-- phpMyAdmin SQL Dump
-- version 5.1.3
-- https://www.phpmyadmin.net/
--
-- Host: 127.0.0.1
-- Generation Time: May 03, 2022 at 04:40 AM
-- Server version: 10.4.22-MariaDB
-- PHP Version: 7.4.28

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `hotel_management`
--

DELIMITER $$
--
-- Procedures
--
CREATE DEFINER=`root`@`localhost` PROCEDURE `AssignRooms` ()   BEGIN
	DECLARE n INT DEFAULT 0;
    DECLARE i INT DEFAULT 0;
    DECLARE checkIn DATE;
    DECLARE checkOut DATE;
    DECLARE stayLength INT;
    DECLARE roomNumber INT;
    DECLARE reservationId INT;
    DECLARE propertyName VARCHAR(100);
	DECLARE roomCount INT;
    DECLARE roomI INT DEFAULT 0;
	SELECT Count(*) FROM Reservation INTO n;
    WHILE i < n DO
		# Get the details of the current reservation
        SET checkIn = (SELECT check_in FROM Reservation ORDER BY reservation_id LIMIT i, 1);
        SET checkOut = (SELECT check_out FROM Reservation ORDER BY reservation_id  LIMIT i, 1);
        SET propertyName = (SELECT property_name FROM Reservation ORDER BY reservation_id LIMIT i, 1);
        SET reservationId = (SELECT reservation_id FROM Reservation ORDER BY reservation_id LIMIT i, 1);
        
        # Get number of days needed
        SET stayLength = DATEDIFF(checkOut, checkIn);
        
        # Get the room number to be assigned. 
        SET roomNumber = 
        (
			SELECT room_num
			FROM (SELECT room_num FROM Room_Date WHERE (_date >= checkIn AND _date < checkOut AND Room_Date.property_name = propertyName AND reservation_ID IS NULL)) AS T
            GROUP BY room_num
            HAVING COUNT(*) = stayLength
            ORDER BY room_num
            LIMIT 0, 1
        );
        
        # The reservation cannot be assigned a room
        # it would be best to remove the reservation from the system
        # Otherwise, make the assignment
		IF roomNumber IS NULL THEN
			DELETE FROM Reservation WHERE reservation_id = reservationId;
            SET n = n - 1;
		ELSE 	
			UPDATE Room_Date
            SET reservation_id = reservationId
            WHERE (room_num = roomNumber AND _date >= checkIn AND _date < checkOut AND property_name = propertyName AND reservation_id IS NULL);
			
            UPDATE Reservation
			SET total_price = (SELECT SUM(rate) FROM Room_Date WHERE reservation_id = reservationId GROUP BY reservation_id)
			WHERE reservation_id = reservationId;
		
			SET i = i + 1;
        END IF;
    END WHILE;
END$$

DELIMITER ;

-- --------------------------------------------------------

--
-- Table structure for table `additionalguests`
--

CREATE TABLE `additionalguests` (
  `reservation_id` int(10) UNSIGNED NOT NULL,
  `phone_number` varchar(15) NOT NULL,
  `first_name` varchar(25) NOT NULL,
  `last_name` varchar(25) NOT NULL,
  `dob` date NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `additionalguests`
--

INSERT INTO `additionalguests` (`reservation_id`, `phone_number`, `first_name`, `last_name`, `dob`) VALUES
(39, '946-211-5996', 'Gavan', 'Aldie', '1995-08-29'),
(119, '407-313-9158', 'Constanta', 'Adan', '1958-01-26'),
(131, '906-348-5262', 'Benni', 'McEllen', '1966-07-04'),
(8, '159-534-0692', 'Edith', 'Stieger', '1976-03-17'),
(113, '530-833-6201', 'Rakel', 'Cacacie', '1995-10-06'),
(140, '290-809-9944', 'Wash', 'Pitfield', '1961-10-07'),
(128, '568-952-9368', 'Trina', 'McGinly', '1967-09-09'),
(169, '818-712-7394', 'Bentley', 'Freeberne', '1955-08-06'),
(3, '466-204-9984', 'Julius', 'Reside', '1990-06-07'),
(137, '418-674-7782', 'Philippa', 'Kauble', '1980-05-21'),
(77, '418-674-7782', 'Philippa', 'Kauble', '1980-05-21'),
(171, '641-487-6311', 'Amalia', 'Ehrat', '1966-10-08'),
(60, '546-259-2830', 'Kenton', 'Sego', '1955-12-18'),
(146, '286-512-0116', 'Giorgi', 'Waterdrinker', '1957-01-08'),
(169, '382-205-2823', 'Arty', 'McGrowther', '1970-11-12'),
(83, '447-283-5821', 'Susanne', 'Yacob', '1952-07-25'),
(170, '903-651-2678', 'Trude', 'Matskevich', '1955-08-16'),
(76, '263-874-1256', 'Cassius', 'Pendlenton', '1986-04-03'),
(22, '701-522-2518', 'Darrel', 'Beecheno', '1954-07-10'),
(15, '927-440-7257', 'Aguie', 'Cristofolo', '1976-10-23'),
(168, '724-447-4856', 'Lowell', 'Kollas', '1958-01-31'),
(98, '919-926-9996', 'Pepito', 'Hardstaff', '1965-02-28'),
(83, '472-888-4576', 'Zechariah', 'Dobinson', '1955-03-10'),
(161, '906-348-5262', 'Benni', 'McEllen', '1966-07-04'),
(65, '106-354-3992', 'Cirilo', 'Malletratt', '1980-08-23'),
(26, '203-432-7643', 'Antonella', 'Snead', '1984-02-27'),
(128, '623-898-3491', 'Cyrill', 'McEwan', '1994-08-31'),
(86, '708-320-4654', 'Adair', 'Deely', '1959-11-03'),
(36, '762-213-7718', 'Odele', 'Helkin', '1994-08-28'),
(155, '719-716-0830', 'Rik', 'Glossop', '1992-03-28'),
(96, '398-847-6382', 'Gabrielle', 'Giovannelli', '1971-09-14'),
(13, '932-441-3835', 'Holden', 'Adenet', '1952-01-19'),
(191, '212-828-9658', 'Carolyn', 'Lukianovich', '1977-05-02'),
(161, '981-904-5029', 'Allen', 'Warder', '1978-04-30'),
(62, '837-260-3724', 'Celia', 'Petrou', '1958-12-07'),
(184, '272-906-4475', 'Linn', 'Reyes', '1958-04-18'),
(63, '948-560-1047', 'Belle', 'Newbigging', '1967-02-05'),
(184, '149-715-5155', 'Weber', 'Hasel', '1988-06-01'),
(29, '605-288-5545', 'Evangeline', 'Asgodby', '1991-03-11'),
(18, '388-501-2825', 'Lief', 'Jones', '1972-04-24'),
(198, '664-955-6023', 'Pennie', 'Russon', '1978-01-22'),
(96, '644-675-3504', 'Bessie', 'Lockitt', '1994-03-31'),
(147, '193-414-9755', 'Xylia', 'Betteriss', '1978-06-09'),
(120, '947-787-1612', 'Ellary', 'Brownbill', '1967-05-24'),
(13, '811-546-0367', 'Joella', 'Hains', '1979-12-21'),
(28, '720-325-7899', 'Sargent', 'de Mullett', '1956-11-30'),
(106, '686-312-6505', 'Muffin', 'Ksandra', '1970-06-28'),
(98, '874-168-7614', 'Josiah', 'Adamski', '1968-09-04'),
(24, '708-320-4654', 'Adair', 'Deely', '1959-11-03'),
(131, '719-716-0830', 'Rik', 'Glossop', '1992-03-28'),
(124, '832-392-5074', 'Selie', 'Yesipov', '1988-04-28'),
(127, '290-809-9944', 'Wash', 'Pitfield', '1961-10-07'),
(140, '466-204-9984', 'Julius', 'Reside', '1990-06-07'),
(129, '418-674-7782', 'Philippa', 'Kauble', '1980-05-21'),
(87, '720-302-4122', 'Stanleigh', 'Aynold', '1960-08-18'),
(99, '210-140-6597', 'Barnard', 'Kann', '1961-03-28'),
(65, '257-470-8471', 'Andreas', 'Mansuer', '1979-12-08'),
(34, '647-469-5133', 'Mariette', 'Challiner', '1988-09-06'),
(180, '286-663-0352', 'Reese', 'Case', '1992-04-16'),
(98, '204-240-2631', 'Mariam', 'Pitrasso', '1978-03-03'),
(89, '568-952-9368', 'Trina', 'McGinly', '1967-09-09'),
(147, '663-755-1957', 'Nickie', 'Blasi', '1955-10-26'),
(187, '910-632-1031', 'Merci', 'Priddis', '1987-08-06'),
(30, '963-902-9596', 'Jeremy', 'Fidge', '2001-03-16'),
(151, '261-395-2447', 'Dorelle', 'Copnar', '1975-12-31'),
(7, '855-955-7043', 'Lebbie', 'Gilbertson', '1983-02-15'),
(194, '815-809-9631', 'Nev', 'Spinello', '1996-12-04'),
(24, '841-591-1327', 'Raffaello', 'Ponnsett', '1955-02-16'),
(136, '212-828-9658', 'Carolyn', 'Lukianovich', '1977-05-02'),
(92, '395-999-1479', 'Gunner', 'Tipping', '1959-05-08'),
(192, '521-467-3072', 'Hollie', 'Willars', '1994-11-08'),
(13, '767-594-2715', 'Almeda', 'Westell', '1978-04-28'),
(109, '700-940-8053', 'Keeley', 'Heminsley', '1990-05-26'),
(183, '923-605-4970', 'Granger', 'Ortells', '1973-05-13'),
(120, '832-392-5074', 'Selie', 'Yesipov', '1988-04-28'),
(200, '210-746-5264', 'Vic', 'Burkill', '1983-04-24'),
(123, '403-257-6615', 'Corrine', 'Etridge', '1980-12-22'),
(99, '910-632-1031', 'Merci', 'Priddis', '1987-08-06'),
(122, '596-665-3827', 'Karisa', 'Rilton', '1997-05-28'),
(43, '559-552-7429', 'Hubert', 'Norway', '1990-01-31'),
(55, '212-152-8420', 'Eberto', 'Whaley', '1972-08-27'),
(75, '970-854-3541', 'Ives', 'Normanvill', '1989-03-14'),
(114, '360-952-3500', 'Leigh', 'Filby', '1975-02-02'),
(161, '927-440-7257', 'Aguie', 'Cristofolo', '1976-10-23'),
(3, '349-384-3194', 'Melicent', 'Flecknoe', '1981-12-11'),
(70, '910-632-1031', 'Merci', 'Priddis', '1987-08-06'),
(59, '648-788-2933', 'Georgianna', 'Wharfe', '1991-07-27'),
(19, '472-888-4576', 'Zechariah', 'Dobinson', '1955-03-10'),
(88, '273-691-6331', 'Juditha', 'Tattersall', '1957-12-17'),
(70, '170-107-3162', 'Magdalen', 'Heimann', '1953-08-21'),
(82, '734-717-5421', 'Gayel', 'Satterfitt', '1978-01-03'),
(175, '418-674-7782', 'Philippa', 'Kauble', '1980-05-21'),
(142, '840-758-1221', 'Colan', 'Gowry', '1972-08-17'),
(174, '720-325-7899', 'Sargent', 'de Mullett', '1956-11-30'),
(74, '683-706-2709', 'Gwendolyn', 'Banat', '1989-02-20'),
(123, '270-617-9175', 'Patten', 'Pitblado', '1970-07-11'),
(50, '136-305-3349', 'Doralyn', 'Pellatt', '1966-08-09'),
(187, '770-533-5281', 'Lisabeth', 'Bonnefin', '1992-09-28'),
(37, '995-196-9540', 'Gael', 'Gaven', '1958-10-09'),
(148, '106-354-3992', 'Cirilo', 'Malletratt', '1980-08-23');

-- --------------------------------------------------------

--
-- Table structure for table `address`
--

CREATE TABLE `address` (
  `street_address` varchar(100) NOT NULL,
  `unit_number` varchar(8) NOT NULL,
  `country` varchar(50) NOT NULL,
  `postal_code` varchar(7) NOT NULL,
  `city` varchar(50) NOT NULL,
  `address_type` enum('billing','property','staff') NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `address`
--

INSERT INTO `address` (`street_address`, `unit_number`, `country`, `postal_code`, `city`, `address_type`) VALUES
('0 Armistice Drive', '72565', 'Canada', 'J3D2J3', 'Skärholmen', 'property'),
('0 Artisan Junction', '19700', 'Canada', 'Q4G8U3', 'Pumaqangtang', 'staff'),
('0 Badeau Terrace', '697', 'Canada', 'Y2U0D5', 'Hrušica', 'property'),
('0 Briar Crest Court', '0', 'United States', '88802', 'Peso da Régua', 'staff'),
('0 Brickson Park Street', '37507', 'Canada', 'M7E8E8', 'Videm pri Ptuju', 'staff'),
('0 Canary Way', '16412', 'Canada', 'H6C8G6', 'Ocoyo', 'property'),
('0 Carpenter Center', '487', 'Canada', 'J3D2J3', 'Reshetikha', 'billing'),
('0 Clarendon Alley', '75', 'United States', '49159', 'Bela Vista', 'billing'),
('0 Farmco Pass', '5', 'Canada', 'T8O1E6', 'les Escaldes', 'property'),
('0 Gina Parkway', '04', 'Canada', 'A1N6I6', 'Kalutara', 'staff'),
('0 Gulseth Crossing', '1', 'United States', '68743', 'Sali', 'staff'),
('0 Manufacturers Court', '24', 'United States', '23482', 'Taraan', 'billing'),
('0 Miller Point', '88', 'United States', '25554', 'Haarlem', 'billing'),
('0 Reindahl Park', '0883', 'United States', '11622', 'Praia das Maçãs', 'billing'),
('0 Rutledge Place', '41', 'United States', '99615', 'Camatagua', 'property'),
('0 Rutledge Street', '5', 'United States', '44890', 'Rungkam', 'property'),
('0 Sachtjen Place', '9091', 'Canada', 'J8R2U6', 'Xinchengzi', 'staff'),
('0 Saint Paul Drive', '82361', 'Canada', 'I8Z4I8', 'Seremban', 'billing'),
('0 Summer Ridge Drive', '6831', 'United States', '26557', 'Iogach', 'staff'),
('0 Vahlen Crossing', '67', 'United States', '44091', 'Beitou', 'billing'),
('0 Washington Drive', '65712', 'Canada', 'K8U3M0', 'Taldan', 'billing'),
('0 Westend Circle', '841', 'United States', '12801', 'Sinamaica', 'staff'),
('00 Sugar Parkway', '82', 'Canada', 'T9F7W2', 'Nasilava', 'staff'),
('00025 Charing Cross Hill', '433', 'Canada', 'R6R1Y9', 'Santa Teresa', 'property'),
('0019 Oak Avenue', '5716', 'Canada', 'B4U9M0', 'Pridonskoy', 'billing'),
('002 Talisman Hill', '781', 'United States', '33640', 'Betim', 'billing'),
('005 Rieder Hill', '36307', 'Canada', 'F3H2R6', 'Zduńska Wola', 'billing'),
('007 Longview Place', '208', 'United States', '83819', 'Tanlad', 'billing'),
('0070 Mcbride Trail', '91700', 'United States', '54292', 'Bogdanovich', 'staff'),
('008 Arrowood Way', '4', 'United States', '78826', 'Nankou', 'billing'),
('01 Ilene Terrace', '845', 'Canada', 'C4S7B0', 'Xike', 'staff'),
('01 Meadow Ridge Avenue', '5617', 'Canada', 'X9G4S1', 'Macinhata da Seixa', 'property'),
('01 Thackeray Park', '323', 'Canada', 'I8Z4I8', 'Figueiredo', 'property'),
('01071 Jana Lane', '6', 'Canada', 'E8K3Q7', 'Gafargaon', 'billing'),
('0128 Amoth Parkway', '65', 'United States', '20458', 'Ängelholm', 'staff'),
('0137 Anthes Pass', '09', 'United States', '15449', 'Uwa', 'billing'),
('018 Springs Court', '33803', 'Canada', 'A1N6I6', 'Donggou', 'staff'),
('02 Badeau Court', '689', 'United States', '12543', 'Andilamena', 'staff'),
('02 Blackbird Center', '2', 'United States', '31589', 'Liujia', 'billing'),
('0202 Orin Point', '5', 'United States', '47656', 'Świętochłowice', 'staff'),
('0223 Independence Road', '8', 'United States', '36100', 'Liangnong', 'staff'),
('0226 Petterle Hill', '11', 'Canada', 'X3Q8Z6', 'Tríkala', 'staff'),
('023 Hanover Circle', '86', 'United States', '19011', 'Rueil-Malmaison', 'staff'),
('02801 Sullivan Terrace', '9328', 'United States', '62244', 'Łopuszna', 'property'),
('0284 Dwight Plaza', '05600', 'United States', '10180', 'Telnice', 'staff'),
('029 Petterle Circle', '9846', 'United States', '75715', 'Santarém', 'billing'),
('0294 Marquette Parkway', '93884', 'United States', '95234', 'Kawaliwu', 'billing'),
('03 Swallow Circle', '7', 'Canada', 'Z6T1W7', 'Tambaksari', 'billing'),
('031 Browning Pass', '0620', 'United States', '28705', 'Okazaki', 'billing'),
('032 Porter Crossing', '24', 'United States', '18164', 'Banos', 'staff'),
('033 Ridgeview Circle', '9520', 'Canada', 'E1Z4Z1', 'Osieck', 'billing'),
('034 Monterey Circle', '59', 'Canada', 'K3C2N2', 'Xiyang', 'property'),
('03407 Sage Way', '5', 'United States', '12801', 'Tielong', 'staff'),
('03501 Monterey Street', '3251', 'Canada', 'P5G0C2', 'San Isidro', 'billing'),
('0362 Bobwhite Hill', '196', 'Canada', 'X9G4S1', 'Flen', 'property'),
('03984 Pankratz Street', '14156', 'United States', '84514', 'København', 'staff'),
('04 3rd Junction', '98800', 'United States', '47656', 'Göteborg', 'staff'),
('04 Center Street', '146', 'Canada', 'W4J7B3', 'Lille', 'billing'),
('04 Dapin Center', '62388', 'Canada', 'F6W0G4', 'Lipnica', 'staff'),
('04 Kingsford Hill', '7886', 'Canada', 'O2A5G4', 'Jiucaigou', 'property'),
('04 Kipling Trail', '376', 'United States', '64877', 'Giedlarowa', 'billing'),
('04 Mccormick Park', '54', 'Canada', 'O1L2K7', 'Druzhba', 'staff'),
('04196 Prentice Hill', '1358', 'United States', '54352', 'Banī Mazār', 'property'),
('044 Randy Trail', '8236', 'United States', '78249', 'Murcki', 'billing'),
('04511 Gerald Center', '13004', 'Canada', 'C5M5E1', 'Uspenka', 'staff'),
('0468 Vidon Way', '0054', 'United States', '95234', 'Magatos', 'property'),
('05 Sycamore Terrace', '8', 'Canada', 'R1L8S7', 'Tingsiqiao', 'staff'),
('055 Homewood Terrace', '3', 'Canada', 'F9Q9S0', 'Lianxia', 'staff'),
('056 Oak Point', '08953', 'United States', '93385', 'Cagayan', 'staff'),
('05724 Erie Street', '6', 'Canada', 'C8Y6F0', 'Sapu Padidu', 'staff'),
('060 Aberg Park', '51', 'Canada', 'G7Q7K7', 'Tunjuk Selatan', 'staff'),
('0632 Farmco Park', '0380', 'Canada', 'C4S7B0', 'Nyima', 'property'),
('06353 Twin Pines Plaza', '89', 'United States', '23104', 'Léchovo', 'staff'),
('06881 Eastwood Court', '60162', 'Canada', 'Y1L4R2', 'Kowo', 'staff'),
('0691 Judy Terrace', '9', 'Canada', 'R0R8S6', 'Linqu', 'staff'),
('07 Division Parkway', '7', 'Canada', 'M3L1W6', 'Fos-sur-Mer', 'property'),
('07 Lerdahl Hill', '69356', 'Canada', 'M9Z3I5', 'Wufu', 'property'),
('07 Meadow Valley Lane', '771', 'United States', '18164', 'Kushikino', 'staff'),
('0716 Glacier Hill Court', '68', 'United States', '22156', 'Pulo', 'property'),
('0718 Kropf Center', '8', 'United States', '63095', 'Yonghe', 'billing'),
('0727 Stone Corner Center', '32', 'Canada', 'U2O7F2', 'Grębów', 'staff'),
('07396 Prairieview Place', '1896', 'Canada', 'Q5Y0T4', 'Washington', 'billing'),
('07472 Badeau Junction', '91', 'United States', '33040', 'Rongxiang', 'staff'),
('077 Thierer Parkway', '83364', 'Canada', 'H8Q2G3', 'Hannover', 'staff'),
('07806 Homewood Pass', '165', 'Canada', 'F7N9L2', 'Savonranta', 'staff'),
('0782 Hooker Drive', '1104', 'Canada', 'Z6T1W7', 'Babice', 'billing'),
('079 Tennyson Center', '7', 'United States', '49654', 'Dungloe', 'property'),
('08 Sutherland Circle', '65496', 'United States', '63095', 'Patani', 'billing'),
('08 Truax Place', '3177', 'Canada', 'Z6T1W7', 'Novorossiysk', 'staff'),
('0829 Mosinee Avenue', '637', 'Canada', 'P5G0C2', '‘Alāqahdārī Gēlān', 'staff'),
('08368 Redwing Center', '18', 'United States', '27632', 'Portela', 'billing'),
('0839 Bluejay Court', '43830', 'Canada', 'E5H3Y3', 'Huarong', 'staff'),
('0852 Holmberg Place', '68334', 'Canada', 'X0F0B6', 'Bulawayo', 'staff'),
('086 Sycamore Way', '44954', 'United States', '84104', 'Seso', 'billing'),
('09 Grayhawk Park', '317', 'United States', '75715', 'Dugu', 'staff'),
('09 Truax Park', '79353', 'Canada', 'M3L1W6', '28 de Noviembre', 'property'),
('090 Northridge Trail', '8', 'United States', '83819', 'Lower Hutt', 'property'),
('0907 Calypso Circle', '9', 'United States', '84104', 'Lafia', 'staff'),
('09128 Southridge Way', '4', 'United States', '64288', 'Johanneshov', 'billing'),
('09158 Mandrake Way', '174', 'United States', '51618', 'Buenavista', 'billing'),
('09611 Eastwood Junction', '363', 'United States', '78984', 'Noormarkku', 'billing'),
('0973 Parkside Drive', '90334', 'United States', '98428', 'Boje', 'property'),
('0988 Heffernan Road', '341', 'Canada', 'Z0H6K0', 'New York City', 'staff'),
('099 Arrowood Place', '4', 'United States', '90820', 'Korolevo', 'billing'),
('0993 Killdeer Trail', '264', 'United States', '98166', 'Daliyuan', 'staff'),
('1 8th Hill', '86801', 'United States', '36100', 'Toulon', 'property'),
('1 Beilfuss Terrace', '41', 'United States', '81112', 'Jizhou', 'property'),
('1 Carioca Junction', '1', 'United States', '28705', 'Castelo', 'billing'),
('1 Eastlawn Road', '86627', 'United States', '93030', 'Dulian', 'billing'),
('1 Express Crossing', '06', 'United States', '36509', 'Sūq Şirwāḩ', 'billing'),
('1 Glacier Hill Hill', '6', 'United States', '95234', 'Is', 'property'),
('1 Graedel Plaza', '261', 'Canada', 'R3X3J2', 'Thessalon', 'staff'),
('1 Iowa Plaza', '0', 'Canada', 'M3L1W6', 'Naples', 'property'),
('1 Lighthouse Bay Avenue', '4700', 'Canada', 'U5S4C4', 'Thị Trấn Phú Mỹ', 'property'),
('1 Nobel Center', '02849', 'United States', '10986', 'Zhugentan', 'property'),
('1 Onsgard Hill', '78134', 'Canada', 'Y3C3O9', 'Flora', 'billing'),
('1 Parkside Circle', '4370', 'Canada', 'X3Q8Z6', 'Shifan', 'staff'),
('1 Pennsylvania Street', '430', 'United States', '90220', 'Thanatpin', 'property'),
('1 Ramsey Circle', '95384', 'United States', '29021', 'Sanli', 'billing'),
('1 Sherman Parkway', '1467', 'United States', '23104', 'Jiantiao', 'staff'),
('1 Stoughton Hill', '8', 'Canada', 'Y6Q1T5', 'Tarata', 'staff'),
('1 Straubel Center', '9', 'United States', '54436', 'Luqiao', 'property'),
('1 Summit Drive', '163', 'United States', '87605', 'Esperalvillo', 'property'),
('1 Superior Park', '85', 'United States', '85861', 'Marsabit', 'property'),
('10 Farwell Parkway', '97736', 'Canada', 'X9G4S1', 'Espinal', 'billing'),
('10 Kenwood Point', '0', 'United States', '68092', 'Pyhäsalmi', 'staff'),
('10 Manley Trail', '42675', 'Canada', 'Y0H4F3', 'Laiyang', 'staff'),
('10 Maple Street', '20271', 'Canada', 'Y3C3O9', 'Ipoh', 'property'),
('10 Sheridan Parkway', '44', 'United States', '47656', 'Chambray-lès-Tours', 'staff'),
('10 Swallow Street', '54', 'United States', '64009', 'Chinch\'ŏn', 'property'),
('10 Transport Park', '2', 'United States', '13060', 'Quimper', 'property'),
('10226 Darwin Street', '1', 'United States', '64877', 'Shizikeng', 'property'),
('103 Texas Point', '9545', 'Canada', 'U5H8D4', 'Krajanbonjor', 'staff'),
('105 Talmadge Center', '70', 'United States', '28127', 'Mata', 'billing'),
('107 Prentice Center', '93943', 'Canada', 'A1N6I6', 'Balucawi', 'property'),
('11 Brown Road', '9', 'Canada', 'K1Z8A2', 'Baganha', 'property'),
('11 Glendale Trail', '81956', 'United States', '82176', 'Båstad', 'property'),
('11 Tennessee Place', '564', 'United States', '28127', 'Nanmu', 'property'),
('11057 Fairfield Parkway', '167', 'Canada', 'J7Y6O1', 'Szelków', 'property'),
('113 Esch Parkway', '2', 'Canada', 'N3C1U3', 'Bayt ‘Ūr at Taḩtā', 'billing'),
('11529 Ohio Road', '12073', 'United States', '68092', 'Kilifarevo', 'billing'),
('1183 Cordelia Circle', '403', 'Canada', 'Z6T1W7', 'Kilju', 'billing'),
('119 Arkansas Center', '1353', 'United States', '52407', 'Aksu', 'staff'),
('12 Carioca Junction', '7', 'Canada', 'R5D3E0', 'Kamyzyak', 'billing'),
('12 Everett Center', '68', 'Canada', 'F7C7A2', 'El Zulia', 'billing'),
('12 Village Green Lane', '3', 'United States', '17271', 'Komono', 'staff'),
('1207 Ridgeway Drive', '52', 'United States', '64009', 'Odolena Voda', 'staff'),
('12173 Monument Alley', '891', 'Canada', 'B4U9M0', 'Goz Beïda', 'property'),
('122 Fordem Road', '87906', 'Canada', 'Q9I5U6', 'San Francisco', 'staff'),
('1230 Fremont Hill', '13', 'Canada', 'B4U9M0', 'Nikolinci', 'property'),
('1246 Ronald Regan Plaza', '14', 'United States', '22156', 'Kola', 'billing'),
('1274 Northport Way', '24612', 'Canada', 'O9Q3J0', 'Rijau', 'property'),
('1348 Fairfield Hill', '5799', 'Canada', 'F9Q9S0', 'Dārāb', 'staff'),
('13675 Acker Plaza', '828', 'Canada', 'G8E6T8', 'Kulunda', 'property'),
('14 Eggendart Court', '7', 'United States', '95234', 'Antonina', 'billing'),
('14092 Cody Lane', '15902', 'Canada', 'O1H1W9', 'Pierzchnica', 'billing'),
('142 Shelley Hill', '231', 'Canada', 'M7E8E8', 'Hovtashen', 'billing'),
('143 Gina Circle', '7497', 'United States', '86702', 'Jingdezhen', 'property'),
('144 Loeprich Park', '87582', 'United States', '43123', 'Luján', 'billing'),
('1450 Melby Circle', '58283', 'Canada', 'Q7C9S6', 'Flushing', 'billing'),
('146 Linden Trail', '1', 'Canada', 'M7H8I9', 'Radymno', 'billing'),
('1473 Sommers Hill', '7011', 'Canada', 'I3W3K6', 'Bojnik', 'billing'),
('1502 Fieldstone Way', '4', 'United States', '93651', 'Boksitogorsk', 'staff'),
('15165 Division Lane', '11833', 'Canada', 'R6R1Y9', 'San Marcos', 'property'),
('15293 Dottie Pass', '62802', 'Canada', 'R1L8S7', 'Susunan', 'property'),
('1532 Everett Parkway', '4553', 'United States', '46675', 'Sōja', 'billing'),
('15321 Bellgrove Road', '9', 'United States', '19091', 'Värnamo', 'property'),
('1541 1st Terrace', '5', 'Canada', 'O9Q3J0', 'Canggou', 'property'),
('15431 School Crossing', '32', 'Canada', 'H6C8G6', 'Cairo', 'staff'),
('15439 Almo Center', '7', 'Canada', 'J5Z0F4', 'Ribeiro', 'property'),
('159 Clemons Place', '18783', 'Canada', 'F9Q9S0', 'São Luís de Montes Belos', 'staff'),
('16 Burning Wood Court', '592', 'Canada', 'F3H2R6', 'Manola', 'staff'),
('16 Oak Way', '17570', 'Canada', 'X9G4S1', 'Wyszogród', 'billing'),
('160 Northridge Junction', '30', 'United States', '14888', 'Vreshtas', 'property'),
('16093 Johnson Terrace', '38228', 'Canada', 'E5H3Y3', 'Jabon', 'billing'),
('16235 Riverside Crossing', '6', 'Canada', 'G9D5D1', 'Maqia', 'staff'),
('1633 Gerald Circle', '2916', 'Canada', 'F3R1I1', 'Yuewan', 'staff'),
('1633 Pond Terrace', '1', 'United States', '63498', 'Tapas', 'property'),
('16609 Claremont Trail', '2442', 'United States', '10230', 'Bugang', 'property'),
('17 Hazelcrest Parkway', '56577', 'Canada', 'G7Q7K7', 'Buenaventura', 'property'),
('17 Katie Center', '2459', 'Canada', 'F6W0G4', 'Cametá', 'billing'),
('17124 Sutherland Court', '32631', 'Canada', 'M9A0Z8', 'Mlangali', 'billing'),
('1718 1st Crossing', '31588', 'United States', '36699', 'Sindanghayu', 'staff'),
('1756 Valley Edge Junction', '7715', 'Canada', 'T8O1E6', 'Kitaibaraki', 'billing'),
('176 Laurel Road', '7658', 'United States', '23482', 'Marystown', 'staff'),
('1772 Fairfield Point', '04966', 'Canada', 'I1N6L0', 'Palayan City', 'property'),
('1782 Red Cloud Place', '40', 'United States', '60174', 'Sísion', 'property'),
('18 Donald Park', '93825', 'Canada', 'K3L0A0', 'Newport News', 'property'),
('18403 Londonderry Point', '6769', 'United States', '54728', 'Talangnan', 'staff'),
('185 Daystar Plaza', '87824', 'Canada', 'R8W0K1', 'Kute', 'property'),
('18767 Coolidge Hill', '15124', 'United States', '75753', 'Fresno', 'property'),
('18904 Larry Crossing', '4629', 'Canada', 'G3U2J7', 'Praszka', 'staff'),
('19 Laurel Terrace', '972', 'United States', '70289', 'Srunikrajan', 'staff'),
('19 Onsgard Drive', '8', 'Canada', 'A7B2R7', 'Guadalupe Victoria', 'staff'),
('19 School Crossing', '97', 'United States', '10230', 'Fengsheng', 'property'),
('19140 Veith Alley', '393', 'United States', '94576', 'Pulau Pinang', 'billing'),
('1927 Mariners Cove Crossing', '48', 'United States', '36209', 'Niš', 'staff'),
('19474 Thompson Center', '543', 'Canada', 'L5K3G0', 'Bella Unión', 'staff'),
('1955 Westend Hill', '81', 'Canada', 'F0O8M2', 'Vodstroy', 'property'),
('19676 Westport Junction', '50', 'United States', '99916', 'Acobambilla', 'billing'),
('19752 Express Drive', '6', 'Canada', 'E8K3Q7', 'Xiumei', 'billing'),
('2 5th Hill', '5426', 'Canada', 'F9E0S9', 'Sinait', 'staff'),
('2 Basil Way', '9', 'Canada', 'D7I5Y6', 'Ljubešćica', 'billing'),
('2 Buena Vista Terrace', '52737', 'United States', '19011', 'El Cantón', 'staff'),
('2 Continental Court', '3', 'United States', '36100', 'Tegalgede', 'property'),
('2 Corscot Hill', '1903', 'Canada', 'M8N0M7', 'Konče', 'staff'),
('2 Dapin Point', '346', 'Canada', 'B5Q7U1', 'Bantry', 'staff'),
('2 Dixon Parkway', '339', 'United States', '75715', 'Xian’an', 'staff'),
('2 Havey Park', '664', 'United States', '36427', 'Mahaica Village', 'property'),
('2 Katie Court', '7', 'United States', '57185', 'Kantyshevo', 'property'),
('2 Lake View Center', '0', 'Canada', 'F7C7A2', 'Nyazura', 'property'),
('2 Larry Court', '0', 'Canada', 'K4Z9W9', 'Xinning', 'staff'),
('2 Lawn Alley', '1029', 'United States', '86702', 'Katagum', 'property'),
('2 Monument Place', '47', 'United States', '19362', 'Qingyang', 'property'),
('2 Oakridge Road', '3171', 'United States', '96546', 'Bovec', 'staff'),
('2 Petterle Parkway', '5372', 'Canada', 'D7M6R9', 'Thị Trấn Nho Quan', 'property'),
('2 Red Cloud Lane', '18', 'United States', '51688', 'Wolongquan', 'staff'),
('2 Sage Park', '8', 'United States', '92662', 'Yehud', 'billing'),
('2 Schmedeman Way', '9', 'United States', '66847', 'Tualeu', 'billing'),
('2 Starling Circle', '7', 'Canada', 'R6T2C5', 'Phatthana Nikhom', 'property'),
('2 Summer Ridge Crossing', '8791', 'United States', '11423', 'Öndörhoshuu', 'staff'),
('2 Vidon Alley', '043', 'United States', '33324', 'Maroanging', 'billing'),
('2 Washington Pass', '75960', 'Canada', 'J3D2J3', 'Al Mushannaf', 'property'),
('20 Eagle Crest Road', '7', 'Canada', 'F9Q9S0', 'Caballococha', 'billing'),
('20 Mendota Court', '42', 'Canada', 'U5L2M5', 'Wonda', 'property'),
('200 Bunting Place', '11923', 'Canada', 'O9Q3J0', 'Monaghan', 'billing'),
('2013 Anderson Junction', '3517', 'Canada', 'J0C3L7', 'Świnna', 'billing'),
('2122 Upham Drive', '4', 'United States', '17973', 'Tirapata', 'staff'),
('21324 Butternut Drive', '2', 'Canada', 'D6A2H3', 'Krasne', 'billing'),
('21357 Crest Line Pass', '27779', 'Canada', 'X6G9Q1', 'Monastirákion', 'billing'),
('2148 Eagan Terrace', '80', 'Canada', 'T7P8G1', 'Romblon', 'staff'),
('2152 Acker Alley', '91', 'United States', '22525', 'Agua Fría', 'staff'),
('22 Drewry Circle', '9', 'Canada', 'N8X0F1', 'Margherita', 'property'),
('22 Ryan Place', '2', 'Canada', 'F7C7A2', 'Jianshe', 'property'),
('223 Onsgard Parkway', '1', 'United States', '23290', 'Yuejin', 'staff'),
('22331 Alpine Terrace', '82536', 'Canada', 'H7H7J0', 'Nelipyno', 'billing'),
('224 Schlimgen Center', '14', 'Canada', 'K4Z9W9', 'Orange', 'property'),
('225 Harbort Hill', '60375', 'United States', '90220', 'Albrechtice', 'billing'),
('22606 Manley Road', '84', 'Canada', 'A9E4H2', 'Boyle', 'property'),
('22633 Utah Place', '54475', 'United States', '95821', 'Kotablolong', 'billing'),
('227 Coolidge Point', '6', 'Canada', 'S7J3F3', 'Herby', 'property'),
('228 Cambridge Hill', '4561', 'Canada', 'Q9B3H1', 'Želiv', 'staff'),
('2286 Paget Place', '18', 'United States', '86900', 'Tuanzhou', 'property'),
('23 Del Sol Drive', '2', 'United States', '20532', 'Memphis', 'billing'),
('23 Forster Crossing', '5932', 'Canada', 'M1N6T4', 'Yanqi', 'staff'),
('23088 Kedzie Circle', '7', 'Canada', 'K3C2N2', 'Ciudad Ojeda', 'property'),
('23120 Hayes Drive', '5', 'Canada', 'R1L8S7', 'Maroanging', 'staff'),
('234 Northview Pass', '8', 'Canada', 'T8O1E6', 'Taung', 'staff'),
('2346 Nancy Court', '83268', 'United States', '47160', 'Novosin’kovo', 'property'),
('235 Colorado Court', '12419', 'Canada', 'D9N7Z9', 'Calzada Larga', 'billing'),
('239 Coolidge Lane', '2', 'United States', '34925', 'Kyrylivka', 'staff'),
('239 Rowland Lane', '06334', 'Canada', 'C8Y6F0', 'Kirovsk', 'billing'),
('2398 Esker Trail', '4', 'Canada', 'F9Q9S0', 'Terter', 'staff'),
('24 Independence Junction', '304', 'United States', '68092', 'Arzakan', 'staff'),
('24 Riverside Terrace', '5', 'United States', '25554', 'Limbuš', 'staff'),
('240 Mccormick Parkway', '6227', 'United States', '73065', 'Concepción de La Vega', 'staff'),
('240 Melrose Drive', '146', 'United States', '22900', 'Neochóri', 'billing'),
('24005 Monterey Lane', '79539', 'United States', '10230', 'Shiwan', 'staff'),
('2409 Basil Drive', '26', 'Canada', 'Q7C9S6', 'Banī an Nahārī', 'staff'),
('242 Tennyson Road', '175', 'Canada', 'K1Z6L8', 'Celestynów', 'staff'),
('2452 Holy Cross Street', '234', 'United States', '83819', 'Heliconia', 'billing'),
('24532 Autumn Leaf Avenue', '810', 'United States', '96436', 'Lahad Datu', 'staff'),
('2468 Continental Drive', '09039', 'United States', '56403', 'Mindyak', 'property'),
('24885 Golf View Place', '767', 'United States', '82176', 'Кондово', 'staff'),
('25 Loeprich Hill', '3', 'United States', '34106', 'Clarin', 'billing'),
('250 Anzinger Avenue', '96861', 'Canada', 'W6D3B8', 'Pilang', 'staff'),
('25090 Aberg Plaza', '67', 'Canada', 'U0L3Z2', 'Lebak', 'staff'),
('252 Burrows Place', '983', 'Canada', 'U1I2O9', 'Guangyubao', 'staff'),
('2539 Thompson Center', '48', 'Canada', 'D6A2H3', 'Katagum', 'staff'),
('255 Kipling Crossing', '21', 'United States', '14374', 'Świlcza', 'staff'),
('257 Brentwood Junction', '02', 'United States', '12616', 'Yajin', 'billing'),
('2575 Sycamore Pass', '6', 'Canada', 'Y1L4R2', 'Tayturka', 'property'),
('2580 Mallard Court', '0', 'Canada', 'M9Z3I5', 'Morrelgonj', 'staff'),
('26 Mayer Street', '0493', 'Canada', 'B4U9M0', '‘Abbāsābād', 'staff'),
('26 Spohn Plaza', '451', 'Canada', 'N2I7M0', 'Jiachuan', 'billing'),
('2606 Johnson Junction', '852', 'Canada', 'Z8U9G8', 'Táriba', 'property'),
('2610 Warrior Trail', '1', 'United States', '31589', 'Chiara', 'billing'),
('264 Claremont Place', '837', 'Canada', 'P5G0C2', 'Rio Claro', 'staff'),
('265 Arapahoe Alley', '833', 'Canada', 'U5S4C4', 'Ondangwa', 'property'),
('2677 Anzinger Center', '7', 'United States', '60174', 'Frederiksberg', 'billing'),
('2687 Kings Circle', '5880', 'Canada', 'S1F1S1', 'Livádion', 'staff'),
('27 Grayhawk Circle', '6', 'United States', '94576', 'Dowlatyār', 'staff'),
('2722 East Junction', '11941', 'United States', '71293', 'Nguékhokh', 'property'),
('28 Charing Cross Avenue', '5', 'Canada', 'C6U7A0', 'Pecna', 'billing'),
('28 Forest Crossing', '16', 'Canada', 'G8E6T8', 'Cibungur', 'property'),
('28 Granby Place', '5', 'Canada', 'Z4S8H4', 'Akita', 'billing'),
('28 Haas Crossing', '6', 'United States', '28127', 'Yangjingziwan', 'billing'),
('28 Havey Way', '1', 'United States', '63498', 'Odeleite', 'billing'),
('28 Melvin Park', '4', 'United States', '96246', 'Falun', 'staff'),
('28025 Ridge Oak Way', '510', 'Canada', 'R6R1Y9', 'Sŏnbong', 'staff'),
('28056 Maple Center', '5', 'Canada', 'S1F1S1', 'Đắk Song', 'property'),
('281 Armistice Place', '0172', 'Canada', 'J9O2C9', 'El Retén', 'property'),
('28267 Namekagon Way', '438', 'United States', '10986', 'Nianba', 'staff'),
('284 Sage Street', '770', 'United States', '22900', 'Colonias Unidas', 'billing'),
('28469 Dryden Street', '23', 'Canada', 'R6T2C5', 'Masaran', 'billing'),
('2869 Barnett Hill', '26780', 'United States', '36100', 'Nashtā Rūd', 'staff'),
('29 Dorton Circle', '040', 'Canada', 'U9R4A6', 'Chinhoyi', 'billing'),
('29134 Corben Parkway', '53313', 'United States', '64288', 'Rahayu Dua', 'billing'),
('292 Tennessee Park', '1', 'United States', '49812', 'Xai-Xai', 'staff'),
('295 Village Green Lane', '2', 'Canada', 'O3K8C6', 'Yaotian', 'billing'),
('29553 Anthes Junction', '443', 'United States', '50847', 'Guaçuí', 'property'),
('29835 Doe Crossing Street', '402', 'United States', '83509', 'Leworook', 'billing'),
('3 8th Park', '76', 'United States', '20336', 'Zhenping Chengguanzhen', 'staff'),
('3 Blue Bill Park Street', '5', 'Canada', 'U1I2O9', 'Repušnica', 'billing'),
('3 Bobwhite Court', '7863', 'Canada', 'S1F1S1', 'Břeclav', 'property'),
('3 Doe Crossing Road', '397', 'Canada', 'E8K3Q7', 'Tô Hạp', 'staff'),
('3 Donald Park', '04', 'Canada', 'Y2N9B0', 'Mayskiy', 'billing'),
('3 Eagle Crest Way', '24', 'Canada', 'Q5Y0T4', 'Tanjungrejo Lor', 'property'),
('3 Express Park', '047', 'Canada', 'Z4X4M1', 'Suure-Jaani', 'billing'),
('3 Forest Dale Court', '3', 'United States', '64288', 'Hobor', 'billing'),
('3 Iowa Place', '2', 'Canada', 'Y3C3O9', 'La Suiza', 'property'),
('3 Kenwood Pass', '15', 'Canada', 'S7J3F3', 'Itanhaém', 'staff'),
('3 Lawn Junction', '173', 'United States', '56403', 'Volksrust', 'property'),
('3 Lien Drive', '4', 'Canada', 'J9O2C9', 'Carig', 'property'),
('3 Londonderry Parkway', '94114', 'Canada', 'U5L2M5', 'Jadho', 'billing'),
('3 Magdeline Terrace', '868', 'Canada', 'Y6G8G7', 'Mirów', 'billing'),
('3 Messerschmidt Circle', '60759', 'Canada', 'G7F6D2', 'Caringin', 'property'),
('3 Miller Pass', '545', 'Canada', 'L7Z0Q8', 'Fuxin', 'property'),
('3 Myrtle Trail', '7871', 'Canada', 'J5Z0F4', 'Ādilpur', 'property'),
('3 Old Gate Park', '2156', 'United States', '34964', 'Byumba', 'billing'),
('3 Pankratz Terrace', '1625', 'United States', '63095', 'Karanganyar', 'staff'),
('3 Reindahl Drive', '5305', 'Canada', 'K8U3M0', 'Guangping', 'property'),
('30 Hayes Park', '2', 'Canada', 'G7F6D2', 'Fezna', 'staff'),
('3001 Autumn Leaf Terrace', '834', 'Canada', 'U1I2O9', 'Harrison', 'staff'),
('303 David Alley', '9617', 'United States', '19091', 'Khosta', 'property'),
('303 Judy Court', '7', 'United States', '23104', 'Wanshan', 'staff'),
('3058 Anzinger Drive', '84', 'Canada', 'P3X6R3', 'Nouaseur', 'billing'),
('3067 Oakridge Parkway', '022', 'United States', '64914', 'Kilimatinde', 'staff'),
('308 Kensington Avenue', '283', 'Canada', 'X3A6Y3', 'Suqin Huimin', 'property'),
('3083 Thierer Alley', '3', 'United States', '95821', 'Beiquan', 'billing'),
('31 Dennis Parkway', '2369', 'Canada', 'U0M6X9', 'Xiadian', 'property'),
('31 Mccormick Hill', '39', 'United States', '67122', 'Alquerubim', 'property'),
('31 Morningstar Trail', '9120', 'Canada', 'R7D0T5', 'Tsyelyakhany', 'staff'),
('31329 Hovde Lane', '5417', 'United States', '83819', 'Imielin', 'billing'),
('31492 Orin Way', '437', 'United States', '23104', 'Ercheng', 'billing'),
('315 Farragut Pass', '3', 'Canada', 'S1F1S1', 'Brwinów', 'staff'),
('3159 Lakeland Drive', '361', 'Canada', 'K1Z6L8', 'Tecpán Guatemala', 'property'),
('31872 Wayridge Point', '401', 'United States', '58782', 'Tangwāni', 'property'),
('32 Hazelcrest Street', '373', 'Canada', 'Y6G8G7', 'Islāmkot', 'property'),
('32 Lukken Avenue', '56798', 'Canada', 'P1X0U7', 'Nice', 'property'),
('3231 Charing Cross Alley', '63', 'Canada', 'B4U9M0', 'Bunut', 'billing'),
('32371 Bellgrove Road', '4034', 'United States', '15751', 'Pinamalayan', 'staff'),
('32796 6th Park', '27992', 'United States', '57046', 'Umeå', 'property'),
('32805 Park Meadow Crossing', '78173', 'Canada', 'Q3P1R6', 'Bantardawa', 'staff'),
('3292 Shoshone Drive', '98655', 'United States', '49159', 'Huaqiao', 'billing'),
('33 Kropf Street', '0297', 'Canada', 'D6A2H3', 'Sundsvall', 'staff'),
('33 Mayer Pass', '74', 'United States', '20336', 'Quime', 'billing'),
('3303 Hudson Court', '4325', 'United States', '74680', 'Primero de Enero', 'property'),
('331 Mifflin Parkway', '1588', 'United States', '64914', 'Falefa', 'property'),
('33183 Westridge Lane', '4', 'Canada', 'X9T8L7', 'Grijó', 'billing'),
('33454 Browning Lane', '24', 'United States', '32542', 'Santa Clara La Laguna', 'billing'),
('335 Basil Plaza', '70', 'United States', '27632', 'Mercaderes', 'staff'),
('3356 Butterfield Alley', '32', 'United States', '81684', 'Kudang', 'billing'),
('33575 Charing Cross Circle', '2', 'United States', '71709', 'Pionerskiy', 'property'),
('34 Bobwhite Trail', '496', 'United States', '79888', 'Koumra', 'billing'),
('34 Duke Circle', '8590', 'Canada', 'S0D6O9', 'Suban Jeriji', 'billing'),
('34 Eggendart Park', '3157', 'Canada', 'J4J2G1', 'Huoche Xizhan', 'billing'),
('34 Lake View Road', '0792', 'Canada', 'T3K2E6', 'San Francisco de Yare', 'property'),
('34 Mcbride Hill', '32', 'Canada', 'I8Z4I8', 'Kagal’nitskaya', 'billing'),
('34 Melby Point', '67', 'Canada', 'Y0H4F3', 'Beiqiao', 'staff'),
('34 Warner Street', '1026', 'Canada', 'M3E7E4', 'Yijiang', 'property'),
('341 American Ash Lane', '97578', 'Canada', 'N4B1L2', 'Sudogda', 'staff'),
('341 Morrow Hill', '0261', 'United States', '86352', 'Bocaiúva', 'staff'),
('34283 Schiller Trail', '28', 'Canada', 'Q8G7F8', 'Kalipucang', 'staff'),
('34385 Johnson Road', '8814', 'United States', '93170', 'Suchedniów', 'property'),
('345 Becker Terrace', '251', 'Canada', 'M1A7U3', 'Ma’an', 'staff'),
('345 Lotheville Pass', '94', 'Canada', 'X6G9Q1', 'Tsimasham', 'billing'),
('34682 Fallview Crossing', '563', 'United States', '15751', 'Zhongcheng', 'property'),
('35 Tomscot Alley', '7', 'United States', '96246', 'Santa Cruz De Tenerife', 'property'),
('35014 Donald Junction', '40', 'United States', '70289', 'Quinta do Sobrado', 'billing'),
('3511 Manufacturers Alley', '0327', 'United States', '20336', 'Tiassalé', 'billing'),
('3516 Pankratz Street', '2', 'United States', '54352', 'Santa Cecília', 'staff'),
('357 Jackson Pass', '21754', 'Canada', 'X3C0M9', 'Bilyayivka', 'property'),
('358 Atwood Junction', '9986', 'United States', '14374', 'Xindian', 'property'),
('36 Kingsford Drive', '78', 'United States', '34964', 'Rostock', 'property'),
('36 Macpherson Avenue', '70692', 'Canada', 'Y1L4R2', 'Zhujiachang', 'billing'),
('361 Butterfield Hill', '5', 'United States', '80530', 'Thawat Buri', 'staff'),
('365 Hooker Pass', '974', 'United States', '10450', 'Gros Morne', 'property'),
('36670 Donald Circle', '19402', 'Canada', 'S7J3F3', 'Koysinceq', 'billing'),
('36807 Stoughton Circle', '5404', 'Canada', 'N3C1U3', 'Nagrak', 'staff'),
('3687 Sheridan Pass', '1', 'Canada', 'R6R1Y9', 'Raejeru', 'property'),
('37 Waubesa Drive', '1', 'Canada', 'H7H7J0', 'Brandýs nad Labem-Stará Boleslav', 'property'),
('3704 Tennessee Pass', '3', 'United States', '51618', 'Huangchen', 'staff'),
('372 Gateway Center', '05246', 'United States', '64914', 'Tierralta', 'billing'),
('3744 Westend Court', '039', 'United States', '96436', 'Vilhena', 'billing'),
('37641 Ridge Oak Center', '9', 'United States', '57799', 'Guará', 'staff'),
('3774 Fisk Point', '8192', 'United States', '77725', 'Jaru', 'staff'),
('38 Hoffman Alley', '2374', 'Canada', 'R6R1Y9', 'Malasila', 'billing'),
('38 Knutson Circle', '7378', 'Canada', 'Y0B2B0', 'Vaggeryd', 'staff'),
('38 Lotheville Plaza', '36', 'Canada', 'T5G2F9', 'Halmstad', 'billing'),
('38 Orin Street', '48', 'Canada', 'C4M3Y3', 'Sishilichengzi', 'staff'),
('38 Warrior Court', '98711', 'United States', '63095', 'Maintang', 'property'),
('38034 Dakota Hill', '9', 'United States', '44220', 'Cilolohan', 'property'),
('3823 Michigan Center', '7960', 'Canada', 'A6I9J9', 'Empório', 'staff'),
('3829 Reindahl Park', '5', 'Canada', 'S3J0B7', 'Asia', 'property'),
('383 Raven Crossing', '872', 'United States', '20532', 'Comandante Luis Piedra Buena', 'staff'),
('3841 Mesta Center', '856', 'United States', '31589', 'Ban Khok', 'billing'),
('385 Grim Alley', '24', 'Canada', 'J7R9B7', 'Cap-Santé', 'billing'),
('38722 Eggendart Place', '4', 'Canada', 'N8X0F1', 'Trollhättan', 'staff'),
('39 Westport Trail', '0', 'Canada', 'G3U2J7', 'Dolní Dvořiště', 'staff'),
('392 Fisk Lane', '9', 'Canada', 'Z4X4M1', 'Limeiras', 'staff'),
('392 Vernon Trail', '57', 'Canada', 'P3X6R3', 'Sedlčany', 'staff'),
('397 Pond Hill', '01772', 'Canada', 'C4S7B0', 'Manay', 'billing'),
('4 5th Junction', '189', 'Canada', 'B2P5X5', 'Sancha', 'staff'),
('4 7th Avenue', '9', 'United States', '33115', 'Suwaru', 'billing'),
('4 Armistice Junction', '919', 'United States', '40251', 'Bogra', 'property'),
('4 Banding Point', '593', 'Canada', 'Y2N9B0', 'West Kelowna', 'staff'),
('4 Cardinal Alley', '122', 'United States', '25554', 'Zhouwang', 'billing'),
('4 Center Avenue', '014', 'Canada', 'Q3P1R6', 'Dvurechensk', 'staff'),
('4 David Hill', '839', 'United States', '43123', 'Józefosław', 'billing'),
('4 Del Sol Parkway', '8042', 'Canada', 'W6D3B8', 'El Triunfo de la Cruz', 'property'),
('4 Derek Trail', '92984', 'United States', '50359', 'Datang', 'property'),
('4 Elgar Place', '591', 'Canada', 'R5D3E0', 'Chigan', 'property'),
('4 Fairfield Crossing', '09', 'Canada', 'D8B2B8', 'Nishor', 'property'),
('4 Graedel Crossing', '15', 'Canada', 'J8R2U6', 'Pakel', 'billing'),
('4 Harper Alley', '7', 'Canada', 'U8T3M1', 'Midoun', 'billing'),
('4 Hermina Crossing', '592', 'Canada', 'E7G4Y7', 'Youwei', 'property'),
('4 High Crossing Center', '20', 'Canada', 'Q8G7F8', 'Pule', 'billing'),
('4 Holmberg Circle', '8', 'Canada', 'A7B2R7', 'Rumilly', 'billing'),
('4 Holy Cross Point', '24173', 'Canada', 'E5H3Y3', 'Vargas', 'staff'),
('4 International Place', '03', 'United States', '27489', 'Zakan-Yurt', 'property'),
('4 Katie Lane', '2', 'Canada', 'H0T9U0', 'Chlewiska', 'staff'),
('4 Maple Parkway', '298', 'Canada', 'Z8U9G8', 'Guandu', 'property'),
('4 Marquette Street', '13969', 'United States', '94574', 'Chengnan', 'property'),
('4 Meadow Valley Way', '478', 'United States', '73065', 'Ouyang', 'billing'),
('4 Merrick Road', '70', 'United States', '64914', 'Bydgoszcz', 'property'),
('4 Michigan Hill', '983', 'Canada', 'Q8G7F8', 'Mount Frere', 'property'),
('4 North Terrace', '290', 'United States', '20458', 'San Antonio', 'property'),
('4 Reinke Street', '30', 'United States', '90820', 'Banyo', 'billing'),
('4 Roth Pass', '6608', 'Canada', 'C2J0I0', 'Meudon', 'billing'),
('4 Susan Court', '01', 'Canada', 'G7Q7K7', 'Pa Phayom', 'billing'),
('4 Tennessee Alley', '9', 'Canada', 'Q3P1R6', 'Esperanza', 'property'),
('4 Transport Crossing', '9', 'United States', '20336', 'Gemuruh', 'staff'),
('4 Vahlen Lane', '50', 'Canada', 'P3X6R3', 'Huangshui', 'billing'),
('4 Vera Junction', '436', 'United States', '78249', 'Kopen', 'billing'),
('4 Warbler Drive', '88944', 'United States', '26557', 'La Jicaral', 'staff'),
('4 Waxwing Trail', '00', 'United States', '51618', 'Thị Trấn Mường Tè', 'property'),
('40 American Center', '7475', 'United States', '29840', 'Jardín América', 'billing'),
('40 Banding Trail', '129', 'United States', '20458', 'Port-Cartier', 'property'),
('40 Esker Avenue', '7', 'United States', '25554', 'Pousada', 'staff'),
('40050 Acker Junction', '360', 'United States', '59737', 'Bago', 'billing'),
('401 Stoughton Road', '3514', 'Canada', 'B2P5X5', 'Kisarazu', 'staff'),
('4028 Hallows Circle', '13', 'Canada', 'U8T3M1', 'Kishi', 'property'),
('4061 Novick Road', '032', 'United States', '57046', 'Haitou', 'billing'),
('40765 Mallard Circle', '57025', 'United States', '43123', 'Rydułtowy', 'property'),
('4081 Sachs Drive', '599', 'Canada', 'K3N7R1', 'Paipu', 'property'),
('41 Starling Circle', '2387', 'Canada', 'O2A5G4', 'Iguig', 'billing'),
('410 Westport Drive', '1959', 'United States', '49633', 'Monte Santo de Minas', 'billing'),
('41004 Valley Edge Road', '42', 'United States', '57185', 'Paojan', 'staff'),
('41364 Garrison Alley', '295', 'Canada', 'S1Y2Z5', 'Santa Clara', 'staff'),
('4152 Weeping Birch Trail', '2', 'Canada', 'T9F7W2', 'Toulon', 'property'),
('416 Pennsylvania Parkway', '2793', 'Canada', 'X0W5C2', 'Kašina', 'billing'),
('41653 Upham Way', '9', 'United States', '18164', 'Shajia’ao', 'staff'),
('41829 Pawling Court', '23', 'Canada', 'D1I1F4', 'Tayāsīr', 'staff'),
('41996 Dapin Way', '4019', 'Canada', 'E8K3Q7', 'Payao', 'billing'),
('42 Gateway Park', '184', 'United States', '12801', 'Chengfeng', 'property'),
('42 North Drive', '69134', 'Canada', 'Z3C1O5', 'Baishi', 'staff'),
('42187 Fisk Point', '0901', 'Canada', 'F3H2R6', 'Chitral', 'billing'),
('4226 Maywood Lane', '39', 'United States', '28705', 'Muang Xay', 'billing'),
('4237 Bowman Hill', '7', 'United States', '11423', 'Mikulčice', 'billing'),
('42420 Harbort Avenue', '543', 'United States', '18164', 'Baiguo', 'billing'),
('429 Waubesa Road', '7192', 'United States', '36100', 'Guane', 'property'),
('42962 Killdeer Place', '41132', 'United States', '17973', 'Kungsbacka', 'staff'),
('43 Artisan Alley', '48', 'United States', '45521', 'Orlando', 'property'),
('43 Corscot Hill', '2', 'Canada', 'M9A0Z8', 'Lunas', 'staff'),
('4346 Monterey Plaza', '674', 'United States', '49654', 'Huaishu', 'billing'),
('435 Hanover Terrace', '5444', 'Canada', 'D9N7Z9', 'Thoeng', 'billing'),
('43520 Cordelia Junction', '63909', 'Canada', 'Z8U9G8', 'Kuleqi', 'staff'),
('43710 Dennis Circle', '68', 'United States', '44220', 'Sacramento', 'staff'),
('438 Lukken Point', '108', 'United States', '33324', 'Huanglong', 'billing'),
('43928 Ohio Street', '01', 'United States', '36699', 'La Trinidad', 'billing'),
('44 Dahle Road', '65', 'Canada', 'J5Z0F4', 'Maojiagang', 'staff'),
('440 Hoard Park', '0829', 'United States', '49633', 'Veselí nad Moravou', 'billing'),
('44516 Green Avenue', '0038', 'Canada', 'I2X5N0', 'Pamiers', 'billing'),
('44651 La Follette Pass', '67', 'United States', '96546', 'Teslić', 'property'),
('4467 Duke Parkway', '9', 'Canada', 'R7F5Z0', 'Purabaya', 'staff'),
('4477 Norway Maple Street', '12', 'United States', '18606', 'Manwakh', 'property'),
('44925 Hayes Alley', '99303', 'Canada', 'X9G4S1', 'Kalianda', 'staff'),
('45 Butternut Crossing', '8', 'United States', '81684', 'Lakbok', 'billing'),
('45 Knutson Crossing', '37', 'United States', '62244', 'Pirg', 'property'),
('45 Lillian Crossing', '623', 'Canada', 'X9T8L7', 'Eksjö', 'billing'),
('45 Shopko Street', '9918', 'United States', '15751', 'Mangkon Daja', 'property'),
('4528 Oakridge Road', '4', 'United States', '84104', 'Fentange', 'property'),
('45402 Springview Road', '9769', 'United States', '37035', 'Nancy', 'billing'),
('4563 Village Court', '896', 'United States', '95677', 'Montepuez', 'billing'),
('458 Anderson Lane', '98726', 'United States', '36209', 'Buenaventura', 'staff'),
('4584 Scoville Road', '769', 'Canada', 'N2I7M0', 'Gongdanglegi Kulon', 'property'),
('46 Chinook Park', '0', 'United States', '12796', 'Cabeço de Vide', 'property'),
('46 Stang Point', '85066', 'United States', '59737', 'Acandí', 'staff'),
('460 Marquette Junction', '93021', 'United States', '78984', 'Shanggan', 'staff'),
('461 Northport Plaza', '5', 'Canada', 'O5N6I0', 'Huangzhuang', 'billing'),
('4612 Dixon Lane', '175', 'Canada', 'I5O9W5', 'Ndom', 'property'),
('46257 Red Cloud Pass', '5', 'United States', '80530', 'Kasba Tadla', 'billing'),
('464 Duke Trail', '28', 'Canada', 'I1J8C0', 'Chom Bueng', 'property'),
('46400 Hallows Hill', '42', 'Canada', 'O3K8C6', 'Sembung', 'property'),
('46556 Forster Alley', '21', 'Canada', 'A6I9J9', 'Dongmazar', 'billing'),
('4670 Service Circle', '25282', 'United States', '17580', 'Shangcunba', 'property'),
('469 Brown Trail', '26569', 'Canada', 'Z4S8H4', 'Berlin', 'staff'),
('46929 Merchant Point', '97125', 'Canada', 'X6G9Q1', 'Yanshi', 'property'),
('47 Orin Terrace', '2385', 'Canada', 'M9A0Z8', 'Umeå', 'property'),
('47124 Thackeray Trail', '1', 'United States', '23104', 'Konggar', 'staff'),
('47176 Sycamore Trail', '06', 'United States', '31667', 'Shatian', 'staff'),
('4732 Westend Road', '694', 'Canada', 'U6K2C9', 'Stupari', 'billing'),
('47590 Kipling Way', '0364', 'Canada', 'C8Y6F0', 'Longcun', 'staff'),
('48 Debs Park', '250', 'Canada', 'Y6G8G7', 'Guanambi', 'property'),
('48 Independence Plaza', '313', 'United States', '46675', 'Haugesund', 'property'),
('481 Bayside Avenue', '4', 'Canada', 'Q7C9S6', 'Bryan', 'billing'),
('48331 Lukken Crossing', '7473', 'Canada', 'Q9B3H1', 'Limoges', 'billing'),
('484 Menomonie Crossing', '2152', 'United States', '41991', 'Ivanivka', 'billing'),
('486 Ohio Circle', '01', 'Canada', 'Z0H6K0', 'Belyayevka', 'property'),
('49 Cordelia Drive', '2896', 'Canada', 'M7H8I9', 'High River', 'property'),
('49 Moulton Place', '84', 'Canada', 'Q1N2F5', 'Tepal', 'property'),
('49 Paget Park', '440', 'Canada', 'H1Q8Y4', 'Florianópolis', 'staff'),
('49 Pearson Street', '50377', 'United States', '49812', 'Necochea', 'property'),
('49292 Kipling Place', '415', 'Canada', 'J7Y6O1', 'General Emilio Aguinaldo', 'property'),
('4937 Summit Road', '3250', 'Canada', 'N4B1L2', 'Michałów-Reginów', 'staff'),
('49431 Northland Court', '4', 'Canada', 'S7J3F3', 'Malasila', 'billing'),
('49757 Oakridge Parkway', '27121', 'United States', '66847', 'Umeå', 'property'),
('4987 Nancy Drive', '4113', 'United States', '14665', 'Qal‘at Bīshah', 'property'),
('5 Anniversary Hill', '884', 'United States', '20336', 'Arcossó', 'billing'),
('5 Bonner Road', '91', 'Canada', 'A6I9J9', 'Mabyan', 'billing'),
('5 Bunker Hill Center', '5', 'Canada', 'J7R9B7', 'Invercargill', 'staff'),
('5 Butterfield Lane', '937', 'Canada', 'K1Z8A2', 'Betulia', 'billing'),
('5 Cherokee Lane', '5', 'United States', '71709', 'Chayuan', 'billing'),
('5 Chinook Center', '0', 'Canada', 'Q9B3H1', 'Lampa', 'property'),
('5 Colorado Hill', '8761', 'United States', '79888', 'Shixi', 'billing'),
('5 Erie Place', '435', 'Canada', 'A9E4H2', 'Yutou', 'billing'),
('5 Golf Course Center', '6', 'Canada', 'X3C0M9', 'Suci Kaler', 'staff'),
('5 Golf View Junction', '72', 'United States', '34106', 'Lees Summit', 'staff'),
('5 Graedel Center', '53740', 'United States', '87605', 'Changzheng', 'billing'),
('5 Gulseth Way', '3855', 'Canada', 'A6Y6K4', 'Sigaozhuang', 'billing'),
('5 Hanson Street', '130', 'United States', '43287', 'Nagrog', 'staff'),
('5 Kim Center', '3722', 'Canada', 'Y3C3O9', 'Sheli', 'staff'),
('5 Linden Parkway', '2543', 'United States', '33783', 'San Pedro One', 'staff'),
('5 Melody Way', '070', 'Canada', 'U2O7F2', 'Libertad', 'property'),
('5 Myrtle Road', '81007', 'Canada', 'T9F7W2', 'Casal Novo', 'staff'),
('5 Northview Court', '22730', 'United States', '85861', 'Sukadana', 'staff'),
('5 Old Gate Park', '34389', 'Canada', 'Y0H4F3', 'Voronezh', 'property'),
('5 Redwing Road', '401', 'Canada', 'C2J0I0', 'Baiyushan', 'staff'),
('5 Sloan Road', '4471', 'United States', '29021', 'Unanu', 'property'),
('5 Spohn Avenue', '48', 'United States', '59737', 'Kinamayan', 'staff'),
('5 Sullivan Circle', '752', 'Canada', 'R7D0T5', 'Rakitnoye', 'billing'),
('5 Tennyson Place', '7', 'United States', '97923', 'Marcovia', 'staff'),
('5 Village Green Junction', '514', 'United States', '95234', 'Shawnee Mission', 'billing'),
('50 Clove Alley', '1', 'Canada', 'K3N7R1', 'Meziměstí', 'staff'),
('5002 Thackeray Trail', '87531', 'Canada', 'C9C5N0', 'Zhanghua', 'staff'),
('501 Elgar Park', '05', 'Canada', 'X9G4S1', 'Västra Frölunda', 'property'),
('50105 Coolidge Crossing', '86319', 'Canada', 'Z4S8H4', 'Santa Lucia', 'billing'),
('50337 Dayton Drive', '1095', 'United States', '34925', 'Zhayang', 'billing'),
('5039 Northfield Way', '35363', 'Canada', 'X6G9Q1', 'Pancol', 'property'),
('505 Banding Court', '91419', 'United States', '11792', 'Nanyulinxi', 'billing'),
('50547 Veith Avenue', '33619', 'Canada', 'X3A6Y3', 'Choisy-le-Roi', 'property'),
('5063 Sugar Crossing', '0', 'Canada', 'A6I9J9', 'Shumikha', 'property'),
('50650 Anzinger Circle', '6', 'United States', '14374', 'Tikhvin', 'property'),
('50764 Pine View Street', '2', 'Canada', 'Q8G7F8', 'Syców', 'billing'),
('51 Bluestem Point', '9', 'Canada', 'M8N0M7', 'Xiangba', 'staff'),
('51 Coolidge Pass', '6126', 'Canada', 'I5O9W5', 'Yujia', 'staff'),
('51 Lien Plaza', '69', 'United States', '94442', 'Volnovakha', 'property'),
('51 Marcy Alley', '88', 'United States', '98428', 'Wujiayao', 'billing'),
('510 Logan Court', '3718', 'United States', '78984', 'Horka nad Moravou', 'staff'),
('5105 Dawn Drive', '31', 'Canada', 'S1Y2Z5', 'Erqu', 'billing'),
('512 Mariners Cove Drive', '2', 'United States', '36100', 'Sapol', 'property'),
('5128 Declaration Hill', '70', 'United States', '30542', 'Paninggaran', 'property'),
('51299 Esker Junction', '0', 'Canada', 'X6G9Q1', 'Nanying', 'property'),
('517 Sunnyside Lane', '802', 'United States', '79888', 'Huaping', 'staff'),
('519 Maryland Hill', '5', 'Canada', 'J7R9B7', 'Nagaracinta', 'property'),
('52 Schmedeman Center', '6114', 'Canada', 'J5W6I8', 'Białobrzegi', 'property'),
('52 Vahlen Point', '5058', 'United States', '82176', 'Kashima', 'staff'),
('52085 Glendale Junction', '79', 'Canada', 'M3L1W6', 'Helsingborg', 'staff'),
('52318 Straubel Circle', '9', 'United States', '46560', 'Battambang', 'billing'),
('5235 Messerschmidt Street', '4', 'Canada', 'X6G9Q1', 'Tolitoli', 'billing'),
('525 Macpherson Alley', '1', 'Canada', 'J3D2J3', 'Lidong', 'billing'),
('5250 Eliot Drive', '9', 'United States', '10986', 'Huanggang', 'billing'),
('52557 Bartelt Point', '9475', 'Canada', 'N3C1U3', 'Kario', 'billing'),
('53 Valley Edge Crossing', '4', 'United States', '93651', 'Codrington', 'billing'),
('530 Pennsylvania Road', '78332', 'United States', '33783', 'Nongoma', 'staff'),
('5354 Maple Road', '633', 'United States', '34964', 'Smedjebacken', 'property'),
('536 Ridge Oak Plaza', '01', 'United States', '38339', 'Ţafas', 'staff'),
('5364 Messerschmidt Alley', '1628', 'Canada', 'Q9I5U6', 'Frederiksberg', 'billing'),
('53782 Milwaukee Avenue', '3', 'United States', '94576', 'Nijmegen', 'staff'),
('53877 Wayridge Pass', '87716', 'Canada', 'C4M3Y3', 'Richmond', 'property'),
('54 Blackbird Parkway', '9', 'United States', '10180', 'Woken', 'staff'),
('54 Lawn Crossing', '8027', 'United States', '20458', 'Vila Nova de Santo André', 'property'),
('54 Pawling Trail', '13', 'Canada', 'R1L8S7', 'Kagay', 'staff'),
('542 Almo Hill', '5', 'Canada', 'S1F1S1', 'Jinshanzui', 'property'),
('54758 Pierstorff Road', '50', 'Canada', 'C9X4Q9', 'Zibreira', 'billing'),
('55 Gateway Place', '483', 'Canada', 'U0L3Z2', 'Jomda', 'staff'),
('55 Shoshone Hill', '7', 'Canada', 'I7F2K1', 'Weizhou', 'billing'),
('55 Weeping Birch Lane', '07432', 'Canada', 'K0X0G7', 'Kapitanivka', 'property'),
('55029 Spohn Park', '2103', 'Canada', 'T8A1I8', 'Kahnūj', 'billing'),
('551 Daystar Point', '85', 'Canada', 'D1L8A6', 'Nasielsk', 'property'),
('5557 Cascade Park', '80962', 'United States', '18606', 'Longquan', 'billing'),
('556 Vernon Drive', '37', 'Canada', 'U5S4C4', 'Wŏnju', 'staff'),
('559 Packers Park', '998', 'United States', '19011', 'Bintawan', 'staff'),
('561 Tomscot Crossing', '3707', 'Canada', 'H0T9U0', 'Cabugao', 'staff'),
('5617 Vidon Crossing', '9115', 'United States', '66847', 'Puntarenas', 'property'),
('5634 Brickson Park Drive', '4146', 'United States', '11462', 'Parigi', 'billing'),
('565 Grim Point', '81', 'United States', '56794', 'Kęty', 'billing'),
('565 Pleasure Park', '082', 'Canada', 'S1F1S1', 'Paccho', 'staff'),
('565 Saint Paul Street', '1', 'United States', '54352', 'Mayahi', 'staff'),
('56618 Pennsylvania Parkway', '377', 'United States', '60174', 'Smoky Lake', 'billing'),
('5676 Pond Circle', '1260', 'Canada', 'O2A5G4', 'Comalapa', 'staff'),
('5682 Merrick Avenue', '67923', 'United States', '47397', 'Zelenodolsk', 'property'),
('57 Sunbrook Street', '62', 'Canada', 'Z0T8F1', 'Quiling', 'staff'),
('57 Welch Park', '2', 'United States', '13918', 'Hengli', 'staff'),
('572 Moland Alley', '8268', 'United States', '77725', 'Wakefield', 'property'),
('578 Kropf Court', '23931', 'Canada', 'U6K2C9', 'Maoming', 'billing'),
('57808 Arizona Park', '3', 'United States', '56794', 'Cabreúva', 'staff'),
('58 Lerdahl Lane', '193', 'United States', '20336', 'Havana', 'staff'),
('58403 Cardinal Park', '293', 'Canada', 'R6T2C5', 'Montecarlo', 'property'),
('58413 Esker Parkway', '64850', 'United States', '94287', 'Shangbahe', 'billing'),
('58959 Stone Corner Avenue', '917', 'United States', '18606', 'Sanguinheira', 'staff'),
('59 Hooker Avenue', '84', 'Canada', 'M9Z3I5', 'Mazhu', 'property'),
('59 Schiller Trail', '5', 'United States', '36100', 'Chynów', 'property'),
('59 Shoshone Hill', '02135', 'United States', '27235', 'Powidz', 'staff'),
('59 Sullivan Point', '7', 'Canada', 'R8W0K1', 'Somié', 'staff'),
('5937 Commercial Avenue', '413', 'United States', '71293', 'Jiuxian', 'property'),
('5946 Spohn Circle', '3', 'United States', '86702', 'Tsalgar', 'property'),
('596 Crowley Road', '02', 'Canada', 'Q9I5U6', 'Konduga', 'billing'),
('5976 Anhalt Trail', '83', 'Canada', 'E2M6A9', 'Qianwei', 'staff'),
('5987 Trailsway Trail', '00495', 'Canada', 'N3G1I7', 'Cocobeach', 'staff'),
('599 Alpine Center', '7372', 'United States', '78826', 'Nusajaya', 'billing'),
('59960 Kim Plaza', '426', 'Canada', 'U5S4C4', 'Wenshao', 'staff'),
('6 Bluestem Hill', '10307', 'Canada', 'J7O4B7', 'Usukhchay', 'property'),
('6 Briar Crest Parkway', '80923', 'Canada', 'K4Z9W9', 'La Montañita', 'billing'),
('6 Bultman Drive', '56', 'United States', '57185', 'As Saddah', 'staff'),
('6 Clemons Hill', '4257', 'Canada', 'M7E8E8', 'Perpignan', 'property'),
('6 Di Loreto Way', '9029', 'Canada', 'B5Q7U1', 'Al Jubayl', 'billing'),
('6 Dovetail Street', '324', 'United States', '56553', 'San Jose', 'property'),
('6 Lakewood Gardens Drive', '41291', 'Canada', 'M7H8I9', 'Igreja', 'staff'),
('6 Mayer Avenue', '3', 'Canada', 'D9N7Z9', 'Lokosovo', 'property'),
('6 Mitchell Junction', '64', 'Canada', 'R7D0T5', 'Changyŏn', 'staff'),
('6 Schurz Court', '2338', 'United States', '11622', 'Ar Rawnah', 'staff'),
('6 Shasta Place', '842', 'Canada', 'J5W6I8', 'Zhongzhai', 'property'),
('6 Shoshone Parkway', '78', 'United States', '73373', 'Catujal Velho', 'property'),
('6 Springs Street', '78127', 'Canada', 'N8X0F1', 'Bacalan', 'staff'),
('6 Sycamore Park', '66388', 'United States', '23482', 'Itabaianinha', 'property'),
('6 Wayridge Court', '4', 'United States', '33040', 'Krasiczyn', 'billing'),
('60 Dottie Place', '6276', 'United States', '54292', 'Loum', 'property'),
('60 Ronald Regan Pass', '71618', 'Canada', 'D6F3D9', 'Panalo-on', 'billing'),
('600 Moulton Street', '10', 'Canada', 'Q9I5U6', 'Birni N Konni', 'staff'),
('6023 Ridgeview Lane', '740', 'United States', '22900', 'Aygestan', 'property'),
('603 Corscot Alley', '87', 'Canada', 'Z0H6K0', 'Bilajari', 'staff'),
('6059 Redwing Terrace', '4', 'United States', '84514', 'Ningtang', 'staff'),
('60614 Everett Center', '5058', 'Canada', 'E7G4Y7', 'Shimanovsk', 'staff'),
('60696 Prentice Parkway', '5', 'United States', '78249', 'Nuquí', 'property'),
('60770 Sommers Drive', '4949', 'United States', '95234', 'Thị Trấn Triệu Sơn', 'billing'),
('6099 Laurel Trail', '97', 'United States', '33783', 'Ronda', 'property'),
('61 Farragut Center', '90462', 'Canada', 'H8Q2G3', 'Pavlovskaya', 'staff'),
('61 Lyons Parkway', '60725', 'Canada', 'K8U3M0', 'Dejen', 'billing'),
('61 Manitowish Pass', '4', 'United States', '15449', 'Terjan', 'staff'),
('61 Reindahl Road', '16', 'United States', '41991', 'Likwatang Timur', 'property'),
('61 Warbler Alley', '81483', 'Canada', 'Q9B3H1', 'Molodohvardiys’k', 'property'),
('6110 Corben Drive', '0', 'Canada', 'O9F1T9', 'Widorokandang', 'staff'),
('6116 Canary Park', '61897', 'United States', '78826', 'Clermont-Ferrand', 'property'),
('613 Parkside Drive', '55', 'United States', '54436', 'Kelapa', 'billing'),
('61354 Marcy Road', '454', 'Canada', 'C4S7B0', 'Jiuxian', 'billing'),
('615 Corben Junction', '66', 'Canada', 'J3D2J3', 'Jamaica', 'staff'),
('615 Elgar Road', '0', 'United States', '47397', 'Thị Trấn Mường Lát', 'property'),
('61820 Summerview Court', '859', 'Canada', 'H8Q2G3', 'Conceição do Araguaia', 'billing'),
('6183 Maryland Road', '396', 'Canada', 'D7M6R9', 'Dolinsk', 'staff'),
('61901 South Plaza', '1', 'United States', '12616', 'Cemara', 'property'),
('6193 Amoth Hill', '7', 'United States', '29840', 'Imeni Babushkina', 'billing'),
('62 Blaine Drive', '3', 'United States', '36427', 'Vestmannaeyjar', 'property'),
('62 Schiller Parkway', '10821', 'United States', '12796', 'Ochota', 'billing'),
('6202 Mariners Cove Avenue', '7', 'United States', '34925', 'Log pri Brezovici', 'property'),
('62132 Shelley Court', '74', 'Canada', 'Y0B2B0', 'Lelekovice', 'property'),
('62222 Namekagon Road', '258', 'Canada', 'Q1N2F5', 'Junchuan', 'property');
INSERT INTO `address` (`street_address`, `unit_number`, `country`, `postal_code`, `city`, `address_type`) VALUES
('6239 Macpherson Plaza', '8756', 'United States', '43123', 'Dean', 'staff'),
('627 Homewood Court', '2', 'United States', '44890', 'Laau', 'staff'),
('628 Morrow Terrace', '5851', 'United States', '22525', 'Sucre', 'property'),
('6290 Oxford Pass', '17477', 'Canada', 'E2M6A9', 'Pires do Rio', 'property'),
('63 Columbus Street', '0843', 'Canada', 'I1J8C0', 'Pilar do Sul', 'property'),
('633 Thackeray Parkway', '3', 'United States', '57046', 'Ginebra', 'billing'),
('63946 Bunker Hill Way', '6441', 'United States', '14888', 'La Montañita', 'billing'),
('64 Stang Road', '537', 'Canada', 'F6W0G4', 'Ning’er', 'staff'),
('64 Stephen Avenue', '015', 'United States', '40251', 'Abaza', 'property'),
('640 Hoard Lane', '77', 'Canada', 'J5G7Z3', 'Kosiv', 'property'),
('64484 Shoshone Avenue', '57343', 'United States', '12543', 'Šenov', 'staff'),
('645 Luster Crossing', '7277', 'United States', '65218', 'Ganpu', 'billing'),
('6453 Burrows Center', '33154', 'United States', '81112', 'Visby', 'staff'),
('646 Lighthouse Bay Drive', '85861', 'Canada', 'T5G2F9', 'Jiblah', 'staff'),
('64618 Alpine Plaza', '4', 'United States', '86900', 'Yantal’', 'billing'),
('647 Sherman Drive', '416', 'Canada', 'U5L2M5', 'Porto Velho', 'billing'),
('65 Rutledge Plaza', '65', 'United States', '83819', 'Qingping', 'staff'),
('650 Sauthoff Road', '4158', 'United States', '84514', 'Bribir', 'property'),
('6506 Clyde Gallagher Avenue', '1', 'United States', '62244', 'Kotel’va', 'staff'),
('6537 Anzinger Road', '11515', 'United States', '71293', 'Ziguinchor', 'property'),
('66 Crest Line Center', '08582', 'Canada', 'F3R1I1', 'Arrentela', 'billing'),
('66 Heath Point', '48', 'Canada', 'P1X0U7', 'Ribeira Grande', 'billing'),
('66 North Trail', '0', 'Canada', 'M7H8I9', 'Bagong Pagasa', 'billing'),
('66 Springs Hill', '23333', 'United States', '49159', 'Lap Lae', 'staff'),
('66044 Packers Crossing', '6', 'United States', '81500', 'Meicheng', 'property'),
('6631 Johnson Street', '9886', 'Canada', 'D9Q0N6', 'Lille', 'staff'),
('6655 Glacier Hill Trail', '2', 'United States', '71709', 'Seren Barat', 'property'),
('6685 Havey Hill', '7', 'United States', '60451', 'Penha Longa', 'billing'),
('67 Bobwhite Court', '981', 'Canada', 'J9X9O1', 'Al Ghayl', 'staff'),
('67 Fallview Pass', '6165', 'United States', '38339', 'Thomassique', 'billing'),
('6701 1st Point', '31', 'United States', '12796', 'Bascaron', 'billing'),
('67021 Kipling Junction', '061', 'United States', '50359', 'Bāglung', 'billing'),
('6727 Kinsman Center', '5', 'United States', '13060', 'Bahaodi', 'staff'),
('676 Waubesa Crossing', '0222', 'Canada', 'J6L9S2', 'Indianapolis', 'billing'),
('67608 Alpine Lane', '127', 'Canada', 'R8W0K1', 'Ayapel', 'staff'),
('6768 Elmside Plaza', '087', 'United States', '74680', 'Agen', 'property'),
('67753 Longview Lane', '949', 'Canada', 'Y6G8G7', 'Sarāvān', 'billing'),
('6797 Lillian Place', '56263', 'Canada', 'H0T9U0', 'Rennebu', 'property'),
('68 Del Sol Court', '19', 'United States', '19362', 'Golčův Jeníkov', 'staff'),
('68 Dwight Park', '6', 'United States', '37035', 'Fort Myers', 'staff'),
('6824 Carberry Road', '107', 'Canada', 'F7C7A2', 'Romans-sur-Isère', 'staff'),
('683 Stone Corner Lane', '25821', 'Canada', 'X0F0B6', 'Floridablanca', 'property'),
('6849 New Castle Junction', '8', 'Canada', 'O1H1W9', 'Fujioka', 'property'),
('6868 Fieldstone Plaza', '4676', 'United States', '25554', 'Jajarkrajan', 'staff'),
('68787 Old Shore Alley', '2', 'Canada', 'Q1I1E7', 'New Hyde Park', 'billing'),
('688 Barby Crossing', '70244', 'Canada', 'C4S7B0', 'Iturama', 'staff'),
('688 Maple Crossing', '2109', 'United States', '27632', 'Merklín', 'billing'),
('68879 Menomonie Junction', '9227', 'United States', '86702', 'Kościerzyna', 'property'),
('69 Farwell Point', '517', 'Canada', 'B3A6R5', 'Cennan', 'property'),
('69 Ryan Street', '46377', 'United States', '27489', 'Bayambang', 'property'),
('69380 Annamark Terrace', '995', 'Canada', 'J6L9S2', 'San Javier', 'staff'),
('694 Lakewood Plaza', '530', 'Canada', 'A6Y6K4', 'Huocheng', 'property'),
('694 Maryland Street', '648', 'United States', '18164', 'Prosperidad', 'staff'),
('696 Haas Way', '1511', 'Canada', 'O5N6I0', 'Banaran', 'staff'),
('69644 Saint Paul Junction', '13640', 'United States', '47397', 'Tvarožná', 'staff'),
('69710 Hansons Drive', '877', 'United States', '31667', 'Krolevets’', 'billing'),
('699 Nevada Way', '19', 'United States', '70571', 'Horgo', 'billing'),
('7 Badeau Avenue', '1021', 'Canada', 'K4M3S0', 'Leninogorsk', 'billing'),
('7 Carpenter Street', '7', 'Canada', 'K1Z6L8', 'Iroquois Falls', 'property'),
('7 Corry Circle', '8980', 'Canada', 'R7D0T5', 'Jām Sāhib', 'staff'),
('7 Dahle Avenue', '42', 'Canada', 'Y6G8G7', 'Albania', 'property'),
('7 Fordem Plaza', '694', 'United States', '90220', 'Pilar do Sul', 'property'),
('7 Forster Alley', '65373', 'United States', '49633', 'Dayingjie', 'staff'),
('7 Fuller Alley', '88', 'Canada', 'U2D4C4', 'Nanshi', 'billing'),
('7 Golden Leaf Crossing', '043', 'United States', '56403', 'Isidro Fabela', 'staff'),
('7 Graceland Junction', '0372', 'Canada', 'C5M5E1', 'Centurion', 'billing'),
('7 Homewood Way', '8312', 'United States', '17580', 'Camachile', 'billing'),
('7 Namekagon Trail', '1', 'Canada', 'D7M6R9', 'Buđanovci', 'billing'),
('7 Prentice Drive', '9277', 'United States', '92662', 'Bangus Kulon', 'billing'),
('7 School Point', '986', 'United States', '68092', 'Tianxin', 'staff'),
('7 Shasta Street', '781', 'United States', '12543', 'East End', 'staff'),
('7 Steensland Street', '824', 'United States', '14665', 'Jiamachi', 'property'),
('7 Sutherland Hill', '675', 'Canada', 'N8X0F1', 'Camden', 'billing'),
('7 Transport Plaza', '2104', 'Canada', 'J8R2U6', 'Vallentuna', 'property'),
('7 Union Terrace', '1', 'Canada', 'E8K3Q7', 'Hostomice', 'staff'),
('7 Vera Crossing', '2', 'Canada', 'I5O9W5', 'Diré', 'billing'),
('7 Weeping Birch Circle', '87223', 'United States', '19091', 'Elliot', 'billing'),
('70 Linden Drive', '0', 'Canada', 'L5K3G0', 'Paris 16', 'staff'),
('70 Mitchell Place', '79601', 'Canada', 'Y0J4P7', 'Nioumamilima', 'property'),
('7017 Park Meadow Drive', '8359', 'United States', '37035', 'Giebułtów', 'staff'),
('7022 Canary Trail', '913', 'Canada', 'M1N6T4', 'Garajati', 'staff'),
('70382 Boyd Court', '09050', 'Canada', 'T5G2F9', 'Wudui', 'billing'),
('705 Del Sol Park', '91', 'Canada', 'A7B2R7', 'Rawaapu', 'billing'),
('7050 Donald Hill', '89', 'Canada', 'N2I7M0', 'Chachagüí', 'billing'),
('70749 Lerdahl Court', '35', 'Canada', 'Y0H4F3', 'Ciudad Guayana', 'staff'),
('7092 Elka Trail', '2740', 'United States', '41991', 'Zagórnik', 'property'),
('71 Clyde Gallagher Drive', '2', 'United States', '71718', 'Huangzhai', 'billing'),
('71 Gina Junction', '02769', 'United States', '10180', 'Yuntan', 'staff'),
('71 Russell Pass', '824', 'Canada', 'Q9I5U6', 'Bendorubuh', 'billing'),
('7154 American Terrace', '82', 'United States', '17580', 'Tytuvėnėliai', 'billing'),
('717 Hansons Place', '66119', 'United States', '94576', 'Gudang', 'property'),
('72 Bultman Terrace', '5', 'United States', '27235', 'Awilega', 'property'),
('72 Elmside Court', '1', 'United States', '31589', 'Repnoye', 'billing'),
('72 Hagan Point', '27', 'Canada', 'T2O7T8', 'Choropampa', 'property'),
('73 Farragut Street', '41063', 'United States', '98166', 'Prince Rupert', 'staff'),
('73 Lien Circle', '0787', 'Canada', 'C4M3Y3', 'Tumcon Ilawod', 'property'),
('73 Melvin Place', '27143', 'Canada', 'T8O1E6', 'Kuningan', 'billing'),
('73 Starling Lane', '002', 'United States', '33783', 'Pecka', 'staff'),
('730 Eagle Crest Drive', '8', 'Canada', 'F3R1I1', 'Sagua de Tánamo', 'billing'),
('73199 Sachs Lane', '170', 'Canada', 'B2P5X5', 'Haapsalu', 'staff'),
('7377 Dayton Trail', '40993', 'United States', '22156', 'Växjö', 'billing'),
('739 Eastwood Plaza', '87', 'United States', '53732', 'Fengyang', 'property'),
('7407 Hansons Terrace', '42655', 'United States', '32542', 'Gaspar', 'billing'),
('743 Packers Hill', '329', 'Canada', 'W6D3B8', 'Sumuragung', 'billing'),
('7431 Texas Park', '1', 'Canada', 'Q3P1R6', 'Ngujuran', 'staff'),
('744 Dovetail Way', '654', 'United States', '50359', 'Saaban', 'billing'),
('7446 Rowland Crossing', '454', 'Canada', 'P3X6R3', 'Wengaingo', 'billing'),
('75 Hagan Lane', '1', 'Canada', 'P1X0U7', 'Keleng', 'staff'),
('75192 Ludington Avenue', '17', 'United States', '32542', 'Žatec', 'property'),
('75358 Oxford Place', '9', 'United States', '44890', 'La Aurora', 'staff'),
('754 Armistice Avenue', '1162', 'Canada', 'R5D3E0', 'Youkaichi', 'property'),
('754 Dorton Lane', '56', 'United States', '14665', 'Ulricehamn', 'billing'),
('75420 Doe Crossing Street', '310', 'United States', '20458', 'Shuangxiqiao', 'property'),
('758 Marcy Lane', '35', 'United States', '18606', 'Antwerpen', 'staff'),
('76 Claremont Alley', '42', 'United States', '66847', 'Armenia', 'billing'),
('76003 Monterey Terrace', '0596', 'Canada', 'K1Z8A2', 'Murom', 'property'),
('762 Old Shore Center', '551', 'United States', '96246', 'Karakulino', 'billing'),
('76213 Waubesa Park', '8369', 'Canada', 'C9X4Q9', 'Skärholmen', 'staff'),
('7629 Stone Corner Park', '90101', 'Canada', 'F3H2R6', 'Tetyushi', 'staff'),
('763 Eagle Crest Lane', '45', 'Canada', 'K3N7R1', 'Gannan', 'billing'),
('76795 Barby Park', '17471', 'United States', '14374', 'Ciparay', 'billing'),
('77 Hoffman Lane', '84631', 'United States', '58782', 'Novonukutskiy', 'staff'),
('77 Stuart Pass', '3', 'United States', '64009', 'Kamigyō-ku', 'property'),
('7700 Kedzie Point', '90286', 'Canada', 'P5G0C2', 'Pignon', 'property'),
('7703 Twin Pines Terrace', '6480', 'United States', '96012', 'Mopti', 'property'),
('771 Commercial Point', '5', 'United States', '68103', 'Butou', 'property'),
('771 Morning Park', '6', 'United States', '94574', 'Priyutovo', 'staff'),
('7742 Dennis Street', '44', 'United States', '29840', 'Yuandianhui', 'staff'),
('779 Truax Lane', '80', 'United States', '87605', 'Xidoupu', 'property'),
('77904 Bowman Road', '90', 'United States', '93616', 'Las Palmas', 'billing'),
('7794 Everett Parkway', '45568', 'United States', '33783', 'Hengfan', 'staff'),
('78 Michigan Avenue', '8', 'United States', '78826', 'Labansari', 'billing'),
('78 Ridge Oak Terrace', '368', 'United States', '64009', 'Khok Charoen', 'staff'),
('78 Sommers Street', '8', 'Canada', 'O1H1W9', 'Tomsk', 'staff'),
('782 Larry Road', '046', 'United States', '15751', 'Ząbkowice Śląskie', 'staff'),
('78228 Ridge Oak Circle', '61886', 'United States', '44220', 'Alburitel', 'billing'),
('78313 Clarendon Park', '720', 'United States', '56794', 'Daxing', 'property'),
('784 Meadow Ridge Street', '21', 'United States', '28705', 'Gelang', 'property'),
('7849 Magdeline Way', '18', 'Canada', 'T2L1B0', 'Aného', 'staff'),
('785 Schmedeman Terrace', '63', 'United States', '15751', 'Geser', 'staff'),
('7878 Dexter Crossing', '355', 'Canada', 'X9G4S1', 'Cherskiy', 'staff'),
('79623 Browning Way', '0', 'United States', '75753', 'Soufrière', 'billing'),
('8 Bartelt Park', '6', 'United States', '44091', 'Tuka', 'property'),
('8 Brickson Park Court', '319', 'United States', '53732', 'Mīr Bachah Kōṯ', 'billing'),
('8 Bultman Avenue', '9846', 'United States', '72863', 'Žrnovnica', 'billing'),
('8 Clarendon Avenue', '6846', 'Canada', 'G2J1L2', 'Yashao', 'property'),
('8 Clove Avenue', '6117', 'Canada', 'G4N1N9', 'Barranca', 'property'),
('8 Cottonwood Parkway', '32', 'Canada', 'L5K3G0', 'Tripoli', 'billing'),
('8 Florence Point', '5', 'United States', '10450', 'Tenjolaya', 'staff'),
('8 Forest Run Center', '663', 'Canada', 'J7Y6O1', 'Xitieshan', 'property'),
('8 Fremont Parkway', '16', 'United States', '12796', 'Kamiennik', 'staff'),
('8 Kensington Center', '3', 'United States', '49654', 'Powidz', 'billing'),
('8 La Follette Hill', '923', 'Canada', 'I5O9W5', 'Vaiamonte', 'billing'),
('8 Mariners Cove Park', '54266', 'United States', '62244', 'Kajiado', 'property'),
('8 Melody Terrace', '7400', 'United States', '86900', 'Taihe Chengguanzhen', 'property'),
('8 Pond Crossing', '5473', 'United States', '81958', 'Floresta', 'billing'),
('8 Randy Alley', '96243', 'Canada', 'N3G1I7', 'Fangxiang', 'property'),
('8 Ridgeview Avenue', '267', 'Canada', 'X6G9Q1', 'Palmerston North', 'property'),
('8 Rusk Terrace', '5991', 'Canada', 'I1N6L0', 'Ayapel', 'staff'),
('8 Sherman Center', '999', 'Canada', 'T9J4Y0', 'Al Muharraq', 'staff'),
('8 Sunbrook Terrace', '471', 'Canada', 'O1B0A3', 'Tečovice', 'property'),
('8 Westend Trail', '68', 'United States', '38339', 'Grazhdanka', 'property'),
('80 Shoshone Terrace', '75209', 'Canada', 'Y0J4P7', 'Hostavice', 'property'),
('80 Stoughton Hill', '1165', 'Canada', 'Y0H4F3', 'Tulungrejo', 'billing'),
('80 Sutherland Street', '48', 'United States', '45521', 'Kobylanka', 'property'),
('80090 Towne Place', '586', 'Canada', 'Q1N2F5', 'Hualian', 'property'),
('801 Holy Cross Court', '316', 'United States', '94287', 'Tangchijie', 'staff'),
('802 Mifflin Place', '1', 'Canada', 'Y3C3O9', 'Jatisari', 'staff'),
('802 Warrior Park', '35', 'United States', '71718', 'Brgy. Nalook, kalibo', 'property'),
('8036 Cardinal Road', '84813', 'Canada', 'P3X6R3', 'Gongdao', 'billing'),
('8045 Susan Way', '8', 'Canada', 'G7Q7K7', 'Kadupinang', 'staff'),
('808 Lindbergh Lane', '3671', 'United States', '64914', 'Philadelphia', 'staff'),
('8081 Tennessee Point', '484', 'United States', '95677', 'Proença-a-Nova', 'billing'),
('80939 Lindbergh Way', '6564', 'Canada', 'P1X0U7', 'Velas', 'billing'),
('81 Bay Crossing', '43', 'Canada', 'X3C0M9', 'Baluk', 'property'),
('81 Drewry Circle', '1081', 'United States', '10180', 'Ta’erqi', 'staff'),
('81 Pawling Plaza', '95365', 'United States', '51688', 'Hartford', 'billing'),
('81 Petterle Way', '5255', 'United States', '55002', 'Fundão', 'staff'),
('81 Rieder Pass', '3568', 'Canada', 'U0M6X9', 'Planaltina', 'property'),
('810 Barnett Road', '15', 'United States', '81500', 'Balbalan', 'property'),
('81258 High Crossing Terrace', '42', 'Canada', 'Y2N9B0', 'Béziers', 'staff'),
('8155 Rockefeller Court', '23', 'Canada', 'U2U5S9', 'Concórdia', 'staff'),
('816 Banding Junction', '50', 'United States', '23482', 'Tovarnik', 'property'),
('8164 Westridge Hill', '15', 'United States', '23104', 'Huinca Renancó', 'staff'),
('818 Vahlen Park', '47170', 'United States', '30542', 'Dobryatino', 'billing'),
('82 Grayhawk Way', '873', 'United States', '13060', 'Pingding', 'staff'),
('82 Hansons Drive', '72', 'Canada', 'U6K2C9', 'Dos Quebradas', 'billing'),
('82 Holy Cross Hill', '5', 'United States', '47656', 'Arsen’yev', 'property'),
('8202 Hansons Way', '64413', 'United States', '36209', 'Cool űrhajó', 'staff'),
('82167 Maryland Hill', '8', 'Canada', 'N4B1L2', 'Chunjiang', 'property'),
('8282 Sherman Crossing', '765', 'United States', '56403', 'San Jose', 'billing'),
('83 Delladonna Circle', '1', 'United States', '33115', 'Novoishimskiy', 'staff'),
('83 Lien Terrace', '84', 'Canada', 'F3H2R6', 'Uji', 'billing'),
('83 Pawling Point', '7574', 'Canada', 'U2D4C4', 'Verkhn’odniprovs’k', 'property'),
('83 Vernon Drive', '2101', 'Canada', 'M1N6T4', 'Profítis Ilías', 'property'),
('83225 Mockingbird Street', '49', 'Canada', 'G4N1N9', 'Wulan Hada', 'staff'),
('834 Thompson Park', '09', 'United States', '50359', 'Nikísiani', 'property'),
('83402 Reinke Trail', '25', 'United States', '91018', 'Wu’erbu Baolige', 'staff'),
('839 Stuart Lane', '52003', 'Canada', 'F8C1T5', 'Hongkeli', 'property'),
('84 Northwestern Lane', '325', 'United States', '72863', 'Palestina', 'property'),
('840 Manley Avenue', '3', 'United States', '35508', 'Lok', 'billing'),
('8411 Westerfield Terrace', '4', 'United States', '57046', 'Nashville', 'property'),
('8442 8th Park', '4963', 'United States', '34106', 'Xinglongjie', 'billing'),
('8449 Rutledge Plaza', '7108', 'Canada', 'L7Z0Q8', 'Bang Kaeo', 'staff'),
('848 Northwestern Point', '08', 'Canada', 'F7N9L2', 'Kromasan', 'property'),
('8497 Rieder Circle', '9825', 'United States', '11462', 'Huangqiang', 'property'),
('85 Montana Terrace', '6291', 'United States', '34964', 'Beauharnois', 'property'),
('8541 Anhalt Crossing', '51', 'United States', '32542', 'Smiřice', 'property'),
('8565 Mayer Terrace', '7', 'United States', '54352', 'Ylöjärvi', 'property'),
('8569 Sachtjen Hill', '292', 'Canada', 'X0W5C2', 'Fengshan', 'billing'),
('8570 Dorton Place', '3', 'United States', '67122', 'Lyalichi', 'staff'),
('85933 Johnson Lane', '662', 'United States', '81958', 'Otacílio Costa', 'property'),
('86 Bunting Junction', '54', 'Canada', 'D1L8A6', 'Jõhvi', 'staff'),
('86 Summer Ridge Trail', '19', 'Canada', 'F3R1I1', 'Cabreúva', 'property'),
('8601 Jay Circle', '2', 'Canada', 'J9O2C9', 'Turośń Kościelna', 'billing'),
('8616 Jenna Point', '73786', 'United States', '57046', 'Curahpacul Satu', 'billing'),
('862 Fisk Lane', '06', 'Canada', 'R4G5K0', 'Jurak Lao’', 'billing'),
('864 Spohn Crossing', '75', 'United States', '78826', 'Cambuga', 'property'),
('87 Forest Run Alley', '862', 'Canada', 'G7Q7K7', 'Ōno-hara', 'billing'),
('87 Hagan Street', '580', 'Canada', 'D2Z9I5', 'Bordeaux', 'billing'),
('87 Kinsman Lane', '564', 'United States', '68103', 'Pesisir', 'property'),
('871 Pankratz Plaza', '633', 'Canada', 'A6Y6K4', 'Yousheng', 'staff'),
('8727 Bay Lane', '5', 'United States', '20336', 'Fanrong', 'property'),
('874 Hollow Ridge Court', '559', 'United States', '78984', 'Yuxin', 'billing'),
('876 Cambridge Court', '75318', 'Canada', 'D1L8A6', 'Bełchatów', 'billing'),
('8852 Washington Hill', '06', 'Canada', 'I3W3K6', 'Buchlovice', 'property'),
('8873 Farragut Road', '8', 'Canada', 'T9J4Y0', 'Little Baguio', 'billing'),
('889 Dunning Avenue', '002', 'United States', '88802', 'Lacolle', 'staff'),
('89 Melrose Hill', '517', 'Canada', 'M3E7E4', 'Zhetian', 'billing'),
('8912 Gulseth Point', '75', 'United States', '11792', 'Puerto Obaldía', 'property'),
('8916 Rigney Lane', '59212', 'Canada', 'K0X0G7', 'Jambesari', 'staff'),
('89170 Nova Terrace', '6', 'Canada', 'B5Q7U1', 'Xishaqiao', 'staff'),
('8919 Barnett Crossing', '25', 'Canada', 'M9Z3I5', 'Unión de Reyes', 'billing'),
('893 Anniversary Plaza', '03091', 'United States', '62244', 'San Agustín', 'staff'),
('8987 Texas Terrace', '2', 'United States', '32422', 'Buinsk', 'property'),
('89959 Cordelia Pass', '775', 'Canada', 'U8T3M1', 'Dengfang', 'billing'),
('89996 Macpherson Hill', '5525', 'Canada', 'F8C1T5', 'Corpus', 'property'),
('9 3rd Pass', '3', 'United States', '10986', 'Junxi', 'staff'),
('9 Barby Street', '6178', 'Canada', 'N6M4O9', 'Houston', 'billing'),
('9 Buhler Court', '3', 'United States', '49159', 'Kabalen', 'staff'),
('9 Cody Drive', '745', 'United States', '10450', 'Omsk', 'staff'),
('9 Dakota Trail', '4972', 'Canada', 'M7H8I9', 'Gammad', 'staff'),
('9 Di Loreto Hill', '007', 'United States', '55456', 'Ljungskile', 'staff'),
('9 Fairfield Hill', '9', 'United States', '93385', 'Minnedosa', 'property'),
('9 Gulseth Drive', '075', 'United States', '28705', 'Oktyabr’skiy', 'billing'),
('9 John Wall Terrace', '340', 'Canada', 'E1Z4Z1', 'Huanglian', 'property'),
('9 Lakewood Gardens Terrace', '7710', 'Canada', 'T8O1E6', 'Krahës', 'property'),
('9 Lien Pass', '5', 'United States', '65218', 'Kotabaru', 'property'),
('9 Loeprich Parkway', '57879', 'Canada', 'C5B6W7', 'Kamo', 'staff'),
('9 Mendota Crossing', '4433', 'United States', '59737', 'Umeå', 'property'),
('9 Morningstar Park', '3', 'Canada', 'X9G4S1', 'Paraćin', 'staff'),
('9 Pawling Center', '41', 'United States', '33040', 'Las Ánimas', 'property'),
('9 Schlimgen Drive', '83703', 'Canada', 'A1N6I6', 'Sławatycze', 'property'),
('9 Schurz Terrace', '8200', 'Canada', 'F9Q9S0', 'Cimahi', 'billing'),
('9 Spohn Road', '3415', 'Canada', 'B4U9M0', 'Nanping', 'property'),
('9 Sutteridge Junction', '3', 'Canada', 'T8O1E6', 'Volodymyrets’', 'property'),
('9 Sycamore Park', '40', 'Canada', 'Y0H4F3', 'Salmi', 'staff'),
('9 Waywood Point', '5', 'United States', '62244', 'Zoetermeer', 'property'),
('90 Anderson Avenue', '28', 'United States', '23104', 'Gafargaon', 'billing'),
('90 Lakewood Gardens Point', '687', 'United States', '62244', 'Sarnia', 'billing'),
('90 Portage Trail', '1862', 'United States', '64288', 'Sarany', 'billing'),
('90 Sycamore Place', '06', 'Canada', 'H1Q8Y4', 'Udënisht', 'property'),
('90033 Knutson Park', '09378', 'Canada', 'W2U8D9', 'Igarapava', 'billing'),
('909 East Circle', '143', 'United States', '92662', 'Nenagh', 'property'),
('91 Darwin Lane', '03', 'Canada', 'B3H8O3', 'Hadakewa', 'billing'),
('91 Randy Plaza', '9939', 'United States', '10180', 'Łobodno', 'billing'),
('914 Porter Park', '785', 'Canada', 'U5H8D4', 'Shaping', 'staff'),
('91606 Twin Pines Parkway', '343', 'United States', '39807', 'Qorveh', 'staff'),
('9176 Messerschmidt Parkway', '9', 'Canada', 'W2U8D9', 'Vidovci', 'billing'),
('91916 Cottonwood Crossing', '379', 'Canada', 'F9Q9S0', 'Hexi', 'staff'),
('91920 Lien Drive', '551', 'Canada', 'R7F5Z0', 'Pimenta Bueno', 'staff'),
('92 Bartelt Hill', '4823', 'United States', '81500', 'Złota', 'billing'),
('92 Birchwood Trail', '0', 'United States', '81500', 'Wysoka', 'staff'),
('9211 Roxbury Circle', '774', 'Canada', 'Q3P1R6', 'Baoquan', 'property'),
('923 Cardinal Parkway', '24903', 'Canada', 'R1L8S7', 'Lintan Chengguanzhen', 'staff'),
('92357 Union Circle', '7', 'United States', '78249', 'Molugan', 'staff'),
('92442 Dryden Point', '07', 'Canada', 'P5A1Q6', 'Baimajing', 'property'),
('925 Sheridan Avenue', '443', 'United States', '44890', 'Lincoln', 'property'),
('92596 Basil Avenue', '630', 'Canada', 'F9E0S9', 'Anjirmuara', 'billing'),
('926 Del Mar Place', '8', 'Canada', 'J5Z0F4', 'Champagnole', 'billing'),
('93 Comanche Junction', '627', 'Canada', 'Y6G8G7', 'Kavalerovo', 'billing'),
('93 Crest Line Junction', '68473', 'Canada', 'F0O8M2', 'Miyata', 'property'),
('93 Myrtle Park', '6', 'United States', '41991', 'Baclayon', 'property'),
('9302 Fisk Street', '58253', 'Canada', 'N6M4O9', 'Guayabal', 'staff'),
('93105 Crescent Oaks Way', '68', 'United States', '54292', 'Orenburg', 'staff'),
('9335 Division Way', '5951', 'Canada', 'T9F7W2', 'Lindi', 'staff'),
('93494 8th Way', '9', 'Canada', 'Y3C3O9', 'Mlawe', 'staff'),
('9415 Kennedy Trail', '5', 'Canada', 'M3L1W6', 'San Francisco', 'billing'),
('94172 Bunting Pass', '0', 'United States', '62244', 'Zhendong', 'staff'),
('947 Iowa Trail', '13', 'Canada', 'R6T2C5', 'Acatenango', 'billing'),
('950 Northridge Way', '209', 'Canada', 'F7C7A2', 'Boguchwała', 'billing'),
('95096 Park Meadow Pass', '47071', 'United States', '57185', 'Puerto López', 'billing'),
('9513 Esch Avenue', '768', 'United States', '15449', 'Skien', 'staff'),
('9529 Upham Hill', '0', 'Canada', 'I8Z4I8', 'Muaralabuh', 'property'),
('954 Mayfield Place', '48', 'United States', '68103', 'Vale', 'property'),
('9543 Vernon Place', '886', 'United States', '12543', 'Polanka Wielka', 'staff'),
('96 Di Loreto Way', '0032', 'Canada', 'Q3P1R6', 'Jadowniki Mokre', 'property'),
('96 Kennedy Pass', '96', 'Canada', 'K1Z8A2', 'Caper', 'staff'),
('963 Fieldstone Parkway', '7', 'Canada', 'D7O2C8', 'Otradnoye', 'property'),
('964 Jenifer Place', '553', 'Canada', 'L7Z0Q8', 'Cikarang', 'property'),
('96428 Morrow Plaza', '8', 'United States', '30542', 'Xianxi', 'staff'),
('96449 Ilene Circle', '93351', 'United States', '57799', 'Vale de Figueira', 'property'),
('97 Butterfield Parkway', '89208', 'United States', '51618', 'Dillenburg', 'property'),
('97 Mcguire Park', '3450', 'United States', '30076', 'Lagnieu', 'staff'),
('97 Messerschmidt Hill', '20192', 'United States', '62244', 'Shtip', 'billing'),
('97 Pennsylvania Road', '598', 'Canada', 'U5H8D4', 'Krapivna', 'staff'),
('97118 Eliot Trail', '84301', 'United States', '12796', 'Cerinza', 'billing'),
('97130 David Way', '82113', 'United States', '46560', 'Sawahan', 'billing'),
('97566 Laurel Road', '58107', 'United States', '58782', 'Huanggangshan', 'property'),
('9761 Dawn Point', '2', 'Canada', 'U2O7F2', 'Nantai', 'staff'),
('9763 Weeping Birch Center', '7', 'United States', '11423', 'Lille', 'property'),
('9766 Mallory Place', '8', 'United States', '27632', 'Krajan Karangsari', 'property'),
('9772 Heath Street', '15', 'Canada', 'U5S4C4', 'Khok Charoen', 'staff'),
('9778 Springview Way', '8', 'Canada', 'W6D3B8', 'Sedkyrkeshch', 'property'),
('9783 Victoria Way', '7', 'Canada', 'Q3P1R6', 'Buga', 'property'),
('9790 Lakewood Avenue', '91417', 'United States', '85192', 'Yegorlykskaya', 'property'),
('98 Hayes Pass', '6511', 'Canada', 'N8X0F1', 'Perpignan', 'staff'),
('98 Hazelcrest Court', '066', 'United States', '41991', 'Rozhdestveno', 'staff'),
('98 Tomscot Hill', '90', 'United States', '86362', 'Město', 'property'),
('980 Packers Trail', '54', 'Canada', 'K3N7R1', 'Dębno', 'billing'),
('983 Morningstar Trail', '440', 'United States', '23290', 'Maiwang', 'staff'),
('983 Petterle Circle', '34', 'United States', '71718', 'Borne Sulinowo', 'billing'),
('9830 Oneill Road', '532', 'United States', '58782', 'Stanley', 'staff'),
('985 Dahle Terrace', '2354', 'Canada', 'R6T2C5', 'Sobral da Adiça', 'property'),
('99 Eastlawn Drive', '0', 'United States', '33040', 'Banyo', 'staff'),
('99 Helena Court', '3739', 'United States', '49159', 'Oslo', 'billing'),
('99 Namekagon Plaza', '5', 'United States', '58535', 'Včelná', 'property'),
('9907 School Crossing', '55', 'Canada', 'U5H8D4', 'Thị Trấn Vạn Hà', 'staff'),
('995 Bay Center', '12', 'United States', '89182', 'Xushan', 'property'),
('99556 Bluestem Court', '082', 'United States', '32542', 'Santo Domingo', 'billing'),
('998 Rockefeller Terrace', '18559', 'Canada', 'P3X6R3', 'Cihua', 'property'),
('999 Prairie Rose Lane', '593', 'Canada', 'U5L2M5', 'Sundsvall', 'property');

-- --------------------------------------------------------

--
-- Table structure for table `amenity`
--

CREATE TABLE `amenity` (
  `amenity_name` varchar(30) NOT NULL,
  `_description` varchar(300) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `amenity`
--

INSERT INTO `amenity` (`amenity_name`, `_description`) VALUES
('Bar', 'Comfortable drinking place'),
('Fitness Center', 'Workout Room'),
('Free Parking', '256 parking spots for guests'),
('Pool', 'swimming pool'),
('Restaurant', 'Best Restaurant in Town'),
('Sauna', 'a small room used as a hot-air or steam bath for cleaning and refreshing the body');

-- --------------------------------------------------------

--
-- Table structure for table `guest`
--

CREATE TABLE `guest` (
  `phone_number` varchar(15) NOT NULL,
  `first_name` varchar(25) NOT NULL,
  `last_name` varchar(25) NOT NULL,
  `dob` date NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `guest`
--

INSERT INTO `guest` (`phone_number`, `first_name`, `last_name`, `dob`) VALUES
('09120118872', 'adones', 'evangelista', '1890-02-04'),
('104-355-1831', 'Blane', 'Ruskin', '2001-01-31'),
('105-293-9265', 'Mathias', 'Honniebal', '1973-05-23'),
('106-134-3626', 'Isaak', 'Gueste', '1952-08-12'),
('106-354-3992', 'Cirilo', 'Malletratt', '1980-08-23'),
('114-396-9035', 'Duffy', 'Sinkin', '1953-05-20'),
('119-310-6112', 'Travus', 'Mongeot', '1984-06-19'),
('124-257-6790', 'Devinne', 'Sherman', '1965-05-29'),
('125-124-8065', 'Cletus', 'Bernardi', '1952-02-10'),
('126-828-5536', 'Job', 'Merwe', '1963-08-12'),
('135-288-1084', 'Brian', 'Masterson', '1976-07-10'),
('136-305-3349', 'Doralyn', 'Pellatt', '1966-08-09'),
('137-648-2748', 'Lindsey', 'Eingerfield', '1975-09-18'),
('141-497-6972', 'Brock', 'Spraggon', '1950-01-26'),
('146-823-8915', 'Marty', 'Loudiane', '1996-07-22'),
('147-724-7450', 'Darrin', 'Reucastle', '1973-04-01'),
('149-715-5155', 'Weber', 'Hasel', '1988-06-01'),
('156-606-8438', 'Oneida', 'Kneebone', '1992-06-24'),
('158-714-9304', 'Worth', 'Dike', '1994-10-26'),
('159-534-0692', 'Edith', 'Stieger', '1976-03-17'),
('162-171-2156', 'Fonzie', 'Chaperlin', '1992-02-05'),
('164-315-3388', 'Theodoric', 'Kelwaybamber', '1963-07-08'),
('167-778-4369', 'Philipa', 'Strutton', '1997-03-31'),
('170-107-3162', 'Magdalen', 'Heimann', '1953-08-21'),
('171-346-5672', 'Lula', 'Weatherdon', '1987-11-09'),
('173-581-1021', 'Vitia', 'Gilchriest', '1960-01-29'),
('177-206-8679', 'Remus', 'Fasey', '1996-02-11'),
('180-259-1152', 'Dunc', 'Leindecker', '1960-04-13'),
('181-796-4393', 'Heath', 'Stiffkins', '1978-07-30'),
('193-414-9755', 'Xylia', 'Betteriss', '1978-06-09'),
('198-838-9196', 'Augie', 'Tockell', '1989-01-28'),
('203-432-7643', 'Antonella', 'Snead', '1984-02-27'),
('204-240-2631', 'Mariam', 'Pitrasso', '1978-03-03'),
('206-938-4269', 'Sydelle', 'Stoneham', '1975-02-19'),
('210-140-6597', 'Barnard', 'Kann', '1961-03-28'),
('210-746-5264', 'Vic', 'Burkill', '1983-04-24'),
('212-150-1249', 'Catharina', 'Nana', '1981-01-26'),
('212-152-8420', 'Eberto', 'Whaley', '1972-08-27'),
('212-828-9658', 'Carolyn', 'Lukianovich', '1977-05-02'),
('212-922-3829', 'Webb', 'O\' Cloney', '1978-05-23'),
('221-735-0785', 'Ali', 'Theze', '1982-07-18'),
('231-956-8802', 'Pierce', 'Le feuvre', '1972-10-18'),
('233-660-3138', 'Fern', 'Vedishchev', '1993-12-21'),
('235-256-5214', 'Hermann', 'Peterffy', '1976-12-09'),
('238-436-9898', 'Kelcie', 'Surmeyer', '1965-01-30'),
('238-925-7629', 'Rex', 'Drew-Clifton', '1982-03-12'),
('238-945-5225', 'Flor', 'Eglin', '1999-08-26'),
('240-602-6555', 'Ferdy', 'Ravelus', '1962-02-26'),
('244-350-9873', 'Blake', 'Heater', '1979-10-30'),
('247-624-0875', 'Chico', 'Casa', '1953-04-25'),
('248-701-4385', 'Ryun', 'McQuorkel', '1993-05-13'),
('253-616-7882', 'Madeleine', 'Elt', '1990-06-07'),
('257-470-8471', 'Andreas', 'Mansuer', '1979-12-08'),
('261-395-2447', 'Dorelle', 'Copnar', '1975-12-31'),
('263-652-4365', 'Frans', 'Arnhold', '1969-07-16'),
('263-874-1256', 'Cassius', 'Pendlenton', '1986-04-03'),
('266-976-7264', 'Will', 'Lampel', '1998-05-12'),
('270-408-2266', 'Anders', 'Rubega', '1999-05-29'),
('270-617-9175', 'Patten', 'Pitblado', '1970-07-11'),
('270-871-6294', 'Christiane', 'Bosher', '2001-05-01'),
('272-906-4475', 'Linn', 'Reyes', '1958-04-18'),
('273-331-3791', 'Sauncho', 'Wadlow', '1964-04-14'),
('273-691-6331', 'Juditha', 'Tattersall', '1957-12-17'),
('274-104-1485', 'Tilda', 'Kubes', '1959-10-08'),
('275-591-7754', 'Maximo', 'Witherington', '1985-03-30'),
('286-512-0116', 'Giorgi', 'Waterdrinker', '1957-01-08'),
('286-663-0352', 'Reese', 'Case', '1992-04-16'),
('290-809-9944', 'Wash', 'Pitfield', '1961-10-07'),
('290-895-1669', 'Kassey', 'Beamson', '1988-09-19'),
('298-398-4181', 'Lauree', 'Figg', '1970-10-27'),
('300-639-5266', 'Sidnee', 'Golden of Ireland', '1962-07-18'),
('303-456-8052', 'Franzen', 'O\'Shevlin', '1969-09-10'),
('313-543-7943', 'Kermie', 'Sture', '1974-05-30'),
('314-303-3338', 'Elnar', 'Gwin', '1955-12-10'),
('317-805-8829', 'Gratia', 'Cowpland', '1983-02-01'),
('318-351-8389', 'Ker', 'Shiers', '1991-08-17'),
('318-625-9354', 'Lucian', 'Umbers', '1959-06-07'),
('331-165-4937', 'Tricia', 'Cressar', '1958-03-28'),
('335-331-0027', 'Ugo', 'Thoday', '1966-07-27'),
('339-248-2193', 'Oona', 'Poulsum', '1981-05-05'),
('343-556-6333', 'Goldi', 'MacNeil', '1959-04-21'),
('348-529-6301', 'Cal', 'Strotone', '1996-10-10'),
('349-384-3194', 'Melicent', 'Flecknoe', '1981-12-11'),
('352-747-4463', 'Raynor', 'Loughren', '1951-10-14'),
('360-952-3500', 'Leigh', 'Filby', '1975-02-02'),
('363-988-7275', 'Dalenna', 'Fruchter', '1956-06-08'),
('364-691-0907', 'Garvin', 'Apple', '1999-10-13'),
('368-861-7893', 'Poul', 'O\'Skehan', '1990-01-02'),
('369-813-0619', 'Ralph', 'Warlaw', '1971-08-26'),
('371-267-9699', 'Ezri', 'MacKellen', '1993-01-05'),
('371-989-3408', 'Kelci', 'Rief', '1961-03-23'),
('374-741-5872', 'Germayne', 'Warsop', '1956-10-08'),
('376-541-9815', 'Katherine', 'Pacher', '1958-08-30'),
('382-205-2823', 'Arty', 'McGrowther', '1970-11-12'),
('383-883-7735', 'Marti', 'Strooband', '1964-04-11'),
('386-603-2298', 'Erma', 'Mattin', '1997-04-30'),
('387-641-7377', 'Sibylla', 'Mitchiner', '1984-12-22'),
('388-501-2825', 'Lief', 'Jones', '1972-04-24'),
('394-589-4346', 'Mar', 'Stoodale', '1966-07-26'),
('395-999-1479', 'Gunner', 'Tipping', '1959-05-08'),
('398-382-8044', 'Vinny', 'Furness', '1998-09-16'),
('398-847-6382', 'Gabrielle', 'Giovannelli', '1971-09-14'),
('399-211-3178', 'Faber', 'Dodshun', '1961-01-23'),
('400-683-0463', 'Tildi', 'Nares', '1957-07-03'),
('401-122-5203', 'Ezequiel', 'Jess', '1976-03-12'),
('403-257-6615', 'Corrine', 'Etridge', '1980-12-22'),
('406-207-8177', 'Fawnia', 'Vance', '1976-03-27'),
('407-313-9158', 'Constanta', 'Adan', '1958-01-26'),
('412-183-2505', 'Sydney', 'Truder', '1950-09-27'),
('412-410-8474', 'King', 'Zanetello', '1965-11-12'),
('414-805-8317', 'Erasmus', 'Torrijos', '1952-08-26'),
('416-224-0177', 'Ricki', 'Dorre', '1969-02-14'),
('417-782-3039', 'Ingemar', 'Laffan', '1985-05-14'),
('418-157-7274', 'Giselle', 'Woonton', '1982-03-18'),
('418-674-7782', 'Philippa', 'Kauble', '1980-05-21'),
('430-620-9893', 'Danya', 'Karppi', '1993-07-05'),
('436-183-2987', 'Elita', 'Winscum', '1957-04-23'),
('436-638-0253', 'Jaime', 'Wilkison', '1988-05-09'),
('447-283-5821', 'Susanne', 'Yacob', '1952-07-25'),
('453-976-9565', 'Judith', 'MacCafferky', '1985-07-17'),
('463-840-0627', 'Darius', 'Horrell', '1962-07-12'),
('466-204-9984', 'Julius', 'Reside', '1990-06-07'),
('467-988-2142', 'Josh', 'Nilges', '1991-08-21'),
('472-110-1893', 'Freedman', 'Allabush', '1975-08-13'),
('472-888-4576', 'Zechariah', 'Dobinson', '1955-03-10'),
('473-155-0626', 'Elijah', 'Umfrey', '1962-03-02'),
('478-673-7730', 'Becka', 'Manilow', '1966-12-16'),
('480-310-7802', 'Missie', 'Climie', '1962-07-28'),
('488-416-6271', 'Luella', 'Biddle', '1999-05-29'),
('491-684-4756', 'Chiarra', 'Cleminshaw', '1973-12-14'),
('497-328-3662', 'Aeriell', 'Gaddes', '1975-07-23'),
('501-442-5364', 'Marjory', 'Eisak', '1970-07-02'),
('507-534-2359', 'Rafe', 'Tumilty', '1972-02-23'),
('514-537-9878', 'Conni', 'Keningley', '1980-10-26'),
('519-379-3663', 'Madelle', 'Al Hirsi', '1971-10-12'),
('520-824-7707', 'Mildred', 'A\'Barrow', '1962-06-21'),
('521-467-3072', 'Hollie', 'Willars', '1994-11-08'),
('522-965-8387', 'Gladys', 'Munkley', '1952-11-18'),
('523-534-8583', 'Sophi', 'Moodie', '1955-02-10'),
('525-334-2384', 'Selle', 'Chamberlain', '1968-11-07'),
('530-833-6201', 'Rakel', 'Cacacie', '1995-10-06'),
('532-129-9607', 'Fred', 'Gaudin', '1987-04-08'),
('532-550-8024', 'Jemimah', 'Punt', '1960-01-11'),
('535-337-1046', 'Flossy', 'Blakiston', '1971-12-20'),
('546-259-2830', 'Kenton', 'Sego', '1955-12-18'),
('547-611-1882', 'Hadlee', 'Gurnay', '1960-06-15'),
('552-138-5508', 'Culley', 'Postlewhite', '1994-09-02'),
('553-982-5938', 'Sib', 'Beldam', '1974-03-06'),
('559-552-7429', 'Hubert', 'Norway', '1990-01-31'),
('562-205-6580', 'Mikel', 'Isham', '1960-08-16'),
('568-952-9368', 'Trina', 'McGinly', '1967-09-09'),
('569-378-4910', 'Derek', 'Sweeting', '1956-04-08'),
('578-105-7503', 'Nevile', 'Waker', '1973-02-10'),
('580-773-4643', 'Liana', 'Sutterby', '1981-03-05'),
('585-203-8624', 'Kendra', 'Carnegy', '1978-05-05'),
('588-967-5540', 'Harald', 'Ditts', '1994-01-30'),
('592-449-4489', 'Vivian', 'Rosnau', '1963-07-23'),
('596-665-3827', 'Karisa', 'Rilton', '1997-05-28'),
('599-682-8209', 'Dasie', 'Chittleburgh', '1968-01-12'),
('600-522-3752', 'Mason', 'Silverwood', '1981-02-19'),
('605-288-5545', 'Evangeline', 'Asgodby', '1991-03-11'),
('608-827-0543', 'Astra', 'Jahndel', '1983-04-29'),
('608-944-1047', 'Eddy', 'Blaszczyk', '1982-12-20'),
('611-811-2001', 'Durand', 'Bletcher', '1997-12-22'),
('614-892-2742', 'Inness', 'Ivanovic', '2000-07-11'),
('617-851-6536', 'Lorilyn', 'Bandiera', '1970-07-03'),
('623-898-3491', 'Cyrill', 'McEwan', '1994-08-31'),
('624-371-3997', 'Quent', 'Gillis', '1964-11-29'),
('634-306-4655', 'Fin', 'Brilleman', '1982-12-08'),
('635-125-5731', 'Elsy', 'McConnal', '1991-11-11'),
('641-487-6311', 'Amalia', 'Ehrat', '1966-10-08'),
('644-675-3504', 'Bessie', 'Lockitt', '1994-03-31'),
('644-890-3173', 'Linnea', 'Pengelley', '1975-02-17'),
('647-469-5133', 'Mariette', 'Challiner', '1988-09-06'),
('648-788-2933', 'Georgianna', 'Wharfe', '1991-07-27'),
('648-807-2649', 'Angil', 'Bigadike', '1952-04-24'),
('648-994-9665', 'Chiquita', 'Caldaro', '1999-08-27'),
('651-886-6470', 'Mair', 'Brideoke', '1977-08-25'),
('652-597-1647', 'Mill', 'Coleson', '1995-08-28'),
('663-755-1957', 'Nickie', 'Blasi', '1955-10-26'),
('664-955-6023', 'Pennie', 'Russon', '1978-01-22'),
('669-987-9714', 'Germain', 'Kettell', '1955-03-04'),
('673-484-5595', 'Lindsay', 'Guiduzzi', '1995-08-08'),
('675-181-5539', 'Crystie', 'Cardinale', '1967-01-29'),
('680-737-9181', 'Martino', 'Yarrington', '1998-12-13'),
('683-706-2709', 'Gwendolyn', 'Banat', '1989-02-20'),
('686-312-6505', 'Muffin', 'Ksandra', '1970-06-28'),
('686-437-2670', 'Merl', 'Hale', '1984-04-13'),
('689-289-7660', 'Vinny', 'Dureden', '1960-07-24'),
('689-588-2212', 'Paule', 'Barns', '1997-09-11'),
('690-817-3737', 'Constantin', 'McKennan', '2001-11-23'),
('691-710-0476', 'Ediva', 'Boyall', '1961-02-28'),
('693-396-4684', 'Marys', 'Bravery', '1982-06-21'),
('697-344-9131', 'Deanne', 'Pepperrall', '1979-01-29'),
('698-385-8702', 'Karen', 'Werner', '1985-06-20'),
('700-766-5305', 'Flossy', 'Waterson', '1975-06-14'),
('700-940-8053', 'Keeley', 'Heminsley', '1990-05-26'),
('701-522-2518', 'Darrel', 'Beecheno', '1954-07-10'),
('708-320-4654', 'Adair', 'Deely', '1959-11-03'),
('710-112-3528', 'Cobbie', 'Pamphilon', '1988-05-16'),
('716-320-5779', 'Toby', 'Blissitt', '1999-03-14'),
('719-163-3484', 'Letty', 'Hartshorne', '1960-09-21'),
('719-716-0830', 'Rik', 'Glossop', '1992-03-28'),
('720-302-4122', 'Stanleigh', 'Aynold', '1960-08-18'),
('720-325-7899', 'Sargent', 'de Mullett', '1956-11-30'),
('724-328-5416', 'Paloma', 'Swabey', '1989-04-21'),
('724-447-4856', 'Lowell', 'Kollas', '1958-01-31'),
('726-819-4643', 'Tirrell', 'Tucknott', '1961-12-29'),
('730-236-0928', 'Nicol', 'Buesnel', '1974-07-22'),
('731-616-0340', 'Isis', 'Lavielle', '1975-03-31'),
('732-330-1473', 'Ravi', 'Lenard', '1993-10-03'),
('734-717-5421', 'Gayel', 'Satterfitt', '1978-01-03'),
('736-483-2569', 'Ardisj', 'Foux', '1978-04-09'),
('738-759-1080', 'Jacquenette', 'Holliar', '1965-12-10'),
('743-630-5905', 'Towny', 'Islep', '1960-12-31'),
('745-671-4584', 'Rab', 'Iannazzi', '1986-07-07'),
('747-479-9285', 'Maureene', 'Wingatt', '1986-12-26'),
('751-825-5730', 'Silvie', 'Plampeyn', '1973-11-09'),
('758-193-1762', 'Antonie', 'Killcross', '1957-07-18'),
('758-489-7887', 'Eugen', 'Vreiberg', '1983-07-06'),
('761-891-7678', 'Veronike', 'Ewells', '1996-07-16'),
('762-213-7718', 'Odele', 'Helkin', '1994-08-28'),
('764-452-1972', 'Gwenore', 'Ellacombe', '1951-03-02'),
('765-102-0505', 'Fran', 'MacDougal', '1969-12-01'),
('767-594-2715', 'Almeda', 'Westell', '1978-04-28'),
('768-301-1581', 'Kirsteni', 'Pirazzi', '1950-10-03'),
('768-923-3318', 'Mace', 'Thies', '1981-09-21'),
('770-533-5281', 'Lisabeth', 'Bonnefin', '1992-09-28'),
('777-463-6477', 'Yoshiko', 'Onyon', '1962-03-03'),
('777-961-0975', 'Jefferey', 'Yewdell', '1962-06-12'),
('782-387-5582', 'Ruth', 'Kinsella', '1961-01-22'),
('791-776-7140', 'Opal', 'Klaaassen', '1985-06-27'),
('793-308-2729', 'Kati', 'Swayton', '1983-12-06'),
('796-683-1924', 'Page', 'Dundendale', '1969-02-18'),
('796-884-6193', 'Ashleigh', 'Repp', '1999-07-27'),
('804-276-8297', 'Zaria', 'Sproat', '1966-03-17'),
('809-242-9370', 'Leena', 'Gumey', '1964-10-16'),
('810-911-1175', 'Ellwood', 'Jadczak', '1959-02-16'),
('811-546-0367', 'Joella', 'Hains', '1979-12-21'),
('814-945-4757', 'Julienne', 'Alsop', '1959-09-12'),
('815-809-9631', 'Nev', 'Spinello', '1996-12-04'),
('818-712-7394', 'Bentley', 'Freeberne', '1955-08-06'),
('820-310-3366', 'Nannette', 'Langforth', '1982-10-10'),
('832-392-5074', 'Selie', 'Yesipov', '1988-04-28'),
('832-885-2692', 'Pepito', 'Carslaw', '1969-03-06'),
('833-919-9906', 'Rosy', 'Lippiello', '1962-03-27'),
('837-260-3724', 'Celia', 'Petrou', '1958-12-07'),
('840-758-1221', 'Colan', 'Gowry', '1972-08-17'),
('841-591-1327', 'Raffaello', 'Ponnsett', '1955-02-16'),
('843-243-4410', 'Tory', 'Haddinton', '1976-12-23'),
('845-537-9521', 'Burty', 'Speedin', '1993-11-20'),
('846-735-7278', 'Ronnie', 'Kearley', '1951-02-02'),
('855-955-7043', 'Lebbie', 'Gilbertson', '1983-02-15'),
('869-582-7856', 'Franchot', 'Dally', '1963-04-29'),
('870-903-4432', 'Lammond', 'Chaytor', '1994-08-04'),
('871-804-9494', 'Barbee', 'Curds', '1989-07-10'),
('874-168-7614', 'Josiah', 'Adamski', '1968-09-04'),
('883-117-7081', 'Sayer', 'Jouannot', '1969-05-22'),
('884-159-4655', 'Christalle', 'Fassman', '1957-02-28'),
('886-787-1658', 'Guthrey', 'Keogh', '2001-10-28'),
('887-290-0459', 'Doria', 'Hazlewood', '1987-06-30'),
('901-667-3889', 'Coretta', 'Bode', '1960-05-05'),
('903-651-2678', 'Trude', 'Matskevich', '1955-08-16'),
('903-769-0531', 'Bucky', 'Mildenhall', '1969-07-06'),
('904-711-8318', 'Jordan', 'Wands', '1976-10-06'),
('906-348-5262', 'Benni', 'McEllen', '1966-07-04'),
('908-875-4601', 'Lanae', 'Casiero', '1964-08-18'),
('910-632-1031', 'Merci', 'Priddis', '1987-08-06'),
('912-729-7064', 'Neely', 'Drewet', '1984-01-28'),
('916-144-1178', 'Modestine', 'Bussell', '1970-01-20'),
('916-462-1293', 'Hirsch', 'Garrettson', '1981-10-16'),
('919-283-1418', 'Owen', 'Dabell', '1997-04-04'),
('919-460-9263', 'Allegra', 'O\'Hartigan', '1959-04-21'),
('919-926-9996', 'Pepito', 'Hardstaff', '1965-02-28'),
('920-145-2575', 'Kurt', 'Tommis', '1983-12-27'),
('923-605-4970', 'Granger', 'Ortells', '1973-05-13'),
('924-504-0519', 'Piotr', 'Saltman', '1955-11-08'),
('927-440-7257', 'Aguie', 'Cristofolo', '1976-10-23'),
('932-441-3835', 'Holden', 'Adenet', '1952-01-19'),
('945-464-3877', 'Agustin', 'Claridge', '1988-02-26'),
('946-211-5996', 'Gavan', 'Aldie', '1995-08-29'),
('947-787-1612', 'Ellary', 'Brownbill', '1967-05-24'),
('948-560-1047', 'Belle', 'Newbigging', '1967-02-05'),
('951-538-0527', 'Red', 'Reaveley', '1975-03-27'),
('952-779-0498', 'Bartlet', 'Weyman', '1982-04-16'),
('962-324-5596', 'Tynan', 'Jamot', '1985-11-08'),
('963-736-6240', 'Eolanda', 'Abells', '1968-09-16'),
('963-902-9596', 'Jeremy', 'Fidge', '2001-03-16'),
('965-129-3056', 'Phillida', 'Bowater', '1974-10-24'),
('965-706-2737', 'Anastasie', 'MacNally', '1965-11-11'),
('970-854-3541', 'Ives', 'Normanvill', '1989-03-14'),
('973-408-1876', 'Gabbie', 'Frankcomb', '1961-03-09'),
('976-217-1455', 'Rebecka', 'Theis', '1977-08-21'),
('978-187-1917', 'Audrey', 'Ryding', '1965-10-01'),
('980-112-6791', 'Shelby', 'Vasishchev', '2000-02-29'),
('981-904-5029', 'Allen', 'Warder', '1978-04-30'),
('985-301-1140', 'Ibby', 'Battye', '1985-06-03'),
('985-468-8637', 'Carny', 'Flaune', '1987-02-15'),
('995-196-9540', 'Gael', 'Gaven', '1958-10-09'),
('996-607-5162', 'Rosemary', 'Cheves', '1959-04-28'),
('998-446-4180', 'Garth', 'Forsythe', '1986-10-14');

--
-- Triggers `guest`
--
DELIMITER $$
CREATE TRIGGER `GuestDOBTrigger` BEFORE INSERT ON `guest` FOR EACH ROW BEGIN
		IF NEW.dob > CURDATE() THEN
			SIGNAL SQLSTATE '45000' SET MESSAGE_TEXT = 'Guest DOB must be earlier than today';
		END IF;
    END
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Table structure for table `payment`
--

CREATE TABLE `payment` (
  `transaction_no` int(10) UNSIGNED NOT NULL,
  `amount` float UNSIGNED NOT NULL,
  `card_num` varchar(16) NOT NULL,
  `reservation_id` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `payment`
--

INSERT INTO `payment` (`transaction_no`, `amount`, `card_num`, `reservation_id`) VALUES
(1, 4912, '9787775556039208', 69),
(2, 295, '1860969626367654', 148),
(3, 296, '4769954416028307', 41),
(4, 5699, '8514893109849147', 172),
(5, 7582, '0423325670665530', 122),
(6, 2135, '7661649169871285', 126),
(7, 2978, '4116149685183712', 159),
(8, 9259, '2343081911420270', 4),
(9, 922, '9633702376177951', 36),
(10, 7400, '2746530148462439', 20),
(11, 9621, '2902603186943357', 195),
(12, 9822, '1757822882281248', 123),
(13, 7989, '0499162350347431', 44),
(14, 9965, '6128364984192585', 61),
(15, 5337, '4066840826680278', 50),
(16, 2866, '2253844537537778', 78),
(17, 4210, '8488582170559412', 97),
(18, 8695, '8350513419139635', 85),
(19, 6158, '5574178187077713', 12),
(20, 8742, '1814459763568116', 73),
(21, 5693, '4987303119600412', 173),
(22, 508, '2124050468912110', 156),
(23, 163, '099047530366655', 65),
(24, 4779, '098085872411349', 14),
(25, 7762, '8939753242344771', 142),
(26, 2843, '680224278717280', 31),
(27, 9723, '9551227008320662', 83),
(28, 232, '509101478668790', 18),
(29, 6957, '5783415250595943', 198),
(30, 6376, '7681699952804392', 183),
(31, 9714, '696715948922523', 51),
(32, 5193, '566080570934620', 115),
(33, 1674, '0147703541316405', 176),
(34, 6096, '5865107447571352', 23),
(35, 965, '9806157284662897', 160),
(36, 7654, '2158520891848274', 159),
(37, 4905, '0841312002398142', 87),
(38, 2887, '3496585461841802', 137),
(39, 7040, '1976798096596934', 163),
(40, 9469, '7243632644111889', 22),
(41, 7835, '7878153814693800', 36),
(42, 1430, '5783415250595943', 156),
(43, 2921, '4066840826680278', 102),
(44, 1863, '8209759001415148', 86),
(45, 6345, '879474943841409', 20),
(46, 9791, '5824846652893345', 20),
(47, 5592, '2477088444755104', 149),
(48, 8413, '0690006137003781', 122),
(49, 6409, '7629852025765676', 160),
(50, 8983, '7951257094716190', 139),
(51, 379, '4978708721169898', 2),
(52, 3635, '4034618456925739', 174),
(53, 4919, '7573258637200892', 19),
(54, 4665, '4076762360093734', 164),
(55, 6527, '6753072484879799', 46),
(56, 3779, '3147900620965461', 134),
(57, 6319, '0616708807532967', 30),
(58, 8259, '1601137213362612', 37),
(59, 8361, '0739420709438522', 64),
(60, 5984, '9877947716447567', 95),
(61, 1902, '1720452741838948', 183),
(62, 5143, '0327903608757079', 126),
(63, 1340, '5136273267815582', 61),
(64, 6929, '6252231439553299', 74),
(65, 122, '3615785858913187', 110),
(66, 221, '0975224364042140', 173),
(67, 9216, '089506918209129', 86),
(68, 1284, '2950768496533653', 42),
(69, 9852, '9422242854458266', 89),
(70, 5291, '9327934269720666', 74),
(71, 2309, '598072426275951', 37),
(72, 327, '8558374715338013', 76),
(73, 8631, '3088476008526353', 144),
(74, 5288, '8812762692616137', 151),
(75, 9140, '1912174515297956', 77),
(76, 5849, '6368679918646977', 47),
(77, 226, '703738693780589', 175),
(78, 3486, '994937063048489', 97),
(79, 86, '3994614531567339', 85),
(80, 4334, '5994843442543394', 66),
(81, 5522, '2544440916426257', 92),
(82, 7497, '2434848823182473', 185),
(83, 1344, '450008140337522', 22),
(84, 5917, '5379188230823777', 43),
(85, 1729, '1601137213362612', 49),
(86, 500, '7211865946897155', 4),
(87, 3472, '5675427725034892', 30),
(88, 994, '5443166251595305', 15),
(89, 3654, '5237085103443714', 43),
(90, 6110, '566080570934620', 55),
(91, 2763, '067670089958742', 131),
(92, 7644, '6200239605389403', 163),
(93, 9693, '6753698481753679', 88),
(94, 2073, '7243632644111889', 140),
(95, 8864, '6752292834822176', 90),
(96, 601, '880556820427237', 139),
(97, 4772, '552869394395580', 139),
(98, 4703, '0730363682809020', 159),
(99, 8537, '8250577384489871', 175),
(100, 6309, '8036027387877775', 153),
(101, 2576, '0564875404682199', 83),
(102, 7758, '3080151401996308', 139),
(103, 4854, '5731064256117636', 165),
(104, 7760, '7772867286476852', 86),
(105, 9000, '3450372683818411', 176),
(106, 1812, '4153901220685658', 7),
(107, 6056, '3282610901281698', 70),
(108, 6687, '9516311598698385', 182),
(109, 7254, '6139069927613026', 51),
(110, 6666, '615096308447958', 126),
(111, 1659, '4034618456925739', 135),
(112, 1683, '1483340307495876', 91),
(113, 3380, '519107337722462', 106),
(114, 7110, '4730479914649162', 151),
(115, 2156, '0147703541316405', 75),
(116, 2738, '9879729078108197', 132),
(117, 4874, '5783415250595943', 44),
(118, 5272, '897458090531830', 178),
(119, 7838, '7762063718827367', 42),
(120, 8150, '5675427725034892', 64),
(121, 5666, '6252231439553299', 112),
(122, 7176, '7243632644111889', 151),
(123, 4447, '6938917838342616', 58),
(124, 416, '2813267599121330', 65),
(125, 8638, '5081685446399275', 52),
(126, 6966, '8029543569524669', 6),
(127, 8171, '2848585071180023', 171),
(128, 1829, '655653402874814', 104),
(129, 2452, '8139880273836998', 184),
(130, 514, '4913237860948669', 44),
(131, 5421, '4298707277272120', 21),
(132, 7017, '159734683286641', 146),
(133, 8027, '4910125125914685', 39),
(134, 9772, '1757822882281248', 133),
(135, 8401, '5664801058301613', 140),
(136, 171, '824178080963593', 45),
(137, 7415, '7275119288365531', 63),
(138, 9049, '4978708721169898', 184),
(139, 3386, '623317851783282', 34),
(140, 7563, '3040094689426677', 83),
(141, 2297, '9831367470279013', 171),
(142, 1503, '2381781410073416', 27),
(143, 8822, '9602255117738081', 151),
(144, 5146, '288631733596485', 76),
(145, 2523, '352916401686733', 96),
(146, 6881, '4179431762117703', 139),
(147, 9769, '070774226150513', 18),
(148, 844, '2407129511987884', 1),
(149, 7549, '6758216455947248', 23),
(150, 9158, '6462658870155812', 52),
(151, 7527, '1210341351652566', 82),
(152, 8742, '6753072484879799', 20),
(153, 2116, '089506918209129', 94),
(154, 7569, '0954109397668798', 103),
(155, 7717, '2888866517313380', 36),
(156, 1346, '5180535113889937', 42),
(157, 3532, '4445996314134442', 70),
(158, 433, '1986838435235606', 103),
(159, 8006, '9652251418270248', 149),
(160, 336, '1341877781030083', 125),
(161, 51, '0309520502231030', 176),
(162, 2327, '3725748073422795', 2),
(163, 2616, '8131198738261976', 87),
(164, 2505, '4261186505436541', 130),
(165, 2034, '624613126786039', 83),
(166, 4863, '4243165796085983', 63),
(167, 5684, '6711572781185353', 95),
(168, 6313, '337987641854657', 124),
(169, 9246, '543833725856815', 123),
(170, 7805, '8375991673301325', 54),
(171, 8968, '664660316932322', 62),
(172, 4072, '7095386293363929', 89),
(173, 4735, '2813267599121330', 159),
(174, 8234, '4245187994229001', 121),
(175, 9401, '724335374765782', 119),
(176, 8772, '6206296378388369', 36),
(177, 5768, '8488582170559412', 145),
(178, 5072, '9633702376177951', 59),
(179, 6834, '4337375689620450', 183),
(180, 8991, '5782468480661885', 141),
(181, 2325, '9456384173214266', 161),
(182, 2109, '0231450592739507', 117),
(183, 3432, '2158520891848274', 189),
(184, 3939, '8250577384489871', 23),
(185, 5385, '7133930631688108', 165),
(186, 1562, '159970665082955', 171),
(187, 4766, '2158520891848274', 74),
(188, 6198, '2734380879169770', 119),
(189, 8373, '4718742936710751', 58),
(190, 5935, '732732985601688', 40),
(191, 3140, '5740303267115422', 129),
(192, 2597, '838615795741365', 197),
(193, 7348, '2401836471847024', 156),
(194, 948, '0170100966284467', 97),
(195, 4983, '7638475556829176', 5),
(196, 5043, '350196572419066', 80),
(197, 6163, '3484877031719904', 57),
(198, 6638, '7424930932419485', 67),
(199, 1415, '5172732474791880', 121),
(200, 176, '082099540818966', 76),
(201, 9549, '968573590469841', 158),
(202, 6785, '3865124788640310', 42),
(203, 8817, '924473183147013', 198),
(204, 7650, '4978708721169898', 161),
(205, 609, '9848777051336169', 131),
(206, 3933, '9361371973631116', 24),
(207, 6938, '5655980918745198', 41),
(208, 6339, '1177644600782659', 92),
(209, 238, '8252115089168966', 153),
(210, 1800, '0890288376989850', 67),
(211, 2843, '5637074545701082', 20),
(212, 5410, '5994843442543394', 74),
(213, 9751, '3921195431838540', 19),
(214, 2465, '2543227429091925', 142),
(215, 8389, '9030288669860068', 88),
(216, 5373, '5812081976320971', 115),
(217, 7656, '2808651484524053', 136),
(218, 3933, '5755958980819015', 42),
(219, 7342, '3981836420348561', 167),
(220, 4990, '1856221754218791', 139),
(221, 7765, '278207416646598', 41),
(222, 4680, '5106884450533544', 3),
(223, 7105, '2056585233378204', 23),
(224, 1950, '7805221878978064', 178),
(225, 8394, '810175198875025', 103),
(226, 6698, '678903774993740', 63),
(227, 6221, '563039418126165', 89),
(228, 870, '6647447947917763', 21),
(229, 5712, '2829867215698870', 145),
(230, 8020, '5158067513718122', 100),
(231, 9541, '1201618014349230', 95),
(232, 9513, '3257915893153423', 170),
(233, 3, '8940665151836336', 41),
(234, 4615, '0973370400415440', 47),
(235, 7549, '4913237860948669', 193),
(236, 7448, '879474943841409', 64),
(237, 6781, '4050462532152661', 71),
(238, 5161, '3554157074301660', 27),
(239, 8918, '352916401686733', 47),
(240, 2493, '5255114564485649', 95),
(241, 9377, '518637243446872', 193),
(242, 3717, '6515269735534782', 129),
(243, 4079, '8181193477874835', 153),
(244, 1883, '7591411137448339', 174),
(245, 4848, '0423325670665530', 72),
(246, 1278, '5225656155945966', 60),
(247, 3130, '1341877781030083', 116),
(248, 4630, '4597994632530728', 46),
(249, 5505, '3774718089748337', 97),
(250, 3771, '264280074187234', 29),
(251, 3470, '7929320895836913', 97),
(252, 5842, '1782375586781224', 200),
(253, 6919, '6064578419673664', 186),
(254, 138, '509101478668790', 200),
(255, 2057, '8521492629218406', 153),
(256, 4804, '9787775556039208', 86),
(257, 6281, '4596060593367644', 80),
(258, 9362, '7243632644111889', 132),
(259, 4258, '0573182414322722', 171),
(260, 8211, '0752241346576622', 53),
(261, 4495, '7785732628028768', 35),
(262, 3147, '0654740831889794', 187),
(263, 3549, '350196572419066', 50),
(264, 3972, '3484877031719904', 163),
(265, 3445, '0088247703938277', 104),
(266, 447, '5611106972265967', 39),
(267, 532, '9311352365310895', 153),
(268, 1563, '6752292834822176', 20),
(269, 3474, '8301654936958581', 167),
(270, 2150, '9319100645608291', 101),
(271, 9408, '5215639641563349', 107),
(272, 8187, '1444365402712689', 170),
(273, 415, '2099185790434934', 39),
(274, 6155, '724335374765782', 90),
(275, 9033, '4396249939313681', 197),
(276, 2617, '6998561778119776', 130),
(277, 1180, '7785732628028768', 158),
(278, 7403, '857677557350328', 104),
(279, 8623, '5158067513718122', 39),
(280, 8441, '1260538990365436', 93),
(281, 1883, '838615795741365', 184),
(282, 4374, '2462211909737191', 34),
(283, 3352, '548456130425784', 111),
(284, 8340, '2654307471945902', 11),
(285, 8713, '252501618871374', 133),
(286, 3998, '9327934269720666', 57),
(287, 190, '1027212557437485', 100),
(288, 3461, '7786139604171525', 93),
(289, 2513, '419134539088070', 16),
(290, 7278, '1919305926564718', 48),
(291, 4702, '6080893312264332', 159),
(292, 2020, '1170647819741760', 164),
(293, 6119, '2829867215698870', 44),
(294, 1900, '4244105145997426', 168),
(295, 136, '3504929963472764', 53),
(296, 2803, '2404076768451529', 137),
(297, 6348, '3725748073422795', 165),
(298, 6259, '760199024710609', 181),
(299, 1698, '3257915893153423', 51),
(300, 65, '0841312002398142', 12);

-- --------------------------------------------------------

--
-- Table structure for table `paymentinformation`
--

CREATE TABLE `paymentinformation` (
  `card_num` varchar(16) NOT NULL,
  `card_type` enum('AMEX','VISA','MC','DISCOVER') NOT NULL,
  `cvv` varchar(4) NOT NULL,
  `expiry_month` int(10) UNSIGNED NOT NULL,
  `expiry_year` int(10) UNSIGNED NOT NULL,
  `street_address` varchar(100) NOT NULL,
  `unit_number` varchar(8) NOT NULL,
  `country` varchar(50) NOT NULL,
  `postal_code` varchar(7) NOT NULL,
  `user_email` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `paymentinformation`
--

INSERT INTO `paymentinformation` (`card_num`, `card_type`, `cvv`, `expiry_month`, `expiry_year`, `street_address`, `unit_number`, `country`, `postal_code`, `user_email`) VALUES
('000888402862305', 'AMEX', '2401', 7, 2024, '802 Warrior Park', '35', 'United States', '71718', 'garchanbaultc2@yelp.com'),
('0015346103308021', 'MC', '680', 2, 2021, '98 Hayes Pass', '6511', 'Canada', 'N8X0F1', 'mlusty82@sphinn.com'),
('001823717437736', 'AMEX', '3658', 12, 2020, '440 Hoard Park', '0829', 'United States', '49633', 'stodorpy@dell.com'),
('0018381989185382', 'MC', '744', 9, 2019, '45402 Springview Road', '9769', 'United States', '37035', 'hkullmannqf@jigsy.com'),
('002571591611760', 'AMEX', '1772', 10, 2022, '38 Warrior Court', '98711', 'United States', '63095', 'frydzynskigm@archive.org'),
('0027436138651233', 'MC', '076', 11, 2020, '7 Corry Circle', '8980', 'Canada', 'R7D0T5', 'gglewau@vimeo.com'),
('0030259295264486', 'VISA', '678', 2, 2021, '51 Coolidge Pass', '6126', 'Canada', 'I5O9W5', 'mholbieek@discuz.net'),
('0063498962502619', 'VISA', '538', 11, 2022, '16093 Johnson Terrace', '38228', 'Canada', 'E5H3Y3', 'twakerhl@vk.com'),
('0088247703938277', 'VISA', '289', 5, 2023, '40 Esker Avenue', '7', 'United States', '25554', 'vmcroriejn@istockphoto.com'),
('009299938983180', 'AMEX', '1643', 12, 2019, '69 Ryan Street', '46377', 'United States', '27489', 'hhalkyardmc@wufoo.com'),
('0102306978774362', 'MC', '451', 12, 2020, '6 Mayer Avenue', '3', 'Canada', 'D9N7Z9', 'aoheffernan59@mapy.cz'),
('010369358376969', 'AMEX', '7629', 3, 2022, '7050 Donald Hill', '89', 'Canada', 'N2I7M0', 'vrhoddie5y@spiegel.de'),
('0103704464872417', 'DISCOVER', '804', 10, 2020, '4 Graedel Crossing', '15', 'Canada', 'J8R2U6', 'igarnulq3@goo.gl'),
('0118361482272150', 'DISCOVER', '577', 9, 2019, '04 Kipling Trail', '376', 'United States', '64877', 'kmcgarrellfc@msu.edu'),
('012208423076606', 'AMEX', '0656', 1, 2023, '76003 Monterey Terrace', '0596', 'Canada', 'K1Z8A2', 'adewickeb9@t-online.de'),
('0136996038708154', 'DISCOVER', '405', 2, 2023, '91916 Cottonwood Crossing', '379', 'Canada', 'F9Q9S0', 'ssouthwood71@weebly.com'),
('014310489972545', 'AMEX', '2636', 6, 2020, '9 Loeprich Parkway', '57879', 'Canada', 'C5B6W7', 'ibenazetjr@army.mil'),
('0147703541316405', 'MC', '694', 10, 2024, '365 Hooker Pass', '974', 'United States', '10450', 'mkassmana7@cbslocal.com'),
('015163983221697', 'AMEX', '3791', 11, 2024, '18403 Londonderry Point', '6769', 'United States', '54728', 'rscourfieldd6@cnbc.com'),
('015572281122880', 'AMEX', '7359', 10, 2018, '44 Dahle Road', '65', 'Canada', 'J5Z0F4', 'skiddello9@paypal.com'),
('0170100966284467', 'VISA', '925', 3, 2019, '87 Hagan Street', '580', 'Canada', 'D2Z9I5', 'etunnah6f@loc.gov'),
('017291616419263', 'AMEX', '1044', 1, 2021, '7 Steensland Street', '824', 'United States', '14665', 'bchapellowiu@etsy.com'),
('0180458104948717', 'VISA', '319', 7, 2020, '26 Spohn Plaza', '451', 'Canada', 'N2I7M0', 'vparmerdu@nature.com'),
('0182607753962872', 'MC', '362', 7, 2023, '3511 Manufacturers Alley', '0327', 'United States', '20336', 'wbaszniakll@amazon.co.uk'),
('018695679714101', 'AMEX', '5830', 1, 2019, '38034 Dakota Hill', '9', 'United States', '44220', 'gmarcubk@technorati.com'),
('0191706606003916', 'VISA', '892', 10, 2022, '72 Bultman Terrace', '5', 'United States', '27235', 'bseear1@4shared.com'),
('0192911407692699', 'DISCOVER', '839', 8, 2024, '35 Tomscot Alley', '7', 'United States', '96246', 'nkrookaq@ed.gov'),
('0202396578936495', 'VISA', '787', 10, 2021, '75192 Ludington Avenue', '17', 'United States', '32542', 'dwestburyac@howstuffworks.com'),
('021747910492540', 'AMEX', '3278', 5, 2024, '5557 Cascade Park', '80962', 'United States', '18606', 'tcowtharddb@howstuffworks.com'),
('0231450592739507', 'DISCOVER', '316', 2, 2023, '0691 Judy Terrace', '9', 'Canada', 'R0R8S6', 'bsloweyir@shop-pro.jp'),
('023574869594882', 'AMEX', '2551', 8, 2022, '82 Grayhawk Way', '873', 'United States', '13060', 'rzima5v@yale.edu'),
('0241846106633051', 'VISA', '953', 1, 2020, '11529 Ohio Road', '12073', 'United States', '68092', 'kpredohlop@cbc.ca'),
('0276945684626889', 'DISCOVER', '268', 3, 2023, '056 Oak Point', '08953', 'United States', '93385', 'bcrabbbw@blogs.com'),
('027733005330079', 'AMEX', '8747', 10, 2020, '469 Brown Trail', '26569', 'Canada', 'Z4S8H4', 'mchant2v@nbcnews.com'),
('029207718088132', 'AMEX', '2714', 11, 2022, '1 8th Hill', '86801', 'United States', '36100', 'bhughmang8@chron.com'),
('0305784938361126', 'DISCOVER', '912', 12, 2019, '07806 Homewood Pass', '165', 'Canada', 'F7N9L2', 'wchaplyn8v@webmd.com'),
('0309520502231030', 'VISA', '715', 4, 2019, '44651 La Follette Pass', '67', 'United States', '96546', 'akobesgq@opensource.org'),
('0327903608757079', 'MC', '397', 12, 2018, '1772 Fairfield Point', '04966', 'Canada', 'I1N6L0', 'fbranganh8@unc.edu'),
('0346669386799578', 'VISA', '521', 7, 2018, '02 Blackbird Center', '2', 'United States', '31589', 'rzima5v@yale.edu'),
('0358545499720306', 'VISA', '639', 4, 2022, '8 Ridgeview Avenue', '267', 'Canada', 'X6G9Q1', 'acarayolla@jimdo.com'),
('0362745991225591', 'MC', '036', 3, 2022, '077 Thierer Parkway', '83364', 'Canada', 'H8Q2G3', 'kjenkin7f@ebay.com'),
('036431663009494', 'AMEX', '2512', 7, 2022, '0 Farmco Pass', '5', 'Canada', 'T8O1E6', 'cgrimwadeet@artisteer.com'),
('0369338127356262', 'DISCOVER', '542', 3, 2020, '308 Kensington Avenue', '283', 'Canada', 'X3A6Y3', 'jlehrps@arstechnica.com'),
('0379836985759596', 'MC', '391', 8, 2018, '9763 Weeping Birch Center', '7', 'United States', '11423', 'lgadesby8u@e-recht24.de'),
('0395772072250042', 'DISCOVER', '416', 9, 2024, '28267 Namekagon Way', '438', 'United States', '10986', 'lpostgateq2@home.pl'),
('0396380837178167', 'VISA', '596', 9, 2022, '7 Prentice Drive', '9277', 'United States', '92662', 'kdalinderqn@hubpages.com'),
('040296495524179', 'AMEX', '5337', 1, 2022, '85 Montana Terrace', '6291', 'United States', '34964', 'cconboyjo@feedburner.com'),
('0408889959448440', 'DISCOVER', '709', 10, 2018, '018 Springs Court', '33803', 'Canada', 'A1N6I6', 'pclinkard32@biblegateway.com'),
('0423325670665530', 'MC', '345', 6, 2022, '2452 Holy Cross Street', '234', 'United States', '83819', 'mahmad9x@reuters.com'),
('0426299301562122', 'DISCOVER', '974', 6, 2022, '64 Stang Road', '537', 'Canada', 'F6W0G4', 'asherwindg@barnesandnoble.com'),
('043758827907019', 'AMEX', '1166', 2, 2020, '90033 Knutson Park', '09378', 'Canada', 'W2U8D9', 'modooleyon@homestead.com'),
('0473452627285681', 'DISCOVER', '723', 3, 2020, '0973 Parkside Drive', '90334', 'United States', '98428', 'aquimbyid@imgur.com'),
('0492115277736885', 'VISA', '887', 1, 2021, '40 American Center', '7475', 'United States', '29840', 'jesbya@tumblr.com'),
('0492645310446038', 'MC', '086', 4, 2021, '75 Hagan Lane', '1', 'Canada', 'P1X0U7', 'mpakemanhr@ocn.ne.jp'),
('0497005900384747', 'VISA', '735', 5, 2018, '61 Lyons Parkway', '60725', 'Canada', 'K8U3M0', 'tbroadwelle9@xinhuanet.com'),
('0499162350347431', 'DISCOVER', '685', 12, 2021, '461 Northport Plaza', '5', 'Canada', 'O5N6I0', 'nsammut1q@cdbaby.com'),
('050642376226732', 'AMEX', '8168', 7, 2021, '3292 Shoshone Drive', '98655', 'United States', '49159', 'bgraebereh@accuweather.com'),
('0511598067260743', 'VISA', '105', 2, 2018, '14092 Cody Lane', '15902', 'Canada', 'O1H1W9', 'kfronks7s@drupal.org'),
('0564875404682199', 'MC', '372', 7, 2019, '572 Moland Alley', '8268', 'United States', '77725', 'liredaleav@admin.ch'),
('0573182414322722', 'MC', '365', 9, 2022, '4 International Place', '03', 'United States', '27489', 'gemblincl@ning.com'),
('058187871595160', 'AMEX', '6037', 11, 2021, '4 Graedel Crossing', '15', 'Canada', 'J8R2U6', 'smcarda3@instagram.com'),
('0591904571803568', 'MC', '966', 9, 2022, '69380 Annamark Terrace', '995', 'Canada', 'J6L9S2', 'jodney1z@nature.com'),
('0616708807532967', 'MC', '710', 10, 2021, '6655 Glacier Hill Trail', '2', 'United States', '71709', 'jpien2@shareasale.com'),
('0637797966817405', 'VISA', '814', 2, 2020, '4 Del Sol Parkway', '8042', 'Canada', 'W6D3B8', 'aohoeybz@amazon.de'),
('0654740831889794', 'VISA', '789', 5, 2024, '83 Vernon Drive', '2101', 'Canada', 'M1N6T4', 'cshortonf5@home.pl'),
('0666089203841801', 'MC', '156', 3, 2022, '36807 Stoughton Circle', '5404', 'Canada', 'N3C1U3', 'dkemster6s@moonfruit.com'),
('0667985709784810', 'DISCOVER', '248', 2, 2022, '505 Banding Court', '91419', 'United States', '11792', 'pluckcuckc6@independent.co.uk'),
('067593871467540', 'AMEX', '8754', 10, 2022, '185 Daystar Plaza', '87824', 'Canada', 'R8W0K1', 'amiellrm@newsvine.com'),
('067670089958742', 'AMEX', '4956', 7, 2021, '758 Marcy Lane', '35', 'United States', '18606', 'fsappsonoe@godaddy.com'),
('0678377631575922', 'DISCOVER', '570', 5, 2023, '0907 Calypso Circle', '9', 'United States', '84104', 'cedwardsot@salon.com'),
('0690006137003781', 'VISA', '000', 6, 2019, '615 Corben Junction', '66', 'Canada', 'J3D2J3', 'rmcilory75@nbcnews.com'),
('070774226150513', 'AMEX', '7501', 6, 2022, '33575 Charing Cross Circle', '2', 'United States', '71709', 'rpollett45@cbc.ca'),
('0720280740139207', 'DISCOVER', '041', 5, 2018, '6 Wayridge Court', '4', 'United States', '33040', 'etunnah6f@loc.gov'),
('0724130590500607', 'DISCOVER', '823', 8, 2024, '24 Riverside Terrace', '5', 'United States', '25554', 'hpetruszka5a@sina.com.cn'),
('0730363682809020', 'MC', '934', 2, 2024, '1230 Fremont Hill', '13', 'Canada', 'B4U9M0', 'rmoraaj@ibm.com'),
('0739420709438522', 'VISA', '022', 8, 2021, '71 Clyde Gallagher Drive', '2', 'United States', '71718', 'mtaverinerh9@hexun.com'),
('0752241346576622', 'VISA', '605', 11, 2021, '358 Atwood Junction', '9986', 'United States', '14374', 'lsharland92@prweb.com'),
('0756001562254226', 'MC', '873', 12, 2023, '8442 8th Park', '4963', 'United States', '34106', 'jleahhj@cocolog-nifty.com'),
('0762726975829008', 'VISA', '117', 12, 2022, '6 Clemons Hill', '4257', 'Canada', 'M7E8E8', 'croxbeebp@wikia.com'),
('0785419495697327', 'MC', '651', 3, 2018, '0727 Stone Corner Center', '32', 'Canada', 'U2O7F2', 'acruess6w@addtoany.com'),
('0793633009906280', 'DISCOVER', '193', 12, 2024, '060 Aberg Park', '51', 'Canada', 'G7Q7K7', 'gmccrowo1@blogger.com'),
('0801063613228799', 'MC', '396', 6, 2021, '51 Bluestem Point', '9', 'Canada', 'M8N0M7', 'scomrie4s@ow.ly'),
('0810083168404142', 'VISA', '537', 10, 2018, '5 Spohn Avenue', '48', 'United States', '59737', 'voxxfj@1und1.de'),
('0816380595627164', 'VISA', '663', 6, 2018, '14 Eggendart Court', '7', 'United States', '95234', 'arawsen55@upenn.edu'),
('082099540818966', 'AMEX', '8507', 4, 2020, '0718 Kropf Center', '8', 'United States', '63095', 'ksayle51@huffingtonpost.com'),
('0841312002398142', 'VISA', '630', 10, 2024, '4 Michigan Hill', '983', 'Canada', 'Q8G7F8', 'cdelaharpepf@4shared.com'),
('0847888102760884', 'VISA', '615', 2, 2018, '75 Hagan Lane', '1', 'Canada', 'P1X0U7', 'gblackford5f@unesco.org'),
('085720048687890', 'AMEX', '1051', 10, 2022, '0632 Farmco Park', '0380', 'Canada', 'C4S7B0', 'mhodgets5x@theatlantic.com'),
('0862549954511739', 'VISA', '935', 12, 2018, '1 Lighthouse Bay Avenue', '4700', 'Canada', 'U5S4C4', 'mbordissqd@cbsnews.com'),
('0864828781098412', 'DISCOVER', '929', 11, 2021, '38 Orin Street', '48', 'Canada', 'C4M3Y3', 'abudgetde@joomla.org'),
('0866824757629348', 'VISA', '171', 12, 2023, '41996 Dapin Way', '4019', 'Canada', 'E8K3Q7', 'etunnah6f@loc.gov'),
('0890288376989850', 'VISA', '237', 4, 2023, '1 Graedel Plaza', '261', 'Canada', 'R3X3J2', 'lbattabeew@photobucket.com'),
('089506918209129', 'AMEX', '3627', 11, 2024, '200 Bunting Place', '11923', 'Canada', 'O9Q3J0', 'dmarguerite86@paginegialle.it'),
('090850129178791', 'AMEX', '2703', 11, 2019, '947 Iowa Trail', '13', 'Canada', 'R6T2C5', 'kgoodluckpn@ted.com'),
('0922594488885749', 'VISA', '700', 8, 2021, '818 Vahlen Park', '47170', 'United States', '30542', 'bklemenzq7@foxnews.com'),
('092524205436115', 'AMEX', '4075', 2, 2023, '65 Rutledge Plaza', '65', 'United States', '83819', 'ngrayleyae@latimes.com'),
('0940823496438419', 'VISA', '923', 5, 2023, '54758 Pierstorff Road', '50', 'Canada', 'C9X4Q9', 'hstoakescm@zdnet.com'),
('0942331735367587', 'DISCOVER', '358', 4, 2021, '83 Lien Terrace', '84', 'Canada', 'F3H2R6', 'ddarcey6d@weebly.com'),
('0943700979609319', 'DISCOVER', '607', 5, 2018, '54 Pawling Trail', '13', 'Canada', 'R1L8S7', 'mdefriesq5@cocolog-nifty.com'),
('0954109397668798', 'DISCOVER', '327', 11, 2024, '48331 Lukken Crossing', '7473', 'Canada', 'Q9B3H1', 'lgogarty3u@mail.ru'),
('0973370400415440', 'VISA', '901', 7, 2018, '1 Iowa Plaza', '0', 'Canada', 'M3L1W6', 'obridalh7@instagram.com'),
('0975224364042140', 'VISA', '844', 6, 2022, '4 International Place', '03', 'United States', '27489', 'mwinfreyof@bluehost.com'),
('098085872411349', 'AMEX', '4575', 6, 2021, '66 Heath Point', '48', 'Canada', 'P1X0U7', 'ahazeuplq@weebly.com'),
('099047530366655', 'AMEX', '5607', 2, 2024, '9415 Kennedy Trail', '5', 'Canada', 'M3L1W6', 'abudgetde@joomla.org'),
('1015924767602369', 'VISA', '347', 10, 2019, '7 Homewood Way', '8312', 'United States', '17580', 'jbattellejf@arstechnica.com'),
('1027212557437485', 'MC', '856', 9, 2024, '559 Packers Park', '998', 'United States', '19011', 'mjennokw@digg.com'),
('1036247502673817', 'MC', '206', 1, 2020, '1 Summit Drive', '163', 'United States', '87605', 'nfantone2x@comsenz.com'),
('1057417844944086', 'MC', '347', 1, 2018, '250 Anzinger Avenue', '96861', 'Canada', 'W6D3B8', 'cbushell9j@nature.com'),
('1067875270844862', 'MC', '356', 1, 2019, '14092 Cody Lane', '15902', 'Canada', 'O1H1W9', 'tmcgrayle8a@hhs.gov'),
('1088770456967861', 'MC', '896', 2, 2023, '17124 Sutherland Court', '32631', 'Canada', 'M9A0Z8', 'aoxfordd3@bigcartel.com'),
('109953398208327', 'AMEX', '2936', 3, 2018, '10 Kenwood Point', '0', 'United States', '68092', 'benstonqy@hibu.com'),
('1101577918927655', 'MC', '320', 7, 2022, '7 Fordem Plaza', '694', 'United States', '90220', 'cmirfieldqg@yellowpages.com'),
('1116519220899604', 'VISA', '925', 1, 2021, '9 Schurz Terrace', '8200', 'Canada', 'F9Q9S0', 'aklimmek13@umich.edu'),
('112894747983298', 'AMEX', '5277', 1, 2022, '1 Summit Drive', '163', 'United States', '87605', 'mtanser3h@mysql.com'),
('1134888107779619', 'DISCOVER', '545', 3, 2023, '9 Waywood Point', '5', 'United States', '62244', 'vmcroriejn@istockphoto.com'),
('1155965601463393', 'DISCOVER', '012', 1, 2019, '60 Ronald Regan Pass', '71618', 'Canada', 'D6F3D9', 'adadgee1@dagondesign.com'),
('1170640706594690', 'DISCOVER', '581', 4, 2018, '779 Truax Lane', '80', 'United States', '87605', 'derik66@samsung.com'),
('1170647819741760', 'VISA', '484', 9, 2021, '5976 Anhalt Trail', '83', 'Canada', 'E2M6A9', 'rgrimme1s@amazonaws.com'),
('1177644600782659', 'DISCOVER', '751', 3, 2019, '628 Morrow Terrace', '5851', 'United States', '22525', 'jhouldcroftbl@senate.gov'),
('1188413593152016', 'DISCOVER', '167', 10, 2024, '4 Waxwing Trail', '00', 'United States', '51618', 'mjanous5u@linkedin.com'),
('1201618014349230', 'DISCOVER', '771', 3, 2022, '8045 Susan Way', '8', 'Canada', 'G7Q7K7', 'jdursleyqh@ameblo.jp'),
('1210341351652566', 'MC', '259', 1, 2021, '84 Northwestern Lane', '325', 'United States', '72863', 'tabramovicz8w@squarespace.com'),
('121083090031776', 'AMEX', '1064', 2, 2020, '3 Forest Dale Court', '3', 'United States', '64288', 'tnewlandsk8@jalbum.net'),
('121264114549711', 'AMEX', '2380', 7, 2023, '82 Grayhawk Way', '873', 'United States', '13060', 'ddorricottlv@gravatar.com'),
('121454567468058', 'AMEX', '8745', 9, 2021, '38 Knutson Circle', '7378', 'Canada', 'Y0B2B0', 'kmaccarranedz@spotify.com'),
('1233526466984690', 'MC', '340', 10, 2023, '308 Kensington Avenue', '283', 'Canada', 'X3A6Y3', 'cgrimwadeet@artisteer.com'),
('1260538990365436', 'DISCOVER', '349', 1, 2020, '4 Graedel Crossing', '15', 'Canada', 'J8R2U6', 'dchapelle7p@miibeian.gov.cn'),
('1262482676566799', 'VISA', '070', 7, 2021, '60 Ronald Regan Pass', '71618', 'Canada', 'D6F3D9', 'frigler7w@slate.com'),
('1281718364878515', 'MC', '692', 4, 2021, '9 Lakewood Gardens Terrace', '7710', 'Canada', 'T8O1E6', 'lsowersbyb1@netscape.com'),
('129958996956792', 'AMEX', '7141', 3, 2018, '91920 Lien Drive', '551', 'Canada', 'R7F5Z0', 'bvirginrg@cam.ac.uk'),
('131453028581878', 'AMEX', '0862', 9, 2022, '4 Warbler Drive', '88944', 'United States', '26557', 'lvaleg3@ifeng.com'),
('1325170872205127', 'DISCOVER', '544', 3, 2023, '0 Gulseth Crossing', '1', 'United States', '68743', 'fforshaw5e@hp.com'),
('1326847869880263', 'MC', '591', 7, 2024, '04 Dapin Center', '62388', 'Canada', 'F6W0G4', 'olukasen8d@ocn.ne.jp'),
('1340155445415183', 'MC', '374', 6, 2020, '572 Moland Alley', '8268', 'United States', '77725', 'tbourdisaz@mediafire.com'),
('1341877781030083', 'DISCOVER', '776', 6, 2020, '7742 Dennis Street', '44', 'United States', '29840', 'tmcgrayle8a@hhs.gov'),
('1350794020463652', 'MC', '993', 3, 2022, '8 Ridgeview Avenue', '267', 'Canada', 'X6G9Q1', 'bsloweyir@shop-pro.jp'),
('1352626429422608', 'VISA', '297', 11, 2019, '92596 Basil Avenue', '630', 'Canada', 'F9E0S9', 'hyegorkovi1@mapy.cz'),
('1385460252638744', 'MC', '381', 7, 2023, '4 Vahlen Lane', '50', 'Canada', 'P3X6R3', 'bosgar8m@stumbleupon.com'),
('139009065338115', 'AMEX', '2649', 7, 2018, '5235 Messerschmidt Street', '4', 'Canada', 'X6G9Q1', 'grashleighhv@jugem.jp'),
('1435731727658077', 'VISA', '607', 7, 2020, '0 Reindahl Park', '0883', 'United States', '11622', 'cbushell9j@nature.com'),
('1441039113307660', 'MC', '973', 11, 2019, '72 Elmside Court', '1', 'United States', '31589', 'voxxfj@1und1.de'),
('1444365402712689', 'VISA', '974', 8, 2023, '5128 Declaration Hill', '70', 'United States', '30542', 'fhalypl@microsoft.com'),
('1451786883416845', 'VISA', '828', 5, 2022, '97 Mcguire Park', '3450', 'United States', '30076', 'mslowgroveol@microsoft.com'),
('1456539813832045', 'MC', '546', 1, 2019, '42962 Killdeer Place', '41132', 'United States', '17973', 'kshotboultei4@msn.com'),
('1459601819631002', 'DISCOVER', '003', 12, 2024, '5 Erie Place', '435', 'Canada', 'A9E4H2', 'ccolnett27@a8.net'),
('1475264578468107', 'MC', '352', 1, 2019, '8541 Anhalt Crossing', '51', 'United States', '32542', 'dmechemo@spiegel.de'),
('147939604937042', 'AMEX', '9875', 1, 2020, '0839 Bluejay Court', '43830', 'Canada', 'E5H3Y3', 'dmclauchlinkg@patch.com'),
('1483340307495876', 'MC', '822', 10, 2019, '32 Hazelcrest Street', '373', 'Canada', 'Y6G8G7', 'swhotton8o@rediff.com'),
('1486205398292401', 'MC', '483', 4, 2023, '76213 Waubesa Park', '8369', 'Canada', 'C9X4Q9', 'fmcsparranj6@hugedomains.com'),
('1491259978123317', 'DISCOVER', '014', 6, 2020, '08 Sutherland Circle', '65496', 'United States', '63095', 'istairmandog@hugedomains.com'),
('1493795715989929', 'DISCOVER', '957', 6, 2024, '964 Jenifer Place', '553', 'Canada', 'L7Z0Q8', 'jkettsnu@aol.com'),
('1505818504361122', 'MC', '882', 9, 2019, '17 Katie Center', '2459', 'Canada', 'F6W0G4', 'dsharperiw@list-manage.com'),
('1529884174276230', 'DISCOVER', '584', 10, 2022, '04 Kingsford Hill', '7886', 'Canada', 'O2A5G4', 'ahalwell84@joomla.org'),
('1539500403736902', 'VISA', '187', 11, 2018, '99556 Bluestem Court', '082', 'United States', '32542', 'mkobpand@dedecms.com'),
('154245364510208', 'AMEX', '6151', 10, 2018, '46257 Red Cloud Pass', '5', 'United States', '80530', 'xgilliard1h@dailymotion.com'),
('1544592823997752', 'DISCOVER', '570', 5, 2023, '345 Lotheville Pass', '94', 'Canada', 'X6G9Q1', 'sgossartpq@gov.uk'),
('1548951642831183', 'DISCOVER', '286', 2, 2021, '9176 Messerschmidt Parkway', '9', 'Canada', 'W2U8D9', 'nslottf9@delicious.com'),
('1562557636009210', 'MC', '748', 11, 2019, '43 Corscot Hill', '2', 'Canada', 'M9A0Z8', 'dtomneye8@smh.com.au'),
('1566105998786654', 'DISCOVER', '070', 1, 2020, '22 Drewry Circle', '9', 'Canada', 'N8X0F1', 'vcozensr6@goodreads.com'),
('1580121048115371', 'VISA', '099', 9, 2019, '464 Duke Trail', '28', 'Canada', 'I1J8C0', 'kboydaoo@altervista.org'),
('159734683286641', 'AMEX', '6001', 6, 2022, '1450 Melby Circle', '58283', 'Canada', 'Q7C9S6', 'zaistropej@ox.ac.uk'),
('159970665082955', 'AMEX', '2238', 6, 2021, '76213 Waubesa Park', '8369', 'Canada', 'C9X4Q9', 'ubooirk@twitter.com'),
('1601137213362612', 'MC', '271', 1, 2020, '335 Basil Plaza', '70', 'United States', '27632', 'jcopcuttgp@sciencedaily.com'),
('1605423693747806', 'MC', '944', 7, 2018, '3 Miller Pass', '545', 'Canada', 'L7Z0Q8', 'lsayburnox@ustream.tv'),
('1606107647535054', 'MC', '250', 8, 2022, '144 Loeprich Park', '87582', 'United States', '43123', 'ritzkovwichhq@pcworld.com'),
('1607085684520278', 'DISCOVER', '862', 12, 2022, '438 Lukken Point', '108', 'United States', '33324', 'spenningsj5@wufoo.com'),
('1610862879436083', 'VISA', '988', 10, 2022, '67608 Alpine Lane', '127', 'Canada', 'R8W0K1', 'amajurye5@163.com'),
('1611538644139193', 'VISA', '539', 10, 2023, '04511 Gerald Center', '13004', 'Canada', 'C5M5E1', 'bgatteridgea2@topsy.com'),
('1633325955784862', 'VISA', '961', 3, 2023, '0294 Marquette Parkway', '93884', 'United States', '95234', 'tmoverley2c@geocities.com'),
('1639582179967194', 'MC', '223', 8, 2023, '8164 Westridge Hill', '15', 'United States', '23104', 'ltappington7e@cdbaby.com'),
('164420094565915', 'AMEX', '8911', 2, 2024, '50547 Veith Avenue', '33619', 'Canada', 'X3A6Y3', 'amcguinleyda@constantcontact.com'),
('1656158229890647', 'DISCOVER', '689', 11, 2023, '11057 Fairfield Parkway', '167', 'Canada', 'J7Y6O1', 'mbarczynski3m@meetup.com'),
('166011657415158', 'AMEX', '9407', 10, 2023, '143 Gina Circle', '7497', 'United States', '86702', 'aklimmek13@umich.edu'),
('1660488248337183', 'MC', '777', 1, 2023, '83 Delladonna Circle', '1', 'United States', '33115', 'aohartnett7x@biblegateway.com'),
('1664129238482487', 'DISCOVER', '206', 9, 2024, '9 Loeprich Parkway', '57879', 'Canada', 'C5B6W7', 'iswiffan9q@soundcloud.com'),
('1664971830700335', 'MC', '571', 9, 2021, '3303 Hudson Court', '4325', 'United States', '74680', 'beadie2y@businesswire.com'),
('1668568830988973', 'DISCOVER', '999', 11, 2023, '24885 Golf View Place', '767', 'United States', '82176', 'gtowsonai@ca.gov'),
('1668778289762621', 'MC', '054', 8, 2022, '2 Schmedeman Way', '9', 'United States', '66847', 'kbonallickex@pbs.org'),
('1695120426593662', 'VISA', '225', 9, 2019, '51 Coolidge Pass', '6126', 'Canada', 'I5O9W5', 'acreykekp@t.co'),
('1710155818581012', 'DISCOVER', '401', 9, 2024, '33 Kropf Street', '0297', 'Canada', 'D6A2H3', 'mheffordoa@pen.io'),
('1710158961310778', 'MC', '377', 9, 2023, '099 Arrowood Place', '4', 'United States', '90820', 'mhousecrafto2@g.co'),
('171805608456574', 'AMEX', '4003', 3, 2020, '1 Lighthouse Bay Avenue', '4700', 'Canada', 'U5S4C4', 'soldreynn@redcross.org'),
('1720452741838948', 'DISCOVER', '025', 6, 2020, '38 Knutson Circle', '7378', 'Canada', 'Y0B2B0', 'dgurg3l@who.int'),
('1736164481918685', 'DISCOVER', '593', 6, 2021, '862 Fisk Lane', '06', 'Canada', 'R4G5K0', 'ewollrauche7@loc.gov'),
('173920234381181', 'AMEX', '2521', 5, 2023, '4 North Terrace', '290', 'United States', '20458', 'scearleyax@artisteer.com'),
('1746201856571293', 'MC', '731', 1, 2020, '4152 Weeping Birch Trail', '2', 'Canada', 'T9F7W2', 'pheggmz@storify.com'),
('1757822882281248', 'MC', '869', 3, 2018, '41996 Dapin Way', '4019', 'Canada', 'E8K3Q7', 'pgorring42@artisteer.com'),
('1768384107208469', 'VISA', '951', 11, 2023, '4 Holy Cross Point', '24173', 'Canada', 'E5H3Y3', 'palmeyfm@nbcnews.com'),
('1782375586781224', 'MC', '213', 4, 2018, '12 Everett Center', '68', 'Canada', 'F7C7A2', 'abodill7o@epa.gov'),
('1798777740877670', 'VISA', '012', 7, 2022, '1 Summit Drive', '163', 'United States', '87605', 'hpieter9@woothemes.com'),
('1814459763568116', 'VISA', '180', 10, 2024, '5682 Merrick Avenue', '67923', 'United States', '47397', 'tbilovusg7@cbc.ca'),
('1827963706401196', 'DISCOVER', '220', 11, 2019, '54758 Pierstorff Road', '50', 'Canada', 'C9X4Q9', 'apach7m@hud.gov'),
('1846186027598383', 'VISA', '100', 5, 2023, '995 Bay Center', '12', 'United States', '89182', 'ggoalleycu@dmoz.org'),
('1856221754218791', 'MC', '732', 4, 2020, '68 Del Sol Court', '19', 'United States', '19362', 'mcesariciq@github.io'),
('1860969626367654', 'DISCOVER', '757', 11, 2022, '61 Lyons Parkway', '60725', 'Canada', 'K8U3M0', 'pgorring42@artisteer.com'),
('1905263924770914', 'VISA', '357', 1, 2022, '0 Badeau Terrace', '697', 'Canada', 'Y2U0D5', 'mhaddickqq@macromedia.com'),
('1912174515297956', 'MC', '544', 5, 2023, '242 Tennyson Road', '175', 'Canada', 'K1Z6L8', 'awyvilljg@amazon.de'),
('191424895930345', 'AMEX', '4182', 5, 2022, '0 Artisan Junction', '19700', 'Canada', 'Q4G8U3', 'roday65@google.cn'),
('1919305926564718', 'DISCOVER', '218', 9, 2019, '89 Melrose Hill', '517', 'Canada', 'M3E7E4', 'casplen6l@goodreads.com'),
('1927979377867569', 'DISCOVER', '355', 12, 2019, '33575 Charing Cross Circle', '2', 'United States', '71709', 'dwoolway2z@nymag.com'),
('1957582527182471', 'MC', '451', 9, 2018, '303 Judy Court', '7', 'United States', '23104', 'lattrideca@seesaa.net'),
('1958410843533733', 'VISA', '610', 11, 2022, '09128 Southridge Way', '4', 'United States', '64288', 'kmirams54@amazon.com'),
('196440805258593', 'AMEX', '6471', 8, 2019, '3 Blue Bill Park Street', '5', 'Canada', 'U1I2O9', 'bhalson5r@indiatimes.com'),
('1964458154084246', 'MC', '596', 5, 2019, '8202 Hansons Way', '64413', 'United States', '36209', 'msprullsfd@webmd.com'),
('1973546461429679', 'DISCOVER', '852', 3, 2020, '4612 Dixon Lane', '175', 'Canada', 'I5O9W5', 'koreaganbr@cisco.com'),
('1976798096596934', 'MC', '511', 9, 2021, '00 Sugar Parkway', '82', 'Canada', 'T9F7W2', 'lattwool87@tiny.cc'),
('1986838435235606', 'DISCOVER', '707', 8, 2020, '2687 Kings Circle', '5880', 'Canada', 'S1F1S1', 'fpeepall14@gizmodo.com'),
('1990436370431511', 'MC', '647', 8, 2019, '4 5th Junction', '189', 'Canada', 'B2P5X5', 'rallans68@zimbio.com'),
('2002400272494028', 'MC', '904', 8, 2022, '6 Mitchell Junction', '64', 'Canada', 'R7D0T5', 'syakolev72@bizjournals.com'),
('2011821214356965', 'DISCOVER', '248', 12, 2023, '6727 Kinsman Center', '5', 'United States', '13060', 'btromansfk@google.co.jp'),
('201642502088266', 'AMEX', '1829', 6, 2021, '031 Browning Pass', '0620', 'United States', '28705', 'tpollicote41@bizjournals.com'),
('2016646610459218', 'DISCOVER', '678', 8, 2019, '99 Namekagon Plaza', '5', 'United States', '58535', 'vmitchelrl@storify.com'),
('2028092731982222', 'DISCOVER', '623', 3, 2023, '0716 Glacier Hill Court', '68', 'United States', '22156', 'bruffellfr@yandex.ru'),
('2031844472669985', 'DISCOVER', '824', 4, 2022, '1955 Westend Hill', '81', 'Canada', 'F0O8M2', 'tdeekesab@surveymonkey.com'),
('203838080942805', 'AMEX', '7243', 1, 2019, '862 Fisk Lane', '06', 'Canada', 'R4G5K0', 'mbrendei@mysql.com'),
('2042386931646454', 'MC', '077', 11, 2020, '51 Lien Plaza', '69', 'United States', '94442', 'cherley7t@live.com'),
('2056585233378204', 'MC', '992', 8, 2020, '8916 Rigney Lane', '59212', 'Canada', 'K0X0G7', 'hpetruszka5a@sina.com.cn'),
('2069379886751355', 'MC', '688', 4, 2020, '5 Tennyson Place', '7', 'United States', '97923', 'sdowsey40@sfgate.com'),
('2099185790434934', 'MC', '048', 4, 2018, '75 Hagan Lane', '1', 'Canada', 'P1X0U7', 'yriteleyo5@usa.gov'),
('2107929912441718', 'VISA', '325', 9, 2022, '17124 Sutherland Court', '32631', 'Canada', 'M9A0Z8', 'hhoward62@wired.com'),
('2119089219754901', 'DISCOVER', '187', 9, 2020, '782 Larry Road', '046', 'United States', '15751', 'cbeetham6@posterous.com'),
('2124050468912110', 'MC', '681', 5, 2019, '85933 Johnson Lane', '662', 'United States', '81958', 'athurbonnt@newsvine.com'),
('2146973500048413', 'DISCOVER', '568', 2, 2018, '8987 Texas Terrace', '2', 'United States', '32422', 'bdanaherag@is.gd'),
('2156875836559029', 'VISA', '445', 9, 2021, '361 Butterfield Hill', '5', 'United States', '80530', 'mgartelloq@irs.gov'),
('2158520891848274', 'MC', '872', 4, 2020, '060 Aberg Park', '51', 'Canada', 'G7Q7K7', 'lwalderai7@ovh.net'),
('2160254952201214', 'DISCOVER', '952', 8, 2021, '96428 Morrow Plaza', '8', 'United States', '30542', 'esheenhz@blog.com'),
('2177296027381761', 'MC', '423', 12, 2018, '159 Clemons Place', '18783', 'Canada', 'F9Q9S0', 'afranchioni1m@sourceforge.net'),
('218002922059043', 'AMEX', '0713', 8, 2020, '73199 Sachs Lane', '170', 'Canada', 'B2P5X5', 'bocannovane34@mozilla.org'),
('219181135666257', 'AMEX', '1145', 8, 2021, '28 Forest Crossing', '16', 'Canada', 'G8E6T8', 'idwyerf1@ucoz.com'),
('2195545491476747', 'MC', '263', 8, 2021, '47590 Kipling Way', '0364', 'Canada', 'C8Y6F0', 'skiddello9@paypal.com'),
('2208907428835352', 'VISA', '611', 1, 2019, '9778 Springview Way', '8', 'Canada', 'W6D3B8', 'hcage1u@furl.net'),
('2208998595592941', 'VISA', '837', 11, 2022, '029 Petterle Circle', '9846', 'United States', '75715', 'llecountpc@huffingtonpost.com'),
('2213123227319139', 'MC', '938', 10, 2024, '23120 Hayes Drive', '5', 'Canada', 'R1L8S7', 'ebaukhambi@japanpost.jp'),
('2239110000494745', 'VISA', '483', 7, 2020, '9 Buhler Court', '3', 'United States', '49159', 'kmousbycz@seesaa.net'),
('2240837300956592', 'VISA', '957', 3, 2019, '4 Reinke Street', '30', 'United States', '90820', 'kinglestoni2@istockphoto.com'),
('2253844537537778', 'MC', '737', 10, 2023, '80939 Lindbergh Way', '6564', 'Canada', 'P1X0U7', 'cshortonf5@home.pl'),
('2270960902845467', 'DISCOVER', '006', 2, 2022, '8570 Dorton Place', '3', 'United States', '67122', 'dmariottenq@surveymonkey.com'),
('2289287039150320', 'DISCOVER', '931', 11, 2023, '2 Katie Court', '7', 'United States', '57185', 'kclibberyod@wsj.com'),
('228974455868688', 'AMEX', '9285', 7, 2020, '1 Glacier Hill Hill', '6', 'United States', '95234', 'npryke7q@un.org'),
('2309626748925524', 'DISCOVER', '447', 3, 2022, '40 Banding Trail', '129', 'United States', '20458', 'sweatherdon18@tripadvisor.com'),
('232957141402173', 'AMEX', '6835', 10, 2024, '29134 Corben Parkway', '53313', 'United States', '64288', 'mdefriesq5@cocolog-nifty.com'),
('2329636803059827', 'MC', '055', 12, 2019, '559 Packers Park', '998', 'United States', '19011', 'rbabonf8@sogou.com'),
('2343081911420270', 'VISA', '997', 10, 2024, '995 Bay Center', '12', 'United States', '89182', 'mscathardd4@bravesites.com'),
('2344875601251599', 'VISA', '417', 7, 2021, '30 Hayes Park', '2', 'Canada', 'G7F6D2', 'bdadgeeg@marriott.com'),
('2361820836217428', 'DISCOVER', '478', 8, 2023, '005 Rieder Hill', '36307', 'Canada', 'F3H2R6', 'mstrainge5g@cocolog-nifty.com'),
('2370129888688806', 'MC', '137', 9, 2022, '1 Stoughton Hill', '8', 'Canada', 'Y6Q1T5', 'rwolfart10@nydailynews.com'),
('2372149153961495', 'MC', '549', 1, 2020, '264 Claremont Place', '837', 'Canada', 'P5G0C2', 'ugoutcherg5@hhs.gov'),
('2381781410073416', 'MC', '979', 3, 2024, '8 Melody Terrace', '7400', 'United States', '86900', 'cherley7t@live.com'),
('2396115673128766', 'MC', '196', 10, 2018, '4584 Scoville Road', '769', 'Canada', 'N2I7M0', 'edaintry7b@nih.gov'),
('2401836471847024', 'VISA', '562', 10, 2022, '8919 Barnett Crossing', '25', 'Canada', 'M9Z3I5', 'zjinkinou@sogou.com'),
('2404076768451529', 'VISA', '301', 6, 2023, '41364 Garrison Alley', '295', 'Canada', 'S1Y2Z5', 'ipinching6q@theglobeandmail.com'),
('2407129511987884', 'VISA', '954', 6, 2020, '565 Pleasure Park', '082', 'Canada', 'S1F1S1', 'hhalkyardmc@wufoo.com'),
('2434848823182473', 'DISCOVER', '699', 2, 2020, '627 Homewood Court', '2', 'United States', '44890', 'ritzkovwichhq@pcworld.com'),
('2450251539543322', 'VISA', '371', 1, 2018, '62 Blaine Drive', '3', 'United States', '36427', 'asoitoux3j@goodreads.com'),
('245766716511712', 'AMEX', '9972', 8, 2022, '6453 Burrows Center', '33154', 'United States', '81112', 'tcody3q@ebay.co.uk'),
('2462211909737191', 'DISCOVER', '997', 7, 2021, '8 Cottonwood Parkway', '32', 'Canada', 'L5K3G0', 'fskeycb@craigslist.org'),
('2467244808935426', 'DISCOVER', '536', 6, 2022, '2 Vidon Alley', '043', 'United States', '33324', 'ssell5o@smugmug.com'),
('2477088444755104', 'DISCOVER', '452', 11, 2023, '5 Golf View Junction', '72', 'United States', '34106', 'vjessop30@blog.com'),
('248110246902369', 'AMEX', '5241', 5, 2018, '1 Nobel Center', '02849', 'United States', '10986', 'garchanbaultc2@yelp.com'),
('2507144651721451', 'DISCOVER', '844', 5, 2019, '645 Luster Crossing', '7277', 'United States', '65218', 'ckamienskigk@google.ru'),
('2507603778878091', 'MC', '712', 2, 2018, '1927 Mariners Cove Crossing', '48', 'United States', '36209', 'dallamc7@eventbrite.com'),
('250944371526730', 'AMEX', '5591', 2, 2019, '40 Banding Trail', '129', 'United States', '20458', 'mepton2w@un.org'),
('252255932677387', 'AMEX', '4686', 5, 2023, '239 Rowland Lane', '06334', 'Canada', 'C8Y6F0', 'wchaplyn8v@webmd.com'),
('252501618871374', 'AMEX', '6957', 4, 2020, '08368 Redwing Center', '18', 'United States', '27632', 'athurbonnt@newsvine.com'),
('2525403224879788', 'VISA', '651', 4, 2020, '76213 Waubesa Park', '8369', 'Canada', 'C9X4Q9', 'acarvillarc@pen.io'),
('2538187875294445', 'VISA', '926', 1, 2024, '4152 Weeping Birch Trail', '2', 'Canada', 'T9F7W2', 'swalbrooklr@ihg.com'),
('2538625508158426', 'MC', '390', 8, 2018, '12 Carioca Junction', '7', 'Canada', 'R5D3E0', 'plytleht@soup.io'),
('2543227429091925', 'MC', '028', 11, 2020, '59960 Kim Plaza', '426', 'Canada', 'U5S4C4', 'dwisherjb@chicagotribune.com'),
('2544440916426257', 'DISCOVER', '935', 2, 2018, '44 Dahle Road', '65', 'Canada', 'J5Z0F4', 'bthreadkello3@trellian.com'),
('2545198519026434', 'DISCOVER', '675', 10, 2023, '10 Maple Street', '20271', 'Canada', 'Y3C3O9', 'mcryer3@fda.gov'),
('2561290994680268', 'DISCOVER', '177', 5, 2020, '96 Kennedy Pass', '96', 'Canada', 'K1Z8A2', 'cedwardsot@salon.com'),
('2563807351948864', 'MC', '766', 7, 2021, '0 Armistice Drive', '72565', 'Canada', 'J3D2J3', 'amcleoidpg@oakley.com'),
('2585130811274983', 'DISCOVER', '735', 10, 2020, '0 Artisan Junction', '19700', 'Canada', 'Q4G8U3', 'sroland9n@acquirethisname.com'),
('260231584830229', 'AMEX', '9760', 8, 2018, '6 Mayer Avenue', '3', 'Canada', 'D9N7Z9', 'agabeyc4@google.ru'),
('262767850312806', 'AMEX', '3004', 1, 2024, '295 Village Green Lane', '2', 'Canada', 'O3K8C6', 'sdavisef@harvard.edu'),
('262808922997336', 'AMEX', '3861', 1, 2022, '98 Tomscot Hill', '90', 'United States', '86362', 'mjanous5u@linkedin.com'),
('264280074187234', 'AMEX', '7611', 6, 2018, '0 Artisan Junction', '19700', 'Canada', 'Q4G8U3', 'jforestallkm@eventbrite.com'),
('2654307471945902', 'MC', '033', 2, 2023, '57 Welch Park', '2', 'United States', '13918', 'gcorcoran83@opensource.org'),
('2688043864510663', 'VISA', '125', 11, 2018, '6868 Fieldstone Plaza', '4676', 'United States', '25554', 'sgarment2j@tripod.com'),
('2712224108288949', 'DISCOVER', '188', 5, 2024, '099 Arrowood Place', '4', 'United States', '90820', 'cgrolmann6e@unicef.org'),
('2734380879169770', 'DISCOVER', '758', 2, 2022, '20 Eagle Crest Road', '7', 'Canada', 'F9Q9S0', 'lyeates46@biglobe.ne.jp'),
('2734609213514850', 'MC', '116', 5, 2023, '0 Canary Way', '16412', 'Canada', 'H6C8G6', 'acarayolla@jimdo.com'),
('2735047397961800', 'VISA', '171', 12, 2024, '50547 Veith Avenue', '33619', 'Canada', 'X3A6Y3', 'jsicilyem@weibo.com'),
('274287824762682', 'AMEX', '4663', 3, 2018, '914 Porter Park', '785', 'Canada', 'U5H8D4', 'casplen6l@goodreads.com'),
('274421679721632', 'AMEX', '4603', 12, 2021, '947 Iowa Trail', '13', 'Canada', 'R6T2C5', 'rlabror3@abc.net.au'),
('274523878777767', 'AMEX', '2891', 6, 2020, '97 Butterfield Parkway', '89208', 'United States', '51618', 'dwestburyac@howstuffworks.com'),
('2746530148462439', 'VISA', '295', 2, 2024, '04 Center Street', '146', 'Canada', 'W4J7B3', 'aobernep@google.cn'),
('2750341281535582', 'DISCOVER', '734', 3, 2020, '42962 Killdeer Place', '41132', 'United States', '17973', 'bdallman93@fc2.com'),
('2772140206078759', 'MC', '056', 7, 2019, '3 Old Gate Park', '2156', 'United States', '34964', 'kinglestoni2@istockphoto.com'),
('2774281766809134', 'MC', '165', 9, 2024, '29134 Corben Parkway', '53313', 'United States', '64288', 'amckleod4a@php.net'),
('278207416646598', 'AMEX', '8657', 12, 2020, '91916 Cottonwood Crossing', '379', 'Canada', 'F9Q9S0', 'mpernell1n@tripadvisor.com'),
('2794243898431676', 'VISA', '411', 8, 2019, '1 Sherman Parkway', '1467', 'United States', '23104', 'cherley7t@live.com'),
('2798605904971084', 'DISCOVER', '452', 5, 2021, '11 Glendale Trail', '81956', 'United States', '82176', 'mcarteran@jimdo.com'),
('2808651484524053', 'VISA', '012', 9, 2019, '998 Rockefeller Terrace', '18559', 'Canada', 'P3X6R3', 'dmccarrollm0@etsy.com'),
('2813267599121330', 'DISCOVER', '000', 8, 2019, '81 Bay Crossing', '43', 'Canada', 'X3C0M9', 'edaintry7b@nih.gov'),
('2824867414130595', 'DISCOVER', '285', 2, 2019, '950 Northridge Way', '209', 'Canada', 'F7C7A2', 'spenningsj5@wufoo.com'),
('2825077264100625', 'MC', '873', 6, 2022, '31872 Wayridge Point', '401', 'United States', '58782', 'jsterndaleju@fastcompany.com'),
('2829867215698870', 'MC', '815', 6, 2022, '78 Sommers Street', '8', 'Canada', 'O1H1W9', 'strigwell38@google.com.hk'),
('2831590935478880', 'DISCOVER', '888', 10, 2019, '4 Elgar Place', '591', 'Canada', 'R5D3E0', 'bestable7c@list-manage.com'),
('2848585071180023', 'VISA', '806', 5, 2022, '0727 Stone Corner Center', '32', 'Canada', 'U2O7F2', 'voxxfj@1und1.de'),
('286169041205032', 'AMEX', '4240', 6, 2023, '64 Stephen Avenue', '015', 'United States', '40251', 'voxxfj@1und1.de'),
('288463524580992', 'AMEX', '3427', 2, 2019, '07806 Homewood Pass', '165', 'Canada', 'F7N9L2', 'hbeatson4o@lycos.com'),
('288631733596485', 'AMEX', '3256', 10, 2020, '91920 Lien Drive', '551', 'Canada', 'R7F5Z0', 'mtanser3h@mysql.com'),
('2888866517313380', 'DISCOVER', '129', 2, 2020, '292 Tennessee Park', '1', 'United States', '49812', 'cwarburton9i@lycos.com'),
('2902603186943357', 'VISA', '169', 8, 2023, '889 Dunning Avenue', '002', 'United States', '88802', 'dephgravebu@psu.edu'),
('291166936521569', 'AMEX', '4980', 9, 2021, '8 Ridgeview Avenue', '267', 'Canada', 'X6G9Q1', 'jpidgeonpj@microsoft.com'),
('2920278708094957', 'VISA', '489', 9, 2022, '9 Buhler Court', '3', 'United States', '49159', 'agonneaue0@surveymonkey.com'),
('2928265002579236', 'VISA', '863', 1, 2020, '2 Corscot Hill', '1903', 'Canada', 'M8N0M7', 'jduddinly@chicagotribune.com'),
('2944761796667604', 'VISA', '701', 9, 2018, '07 Lerdahl Hill', '69356', 'Canada', 'M9Z3I5', 'slovedayl6@google.it'),
('2950768496533653', 'VISA', '201', 5, 2024, '8 Bultman Avenue', '9846', 'United States', '72863', 'bfarnhillb@senate.gov'),
('295084198019314', 'AMEX', '1632', 3, 2022, '8 Bultman Avenue', '9846', 'United States', '72863', 'lwalderai7@ovh.net'),
('296907107066988', 'AMEX', '2313', 2, 2018, '8 Sunbrook Terrace', '471', 'Canada', 'O1B0A3', 'slaxtonmf@gnu.org'),
('2983623427470371', 'VISA', '275', 3, 2023, '758 Marcy Lane', '35', 'United States', '18606', 'apach7m@hud.gov'),
('298458110121949', 'AMEX', '3456', 6, 2018, '8497 Rieder Circle', '9825', 'United States', '11462', 'theakerq0@sphinn.com'),
('299712100541853', 'AMEX', '7054', 9, 2019, '8045 Susan Way', '8', 'Canada', 'G7Q7K7', 'asier9o@youku.com'),
('3003681838180477', 'VISA', '982', 1, 2024, '5557 Cascade Park', '80962', 'United States', '18606', 'jcotman9r@sfgate.com'),
('3037115143278566', 'VISA', '364', 3, 2019, '6110 Corben Drive', '0', 'Canada', 'O9F1T9', 'ckamienskigk@google.ru'),
('3040094689426677', 'MC', '723', 2, 2023, '029 Petterle Circle', '9846', 'United States', '75715', 'cchesson2b@samsung.com'),
('3050563502897930', 'MC', '877', 2, 2021, '87 Kinsman Lane', '564', 'United States', '68103', 'mdecarlok3@barnesandnoble.com'),
('305981883866785', 'AMEX', '7749', 3, 2021, '22633 Utah Place', '54475', 'United States', '95821', 'csoltanfx@cnn.com'),
('3080151401996308', 'DISCOVER', '506', 3, 2020, '43710 Dennis Circle', '68', 'United States', '44220', 'ailivebs@bbc.co.uk'),
('3088476008526353', 'VISA', '594', 3, 2021, '9302 Fisk Street', '58253', 'Canada', 'N6M4O9', 'bfarnhillb@senate.gov'),
('3093546061760705', 'MC', '895', 11, 2019, '876 Cambridge Court', '75318', 'Canada', 'D1L8A6', 'gtowsonai@ca.gov'),
('3104048007402859', 'DISCOVER', '999', 6, 2020, '10 Farwell Parkway', '97736', 'Canada', 'X9G4S1', 'agabeyc4@google.ru'),
('3116049145745742', 'MC', '128', 5, 2022, '15293 Dottie Pass', '62802', 'Canada', 'R1L8S7', 'deastridgeb5@xinhuanet.com'),
('3128265440655142', 'MC', '844', 3, 2018, '556 Vernon Drive', '37', 'Canada', 'U5S4C4', 'cditchett4q@jiathis.com'),
('3147900620965461', 'MC', '213', 5, 2021, '762 Old Shore Center', '551', 'United States', '96246', 'apurchonc1@unc.edu'),
('315511348896818', 'AMEX', '0976', 7, 2019, '4237 Bowman Hill', '7', 'United States', '11423', 'eyushmanovlc@wikispaces.com'),
('3168540262832079', 'MC', '565', 6, 2023, '834 Thompson Park', '09', 'United States', '50359', 'eswornhy@sitemeter.com'),
('3179290028123894', 'VISA', '243', 2, 2018, '9 Cody Drive', '745', 'United States', '10450', 'wmccarron1a@blogs.com'),
('3181134629769720', 'VISA', '440', 1, 2023, '561 Tomscot Crossing', '3707', 'Canada', 'H0T9U0', 'lduell7r@wiley.com'),
('3198950728103609', 'DISCOVER', '567', 3, 2020, '57 Sunbrook Street', '62', 'Canada', 'Z0T8F1', 'rraglessjj@tmall.com'),
('3204174894843574', 'VISA', '081', 10, 2019, '572 Moland Alley', '8268', 'United States', '77725', 'rosharry6x@accuweather.com'),
('321079926476330', 'AMEX', '1221', 11, 2021, '9 Buhler Court', '3', 'United States', '49159', 'esheenhz@blog.com'),
('321846846243915', 'AMEX', '6456', 11, 2024, '49757 Oakridge Parkway', '27121', 'United States', '66847', 'ssouthwood71@weebly.com'),
('3224407351596207', 'VISA', '727', 3, 2022, '33454 Browning Lane', '24', 'United States', '32542', 'hfebre5i@sfgate.com'),
('3257365985953892', 'DISCOVER', '719', 8, 2023, '3 Express Park', '047', 'Canada', 'Z4X4M1', 'npohlakrf@npr.org'),
('3257915893153423', 'VISA', '893', 3, 2019, '536 Ridge Oak Plaza', '01', 'United States', '38339', 'mmcalroyhu@drupal.org'),
('3282610901281698', 'MC', '121', 7, 2023, '572 Moland Alley', '8268', 'United States', '77725', 'mdedneycj@theguardian.com'),
('3289616054253195', 'VISA', '585', 5, 2022, '429 Waubesa Road', '7192', 'United States', '36100', 'cgioriohw@webnode.com'),
('3321919800207828', 'MC', '532', 1, 2023, '41 Starling Circle', '2387', 'Canada', 'O2A5G4', 'nkitneyl0@dailymail.co.uk'),
('3343590596435886', 'VISA', '808', 9, 2024, '874 Hollow Ridge Court', '559', 'United States', '78984', 'alazare1k@163.com'),
('3368858973851597', 'MC', '658', 8, 2019, '34283 Schiller Trail', '28', 'Canada', 'Q8G7F8', 'wabelshs@cafepress.com'),
('337987641854657', 'AMEX', '2465', 9, 2019, '01071 Jana Lane', '6', 'Canada', 'E8K3Q7', 'dquogancy@wsj.com'),
('3381202984656990', 'DISCOVER', '905', 6, 2020, '4 Katie Lane', '2', 'Canada', 'H0T9U0', 'eivashintsov4v@yandex.ru'),
('3388224892752270', 'MC', '037', 9, 2019, '2148 Eagan Terrace', '80', 'Canada', 'T7P8G1', 'scearleyax@artisteer.com'),
('3417510576618453', 'VISA', '636', 2, 2019, '144 Loeprich Park', '87582', 'United States', '43123', 'singledowcc@europa.eu'),
('343109052802102', 'AMEX', '6228', 10, 2023, '0226 Petterle Hill', '11', 'Canada', 'X3Q8Z6', 'ldarreerh@prweb.com'),
('3439359734862511', 'MC', '906', 6, 2023, '8411 Westerfield Terrace', '4', 'United States', '57046', 'nworman5k@abc.net.au'),
('3450372683818411', 'DISCOVER', '250', 12, 2020, '73 Starling Lane', '002', 'United States', '33783', 'ccolnett27@a8.net'),
('347460446651607', 'AMEX', '8955', 5, 2019, '1230 Fremont Hill', '13', 'Canada', 'B4U9M0', 'lgadesby8u@e-recht24.de'),
('348166829417449', 'AMEX', '0942', 2, 2020, '572 Moland Alley', '8268', 'United States', '77725', 'aohartnett7x@biblegateway.com'),
('3484877031719904', 'VISA', '674', 11, 2020, '51 Coolidge Pass', '6126', 'Canada', 'I5O9W5', 'fmeddemmen67@oracle.com'),
('3496585461841802', 'MC', '183', 10, 2024, '7017 Park Meadow Drive', '8359', 'United States', '37035', 'nkrookaq@ed.gov'),
('350196572419066', 'AMEX', '9035', 10, 2024, '4 High Crossing Center', '20', 'Canada', 'Q8G7F8', 'glawteyj8@people.com.cn'),
('3504929963472764', 'VISA', '142', 4, 2019, '3 Eagle Crest Way', '24', 'Canada', 'Q5Y0T4', 'bnewsteadfi@creativecommons.org'),
('3509440134001843', 'MC', '110', 5, 2022, '4 7th Avenue', '9', 'United States', '33115', 'lhattrick9z@eventbrite.com'),
('352916401686733', 'AMEX', '9938', 6, 2024, '0718 Kropf Center', '8', 'United States', '63095', 'eivashintsov4v@yandex.ru'),
('3554157074301660', 'DISCOVER', '519', 1, 2018, '0 Brickson Park Street', '37507', 'Canada', 'M7E8E8', 'mbarczynski3m@meetup.com'),
('3571763657735389', 'VISA', '243', 4, 2020, '44651 La Follette Pass', '67', 'United States', '96546', 'nfantone2x@comsenz.com'),
('3585964369554887', 'VISA', '425', 8, 2022, '97 Messerschmidt Hill', '20192', 'United States', '62244', 'dchilderhousei0@dion.ne.jp'),
('360595802806460', 'AMEX', '1806', 1, 2018, '78228 Ridge Oak Circle', '61886', 'United States', '44220', 'cknatt7n@ftc.gov'),
('3615785858913187', 'MC', '462', 9, 2024, '5 Bonner Road', '91', 'Canada', 'A6I9J9', 'fhandasydeis@slashdot.org'),
('3639561689352624', 'MC', '957', 9, 2022, '056 Oak Point', '08953', 'United States', '93385', 'lgoublierjz@arstechnica.com'),
('3643599558446718', 'DISCOVER', '557', 7, 2018, '6193 Amoth Hill', '7', 'United States', '29840', 'vpatrone8s@youku.com'),
('3651937552584933', 'VISA', '667', 9, 2024, '8919 Barnett Crossing', '25', 'Canada', 'M9Z3I5', 'cstormesl9@imageshack.us'),
('3686155073422145', 'DISCOVER', '790', 8, 2022, '6 Springs Street', '78127', 'Canada', 'N8X0F1', 'zharbar8z@squidoo.com'),
('368906930010272', 'AMEX', '5408', 3, 2022, '985 Dahle Terrace', '2354', 'Canada', 'R6T2C5', 'dfelstead36@microsoft.com'),
('3693835605337847', 'VISA', '360', 6, 2024, '8852 Washington Hill', '06', 'Canada', 'I3W3K6', 'klibbis4n@cmu.edu'),
('3701711659132456', 'VISA', '999', 5, 2020, '510 Logan Court', '3718', 'United States', '78984', 'acreykekp@t.co'),
('370806533866156', 'AMEX', '7928', 7, 2019, '00025 Charing Cross Hill', '433', 'Canada', 'R6R1Y9', 'cherley7t@live.com'),
('3709943693782977', 'VISA', '739', 8, 2018, '4732 Westend Road', '694', 'Canada', 'U6K2C9', 'mzuckeree@webs.com'),
('3713577258354426', 'VISA', '787', 11, 2024, '0 Manufacturers Court', '24', 'United States', '23482', 'croxbeebp@wikia.com'),
('3716918506302809', 'VISA', '879', 12, 2022, '6202 Mariners Cove Avenue', '7', 'United States', '34925', 'kmcgarrellfc@msu.edu'),
('3725387646715015', 'MC', '204', 4, 2019, '77 Stuart Pass', '3', 'United States', '64009', 'modooleyon@homestead.com'),
('3725748073422795', 'VISA', '594', 1, 2019, '401 Stoughton Road', '3514', 'Canada', 'B2P5X5', 'ebrudenell1e@ask.com'),
('3755068220668436', 'MC', '490', 6, 2018, '97 Messerschmidt Hill', '20192', 'United States', '62244', 'jcharlejp@constantcontact.com'),
('3768501064232817', 'DISCOVER', '535', 11, 2019, '909 East Circle', '143', 'United States', '92662', 'enivenx@mail.ru'),
('3774718089748337', 'VISA', '655', 1, 2022, '3774 Fisk Point', '8192', 'United States', '77725', 'kclibberyod@wsj.com'),
('3794909170327925', 'DISCOVER', '348', 12, 2021, '60 Ronald Regan Pass', '71618', 'Canada', 'D6F3D9', 'bszachniewicz2h@guardian.co.uk'),
('3795671215150070', 'VISA', '894', 9, 2021, '717 Hansons Place', '66119', 'United States', '94576', 'asoitoux3j@goodreads.com'),
('3804675074586298', 'VISA', '794', 7, 2023, '9 Spohn Road', '3415', 'Canada', 'B4U9M0', 'uhazeldenerj@tinyurl.com'),
('3819788134990347', 'MC', '828', 11, 2024, '257 Brentwood Junction', '02', 'United States', '12616', 'spraterhb@ehow.com'),
('382019316528895', 'AMEX', '3465', 4, 2023, '8 Bartelt Park', '6', 'United States', '44091', 'kdyet8y@businessweek.com'),
('3822725628874130', 'VISA', '904', 1, 2022, '73 Farragut Street', '41063', 'United States', '98166', 'ewealleans3x@miitbeian.gov.cn'),
('3828537918141575', 'VISA', '747', 1, 2023, '18403 Londonderry Point', '6769', 'United States', '54728', 'hhoward62@wired.com'),
('382918114411235', 'AMEX', '7435', 8, 2024, '61 Manitowish Pass', '4', 'United States', '15449', 'kkadwalliderm1@gov.uk'),
('3855072912546269', 'DISCOVER', '959', 1, 2023, '75420 Doe Crossing Street', '310', 'United States', '20458', 'amacane57@si.edu'),
('3859082296954467', 'VISA', '754', 8, 2022, '51299 Esker Junction', '0', 'Canada', 'X6G9Q1', 'ewollrauche7@loc.gov'),
('3865124788640310', 'VISA', '449', 10, 2019, '7 Transport Plaza', '2104', 'Canada', 'J8R2U6', 'mslowgroveol@microsoft.com'),
('386677341545891', 'AMEX', '3283', 10, 2018, '640 Hoard Lane', '77', 'Canada', 'J5G7Z3', 'dwoolway2z@nymag.com'),
('3876797323735092', 'MC', '517', 12, 2018, '31329 Hovde Lane', '5417', 'United States', '83819', 'whaggard6z@rakuten.co.jp'),
('3895272953145232', 'VISA', '996', 3, 2018, '615 Elgar Road', '0', 'United States', '47397', 'tnewlandsk8@jalbum.net'),
('3921195431838540', 'MC', '400', 11, 2022, '5235 Messerschmidt Street', '4', 'Canada', 'X6G9Q1', 'bsweetland9a@nature.com'),
('3941425576573735', 'MC', '954', 7, 2021, '2452 Holy Cross Street', '234', 'United States', '83819', 'sdavisef@harvard.edu'),
('3956197466469192', 'DISCOVER', '993', 7, 2024, '33 Kropf Street', '0297', 'Canada', 'D6A2H3', 'nralphs53@digg.com'),
('3981836420348561', 'DISCOVER', '541', 7, 2022, '8569 Sachtjen Hill', '292', 'Canada', 'X0W5C2', 'jclougherle@bravesites.com'),
('398877350082596', 'AMEX', '2645', 1, 2021, '97118 Eliot Trail', '84301', 'United States', '12796', 'rconingif@phoca.cz'),
('3989228893024007', 'DISCOVER', '356', 12, 2020, '75192 Ludington Avenue', '17', 'United States', '32542', 'amcnicol3k@printfriendly.com'),
('3994614531567339', 'VISA', '822', 12, 2022, '647 Sherman Drive', '416', 'Canada', 'U5L2M5', 'tcamacho2f@reference.com'),
('402456985118872', 'AMEX', '7064', 2, 2021, '6193 Amoth Hill', '7', 'United States', '29840', 'epiersehc@techcrunch.com'),
('4029822266745118', 'VISA', '614', 10, 2023, '0718 Kropf Center', '8', 'United States', '63095', 'wrickesies4x@yandex.ru'),
('4034618456925739', 'DISCOVER', '998', 9, 2018, '0973 Parkside Drive', '90334', 'United States', '98428', 'eberensqp@biglobe.ne.jp'),
('4042476285112862', 'MC', '829', 1, 2018, '0 Carpenter Center', '487', 'Canada', 'J3D2J3', 'nbrundrett8p@va.gov'),
('4050462532152661', 'DISCOVER', '783', 10, 2024, '9 Sutteridge Junction', '3', 'Canada', 'T8O1E6', 'dtollandix@sfgate.com'),
('4066840826680278', 'VISA', '171', 2, 2024, '35014 Donald Junction', '40', 'United States', '70289', 'klightollers3r@theglobeandmail.com'),
('4076762360093734', 'DISCOVER', '193', 12, 2018, '345 Lotheville Pass', '94', 'Canada', 'X6G9Q1', 'fweedeneu@goodreads.com'),
('4078354681593204', 'VISA', '960', 9, 2019, '002 Talisman Hill', '781', 'United States', '33640', 'tkimblyad@economist.com'),
('408400212669699', 'AMEX', '0856', 9, 2023, '0 Carpenter Center', '487', 'Canada', 'J3D2J3', 'etween61@g.co'),
('4086119144555087', 'MC', '038', 4, 2019, '559 Packers Park', '998', 'United States', '19011', 'pwildgoose8e@storify.com');
INSERT INTO `paymentinformation` (`card_num`, `card_type`, `cvv`, `expiry_month`, `expiry_year`, `street_address`, `unit_number`, `country`, `postal_code`, `user_email`) VALUES
('4092083323950388', 'DISCOVER', '766', 9, 2020, '45 Shopko Street', '9918', 'United States', '15751', 'hyearn5t@netscape.com'),
('4100388699536765', 'VISA', '354', 11, 2020, '8 Mariners Cove Park', '54266', 'United States', '62244', 'tjudkins9c@fastcompany.com'),
('4113288757646835', 'VISA', '278', 2, 2020, '556 Vernon Drive', '37', 'Canada', 'U5S4C4', 'ksnare6p@google.ca'),
('4116149685183712', 'DISCOVER', '554', 2, 2020, '8 Clove Avenue', '6117', 'Canada', 'G4N1N9', 'giacopettih2@samsung.com'),
('4129883013292949', 'VISA', '211', 1, 2020, '2 Washington Pass', '75960', 'Canada', 'J3D2J3', 'rchallacec3@simplemachines.org'),
('4145612213854727', 'MC', '920', 10, 2024, '8 Forest Run Center', '663', 'Canada', 'J7Y6O1', 'kvanyakinlw@gizmodo.com'),
('4153901220685658', 'DISCOVER', '692', 11, 2024, '077 Thierer Parkway', '83364', 'Canada', 'H8Q2G3', 'vparmerdu@nature.com'),
('4163806497148222', 'MC', '792', 2, 2023, '03984 Pankratz Street', '14156', 'United States', '84514', 'asoitoux3j@goodreads.com'),
('4168477902535553', 'DISCOVER', '913', 8, 2019, '23 Forster Crossing', '5932', 'Canada', 'M1N6T4', 'lgepson6j@sciencedirect.com'),
('4179431762117703', 'DISCOVER', '931', 4, 2023, '510 Logan Court', '3718', 'United States', '78984', 'lvaleg3@ifeng.com'),
('4184043718174295', 'VISA', '980', 12, 2019, '464 Duke Trail', '28', 'Canada', 'I1J8C0', 'esheenhz@blog.com'),
('4188882712185469', 'MC', '501', 4, 2020, '51 Bluestem Point', '9', 'Canada', 'M8N0M7', 'neidelman7a@ed.gov'),
('419134539088070', 'AMEX', '0663', 7, 2019, '5 Northview Court', '22730', 'United States', '85861', 'gmoulink5@addtoany.com'),
('4211228714102425', 'VISA', '002', 8, 2023, '345 Lotheville Pass', '94', 'Canada', 'X6G9Q1', 'cknaptonf7@liveinternet.ru'),
('421783666903199', 'AMEX', '8965', 12, 2022, '03501 Monterey Street', '3251', 'Canada', 'P5G0C2', 'mwinfreyof@bluehost.com'),
('422386786008502', 'AMEX', '7195', 9, 2020, '0 Summer Ridge Drive', '6831', 'United States', '26557', 'ksayle51@huffingtonpost.com'),
('4243165796085983', 'DISCOVER', '387', 3, 2024, '785 Schmedeman Terrace', '63', 'United States', '15751', 'japfler3a@wunderground.com'),
('4244105145997426', 'DISCOVER', '755', 9, 2020, '59 Schiller Trail', '5', 'United States', '36100', 'gvaughanjx@yellowpages.com'),
('4245187994229001', 'DISCOVER', '168', 5, 2022, '9 3rd Pass', '3', 'United States', '10986', 'hdolbeyr2@google.com'),
('4258300762376977', 'MC', '903', 1, 2020, '8155 Rockefeller Court', '23', 'Canada', 'U2U5S9', 'umatkovicmw@i2i.jp'),
('4261186505436541', 'MC', '617', 11, 2022, '22331 Alpine Terrace', '82536', 'Canada', 'H7H7J0', 'svandenbroekq8@princeton.edu'),
('426523259298142', 'AMEX', '6677', 11, 2024, '0691 Judy Terrace', '9', 'Canada', 'R0R8S6', 'jadame39@ebay.co.uk'),
('426576729115333', 'AMEX', '1935', 8, 2019, '19 Laurel Terrace', '972', 'United States', '70289', 'abeentjesng@whitehouse.gov'),
('427208053389778', 'AMEX', '3865', 10, 2020, '1 Stoughton Hill', '8', 'Canada', 'Y6Q1T5', 'wtaylour3p@yellowpages.com'),
('4286835431611525', 'DISCOVER', '457', 12, 2023, '4467 Duke Parkway', '9', 'Canada', 'R7F5Z0', 'mcopinsoi@ihg.com'),
('4298707277272120', 'VISA', '619', 5, 2019, '57808 Arizona Park', '3', 'United States', '56794', 'bsoanpb@icq.com'),
('4303013045691978', 'DISCOVER', '069', 6, 2018, '6685 Havey Hill', '7', 'United States', '60451', 'cmoulsdallih@so-net.ne.jp'),
('4326059239580408', 'MC', '842', 2, 2023, '4 Hermina Crossing', '592', 'Canada', 'E7G4Y7', 'tkobus4j@eventbrite.com'),
('433702633770447', 'AMEX', '3804', 1, 2019, '00 Sugar Parkway', '82', 'Canada', 'T9F7W2', 'cchesson2b@samsung.com'),
('4337375689620450', 'DISCOVER', '728', 5, 2023, '0137 Anthes Pass', '09', 'United States', '15449', 'pmckimmqm@rediff.com'),
('4339046356873180', 'DISCOVER', '308', 7, 2018, '416 Pennsylvania Parkway', '2793', 'Canada', 'X0W5C2', 'umatkovicmw@i2i.jp'),
('4355502392172004', 'DISCOVER', '136', 6, 2023, '0907 Calypso Circle', '9', 'United States', '84104', 'rbroaderi9@bbb.org'),
('4358649073456319', 'VISA', '124', 1, 2020, '763 Eagle Crest Lane', '45', 'Canada', 'K3N7R1', 'dransburyby@slashdot.org'),
('4372972948663712', 'MC', '273', 1, 2019, '2409 Basil Drive', '26', 'Canada', 'Q7C9S6', 'nlatourj3@ask.com'),
('4388798728746854', 'MC', '657', 5, 2019, '2398 Esker Trail', '4', 'Canada', 'F9Q9S0', 'bchapellowiu@etsy.com'),
('4396249939313681', 'DISCOVER', '838', 10, 2022, '561 Tomscot Crossing', '3707', 'Canada', 'H0T9U0', 'afullardj2@census.gov'),
('4412020672650454', 'VISA', '220', 9, 2021, '5 Village Green Junction', '514', 'United States', '95234', 'derik66@samsung.com'),
('4435486017786819', 'MC', '531', 9, 2023, '8 Forest Run Center', '663', 'Canada', 'J7Y6O1', 'ckunkelrp@noaa.gov'),
('4445996314134442', 'MC', '680', 5, 2022, '32796 6th Park', '27992', 'United States', '57046', 'tdurn73@cargocollective.com'),
('448247044150849', 'AMEX', '7995', 5, 2019, '647 Sherman Drive', '416', 'Canada', 'U5L2M5', 'gdouce3s@hostgator.com'),
('4490020354499229', 'DISCOVER', '671', 1, 2019, '73 Melvin Place', '27143', 'Canada', 'T8O1E6', 'dcamps@imgur.com'),
('4496582242933150', 'DISCOVER', '658', 12, 2022, '694 Lakewood Plaza', '530', 'Canada', 'A6Y6K4', 'jcopcuttgp@sciencedaily.com'),
('4497048823368326', 'VISA', '227', 2, 2021, '64484 Shoshone Avenue', '57343', 'United States', '12543', 'bklaussenl4@purevolume.com'),
('450008140337522', 'AMEX', '3864', 2, 2024, '78 Sommers Street', '8', 'Canada', 'O1H1W9', 'adenholm4@e-recht24.de'),
('454230449894343', 'AMEX', '5326', 5, 2019, '029 Petterle Circle', '9846', 'United States', '75715', 'anoenk@mit.edu'),
('4554902768063197', 'MC', '634', 4, 2023, '04 Kipling Trail', '376', 'United States', '64877', 'swindress5z@answers.com'),
('455558826913531', 'AMEX', '3024', 4, 2019, '63946 Bunker Hill Way', '6441', 'United States', '14888', 'amacane57@si.edu'),
('455840508132216', 'AMEX', '3971', 11, 2018, '8919 Barnett Crossing', '25', 'Canada', 'M9Z3I5', 'jdudney4d@ca.gov'),
('4560256965367221', 'MC', '647', 11, 2024, '469 Brown Trail', '26569', 'Canada', 'Z4S8H4', 'rnajera3c@google.es'),
('4591360365900663', 'MC', '228', 4, 2020, '28 Charing Cross Avenue', '5', 'Canada', 'C6U7A0', 'rkowal33@yahoo.co.jp'),
('4596060593367644', 'MC', '864', 1, 2020, '60 Dottie Place', '6276', 'United States', '54292', 'nvampluso7@webs.com'),
('4597994632530728', 'DISCOVER', '661', 3, 2019, '58 Lerdahl Lane', '193', 'United States', '20336', 'ostanmerny@themeforest.net'),
('4606463172304539', 'DISCOVER', '625', 4, 2023, '76213 Waubesa Park', '8369', 'Canada', 'C9X4Q9', 'gcorcoran83@opensource.org'),
('461569814620136', 'AMEX', '3682', 3, 2024, '103 Texas Point', '9545', 'Canada', 'U5H8D4', 'lpedlowh3@printfriendly.com'),
('462952318550999', 'AMEX', '6087', 2, 2019, '1 Summit Drive', '163', 'United States', '87605', 'kjersonig@wix.com'),
('463018646023017', 'AMEX', '1924', 3, 2019, '15165 Division Lane', '11833', 'Canada', 'R6R1Y9', 'lsowersbyb1@netscape.com'),
('463605937902807', 'AMEX', '9760', 7, 2019, '66 Heath Point', '48', 'Canada', 'P1X0U7', 'mgoodbody16@sphinn.com'),
('4649325176566170', 'VISA', '249', 5, 2022, '78 Sommers Street', '8', 'Canada', 'O1H1W9', 'cgrimwadeet@artisteer.com'),
('4651822349833562', 'MC', '543', 5, 2018, '0993 Killdeer Trail', '264', 'United States', '98166', 'tmullearybn@blogs.com'),
('4682816313800808', 'VISA', '816', 7, 2020, '223 Onsgard Parkway', '1', 'United States', '23290', 'swhilderit@qq.com'),
('4712302654138745', 'VISA', '497', 8, 2018, '6631 Johnson Street', '9886', 'Canada', 'D9Q0N6', 'tsimecekls@slideshare.net'),
('4718742936710751', 'MC', '860', 10, 2024, '6 Bultman Drive', '56', 'United States', '57185', 'roday65@google.cn'),
('471951771845207', 'AMEX', '9612', 12, 2020, '90 Anderson Avenue', '28', 'United States', '23104', 'hhalkyardmc@wufoo.com'),
('4729380855337687', 'VISA', '219', 1, 2018, '49 Pearson Street', '50377', 'United States', '49812', 'lgepson6j@sciencedirect.com'),
('4730479914649162', 'DISCOVER', '225', 1, 2019, '10 Swallow Street', '54', 'United States', '64009', 'jdelaperrelledp@hubpages.com'),
('4751341031843820', 'VISA', '902', 2, 2024, '97566 Laurel Road', '58107', 'United States', '58782', 'rwolfart10@nydailynews.com'),
('4769319028560601', 'VISA', '313', 12, 2020, '8155 Rockefeller Court', '23', 'Canada', 'U2U5S9', 'amiddiff6t@paypal.com'),
('4769954416028307', 'DISCOVER', '731', 10, 2019, '107 Prentice Center', '93943', 'Canada', 'A1N6I6', 'jmacmichael9e@e-recht24.de'),
('479902882094496', 'AMEX', '1773', 7, 2023, '70 Linden Drive', '0', 'Canada', 'L5K3G0', 'hyegorkovi1@mapy.cz'),
('4812223752316948', 'VISA', '393', 2, 2023, '4467 Duke Parkway', '9', 'Canada', 'R7F5Z0', 'hpietsmap0@google.com.hk'),
('481804268664823', 'AMEX', '4343', 2, 2018, '284 Sage Street', '770', 'United States', '22900', 'abrimblecomben3@pinterest.com'),
('4846441890741683', 'VISA', '657', 11, 2023, '5 Kim Center', '3722', 'Canada', 'Y3C3O9', 'jreadwin49@redcross.org'),
('4847615243154364', 'DISCOVER', '223', 8, 2021, '3823 Michigan Center', '7960', 'Canada', 'A6I9J9', 'dcapstickbd@live.com'),
('4859430074857234', 'DISCOVER', '835', 12, 2022, '7878 Dexter Crossing', '355', 'Canada', 'X9G4S1', 'wabelshs@cafepress.com'),
('486245763416217', 'AMEX', '4730', 1, 2020, '3159 Lakeland Drive', '361', 'Canada', 'K1Z6L8', 'hhoward62@wired.com'),
('4872063386002090', 'VISA', '074', 1, 2019, '5634 Brickson Park Drive', '4146', 'United States', '11462', 'ggoalleycu@dmoz.org'),
('488347340997078', 'AMEX', '3585', 9, 2018, '6290 Oxford Pass', '17477', 'Canada', 'E2M6A9', 'mroswarner4@typepad.com'),
('4901577618287892', 'VISA', '514', 1, 2019, '7 Weeping Birch Circle', '87223', 'United States', '19091', 'mfoundcq@domainmarket.com'),
('4905144127788001', 'MC', '991', 10, 2024, '34 Warner Street', '1026', 'Canada', 'M3E7E4', 'swoodwindcn@yale.edu'),
('4910125125914685', 'VISA', '911', 10, 2019, '7742 Dennis Street', '44', 'United States', '29840', 'mbenaine2p@ning.com'),
('4913237860948669', 'DISCOVER', '825', 4, 2022, '0 Westend Circle', '841', 'United States', '12801', 'mchuckb8@cbslocal.com'),
('4957055298416503', 'DISCOVER', '359', 11, 2023, '64 Stephen Avenue', '015', 'United States', '40251', 'rcurroriv@upenn.edu'),
('4959719957664052', 'VISA', '076', 7, 2018, '9211 Roxbury Circle', '774', 'Canada', 'Q3P1R6', 'mchuckb8@cbslocal.com'),
('4962679671540464', 'VISA', '597', 3, 2022, '0718 Kropf Center', '8', 'United States', '63095', 'twakerhl@vk.com'),
('4978708721169898', 'MC', '420', 11, 2018, '7022 Canary Trail', '913', 'Canada', 'M1N6T4', 'cmanicomor@cbc.ca'),
('4982288835563153', 'VISA', '186', 6, 2024, '33575 Charing Cross Circle', '2', 'United States', '71709', 'dberref@bbc.co.uk'),
('498284541775640', 'AMEX', '9089', 1, 2019, '41 Starling Circle', '2387', 'Canada', 'O2A5G4', 'uhazeldenerj@tinyurl.com'),
('4987303119600412', 'VISA', '111', 3, 2019, '09 Grayhawk Park', '317', 'United States', '75715', 'aoheffernan59@mapy.cz'),
('499532727567747', 'AMEX', '0782', 11, 2024, '9335 Division Way', '5951', 'Canada', 'T9F7W2', 'dstenettdk@shutterfly.com'),
('499957814602115', 'AMEX', '8302', 4, 2018, '889 Dunning Avenue', '002', 'United States', '88802', 'ajelley89@berkeley.edu'),
('5030072744671396', 'DISCOVER', '694', 4, 2023, '4477 Norway Maple Street', '12', 'United States', '18606', 'srispinel@bbc.co.uk'),
('5035525624840471', 'DISCOVER', '422', 9, 2022, '3 Pankratz Terrace', '1625', 'United States', '63095', 'bklaussenl4@purevolume.com'),
('5047041350017357', 'VISA', '738', 6, 2022, '46 Chinook Park', '0', 'United States', '12796', 'smalkini3@yellowbook.com'),
('5049403756965709', 'DISCOVER', '963', 10, 2019, '87 Kinsman Lane', '564', 'United States', '68103', 'hbeatson4o@lycos.com'),
('5067713339759586', 'VISA', '406', 1, 2021, '78 Sommers Street', '8', 'Canada', 'O1H1W9', 'alotterington1w@mit.edu'),
('5076260827621747', 'MC', '804', 3, 2020, '64 Stephen Avenue', '015', 'United States', '40251', 'nwimburyds@purevolume.com'),
('5081685446399275', 'VISA', '704', 3, 2024, '13675 Acker Plaza', '828', 'Canada', 'G8E6T8', 'ccrosserpe@domainmarket.com'),
('5087045374094339', 'DISCOVER', '674', 9, 2024, '7431 Texas Park', '1', 'Canada', 'Q3P1R6', 'gantalie@live.com'),
('509101478668790', 'AMEX', '8956', 10, 2019, '1 Ramsey Circle', '95384', 'United States', '29021', 'mgabalan6@ft.com'),
('509225818851417', 'AMEX', '4091', 12, 2018, '5 Village Green Junction', '514', 'United States', '95234', 'awyvilljg@amazon.de'),
('5106884450533544', 'MC', '069', 6, 2023, '95096 Park Meadow Pass', '47071', 'United States', '57185', 'cmanicomor@cbc.ca'),
('5117708585207018', 'MC', '624', 8, 2023, '51 Lien Plaza', '69', 'United States', '94442', 'amajurye5@163.com'),
('513236527802862', 'AMEX', '2541', 5, 2020, '55 Shoshone Hill', '7', 'Canada', 'I7F2K1', 'trosenfelderlu@drupal.org'),
('5136273267815582', 'VISA', '555', 8, 2022, '35 Tomscot Alley', '7', 'United States', '96246', 'rraglessjj@tmall.com'),
('5158067513718122', 'DISCOVER', '574', 8, 2020, '1 Summit Drive', '163', 'United States', '87605', 'benstonqy@hibu.com'),
('5166002900471355', 'VISA', '988', 11, 2023, '92 Bartelt Hill', '4823', 'United States', '81500', 'cdelaharpepf@4shared.com'),
('5172732474791880', 'DISCOVER', '542', 8, 2023, '6797 Lillian Place', '56263', 'Canada', 'H0T9U0', 'ncastagnen0@twitpic.com'),
('5180535113889937', 'VISA', '990', 9, 2020, '51299 Esker Junction', '0', 'Canada', 'X6G9Q1', 'kbreaganmm@accuweather.com'),
('5181664306540637', 'VISA', '149', 4, 2024, '758 Marcy Lane', '35', 'United States', '18606', 'jtoselandov@last.fm'),
('518637243446872', 'AMEX', '0201', 7, 2022, '19140 Veith Alley', '393', 'United States', '94576', 'ltrudgeonp1@rediff.com'),
('519107337722462', 'AMEX', '4127', 5, 2022, '8045 Susan Way', '8', 'Canada', 'G7Q7K7', 'dcamps@imgur.com'),
('5215639641563349', 'DISCOVER', '059', 9, 2023, '7 School Point', '986', 'United States', '68092', 'ccolnett27@a8.net'),
('5225656155945966', 'MC', '463', 11, 2020, '4670 Service Circle', '25282', 'United States', '17580', 'mdefriesq5@cocolog-nifty.com'),
('5237085103443714', 'VISA', '109', 10, 2020, '58959 Stone Corner Avenue', '917', 'United States', '18606', 'tnewlandsk8@jalbum.net'),
('5255114564485649', 'DISCOVER', '344', 12, 2020, '81 Petterle Way', '5255', 'United States', '55002', 'jscownms@sina.com.cn'),
('5271663964475120', 'DISCOVER', '469', 8, 2018, '486 Ohio Circle', '01', 'Canada', 'Z0H6K0', 'hcubbinin@instagram.com'),
('5274357600369968', 'VISA', '252', 7, 2018, '512 Mariners Cove Drive', '2', 'United States', '36100', 'desomehm@princeton.edu'),
('528704841194205', 'AMEX', '6261', 12, 2023, '8 Kensington Center', '3', 'United States', '49654', 'rgrimme1s@amazonaws.com'),
('529623911309427', 'AMEX', '5686', 8, 2021, '090 Northridge Trail', '8', 'United States', '83819', 'gduddingh@facebook.com'),
('5298459651156144', 'DISCOVER', '655', 10, 2019, '8 Kensington Center', '3', 'United States', '49654', 'jdene44@wired.com'),
('5300123018639965', 'DISCOVER', '677', 3, 2019, '501 Elgar Park', '05', 'Canada', 'X9G4S1', 'mheffordoa@pen.io'),
('5304830995958339', 'MC', '436', 12, 2020, '28056 Maple Center', '5', 'Canada', 'S1F1S1', 'mbrendei@mysql.com'),
('530718767094979', 'AMEX', '0631', 4, 2022, '6 Clemons Hill', '4257', 'Canada', 'M7E8E8', 'aklimmek13@umich.edu'),
('5310141928349859', 'DISCOVER', '557', 2, 2022, '34283 Schiller Trail', '28', 'Canada', 'Q8G7F8', 'kjersonig@wix.com'),
('532720714899944', 'AMEX', '0367', 5, 2020, '3231 Charing Cross Alley', '63', 'Canada', 'B4U9M0', 'agengekn@mozilla.org'),
('5327862208047532', 'MC', '365', 12, 2023, '239 Rowland Lane', '06334', 'Canada', 'C8Y6F0', 'cmcconnachie8f@gmpg.org'),
('5350485275611712', 'DISCOVER', '152', 6, 2021, '9 John Wall Terrace', '340', 'Canada', 'E1Z4Z1', 'bcrabbbw@blogs.com'),
('5355059943361159', 'MC', '155', 10, 2022, '9 Gulseth Drive', '075', 'United States', '28705', 'mentres1d@disqus.com'),
('5361685396293176', 'MC', '109', 2, 2020, '40 Banding Trail', '129', 'United States', '20458', 'swoolatt29@dailymail.co.uk'),
('5374164375207721', 'VISA', '548', 11, 2022, '25 Loeprich Hill', '3', 'United States', '34106', 'dmariottenq@surveymonkey.com'),
('5379188230823777', 'VISA', '352', 7, 2018, '97 Messerschmidt Hill', '20192', 'United States', '62244', 'silyinskike@mtv.com'),
('5391354255864170', 'VISA', '899', 2, 2024, '2152 Acker Alley', '91', 'United States', '22525', 'kfidgeon6i@psu.edu'),
('539777627569448', 'AMEX', '5863', 9, 2019, '556 Vernon Drive', '37', 'Canada', 'U5S4C4', 'fpeepall14@gizmodo.com'),
('5404843071635880', 'MC', '388', 11, 2022, '76 Claremont Alley', '42', 'United States', '66847', 'epiersehc@techcrunch.com'),
('5410252601266290', 'VISA', '136', 12, 2020, '4 5th Junction', '189', 'Canada', 'B2P5X5', 'aacomb11@wisc.edu'),
('5410570381635038', 'VISA', '972', 8, 2023, '9302 Fisk Street', '58253', 'Canada', 'N6M4O9', 'liredaleav@admin.ch'),
('5414240375519835', 'MC', '720', 1, 2023, '66044 Packers Crossing', '6', 'United States', '81500', 'carens63@wikia.com'),
('5423210075598561', 'VISA', '034', 10, 2021, '5235 Messerschmidt Street', '4', 'Canada', 'X6G9Q1', 'rcurlis9y@blogs.com'),
('543833725856815', 'AMEX', '6296', 10, 2018, '6824 Carberry Road', '107', 'Canada', 'F7C7A2', 'sbirkheadm@sakura.ne.jp'),
('5443166251595305', 'MC', '706', 3, 2019, '8 Clove Avenue', '6117', 'Canada', 'G4N1N9', 'sprinnettl7@addthis.com'),
('546058742942775', 'AMEX', '5805', 2, 2019, '24 Independence Junction', '304', 'United States', '68092', 'flesurfko@acquirethisname.com'),
('5467771621185023', 'MC', '311', 9, 2018, '3001 Autumn Leaf Terrace', '834', 'Canada', 'U1I2O9', 'mentres1d@disqus.com'),
('5474249370977919', 'MC', '322', 10, 2019, '15165 Division Lane', '11833', 'Canada', 'R6R1Y9', 'ebrudenell1e@ask.com'),
('5474997063717419', 'DISCOVER', '276', 1, 2022, '7878 Dexter Crossing', '355', 'Canada', 'X9G4S1', 'cdobrovolski4z@eventbrite.com'),
('548456130425784', 'AMEX', '4866', 10, 2024, '980 Packers Trail', '54', 'Canada', 'K3N7R1', 'ibiggamph@alexa.com'),
('5484851215066351', 'VISA', '833', 4, 2022, '18904 Larry Crossing', '4629', 'Canada', 'G3U2J7', 'kbischoffci@nifty.com'),
('5492292047619378', 'VISA', '138', 8, 2020, '11 Tennessee Place', '564', 'United States', '28127', 'cmcilhattona5@ebay.com'),
('552869394395580', 'AMEX', '2882', 7, 2020, '5002 Thackeray Trail', '87531', 'Canada', 'C9C5N0', 'twakerhl@vk.com'),
('5539441432062316', 'MC', '543', 10, 2020, '83225 Mockingbird Street', '49', 'Canada', 'G4N1N9', 'dchristypd@noaa.gov'),
('5546393229972390', 'MC', '449', 4, 2022, '6655 Glacier Hill Trail', '2', 'United States', '71709', 'gblackford5f@unesco.org'),
('555649584037003', 'AMEX', '1818', 9, 2023, '950 Northridge Way', '209', 'Canada', 'F7C7A2', 'jstefanovic78@jiathis.com'),
('5573614030527595', 'MC', '936', 3, 2021, '42 North Drive', '69134', 'Canada', 'Z3C1O5', 'dwisherjb@chicagotribune.com'),
('5574178187077713', 'MC', '777', 6, 2020, '15321 Bellgrove Road', '9', 'United States', '19091', 'ltrimmillpk@boston.com'),
('5584359990593692', 'DISCOVER', '470', 10, 2020, '4 Katie Lane', '2', 'Canada', 'H0T9U0', 'apurchonc1@unc.edu'),
('5584388469186743', 'MC', '936', 2, 2022, '82 Hansons Drive', '72', 'Canada', 'U6K2C9', 'kjenkin7f@ebay.com'),
('5595727014342856', 'DISCOVER', '990', 12, 2024, '89170 Nova Terrace', '6', 'Canada', 'B5Q7U1', 'ewealleans3x@miitbeian.gov.cn'),
('560083245055072', 'AMEX', '1746', 11, 2018, '0829 Mosinee Avenue', '637', 'Canada', 'P5G0C2', 'llecountpc@huffingtonpost.com'),
('5605958372194628', 'MC', '241', 8, 2020, '30 Hayes Park', '2', 'Canada', 'G7F6D2', 'pchadneyiz@marketwatch.com'),
('5610436024364573', 'DISCOVER', '048', 11, 2024, '62 Schiller Parkway', '10821', 'United States', '12796', 'jesbya@tumblr.com'),
('5611106972265967', 'DISCOVER', '878', 5, 2022, '1 Carioca Junction', '1', 'United States', '28705', 'sgothardl1@163.com'),
('563039418126165', 'AMEX', '9029', 10, 2018, '8912 Gulseth Point', '75', 'United States', '11792', 'gbateyfg@icio.us'),
('5637074545701082', 'VISA', '065', 3, 2021, '144 Loeprich Park', '87582', 'United States', '43123', 'jadame39@ebay.co.uk'),
('5643787070497923', 'MC', '618', 10, 2023, '32371 Bellgrove Road', '4034', 'United States', '15751', 'lyeates46@biglobe.ne.jp'),
('5652568353124364', 'DISCOVER', '588', 9, 2019, '4612 Dixon Lane', '175', 'Canada', 'I5O9W5', 'spraterhb@ehow.com'),
('5655980918745198', 'DISCOVER', '505', 2, 2023, '341 Morrow Hill', '0261', 'United States', '86352', 'singledowcc@europa.eu'),
('5656522655884978', 'MC', '965', 7, 2021, '70382 Boyd Court', '09050', 'Canada', 'T5G2F9', 'mcorranfa@oaic.gov.au'),
('566080570934620', 'AMEX', '7805', 1, 2024, '28267 Namekagon Way', '438', 'United States', '10986', 'echelleydd@amazon.co.uk'),
('5664801058301613', 'MC', '567', 8, 2023, '9176 Messerschmidt Parkway', '9', 'Canada', 'W2U8D9', 'acarlesine@ucoz.com'),
('5665933035996474', 'DISCOVER', '502', 12, 2021, '10226 Darwin Street', '1', 'United States', '64877', 'nslottf9@delicious.com'),
('5675427725034892', 'VISA', '683', 1, 2021, '923 Cardinal Parkway', '24903', 'Canada', 'R1L8S7', 'bdallman93@fc2.com'),
('567969353300185', 'AMEX', '5540', 10, 2019, '19 Laurel Terrace', '972', 'United States', '70289', 'ckunkelrp@noaa.gov'),
('5685529221144340', 'MC', '036', 4, 2021, '15321 Bellgrove Road', '9', 'United States', '19091', 'mshimmin9l@plala.or.jp'),
('568613093378306', 'AMEX', '2826', 6, 2019, '5 Graedel Center', '53740', 'United States', '87605', 'dwhatford3v@npr.org'),
('5688011607241964', 'DISCOVER', '166', 4, 2018, '45402 Springview Road', '9769', 'United States', '37035', 'lgadesby8u@e-recht24.de'),
('5689174566178747', 'MC', '874', 12, 2019, '5676 Pond Circle', '1260', 'Canada', 'O2A5G4', 'nwimburyds@purevolume.com'),
('5731064256117636', 'MC', '468', 2, 2019, '0128 Amoth Parkway', '65', 'United States', '20458', 'echelleydd@amazon.co.uk'),
('573487428963653', 'AMEX', '6834', 10, 2020, '239 Rowland Lane', '06334', 'Canada', 'C8Y6F0', 'voxxfj@1und1.de'),
('5735062483173628', 'VISA', '336', 12, 2020, '37 Waubesa Drive', '1', 'Canada', 'H7H7J0', 'hmelbourneeo@hp.com'),
('5738758248228812', 'DISCOVER', '362', 10, 2018, '1 Straubel Center', '9', 'United States', '54436', 'frydzynskigm@archive.org'),
('5738796682040732', 'MC', '462', 5, 2018, '1541 1st Terrace', '5', 'Canada', 'O9Q3J0', 'gmarcubk@technorati.com'),
('573956306586018', 'AMEX', '9056', 2, 2018, '2 Monument Place', '47', 'United States', '19362', 'mdedneycj@theguardian.com'),
('5740303267115422', 'VISA', '809', 3, 2018, '3 8th Park', '76', 'United States', '20336', 'jjoulpa@home.pl'),
('5755419630652792', 'DISCOVER', '053', 9, 2022, '361 Butterfield Hill', '5', 'United States', '80530', 'bholdworthz@sciencedirect.com'),
('5755958980819015', 'MC', '082', 5, 2021, '37641 Ridge Oak Center', '9', 'United States', '57799', 'dwoolway2z@nymag.com'),
('5782468480661885', 'VISA', '696', 3, 2019, '41004 Valley Edge Road', '42', 'United States', '57185', 'cmateogj@sun.com'),
('5783415250595943', 'VISA', '012', 11, 2023, '810 Barnett Road', '15', 'United States', '81500', 'dephgravebu@psu.edu'),
('5786817380140686', 'DISCOVER', '382', 2, 2024, '1541 1st Terrace', '5', 'Canada', 'O9Q3J0', 'cbushell9j@nature.com'),
('579204674519278', 'AMEX', '5467', 9, 2022, '9763 Weeping Birch Center', '7', 'United States', '11423', 'kmamwelld1@gravatar.com'),
('5806590234444799', 'VISA', '277', 7, 2018, '5 Bunker Hill Center', '5', 'Canada', 'J7R9B7', 'cshropshiremh@sfgate.com'),
('5810403438465236', 'VISA', '381', 3, 2024, '57808 Arizona Park', '3', 'United States', '56794', 'tkimblyad@economist.com'),
('5812081976320971', 'MC', '647', 7, 2018, '9 Cody Drive', '745', 'United States', '10450', 'adadgee1@dagondesign.com'),
('5822273297766373', 'MC', '685', 12, 2019, '36 Kingsford Drive', '78', 'United States', '34964', 'lpostgateq2@home.pl'),
('5824846652893345', 'MC', '508', 5, 2019, '0839 Bluejay Court', '43830', 'Canada', 'E5H3Y3', 'lduell7r@wiley.com'),
('5830840490230516', 'VISA', '297', 5, 2018, '9 Lakewood Gardens Terrace', '7710', 'Canada', 'T8O1E6', 'vpatrone8s@youku.com'),
('5848090697793369', 'VISA', '757', 7, 2021, '61 Manitowish Pass', '4', 'United States', '15449', 'rmilellag1@slashdot.org'),
('5865107447571352', 'VISA', '288', 8, 2023, '9 Pawling Center', '41', 'United States', '33040', 'slovedayl6@google.it'),
('5871808270411981', 'MC', '816', 9, 2023, '91 Darwin Lane', '03', 'Canada', 'B3H8O3', 'ksayle51@huffingtonpost.com'),
('5874973318189656', 'MC', '046', 1, 2020, '01 Thackeray Park', '323', 'Canada', 'I8Z4I8', 'emcveighf4@bloglovin.com'),
('5880083265086072', 'DISCOVER', '868', 8, 2024, '46 Chinook Park', '0', 'United States', '12796', 'mcopinsoi@ihg.com'),
('5889138227687459', 'VISA', '568', 6, 2024, '19 Laurel Terrace', '972', 'United States', '70289', 'cbushell9j@nature.com'),
('5901653552997366', 'MC', '820', 7, 2022, '460 Marquette Junction', '93021', 'United States', '78984', 'zllorensn5@thetimes.co.uk'),
('5920148413814200', 'MC', '493', 4, 2023, '5 Redwing Road', '401', 'Canada', 'C2J0I0', 'silyinskike@mtv.com'),
('5936204370230236', 'DISCOVER', '447', 1, 2018, '4 Graedel Crossing', '15', 'Canada', 'J8R2U6', 'jarnollk6@va.gov'),
('594535202405600', 'AMEX', '1397', 12, 2020, '7 Namekagon Trail', '1', 'Canada', 'D7M6R9', 'rbroaderi9@bbb.org'),
('5945789202023651', 'DISCOVER', '399', 3, 2018, '92442 Dryden Point', '07', 'Canada', 'P5A1Q6', 'mbrosettifb@timesonline.co.uk'),
('594651959062697', 'AMEX', '1949', 3, 2019, '3774 Fisk Point', '8192', 'United States', '77725', 'jdudney4d@ca.gov'),
('5962623503237122', 'VISA', '721', 12, 2018, '82 Holy Cross Hill', '5', 'United States', '47656', 'nfantone2x@comsenz.com'),
('598072426275951', 'AMEX', '7400', 10, 2020, '51 Marcy Alley', '88', 'United States', '98428', 'cshortonf5@home.pl'),
('5994843442543394', 'DISCOVER', '495', 7, 2022, '2 5th Hill', '5426', 'Canada', 'F9E0S9', 'mhodgets5x@theatlantic.com'),
('6003608108914920', 'MC', '696', 12, 2019, '6 Shasta Place', '842', 'Canada', 'J5W6I8', 'dgaggh1@weebly.com'),
('601778609116038', 'AMEX', '3697', 4, 2019, '4081 Sachs Drive', '599', 'Canada', 'K3N7R1', 'lduell7r@wiley.com'),
('6023338776450949', 'MC', '934', 9, 2020, '66 Heath Point', '48', 'Canada', 'P1X0U7', 'bhartfleetib@yellowbook.com'),
('6030983023734075', 'MC', '005', 9, 2019, '23 Forster Crossing', '5932', 'Canada', 'M1N6T4', 'cshortonf5@home.pl'),
('6039037330692971', 'VISA', '636', 4, 2018, '7 Weeping Birch Circle', '87223', 'United States', '19091', 'lpedlowh3@printfriendly.com'),
('605413637874057', 'AMEX', '4070', 12, 2018, '73199 Sachs Lane', '170', 'Canada', 'B2P5X5', 'lcarnegylh@ameblo.jp'),
('6064101318446488', 'MC', '853', 12, 2022, '0 Washington Drive', '65712', 'Canada', 'K8U3M0', 'btromansfk@google.co.jp'),
('6064578419673664', 'DISCOVER', '839', 1, 2019, '41004 Valley Edge Road', '42', 'United States', '57185', 'bmusselwhiteik@yelp.com'),
('6079004713878758', 'MC', '835', 11, 2019, '802 Mifflin Place', '1', 'Canada', 'Y3C3O9', 'rbennellq4@wiley.com'),
('6080893312264332', 'MC', '816', 11, 2023, '46 Chinook Park', '0', 'United States', '12796', 'agabeyc4@google.ru'),
('6101893244359139', 'MC', '741', 5, 2024, '8 Kensington Center', '3', 'United States', '49654', 'mdecarlok3@barnesandnoble.com'),
('6107632270179213', 'MC', '565', 3, 2024, '47176 Sycamore Trail', '06', 'United States', '31667', 'aboxellgy@skyrock.com'),
('6118867427492628', 'MC', '952', 3, 2024, '92357 Union Circle', '7', 'United States', '78249', 'gfalkjq@cnbc.com'),
('6125082591977935', 'DISCOVER', '765', 10, 2019, '0 Reindahl Park', '0883', 'United States', '11622', 'zgersonm9@odnoklassniki.ru'),
('612626549652460', 'AMEX', '5459', 4, 2024, '93 Myrtle Park', '6', 'United States', '41991', 'tmullearybn@blogs.com'),
('6128364984192585', 'VISA', '319', 1, 2019, '7377 Dayton Trail', '40993', 'United States', '22156', 'jnice26@friendfeed.com'),
('6139069927613026', 'VISA', '251', 4, 2019, '28 Melvin Park', '4', 'United States', '96246', 'rallans68@zimbio.com'),
('614377731850438', 'AMEX', '1009', 5, 2021, '67 Bobwhite Court', '981', 'Canada', 'J9X9O1', 'bhughmang8@chron.com'),
('615096308447958', 'AMEX', '1658', 12, 2020, '63946 Bunker Hill Way', '6441', 'United States', '14888', 'trosenfelderlu@drupal.org'),
('6154611090550714', 'DISCOVER', '932', 3, 2018, '52318 Straubel Circle', '9', 'United States', '46560', 'tdurn73@cargocollective.com'),
('6161246191608074', 'VISA', '086', 12, 2019, '09128 Southridge Way', '4', 'United States', '64288', 'jkettsnu@aol.com'),
('6169099679239947', 'MC', '562', 5, 2018, '950 Northridge Way', '209', 'Canada', 'F7C7A2', 'nslottf9@delicious.com'),
('6200239605389403', 'DISCOVER', '020', 7, 2020, '240 Mccormick Parkway', '6227', 'United States', '73065', 'cdinsalekt@myspace.com'),
('6206296378388369', 'DISCOVER', '252', 1, 2023, '7742 Dennis Street', '44', 'United States', '29840', 'heydelos@aol.com'),
('6227009509549522', 'MC', '703', 1, 2024, '4 High Crossing Center', '20', 'Canada', 'Q8G7F8', 'jdouglissd0@twitter.com'),
('623317851783282', 'AMEX', '2736', 6, 2024, '3 Myrtle Trail', '7871', 'Canada', 'J5Z0F4', 'ksayle51@huffingtonpost.com'),
('623728207658751', 'AMEX', '0726', 1, 2023, '81 Pawling Plaza', '95365', 'United States', '51688', 'cwilloway1p@github.io'),
('624613126786039', 'AMEX', '7307', 1, 2023, '234 Northview Pass', '8', 'Canada', 'T8O1E6', 'rbroaderi9@bbb.org'),
('624938750643158', 'AMEX', '6838', 2, 2023, '94172 Bunting Pass', '0', 'United States', '62244', 'jdursleyqh@ameblo.jp'),
('6252231439553299', 'DISCOVER', '578', 6, 2018, '628 Morrow Terrace', '5851', 'United States', '22525', 'jlehrps@arstechnica.com'),
('6274590044759768', 'MC', '537', 10, 2024, '07396 Prairieview Place', '1896', 'Canada', 'Q5Y0T4', 'vcozensr6@goodreads.com'),
('6276689048220332', 'DISCOVER', '539', 12, 2019, '105 Talmadge Center', '70', 'United States', '28127', 'imarkosed@china.com.cn'),
('629051022763391', 'AMEX', '2564', 3, 2023, '4081 Sachs Drive', '599', 'Canada', 'K3N7R1', 'ostanmerny@themeforest.net'),
('6300301137229447', 'VISA', '902', 10, 2023, '01 Ilene Terrace', '845', 'Canada', 'C4S7B0', 'olukasen8d@ocn.ne.jp'),
('6304415831165905', 'MC', '664', 7, 2024, '2468 Continental Drive', '09039', 'United States', '56403', 'kkadwalliderm1@gov.uk'),
('6307313302369093', 'DISCOVER', '455', 2, 2018, '04511 Gerald Center', '13004', 'Canada', 'C5M5E1', 'cmellers1f@xrea.com'),
('6316354496075981', 'DISCOVER', '294', 7, 2022, '34283 Schiller Trail', '28', 'Canada', 'Q8G7F8', 'ealdrenma@odnoklassniki.ru'),
('6330546293940218', 'DISCOVER', '936', 6, 2020, '3 Blue Bill Park Street', '5', 'Canada', 'U1I2O9', 'dstrainfl@cloudflare.com'),
('633265520763451', 'AMEX', '8130', 11, 2019, '6 Mayer Avenue', '3', 'Canada', 'D9N7Z9', 'dtollandix@sfgate.com'),
('6356613209789210', 'MC', '493', 7, 2018, '15293 Dottie Pass', '62802', 'Canada', 'R1L8S7', 'nfantone2x@comsenz.com'),
('636041060830879', 'AMEX', '2211', 8, 2021, '103 Texas Point', '9545', 'Canada', 'U5H8D4', 'tfrostickbm@merriam-webster.com'),
('6366323370573146', 'DISCOVER', '566', 8, 2020, '84 Northwestern Lane', '325', 'United States', '72863', 'mjennokw@digg.com'),
('6368679918646977', 'VISA', '736', 1, 2020, '89996 Macpherson Hill', '5525', 'Canada', 'F8C1T5', 'rvalentingi@census.gov'),
('637704765253783', 'AMEX', '6131', 11, 2018, '3 Eagle Crest Way', '24', 'Canada', 'Q5Y0T4', 'jpien2@shareasale.com'),
('6390150357154954', 'VISA', '490', 7, 2019, '2452 Holy Cross Street', '234', 'United States', '83819', 'mramalho9u@squarespace.com'),
('6404351629395608', 'VISA', '829', 10, 2018, '38 Knutson Circle', '7378', 'Canada', 'Y0B2B0', 'scatherine5j@redcross.org'),
('640623721297945', 'AMEX', '1607', 10, 2019, '4 Del Sol Parkway', '8042', 'Canada', 'W6D3B8', 'ddorricottlv@gravatar.com'),
('6414791127187432', 'DISCOVER', '194', 11, 2024, '28056 Maple Center', '5', 'Canada', 'S1F1S1', 'jsporgeonjw@chicagotribune.com'),
('641855615403701', 'AMEX', '6715', 3, 2021, '49431 Northland Court', '4', 'Canada', 'S7J3F3', 'vtrowlerey@usatoday.com'),
('6424520491203636', 'VISA', '018', 11, 2024, '97 Mcguire Park', '3450', 'United States', '30076', 'mlowderqr@bloglines.com'),
('6430918846616192', 'VISA', '731', 5, 2024, '4 Marquette Street', '13969', 'United States', '94574', 'adewickeb9@t-online.de'),
('6439033772439242', 'VISA', '104', 9, 2020, '92 Birchwood Trail', '0', 'United States', '81500', 'mholbieek@discuz.net'),
('644176947188212', 'AMEX', '8185', 10, 2023, '2148 Eagan Terrace', '80', 'Canada', 'T7P8G1', 'fscattergoodp6@ezinearticles.com'),
('6450521382161991', 'VISA', '404', 4, 2018, '69 Farwell Point', '517', 'Canada', 'B3A6R5', 'gcorcoran83@opensource.org'),
('6462658870155812', 'MC', '145', 9, 2023, '2 Dixon Parkway', '339', 'United States', '75715', 'dcutbush6v@ovh.net'),
('6473008428290937', 'DISCOVER', '818', 11, 2023, '505 Banding Court', '91419', 'United States', '11792', 'clovinga8@ocn.ne.jp'),
('6484072195983624', 'VISA', '388', 12, 2023, '1207 Ridgeway Drive', '52', 'United States', '64009', 'ssanthousegb@joomla.org'),
('6513387772760039', 'MC', '844', 3, 2023, '93 Crest Line Junction', '68473', 'Canada', 'F0O8M2', 'nkrookaq@ed.gov'),
('6515269735534782', 'MC', '030', 6, 2021, '11 Tennessee Place', '564', 'United States', '28127', 'amacane57@si.edu'),
('652309475224030', 'AMEX', '0391', 6, 2022, '31492 Orin Way', '437', 'United States', '23104', 'klippo7k@hp.com'),
('6527848552962190', 'MC', '901', 2, 2023, '0691 Judy Terrace', '9', 'Canada', 'R0R8S6', 'glawteyj8@people.com.cn'),
('6538815224717383', 'MC', '546', 4, 2020, '36 Kingsford Drive', '78', 'United States', '34964', 'djoseferhd@amazon.com'),
('6543989161758130', 'MC', '631', 4, 2024, '31872 Wayridge Point', '401', 'United States', '58782', 'amcnivenki@cnn.com'),
('6547903372105640', 'MC', '155', 11, 2023, '200 Bunting Place', '11923', 'Canada', 'O9Q3J0', 'bholdworthz@sciencedirect.com'),
('655653402874814', 'AMEX', '3934', 3, 2023, '239 Coolidge Lane', '2', 'United States', '34925', 'hsevingn@elpais.com'),
('6567151671774291', 'VISA', '301', 6, 2023, '228 Cambridge Hill', '4561', 'Canada', 'Q9B3H1', 'fpeepall14@gizmodo.com'),
('6568074933529232', 'DISCOVER', '128', 2, 2018, '2580 Mallard Court', '0', 'Canada', 'M9Z3I5', 'hkullmannqf@jigsy.com'),
('6580304745470317', 'DISCOVER', '400', 3, 2020, '2 Monument Place', '47', 'United States', '19362', 'nbrundrett8p@va.gov'),
('658294290788149', 'AMEX', '4156', 10, 2020, '09128 Southridge Way', '4', 'United States', '64288', 'egarwillnr@dailymail.co.uk'),
('658328439581209', 'AMEX', '6653', 7, 2023, '67608 Alpine Lane', '127', 'Canada', 'R8W0K1', 'pchadneyiz@marketwatch.com'),
('6587694430187764', 'MC', '971', 6, 2021, '98 Hayes Pass', '6511', 'Canada', 'N8X0F1', 'avedekhinlm@hhs.gov'),
('6591780168274175', 'VISA', '442', 1, 2018, '64 Stang Road', '537', 'Canada', 'F6W0G4', 'aumneyjk@behance.net'),
('6619071221406222', 'DISCOVER', '158', 1, 2018, '65 Rutledge Plaza', '65', 'United States', '83819', 'rpollett45@cbc.ca'),
('6624173764319174', 'DISCOVER', '483', 1, 2024, '6 Mayer Avenue', '3', 'Canada', 'D9N7Z9', 'lpostgateq2@home.pl'),
('6627990278476212', 'MC', '323', 12, 2023, '05724 Erie Street', '6', 'Canada', 'C8Y6F0', 'aklimmek13@umich.edu'),
('663345572940900', 'AMEX', '4764', 6, 2023, '5634 Brickson Park Drive', '4146', 'United States', '11462', 'agaskinshk@jiathis.com'),
('663933537331405', 'AMEX', '0056', 9, 2023, '3 Londonderry Parkway', '94114', 'Canada', 'U5L2M5', 'singledowcc@europa.eu'),
('6641954985499534', 'MC', '844', 9, 2023, '12 Village Green Lane', '3', 'United States', '17271', 'fbambrughk4@360.cn'),
('664660316932322', 'AMEX', '4531', 10, 2020, '0137 Anthes Pass', '09', 'United States', '15449', 'nbrundrett8p@va.gov'),
('6647447947917763', 'DISCOVER', '066', 3, 2019, '09128 Southridge Way', '4', 'United States', '64288', 'cmateogj@sun.com'),
('6649543282184336', 'DISCOVER', '507', 11, 2023, '2 Continental Court', '3', 'United States', '36100', 'haselcx@ycombinator.com'),
('665274802164803', 'AMEX', '9164', 12, 2018, '80090 Towne Place', '586', 'Canada', 'Q1N2F5', 'asherwindg@barnesandnoble.com'),
('6658068657933212', 'VISA', '420', 8, 2019, '83 Lien Terrace', '84', 'Canada', 'F3H2R6', 'grampley1y@360.cn'),
('666082795028525', 'AMEX', '7969', 3, 2022, '15165 Division Lane', '11833', 'Canada', 'R6R1Y9', 'mbenaine2p@ning.com'),
('667327339639164', 'AMEX', '7186', 5, 2019, '31329 Hovde Lane', '5417', 'United States', '83819', 'mbenaine2p@ning.com'),
('6711572781185353', 'MC', '724', 6, 2021, '410 Westport Drive', '1959', 'United States', '49633', 'ndowlingar@usnews.com'),
('672466964965180', 'AMEX', '6878', 10, 2018, '34 Duke Circle', '8590', 'Canada', 'S0D6O9', 'jpien2@shareasale.com'),
('6737820702842461', 'VISA', '726', 1, 2023, '0 Manufacturers Court', '24', 'United States', '23482', 'cmckissack2u@japanpost.jp'),
('6752292834822176', 'VISA', '008', 9, 2020, '1183 Cordelia Circle', '403', 'Canada', 'Z6T1W7', 'mheffordoa@pen.io'),
('6752511266963579', 'VISA', '509', 11, 2022, '023 Hanover Circle', '86', 'United States', '19011', 'heydelos@aol.com'),
('6753072484879799', 'VISA', '384', 4, 2023, '9 Mendota Crossing', '4433', 'United States', '59737', 'dsimms3y@cafepress.com'),
('6753698481753679', 'VISA', '652', 2, 2021, '7629 Stone Corner Park', '90101', 'Canada', 'F3H2R6', 'mahmad9x@reuters.com'),
('6758216455947248', 'VISA', '131', 10, 2019, '3 8th Park', '76', 'United States', '20336', 'jmorphetku@princeton.edu'),
('6761237767468142', 'MC', '699', 5, 2024, '34283 Schiller Trail', '28', 'Canada', 'Q8G7F8', 'ckyne2s@yahoo.com'),
('6779183387500475', 'MC', '935', 1, 2020, '5 Colorado Hill', '8761', 'United States', '79888', 'eivashintsov4v@yandex.ru'),
('678903774993740', 'AMEX', '2228', 3, 2018, '99 Helena Court', '3739', 'United States', '49159', 'hcameratiqa@youtu.be'),
('679552686266709', 'AMEX', '1698', 6, 2021, '1 Sherman Parkway', '1467', 'United States', '23104', 'dwhatford3v@npr.org'),
('6799047220294012', 'MC', '803', 9, 2018, '6183 Maryland Road', '396', 'Canada', 'D7M6R9', 'aumneyjk@behance.net'),
('680224278717280', 'AMEX', '4281', 3, 2019, '68 Dwight Park', '6', 'United States', '37035', 'gglewau@vimeo.com'),
('6871793594051944', 'DISCOVER', '242', 2, 2021, '8 Florence Point', '5', 'United States', '10450', 'cmullinermn@gnu.org'),
('6906638232929688', 'VISA', '632', 7, 2018, '995 Bay Center', '12', 'United States', '89182', 'cmcconnachie8f@gmpg.org'),
('6928931737685853', 'DISCOVER', '343', 8, 2023, '7703 Twin Pines Terrace', '6480', 'United States', '96012', 'weltonob@dyndns.org'),
('6934906801139021', 'MC', '158', 2, 2020, '99556 Bluestem Court', '082', 'United States', '32542', 'cditchett4q@jiathis.com'),
('6938917838342616', 'VISA', '516', 5, 2020, '055 Homewood Terrace', '3', 'Canada', 'F9Q9S0', 'mcryer3@fda.gov'),
('6959739243177235', 'DISCOVER', '712', 12, 2022, '0 Saint Paul Drive', '82361', 'Canada', 'I8Z4I8', 'vblazejewski2l@odnoklassniki.ru'),
('6965668872821323', 'VISA', '424', 2, 2021, '385 Grim Alley', '24', 'Canada', 'J7R9B7', 'ostaniforthdm@home.pl'),
('696715948922523', 'AMEX', '8832', 1, 2021, '28056 Maple Center', '5', 'Canada', 'S1F1S1', 'dheggesoz@senate.gov'),
('6981383392213254', 'DISCOVER', '589', 12, 2018, '50547 Veith Avenue', '33619', 'Canada', 'X3A6Y3', 'tdicarlir0@artisteer.com'),
('6991476740099503', 'VISA', '326', 9, 2020, '91920 Lien Drive', '551', 'Canada', 'R7F5Z0', 'mahmad9x@reuters.com'),
('6998561778119776', 'VISA', '430', 2, 2018, '10226 Darwin Street', '1', 'United States', '64877', 'ttuma69@addtoany.com'),
('7031860174216276', 'MC', '275', 8, 2022, '75192 Ludington Avenue', '17', 'United States', '32542', 'preddickfv@cdbaby.com'),
('703738693780589', 'AMEX', '0337', 12, 2022, '6631 Johnson Street', '9886', 'Canada', 'D9Q0N6', 'mchant2v@nbcnews.com'),
('703863307992818', 'AMEX', '4696', 3, 2023, '8 Clove Avenue', '6117', 'Canada', 'G4N1N9', 'lsarlelf@photobucket.com'),
('7041882892521864', 'DISCOVER', '572', 7, 2019, '1633 Gerald Circle', '2916', 'Canada', 'F3R1I1', 'mmcalroyhu@drupal.org'),
('704236689572424', 'AMEX', '4103', 1, 2020, '7154 American Terrace', '82', 'United States', '17580', 'tdavidsenbt@behance.net'),
('7050566047254420', 'MC', '726', 12, 2020, '1772 Fairfield Point', '04966', 'Canada', 'I1N6L0', 'skelshawdr@goo.ne.jp'),
('7095386293363929', 'MC', '222', 9, 2019, '9513 Esch Avenue', '768', 'United States', '15449', 'rgrimme1s@amazonaws.com'),
('7099747348821848', 'VISA', '150', 11, 2023, '10 Kenwood Point', '0', 'United States', '68092', 'jnice26@friendfeed.com'),
('7107488364353101', 'MC', '299', 10, 2023, '04 Dapin Center', '62388', 'Canada', 'F6W0G4', 'adenholm4@e-recht24.de'),
('7108341281655597', 'VISA', '686', 3, 2019, '31872 Wayridge Point', '401', 'United States', '58782', 'aboxellgy@skyrock.com'),
('710844167433068', 'AMEX', '7144', 8, 2018, '89 Melrose Hill', '517', 'Canada', 'M3E7E4', 'siianon25@hugedomains.com'),
('710889683228269', 'AMEX', '9383', 9, 2021, '7 Transport Plaza', '2104', 'Canada', 'J8R2U6', 'rvalentingi@census.gov'),
('7121380573926782', 'MC', '206', 11, 2022, '52 Schmedeman Center', '6114', 'Canada', 'J5W6I8', 'hconnoldj@ycombinator.com'),
('7131038026772559', 'VISA', '661', 4, 2021, '3 Pankratz Terrace', '1625', 'United States', '63095', 'eswornhy@sitemeter.com'),
('7133930631688108', 'DISCOVER', '488', 10, 2018, '985 Dahle Terrace', '2354', 'Canada', 'R6T2C5', 'rchallacec3@simplemachines.org'),
('7161384527097894', 'DISCOVER', '920', 3, 2021, '5976 Anhalt Trail', '83', 'Canada', 'E2M6A9', 'mhaddickqq@macromedia.com'),
('7211865946897155', 'VISA', '513', 9, 2024, '1 Beilfuss Terrace', '41', 'United States', '81112', 'fforshaw5e@hp.com'),
('7212643669663645', 'MC', '673', 7, 2022, '144 Loeprich Park', '87582', 'United States', '43123', 'cgoodgeo6@adobe.com'),
('7225426576285329', 'VISA', '916', 4, 2024, '62222 Namekagon Road', '258', 'Canada', 'Q1N2F5', 'mbollam7y@typepad.com'),
('7226513520791610', 'VISA', '420', 7, 2018, '816 Banding Junction', '50', 'United States', '23482', 'emcveighf4@bloglovin.com'),
('722743143909884', 'AMEX', '7966', 10, 2020, '16 Burning Wood Court', '592', 'Canada', 'F3H2R6', 'dbezemerez@youku.com'),
('724335374765782', 'AMEX', '1051', 4, 2020, '38 Warrior Court', '98711', 'United States', '63095', 'nbaumanbh@imdb.com'),
('7243632644111889', 'DISCOVER', '181', 4, 2022, '53877 Wayridge Pass', '87716', 'Canada', 'C4M3Y3', 'lbattabeew@photobucket.com'),
('7250060645618467', 'MC', '515', 3, 2021, '7 Golden Leaf Crossing', '043', 'United States', '56403', 'ecaig3o@craigslist.org'),
('7275119288365531', 'VISA', '905', 2, 2020, '98 Tomscot Hill', '90', 'United States', '86362', 'selmanh@sogou.com'),
('7281398707634112', 'MC', '385', 10, 2021, '2687 Kings Circle', '5880', 'Canada', 'S1F1S1', 'kdasenthh@wufoo.com'),
('728975411900210', 'AMEX', '5618', 12, 2019, '8 Westend Trail', '68', 'United States', '38339', 'mdecarlok3@barnesandnoble.com'),
('7314762884324306', 'VISA', '824', 4, 2021, '2687 Kings Circle', '5880', 'Canada', 'S1F1S1', 'rgoddardgs@sciencedaily.com'),
('732732985601688', 'AMEX', '8212', 5, 2020, '29134 Corben Parkway', '53313', 'United States', '64288', 'nfantone2x@comsenz.com'),
('7333200057959605', 'DISCOVER', '327', 8, 2018, '46929 Merchant Point', '97125', 'Canada', 'X6G9Q1', 'smcarda3@instagram.com'),
('7345380198804112', 'VISA', '847', 6, 2022, '4 Fairfield Crossing', '09', 'Canada', 'D8B2B8', 'ritzkovwichhq@pcworld.com'),
('735599483882619', 'AMEX', '5199', 4, 2022, '5 Spohn Avenue', '48', 'United States', '59737', 'tpullinqk@newyorker.com'),
('7364935886176746', 'VISA', '633', 8, 2022, '3058 Anzinger Drive', '84', 'Canada', 'P3X6R3', 'nbillyardy@bloglovin.com'),
('7373434034080231', 'MC', '438', 3, 2024, '530 Pennsylvania Road', '78332', 'United States', '33783', 'fforshaw5e@hp.com'),
('7415118955768647', 'MC', '899', 1, 2022, '64618 Alpine Plaza', '4', 'United States', '86900', 'japfler3a@wunderground.com'),
('7424930932419485', 'VISA', '921', 10, 2020, '9 Dakota Trail', '4972', 'Canada', 'M7H8I9', 'dberref@bbc.co.uk'),
('7436646513941876', 'VISA', '069', 5, 2020, '1 Sherman Parkway', '1467', 'United States', '23104', 'mramalho9u@squarespace.com'),
('745458126161197', 'AMEX', '6736', 7, 2023, '551 Daystar Point', '85', 'Canada', 'D1L8A6', 'hpieter9@woothemes.com'),
('7457583638488262', 'DISCOVER', '474', 11, 2019, '83 Delladonna Circle', '1', 'United States', '33115', 'apach7m@hud.gov'),
('7474981840723015', 'VISA', '275', 12, 2024, '950 Northridge Way', '209', 'Canada', 'F7C7A2', 'aoxfordd3@bigcartel.com'),
('7505226272773114', 'MC', '151', 7, 2018, '6 Briar Crest Parkway', '80923', 'Canada', 'K4Z9W9', 'dbezemerez@youku.com'),
('7543553540867379', 'DISCOVER', '724', 12, 2018, '744 Dovetail Way', '654', 'United States', '50359', 'bvaskovfq@pagesperso-orange.fr'),
('7553374324330116', 'DISCOVER', '834', 2, 2024, '3 Lien Drive', '4', 'Canada', 'J9O2C9', 'ylancasterqz@yale.edu'),
('756293112261641', 'AMEX', '7226', 8, 2022, '38 Lotheville Plaza', '36', 'Canada', 'T5G2F9', 'tmoverley2c@geocities.com'),
('7573258637200892', 'VISA', '623', 12, 2019, '224 Schlimgen Center', '14', 'Canada', 'K4Z9W9', 'dpeppard31@barnesandnoble.com'),
('7591411137448339', 'MC', '288', 8, 2021, '59 Hooker Avenue', '84', 'Canada', 'M9Z3I5', 'amiddiff6t@paypal.com'),
('760199024710609', 'AMEX', '1658', 10, 2023, '29553 Anthes Junction', '443', 'United States', '50847', 'kdommersennl@home.pl'),
('7603796258922603', 'MC', '342', 5, 2022, '7700 Kedzie Point', '90286', 'Canada', 'P5G0C2', 'btempletonio@dailymotion.com'),
('760752440608929', 'AMEX', '2135', 2, 2023, '04 Mccormick Park', '54', 'Canada', 'O1L2K7', 'ltrudgeonp1@rediff.com'),
('761153525168495', 'AMEX', '5793', 11, 2024, '0 Saint Paul Drive', '82361', 'Canada', 'I8Z4I8', 'hdalgleish6m@theglobeandmail.com'),
('7626071756934399', 'MC', '373', 4, 2022, '5 Linden Parkway', '2543', 'United States', '33783', 'rconingif@phoca.cz'),
('7629852025765676', 'DISCOVER', '740', 7, 2020, '75358 Oxford Place', '9', 'United States', '44890', 'jdene44@wired.com'),
('7638475556829176', 'MC', '908', 8, 2020, '73 Melvin Place', '27143', 'Canada', 'T8O1E6', 'kjersonig@wix.com'),
('7639417999753407', 'DISCOVER', '799', 10, 2024, '44651 La Follette Pass', '67', 'United States', '96546', 'lmurneymp@diigo.com'),
('7646940758226294', 'VISA', '931', 11, 2018, '32805 Park Meadow Crossing', '78173', 'Canada', 'Q3P1R6', 'kgibkemj@ucoz.ru'),
('7661649169871285', 'MC', '411', 5, 2019, '7 Carpenter Street', '7', 'Canada', 'K1Z6L8', 'kwinscom4k@icq.com'),
('7681699952804392', 'VISA', '472', 11, 2024, '9 Waywood Point', '5', 'United States', '62244', 'cdinsalekt@myspace.com'),
('7691895736553529', 'MC', '709', 12, 2024, '998 Rockefeller Terrace', '18559', 'Canada', 'P3X6R3', 'pmckimmqm@rediff.com'),
('7697901354840248', 'VISA', '203', 12, 2018, '0 Canary Way', '16412', 'Canada', 'H6C8G6', 'abrimblecomben3@pinterest.com'),
('771282127130784', 'AMEX', '6349', 4, 2022, '07 Meadow Valley Lane', '771', 'United States', '18164', 'lwalderai7@ovh.net'),
('7734510082018973', 'MC', '270', 3, 2019, '281 Armistice Place', '0172', 'Canada', 'J9O2C9', 'mhousecrafto2@g.co'),
('774262597564675', 'AMEX', '5412', 3, 2022, '9778 Springview Way', '8', 'Canada', 'W6D3B8', 'jsterndaleju@fastcompany.com'),
('774487568178305', 'AMEX', '1291', 1, 2020, '4226 Maywood Lane', '39', 'United States', '28705', 'jclougherle@bravesites.com'),
('774694088288738', 'AMEX', '3827', 9, 2021, '9 Sycamore Park', '40', 'Canada', 'Y0H4F3', 'bdallman93@fc2.com'),
('7750948842183115', 'DISCOVER', '019', 12, 2023, '89959 Cordelia Pass', '775', 'Canada', 'U8T3M1', 'eagaroc@forbes.com'),
('7757892958800732', 'MC', '823', 5, 2023, '70 Mitchell Place', '79601', 'Canada', 'Y0J4P7', 'nworman5k@abc.net.au'),
('7759114821628640', 'VISA', '587', 12, 2021, '0691 Judy Terrace', '9', 'Canada', 'R0R8S6', 'rmaloneybg@jugem.jp'),
('7762063718827367', 'MC', '902', 7, 2023, '24 Independence Junction', '304', 'United States', '68092', 'vvallantine0@java.com'),
('7772867286476852', 'DISCOVER', '680', 10, 2018, '48 Debs Park', '250', 'Canada', 'Y6G8G7', 'ritzkovwichhq@pcworld.com'),
('778470838485954', 'AMEX', '5528', 12, 2024, '28 Haas Crossing', '6', 'United States', '28127', 'agritskovmd@soundcloud.com'),
('7785401983751713', 'VISA', '493', 3, 2018, '08 Truax Place', '3177', 'Canada', 'Z6T1W7', 'apach7m@hud.gov'),
('7785732628028768', 'MC', '489', 3, 2021, '7700 Kedzie Point', '90286', 'Canada', 'P5G0C2', 'bmccreery47@cloudflare.com'),
('778600445708739', 'AMEX', '7056', 10, 2018, '78 Ridge Oak Terrace', '368', 'United States', '64009', 'smalkini3@yellowbook.com'),
('7786139604171525', 'VISA', '231', 10, 2021, '435 Hanover Terrace', '5444', 'Canada', 'D9N7Z9', 'dephgravebu@psu.edu'),
('7805221878978064', 'VISA', '003', 4, 2022, '0226 Petterle Hill', '11', 'Canada', 'X3Q8Z6', 'dmarguerite86@paginegialle.it'),
('780819124575274', 'AMEX', '3717', 1, 2018, '06881 Eastwood Court', '60162', 'Canada', 'Y1L4R2', 'acasselykx@webmd.com'),
('782242170366071', 'AMEX', '9402', 11, 2021, '76003 Monterey Terrace', '0596', 'Canada', 'K1Z8A2', 'bmeneelyc8@miibeian.gov.cn'),
('7859551467763360', 'VISA', '902', 1, 2023, '90 Lakewood Gardens Point', '687', 'United States', '62244', 'glearmouthu@wordpress.org'),
('7874390628090607', 'VISA', '649', 8, 2021, '75420 Doe Crossing Street', '310', 'United States', '20458', 'swhilderit@qq.com'),
('7878153814693800', 'MC', '768', 5, 2022, '512 Mariners Cove Drive', '2', 'United States', '36100', 'achessman1b@census.gov'),
('7889058731456746', 'VISA', '252', 2, 2024, '11057 Fairfield Parkway', '167', 'Canada', 'J7Y6O1', 'ylancasterqz@yale.edu'),
('7896935763629244', 'MC', '640', 10, 2018, '0 Reindahl Park', '0883', 'United States', '11622', 'avasyukov5@slate.com'),
('7911755241325297', 'VISA', '768', 8, 2019, '76 Claremont Alley', '42', 'United States', '66847', 'lsapshedlj@wikispaces.com'),
('791633067455374', 'AMEX', '8613', 11, 2024, '3 Myrtle Trail', '7871', 'Canada', 'J5Z0F4', 'zjinkinou@sogou.com'),
('7929320895836913', 'VISA', '106', 3, 2018, '94172 Bunting Pass', '0', 'United States', '62244', 'mhuettcd@theatlantic.com'),
('7941013148878917', 'MC', '646', 4, 2019, '645 Luster Crossing', '7277', 'United States', '65218', 'lbattabeew@photobucket.com'),
('7945570998203853', 'VISA', '894', 9, 2022, '28 Havey Way', '1', 'United States', '63498', 'jortigercv@miitbeian.gov.cn'),
('7950089946964266', 'DISCOVER', '252', 11, 2020, '04 Kingsford Hill', '7886', 'Canada', 'O2A5G4', 'rvalentingi@census.gov'),
('7951257094716190', 'VISA', '697', 3, 2023, '30 Hayes Park', '2', 'Canada', 'G7F6D2', 'apackwoodoy@t.co');
INSERT INTO `paymentinformation` (`card_num`, `card_type`, `cvv`, `expiry_month`, `expiry_year`, `street_address`, `unit_number`, `country`, `postal_code`, `user_email`) VALUES
('796825050606038', 'AMEX', '4820', 10, 2023, '0 Carpenter Center', '487', 'Canada', 'J3D2J3', 'sweatherdon18@tripadvisor.com'),
('7981545674493848', 'VISA', '524', 11, 2022, '78 Michigan Avenue', '8', 'United States', '78826', 'dransburyby@slashdot.org'),
('8027037351212186', 'DISCOVER', '860', 2, 2022, '19140 Veith Alley', '393', 'United States', '94576', 'dlageml@sun.com'),
('8029543569524669', 'DISCOVER', '175', 7, 2018, '8 Pond Crossing', '5473', 'United States', '81958', 'lattwool87@tiny.cc'),
('8036027387877775', 'MC', '885', 9, 2020, '9176 Messerschmidt Parkway', '9', 'Canada', 'W2U8D9', 'imarkosed@china.com.cn'),
('803965605936218', 'AMEX', '8261', 5, 2020, '1 Lighthouse Bay Avenue', '4700', 'Canada', 'U5S4C4', 'ctrundlergr@deliciousdays.com'),
('804218274938535', 'AMEX', '3952', 4, 2022, '4 Holmberg Circle', '8', 'Canada', 'A7B2R7', 'zllorensn5@thetimes.co.uk'),
('8056250340238459', 'VISA', '210', 12, 2021, '96428 Morrow Plaza', '8', 'United States', '30542', 'emanaghfs@i2i.jp'),
('8065827038101990', 'VISA', '633', 1, 2020, '41653 Upham Way', '9', 'United States', '18164', 'garchanbaultc2@yelp.com'),
('808196262843445', 'AMEX', '3043', 3, 2020, '9415 Kennedy Trail', '5', 'Canada', 'M3L1W6', 'khallgalleyfy@free.fr'),
('8094813299151274', 'DISCOVER', '568', 12, 2023, '676 Waubesa Crossing', '0222', 'Canada', 'J6L9S2', 'hohenerym2@reverbnation.com'),
('8100756788033028', 'DISCOVER', '463', 3, 2019, '9783 Victoria Way', '7', 'Canada', 'Q3P1R6', 'ssouthwood71@weebly.com'),
('810175198875025', 'AMEX', '1341', 11, 2020, '00025 Charing Cross Hill', '433', 'Canada', 'R6R1Y9', 'pgraysmark5b@japanpost.jp'),
('8131198738261976', 'DISCOVER', '330', 1, 2018, '983 Morningstar Trail', '440', 'United States', '23290', 'gryvesjt@state.gov'),
('8139880273836998', 'DISCOVER', '479', 10, 2024, '2 Petterle Parkway', '5372', 'Canada', 'D7M6R9', 'jkneale98@taobao.com'),
('814825291794923', 'AMEX', '0503', 11, 2021, '59 Sullivan Point', '7', 'Canada', 'R8W0K1', 'ceusteslx@dell.com'),
('8162984089124650', 'MC', '503', 1, 2024, '8164 Westridge Hill', '15', 'United States', '23104', 'esimes58@slideshare.net'),
('816466240578808', 'AMEX', '8549', 9, 2021, '44 Dahle Road', '65', 'Canada', 'J5Z0F4', 'lmorsley1v@histats.com'),
('8168585835214195', 'DISCOVER', '120', 1, 2024, '9 Fairfield Hill', '9', 'United States', '93385', 'gnafzigerg2@mashable.com'),
('8181193477874835', 'MC', '740', 6, 2020, '54 Pawling Trail', '13', 'Canada', 'R1L8S7', 'wtaylour3p@yellowpages.com'),
('8209759001415148', 'DISCOVER', '851', 4, 2023, '0 Sachtjen Place', '9091', 'Canada', 'J8R2U6', 'vschwandermannfe@rambler.ru'),
('8219047868601650', 'VISA', '416', 4, 2021, '9335 Division Way', '5951', 'Canada', 'T9F7W2', 'aklimmek13@umich.edu'),
('8222237588355985', 'MC', '186', 2, 2020, '57 Sunbrook Street', '62', 'Canada', 'Z0T8F1', 'imagowan3b@yolasite.com'),
('824178080963593', 'AMEX', '9339', 11, 2024, '646 Lighthouse Bay Drive', '85861', 'Canada', 'T5G2F9', 'aklimmek13@umich.edu'),
('8250577384489871', 'VISA', '124', 12, 2023, '5 Kim Center', '3722', 'Canada', 'Y3C3O9', 'kshotboultei4@msn.com'),
('8252115089168966', 'VISA', '384', 5, 2021, '228 Cambridge Hill', '4561', 'Canada', 'Q9B3H1', 'pheggmz@storify.com'),
('8261062068351284', 'DISCOVER', '672', 8, 2019, '67753 Longview Lane', '949', 'Canada', 'Y6G8G7', 'nwreakesd8@sourceforge.net'),
('8272252465563212', 'DISCOVER', '364', 5, 2019, '09 Grayhawk Park', '317', 'United States', '75715', 'ckunkelrp@noaa.gov'),
('8288308325186201', 'VISA', '611', 1, 2023, '9 Lakewood Gardens Terrace', '7710', 'Canada', 'T8O1E6', 'claweles88@tmall.com'),
('8301654936958581', 'MC', '834', 3, 2018, '23088 Kedzie Circle', '7', 'Canada', 'K3C2N2', 'obridalh7@instagram.com'),
('8311974439201047', 'MC', '337', 2, 2019, '1 Superior Park', '85', 'United States', '85861', 'cgoolding4r@mlb.com'),
('832852302724849', 'AMEX', '8872', 2, 2021, '5 Sloan Road', '4471', 'United States', '29021', 'jbutterfill6c@mail.ru'),
('8344865894200504', 'MC', '849', 5, 2021, '67021 Kipling Junction', '061', 'United States', '50359', 'skelshawdr@goo.ne.jp'),
('8348098797385460', 'VISA', '045', 10, 2018, '1927 Mariners Cove Crossing', '48', 'United States', '36209', 'ajelksic@huffingtonpost.com'),
('8350513419139635', 'DISCOVER', '327', 9, 2020, '08 Truax Place', '3177', 'Canada', 'Z6T1W7', 'mstannett6g@webnode.com'),
('8358646646555058', 'MC', '706', 7, 2023, '24885 Golf View Place', '767', 'United States', '82176', 'smalkini3@yellowbook.com'),
('836224943404808', 'AMEX', '4916', 11, 2019, '5 Colorado Hill', '8761', 'United States', '79888', 'cmirfieldqg@yellowpages.com'),
('8370134266789649', 'VISA', '741', 9, 2021, '69710 Hansons Drive', '877', 'United States', '31667', 'rvaseydy@facebook.com'),
('8375889083704525', 'VISA', '403', 5, 2024, '11 Brown Road', '9', 'Canada', 'K1Z8A2', 'gonionl3@yellowbook.com'),
('8375991673301325', 'MC', '990', 9, 2020, '5 Butterfield Lane', '937', 'Canada', 'K1Z8A2', 'ttuma69@addtoany.com'),
('8378360219765197', 'MC', '021', 9, 2019, '23120 Hayes Drive', '5', 'Canada', 'R1L8S7', 'iclaesens8k@jimdo.com'),
('8382805009448046', 'DISCOVER', '305', 5, 2022, '8 Pond Crossing', '5473', 'United States', '81958', 'dholdforthmv@163.com'),
('838445079359023', 'AMEX', '2313', 1, 2018, '4152 Weeping Birch Trail', '2', 'Canada', 'T9F7W2', 'nconlonpv@dell.com'),
('838615795741365', 'AMEX', '0832', 1, 2021, '69 Farwell Point', '517', 'Canada', 'B3A6R5', 'mbordissqd@cbsnews.com'),
('8415979068464307', 'DISCOVER', '030', 9, 2023, '1473 Sommers Hill', '7011', 'Canada', 'I3W3K6', 'rlabror3@abc.net.au'),
('8418364191719797', 'MC', '323', 9, 2020, '01 Meadow Ridge Avenue', '5617', 'Canada', 'X9G4S1', 'dmawhinneyp@dagondesign.com'),
('8427675008142810', 'DISCOVER', '761', 1, 2022, '0 Carpenter Center', '487', 'Canada', 'J3D2J3', 'mgartelloq@irs.gov'),
('843410731525636', 'AMEX', '2170', 9, 2024, '76003 Monterey Terrace', '0596', 'Canada', 'K1Z8A2', 'nalekseicikp7@godaddy.com'),
('8440126413475382', 'DISCOVER', '287', 1, 2018, '9763 Weeping Birch Center', '7', 'United States', '11423', 'mkobpand@dedecms.com'),
('8448651666751697', 'VISA', '155', 12, 2020, '42 Gateway Park', '184', 'United States', '12801', 'gtowsonai@ca.gov'),
('8456511268713872', 'MC', '960', 1, 2018, '2 Havey Park', '664', 'United States', '36427', 'acruess6w@addtoany.com'),
('8487279778178449', 'DISCOVER', '046', 6, 2024, '78 Sommers Street', '8', 'Canada', 'O1H1W9', 'trosenfelderlu@drupal.org'),
('8488582170559412', 'DISCOVER', '406', 10, 2022, '5 Chinook Center', '0', 'Canada', 'Q9B3H1', 'adovingtonlo@cyberchimps.com'),
('8514893109849147', 'DISCOVER', '746', 3, 2018, '438 Lukken Point', '108', 'United States', '33324', 'aoxfordd3@bigcartel.com'),
('8521492629218406', 'MC', '117', 12, 2021, '688 Maple Crossing', '2109', 'United States', '27632', 'prainsburybc@epa.gov'),
('8548543490014155', 'MC', '123', 4, 2019, '4 David Hill', '839', 'United States', '43123', 'nbaumanbh@imdb.com'),
('8558374715338013', 'DISCOVER', '264', 10, 2021, '107 Prentice Center', '93943', 'Canada', 'A1N6I6', 'fmeddemmen67@oracle.com'),
('8558694962559095', 'MC', '701', 12, 2023, '3 Blue Bill Park Street', '5', 'Canada', 'U1I2O9', 'jforestallkm@eventbrite.com'),
('8562844242678734', 'MC', '508', 1, 2019, '71 Russell Pass', '824', 'Canada', 'Q9I5U6', 'grampley1y@360.cn'),
('857677557350328', 'AMEX', '9747', 11, 2021, '26 Mayer Street', '0493', 'Canada', 'B4U9M0', 'nwreakesd8@sourceforge.net'),
('8601690572983140', 'MC', '784', 4, 2022, '7022 Canary Trail', '913', 'Canada', 'M1N6T4', 'rnajera3c@google.es'),
('8624876552097245', 'VISA', '756', 5, 2019, '08368 Redwing Center', '18', 'United States', '27632', 'jcopcuttgp@sciencedaily.com'),
('8639991681796020', 'DISCOVER', '660', 8, 2018, '2 Red Cloud Lane', '18', 'United States', '51688', 'igoaks9w@hexun.com'),
('864073194194072', 'AMEX', '8628', 12, 2019, '914 Porter Park', '785', 'Canada', 'U5H8D4', 'nwoolvinhp@1688.com'),
('8647192986533004', 'DISCOVER', '065', 5, 2018, '055 Homewood Terrace', '3', 'Canada', 'F9Q9S0', 'clongmanal@admin.ch'),
('8647631378632999', 'DISCOVER', '491', 9, 2020, '9761 Dawn Point', '2', 'Canada', 'U2O7F2', 'bhalson5r@indiatimes.com'),
('8648746784539168', 'VISA', '311', 2, 2024, '64618 Alpine Plaza', '4', 'United States', '86900', 'bdanaherag@is.gd'),
('865192736326052', 'AMEX', '9447', 12, 2020, '52 Schmedeman Center', '6114', 'Canada', 'J5W6I8', 'amiellrm@newsvine.com'),
('8672955460768136', 'DISCOVER', '202', 9, 2019, '372 Gateway Center', '05246', 'United States', '64914', 'rambrozkv@php.net'),
('867631003698716', 'AMEX', '4363', 4, 2020, '19 School Crossing', '97', 'United States', '10230', 'pbearnr1@cnet.com'),
('8679140316784305', 'MC', '085', 9, 2018, '8569 Sachtjen Hill', '292', 'Canada', 'X0W5C2', 'hpieter9@woothemes.com'),
('8705680956302000', 'VISA', '546', 7, 2019, '008 Arrowood Way', '4', 'United States', '78826', 'mmabeyq9@umn.edu'),
('8719671666455440', 'VISA', '615', 6, 2024, '42187 Fisk Point', '0901', 'Canada', 'F3H2R6', 'cferryja@hp.com'),
('8724805879909869', 'MC', '506', 3, 2023, '60770 Sommers Drive', '4949', 'United States', '95234', 'tbourdisaz@mediafire.com'),
('8744325342785470', 'VISA', '972', 6, 2023, '81 Pawling Plaza', '95365', 'United States', '51688', 'lcoleydi@patch.com'),
('8767862273031028', 'DISCOVER', '775', 11, 2023, '9772 Heath Street', '15', 'Canada', 'U5S4C4', 'ubooirk@twitter.com'),
('8789449272329092', 'DISCOVER', '309', 3, 2019, '04 Dapin Center', '62388', 'Canada', 'F6W0G4', 'rfosserd60@newyorker.com'),
('879474943841409', 'AMEX', '2319', 4, 2019, '176 Laurel Road', '7658', 'United States', '23482', 'hsherratt2o@google.nl'),
('880556820427237', 'AMEX', '2788', 7, 2019, '2722 East Junction', '11941', 'United States', '71293', 'btromansfk@google.co.jp'),
('8812762692616137', 'VISA', '824', 4, 2019, '627 Homewood Court', '2', 'United States', '44890', 'bnewsteadfi@creativecommons.org'),
('881437772681760', 'AMEX', '8219', 2, 2023, '45 Shopko Street', '9918', 'United States', '15751', 'tsimecekls@slideshare.net'),
('882855234436043', 'AMEX', '9226', 5, 2022, '5250 Eliot Drive', '9', 'United States', '10986', 'soxfordp3@imgur.com'),
('8836443236413936', 'MC', '958', 3, 2020, '8565 Mayer Terrace', '7', 'United States', '54352', 'dquogancy@wsj.com'),
('8847974813162262', 'DISCOVER', '557', 9, 2022, '27 Grayhawk Circle', '6', 'United States', '94576', 'swoodwindcn@yale.edu'),
('885378542208884', 'AMEX', '0371', 6, 2022, '73 Farragut Street', '41063', 'United States', '98166', 'kbriars8i@t-online.de'),
('886191476212801', 'AMEX', '9424', 6, 2021, '5 Golf View Junction', '72', 'United States', '34106', 'wchaplyn8v@webmd.com'),
('8900995557546060', 'MC', '897', 7, 2019, '41364 Garrison Alley', '295', 'Canada', 'S1Y2Z5', 'bcasirolias@howstuffworks.com'),
('8908857048992840', 'DISCOVER', '904', 5, 2024, '71 Clyde Gallagher Drive', '2', 'United States', '71718', 'eparsell6u@squarespace.com'),
('8910922593429329', 'MC', '056', 3, 2023, '34 Melby Point', '67', 'Canada', 'Y0H4F3', 'agabeyc4@google.ru'),
('8912828099400761', 'DISCOVER', '661', 4, 2023, '82167 Maryland Hill', '8', 'Canada', 'N4B1L2', 'ckyne2s@yahoo.com'),
('8922502420079069', 'MC', '894', 12, 2020, '4467 Duke Parkway', '9', 'Canada', 'R7F5Z0', 'kbowsheres@imdb.com'),
('8926437571154566', 'DISCOVER', '600', 5, 2018, '04 Kingsford Hill', '7886', 'Canada', 'O2A5G4', 'dgodilington4c@nationalgeographic.com'),
('8939753242344771', 'DISCOVER', '947', 12, 2019, '397 Pond Hill', '01772', 'Canada', 'C4S7B0', 'cnewislt@constantcontact.com'),
('8940665151836336', 'MC', '918', 1, 2018, '07396 Prairieview Place', '1896', 'Canada', 'Q5Y0T4', 'ahefferfz@amazon.com'),
('8943496697314998', 'VISA', '353', 12, 2024, '2286 Paget Place', '18', 'United States', '86900', 'swillmore7g@hud.gov'),
('8949630305894820', 'DISCOVER', '636', 4, 2020, '3 Donald Park', '04', 'Canada', 'Y2N9B0', 'lcoleydi@patch.com'),
('897458090531830', 'AMEX', '4333', 3, 2024, '15165 Division Lane', '11833', 'Canada', 'R6R1Y9', 'aabilowitzak@last.fm'),
('898595037458036', 'AMEX', '9019', 9, 2019, '46 Chinook Park', '0', 'United States', '12796', 'lsarlelf@photobucket.com'),
('901719700580600', 'AMEX', '0545', 6, 2018, '46257 Red Cloud Pass', '5', 'United States', '80530', 'elabrom3z@vinaora.com'),
('9017760450741203', 'MC', '056', 4, 2019, '176 Laurel Road', '7658', 'United States', '23482', 'dsharperiw@list-manage.com'),
('9030288669860068', 'MC', '843', 12, 2021, '0993 Killdeer Trail', '264', 'United States', '98166', 'mgoodbody16@sphinn.com'),
('9056419531571869', 'VISA', '987', 5, 2019, '70382 Boyd Court', '09050', 'Canada', 'T5G2F9', 'akobesgq@opensource.org'),
('9071278128017420', 'VISA', '326', 12, 2024, '18904 Larry Crossing', '4629', 'Canada', 'G3U2J7', 'ckunkelrp@noaa.gov'),
('9075963150537618', 'VISA', '211', 9, 2018, '91606 Twin Pines Parkway', '343', 'United States', '39807', 'gcorcoran83@opensource.org'),
('9093862879833214', 'MC', '501', 6, 2022, '392 Vernon Trail', '57', 'Canada', 'P3X6R3', 'pwildgoose8e@storify.com'),
('9122089728715632', 'MC', '377', 1, 2018, '4 Maple Parkway', '298', 'Canada', 'Z8U9G8', 'sbrashiernj@ftc.gov'),
('9144669897670300', 'DISCOVER', '757', 7, 2020, '54 Blackbird Parkway', '9', 'United States', '10180', 'mnellisql@github.io'),
('915418042733778', 'AMEX', '0743', 1, 2023, '8442 8th Park', '4963', 'United States', '34106', 'akeepeeq@jigsy.com'),
('915617893014562', 'AMEX', '6438', 4, 2022, '501 Elgar Park', '05', 'Canada', 'X9G4S1', 'seisoldk2@dagondesign.com'),
('9156826489503378', 'VISA', '479', 2, 2022, '20 Eagle Crest Road', '7', 'Canada', 'F9Q9S0', 'bholdworthz@sciencedirect.com'),
('9172123581053946', 'MC', '526', 5, 2022, '28267 Namekagon Way', '438', 'United States', '10986', 'tdurn73@cargocollective.com'),
('9193795352853498', 'VISA', '639', 3, 2021, '5 Golf View Junction', '72', 'United States', '34106', 'garchanbaultc2@yelp.com'),
('9196565255911179', 'MC', '801', 1, 2021, '257 Brentwood Junction', '02', 'United States', '12616', 'luphamck@xinhuanet.com'),
('9197756424256535', 'DISCOVER', '417', 2, 2018, '85 Montana Terrace', '6291', 'United States', '34964', 'mshimmin9l@plala.or.jp'),
('9201870561257613', 'MC', '842', 9, 2018, '83 Vernon Drive', '2101', 'Canada', 'M1N6T4', 'aennewqo@tinyurl.com'),
('9227817168331609', 'VISA', '254', 9, 2023, '816 Banding Junction', '50', 'United States', '23482', 'colley8r@upenn.edu'),
('9235362348794261', 'MC', '616', 2, 2023, '4670 Service Circle', '25282', 'United States', '17580', 'cgoodgeo6@adobe.com'),
('924473183147013', 'AMEX', '1590', 8, 2024, '49 Pearson Street', '50377', 'United States', '49812', 'amcleoidpg@oakley.com'),
('9245195757119139', 'DISCOVER', '472', 3, 2019, '5 Tennyson Place', '7', 'United States', '97923', 'mlourens7j@t-online.de'),
('9250919912089507', 'DISCOVER', '265', 4, 2023, '223 Onsgard Parkway', '1', 'United States', '23290', 'kleifer81@wiley.com'),
('928046278889438', 'AMEX', '8993', 11, 2024, '0202 Orin Point', '5', 'United States', '47656', 'imarkosed@china.com.cn'),
('9293075958321627', 'VISA', '813', 6, 2022, '2677 Anzinger Center', '7', 'United States', '60174', 'jcollecottmx@webs.com'),
('9295646176916698', 'DISCOVER', '054', 7, 2021, '1782 Red Cloud Place', '40', 'United States', '60174', 'bdanaherag@is.gd'),
('9305435602500961', 'MC', '120', 3, 2024, '808 Lindbergh Lane', '3671', 'United States', '64914', 'hpietsmap0@google.com.hk'),
('9311352365310895', 'VISA', '402', 9, 2018, '144 Loeprich Park', '87582', 'United States', '43123', 'wtaylour3p@yellowpages.com'),
('9319100645608291', 'VISA', '596', 11, 2018, '9763 Weeping Birch Center', '7', 'United States', '11423', 'ltrudgeonp1@rediff.com'),
('9327934269720666', 'DISCOVER', '358', 2, 2023, '77904 Bowman Road', '90', 'United States', '93616', 'mdedneycj@theguardian.com'),
('933764961053999', 'AMEX', '9516', 7, 2020, '079 Tennyson Center', '7', 'United States', '49654', 'hstoakescm@zdnet.com'),
('9361371973631116', 'VISA', '223', 10, 2021, '27 Grayhawk Circle', '6', 'United States', '94576', 'frydzynskigm@archive.org'),
('9365043313771006', 'VISA', '419', 2, 2022, '61 Warbler Alley', '81483', 'Canada', 'Q9B3H1', 'cmettrickbo@domainmarket.com'),
('9373813940639256', 'VISA', '236', 9, 2023, '0284 Dwight Plaza', '05600', 'United States', '10180', 'lniaves6y@de.vu'),
('937398971047907', 'AMEX', '8180', 7, 2022, '9783 Victoria Way', '7', 'Canada', 'Q3P1R6', 'fcampion2k@unesco.org'),
('9377914394379231', 'MC', '252', 1, 2018, '9 Dakota Trail', '4972', 'Canada', 'M7H8I9', 'bchapellowiu@etsy.com'),
('938082555487674', 'AMEX', '3173', 5, 2019, '4 Banding Point', '593', 'Canada', 'Y2N9B0', 'jglowach6n@google.ru'),
('9386274320482546', 'MC', '814', 3, 2021, '2 Basil Way', '9', 'Canada', 'D7I5Y6', 'cedwardsot@salon.com'),
('9407932310311293', 'VISA', '862', 7, 2018, '09158 Mandrake Way', '174', 'United States', '51618', 'rbabonf8@sogou.com'),
('941261685908471', 'AMEX', '5015', 4, 2023, '60614 Everett Center', '5058', 'Canada', 'E7G4Y7', 'arawsen55@upenn.edu'),
('9422242854458266', 'VISA', '979', 8, 2021, '47124 Thackeray Trail', '1', 'United States', '23104', 'sdowsey40@sfgate.com'),
('943337967369280', 'AMEX', '3016', 2, 2018, '78228 Ridge Oak Circle', '61886', 'United States', '44220', 'emullallyq1@msu.edu'),
('9434956596365040', 'DISCOVER', '987', 4, 2020, '81 Bay Crossing', '43', 'Canada', 'X3C0M9', 'mcarteran@jimdo.com'),
('9456384173214266', 'VISA', '352', 12, 2018, '358 Atwood Junction', '9986', 'United States', '14374', 'btromansfk@google.co.jp'),
('9461247945778433', 'DISCOVER', '550', 5, 2021, '0226 Petterle Hill', '11', 'Canada', 'X3Q8Z6', 'earrundaleb0@narod.ru'),
('9496369108044184', 'VISA', '160', 10, 2023, '816 Banding Junction', '50', 'United States', '23482', 'xgilliard1h@dailymotion.com'),
('9502958762380215', 'DISCOVER', '740', 4, 2021, '42962 Killdeer Place', '41132', 'United States', '17973', 'mjouannotch@google.de'),
('9516311598698385', 'VISA', '413', 9, 2020, '37 Waubesa Drive', '1', 'Canada', 'H7H7J0', 'tworgen8j@ameblo.jp'),
('9549488135308628', 'DISCOVER', '441', 2, 2018, '142 Shelley Hill', '231', 'Canada', 'M7E8E8', 'ostanmerny@themeforest.net'),
('9551227008320662', 'VISA', '657', 9, 2018, '1450 Melby Circle', '58283', 'Canada', 'Q7C9S6', 'hbrassenx@bloglovin.com'),
('9589969896788119', 'DISCOVER', '018', 2, 2023, '43928 Ohio Street', '01', 'United States', '36699', 'kclibberyod@wsj.com'),
('9592194903859099', 'MC', '406', 5, 2020, '04 3rd Junction', '98800', 'United States', '47656', 'acarlesine@ucoz.com'),
('9597356337768288', 'VISA', '203', 10, 2022, '227 Coolidge Point', '6', 'Canada', 'S7J3F3', 'agonneaue0@surveymonkey.com'),
('960151410398260', 'AMEX', '7563', 5, 2020, '7017 Park Meadow Drive', '8359', 'United States', '37035', 'vroystonc@topsy.com'),
('9602255117738081', 'VISA', '222', 6, 2020, '2 Petterle Parkway', '5372', 'Canada', 'D7M6R9', 'dtrelease48@lulu.com'),
('9614246782599845', 'DISCOVER', '695', 1, 2018, '35014 Donald Junction', '40', 'United States', '70289', 'apimer28@upenn.edu'),
('9632715602404713', 'DISCOVER', '000', 7, 2018, '8570 Dorton Place', '3', 'United States', '67122', 'taichesonhi@springer.com'),
('9633702376177951', 'MC', '073', 8, 2022, '113 Esch Parkway', '2', 'Canada', 'N3C1U3', 'mheffordoa@pen.io'),
('9652251418270248', 'VISA', '781', 2, 2024, '464 Duke Trail', '28', 'Canada', 'I1J8C0', 'mcorranfa@oaic.gov.au'),
('9656454294444720', 'VISA', '993', 3, 2020, '10226 Darwin Street', '1', 'United States', '64877', 'fcampion2k@unesco.org'),
('968573590469841', 'AMEX', '8011', 10, 2018, '57 Sunbrook Street', '62', 'Canada', 'Z0T8F1', 'croxbeebp@wikia.com'),
('9712540340645929', 'MC', '403', 3, 2018, '34 Bobwhite Trail', '496', 'United States', '79888', 'rpollett45@cbc.ca'),
('974625867269311', 'AMEX', '0714', 10, 2022, '0 Reindahl Park', '0883', 'United States', '11622', 'mgabalan6@ft.com'),
('977650910355248', 'AMEX', '6834', 5, 2019, '55 Weeping Birch Lane', '07432', 'Canada', 'K0X0G7', 'jreadwin49@redcross.org'),
('9787775556039208', 'VISA', '486', 1, 2018, '73199 Sachs Lane', '170', 'Canada', 'B2P5X5', 'apimer28@upenn.edu'),
('9801001729575724', 'MC', '083', 6, 2020, '87 Kinsman Lane', '564', 'United States', '68103', 'lmurneymp@diigo.com'),
('9801534573066790', 'MC', '929', 7, 2023, '6 Shoshone Parkway', '78', 'United States', '73373', 'gryvesjt@state.gov'),
('9806157284662897', 'VISA', '321', 11, 2018, '67608 Alpine Lane', '127', 'Canada', 'R8W0K1', 'cmellers1f@xrea.com'),
('9807989734308482', 'MC', '935', 4, 2024, '345 Lotheville Pass', '94', 'Canada', 'X6G9Q1', 'fhalypl@microsoft.com'),
('9815585160753701', 'MC', '602', 12, 2018, '743 Packers Hill', '329', 'Canada', 'W6D3B8', 'abeamondrq@utexas.edu'),
('9821618365878204', 'MC', '552', 5, 2021, '69 Ryan Street', '46377', 'United States', '27489', 'dbezemerez@youku.com'),
('9831367470279013', 'DISCOVER', '751', 11, 2022, '4 Graedel Crossing', '15', 'Canada', 'J8R2U6', 'mkassmana7@cbslocal.com'),
('9848777051336169', 'MC', '239', 8, 2019, '44516 Green Avenue', '0038', 'Canada', 'I2X5N0', 'mdefriesq5@cocolog-nifty.com'),
('9859103155751827', 'VISA', '511', 4, 2019, '512 Mariners Cove Drive', '2', 'United States', '36100', 'gantalie@live.com'),
('9877947716447567', 'VISA', '817', 6, 2018, '2 Starling Circle', '7', 'Canada', 'R6T2C5', 'jbyresro@ycombinator.com'),
('9879729078108197', 'DISCOVER', '052', 10, 2023, '26 Spohn Plaza', '451', 'Canada', 'N2I7M0', 'jkettsnu@aol.com'),
('9881763247816183', 'MC', '756', 7, 2023, '1246 Ronald Regan Plaza', '14', 'United States', '22156', 'agritskovmd@soundcloud.com'),
('9901310341232547', 'MC', '473', 7, 2021, '0223 Independence Road', '8', 'United States', '36100', 'csambiedgehe@craigslist.org'),
('9909280447714861', 'DISCOVER', '863', 6, 2024, '1183 Cordelia Circle', '403', 'Canada', 'Z6T1W7', 'hlivoirb2@examiner.com'),
('9928599986824148', 'DISCOVER', '229', 7, 2021, '8045 Susan Way', '8', 'Canada', 'G7Q7K7', 'nwoolvinhp@1688.com'),
('9942983776806933', 'VISA', '848', 12, 2019, '3 Bobwhite Court', '7863', 'Canada', 'S1F1S1', 'lbrittlesb6@merriam-webster.com'),
('994937063048489', 'AMEX', '0099', 8, 2021, '458 Anderson Lane', '98726', 'United States', '36209', 'lbryer7@earthlink.net'),
('9969453445144964', 'DISCOVER', '152', 9, 2019, '235 Colorado Court', '12419', 'Canada', 'D9N7Z9', 'jsporgeonjw@chicagotribune.com'),
('997729261502318', 'AMEX', '4541', 7, 2023, '72 Elmside Court', '1', 'United States', '31589', 'apach7m@hud.gov'),
('9997559416354289', 'MC', '785', 1, 2022, '46257 Red Cloud Pass', '5', 'United States', '80530', 'gemblincl@ning.com');

-- --------------------------------------------------------

--
-- Table structure for table `phonenumberaddress`
--

CREATE TABLE `phonenumberaddress` (
  `phone_number` varchar(15) NOT NULL,
  `street_address` varchar(100) NOT NULL,
  `unit_number` varchar(8) NOT NULL,
  `country` varchar(50) NOT NULL,
  `postal_code` varchar(7) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `phonenumberaddress`
--

INSERT INTO `phonenumberaddress` (`phone_number`, `street_address`, `unit_number`, `country`, `postal_code`) VALUES
('104-931-9078', '239 Coolidge Lane', '2', 'United States', '34925'),
('108-287-5302', '1 Carioca Junction', '1', 'United States', '28705'),
('113-405-7057', '39 Westport Trail', '0', 'Canada', 'G3U2J7'),
('114-655-8575', '40 Banding Trail', '129', 'United States', '20458'),
('119-369-5436', '49 Cordelia Drive', '2896', 'Canada', 'M7H8I9'),
('120-258-3197', '8852 Washington Hill', '06', 'Canada', 'I3W3K6'),
('120-983-7366', '146 Linden Trail', '1', 'Canada', 'M7H8I9'),
('121-211-1716', '18767 Coolidge Hill', '15124', 'United States', '75753'),
('121-822-0881', '4 Tennessee Alley', '9', 'Canada', 'Q3P1R6'),
('122-918-3100', '628 Morrow Terrace', '5851', 'United States', '22525'),
('122-981-6474', '8036 Cardinal Road', '84813', 'Canada', 'P3X6R3'),
('133-825-9652', '1633 Pond Terrace', '1', 'United States', '63498'),
('134-520-6003', '09611 Eastwood Junction', '363', 'United States', '78984'),
('135-811-4018', '717 Hansons Place', '66119', 'United States', '94576'),
('137-945-5049', '4 Holmberg Circle', '8', 'Canada', 'A7B2R7'),
('139-445-8325', '4 Banding Point', '593', 'Canada', 'Y2N9B0'),
('142-279-3043', '2013 Anderson Junction', '3517', 'Canada', 'J0C3L7'),
('146-232-3244', '6 Dovetail Street', '324', 'United States', '56553'),
('150-192-0474', '565 Saint Paul Street', '1', 'United States', '54352'),
('152-998-9468', '0226 Petterle Hill', '11', 'Canada', 'X3Q8Z6'),
('155-160-6421', '8164 Westridge Hill', '15', 'United States', '23104'),
('155-259-2633', '239 Rowland Lane', '06334', 'Canada', 'C8Y6F0'),
('160-569-9303', '0 Sachtjen Place', '9091', 'Canada', 'J8R2U6'),
('166-781-2320', '32 Hazelcrest Street', '373', 'Canada', 'Y6G8G7'),
('176-353-3467', '41829 Pawling Court', '23', 'Canada', 'D1I1F4'),
('178-341-9924', '7050 Donald Hill', '89', 'Canada', 'N2I7M0'),
('184-711-9497', '62 Schiller Parkway', '10821', 'United States', '12796'),
('188-611-4476', '8 Clarendon Avenue', '6846', 'Canada', 'G2J1L2'),
('192-920-1583', '416 Pennsylvania Parkway', '2793', 'Canada', 'X0W5C2'),
('195-682-9515', '6 Bultman Drive', '56', 'United States', '57185'),
('196-710-3733', '3829 Reindahl Park', '5', 'Canada', 'S3J0B7'),
('196-953-2872', '2 Basil Way', '9', 'Canada', 'D7I5Y6'),
('206-576-5864', '2 Buena Vista Terrace', '52737', 'United States', '19011'),
('206-859-8948', '103 Texas Point', '9545', 'Canada', 'U5H8D4'),
('206-863-8750', '9 Buhler Court', '3', 'United States', '49159'),
('215-219-1962', '62132 Shelley Court', '74', 'Canada', 'Y0B2B0'),
('220-560-6370', '5364 Messerschmidt Alley', '1628', 'Canada', 'Q9I5U6'),
('225-733-6173', '4 Transport Crossing', '9', 'United States', '20336'),
('227-124-3761', '7 Steensland Street', '824', 'United States', '14665'),
('229-651-0763', '16 Oak Way', '17570', 'Canada', 'X9G4S1'),
('229-684-9340', '1 Express Crossing', '06', 'United States', '36509'),
('236-719-6665', '5 Sullivan Circle', '752', 'Canada', 'R7D0T5'),
('240-705-9908', '54 Pawling Trail', '13', 'Canada', 'R1L8S7'),
('250-666-4122', '29 Dorton Circle', '040', 'Canada', 'U9R4A6'),
('258-119-0196', '517 Sunnyside Lane', '802', 'United States', '79888'),
('272-481-8869', '7629 Stone Corner Park', '90101', 'Canada', 'F3H2R6'),
('276-948-2870', '3 Kenwood Pass', '15', 'Canada', 'S7J3F3'),
('277-793-1755', '04 Dapin Center', '62388', 'Canada', 'F6W0G4'),
('280-178-5627', '25 Loeprich Hill', '3', 'United States', '34106'),
('293-779-3112', '8987 Texas Terrace', '2', 'United States', '32422'),
('298-192-3915', '4061 Novick Road', '032', 'United States', '57046'),
('301-135-8389', '341 Morrow Hill', '0261', 'United States', '86352'),
('309-663-1195', '10226 Darwin Street', '1', 'United States', '64877'),
('315-900-9098', '04 Mccormick Park', '54', 'Canada', 'O1L2K7'),
('316-463-7307', '0137 Anthes Pass', '09', 'United States', '15449'),
('317-317-8532', '1450 Melby Circle', '58283', 'Canada', 'Q7C9S6'),
('341-375-5860', '2148 Eagan Terrace', '80', 'Canada', 'T7P8G1'),
('342-253-8403', '771 Morning Park', '6', 'United States', '94574'),
('344-613-5051', '30 Hayes Park', '2', 'Canada', 'G7F6D2'),
('354-656-5156', '1 Summit Drive', '163', 'United States', '87605'),
('355-821-5115', '980 Packers Trail', '54', 'Canada', 'K3N7R1'),
('356-258-5396', '91916 Cottonwood Crossing', '379', 'Canada', 'F9Q9S0'),
('361-195-4105', '7022 Canary Trail', '913', 'Canada', 'M1N6T4'),
('361-792-7764', '744 Dovetail Way', '654', 'United States', '50359'),
('382-594-1938', '12173 Monument Alley', '891', 'Canada', 'B4U9M0'),
('383-139-3891', '3001 Autumn Leaf Terrace', '834', 'Canada', 'U1I2O9'),
('384-361-6739', '8 Bartelt Park', '6', 'United States', '44091'),
('392-820-7181', '530 Pennsylvania Road', '78332', 'United States', '33783'),
('393-300-8031', '5235 Messerschmidt Street', '4', 'Canada', 'X6G9Q1'),
('404-409-6046', '8 Sherman Center', '999', 'Canada', 'T9J4Y0'),
('405-569-4122', '627 Homewood Court', '2', 'United States', '44890'),
('406-441-1729', '21357 Crest Line Pass', '27779', 'Canada', 'X6G9Q1'),
('416-200-2571', '2 5th Hill', '5426', 'Canada', 'F9E0S9'),
('416-621-2824', '1541 1st Terrace', '5', 'Canada', 'O9Q3J0'),
('424-435-1919', '688 Barby Crossing', '70244', 'Canada', 'C4S7B0'),
('427-153-0752', '628 Morrow Terrace', '5851', 'United States', '22525'),
('430-342-9210', '71 Russell Pass', '824', 'Canada', 'Q9I5U6'),
('439-765-1066', '03 Swallow Circle', '7', 'Canada', 'Z6T1W7'),
('442-526-2727', '8442 8th Park', '4963', 'United States', '34106'),
('451-859-1665', '002 Talisman Hill', '781', 'United States', '33640'),
('452-389-9887', '50764 Pine View Street', '2', 'Canada', 'Q8G7F8'),
('453-113-8918', '83 Delladonna Circle', '1', 'United States', '33115'),
('460-708-1726', '7377 Dayton Trail', '40993', 'United States', '22156'),
('461-637-4874', '9 Pawling Center', '41', 'United States', '33040'),
('461-914-0487', '8569 Sachtjen Hill', '292', 'Canada', 'X0W5C2'),
('469-482-2015', '264 Claremont Place', '837', 'Canada', 'P5G0C2'),
('470-646-5422', '2 Basil Way', '9', 'Canada', 'D7I5Y6'),
('471-598-0701', '24 Riverside Terrace', '5', 'United States', '25554'),
('481-500-4895', '440 Hoard Park', '0829', 'United States', '49633'),
('482-721-0291', '6290 Oxford Pass', '17477', 'Canada', 'E2M6A9'),
('491-352-4554', '4 High Crossing Center', '20', 'Canada', 'Q8G7F8'),
('496-698-1727', '34682 Fallview Crossing', '563', 'United States', '15751'),
('511-716-7655', '32796 6th Park', '27992', 'United States', '57046'),
('513-675-9164', '8 Cottonwood Parkway', '32', 'Canada', 'L5K3G0'),
('517-736-5910', '2468 Continental Drive', '09039', 'United States', '56403'),
('525-454-8205', '46400 Hallows Hill', '42', 'Canada', 'O3K8C6'),
('525-635-0830', '34 Lake View Road', '0792', 'Canada', 'T3K2E6'),
('537-625-4334', '08 Sutherland Circle', '65496', 'United States', '63095'),
('540-266-1242', '4 Vera Junction', '436', 'United States', '78249'),
('541-687-8288', '9778 Springview Way', '8', 'Canada', 'W6D3B8'),
('542-408-1661', '484 Menomonie Crossing', '2152', 'United States', '41991'),
('547-120-2674', '45 Shopko Street', '9918', 'United States', '15751'),
('550-695-2863', '19752 Express Drive', '6', 'Canada', 'E8K3Q7'),
('553-667-7595', '61 Warbler Alley', '81483', 'Canada', 'Q9B3H1'),
('555-726-3065', '392 Vernon Trail', '57', 'Canada', 'P3X6R3'),
('575-935-1426', '0 Westend Circle', '841', 'United States', '12801'),
('577-592-4874', '7700 Kedzie Point', '90286', 'Canada', 'P5G0C2'),
('578-774-3098', '15431 School Crossing', '32', 'Canada', 'H6C8G6'),
('580-602-3525', '25 Loeprich Hill', '3', 'United States', '34106'),
('583-539-2475', '9 Lien Pass', '5', 'United States', '65218'),
('588-104-8497', '031 Browning Pass', '0620', 'United States', '28705'),
('588-541-0255', '5 Golf Course Center', '6', 'Canada', 'X3C0M9'),
('591-994-4170', '59 Sullivan Point', '7', 'Canada', 'R8W0K1'),
('595-189-6485', '034 Monterey Circle', '59', 'Canada', 'K3C2N2'),
('598-577-8255', '9 Spohn Road', '3415', 'Canada', 'B4U9M0'),
('604-508-0231', '13675 Acker Plaza', '828', 'Canada', 'G8E6T8'),
('606-665-4791', '7 Namekagon Trail', '1', 'Canada', 'D7M6R9'),
('607-142-0402', '10 Farwell Parkway', '97736', 'Canada', 'X9G4S1'),
('607-762-5056', '6453 Burrows Center', '33154', 'United States', '81112'),
('610-764-4392', '63 Columbus Street', '0843', 'Canada', 'I1J8C0'),
('616-403-7654', '3356 Butterfield Alley', '32', 'United States', '81684'),
('627-337-5491', '87 Forest Run Alley', '862', 'Canada', 'G7Q7K7'),
('629-800-1291', '4 Fairfield Crossing', '09', 'Canada', 'D8B2B8'),
('630-227-4355', '694 Lakewood Plaza', '530', 'Canada', 'A6Y6K4'),
('633-653-4603', '4 Vahlen Lane', '50', 'Canada', 'P3X6R3'),
('636-594-8193', '22 Ryan Place', '2', 'Canada', 'F7C7A2'),
('642-274-7762', '42 Gateway Park', '184', 'United States', '12801'),
('649-221-0123', '2 Lawn Alley', '1029', 'United States', '86702'),
('655-986-4791', '8442 8th Park', '4963', 'United States', '34106'),
('657-451-4638', '264 Claremont Place', '837', 'Canada', 'P5G0C2'),
('659-600-3062', '963 Fieldstone Parkway', '7', 'Canada', 'D7O2C8'),
('659-832-7831', '5976 Anhalt Trail', '83', 'Canada', 'E2M6A9'),
('662-134-6715', '04196 Prentice Hill', '1358', 'United States', '54352'),
('679-330-1935', '6183 Maryland Road', '396', 'Canada', 'D7M6R9'),
('683-558-1444', '694 Maryland Street', '648', 'United States', '18164'),
('684-636-1222', '38 Knutson Circle', '7378', 'Canada', 'Y0B2B0'),
('707-279-6441', '02 Badeau Court', '689', 'United States', '12543'),
('708-454-0660', '2398 Esker Trail', '4', 'Canada', 'F9Q9S0'),
('714-641-4376', '600 Moulton Street', '10', 'Canada', 'Q9I5U6'),
('716-922-5218', '70749 Lerdahl Court', '35', 'Canada', 'Y0H4F3'),
('718-629-0415', '61 Manitowish Pass', '4', 'United States', '15449'),
('719-227-8789', '565 Pleasure Park', '082', 'Canada', 'S1F1S1'),
('721-570-4234', '33454 Browning Lane', '24', 'United States', '32542'),
('723-923-6354', '19 Laurel Terrace', '972', 'United States', '70289'),
('728-911-4375', '224 Schlimgen Center', '14', 'Canada', 'K4Z9W9'),
('740-142-6354', '1718 1st Crossing', '31588', 'United States', '36699'),
('744-784-4138', '63 Columbus Street', '0843', 'Canada', 'I1J8C0'),
('745-404-0260', '93 Crest Line Junction', '68473', 'Canada', 'F0O8M2'),
('749-441-6174', '49 Pearson Street', '50377', 'United States', '49812'),
('752-684-0979', '032 Porter Crossing', '24', 'United States', '18164'),
('754-561-2770', '3 Pankratz Terrace', '1625', 'United States', '63095'),
('755-360-3633', '3 Londonderry Parkway', '94114', 'Canada', 'U5L2M5'),
('757-574-7155', '5 Village Green Junction', '514', 'United States', '95234'),
('762-324-2050', '250 Anzinger Avenue', '96861', 'Canada', 'W6D3B8'),
('763-605-0369', '25 Loeprich Hill', '3', 'United States', '34106'),
('763-956-7818', '1955 Westend Hill', '81', 'Canada', 'F0O8M2'),
('770-485-5840', '60614 Everett Center', '5058', 'Canada', 'E7G4Y7'),
('779-818-5036', '36807 Stoughton Circle', '5404', 'Canada', 'N3C1U3'),
('782-877-9906', '0 Manufacturers Court', '24', 'United States', '23482'),
('798-853-3307', '9 Lien Pass', '5', 'United States', '65218'),
('802-875-5662', '542 Almo Hill', '5', 'Canada', 'S1F1S1'),
('814-872-1407', '119 Arkansas Center', '1353', 'United States', '52407'),
('818-525-4770', '77904 Bowman Road', '90', 'United States', '93616'),
('818-775-9835', '4 High Crossing Center', '20', 'Canada', 'Q8G7F8'),
('825-780-7293', '200 Bunting Place', '11923', 'Canada', 'O9Q3J0'),
('825-917-5044', '50105 Coolidge Crossing', '86319', 'Canada', 'Z4S8H4'),
('826-120-3080', '561 Tomscot Crossing', '3707', 'Canada', 'H0T9U0'),
('831-932-9900', '810 Barnett Road', '15', 'United States', '81500'),
('835-912-3274', '36807 Stoughton Circle', '5404', 'Canada', 'N3C1U3'),
('837-319-4505', '75192 Ludington Avenue', '17', 'United States', '32542'),
('845-263-7092', '10 Maple Street', '20271', 'Canada', 'Y3C3O9'),
('852-366-1909', '599 Alpine Center', '7372', 'United States', '78826'),
('852-507-3620', '7407 Hansons Terrace', '42655', 'United States', '32542'),
('854-980-3312', '54758 Pierstorff Road', '50', 'Canada', 'C9X4Q9'),
('872-499-7084', '93 Myrtle Park', '6', 'United States', '41991'),
('878-127-8200', '146 Linden Trail', '1', 'Canada', 'M7H8I9'),
('878-401-2177', '954 Mayfield Place', '48', 'United States', '68103'),
('893-539-6749', '0907 Calypso Circle', '9', 'United States', '84104'),
('898-438-4151', '93494 8th Way', '9', 'Canada', 'Y3C3O9'),
('905-400-5025', '234 Northview Pass', '8', 'Canada', 'T8O1E6'),
('907-493-4233', '5 Myrtle Road', '81007', 'Canada', 'T9F7W2'),
('925-772-7505', '15165 Division Lane', '11833', 'Canada', 'R6R1Y9'),
('936-773-6470', '029 Petterle Circle', '9846', 'United States', '75715'),
('939-111-3953', '397 Pond Hill', '01772', 'Canada', 'C4S7B0'),
('940-851-2244', '303 David Alley', '9617', 'United States', '19091'),
('944-277-3473', '1 Pennsylvania Street', '430', 'United States', '90220'),
('944-843-3251', '9 Sycamore Park', '40', 'Canada', 'Y0H4F3'),
('945-568-5880', '3001 Autumn Leaf Terrace', '834', 'Canada', 'U1I2O9'),
('946-845-7713', '2606 Johnson Junction', '852', 'Canada', 'Z8U9G8'),
('950-186-8380', '4732 Westend Road', '694', 'Canada', 'U6K2C9'),
('956-100-4178', '5 Golf Course Center', '6', 'Canada', 'X3C0M9'),
('957-102-1310', '345 Lotheville Pass', '94', 'Canada', 'X6G9Q1'),
('959-207-3145', '04196 Prentice Hill', '1358', 'United States', '54352'),
('977-938-6934', '18403 Londonderry Point', '6769', 'United States', '54728'),
('984-863-0952', '950 Northridge Way', '209', 'Canada', 'F7C7A2'),
('987-107-6841', '0727 Stone Corner Center', '32', 'Canada', 'U2O7F2'),
('987-588-9804', '341 American Ash Lane', '97578', 'Canada', 'N4B1L2'),
('994-368-7249', '7 Vera Crossing', '2', 'Canada', 'I5O9W5'),
('997-963-9850', '1718 1st Crossing', '31588', 'United States', '36699'),
('999-375-8729', '07396 Prairieview Place', '1896', 'Canada', 'Q5Y0T4');

-- --------------------------------------------------------

--
-- Table structure for table `property`
--

CREATE TABLE `property` (
  `property_name` varchar(100) NOT NULL,
  `phone_number` varchar(15) NOT NULL,
  `street_address` varchar(100) NOT NULL,
  `unit_number` varchar(8) NOT NULL,
  `country` varchar(50) NOT NULL,
  `postal_code` varchar(7) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `property`
--

INSERT INTO `property` (`property_name`, `phone_number`, `street_address`, `unit_number`, `country`, `postal_code`) VALUES
('Candlewood Suites', '9927921937', '10 Maple Street', '20271', 'Canada', 'Y3C3O9'),
('Cute Mountains Inn', '8597866640', '35014 Donald Junction', '40', 'United States', '70289'),
('Hampton Inn', '3706456688', '2539 Thompson Center', '48', 'Canada', 'D6A2H3'),
('Hi-Way Inn', '3662108336', '683 Stone Corner Lane', '25821', 'Canada', 'X0F0B6'),
('Hilton Downtown', '7704409233', '31 Morningstar Trail', '9120', 'Canada', 'R7D0T5'),
('Hotel deLuxe', '3416447567', '240 Melrose Drive', '146', 'United States', '22900'),
('Luxor', '8627432192', '079 Tennyson Center', '7', 'United States', '49654'),
('Residence Inn', '8103528155', '49757 Oakridge Parkway', '27121', 'United States', '66847'),
('Sheraton Centre', '2588217158', '5128 Declaration Hill', '70', 'United States', '30542'),
('The Paradise Inn', '2138895316', '224 Schlimgen Center', '14', 'Canada', 'K4Z9W9');

-- --------------------------------------------------------

--
-- Table structure for table `propertyamenity`
--

CREATE TABLE `propertyamenity` (
  `amenity_name` varchar(30) NOT NULL,
  `property_name` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `propertyamenity`
--

INSERT INTO `propertyamenity` (`amenity_name`, `property_name`) VALUES
('Bar', 'Candlewood Suites'),
('Bar', 'Hampton Inn'),
('Bar', 'Hilton Downtown'),
('Bar', 'Luxor'),
('Bar', 'Sheraton Centre'),
('Fitness Center', 'Cute Mountains Inn'),
('Fitness Center', 'Hi-Way Inn'),
('Fitness Center', 'Hotel deLuxe'),
('Fitness Center', 'Residence Inn'),
('Fitness Center', 'The Paradise Inn'),
('Free Parking', 'Candlewood Suites'),
('Free Parking', 'Hampton Inn'),
('Free Parking', 'Hilton Downtown'),
('Free Parking', 'Luxor'),
('Free Parking', 'Sheraton Centre'),
('Pool', 'Cute Mountains Inn'),
('Pool', 'Hi-Way Inn'),
('Pool', 'Hotel deLuxe'),
('Pool', 'Residence Inn'),
('Pool', 'The Paradise Inn'),
('Restaurant', 'Candlewood Suites'),
('Restaurant', 'Hampton Inn'),
('Restaurant', 'Hilton Downtown'),
('Restaurant', 'Luxor'),
('Restaurant', 'Sheraton Centre'),
('Sauna', 'Cute Mountains Inn'),
('Sauna', 'Hi-Way Inn'),
('Sauna', 'Hotel deLuxe'),
('Sauna', 'Residence Inn'),
('Sauna', 'The Paradise Inn');

-- --------------------------------------------------------

--
-- Table structure for table `provincecountrypostalcode`
--

CREATE TABLE `provincecountrypostalcode` (
  `country` varchar(50) NOT NULL,
  `postal_code` varchar(7) NOT NULL,
  `province_or_state` varchar(50) NOT NULL
) ;

--
-- Dumping data for table `provincecountrypostalcode`
--

INSERT INTO `provincecountrypostalcode` (`country`, `postal_code`, `province_or_state`) VALUES
('Canada', 'A1N6I6', 'Ontario'),
('Canada', 'A6I9J9', 'Quebec'),
('Canada', 'A6Y6K4', 'Alberta'),
('Canada', 'A7B2R7', 'Ontario'),
('Canada', 'A9E4H2', 'Ontario'),
('Canada', 'B2P5X5', 'Alberta'),
('Canada', 'B3A6R5', 'Quebec'),
('Canada', 'B3H8O3', 'Quebec'),
('Canada', 'B4U9M0', 'Alberta'),
('Canada', 'B5Q7U1', 'Alberta'),
('Canada', 'C2J0I0', 'Ontario'),
('Canada', 'C4M3Y3', 'Ontario'),
('Canada', 'C4S7B0', 'Alberta'),
('Canada', 'C5B6W7', 'Ontario'),
('Canada', 'C5M5E1', 'Alberta'),
('Canada', 'C6U7A0', 'Ontario'),
('Canada', 'C8I3M6', 'Quebec'),
('Canada', 'C8Y6F0', 'Ontario'),
('Canada', 'C9C5N0', 'Alberta'),
('Canada', 'C9X4Q9', 'Quebec'),
('Canada', 'D1I1F4', 'Alberta'),
('Canada', 'D1L8A6', 'Alberta'),
('Canada', 'D1X0Z5', 'Alberta'),
('Canada', 'D2Z9I5', 'Alberta'),
('Canada', 'D6A2H3', 'Ontario'),
('Canada', 'D6F3D9', 'Alberta'),
('Canada', 'D7I5Y6', 'Alberta'),
('Canada', 'D7M6R9', 'Quebec'),
('Canada', 'D7O2C8', 'Quebec'),
('Canada', 'D8B2B8', 'Ontario'),
('Canada', 'D9N7Z9', 'Quebec'),
('Canada', 'D9Q0N6', 'Ontario'),
('Canada', 'E1Z4Z1', 'Quebec'),
('Canada', 'E2M6A9', 'Ontario'),
('Canada', 'E5H3Y3', 'Quebec'),
('Canada', 'E6Y5I5', 'Alberta'),
('Canada', 'E7G4Y7', 'Quebec'),
('Canada', 'E8K3Q7', 'Quebec'),
('Canada', 'F0O8M2', 'Quebec'),
('Canada', 'F3H2R6', 'Alberta'),
('Canada', 'F3R1I1', 'Quebec'),
('Canada', 'F6W0G4', 'Alberta'),
('Canada', 'F7C7A2', 'Ontario'),
('Canada', 'F7N9L2', 'Ontario'),
('Canada', 'F8C1T5', 'Alberta'),
('Canada', 'F9E0S9', 'Quebec'),
('Canada', 'F9Q9S0', 'Alberta'),
('Canada', 'G2J1L2', 'Alberta'),
('Canada', 'G3U2J7', 'Ontario'),
('Canada', 'G4N1N9', 'Quebec'),
('Canada', 'G6P9D1', 'Alberta'),
('Canada', 'G7F6D2', 'Alberta'),
('Canada', 'G7Q7K7', 'Alberta'),
('Canada', 'G8E6T8', 'Quebec'),
('Canada', 'G9D5D1', 'Alberta'),
('Canada', 'H0T9U0', 'Ontario'),
('Canada', 'H1Q8Y4', 'Alberta'),
('Canada', 'H4N6A1', 'Alberta'),
('Canada', 'H6C8G6', 'Quebec'),
('Canada', 'H7H7J0', 'Alberta'),
('Canada', 'H8Q2G3', 'Ontario'),
('Canada', 'H8R3R4', 'Ontario'),
('Canada', 'I1J8C0', 'Quebec'),
('Canada', 'I1N6L0', 'Alberta'),
('Canada', 'I2X5N0', 'Alberta'),
('Canada', 'I3W3K6', 'Ontario'),
('Canada', 'I5O9W5', 'Quebec'),
('Canada', 'I7F2K1', 'Quebec'),
('Canada', 'I8H8L3', 'Alberta'),
('Canada', 'I8Z4I8', 'Alberta'),
('Canada', 'J0C3L7', 'Alberta'),
('Canada', 'J3D2J3', 'Alberta'),
('Canada', 'J4J2G1', 'Alberta'),
('Canada', 'J5G7Z3', 'Alberta'),
('Canada', 'J5W6I8', 'Quebec'),
('Canada', 'J5Z0F4', 'Ontario'),
('Canada', 'J6L9S2', 'Ontario'),
('Canada', 'J7O4B7', 'Alberta'),
('Canada', 'J7R9B7', 'Ontario'),
('Canada', 'J7Y6O1', 'Ontario'),
('Canada', 'J8R2U6', 'Quebec'),
('Canada', 'J8R9P6', 'Alberta'),
('Canada', 'J9O2C9', 'Alberta'),
('Canada', 'J9X9O1', 'Alberta'),
('Canada', 'K0X0G7', 'Quebec'),
('Canada', 'K1Z6L8', 'Quebec'),
('Canada', 'K1Z8A2', 'Quebec'),
('Canada', 'K3C2N2', 'Quebec'),
('Canada', 'K3L0A0', 'Ontario'),
('Canada', 'K3N7R1', 'Quebec'),
('Canada', 'K4M3S0', 'Ontario'),
('Canada', 'K4Z9W9', 'Alberta'),
('Canada', 'K8U3M0', 'Quebec'),
('Canada', 'L1D8Y6', 'Ontario'),
('Canada', 'L5K3G0', 'Quebec'),
('Canada', 'L6O6Z0', 'Alberta'),
('Canada', 'L7Z0Q8', 'Quebec'),
('Canada', 'M1A7U3', 'Alberta'),
('Canada', 'M1N6T4', 'Alberta'),
('Canada', 'M3E7E4', 'Quebec'),
('Canada', 'M3L1W6', 'Alberta'),
('Canada', 'M7E8E8', 'Quebec'),
('Canada', 'M7H8I9', 'Ontario'),
('Canada', 'M8I0K1', 'Alberta'),
('Canada', 'M8N0M7', 'Quebec'),
('Canada', 'M9A0Z8', 'Alberta'),
('Canada', 'M9Z3I5', 'Quebec'),
('Canada', 'N2I7M0', 'Quebec'),
('Canada', 'N3C1U3', 'Quebec'),
('Canada', 'N3G1I7', 'Ontario'),
('Canada', 'N4B1L2', 'Quebec'),
('Canada', 'N6M4O9', 'Ontario'),
('Canada', 'N7B2Q0', 'Alberta'),
('Canada', 'N8X0F1', 'Alberta'),
('Canada', 'O1A8T0', 'Quebec'),
('Canada', 'O1B0A3', 'Quebec'),
('Canada', 'O1H1W9', 'Quebec'),
('Canada', 'O1L2K7', 'Alberta'),
('Canada', 'O2A5G4', 'Quebec'),
('Canada', 'O3K8C6', 'Quebec'),
('Canada', 'O5N6I0', 'Quebec'),
('Canada', 'O9F1T9', 'Alberta'),
('Canada', 'O9Q3J0', 'Ontario'),
('Canada', 'P1X0U7', 'Ontario'),
('Canada', 'P3X6R3', 'Quebec'),
('Canada', 'P5A1Q6', 'Alberta'),
('Canada', 'P5G0C2', 'Ontario'),
('Canada', 'P9L7T5', 'Quebec'),
('Canada', 'Q1I1E7', 'Alberta'),
('Canada', 'Q1N2F5', 'Ontario'),
('Canada', 'Q3P1R6', 'Alberta'),
('Canada', 'Q4G8U3', 'Quebec'),
('Canada', 'Q5Y0T4', 'Alberta'),
('Canada', 'Q7C9S6', 'Alberta'),
('Canada', 'Q8G7F8', 'Ontario'),
('Canada', 'Q9B3H1', 'Quebec'),
('Canada', 'Q9I5U6', 'Quebec'),
('Canada', 'R0R8S6', 'Alberta'),
('Canada', 'R1L8S7', 'Ontario'),
('Canada', 'R3X3J2', 'Quebec'),
('Canada', 'R4G5K0', 'Ontario'),
('Canada', 'R5D3E0', 'Alberta'),
('Canada', 'R6R1Y9', 'Alberta'),
('Canada', 'R6T2C5', 'Quebec'),
('Canada', 'R7D0T5', 'Quebec'),
('Canada', 'R7F5Z0', 'Ontario'),
('Canada', 'R8W0K1', 'Alberta'),
('Canada', 'S0D6O9', 'Alberta'),
('Canada', 'S1F1S1', 'Ontario'),
('Canada', 'S1Y2Z5', 'Ontario'),
('Canada', 'S3J0B7', 'Ontario'),
('Canada', 'S7J3F3', 'Quebec'),
('Canada', 'T2L1B0', 'Ontario'),
('Canada', 'T2O7T8', 'Quebec'),
('Canada', 'T3K2E6', 'Alberta'),
('Canada', 'T5G2F9', 'Ontario'),
('Canada', 'T7P8G1', 'Alberta'),
('Canada', 'T8A1I8', 'Alberta'),
('Canada', 'T8O1E6', 'Alberta'),
('Canada', 'T9F7W2', 'Alberta'),
('Canada', 'T9J4Y0', 'Quebec'),
('Canada', 'U0L3Z2', 'Ontario'),
('Canada', 'U0M6X9', 'Ontario'),
('Canada', 'U1I2O9', 'Quebec'),
('Canada', 'U2D4C4', 'Alberta'),
('Canada', 'U2O7F2', 'Quebec'),
('Canada', 'U2U5S9', 'Ontario'),
('Canada', 'U5H8D4', 'Ontario'),
('Canada', 'U5L2M5', 'Quebec'),
('Canada', 'U5S4C4', 'Alberta'),
('Canada', 'U6K2C9', 'Quebec'),
('Canada', 'U8T3M1', 'Quebec'),
('Canada', 'U9R4A6', 'Alberta'),
('Canada', 'W2U8D9', 'Alberta'),
('Canada', 'W4J7B3', 'Alberta'),
('Canada', 'W6D3B8', 'Ontario'),
('Canada', 'X0F0B6', 'Ontario'),
('Canada', 'X0W5C2', 'Ontario'),
('Canada', 'X3A6Y3', 'Alberta'),
('Canada', 'X3C0M9', 'Quebec'),
('Canada', 'X3Q8Z6', 'Alberta'),
('Canada', 'X6G9Q1', 'Alberta'),
('Canada', 'X6T4Z7', 'Ontario'),
('Canada', 'X9G4S1', 'Ontario'),
('Canada', 'X9T8L7', 'Ontario'),
('Canada', 'Y0B2B0', 'Quebec'),
('Canada', 'Y0H4F3', 'Ontario'),
('Canada', 'Y0J4P7', 'Quebec'),
('Canada', 'Y0N1D6', 'Alberta'),
('Canada', 'Y1L4R2', 'Ontario'),
('Canada', 'Y2N9B0', 'Ontario'),
('Canada', 'Y2U0D5', 'Alberta'),
('Canada', 'Y3C3O9', 'Ontario'),
('Canada', 'Y6G8G7', 'Ontario'),
('Canada', 'Y6Q1T5', 'Ontario'),
('Canada', 'Z0H6K0', 'Quebec'),
('Canada', 'Z0T8F1', 'Alberta'),
('Canada', 'Z3C1O5', 'Ontario'),
('Canada', 'Z4S8H4', 'Ontario'),
('Canada', 'Z4X4M1', 'Alberta'),
('Canada', 'Z6T1W7', 'Quebec'),
('Canada', 'Z8U9G8', 'Quebec'),
('United States', '10180', 'Texas'),
('United States', '10230', 'Florida'),
('United States', '10450', 'California'),
('United States', '10986', 'New York'),
('United States', '11423', 'California'),
('United States', '11462', 'Florida'),
('United States', '11622', 'California'),
('United States', '11792', 'New York'),
('United States', '11860', 'Texas'),
('United States', '12543', 'Florida'),
('United States', '12572', 'Florida'),
('United States', '12616', 'Florida'),
('United States', '12796', 'New York'),
('United States', '12801', 'Texas'),
('United States', '13060', 'Texas'),
('United States', '13918', 'Michigan'),
('United States', '14374', 'New York'),
('United States', '14599', 'Florida'),
('United States', '14665', 'Texas'),
('United States', '14888', 'New York'),
('United States', '15449', 'Michigan'),
('United States', '15751', 'Florida'),
('United States', '16474', 'Florida'),
('United States', '17271', 'Florida'),
('United States', '17580', 'New York'),
('United States', '17973', 'Florida'),
('United States', '18164', 'Florida'),
('United States', '18606', 'California'),
('United States', '19011', 'Texas'),
('United States', '19091', 'Florida'),
('United States', '19362', 'Florida'),
('United States', '19891', 'California'),
('United States', '20336', 'Texas'),
('United States', '20458', 'New York'),
('United States', '20532', 'California'),
('United States', '20913', 'California'),
('United States', '22147', 'Florida'),
('United States', '22156', 'New York'),
('United States', '22525', 'Texas'),
('United States', '22900', 'Florida'),
('United States', '23104', 'Michigan'),
('United States', '23290', 'Michigan'),
('United States', '23482', 'Michigan'),
('United States', '25554', 'Michigan'),
('United States', '26557', 'California'),
('United States', '27235', 'California'),
('United States', '27489', 'California'),
('United States', '27632', 'Texas'),
('United States', '28127', 'Texas'),
('United States', '28705', 'California'),
('United States', '29021', 'California'),
('United States', '29840', 'Texas'),
('United States', '30076', 'Florida'),
('United States', '30542', 'Texas'),
('United States', '31589', 'Texas'),
('United States', '31667', 'Michigan'),
('United States', '32422', 'New York'),
('United States', '32542', 'New York'),
('United States', '33040', 'Florida'),
('United States', '33115', 'Michigan'),
('United States', '33324', 'New York'),
('United States', '33640', 'California'),
('United States', '33783', 'Florida'),
('United States', '34106', 'New York'),
('United States', '34925', 'Texas'),
('United States', '34964', 'Michigan'),
('United States', '35508', 'Florida'),
('United States', '36100', 'Florida'),
('United States', '36209', 'California'),
('United States', '36427', 'Michigan'),
('United States', '36509', 'Michigan'),
('United States', '36699', 'Texas'),
('United States', '37035', 'Florida'),
('United States', '38339', 'California'),
('United States', '39807', 'California'),
('United States', '40251', 'Florida'),
('United States', '41991', 'Florida'),
('United States', '42930', 'California'),
('United States', '43123', 'New York'),
('United States', '43287', 'Michigan'),
('United States', '44091', 'Florida'),
('United States', '44220', 'Michigan'),
('United States', '44370', 'New York'),
('United States', '44890', 'California'),
('United States', '45521', 'Michigan'),
('United States', '46560', 'Florida'),
('United States', '46675', 'Texas'),
('United States', '46985', 'Texas'),
('United States', '47160', 'Texas'),
('United States', '47397', 'Michigan'),
('United States', '47656', 'Michigan'),
('United States', '49159', 'Michigan'),
('United States', '49633', 'Michigan'),
('United States', '49654', 'Michigan'),
('United States', '49812', 'Michigan'),
('United States', '50359', 'Florida'),
('United States', '50847', 'Michigan'),
('United States', '51618', 'Florida'),
('United States', '51688', 'Florida'),
('United States', '52407', 'California'),
('United States', '53732', 'Texas'),
('United States', '54292', 'California'),
('United States', '54352', 'New York'),
('United States', '54436', 'California'),
('United States', '54728', 'Texas'),
('United States', '55002', 'California'),
('United States', '55456', 'California'),
('United States', '56403', 'Florida'),
('United States', '56553', 'Michigan'),
('United States', '56794', 'California'),
('United States', '57046', 'Florida'),
('United States', '57185', 'California'),
('United States', '57491', 'Florida'),
('United States', '57799', 'California'),
('United States', '58535', 'Florida'),
('United States', '58782', 'Florida'),
('United States', '59737', 'Michigan'),
('United States', '60174', 'New York'),
('United States', '60451', 'California'),
('United States', '62228', 'California'),
('United States', '62244', 'Florida'),
('United States', '63095', 'Texas'),
('United States', '63498', 'Michigan'),
('United States', '64009', 'New York'),
('United States', '64288', 'Florida'),
('United States', '64877', 'Texas'),
('United States', '64914', 'California'),
('United States', '65218', 'Florida'),
('United States', '66847', 'California'),
('United States', '67122', 'New York'),
('United States', '68092', 'Florida'),
('United States', '68103', 'Florida'),
('United States', '68743', 'Texas'),
('United States', '70289', 'Florida'),
('United States', '70571', 'New York'),
('United States', '71293', 'New York'),
('United States', '71709', 'Michigan'),
('United States', '71718', 'Florida'),
('United States', '72863', 'Texas'),
('United States', '73065', 'Michigan'),
('United States', '73373', 'Michigan'),
('United States', '74680', 'California'),
('United States', '75715', 'Texas'),
('United States', '75753', 'Michigan'),
('United States', '77725', 'California'),
('United States', '78249', 'New York'),
('United States', '78826', 'Texas'),
('United States', '78984', 'Florida'),
('United States', '79888', 'Texas'),
('United States', '80530', 'California'),
('United States', '81112', 'Michigan'),
('United States', '81500', 'California'),
('United States', '81684', 'New York'),
('United States', '81958', 'Michigan'),
('United States', '82176', 'Michigan'),
('United States', '83509', 'California'),
('United States', '83819', 'Texas'),
('United States', '84104', 'Michigan'),
('United States', '84514', 'Florida'),
('United States', '85192', 'Michigan'),
('United States', '85861', 'Michigan'),
('United States', '85991', 'California'),
('United States', '86352', 'Michigan'),
('United States', '86362', 'Texas'),
('United States', '86495', 'New York'),
('United States', '86702', 'Florida'),
('United States', '86900', 'California'),
('United States', '87605', 'New York'),
('United States', '88802', 'California'),
('United States', '89182', 'Texas'),
('United States', '90220', 'Michigan'),
('United States', '90820', 'New York'),
('United States', '91018', 'Michigan'),
('United States', '92662', 'Michigan'),
('United States', '93030', 'New York'),
('United States', '93170', 'California'),
('United States', '93385', 'Michigan'),
('United States', '93616', 'California'),
('United States', '93651', 'Florida'),
('United States', '94287', 'New York'),
('United States', '94442', 'Michigan'),
('United States', '94574', 'Texas'),
('United States', '94576', 'Florida'),
('United States', '95234', 'California'),
('United States', '95677', 'California'),
('United States', '95821', 'California'),
('United States', '96012', 'Michigan'),
('United States', '96246', 'Michigan'),
('United States', '96436', 'New York'),
('United States', '96546', 'Florida'),
('United States', '97923', 'Texas'),
('United States', '98014', 'Texas'),
('United States', '98166', 'California'),
('United States', '98428', 'Michigan'),
('United States', '99615', 'New York'),
('United States', '99916', 'New York');

-- --------------------------------------------------------

--
-- Table structure for table `reservation`
--

CREATE TABLE `reservation` (
  `reservation_id` int(10) UNSIGNED NOT NULL,
  `check_out` date NOT NULL,
  `check_in` date NOT NULL,
  `total_price` float NOT NULL,
  `user_email` varchar(100) NOT NULL,
  `property_name` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `reservation`
--

INSERT INTO `reservation` (`reservation_id`, `check_out`, `check_in`, `total_price`, `user_email`, `property_name`) VALUES
(1, '2019-03-08', '2019-03-02', 1496, 'clongmanal@admin.ch', 'Hi-Way Inn'),
(2, '2019-03-09', '2019-02-18', 4952, 'ewollrauche7@loc.gov', 'Hi-Way Inn'),
(3, '2019-04-06', '2019-04-02', 830, 'sodonohuedn@mozilla.com', 'Residence Inn'),
(4, '2019-06-24', '2019-06-07', 4297, 'ceusteslx@dell.com', 'Cute Mountains Inn'),
(5, '2019-04-05', '2019-03-19', 4574, 'swoodwindcn@yale.edu', 'Hotel deLuxe'),
(7, '2019-03-25', '2019-03-03', 5768, 'kleifer81@wiley.com', 'Hilton Downtown'),
(8, '2019-07-09', '2019-06-29', 2171, 'ahaughianji@dedecms.com', 'Cute Mountains Inn'),
(9, '2019-01-25', '2019-01-06', 4763, 'dpeppard31@barnesandnoble.com', 'Hi-Way Inn'),
(10, '2019-07-31', '2019-07-04', 6833, 'pgraysmark5b@japanpost.jp', 'Sheraton Centre'),
(11, '2019-12-03', '2019-11-21', 3278, 'cwarburton9i@lycos.com', 'Sheraton Centre'),
(12, '2019-04-09', '2019-04-08', 297, 'frigler7w@slate.com', 'Luxor'),
(13, '2019-05-10', '2019-04-20', 5589, 'eriedigerqx@apple.com', 'The Paradise Inn'),
(14, '2020-01-13', '2019-12-22', 5171, 'cbroadfieldew@sciencedirect.com', 'Cute Mountains Inn'),
(15, '2020-01-20', '2019-12-28', 5610, 'emullallyq1@msu.edu', 'Hotel deLuxe'),
(16, '2019-09-05', '2019-08-20', 4140, 'pmckimmqm@rediff.com', 'Residence Inn'),
(17, '2020-01-14', '2020-01-04', 2308, 'ksighartm6@twitpic.com', 'Luxor'),
(18, '2019-09-15', '2019-09-04', 2530, 'dheggesoz@senate.gov', 'Hi-Way Inn'),
(19, '2019-03-01', '2019-02-05', 6135, 'chenrichsendv@economist.com', 'The Paradise Inn'),
(20, '2019-02-21', '2019-02-12', 1981, 'ksayle51@huffingtonpost.com', 'Cute Mountains Inn'),
(21, '2019-09-26', '2019-08-29', 6559, 'cdonizeauil@epa.gov', 'Hampton Inn'),
(22, '2019-09-09', '2019-09-04', 1422, 'jjoulpa@home.pl', 'Hilton Downtown'),
(23, '2019-03-27', '2019-03-22', 1411, 'mstobbart22@yahoo.co.jp', 'Hotel deLuxe'),
(24, '2019-04-20', '2019-04-05', 3610, 'kgowlett8c@pcworld.com', 'Cute Mountains Inn'),
(25, '2019-09-20', '2019-09-10', 3096, 'hlivoirb2@examiner.com', 'Hampton Inn'),
(26, '2019-03-31', '2019-03-12', 4663, 'djoscelyn9p@ihg.com', 'The Paradise Inn'),
(27, '2019-06-29', '2019-06-08', 5689, 'mbenaine2p@ning.com', 'Hotel deLuxe'),
(28, '2019-07-17', '2019-07-10', 1755, 'efevierga@51.la', 'Residence Inn'),
(29, '2019-08-14', '2019-08-05', 2147, 'lnortheastqu@ucsd.edu', 'Hi-Way Inn'),
(30, '2019-07-28', '2019-07-25', 844, 'lpostgateq2@home.pl', 'Cute Mountains Inn'),
(31, '2020-02-01', '2020-01-09', 5310, 'siianon25@hugedomains.com', 'Hotel deLuxe'),
(33, '2020-01-27', '2020-01-11', 4256, 'kmousbycz@seesaa.net', 'Hilton Downtown'),
(34, '2019-04-02', '2019-03-04', 6823, 'acruess6w@addtoany.com', 'Hi-Way Inn'),
(35, '2019-04-26', '2019-04-15', 2360, 'nmccreaap@360.cn', 'Candlewood Suites'),
(36, '2019-04-19', '2019-04-12', 2237, 'ubooirk@twitter.com', 'Residence Inn'),
(37, '2019-07-10', '2019-06-12', 6388, 'luphamck@xinhuanet.com', 'Hampton Inn'),
(38, '2019-09-02', '2019-08-18', 3661, 'ccossor9v@icq.com', 'Candlewood Suites'),
(39, '2019-07-19', '2019-06-26', 6525, 'tcopemanmq@nyu.edu', 'Hilton Downtown'),
(40, '2020-01-09', '2020-01-05', 1217, 'taichesonhi@springer.com', 'Sheraton Centre'),
(41, '2019-06-19', '2019-06-01', 4799, 'swhilderit@qq.com', 'The Paradise Inn'),
(42, '2019-03-17', '2019-03-03', 3458, 'ainch1x@whitehouse.gov', 'Hampton Inn'),
(43, '2019-09-15', '2019-09-08', 1654, 'nfantone2x@comsenz.com', 'The Paradise Inn'),
(44, '2019-12-28', '2019-12-06', 5949, 'amcleoidpg@oakley.com', 'Sheraton Centre'),
(45, '2020-01-24', '2019-12-29', 6647, 'kdalinderqn@hubpages.com', 'Sheraton Centre'),
(46, '2019-08-02', '2019-07-11', 4895, 'gvowlesdq@w3.org', 'Hilton Downtown'),
(47, '2019-05-05', '2019-04-27', 1608, 'lpowlesland85@bloglines.com', 'Luxor'),
(48, '2019-02-13', '2019-01-21', 5438, 'ncastagnen0@twitpic.com', 'Candlewood Suites'),
(49, '2019-07-28', '2019-07-12', 3995, 'mepton2w@un.org', 'Hampton Inn'),
(51, '2019-06-07', '2019-05-20', 4137, 'mentres1d@disqus.com', 'Hampton Inn'),
(52, '2019-11-25', '2019-11-07', 4667, 'kbonallickex@pbs.org', 'Hotel deLuxe'),
(53, '2020-01-05', '2019-12-24', 2836, 'cedwardsot@salon.com', 'Hi-Way Inn'),
(54, '2019-01-18', '2019-01-12', 1645, 'nmaffiakj@google.ca', 'Hotel deLuxe'),
(55, '2019-09-14', '2019-08-25', 5172, 'fweedeneu@goodreads.com', 'Cute Mountains Inn'),
(56, '2019-11-18', '2019-10-20', 7477, 'parderneg6@shinystat.com', 'Hi-Way Inn'),
(57, '2019-03-04', '2019-03-03', 338, 'bgavenii@qq.com', 'Hi-Way Inn'),
(58, '2019-10-03', '2019-09-21', 2925, 'btromansfk@google.co.jp', 'Sheraton Centre'),
(60, '2019-03-07', '2019-02-14', 5117, 'kfidgeon6i@psu.edu', 'Cute Mountains Inn'),
(61, '2019-04-13', '2019-03-25', 5077, 'ocoffeem3@networkadvertising.org', 'Hilton Downtown'),
(62, '2019-08-24', '2019-08-06', 4871, 'agaskinshk@jiathis.com', 'Hampton Inn'),
(63, '2019-02-21', '2019-02-02', 4980, 'grampley1y@360.cn', 'Candlewood Suites'),
(64, '2020-02-04', '2020-01-31', 984, 'kfullerton3n@nasa.gov', 'Cute Mountains Inn'),
(65, '2019-09-26', '2019-09-14', 3093, 'zharbar8z@squidoo.com', 'Hi-Way Inn'),
(66, '2019-07-19', '2019-06-25', 6121, 'mizaacp5@artisteer.com', 'Hi-Way Inn'),
(67, '2019-12-07', '2019-11-12', 5812, 'lvaleg3@ifeng.com', 'Candlewood Suites'),
(68, '2020-01-20', '2020-01-11', 2629, 'bsharpe3@mozilla.com', 'The Paradise Inn'),
(69, '2020-01-15', '2019-12-31', 4416, 'mgartelloq@irs.gov', 'Hi-Way Inn'),
(70, '2019-11-18', '2019-11-15', 846, 'jscownms@sina.com.cn', 'Hotel deLuxe'),
(71, '2019-04-29', '2019-04-16', 2846, 'ckamienskigk@google.ru', 'Candlewood Suites'),
(72, '2019-12-11', '2019-12-05', 1488, 'rvalentingi@census.gov', 'Cute Mountains Inn'),
(73, '2019-07-30', '2019-07-16', 4176, 'afranchioni1m@sourceforge.net', 'Residence Inn'),
(74, '2019-04-28', '2019-04-04', 5713, 'vschwandermannfe@rambler.ru', 'Cute Mountains Inn'),
(75, '2019-11-10', '2019-10-14', 6536, 'apurchonc1@unc.edu', 'Luxor'),
(76, '2019-05-06', '2019-04-07', 8151, 'anorth52@networksolutions.com', 'Hotel deLuxe'),
(77, '2019-08-21', '2019-07-27', 5878, 'weltonob@dyndns.org', 'Hi-Way Inn'),
(78, '2019-07-11', '2019-06-12', 6832, 'jtoselandov@last.fm', 'Luxor'),
(79, '2019-06-05', '2019-05-11', 6472, 'garchanbaultc2@yelp.com', 'Hi-Way Inn'),
(80, '2019-05-01', '2019-04-07', 5616, 'lniaves6y@de.vu', 'Hilton Downtown'),
(81, '2019-12-20', '2019-12-01', 4645, 'gfalkjq@cnbc.com', 'Cute Mountains Inn'),
(82, '2019-10-30', '2019-10-13', 4308, 'nwreakesd8@sourceforge.net', 'Cute Mountains Inn'),
(84, '2019-10-29', '2019-10-13', 4366, 'soxfordp3@imgur.com', 'Luxor'),
(85, '2019-06-07', '2019-05-10', 7128, 'kfidgeon6i@psu.edu', 'Candlewood Suites'),
(86, '2019-09-18', '2019-08-20', 6998, 'uarrighinia1@typepad.com', 'Hampton Inn'),
(87, '2020-01-29', '2020-01-13', 4095, 'bpiggin1r@deliciousdays.com', 'Hi-Way Inn'),
(88, '2019-09-30', '2019-09-18', 2246, 'emcdavitt80@wikispaces.com', 'Hi-Way Inn'),
(89, '2019-05-10', '2019-04-20', 4513, 'liredaleav@admin.ch', 'Hi-Way Inn'),
(90, '2019-11-23', '2019-11-13', 2424, 'sweatherdon18@tripadvisor.com', 'Candlewood Suites'),
(91, '2019-03-16', '2019-03-08', 2009, 'kdyet8y@businessweek.com', 'Hotel deLuxe'),
(92, '2019-08-07', '2019-07-09', 7180, 'rfeehely2n@google.com.au', 'Hampton Inn'),
(93, '2019-12-26', '2019-12-14', 2627, 'vrhoddie5y@spiegel.de', 'Cute Mountains Inn'),
(94, '2019-09-07', '2019-08-28', 2367, 'mdecarlok3@barnesandnoble.com', 'Hotel deLuxe'),
(95, '2019-10-03', '2019-09-26', 1459, 'pmckimmqm@rediff.com', 'Sheraton Centre'),
(96, '2019-04-16', '2019-04-02', 3007, 'cjansson2i@studiopress.com', 'Sheraton Centre'),
(97, '2019-12-30', '2019-12-11', 4670, 'dmariottenq@surveymonkey.com', 'Candlewood Suites'),
(98, '2019-08-23', '2019-07-29', 6839, 'adadgee1@dagondesign.com', 'Hotel deLuxe'),
(99, '2019-02-14', '2019-02-10', 1382, 'gstewartsonnh@livejournal.com', 'Residence Inn'),
(100, '2019-12-11', '2019-11-15', 7246, 'bhughmang8@chron.com', 'Cute Mountains Inn'),
(101, '2019-08-25', '2019-08-04', 5514, 'skiddello9@paypal.com', 'Cute Mountains Inn'),
(102, '2019-06-06', '2019-05-12', 6274, 'cmeyrick95@angelfire.com', 'Luxor'),
(104, '2019-03-10', '2019-02-19', 4253, 'dephgravebu@psu.edu', 'Hampton Inn'),
(105, '2019-11-10', '2019-10-18', 6561, 'eswornhy@sitemeter.com', 'Hilton Downtown'),
(106, '2019-11-09', '2019-11-08', 221, 'jdene44@wired.com', 'Luxor'),
(107, '2019-08-16', '2019-08-01', 4097, 'nwreakesd8@sourceforge.net', 'Hampton Inn'),
(108, '2019-07-05', '2019-06-08', 6082, 'lduell7r@wiley.com', 'Sheraton Centre'),
(109, '2019-06-22', '2019-06-12', 2887, 'tmullearybn@blogs.com', 'Cute Mountains Inn'),
(110, '2019-06-15', '2019-06-03', 2672, 'ebaukhambi@japanpost.jp', 'Candlewood Suites'),
(111, '2019-05-13', '2019-04-13', 7211, 'rjohannespu@marketwatch.com', 'Sheraton Centre'),
(112, '2019-07-14', '2019-06-28', 4250, 'egarwillnr@dailymail.co.uk', 'Sheraton Centre'),
(113, '2019-04-24', '2019-04-16', 2094, 'kbriars8i@t-online.de', 'Residence Inn'),
(114, '2019-11-09', '2019-10-27', 3327, 'agaskinshk@jiathis.com', 'Candlewood Suites'),
(115, '2019-02-22', '2019-02-09', 3514, 'amajurye5@163.com', 'Luxor'),
(116, '2019-06-28', '2019-06-08', 5190, 'ldarreerh@prweb.com', 'Hi-Way Inn'),
(117, '2019-09-18', '2019-08-20', 7795, 'odutnelljm@liveinternet.ru', 'Luxor'),
(118, '2019-12-25', '2019-11-28', 6616, 'gfochsg9@eepurl.com', 'Candlewood Suites'),
(119, '2019-05-21', '2019-04-26', 6766, 'gwigsello0@archive.org', 'Residence Inn'),
(120, '2020-02-03', '2020-01-17', 4181, 'arawsen55@upenn.edu', 'Cute Mountains Inn'),
(121, '2019-04-10', '2019-04-05', 1003, 'gmarcamkk@wikipedia.org', 'Hotel deLuxe'),
(122, '2019-09-07', '2019-08-17', 5055, 'jkettsnu@aol.com', 'The Paradise Inn'),
(123, '2019-10-02', '2019-09-18', 3234, 'bpeasbylk@hugedomains.com', 'Hotel deLuxe'),
(124, '2019-04-16', '2019-04-07', 2492, 'jbowmen3t@jimdo.com', 'Sheraton Centre'),
(125, '2019-11-15', '2019-11-07', 2122, 'bferresf0@hexun.com', 'The Paradise Inn'),
(126, '2020-01-24', '2020-01-17', 1572, 'hpieter9@woothemes.com', 'Hilton Downtown'),
(127, '2019-04-05', '2019-03-19', 4028, 'mwansburycg@yale.edu', 'Cute Mountains Inn'),
(128, '2019-08-24', '2019-08-09', 3538, 'cknaptonf7@liveinternet.ru', 'Cute Mountains Inn'),
(129, '2019-11-06', '2019-10-22', 3754, 'mfoundcq@domainmarket.com', 'Luxor'),
(130, '2019-09-02', '2019-08-27', 1677, 'sbratcherhn@t-online.de', 'Candlewood Suites'),
(131, '2019-06-28', '2019-06-11', 4085, 'tpollicote41@bizjournals.com', 'Luxor'),
(132, '2019-09-30', '2019-09-04', 6739, 'olukasen8d@ocn.ne.jp', 'Hampton Inn'),
(133, '2019-07-25', '2019-06-25', 7492, 'gcarrabotmi@yandex.ru', 'Luxor'),
(134, '2019-05-02', '2019-04-04', 6856, 'bgavenii@qq.com', 'Sheraton Centre'),
(135, '2019-01-06', '2019-01-03', 820, 'sriding99@ehow.com', 'Hotel deLuxe'),
(136, '2019-12-24', '2019-11-26', 6700, 'bfarnhillb@senate.gov', 'Candlewood Suites'),
(137, '2020-01-18', '2019-12-25', 6470, 'rlightbj@walmart.com', 'Luxor'),
(138, '2019-05-03', '2019-04-26', 1854, 'syakolev72@bizjournals.com', 'The Paradise Inn'),
(139, '2019-07-13', '2019-06-26', 4052, 'sriding99@ehow.com', 'The Paradise Inn'),
(140, '2019-08-24', '2019-08-05', 5014, 'vjessop30@blog.com', 'Luxor'),
(141, '2019-01-11', '2019-01-01', 3157, 'mgarnson9g@freewebs.com', 'Residence Inn'),
(142, '2019-10-15', '2019-09-27', 4735, 'tcliffordm5@phoca.cz', 'Luxor'),
(143, '2019-04-30', '2019-04-08', 6355, 'cshortonf5@home.pl', 'Hampton Inn'),
(144, '2019-06-09', '2019-05-10', 7228, 'jleahhj@cocolog-nifty.com', 'Hampton Inn'),
(145, '2019-05-04', '2019-04-13', 4962, 'nbillyardy@bloglovin.com', 'Hilton Downtown'),
(146, '2019-04-08', '2019-03-13', 7078, 'seisoldk2@dagondesign.com', 'Hampton Inn'),
(147, '2019-10-02', '2019-09-09', 5426, 'hgollardaf@bbc.co.uk', 'Cute Mountains Inn'),
(148, '2019-12-29', '2019-11-29', 7568, 'hbrassenx@bloglovin.com', 'Hilton Downtown'),
(149, '2019-05-26', '2019-05-17', 2445, 'abeamondrq@utexas.edu', 'Hilton Downtown'),
(150, '2019-12-15', '2019-12-13', 518, 'snorthernao@loc.gov', 'Sheraton Centre'),
(151, '2019-07-24', '2019-06-25', 7624, 'rgrimme1s@amazonaws.com', 'Hilton Downtown'),
(152, '2019-09-04', '2019-08-29', 1584, 'lbreward5c@unicef.org', 'Sheraton Centre'),
(153, '2019-10-29', '2019-10-10', 4317, 'eyushmanovlc@wikispaces.com', 'Luxor'),
(154, '2019-01-15', '2019-01-07', 1988, 'snorthernao@loc.gov', 'Cute Mountains Inn'),
(155, '2019-02-28', '2019-02-05', 5865, 'ssell5o@smugmug.com', 'Hampton Inn'),
(156, '2019-04-23', '2019-04-09', 3216, 'hkeytea4@is.gd', 'Cute Mountains Inn'),
(157, '2019-02-17', '2019-02-12', 1323, 'bgatteridgea2@topsy.com', 'Hi-Way Inn'),
(158, '2019-04-30', '2019-04-18', 3428, 'eswornhy@sitemeter.com', 'Hampton Inn'),
(159, '2019-04-24', '2019-04-17', 1875, 'wbaszniakll@amazon.co.uk', 'Hampton Inn'),
(161, '2019-09-21', '2019-08-22', 7508, 'cmoulsdallih@so-net.ne.jp', 'Cute Mountains Inn'),
(162, '2019-06-08', '2019-05-20', 4859, 'frydzynskigm@archive.org', 'Hotel deLuxe'),
(163, '2019-05-12', '2019-05-05', 1748, 'jduddinly@chicagotribune.com', 'Hotel deLuxe'),
(165, '2019-01-15', '2019-01-09', 1393, 'rainleybb@tmall.com', 'Sheraton Centre'),
(166, '2019-10-05', '2019-09-10', 7097, 'gdrage5d@adobe.com', 'Hampton Inn'),
(167, '2019-03-06', '2019-02-04', 8011, 'nperdue5w@nature.com', 'Hi-Way Inn'),
(168, '2019-11-14', '2019-10-16', 8180, 'dmulloch4u@umn.edu', 'Hilton Downtown'),
(169, '2019-01-15', '2019-01-10', 1078, 'acolvieg4@utexas.edu', 'Luxor'),
(170, '2019-09-30', '2019-09-17', 3678, 'jineson12@fema.gov', 'Sheraton Centre'),
(171, '2019-06-25', '2019-06-16', 2484, 'rainleybb@tmall.com', 'Hilton Downtown'),
(172, '2019-07-08', '2019-06-19', 4307, 'kinglestoni2@istockphoto.com', 'The Paradise Inn'),
(173, '2019-04-03', '2019-03-07', 6956, 'yalvarho@pcworld.com', 'Residence Inn'),
(174, '2019-03-30', '2019-03-11', 4782, 'pheggmz@storify.com', 'Luxor'),
(175, '2020-01-01', '2019-12-20', 3180, 'lhattrick9z@eventbrite.com', 'Sheraton Centre'),
(176, '2020-01-20', '2019-12-23', 7253, 'gryvesjt@state.gov', 'Luxor'),
(177, '2019-11-01', '2019-10-23', 2039, 'roday65@google.cn', 'Candlewood Suites'),
(178, '2019-12-30', '2019-12-07', 6129, 'hcharrett5n@live.com', 'The Paradise Inn'),
(179, '2019-06-07', '2019-05-30', 2036, 'rcleef6h@senate.gov', 'The Paradise Inn'),
(180, '2019-03-28', '2019-03-04', 5527, 'rpavlenko3e@cyberchimps.com', 'Sheraton Centre'),
(181, '2019-03-30', '2019-03-17', 3930, 'frydzynskigm@archive.org', 'Hi-Way Inn'),
(182, '2019-06-07', '2019-05-10', 6666, 'bpiggin1r@deliciousdays.com', 'The Paradise Inn'),
(183, '2019-12-22', '2019-12-10', 2949, 'ecaig3o@craigslist.org', 'Candlewood Suites'),
(184, '2019-08-13', '2019-07-26', 4374, 'mwarnockgg@xrea.com', 'Residence Inn'),
(185, '2019-05-05', '2019-04-06', 6816, 'mramalho9u@squarespace.com', 'Hilton Downtown'),
(186, '2019-08-02', '2019-07-19', 3076, 'nconlonpv@dell.com', 'Residence Inn'),
(187, '2019-02-21', '2019-02-09', 3086, 'dvinaul2@dyndns.org', 'Hilton Downtown'),
(188, '2019-11-27', '2019-11-16', 2676, 'chillatt5l@hhs.gov', 'Hampton Inn'),
(189, '2019-07-11', '2019-06-22', 4772, 'emcveighf4@bloglovin.com', 'Residence Inn'),
(190, '2019-09-28', '2019-09-12', 3851, 'rlabror3@abc.net.au', 'Hotel deLuxe'),
(191, '2020-01-19', '2020-01-11', 2083, 'jsterndaleju@fastcompany.com', 'Candlewood Suites'),
(192, '2019-08-23', '2019-07-29', 6558, 'dvinaul2@dyndns.org', 'Luxor'),
(193, '2019-09-22', '2019-09-15', 1571, 'gcurtonj0@prlog.org', 'Hampton Inn'),
(194, '2019-03-12', '2019-02-11', 7011, 'dcamps@imgur.com', 'Sheraton Centre'),
(195, '2019-02-13', '2019-02-06', 1924, 'jdunninge4@webs.com', 'Hilton Downtown'),
(196, '2019-07-10', '2019-06-18', 5848, 'iswiffan9q@soundcloud.com', 'Hilton Downtown'),
(197, '2019-03-18', '2019-03-08', 2398, 'pgorring42@artisteer.com', 'Hi-Way Inn'),
(198, '2019-05-22', '2019-04-22', 6758, 'kkadwalliderm1@gov.uk', 'Hampton Inn'),
(199, '2019-06-29', '2019-06-19', 2572, 'jdursleyqh@ameblo.jp', 'Hotel deLuxe'),
(200, '2020-01-29', '2020-01-15', 3560, 'tkimblyad@economist.com', 'Candlewood Suites');

-- --------------------------------------------------------

--
-- Table structure for table `review`
--

CREATE TABLE `review` (
  `review_id` int(10) UNSIGNED NOT NULL,
  `rating` int(10) UNSIGNED NOT NULL,
  `date_created` timestamp NOT NULL DEFAULT current_timestamp(),
  `property_name` varchar(100) NOT NULL,
  `user_email` varchar(100) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `review`
--

INSERT INTO `review` (`review_id`, `rating`, `date_created`, `property_name`, `user_email`) VALUES
(1, 8, '2019-03-27 06:15:29', 'Residence Inn', 'gdouce3s@hostgator.com'),
(2, 7, '2020-01-17 16:57:29', 'Hotel deLuxe', 'qmattosoffii@acquirethisname.com'),
(3, 5, '2020-04-18 19:03:22', 'Candlewood Suites', 'sendekp@ehow.com'),
(4, 6, '2020-07-22 20:56:35', 'Hilton Downtown', 'gplail3s@de.vu'),
(5, 6, '2020-01-22 12:48:53', 'Sheraton Centre', 'gdwinejc@aol.com'),
(6, 7, '2019-12-04 11:15:04', 'Hotel deLuxe', 'ibartloszjv@exblog.jp'),
(7, 4, '2020-01-11 22:23:15', 'Sheraton Centre', 'rrenshellma@redcross.org'),
(8, 6, '2019-08-30 10:03:22', 'Luxor', 'bmashalfq@berkeley.edu'),
(9, 5, '2019-03-31 11:11:10', 'Hi-Way Inn', 'jjiroutekln@yale.edu'),
(10, 2, '2020-01-21 23:39:32', 'Hilton Downtown', 'mmitroshinovcg@sciencedaily.com'),
(11, 3, '2020-03-04 21:42:52', 'Luxor', 'aacomb11@wisc.edu'),
(12, 9, '2020-06-18 19:37:07', 'Cute Mountains Inn', 'bmcmeyler62@cafepress.com'),
(13, 3, '2019-04-14 09:56:40', 'Luxor', 'jflay1t@topsy.com'),
(14, 2, '2019-12-08 09:22:37', 'Candlewood Suites', 'dcuardall4i@bluehost.com'),
(15, 2, '2020-08-09 02:08:21', 'The Paradise Inn', 'mklazengagb@altervista.org'),
(16, 10, '2019-03-23 07:32:08', 'Hi-Way Inn', 'rmilellag1@slashdot.org'),
(17, 5, '2019-11-24 16:37:04', 'The Paradise Inn', 'mtaverinerh9@hexun.com'),
(18, 6, '2019-08-13 14:10:36', 'Hi-Way Inn', 'gyukhnevichdw@webs.com'),
(19, 4, '2020-05-23 20:35:21', 'The Paradise Inn', 'cgoodboddy4o@woothemes.com'),
(20, 6, '2020-02-15 19:53:56', 'Hotel deLuxe', 'mbordissqd@cbsnews.com'),
(21, 6, '2019-10-22 11:13:02', 'The Paradise Inn', 'cjansson2i@studiopress.com'),
(22, 9, '2019-01-24 05:59:16', 'The Paradise Inn', 'nstanger70@mysql.com'),
(23, 3, '2019-07-25 22:28:06', 'Luxor', 'cwarburton9i@lycos.com'),
(24, 3, '2020-08-01 07:00:17', 'Cute Mountains Inn', 'jbyresro@ycombinator.com'),
(25, 6, '2019-05-15 16:21:15', 'Luxor', 'dhebard5i@cyberchimps.com'),
(26, 1, '2020-08-12 20:18:32', 'Residence Inn', 'sfludder37@about.me'),
(27, 1, '2020-03-20 06:58:28', 'Residence Inn', 'fcolhounbl@mtv.com'),
(28, 1, '2020-04-13 04:59:44', 'Hi-Way Inn', 'fkingescote5@epa.gov'),
(29, 6, '2019-06-17 01:04:58', 'Candlewood Suites', 'wsirkett38@drupal.org'),
(30, 7, '2020-05-24 19:34:59', 'Residence Inn', 'lcreganij@va.gov'),
(31, 2, '2020-04-11 13:02:54', 'Candlewood Suites', 'tjordenih@surveymonkey.com'),
(32, 5, '2019-01-15 02:36:54', 'Candlewood Suites', 'rfurmagehr@clickbank.net'),
(33, 6, '2019-07-29 21:18:40', 'The Paradise Inn', 'gimrieqa@hc360.com'),
(34, 9, '2020-06-19 13:32:09', 'Luxor', 'lvirgoer8@ibm.com'),
(35, 3, '2019-03-18 20:06:29', 'Candlewood Suites', 'slovedayl6@google.it'),
(36, 8, '2019-10-13 23:58:14', 'Luxor', 'jcoathamfm@ezinearticles.com'),
(37, 6, '2019-12-05 23:04:50', 'Hi-Way Inn', 'fcampion2k@unesco.org'),
(38, 5, '2019-02-26 05:34:32', 'Candlewood Suites', 'fscattergoodp6@ezinearticles.com'),
(39, 8, '2019-05-16 18:53:13', 'Hi-Way Inn', 'vstodit8t@nih.gov'),
(40, 9, '2019-07-06 00:03:09', 'Sheraton Centre', 'bronaldsonaw@yahoo.co.jp'),
(41, 8, '2019-03-28 21:40:46', 'Cute Mountains Inn', 'jspowage85@narod.ru'),
(42, 9, '2019-10-14 18:17:20', 'Hi-Way Inn', 'twakerhl@vk.com'),
(43, 6, '2019-02-14 20:25:15', 'Hampton Inn', 'glawteyj8@people.com.cn'),
(44, 3, '2019-05-02 14:49:19', 'Hampton Inn', 'heydelos@aol.com'),
(45, 2, '2019-07-12 01:21:31', 'Sheraton Centre', 'rloxdale2s@dot.gov'),
(46, 5, '2020-01-12 19:59:01', 'Luxor', 'taichesonhi@springer.com'),
(47, 1, '2020-04-02 01:01:20', 'Sheraton Centre', 'drainsburyj7@quantcast.com'),
(48, 10, '2019-05-05 13:25:40', 'Hilton Downtown', 'cdifranceshci3x@narod.ru'),
(49, 6, '2020-04-08 00:46:38', 'Luxor', 'ebencher95@pinterest.com'),
(50, 1, '2019-05-28 01:01:49', 'Hilton Downtown', 'hastberyqm@trellian.com'),
(51, 3, '2019-07-14 13:32:42', 'Hampton Inn', 'bgwalterjs@patch.com'),
(52, 2, '2020-02-22 14:20:07', 'Hi-Way Inn', 'rleggenff@prweb.com'),
(53, 7, '2019-12-21 05:28:20', 'Candlewood Suites', 'nmaffiakj@google.ca'),
(54, 6, '2019-05-17 12:36:53', 'Luxor', 'etween61@g.co'),
(55, 9, '2019-06-04 16:41:21', 'Residence Inn', 'wabelshs@cafepress.com'),
(56, 8, '2019-05-18 02:39:26', 'Sheraton Centre', 'bousbieb0@wikimedia.org'),
(57, 2, '2019-02-19 21:14:55', 'Hi-Way Inn', 'dpeppard31@barnesandnoble.com'),
(58, 9, '2019-11-15 16:05:22', 'Candlewood Suites', 'jcollecottmx@webs.com'),
(59, 5, '2019-11-21 14:21:23', 'Candlewood Suites', 'bbatistelli8u@bloomberg.com'),
(60, 1, '2020-01-09 23:22:35', 'Hampton Inn', 'kmirams54@amazon.com'),
(61, 7, '2019-09-09 16:39:40', 'Cute Mountains Inn', 'smoldenrr@pbs.org'),
(62, 4, '2019-10-01 10:52:40', 'Sheraton Centre', 'jleahhj@cocolog-nifty.com'),
(63, 5, '2019-11-30 13:38:39', 'Residence Inn', 'adorow9j@washington.edu'),
(64, 6, '2020-01-27 17:51:37', 'Candlewood Suites', 'jbutterfill6c@mail.ru'),
(65, 5, '2019-03-03 12:51:56', 'Hilton Downtown', 'ehuygen8w@netvibes.com'),
(66, 5, '2020-07-12 01:07:58', 'Residence Inn', 'jdene44@wired.com'),
(67, 6, '2020-02-08 04:27:29', 'Luxor', 'cmacintyrelp@sciencedirect.com'),
(68, 3, '2020-04-16 18:50:22', 'The Paradise Inn', 'sdowsey40@sfgate.com'),
(69, 1, '2019-12-18 05:34:46', 'Hilton Downtown', 'ewilcocksbx@elegantthemes.com'),
(70, 5, '2020-04-22 14:00:52', 'Sheraton Centre', 'gloucheha@com.com'),
(71, 3, '2019-04-19 11:03:16', 'Residence Inn', 'tsteanson3t@apple.com'),
(72, 6, '2019-12-09 02:53:33', 'Cute Mountains Inn', 'aquimbyid@imgur.com'),
(73, 2, '2019-12-31 04:19:16', 'Hilton Downtown', 'criepnx@amazonaws.com'),
(74, 3, '2020-05-19 23:35:36', 'Sheraton Centre', 'sgoldsbyh4@weather.com'),
(75, 10, '2019-10-29 04:51:57', 'Hotel deLuxe', 'krainsjl@jimdo.com'),
(76, 3, '2020-07-20 07:57:13', 'Residence Inn', 'rswinl4@shop-pro.jp'),
(77, 4, '2020-02-28 21:37:49', 'Residence Inn', 'ldarreerh@prweb.com'),
(78, 3, '2019-07-19 05:08:18', 'Candlewood Suites', 'jmilsapav@pinterest.com'),
(79, 9, '2020-04-21 13:52:52', 'Candlewood Suites', 'gclemenzap8@cnn.com'),
(80, 2, '2019-09-12 14:18:48', 'Hilton Downtown', 'sdowsey40@sfgate.com'),
(81, 10, '2020-04-07 19:40:12', 'Luxor', 'kluardcf@parallels.com'),
(82, 1, '2020-01-09 07:01:34', 'Hi-Way Inn', 'gangelc7@ucoz.ru'),
(83, 6, '2019-09-13 03:41:25', 'Candlewood Suites', 'mbaswalldo@slate.com'),
(84, 1, '2019-03-03 05:50:39', 'Hi-Way Inn', 'mcesariciq@github.io'),
(85, 3, '2020-02-13 00:19:18', 'Hi-Way Inn', 'kbellfieldbk@oracle.com'),
(86, 9, '2019-09-02 09:08:54', 'The Paradise Inn', 'agengekn@mozilla.org'),
(87, 5, '2019-01-03 12:54:31', 'Hi-Way Inn', 'admin@ihg.com'),
(88, 9, '2019-06-30 07:56:58', 'Hilton Downtown', 'rscourfieldd6@cnbc.com'),
(89, 8, '2019-01-03 05:13:33', 'Candlewood Suites', 'olukasen8d@ocn.ne.jp'),
(90, 1, '2020-04-22 00:45:37', 'Hilton Downtown', 'ccapnerkg@alibaba.com'),
(91, 8, '2020-03-19 06:23:29', 'Luxor', 'chenrichsendv@economist.com'),
(92, 5, '2020-08-08 16:24:52', 'Hampton Inn', 'mstrutt23@google.es'),
(93, 5, '2019-05-19 20:06:10', 'Cute Mountains Inn', 'mdedneycj@theguardian.com'),
(94, 6, '2020-01-22 14:31:22', 'The Paradise Inn', 'bgoodhayiy@csmonitor.com'),
(95, 8, '2019-10-08 19:40:24', 'Hotel deLuxe', 'sweatherdon18@tripadvisor.com'),
(96, 10, '2019-01-23 05:36:47', 'Hotel deLuxe', 'vramsdelln1@google.cn'),
(97, 9, '2019-05-27 22:57:26', 'Hampton Inn', 'agengekn@mozilla.org'),
(98, 6, '2020-05-22 22:42:35', 'Cute Mountains Inn', 'msantenu@yahoo.co.jp'),
(99, 3, '2020-07-10 02:08:35', 'Luxor', 'cfreckletonbu@elpais.com'),
(100, 6, '2019-03-06 01:00:56', 'The Paradise Inn', 'kwinscom4k@icq.com'),
(101, 5, '2020-03-16 00:33:12', 'Hi-Way Inn', 'cpheardn@usa.gov'),
(102, 10, '2019-09-22 21:21:28', 'Residence Inn', 'tbilovusg7@cbc.ca'),
(103, 9, '2019-09-18 08:10:22', 'Cute Mountains Inn', 'mtaconfj@nsw.gov.au'),
(104, 10, '2019-06-11 14:10:50', 'Hi-Way Inn', 'mhuettcd@theatlantic.com'),
(105, 1, '2020-01-25 04:28:08', 'The Paradise Inn', 'drainsburyj7@quantcast.com'),
(106, 5, '2020-01-25 01:35:01', 'Hilton Downtown', 'khelinpt@google.it'),
(107, 5, '2019-06-17 22:35:28', 'Candlewood Suites', 'wchaplyn8v@webmd.com'),
(108, 6, '2019-06-12 00:25:58', 'Luxor', 'joxfordho@sogou.com'),
(109, 4, '2019-07-18 21:10:02', 'Sheraton Centre', 'hmawtusbv@foxnews.com'),
(110, 9, '2019-01-24 14:29:00', 'Luxor', 'mcorranfa@oaic.gov.au'),
(111, 4, '2020-07-29 04:21:29', 'The Paradise Inn', 'pwhitebrooker@prnewswire.com'),
(112, 9, '2019-10-25 07:48:42', 'Luxor', 'bmcgonigle8g@indiegogo.com'),
(113, 4, '2019-07-30 08:44:19', 'Sheraton Centre', 'vblazejewski2l@odnoklassniki.ru'),
(114, 7, '2019-07-21 01:39:21', 'Cute Mountains Inn', 'yriteleyo5@usa.gov'),
(115, 5, '2019-07-19 11:14:52', 'Sheraton Centre', 'ascotson1y@deviantart.com'),
(116, 7, '2019-11-21 05:44:39', 'Hi-Way Inn', 'snorthernao@loc.gov'),
(117, 5, '2020-08-03 02:41:50', 'Hotel deLuxe', 'pgraingehx@businessweek.com'),
(118, 7, '2019-02-23 08:02:41', 'Hilton Downtown', 'gdidsburypk@i2i.jp'),
(119, 1, '2019-12-05 19:27:59', 'Hampton Inn', 'dcorstanng@smugmug.com'),
(120, 2, '2019-04-17 13:11:10', 'Hi-Way Inn', 'syakolev72@bizjournals.com'),
(121, 6, '2020-08-07 20:21:31', 'Luxor', 'bgavenii@qq.com'),
(122, 3, '2020-07-10 05:39:03', 'Cute Mountains Inn', 'hfebre5i@sfgate.com'),
(123, 3, '2019-11-18 19:47:10', 'Hilton Downtown', 'nsealoveka@usa.gov'),
(124, 6, '2019-04-25 19:43:23', 'The Paradise Inn', 'gdeetlefsht@reuters.com'),
(125, 3, '2020-05-17 02:14:40', 'Hi-Way Inn', 'oleemansdc@mapy.cz'),
(126, 8, '2019-08-22 02:40:57', 'Hotel deLuxe', 'bdutnall8l@bloomberg.com'),
(127, 6, '2020-05-10 09:30:23', 'Hilton Downtown', 'cmoiseybv@redcross.org'),
(128, 4, '2020-07-24 14:52:13', 'Hotel deLuxe', 'cwilloway1p@github.io'),
(129, 1, '2020-07-31 17:16:37', 'Hi-Way Inn', 'ubooirk@twitter.com'),
(130, 9, '2019-02-19 08:48:53', 'Candlewood Suites', 'awhiskerdpm@amazon.co.uk'),
(131, 1, '2020-01-25 08:32:26', 'Hi-Way Inn', 'tmammattn5@redcross.org'),
(132, 3, '2019-10-20 04:00:20', 'Luxor', 'eshapter7r@samsung.com'),
(133, 9, '2019-01-02 16:57:16', 'Hi-Way Inn', 'ritzkovwichhq@pcworld.com'),
(134, 6, '2019-01-29 08:58:55', 'Residence Inn', 'dstrasegn@state.tx.us'),
(135, 5, '2019-02-22 12:01:12', 'Residence Inn', 'lsharland92@prweb.com'),
(136, 4, '2019-07-14 09:42:56', 'Hilton Downtown', 'pnesterlo@dmoz.org'),
(137, 10, '2019-12-15 18:33:59', 'Hi-Way Inn', 'bberriehf@europa.eu'),
(138, 8, '2020-06-26 22:47:08', 'Residence Inn', 'kvennartdc@blogtalkradio.com'),
(139, 3, '2019-09-20 13:44:36', 'Residence Inn', 'hfineya0@whitehouse.gov'),
(140, 7, '2019-07-07 02:49:10', 'Candlewood Suites', 'dcruden79@phoca.cz'),
(141, 7, '2020-04-30 02:02:57', 'Sheraton Centre', 'mgerb45@aol.com'),
(142, 3, '2019-07-04 11:51:08', 'The Paradise Inn', 'jmeadeniv@dyndns.org'),
(143, 2, '2019-06-12 00:58:42', 'Hi-Way Inn', 'rgoldster9o@statcounter.com'),
(144, 4, '2019-04-09 10:46:08', 'Candlewood Suites', 'vpatrone8s@youku.com'),
(145, 6, '2020-02-03 17:22:59', 'Residence Inn', 'dchristypd@noaa.gov'),
(146, 5, '2020-06-10 17:03:42', 'Luxor', 'nogeaneynh@webmd.com'),
(147, 5, '2020-01-30 13:04:21', 'Luxor', 'llowdham5s@chron.com'),
(148, 2, '2019-11-23 16:59:45', 'Hi-Way Inn', 'nfantone2x@comsenz.com'),
(149, 10, '2019-10-14 07:36:14', 'Luxor', 'cfinchamjn@columbia.edu'),
(150, 8, '2019-08-11 20:50:53', 'Luxor', 'kmcgarrellfc@msu.edu'),
(151, 5, '2019-01-17 09:40:04', 'Cute Mountains Inn', 'fkleslbz@nationalgeographic.com'),
(152, 8, '2019-06-08 06:14:46', 'Candlewood Suites', 'nrobotthambq@fda.gov'),
(153, 8, '2019-06-26 07:18:27', 'Residence Inn', 'kdaughertyl8@amazon.com'),
(154, 6, '2019-06-13 21:04:02', 'Sheraton Centre', 'nwoolvinhp@1688.com'),
(155, 6, '2019-10-15 20:27:43', 'The Paradise Inn', 'nmolanqg@uol.com.br'),
(156, 4, '2019-08-08 09:26:35', 'Residence Inn', 'jtellenbrokct@imdb.com'),
(157, 6, '2020-03-17 12:36:04', 'The Paradise Inn', 'hbeynke98@istockphoto.com'),
(158, 4, '2019-08-30 09:57:49', 'Hampton Inn', 'gdublin2u@whitehouse.gov'),
(159, 5, '2019-04-10 09:19:39', 'Hampton Inn', 'hpietsmap0@google.com.hk'),
(160, 3, '2019-04-22 06:20:33', 'The Paradise Inn', 'rharewoodca@de.vu'),
(161, 5, '2020-06-22 08:40:16', 'Hi-Way Inn', 'jcleevesi7@soundcloud.com'),
(162, 5, '2020-03-01 21:44:01', 'Hi-Way Inn', 'mfaier1g@miibeian.gov.cn'),
(163, 2, '2020-06-09 12:59:02', 'Hampton Inn', 'omusgrovegl@examiner.com'),
(164, 6, '2020-08-12 01:27:46', 'Residence Inn', 'tilyushkinaj@netlog.com'),
(165, 8, '2020-02-27 14:04:43', 'The Paradise Inn', 'jforestallkm@eventbrite.com'),
(166, 4, '2020-08-14 10:37:58', 'Hi-Way Inn', 'slovedayl6@google.it'),
(167, 6, '2020-02-08 19:56:00', 'Hampton Inn', 'mnorthing6p@biblegateway.com'),
(168, 10, '2019-05-15 14:11:03', 'Sheraton Centre', 'lwalteringo4@barnesandnoble.com'),
(169, 6, '2020-06-25 18:13:50', 'Hampton Inn', 'gtreffreym1@netscape.com'),
(170, 3, '2020-06-04 10:45:37', 'Hotel deLuxe', 'bbynethad@scribd.com'),
(171, 3, '2019-01-01 21:48:03', 'Candlewood Suites', 'mpreene7f@delicious.com'),
(172, 7, '2019-11-12 23:33:01', 'Hi-Way Inn', 'cscarde@google.de'),
(173, 9, '2020-04-13 19:58:45', 'Hotel deLuxe', 'rmaloneybg@jugem.jp'),
(174, 1, '2019-02-27 20:44:59', 'Hilton Downtown', 'fsappsonoe@godaddy.com'),
(175, 2, '2020-06-15 02:04:01', 'The Paradise Inn', 'bdallman93@fc2.com'),
(176, 8, '2019-03-06 13:18:03', 'Hotel deLuxe', 'wcorstonkl@yelp.com'),
(177, 6, '2020-02-01 17:24:47', 'The Paradise Inn', 'roday65@google.cn'),
(178, 7, '2020-01-05 11:28:05', 'Hilton Downtown', 'gloadsmanq4@ucoz.ru'),
(179, 3, '2019-11-10 18:18:19', 'Residence Inn', 'tsemoninid@google.de'),
(180, 4, '2019-07-29 09:19:28', 'Sheraton Centre', 'vvallantine0@java.com'),
(181, 2, '2020-03-12 20:19:06', 'The Paradise Inn', 'dnelesfs@disqus.com'),
(182, 7, '2020-04-23 13:53:47', 'Candlewood Suites', 'rchallacec3@simplemachines.org'),
(183, 8, '2020-03-08 22:12:56', 'Luxor', 'tjordenih@surveymonkey.com'),
(184, 3, '2020-07-22 00:33:44', 'Candlewood Suites', 'bgawkeka@devhub.com'),
(185, 5, '2019-02-07 09:53:28', 'Cute Mountains Inn', 'fjelfrp@gravatar.com'),
(186, 2, '2020-05-28 14:07:52', 'Residence Inn', 'rcleef6h@senate.gov'),
(187, 10, '2020-05-15 06:27:17', 'Hampton Inn', 'bgatteridgea2@topsy.com'),
(188, 3, '2020-07-16 08:49:33', 'Hampton Inn', 'mgartelloq@irs.gov'),
(189, 5, '2019-11-08 20:08:13', 'Hampton Inn', 'luphamck@xinhuanet.com'),
(190, 8, '2020-01-07 02:02:25', 'Sheraton Centre', 'cpeggramj7@yolasite.com'),
(191, 3, '2019-05-17 13:09:56', 'The Paradise Inn', 'ljerzycowski2q@pagesperso-orange.fr'),
(192, 9, '2019-07-26 19:31:01', 'The Paradise Inn', 'nmaffiakj@google.ca'),
(193, 6, '2019-08-21 15:48:02', 'Hilton Downtown', 'ehollidge5e@uiuc.edu'),
(194, 9, '2019-02-06 19:04:50', 'Cute Mountains Inn', 'ccossor9v@icq.com'),
(195, 2, '2019-08-17 07:13:48', 'Luxor', 'dmckanern@gmpg.org'),
(196, 2, '2019-11-04 17:41:23', 'Sheraton Centre', 'bmccreery47@cloudflare.com'),
(197, 10, '2019-02-17 05:48:41', 'Hi-Way Inn', 'rjindad5@indiatimes.com'),
(198, 6, '2019-12-20 11:06:47', 'Hilton Downtown', 'vwestmerland35@umn.edu'),
(199, 2, '2019-05-09 00:25:50', 'Hotel deLuxe', 'bmusselwhiteik@yelp.com'),
(200, 8, '2019-07-31 21:50:45', 'Residence Inn', 'crollinq6@oakley.com'),
(201, 10, '2020-07-23 05:58:45', 'Cute Mountains Inn', 'bgawkeka@devhub.com'),
(202, 1, '2020-01-13 09:33:23', 'The Paradise Inn', 'eskedgex@hao123.com'),
(203, 4, '2019-07-26 04:03:59', 'Luxor', 'cvolk6w@people.com.cn'),
(204, 6, '2019-09-27 02:17:35', 'Residence Inn', 'afryman20@naver.com'),
(205, 3, '2020-06-13 21:57:37', 'Candlewood Suites', 'wtaylour3p@yellowpages.com'),
(206, 1, '2020-02-29 17:08:26', 'Luxor', 'hcharrett5n@live.com'),
(207, 5, '2019-09-04 20:29:39', 'The Paradise Inn', 'kcisson6b@pen.io'),
(208, 4, '2019-10-23 06:36:34', 'Hotel deLuxe', 'ajeynessn@nhs.uk'),
(209, 2, '2019-08-27 14:12:03', 'The Paradise Inn', 'bpeasbylk@hugedomains.com'),
(210, 10, '2019-02-23 13:59:05', 'Hi-Way Inn', 'abeentjesng@whitehouse.gov'),
(211, 2, '2019-09-27 04:26:45', 'Sheraton Centre', 'gcarrabotmi@yandex.ru'),
(212, 1, '2019-03-08 09:20:20', 'The Paradise Inn', 'amcentagart7u@hud.gov'),
(213, 6, '2020-06-14 09:56:59', 'Luxor', 'dpoynzere8@xrea.com'),
(214, 2, '2019-02-27 08:10:37', 'Hampton Inn', 'mcoito6@ibm.com'),
(215, 6, '2019-12-15 21:43:07', 'Hotel deLuxe', 'ltappington7e@cdbaby.com'),
(216, 6, '2020-07-17 00:13:56', 'Hi-Way Inn', 'eshilstonmm@icio.us'),
(217, 8, '2019-12-02 21:06:53', 'Sheraton Centre', 'dcoond9@nydailynews.com'),
(218, 4, '2019-12-15 06:57:19', 'Hotel deLuxe', 'wstratton20@chronoengine.com'),
(219, 6, '2020-02-08 21:34:00', 'Hampton Inn', 'cshropshiremh@sfgate.com'),
(220, 5, '2019-05-24 17:32:13', 'Hilton Downtown', 'adunkerkkx@state.tx.us'),
(221, 1, '2020-05-19 16:40:12', 'Sheraton Centre', 'chabbemaiw@yellowbook.com'),
(222, 4, '2020-01-18 01:53:07', 'Sheraton Centre', 'ktottjh@japanpost.jp'),
(223, 10, '2019-05-10 04:21:00', 'The Paradise Inn', 'ptophamni@networksolutions.com'),
(224, 10, '2020-02-07 04:33:52', 'Hi-Way Inn', 'admin@ihg.com'),
(225, 5, '2020-03-08 09:08:20', 'Hilton Downtown', 'iwisniewskio0@toplist.cz'),
(226, 6, '2019-05-05 20:00:33', 'Hotel deLuxe', 'rbennellq4@wiley.com'),
(227, 7, '2019-03-10 05:02:24', 'Luxor', 'ylancasterqz@yale.edu'),
(228, 6, '2020-06-17 05:57:18', 'Hampton Inn', 'lbattabeew@photobucket.com'),
(229, 1, '2020-03-13 23:38:27', 'Hampton Inn', 'adurstonh5@unc.edu'),
(230, 4, '2019-12-02 08:13:54', 'The Paradise Inn', 'idanymu@usda.gov'),
(231, 2, '2019-03-20 14:29:45', 'Hotel deLuxe', 'csommervillejx@miibeian.gov.cn'),
(232, 7, '2019-12-02 01:43:37', 'Residence Inn', 'muchn@chicagotribune.com'),
(233, 3, '2020-04-17 03:43:45', 'Candlewood Suites', 'rkilleley3f@jimdo.com'),
(234, 1, '2019-12-16 14:09:33', 'Sheraton Centre', 'cconboyjo@feedburner.com'),
(235, 9, '2019-11-10 12:54:25', 'Sheraton Centre', 'ggoalleycu@dmoz.org'),
(236, 10, '2019-07-18 16:47:38', 'Cute Mountains Inn', 'hyearn5t@netscape.com'),
(237, 6, '2019-12-17 17:16:52', 'Hampton Inn', 'bszachniewicz2h@guardian.co.uk'),
(238, 1, '2019-09-04 17:51:51', 'Residence Inn', 'jtoselandov@last.fm'),
(239, 6, '2019-10-18 21:15:37', 'Luxor', 'wmatfieldfu@shop-pro.jp'),
(240, 3, '2020-01-09 02:56:35', 'Sheraton Centre', 'nvampluso7@webs.com'),
(241, 4, '2019-02-25 01:25:51', 'Sheraton Centre', 'farthey7o@moonfruit.com'),
(242, 5, '2020-01-11 22:50:07', 'Candlewood Suites', 'hemonsjk@hc360.com'),
(243, 4, '2019-11-06 21:40:26', 'The Paradise Inn', 'selmanh@sogou.com'),
(244, 7, '2019-03-07 23:26:42', 'Sheraton Centre', 'mfauning9s@home.pl'),
(245, 9, '2020-01-23 07:06:10', 'Luxor', 'msiggeb5@yahoo.co.jp'),
(246, 7, '2020-07-14 15:59:33', 'Cute Mountains Inn', 'mpennialld3@cafepress.com'),
(247, 6, '2019-07-19 09:02:11', 'Candlewood Suites', 'caymericho3@google.com.au'),
(248, 7, '2019-04-04 10:57:55', 'Residence Inn', 'hkullmannqf@jigsy.com'),
(249, 1, '2020-01-28 10:51:12', 'Hilton Downtown', 'mscirmanhz@google.es'),
(250, 1, '2019-08-10 16:48:22', 'Hi-Way Inn', 'bmcmeyler62@cafepress.com'),
(251, 3, '2020-05-30 16:27:37', 'Hi-Way Inn', 'psmaridgeia@pinterest.com'),
(252, 1, '2020-08-12 17:34:13', 'Candlewood Suites', 'ggravellsgz@photobucket.com'),
(253, 6, '2020-04-25 10:59:04', 'The Paradise Inn', 'rloxdale2s@dot.gov'),
(254, 4, '2019-06-09 11:08:43', 'Hampton Inn', 'rswinl4@shop-pro.jp'),
(255, 2, '2019-05-25 02:43:55', 'Hotel deLuxe', 'dholdforthmv@163.com'),
(256, 3, '2019-05-02 08:17:07', 'Hi-Way Inn', 'mserraillier9m@pen.io'),
(257, 9, '2020-07-11 11:38:31', 'Luxor', 'voxxfj@1und1.de'),
(258, 5, '2019-07-09 19:42:40', 'Hampton Inn', 'elumsdaledf@w3.org'),
(259, 6, '2019-09-01 11:07:03', 'Hampton Inn', 'ggoaterks@taobao.com'),
(260, 4, '2019-01-28 02:33:39', 'Hampton Inn', 'nmolanqg@uol.com.br'),
(261, 5, '2020-01-26 06:27:21', 'Luxor', 'nnovak4v@weather.com'),
(262, 7, '2019-02-02 13:42:56', 'The Paradise Inn', 'mlittlejohnsfb@state.gov'),
(263, 9, '2019-09-01 21:51:41', 'Hilton Downtown', 'hchristall10@dmoz.org'),
(264, 5, '2020-02-05 20:40:29', 'Hi-Way Inn', 'krangell27@delicious.com'),
(265, 10, '2020-04-21 16:31:55', 'Candlewood Suites', 'emasord@mtv.com'),
(266, 4, '2019-12-19 04:38:12', 'Sheraton Centre', 'pdenseyjg@topsy.com'),
(267, 1, '2019-03-26 08:34:46', 'Hampton Inn', 'bbatty73@wp.com'),
(268, 6, '2020-05-02 14:34:12', 'Residence Inn', 'kdommersennl@home.pl'),
(269, 7, '2019-07-17 18:12:14', 'Candlewood Suites', 'mmerkel2g@eventbrite.com'),
(270, 2, '2020-01-13 20:27:39', 'Luxor', 'dstrainfl@cloudflare.com'),
(271, 6, '2019-03-20 13:22:59', 'Residence Inn', 'agaskinshk@jiathis.com'),
(272, 3, '2020-06-17 06:04:29', 'Luxor', 'flesurfko@acquirethisname.com'),
(273, 7, '2019-06-28 11:56:42', 'The Paradise Inn', 'swinkleg3@tinyurl.com'),
(274, 2, '2019-10-08 20:34:35', 'Hampton Inn', 'bfettis89@elegantthemes.com'),
(275, 3, '2019-04-09 00:10:08', 'Sheraton Centre', 'ncoldbreath6c@mysql.com'),
(276, 1, '2019-01-01 08:32:21', 'Luxor', 'shazell@google.co.jp'),
(277, 5, '2019-04-07 12:55:33', 'Hampton Inn', 'bcritzen9h@123-reg.co.uk'),
(278, 3, '2019-03-10 22:31:22', 'The Paradise Inn', 'ccolnett27@a8.net'),
(279, 9, '2020-03-21 04:55:51', 'Hilton Downtown', 'gbocock8q@alexa.com'),
(280, 5, '2019-06-21 01:28:43', 'Candlewood Suites', 'esurmanhv@w3.org'),
(281, 4, '2019-04-29 07:58:55', 'Hotel deLuxe', 'eswindellsgu@wired.com'),
(282, 9, '2019-12-22 22:06:38', 'Hi-Way Inn', 'dchapelle7p@miibeian.gov.cn'),
(283, 8, '2020-05-21 17:41:15', 'Hampton Inn', 'rkowal33@yahoo.co.jp'),
(284, 10, '2019-05-09 00:49:03', 'Candlewood Suites', 'dloadernc@wikispaces.com'),
(285, 4, '2019-09-01 19:50:59', 'Residence Inn', 'vsimoncinia3@merriam-webster.com'),
(286, 2, '2019-09-09 23:37:47', 'The Paradise Inn', 'fhandasydeis@slashdot.org'),
(287, 7, '2019-04-10 21:16:29', 'Cute Mountains Inn', 'hstubbeley3y@mail.ru'),
(288, 6, '2019-02-16 16:30:33', 'Hi-Way Inn', 'asheircliffe4l@bing.com'),
(289, 8, '2020-08-04 12:18:18', 'Hampton Inn', 'pdumpletonoh@goodreads.com'),
(290, 10, '2020-06-25 21:37:23', 'The Paradise Inn', 'droafa5@angelfire.com'),
(291, 2, '2020-07-23 23:43:11', 'Sheraton Centre', 'vkilduff41@jiathis.com'),
(292, 7, '2019-02-22 02:18:16', 'Hi-Way Inn', 'ipinching6q@theglobeandmail.com'),
(293, 8, '2019-06-22 20:36:39', 'Residence Inn', 'amaulindi@surveymonkey.com'),
(294, 2, '2019-01-21 12:18:03', 'The Paradise Inn', 'icarik29@sohu.com'),
(295, 9, '2019-02-17 16:19:51', 'The Paradise Inn', 'hmawtusbv@foxnews.com'),
(296, 4, '2019-09-15 08:52:06', 'Cute Mountains Inn', 'hsargersonbm@boston.com'),
(297, 5, '2019-07-12 00:20:17', 'Luxor', 'tshine6b@topsy.com'),
(298, 6, '2020-05-17 05:17:33', 'Residence Inn', 'icoategf@buzzfeed.com'),
(299, 8, '2020-02-22 16:44:52', 'Luxor', 'fcampion2k@unesco.org'),
(300, 2, '2019-11-02 19:40:35', 'The Paradise Inn', 'cbenedito97@washington.edu'),
(301, 3, '2019-07-10 04:48:20', 'Candlewood Suites', 'awoodard2a@is.gd'),
(302, 9, '2020-04-13 09:36:01', 'Hampton Inn', 'abatecoklg@constantcontact.com'),
(303, 5, '2020-02-11 04:58:13', 'Hilton Downtown', 'kskeates9d@imgur.com'),
(304, 1, '2019-11-30 08:17:30', 'Luxor', 'soxfordp3@imgur.com'),
(305, 2, '2019-10-17 04:23:50', 'Sheraton Centre', 'cassurev@npr.org'),
(306, 4, '2019-06-27 17:45:06', 'Hampton Inn', 'lminerojo@nifty.com'),
(307, 4, '2019-12-27 13:54:22', 'Hotel deLuxe', 'ccrosserpe@domainmarket.com'),
(308, 2, '2020-05-19 09:40:59', 'Hotel deLuxe', 'vremirezk5@amazon.de'),
(309, 5, '2020-07-24 16:56:52', 'Hi-Way Inn', 'kpredohlop@cbc.ca'),
(310, 6, '2019-07-13 08:50:13', 'Sheraton Centre', 'jstefanovic78@jiathis.com'),
(311, 1, '2019-06-29 12:42:35', 'Hotel deLuxe', 'csoltanfx@cnn.com'),
(312, 4, '2019-02-01 19:01:05', 'Sheraton Centre', 'japfler3a@wunderground.com'),
(313, 4, '2020-07-02 18:33:46', 'Hampton Inn', 'ciddonfl@blogtalkradio.com'),
(314, 2, '2019-10-01 13:48:24', 'Hotel deLuxe', 'cshorto4c@techcrunch.com'),
(315, 6, '2020-01-17 17:00:35', 'Hotel deLuxe', 'lattwool87@tiny.cc'),
(316, 5, '2020-03-06 19:09:20', 'Sheraton Centre', 'rjoosti8@unicef.org'),
(317, 3, '2019-01-15 13:38:30', 'Hotel deLuxe', 'ckunkelrp@noaa.gov'),
(318, 3, '2019-04-30 03:06:11', 'The Paradise Inn', 'aboxellgy@skyrock.com'),
(319, 4, '2020-03-12 10:52:28', 'Hilton Downtown', 'omusgrovegl@examiner.com'),
(320, 4, '2019-06-28 16:35:06', 'Hampton Inn', 'mrosenblattc4@prweb.com'),
(321, 2, '2019-03-21 19:44:03', 'Sheraton Centre', 'amiddiff6t@paypal.com'),
(322, 2, '2019-04-22 20:51:47', 'Candlewood Suites', 'epimmockeal@meetup.com'),
(323, 6, '2020-02-17 17:20:59', 'Hilton Downtown', 'kbelsham1m@mapy.cz'),
(324, 1, '2019-05-27 03:06:39', 'The Paradise Inn', 'cfishce@usatoday.com'),
(325, 6, '2020-03-26 09:40:10', 'Hi-Way Inn', 'oirdale56@trellian.com'),
(326, 10, '2019-10-28 00:30:28', 'Hampton Inn', 'ghendriksends@blinklist.com'),
(327, 3, '2019-09-03 02:38:29', 'Hilton Downtown', 'giacopettih2@samsung.com'),
(328, 1, '2020-07-09 06:46:58', 'Hi-Way Inn', 'osuermeierlf@feedburner.com'),
(329, 5, '2019-01-07 20:43:40', 'Residence Inn', 'vhatliff3a@weebly.com'),
(330, 3, '2019-04-15 00:26:35', 'Hi-Way Inn', 'apeidrocq@slideshare.net'),
(331, 2, '2019-06-16 02:21:31', 'Sheraton Centre', 'hastberyqm@trellian.com'),
(332, 2, '2020-02-13 11:28:02', 'Hilton Downtown', 'cnewislt@constantcontact.com'),
(333, 9, '2019-08-06 02:19:04', 'Hi-Way Inn', 'mtaverinerh9@hexun.com'),
(334, 1, '2019-03-25 02:14:37', 'Residence Inn', 'jhouldcroftbl@senate.gov'),
(335, 3, '2019-10-05 17:02:56', 'Cute Mountains Inn', 'ltriplettgd@cocolog-nifty.com'),
(336, 2, '2020-06-22 21:44:54', 'Hotel deLuxe', 'mdabner2t@dedecms.com'),
(337, 6, '2020-06-06 18:33:40', 'Cute Mountains Inn', 'mtaconfj@nsw.gov.au'),
(338, 6, '2019-04-14 18:23:20', 'Candlewood Suites', 'dchapelle7p@miibeian.gov.cn'),
(339, 7, '2019-06-18 20:35:38', 'Hi-Way Inn', 'tcamacho2f@reference.com'),
(340, 3, '2019-05-06 11:13:41', 'Candlewood Suites', 'tcliffordm5@phoca.cz'),
(341, 2, '2019-12-10 03:19:25', 'Luxor', 'yscotchmorek1@xing.com'),
(342, 6, '2020-08-06 03:44:55', 'Hampton Inn', 'dcrantonei@drupal.org'),
(343, 2, '2020-08-03 02:11:54', 'Hampton Inn', 'sspinola5y@youtu.be'),
(344, 8, '2020-08-14 10:51:09', 'Residence Inn', 'klibbis4n@cmu.edu'),
(345, 10, '2020-03-24 18:17:42', 'Hilton Downtown', 'vmchardykf@topsy.com'),
(346, 1, '2019-03-04 14:35:19', 'Candlewood Suites', 'gthornally37@myspace.com'),
(347, 5, '2020-08-13 11:20:42', 'Hi-Way Inn', 'gdahmel66@boston.com'),
(348, 3, '2020-07-28 06:04:20', 'Residence Inn', 'gleprovosti4@domainmarket.com'),
(349, 4, '2020-06-19 03:59:11', 'The Paradise Inn', 'nvedmore4b@goo.gl'),
(350, 2, '2020-06-26 01:44:54', 'Hampton Inn', 'csambiedgehe@craigslist.org'),
(351, 5, '2020-07-21 13:04:00', 'Hi-Way Inn', 'cknatt7n@ftc.gov'),
(352, 7, '2019-02-11 21:40:56', 'Residence Inn', 'yriteleyo5@usa.gov'),
(353, 9, '2019-03-04 00:48:20', 'The Paradise Inn', 'marguecw@printfriendly.com'),
(354, 8, '2019-11-05 10:13:43', 'Cute Mountains Inn', 'lgommowegu@google.nl'),
(355, 9, '2019-06-04 11:34:14', 'The Paradise Inn', 'cemmerson8j@wp.com'),
(356, 4, '2019-09-04 02:11:22', 'Sheraton Centre', 'hhoward62@wired.com'),
(357, 4, '2020-06-30 17:17:18', 'Hotel deLuxe', 'mkitchinghamod@google.com'),
(358, 9, '2019-01-28 14:00:04', 'Candlewood Suites', 'adignumnv@amazon.de'),
(359, 7, '2019-04-12 16:01:56', 'Cute Mountains Inn', 'hpresterns@eventbrite.com'),
(360, 8, '2019-08-03 00:34:14', 'Hilton Downtown', 'hhoward62@wired.com'),
(361, 10, '2019-09-20 13:43:14', 'Hampton Inn', 'esheenhz@blog.com'),
(362, 6, '2019-12-01 04:18:06', 'Luxor', 'jnendick8b@walmart.com'),
(363, 4, '2019-05-06 20:11:48', 'Candlewood Suites', 'mzuckeree@webs.com'),
(364, 4, '2019-01-22 17:02:36', 'Luxor', 'bsharpe3@mozilla.com'),
(365, 2, '2020-02-05 09:39:01', 'The Paradise Inn', 'ckyne2s@yahoo.com'),
(366, 1, '2019-08-05 00:49:32', 'The Paradise Inn', 'pnesterlo@dmoz.org'),
(367, 8, '2019-01-18 09:43:45', 'Hampton Inn', 'sseldnern4@google.cn'),
(368, 9, '2019-02-17 05:16:39', 'Hampton Inn', 'rswanboroughf6@fema.gov'),
(369, 6, '2019-04-13 03:37:54', 'Hilton Downtown', 'dspiers74@dion.ne.jp'),
(370, 4, '2020-07-03 10:42:19', 'Hi-Way Inn', 'mstrutt23@google.es'),
(371, 2, '2019-11-12 06:29:19', 'Hi-Way Inn', 'gmoulink5@addtoany.com'),
(372, 5, '2019-07-28 19:30:19', 'Candlewood Suites', 'gonionl3@yellowbook.com'),
(373, 1, '2020-05-03 19:29:10', 'Hilton Downtown', 'ddorricottlv@gravatar.com'),
(374, 6, '2019-12-23 22:49:09', 'Luxor', 'cdonahue3f@myspace.com'),
(375, 5, '2019-09-25 17:06:42', 'Hilton Downtown', 'oshortonll@constantcontact.com'),
(376, 3, '2020-07-12 22:29:06', 'Candlewood Suites', 'gsolwayn1@tripod.com'),
(377, 6, '2020-02-10 16:09:40', 'Hilton Downtown', 'feyerg@behance.net'),
(378, 9, '2020-04-26 04:19:36', 'The Paradise Inn', 'bbeagriegw@mail.ru'),
(379, 7, '2019-09-06 08:55:50', 'Cute Mountains Inn', 'ifaynegl@parallels.com'),
(380, 1, '2020-01-18 00:24:08', 'Hotel deLuxe', 'wbracegirdle1l@comsenz.com'),
(381, 7, '2019-04-07 20:24:34', 'Hi-Way Inn', 'gblissittl0@hud.gov'),
(382, 8, '2020-01-29 15:41:59', 'Residence Inn', 'scatherine5j@redcross.org'),
(383, 9, '2019-01-24 23:04:33', 'Hi-Way Inn', 'slambregtsjw@europa.eu'),
(384, 5, '2019-12-18 04:41:40', 'Hilton Downtown', 'ndicarlib1@cnn.com'),
(385, 9, '2019-01-08 11:12:48', 'Cute Mountains Inn', 'ibartloszjv@exblog.jp'),
(386, 4, '2020-03-28 03:22:52', 'Residence Inn', 'vcowpe99@soundcloud.com'),
(387, 10, '2019-05-21 04:23:34', 'Candlewood Suites', 'smarchisogx@who.int'),
(388, 6, '2019-01-17 00:57:54', 'Luxor', 'kseckerr6@gnu.org'),
(389, 1, '2019-04-30 22:05:29', 'Hilton Downtown', 'cbullmana7@forbes.com'),
(390, 5, '2019-08-27 09:25:50', 'Candlewood Suites', 'tlaverenzdj@amazon.co.jp'),
(391, 6, '2020-03-14 12:44:29', 'The Paradise Inn', 'tharrellfw@naver.com'),
(392, 9, '2020-06-26 07:55:28', 'Hotel deLuxe', 'ksighartm6@twitpic.com'),
(393, 7, '2019-08-22 09:15:15', 'Hilton Downtown', 'lpinkardnb@rediff.com'),
(394, 1, '2019-02-10 20:00:33', 'Hampton Inn', 'pheggmz@storify.com'),
(395, 7, '2020-06-18 15:24:13', 'Luxor', 'esheedi6@redcross.org'),
(396, 3, '2020-07-08 20:59:54', 'Candlewood Suites', 'mcoito6@ibm.com'),
(397, 6, '2020-01-22 02:55:04', 'Residence Inn', 'ddarbishireet@nasa.gov'),
(398, 7, '2019-08-31 16:42:58', 'Luxor', 'gdeetlefsht@reuters.com'),
(399, 6, '2019-02-17 05:14:19', 'Hi-Way Inn', 'dkendala4@slideshare.net'),
(400, 10, '2019-07-20 16:53:31', 'Cute Mountains Inn', 'tmudd9t@ibm.com'),
(401, 3, '2020-07-31 03:55:11', 'Sheraton Centre', 'amacaleesef0@vkontakte.ru'),
(402, 10, '2020-02-09 05:48:46', 'Sheraton Centre', 'nscrannyoh@canalblog.com'),
(403, 8, '2020-06-09 23:09:40', 'The Paradise Inn', 'alongworthylc@admin.ch'),
(404, 3, '2019-10-12 22:07:39', 'Hotel deLuxe', 'mdabnerje@state.tx.us'),
(405, 6, '2019-05-30 08:29:25', 'Hi-Way Inn', 'anorth52@networksolutions.com'),
(406, 2, '2019-02-22 01:34:31', 'Candlewood Suites', 'jblissitt5u@cbslocal.com'),
(407, 5, '2019-05-08 19:36:16', 'Hampton Inn', 'ttuma69@addtoany.com'),
(408, 9, '2019-09-13 11:06:06', 'Residence Inn', 'kwalling22@ucoz.ru'),
(409, 5, '2019-02-19 00:39:43', 'Sheraton Centre', 'gduddingh@facebook.com'),
(410, 7, '2019-09-21 19:40:33', 'Hampton Inn', 'rvazquezpo@delicious.com'),
(411, 5, '2019-04-12 13:37:43', 'Luxor', 'tskillaa@auda.org.au'),
(412, 9, '2020-07-04 07:01:48', 'Hampton Inn', 'fothenlj@goo.gl'),
(413, 6, '2019-06-29 19:14:45', 'Cute Mountains Inn', 'dwhatford3v@npr.org'),
(414, 4, '2019-11-12 01:56:37', 'Cute Mountains Inn', 'aacomb11@wisc.edu'),
(415, 3, '2019-04-14 01:44:17', 'The Paradise Inn', 'bseear1@4shared.com'),
(416, 10, '2019-10-31 01:53:59', 'Residence Inn', 'kinglestoni2@istockphoto.com'),
(417, 7, '2019-09-02 03:22:40', 'The Paradise Inn', 'vredwin4h@sciencedirect.com'),
(418, 3, '2020-08-13 17:32:44', 'Hi-Way Inn', 'nglosterlm@squidoo.com'),
(419, 5, '2020-01-17 06:49:07', 'Hampton Inn', 'vpatrone8s@youku.com'),
(420, 5, '2020-07-01 21:18:42', 'Hampton Inn', 'jodney1z@nature.com'),
(421, 6, '2019-11-10 14:12:39', 'The Paradise Inn', 'jadame39@ebay.co.uk'),
(422, 5, '2020-01-30 05:55:10', 'Hotel deLuxe', 'shazlewooddu@newsvine.com'),
(423, 4, '2019-12-12 13:45:38', 'Hilton Downtown', 'aklimmek13@umich.edu'),
(424, 2, '2019-04-16 02:55:12', 'Hi-Way Inn', 'gcurtonj0@prlog.org'),
(425, 9, '2019-12-04 19:22:22', 'Sheraton Centre', 'iswiffan9q@soundcloud.com'),
(426, 4, '2020-06-18 11:11:11', 'Candlewood Suites', 'sdogg7h@tuttocitta.it'),
(427, 7, '2019-05-15 07:41:09', 'The Paradise Inn', 'rallans68@zimbio.com'),
(428, 5, '2020-04-11 01:58:49', 'Hilton Downtown', 'gaugustin1s@economist.com'),
(429, 1, '2019-06-03 22:52:16', 'Cute Mountains Inn', 'cferryja@hp.com'),
(430, 5, '2019-01-22 13:38:36', 'The Paradise Inn', 'erabjohnsk7@usgs.gov'),
(431, 10, '2020-08-04 08:00:23', 'Residence Inn', 'ltriplettgd@cocolog-nifty.com'),
(432, 10, '2019-07-01 01:08:06', 'Luxor', 'asolon9g@clickbank.net'),
(433, 3, '2020-06-25 22:50:30', 'Residence Inn', 'clongmanal@admin.ch'),
(434, 7, '2019-09-08 11:40:59', 'Residence Inn', 'dbonannok@columbia.edu'),
(435, 5, '2020-01-07 12:29:30', 'Luxor', 'jsicilyem@weibo.com'),
(436, 8, '2019-03-24 00:29:32', 'Hotel deLuxe', 'agonneaue0@surveymonkey.com'),
(437, 8, '2020-06-23 17:41:40', 'Cute Mountains Inn', 'vchapple2l@gizmodo.com'),
(438, 1, '2019-01-16 18:10:06', 'Hilton Downtown', 'tkobus4j@eventbrite.com'),
(439, 6, '2019-10-15 17:34:19', 'Hilton Downtown', 'aking3e@bbb.org'),
(440, 9, '2020-05-05 08:10:21', 'Sheraton Centre', 'kseckerr6@gnu.org'),
(441, 6, '2019-12-30 05:45:39', 'The Paradise Inn', 'mfaier1g@miibeian.gov.cn'),
(442, 5, '2020-08-09 13:08:10', 'Candlewood Suites', 'lgoublierjz@arstechnica.com'),
(443, 3, '2019-02-13 06:43:23', 'Hotel deLuxe', 'aklimmek13@umich.edu'),
(444, 4, '2019-09-04 10:31:55', 'Hi-Way Inn', 'bdutnall8l@bloomberg.com'),
(445, 4, '2019-01-08 10:49:53', 'Sheraton Centre', 'tswinburneay@trellian.com'),
(446, 10, '2019-11-25 12:25:21', 'Hi-Way Inn', 'nmolanqg@uol.com.br'),
(447, 7, '2019-04-04 22:30:33', 'Cute Mountains Inn', 'neidelman7a@ed.gov'),
(448, 10, '2019-01-31 10:03:53', 'Hilton Downtown', 'gplail3s@de.vu'),
(449, 1, '2019-11-08 12:26:50', 'The Paradise Inn', 'csoltanfx@cnn.com'),
(450, 1, '2019-05-24 05:15:16', 'Hilton Downtown', 'fscattergoodp6@ezinearticles.com'),
(451, 3, '2020-06-07 17:50:45', 'Residence Inn', 'cmcauliffear@xinhuanet.com'),
(452, 7, '2019-01-08 13:12:10', 'Candlewood Suites', 'mdutteridgeas@typepad.com'),
(453, 2, '2019-12-06 00:33:45', 'Candlewood Suites', 'gtongelx@posterous.com'),
(454, 2, '2019-08-16 23:53:04', 'Sheraton Centre', 'cferryja@hp.com'),
(455, 1, '2019-07-07 09:02:10', 'Hampton Inn', 'jcolleltonb@qq.com'),
(456, 9, '2019-05-18 12:55:35', 'The Paradise Inn', 'ddarbishireet@nasa.gov'),
(457, 10, '2019-12-12 09:19:58', 'Cute Mountains Inn', 'hscotlandda@amazon.co.uk'),
(458, 7, '2020-05-04 07:27:15', 'Candlewood Suites', 'bchapellowiu@etsy.com'),
(459, 5, '2019-03-10 22:21:43', 'Residence Inn', 'sgoldsbyh4@weather.com'),
(460, 3, '2019-06-28 22:45:53', 'The Paradise Inn', 'agengekn@mozilla.org'),
(461, 4, '2019-02-22 13:40:17', 'Hi-Way Inn', 'etween61@g.co'),
(462, 1, '2020-04-04 10:37:39', 'Hilton Downtown', 'mdudenie3i@soundcloud.com'),
(463, 2, '2019-01-03 18:23:07', 'Luxor', 'amenaulcp@over-blog.com'),
(464, 7, '2020-06-13 12:44:42', 'Sheraton Centre', 'khallgalleyfy@free.fr'),
(465, 5, '2019-03-12 23:06:01', 'Candlewood Suites', 'imagowan3b@yolasite.com'),
(466, 9, '2020-02-10 03:57:06', 'Cute Mountains Inn', 'zaistropej@ox.ac.uk'),
(467, 8, '2019-10-01 07:35:06', 'The Paradise Inn', 'hchantillonnw@usnews.com'),
(468, 9, '2020-07-18 13:43:24', 'Hampton Inn', 'ascholfieldhs@admin.ch'),
(469, 2, '2019-10-07 19:21:53', 'Hi-Way Inn', 'acroixnm@bloglines.com'),
(470, 5, '2020-01-14 11:44:43', 'Candlewood Suites', 'caymericho3@google.com.au'),
(471, 3, '2019-02-13 03:34:59', 'Luxor', 'lmurneymp@diigo.com'),
(472, 4, '2019-10-15 18:16:10', 'Residence Inn', 'swillesonco@lulu.com'),
(473, 5, '2019-01-04 00:11:37', 'Hi-Way Inn', 'gcarrabotmi@yandex.ru'),
(474, 2, '2019-06-26 18:41:40', 'Residence Inn', 'vcowpe99@soundcloud.com'),
(475, 2, '2020-01-13 21:34:52', 'Cute Mountains Inn', 'nbrimicombed@flickr.com'),
(476, 10, '2019-07-09 05:53:46', 'Hampton Inn', 'rriddeoughbp@theguardian.com'),
(477, 4, '2019-08-08 13:46:03', 'Hotel deLuxe', 'akemitt2m@ca.gov'),
(478, 2, '2019-08-31 07:19:49', 'Hampton Inn', 'hsherratt2o@google.nl'),
(479, 9, '2020-07-23 14:01:19', 'Residence Inn', 'rblankley4d@wikimedia.org'),
(480, 8, '2019-07-13 06:01:27', 'Hilton Downtown', 'mpennialld3@cafepress.com'),
(481, 9, '2019-04-01 01:52:40', 'Candlewood Suites', 'mdedneycj@theguardian.com'),
(482, 6, '2019-02-09 14:43:58', 'Sheraton Centre', 'lbroune5d@godaddy.com'),
(483, 4, '2019-02-15 05:57:06', 'Cute Mountains Inn', 'amiddiff6t@paypal.com'),
(484, 8, '2020-03-27 03:10:12', 'Luxor', 'ajaycockqo@ehow.com'),
(485, 4, '2019-06-11 22:13:46', 'Hi-Way Inn', 'odoubledaybj@friendfeed.com'),
(486, 10, '2020-01-23 09:45:53', 'Hi-Way Inn', 'heydelos@aol.com'),
(487, 1, '2020-03-16 18:18:08', 'Cute Mountains Inn', 'polivera9b@1und1.de'),
(488, 6, '2019-11-27 00:58:33', 'Residence Inn', 'pgraingehx@businessweek.com'),
(489, 1, '2019-11-03 09:02:18', 'Hotel deLuxe', 'eibbetsone3@creativecommons.org'),
(490, 5, '2019-04-03 16:12:26', 'Hilton Downtown', 'nwreakesd8@sourceforge.net'),
(491, 9, '2020-07-28 01:39:25', 'Cute Mountains Inn', 'mvickressc2@blogs.com'),
(492, 5, '2019-11-28 07:37:17', 'Luxor', 'ahalshaw64@berkeley.edu'),
(493, 9, '2019-12-26 04:33:16', 'Hilton Downtown', 'jblissitt5u@cbslocal.com'),
(494, 4, '2019-07-06 23:21:43', 'Hi-Way Inn', 'oleemansdc@mapy.cz'),
(495, 3, '2020-04-27 18:59:34', 'Hi-Way Inn', 'ajelksic@huffingtonpost.com'),
(496, 5, '2019-04-12 07:12:39', 'Hotel deLuxe', 'sgricks5k@nydailynews.com'),
(497, 3, '2019-04-21 11:56:01', 'Cute Mountains Inn', 'mwarnockgg@xrea.com'),
(498, 10, '2019-11-12 02:05:04', 'Residence Inn', 'seisoldk2@dagondesign.com'),
(499, 4, '2020-04-10 09:04:10', 'The Paradise Inn', 'esitlinton3z@joomla.org'),
(500, 4, '2020-05-11 20:35:26', 'Hilton Downtown', 'nnovak4v@weather.com'),
(501, 3, '2020-02-16 18:24:59', 'Hilton Downtown', 'fscattergoodp6@ezinearticles.com'),
(502, 7, '2020-05-27 07:47:01', 'Hi-Way Inn', 'swalbrooklr@ihg.com'),
(503, 6, '2019-03-29 10:05:17', 'The Paradise Inn', 'sdesbrowgv@google.co.jp'),
(504, 10, '2019-04-08 10:06:26', 'Residence Inn', 'hrunseyhp@redcross.org'),
(505, 4, '2019-07-03 16:10:46', 'Cute Mountains Inn', 'apeidrocq@slideshare.net'),
(506, 1, '2019-11-09 08:33:17', 'Hotel deLuxe', 'gmoulink5@addtoany.com'),
(507, 9, '2020-01-17 19:57:43', 'Hi-Way Inn', 'cgrimwadeet@artisteer.com'),
(508, 10, '2020-03-27 09:05:26', 'The Paradise Inn', 'dgamil8m@e-recht24.de'),
(509, 4, '2020-03-12 17:36:06', 'Hotel deLuxe', 'htimmense4@infoseek.co.jp'),
(510, 3, '2019-07-13 22:19:50', 'Luxor', 'bdewanebh@google.fr'),
(511, 4, '2019-03-24 12:52:15', 'Luxor', 'eyushmanovlc@wikispaces.com'),
(512, 6, '2020-02-07 23:13:56', 'The Paradise Inn', 'wrickesies4x@yandex.ru'),
(513, 2, '2020-03-31 04:06:49', 'Sheraton Centre', 'yphaup7k@godaddy.com'),
(514, 3, '2019-08-03 18:39:34', 'Hi-Way Inn', 'kgoulter1b@gmpg.org'),
(515, 1, '2019-03-01 05:44:30', 'Hotel deLuxe', 'hastberyqm@trellian.com'),
(516, 7, '2019-02-25 19:28:25', 'Hampton Inn', 'clamming53@booking.com'),
(517, 3, '2019-01-10 08:10:36', 'The Paradise Inn', 'bdownes2d@amazonaws.com'),
(518, 2, '2019-12-18 20:46:28', 'The Paradise Inn', 'gdwinejc@aol.com'),
(519, 8, '2019-04-03 23:13:31', 'The Paradise Inn', 'sminnisp4@cafepress.com'),
(520, 9, '2020-04-23 12:14:21', 'Hotel deLuxe', 'gtongelx@posterous.com'),
(521, 2, '2019-03-08 13:08:55', 'Luxor', 'dwestburyac@howstuffworks.com'),
(522, 1, '2019-02-18 13:42:00', 'Hampton Inn', 'pcrispe7l@angelfire.com'),
(523, 5, '2019-01-07 02:25:12', 'Hi-Way Inn', 'bgregl8@liveinternet.ru'),
(524, 8, '2019-08-21 16:47:10', 'Sheraton Centre', 'llowdham5s@chron.com'),
(525, 1, '2020-01-06 17:25:40', 'Luxor', 'dcorstanng@smugmug.com'),
(526, 4, '2019-03-14 09:38:24', 'Sheraton Centre', 'gmarcubk@technorati.com'),
(527, 9, '2019-10-14 12:25:52', 'Hampton Inn', 'ftwitty3@discuz.net'),
(528, 8, '2019-08-25 11:40:59', 'Candlewood Suites', 'ekellittkq@boston.com'),
(529, 3, '2019-02-05 22:12:35', 'Cute Mountains Inn', 'lcreganij@va.gov'),
(530, 7, '2019-11-11 19:57:30', 'Hi-Way Inn', 'sedelheid9p@google.nl'),
(531, 4, '2020-07-03 14:30:15', 'Hotel deLuxe', 'istonnelleb@indiegogo.com'),
(532, 8, '2019-12-27 00:10:12', 'The Paradise Inn', 'imarkosed@china.com.cn'),
(533, 5, '2020-03-06 01:04:13', 'Hampton Inn', 'droafa5@angelfire.com'),
(534, 4, '2019-12-12 22:26:38', 'Hi-Way Inn', 'pduffett8o@chron.com'),
(535, 8, '2020-02-04 16:24:51', 'Cute Mountains Inn', 'mjennokw@digg.com'),
(536, 10, '2019-01-10 23:04:47', 'Hampton Inn', 'rleggenff@prweb.com'),
(537, 3, '2020-06-09 18:12:28', 'Cute Mountains Inn', 'dmariottenq@surveymonkey.com'),
(538, 1, '2019-05-13 05:07:59', 'Sheraton Centre', 'koreaganbr@cisco.com'),
(539, 2, '2020-01-12 14:50:56', 'Candlewood Suites', 'vmchardykf@topsy.com'),
(540, 10, '2019-02-26 11:12:14', 'Hampton Inn', 'lwildepn@ebay.com'),
(541, 8, '2020-02-25 16:13:13', 'Hi-Way Inn', 'gloucheha@com.com'),
(542, 5, '2019-10-23 01:57:02', 'Cute Mountains Inn', 'tlockheadqn@earthlink.net'),
(543, 8, '2020-08-11 17:47:35', 'Hampton Inn', 'jdursleyqh@ameblo.jp'),
(544, 3, '2020-06-28 04:58:28', 'Hi-Way Inn', 'ctrundlergr@deliciousdays.com'),
(545, 4, '2019-02-02 23:40:04', 'Hotel deLuxe', 'dgodilington4c@nationalgeographic.com'),
(546, 4, '2019-03-01 03:39:44', 'Sheraton Centre', 'tdonaho2t@amazon.co.uk'),
(547, 10, '2020-03-30 07:43:58', 'Candlewood Suites', 'kshotboultei4@msn.com'),
(548, 9, '2020-03-03 15:42:11', 'Cute Mountains Inn', 'nperdue5w@nature.com'),
(549, 7, '2020-01-02 00:58:39', 'Candlewood Suites', 'athurbonnt@newsvine.com'),
(550, 5, '2019-09-23 07:51:00', 'Candlewood Suites', 'rknocker4q@mediafire.com'),
(551, 3, '2019-07-17 20:12:32', 'Sheraton Centre', 'rbillingtonm0@ibm.com'),
(552, 2, '2020-01-07 11:20:11', 'Hampton Inn', 'gdrage5d@adobe.com'),
(553, 10, '2019-03-22 15:41:29', 'Hi-Way Inn', 'ecaig3o@craigslist.org'),
(554, 10, '2020-07-13 23:20:44', 'Hampton Inn', 'eparsell6u@squarespace.com'),
(555, 1, '2019-12-09 01:44:30', 'The Paradise Inn', 'bcrinagef7@usda.gov'),
(556, 9, '2020-05-13 08:32:40', 'The Paradise Inn', 'ewilcocksbx@elegantthemes.com'),
(557, 3, '2020-02-15 11:53:43', 'Hotel deLuxe', 'fmckeney8l@bbb.org'),
(558, 1, '2019-08-22 15:33:10', 'The Paradise Inn', 'gglewau@vimeo.com'),
(559, 1, '2020-07-20 11:29:02', 'Cute Mountains Inn', 'klibbis4n@cmu.edu'),
(560, 5, '2019-09-03 03:49:38', 'Hilton Downtown', 'idebruynev@tuttocitta.it'),
(561, 6, '2019-07-13 03:57:27', 'Candlewood Suites', 'apaulmannoy@weebly.com'),
(562, 5, '2019-07-30 17:25:30', 'Hampton Inn', 'mdecarlok3@barnesandnoble.com'),
(563, 2, '2019-05-28 08:49:57', 'Sheraton Centre', 'nhorburghoc@odnoklassniki.ru'),
(564, 6, '2019-10-24 06:45:25', 'Cute Mountains Inn', 'zjinkinou@sogou.com'),
(565, 6, '2019-12-08 16:37:31', 'Cute Mountains Inn', 'jspowage85@narod.ru'),
(566, 3, '2020-04-11 03:20:52', 'Candlewood Suites', 'mcoito6@ibm.com'),
(567, 8, '2018-12-31 21:05:31', 'Sheraton Centre', 'odutnelljm@liveinternet.ru'),
(568, 5, '2019-07-17 20:32:46', 'Hotel deLuxe', 'caymericho3@google.com.au'),
(569, 3, '2019-03-13 16:57:24', 'Residence Inn', 'wbracegirdle1l@comsenz.com'),
(570, 8, '2020-08-14 00:38:13', 'Hi-Way Inn', 'mlivesayl1@sun.com'),
(571, 7, '2019-10-27 06:38:03', 'Hilton Downtown', 'swillesonco@lulu.com'),
(572, 8, '2020-01-26 16:36:45', 'Candlewood Suites', 'ccanons@sun.com'),
(573, 8, '2020-01-15 07:45:01', 'Residence Inn', 'sgiffautbb@csmonitor.com'),
(574, 7, '2020-04-05 06:02:23', 'Hi-Way Inn', 'cedwardsot@salon.com'),
(575, 8, '2019-08-13 19:35:25', 'Residence Inn', 'kinglestoni2@istockphoto.com'),
(576, 10, '2020-03-23 08:26:05', 'Hilton Downtown', 'bpalffynj@etsy.com'),
(577, 3, '2020-01-03 21:28:59', 'Cute Mountains Inn', 'rmilellag1@slashdot.org'),
(578, 8, '2019-11-23 10:45:00', 'Hi-Way Inn', 'mdonhardt6v@theguardian.com'),
(579, 8, '2019-01-20 16:55:11', 'Residence Inn', 'rfinlaysonk4@cnet.com'),
(580, 9, '2020-04-07 15:27:30', 'The Paradise Inn', 'wcastagnier92@upenn.edu'),
(581, 4, '2019-04-10 12:09:58', 'Sheraton Centre', 'lgoublierjz@arstechnica.com'),
(582, 2, '2019-07-09 16:57:42', 'Hi-Way Inn', 'drobartic@fastcompany.com'),
(583, 9, '2019-04-23 13:25:33', 'Hilton Downtown', 'oshortonll@constantcontact.com'),
(584, 3, '2019-11-27 03:10:35', 'Residence Inn', 'fuphill2y@oaic.gov.au'),
(585, 1, '2019-04-19 12:34:19', 'Hotel deLuxe', 'nsweetland3g@ezinearticles.com'),
(586, 8, '2019-12-31 08:42:20', 'The Paradise Inn', 'uhazeldenerj@tinyurl.com'),
(587, 3, '2019-12-11 17:50:57', 'Cute Mountains Inn', 'ngrayleyae@latimes.com'),
(588, 4, '2019-12-05 04:39:01', 'The Paradise Inn', 'atagglr@posterous.com'),
(589, 7, '2020-06-29 02:03:19', 'Hampton Inn', 'fhalypl@microsoft.com'),
(590, 4, '2019-10-01 01:52:49', 'Hilton Downtown', 'dmclauchlinkg@patch.com'),
(591, 8, '2020-02-10 11:53:03', 'Hi-Way Inn', 'gbocock8q@alexa.com'),
(592, 8, '2019-01-25 01:34:30', 'The Paradise Inn', 'gfalkjq@cnbc.com'),
(593, 5, '2020-02-24 16:57:25', 'Hi-Way Inn', 'mronaynekh@house.gov'),
(594, 6, '2020-04-12 13:47:55', 'Hi-Way Inn', 'kboydaoo@altervista.org'),
(595, 1, '2020-02-16 09:02:59', 'Hilton Downtown', 'ewollrauche7@loc.gov'),
(596, 7, '2020-01-14 19:52:17', 'Residence Inn', 'plytleht@soup.io'),
(597, 4, '2019-07-18 19:09:48', 'Cute Mountains Inn', 'ccawkwell6n@businessinsider.com'),
(598, 10, '2019-09-08 13:08:45', 'Hotel deLuxe', 'kbarteletbg@liveinternet.ru'),
(599, 6, '2020-06-06 15:24:40', 'Hi-Way Inn', 'bronaldsonaw@yahoo.co.jp'),
(600, 8, '2019-04-16 07:20:17', 'Candlewood Suites', 'jlansdown3u@yahoo.com'),
(601, 9, '2019-01-03 16:45:56', 'The Paradise Inn', 'bfinlator4t@dell.com'),
(602, 5, '2019-12-02 09:36:01', 'Cute Mountains Inn', 'nhorburghoc@odnoklassniki.ru'),
(603, 8, '2019-05-20 19:51:13', 'Hilton Downtown', 'kgaulef9@mtv.com'),
(604, 9, '2020-08-06 08:30:53', 'Hilton Downtown', 'mgerb45@aol.com'),
(605, 2, '2019-12-02 04:24:17', 'Hampton Inn', 'mhousecrafto2@g.co'),
(606, 6, '2020-07-07 22:26:42', 'Cute Mountains Inn', 'fbonhillmc@google.com.br'),
(607, 10, '2019-05-30 06:51:52', 'Hi-Way Inn', 'alongworthylc@admin.ch'),
(608, 8, '2020-04-01 16:24:40', 'Cute Mountains Inn', 'mgoodersgz@posterous.com'),
(609, 9, '2019-07-19 10:02:03', 'Candlewood Suites', 'cchesson2b@samsung.com'),
(610, 6, '2020-07-05 23:19:29', 'Cute Mountains Inn', 'bestable7c@list-manage.com'),
(611, 2, '2019-01-14 14:14:16', 'Hi-Way Inn', 'dfilipputti96@theguardian.com'),
(612, 4, '2020-08-09 23:32:25', 'Sheraton Centre', 'awhetnell8s@intel.com'),
(613, 8, '2019-09-15 20:35:20', 'Sheraton Centre', 'cbushell9j@nature.com'),
(614, 2, '2020-02-23 02:21:30', 'Sheraton Centre', 'grogerothq@bravesites.com'),
(615, 4, '2019-02-01 08:15:18', 'Hilton Downtown', 'gfalkjq@cnbc.com'),
(616, 2, '2020-06-12 09:16:27', 'The Paradise Inn', 'mclaxson1p@npr.org'),
(617, 2, '2020-04-12 20:42:54', 'Candlewood Suites', 'rtattershaw30@cnbc.com'),
(618, 1, '2019-03-26 15:26:03', 'Hi-Way Inn', 'tdurn73@cargocollective.com'),
(619, 2, '2019-06-23 01:14:53', 'Cute Mountains Inn', 'lattrideca@seesaa.net'),
(620, 7, '2020-06-26 14:58:04', 'Candlewood Suites', 'wmatfieldfu@shop-pro.jp'),
(621, 9, '2019-06-28 05:35:06', 'Hilton Downtown', 'moverellgd@discuz.net'),
(622, 4, '2020-04-16 12:30:09', 'Hotel deLuxe', 'ddmitrichenkoco@over-blog.com'),
(623, 5, '2020-07-08 22:56:40', 'Hotel deLuxe', 'aohoeybz@amazon.de'),
(624, 10, '2019-03-07 23:05:21', 'The Paradise Inn', 'cstickelp9@cdc.gov'),
(625, 10, '2019-06-26 19:35:06', 'Hampton Inn', 'hchristopher2j@yale.edu'),
(626, 6, '2019-07-08 14:10:44', 'Residence Inn', 'abeamondrq@utexas.edu'),
(627, 3, '2019-01-13 16:43:56', 'Hi-Way Inn', 'mmcclancyn9@msn.com'),
(628, 9, '2019-08-15 06:35:44', 'Hi-Way Inn', 'ndicarlib1@cnn.com'),
(629, 9, '2019-07-23 16:07:50', 'Hilton Downtown', 'klaversj9@parallels.com'),
(630, 10, '2019-07-03 09:51:39', 'Hotel deLuxe', 'ceusteslx@dell.com'),
(631, 1, '2020-05-10 14:20:18', 'Hi-Way Inn', 'gjenkinol@comsenz.com'),
(632, 2, '2019-07-29 01:07:11', 'Residence Inn', 'adorow9j@washington.edu'),
(633, 10, '2019-06-18 05:37:55', 'Sheraton Centre', 'vblazejewski2l@odnoklassniki.ru'),
(634, 8, '2020-07-17 22:23:09', 'Hi-Way Inn', 'sdoldonky@163.com'),
(635, 2, '2019-06-01 18:46:09', 'Residence Inn', 'aphillinsls@discuz.net'),
(636, 3, '2020-07-23 21:09:38', 'Candlewood Suites', 'oelsmoredl@spiegel.de'),
(637, 5, '2020-01-11 15:58:39', 'Luxor', 'jgreenigp2@alibaba.com'),
(638, 9, '2020-04-11 16:38:49', 'Hotel deLuxe', 'fforson5l@ihg.com'),
(639, 5, '2019-09-21 15:45:46', 'Cute Mountains Inn', 'jdene44@wired.com'),
(640, 7, '2020-06-12 14:00:54', 'Hi-Way Inn', 'hmcgeacheypr@facebook.com'),
(641, 7, '2020-07-13 04:38:24', 'Residence Inn', 'lpharrowpt@cbc.ca'),
(642, 5, '2019-05-12 16:07:49', 'Hotel deLuxe', 'ssowtefo@wufoo.com'),
(643, 2, '2020-03-28 09:46:32', 'Hi-Way Inn', 'nmatonin2f@blinklist.com'),
(644, 9, '2019-01-03 23:35:39', 'Sheraton Centre', 'eaylmorer7@addtoany.com'),
(645, 1, '2019-11-22 00:46:29', 'Hi-Way Inn', 'jcheasmanh6@google.com.hk'),
(646, 9, '2019-04-27 17:12:20', 'Luxor', 'rknocker4q@mediafire.com'),
(647, 10, '2019-08-14 06:13:29', 'Cute Mountains Inn', 'cfreiburgerpo@livejournal.com'),
(648, 3, '2020-05-21 10:45:44', 'Sheraton Centre', 'acarlesine@ucoz.com'),
(649, 3, '2019-07-29 18:42:20', 'Hilton Downtown', 'jflanndd@phoca.cz'),
(650, 7, '2020-04-27 07:23:43', 'Residence Inn', 'atagglr@posterous.com'),
(651, 1, '2020-03-08 06:31:19', 'Hotel deLuxe', 'nperdue5w@nature.com'),
(652, 7, '2019-03-21 21:14:13', 'Hotel deLuxe', 'bblinde0@over-blog.com'),
(653, 3, '2020-05-14 12:56:14', 'Candlewood Suites', 'nscrannyoh@canalblog.com'),
(654, 4, '2019-10-08 05:30:29', 'Residence Inn', 'swankai@weebly.com'),
(655, 9, '2019-08-04 16:52:34', 'Hampton Inn', 'tkobus4j@eventbrite.com'),
(656, 6, '2019-04-04 03:26:58', 'The Paradise Inn', 'jreadwin49@redcross.org'),
(657, 4, '2020-07-16 12:43:20', 'Sheraton Centre', 'gdrage5d@adobe.com'),
(658, 7, '2020-04-09 07:33:08', 'Cute Mountains Inn', 'lbroune5d@godaddy.com'),
(659, 8, '2019-09-07 06:17:51', 'Hi-Way Inn', 'pgraingehx@businessweek.com'),
(660, 5, '2019-04-16 14:27:36', 'Hampton Inn', 'ehelleckasoi@usatoday.com'),
(661, 8, '2020-05-12 20:07:06', 'Hampton Inn', 'jjoulpa@home.pl'),
(662, 8, '2019-03-18 09:59:59', 'Luxor', 'jkasnm@businesswire.com'),
(663, 2, '2019-10-19 10:16:13', 'Luxor', 'screhank1@github.io'),
(664, 1, '2019-07-08 12:47:03', 'Hilton Downtown', 'vdumbltonnc@nymag.com'),
(665, 10, '2020-01-28 02:27:57', 'Candlewood Suites', 'fhillsdx@naver.com'),
(666, 3, '2020-03-13 02:53:39', 'Hi-Way Inn', 'sduffynkc@marketwatch.com'),
(667, 8, '2019-08-22 06:37:11', 'Hampton Inn', 'rfurmagehr@clickbank.net'),
(668, 10, '2019-05-31 21:51:43', 'Sheraton Centre', 'zduelleg@mit.edu'),
(669, 8, '2019-04-22 02:53:49', 'Luxor', 'adignumnv@amazon.de'),
(670, 9, '2019-09-19 08:59:01', 'Residence Inn', 'tshine6b@topsy.com'),
(671, 7, '2019-09-08 22:55:31', 'Luxor', 'eskedgex@hao123.com'),
(672, 1, '2019-05-27 13:37:04', 'Residence Inn', 'klilywhitef@jigsy.com'),
(673, 9, '2020-04-29 22:36:47', 'Hampton Inn', 'mhodgets5x@theatlantic.com'),
(674, 10, '2019-06-30 13:40:39', 'Residence Inn', 'aphillinsls@discuz.net'),
(675, 1, '2019-10-23 14:45:19', 'Hampton Inn', 'horiel71@comcast.net'),
(676, 4, '2020-05-19 05:53:13', 'Sheraton Centre', 'gscraggeh@macromedia.com');
INSERT INTO `review` (`review_id`, `rating`, `date_created`, `property_name`, `user_email`) VALUES
(677, 4, '2019-01-20 18:36:39', 'Hi-Way Inn', 'lgadesby8u@e-recht24.de'),
(678, 1, '2020-03-25 22:19:20', 'Candlewood Suites', 'bdunnanqp@gnu.org'),
(679, 10, '2019-03-16 03:29:00', 'Hotel deLuxe', 'rgass2h@newyorker.com'),
(680, 9, '2019-06-16 13:58:47', 'Hotel deLuxe', 'gtowsonai@ca.gov'),
(681, 2, '2019-06-28 09:34:25', 'Hampton Inn', 'hscotlandda@amazon.co.uk'),
(682, 4, '2019-03-29 18:06:16', 'Cute Mountains Inn', 'dquogancy@wsj.com'),
(683, 6, '2019-10-25 23:27:54', 'Hampton Inn', 'ccotillardge@blogger.com'),
(684, 6, '2020-07-09 04:53:45', 'Cute Mountains Inn', 'gglewau@vimeo.com'),
(685, 2, '2019-01-16 18:18:51', 'Cute Mountains Inn', 'cmoleng0@yellowbook.com'),
(686, 2, '2020-08-10 14:08:57', 'The Paradise Inn', 'sjouanetonl2@loc.gov'),
(687, 3, '2019-04-03 23:03:17', 'Hilton Downtown', 'bvenmorenf@aol.com'),
(688, 5, '2019-08-05 09:38:07', 'Hilton Downtown', 'igoaks9w@hexun.com'),
(689, 3, '2020-05-19 09:04:58', 'Candlewood Suites', 'fkleslbz@nationalgeographic.com'),
(690, 6, '2019-02-14 11:25:05', 'Residence Inn', 'wsirkett38@drupal.org'),
(691, 3, '2019-09-16 04:02:49', 'Candlewood Suites', 'rlabror3@abc.net.au'),
(692, 2, '2020-06-21 15:56:59', 'Hampton Inn', 'idemicoli1h@de.vu'),
(693, 5, '2020-06-22 18:10:32', 'Hi-Way Inn', 'nogeaneynh@webmd.com'),
(694, 6, '2019-09-21 08:55:17', 'The Paradise Inn', 'pchadneyiz@marketwatch.com'),
(695, 9, '2020-06-23 16:56:45', 'The Paradise Inn', 'tdurn73@cargocollective.com'),
(696, 6, '2020-01-18 19:23:58', 'Hotel deLuxe', 'rainleybb@tmall.com'),
(697, 1, '2019-03-04 15:43:43', 'The Paradise Inn', 'hpetruszka5a@sina.com.cn'),
(698, 9, '2020-07-09 16:54:25', 'Residence Inn', 'lvanvuuren79@answers.com'),
(699, 4, '2020-05-27 13:32:13', 'Residence Inn', 'mkellard8p@ftc.gov'),
(700, 6, '2019-08-23 19:55:42', 'Sheraton Centre', 'nblowinglh@vimeo.com'),
(701, 9, '2019-07-23 03:26:00', 'Hi-Way Inn', 'lpinkardnb@rediff.com'),
(702, 3, '2020-06-12 00:50:42', 'Hilton Downtown', 'bpalffynj@etsy.com'),
(703, 8, '2020-04-22 08:35:30', 'The Paradise Inn', 'amajurye5@163.com'),
(704, 6, '2019-03-16 17:50:35', 'Cute Mountains Inn', 'rknocker4q@mediafire.com'),
(705, 9, '2020-01-21 13:07:54', 'Hilton Downtown', 'rnajera3c@google.es'),
(706, 10, '2019-05-26 14:13:41', 'Cute Mountains Inn', 'mbrosettifb@timesonline.co.uk'),
(707, 8, '2019-12-05 10:55:43', 'Hi-Way Inn', 'hcharrett5n@live.com'),
(708, 8, '2019-08-03 20:34:54', 'Residence Inn', 'amennear94@yolasite.com'),
(709, 4, '2020-04-24 22:05:30', 'The Paradise Inn', 'vblazejewski2l@odnoklassniki.ru'),
(710, 5, '2020-05-22 19:41:26', 'Hi-Way Inn', 'kriddell4b@china.com.cn'),
(711, 4, '2020-05-18 12:23:26', 'Hi-Way Inn', 'ggravellsgz@photobucket.com'),
(712, 8, '2019-05-09 23:03:26', 'Sheraton Centre', 'gmccrowo1@blogger.com'),
(713, 6, '2019-10-14 03:42:02', 'Sheraton Centre', 'bbeagriegw@mail.ru'),
(714, 5, '2020-02-22 17:44:06', 'Luxor', 'pwhitebrooker@prnewswire.com'),
(715, 4, '2019-02-03 17:29:47', 'Hampton Inn', 'mgirodonp7@t-online.de'),
(716, 6, '2019-05-27 07:04:52', 'The Paradise Inn', 'swhilderit@qq.com'),
(717, 10, '2019-12-09 10:59:03', 'Cute Mountains Inn', 'tcliffordm5@phoca.cz'),
(718, 10, '2019-01-31 17:23:07', 'Hilton Downtown', 'rfelten36@godaddy.com'),
(719, 6, '2020-06-28 07:38:18', 'Residence Inn', 'elumsdaledf@w3.org'),
(720, 1, '2019-01-24 21:10:02', 'Luxor', 'iwisniewskio0@toplist.cz'),
(721, 9, '2020-04-22 03:25:31', 'Residence Inn', 'gfalkjq@cnbc.com'),
(722, 8, '2019-01-26 09:54:04', 'Hi-Way Inn', 'bgregl8@liveinternet.ru'),
(723, 5, '2019-03-26 09:09:33', 'Hotel deLuxe', 'lventoned@over-blog.com'),
(724, 7, '2019-06-13 20:24:34', 'Hilton Downtown', 'tcowtharddb@howstuffworks.com'),
(725, 9, '2019-09-24 21:11:39', 'Sheraton Centre', 'mdugdalenk@usgs.gov'),
(726, 7, '2019-10-22 11:04:30', 'Candlewood Suites', 'amarqyeso@infoseek.co.jp'),
(727, 9, '2020-07-30 18:34:55', 'Sheraton Centre', 'kbakeyhe@dmoz.org'),
(728, 5, '2019-10-25 01:18:20', 'Luxor', 'alotterington1w@mit.edu'),
(729, 5, '2019-09-01 15:07:50', 'Hotel deLuxe', 'mserraillier9m@pen.io'),
(730, 2, '2019-02-09 13:57:59', 'Hampton Inn', 'cokief2@studiopress.com'),
(731, 1, '2019-09-16 02:24:48', 'Luxor', 'jstredderp4@addtoany.com'),
(732, 9, '2019-08-01 04:49:44', 'The Paradise Inn', 'ewealleans3x@miitbeian.gov.cn'),
(733, 5, '2019-03-12 08:22:53', 'Hotel deLuxe', 'scharterd6@deliciousdays.com'),
(734, 10, '2020-01-05 07:28:16', 'Sheraton Centre', 'rtebbitiz@nasa.gov'),
(735, 5, '2020-02-23 23:22:07', 'Luxor', 'mkellard8p@ftc.gov'),
(736, 2, '2019-08-10 13:12:51', 'The Paradise Inn', 'goscroftkn@ucoz.ru'),
(737, 3, '2019-12-19 13:39:14', 'Candlewood Suites', 'ktottjh@japanpost.jp'),
(738, 1, '2020-06-23 16:28:57', 'Residence Inn', 'eshellshearow@forbes.com'),
(739, 2, '2019-09-11 13:38:52', 'Candlewood Suites', 'rambrozkv@php.net'),
(740, 1, '2020-08-14 03:08:50', 'Hilton Downtown', 'awonfar3w@pcworld.com'),
(741, 10, '2020-05-28 10:38:52', 'Candlewood Suites', 'lbennsn2@umn.edu'),
(742, 5, '2019-02-17 05:18:59', 'Candlewood Suites', 'lhattrick9z@eventbrite.com'),
(743, 9, '2019-03-14 13:10:04', 'Hi-Way Inn', 'ncastagnen0@twitpic.com'),
(744, 9, '2019-11-27 18:46:01', 'Cute Mountains Inn', 'gcreaser1j@npr.org'),
(745, 8, '2019-05-31 13:27:44', 'Hi-Way Inn', 'frydzynskigm@archive.org'),
(746, 10, '2019-09-23 03:16:33', 'Cute Mountains Inn', 'lbennsn2@umn.edu'),
(747, 10, '2020-04-04 16:26:35', 'Hotel deLuxe', 'gfilov2e@huffingtonpost.com'),
(748, 7, '2019-05-19 22:27:24', 'Luxor', 'cjansson2i@studiopress.com'),
(749, 9, '2019-04-05 18:17:11', 'Residence Inn', 'dkemster6s@moonfruit.com'),
(750, 6, '2019-02-13 22:01:39', 'Candlewood Suites', 'ftwitty3@discuz.net'),
(751, 8, '2019-01-27 22:21:17', 'Hotel deLuxe', 'tsextyef@flavors.me'),
(752, 1, '2019-09-24 03:00:10', 'Cute Mountains Inn', 'mhousecrafto2@g.co'),
(753, 1, '2019-01-08 10:34:49', 'Hilton Downtown', 'mheffordoa@pen.io'),
(754, 7, '2019-07-19 16:46:08', 'Hi-Way Inn', 'gleprovosti4@domainmarket.com'),
(755, 6, '2020-01-27 14:08:26', 'Candlewood Suites', 'jbevan31@myspace.com'),
(756, 9, '2020-04-01 03:16:29', 'Hotel deLuxe', 'swhitmorej4@yellowbook.com'),
(757, 2, '2020-05-24 00:47:53', 'Residence Inn', 'mdudenie3i@soundcloud.com'),
(758, 2, '2020-03-07 06:59:51', 'Hi-Way Inn', 'lbaudins7e@ucoz.ru'),
(759, 10, '2019-02-08 02:23:34', 'The Paradise Inn', 'jsoutherellgx@adobe.com'),
(760, 8, '2020-03-03 00:10:21', 'The Paradise Inn', 'boverlandli@hatena.ne.jp'),
(761, 8, '2019-01-20 20:30:08', 'Luxor', 'ccotillardge@blogger.com'),
(762, 9, '2019-07-16 05:07:26', 'Hi-Way Inn', 'mmcclancyn9@msn.com'),
(763, 5, '2019-03-28 19:35:33', 'Luxor', 'dheggesoz@senate.gov'),
(764, 7, '2020-05-20 12:57:18', 'Cute Mountains Inn', 'mmatteahw@hibu.com'),
(765, 10, '2020-06-03 12:13:37', 'Hotel deLuxe', 'bousbieb0@wikimedia.org'),
(766, 5, '2019-09-14 22:11:51', 'Cute Mountains Inn', 'ksutterfieldr4@bravesites.com'),
(767, 1, '2020-07-22 01:17:26', 'Hampton Inn', 'ldibollj3@yale.edu'),
(768, 5, '2019-11-05 04:01:58', 'Sheraton Centre', 'mhodgets5x@theatlantic.com'),
(769, 8, '2020-06-08 13:27:45', 'The Paradise Inn', 'ltrudgeonp1@rediff.com'),
(770, 1, '2019-03-17 03:55:24', 'Candlewood Suites', 'sebbettk3@nytimes.com'),
(771, 5, '2019-01-16 11:56:51', 'Residence Inn', 'hpetruszka5a@sina.com.cn'),
(772, 3, '2020-03-10 15:55:49', 'Sheraton Centre', 'akeepeeq@jigsy.com'),
(773, 10, '2019-01-26 13:41:53', 'Hi-Way Inn', 'awoodard2a@is.gd'),
(774, 8, '2020-07-22 16:39:08', 'Hotel deLuxe', 'cemmerson8j@wp.com'),
(775, 4, '2019-11-06 07:06:58', 'The Paradise Inn', 'menston91@flavors.me'),
(776, 2, '2019-04-30 16:47:29', 'Hilton Downtown', 'bduchateaulk@sciencedaily.com'),
(777, 3, '2020-03-22 06:57:33', 'Hampton Inn', 'bducaen7m@blogs.com'),
(778, 8, '2019-10-25 10:29:42', 'Hi-Way Inn', 'gblackford5f@unesco.org'),
(779, 6, '2020-07-12 15:08:26', 'Cute Mountains Inn', 'gmarcamkk@wikipedia.org'),
(780, 1, '2020-02-10 04:51:44', 'Hampton Inn', 'mmcclancyn9@msn.com'),
(781, 1, '2020-05-07 00:50:44', 'Luxor', 'rfinlaysonk4@cnet.com'),
(782, 3, '2019-05-31 06:42:25', 'Luxor', 'rcollinop@japanpost.jp'),
(783, 3, '2020-04-04 09:07:44', 'Luxor', 'kbakeyhe@dmoz.org'),
(784, 1, '2020-03-15 00:33:11', 'The Paradise Inn', 'moverellgd@discuz.net'),
(785, 9, '2019-07-10 15:10:28', 'Hilton Downtown', 'lpedlowh3@printfriendly.com'),
(786, 5, '2019-02-18 19:22:30', 'Hotel deLuxe', 'kpredohlop@cbc.ca'),
(787, 3, '2020-01-03 07:56:02', 'Hotel deLuxe', 'gfochsg9@eepurl.com'),
(788, 10, '2020-05-10 17:53:54', 'Hilton Downtown', 'lmurneymp@diigo.com'),
(789, 9, '2020-06-12 12:38:41', 'Hotel deLuxe', 'vogarags@globo.com'),
(790, 5, '2020-07-16 04:45:13', 'Sheraton Centre', 'cmcauliffear@xinhuanet.com'),
(791, 7, '2020-07-08 13:07:27', 'The Paradise Inn', 'cstormesl9@imageshack.us'),
(792, 3, '2019-06-11 15:05:35', 'Hi-Way Inn', 'vfontefc@rediff.com'),
(793, 7, '2020-01-09 16:29:28', 'Sheraton Centre', 'kriddell4b@china.com.cn'),
(794, 8, '2020-04-05 23:07:00', 'Hi-Way Inn', 'mdutteridgeas@typepad.com'),
(795, 3, '2019-04-02 13:25:22', 'Luxor', 'tmactrustriecw@ox.ac.uk'),
(796, 7, '2019-05-23 18:56:08', 'Candlewood Suites', 'winkeri8@bandcamp.com'),
(797, 5, '2019-03-26 15:15:40', 'Candlewood Suites', 'yalvarho@pcworld.com'),
(798, 3, '2019-05-02 00:00:26', 'Candlewood Suites', 'ericardetab@skyrock.com'),
(799, 4, '2019-06-17 19:51:39', 'Cute Mountains Inn', 'vmattis6k@craigslist.org'),
(800, 6, '2019-09-27 19:06:44', 'Residence Inn', 'mpreene7f@delicious.com'),
(801, 2, '2020-05-02 10:20:10', 'Sheraton Centre', 'cgiordanoc6@godaddy.com'),
(802, 10, '2019-06-07 08:24:42', 'Hampton Inn', 'lkingshottip@google.cn'),
(803, 2, '2019-02-03 14:23:26', 'Hampton Inn', 'beustonl5@ycombinator.com'),
(804, 8, '2020-03-12 14:08:57', 'Hi-Way Inn', 'rdibb2o@artisteer.com'),
(805, 5, '2020-01-26 01:24:05', 'Hotel deLuxe', 'kmamwelld1@gravatar.com'),
(806, 2, '2019-11-01 19:20:43', 'Cute Mountains Inn', 'dtrelease48@lulu.com'),
(807, 6, '2019-02-10 19:15:29', 'Hampton Inn', 'agulya9@acquirethisname.com'),
(808, 2, '2019-09-23 04:50:56', 'Residence Inn', 'cmirfieldqg@yellowpages.com'),
(809, 4, '2019-06-01 08:00:54', 'Hilton Downtown', 'dgodilington4c@nationalgeographic.com'),
(810, 3, '2020-07-28 08:47:55', 'Hotel deLuxe', 'ghendriksends@blinklist.com'),
(811, 9, '2019-01-30 11:17:03', 'Cute Mountains Inn', 'mfoundcq@domainmarket.com'),
(812, 1, '2020-07-22 19:43:27', 'Cute Mountains Inn', 'bsweetland9a@nature.com'),
(813, 1, '2020-03-14 18:50:09', 'Hi-Way Inn', 'vkitchingmaneo@cdc.gov'),
(814, 7, '2020-05-05 00:09:14', 'Hi-Way Inn', 'baltoftq8@senate.gov'),
(815, 6, '2019-08-13 06:11:02', 'Luxor', 'lpfeuffermb@example.com'),
(816, 3, '2019-09-11 23:20:02', 'Hi-Way Inn', 'fskeycb@craigslist.org'),
(817, 4, '2019-01-05 04:18:24', 'Hotel deLuxe', 'dtodhunterez@foxnews.com'),
(818, 5, '2019-01-24 08:34:38', 'Hi-Way Inn', 'llistpf@wix.com'),
(819, 10, '2019-11-27 14:01:56', 'Hi-Way Inn', 'htinsley68@dagondesign.com'),
(820, 10, '2019-10-01 19:44:03', 'Hotel deLuxe', 'fuphill2y@oaic.gov.au'),
(821, 5, '2020-01-27 14:19:03', 'The Paradise Inn', 'aiacapucci6h@fema.gov'),
(822, 6, '2020-02-17 07:21:24', 'Hampton Inn', 'jwalsom4a@cornell.edu'),
(823, 3, '2019-09-07 03:15:23', 'Luxor', 'ggoaterks@taobao.com'),
(824, 1, '2019-08-22 08:01:26', 'The Paradise Inn', 'vchapple2l@gizmodo.com'),
(825, 1, '2019-05-16 04:34:45', 'Hi-Way Inn', 'mizaacp5@artisteer.com'),
(826, 9, '2019-05-10 19:06:17', 'Hotel deLuxe', 'kmcgarrellfc@msu.edu'),
(827, 8, '2019-05-06 00:05:49', 'Sheraton Centre', 'jodney1z@nature.com'),
(828, 6, '2020-07-16 16:50:01', 'Hampton Inn', 'bpeasbylk@hugedomains.com'),
(829, 1, '2020-07-09 06:26:40', 'Residence Inn', 'bfarnhillb@senate.gov'),
(830, 7, '2020-05-25 22:43:39', 'Luxor', 'mboggsqi@psu.edu'),
(831, 3, '2019-05-18 09:27:17', 'Cute Mountains Inn', 'dlageml@sun.com'),
(832, 10, '2019-09-29 17:18:42', 'Candlewood Suites', 'rcoasterpd@flavors.me'),
(833, 3, '2019-10-06 13:04:46', 'Sheraton Centre', 'btromansfk@google.co.jp'),
(834, 4, '2019-04-21 10:07:03', 'Hampton Inn', 'dgaggh1@weebly.com'),
(835, 4, '2019-07-20 07:43:37', 'Hampton Inn', 'jsporgeonjw@chicagotribune.com'),
(836, 7, '2020-01-17 06:05:27', 'Hi-Way Inn', 'bferresf0@hexun.com'),
(837, 6, '2020-06-07 21:07:15', 'Hilton Downtown', 'ashapera1c@techcrunch.com'),
(838, 9, '2020-08-06 05:22:08', 'Hilton Downtown', 'iepps1a@phpbb.com'),
(839, 1, '2020-04-07 16:42:28', 'Luxor', 'msteaningg0@businesswire.com'),
(840, 1, '2019-05-28 09:40:09', 'Hotel deLuxe', 'hmacritchieeq@angelfire.com'),
(841, 7, '2019-06-05 18:51:08', 'Luxor', 'vparmerdu@nature.com'),
(842, 10, '2019-03-01 00:31:10', 'Luxor', 'bdanaherag@is.gd'),
(843, 5, '2019-08-21 19:49:24', 'Hilton Downtown', 'kmcvittiedp@ox.ac.uk'),
(844, 4, '2019-02-06 19:57:29', 'Hilton Downtown', 'wrickesies4x@yandex.ru'),
(845, 7, '2019-06-21 10:02:59', 'The Paradise Inn', 'caltimasea@istockphoto.com'),
(846, 4, '2020-02-14 11:11:07', 'Hi-Way Inn', 'gellwood1v@php.net'),
(847, 5, '2019-03-06 08:31:30', 'Residence Inn', 'nkitneyl0@dailymail.co.uk'),
(848, 3, '2019-08-22 07:01:26', 'Hampton Inn', 'gblissittl0@hud.gov'),
(849, 1, '2019-03-14 14:29:08', 'Luxor', 'mkitchinghamod@google.com'),
(850, 9, '2019-03-15 23:57:58', 'Hilton Downtown', 'lgadesby8u@e-recht24.de'),
(851, 2, '2019-08-10 20:02:06', 'Sheraton Centre', 'iepps1a@phpbb.com'),
(852, 4, '2019-06-19 17:53:21', 'Luxor', 'deastridgeb5@xinhuanet.com'),
(853, 10, '2019-03-08 01:33:46', 'Residence Inn', 'cdonizeauil@epa.gov'),
(854, 4, '2019-06-28 23:07:58', 'Luxor', 'jboastjl@devhub.com'),
(855, 1, '2019-03-24 00:20:28', 'Luxor', 'lmewisqk@friendfeed.com'),
(856, 6, '2019-04-12 14:10:29', 'Residence Inn', 'swoodwindcn@yale.edu'),
(857, 5, '2020-02-25 07:24:44', 'Hilton Downtown', 'aframpton7d@paginegialle.it'),
(858, 1, '2020-04-14 15:58:10', 'Hotel deLuxe', 'sgilletg9@wikipedia.org'),
(859, 10, '2019-12-16 05:08:53', 'Hi-Way Inn', 'cperfilig@ibm.com'),
(860, 10, '2019-04-30 10:53:32', 'Sheraton Centre', 'mizaacp5@artisteer.com'),
(861, 5, '2019-03-22 11:27:52', 'Cute Mountains Inn', 'tsextyef@flavors.me'),
(862, 1, '2019-05-21 03:47:09', 'Hilton Downtown', 'emcveighf4@bloglovin.com'),
(863, 8, '2020-04-29 19:14:59', 'Hilton Downtown', 'dvinaul2@dyndns.org'),
(864, 2, '2019-12-15 03:37:38', 'Luxor', 'amckleod4a@php.net'),
(865, 6, '2020-08-08 04:44:00', 'The Paradise Inn', 'gelcoata2@umn.edu'),
(866, 4, '2019-11-04 11:48:33', 'Hampton Inn', 'mlivesayl1@sun.com'),
(867, 10, '2020-07-24 13:05:21', 'Hotel deLuxe', 'amckleod4a@php.net'),
(868, 6, '2020-02-20 12:15:01', 'Hilton Downtown', 'mkitchinghamod@google.com'),
(869, 4, '2019-03-09 09:40:16', 'Hilton Downtown', 'ssawday86@woothemes.com'),
(870, 7, '2019-10-17 13:15:56', 'Candlewood Suites', 'jgreenigp2@alibaba.com'),
(871, 3, '2019-05-10 02:51:11', 'Luxor', 'bvirginrg@cam.ac.uk'),
(872, 5, '2019-09-02 15:04:35', 'Candlewood Suites', 'sscopesa6@google.de'),
(873, 1, '2020-06-24 05:44:25', 'Candlewood Suites', 'gjenkinol@comsenz.com'),
(874, 2, '2019-03-22 01:25:38', 'Sheraton Centre', 'llowdham5s@chron.com'),
(875, 8, '2019-08-01 22:22:23', 'Candlewood Suites', 'hbeatson4o@lycos.com'),
(876, 6, '2019-12-16 23:10:08', 'Hampton Inn', 'bdamperqf@chronoengine.com'),
(877, 6, '2019-07-09 18:12:08', 'Hotel deLuxe', 'cdonahue3f@myspace.com'),
(878, 8, '2020-03-23 23:05:41', 'Cute Mountains Inn', 'aburnage6a@cbslocal.com'),
(879, 5, '2019-07-08 16:12:00', 'Luxor', 'dhancockqb@statcounter.com'),
(880, 8, '2020-03-25 05:44:58', 'Sheraton Centre', 'rmaragesqv@ycombinator.com'),
(881, 1, '2020-04-15 19:38:45', 'Hotel deLuxe', 'jdouglissd0@twitter.com'),
(882, 4, '2020-03-07 21:27:10', 'Hampton Inn', 'smincini19@discovery.com'),
(883, 2, '2019-04-27 16:14:35', 'Candlewood Suites', 'rbandeykz@bloomberg.com'),
(884, 6, '2020-05-31 06:16:29', 'Hotel deLuxe', 'ibartloszjv@exblog.jp'),
(885, 5, '2019-03-14 12:53:31', 'Hampton Inn', 'rwinfield52@google.com.br'),
(886, 6, '2020-04-28 07:53:52', 'Hotel deLuxe', 'cherley7t@live.com'),
(887, 1, '2019-08-25 15:01:22', 'Hilton Downtown', 'gmenhamft@nih.gov'),
(888, 10, '2019-01-23 10:52:49', 'Residence Inn', 'abatecoklg@constantcontact.com'),
(889, 5, '2019-05-03 10:41:30', 'Cute Mountains Inn', 'tclapstonr@google.com'),
(890, 3, '2020-02-03 04:55:53', 'Luxor', 'tpollicote41@bizjournals.com'),
(891, 2, '2020-01-06 11:51:37', 'Cute Mountains Inn', 'jbattellejf@arstechnica.com'),
(892, 2, '2020-03-25 00:10:38', 'Hi-Way Inn', 'enorwayon@nature.com'),
(893, 3, '2020-08-10 01:01:46', 'Hi-Way Inn', 'odoubledaybj@friendfeed.com'),
(894, 1, '2020-03-28 07:47:50', 'Residence Inn', 'klemarchant9z@gravatar.com'),
(895, 5, '2020-04-21 19:25:14', 'The Paradise Inn', 'mbevensfo@unc.edu'),
(896, 5, '2020-02-26 13:34:05', 'Hampton Inn', 'swhilderit@qq.com'),
(897, 4, '2019-03-31 19:43:41', 'Hampton Inn', 'kblythdw@dagondesign.com'),
(898, 3, '2019-05-28 21:54:45', 'Hampton Inn', 'cperfilig@ibm.com'),
(899, 5, '2020-07-08 18:59:58', 'Cute Mountains Inn', 'jdurantin@census.gov'),
(900, 1, '2019-03-10 23:54:33', 'Residence Inn', 'bholdworthz@sciencedirect.com'),
(901, 10, '2020-03-18 17:18:02', 'Hampton Inn', 'dwoolway2z@nymag.com'),
(902, 7, '2019-06-22 02:16:16', 'Cute Mountains Inn', 'kvanyakinlw@gizmodo.com'),
(903, 9, '2019-11-26 20:10:15', 'Cute Mountains Inn', 'mmabeyq9@umn.edu'),
(904, 6, '2020-02-03 06:36:24', 'Hilton Downtown', 'clongmanal@admin.ch'),
(905, 9, '2019-10-28 08:23:19', 'Candlewood Suites', 'gblissittl0@hud.gov'),
(906, 1, '2020-06-20 16:45:20', 'Cute Mountains Inn', 'ksighartm6@twitpic.com'),
(907, 1, '2019-11-23 19:32:21', 'Hilton Downtown', 'emasord@mtv.com'),
(908, 3, '2020-03-28 02:35:22', 'Cute Mountains Inn', 'cshorto4c@techcrunch.com'),
(909, 8, '2020-07-13 15:43:48', 'Luxor', 'horiel71@comcast.net'),
(910, 5, '2020-06-10 11:38:44', 'Residence Inn', 'slaxtonmf@gnu.org'),
(911, 9, '2019-03-01 05:19:49', 'Candlewood Suites', 'rpettersenkb@stumbleupon.com'),
(912, 4, '2019-10-28 21:25:15', 'The Paradise Inn', 'arawsen55@upenn.edu'),
(913, 1, '2020-02-18 21:38:33', 'Candlewood Suites', 'dwhitehairky@behance.net'),
(914, 7, '2020-01-02 13:17:32', 'Hilton Downtown', 'mklazengagb@altervista.org'),
(915, 1, '2019-06-26 16:45:17', 'Hi-Way Inn', 'aobernep@google.cn'),
(916, 7, '2020-07-26 05:31:05', 'Sheraton Centre', 'dbraghinina@bluehost.com'),
(917, 10, '2019-08-09 10:41:48', 'Hotel deLuxe', 'rmageeiq@harvard.edu'),
(918, 4, '2019-11-08 11:18:39', 'Sheraton Centre', 'egarwillnr@dailymail.co.uk'),
(919, 9, '2019-12-11 12:53:34', 'Hi-Way Inn', 'jscownms@sina.com.cn'),
(920, 7, '2020-07-04 16:18:40', 'Candlewood Suites', 'mroddellcy@t-online.de'),
(921, 6, '2020-02-05 23:47:53', 'Hotel deLuxe', 'sbirkheadm@sakura.ne.jp'),
(922, 2, '2019-09-02 23:57:49', 'Hotel deLuxe', 'dgentzsch9a@amazonaws.com'),
(923, 10, '2019-04-13 17:17:45', 'Candlewood Suites', 'nnovak4v@weather.com'),
(924, 8, '2020-06-18 10:48:53', 'Cute Mountains Inn', 'hmowburyqq@clickbank.net'),
(925, 1, '2019-07-05 18:15:09', 'The Paradise Inn', 'sseldnern4@google.cn'),
(926, 1, '2019-01-23 11:46:16', 'Hilton Downtown', 'sgatland4e@alibaba.com'),
(927, 3, '2019-12-03 04:41:15', 'Hotel deLuxe', 'kstephensq7@mapquest.com'),
(928, 6, '2019-01-01 15:40:39', 'Hi-Way Inn', 'adignumnv@amazon.de'),
(929, 9, '2019-08-27 03:42:48', 'Sheraton Centre', 'rgass2h@newyorker.com'),
(930, 7, '2020-03-23 06:32:47', 'Sheraton Centre', 'kquick6j@fc2.com'),
(931, 4, '2020-01-19 04:34:30', 'Hi-Way Inn', 'jblissitt5u@cbslocal.com'),
(932, 10, '2019-04-07 00:10:55', 'Cute Mountains Inn', 'klemarchant9z@gravatar.com'),
(933, 5, '2020-04-07 05:37:00', 'Residence Inn', 'jjeremaesqi@deliciousdays.com'),
(934, 8, '2019-04-17 11:11:35', 'The Paradise Inn', 'kdelapa@ebay.co.uk'),
(935, 6, '2019-08-23 09:18:50', 'The Paradise Inn', 'fbranganh8@unc.edu'),
(936, 5, '2019-12-04 15:50:59', 'Luxor', 'slambregtsjw@europa.eu'),
(937, 1, '2019-11-21 21:13:40', 'Residence Inn', 'bseear1@4shared.com'),
(938, 7, '2019-07-29 12:55:14', 'Hi-Way Inn', 'vvallantine0@java.com'),
(939, 9, '2019-07-03 06:57:33', 'Cute Mountains Inn', 'cmirfieldqg@yellowpages.com'),
(940, 4, '2019-03-17 03:43:45', 'Luxor', 'vriordanke@aol.com'),
(941, 2, '2019-05-26 09:31:57', 'Sheraton Centre', 'cfrayneny@buzzfeed.com'),
(942, 4, '2020-02-12 10:34:49', 'Luxor', 'kpurkess97@plala.or.jp'),
(943, 4, '2020-03-12 00:14:18', 'Luxor', 'lsapshedlj@wikispaces.com'),
(944, 3, '2019-05-27 03:45:49', 'The Paradise Inn', 'fkeming48@kickstarter.com'),
(945, 4, '2020-02-08 11:33:08', 'Cute Mountains Inn', 'ciddonfl@blogtalkradio.com'),
(946, 8, '2019-09-06 10:30:53', 'Hilton Downtown', 'wmixon81@bloglovin.com'),
(947, 2, '2019-03-24 00:52:08', 'Sheraton Centre', 'fjerzycowskigt@parallels.com'),
(948, 9, '2020-04-26 20:16:42', 'Hampton Inn', 'dbonannok@columbia.edu'),
(949, 7, '2019-03-25 19:30:08', 'Hi-Way Inn', 'boyleykb@so-net.ne.jp'),
(950, 5, '2019-01-07 06:24:49', 'Sheraton Centre', 'ashapera1c@techcrunch.com'),
(951, 1, '2019-07-30 09:48:51', 'The Paradise Inn', 'swillesonco@lulu.com'),
(952, 7, '2019-01-23 10:22:50', 'Sheraton Centre', 'hbushe11@printfriendly.com'),
(953, 7, '2020-01-05 04:02:40', 'Hampton Inn', 'jmorphetku@princeton.edu'),
(954, 6, '2020-01-15 11:00:38', 'Hampton Inn', 'hedensaq@sina.com.cn'),
(955, 8, '2019-03-13 20:26:35', 'Sheraton Centre', 'sgothardl1@163.com'),
(956, 4, '2019-10-27 20:48:04', 'Hotel deLuxe', 'talgerhu@parallels.com'),
(957, 6, '2019-11-15 00:56:54', 'Cute Mountains Inn', 'mstorrock84@reuters.com'),
(958, 7, '2019-10-08 07:52:01', 'The Paradise Inn', 'lmccookhf@newsvine.com'),
(959, 3, '2019-02-02 14:34:16', 'Sheraton Centre', 'vmitchelrl@storify.com'),
(960, 3, '2019-10-30 13:30:50', 'Hilton Downtown', 'vparmerdu@nature.com'),
(961, 8, '2019-05-08 11:24:05', 'Hotel deLuxe', 'rjindad5@indiatimes.com'),
(962, 7, '2019-01-26 14:33:15', 'Hi-Way Inn', 'mtanser3h@mysql.com'),
(963, 5, '2020-01-28 09:28:53', 'Cute Mountains Inn', 'bmccreery47@cloudflare.com'),
(964, 1, '2020-06-28 11:20:38', 'Residence Inn', 'dtrelease48@lulu.com'),
(965, 3, '2020-07-11 06:03:09', 'Residence Inn', 'fmckeney8l@bbb.org'),
(966, 6, '2019-02-24 20:41:17', 'Hotel deLuxe', 'jstofferg1@addthis.com'),
(967, 3, '2019-11-13 10:54:10', 'Luxor', 'glawteyj8@people.com.cn'),
(968, 2, '2019-01-08 08:20:06', 'The Paradise Inn', 'lguinessr8@ihg.com'),
(969, 3, '2020-05-31 01:52:00', 'Hilton Downtown', 'ddarcey6d@weebly.com'),
(970, 1, '2019-12-06 11:20:23', 'Hotel deLuxe', 'jclougherle@bravesites.com'),
(971, 8, '2019-11-12 10:44:38', 'Sheraton Centre', 'jpernell4f@skyrock.com'),
(972, 8, '2019-05-08 00:54:27', 'Candlewood Suites', 'dmullearykc@typepad.com'),
(973, 9, '2020-04-16 15:46:09', 'Hampton Inn', 'krichfordhl@de.vu'),
(974, 1, '2019-12-17 13:08:02', 'Hotel deLuxe', 'gtarbath4p@moonfruit.com'),
(975, 2, '2019-12-10 13:22:19', 'Hilton Downtown', 'astert9h@foxnews.com'),
(976, 5, '2020-01-15 01:59:11', 'The Paradise Inn', 'bstillmanqs@prweb.com'),
(977, 8, '2019-12-12 18:32:26', 'Luxor', 'mbentermanit@microsoft.com'),
(978, 6, '2019-09-25 13:38:09', 'Hampton Inn', 'sdavisef@harvard.edu'),
(979, 6, '2020-03-25 11:54:04', 'The Paradise Inn', 'rmcilory75@nbcnews.com'),
(980, 2, '2019-10-05 11:55:44', 'Candlewood Suites', 'cconboyjo@feedburner.com'),
(981, 7, '2019-03-31 07:14:35', 'Hampton Inn', 'nkitneyl0@dailymail.co.uk'),
(982, 6, '2019-01-03 18:11:30', 'Luxor', 'singledowcc@europa.eu'),
(983, 6, '2019-04-05 22:07:55', 'Luxor', 'rlabror3@abc.net.au'),
(984, 4, '2019-04-01 07:48:29', 'Hilton Downtown', 'idanymu@usda.gov'),
(985, 7, '2019-01-11 11:28:00', 'Sheraton Centre', 'rwinfield52@google.com.br'),
(986, 7, '2019-09-10 22:03:56', 'Luxor', 'tkeffordpc@eventbrite.com'),
(987, 10, '2019-03-12 04:16:13', 'Hotel deLuxe', 'alotterington1w@mit.edu'),
(988, 2, '2019-01-08 11:40:40', 'Candlewood Suites', 'kbakeyhe@dmoz.org'),
(989, 10, '2019-04-07 10:53:47', 'Hotel deLuxe', 'bpalffynj@etsy.com'),
(990, 9, '2019-11-12 00:13:41', 'Luxor', 'menstonekh@sphinn.com'),
(991, 8, '2020-05-12 10:02:54', 'Hilton Downtown', 'kdamrellqs@ucla.edu'),
(992, 4, '2020-03-06 20:13:27', 'Luxor', 'adovingtonlo@cyberchimps.com'),
(993, 3, '2019-01-12 23:17:16', 'Hotel deLuxe', 'bgregl8@liveinternet.ru'),
(994, 4, '2019-07-22 07:26:24', 'Cute Mountains Inn', 'rconingif@phoca.cz'),
(995, 5, '2019-11-10 03:07:34', 'The Paradise Inn', 'apackwoodoy@t.co'),
(996, 6, '2020-05-15 00:30:00', 'Hilton Downtown', 'ebrudenell1e@ask.com'),
(997, 7, '2019-08-04 10:09:29', 'Candlewood Suites', 'rheynelpj@examiner.com'),
(998, 4, '2019-10-22 02:54:40', 'Luxor', 'zgandarfp@webs.com'),
(999, 1, '2019-05-06 15:02:05', 'Luxor', 'lwalteringo4@barnesandnoble.com'),
(1000, 8, '2019-08-01 20:31:04', 'Sheraton Centre', 'hpeeverc5@comsenz.com'),
(1001, 1, '2019-06-05 20:30:06', 'Luxor', 'amcbrier55@rediff.com'),
(1002, 6, '2019-11-12 09:50:32', 'Residence Inn', 'wbracegirdle1l@comsenz.com'),
(1003, 9, '2019-07-22 18:17:33', 'Candlewood Suites', 'mdesporteps@last.fm'),
(1004, 4, '2019-07-08 04:59:10', 'Candlewood Suites', 'mgrunbaumq9@nature.com'),
(1005, 10, '2019-02-28 14:01:06', 'Hi-Way Inn', 'lkingshottip@google.cn'),
(1006, 3, '2020-04-01 18:43:05', 'Hi-Way Inn', 'jscownms@sina.com.cn'),
(1007, 9, '2019-01-24 08:13:28', 'Hampton Inn', 'acasselykx@webmd.com'),
(1008, 10, '2019-08-15 18:51:26', 'Residence Inn', 'ksnare6p@google.ca'),
(1009, 4, '2020-03-22 19:26:33', 'Hampton Inn', 'singledowcc@europa.eu'),
(1010, 5, '2020-08-13 01:53:24', 'Luxor', 'jmacveyd9@gizmodo.com'),
(1011, 7, '2020-03-21 06:50:48', 'Luxor', 'lgepson6j@sciencedirect.com'),
(1012, 1, '2019-01-28 18:06:46', 'Residence Inn', 'bzielinskio4@about.me'),
(1013, 10, '2020-08-09 05:16:10', 'Hampton Inn', 'tsaffon6y@t-online.de'),
(1014, 8, '2019-12-11 00:33:39', 'Hotel deLuxe', 'sgrangier43@bizjournals.com'),
(1015, 1, '2019-01-02 00:52:08', 'Sheraton Centre', 'gantalie@live.com'),
(1016, 1, '2020-04-14 09:54:02', 'Cute Mountains Inn', 'rfinlaysonk4@cnet.com'),
(1017, 7, '2019-10-04 12:22:25', 'Sheraton Centre', 'zjinkinou@sogou.com'),
(1018, 3, '2019-03-22 02:31:41', 'Luxor', 'rpavlenko3e@cyberchimps.com'),
(1019, 7, '2020-05-29 16:34:18', 'Luxor', 'pdictybf@nytimes.com'),
(1020, 4, '2020-05-11 04:11:23', 'Hilton Downtown', 'djenicek64@reference.com'),
(1021, 9, '2020-04-14 18:37:51', 'Hi-Way Inn', 'sbourdicede@purevolume.com'),
(1022, 8, '2019-06-17 06:38:06', 'Sheraton Centre', 'bdamperqf@chronoengine.com'),
(1023, 6, '2019-12-01 08:28:44', 'Hotel deLuxe', 'deastridgeb5@xinhuanet.com'),
(1024, 2, '2020-04-03 19:02:42', 'Candlewood Suites', 'ksutterfieldr4@bravesites.com'),
(1025, 1, '2020-02-12 16:50:54', 'Hilton Downtown', 'gnaulch@baidu.com'),
(1026, 10, '2020-01-07 20:46:42', 'Luxor', 'bcasirolias@howstuffworks.com'),
(1027, 10, '2019-05-15 19:05:49', 'Luxor', 'mcoito6@ibm.com'),
(1028, 2, '2019-07-02 23:01:26', 'Sheraton Centre', 'vjessop30@blog.com'),
(1029, 5, '2020-06-25 04:14:52', 'Hotel deLuxe', 'agaskinshk@jiathis.com'),
(1030, 5, '2020-05-03 09:59:08', 'Hi-Way Inn', 'dnieselml@microsoft.com'),
(1031, 10, '2019-01-11 17:40:40', 'Luxor', 'aheyburn2q@census.gov'),
(1032, 5, '2019-12-26 19:23:02', 'Cute Mountains Inn', 'jhatrickpx@rakuten.co.jp'),
(1033, 10, '2019-02-09 06:01:10', 'Hampton Inn', 'ckittemanhg@printfriendly.com'),
(1034, 2, '2019-08-30 13:02:56', 'Luxor', 'tdicarlir0@artisteer.com'),
(1035, 6, '2019-04-09 18:28:40', 'The Paradise Inn', 'crollinq6@oakley.com'),
(1036, 6, '2020-06-07 01:21:15', 'Residence Inn', 'areekeni5@sciencedirect.com'),
(1037, 6, '2019-06-23 23:20:56', 'The Paradise Inn', 'dlageml@sun.com'),
(1038, 2, '2020-04-11 01:24:04', 'Hampton Inn', 'parderneg6@shinystat.com'),
(1039, 6, '2020-08-05 11:07:20', 'Hilton Downtown', 'dcapstickbd@live.com'),
(1040, 4, '2020-05-06 21:24:36', 'Residence Inn', 'fmeddemmen67@oracle.com'),
(1041, 3, '2020-06-08 06:32:29', 'The Paradise Inn', 'jellenkj@woothemes.com'),
(1042, 9, '2019-10-21 11:50:23', 'Luxor', 'imarkosed@china.com.cn'),
(1043, 4, '2019-08-24 14:37:08', 'Hotel deLuxe', 'mpreene7f@delicious.com'),
(1044, 1, '2019-04-05 17:53:29', 'Luxor', 'wrickesies4x@yandex.ru'),
(1045, 1, '2020-05-24 23:55:45', 'Cute Mountains Inn', 'screhank1@github.io'),
(1046, 10, '2020-05-20 01:07:06', 'Sheraton Centre', 'klilywhitef@jigsy.com'),
(1047, 3, '2019-03-27 02:41:17', 'Hi-Way Inn', 'sroland9n@acquirethisname.com'),
(1048, 2, '2019-10-28 11:26:10', 'Hi-Way Inn', 'ltrimmillpk@boston.com'),
(1049, 9, '2019-08-29 00:47:06', 'Hi-Way Inn', 'rcoasterpd@flavors.me'),
(1050, 7, '2019-11-23 10:30:41', 'Cute Mountains Inn', 'pkirvin14@cmu.edu'),
(1051, 6, '2020-05-04 13:30:10', 'Luxor', 'ptophamni@networksolutions.com'),
(1052, 9, '2020-06-06 15:55:47', 'Hampton Inn', 'gwyldboredq@weather.com'),
(1053, 1, '2020-04-23 12:48:17', 'Cute Mountains Inn', 'lswashh3@addtoany.com'),
(1054, 4, '2020-03-29 13:27:01', 'Hi-Way Inn', 'nwoolvinhp@1688.com'),
(1055, 4, '2019-01-17 06:54:02', 'Residence Inn', 'pmacmoyer3p@ifeng.com'),
(1056, 7, '2019-06-08 03:25:01', 'Cute Mountains Inn', 'lgepson6j@sciencedirect.com'),
(1057, 8, '2019-08-11 00:24:01', 'The Paradise Inn', 'rvernazzamt@java.com'),
(1058, 9, '2019-05-14 16:20:41', 'Hi-Way Inn', 'cassurev@npr.org'),
(1059, 5, '2020-03-20 12:26:24', 'Hilton Downtown', 'cperfilig@ibm.com'),
(1060, 8, '2019-04-07 19:51:26', 'Hi-Way Inn', 'nmaffiakj@google.ca'),
(1061, 5, '2020-07-25 17:49:14', 'Sheraton Centre', 'bgawkeka@devhub.com'),
(1062, 10, '2020-07-23 00:25:27', 'The Paradise Inn', 'dstenettdk@shutterfly.com'),
(1063, 10, '2019-02-19 04:10:41', 'Luxor', 'cfiller61@wired.com'),
(1064, 9, '2020-05-13 06:44:27', 'Cute Mountains Inn', 'amineghelliom@nydailynews.com'),
(1065, 9, '2019-06-14 16:56:07', 'Hampton Inn', 'gonionl3@yellowbook.com'),
(1066, 6, '2019-08-03 12:20:20', 'Hotel deLuxe', 'mbrosettifb@timesonline.co.uk'),
(1067, 4, '2020-03-25 06:52:02', 'Hi-Way Inn', 'mbollam7y@typepad.com'),
(1068, 6, '2019-06-13 20:46:19', 'Hi-Way Inn', 'bdunnanqp@gnu.org'),
(1069, 1, '2020-05-31 08:23:18', 'The Paradise Inn', 'kvanyakinlw@gizmodo.com'),
(1070, 4, '2020-02-12 19:41:51', 'Sheraton Centre', 'cdinsalekt@myspace.com'),
(1071, 6, '2019-01-06 08:12:55', 'Luxor', 'sweatherdon18@tripadvisor.com'),
(1072, 1, '2019-04-02 10:48:46', 'Sheraton Centre', 'droafa5@angelfire.com'),
(1073, 3, '2020-02-11 00:34:52', 'Cute Mountains Inn', 'fbambrughk4@360.cn'),
(1074, 7, '2019-01-27 06:22:18', 'Hotel deLuxe', 'aoxfordd3@bigcartel.com'),
(1075, 8, '2019-12-22 14:55:04', 'Luxor', 'ckunkelrp@noaa.gov'),
(1076, 10, '2019-12-30 15:33:14', 'Hilton Downtown', 'knockellsbe@china.com.cn'),
(1077, 9, '2019-07-28 10:08:06', 'Luxor', 'pensleyki@wsj.com'),
(1078, 9, '2019-12-31 23:33:19', 'Hi-Way Inn', 'mdecarlok3@barnesandnoble.com'),
(1079, 8, '2019-10-17 08:20:02', 'Cute Mountains Inn', 'lhughsfz@etsy.com'),
(1080, 9, '2020-01-13 03:42:22', 'Hotel deLuxe', 'cferryja@hp.com'),
(1081, 8, '2019-10-23 08:16:40', 'Luxor', 'nmakinkm@bigcartel.com'),
(1082, 10, '2020-04-18 11:58:27', 'Candlewood Suites', 'tsemoninid@google.de'),
(1083, 1, '2020-06-29 14:19:08', 'Hampton Inn', 'bgatteridgea2@topsy.com'),
(1084, 6, '2019-06-02 03:36:35', 'Hi-Way Inn', 'hdecarolisgc@wsj.com'),
(1085, 8, '2019-02-10 03:30:53', 'Candlewood Suites', 'areekeni5@sciencedirect.com'),
(1086, 4, '2019-08-29 00:04:28', 'Hampton Inn', 'joldredac@wordpress.com'),
(1087, 7, '2020-05-03 21:22:41', 'The Paradise Inn', 'afaust91@soup.io'),
(1088, 3, '2020-01-11 22:22:18', 'Hilton Downtown', 'nwreakesd8@sourceforge.net'),
(1089, 9, '2020-01-21 10:40:45', 'Cute Mountains Inn', 'aprivettle@pbs.org'),
(1090, 7, '2020-02-27 09:26:56', 'Sheraton Centre', 'cdelaharpepf@4shared.com'),
(1091, 10, '2019-09-14 15:22:01', 'Hi-Way Inn', 'bousbieb0@wikimedia.org'),
(1092, 8, '2019-02-23 08:27:52', 'Hi-Way Inn', 'agonneaue0@surveymonkey.com'),
(1093, 8, '2020-06-02 21:02:48', 'The Paradise Inn', 'rnoireljs@oracle.com'),
(1094, 2, '2019-05-26 23:29:53', 'The Paradise Inn', 'bestable7c@list-manage.com'),
(1095, 3, '2020-01-07 00:15:02', 'The Paradise Inn', 'scottier8x@google.es'),
(1096, 6, '2019-08-03 04:24:22', 'Candlewood Suites', 'egarwillnr@dailymail.co.uk'),
(1097, 7, '2019-03-31 06:41:34', 'Candlewood Suites', 'parderneg6@shinystat.com'),
(1098, 10, '2019-01-19 13:14:06', 'Hilton Downtown', 'gleprovosti4@domainmarket.com'),
(1099, 3, '2019-01-16 03:15:17', 'Candlewood Suites', 'cmirfieldqg@yellowpages.com'),
(1100, 10, '2019-07-30 08:58:55', 'Luxor', 'rjillissem@google.com.br'),
(1101, 6, '2019-02-19 03:21:15', 'Luxor', 'mgovando@merriam-webster.com'),
(1102, 8, '2019-12-02 21:59:28', 'Sheraton Centre', 'tswinburneay@trellian.com'),
(1103, 1, '2019-07-14 17:58:46', 'Hampton Inn', 'tbourdisaz@mediafire.com'),
(1104, 8, '2019-09-02 14:46:04', 'Hi-Way Inn', 'acarlens6m@sphinn.com'),
(1105, 7, '2019-05-23 23:06:16', 'Sheraton Centre', 'eshorten1t@seesaa.net'),
(1106, 3, '2019-02-28 19:13:20', 'Hilton Downtown', 'beadie2y@businesswire.com'),
(1107, 5, '2020-03-05 20:23:55', 'Hi-Way Inn', 'kpurkess97@plala.or.jp'),
(1108, 6, '2019-10-21 08:43:32', 'Hotel deLuxe', 'mjennokw@digg.com'),
(1109, 10, '2020-04-02 04:08:23', 'Hilton Downtown', 'llecountpc@huffingtonpost.com'),
(1110, 4, '2019-12-08 14:33:05', 'Cute Mountains Inn', 'mpernell1n@tripadvisor.com'),
(1111, 3, '2019-06-21 01:12:57', 'Candlewood Suites', 'aiveyj4@histats.com'),
(1112, 2, '2020-03-02 21:06:57', 'Sheraton Centre', 'sgrangier43@bizjournals.com'),
(1113, 10, '2019-09-23 02:18:00', 'Hampton Inn', 'ddorricottlv@gravatar.com'),
(1114, 3, '2019-02-02 00:01:09', 'Hampton Inn', 'mhaddickqq@macromedia.com'),
(1115, 8, '2019-02-07 01:49:05', 'Candlewood Suites', 'sberntssenbw@thetimes.co.uk'),
(1116, 1, '2020-06-20 02:23:28', 'Hilton Downtown', 'svandenbroekq8@princeton.edu'),
(1117, 6, '2020-05-08 04:57:26', 'Hotel deLuxe', 'astowgill9q@bloglines.com'),
(1118, 1, '2020-05-20 14:24:49', 'Candlewood Suites', 'dsharperiw@list-manage.com'),
(1119, 6, '2019-08-13 02:57:11', 'Hotel deLuxe', 'sfludder37@about.me'),
(1120, 8, '2019-11-25 16:17:52', 'Cute Mountains Inn', 'eburgon4m@ed.gov'),
(1121, 3, '2020-03-02 03:59:22', 'Hotel deLuxe', 'jroftj@opensource.org'),
(1122, 6, '2019-06-04 22:50:59', 'Luxor', 'wfidgeon8@amazon.co.uk'),
(1123, 2, '2020-06-02 00:53:06', 'The Paradise Inn', 'mfenwickor@berkeley.edu'),
(1124, 2, '2020-04-23 16:03:20', 'Candlewood Suites', 'amineghelliom@nydailynews.com'),
(1125, 3, '2019-04-09 07:47:23', 'Hotel deLuxe', 'eclubleym8@mit.edu'),
(1126, 7, '2020-08-03 15:01:58', 'Residence Inn', 'kbowsheres@imdb.com'),
(1127, 8, '2019-07-08 05:43:48', 'Hi-Way Inn', 'tcowtharddb@howstuffworks.com'),
(1128, 6, '2020-05-27 13:41:26', 'Residence Inn', 'cmeyrick95@angelfire.com'),
(1129, 9, '2020-02-12 07:32:19', 'Hilton Downtown', 'nmakinkm@bigcartel.com'),
(1130, 2, '2019-02-22 10:29:58', 'Candlewood Suites', 'vdurrantj1@kickstarter.com'),
(1131, 4, '2020-03-07 01:17:06', 'Residence Inn', 'lduell7r@wiley.com'),
(1132, 3, '2020-05-30 17:36:49', 'The Paradise Inn', 'smoldenrr@pbs.org'),
(1133, 6, '2019-08-09 03:34:58', 'Residence Inn', 'gwigsello0@archive.org'),
(1134, 9, '2020-05-03 12:30:05', 'Candlewood Suites', 'tloneyqb@ucla.edu'),
(1135, 5, '2019-12-06 13:17:44', 'Luxor', 'acreykekp@t.co'),
(1136, 9, '2020-04-07 20:01:49', 'Candlewood Suites', 'vredwin4h@sciencedirect.com'),
(1137, 8, '2019-04-21 22:47:17', 'Sheraton Centre', 'pmckimmqm@rediff.com'),
(1138, 10, '2019-09-05 03:15:55', 'The Paradise Inn', 'dmariottenq@surveymonkey.com'),
(1139, 3, '2019-11-23 19:07:46', 'The Paradise Inn', 'apimer28@upenn.edu'),
(1140, 2, '2019-11-24 05:39:31', 'Hilton Downtown', 'ssnalhamdj@i2i.jp'),
(1141, 10, '2019-02-02 04:33:21', 'Hotel deLuxe', 'dgentzsch9a@amazonaws.com'),
(1142, 7, '2020-06-08 02:45:35', 'Sheraton Centre', 'achingeh7@cbslocal.com'),
(1143, 8, '2019-06-08 16:45:13', 'Candlewood Suites', 'tmacaleesmg@free.fr'),
(1144, 2, '2019-10-06 12:53:14', 'Hilton Downtown', 'dtrelease48@lulu.com'),
(1145, 10, '2019-06-03 15:02:19', 'Sheraton Centre', 'eibbetsone3@creativecommons.org'),
(1146, 1, '2019-08-24 05:18:50', 'Hilton Downtown', 'qmattosoffii@acquirethisname.com'),
(1147, 4, '2020-07-08 01:25:28', 'Luxor', 'wbaszniakll@amazon.co.uk'),
(1148, 1, '2019-03-26 15:21:16', 'Residence Inn', 'akemitt2m@ca.gov'),
(1149, 5, '2019-03-28 09:12:35', 'Sheraton Centre', 'ksignej5@vimeo.com'),
(1150, 4, '2019-09-20 08:43:15', 'Cute Mountains Inn', 'cdonisem4@blinklist.com'),
(1151, 9, '2020-02-20 03:29:30', 'The Paradise Inn', 'swhotton8o@rediff.com'),
(1152, 10, '2019-11-20 11:50:41', 'Hampton Inn', 'cgiordanoc6@godaddy.com'),
(1153, 7, '2020-07-26 12:09:20', 'Hampton Inn', 'sduffynkc@marketwatch.com'),
(1154, 10, '2019-08-30 00:24:38', 'Sheraton Centre', 'mroswarner4@typepad.com'),
(1155, 2, '2019-09-14 22:30:39', 'Hilton Downtown', 'soxfordp3@imgur.com'),
(1156, 2, '2019-01-25 02:43:56', 'The Paradise Inn', 'ceveristmi@businessweek.com'),
(1157, 7, '2019-04-19 06:05:13', 'Hotel deLuxe', 'tsteanson3t@apple.com'),
(1158, 2, '2020-06-20 05:35:34', 'Sheraton Centre', 'djoscelyn9p@ihg.com'),
(1159, 5, '2020-04-26 18:59:43', 'Hampton Inn', 'ajelksic@huffingtonpost.com'),
(1160, 8, '2020-03-19 12:28:36', 'Sheraton Centre', 'cdifranceshci3x@narod.ru'),
(1161, 3, '2020-06-18 02:36:57', 'Hi-Way Inn', 'amiellrm@newsvine.com'),
(1162, 3, '2020-05-01 10:16:52', 'Hampton Inn', 'wjakesmh@squarespace.com'),
(1163, 8, '2019-05-17 12:36:50', 'Residence Inn', 'tjordenih@surveymonkey.com'),
(1164, 4, '2020-06-09 06:38:07', 'Hotel deLuxe', 'bvaskovfq@pagesperso-orange.fr'),
(1165, 9, '2020-07-26 12:28:04', 'Hotel deLuxe', 'mrosenblattc4@prweb.com'),
(1166, 9, '2019-11-22 21:38:25', 'Sheraton Centre', 'sgasperoln@dailymotion.com'),
(1167, 3, '2019-02-05 22:29:24', 'Residence Inn', 'nalekseicikp7@godaddy.com'),
(1168, 1, '2020-02-11 21:41:36', 'Hotel deLuxe', 'dhedingh@scientificamerican.com'),
(1169, 7, '2019-02-02 20:46:48', 'Hampton Inn', 'vvallantine0@java.com'),
(1170, 8, '2020-05-17 21:38:15', 'Hampton Inn', 'gcarrabotmi@yandex.ru'),
(1171, 3, '2019-03-03 22:28:39', 'Candlewood Suites', 'wsirkett38@drupal.org'),
(1172, 3, '2019-10-27 23:02:57', 'Hi-Way Inn', 'slosano8@wordpress.com'),
(1173, 2, '2020-08-04 14:01:06', 'Hilton Downtown', 'ddimmick1r@virginia.edu'),
(1174, 6, '2019-07-23 11:57:52', 'Luxor', 'dgodilington4c@nationalgeographic.com'),
(1175, 2, '2019-05-16 18:33:48', 'Luxor', 'aticksalljr@addtoany.com'),
(1176, 2, '2020-03-14 11:32:13', 'Sheraton Centre', 'hfilippon3@jigsy.com'),
(1177, 10, '2020-07-27 23:45:31', 'Luxor', 'fjerzycowskigt@parallels.com'),
(1178, 4, '2019-04-15 12:00:58', 'The Paradise Inn', 'rbillingtonm0@ibm.com'),
(1179, 8, '2020-02-22 01:33:45', 'Candlewood Suites', 'lhattrick9z@eventbrite.com'),
(1180, 1, '2020-05-08 14:13:24', 'Candlewood Suites', 'jlarge4w@squidoo.com'),
(1181, 5, '2020-05-16 01:59:21', 'Residence Inn', 'mcarteran@jimdo.com'),
(1182, 8, '2020-07-02 10:00:48', 'Residence Inn', 'bedgson28@economist.com'),
(1183, 6, '2019-09-26 22:18:47', 'Luxor', 'sdesbrowgv@google.co.jp'),
(1184, 4, '2019-11-13 11:30:48', 'Hi-Way Inn', 'tphiferne@hhs.gov'),
(1185, 4, '2019-10-25 11:32:24', 'Candlewood Suites', 'alotterington1w@mit.edu'),
(1186, 3, '2019-12-20 09:31:24', 'Hampton Inn', 'cwatheymg@home.pl'),
(1187, 2, '2019-06-12 11:39:38', 'The Paradise Inn', 'iironside83@dagondesign.com'),
(1188, 9, '2020-06-09 18:44:01', 'The Paradise Inn', 'vramsdelln1@google.cn'),
(1189, 7, '2020-06-23 15:15:15', 'Residence Inn', 'csoltanfx@cnn.com'),
(1190, 7, '2020-06-13 19:46:36', 'Candlewood Suites', 'rtattershaw30@cnbc.com'),
(1191, 9, '2019-06-20 18:00:06', 'Luxor', 'cdegoyfu@telegraph.co.uk'),
(1192, 2, '2019-07-23 21:29:22', 'Residence Inn', 'bwessellfw@pcworld.com'),
(1193, 2, '2019-09-04 22:35:51', 'Candlewood Suites', 'mmccaughan7t@sfgate.com'),
(1194, 1, '2019-06-02 19:36:31', 'Hampton Inn', 'rsmallpeacec5@yandex.ru'),
(1195, 6, '2019-09-26 10:20:30', 'Cute Mountains Inn', 'bmusselwhiteik@yelp.com'),
(1196, 2, '2019-10-12 16:00:07', 'Residence Inn', 'npatleyob@loc.gov'),
(1197, 3, '2019-12-02 20:11:34', 'Hampton Inn', 'mengadk@edublogs.org'),
(1198, 4, '2020-01-27 07:01:14', 'Hampton Inn', 'hpinnijaren@feedburner.com'),
(1199, 6, '2020-04-25 23:00:46', 'Sheraton Centre', 'ggoalleycu@dmoz.org'),
(1200, 2, '2019-08-10 18:41:13', 'Hotel deLuxe', 'hquartermaink9@fotki.com'),
(1201, 1, '2020-07-14 15:24:19', 'Hi-Way Inn', 'obridalh7@instagram.com'),
(1202, 1, '2020-01-12 11:30:19', 'Hotel deLuxe', 'rvalentingi@census.gov'),
(1203, 3, '2019-10-18 15:24:20', 'Hilton Downtown', 'jglowach6n@google.ru'),
(1204, 1, '2019-09-09 15:42:50', 'Hilton Downtown', 'slamey3o@columbia.edu'),
(1205, 5, '2020-07-06 10:21:04', 'Hi-Way Inn', 'modonohuehj@irs.gov'),
(1206, 6, '2020-03-02 04:52:06', 'Residence Inn', 'qmattosoffii@acquirethisname.com'),
(1207, 1, '2020-05-31 12:09:57', 'Hotel deLuxe', 'wmaffeyif@behance.net'),
(1208, 5, '2020-05-24 00:13:32', 'Hilton Downtown', 'cswatheridgemo@wordpress.org'),
(1209, 2, '2019-08-08 18:48:05', 'The Paradise Inn', 'jsonege@mtv.com'),
(1210, 10, '2020-04-16 05:07:57', 'Hilton Downtown', 'hhentze82@boston.com'),
(1211, 5, '2019-04-21 11:26:37', 'Cute Mountains Inn', 'asilverthornec8@usda.gov'),
(1212, 3, '2020-07-25 07:49:15', 'Hi-Way Inn', 'msiggeb5@yahoo.co.jp'),
(1213, 3, '2020-01-22 04:21:24', 'The Paradise Inn', 'adovingtonlo@cyberchimps.com'),
(1214, 6, '2019-11-10 16:24:44', 'The Paradise Inn', 'mdesporteps@last.fm'),
(1215, 9, '2019-07-04 02:35:47', 'Sheraton Centre', 'cparnabyno@cafepress.com'),
(1216, 1, '2020-04-17 11:50:48', 'Hilton Downtown', 'cdeinhardf5@go.com'),
(1217, 10, '2019-05-08 19:47:53', 'Hilton Downtown', 'acona3r@bbb.org'),
(1218, 5, '2019-06-16 08:26:45', 'Hampton Inn', 'hpieter9@woothemes.com'),
(1219, 1, '2019-05-31 23:18:36', 'Hi-Way Inn', 'pwartonr@slate.com'),
(1220, 8, '2019-04-20 10:45:37', 'Candlewood Suites', 'mdraisey8z@sciencedirect.com'),
(1221, 1, '2020-07-23 11:37:56', 'Luxor', 'cbushell9j@nature.com'),
(1222, 4, '2020-03-05 16:48:01', 'Hi-Way Inn', 'pshulemlg@oakley.com'),
(1223, 1, '2019-07-16 07:34:45', 'Candlewood Suites', 'rcaslaneow@unicef.org'),
(1224, 6, '2020-02-21 09:58:05', 'Hotel deLuxe', 'hyockney9s@arstechnica.com'),
(1225, 2, '2020-07-28 20:07:01', 'Luxor', 'adeguek8@state.tx.us'),
(1226, 4, '2019-01-10 20:45:02', 'Sheraton Centre', 'umatkovicmw@i2i.jp'),
(1227, 10, '2020-06-18 03:05:20', 'Hotel deLuxe', 'tyansonse2@google.es'),
(1228, 8, '2019-03-19 09:10:47', 'Luxor', 'jscownms@sina.com.cn'),
(1229, 10, '2020-01-04 04:29:43', 'Sheraton Centre', 'smaynell6i@google.co.uk'),
(1230, 6, '2019-08-22 21:59:17', 'Hotel deLuxe', 'eclemoesmr@webnode.com'),
(1231, 7, '2019-08-14 17:13:59', 'Hotel deLuxe', 'tocassidy51@lulu.com'),
(1232, 8, '2020-03-13 14:32:20', 'Luxor', 'cedwardsot@salon.com'),
(1233, 4, '2020-07-27 08:06:18', 'Hilton Downtown', 'vrhoddie5y@spiegel.de'),
(1234, 8, '2020-08-12 11:27:23', 'Residence Inn', 'tpietersmaec@amazon.de'),
(1235, 2, '2019-10-09 04:13:19', 'Hampton Inn', 'mtanser3h@mysql.com'),
(1236, 10, '2020-01-14 19:10:11', 'Hilton Downtown', 'yphaup7k@godaddy.com'),
(1237, 6, '2019-03-12 23:08:35', 'Hampton Inn', 'gimrieqa@hc360.com'),
(1238, 3, '2019-04-15 16:28:27', 'Candlewood Suites', 'ksutterfieldr4@bravesites.com'),
(1239, 2, '2019-04-16 13:28:44', 'The Paradise Inn', 'cingray44@virginia.edu'),
(1240, 10, '2019-12-28 19:10:17', 'Hi-Way Inn', 'kmillier1l@alibaba.com'),
(1241, 3, '2019-07-29 05:43:52', 'Hotel deLuxe', 'dcritchlowrh@hostgator.com'),
(1242, 2, '2019-08-25 09:22:35', 'The Paradise Inn', 'rloxdale2s@dot.gov'),
(1243, 4, '2020-05-18 11:31:21', 'Hilton Downtown', 'clamming53@booking.com'),
(1244, 7, '2019-09-08 06:50:10', 'Cute Mountains Inn', 'scajkler4z@taobao.com'),
(1245, 3, '2020-02-28 16:23:07', 'Sheraton Centre', 'lmagson70@cdc.gov'),
(1246, 5, '2019-12-04 13:48:16', 'Cute Mountains Inn', 'adenholm4@e-recht24.de'),
(1247, 6, '2019-02-26 05:27:17', 'Luxor', 'dtollandix@sfgate.com'),
(1248, 8, '2019-09-25 08:40:43', 'Hampton Inn', 'lpfeuffermb@example.com'),
(1249, 9, '2020-07-26 01:50:01', 'Hampton Inn', 'bmorfordat@google.de'),
(1250, 6, '2019-01-10 03:59:23', 'The Paradise Inn', 'vwestmerland35@umn.edu'),
(1251, 2, '2019-12-21 18:52:59', 'Candlewood Suites', 'istudmanpq@csmonitor.com'),
(1252, 2, '2020-02-20 21:15:25', 'Candlewood Suites', 'hwhorlowrd@mashable.com'),
(1253, 10, '2019-11-01 09:14:50', 'The Paradise Inn', 'lniaves6y@de.vu'),
(1254, 9, '2019-09-22 08:00:16', 'The Paradise Inn', 'weltonob@dyndns.org'),
(1255, 1, '2019-07-14 19:01:12', 'Residence Inn', 'erecord49@dedecms.com'),
(1256, 8, '2019-04-12 05:45:09', 'Cute Mountains Inn', 'pmeneofa@storify.com'),
(1257, 9, '2019-12-02 07:34:10', 'Cute Mountains Inn', 'wrickesies4x@yandex.ru'),
(1258, 6, '2020-01-01 21:13:52', 'Hampton Inn', 'abroadway2k@de.vu'),
(1259, 2, '2019-06-08 20:01:58', 'Residence Inn', 'lsharland92@prweb.com'),
(1260, 1, '2019-06-03 23:30:51', 'Luxor', 'sbridgewoodd2@purevolume.com'),
(1261, 10, '2019-02-11 18:29:39', 'Residence Inn', 'mmcalroyhu@drupal.org'),
(1262, 10, '2019-06-02 13:06:32', 'Sheraton Centre', 'jscoreynp@fc2.com'),
(1263, 5, '2019-01-31 22:52:31', 'Hotel deLuxe', 'nmallordqv@google.nl'),
(1264, 4, '2019-12-14 22:29:02', 'The Paradise Inn', 'rpettersenkb@stumbleupon.com'),
(1265, 4, '2020-03-05 01:53:41', 'Cute Mountains Inn', 'wtomaellokv@hatena.ne.jp'),
(1266, 2, '2019-08-29 23:39:32', 'Hampton Inn', 'tkobus4j@eventbrite.com'),
(1267, 9, '2019-12-26 08:18:53', 'Hampton Inn', 'jtellenbrokct@imdb.com'),
(1268, 2, '2020-05-12 06:09:52', 'Luxor', 'dhebard5i@cyberchimps.com'),
(1269, 6, '2019-05-09 03:52:24', 'Sheraton Centre', 'benstonqy@hibu.com'),
(1270, 10, '2019-03-23 19:47:55', 'Luxor', 'uhazeldenerj@tinyurl.com'),
(1271, 7, '2020-03-16 22:19:22', 'Hotel deLuxe', 'cmellers1f@xrea.com'),
(1272, 8, '2020-07-11 22:15:22', 'The Paradise Inn', 'smithanel@constantcontact.com'),
(1273, 1, '2019-03-11 05:42:03', 'Luxor', 'aticksalljr@addtoany.com'),
(1274, 2, '2019-11-04 22:12:05', 'Hilton Downtown', 'jclougherle@bravesites.com'),
(1275, 9, '2020-04-10 04:21:12', 'The Paradise Inn', 'hbiesingerja@mapquest.com'),
(1276, 9, '2019-06-21 19:56:30', 'Hotel deLuxe', 'mcastellscc@vk.com'),
(1277, 3, '2020-04-16 05:15:46', 'Luxor', 'ncastagnen0@twitpic.com'),
(1278, 8, '2020-06-18 03:57:37', 'Hotel deLuxe', 'llowdham5s@chron.com'),
(1279, 7, '2019-01-05 06:32:13', 'Luxor', 'ebaukhambi@japanpost.jp'),
(1280, 6, '2019-07-08 20:52:01', 'Residence Inn', 'jnorthernmt@google.it'),
(1281, 3, '2020-07-14 22:42:34', 'Candlewood Suites', 'bmeneelyc8@miibeian.gov.cn'),
(1282, 7, '2019-07-23 17:05:05', 'Cute Mountains Inn', 'ssowtefo@wufoo.com'),
(1283, 5, '2019-02-19 14:07:09', 'The Paradise Inn', 'jpidgeonpj@microsoft.com'),
(1284, 3, '2019-12-25 09:00:45', 'Cute Mountains Inn', 'fellerkerk0@technorati.com'),
(1285, 7, '2019-10-13 15:35:56', 'Sheraton Centre', 'agaskinshk@jiathis.com'),
(1286, 5, '2019-07-31 01:59:56', 'The Paradise Inn', 'hemonsjk@hc360.com'),
(1287, 5, '2019-10-14 00:39:46', 'The Paradise Inn', 'jjiroutekln@yale.edu'),
(1288, 3, '2019-04-29 06:14:29', 'Hotel deLuxe', 'vmattis6k@craigslist.org'),
(1289, 4, '2020-03-01 11:31:32', 'Candlewood Suites', 'gdrage5d@adobe.com'),
(1290, 9, '2020-01-06 17:00:21', 'Cute Mountains Inn', 'ibartloszjv@exblog.jp'),
(1291, 10, '2020-02-01 09:22:10', 'Luxor', 'lgadesby8u@e-recht24.de'),
(1292, 1, '2019-04-10 10:07:55', 'Hilton Downtown', 'vremirezk5@amazon.de'),
(1293, 6, '2020-06-15 06:57:42', 'Hotel deLuxe', 'jblissitt5u@cbslocal.com'),
(1294, 4, '2020-02-01 22:34:08', 'Hilton Downtown', 'kfidgeon6i@psu.edu'),
(1295, 3, '2019-01-20 04:12:57', 'Cute Mountains Inn', 'rtolletoz@cornell.edu'),
(1296, 5, '2020-08-08 05:00:01', 'Hilton Downtown', 'acecijd@wunderground.com'),
(1297, 7, '2020-01-21 04:28:36', 'Hotel deLuxe', 'noliveto7p@harvard.edu'),
(1298, 1, '2019-12-08 09:40:11', 'Residence Inn', 'pgorring42@artisteer.com'),
(1299, 7, '2019-01-18 23:35:53', 'The Paradise Inn', 'nbrimilcombebr@liveinternet.ru'),
(1300, 7, '2020-04-06 12:33:16', 'Hi-Way Inn', 'zjinkinou@sogou.com'),
(1301, 2, '2019-03-20 05:03:31', 'Hilton Downtown', 'mwansburycg@yale.edu'),
(1302, 6, '2019-08-19 10:23:32', 'Luxor', 'emasord@mtv.com'),
(1303, 8, '2019-01-11 03:33:13', 'Hi-Way Inn', 'mpreene7f@delicious.com'),
(1304, 3, '2019-05-28 10:31:10', 'The Paradise Inn', 'fhandasydeis@slashdot.org'),
(1305, 3, '2019-07-26 10:51:30', 'Hilton Downtown', 'tpullinqk@newyorker.com'),
(1306, 7, '2020-06-04 05:12:10', 'Residence Inn', 'fpanyero2@aboutads.info'),
(1307, 4, '2019-06-20 22:56:39', 'Hampton Inn', 'efevierga@51.la'),
(1308, 4, '2019-03-18 02:58:01', 'The Paradise Inn', 'spenningsj5@wufoo.com'),
(1309, 6, '2020-08-08 00:12:09', 'Hampton Inn', 'tbourdisaz@mediafire.com'),
(1310, 6, '2020-06-01 05:04:01', 'Candlewood Suites', 'kgersamat@aol.com'),
(1311, 3, '2019-11-23 22:22:33', 'Sheraton Centre', 'mpotes8f@google.de'),
(1312, 10, '2020-06-14 19:26:10', 'The Paradise Inn', 'crollinq6@oakley.com'),
(1313, 8, '2019-12-30 13:32:57', 'Hampton Inn', 'oshortonll@constantcontact.com'),
(1314, 3, '2020-04-07 13:01:40', 'Hi-Way Inn', 'mburnagedl@creativecommons.org'),
(1315, 2, '2019-10-23 16:49:54', 'Hotel deLuxe', 'westcourte1@parallels.com'),
(1316, 2, '2020-07-04 16:16:19', 'Hi-Way Inn', 'vroystonc@topsy.com'),
(1317, 8, '2020-07-10 13:33:28', 'Luxor', 'daers1@craigslist.org'),
(1318, 5, '2019-03-05 05:14:47', 'Luxor', 'hedensaq@sina.com.cn'),
(1319, 7, '2019-04-27 02:46:04', 'The Paradise Inn', 'adriffilljf@gnu.org'),
(1320, 2, '2020-02-08 02:21:48', 'Candlewood Suites', 'kbragge59@foxnews.com'),
(1321, 9, '2019-04-11 11:31:57', 'Luxor', 'rmcilory75@nbcnews.com'),
(1322, 4, '2020-08-03 06:27:12', 'Cute Mountains Inn', 'mblanche4e@creativecommons.org'),
(1323, 1, '2020-06-06 03:51:47', 'Residence Inn', 'rkowal33@yahoo.co.jp'),
(1324, 7, '2020-01-15 08:54:37', 'Luxor', 'rswanboroughf6@fema.gov'),
(1325, 10, '2019-01-10 23:54:09', 'Cute Mountains Inn', 'lbeamson6k@clickbank.net'),
(1326, 10, '2019-09-30 03:44:50', 'The Paradise Inn', 'hfebre5i@sfgate.com'),
(1327, 6, '2019-01-05 05:30:39', 'Cute Mountains Inn', 'rruprechtermn@unicef.org'),
(1328, 6, '2019-02-14 01:31:47', 'Cute Mountains Inn', 'jduddinly@chicagotribune.com'),
(1329, 2, '2020-05-22 08:17:34', 'Hilton Downtown', 'mnisbetdt@amazon.com'),
(1330, 7, '2019-10-15 11:24:20', 'Cute Mountains Inn', 'boyleykb@so-net.ne.jp'),
(1331, 7, '2019-02-14 22:58:41', 'Residence Inn', 'nbrimicombed@flickr.com'),
(1332, 9, '2019-08-15 12:34:10', 'Hampton Inn', 'tyansonse2@google.es'),
(1333, 2, '2020-03-27 05:35:38', 'Hilton Downtown', 'modooleyon@homestead.com'),
(1334, 7, '2019-06-29 23:02:29', 'Cute Mountains Inn', 'gpipkinfe@nytimes.com'),
(1335, 10, '2019-01-28 23:51:54', 'Cute Mountains Inn', 'aplattsdy@technorati.com'),
(1336, 9, '2019-07-18 11:35:26', 'Hotel deLuxe', 'tshine6b@topsy.com'),
(1337, 10, '2019-01-28 05:10:37', 'Cute Mountains Inn', 'pwantlingmp@discovery.com'),
(1338, 8, '2019-07-21 11:44:00', 'Hampton Inn', 'lmorsley1v@histats.com'),
(1339, 4, '2019-06-22 10:32:25', 'Hotel deLuxe', 'dcrantonei@drupal.org'),
(1340, 10, '2019-11-27 19:05:39', 'Hilton Downtown', 'oleemansdc@mapy.cz'),
(1341, 8, '2019-06-02 18:08:19', 'Sheraton Centre', 'hcroneg4@nps.gov'),
(1342, 8, '2019-01-30 02:29:14', 'Luxor', 'agomesh0@blog.com'),
(1343, 6, '2020-02-03 11:37:35', 'The Paradise Inn', 'alissamancs@mtv.com'),
(1344, 3, '2020-01-08 01:38:01', 'Cute Mountains Inn', 'mbarczynski3m@meetup.com'),
(1345, 2, '2019-07-17 03:14:37', 'Residence Inn', 'asummerly72@fda.gov');
INSERT INTO `review` (`review_id`, `rating`, `date_created`, `property_name`, `user_email`) VALUES
(1346, 7, '2020-07-26 17:28:02', 'Hampton Inn', 'nwimburyds@purevolume.com'),
(1347, 6, '2019-11-09 15:02:23', 'Luxor', 'gmenhamft@nih.gov'),
(1348, 10, '2020-06-13 22:20:56', 'Hampton Inn', 'gkerswell8k@oracle.com'),
(1349, 2, '2019-07-04 02:19:07', 'Sheraton Centre', 'fcampion2k@unesco.org'),
(1350, 9, '2019-05-04 14:24:55', 'Sheraton Centre', 'rmageeiq@harvard.edu'),
(1351, 7, '2020-03-06 20:11:23', 'Hi-Way Inn', 'claweles88@tmall.com'),
(1352, 2, '2019-06-03 07:46:52', 'Sheraton Centre', 'dwilmott2p@earthlink.net'),
(1353, 1, '2019-05-31 02:58:14', 'Candlewood Suites', 'mwherton4i@shareasale.com'),
(1354, 9, '2020-01-21 18:38:26', 'Hampton Inn', 'fbambrughk4@360.cn'),
(1355, 4, '2020-03-16 07:02:11', 'Residence Inn', 'nmaffiakj@google.ca'),
(1356, 8, '2019-03-13 07:58:44', 'Sheraton Centre', 'kstephensq7@mapquest.com'),
(1357, 1, '2019-06-08 13:59:10', 'Hi-Way Inn', 'rcleef6h@senate.gov'),
(1358, 2, '2019-08-09 08:30:41', 'Hi-Way Inn', 'mjanous5u@linkedin.com'),
(1359, 10, '2019-05-10 19:57:44', 'Hilton Downtown', 'jroftj@opensource.org'),
(1360, 2, '2020-05-18 12:00:07', 'Sheraton Centre', 'tsemoninid@google.de'),
(1361, 5, '2020-06-17 04:56:50', 'The Paradise Inn', 'dbriiginshawfh@edublogs.org'),
(1362, 4, '2019-12-06 23:19:13', 'The Paradise Inn', 'rmoraaj@ibm.com'),
(1363, 8, '2020-06-20 20:47:24', 'Hotel deLuxe', 'rzima5v@yale.edu'),
(1364, 3, '2020-03-16 04:37:43', 'Hotel deLuxe', 'sseldnern4@google.cn'),
(1365, 3, '2019-03-15 04:11:05', 'Cute Mountains Inn', 'kdamrellqs@ucla.edu'),
(1366, 4, '2019-05-25 07:00:35', 'Hi-Way Inn', 'swoolatt29@dailymail.co.uk'),
(1367, 2, '2020-02-02 19:31:32', 'Cute Mountains Inn', 'spraterhb@ehow.com'),
(1368, 5, '2020-06-24 18:57:15', 'Hotel deLuxe', 'isandelandr0@exblog.jp'),
(1369, 5, '2019-05-03 17:56:29', 'Residence Inn', 'jboastjl@devhub.com'),
(1370, 10, '2020-01-28 12:42:26', 'Hi-Way Inn', 'wrickesies4x@yandex.ru'),
(1371, 7, '2019-06-08 08:58:50', 'Hilton Downtown', 'jmilsapav@pinterest.com'),
(1372, 5, '2020-03-03 22:24:51', 'Candlewood Suites', 'nschooling8b@clickbank.net'),
(1373, 7, '2020-07-07 03:24:19', 'Hotel deLuxe', 'dtollandix@sfgate.com'),
(1374, 2, '2019-03-16 20:05:14', 'Residence Inn', 'ohartlelw@godaddy.com'),
(1375, 2, '2020-07-30 09:24:42', 'Hi-Way Inn', 'wsander2g@auda.org.au'),
(1376, 9, '2019-05-18 23:01:59', 'Residence Inn', 'nwreakesd8@sourceforge.net'),
(1377, 3, '2020-01-03 01:04:10', 'Hilton Downtown', 'cswatheridgemo@wordpress.org'),
(1378, 4, '2020-03-18 04:29:22', 'Luxor', 'cmcilhattona5@ebay.com'),
(1379, 1, '2020-07-30 19:55:57', 'Hilton Downtown', 'desomehm@princeton.edu'),
(1380, 2, '2020-04-10 01:48:28', 'Hi-Way Inn', 'lquilkinhb@behance.net'),
(1381, 6, '2019-12-23 11:59:07', 'Candlewood Suites', 'crookepp@army.mil'),
(1382, 8, '2019-06-11 08:02:01', 'Candlewood Suites', 'flesurfko@acquirethisname.com'),
(1383, 10, '2019-01-15 12:58:22', 'Hotel deLuxe', 'ksighartm6@twitpic.com'),
(1384, 8, '2019-01-23 21:24:14', 'Residence Inn', 'mroddellcy@t-online.de'),
(1385, 8, '2019-02-22 08:30:45', 'Sheraton Centre', 'adenholm4@e-recht24.de'),
(1386, 10, '2020-03-26 08:59:38', 'Candlewood Suites', 'slamey3o@columbia.edu'),
(1387, 7, '2020-04-04 18:09:28', 'Candlewood Suites', 'cdifranceshci3x@narod.ru'),
(1388, 1, '2019-03-08 15:00:40', 'Hampton Inn', 'dquogancy@wsj.com'),
(1389, 8, '2020-05-22 14:58:51', 'Luxor', 'bhalson5r@indiatimes.com'),
(1390, 2, '2020-02-04 01:48:15', 'Hilton Downtown', 'hdolbeyr2@google.com'),
(1391, 8, '2019-04-27 22:21:48', 'Hilton Downtown', 'hbeynke98@istockphoto.com'),
(1392, 6, '2020-06-28 12:47:06', 'Sheraton Centre', 'neidelman7a@ed.gov'),
(1393, 8, '2019-02-04 22:23:08', 'Hampton Inn', 'astert9h@foxnews.com'),
(1394, 1, '2020-01-19 07:11:35', 'Cute Mountains Inn', 'ajasik6z@com.com'),
(1395, 5, '2020-05-11 15:10:52', 'Candlewood Suites', 'ftibolsmr@123-reg.co.uk'),
(1396, 3, '2020-05-17 09:38:01', 'Luxor', 'zshevellc9@ted.com'),
(1397, 8, '2019-08-01 02:22:49', 'Residence Inn', 'voxxfj@1und1.de'),
(1398, 10, '2019-07-31 01:17:11', 'Hilton Downtown', 'gerrichil3@cnet.com'),
(1399, 5, '2020-07-15 14:03:35', 'Hi-Way Inn', 'dtodhunterez@foxnews.com'),
(1400, 9, '2019-07-31 09:05:38', 'Hilton Downtown', 'bpearnh2@merriam-webster.com'),
(1401, 3, '2020-01-18 15:57:05', 'Hotel deLuxe', 'rgebb6u@sourceforge.net'),
(1402, 8, '2020-06-11 19:39:07', 'Hi-Way Inn', 'mlittlejohnsfb@state.gov'),
(1403, 3, '2020-02-28 23:25:46', 'Hilton Downtown', 'ctenny80@printfriendly.com'),
(1404, 3, '2020-03-28 06:12:38', 'Hotel deLuxe', 'dwestfrimley6g@vimeo.com'),
(1405, 9, '2019-11-23 13:41:34', 'Cute Mountains Inn', 'jtoselandov@last.fm'),
(1406, 8, '2020-06-06 22:53:48', 'Hampton Inn', 'nwoodingsou@xinhuanet.com'),
(1407, 4, '2019-05-07 10:23:19', 'Hi-Way Inn', 'ekellittkq@boston.com'),
(1408, 10, '2019-10-26 11:42:30', 'Hi-Way Inn', 'jscownms@sina.com.cn'),
(1409, 10, '2020-07-08 13:24:46', 'Luxor', 'tkeffordpc@eventbrite.com'),
(1410, 5, '2019-10-16 17:14:58', 'Hampton Inn', 'jtowell40@wiley.com'),
(1411, 5, '2020-06-07 13:33:05', 'Hi-Way Inn', 'mwhitney1d@hc360.com'),
(1412, 5, '2019-07-06 14:12:36', 'Hampton Inn', 'mdefriesq5@cocolog-nifty.com'),
(1413, 4, '2019-03-09 02:15:52', 'Residence Inn', 'gloadsmanq4@ucoz.ru'),
(1414, 3, '2019-01-31 02:09:05', 'Hi-Way Inn', 'alewendono8@princeton.edu'),
(1415, 6, '2020-06-27 19:55:55', 'Cute Mountains Inn', 'hbiesingerja@mapquest.com'),
(1416, 9, '2020-06-11 08:05:37', 'Residence Inn', 'egarwillnr@dailymail.co.uk'),
(1417, 10, '2020-04-23 03:46:04', 'Hotel deLuxe', 'ffrushardel@tuttocitta.it'),
(1418, 2, '2019-12-22 12:08:36', 'The Paradise Inn', 'nmallordqv@google.nl'),
(1419, 9, '2019-08-29 03:19:44', 'The Paradise Inn', 'igarnulq3@goo.gl'),
(1420, 7, '2019-12-13 23:00:51', 'Candlewood Suites', 'cbettison5o@canalblog.com'),
(1421, 2, '2019-08-01 01:33:41', 'Hilton Downtown', 'sgarment2j@tripod.com'),
(1422, 2, '2019-01-03 19:41:43', 'Residence Inn', 'emullallyq1@msu.edu'),
(1423, 4, '2020-06-27 06:17:38', 'Sheraton Centre', 'mdedneycj@theguardian.com'),
(1424, 6, '2019-10-16 05:27:46', 'Hampton Inn', 'ghendriksends@blinklist.com'),
(1425, 6, '2019-04-10 13:14:08', 'Cute Mountains Inn', 'rleggenff@prweb.com'),
(1426, 1, '2020-02-23 03:38:56', 'Hi-Way Inn', 'pdenseyjg@topsy.com'),
(1427, 2, '2020-02-05 05:48:56', 'Residence Inn', 'asuartcj@utexas.edu'),
(1428, 5, '2020-01-26 21:25:07', 'The Paradise Inn', 'mchurchousefp@redcross.org'),
(1429, 7, '2019-05-04 02:07:02', 'Hi-Way Inn', 'eagaroc@forbes.com'),
(1430, 4, '2019-10-08 20:08:52', 'Hotel deLuxe', 'shalsted2a@indiegogo.com'),
(1431, 6, '2019-02-08 13:21:51', 'Hampton Inn', 'hfowgiesb4@patch.com'),
(1432, 10, '2019-03-27 08:25:56', 'Luxor', 'jpien2@shareasale.com'),
(1433, 3, '2020-05-10 00:45:52', 'Hilton Downtown', 'pmachostiei9@unc.edu'),
(1434, 2, '2019-12-03 18:33:27', 'Hampton Inn', 'dloadernc@wikispaces.com'),
(1435, 4, '2019-12-22 11:53:47', 'Sheraton Centre', 'hripper74@blogspot.com'),
(1436, 9, '2019-01-11 21:02:23', 'Sheraton Centre', 'mwarnockgg@xrea.com'),
(1437, 7, '2020-01-19 09:06:47', 'Hampton Inn', 'ckittemanhg@printfriendly.com'),
(1438, 3, '2019-03-09 09:47:52', 'Cute Mountains Inn', 'zpetrosiannn@oaic.gov.au'),
(1439, 1, '2019-04-07 02:36:31', 'Hilton Downtown', 'rkilleley3f@jimdo.com'),
(1440, 4, '2019-04-05 02:01:18', 'Cute Mountains Inn', 'bbynethad@scribd.com'),
(1441, 3, '2020-04-28 08:00:36', 'Hampton Inn', 'edaintry7b@nih.gov'),
(1442, 1, '2020-04-13 12:38:51', 'Hilton Downtown', 'beustonl5@ycombinator.com'),
(1443, 3, '2019-02-06 02:59:47', 'Sheraton Centre', 'cdudin5q@google.ca'),
(1444, 8, '2019-06-23 15:28:37', 'Residence Inn', 'jsicilyem@weibo.com'),
(1445, 8, '2020-06-27 03:00:39', 'Hotel deLuxe', 'nhorburghoc@odnoklassniki.ru'),
(1446, 9, '2019-12-15 23:30:58', 'Hotel deLuxe', 'gscowcraftld@bizjournals.com'),
(1447, 7, '2019-01-24 04:10:29', 'Candlewood Suites', 'pwhitebrooker@prnewswire.com'),
(1448, 8, '2019-02-22 06:01:25', 'Candlewood Suites', 'aking3e@bbb.org'),
(1449, 4, '2019-05-16 21:04:20', 'Residence Inn', 'astert9h@foxnews.com'),
(1450, 5, '2019-10-19 21:15:30', 'Sheraton Centre', 'trudolph9l@guardian.co.uk'),
(1451, 2, '2020-03-22 05:44:28', 'Hilton Downtown', 'mvickressc2@blogs.com'),
(1452, 8, '2020-07-18 02:34:22', 'Luxor', 'fbonhillmc@google.com.br'),
(1453, 7, '2020-04-15 08:59:11', 'Hilton Downtown', 'jkasnm@businesswire.com'),
(1454, 3, '2019-04-11 18:52:09', 'Cute Mountains Inn', 'cmcilhattona5@ebay.com'),
(1455, 10, '2020-03-27 01:41:26', 'The Paradise Inn', 'epimmockeal@meetup.com'),
(1456, 10, '2019-07-18 11:35:11', 'Hotel deLuxe', 'jtinebq@drupal.org'),
(1457, 5, '2020-03-22 02:28:45', 'Hotel deLuxe', 'admin@ihg.com'),
(1458, 10, '2019-03-24 02:39:44', 'Cute Mountains Inn', 'wcaneypz@sina.com.cn'),
(1459, 1, '2019-02-18 04:40:54', 'Cute Mountains Inn', 'croxbeebp@wikia.com'),
(1460, 2, '2019-09-09 16:06:43', 'Hilton Downtown', 'obarnesa0@admin.ch'),
(1461, 8, '2020-04-24 14:48:58', 'Hotel deLuxe', 'nglosterlm@squidoo.com'),
(1462, 2, '2019-06-16 00:27:07', 'Hi-Way Inn', 'ttuma69@addtoany.com'),
(1463, 10, '2020-05-11 09:48:57', 'Hi-Way Inn', 'btromansfk@google.co.jp'),
(1464, 8, '2019-10-28 19:31:29', 'Hotel deLuxe', 'gnoliep@icio.us'),
(1465, 8, '2019-01-24 19:13:36', 'Hampton Inn', 'bcritzen9h@123-reg.co.uk'),
(1466, 2, '2020-05-24 23:48:12', 'Hilton Downtown', 'edaintry7b@nih.gov'),
(1467, 3, '2019-12-11 23:52:21', 'Cute Mountains Inn', 'ccanons@sun.com'),
(1468, 4, '2019-05-14 00:02:50', 'Hampton Inn', 'kblythdw@dagondesign.com'),
(1469, 1, '2019-02-21 18:09:50', 'Candlewood Suites', 'bdunnanqp@gnu.org'),
(1470, 1, '2019-04-07 00:25:33', 'Luxor', 'oletherburybc@tiny.cc'),
(1471, 7, '2019-10-30 18:35:26', 'Hilton Downtown', 'rkear6e@newsvine.com'),
(1472, 4, '2019-08-28 06:00:41', 'Hi-Way Inn', 'eyushmanovlc@wikispaces.com'),
(1473, 1, '2019-03-26 15:03:36', 'Hampton Inn', 'eshapter7r@samsung.com'),
(1474, 8, '2019-06-24 22:15:39', 'Residence Inn', 'vschwandermannfe@rambler.ru'),
(1475, 9, '2019-07-20 11:46:58', 'Cute Mountains Inn', 'mjanous5u@linkedin.com'),
(1476, 9, '2019-02-13 22:18:01', 'Luxor', 'aumneyjk@behance.net'),
(1477, 5, '2020-04-07 01:53:11', 'The Paradise Inn', 'hpeeverc5@comsenz.com'),
(1478, 6, '2020-02-25 08:01:47', 'Hotel deLuxe', 'crubinj1@skyrock.com'),
(1479, 4, '2019-02-09 18:35:50', 'Candlewood Suites', 'bmcmeyler62@cafepress.com'),
(1480, 10, '2019-04-26 13:25:54', 'Hampton Inn', 'ndowlingar@usnews.com'),
(1481, 4, '2020-05-24 12:41:13', 'Hotel deLuxe', 'soldreynn@redcross.org'),
(1482, 5, '2019-03-06 03:56:21', 'Sheraton Centre', 'mbrosettifb@timesonline.co.uk'),
(1483, 7, '2020-03-10 11:53:13', 'Hilton Downtown', 'cogdahlb8@parallels.com'),
(1484, 2, '2020-06-22 23:53:35', 'Hilton Downtown', 'kbischoffci@nifty.com'),
(1485, 6, '2019-11-19 15:01:19', 'Residence Inn', 'jmorphetku@princeton.edu'),
(1486, 7, '2020-01-04 09:22:28', 'Hi-Way Inn', 'aohartnett7x@biblegateway.com'),
(1487, 7, '2019-08-01 10:20:19', 'Luxor', 'gantalie@live.com'),
(1488, 9, '2020-02-06 09:58:43', 'Hotel deLuxe', 'smcarda3@instagram.com'),
(1489, 1, '2019-02-28 15:57:35', 'The Paradise Inn', 'dmckanern@gmpg.org'),
(1490, 8, '2020-02-27 04:14:32', 'Luxor', 'kgaulef9@mtv.com'),
(1491, 5, '2020-03-15 11:14:16', 'Cute Mountains Inn', 'lnortheastqu@ucsd.edu'),
(1492, 9, '2020-07-13 11:18:45', 'Candlewood Suites', 'edaintry7b@nih.gov'),
(1493, 10, '2019-02-19 15:44:38', 'Hotel deLuxe', 'dholdforthmv@163.com'),
(1494, 6, '2019-11-27 14:36:45', 'Candlewood Suites', 'fcolhounbl@mtv.com'),
(1495, 6, '2019-01-17 21:14:11', 'Hi-Way Inn', 'mmcclancyn9@msn.com'),
(1496, 3, '2019-12-24 22:15:02', 'Candlewood Suites', 'icarlemq@fotki.com'),
(1497, 4, '2019-03-01 07:47:04', 'Luxor', 'liredaleav@admin.ch'),
(1498, 5, '2019-05-10 07:17:45', 'Candlewood Suites', 'jliverseegedt@dmoz.org'),
(1499, 10, '2020-04-14 02:30:41', 'Hotel deLuxe', 'hlivoirb2@examiner.com'),
(1500, 5, '2020-01-15 01:17:01', 'Luxor', 'sgellingff@instagram.com'),
(1501, 5, '2019-12-26 21:21:23', 'Luxor', 'rkear6e@newsvine.com'),
(1502, 2, '2020-03-21 20:02:44', 'The Paradise Inn', 'rpreator3c@symantec.com'),
(1503, 8, '2020-08-02 14:52:52', 'Hampton Inn', 'gangelc7@ucoz.ru'),
(1504, 7, '2020-03-31 08:56:17', 'Luxor', 'kmaclesebn@blogspot.com'),
(1505, 1, '2019-02-09 10:04:59', 'Cute Mountains Inn', 'lgoney8h@dropbox.com'),
(1506, 6, '2019-12-31 10:42:19', 'Residence Inn', 'etoobyjc@globo.com'),
(1507, 4, '2020-02-06 03:45:25', 'Sheraton Centre', 'nbaumanbh@imdb.com'),
(1508, 7, '2019-04-16 22:16:42', 'Hilton Downtown', 'ptophamni@networksolutions.com'),
(1509, 8, '2019-12-30 23:51:43', 'Cute Mountains Inn', 'lgoublierjz@arstechnica.com'),
(1510, 1, '2020-01-06 07:33:10', 'Hampton Inn', 'msiggeb5@yahoo.co.jp'),
(1511, 10, '2019-01-11 19:06:54', 'Candlewood Suites', 'apimer28@upenn.edu'),
(1512, 7, '2019-05-10 22:02:19', 'Hilton Downtown', 'dbeedelleu@go.com'),
(1513, 1, '2019-09-06 02:23:17', 'The Paradise Inn', 'mdudenie3i@soundcloud.com'),
(1514, 5, '2020-03-26 06:24:00', 'Sheraton Centre', 'rjoicef8@topsy.com'),
(1515, 6, '2020-05-18 23:40:19', 'The Paradise Inn', 'gmccrowo1@blogger.com'),
(1516, 4, '2020-05-15 12:00:38', 'Sheraton Centre', 'nschooling8b@clickbank.net'),
(1517, 3, '2019-07-22 21:02:40', 'Residence Inn', 'cmcconnachie8f@gmpg.org'),
(1518, 3, '2019-06-16 00:47:25', 'Hi-Way Inn', 'colley8r@upenn.edu'),
(1519, 10, '2019-01-26 08:10:11', 'Luxor', 'ndowlingar@usnews.com'),
(1520, 7, '2019-01-02 19:48:02', 'Hampton Inn', 'mwansburycg@yale.edu'),
(1521, 5, '2019-02-14 05:26:43', 'Candlewood Suites', 'acarvillarc@pen.io'),
(1522, 6, '2019-10-29 05:46:01', 'Luxor', 'ashapera1c@techcrunch.com'),
(1523, 9, '2020-04-26 02:19:43', 'Hi-Way Inn', 'sgasperoln@dailymotion.com'),
(1524, 7, '2019-03-30 03:18:14', 'Luxor', 'swhilderit@qq.com'),
(1525, 4, '2020-03-21 21:55:21', 'The Paradise Inn', 'cdonahue3f@myspace.com'),
(1526, 2, '2019-07-04 17:49:13', 'Residence Inn', 'msetterthwait1i@zdnet.com'),
(1527, 9, '2020-01-11 07:50:22', 'Cute Mountains Inn', 'hupham1k@cbc.ca'),
(1528, 10, '2019-05-01 04:00:49', 'Residence Inn', 'srylandci@timesonline.co.uk'),
(1529, 1, '2020-01-25 12:47:42', 'Sheraton Centre', 'krangell27@delicious.com'),
(1530, 3, '2020-01-31 22:30:27', 'Cute Mountains Inn', 'jbowmen3t@jimdo.com'),
(1531, 8, '2020-07-29 12:19:11', 'Hilton Downtown', 'ostaniforthdm@home.pl'),
(1532, 1, '2020-04-25 19:27:09', 'Hotel deLuxe', 'bosgar8m@stumbleupon.com'),
(1533, 1, '2019-04-14 06:32:45', 'Hilton Downtown', 'bklaussenl4@purevolume.com'),
(1534, 1, '2019-05-15 07:02:54', 'Sheraton Centre', 'bhalson5r@indiatimes.com'),
(1535, 3, '2019-06-14 10:35:14', 'Hampton Inn', 'yphaup7k@godaddy.com'),
(1536, 4, '2019-10-24 13:36:43', 'Hi-Way Inn', 'rambrozkv@php.net'),
(1537, 10, '2019-06-09 09:29:20', 'Cute Mountains Inn', 'apurleri@nih.gov'),
(1538, 9, '2019-12-17 11:01:26', 'Cute Mountains Inn', 'ngeggusr5@theglobeandmail.com'),
(1539, 10, '2019-04-08 20:25:40', 'Hilton Downtown', 'cshropshiremh@sfgate.com'),
(1540, 1, '2019-07-22 18:25:49', 'Hilton Downtown', 'mstirrupra@csmonitor.com'),
(1541, 4, '2019-07-01 02:58:14', 'Hilton Downtown', 'savrahamian24@google.ca'),
(1542, 5, '2020-02-10 12:33:58', 'Residence Inn', 'ddurnallq1@cbc.ca'),
(1543, 8, '2019-05-27 09:23:10', 'Hampton Inn', 'ksignej5@vimeo.com'),
(1544, 2, '2019-06-21 02:46:47', 'Cute Mountains Inn', 'joldredac@wordpress.com'),
(1545, 9, '2020-07-15 20:45:44', 'Luxor', 'dcrantonei@drupal.org'),
(1546, 1, '2019-12-24 07:50:56', 'Hampton Inn', 'hkullmannqf@jigsy.com'),
(1547, 2, '2019-05-28 17:48:18', 'The Paradise Inn', 'dwisherjb@chicagotribune.com'),
(1548, 5, '2019-04-16 23:15:26', 'Hilton Downtown', 'kseckerr6@gnu.org'),
(1549, 6, '2020-03-16 18:15:16', 'Hampton Inn', 'lmorsley1v@histats.com'),
(1550, 7, '2019-01-10 01:49:25', 'Cute Mountains Inn', 'amandres3h@rediff.com'),
(1551, 7, '2019-01-19 05:45:11', 'Hi-Way Inn', 'ajaycockqo@ehow.com'),
(1552, 6, '2019-09-28 11:56:13', 'Luxor', 'gstentonkl@twitter.com'),
(1553, 5, '2020-07-25 09:32:52', 'Hotel deLuxe', 'fhandasydeis@slashdot.org'),
(1554, 2, '2020-04-19 10:11:04', 'Residence Inn', 'jdunninge4@webs.com'),
(1555, 9, '2020-05-20 09:13:39', 'Hilton Downtown', 'hconnoldj@ycombinator.com'),
(1556, 7, '2019-05-12 12:49:44', 'Hotel deLuxe', 'rosharry6x@accuweather.com'),
(1557, 5, '2019-02-18 11:28:58', 'Hilton Downtown', 'jkasnm@businesswire.com'),
(1558, 6, '2020-03-15 10:29:18', 'Residence Inn', 'apurleri@nih.gov'),
(1559, 7, '2020-01-16 06:56:07', 'Hampton Inn', 'hchristall10@dmoz.org'),
(1560, 5, '2019-12-27 00:26:18', 'Hampton Inn', 'ggoalleycu@dmoz.org'),
(1561, 2, '2019-11-24 22:48:25', 'Sheraton Centre', 'mrosenblattc4@prweb.com'),
(1562, 4, '2020-03-12 17:29:25', 'Hilton Downtown', 'agritskovmd@soundcloud.com'),
(1563, 1, '2019-06-02 02:19:59', 'Luxor', 'osuermeierlf@feedburner.com'),
(1564, 6, '2019-12-11 03:11:26', 'Cute Mountains Inn', 'dcruden79@phoca.cz'),
(1565, 10, '2019-11-18 06:21:36', 'Candlewood Suites', 'apackwoodoy@t.co'),
(1566, 2, '2019-07-05 01:06:43', 'Hilton Downtown', 'bgiampietro56@bbb.org'),
(1567, 9, '2019-05-02 13:14:48', 'Hilton Downtown', 'ggregond@xing.com'),
(1568, 7, '2020-03-27 11:26:04', 'The Paradise Inn', 'bgerholdhh@harvard.edu'),
(1569, 7, '2019-03-08 10:19:19', 'The Paradise Inn', 'swoolatt29@dailymail.co.uk'),
(1570, 3, '2020-01-16 04:51:55', 'Cute Mountains Inn', 'afryman20@naver.com'),
(1571, 5, '2019-12-09 23:24:37', 'The Paradise Inn', 'fhandasydeis@slashdot.org'),
(1572, 10, '2019-10-16 17:14:14', 'Hotel deLuxe', 'klaversj9@parallels.com'),
(1573, 10, '2020-05-13 09:22:24', 'Luxor', 'rquayle8y@bloomberg.com'),
(1574, 7, '2019-07-15 02:04:31', 'Hampton Inn', 'cpinkard7j@constantcontact.com'),
(1575, 5, '2020-07-31 07:46:51', 'Hi-Way Inn', 'fshingfield50@parallels.com'),
(1576, 7, '2019-02-06 15:34:57', 'Luxor', 'ltriplettgd@cocolog-nifty.com'),
(1577, 4, '2020-01-12 13:56:44', 'Residence Inn', 'acroixnm@bloglines.com'),
(1578, 8, '2019-04-08 17:40:11', 'Residence Inn', 'dchristypd@noaa.gov'),
(1579, 3, '2020-03-30 00:31:14', 'Hilton Downtown', 'jlansdown3u@yahoo.com'),
(1580, 2, '2019-09-04 03:04:02', 'Cute Mountains Inn', 'dkendala4@slideshare.net'),
(1581, 9, '2019-01-25 19:41:41', 'Residence Inn', 'ibiggamph@alexa.com'),
(1582, 5, '2019-10-04 05:29:22', 'Hilton Downtown', 'awyvilljg@amazon.de'),
(1583, 7, '2020-04-25 05:19:01', 'Candlewood Suites', 'ccuell2n@census.gov'),
(1584, 3, '2020-04-29 01:43:04', 'The Paradise Inn', 'hsevingn@elpais.com'),
(1585, 9, '2019-02-06 05:35:11', 'Hilton Downtown', 'hpresterns@eventbrite.com'),
(1586, 9, '2019-01-30 21:58:04', 'The Paradise Inn', 'wmixon81@bloglovin.com'),
(1587, 10, '2019-10-06 12:43:08', 'Hotel deLuxe', 'kmirams54@amazon.com'),
(1588, 5, '2019-09-18 11:05:32', 'Candlewood Suites', 'hmelbourneeo@hp.com'),
(1589, 6, '2019-11-24 18:12:51', 'Hotel deLuxe', 'tskillaa@auda.org.au'),
(1590, 2, '2020-03-04 02:32:10', 'Sheraton Centre', 'anoenk@mit.edu'),
(1591, 8, '2020-05-11 16:36:07', 'Hi-Way Inn', 'ytibblt@cnbc.com'),
(1592, 1, '2019-03-04 19:28:00', 'Candlewood Suites', 'nmolanqg@uol.com.br'),
(1593, 2, '2019-08-07 11:40:02', 'Hi-Way Inn', 'rlabror3@abc.net.au'),
(1594, 4, '2019-06-13 21:39:50', 'Hampton Inn', 'dmacgiffiniu@imgur.com'),
(1595, 5, '2020-07-04 10:01:56', 'Hampton Inn', 'rgoddardgs@sciencedaily.com'),
(1596, 4, '2019-05-17 09:07:14', 'Candlewood Suites', 'rmcilory75@nbcnews.com'),
(1597, 4, '2019-08-25 10:18:51', 'Hampton Inn', 'jjoulpa@home.pl'),
(1598, 4, '2019-02-12 08:36:44', 'Candlewood Suites', 'cperfilig@ibm.com'),
(1599, 6, '2019-10-06 19:40:24', 'Candlewood Suites', 'pmckimmqm@rediff.com'),
(1600, 8, '2020-02-13 08:14:29', 'The Paradise Inn', 'mboggsqi@psu.edu'),
(1601, 1, '2020-07-27 09:49:02', 'Hampton Inn', 'sendekp@ehow.com'),
(1602, 6, '2019-08-09 22:18:06', 'Luxor', 'gfilov2e@huffingtonpost.com'),
(1603, 9, '2019-08-25 14:05:31', 'Hi-Way Inn', 'ahefferfz@amazon.com'),
(1604, 7, '2019-11-23 00:24:00', 'Candlewood Suites', 'mbenaine2p@ning.com'),
(1605, 10, '2019-02-07 18:48:26', 'Hi-Way Inn', 'hmcgeacheypr@facebook.com'),
(1606, 1, '2020-01-04 06:32:12', 'Hotel deLuxe', 'iromaintpy@google.it'),
(1607, 8, '2020-07-04 23:53:41', 'Candlewood Suites', 'sdoore6l@cnn.com'),
(1608, 8, '2019-07-20 12:47:19', 'Hampton Inn', 'ibrixeyaa@yelp.com'),
(1609, 5, '2019-01-25 19:35:40', 'Hilton Downtown', 'fplaingm@blogger.com'),
(1610, 6, '2019-11-01 13:35:36', 'Hi-Way Inn', 'nvedmore4b@goo.gl'),
(1611, 5, '2019-10-08 20:34:05', 'Cute Mountains Inn', 'lmaccartneyap@addtoany.com'),
(1612, 8, '2020-02-19 23:01:53', 'Hilton Downtown', 'bgatteridgea2@topsy.com'),
(1613, 10, '2019-10-02 05:31:38', 'Hi-Way Inn', 'ebrudenell1e@ask.com'),
(1614, 4, '2019-12-25 13:35:00', 'Luxor', 'jbattellejf@arstechnica.com'),
(1615, 6, '2019-02-24 04:50:38', 'Cute Mountains Inn', 'mcopinsoi@ihg.com'),
(1616, 10, '2019-06-16 12:12:16', 'Candlewood Suites', 'jstredderp4@addtoany.com'),
(1617, 7, '2019-09-23 17:35:56', 'Hotel deLuxe', 'scomrie4s@ow.ly'),
(1618, 9, '2019-06-26 07:31:51', 'Candlewood Suites', 'jmaynellmu@technorati.com'),
(1619, 7, '2019-08-14 02:01:21', 'The Paradise Inn', 'dhebard5i@cyberchimps.com'),
(1620, 5, '2019-09-16 04:48:21', 'Candlewood Suites', 'psmaridgeia@pinterest.com'),
(1621, 9, '2019-02-02 09:35:22', 'Luxor', 'hmcgeacheypr@facebook.com'),
(1622, 3, '2019-01-24 12:29:21', 'Luxor', 'sbirkheadm@sakura.ne.jp'),
(1623, 1, '2019-08-09 19:50:37', 'Sheraton Centre', 'gloadsmanq4@ucoz.ru'),
(1624, 5, '2019-03-10 23:04:38', 'Hotel deLuxe', 'iironside83@dagondesign.com'),
(1625, 9, '2019-09-05 11:09:05', 'Candlewood Suites', 'ckyne2s@yahoo.com'),
(1626, 6, '2020-02-05 07:55:21', 'Candlewood Suites', 'kdommersennl@home.pl'),
(1627, 5, '2020-05-21 16:26:59', 'Hotel deLuxe', 'beustonl5@ycombinator.com'),
(1628, 6, '2019-12-02 21:26:13', 'Hotel deLuxe', 'dtitcomb93@ustream.tv'),
(1629, 9, '2019-12-29 16:10:56', 'Luxor', 'emarstersfg@microsoft.com'),
(1630, 6, '2020-07-28 06:09:51', 'Sheraton Centre', 'lsapshedlj@wikispaces.com'),
(1631, 2, '2020-03-23 07:56:36', 'Sheraton Centre', 'zmacieiczykj6@google.co.jp'),
(1632, 1, '2019-06-24 07:37:07', 'Hotel deLuxe', 'ahefferfz@amazon.com'),
(1633, 5, '2019-02-04 01:39:16', 'Hilton Downtown', 'jzmitrichenkop5@bloomberg.com'),
(1634, 6, '2019-05-27 23:15:31', 'Luxor', 'isallnowq6@imageshack.us'),
(1635, 3, '2019-03-30 05:40:21', 'Sheraton Centre', 'fpeepall14@gizmodo.com'),
(1636, 10, '2020-07-12 16:53:52', 'Hampton Inn', 'maitken18@ed.gov'),
(1637, 5, '2020-01-30 09:44:38', 'Hilton Downtown', 'cdudin5q@google.ca'),
(1638, 2, '2020-01-16 08:42:26', 'Hi-Way Inn', 'nmolanqg@uol.com.br'),
(1639, 3, '2020-05-03 00:48:42', 'Hilton Downtown', 'ssacher8q@google.nl'),
(1640, 2, '2020-01-26 19:12:30', 'Sheraton Centre', 'dguineryp6@icq.com'),
(1641, 6, '2019-11-25 17:37:37', 'The Paradise Inn', 'alockyeare6@businessinsider.com'),
(1642, 1, '2019-10-11 23:44:41', 'Hilton Downtown', 'cdonisem4@blinklist.com'),
(1643, 9, '2019-05-09 20:56:37', 'Hilton Downtown', 'rrichardetix@constantcontact.com'),
(1644, 3, '2019-12-21 20:09:47', 'Luxor', 'mstobbart22@yahoo.co.jp'),
(1645, 9, '2019-05-03 23:53:04', 'Hampton Inn', 'cmullinermn@gnu.org'),
(1646, 1, '2019-04-01 21:17:56', 'Hotel deLuxe', 'lrabbagej0@goo.ne.jp'),
(1647, 3, '2020-05-23 10:45:37', 'Hampton Inn', 'lquilkinhb@behance.net'),
(1648, 5, '2019-08-05 19:14:50', 'Hi-Way Inn', 'lwalteringo4@barnesandnoble.com'),
(1649, 8, '2019-10-20 22:39:57', 'Sheraton Centre', 'dleakner1w@si.edu'),
(1650, 5, '2019-07-01 10:58:28', 'Candlewood Suites', 'ahaughianji@dedecms.com'),
(1651, 10, '2020-08-09 16:22:44', 'Candlewood Suites', 'rcollinop@japanpost.jp'),
(1652, 5, '2019-10-19 23:34:36', 'Residence Inn', 'mmccaughan7t@sfgate.com'),
(1653, 2, '2019-07-25 06:54:17', 'Hotel deLuxe', 'hkeytea4@is.gd'),
(1654, 2, '2020-04-23 01:42:40', 'Residence Inn', 'grogerothq@bravesites.com'),
(1655, 5, '2019-04-30 03:52:32', 'Hotel deLuxe', 'cmolineauxcb@jalbum.net'),
(1656, 6, '2019-11-16 10:32:10', 'Hilton Downtown', 'sansilld1@mapy.cz'),
(1657, 4, '2019-09-21 01:20:57', 'Luxor', 'ascotson1y@deviantart.com'),
(1658, 10, '2019-02-11 13:11:25', 'Sheraton Centre', 'gpipkinfe@nytimes.com'),
(1659, 1, '2020-01-14 12:48:04', 'Sheraton Centre', 'kdaughertyl8@amazon.com'),
(1660, 3, '2020-02-20 05:18:44', 'Luxor', 'mgartelloq@irs.gov'),
(1661, 7, '2019-04-04 19:24:34', 'Sheraton Centre', 'gduddingh@facebook.com'),
(1662, 10, '2019-09-25 14:06:51', 'Cute Mountains Inn', 'rlansdownlb@tinyurl.com'),
(1663, 4, '2020-03-02 19:48:54', 'Cute Mountains Inn', 'nalekseicikp7@godaddy.com'),
(1664, 5, '2019-06-23 09:46:41', 'Hampton Inn', 'cdonisem4@blinklist.com'),
(1665, 9, '2020-07-02 18:48:10', 'Hilton Downtown', 'hripper74@blogspot.com'),
(1666, 8, '2019-12-29 23:41:03', 'Luxor', 'jmccrann9w@tinypic.com'),
(1667, 6, '2019-12-26 23:32:41', 'Hilton Downtown', 'jpetergc@godaddy.com'),
(1668, 5, '2019-02-23 00:51:59', 'Hilton Downtown', 'lsharland92@prweb.com'),
(1669, 9, '2019-09-12 02:43:34', 'Hampton Inn', 'lmagson70@cdc.gov'),
(1670, 2, '2020-03-08 14:36:34', 'Hi-Way Inn', 'dvasilmanovh4@indiegogo.com'),
(1671, 2, '2020-08-01 17:36:53', 'Hilton Downtown', 'lsayburnox@ustream.tv'),
(1672, 2, '2019-08-11 05:23:39', 'Hi-Way Inn', 'ggregond@xing.com'),
(1673, 6, '2020-07-28 08:33:24', 'Hilton Downtown', 'tskillaa@auda.org.au'),
(1674, 10, '2020-05-28 08:55:25', 'Hilton Downtown', 'fkleslbz@nationalgeographic.com'),
(1675, 7, '2019-08-20 02:23:57', 'Hilton Downtown', 'bruffellfr@yandex.ru'),
(1676, 1, '2019-02-05 01:05:34', 'Luxor', 'ztunnacliffec1@intel.com'),
(1677, 5, '2020-02-07 13:14:18', 'Hilton Downtown', 'bferberp3@feedburner.com'),
(1678, 1, '2020-06-23 10:42:05', 'Hotel deLuxe', 'akeepeeq@jigsy.com'),
(1679, 2, '2020-02-12 17:58:09', 'Hotel deLuxe', 'jreadwin49@redcross.org'),
(1680, 2, '2020-05-11 05:58:33', 'Candlewood Suites', 'cmirfieldqg@yellowpages.com'),
(1681, 4, '2020-07-10 03:23:29', 'Residence Inn', 'bhallbirddz@spotify.com'),
(1682, 9, '2019-06-07 22:54:08', 'The Paradise Inn', 'gmarcubk@technorati.com'),
(1683, 4, '2019-08-06 22:52:10', 'Luxor', 'rbillingtonm0@ibm.com'),
(1684, 2, '2020-08-04 05:41:02', 'Cute Mountains Inn', 'scaheyqu@about.com'),
(1685, 5, '2019-04-07 06:31:40', 'The Paradise Inn', 'oelsmoredl@spiegel.de'),
(1686, 6, '2020-06-26 07:06:15', 'Luxor', 'bandrusyakok@facebook.com'),
(1687, 8, '2020-02-14 19:12:48', 'Cute Mountains Inn', 'tphiferne@hhs.gov'),
(1688, 1, '2020-06-03 10:23:55', 'Hotel deLuxe', 'dcorstanng@smugmug.com'),
(1689, 6, '2019-06-23 11:16:18', 'Candlewood Suites', 'mshimmin9l@plala.or.jp'),
(1690, 10, '2019-09-01 22:28:21', 'Cute Mountains Inn', 'ngiacopellorf@elegantthemes.com'),
(1691, 6, '2019-10-03 16:23:34', 'Cute Mountains Inn', 'adowbekint@deviantart.com'),
(1692, 2, '2019-02-16 19:15:00', 'Cute Mountains Inn', 'jkadwallider5p@narod.ru'),
(1693, 1, '2019-10-05 01:29:25', 'Candlewood Suites', 'kmaclesebn@blogspot.com'),
(1694, 1, '2019-11-25 21:58:10', 'The Paradise Inn', 'lduell7r@wiley.com'),
(1695, 9, '2019-08-12 03:41:01', 'Candlewood Suites', 'gjenkinol@comsenz.com'),
(1696, 9, '2019-03-31 16:56:38', 'Sheraton Centre', 'ecaig3o@craigslist.org'),
(1697, 5, '2019-08-08 03:16:24', 'Luxor', 'darmingq@desdev.cn'),
(1698, 8, '2019-03-19 07:04:17', 'Hi-Way Inn', 'rmilellag1@slashdot.org'),
(1699, 6, '2020-03-21 10:46:44', 'Cute Mountains Inn', 'ssouthwood71@weebly.com'),
(1700, 2, '2020-04-01 16:59:20', 'Hilton Downtown', 'lbryer7@earthlink.net'),
(1701, 3, '2019-08-09 05:21:28', 'Hotel deLuxe', 'rkilleley3f@jimdo.com'),
(1702, 3, '2019-03-23 01:31:52', 'Cute Mountains Inn', 'zaistropej@ox.ac.uk'),
(1703, 8, '2020-05-30 13:30:45', 'Luxor', 'dquogancy@wsj.com'),
(1704, 8, '2019-07-26 18:48:20', 'Luxor', 'hdalgleish6m@theglobeandmail.com'),
(1705, 7, '2020-05-19 07:40:13', 'Candlewood Suites', 'gdublin2u@whitehouse.gov'),
(1706, 6, '2020-06-05 10:29:16', 'Hotel deLuxe', 'tsextyef@flavors.me'),
(1707, 7, '2019-07-06 00:00:03', 'The Paradise Inn', 'bpeasbylk@hugedomains.com'),
(1708, 3, '2019-11-17 10:24:26', 'Hampton Inn', 'ewakes9v@dedecms.com'),
(1709, 9, '2019-04-25 09:02:22', 'Hotel deLuxe', 'aklimmek13@umich.edu'),
(1710, 7, '2019-09-06 18:07:23', 'Residence Inn', 'chabbemaiw@yellowbook.com'),
(1711, 1, '2019-05-01 18:57:47', 'Hotel deLuxe', 'wjakesmh@squarespace.com'),
(1712, 10, '2019-12-29 21:45:17', 'Luxor', 'dgodilington4c@nationalgeographic.com'),
(1713, 6, '2019-08-28 10:24:27', 'Luxor', 'aobernep@google.cn'),
(1714, 5, '2019-02-15 02:05:35', 'The Paradise Inn', 'magastina75@wufoo.com'),
(1715, 1, '2019-06-24 06:11:10', 'Hilton Downtown', 'cparnabyno@cafepress.com'),
(1716, 10, '2020-03-22 00:28:39', 'Hotel deLuxe', 'klightollers3r@theglobeandmail.com'),
(1717, 2, '2019-04-22 13:08:36', 'Hi-Way Inn', 'fwreforddh@columbia.edu'),
(1718, 10, '2019-02-14 21:25:42', 'Candlewood Suites', 'enorwayon@nature.com'),
(1719, 10, '2019-12-01 10:51:26', 'Hi-Way Inn', 'elumsdaledf@w3.org'),
(1720, 8, '2020-05-30 04:47:11', 'Residence Inn', 'lpinkardnb@rediff.com'),
(1721, 3, '2019-07-17 07:58:18', 'The Paradise Inn', 'lgepson6j@sciencedirect.com'),
(1722, 4, '2020-01-16 03:52:42', 'Cute Mountains Inn', 'kshepeard4f@xing.com'),
(1723, 6, '2019-11-29 16:53:56', 'Candlewood Suites', 'alissamancs@mtv.com'),
(1724, 6, '2020-05-11 13:58:33', 'Luxor', 'acarayolla@jimdo.com'),
(1725, 4, '2019-03-04 18:36:01', 'The Paradise Inn', 'kmousbycz@seesaa.net'),
(1726, 5, '2020-02-27 12:14:33', 'Candlewood Suites', 'sbratcherhn@t-online.de'),
(1727, 4, '2020-02-10 09:59:30', 'Candlewood Suites', 'egobathy@businesswire.com'),
(1728, 10, '2020-04-17 01:33:46', 'Cute Mountains Inn', 'dbraghinina@bluehost.com'),
(1729, 6, '2020-08-04 23:57:52', 'Hi-Way Inn', 'jsnodden58@google.cn'),
(1730, 5, '2019-08-03 23:55:47', 'Candlewood Suites', 'cswatheridgemo@wordpress.org'),
(1731, 2, '2020-05-31 05:52:04', 'Candlewood Suites', 'mlarringtondx@imdb.com'),
(1732, 3, '2019-01-26 11:51:20', 'Sheraton Centre', 'dthistleton6t@buzzfeed.com'),
(1733, 3, '2020-01-07 20:03:34', 'Hi-Way Inn', 'jcheasmanh6@google.com.hk'),
(1734, 3, '2019-08-15 09:13:05', 'Luxor', 'rpreator3c@symantec.com'),
(1735, 9, '2020-02-04 03:58:42', 'Candlewood Suites', 'ccanons@sun.com'),
(1736, 2, '2020-05-18 23:49:20', 'Hilton Downtown', 'preddickfv@cdbaby.com'),
(1737, 3, '2019-03-19 14:49:17', 'Hi-Way Inn', 'dquogancy@wsj.com'),
(1738, 8, '2020-08-04 05:04:30', 'Hotel deLuxe', 'klibbis4n@cmu.edu'),
(1739, 7, '2019-12-05 00:00:34', 'Candlewood Suites', 'mcristofarik9@marriott.com'),
(1740, 5, '2019-12-07 22:55:11', 'Cute Mountains Inn', 'jscownms@sina.com.cn'),
(1741, 1, '2019-02-12 07:21:59', 'Hampton Inn', 'bsloweyir@shop-pro.jp'),
(1742, 10, '2019-08-30 22:18:26', 'Hi-Way Inn', 'athurbonnt@newsvine.com'),
(1743, 5, '2019-10-15 22:48:54', 'Cute Mountains Inn', 'bseear1@4shared.com'),
(1744, 1, '2019-07-11 09:24:23', 'Hilton Downtown', 'ntrenear2c@canalblog.com'),
(1745, 9, '2020-06-24 01:44:11', 'Residence Inn', 'derik66@samsung.com'),
(1746, 5, '2019-03-14 21:49:30', 'Hampton Inn', 'ncastagnen0@twitpic.com'),
(1747, 2, '2019-05-15 02:03:09', 'Luxor', 'rbandeykz@bloomberg.com'),
(1748, 1, '2019-02-01 21:59:34', 'The Paradise Inn', 'vpetrovicbo@t.co'),
(1749, 4, '2019-05-02 02:39:19', 'Hi-Way Inn', 'tdicarlir0@artisteer.com'),
(1750, 5, '2020-02-11 08:15:23', 'Hotel deLuxe', 'mdefriesq5@cocolog-nifty.com'),
(1751, 10, '2020-05-20 16:54:33', 'Residence Inn', 'kbellfieldbk@oracle.com'),
(1752, 10, '2019-09-20 01:56:22', 'Luxor', 'bocannovane34@mozilla.org'),
(1753, 7, '2020-05-19 20:45:41', 'The Paradise Inn', 'nslottf9@delicious.com'),
(1754, 1, '2019-04-09 10:38:45', 'The Paradise Inn', 'ddorricottlv@gravatar.com'),
(1755, 6, '2019-02-23 18:13:35', 'Hilton Downtown', 'gbreukelman8i@usa.gov'),
(1756, 6, '2019-10-09 15:18:53', 'Cute Mountains Inn', 'gtowsonai@ca.gov'),
(1757, 1, '2019-02-12 18:31:18', 'Candlewood Suites', 'bvaskovfq@pagesperso-orange.fr'),
(1758, 2, '2020-04-09 13:12:17', 'Cute Mountains Inn', 'cditchett4q@jiathis.com'),
(1759, 8, '2019-02-04 21:48:46', 'Cute Mountains Inn', 'hgollardaf@bbc.co.uk'),
(1760, 5, '2020-08-05 05:49:46', 'Hotel deLuxe', 'cfrayneny@buzzfeed.com'),
(1761, 3, '2019-10-07 06:56:21', 'Residence Inn', 'gskillanders7x@eepurl.com'),
(1762, 6, '2019-04-14 09:56:52', 'Hotel deLuxe', 'iswiffan9q@soundcloud.com'),
(1763, 5, '2019-04-23 14:05:50', 'Cute Mountains Inn', 'bocannovane34@mozilla.org'),
(1764, 2, '2019-02-06 15:31:28', 'Residence Inn', 'ltrimmillpk@boston.com'),
(1765, 7, '2020-01-21 20:21:39', 'Hilton Downtown', 'aosheerin3g@netlog.com'),
(1766, 2, '2020-08-08 15:41:34', 'Hilton Downtown', 'voxxfj@1und1.de'),
(1767, 4, '2019-03-08 16:25:46', 'Cute Mountains Inn', 'aedelerc0@yale.edu'),
(1768, 7, '2020-07-22 13:31:10', 'Hi-Way Inn', 'lsowersbyb1@netscape.com'),
(1769, 10, '2020-06-21 03:36:30', 'Hi-Way Inn', 'slaxtonmf@gnu.org'),
(1770, 10, '2020-05-16 09:37:18', 'Residence Inn', 'jnorthernmt@google.it'),
(1771, 4, '2019-07-30 00:11:32', 'Luxor', 'hfriedh1@jigsy.com'),
(1772, 10, '2019-08-07 08:05:50', 'Luxor', 'sdoldonky@163.com'),
(1773, 2, '2019-08-12 18:12:00', 'Hampton Inn', 'smoldenrr@pbs.org'),
(1774, 10, '2019-12-23 05:26:56', 'Cute Mountains Inn', 'btiptaftrc@com.com'),
(1775, 5, '2019-02-17 19:58:31', 'Hampton Inn', 'mjanous5u@linkedin.com'),
(1776, 4, '2020-04-06 06:28:07', 'Hotel deLuxe', 'natchly5w@bluehost.com'),
(1777, 10, '2019-07-16 00:31:52', 'The Paradise Inn', 'klemarchant9z@gravatar.com'),
(1778, 4, '2019-09-26 08:11:13', 'Residence Inn', 'rmoraaj@ibm.com'),
(1779, 8, '2019-12-06 11:26:28', 'Hi-Way Inn', 'mgabalan6@ft.com'),
(1780, 9, '2019-05-17 06:13:09', 'Hotel deLuxe', 'hblais1o@google.ru'),
(1781, 7, '2019-08-19 02:56:19', 'Hotel deLuxe', 'tsextyef@flavors.me'),
(1782, 10, '2019-03-10 00:12:47', 'Hi-Way Inn', 'nsealoveka@usa.gov'),
(1783, 1, '2019-08-06 10:57:08', 'Hilton Downtown', 'scajkler4z@taobao.com'),
(1784, 8, '2020-06-10 17:54:15', 'Hotel deLuxe', 'drainsburyj7@quantcast.com'),
(1785, 4, '2019-05-03 07:08:03', 'Hilton Downtown', 'tpollicote41@bizjournals.com'),
(1786, 8, '2019-10-16 23:27:13', 'Cute Mountains Inn', 'dgamil8m@e-recht24.de'),
(1787, 8, '2020-04-30 13:26:54', 'Candlewood Suites', 'spenningsj5@wufoo.com'),
(1788, 3, '2019-05-02 23:20:26', 'Sheraton Centre', 'rswynfenhi@xrea.com'),
(1789, 3, '2019-08-09 02:28:10', 'Cute Mountains Inn', 'swindress5z@answers.com'),
(1790, 2, '2019-04-27 20:07:17', 'Luxor', 'glawteyj8@people.com.cn'),
(1791, 5, '2019-03-06 02:18:24', 'The Paradise Inn', 'ahaughianji@dedecms.com'),
(1792, 1, '2019-07-06 13:00:50', 'Luxor', 'scatherine5j@redcross.org'),
(1793, 7, '2019-07-11 06:15:32', 'Hotel deLuxe', 'tfrostickbm@merriam-webster.com'),
(1794, 6, '2019-10-06 00:24:43', 'Hilton Downtown', 'tsteanson3t@apple.com'),
(1795, 2, '2019-06-14 01:49:19', 'Residence Inn', 'tlevisonkf@geocities.jp'),
(1796, 4, '2020-03-04 13:33:57', 'Cute Mountains Inn', 'emullallyq1@msu.edu'),
(1797, 1, '2019-04-05 10:06:50', 'Hi-Way Inn', 'areekeni5@sciencedirect.com'),
(1798, 8, '2020-07-08 20:19:18', 'Luxor', 'areekeni5@sciencedirect.com'),
(1799, 5, '2019-06-25 14:04:04', 'Hotel deLuxe', 'earrundaleb0@narod.ru'),
(1800, 8, '2020-04-28 03:59:27', 'Hotel deLuxe', 'mzuckeree@webs.com'),
(1801, 8, '2019-06-03 10:33:08', 'Residence Inn', 'hpinnijaren@feedburner.com'),
(1802, 9, '2019-04-08 12:43:38', 'Hotel deLuxe', 'hcroneg4@nps.gov'),
(1803, 4, '2020-07-09 00:52:05', 'Hotel deLuxe', 'igarnulq3@goo.gl'),
(1804, 4, '2020-03-30 10:27:38', 'Hotel deLuxe', 'dnelesfs@disqus.com'),
(1805, 9, '2020-01-13 08:24:28', 'Candlewood Suites', 'dloraino7@issuu.com'),
(1806, 9, '2019-03-11 01:04:12', 'Hilton Downtown', 'bglyssanne2v@wikipedia.org'),
(1807, 7, '2020-06-12 02:43:27', 'Cute Mountains Inn', 'bmorfordat@google.de'),
(1808, 7, '2019-11-04 04:19:28', 'Cute Mountains Inn', 'kbragge59@foxnews.com'),
(1809, 9, '2020-03-30 01:25:54', 'Residence Inn', 'ahazeuplq@weebly.com'),
(1810, 3, '2020-01-27 06:44:02', 'Hi-Way Inn', 'nbrimicombed@flickr.com'),
(1811, 8, '2019-06-06 13:09:59', 'Sheraton Centre', 'rrochil@canalblog.com'),
(1812, 4, '2019-08-30 07:17:18', 'Hilton Downtown', 'ckittemanhg@printfriendly.com'),
(1813, 4, '2020-04-25 10:35:10', 'Hotel deLuxe', 'athurbonnt@newsvine.com'),
(1814, 2, '2019-01-28 23:55:36', 'Candlewood Suites', 'mhapkec0@deliciousdays.com'),
(1815, 6, '2019-11-15 22:11:49', 'The Paradise Inn', 'jpernell4f@skyrock.com'),
(1816, 4, '2019-10-11 03:30:49', 'Residence Inn', 'nbaumanbh@imdb.com'),
(1817, 4, '2019-05-03 00:53:43', 'Sheraton Centre', 'feyerg@behance.net'),
(1818, 4, '2020-01-05 22:49:21', 'Hotel deLuxe', 'cfishce@usatoday.com'),
(1819, 1, '2019-12-15 08:08:40', 'Hi-Way Inn', 'jdowsett4@cpanel.net'),
(1820, 6, '2019-07-15 04:14:06', 'The Paradise Inn', 'dgurg3l@who.int'),
(1821, 10, '2020-06-26 09:23:45', 'Hi-Way Inn', 'jduddinly@chicagotribune.com'),
(1822, 7, '2020-02-02 03:34:40', 'Residence Inn', 'alotterington1w@mit.edu'),
(1823, 6, '2020-05-08 16:51:59', 'The Paradise Inn', 'nkrookaq@ed.gov'),
(1824, 2, '2019-02-11 06:56:42', 'Luxor', 'jpendrichaz@blogspot.com'),
(1825, 8, '2020-04-23 10:21:28', 'Sheraton Centre', 'fdonnell3i@go.com'),
(1826, 9, '2019-11-22 21:38:34', 'Hotel deLuxe', 'tmammattn5@redcross.org'),
(1827, 8, '2019-08-04 12:39:23', 'Hampton Inn', 'pgraysmark5b@japanpost.jp'),
(1828, 5, '2019-04-30 07:45:03', 'Hampton Inn', 'tcliffordm5@phoca.cz'),
(1829, 7, '2020-02-05 11:46:48', 'The Paradise Inn', 'rsieghartey@cyberchimps.com'),
(1830, 2, '2020-04-02 15:23:57', 'Sheraton Centre', 'wsirkett38@drupal.org'),
(1831, 8, '2019-01-08 22:19:34', 'Residence Inn', 'cbarbierbd@examiner.com'),
(1832, 2, '2019-12-16 01:46:26', 'Residence Inn', 'mdabner2t@dedecms.com'),
(1833, 10, '2019-11-22 14:14:04', 'Sheraton Centre', 'lmcguckinoj@drupal.org'),
(1834, 1, '2020-02-09 18:48:02', 'Sheraton Centre', 'amckeefrycu@ycombinator.com'),
(1835, 2, '2020-02-10 00:47:58', 'Luxor', 'ewakes9v@dedecms.com'),
(1836, 2, '2020-06-15 18:01:10', 'Hampton Inn', 'cdinsalekt@myspace.com'),
(1837, 2, '2019-12-22 13:08:25', 'Hi-Way Inn', 'flairdmo@google.com.au'),
(1838, 1, '2020-02-15 03:59:31', 'Luxor', 'ppuvia24@salon.com'),
(1839, 1, '2020-04-01 17:19:56', 'Residence Inn', 'gmathisfy@spiegel.de'),
(1840, 8, '2020-01-23 14:43:13', 'The Paradise Inn', 'dthistleton6t@buzzfeed.com'),
(1841, 5, '2019-10-08 22:06:15', 'Hampton Inn', 'dcorstanng@smugmug.com'),
(1842, 2, '2020-08-06 21:37:49', 'The Paradise Inn', 'djoseferhd@amazon.com'),
(1843, 5, '2020-03-26 02:56:15', 'Hi-Way Inn', 'ptophamni@networksolutions.com'),
(1844, 5, '2019-10-05 13:17:18', 'Sheraton Centre', 'gaugustin1s@economist.com'),
(1845, 2, '2020-06-20 04:19:50', 'Hilton Downtown', 'wmatfieldfu@shop-pro.jp'),
(1846, 5, '2020-06-17 23:51:54', 'Luxor', 'kpredohlop@cbc.ca'),
(1847, 4, '2020-04-03 02:25:25', 'Hilton Downtown', 'noliveto7p@harvard.edu'),
(1848, 3, '2020-05-06 14:42:07', 'Hampton Inn', 'rgrimme1s@amazonaws.com'),
(1849, 10, '2020-04-17 12:44:54', 'Hilton Downtown', 'vdumbltonnc@nymag.com'),
(1850, 8, '2020-07-07 17:39:58', 'Candlewood Suites', 'lpinkardnb@rediff.com'),
(1851, 3, '2019-04-19 03:35:32', 'Residence Inn', 'tlockheadqn@earthlink.net'),
(1852, 5, '2019-07-19 06:17:49', 'Hi-Way Inn', 'bmccreery47@cloudflare.com'),
(1853, 10, '2020-04-10 13:44:10', 'Residence Inn', 'ostanmerny@themeforest.net'),
(1854, 5, '2019-01-15 16:43:15', 'Hilton Downtown', 'lventoned@over-blog.com'),
(1855, 5, '2019-02-27 13:14:27', 'Luxor', 'bseear1@4shared.com'),
(1856, 2, '2019-09-06 03:14:25', 'The Paradise Inn', 'kcolvineri@indiatimes.com'),
(1857, 7, '2020-06-09 23:11:47', 'Sheraton Centre', 'beustonl5@ycombinator.com'),
(1858, 5, '2019-08-10 17:47:21', 'Hilton Downtown', 'mdefriesq5@cocolog-nifty.com'),
(1859, 3, '2020-02-01 00:41:05', 'Hilton Downtown', 'dianitti4s@ibm.com'),
(1860, 2, '2019-09-30 01:45:45', 'Sheraton Centre', 'cingray44@virginia.edu'),
(1861, 9, '2019-10-18 13:04:38', 'Candlewood Suites', 'hquartermaink9@fotki.com'),
(1862, 5, '2019-02-26 08:40:01', 'Hilton Downtown', 'rrochil@canalblog.com'),
(1863, 7, '2020-01-03 19:26:08', 'Luxor', 'maitken18@ed.gov'),
(1864, 2, '2020-01-28 00:24:04', 'Luxor', 'hziehmsnz@mashable.com'),
(1865, 3, '2020-06-26 11:06:50', 'Candlewood Suites', 'strigwell38@google.com.hk'),
(1866, 3, '2019-08-18 18:12:19', 'Hi-Way Inn', 'ehelleckasoi@usatoday.com'),
(1867, 1, '2020-05-15 03:03:09', 'Hi-Way Inn', 'caymericho3@google.com.au'),
(1868, 9, '2020-01-18 16:25:43', 'Hilton Downtown', 'dloraino7@issuu.com'),
(1869, 10, '2019-02-20 05:31:03', 'Candlewood Suites', 'xearwaker4r@businessweek.com'),
(1870, 9, '2019-01-24 16:39:11', 'Luxor', 'pwakeley2x@tuttocitta.it'),
(1871, 10, '2019-12-01 09:44:11', 'Hampton Inn', 'emcveighf4@bloglovin.com'),
(1872, 1, '2020-01-12 13:03:42', 'Residence Inn', 'dmulloch4u@umn.edu'),
(1873, 1, '2019-10-01 20:34:30', 'Luxor', 'ebarbierp1@ameblo.jp'),
(1874, 10, '2019-11-19 10:18:47', 'The Paradise Inn', 'tkeffordpc@eventbrite.com'),
(1875, 3, '2019-12-03 10:11:51', 'Hilton Downtown', 'nmolanqg@uol.com.br'),
(1876, 3, '2020-03-22 16:30:36', 'Hotel deLuxe', 'mbevensfo@unc.edu'),
(1877, 1, '2020-06-05 15:31:48', 'Candlewood Suites', 'gloadsmanq4@ucoz.ru'),
(1878, 7, '2020-06-23 03:42:12', 'Hampton Inn', 'wrickesies4x@yandex.ru'),
(1879, 10, '2019-10-05 05:48:00', 'Luxor', 'fkleslbz@nationalgeographic.com'),
(1880, 7, '2020-02-11 00:07:13', 'Luxor', 'dalenin42@sakura.ne.jp'),
(1881, 7, '2019-06-14 08:50:55', 'Luxor', 'odutnelljm@liveinternet.ru'),
(1882, 10, '2019-07-31 00:43:42', 'Hotel deLuxe', 'dbeedelleu@go.com'),
(1883, 7, '2020-04-17 16:02:22', 'Hi-Way Inn', 'cfiller61@wired.com'),
(1884, 8, '2019-04-25 22:37:21', 'The Paradise Inn', 'sbirkheadm@sakura.ne.jp'),
(1885, 10, '2020-05-21 18:31:01', 'Hotel deLuxe', 'igoaks9w@hexun.com'),
(1886, 10, '2019-06-30 00:24:45', 'Cute Mountains Inn', 'isallnowq6@imageshack.us'),
(1887, 4, '2019-11-06 10:45:34', 'Sheraton Centre', 'hsevingn@elpais.com'),
(1888, 5, '2019-03-25 07:48:58', 'Sheraton Centre', 'mbrendei@mysql.com'),
(1889, 7, '2019-06-04 23:22:25', 'The Paradise Inn', 'vogarags@globo.com'),
(1890, 7, '2020-05-24 04:09:09', 'Hi-Way Inn', 'tcopemanmq@nyu.edu'),
(1891, 9, '2020-04-30 23:58:21', 'Sheraton Centre', 'pgraysmark5b@japanpost.jp'),
(1892, 10, '2019-08-14 13:28:58', 'Candlewood Suites', 'smaple7w@blogtalkradio.com'),
(1893, 4, '2019-08-09 21:50:06', 'The Paradise Inn', 'mlarringtondx@imdb.com'),
(1894, 4, '2019-01-08 02:29:12', 'Hi-Way Inn', 'dvasilmanovh4@indiegogo.com'),
(1895, 3, '2020-06-24 06:38:51', 'Hampton Inn', 'jbutterfill6c@mail.ru'),
(1896, 10, '2020-05-30 10:50:45', 'The Paradise Inn', 'rgrestyqz@vk.com'),
(1897, 7, '2020-06-09 05:38:46', 'Hi-Way Inn', 'hwhorlowrd@mashable.com'),
(1898, 8, '2019-04-24 17:27:45', 'Sheraton Centre', 'mramalho9u@squarespace.com'),
(1899, 10, '2020-01-23 04:28:06', 'Hilton Downtown', 'aabilowitzak@last.fm'),
(1900, 6, '2019-09-25 03:15:37', 'Hotel deLuxe', 'abrimblecomben3@pinterest.com'),
(1901, 8, '2019-01-21 09:46:43', 'Sheraton Centre', 'elumsdaledf@w3.org'),
(1902, 3, '2020-02-01 07:18:17', 'Candlewood Suites', 'lrabbagej0@goo.ne.jp'),
(1903, 8, '2019-07-09 08:20:48', 'Candlewood Suites', 'cdobrovolski4z@eventbrite.com'),
(1904, 9, '2020-03-10 10:25:55', 'Hampton Inn', 'ldibollj3@yale.edu'),
(1905, 2, '2019-02-26 06:44:52', 'Hampton Inn', 'ggravellsgz@photobucket.com'),
(1906, 1, '2020-07-31 15:22:34', 'Luxor', 'hcroneg4@nps.gov'),
(1907, 6, '2019-12-21 06:22:47', 'Hi-Way Inn', 'gpipkinfe@nytimes.com'),
(1908, 6, '2020-08-13 18:42:21', 'Hotel deLuxe', 'bbonallickcl@cnet.com'),
(1909, 9, '2020-02-05 17:46:31', 'The Paradise Inn', 'aprivettle@pbs.org'),
(1910, 3, '2020-07-13 13:02:50', 'Residence Inn', 'dallison76@dedecms.com'),
(1911, 2, '2019-04-15 12:44:23', 'Hotel deLuxe', 'smithanel@constantcontact.com'),
(1912, 3, '2019-06-04 19:48:08', 'Cute Mountains Inn', 'cmcauliffear@xinhuanet.com'),
(1913, 9, '2019-11-10 05:02:27', 'Candlewood Suites', 'cguillond4p@gmpg.org'),
(1914, 7, '2019-07-18 09:44:11', 'Candlewood Suites', 'aprivettle@pbs.org'),
(1915, 7, '2020-05-28 12:18:50', 'Hampton Inn', 'hmacritchieeq@angelfire.com'),
(1916, 1, '2020-07-10 09:01:16', 'Hi-Way Inn', 'ahaughianji@dedecms.com'),
(1917, 2, '2019-11-22 00:43:02', 'Cute Mountains Inn', 'jwestcaree@utexas.edu'),
(1918, 3, '2020-04-19 22:19:24', 'Hilton Downtown', 'csoltanfx@cnn.com'),
(1919, 10, '2019-12-25 08:41:54', 'Hilton Downtown', 'nrobotthambq@fda.gov'),
(1920, 4, '2020-02-15 05:28:45', 'Candlewood Suites', 'kdalinderqn@hubpages.com'),
(1921, 4, '2019-07-21 06:16:42', 'Hi-Way Inn', 'seisoldk2@dagondesign.com'),
(1922, 8, '2019-08-23 06:37:07', 'Hotel deLuxe', 'afryman20@naver.com'),
(1923, 5, '2020-01-02 22:14:55', 'Hilton Downtown', 'amaulindi@surveymonkey.com'),
(1924, 4, '2019-04-25 20:21:12', 'Luxor', 'ewilcocksbx@elegantthemes.com'),
(1925, 8, '2019-07-29 02:37:58', 'Hi-Way Inn', 'zfolkerd5g@nydailynews.com'),
(1926, 2, '2019-07-23 03:03:58', 'Hi-Way Inn', 'daers1@craigslist.org'),
(1927, 6, '2020-01-02 06:19:49', 'Sheraton Centre', 'jashdownqw@merriam-webster.com'),
(1928, 3, '2019-02-16 23:27:50', 'Hotel deLuxe', 'kshawl21@nifty.com'),
(1929, 8, '2019-03-25 20:10:16', 'Hi-Way Inn', 'asadlermf@xing.com'),
(1930, 8, '2019-09-17 16:02:21', 'Hampton Inn', 'gdahmel66@boston.com'),
(1931, 10, '2019-08-02 18:19:04', 'The Paradise Inn', 'mslowgroveol@microsoft.com'),
(1932, 10, '2019-12-26 05:50:31', 'Residence Inn', 'ncrouchf3@ftc.gov'),
(1933, 1, '2019-01-26 22:41:26', 'The Paradise Inn', 'alockyeare6@businessinsider.com'),
(1934, 10, '2020-03-30 08:51:17', 'Residence Inn', 'kdebenedittiqx@blogger.com'),
(1935, 7, '2020-04-04 01:34:32', 'Hampton Inn', 'rlansdownlb@tinyurl.com'),
(1936, 10, '2019-08-02 06:56:38', 'The Paradise Inn', 'twakerhl@vk.com'),
(1937, 5, '2020-06-12 04:38:46', 'Hampton Inn', 'mmccaughan7t@sfgate.com'),
(1938, 9, '2020-07-29 16:51:34', 'Luxor', 'hchristopher2j@yale.edu'),
(1939, 5, '2019-12-24 19:39:32', 'Sheraton Centre', 'crubinj1@skyrock.com'),
(1940, 7, '2019-08-17 00:59:54', 'Sheraton Centre', 'bzielinskio4@about.me'),
(1941, 10, '2020-01-09 11:18:29', 'The Paradise Inn', 'achingeh7@cbslocal.com'),
(1942, 6, '2020-07-06 07:57:07', 'Candlewood Suites', 'mmcdonnelli6@virginia.edu'),
(1943, 5, '2019-02-22 15:49:33', 'Sheraton Centre', 'lminerojo@nifty.com'),
(1944, 2, '2020-05-27 21:14:08', 'Cute Mountains Inn', 'agaskinshk@jiathis.com'),
(1945, 9, '2019-05-27 14:43:15', 'Hilton Downtown', 'etween61@g.co'),
(1946, 5, '2020-05-06 16:41:43', 'Candlewood Suites', 'dephgravebu@psu.edu'),
(1947, 3, '2019-05-28 16:28:56', 'Sheraton Centre', 'sansilld1@mapy.cz'),
(1948, 10, '2020-04-16 14:51:52', 'Candlewood Suites', 'jlafondk2@huffingtonpost.com'),
(1949, 2, '2020-04-14 23:51:27', 'Candlewood Suites', 'tmoverley2c@geocities.com'),
(1950, 10, '2020-07-15 14:02:52', 'Hi-Way Inn', 'fblackboro7i@ucoz.com'),
(1951, 10, '2019-05-17 04:21:30', 'The Paradise Inn', 'rrozeth0@ed.gov'),
(1952, 8, '2020-04-20 19:15:18', 'Sheraton Centre', 'scajkler4z@taobao.com'),
(1953, 4, '2019-10-20 17:21:19', 'Candlewood Suites', 'alewendono8@princeton.edu'),
(1954, 8, '2019-01-14 14:39:18', 'Hotel deLuxe', 'muchn@chicagotribune.com'),
(1955, 4, '2019-01-17 19:49:02', 'The Paradise Inn', 'tlevisonkf@geocities.jp'),
(1956, 2, '2020-03-20 11:24:10', 'Residence Inn', 'fpeepall14@gizmodo.com'),
(1957, 6, '2019-05-05 12:14:22', 'Candlewood Suites', 'gnafzigerg2@mashable.com'),
(1958, 10, '2020-04-29 15:57:04', 'Hampton Inn', 'mmatteahw@hibu.com'),
(1959, 3, '2019-02-21 04:50:54', 'Luxor', 'gfawloro@chicagotribune.com'),
(1960, 7, '2020-04-23 10:22:24', 'Residence Inn', 'tmonnoyerdg@furl.net'),
(1961, 8, '2020-06-15 20:14:16', 'Sheraton Centre', 'evittelan@weebly.com'),
(1962, 1, '2020-02-21 22:58:20', 'Candlewood Suites', 'hhoward62@wired.com'),
(1963, 9, '2019-12-22 14:30:53', 'Hilton Downtown', 'asilverthornec8@usda.gov'),
(1964, 1, '2019-03-13 08:46:27', 'Cute Mountains Inn', 'dgentzsch9a@amazonaws.com'),
(1965, 6, '2019-06-15 09:04:44', 'Luxor', 'westcourte1@parallels.com'),
(1966, 4, '2019-07-05 04:52:12', 'Residence Inn', 'sroland9n@acquirethisname.com'),
(1967, 3, '2019-12-29 15:43:23', 'Residence Inn', 'npirdyek@cdc.gov'),
(1968, 3, '2020-04-09 14:12:56', 'Luxor', 'bthreadkello3@trellian.com'),
(1969, 3, '2019-04-26 13:16:38', 'Cute Mountains Inn', 'igarnulq3@goo.gl'),
(1970, 10, '2020-01-07 17:27:12', 'The Paradise Inn', 'jspowage85@narod.ru'),
(1971, 4, '2019-05-18 13:39:14', 'Luxor', 'hripper74@blogspot.com'),
(1972, 9, '2019-05-18 16:41:04', 'Hampton Inn', 'gplail3s@de.vu'),
(1973, 10, '2019-03-05 16:52:40', 'Cute Mountains Inn', 'mchurchousefp@redcross.org'),
(1974, 3, '2019-12-13 16:51:27', 'Hotel deLuxe', 'fjelfrp@gravatar.com'),
(1975, 5, '2020-03-03 11:02:25', 'Residence Inn', 'seisoldk2@dagondesign.com'),
(1976, 7, '2019-02-01 09:38:24', 'Residence Inn', 'dephgravebu@psu.edu'),
(1977, 8, '2019-09-21 00:14:34', 'Hampton Inn', 'jdouglissd0@twitter.com'),
(1978, 2, '2019-06-08 02:18:46', 'Hampton Inn', 'aloader6f@archive.org'),
(1979, 10, '2019-05-04 10:14:15', 'The Paradise Inn', 'kfronks7s@drupal.org'),
(1980, 2, '2019-09-03 18:58:28', 'Hotel deLuxe', 'mcastellscc@vk.com'),
(1981, 5, '2019-09-15 07:39:35', 'Hampton Inn', 'gdahmel66@boston.com'),
(1982, 2, '2020-04-21 06:24:01', 'Sheraton Centre', 'aobernep@google.cn'),
(1983, 6, '2019-07-25 01:11:45', 'Hi-Way Inn', 'kwalling22@ucoz.ru'),
(1984, 1, '2019-10-07 10:00:45', 'Cute Mountains Inn', 'egobathy@businesswire.com'),
(1985, 8, '2020-08-02 22:09:16', 'The Paradise Inn', 'mgarnson9g@freewebs.com'),
(1986, 5, '2020-01-09 05:45:05', 'Hotel deLuxe', 'nscutchingmj@addtoany.com'),
(1987, 5, '2019-07-01 05:07:13', 'Hampton Inn', 'jdurantin@census.gov'),
(1988, 5, '2019-11-24 11:36:33', 'Sheraton Centre', 'lrabbagej0@goo.ne.jp'),
(1989, 10, '2020-01-30 02:59:56', 'Hi-Way Inn', 'mdecarlok3@barnesandnoble.com'),
(1990, 1, '2020-03-23 21:58:50', 'Hilton Downtown', 'tmullearybn@blogs.com'),
(1991, 3, '2020-06-11 19:29:17', 'Hilton Downtown', 'readdycn@cmu.edu'),
(1992, 10, '2019-09-08 08:11:13', 'The Paradise Inn', 'sedelheid9p@google.nl'),
(1993, 4, '2019-02-11 13:54:16', 'Residence Inn', 'bwikeyah@linkedin.com'),
(1994, 8, '2020-05-18 18:38:05', 'Sheraton Centre', 'jbattellejf@arstechnica.com'),
(1995, 4, '2020-05-13 07:10:34', 'Cute Mountains Inn', 'glawteyj8@people.com.cn'),
(1996, 2, '2019-08-20 10:12:34', 'Hampton Inn', 'mtettherpl@prnewswire.com'),
(1997, 8, '2019-06-13 23:40:33', 'Luxor', 'klaversj9@parallels.com'),
(1998, 2, '2019-12-23 19:59:56', 'Residence Inn', 'ksenchenkopi@nhs.uk'),
(1999, 7, '2019-11-17 12:57:49', 'Cute Mountains Inn', 'pdumpletonoh@goodreads.com'),
(2000, 3, '2019-05-24 01:48:39', 'The Paradise Inn', 'pwildgoose8e@storify.com');

-- --------------------------------------------------------

--
-- Table structure for table `room`
--

CREATE TABLE `room` (
  `property_name` varchar(100) NOT NULL,
  `room_num` int(10) UNSIGNED NOT NULL,
  `room_type` varchar(20) NOT NULL,
  `_description` varchar(300) NOT NULL,
  `capacity` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `room`
--

INSERT INTO `room` (`property_name`, `room_num`, `room_type`, `_description`, `capacity`) VALUES
('Candlewood Suites', 2, 'King', 'Awesome room with great views', 1),
('Candlewood Suites', 19, 'King', 'Awesome room with great views', 5),
('Candlewood Suites', 24, 'King', 'Awesome room with great views', 4),
('Candlewood Suites', 48, 'Double', 'This is a great room for two people', 3),
('Candlewood Suites', 53, 'Suite', 'The best we have', 8),
('Candlewood Suites', 80, 'King', 'Awesome room with great views', 2),
('Candlewood Suites', 82, 'Queen', 'Luxurious queen bed comes with breakfast', 6),
('Candlewood Suites', 86, 'Double', 'This is a great room for two people', 4),
('Candlewood Suites', 102, 'Suite', 'The best we have', 7),
('Candlewood Suites', 105, 'Double', 'This is a great room for two people', 7),
('Candlewood Suites', 106, 'Double', 'This is a great room for two people', 7),
('Candlewood Suites', 108, 'Suite', 'The best we have', 10),
('Candlewood Suites', 110, 'Suite', 'The best we have', 10),
('Candlewood Suites', 114, 'Suite', 'The best we have', 3),
('Candlewood Suites', 133, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Candlewood Suites', 134, 'Suite', 'The best we have', 10),
('Candlewood Suites', 135, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Candlewood Suites', 155, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Candlewood Suites', 157, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Candlewood Suites', 158, 'Suite', 'The best we have', 8),
('Candlewood Suites', 174, 'Double', 'This is a great room for two people', 8),
('Candlewood Suites', 176, 'Double', 'This is a great room for two people', 8),
('Candlewood Suites', 178, 'Suite', 'The best we have', 6),
('Candlewood Suites', 180, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Candlewood Suites', 207, 'Suite', 'The best we have', 3),
('Candlewood Suites', 221, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Candlewood Suites', 222, 'Queen', 'Luxurious queen bed comes with breakfast', 9),
('Candlewood Suites', 223, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Candlewood Suites', 234, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Candlewood Suites', 248, 'Double', 'This is a great room for two people', 8),
('Candlewood Suites', 260, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Candlewood Suites', 276, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('Candlewood Suites', 296, 'King', 'Awesome room with great views', 2),
('Candlewood Suites', 300, 'King', 'Awesome room with great views', 2),
('Cute Mountains Inn', 4, 'King', 'Awesome room with great views', 8),
('Cute Mountains Inn', 9, 'Double', 'This is a great room for two people', 3),
('Cute Mountains Inn', 16, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Cute Mountains Inn', 29, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Cute Mountains Inn', 40, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Cute Mountains Inn', 49, 'Double', 'This is a great room for two people', 6),
('Cute Mountains Inn', 63, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Cute Mountains Inn', 69, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Cute Mountains Inn', 77, 'Double', 'This is a great room for two people', 3),
('Cute Mountains Inn', 84, 'King', 'Awesome room with great views', 8),
('Cute Mountains Inn', 97, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Cute Mountains Inn', 99, 'Queen', 'Luxurious queen bed comes with breakfast', 8),
('Cute Mountains Inn', 109, 'Double', 'This is a great room for two people', 1),
('Cute Mountains Inn', 111, 'Queen', 'Luxurious queen bed comes with breakfast', 3),
('Cute Mountains Inn', 119, 'Double', 'This is a great room for two people', 3),
('Cute Mountains Inn', 122, 'King', 'Awesome room with great views', 2),
('Cute Mountains Inn', 123, 'Suite', 'The best we have', 2),
('Cute Mountains Inn', 127, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Cute Mountains Inn', 130, 'Suite', 'The best we have', 2),
('Cute Mountains Inn', 136, 'Queen', 'Luxurious queen bed comes with breakfast', 6),
('Cute Mountains Inn', 146, 'Suite', 'The best we have', 3),
('Cute Mountains Inn', 154, 'Double', 'This is a great room for two people', 7),
('Cute Mountains Inn', 161, 'Suite', 'The best we have', 10),
('Cute Mountains Inn', 164, 'Suite', 'The best we have', 4),
('Cute Mountains Inn', 170, 'King', 'Awesome room with great views', 3),
('Cute Mountains Inn', 201, 'Suite', 'The best we have', 2),
('Cute Mountains Inn', 202, 'Suite', 'The best we have', 9),
('Cute Mountains Inn', 215, 'Suite', 'The best we have', 3),
('Cute Mountains Inn', 218, 'King', 'Awesome room with great views', 5),
('Cute Mountains Inn', 229, 'Suite', 'The best we have', 5),
('Cute Mountains Inn', 253, 'Suite', 'The best we have', 7),
('Cute Mountains Inn', 265, 'King', 'Awesome room with great views', 8),
('Cute Mountains Inn', 273, 'Suite', 'The best we have', 6),
('Cute Mountains Inn', 277, 'Double', 'This is a great room for two people', 2),
('Cute Mountains Inn', 280, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Cute Mountains Inn', 281, 'Double', 'This is a great room for two people', 1),
('Cute Mountains Inn', 292, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Cute Mountains Inn', 298, 'Double', 'This is a great room for two people', 4),
('Cute Mountains Inn', 299, 'King', 'Awesome room with great views', 2),
('Hampton Inn', 18, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('Hampton Inn', 20, 'King', 'Awesome room with great views', 3),
('Hampton Inn', 28, 'Suite', 'The best we have', 7),
('Hampton Inn', 37, 'Suite', 'The best we have', 1),
('Hampton Inn', 38, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('Hampton Inn', 43, 'King', 'Awesome room with great views', 6),
('Hampton Inn', 44, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('Hampton Inn', 56, 'King', 'Awesome room with great views', 10),
('Hampton Inn', 57, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Hampton Inn', 61, 'Suite', 'The best we have', 10),
('Hampton Inn', 66, 'Suite', 'The best we have', 10),
('Hampton Inn', 68, 'Double', 'This is a great room for two people', 9),
('Hampton Inn', 71, 'Suite', 'The best we have', 7),
('Hampton Inn', 78, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Hampton Inn', 100, 'Suite', 'The best we have', 5),
('Hampton Inn', 101, 'Double', 'This is a great room for two people', 5),
('Hampton Inn', 104, 'Double', 'This is a great room for two people', 5),
('Hampton Inn', 115, 'Suite', 'The best we have', 4),
('Hampton Inn', 124, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Hampton Inn', 129, 'King', 'Awesome room with great views', 4),
('Hampton Inn', 142, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Hampton Inn', 144, 'Double', 'This is a great room for two people', 4),
('Hampton Inn', 147, 'Double', 'This is a great room for two people', 4),
('Hampton Inn', 151, 'King', 'Awesome room with great views', 4),
('Hampton Inn', 168, 'Queen', 'Luxurious queen bed comes with breakfast', 9),
('Hampton Inn', 185, 'Suite', 'The best we have', 5),
('Hampton Inn', 191, 'Suite', 'The best we have', 7),
('Hampton Inn', 192, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Hampton Inn', 195, 'Queen', 'Luxurious queen bed comes with breakfast', 6),
('Hampton Inn', 252, 'Suite', 'The best we have', 8),
('Hampton Inn', 256, 'Suite', 'The best we have', 4),
('Hampton Inn', 267, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Hampton Inn', 270, 'Queen', 'Luxurious queen bed comes with breakfast', 8),
('Hampton Inn', 288, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Hampton Inn', 291, 'Double', 'This is a great room for two people', 4),
('Hi-Way Inn', 12, 'Suite', 'The best we have', 4),
('Hi-Way Inn', 14, 'King', 'Awesome room with great views', 2),
('Hi-Way Inn', 72, 'Suite', 'The best we have', 4),
('Hi-Way Inn', 76, 'Suite', 'The best we have', 5),
('Hi-Way Inn', 79, 'Queen', 'Luxurious queen bed comes with breakfast', 8),
('Hi-Way Inn', 87, 'Suite', 'The best we have', 3),
('Hi-Way Inn', 94, 'Suite', 'The best we have', 7),
('Hi-Way Inn', 117, 'Suite', 'The best we have', 4),
('Hi-Way Inn', 149, 'Double', 'This is a great room for two people', 2),
('Hi-Way Inn', 165, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Hi-Way Inn', 183, 'Double', 'This is a great room for two people', 9),
('Hi-Way Inn', 188, 'Double', 'This is a great room for two people', 3),
('Hi-Way Inn', 196, 'Double', 'This is a great room for two people', 9),
('Hi-Way Inn', 197, 'King', 'Awesome room with great views', 9),
('Hi-Way Inn', 208, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('Hi-Way Inn', 232, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Hi-Way Inn', 254, 'King', 'Awesome room with great views', 9),
('Hi-Way Inn', 263, 'Double', 'This is a great room for two people', 8),
('Hi-Way Inn', 268, 'King', 'Awesome room with great views', 5),
('Hi-Way Inn', 287, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Hi-Way Inn', 294, 'Double', 'This is a great room for two people', 8),
('Hi-Way Inn', 295, 'Suite', 'The best we have', 10),
('Hilton Downtown', 8, 'Suite', 'The best we have', 6),
('Hilton Downtown', 10, 'Suite', 'The best we have', 6),
('Hilton Downtown', 17, 'Queen', 'Luxurious queen bed comes with breakfast', 8),
('Hilton Downtown', 54, 'King', 'Awesome room with great views', 5),
('Hilton Downtown', 81, 'Double', 'This is a great room for two people', 6),
('Hilton Downtown', 85, 'Queen', 'Luxurious queen bed comes with breakfast', 8),
('Hilton Downtown', 95, 'King', 'Awesome room with great views', 4),
('Hilton Downtown', 98, 'King', 'Awesome room with great views', 2),
('Hilton Downtown', 103, 'Double', 'This is a great room for two people', 6),
('Hilton Downtown', 107, 'King', 'Awesome room with great views', 2),
('Hilton Downtown', 152, 'Double', 'This is a great room for two people', 2),
('Hilton Downtown', 186, 'Suite', 'The best we have', 1),
('Hilton Downtown', 190, 'Double', 'This is a great room for two people', 1),
('Hilton Downtown', 200, 'Suite', 'The best we have', 9),
('Hilton Downtown', 203, 'Double', 'This is a great room for two people', 8),
('Hilton Downtown', 204, 'Suite', 'The best we have', 9),
('Hilton Downtown', 216, 'King', 'Awesome room with great views', 10),
('Hilton Downtown', 219, 'King', 'Awesome room with great views', 8),
('Hilton Downtown', 225, 'Suite', 'The best we have', 3),
('Hilton Downtown', 228, 'King', 'Awesome room with great views', 7),
('Hilton Downtown', 238, 'Suite', 'The best we have', 10),
('Hilton Downtown', 247, 'Suite', 'The best we have', 2),
('Hilton Downtown', 250, 'King', 'Awesome room with great views', 1),
('Hotel deLuxe', 5, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Hotel deLuxe', 22, 'Double', 'This is a great room for two people', 6),
('Hotel deLuxe', 45, 'Double', 'This is a great room for two people', 2),
('Hotel deLuxe', 50, 'Suite', 'The best we have', 1),
('Hotel deLuxe', 51, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Hotel deLuxe', 55, 'Suite', 'The best we have', 3),
('Hotel deLuxe', 64, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('Hotel deLuxe', 65, 'Double', 'This is a great room for two people', 10),
('Hotel deLuxe', 73, 'Suite', 'The best we have', 5),
('Hotel deLuxe', 83, 'Suite', 'The best we have', 4),
('Hotel deLuxe', 88, 'Double', 'This is a great room for two people', 3),
('Hotel deLuxe', 91, 'Double', 'This is a great room for two people', 10),
('Hotel deLuxe', 116, 'Double', 'This is a great room for two people', 6),
('Hotel deLuxe', 126, 'Double', 'This is a great room for two people', 3),
('Hotel deLuxe', 131, 'Double', 'This is a great room for two people', 1),
('Hotel deLuxe', 138, 'King', 'Awesome room with great views', 1),
('Hotel deLuxe', 143, 'Suite', 'The best we have', 1),
('Hotel deLuxe', 145, 'Suite', 'The best we have', 4),
('Hotel deLuxe', 153, 'King', 'Awesome room with great views', 7),
('Hotel deLuxe', 167, 'Suite', 'The best we have', 3),
('Hotel deLuxe', 169, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Hotel deLuxe', 179, 'Double', 'This is a great room for two people', 1),
('Hotel deLuxe', 181, 'Suite', 'The best we have', 8),
('Hotel deLuxe', 205, 'Double', 'This is a great room for two people', 3),
('Hotel deLuxe', 209, 'Double', 'This is a great room for two people', 1),
('Hotel deLuxe', 220, 'Suite', 'The best we have', 6),
('Hotel deLuxe', 243, 'King', 'Awesome room with great views', 7),
('Hotel deLuxe', 251, 'King', 'Awesome room with great views', 3),
('Hotel deLuxe', 258, 'Suite', 'The best we have', 7),
('Hotel deLuxe', 274, 'Queen', 'Luxurious queen bed comes with breakfast', 6),
('Luxor', 3, 'Double', 'This is a great room for two people', 2),
('Luxor', 23, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Luxor', 26, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Luxor', 27, 'Suite', 'The best we have', 7),
('Luxor', 30, 'Double', 'This is a great room for two people', 6),
('Luxor', 33, 'Queen', 'Luxurious queen bed comes with breakfast', 6),
('Luxor', 47, 'Double', 'This is a great room for two people', 1),
('Luxor', 59, 'Queen', 'Luxurious queen bed comes with breakfast', 8),
('Luxor', 60, 'Suite', 'The best we have', 10),
('Luxor', 62, 'King', 'Awesome room with great views', 5),
('Luxor', 89, 'Suite', 'The best we have', 10),
('Luxor', 128, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Luxor', 141, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Luxor', 150, 'Double', 'This is a great room for two people', 4),
('Luxor', 177, 'Suite', 'The best we have', 1),
('Luxor', 194, 'King', 'Awesome room with great views', 5),
('Luxor', 214, 'Suite', 'The best we have', 7),
('Luxor', 235, 'King', 'Awesome room with great views', 5),
('Luxor', 237, 'King', 'Awesome room with great views', 9),
('Luxor', 241, 'Double', 'This is a great room for two people', 3),
('Luxor', 257, 'Suite', 'The best we have', 10),
('Luxor', 259, 'Double', 'This is a great room for two people', 1),
('Luxor', 264, 'King', 'Awesome room with great views', 6),
('Luxor', 271, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Luxor', 272, 'King', 'Awesome room with great views', 2),
('Luxor', 275, 'Double', 'This is a great room for two people', 3),
('Luxor', 283, 'Double', 'This is a great room for two people', 5),
('Luxor', 284, 'Queen', 'Luxurious queen bed comes with breakfast', 6),
('Luxor', 286, 'Double', 'This is a great room for two people', 1),
('Luxor', 289, 'Double', 'This is a great room for two people', 10),
('Residence Inn', 1, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Residence Inn', 31, 'King', 'Awesome room with great views', 2),
('Residence Inn', 39, 'Queen', 'Luxurious queen bed comes with breakfast', 1),
('Residence Inn', 67, 'Suite', 'The best we have', 10),
('Residence Inn', 75, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Residence Inn', 96, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Residence Inn', 118, 'King', 'Awesome room with great views', 10),
('Residence Inn', 120, 'Double', 'This is a great room for two people', 5),
('Residence Inn', 132, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Residence Inn', 137, 'Queen', 'Luxurious queen bed comes with breakfast', 4),
('Residence Inn', 156, 'Double', 'This is a great room for two people', 10),
('Residence Inn', 160, 'King', 'Awesome room with great views', 9),
('Residence Inn', 162, 'King', 'Awesome room with great views', 4),
('Residence Inn', 173, 'Suite', 'The best we have', 6),
('Residence Inn', 212, 'King', 'Awesome room with great views', 7),
('Residence Inn', 239, 'King', 'Awesome room with great views', 10),
('Residence Inn', 240, 'Suite', 'The best we have', 5),
('Residence Inn', 242, 'Double', 'This is a great room for two people', 5),
('Residence Inn', 249, 'Queen', 'Luxurious queen bed comes with breakfast', 3),
('Residence Inn', 261, 'Suite', 'The best we have', 3),
('Residence Inn', 269, 'Suite', 'The best we have', 2),
('Residence Inn', 278, 'Suite', 'The best we have', 9),
('Residence Inn', 285, 'Double', 'This is a great room for two people', 8),
('Residence Inn', 297, 'Suite', 'The best we have', 8),
('Sheraton Centre', 7, 'Suite', 'The best we have', 10),
('Sheraton Centre', 13, 'Double', 'This is a great room for two people', 10),
('Sheraton Centre', 25, 'Double', 'This is a great room for two people', 9),
('Sheraton Centre', 34, 'Suite', 'The best we have', 6),
('Sheraton Centre', 41, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Sheraton Centre', 42, 'King', 'Awesome room with great views', 8),
('Sheraton Centre', 46, 'Queen', 'Luxurious queen bed comes with breakfast', 3),
('Sheraton Centre', 58, 'Double', 'This is a great room for two people', 8),
('Sheraton Centre', 70, 'Double', 'This is a great room for two people', 9),
('Sheraton Centre', 92, 'Suite', 'The best we have', 6),
('Sheraton Centre', 93, 'King', 'Awesome room with great views', 10),
('Sheraton Centre', 163, 'Double', 'This is a great room for two people', 10),
('Sheraton Centre', 166, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('Sheraton Centre', 171, 'Suite', 'The best we have', 7),
('Sheraton Centre', 172, 'King', 'Awesome room with great views', 3),
('Sheraton Centre', 182, 'King', 'Awesome room with great views', 9),
('Sheraton Centre', 184, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('Sheraton Centre', 189, 'King', 'Awesome room with great views', 8),
('Sheraton Centre', 210, 'King', 'Awesome room with great views', 3),
('Sheraton Centre', 213, 'Double', 'This is a great room for two people', 3),
('Sheraton Centre', 217, 'Suite', 'The best we have', 7),
('Sheraton Centre', 224, 'Double', 'This is a great room for two people', 10),
('Sheraton Centre', 227, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('Sheraton Centre', 231, 'King', 'Awesome room with great views', 10),
('Sheraton Centre', 236, 'Double', 'This is a great room for two people', 7),
('Sheraton Centre', 246, 'Suite', 'The best we have', 7),
('Sheraton Centre', 255, 'King', 'Awesome room with great views', 10),
('Sheraton Centre', 262, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('Sheraton Centre', 282, 'Suite', 'The best we have', 9),
('Sheraton Centre', 293, 'King', 'Awesome room with great views', 9),
('The Paradise Inn', 6, 'King', 'Awesome room with great views', 8),
('The Paradise Inn', 11, 'King', 'Awesome room with great views', 3),
('The Paradise Inn', 15, 'Queen', 'Luxurious queen bed comes with breakfast', 2),
('The Paradise Inn', 21, 'King', 'Awesome room with great views', 9),
('The Paradise Inn', 32, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('The Paradise Inn', 35, 'Double', 'This is a great room for two people', 4),
('The Paradise Inn', 36, 'King', 'Awesome room with great views', 2),
('The Paradise Inn', 52, 'King', 'Awesome room with great views', 9),
('The Paradise Inn', 74, 'King', 'Awesome room with great views', 1),
('The Paradise Inn', 90, 'Double', 'This is a great room for two people', 6),
('The Paradise Inn', 112, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('The Paradise Inn', 113, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('The Paradise Inn', 121, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('The Paradise Inn', 125, 'Suite', 'The best we have', 3),
('The Paradise Inn', 139, 'King', 'Awesome room with great views', 3),
('The Paradise Inn', 140, 'Queen', 'Luxurious queen bed comes with breakfast', 5),
('The Paradise Inn', 148, 'King', 'Awesome room with great views', 6),
('The Paradise Inn', 159, 'King', 'Awesome room with great views', 7),
('The Paradise Inn', 175, 'Double', 'This is a great room for two people', 8),
('The Paradise Inn', 187, 'Suite', 'The best we have', 5),
('The Paradise Inn', 193, 'Double', 'This is a great room for two people', 5),
('The Paradise Inn', 198, 'Suite', 'The best we have', 5),
('The Paradise Inn', 199, 'King', 'Awesome room with great views', 3),
('The Paradise Inn', 206, 'King', 'Awesome room with great views', 4),
('The Paradise Inn', 211, 'Suite', 'The best we have', 7),
('The Paradise Inn', 226, 'Suite', 'The best we have', 2),
('The Paradise Inn', 230, 'Queen', 'Luxurious queen bed comes with breakfast', 10),
('The Paradise Inn', 233, 'King', 'Awesome room with great views', 10),
('The Paradise Inn', 244, 'Queen', 'Luxurious queen bed comes with breakfast', 9),
('The Paradise Inn', 245, 'Queen', 'Luxurious queen bed comes with breakfast', 7),
('The Paradise Inn', 266, 'Suite', 'The best we have', 1),
('The Paradise Inn', 279, 'Double', 'This is a great room for two people', 6),
('The Paradise Inn', 290, 'Suite', 'The best we have', 5);

-- --------------------------------------------------------

--
-- Table structure for table `room_date`
--

CREATE TABLE `room_date` (
  `property_name` varchar(100) NOT NULL,
  `room_num` int(10) UNSIGNED NOT NULL,
  `_date` date NOT NULL,
  `rate` float NOT NULL,
  `reservation_id` int(10) UNSIGNED DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `room_date`
--

INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 2, '2019-01-01', 301, NULL),
('Candlewood Suites', 2, '2019-01-02', 334, NULL),
('Candlewood Suites', 2, '2019-01-03', 174, NULL),
('Candlewood Suites', 2, '2019-01-04', 145, NULL),
('Candlewood Suites', 2, '2019-01-05', 179, NULL),
('Candlewood Suites', 2, '2019-01-06', 299, NULL),
('Candlewood Suites', 2, '2019-01-07', 357, NULL),
('Candlewood Suites', 2, '2019-01-08', 258, NULL),
('Candlewood Suites', 2, '2019-01-09', 261, NULL),
('Candlewood Suites', 2, '2019-01-10', 113, NULL),
('Candlewood Suites', 2, '2019-01-11', 106, NULL),
('Candlewood Suites', 2, '2019-01-12', 108, NULL),
('Candlewood Suites', 2, '2019-01-13', 267, NULL),
('Candlewood Suites', 2, '2019-01-14', 295, NULL),
('Candlewood Suites', 2, '2019-01-15', 207, NULL),
('Candlewood Suites', 2, '2019-01-16', 234, NULL),
('Candlewood Suites', 2, '2019-01-17', 337, NULL),
('Candlewood Suites', 2, '2019-01-18', 382, NULL),
('Candlewood Suites', 2, '2019-01-19', 134, NULL),
('Candlewood Suites', 2, '2019-01-20', 101, NULL),
('Candlewood Suites', 2, '2019-01-21', 147, 48),
('Candlewood Suites', 2, '2019-01-22', 233, 48),
('Candlewood Suites', 2, '2019-01-23', 194, 48),
('Candlewood Suites', 2, '2019-01-24', 221, 48),
('Candlewood Suites', 2, '2019-01-25', 231, 48),
('Candlewood Suites', 2, '2019-01-26', 392, 48),
('Candlewood Suites', 2, '2019-01-27', 252, 48),
('Candlewood Suites', 2, '2019-01-28', 176, 48),
('Candlewood Suites', 2, '2019-01-29', 113, 48),
('Candlewood Suites', 2, '2019-01-30', 328, 48),
('Candlewood Suites', 2, '2019-01-31', 208, 48),
('Candlewood Suites', 2, '2019-02-01', 397, 48),
('Candlewood Suites', 2, '2019-02-02', 175, 48),
('Candlewood Suites', 2, '2019-02-03', 243, 48),
('Candlewood Suites', 2, '2019-02-04', 203, 48),
('Candlewood Suites', 2, '2019-02-05', 393, 48),
('Candlewood Suites', 2, '2019-02-06', 211, 48),
('Candlewood Suites', 2, '2019-02-07', 356, 48),
('Candlewood Suites', 2, '2019-02-08', 343, 48),
('Candlewood Suites', 2, '2019-02-09', 150, 48),
('Candlewood Suites', 2, '2019-02-10', 152, 48),
('Candlewood Suites', 2, '2019-02-11', 206, 48),
('Candlewood Suites', 2, '2019-02-12', 114, 48),
('Candlewood Suites', 2, '2019-02-13', 376, NULL),
('Candlewood Suites', 2, '2019-02-14', 319, NULL),
('Candlewood Suites', 2, '2019-02-15', 370, NULL),
('Candlewood Suites', 2, '2019-02-16', 217, NULL),
('Candlewood Suites', 2, '2019-02-17', 375, NULL),
('Candlewood Suites', 2, '2019-02-18', 229, NULL),
('Candlewood Suites', 2, '2019-02-19', 307, NULL),
('Candlewood Suites', 2, '2019-02-20', 351, NULL),
('Candlewood Suites', 2, '2019-02-21', 258, NULL),
('Candlewood Suites', 2, '2019-02-22', 193, NULL),
('Candlewood Suites', 2, '2019-02-23', 261, NULL),
('Candlewood Suites', 2, '2019-02-24', 182, NULL),
('Candlewood Suites', 2, '2019-02-25', 275, NULL),
('Candlewood Suites', 2, '2019-02-26', 361, NULL),
('Candlewood Suites', 2, '2019-02-27', 278, NULL),
('Candlewood Suites', 2, '2019-02-28', 365, NULL),
('Candlewood Suites', 2, '2019-03-01', 180, NULL),
('Candlewood Suites', 2, '2019-03-02', 340, NULL),
('Candlewood Suites', 2, '2019-03-03', 206, NULL),
('Candlewood Suites', 2, '2019-03-04', 305, NULL),
('Candlewood Suites', 2, '2019-03-05', 284, NULL),
('Candlewood Suites', 2, '2019-03-06', 314, NULL),
('Candlewood Suites', 2, '2019-03-07', 271, NULL),
('Candlewood Suites', 2, '2019-03-08', 174, NULL),
('Candlewood Suites', 2, '2019-03-09', 344, NULL),
('Candlewood Suites', 2, '2019-03-10', 115, NULL),
('Candlewood Suites', 2, '2019-03-11', 298, NULL),
('Candlewood Suites', 2, '2019-03-12', 209, NULL),
('Candlewood Suites', 2, '2019-03-13', 168, NULL),
('Candlewood Suites', 2, '2019-03-14', 399, NULL),
('Candlewood Suites', 2, '2019-03-15', 107, NULL),
('Candlewood Suites', 2, '2019-03-16', 149, NULL),
('Candlewood Suites', 2, '2019-03-17', 303, NULL),
('Candlewood Suites', 2, '2019-03-18', 143, NULL),
('Candlewood Suites', 2, '2019-03-19', 278, NULL),
('Candlewood Suites', 2, '2019-03-20', 234, NULL),
('Candlewood Suites', 2, '2019-03-21', 320, NULL),
('Candlewood Suites', 2, '2019-03-22', 266, NULL),
('Candlewood Suites', 2, '2019-03-23', 246, NULL),
('Candlewood Suites', 2, '2019-03-24', 283, NULL),
('Candlewood Suites', 2, '2019-03-25', 353, NULL),
('Candlewood Suites', 2, '2019-03-26', 266, NULL),
('Candlewood Suites', 2, '2019-03-27', 389, NULL),
('Candlewood Suites', 2, '2019-03-28', 149, NULL),
('Candlewood Suites', 2, '2019-03-29', 285, NULL),
('Candlewood Suites', 2, '2019-03-30', 381, NULL),
('Candlewood Suites', 2, '2019-03-31', 270, NULL),
('Candlewood Suites', 2, '2019-04-01', 194, NULL),
('Candlewood Suites', 2, '2019-04-02', 134, NULL),
('Candlewood Suites', 2, '2019-04-03', 131, NULL),
('Candlewood Suites', 2, '2019-04-04', 263, NULL),
('Candlewood Suites', 2, '2019-04-05', 398, NULL),
('Candlewood Suites', 2, '2019-04-06', 254, NULL),
('Candlewood Suites', 2, '2019-04-07', 107, NULL),
('Candlewood Suites', 2, '2019-04-08', 110, NULL),
('Candlewood Suites', 2, '2019-04-09', 289, NULL),
('Candlewood Suites', 2, '2019-04-10', 114, NULL),
('Candlewood Suites', 2, '2019-04-11', 264, NULL),
('Candlewood Suites', 2, '2019-04-12', 267, NULL),
('Candlewood Suites', 2, '2019-04-13', 168, NULL),
('Candlewood Suites', 2, '2019-04-14', 251, NULL),
('Candlewood Suites', 2, '2019-04-15', 387, 35),
('Candlewood Suites', 2, '2019-04-16', 162, 35),
('Candlewood Suites', 2, '2019-04-17', 197, 35),
('Candlewood Suites', 2, '2019-04-18', 111, 35),
('Candlewood Suites', 2, '2019-04-19', 284, 35),
('Candlewood Suites', 2, '2019-04-20', 127, 35),
('Candlewood Suites', 2, '2019-04-21', 172, 35),
('Candlewood Suites', 2, '2019-04-22', 299, 35),
('Candlewood Suites', 2, '2019-04-23', 393, 35),
('Candlewood Suites', 2, '2019-04-24', 108, 35),
('Candlewood Suites', 2, '2019-04-25', 120, 35),
('Candlewood Suites', 2, '2019-04-26', 332, NULL),
('Candlewood Suites', 2, '2019-04-27', 110, NULL),
('Candlewood Suites', 2, '2019-04-28', 298, NULL),
('Candlewood Suites', 2, '2019-04-29', 288, NULL),
('Candlewood Suites', 2, '2019-04-30', 287, NULL),
('Candlewood Suites', 2, '2019-05-01', 320, NULL),
('Candlewood Suites', 2, '2019-05-02', 297, NULL),
('Candlewood Suites', 2, '2019-05-03', 155, NULL),
('Candlewood Suites', 2, '2019-05-04', 271, NULL),
('Candlewood Suites', 2, '2019-05-05', 156, NULL),
('Candlewood Suites', 2, '2019-05-06', 231, NULL),
('Candlewood Suites', 2, '2019-05-07', 185, NULL),
('Candlewood Suites', 2, '2019-05-08', 280, NULL),
('Candlewood Suites', 2, '2019-05-09', 166, NULL),
('Candlewood Suites', 2, '2019-05-10', 195, 85),
('Candlewood Suites', 2, '2019-05-11', 227, 85),
('Candlewood Suites', 2, '2019-05-12', 294, 85),
('Candlewood Suites', 2, '2019-05-13', 301, 85),
('Candlewood Suites', 2, '2019-05-14', 236, 85),
('Candlewood Suites', 2, '2019-05-15', 393, 85),
('Candlewood Suites', 2, '2019-05-16', 140, 85),
('Candlewood Suites', 2, '2019-05-17', 263, 85),
('Candlewood Suites', 2, '2019-05-18', 258, 85),
('Candlewood Suites', 2, '2019-05-19', 247, 85),
('Candlewood Suites', 2, '2019-05-20', 151, 85),
('Candlewood Suites', 2, '2019-05-21', 158, 85),
('Candlewood Suites', 2, '2019-05-22', 233, 85),
('Candlewood Suites', 2, '2019-05-23', 361, 85),
('Candlewood Suites', 2, '2019-05-24', 117, 85),
('Candlewood Suites', 2, '2019-05-25', 352, 85),
('Candlewood Suites', 2, '2019-05-26', 192, 85),
('Candlewood Suites', 2, '2019-05-27', 224, 85),
('Candlewood Suites', 2, '2019-05-28', 128, 85),
('Candlewood Suites', 2, '2019-05-29', 280, 85),
('Candlewood Suites', 2, '2019-05-30', 139, 85),
('Candlewood Suites', 2, '2019-05-31', 254, 85),
('Candlewood Suites', 2, '2019-06-01', 375, 85),
('Candlewood Suites', 2, '2019-06-02', 309, 85),
('Candlewood Suites', 2, '2019-06-03', 367, 85),
('Candlewood Suites', 2, '2019-06-04', 277, 85),
('Candlewood Suites', 2, '2019-06-05', 306, 85),
('Candlewood Suites', 2, '2019-06-06', 351, 85),
('Candlewood Suites', 2, '2019-06-07', 132, NULL),
('Candlewood Suites', 2, '2019-06-08', 186, NULL),
('Candlewood Suites', 2, '2019-06-09', 237, NULL),
('Candlewood Suites', 2, '2019-06-10', 327, NULL),
('Candlewood Suites', 2, '2019-06-11', 232, NULL),
('Candlewood Suites', 2, '2019-06-12', 385, NULL),
('Candlewood Suites', 2, '2019-06-13', 340, NULL),
('Candlewood Suites', 2, '2019-06-14', 223, NULL),
('Candlewood Suites', 2, '2019-06-15', 218, NULL),
('Candlewood Suites', 2, '2019-06-16', 258, NULL),
('Candlewood Suites', 2, '2019-06-17', 184, NULL),
('Candlewood Suites', 2, '2019-06-18', 205, NULL),
('Candlewood Suites', 2, '2019-06-19', 274, NULL),
('Candlewood Suites', 2, '2019-06-20', 239, NULL),
('Candlewood Suites', 2, '2019-06-21', 377, NULL),
('Candlewood Suites', 2, '2019-06-22', 333, NULL),
('Candlewood Suites', 2, '2019-06-23', 368, NULL),
('Candlewood Suites', 2, '2019-06-24', 327, NULL),
('Candlewood Suites', 2, '2019-06-25', 253, NULL),
('Candlewood Suites', 2, '2019-06-26', 220, NULL),
('Candlewood Suites', 2, '2019-06-27', 386, NULL),
('Candlewood Suites', 2, '2019-06-28', 214, NULL),
('Candlewood Suites', 2, '2019-06-29', 396, NULL),
('Candlewood Suites', 2, '2019-06-30', 293, NULL),
('Candlewood Suites', 2, '2019-07-01', 168, NULL),
('Candlewood Suites', 2, '2019-07-02', 218, NULL),
('Candlewood Suites', 2, '2019-07-03', 183, NULL),
('Candlewood Suites', 2, '2019-07-04', 370, NULL),
('Candlewood Suites', 2, '2019-07-05', 228, NULL),
('Candlewood Suites', 2, '2019-07-06', 257, NULL),
('Candlewood Suites', 2, '2019-07-07', 250, NULL),
('Candlewood Suites', 2, '2019-07-08', 215, NULL),
('Candlewood Suites', 2, '2019-07-09', 231, NULL),
('Candlewood Suites', 2, '2019-07-10', 341, NULL),
('Candlewood Suites', 2, '2019-07-11', 298, NULL),
('Candlewood Suites', 2, '2019-07-12', 232, NULL),
('Candlewood Suites', 2, '2019-07-13', 382, NULL),
('Candlewood Suites', 2, '2019-07-14', 344, NULL),
('Candlewood Suites', 2, '2019-07-15', 133, NULL),
('Candlewood Suites', 2, '2019-07-16', 181, NULL),
('Candlewood Suites', 2, '2019-07-17', 377, NULL),
('Candlewood Suites', 2, '2019-07-18', 381, NULL),
('Candlewood Suites', 2, '2019-07-19', 209, NULL),
('Candlewood Suites', 2, '2019-07-20', 345, NULL),
('Candlewood Suites', 2, '2019-07-21', 117, NULL),
('Candlewood Suites', 2, '2019-07-22', 110, NULL),
('Candlewood Suites', 2, '2019-07-23', 386, NULL),
('Candlewood Suites', 2, '2019-07-24', 114, NULL),
('Candlewood Suites', 2, '2019-07-25', 174, NULL),
('Candlewood Suites', 2, '2019-07-26', 234, NULL),
('Candlewood Suites', 2, '2019-07-27', 173, NULL),
('Candlewood Suites', 2, '2019-07-28', 104, NULL),
('Candlewood Suites', 2, '2019-07-29', 113, NULL),
('Candlewood Suites', 2, '2019-07-30', 264, NULL),
('Candlewood Suites', 2, '2019-07-31', 178, NULL),
('Candlewood Suites', 2, '2019-08-01', 144, NULL),
('Candlewood Suites', 2, '2019-08-02', 287, NULL),
('Candlewood Suites', 2, '2019-08-03', 245, NULL),
('Candlewood Suites', 2, '2019-08-04', 231, NULL),
('Candlewood Suites', 2, '2019-08-05', 373, NULL),
('Candlewood Suites', 2, '2019-08-06', 118, NULL),
('Candlewood Suites', 2, '2019-08-07', 332, NULL),
('Candlewood Suites', 2, '2019-08-08', 291, NULL),
('Candlewood Suites', 2, '2019-08-09', 278, NULL),
('Candlewood Suites', 2, '2019-08-10', 136, NULL),
('Candlewood Suites', 2, '2019-08-11', 276, NULL),
('Candlewood Suites', 2, '2019-08-12', 178, NULL),
('Candlewood Suites', 2, '2019-08-13', 267, NULL),
('Candlewood Suites', 2, '2019-08-14', 192, NULL),
('Candlewood Suites', 2, '2019-08-15', 269, NULL),
('Candlewood Suites', 2, '2019-08-16', 397, NULL),
('Candlewood Suites', 2, '2019-08-17', 208, NULL),
('Candlewood Suites', 2, '2019-08-18', 275, 38),
('Candlewood Suites', 2, '2019-08-19', 134, 38),
('Candlewood Suites', 2, '2019-08-20', 245, 38),
('Candlewood Suites', 2, '2019-08-21', 233, 38),
('Candlewood Suites', 2, '2019-08-22', 315, 38),
('Candlewood Suites', 2, '2019-08-23', 240, 38),
('Candlewood Suites', 2, '2019-08-24', 137, 38),
('Candlewood Suites', 2, '2019-08-25', 269, 38),
('Candlewood Suites', 2, '2019-08-26', 298, 38),
('Candlewood Suites', 2, '2019-08-27', 352, 38),
('Candlewood Suites', 2, '2019-08-28', 249, 38),
('Candlewood Suites', 2, '2019-08-29', 143, 38),
('Candlewood Suites', 2, '2019-08-30', 331, 38),
('Candlewood Suites', 2, '2019-08-31', 123, 38),
('Candlewood Suites', 2, '2019-09-01', 317, 38),
('Candlewood Suites', 2, '2019-09-02', 259, NULL),
('Candlewood Suites', 2, '2019-09-03', 318, NULL),
('Candlewood Suites', 2, '2019-09-04', 255, NULL),
('Candlewood Suites', 2, '2019-09-05', 200, NULL),
('Candlewood Suites', 2, '2019-09-06', 386, NULL),
('Candlewood Suites', 2, '2019-09-07', 269, NULL),
('Candlewood Suites', 2, '2019-09-08', 190, NULL),
('Candlewood Suites', 2, '2019-09-09', 326, NULL),
('Candlewood Suites', 2, '2019-09-10', 163, NULL),
('Candlewood Suites', 2, '2019-09-11', 342, NULL),
('Candlewood Suites', 2, '2019-09-12', 253, NULL),
('Candlewood Suites', 2, '2019-09-13', 343, NULL),
('Candlewood Suites', 2, '2019-09-14', 315, NULL),
('Candlewood Suites', 2, '2019-09-15', 188, NULL),
('Candlewood Suites', 2, '2019-09-16', 137, NULL),
('Candlewood Suites', 2, '2019-09-17', 296, NULL),
('Candlewood Suites', 2, '2019-09-18', 368, NULL),
('Candlewood Suites', 2, '2019-09-19', 256, NULL),
('Candlewood Suites', 2, '2019-09-20', 233, NULL),
('Candlewood Suites', 2, '2019-09-21', 111, NULL),
('Candlewood Suites', 2, '2019-09-22', 176, NULL),
('Candlewood Suites', 2, '2019-09-23', 352, NULL),
('Candlewood Suites', 2, '2019-09-24', 162, NULL),
('Candlewood Suites', 2, '2019-09-25', 399, NULL),
('Candlewood Suites', 2, '2019-09-26', 135, NULL),
('Candlewood Suites', 2, '2019-09-27', 229, NULL),
('Candlewood Suites', 2, '2019-09-28', 159, NULL),
('Candlewood Suites', 2, '2019-09-29', 293, NULL),
('Candlewood Suites', 2, '2019-09-30', 230, NULL),
('Candlewood Suites', 2, '2019-10-01', 116, NULL),
('Candlewood Suites', 2, '2019-10-02', 210, NULL),
('Candlewood Suites', 2, '2019-10-03', 349, NULL),
('Candlewood Suites', 2, '2019-10-04', 260, NULL),
('Candlewood Suites', 2, '2019-10-05', 307, NULL),
('Candlewood Suites', 2, '2019-10-06', 318, NULL),
('Candlewood Suites', 2, '2019-10-07', 233, NULL),
('Candlewood Suites', 2, '2019-10-08', 275, NULL),
('Candlewood Suites', 2, '2019-10-09', 138, NULL),
('Candlewood Suites', 2, '2019-10-10', 314, NULL),
('Candlewood Suites', 2, '2019-10-11', 129, NULL),
('Candlewood Suites', 2, '2019-10-12', 303, NULL),
('Candlewood Suites', 2, '2019-10-13', 131, NULL),
('Candlewood Suites', 2, '2019-10-14', 311, NULL),
('Candlewood Suites', 2, '2019-10-15', 316, NULL),
('Candlewood Suites', 2, '2019-10-16', 356, NULL),
('Candlewood Suites', 2, '2019-10-17', 254, NULL),
('Candlewood Suites', 2, '2019-10-18', 146, NULL),
('Candlewood Suites', 2, '2019-10-19', 212, NULL),
('Candlewood Suites', 2, '2019-10-20', 279, NULL),
('Candlewood Suites', 2, '2019-10-21', 190, NULL),
('Candlewood Suites', 2, '2019-10-22', 354, NULL),
('Candlewood Suites', 2, '2019-10-23', 230, NULL),
('Candlewood Suites', 2, '2019-10-24', 128, NULL),
('Candlewood Suites', 2, '2019-10-25', 134, NULL),
('Candlewood Suites', 2, '2019-10-26', 394, NULL),
('Candlewood Suites', 2, '2019-10-27', 289, 114),
('Candlewood Suites', 2, '2019-10-28', 300, 114),
('Candlewood Suites', 2, '2019-10-29', 157, 114),
('Candlewood Suites', 2, '2019-10-30', 385, 114),
('Candlewood Suites', 2, '2019-10-31', 111, 114),
('Candlewood Suites', 2, '2019-11-01', 336, 114),
('Candlewood Suites', 2, '2019-11-02', 122, 114),
('Candlewood Suites', 2, '2019-11-03', 326, 114),
('Candlewood Suites', 2, '2019-11-04', 177, 114),
('Candlewood Suites', 2, '2019-11-05', 328, 114),
('Candlewood Suites', 2, '2019-11-06', 224, 114),
('Candlewood Suites', 2, '2019-11-07', 337, 114),
('Candlewood Suites', 2, '2019-11-08', 235, 114),
('Candlewood Suites', 2, '2019-11-09', 274, NULL),
('Candlewood Suites', 2, '2019-11-10', 191, NULL),
('Candlewood Suites', 2, '2019-11-11', 365, NULL),
('Candlewood Suites', 2, '2019-11-12', 375, 67),
('Candlewood Suites', 2, '2019-11-13', 243, 67),
('Candlewood Suites', 2, '2019-11-14', 125, 67),
('Candlewood Suites', 2, '2019-11-15', 162, 67),
('Candlewood Suites', 2, '2019-11-16', 257, 67),
('Candlewood Suites', 2, '2019-11-17', 333, 67),
('Candlewood Suites', 2, '2019-11-18', 236, 67),
('Candlewood Suites', 2, '2019-11-19', 342, 67),
('Candlewood Suites', 2, '2019-11-20', 229, 67),
('Candlewood Suites', 2, '2019-11-21', 254, 67),
('Candlewood Suites', 2, '2019-11-22', 144, 67),
('Candlewood Suites', 2, '2019-11-23', 138, 67),
('Candlewood Suites', 2, '2019-11-24', 288, 67),
('Candlewood Suites', 2, '2019-11-25', 374, 67),
('Candlewood Suites', 2, '2019-11-26', 265, 67),
('Candlewood Suites', 2, '2019-11-27', 151, 67),
('Candlewood Suites', 2, '2019-11-28', 159, 67),
('Candlewood Suites', 2, '2019-11-29', 274, 67),
('Candlewood Suites', 2, '2019-11-30', 267, 67),
('Candlewood Suites', 2, '2019-12-01', 198, 67),
('Candlewood Suites', 2, '2019-12-02', 168, 67),
('Candlewood Suites', 2, '2019-12-03', 224, 67),
('Candlewood Suites', 2, '2019-12-04', 208, 67),
('Candlewood Suites', 2, '2019-12-05', 270, 67),
('Candlewood Suites', 2, '2019-12-06', 128, 67),
('Candlewood Suites', 2, '2019-12-07', 352, NULL),
('Candlewood Suites', 2, '2019-12-08', 170, NULL),
('Candlewood Suites', 2, '2019-12-09', 385, NULL),
('Candlewood Suites', 2, '2019-12-10', 319, NULL),
('Candlewood Suites', 2, '2019-12-11', 286, 97),
('Candlewood Suites', 2, '2019-12-12', 103, 97),
('Candlewood Suites', 2, '2019-12-13', 240, 97),
('Candlewood Suites', 2, '2019-12-14', 350, 97),
('Candlewood Suites', 2, '2019-12-15', 158, 97),
('Candlewood Suites', 2, '2019-12-16', 347, 97),
('Candlewood Suites', 2, '2019-12-17', 292, 97),
('Candlewood Suites', 2, '2019-12-18', 172, 97),
('Candlewood Suites', 2, '2019-12-19', 364, 97),
('Candlewood Suites', 2, '2019-12-20', 326, 97),
('Candlewood Suites', 2, '2019-12-21', 194, 97),
('Candlewood Suites', 2, '2019-12-22', 105, 97),
('Candlewood Suites', 2, '2019-12-23', 243, 97),
('Candlewood Suites', 2, '2019-12-24', 295, 97),
('Candlewood Suites', 2, '2019-12-25', 392, 97),
('Candlewood Suites', 2, '2019-12-26', 287, 97),
('Candlewood Suites', 2, '2019-12-27', 149, 97),
('Candlewood Suites', 2, '2019-12-28', 169, 97),
('Candlewood Suites', 2, '2019-12-29', 198, 97),
('Candlewood Suites', 2, '2019-12-30', 251, NULL),
('Candlewood Suites', 2, '2019-12-31', 254, NULL),
('Candlewood Suites', 2, '2020-01-01', 203, NULL),
('Candlewood Suites', 2, '2020-01-02', 226, NULL),
('Candlewood Suites', 2, '2020-01-03', 371, NULL),
('Candlewood Suites', 2, '2020-01-04', 308, NULL),
('Candlewood Suites', 2, '2020-01-05', 206, NULL),
('Candlewood Suites', 2, '2020-01-06', 107, NULL),
('Candlewood Suites', 2, '2020-01-07', 263, NULL),
('Candlewood Suites', 2, '2020-01-08', 295, NULL),
('Candlewood Suites', 2, '2020-01-09', 393, NULL),
('Candlewood Suites', 2, '2020-01-10', 209, NULL),
('Candlewood Suites', 2, '2020-01-11', 150, 191),
('Candlewood Suites', 2, '2020-01-12', 164, 191),
('Candlewood Suites', 2, '2020-01-13', 144, 191),
('Candlewood Suites', 2, '2020-01-14', 398, 191),
('Candlewood Suites', 2, '2020-01-15', 184, 191),
('Candlewood Suites', 2, '2020-01-16', 385, 191),
('Candlewood Suites', 2, '2020-01-17', 321, 191),
('Candlewood Suites', 2, '2020-01-18', 337, 191),
('Candlewood Suites', 2, '2020-01-19', 310, NULL),
('Candlewood Suites', 2, '2020-01-20', 114, NULL),
('Candlewood Suites', 2, '2020-01-21', 175, NULL),
('Candlewood Suites', 2, '2020-01-22', 211, NULL),
('Candlewood Suites', 2, '2020-01-23', 205, NULL),
('Candlewood Suites', 2, '2020-01-24', 360, NULL),
('Candlewood Suites', 2, '2020-01-25', 221, NULL),
('Candlewood Suites', 2, '2020-01-26', 134, NULL),
('Candlewood Suites', 2, '2020-01-27', 385, NULL),
('Candlewood Suites', 2, '2020-01-28', 248, NULL),
('Candlewood Suites', 2, '2020-01-29', 312, NULL),
('Candlewood Suites', 2, '2020-01-30', 138, NULL),
('Candlewood Suites', 2, '2020-01-31', 395, NULL),
('Candlewood Suites', 2, '2020-02-01', 296, NULL),
('Candlewood Suites', 2, '2020-02-02', 348, NULL),
('Candlewood Suites', 2, '2020-02-03', 180, NULL),
('Candlewood Suites', 2, '2020-02-04', 198, NULL),
('Candlewood Suites', 19, '2019-01-01', 266, NULL),
('Candlewood Suites', 19, '2019-01-02', 179, NULL),
('Candlewood Suites', 19, '2019-01-03', 268, NULL),
('Candlewood Suites', 19, '2019-01-04', 154, NULL),
('Candlewood Suites', 19, '2019-01-05', 317, NULL),
('Candlewood Suites', 19, '2019-01-06', 392, NULL),
('Candlewood Suites', 19, '2019-01-07', 221, NULL),
('Candlewood Suites', 19, '2019-01-08', 168, NULL),
('Candlewood Suites', 19, '2019-01-09', 369, NULL),
('Candlewood Suites', 19, '2019-01-10', 197, NULL),
('Candlewood Suites', 19, '2019-01-11', 286, NULL),
('Candlewood Suites', 19, '2019-01-12', 269, NULL),
('Candlewood Suites', 19, '2019-01-13', 312, NULL),
('Candlewood Suites', 19, '2019-01-14', 185, NULL),
('Candlewood Suites', 19, '2019-01-15', 145, NULL),
('Candlewood Suites', 19, '2019-01-16', 251, NULL),
('Candlewood Suites', 19, '2019-01-17', 221, NULL),
('Candlewood Suites', 19, '2019-01-18', 281, NULL),
('Candlewood Suites', 19, '2019-01-19', 361, NULL),
('Candlewood Suites', 19, '2019-01-20', 268, NULL),
('Candlewood Suites', 19, '2019-01-21', 219, NULL),
('Candlewood Suites', 19, '2019-01-22', 396, NULL),
('Candlewood Suites', 19, '2019-01-23', 387, NULL),
('Candlewood Suites', 19, '2019-01-24', 229, NULL),
('Candlewood Suites', 19, '2019-01-25', 154, NULL),
('Candlewood Suites', 19, '2019-01-26', 134, NULL),
('Candlewood Suites', 19, '2019-01-27', 287, NULL),
('Candlewood Suites', 19, '2019-01-28', 269, NULL),
('Candlewood Suites', 19, '2019-01-29', 240, NULL),
('Candlewood Suites', 19, '2019-01-30', 307, NULL),
('Candlewood Suites', 19, '2019-01-31', 203, NULL),
('Candlewood Suites', 19, '2019-02-01', 346, NULL),
('Candlewood Suites', 19, '2019-02-02', 332, 63),
('Candlewood Suites', 19, '2019-02-03', 198, 63),
('Candlewood Suites', 19, '2019-02-04', 391, 63),
('Candlewood Suites', 19, '2019-02-05', 184, 63),
('Candlewood Suites', 19, '2019-02-06', 396, 63),
('Candlewood Suites', 19, '2019-02-07', 207, 63),
('Candlewood Suites', 19, '2019-02-08', 107, 63),
('Candlewood Suites', 19, '2019-02-09', 133, 63),
('Candlewood Suites', 19, '2019-02-10', 369, 63),
('Candlewood Suites', 19, '2019-02-11', 374, 63),
('Candlewood Suites', 19, '2019-02-12', 321, 63),
('Candlewood Suites', 19, '2019-02-13', 144, 63),
('Candlewood Suites', 19, '2019-02-14', 217, 63),
('Candlewood Suites', 19, '2019-02-15', 357, 63),
('Candlewood Suites', 19, '2019-02-16', 163, 63),
('Candlewood Suites', 19, '2019-02-17', 136, 63),
('Candlewood Suites', 19, '2019-02-18', 229, 63),
('Candlewood Suites', 19, '2019-02-19', 343, 63),
('Candlewood Suites', 19, '2019-02-20', 379, 63),
('Candlewood Suites', 19, '2019-02-21', 199, NULL),
('Candlewood Suites', 19, '2019-02-22', 250, NULL),
('Candlewood Suites', 19, '2019-02-23', 223, NULL),
('Candlewood Suites', 19, '2019-02-24', 182, NULL),
('Candlewood Suites', 19, '2019-02-25', 252, NULL),
('Candlewood Suites', 19, '2019-02-26', 347, NULL),
('Candlewood Suites', 19, '2019-02-27', 160, NULL),
('Candlewood Suites', 19, '2019-02-28', 200, NULL),
('Candlewood Suites', 19, '2019-03-01', 204, NULL),
('Candlewood Suites', 19, '2019-03-02', 330, NULL),
('Candlewood Suites', 19, '2019-03-03', 176, NULL),
('Candlewood Suites', 19, '2019-03-04', 256, NULL),
('Candlewood Suites', 19, '2019-03-05', 171, NULL),
('Candlewood Suites', 19, '2019-03-06', 157, NULL),
('Candlewood Suites', 19, '2019-03-07', 155, NULL),
('Candlewood Suites', 19, '2019-03-08', 180, NULL),
('Candlewood Suites', 19, '2019-03-09', 104, NULL),
('Candlewood Suites', 19, '2019-03-10', 120, NULL),
('Candlewood Suites', 19, '2019-03-11', 188, NULL),
('Candlewood Suites', 19, '2019-03-12', 281, NULL),
('Candlewood Suites', 19, '2019-03-13', 235, NULL),
('Candlewood Suites', 19, '2019-03-14', 356, NULL),
('Candlewood Suites', 19, '2019-03-15', 244, NULL),
('Candlewood Suites', 19, '2019-03-16', 270, NULL),
('Candlewood Suites', 19, '2019-03-17', 165, NULL),
('Candlewood Suites', 19, '2019-03-18', 117, NULL),
('Candlewood Suites', 19, '2019-03-19', 183, NULL),
('Candlewood Suites', 19, '2019-03-20', 108, NULL),
('Candlewood Suites', 19, '2019-03-21', 298, NULL),
('Candlewood Suites', 19, '2019-03-22', 203, NULL),
('Candlewood Suites', 19, '2019-03-23', 328, NULL),
('Candlewood Suites', 19, '2019-03-24', 158, NULL),
('Candlewood Suites', 19, '2019-03-25', 384, NULL),
('Candlewood Suites', 19, '2019-03-26', 281, NULL),
('Candlewood Suites', 19, '2019-03-27', 352, NULL),
('Candlewood Suites', 19, '2019-03-28', 186, NULL),
('Candlewood Suites', 19, '2019-03-29', 128, NULL),
('Candlewood Suites', 19, '2019-03-30', 248, NULL),
('Candlewood Suites', 19, '2019-03-31', 247, NULL),
('Candlewood Suites', 19, '2019-04-01', 127, NULL),
('Candlewood Suites', 19, '2019-04-02', 101, NULL),
('Candlewood Suites', 19, '2019-04-03', 122, NULL),
('Candlewood Suites', 19, '2019-04-04', 167, NULL),
('Candlewood Suites', 19, '2019-04-05', 120, NULL),
('Candlewood Suites', 19, '2019-04-06', 130, NULL),
('Candlewood Suites', 19, '2019-04-07', 186, NULL),
('Candlewood Suites', 19, '2019-04-08', 358, NULL),
('Candlewood Suites', 19, '2019-04-09', 149, NULL),
('Candlewood Suites', 19, '2019-04-10', 334, NULL),
('Candlewood Suites', 19, '2019-04-11', 180, NULL),
('Candlewood Suites', 19, '2019-04-12', 321, NULL),
('Candlewood Suites', 19, '2019-04-13', 389, NULL),
('Candlewood Suites', 19, '2019-04-14', 280, NULL),
('Candlewood Suites', 19, '2019-04-15', 349, NULL),
('Candlewood Suites', 19, '2019-04-16', 134, 71),
('Candlewood Suites', 19, '2019-04-17', 130, 71),
('Candlewood Suites', 19, '2019-04-18', 206, 71),
('Candlewood Suites', 19, '2019-04-19', 111, 71),
('Candlewood Suites', 19, '2019-04-20', 303, 71),
('Candlewood Suites', 19, '2019-04-21', 170, 71),
('Candlewood Suites', 19, '2019-04-22', 145, 71),
('Candlewood Suites', 19, '2019-04-23', 196, 71),
('Candlewood Suites', 19, '2019-04-24', 238, 71),
('Candlewood Suites', 19, '2019-04-25', 364, 71),
('Candlewood Suites', 19, '2019-04-26', 354, 71),
('Candlewood Suites', 19, '2019-04-27', 123, 71),
('Candlewood Suites', 19, '2019-04-28', 372, 71),
('Candlewood Suites', 19, '2019-04-29', 218, NULL),
('Candlewood Suites', 19, '2019-04-30', 114, NULL),
('Candlewood Suites', 19, '2019-05-01', 189, NULL),
('Candlewood Suites', 19, '2019-05-02', 147, NULL),
('Candlewood Suites', 19, '2019-05-03', 244, NULL),
('Candlewood Suites', 19, '2019-05-04', 253, NULL),
('Candlewood Suites', 19, '2019-05-05', 345, NULL),
('Candlewood Suites', 19, '2019-05-06', 341, NULL),
('Candlewood Suites', 19, '2019-05-07', 215, NULL),
('Candlewood Suites', 19, '2019-05-08', 330, NULL),
('Candlewood Suites', 19, '2019-05-09', 347, NULL),
('Candlewood Suites', 19, '2019-05-10', 322, NULL),
('Candlewood Suites', 19, '2019-05-11', 357, NULL),
('Candlewood Suites', 19, '2019-05-12', 173, NULL),
('Candlewood Suites', 19, '2019-05-13', 267, NULL),
('Candlewood Suites', 19, '2019-05-14', 100, NULL),
('Candlewood Suites', 19, '2019-05-15', 365, NULL),
('Candlewood Suites', 19, '2019-05-16', 219, NULL),
('Candlewood Suites', 19, '2019-05-17', 257, NULL),
('Candlewood Suites', 19, '2019-05-18', 317, NULL),
('Candlewood Suites', 19, '2019-05-19', 113, NULL),
('Candlewood Suites', 19, '2019-05-20', 385, NULL),
('Candlewood Suites', 19, '2019-05-21', 319, NULL),
('Candlewood Suites', 19, '2019-05-22', 287, NULL),
('Candlewood Suites', 19, '2019-05-23', 153, NULL),
('Candlewood Suites', 19, '2019-05-24', 185, NULL),
('Candlewood Suites', 19, '2019-05-25', 197, NULL),
('Candlewood Suites', 19, '2019-05-26', 205, NULL),
('Candlewood Suites', 19, '2019-05-27', 114, NULL),
('Candlewood Suites', 19, '2019-05-28', 169, NULL),
('Candlewood Suites', 19, '2019-05-29', 300, NULL),
('Candlewood Suites', 19, '2019-05-30', 339, NULL),
('Candlewood Suites', 19, '2019-05-31', 210, NULL),
('Candlewood Suites', 19, '2019-06-01', 304, NULL),
('Candlewood Suites', 19, '2019-06-02', 116, NULL),
('Candlewood Suites', 19, '2019-06-03', 105, 110),
('Candlewood Suites', 19, '2019-06-04', 114, 110),
('Candlewood Suites', 19, '2019-06-05', 217, 110),
('Candlewood Suites', 19, '2019-06-06', 190, 110),
('Candlewood Suites', 19, '2019-06-07', 210, 110),
('Candlewood Suites', 19, '2019-06-08', 347, 110),
('Candlewood Suites', 19, '2019-06-09', 358, 110),
('Candlewood Suites', 19, '2019-06-10', 123, 110),
('Candlewood Suites', 19, '2019-06-11', 295, 110),
('Candlewood Suites', 19, '2019-06-12', 184, 110),
('Candlewood Suites', 19, '2019-06-13', 162, 110),
('Candlewood Suites', 19, '2019-06-14', 367, 110),
('Candlewood Suites', 19, '2019-06-15', 140, NULL),
('Candlewood Suites', 19, '2019-06-16', 179, NULL),
('Candlewood Suites', 19, '2019-06-17', 233, NULL),
('Candlewood Suites', 19, '2019-06-18', 243, NULL),
('Candlewood Suites', 19, '2019-06-19', 273, NULL),
('Candlewood Suites', 19, '2019-06-20', 154, NULL),
('Candlewood Suites', 19, '2019-06-21', 342, NULL),
('Candlewood Suites', 19, '2019-06-22', 269, NULL),
('Candlewood Suites', 19, '2019-06-23', 133, NULL),
('Candlewood Suites', 19, '2019-06-24', 234, NULL),
('Candlewood Suites', 19, '2019-06-25', 219, NULL),
('Candlewood Suites', 19, '2019-06-26', 341, NULL),
('Candlewood Suites', 19, '2019-06-27', 300, NULL),
('Candlewood Suites', 19, '2019-06-28', 380, NULL),
('Candlewood Suites', 19, '2019-06-29', 278, NULL),
('Candlewood Suites', 19, '2019-06-30', 322, NULL),
('Candlewood Suites', 19, '2019-07-01', 372, NULL),
('Candlewood Suites', 19, '2019-07-02', 332, NULL),
('Candlewood Suites', 19, '2019-07-03', 287, NULL),
('Candlewood Suites', 19, '2019-07-04', 217, NULL),
('Candlewood Suites', 19, '2019-07-05', 153, NULL),
('Candlewood Suites', 19, '2019-07-06', 336, NULL),
('Candlewood Suites', 19, '2019-07-07', 214, NULL),
('Candlewood Suites', 19, '2019-07-08', 182, NULL),
('Candlewood Suites', 19, '2019-07-09', 138, NULL),
('Candlewood Suites', 19, '2019-07-10', 311, NULL),
('Candlewood Suites', 19, '2019-07-11', 293, NULL),
('Candlewood Suites', 19, '2019-07-12', 253, NULL),
('Candlewood Suites', 19, '2019-07-13', 309, NULL),
('Candlewood Suites', 19, '2019-07-14', 332, NULL),
('Candlewood Suites', 19, '2019-07-15', 152, NULL),
('Candlewood Suites', 19, '2019-07-16', 165, NULL),
('Candlewood Suites', 19, '2019-07-17', 365, NULL),
('Candlewood Suites', 19, '2019-07-18', 260, NULL),
('Candlewood Suites', 19, '2019-07-19', 121, NULL),
('Candlewood Suites', 19, '2019-07-20', 368, NULL),
('Candlewood Suites', 19, '2019-07-21', 348, NULL),
('Candlewood Suites', 19, '2019-07-22', 100, NULL),
('Candlewood Suites', 19, '2019-07-23', 326, NULL),
('Candlewood Suites', 19, '2019-07-24', 383, NULL),
('Candlewood Suites', 19, '2019-07-25', 287, NULL),
('Candlewood Suites', 19, '2019-07-26', 223, NULL),
('Candlewood Suites', 19, '2019-07-27', 363, NULL),
('Candlewood Suites', 19, '2019-07-28', 211, NULL),
('Candlewood Suites', 19, '2019-07-29', 312, NULL),
('Candlewood Suites', 19, '2019-07-30', 169, NULL),
('Candlewood Suites', 19, '2019-07-31', 225, NULL),
('Candlewood Suites', 19, '2019-08-01', 303, NULL),
('Candlewood Suites', 19, '2019-08-02', 339, NULL),
('Candlewood Suites', 19, '2019-08-03', 129, NULL),
('Candlewood Suites', 19, '2019-08-04', 280, NULL),
('Candlewood Suites', 19, '2019-08-05', 368, NULL),
('Candlewood Suites', 19, '2019-08-06', 241, NULL),
('Candlewood Suites', 19, '2019-08-07', 351, NULL),
('Candlewood Suites', 19, '2019-08-08', 235, NULL),
('Candlewood Suites', 19, '2019-08-09', 377, NULL),
('Candlewood Suites', 19, '2019-08-10', 303, NULL),
('Candlewood Suites', 19, '2019-08-11', 237, NULL),
('Candlewood Suites', 19, '2019-08-12', 238, NULL),
('Candlewood Suites', 19, '2019-08-13', 286, NULL),
('Candlewood Suites', 19, '2019-08-14', 323, NULL),
('Candlewood Suites', 19, '2019-08-15', 103, NULL),
('Candlewood Suites', 19, '2019-08-16', 286, NULL),
('Candlewood Suites', 19, '2019-08-17', 265, NULL),
('Candlewood Suites', 19, '2019-08-18', 144, NULL),
('Candlewood Suites', 19, '2019-08-19', 392, NULL),
('Candlewood Suites', 19, '2019-08-20', 101, NULL),
('Candlewood Suites', 19, '2019-08-21', 237, NULL),
('Candlewood Suites', 19, '2019-08-22', 298, NULL),
('Candlewood Suites', 19, '2019-08-23', 357, NULL),
('Candlewood Suites', 19, '2019-08-24', 209, NULL),
('Candlewood Suites', 19, '2019-08-25', 334, NULL),
('Candlewood Suites', 19, '2019-08-26', 360, NULL),
('Candlewood Suites', 19, '2019-08-27', 338, 130),
('Candlewood Suites', 19, '2019-08-28', 342, 130),
('Candlewood Suites', 19, '2019-08-29', 197, 130),
('Candlewood Suites', 19, '2019-08-30', 362, 130),
('Candlewood Suites', 19, '2019-08-31', 253, 130),
('Candlewood Suites', 19, '2019-09-01', 185, 130),
('Candlewood Suites', 19, '2019-09-02', 125, NULL),
('Candlewood Suites', 19, '2019-09-03', 173, NULL),
('Candlewood Suites', 19, '2019-09-04', 254, NULL),
('Candlewood Suites', 19, '2019-09-05', 181, NULL),
('Candlewood Suites', 19, '2019-09-06', 205, NULL),
('Candlewood Suites', 19, '2019-09-07', 372, NULL),
('Candlewood Suites', 19, '2019-09-08', 180, NULL),
('Candlewood Suites', 19, '2019-09-09', 316, NULL),
('Candlewood Suites', 19, '2019-09-10', 137, NULL),
('Candlewood Suites', 19, '2019-09-11', 153, NULL),
('Candlewood Suites', 19, '2019-09-12', 104, NULL),
('Candlewood Suites', 19, '2019-09-13', 248, NULL),
('Candlewood Suites', 19, '2019-09-14', 266, NULL),
('Candlewood Suites', 19, '2019-09-15', 206, NULL),
('Candlewood Suites', 19, '2019-09-16', 379, NULL),
('Candlewood Suites', 19, '2019-09-17', 331, NULL),
('Candlewood Suites', 19, '2019-09-18', 117, NULL),
('Candlewood Suites', 19, '2019-09-19', 289, NULL),
('Candlewood Suites', 19, '2019-09-20', 119, NULL),
('Candlewood Suites', 19, '2019-09-21', 285, NULL),
('Candlewood Suites', 19, '2019-09-22', 133, NULL),
('Candlewood Suites', 19, '2019-09-23', 110, NULL),
('Candlewood Suites', 19, '2019-09-24', 113, NULL),
('Candlewood Suites', 19, '2019-09-25', 263, NULL),
('Candlewood Suites', 19, '2019-09-26', 130, NULL),
('Candlewood Suites', 19, '2019-09-27', 270, NULL),
('Candlewood Suites', 19, '2019-09-28', 153, NULL),
('Candlewood Suites', 19, '2019-09-29', 332, NULL),
('Candlewood Suites', 19, '2019-09-30', 221, NULL),
('Candlewood Suites', 19, '2019-10-01', 194, NULL),
('Candlewood Suites', 19, '2019-10-02', 183, NULL),
('Candlewood Suites', 19, '2019-10-03', 346, NULL),
('Candlewood Suites', 19, '2019-10-04', 120, NULL),
('Candlewood Suites', 19, '2019-10-05', 130, NULL),
('Candlewood Suites', 19, '2019-10-06', 164, NULL),
('Candlewood Suites', 19, '2019-10-07', 196, NULL),
('Candlewood Suites', 19, '2019-10-08', 309, NULL),
('Candlewood Suites', 19, '2019-10-09', 141, NULL),
('Candlewood Suites', 19, '2019-10-10', 119, NULL),
('Candlewood Suites', 19, '2019-10-11', 136, NULL),
('Candlewood Suites', 19, '2019-10-12', 118, NULL),
('Candlewood Suites', 19, '2019-10-13', 131, NULL),
('Candlewood Suites', 19, '2019-10-14', 255, NULL),
('Candlewood Suites', 19, '2019-10-15', 317, NULL),
('Candlewood Suites', 19, '2019-10-16', 330, NULL),
('Candlewood Suites', 19, '2019-10-17', 137, NULL),
('Candlewood Suites', 19, '2019-10-18', 141, NULL),
('Candlewood Suites', 19, '2019-10-19', 154, NULL),
('Candlewood Suites', 19, '2019-10-20', 197, NULL),
('Candlewood Suites', 19, '2019-10-21', 394, NULL),
('Candlewood Suites', 19, '2019-10-22', 363, NULL),
('Candlewood Suites', 19, '2019-10-23', 340, 177),
('Candlewood Suites', 19, '2019-10-24', 157, 177),
('Candlewood Suites', 19, '2019-10-25', 157, 177),
('Candlewood Suites', 19, '2019-10-26', 288, 177),
('Candlewood Suites', 19, '2019-10-27', 233, 177),
('Candlewood Suites', 19, '2019-10-28', 182, 177),
('Candlewood Suites', 19, '2019-10-29', 336, 177),
('Candlewood Suites', 19, '2019-10-30', 132, 177),
('Candlewood Suites', 19, '2019-10-31', 214, 177),
('Candlewood Suites', 19, '2019-11-01', 332, NULL),
('Candlewood Suites', 19, '2019-11-02', 161, NULL),
('Candlewood Suites', 19, '2019-11-03', 324, NULL),
('Candlewood Suites', 19, '2019-11-04', 257, NULL),
('Candlewood Suites', 19, '2019-11-05', 101, NULL),
('Candlewood Suites', 19, '2019-11-06', 178, NULL),
('Candlewood Suites', 19, '2019-11-07', 380, NULL),
('Candlewood Suites', 19, '2019-11-08', 169, NULL),
('Candlewood Suites', 19, '2019-11-09', 273, NULL),
('Candlewood Suites', 19, '2019-11-10', 398, NULL),
('Candlewood Suites', 19, '2019-11-11', 294, NULL),
('Candlewood Suites', 19, '2019-11-12', 172, NULL),
('Candlewood Suites', 19, '2019-11-13', 134, 90),
('Candlewood Suites', 19, '2019-11-14', 225, 90),
('Candlewood Suites', 19, '2019-11-15', 271, 90),
('Candlewood Suites', 19, '2019-11-16', 233, 90),
('Candlewood Suites', 19, '2019-11-17', 274, 90),
('Candlewood Suites', 19, '2019-11-18', 243, 90),
('Candlewood Suites', 19, '2019-11-19', 336, 90),
('Candlewood Suites', 19, '2019-11-20', 173, 90),
('Candlewood Suites', 19, '2019-11-21', 197, 90),
('Candlewood Suites', 19, '2019-11-22', 338, 90),
('Candlewood Suites', 19, '2019-11-23', 249, NULL),
('Candlewood Suites', 19, '2019-11-24', 261, NULL),
('Candlewood Suites', 19, '2019-11-25', 204, NULL),
('Candlewood Suites', 19, '2019-11-26', 136, NULL),
('Candlewood Suites', 19, '2019-11-27', 346, NULL),
('Candlewood Suites', 19, '2019-11-28', 161, 118),
('Candlewood Suites', 19, '2019-11-29', 170, 118),
('Candlewood Suites', 19, '2019-11-30', 265, 118),
('Candlewood Suites', 19, '2019-12-01', 221, 118),
('Candlewood Suites', 19, '2019-12-02', 196, 118),
('Candlewood Suites', 19, '2019-12-03', 360, 118),
('Candlewood Suites', 19, '2019-12-04', 117, 118),
('Candlewood Suites', 19, '2019-12-05', 394, 118),
('Candlewood Suites', 19, '2019-12-06', 226, 118),
('Candlewood Suites', 19, '2019-12-07', 263, 118),
('Candlewood Suites', 19, '2019-12-08', 288, 118),
('Candlewood Suites', 19, '2019-12-09', 308, 118),
('Candlewood Suites', 19, '2019-12-10', 133, 118),
('Candlewood Suites', 19, '2019-12-11', 392, 118),
('Candlewood Suites', 19, '2019-12-12', 327, 118),
('Candlewood Suites', 19, '2019-12-13', 392, 118),
('Candlewood Suites', 19, '2019-12-14', 138, 118),
('Candlewood Suites', 19, '2019-12-15', 343, 118),
('Candlewood Suites', 19, '2019-12-16', 117, 118),
('Candlewood Suites', 19, '2019-12-17', 115, 118),
('Candlewood Suites', 19, '2019-12-18', 242, 118),
('Candlewood Suites', 19, '2019-12-19', 181, 118),
('Candlewood Suites', 19, '2019-12-20', 282, 118),
('Candlewood Suites', 19, '2019-12-21', 247, 118),
('Candlewood Suites', 19, '2019-12-22', 288, 118),
('Candlewood Suites', 19, '2019-12-23', 242, 118),
('Candlewood Suites', 19, '2019-12-24', 208, 118),
('Candlewood Suites', 19, '2019-12-25', 168, NULL),
('Candlewood Suites', 19, '2019-12-26', 139, NULL),
('Candlewood Suites', 19, '2019-12-27', 204, NULL),
('Candlewood Suites', 19, '2019-12-28', 330, NULL),
('Candlewood Suites', 19, '2019-12-29', 384, NULL),
('Candlewood Suites', 19, '2019-12-30', 134, NULL),
('Candlewood Suites', 19, '2019-12-31', 171, NULL),
('Candlewood Suites', 19, '2020-01-01', 284, NULL),
('Candlewood Suites', 19, '2020-01-02', 226, NULL),
('Candlewood Suites', 19, '2020-01-03', 237, NULL),
('Candlewood Suites', 19, '2020-01-04', 222, NULL),
('Candlewood Suites', 19, '2020-01-05', 394, NULL),
('Candlewood Suites', 19, '2020-01-06', 118, NULL),
('Candlewood Suites', 19, '2020-01-07', 178, NULL),
('Candlewood Suites', 19, '2020-01-08', 270, NULL),
('Candlewood Suites', 19, '2020-01-09', 251, NULL),
('Candlewood Suites', 19, '2020-01-10', 193, NULL),
('Candlewood Suites', 19, '2020-01-11', 168, NULL),
('Candlewood Suites', 19, '2020-01-12', 137, NULL),
('Candlewood Suites', 19, '2020-01-13', 225, NULL),
('Candlewood Suites', 19, '2020-01-14', 223, NULL),
('Candlewood Suites', 19, '2020-01-15', 329, 200),
('Candlewood Suites', 19, '2020-01-16', 174, 200),
('Candlewood Suites', 19, '2020-01-17', 240, 200),
('Candlewood Suites', 19, '2020-01-18', 178, 200),
('Candlewood Suites', 19, '2020-01-19', 177, 200),
('Candlewood Suites', 19, '2020-01-20', 172, 200),
('Candlewood Suites', 19, '2020-01-21', 204, 200),
('Candlewood Suites', 19, '2020-01-22', 274, 200),
('Candlewood Suites', 19, '2020-01-23', 288, 200),
('Candlewood Suites', 19, '2020-01-24', 355, 200),
('Candlewood Suites', 19, '2020-01-25', 394, 200),
('Candlewood Suites', 19, '2020-01-26', 340, 200),
('Candlewood Suites', 19, '2020-01-27', 258, 200),
('Candlewood Suites', 19, '2020-01-28', 177, 200),
('Candlewood Suites', 19, '2020-01-29', 210, NULL),
('Candlewood Suites', 19, '2020-01-30', 360, NULL),
('Candlewood Suites', 19, '2020-01-31', 310, NULL),
('Candlewood Suites', 19, '2020-02-01', 300, NULL),
('Candlewood Suites', 19, '2020-02-02', 164, NULL),
('Candlewood Suites', 19, '2020-02-03', 163, NULL),
('Candlewood Suites', 19, '2020-02-04', 375, NULL),
('Candlewood Suites', 24, '2019-01-01', 326, NULL),
('Candlewood Suites', 24, '2019-01-02', 392, NULL),
('Candlewood Suites', 24, '2019-01-03', 118, NULL),
('Candlewood Suites', 24, '2019-01-04', 234, NULL),
('Candlewood Suites', 24, '2019-01-05', 350, NULL),
('Candlewood Suites', 24, '2019-01-06', 363, NULL),
('Candlewood Suites', 24, '2019-01-07', 234, NULL),
('Candlewood Suites', 24, '2019-01-08', 264, NULL),
('Candlewood Suites', 24, '2019-01-09', 363, NULL),
('Candlewood Suites', 24, '2019-01-10', 250, NULL),
('Candlewood Suites', 24, '2019-01-11', 112, NULL),
('Candlewood Suites', 24, '2019-01-12', 323, NULL),
('Candlewood Suites', 24, '2019-01-13', 357, NULL),
('Candlewood Suites', 24, '2019-01-14', 243, NULL),
('Candlewood Suites', 24, '2019-01-15', 303, NULL),
('Candlewood Suites', 24, '2019-01-16', 152, NULL),
('Candlewood Suites', 24, '2019-01-17', 296, NULL),
('Candlewood Suites', 24, '2019-01-18', 161, NULL),
('Candlewood Suites', 24, '2019-01-19', 104, NULL),
('Candlewood Suites', 24, '2019-01-20', 340, NULL),
('Candlewood Suites', 24, '2019-01-21', 254, NULL),
('Candlewood Suites', 24, '2019-01-22', 280, NULL),
('Candlewood Suites', 24, '2019-01-23', 353, NULL),
('Candlewood Suites', 24, '2019-01-24', 382, NULL),
('Candlewood Suites', 24, '2019-01-25', 277, NULL),
('Candlewood Suites', 24, '2019-01-26', 293, NULL),
('Candlewood Suites', 24, '2019-01-27', 281, NULL),
('Candlewood Suites', 24, '2019-01-28', 120, NULL),
('Candlewood Suites', 24, '2019-01-29', 162, NULL),
('Candlewood Suites', 24, '2019-01-30', 150, NULL),
('Candlewood Suites', 24, '2019-01-31', 289, NULL),
('Candlewood Suites', 24, '2019-02-01', 139, NULL),
('Candlewood Suites', 24, '2019-02-02', 136, NULL),
('Candlewood Suites', 24, '2019-02-03', 159, NULL),
('Candlewood Suites', 24, '2019-02-04', 343, NULL),
('Candlewood Suites', 24, '2019-02-05', 243, NULL),
('Candlewood Suites', 24, '2019-02-06', 347, NULL),
('Candlewood Suites', 24, '2019-02-07', 168, NULL),
('Candlewood Suites', 24, '2019-02-08', 305, NULL),
('Candlewood Suites', 24, '2019-02-09', 114, NULL),
('Candlewood Suites', 24, '2019-02-10', 391, NULL),
('Candlewood Suites', 24, '2019-02-11', 256, NULL),
('Candlewood Suites', 24, '2019-02-12', 265, NULL),
('Candlewood Suites', 24, '2019-02-13', 392, NULL),
('Candlewood Suites', 24, '2019-02-14', 327, NULL),
('Candlewood Suites', 24, '2019-02-15', 274, NULL),
('Candlewood Suites', 24, '2019-02-16', 361, NULL),
('Candlewood Suites', 24, '2019-02-17', 353, NULL),
('Candlewood Suites', 24, '2019-02-18', 356, NULL),
('Candlewood Suites', 24, '2019-02-19', 392, NULL),
('Candlewood Suites', 24, '2019-02-20', 142, NULL),
('Candlewood Suites', 24, '2019-02-21', 122, NULL),
('Candlewood Suites', 24, '2019-02-22', 272, NULL),
('Candlewood Suites', 24, '2019-02-23', 235, NULL),
('Candlewood Suites', 24, '2019-02-24', 268, NULL),
('Candlewood Suites', 24, '2019-02-25', 336, NULL),
('Candlewood Suites', 24, '2019-02-26', 254, NULL),
('Candlewood Suites', 24, '2019-02-27', 167, NULL),
('Candlewood Suites', 24, '2019-02-28', 102, NULL),
('Candlewood Suites', 24, '2019-03-01', 383, NULL),
('Candlewood Suites', 24, '2019-03-02', 231, NULL),
('Candlewood Suites', 24, '2019-03-03', 161, NULL),
('Candlewood Suites', 24, '2019-03-04', 268, NULL),
('Candlewood Suites', 24, '2019-03-05', 200, NULL),
('Candlewood Suites', 24, '2019-03-06', 341, NULL),
('Candlewood Suites', 24, '2019-03-07', 162, NULL),
('Candlewood Suites', 24, '2019-03-08', 278, NULL),
('Candlewood Suites', 24, '2019-03-09', 287, NULL),
('Candlewood Suites', 24, '2019-03-10', 152, NULL),
('Candlewood Suites', 24, '2019-03-11', 245, NULL),
('Candlewood Suites', 24, '2019-03-12', 377, NULL),
('Candlewood Suites', 24, '2019-03-13', 272, NULL),
('Candlewood Suites', 24, '2019-03-14', 185, NULL),
('Candlewood Suites', 24, '2019-03-15', 200, NULL),
('Candlewood Suites', 24, '2019-03-16', 201, NULL),
('Candlewood Suites', 24, '2019-03-17', 118, NULL),
('Candlewood Suites', 24, '2019-03-18', 357, NULL),
('Candlewood Suites', 24, '2019-03-19', 279, NULL),
('Candlewood Suites', 24, '2019-03-20', 336, NULL),
('Candlewood Suites', 24, '2019-03-21', 133, NULL),
('Candlewood Suites', 24, '2019-03-22', 119, NULL),
('Candlewood Suites', 24, '2019-03-23', 201, NULL),
('Candlewood Suites', 24, '2019-03-24', 144, NULL),
('Candlewood Suites', 24, '2019-03-25', 163, NULL),
('Candlewood Suites', 24, '2019-03-26', 209, NULL),
('Candlewood Suites', 24, '2019-03-27', 193, NULL),
('Candlewood Suites', 24, '2019-03-28', 383, NULL),
('Candlewood Suites', 24, '2019-03-29', 287, NULL),
('Candlewood Suites', 24, '2019-03-30', 299, NULL),
('Candlewood Suites', 24, '2019-03-31', 325, NULL),
('Candlewood Suites', 24, '2019-04-01', 253, NULL),
('Candlewood Suites', 24, '2019-04-02', 305, NULL),
('Candlewood Suites', 24, '2019-04-03', 120, NULL),
('Candlewood Suites', 24, '2019-04-04', 248, NULL),
('Candlewood Suites', 24, '2019-04-05', 205, NULL),
('Candlewood Suites', 24, '2019-04-06', 386, NULL),
('Candlewood Suites', 24, '2019-04-07', 212, NULL),
('Candlewood Suites', 24, '2019-04-08', 159, NULL),
('Candlewood Suites', 24, '2019-04-09', 380, NULL),
('Candlewood Suites', 24, '2019-04-10', 329, NULL),
('Candlewood Suites', 24, '2019-04-11', 310, NULL),
('Candlewood Suites', 24, '2019-04-12', 104, NULL),
('Candlewood Suites', 24, '2019-04-13', 143, NULL),
('Candlewood Suites', 24, '2019-04-14', 248, NULL),
('Candlewood Suites', 24, '2019-04-15', 183, NULL),
('Candlewood Suites', 24, '2019-04-16', 385, NULL),
('Candlewood Suites', 24, '2019-04-17', 262, NULL),
('Candlewood Suites', 24, '2019-04-18', 297, NULL),
('Candlewood Suites', 24, '2019-04-19', 205, NULL),
('Candlewood Suites', 24, '2019-04-20', 137, NULL),
('Candlewood Suites', 24, '2019-04-21', 235, NULL),
('Candlewood Suites', 24, '2019-04-22', 329, NULL),
('Candlewood Suites', 24, '2019-04-23', 302, NULL),
('Candlewood Suites', 24, '2019-04-24', 166, NULL),
('Candlewood Suites', 24, '2019-04-25', 159, NULL),
('Candlewood Suites', 24, '2019-04-26', 373, NULL),
('Candlewood Suites', 24, '2019-04-27', 185, NULL),
('Candlewood Suites', 24, '2019-04-28', 267, NULL),
('Candlewood Suites', 24, '2019-04-29', 129, NULL),
('Candlewood Suites', 24, '2019-04-30', 208, NULL),
('Candlewood Suites', 24, '2019-05-01', 185, NULL),
('Candlewood Suites', 24, '2019-05-02', 348, NULL),
('Candlewood Suites', 24, '2019-05-03', 352, NULL),
('Candlewood Suites', 24, '2019-05-04', 350, NULL),
('Candlewood Suites', 24, '2019-05-05', 255, NULL),
('Candlewood Suites', 24, '2019-05-06', 314, NULL),
('Candlewood Suites', 24, '2019-05-07', 124, NULL),
('Candlewood Suites', 24, '2019-05-08', 112, NULL),
('Candlewood Suites', 24, '2019-05-09', 237, NULL),
('Candlewood Suites', 24, '2019-05-10', 326, NULL),
('Candlewood Suites', 24, '2019-05-11', 104, NULL),
('Candlewood Suites', 24, '2019-05-12', 185, NULL),
('Candlewood Suites', 24, '2019-05-13', 332, NULL),
('Candlewood Suites', 24, '2019-05-14', 295, NULL),
('Candlewood Suites', 24, '2019-05-15', 245, NULL),
('Candlewood Suites', 24, '2019-05-16', 277, NULL),
('Candlewood Suites', 24, '2019-05-17', 396, NULL),
('Candlewood Suites', 24, '2019-05-18', 111, NULL),
('Candlewood Suites', 24, '2019-05-19', 322, NULL),
('Candlewood Suites', 24, '2019-05-20', 173, NULL),
('Candlewood Suites', 24, '2019-05-21', 120, NULL),
('Candlewood Suites', 24, '2019-05-22', 336, NULL),
('Candlewood Suites', 24, '2019-05-23', 181, NULL),
('Candlewood Suites', 24, '2019-05-24', 176, NULL),
('Candlewood Suites', 24, '2019-05-25', 126, NULL),
('Candlewood Suites', 24, '2019-05-26', 347, NULL),
('Candlewood Suites', 24, '2019-05-27', 101, NULL),
('Candlewood Suites', 24, '2019-05-28', 361, NULL),
('Candlewood Suites', 24, '2019-05-29', 262, NULL),
('Candlewood Suites', 24, '2019-05-30', 278, NULL),
('Candlewood Suites', 24, '2019-05-31', 189, NULL),
('Candlewood Suites', 24, '2019-06-01', 295, NULL),
('Candlewood Suites', 24, '2019-06-02', 152, NULL),
('Candlewood Suites', 24, '2019-06-03', 223, NULL),
('Candlewood Suites', 24, '2019-06-04', 242, NULL),
('Candlewood Suites', 24, '2019-06-05', 368, NULL),
('Candlewood Suites', 24, '2019-06-06', 397, NULL),
('Candlewood Suites', 24, '2019-06-07', 257, NULL),
('Candlewood Suites', 24, '2019-06-08', 180, NULL),
('Candlewood Suites', 24, '2019-06-09', 378, NULL),
('Candlewood Suites', 24, '2019-06-10', 137, NULL),
('Candlewood Suites', 24, '2019-06-11', 380, NULL),
('Candlewood Suites', 24, '2019-06-12', 265, NULL),
('Candlewood Suites', 24, '2019-06-13', 290, NULL),
('Candlewood Suites', 24, '2019-06-14', 167, NULL),
('Candlewood Suites', 24, '2019-06-15', 248, NULL),
('Candlewood Suites', 24, '2019-06-16', 321, NULL),
('Candlewood Suites', 24, '2019-06-17', 211, NULL),
('Candlewood Suites', 24, '2019-06-18', 201, NULL),
('Candlewood Suites', 24, '2019-06-19', 144, NULL),
('Candlewood Suites', 24, '2019-06-20', 251, NULL),
('Candlewood Suites', 24, '2019-06-21', 178, NULL),
('Candlewood Suites', 24, '2019-06-22', 246, NULL),
('Candlewood Suites', 24, '2019-06-23', 365, NULL),
('Candlewood Suites', 24, '2019-06-24', 389, NULL),
('Candlewood Suites', 24, '2019-06-25', 237, NULL),
('Candlewood Suites', 24, '2019-06-26', 348, NULL),
('Candlewood Suites', 24, '2019-06-27', 243, NULL),
('Candlewood Suites', 24, '2019-06-28', 260, NULL),
('Candlewood Suites', 24, '2019-06-29', 100, NULL),
('Candlewood Suites', 24, '2019-06-30', 333, NULL),
('Candlewood Suites', 24, '2019-07-01', 355, NULL),
('Candlewood Suites', 24, '2019-07-02', 308, NULL),
('Candlewood Suites', 24, '2019-07-03', 187, NULL),
('Candlewood Suites', 24, '2019-07-04', 178, NULL),
('Candlewood Suites', 24, '2019-07-05', 281, NULL),
('Candlewood Suites', 24, '2019-07-06', 208, NULL),
('Candlewood Suites', 24, '2019-07-07', 220, NULL),
('Candlewood Suites', 24, '2019-07-08', 168, NULL),
('Candlewood Suites', 24, '2019-07-09', 196, NULL),
('Candlewood Suites', 24, '2019-07-10', 133, NULL),
('Candlewood Suites', 24, '2019-07-11', 172, NULL),
('Candlewood Suites', 24, '2019-07-12', 172, NULL),
('Candlewood Suites', 24, '2019-07-13', 299, NULL),
('Candlewood Suites', 24, '2019-07-14', 227, NULL),
('Candlewood Suites', 24, '2019-07-15', 261, NULL),
('Candlewood Suites', 24, '2019-07-16', 182, NULL),
('Candlewood Suites', 24, '2019-07-17', 295, NULL),
('Candlewood Suites', 24, '2019-07-18', 359, NULL),
('Candlewood Suites', 24, '2019-07-19', 179, NULL),
('Candlewood Suites', 24, '2019-07-20', 105, NULL),
('Candlewood Suites', 24, '2019-07-21', 391, NULL),
('Candlewood Suites', 24, '2019-07-22', 370, NULL),
('Candlewood Suites', 24, '2019-07-23', 375, NULL),
('Candlewood Suites', 24, '2019-07-24', 274, NULL),
('Candlewood Suites', 24, '2019-07-25', 214, NULL),
('Candlewood Suites', 24, '2019-07-26', 316, NULL),
('Candlewood Suites', 24, '2019-07-27', 293, NULL),
('Candlewood Suites', 24, '2019-07-28', 345, NULL),
('Candlewood Suites', 24, '2019-07-29', 220, NULL),
('Candlewood Suites', 24, '2019-07-30', 252, NULL),
('Candlewood Suites', 24, '2019-07-31', 192, NULL),
('Candlewood Suites', 24, '2019-08-01', 386, NULL),
('Candlewood Suites', 24, '2019-08-02', 133, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 24, '2019-08-03', 111, NULL),
('Candlewood Suites', 24, '2019-08-04', 309, NULL),
('Candlewood Suites', 24, '2019-08-05', 319, NULL),
('Candlewood Suites', 24, '2019-08-06', 155, NULL),
('Candlewood Suites', 24, '2019-08-07', 359, NULL),
('Candlewood Suites', 24, '2019-08-08', 202, NULL),
('Candlewood Suites', 24, '2019-08-09', 352, NULL),
('Candlewood Suites', 24, '2019-08-10', 107, NULL),
('Candlewood Suites', 24, '2019-08-11', 257, NULL),
('Candlewood Suites', 24, '2019-08-12', 255, NULL),
('Candlewood Suites', 24, '2019-08-13', 229, NULL),
('Candlewood Suites', 24, '2019-08-14', 338, NULL),
('Candlewood Suites', 24, '2019-08-15', 209, NULL),
('Candlewood Suites', 24, '2019-08-16', 140, NULL),
('Candlewood Suites', 24, '2019-08-17', 303, NULL),
('Candlewood Suites', 24, '2019-08-18', 395, NULL),
('Candlewood Suites', 24, '2019-08-19', 259, NULL),
('Candlewood Suites', 24, '2019-08-20', 271, NULL),
('Candlewood Suites', 24, '2019-08-21', 384, NULL),
('Candlewood Suites', 24, '2019-08-22', 145, NULL),
('Candlewood Suites', 24, '2019-08-23', 365, NULL),
('Candlewood Suites', 24, '2019-08-24', 236, NULL),
('Candlewood Suites', 24, '2019-08-25', 165, NULL),
('Candlewood Suites', 24, '2019-08-26', 206, NULL),
('Candlewood Suites', 24, '2019-08-27', 238, NULL),
('Candlewood Suites', 24, '2019-08-28', 262, NULL),
('Candlewood Suites', 24, '2019-08-29', 153, NULL),
('Candlewood Suites', 24, '2019-08-30', 116, NULL),
('Candlewood Suites', 24, '2019-08-31', 195, NULL),
('Candlewood Suites', 24, '2019-09-01', 176, NULL),
('Candlewood Suites', 24, '2019-09-02', 348, NULL),
('Candlewood Suites', 24, '2019-09-03', 113, NULL),
('Candlewood Suites', 24, '2019-09-04', 106, NULL),
('Candlewood Suites', 24, '2019-09-05', 208, NULL),
('Candlewood Suites', 24, '2019-09-06', 369, NULL),
('Candlewood Suites', 24, '2019-09-07', 351, NULL),
('Candlewood Suites', 24, '2019-09-08', 228, NULL),
('Candlewood Suites', 24, '2019-09-09', 200, NULL),
('Candlewood Suites', 24, '2019-09-10', 398, NULL),
('Candlewood Suites', 24, '2019-09-11', 240, NULL),
('Candlewood Suites', 24, '2019-09-12', 263, NULL),
('Candlewood Suites', 24, '2019-09-13', 114, NULL),
('Candlewood Suites', 24, '2019-09-14', 286, NULL),
('Candlewood Suites', 24, '2019-09-15', 369, NULL),
('Candlewood Suites', 24, '2019-09-16', 186, NULL),
('Candlewood Suites', 24, '2019-09-17', 370, NULL),
('Candlewood Suites', 24, '2019-09-18', 280, NULL),
('Candlewood Suites', 24, '2019-09-19', 279, NULL),
('Candlewood Suites', 24, '2019-09-20', 397, NULL),
('Candlewood Suites', 24, '2019-09-21', 391, NULL),
('Candlewood Suites', 24, '2019-09-22', 337, NULL),
('Candlewood Suites', 24, '2019-09-23', 292, NULL),
('Candlewood Suites', 24, '2019-09-24', 278, NULL),
('Candlewood Suites', 24, '2019-09-25', 317, NULL),
('Candlewood Suites', 24, '2019-09-26', 145, NULL),
('Candlewood Suites', 24, '2019-09-27', 262, NULL),
('Candlewood Suites', 24, '2019-09-28', 186, NULL),
('Candlewood Suites', 24, '2019-09-29', 383, NULL),
('Candlewood Suites', 24, '2019-09-30', 314, NULL),
('Candlewood Suites', 24, '2019-10-01', 224, NULL),
('Candlewood Suites', 24, '2019-10-02', 185, NULL),
('Candlewood Suites', 24, '2019-10-03', 285, NULL),
('Candlewood Suites', 24, '2019-10-04', 321, NULL),
('Candlewood Suites', 24, '2019-10-05', 230, NULL),
('Candlewood Suites', 24, '2019-10-06', 369, NULL),
('Candlewood Suites', 24, '2019-10-07', 181, NULL),
('Candlewood Suites', 24, '2019-10-08', 320, NULL),
('Candlewood Suites', 24, '2019-10-09', 194, NULL),
('Candlewood Suites', 24, '2019-10-10', 155, NULL),
('Candlewood Suites', 24, '2019-10-11', 192, NULL),
('Candlewood Suites', 24, '2019-10-12', 181, NULL),
('Candlewood Suites', 24, '2019-10-13', 162, NULL),
('Candlewood Suites', 24, '2019-10-14', 246, NULL),
('Candlewood Suites', 24, '2019-10-15', 238, NULL),
('Candlewood Suites', 24, '2019-10-16', 179, NULL),
('Candlewood Suites', 24, '2019-10-17', 123, NULL),
('Candlewood Suites', 24, '2019-10-18', 167, NULL),
('Candlewood Suites', 24, '2019-10-19', 337, NULL),
('Candlewood Suites', 24, '2019-10-20', 349, NULL),
('Candlewood Suites', 24, '2019-10-21', 101, NULL),
('Candlewood Suites', 24, '2019-10-22', 352, NULL),
('Candlewood Suites', 24, '2019-10-23', 311, NULL),
('Candlewood Suites', 24, '2019-10-24', 298, NULL),
('Candlewood Suites', 24, '2019-10-25', 283, NULL),
('Candlewood Suites', 24, '2019-10-26', 160, NULL),
('Candlewood Suites', 24, '2019-10-27', 200, NULL),
('Candlewood Suites', 24, '2019-10-28', 212, NULL),
('Candlewood Suites', 24, '2019-10-29', 210, NULL),
('Candlewood Suites', 24, '2019-10-30', 308, NULL),
('Candlewood Suites', 24, '2019-10-31', 335, NULL),
('Candlewood Suites', 24, '2019-11-01', 254, NULL),
('Candlewood Suites', 24, '2019-11-02', 343, NULL),
('Candlewood Suites', 24, '2019-11-03', 242, NULL),
('Candlewood Suites', 24, '2019-11-04', 352, NULL),
('Candlewood Suites', 24, '2019-11-05', 321, NULL),
('Candlewood Suites', 24, '2019-11-06', 119, NULL),
('Candlewood Suites', 24, '2019-11-07', 190, NULL),
('Candlewood Suites', 24, '2019-11-08', 340, NULL),
('Candlewood Suites', 24, '2019-11-09', 144, NULL),
('Candlewood Suites', 24, '2019-11-10', 115, NULL),
('Candlewood Suites', 24, '2019-11-11', 278, NULL),
('Candlewood Suites', 24, '2019-11-12', 235, NULL),
('Candlewood Suites', 24, '2019-11-13', 140, NULL),
('Candlewood Suites', 24, '2019-11-14', 351, NULL),
('Candlewood Suites', 24, '2019-11-15', 169, NULL),
('Candlewood Suites', 24, '2019-11-16', 293, NULL),
('Candlewood Suites', 24, '2019-11-17', 270, NULL),
('Candlewood Suites', 24, '2019-11-18', 108, NULL),
('Candlewood Suites', 24, '2019-11-19', 255, NULL),
('Candlewood Suites', 24, '2019-11-20', 381, NULL),
('Candlewood Suites', 24, '2019-11-21', 125, NULL),
('Candlewood Suites', 24, '2019-11-22', 256, NULL),
('Candlewood Suites', 24, '2019-11-23', 132, NULL),
('Candlewood Suites', 24, '2019-11-24', 339, NULL),
('Candlewood Suites', 24, '2019-11-25', 101, NULL),
('Candlewood Suites', 24, '2019-11-26', 387, 136),
('Candlewood Suites', 24, '2019-11-27', 280, 136),
('Candlewood Suites', 24, '2019-11-28', 226, 136),
('Candlewood Suites', 24, '2019-11-29', 229, 136),
('Candlewood Suites', 24, '2019-11-30', 124, 136),
('Candlewood Suites', 24, '2019-12-01', 112, 136),
('Candlewood Suites', 24, '2019-12-02', 377, 136),
('Candlewood Suites', 24, '2019-12-03', 125, 136),
('Candlewood Suites', 24, '2019-12-04', 161, 136),
('Candlewood Suites', 24, '2019-12-05', 160, 136),
('Candlewood Suites', 24, '2019-12-06', 345, 136),
('Candlewood Suites', 24, '2019-12-07', 161, 136),
('Candlewood Suites', 24, '2019-12-08', 229, 136),
('Candlewood Suites', 24, '2019-12-09', 286, 136),
('Candlewood Suites', 24, '2019-12-10', 210, 136),
('Candlewood Suites', 24, '2019-12-11', 102, 136),
('Candlewood Suites', 24, '2019-12-12', 327, 136),
('Candlewood Suites', 24, '2019-12-13', 241, 136),
('Candlewood Suites', 24, '2019-12-14', 141, 136),
('Candlewood Suites', 24, '2019-12-15', 241, 136),
('Candlewood Suites', 24, '2019-12-16', 343, 136),
('Candlewood Suites', 24, '2019-12-17', 198, 136),
('Candlewood Suites', 24, '2019-12-18', 293, 136),
('Candlewood Suites', 24, '2019-12-19', 315, 136),
('Candlewood Suites', 24, '2019-12-20', 332, 136),
('Candlewood Suites', 24, '2019-12-21', 251, 136),
('Candlewood Suites', 24, '2019-12-22', 122, 136),
('Candlewood Suites', 24, '2019-12-23', 382, 136),
('Candlewood Suites', 24, '2019-12-24', 354, NULL),
('Candlewood Suites', 24, '2019-12-25', 164, NULL),
('Candlewood Suites', 24, '2019-12-26', 334, NULL),
('Candlewood Suites', 24, '2019-12-27', 175, NULL),
('Candlewood Suites', 24, '2019-12-28', 145, NULL),
('Candlewood Suites', 24, '2019-12-29', 329, NULL),
('Candlewood Suites', 24, '2019-12-30', 118, NULL),
('Candlewood Suites', 24, '2019-12-31', 292, NULL),
('Candlewood Suites', 24, '2020-01-01', 111, NULL),
('Candlewood Suites', 24, '2020-01-02', 355, NULL),
('Candlewood Suites', 24, '2020-01-03', 272, NULL),
('Candlewood Suites', 24, '2020-01-04', 386, NULL),
('Candlewood Suites', 24, '2020-01-05', 354, NULL),
('Candlewood Suites', 24, '2020-01-06', 168, NULL),
('Candlewood Suites', 24, '2020-01-07', 303, NULL),
('Candlewood Suites', 24, '2020-01-08', 366, NULL),
('Candlewood Suites', 24, '2020-01-09', 275, NULL),
('Candlewood Suites', 24, '2020-01-10', 237, NULL),
('Candlewood Suites', 24, '2020-01-11', 291, NULL),
('Candlewood Suites', 24, '2020-01-12', 392, NULL),
('Candlewood Suites', 24, '2020-01-13', 296, NULL),
('Candlewood Suites', 24, '2020-01-14', 122, NULL),
('Candlewood Suites', 24, '2020-01-15', 393, NULL),
('Candlewood Suites', 24, '2020-01-16', 212, NULL),
('Candlewood Suites', 24, '2020-01-17', 136, NULL),
('Candlewood Suites', 24, '2020-01-18', 378, NULL),
('Candlewood Suites', 24, '2020-01-19', 155, NULL),
('Candlewood Suites', 24, '2020-01-20', 122, NULL),
('Candlewood Suites', 24, '2020-01-21', 392, NULL),
('Candlewood Suites', 24, '2020-01-22', 339, NULL),
('Candlewood Suites', 24, '2020-01-23', 128, NULL),
('Candlewood Suites', 24, '2020-01-24', 298, NULL),
('Candlewood Suites', 24, '2020-01-25', 305, NULL),
('Candlewood Suites', 24, '2020-01-26', 297, NULL),
('Candlewood Suites', 24, '2020-01-27', 334, NULL),
('Candlewood Suites', 24, '2020-01-28', 340, NULL),
('Candlewood Suites', 24, '2020-01-29', 312, NULL),
('Candlewood Suites', 24, '2020-01-30', 386, NULL),
('Candlewood Suites', 24, '2020-01-31', 269, NULL),
('Candlewood Suites', 24, '2020-02-01', 214, NULL),
('Candlewood Suites', 24, '2020-02-02', 275, NULL),
('Candlewood Suites', 24, '2020-02-03', 178, NULL),
('Candlewood Suites', 24, '2020-02-04', 282, NULL),
('Candlewood Suites', 48, '2019-01-01', 134, NULL),
('Candlewood Suites', 48, '2019-01-02', 127, NULL),
('Candlewood Suites', 48, '2019-01-03', 289, NULL),
('Candlewood Suites', 48, '2019-01-04', 308, NULL),
('Candlewood Suites', 48, '2019-01-05', 398, NULL),
('Candlewood Suites', 48, '2019-01-06', 239, NULL),
('Candlewood Suites', 48, '2019-01-07', 107, NULL),
('Candlewood Suites', 48, '2019-01-08', 119, NULL),
('Candlewood Suites', 48, '2019-01-09', 307, NULL),
('Candlewood Suites', 48, '2019-01-10', 257, NULL),
('Candlewood Suites', 48, '2019-01-11', 201, NULL),
('Candlewood Suites', 48, '2019-01-12', 109, NULL),
('Candlewood Suites', 48, '2019-01-13', 152, NULL),
('Candlewood Suites', 48, '2019-01-14', 260, NULL),
('Candlewood Suites', 48, '2019-01-15', 382, NULL),
('Candlewood Suites', 48, '2019-01-16', 207, NULL),
('Candlewood Suites', 48, '2019-01-17', 117, NULL),
('Candlewood Suites', 48, '2019-01-18', 162, NULL),
('Candlewood Suites', 48, '2019-01-19', 237, NULL),
('Candlewood Suites', 48, '2019-01-20', 194, NULL),
('Candlewood Suites', 48, '2019-01-21', 214, NULL),
('Candlewood Suites', 48, '2019-01-22', 113, NULL),
('Candlewood Suites', 48, '2019-01-23', 204, NULL),
('Candlewood Suites', 48, '2019-01-24', 224, NULL),
('Candlewood Suites', 48, '2019-01-25', 224, NULL),
('Candlewood Suites', 48, '2019-01-26', 364, NULL),
('Candlewood Suites', 48, '2019-01-27', 141, NULL),
('Candlewood Suites', 48, '2019-01-28', 295, NULL),
('Candlewood Suites', 48, '2019-01-29', 289, NULL),
('Candlewood Suites', 48, '2019-01-30', 333, NULL),
('Candlewood Suites', 48, '2019-01-31', 137, NULL),
('Candlewood Suites', 48, '2019-02-01', 160, NULL),
('Candlewood Suites', 48, '2019-02-02', 184, NULL),
('Candlewood Suites', 48, '2019-02-03', 101, NULL),
('Candlewood Suites', 48, '2019-02-04', 145, NULL),
('Candlewood Suites', 48, '2019-02-05', 262, NULL),
('Candlewood Suites', 48, '2019-02-06', 147, NULL),
('Candlewood Suites', 48, '2019-02-07', 119, NULL),
('Candlewood Suites', 48, '2019-02-08', 207, NULL),
('Candlewood Suites', 48, '2019-02-09', 370, NULL),
('Candlewood Suites', 48, '2019-02-10', 146, NULL),
('Candlewood Suites', 48, '2019-02-11', 356, NULL),
('Candlewood Suites', 48, '2019-02-12', 262, NULL),
('Candlewood Suites', 48, '2019-02-13', 232, NULL),
('Candlewood Suites', 48, '2019-02-14', 285, NULL),
('Candlewood Suites', 48, '2019-02-15', 198, NULL),
('Candlewood Suites', 48, '2019-02-16', 318, NULL),
('Candlewood Suites', 48, '2019-02-17', 361, NULL),
('Candlewood Suites', 48, '2019-02-18', 396, NULL),
('Candlewood Suites', 48, '2019-02-19', 235, NULL),
('Candlewood Suites', 48, '2019-02-20', 375, NULL),
('Candlewood Suites', 48, '2019-02-21', 212, NULL),
('Candlewood Suites', 48, '2019-02-22', 212, NULL),
('Candlewood Suites', 48, '2019-02-23', 103, NULL),
('Candlewood Suites', 48, '2019-02-24', 392, NULL),
('Candlewood Suites', 48, '2019-02-25', 224, NULL),
('Candlewood Suites', 48, '2019-02-26', 130, NULL),
('Candlewood Suites', 48, '2019-02-27', 255, NULL),
('Candlewood Suites', 48, '2019-02-28', 110, NULL),
('Candlewood Suites', 48, '2019-03-01', 303, NULL),
('Candlewood Suites', 48, '2019-03-02', 364, NULL),
('Candlewood Suites', 48, '2019-03-03', 179, NULL),
('Candlewood Suites', 48, '2019-03-04', 174, NULL),
('Candlewood Suites', 48, '2019-03-05', 388, NULL),
('Candlewood Suites', 48, '2019-03-06', 234, NULL),
('Candlewood Suites', 48, '2019-03-07', 246, NULL),
('Candlewood Suites', 48, '2019-03-08', 152, NULL),
('Candlewood Suites', 48, '2019-03-09', 122, NULL),
('Candlewood Suites', 48, '2019-03-10', 303, NULL),
('Candlewood Suites', 48, '2019-03-11', 262, NULL),
('Candlewood Suites', 48, '2019-03-12', 343, NULL),
('Candlewood Suites', 48, '2019-03-13', 255, NULL),
('Candlewood Suites', 48, '2019-03-14', 355, NULL),
('Candlewood Suites', 48, '2019-03-15', 165, NULL),
('Candlewood Suites', 48, '2019-03-16', 399, NULL),
('Candlewood Suites', 48, '2019-03-17', 294, NULL),
('Candlewood Suites', 48, '2019-03-18', 134, NULL),
('Candlewood Suites', 48, '2019-03-19', 145, NULL),
('Candlewood Suites', 48, '2019-03-20', 357, NULL),
('Candlewood Suites', 48, '2019-03-21', 268, NULL),
('Candlewood Suites', 48, '2019-03-22', 187, NULL),
('Candlewood Suites', 48, '2019-03-23', 223, NULL),
('Candlewood Suites', 48, '2019-03-24', 147, NULL),
('Candlewood Suites', 48, '2019-03-25', 161, NULL),
('Candlewood Suites', 48, '2019-03-26', 101, NULL),
('Candlewood Suites', 48, '2019-03-27', 111, NULL),
('Candlewood Suites', 48, '2019-03-28', 360, NULL),
('Candlewood Suites', 48, '2019-03-29', 354, NULL),
('Candlewood Suites', 48, '2019-03-30', 349, NULL),
('Candlewood Suites', 48, '2019-03-31', 186, NULL),
('Candlewood Suites', 48, '2019-04-01', 186, NULL),
('Candlewood Suites', 48, '2019-04-02', 223, NULL),
('Candlewood Suites', 48, '2019-04-03', 134, NULL),
('Candlewood Suites', 48, '2019-04-04', 340, NULL),
('Candlewood Suites', 48, '2019-04-05', 265, NULL),
('Candlewood Suites', 48, '2019-04-06', 240, NULL),
('Candlewood Suites', 48, '2019-04-07', 102, NULL),
('Candlewood Suites', 48, '2019-04-08', 221, NULL),
('Candlewood Suites', 48, '2019-04-09', 153, NULL),
('Candlewood Suites', 48, '2019-04-10', 245, NULL),
('Candlewood Suites', 48, '2019-04-11', 308, NULL),
('Candlewood Suites', 48, '2019-04-12', 358, NULL),
('Candlewood Suites', 48, '2019-04-13', 350, NULL),
('Candlewood Suites', 48, '2019-04-14', 298, NULL),
('Candlewood Suites', 48, '2019-04-15', 369, NULL),
('Candlewood Suites', 48, '2019-04-16', 222, NULL),
('Candlewood Suites', 48, '2019-04-17', 218, NULL),
('Candlewood Suites', 48, '2019-04-18', 168, NULL),
('Candlewood Suites', 48, '2019-04-19', 292, NULL),
('Candlewood Suites', 48, '2019-04-20', 277, NULL),
('Candlewood Suites', 48, '2019-04-21', 264, NULL),
('Candlewood Suites', 48, '2019-04-22', 212, NULL),
('Candlewood Suites', 48, '2019-04-23', 222, NULL),
('Candlewood Suites', 48, '2019-04-24', 319, NULL),
('Candlewood Suites', 48, '2019-04-25', 202, NULL),
('Candlewood Suites', 48, '2019-04-26', 106, NULL),
('Candlewood Suites', 48, '2019-04-27', 157, NULL),
('Candlewood Suites', 48, '2019-04-28', 120, NULL),
('Candlewood Suites', 48, '2019-04-29', 190, NULL),
('Candlewood Suites', 48, '2019-04-30', 298, NULL),
('Candlewood Suites', 48, '2019-05-01', 260, NULL),
('Candlewood Suites', 48, '2019-05-02', 296, NULL),
('Candlewood Suites', 48, '2019-05-03', 330, NULL),
('Candlewood Suites', 48, '2019-05-04', 293, NULL),
('Candlewood Suites', 48, '2019-05-05', 140, NULL),
('Candlewood Suites', 48, '2019-05-06', 147, NULL),
('Candlewood Suites', 48, '2019-05-07', 176, NULL),
('Candlewood Suites', 48, '2019-05-08', 371, NULL),
('Candlewood Suites', 48, '2019-05-09', 347, NULL),
('Candlewood Suites', 48, '2019-05-10', 266, NULL),
('Candlewood Suites', 48, '2019-05-11', 248, NULL),
('Candlewood Suites', 48, '2019-05-12', 307, NULL),
('Candlewood Suites', 48, '2019-05-13', 162, NULL),
('Candlewood Suites', 48, '2019-05-14', 174, NULL),
('Candlewood Suites', 48, '2019-05-15', 329, NULL),
('Candlewood Suites', 48, '2019-05-16', 326, NULL),
('Candlewood Suites', 48, '2019-05-17', 211, NULL),
('Candlewood Suites', 48, '2019-05-18', 104, NULL),
('Candlewood Suites', 48, '2019-05-19', 272, NULL),
('Candlewood Suites', 48, '2019-05-20', 209, NULL),
('Candlewood Suites', 48, '2019-05-21', 145, NULL),
('Candlewood Suites', 48, '2019-05-22', 118, NULL),
('Candlewood Suites', 48, '2019-05-23', 348, NULL),
('Candlewood Suites', 48, '2019-05-24', 223, NULL),
('Candlewood Suites', 48, '2019-05-25', 243, NULL),
('Candlewood Suites', 48, '2019-05-26', 122, NULL),
('Candlewood Suites', 48, '2019-05-27', 364, NULL),
('Candlewood Suites', 48, '2019-05-28', 301, NULL),
('Candlewood Suites', 48, '2019-05-29', 309, NULL),
('Candlewood Suites', 48, '2019-05-30', 274, NULL),
('Candlewood Suites', 48, '2019-05-31', 217, NULL),
('Candlewood Suites', 48, '2019-06-01', 163, NULL),
('Candlewood Suites', 48, '2019-06-02', 312, NULL),
('Candlewood Suites', 48, '2019-06-03', 101, NULL),
('Candlewood Suites', 48, '2019-06-04', 170, NULL),
('Candlewood Suites', 48, '2019-06-05', 188, NULL),
('Candlewood Suites', 48, '2019-06-06', 115, NULL),
('Candlewood Suites', 48, '2019-06-07', 253, NULL),
('Candlewood Suites', 48, '2019-06-08', 358, NULL),
('Candlewood Suites', 48, '2019-06-09', 117, NULL),
('Candlewood Suites', 48, '2019-06-10', 214, NULL),
('Candlewood Suites', 48, '2019-06-11', 317, NULL),
('Candlewood Suites', 48, '2019-06-12', 373, NULL),
('Candlewood Suites', 48, '2019-06-13', 265, NULL),
('Candlewood Suites', 48, '2019-06-14', 236, NULL),
('Candlewood Suites', 48, '2019-06-15', 119, NULL),
('Candlewood Suites', 48, '2019-06-16', 368, NULL),
('Candlewood Suites', 48, '2019-06-17', 258, NULL),
('Candlewood Suites', 48, '2019-06-18', 178, NULL),
('Candlewood Suites', 48, '2019-06-19', 399, NULL),
('Candlewood Suites', 48, '2019-06-20', 394, NULL),
('Candlewood Suites', 48, '2019-06-21', 367, NULL),
('Candlewood Suites', 48, '2019-06-22', 322, NULL),
('Candlewood Suites', 48, '2019-06-23', 124, NULL),
('Candlewood Suites', 48, '2019-06-24', 245, NULL),
('Candlewood Suites', 48, '2019-06-25', 126, NULL),
('Candlewood Suites', 48, '2019-06-26', 317, NULL),
('Candlewood Suites', 48, '2019-06-27', 215, NULL),
('Candlewood Suites', 48, '2019-06-28', 359, NULL),
('Candlewood Suites', 48, '2019-06-29', 166, NULL),
('Candlewood Suites', 48, '2019-06-30', 300, NULL),
('Candlewood Suites', 48, '2019-07-01', 262, NULL),
('Candlewood Suites', 48, '2019-07-02', 143, NULL),
('Candlewood Suites', 48, '2019-07-03', 275, NULL),
('Candlewood Suites', 48, '2019-07-04', 140, NULL),
('Candlewood Suites', 48, '2019-07-05', 248, NULL),
('Candlewood Suites', 48, '2019-07-06', 234, NULL),
('Candlewood Suites', 48, '2019-07-07', 359, NULL),
('Candlewood Suites', 48, '2019-07-08', 191, NULL),
('Candlewood Suites', 48, '2019-07-09', 166, NULL),
('Candlewood Suites', 48, '2019-07-10', 231, NULL),
('Candlewood Suites', 48, '2019-07-11', 181, NULL),
('Candlewood Suites', 48, '2019-07-12', 300, NULL),
('Candlewood Suites', 48, '2019-07-13', 170, NULL),
('Candlewood Suites', 48, '2019-07-14', 341, NULL),
('Candlewood Suites', 48, '2019-07-15', 150, NULL),
('Candlewood Suites', 48, '2019-07-16', 317, NULL),
('Candlewood Suites', 48, '2019-07-17', 282, NULL),
('Candlewood Suites', 48, '2019-07-18', 315, NULL),
('Candlewood Suites', 48, '2019-07-19', 132, NULL),
('Candlewood Suites', 48, '2019-07-20', 223, NULL),
('Candlewood Suites', 48, '2019-07-21', 209, NULL),
('Candlewood Suites', 48, '2019-07-22', 250, NULL),
('Candlewood Suites', 48, '2019-07-23', 197, NULL),
('Candlewood Suites', 48, '2019-07-24', 123, NULL),
('Candlewood Suites', 48, '2019-07-25', 110, NULL),
('Candlewood Suites', 48, '2019-07-26', 210, NULL),
('Candlewood Suites', 48, '2019-07-27', 276, NULL),
('Candlewood Suites', 48, '2019-07-28', 390, NULL),
('Candlewood Suites', 48, '2019-07-29', 366, NULL),
('Candlewood Suites', 48, '2019-07-30', 354, NULL),
('Candlewood Suites', 48, '2019-07-31', 184, NULL),
('Candlewood Suites', 48, '2019-08-01', 318, NULL),
('Candlewood Suites', 48, '2019-08-02', 152, NULL),
('Candlewood Suites', 48, '2019-08-03', 369, NULL),
('Candlewood Suites', 48, '2019-08-04', 306, NULL),
('Candlewood Suites', 48, '2019-08-05', 393, NULL),
('Candlewood Suites', 48, '2019-08-06', 251, NULL),
('Candlewood Suites', 48, '2019-08-07', 342, NULL),
('Candlewood Suites', 48, '2019-08-08', 207, NULL),
('Candlewood Suites', 48, '2019-08-09', 230, NULL),
('Candlewood Suites', 48, '2019-08-10', 127, NULL),
('Candlewood Suites', 48, '2019-08-11', 176, NULL),
('Candlewood Suites', 48, '2019-08-12', 163, NULL),
('Candlewood Suites', 48, '2019-08-13', 188, NULL),
('Candlewood Suites', 48, '2019-08-14', 323, NULL),
('Candlewood Suites', 48, '2019-08-15', 334, NULL),
('Candlewood Suites', 48, '2019-08-16', 341, NULL),
('Candlewood Suites', 48, '2019-08-17', 321, NULL),
('Candlewood Suites', 48, '2019-08-18', 242, NULL),
('Candlewood Suites', 48, '2019-08-19', 317, NULL),
('Candlewood Suites', 48, '2019-08-20', 353, NULL),
('Candlewood Suites', 48, '2019-08-21', 212, NULL),
('Candlewood Suites', 48, '2019-08-22', 330, NULL),
('Candlewood Suites', 48, '2019-08-23', 354, NULL),
('Candlewood Suites', 48, '2019-08-24', 152, NULL),
('Candlewood Suites', 48, '2019-08-25', 321, NULL),
('Candlewood Suites', 48, '2019-08-26', 149, NULL),
('Candlewood Suites', 48, '2019-08-27', 374, NULL),
('Candlewood Suites', 48, '2019-08-28', 187, NULL),
('Candlewood Suites', 48, '2019-08-29', 378, NULL),
('Candlewood Suites', 48, '2019-08-30', 295, NULL),
('Candlewood Suites', 48, '2019-08-31', 117, NULL),
('Candlewood Suites', 48, '2019-09-01', 226, NULL),
('Candlewood Suites', 48, '2019-09-02', 366, NULL),
('Candlewood Suites', 48, '2019-09-03', 244, NULL),
('Candlewood Suites', 48, '2019-09-04', 268, NULL),
('Candlewood Suites', 48, '2019-09-05', 395, NULL),
('Candlewood Suites', 48, '2019-09-06', 230, NULL),
('Candlewood Suites', 48, '2019-09-07', 240, NULL),
('Candlewood Suites', 48, '2019-09-08', 200, NULL),
('Candlewood Suites', 48, '2019-09-09', 255, NULL),
('Candlewood Suites', 48, '2019-09-10', 278, NULL),
('Candlewood Suites', 48, '2019-09-11', 340, NULL),
('Candlewood Suites', 48, '2019-09-12', 301, NULL),
('Candlewood Suites', 48, '2019-09-13', 325, NULL),
('Candlewood Suites', 48, '2019-09-14', 231, NULL),
('Candlewood Suites', 48, '2019-09-15', 224, NULL),
('Candlewood Suites', 48, '2019-09-16', 291, NULL),
('Candlewood Suites', 48, '2019-09-17', 156, NULL),
('Candlewood Suites', 48, '2019-09-18', 349, NULL),
('Candlewood Suites', 48, '2019-09-19', 128, NULL),
('Candlewood Suites', 48, '2019-09-20', 327, NULL),
('Candlewood Suites', 48, '2019-09-21', 100, NULL),
('Candlewood Suites', 48, '2019-09-22', 286, NULL),
('Candlewood Suites', 48, '2019-09-23', 129, NULL),
('Candlewood Suites', 48, '2019-09-24', 355, NULL),
('Candlewood Suites', 48, '2019-09-25', 397, NULL),
('Candlewood Suites', 48, '2019-09-26', 233, NULL),
('Candlewood Suites', 48, '2019-09-27', 100, NULL),
('Candlewood Suites', 48, '2019-09-28', 375, NULL),
('Candlewood Suites', 48, '2019-09-29', 219, NULL),
('Candlewood Suites', 48, '2019-09-30', 206, NULL),
('Candlewood Suites', 48, '2019-10-01', 139, NULL),
('Candlewood Suites', 48, '2019-10-02', 277, NULL),
('Candlewood Suites', 48, '2019-10-03', 287, NULL),
('Candlewood Suites', 48, '2019-10-04', 247, NULL),
('Candlewood Suites', 48, '2019-10-05', 359, NULL),
('Candlewood Suites', 48, '2019-10-06', 351, NULL),
('Candlewood Suites', 48, '2019-10-07', 216, NULL),
('Candlewood Suites', 48, '2019-10-08', 275, NULL),
('Candlewood Suites', 48, '2019-10-09', 147, NULL),
('Candlewood Suites', 48, '2019-10-10', 320, NULL),
('Candlewood Suites', 48, '2019-10-11', 154, NULL),
('Candlewood Suites', 48, '2019-10-12', 149, NULL),
('Candlewood Suites', 48, '2019-10-13', 316, NULL),
('Candlewood Suites', 48, '2019-10-14', 364, NULL),
('Candlewood Suites', 48, '2019-10-15', 140, NULL),
('Candlewood Suites', 48, '2019-10-16', 109, NULL),
('Candlewood Suites', 48, '2019-10-17', 105, NULL),
('Candlewood Suites', 48, '2019-10-18', 312, NULL),
('Candlewood Suites', 48, '2019-10-19', 223, NULL),
('Candlewood Suites', 48, '2019-10-20', 154, NULL),
('Candlewood Suites', 48, '2019-10-21', 123, NULL),
('Candlewood Suites', 48, '2019-10-22', 273, NULL),
('Candlewood Suites', 48, '2019-10-23', 136, NULL),
('Candlewood Suites', 48, '2019-10-24', 321, NULL),
('Candlewood Suites', 48, '2019-10-25', 247, NULL),
('Candlewood Suites', 48, '2019-10-26', 137, NULL),
('Candlewood Suites', 48, '2019-10-27', 201, NULL),
('Candlewood Suites', 48, '2019-10-28', 116, NULL),
('Candlewood Suites', 48, '2019-10-29', 242, NULL),
('Candlewood Suites', 48, '2019-10-30', 141, NULL),
('Candlewood Suites', 48, '2019-10-31', 336, NULL),
('Candlewood Suites', 48, '2019-11-01', 173, NULL),
('Candlewood Suites', 48, '2019-11-02', 229, NULL),
('Candlewood Suites', 48, '2019-11-03', 141, NULL),
('Candlewood Suites', 48, '2019-11-04', 292, NULL),
('Candlewood Suites', 48, '2019-11-05', 303, NULL),
('Candlewood Suites', 48, '2019-11-06', 262, NULL),
('Candlewood Suites', 48, '2019-11-07', 309, NULL),
('Candlewood Suites', 48, '2019-11-08', 193, NULL),
('Candlewood Suites', 48, '2019-11-09', 103, NULL),
('Candlewood Suites', 48, '2019-11-10', 181, NULL),
('Candlewood Suites', 48, '2019-11-11', 105, NULL),
('Candlewood Suites', 48, '2019-11-12', 259, NULL),
('Candlewood Suites', 48, '2019-11-13', 197, NULL),
('Candlewood Suites', 48, '2019-11-14', 380, NULL),
('Candlewood Suites', 48, '2019-11-15', 233, NULL),
('Candlewood Suites', 48, '2019-11-16', 368, NULL),
('Candlewood Suites', 48, '2019-11-17', 128, NULL),
('Candlewood Suites', 48, '2019-11-18', 313, NULL),
('Candlewood Suites', 48, '2019-11-19', 165, NULL),
('Candlewood Suites', 48, '2019-11-20', 384, NULL),
('Candlewood Suites', 48, '2019-11-21', 232, NULL),
('Candlewood Suites', 48, '2019-11-22', 169, NULL),
('Candlewood Suites', 48, '2019-11-23', 116, NULL),
('Candlewood Suites', 48, '2019-11-24', 216, NULL),
('Candlewood Suites', 48, '2019-11-25', 392, NULL),
('Candlewood Suites', 48, '2019-11-26', 227, NULL),
('Candlewood Suites', 48, '2019-11-27', 260, NULL),
('Candlewood Suites', 48, '2019-11-28', 247, NULL),
('Candlewood Suites', 48, '2019-11-29', 234, NULL),
('Candlewood Suites', 48, '2019-11-30', 327, NULL),
('Candlewood Suites', 48, '2019-12-01', 399, NULL),
('Candlewood Suites', 48, '2019-12-02', 296, NULL),
('Candlewood Suites', 48, '2019-12-03', 349, NULL),
('Candlewood Suites', 48, '2019-12-04', 357, NULL),
('Candlewood Suites', 48, '2019-12-05', 119, NULL),
('Candlewood Suites', 48, '2019-12-06', 349, NULL),
('Candlewood Suites', 48, '2019-12-07', 215, NULL),
('Candlewood Suites', 48, '2019-12-08', 181, NULL),
('Candlewood Suites', 48, '2019-12-09', 109, NULL),
('Candlewood Suites', 48, '2019-12-10', 248, 183),
('Candlewood Suites', 48, '2019-12-11', 132, 183),
('Candlewood Suites', 48, '2019-12-12', 255, 183),
('Candlewood Suites', 48, '2019-12-13', 228, 183),
('Candlewood Suites', 48, '2019-12-14', 193, 183),
('Candlewood Suites', 48, '2019-12-15', 377, 183),
('Candlewood Suites', 48, '2019-12-16', 367, 183),
('Candlewood Suites', 48, '2019-12-17', 247, 183),
('Candlewood Suites', 48, '2019-12-18', 339, 183),
('Candlewood Suites', 48, '2019-12-19', 333, 183),
('Candlewood Suites', 48, '2019-12-20', 114, 183),
('Candlewood Suites', 48, '2019-12-21', 116, 183),
('Candlewood Suites', 48, '2019-12-22', 250, NULL),
('Candlewood Suites', 48, '2019-12-23', 184, NULL),
('Candlewood Suites', 48, '2019-12-24', 148, NULL),
('Candlewood Suites', 48, '2019-12-25', 219, NULL),
('Candlewood Suites', 48, '2019-12-26', 254, NULL),
('Candlewood Suites', 48, '2019-12-27', 161, NULL),
('Candlewood Suites', 48, '2019-12-28', 235, NULL),
('Candlewood Suites', 48, '2019-12-29', 393, NULL),
('Candlewood Suites', 48, '2019-12-30', 387, NULL),
('Candlewood Suites', 48, '2019-12-31', 246, NULL),
('Candlewood Suites', 48, '2020-01-01', 206, NULL),
('Candlewood Suites', 48, '2020-01-02', 398, NULL),
('Candlewood Suites', 48, '2020-01-03', 252, NULL),
('Candlewood Suites', 48, '2020-01-04', 264, NULL),
('Candlewood Suites', 48, '2020-01-05', 189, NULL),
('Candlewood Suites', 48, '2020-01-06', 388, NULL),
('Candlewood Suites', 48, '2020-01-07', 281, NULL),
('Candlewood Suites', 48, '2020-01-08', 321, NULL),
('Candlewood Suites', 48, '2020-01-09', 224, NULL),
('Candlewood Suites', 48, '2020-01-10', 209, NULL),
('Candlewood Suites', 48, '2020-01-11', 252, NULL),
('Candlewood Suites', 48, '2020-01-12', 251, NULL),
('Candlewood Suites', 48, '2020-01-13', 103, NULL),
('Candlewood Suites', 48, '2020-01-14', 143, NULL),
('Candlewood Suites', 48, '2020-01-15', 278, NULL),
('Candlewood Suites', 48, '2020-01-16', 140, NULL),
('Candlewood Suites', 48, '2020-01-17', 162, NULL),
('Candlewood Suites', 48, '2020-01-18', 356, NULL),
('Candlewood Suites', 48, '2020-01-19', 146, NULL),
('Candlewood Suites', 48, '2020-01-20', 293, NULL),
('Candlewood Suites', 48, '2020-01-21', 351, NULL),
('Candlewood Suites', 48, '2020-01-22', 174, NULL),
('Candlewood Suites', 48, '2020-01-23', 277, NULL),
('Candlewood Suites', 48, '2020-01-24', 322, NULL),
('Candlewood Suites', 48, '2020-01-25', 243, NULL),
('Candlewood Suites', 48, '2020-01-26', 367, NULL),
('Candlewood Suites', 48, '2020-01-27', 196, NULL),
('Candlewood Suites', 48, '2020-01-28', 173, NULL),
('Candlewood Suites', 48, '2020-01-29', 230, NULL),
('Candlewood Suites', 48, '2020-01-30', 153, NULL),
('Candlewood Suites', 48, '2020-01-31', 313, NULL),
('Candlewood Suites', 48, '2020-02-01', 368, NULL),
('Candlewood Suites', 48, '2020-02-02', 182, NULL),
('Candlewood Suites', 48, '2020-02-03', 299, NULL),
('Candlewood Suites', 48, '2020-02-04', 186, NULL),
('Candlewood Suites', 53, '2019-01-01', 192, NULL),
('Candlewood Suites', 53, '2019-01-02', 257, NULL),
('Candlewood Suites', 53, '2019-01-03', 388, NULL),
('Candlewood Suites', 53, '2019-01-04', 139, NULL),
('Candlewood Suites', 53, '2019-01-05', 239, NULL),
('Candlewood Suites', 53, '2019-01-06', 309, NULL),
('Candlewood Suites', 53, '2019-01-07', 333, NULL),
('Candlewood Suites', 53, '2019-01-08', 304, NULL),
('Candlewood Suites', 53, '2019-01-09', 349, NULL),
('Candlewood Suites', 53, '2019-01-10', 135, NULL),
('Candlewood Suites', 53, '2019-01-11', 269, NULL),
('Candlewood Suites', 53, '2019-01-12', 377, NULL),
('Candlewood Suites', 53, '2019-01-13', 188, NULL),
('Candlewood Suites', 53, '2019-01-14', 171, NULL),
('Candlewood Suites', 53, '2019-01-15', 300, NULL),
('Candlewood Suites', 53, '2019-01-16', 180, NULL),
('Candlewood Suites', 53, '2019-01-17', 200, NULL),
('Candlewood Suites', 53, '2019-01-18', 228, NULL),
('Candlewood Suites', 53, '2019-01-19', 173, NULL),
('Candlewood Suites', 53, '2019-01-20', 152, NULL),
('Candlewood Suites', 53, '2019-01-21', 210, NULL),
('Candlewood Suites', 53, '2019-01-22', 224, NULL),
('Candlewood Suites', 53, '2019-01-23', 160, NULL),
('Candlewood Suites', 53, '2019-01-24', 175, NULL),
('Candlewood Suites', 53, '2019-01-25', 188, NULL),
('Candlewood Suites', 53, '2019-01-26', 240, NULL),
('Candlewood Suites', 53, '2019-01-27', 363, NULL),
('Candlewood Suites', 53, '2019-01-28', 114, NULL),
('Candlewood Suites', 53, '2019-01-29', 260, NULL),
('Candlewood Suites', 53, '2019-01-30', 215, NULL),
('Candlewood Suites', 53, '2019-01-31', 320, NULL),
('Candlewood Suites', 53, '2019-02-01', 282, NULL),
('Candlewood Suites', 53, '2019-02-02', 114, NULL),
('Candlewood Suites', 53, '2019-02-03', 230, NULL),
('Candlewood Suites', 53, '2019-02-04', 196, NULL),
('Candlewood Suites', 53, '2019-02-05', 181, NULL),
('Candlewood Suites', 53, '2019-02-06', 197, NULL),
('Candlewood Suites', 53, '2019-02-07', 291, NULL),
('Candlewood Suites', 53, '2019-02-08', 321, NULL),
('Candlewood Suites', 53, '2019-02-09', 212, NULL),
('Candlewood Suites', 53, '2019-02-10', 356, NULL),
('Candlewood Suites', 53, '2019-02-11', 311, NULL),
('Candlewood Suites', 53, '2019-02-12', 116, NULL),
('Candlewood Suites', 53, '2019-02-13', 181, NULL),
('Candlewood Suites', 53, '2019-02-14', 344, NULL),
('Candlewood Suites', 53, '2019-02-15', 368, NULL),
('Candlewood Suites', 53, '2019-02-16', 109, NULL),
('Candlewood Suites', 53, '2019-02-17', 345, NULL),
('Candlewood Suites', 53, '2019-02-18', 211, NULL),
('Candlewood Suites', 53, '2019-02-19', 199, NULL),
('Candlewood Suites', 53, '2019-02-20', 147, NULL),
('Candlewood Suites', 53, '2019-02-21', 295, NULL),
('Candlewood Suites', 53, '2019-02-22', 141, NULL),
('Candlewood Suites', 53, '2019-02-23', 313, NULL),
('Candlewood Suites', 53, '2019-02-24', 156, NULL),
('Candlewood Suites', 53, '2019-02-25', 311, NULL),
('Candlewood Suites', 53, '2019-02-26', 388, NULL),
('Candlewood Suites', 53, '2019-02-27', 373, NULL),
('Candlewood Suites', 53, '2019-02-28', 147, NULL),
('Candlewood Suites', 53, '2019-03-01', 266, NULL),
('Candlewood Suites', 53, '2019-03-02', 128, NULL),
('Candlewood Suites', 53, '2019-03-03', 312, NULL),
('Candlewood Suites', 53, '2019-03-04', 263, NULL),
('Candlewood Suites', 53, '2019-03-05', 342, NULL),
('Candlewood Suites', 53, '2019-03-06', 347, NULL),
('Candlewood Suites', 53, '2019-03-07', 345, NULL),
('Candlewood Suites', 53, '2019-03-08', 124, NULL),
('Candlewood Suites', 53, '2019-03-09', 252, NULL),
('Candlewood Suites', 53, '2019-03-10', 358, NULL),
('Candlewood Suites', 53, '2019-03-11', 174, NULL),
('Candlewood Suites', 53, '2019-03-12', 184, NULL),
('Candlewood Suites', 53, '2019-03-13', 362, NULL),
('Candlewood Suites', 53, '2019-03-14', 223, NULL),
('Candlewood Suites', 53, '2019-03-15', 128, NULL),
('Candlewood Suites', 53, '2019-03-16', 389, NULL),
('Candlewood Suites', 53, '2019-03-17', 117, NULL),
('Candlewood Suites', 53, '2019-03-18', 398, NULL),
('Candlewood Suites', 53, '2019-03-19', 391, NULL),
('Candlewood Suites', 53, '2019-03-20', 377, NULL),
('Candlewood Suites', 53, '2019-03-21', 245, NULL),
('Candlewood Suites', 53, '2019-03-22', 180, NULL),
('Candlewood Suites', 53, '2019-03-23', 110, NULL),
('Candlewood Suites', 53, '2019-03-24', 204, NULL),
('Candlewood Suites', 53, '2019-03-25', 216, NULL),
('Candlewood Suites', 53, '2019-03-26', 379, NULL),
('Candlewood Suites', 53, '2019-03-27', 174, NULL),
('Candlewood Suites', 53, '2019-03-28', 249, NULL),
('Candlewood Suites', 53, '2019-03-29', 206, NULL),
('Candlewood Suites', 53, '2019-03-30', 151, NULL),
('Candlewood Suites', 53, '2019-03-31', 155, NULL),
('Candlewood Suites', 53, '2019-04-01', 369, NULL),
('Candlewood Suites', 53, '2019-04-02', 399, NULL),
('Candlewood Suites', 53, '2019-04-03', 212, NULL),
('Candlewood Suites', 53, '2019-04-04', 256, NULL),
('Candlewood Suites', 53, '2019-04-05', 313, NULL),
('Candlewood Suites', 53, '2019-04-06', 243, NULL),
('Candlewood Suites', 53, '2019-04-07', 374, NULL),
('Candlewood Suites', 53, '2019-04-08', 229, NULL),
('Candlewood Suites', 53, '2019-04-09', 127, NULL),
('Candlewood Suites', 53, '2019-04-10', 136, NULL),
('Candlewood Suites', 53, '2019-04-11', 213, NULL),
('Candlewood Suites', 53, '2019-04-12', 178, NULL),
('Candlewood Suites', 53, '2019-04-13', 319, NULL),
('Candlewood Suites', 53, '2019-04-14', 348, NULL),
('Candlewood Suites', 53, '2019-04-15', 295, NULL),
('Candlewood Suites', 53, '2019-04-16', 156, NULL),
('Candlewood Suites', 53, '2019-04-17', 203, NULL),
('Candlewood Suites', 53, '2019-04-18', 151, NULL),
('Candlewood Suites', 53, '2019-04-19', 146, NULL),
('Candlewood Suites', 53, '2019-04-20', 276, NULL),
('Candlewood Suites', 53, '2019-04-21', 217, NULL),
('Candlewood Suites', 53, '2019-04-22', 274, NULL),
('Candlewood Suites', 53, '2019-04-23', 103, NULL),
('Candlewood Suites', 53, '2019-04-24', 395, NULL),
('Candlewood Suites', 53, '2019-04-25', 137, NULL),
('Candlewood Suites', 53, '2019-04-26', 212, NULL),
('Candlewood Suites', 53, '2019-04-27', 129, NULL),
('Candlewood Suites', 53, '2019-04-28', 297, NULL),
('Candlewood Suites', 53, '2019-04-29', 165, NULL),
('Candlewood Suites', 53, '2019-04-30', 168, NULL),
('Candlewood Suites', 53, '2019-05-01', 343, NULL),
('Candlewood Suites', 53, '2019-05-02', 338, NULL),
('Candlewood Suites', 53, '2019-05-03', 193, NULL),
('Candlewood Suites', 53, '2019-05-04', 317, NULL),
('Candlewood Suites', 53, '2019-05-05', 136, NULL),
('Candlewood Suites', 53, '2019-05-06', 292, NULL),
('Candlewood Suites', 53, '2019-05-07', 106, NULL),
('Candlewood Suites', 53, '2019-05-08', 219, NULL),
('Candlewood Suites', 53, '2019-05-09', 321, NULL),
('Candlewood Suites', 53, '2019-05-10', 250, NULL),
('Candlewood Suites', 53, '2019-05-11', 229, NULL),
('Candlewood Suites', 53, '2019-05-12', 278, NULL),
('Candlewood Suites', 53, '2019-05-13', 314, NULL),
('Candlewood Suites', 53, '2019-05-14', 188, NULL),
('Candlewood Suites', 53, '2019-05-15', 212, NULL),
('Candlewood Suites', 53, '2019-05-16', 101, NULL),
('Candlewood Suites', 53, '2019-05-17', 366, NULL),
('Candlewood Suites', 53, '2019-05-18', 389, NULL),
('Candlewood Suites', 53, '2019-05-19', 295, NULL),
('Candlewood Suites', 53, '2019-05-20', 128, NULL),
('Candlewood Suites', 53, '2019-05-21', 267, NULL),
('Candlewood Suites', 53, '2019-05-22', 383, NULL),
('Candlewood Suites', 53, '2019-05-23', 196, NULL),
('Candlewood Suites', 53, '2019-05-24', 190, NULL),
('Candlewood Suites', 53, '2019-05-25', 136, NULL),
('Candlewood Suites', 53, '2019-05-26', 368, NULL),
('Candlewood Suites', 53, '2019-05-27', 217, NULL),
('Candlewood Suites', 53, '2019-05-28', 323, NULL),
('Candlewood Suites', 53, '2019-05-29', 362, NULL),
('Candlewood Suites', 53, '2019-05-30', 135, NULL),
('Candlewood Suites', 53, '2019-05-31', 117, NULL),
('Candlewood Suites', 53, '2019-06-01', 131, NULL),
('Candlewood Suites', 53, '2019-06-02', 107, NULL),
('Candlewood Suites', 53, '2019-06-03', 338, NULL),
('Candlewood Suites', 53, '2019-06-04', 322, NULL),
('Candlewood Suites', 53, '2019-06-05', 338, NULL),
('Candlewood Suites', 53, '2019-06-06', 184, NULL),
('Candlewood Suites', 53, '2019-06-07', 394, NULL),
('Candlewood Suites', 53, '2019-06-08', 250, NULL),
('Candlewood Suites', 53, '2019-06-09', 250, NULL),
('Candlewood Suites', 53, '2019-06-10', 262, NULL),
('Candlewood Suites', 53, '2019-06-11', 343, NULL),
('Candlewood Suites', 53, '2019-06-12', 371, NULL),
('Candlewood Suites', 53, '2019-06-13', 357, NULL),
('Candlewood Suites', 53, '2019-06-14', 280, NULL),
('Candlewood Suites', 53, '2019-06-15', 350, NULL),
('Candlewood Suites', 53, '2019-06-16', 179, NULL),
('Candlewood Suites', 53, '2019-06-17', 259, NULL),
('Candlewood Suites', 53, '2019-06-18', 186, NULL),
('Candlewood Suites', 53, '2019-06-19', 266, NULL),
('Candlewood Suites', 53, '2019-06-20', 220, NULL),
('Candlewood Suites', 53, '2019-06-21', 301, NULL),
('Candlewood Suites', 53, '2019-06-22', 173, NULL),
('Candlewood Suites', 53, '2019-06-23', 327, NULL),
('Candlewood Suites', 53, '2019-06-24', 259, NULL),
('Candlewood Suites', 53, '2019-06-25', 123, NULL),
('Candlewood Suites', 53, '2019-06-26', 143, NULL),
('Candlewood Suites', 53, '2019-06-27', 247, NULL),
('Candlewood Suites', 53, '2019-06-28', 314, NULL),
('Candlewood Suites', 53, '2019-06-29', 133, NULL),
('Candlewood Suites', 53, '2019-06-30', 100, NULL),
('Candlewood Suites', 53, '2019-07-01', 142, NULL),
('Candlewood Suites', 53, '2019-07-02', 291, NULL),
('Candlewood Suites', 53, '2019-07-03', 114, NULL),
('Candlewood Suites', 53, '2019-07-04', 365, NULL),
('Candlewood Suites', 53, '2019-07-05', 297, NULL),
('Candlewood Suites', 53, '2019-07-06', 144, NULL),
('Candlewood Suites', 53, '2019-07-07', 134, NULL),
('Candlewood Suites', 53, '2019-07-08', 354, NULL),
('Candlewood Suites', 53, '2019-07-09', 142, NULL),
('Candlewood Suites', 53, '2019-07-10', 357, NULL),
('Candlewood Suites', 53, '2019-07-11', 290, NULL),
('Candlewood Suites', 53, '2019-07-12', 284, NULL),
('Candlewood Suites', 53, '2019-07-13', 152, NULL),
('Candlewood Suites', 53, '2019-07-14', 325, NULL),
('Candlewood Suites', 53, '2019-07-15', 168, NULL),
('Candlewood Suites', 53, '2019-07-16', 338, NULL),
('Candlewood Suites', 53, '2019-07-17', 125, NULL),
('Candlewood Suites', 53, '2019-07-18', 397, NULL),
('Candlewood Suites', 53, '2019-07-19', 325, NULL),
('Candlewood Suites', 53, '2019-07-20', 101, NULL),
('Candlewood Suites', 53, '2019-07-21', 373, NULL),
('Candlewood Suites', 53, '2019-07-22', 343, NULL),
('Candlewood Suites', 53, '2019-07-23', 361, NULL),
('Candlewood Suites', 53, '2019-07-24', 294, NULL),
('Candlewood Suites', 53, '2019-07-25', 109, NULL),
('Candlewood Suites', 53, '2019-07-26', 304, NULL),
('Candlewood Suites', 53, '2019-07-27', 104, NULL),
('Candlewood Suites', 53, '2019-07-28', 214, NULL),
('Candlewood Suites', 53, '2019-07-29', 170, NULL),
('Candlewood Suites', 53, '2019-07-30', 315, NULL),
('Candlewood Suites', 53, '2019-07-31', 246, NULL),
('Candlewood Suites', 53, '2019-08-01', 335, NULL),
('Candlewood Suites', 53, '2019-08-02', 260, NULL),
('Candlewood Suites', 53, '2019-08-03', 213, NULL),
('Candlewood Suites', 53, '2019-08-04', 201, NULL),
('Candlewood Suites', 53, '2019-08-05', 307, NULL),
('Candlewood Suites', 53, '2019-08-06', 389, NULL),
('Candlewood Suites', 53, '2019-08-07', 233, NULL),
('Candlewood Suites', 53, '2019-08-08', 326, NULL),
('Candlewood Suites', 53, '2019-08-09', 295, NULL),
('Candlewood Suites', 53, '2019-08-10', 216, NULL),
('Candlewood Suites', 53, '2019-08-11', 308, NULL),
('Candlewood Suites', 53, '2019-08-12', 251, NULL),
('Candlewood Suites', 53, '2019-08-13', 153, NULL),
('Candlewood Suites', 53, '2019-08-14', 201, NULL),
('Candlewood Suites', 53, '2019-08-15', 346, NULL),
('Candlewood Suites', 53, '2019-08-16', 287, NULL),
('Candlewood Suites', 53, '2019-08-17', 295, NULL),
('Candlewood Suites', 53, '2019-08-18', 228, NULL),
('Candlewood Suites', 53, '2019-08-19', 110, NULL),
('Candlewood Suites', 53, '2019-08-20', 251, NULL),
('Candlewood Suites', 53, '2019-08-21', 106, NULL),
('Candlewood Suites', 53, '2019-08-22', 218, NULL),
('Candlewood Suites', 53, '2019-08-23', 275, NULL),
('Candlewood Suites', 53, '2019-08-24', 255, NULL),
('Candlewood Suites', 53, '2019-08-25', 111, NULL),
('Candlewood Suites', 53, '2019-08-26', 330, NULL),
('Candlewood Suites', 53, '2019-08-27', 159, NULL),
('Candlewood Suites', 53, '2019-08-28', 348, NULL),
('Candlewood Suites', 53, '2019-08-29', 129, NULL),
('Candlewood Suites', 53, '2019-08-30', 127, NULL),
('Candlewood Suites', 53, '2019-08-31', 199, NULL),
('Candlewood Suites', 53, '2019-09-01', 203, NULL),
('Candlewood Suites', 53, '2019-09-02', 385, NULL),
('Candlewood Suites', 53, '2019-09-03', 183, NULL),
('Candlewood Suites', 53, '2019-09-04', 324, NULL),
('Candlewood Suites', 53, '2019-09-05', 351, NULL),
('Candlewood Suites', 53, '2019-09-06', 245, NULL),
('Candlewood Suites', 53, '2019-09-07', 347, NULL),
('Candlewood Suites', 53, '2019-09-08', 219, NULL),
('Candlewood Suites', 53, '2019-09-09', 276, NULL),
('Candlewood Suites', 53, '2019-09-10', 397, NULL),
('Candlewood Suites', 53, '2019-09-11', 284, NULL),
('Candlewood Suites', 53, '2019-09-12', 318, NULL),
('Candlewood Suites', 53, '2019-09-13', 282, NULL),
('Candlewood Suites', 53, '2019-09-14', 199, NULL),
('Candlewood Suites', 53, '2019-09-15', 215, NULL),
('Candlewood Suites', 53, '2019-09-16', 199, NULL),
('Candlewood Suites', 53, '2019-09-17', 170, NULL),
('Candlewood Suites', 53, '2019-09-18', 208, NULL),
('Candlewood Suites', 53, '2019-09-19', 304, NULL),
('Candlewood Suites', 53, '2019-09-20', 344, NULL),
('Candlewood Suites', 53, '2019-09-21', 128, NULL),
('Candlewood Suites', 53, '2019-09-22', 319, NULL),
('Candlewood Suites', 53, '2019-09-23', 272, NULL),
('Candlewood Suites', 53, '2019-09-24', 238, NULL),
('Candlewood Suites', 53, '2019-09-25', 335, NULL),
('Candlewood Suites', 53, '2019-09-26', 334, NULL),
('Candlewood Suites', 53, '2019-09-27', 214, NULL),
('Candlewood Suites', 53, '2019-09-28', 317, NULL),
('Candlewood Suites', 53, '2019-09-29', 148, NULL),
('Candlewood Suites', 53, '2019-09-30', 292, NULL),
('Candlewood Suites', 53, '2019-10-01', 225, NULL),
('Candlewood Suites', 53, '2019-10-02', 131, NULL),
('Candlewood Suites', 53, '2019-10-03', 181, NULL),
('Candlewood Suites', 53, '2019-10-04', 173, NULL),
('Candlewood Suites', 53, '2019-10-05', 106, NULL),
('Candlewood Suites', 53, '2019-10-06', 248, NULL),
('Candlewood Suites', 53, '2019-10-07', 138, NULL),
('Candlewood Suites', 53, '2019-10-08', 313, NULL),
('Candlewood Suites', 53, '2019-10-09', 354, NULL),
('Candlewood Suites', 53, '2019-10-10', 132, NULL),
('Candlewood Suites', 53, '2019-10-11', 395, NULL),
('Candlewood Suites', 53, '2019-10-12', 104, NULL),
('Candlewood Suites', 53, '2019-10-13', 394, NULL),
('Candlewood Suites', 53, '2019-10-14', 381, NULL),
('Candlewood Suites', 53, '2019-10-15', 184, NULL),
('Candlewood Suites', 53, '2019-10-16', 207, NULL),
('Candlewood Suites', 53, '2019-10-17', 358, NULL),
('Candlewood Suites', 53, '2019-10-18', 360, NULL),
('Candlewood Suites', 53, '2019-10-19', 304, NULL),
('Candlewood Suites', 53, '2019-10-20', 222, NULL),
('Candlewood Suites', 53, '2019-10-21', 214, NULL),
('Candlewood Suites', 53, '2019-10-22', 206, NULL),
('Candlewood Suites', 53, '2019-10-23', 248, NULL),
('Candlewood Suites', 53, '2019-10-24', 310, NULL),
('Candlewood Suites', 53, '2019-10-25', 288, NULL),
('Candlewood Suites', 53, '2019-10-26', 106, NULL),
('Candlewood Suites', 53, '2019-10-27', 308, NULL),
('Candlewood Suites', 53, '2019-10-28', 143, NULL),
('Candlewood Suites', 53, '2019-10-29', 180, NULL),
('Candlewood Suites', 53, '2019-10-30', 282, NULL),
('Candlewood Suites', 53, '2019-10-31', 276, NULL),
('Candlewood Suites', 53, '2019-11-01', 304, NULL),
('Candlewood Suites', 53, '2019-11-02', 319, NULL),
('Candlewood Suites', 53, '2019-11-03', 177, NULL),
('Candlewood Suites', 53, '2019-11-04', 301, NULL),
('Candlewood Suites', 53, '2019-11-05', 150, NULL),
('Candlewood Suites', 53, '2019-11-06', 253, NULL),
('Candlewood Suites', 53, '2019-11-07', 277, NULL),
('Candlewood Suites', 53, '2019-11-08', 146, NULL),
('Candlewood Suites', 53, '2019-11-09', 285, NULL),
('Candlewood Suites', 53, '2019-11-10', 160, NULL),
('Candlewood Suites', 53, '2019-11-11', 195, NULL),
('Candlewood Suites', 53, '2019-11-12', 191, NULL),
('Candlewood Suites', 53, '2019-11-13', 167, NULL),
('Candlewood Suites', 53, '2019-11-14', 145, NULL),
('Candlewood Suites', 53, '2019-11-15', 260, NULL),
('Candlewood Suites', 53, '2019-11-16', 262, NULL),
('Candlewood Suites', 53, '2019-11-17', 333, NULL),
('Candlewood Suites', 53, '2019-11-18', 242, NULL),
('Candlewood Suites', 53, '2019-11-19', 263, NULL),
('Candlewood Suites', 53, '2019-11-20', 376, NULL),
('Candlewood Suites', 53, '2019-11-21', 385, NULL),
('Candlewood Suites', 53, '2019-11-22', 276, NULL),
('Candlewood Suites', 53, '2019-11-23', 382, NULL),
('Candlewood Suites', 53, '2019-11-24', 262, NULL),
('Candlewood Suites', 53, '2019-11-25', 359, NULL),
('Candlewood Suites', 53, '2019-11-26', 173, NULL),
('Candlewood Suites', 53, '2019-11-27', 360, NULL),
('Candlewood Suites', 53, '2019-11-28', 158, NULL),
('Candlewood Suites', 53, '2019-11-29', 382, NULL),
('Candlewood Suites', 53, '2019-11-30', 262, NULL),
('Candlewood Suites', 53, '2019-12-01', 360, NULL),
('Candlewood Suites', 53, '2019-12-02', 249, NULL),
('Candlewood Suites', 53, '2019-12-03', 367, NULL),
('Candlewood Suites', 53, '2019-12-04', 300, NULL),
('Candlewood Suites', 53, '2019-12-05', 314, NULL),
('Candlewood Suites', 53, '2019-12-06', 309, NULL),
('Candlewood Suites', 53, '2019-12-07', 194, NULL),
('Candlewood Suites', 53, '2019-12-08', 117, NULL),
('Candlewood Suites', 53, '2019-12-09', 184, NULL),
('Candlewood Suites', 53, '2019-12-10', 212, NULL),
('Candlewood Suites', 53, '2019-12-11', 256, NULL),
('Candlewood Suites', 53, '2019-12-12', 194, NULL),
('Candlewood Suites', 53, '2019-12-13', 317, NULL),
('Candlewood Suites', 53, '2019-12-14', 139, NULL),
('Candlewood Suites', 53, '2019-12-15', 160, NULL),
('Candlewood Suites', 53, '2019-12-16', 106, NULL),
('Candlewood Suites', 53, '2019-12-17', 240, NULL),
('Candlewood Suites', 53, '2019-12-18', 118, NULL),
('Candlewood Suites', 53, '2019-12-19', 321, NULL),
('Candlewood Suites', 53, '2019-12-20', 374, NULL),
('Candlewood Suites', 53, '2019-12-21', 325, NULL),
('Candlewood Suites', 53, '2019-12-22', 183, NULL),
('Candlewood Suites', 53, '2019-12-23', 277, NULL),
('Candlewood Suites', 53, '2019-12-24', 176, NULL),
('Candlewood Suites', 53, '2019-12-25', 200, NULL),
('Candlewood Suites', 53, '2019-12-26', 171, NULL),
('Candlewood Suites', 53, '2019-12-27', 181, NULL),
('Candlewood Suites', 53, '2019-12-28', 339, NULL),
('Candlewood Suites', 53, '2019-12-29', 278, NULL),
('Candlewood Suites', 53, '2019-12-30', 284, NULL),
('Candlewood Suites', 53, '2019-12-31', 257, NULL),
('Candlewood Suites', 53, '2020-01-01', 297, NULL),
('Candlewood Suites', 53, '2020-01-02', 226, NULL),
('Candlewood Suites', 53, '2020-01-03', 345, NULL),
('Candlewood Suites', 53, '2020-01-04', 365, NULL),
('Candlewood Suites', 53, '2020-01-05', 383, NULL),
('Candlewood Suites', 53, '2020-01-06', 136, NULL),
('Candlewood Suites', 53, '2020-01-07', 396, NULL),
('Candlewood Suites', 53, '2020-01-08', 107, NULL),
('Candlewood Suites', 53, '2020-01-09', 194, NULL),
('Candlewood Suites', 53, '2020-01-10', 232, NULL),
('Candlewood Suites', 53, '2020-01-11', 287, NULL),
('Candlewood Suites', 53, '2020-01-12', 279, NULL),
('Candlewood Suites', 53, '2020-01-13', 127, NULL),
('Candlewood Suites', 53, '2020-01-14', 248, NULL),
('Candlewood Suites', 53, '2020-01-15', 111, NULL),
('Candlewood Suites', 53, '2020-01-16', 265, NULL),
('Candlewood Suites', 53, '2020-01-17', 304, NULL),
('Candlewood Suites', 53, '2020-01-18', 248, NULL),
('Candlewood Suites', 53, '2020-01-19', 165, NULL),
('Candlewood Suites', 53, '2020-01-20', 102, NULL),
('Candlewood Suites', 53, '2020-01-21', 180, NULL),
('Candlewood Suites', 53, '2020-01-22', 351, NULL),
('Candlewood Suites', 53, '2020-01-23', 300, NULL),
('Candlewood Suites', 53, '2020-01-24', 319, NULL),
('Candlewood Suites', 53, '2020-01-25', 201, NULL),
('Candlewood Suites', 53, '2020-01-26', 244, NULL),
('Candlewood Suites', 53, '2020-01-27', 179, NULL),
('Candlewood Suites', 53, '2020-01-28', 343, NULL),
('Candlewood Suites', 53, '2020-01-29', 113, NULL),
('Candlewood Suites', 53, '2020-01-30', 106, NULL),
('Candlewood Suites', 53, '2020-01-31', 361, NULL),
('Candlewood Suites', 53, '2020-02-01', 201, NULL),
('Candlewood Suites', 53, '2020-02-02', 288, NULL),
('Candlewood Suites', 53, '2020-02-03', 262, NULL),
('Candlewood Suites', 53, '2020-02-04', 285, NULL),
('Candlewood Suites', 80, '2019-01-01', 157, NULL),
('Candlewood Suites', 80, '2019-01-02', 205, NULL),
('Candlewood Suites', 80, '2019-01-03', 377, NULL),
('Candlewood Suites', 80, '2019-01-04', 272, NULL),
('Candlewood Suites', 80, '2019-01-05', 204, NULL),
('Candlewood Suites', 80, '2019-01-06', 125, NULL),
('Candlewood Suites', 80, '2019-01-07', 345, NULL),
('Candlewood Suites', 80, '2019-01-08', 164, NULL),
('Candlewood Suites', 80, '2019-01-09', 124, NULL),
('Candlewood Suites', 80, '2019-01-10', 107, NULL),
('Candlewood Suites', 80, '2019-01-11', 343, NULL),
('Candlewood Suites', 80, '2019-01-12', 256, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 80, '2019-01-13', 384, NULL),
('Candlewood Suites', 80, '2019-01-14', 273, NULL),
('Candlewood Suites', 80, '2019-01-15', 257, NULL),
('Candlewood Suites', 80, '2019-01-16', 180, NULL),
('Candlewood Suites', 80, '2019-01-17', 246, NULL),
('Candlewood Suites', 80, '2019-01-18', 253, NULL),
('Candlewood Suites', 80, '2019-01-19', 354, NULL),
('Candlewood Suites', 80, '2019-01-20', 376, NULL),
('Candlewood Suites', 80, '2019-01-21', 306, NULL),
('Candlewood Suites', 80, '2019-01-22', 384, NULL),
('Candlewood Suites', 80, '2019-01-23', 392, NULL),
('Candlewood Suites', 80, '2019-01-24', 104, NULL),
('Candlewood Suites', 80, '2019-01-25', 171, NULL),
('Candlewood Suites', 80, '2019-01-26', 310, NULL),
('Candlewood Suites', 80, '2019-01-27', 395, NULL),
('Candlewood Suites', 80, '2019-01-28', 186, NULL),
('Candlewood Suites', 80, '2019-01-29', 333, NULL),
('Candlewood Suites', 80, '2019-01-30', 274, NULL),
('Candlewood Suites', 80, '2019-01-31', 190, NULL),
('Candlewood Suites', 80, '2019-02-01', 231, NULL),
('Candlewood Suites', 80, '2019-02-02', 218, NULL),
('Candlewood Suites', 80, '2019-02-03', 149, NULL),
('Candlewood Suites', 80, '2019-02-04', 145, NULL),
('Candlewood Suites', 80, '2019-02-05', 320, NULL),
('Candlewood Suites', 80, '2019-02-06', 142, NULL),
('Candlewood Suites', 80, '2019-02-07', 100, NULL),
('Candlewood Suites', 80, '2019-02-08', 284, NULL),
('Candlewood Suites', 80, '2019-02-09', 149, NULL),
('Candlewood Suites', 80, '2019-02-10', 345, NULL),
('Candlewood Suites', 80, '2019-02-11', 391, NULL),
('Candlewood Suites', 80, '2019-02-12', 295, NULL),
('Candlewood Suites', 80, '2019-02-13', 110, NULL),
('Candlewood Suites', 80, '2019-02-14', 168, NULL),
('Candlewood Suites', 80, '2019-02-15', 249, NULL),
('Candlewood Suites', 80, '2019-02-16', 389, NULL),
('Candlewood Suites', 80, '2019-02-17', 241, NULL),
('Candlewood Suites', 80, '2019-02-18', 368, NULL),
('Candlewood Suites', 80, '2019-02-19', 190, NULL),
('Candlewood Suites', 80, '2019-02-20', 114, NULL),
('Candlewood Suites', 80, '2019-02-21', 142, NULL),
('Candlewood Suites', 80, '2019-02-22', 273, NULL),
('Candlewood Suites', 80, '2019-02-23', 255, NULL),
('Candlewood Suites', 80, '2019-02-24', 104, NULL),
('Candlewood Suites', 80, '2019-02-25', 185, NULL),
('Candlewood Suites', 80, '2019-02-26', 250, NULL),
('Candlewood Suites', 80, '2019-02-27', 102, NULL),
('Candlewood Suites', 80, '2019-02-28', 303, NULL),
('Candlewood Suites', 80, '2019-03-01', 322, NULL),
('Candlewood Suites', 80, '2019-03-02', 349, NULL),
('Candlewood Suites', 80, '2019-03-03', 322, NULL),
('Candlewood Suites', 80, '2019-03-04', 396, NULL),
('Candlewood Suites', 80, '2019-03-05', 147, NULL),
('Candlewood Suites', 80, '2019-03-06', 333, NULL),
('Candlewood Suites', 80, '2019-03-07', 286, NULL),
('Candlewood Suites', 80, '2019-03-08', 368, NULL),
('Candlewood Suites', 80, '2019-03-09', 195, NULL),
('Candlewood Suites', 80, '2019-03-10', 182, NULL),
('Candlewood Suites', 80, '2019-03-11', 284, NULL),
('Candlewood Suites', 80, '2019-03-12', 392, NULL),
('Candlewood Suites', 80, '2019-03-13', 343, NULL),
('Candlewood Suites', 80, '2019-03-14', 247, NULL),
('Candlewood Suites', 80, '2019-03-15', 345, NULL),
('Candlewood Suites', 80, '2019-03-16', 350, NULL),
('Candlewood Suites', 80, '2019-03-17', 202, NULL),
('Candlewood Suites', 80, '2019-03-18', 289, NULL),
('Candlewood Suites', 80, '2019-03-19', 219, NULL),
('Candlewood Suites', 80, '2019-03-20', 116, NULL),
('Candlewood Suites', 80, '2019-03-21', 319, NULL),
('Candlewood Suites', 80, '2019-03-22', 236, NULL),
('Candlewood Suites', 80, '2019-03-23', 383, NULL),
('Candlewood Suites', 80, '2019-03-24', 178, NULL),
('Candlewood Suites', 80, '2019-03-25', 199, NULL),
('Candlewood Suites', 80, '2019-03-26', 294, NULL),
('Candlewood Suites', 80, '2019-03-27', 138, NULL),
('Candlewood Suites', 80, '2019-03-28', 368, NULL),
('Candlewood Suites', 80, '2019-03-29', 168, NULL),
('Candlewood Suites', 80, '2019-03-30', 209, NULL),
('Candlewood Suites', 80, '2019-03-31', 118, NULL),
('Candlewood Suites', 80, '2019-04-01', 288, NULL),
('Candlewood Suites', 80, '2019-04-02', 325, NULL),
('Candlewood Suites', 80, '2019-04-03', 257, NULL),
('Candlewood Suites', 80, '2019-04-04', 158, NULL),
('Candlewood Suites', 80, '2019-04-05', 368, NULL),
('Candlewood Suites', 80, '2019-04-06', 395, NULL),
('Candlewood Suites', 80, '2019-04-07', 265, NULL),
('Candlewood Suites', 80, '2019-04-08', 382, NULL),
('Candlewood Suites', 80, '2019-04-09', 377, NULL),
('Candlewood Suites', 80, '2019-04-10', 147, NULL),
('Candlewood Suites', 80, '2019-04-11', 341, NULL),
('Candlewood Suites', 80, '2019-04-12', 316, NULL),
('Candlewood Suites', 80, '2019-04-13', 148, NULL),
('Candlewood Suites', 80, '2019-04-14', 147, NULL),
('Candlewood Suites', 80, '2019-04-15', 270, NULL),
('Candlewood Suites', 80, '2019-04-16', 317, NULL),
('Candlewood Suites', 80, '2019-04-17', 263, NULL),
('Candlewood Suites', 80, '2019-04-18', 149, NULL),
('Candlewood Suites', 80, '2019-04-19', 352, NULL),
('Candlewood Suites', 80, '2019-04-20', 146, NULL),
('Candlewood Suites', 80, '2019-04-21', 194, NULL),
('Candlewood Suites', 80, '2019-04-22', 334, NULL),
('Candlewood Suites', 80, '2019-04-23', 349, NULL),
('Candlewood Suites', 80, '2019-04-24', 317, NULL),
('Candlewood Suites', 80, '2019-04-25', 276, NULL),
('Candlewood Suites', 80, '2019-04-26', 341, NULL),
('Candlewood Suites', 80, '2019-04-27', 376, NULL),
('Candlewood Suites', 80, '2019-04-28', 127, NULL),
('Candlewood Suites', 80, '2019-04-29', 153, NULL),
('Candlewood Suites', 80, '2019-04-30', 144, NULL),
('Candlewood Suites', 80, '2019-05-01', 238, NULL),
('Candlewood Suites', 80, '2019-05-02', 105, NULL),
('Candlewood Suites', 80, '2019-05-03', 175, NULL),
('Candlewood Suites', 80, '2019-05-04', 304, NULL),
('Candlewood Suites', 80, '2019-05-05', 163, NULL),
('Candlewood Suites', 80, '2019-05-06', 321, NULL),
('Candlewood Suites', 80, '2019-05-07', 204, NULL),
('Candlewood Suites', 80, '2019-05-08', 182, NULL),
('Candlewood Suites', 80, '2019-05-09', 167, NULL),
('Candlewood Suites', 80, '2019-05-10', 355, NULL),
('Candlewood Suites', 80, '2019-05-11', 304, NULL),
('Candlewood Suites', 80, '2019-05-12', 372, NULL),
('Candlewood Suites', 80, '2019-05-13', 384, NULL),
('Candlewood Suites', 80, '2019-05-14', 315, NULL),
('Candlewood Suites', 80, '2019-05-15', 274, NULL),
('Candlewood Suites', 80, '2019-05-16', 329, NULL),
('Candlewood Suites', 80, '2019-05-17', 199, NULL),
('Candlewood Suites', 80, '2019-05-18', 331, NULL),
('Candlewood Suites', 80, '2019-05-19', 258, NULL),
('Candlewood Suites', 80, '2019-05-20', 211, NULL),
('Candlewood Suites', 80, '2019-05-21', 197, NULL),
('Candlewood Suites', 80, '2019-05-22', 260, NULL),
('Candlewood Suites', 80, '2019-05-23', 135, NULL),
('Candlewood Suites', 80, '2019-05-24', 182, NULL),
('Candlewood Suites', 80, '2019-05-25', 153, NULL),
('Candlewood Suites', 80, '2019-05-26', 174, NULL),
('Candlewood Suites', 80, '2019-05-27', 193, NULL),
('Candlewood Suites', 80, '2019-05-28', 310, NULL),
('Candlewood Suites', 80, '2019-05-29', 180, NULL),
('Candlewood Suites', 80, '2019-05-30', 353, NULL),
('Candlewood Suites', 80, '2019-05-31', 133, NULL),
('Candlewood Suites', 80, '2019-06-01', 364, NULL),
('Candlewood Suites', 80, '2019-06-02', 398, NULL),
('Candlewood Suites', 80, '2019-06-03', 388, NULL),
('Candlewood Suites', 80, '2019-06-04', 399, NULL),
('Candlewood Suites', 80, '2019-06-05', 127, NULL),
('Candlewood Suites', 80, '2019-06-06', 176, NULL),
('Candlewood Suites', 80, '2019-06-07', 214, NULL),
('Candlewood Suites', 80, '2019-06-08', 379, NULL),
('Candlewood Suites', 80, '2019-06-09', 202, NULL),
('Candlewood Suites', 80, '2019-06-10', 266, NULL),
('Candlewood Suites', 80, '2019-06-11', 367, NULL),
('Candlewood Suites', 80, '2019-06-12', 337, NULL),
('Candlewood Suites', 80, '2019-06-13', 289, NULL),
('Candlewood Suites', 80, '2019-06-14', 293, NULL),
('Candlewood Suites', 80, '2019-06-15', 395, NULL),
('Candlewood Suites', 80, '2019-06-16', 291, NULL),
('Candlewood Suites', 80, '2019-06-17', 122, NULL),
('Candlewood Suites', 80, '2019-06-18', 298, NULL),
('Candlewood Suites', 80, '2019-06-19', 334, NULL),
('Candlewood Suites', 80, '2019-06-20', 117, NULL),
('Candlewood Suites', 80, '2019-06-21', 304, NULL),
('Candlewood Suites', 80, '2019-06-22', 102, NULL),
('Candlewood Suites', 80, '2019-06-23', 265, NULL),
('Candlewood Suites', 80, '2019-06-24', 161, NULL),
('Candlewood Suites', 80, '2019-06-25', 137, NULL),
('Candlewood Suites', 80, '2019-06-26', 262, NULL),
('Candlewood Suites', 80, '2019-06-27', 189, NULL),
('Candlewood Suites', 80, '2019-06-28', 397, NULL),
('Candlewood Suites', 80, '2019-06-29', 367, NULL),
('Candlewood Suites', 80, '2019-06-30', 103, NULL),
('Candlewood Suites', 80, '2019-07-01', 127, NULL),
('Candlewood Suites', 80, '2019-07-02', 329, NULL),
('Candlewood Suites', 80, '2019-07-03', 246, NULL),
('Candlewood Suites', 80, '2019-07-04', 104, NULL),
('Candlewood Suites', 80, '2019-07-05', 343, NULL),
('Candlewood Suites', 80, '2019-07-06', 221, NULL),
('Candlewood Suites', 80, '2019-07-07', 393, NULL),
('Candlewood Suites', 80, '2019-07-08', 198, NULL),
('Candlewood Suites', 80, '2019-07-09', 115, NULL),
('Candlewood Suites', 80, '2019-07-10', 394, NULL),
('Candlewood Suites', 80, '2019-07-11', 209, NULL),
('Candlewood Suites', 80, '2019-07-12', 122, NULL),
('Candlewood Suites', 80, '2019-07-13', 152, NULL),
('Candlewood Suites', 80, '2019-07-14', 204, NULL),
('Candlewood Suites', 80, '2019-07-15', 288, NULL),
('Candlewood Suites', 80, '2019-07-16', 341, NULL),
('Candlewood Suites', 80, '2019-07-17', 278, NULL),
('Candlewood Suites', 80, '2019-07-18', 342, NULL),
('Candlewood Suites', 80, '2019-07-19', 229, NULL),
('Candlewood Suites', 80, '2019-07-20', 334, NULL),
('Candlewood Suites', 80, '2019-07-21', 238, NULL),
('Candlewood Suites', 80, '2019-07-22', 266, NULL),
('Candlewood Suites', 80, '2019-07-23', 216, NULL),
('Candlewood Suites', 80, '2019-07-24', 399, NULL),
('Candlewood Suites', 80, '2019-07-25', 114, NULL),
('Candlewood Suites', 80, '2019-07-26', 191, NULL),
('Candlewood Suites', 80, '2019-07-27', 191, NULL),
('Candlewood Suites', 80, '2019-07-28', 104, NULL),
('Candlewood Suites', 80, '2019-07-29', 254, NULL),
('Candlewood Suites', 80, '2019-07-30', 113, NULL),
('Candlewood Suites', 80, '2019-07-31', 279, NULL),
('Candlewood Suites', 80, '2019-08-01', 321, NULL),
('Candlewood Suites', 80, '2019-08-02', 145, NULL),
('Candlewood Suites', 80, '2019-08-03', 160, NULL),
('Candlewood Suites', 80, '2019-08-04', 290, NULL),
('Candlewood Suites', 80, '2019-08-05', 258, NULL),
('Candlewood Suites', 80, '2019-08-06', 193, NULL),
('Candlewood Suites', 80, '2019-08-07', 341, NULL),
('Candlewood Suites', 80, '2019-08-08', 313, NULL),
('Candlewood Suites', 80, '2019-08-09', 383, NULL),
('Candlewood Suites', 80, '2019-08-10', 299, NULL),
('Candlewood Suites', 80, '2019-08-11', 313, NULL),
('Candlewood Suites', 80, '2019-08-12', 365, NULL),
('Candlewood Suites', 80, '2019-08-13', 103, NULL),
('Candlewood Suites', 80, '2019-08-14', 236, NULL),
('Candlewood Suites', 80, '2019-08-15', 329, NULL),
('Candlewood Suites', 80, '2019-08-16', 313, NULL),
('Candlewood Suites', 80, '2019-08-17', 112, NULL),
('Candlewood Suites', 80, '2019-08-18', 313, NULL),
('Candlewood Suites', 80, '2019-08-19', 399, NULL),
('Candlewood Suites', 80, '2019-08-20', 396, NULL),
('Candlewood Suites', 80, '2019-08-21', 394, NULL),
('Candlewood Suites', 80, '2019-08-22', 298, NULL),
('Candlewood Suites', 80, '2019-08-23', 217, NULL),
('Candlewood Suites', 80, '2019-08-24', 118, NULL),
('Candlewood Suites', 80, '2019-08-25', 392, NULL),
('Candlewood Suites', 80, '2019-08-26', 204, NULL),
('Candlewood Suites', 80, '2019-08-27', 171, NULL),
('Candlewood Suites', 80, '2019-08-28', 177, NULL),
('Candlewood Suites', 80, '2019-08-29', 313, NULL),
('Candlewood Suites', 80, '2019-08-30', 252, NULL),
('Candlewood Suites', 80, '2019-08-31', 247, NULL),
('Candlewood Suites', 80, '2019-09-01', 236, NULL),
('Candlewood Suites', 80, '2019-09-02', 129, NULL),
('Candlewood Suites', 80, '2019-09-03', 384, NULL),
('Candlewood Suites', 80, '2019-09-04', 115, NULL),
('Candlewood Suites', 80, '2019-09-05', 172, NULL),
('Candlewood Suites', 80, '2019-09-06', 133, NULL),
('Candlewood Suites', 80, '2019-09-07', 318, NULL),
('Candlewood Suites', 80, '2019-09-08', 394, NULL),
('Candlewood Suites', 80, '2019-09-09', 216, NULL),
('Candlewood Suites', 80, '2019-09-10', 151, NULL),
('Candlewood Suites', 80, '2019-09-11', 298, NULL),
('Candlewood Suites', 80, '2019-09-12', 285, NULL),
('Candlewood Suites', 80, '2019-09-13', 334, NULL),
('Candlewood Suites', 80, '2019-09-14', 200, NULL),
('Candlewood Suites', 80, '2019-09-15', 302, NULL),
('Candlewood Suites', 80, '2019-09-16', 324, NULL),
('Candlewood Suites', 80, '2019-09-17', 283, NULL),
('Candlewood Suites', 80, '2019-09-18', 193, NULL),
('Candlewood Suites', 80, '2019-09-19', 136, NULL),
('Candlewood Suites', 80, '2019-09-20', 341, NULL),
('Candlewood Suites', 80, '2019-09-21', 239, NULL),
('Candlewood Suites', 80, '2019-09-22', 337, NULL),
('Candlewood Suites', 80, '2019-09-23', 273, NULL),
('Candlewood Suites', 80, '2019-09-24', 328, NULL),
('Candlewood Suites', 80, '2019-09-25', 384, NULL),
('Candlewood Suites', 80, '2019-09-26', 269, NULL),
('Candlewood Suites', 80, '2019-09-27', 370, NULL),
('Candlewood Suites', 80, '2019-09-28', 359, NULL),
('Candlewood Suites', 80, '2019-09-29', 283, NULL),
('Candlewood Suites', 80, '2019-09-30', 142, NULL),
('Candlewood Suites', 80, '2019-10-01', 305, NULL),
('Candlewood Suites', 80, '2019-10-02', 324, NULL),
('Candlewood Suites', 80, '2019-10-03', 244, NULL),
('Candlewood Suites', 80, '2019-10-04', 323, NULL),
('Candlewood Suites', 80, '2019-10-05', 251, NULL),
('Candlewood Suites', 80, '2019-10-06', 387, NULL),
('Candlewood Suites', 80, '2019-10-07', 242, NULL),
('Candlewood Suites', 80, '2019-10-08', 343, NULL),
('Candlewood Suites', 80, '2019-10-09', 327, NULL),
('Candlewood Suites', 80, '2019-10-10', 200, NULL),
('Candlewood Suites', 80, '2019-10-11', 213, NULL),
('Candlewood Suites', 80, '2019-10-12', 276, NULL),
('Candlewood Suites', 80, '2019-10-13', 323, NULL),
('Candlewood Suites', 80, '2019-10-14', 114, NULL),
('Candlewood Suites', 80, '2019-10-15', 104, NULL),
('Candlewood Suites', 80, '2019-10-16', 307, NULL),
('Candlewood Suites', 80, '2019-10-17', 175, NULL),
('Candlewood Suites', 80, '2019-10-18', 164, NULL),
('Candlewood Suites', 80, '2019-10-19', 150, NULL),
('Candlewood Suites', 80, '2019-10-20', 250, NULL),
('Candlewood Suites', 80, '2019-10-21', 301, NULL),
('Candlewood Suites', 80, '2019-10-22', 115, NULL),
('Candlewood Suites', 80, '2019-10-23', 131, NULL),
('Candlewood Suites', 80, '2019-10-24', 187, NULL),
('Candlewood Suites', 80, '2019-10-25', 296, NULL),
('Candlewood Suites', 80, '2019-10-26', 321, NULL),
('Candlewood Suites', 80, '2019-10-27', 236, NULL),
('Candlewood Suites', 80, '2019-10-28', 268, NULL),
('Candlewood Suites', 80, '2019-10-29', 374, NULL),
('Candlewood Suites', 80, '2019-10-30', 286, NULL),
('Candlewood Suites', 80, '2019-10-31', 272, NULL),
('Candlewood Suites', 80, '2019-11-01', 302, NULL),
('Candlewood Suites', 80, '2019-11-02', 206, NULL),
('Candlewood Suites', 80, '2019-11-03', 365, NULL),
('Candlewood Suites', 80, '2019-11-04', 232, NULL),
('Candlewood Suites', 80, '2019-11-05', 345, NULL),
('Candlewood Suites', 80, '2019-11-06', 381, NULL),
('Candlewood Suites', 80, '2019-11-07', 358, NULL),
('Candlewood Suites', 80, '2019-11-08', 350, NULL),
('Candlewood Suites', 80, '2019-11-09', 114, NULL),
('Candlewood Suites', 80, '2019-11-10', 158, NULL),
('Candlewood Suites', 80, '2019-11-11', 261, NULL),
('Candlewood Suites', 80, '2019-11-12', 378, NULL),
('Candlewood Suites', 80, '2019-11-13', 144, NULL),
('Candlewood Suites', 80, '2019-11-14', 388, NULL),
('Candlewood Suites', 80, '2019-11-15', 199, NULL),
('Candlewood Suites', 80, '2019-11-16', 108, NULL),
('Candlewood Suites', 80, '2019-11-17', 279, NULL),
('Candlewood Suites', 80, '2019-11-18', 171, NULL),
('Candlewood Suites', 80, '2019-11-19', 122, NULL),
('Candlewood Suites', 80, '2019-11-20', 332, NULL),
('Candlewood Suites', 80, '2019-11-21', 229, NULL),
('Candlewood Suites', 80, '2019-11-22', 174, NULL),
('Candlewood Suites', 80, '2019-11-23', 261, NULL),
('Candlewood Suites', 80, '2019-11-24', 264, NULL),
('Candlewood Suites', 80, '2019-11-25', 217, NULL),
('Candlewood Suites', 80, '2019-11-26', 386, NULL),
('Candlewood Suites', 80, '2019-11-27', 320, NULL),
('Candlewood Suites', 80, '2019-11-28', 252, NULL),
('Candlewood Suites', 80, '2019-11-29', 211, NULL),
('Candlewood Suites', 80, '2019-11-30', 229, NULL),
('Candlewood Suites', 80, '2019-12-01', 204, NULL),
('Candlewood Suites', 80, '2019-12-02', 260, NULL),
('Candlewood Suites', 80, '2019-12-03', 390, NULL),
('Candlewood Suites', 80, '2019-12-04', 331, NULL),
('Candlewood Suites', 80, '2019-12-05', 213, NULL),
('Candlewood Suites', 80, '2019-12-06', 398, NULL),
('Candlewood Suites', 80, '2019-12-07', 224, NULL),
('Candlewood Suites', 80, '2019-12-08', 245, NULL),
('Candlewood Suites', 80, '2019-12-09', 196, NULL),
('Candlewood Suites', 80, '2019-12-10', 216, NULL),
('Candlewood Suites', 80, '2019-12-11', 183, NULL),
('Candlewood Suites', 80, '2019-12-12', 103, NULL),
('Candlewood Suites', 80, '2019-12-13', 204, NULL),
('Candlewood Suites', 80, '2019-12-14', 319, NULL),
('Candlewood Suites', 80, '2019-12-15', 173, NULL),
('Candlewood Suites', 80, '2019-12-16', 231, NULL),
('Candlewood Suites', 80, '2019-12-17', 361, NULL),
('Candlewood Suites', 80, '2019-12-18', 373, NULL),
('Candlewood Suites', 80, '2019-12-19', 204, NULL),
('Candlewood Suites', 80, '2019-12-20', 229, NULL),
('Candlewood Suites', 80, '2019-12-21', 279, NULL),
('Candlewood Suites', 80, '2019-12-22', 366, NULL),
('Candlewood Suites', 80, '2019-12-23', 130, NULL),
('Candlewood Suites', 80, '2019-12-24', 338, NULL),
('Candlewood Suites', 80, '2019-12-25', 245, NULL),
('Candlewood Suites', 80, '2019-12-26', 290, NULL),
('Candlewood Suites', 80, '2019-12-27', 324, NULL),
('Candlewood Suites', 80, '2019-12-28', 290, NULL),
('Candlewood Suites', 80, '2019-12-29', 111, NULL),
('Candlewood Suites', 80, '2019-12-30', 160, NULL),
('Candlewood Suites', 80, '2019-12-31', 146, NULL),
('Candlewood Suites', 80, '2020-01-01', 168, NULL),
('Candlewood Suites', 80, '2020-01-02', 136, NULL),
('Candlewood Suites', 80, '2020-01-03', 269, NULL),
('Candlewood Suites', 80, '2020-01-04', 331, NULL),
('Candlewood Suites', 80, '2020-01-05', 347, NULL),
('Candlewood Suites', 80, '2020-01-06', 317, NULL),
('Candlewood Suites', 80, '2020-01-07', 140, NULL),
('Candlewood Suites', 80, '2020-01-08', 373, NULL),
('Candlewood Suites', 80, '2020-01-09', 198, NULL),
('Candlewood Suites', 80, '2020-01-10', 135, NULL),
('Candlewood Suites', 80, '2020-01-11', 278, NULL),
('Candlewood Suites', 80, '2020-01-12', 241, NULL),
('Candlewood Suites', 80, '2020-01-13', 228, NULL),
('Candlewood Suites', 80, '2020-01-14', 110, NULL),
('Candlewood Suites', 80, '2020-01-15', 224, NULL),
('Candlewood Suites', 80, '2020-01-16', 204, NULL),
('Candlewood Suites', 80, '2020-01-17', 333, NULL),
('Candlewood Suites', 80, '2020-01-18', 370, NULL),
('Candlewood Suites', 80, '2020-01-19', 287, NULL),
('Candlewood Suites', 80, '2020-01-20', 129, NULL),
('Candlewood Suites', 80, '2020-01-21', 346, NULL),
('Candlewood Suites', 80, '2020-01-22', 233, NULL),
('Candlewood Suites', 80, '2020-01-23', 268, NULL),
('Candlewood Suites', 80, '2020-01-24', 227, NULL),
('Candlewood Suites', 80, '2020-01-25', 177, NULL),
('Candlewood Suites', 80, '2020-01-26', 319, NULL),
('Candlewood Suites', 80, '2020-01-27', 206, NULL),
('Candlewood Suites', 80, '2020-01-28', 196, NULL),
('Candlewood Suites', 80, '2020-01-29', 379, NULL),
('Candlewood Suites', 80, '2020-01-30', 272, NULL),
('Candlewood Suites', 80, '2020-01-31', 163, NULL),
('Candlewood Suites', 80, '2020-02-01', 101, NULL),
('Candlewood Suites', 80, '2020-02-02', 195, NULL),
('Candlewood Suites', 80, '2020-02-03', 314, NULL),
('Candlewood Suites', 80, '2020-02-04', 169, NULL),
('Candlewood Suites', 82, '2019-01-01', 110, NULL),
('Candlewood Suites', 82, '2019-01-02', 156, NULL),
('Candlewood Suites', 82, '2019-01-03', 322, NULL),
('Candlewood Suites', 82, '2019-01-04', 244, NULL),
('Candlewood Suites', 82, '2019-01-05', 201, NULL),
('Candlewood Suites', 82, '2019-01-06', 200, NULL),
('Candlewood Suites', 82, '2019-01-07', 326, NULL),
('Candlewood Suites', 82, '2019-01-08', 106, NULL),
('Candlewood Suites', 82, '2019-01-09', 372, NULL),
('Candlewood Suites', 82, '2019-01-10', 331, NULL),
('Candlewood Suites', 82, '2019-01-11', 207, NULL),
('Candlewood Suites', 82, '2019-01-12', 350, NULL),
('Candlewood Suites', 82, '2019-01-13', 359, NULL),
('Candlewood Suites', 82, '2019-01-14', 156, NULL),
('Candlewood Suites', 82, '2019-01-15', 285, NULL),
('Candlewood Suites', 82, '2019-01-16', 259, NULL),
('Candlewood Suites', 82, '2019-01-17', 231, NULL),
('Candlewood Suites', 82, '2019-01-18', 182, NULL),
('Candlewood Suites', 82, '2019-01-19', 250, NULL),
('Candlewood Suites', 82, '2019-01-20', 128, NULL),
('Candlewood Suites', 82, '2019-01-21', 202, NULL),
('Candlewood Suites', 82, '2019-01-22', 248, NULL),
('Candlewood Suites', 82, '2019-01-23', 179, NULL),
('Candlewood Suites', 82, '2019-01-24', 196, NULL),
('Candlewood Suites', 82, '2019-01-25', 190, NULL),
('Candlewood Suites', 82, '2019-01-26', 132, NULL),
('Candlewood Suites', 82, '2019-01-27', 184, NULL),
('Candlewood Suites', 82, '2019-01-28', 186, NULL),
('Candlewood Suites', 82, '2019-01-29', 187, NULL),
('Candlewood Suites', 82, '2019-01-30', 327, NULL),
('Candlewood Suites', 82, '2019-01-31', 190, NULL),
('Candlewood Suites', 82, '2019-02-01', 210, NULL),
('Candlewood Suites', 82, '2019-02-02', 347, NULL),
('Candlewood Suites', 82, '2019-02-03', 255, NULL),
('Candlewood Suites', 82, '2019-02-04', 338, NULL),
('Candlewood Suites', 82, '2019-02-05', 359, NULL),
('Candlewood Suites', 82, '2019-02-06', 320, NULL),
('Candlewood Suites', 82, '2019-02-07', 127, NULL),
('Candlewood Suites', 82, '2019-02-08', 358, NULL),
('Candlewood Suites', 82, '2019-02-09', 311, NULL),
('Candlewood Suites', 82, '2019-02-10', 257, NULL),
('Candlewood Suites', 82, '2019-02-11', 320, NULL),
('Candlewood Suites', 82, '2019-02-12', 126, NULL),
('Candlewood Suites', 82, '2019-02-13', 210, NULL),
('Candlewood Suites', 82, '2019-02-14', 307, NULL),
('Candlewood Suites', 82, '2019-02-15', 342, NULL),
('Candlewood Suites', 82, '2019-02-16', 321, NULL),
('Candlewood Suites', 82, '2019-02-17', 370, NULL),
('Candlewood Suites', 82, '2019-02-18', 208, NULL),
('Candlewood Suites', 82, '2019-02-19', 252, NULL),
('Candlewood Suites', 82, '2019-02-20', 326, NULL),
('Candlewood Suites', 82, '2019-02-21', 323, NULL),
('Candlewood Suites', 82, '2019-02-22', 242, NULL),
('Candlewood Suites', 82, '2019-02-23', 239, NULL),
('Candlewood Suites', 82, '2019-02-24', 253, NULL),
('Candlewood Suites', 82, '2019-02-25', 192, NULL),
('Candlewood Suites', 82, '2019-02-26', 286, NULL),
('Candlewood Suites', 82, '2019-02-27', 193, NULL),
('Candlewood Suites', 82, '2019-02-28', 374, NULL),
('Candlewood Suites', 82, '2019-03-01', 112, NULL),
('Candlewood Suites', 82, '2019-03-02', 362, NULL),
('Candlewood Suites', 82, '2019-03-03', 274, NULL),
('Candlewood Suites', 82, '2019-03-04', 190, NULL),
('Candlewood Suites', 82, '2019-03-05', 210, NULL),
('Candlewood Suites', 82, '2019-03-06', 226, NULL),
('Candlewood Suites', 82, '2019-03-07', 294, NULL),
('Candlewood Suites', 82, '2019-03-08', 165, NULL),
('Candlewood Suites', 82, '2019-03-09', 118, NULL),
('Candlewood Suites', 82, '2019-03-10', 339, NULL),
('Candlewood Suites', 82, '2019-03-11', 199, NULL),
('Candlewood Suites', 82, '2019-03-12', 109, NULL),
('Candlewood Suites', 82, '2019-03-13', 231, NULL),
('Candlewood Suites', 82, '2019-03-14', 170, NULL),
('Candlewood Suites', 82, '2019-03-15', 343, NULL),
('Candlewood Suites', 82, '2019-03-16', 184, NULL),
('Candlewood Suites', 82, '2019-03-17', 259, NULL),
('Candlewood Suites', 82, '2019-03-18', 154, NULL),
('Candlewood Suites', 82, '2019-03-19', 125, NULL),
('Candlewood Suites', 82, '2019-03-20', 247, NULL),
('Candlewood Suites', 82, '2019-03-21', 161, NULL),
('Candlewood Suites', 82, '2019-03-22', 244, NULL),
('Candlewood Suites', 82, '2019-03-23', 287, NULL),
('Candlewood Suites', 82, '2019-03-24', 177, NULL),
('Candlewood Suites', 82, '2019-03-25', 249, NULL),
('Candlewood Suites', 82, '2019-03-26', 233, NULL),
('Candlewood Suites', 82, '2019-03-27', 367, NULL),
('Candlewood Suites', 82, '2019-03-28', 391, NULL),
('Candlewood Suites', 82, '2019-03-29', 125, NULL),
('Candlewood Suites', 82, '2019-03-30', 192, NULL),
('Candlewood Suites', 82, '2019-03-31', 324, NULL),
('Candlewood Suites', 82, '2019-04-01', 236, NULL),
('Candlewood Suites', 82, '2019-04-02', 332, NULL),
('Candlewood Suites', 82, '2019-04-03', 249, NULL),
('Candlewood Suites', 82, '2019-04-04', 226, NULL),
('Candlewood Suites', 82, '2019-04-05', 204, NULL),
('Candlewood Suites', 82, '2019-04-06', 248, NULL),
('Candlewood Suites', 82, '2019-04-07', 102, NULL),
('Candlewood Suites', 82, '2019-04-08', 225, NULL),
('Candlewood Suites', 82, '2019-04-09', 203, NULL),
('Candlewood Suites', 82, '2019-04-10', 228, NULL),
('Candlewood Suites', 82, '2019-04-11', 367, NULL),
('Candlewood Suites', 82, '2019-04-12', 348, NULL),
('Candlewood Suites', 82, '2019-04-13', 282, NULL),
('Candlewood Suites', 82, '2019-04-14', 190, NULL),
('Candlewood Suites', 82, '2019-04-15', 363, NULL),
('Candlewood Suites', 82, '2019-04-16', 114, NULL),
('Candlewood Suites', 82, '2019-04-17', 308, NULL),
('Candlewood Suites', 82, '2019-04-18', 194, NULL),
('Candlewood Suites', 82, '2019-04-19', 324, NULL),
('Candlewood Suites', 82, '2019-04-20', 105, NULL),
('Candlewood Suites', 82, '2019-04-21', 220, NULL),
('Candlewood Suites', 82, '2019-04-22', 146, NULL),
('Candlewood Suites', 82, '2019-04-23', 137, NULL),
('Candlewood Suites', 82, '2019-04-24', 304, NULL),
('Candlewood Suites', 82, '2019-04-25', 272, NULL),
('Candlewood Suites', 82, '2019-04-26', 369, NULL),
('Candlewood Suites', 82, '2019-04-27', 192, NULL),
('Candlewood Suites', 82, '2019-04-28', 245, NULL),
('Candlewood Suites', 82, '2019-04-29', 172, NULL),
('Candlewood Suites', 82, '2019-04-30', 119, NULL),
('Candlewood Suites', 82, '2019-05-01', 362, NULL),
('Candlewood Suites', 82, '2019-05-02', 308, NULL),
('Candlewood Suites', 82, '2019-05-03', 199, NULL),
('Candlewood Suites', 82, '2019-05-04', 169, NULL),
('Candlewood Suites', 82, '2019-05-05', 304, NULL),
('Candlewood Suites', 82, '2019-05-06', 329, NULL),
('Candlewood Suites', 82, '2019-05-07', 304, NULL),
('Candlewood Suites', 82, '2019-05-08', 155, NULL),
('Candlewood Suites', 82, '2019-05-09', 370, NULL),
('Candlewood Suites', 82, '2019-05-10', 325, NULL),
('Candlewood Suites', 82, '2019-05-11', 130, NULL),
('Candlewood Suites', 82, '2019-05-12', 326, NULL),
('Candlewood Suites', 82, '2019-05-13', 278, NULL),
('Candlewood Suites', 82, '2019-05-14', 312, NULL),
('Candlewood Suites', 82, '2019-05-15', 335, NULL),
('Candlewood Suites', 82, '2019-05-16', 343, NULL),
('Candlewood Suites', 82, '2019-05-17', 399, NULL),
('Candlewood Suites', 82, '2019-05-18', 389, NULL),
('Candlewood Suites', 82, '2019-05-19', 306, NULL),
('Candlewood Suites', 82, '2019-05-20', 274, NULL),
('Candlewood Suites', 82, '2019-05-21', 387, NULL),
('Candlewood Suites', 82, '2019-05-22', 353, NULL),
('Candlewood Suites', 82, '2019-05-23', 289, NULL),
('Candlewood Suites', 82, '2019-05-24', 239, NULL),
('Candlewood Suites', 82, '2019-05-25', 256, NULL),
('Candlewood Suites', 82, '2019-05-26', 268, NULL),
('Candlewood Suites', 82, '2019-05-27', 214, NULL),
('Candlewood Suites', 82, '2019-05-28', 182, NULL),
('Candlewood Suites', 82, '2019-05-29', 317, NULL),
('Candlewood Suites', 82, '2019-05-30', 360, NULL),
('Candlewood Suites', 82, '2019-05-31', 216, NULL),
('Candlewood Suites', 82, '2019-06-01', 130, NULL),
('Candlewood Suites', 82, '2019-06-02', 370, NULL),
('Candlewood Suites', 82, '2019-06-03', 226, NULL),
('Candlewood Suites', 82, '2019-06-04', 331, NULL),
('Candlewood Suites', 82, '2019-06-05', 123, NULL),
('Candlewood Suites', 82, '2019-06-06', 228, NULL),
('Candlewood Suites', 82, '2019-06-07', 389, NULL),
('Candlewood Suites', 82, '2019-06-08', 145, NULL),
('Candlewood Suites', 82, '2019-06-09', 159, NULL),
('Candlewood Suites', 82, '2019-06-10', 146, NULL),
('Candlewood Suites', 82, '2019-06-11', 105, NULL),
('Candlewood Suites', 82, '2019-06-12', 173, NULL),
('Candlewood Suites', 82, '2019-06-13', 276, NULL),
('Candlewood Suites', 82, '2019-06-14', 226, NULL),
('Candlewood Suites', 82, '2019-06-15', 227, NULL),
('Candlewood Suites', 82, '2019-06-16', 218, NULL),
('Candlewood Suites', 82, '2019-06-17', 331, NULL),
('Candlewood Suites', 82, '2019-06-18', 233, NULL),
('Candlewood Suites', 82, '2019-06-19', 173, NULL),
('Candlewood Suites', 82, '2019-06-20', 126, NULL),
('Candlewood Suites', 82, '2019-06-21', 219, NULL),
('Candlewood Suites', 82, '2019-06-22', 189, NULL),
('Candlewood Suites', 82, '2019-06-23', 243, NULL),
('Candlewood Suites', 82, '2019-06-24', 226, NULL),
('Candlewood Suites', 82, '2019-06-25', 215, NULL),
('Candlewood Suites', 82, '2019-06-26', 181, NULL),
('Candlewood Suites', 82, '2019-06-27', 106, NULL),
('Candlewood Suites', 82, '2019-06-28', 341, NULL),
('Candlewood Suites', 82, '2019-06-29', 138, NULL),
('Candlewood Suites', 82, '2019-06-30', 112, NULL),
('Candlewood Suites', 82, '2019-07-01', 107, NULL),
('Candlewood Suites', 82, '2019-07-02', 372, NULL),
('Candlewood Suites', 82, '2019-07-03', 187, NULL),
('Candlewood Suites', 82, '2019-07-04', 228, NULL),
('Candlewood Suites', 82, '2019-07-05', 123, NULL),
('Candlewood Suites', 82, '2019-07-06', 273, NULL),
('Candlewood Suites', 82, '2019-07-07', 265, NULL),
('Candlewood Suites', 82, '2019-07-08', 126, NULL),
('Candlewood Suites', 82, '2019-07-09', 348, NULL),
('Candlewood Suites', 82, '2019-07-10', 201, NULL),
('Candlewood Suites', 82, '2019-07-11', 375, NULL),
('Candlewood Suites', 82, '2019-07-12', 259, NULL),
('Candlewood Suites', 82, '2019-07-13', 202, NULL),
('Candlewood Suites', 82, '2019-07-14', 245, NULL),
('Candlewood Suites', 82, '2019-07-15', 237, NULL),
('Candlewood Suites', 82, '2019-07-16', 289, NULL),
('Candlewood Suites', 82, '2019-07-17', 316, NULL),
('Candlewood Suites', 82, '2019-07-18', 118, NULL),
('Candlewood Suites', 82, '2019-07-19', 369, NULL),
('Candlewood Suites', 82, '2019-07-20', 370, NULL),
('Candlewood Suites', 82, '2019-07-21', 270, NULL),
('Candlewood Suites', 82, '2019-07-22', 199, NULL),
('Candlewood Suites', 82, '2019-07-23', 194, NULL),
('Candlewood Suites', 82, '2019-07-24', 113, NULL),
('Candlewood Suites', 82, '2019-07-25', 143, NULL),
('Candlewood Suites', 82, '2019-07-26', 241, NULL),
('Candlewood Suites', 82, '2019-07-27', 245, NULL),
('Candlewood Suites', 82, '2019-07-28', 378, NULL),
('Candlewood Suites', 82, '2019-07-29', 359, NULL),
('Candlewood Suites', 82, '2019-07-30', 122, NULL),
('Candlewood Suites', 82, '2019-07-31', 257, NULL),
('Candlewood Suites', 82, '2019-08-01', 200, NULL),
('Candlewood Suites', 82, '2019-08-02', 146, NULL),
('Candlewood Suites', 82, '2019-08-03', 358, NULL),
('Candlewood Suites', 82, '2019-08-04', 148, NULL),
('Candlewood Suites', 82, '2019-08-05', 268, NULL),
('Candlewood Suites', 82, '2019-08-06', 299, NULL),
('Candlewood Suites', 82, '2019-08-07', 307, NULL),
('Candlewood Suites', 82, '2019-08-08', 186, NULL),
('Candlewood Suites', 82, '2019-08-09', 333, NULL),
('Candlewood Suites', 82, '2019-08-10', 147, NULL),
('Candlewood Suites', 82, '2019-08-11', 241, NULL),
('Candlewood Suites', 82, '2019-08-12', 373, NULL),
('Candlewood Suites', 82, '2019-08-13', 258, NULL),
('Candlewood Suites', 82, '2019-08-14', 177, NULL),
('Candlewood Suites', 82, '2019-08-15', 208, NULL),
('Candlewood Suites', 82, '2019-08-16', 304, NULL),
('Candlewood Suites', 82, '2019-08-17', 178, NULL),
('Candlewood Suites', 82, '2019-08-18', 183, NULL),
('Candlewood Suites', 82, '2019-08-19', 365, NULL),
('Candlewood Suites', 82, '2019-08-20', 228, NULL),
('Candlewood Suites', 82, '2019-08-21', 354, NULL),
('Candlewood Suites', 82, '2019-08-22', 137, NULL),
('Candlewood Suites', 82, '2019-08-23', 157, NULL),
('Candlewood Suites', 82, '2019-08-24', 326, NULL),
('Candlewood Suites', 82, '2019-08-25', 329, NULL),
('Candlewood Suites', 82, '2019-08-26', 231, NULL),
('Candlewood Suites', 82, '2019-08-27', 278, NULL),
('Candlewood Suites', 82, '2019-08-28', 345, NULL),
('Candlewood Suites', 82, '2019-08-29', 180, NULL),
('Candlewood Suites', 82, '2019-08-30', 179, NULL),
('Candlewood Suites', 82, '2019-08-31', 237, NULL),
('Candlewood Suites', 82, '2019-09-01', 173, NULL),
('Candlewood Suites', 82, '2019-09-02', 288, NULL),
('Candlewood Suites', 82, '2019-09-03', 373, NULL),
('Candlewood Suites', 82, '2019-09-04', 104, NULL),
('Candlewood Suites', 82, '2019-09-05', 308, NULL),
('Candlewood Suites', 82, '2019-09-06', 132, NULL),
('Candlewood Suites', 82, '2019-09-07', 147, NULL),
('Candlewood Suites', 82, '2019-09-08', 314, NULL),
('Candlewood Suites', 82, '2019-09-09', 153, NULL),
('Candlewood Suites', 82, '2019-09-10', 365, NULL),
('Candlewood Suites', 82, '2019-09-11', 238, NULL),
('Candlewood Suites', 82, '2019-09-12', 375, NULL),
('Candlewood Suites', 82, '2019-09-13', 128, NULL),
('Candlewood Suites', 82, '2019-09-14', 304, NULL),
('Candlewood Suites', 82, '2019-09-15', 168, NULL),
('Candlewood Suites', 82, '2019-09-16', 323, NULL),
('Candlewood Suites', 82, '2019-09-17', 206, NULL),
('Candlewood Suites', 82, '2019-09-18', 241, NULL),
('Candlewood Suites', 82, '2019-09-19', 267, NULL),
('Candlewood Suites', 82, '2019-09-20', 275, NULL),
('Candlewood Suites', 82, '2019-09-21', 114, NULL),
('Candlewood Suites', 82, '2019-09-22', 329, NULL),
('Candlewood Suites', 82, '2019-09-23', 149, NULL),
('Candlewood Suites', 82, '2019-09-24', 226, NULL),
('Candlewood Suites', 82, '2019-09-25', 214, NULL),
('Candlewood Suites', 82, '2019-09-26', 245, NULL),
('Candlewood Suites', 82, '2019-09-27', 208, NULL),
('Candlewood Suites', 82, '2019-09-28', 147, NULL),
('Candlewood Suites', 82, '2019-09-29', 271, NULL),
('Candlewood Suites', 82, '2019-09-30', 336, NULL),
('Candlewood Suites', 82, '2019-10-01', 152, NULL),
('Candlewood Suites', 82, '2019-10-02', 227, NULL),
('Candlewood Suites', 82, '2019-10-03', 276, NULL),
('Candlewood Suites', 82, '2019-10-04', 395, NULL),
('Candlewood Suites', 82, '2019-10-05', 241, NULL),
('Candlewood Suites', 82, '2019-10-06', 192, NULL),
('Candlewood Suites', 82, '2019-10-07', 397, NULL),
('Candlewood Suites', 82, '2019-10-08', 376, NULL),
('Candlewood Suites', 82, '2019-10-09', 174, NULL),
('Candlewood Suites', 82, '2019-10-10', 207, NULL),
('Candlewood Suites', 82, '2019-10-11', 379, NULL),
('Candlewood Suites', 82, '2019-10-12', 365, NULL),
('Candlewood Suites', 82, '2019-10-13', 335, NULL),
('Candlewood Suites', 82, '2019-10-14', 226, NULL),
('Candlewood Suites', 82, '2019-10-15', 166, NULL),
('Candlewood Suites', 82, '2019-10-16', 214, NULL),
('Candlewood Suites', 82, '2019-10-17', 302, NULL),
('Candlewood Suites', 82, '2019-10-18', 239, NULL),
('Candlewood Suites', 82, '2019-10-19', 341, NULL),
('Candlewood Suites', 82, '2019-10-20', 186, NULL),
('Candlewood Suites', 82, '2019-10-21', 164, NULL),
('Candlewood Suites', 82, '2019-10-22', 158, NULL),
('Candlewood Suites', 82, '2019-10-23', 112, NULL),
('Candlewood Suites', 82, '2019-10-24', 207, NULL),
('Candlewood Suites', 82, '2019-10-25', 219, NULL),
('Candlewood Suites', 82, '2019-10-26', 285, NULL),
('Candlewood Suites', 82, '2019-10-27', 156, NULL),
('Candlewood Suites', 82, '2019-10-28', 209, NULL),
('Candlewood Suites', 82, '2019-10-29', 332, NULL),
('Candlewood Suites', 82, '2019-10-30', 186, NULL),
('Candlewood Suites', 82, '2019-10-31', 132, NULL),
('Candlewood Suites', 82, '2019-11-01', 198, NULL),
('Candlewood Suites', 82, '2019-11-02', 275, NULL),
('Candlewood Suites', 82, '2019-11-03', 292, NULL),
('Candlewood Suites', 82, '2019-11-04', 158, NULL),
('Candlewood Suites', 82, '2019-11-05', 274, NULL),
('Candlewood Suites', 82, '2019-11-06', 144, NULL),
('Candlewood Suites', 82, '2019-11-07', 258, NULL),
('Candlewood Suites', 82, '2019-11-08', 316, NULL),
('Candlewood Suites', 82, '2019-11-09', 215, NULL),
('Candlewood Suites', 82, '2019-11-10', 212, NULL),
('Candlewood Suites', 82, '2019-11-11', 319, NULL),
('Candlewood Suites', 82, '2019-11-12', 320, NULL),
('Candlewood Suites', 82, '2019-11-13', 120, NULL),
('Candlewood Suites', 82, '2019-11-14', 203, NULL),
('Candlewood Suites', 82, '2019-11-15', 117, NULL),
('Candlewood Suites', 82, '2019-11-16', 254, NULL),
('Candlewood Suites', 82, '2019-11-17', 299, NULL),
('Candlewood Suites', 82, '2019-11-18', 330, NULL),
('Candlewood Suites', 82, '2019-11-19', 318, NULL),
('Candlewood Suites', 82, '2019-11-20', 131, NULL),
('Candlewood Suites', 82, '2019-11-21', 192, NULL),
('Candlewood Suites', 82, '2019-11-22', 242, NULL),
('Candlewood Suites', 82, '2019-11-23', 363, NULL),
('Candlewood Suites', 82, '2019-11-24', 132, NULL),
('Candlewood Suites', 82, '2019-11-25', 210, NULL),
('Candlewood Suites', 82, '2019-11-26', 110, NULL),
('Candlewood Suites', 82, '2019-11-27', 124, NULL),
('Candlewood Suites', 82, '2019-11-28', 384, NULL),
('Candlewood Suites', 82, '2019-11-29', 108, NULL),
('Candlewood Suites', 82, '2019-11-30', 259, NULL),
('Candlewood Suites', 82, '2019-12-01', 139, NULL),
('Candlewood Suites', 82, '2019-12-02', 153, NULL),
('Candlewood Suites', 82, '2019-12-03', 149, NULL),
('Candlewood Suites', 82, '2019-12-04', 356, NULL),
('Candlewood Suites', 82, '2019-12-05', 324, NULL),
('Candlewood Suites', 82, '2019-12-06', 365, NULL),
('Candlewood Suites', 82, '2019-12-07', 141, NULL),
('Candlewood Suites', 82, '2019-12-08', 174, NULL),
('Candlewood Suites', 82, '2019-12-09', 329, NULL),
('Candlewood Suites', 82, '2019-12-10', 346, NULL),
('Candlewood Suites', 82, '2019-12-11', 348, NULL),
('Candlewood Suites', 82, '2019-12-12', 137, NULL),
('Candlewood Suites', 82, '2019-12-13', 269, NULL),
('Candlewood Suites', 82, '2019-12-14', 177, NULL),
('Candlewood Suites', 82, '2019-12-15', 286, NULL),
('Candlewood Suites', 82, '2019-12-16', 137, NULL),
('Candlewood Suites', 82, '2019-12-17', 387, NULL),
('Candlewood Suites', 82, '2019-12-18', 211, NULL),
('Candlewood Suites', 82, '2019-12-19', 259, NULL),
('Candlewood Suites', 82, '2019-12-20', 222, NULL),
('Candlewood Suites', 82, '2019-12-21', 322, NULL),
('Candlewood Suites', 82, '2019-12-22', 280, NULL),
('Candlewood Suites', 82, '2019-12-23', 321, NULL),
('Candlewood Suites', 82, '2019-12-24', 162, NULL),
('Candlewood Suites', 82, '2019-12-25', 226, NULL),
('Candlewood Suites', 82, '2019-12-26', 239, NULL),
('Candlewood Suites', 82, '2019-12-27', 378, NULL),
('Candlewood Suites', 82, '2019-12-28', 334, NULL),
('Candlewood Suites', 82, '2019-12-29', 224, NULL),
('Candlewood Suites', 82, '2019-12-30', 146, NULL),
('Candlewood Suites', 82, '2019-12-31', 161, NULL),
('Candlewood Suites', 82, '2020-01-01', 147, NULL),
('Candlewood Suites', 82, '2020-01-02', 201, NULL),
('Candlewood Suites', 82, '2020-01-03', 209, NULL),
('Candlewood Suites', 82, '2020-01-04', 163, NULL),
('Candlewood Suites', 82, '2020-01-05', 188, NULL),
('Candlewood Suites', 82, '2020-01-06', 176, NULL),
('Candlewood Suites', 82, '2020-01-07', 309, NULL),
('Candlewood Suites', 82, '2020-01-08', 243, NULL),
('Candlewood Suites', 82, '2020-01-09', 308, NULL),
('Candlewood Suites', 82, '2020-01-10', 178, NULL),
('Candlewood Suites', 82, '2020-01-11', 130, NULL),
('Candlewood Suites', 82, '2020-01-12', 270, NULL),
('Candlewood Suites', 82, '2020-01-13', 361, NULL),
('Candlewood Suites', 82, '2020-01-14', 307, NULL),
('Candlewood Suites', 82, '2020-01-15', 384, NULL),
('Candlewood Suites', 82, '2020-01-16', 127, NULL),
('Candlewood Suites', 82, '2020-01-17', 353, NULL),
('Candlewood Suites', 82, '2020-01-18', 110, NULL),
('Candlewood Suites', 82, '2020-01-19', 242, NULL),
('Candlewood Suites', 82, '2020-01-20', 238, NULL),
('Candlewood Suites', 82, '2020-01-21', 191, NULL),
('Candlewood Suites', 82, '2020-01-22', 313, NULL),
('Candlewood Suites', 82, '2020-01-23', 343, NULL),
('Candlewood Suites', 82, '2020-01-24', 380, NULL),
('Candlewood Suites', 82, '2020-01-25', 181, NULL),
('Candlewood Suites', 82, '2020-01-26', 162, NULL),
('Candlewood Suites', 82, '2020-01-27', 393, NULL),
('Candlewood Suites', 82, '2020-01-28', 150, NULL),
('Candlewood Suites', 82, '2020-01-29', 254, NULL),
('Candlewood Suites', 82, '2020-01-30', 343, NULL),
('Candlewood Suites', 82, '2020-01-31', 235, NULL),
('Candlewood Suites', 82, '2020-02-01', 102, NULL),
('Candlewood Suites', 82, '2020-02-02', 309, NULL),
('Candlewood Suites', 82, '2020-02-03', 385, NULL),
('Candlewood Suites', 82, '2020-02-04', 187, NULL),
('Candlewood Suites', 86, '2019-01-01', 281, NULL),
('Candlewood Suites', 86, '2019-01-02', 363, NULL),
('Candlewood Suites', 86, '2019-01-03', 377, NULL),
('Candlewood Suites', 86, '2019-01-04', 304, NULL),
('Candlewood Suites', 86, '2019-01-05', 293, NULL),
('Candlewood Suites', 86, '2019-01-06', 227, NULL),
('Candlewood Suites', 86, '2019-01-07', 197, NULL),
('Candlewood Suites', 86, '2019-01-08', 241, NULL),
('Candlewood Suites', 86, '2019-01-09', 190, NULL),
('Candlewood Suites', 86, '2019-01-10', 335, NULL),
('Candlewood Suites', 86, '2019-01-11', 207, NULL),
('Candlewood Suites', 86, '2019-01-12', 285, NULL),
('Candlewood Suites', 86, '2019-01-13', 240, NULL),
('Candlewood Suites', 86, '2019-01-14', 161, NULL),
('Candlewood Suites', 86, '2019-01-15', 252, NULL),
('Candlewood Suites', 86, '2019-01-16', 358, NULL),
('Candlewood Suites', 86, '2019-01-17', 318, NULL),
('Candlewood Suites', 86, '2019-01-18', 351, NULL),
('Candlewood Suites', 86, '2019-01-19', 392, NULL),
('Candlewood Suites', 86, '2019-01-20', 310, NULL),
('Candlewood Suites', 86, '2019-01-21', 292, NULL),
('Candlewood Suites', 86, '2019-01-22', 288, NULL),
('Candlewood Suites', 86, '2019-01-23', 220, NULL),
('Candlewood Suites', 86, '2019-01-24', 266, NULL),
('Candlewood Suites', 86, '2019-01-25', 337, NULL),
('Candlewood Suites', 86, '2019-01-26', 231, NULL),
('Candlewood Suites', 86, '2019-01-27', 238, NULL),
('Candlewood Suites', 86, '2019-01-28', 274, NULL),
('Candlewood Suites', 86, '2019-01-29', 136, NULL),
('Candlewood Suites', 86, '2019-01-30', 111, NULL),
('Candlewood Suites', 86, '2019-01-31', 281, NULL),
('Candlewood Suites', 86, '2019-02-01', 257, NULL),
('Candlewood Suites', 86, '2019-02-02', 382, NULL),
('Candlewood Suites', 86, '2019-02-03', 127, NULL),
('Candlewood Suites', 86, '2019-02-04', 255, NULL),
('Candlewood Suites', 86, '2019-02-05', 134, NULL),
('Candlewood Suites', 86, '2019-02-06', 176, NULL),
('Candlewood Suites', 86, '2019-02-07', 234, NULL),
('Candlewood Suites', 86, '2019-02-08', 238, NULL),
('Candlewood Suites', 86, '2019-02-09', 107, NULL),
('Candlewood Suites', 86, '2019-02-10', 150, NULL),
('Candlewood Suites', 86, '2019-02-11', 327, NULL),
('Candlewood Suites', 86, '2019-02-12', 245, NULL),
('Candlewood Suites', 86, '2019-02-13', 320, NULL),
('Candlewood Suites', 86, '2019-02-14', 330, NULL),
('Candlewood Suites', 86, '2019-02-15', 263, NULL),
('Candlewood Suites', 86, '2019-02-16', 340, NULL),
('Candlewood Suites', 86, '2019-02-17', 127, NULL),
('Candlewood Suites', 86, '2019-02-18', 136, NULL),
('Candlewood Suites', 86, '2019-02-19', 293, NULL),
('Candlewood Suites', 86, '2019-02-20', 288, NULL),
('Candlewood Suites', 86, '2019-02-21', 192, NULL),
('Candlewood Suites', 86, '2019-02-22', 293, NULL),
('Candlewood Suites', 86, '2019-02-23', 330, NULL),
('Candlewood Suites', 86, '2019-02-24', 253, NULL),
('Candlewood Suites', 86, '2019-02-25', 306, NULL),
('Candlewood Suites', 86, '2019-02-26', 282, NULL),
('Candlewood Suites', 86, '2019-02-27', 258, NULL),
('Candlewood Suites', 86, '2019-02-28', 264, NULL),
('Candlewood Suites', 86, '2019-03-01', 393, NULL),
('Candlewood Suites', 86, '2019-03-02', 364, NULL),
('Candlewood Suites', 86, '2019-03-03', 304, NULL),
('Candlewood Suites', 86, '2019-03-04', 264, NULL),
('Candlewood Suites', 86, '2019-03-05', 207, NULL),
('Candlewood Suites', 86, '2019-03-06', 331, NULL),
('Candlewood Suites', 86, '2019-03-07', 215, NULL),
('Candlewood Suites', 86, '2019-03-08', 225, NULL),
('Candlewood Suites', 86, '2019-03-09', 205, NULL),
('Candlewood Suites', 86, '2019-03-10', 146, NULL),
('Candlewood Suites', 86, '2019-03-11', 343, NULL),
('Candlewood Suites', 86, '2019-03-12', 168, NULL),
('Candlewood Suites', 86, '2019-03-13', 324, NULL),
('Candlewood Suites', 86, '2019-03-14', 308, NULL),
('Candlewood Suites', 86, '2019-03-15', 277, NULL),
('Candlewood Suites', 86, '2019-03-16', 368, NULL),
('Candlewood Suites', 86, '2019-03-17', 292, NULL),
('Candlewood Suites', 86, '2019-03-18', 100, NULL),
('Candlewood Suites', 86, '2019-03-19', 167, NULL),
('Candlewood Suites', 86, '2019-03-20', 190, NULL),
('Candlewood Suites', 86, '2019-03-21', 349, NULL),
('Candlewood Suites', 86, '2019-03-22', 110, NULL),
('Candlewood Suites', 86, '2019-03-23', 184, NULL),
('Candlewood Suites', 86, '2019-03-24', 254, NULL),
('Candlewood Suites', 86, '2019-03-25', 246, NULL),
('Candlewood Suites', 86, '2019-03-26', 182, NULL),
('Candlewood Suites', 86, '2019-03-27', 125, NULL),
('Candlewood Suites', 86, '2019-03-28', 151, NULL),
('Candlewood Suites', 86, '2019-03-29', 322, NULL),
('Candlewood Suites', 86, '2019-03-30', 234, NULL),
('Candlewood Suites', 86, '2019-03-31', 266, NULL),
('Candlewood Suites', 86, '2019-04-01', 216, NULL),
('Candlewood Suites', 86, '2019-04-02', 283, NULL),
('Candlewood Suites', 86, '2019-04-03', 374, NULL),
('Candlewood Suites', 86, '2019-04-04', 253, NULL),
('Candlewood Suites', 86, '2019-04-05', 117, NULL),
('Candlewood Suites', 86, '2019-04-06', 254, NULL),
('Candlewood Suites', 86, '2019-04-07', 217, NULL),
('Candlewood Suites', 86, '2019-04-08', 177, NULL),
('Candlewood Suites', 86, '2019-04-09', 386, NULL),
('Candlewood Suites', 86, '2019-04-10', 297, NULL),
('Candlewood Suites', 86, '2019-04-11', 110, NULL),
('Candlewood Suites', 86, '2019-04-12', 391, NULL),
('Candlewood Suites', 86, '2019-04-13', 267, NULL),
('Candlewood Suites', 86, '2019-04-14', 111, NULL),
('Candlewood Suites', 86, '2019-04-15', 308, NULL),
('Candlewood Suites', 86, '2019-04-16', 122, NULL),
('Candlewood Suites', 86, '2019-04-17', 349, NULL),
('Candlewood Suites', 86, '2019-04-18', 125, NULL),
('Candlewood Suites', 86, '2019-04-19', 165, NULL),
('Candlewood Suites', 86, '2019-04-20', 285, NULL),
('Candlewood Suites', 86, '2019-04-21', 119, NULL),
('Candlewood Suites', 86, '2019-04-22', 232, NULL),
('Candlewood Suites', 86, '2019-04-23', 139, NULL),
('Candlewood Suites', 86, '2019-04-24', 166, NULL),
('Candlewood Suites', 86, '2019-04-25', 133, NULL),
('Candlewood Suites', 86, '2019-04-26', 123, NULL),
('Candlewood Suites', 86, '2019-04-27', 332, NULL),
('Candlewood Suites', 86, '2019-04-28', 145, NULL),
('Candlewood Suites', 86, '2019-04-29', 301, NULL),
('Candlewood Suites', 86, '2019-04-30', 363, NULL),
('Candlewood Suites', 86, '2019-05-01', 397, NULL),
('Candlewood Suites', 86, '2019-05-02', 225, NULL),
('Candlewood Suites', 86, '2019-05-03', 368, NULL),
('Candlewood Suites', 86, '2019-05-04', 135, NULL),
('Candlewood Suites', 86, '2019-05-05', 333, NULL),
('Candlewood Suites', 86, '2019-05-06', 281, NULL),
('Candlewood Suites', 86, '2019-05-07', 207, NULL),
('Candlewood Suites', 86, '2019-05-08', 129, NULL),
('Candlewood Suites', 86, '2019-05-09', 350, NULL),
('Candlewood Suites', 86, '2019-05-10', 158, NULL),
('Candlewood Suites', 86, '2019-05-11', 240, NULL),
('Candlewood Suites', 86, '2019-05-12', 113, NULL),
('Candlewood Suites', 86, '2019-05-13', 140, NULL),
('Candlewood Suites', 86, '2019-05-14', 214, NULL),
('Candlewood Suites', 86, '2019-05-15', 154, NULL),
('Candlewood Suites', 86, '2019-05-16', 329, NULL),
('Candlewood Suites', 86, '2019-05-17', 396, NULL),
('Candlewood Suites', 86, '2019-05-18', 251, NULL),
('Candlewood Suites', 86, '2019-05-19', 356, NULL),
('Candlewood Suites', 86, '2019-05-20', 336, NULL),
('Candlewood Suites', 86, '2019-05-21', 345, NULL),
('Candlewood Suites', 86, '2019-05-22', 283, NULL),
('Candlewood Suites', 86, '2019-05-23', 340, NULL),
('Candlewood Suites', 86, '2019-05-24', 248, NULL),
('Candlewood Suites', 86, '2019-05-25', 121, NULL),
('Candlewood Suites', 86, '2019-05-26', 117, NULL),
('Candlewood Suites', 86, '2019-05-27', 393, NULL),
('Candlewood Suites', 86, '2019-05-28', 180, NULL),
('Candlewood Suites', 86, '2019-05-29', 344, NULL),
('Candlewood Suites', 86, '2019-05-30', 344, NULL),
('Candlewood Suites', 86, '2019-05-31', 282, NULL),
('Candlewood Suites', 86, '2019-06-01', 359, NULL),
('Candlewood Suites', 86, '2019-06-02', 255, NULL),
('Candlewood Suites', 86, '2019-06-03', 168, NULL),
('Candlewood Suites', 86, '2019-06-04', 359, NULL),
('Candlewood Suites', 86, '2019-06-05', 132, NULL),
('Candlewood Suites', 86, '2019-06-06', 214, NULL),
('Candlewood Suites', 86, '2019-06-07', 303, NULL),
('Candlewood Suites', 86, '2019-06-08', 386, NULL),
('Candlewood Suites', 86, '2019-06-09', 388, NULL),
('Candlewood Suites', 86, '2019-06-10', 134, NULL),
('Candlewood Suites', 86, '2019-06-11', 224, NULL),
('Candlewood Suites', 86, '2019-06-12', 353, NULL),
('Candlewood Suites', 86, '2019-06-13', 113, NULL),
('Candlewood Suites', 86, '2019-06-14', 150, NULL),
('Candlewood Suites', 86, '2019-06-15', 147, NULL),
('Candlewood Suites', 86, '2019-06-16', 118, NULL),
('Candlewood Suites', 86, '2019-06-17', 292, NULL),
('Candlewood Suites', 86, '2019-06-18', 170, NULL),
('Candlewood Suites', 86, '2019-06-19', 362, NULL),
('Candlewood Suites', 86, '2019-06-20', 179, NULL),
('Candlewood Suites', 86, '2019-06-21', 381, NULL),
('Candlewood Suites', 86, '2019-06-22', 240, NULL),
('Candlewood Suites', 86, '2019-06-23', 320, NULL),
('Candlewood Suites', 86, '2019-06-24', 248, NULL),
('Candlewood Suites', 86, '2019-06-25', 267, NULL),
('Candlewood Suites', 86, '2019-06-26', 318, NULL),
('Candlewood Suites', 86, '2019-06-27', 163, NULL),
('Candlewood Suites', 86, '2019-06-28', 114, NULL),
('Candlewood Suites', 86, '2019-06-29', 388, NULL),
('Candlewood Suites', 86, '2019-06-30', 154, NULL),
('Candlewood Suites', 86, '2019-07-01', 355, NULL),
('Candlewood Suites', 86, '2019-07-02', 173, NULL),
('Candlewood Suites', 86, '2019-07-03', 398, NULL),
('Candlewood Suites', 86, '2019-07-04', 129, NULL),
('Candlewood Suites', 86, '2019-07-05', 389, NULL),
('Candlewood Suites', 86, '2019-07-06', 303, NULL),
('Candlewood Suites', 86, '2019-07-07', 346, NULL),
('Candlewood Suites', 86, '2019-07-08', 237, NULL),
('Candlewood Suites', 86, '2019-07-09', 397, NULL),
('Candlewood Suites', 86, '2019-07-10', 321, NULL),
('Candlewood Suites', 86, '2019-07-11', 247, NULL),
('Candlewood Suites', 86, '2019-07-12', 227, NULL),
('Candlewood Suites', 86, '2019-07-13', 155, NULL),
('Candlewood Suites', 86, '2019-07-14', 212, NULL),
('Candlewood Suites', 86, '2019-07-15', 223, NULL),
('Candlewood Suites', 86, '2019-07-16', 324, NULL),
('Candlewood Suites', 86, '2019-07-17', 345, NULL),
('Candlewood Suites', 86, '2019-07-18', 365, NULL),
('Candlewood Suites', 86, '2019-07-19', 159, NULL),
('Candlewood Suites', 86, '2019-07-20', 149, NULL),
('Candlewood Suites', 86, '2019-07-21', 240, NULL),
('Candlewood Suites', 86, '2019-07-22', 100, NULL),
('Candlewood Suites', 86, '2019-07-23', 224, NULL),
('Candlewood Suites', 86, '2019-07-24', 171, NULL),
('Candlewood Suites', 86, '2019-07-25', 272, NULL),
('Candlewood Suites', 86, '2019-07-26', 232, NULL),
('Candlewood Suites', 86, '2019-07-27', 253, NULL),
('Candlewood Suites', 86, '2019-07-28', 277, NULL),
('Candlewood Suites', 86, '2019-07-29', 333, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 86, '2019-07-30', 170, NULL),
('Candlewood Suites', 86, '2019-07-31', 346, NULL),
('Candlewood Suites', 86, '2019-08-01', 236, NULL),
('Candlewood Suites', 86, '2019-08-02', 197, NULL),
('Candlewood Suites', 86, '2019-08-03', 314, NULL),
('Candlewood Suites', 86, '2019-08-04', 371, NULL),
('Candlewood Suites', 86, '2019-08-05', 167, NULL),
('Candlewood Suites', 86, '2019-08-06', 216, NULL),
('Candlewood Suites', 86, '2019-08-07', 113, NULL),
('Candlewood Suites', 86, '2019-08-08', 191, NULL),
('Candlewood Suites', 86, '2019-08-09', 114, NULL),
('Candlewood Suites', 86, '2019-08-10', 337, NULL),
('Candlewood Suites', 86, '2019-08-11', 165, NULL),
('Candlewood Suites', 86, '2019-08-12', 369, NULL),
('Candlewood Suites', 86, '2019-08-13', 278, NULL),
('Candlewood Suites', 86, '2019-08-14', 376, NULL),
('Candlewood Suites', 86, '2019-08-15', 251, NULL),
('Candlewood Suites', 86, '2019-08-16', 179, NULL),
('Candlewood Suites', 86, '2019-08-17', 152, NULL),
('Candlewood Suites', 86, '2019-08-18', 174, NULL),
('Candlewood Suites', 86, '2019-08-19', 228, NULL),
('Candlewood Suites', 86, '2019-08-20', 154, NULL),
('Candlewood Suites', 86, '2019-08-21', 186, NULL),
('Candlewood Suites', 86, '2019-08-22', 292, NULL),
('Candlewood Suites', 86, '2019-08-23', 335, NULL),
('Candlewood Suites', 86, '2019-08-24', 276, NULL),
('Candlewood Suites', 86, '2019-08-25', 370, NULL),
('Candlewood Suites', 86, '2019-08-26', 142, NULL),
('Candlewood Suites', 86, '2019-08-27', 178, NULL),
('Candlewood Suites', 86, '2019-08-28', 194, NULL),
('Candlewood Suites', 86, '2019-08-29', 161, NULL),
('Candlewood Suites', 86, '2019-08-30', 338, NULL),
('Candlewood Suites', 86, '2019-08-31', 343, NULL),
('Candlewood Suites', 86, '2019-09-01', 356, NULL),
('Candlewood Suites', 86, '2019-09-02', 356, NULL),
('Candlewood Suites', 86, '2019-09-03', 312, NULL),
('Candlewood Suites', 86, '2019-09-04', 376, NULL),
('Candlewood Suites', 86, '2019-09-05', 323, NULL),
('Candlewood Suites', 86, '2019-09-06', 161, NULL),
('Candlewood Suites', 86, '2019-09-07', 281, NULL),
('Candlewood Suites', 86, '2019-09-08', 290, NULL),
('Candlewood Suites', 86, '2019-09-09', 315, NULL),
('Candlewood Suites', 86, '2019-09-10', 373, NULL),
('Candlewood Suites', 86, '2019-09-11', 196, NULL),
('Candlewood Suites', 86, '2019-09-12', 320, NULL),
('Candlewood Suites', 86, '2019-09-13', 139, NULL),
('Candlewood Suites', 86, '2019-09-14', 222, NULL),
('Candlewood Suites', 86, '2019-09-15', 132, NULL),
('Candlewood Suites', 86, '2019-09-16', 241, NULL),
('Candlewood Suites', 86, '2019-09-17', 381, NULL),
('Candlewood Suites', 86, '2019-09-18', 227, NULL),
('Candlewood Suites', 86, '2019-09-19', 230, NULL),
('Candlewood Suites', 86, '2019-09-20', 251, NULL),
('Candlewood Suites', 86, '2019-09-21', 353, NULL),
('Candlewood Suites', 86, '2019-09-22', 236, NULL),
('Candlewood Suites', 86, '2019-09-23', 125, NULL),
('Candlewood Suites', 86, '2019-09-24', 345, NULL),
('Candlewood Suites', 86, '2019-09-25', 120, NULL),
('Candlewood Suites', 86, '2019-09-26', 317, NULL),
('Candlewood Suites', 86, '2019-09-27', 133, NULL),
('Candlewood Suites', 86, '2019-09-28', 157, NULL),
('Candlewood Suites', 86, '2019-09-29', 107, NULL),
('Candlewood Suites', 86, '2019-09-30', 253, NULL),
('Candlewood Suites', 86, '2019-10-01', 344, NULL),
('Candlewood Suites', 86, '2019-10-02', 365, NULL),
('Candlewood Suites', 86, '2019-10-03', 249, NULL),
('Candlewood Suites', 86, '2019-10-04', 308, NULL),
('Candlewood Suites', 86, '2019-10-05', 353, NULL),
('Candlewood Suites', 86, '2019-10-06', 300, NULL),
('Candlewood Suites', 86, '2019-10-07', 261, NULL),
('Candlewood Suites', 86, '2019-10-08', 153, NULL),
('Candlewood Suites', 86, '2019-10-09', 391, NULL),
('Candlewood Suites', 86, '2019-10-10', 333, NULL),
('Candlewood Suites', 86, '2019-10-11', 259, NULL),
('Candlewood Suites', 86, '2019-10-12', 298, NULL),
('Candlewood Suites', 86, '2019-10-13', 308, NULL),
('Candlewood Suites', 86, '2019-10-14', 391, NULL),
('Candlewood Suites', 86, '2019-10-15', 121, NULL),
('Candlewood Suites', 86, '2019-10-16', 350, NULL),
('Candlewood Suites', 86, '2019-10-17', 283, NULL),
('Candlewood Suites', 86, '2019-10-18', 306, NULL),
('Candlewood Suites', 86, '2019-10-19', 253, NULL),
('Candlewood Suites', 86, '2019-10-20', 377, NULL),
('Candlewood Suites', 86, '2019-10-21', 116, NULL),
('Candlewood Suites', 86, '2019-10-22', 343, NULL),
('Candlewood Suites', 86, '2019-10-23', 367, NULL),
('Candlewood Suites', 86, '2019-10-24', 374, NULL),
('Candlewood Suites', 86, '2019-10-25', 106, NULL),
('Candlewood Suites', 86, '2019-10-26', 361, NULL),
('Candlewood Suites', 86, '2019-10-27', 272, NULL),
('Candlewood Suites', 86, '2019-10-28', 145, NULL),
('Candlewood Suites', 86, '2019-10-29', 137, NULL),
('Candlewood Suites', 86, '2019-10-30', 272, NULL),
('Candlewood Suites', 86, '2019-10-31', 344, NULL),
('Candlewood Suites', 86, '2019-11-01', 285, NULL),
('Candlewood Suites', 86, '2019-11-02', 359, NULL),
('Candlewood Suites', 86, '2019-11-03', 265, NULL),
('Candlewood Suites', 86, '2019-11-04', 293, NULL),
('Candlewood Suites', 86, '2019-11-05', 236, NULL),
('Candlewood Suites', 86, '2019-11-06', 379, NULL),
('Candlewood Suites', 86, '2019-11-07', 119, NULL),
('Candlewood Suites', 86, '2019-11-08', 127, NULL),
('Candlewood Suites', 86, '2019-11-09', 336, NULL),
('Candlewood Suites', 86, '2019-11-10', 184, NULL),
('Candlewood Suites', 86, '2019-11-11', 113, NULL),
('Candlewood Suites', 86, '2019-11-12', 364, NULL),
('Candlewood Suites', 86, '2019-11-13', 369, NULL),
('Candlewood Suites', 86, '2019-11-14', 354, NULL),
('Candlewood Suites', 86, '2019-11-15', 188, NULL),
('Candlewood Suites', 86, '2019-11-16', 246, NULL),
('Candlewood Suites', 86, '2019-11-17', 257, NULL),
('Candlewood Suites', 86, '2019-11-18', 139, NULL),
('Candlewood Suites', 86, '2019-11-19', 228, NULL),
('Candlewood Suites', 86, '2019-11-20', 161, NULL),
('Candlewood Suites', 86, '2019-11-21', 174, NULL),
('Candlewood Suites', 86, '2019-11-22', 287, NULL),
('Candlewood Suites', 86, '2019-11-23', 332, NULL),
('Candlewood Suites', 86, '2019-11-24', 370, NULL),
('Candlewood Suites', 86, '2019-11-25', 298, NULL),
('Candlewood Suites', 86, '2019-11-26', 192, NULL),
('Candlewood Suites', 86, '2019-11-27', 157, NULL),
('Candlewood Suites', 86, '2019-11-28', 164, NULL),
('Candlewood Suites', 86, '2019-11-29', 109, NULL),
('Candlewood Suites', 86, '2019-11-30', 207, NULL),
('Candlewood Suites', 86, '2019-12-01', 282, NULL),
('Candlewood Suites', 86, '2019-12-02', 185, NULL),
('Candlewood Suites', 86, '2019-12-03', 377, NULL),
('Candlewood Suites', 86, '2019-12-04', 388, NULL),
('Candlewood Suites', 86, '2019-12-05', 283, NULL),
('Candlewood Suites', 86, '2019-12-06', 232, NULL),
('Candlewood Suites', 86, '2019-12-07', 232, NULL),
('Candlewood Suites', 86, '2019-12-08', 335, NULL),
('Candlewood Suites', 86, '2019-12-09', 357, NULL),
('Candlewood Suites', 86, '2019-12-10', 382, NULL),
('Candlewood Suites', 86, '2019-12-11', 190, NULL),
('Candlewood Suites', 86, '2019-12-12', 273, NULL),
('Candlewood Suites', 86, '2019-12-13', 333, NULL),
('Candlewood Suites', 86, '2019-12-14', 131, NULL),
('Candlewood Suites', 86, '2019-12-15', 210, NULL),
('Candlewood Suites', 86, '2019-12-16', 194, NULL),
('Candlewood Suites', 86, '2019-12-17', 150, NULL),
('Candlewood Suites', 86, '2019-12-18', 137, NULL),
('Candlewood Suites', 86, '2019-12-19', 282, NULL),
('Candlewood Suites', 86, '2019-12-20', 326, NULL),
('Candlewood Suites', 86, '2019-12-21', 373, NULL),
('Candlewood Suites', 86, '2019-12-22', 203, NULL),
('Candlewood Suites', 86, '2019-12-23', 217, NULL),
('Candlewood Suites', 86, '2019-12-24', 297, NULL),
('Candlewood Suites', 86, '2019-12-25', 297, NULL),
('Candlewood Suites', 86, '2019-12-26', 227, NULL),
('Candlewood Suites', 86, '2019-12-27', 217, NULL),
('Candlewood Suites', 86, '2019-12-28', 103, NULL),
('Candlewood Suites', 86, '2019-12-29', 386, NULL),
('Candlewood Suites', 86, '2019-12-30', 152, NULL),
('Candlewood Suites', 86, '2019-12-31', 267, NULL),
('Candlewood Suites', 86, '2020-01-01', 132, NULL),
('Candlewood Suites', 86, '2020-01-02', 199, NULL),
('Candlewood Suites', 86, '2020-01-03', 138, NULL),
('Candlewood Suites', 86, '2020-01-04', 320, NULL),
('Candlewood Suites', 86, '2020-01-05', 100, NULL),
('Candlewood Suites', 86, '2020-01-06', 132, NULL),
('Candlewood Suites', 86, '2020-01-07', 127, NULL),
('Candlewood Suites', 86, '2020-01-08', 299, NULL),
('Candlewood Suites', 86, '2020-01-09', 250, NULL),
('Candlewood Suites', 86, '2020-01-10', 384, NULL),
('Candlewood Suites', 86, '2020-01-11', 317, NULL),
('Candlewood Suites', 86, '2020-01-12', 225, NULL),
('Candlewood Suites', 86, '2020-01-13', 119, NULL),
('Candlewood Suites', 86, '2020-01-14', 205, NULL),
('Candlewood Suites', 86, '2020-01-15', 252, NULL),
('Candlewood Suites', 86, '2020-01-16', 224, NULL),
('Candlewood Suites', 86, '2020-01-17', 365, NULL),
('Candlewood Suites', 86, '2020-01-18', 237, NULL),
('Candlewood Suites', 86, '2020-01-19', 247, NULL),
('Candlewood Suites', 86, '2020-01-20', 107, NULL),
('Candlewood Suites', 86, '2020-01-21', 119, NULL),
('Candlewood Suites', 86, '2020-01-22', 168, NULL),
('Candlewood Suites', 86, '2020-01-23', 211, NULL),
('Candlewood Suites', 86, '2020-01-24', 218, NULL),
('Candlewood Suites', 86, '2020-01-25', 274, NULL),
('Candlewood Suites', 86, '2020-01-26', 356, NULL),
('Candlewood Suites', 86, '2020-01-27', 347, NULL),
('Candlewood Suites', 86, '2020-01-28', 366, NULL),
('Candlewood Suites', 86, '2020-01-29', 334, NULL),
('Candlewood Suites', 86, '2020-01-30', 199, NULL),
('Candlewood Suites', 86, '2020-01-31', 285, NULL),
('Candlewood Suites', 86, '2020-02-01', 108, NULL),
('Candlewood Suites', 86, '2020-02-02', 261, NULL),
('Candlewood Suites', 86, '2020-02-03', 282, NULL),
('Candlewood Suites', 86, '2020-02-04', 330, NULL),
('Candlewood Suites', 102, '2019-01-01', 374, NULL),
('Candlewood Suites', 102, '2019-01-02', 349, NULL),
('Candlewood Suites', 102, '2019-01-03', 219, NULL),
('Candlewood Suites', 102, '2019-01-04', 389, NULL),
('Candlewood Suites', 102, '2019-01-05', 163, NULL),
('Candlewood Suites', 102, '2019-01-06', 135, NULL),
('Candlewood Suites', 102, '2019-01-07', 207, NULL),
('Candlewood Suites', 102, '2019-01-08', 185, NULL),
('Candlewood Suites', 102, '2019-01-09', 334, NULL),
('Candlewood Suites', 102, '2019-01-10', 281, NULL),
('Candlewood Suites', 102, '2019-01-11', 314, NULL),
('Candlewood Suites', 102, '2019-01-12', 273, NULL),
('Candlewood Suites', 102, '2019-01-13', 327, NULL),
('Candlewood Suites', 102, '2019-01-14', 238, NULL),
('Candlewood Suites', 102, '2019-01-15', 309, NULL),
('Candlewood Suites', 102, '2019-01-16', 314, NULL),
('Candlewood Suites', 102, '2019-01-17', 196, NULL),
('Candlewood Suites', 102, '2019-01-18', 209, NULL),
('Candlewood Suites', 102, '2019-01-19', 209, NULL),
('Candlewood Suites', 102, '2019-01-20', 167, NULL),
('Candlewood Suites', 102, '2019-01-21', 156, NULL),
('Candlewood Suites', 102, '2019-01-22', 298, NULL),
('Candlewood Suites', 102, '2019-01-23', 165, NULL),
('Candlewood Suites', 102, '2019-01-24', 345, NULL),
('Candlewood Suites', 102, '2019-01-25', 115, NULL),
('Candlewood Suites', 102, '2019-01-26', 357, NULL),
('Candlewood Suites', 102, '2019-01-27', 235, NULL),
('Candlewood Suites', 102, '2019-01-28', 114, NULL),
('Candlewood Suites', 102, '2019-01-29', 320, NULL),
('Candlewood Suites', 102, '2019-01-30', 377, NULL),
('Candlewood Suites', 102, '2019-01-31', 137, NULL),
('Candlewood Suites', 102, '2019-02-01', 258, NULL),
('Candlewood Suites', 102, '2019-02-02', 169, NULL),
('Candlewood Suites', 102, '2019-02-03', 372, NULL),
('Candlewood Suites', 102, '2019-02-04', 163, NULL),
('Candlewood Suites', 102, '2019-02-05', 395, NULL),
('Candlewood Suites', 102, '2019-02-06', 122, NULL),
('Candlewood Suites', 102, '2019-02-07', 391, NULL),
('Candlewood Suites', 102, '2019-02-08', 316, NULL),
('Candlewood Suites', 102, '2019-02-09', 101, NULL),
('Candlewood Suites', 102, '2019-02-10', 179, NULL),
('Candlewood Suites', 102, '2019-02-11', 276, NULL),
('Candlewood Suites', 102, '2019-02-12', 147, NULL),
('Candlewood Suites', 102, '2019-02-13', 268, NULL),
('Candlewood Suites', 102, '2019-02-14', 333, NULL),
('Candlewood Suites', 102, '2019-02-15', 191, NULL),
('Candlewood Suites', 102, '2019-02-16', 334, NULL),
('Candlewood Suites', 102, '2019-02-17', 326, NULL),
('Candlewood Suites', 102, '2019-02-18', 258, NULL),
('Candlewood Suites', 102, '2019-02-19', 308, NULL),
('Candlewood Suites', 102, '2019-02-20', 366, NULL),
('Candlewood Suites', 102, '2019-02-21', 189, NULL),
('Candlewood Suites', 102, '2019-02-22', 337, NULL),
('Candlewood Suites', 102, '2019-02-23', 233, NULL),
('Candlewood Suites', 102, '2019-02-24', 106, NULL),
('Candlewood Suites', 102, '2019-02-25', 256, NULL),
('Candlewood Suites', 102, '2019-02-26', 153, NULL),
('Candlewood Suites', 102, '2019-02-27', 314, NULL),
('Candlewood Suites', 102, '2019-02-28', 399, NULL),
('Candlewood Suites', 102, '2019-03-01', 332, NULL),
('Candlewood Suites', 102, '2019-03-02', 335, NULL),
('Candlewood Suites', 102, '2019-03-03', 299, NULL),
('Candlewood Suites', 102, '2019-03-04', 352, NULL),
('Candlewood Suites', 102, '2019-03-05', 308, NULL),
('Candlewood Suites', 102, '2019-03-06', 279, NULL),
('Candlewood Suites', 102, '2019-03-07', 395, NULL),
('Candlewood Suites', 102, '2019-03-08', 229, NULL),
('Candlewood Suites', 102, '2019-03-09', 270, NULL),
('Candlewood Suites', 102, '2019-03-10', 215, NULL),
('Candlewood Suites', 102, '2019-03-11', 119, NULL),
('Candlewood Suites', 102, '2019-03-12', 113, NULL),
('Candlewood Suites', 102, '2019-03-13', 230, NULL),
('Candlewood Suites', 102, '2019-03-14', 329, NULL),
('Candlewood Suites', 102, '2019-03-15', 260, NULL),
('Candlewood Suites', 102, '2019-03-16', 292, NULL),
('Candlewood Suites', 102, '2019-03-17', 281, NULL),
('Candlewood Suites', 102, '2019-03-18', 241, NULL),
('Candlewood Suites', 102, '2019-03-19', 362, NULL),
('Candlewood Suites', 102, '2019-03-20', 110, NULL),
('Candlewood Suites', 102, '2019-03-21', 261, NULL),
('Candlewood Suites', 102, '2019-03-22', 320, NULL),
('Candlewood Suites', 102, '2019-03-23', 259, NULL),
('Candlewood Suites', 102, '2019-03-24', 337, NULL),
('Candlewood Suites', 102, '2019-03-25', 386, NULL),
('Candlewood Suites', 102, '2019-03-26', 113, NULL),
('Candlewood Suites', 102, '2019-03-27', 322, NULL),
('Candlewood Suites', 102, '2019-03-28', 384, NULL),
('Candlewood Suites', 102, '2019-03-29', 234, NULL),
('Candlewood Suites', 102, '2019-03-30', 192, NULL),
('Candlewood Suites', 102, '2019-03-31', 260, NULL),
('Candlewood Suites', 102, '2019-04-01', 271, NULL),
('Candlewood Suites', 102, '2019-04-02', 320, NULL),
('Candlewood Suites', 102, '2019-04-03', 126, NULL),
('Candlewood Suites', 102, '2019-04-04', 189, NULL),
('Candlewood Suites', 102, '2019-04-05', 171, NULL),
('Candlewood Suites', 102, '2019-04-06', 127, NULL),
('Candlewood Suites', 102, '2019-04-07', 378, NULL),
('Candlewood Suites', 102, '2019-04-08', 112, NULL),
('Candlewood Suites', 102, '2019-04-09', 320, NULL),
('Candlewood Suites', 102, '2019-04-10', 104, NULL),
('Candlewood Suites', 102, '2019-04-11', 253, NULL),
('Candlewood Suites', 102, '2019-04-12', 213, NULL),
('Candlewood Suites', 102, '2019-04-13', 390, NULL),
('Candlewood Suites', 102, '2019-04-14', 185, NULL),
('Candlewood Suites', 102, '2019-04-15', 350, NULL),
('Candlewood Suites', 102, '2019-04-16', 167, NULL),
('Candlewood Suites', 102, '2019-04-17', 122, NULL),
('Candlewood Suites', 102, '2019-04-18', 242, NULL),
('Candlewood Suites', 102, '2019-04-19', 353, NULL),
('Candlewood Suites', 102, '2019-04-20', 111, NULL),
('Candlewood Suites', 102, '2019-04-21', 134, NULL),
('Candlewood Suites', 102, '2019-04-22', 319, NULL),
('Candlewood Suites', 102, '2019-04-23', 184, NULL),
('Candlewood Suites', 102, '2019-04-24', 122, NULL),
('Candlewood Suites', 102, '2019-04-25', 349, NULL),
('Candlewood Suites', 102, '2019-04-26', 309, NULL),
('Candlewood Suites', 102, '2019-04-27', 387, NULL),
('Candlewood Suites', 102, '2019-04-28', 188, NULL),
('Candlewood Suites', 102, '2019-04-29', 288, NULL),
('Candlewood Suites', 102, '2019-04-30', 158, NULL),
('Candlewood Suites', 102, '2019-05-01', 199, NULL),
('Candlewood Suites', 102, '2019-05-02', 104, NULL),
('Candlewood Suites', 102, '2019-05-03', 245, NULL),
('Candlewood Suites', 102, '2019-05-04', 367, NULL),
('Candlewood Suites', 102, '2019-05-05', 352, NULL),
('Candlewood Suites', 102, '2019-05-06', 320, NULL),
('Candlewood Suites', 102, '2019-05-07', 325, NULL),
('Candlewood Suites', 102, '2019-05-08', 382, NULL),
('Candlewood Suites', 102, '2019-05-09', 243, NULL),
('Candlewood Suites', 102, '2019-05-10', 317, NULL),
('Candlewood Suites', 102, '2019-05-11', 109, NULL),
('Candlewood Suites', 102, '2019-05-12', 387, NULL),
('Candlewood Suites', 102, '2019-05-13', 367, NULL),
('Candlewood Suites', 102, '2019-05-14', 336, NULL),
('Candlewood Suites', 102, '2019-05-15', 266, NULL),
('Candlewood Suites', 102, '2019-05-16', 215, NULL),
('Candlewood Suites', 102, '2019-05-17', 386, NULL),
('Candlewood Suites', 102, '2019-05-18', 291, NULL),
('Candlewood Suites', 102, '2019-05-19', 165, NULL),
('Candlewood Suites', 102, '2019-05-20', 158, NULL),
('Candlewood Suites', 102, '2019-05-21', 162, NULL),
('Candlewood Suites', 102, '2019-05-22', 260, NULL),
('Candlewood Suites', 102, '2019-05-23', 132, NULL),
('Candlewood Suites', 102, '2019-05-24', 126, NULL),
('Candlewood Suites', 102, '2019-05-25', 339, NULL),
('Candlewood Suites', 102, '2019-05-26', 284, NULL),
('Candlewood Suites', 102, '2019-05-27', 323, NULL),
('Candlewood Suites', 102, '2019-05-28', 257, NULL),
('Candlewood Suites', 102, '2019-05-29', 371, NULL),
('Candlewood Suites', 102, '2019-05-30', 241, NULL),
('Candlewood Suites', 102, '2019-05-31', 362, NULL),
('Candlewood Suites', 102, '2019-06-01', 103, NULL),
('Candlewood Suites', 102, '2019-06-02', 365, NULL),
('Candlewood Suites', 102, '2019-06-03', 362, NULL),
('Candlewood Suites', 102, '2019-06-04', 104, NULL),
('Candlewood Suites', 102, '2019-06-05', 192, NULL),
('Candlewood Suites', 102, '2019-06-06', 287, NULL),
('Candlewood Suites', 102, '2019-06-07', 250, NULL),
('Candlewood Suites', 102, '2019-06-08', 198, NULL),
('Candlewood Suites', 102, '2019-06-09', 164, NULL),
('Candlewood Suites', 102, '2019-06-10', 130, NULL),
('Candlewood Suites', 102, '2019-06-11', 105, NULL),
('Candlewood Suites', 102, '2019-06-12', 247, NULL),
('Candlewood Suites', 102, '2019-06-13', 236, NULL),
('Candlewood Suites', 102, '2019-06-14', 271, NULL),
('Candlewood Suites', 102, '2019-06-15', 258, NULL),
('Candlewood Suites', 102, '2019-06-16', 134, NULL),
('Candlewood Suites', 102, '2019-06-17', 365, NULL),
('Candlewood Suites', 102, '2019-06-18', 352, NULL),
('Candlewood Suites', 102, '2019-06-19', 290, NULL),
('Candlewood Suites', 102, '2019-06-20', 117, NULL),
('Candlewood Suites', 102, '2019-06-21', 248, NULL),
('Candlewood Suites', 102, '2019-06-22', 233, NULL),
('Candlewood Suites', 102, '2019-06-23', 173, NULL),
('Candlewood Suites', 102, '2019-06-24', 164, NULL),
('Candlewood Suites', 102, '2019-06-25', 288, NULL),
('Candlewood Suites', 102, '2019-06-26', 351, NULL),
('Candlewood Suites', 102, '2019-06-27', 397, NULL),
('Candlewood Suites', 102, '2019-06-28', 346, NULL),
('Candlewood Suites', 102, '2019-06-29', 225, NULL),
('Candlewood Suites', 102, '2019-06-30', 334, NULL),
('Candlewood Suites', 102, '2019-07-01', 154, NULL),
('Candlewood Suites', 102, '2019-07-02', 249, NULL),
('Candlewood Suites', 102, '2019-07-03', 128, NULL),
('Candlewood Suites', 102, '2019-07-04', 161, NULL),
('Candlewood Suites', 102, '2019-07-05', 275, NULL),
('Candlewood Suites', 102, '2019-07-06', 297, NULL),
('Candlewood Suites', 102, '2019-07-07', 234, NULL),
('Candlewood Suites', 102, '2019-07-08', 109, NULL),
('Candlewood Suites', 102, '2019-07-09', 239, NULL),
('Candlewood Suites', 102, '2019-07-10', 304, NULL),
('Candlewood Suites', 102, '2019-07-11', 313, NULL),
('Candlewood Suites', 102, '2019-07-12', 259, NULL),
('Candlewood Suites', 102, '2019-07-13', 369, NULL),
('Candlewood Suites', 102, '2019-07-14', 227, NULL),
('Candlewood Suites', 102, '2019-07-15', 302, NULL),
('Candlewood Suites', 102, '2019-07-16', 353, NULL),
('Candlewood Suites', 102, '2019-07-17', 378, NULL),
('Candlewood Suites', 102, '2019-07-18', 172, NULL),
('Candlewood Suites', 102, '2019-07-19', 189, NULL),
('Candlewood Suites', 102, '2019-07-20', 135, NULL),
('Candlewood Suites', 102, '2019-07-21', 290, NULL),
('Candlewood Suites', 102, '2019-07-22', 102, NULL),
('Candlewood Suites', 102, '2019-07-23', 136, NULL),
('Candlewood Suites', 102, '2019-07-24', 114, NULL),
('Candlewood Suites', 102, '2019-07-25', 234, NULL),
('Candlewood Suites', 102, '2019-07-26', 338, NULL),
('Candlewood Suites', 102, '2019-07-27', 131, NULL),
('Candlewood Suites', 102, '2019-07-28', 151, NULL),
('Candlewood Suites', 102, '2019-07-29', 189, NULL),
('Candlewood Suites', 102, '2019-07-30', 386, NULL),
('Candlewood Suites', 102, '2019-07-31', 262, NULL),
('Candlewood Suites', 102, '2019-08-01', 183, NULL),
('Candlewood Suites', 102, '2019-08-02', 146, NULL),
('Candlewood Suites', 102, '2019-08-03', 393, NULL),
('Candlewood Suites', 102, '2019-08-04', 111, NULL),
('Candlewood Suites', 102, '2019-08-05', 230, NULL),
('Candlewood Suites', 102, '2019-08-06', 385, NULL),
('Candlewood Suites', 102, '2019-08-07', 145, NULL),
('Candlewood Suites', 102, '2019-08-08', 298, NULL),
('Candlewood Suites', 102, '2019-08-09', 375, NULL),
('Candlewood Suites', 102, '2019-08-10', 244, NULL),
('Candlewood Suites', 102, '2019-08-11', 303, NULL),
('Candlewood Suites', 102, '2019-08-12', 328, NULL),
('Candlewood Suites', 102, '2019-08-13', 220, NULL),
('Candlewood Suites', 102, '2019-08-14', 352, NULL),
('Candlewood Suites', 102, '2019-08-15', 232, NULL),
('Candlewood Suites', 102, '2019-08-16', 186, NULL),
('Candlewood Suites', 102, '2019-08-17', 126, NULL),
('Candlewood Suites', 102, '2019-08-18', 224, NULL),
('Candlewood Suites', 102, '2019-08-19', 245, NULL),
('Candlewood Suites', 102, '2019-08-20', 288, NULL),
('Candlewood Suites', 102, '2019-08-21', 372, NULL),
('Candlewood Suites', 102, '2019-08-22', 351, NULL),
('Candlewood Suites', 102, '2019-08-23', 205, NULL),
('Candlewood Suites', 102, '2019-08-24', 303, NULL),
('Candlewood Suites', 102, '2019-08-25', 163, NULL),
('Candlewood Suites', 102, '2019-08-26', 218, NULL),
('Candlewood Suites', 102, '2019-08-27', 258, NULL),
('Candlewood Suites', 102, '2019-08-28', 137, NULL),
('Candlewood Suites', 102, '2019-08-29', 165, NULL),
('Candlewood Suites', 102, '2019-08-30', 154, NULL),
('Candlewood Suites', 102, '2019-08-31', 305, NULL),
('Candlewood Suites', 102, '2019-09-01', 263, NULL),
('Candlewood Suites', 102, '2019-09-02', 216, NULL),
('Candlewood Suites', 102, '2019-09-03', 340, NULL),
('Candlewood Suites', 102, '2019-09-04', 268, NULL),
('Candlewood Suites', 102, '2019-09-05', 294, NULL),
('Candlewood Suites', 102, '2019-09-06', 312, NULL),
('Candlewood Suites', 102, '2019-09-07', 266, NULL),
('Candlewood Suites', 102, '2019-09-08', 105, NULL),
('Candlewood Suites', 102, '2019-09-09', 115, NULL),
('Candlewood Suites', 102, '2019-09-10', 372, NULL),
('Candlewood Suites', 102, '2019-09-11', 166, NULL),
('Candlewood Suites', 102, '2019-09-12', 373, NULL),
('Candlewood Suites', 102, '2019-09-13', 209, NULL),
('Candlewood Suites', 102, '2019-09-14', 396, NULL),
('Candlewood Suites', 102, '2019-09-15', 358, NULL),
('Candlewood Suites', 102, '2019-09-16', 139, NULL),
('Candlewood Suites', 102, '2019-09-17', 290, NULL),
('Candlewood Suites', 102, '2019-09-18', 313, NULL),
('Candlewood Suites', 102, '2019-09-19', 250, NULL),
('Candlewood Suites', 102, '2019-09-20', 331, NULL),
('Candlewood Suites', 102, '2019-09-21', 121, NULL),
('Candlewood Suites', 102, '2019-09-22', 392, NULL),
('Candlewood Suites', 102, '2019-09-23', 382, NULL),
('Candlewood Suites', 102, '2019-09-24', 349, NULL),
('Candlewood Suites', 102, '2019-09-25', 160, NULL),
('Candlewood Suites', 102, '2019-09-26', 151, NULL),
('Candlewood Suites', 102, '2019-09-27', 241, NULL),
('Candlewood Suites', 102, '2019-09-28', 246, NULL),
('Candlewood Suites', 102, '2019-09-29', 222, NULL),
('Candlewood Suites', 102, '2019-09-30', 157, NULL),
('Candlewood Suites', 102, '2019-10-01', 266, NULL),
('Candlewood Suites', 102, '2019-10-02', 142, NULL),
('Candlewood Suites', 102, '2019-10-03', 318, NULL),
('Candlewood Suites', 102, '2019-10-04', 256, NULL),
('Candlewood Suites', 102, '2019-10-05', 339, NULL),
('Candlewood Suites', 102, '2019-10-06', 223, NULL),
('Candlewood Suites', 102, '2019-10-07', 315, NULL),
('Candlewood Suites', 102, '2019-10-08', 136, NULL),
('Candlewood Suites', 102, '2019-10-09', 132, NULL),
('Candlewood Suites', 102, '2019-10-10', 345, NULL),
('Candlewood Suites', 102, '2019-10-11', 356, NULL),
('Candlewood Suites', 102, '2019-10-12', 297, NULL),
('Candlewood Suites', 102, '2019-10-13', 132, NULL),
('Candlewood Suites', 102, '2019-10-14', 276, NULL),
('Candlewood Suites', 102, '2019-10-15', 306, NULL),
('Candlewood Suites', 102, '2019-10-16', 109, NULL),
('Candlewood Suites', 102, '2019-10-17', 112, NULL),
('Candlewood Suites', 102, '2019-10-18', 112, NULL),
('Candlewood Suites', 102, '2019-10-19', 145, NULL),
('Candlewood Suites', 102, '2019-10-20', 329, NULL),
('Candlewood Suites', 102, '2019-10-21', 287, NULL),
('Candlewood Suites', 102, '2019-10-22', 244, NULL),
('Candlewood Suites', 102, '2019-10-23', 202, NULL),
('Candlewood Suites', 102, '2019-10-24', 250, NULL),
('Candlewood Suites', 102, '2019-10-25', 375, NULL),
('Candlewood Suites', 102, '2019-10-26', 252, NULL),
('Candlewood Suites', 102, '2019-10-27', 193, NULL),
('Candlewood Suites', 102, '2019-10-28', 297, NULL),
('Candlewood Suites', 102, '2019-10-29', 190, NULL),
('Candlewood Suites', 102, '2019-10-30', 102, NULL),
('Candlewood Suites', 102, '2019-10-31', 323, NULL),
('Candlewood Suites', 102, '2019-11-01', 133, NULL),
('Candlewood Suites', 102, '2019-11-02', 267, NULL),
('Candlewood Suites', 102, '2019-11-03', 352, NULL),
('Candlewood Suites', 102, '2019-11-04', 293, NULL),
('Candlewood Suites', 102, '2019-11-05', 257, NULL),
('Candlewood Suites', 102, '2019-11-06', 165, NULL),
('Candlewood Suites', 102, '2019-11-07', 321, NULL),
('Candlewood Suites', 102, '2019-11-08', 190, NULL),
('Candlewood Suites', 102, '2019-11-09', 334, NULL),
('Candlewood Suites', 102, '2019-11-10', 188, NULL),
('Candlewood Suites', 102, '2019-11-11', 110, NULL),
('Candlewood Suites', 102, '2019-11-12', 160, NULL),
('Candlewood Suites', 102, '2019-11-13', 185, NULL),
('Candlewood Suites', 102, '2019-11-14', 161, NULL),
('Candlewood Suites', 102, '2019-11-15', 190, NULL),
('Candlewood Suites', 102, '2019-11-16', 368, NULL),
('Candlewood Suites', 102, '2019-11-17', 288, NULL),
('Candlewood Suites', 102, '2019-11-18', 203, NULL),
('Candlewood Suites', 102, '2019-11-19', 384, NULL),
('Candlewood Suites', 102, '2019-11-20', 313, NULL),
('Candlewood Suites', 102, '2019-11-21', 192, NULL),
('Candlewood Suites', 102, '2019-11-22', 313, NULL),
('Candlewood Suites', 102, '2019-11-23', 170, NULL),
('Candlewood Suites', 102, '2019-11-24', 156, NULL),
('Candlewood Suites', 102, '2019-11-25', 160, NULL),
('Candlewood Suites', 102, '2019-11-26', 231, NULL),
('Candlewood Suites', 102, '2019-11-27', 314, NULL),
('Candlewood Suites', 102, '2019-11-28', 168, NULL),
('Candlewood Suites', 102, '2019-11-29', 121, NULL),
('Candlewood Suites', 102, '2019-11-30', 162, NULL),
('Candlewood Suites', 102, '2019-12-01', 296, NULL),
('Candlewood Suites', 102, '2019-12-02', 366, NULL),
('Candlewood Suites', 102, '2019-12-03', 139, NULL),
('Candlewood Suites', 102, '2019-12-04', 173, NULL),
('Candlewood Suites', 102, '2019-12-05', 344, NULL),
('Candlewood Suites', 102, '2019-12-06', 266, NULL),
('Candlewood Suites', 102, '2019-12-07', 336, NULL),
('Candlewood Suites', 102, '2019-12-08', 153, NULL),
('Candlewood Suites', 102, '2019-12-09', 396, NULL),
('Candlewood Suites', 102, '2019-12-10', 173, NULL),
('Candlewood Suites', 102, '2019-12-11', 106, NULL),
('Candlewood Suites', 102, '2019-12-12', 258, NULL),
('Candlewood Suites', 102, '2019-12-13', 157, NULL),
('Candlewood Suites', 102, '2019-12-14', 324, NULL),
('Candlewood Suites', 102, '2019-12-15', 392, NULL),
('Candlewood Suites', 102, '2019-12-16', 157, NULL),
('Candlewood Suites', 102, '2019-12-17', 391, NULL),
('Candlewood Suites', 102, '2019-12-18', 251, NULL),
('Candlewood Suites', 102, '2019-12-19', 236, NULL),
('Candlewood Suites', 102, '2019-12-20', 265, NULL),
('Candlewood Suites', 102, '2019-12-21', 198, NULL),
('Candlewood Suites', 102, '2019-12-22', 374, NULL),
('Candlewood Suites', 102, '2019-12-23', 320, NULL),
('Candlewood Suites', 102, '2019-12-24', 301, NULL),
('Candlewood Suites', 102, '2019-12-25', 107, NULL),
('Candlewood Suites', 102, '2019-12-26', 316, NULL),
('Candlewood Suites', 102, '2019-12-27', 152, NULL),
('Candlewood Suites', 102, '2019-12-28', 310, NULL),
('Candlewood Suites', 102, '2019-12-29', 258, NULL),
('Candlewood Suites', 102, '2019-12-30', 224, NULL),
('Candlewood Suites', 102, '2019-12-31', 153, NULL),
('Candlewood Suites', 102, '2020-01-01', 119, NULL),
('Candlewood Suites', 102, '2020-01-02', 293, NULL),
('Candlewood Suites', 102, '2020-01-03', 267, NULL),
('Candlewood Suites', 102, '2020-01-04', 111, NULL),
('Candlewood Suites', 102, '2020-01-05', 137, NULL),
('Candlewood Suites', 102, '2020-01-06', 330, NULL),
('Candlewood Suites', 102, '2020-01-07', 207, NULL),
('Candlewood Suites', 102, '2020-01-08', 366, NULL),
('Candlewood Suites', 102, '2020-01-09', 223, NULL),
('Candlewood Suites', 102, '2020-01-10', 390, NULL),
('Candlewood Suites', 102, '2020-01-11', 196, NULL),
('Candlewood Suites', 102, '2020-01-12', 217, NULL),
('Candlewood Suites', 102, '2020-01-13', 312, NULL),
('Candlewood Suites', 102, '2020-01-14', 306, NULL),
('Candlewood Suites', 102, '2020-01-15', 306, NULL),
('Candlewood Suites', 102, '2020-01-16', 340, NULL),
('Candlewood Suites', 102, '2020-01-17', 367, NULL),
('Candlewood Suites', 102, '2020-01-18', 159, NULL),
('Candlewood Suites', 102, '2020-01-19', 112, NULL),
('Candlewood Suites', 102, '2020-01-20', 318, NULL),
('Candlewood Suites', 102, '2020-01-21', 223, NULL),
('Candlewood Suites', 102, '2020-01-22', 399, NULL),
('Candlewood Suites', 102, '2020-01-23', 226, NULL),
('Candlewood Suites', 102, '2020-01-24', 150, NULL),
('Candlewood Suites', 102, '2020-01-25', 129, NULL),
('Candlewood Suites', 102, '2020-01-26', 294, NULL),
('Candlewood Suites', 102, '2020-01-27', 158, NULL),
('Candlewood Suites', 102, '2020-01-28', 379, NULL),
('Candlewood Suites', 102, '2020-01-29', 209, NULL),
('Candlewood Suites', 102, '2020-01-30', 168, NULL),
('Candlewood Suites', 102, '2020-01-31', 320, NULL),
('Candlewood Suites', 102, '2020-02-01', 134, NULL),
('Candlewood Suites', 102, '2020-02-02', 279, NULL),
('Candlewood Suites', 102, '2020-02-03', 155, NULL),
('Candlewood Suites', 102, '2020-02-04', 390, NULL),
('Candlewood Suites', 105, '2019-01-01', 328, NULL),
('Candlewood Suites', 105, '2019-01-02', 256, NULL),
('Candlewood Suites', 105, '2019-01-03', 166, NULL),
('Candlewood Suites', 105, '2019-01-04', 335, NULL),
('Candlewood Suites', 105, '2019-01-05', 137, NULL),
('Candlewood Suites', 105, '2019-01-06', 193, NULL),
('Candlewood Suites', 105, '2019-01-07', 343, NULL),
('Candlewood Suites', 105, '2019-01-08', 103, NULL),
('Candlewood Suites', 105, '2019-01-09', 102, NULL),
('Candlewood Suites', 105, '2019-01-10', 301, NULL),
('Candlewood Suites', 105, '2019-01-11', 251, NULL),
('Candlewood Suites', 105, '2019-01-12', 113, NULL),
('Candlewood Suites', 105, '2019-01-13', 213, NULL),
('Candlewood Suites', 105, '2019-01-14', 305, NULL),
('Candlewood Suites', 105, '2019-01-15', 387, NULL),
('Candlewood Suites', 105, '2019-01-16', 394, NULL),
('Candlewood Suites', 105, '2019-01-17', 227, NULL),
('Candlewood Suites', 105, '2019-01-18', 194, NULL),
('Candlewood Suites', 105, '2019-01-19', 368, NULL),
('Candlewood Suites', 105, '2019-01-20', 107, NULL),
('Candlewood Suites', 105, '2019-01-21', 103, NULL),
('Candlewood Suites', 105, '2019-01-22', 227, NULL),
('Candlewood Suites', 105, '2019-01-23', 362, NULL),
('Candlewood Suites', 105, '2019-01-24', 226, NULL),
('Candlewood Suites', 105, '2019-01-25', 365, NULL),
('Candlewood Suites', 105, '2019-01-26', 395, NULL),
('Candlewood Suites', 105, '2019-01-27', 364, NULL),
('Candlewood Suites', 105, '2019-01-28', 247, NULL),
('Candlewood Suites', 105, '2019-01-29', 192, NULL),
('Candlewood Suites', 105, '2019-01-30', 253, NULL),
('Candlewood Suites', 105, '2019-01-31', 340, NULL),
('Candlewood Suites', 105, '2019-02-01', 116, NULL),
('Candlewood Suites', 105, '2019-02-02', 199, NULL),
('Candlewood Suites', 105, '2019-02-03', 180, NULL),
('Candlewood Suites', 105, '2019-02-04', 249, NULL),
('Candlewood Suites', 105, '2019-02-05', 274, NULL),
('Candlewood Suites', 105, '2019-02-06', 279, NULL),
('Candlewood Suites', 105, '2019-02-07', 254, NULL),
('Candlewood Suites', 105, '2019-02-08', 166, NULL),
('Candlewood Suites', 105, '2019-02-09', 386, NULL),
('Candlewood Suites', 105, '2019-02-10', 346, NULL),
('Candlewood Suites', 105, '2019-02-11', 298, NULL),
('Candlewood Suites', 105, '2019-02-12', 202, NULL),
('Candlewood Suites', 105, '2019-02-13', 283, NULL),
('Candlewood Suites', 105, '2019-02-14', 272, NULL),
('Candlewood Suites', 105, '2019-02-15', 365, NULL),
('Candlewood Suites', 105, '2019-02-16', 250, NULL),
('Candlewood Suites', 105, '2019-02-17', 249, NULL),
('Candlewood Suites', 105, '2019-02-18', 183, NULL),
('Candlewood Suites', 105, '2019-02-19', 261, NULL),
('Candlewood Suites', 105, '2019-02-20', 263, NULL),
('Candlewood Suites', 105, '2019-02-21', 272, NULL),
('Candlewood Suites', 105, '2019-02-22', 109, NULL),
('Candlewood Suites', 105, '2019-02-23', 376, NULL),
('Candlewood Suites', 105, '2019-02-24', 272, NULL),
('Candlewood Suites', 105, '2019-02-25', 262, NULL),
('Candlewood Suites', 105, '2019-02-26', 120, NULL),
('Candlewood Suites', 105, '2019-02-27', 393, NULL),
('Candlewood Suites', 105, '2019-02-28', 202, NULL),
('Candlewood Suites', 105, '2019-03-01', 382, NULL),
('Candlewood Suites', 105, '2019-03-02', 181, NULL),
('Candlewood Suites', 105, '2019-03-03', 186, NULL),
('Candlewood Suites', 105, '2019-03-04', 266, NULL),
('Candlewood Suites', 105, '2019-03-05', 220, NULL),
('Candlewood Suites', 105, '2019-03-06', 302, NULL),
('Candlewood Suites', 105, '2019-03-07', 328, NULL),
('Candlewood Suites', 105, '2019-03-08', 371, NULL),
('Candlewood Suites', 105, '2019-03-09', 337, NULL),
('Candlewood Suites', 105, '2019-03-10', 237, NULL),
('Candlewood Suites', 105, '2019-03-11', 365, NULL),
('Candlewood Suites', 105, '2019-03-12', 263, NULL),
('Candlewood Suites', 105, '2019-03-13', 378, NULL),
('Candlewood Suites', 105, '2019-03-14', 321, NULL),
('Candlewood Suites', 105, '2019-03-15', 367, NULL),
('Candlewood Suites', 105, '2019-03-16', 255, NULL),
('Candlewood Suites', 105, '2019-03-17', 131, NULL),
('Candlewood Suites', 105, '2019-03-18', 203, NULL),
('Candlewood Suites', 105, '2019-03-19', 309, NULL),
('Candlewood Suites', 105, '2019-03-20', 180, NULL),
('Candlewood Suites', 105, '2019-03-21', 161, NULL),
('Candlewood Suites', 105, '2019-03-22', 271, NULL),
('Candlewood Suites', 105, '2019-03-23', 346, NULL),
('Candlewood Suites', 105, '2019-03-24', 225, NULL),
('Candlewood Suites', 105, '2019-03-25', 190, NULL),
('Candlewood Suites', 105, '2019-03-26', 221, NULL),
('Candlewood Suites', 105, '2019-03-27', 234, NULL),
('Candlewood Suites', 105, '2019-03-28', 168, NULL),
('Candlewood Suites', 105, '2019-03-29', 103, NULL),
('Candlewood Suites', 105, '2019-03-30', 160, NULL),
('Candlewood Suites', 105, '2019-03-31', 101, NULL),
('Candlewood Suites', 105, '2019-04-01', 307, NULL),
('Candlewood Suites', 105, '2019-04-02', 350, NULL),
('Candlewood Suites', 105, '2019-04-03', 307, NULL),
('Candlewood Suites', 105, '2019-04-04', 385, NULL),
('Candlewood Suites', 105, '2019-04-05', 106, NULL),
('Candlewood Suites', 105, '2019-04-06', 375, NULL),
('Candlewood Suites', 105, '2019-04-07', 238, NULL),
('Candlewood Suites', 105, '2019-04-08', 229, NULL),
('Candlewood Suites', 105, '2019-04-09', 341, NULL),
('Candlewood Suites', 105, '2019-04-10', 129, NULL),
('Candlewood Suites', 105, '2019-04-11', 233, NULL),
('Candlewood Suites', 105, '2019-04-12', 392, NULL),
('Candlewood Suites', 105, '2019-04-13', 148, NULL),
('Candlewood Suites', 105, '2019-04-14', 192, NULL),
('Candlewood Suites', 105, '2019-04-15', 128, NULL),
('Candlewood Suites', 105, '2019-04-16', 372, NULL),
('Candlewood Suites', 105, '2019-04-17', 365, NULL),
('Candlewood Suites', 105, '2019-04-18', 135, NULL),
('Candlewood Suites', 105, '2019-04-19', 269, NULL),
('Candlewood Suites', 105, '2019-04-20', 203, NULL),
('Candlewood Suites', 105, '2019-04-21', 212, NULL),
('Candlewood Suites', 105, '2019-04-22', 201, NULL),
('Candlewood Suites', 105, '2019-04-23', 102, NULL),
('Candlewood Suites', 105, '2019-04-24', 309, NULL),
('Candlewood Suites', 105, '2019-04-25', 347, NULL),
('Candlewood Suites', 105, '2019-04-26', 176, NULL),
('Candlewood Suites', 105, '2019-04-27', 237, NULL),
('Candlewood Suites', 105, '2019-04-28', 108, NULL),
('Candlewood Suites', 105, '2019-04-29', 139, NULL),
('Candlewood Suites', 105, '2019-04-30', 202, NULL),
('Candlewood Suites', 105, '2019-05-01', 303, NULL),
('Candlewood Suites', 105, '2019-05-02', 343, NULL),
('Candlewood Suites', 105, '2019-05-03', 320, NULL),
('Candlewood Suites', 105, '2019-05-04', 132, NULL),
('Candlewood Suites', 105, '2019-05-05', 365, NULL),
('Candlewood Suites', 105, '2019-05-06', 357, NULL),
('Candlewood Suites', 105, '2019-05-07', 301, NULL),
('Candlewood Suites', 105, '2019-05-08', 224, NULL),
('Candlewood Suites', 105, '2019-05-09', 363, NULL),
('Candlewood Suites', 105, '2019-05-10', 111, NULL),
('Candlewood Suites', 105, '2019-05-11', 325, NULL),
('Candlewood Suites', 105, '2019-05-12', 298, NULL),
('Candlewood Suites', 105, '2019-05-13', 116, NULL),
('Candlewood Suites', 105, '2019-05-14', 338, NULL),
('Candlewood Suites', 105, '2019-05-15', 168, NULL),
('Candlewood Suites', 105, '2019-05-16', 288, NULL),
('Candlewood Suites', 105, '2019-05-17', 341, NULL),
('Candlewood Suites', 105, '2019-05-18', 301, NULL),
('Candlewood Suites', 105, '2019-05-19', 257, NULL),
('Candlewood Suites', 105, '2019-05-20', 285, NULL),
('Candlewood Suites', 105, '2019-05-21', 277, NULL),
('Candlewood Suites', 105, '2019-05-22', 350, NULL),
('Candlewood Suites', 105, '2019-05-23', 141, NULL),
('Candlewood Suites', 105, '2019-05-24', 384, NULL),
('Candlewood Suites', 105, '2019-05-25', 331, NULL),
('Candlewood Suites', 105, '2019-05-26', 368, NULL),
('Candlewood Suites', 105, '2019-05-27', 335, NULL),
('Candlewood Suites', 105, '2019-05-28', 343, NULL),
('Candlewood Suites', 105, '2019-05-29', 121, NULL),
('Candlewood Suites', 105, '2019-05-30', 373, NULL),
('Candlewood Suites', 105, '2019-05-31', 265, NULL),
('Candlewood Suites', 105, '2019-06-01', 239, NULL),
('Candlewood Suites', 105, '2019-06-02', 363, NULL),
('Candlewood Suites', 105, '2019-06-03', 304, NULL),
('Candlewood Suites', 105, '2019-06-04', 241, NULL),
('Candlewood Suites', 105, '2019-06-05', 165, NULL),
('Candlewood Suites', 105, '2019-06-06', 391, NULL),
('Candlewood Suites', 105, '2019-06-07', 239, NULL),
('Candlewood Suites', 105, '2019-06-08', 332, NULL),
('Candlewood Suites', 105, '2019-06-09', 158, NULL),
('Candlewood Suites', 105, '2019-06-10', 150, NULL),
('Candlewood Suites', 105, '2019-06-11', 352, NULL),
('Candlewood Suites', 105, '2019-06-12', 375, NULL),
('Candlewood Suites', 105, '2019-06-13', 141, NULL),
('Candlewood Suites', 105, '2019-06-14', 207, NULL),
('Candlewood Suites', 105, '2019-06-15', 147, NULL),
('Candlewood Suites', 105, '2019-06-16', 219, NULL),
('Candlewood Suites', 105, '2019-06-17', 251, NULL),
('Candlewood Suites', 105, '2019-06-18', 251, NULL),
('Candlewood Suites', 105, '2019-06-19', 264, NULL),
('Candlewood Suites', 105, '2019-06-20', 248, NULL),
('Candlewood Suites', 105, '2019-06-21', 300, NULL),
('Candlewood Suites', 105, '2019-06-22', 347, NULL),
('Candlewood Suites', 105, '2019-06-23', 105, NULL),
('Candlewood Suites', 105, '2019-06-24', 277, NULL),
('Candlewood Suites', 105, '2019-06-25', 240, NULL),
('Candlewood Suites', 105, '2019-06-26', 101, NULL),
('Candlewood Suites', 105, '2019-06-27', 199, NULL),
('Candlewood Suites', 105, '2019-06-28', 391, NULL),
('Candlewood Suites', 105, '2019-06-29', 163, NULL),
('Candlewood Suites', 105, '2019-06-30', 209, NULL),
('Candlewood Suites', 105, '2019-07-01', 208, NULL),
('Candlewood Suites', 105, '2019-07-02', 325, NULL),
('Candlewood Suites', 105, '2019-07-03', 247, NULL),
('Candlewood Suites', 105, '2019-07-04', 317, NULL),
('Candlewood Suites', 105, '2019-07-05', 109, NULL),
('Candlewood Suites', 105, '2019-07-06', 174, NULL),
('Candlewood Suites', 105, '2019-07-07', 332, NULL),
('Candlewood Suites', 105, '2019-07-08', 334, NULL),
('Candlewood Suites', 105, '2019-07-09', 205, NULL),
('Candlewood Suites', 105, '2019-07-10', 155, NULL),
('Candlewood Suites', 105, '2019-07-11', 124, NULL),
('Candlewood Suites', 105, '2019-07-12', 213, NULL),
('Candlewood Suites', 105, '2019-07-13', 382, NULL),
('Candlewood Suites', 105, '2019-07-14', 100, NULL),
('Candlewood Suites', 105, '2019-07-15', 145, NULL),
('Candlewood Suites', 105, '2019-07-16', 394, NULL),
('Candlewood Suites', 105, '2019-07-17', 156, NULL),
('Candlewood Suites', 105, '2019-07-18', 264, NULL),
('Candlewood Suites', 105, '2019-07-19', 367, NULL),
('Candlewood Suites', 105, '2019-07-20', 130, NULL),
('Candlewood Suites', 105, '2019-07-21', 328, NULL),
('Candlewood Suites', 105, '2019-07-22', 109, NULL),
('Candlewood Suites', 105, '2019-07-23', 212, NULL),
('Candlewood Suites', 105, '2019-07-24', 258, NULL),
('Candlewood Suites', 105, '2019-07-25', 253, NULL),
('Candlewood Suites', 105, '2019-07-26', 293, NULL),
('Candlewood Suites', 105, '2019-07-27', 397, NULL),
('Candlewood Suites', 105, '2019-07-28', 126, NULL),
('Candlewood Suites', 105, '2019-07-29', 145, NULL),
('Candlewood Suites', 105, '2019-07-30', 118, NULL),
('Candlewood Suites', 105, '2019-07-31', 173, NULL),
('Candlewood Suites', 105, '2019-08-01', 107, NULL),
('Candlewood Suites', 105, '2019-08-02', 338, NULL),
('Candlewood Suites', 105, '2019-08-03', 325, NULL),
('Candlewood Suites', 105, '2019-08-04', 240, NULL),
('Candlewood Suites', 105, '2019-08-05', 249, NULL),
('Candlewood Suites', 105, '2019-08-06', 275, NULL),
('Candlewood Suites', 105, '2019-08-07', 287, NULL),
('Candlewood Suites', 105, '2019-08-08', 216, NULL),
('Candlewood Suites', 105, '2019-08-09', 231, NULL),
('Candlewood Suites', 105, '2019-08-10', 113, NULL),
('Candlewood Suites', 105, '2019-08-11', 322, NULL),
('Candlewood Suites', 105, '2019-08-12', 134, NULL),
('Candlewood Suites', 105, '2019-08-13', 164, NULL),
('Candlewood Suites', 105, '2019-08-14', 233, NULL),
('Candlewood Suites', 105, '2019-08-15', 306, NULL),
('Candlewood Suites', 105, '2019-08-16', 295, NULL),
('Candlewood Suites', 105, '2019-08-17', 376, NULL),
('Candlewood Suites', 105, '2019-08-18', 199, NULL),
('Candlewood Suites', 105, '2019-08-19', 140, NULL),
('Candlewood Suites', 105, '2019-08-20', 275, NULL),
('Candlewood Suites', 105, '2019-08-21', 302, NULL),
('Candlewood Suites', 105, '2019-08-22', 177, NULL),
('Candlewood Suites', 105, '2019-08-23', 222, NULL),
('Candlewood Suites', 105, '2019-08-24', 289, NULL),
('Candlewood Suites', 105, '2019-08-25', 204, NULL),
('Candlewood Suites', 105, '2019-08-26', 265, NULL),
('Candlewood Suites', 105, '2019-08-27', 355, NULL),
('Candlewood Suites', 105, '2019-08-28', 301, NULL),
('Candlewood Suites', 105, '2019-08-29', 241, NULL),
('Candlewood Suites', 105, '2019-08-30', 256, NULL),
('Candlewood Suites', 105, '2019-08-31', 396, NULL),
('Candlewood Suites', 105, '2019-09-01', 147, NULL),
('Candlewood Suites', 105, '2019-09-02', 214, NULL),
('Candlewood Suites', 105, '2019-09-03', 366, NULL),
('Candlewood Suites', 105, '2019-09-04', 114, NULL),
('Candlewood Suites', 105, '2019-09-05', 100, NULL),
('Candlewood Suites', 105, '2019-09-06', 374, NULL),
('Candlewood Suites', 105, '2019-09-07', 387, NULL),
('Candlewood Suites', 105, '2019-09-08', 158, NULL),
('Candlewood Suites', 105, '2019-09-09', 133, NULL),
('Candlewood Suites', 105, '2019-09-10', 339, NULL),
('Candlewood Suites', 105, '2019-09-11', 142, NULL),
('Candlewood Suites', 105, '2019-09-12', 207, NULL),
('Candlewood Suites', 105, '2019-09-13', 228, NULL),
('Candlewood Suites', 105, '2019-09-14', 317, NULL),
('Candlewood Suites', 105, '2019-09-15', 394, NULL),
('Candlewood Suites', 105, '2019-09-16', 172, NULL),
('Candlewood Suites', 105, '2019-09-17', 204, NULL),
('Candlewood Suites', 105, '2019-09-18', 185, NULL),
('Candlewood Suites', 105, '2019-09-19', 161, NULL),
('Candlewood Suites', 105, '2019-09-20', 204, NULL),
('Candlewood Suites', 105, '2019-09-21', 349, NULL),
('Candlewood Suites', 105, '2019-09-22', 254, NULL),
('Candlewood Suites', 105, '2019-09-23', 232, NULL),
('Candlewood Suites', 105, '2019-09-24', 310, NULL),
('Candlewood Suites', 105, '2019-09-25', 338, NULL),
('Candlewood Suites', 105, '2019-09-26', 306, NULL),
('Candlewood Suites', 105, '2019-09-27', 105, NULL),
('Candlewood Suites', 105, '2019-09-28', 358, NULL),
('Candlewood Suites', 105, '2019-09-29', 388, NULL),
('Candlewood Suites', 105, '2019-09-30', 226, NULL),
('Candlewood Suites', 105, '2019-10-01', 198, NULL),
('Candlewood Suites', 105, '2019-10-02', 116, NULL),
('Candlewood Suites', 105, '2019-10-03', 142, NULL),
('Candlewood Suites', 105, '2019-10-04', 256, NULL),
('Candlewood Suites', 105, '2019-10-05', 239, NULL),
('Candlewood Suites', 105, '2019-10-06', 118, NULL),
('Candlewood Suites', 105, '2019-10-07', 392, NULL),
('Candlewood Suites', 105, '2019-10-08', 122, NULL),
('Candlewood Suites', 105, '2019-10-09', 287, NULL),
('Candlewood Suites', 105, '2019-10-10', 326, NULL),
('Candlewood Suites', 105, '2019-10-11', 303, NULL),
('Candlewood Suites', 105, '2019-10-12', 191, NULL),
('Candlewood Suites', 105, '2019-10-13', 237, NULL),
('Candlewood Suites', 105, '2019-10-14', 107, NULL),
('Candlewood Suites', 105, '2019-10-15', 166, NULL),
('Candlewood Suites', 105, '2019-10-16', 296, NULL),
('Candlewood Suites', 105, '2019-10-17', 209, NULL),
('Candlewood Suites', 105, '2019-10-18', 143, NULL),
('Candlewood Suites', 105, '2019-10-19', 167, NULL),
('Candlewood Suites', 105, '2019-10-20', 116, NULL),
('Candlewood Suites', 105, '2019-10-21', 390, NULL),
('Candlewood Suites', 105, '2019-10-22', 389, NULL),
('Candlewood Suites', 105, '2019-10-23', 107, NULL),
('Candlewood Suites', 105, '2019-10-24', 329, NULL),
('Candlewood Suites', 105, '2019-10-25', 259, NULL),
('Candlewood Suites', 105, '2019-10-26', 379, NULL),
('Candlewood Suites', 105, '2019-10-27', 348, NULL),
('Candlewood Suites', 105, '2019-10-28', 349, NULL),
('Candlewood Suites', 105, '2019-10-29', 141, NULL),
('Candlewood Suites', 105, '2019-10-30', 197, NULL),
('Candlewood Suites', 105, '2019-10-31', 185, NULL),
('Candlewood Suites', 105, '2019-11-01', 309, NULL),
('Candlewood Suites', 105, '2019-11-02', 162, NULL),
('Candlewood Suites', 105, '2019-11-03', 262, NULL),
('Candlewood Suites', 105, '2019-11-04', 187, NULL),
('Candlewood Suites', 105, '2019-11-05', 179, NULL),
('Candlewood Suites', 105, '2019-11-06', 186, NULL),
('Candlewood Suites', 105, '2019-11-07', 247, NULL),
('Candlewood Suites', 105, '2019-11-08', 170, NULL),
('Candlewood Suites', 105, '2019-11-09', 264, NULL),
('Candlewood Suites', 105, '2019-11-10', 286, NULL),
('Candlewood Suites', 105, '2019-11-11', 111, NULL),
('Candlewood Suites', 105, '2019-11-12', 210, NULL),
('Candlewood Suites', 105, '2019-11-13', 320, NULL),
('Candlewood Suites', 105, '2019-11-14', 245, NULL),
('Candlewood Suites', 105, '2019-11-15', 287, NULL),
('Candlewood Suites', 105, '2019-11-16', 103, NULL),
('Candlewood Suites', 105, '2019-11-17', 272, NULL),
('Candlewood Suites', 105, '2019-11-18', 198, NULL),
('Candlewood Suites', 105, '2019-11-19', 239, NULL),
('Candlewood Suites', 105, '2019-11-20', 383, NULL),
('Candlewood Suites', 105, '2019-11-21', 340, NULL),
('Candlewood Suites', 105, '2019-11-22', 302, NULL),
('Candlewood Suites', 105, '2019-11-23', 355, NULL),
('Candlewood Suites', 105, '2019-11-24', 170, NULL),
('Candlewood Suites', 105, '2019-11-25', 108, NULL),
('Candlewood Suites', 105, '2019-11-26', 178, NULL),
('Candlewood Suites', 105, '2019-11-27', 101, NULL),
('Candlewood Suites', 105, '2019-11-28', 251, NULL),
('Candlewood Suites', 105, '2019-11-29', 177, NULL),
('Candlewood Suites', 105, '2019-11-30', 386, NULL),
('Candlewood Suites', 105, '2019-12-01', 235, NULL),
('Candlewood Suites', 105, '2019-12-02', 278, NULL),
('Candlewood Suites', 105, '2019-12-03', 363, NULL),
('Candlewood Suites', 105, '2019-12-04', 200, NULL),
('Candlewood Suites', 105, '2019-12-05', 171, NULL),
('Candlewood Suites', 105, '2019-12-06', 233, NULL),
('Candlewood Suites', 105, '2019-12-07', 287, NULL),
('Candlewood Suites', 105, '2019-12-08', 260, NULL),
('Candlewood Suites', 105, '2019-12-09', 213, NULL),
('Candlewood Suites', 105, '2019-12-10', 217, NULL),
('Candlewood Suites', 105, '2019-12-11', 164, NULL),
('Candlewood Suites', 105, '2019-12-12', 368, NULL),
('Candlewood Suites', 105, '2019-12-13', 288, NULL),
('Candlewood Suites', 105, '2019-12-14', 225, NULL),
('Candlewood Suites', 105, '2019-12-15', 333, NULL),
('Candlewood Suites', 105, '2019-12-16', 102, NULL),
('Candlewood Suites', 105, '2019-12-17', 204, NULL),
('Candlewood Suites', 105, '2019-12-18', 147, NULL),
('Candlewood Suites', 105, '2019-12-19', 232, NULL),
('Candlewood Suites', 105, '2019-12-20', 248, NULL),
('Candlewood Suites', 105, '2019-12-21', 372, NULL),
('Candlewood Suites', 105, '2019-12-22', 264, NULL),
('Candlewood Suites', 105, '2019-12-23', 252, NULL),
('Candlewood Suites', 105, '2019-12-24', 213, NULL),
('Candlewood Suites', 105, '2019-12-25', 143, NULL),
('Candlewood Suites', 105, '2019-12-26', 201, NULL),
('Candlewood Suites', 105, '2019-12-27', 311, NULL),
('Candlewood Suites', 105, '2019-12-28', 243, NULL),
('Candlewood Suites', 105, '2019-12-29', 331, NULL),
('Candlewood Suites', 105, '2019-12-30', 262, NULL),
('Candlewood Suites', 105, '2019-12-31', 166, NULL),
('Candlewood Suites', 105, '2020-01-01', 101, NULL),
('Candlewood Suites', 105, '2020-01-02', 168, NULL),
('Candlewood Suites', 105, '2020-01-03', 218, NULL),
('Candlewood Suites', 105, '2020-01-04', 395, NULL),
('Candlewood Suites', 105, '2020-01-05', 286, NULL),
('Candlewood Suites', 105, '2020-01-06', 254, NULL),
('Candlewood Suites', 105, '2020-01-07', 254, NULL),
('Candlewood Suites', 105, '2020-01-08', 235, NULL),
('Candlewood Suites', 105, '2020-01-09', 266, NULL),
('Candlewood Suites', 105, '2020-01-10', 396, NULL),
('Candlewood Suites', 105, '2020-01-11', 228, NULL),
('Candlewood Suites', 105, '2020-01-12', 311, NULL),
('Candlewood Suites', 105, '2020-01-13', 205, NULL),
('Candlewood Suites', 105, '2020-01-14', 216, NULL),
('Candlewood Suites', 105, '2020-01-15', 377, NULL),
('Candlewood Suites', 105, '2020-01-16', 329, NULL),
('Candlewood Suites', 105, '2020-01-17', 343, NULL),
('Candlewood Suites', 105, '2020-01-18', 283, NULL),
('Candlewood Suites', 105, '2020-01-19', 318, NULL),
('Candlewood Suites', 105, '2020-01-20', 273, NULL),
('Candlewood Suites', 105, '2020-01-21', 358, NULL),
('Candlewood Suites', 105, '2020-01-22', 192, NULL),
('Candlewood Suites', 105, '2020-01-23', 398, NULL),
('Candlewood Suites', 105, '2020-01-24', 296, NULL),
('Candlewood Suites', 105, '2020-01-25', 325, NULL),
('Candlewood Suites', 105, '2020-01-26', 301, NULL),
('Candlewood Suites', 105, '2020-01-27', 251, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 105, '2020-01-28', 397, NULL),
('Candlewood Suites', 105, '2020-01-29', 244, NULL),
('Candlewood Suites', 105, '2020-01-30', 144, NULL),
('Candlewood Suites', 105, '2020-01-31', 345, NULL),
('Candlewood Suites', 105, '2020-02-01', 247, NULL),
('Candlewood Suites', 105, '2020-02-02', 213, NULL),
('Candlewood Suites', 105, '2020-02-03', 129, NULL),
('Candlewood Suites', 105, '2020-02-04', 261, NULL),
('Candlewood Suites', 106, '2019-01-01', 119, NULL),
('Candlewood Suites', 106, '2019-01-02', 135, NULL),
('Candlewood Suites', 106, '2019-01-03', 375, NULL),
('Candlewood Suites', 106, '2019-01-04', 106, NULL),
('Candlewood Suites', 106, '2019-01-05', 394, NULL),
('Candlewood Suites', 106, '2019-01-06', 162, NULL),
('Candlewood Suites', 106, '2019-01-07', 393, NULL),
('Candlewood Suites', 106, '2019-01-08', 162, NULL),
('Candlewood Suites', 106, '2019-01-09', 307, NULL),
('Candlewood Suites', 106, '2019-01-10', 263, NULL),
('Candlewood Suites', 106, '2019-01-11', 212, NULL),
('Candlewood Suites', 106, '2019-01-12', 243, NULL),
('Candlewood Suites', 106, '2019-01-13', 285, NULL),
('Candlewood Suites', 106, '2019-01-14', 113, NULL),
('Candlewood Suites', 106, '2019-01-15', 311, NULL),
('Candlewood Suites', 106, '2019-01-16', 328, NULL),
('Candlewood Suites', 106, '2019-01-17', 149, NULL),
('Candlewood Suites', 106, '2019-01-18', 242, NULL),
('Candlewood Suites', 106, '2019-01-19', 214, NULL),
('Candlewood Suites', 106, '2019-01-20', 235, NULL),
('Candlewood Suites', 106, '2019-01-21', 247, NULL),
('Candlewood Suites', 106, '2019-01-22', 139, NULL),
('Candlewood Suites', 106, '2019-01-23', 318, NULL),
('Candlewood Suites', 106, '2019-01-24', 295, NULL),
('Candlewood Suites', 106, '2019-01-25', 179, NULL),
('Candlewood Suites', 106, '2019-01-26', 205, NULL),
('Candlewood Suites', 106, '2019-01-27', 117, NULL),
('Candlewood Suites', 106, '2019-01-28', 196, NULL),
('Candlewood Suites', 106, '2019-01-29', 201, NULL),
('Candlewood Suites', 106, '2019-01-30', 334, NULL),
('Candlewood Suites', 106, '2019-01-31', 291, NULL),
('Candlewood Suites', 106, '2019-02-01', 309, NULL),
('Candlewood Suites', 106, '2019-02-02', 388, NULL),
('Candlewood Suites', 106, '2019-02-03', 283, NULL),
('Candlewood Suites', 106, '2019-02-04', 358, NULL),
('Candlewood Suites', 106, '2019-02-05', 386, NULL),
('Candlewood Suites', 106, '2019-02-06', 330, NULL),
('Candlewood Suites', 106, '2019-02-07', 297, NULL),
('Candlewood Suites', 106, '2019-02-08', 381, NULL),
('Candlewood Suites', 106, '2019-02-09', 326, NULL),
('Candlewood Suites', 106, '2019-02-10', 193, NULL),
('Candlewood Suites', 106, '2019-02-11', 265, NULL),
('Candlewood Suites', 106, '2019-02-12', 169, NULL),
('Candlewood Suites', 106, '2019-02-13', 212, NULL),
('Candlewood Suites', 106, '2019-02-14', 262, NULL),
('Candlewood Suites', 106, '2019-02-15', 254, NULL),
('Candlewood Suites', 106, '2019-02-16', 149, NULL),
('Candlewood Suites', 106, '2019-02-17', 166, NULL),
('Candlewood Suites', 106, '2019-02-18', 341, NULL),
('Candlewood Suites', 106, '2019-02-19', 284, NULL),
('Candlewood Suites', 106, '2019-02-20', 121, NULL),
('Candlewood Suites', 106, '2019-02-21', 394, NULL),
('Candlewood Suites', 106, '2019-02-22', 334, NULL),
('Candlewood Suites', 106, '2019-02-23', 180, NULL),
('Candlewood Suites', 106, '2019-02-24', 342, NULL),
('Candlewood Suites', 106, '2019-02-25', 144, NULL),
('Candlewood Suites', 106, '2019-02-26', 341, NULL),
('Candlewood Suites', 106, '2019-02-27', 326, NULL),
('Candlewood Suites', 106, '2019-02-28', 314, NULL),
('Candlewood Suites', 106, '2019-03-01', 215, NULL),
('Candlewood Suites', 106, '2019-03-02', 103, NULL),
('Candlewood Suites', 106, '2019-03-03', 231, NULL),
('Candlewood Suites', 106, '2019-03-04', 177, NULL),
('Candlewood Suites', 106, '2019-03-05', 373, NULL),
('Candlewood Suites', 106, '2019-03-06', 275, NULL),
('Candlewood Suites', 106, '2019-03-07', 355, NULL),
('Candlewood Suites', 106, '2019-03-08', 169, NULL),
('Candlewood Suites', 106, '2019-03-09', 176, NULL),
('Candlewood Suites', 106, '2019-03-10', 142, NULL),
('Candlewood Suites', 106, '2019-03-11', 169, NULL),
('Candlewood Suites', 106, '2019-03-12', 278, NULL),
('Candlewood Suites', 106, '2019-03-13', 200, NULL),
('Candlewood Suites', 106, '2019-03-14', 221, NULL),
('Candlewood Suites', 106, '2019-03-15', 355, NULL),
('Candlewood Suites', 106, '2019-03-16', 297, NULL),
('Candlewood Suites', 106, '2019-03-17', 312, NULL),
('Candlewood Suites', 106, '2019-03-18', 194, NULL),
('Candlewood Suites', 106, '2019-03-19', 358, NULL),
('Candlewood Suites', 106, '2019-03-20', 170, NULL),
('Candlewood Suites', 106, '2019-03-21', 221, NULL),
('Candlewood Suites', 106, '2019-03-22', 294, NULL),
('Candlewood Suites', 106, '2019-03-23', 253, NULL),
('Candlewood Suites', 106, '2019-03-24', 315, NULL),
('Candlewood Suites', 106, '2019-03-25', 291, NULL),
('Candlewood Suites', 106, '2019-03-26', 363, NULL),
('Candlewood Suites', 106, '2019-03-27', 108, NULL),
('Candlewood Suites', 106, '2019-03-28', 189, NULL),
('Candlewood Suites', 106, '2019-03-29', 316, NULL),
('Candlewood Suites', 106, '2019-03-30', 125, NULL),
('Candlewood Suites', 106, '2019-03-31', 227, NULL),
('Candlewood Suites', 106, '2019-04-01', 324, NULL),
('Candlewood Suites', 106, '2019-04-02', 392, NULL),
('Candlewood Suites', 106, '2019-04-03', 158, NULL),
('Candlewood Suites', 106, '2019-04-04', 358, NULL),
('Candlewood Suites', 106, '2019-04-05', 216, NULL),
('Candlewood Suites', 106, '2019-04-06', 193, NULL),
('Candlewood Suites', 106, '2019-04-07', 259, NULL),
('Candlewood Suites', 106, '2019-04-08', 111, NULL),
('Candlewood Suites', 106, '2019-04-09', 347, NULL),
('Candlewood Suites', 106, '2019-04-10', 233, NULL),
('Candlewood Suites', 106, '2019-04-11', 308, NULL),
('Candlewood Suites', 106, '2019-04-12', 322, NULL),
('Candlewood Suites', 106, '2019-04-13', 371, NULL),
('Candlewood Suites', 106, '2019-04-14', 306, NULL),
('Candlewood Suites', 106, '2019-04-15', 392, NULL),
('Candlewood Suites', 106, '2019-04-16', 358, NULL),
('Candlewood Suites', 106, '2019-04-17', 158, NULL),
('Candlewood Suites', 106, '2019-04-18', 151, NULL),
('Candlewood Suites', 106, '2019-04-19', 186, NULL),
('Candlewood Suites', 106, '2019-04-20', 281, NULL),
('Candlewood Suites', 106, '2019-04-21', 259, NULL),
('Candlewood Suites', 106, '2019-04-22', 249, NULL),
('Candlewood Suites', 106, '2019-04-23', 161, NULL),
('Candlewood Suites', 106, '2019-04-24', 182, NULL),
('Candlewood Suites', 106, '2019-04-25', 290, NULL),
('Candlewood Suites', 106, '2019-04-26', 152, NULL),
('Candlewood Suites', 106, '2019-04-27', 226, NULL),
('Candlewood Suites', 106, '2019-04-28', 177, NULL),
('Candlewood Suites', 106, '2019-04-29', 330, NULL),
('Candlewood Suites', 106, '2019-04-30', 135, NULL),
('Candlewood Suites', 106, '2019-05-01', 221, NULL),
('Candlewood Suites', 106, '2019-05-02', 104, NULL),
('Candlewood Suites', 106, '2019-05-03', 167, NULL),
('Candlewood Suites', 106, '2019-05-04', 357, NULL),
('Candlewood Suites', 106, '2019-05-05', 366, NULL),
('Candlewood Suites', 106, '2019-05-06', 126, NULL),
('Candlewood Suites', 106, '2019-05-07', 134, NULL),
('Candlewood Suites', 106, '2019-05-08', 172, NULL),
('Candlewood Suites', 106, '2019-05-09', 388, NULL),
('Candlewood Suites', 106, '2019-05-10', 104, NULL),
('Candlewood Suites', 106, '2019-05-11', 300, NULL),
('Candlewood Suites', 106, '2019-05-12', 229, NULL),
('Candlewood Suites', 106, '2019-05-13', 280, NULL),
('Candlewood Suites', 106, '2019-05-14', 284, NULL),
('Candlewood Suites', 106, '2019-05-15', 241, NULL),
('Candlewood Suites', 106, '2019-05-16', 395, NULL),
('Candlewood Suites', 106, '2019-05-17', 147, NULL),
('Candlewood Suites', 106, '2019-05-18', 233, NULL),
('Candlewood Suites', 106, '2019-05-19', 389, NULL),
('Candlewood Suites', 106, '2019-05-20', 249, NULL),
('Candlewood Suites', 106, '2019-05-21', 199, NULL),
('Candlewood Suites', 106, '2019-05-22', 271, NULL),
('Candlewood Suites', 106, '2019-05-23', 210, NULL),
('Candlewood Suites', 106, '2019-05-24', 245, NULL),
('Candlewood Suites', 106, '2019-05-25', 238, NULL),
('Candlewood Suites', 106, '2019-05-26', 291, NULL),
('Candlewood Suites', 106, '2019-05-27', 306, NULL),
('Candlewood Suites', 106, '2019-05-28', 244, NULL),
('Candlewood Suites', 106, '2019-05-29', 293, NULL),
('Candlewood Suites', 106, '2019-05-30', 144, NULL),
('Candlewood Suites', 106, '2019-05-31', 138, NULL),
('Candlewood Suites', 106, '2019-06-01', 185, NULL),
('Candlewood Suites', 106, '2019-06-02', 317, NULL),
('Candlewood Suites', 106, '2019-06-03', 337, NULL),
('Candlewood Suites', 106, '2019-06-04', 194, NULL),
('Candlewood Suites', 106, '2019-06-05', 150, NULL),
('Candlewood Suites', 106, '2019-06-06', 394, NULL),
('Candlewood Suites', 106, '2019-06-07', 346, NULL),
('Candlewood Suites', 106, '2019-06-08', 367, NULL),
('Candlewood Suites', 106, '2019-06-09', 198, NULL),
('Candlewood Suites', 106, '2019-06-10', 260, NULL),
('Candlewood Suites', 106, '2019-06-11', 148, NULL),
('Candlewood Suites', 106, '2019-06-12', 134, NULL),
('Candlewood Suites', 106, '2019-06-13', 201, NULL),
('Candlewood Suites', 106, '2019-06-14', 123, NULL),
('Candlewood Suites', 106, '2019-06-15', 162, NULL),
('Candlewood Suites', 106, '2019-06-16', 295, NULL),
('Candlewood Suites', 106, '2019-06-17', 361, NULL),
('Candlewood Suites', 106, '2019-06-18', 398, NULL),
('Candlewood Suites', 106, '2019-06-19', 353, NULL),
('Candlewood Suites', 106, '2019-06-20', 188, NULL),
('Candlewood Suites', 106, '2019-06-21', 357, NULL),
('Candlewood Suites', 106, '2019-06-22', 336, NULL),
('Candlewood Suites', 106, '2019-06-23', 205, NULL),
('Candlewood Suites', 106, '2019-06-24', 191, NULL),
('Candlewood Suites', 106, '2019-06-25', 235, NULL),
('Candlewood Suites', 106, '2019-06-26', 252, NULL),
('Candlewood Suites', 106, '2019-06-27', 303, NULL),
('Candlewood Suites', 106, '2019-06-28', 219, NULL),
('Candlewood Suites', 106, '2019-06-29', 341, NULL),
('Candlewood Suites', 106, '2019-06-30', 243, NULL),
('Candlewood Suites', 106, '2019-07-01', 178, NULL),
('Candlewood Suites', 106, '2019-07-02', 181, NULL),
('Candlewood Suites', 106, '2019-07-03', 154, NULL),
('Candlewood Suites', 106, '2019-07-04', 105, NULL),
('Candlewood Suites', 106, '2019-07-05', 220, NULL),
('Candlewood Suites', 106, '2019-07-06', 181, NULL),
('Candlewood Suites', 106, '2019-07-07', 258, NULL),
('Candlewood Suites', 106, '2019-07-08', 345, NULL),
('Candlewood Suites', 106, '2019-07-09', 207, NULL),
('Candlewood Suites', 106, '2019-07-10', 365, NULL),
('Candlewood Suites', 106, '2019-07-11', 181, NULL),
('Candlewood Suites', 106, '2019-07-12', 189, NULL),
('Candlewood Suites', 106, '2019-07-13', 102, NULL),
('Candlewood Suites', 106, '2019-07-14', 320, NULL),
('Candlewood Suites', 106, '2019-07-15', 316, NULL),
('Candlewood Suites', 106, '2019-07-16', 211, NULL),
('Candlewood Suites', 106, '2019-07-17', 145, NULL),
('Candlewood Suites', 106, '2019-07-18', 105, NULL),
('Candlewood Suites', 106, '2019-07-19', 269, NULL),
('Candlewood Suites', 106, '2019-07-20', 142, NULL),
('Candlewood Suites', 106, '2019-07-21', 373, NULL),
('Candlewood Suites', 106, '2019-07-22', 140, NULL),
('Candlewood Suites', 106, '2019-07-23', 250, NULL),
('Candlewood Suites', 106, '2019-07-24', 250, NULL),
('Candlewood Suites', 106, '2019-07-25', 163, NULL),
('Candlewood Suites', 106, '2019-07-26', 354, NULL),
('Candlewood Suites', 106, '2019-07-27', 291, NULL),
('Candlewood Suites', 106, '2019-07-28', 379, NULL),
('Candlewood Suites', 106, '2019-07-29', 360, NULL),
('Candlewood Suites', 106, '2019-07-30', 236, NULL),
('Candlewood Suites', 106, '2019-07-31', 278, NULL),
('Candlewood Suites', 106, '2019-08-01', 186, NULL),
('Candlewood Suites', 106, '2019-08-02', 252, NULL),
('Candlewood Suites', 106, '2019-08-03', 346, NULL),
('Candlewood Suites', 106, '2019-08-04', 170, NULL),
('Candlewood Suites', 106, '2019-08-05', 156, NULL),
('Candlewood Suites', 106, '2019-08-06', 122, NULL),
('Candlewood Suites', 106, '2019-08-07', 300, NULL),
('Candlewood Suites', 106, '2019-08-08', 386, NULL),
('Candlewood Suites', 106, '2019-08-09', 232, NULL),
('Candlewood Suites', 106, '2019-08-10', 330, NULL),
('Candlewood Suites', 106, '2019-08-11', 300, NULL),
('Candlewood Suites', 106, '2019-08-12', 184, NULL),
('Candlewood Suites', 106, '2019-08-13', 359, NULL),
('Candlewood Suites', 106, '2019-08-14', 308, NULL),
('Candlewood Suites', 106, '2019-08-15', 136, NULL),
('Candlewood Suites', 106, '2019-08-16', 216, NULL),
('Candlewood Suites', 106, '2019-08-17', 202, NULL),
('Candlewood Suites', 106, '2019-08-18', 224, NULL),
('Candlewood Suites', 106, '2019-08-19', 169, NULL),
('Candlewood Suites', 106, '2019-08-20', 112, NULL),
('Candlewood Suites', 106, '2019-08-21', 292, NULL),
('Candlewood Suites', 106, '2019-08-22', 335, NULL),
('Candlewood Suites', 106, '2019-08-23', 394, NULL),
('Candlewood Suites', 106, '2019-08-24', 137, NULL),
('Candlewood Suites', 106, '2019-08-25', 131, NULL),
('Candlewood Suites', 106, '2019-08-26', 270, NULL),
('Candlewood Suites', 106, '2019-08-27', 304, NULL),
('Candlewood Suites', 106, '2019-08-28', 396, NULL),
('Candlewood Suites', 106, '2019-08-29', 311, NULL),
('Candlewood Suites', 106, '2019-08-30', 121, NULL),
('Candlewood Suites', 106, '2019-08-31', 365, NULL),
('Candlewood Suites', 106, '2019-09-01', 147, NULL),
('Candlewood Suites', 106, '2019-09-02', 319, NULL),
('Candlewood Suites', 106, '2019-09-03', 111, NULL),
('Candlewood Suites', 106, '2019-09-04', 268, NULL),
('Candlewood Suites', 106, '2019-09-05', 119, NULL),
('Candlewood Suites', 106, '2019-09-06', 236, NULL),
('Candlewood Suites', 106, '2019-09-07', 136, NULL),
('Candlewood Suites', 106, '2019-09-08', 376, NULL),
('Candlewood Suites', 106, '2019-09-09', 222, NULL),
('Candlewood Suites', 106, '2019-09-10', 182, NULL),
('Candlewood Suites', 106, '2019-09-11', 115, NULL),
('Candlewood Suites', 106, '2019-09-12', 118, NULL),
('Candlewood Suites', 106, '2019-09-13', 113, NULL),
('Candlewood Suites', 106, '2019-09-14', 297, NULL),
('Candlewood Suites', 106, '2019-09-15', 196, NULL),
('Candlewood Suites', 106, '2019-09-16', 342, NULL),
('Candlewood Suites', 106, '2019-09-17', 352, NULL),
('Candlewood Suites', 106, '2019-09-18', 185, NULL),
('Candlewood Suites', 106, '2019-09-19', 254, NULL),
('Candlewood Suites', 106, '2019-09-20', 227, NULL),
('Candlewood Suites', 106, '2019-09-21', 384, NULL),
('Candlewood Suites', 106, '2019-09-22', 296, NULL),
('Candlewood Suites', 106, '2019-09-23', 216, NULL),
('Candlewood Suites', 106, '2019-09-24', 102, NULL),
('Candlewood Suites', 106, '2019-09-25', 211, NULL),
('Candlewood Suites', 106, '2019-09-26', 378, NULL),
('Candlewood Suites', 106, '2019-09-27', 304, NULL),
('Candlewood Suites', 106, '2019-09-28', 355, NULL),
('Candlewood Suites', 106, '2019-09-29', 274, NULL),
('Candlewood Suites', 106, '2019-09-30', 262, NULL),
('Candlewood Suites', 106, '2019-10-01', 393, NULL),
('Candlewood Suites', 106, '2019-10-02', 355, NULL),
('Candlewood Suites', 106, '2019-10-03', 259, NULL),
('Candlewood Suites', 106, '2019-10-04', 114, NULL),
('Candlewood Suites', 106, '2019-10-05', 378, NULL),
('Candlewood Suites', 106, '2019-10-06', 120, NULL),
('Candlewood Suites', 106, '2019-10-07', 315, NULL),
('Candlewood Suites', 106, '2019-10-08', 102, NULL),
('Candlewood Suites', 106, '2019-10-09', 342, NULL),
('Candlewood Suites', 106, '2019-10-10', 197, NULL),
('Candlewood Suites', 106, '2019-10-11', 350, NULL),
('Candlewood Suites', 106, '2019-10-12', 264, NULL),
('Candlewood Suites', 106, '2019-10-13', 391, NULL),
('Candlewood Suites', 106, '2019-10-14', 206, NULL),
('Candlewood Suites', 106, '2019-10-15', 113, NULL),
('Candlewood Suites', 106, '2019-10-16', 155, NULL),
('Candlewood Suites', 106, '2019-10-17', 310, NULL),
('Candlewood Suites', 106, '2019-10-18', 281, NULL),
('Candlewood Suites', 106, '2019-10-19', 299, NULL),
('Candlewood Suites', 106, '2019-10-20', 394, NULL),
('Candlewood Suites', 106, '2019-10-21', 391, NULL),
('Candlewood Suites', 106, '2019-10-22', 214, NULL),
('Candlewood Suites', 106, '2019-10-23', 129, NULL),
('Candlewood Suites', 106, '2019-10-24', 195, NULL),
('Candlewood Suites', 106, '2019-10-25', 367, NULL),
('Candlewood Suites', 106, '2019-10-26', 140, NULL),
('Candlewood Suites', 106, '2019-10-27', 164, NULL),
('Candlewood Suites', 106, '2019-10-28', 154, NULL),
('Candlewood Suites', 106, '2019-10-29', 334, NULL),
('Candlewood Suites', 106, '2019-10-30', 278, NULL),
('Candlewood Suites', 106, '2019-10-31', 158, NULL),
('Candlewood Suites', 106, '2019-11-01', 147, NULL),
('Candlewood Suites', 106, '2019-11-02', 209, NULL),
('Candlewood Suites', 106, '2019-11-03', 158, NULL),
('Candlewood Suites', 106, '2019-11-04', 255, NULL),
('Candlewood Suites', 106, '2019-11-05', 325, NULL),
('Candlewood Suites', 106, '2019-11-06', 336, NULL),
('Candlewood Suites', 106, '2019-11-07', 175, NULL),
('Candlewood Suites', 106, '2019-11-08', 181, NULL),
('Candlewood Suites', 106, '2019-11-09', 218, NULL),
('Candlewood Suites', 106, '2019-11-10', 166, NULL),
('Candlewood Suites', 106, '2019-11-11', 125, NULL),
('Candlewood Suites', 106, '2019-11-12', 168, NULL),
('Candlewood Suites', 106, '2019-11-13', 343, NULL),
('Candlewood Suites', 106, '2019-11-14', 342, NULL),
('Candlewood Suites', 106, '2019-11-15', 164, NULL),
('Candlewood Suites', 106, '2019-11-16', 211, NULL),
('Candlewood Suites', 106, '2019-11-17', 394, NULL),
('Candlewood Suites', 106, '2019-11-18', 284, NULL),
('Candlewood Suites', 106, '2019-11-19', 243, NULL),
('Candlewood Suites', 106, '2019-11-20', 275, NULL),
('Candlewood Suites', 106, '2019-11-21', 126, NULL),
('Candlewood Suites', 106, '2019-11-22', 172, NULL),
('Candlewood Suites', 106, '2019-11-23', 266, NULL),
('Candlewood Suites', 106, '2019-11-24', 284, NULL),
('Candlewood Suites', 106, '2019-11-25', 261, NULL),
('Candlewood Suites', 106, '2019-11-26', 398, NULL),
('Candlewood Suites', 106, '2019-11-27', 362, NULL),
('Candlewood Suites', 106, '2019-11-28', 351, NULL),
('Candlewood Suites', 106, '2019-11-29', 122, NULL),
('Candlewood Suites', 106, '2019-11-30', 147, NULL),
('Candlewood Suites', 106, '2019-12-01', 186, NULL),
('Candlewood Suites', 106, '2019-12-02', 189, NULL),
('Candlewood Suites', 106, '2019-12-03', 398, NULL),
('Candlewood Suites', 106, '2019-12-04', 381, NULL),
('Candlewood Suites', 106, '2019-12-05', 324, NULL),
('Candlewood Suites', 106, '2019-12-06', 266, NULL),
('Candlewood Suites', 106, '2019-12-07', 327, NULL),
('Candlewood Suites', 106, '2019-12-08', 144, NULL),
('Candlewood Suites', 106, '2019-12-09', 375, NULL),
('Candlewood Suites', 106, '2019-12-10', 168, NULL),
('Candlewood Suites', 106, '2019-12-11', 100, NULL),
('Candlewood Suites', 106, '2019-12-12', 368, NULL),
('Candlewood Suites', 106, '2019-12-13', 269, NULL),
('Candlewood Suites', 106, '2019-12-14', 356, NULL),
('Candlewood Suites', 106, '2019-12-15', 386, NULL),
('Candlewood Suites', 106, '2019-12-16', 243, NULL),
('Candlewood Suites', 106, '2019-12-17', 347, NULL),
('Candlewood Suites', 106, '2019-12-18', 182, NULL),
('Candlewood Suites', 106, '2019-12-19', 354, NULL),
('Candlewood Suites', 106, '2019-12-20', 344, NULL),
('Candlewood Suites', 106, '2019-12-21', 268, NULL),
('Candlewood Suites', 106, '2019-12-22', 399, NULL),
('Candlewood Suites', 106, '2019-12-23', 198, NULL),
('Candlewood Suites', 106, '2019-12-24', 365, NULL),
('Candlewood Suites', 106, '2019-12-25', 296, NULL),
('Candlewood Suites', 106, '2019-12-26', 256, NULL),
('Candlewood Suites', 106, '2019-12-27', 100, NULL),
('Candlewood Suites', 106, '2019-12-28', 185, NULL),
('Candlewood Suites', 106, '2019-12-29', 182, NULL),
('Candlewood Suites', 106, '2019-12-30', 238, NULL),
('Candlewood Suites', 106, '2019-12-31', 270, NULL),
('Candlewood Suites', 106, '2020-01-01', 346, NULL),
('Candlewood Suites', 106, '2020-01-02', 160, NULL),
('Candlewood Suites', 106, '2020-01-03', 190, NULL),
('Candlewood Suites', 106, '2020-01-04', 343, NULL),
('Candlewood Suites', 106, '2020-01-05', 319, NULL),
('Candlewood Suites', 106, '2020-01-06', 183, NULL),
('Candlewood Suites', 106, '2020-01-07', 249, NULL),
('Candlewood Suites', 106, '2020-01-08', 274, NULL),
('Candlewood Suites', 106, '2020-01-09', 263, NULL),
('Candlewood Suites', 106, '2020-01-10', 110, NULL),
('Candlewood Suites', 106, '2020-01-11', 151, NULL),
('Candlewood Suites', 106, '2020-01-12', 205, NULL),
('Candlewood Suites', 106, '2020-01-13', 291, NULL),
('Candlewood Suites', 106, '2020-01-14', 364, NULL),
('Candlewood Suites', 106, '2020-01-15', 269, NULL),
('Candlewood Suites', 106, '2020-01-16', 225, NULL),
('Candlewood Suites', 106, '2020-01-17', 213, NULL),
('Candlewood Suites', 106, '2020-01-18', 239, NULL),
('Candlewood Suites', 106, '2020-01-19', 253, NULL),
('Candlewood Suites', 106, '2020-01-20', 309, NULL),
('Candlewood Suites', 106, '2020-01-21', 121, NULL),
('Candlewood Suites', 106, '2020-01-22', 263, NULL),
('Candlewood Suites', 106, '2020-01-23', 312, NULL),
('Candlewood Suites', 106, '2020-01-24', 330, NULL),
('Candlewood Suites', 106, '2020-01-25', 238, NULL),
('Candlewood Suites', 106, '2020-01-26', 223, NULL),
('Candlewood Suites', 106, '2020-01-27', 380, NULL),
('Candlewood Suites', 106, '2020-01-28', 147, NULL),
('Candlewood Suites', 106, '2020-01-29', 191, NULL),
('Candlewood Suites', 106, '2020-01-30', 116, NULL),
('Candlewood Suites', 106, '2020-01-31', 365, NULL),
('Candlewood Suites', 106, '2020-02-01', 135, NULL),
('Candlewood Suites', 106, '2020-02-02', 130, NULL),
('Candlewood Suites', 106, '2020-02-03', 383, NULL),
('Candlewood Suites', 106, '2020-02-04', 333, NULL),
('Candlewood Suites', 108, '2019-01-01', 112, NULL),
('Candlewood Suites', 108, '2019-01-02', 108, NULL),
('Candlewood Suites', 108, '2019-01-03', 376, NULL),
('Candlewood Suites', 108, '2019-01-04', 325, NULL),
('Candlewood Suites', 108, '2019-01-05', 263, NULL),
('Candlewood Suites', 108, '2019-01-06', 131, NULL),
('Candlewood Suites', 108, '2019-01-07', 240, NULL),
('Candlewood Suites', 108, '2019-01-08', 102, NULL),
('Candlewood Suites', 108, '2019-01-09', 230, NULL),
('Candlewood Suites', 108, '2019-01-10', 313, NULL),
('Candlewood Suites', 108, '2019-01-11', 206, NULL),
('Candlewood Suites', 108, '2019-01-12', 179, NULL),
('Candlewood Suites', 108, '2019-01-13', 385, NULL),
('Candlewood Suites', 108, '2019-01-14', 150, NULL),
('Candlewood Suites', 108, '2019-01-15', 294, NULL),
('Candlewood Suites', 108, '2019-01-16', 361, NULL),
('Candlewood Suites', 108, '2019-01-17', 264, NULL),
('Candlewood Suites', 108, '2019-01-18', 231, NULL),
('Candlewood Suites', 108, '2019-01-19', 167, NULL),
('Candlewood Suites', 108, '2019-01-20', 153, NULL),
('Candlewood Suites', 108, '2019-01-21', 229, NULL),
('Candlewood Suites', 108, '2019-01-22', 215, NULL),
('Candlewood Suites', 108, '2019-01-23', 105, NULL),
('Candlewood Suites', 108, '2019-01-24', 397, NULL),
('Candlewood Suites', 108, '2019-01-25', 302, NULL),
('Candlewood Suites', 108, '2019-01-26', 341, NULL),
('Candlewood Suites', 108, '2019-01-27', 291, NULL),
('Candlewood Suites', 108, '2019-01-28', 137, NULL),
('Candlewood Suites', 108, '2019-01-29', 328, NULL),
('Candlewood Suites', 108, '2019-01-30', 212, NULL),
('Candlewood Suites', 108, '2019-01-31', 333, NULL),
('Candlewood Suites', 108, '2019-02-01', 195, NULL),
('Candlewood Suites', 108, '2019-02-02', 343, NULL),
('Candlewood Suites', 108, '2019-02-03', 176, NULL),
('Candlewood Suites', 108, '2019-02-04', 341, NULL),
('Candlewood Suites', 108, '2019-02-05', 108, NULL),
('Candlewood Suites', 108, '2019-02-06', 115, NULL),
('Candlewood Suites', 108, '2019-02-07', 324, NULL),
('Candlewood Suites', 108, '2019-02-08', 111, NULL),
('Candlewood Suites', 108, '2019-02-09', 374, NULL),
('Candlewood Suites', 108, '2019-02-10', 130, NULL),
('Candlewood Suites', 108, '2019-02-11', 330, NULL),
('Candlewood Suites', 108, '2019-02-12', 139, NULL),
('Candlewood Suites', 108, '2019-02-13', 112, NULL),
('Candlewood Suites', 108, '2019-02-14', 396, NULL),
('Candlewood Suites', 108, '2019-02-15', 375, NULL),
('Candlewood Suites', 108, '2019-02-16', 197, NULL),
('Candlewood Suites', 108, '2019-02-17', 286, NULL),
('Candlewood Suites', 108, '2019-02-18', 157, NULL),
('Candlewood Suites', 108, '2019-02-19', 236, NULL),
('Candlewood Suites', 108, '2019-02-20', 315, NULL),
('Candlewood Suites', 108, '2019-02-21', 155, NULL),
('Candlewood Suites', 108, '2019-02-22', 345, NULL),
('Candlewood Suites', 108, '2019-02-23', 272, NULL),
('Candlewood Suites', 108, '2019-02-24', 197, NULL),
('Candlewood Suites', 108, '2019-02-25', 133, NULL),
('Candlewood Suites', 108, '2019-02-26', 343, NULL),
('Candlewood Suites', 108, '2019-02-27', 351, NULL),
('Candlewood Suites', 108, '2019-02-28', 264, NULL),
('Candlewood Suites', 108, '2019-03-01', 127, NULL),
('Candlewood Suites', 108, '2019-03-02', 174, NULL),
('Candlewood Suites', 108, '2019-03-03', 199, NULL),
('Candlewood Suites', 108, '2019-03-04', 285, NULL),
('Candlewood Suites', 108, '2019-03-05', 209, NULL),
('Candlewood Suites', 108, '2019-03-06', 366, NULL),
('Candlewood Suites', 108, '2019-03-07', 393, NULL),
('Candlewood Suites', 108, '2019-03-08', 233, NULL),
('Candlewood Suites', 108, '2019-03-09', 369, NULL),
('Candlewood Suites', 108, '2019-03-10', 199, NULL),
('Candlewood Suites', 108, '2019-03-11', 253, NULL),
('Candlewood Suites', 108, '2019-03-12', 199, NULL),
('Candlewood Suites', 108, '2019-03-13', 368, NULL),
('Candlewood Suites', 108, '2019-03-14', 340, NULL),
('Candlewood Suites', 108, '2019-03-15', 277, NULL),
('Candlewood Suites', 108, '2019-03-16', 324, NULL),
('Candlewood Suites', 108, '2019-03-17', 168, NULL),
('Candlewood Suites', 108, '2019-03-18', 263, NULL),
('Candlewood Suites', 108, '2019-03-19', 162, NULL),
('Candlewood Suites', 108, '2019-03-20', 209, NULL),
('Candlewood Suites', 108, '2019-03-21', 221, NULL),
('Candlewood Suites', 108, '2019-03-22', 259, NULL),
('Candlewood Suites', 108, '2019-03-23', 129, NULL),
('Candlewood Suites', 108, '2019-03-24', 202, NULL),
('Candlewood Suites', 108, '2019-03-25', 188, NULL),
('Candlewood Suites', 108, '2019-03-26', 155, NULL),
('Candlewood Suites', 108, '2019-03-27', 337, NULL),
('Candlewood Suites', 108, '2019-03-28', 342, NULL),
('Candlewood Suites', 108, '2019-03-29', 271, NULL),
('Candlewood Suites', 108, '2019-03-30', 344, NULL),
('Candlewood Suites', 108, '2019-03-31', 134, NULL),
('Candlewood Suites', 108, '2019-04-01', 299, NULL),
('Candlewood Suites', 108, '2019-04-02', 212, NULL),
('Candlewood Suites', 108, '2019-04-03', 370, NULL),
('Candlewood Suites', 108, '2019-04-04', 238, NULL),
('Candlewood Suites', 108, '2019-04-05', 365, NULL),
('Candlewood Suites', 108, '2019-04-06', 340, NULL),
('Candlewood Suites', 108, '2019-04-07', 179, NULL),
('Candlewood Suites', 108, '2019-04-08', 366, NULL),
('Candlewood Suites', 108, '2019-04-09', 314, NULL),
('Candlewood Suites', 108, '2019-04-10', 377, NULL),
('Candlewood Suites', 108, '2019-04-11', 139, NULL),
('Candlewood Suites', 108, '2019-04-12', 335, NULL),
('Candlewood Suites', 108, '2019-04-13', 112, NULL),
('Candlewood Suites', 108, '2019-04-14', 253, NULL),
('Candlewood Suites', 108, '2019-04-15', 274, NULL),
('Candlewood Suites', 108, '2019-04-16', 274, NULL),
('Candlewood Suites', 108, '2019-04-17', 197, NULL),
('Candlewood Suites', 108, '2019-04-18', 248, NULL),
('Candlewood Suites', 108, '2019-04-19', 323, NULL),
('Candlewood Suites', 108, '2019-04-20', 398, NULL),
('Candlewood Suites', 108, '2019-04-21', 261, NULL),
('Candlewood Suites', 108, '2019-04-22', 242, NULL),
('Candlewood Suites', 108, '2019-04-23', 399, NULL),
('Candlewood Suites', 108, '2019-04-24', 182, NULL),
('Candlewood Suites', 108, '2019-04-25', 307, NULL),
('Candlewood Suites', 108, '2019-04-26', 132, NULL),
('Candlewood Suites', 108, '2019-04-27', 319, NULL),
('Candlewood Suites', 108, '2019-04-28', 160, NULL),
('Candlewood Suites', 108, '2019-04-29', 233, NULL),
('Candlewood Suites', 108, '2019-04-30', 269, NULL),
('Candlewood Suites', 108, '2019-05-01', 396, NULL),
('Candlewood Suites', 108, '2019-05-02', 291, NULL),
('Candlewood Suites', 108, '2019-05-03', 373, NULL),
('Candlewood Suites', 108, '2019-05-04', 391, NULL),
('Candlewood Suites', 108, '2019-05-05', 335, NULL),
('Candlewood Suites', 108, '2019-05-06', 361, NULL),
('Candlewood Suites', 108, '2019-05-07', 266, NULL),
('Candlewood Suites', 108, '2019-05-08', 389, NULL),
('Candlewood Suites', 108, '2019-05-09', 152, NULL),
('Candlewood Suites', 108, '2019-05-10', 389, NULL),
('Candlewood Suites', 108, '2019-05-11', 124, NULL),
('Candlewood Suites', 108, '2019-05-12', 150, NULL),
('Candlewood Suites', 108, '2019-05-13', 351, NULL),
('Candlewood Suites', 108, '2019-05-14', 307, NULL),
('Candlewood Suites', 108, '2019-05-15', 303, NULL),
('Candlewood Suites', 108, '2019-05-16', 114, NULL),
('Candlewood Suites', 108, '2019-05-17', 212, NULL),
('Candlewood Suites', 108, '2019-05-18', 164, NULL),
('Candlewood Suites', 108, '2019-05-19', 174, NULL),
('Candlewood Suites', 108, '2019-05-20', 291, NULL),
('Candlewood Suites', 108, '2019-05-21', 366, NULL),
('Candlewood Suites', 108, '2019-05-22', 205, NULL),
('Candlewood Suites', 108, '2019-05-23', 226, NULL),
('Candlewood Suites', 108, '2019-05-24', 274, NULL),
('Candlewood Suites', 108, '2019-05-25', 100, NULL),
('Candlewood Suites', 108, '2019-05-26', 249, NULL),
('Candlewood Suites', 108, '2019-05-27', 126, NULL),
('Candlewood Suites', 108, '2019-05-28', 393, NULL),
('Candlewood Suites', 108, '2019-05-29', 103, NULL),
('Candlewood Suites', 108, '2019-05-30', 100, NULL),
('Candlewood Suites', 108, '2019-05-31', 394, NULL),
('Candlewood Suites', 108, '2019-06-01', 112, NULL),
('Candlewood Suites', 108, '2019-06-02', 100, NULL),
('Candlewood Suites', 108, '2019-06-03', 372, NULL),
('Candlewood Suites', 108, '2019-06-04', 148, NULL),
('Candlewood Suites', 108, '2019-06-05', 157, NULL),
('Candlewood Suites', 108, '2019-06-06', 398, NULL),
('Candlewood Suites', 108, '2019-06-07', 313, NULL),
('Candlewood Suites', 108, '2019-06-08', 137, NULL),
('Candlewood Suites', 108, '2019-06-09', 115, NULL),
('Candlewood Suites', 108, '2019-06-10', 151, NULL),
('Candlewood Suites', 108, '2019-06-11', 183, NULL),
('Candlewood Suites', 108, '2019-06-12', 347, NULL),
('Candlewood Suites', 108, '2019-06-13', 179, NULL),
('Candlewood Suites', 108, '2019-06-14', 193, NULL),
('Candlewood Suites', 108, '2019-06-15', 270, NULL),
('Candlewood Suites', 108, '2019-06-16', 115, NULL),
('Candlewood Suites', 108, '2019-06-17', 352, NULL),
('Candlewood Suites', 108, '2019-06-18', 239, NULL),
('Candlewood Suites', 108, '2019-06-19', 274, NULL),
('Candlewood Suites', 108, '2019-06-20', 399, NULL),
('Candlewood Suites', 108, '2019-06-21', 187, NULL),
('Candlewood Suites', 108, '2019-06-22', 238, NULL),
('Candlewood Suites', 108, '2019-06-23', 311, NULL),
('Candlewood Suites', 108, '2019-06-24', 325, NULL),
('Candlewood Suites', 108, '2019-06-25', 356, NULL),
('Candlewood Suites', 108, '2019-06-26', 256, NULL),
('Candlewood Suites', 108, '2019-06-27', 218, NULL),
('Candlewood Suites', 108, '2019-06-28', 120, NULL),
('Candlewood Suites', 108, '2019-06-29', 214, NULL),
('Candlewood Suites', 108, '2019-06-30', 189, NULL),
('Candlewood Suites', 108, '2019-07-01', 168, NULL),
('Candlewood Suites', 108, '2019-07-02', 128, NULL),
('Candlewood Suites', 108, '2019-07-03', 226, NULL),
('Candlewood Suites', 108, '2019-07-04', 372, NULL),
('Candlewood Suites', 108, '2019-07-05', 373, NULL),
('Candlewood Suites', 108, '2019-07-06', 285, NULL),
('Candlewood Suites', 108, '2019-07-07', 194, NULL),
('Candlewood Suites', 108, '2019-07-08', 322, NULL),
('Candlewood Suites', 108, '2019-07-09', 323, NULL),
('Candlewood Suites', 108, '2019-07-10', 363, NULL),
('Candlewood Suites', 108, '2019-07-11', 134, NULL),
('Candlewood Suites', 108, '2019-07-12', 207, NULL),
('Candlewood Suites', 108, '2019-07-13', 167, NULL),
('Candlewood Suites', 108, '2019-07-14', 298, NULL),
('Candlewood Suites', 108, '2019-07-15', 149, NULL),
('Candlewood Suites', 108, '2019-07-16', 374, NULL),
('Candlewood Suites', 108, '2019-07-17', 157, NULL),
('Candlewood Suites', 108, '2019-07-18', 236, NULL),
('Candlewood Suites', 108, '2019-07-19', 146, NULL),
('Candlewood Suites', 108, '2019-07-20', 224, NULL),
('Candlewood Suites', 108, '2019-07-21', 181, NULL),
('Candlewood Suites', 108, '2019-07-22', 272, NULL),
('Candlewood Suites', 108, '2019-07-23', 217, NULL),
('Candlewood Suites', 108, '2019-07-24', 374, NULL),
('Candlewood Suites', 108, '2019-07-25', 258, NULL),
('Candlewood Suites', 108, '2019-07-26', 189, NULL),
('Candlewood Suites', 108, '2019-07-27', 164, NULL),
('Candlewood Suites', 108, '2019-07-28', 216, NULL),
('Candlewood Suites', 108, '2019-07-29', 366, NULL),
('Candlewood Suites', 108, '2019-07-30', 123, NULL),
('Candlewood Suites', 108, '2019-07-31', 172, NULL),
('Candlewood Suites', 108, '2019-08-01', 208, NULL),
('Candlewood Suites', 108, '2019-08-02', 149, NULL),
('Candlewood Suites', 108, '2019-08-03', 355, NULL),
('Candlewood Suites', 108, '2019-08-04', 328, NULL),
('Candlewood Suites', 108, '2019-08-05', 232, NULL),
('Candlewood Suites', 108, '2019-08-06', 284, NULL),
('Candlewood Suites', 108, '2019-08-07', 240, NULL),
('Candlewood Suites', 108, '2019-08-08', 285, NULL),
('Candlewood Suites', 108, '2019-08-09', 368, NULL),
('Candlewood Suites', 108, '2019-08-10', 312, NULL),
('Candlewood Suites', 108, '2019-08-11', 135, NULL),
('Candlewood Suites', 108, '2019-08-12', 120, NULL),
('Candlewood Suites', 108, '2019-08-13', 307, NULL),
('Candlewood Suites', 108, '2019-08-14', 141, NULL),
('Candlewood Suites', 108, '2019-08-15', 261, NULL),
('Candlewood Suites', 108, '2019-08-16', 394, NULL),
('Candlewood Suites', 108, '2019-08-17', 384, NULL),
('Candlewood Suites', 108, '2019-08-18', 124, NULL),
('Candlewood Suites', 108, '2019-08-19', 325, NULL),
('Candlewood Suites', 108, '2019-08-20', 235, NULL),
('Candlewood Suites', 108, '2019-08-21', 156, NULL),
('Candlewood Suites', 108, '2019-08-22', 144, NULL),
('Candlewood Suites', 108, '2019-08-23', 304, NULL),
('Candlewood Suites', 108, '2019-08-24', 315, NULL),
('Candlewood Suites', 108, '2019-08-25', 242, NULL),
('Candlewood Suites', 108, '2019-08-26', 157, NULL),
('Candlewood Suites', 108, '2019-08-27', 354, NULL),
('Candlewood Suites', 108, '2019-08-28', 377, NULL),
('Candlewood Suites', 108, '2019-08-29', 132, NULL),
('Candlewood Suites', 108, '2019-08-30', 337, NULL),
('Candlewood Suites', 108, '2019-08-31', 239, NULL),
('Candlewood Suites', 108, '2019-09-01', 192, NULL),
('Candlewood Suites', 108, '2019-09-02', 256, NULL),
('Candlewood Suites', 108, '2019-09-03', 258, NULL),
('Candlewood Suites', 108, '2019-09-04', 295, NULL),
('Candlewood Suites', 108, '2019-09-05', 193, NULL),
('Candlewood Suites', 108, '2019-09-06', 257, NULL),
('Candlewood Suites', 108, '2019-09-07', 322, NULL),
('Candlewood Suites', 108, '2019-09-08', 105, NULL),
('Candlewood Suites', 108, '2019-09-09', 309, NULL),
('Candlewood Suites', 108, '2019-09-10', 392, NULL),
('Candlewood Suites', 108, '2019-09-11', 350, NULL),
('Candlewood Suites', 108, '2019-09-12', 167, NULL),
('Candlewood Suites', 108, '2019-09-13', 382, NULL),
('Candlewood Suites', 108, '2019-09-14', 133, NULL),
('Candlewood Suites', 108, '2019-09-15', 300, NULL),
('Candlewood Suites', 108, '2019-09-16', 195, NULL),
('Candlewood Suites', 108, '2019-09-17', 147, NULL),
('Candlewood Suites', 108, '2019-09-18', 273, NULL),
('Candlewood Suites', 108, '2019-09-19', 389, NULL),
('Candlewood Suites', 108, '2019-09-20', 124, NULL),
('Candlewood Suites', 108, '2019-09-21', 171, NULL),
('Candlewood Suites', 108, '2019-09-22', 316, NULL),
('Candlewood Suites', 108, '2019-09-23', 283, NULL),
('Candlewood Suites', 108, '2019-09-24', 381, NULL),
('Candlewood Suites', 108, '2019-09-25', 241, NULL),
('Candlewood Suites', 108, '2019-09-26', 270, NULL),
('Candlewood Suites', 108, '2019-09-27', 203, NULL),
('Candlewood Suites', 108, '2019-09-28', 298, NULL),
('Candlewood Suites', 108, '2019-09-29', 109, NULL),
('Candlewood Suites', 108, '2019-09-30', 232, NULL),
('Candlewood Suites', 108, '2019-10-01', 370, NULL),
('Candlewood Suites', 108, '2019-10-02', 126, NULL),
('Candlewood Suites', 108, '2019-10-03', 168, NULL),
('Candlewood Suites', 108, '2019-10-04', 303, NULL),
('Candlewood Suites', 108, '2019-10-05', 172, NULL),
('Candlewood Suites', 108, '2019-10-06', 147, NULL),
('Candlewood Suites', 108, '2019-10-07', 300, NULL),
('Candlewood Suites', 108, '2019-10-08', 347, NULL),
('Candlewood Suites', 108, '2019-10-09', 148, NULL),
('Candlewood Suites', 108, '2019-10-10', 206, NULL),
('Candlewood Suites', 108, '2019-10-11', 142, NULL),
('Candlewood Suites', 108, '2019-10-12', 347, NULL),
('Candlewood Suites', 108, '2019-10-13', 244, NULL),
('Candlewood Suites', 108, '2019-10-14', 312, NULL),
('Candlewood Suites', 108, '2019-10-15', 266, NULL),
('Candlewood Suites', 108, '2019-10-16', 386, NULL),
('Candlewood Suites', 108, '2019-10-17', 224, NULL),
('Candlewood Suites', 108, '2019-10-18', 274, NULL),
('Candlewood Suites', 108, '2019-10-19', 293, NULL),
('Candlewood Suites', 108, '2019-10-20', 321, NULL),
('Candlewood Suites', 108, '2019-10-21', 383, NULL),
('Candlewood Suites', 108, '2019-10-22', 103, NULL),
('Candlewood Suites', 108, '2019-10-23', 226, NULL),
('Candlewood Suites', 108, '2019-10-24', 187, NULL),
('Candlewood Suites', 108, '2019-10-25', 360, NULL),
('Candlewood Suites', 108, '2019-10-26', 360, NULL),
('Candlewood Suites', 108, '2019-10-27', 274, NULL),
('Candlewood Suites', 108, '2019-10-28', 224, NULL),
('Candlewood Suites', 108, '2019-10-29', 249, NULL),
('Candlewood Suites', 108, '2019-10-30', 101, NULL),
('Candlewood Suites', 108, '2019-10-31', 136, NULL),
('Candlewood Suites', 108, '2019-11-01', 309, NULL),
('Candlewood Suites', 108, '2019-11-02', 158, NULL),
('Candlewood Suites', 108, '2019-11-03', 205, NULL),
('Candlewood Suites', 108, '2019-11-04', 316, NULL),
('Candlewood Suites', 108, '2019-11-05', 386, NULL),
('Candlewood Suites', 108, '2019-11-06', 123, NULL),
('Candlewood Suites', 108, '2019-11-07', 333, NULL),
('Candlewood Suites', 108, '2019-11-08', 296, NULL),
('Candlewood Suites', 108, '2019-11-09', 199, NULL),
('Candlewood Suites', 108, '2019-11-10', 174, NULL),
('Candlewood Suites', 108, '2019-11-11', 194, NULL),
('Candlewood Suites', 108, '2019-11-12', 112, NULL),
('Candlewood Suites', 108, '2019-11-13', 358, NULL),
('Candlewood Suites', 108, '2019-11-14', 276, NULL),
('Candlewood Suites', 108, '2019-11-15', 162, NULL),
('Candlewood Suites', 108, '2019-11-16', 345, NULL),
('Candlewood Suites', 108, '2019-11-17', 155, NULL),
('Candlewood Suites', 108, '2019-11-18', 125, NULL),
('Candlewood Suites', 108, '2019-11-19', 398, NULL),
('Candlewood Suites', 108, '2019-11-20', 126, NULL),
('Candlewood Suites', 108, '2019-11-21', 109, NULL),
('Candlewood Suites', 108, '2019-11-22', 153, NULL),
('Candlewood Suites', 108, '2019-11-23', 164, NULL),
('Candlewood Suites', 108, '2019-11-24', 208, NULL),
('Candlewood Suites', 108, '2019-11-25', 279, NULL),
('Candlewood Suites', 108, '2019-11-26', 159, NULL),
('Candlewood Suites', 108, '2019-11-27', 206, NULL),
('Candlewood Suites', 108, '2019-11-28', 301, NULL),
('Candlewood Suites', 108, '2019-11-29', 280, NULL),
('Candlewood Suites', 108, '2019-11-30', 379, NULL),
('Candlewood Suites', 108, '2019-12-01', 127, NULL),
('Candlewood Suites', 108, '2019-12-02', 313, NULL),
('Candlewood Suites', 108, '2019-12-03', 201, NULL),
('Candlewood Suites', 108, '2019-12-04', 306, NULL),
('Candlewood Suites', 108, '2019-12-05', 108, NULL),
('Candlewood Suites', 108, '2019-12-06', 235, NULL),
('Candlewood Suites', 108, '2019-12-07', 372, NULL),
('Candlewood Suites', 108, '2019-12-08', 139, NULL),
('Candlewood Suites', 108, '2019-12-09', 238, NULL),
('Candlewood Suites', 108, '2019-12-10', 391, NULL),
('Candlewood Suites', 108, '2019-12-11', 209, NULL),
('Candlewood Suites', 108, '2019-12-12', 337, NULL),
('Candlewood Suites', 108, '2019-12-13', 383, NULL),
('Candlewood Suites', 108, '2019-12-14', 107, NULL),
('Candlewood Suites', 108, '2019-12-15', 235, NULL),
('Candlewood Suites', 108, '2019-12-16', 209, NULL),
('Candlewood Suites', 108, '2019-12-17', 124, NULL),
('Candlewood Suites', 108, '2019-12-18', 367, NULL),
('Candlewood Suites', 108, '2019-12-19', 373, NULL),
('Candlewood Suites', 108, '2019-12-20', 276, NULL),
('Candlewood Suites', 108, '2019-12-21', 123, NULL),
('Candlewood Suites', 108, '2019-12-22', 202, NULL),
('Candlewood Suites', 108, '2019-12-23', 134, NULL),
('Candlewood Suites', 108, '2019-12-24', 183, NULL),
('Candlewood Suites', 108, '2019-12-25', 352, NULL),
('Candlewood Suites', 108, '2019-12-26', 280, NULL),
('Candlewood Suites', 108, '2019-12-27', 364, NULL),
('Candlewood Suites', 108, '2019-12-28', 395, NULL),
('Candlewood Suites', 108, '2019-12-29', 117, NULL),
('Candlewood Suites', 108, '2019-12-30', 306, NULL),
('Candlewood Suites', 108, '2019-12-31', 154, NULL),
('Candlewood Suites', 108, '2020-01-01', 131, NULL),
('Candlewood Suites', 108, '2020-01-02', 195, NULL),
('Candlewood Suites', 108, '2020-01-03', 195, NULL),
('Candlewood Suites', 108, '2020-01-04', 129, NULL),
('Candlewood Suites', 108, '2020-01-05', 337, NULL),
('Candlewood Suites', 108, '2020-01-06', 352, NULL),
('Candlewood Suites', 108, '2020-01-07', 386, NULL),
('Candlewood Suites', 108, '2020-01-08', 269, NULL),
('Candlewood Suites', 108, '2020-01-09', 116, NULL),
('Candlewood Suites', 108, '2020-01-10', 164, NULL),
('Candlewood Suites', 108, '2020-01-11', 274, NULL),
('Candlewood Suites', 108, '2020-01-12', 293, NULL),
('Candlewood Suites', 108, '2020-01-13', 139, NULL),
('Candlewood Suites', 108, '2020-01-14', 169, NULL),
('Candlewood Suites', 108, '2020-01-15', 111, NULL),
('Candlewood Suites', 108, '2020-01-16', 339, NULL),
('Candlewood Suites', 108, '2020-01-17', 238, NULL),
('Candlewood Suites', 108, '2020-01-18', 248, NULL),
('Candlewood Suites', 108, '2020-01-19', 214, NULL),
('Candlewood Suites', 108, '2020-01-20', 326, NULL),
('Candlewood Suites', 108, '2020-01-21', 332, NULL),
('Candlewood Suites', 108, '2020-01-22', 340, NULL),
('Candlewood Suites', 108, '2020-01-23', 267, NULL),
('Candlewood Suites', 108, '2020-01-24', 366, NULL),
('Candlewood Suites', 108, '2020-01-25', 114, NULL),
('Candlewood Suites', 108, '2020-01-26', 113, NULL),
('Candlewood Suites', 108, '2020-01-27', 150, NULL),
('Candlewood Suites', 108, '2020-01-28', 347, NULL),
('Candlewood Suites', 108, '2020-01-29', 126, NULL),
('Candlewood Suites', 108, '2020-01-30', 346, NULL),
('Candlewood Suites', 108, '2020-01-31', 392, NULL),
('Candlewood Suites', 108, '2020-02-01', 132, NULL),
('Candlewood Suites', 108, '2020-02-02', 210, NULL),
('Candlewood Suites', 108, '2020-02-03', 228, NULL),
('Candlewood Suites', 108, '2020-02-04', 185, NULL),
('Candlewood Suites', 110, '2019-01-01', 102, NULL),
('Candlewood Suites', 110, '2019-01-02', 335, NULL),
('Candlewood Suites', 110, '2019-01-03', 355, NULL),
('Candlewood Suites', 110, '2019-01-04', 311, NULL),
('Candlewood Suites', 110, '2019-01-05', 333, NULL),
('Candlewood Suites', 110, '2019-01-06', 370, NULL),
('Candlewood Suites', 110, '2019-01-07', 220, NULL),
('Candlewood Suites', 110, '2019-01-08', 222, NULL),
('Candlewood Suites', 110, '2019-01-09', 128, NULL),
('Candlewood Suites', 110, '2019-01-10', 374, NULL),
('Candlewood Suites', 110, '2019-01-11', 297, NULL),
('Candlewood Suites', 110, '2019-01-12', 368, NULL),
('Candlewood Suites', 110, '2019-01-13', 370, NULL),
('Candlewood Suites', 110, '2019-01-14', 313, NULL),
('Candlewood Suites', 110, '2019-01-15', 139, NULL),
('Candlewood Suites', 110, '2019-01-16', 121, NULL),
('Candlewood Suites', 110, '2019-01-17', 174, NULL),
('Candlewood Suites', 110, '2019-01-18', 326, NULL),
('Candlewood Suites', 110, '2019-01-19', 395, NULL),
('Candlewood Suites', 110, '2019-01-20', 262, NULL),
('Candlewood Suites', 110, '2019-01-21', 303, NULL),
('Candlewood Suites', 110, '2019-01-22', 259, NULL),
('Candlewood Suites', 110, '2019-01-23', 372, NULL),
('Candlewood Suites', 110, '2019-01-24', 100, NULL),
('Candlewood Suites', 110, '2019-01-25', 272, NULL),
('Candlewood Suites', 110, '2019-01-26', 388, NULL),
('Candlewood Suites', 110, '2019-01-27', 106, NULL),
('Candlewood Suites', 110, '2019-01-28', 298, NULL),
('Candlewood Suites', 110, '2019-01-29', 339, NULL),
('Candlewood Suites', 110, '2019-01-30', 258, NULL),
('Candlewood Suites', 110, '2019-01-31', 395, NULL),
('Candlewood Suites', 110, '2019-02-01', 250, NULL),
('Candlewood Suites', 110, '2019-02-02', 154, NULL),
('Candlewood Suites', 110, '2019-02-03', 232, NULL),
('Candlewood Suites', 110, '2019-02-04', 235, NULL),
('Candlewood Suites', 110, '2019-02-05', 182, NULL),
('Candlewood Suites', 110, '2019-02-06', 384, NULL),
('Candlewood Suites', 110, '2019-02-07', 329, NULL),
('Candlewood Suites', 110, '2019-02-08', 210, NULL),
('Candlewood Suites', 110, '2019-02-09', 193, NULL),
('Candlewood Suites', 110, '2019-02-10', 268, NULL),
('Candlewood Suites', 110, '2019-02-11', 156, NULL),
('Candlewood Suites', 110, '2019-02-12', 388, NULL),
('Candlewood Suites', 110, '2019-02-13', 125, NULL),
('Candlewood Suites', 110, '2019-02-14', 194, NULL),
('Candlewood Suites', 110, '2019-02-15', 113, NULL),
('Candlewood Suites', 110, '2019-02-16', 140, NULL),
('Candlewood Suites', 110, '2019-02-17', 230, NULL),
('Candlewood Suites', 110, '2019-02-18', 260, NULL),
('Candlewood Suites', 110, '2019-02-19', 230, NULL),
('Candlewood Suites', 110, '2019-02-20', 211, NULL),
('Candlewood Suites', 110, '2019-02-21', 391, NULL),
('Candlewood Suites', 110, '2019-02-22', 321, NULL),
('Candlewood Suites', 110, '2019-02-23', 120, NULL),
('Candlewood Suites', 110, '2019-02-24', 157, NULL),
('Candlewood Suites', 110, '2019-02-25', 133, NULL),
('Candlewood Suites', 110, '2019-02-26', 296, NULL),
('Candlewood Suites', 110, '2019-02-27', 377, NULL),
('Candlewood Suites', 110, '2019-02-28', 281, NULL),
('Candlewood Suites', 110, '2019-03-01', 192, NULL),
('Candlewood Suites', 110, '2019-03-02', 158, NULL),
('Candlewood Suites', 110, '2019-03-03', 204, NULL),
('Candlewood Suites', 110, '2019-03-04', 196, NULL),
('Candlewood Suites', 110, '2019-03-05', 127, NULL),
('Candlewood Suites', 110, '2019-03-06', 308, NULL),
('Candlewood Suites', 110, '2019-03-07', 200, NULL),
('Candlewood Suites', 110, '2019-03-08', 260, NULL),
('Candlewood Suites', 110, '2019-03-09', 316, NULL),
('Candlewood Suites', 110, '2019-03-10', 170, NULL),
('Candlewood Suites', 110, '2019-03-11', 356, NULL),
('Candlewood Suites', 110, '2019-03-12', 363, NULL),
('Candlewood Suites', 110, '2019-03-13', 238, NULL),
('Candlewood Suites', 110, '2019-03-14', 338, NULL),
('Candlewood Suites', 110, '2019-03-15', 218, NULL),
('Candlewood Suites', 110, '2019-03-16', 329, NULL),
('Candlewood Suites', 110, '2019-03-17', 103, NULL),
('Candlewood Suites', 110, '2019-03-18', 333, NULL),
('Candlewood Suites', 110, '2019-03-19', 239, NULL),
('Candlewood Suites', 110, '2019-03-20', 136, NULL),
('Candlewood Suites', 110, '2019-03-21', 343, NULL),
('Candlewood Suites', 110, '2019-03-22', 311, NULL),
('Candlewood Suites', 110, '2019-03-23', 383, NULL),
('Candlewood Suites', 110, '2019-03-24', 263, NULL),
('Candlewood Suites', 110, '2019-03-25', 269, NULL),
('Candlewood Suites', 110, '2019-03-26', 184, NULL),
('Candlewood Suites', 110, '2019-03-27', 363, NULL),
('Candlewood Suites', 110, '2019-03-28', 145, NULL),
('Candlewood Suites', 110, '2019-03-29', 308, NULL),
('Candlewood Suites', 110, '2019-03-30', 345, NULL),
('Candlewood Suites', 110, '2019-03-31', 188, NULL),
('Candlewood Suites', 110, '2019-04-01', 124, NULL),
('Candlewood Suites', 110, '2019-04-02', 383, NULL),
('Candlewood Suites', 110, '2019-04-03', 377, NULL),
('Candlewood Suites', 110, '2019-04-04', 317, NULL),
('Candlewood Suites', 110, '2019-04-05', 175, NULL),
('Candlewood Suites', 110, '2019-04-06', 124, NULL),
('Candlewood Suites', 110, '2019-04-07', 320, NULL),
('Candlewood Suites', 110, '2019-04-08', 197, NULL),
('Candlewood Suites', 110, '2019-04-09', 127, NULL),
('Candlewood Suites', 110, '2019-04-10', 186, NULL),
('Candlewood Suites', 110, '2019-04-11', 275, NULL),
('Candlewood Suites', 110, '2019-04-12', 308, NULL),
('Candlewood Suites', 110, '2019-04-13', 247, NULL),
('Candlewood Suites', 110, '2019-04-14', 250, NULL),
('Candlewood Suites', 110, '2019-04-15', 394, NULL),
('Candlewood Suites', 110, '2019-04-16', 198, NULL),
('Candlewood Suites', 110, '2019-04-17', 112, NULL),
('Candlewood Suites', 110, '2019-04-18', 388, NULL),
('Candlewood Suites', 110, '2019-04-19', 360, NULL),
('Candlewood Suites', 110, '2019-04-20', 146, NULL),
('Candlewood Suites', 110, '2019-04-21', 130, NULL),
('Candlewood Suites', 110, '2019-04-22', 362, NULL),
('Candlewood Suites', 110, '2019-04-23', 210, NULL),
('Candlewood Suites', 110, '2019-04-24', 264, NULL),
('Candlewood Suites', 110, '2019-04-25', 268, NULL),
('Candlewood Suites', 110, '2019-04-26', 105, NULL),
('Candlewood Suites', 110, '2019-04-27', 217, NULL),
('Candlewood Suites', 110, '2019-04-28', 170, NULL),
('Candlewood Suites', 110, '2019-04-29', 377, NULL),
('Candlewood Suites', 110, '2019-04-30', 243, NULL),
('Candlewood Suites', 110, '2019-05-01', 317, NULL),
('Candlewood Suites', 110, '2019-05-02', 145, NULL),
('Candlewood Suites', 110, '2019-05-03', 367, NULL),
('Candlewood Suites', 110, '2019-05-04', 184, NULL),
('Candlewood Suites', 110, '2019-05-05', 180, NULL),
('Candlewood Suites', 110, '2019-05-06', 127, NULL),
('Candlewood Suites', 110, '2019-05-07', 231, NULL),
('Candlewood Suites', 110, '2019-05-08', 130, NULL),
('Candlewood Suites', 110, '2019-05-09', 395, NULL),
('Candlewood Suites', 110, '2019-05-10', 332, NULL),
('Candlewood Suites', 110, '2019-05-11', 222, NULL),
('Candlewood Suites', 110, '2019-05-12', 265, NULL),
('Candlewood Suites', 110, '2019-05-13', 215, NULL),
('Candlewood Suites', 110, '2019-05-14', 282, NULL),
('Candlewood Suites', 110, '2019-05-15', 391, NULL),
('Candlewood Suites', 110, '2019-05-16', 183, NULL),
('Candlewood Suites', 110, '2019-05-17', 218, NULL),
('Candlewood Suites', 110, '2019-05-18', 320, NULL),
('Candlewood Suites', 110, '2019-05-19', 206, NULL),
('Candlewood Suites', 110, '2019-05-20', 309, NULL),
('Candlewood Suites', 110, '2019-05-21', 234, NULL),
('Candlewood Suites', 110, '2019-05-22', 113, NULL),
('Candlewood Suites', 110, '2019-05-23', 101, NULL),
('Candlewood Suites', 110, '2019-05-24', 234, NULL),
('Candlewood Suites', 110, '2019-05-25', 287, NULL),
('Candlewood Suites', 110, '2019-05-26', 271, NULL),
('Candlewood Suites', 110, '2019-05-27', 212, NULL),
('Candlewood Suites', 110, '2019-05-28', 232, NULL),
('Candlewood Suites', 110, '2019-05-29', 137, NULL),
('Candlewood Suites', 110, '2019-05-30', 270, NULL),
('Candlewood Suites', 110, '2019-05-31', 259, NULL),
('Candlewood Suites', 110, '2019-06-01', 203, NULL),
('Candlewood Suites', 110, '2019-06-02', 349, NULL),
('Candlewood Suites', 110, '2019-06-03', 151, NULL),
('Candlewood Suites', 110, '2019-06-04', 359, NULL),
('Candlewood Suites', 110, '2019-06-05', 233, NULL),
('Candlewood Suites', 110, '2019-06-06', 110, NULL),
('Candlewood Suites', 110, '2019-06-07', 129, NULL),
('Candlewood Suites', 110, '2019-06-08', 387, NULL),
('Candlewood Suites', 110, '2019-06-09', 181, NULL),
('Candlewood Suites', 110, '2019-06-10', 175, NULL),
('Candlewood Suites', 110, '2019-06-11', 370, NULL),
('Candlewood Suites', 110, '2019-06-12', 333, NULL),
('Candlewood Suites', 110, '2019-06-13', 192, NULL),
('Candlewood Suites', 110, '2019-06-14', 199, NULL),
('Candlewood Suites', 110, '2019-06-15', 165, NULL),
('Candlewood Suites', 110, '2019-06-16', 193, NULL),
('Candlewood Suites', 110, '2019-06-17', 276, NULL),
('Candlewood Suites', 110, '2019-06-18', 200, NULL),
('Candlewood Suites', 110, '2019-06-19', 208, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 110, '2019-06-20', 131, NULL),
('Candlewood Suites', 110, '2019-06-21', 361, NULL),
('Candlewood Suites', 110, '2019-06-22', 384, NULL),
('Candlewood Suites', 110, '2019-06-23', 241, NULL),
('Candlewood Suites', 110, '2019-06-24', 354, NULL),
('Candlewood Suites', 110, '2019-06-25', 377, NULL),
('Candlewood Suites', 110, '2019-06-26', 127, NULL),
('Candlewood Suites', 110, '2019-06-27', 382, NULL),
('Candlewood Suites', 110, '2019-06-28', 145, NULL),
('Candlewood Suites', 110, '2019-06-29', 250, NULL),
('Candlewood Suites', 110, '2019-06-30', 114, NULL),
('Candlewood Suites', 110, '2019-07-01', 204, NULL),
('Candlewood Suites', 110, '2019-07-02', 297, NULL),
('Candlewood Suites', 110, '2019-07-03', 272, NULL),
('Candlewood Suites', 110, '2019-07-04', 248, NULL),
('Candlewood Suites', 110, '2019-07-05', 207, NULL),
('Candlewood Suites', 110, '2019-07-06', 181, NULL),
('Candlewood Suites', 110, '2019-07-07', 397, NULL),
('Candlewood Suites', 110, '2019-07-08', 178, NULL),
('Candlewood Suites', 110, '2019-07-09', 293, NULL),
('Candlewood Suites', 110, '2019-07-10', 317, NULL),
('Candlewood Suites', 110, '2019-07-11', 329, NULL),
('Candlewood Suites', 110, '2019-07-12', 371, NULL),
('Candlewood Suites', 110, '2019-07-13', 126, NULL),
('Candlewood Suites', 110, '2019-07-14', 134, NULL),
('Candlewood Suites', 110, '2019-07-15', 295, NULL),
('Candlewood Suites', 110, '2019-07-16', 238, NULL),
('Candlewood Suites', 110, '2019-07-17', 250, NULL),
('Candlewood Suites', 110, '2019-07-18', 163, NULL),
('Candlewood Suites', 110, '2019-07-19', 125, NULL),
('Candlewood Suites', 110, '2019-07-20', 292, NULL),
('Candlewood Suites', 110, '2019-07-21', 288, NULL),
('Candlewood Suites', 110, '2019-07-22', 242, NULL),
('Candlewood Suites', 110, '2019-07-23', 234, NULL),
('Candlewood Suites', 110, '2019-07-24', 121, NULL),
('Candlewood Suites', 110, '2019-07-25', 101, NULL),
('Candlewood Suites', 110, '2019-07-26', 386, NULL),
('Candlewood Suites', 110, '2019-07-27', 149, NULL),
('Candlewood Suites', 110, '2019-07-28', 142, NULL),
('Candlewood Suites', 110, '2019-07-29', 350, NULL),
('Candlewood Suites', 110, '2019-07-30', 110, NULL),
('Candlewood Suites', 110, '2019-07-31', 225, NULL),
('Candlewood Suites', 110, '2019-08-01', 383, NULL),
('Candlewood Suites', 110, '2019-08-02', 188, NULL),
('Candlewood Suites', 110, '2019-08-03', 338, NULL),
('Candlewood Suites', 110, '2019-08-04', 130, NULL),
('Candlewood Suites', 110, '2019-08-05', 294, NULL),
('Candlewood Suites', 110, '2019-08-06', 354, NULL),
('Candlewood Suites', 110, '2019-08-07', 202, NULL),
('Candlewood Suites', 110, '2019-08-08', 167, NULL),
('Candlewood Suites', 110, '2019-08-09', 143, NULL),
('Candlewood Suites', 110, '2019-08-10', 169, NULL),
('Candlewood Suites', 110, '2019-08-11', 274, NULL),
('Candlewood Suites', 110, '2019-08-12', 247, NULL),
('Candlewood Suites', 110, '2019-08-13', 358, NULL),
('Candlewood Suites', 110, '2019-08-14', 283, NULL),
('Candlewood Suites', 110, '2019-08-15', 198, NULL),
('Candlewood Suites', 110, '2019-08-16', 325, NULL),
('Candlewood Suites', 110, '2019-08-17', 312, NULL),
('Candlewood Suites', 110, '2019-08-18', 148, NULL),
('Candlewood Suites', 110, '2019-08-19', 118, NULL),
('Candlewood Suites', 110, '2019-08-20', 140, NULL),
('Candlewood Suites', 110, '2019-08-21', 105, NULL),
('Candlewood Suites', 110, '2019-08-22', 217, NULL),
('Candlewood Suites', 110, '2019-08-23', 239, NULL),
('Candlewood Suites', 110, '2019-08-24', 167, NULL),
('Candlewood Suites', 110, '2019-08-25', 121, NULL),
('Candlewood Suites', 110, '2019-08-26', 175, NULL),
('Candlewood Suites', 110, '2019-08-27', 159, NULL),
('Candlewood Suites', 110, '2019-08-28', 297, NULL),
('Candlewood Suites', 110, '2019-08-29', 227, NULL),
('Candlewood Suites', 110, '2019-08-30', 320, NULL),
('Candlewood Suites', 110, '2019-08-31', 302, NULL),
('Candlewood Suites', 110, '2019-09-01', 121, NULL),
('Candlewood Suites', 110, '2019-09-02', 223, NULL),
('Candlewood Suites', 110, '2019-09-03', 255, NULL),
('Candlewood Suites', 110, '2019-09-04', 273, NULL),
('Candlewood Suites', 110, '2019-09-05', 211, NULL),
('Candlewood Suites', 110, '2019-09-06', 179, NULL),
('Candlewood Suites', 110, '2019-09-07', 200, NULL),
('Candlewood Suites', 110, '2019-09-08', 198, NULL),
('Candlewood Suites', 110, '2019-09-09', 182, NULL),
('Candlewood Suites', 110, '2019-09-10', 116, NULL),
('Candlewood Suites', 110, '2019-09-11', 104, NULL),
('Candlewood Suites', 110, '2019-09-12', 383, NULL),
('Candlewood Suites', 110, '2019-09-13', 270, NULL),
('Candlewood Suites', 110, '2019-09-14', 277, NULL),
('Candlewood Suites', 110, '2019-09-15', 212, NULL),
('Candlewood Suites', 110, '2019-09-16', 149, NULL),
('Candlewood Suites', 110, '2019-09-17', 178, NULL),
('Candlewood Suites', 110, '2019-09-18', 107, NULL),
('Candlewood Suites', 110, '2019-09-19', 183, NULL),
('Candlewood Suites', 110, '2019-09-20', 138, NULL),
('Candlewood Suites', 110, '2019-09-21', 206, NULL),
('Candlewood Suites', 110, '2019-09-22', 294, NULL),
('Candlewood Suites', 110, '2019-09-23', 368, NULL),
('Candlewood Suites', 110, '2019-09-24', 298, NULL),
('Candlewood Suites', 110, '2019-09-25', 171, NULL),
('Candlewood Suites', 110, '2019-09-26', 118, NULL),
('Candlewood Suites', 110, '2019-09-27', 306, NULL),
('Candlewood Suites', 110, '2019-09-28', 328, NULL),
('Candlewood Suites', 110, '2019-09-29', 224, NULL),
('Candlewood Suites', 110, '2019-09-30', 274, NULL),
('Candlewood Suites', 110, '2019-10-01', 271, NULL),
('Candlewood Suites', 110, '2019-10-02', 367, NULL),
('Candlewood Suites', 110, '2019-10-03', 264, NULL),
('Candlewood Suites', 110, '2019-10-04', 170, NULL),
('Candlewood Suites', 110, '2019-10-05', 227, NULL),
('Candlewood Suites', 110, '2019-10-06', 276, NULL),
('Candlewood Suites', 110, '2019-10-07', 154, NULL),
('Candlewood Suites', 110, '2019-10-08', 126, NULL),
('Candlewood Suites', 110, '2019-10-09', 215, NULL),
('Candlewood Suites', 110, '2019-10-10', 342, NULL),
('Candlewood Suites', 110, '2019-10-11', 158, NULL),
('Candlewood Suites', 110, '2019-10-12', 245, NULL),
('Candlewood Suites', 110, '2019-10-13', 249, NULL),
('Candlewood Suites', 110, '2019-10-14', 240, NULL),
('Candlewood Suites', 110, '2019-10-15', 295, NULL),
('Candlewood Suites', 110, '2019-10-16', 168, NULL),
('Candlewood Suites', 110, '2019-10-17', 391, NULL),
('Candlewood Suites', 110, '2019-10-18', 126, NULL),
('Candlewood Suites', 110, '2019-10-19', 170, NULL),
('Candlewood Suites', 110, '2019-10-20', 323, NULL),
('Candlewood Suites', 110, '2019-10-21', 342, NULL),
('Candlewood Suites', 110, '2019-10-22', 374, NULL),
('Candlewood Suites', 110, '2019-10-23', 345, NULL),
('Candlewood Suites', 110, '2019-10-24', 253, NULL),
('Candlewood Suites', 110, '2019-10-25', 301, NULL),
('Candlewood Suites', 110, '2019-10-26', 384, NULL),
('Candlewood Suites', 110, '2019-10-27', 179, NULL),
('Candlewood Suites', 110, '2019-10-28', 258, NULL),
('Candlewood Suites', 110, '2019-10-29', 142, NULL),
('Candlewood Suites', 110, '2019-10-30', 171, NULL),
('Candlewood Suites', 110, '2019-10-31', 105, NULL),
('Candlewood Suites', 110, '2019-11-01', 106, NULL),
('Candlewood Suites', 110, '2019-11-02', 364, NULL),
('Candlewood Suites', 110, '2019-11-03', 148, NULL),
('Candlewood Suites', 110, '2019-11-04', 117, NULL),
('Candlewood Suites', 110, '2019-11-05', 258, NULL),
('Candlewood Suites', 110, '2019-11-06', 107, NULL),
('Candlewood Suites', 110, '2019-11-07', 142, NULL),
('Candlewood Suites', 110, '2019-11-08', 235, NULL),
('Candlewood Suites', 110, '2019-11-09', 241, NULL),
('Candlewood Suites', 110, '2019-11-10', 272, NULL),
('Candlewood Suites', 110, '2019-11-11', 197, NULL),
('Candlewood Suites', 110, '2019-11-12', 258, NULL),
('Candlewood Suites', 110, '2019-11-13', 362, NULL),
('Candlewood Suites', 110, '2019-11-14', 255, NULL),
('Candlewood Suites', 110, '2019-11-15', 218, NULL),
('Candlewood Suites', 110, '2019-11-16', 393, NULL),
('Candlewood Suites', 110, '2019-11-17', 392, NULL),
('Candlewood Suites', 110, '2019-11-18', 275, NULL),
('Candlewood Suites', 110, '2019-11-19', 263, NULL),
('Candlewood Suites', 110, '2019-11-20', 306, NULL),
('Candlewood Suites', 110, '2019-11-21', 369, NULL),
('Candlewood Suites', 110, '2019-11-22', 149, NULL),
('Candlewood Suites', 110, '2019-11-23', 224, NULL),
('Candlewood Suites', 110, '2019-11-24', 390, NULL),
('Candlewood Suites', 110, '2019-11-25', 214, NULL),
('Candlewood Suites', 110, '2019-11-26', 398, NULL),
('Candlewood Suites', 110, '2019-11-27', 146, NULL),
('Candlewood Suites', 110, '2019-11-28', 353, NULL),
('Candlewood Suites', 110, '2019-11-29', 336, NULL),
('Candlewood Suites', 110, '2019-11-30', 152, NULL),
('Candlewood Suites', 110, '2019-12-01', 279, NULL),
('Candlewood Suites', 110, '2019-12-02', 298, NULL),
('Candlewood Suites', 110, '2019-12-03', 312, NULL),
('Candlewood Suites', 110, '2019-12-04', 287, NULL),
('Candlewood Suites', 110, '2019-12-05', 366, NULL),
('Candlewood Suites', 110, '2019-12-06', 275, NULL),
('Candlewood Suites', 110, '2019-12-07', 182, NULL),
('Candlewood Suites', 110, '2019-12-08', 164, NULL),
('Candlewood Suites', 110, '2019-12-09', 264, NULL),
('Candlewood Suites', 110, '2019-12-10', 152, NULL),
('Candlewood Suites', 110, '2019-12-11', 347, NULL),
('Candlewood Suites', 110, '2019-12-12', 182, NULL),
('Candlewood Suites', 110, '2019-12-13', 109, NULL),
('Candlewood Suites', 110, '2019-12-14', 265, NULL),
('Candlewood Suites', 110, '2019-12-15', 215, NULL),
('Candlewood Suites', 110, '2019-12-16', 216, NULL),
('Candlewood Suites', 110, '2019-12-17', 380, NULL),
('Candlewood Suites', 110, '2019-12-18', 291, NULL),
('Candlewood Suites', 110, '2019-12-19', 105, NULL),
('Candlewood Suites', 110, '2019-12-20', 250, NULL),
('Candlewood Suites', 110, '2019-12-21', 310, NULL),
('Candlewood Suites', 110, '2019-12-22', 313, NULL),
('Candlewood Suites', 110, '2019-12-23', 276, NULL),
('Candlewood Suites', 110, '2019-12-24', 321, NULL),
('Candlewood Suites', 110, '2019-12-25', 171, NULL),
('Candlewood Suites', 110, '2019-12-26', 230, NULL),
('Candlewood Suites', 110, '2019-12-27', 224, NULL),
('Candlewood Suites', 110, '2019-12-28', 124, NULL),
('Candlewood Suites', 110, '2019-12-29', 239, NULL),
('Candlewood Suites', 110, '2019-12-30', 118, NULL),
('Candlewood Suites', 110, '2019-12-31', 158, NULL),
('Candlewood Suites', 110, '2020-01-01', 114, NULL),
('Candlewood Suites', 110, '2020-01-02', 399, NULL),
('Candlewood Suites', 110, '2020-01-03', 306, NULL),
('Candlewood Suites', 110, '2020-01-04', 117, NULL),
('Candlewood Suites', 110, '2020-01-05', 328, NULL),
('Candlewood Suites', 110, '2020-01-06', 212, NULL),
('Candlewood Suites', 110, '2020-01-07', 182, NULL),
('Candlewood Suites', 110, '2020-01-08', 122, NULL),
('Candlewood Suites', 110, '2020-01-09', 292, NULL),
('Candlewood Suites', 110, '2020-01-10', 390, NULL),
('Candlewood Suites', 110, '2020-01-11', 218, NULL),
('Candlewood Suites', 110, '2020-01-12', 148, NULL),
('Candlewood Suites', 110, '2020-01-13', 322, NULL),
('Candlewood Suites', 110, '2020-01-14', 255, NULL),
('Candlewood Suites', 110, '2020-01-15', 248, NULL),
('Candlewood Suites', 110, '2020-01-16', 322, NULL),
('Candlewood Suites', 110, '2020-01-17', 152, NULL),
('Candlewood Suites', 110, '2020-01-18', 122, NULL),
('Candlewood Suites', 110, '2020-01-19', 209, NULL),
('Candlewood Suites', 110, '2020-01-20', 303, NULL),
('Candlewood Suites', 110, '2020-01-21', 295, NULL),
('Candlewood Suites', 110, '2020-01-22', 210, NULL),
('Candlewood Suites', 110, '2020-01-23', 301, NULL),
('Candlewood Suites', 110, '2020-01-24', 137, NULL),
('Candlewood Suites', 110, '2020-01-25', 355, NULL),
('Candlewood Suites', 110, '2020-01-26', 397, NULL),
('Candlewood Suites', 110, '2020-01-27', 108, NULL),
('Candlewood Suites', 110, '2020-01-28', 296, NULL),
('Candlewood Suites', 110, '2020-01-29', 256, NULL),
('Candlewood Suites', 110, '2020-01-30', 385, NULL),
('Candlewood Suites', 110, '2020-01-31', 166, NULL),
('Candlewood Suites', 110, '2020-02-01', 156, NULL),
('Candlewood Suites', 110, '2020-02-02', 262, NULL),
('Candlewood Suites', 110, '2020-02-03', 190, NULL),
('Candlewood Suites', 110, '2020-02-04', 128, NULL),
('Candlewood Suites', 114, '2019-01-01', 376, NULL),
('Candlewood Suites', 114, '2019-01-02', 351, NULL),
('Candlewood Suites', 114, '2019-01-03', 248, NULL),
('Candlewood Suites', 114, '2019-01-04', 177, NULL),
('Candlewood Suites', 114, '2019-01-05', 175, NULL),
('Candlewood Suites', 114, '2019-01-06', 157, NULL),
('Candlewood Suites', 114, '2019-01-07', 279, NULL),
('Candlewood Suites', 114, '2019-01-08', 105, NULL),
('Candlewood Suites', 114, '2019-01-09', 153, NULL),
('Candlewood Suites', 114, '2019-01-10', 234, NULL),
('Candlewood Suites', 114, '2019-01-11', 167, NULL),
('Candlewood Suites', 114, '2019-01-12', 300, NULL),
('Candlewood Suites', 114, '2019-01-13', 297, NULL),
('Candlewood Suites', 114, '2019-01-14', 117, NULL),
('Candlewood Suites', 114, '2019-01-15', 313, NULL),
('Candlewood Suites', 114, '2019-01-16', 324, NULL),
('Candlewood Suites', 114, '2019-01-17', 280, NULL),
('Candlewood Suites', 114, '2019-01-18', 240, NULL),
('Candlewood Suites', 114, '2019-01-19', 173, NULL),
('Candlewood Suites', 114, '2019-01-20', 149, NULL),
('Candlewood Suites', 114, '2019-01-21', 128, NULL),
('Candlewood Suites', 114, '2019-01-22', 252, NULL),
('Candlewood Suites', 114, '2019-01-23', 245, NULL),
('Candlewood Suites', 114, '2019-01-24', 110, NULL),
('Candlewood Suites', 114, '2019-01-25', 355, NULL),
('Candlewood Suites', 114, '2019-01-26', 220, NULL),
('Candlewood Suites', 114, '2019-01-27', 157, NULL),
('Candlewood Suites', 114, '2019-01-28', 380, NULL),
('Candlewood Suites', 114, '2019-01-29', 312, NULL),
('Candlewood Suites', 114, '2019-01-30', 253, NULL),
('Candlewood Suites', 114, '2019-01-31', 275, NULL),
('Candlewood Suites', 114, '2019-02-01', 266, NULL),
('Candlewood Suites', 114, '2019-02-02', 239, NULL),
('Candlewood Suites', 114, '2019-02-03', 234, NULL),
('Candlewood Suites', 114, '2019-02-04', 349, NULL),
('Candlewood Suites', 114, '2019-02-05', 185, NULL),
('Candlewood Suites', 114, '2019-02-06', 277, NULL),
('Candlewood Suites', 114, '2019-02-07', 274, NULL),
('Candlewood Suites', 114, '2019-02-08', 319, NULL),
('Candlewood Suites', 114, '2019-02-09', 341, NULL),
('Candlewood Suites', 114, '2019-02-10', 252, NULL),
('Candlewood Suites', 114, '2019-02-11', 291, NULL),
('Candlewood Suites', 114, '2019-02-12', 223, NULL),
('Candlewood Suites', 114, '2019-02-13', 187, NULL),
('Candlewood Suites', 114, '2019-02-14', 283, NULL),
('Candlewood Suites', 114, '2019-02-15', 238, NULL),
('Candlewood Suites', 114, '2019-02-16', 307, NULL),
('Candlewood Suites', 114, '2019-02-17', 193, NULL),
('Candlewood Suites', 114, '2019-02-18', 132, NULL),
('Candlewood Suites', 114, '2019-02-19', 342, NULL),
('Candlewood Suites', 114, '2019-02-20', 314, NULL),
('Candlewood Suites', 114, '2019-02-21', 190, NULL),
('Candlewood Suites', 114, '2019-02-22', 172, NULL),
('Candlewood Suites', 114, '2019-02-23', 286, NULL),
('Candlewood Suites', 114, '2019-02-24', 395, NULL),
('Candlewood Suites', 114, '2019-02-25', 169, NULL),
('Candlewood Suites', 114, '2019-02-26', 351, NULL),
('Candlewood Suites', 114, '2019-02-27', 135, NULL),
('Candlewood Suites', 114, '2019-02-28', 210, NULL),
('Candlewood Suites', 114, '2019-03-01', 178, NULL),
('Candlewood Suites', 114, '2019-03-02', 169, NULL),
('Candlewood Suites', 114, '2019-03-03', 321, NULL),
('Candlewood Suites', 114, '2019-03-04', 324, NULL),
('Candlewood Suites', 114, '2019-03-05', 206, NULL),
('Candlewood Suites', 114, '2019-03-06', 342, NULL),
('Candlewood Suites', 114, '2019-03-07', 320, NULL),
('Candlewood Suites', 114, '2019-03-08', 198, NULL),
('Candlewood Suites', 114, '2019-03-09', 374, NULL),
('Candlewood Suites', 114, '2019-03-10', 152, NULL),
('Candlewood Suites', 114, '2019-03-11', 324, NULL),
('Candlewood Suites', 114, '2019-03-12', 220, NULL),
('Candlewood Suites', 114, '2019-03-13', 287, NULL),
('Candlewood Suites', 114, '2019-03-14', 269, NULL),
('Candlewood Suites', 114, '2019-03-15', 161, NULL),
('Candlewood Suites', 114, '2019-03-16', 272, NULL),
('Candlewood Suites', 114, '2019-03-17', 212, NULL),
('Candlewood Suites', 114, '2019-03-18', 177, NULL),
('Candlewood Suites', 114, '2019-03-19', 308, NULL),
('Candlewood Suites', 114, '2019-03-20', 254, NULL),
('Candlewood Suites', 114, '2019-03-21', 355, NULL),
('Candlewood Suites', 114, '2019-03-22', 380, NULL),
('Candlewood Suites', 114, '2019-03-23', 231, NULL),
('Candlewood Suites', 114, '2019-03-24', 311, NULL),
('Candlewood Suites', 114, '2019-03-25', 379, NULL),
('Candlewood Suites', 114, '2019-03-26', 355, NULL),
('Candlewood Suites', 114, '2019-03-27', 105, NULL),
('Candlewood Suites', 114, '2019-03-28', 196, NULL),
('Candlewood Suites', 114, '2019-03-29', 328, NULL),
('Candlewood Suites', 114, '2019-03-30', 296, NULL),
('Candlewood Suites', 114, '2019-03-31', 137, NULL),
('Candlewood Suites', 114, '2019-04-01', 222, NULL),
('Candlewood Suites', 114, '2019-04-02', 278, NULL),
('Candlewood Suites', 114, '2019-04-03', 376, NULL),
('Candlewood Suites', 114, '2019-04-04', 171, NULL),
('Candlewood Suites', 114, '2019-04-05', 281, NULL),
('Candlewood Suites', 114, '2019-04-06', 399, NULL),
('Candlewood Suites', 114, '2019-04-07', 364, NULL),
('Candlewood Suites', 114, '2019-04-08', 391, NULL),
('Candlewood Suites', 114, '2019-04-09', 196, NULL),
('Candlewood Suites', 114, '2019-04-10', 300, NULL),
('Candlewood Suites', 114, '2019-04-11', 255, NULL),
('Candlewood Suites', 114, '2019-04-12', 135, NULL),
('Candlewood Suites', 114, '2019-04-13', 200, NULL),
('Candlewood Suites', 114, '2019-04-14', 390, NULL),
('Candlewood Suites', 114, '2019-04-15', 151, NULL),
('Candlewood Suites', 114, '2019-04-16', 368, NULL),
('Candlewood Suites', 114, '2019-04-17', 168, NULL),
('Candlewood Suites', 114, '2019-04-18', 198, NULL),
('Candlewood Suites', 114, '2019-04-19', 132, NULL),
('Candlewood Suites', 114, '2019-04-20', 338, NULL),
('Candlewood Suites', 114, '2019-04-21', 365, NULL),
('Candlewood Suites', 114, '2019-04-22', 387, NULL),
('Candlewood Suites', 114, '2019-04-23', 357, NULL),
('Candlewood Suites', 114, '2019-04-24', 377, NULL),
('Candlewood Suites', 114, '2019-04-25', 319, NULL),
('Candlewood Suites', 114, '2019-04-26', 332, NULL),
('Candlewood Suites', 114, '2019-04-27', 330, NULL),
('Candlewood Suites', 114, '2019-04-28', 270, NULL),
('Candlewood Suites', 114, '2019-04-29', 188, NULL),
('Candlewood Suites', 114, '2019-04-30', 308, NULL),
('Candlewood Suites', 114, '2019-05-01', 299, NULL),
('Candlewood Suites', 114, '2019-05-02', 353, NULL),
('Candlewood Suites', 114, '2019-05-03', 316, NULL),
('Candlewood Suites', 114, '2019-05-04', 246, NULL),
('Candlewood Suites', 114, '2019-05-05', 393, NULL),
('Candlewood Suites', 114, '2019-05-06', 351, NULL),
('Candlewood Suites', 114, '2019-05-07', 255, NULL),
('Candlewood Suites', 114, '2019-05-08', 282, NULL),
('Candlewood Suites', 114, '2019-05-09', 219, NULL),
('Candlewood Suites', 114, '2019-05-10', 394, NULL),
('Candlewood Suites', 114, '2019-05-11', 339, NULL),
('Candlewood Suites', 114, '2019-05-12', 174, NULL),
('Candlewood Suites', 114, '2019-05-13', 221, NULL),
('Candlewood Suites', 114, '2019-05-14', 391, NULL),
('Candlewood Suites', 114, '2019-05-15', 347, NULL),
('Candlewood Suites', 114, '2019-05-16', 175, NULL),
('Candlewood Suites', 114, '2019-05-17', 357, NULL),
('Candlewood Suites', 114, '2019-05-18', 109, NULL),
('Candlewood Suites', 114, '2019-05-19', 109, NULL),
('Candlewood Suites', 114, '2019-05-20', 273, NULL),
('Candlewood Suites', 114, '2019-05-21', 270, NULL),
('Candlewood Suites', 114, '2019-05-22', 149, NULL),
('Candlewood Suites', 114, '2019-05-23', 329, NULL),
('Candlewood Suites', 114, '2019-05-24', 251, NULL),
('Candlewood Suites', 114, '2019-05-25', 134, NULL),
('Candlewood Suites', 114, '2019-05-26', 210, NULL),
('Candlewood Suites', 114, '2019-05-27', 284, NULL),
('Candlewood Suites', 114, '2019-05-28', 184, NULL),
('Candlewood Suites', 114, '2019-05-29', 278, NULL),
('Candlewood Suites', 114, '2019-05-30', 349, NULL),
('Candlewood Suites', 114, '2019-05-31', 312, NULL),
('Candlewood Suites', 114, '2019-06-01', 281, NULL),
('Candlewood Suites', 114, '2019-06-02', 143, NULL),
('Candlewood Suites', 114, '2019-06-03', 139, NULL),
('Candlewood Suites', 114, '2019-06-04', 351, NULL),
('Candlewood Suites', 114, '2019-06-05', 296, NULL),
('Candlewood Suites', 114, '2019-06-06', 155, NULL),
('Candlewood Suites', 114, '2019-06-07', 204, NULL),
('Candlewood Suites', 114, '2019-06-08', 223, NULL),
('Candlewood Suites', 114, '2019-06-09', 162, NULL),
('Candlewood Suites', 114, '2019-06-10', 322, NULL),
('Candlewood Suites', 114, '2019-06-11', 305, NULL),
('Candlewood Suites', 114, '2019-06-12', 225, NULL),
('Candlewood Suites', 114, '2019-06-13', 325, NULL),
('Candlewood Suites', 114, '2019-06-14', 314, NULL),
('Candlewood Suites', 114, '2019-06-15', 215, NULL),
('Candlewood Suites', 114, '2019-06-16', 220, NULL),
('Candlewood Suites', 114, '2019-06-17', 227, NULL),
('Candlewood Suites', 114, '2019-06-18', 186, NULL),
('Candlewood Suites', 114, '2019-06-19', 122, NULL),
('Candlewood Suites', 114, '2019-06-20', 260, NULL),
('Candlewood Suites', 114, '2019-06-21', 245, NULL),
('Candlewood Suites', 114, '2019-06-22', 205, NULL),
('Candlewood Suites', 114, '2019-06-23', 172, NULL),
('Candlewood Suites', 114, '2019-06-24', 396, NULL),
('Candlewood Suites', 114, '2019-06-25', 118, NULL),
('Candlewood Suites', 114, '2019-06-26', 367, NULL),
('Candlewood Suites', 114, '2019-06-27', 255, NULL),
('Candlewood Suites', 114, '2019-06-28', 264, NULL),
('Candlewood Suites', 114, '2019-06-29', 206, NULL),
('Candlewood Suites', 114, '2019-06-30', 206, NULL),
('Candlewood Suites', 114, '2019-07-01', 116, NULL),
('Candlewood Suites', 114, '2019-07-02', 104, NULL),
('Candlewood Suites', 114, '2019-07-03', 281, NULL),
('Candlewood Suites', 114, '2019-07-04', 322, NULL),
('Candlewood Suites', 114, '2019-07-05', 117, NULL),
('Candlewood Suites', 114, '2019-07-06', 252, NULL),
('Candlewood Suites', 114, '2019-07-07', 103, NULL),
('Candlewood Suites', 114, '2019-07-08', 122, NULL),
('Candlewood Suites', 114, '2019-07-09', 399, NULL),
('Candlewood Suites', 114, '2019-07-10', 396, NULL),
('Candlewood Suites', 114, '2019-07-11', 240, NULL),
('Candlewood Suites', 114, '2019-07-12', 231, NULL),
('Candlewood Suites', 114, '2019-07-13', 332, NULL),
('Candlewood Suites', 114, '2019-07-14', 273, NULL),
('Candlewood Suites', 114, '2019-07-15', 327, NULL),
('Candlewood Suites', 114, '2019-07-16', 270, NULL),
('Candlewood Suites', 114, '2019-07-17', 379, NULL),
('Candlewood Suites', 114, '2019-07-18', 308, NULL),
('Candlewood Suites', 114, '2019-07-19', 384, NULL),
('Candlewood Suites', 114, '2019-07-20', 388, NULL),
('Candlewood Suites', 114, '2019-07-21', 197, NULL),
('Candlewood Suites', 114, '2019-07-22', 293, NULL),
('Candlewood Suites', 114, '2019-07-23', 121, NULL),
('Candlewood Suites', 114, '2019-07-24', 284, NULL),
('Candlewood Suites', 114, '2019-07-25', 230, NULL),
('Candlewood Suites', 114, '2019-07-26', 362, NULL),
('Candlewood Suites', 114, '2019-07-27', 152, NULL),
('Candlewood Suites', 114, '2019-07-28', 265, NULL),
('Candlewood Suites', 114, '2019-07-29', 253, NULL),
('Candlewood Suites', 114, '2019-07-30', 381, NULL),
('Candlewood Suites', 114, '2019-07-31', 209, NULL),
('Candlewood Suites', 114, '2019-08-01', 293, NULL),
('Candlewood Suites', 114, '2019-08-02', 393, NULL),
('Candlewood Suites', 114, '2019-08-03', 228, NULL),
('Candlewood Suites', 114, '2019-08-04', 169, NULL),
('Candlewood Suites', 114, '2019-08-05', 376, NULL),
('Candlewood Suites', 114, '2019-08-06', 219, NULL),
('Candlewood Suites', 114, '2019-08-07', 188, NULL),
('Candlewood Suites', 114, '2019-08-08', 179, NULL),
('Candlewood Suites', 114, '2019-08-09', 111, NULL),
('Candlewood Suites', 114, '2019-08-10', 113, NULL),
('Candlewood Suites', 114, '2019-08-11', 267, NULL),
('Candlewood Suites', 114, '2019-08-12', 177, NULL),
('Candlewood Suites', 114, '2019-08-13', 168, NULL),
('Candlewood Suites', 114, '2019-08-14', 293, NULL),
('Candlewood Suites', 114, '2019-08-15', 108, NULL),
('Candlewood Suites', 114, '2019-08-16', 344, NULL),
('Candlewood Suites', 114, '2019-08-17', 311, NULL),
('Candlewood Suites', 114, '2019-08-18', 270, NULL),
('Candlewood Suites', 114, '2019-08-19', 117, NULL),
('Candlewood Suites', 114, '2019-08-20', 197, NULL),
('Candlewood Suites', 114, '2019-08-21', 258, NULL),
('Candlewood Suites', 114, '2019-08-22', 251, NULL),
('Candlewood Suites', 114, '2019-08-23', 183, NULL),
('Candlewood Suites', 114, '2019-08-24', 389, NULL),
('Candlewood Suites', 114, '2019-08-25', 380, NULL),
('Candlewood Suites', 114, '2019-08-26', 303, NULL),
('Candlewood Suites', 114, '2019-08-27', 231, NULL),
('Candlewood Suites', 114, '2019-08-28', 253, NULL),
('Candlewood Suites', 114, '2019-08-29', 340, NULL),
('Candlewood Suites', 114, '2019-08-30', 190, NULL),
('Candlewood Suites', 114, '2019-08-31', 392, NULL),
('Candlewood Suites', 114, '2019-09-01', 230, NULL),
('Candlewood Suites', 114, '2019-09-02', 248, NULL),
('Candlewood Suites', 114, '2019-09-03', 102, NULL),
('Candlewood Suites', 114, '2019-09-04', 382, NULL),
('Candlewood Suites', 114, '2019-09-05', 376, NULL),
('Candlewood Suites', 114, '2019-09-06', 322, NULL),
('Candlewood Suites', 114, '2019-09-07', 237, NULL),
('Candlewood Suites', 114, '2019-09-08', 277, NULL),
('Candlewood Suites', 114, '2019-09-09', 181, NULL),
('Candlewood Suites', 114, '2019-09-10', 204, NULL),
('Candlewood Suites', 114, '2019-09-11', 272, NULL),
('Candlewood Suites', 114, '2019-09-12', 112, NULL),
('Candlewood Suites', 114, '2019-09-13', 105, NULL),
('Candlewood Suites', 114, '2019-09-14', 284, NULL),
('Candlewood Suites', 114, '2019-09-15', 362, NULL),
('Candlewood Suites', 114, '2019-09-16', 360, NULL),
('Candlewood Suites', 114, '2019-09-17', 353, NULL),
('Candlewood Suites', 114, '2019-09-18', 219, NULL),
('Candlewood Suites', 114, '2019-09-19', 248, NULL),
('Candlewood Suites', 114, '2019-09-20', 221, NULL),
('Candlewood Suites', 114, '2019-09-21', 117, NULL),
('Candlewood Suites', 114, '2019-09-22', 120, NULL),
('Candlewood Suites', 114, '2019-09-23', 292, NULL),
('Candlewood Suites', 114, '2019-09-24', 250, NULL),
('Candlewood Suites', 114, '2019-09-25', 334, NULL),
('Candlewood Suites', 114, '2019-09-26', 279, NULL),
('Candlewood Suites', 114, '2019-09-27', 223, NULL),
('Candlewood Suites', 114, '2019-09-28', 345, NULL),
('Candlewood Suites', 114, '2019-09-29', 393, NULL),
('Candlewood Suites', 114, '2019-09-30', 274, NULL),
('Candlewood Suites', 114, '2019-10-01', 147, NULL),
('Candlewood Suites', 114, '2019-10-02', 157, NULL),
('Candlewood Suites', 114, '2019-10-03', 116, NULL),
('Candlewood Suites', 114, '2019-10-04', 145, NULL),
('Candlewood Suites', 114, '2019-10-05', 218, NULL),
('Candlewood Suites', 114, '2019-10-06', 238, NULL),
('Candlewood Suites', 114, '2019-10-07', 372, NULL),
('Candlewood Suites', 114, '2019-10-08', 392, NULL),
('Candlewood Suites', 114, '2019-10-09', 232, NULL),
('Candlewood Suites', 114, '2019-10-10', 392, NULL),
('Candlewood Suites', 114, '2019-10-11', 266, NULL),
('Candlewood Suites', 114, '2019-10-12', 382, NULL),
('Candlewood Suites', 114, '2019-10-13', 110, NULL),
('Candlewood Suites', 114, '2019-10-14', 165, NULL),
('Candlewood Suites', 114, '2019-10-15', 275, NULL),
('Candlewood Suites', 114, '2019-10-16', 180, NULL),
('Candlewood Suites', 114, '2019-10-17', 285, NULL),
('Candlewood Suites', 114, '2019-10-18', 312, NULL),
('Candlewood Suites', 114, '2019-10-19', 171, NULL),
('Candlewood Suites', 114, '2019-10-20', 254, NULL),
('Candlewood Suites', 114, '2019-10-21', 163, NULL),
('Candlewood Suites', 114, '2019-10-22', 260, NULL),
('Candlewood Suites', 114, '2019-10-23', 346, NULL),
('Candlewood Suites', 114, '2019-10-24', 304, NULL),
('Candlewood Suites', 114, '2019-10-25', 325, NULL),
('Candlewood Suites', 114, '2019-10-26', 138, NULL),
('Candlewood Suites', 114, '2019-10-27', 275, NULL),
('Candlewood Suites', 114, '2019-10-28', 219, NULL),
('Candlewood Suites', 114, '2019-10-29', 163, NULL),
('Candlewood Suites', 114, '2019-10-30', 153, NULL),
('Candlewood Suites', 114, '2019-10-31', 316, NULL),
('Candlewood Suites', 114, '2019-11-01', 101, NULL),
('Candlewood Suites', 114, '2019-11-02', 346, NULL),
('Candlewood Suites', 114, '2019-11-03', 329, NULL),
('Candlewood Suites', 114, '2019-11-04', 134, NULL),
('Candlewood Suites', 114, '2019-11-05', 333, NULL),
('Candlewood Suites', 114, '2019-11-06', 367, NULL),
('Candlewood Suites', 114, '2019-11-07', 209, NULL),
('Candlewood Suites', 114, '2019-11-08', 187, NULL),
('Candlewood Suites', 114, '2019-11-09', 207, NULL),
('Candlewood Suites', 114, '2019-11-10', 138, NULL),
('Candlewood Suites', 114, '2019-11-11', 300, NULL),
('Candlewood Suites', 114, '2019-11-12', 253, NULL),
('Candlewood Suites', 114, '2019-11-13', 335, NULL),
('Candlewood Suites', 114, '2019-11-14', 349, NULL),
('Candlewood Suites', 114, '2019-11-15', 204, NULL),
('Candlewood Suites', 114, '2019-11-16', 232, NULL),
('Candlewood Suites', 114, '2019-11-17', 196, NULL),
('Candlewood Suites', 114, '2019-11-18', 301, NULL),
('Candlewood Suites', 114, '2019-11-19', 322, NULL),
('Candlewood Suites', 114, '2019-11-20', 152, NULL),
('Candlewood Suites', 114, '2019-11-21', 218, NULL),
('Candlewood Suites', 114, '2019-11-22', 187, NULL),
('Candlewood Suites', 114, '2019-11-23', 229, NULL),
('Candlewood Suites', 114, '2019-11-24', 326, NULL),
('Candlewood Suites', 114, '2019-11-25', 133, NULL),
('Candlewood Suites', 114, '2019-11-26', 216, NULL),
('Candlewood Suites', 114, '2019-11-27', 312, NULL),
('Candlewood Suites', 114, '2019-11-28', 165, NULL),
('Candlewood Suites', 114, '2019-11-29', 138, NULL),
('Candlewood Suites', 114, '2019-11-30', 123, NULL),
('Candlewood Suites', 114, '2019-12-01', 312, NULL),
('Candlewood Suites', 114, '2019-12-02', 153, NULL),
('Candlewood Suites', 114, '2019-12-03', 259, NULL),
('Candlewood Suites', 114, '2019-12-04', 117, NULL),
('Candlewood Suites', 114, '2019-12-05', 208, NULL),
('Candlewood Suites', 114, '2019-12-06', 271, NULL),
('Candlewood Suites', 114, '2019-12-07', 294, NULL),
('Candlewood Suites', 114, '2019-12-08', 304, NULL),
('Candlewood Suites', 114, '2019-12-09', 205, NULL),
('Candlewood Suites', 114, '2019-12-10', 386, NULL),
('Candlewood Suites', 114, '2019-12-11', 107, NULL),
('Candlewood Suites', 114, '2019-12-12', 101, NULL),
('Candlewood Suites', 114, '2019-12-13', 197, NULL),
('Candlewood Suites', 114, '2019-12-14', 305, NULL),
('Candlewood Suites', 114, '2019-12-15', 271, NULL),
('Candlewood Suites', 114, '2019-12-16', 353, NULL),
('Candlewood Suites', 114, '2019-12-17', 228, NULL),
('Candlewood Suites', 114, '2019-12-18', 256, NULL),
('Candlewood Suites', 114, '2019-12-19', 207, NULL),
('Candlewood Suites', 114, '2019-12-20', 322, NULL),
('Candlewood Suites', 114, '2019-12-21', 184, NULL),
('Candlewood Suites', 114, '2019-12-22', 258, NULL),
('Candlewood Suites', 114, '2019-12-23', 279, NULL),
('Candlewood Suites', 114, '2019-12-24', 358, NULL),
('Candlewood Suites', 114, '2019-12-25', 298, NULL),
('Candlewood Suites', 114, '2019-12-26', 213, NULL),
('Candlewood Suites', 114, '2019-12-27', 226, NULL),
('Candlewood Suites', 114, '2019-12-28', 233, NULL),
('Candlewood Suites', 114, '2019-12-29', 145, NULL),
('Candlewood Suites', 114, '2019-12-30', 172, NULL),
('Candlewood Suites', 114, '2019-12-31', 228, NULL),
('Candlewood Suites', 114, '2020-01-01', 379, NULL),
('Candlewood Suites', 114, '2020-01-02', 108, NULL),
('Candlewood Suites', 114, '2020-01-03', 247, NULL),
('Candlewood Suites', 114, '2020-01-04', 398, NULL),
('Candlewood Suites', 114, '2020-01-05', 228, NULL),
('Candlewood Suites', 114, '2020-01-06', 206, NULL),
('Candlewood Suites', 114, '2020-01-07', 251, NULL),
('Candlewood Suites', 114, '2020-01-08', 302, NULL),
('Candlewood Suites', 114, '2020-01-09', 113, NULL),
('Candlewood Suites', 114, '2020-01-10', 158, NULL),
('Candlewood Suites', 114, '2020-01-11', 168, NULL),
('Candlewood Suites', 114, '2020-01-12', 364, NULL),
('Candlewood Suites', 114, '2020-01-13', 195, NULL),
('Candlewood Suites', 114, '2020-01-14', 370, NULL),
('Candlewood Suites', 114, '2020-01-15', 208, NULL),
('Candlewood Suites', 114, '2020-01-16', 190, NULL),
('Candlewood Suites', 114, '2020-01-17', 245, NULL),
('Candlewood Suites', 114, '2020-01-18', 365, NULL),
('Candlewood Suites', 114, '2020-01-19', 306, NULL),
('Candlewood Suites', 114, '2020-01-20', 138, NULL),
('Candlewood Suites', 114, '2020-01-21', 383, NULL),
('Candlewood Suites', 114, '2020-01-22', 231, NULL),
('Candlewood Suites', 114, '2020-01-23', 301, NULL),
('Candlewood Suites', 114, '2020-01-24', 391, NULL),
('Candlewood Suites', 114, '2020-01-25', 136, NULL),
('Candlewood Suites', 114, '2020-01-26', 348, NULL),
('Candlewood Suites', 114, '2020-01-27', 291, NULL),
('Candlewood Suites', 114, '2020-01-28', 336, NULL),
('Candlewood Suites', 114, '2020-01-29', 202, NULL),
('Candlewood Suites', 114, '2020-01-30', 185, NULL),
('Candlewood Suites', 114, '2020-01-31', 154, NULL),
('Candlewood Suites', 114, '2020-02-01', 286, NULL),
('Candlewood Suites', 114, '2020-02-02', 278, NULL),
('Candlewood Suites', 114, '2020-02-03', 169, NULL),
('Candlewood Suites', 114, '2020-02-04', 282, NULL),
('Candlewood Suites', 133, '2019-01-01', 274, NULL),
('Candlewood Suites', 133, '2019-01-02', 350, NULL),
('Candlewood Suites', 133, '2019-01-03', 376, NULL),
('Candlewood Suites', 133, '2019-01-04', 153, NULL),
('Candlewood Suites', 133, '2019-01-05', 375, NULL),
('Candlewood Suites', 133, '2019-01-06', 174, NULL),
('Candlewood Suites', 133, '2019-01-07', 337, NULL),
('Candlewood Suites', 133, '2019-01-08', 361, NULL),
('Candlewood Suites', 133, '2019-01-09', 281, NULL),
('Candlewood Suites', 133, '2019-01-10', 246, NULL),
('Candlewood Suites', 133, '2019-01-11', 146, NULL),
('Candlewood Suites', 133, '2019-01-12', 298, NULL),
('Candlewood Suites', 133, '2019-01-13', 275, NULL),
('Candlewood Suites', 133, '2019-01-14', 143, NULL),
('Candlewood Suites', 133, '2019-01-15', 146, NULL),
('Candlewood Suites', 133, '2019-01-16', 256, NULL),
('Candlewood Suites', 133, '2019-01-17', 175, NULL),
('Candlewood Suites', 133, '2019-01-18', 120, NULL),
('Candlewood Suites', 133, '2019-01-19', 180, NULL),
('Candlewood Suites', 133, '2019-01-20', 159, NULL),
('Candlewood Suites', 133, '2019-01-21', 231, NULL),
('Candlewood Suites', 133, '2019-01-22', 382, NULL),
('Candlewood Suites', 133, '2019-01-23', 308, NULL),
('Candlewood Suites', 133, '2019-01-24', 151, NULL),
('Candlewood Suites', 133, '2019-01-25', 258, NULL),
('Candlewood Suites', 133, '2019-01-26', 134, NULL),
('Candlewood Suites', 133, '2019-01-27', 368, NULL),
('Candlewood Suites', 133, '2019-01-28', 308, NULL),
('Candlewood Suites', 133, '2019-01-29', 143, NULL),
('Candlewood Suites', 133, '2019-01-30', 393, NULL),
('Candlewood Suites', 133, '2019-01-31', 389, NULL),
('Candlewood Suites', 133, '2019-02-01', 181, NULL),
('Candlewood Suites', 133, '2019-02-02', 334, NULL),
('Candlewood Suites', 133, '2019-02-03', 374, NULL),
('Candlewood Suites', 133, '2019-02-04', 344, NULL),
('Candlewood Suites', 133, '2019-02-05', 280, NULL),
('Candlewood Suites', 133, '2019-02-06', 132, NULL),
('Candlewood Suites', 133, '2019-02-07', 282, NULL),
('Candlewood Suites', 133, '2019-02-08', 263, NULL),
('Candlewood Suites', 133, '2019-02-09', 128, NULL),
('Candlewood Suites', 133, '2019-02-10', 357, NULL),
('Candlewood Suites', 133, '2019-02-11', 288, NULL),
('Candlewood Suites', 133, '2019-02-12', 150, NULL),
('Candlewood Suites', 133, '2019-02-13', 160, NULL),
('Candlewood Suites', 133, '2019-02-14', 133, NULL),
('Candlewood Suites', 133, '2019-02-15', 155, NULL),
('Candlewood Suites', 133, '2019-02-16', 115, NULL),
('Candlewood Suites', 133, '2019-02-17', 174, NULL),
('Candlewood Suites', 133, '2019-02-18', 379, NULL),
('Candlewood Suites', 133, '2019-02-19', 319, NULL),
('Candlewood Suites', 133, '2019-02-20', 234, NULL),
('Candlewood Suites', 133, '2019-02-21', 277, NULL),
('Candlewood Suites', 133, '2019-02-22', 396, NULL),
('Candlewood Suites', 133, '2019-02-23', 368, NULL),
('Candlewood Suites', 133, '2019-02-24', 205, NULL),
('Candlewood Suites', 133, '2019-02-25', 344, NULL),
('Candlewood Suites', 133, '2019-02-26', 166, NULL),
('Candlewood Suites', 133, '2019-02-27', 342, NULL),
('Candlewood Suites', 133, '2019-02-28', 110, NULL),
('Candlewood Suites', 133, '2019-03-01', 214, NULL),
('Candlewood Suites', 133, '2019-03-02', 271, NULL),
('Candlewood Suites', 133, '2019-03-03', 294, NULL),
('Candlewood Suites', 133, '2019-03-04', 332, NULL),
('Candlewood Suites', 133, '2019-03-05', 252, NULL),
('Candlewood Suites', 133, '2019-03-06', 387, NULL),
('Candlewood Suites', 133, '2019-03-07', 303, NULL),
('Candlewood Suites', 133, '2019-03-08', 111, NULL),
('Candlewood Suites', 133, '2019-03-09', 222, NULL),
('Candlewood Suites', 133, '2019-03-10', 151, NULL),
('Candlewood Suites', 133, '2019-03-11', 152, NULL),
('Candlewood Suites', 133, '2019-03-12', 211, NULL),
('Candlewood Suites', 133, '2019-03-13', 324, NULL),
('Candlewood Suites', 133, '2019-03-14', 235, NULL),
('Candlewood Suites', 133, '2019-03-15', 351, NULL),
('Candlewood Suites', 133, '2019-03-16', 276, NULL),
('Candlewood Suites', 133, '2019-03-17', 352, NULL),
('Candlewood Suites', 133, '2019-03-18', 387, NULL),
('Candlewood Suites', 133, '2019-03-19', 125, NULL),
('Candlewood Suites', 133, '2019-03-20', 162, NULL),
('Candlewood Suites', 133, '2019-03-21', 345, NULL),
('Candlewood Suites', 133, '2019-03-22', 268, NULL),
('Candlewood Suites', 133, '2019-03-23', 206, NULL),
('Candlewood Suites', 133, '2019-03-24', 367, NULL),
('Candlewood Suites', 133, '2019-03-25', 391, NULL),
('Candlewood Suites', 133, '2019-03-26', 226, NULL),
('Candlewood Suites', 133, '2019-03-27', 236, NULL),
('Candlewood Suites', 133, '2019-03-28', 146, NULL),
('Candlewood Suites', 133, '2019-03-29', 318, NULL),
('Candlewood Suites', 133, '2019-03-30', 345, NULL),
('Candlewood Suites', 133, '2019-03-31', 324, NULL),
('Candlewood Suites', 133, '2019-04-01', 337, NULL),
('Candlewood Suites', 133, '2019-04-02', 143, NULL),
('Candlewood Suites', 133, '2019-04-03', 350, NULL),
('Candlewood Suites', 133, '2019-04-04', 102, NULL),
('Candlewood Suites', 133, '2019-04-05', 181, NULL),
('Candlewood Suites', 133, '2019-04-06', 325, NULL),
('Candlewood Suites', 133, '2019-04-07', 161, NULL),
('Candlewood Suites', 133, '2019-04-08', 362, NULL),
('Candlewood Suites', 133, '2019-04-09', 200, NULL),
('Candlewood Suites', 133, '2019-04-10', 242, NULL),
('Candlewood Suites', 133, '2019-04-11', 353, NULL),
('Candlewood Suites', 133, '2019-04-12', 251, NULL),
('Candlewood Suites', 133, '2019-04-13', 160, NULL),
('Candlewood Suites', 133, '2019-04-14', 200, NULL),
('Candlewood Suites', 133, '2019-04-15', 372, NULL),
('Candlewood Suites', 133, '2019-04-16', 247, NULL),
('Candlewood Suites', 133, '2019-04-17', 105, NULL),
('Candlewood Suites', 133, '2019-04-18', 325, NULL),
('Candlewood Suites', 133, '2019-04-19', 378, NULL),
('Candlewood Suites', 133, '2019-04-20', 252, NULL),
('Candlewood Suites', 133, '2019-04-21', 137, NULL),
('Candlewood Suites', 133, '2019-04-22', 147, NULL),
('Candlewood Suites', 133, '2019-04-23', 152, NULL),
('Candlewood Suites', 133, '2019-04-24', 393, NULL),
('Candlewood Suites', 133, '2019-04-25', 391, NULL),
('Candlewood Suites', 133, '2019-04-26', 342, NULL),
('Candlewood Suites', 133, '2019-04-27', 300, NULL),
('Candlewood Suites', 133, '2019-04-28', 140, NULL),
('Candlewood Suites', 133, '2019-04-29', 307, NULL),
('Candlewood Suites', 133, '2019-04-30', 110, NULL),
('Candlewood Suites', 133, '2019-05-01', 141, NULL),
('Candlewood Suites', 133, '2019-05-02', 332, NULL),
('Candlewood Suites', 133, '2019-05-03', 381, NULL),
('Candlewood Suites', 133, '2019-05-04', 282, NULL),
('Candlewood Suites', 133, '2019-05-05', 125, NULL),
('Candlewood Suites', 133, '2019-05-06', 374, NULL),
('Candlewood Suites', 133, '2019-05-07', 184, NULL),
('Candlewood Suites', 133, '2019-05-08', 324, NULL),
('Candlewood Suites', 133, '2019-05-09', 111, NULL),
('Candlewood Suites', 133, '2019-05-10', 273, NULL),
('Candlewood Suites', 133, '2019-05-11', 331, NULL),
('Candlewood Suites', 133, '2019-05-12', 275, NULL),
('Candlewood Suites', 133, '2019-05-13', 364, NULL),
('Candlewood Suites', 133, '2019-05-14', 111, NULL),
('Candlewood Suites', 133, '2019-05-15', 161, NULL),
('Candlewood Suites', 133, '2019-05-16', 228, NULL),
('Candlewood Suites', 133, '2019-05-17', 132, NULL),
('Candlewood Suites', 133, '2019-05-18', 384, NULL),
('Candlewood Suites', 133, '2019-05-19', 127, NULL),
('Candlewood Suites', 133, '2019-05-20', 338, NULL),
('Candlewood Suites', 133, '2019-05-21', 251, NULL),
('Candlewood Suites', 133, '2019-05-22', 306, NULL),
('Candlewood Suites', 133, '2019-05-23', 341, NULL),
('Candlewood Suites', 133, '2019-05-24', 152, NULL),
('Candlewood Suites', 133, '2019-05-25', 309, NULL),
('Candlewood Suites', 133, '2019-05-26', 138, NULL),
('Candlewood Suites', 133, '2019-05-27', 384, NULL),
('Candlewood Suites', 133, '2019-05-28', 122, NULL),
('Candlewood Suites', 133, '2019-05-29', 277, NULL),
('Candlewood Suites', 133, '2019-05-30', 235, NULL),
('Candlewood Suites', 133, '2019-05-31', 383, NULL),
('Candlewood Suites', 133, '2019-06-01', 397, NULL),
('Candlewood Suites', 133, '2019-06-02', 170, NULL),
('Candlewood Suites', 133, '2019-06-03', 144, NULL),
('Candlewood Suites', 133, '2019-06-04', 276, NULL),
('Candlewood Suites', 133, '2019-06-05', 380, NULL),
('Candlewood Suites', 133, '2019-06-06', 347, NULL),
('Candlewood Suites', 133, '2019-06-07', 234, NULL),
('Candlewood Suites', 133, '2019-06-08', 155, NULL),
('Candlewood Suites', 133, '2019-06-09', 169, NULL),
('Candlewood Suites', 133, '2019-06-10', 385, NULL),
('Candlewood Suites', 133, '2019-06-11', 313, NULL),
('Candlewood Suites', 133, '2019-06-12', 327, NULL),
('Candlewood Suites', 133, '2019-06-13', 350, NULL),
('Candlewood Suites', 133, '2019-06-14', 273, NULL),
('Candlewood Suites', 133, '2019-06-15', 182, NULL),
('Candlewood Suites', 133, '2019-06-16', 122, NULL),
('Candlewood Suites', 133, '2019-06-17', 206, NULL),
('Candlewood Suites', 133, '2019-06-18', 229, NULL),
('Candlewood Suites', 133, '2019-06-19', 187, NULL),
('Candlewood Suites', 133, '2019-06-20', 206, NULL),
('Candlewood Suites', 133, '2019-06-21', 342, NULL),
('Candlewood Suites', 133, '2019-06-22', 372, NULL),
('Candlewood Suites', 133, '2019-06-23', 338, NULL),
('Candlewood Suites', 133, '2019-06-24', 218, NULL),
('Candlewood Suites', 133, '2019-06-25', 259, NULL),
('Candlewood Suites', 133, '2019-06-26', 152, NULL),
('Candlewood Suites', 133, '2019-06-27', 332, NULL),
('Candlewood Suites', 133, '2019-06-28', 187, NULL),
('Candlewood Suites', 133, '2019-06-29', 183, NULL),
('Candlewood Suites', 133, '2019-06-30', 289, NULL),
('Candlewood Suites', 133, '2019-07-01', 167, NULL),
('Candlewood Suites', 133, '2019-07-02', 129, NULL),
('Candlewood Suites', 133, '2019-07-03', 188, NULL),
('Candlewood Suites', 133, '2019-07-04', 168, NULL),
('Candlewood Suites', 133, '2019-07-05', 163, NULL),
('Candlewood Suites', 133, '2019-07-06', 319, NULL),
('Candlewood Suites', 133, '2019-07-07', 127, NULL),
('Candlewood Suites', 133, '2019-07-08', 275, NULL),
('Candlewood Suites', 133, '2019-07-09', 114, NULL),
('Candlewood Suites', 133, '2019-07-10', 329, NULL),
('Candlewood Suites', 133, '2019-07-11', 117, NULL),
('Candlewood Suites', 133, '2019-07-12', 245, NULL),
('Candlewood Suites', 133, '2019-07-13', 280, NULL),
('Candlewood Suites', 133, '2019-07-14', 266, NULL),
('Candlewood Suites', 133, '2019-07-15', 353, NULL),
('Candlewood Suites', 133, '2019-07-16', 234, NULL),
('Candlewood Suites', 133, '2019-07-17', 147, NULL),
('Candlewood Suites', 133, '2019-07-18', 350, NULL),
('Candlewood Suites', 133, '2019-07-19', 246, NULL),
('Candlewood Suites', 133, '2019-07-20', 366, NULL),
('Candlewood Suites', 133, '2019-07-21', 322, NULL),
('Candlewood Suites', 133, '2019-07-22', 339, NULL),
('Candlewood Suites', 133, '2019-07-23', 102, NULL),
('Candlewood Suites', 133, '2019-07-24', 357, NULL),
('Candlewood Suites', 133, '2019-07-25', 149, NULL),
('Candlewood Suites', 133, '2019-07-26', 251, NULL),
('Candlewood Suites', 133, '2019-07-27', 216, NULL),
('Candlewood Suites', 133, '2019-07-28', 198, NULL),
('Candlewood Suites', 133, '2019-07-29', 115, NULL),
('Candlewood Suites', 133, '2019-07-30', 274, NULL),
('Candlewood Suites', 133, '2019-07-31', 273, NULL),
('Candlewood Suites', 133, '2019-08-01', 217, NULL),
('Candlewood Suites', 133, '2019-08-02', 100, NULL),
('Candlewood Suites', 133, '2019-08-03', 323, NULL),
('Candlewood Suites', 133, '2019-08-04', 356, NULL),
('Candlewood Suites', 133, '2019-08-05', 295, NULL),
('Candlewood Suites', 133, '2019-08-06', 235, NULL),
('Candlewood Suites', 133, '2019-08-07', 235, NULL),
('Candlewood Suites', 133, '2019-08-08', 295, NULL),
('Candlewood Suites', 133, '2019-08-09', 326, NULL),
('Candlewood Suites', 133, '2019-08-10', 257, NULL),
('Candlewood Suites', 133, '2019-08-11', 115, NULL),
('Candlewood Suites', 133, '2019-08-12', 344, NULL),
('Candlewood Suites', 133, '2019-08-13', 267, NULL),
('Candlewood Suites', 133, '2019-08-14', 215, NULL),
('Candlewood Suites', 133, '2019-08-15', 148, NULL),
('Candlewood Suites', 133, '2019-08-16', 346, NULL),
('Candlewood Suites', 133, '2019-08-17', 218, NULL),
('Candlewood Suites', 133, '2019-08-18', 206, NULL),
('Candlewood Suites', 133, '2019-08-19', 131, NULL),
('Candlewood Suites', 133, '2019-08-20', 166, NULL),
('Candlewood Suites', 133, '2019-08-21', 273, NULL),
('Candlewood Suites', 133, '2019-08-22', 204, NULL),
('Candlewood Suites', 133, '2019-08-23', 101, NULL),
('Candlewood Suites', 133, '2019-08-24', 147, NULL),
('Candlewood Suites', 133, '2019-08-25', 234, NULL),
('Candlewood Suites', 133, '2019-08-26', 290, NULL),
('Candlewood Suites', 133, '2019-08-27', 281, NULL),
('Candlewood Suites', 133, '2019-08-28', 277, NULL),
('Candlewood Suites', 133, '2019-08-29', 319, NULL),
('Candlewood Suites', 133, '2019-08-30', 192, NULL),
('Candlewood Suites', 133, '2019-08-31', 354, NULL),
('Candlewood Suites', 133, '2019-09-01', 387, NULL),
('Candlewood Suites', 133, '2019-09-02', 171, NULL),
('Candlewood Suites', 133, '2019-09-03', 245, NULL),
('Candlewood Suites', 133, '2019-09-04', 389, NULL),
('Candlewood Suites', 133, '2019-09-05', 246, NULL),
('Candlewood Suites', 133, '2019-09-06', 377, NULL),
('Candlewood Suites', 133, '2019-09-07', 185, NULL),
('Candlewood Suites', 133, '2019-09-08', 390, NULL),
('Candlewood Suites', 133, '2019-09-09', 261, NULL),
('Candlewood Suites', 133, '2019-09-10', 272, NULL),
('Candlewood Suites', 133, '2019-09-11', 350, NULL),
('Candlewood Suites', 133, '2019-09-12', 214, NULL),
('Candlewood Suites', 133, '2019-09-13', 217, NULL),
('Candlewood Suites', 133, '2019-09-14', 191, NULL),
('Candlewood Suites', 133, '2019-09-15', 174, NULL),
('Candlewood Suites', 133, '2019-09-16', 355, NULL),
('Candlewood Suites', 133, '2019-09-17', 229, NULL),
('Candlewood Suites', 133, '2019-09-18', 374, NULL),
('Candlewood Suites', 133, '2019-09-19', 290, NULL),
('Candlewood Suites', 133, '2019-09-20', 291, NULL),
('Candlewood Suites', 133, '2019-09-21', 169, NULL),
('Candlewood Suites', 133, '2019-09-22', 219, NULL),
('Candlewood Suites', 133, '2019-09-23', 255, NULL),
('Candlewood Suites', 133, '2019-09-24', 257, NULL),
('Candlewood Suites', 133, '2019-09-25', 159, NULL),
('Candlewood Suites', 133, '2019-09-26', 343, NULL),
('Candlewood Suites', 133, '2019-09-27', 394, NULL),
('Candlewood Suites', 133, '2019-09-28', 344, NULL),
('Candlewood Suites', 133, '2019-09-29', 293, NULL),
('Candlewood Suites', 133, '2019-09-30', 150, NULL),
('Candlewood Suites', 133, '2019-10-01', 123, NULL),
('Candlewood Suites', 133, '2019-10-02', 183, NULL),
('Candlewood Suites', 133, '2019-10-03', 288, NULL),
('Candlewood Suites', 133, '2019-10-04', 112, NULL),
('Candlewood Suites', 133, '2019-10-05', 313, NULL),
('Candlewood Suites', 133, '2019-10-06', 263, NULL),
('Candlewood Suites', 133, '2019-10-07', 399, NULL),
('Candlewood Suites', 133, '2019-10-08', 281, NULL),
('Candlewood Suites', 133, '2019-10-09', 114, NULL),
('Candlewood Suites', 133, '2019-10-10', 234, NULL),
('Candlewood Suites', 133, '2019-10-11', 157, NULL),
('Candlewood Suites', 133, '2019-10-12', 179, NULL),
('Candlewood Suites', 133, '2019-10-13', 307, NULL),
('Candlewood Suites', 133, '2019-10-14', 308, NULL),
('Candlewood Suites', 133, '2019-10-15', 391, NULL),
('Candlewood Suites', 133, '2019-10-16', 296, NULL),
('Candlewood Suites', 133, '2019-10-17', 150, NULL),
('Candlewood Suites', 133, '2019-10-18', 182, NULL),
('Candlewood Suites', 133, '2019-10-19', 248, NULL),
('Candlewood Suites', 133, '2019-10-20', 202, NULL),
('Candlewood Suites', 133, '2019-10-21', 291, NULL),
('Candlewood Suites', 133, '2019-10-22', 380, NULL),
('Candlewood Suites', 133, '2019-10-23', 296, NULL),
('Candlewood Suites', 133, '2019-10-24', 361, NULL),
('Candlewood Suites', 133, '2019-10-25', 322, NULL),
('Candlewood Suites', 133, '2019-10-26', 340, NULL),
('Candlewood Suites', 133, '2019-10-27', 139, NULL),
('Candlewood Suites', 133, '2019-10-28', 224, NULL),
('Candlewood Suites', 133, '2019-10-29', 290, NULL),
('Candlewood Suites', 133, '2019-10-30', 153, NULL),
('Candlewood Suites', 133, '2019-10-31', 266, NULL),
('Candlewood Suites', 133, '2019-11-01', 390, NULL),
('Candlewood Suites', 133, '2019-11-02', 241, NULL),
('Candlewood Suites', 133, '2019-11-03', 199, NULL),
('Candlewood Suites', 133, '2019-11-04', 222, NULL),
('Candlewood Suites', 133, '2019-11-05', 191, NULL),
('Candlewood Suites', 133, '2019-11-06', 214, NULL),
('Candlewood Suites', 133, '2019-11-07', 222, NULL),
('Candlewood Suites', 133, '2019-11-08', 131, NULL),
('Candlewood Suites', 133, '2019-11-09', 215, NULL),
('Candlewood Suites', 133, '2019-11-10', 373, NULL),
('Candlewood Suites', 133, '2019-11-11', 209, NULL),
('Candlewood Suites', 133, '2019-11-12', 391, NULL),
('Candlewood Suites', 133, '2019-11-13', 190, NULL),
('Candlewood Suites', 133, '2019-11-14', 277, NULL),
('Candlewood Suites', 133, '2019-11-15', 266, NULL),
('Candlewood Suites', 133, '2019-11-16', 182, NULL),
('Candlewood Suites', 133, '2019-11-17', 306, NULL),
('Candlewood Suites', 133, '2019-11-18', 281, NULL),
('Candlewood Suites', 133, '2019-11-19', 122, NULL),
('Candlewood Suites', 133, '2019-11-20', 344, NULL),
('Candlewood Suites', 133, '2019-11-21', 181, NULL),
('Candlewood Suites', 133, '2019-11-22', 388, NULL),
('Candlewood Suites', 133, '2019-11-23', 374, NULL),
('Candlewood Suites', 133, '2019-11-24', 359, NULL),
('Candlewood Suites', 133, '2019-11-25', 222, NULL),
('Candlewood Suites', 133, '2019-11-26', 386, NULL),
('Candlewood Suites', 133, '2019-11-27', 124, NULL),
('Candlewood Suites', 133, '2019-11-28', 263, NULL),
('Candlewood Suites', 133, '2019-11-29', 184, NULL),
('Candlewood Suites', 133, '2019-11-30', 359, NULL),
('Candlewood Suites', 133, '2019-12-01', 323, NULL),
('Candlewood Suites', 133, '2019-12-02', 370, NULL),
('Candlewood Suites', 133, '2019-12-03', 258, NULL),
('Candlewood Suites', 133, '2019-12-04', 226, NULL),
('Candlewood Suites', 133, '2019-12-05', 142, NULL),
('Candlewood Suites', 133, '2019-12-06', 131, NULL),
('Candlewood Suites', 133, '2019-12-07', 225, NULL),
('Candlewood Suites', 133, '2019-12-08', 327, NULL),
('Candlewood Suites', 133, '2019-12-09', 136, NULL),
('Candlewood Suites', 133, '2019-12-10', 173, NULL),
('Candlewood Suites', 133, '2019-12-11', 295, NULL),
('Candlewood Suites', 133, '2019-12-12', 158, NULL),
('Candlewood Suites', 133, '2019-12-13', 258, NULL),
('Candlewood Suites', 133, '2019-12-14', 333, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 133, '2019-12-15', 312, NULL),
('Candlewood Suites', 133, '2019-12-16', 116, NULL),
('Candlewood Suites', 133, '2019-12-17', 200, NULL),
('Candlewood Suites', 133, '2019-12-18', 306, NULL),
('Candlewood Suites', 133, '2019-12-19', 320, NULL),
('Candlewood Suites', 133, '2019-12-20', 160, NULL),
('Candlewood Suites', 133, '2019-12-21', 189, NULL),
('Candlewood Suites', 133, '2019-12-22', 255, NULL),
('Candlewood Suites', 133, '2019-12-23', 167, NULL),
('Candlewood Suites', 133, '2019-12-24', 127, NULL),
('Candlewood Suites', 133, '2019-12-25', 280, NULL),
('Candlewood Suites', 133, '2019-12-26', 275, NULL),
('Candlewood Suites', 133, '2019-12-27', 358, NULL),
('Candlewood Suites', 133, '2019-12-28', 393, NULL),
('Candlewood Suites', 133, '2019-12-29', 209, NULL),
('Candlewood Suites', 133, '2019-12-30', 107, NULL),
('Candlewood Suites', 133, '2019-12-31', 270, NULL),
('Candlewood Suites', 133, '2020-01-01', 253, NULL),
('Candlewood Suites', 133, '2020-01-02', 144, NULL),
('Candlewood Suites', 133, '2020-01-03', 217, NULL),
('Candlewood Suites', 133, '2020-01-04', 342, NULL),
('Candlewood Suites', 133, '2020-01-05', 357, NULL),
('Candlewood Suites', 133, '2020-01-06', 294, NULL),
('Candlewood Suites', 133, '2020-01-07', 313, NULL),
('Candlewood Suites', 133, '2020-01-08', 147, NULL),
('Candlewood Suites', 133, '2020-01-09', 189, NULL),
('Candlewood Suites', 133, '2020-01-10', 119, NULL),
('Candlewood Suites', 133, '2020-01-11', 386, NULL),
('Candlewood Suites', 133, '2020-01-12', 374, NULL),
('Candlewood Suites', 133, '2020-01-13', 211, NULL),
('Candlewood Suites', 133, '2020-01-14', 386, NULL),
('Candlewood Suites', 133, '2020-01-15', 199, NULL),
('Candlewood Suites', 133, '2020-01-16', 186, NULL),
('Candlewood Suites', 133, '2020-01-17', 368, NULL),
('Candlewood Suites', 133, '2020-01-18', 159, NULL),
('Candlewood Suites', 133, '2020-01-19', 203, NULL),
('Candlewood Suites', 133, '2020-01-20', 282, NULL),
('Candlewood Suites', 133, '2020-01-21', 327, NULL),
('Candlewood Suites', 133, '2020-01-22', 124, NULL),
('Candlewood Suites', 133, '2020-01-23', 206, NULL),
('Candlewood Suites', 133, '2020-01-24', 242, NULL),
('Candlewood Suites', 133, '2020-01-25', 115, NULL),
('Candlewood Suites', 133, '2020-01-26', 149, NULL),
('Candlewood Suites', 133, '2020-01-27', 133, NULL),
('Candlewood Suites', 133, '2020-01-28', 394, NULL),
('Candlewood Suites', 133, '2020-01-29', 142, NULL),
('Candlewood Suites', 133, '2020-01-30', 273, NULL),
('Candlewood Suites', 133, '2020-01-31', 172, NULL),
('Candlewood Suites', 133, '2020-02-01', 260, NULL),
('Candlewood Suites', 133, '2020-02-02', 207, NULL),
('Candlewood Suites', 133, '2020-02-03', 173, NULL),
('Candlewood Suites', 133, '2020-02-04', 329, NULL),
('Candlewood Suites', 134, '2019-01-01', 143, NULL),
('Candlewood Suites', 134, '2019-01-02', 299, NULL),
('Candlewood Suites', 134, '2019-01-03', 135, NULL),
('Candlewood Suites', 134, '2019-01-04', 137, NULL),
('Candlewood Suites', 134, '2019-01-05', 352, NULL),
('Candlewood Suites', 134, '2019-01-06', 302, NULL),
('Candlewood Suites', 134, '2019-01-07', 148, NULL),
('Candlewood Suites', 134, '2019-01-08', 191, NULL),
('Candlewood Suites', 134, '2019-01-09', 244, NULL),
('Candlewood Suites', 134, '2019-01-10', 129, NULL),
('Candlewood Suites', 134, '2019-01-11', 127, NULL),
('Candlewood Suites', 134, '2019-01-12', 189, NULL),
('Candlewood Suites', 134, '2019-01-13', 386, NULL),
('Candlewood Suites', 134, '2019-01-14', 265, NULL),
('Candlewood Suites', 134, '2019-01-15', 294, NULL),
('Candlewood Suites', 134, '2019-01-16', 207, NULL),
('Candlewood Suites', 134, '2019-01-17', 237, NULL),
('Candlewood Suites', 134, '2019-01-18', 384, NULL),
('Candlewood Suites', 134, '2019-01-19', 282, NULL),
('Candlewood Suites', 134, '2019-01-20', 250, NULL),
('Candlewood Suites', 134, '2019-01-21', 373, NULL),
('Candlewood Suites', 134, '2019-01-22', 155, NULL),
('Candlewood Suites', 134, '2019-01-23', 107, NULL),
('Candlewood Suites', 134, '2019-01-24', 324, NULL),
('Candlewood Suites', 134, '2019-01-25', 127, NULL),
('Candlewood Suites', 134, '2019-01-26', 213, NULL),
('Candlewood Suites', 134, '2019-01-27', 371, NULL),
('Candlewood Suites', 134, '2019-01-28', 298, NULL),
('Candlewood Suites', 134, '2019-01-29', 279, NULL),
('Candlewood Suites', 134, '2019-01-30', 208, NULL),
('Candlewood Suites', 134, '2019-01-31', 122, NULL),
('Candlewood Suites', 134, '2019-02-01', 306, NULL),
('Candlewood Suites', 134, '2019-02-02', 253, NULL),
('Candlewood Suites', 134, '2019-02-03', 168, NULL),
('Candlewood Suites', 134, '2019-02-04', 270, NULL),
('Candlewood Suites', 134, '2019-02-05', 147, NULL),
('Candlewood Suites', 134, '2019-02-06', 331, NULL),
('Candlewood Suites', 134, '2019-02-07', 190, NULL),
('Candlewood Suites', 134, '2019-02-08', 261, NULL),
('Candlewood Suites', 134, '2019-02-09', 119, NULL),
('Candlewood Suites', 134, '2019-02-10', 328, NULL),
('Candlewood Suites', 134, '2019-02-11', 169, NULL),
('Candlewood Suites', 134, '2019-02-12', 285, NULL),
('Candlewood Suites', 134, '2019-02-13', 142, NULL),
('Candlewood Suites', 134, '2019-02-14', 317, NULL),
('Candlewood Suites', 134, '2019-02-15', 262, NULL),
('Candlewood Suites', 134, '2019-02-16', 156, NULL),
('Candlewood Suites', 134, '2019-02-17', 193, NULL),
('Candlewood Suites', 134, '2019-02-18', 199, NULL),
('Candlewood Suites', 134, '2019-02-19', 172, NULL),
('Candlewood Suites', 134, '2019-02-20', 128, NULL),
('Candlewood Suites', 134, '2019-02-21', 115, NULL),
('Candlewood Suites', 134, '2019-02-22', 167, NULL),
('Candlewood Suites', 134, '2019-02-23', 285, NULL),
('Candlewood Suites', 134, '2019-02-24', 342, NULL),
('Candlewood Suites', 134, '2019-02-25', 213, NULL),
('Candlewood Suites', 134, '2019-02-26', 279, NULL),
('Candlewood Suites', 134, '2019-02-27', 305, NULL),
('Candlewood Suites', 134, '2019-02-28', 121, NULL),
('Candlewood Suites', 134, '2019-03-01', 136, NULL),
('Candlewood Suites', 134, '2019-03-02', 147, NULL),
('Candlewood Suites', 134, '2019-03-03', 106, NULL),
('Candlewood Suites', 134, '2019-03-04', 287, NULL),
('Candlewood Suites', 134, '2019-03-05', 241, NULL),
('Candlewood Suites', 134, '2019-03-06', 209, NULL),
('Candlewood Suites', 134, '2019-03-07', 154, NULL),
('Candlewood Suites', 134, '2019-03-08', 164, NULL),
('Candlewood Suites', 134, '2019-03-09', 189, NULL),
('Candlewood Suites', 134, '2019-03-10', 200, NULL),
('Candlewood Suites', 134, '2019-03-11', 288, NULL),
('Candlewood Suites', 134, '2019-03-12', 294, NULL),
('Candlewood Suites', 134, '2019-03-13', 358, NULL),
('Candlewood Suites', 134, '2019-03-14', 266, NULL),
('Candlewood Suites', 134, '2019-03-15', 273, NULL),
('Candlewood Suites', 134, '2019-03-16', 164, NULL),
('Candlewood Suites', 134, '2019-03-17', 124, NULL),
('Candlewood Suites', 134, '2019-03-18', 104, NULL),
('Candlewood Suites', 134, '2019-03-19', 199, NULL),
('Candlewood Suites', 134, '2019-03-20', 250, NULL),
('Candlewood Suites', 134, '2019-03-21', 262, NULL),
('Candlewood Suites', 134, '2019-03-22', 100, NULL),
('Candlewood Suites', 134, '2019-03-23', 239, NULL),
('Candlewood Suites', 134, '2019-03-24', 202, NULL),
('Candlewood Suites', 134, '2019-03-25', 117, NULL),
('Candlewood Suites', 134, '2019-03-26', 266, NULL),
('Candlewood Suites', 134, '2019-03-27', 165, NULL),
('Candlewood Suites', 134, '2019-03-28', 343, NULL),
('Candlewood Suites', 134, '2019-03-29', 205, NULL),
('Candlewood Suites', 134, '2019-03-30', 139, NULL),
('Candlewood Suites', 134, '2019-03-31', 208, NULL),
('Candlewood Suites', 134, '2019-04-01', 323, NULL),
('Candlewood Suites', 134, '2019-04-02', 382, NULL),
('Candlewood Suites', 134, '2019-04-03', 221, NULL),
('Candlewood Suites', 134, '2019-04-04', 200, NULL),
('Candlewood Suites', 134, '2019-04-05', 264, NULL),
('Candlewood Suites', 134, '2019-04-06', 326, NULL),
('Candlewood Suites', 134, '2019-04-07', 213, NULL),
('Candlewood Suites', 134, '2019-04-08', 236, NULL),
('Candlewood Suites', 134, '2019-04-09', 310, NULL),
('Candlewood Suites', 134, '2019-04-10', 212, NULL),
('Candlewood Suites', 134, '2019-04-11', 298, NULL),
('Candlewood Suites', 134, '2019-04-12', 153, NULL),
('Candlewood Suites', 134, '2019-04-13', 101, NULL),
('Candlewood Suites', 134, '2019-04-14', 332, NULL),
('Candlewood Suites', 134, '2019-04-15', 106, NULL),
('Candlewood Suites', 134, '2019-04-16', 332, NULL),
('Candlewood Suites', 134, '2019-04-17', 222, NULL),
('Candlewood Suites', 134, '2019-04-18', 332, NULL),
('Candlewood Suites', 134, '2019-04-19', 195, NULL),
('Candlewood Suites', 134, '2019-04-20', 148, NULL),
('Candlewood Suites', 134, '2019-04-21', 392, NULL),
('Candlewood Suites', 134, '2019-04-22', 375, NULL),
('Candlewood Suites', 134, '2019-04-23', 191, NULL),
('Candlewood Suites', 134, '2019-04-24', 134, NULL),
('Candlewood Suites', 134, '2019-04-25', 299, NULL),
('Candlewood Suites', 134, '2019-04-26', 317, NULL),
('Candlewood Suites', 134, '2019-04-27', 108, NULL),
('Candlewood Suites', 134, '2019-04-28', 391, NULL),
('Candlewood Suites', 134, '2019-04-29', 270, NULL),
('Candlewood Suites', 134, '2019-04-30', 127, NULL),
('Candlewood Suites', 134, '2019-05-01', 312, NULL),
('Candlewood Suites', 134, '2019-05-02', 199, NULL),
('Candlewood Suites', 134, '2019-05-03', 255, NULL),
('Candlewood Suites', 134, '2019-05-04', 270, NULL),
('Candlewood Suites', 134, '2019-05-05', 246, NULL),
('Candlewood Suites', 134, '2019-05-06', 117, NULL),
('Candlewood Suites', 134, '2019-05-07', 353, NULL),
('Candlewood Suites', 134, '2019-05-08', 371, NULL),
('Candlewood Suites', 134, '2019-05-09', 398, NULL),
('Candlewood Suites', 134, '2019-05-10', 383, NULL),
('Candlewood Suites', 134, '2019-05-11', 235, NULL),
('Candlewood Suites', 134, '2019-05-12', 153, NULL),
('Candlewood Suites', 134, '2019-05-13', 156, NULL),
('Candlewood Suites', 134, '2019-05-14', 180, NULL),
('Candlewood Suites', 134, '2019-05-15', 267, NULL),
('Candlewood Suites', 134, '2019-05-16', 213, NULL),
('Candlewood Suites', 134, '2019-05-17', 389, NULL),
('Candlewood Suites', 134, '2019-05-18', 293, NULL),
('Candlewood Suites', 134, '2019-05-19', 210, NULL),
('Candlewood Suites', 134, '2019-05-20', 172, NULL),
('Candlewood Suites', 134, '2019-05-21', 344, NULL),
('Candlewood Suites', 134, '2019-05-22', 386, NULL),
('Candlewood Suites', 134, '2019-05-23', 320, NULL),
('Candlewood Suites', 134, '2019-05-24', 207, NULL),
('Candlewood Suites', 134, '2019-05-25', 142, NULL),
('Candlewood Suites', 134, '2019-05-26', 260, NULL),
('Candlewood Suites', 134, '2019-05-27', 369, NULL),
('Candlewood Suites', 134, '2019-05-28', 259, NULL),
('Candlewood Suites', 134, '2019-05-29', 154, NULL),
('Candlewood Suites', 134, '2019-05-30', 330, NULL),
('Candlewood Suites', 134, '2019-05-31', 282, NULL),
('Candlewood Suites', 134, '2019-06-01', 143, NULL),
('Candlewood Suites', 134, '2019-06-02', 321, NULL),
('Candlewood Suites', 134, '2019-06-03', 203, NULL),
('Candlewood Suites', 134, '2019-06-04', 231, NULL),
('Candlewood Suites', 134, '2019-06-05', 312, NULL),
('Candlewood Suites', 134, '2019-06-06', 268, NULL),
('Candlewood Suites', 134, '2019-06-07', 157, NULL),
('Candlewood Suites', 134, '2019-06-08', 305, NULL),
('Candlewood Suites', 134, '2019-06-09', 257, NULL),
('Candlewood Suites', 134, '2019-06-10', 259, NULL),
('Candlewood Suites', 134, '2019-06-11', 249, NULL),
('Candlewood Suites', 134, '2019-06-12', 261, NULL),
('Candlewood Suites', 134, '2019-06-13', 377, NULL),
('Candlewood Suites', 134, '2019-06-14', 325, NULL),
('Candlewood Suites', 134, '2019-06-15', 166, NULL),
('Candlewood Suites', 134, '2019-06-16', 150, NULL),
('Candlewood Suites', 134, '2019-06-17', 250, NULL),
('Candlewood Suites', 134, '2019-06-18', 190, NULL),
('Candlewood Suites', 134, '2019-06-19', 168, NULL),
('Candlewood Suites', 134, '2019-06-20', 150, NULL),
('Candlewood Suites', 134, '2019-06-21', 276, NULL),
('Candlewood Suites', 134, '2019-06-22', 248, NULL),
('Candlewood Suites', 134, '2019-06-23', 174, NULL),
('Candlewood Suites', 134, '2019-06-24', 104, NULL),
('Candlewood Suites', 134, '2019-06-25', 241, NULL),
('Candlewood Suites', 134, '2019-06-26', 161, NULL),
('Candlewood Suites', 134, '2019-06-27', 197, NULL),
('Candlewood Suites', 134, '2019-06-28', 341, NULL),
('Candlewood Suites', 134, '2019-06-29', 196, NULL),
('Candlewood Suites', 134, '2019-06-30', 128, NULL),
('Candlewood Suites', 134, '2019-07-01', 391, NULL),
('Candlewood Suites', 134, '2019-07-02', 233, NULL),
('Candlewood Suites', 134, '2019-07-03', 300, NULL),
('Candlewood Suites', 134, '2019-07-04', 374, NULL),
('Candlewood Suites', 134, '2019-07-05', 366, NULL),
('Candlewood Suites', 134, '2019-07-06', 136, NULL),
('Candlewood Suites', 134, '2019-07-07', 225, NULL),
('Candlewood Suites', 134, '2019-07-08', 311, NULL),
('Candlewood Suites', 134, '2019-07-09', 173, NULL),
('Candlewood Suites', 134, '2019-07-10', 359, NULL),
('Candlewood Suites', 134, '2019-07-11', 365, NULL),
('Candlewood Suites', 134, '2019-07-12', 132, NULL),
('Candlewood Suites', 134, '2019-07-13', 305, NULL),
('Candlewood Suites', 134, '2019-07-14', 110, NULL),
('Candlewood Suites', 134, '2019-07-15', 383, NULL),
('Candlewood Suites', 134, '2019-07-16', 262, NULL),
('Candlewood Suites', 134, '2019-07-17', 398, NULL),
('Candlewood Suites', 134, '2019-07-18', 128, NULL),
('Candlewood Suites', 134, '2019-07-19', 279, NULL),
('Candlewood Suites', 134, '2019-07-20', 266, NULL),
('Candlewood Suites', 134, '2019-07-21', 321, NULL),
('Candlewood Suites', 134, '2019-07-22', 119, NULL),
('Candlewood Suites', 134, '2019-07-23', 346, NULL),
('Candlewood Suites', 134, '2019-07-24', 234, NULL),
('Candlewood Suites', 134, '2019-07-25', 256, NULL),
('Candlewood Suites', 134, '2019-07-26', 373, NULL),
('Candlewood Suites', 134, '2019-07-27', 221, NULL),
('Candlewood Suites', 134, '2019-07-28', 395, NULL),
('Candlewood Suites', 134, '2019-07-29', 316, NULL),
('Candlewood Suites', 134, '2019-07-30', 128, NULL),
('Candlewood Suites', 134, '2019-07-31', 337, NULL),
('Candlewood Suites', 134, '2019-08-01', 104, NULL),
('Candlewood Suites', 134, '2019-08-02', 124, NULL),
('Candlewood Suites', 134, '2019-08-03', 231, NULL),
('Candlewood Suites', 134, '2019-08-04', 270, NULL),
('Candlewood Suites', 134, '2019-08-05', 251, NULL),
('Candlewood Suites', 134, '2019-08-06', 119, NULL),
('Candlewood Suites', 134, '2019-08-07', 212, NULL),
('Candlewood Suites', 134, '2019-08-08', 239, NULL),
('Candlewood Suites', 134, '2019-08-09', 300, NULL),
('Candlewood Suites', 134, '2019-08-10', 245, NULL),
('Candlewood Suites', 134, '2019-08-11', 271, NULL),
('Candlewood Suites', 134, '2019-08-12', 188, NULL),
('Candlewood Suites', 134, '2019-08-13', 133, NULL),
('Candlewood Suites', 134, '2019-08-14', 396, NULL),
('Candlewood Suites', 134, '2019-08-15', 315, NULL),
('Candlewood Suites', 134, '2019-08-16', 296, NULL),
('Candlewood Suites', 134, '2019-08-17', 358, NULL),
('Candlewood Suites', 134, '2019-08-18', 119, NULL),
('Candlewood Suites', 134, '2019-08-19', 203, NULL),
('Candlewood Suites', 134, '2019-08-20', 139, NULL),
('Candlewood Suites', 134, '2019-08-21', 194, NULL),
('Candlewood Suites', 134, '2019-08-22', 169, NULL),
('Candlewood Suites', 134, '2019-08-23', 155, NULL),
('Candlewood Suites', 134, '2019-08-24', 367, NULL),
('Candlewood Suites', 134, '2019-08-25', 233, NULL),
('Candlewood Suites', 134, '2019-08-26', 142, NULL),
('Candlewood Suites', 134, '2019-08-27', 311, NULL),
('Candlewood Suites', 134, '2019-08-28', 225, NULL),
('Candlewood Suites', 134, '2019-08-29', 176, NULL),
('Candlewood Suites', 134, '2019-08-30', 289, NULL),
('Candlewood Suites', 134, '2019-08-31', 195, NULL),
('Candlewood Suites', 134, '2019-09-01', 247, NULL),
('Candlewood Suites', 134, '2019-09-02', 310, NULL),
('Candlewood Suites', 134, '2019-09-03', 221, NULL),
('Candlewood Suites', 134, '2019-09-04', 101, NULL),
('Candlewood Suites', 134, '2019-09-05', 304, NULL),
('Candlewood Suites', 134, '2019-09-06', 218, NULL),
('Candlewood Suites', 134, '2019-09-07', 115, NULL),
('Candlewood Suites', 134, '2019-09-08', 122, NULL),
('Candlewood Suites', 134, '2019-09-09', 362, NULL),
('Candlewood Suites', 134, '2019-09-10', 351, NULL),
('Candlewood Suites', 134, '2019-09-11', 231, NULL),
('Candlewood Suites', 134, '2019-09-12', 336, NULL),
('Candlewood Suites', 134, '2019-09-13', 370, NULL),
('Candlewood Suites', 134, '2019-09-14', 304, NULL),
('Candlewood Suites', 134, '2019-09-15', 285, NULL),
('Candlewood Suites', 134, '2019-09-16', 294, NULL),
('Candlewood Suites', 134, '2019-09-17', 288, NULL),
('Candlewood Suites', 134, '2019-09-18', 212, NULL),
('Candlewood Suites', 134, '2019-09-19', 309, NULL),
('Candlewood Suites', 134, '2019-09-20', 391, NULL),
('Candlewood Suites', 134, '2019-09-21', 392, NULL),
('Candlewood Suites', 134, '2019-09-22', 337, NULL),
('Candlewood Suites', 134, '2019-09-23', 300, NULL),
('Candlewood Suites', 134, '2019-09-24', 133, NULL),
('Candlewood Suites', 134, '2019-09-25', 292, NULL),
('Candlewood Suites', 134, '2019-09-26', 177, NULL),
('Candlewood Suites', 134, '2019-09-27', 303, NULL),
('Candlewood Suites', 134, '2019-09-28', 282, NULL),
('Candlewood Suites', 134, '2019-09-29', 185, NULL),
('Candlewood Suites', 134, '2019-09-30', 126, NULL),
('Candlewood Suites', 134, '2019-10-01', 374, NULL),
('Candlewood Suites', 134, '2019-10-02', 347, NULL),
('Candlewood Suites', 134, '2019-10-03', 395, NULL),
('Candlewood Suites', 134, '2019-10-04', 329, NULL),
('Candlewood Suites', 134, '2019-10-05', 208, NULL),
('Candlewood Suites', 134, '2019-10-06', 200, NULL),
('Candlewood Suites', 134, '2019-10-07', 179, NULL),
('Candlewood Suites', 134, '2019-10-08', 131, NULL),
('Candlewood Suites', 134, '2019-10-09', 377, NULL),
('Candlewood Suites', 134, '2019-10-10', 195, NULL),
('Candlewood Suites', 134, '2019-10-11', 186, NULL),
('Candlewood Suites', 134, '2019-10-12', 247, NULL),
('Candlewood Suites', 134, '2019-10-13', 204, NULL),
('Candlewood Suites', 134, '2019-10-14', 344, NULL),
('Candlewood Suites', 134, '2019-10-15', 132, NULL),
('Candlewood Suites', 134, '2019-10-16', 242, NULL),
('Candlewood Suites', 134, '2019-10-17', 398, NULL),
('Candlewood Suites', 134, '2019-10-18', 175, NULL),
('Candlewood Suites', 134, '2019-10-19', 324, NULL),
('Candlewood Suites', 134, '2019-10-20', 149, NULL),
('Candlewood Suites', 134, '2019-10-21', 264, NULL),
('Candlewood Suites', 134, '2019-10-22', 118, NULL),
('Candlewood Suites', 134, '2019-10-23', 344, NULL),
('Candlewood Suites', 134, '2019-10-24', 194, NULL),
('Candlewood Suites', 134, '2019-10-25', 233, NULL),
('Candlewood Suites', 134, '2019-10-26', 287, NULL),
('Candlewood Suites', 134, '2019-10-27', 369, NULL),
('Candlewood Suites', 134, '2019-10-28', 360, NULL),
('Candlewood Suites', 134, '2019-10-29', 261, NULL),
('Candlewood Suites', 134, '2019-10-30', 206, NULL),
('Candlewood Suites', 134, '2019-10-31', 282, NULL),
('Candlewood Suites', 134, '2019-11-01', 347, NULL),
('Candlewood Suites', 134, '2019-11-02', 364, NULL),
('Candlewood Suites', 134, '2019-11-03', 209, NULL),
('Candlewood Suites', 134, '2019-11-04', 309, NULL),
('Candlewood Suites', 134, '2019-11-05', 156, NULL),
('Candlewood Suites', 134, '2019-11-06', 171, NULL),
('Candlewood Suites', 134, '2019-11-07', 382, NULL),
('Candlewood Suites', 134, '2019-11-08', 295, NULL),
('Candlewood Suites', 134, '2019-11-09', 355, NULL),
('Candlewood Suites', 134, '2019-11-10', 152, NULL),
('Candlewood Suites', 134, '2019-11-11', 347, NULL),
('Candlewood Suites', 134, '2019-11-12', 197, NULL),
('Candlewood Suites', 134, '2019-11-13', 146, NULL),
('Candlewood Suites', 134, '2019-11-14', 240, NULL),
('Candlewood Suites', 134, '2019-11-15', 318, NULL),
('Candlewood Suites', 134, '2019-11-16', 115, NULL),
('Candlewood Suites', 134, '2019-11-17', 240, NULL),
('Candlewood Suites', 134, '2019-11-18', 101, NULL),
('Candlewood Suites', 134, '2019-11-19', 143, NULL),
('Candlewood Suites', 134, '2019-11-20', 263, NULL),
('Candlewood Suites', 134, '2019-11-21', 154, NULL),
('Candlewood Suites', 134, '2019-11-22', 378, NULL),
('Candlewood Suites', 134, '2019-11-23', 184, NULL),
('Candlewood Suites', 134, '2019-11-24', 119, NULL),
('Candlewood Suites', 134, '2019-11-25', 312, NULL),
('Candlewood Suites', 134, '2019-11-26', 284, NULL),
('Candlewood Suites', 134, '2019-11-27', 182, NULL),
('Candlewood Suites', 134, '2019-11-28', 123, NULL),
('Candlewood Suites', 134, '2019-11-29', 105, NULL),
('Candlewood Suites', 134, '2019-11-30', 127, NULL),
('Candlewood Suites', 134, '2019-12-01', 279, NULL),
('Candlewood Suites', 134, '2019-12-02', 393, NULL),
('Candlewood Suites', 134, '2019-12-03', 112, NULL),
('Candlewood Suites', 134, '2019-12-04', 380, NULL),
('Candlewood Suites', 134, '2019-12-05', 288, NULL),
('Candlewood Suites', 134, '2019-12-06', 341, NULL),
('Candlewood Suites', 134, '2019-12-07', 142, NULL),
('Candlewood Suites', 134, '2019-12-08', 322, NULL),
('Candlewood Suites', 134, '2019-12-09', 266, NULL),
('Candlewood Suites', 134, '2019-12-10', 208, NULL),
('Candlewood Suites', 134, '2019-12-11', 154, NULL),
('Candlewood Suites', 134, '2019-12-12', 387, NULL),
('Candlewood Suites', 134, '2019-12-13', 300, NULL),
('Candlewood Suites', 134, '2019-12-14', 347, NULL),
('Candlewood Suites', 134, '2019-12-15', 345, NULL),
('Candlewood Suites', 134, '2019-12-16', 325, NULL),
('Candlewood Suites', 134, '2019-12-17', 218, NULL),
('Candlewood Suites', 134, '2019-12-18', 364, NULL),
('Candlewood Suites', 134, '2019-12-19', 278, NULL),
('Candlewood Suites', 134, '2019-12-20', 334, NULL),
('Candlewood Suites', 134, '2019-12-21', 295, NULL),
('Candlewood Suites', 134, '2019-12-22', 100, NULL),
('Candlewood Suites', 134, '2019-12-23', 200, NULL),
('Candlewood Suites', 134, '2019-12-24', 362, NULL),
('Candlewood Suites', 134, '2019-12-25', 104, NULL),
('Candlewood Suites', 134, '2019-12-26', 335, NULL),
('Candlewood Suites', 134, '2019-12-27', 115, NULL),
('Candlewood Suites', 134, '2019-12-28', 265, NULL),
('Candlewood Suites', 134, '2019-12-29', 211, NULL),
('Candlewood Suites', 134, '2019-12-30', 218, NULL),
('Candlewood Suites', 134, '2019-12-31', 263, NULL),
('Candlewood Suites', 134, '2020-01-01', 328, NULL),
('Candlewood Suites', 134, '2020-01-02', 296, NULL),
('Candlewood Suites', 134, '2020-01-03', 246, NULL),
('Candlewood Suites', 134, '2020-01-04', 114, NULL),
('Candlewood Suites', 134, '2020-01-05', 103, NULL),
('Candlewood Suites', 134, '2020-01-06', 150, NULL),
('Candlewood Suites', 134, '2020-01-07', 109, NULL),
('Candlewood Suites', 134, '2020-01-08', 330, NULL),
('Candlewood Suites', 134, '2020-01-09', 208, NULL),
('Candlewood Suites', 134, '2020-01-10', 324, NULL),
('Candlewood Suites', 134, '2020-01-11', 125, NULL),
('Candlewood Suites', 134, '2020-01-12', 381, NULL),
('Candlewood Suites', 134, '2020-01-13', 367, NULL),
('Candlewood Suites', 134, '2020-01-14', 119, NULL),
('Candlewood Suites', 134, '2020-01-15', 269, NULL),
('Candlewood Suites', 134, '2020-01-16', 260, NULL),
('Candlewood Suites', 134, '2020-01-17', 108, NULL),
('Candlewood Suites', 134, '2020-01-18', 200, NULL),
('Candlewood Suites', 134, '2020-01-19', 297, NULL),
('Candlewood Suites', 134, '2020-01-20', 298, NULL),
('Candlewood Suites', 134, '2020-01-21', 388, NULL),
('Candlewood Suites', 134, '2020-01-22', 129, NULL),
('Candlewood Suites', 134, '2020-01-23', 327, NULL),
('Candlewood Suites', 134, '2020-01-24', 237, NULL),
('Candlewood Suites', 134, '2020-01-25', 365, NULL),
('Candlewood Suites', 134, '2020-01-26', 199, NULL),
('Candlewood Suites', 134, '2020-01-27', 292, NULL),
('Candlewood Suites', 134, '2020-01-28', 264, NULL),
('Candlewood Suites', 134, '2020-01-29', 304, NULL),
('Candlewood Suites', 134, '2020-01-30', 110, NULL),
('Candlewood Suites', 134, '2020-01-31', 300, NULL),
('Candlewood Suites', 134, '2020-02-01', 344, NULL),
('Candlewood Suites', 134, '2020-02-02', 102, NULL),
('Candlewood Suites', 134, '2020-02-03', 261, NULL),
('Candlewood Suites', 134, '2020-02-04', 399, NULL),
('Candlewood Suites', 135, '2019-01-01', 391, NULL),
('Candlewood Suites', 135, '2019-01-02', 345, NULL),
('Candlewood Suites', 135, '2019-01-03', 346, NULL),
('Candlewood Suites', 135, '2019-01-04', 124, NULL),
('Candlewood Suites', 135, '2019-01-05', 236, NULL),
('Candlewood Suites', 135, '2019-01-06', 289, NULL),
('Candlewood Suites', 135, '2019-01-07', 229, NULL),
('Candlewood Suites', 135, '2019-01-08', 370, NULL),
('Candlewood Suites', 135, '2019-01-09', 280, NULL),
('Candlewood Suites', 135, '2019-01-10', 109, NULL),
('Candlewood Suites', 135, '2019-01-11', 397, NULL),
('Candlewood Suites', 135, '2019-01-12', 254, NULL),
('Candlewood Suites', 135, '2019-01-13', 106, NULL),
('Candlewood Suites', 135, '2019-01-14', 198, NULL),
('Candlewood Suites', 135, '2019-01-15', 331, NULL),
('Candlewood Suites', 135, '2019-01-16', 168, NULL),
('Candlewood Suites', 135, '2019-01-17', 261, NULL),
('Candlewood Suites', 135, '2019-01-18', 258, NULL),
('Candlewood Suites', 135, '2019-01-19', 170, NULL),
('Candlewood Suites', 135, '2019-01-20', 371, NULL),
('Candlewood Suites', 135, '2019-01-21', 171, NULL),
('Candlewood Suites', 135, '2019-01-22', 130, NULL),
('Candlewood Suites', 135, '2019-01-23', 113, NULL),
('Candlewood Suites', 135, '2019-01-24', 167, NULL),
('Candlewood Suites', 135, '2019-01-25', 363, NULL),
('Candlewood Suites', 135, '2019-01-26', 264, NULL),
('Candlewood Suites', 135, '2019-01-27', 349, NULL),
('Candlewood Suites', 135, '2019-01-28', 169, NULL),
('Candlewood Suites', 135, '2019-01-29', 269, NULL),
('Candlewood Suites', 135, '2019-01-30', 360, NULL),
('Candlewood Suites', 135, '2019-01-31', 242, NULL),
('Candlewood Suites', 135, '2019-02-01', 288, NULL),
('Candlewood Suites', 135, '2019-02-02', 162, NULL),
('Candlewood Suites', 135, '2019-02-03', 218, NULL),
('Candlewood Suites', 135, '2019-02-04', 220, NULL),
('Candlewood Suites', 135, '2019-02-05', 395, NULL),
('Candlewood Suites', 135, '2019-02-06', 260, NULL),
('Candlewood Suites', 135, '2019-02-07', 303, NULL),
('Candlewood Suites', 135, '2019-02-08', 115, NULL),
('Candlewood Suites', 135, '2019-02-09', 110, NULL),
('Candlewood Suites', 135, '2019-02-10', 168, NULL),
('Candlewood Suites', 135, '2019-02-11', 179, NULL),
('Candlewood Suites', 135, '2019-02-12', 272, NULL),
('Candlewood Suites', 135, '2019-02-13', 131, NULL),
('Candlewood Suites', 135, '2019-02-14', 186, NULL),
('Candlewood Suites', 135, '2019-02-15', 146, NULL),
('Candlewood Suites', 135, '2019-02-16', 335, NULL),
('Candlewood Suites', 135, '2019-02-17', 342, NULL),
('Candlewood Suites', 135, '2019-02-18', 357, NULL),
('Candlewood Suites', 135, '2019-02-19', 101, NULL),
('Candlewood Suites', 135, '2019-02-20', 142, NULL),
('Candlewood Suites', 135, '2019-02-21', 247, NULL),
('Candlewood Suites', 135, '2019-02-22', 147, NULL),
('Candlewood Suites', 135, '2019-02-23', 221, NULL),
('Candlewood Suites', 135, '2019-02-24', 394, NULL),
('Candlewood Suites', 135, '2019-02-25', 234, NULL),
('Candlewood Suites', 135, '2019-02-26', 197, NULL),
('Candlewood Suites', 135, '2019-02-27', 102, NULL),
('Candlewood Suites', 135, '2019-02-28', 174, NULL),
('Candlewood Suites', 135, '2019-03-01', 241, NULL),
('Candlewood Suites', 135, '2019-03-02', 125, NULL),
('Candlewood Suites', 135, '2019-03-03', 148, NULL),
('Candlewood Suites', 135, '2019-03-04', 343, NULL),
('Candlewood Suites', 135, '2019-03-05', 349, NULL),
('Candlewood Suites', 135, '2019-03-06', 385, NULL),
('Candlewood Suites', 135, '2019-03-07', 362, NULL),
('Candlewood Suites', 135, '2019-03-08', 385, NULL),
('Candlewood Suites', 135, '2019-03-09', 179, NULL),
('Candlewood Suites', 135, '2019-03-10', 146, NULL),
('Candlewood Suites', 135, '2019-03-11', 286, NULL),
('Candlewood Suites', 135, '2019-03-12', 138, NULL),
('Candlewood Suites', 135, '2019-03-13', 119, NULL),
('Candlewood Suites', 135, '2019-03-14', 224, NULL),
('Candlewood Suites', 135, '2019-03-15', 211, NULL),
('Candlewood Suites', 135, '2019-03-16', 192, NULL),
('Candlewood Suites', 135, '2019-03-17', 363, NULL),
('Candlewood Suites', 135, '2019-03-18', 161, NULL),
('Candlewood Suites', 135, '2019-03-19', 221, NULL),
('Candlewood Suites', 135, '2019-03-20', 365, NULL),
('Candlewood Suites', 135, '2019-03-21', 174, NULL),
('Candlewood Suites', 135, '2019-03-22', 195, NULL),
('Candlewood Suites', 135, '2019-03-23', 178, NULL),
('Candlewood Suites', 135, '2019-03-24', 108, NULL),
('Candlewood Suites', 135, '2019-03-25', 214, NULL),
('Candlewood Suites', 135, '2019-03-26', 252, NULL),
('Candlewood Suites', 135, '2019-03-27', 318, NULL),
('Candlewood Suites', 135, '2019-03-28', 276, NULL),
('Candlewood Suites', 135, '2019-03-29', 270, NULL),
('Candlewood Suites', 135, '2019-03-30', 158, NULL),
('Candlewood Suites', 135, '2019-03-31', 267, NULL),
('Candlewood Suites', 135, '2019-04-01', 202, NULL),
('Candlewood Suites', 135, '2019-04-02', 183, NULL),
('Candlewood Suites', 135, '2019-04-03', 255, NULL),
('Candlewood Suites', 135, '2019-04-04', 294, NULL),
('Candlewood Suites', 135, '2019-04-05', 378, NULL),
('Candlewood Suites', 135, '2019-04-06', 255, NULL),
('Candlewood Suites', 135, '2019-04-07', 184, NULL),
('Candlewood Suites', 135, '2019-04-08', 298, NULL),
('Candlewood Suites', 135, '2019-04-09', 250, NULL),
('Candlewood Suites', 135, '2019-04-10', 232, NULL),
('Candlewood Suites', 135, '2019-04-11', 332, NULL),
('Candlewood Suites', 135, '2019-04-12', 213, NULL),
('Candlewood Suites', 135, '2019-04-13', 224, NULL),
('Candlewood Suites', 135, '2019-04-14', 360, NULL),
('Candlewood Suites', 135, '2019-04-15', 216, NULL),
('Candlewood Suites', 135, '2019-04-16', 217, NULL),
('Candlewood Suites', 135, '2019-04-17', 396, NULL),
('Candlewood Suites', 135, '2019-04-18', 286, NULL),
('Candlewood Suites', 135, '2019-04-19', 343, NULL),
('Candlewood Suites', 135, '2019-04-20', 184, NULL),
('Candlewood Suites', 135, '2019-04-21', 248, NULL),
('Candlewood Suites', 135, '2019-04-22', 133, NULL),
('Candlewood Suites', 135, '2019-04-23', 100, NULL),
('Candlewood Suites', 135, '2019-04-24', 292, NULL),
('Candlewood Suites', 135, '2019-04-25', 222, NULL),
('Candlewood Suites', 135, '2019-04-26', 158, NULL),
('Candlewood Suites', 135, '2019-04-27', 143, NULL),
('Candlewood Suites', 135, '2019-04-28', 234, NULL),
('Candlewood Suites', 135, '2019-04-29', 332, NULL),
('Candlewood Suites', 135, '2019-04-30', 206, NULL),
('Candlewood Suites', 135, '2019-05-01', 137, NULL),
('Candlewood Suites', 135, '2019-05-02', 201, NULL),
('Candlewood Suites', 135, '2019-05-03', 331, NULL),
('Candlewood Suites', 135, '2019-05-04', 107, NULL),
('Candlewood Suites', 135, '2019-05-05', 158, NULL),
('Candlewood Suites', 135, '2019-05-06', 263, NULL),
('Candlewood Suites', 135, '2019-05-07', 215, NULL),
('Candlewood Suites', 135, '2019-05-08', 184, NULL),
('Candlewood Suites', 135, '2019-05-09', 356, NULL),
('Candlewood Suites', 135, '2019-05-10', 397, NULL),
('Candlewood Suites', 135, '2019-05-11', 385, NULL),
('Candlewood Suites', 135, '2019-05-12', 144, NULL),
('Candlewood Suites', 135, '2019-05-13', 188, NULL),
('Candlewood Suites', 135, '2019-05-14', 168, NULL),
('Candlewood Suites', 135, '2019-05-15', 151, NULL),
('Candlewood Suites', 135, '2019-05-16', 280, NULL),
('Candlewood Suites', 135, '2019-05-17', 249, NULL),
('Candlewood Suites', 135, '2019-05-18', 217, NULL),
('Candlewood Suites', 135, '2019-05-19', 269, NULL),
('Candlewood Suites', 135, '2019-05-20', 345, NULL),
('Candlewood Suites', 135, '2019-05-21', 268, NULL),
('Candlewood Suites', 135, '2019-05-22', 313, NULL),
('Candlewood Suites', 135, '2019-05-23', 178, NULL),
('Candlewood Suites', 135, '2019-05-24', 180, NULL),
('Candlewood Suites', 135, '2019-05-25', 285, NULL),
('Candlewood Suites', 135, '2019-05-26', 187, NULL),
('Candlewood Suites', 135, '2019-05-27', 291, NULL),
('Candlewood Suites', 135, '2019-05-28', 228, NULL),
('Candlewood Suites', 135, '2019-05-29', 139, NULL),
('Candlewood Suites', 135, '2019-05-30', 243, NULL),
('Candlewood Suites', 135, '2019-05-31', 161, NULL),
('Candlewood Suites', 135, '2019-06-01', 326, NULL),
('Candlewood Suites', 135, '2019-06-02', 395, NULL),
('Candlewood Suites', 135, '2019-06-03', 182, NULL),
('Candlewood Suites', 135, '2019-06-04', 227, NULL),
('Candlewood Suites', 135, '2019-06-05', 323, NULL),
('Candlewood Suites', 135, '2019-06-06', 201, NULL),
('Candlewood Suites', 135, '2019-06-07', 286, NULL),
('Candlewood Suites', 135, '2019-06-08', 360, NULL),
('Candlewood Suites', 135, '2019-06-09', 379, NULL),
('Candlewood Suites', 135, '2019-06-10', 342, NULL),
('Candlewood Suites', 135, '2019-06-11', 209, NULL),
('Candlewood Suites', 135, '2019-06-12', 225, NULL),
('Candlewood Suites', 135, '2019-06-13', 135, NULL),
('Candlewood Suites', 135, '2019-06-14', 105, NULL),
('Candlewood Suites', 135, '2019-06-15', 186, NULL),
('Candlewood Suites', 135, '2019-06-16', 284, NULL),
('Candlewood Suites', 135, '2019-06-17', 233, NULL),
('Candlewood Suites', 135, '2019-06-18', 161, NULL),
('Candlewood Suites', 135, '2019-06-19', 182, NULL),
('Candlewood Suites', 135, '2019-06-20', 333, NULL),
('Candlewood Suites', 135, '2019-06-21', 253, NULL),
('Candlewood Suites', 135, '2019-06-22', 323, NULL),
('Candlewood Suites', 135, '2019-06-23', 357, NULL),
('Candlewood Suites', 135, '2019-06-24', 364, NULL),
('Candlewood Suites', 135, '2019-06-25', 331, NULL),
('Candlewood Suites', 135, '2019-06-26', 251, NULL),
('Candlewood Suites', 135, '2019-06-27', 186, NULL),
('Candlewood Suites', 135, '2019-06-28', 147, NULL),
('Candlewood Suites', 135, '2019-06-29', 333, NULL),
('Candlewood Suites', 135, '2019-06-30', 273, NULL),
('Candlewood Suites', 135, '2019-07-01', 154, NULL),
('Candlewood Suites', 135, '2019-07-02', 380, NULL),
('Candlewood Suites', 135, '2019-07-03', 237, NULL),
('Candlewood Suites', 135, '2019-07-04', 365, NULL),
('Candlewood Suites', 135, '2019-07-05', 341, NULL),
('Candlewood Suites', 135, '2019-07-06', 226, NULL),
('Candlewood Suites', 135, '2019-07-07', 343, NULL),
('Candlewood Suites', 135, '2019-07-08', 332, NULL),
('Candlewood Suites', 135, '2019-07-09', 126, NULL),
('Candlewood Suites', 135, '2019-07-10', 110, NULL),
('Candlewood Suites', 135, '2019-07-11', 174, NULL),
('Candlewood Suites', 135, '2019-07-12', 126, NULL),
('Candlewood Suites', 135, '2019-07-13', 287, NULL),
('Candlewood Suites', 135, '2019-07-14', 253, NULL),
('Candlewood Suites', 135, '2019-07-15', 156, NULL),
('Candlewood Suites', 135, '2019-07-16', 206, NULL),
('Candlewood Suites', 135, '2019-07-17', 251, NULL),
('Candlewood Suites', 135, '2019-07-18', 390, NULL),
('Candlewood Suites', 135, '2019-07-19', 256, NULL),
('Candlewood Suites', 135, '2019-07-20', 133, NULL),
('Candlewood Suites', 135, '2019-07-21', 238, NULL),
('Candlewood Suites', 135, '2019-07-22', 377, NULL),
('Candlewood Suites', 135, '2019-07-23', 126, NULL),
('Candlewood Suites', 135, '2019-07-24', 300, NULL),
('Candlewood Suites', 135, '2019-07-25', 133, NULL),
('Candlewood Suites', 135, '2019-07-26', 110, NULL),
('Candlewood Suites', 135, '2019-07-27', 361, NULL),
('Candlewood Suites', 135, '2019-07-28', 384, NULL),
('Candlewood Suites', 135, '2019-07-29', 235, NULL),
('Candlewood Suites', 135, '2019-07-30', 317, NULL),
('Candlewood Suites', 135, '2019-07-31', 167, NULL),
('Candlewood Suites', 135, '2019-08-01', 369, NULL),
('Candlewood Suites', 135, '2019-08-02', 219, NULL),
('Candlewood Suites', 135, '2019-08-03', 389, NULL),
('Candlewood Suites', 135, '2019-08-04', 186, NULL),
('Candlewood Suites', 135, '2019-08-05', 271, NULL),
('Candlewood Suites', 135, '2019-08-06', 391, NULL),
('Candlewood Suites', 135, '2019-08-07', 257, NULL),
('Candlewood Suites', 135, '2019-08-08', 212, NULL),
('Candlewood Suites', 135, '2019-08-09', 123, NULL),
('Candlewood Suites', 135, '2019-08-10', 355, NULL),
('Candlewood Suites', 135, '2019-08-11', 313, NULL),
('Candlewood Suites', 135, '2019-08-12', 110, NULL),
('Candlewood Suites', 135, '2019-08-13', 362, NULL),
('Candlewood Suites', 135, '2019-08-14', 334, NULL),
('Candlewood Suites', 135, '2019-08-15', 131, NULL),
('Candlewood Suites', 135, '2019-08-16', 344, NULL),
('Candlewood Suites', 135, '2019-08-17', 137, NULL),
('Candlewood Suites', 135, '2019-08-18', 178, NULL),
('Candlewood Suites', 135, '2019-08-19', 224, NULL),
('Candlewood Suites', 135, '2019-08-20', 398, NULL),
('Candlewood Suites', 135, '2019-08-21', 352, NULL),
('Candlewood Suites', 135, '2019-08-22', 134, NULL),
('Candlewood Suites', 135, '2019-08-23', 372, NULL),
('Candlewood Suites', 135, '2019-08-24', 396, NULL),
('Candlewood Suites', 135, '2019-08-25', 361, NULL),
('Candlewood Suites', 135, '2019-08-26', 339, NULL),
('Candlewood Suites', 135, '2019-08-27', 312, NULL),
('Candlewood Suites', 135, '2019-08-28', 194, NULL),
('Candlewood Suites', 135, '2019-08-29', 125, NULL),
('Candlewood Suites', 135, '2019-08-30', 172, NULL),
('Candlewood Suites', 135, '2019-08-31', 115, NULL),
('Candlewood Suites', 135, '2019-09-01', 273, NULL),
('Candlewood Suites', 135, '2019-09-02', 340, NULL),
('Candlewood Suites', 135, '2019-09-03', 269, NULL),
('Candlewood Suites', 135, '2019-09-04', 140, NULL),
('Candlewood Suites', 135, '2019-09-05', 381, NULL),
('Candlewood Suites', 135, '2019-09-06', 158, NULL),
('Candlewood Suites', 135, '2019-09-07', 222, NULL),
('Candlewood Suites', 135, '2019-09-08', 237, NULL),
('Candlewood Suites', 135, '2019-09-09', 326, NULL),
('Candlewood Suites', 135, '2019-09-10', 236, NULL),
('Candlewood Suites', 135, '2019-09-11', 308, NULL),
('Candlewood Suites', 135, '2019-09-12', 335, NULL),
('Candlewood Suites', 135, '2019-09-13', 201, NULL),
('Candlewood Suites', 135, '2019-09-14', 247, NULL),
('Candlewood Suites', 135, '2019-09-15', 202, NULL),
('Candlewood Suites', 135, '2019-09-16', 307, NULL),
('Candlewood Suites', 135, '2019-09-17', 353, NULL),
('Candlewood Suites', 135, '2019-09-18', 141, NULL),
('Candlewood Suites', 135, '2019-09-19', 273, NULL),
('Candlewood Suites', 135, '2019-09-20', 384, NULL),
('Candlewood Suites', 135, '2019-09-21', 156, NULL),
('Candlewood Suites', 135, '2019-09-22', 326, NULL),
('Candlewood Suites', 135, '2019-09-23', 334, NULL),
('Candlewood Suites', 135, '2019-09-24', 394, NULL),
('Candlewood Suites', 135, '2019-09-25', 284, NULL),
('Candlewood Suites', 135, '2019-09-26', 359, NULL),
('Candlewood Suites', 135, '2019-09-27', 232, NULL),
('Candlewood Suites', 135, '2019-09-28', 280, NULL),
('Candlewood Suites', 135, '2019-09-29', 249, NULL),
('Candlewood Suites', 135, '2019-09-30', 381, NULL),
('Candlewood Suites', 135, '2019-10-01', 199, NULL),
('Candlewood Suites', 135, '2019-10-02', 187, NULL),
('Candlewood Suites', 135, '2019-10-03', 110, NULL),
('Candlewood Suites', 135, '2019-10-04', 307, NULL),
('Candlewood Suites', 135, '2019-10-05', 304, NULL),
('Candlewood Suites', 135, '2019-10-06', 112, NULL),
('Candlewood Suites', 135, '2019-10-07', 200, NULL),
('Candlewood Suites', 135, '2019-10-08', 310, NULL),
('Candlewood Suites', 135, '2019-10-09', 242, NULL),
('Candlewood Suites', 135, '2019-10-10', 173, NULL),
('Candlewood Suites', 135, '2019-10-11', 359, NULL),
('Candlewood Suites', 135, '2019-10-12', 297, NULL),
('Candlewood Suites', 135, '2019-10-13', 298, NULL),
('Candlewood Suites', 135, '2019-10-14', 396, NULL),
('Candlewood Suites', 135, '2019-10-15', 287, NULL),
('Candlewood Suites', 135, '2019-10-16', 220, NULL),
('Candlewood Suites', 135, '2019-10-17', 240, NULL),
('Candlewood Suites', 135, '2019-10-18', 230, NULL),
('Candlewood Suites', 135, '2019-10-19', 179, NULL),
('Candlewood Suites', 135, '2019-10-20', 339, NULL),
('Candlewood Suites', 135, '2019-10-21', 349, NULL),
('Candlewood Suites', 135, '2019-10-22', 253, NULL),
('Candlewood Suites', 135, '2019-10-23', 130, NULL),
('Candlewood Suites', 135, '2019-10-24', 388, NULL),
('Candlewood Suites', 135, '2019-10-25', 103, NULL),
('Candlewood Suites', 135, '2019-10-26', 313, NULL),
('Candlewood Suites', 135, '2019-10-27', 129, NULL),
('Candlewood Suites', 135, '2019-10-28', 130, NULL),
('Candlewood Suites', 135, '2019-10-29', 335, NULL),
('Candlewood Suites', 135, '2019-10-30', 171, NULL),
('Candlewood Suites', 135, '2019-10-31', 211, NULL),
('Candlewood Suites', 135, '2019-11-01', 163, NULL),
('Candlewood Suites', 135, '2019-11-02', 100, NULL),
('Candlewood Suites', 135, '2019-11-03', 348, NULL),
('Candlewood Suites', 135, '2019-11-04', 179, NULL),
('Candlewood Suites', 135, '2019-11-05', 109, NULL),
('Candlewood Suites', 135, '2019-11-06', 112, NULL),
('Candlewood Suites', 135, '2019-11-07', 244, NULL),
('Candlewood Suites', 135, '2019-11-08', 381, NULL),
('Candlewood Suites', 135, '2019-11-09', 129, NULL),
('Candlewood Suites', 135, '2019-11-10', 141, NULL),
('Candlewood Suites', 135, '2019-11-11', 108, NULL),
('Candlewood Suites', 135, '2019-11-12', 314, NULL),
('Candlewood Suites', 135, '2019-11-13', 361, NULL),
('Candlewood Suites', 135, '2019-11-14', 269, NULL),
('Candlewood Suites', 135, '2019-11-15', 395, NULL),
('Candlewood Suites', 135, '2019-11-16', 226, NULL),
('Candlewood Suites', 135, '2019-11-17', 184, NULL),
('Candlewood Suites', 135, '2019-11-18', 162, NULL),
('Candlewood Suites', 135, '2019-11-19', 251, NULL),
('Candlewood Suites', 135, '2019-11-20', 185, NULL),
('Candlewood Suites', 135, '2019-11-21', 128, NULL),
('Candlewood Suites', 135, '2019-11-22', 328, NULL),
('Candlewood Suites', 135, '2019-11-23', 299, NULL),
('Candlewood Suites', 135, '2019-11-24', 317, NULL),
('Candlewood Suites', 135, '2019-11-25', 196, NULL),
('Candlewood Suites', 135, '2019-11-26', 162, NULL),
('Candlewood Suites', 135, '2019-11-27', 141, NULL),
('Candlewood Suites', 135, '2019-11-28', 328, NULL),
('Candlewood Suites', 135, '2019-11-29', 176, NULL),
('Candlewood Suites', 135, '2019-11-30', 360, NULL),
('Candlewood Suites', 135, '2019-12-01', 329, NULL),
('Candlewood Suites', 135, '2019-12-02', 155, NULL),
('Candlewood Suites', 135, '2019-12-03', 288, NULL),
('Candlewood Suites', 135, '2019-12-04', 222, NULL),
('Candlewood Suites', 135, '2019-12-05', 314, NULL),
('Candlewood Suites', 135, '2019-12-06', 313, NULL),
('Candlewood Suites', 135, '2019-12-07', 236, NULL),
('Candlewood Suites', 135, '2019-12-08', 231, NULL),
('Candlewood Suites', 135, '2019-12-09', 222, NULL),
('Candlewood Suites', 135, '2019-12-10', 121, NULL),
('Candlewood Suites', 135, '2019-12-11', 388, NULL),
('Candlewood Suites', 135, '2019-12-12', 163, NULL),
('Candlewood Suites', 135, '2019-12-13', 326, NULL),
('Candlewood Suites', 135, '2019-12-14', 339, NULL),
('Candlewood Suites', 135, '2019-12-15', 390, NULL),
('Candlewood Suites', 135, '2019-12-16', 275, NULL),
('Candlewood Suites', 135, '2019-12-17', 392, NULL),
('Candlewood Suites', 135, '2019-12-18', 202, NULL),
('Candlewood Suites', 135, '2019-12-19', 333, NULL),
('Candlewood Suites', 135, '2019-12-20', 191, NULL),
('Candlewood Suites', 135, '2019-12-21', 209, NULL),
('Candlewood Suites', 135, '2019-12-22', 235, NULL),
('Candlewood Suites', 135, '2019-12-23', 398, NULL),
('Candlewood Suites', 135, '2019-12-24', 130, NULL),
('Candlewood Suites', 135, '2019-12-25', 184, NULL),
('Candlewood Suites', 135, '2019-12-26', 153, NULL),
('Candlewood Suites', 135, '2019-12-27', 300, NULL),
('Candlewood Suites', 135, '2019-12-28', 350, NULL),
('Candlewood Suites', 135, '2019-12-29', 326, NULL),
('Candlewood Suites', 135, '2019-12-30', 370, NULL),
('Candlewood Suites', 135, '2019-12-31', 107, NULL),
('Candlewood Suites', 135, '2020-01-01', 181, NULL),
('Candlewood Suites', 135, '2020-01-02', 351, NULL),
('Candlewood Suites', 135, '2020-01-03', 180, NULL),
('Candlewood Suites', 135, '2020-01-04', 345, NULL),
('Candlewood Suites', 135, '2020-01-05', 246, NULL),
('Candlewood Suites', 135, '2020-01-06', 371, NULL),
('Candlewood Suites', 135, '2020-01-07', 109, NULL),
('Candlewood Suites', 135, '2020-01-08', 210, NULL),
('Candlewood Suites', 135, '2020-01-09', 372, NULL),
('Candlewood Suites', 135, '2020-01-10', 262, NULL),
('Candlewood Suites', 135, '2020-01-11', 269, NULL),
('Candlewood Suites', 135, '2020-01-12', 381, NULL),
('Candlewood Suites', 135, '2020-01-13', 204, NULL),
('Candlewood Suites', 135, '2020-01-14', 237, NULL),
('Candlewood Suites', 135, '2020-01-15', 347, NULL),
('Candlewood Suites', 135, '2020-01-16', 344, NULL),
('Candlewood Suites', 135, '2020-01-17', 236, NULL),
('Candlewood Suites', 135, '2020-01-18', 127, NULL),
('Candlewood Suites', 135, '2020-01-19', 178, NULL),
('Candlewood Suites', 135, '2020-01-20', 243, NULL),
('Candlewood Suites', 135, '2020-01-21', 260, NULL),
('Candlewood Suites', 135, '2020-01-22', 174, NULL),
('Candlewood Suites', 135, '2020-01-23', 316, NULL),
('Candlewood Suites', 135, '2020-01-24', 361, NULL),
('Candlewood Suites', 135, '2020-01-25', 184, NULL),
('Candlewood Suites', 135, '2020-01-26', 152, NULL),
('Candlewood Suites', 135, '2020-01-27', 360, NULL),
('Candlewood Suites', 135, '2020-01-28', 336, NULL),
('Candlewood Suites', 135, '2020-01-29', 394, NULL),
('Candlewood Suites', 135, '2020-01-30', 230, NULL),
('Candlewood Suites', 135, '2020-01-31', 284, NULL),
('Candlewood Suites', 135, '2020-02-01', 240, NULL),
('Candlewood Suites', 135, '2020-02-02', 389, NULL),
('Candlewood Suites', 135, '2020-02-03', 384, NULL),
('Candlewood Suites', 135, '2020-02-04', 309, NULL),
('Candlewood Suites', 155, '2019-01-01', 230, NULL),
('Candlewood Suites', 155, '2019-01-02', 129, NULL),
('Candlewood Suites', 155, '2019-01-03', 328, NULL),
('Candlewood Suites', 155, '2019-01-04', 111, NULL),
('Candlewood Suites', 155, '2019-01-05', 325, NULL),
('Candlewood Suites', 155, '2019-01-06', 137, NULL),
('Candlewood Suites', 155, '2019-01-07', 304, NULL),
('Candlewood Suites', 155, '2019-01-08', 276, NULL),
('Candlewood Suites', 155, '2019-01-09', 268, NULL),
('Candlewood Suites', 155, '2019-01-10', 357, NULL),
('Candlewood Suites', 155, '2019-01-11', 305, NULL),
('Candlewood Suites', 155, '2019-01-12', 300, NULL),
('Candlewood Suites', 155, '2019-01-13', 172, NULL),
('Candlewood Suites', 155, '2019-01-14', 396, NULL),
('Candlewood Suites', 155, '2019-01-15', 376, NULL),
('Candlewood Suites', 155, '2019-01-16', 122, NULL),
('Candlewood Suites', 155, '2019-01-17', 196, NULL),
('Candlewood Suites', 155, '2019-01-18', 337, NULL),
('Candlewood Suites', 155, '2019-01-19', 205, NULL),
('Candlewood Suites', 155, '2019-01-20', 108, NULL),
('Candlewood Suites', 155, '2019-01-21', 236, NULL),
('Candlewood Suites', 155, '2019-01-22', 384, NULL),
('Candlewood Suites', 155, '2019-01-23', 142, NULL),
('Candlewood Suites', 155, '2019-01-24', 364, NULL),
('Candlewood Suites', 155, '2019-01-25', 132, NULL),
('Candlewood Suites', 155, '2019-01-26', 281, NULL),
('Candlewood Suites', 155, '2019-01-27', 233, NULL),
('Candlewood Suites', 155, '2019-01-28', 151, NULL),
('Candlewood Suites', 155, '2019-01-29', 105, NULL),
('Candlewood Suites', 155, '2019-01-30', 178, NULL),
('Candlewood Suites', 155, '2019-01-31', 146, NULL),
('Candlewood Suites', 155, '2019-02-01', 123, NULL),
('Candlewood Suites', 155, '2019-02-02', 253, NULL),
('Candlewood Suites', 155, '2019-02-03', 186, NULL),
('Candlewood Suites', 155, '2019-02-04', 189, NULL),
('Candlewood Suites', 155, '2019-02-05', 234, NULL),
('Candlewood Suites', 155, '2019-02-06', 207, NULL),
('Candlewood Suites', 155, '2019-02-07', 246, NULL),
('Candlewood Suites', 155, '2019-02-08', 291, NULL),
('Candlewood Suites', 155, '2019-02-09', 396, NULL),
('Candlewood Suites', 155, '2019-02-10', 359, NULL),
('Candlewood Suites', 155, '2019-02-11', 291, NULL),
('Candlewood Suites', 155, '2019-02-12', 108, NULL),
('Candlewood Suites', 155, '2019-02-13', 129, NULL),
('Candlewood Suites', 155, '2019-02-14', 178, NULL),
('Candlewood Suites', 155, '2019-02-15', 142, NULL),
('Candlewood Suites', 155, '2019-02-16', 206, NULL),
('Candlewood Suites', 155, '2019-02-17', 134, NULL),
('Candlewood Suites', 155, '2019-02-18', 190, NULL),
('Candlewood Suites', 155, '2019-02-19', 192, NULL),
('Candlewood Suites', 155, '2019-02-20', 224, NULL),
('Candlewood Suites', 155, '2019-02-21', 189, NULL),
('Candlewood Suites', 155, '2019-02-22', 133, NULL),
('Candlewood Suites', 155, '2019-02-23', 152, NULL),
('Candlewood Suites', 155, '2019-02-24', 245, NULL),
('Candlewood Suites', 155, '2019-02-25', 133, NULL),
('Candlewood Suites', 155, '2019-02-26', 347, NULL),
('Candlewood Suites', 155, '2019-02-27', 393, NULL),
('Candlewood Suites', 155, '2019-02-28', 106, NULL),
('Candlewood Suites', 155, '2019-03-01', 397, NULL),
('Candlewood Suites', 155, '2019-03-02', 383, NULL),
('Candlewood Suites', 155, '2019-03-03', 324, NULL),
('Candlewood Suites', 155, '2019-03-04', 152, NULL),
('Candlewood Suites', 155, '2019-03-05', 324, NULL),
('Candlewood Suites', 155, '2019-03-06', 299, NULL),
('Candlewood Suites', 155, '2019-03-07', 350, NULL),
('Candlewood Suites', 155, '2019-03-08', 136, NULL),
('Candlewood Suites', 155, '2019-03-09', 230, NULL),
('Candlewood Suites', 155, '2019-03-10', 333, NULL),
('Candlewood Suites', 155, '2019-03-11', 167, NULL),
('Candlewood Suites', 155, '2019-03-12', 310, NULL),
('Candlewood Suites', 155, '2019-03-13', 321, NULL),
('Candlewood Suites', 155, '2019-03-14', 224, NULL),
('Candlewood Suites', 155, '2019-03-15', 139, NULL),
('Candlewood Suites', 155, '2019-03-16', 370, NULL),
('Candlewood Suites', 155, '2019-03-17', 143, NULL),
('Candlewood Suites', 155, '2019-03-18', 392, NULL),
('Candlewood Suites', 155, '2019-03-19', 108, NULL),
('Candlewood Suites', 155, '2019-03-20', 374, NULL),
('Candlewood Suites', 155, '2019-03-21', 285, NULL),
('Candlewood Suites', 155, '2019-03-22', 275, NULL),
('Candlewood Suites', 155, '2019-03-23', 374, NULL),
('Candlewood Suites', 155, '2019-03-24', 133, NULL),
('Candlewood Suites', 155, '2019-03-25', 320, NULL),
('Candlewood Suites', 155, '2019-03-26', 363, NULL),
('Candlewood Suites', 155, '2019-03-27', 397, NULL),
('Candlewood Suites', 155, '2019-03-28', 252, NULL),
('Candlewood Suites', 155, '2019-03-29', 336, NULL),
('Candlewood Suites', 155, '2019-03-30', 273, NULL),
('Candlewood Suites', 155, '2019-03-31', 312, NULL),
('Candlewood Suites', 155, '2019-04-01', 243, NULL),
('Candlewood Suites', 155, '2019-04-02', 269, NULL),
('Candlewood Suites', 155, '2019-04-03', 212, NULL),
('Candlewood Suites', 155, '2019-04-04', 168, NULL),
('Candlewood Suites', 155, '2019-04-05', 398, NULL),
('Candlewood Suites', 155, '2019-04-06', 199, NULL),
('Candlewood Suites', 155, '2019-04-07', 182, NULL),
('Candlewood Suites', 155, '2019-04-08', 380, NULL),
('Candlewood Suites', 155, '2019-04-09', 222, NULL),
('Candlewood Suites', 155, '2019-04-10', 126, NULL),
('Candlewood Suites', 155, '2019-04-11', 368, NULL),
('Candlewood Suites', 155, '2019-04-12', 204, NULL),
('Candlewood Suites', 155, '2019-04-13', 119, NULL),
('Candlewood Suites', 155, '2019-04-14', 103, NULL),
('Candlewood Suites', 155, '2019-04-15', 363, NULL),
('Candlewood Suites', 155, '2019-04-16', 290, NULL),
('Candlewood Suites', 155, '2019-04-17', 312, NULL),
('Candlewood Suites', 155, '2019-04-18', 333, NULL),
('Candlewood Suites', 155, '2019-04-19', 129, NULL),
('Candlewood Suites', 155, '2019-04-20', 377, NULL),
('Candlewood Suites', 155, '2019-04-21', 266, NULL),
('Candlewood Suites', 155, '2019-04-22', 341, NULL),
('Candlewood Suites', 155, '2019-04-23', 125, NULL),
('Candlewood Suites', 155, '2019-04-24', 359, NULL),
('Candlewood Suites', 155, '2019-04-25', 114, NULL),
('Candlewood Suites', 155, '2019-04-26', 341, NULL),
('Candlewood Suites', 155, '2019-04-27', 291, NULL),
('Candlewood Suites', 155, '2019-04-28', 198, NULL),
('Candlewood Suites', 155, '2019-04-29', 151, NULL),
('Candlewood Suites', 155, '2019-04-30', 247, NULL),
('Candlewood Suites', 155, '2019-05-01', 248, NULL),
('Candlewood Suites', 155, '2019-05-02', 307, NULL),
('Candlewood Suites', 155, '2019-05-03', 194, NULL),
('Candlewood Suites', 155, '2019-05-04', 224, NULL),
('Candlewood Suites', 155, '2019-05-05', 253, NULL),
('Candlewood Suites', 155, '2019-05-06', 267, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 155, '2019-05-07', 216, NULL),
('Candlewood Suites', 155, '2019-05-08', 309, NULL),
('Candlewood Suites', 155, '2019-05-09', 188, NULL),
('Candlewood Suites', 155, '2019-05-10', 135, NULL),
('Candlewood Suites', 155, '2019-05-11', 218, NULL),
('Candlewood Suites', 155, '2019-05-12', 158, NULL),
('Candlewood Suites', 155, '2019-05-13', 373, NULL),
('Candlewood Suites', 155, '2019-05-14', 201, NULL),
('Candlewood Suites', 155, '2019-05-15', 156, NULL),
('Candlewood Suites', 155, '2019-05-16', 364, NULL),
('Candlewood Suites', 155, '2019-05-17', 278, NULL),
('Candlewood Suites', 155, '2019-05-18', 103, NULL),
('Candlewood Suites', 155, '2019-05-19', 314, NULL),
('Candlewood Suites', 155, '2019-05-20', 210, NULL),
('Candlewood Suites', 155, '2019-05-21', 208, NULL),
('Candlewood Suites', 155, '2019-05-22', 308, NULL),
('Candlewood Suites', 155, '2019-05-23', 131, NULL),
('Candlewood Suites', 155, '2019-05-24', 180, NULL),
('Candlewood Suites', 155, '2019-05-25', 300, NULL),
('Candlewood Suites', 155, '2019-05-26', 355, NULL),
('Candlewood Suites', 155, '2019-05-27', 250, NULL),
('Candlewood Suites', 155, '2019-05-28', 267, NULL),
('Candlewood Suites', 155, '2019-05-29', 134, NULL),
('Candlewood Suites', 155, '2019-05-30', 128, NULL),
('Candlewood Suites', 155, '2019-05-31', 158, NULL),
('Candlewood Suites', 155, '2019-06-01', 198, NULL),
('Candlewood Suites', 155, '2019-06-02', 312, NULL),
('Candlewood Suites', 155, '2019-06-03', 200, NULL),
('Candlewood Suites', 155, '2019-06-04', 340, NULL),
('Candlewood Suites', 155, '2019-06-05', 277, NULL),
('Candlewood Suites', 155, '2019-06-06', 399, NULL),
('Candlewood Suites', 155, '2019-06-07', 259, NULL),
('Candlewood Suites', 155, '2019-06-08', 187, NULL),
('Candlewood Suites', 155, '2019-06-09', 126, NULL),
('Candlewood Suites', 155, '2019-06-10', 233, NULL),
('Candlewood Suites', 155, '2019-06-11', 198, NULL),
('Candlewood Suites', 155, '2019-06-12', 240, NULL),
('Candlewood Suites', 155, '2019-06-13', 343, NULL),
('Candlewood Suites', 155, '2019-06-14', 350, NULL),
('Candlewood Suites', 155, '2019-06-15', 329, NULL),
('Candlewood Suites', 155, '2019-06-16', 271, NULL),
('Candlewood Suites', 155, '2019-06-17', 315, NULL),
('Candlewood Suites', 155, '2019-06-18', 134, NULL),
('Candlewood Suites', 155, '2019-06-19', 304, NULL),
('Candlewood Suites', 155, '2019-06-20', 216, NULL),
('Candlewood Suites', 155, '2019-06-21', 337, NULL),
('Candlewood Suites', 155, '2019-06-22', 171, NULL),
('Candlewood Suites', 155, '2019-06-23', 265, NULL),
('Candlewood Suites', 155, '2019-06-24', 209, NULL),
('Candlewood Suites', 155, '2019-06-25', 229, NULL),
('Candlewood Suites', 155, '2019-06-26', 370, NULL),
('Candlewood Suites', 155, '2019-06-27', 240, NULL),
('Candlewood Suites', 155, '2019-06-28', 211, NULL),
('Candlewood Suites', 155, '2019-06-29', 377, NULL),
('Candlewood Suites', 155, '2019-06-30', 279, NULL),
('Candlewood Suites', 155, '2019-07-01', 395, NULL),
('Candlewood Suites', 155, '2019-07-02', 199, NULL),
('Candlewood Suites', 155, '2019-07-03', 184, NULL),
('Candlewood Suites', 155, '2019-07-04', 303, NULL),
('Candlewood Suites', 155, '2019-07-05', 206, NULL),
('Candlewood Suites', 155, '2019-07-06', 322, NULL),
('Candlewood Suites', 155, '2019-07-07', 343, NULL),
('Candlewood Suites', 155, '2019-07-08', 327, NULL),
('Candlewood Suites', 155, '2019-07-09', 311, NULL),
('Candlewood Suites', 155, '2019-07-10', 273, NULL),
('Candlewood Suites', 155, '2019-07-11', 274, NULL),
('Candlewood Suites', 155, '2019-07-12', 134, NULL),
('Candlewood Suites', 155, '2019-07-13', 119, NULL),
('Candlewood Suites', 155, '2019-07-14', 236, NULL),
('Candlewood Suites', 155, '2019-07-15', 134, NULL),
('Candlewood Suites', 155, '2019-07-16', 146, NULL),
('Candlewood Suites', 155, '2019-07-17', 260, NULL),
('Candlewood Suites', 155, '2019-07-18', 266, NULL),
('Candlewood Suites', 155, '2019-07-19', 343, NULL),
('Candlewood Suites', 155, '2019-07-20', 367, NULL),
('Candlewood Suites', 155, '2019-07-21', 126, NULL),
('Candlewood Suites', 155, '2019-07-22', 231, NULL),
('Candlewood Suites', 155, '2019-07-23', 394, NULL),
('Candlewood Suites', 155, '2019-07-24', 100, NULL),
('Candlewood Suites', 155, '2019-07-25', 399, NULL),
('Candlewood Suites', 155, '2019-07-26', 231, NULL),
('Candlewood Suites', 155, '2019-07-27', 141, NULL),
('Candlewood Suites', 155, '2019-07-28', 333, NULL),
('Candlewood Suites', 155, '2019-07-29', 126, NULL),
('Candlewood Suites', 155, '2019-07-30', 202, NULL),
('Candlewood Suites', 155, '2019-07-31', 323, NULL),
('Candlewood Suites', 155, '2019-08-01', 234, NULL),
('Candlewood Suites', 155, '2019-08-02', 323, NULL),
('Candlewood Suites', 155, '2019-08-03', 250, NULL),
('Candlewood Suites', 155, '2019-08-04', 321, NULL),
('Candlewood Suites', 155, '2019-08-05', 199, NULL),
('Candlewood Suites', 155, '2019-08-06', 297, NULL),
('Candlewood Suites', 155, '2019-08-07', 247, NULL),
('Candlewood Suites', 155, '2019-08-08', 242, NULL),
('Candlewood Suites', 155, '2019-08-09', 216, NULL),
('Candlewood Suites', 155, '2019-08-10', 343, NULL),
('Candlewood Suites', 155, '2019-08-11', 354, NULL),
('Candlewood Suites', 155, '2019-08-12', 184, NULL),
('Candlewood Suites', 155, '2019-08-13', 113, NULL),
('Candlewood Suites', 155, '2019-08-14', 385, NULL),
('Candlewood Suites', 155, '2019-08-15', 213, NULL),
('Candlewood Suites', 155, '2019-08-16', 130, NULL),
('Candlewood Suites', 155, '2019-08-17', 110, NULL),
('Candlewood Suites', 155, '2019-08-18', 134, NULL),
('Candlewood Suites', 155, '2019-08-19', 112, NULL),
('Candlewood Suites', 155, '2019-08-20', 273, NULL),
('Candlewood Suites', 155, '2019-08-21', 177, NULL),
('Candlewood Suites', 155, '2019-08-22', 365, NULL),
('Candlewood Suites', 155, '2019-08-23', 397, NULL),
('Candlewood Suites', 155, '2019-08-24', 177, NULL),
('Candlewood Suites', 155, '2019-08-25', 110, NULL),
('Candlewood Suites', 155, '2019-08-26', 272, NULL),
('Candlewood Suites', 155, '2019-08-27', 229, NULL),
('Candlewood Suites', 155, '2019-08-28', 198, NULL),
('Candlewood Suites', 155, '2019-08-29', 295, NULL),
('Candlewood Suites', 155, '2019-08-30', 193, NULL),
('Candlewood Suites', 155, '2019-08-31', 190, NULL),
('Candlewood Suites', 155, '2019-09-01', 224, NULL),
('Candlewood Suites', 155, '2019-09-02', 371, NULL),
('Candlewood Suites', 155, '2019-09-03', 283, NULL),
('Candlewood Suites', 155, '2019-09-04', 294, NULL),
('Candlewood Suites', 155, '2019-09-05', 292, NULL),
('Candlewood Suites', 155, '2019-09-06', 336, NULL),
('Candlewood Suites', 155, '2019-09-07', 364, NULL),
('Candlewood Suites', 155, '2019-09-08', 123, NULL),
('Candlewood Suites', 155, '2019-09-09', 147, NULL),
('Candlewood Suites', 155, '2019-09-10', 328, NULL),
('Candlewood Suites', 155, '2019-09-11', 146, NULL),
('Candlewood Suites', 155, '2019-09-12', 269, NULL),
('Candlewood Suites', 155, '2019-09-13', 393, NULL),
('Candlewood Suites', 155, '2019-09-14', 224, NULL),
('Candlewood Suites', 155, '2019-09-15', 355, NULL),
('Candlewood Suites', 155, '2019-09-16', 251, NULL),
('Candlewood Suites', 155, '2019-09-17', 200, NULL),
('Candlewood Suites', 155, '2019-09-18', 269, NULL),
('Candlewood Suites', 155, '2019-09-19', 339, NULL),
('Candlewood Suites', 155, '2019-09-20', 347, NULL),
('Candlewood Suites', 155, '2019-09-21', 102, NULL),
('Candlewood Suites', 155, '2019-09-22', 220, NULL),
('Candlewood Suites', 155, '2019-09-23', 373, NULL),
('Candlewood Suites', 155, '2019-09-24', 274, NULL),
('Candlewood Suites', 155, '2019-09-25', 146, NULL),
('Candlewood Suites', 155, '2019-09-26', 261, NULL),
('Candlewood Suites', 155, '2019-09-27', 153, NULL),
('Candlewood Suites', 155, '2019-09-28', 154, NULL),
('Candlewood Suites', 155, '2019-09-29', 289, NULL),
('Candlewood Suites', 155, '2019-09-30', 227, NULL),
('Candlewood Suites', 155, '2019-10-01', 377, NULL),
('Candlewood Suites', 155, '2019-10-02', 395, NULL),
('Candlewood Suites', 155, '2019-10-03', 164, NULL),
('Candlewood Suites', 155, '2019-10-04', 151, NULL),
('Candlewood Suites', 155, '2019-10-05', 196, NULL),
('Candlewood Suites', 155, '2019-10-06', 162, NULL),
('Candlewood Suites', 155, '2019-10-07', 362, NULL),
('Candlewood Suites', 155, '2019-10-08', 161, NULL),
('Candlewood Suites', 155, '2019-10-09', 279, NULL),
('Candlewood Suites', 155, '2019-10-10', 179, NULL),
('Candlewood Suites', 155, '2019-10-11', 240, NULL),
('Candlewood Suites', 155, '2019-10-12', 347, NULL),
('Candlewood Suites', 155, '2019-10-13', 179, NULL),
('Candlewood Suites', 155, '2019-10-14', 250, NULL),
('Candlewood Suites', 155, '2019-10-15', 340, NULL),
('Candlewood Suites', 155, '2019-10-16', 277, NULL),
('Candlewood Suites', 155, '2019-10-17', 205, NULL),
('Candlewood Suites', 155, '2019-10-18', 223, NULL),
('Candlewood Suites', 155, '2019-10-19', 122, NULL),
('Candlewood Suites', 155, '2019-10-20', 248, NULL),
('Candlewood Suites', 155, '2019-10-21', 251, NULL),
('Candlewood Suites', 155, '2019-10-22', 212, NULL),
('Candlewood Suites', 155, '2019-10-23', 118, NULL),
('Candlewood Suites', 155, '2019-10-24', 358, NULL),
('Candlewood Suites', 155, '2019-10-25', 316, NULL),
('Candlewood Suites', 155, '2019-10-26', 306, NULL),
('Candlewood Suites', 155, '2019-10-27', 338, NULL),
('Candlewood Suites', 155, '2019-10-28', 369, NULL),
('Candlewood Suites', 155, '2019-10-29', 193, NULL),
('Candlewood Suites', 155, '2019-10-30', 138, NULL),
('Candlewood Suites', 155, '2019-10-31', 111, NULL),
('Candlewood Suites', 155, '2019-11-01', 276, NULL),
('Candlewood Suites', 155, '2019-11-02', 210, NULL),
('Candlewood Suites', 155, '2019-11-03', 114, NULL),
('Candlewood Suites', 155, '2019-11-04', 166, NULL),
('Candlewood Suites', 155, '2019-11-05', 278, NULL),
('Candlewood Suites', 155, '2019-11-06', 248, NULL),
('Candlewood Suites', 155, '2019-11-07', 275, NULL),
('Candlewood Suites', 155, '2019-11-08', 323, NULL),
('Candlewood Suites', 155, '2019-11-09', 379, NULL),
('Candlewood Suites', 155, '2019-11-10', 152, NULL),
('Candlewood Suites', 155, '2019-11-11', 299, NULL),
('Candlewood Suites', 155, '2019-11-12', 280, NULL),
('Candlewood Suites', 155, '2019-11-13', 366, NULL),
('Candlewood Suites', 155, '2019-11-14', 226, NULL),
('Candlewood Suites', 155, '2019-11-15', 320, NULL),
('Candlewood Suites', 155, '2019-11-16', 389, NULL),
('Candlewood Suites', 155, '2019-11-17', 398, NULL),
('Candlewood Suites', 155, '2019-11-18', 110, NULL),
('Candlewood Suites', 155, '2019-11-19', 124, NULL),
('Candlewood Suites', 155, '2019-11-20', 334, NULL),
('Candlewood Suites', 155, '2019-11-21', 378, NULL),
('Candlewood Suites', 155, '2019-11-22', 108, NULL),
('Candlewood Suites', 155, '2019-11-23', 244, NULL),
('Candlewood Suites', 155, '2019-11-24', 231, NULL),
('Candlewood Suites', 155, '2019-11-25', 243, NULL),
('Candlewood Suites', 155, '2019-11-26', 157, NULL),
('Candlewood Suites', 155, '2019-11-27', 357, NULL),
('Candlewood Suites', 155, '2019-11-28', 269, NULL),
('Candlewood Suites', 155, '2019-11-29', 165, NULL),
('Candlewood Suites', 155, '2019-11-30', 120, NULL),
('Candlewood Suites', 155, '2019-12-01', 108, NULL),
('Candlewood Suites', 155, '2019-12-02', 396, NULL),
('Candlewood Suites', 155, '2019-12-03', 104, NULL),
('Candlewood Suites', 155, '2019-12-04', 168, NULL),
('Candlewood Suites', 155, '2019-12-05', 306, NULL),
('Candlewood Suites', 155, '2019-12-06', 144, NULL),
('Candlewood Suites', 155, '2019-12-07', 353, NULL),
('Candlewood Suites', 155, '2019-12-08', 391, NULL),
('Candlewood Suites', 155, '2019-12-09', 214, NULL),
('Candlewood Suites', 155, '2019-12-10', 184, NULL),
('Candlewood Suites', 155, '2019-12-11', 175, NULL),
('Candlewood Suites', 155, '2019-12-12', 154, NULL),
('Candlewood Suites', 155, '2019-12-13', 329, NULL),
('Candlewood Suites', 155, '2019-12-14', 252, NULL),
('Candlewood Suites', 155, '2019-12-15', 218, NULL),
('Candlewood Suites', 155, '2019-12-16', 302, NULL),
('Candlewood Suites', 155, '2019-12-17', 304, NULL),
('Candlewood Suites', 155, '2019-12-18', 118, NULL),
('Candlewood Suites', 155, '2019-12-19', 129, NULL),
('Candlewood Suites', 155, '2019-12-20', 154, NULL),
('Candlewood Suites', 155, '2019-12-21', 359, NULL),
('Candlewood Suites', 155, '2019-12-22', 177, NULL),
('Candlewood Suites', 155, '2019-12-23', 390, NULL),
('Candlewood Suites', 155, '2019-12-24', 363, NULL),
('Candlewood Suites', 155, '2019-12-25', 206, NULL),
('Candlewood Suites', 155, '2019-12-26', 258, NULL),
('Candlewood Suites', 155, '2019-12-27', 156, NULL),
('Candlewood Suites', 155, '2019-12-28', 254, NULL),
('Candlewood Suites', 155, '2019-12-29', 298, NULL),
('Candlewood Suites', 155, '2019-12-30', 196, NULL),
('Candlewood Suites', 155, '2019-12-31', 248, NULL),
('Candlewood Suites', 155, '2020-01-01', 121, NULL),
('Candlewood Suites', 155, '2020-01-02', 165, NULL),
('Candlewood Suites', 155, '2020-01-03', 360, NULL),
('Candlewood Suites', 155, '2020-01-04', 385, NULL),
('Candlewood Suites', 155, '2020-01-05', 218, NULL),
('Candlewood Suites', 155, '2020-01-06', 104, NULL),
('Candlewood Suites', 155, '2020-01-07', 116, NULL),
('Candlewood Suites', 155, '2020-01-08', 259, NULL),
('Candlewood Suites', 155, '2020-01-09', 235, NULL),
('Candlewood Suites', 155, '2020-01-10', 241, NULL),
('Candlewood Suites', 155, '2020-01-11', 272, NULL),
('Candlewood Suites', 155, '2020-01-12', 363, NULL),
('Candlewood Suites', 155, '2020-01-13', 120, NULL),
('Candlewood Suites', 155, '2020-01-14', 128, NULL),
('Candlewood Suites', 155, '2020-01-15', 231, NULL),
('Candlewood Suites', 155, '2020-01-16', 240, NULL),
('Candlewood Suites', 155, '2020-01-17', 157, NULL),
('Candlewood Suites', 155, '2020-01-18', 232, NULL),
('Candlewood Suites', 155, '2020-01-19', 197, NULL),
('Candlewood Suites', 155, '2020-01-20', 224, NULL),
('Candlewood Suites', 155, '2020-01-21', 336, NULL),
('Candlewood Suites', 155, '2020-01-22', 382, NULL),
('Candlewood Suites', 155, '2020-01-23', 200, NULL),
('Candlewood Suites', 155, '2020-01-24', 394, NULL),
('Candlewood Suites', 155, '2020-01-25', 325, NULL),
('Candlewood Suites', 155, '2020-01-26', 360, NULL),
('Candlewood Suites', 155, '2020-01-27', 224, NULL),
('Candlewood Suites', 155, '2020-01-28', 191, NULL),
('Candlewood Suites', 155, '2020-01-29', 358, NULL),
('Candlewood Suites', 155, '2020-01-30', 123, NULL),
('Candlewood Suites', 155, '2020-01-31', 119, NULL),
('Candlewood Suites', 155, '2020-02-01', 370, NULL),
('Candlewood Suites', 155, '2020-02-02', 338, NULL),
('Candlewood Suites', 155, '2020-02-03', 140, NULL),
('Candlewood Suites', 155, '2020-02-04', 247, NULL),
('Candlewood Suites', 157, '2019-01-01', 176, NULL),
('Candlewood Suites', 157, '2019-01-02', 110, NULL),
('Candlewood Suites', 157, '2019-01-03', 200, NULL),
('Candlewood Suites', 157, '2019-01-04', 384, NULL),
('Candlewood Suites', 157, '2019-01-05', 218, NULL),
('Candlewood Suites', 157, '2019-01-06', 321, NULL),
('Candlewood Suites', 157, '2019-01-07', 130, NULL),
('Candlewood Suites', 157, '2019-01-08', 174, NULL),
('Candlewood Suites', 157, '2019-01-09', 398, NULL),
('Candlewood Suites', 157, '2019-01-10', 157, NULL),
('Candlewood Suites', 157, '2019-01-11', 236, NULL),
('Candlewood Suites', 157, '2019-01-12', 342, NULL),
('Candlewood Suites', 157, '2019-01-13', 142, NULL),
('Candlewood Suites', 157, '2019-01-14', 385, NULL),
('Candlewood Suites', 157, '2019-01-15', 185, NULL),
('Candlewood Suites', 157, '2019-01-16', 305, NULL),
('Candlewood Suites', 157, '2019-01-17', 397, NULL),
('Candlewood Suites', 157, '2019-01-18', 213, NULL),
('Candlewood Suites', 157, '2019-01-19', 114, NULL),
('Candlewood Suites', 157, '2019-01-20', 229, NULL),
('Candlewood Suites', 157, '2019-01-21', 269, NULL),
('Candlewood Suites', 157, '2019-01-22', 232, NULL),
('Candlewood Suites', 157, '2019-01-23', 271, NULL),
('Candlewood Suites', 157, '2019-01-24', 320, NULL),
('Candlewood Suites', 157, '2019-01-25', 372, NULL),
('Candlewood Suites', 157, '2019-01-26', 214, NULL),
('Candlewood Suites', 157, '2019-01-27', 320, NULL),
('Candlewood Suites', 157, '2019-01-28', 148, NULL),
('Candlewood Suites', 157, '2019-01-29', 221, NULL),
('Candlewood Suites', 157, '2019-01-30', 308, NULL),
('Candlewood Suites', 157, '2019-01-31', 202, NULL),
('Candlewood Suites', 157, '2019-02-01', 253, NULL),
('Candlewood Suites', 157, '2019-02-02', 378, NULL),
('Candlewood Suites', 157, '2019-02-03', 179, NULL),
('Candlewood Suites', 157, '2019-02-04', 185, NULL),
('Candlewood Suites', 157, '2019-02-05', 186, NULL),
('Candlewood Suites', 157, '2019-02-06', 154, NULL),
('Candlewood Suites', 157, '2019-02-07', 220, NULL),
('Candlewood Suites', 157, '2019-02-08', 111, NULL),
('Candlewood Suites', 157, '2019-02-09', 347, NULL),
('Candlewood Suites', 157, '2019-02-10', 291, NULL),
('Candlewood Suites', 157, '2019-02-11', 216, NULL),
('Candlewood Suites', 157, '2019-02-12', 223, NULL),
('Candlewood Suites', 157, '2019-02-13', 152, NULL),
('Candlewood Suites', 157, '2019-02-14', 234, NULL),
('Candlewood Suites', 157, '2019-02-15', 173, NULL),
('Candlewood Suites', 157, '2019-02-16', 228, NULL),
('Candlewood Suites', 157, '2019-02-17', 145, NULL),
('Candlewood Suites', 157, '2019-02-18', 381, NULL),
('Candlewood Suites', 157, '2019-02-19', 255, NULL),
('Candlewood Suites', 157, '2019-02-20', 295, NULL),
('Candlewood Suites', 157, '2019-02-21', 106, NULL),
('Candlewood Suites', 157, '2019-02-22', 124, NULL),
('Candlewood Suites', 157, '2019-02-23', 295, NULL),
('Candlewood Suites', 157, '2019-02-24', 244, NULL),
('Candlewood Suites', 157, '2019-02-25', 163, NULL),
('Candlewood Suites', 157, '2019-02-26', 145, NULL),
('Candlewood Suites', 157, '2019-02-27', 361, NULL),
('Candlewood Suites', 157, '2019-02-28', 211, NULL),
('Candlewood Suites', 157, '2019-03-01', 262, NULL),
('Candlewood Suites', 157, '2019-03-02', 239, NULL),
('Candlewood Suites', 157, '2019-03-03', 175, NULL),
('Candlewood Suites', 157, '2019-03-04', 230, NULL),
('Candlewood Suites', 157, '2019-03-05', 173, NULL),
('Candlewood Suites', 157, '2019-03-06', 238, NULL),
('Candlewood Suites', 157, '2019-03-07', 265, NULL),
('Candlewood Suites', 157, '2019-03-08', 323, NULL),
('Candlewood Suites', 157, '2019-03-09', 213, NULL),
('Candlewood Suites', 157, '2019-03-10', 227, NULL),
('Candlewood Suites', 157, '2019-03-11', 178, NULL),
('Candlewood Suites', 157, '2019-03-12', 135, NULL),
('Candlewood Suites', 157, '2019-03-13', 248, NULL),
('Candlewood Suites', 157, '2019-03-14', 349, NULL),
('Candlewood Suites', 157, '2019-03-15', 261, NULL),
('Candlewood Suites', 157, '2019-03-16', 271, NULL),
('Candlewood Suites', 157, '2019-03-17', 128, NULL),
('Candlewood Suites', 157, '2019-03-18', 177, NULL),
('Candlewood Suites', 157, '2019-03-19', 378, NULL),
('Candlewood Suites', 157, '2019-03-20', 376, NULL),
('Candlewood Suites', 157, '2019-03-21', 202, NULL),
('Candlewood Suites', 157, '2019-03-22', 390, NULL),
('Candlewood Suites', 157, '2019-03-23', 336, NULL),
('Candlewood Suites', 157, '2019-03-24', 245, NULL),
('Candlewood Suites', 157, '2019-03-25', 258, NULL),
('Candlewood Suites', 157, '2019-03-26', 359, NULL),
('Candlewood Suites', 157, '2019-03-27', 329, NULL),
('Candlewood Suites', 157, '2019-03-28', 331, NULL),
('Candlewood Suites', 157, '2019-03-29', 173, NULL),
('Candlewood Suites', 157, '2019-03-30', 194, NULL),
('Candlewood Suites', 157, '2019-03-31', 361, NULL),
('Candlewood Suites', 157, '2019-04-01', 210, NULL),
('Candlewood Suites', 157, '2019-04-02', 394, NULL),
('Candlewood Suites', 157, '2019-04-03', 197, NULL),
('Candlewood Suites', 157, '2019-04-04', 161, NULL),
('Candlewood Suites', 157, '2019-04-05', 156, NULL),
('Candlewood Suites', 157, '2019-04-06', 132, NULL),
('Candlewood Suites', 157, '2019-04-07', 257, NULL),
('Candlewood Suites', 157, '2019-04-08', 307, NULL),
('Candlewood Suites', 157, '2019-04-09', 259, NULL),
('Candlewood Suites', 157, '2019-04-10', 133, NULL),
('Candlewood Suites', 157, '2019-04-11', 143, NULL),
('Candlewood Suites', 157, '2019-04-12', 284, NULL),
('Candlewood Suites', 157, '2019-04-13', 123, NULL),
('Candlewood Suites', 157, '2019-04-14', 234, NULL),
('Candlewood Suites', 157, '2019-04-15', 165, NULL),
('Candlewood Suites', 157, '2019-04-16', 399, NULL),
('Candlewood Suites', 157, '2019-04-17', 274, NULL),
('Candlewood Suites', 157, '2019-04-18', 107, NULL),
('Candlewood Suites', 157, '2019-04-19', 117, NULL),
('Candlewood Suites', 157, '2019-04-20', 331, NULL),
('Candlewood Suites', 157, '2019-04-21', 185, NULL),
('Candlewood Suites', 157, '2019-04-22', 308, NULL),
('Candlewood Suites', 157, '2019-04-23', 228, NULL),
('Candlewood Suites', 157, '2019-04-24', 219, NULL),
('Candlewood Suites', 157, '2019-04-25', 102, NULL),
('Candlewood Suites', 157, '2019-04-26', 232, NULL),
('Candlewood Suites', 157, '2019-04-27', 328, NULL),
('Candlewood Suites', 157, '2019-04-28', 190, NULL),
('Candlewood Suites', 157, '2019-04-29', 259, NULL),
('Candlewood Suites', 157, '2019-04-30', 221, NULL),
('Candlewood Suites', 157, '2019-05-01', 129, NULL),
('Candlewood Suites', 157, '2019-05-02', 231, NULL),
('Candlewood Suites', 157, '2019-05-03', 177, NULL),
('Candlewood Suites', 157, '2019-05-04', 100, NULL),
('Candlewood Suites', 157, '2019-05-05', 389, NULL),
('Candlewood Suites', 157, '2019-05-06', 145, NULL),
('Candlewood Suites', 157, '2019-05-07', 335, NULL),
('Candlewood Suites', 157, '2019-05-08', 294, NULL),
('Candlewood Suites', 157, '2019-05-09', 373, NULL),
('Candlewood Suites', 157, '2019-05-10', 285, NULL),
('Candlewood Suites', 157, '2019-05-11', 137, NULL),
('Candlewood Suites', 157, '2019-05-12', 259, NULL),
('Candlewood Suites', 157, '2019-05-13', 300, NULL),
('Candlewood Suites', 157, '2019-05-14', 102, NULL),
('Candlewood Suites', 157, '2019-05-15', 227, NULL),
('Candlewood Suites', 157, '2019-05-16', 280, NULL),
('Candlewood Suites', 157, '2019-05-17', 245, NULL),
('Candlewood Suites', 157, '2019-05-18', 366, NULL),
('Candlewood Suites', 157, '2019-05-19', 362, NULL),
('Candlewood Suites', 157, '2019-05-20', 215, NULL),
('Candlewood Suites', 157, '2019-05-21', 135, NULL),
('Candlewood Suites', 157, '2019-05-22', 199, NULL),
('Candlewood Suites', 157, '2019-05-23', 322, NULL),
('Candlewood Suites', 157, '2019-05-24', 258, NULL),
('Candlewood Suites', 157, '2019-05-25', 244, NULL),
('Candlewood Suites', 157, '2019-05-26', 216, NULL),
('Candlewood Suites', 157, '2019-05-27', 279, NULL),
('Candlewood Suites', 157, '2019-05-28', 248, NULL),
('Candlewood Suites', 157, '2019-05-29', 152, NULL),
('Candlewood Suites', 157, '2019-05-30', 111, NULL),
('Candlewood Suites', 157, '2019-05-31', 209, NULL),
('Candlewood Suites', 157, '2019-06-01', 214, NULL),
('Candlewood Suites', 157, '2019-06-02', 277, NULL),
('Candlewood Suites', 157, '2019-06-03', 356, NULL),
('Candlewood Suites', 157, '2019-06-04', 322, NULL),
('Candlewood Suites', 157, '2019-06-05', 319, NULL),
('Candlewood Suites', 157, '2019-06-06', 396, NULL),
('Candlewood Suites', 157, '2019-06-07', 337, NULL),
('Candlewood Suites', 157, '2019-06-08', 355, NULL),
('Candlewood Suites', 157, '2019-06-09', 291, NULL),
('Candlewood Suites', 157, '2019-06-10', 338, NULL),
('Candlewood Suites', 157, '2019-06-11', 261, NULL),
('Candlewood Suites', 157, '2019-06-12', 127, NULL),
('Candlewood Suites', 157, '2019-06-13', 310, NULL),
('Candlewood Suites', 157, '2019-06-14', 136, NULL),
('Candlewood Suites', 157, '2019-06-15', 387, NULL),
('Candlewood Suites', 157, '2019-06-16', 104, NULL),
('Candlewood Suites', 157, '2019-06-17', 179, NULL),
('Candlewood Suites', 157, '2019-06-18', 389, NULL),
('Candlewood Suites', 157, '2019-06-19', 275, NULL),
('Candlewood Suites', 157, '2019-06-20', 283, NULL),
('Candlewood Suites', 157, '2019-06-21', 228, NULL),
('Candlewood Suites', 157, '2019-06-22', 386, NULL),
('Candlewood Suites', 157, '2019-06-23', 152, NULL),
('Candlewood Suites', 157, '2019-06-24', 155, NULL),
('Candlewood Suites', 157, '2019-06-25', 355, NULL),
('Candlewood Suites', 157, '2019-06-26', 398, NULL),
('Candlewood Suites', 157, '2019-06-27', 243, NULL),
('Candlewood Suites', 157, '2019-06-28', 214, NULL),
('Candlewood Suites', 157, '2019-06-29', 187, NULL),
('Candlewood Suites', 157, '2019-06-30', 180, NULL),
('Candlewood Suites', 157, '2019-07-01', 215, NULL),
('Candlewood Suites', 157, '2019-07-02', 355, NULL),
('Candlewood Suites', 157, '2019-07-03', 109, NULL),
('Candlewood Suites', 157, '2019-07-04', 322, NULL),
('Candlewood Suites', 157, '2019-07-05', 208, NULL),
('Candlewood Suites', 157, '2019-07-06', 232, NULL),
('Candlewood Suites', 157, '2019-07-07', 286, NULL),
('Candlewood Suites', 157, '2019-07-08', 239, NULL),
('Candlewood Suites', 157, '2019-07-09', 177, NULL),
('Candlewood Suites', 157, '2019-07-10', 336, NULL),
('Candlewood Suites', 157, '2019-07-11', 148, NULL),
('Candlewood Suites', 157, '2019-07-12', 191, NULL),
('Candlewood Suites', 157, '2019-07-13', 235, NULL),
('Candlewood Suites', 157, '2019-07-14', 320, NULL),
('Candlewood Suites', 157, '2019-07-15', 102, NULL),
('Candlewood Suites', 157, '2019-07-16', 311, NULL),
('Candlewood Suites', 157, '2019-07-17', 146, NULL),
('Candlewood Suites', 157, '2019-07-18', 360, NULL),
('Candlewood Suites', 157, '2019-07-19', 250, NULL),
('Candlewood Suites', 157, '2019-07-20', 136, NULL),
('Candlewood Suites', 157, '2019-07-21', 118, NULL),
('Candlewood Suites', 157, '2019-07-22', 223, NULL),
('Candlewood Suites', 157, '2019-07-23', 293, NULL),
('Candlewood Suites', 157, '2019-07-24', 399, NULL),
('Candlewood Suites', 157, '2019-07-25', 297, NULL),
('Candlewood Suites', 157, '2019-07-26', 126, NULL),
('Candlewood Suites', 157, '2019-07-27', 122, NULL),
('Candlewood Suites', 157, '2019-07-28', 114, NULL),
('Candlewood Suites', 157, '2019-07-29', 128, NULL),
('Candlewood Suites', 157, '2019-07-30', 258, NULL),
('Candlewood Suites', 157, '2019-07-31', 116, NULL),
('Candlewood Suites', 157, '2019-08-01', 265, NULL),
('Candlewood Suites', 157, '2019-08-02', 257, NULL),
('Candlewood Suites', 157, '2019-08-03', 284, NULL),
('Candlewood Suites', 157, '2019-08-04', 346, NULL),
('Candlewood Suites', 157, '2019-08-05', 386, NULL),
('Candlewood Suites', 157, '2019-08-06', 215, NULL),
('Candlewood Suites', 157, '2019-08-07', 365, NULL),
('Candlewood Suites', 157, '2019-08-08', 175, NULL),
('Candlewood Suites', 157, '2019-08-09', 310, NULL),
('Candlewood Suites', 157, '2019-08-10', 247, NULL),
('Candlewood Suites', 157, '2019-08-11', 130, NULL),
('Candlewood Suites', 157, '2019-08-12', 194, NULL),
('Candlewood Suites', 157, '2019-08-13', 280, NULL),
('Candlewood Suites', 157, '2019-08-14', 223, NULL),
('Candlewood Suites', 157, '2019-08-15', 271, NULL),
('Candlewood Suites', 157, '2019-08-16', 121, NULL),
('Candlewood Suites', 157, '2019-08-17', 342, NULL),
('Candlewood Suites', 157, '2019-08-18', 337, NULL),
('Candlewood Suites', 157, '2019-08-19', 386, NULL),
('Candlewood Suites', 157, '2019-08-20', 373, NULL),
('Candlewood Suites', 157, '2019-08-21', 331, NULL),
('Candlewood Suites', 157, '2019-08-22', 121, NULL),
('Candlewood Suites', 157, '2019-08-23', 169, NULL),
('Candlewood Suites', 157, '2019-08-24', 199, NULL),
('Candlewood Suites', 157, '2019-08-25', 266, NULL),
('Candlewood Suites', 157, '2019-08-26', 242, NULL),
('Candlewood Suites', 157, '2019-08-27', 111, NULL),
('Candlewood Suites', 157, '2019-08-28', 308, NULL),
('Candlewood Suites', 157, '2019-08-29', 100, NULL),
('Candlewood Suites', 157, '2019-08-30', 349, NULL),
('Candlewood Suites', 157, '2019-08-31', 205, NULL),
('Candlewood Suites', 157, '2019-09-01', 202, NULL),
('Candlewood Suites', 157, '2019-09-02', 134, NULL),
('Candlewood Suites', 157, '2019-09-03', 210, NULL),
('Candlewood Suites', 157, '2019-09-04', 353, NULL),
('Candlewood Suites', 157, '2019-09-05', 221, NULL),
('Candlewood Suites', 157, '2019-09-06', 210, NULL),
('Candlewood Suites', 157, '2019-09-07', 155, NULL),
('Candlewood Suites', 157, '2019-09-08', 102, NULL),
('Candlewood Suites', 157, '2019-09-09', 255, NULL),
('Candlewood Suites', 157, '2019-09-10', 232, NULL),
('Candlewood Suites', 157, '2019-09-11', 309, NULL),
('Candlewood Suites', 157, '2019-09-12', 241, NULL),
('Candlewood Suites', 157, '2019-09-13', 363, NULL),
('Candlewood Suites', 157, '2019-09-14', 280, NULL),
('Candlewood Suites', 157, '2019-09-15', 172, NULL),
('Candlewood Suites', 157, '2019-09-16', 238, NULL),
('Candlewood Suites', 157, '2019-09-17', 143, NULL),
('Candlewood Suites', 157, '2019-09-18', 222, NULL),
('Candlewood Suites', 157, '2019-09-19', 178, NULL),
('Candlewood Suites', 157, '2019-09-20', 184, NULL),
('Candlewood Suites', 157, '2019-09-21', 245, NULL),
('Candlewood Suites', 157, '2019-09-22', 323, NULL),
('Candlewood Suites', 157, '2019-09-23', 163, NULL),
('Candlewood Suites', 157, '2019-09-24', 387, NULL),
('Candlewood Suites', 157, '2019-09-25', 377, NULL),
('Candlewood Suites', 157, '2019-09-26', 131, NULL),
('Candlewood Suites', 157, '2019-09-27', 270, NULL),
('Candlewood Suites', 157, '2019-09-28', 132, NULL),
('Candlewood Suites', 157, '2019-09-29', 297, NULL),
('Candlewood Suites', 157, '2019-09-30', 195, NULL),
('Candlewood Suites', 157, '2019-10-01', 286, NULL),
('Candlewood Suites', 157, '2019-10-02', 112, NULL),
('Candlewood Suites', 157, '2019-10-03', 391, NULL),
('Candlewood Suites', 157, '2019-10-04', 331, NULL),
('Candlewood Suites', 157, '2019-10-05', 268, NULL),
('Candlewood Suites', 157, '2019-10-06', 374, NULL),
('Candlewood Suites', 157, '2019-10-07', 212, NULL),
('Candlewood Suites', 157, '2019-10-08', 372, NULL),
('Candlewood Suites', 157, '2019-10-09', 272, NULL),
('Candlewood Suites', 157, '2019-10-10', 278, NULL),
('Candlewood Suites', 157, '2019-10-11', 320, NULL),
('Candlewood Suites', 157, '2019-10-12', 144, NULL),
('Candlewood Suites', 157, '2019-10-13', 200, NULL),
('Candlewood Suites', 157, '2019-10-14', 261, NULL),
('Candlewood Suites', 157, '2019-10-15', 138, NULL),
('Candlewood Suites', 157, '2019-10-16', 324, NULL),
('Candlewood Suites', 157, '2019-10-17', 206, NULL),
('Candlewood Suites', 157, '2019-10-18', 327, NULL),
('Candlewood Suites', 157, '2019-10-19', 276, NULL),
('Candlewood Suites', 157, '2019-10-20', 122, NULL),
('Candlewood Suites', 157, '2019-10-21', 112, NULL),
('Candlewood Suites', 157, '2019-10-22', 202, NULL),
('Candlewood Suites', 157, '2019-10-23', 100, NULL),
('Candlewood Suites', 157, '2019-10-24', 227, NULL),
('Candlewood Suites', 157, '2019-10-25', 271, NULL),
('Candlewood Suites', 157, '2019-10-26', 190, NULL),
('Candlewood Suites', 157, '2019-10-27', 302, NULL),
('Candlewood Suites', 157, '2019-10-28', 158, NULL),
('Candlewood Suites', 157, '2019-10-29', 159, NULL),
('Candlewood Suites', 157, '2019-10-30', 376, NULL),
('Candlewood Suites', 157, '2019-10-31', 124, NULL),
('Candlewood Suites', 157, '2019-11-01', 192, NULL),
('Candlewood Suites', 157, '2019-11-02', 347, NULL),
('Candlewood Suites', 157, '2019-11-03', 326, NULL),
('Candlewood Suites', 157, '2019-11-04', 197, NULL),
('Candlewood Suites', 157, '2019-11-05', 363, NULL),
('Candlewood Suites', 157, '2019-11-06', 204, NULL),
('Candlewood Suites', 157, '2019-11-07', 242, NULL),
('Candlewood Suites', 157, '2019-11-08', 370, NULL),
('Candlewood Suites', 157, '2019-11-09', 210, NULL),
('Candlewood Suites', 157, '2019-11-10', 235, NULL),
('Candlewood Suites', 157, '2019-11-11', 172, NULL),
('Candlewood Suites', 157, '2019-11-12', 356, NULL),
('Candlewood Suites', 157, '2019-11-13', 348, NULL),
('Candlewood Suites', 157, '2019-11-14', 221, NULL),
('Candlewood Suites', 157, '2019-11-15', 314, NULL),
('Candlewood Suites', 157, '2019-11-16', 267, NULL),
('Candlewood Suites', 157, '2019-11-17', 141, NULL),
('Candlewood Suites', 157, '2019-11-18', 261, NULL),
('Candlewood Suites', 157, '2019-11-19', 369, NULL),
('Candlewood Suites', 157, '2019-11-20', 117, NULL),
('Candlewood Suites', 157, '2019-11-21', 208, NULL),
('Candlewood Suites', 157, '2019-11-22', 355, NULL),
('Candlewood Suites', 157, '2019-11-23', 223, NULL),
('Candlewood Suites', 157, '2019-11-24', 102, NULL),
('Candlewood Suites', 157, '2019-11-25', 230, NULL),
('Candlewood Suites', 157, '2019-11-26', 200, NULL),
('Candlewood Suites', 157, '2019-11-27', 362, NULL),
('Candlewood Suites', 157, '2019-11-28', 261, NULL),
('Candlewood Suites', 157, '2019-11-29', 197, NULL),
('Candlewood Suites', 157, '2019-11-30', 318, NULL),
('Candlewood Suites', 157, '2019-12-01', 351, NULL),
('Candlewood Suites', 157, '2019-12-02', 217, NULL),
('Candlewood Suites', 157, '2019-12-03', 157, NULL),
('Candlewood Suites', 157, '2019-12-04', 377, NULL),
('Candlewood Suites', 157, '2019-12-05', 187, NULL),
('Candlewood Suites', 157, '2019-12-06', 282, NULL),
('Candlewood Suites', 157, '2019-12-07', 357, NULL),
('Candlewood Suites', 157, '2019-12-08', 260, NULL),
('Candlewood Suites', 157, '2019-12-09', 303, NULL),
('Candlewood Suites', 157, '2019-12-10', 154, NULL),
('Candlewood Suites', 157, '2019-12-11', 213, NULL),
('Candlewood Suites', 157, '2019-12-12', 180, NULL),
('Candlewood Suites', 157, '2019-12-13', 268, NULL),
('Candlewood Suites', 157, '2019-12-14', 146, NULL),
('Candlewood Suites', 157, '2019-12-15', 119, NULL),
('Candlewood Suites', 157, '2019-12-16', 286, NULL),
('Candlewood Suites', 157, '2019-12-17', 246, NULL),
('Candlewood Suites', 157, '2019-12-18', 185, NULL),
('Candlewood Suites', 157, '2019-12-19', 147, NULL),
('Candlewood Suites', 157, '2019-12-20', 396, NULL),
('Candlewood Suites', 157, '2019-12-21', 169, NULL),
('Candlewood Suites', 157, '2019-12-22', 378, NULL),
('Candlewood Suites', 157, '2019-12-23', 358, NULL),
('Candlewood Suites', 157, '2019-12-24', 126, NULL),
('Candlewood Suites', 157, '2019-12-25', 380, NULL),
('Candlewood Suites', 157, '2019-12-26', 134, NULL),
('Candlewood Suites', 157, '2019-12-27', 379, NULL),
('Candlewood Suites', 157, '2019-12-28', 122, NULL),
('Candlewood Suites', 157, '2019-12-29', 115, NULL),
('Candlewood Suites', 157, '2019-12-30', 369, NULL),
('Candlewood Suites', 157, '2019-12-31', 220, NULL),
('Candlewood Suites', 157, '2020-01-01', 262, NULL),
('Candlewood Suites', 157, '2020-01-02', 274, NULL),
('Candlewood Suites', 157, '2020-01-03', 263, NULL),
('Candlewood Suites', 157, '2020-01-04', 188, NULL),
('Candlewood Suites', 157, '2020-01-05', 254, NULL),
('Candlewood Suites', 157, '2020-01-06', 208, NULL),
('Candlewood Suites', 157, '2020-01-07', 154, NULL),
('Candlewood Suites', 157, '2020-01-08', 265, NULL),
('Candlewood Suites', 157, '2020-01-09', 263, NULL),
('Candlewood Suites', 157, '2020-01-10', 318, NULL),
('Candlewood Suites', 157, '2020-01-11', 152, NULL),
('Candlewood Suites', 157, '2020-01-12', 272, NULL),
('Candlewood Suites', 157, '2020-01-13', 187, NULL),
('Candlewood Suites', 157, '2020-01-14', 128, NULL),
('Candlewood Suites', 157, '2020-01-15', 314, NULL),
('Candlewood Suites', 157, '2020-01-16', 367, NULL),
('Candlewood Suites', 157, '2020-01-17', 276, NULL),
('Candlewood Suites', 157, '2020-01-18', 380, NULL),
('Candlewood Suites', 157, '2020-01-19', 351, NULL),
('Candlewood Suites', 157, '2020-01-20', 289, NULL),
('Candlewood Suites', 157, '2020-01-21', 201, NULL),
('Candlewood Suites', 157, '2020-01-22', 388, NULL),
('Candlewood Suites', 157, '2020-01-23', 250, NULL),
('Candlewood Suites', 157, '2020-01-24', 187, NULL),
('Candlewood Suites', 157, '2020-01-25', 373, NULL),
('Candlewood Suites', 157, '2020-01-26', 348, NULL),
('Candlewood Suites', 157, '2020-01-27', 242, NULL),
('Candlewood Suites', 157, '2020-01-28', 146, NULL),
('Candlewood Suites', 157, '2020-01-29', 211, NULL),
('Candlewood Suites', 157, '2020-01-30', 123, NULL),
('Candlewood Suites', 157, '2020-01-31', 245, NULL),
('Candlewood Suites', 157, '2020-02-01', 129, NULL),
('Candlewood Suites', 157, '2020-02-02', 123, NULL),
('Candlewood Suites', 157, '2020-02-03', 350, NULL),
('Candlewood Suites', 157, '2020-02-04', 207, NULL),
('Candlewood Suites', 158, '2019-01-01', 391, NULL),
('Candlewood Suites', 158, '2019-01-02', 362, NULL),
('Candlewood Suites', 158, '2019-01-03', 220, NULL),
('Candlewood Suites', 158, '2019-01-04', 286, NULL),
('Candlewood Suites', 158, '2019-01-05', 316, NULL),
('Candlewood Suites', 158, '2019-01-06', 193, NULL),
('Candlewood Suites', 158, '2019-01-07', 240, NULL),
('Candlewood Suites', 158, '2019-01-08', 243, NULL),
('Candlewood Suites', 158, '2019-01-09', 190, NULL),
('Candlewood Suites', 158, '2019-01-10', 218, NULL),
('Candlewood Suites', 158, '2019-01-11', 164, NULL),
('Candlewood Suites', 158, '2019-01-12', 111, NULL),
('Candlewood Suites', 158, '2019-01-13', 394, NULL),
('Candlewood Suites', 158, '2019-01-14', 339, NULL),
('Candlewood Suites', 158, '2019-01-15', 300, NULL),
('Candlewood Suites', 158, '2019-01-16', 158, NULL),
('Candlewood Suites', 158, '2019-01-17', 395, NULL),
('Candlewood Suites', 158, '2019-01-18', 255, NULL),
('Candlewood Suites', 158, '2019-01-19', 157, NULL),
('Candlewood Suites', 158, '2019-01-20', 120, NULL),
('Candlewood Suites', 158, '2019-01-21', 237, NULL),
('Candlewood Suites', 158, '2019-01-22', 209, NULL),
('Candlewood Suites', 158, '2019-01-23', 230, NULL),
('Candlewood Suites', 158, '2019-01-24', 107, NULL),
('Candlewood Suites', 158, '2019-01-25', 165, NULL),
('Candlewood Suites', 158, '2019-01-26', 126, NULL),
('Candlewood Suites', 158, '2019-01-27', 202, NULL),
('Candlewood Suites', 158, '2019-01-28', 186, NULL),
('Candlewood Suites', 158, '2019-01-29', 389, NULL),
('Candlewood Suites', 158, '2019-01-30', 307, NULL),
('Candlewood Suites', 158, '2019-01-31', 175, NULL),
('Candlewood Suites', 158, '2019-02-01', 194, NULL),
('Candlewood Suites', 158, '2019-02-02', 132, NULL),
('Candlewood Suites', 158, '2019-02-03', 236, NULL),
('Candlewood Suites', 158, '2019-02-04', 261, NULL),
('Candlewood Suites', 158, '2019-02-05', 126, NULL),
('Candlewood Suites', 158, '2019-02-06', 352, NULL),
('Candlewood Suites', 158, '2019-02-07', 262, NULL),
('Candlewood Suites', 158, '2019-02-08', 185, NULL),
('Candlewood Suites', 158, '2019-02-09', 151, NULL),
('Candlewood Suites', 158, '2019-02-10', 278, NULL),
('Candlewood Suites', 158, '2019-02-11', 107, NULL),
('Candlewood Suites', 158, '2019-02-12', 391, NULL),
('Candlewood Suites', 158, '2019-02-13', 274, NULL),
('Candlewood Suites', 158, '2019-02-14', 236, NULL),
('Candlewood Suites', 158, '2019-02-15', 340, NULL),
('Candlewood Suites', 158, '2019-02-16', 121, NULL),
('Candlewood Suites', 158, '2019-02-17', 223, NULL),
('Candlewood Suites', 158, '2019-02-18', 336, NULL),
('Candlewood Suites', 158, '2019-02-19', 303, NULL),
('Candlewood Suites', 158, '2019-02-20', 102, NULL),
('Candlewood Suites', 158, '2019-02-21', 164, NULL),
('Candlewood Suites', 158, '2019-02-22', 123, NULL),
('Candlewood Suites', 158, '2019-02-23', 321, NULL),
('Candlewood Suites', 158, '2019-02-24', 383, NULL),
('Candlewood Suites', 158, '2019-02-25', 318, NULL),
('Candlewood Suites', 158, '2019-02-26', 186, NULL),
('Candlewood Suites', 158, '2019-02-27', 225, NULL),
('Candlewood Suites', 158, '2019-02-28', 336, NULL),
('Candlewood Suites', 158, '2019-03-01', 318, NULL),
('Candlewood Suites', 158, '2019-03-02', 248, NULL),
('Candlewood Suites', 158, '2019-03-03', 103, NULL),
('Candlewood Suites', 158, '2019-03-04', 298, NULL),
('Candlewood Suites', 158, '2019-03-05', 393, NULL),
('Candlewood Suites', 158, '2019-03-06', 195, NULL),
('Candlewood Suites', 158, '2019-03-07', 176, NULL),
('Candlewood Suites', 158, '2019-03-08', 207, NULL),
('Candlewood Suites', 158, '2019-03-09', 274, NULL),
('Candlewood Suites', 158, '2019-03-10', 335, NULL),
('Candlewood Suites', 158, '2019-03-11', 290, NULL),
('Candlewood Suites', 158, '2019-03-12', 247, NULL),
('Candlewood Suites', 158, '2019-03-13', 180, NULL),
('Candlewood Suites', 158, '2019-03-14', 375, NULL),
('Candlewood Suites', 158, '2019-03-15', 188, NULL),
('Candlewood Suites', 158, '2019-03-16', 149, NULL),
('Candlewood Suites', 158, '2019-03-17', 112, NULL),
('Candlewood Suites', 158, '2019-03-18', 211, NULL),
('Candlewood Suites', 158, '2019-03-19', 267, NULL),
('Candlewood Suites', 158, '2019-03-20', 359, NULL),
('Candlewood Suites', 158, '2019-03-21', 356, NULL),
('Candlewood Suites', 158, '2019-03-22', 126, NULL),
('Candlewood Suites', 158, '2019-03-23', 159, NULL),
('Candlewood Suites', 158, '2019-03-24', 125, NULL),
('Candlewood Suites', 158, '2019-03-25', 229, NULL),
('Candlewood Suites', 158, '2019-03-26', 307, NULL),
('Candlewood Suites', 158, '2019-03-27', 354, NULL),
('Candlewood Suites', 158, '2019-03-28', 202, NULL),
('Candlewood Suites', 158, '2019-03-29', 355, NULL),
('Candlewood Suites', 158, '2019-03-30', 351, NULL),
('Candlewood Suites', 158, '2019-03-31', 169, NULL),
('Candlewood Suites', 158, '2019-04-01', 220, NULL),
('Candlewood Suites', 158, '2019-04-02', 167, NULL),
('Candlewood Suites', 158, '2019-04-03', 247, NULL),
('Candlewood Suites', 158, '2019-04-04', 203, NULL),
('Candlewood Suites', 158, '2019-04-05', 385, NULL),
('Candlewood Suites', 158, '2019-04-06', 263, NULL),
('Candlewood Suites', 158, '2019-04-07', 339, NULL),
('Candlewood Suites', 158, '2019-04-08', 297, NULL),
('Candlewood Suites', 158, '2019-04-09', 230, NULL),
('Candlewood Suites', 158, '2019-04-10', 188, NULL),
('Candlewood Suites', 158, '2019-04-11', 114, NULL),
('Candlewood Suites', 158, '2019-04-12', 106, NULL),
('Candlewood Suites', 158, '2019-04-13', 159, NULL),
('Candlewood Suites', 158, '2019-04-14', 165, NULL),
('Candlewood Suites', 158, '2019-04-15', 238, NULL),
('Candlewood Suites', 158, '2019-04-16', 125, NULL),
('Candlewood Suites', 158, '2019-04-17', 335, NULL),
('Candlewood Suites', 158, '2019-04-18', 337, NULL),
('Candlewood Suites', 158, '2019-04-19', 399, NULL),
('Candlewood Suites', 158, '2019-04-20', 126, NULL),
('Candlewood Suites', 158, '2019-04-21', 329, NULL),
('Candlewood Suites', 158, '2019-04-22', 117, NULL),
('Candlewood Suites', 158, '2019-04-23', 365, NULL),
('Candlewood Suites', 158, '2019-04-24', 221, NULL),
('Candlewood Suites', 158, '2019-04-25', 371, NULL),
('Candlewood Suites', 158, '2019-04-26', 338, NULL),
('Candlewood Suites', 158, '2019-04-27', 365, NULL),
('Candlewood Suites', 158, '2019-04-28', 258, NULL),
('Candlewood Suites', 158, '2019-04-29', 144, NULL),
('Candlewood Suites', 158, '2019-04-30', 262, NULL),
('Candlewood Suites', 158, '2019-05-01', 104, NULL),
('Candlewood Suites', 158, '2019-05-02', 137, NULL),
('Candlewood Suites', 158, '2019-05-03', 204, NULL),
('Candlewood Suites', 158, '2019-05-04', 327, NULL),
('Candlewood Suites', 158, '2019-05-05', 188, NULL),
('Candlewood Suites', 158, '2019-05-06', 124, NULL),
('Candlewood Suites', 158, '2019-05-07', 329, NULL),
('Candlewood Suites', 158, '2019-05-08', 143, NULL),
('Candlewood Suites', 158, '2019-05-09', 301, NULL),
('Candlewood Suites', 158, '2019-05-10', 321, NULL),
('Candlewood Suites', 158, '2019-05-11', 233, NULL),
('Candlewood Suites', 158, '2019-05-12', 120, NULL),
('Candlewood Suites', 158, '2019-05-13', 282, NULL),
('Candlewood Suites', 158, '2019-05-14', 105, NULL),
('Candlewood Suites', 158, '2019-05-15', 265, NULL),
('Candlewood Suites', 158, '2019-05-16', 207, NULL),
('Candlewood Suites', 158, '2019-05-17', 291, NULL),
('Candlewood Suites', 158, '2019-05-18', 222, NULL),
('Candlewood Suites', 158, '2019-05-19', 170, NULL),
('Candlewood Suites', 158, '2019-05-20', 345, NULL),
('Candlewood Suites', 158, '2019-05-21', 253, NULL),
('Candlewood Suites', 158, '2019-05-22', 273, NULL),
('Candlewood Suites', 158, '2019-05-23', 214, NULL),
('Candlewood Suites', 158, '2019-05-24', 353, NULL),
('Candlewood Suites', 158, '2019-05-25', 219, NULL),
('Candlewood Suites', 158, '2019-05-26', 216, NULL),
('Candlewood Suites', 158, '2019-05-27', 246, NULL),
('Candlewood Suites', 158, '2019-05-28', 342, NULL),
('Candlewood Suites', 158, '2019-05-29', 261, NULL),
('Candlewood Suites', 158, '2019-05-30', 373, NULL),
('Candlewood Suites', 158, '2019-05-31', 171, NULL),
('Candlewood Suites', 158, '2019-06-01', 377, NULL),
('Candlewood Suites', 158, '2019-06-02', 347, NULL),
('Candlewood Suites', 158, '2019-06-03', 182, NULL),
('Candlewood Suites', 158, '2019-06-04', 189, NULL),
('Candlewood Suites', 158, '2019-06-05', 363, NULL),
('Candlewood Suites', 158, '2019-06-06', 381, NULL),
('Candlewood Suites', 158, '2019-06-07', 209, NULL),
('Candlewood Suites', 158, '2019-06-08', 216, NULL),
('Candlewood Suites', 158, '2019-06-09', 377, NULL),
('Candlewood Suites', 158, '2019-06-10', 291, NULL),
('Candlewood Suites', 158, '2019-06-11', 315, NULL),
('Candlewood Suites', 158, '2019-06-12', 116, NULL),
('Candlewood Suites', 158, '2019-06-13', 124, NULL),
('Candlewood Suites', 158, '2019-06-14', 130, NULL),
('Candlewood Suites', 158, '2019-06-15', 251, NULL),
('Candlewood Suites', 158, '2019-06-16', 207, NULL),
('Candlewood Suites', 158, '2019-06-17', 147, NULL),
('Candlewood Suites', 158, '2019-06-18', 245, NULL),
('Candlewood Suites', 158, '2019-06-19', 363, NULL),
('Candlewood Suites', 158, '2019-06-20', 365, NULL),
('Candlewood Suites', 158, '2019-06-21', 330, NULL),
('Candlewood Suites', 158, '2019-06-22', 118, NULL),
('Candlewood Suites', 158, '2019-06-23', 167, NULL),
('Candlewood Suites', 158, '2019-06-24', 346, NULL),
('Candlewood Suites', 158, '2019-06-25', 388, NULL),
('Candlewood Suites', 158, '2019-06-26', 179, NULL),
('Candlewood Suites', 158, '2019-06-27', 394, NULL),
('Candlewood Suites', 158, '2019-06-28', 340, NULL),
('Candlewood Suites', 158, '2019-06-29', 305, NULL),
('Candlewood Suites', 158, '2019-06-30', 263, NULL),
('Candlewood Suites', 158, '2019-07-01', 389, NULL),
('Candlewood Suites', 158, '2019-07-02', 179, NULL),
('Candlewood Suites', 158, '2019-07-03', 192, NULL),
('Candlewood Suites', 158, '2019-07-04', 300, NULL),
('Candlewood Suites', 158, '2019-07-05', 323, NULL),
('Candlewood Suites', 158, '2019-07-06', 393, NULL),
('Candlewood Suites', 158, '2019-07-07', 299, NULL),
('Candlewood Suites', 158, '2019-07-08', 116, NULL),
('Candlewood Suites', 158, '2019-07-09', 152, NULL),
('Candlewood Suites', 158, '2019-07-10', 161, NULL),
('Candlewood Suites', 158, '2019-07-11', 120, NULL),
('Candlewood Suites', 158, '2019-07-12', 156, NULL),
('Candlewood Suites', 158, '2019-07-13', 117, NULL),
('Candlewood Suites', 158, '2019-07-14', 193, NULL),
('Candlewood Suites', 158, '2019-07-15', 308, NULL),
('Candlewood Suites', 158, '2019-07-16', 119, NULL),
('Candlewood Suites', 158, '2019-07-17', 152, NULL),
('Candlewood Suites', 158, '2019-07-18', 301, NULL),
('Candlewood Suites', 158, '2019-07-19', 121, NULL),
('Candlewood Suites', 158, '2019-07-20', 379, NULL),
('Candlewood Suites', 158, '2019-07-21', 112, NULL),
('Candlewood Suites', 158, '2019-07-22', 322, NULL),
('Candlewood Suites', 158, '2019-07-23', 183, NULL),
('Candlewood Suites', 158, '2019-07-24', 394, NULL),
('Candlewood Suites', 158, '2019-07-25', 186, NULL),
('Candlewood Suites', 158, '2019-07-26', 139, NULL),
('Candlewood Suites', 158, '2019-07-27', 387, NULL),
('Candlewood Suites', 158, '2019-07-28', 370, NULL),
('Candlewood Suites', 158, '2019-07-29', 160, NULL),
('Candlewood Suites', 158, '2019-07-30', 287, NULL),
('Candlewood Suites', 158, '2019-07-31', 113, NULL),
('Candlewood Suites', 158, '2019-08-01', 221, NULL),
('Candlewood Suites', 158, '2019-08-02', 220, NULL),
('Candlewood Suites', 158, '2019-08-03', 272, NULL),
('Candlewood Suites', 158, '2019-08-04', 367, NULL),
('Candlewood Suites', 158, '2019-08-05', 331, NULL),
('Candlewood Suites', 158, '2019-08-06', 382, NULL),
('Candlewood Suites', 158, '2019-08-07', 385, NULL),
('Candlewood Suites', 158, '2019-08-08', 349, NULL),
('Candlewood Suites', 158, '2019-08-09', 203, NULL),
('Candlewood Suites', 158, '2019-08-10', 108, NULL),
('Candlewood Suites', 158, '2019-08-11', 387, NULL),
('Candlewood Suites', 158, '2019-08-12', 318, NULL),
('Candlewood Suites', 158, '2019-08-13', 359, NULL),
('Candlewood Suites', 158, '2019-08-14', 159, NULL),
('Candlewood Suites', 158, '2019-08-15', 315, NULL),
('Candlewood Suites', 158, '2019-08-16', 114, NULL),
('Candlewood Suites', 158, '2019-08-17', 377, NULL),
('Candlewood Suites', 158, '2019-08-18', 281, NULL),
('Candlewood Suites', 158, '2019-08-19', 297, NULL),
('Candlewood Suites', 158, '2019-08-20', 346, NULL),
('Candlewood Suites', 158, '2019-08-21', 124, NULL),
('Candlewood Suites', 158, '2019-08-22', 310, NULL),
('Candlewood Suites', 158, '2019-08-23', 154, NULL),
('Candlewood Suites', 158, '2019-08-24', 365, NULL),
('Candlewood Suites', 158, '2019-08-25', 299, NULL),
('Candlewood Suites', 158, '2019-08-26', 293, NULL),
('Candlewood Suites', 158, '2019-08-27', 366, NULL),
('Candlewood Suites', 158, '2019-08-28', 245, NULL),
('Candlewood Suites', 158, '2019-08-29', 116, NULL),
('Candlewood Suites', 158, '2019-08-30', 167, NULL),
('Candlewood Suites', 158, '2019-08-31', 354, NULL),
('Candlewood Suites', 158, '2019-09-01', 239, NULL),
('Candlewood Suites', 158, '2019-09-02', 359, NULL),
('Candlewood Suites', 158, '2019-09-03', 399, NULL),
('Candlewood Suites', 158, '2019-09-04', 181, NULL),
('Candlewood Suites', 158, '2019-09-05', 128, NULL),
('Candlewood Suites', 158, '2019-09-06', 239, NULL),
('Candlewood Suites', 158, '2019-09-07', 184, NULL),
('Candlewood Suites', 158, '2019-09-08', 343, NULL),
('Candlewood Suites', 158, '2019-09-09', 137, NULL),
('Candlewood Suites', 158, '2019-09-10', 377, NULL),
('Candlewood Suites', 158, '2019-09-11', 105, NULL),
('Candlewood Suites', 158, '2019-09-12', 296, NULL),
('Candlewood Suites', 158, '2019-09-13', 238, NULL),
('Candlewood Suites', 158, '2019-09-14', 329, NULL),
('Candlewood Suites', 158, '2019-09-15', 294, NULL),
('Candlewood Suites', 158, '2019-09-16', 336, NULL),
('Candlewood Suites', 158, '2019-09-17', 315, NULL),
('Candlewood Suites', 158, '2019-09-18', 202, NULL),
('Candlewood Suites', 158, '2019-09-19', 374, NULL),
('Candlewood Suites', 158, '2019-09-20', 378, NULL),
('Candlewood Suites', 158, '2019-09-21', 220, NULL),
('Candlewood Suites', 158, '2019-09-22', 256, NULL),
('Candlewood Suites', 158, '2019-09-23', 198, NULL),
('Candlewood Suites', 158, '2019-09-24', 113, NULL),
('Candlewood Suites', 158, '2019-09-25', 146, NULL),
('Candlewood Suites', 158, '2019-09-26', 371, NULL),
('Candlewood Suites', 158, '2019-09-27', 191, NULL),
('Candlewood Suites', 158, '2019-09-28', 398, NULL),
('Candlewood Suites', 158, '2019-09-29', 220, NULL),
('Candlewood Suites', 158, '2019-09-30', 192, NULL),
('Candlewood Suites', 158, '2019-10-01', 202, NULL),
('Candlewood Suites', 158, '2019-10-02', 176, NULL),
('Candlewood Suites', 158, '2019-10-03', 166, NULL),
('Candlewood Suites', 158, '2019-10-04', 205, NULL),
('Candlewood Suites', 158, '2019-10-05', 354, NULL),
('Candlewood Suites', 158, '2019-10-06', 382, NULL),
('Candlewood Suites', 158, '2019-10-07', 175, NULL),
('Candlewood Suites', 158, '2019-10-08', 379, NULL),
('Candlewood Suites', 158, '2019-10-09', 120, NULL),
('Candlewood Suites', 158, '2019-10-10', 152, NULL),
('Candlewood Suites', 158, '2019-10-11', 184, NULL),
('Candlewood Suites', 158, '2019-10-12', 178, NULL),
('Candlewood Suites', 158, '2019-10-13', 365, NULL),
('Candlewood Suites', 158, '2019-10-14', 155, NULL),
('Candlewood Suites', 158, '2019-10-15', 172, NULL),
('Candlewood Suites', 158, '2019-10-16', 390, NULL),
('Candlewood Suites', 158, '2019-10-17', 318, NULL),
('Candlewood Suites', 158, '2019-10-18', 265, NULL),
('Candlewood Suites', 158, '2019-10-19', 313, NULL),
('Candlewood Suites', 158, '2019-10-20', 370, NULL),
('Candlewood Suites', 158, '2019-10-21', 304, NULL),
('Candlewood Suites', 158, '2019-10-22', 274, NULL),
('Candlewood Suites', 158, '2019-10-23', 346, NULL),
('Candlewood Suites', 158, '2019-10-24', 262, NULL),
('Candlewood Suites', 158, '2019-10-25', 307, NULL),
('Candlewood Suites', 158, '2019-10-26', 231, NULL),
('Candlewood Suites', 158, '2019-10-27', 398, NULL),
('Candlewood Suites', 158, '2019-10-28', 181, NULL),
('Candlewood Suites', 158, '2019-10-29', 118, NULL),
('Candlewood Suites', 158, '2019-10-30', 169, NULL),
('Candlewood Suites', 158, '2019-10-31', 189, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 158, '2019-11-01', 334, NULL),
('Candlewood Suites', 158, '2019-11-02', 108, NULL),
('Candlewood Suites', 158, '2019-11-03', 287, NULL),
('Candlewood Suites', 158, '2019-11-04', 387, NULL),
('Candlewood Suites', 158, '2019-11-05', 282, NULL),
('Candlewood Suites', 158, '2019-11-06', 177, NULL),
('Candlewood Suites', 158, '2019-11-07', 285, NULL),
('Candlewood Suites', 158, '2019-11-08', 183, NULL),
('Candlewood Suites', 158, '2019-11-09', 113, NULL),
('Candlewood Suites', 158, '2019-11-10', 322, NULL),
('Candlewood Suites', 158, '2019-11-11', 161, NULL),
('Candlewood Suites', 158, '2019-11-12', 241, NULL),
('Candlewood Suites', 158, '2019-11-13', 241, NULL),
('Candlewood Suites', 158, '2019-11-14', 330, NULL),
('Candlewood Suites', 158, '2019-11-15', 212, NULL),
('Candlewood Suites', 158, '2019-11-16', 370, NULL),
('Candlewood Suites', 158, '2019-11-17', 311, NULL),
('Candlewood Suites', 158, '2019-11-18', 277, NULL),
('Candlewood Suites', 158, '2019-11-19', 172, NULL),
('Candlewood Suites', 158, '2019-11-20', 385, NULL),
('Candlewood Suites', 158, '2019-11-21', 107, NULL),
('Candlewood Suites', 158, '2019-11-22', 150, NULL),
('Candlewood Suites', 158, '2019-11-23', 282, NULL),
('Candlewood Suites', 158, '2019-11-24', 319, NULL),
('Candlewood Suites', 158, '2019-11-25', 320, NULL),
('Candlewood Suites', 158, '2019-11-26', 131, NULL),
('Candlewood Suites', 158, '2019-11-27', 341, NULL),
('Candlewood Suites', 158, '2019-11-28', 399, NULL),
('Candlewood Suites', 158, '2019-11-29', 391, NULL),
('Candlewood Suites', 158, '2019-11-30', 230, NULL),
('Candlewood Suites', 158, '2019-12-01', 133, NULL),
('Candlewood Suites', 158, '2019-12-02', 395, NULL),
('Candlewood Suites', 158, '2019-12-03', 372, NULL),
('Candlewood Suites', 158, '2019-12-04', 382, NULL),
('Candlewood Suites', 158, '2019-12-05', 220, NULL),
('Candlewood Suites', 158, '2019-12-06', 276, NULL),
('Candlewood Suites', 158, '2019-12-07', 329, NULL),
('Candlewood Suites', 158, '2019-12-08', 327, NULL),
('Candlewood Suites', 158, '2019-12-09', 173, NULL),
('Candlewood Suites', 158, '2019-12-10', 122, NULL),
('Candlewood Suites', 158, '2019-12-11', 140, NULL),
('Candlewood Suites', 158, '2019-12-12', 341, NULL),
('Candlewood Suites', 158, '2019-12-13', 255, NULL),
('Candlewood Suites', 158, '2019-12-14', 172, NULL),
('Candlewood Suites', 158, '2019-12-15', 141, NULL),
('Candlewood Suites', 158, '2019-12-16', 125, NULL),
('Candlewood Suites', 158, '2019-12-17', 217, NULL),
('Candlewood Suites', 158, '2019-12-18', 171, NULL),
('Candlewood Suites', 158, '2019-12-19', 247, NULL),
('Candlewood Suites', 158, '2019-12-20', 219, NULL),
('Candlewood Suites', 158, '2019-12-21', 267, NULL),
('Candlewood Suites', 158, '2019-12-22', 362, NULL),
('Candlewood Suites', 158, '2019-12-23', 220, NULL),
('Candlewood Suites', 158, '2019-12-24', 340, NULL),
('Candlewood Suites', 158, '2019-12-25', 280, NULL),
('Candlewood Suites', 158, '2019-12-26', 393, NULL),
('Candlewood Suites', 158, '2019-12-27', 129, NULL),
('Candlewood Suites', 158, '2019-12-28', 349, NULL),
('Candlewood Suites', 158, '2019-12-29', 180, NULL),
('Candlewood Suites', 158, '2019-12-30', 261, NULL),
('Candlewood Suites', 158, '2019-12-31', 256, NULL),
('Candlewood Suites', 158, '2020-01-01', 247, NULL),
('Candlewood Suites', 158, '2020-01-02', 175, NULL),
('Candlewood Suites', 158, '2020-01-03', 133, NULL),
('Candlewood Suites', 158, '2020-01-04', 287, NULL),
('Candlewood Suites', 158, '2020-01-05', 219, NULL),
('Candlewood Suites', 158, '2020-01-06', 326, NULL),
('Candlewood Suites', 158, '2020-01-07', 322, NULL),
('Candlewood Suites', 158, '2020-01-08', 149, NULL),
('Candlewood Suites', 158, '2020-01-09', 208, NULL),
('Candlewood Suites', 158, '2020-01-10', 169, NULL),
('Candlewood Suites', 158, '2020-01-11', 146, NULL),
('Candlewood Suites', 158, '2020-01-12', 174, NULL),
('Candlewood Suites', 158, '2020-01-13', 178, NULL),
('Candlewood Suites', 158, '2020-01-14', 159, NULL),
('Candlewood Suites', 158, '2020-01-15', 177, NULL),
('Candlewood Suites', 158, '2020-01-16', 115, NULL),
('Candlewood Suites', 158, '2020-01-17', 212, NULL),
('Candlewood Suites', 158, '2020-01-18', 204, NULL),
('Candlewood Suites', 158, '2020-01-19', 167, NULL),
('Candlewood Suites', 158, '2020-01-20', 375, NULL),
('Candlewood Suites', 158, '2020-01-21', 198, NULL),
('Candlewood Suites', 158, '2020-01-22', 396, NULL),
('Candlewood Suites', 158, '2020-01-23', 254, NULL),
('Candlewood Suites', 158, '2020-01-24', 253, NULL),
('Candlewood Suites', 158, '2020-01-25', 191, NULL),
('Candlewood Suites', 158, '2020-01-26', 257, NULL),
('Candlewood Suites', 158, '2020-01-27', 136, NULL),
('Candlewood Suites', 158, '2020-01-28', 358, NULL),
('Candlewood Suites', 158, '2020-01-29', 182, NULL),
('Candlewood Suites', 158, '2020-01-30', 147, NULL),
('Candlewood Suites', 158, '2020-01-31', 167, NULL),
('Candlewood Suites', 158, '2020-02-01', 334, NULL),
('Candlewood Suites', 158, '2020-02-02', 104, NULL),
('Candlewood Suites', 158, '2020-02-03', 327, NULL),
('Candlewood Suites', 158, '2020-02-04', 197, NULL),
('Candlewood Suites', 174, '2019-01-01', 127, NULL),
('Candlewood Suites', 174, '2019-01-02', 183, NULL),
('Candlewood Suites', 174, '2019-01-03', 398, NULL),
('Candlewood Suites', 174, '2019-01-04', 180, NULL),
('Candlewood Suites', 174, '2019-01-05', 224, NULL),
('Candlewood Suites', 174, '2019-01-06', 204, NULL),
('Candlewood Suites', 174, '2019-01-07', 112, NULL),
('Candlewood Suites', 174, '2019-01-08', 294, NULL),
('Candlewood Suites', 174, '2019-01-09', 255, NULL),
('Candlewood Suites', 174, '2019-01-10', 217, NULL),
('Candlewood Suites', 174, '2019-01-11', 313, NULL),
('Candlewood Suites', 174, '2019-01-12', 327, NULL),
('Candlewood Suites', 174, '2019-01-13', 246, NULL),
('Candlewood Suites', 174, '2019-01-14', 140, NULL),
('Candlewood Suites', 174, '2019-01-15', 242, NULL),
('Candlewood Suites', 174, '2019-01-16', 375, NULL),
('Candlewood Suites', 174, '2019-01-17', 386, NULL),
('Candlewood Suites', 174, '2019-01-18', 235, NULL),
('Candlewood Suites', 174, '2019-01-19', 343, NULL),
('Candlewood Suites', 174, '2019-01-20', 112, NULL),
('Candlewood Suites', 174, '2019-01-21', 280, NULL),
('Candlewood Suites', 174, '2019-01-22', 248, NULL),
('Candlewood Suites', 174, '2019-01-23', 237, NULL),
('Candlewood Suites', 174, '2019-01-24', 375, NULL),
('Candlewood Suites', 174, '2019-01-25', 211, NULL),
('Candlewood Suites', 174, '2019-01-26', 191, NULL),
('Candlewood Suites', 174, '2019-01-27', 251, NULL),
('Candlewood Suites', 174, '2019-01-28', 386, NULL),
('Candlewood Suites', 174, '2019-01-29', 282, NULL),
('Candlewood Suites', 174, '2019-01-30', 210, NULL),
('Candlewood Suites', 174, '2019-01-31', 171, NULL),
('Candlewood Suites', 174, '2019-02-01', 114, NULL),
('Candlewood Suites', 174, '2019-02-02', 327, NULL),
('Candlewood Suites', 174, '2019-02-03', 242, NULL),
('Candlewood Suites', 174, '2019-02-04', 351, NULL),
('Candlewood Suites', 174, '2019-02-05', 276, NULL),
('Candlewood Suites', 174, '2019-02-06', 296, NULL),
('Candlewood Suites', 174, '2019-02-07', 254, NULL),
('Candlewood Suites', 174, '2019-02-08', 192, NULL),
('Candlewood Suites', 174, '2019-02-09', 213, NULL),
('Candlewood Suites', 174, '2019-02-10', 118, NULL),
('Candlewood Suites', 174, '2019-02-11', 390, NULL),
('Candlewood Suites', 174, '2019-02-12', 289, NULL),
('Candlewood Suites', 174, '2019-02-13', 213, NULL),
('Candlewood Suites', 174, '2019-02-14', 379, NULL),
('Candlewood Suites', 174, '2019-02-15', 181, NULL),
('Candlewood Suites', 174, '2019-02-16', 120, NULL),
('Candlewood Suites', 174, '2019-02-17', 278, NULL),
('Candlewood Suites', 174, '2019-02-18', 138, NULL),
('Candlewood Suites', 174, '2019-02-19', 347, NULL),
('Candlewood Suites', 174, '2019-02-20', 125, NULL),
('Candlewood Suites', 174, '2019-02-21', 101, NULL),
('Candlewood Suites', 174, '2019-02-22', 144, NULL),
('Candlewood Suites', 174, '2019-02-23', 322, NULL),
('Candlewood Suites', 174, '2019-02-24', 186, NULL),
('Candlewood Suites', 174, '2019-02-25', 101, NULL),
('Candlewood Suites', 174, '2019-02-26', 393, NULL),
('Candlewood Suites', 174, '2019-02-27', 243, NULL),
('Candlewood Suites', 174, '2019-02-28', 350, NULL),
('Candlewood Suites', 174, '2019-03-01', 106, NULL),
('Candlewood Suites', 174, '2019-03-02', 125, NULL),
('Candlewood Suites', 174, '2019-03-03', 192, NULL),
('Candlewood Suites', 174, '2019-03-04', 100, NULL),
('Candlewood Suites', 174, '2019-03-05', 146, NULL),
('Candlewood Suites', 174, '2019-03-06', 160, NULL),
('Candlewood Suites', 174, '2019-03-07', 284, NULL),
('Candlewood Suites', 174, '2019-03-08', 267, NULL),
('Candlewood Suites', 174, '2019-03-09', 334, NULL),
('Candlewood Suites', 174, '2019-03-10', 296, NULL),
('Candlewood Suites', 174, '2019-03-11', 216, NULL),
('Candlewood Suites', 174, '2019-03-12', 131, NULL),
('Candlewood Suites', 174, '2019-03-13', 354, NULL),
('Candlewood Suites', 174, '2019-03-14', 127, NULL),
('Candlewood Suites', 174, '2019-03-15', 359, NULL),
('Candlewood Suites', 174, '2019-03-16', 130, NULL),
('Candlewood Suites', 174, '2019-03-17', 377, NULL),
('Candlewood Suites', 174, '2019-03-18', 126, NULL),
('Candlewood Suites', 174, '2019-03-19', 399, NULL),
('Candlewood Suites', 174, '2019-03-20', 266, NULL),
('Candlewood Suites', 174, '2019-03-21', 173, NULL),
('Candlewood Suites', 174, '2019-03-22', 262, NULL),
('Candlewood Suites', 174, '2019-03-23', 285, NULL),
('Candlewood Suites', 174, '2019-03-24', 393, NULL),
('Candlewood Suites', 174, '2019-03-25', 273, NULL),
('Candlewood Suites', 174, '2019-03-26', 357, NULL),
('Candlewood Suites', 174, '2019-03-27', 386, NULL),
('Candlewood Suites', 174, '2019-03-28', 216, NULL),
('Candlewood Suites', 174, '2019-03-29', 256, NULL),
('Candlewood Suites', 174, '2019-03-30', 172, NULL),
('Candlewood Suites', 174, '2019-03-31', 262, NULL),
('Candlewood Suites', 174, '2019-04-01', 372, NULL),
('Candlewood Suites', 174, '2019-04-02', 150, NULL),
('Candlewood Suites', 174, '2019-04-03', 247, NULL),
('Candlewood Suites', 174, '2019-04-04', 129, NULL),
('Candlewood Suites', 174, '2019-04-05', 158, NULL),
('Candlewood Suites', 174, '2019-04-06', 218, NULL),
('Candlewood Suites', 174, '2019-04-07', 224, NULL),
('Candlewood Suites', 174, '2019-04-08', 161, NULL),
('Candlewood Suites', 174, '2019-04-09', 275, NULL),
('Candlewood Suites', 174, '2019-04-10', 140, NULL),
('Candlewood Suites', 174, '2019-04-11', 339, NULL),
('Candlewood Suites', 174, '2019-04-12', 180, NULL),
('Candlewood Suites', 174, '2019-04-13', 324, NULL),
('Candlewood Suites', 174, '2019-04-14', 323, NULL),
('Candlewood Suites', 174, '2019-04-15', 297, NULL),
('Candlewood Suites', 174, '2019-04-16', 228, NULL),
('Candlewood Suites', 174, '2019-04-17', 152, NULL),
('Candlewood Suites', 174, '2019-04-18', 366, NULL),
('Candlewood Suites', 174, '2019-04-19', 346, NULL),
('Candlewood Suites', 174, '2019-04-20', 138, NULL),
('Candlewood Suites', 174, '2019-04-21', 389, NULL),
('Candlewood Suites', 174, '2019-04-22', 162, NULL),
('Candlewood Suites', 174, '2019-04-23', 142, NULL),
('Candlewood Suites', 174, '2019-04-24', 345, NULL),
('Candlewood Suites', 174, '2019-04-25', 251, NULL),
('Candlewood Suites', 174, '2019-04-26', 293, NULL),
('Candlewood Suites', 174, '2019-04-27', 142, NULL),
('Candlewood Suites', 174, '2019-04-28', 317, NULL),
('Candlewood Suites', 174, '2019-04-29', 141, NULL),
('Candlewood Suites', 174, '2019-04-30', 249, NULL),
('Candlewood Suites', 174, '2019-05-01', 332, NULL),
('Candlewood Suites', 174, '2019-05-02', 193, NULL),
('Candlewood Suites', 174, '2019-05-03', 387, NULL),
('Candlewood Suites', 174, '2019-05-04', 338, NULL),
('Candlewood Suites', 174, '2019-05-05', 272, NULL),
('Candlewood Suites', 174, '2019-05-06', 387, NULL),
('Candlewood Suites', 174, '2019-05-07', 238, NULL),
('Candlewood Suites', 174, '2019-05-08', 333, NULL),
('Candlewood Suites', 174, '2019-05-09', 286, NULL),
('Candlewood Suites', 174, '2019-05-10', 351, NULL),
('Candlewood Suites', 174, '2019-05-11', 353, NULL),
('Candlewood Suites', 174, '2019-05-12', 325, NULL),
('Candlewood Suites', 174, '2019-05-13', 110, NULL),
('Candlewood Suites', 174, '2019-05-14', 121, NULL),
('Candlewood Suites', 174, '2019-05-15', 248, NULL),
('Candlewood Suites', 174, '2019-05-16', 395, NULL),
('Candlewood Suites', 174, '2019-05-17', 320, NULL),
('Candlewood Suites', 174, '2019-05-18', 213, NULL),
('Candlewood Suites', 174, '2019-05-19', 265, NULL),
('Candlewood Suites', 174, '2019-05-20', 379, NULL),
('Candlewood Suites', 174, '2019-05-21', 159, NULL),
('Candlewood Suites', 174, '2019-05-22', 369, NULL),
('Candlewood Suites', 174, '2019-05-23', 308, NULL),
('Candlewood Suites', 174, '2019-05-24', 290, NULL),
('Candlewood Suites', 174, '2019-05-25', 266, NULL),
('Candlewood Suites', 174, '2019-05-26', 330, NULL),
('Candlewood Suites', 174, '2019-05-27', 292, NULL),
('Candlewood Suites', 174, '2019-05-28', 267, NULL),
('Candlewood Suites', 174, '2019-05-29', 147, NULL),
('Candlewood Suites', 174, '2019-05-30', 230, NULL),
('Candlewood Suites', 174, '2019-05-31', 129, NULL),
('Candlewood Suites', 174, '2019-06-01', 243, NULL),
('Candlewood Suites', 174, '2019-06-02', 208, NULL),
('Candlewood Suites', 174, '2019-06-03', 344, NULL),
('Candlewood Suites', 174, '2019-06-04', 180, NULL),
('Candlewood Suites', 174, '2019-06-05', 157, NULL),
('Candlewood Suites', 174, '2019-06-06', 318, NULL),
('Candlewood Suites', 174, '2019-06-07', 233, NULL),
('Candlewood Suites', 174, '2019-06-08', 217, NULL),
('Candlewood Suites', 174, '2019-06-09', 312, NULL),
('Candlewood Suites', 174, '2019-06-10', 344, NULL),
('Candlewood Suites', 174, '2019-06-11', 392, NULL),
('Candlewood Suites', 174, '2019-06-12', 399, NULL),
('Candlewood Suites', 174, '2019-06-13', 189, NULL),
('Candlewood Suites', 174, '2019-06-14', 142, NULL),
('Candlewood Suites', 174, '2019-06-15', 294, NULL),
('Candlewood Suites', 174, '2019-06-16', 325, NULL),
('Candlewood Suites', 174, '2019-06-17', 399, NULL),
('Candlewood Suites', 174, '2019-06-18', 256, NULL),
('Candlewood Suites', 174, '2019-06-19', 292, NULL),
('Candlewood Suites', 174, '2019-06-20', 275, NULL),
('Candlewood Suites', 174, '2019-06-21', 267, NULL),
('Candlewood Suites', 174, '2019-06-22', 231, NULL),
('Candlewood Suites', 174, '2019-06-23', 280, NULL),
('Candlewood Suites', 174, '2019-06-24', 265, NULL),
('Candlewood Suites', 174, '2019-06-25', 174, NULL),
('Candlewood Suites', 174, '2019-06-26', 203, NULL),
('Candlewood Suites', 174, '2019-06-27', 243, NULL),
('Candlewood Suites', 174, '2019-06-28', 358, NULL),
('Candlewood Suites', 174, '2019-06-29', 264, NULL),
('Candlewood Suites', 174, '2019-06-30', 374, NULL),
('Candlewood Suites', 174, '2019-07-01', 302, NULL),
('Candlewood Suites', 174, '2019-07-02', 332, NULL),
('Candlewood Suites', 174, '2019-07-03', 237, NULL),
('Candlewood Suites', 174, '2019-07-04', 135, NULL),
('Candlewood Suites', 174, '2019-07-05', 292, NULL),
('Candlewood Suites', 174, '2019-07-06', 270, NULL),
('Candlewood Suites', 174, '2019-07-07', 239, NULL),
('Candlewood Suites', 174, '2019-07-08', 362, NULL),
('Candlewood Suites', 174, '2019-07-09', 130, NULL),
('Candlewood Suites', 174, '2019-07-10', 296, NULL),
('Candlewood Suites', 174, '2019-07-11', 357, NULL),
('Candlewood Suites', 174, '2019-07-12', 104, NULL),
('Candlewood Suites', 174, '2019-07-13', 381, NULL),
('Candlewood Suites', 174, '2019-07-14', 205, NULL),
('Candlewood Suites', 174, '2019-07-15', 234, NULL),
('Candlewood Suites', 174, '2019-07-16', 164, NULL),
('Candlewood Suites', 174, '2019-07-17', 224, NULL),
('Candlewood Suites', 174, '2019-07-18', 327, NULL),
('Candlewood Suites', 174, '2019-07-19', 355, NULL),
('Candlewood Suites', 174, '2019-07-20', 188, NULL),
('Candlewood Suites', 174, '2019-07-21', 106, NULL),
('Candlewood Suites', 174, '2019-07-22', 241, NULL),
('Candlewood Suites', 174, '2019-07-23', 237, NULL),
('Candlewood Suites', 174, '2019-07-24', 376, NULL),
('Candlewood Suites', 174, '2019-07-25', 242, NULL),
('Candlewood Suites', 174, '2019-07-26', 217, NULL),
('Candlewood Suites', 174, '2019-07-27', 271, NULL),
('Candlewood Suites', 174, '2019-07-28', 208, NULL),
('Candlewood Suites', 174, '2019-07-29', 318, NULL),
('Candlewood Suites', 174, '2019-07-30', 259, NULL),
('Candlewood Suites', 174, '2019-07-31', 115, NULL),
('Candlewood Suites', 174, '2019-08-01', 213, NULL),
('Candlewood Suites', 174, '2019-08-02', 228, NULL),
('Candlewood Suites', 174, '2019-08-03', 108, NULL),
('Candlewood Suites', 174, '2019-08-04', 100, NULL),
('Candlewood Suites', 174, '2019-08-05', 397, NULL),
('Candlewood Suites', 174, '2019-08-06', 267, NULL),
('Candlewood Suites', 174, '2019-08-07', 132, NULL),
('Candlewood Suites', 174, '2019-08-08', 221, NULL),
('Candlewood Suites', 174, '2019-08-09', 285, NULL),
('Candlewood Suites', 174, '2019-08-10', 300, NULL),
('Candlewood Suites', 174, '2019-08-11', 245, NULL),
('Candlewood Suites', 174, '2019-08-12', 306, NULL),
('Candlewood Suites', 174, '2019-08-13', 259, NULL),
('Candlewood Suites', 174, '2019-08-14', 326, NULL),
('Candlewood Suites', 174, '2019-08-15', 362, NULL),
('Candlewood Suites', 174, '2019-08-16', 106, NULL),
('Candlewood Suites', 174, '2019-08-17', 163, NULL),
('Candlewood Suites', 174, '2019-08-18', 296, NULL),
('Candlewood Suites', 174, '2019-08-19', 228, NULL),
('Candlewood Suites', 174, '2019-08-20', 210, NULL),
('Candlewood Suites', 174, '2019-08-21', 125, NULL),
('Candlewood Suites', 174, '2019-08-22', 186, NULL),
('Candlewood Suites', 174, '2019-08-23', 162, NULL),
('Candlewood Suites', 174, '2019-08-24', 226, NULL),
('Candlewood Suites', 174, '2019-08-25', 297, NULL),
('Candlewood Suites', 174, '2019-08-26', 340, NULL),
('Candlewood Suites', 174, '2019-08-27', 197, NULL),
('Candlewood Suites', 174, '2019-08-28', 203, NULL),
('Candlewood Suites', 174, '2019-08-29', 181, NULL),
('Candlewood Suites', 174, '2019-08-30', 286, NULL),
('Candlewood Suites', 174, '2019-08-31', 155, NULL),
('Candlewood Suites', 174, '2019-09-01', 188, NULL),
('Candlewood Suites', 174, '2019-09-02', 392, NULL),
('Candlewood Suites', 174, '2019-09-03', 367, NULL),
('Candlewood Suites', 174, '2019-09-04', 348, NULL),
('Candlewood Suites', 174, '2019-09-05', 176, NULL),
('Candlewood Suites', 174, '2019-09-06', 168, NULL),
('Candlewood Suites', 174, '2019-09-07', 354, NULL),
('Candlewood Suites', 174, '2019-09-08', 107, NULL),
('Candlewood Suites', 174, '2019-09-09', 121, NULL),
('Candlewood Suites', 174, '2019-09-10', 192, NULL),
('Candlewood Suites', 174, '2019-09-11', 100, NULL),
('Candlewood Suites', 174, '2019-09-12', 359, NULL),
('Candlewood Suites', 174, '2019-09-13', 299, NULL),
('Candlewood Suites', 174, '2019-09-14', 104, NULL),
('Candlewood Suites', 174, '2019-09-15', 253, NULL),
('Candlewood Suites', 174, '2019-09-16', 265, NULL),
('Candlewood Suites', 174, '2019-09-17', 147, NULL),
('Candlewood Suites', 174, '2019-09-18', 246, NULL),
('Candlewood Suites', 174, '2019-09-19', 334, NULL),
('Candlewood Suites', 174, '2019-09-20', 339, NULL),
('Candlewood Suites', 174, '2019-09-21', 266, NULL),
('Candlewood Suites', 174, '2019-09-22', 213, NULL),
('Candlewood Suites', 174, '2019-09-23', 102, NULL),
('Candlewood Suites', 174, '2019-09-24', 206, NULL),
('Candlewood Suites', 174, '2019-09-25', 101, NULL),
('Candlewood Suites', 174, '2019-09-26', 164, NULL),
('Candlewood Suites', 174, '2019-09-27', 343, NULL),
('Candlewood Suites', 174, '2019-09-28', 295, NULL),
('Candlewood Suites', 174, '2019-09-29', 108, NULL),
('Candlewood Suites', 174, '2019-09-30', 275, NULL),
('Candlewood Suites', 174, '2019-10-01', 351, NULL),
('Candlewood Suites', 174, '2019-10-02', 146, NULL),
('Candlewood Suites', 174, '2019-10-03', 155, NULL),
('Candlewood Suites', 174, '2019-10-04', 232, NULL),
('Candlewood Suites', 174, '2019-10-05', 267, NULL),
('Candlewood Suites', 174, '2019-10-06', 391, NULL),
('Candlewood Suites', 174, '2019-10-07', 140, NULL),
('Candlewood Suites', 174, '2019-10-08', 379, NULL),
('Candlewood Suites', 174, '2019-10-09', 288, NULL),
('Candlewood Suites', 174, '2019-10-10', 129, NULL),
('Candlewood Suites', 174, '2019-10-11', 158, NULL),
('Candlewood Suites', 174, '2019-10-12', 361, NULL),
('Candlewood Suites', 174, '2019-10-13', 226, NULL),
('Candlewood Suites', 174, '2019-10-14', 191, NULL),
('Candlewood Suites', 174, '2019-10-15', 347, NULL),
('Candlewood Suites', 174, '2019-10-16', 277, NULL),
('Candlewood Suites', 174, '2019-10-17', 269, NULL),
('Candlewood Suites', 174, '2019-10-18', 246, NULL),
('Candlewood Suites', 174, '2019-10-19', 339, NULL),
('Candlewood Suites', 174, '2019-10-20', 181, NULL),
('Candlewood Suites', 174, '2019-10-21', 186, NULL),
('Candlewood Suites', 174, '2019-10-22', 366, NULL),
('Candlewood Suites', 174, '2019-10-23', 130, NULL),
('Candlewood Suites', 174, '2019-10-24', 228, NULL),
('Candlewood Suites', 174, '2019-10-25', 322, NULL),
('Candlewood Suites', 174, '2019-10-26', 189, NULL),
('Candlewood Suites', 174, '2019-10-27', 384, NULL),
('Candlewood Suites', 174, '2019-10-28', 332, NULL),
('Candlewood Suites', 174, '2019-10-29', 314, NULL),
('Candlewood Suites', 174, '2019-10-30', 217, NULL),
('Candlewood Suites', 174, '2019-10-31', 170, NULL),
('Candlewood Suites', 174, '2019-11-01', 392, NULL),
('Candlewood Suites', 174, '2019-11-02', 297, NULL),
('Candlewood Suites', 174, '2019-11-03', 358, NULL),
('Candlewood Suites', 174, '2019-11-04', 343, NULL),
('Candlewood Suites', 174, '2019-11-05', 222, NULL),
('Candlewood Suites', 174, '2019-11-06', 173, NULL),
('Candlewood Suites', 174, '2019-11-07', 299, NULL),
('Candlewood Suites', 174, '2019-11-08', 307, NULL),
('Candlewood Suites', 174, '2019-11-09', 135, NULL),
('Candlewood Suites', 174, '2019-11-10', 205, NULL),
('Candlewood Suites', 174, '2019-11-11', 193, NULL),
('Candlewood Suites', 174, '2019-11-12', 339, NULL),
('Candlewood Suites', 174, '2019-11-13', 363, NULL),
('Candlewood Suites', 174, '2019-11-14', 287, NULL),
('Candlewood Suites', 174, '2019-11-15', 316, NULL),
('Candlewood Suites', 174, '2019-11-16', 347, NULL),
('Candlewood Suites', 174, '2019-11-17', 132, NULL),
('Candlewood Suites', 174, '2019-11-18', 205, NULL),
('Candlewood Suites', 174, '2019-11-19', 256, NULL),
('Candlewood Suites', 174, '2019-11-20', 274, NULL),
('Candlewood Suites', 174, '2019-11-21', 110, NULL),
('Candlewood Suites', 174, '2019-11-22', 186, NULL),
('Candlewood Suites', 174, '2019-11-23', 344, NULL),
('Candlewood Suites', 174, '2019-11-24', 288, NULL),
('Candlewood Suites', 174, '2019-11-25', 209, NULL),
('Candlewood Suites', 174, '2019-11-26', 254, NULL),
('Candlewood Suites', 174, '2019-11-27', 219, NULL),
('Candlewood Suites', 174, '2019-11-28', 211, NULL),
('Candlewood Suites', 174, '2019-11-29', 366, NULL),
('Candlewood Suites', 174, '2019-11-30', 100, NULL),
('Candlewood Suites', 174, '2019-12-01', 112, NULL),
('Candlewood Suites', 174, '2019-12-02', 324, NULL),
('Candlewood Suites', 174, '2019-12-03', 392, NULL),
('Candlewood Suites', 174, '2019-12-04', 380, NULL),
('Candlewood Suites', 174, '2019-12-05', 137, NULL),
('Candlewood Suites', 174, '2019-12-06', 136, NULL),
('Candlewood Suites', 174, '2019-12-07', 174, NULL),
('Candlewood Suites', 174, '2019-12-08', 156, NULL),
('Candlewood Suites', 174, '2019-12-09', 155, NULL),
('Candlewood Suites', 174, '2019-12-10', 347, NULL),
('Candlewood Suites', 174, '2019-12-11', 263, NULL),
('Candlewood Suites', 174, '2019-12-12', 165, NULL),
('Candlewood Suites', 174, '2019-12-13', 369, NULL),
('Candlewood Suites', 174, '2019-12-14', 325, NULL),
('Candlewood Suites', 174, '2019-12-15', 249, NULL),
('Candlewood Suites', 174, '2019-12-16', 268, NULL),
('Candlewood Suites', 174, '2019-12-17', 250, NULL),
('Candlewood Suites', 174, '2019-12-18', 200, NULL),
('Candlewood Suites', 174, '2019-12-19', 398, NULL),
('Candlewood Suites', 174, '2019-12-20', 108, NULL),
('Candlewood Suites', 174, '2019-12-21', 128, NULL),
('Candlewood Suites', 174, '2019-12-22', 273, NULL),
('Candlewood Suites', 174, '2019-12-23', 228, NULL),
('Candlewood Suites', 174, '2019-12-24', 325, NULL),
('Candlewood Suites', 174, '2019-12-25', 161, NULL),
('Candlewood Suites', 174, '2019-12-26', 267, NULL),
('Candlewood Suites', 174, '2019-12-27', 306, NULL),
('Candlewood Suites', 174, '2019-12-28', 379, NULL),
('Candlewood Suites', 174, '2019-12-29', 154, NULL),
('Candlewood Suites', 174, '2019-12-30', 397, NULL),
('Candlewood Suites', 174, '2019-12-31', 218, NULL),
('Candlewood Suites', 174, '2020-01-01', 352, NULL),
('Candlewood Suites', 174, '2020-01-02', 253, NULL),
('Candlewood Suites', 174, '2020-01-03', 376, NULL),
('Candlewood Suites', 174, '2020-01-04', 172, NULL),
('Candlewood Suites', 174, '2020-01-05', 230, NULL),
('Candlewood Suites', 174, '2020-01-06', 310, NULL),
('Candlewood Suites', 174, '2020-01-07', 151, NULL),
('Candlewood Suites', 174, '2020-01-08', 149, NULL),
('Candlewood Suites', 174, '2020-01-09', 151, NULL),
('Candlewood Suites', 174, '2020-01-10', 392, NULL),
('Candlewood Suites', 174, '2020-01-11', 175, NULL),
('Candlewood Suites', 174, '2020-01-12', 252, NULL),
('Candlewood Suites', 174, '2020-01-13', 229, NULL),
('Candlewood Suites', 174, '2020-01-14', 310, NULL),
('Candlewood Suites', 174, '2020-01-15', 145, NULL),
('Candlewood Suites', 174, '2020-01-16', 277, NULL),
('Candlewood Suites', 174, '2020-01-17', 132, NULL),
('Candlewood Suites', 174, '2020-01-18', 380, NULL),
('Candlewood Suites', 174, '2020-01-19', 282, NULL),
('Candlewood Suites', 174, '2020-01-20', 310, NULL),
('Candlewood Suites', 174, '2020-01-21', 285, NULL),
('Candlewood Suites', 174, '2020-01-22', 118, NULL),
('Candlewood Suites', 174, '2020-01-23', 121, NULL),
('Candlewood Suites', 174, '2020-01-24', 307, NULL),
('Candlewood Suites', 174, '2020-01-25', 337, NULL),
('Candlewood Suites', 174, '2020-01-26', 143, NULL),
('Candlewood Suites', 174, '2020-01-27', 158, NULL),
('Candlewood Suites', 174, '2020-01-28', 353, NULL),
('Candlewood Suites', 174, '2020-01-29', 178, NULL),
('Candlewood Suites', 174, '2020-01-30', 266, NULL),
('Candlewood Suites', 174, '2020-01-31', 303, NULL),
('Candlewood Suites', 174, '2020-02-01', 286, NULL),
('Candlewood Suites', 174, '2020-02-02', 349, NULL),
('Candlewood Suites', 174, '2020-02-03', 186, NULL),
('Candlewood Suites', 174, '2020-02-04', 266, NULL),
('Candlewood Suites', 176, '2019-01-01', 261, NULL),
('Candlewood Suites', 176, '2019-01-02', 328, NULL),
('Candlewood Suites', 176, '2019-01-03', 330, NULL),
('Candlewood Suites', 176, '2019-01-04', 240, NULL),
('Candlewood Suites', 176, '2019-01-05', 375, NULL),
('Candlewood Suites', 176, '2019-01-06', 340, NULL),
('Candlewood Suites', 176, '2019-01-07', 337, NULL),
('Candlewood Suites', 176, '2019-01-08', 339, NULL),
('Candlewood Suites', 176, '2019-01-09', 305, NULL),
('Candlewood Suites', 176, '2019-01-10', 334, NULL),
('Candlewood Suites', 176, '2019-01-11', 375, NULL),
('Candlewood Suites', 176, '2019-01-12', 305, NULL),
('Candlewood Suites', 176, '2019-01-13', 247, NULL),
('Candlewood Suites', 176, '2019-01-14', 183, NULL),
('Candlewood Suites', 176, '2019-01-15', 213, NULL),
('Candlewood Suites', 176, '2019-01-16', 105, NULL),
('Candlewood Suites', 176, '2019-01-17', 346, NULL),
('Candlewood Suites', 176, '2019-01-18', 313, NULL),
('Candlewood Suites', 176, '2019-01-19', 245, NULL),
('Candlewood Suites', 176, '2019-01-20', 102, NULL),
('Candlewood Suites', 176, '2019-01-21', 290, NULL),
('Candlewood Suites', 176, '2019-01-22', 214, NULL),
('Candlewood Suites', 176, '2019-01-23', 398, NULL),
('Candlewood Suites', 176, '2019-01-24', 257, NULL),
('Candlewood Suites', 176, '2019-01-25', 161, NULL),
('Candlewood Suites', 176, '2019-01-26', 175, NULL),
('Candlewood Suites', 176, '2019-01-27', 249, NULL),
('Candlewood Suites', 176, '2019-01-28', 375, NULL),
('Candlewood Suites', 176, '2019-01-29', 143, NULL),
('Candlewood Suites', 176, '2019-01-30', 332, NULL),
('Candlewood Suites', 176, '2019-01-31', 228, NULL),
('Candlewood Suites', 176, '2019-02-01', 186, NULL),
('Candlewood Suites', 176, '2019-02-02', 241, NULL),
('Candlewood Suites', 176, '2019-02-03', 102, NULL),
('Candlewood Suites', 176, '2019-02-04', 272, NULL),
('Candlewood Suites', 176, '2019-02-05', 302, NULL),
('Candlewood Suites', 176, '2019-02-06', 325, NULL),
('Candlewood Suites', 176, '2019-02-07', 381, NULL),
('Candlewood Suites', 176, '2019-02-08', 306, NULL),
('Candlewood Suites', 176, '2019-02-09', 211, NULL),
('Candlewood Suites', 176, '2019-02-10', 255, NULL),
('Candlewood Suites', 176, '2019-02-11', 329, NULL),
('Candlewood Suites', 176, '2019-02-12', 171, NULL),
('Candlewood Suites', 176, '2019-02-13', 145, NULL),
('Candlewood Suites', 176, '2019-02-14', 189, NULL),
('Candlewood Suites', 176, '2019-02-15', 388, NULL),
('Candlewood Suites', 176, '2019-02-16', 138, NULL),
('Candlewood Suites', 176, '2019-02-17', 324, NULL),
('Candlewood Suites', 176, '2019-02-18', 180, NULL),
('Candlewood Suites', 176, '2019-02-19', 127, NULL),
('Candlewood Suites', 176, '2019-02-20', 220, NULL),
('Candlewood Suites', 176, '2019-02-21', 215, NULL),
('Candlewood Suites', 176, '2019-02-22', 253, NULL),
('Candlewood Suites', 176, '2019-02-23', 244, NULL),
('Candlewood Suites', 176, '2019-02-24', 279, NULL),
('Candlewood Suites', 176, '2019-02-25', 352, NULL),
('Candlewood Suites', 176, '2019-02-26', 111, NULL),
('Candlewood Suites', 176, '2019-02-27', 139, NULL),
('Candlewood Suites', 176, '2019-02-28', 340, NULL),
('Candlewood Suites', 176, '2019-03-01', 374, NULL),
('Candlewood Suites', 176, '2019-03-02', 380, NULL),
('Candlewood Suites', 176, '2019-03-03', 252, NULL),
('Candlewood Suites', 176, '2019-03-04', 105, NULL),
('Candlewood Suites', 176, '2019-03-05', 353, NULL),
('Candlewood Suites', 176, '2019-03-06', 115, NULL),
('Candlewood Suites', 176, '2019-03-07', 193, NULL),
('Candlewood Suites', 176, '2019-03-08', 313, NULL),
('Candlewood Suites', 176, '2019-03-09', 146, NULL),
('Candlewood Suites', 176, '2019-03-10', 377, NULL),
('Candlewood Suites', 176, '2019-03-11', 111, NULL),
('Candlewood Suites', 176, '2019-03-12', 114, NULL),
('Candlewood Suites', 176, '2019-03-13', 232, NULL),
('Candlewood Suites', 176, '2019-03-14', 311, NULL),
('Candlewood Suites', 176, '2019-03-15', 229, NULL),
('Candlewood Suites', 176, '2019-03-16', 105, NULL),
('Candlewood Suites', 176, '2019-03-17', 247, NULL),
('Candlewood Suites', 176, '2019-03-18', 194, NULL),
('Candlewood Suites', 176, '2019-03-19', 198, NULL),
('Candlewood Suites', 176, '2019-03-20', 154, NULL),
('Candlewood Suites', 176, '2019-03-21', 301, NULL),
('Candlewood Suites', 176, '2019-03-22', 231, NULL),
('Candlewood Suites', 176, '2019-03-23', 250, NULL),
('Candlewood Suites', 176, '2019-03-24', 288, NULL),
('Candlewood Suites', 176, '2019-03-25', 277, NULL),
('Candlewood Suites', 176, '2019-03-26', 167, NULL),
('Candlewood Suites', 176, '2019-03-27', 169, NULL),
('Candlewood Suites', 176, '2019-03-28', 374, NULL),
('Candlewood Suites', 176, '2019-03-29', 118, NULL),
('Candlewood Suites', 176, '2019-03-30', 309, NULL),
('Candlewood Suites', 176, '2019-03-31', 103, NULL),
('Candlewood Suites', 176, '2019-04-01', 202, NULL),
('Candlewood Suites', 176, '2019-04-02', 150, NULL),
('Candlewood Suites', 176, '2019-04-03', 396, NULL),
('Candlewood Suites', 176, '2019-04-04', 239, NULL),
('Candlewood Suites', 176, '2019-04-05', 136, NULL),
('Candlewood Suites', 176, '2019-04-06', 200, NULL),
('Candlewood Suites', 176, '2019-04-07', 306, NULL),
('Candlewood Suites', 176, '2019-04-08', 118, NULL),
('Candlewood Suites', 176, '2019-04-09', 284, NULL),
('Candlewood Suites', 176, '2019-04-10', 340, NULL),
('Candlewood Suites', 176, '2019-04-11', 355, NULL),
('Candlewood Suites', 176, '2019-04-12', 182, NULL),
('Candlewood Suites', 176, '2019-04-13', 145, NULL),
('Candlewood Suites', 176, '2019-04-14', 118, NULL),
('Candlewood Suites', 176, '2019-04-15', 370, NULL),
('Candlewood Suites', 176, '2019-04-16', 366, NULL),
('Candlewood Suites', 176, '2019-04-17', 254, NULL),
('Candlewood Suites', 176, '2019-04-18', 118, NULL),
('Candlewood Suites', 176, '2019-04-19', 133, NULL),
('Candlewood Suites', 176, '2019-04-20', 212, NULL),
('Candlewood Suites', 176, '2019-04-21', 258, NULL),
('Candlewood Suites', 176, '2019-04-22', 360, NULL),
('Candlewood Suites', 176, '2019-04-23', 115, NULL),
('Candlewood Suites', 176, '2019-04-24', 362, NULL),
('Candlewood Suites', 176, '2019-04-25', 339, NULL),
('Candlewood Suites', 176, '2019-04-26', 352, NULL),
('Candlewood Suites', 176, '2019-04-27', 117, NULL),
('Candlewood Suites', 176, '2019-04-28', 112, NULL),
('Candlewood Suites', 176, '2019-04-29', 172, NULL),
('Candlewood Suites', 176, '2019-04-30', 360, NULL),
('Candlewood Suites', 176, '2019-05-01', 349, NULL),
('Candlewood Suites', 176, '2019-05-02', 153, NULL),
('Candlewood Suites', 176, '2019-05-03', 324, NULL),
('Candlewood Suites', 176, '2019-05-04', 309, NULL),
('Candlewood Suites', 176, '2019-05-05', 396, NULL),
('Candlewood Suites', 176, '2019-05-06', 264, NULL),
('Candlewood Suites', 176, '2019-05-07', 104, NULL),
('Candlewood Suites', 176, '2019-05-08', 235, NULL),
('Candlewood Suites', 176, '2019-05-09', 128, NULL),
('Candlewood Suites', 176, '2019-05-10', 392, NULL),
('Candlewood Suites', 176, '2019-05-11', 369, NULL),
('Candlewood Suites', 176, '2019-05-12', 265, NULL),
('Candlewood Suites', 176, '2019-05-13', 205, NULL),
('Candlewood Suites', 176, '2019-05-14', 189, NULL),
('Candlewood Suites', 176, '2019-05-15', 343, NULL),
('Candlewood Suites', 176, '2019-05-16', 357, NULL),
('Candlewood Suites', 176, '2019-05-17', 329, NULL),
('Candlewood Suites', 176, '2019-05-18', 297, NULL),
('Candlewood Suites', 176, '2019-05-19', 113, NULL),
('Candlewood Suites', 176, '2019-05-20', 163, NULL),
('Candlewood Suites', 176, '2019-05-21', 236, NULL),
('Candlewood Suites', 176, '2019-05-22', 326, NULL),
('Candlewood Suites', 176, '2019-05-23', 197, NULL),
('Candlewood Suites', 176, '2019-05-24', 293, NULL),
('Candlewood Suites', 176, '2019-05-25', 272, NULL),
('Candlewood Suites', 176, '2019-05-26', 304, NULL),
('Candlewood Suites', 176, '2019-05-27', 322, NULL),
('Candlewood Suites', 176, '2019-05-28', 209, NULL),
('Candlewood Suites', 176, '2019-05-29', 154, NULL),
('Candlewood Suites', 176, '2019-05-30', 233, NULL),
('Candlewood Suites', 176, '2019-05-31', 331, NULL),
('Candlewood Suites', 176, '2019-06-01', 285, NULL),
('Candlewood Suites', 176, '2019-06-02', 197, NULL),
('Candlewood Suites', 176, '2019-06-03', 171, NULL),
('Candlewood Suites', 176, '2019-06-04', 232, NULL),
('Candlewood Suites', 176, '2019-06-05', 199, NULL),
('Candlewood Suites', 176, '2019-06-06', 347, NULL),
('Candlewood Suites', 176, '2019-06-07', 140, NULL),
('Candlewood Suites', 176, '2019-06-08', 334, NULL),
('Candlewood Suites', 176, '2019-06-09', 330, NULL),
('Candlewood Suites', 176, '2019-06-10', 147, NULL),
('Candlewood Suites', 176, '2019-06-11', 316, NULL),
('Candlewood Suites', 176, '2019-06-12', 348, NULL),
('Candlewood Suites', 176, '2019-06-13', 175, NULL),
('Candlewood Suites', 176, '2019-06-14', 219, NULL),
('Candlewood Suites', 176, '2019-06-15', 316, NULL),
('Candlewood Suites', 176, '2019-06-16', 302, NULL),
('Candlewood Suites', 176, '2019-06-17', 255, NULL),
('Candlewood Suites', 176, '2019-06-18', 148, NULL),
('Candlewood Suites', 176, '2019-06-19', 270, NULL),
('Candlewood Suites', 176, '2019-06-20', 184, NULL),
('Candlewood Suites', 176, '2019-06-21', 247, NULL),
('Candlewood Suites', 176, '2019-06-22', 105, NULL),
('Candlewood Suites', 176, '2019-06-23', 199, NULL),
('Candlewood Suites', 176, '2019-06-24', 191, NULL),
('Candlewood Suites', 176, '2019-06-25', 208, NULL),
('Candlewood Suites', 176, '2019-06-26', 377, NULL),
('Candlewood Suites', 176, '2019-06-27', 233, NULL),
('Candlewood Suites', 176, '2019-06-28', 370, NULL),
('Candlewood Suites', 176, '2019-06-29', 304, NULL),
('Candlewood Suites', 176, '2019-06-30', 383, NULL),
('Candlewood Suites', 176, '2019-07-01', 241, NULL),
('Candlewood Suites', 176, '2019-07-02', 124, NULL),
('Candlewood Suites', 176, '2019-07-03', 207, NULL),
('Candlewood Suites', 176, '2019-07-04', 275, NULL),
('Candlewood Suites', 176, '2019-07-05', 389, NULL),
('Candlewood Suites', 176, '2019-07-06', 371, NULL),
('Candlewood Suites', 176, '2019-07-07', 200, NULL),
('Candlewood Suites', 176, '2019-07-08', 164, NULL),
('Candlewood Suites', 176, '2019-07-09', 392, NULL),
('Candlewood Suites', 176, '2019-07-10', 297, NULL),
('Candlewood Suites', 176, '2019-07-11', 124, NULL),
('Candlewood Suites', 176, '2019-07-12', 256, NULL),
('Candlewood Suites', 176, '2019-07-13', 254, NULL),
('Candlewood Suites', 176, '2019-07-14', 348, NULL),
('Candlewood Suites', 176, '2019-07-15', 146, NULL),
('Candlewood Suites', 176, '2019-07-16', 360, NULL),
('Candlewood Suites', 176, '2019-07-17', 263, NULL),
('Candlewood Suites', 176, '2019-07-18', 334, NULL),
('Candlewood Suites', 176, '2019-07-19', 113, NULL),
('Candlewood Suites', 176, '2019-07-20', 303, NULL),
('Candlewood Suites', 176, '2019-07-21', 394, NULL),
('Candlewood Suites', 176, '2019-07-22', 141, NULL),
('Candlewood Suites', 176, '2019-07-23', 238, NULL),
('Candlewood Suites', 176, '2019-07-24', 296, NULL),
('Candlewood Suites', 176, '2019-07-25', 251, NULL),
('Candlewood Suites', 176, '2019-07-26', 269, NULL),
('Candlewood Suites', 176, '2019-07-27', 393, NULL),
('Candlewood Suites', 176, '2019-07-28', 132, NULL),
('Candlewood Suites', 176, '2019-07-29', 109, NULL),
('Candlewood Suites', 176, '2019-07-30', 335, NULL),
('Candlewood Suites', 176, '2019-07-31', 138, NULL),
('Candlewood Suites', 176, '2019-08-01', 300, NULL),
('Candlewood Suites', 176, '2019-08-02', 382, NULL),
('Candlewood Suites', 176, '2019-08-03', 225, NULL),
('Candlewood Suites', 176, '2019-08-04', 198, NULL),
('Candlewood Suites', 176, '2019-08-05', 293, NULL),
('Candlewood Suites', 176, '2019-08-06', 389, NULL),
('Candlewood Suites', 176, '2019-08-07', 303, NULL),
('Candlewood Suites', 176, '2019-08-08', 257, NULL),
('Candlewood Suites', 176, '2019-08-09', 115, NULL),
('Candlewood Suites', 176, '2019-08-10', 175, NULL),
('Candlewood Suites', 176, '2019-08-11', 266, NULL),
('Candlewood Suites', 176, '2019-08-12', 179, NULL),
('Candlewood Suites', 176, '2019-08-13', 117, NULL),
('Candlewood Suites', 176, '2019-08-14', 154, NULL),
('Candlewood Suites', 176, '2019-08-15', 167, NULL),
('Candlewood Suites', 176, '2019-08-16', 391, NULL),
('Candlewood Suites', 176, '2019-08-17', 181, NULL),
('Candlewood Suites', 176, '2019-08-18', 237, NULL),
('Candlewood Suites', 176, '2019-08-19', 149, NULL),
('Candlewood Suites', 176, '2019-08-20', 212, NULL),
('Candlewood Suites', 176, '2019-08-21', 157, NULL),
('Candlewood Suites', 176, '2019-08-22', 204, NULL),
('Candlewood Suites', 176, '2019-08-23', 249, NULL),
('Candlewood Suites', 176, '2019-08-24', 236, NULL),
('Candlewood Suites', 176, '2019-08-25', 189, NULL),
('Candlewood Suites', 176, '2019-08-26', 123, NULL),
('Candlewood Suites', 176, '2019-08-27', 387, NULL),
('Candlewood Suites', 176, '2019-08-28', 180, NULL),
('Candlewood Suites', 176, '2019-08-29', 156, NULL),
('Candlewood Suites', 176, '2019-08-30', 231, NULL),
('Candlewood Suites', 176, '2019-08-31', 213, NULL),
('Candlewood Suites', 176, '2019-09-01', 123, NULL),
('Candlewood Suites', 176, '2019-09-02', 186, NULL),
('Candlewood Suites', 176, '2019-09-03', 240, NULL),
('Candlewood Suites', 176, '2019-09-04', 199, NULL),
('Candlewood Suites', 176, '2019-09-05', 396, NULL),
('Candlewood Suites', 176, '2019-09-06', 322, NULL),
('Candlewood Suites', 176, '2019-09-07', 218, NULL),
('Candlewood Suites', 176, '2019-09-08', 310, NULL),
('Candlewood Suites', 176, '2019-09-09', 393, NULL),
('Candlewood Suites', 176, '2019-09-10', 326, NULL),
('Candlewood Suites', 176, '2019-09-11', 387, NULL),
('Candlewood Suites', 176, '2019-09-12', 209, NULL),
('Candlewood Suites', 176, '2019-09-13', 384, NULL),
('Candlewood Suites', 176, '2019-09-14', 335, NULL),
('Candlewood Suites', 176, '2019-09-15', 285, NULL),
('Candlewood Suites', 176, '2019-09-16', 217, NULL),
('Candlewood Suites', 176, '2019-09-17', 290, NULL),
('Candlewood Suites', 176, '2019-09-18', 222, NULL),
('Candlewood Suites', 176, '2019-09-19', 148, NULL),
('Candlewood Suites', 176, '2019-09-20', 162, NULL),
('Candlewood Suites', 176, '2019-09-21', 271, NULL),
('Candlewood Suites', 176, '2019-09-22', 198, NULL),
('Candlewood Suites', 176, '2019-09-23', 115, NULL),
('Candlewood Suites', 176, '2019-09-24', 289, NULL),
('Candlewood Suites', 176, '2019-09-25', 268, NULL),
('Candlewood Suites', 176, '2019-09-26', 207, NULL),
('Candlewood Suites', 176, '2019-09-27', 146, NULL),
('Candlewood Suites', 176, '2019-09-28', 179, NULL),
('Candlewood Suites', 176, '2019-09-29', 381, NULL),
('Candlewood Suites', 176, '2019-09-30', 102, NULL),
('Candlewood Suites', 176, '2019-10-01', 151, NULL),
('Candlewood Suites', 176, '2019-10-02', 103, NULL),
('Candlewood Suites', 176, '2019-10-03', 177, NULL),
('Candlewood Suites', 176, '2019-10-04', 144, NULL),
('Candlewood Suites', 176, '2019-10-05', 174, NULL),
('Candlewood Suites', 176, '2019-10-06', 109, NULL),
('Candlewood Suites', 176, '2019-10-07', 376, NULL),
('Candlewood Suites', 176, '2019-10-08', 359, NULL),
('Candlewood Suites', 176, '2019-10-09', 378, NULL),
('Candlewood Suites', 176, '2019-10-10', 388, NULL),
('Candlewood Suites', 176, '2019-10-11', 141, NULL),
('Candlewood Suites', 176, '2019-10-12', 271, NULL),
('Candlewood Suites', 176, '2019-10-13', 235, NULL),
('Candlewood Suites', 176, '2019-10-14', 394, NULL),
('Candlewood Suites', 176, '2019-10-15', 221, NULL),
('Candlewood Suites', 176, '2019-10-16', 117, NULL),
('Candlewood Suites', 176, '2019-10-17', 295, NULL),
('Candlewood Suites', 176, '2019-10-18', 336, NULL),
('Candlewood Suites', 176, '2019-10-19', 356, NULL),
('Candlewood Suites', 176, '2019-10-20', 298, NULL),
('Candlewood Suites', 176, '2019-10-21', 217, NULL),
('Candlewood Suites', 176, '2019-10-22', 307, NULL),
('Candlewood Suites', 176, '2019-10-23', 113, NULL),
('Candlewood Suites', 176, '2019-10-24', 256, NULL),
('Candlewood Suites', 176, '2019-10-25', 290, NULL),
('Candlewood Suites', 176, '2019-10-26', 150, NULL),
('Candlewood Suites', 176, '2019-10-27', 328, NULL),
('Candlewood Suites', 176, '2019-10-28', 119, NULL),
('Candlewood Suites', 176, '2019-10-29', 215, NULL),
('Candlewood Suites', 176, '2019-10-30', 176, NULL),
('Candlewood Suites', 176, '2019-10-31', 184, NULL),
('Candlewood Suites', 176, '2019-11-01', 260, NULL),
('Candlewood Suites', 176, '2019-11-02', 164, NULL),
('Candlewood Suites', 176, '2019-11-03', 230, NULL),
('Candlewood Suites', 176, '2019-11-04', 154, NULL),
('Candlewood Suites', 176, '2019-11-05', 162, NULL),
('Candlewood Suites', 176, '2019-11-06', 235, NULL),
('Candlewood Suites', 176, '2019-11-07', 242, NULL),
('Candlewood Suites', 176, '2019-11-08', 286, NULL),
('Candlewood Suites', 176, '2019-11-09', 238, NULL),
('Candlewood Suites', 176, '2019-11-10', 258, NULL),
('Candlewood Suites', 176, '2019-11-11', 380, NULL),
('Candlewood Suites', 176, '2019-11-12', 272, NULL),
('Candlewood Suites', 176, '2019-11-13', 391, NULL),
('Candlewood Suites', 176, '2019-11-14', 344, NULL),
('Candlewood Suites', 176, '2019-11-15', 248, NULL),
('Candlewood Suites', 176, '2019-11-16', 228, NULL),
('Candlewood Suites', 176, '2019-11-17', 226, NULL),
('Candlewood Suites', 176, '2019-11-18', 391, NULL),
('Candlewood Suites', 176, '2019-11-19', 364, NULL),
('Candlewood Suites', 176, '2019-11-20', 117, NULL),
('Candlewood Suites', 176, '2019-11-21', 129, NULL),
('Candlewood Suites', 176, '2019-11-22', 383, NULL),
('Candlewood Suites', 176, '2019-11-23', 175, NULL),
('Candlewood Suites', 176, '2019-11-24', 386, NULL),
('Candlewood Suites', 176, '2019-11-25', 285, NULL),
('Candlewood Suites', 176, '2019-11-26', 178, NULL),
('Candlewood Suites', 176, '2019-11-27', 275, NULL),
('Candlewood Suites', 176, '2019-11-28', 361, NULL),
('Candlewood Suites', 176, '2019-11-29', 256, NULL),
('Candlewood Suites', 176, '2019-11-30', 307, NULL),
('Candlewood Suites', 176, '2019-12-01', 362, NULL),
('Candlewood Suites', 176, '2019-12-02', 337, NULL),
('Candlewood Suites', 176, '2019-12-03', 142, NULL),
('Candlewood Suites', 176, '2019-12-04', 355, NULL),
('Candlewood Suites', 176, '2019-12-05', 228, NULL),
('Candlewood Suites', 176, '2019-12-06', 351, NULL),
('Candlewood Suites', 176, '2019-12-07', 381, NULL),
('Candlewood Suites', 176, '2019-12-08', 298, NULL),
('Candlewood Suites', 176, '2019-12-09', 159, NULL),
('Candlewood Suites', 176, '2019-12-10', 368, NULL),
('Candlewood Suites', 176, '2019-12-11', 193, NULL),
('Candlewood Suites', 176, '2019-12-12', 303, NULL),
('Candlewood Suites', 176, '2019-12-13', 380, NULL),
('Candlewood Suites', 176, '2019-12-14', 107, NULL),
('Candlewood Suites', 176, '2019-12-15', 122, NULL),
('Candlewood Suites', 176, '2019-12-16', 263, NULL),
('Candlewood Suites', 176, '2019-12-17', 199, NULL),
('Candlewood Suites', 176, '2019-12-18', 389, NULL),
('Candlewood Suites', 176, '2019-12-19', 247, NULL),
('Candlewood Suites', 176, '2019-12-20', 385, NULL),
('Candlewood Suites', 176, '2019-12-21', 339, NULL),
('Candlewood Suites', 176, '2019-12-22', 183, NULL),
('Candlewood Suites', 176, '2019-12-23', 378, NULL),
('Candlewood Suites', 176, '2019-12-24', 205, NULL),
('Candlewood Suites', 176, '2019-12-25', 166, NULL),
('Candlewood Suites', 176, '2019-12-26', 355, NULL),
('Candlewood Suites', 176, '2019-12-27', 147, NULL),
('Candlewood Suites', 176, '2019-12-28', 147, NULL),
('Candlewood Suites', 176, '2019-12-29', 132, NULL),
('Candlewood Suites', 176, '2019-12-30', 200, NULL),
('Candlewood Suites', 176, '2019-12-31', 225, NULL),
('Candlewood Suites', 176, '2020-01-01', 317, NULL),
('Candlewood Suites', 176, '2020-01-02', 341, NULL),
('Candlewood Suites', 176, '2020-01-03', 185, NULL),
('Candlewood Suites', 176, '2020-01-04', 197, NULL),
('Candlewood Suites', 176, '2020-01-05', 393, NULL),
('Candlewood Suites', 176, '2020-01-06', 172, NULL),
('Candlewood Suites', 176, '2020-01-07', 286, NULL),
('Candlewood Suites', 176, '2020-01-08', 198, NULL),
('Candlewood Suites', 176, '2020-01-09', 332, NULL),
('Candlewood Suites', 176, '2020-01-10', 153, NULL),
('Candlewood Suites', 176, '2020-01-11', 336, NULL),
('Candlewood Suites', 176, '2020-01-12', 340, NULL),
('Candlewood Suites', 176, '2020-01-13', 211, NULL),
('Candlewood Suites', 176, '2020-01-14', 373, NULL),
('Candlewood Suites', 176, '2020-01-15', 395, NULL),
('Candlewood Suites', 176, '2020-01-16', 339, NULL),
('Candlewood Suites', 176, '2020-01-17', 224, NULL),
('Candlewood Suites', 176, '2020-01-18', 290, NULL),
('Candlewood Suites', 176, '2020-01-19', 210, NULL),
('Candlewood Suites', 176, '2020-01-20', 323, NULL),
('Candlewood Suites', 176, '2020-01-21', 133, NULL),
('Candlewood Suites', 176, '2020-01-22', 202, NULL),
('Candlewood Suites', 176, '2020-01-23', 344, NULL),
('Candlewood Suites', 176, '2020-01-24', 374, NULL),
('Candlewood Suites', 176, '2020-01-25', 113, NULL),
('Candlewood Suites', 176, '2020-01-26', 145, NULL),
('Candlewood Suites', 176, '2020-01-27', 279, NULL),
('Candlewood Suites', 176, '2020-01-28', 289, NULL),
('Candlewood Suites', 176, '2020-01-29', 245, NULL),
('Candlewood Suites', 176, '2020-01-30', 192, NULL),
('Candlewood Suites', 176, '2020-01-31', 314, NULL),
('Candlewood Suites', 176, '2020-02-01', 329, NULL),
('Candlewood Suites', 176, '2020-02-02', 136, NULL),
('Candlewood Suites', 176, '2020-02-03', 150, NULL),
('Candlewood Suites', 176, '2020-02-04', 336, NULL),
('Candlewood Suites', 178, '2019-01-01', 224, NULL),
('Candlewood Suites', 178, '2019-01-02', 394, NULL),
('Candlewood Suites', 178, '2019-01-03', 359, NULL),
('Candlewood Suites', 178, '2019-01-04', 262, NULL),
('Candlewood Suites', 178, '2019-01-05', 203, NULL),
('Candlewood Suites', 178, '2019-01-06', 389, NULL),
('Candlewood Suites', 178, '2019-01-07', 353, NULL),
('Candlewood Suites', 178, '2019-01-08', 113, NULL),
('Candlewood Suites', 178, '2019-01-09', 362, NULL),
('Candlewood Suites', 178, '2019-01-10', 318, NULL),
('Candlewood Suites', 178, '2019-01-11', 234, NULL),
('Candlewood Suites', 178, '2019-01-12', 141, NULL),
('Candlewood Suites', 178, '2019-01-13', 399, NULL),
('Candlewood Suites', 178, '2019-01-14', 395, NULL),
('Candlewood Suites', 178, '2019-01-15', 238, NULL),
('Candlewood Suites', 178, '2019-01-16', 198, NULL),
('Candlewood Suites', 178, '2019-01-17', 174, NULL),
('Candlewood Suites', 178, '2019-01-18', 161, NULL),
('Candlewood Suites', 178, '2019-01-19', 398, NULL),
('Candlewood Suites', 178, '2019-01-20', 376, NULL),
('Candlewood Suites', 178, '2019-01-21', 209, NULL),
('Candlewood Suites', 178, '2019-01-22', 227, NULL),
('Candlewood Suites', 178, '2019-01-23', 278, NULL),
('Candlewood Suites', 178, '2019-01-24', 359, NULL),
('Candlewood Suites', 178, '2019-01-25', 370, NULL),
('Candlewood Suites', 178, '2019-01-26', 202, NULL),
('Candlewood Suites', 178, '2019-01-27', 394, NULL),
('Candlewood Suites', 178, '2019-01-28', 316, NULL),
('Candlewood Suites', 178, '2019-01-29', 371, NULL),
('Candlewood Suites', 178, '2019-01-30', 329, NULL),
('Candlewood Suites', 178, '2019-01-31', 230, NULL),
('Candlewood Suites', 178, '2019-02-01', 190, NULL),
('Candlewood Suites', 178, '2019-02-02', 124, NULL),
('Candlewood Suites', 178, '2019-02-03', 284, NULL),
('Candlewood Suites', 178, '2019-02-04', 208, NULL),
('Candlewood Suites', 178, '2019-02-05', 283, NULL),
('Candlewood Suites', 178, '2019-02-06', 339, NULL),
('Candlewood Suites', 178, '2019-02-07', 144, NULL),
('Candlewood Suites', 178, '2019-02-08', 255, NULL),
('Candlewood Suites', 178, '2019-02-09', 316, NULL),
('Candlewood Suites', 178, '2019-02-10', 222, NULL),
('Candlewood Suites', 178, '2019-02-11', 374, NULL),
('Candlewood Suites', 178, '2019-02-12', 187, NULL),
('Candlewood Suites', 178, '2019-02-13', 287, NULL),
('Candlewood Suites', 178, '2019-02-14', 307, NULL),
('Candlewood Suites', 178, '2019-02-15', 394, NULL),
('Candlewood Suites', 178, '2019-02-16', 229, NULL),
('Candlewood Suites', 178, '2019-02-17', 384, NULL),
('Candlewood Suites', 178, '2019-02-18', 386, NULL),
('Candlewood Suites', 178, '2019-02-19', 393, NULL),
('Candlewood Suites', 178, '2019-02-20', 326, NULL),
('Candlewood Suites', 178, '2019-02-21', 372, NULL),
('Candlewood Suites', 178, '2019-02-22', 130, NULL),
('Candlewood Suites', 178, '2019-02-23', 157, NULL),
('Candlewood Suites', 178, '2019-02-24', 137, NULL),
('Candlewood Suites', 178, '2019-02-25', 156, NULL),
('Candlewood Suites', 178, '2019-02-26', 173, NULL),
('Candlewood Suites', 178, '2019-02-27', 169, NULL),
('Candlewood Suites', 178, '2019-02-28', 252, NULL),
('Candlewood Suites', 178, '2019-03-01', 256, NULL),
('Candlewood Suites', 178, '2019-03-02', 224, NULL),
('Candlewood Suites', 178, '2019-03-03', 283, NULL),
('Candlewood Suites', 178, '2019-03-04', 128, NULL),
('Candlewood Suites', 178, '2019-03-05', 328, NULL),
('Candlewood Suites', 178, '2019-03-06', 298, NULL),
('Candlewood Suites', 178, '2019-03-07', 314, NULL),
('Candlewood Suites', 178, '2019-03-08', 366, NULL),
('Candlewood Suites', 178, '2019-03-09', 228, NULL),
('Candlewood Suites', 178, '2019-03-10', 294, NULL),
('Candlewood Suites', 178, '2019-03-11', 108, NULL),
('Candlewood Suites', 178, '2019-03-12', 377, NULL),
('Candlewood Suites', 178, '2019-03-13', 300, NULL),
('Candlewood Suites', 178, '2019-03-14', 175, NULL),
('Candlewood Suites', 178, '2019-03-15', 271, NULL),
('Candlewood Suites', 178, '2019-03-16', 336, NULL),
('Candlewood Suites', 178, '2019-03-17', 305, NULL),
('Candlewood Suites', 178, '2019-03-18', 193, NULL),
('Candlewood Suites', 178, '2019-03-19', 290, NULL),
('Candlewood Suites', 178, '2019-03-20', 175, NULL),
('Candlewood Suites', 178, '2019-03-21', 284, NULL),
('Candlewood Suites', 178, '2019-03-22', 268, NULL),
('Candlewood Suites', 178, '2019-03-23', 294, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 178, '2019-03-24', 162, NULL),
('Candlewood Suites', 178, '2019-03-25', 165, NULL),
('Candlewood Suites', 178, '2019-03-26', 265, NULL),
('Candlewood Suites', 178, '2019-03-27', 184, NULL),
('Candlewood Suites', 178, '2019-03-28', 222, NULL),
('Candlewood Suites', 178, '2019-03-29', 321, NULL),
('Candlewood Suites', 178, '2019-03-30', 330, NULL),
('Candlewood Suites', 178, '2019-03-31', 229, NULL),
('Candlewood Suites', 178, '2019-04-01', 391, NULL),
('Candlewood Suites', 178, '2019-04-02', 203, NULL),
('Candlewood Suites', 178, '2019-04-03', 236, NULL),
('Candlewood Suites', 178, '2019-04-04', 106, NULL),
('Candlewood Suites', 178, '2019-04-05', 105, NULL),
('Candlewood Suites', 178, '2019-04-06', 249, NULL),
('Candlewood Suites', 178, '2019-04-07', 156, NULL),
('Candlewood Suites', 178, '2019-04-08', 307, NULL),
('Candlewood Suites', 178, '2019-04-09', 196, NULL),
('Candlewood Suites', 178, '2019-04-10', 278, NULL),
('Candlewood Suites', 178, '2019-04-11', 360, NULL),
('Candlewood Suites', 178, '2019-04-12', 272, NULL),
('Candlewood Suites', 178, '2019-04-13', 255, NULL),
('Candlewood Suites', 178, '2019-04-14', 125, NULL),
('Candlewood Suites', 178, '2019-04-15', 260, NULL),
('Candlewood Suites', 178, '2019-04-16', 147, NULL),
('Candlewood Suites', 178, '2019-04-17', 117, NULL),
('Candlewood Suites', 178, '2019-04-18', 291, NULL),
('Candlewood Suites', 178, '2019-04-19', 129, NULL),
('Candlewood Suites', 178, '2019-04-20', 246, NULL),
('Candlewood Suites', 178, '2019-04-21', 326, NULL),
('Candlewood Suites', 178, '2019-04-22', 315, NULL),
('Candlewood Suites', 178, '2019-04-23', 351, NULL),
('Candlewood Suites', 178, '2019-04-24', 376, NULL),
('Candlewood Suites', 178, '2019-04-25', 245, NULL),
('Candlewood Suites', 178, '2019-04-26', 183, NULL),
('Candlewood Suites', 178, '2019-04-27', 358, NULL),
('Candlewood Suites', 178, '2019-04-28', 112, NULL),
('Candlewood Suites', 178, '2019-04-29', 341, NULL),
('Candlewood Suites', 178, '2019-04-30', 353, NULL),
('Candlewood Suites', 178, '2019-05-01', 349, NULL),
('Candlewood Suites', 178, '2019-05-02', 386, NULL),
('Candlewood Suites', 178, '2019-05-03', 359, NULL),
('Candlewood Suites', 178, '2019-05-04', 129, NULL),
('Candlewood Suites', 178, '2019-05-05', 163, NULL),
('Candlewood Suites', 178, '2019-05-06', 358, NULL),
('Candlewood Suites', 178, '2019-05-07', 306, NULL),
('Candlewood Suites', 178, '2019-05-08', 377, NULL),
('Candlewood Suites', 178, '2019-05-09', 282, NULL),
('Candlewood Suites', 178, '2019-05-10', 208, NULL),
('Candlewood Suites', 178, '2019-05-11', 384, NULL),
('Candlewood Suites', 178, '2019-05-12', 252, NULL),
('Candlewood Suites', 178, '2019-05-13', 294, NULL),
('Candlewood Suites', 178, '2019-05-14', 182, NULL),
('Candlewood Suites', 178, '2019-05-15', 272, NULL),
('Candlewood Suites', 178, '2019-05-16', 201, NULL),
('Candlewood Suites', 178, '2019-05-17', 286, NULL),
('Candlewood Suites', 178, '2019-05-18', 148, NULL),
('Candlewood Suites', 178, '2019-05-19', 273, NULL),
('Candlewood Suites', 178, '2019-05-20', 179, NULL),
('Candlewood Suites', 178, '2019-05-21', 305, NULL),
('Candlewood Suites', 178, '2019-05-22', 123, NULL),
('Candlewood Suites', 178, '2019-05-23', 261, NULL),
('Candlewood Suites', 178, '2019-05-24', 196, NULL),
('Candlewood Suites', 178, '2019-05-25', 163, NULL),
('Candlewood Suites', 178, '2019-05-26', 128, NULL),
('Candlewood Suites', 178, '2019-05-27', 334, NULL),
('Candlewood Suites', 178, '2019-05-28', 146, NULL),
('Candlewood Suites', 178, '2019-05-29', 230, NULL),
('Candlewood Suites', 178, '2019-05-30', 377, NULL),
('Candlewood Suites', 178, '2019-05-31', 270, NULL),
('Candlewood Suites', 178, '2019-06-01', 296, NULL),
('Candlewood Suites', 178, '2019-06-02', 262, NULL),
('Candlewood Suites', 178, '2019-06-03', 325, NULL),
('Candlewood Suites', 178, '2019-06-04', 221, NULL),
('Candlewood Suites', 178, '2019-06-05', 123, NULL),
('Candlewood Suites', 178, '2019-06-06', 381, NULL),
('Candlewood Suites', 178, '2019-06-07', 199, NULL),
('Candlewood Suites', 178, '2019-06-08', 321, NULL),
('Candlewood Suites', 178, '2019-06-09', 315, NULL),
('Candlewood Suites', 178, '2019-06-10', 203, NULL),
('Candlewood Suites', 178, '2019-06-11', 302, NULL),
('Candlewood Suites', 178, '2019-06-12', 143, NULL),
('Candlewood Suites', 178, '2019-06-13', 206, NULL),
('Candlewood Suites', 178, '2019-06-14', 272, NULL),
('Candlewood Suites', 178, '2019-06-15', 300, NULL),
('Candlewood Suites', 178, '2019-06-16', 138, NULL),
('Candlewood Suites', 178, '2019-06-17', 277, NULL),
('Candlewood Suites', 178, '2019-06-18', 170, NULL),
('Candlewood Suites', 178, '2019-06-19', 376, NULL),
('Candlewood Suites', 178, '2019-06-20', 295, NULL),
('Candlewood Suites', 178, '2019-06-21', 332, NULL),
('Candlewood Suites', 178, '2019-06-22', 330, NULL),
('Candlewood Suites', 178, '2019-06-23', 353, NULL),
('Candlewood Suites', 178, '2019-06-24', 357, NULL),
('Candlewood Suites', 178, '2019-06-25', 119, NULL),
('Candlewood Suites', 178, '2019-06-26', 276, NULL),
('Candlewood Suites', 178, '2019-06-27', 338, NULL),
('Candlewood Suites', 178, '2019-06-28', 374, NULL),
('Candlewood Suites', 178, '2019-06-29', 329, NULL),
('Candlewood Suites', 178, '2019-06-30', 391, NULL),
('Candlewood Suites', 178, '2019-07-01', 203, NULL),
('Candlewood Suites', 178, '2019-07-02', 123, NULL),
('Candlewood Suites', 178, '2019-07-03', 227, NULL),
('Candlewood Suites', 178, '2019-07-04', 272, NULL),
('Candlewood Suites', 178, '2019-07-05', 373, NULL),
('Candlewood Suites', 178, '2019-07-06', 348, NULL),
('Candlewood Suites', 178, '2019-07-07', 183, NULL),
('Candlewood Suites', 178, '2019-07-08', 232, NULL),
('Candlewood Suites', 178, '2019-07-09', 274, NULL),
('Candlewood Suites', 178, '2019-07-10', 197, NULL),
('Candlewood Suites', 178, '2019-07-11', 350, NULL),
('Candlewood Suites', 178, '2019-07-12', 268, NULL),
('Candlewood Suites', 178, '2019-07-13', 328, NULL),
('Candlewood Suites', 178, '2019-07-14', 124, NULL),
('Candlewood Suites', 178, '2019-07-15', 228, NULL),
('Candlewood Suites', 178, '2019-07-16', 312, NULL),
('Candlewood Suites', 178, '2019-07-17', 243, NULL),
('Candlewood Suites', 178, '2019-07-18', 288, NULL),
('Candlewood Suites', 178, '2019-07-19', 300, NULL),
('Candlewood Suites', 178, '2019-07-20', 254, NULL),
('Candlewood Suites', 178, '2019-07-21', 354, NULL),
('Candlewood Suites', 178, '2019-07-22', 180, NULL),
('Candlewood Suites', 178, '2019-07-23', 378, NULL),
('Candlewood Suites', 178, '2019-07-24', 253, NULL),
('Candlewood Suites', 178, '2019-07-25', 131, NULL),
('Candlewood Suites', 178, '2019-07-26', 294, NULL),
('Candlewood Suites', 178, '2019-07-27', 153, NULL),
('Candlewood Suites', 178, '2019-07-28', 235, NULL),
('Candlewood Suites', 178, '2019-07-29', 393, NULL),
('Candlewood Suites', 178, '2019-07-30', 200, NULL),
('Candlewood Suites', 178, '2019-07-31', 247, NULL),
('Candlewood Suites', 178, '2019-08-01', 163, NULL),
('Candlewood Suites', 178, '2019-08-02', 224, NULL),
('Candlewood Suites', 178, '2019-08-03', 100, NULL),
('Candlewood Suites', 178, '2019-08-04', 290, NULL),
('Candlewood Suites', 178, '2019-08-05', 174, NULL),
('Candlewood Suites', 178, '2019-08-06', 145, NULL),
('Candlewood Suites', 178, '2019-08-07', 122, NULL),
('Candlewood Suites', 178, '2019-08-08', 222, NULL),
('Candlewood Suites', 178, '2019-08-09', 223, NULL),
('Candlewood Suites', 178, '2019-08-10', 178, NULL),
('Candlewood Suites', 178, '2019-08-11', 197, NULL),
('Candlewood Suites', 178, '2019-08-12', 178, NULL),
('Candlewood Suites', 178, '2019-08-13', 307, NULL),
('Candlewood Suites', 178, '2019-08-14', 292, NULL),
('Candlewood Suites', 178, '2019-08-15', 247, NULL),
('Candlewood Suites', 178, '2019-08-16', 335, NULL),
('Candlewood Suites', 178, '2019-08-17', 320, NULL),
('Candlewood Suites', 178, '2019-08-18', 197, NULL),
('Candlewood Suites', 178, '2019-08-19', 260, NULL),
('Candlewood Suites', 178, '2019-08-20', 330, NULL),
('Candlewood Suites', 178, '2019-08-21', 308, NULL),
('Candlewood Suites', 178, '2019-08-22', 360, NULL),
('Candlewood Suites', 178, '2019-08-23', 362, NULL),
('Candlewood Suites', 178, '2019-08-24', 104, NULL),
('Candlewood Suites', 178, '2019-08-25', 255, NULL),
('Candlewood Suites', 178, '2019-08-26', 395, NULL),
('Candlewood Suites', 178, '2019-08-27', 345, NULL),
('Candlewood Suites', 178, '2019-08-28', 191, NULL),
('Candlewood Suites', 178, '2019-08-29', 140, NULL),
('Candlewood Suites', 178, '2019-08-30', 198, NULL),
('Candlewood Suites', 178, '2019-08-31', 201, NULL),
('Candlewood Suites', 178, '2019-09-01', 252, NULL),
('Candlewood Suites', 178, '2019-09-02', 251, NULL),
('Candlewood Suites', 178, '2019-09-03', 297, NULL),
('Candlewood Suites', 178, '2019-09-04', 149, NULL),
('Candlewood Suites', 178, '2019-09-05', 155, NULL),
('Candlewood Suites', 178, '2019-09-06', 106, NULL),
('Candlewood Suites', 178, '2019-09-07', 231, NULL),
('Candlewood Suites', 178, '2019-09-08', 228, NULL),
('Candlewood Suites', 178, '2019-09-09', 302, NULL),
('Candlewood Suites', 178, '2019-09-10', 357, NULL),
('Candlewood Suites', 178, '2019-09-11', 334, NULL),
('Candlewood Suites', 178, '2019-09-12', 168, NULL),
('Candlewood Suites', 178, '2019-09-13', 320, NULL),
('Candlewood Suites', 178, '2019-09-14', 364, NULL),
('Candlewood Suites', 178, '2019-09-15', 266, NULL),
('Candlewood Suites', 178, '2019-09-16', 190, NULL),
('Candlewood Suites', 178, '2019-09-17', 311, NULL),
('Candlewood Suites', 178, '2019-09-18', 276, NULL),
('Candlewood Suites', 178, '2019-09-19', 239, NULL),
('Candlewood Suites', 178, '2019-09-20', 294, NULL),
('Candlewood Suites', 178, '2019-09-21', 156, NULL),
('Candlewood Suites', 178, '2019-09-22', 248, NULL),
('Candlewood Suites', 178, '2019-09-23', 169, NULL),
('Candlewood Suites', 178, '2019-09-24', 129, NULL),
('Candlewood Suites', 178, '2019-09-25', 339, NULL),
('Candlewood Suites', 178, '2019-09-26', 145, NULL),
('Candlewood Suites', 178, '2019-09-27', 199, NULL),
('Candlewood Suites', 178, '2019-09-28', 213, NULL),
('Candlewood Suites', 178, '2019-09-29', 283, NULL),
('Candlewood Suites', 178, '2019-09-30', 184, NULL),
('Candlewood Suites', 178, '2019-10-01', 200, NULL),
('Candlewood Suites', 178, '2019-10-02', 277, NULL),
('Candlewood Suites', 178, '2019-10-03', 321, NULL),
('Candlewood Suites', 178, '2019-10-04', 224, NULL),
('Candlewood Suites', 178, '2019-10-05', 270, NULL),
('Candlewood Suites', 178, '2019-10-06', 172, NULL),
('Candlewood Suites', 178, '2019-10-07', 158, NULL),
('Candlewood Suites', 178, '2019-10-08', 257, NULL),
('Candlewood Suites', 178, '2019-10-09', 327, NULL),
('Candlewood Suites', 178, '2019-10-10', 254, NULL),
('Candlewood Suites', 178, '2019-10-11', 132, NULL),
('Candlewood Suites', 178, '2019-10-12', 170, NULL),
('Candlewood Suites', 178, '2019-10-13', 396, NULL),
('Candlewood Suites', 178, '2019-10-14', 396, NULL),
('Candlewood Suites', 178, '2019-10-15', 262, NULL),
('Candlewood Suites', 178, '2019-10-16', 256, NULL),
('Candlewood Suites', 178, '2019-10-17', 266, NULL),
('Candlewood Suites', 178, '2019-10-18', 241, NULL),
('Candlewood Suites', 178, '2019-10-19', 363, NULL),
('Candlewood Suites', 178, '2019-10-20', 247, NULL),
('Candlewood Suites', 178, '2019-10-21', 130, NULL),
('Candlewood Suites', 178, '2019-10-22', 338, NULL),
('Candlewood Suites', 178, '2019-10-23', 374, NULL),
('Candlewood Suites', 178, '2019-10-24', 197, NULL),
('Candlewood Suites', 178, '2019-10-25', 386, NULL),
('Candlewood Suites', 178, '2019-10-26', 384, NULL),
('Candlewood Suites', 178, '2019-10-27', 389, NULL),
('Candlewood Suites', 178, '2019-10-28', 398, NULL),
('Candlewood Suites', 178, '2019-10-29', 334, NULL),
('Candlewood Suites', 178, '2019-10-30', 133, NULL),
('Candlewood Suites', 178, '2019-10-31', 310, NULL),
('Candlewood Suites', 178, '2019-11-01', 323, NULL),
('Candlewood Suites', 178, '2019-11-02', 127, NULL),
('Candlewood Suites', 178, '2019-11-03', 275, NULL),
('Candlewood Suites', 178, '2019-11-04', 243, NULL),
('Candlewood Suites', 178, '2019-11-05', 346, NULL),
('Candlewood Suites', 178, '2019-11-06', 256, NULL),
('Candlewood Suites', 178, '2019-11-07', 215, NULL),
('Candlewood Suites', 178, '2019-11-08', 109, NULL),
('Candlewood Suites', 178, '2019-11-09', 386, NULL),
('Candlewood Suites', 178, '2019-11-10', 276, NULL),
('Candlewood Suites', 178, '2019-11-11', 323, NULL),
('Candlewood Suites', 178, '2019-11-12', 243, NULL),
('Candlewood Suites', 178, '2019-11-13', 168, NULL),
('Candlewood Suites', 178, '2019-11-14', 161, NULL),
('Candlewood Suites', 178, '2019-11-15', 192, NULL),
('Candlewood Suites', 178, '2019-11-16', 298, NULL),
('Candlewood Suites', 178, '2019-11-17', 335, NULL),
('Candlewood Suites', 178, '2019-11-18', 343, NULL),
('Candlewood Suites', 178, '2019-11-19', 353, NULL),
('Candlewood Suites', 178, '2019-11-20', 261, NULL),
('Candlewood Suites', 178, '2019-11-21', 218, NULL),
('Candlewood Suites', 178, '2019-11-22', 355, NULL),
('Candlewood Suites', 178, '2019-11-23', 342, NULL),
('Candlewood Suites', 178, '2019-11-24', 363, NULL),
('Candlewood Suites', 178, '2019-11-25', 399, NULL),
('Candlewood Suites', 178, '2019-11-26', 330, NULL),
('Candlewood Suites', 178, '2019-11-27', 316, NULL),
('Candlewood Suites', 178, '2019-11-28', 173, NULL),
('Candlewood Suites', 178, '2019-11-29', 385, NULL),
('Candlewood Suites', 178, '2019-11-30', 238, NULL),
('Candlewood Suites', 178, '2019-12-01', 173, NULL),
('Candlewood Suites', 178, '2019-12-02', 311, NULL),
('Candlewood Suites', 178, '2019-12-03', 337, NULL),
('Candlewood Suites', 178, '2019-12-04', 233, NULL),
('Candlewood Suites', 178, '2019-12-05', 327, NULL),
('Candlewood Suites', 178, '2019-12-06', 349, NULL),
('Candlewood Suites', 178, '2019-12-07', 387, NULL),
('Candlewood Suites', 178, '2019-12-08', 325, NULL),
('Candlewood Suites', 178, '2019-12-09', 228, NULL),
('Candlewood Suites', 178, '2019-12-10', 102, NULL),
('Candlewood Suites', 178, '2019-12-11', 379, NULL),
('Candlewood Suites', 178, '2019-12-12', 321, NULL),
('Candlewood Suites', 178, '2019-12-13', 394, NULL),
('Candlewood Suites', 178, '2019-12-14', 362, NULL),
('Candlewood Suites', 178, '2019-12-15', 363, NULL),
('Candlewood Suites', 178, '2019-12-16', 111, NULL),
('Candlewood Suites', 178, '2019-12-17', 146, NULL),
('Candlewood Suites', 178, '2019-12-18', 344, NULL),
('Candlewood Suites', 178, '2019-12-19', 241, NULL),
('Candlewood Suites', 178, '2019-12-20', 300, NULL),
('Candlewood Suites', 178, '2019-12-21', 311, NULL),
('Candlewood Suites', 178, '2019-12-22', 296, NULL),
('Candlewood Suites', 178, '2019-12-23', 210, NULL),
('Candlewood Suites', 178, '2019-12-24', 251, NULL),
('Candlewood Suites', 178, '2019-12-25', 248, NULL),
('Candlewood Suites', 178, '2019-12-26', 276, NULL),
('Candlewood Suites', 178, '2019-12-27', 315, NULL),
('Candlewood Suites', 178, '2019-12-28', 398, NULL),
('Candlewood Suites', 178, '2019-12-29', 397, NULL),
('Candlewood Suites', 178, '2019-12-30', 313, NULL),
('Candlewood Suites', 178, '2019-12-31', 369, NULL),
('Candlewood Suites', 178, '2020-01-01', 131, NULL),
('Candlewood Suites', 178, '2020-01-02', 247, NULL),
('Candlewood Suites', 178, '2020-01-03', 294, NULL),
('Candlewood Suites', 178, '2020-01-04', 371, NULL),
('Candlewood Suites', 178, '2020-01-05', 278, NULL),
('Candlewood Suites', 178, '2020-01-06', 128, NULL),
('Candlewood Suites', 178, '2020-01-07', 280, NULL),
('Candlewood Suites', 178, '2020-01-08', 145, NULL),
('Candlewood Suites', 178, '2020-01-09', 209, NULL),
('Candlewood Suites', 178, '2020-01-10', 388, NULL),
('Candlewood Suites', 178, '2020-01-11', 155, NULL),
('Candlewood Suites', 178, '2020-01-12', 245, NULL),
('Candlewood Suites', 178, '2020-01-13', 270, NULL),
('Candlewood Suites', 178, '2020-01-14', 235, NULL),
('Candlewood Suites', 178, '2020-01-15', 242, NULL),
('Candlewood Suites', 178, '2020-01-16', 164, NULL),
('Candlewood Suites', 178, '2020-01-17', 324, NULL),
('Candlewood Suites', 178, '2020-01-18', 212, NULL),
('Candlewood Suites', 178, '2020-01-19', 105, NULL),
('Candlewood Suites', 178, '2020-01-20', 286, NULL),
('Candlewood Suites', 178, '2020-01-21', 309, NULL),
('Candlewood Suites', 178, '2020-01-22', 256, NULL),
('Candlewood Suites', 178, '2020-01-23', 355, NULL),
('Candlewood Suites', 178, '2020-01-24', 250, NULL),
('Candlewood Suites', 178, '2020-01-25', 355, NULL),
('Candlewood Suites', 178, '2020-01-26', 198, NULL),
('Candlewood Suites', 178, '2020-01-27', 224, NULL),
('Candlewood Suites', 178, '2020-01-28', 289, NULL),
('Candlewood Suites', 178, '2020-01-29', 291, NULL),
('Candlewood Suites', 178, '2020-01-30', 359, NULL),
('Candlewood Suites', 178, '2020-01-31', 259, NULL),
('Candlewood Suites', 178, '2020-02-01', 388, NULL),
('Candlewood Suites', 178, '2020-02-02', 133, NULL),
('Candlewood Suites', 178, '2020-02-03', 393, NULL),
('Candlewood Suites', 178, '2020-02-04', 184, NULL),
('Candlewood Suites', 180, '2019-01-01', 241, NULL),
('Candlewood Suites', 180, '2019-01-02', 285, NULL),
('Candlewood Suites', 180, '2019-01-03', 104, NULL),
('Candlewood Suites', 180, '2019-01-04', 192, NULL),
('Candlewood Suites', 180, '2019-01-05', 388, NULL),
('Candlewood Suites', 180, '2019-01-06', 226, NULL),
('Candlewood Suites', 180, '2019-01-07', 354, NULL),
('Candlewood Suites', 180, '2019-01-08', 349, NULL),
('Candlewood Suites', 180, '2019-01-09', 196, NULL),
('Candlewood Suites', 180, '2019-01-10', 190, NULL),
('Candlewood Suites', 180, '2019-01-11', 246, NULL),
('Candlewood Suites', 180, '2019-01-12', 293, NULL),
('Candlewood Suites', 180, '2019-01-13', 252, NULL),
('Candlewood Suites', 180, '2019-01-14', 126, NULL),
('Candlewood Suites', 180, '2019-01-15', 153, NULL),
('Candlewood Suites', 180, '2019-01-16', 274, NULL),
('Candlewood Suites', 180, '2019-01-17', 331, NULL),
('Candlewood Suites', 180, '2019-01-18', 364, NULL),
('Candlewood Suites', 180, '2019-01-19', 255, NULL),
('Candlewood Suites', 180, '2019-01-20', 272, NULL),
('Candlewood Suites', 180, '2019-01-21', 374, NULL),
('Candlewood Suites', 180, '2019-01-22', 394, NULL),
('Candlewood Suites', 180, '2019-01-23', 396, NULL),
('Candlewood Suites', 180, '2019-01-24', 324, NULL),
('Candlewood Suites', 180, '2019-01-25', 368, NULL),
('Candlewood Suites', 180, '2019-01-26', 388, NULL),
('Candlewood Suites', 180, '2019-01-27', 222, NULL),
('Candlewood Suites', 180, '2019-01-28', 355, NULL),
('Candlewood Suites', 180, '2019-01-29', 127, NULL),
('Candlewood Suites', 180, '2019-01-30', 249, NULL),
('Candlewood Suites', 180, '2019-01-31', 364, NULL),
('Candlewood Suites', 180, '2019-02-01', 291, NULL),
('Candlewood Suites', 180, '2019-02-02', 397, NULL),
('Candlewood Suites', 180, '2019-02-03', 118, NULL),
('Candlewood Suites', 180, '2019-02-04', 123, NULL),
('Candlewood Suites', 180, '2019-02-05', 110, NULL),
('Candlewood Suites', 180, '2019-02-06', 318, NULL),
('Candlewood Suites', 180, '2019-02-07', 377, NULL),
('Candlewood Suites', 180, '2019-02-08', 257, NULL),
('Candlewood Suites', 180, '2019-02-09', 247, NULL),
('Candlewood Suites', 180, '2019-02-10', 246, NULL),
('Candlewood Suites', 180, '2019-02-11', 183, NULL),
('Candlewood Suites', 180, '2019-02-12', 323, NULL),
('Candlewood Suites', 180, '2019-02-13', 300, NULL),
('Candlewood Suites', 180, '2019-02-14', 269, NULL),
('Candlewood Suites', 180, '2019-02-15', 109, NULL),
('Candlewood Suites', 180, '2019-02-16', 333, NULL),
('Candlewood Suites', 180, '2019-02-17', 250, NULL),
('Candlewood Suites', 180, '2019-02-18', 391, NULL),
('Candlewood Suites', 180, '2019-02-19', 286, NULL),
('Candlewood Suites', 180, '2019-02-20', 269, NULL),
('Candlewood Suites', 180, '2019-02-21', 213, NULL),
('Candlewood Suites', 180, '2019-02-22', 392, NULL),
('Candlewood Suites', 180, '2019-02-23', 252, NULL),
('Candlewood Suites', 180, '2019-02-24', 350, NULL),
('Candlewood Suites', 180, '2019-02-25', 223, NULL),
('Candlewood Suites', 180, '2019-02-26', 133, NULL),
('Candlewood Suites', 180, '2019-02-27', 328, NULL),
('Candlewood Suites', 180, '2019-02-28', 138, NULL),
('Candlewood Suites', 180, '2019-03-01', 357, NULL),
('Candlewood Suites', 180, '2019-03-02', 182, NULL),
('Candlewood Suites', 180, '2019-03-03', 262, NULL),
('Candlewood Suites', 180, '2019-03-04', 224, NULL),
('Candlewood Suites', 180, '2019-03-05', 180, NULL),
('Candlewood Suites', 180, '2019-03-06', 146, NULL),
('Candlewood Suites', 180, '2019-03-07', 289, NULL),
('Candlewood Suites', 180, '2019-03-08', 190, NULL),
('Candlewood Suites', 180, '2019-03-09', 304, NULL),
('Candlewood Suites', 180, '2019-03-10', 242, NULL),
('Candlewood Suites', 180, '2019-03-11', 105, NULL),
('Candlewood Suites', 180, '2019-03-12', 242, NULL),
('Candlewood Suites', 180, '2019-03-13', 103, NULL),
('Candlewood Suites', 180, '2019-03-14', 143, NULL),
('Candlewood Suites', 180, '2019-03-15', 270, NULL),
('Candlewood Suites', 180, '2019-03-16', 366, NULL),
('Candlewood Suites', 180, '2019-03-17', 385, NULL),
('Candlewood Suites', 180, '2019-03-18', 285, NULL),
('Candlewood Suites', 180, '2019-03-19', 160, NULL),
('Candlewood Suites', 180, '2019-03-20', 310, NULL),
('Candlewood Suites', 180, '2019-03-21', 119, NULL),
('Candlewood Suites', 180, '2019-03-22', 249, NULL),
('Candlewood Suites', 180, '2019-03-23', 320, NULL),
('Candlewood Suites', 180, '2019-03-24', 148, NULL),
('Candlewood Suites', 180, '2019-03-25', 198, NULL),
('Candlewood Suites', 180, '2019-03-26', 123, NULL),
('Candlewood Suites', 180, '2019-03-27', 316, NULL),
('Candlewood Suites', 180, '2019-03-28', 191, NULL),
('Candlewood Suites', 180, '2019-03-29', 251, NULL),
('Candlewood Suites', 180, '2019-03-30', 321, NULL),
('Candlewood Suites', 180, '2019-03-31', 139, NULL),
('Candlewood Suites', 180, '2019-04-01', 351, NULL),
('Candlewood Suites', 180, '2019-04-02', 164, NULL),
('Candlewood Suites', 180, '2019-04-03', 194, NULL),
('Candlewood Suites', 180, '2019-04-04', 315, NULL),
('Candlewood Suites', 180, '2019-04-05', 319, NULL),
('Candlewood Suites', 180, '2019-04-06', 243, NULL),
('Candlewood Suites', 180, '2019-04-07', 364, NULL),
('Candlewood Suites', 180, '2019-04-08', 183, NULL),
('Candlewood Suites', 180, '2019-04-09', 330, NULL),
('Candlewood Suites', 180, '2019-04-10', 272, NULL),
('Candlewood Suites', 180, '2019-04-11', 332, NULL),
('Candlewood Suites', 180, '2019-04-12', 115, NULL),
('Candlewood Suites', 180, '2019-04-13', 138, NULL),
('Candlewood Suites', 180, '2019-04-14', 169, NULL),
('Candlewood Suites', 180, '2019-04-15', 392, NULL),
('Candlewood Suites', 180, '2019-04-16', 138, NULL),
('Candlewood Suites', 180, '2019-04-17', 323, NULL),
('Candlewood Suites', 180, '2019-04-18', 104, NULL),
('Candlewood Suites', 180, '2019-04-19', 145, NULL),
('Candlewood Suites', 180, '2019-04-20', 196, NULL),
('Candlewood Suites', 180, '2019-04-21', 157, NULL),
('Candlewood Suites', 180, '2019-04-22', 394, NULL),
('Candlewood Suites', 180, '2019-04-23', 112, NULL),
('Candlewood Suites', 180, '2019-04-24', 396, NULL),
('Candlewood Suites', 180, '2019-04-25', 110, NULL),
('Candlewood Suites', 180, '2019-04-26', 359, NULL),
('Candlewood Suites', 180, '2019-04-27', 142, NULL),
('Candlewood Suites', 180, '2019-04-28', 123, NULL),
('Candlewood Suites', 180, '2019-04-29', 190, NULL),
('Candlewood Suites', 180, '2019-04-30', 287, NULL),
('Candlewood Suites', 180, '2019-05-01', 298, NULL),
('Candlewood Suites', 180, '2019-05-02', 170, NULL),
('Candlewood Suites', 180, '2019-05-03', 125, NULL),
('Candlewood Suites', 180, '2019-05-04', 222, NULL),
('Candlewood Suites', 180, '2019-05-05', 130, NULL),
('Candlewood Suites', 180, '2019-05-06', 301, NULL),
('Candlewood Suites', 180, '2019-05-07', 220, NULL),
('Candlewood Suites', 180, '2019-05-08', 180, NULL),
('Candlewood Suites', 180, '2019-05-09', 328, NULL),
('Candlewood Suites', 180, '2019-05-10', 365, NULL),
('Candlewood Suites', 180, '2019-05-11', 113, NULL),
('Candlewood Suites', 180, '2019-05-12', 363, NULL),
('Candlewood Suites', 180, '2019-05-13', 156, NULL),
('Candlewood Suites', 180, '2019-05-14', 245, NULL),
('Candlewood Suites', 180, '2019-05-15', 231, NULL),
('Candlewood Suites', 180, '2019-05-16', 133, NULL),
('Candlewood Suites', 180, '2019-05-17', 340, NULL),
('Candlewood Suites', 180, '2019-05-18', 349, NULL),
('Candlewood Suites', 180, '2019-05-19', 325, NULL),
('Candlewood Suites', 180, '2019-05-20', 306, NULL),
('Candlewood Suites', 180, '2019-05-21', 118, NULL),
('Candlewood Suites', 180, '2019-05-22', 138, NULL),
('Candlewood Suites', 180, '2019-05-23', 315, NULL),
('Candlewood Suites', 180, '2019-05-24', 302, NULL),
('Candlewood Suites', 180, '2019-05-25', 199, NULL),
('Candlewood Suites', 180, '2019-05-26', 230, NULL),
('Candlewood Suites', 180, '2019-05-27', 306, NULL),
('Candlewood Suites', 180, '2019-05-28', 302, NULL),
('Candlewood Suites', 180, '2019-05-29', 289, NULL),
('Candlewood Suites', 180, '2019-05-30', 184, NULL),
('Candlewood Suites', 180, '2019-05-31', 255, NULL),
('Candlewood Suites', 180, '2019-06-01', 226, NULL),
('Candlewood Suites', 180, '2019-06-02', 319, NULL),
('Candlewood Suites', 180, '2019-06-03', 113, NULL),
('Candlewood Suites', 180, '2019-06-04', 312, NULL),
('Candlewood Suites', 180, '2019-06-05', 218, NULL),
('Candlewood Suites', 180, '2019-06-06', 164, NULL),
('Candlewood Suites', 180, '2019-06-07', 178, NULL),
('Candlewood Suites', 180, '2019-06-08', 205, NULL),
('Candlewood Suites', 180, '2019-06-09', 185, NULL),
('Candlewood Suites', 180, '2019-06-10', 177, NULL),
('Candlewood Suites', 180, '2019-06-11', 162, NULL),
('Candlewood Suites', 180, '2019-06-12', 172, NULL),
('Candlewood Suites', 180, '2019-06-13', 106, NULL),
('Candlewood Suites', 180, '2019-06-14', 303, NULL),
('Candlewood Suites', 180, '2019-06-15', 153, NULL),
('Candlewood Suites', 180, '2019-06-16', 282, NULL),
('Candlewood Suites', 180, '2019-06-17', 223, NULL),
('Candlewood Suites', 180, '2019-06-18', 307, NULL),
('Candlewood Suites', 180, '2019-06-19', 368, NULL),
('Candlewood Suites', 180, '2019-06-20', 223, NULL),
('Candlewood Suites', 180, '2019-06-21', 220, NULL),
('Candlewood Suites', 180, '2019-06-22', 335, NULL),
('Candlewood Suites', 180, '2019-06-23', 172, NULL),
('Candlewood Suites', 180, '2019-06-24', 216, NULL),
('Candlewood Suites', 180, '2019-06-25', 173, NULL),
('Candlewood Suites', 180, '2019-06-26', 152, NULL),
('Candlewood Suites', 180, '2019-06-27', 291, NULL),
('Candlewood Suites', 180, '2019-06-28', 364, NULL),
('Candlewood Suites', 180, '2019-06-29', 333, NULL),
('Candlewood Suites', 180, '2019-06-30', 110, NULL),
('Candlewood Suites', 180, '2019-07-01', 189, NULL),
('Candlewood Suites', 180, '2019-07-02', 143, NULL),
('Candlewood Suites', 180, '2019-07-03', 113, NULL),
('Candlewood Suites', 180, '2019-07-04', 135, NULL),
('Candlewood Suites', 180, '2019-07-05', 295, NULL),
('Candlewood Suites', 180, '2019-07-06', 225, NULL),
('Candlewood Suites', 180, '2019-07-07', 217, NULL),
('Candlewood Suites', 180, '2019-07-08', 271, NULL),
('Candlewood Suites', 180, '2019-07-09', 392, NULL),
('Candlewood Suites', 180, '2019-07-10', 296, NULL),
('Candlewood Suites', 180, '2019-07-11', 378, NULL),
('Candlewood Suites', 180, '2019-07-12', 171, NULL),
('Candlewood Suites', 180, '2019-07-13', 180, NULL),
('Candlewood Suites', 180, '2019-07-14', 377, NULL),
('Candlewood Suites', 180, '2019-07-15', 304, NULL),
('Candlewood Suites', 180, '2019-07-16', 380, NULL),
('Candlewood Suites', 180, '2019-07-17', 325, NULL),
('Candlewood Suites', 180, '2019-07-18', 339, NULL),
('Candlewood Suites', 180, '2019-07-19', 161, NULL),
('Candlewood Suites', 180, '2019-07-20', 259, NULL),
('Candlewood Suites', 180, '2019-07-21', 190, NULL),
('Candlewood Suites', 180, '2019-07-22', 379, NULL),
('Candlewood Suites', 180, '2019-07-23', 175, NULL),
('Candlewood Suites', 180, '2019-07-24', 277, NULL),
('Candlewood Suites', 180, '2019-07-25', 101, NULL),
('Candlewood Suites', 180, '2019-07-26', 262, NULL),
('Candlewood Suites', 180, '2019-07-27', 385, NULL),
('Candlewood Suites', 180, '2019-07-28', 380, NULL),
('Candlewood Suites', 180, '2019-07-29', 337, NULL),
('Candlewood Suites', 180, '2019-07-30', 193, NULL),
('Candlewood Suites', 180, '2019-07-31', 121, NULL),
('Candlewood Suites', 180, '2019-08-01', 114, NULL),
('Candlewood Suites', 180, '2019-08-02', 176, NULL),
('Candlewood Suites', 180, '2019-08-03', 326, NULL),
('Candlewood Suites', 180, '2019-08-04', 156, NULL),
('Candlewood Suites', 180, '2019-08-05', 191, NULL),
('Candlewood Suites', 180, '2019-08-06', 359, NULL),
('Candlewood Suites', 180, '2019-08-07', 201, NULL),
('Candlewood Suites', 180, '2019-08-08', 239, NULL),
('Candlewood Suites', 180, '2019-08-09', 370, NULL),
('Candlewood Suites', 180, '2019-08-10', 263, NULL),
('Candlewood Suites', 180, '2019-08-11', 386, NULL),
('Candlewood Suites', 180, '2019-08-12', 254, NULL),
('Candlewood Suites', 180, '2019-08-13', 187, NULL),
('Candlewood Suites', 180, '2019-08-14', 300, NULL),
('Candlewood Suites', 180, '2019-08-15', 337, NULL),
('Candlewood Suites', 180, '2019-08-16', 104, NULL),
('Candlewood Suites', 180, '2019-08-17', 354, NULL),
('Candlewood Suites', 180, '2019-08-18', 174, NULL),
('Candlewood Suites', 180, '2019-08-19', 153, NULL),
('Candlewood Suites', 180, '2019-08-20', 313, NULL),
('Candlewood Suites', 180, '2019-08-21', 371, NULL),
('Candlewood Suites', 180, '2019-08-22', 189, NULL),
('Candlewood Suites', 180, '2019-08-23', 362, NULL),
('Candlewood Suites', 180, '2019-08-24', 311, NULL),
('Candlewood Suites', 180, '2019-08-25', 307, NULL),
('Candlewood Suites', 180, '2019-08-26', 306, NULL),
('Candlewood Suites', 180, '2019-08-27', 164, NULL),
('Candlewood Suites', 180, '2019-08-28', 316, NULL),
('Candlewood Suites', 180, '2019-08-29', 131, NULL),
('Candlewood Suites', 180, '2019-08-30', 199, NULL),
('Candlewood Suites', 180, '2019-08-31', 268, NULL),
('Candlewood Suites', 180, '2019-09-01', 192, NULL),
('Candlewood Suites', 180, '2019-09-02', 299, NULL),
('Candlewood Suites', 180, '2019-09-03', 366, NULL),
('Candlewood Suites', 180, '2019-09-04', 351, NULL),
('Candlewood Suites', 180, '2019-09-05', 388, NULL),
('Candlewood Suites', 180, '2019-09-06', 364, NULL),
('Candlewood Suites', 180, '2019-09-07', 398, NULL),
('Candlewood Suites', 180, '2019-09-08', 109, NULL),
('Candlewood Suites', 180, '2019-09-09', 230, NULL),
('Candlewood Suites', 180, '2019-09-10', 105, NULL),
('Candlewood Suites', 180, '2019-09-11', 111, NULL),
('Candlewood Suites', 180, '2019-09-12', 111, NULL),
('Candlewood Suites', 180, '2019-09-13', 352, NULL),
('Candlewood Suites', 180, '2019-09-14', 113, NULL),
('Candlewood Suites', 180, '2019-09-15', 378, NULL),
('Candlewood Suites', 180, '2019-09-16', 201, NULL),
('Candlewood Suites', 180, '2019-09-17', 286, NULL),
('Candlewood Suites', 180, '2019-09-18', 313, NULL),
('Candlewood Suites', 180, '2019-09-19', 351, NULL),
('Candlewood Suites', 180, '2019-09-20', 283, NULL),
('Candlewood Suites', 180, '2019-09-21', 169, NULL),
('Candlewood Suites', 180, '2019-09-22', 250, NULL),
('Candlewood Suites', 180, '2019-09-23', 101, NULL),
('Candlewood Suites', 180, '2019-09-24', 278, NULL),
('Candlewood Suites', 180, '2019-09-25', 190, NULL),
('Candlewood Suites', 180, '2019-09-26', 304, NULL),
('Candlewood Suites', 180, '2019-09-27', 160, NULL),
('Candlewood Suites', 180, '2019-09-28', 126, NULL),
('Candlewood Suites', 180, '2019-09-29', 173, NULL),
('Candlewood Suites', 180, '2019-09-30', 213, NULL),
('Candlewood Suites', 180, '2019-10-01', 147, NULL),
('Candlewood Suites', 180, '2019-10-02', 378, NULL),
('Candlewood Suites', 180, '2019-10-03', 374, NULL),
('Candlewood Suites', 180, '2019-10-04', 291, NULL),
('Candlewood Suites', 180, '2019-10-05', 129, NULL),
('Candlewood Suites', 180, '2019-10-06', 134, NULL),
('Candlewood Suites', 180, '2019-10-07', 166, NULL),
('Candlewood Suites', 180, '2019-10-08', 110, NULL),
('Candlewood Suites', 180, '2019-10-09', 102, NULL),
('Candlewood Suites', 180, '2019-10-10', 308, NULL),
('Candlewood Suites', 180, '2019-10-11', 135, NULL),
('Candlewood Suites', 180, '2019-10-12', 240, NULL),
('Candlewood Suites', 180, '2019-10-13', 277, NULL),
('Candlewood Suites', 180, '2019-10-14', 398, NULL),
('Candlewood Suites', 180, '2019-10-15', 250, NULL),
('Candlewood Suites', 180, '2019-10-16', 229, NULL),
('Candlewood Suites', 180, '2019-10-17', 348, NULL),
('Candlewood Suites', 180, '2019-10-18', 397, NULL),
('Candlewood Suites', 180, '2019-10-19', 349, NULL),
('Candlewood Suites', 180, '2019-10-20', 240, NULL),
('Candlewood Suites', 180, '2019-10-21', 199, NULL),
('Candlewood Suites', 180, '2019-10-22', 370, NULL),
('Candlewood Suites', 180, '2019-10-23', 233, NULL),
('Candlewood Suites', 180, '2019-10-24', 115, NULL),
('Candlewood Suites', 180, '2019-10-25', 358, NULL),
('Candlewood Suites', 180, '2019-10-26', 172, NULL),
('Candlewood Suites', 180, '2019-10-27', 263, NULL),
('Candlewood Suites', 180, '2019-10-28', 332, NULL),
('Candlewood Suites', 180, '2019-10-29', 328, NULL),
('Candlewood Suites', 180, '2019-10-30', 334, NULL),
('Candlewood Suites', 180, '2019-10-31', 301, NULL),
('Candlewood Suites', 180, '2019-11-01', 137, NULL),
('Candlewood Suites', 180, '2019-11-02', 343, NULL),
('Candlewood Suites', 180, '2019-11-03', 288, NULL),
('Candlewood Suites', 180, '2019-11-04', 351, NULL),
('Candlewood Suites', 180, '2019-11-05', 243, NULL),
('Candlewood Suites', 180, '2019-11-06', 176, NULL),
('Candlewood Suites', 180, '2019-11-07', 246, NULL),
('Candlewood Suites', 180, '2019-11-08', 189, NULL),
('Candlewood Suites', 180, '2019-11-09', 215, NULL),
('Candlewood Suites', 180, '2019-11-10', 205, NULL),
('Candlewood Suites', 180, '2019-11-11', 374, NULL),
('Candlewood Suites', 180, '2019-11-12', 299, NULL),
('Candlewood Suites', 180, '2019-11-13', 168, NULL),
('Candlewood Suites', 180, '2019-11-14', 273, NULL),
('Candlewood Suites', 180, '2019-11-15', 116, NULL),
('Candlewood Suites', 180, '2019-11-16', 107, NULL),
('Candlewood Suites', 180, '2019-11-17', 300, NULL),
('Candlewood Suites', 180, '2019-11-18', 141, NULL),
('Candlewood Suites', 180, '2019-11-19', 272, NULL),
('Candlewood Suites', 180, '2019-11-20', 257, NULL),
('Candlewood Suites', 180, '2019-11-21', 301, NULL),
('Candlewood Suites', 180, '2019-11-22', 227, NULL),
('Candlewood Suites', 180, '2019-11-23', 186, NULL),
('Candlewood Suites', 180, '2019-11-24', 261, NULL),
('Candlewood Suites', 180, '2019-11-25', 141, NULL),
('Candlewood Suites', 180, '2019-11-26', 116, NULL),
('Candlewood Suites', 180, '2019-11-27', 356, NULL),
('Candlewood Suites', 180, '2019-11-28', 280, NULL),
('Candlewood Suites', 180, '2019-11-29', 155, NULL),
('Candlewood Suites', 180, '2019-11-30', 169, NULL),
('Candlewood Suites', 180, '2019-12-01', 279, NULL),
('Candlewood Suites', 180, '2019-12-02', 147, NULL),
('Candlewood Suites', 180, '2019-12-03', 258, NULL),
('Candlewood Suites', 180, '2019-12-04', 301, NULL),
('Candlewood Suites', 180, '2019-12-05', 255, NULL),
('Candlewood Suites', 180, '2019-12-06', 294, NULL),
('Candlewood Suites', 180, '2019-12-07', 390, NULL),
('Candlewood Suites', 180, '2019-12-08', 331, NULL),
('Candlewood Suites', 180, '2019-12-09', 264, NULL),
('Candlewood Suites', 180, '2019-12-10', 204, NULL),
('Candlewood Suites', 180, '2019-12-11', 314, NULL),
('Candlewood Suites', 180, '2019-12-12', 297, NULL),
('Candlewood Suites', 180, '2019-12-13', 133, NULL),
('Candlewood Suites', 180, '2019-12-14', 190, NULL),
('Candlewood Suites', 180, '2019-12-15', 152, NULL),
('Candlewood Suites', 180, '2019-12-16', 266, NULL),
('Candlewood Suites', 180, '2019-12-17', 331, NULL),
('Candlewood Suites', 180, '2019-12-18', 155, NULL),
('Candlewood Suites', 180, '2019-12-19', 364, NULL),
('Candlewood Suites', 180, '2019-12-20', 245, NULL),
('Candlewood Suites', 180, '2019-12-21', 140, NULL),
('Candlewood Suites', 180, '2019-12-22', 232, NULL),
('Candlewood Suites', 180, '2019-12-23', 113, NULL),
('Candlewood Suites', 180, '2019-12-24', 241, NULL),
('Candlewood Suites', 180, '2019-12-25', 344, NULL),
('Candlewood Suites', 180, '2019-12-26', 215, NULL),
('Candlewood Suites', 180, '2019-12-27', 135, NULL),
('Candlewood Suites', 180, '2019-12-28', 248, NULL),
('Candlewood Suites', 180, '2019-12-29', 289, NULL),
('Candlewood Suites', 180, '2019-12-30', 265, NULL),
('Candlewood Suites', 180, '2019-12-31', 172, NULL),
('Candlewood Suites', 180, '2020-01-01', 205, NULL),
('Candlewood Suites', 180, '2020-01-02', 111, NULL),
('Candlewood Suites', 180, '2020-01-03', 218, NULL),
('Candlewood Suites', 180, '2020-01-04', 264, NULL),
('Candlewood Suites', 180, '2020-01-05', 112, NULL),
('Candlewood Suites', 180, '2020-01-06', 327, NULL),
('Candlewood Suites', 180, '2020-01-07', 141, NULL),
('Candlewood Suites', 180, '2020-01-08', 330, NULL),
('Candlewood Suites', 180, '2020-01-09', 249, NULL),
('Candlewood Suites', 180, '2020-01-10', 184, NULL),
('Candlewood Suites', 180, '2020-01-11', 268, NULL),
('Candlewood Suites', 180, '2020-01-12', 105, NULL),
('Candlewood Suites', 180, '2020-01-13', 315, NULL),
('Candlewood Suites', 180, '2020-01-14', 256, NULL),
('Candlewood Suites', 180, '2020-01-15', 222, NULL),
('Candlewood Suites', 180, '2020-01-16', 305, NULL),
('Candlewood Suites', 180, '2020-01-17', 248, NULL),
('Candlewood Suites', 180, '2020-01-18', 388, NULL),
('Candlewood Suites', 180, '2020-01-19', 393, NULL),
('Candlewood Suites', 180, '2020-01-20', 362, NULL),
('Candlewood Suites', 180, '2020-01-21', 148, NULL),
('Candlewood Suites', 180, '2020-01-22', 273, NULL),
('Candlewood Suites', 180, '2020-01-23', 344, NULL),
('Candlewood Suites', 180, '2020-01-24', 331, NULL),
('Candlewood Suites', 180, '2020-01-25', 134, NULL),
('Candlewood Suites', 180, '2020-01-26', 154, NULL),
('Candlewood Suites', 180, '2020-01-27', 182, NULL),
('Candlewood Suites', 180, '2020-01-28', 177, NULL),
('Candlewood Suites', 180, '2020-01-29', 320, NULL),
('Candlewood Suites', 180, '2020-01-30', 222, NULL),
('Candlewood Suites', 180, '2020-01-31', 256, NULL),
('Candlewood Suites', 180, '2020-02-01', 254, NULL),
('Candlewood Suites', 180, '2020-02-02', 158, NULL),
('Candlewood Suites', 180, '2020-02-03', 216, NULL),
('Candlewood Suites', 180, '2020-02-04', 113, NULL),
('Candlewood Suites', 207, '2019-01-01', 131, NULL),
('Candlewood Suites', 207, '2019-01-02', 142, NULL),
('Candlewood Suites', 207, '2019-01-03', 242, NULL),
('Candlewood Suites', 207, '2019-01-04', 375, NULL),
('Candlewood Suites', 207, '2019-01-05', 334, NULL),
('Candlewood Suites', 207, '2019-01-06', 165, NULL),
('Candlewood Suites', 207, '2019-01-07', 311, NULL),
('Candlewood Suites', 207, '2019-01-08', 107, NULL),
('Candlewood Suites', 207, '2019-01-09', 395, NULL),
('Candlewood Suites', 207, '2019-01-10', 194, NULL),
('Candlewood Suites', 207, '2019-01-11', 131, NULL),
('Candlewood Suites', 207, '2019-01-12', 343, NULL),
('Candlewood Suites', 207, '2019-01-13', 264, NULL),
('Candlewood Suites', 207, '2019-01-14', 248, NULL),
('Candlewood Suites', 207, '2019-01-15', 250, NULL),
('Candlewood Suites', 207, '2019-01-16', 379, NULL),
('Candlewood Suites', 207, '2019-01-17', 135, NULL),
('Candlewood Suites', 207, '2019-01-18', 336, NULL),
('Candlewood Suites', 207, '2019-01-19', 279, NULL),
('Candlewood Suites', 207, '2019-01-20', 131, NULL),
('Candlewood Suites', 207, '2019-01-21', 244, NULL),
('Candlewood Suites', 207, '2019-01-22', 288, NULL),
('Candlewood Suites', 207, '2019-01-23', 145, NULL),
('Candlewood Suites', 207, '2019-01-24', 144, NULL),
('Candlewood Suites', 207, '2019-01-25', 332, NULL),
('Candlewood Suites', 207, '2019-01-26', 333, NULL),
('Candlewood Suites', 207, '2019-01-27', 127, NULL),
('Candlewood Suites', 207, '2019-01-28', 130, NULL),
('Candlewood Suites', 207, '2019-01-29', 321, NULL),
('Candlewood Suites', 207, '2019-01-30', 160, NULL),
('Candlewood Suites', 207, '2019-01-31', 131, NULL),
('Candlewood Suites', 207, '2019-02-01', 186, NULL),
('Candlewood Suites', 207, '2019-02-02', 313, NULL),
('Candlewood Suites', 207, '2019-02-03', 235, NULL),
('Candlewood Suites', 207, '2019-02-04', 193, NULL),
('Candlewood Suites', 207, '2019-02-05', 200, NULL),
('Candlewood Suites', 207, '2019-02-06', 176, NULL),
('Candlewood Suites', 207, '2019-02-07', 154, NULL),
('Candlewood Suites', 207, '2019-02-08', 121, NULL),
('Candlewood Suites', 207, '2019-02-09', 187, NULL),
('Candlewood Suites', 207, '2019-02-10', 163, NULL),
('Candlewood Suites', 207, '2019-02-11', 296, NULL),
('Candlewood Suites', 207, '2019-02-12', 357, NULL),
('Candlewood Suites', 207, '2019-02-13', 238, NULL),
('Candlewood Suites', 207, '2019-02-14', 326, NULL),
('Candlewood Suites', 207, '2019-02-15', 162, NULL),
('Candlewood Suites', 207, '2019-02-16', 278, NULL),
('Candlewood Suites', 207, '2019-02-17', 299, NULL),
('Candlewood Suites', 207, '2019-02-18', 397, NULL),
('Candlewood Suites', 207, '2019-02-19', 153, NULL),
('Candlewood Suites', 207, '2019-02-20', 267, NULL),
('Candlewood Suites', 207, '2019-02-21', 152, NULL),
('Candlewood Suites', 207, '2019-02-22', 272, NULL),
('Candlewood Suites', 207, '2019-02-23', 392, NULL),
('Candlewood Suites', 207, '2019-02-24', 337, NULL),
('Candlewood Suites', 207, '2019-02-25', 249, NULL),
('Candlewood Suites', 207, '2019-02-26', 346, NULL),
('Candlewood Suites', 207, '2019-02-27', 134, NULL),
('Candlewood Suites', 207, '2019-02-28', 137, NULL),
('Candlewood Suites', 207, '2019-03-01', 318, NULL),
('Candlewood Suites', 207, '2019-03-02', 137, NULL),
('Candlewood Suites', 207, '2019-03-03', 359, NULL),
('Candlewood Suites', 207, '2019-03-04', 338, NULL),
('Candlewood Suites', 207, '2019-03-05', 115, NULL),
('Candlewood Suites', 207, '2019-03-06', 338, NULL),
('Candlewood Suites', 207, '2019-03-07', 107, NULL),
('Candlewood Suites', 207, '2019-03-08', 352, NULL),
('Candlewood Suites', 207, '2019-03-09', 138, NULL),
('Candlewood Suites', 207, '2019-03-10', 226, NULL),
('Candlewood Suites', 207, '2019-03-11', 104, NULL),
('Candlewood Suites', 207, '2019-03-12', 279, NULL),
('Candlewood Suites', 207, '2019-03-13', 114, NULL),
('Candlewood Suites', 207, '2019-03-14', 392, NULL),
('Candlewood Suites', 207, '2019-03-15', 135, NULL),
('Candlewood Suites', 207, '2019-03-16', 122, NULL),
('Candlewood Suites', 207, '2019-03-17', 310, NULL),
('Candlewood Suites', 207, '2019-03-18', 145, NULL),
('Candlewood Suites', 207, '2019-03-19', 127, NULL),
('Candlewood Suites', 207, '2019-03-20', 326, NULL),
('Candlewood Suites', 207, '2019-03-21', 241, NULL),
('Candlewood Suites', 207, '2019-03-22', 339, NULL),
('Candlewood Suites', 207, '2019-03-23', 318, NULL),
('Candlewood Suites', 207, '2019-03-24', 152, NULL),
('Candlewood Suites', 207, '2019-03-25', 395, NULL),
('Candlewood Suites', 207, '2019-03-26', 321, NULL),
('Candlewood Suites', 207, '2019-03-27', 329, NULL),
('Candlewood Suites', 207, '2019-03-28', 190, NULL),
('Candlewood Suites', 207, '2019-03-29', 194, NULL),
('Candlewood Suites', 207, '2019-03-30', 215, NULL),
('Candlewood Suites', 207, '2019-03-31', 208, NULL),
('Candlewood Suites', 207, '2019-04-01', 183, NULL),
('Candlewood Suites', 207, '2019-04-02', 112, NULL),
('Candlewood Suites', 207, '2019-04-03', 164, NULL),
('Candlewood Suites', 207, '2019-04-04', 256, NULL),
('Candlewood Suites', 207, '2019-04-05', 278, NULL),
('Candlewood Suites', 207, '2019-04-06', 370, NULL),
('Candlewood Suites', 207, '2019-04-07', 352, NULL),
('Candlewood Suites', 207, '2019-04-08', 192, NULL),
('Candlewood Suites', 207, '2019-04-09', 363, NULL),
('Candlewood Suites', 207, '2019-04-10', 126, NULL),
('Candlewood Suites', 207, '2019-04-11', 184, NULL),
('Candlewood Suites', 207, '2019-04-12', 258, NULL),
('Candlewood Suites', 207, '2019-04-13', 124, NULL),
('Candlewood Suites', 207, '2019-04-14', 372, NULL),
('Candlewood Suites', 207, '2019-04-15', 181, NULL),
('Candlewood Suites', 207, '2019-04-16', 148, NULL),
('Candlewood Suites', 207, '2019-04-17', 265, NULL),
('Candlewood Suites', 207, '2019-04-18', 146, NULL),
('Candlewood Suites', 207, '2019-04-19', 237, NULL),
('Candlewood Suites', 207, '2019-04-20', 140, NULL),
('Candlewood Suites', 207, '2019-04-21', 304, NULL),
('Candlewood Suites', 207, '2019-04-22', 325, NULL),
('Candlewood Suites', 207, '2019-04-23', 304, NULL),
('Candlewood Suites', 207, '2019-04-24', 152, NULL),
('Candlewood Suites', 207, '2019-04-25', 312, NULL),
('Candlewood Suites', 207, '2019-04-26', 248, NULL),
('Candlewood Suites', 207, '2019-04-27', 134, NULL),
('Candlewood Suites', 207, '2019-04-28', 182, NULL),
('Candlewood Suites', 207, '2019-04-29', 124, NULL),
('Candlewood Suites', 207, '2019-04-30', 274, NULL),
('Candlewood Suites', 207, '2019-05-01', 343, NULL),
('Candlewood Suites', 207, '2019-05-02', 196, NULL),
('Candlewood Suites', 207, '2019-05-03', 349, NULL),
('Candlewood Suites', 207, '2019-05-04', 320, NULL),
('Candlewood Suites', 207, '2019-05-05', 362, NULL),
('Candlewood Suites', 207, '2019-05-06', 330, NULL),
('Candlewood Suites', 207, '2019-05-07', 383, NULL),
('Candlewood Suites', 207, '2019-05-08', 271, NULL),
('Candlewood Suites', 207, '2019-05-09', 393, NULL),
('Candlewood Suites', 207, '2019-05-10', 200, NULL),
('Candlewood Suites', 207, '2019-05-11', 215, NULL),
('Candlewood Suites', 207, '2019-05-12', 361, NULL),
('Candlewood Suites', 207, '2019-05-13', 397, NULL),
('Candlewood Suites', 207, '2019-05-14', 278, NULL),
('Candlewood Suites', 207, '2019-05-15', 240, NULL),
('Candlewood Suites', 207, '2019-05-16', 262, NULL),
('Candlewood Suites', 207, '2019-05-17', 146, NULL),
('Candlewood Suites', 207, '2019-05-18', 300, NULL),
('Candlewood Suites', 207, '2019-05-19', 106, NULL),
('Candlewood Suites', 207, '2019-05-20', 293, NULL),
('Candlewood Suites', 207, '2019-05-21', 175, NULL),
('Candlewood Suites', 207, '2019-05-22', 222, NULL),
('Candlewood Suites', 207, '2019-05-23', 394, NULL),
('Candlewood Suites', 207, '2019-05-24', 222, NULL),
('Candlewood Suites', 207, '2019-05-25', 107, NULL),
('Candlewood Suites', 207, '2019-05-26', 368, NULL),
('Candlewood Suites', 207, '2019-05-27', 128, NULL),
('Candlewood Suites', 207, '2019-05-28', 371, NULL),
('Candlewood Suites', 207, '2019-05-29', 353, NULL),
('Candlewood Suites', 207, '2019-05-30', 292, NULL),
('Candlewood Suites', 207, '2019-05-31', 367, NULL),
('Candlewood Suites', 207, '2019-06-01', 141, NULL),
('Candlewood Suites', 207, '2019-06-02', 111, NULL),
('Candlewood Suites', 207, '2019-06-03', 392, NULL),
('Candlewood Suites', 207, '2019-06-04', 194, NULL),
('Candlewood Suites', 207, '2019-06-05', 321, NULL),
('Candlewood Suites', 207, '2019-06-06', 178, NULL),
('Candlewood Suites', 207, '2019-06-07', 191, NULL),
('Candlewood Suites', 207, '2019-06-08', 262, NULL),
('Candlewood Suites', 207, '2019-06-09', 181, NULL),
('Candlewood Suites', 207, '2019-06-10', 173, NULL),
('Candlewood Suites', 207, '2019-06-11', 107, NULL),
('Candlewood Suites', 207, '2019-06-12', 329, NULL),
('Candlewood Suites', 207, '2019-06-13', 112, NULL),
('Candlewood Suites', 207, '2019-06-14', 299, NULL),
('Candlewood Suites', 207, '2019-06-15', 367, NULL),
('Candlewood Suites', 207, '2019-06-16', 296, NULL),
('Candlewood Suites', 207, '2019-06-17', 186, NULL),
('Candlewood Suites', 207, '2019-06-18', 325, NULL),
('Candlewood Suites', 207, '2019-06-19', 314, NULL),
('Candlewood Suites', 207, '2019-06-20', 132, NULL),
('Candlewood Suites', 207, '2019-06-21', 304, NULL),
('Candlewood Suites', 207, '2019-06-22', 285, NULL),
('Candlewood Suites', 207, '2019-06-23', 300, NULL),
('Candlewood Suites', 207, '2019-06-24', 208, NULL),
('Candlewood Suites', 207, '2019-06-25', 106, NULL),
('Candlewood Suites', 207, '2019-06-26', 131, NULL),
('Candlewood Suites', 207, '2019-06-27', 340, NULL),
('Candlewood Suites', 207, '2019-06-28', 298, NULL),
('Candlewood Suites', 207, '2019-06-29', 278, NULL),
('Candlewood Suites', 207, '2019-06-30', 176, NULL),
('Candlewood Suites', 207, '2019-07-01', 239, NULL),
('Candlewood Suites', 207, '2019-07-02', 248, NULL),
('Candlewood Suites', 207, '2019-07-03', 386, NULL),
('Candlewood Suites', 207, '2019-07-04', 358, NULL),
('Candlewood Suites', 207, '2019-07-05', 260, NULL),
('Candlewood Suites', 207, '2019-07-06', 284, NULL),
('Candlewood Suites', 207, '2019-07-07', 134, NULL),
('Candlewood Suites', 207, '2019-07-08', 258, NULL),
('Candlewood Suites', 207, '2019-07-09', 138, NULL),
('Candlewood Suites', 207, '2019-07-10', 189, NULL),
('Candlewood Suites', 207, '2019-07-11', 141, NULL),
('Candlewood Suites', 207, '2019-07-12', 254, NULL),
('Candlewood Suites', 207, '2019-07-13', 114, NULL),
('Candlewood Suites', 207, '2019-07-14', 215, NULL),
('Candlewood Suites', 207, '2019-07-15', 137, NULL),
('Candlewood Suites', 207, '2019-07-16', 262, NULL),
('Candlewood Suites', 207, '2019-07-17', 199, NULL),
('Candlewood Suites', 207, '2019-07-18', 130, NULL),
('Candlewood Suites', 207, '2019-07-19', 108, NULL),
('Candlewood Suites', 207, '2019-07-20', 135, NULL),
('Candlewood Suites', 207, '2019-07-21', 385, NULL),
('Candlewood Suites', 207, '2019-07-22', 355, NULL),
('Candlewood Suites', 207, '2019-07-23', 243, NULL),
('Candlewood Suites', 207, '2019-07-24', 226, NULL),
('Candlewood Suites', 207, '2019-07-25', 314, NULL),
('Candlewood Suites', 207, '2019-07-26', 331, NULL),
('Candlewood Suites', 207, '2019-07-27', 168, NULL),
('Candlewood Suites', 207, '2019-07-28', 197, NULL),
('Candlewood Suites', 207, '2019-07-29', 108, NULL),
('Candlewood Suites', 207, '2019-07-30', 267, NULL),
('Candlewood Suites', 207, '2019-07-31', 362, NULL),
('Candlewood Suites', 207, '2019-08-01', 283, NULL),
('Candlewood Suites', 207, '2019-08-02', 110, NULL),
('Candlewood Suites', 207, '2019-08-03', 331, NULL),
('Candlewood Suites', 207, '2019-08-04', 111, NULL),
('Candlewood Suites', 207, '2019-08-05', 333, NULL),
('Candlewood Suites', 207, '2019-08-06', 362, NULL),
('Candlewood Suites', 207, '2019-08-07', 239, NULL),
('Candlewood Suites', 207, '2019-08-08', 131, NULL),
('Candlewood Suites', 207, '2019-08-09', 181, NULL),
('Candlewood Suites', 207, '2019-08-10', 383, NULL),
('Candlewood Suites', 207, '2019-08-11', 341, NULL),
('Candlewood Suites', 207, '2019-08-12', 336, NULL),
('Candlewood Suites', 207, '2019-08-13', 214, NULL),
('Candlewood Suites', 207, '2019-08-14', 222, NULL),
('Candlewood Suites', 207, '2019-08-15', 242, NULL),
('Candlewood Suites', 207, '2019-08-16', 315, NULL),
('Candlewood Suites', 207, '2019-08-17', 112, NULL),
('Candlewood Suites', 207, '2019-08-18', 180, NULL),
('Candlewood Suites', 207, '2019-08-19', 188, NULL),
('Candlewood Suites', 207, '2019-08-20', 179, NULL),
('Candlewood Suites', 207, '2019-08-21', 230, NULL),
('Candlewood Suites', 207, '2019-08-22', 367, NULL),
('Candlewood Suites', 207, '2019-08-23', 324, NULL),
('Candlewood Suites', 207, '2019-08-24', 242, NULL),
('Candlewood Suites', 207, '2019-08-25', 370, NULL),
('Candlewood Suites', 207, '2019-08-26', 244, NULL),
('Candlewood Suites', 207, '2019-08-27', 286, NULL),
('Candlewood Suites', 207, '2019-08-28', 309, NULL),
('Candlewood Suites', 207, '2019-08-29', 134, NULL),
('Candlewood Suites', 207, '2019-08-30', 299, NULL),
('Candlewood Suites', 207, '2019-08-31', 337, NULL),
('Candlewood Suites', 207, '2019-09-01', 105, NULL),
('Candlewood Suites', 207, '2019-09-02', 342, NULL),
('Candlewood Suites', 207, '2019-09-03', 241, NULL),
('Candlewood Suites', 207, '2019-09-04', 309, NULL),
('Candlewood Suites', 207, '2019-09-05', 174, NULL),
('Candlewood Suites', 207, '2019-09-06', 202, NULL),
('Candlewood Suites', 207, '2019-09-07', 301, NULL),
('Candlewood Suites', 207, '2019-09-08', 362, NULL),
('Candlewood Suites', 207, '2019-09-09', 147, NULL),
('Candlewood Suites', 207, '2019-09-10', 254, NULL),
('Candlewood Suites', 207, '2019-09-11', 351, NULL),
('Candlewood Suites', 207, '2019-09-12', 253, NULL),
('Candlewood Suites', 207, '2019-09-13', 100, NULL),
('Candlewood Suites', 207, '2019-09-14', 273, NULL),
('Candlewood Suites', 207, '2019-09-15', 390, NULL),
('Candlewood Suites', 207, '2019-09-16', 336, NULL),
('Candlewood Suites', 207, '2019-09-17', 396, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 207, '2019-09-18', 340, NULL),
('Candlewood Suites', 207, '2019-09-19', 337, NULL),
('Candlewood Suites', 207, '2019-09-20', 133, NULL),
('Candlewood Suites', 207, '2019-09-21', 277, NULL),
('Candlewood Suites', 207, '2019-09-22', 105, NULL),
('Candlewood Suites', 207, '2019-09-23', 197, NULL),
('Candlewood Suites', 207, '2019-09-24', 303, NULL),
('Candlewood Suites', 207, '2019-09-25', 133, NULL),
('Candlewood Suites', 207, '2019-09-26', 383, NULL),
('Candlewood Suites', 207, '2019-09-27', 102, NULL),
('Candlewood Suites', 207, '2019-09-28', 192, NULL),
('Candlewood Suites', 207, '2019-09-29', 217, NULL),
('Candlewood Suites', 207, '2019-09-30', 113, NULL),
('Candlewood Suites', 207, '2019-10-01', 336, NULL),
('Candlewood Suites', 207, '2019-10-02', 357, NULL),
('Candlewood Suites', 207, '2019-10-03', 208, NULL),
('Candlewood Suites', 207, '2019-10-04', 383, NULL),
('Candlewood Suites', 207, '2019-10-05', 333, NULL),
('Candlewood Suites', 207, '2019-10-06', 356, NULL),
('Candlewood Suites', 207, '2019-10-07', 253, NULL),
('Candlewood Suites', 207, '2019-10-08', 279, NULL),
('Candlewood Suites', 207, '2019-10-09', 330, NULL),
('Candlewood Suites', 207, '2019-10-10', 379, NULL),
('Candlewood Suites', 207, '2019-10-11', 183, NULL),
('Candlewood Suites', 207, '2019-10-12', 288, NULL),
('Candlewood Suites', 207, '2019-10-13', 399, NULL),
('Candlewood Suites', 207, '2019-10-14', 105, NULL),
('Candlewood Suites', 207, '2019-10-15', 362, NULL),
('Candlewood Suites', 207, '2019-10-16', 278, NULL),
('Candlewood Suites', 207, '2019-10-17', 240, NULL),
('Candlewood Suites', 207, '2019-10-18', 262, NULL),
('Candlewood Suites', 207, '2019-10-19', 254, NULL),
('Candlewood Suites', 207, '2019-10-20', 360, NULL),
('Candlewood Suites', 207, '2019-10-21', 204, NULL),
('Candlewood Suites', 207, '2019-10-22', 136, NULL),
('Candlewood Suites', 207, '2019-10-23', 244, NULL),
('Candlewood Suites', 207, '2019-10-24', 187, NULL),
('Candlewood Suites', 207, '2019-10-25', 234, NULL),
('Candlewood Suites', 207, '2019-10-26', 209, NULL),
('Candlewood Suites', 207, '2019-10-27', 345, NULL),
('Candlewood Suites', 207, '2019-10-28', 367, NULL),
('Candlewood Suites', 207, '2019-10-29', 236, NULL),
('Candlewood Suites', 207, '2019-10-30', 275, NULL),
('Candlewood Suites', 207, '2019-10-31', 174, NULL),
('Candlewood Suites', 207, '2019-11-01', 218, NULL),
('Candlewood Suites', 207, '2019-11-02', 334, NULL),
('Candlewood Suites', 207, '2019-11-03', 216, NULL),
('Candlewood Suites', 207, '2019-11-04', 328, NULL),
('Candlewood Suites', 207, '2019-11-05', 379, NULL),
('Candlewood Suites', 207, '2019-11-06', 311, NULL),
('Candlewood Suites', 207, '2019-11-07', 188, NULL),
('Candlewood Suites', 207, '2019-11-08', 216, NULL),
('Candlewood Suites', 207, '2019-11-09', 119, NULL),
('Candlewood Suites', 207, '2019-11-10', 398, NULL),
('Candlewood Suites', 207, '2019-11-11', 203, NULL),
('Candlewood Suites', 207, '2019-11-12', 366, NULL),
('Candlewood Suites', 207, '2019-11-13', 237, NULL),
('Candlewood Suites', 207, '2019-11-14', 184, NULL),
('Candlewood Suites', 207, '2019-11-15', 203, NULL),
('Candlewood Suites', 207, '2019-11-16', 143, NULL),
('Candlewood Suites', 207, '2019-11-17', 393, NULL),
('Candlewood Suites', 207, '2019-11-18', 175, NULL),
('Candlewood Suites', 207, '2019-11-19', 201, NULL),
('Candlewood Suites', 207, '2019-11-20', 101, NULL),
('Candlewood Suites', 207, '2019-11-21', 150, NULL),
('Candlewood Suites', 207, '2019-11-22', 271, NULL),
('Candlewood Suites', 207, '2019-11-23', 105, NULL),
('Candlewood Suites', 207, '2019-11-24', 113, NULL),
('Candlewood Suites', 207, '2019-11-25', 308, NULL),
('Candlewood Suites', 207, '2019-11-26', 390, NULL),
('Candlewood Suites', 207, '2019-11-27', 131, NULL),
('Candlewood Suites', 207, '2019-11-28', 183, NULL),
('Candlewood Suites', 207, '2019-11-29', 120, NULL),
('Candlewood Suites', 207, '2019-11-30', 333, NULL),
('Candlewood Suites', 207, '2019-12-01', 177, NULL),
('Candlewood Suites', 207, '2019-12-02', 301, NULL),
('Candlewood Suites', 207, '2019-12-03', 180, NULL),
('Candlewood Suites', 207, '2019-12-04', 106, NULL),
('Candlewood Suites', 207, '2019-12-05', 191, NULL),
('Candlewood Suites', 207, '2019-12-06', 321, NULL),
('Candlewood Suites', 207, '2019-12-07', 390, NULL),
('Candlewood Suites', 207, '2019-12-08', 279, NULL),
('Candlewood Suites', 207, '2019-12-09', 239, NULL),
('Candlewood Suites', 207, '2019-12-10', 316, NULL),
('Candlewood Suites', 207, '2019-12-11', 337, NULL),
('Candlewood Suites', 207, '2019-12-12', 120, NULL),
('Candlewood Suites', 207, '2019-12-13', 282, NULL),
('Candlewood Suites', 207, '2019-12-14', 364, NULL),
('Candlewood Suites', 207, '2019-12-15', 169, NULL),
('Candlewood Suites', 207, '2019-12-16', 297, NULL),
('Candlewood Suites', 207, '2019-12-17', 219, NULL),
('Candlewood Suites', 207, '2019-12-18', 243, NULL),
('Candlewood Suites', 207, '2019-12-19', 101, NULL),
('Candlewood Suites', 207, '2019-12-20', 225, NULL),
('Candlewood Suites', 207, '2019-12-21', 267, NULL),
('Candlewood Suites', 207, '2019-12-22', 173, NULL),
('Candlewood Suites', 207, '2019-12-23', 137, NULL),
('Candlewood Suites', 207, '2019-12-24', 350, NULL),
('Candlewood Suites', 207, '2019-12-25', 276, NULL),
('Candlewood Suites', 207, '2019-12-26', 146, NULL),
('Candlewood Suites', 207, '2019-12-27', 232, NULL),
('Candlewood Suites', 207, '2019-12-28', 250, NULL),
('Candlewood Suites', 207, '2019-12-29', 154, NULL),
('Candlewood Suites', 207, '2019-12-30', 285, NULL),
('Candlewood Suites', 207, '2019-12-31', 252, NULL),
('Candlewood Suites', 207, '2020-01-01', 230, NULL),
('Candlewood Suites', 207, '2020-01-02', 315, NULL),
('Candlewood Suites', 207, '2020-01-03', 106, NULL),
('Candlewood Suites', 207, '2020-01-04', 109, NULL),
('Candlewood Suites', 207, '2020-01-05', 225, NULL),
('Candlewood Suites', 207, '2020-01-06', 249, NULL),
('Candlewood Suites', 207, '2020-01-07', 367, NULL),
('Candlewood Suites', 207, '2020-01-08', 214, NULL),
('Candlewood Suites', 207, '2020-01-09', 220, NULL),
('Candlewood Suites', 207, '2020-01-10', 254, NULL),
('Candlewood Suites', 207, '2020-01-11', 174, NULL),
('Candlewood Suites', 207, '2020-01-12', 292, NULL),
('Candlewood Suites', 207, '2020-01-13', 367, NULL),
('Candlewood Suites', 207, '2020-01-14', 178, NULL),
('Candlewood Suites', 207, '2020-01-15', 284, NULL),
('Candlewood Suites', 207, '2020-01-16', 332, NULL),
('Candlewood Suites', 207, '2020-01-17', 171, NULL),
('Candlewood Suites', 207, '2020-01-18', 305, NULL),
('Candlewood Suites', 207, '2020-01-19', 353, NULL),
('Candlewood Suites', 207, '2020-01-20', 251, NULL),
('Candlewood Suites', 207, '2020-01-21', 311, NULL),
('Candlewood Suites', 207, '2020-01-22', 197, NULL),
('Candlewood Suites', 207, '2020-01-23', 256, NULL),
('Candlewood Suites', 207, '2020-01-24', 202, NULL),
('Candlewood Suites', 207, '2020-01-25', 107, NULL),
('Candlewood Suites', 207, '2020-01-26', 378, NULL),
('Candlewood Suites', 207, '2020-01-27', 140, NULL),
('Candlewood Suites', 207, '2020-01-28', 217, NULL),
('Candlewood Suites', 207, '2020-01-29', 329, NULL),
('Candlewood Suites', 207, '2020-01-30', 235, NULL),
('Candlewood Suites', 207, '2020-01-31', 101, NULL),
('Candlewood Suites', 207, '2020-02-01', 306, NULL),
('Candlewood Suites', 207, '2020-02-02', 290, NULL),
('Candlewood Suites', 207, '2020-02-03', 102, NULL),
('Candlewood Suites', 207, '2020-02-04', 215, NULL),
('Candlewood Suites', 221, '2019-01-01', 131, NULL),
('Candlewood Suites', 221, '2019-01-02', 355, NULL),
('Candlewood Suites', 221, '2019-01-03', 199, NULL),
('Candlewood Suites', 221, '2019-01-04', 300, NULL),
('Candlewood Suites', 221, '2019-01-05', 105, NULL),
('Candlewood Suites', 221, '2019-01-06', 346, NULL),
('Candlewood Suites', 221, '2019-01-07', 395, NULL),
('Candlewood Suites', 221, '2019-01-08', 288, NULL),
('Candlewood Suites', 221, '2019-01-09', 385, NULL),
('Candlewood Suites', 221, '2019-01-10', 300, NULL),
('Candlewood Suites', 221, '2019-01-11', 114, NULL),
('Candlewood Suites', 221, '2019-01-12', 136, NULL),
('Candlewood Suites', 221, '2019-01-13', 163, NULL),
('Candlewood Suites', 221, '2019-01-14', 161, NULL),
('Candlewood Suites', 221, '2019-01-15', 391, NULL),
('Candlewood Suites', 221, '2019-01-16', 373, NULL),
('Candlewood Suites', 221, '2019-01-17', 184, NULL),
('Candlewood Suites', 221, '2019-01-18', 191, NULL),
('Candlewood Suites', 221, '2019-01-19', 231, NULL),
('Candlewood Suites', 221, '2019-01-20', 343, NULL),
('Candlewood Suites', 221, '2019-01-21', 301, NULL),
('Candlewood Suites', 221, '2019-01-22', 160, NULL),
('Candlewood Suites', 221, '2019-01-23', 340, NULL),
('Candlewood Suites', 221, '2019-01-24', 250, NULL),
('Candlewood Suites', 221, '2019-01-25', 157, NULL),
('Candlewood Suites', 221, '2019-01-26', 102, NULL),
('Candlewood Suites', 221, '2019-01-27', 169, NULL),
('Candlewood Suites', 221, '2019-01-28', 384, NULL),
('Candlewood Suites', 221, '2019-01-29', 224, NULL),
('Candlewood Suites', 221, '2019-01-30', 252, NULL),
('Candlewood Suites', 221, '2019-01-31', 366, NULL),
('Candlewood Suites', 221, '2019-02-01', 257, NULL),
('Candlewood Suites', 221, '2019-02-02', 273, NULL),
('Candlewood Suites', 221, '2019-02-03', 124, NULL),
('Candlewood Suites', 221, '2019-02-04', 197, NULL),
('Candlewood Suites', 221, '2019-02-05', 269, NULL),
('Candlewood Suites', 221, '2019-02-06', 125, NULL),
('Candlewood Suites', 221, '2019-02-07', 140, NULL),
('Candlewood Suites', 221, '2019-02-08', 335, NULL),
('Candlewood Suites', 221, '2019-02-09', 395, NULL),
('Candlewood Suites', 221, '2019-02-10', 277, NULL),
('Candlewood Suites', 221, '2019-02-11', 230, NULL),
('Candlewood Suites', 221, '2019-02-12', 114, NULL),
('Candlewood Suites', 221, '2019-02-13', 193, NULL),
('Candlewood Suites', 221, '2019-02-14', 124, NULL),
('Candlewood Suites', 221, '2019-02-15', 384, NULL),
('Candlewood Suites', 221, '2019-02-16', 293, NULL),
('Candlewood Suites', 221, '2019-02-17', 346, NULL),
('Candlewood Suites', 221, '2019-02-18', 113, NULL),
('Candlewood Suites', 221, '2019-02-19', 106, NULL),
('Candlewood Suites', 221, '2019-02-20', 130, NULL),
('Candlewood Suites', 221, '2019-02-21', 321, NULL),
('Candlewood Suites', 221, '2019-02-22', 384, NULL),
('Candlewood Suites', 221, '2019-02-23', 202, NULL),
('Candlewood Suites', 221, '2019-02-24', 239, NULL),
('Candlewood Suites', 221, '2019-02-25', 175, NULL),
('Candlewood Suites', 221, '2019-02-26', 331, NULL),
('Candlewood Suites', 221, '2019-02-27', 186, NULL),
('Candlewood Suites', 221, '2019-02-28', 171, NULL),
('Candlewood Suites', 221, '2019-03-01', 120, NULL),
('Candlewood Suites', 221, '2019-03-02', 342, NULL),
('Candlewood Suites', 221, '2019-03-03', 309, NULL),
('Candlewood Suites', 221, '2019-03-04', 317, NULL),
('Candlewood Suites', 221, '2019-03-05', 238, NULL),
('Candlewood Suites', 221, '2019-03-06', 249, NULL),
('Candlewood Suites', 221, '2019-03-07', 167, NULL),
('Candlewood Suites', 221, '2019-03-08', 192, NULL),
('Candlewood Suites', 221, '2019-03-09', 276, NULL),
('Candlewood Suites', 221, '2019-03-10', 306, NULL),
('Candlewood Suites', 221, '2019-03-11', 103, NULL),
('Candlewood Suites', 221, '2019-03-12', 270, NULL),
('Candlewood Suites', 221, '2019-03-13', 163, NULL),
('Candlewood Suites', 221, '2019-03-14', 228, NULL),
('Candlewood Suites', 221, '2019-03-15', 365, NULL),
('Candlewood Suites', 221, '2019-03-16', 313, NULL),
('Candlewood Suites', 221, '2019-03-17', 295, NULL),
('Candlewood Suites', 221, '2019-03-18', 371, NULL),
('Candlewood Suites', 221, '2019-03-19', 359, NULL),
('Candlewood Suites', 221, '2019-03-20', 303, NULL),
('Candlewood Suites', 221, '2019-03-21', 151, NULL),
('Candlewood Suites', 221, '2019-03-22', 252, NULL),
('Candlewood Suites', 221, '2019-03-23', 234, NULL),
('Candlewood Suites', 221, '2019-03-24', 216, NULL),
('Candlewood Suites', 221, '2019-03-25', 380, NULL),
('Candlewood Suites', 221, '2019-03-26', 237, NULL),
('Candlewood Suites', 221, '2019-03-27', 298, NULL),
('Candlewood Suites', 221, '2019-03-28', 277, NULL),
('Candlewood Suites', 221, '2019-03-29', 115, NULL),
('Candlewood Suites', 221, '2019-03-30', 315, NULL),
('Candlewood Suites', 221, '2019-03-31', 222, NULL),
('Candlewood Suites', 221, '2019-04-01', 362, NULL),
('Candlewood Suites', 221, '2019-04-02', 269, NULL),
('Candlewood Suites', 221, '2019-04-03', 136, NULL),
('Candlewood Suites', 221, '2019-04-04', 236, NULL),
('Candlewood Suites', 221, '2019-04-05', 336, NULL),
('Candlewood Suites', 221, '2019-04-06', 120, NULL),
('Candlewood Suites', 221, '2019-04-07', 267, NULL),
('Candlewood Suites', 221, '2019-04-08', 311, NULL),
('Candlewood Suites', 221, '2019-04-09', 126, NULL),
('Candlewood Suites', 221, '2019-04-10', 313, NULL),
('Candlewood Suites', 221, '2019-04-11', 122, NULL),
('Candlewood Suites', 221, '2019-04-12', 248, NULL),
('Candlewood Suites', 221, '2019-04-13', 110, NULL),
('Candlewood Suites', 221, '2019-04-14', 353, NULL),
('Candlewood Suites', 221, '2019-04-15', 229, NULL),
('Candlewood Suites', 221, '2019-04-16', 226, NULL),
('Candlewood Suites', 221, '2019-04-17', 256, NULL),
('Candlewood Suites', 221, '2019-04-18', 317, NULL),
('Candlewood Suites', 221, '2019-04-19', 350, NULL),
('Candlewood Suites', 221, '2019-04-20', 316, NULL),
('Candlewood Suites', 221, '2019-04-21', 352, NULL),
('Candlewood Suites', 221, '2019-04-22', 346, NULL),
('Candlewood Suites', 221, '2019-04-23', 185, NULL),
('Candlewood Suites', 221, '2019-04-24', 372, NULL),
('Candlewood Suites', 221, '2019-04-25', 232, NULL),
('Candlewood Suites', 221, '2019-04-26', 362, NULL),
('Candlewood Suites', 221, '2019-04-27', 144, NULL),
('Candlewood Suites', 221, '2019-04-28', 138, NULL),
('Candlewood Suites', 221, '2019-04-29', 254, NULL),
('Candlewood Suites', 221, '2019-04-30', 110, NULL),
('Candlewood Suites', 221, '2019-05-01', 121, NULL),
('Candlewood Suites', 221, '2019-05-02', 369, NULL),
('Candlewood Suites', 221, '2019-05-03', 372, NULL),
('Candlewood Suites', 221, '2019-05-04', 238, NULL),
('Candlewood Suites', 221, '2019-05-05', 122, NULL),
('Candlewood Suites', 221, '2019-05-06', 348, NULL),
('Candlewood Suites', 221, '2019-05-07', 256, NULL),
('Candlewood Suites', 221, '2019-05-08', 113, NULL),
('Candlewood Suites', 221, '2019-05-09', 280, NULL),
('Candlewood Suites', 221, '2019-05-10', 106, NULL),
('Candlewood Suites', 221, '2019-05-11', 334, NULL),
('Candlewood Suites', 221, '2019-05-12', 315, NULL),
('Candlewood Suites', 221, '2019-05-13', 221, NULL),
('Candlewood Suites', 221, '2019-05-14', 256, NULL),
('Candlewood Suites', 221, '2019-05-15', 108, NULL),
('Candlewood Suites', 221, '2019-05-16', 212, NULL),
('Candlewood Suites', 221, '2019-05-17', 211, NULL),
('Candlewood Suites', 221, '2019-05-18', 356, NULL),
('Candlewood Suites', 221, '2019-05-19', 357, NULL),
('Candlewood Suites', 221, '2019-05-20', 150, NULL),
('Candlewood Suites', 221, '2019-05-21', 123, NULL),
('Candlewood Suites', 221, '2019-05-22', 298, NULL),
('Candlewood Suites', 221, '2019-05-23', 325, NULL),
('Candlewood Suites', 221, '2019-05-24', 104, NULL),
('Candlewood Suites', 221, '2019-05-25', 137, NULL),
('Candlewood Suites', 221, '2019-05-26', 149, NULL),
('Candlewood Suites', 221, '2019-05-27', 223, NULL),
('Candlewood Suites', 221, '2019-05-28', 251, NULL),
('Candlewood Suites', 221, '2019-05-29', 201, NULL),
('Candlewood Suites', 221, '2019-05-30', 208, NULL),
('Candlewood Suites', 221, '2019-05-31', 369, NULL),
('Candlewood Suites', 221, '2019-06-01', 230, NULL),
('Candlewood Suites', 221, '2019-06-02', 100, NULL),
('Candlewood Suites', 221, '2019-06-03', 319, NULL),
('Candlewood Suites', 221, '2019-06-04', 237, NULL),
('Candlewood Suites', 221, '2019-06-05', 254, NULL),
('Candlewood Suites', 221, '2019-06-06', 299, NULL),
('Candlewood Suites', 221, '2019-06-07', 323, NULL),
('Candlewood Suites', 221, '2019-06-08', 297, NULL),
('Candlewood Suites', 221, '2019-06-09', 249, NULL),
('Candlewood Suites', 221, '2019-06-10', 234, NULL),
('Candlewood Suites', 221, '2019-06-11', 248, NULL),
('Candlewood Suites', 221, '2019-06-12', 133, NULL),
('Candlewood Suites', 221, '2019-06-13', 142, NULL),
('Candlewood Suites', 221, '2019-06-14', 185, NULL),
('Candlewood Suites', 221, '2019-06-15', 375, NULL),
('Candlewood Suites', 221, '2019-06-16', 235, NULL),
('Candlewood Suites', 221, '2019-06-17', 158, NULL),
('Candlewood Suites', 221, '2019-06-18', 304, NULL),
('Candlewood Suites', 221, '2019-06-19', 368, NULL),
('Candlewood Suites', 221, '2019-06-20', 190, NULL),
('Candlewood Suites', 221, '2019-06-21', 161, NULL),
('Candlewood Suites', 221, '2019-06-22', 319, NULL),
('Candlewood Suites', 221, '2019-06-23', 284, NULL),
('Candlewood Suites', 221, '2019-06-24', 291, NULL),
('Candlewood Suites', 221, '2019-06-25', 211, NULL),
('Candlewood Suites', 221, '2019-06-26', 101, NULL),
('Candlewood Suites', 221, '2019-06-27', 130, NULL),
('Candlewood Suites', 221, '2019-06-28', 298, NULL),
('Candlewood Suites', 221, '2019-06-29', 293, NULL),
('Candlewood Suites', 221, '2019-06-30', 149, NULL),
('Candlewood Suites', 221, '2019-07-01', 227, NULL),
('Candlewood Suites', 221, '2019-07-02', 109, NULL),
('Candlewood Suites', 221, '2019-07-03', 290, NULL),
('Candlewood Suites', 221, '2019-07-04', 386, NULL),
('Candlewood Suites', 221, '2019-07-05', 313, NULL),
('Candlewood Suites', 221, '2019-07-06', 343, NULL),
('Candlewood Suites', 221, '2019-07-07', 219, NULL),
('Candlewood Suites', 221, '2019-07-08', 376, NULL),
('Candlewood Suites', 221, '2019-07-09', 314, NULL),
('Candlewood Suites', 221, '2019-07-10', 258, NULL),
('Candlewood Suites', 221, '2019-07-11', 371, NULL),
('Candlewood Suites', 221, '2019-07-12', 358, NULL),
('Candlewood Suites', 221, '2019-07-13', 231, NULL),
('Candlewood Suites', 221, '2019-07-14', 142, NULL),
('Candlewood Suites', 221, '2019-07-15', 275, NULL),
('Candlewood Suites', 221, '2019-07-16', 372, NULL),
('Candlewood Suites', 221, '2019-07-17', 221, NULL),
('Candlewood Suites', 221, '2019-07-18', 133, NULL),
('Candlewood Suites', 221, '2019-07-19', 254, NULL),
('Candlewood Suites', 221, '2019-07-20', 397, NULL),
('Candlewood Suites', 221, '2019-07-21', 357, NULL),
('Candlewood Suites', 221, '2019-07-22', 237, NULL),
('Candlewood Suites', 221, '2019-07-23', 290, NULL),
('Candlewood Suites', 221, '2019-07-24', 200, NULL),
('Candlewood Suites', 221, '2019-07-25', 265, NULL),
('Candlewood Suites', 221, '2019-07-26', 168, NULL),
('Candlewood Suites', 221, '2019-07-27', 187, NULL),
('Candlewood Suites', 221, '2019-07-28', 346, NULL),
('Candlewood Suites', 221, '2019-07-29', 329, NULL),
('Candlewood Suites', 221, '2019-07-30', 356, NULL),
('Candlewood Suites', 221, '2019-07-31', 149, NULL),
('Candlewood Suites', 221, '2019-08-01', 374, NULL),
('Candlewood Suites', 221, '2019-08-02', 219, NULL),
('Candlewood Suites', 221, '2019-08-03', 276, NULL),
('Candlewood Suites', 221, '2019-08-04', 289, NULL),
('Candlewood Suites', 221, '2019-08-05', 393, NULL),
('Candlewood Suites', 221, '2019-08-06', 330, NULL),
('Candlewood Suites', 221, '2019-08-07', 194, NULL),
('Candlewood Suites', 221, '2019-08-08', 138, NULL),
('Candlewood Suites', 221, '2019-08-09', 295, NULL),
('Candlewood Suites', 221, '2019-08-10', 125, NULL),
('Candlewood Suites', 221, '2019-08-11', 149, NULL),
('Candlewood Suites', 221, '2019-08-12', 216, NULL),
('Candlewood Suites', 221, '2019-08-13', 109, NULL),
('Candlewood Suites', 221, '2019-08-14', 111, NULL),
('Candlewood Suites', 221, '2019-08-15', 101, NULL),
('Candlewood Suites', 221, '2019-08-16', 263, NULL),
('Candlewood Suites', 221, '2019-08-17', 300, NULL),
('Candlewood Suites', 221, '2019-08-18', 280, NULL),
('Candlewood Suites', 221, '2019-08-19', 379, NULL),
('Candlewood Suites', 221, '2019-08-20', 156, NULL),
('Candlewood Suites', 221, '2019-08-21', 237, NULL),
('Candlewood Suites', 221, '2019-08-22', 269, NULL),
('Candlewood Suites', 221, '2019-08-23', 137, NULL),
('Candlewood Suites', 221, '2019-08-24', 179, NULL),
('Candlewood Suites', 221, '2019-08-25', 232, NULL),
('Candlewood Suites', 221, '2019-08-26', 203, NULL),
('Candlewood Suites', 221, '2019-08-27', 239, NULL),
('Candlewood Suites', 221, '2019-08-28', 197, NULL),
('Candlewood Suites', 221, '2019-08-29', 178, NULL),
('Candlewood Suites', 221, '2019-08-30', 201, NULL),
('Candlewood Suites', 221, '2019-08-31', 182, NULL),
('Candlewood Suites', 221, '2019-09-01', 151, NULL),
('Candlewood Suites', 221, '2019-09-02', 114, NULL),
('Candlewood Suites', 221, '2019-09-03', 305, NULL),
('Candlewood Suites', 221, '2019-09-04', 392, NULL),
('Candlewood Suites', 221, '2019-09-05', 209, NULL),
('Candlewood Suites', 221, '2019-09-06', 119, NULL),
('Candlewood Suites', 221, '2019-09-07', 211, NULL),
('Candlewood Suites', 221, '2019-09-08', 184, NULL),
('Candlewood Suites', 221, '2019-09-09', 244, NULL),
('Candlewood Suites', 221, '2019-09-10', 255, NULL),
('Candlewood Suites', 221, '2019-09-11', 122, NULL),
('Candlewood Suites', 221, '2019-09-12', 233, NULL),
('Candlewood Suites', 221, '2019-09-13', 246, NULL),
('Candlewood Suites', 221, '2019-09-14', 326, NULL),
('Candlewood Suites', 221, '2019-09-15', 116, NULL),
('Candlewood Suites', 221, '2019-09-16', 377, NULL),
('Candlewood Suites', 221, '2019-09-17', 124, NULL),
('Candlewood Suites', 221, '2019-09-18', 359, NULL),
('Candlewood Suites', 221, '2019-09-19', 236, NULL),
('Candlewood Suites', 221, '2019-09-20', 317, NULL),
('Candlewood Suites', 221, '2019-09-21', 178, NULL),
('Candlewood Suites', 221, '2019-09-22', 277, NULL),
('Candlewood Suites', 221, '2019-09-23', 284, NULL),
('Candlewood Suites', 221, '2019-09-24', 281, NULL),
('Candlewood Suites', 221, '2019-09-25', 297, NULL),
('Candlewood Suites', 221, '2019-09-26', 305, NULL),
('Candlewood Suites', 221, '2019-09-27', 229, NULL),
('Candlewood Suites', 221, '2019-09-28', 184, NULL),
('Candlewood Suites', 221, '2019-09-29', 166, NULL),
('Candlewood Suites', 221, '2019-09-30', 129, NULL),
('Candlewood Suites', 221, '2019-10-01', 239, NULL),
('Candlewood Suites', 221, '2019-10-02', 252, NULL),
('Candlewood Suites', 221, '2019-10-03', 117, NULL),
('Candlewood Suites', 221, '2019-10-04', 343, NULL),
('Candlewood Suites', 221, '2019-10-05', 279, NULL),
('Candlewood Suites', 221, '2019-10-06', 378, NULL),
('Candlewood Suites', 221, '2019-10-07', 369, NULL),
('Candlewood Suites', 221, '2019-10-08', 367, NULL),
('Candlewood Suites', 221, '2019-10-09', 342, NULL),
('Candlewood Suites', 221, '2019-10-10', 272, NULL),
('Candlewood Suites', 221, '2019-10-11', 107, NULL),
('Candlewood Suites', 221, '2019-10-12', 321, NULL),
('Candlewood Suites', 221, '2019-10-13', 164, NULL),
('Candlewood Suites', 221, '2019-10-14', 130, NULL),
('Candlewood Suites', 221, '2019-10-15', 362, NULL),
('Candlewood Suites', 221, '2019-10-16', 302, NULL),
('Candlewood Suites', 221, '2019-10-17', 356, NULL),
('Candlewood Suites', 221, '2019-10-18', 322, NULL),
('Candlewood Suites', 221, '2019-10-19', 125, NULL),
('Candlewood Suites', 221, '2019-10-20', 381, NULL),
('Candlewood Suites', 221, '2019-10-21', 326, NULL),
('Candlewood Suites', 221, '2019-10-22', 370, NULL),
('Candlewood Suites', 221, '2019-10-23', 122, NULL),
('Candlewood Suites', 221, '2019-10-24', 190, NULL),
('Candlewood Suites', 221, '2019-10-25', 298, NULL),
('Candlewood Suites', 221, '2019-10-26', 131, NULL),
('Candlewood Suites', 221, '2019-10-27', 238, NULL),
('Candlewood Suites', 221, '2019-10-28', 141, NULL),
('Candlewood Suites', 221, '2019-10-29', 396, NULL),
('Candlewood Suites', 221, '2019-10-30', 272, NULL),
('Candlewood Suites', 221, '2019-10-31', 169, NULL),
('Candlewood Suites', 221, '2019-11-01', 276, NULL),
('Candlewood Suites', 221, '2019-11-02', 242, NULL),
('Candlewood Suites', 221, '2019-11-03', 117, NULL),
('Candlewood Suites', 221, '2019-11-04', 189, NULL),
('Candlewood Suites', 221, '2019-11-05', 167, NULL),
('Candlewood Suites', 221, '2019-11-06', 328, NULL),
('Candlewood Suites', 221, '2019-11-07', 102, NULL),
('Candlewood Suites', 221, '2019-11-08', 113, NULL),
('Candlewood Suites', 221, '2019-11-09', 150, NULL),
('Candlewood Suites', 221, '2019-11-10', 378, NULL),
('Candlewood Suites', 221, '2019-11-11', 394, NULL),
('Candlewood Suites', 221, '2019-11-12', 233, NULL),
('Candlewood Suites', 221, '2019-11-13', 282, NULL),
('Candlewood Suites', 221, '2019-11-14', 299, NULL),
('Candlewood Suites', 221, '2019-11-15', 266, NULL),
('Candlewood Suites', 221, '2019-11-16', 295, NULL),
('Candlewood Suites', 221, '2019-11-17', 366, NULL),
('Candlewood Suites', 221, '2019-11-18', 354, NULL),
('Candlewood Suites', 221, '2019-11-19', 390, NULL),
('Candlewood Suites', 221, '2019-11-20', 237, NULL),
('Candlewood Suites', 221, '2019-11-21', 350, NULL),
('Candlewood Suites', 221, '2019-11-22', 274, NULL),
('Candlewood Suites', 221, '2019-11-23', 168, NULL),
('Candlewood Suites', 221, '2019-11-24', 286, NULL),
('Candlewood Suites', 221, '2019-11-25', 118, NULL),
('Candlewood Suites', 221, '2019-11-26', 303, NULL),
('Candlewood Suites', 221, '2019-11-27', 389, NULL),
('Candlewood Suites', 221, '2019-11-28', 277, NULL),
('Candlewood Suites', 221, '2019-11-29', 338, NULL),
('Candlewood Suites', 221, '2019-11-30', 157, NULL),
('Candlewood Suites', 221, '2019-12-01', 248, NULL),
('Candlewood Suites', 221, '2019-12-02', 365, NULL),
('Candlewood Suites', 221, '2019-12-03', 328, NULL),
('Candlewood Suites', 221, '2019-12-04', 127, NULL),
('Candlewood Suites', 221, '2019-12-05', 394, NULL),
('Candlewood Suites', 221, '2019-12-06', 324, NULL),
('Candlewood Suites', 221, '2019-12-07', 380, NULL),
('Candlewood Suites', 221, '2019-12-08', 305, NULL),
('Candlewood Suites', 221, '2019-12-09', 302, NULL),
('Candlewood Suites', 221, '2019-12-10', 266, NULL),
('Candlewood Suites', 221, '2019-12-11', 341, NULL),
('Candlewood Suites', 221, '2019-12-12', 211, NULL),
('Candlewood Suites', 221, '2019-12-13', 313, NULL),
('Candlewood Suites', 221, '2019-12-14', 252, NULL),
('Candlewood Suites', 221, '2019-12-15', 289, NULL),
('Candlewood Suites', 221, '2019-12-16', 289, NULL),
('Candlewood Suites', 221, '2019-12-17', 304, NULL),
('Candlewood Suites', 221, '2019-12-18', 350, NULL),
('Candlewood Suites', 221, '2019-12-19', 210, NULL),
('Candlewood Suites', 221, '2019-12-20', 289, NULL),
('Candlewood Suites', 221, '2019-12-21', 216, NULL),
('Candlewood Suites', 221, '2019-12-22', 368, NULL),
('Candlewood Suites', 221, '2019-12-23', 246, NULL),
('Candlewood Suites', 221, '2019-12-24', 329, NULL),
('Candlewood Suites', 221, '2019-12-25', 247, NULL),
('Candlewood Suites', 221, '2019-12-26', 288, NULL),
('Candlewood Suites', 221, '2019-12-27', 357, NULL),
('Candlewood Suites', 221, '2019-12-28', 106, NULL),
('Candlewood Suites', 221, '2019-12-29', 106, NULL),
('Candlewood Suites', 221, '2019-12-30', 229, NULL),
('Candlewood Suites', 221, '2019-12-31', 347, NULL),
('Candlewood Suites', 221, '2020-01-01', 136, NULL),
('Candlewood Suites', 221, '2020-01-02', 244, NULL),
('Candlewood Suites', 221, '2020-01-03', 379, NULL),
('Candlewood Suites', 221, '2020-01-04', 253, NULL),
('Candlewood Suites', 221, '2020-01-05', 389, NULL),
('Candlewood Suites', 221, '2020-01-06', 164, NULL),
('Candlewood Suites', 221, '2020-01-07', 112, NULL),
('Candlewood Suites', 221, '2020-01-08', 284, NULL),
('Candlewood Suites', 221, '2020-01-09', 251, NULL),
('Candlewood Suites', 221, '2020-01-10', 318, NULL),
('Candlewood Suites', 221, '2020-01-11', 267, NULL),
('Candlewood Suites', 221, '2020-01-12', 144, NULL),
('Candlewood Suites', 221, '2020-01-13', 189, NULL),
('Candlewood Suites', 221, '2020-01-14', 323, NULL),
('Candlewood Suites', 221, '2020-01-15', 358, NULL),
('Candlewood Suites', 221, '2020-01-16', 345, NULL),
('Candlewood Suites', 221, '2020-01-17', 310, NULL),
('Candlewood Suites', 221, '2020-01-18', 260, NULL),
('Candlewood Suites', 221, '2020-01-19', 184, NULL),
('Candlewood Suites', 221, '2020-01-20', 372, NULL),
('Candlewood Suites', 221, '2020-01-21', 114, NULL),
('Candlewood Suites', 221, '2020-01-22', 367, NULL),
('Candlewood Suites', 221, '2020-01-23', 149, NULL),
('Candlewood Suites', 221, '2020-01-24', 221, NULL),
('Candlewood Suites', 221, '2020-01-25', 334, NULL),
('Candlewood Suites', 221, '2020-01-26', 126, NULL),
('Candlewood Suites', 221, '2020-01-27', 355, NULL),
('Candlewood Suites', 221, '2020-01-28', 157, NULL),
('Candlewood Suites', 221, '2020-01-29', 285, NULL),
('Candlewood Suites', 221, '2020-01-30', 106, NULL),
('Candlewood Suites', 221, '2020-01-31', 240, NULL),
('Candlewood Suites', 221, '2020-02-01', 368, NULL),
('Candlewood Suites', 221, '2020-02-02', 279, NULL),
('Candlewood Suites', 221, '2020-02-03', 360, NULL),
('Candlewood Suites', 221, '2020-02-04', 334, NULL),
('Candlewood Suites', 222, '2019-01-01', 165, NULL),
('Candlewood Suites', 222, '2019-01-02', 351, NULL),
('Candlewood Suites', 222, '2019-01-03', 168, NULL),
('Candlewood Suites', 222, '2019-01-04', 276, NULL),
('Candlewood Suites', 222, '2019-01-05', 324, NULL),
('Candlewood Suites', 222, '2019-01-06', 235, NULL),
('Candlewood Suites', 222, '2019-01-07', 342, NULL),
('Candlewood Suites', 222, '2019-01-08', 121, NULL),
('Candlewood Suites', 222, '2019-01-09', 342, NULL),
('Candlewood Suites', 222, '2019-01-10', 220, NULL),
('Candlewood Suites', 222, '2019-01-11', 381, NULL),
('Candlewood Suites', 222, '2019-01-12', 153, NULL),
('Candlewood Suites', 222, '2019-01-13', 224, NULL),
('Candlewood Suites', 222, '2019-01-14', 264, NULL),
('Candlewood Suites', 222, '2019-01-15', 205, NULL),
('Candlewood Suites', 222, '2019-01-16', 327, NULL),
('Candlewood Suites', 222, '2019-01-17', 112, NULL),
('Candlewood Suites', 222, '2019-01-18', 149, NULL),
('Candlewood Suites', 222, '2019-01-19', 221, NULL),
('Candlewood Suites', 222, '2019-01-20', 320, NULL),
('Candlewood Suites', 222, '2019-01-21', 373, NULL),
('Candlewood Suites', 222, '2019-01-22', 136, NULL),
('Candlewood Suites', 222, '2019-01-23', 263, NULL),
('Candlewood Suites', 222, '2019-01-24', 116, NULL),
('Candlewood Suites', 222, '2019-01-25', 290, NULL),
('Candlewood Suites', 222, '2019-01-26', 312, NULL),
('Candlewood Suites', 222, '2019-01-27', 365, NULL),
('Candlewood Suites', 222, '2019-01-28', 230, NULL),
('Candlewood Suites', 222, '2019-01-29', 359, NULL),
('Candlewood Suites', 222, '2019-01-30', 382, NULL),
('Candlewood Suites', 222, '2019-01-31', 135, NULL),
('Candlewood Suites', 222, '2019-02-01', 328, NULL),
('Candlewood Suites', 222, '2019-02-02', 329, NULL),
('Candlewood Suites', 222, '2019-02-03', 116, NULL),
('Candlewood Suites', 222, '2019-02-04', 306, NULL),
('Candlewood Suites', 222, '2019-02-05', 346, NULL),
('Candlewood Suites', 222, '2019-02-06', 298, NULL),
('Candlewood Suites', 222, '2019-02-07', 140, NULL),
('Candlewood Suites', 222, '2019-02-08', 310, NULL),
('Candlewood Suites', 222, '2019-02-09', 115, NULL),
('Candlewood Suites', 222, '2019-02-10', 198, NULL),
('Candlewood Suites', 222, '2019-02-11', 165, NULL),
('Candlewood Suites', 222, '2019-02-12', 300, NULL),
('Candlewood Suites', 222, '2019-02-13', 151, NULL),
('Candlewood Suites', 222, '2019-02-14', 142, NULL),
('Candlewood Suites', 222, '2019-02-15', 135, NULL),
('Candlewood Suites', 222, '2019-02-16', 232, NULL),
('Candlewood Suites', 222, '2019-02-17', 132, NULL),
('Candlewood Suites', 222, '2019-02-18', 173, NULL),
('Candlewood Suites', 222, '2019-02-19', 273, NULL),
('Candlewood Suites', 222, '2019-02-20', 348, NULL),
('Candlewood Suites', 222, '2019-02-21', 148, NULL),
('Candlewood Suites', 222, '2019-02-22', 104, NULL),
('Candlewood Suites', 222, '2019-02-23', 336, NULL),
('Candlewood Suites', 222, '2019-02-24', 381, NULL),
('Candlewood Suites', 222, '2019-02-25', 332, NULL),
('Candlewood Suites', 222, '2019-02-26', 220, NULL),
('Candlewood Suites', 222, '2019-02-27', 130, NULL),
('Candlewood Suites', 222, '2019-02-28', 343, NULL),
('Candlewood Suites', 222, '2019-03-01', 145, NULL),
('Candlewood Suites', 222, '2019-03-02', 298, NULL),
('Candlewood Suites', 222, '2019-03-03', 368, NULL),
('Candlewood Suites', 222, '2019-03-04', 173, NULL),
('Candlewood Suites', 222, '2019-03-05', 146, NULL),
('Candlewood Suites', 222, '2019-03-06', 131, NULL),
('Candlewood Suites', 222, '2019-03-07', 114, NULL),
('Candlewood Suites', 222, '2019-03-08', 103, NULL),
('Candlewood Suites', 222, '2019-03-09', 268, NULL),
('Candlewood Suites', 222, '2019-03-10', 153, NULL),
('Candlewood Suites', 222, '2019-03-11', 106, NULL),
('Candlewood Suites', 222, '2019-03-12', 116, NULL),
('Candlewood Suites', 222, '2019-03-13', 372, NULL),
('Candlewood Suites', 222, '2019-03-14', 165, NULL),
('Candlewood Suites', 222, '2019-03-15', 122, NULL),
('Candlewood Suites', 222, '2019-03-16', 200, NULL),
('Candlewood Suites', 222, '2019-03-17', 147, NULL),
('Candlewood Suites', 222, '2019-03-18', 122, NULL),
('Candlewood Suites', 222, '2019-03-19', 113, NULL),
('Candlewood Suites', 222, '2019-03-20', 134, NULL),
('Candlewood Suites', 222, '2019-03-21', 231, NULL),
('Candlewood Suites', 222, '2019-03-22', 142, NULL),
('Candlewood Suites', 222, '2019-03-23', 113, NULL),
('Candlewood Suites', 222, '2019-03-24', 223, NULL),
('Candlewood Suites', 222, '2019-03-25', 315, NULL),
('Candlewood Suites', 222, '2019-03-26', 123, NULL),
('Candlewood Suites', 222, '2019-03-27', 103, NULL),
('Candlewood Suites', 222, '2019-03-28', 115, NULL),
('Candlewood Suites', 222, '2019-03-29', 197, NULL),
('Candlewood Suites', 222, '2019-03-30', 231, NULL),
('Candlewood Suites', 222, '2019-03-31', 387, NULL),
('Candlewood Suites', 222, '2019-04-01', 261, NULL),
('Candlewood Suites', 222, '2019-04-02', 308, NULL),
('Candlewood Suites', 222, '2019-04-03', 388, NULL),
('Candlewood Suites', 222, '2019-04-04', 313, NULL),
('Candlewood Suites', 222, '2019-04-05', 147, NULL),
('Candlewood Suites', 222, '2019-04-06', 290, NULL),
('Candlewood Suites', 222, '2019-04-07', 179, NULL),
('Candlewood Suites', 222, '2019-04-08', 279, NULL),
('Candlewood Suites', 222, '2019-04-09', 338, NULL),
('Candlewood Suites', 222, '2019-04-10', 188, NULL),
('Candlewood Suites', 222, '2019-04-11', 259, NULL),
('Candlewood Suites', 222, '2019-04-12', 365, NULL),
('Candlewood Suites', 222, '2019-04-13', 378, NULL),
('Candlewood Suites', 222, '2019-04-14', 250, NULL),
('Candlewood Suites', 222, '2019-04-15', 201, NULL),
('Candlewood Suites', 222, '2019-04-16', 286, NULL),
('Candlewood Suites', 222, '2019-04-17', 387, NULL),
('Candlewood Suites', 222, '2019-04-18', 148, NULL),
('Candlewood Suites', 222, '2019-04-19', 339, NULL),
('Candlewood Suites', 222, '2019-04-20', 158, NULL),
('Candlewood Suites', 222, '2019-04-21', 147, NULL),
('Candlewood Suites', 222, '2019-04-22', 354, NULL),
('Candlewood Suites', 222, '2019-04-23', 213, NULL),
('Candlewood Suites', 222, '2019-04-24', 104, NULL),
('Candlewood Suites', 222, '2019-04-25', 124, NULL),
('Candlewood Suites', 222, '2019-04-26', 368, NULL),
('Candlewood Suites', 222, '2019-04-27', 218, NULL),
('Candlewood Suites', 222, '2019-04-28', 345, NULL),
('Candlewood Suites', 222, '2019-04-29', 196, NULL),
('Candlewood Suites', 222, '2019-04-30', 227, NULL),
('Candlewood Suites', 222, '2019-05-01', 376, NULL),
('Candlewood Suites', 222, '2019-05-02', 259, NULL),
('Candlewood Suites', 222, '2019-05-03', 110, NULL),
('Candlewood Suites', 222, '2019-05-04', 129, NULL),
('Candlewood Suites', 222, '2019-05-05', 323, NULL),
('Candlewood Suites', 222, '2019-05-06', 349, NULL),
('Candlewood Suites', 222, '2019-05-07', 332, NULL),
('Candlewood Suites', 222, '2019-05-08', 254, NULL),
('Candlewood Suites', 222, '2019-05-09', 125, NULL),
('Candlewood Suites', 222, '2019-05-10', 132, NULL),
('Candlewood Suites', 222, '2019-05-11', 329, NULL),
('Candlewood Suites', 222, '2019-05-12', 393, NULL),
('Candlewood Suites', 222, '2019-05-13', 111, NULL),
('Candlewood Suites', 222, '2019-05-14', 346, NULL),
('Candlewood Suites', 222, '2019-05-15', 318, NULL),
('Candlewood Suites', 222, '2019-05-16', 175, NULL),
('Candlewood Suites', 222, '2019-05-17', 215, NULL),
('Candlewood Suites', 222, '2019-05-18', 178, NULL),
('Candlewood Suites', 222, '2019-05-19', 168, NULL),
('Candlewood Suites', 222, '2019-05-20', 368, NULL),
('Candlewood Suites', 222, '2019-05-21', 288, NULL),
('Candlewood Suites', 222, '2019-05-22', 122, NULL),
('Candlewood Suites', 222, '2019-05-23', 342, NULL),
('Candlewood Suites', 222, '2019-05-24', 355, NULL),
('Candlewood Suites', 222, '2019-05-25', 264, NULL),
('Candlewood Suites', 222, '2019-05-26', 141, NULL),
('Candlewood Suites', 222, '2019-05-27', 331, NULL),
('Candlewood Suites', 222, '2019-05-28', 340, NULL),
('Candlewood Suites', 222, '2019-05-29', 147, NULL),
('Candlewood Suites', 222, '2019-05-30', 365, NULL),
('Candlewood Suites', 222, '2019-05-31', 345, NULL),
('Candlewood Suites', 222, '2019-06-01', 325, NULL),
('Candlewood Suites', 222, '2019-06-02', 364, NULL),
('Candlewood Suites', 222, '2019-06-03', 320, NULL),
('Candlewood Suites', 222, '2019-06-04', 205, NULL),
('Candlewood Suites', 222, '2019-06-05', 207, NULL),
('Candlewood Suites', 222, '2019-06-06', 262, NULL),
('Candlewood Suites', 222, '2019-06-07', 341, NULL),
('Candlewood Suites', 222, '2019-06-08', 297, NULL),
('Candlewood Suites', 222, '2019-06-09', 305, NULL),
('Candlewood Suites', 222, '2019-06-10', 255, NULL),
('Candlewood Suites', 222, '2019-06-11', 218, NULL),
('Candlewood Suites', 222, '2019-06-12', 175, NULL),
('Candlewood Suites', 222, '2019-06-13', 274, NULL),
('Candlewood Suites', 222, '2019-06-14', 232, NULL),
('Candlewood Suites', 222, '2019-06-15', 374, NULL),
('Candlewood Suites', 222, '2019-06-16', 189, NULL),
('Candlewood Suites', 222, '2019-06-17', 134, NULL),
('Candlewood Suites', 222, '2019-06-18', 148, NULL),
('Candlewood Suites', 222, '2019-06-19', 198, NULL),
('Candlewood Suites', 222, '2019-06-20', 153, NULL),
('Candlewood Suites', 222, '2019-06-21', 392, NULL),
('Candlewood Suites', 222, '2019-06-22', 343, NULL),
('Candlewood Suites', 222, '2019-06-23', 120, NULL),
('Candlewood Suites', 222, '2019-06-24', 133, NULL),
('Candlewood Suites', 222, '2019-06-25', 337, NULL),
('Candlewood Suites', 222, '2019-06-26', 312, NULL),
('Candlewood Suites', 222, '2019-06-27', 131, NULL),
('Candlewood Suites', 222, '2019-06-28', 199, NULL),
('Candlewood Suites', 222, '2019-06-29', 231, NULL),
('Candlewood Suites', 222, '2019-06-30', 118, NULL),
('Candlewood Suites', 222, '2019-07-01', 320, NULL),
('Candlewood Suites', 222, '2019-07-02', 302, NULL),
('Candlewood Suites', 222, '2019-07-03', 191, NULL),
('Candlewood Suites', 222, '2019-07-04', 156, NULL),
('Candlewood Suites', 222, '2019-07-05', 386, NULL),
('Candlewood Suites', 222, '2019-07-06', 164, NULL),
('Candlewood Suites', 222, '2019-07-07', 295, NULL),
('Candlewood Suites', 222, '2019-07-08', 108, NULL),
('Candlewood Suites', 222, '2019-07-09', 158, NULL),
('Candlewood Suites', 222, '2019-07-10', 323, NULL),
('Candlewood Suites', 222, '2019-07-11', 135, NULL),
('Candlewood Suites', 222, '2019-07-12', 326, NULL),
('Candlewood Suites', 222, '2019-07-13', 116, NULL),
('Candlewood Suites', 222, '2019-07-14', 267, NULL),
('Candlewood Suites', 222, '2019-07-15', 261, NULL),
('Candlewood Suites', 222, '2019-07-16', 372, NULL),
('Candlewood Suites', 222, '2019-07-17', 110, NULL),
('Candlewood Suites', 222, '2019-07-18', 178, NULL),
('Candlewood Suites', 222, '2019-07-19', 249, NULL),
('Candlewood Suites', 222, '2019-07-20', 283, NULL),
('Candlewood Suites', 222, '2019-07-21', 228, NULL),
('Candlewood Suites', 222, '2019-07-22', 324, NULL),
('Candlewood Suites', 222, '2019-07-23', 322, NULL),
('Candlewood Suites', 222, '2019-07-24', 222, NULL),
('Candlewood Suites', 222, '2019-07-25', 286, NULL),
('Candlewood Suites', 222, '2019-07-26', 349, NULL),
('Candlewood Suites', 222, '2019-07-27', 331, NULL),
('Candlewood Suites', 222, '2019-07-28', 137, NULL),
('Candlewood Suites', 222, '2019-07-29', 320, NULL),
('Candlewood Suites', 222, '2019-07-30', 279, NULL),
('Candlewood Suites', 222, '2019-07-31', 161, NULL),
('Candlewood Suites', 222, '2019-08-01', 319, NULL),
('Candlewood Suites', 222, '2019-08-02', 369, NULL),
('Candlewood Suites', 222, '2019-08-03', 288, NULL),
('Candlewood Suites', 222, '2019-08-04', 112, NULL),
('Candlewood Suites', 222, '2019-08-05', 266, NULL),
('Candlewood Suites', 222, '2019-08-06', 166, NULL),
('Candlewood Suites', 222, '2019-08-07', 154, NULL),
('Candlewood Suites', 222, '2019-08-08', 196, NULL),
('Candlewood Suites', 222, '2019-08-09', 235, NULL),
('Candlewood Suites', 222, '2019-08-10', 275, NULL),
('Candlewood Suites', 222, '2019-08-11', 219, NULL),
('Candlewood Suites', 222, '2019-08-12', 275, NULL),
('Candlewood Suites', 222, '2019-08-13', 103, NULL),
('Candlewood Suites', 222, '2019-08-14', 392, NULL),
('Candlewood Suites', 222, '2019-08-15', 281, NULL),
('Candlewood Suites', 222, '2019-08-16', 272, NULL),
('Candlewood Suites', 222, '2019-08-17', 163, NULL),
('Candlewood Suites', 222, '2019-08-18', 158, NULL),
('Candlewood Suites', 222, '2019-08-19', 333, NULL),
('Candlewood Suites', 222, '2019-08-20', 144, NULL),
('Candlewood Suites', 222, '2019-08-21', 395, NULL),
('Candlewood Suites', 222, '2019-08-22', 143, NULL),
('Candlewood Suites', 222, '2019-08-23', 210, NULL),
('Candlewood Suites', 222, '2019-08-24', 369, NULL),
('Candlewood Suites', 222, '2019-08-25', 249, NULL),
('Candlewood Suites', 222, '2019-08-26', 186, NULL),
('Candlewood Suites', 222, '2019-08-27', 238, NULL),
('Candlewood Suites', 222, '2019-08-28', 258, NULL),
('Candlewood Suites', 222, '2019-08-29', 390, NULL),
('Candlewood Suites', 222, '2019-08-30', 308, NULL),
('Candlewood Suites', 222, '2019-08-31', 101, NULL),
('Candlewood Suites', 222, '2019-09-01', 338, NULL),
('Candlewood Suites', 222, '2019-09-02', 344, NULL),
('Candlewood Suites', 222, '2019-09-03', 105, NULL),
('Candlewood Suites', 222, '2019-09-04', 333, NULL),
('Candlewood Suites', 222, '2019-09-05', 120, NULL),
('Candlewood Suites', 222, '2019-09-06', 190, NULL),
('Candlewood Suites', 222, '2019-09-07', 352, NULL),
('Candlewood Suites', 222, '2019-09-08', 336, NULL),
('Candlewood Suites', 222, '2019-09-09', 381, NULL),
('Candlewood Suites', 222, '2019-09-10', 116, NULL),
('Candlewood Suites', 222, '2019-09-11', 360, NULL),
('Candlewood Suites', 222, '2019-09-12', 306, NULL),
('Candlewood Suites', 222, '2019-09-13', 229, NULL),
('Candlewood Suites', 222, '2019-09-14', 114, NULL),
('Candlewood Suites', 222, '2019-09-15', 211, NULL),
('Candlewood Suites', 222, '2019-09-16', 177, NULL),
('Candlewood Suites', 222, '2019-09-17', 230, NULL),
('Candlewood Suites', 222, '2019-09-18', 374, NULL),
('Candlewood Suites', 222, '2019-09-19', 366, NULL),
('Candlewood Suites', 222, '2019-09-20', 186, NULL),
('Candlewood Suites', 222, '2019-09-21', 261, NULL),
('Candlewood Suites', 222, '2019-09-22', 367, NULL),
('Candlewood Suites', 222, '2019-09-23', 129, NULL),
('Candlewood Suites', 222, '2019-09-24', 397, NULL),
('Candlewood Suites', 222, '2019-09-25', 387, NULL),
('Candlewood Suites', 222, '2019-09-26', 277, NULL),
('Candlewood Suites', 222, '2019-09-27', 140, NULL),
('Candlewood Suites', 222, '2019-09-28', 246, NULL),
('Candlewood Suites', 222, '2019-09-29', 378, NULL),
('Candlewood Suites', 222, '2019-09-30', 208, NULL),
('Candlewood Suites', 222, '2019-10-01', 388, NULL),
('Candlewood Suites', 222, '2019-10-02', 390, NULL),
('Candlewood Suites', 222, '2019-10-03', 164, NULL),
('Candlewood Suites', 222, '2019-10-04', 166, NULL),
('Candlewood Suites', 222, '2019-10-05', 298, NULL),
('Candlewood Suites', 222, '2019-10-06', 123, NULL),
('Candlewood Suites', 222, '2019-10-07', 385, NULL),
('Candlewood Suites', 222, '2019-10-08', 296, NULL),
('Candlewood Suites', 222, '2019-10-09', 322, NULL),
('Candlewood Suites', 222, '2019-10-10', 122, NULL),
('Candlewood Suites', 222, '2019-10-11', 186, NULL),
('Candlewood Suites', 222, '2019-10-12', 343, NULL),
('Candlewood Suites', 222, '2019-10-13', 122, NULL),
('Candlewood Suites', 222, '2019-10-14', 235, NULL),
('Candlewood Suites', 222, '2019-10-15', 322, NULL),
('Candlewood Suites', 222, '2019-10-16', 277, NULL),
('Candlewood Suites', 222, '2019-10-17', 360, NULL),
('Candlewood Suites', 222, '2019-10-18', 123, NULL),
('Candlewood Suites', 222, '2019-10-19', 363, NULL),
('Candlewood Suites', 222, '2019-10-20', 125, NULL),
('Candlewood Suites', 222, '2019-10-21', 318, NULL),
('Candlewood Suites', 222, '2019-10-22', 141, NULL),
('Candlewood Suites', 222, '2019-10-23', 379, NULL),
('Candlewood Suites', 222, '2019-10-24', 291, NULL),
('Candlewood Suites', 222, '2019-10-25', 389, NULL),
('Candlewood Suites', 222, '2019-10-26', 225, NULL),
('Candlewood Suites', 222, '2019-10-27', 356, NULL),
('Candlewood Suites', 222, '2019-10-28', 103, NULL),
('Candlewood Suites', 222, '2019-10-29', 274, NULL),
('Candlewood Suites', 222, '2019-10-30', 137, NULL),
('Candlewood Suites', 222, '2019-10-31', 223, NULL),
('Candlewood Suites', 222, '2019-11-01', 329, NULL),
('Candlewood Suites', 222, '2019-11-02', 108, NULL),
('Candlewood Suites', 222, '2019-11-03', 136, NULL),
('Candlewood Suites', 222, '2019-11-04', 160, NULL),
('Candlewood Suites', 222, '2019-11-05', 197, NULL),
('Candlewood Suites', 222, '2019-11-06', 306, NULL),
('Candlewood Suites', 222, '2019-11-07', 148, NULL),
('Candlewood Suites', 222, '2019-11-08', 121, NULL),
('Candlewood Suites', 222, '2019-11-09', 295, NULL),
('Candlewood Suites', 222, '2019-11-10', 295, NULL),
('Candlewood Suites', 222, '2019-11-11', 359, NULL),
('Candlewood Suites', 222, '2019-11-12', 270, NULL),
('Candlewood Suites', 222, '2019-11-13', 297, NULL),
('Candlewood Suites', 222, '2019-11-14', 245, NULL),
('Candlewood Suites', 222, '2019-11-15', 325, NULL),
('Candlewood Suites', 222, '2019-11-16', 345, NULL),
('Candlewood Suites', 222, '2019-11-17', 251, NULL),
('Candlewood Suites', 222, '2019-11-18', 244, NULL),
('Candlewood Suites', 222, '2019-11-19', 348, NULL),
('Candlewood Suites', 222, '2019-11-20', 179, NULL),
('Candlewood Suites', 222, '2019-11-21', 300, NULL),
('Candlewood Suites', 222, '2019-11-22', 158, NULL),
('Candlewood Suites', 222, '2019-11-23', 126, NULL),
('Candlewood Suites', 222, '2019-11-24', 390, NULL),
('Candlewood Suites', 222, '2019-11-25', 164, NULL),
('Candlewood Suites', 222, '2019-11-26', 247, NULL),
('Candlewood Suites', 222, '2019-11-27', 253, NULL),
('Candlewood Suites', 222, '2019-11-28', 135, NULL),
('Candlewood Suites', 222, '2019-11-29', 331, NULL),
('Candlewood Suites', 222, '2019-11-30', 287, NULL),
('Candlewood Suites', 222, '2019-12-01', 310, NULL),
('Candlewood Suites', 222, '2019-12-02', 222, NULL),
('Candlewood Suites', 222, '2019-12-03', 398, NULL),
('Candlewood Suites', 222, '2019-12-04', 219, NULL),
('Candlewood Suites', 222, '2019-12-05', 395, NULL),
('Candlewood Suites', 222, '2019-12-06', 258, NULL),
('Candlewood Suites', 222, '2019-12-07', 330, NULL),
('Candlewood Suites', 222, '2019-12-08', 285, NULL),
('Candlewood Suites', 222, '2019-12-09', 393, NULL),
('Candlewood Suites', 222, '2019-12-10', 286, NULL),
('Candlewood Suites', 222, '2019-12-11', 293, NULL),
('Candlewood Suites', 222, '2019-12-12', 297, NULL),
('Candlewood Suites', 222, '2019-12-13', 320, NULL),
('Candlewood Suites', 222, '2019-12-14', 368, NULL),
('Candlewood Suites', 222, '2019-12-15', 240, NULL),
('Candlewood Suites', 222, '2019-12-16', 154, NULL),
('Candlewood Suites', 222, '2019-12-17', 164, NULL),
('Candlewood Suites', 222, '2019-12-18', 323, NULL),
('Candlewood Suites', 222, '2019-12-19', 347, NULL),
('Candlewood Suites', 222, '2019-12-20', 374, NULL),
('Candlewood Suites', 222, '2019-12-21', 178, NULL),
('Candlewood Suites', 222, '2019-12-22', 321, NULL),
('Candlewood Suites', 222, '2019-12-23', 120, NULL),
('Candlewood Suites', 222, '2019-12-24', 196, NULL),
('Candlewood Suites', 222, '2019-12-25', 307, NULL),
('Candlewood Suites', 222, '2019-12-26', 301, NULL),
('Candlewood Suites', 222, '2019-12-27', 387, NULL),
('Candlewood Suites', 222, '2019-12-28', 278, NULL),
('Candlewood Suites', 222, '2019-12-29', 265, NULL),
('Candlewood Suites', 222, '2019-12-30', 194, NULL),
('Candlewood Suites', 222, '2019-12-31', 280, NULL),
('Candlewood Suites', 222, '2020-01-01', 193, NULL),
('Candlewood Suites', 222, '2020-01-02', 173, NULL),
('Candlewood Suites', 222, '2020-01-03', 275, NULL),
('Candlewood Suites', 222, '2020-01-04', 239, NULL),
('Candlewood Suites', 222, '2020-01-05', 271, NULL),
('Candlewood Suites', 222, '2020-01-06', 277, NULL),
('Candlewood Suites', 222, '2020-01-07', 260, NULL),
('Candlewood Suites', 222, '2020-01-08', 376, NULL),
('Candlewood Suites', 222, '2020-01-09', 196, NULL),
('Candlewood Suites', 222, '2020-01-10', 127, NULL),
('Candlewood Suites', 222, '2020-01-11', 114, NULL),
('Candlewood Suites', 222, '2020-01-12', 343, NULL),
('Candlewood Suites', 222, '2020-01-13', 347, NULL),
('Candlewood Suites', 222, '2020-01-14', 382, NULL),
('Candlewood Suites', 222, '2020-01-15', 235, NULL),
('Candlewood Suites', 222, '2020-01-16', 331, NULL),
('Candlewood Suites', 222, '2020-01-17', 338, NULL),
('Candlewood Suites', 222, '2020-01-18', 286, NULL),
('Candlewood Suites', 222, '2020-01-19', 364, NULL),
('Candlewood Suites', 222, '2020-01-20', 108, NULL),
('Candlewood Suites', 222, '2020-01-21', 137, NULL),
('Candlewood Suites', 222, '2020-01-22', 244, NULL),
('Candlewood Suites', 222, '2020-01-23', 176, NULL),
('Candlewood Suites', 222, '2020-01-24', 398, NULL),
('Candlewood Suites', 222, '2020-01-25', 350, NULL),
('Candlewood Suites', 222, '2020-01-26', 299, NULL),
('Candlewood Suites', 222, '2020-01-27', 354, NULL),
('Candlewood Suites', 222, '2020-01-28', 332, NULL),
('Candlewood Suites', 222, '2020-01-29', 340, NULL),
('Candlewood Suites', 222, '2020-01-30', 328, NULL),
('Candlewood Suites', 222, '2020-01-31', 195, NULL),
('Candlewood Suites', 222, '2020-02-01', 222, NULL),
('Candlewood Suites', 222, '2020-02-02', 122, NULL),
('Candlewood Suites', 222, '2020-02-03', 195, NULL),
('Candlewood Suites', 222, '2020-02-04', 325, NULL),
('Candlewood Suites', 223, '2019-01-01', 330, NULL),
('Candlewood Suites', 223, '2019-01-02', 291, NULL),
('Candlewood Suites', 223, '2019-01-03', 145, NULL),
('Candlewood Suites', 223, '2019-01-04', 378, NULL),
('Candlewood Suites', 223, '2019-01-05', 307, NULL),
('Candlewood Suites', 223, '2019-01-06', 336, NULL),
('Candlewood Suites', 223, '2019-01-07', 126, NULL),
('Candlewood Suites', 223, '2019-01-08', 243, NULL),
('Candlewood Suites', 223, '2019-01-09', 155, NULL),
('Candlewood Suites', 223, '2019-01-10', 101, NULL),
('Candlewood Suites', 223, '2019-01-11', 261, NULL),
('Candlewood Suites', 223, '2019-01-12', 256, NULL),
('Candlewood Suites', 223, '2019-01-13', 234, NULL),
('Candlewood Suites', 223, '2019-01-14', 134, NULL),
('Candlewood Suites', 223, '2019-01-15', 351, NULL),
('Candlewood Suites', 223, '2019-01-16', 119, NULL),
('Candlewood Suites', 223, '2019-01-17', 211, NULL),
('Candlewood Suites', 223, '2019-01-18', 369, NULL),
('Candlewood Suites', 223, '2019-01-19', 310, NULL),
('Candlewood Suites', 223, '2019-01-20', 171, NULL),
('Candlewood Suites', 223, '2019-01-21', 260, NULL),
('Candlewood Suites', 223, '2019-01-22', 399, NULL),
('Candlewood Suites', 223, '2019-01-23', 197, NULL),
('Candlewood Suites', 223, '2019-01-24', 332, NULL),
('Candlewood Suites', 223, '2019-01-25', 280, NULL),
('Candlewood Suites', 223, '2019-01-26', 256, NULL),
('Candlewood Suites', 223, '2019-01-27', 319, NULL),
('Candlewood Suites', 223, '2019-01-28', 200, NULL),
('Candlewood Suites', 223, '2019-01-29', 122, NULL),
('Candlewood Suites', 223, '2019-01-30', 153, NULL),
('Candlewood Suites', 223, '2019-01-31', 377, NULL),
('Candlewood Suites', 223, '2019-02-01', 169, NULL),
('Candlewood Suites', 223, '2019-02-02', 126, NULL),
('Candlewood Suites', 223, '2019-02-03', 108, NULL),
('Candlewood Suites', 223, '2019-02-04', 240, NULL),
('Candlewood Suites', 223, '2019-02-05', 225, NULL),
('Candlewood Suites', 223, '2019-02-06', 116, NULL),
('Candlewood Suites', 223, '2019-02-07', 180, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 223, '2019-02-08', 147, NULL),
('Candlewood Suites', 223, '2019-02-09', 192, NULL),
('Candlewood Suites', 223, '2019-02-10', 359, NULL),
('Candlewood Suites', 223, '2019-02-11', 333, NULL),
('Candlewood Suites', 223, '2019-02-12', 159, NULL),
('Candlewood Suites', 223, '2019-02-13', 376, NULL),
('Candlewood Suites', 223, '2019-02-14', 238, NULL),
('Candlewood Suites', 223, '2019-02-15', 323, NULL),
('Candlewood Suites', 223, '2019-02-16', 182, NULL),
('Candlewood Suites', 223, '2019-02-17', 123, NULL),
('Candlewood Suites', 223, '2019-02-18', 129, NULL),
('Candlewood Suites', 223, '2019-02-19', 349, NULL),
('Candlewood Suites', 223, '2019-02-20', 350, NULL),
('Candlewood Suites', 223, '2019-02-21', 278, NULL),
('Candlewood Suites', 223, '2019-02-22', 167, NULL),
('Candlewood Suites', 223, '2019-02-23', 375, NULL),
('Candlewood Suites', 223, '2019-02-24', 191, NULL),
('Candlewood Suites', 223, '2019-02-25', 132, NULL),
('Candlewood Suites', 223, '2019-02-26', 305, NULL),
('Candlewood Suites', 223, '2019-02-27', 290, NULL),
('Candlewood Suites', 223, '2019-02-28', 205, NULL),
('Candlewood Suites', 223, '2019-03-01', 265, NULL),
('Candlewood Suites', 223, '2019-03-02', 365, NULL),
('Candlewood Suites', 223, '2019-03-03', 214, NULL),
('Candlewood Suites', 223, '2019-03-04', 112, NULL),
('Candlewood Suites', 223, '2019-03-05', 214, NULL),
('Candlewood Suites', 223, '2019-03-06', 110, NULL),
('Candlewood Suites', 223, '2019-03-07', 272, NULL),
('Candlewood Suites', 223, '2019-03-08', 140, NULL),
('Candlewood Suites', 223, '2019-03-09', 111, NULL),
('Candlewood Suites', 223, '2019-03-10', 349, NULL),
('Candlewood Suites', 223, '2019-03-11', 119, NULL),
('Candlewood Suites', 223, '2019-03-12', 268, NULL),
('Candlewood Suites', 223, '2019-03-13', 373, NULL),
('Candlewood Suites', 223, '2019-03-14', 343, NULL),
('Candlewood Suites', 223, '2019-03-15', 316, NULL),
('Candlewood Suites', 223, '2019-03-16', 263, NULL),
('Candlewood Suites', 223, '2019-03-17', 348, NULL),
('Candlewood Suites', 223, '2019-03-18', 299, NULL),
('Candlewood Suites', 223, '2019-03-19', 289, NULL),
('Candlewood Suites', 223, '2019-03-20', 264, NULL),
('Candlewood Suites', 223, '2019-03-21', 302, NULL),
('Candlewood Suites', 223, '2019-03-22', 153, NULL),
('Candlewood Suites', 223, '2019-03-23', 365, NULL),
('Candlewood Suites', 223, '2019-03-24', 371, NULL),
('Candlewood Suites', 223, '2019-03-25', 338, NULL),
('Candlewood Suites', 223, '2019-03-26', 104, NULL),
('Candlewood Suites', 223, '2019-03-27', 121, NULL),
('Candlewood Suites', 223, '2019-03-28', 243, NULL),
('Candlewood Suites', 223, '2019-03-29', 238, NULL),
('Candlewood Suites', 223, '2019-03-30', 108, NULL),
('Candlewood Suites', 223, '2019-03-31', 269, NULL),
('Candlewood Suites', 223, '2019-04-01', 119, NULL),
('Candlewood Suites', 223, '2019-04-02', 332, NULL),
('Candlewood Suites', 223, '2019-04-03', 235, NULL),
('Candlewood Suites', 223, '2019-04-04', 156, NULL),
('Candlewood Suites', 223, '2019-04-05', 227, NULL),
('Candlewood Suites', 223, '2019-04-06', 393, NULL),
('Candlewood Suites', 223, '2019-04-07', 295, NULL),
('Candlewood Suites', 223, '2019-04-08', 363, NULL),
('Candlewood Suites', 223, '2019-04-09', 316, NULL),
('Candlewood Suites', 223, '2019-04-10', 204, NULL),
('Candlewood Suites', 223, '2019-04-11', 229, NULL),
('Candlewood Suites', 223, '2019-04-12', 381, NULL),
('Candlewood Suites', 223, '2019-04-13', 260, NULL),
('Candlewood Suites', 223, '2019-04-14', 390, NULL),
('Candlewood Suites', 223, '2019-04-15', 218, NULL),
('Candlewood Suites', 223, '2019-04-16', 353, NULL),
('Candlewood Suites', 223, '2019-04-17', 165, NULL),
('Candlewood Suites', 223, '2019-04-18', 292, NULL),
('Candlewood Suites', 223, '2019-04-19', 245, NULL),
('Candlewood Suites', 223, '2019-04-20', 343, NULL),
('Candlewood Suites', 223, '2019-04-21', 181, NULL),
('Candlewood Suites', 223, '2019-04-22', 333, NULL),
('Candlewood Suites', 223, '2019-04-23', 112, NULL),
('Candlewood Suites', 223, '2019-04-24', 205, NULL),
('Candlewood Suites', 223, '2019-04-25', 126, NULL),
('Candlewood Suites', 223, '2019-04-26', 354, NULL),
('Candlewood Suites', 223, '2019-04-27', 261, NULL),
('Candlewood Suites', 223, '2019-04-28', 312, NULL),
('Candlewood Suites', 223, '2019-04-29', 120, NULL),
('Candlewood Suites', 223, '2019-04-30', 109, NULL),
('Candlewood Suites', 223, '2019-05-01', 217, NULL),
('Candlewood Suites', 223, '2019-05-02', 388, NULL),
('Candlewood Suites', 223, '2019-05-03', 236, NULL),
('Candlewood Suites', 223, '2019-05-04', 133, NULL),
('Candlewood Suites', 223, '2019-05-05', 247, NULL),
('Candlewood Suites', 223, '2019-05-06', 302, NULL),
('Candlewood Suites', 223, '2019-05-07', 191, NULL),
('Candlewood Suites', 223, '2019-05-08', 233, NULL),
('Candlewood Suites', 223, '2019-05-09', 283, NULL),
('Candlewood Suites', 223, '2019-05-10', 243, NULL),
('Candlewood Suites', 223, '2019-05-11', 241, NULL),
('Candlewood Suites', 223, '2019-05-12', 321, NULL),
('Candlewood Suites', 223, '2019-05-13', 396, NULL),
('Candlewood Suites', 223, '2019-05-14', 264, NULL),
('Candlewood Suites', 223, '2019-05-15', 270, NULL),
('Candlewood Suites', 223, '2019-05-16', 139, NULL),
('Candlewood Suites', 223, '2019-05-17', 341, NULL),
('Candlewood Suites', 223, '2019-05-18', 322, NULL),
('Candlewood Suites', 223, '2019-05-19', 269, NULL),
('Candlewood Suites', 223, '2019-05-20', 391, NULL),
('Candlewood Suites', 223, '2019-05-21', 374, NULL),
('Candlewood Suites', 223, '2019-05-22', 217, NULL),
('Candlewood Suites', 223, '2019-05-23', 335, NULL),
('Candlewood Suites', 223, '2019-05-24', 161, NULL),
('Candlewood Suites', 223, '2019-05-25', 212, NULL),
('Candlewood Suites', 223, '2019-05-26', 159, NULL),
('Candlewood Suites', 223, '2019-05-27', 289, NULL),
('Candlewood Suites', 223, '2019-05-28', 251, NULL),
('Candlewood Suites', 223, '2019-05-29', 333, NULL),
('Candlewood Suites', 223, '2019-05-30', 201, NULL),
('Candlewood Suites', 223, '2019-05-31', 218, NULL),
('Candlewood Suites', 223, '2019-06-01', 238, NULL),
('Candlewood Suites', 223, '2019-06-02', 223, NULL),
('Candlewood Suites', 223, '2019-06-03', 243, NULL),
('Candlewood Suites', 223, '2019-06-04', 212, NULL),
('Candlewood Suites', 223, '2019-06-05', 175, NULL),
('Candlewood Suites', 223, '2019-06-06', 312, NULL),
('Candlewood Suites', 223, '2019-06-07', 336, NULL),
('Candlewood Suites', 223, '2019-06-08', 197, NULL),
('Candlewood Suites', 223, '2019-06-09', 377, NULL),
('Candlewood Suites', 223, '2019-06-10', 170, NULL),
('Candlewood Suites', 223, '2019-06-11', 248, NULL),
('Candlewood Suites', 223, '2019-06-12', 379, NULL),
('Candlewood Suites', 223, '2019-06-13', 244, NULL),
('Candlewood Suites', 223, '2019-06-14', 203, NULL),
('Candlewood Suites', 223, '2019-06-15', 346, NULL),
('Candlewood Suites', 223, '2019-06-16', 138, NULL),
('Candlewood Suites', 223, '2019-06-17', 396, NULL),
('Candlewood Suites', 223, '2019-06-18', 327, NULL),
('Candlewood Suites', 223, '2019-06-19', 385, NULL),
('Candlewood Suites', 223, '2019-06-20', 398, NULL),
('Candlewood Suites', 223, '2019-06-21', 178, NULL),
('Candlewood Suites', 223, '2019-06-22', 360, NULL),
('Candlewood Suites', 223, '2019-06-23', 247, NULL),
('Candlewood Suites', 223, '2019-06-24', 293, NULL),
('Candlewood Suites', 223, '2019-06-25', 352, NULL),
('Candlewood Suites', 223, '2019-06-26', 256, NULL),
('Candlewood Suites', 223, '2019-06-27', 164, NULL),
('Candlewood Suites', 223, '2019-06-28', 298, NULL),
('Candlewood Suites', 223, '2019-06-29', 179, NULL),
('Candlewood Suites', 223, '2019-06-30', 343, NULL),
('Candlewood Suites', 223, '2019-07-01', 219, NULL),
('Candlewood Suites', 223, '2019-07-02', 183, NULL),
('Candlewood Suites', 223, '2019-07-03', 288, NULL),
('Candlewood Suites', 223, '2019-07-04', 124, NULL),
('Candlewood Suites', 223, '2019-07-05', 290, NULL),
('Candlewood Suites', 223, '2019-07-06', 294, NULL),
('Candlewood Suites', 223, '2019-07-07', 119, NULL),
('Candlewood Suites', 223, '2019-07-08', 214, NULL),
('Candlewood Suites', 223, '2019-07-09', 346, NULL),
('Candlewood Suites', 223, '2019-07-10', 143, NULL),
('Candlewood Suites', 223, '2019-07-11', 360, NULL),
('Candlewood Suites', 223, '2019-07-12', 156, NULL),
('Candlewood Suites', 223, '2019-07-13', 384, NULL),
('Candlewood Suites', 223, '2019-07-14', 209, NULL),
('Candlewood Suites', 223, '2019-07-15', 381, NULL),
('Candlewood Suites', 223, '2019-07-16', 348, NULL),
('Candlewood Suites', 223, '2019-07-17', 384, NULL),
('Candlewood Suites', 223, '2019-07-18', 392, NULL),
('Candlewood Suites', 223, '2019-07-19', 384, NULL),
('Candlewood Suites', 223, '2019-07-20', 124, NULL),
('Candlewood Suites', 223, '2019-07-21', 273, NULL),
('Candlewood Suites', 223, '2019-07-22', 207, NULL),
('Candlewood Suites', 223, '2019-07-23', 338, NULL),
('Candlewood Suites', 223, '2019-07-24', 112, NULL),
('Candlewood Suites', 223, '2019-07-25', 233, NULL),
('Candlewood Suites', 223, '2019-07-26', 242, NULL),
('Candlewood Suites', 223, '2019-07-27', 395, NULL),
('Candlewood Suites', 223, '2019-07-28', 149, NULL),
('Candlewood Suites', 223, '2019-07-29', 214, NULL),
('Candlewood Suites', 223, '2019-07-30', 226, NULL),
('Candlewood Suites', 223, '2019-07-31', 259, NULL),
('Candlewood Suites', 223, '2019-08-01', 375, NULL),
('Candlewood Suites', 223, '2019-08-02', 186, NULL),
('Candlewood Suites', 223, '2019-08-03', 212, NULL),
('Candlewood Suites', 223, '2019-08-04', 192, NULL),
('Candlewood Suites', 223, '2019-08-05', 354, NULL),
('Candlewood Suites', 223, '2019-08-06', 342, NULL),
('Candlewood Suites', 223, '2019-08-07', 388, NULL),
('Candlewood Suites', 223, '2019-08-08', 168, NULL),
('Candlewood Suites', 223, '2019-08-09', 189, NULL),
('Candlewood Suites', 223, '2019-08-10', 303, NULL),
('Candlewood Suites', 223, '2019-08-11', 249, NULL),
('Candlewood Suites', 223, '2019-08-12', 326, NULL),
('Candlewood Suites', 223, '2019-08-13', 390, NULL),
('Candlewood Suites', 223, '2019-08-14', 327, NULL),
('Candlewood Suites', 223, '2019-08-15', 100, NULL),
('Candlewood Suites', 223, '2019-08-16', 170, NULL),
('Candlewood Suites', 223, '2019-08-17', 114, NULL),
('Candlewood Suites', 223, '2019-08-18', 153, NULL),
('Candlewood Suites', 223, '2019-08-19', 128, NULL),
('Candlewood Suites', 223, '2019-08-20', 153, NULL),
('Candlewood Suites', 223, '2019-08-21', 264, NULL),
('Candlewood Suites', 223, '2019-08-22', 110, NULL),
('Candlewood Suites', 223, '2019-08-23', 243, NULL),
('Candlewood Suites', 223, '2019-08-24', 307, NULL),
('Candlewood Suites', 223, '2019-08-25', 149, NULL),
('Candlewood Suites', 223, '2019-08-26', 218, NULL),
('Candlewood Suites', 223, '2019-08-27', 375, NULL),
('Candlewood Suites', 223, '2019-08-28', 299, NULL),
('Candlewood Suites', 223, '2019-08-29', 115, NULL),
('Candlewood Suites', 223, '2019-08-30', 236, NULL),
('Candlewood Suites', 223, '2019-08-31', 156, NULL),
('Candlewood Suites', 223, '2019-09-01', 237, NULL),
('Candlewood Suites', 223, '2019-09-02', 379, NULL),
('Candlewood Suites', 223, '2019-09-03', 110, NULL),
('Candlewood Suites', 223, '2019-09-04', 390, NULL),
('Candlewood Suites', 223, '2019-09-05', 177, NULL),
('Candlewood Suites', 223, '2019-09-06', 193, NULL),
('Candlewood Suites', 223, '2019-09-07', 126, NULL),
('Candlewood Suites', 223, '2019-09-08', 128, NULL),
('Candlewood Suites', 223, '2019-09-09', 174, NULL),
('Candlewood Suites', 223, '2019-09-10', 313, NULL),
('Candlewood Suites', 223, '2019-09-11', 135, NULL),
('Candlewood Suites', 223, '2019-09-12', 132, NULL),
('Candlewood Suites', 223, '2019-09-13', 309, NULL),
('Candlewood Suites', 223, '2019-09-14', 393, NULL),
('Candlewood Suites', 223, '2019-09-15', 309, NULL),
('Candlewood Suites', 223, '2019-09-16', 254, NULL),
('Candlewood Suites', 223, '2019-09-17', 381, NULL),
('Candlewood Suites', 223, '2019-09-18', 395, NULL),
('Candlewood Suites', 223, '2019-09-19', 125, NULL),
('Candlewood Suites', 223, '2019-09-20', 182, NULL),
('Candlewood Suites', 223, '2019-09-21', 371, NULL),
('Candlewood Suites', 223, '2019-09-22', 308, NULL),
('Candlewood Suites', 223, '2019-09-23', 292, NULL),
('Candlewood Suites', 223, '2019-09-24', 141, NULL),
('Candlewood Suites', 223, '2019-09-25', 343, NULL),
('Candlewood Suites', 223, '2019-09-26', 371, NULL),
('Candlewood Suites', 223, '2019-09-27', 215, NULL),
('Candlewood Suites', 223, '2019-09-28', 276, NULL),
('Candlewood Suites', 223, '2019-09-29', 395, NULL),
('Candlewood Suites', 223, '2019-09-30', 250, NULL),
('Candlewood Suites', 223, '2019-10-01', 222, NULL),
('Candlewood Suites', 223, '2019-10-02', 192, NULL),
('Candlewood Suites', 223, '2019-10-03', 369, NULL),
('Candlewood Suites', 223, '2019-10-04', 301, NULL),
('Candlewood Suites', 223, '2019-10-05', 253, NULL),
('Candlewood Suites', 223, '2019-10-06', 280, NULL),
('Candlewood Suites', 223, '2019-10-07', 121, NULL),
('Candlewood Suites', 223, '2019-10-08', 282, NULL),
('Candlewood Suites', 223, '2019-10-09', 184, NULL),
('Candlewood Suites', 223, '2019-10-10', 294, NULL),
('Candlewood Suites', 223, '2019-10-11', 212, NULL),
('Candlewood Suites', 223, '2019-10-12', 353, NULL),
('Candlewood Suites', 223, '2019-10-13', 321, NULL),
('Candlewood Suites', 223, '2019-10-14', 385, NULL),
('Candlewood Suites', 223, '2019-10-15', 127, NULL),
('Candlewood Suites', 223, '2019-10-16', 379, NULL),
('Candlewood Suites', 223, '2019-10-17', 332, NULL),
('Candlewood Suites', 223, '2019-10-18', 150, NULL),
('Candlewood Suites', 223, '2019-10-19', 139, NULL),
('Candlewood Suites', 223, '2019-10-20', 285, NULL),
('Candlewood Suites', 223, '2019-10-21', 214, NULL),
('Candlewood Suites', 223, '2019-10-22', 396, NULL),
('Candlewood Suites', 223, '2019-10-23', 227, NULL),
('Candlewood Suites', 223, '2019-10-24', 183, NULL),
('Candlewood Suites', 223, '2019-10-25', 349, NULL),
('Candlewood Suites', 223, '2019-10-26', 334, NULL),
('Candlewood Suites', 223, '2019-10-27', 364, NULL),
('Candlewood Suites', 223, '2019-10-28', 292, NULL),
('Candlewood Suites', 223, '2019-10-29', 384, NULL),
('Candlewood Suites', 223, '2019-10-30', 369, NULL),
('Candlewood Suites', 223, '2019-10-31', 206, NULL),
('Candlewood Suites', 223, '2019-11-01', 115, NULL),
('Candlewood Suites', 223, '2019-11-02', 317, NULL),
('Candlewood Suites', 223, '2019-11-03', 231, NULL),
('Candlewood Suites', 223, '2019-11-04', 132, NULL),
('Candlewood Suites', 223, '2019-11-05', 384, NULL),
('Candlewood Suites', 223, '2019-11-06', 149, NULL),
('Candlewood Suites', 223, '2019-11-07', 334, NULL),
('Candlewood Suites', 223, '2019-11-08', 163, NULL),
('Candlewood Suites', 223, '2019-11-09', 323, NULL),
('Candlewood Suites', 223, '2019-11-10', 243, NULL),
('Candlewood Suites', 223, '2019-11-11', 214, NULL),
('Candlewood Suites', 223, '2019-11-12', 249, NULL),
('Candlewood Suites', 223, '2019-11-13', 241, NULL),
('Candlewood Suites', 223, '2019-11-14', 230, NULL),
('Candlewood Suites', 223, '2019-11-15', 127, NULL),
('Candlewood Suites', 223, '2019-11-16', 139, NULL),
('Candlewood Suites', 223, '2019-11-17', 358, NULL),
('Candlewood Suites', 223, '2019-11-18', 358, NULL),
('Candlewood Suites', 223, '2019-11-19', 169, NULL),
('Candlewood Suites', 223, '2019-11-20', 387, NULL),
('Candlewood Suites', 223, '2019-11-21', 351, NULL),
('Candlewood Suites', 223, '2019-11-22', 170, NULL),
('Candlewood Suites', 223, '2019-11-23', 327, NULL),
('Candlewood Suites', 223, '2019-11-24', 391, NULL),
('Candlewood Suites', 223, '2019-11-25', 369, NULL),
('Candlewood Suites', 223, '2019-11-26', 226, NULL),
('Candlewood Suites', 223, '2019-11-27', 296, NULL),
('Candlewood Suites', 223, '2019-11-28', 345, NULL),
('Candlewood Suites', 223, '2019-11-29', 239, NULL),
('Candlewood Suites', 223, '2019-11-30', 263, NULL),
('Candlewood Suites', 223, '2019-12-01', 105, NULL),
('Candlewood Suites', 223, '2019-12-02', 215, NULL),
('Candlewood Suites', 223, '2019-12-03', 307, NULL),
('Candlewood Suites', 223, '2019-12-04', 312, NULL),
('Candlewood Suites', 223, '2019-12-05', 394, NULL),
('Candlewood Suites', 223, '2019-12-06', 220, NULL),
('Candlewood Suites', 223, '2019-12-07', 110, NULL),
('Candlewood Suites', 223, '2019-12-08', 113, NULL),
('Candlewood Suites', 223, '2019-12-09', 362, NULL),
('Candlewood Suites', 223, '2019-12-10', 230, NULL),
('Candlewood Suites', 223, '2019-12-11', 345, NULL),
('Candlewood Suites', 223, '2019-12-12', 152, NULL),
('Candlewood Suites', 223, '2019-12-13', 260, NULL),
('Candlewood Suites', 223, '2019-12-14', 382, NULL),
('Candlewood Suites', 223, '2019-12-15', 233, NULL),
('Candlewood Suites', 223, '2019-12-16', 104, NULL),
('Candlewood Suites', 223, '2019-12-17', 105, NULL),
('Candlewood Suites', 223, '2019-12-18', 166, NULL),
('Candlewood Suites', 223, '2019-12-19', 108, NULL),
('Candlewood Suites', 223, '2019-12-20', 302, NULL),
('Candlewood Suites', 223, '2019-12-21', 144, NULL),
('Candlewood Suites', 223, '2019-12-22', 102, NULL),
('Candlewood Suites', 223, '2019-12-23', 362, NULL),
('Candlewood Suites', 223, '2019-12-24', 192, NULL),
('Candlewood Suites', 223, '2019-12-25', 395, NULL),
('Candlewood Suites', 223, '2019-12-26', 241, NULL),
('Candlewood Suites', 223, '2019-12-27', 163, NULL),
('Candlewood Suites', 223, '2019-12-28', 375, NULL),
('Candlewood Suites', 223, '2019-12-29', 311, NULL),
('Candlewood Suites', 223, '2019-12-30', 181, NULL),
('Candlewood Suites', 223, '2019-12-31', 259, NULL),
('Candlewood Suites', 223, '2020-01-01', 156, NULL),
('Candlewood Suites', 223, '2020-01-02', 336, NULL),
('Candlewood Suites', 223, '2020-01-03', 141, NULL),
('Candlewood Suites', 223, '2020-01-04', 336, NULL),
('Candlewood Suites', 223, '2020-01-05', 390, NULL),
('Candlewood Suites', 223, '2020-01-06', 191, NULL),
('Candlewood Suites', 223, '2020-01-07', 263, NULL),
('Candlewood Suites', 223, '2020-01-08', 327, NULL),
('Candlewood Suites', 223, '2020-01-09', 129, NULL),
('Candlewood Suites', 223, '2020-01-10', 185, NULL),
('Candlewood Suites', 223, '2020-01-11', 269, NULL),
('Candlewood Suites', 223, '2020-01-12', 284, NULL),
('Candlewood Suites', 223, '2020-01-13', 167, NULL),
('Candlewood Suites', 223, '2020-01-14', 239, NULL),
('Candlewood Suites', 223, '2020-01-15', 304, NULL),
('Candlewood Suites', 223, '2020-01-16', 220, NULL),
('Candlewood Suites', 223, '2020-01-17', 359, NULL),
('Candlewood Suites', 223, '2020-01-18', 253, NULL),
('Candlewood Suites', 223, '2020-01-19', 268, NULL),
('Candlewood Suites', 223, '2020-01-20', 224, NULL),
('Candlewood Suites', 223, '2020-01-21', 242, NULL),
('Candlewood Suites', 223, '2020-01-22', 321, NULL),
('Candlewood Suites', 223, '2020-01-23', 333, NULL),
('Candlewood Suites', 223, '2020-01-24', 326, NULL),
('Candlewood Suites', 223, '2020-01-25', 350, NULL),
('Candlewood Suites', 223, '2020-01-26', 118, NULL),
('Candlewood Suites', 223, '2020-01-27', 304, NULL),
('Candlewood Suites', 223, '2020-01-28', 191, NULL),
('Candlewood Suites', 223, '2020-01-29', 143, NULL),
('Candlewood Suites', 223, '2020-01-30', 321, NULL),
('Candlewood Suites', 223, '2020-01-31', 158, NULL),
('Candlewood Suites', 223, '2020-02-01', 205, NULL),
('Candlewood Suites', 223, '2020-02-02', 277, NULL),
('Candlewood Suites', 223, '2020-02-03', 396, NULL),
('Candlewood Suites', 223, '2020-02-04', 224, NULL),
('Candlewood Suites', 234, '2019-01-01', 157, NULL),
('Candlewood Suites', 234, '2019-01-02', 303, NULL),
('Candlewood Suites', 234, '2019-01-03', 122, NULL),
('Candlewood Suites', 234, '2019-01-04', 362, NULL),
('Candlewood Suites', 234, '2019-01-05', 164, NULL),
('Candlewood Suites', 234, '2019-01-06', 279, NULL),
('Candlewood Suites', 234, '2019-01-07', 103, NULL),
('Candlewood Suites', 234, '2019-01-08', 149, NULL),
('Candlewood Suites', 234, '2019-01-09', 248, NULL),
('Candlewood Suites', 234, '2019-01-10', 344, NULL),
('Candlewood Suites', 234, '2019-01-11', 362, NULL),
('Candlewood Suites', 234, '2019-01-12', 121, NULL),
('Candlewood Suites', 234, '2019-01-13', 398, NULL),
('Candlewood Suites', 234, '2019-01-14', 379, NULL),
('Candlewood Suites', 234, '2019-01-15', 144, NULL),
('Candlewood Suites', 234, '2019-01-16', 115, NULL),
('Candlewood Suites', 234, '2019-01-17', 321, NULL),
('Candlewood Suites', 234, '2019-01-18', 101, NULL),
('Candlewood Suites', 234, '2019-01-19', 188, NULL),
('Candlewood Suites', 234, '2019-01-20', 397, NULL),
('Candlewood Suites', 234, '2019-01-21', 384, NULL),
('Candlewood Suites', 234, '2019-01-22', 290, NULL),
('Candlewood Suites', 234, '2019-01-23', 396, NULL),
('Candlewood Suites', 234, '2019-01-24', 310, NULL),
('Candlewood Suites', 234, '2019-01-25', 128, NULL),
('Candlewood Suites', 234, '2019-01-26', 243, NULL),
('Candlewood Suites', 234, '2019-01-27', 399, NULL),
('Candlewood Suites', 234, '2019-01-28', 211, NULL),
('Candlewood Suites', 234, '2019-01-29', 333, NULL),
('Candlewood Suites', 234, '2019-01-30', 121, NULL),
('Candlewood Suites', 234, '2019-01-31', 183, NULL),
('Candlewood Suites', 234, '2019-02-01', 360, NULL),
('Candlewood Suites', 234, '2019-02-02', 142, NULL),
('Candlewood Suites', 234, '2019-02-03', 393, NULL),
('Candlewood Suites', 234, '2019-02-04', 182, NULL),
('Candlewood Suites', 234, '2019-02-05', 288, NULL),
('Candlewood Suites', 234, '2019-02-06', 184, NULL),
('Candlewood Suites', 234, '2019-02-07', 382, NULL),
('Candlewood Suites', 234, '2019-02-08', 305, NULL),
('Candlewood Suites', 234, '2019-02-09', 213, NULL),
('Candlewood Suites', 234, '2019-02-10', 203, NULL),
('Candlewood Suites', 234, '2019-02-11', 171, NULL),
('Candlewood Suites', 234, '2019-02-12', 395, NULL),
('Candlewood Suites', 234, '2019-02-13', 127, NULL),
('Candlewood Suites', 234, '2019-02-14', 365, NULL),
('Candlewood Suites', 234, '2019-02-15', 211, NULL),
('Candlewood Suites', 234, '2019-02-16', 114, NULL),
('Candlewood Suites', 234, '2019-02-17', 120, NULL),
('Candlewood Suites', 234, '2019-02-18', 326, NULL),
('Candlewood Suites', 234, '2019-02-19', 223, NULL),
('Candlewood Suites', 234, '2019-02-20', 307, NULL),
('Candlewood Suites', 234, '2019-02-21', 245, NULL),
('Candlewood Suites', 234, '2019-02-22', 127, NULL),
('Candlewood Suites', 234, '2019-02-23', 168, NULL),
('Candlewood Suites', 234, '2019-02-24', 312, NULL),
('Candlewood Suites', 234, '2019-02-25', 165, NULL),
('Candlewood Suites', 234, '2019-02-26', 167, NULL),
('Candlewood Suites', 234, '2019-02-27', 363, NULL),
('Candlewood Suites', 234, '2019-02-28', 196, NULL),
('Candlewood Suites', 234, '2019-03-01', 191, NULL),
('Candlewood Suites', 234, '2019-03-02', 233, NULL),
('Candlewood Suites', 234, '2019-03-03', 168, NULL),
('Candlewood Suites', 234, '2019-03-04', 241, NULL),
('Candlewood Suites', 234, '2019-03-05', 235, NULL),
('Candlewood Suites', 234, '2019-03-06', 358, NULL),
('Candlewood Suites', 234, '2019-03-07', 316, NULL),
('Candlewood Suites', 234, '2019-03-08', 290, NULL),
('Candlewood Suites', 234, '2019-03-09', 254, NULL),
('Candlewood Suites', 234, '2019-03-10', 285, NULL),
('Candlewood Suites', 234, '2019-03-11', 180, NULL),
('Candlewood Suites', 234, '2019-03-12', 293, NULL),
('Candlewood Suites', 234, '2019-03-13', 349, NULL),
('Candlewood Suites', 234, '2019-03-14', 218, NULL),
('Candlewood Suites', 234, '2019-03-15', 213, NULL),
('Candlewood Suites', 234, '2019-03-16', 313, NULL),
('Candlewood Suites', 234, '2019-03-17', 301, NULL),
('Candlewood Suites', 234, '2019-03-18', 126, NULL),
('Candlewood Suites', 234, '2019-03-19', 105, NULL),
('Candlewood Suites', 234, '2019-03-20', 218, NULL),
('Candlewood Suites', 234, '2019-03-21', 119, NULL),
('Candlewood Suites', 234, '2019-03-22', 241, NULL),
('Candlewood Suites', 234, '2019-03-23', 188, NULL),
('Candlewood Suites', 234, '2019-03-24', 186, NULL),
('Candlewood Suites', 234, '2019-03-25', 343, NULL),
('Candlewood Suites', 234, '2019-03-26', 350, NULL),
('Candlewood Suites', 234, '2019-03-27', 199, NULL),
('Candlewood Suites', 234, '2019-03-28', 170, NULL),
('Candlewood Suites', 234, '2019-03-29', 199, NULL),
('Candlewood Suites', 234, '2019-03-30', 347, NULL),
('Candlewood Suites', 234, '2019-03-31', 385, NULL),
('Candlewood Suites', 234, '2019-04-01', 311, NULL),
('Candlewood Suites', 234, '2019-04-02', 340, NULL),
('Candlewood Suites', 234, '2019-04-03', 212, NULL),
('Candlewood Suites', 234, '2019-04-04', 344, NULL),
('Candlewood Suites', 234, '2019-04-05', 292, NULL),
('Candlewood Suites', 234, '2019-04-06', 395, NULL),
('Candlewood Suites', 234, '2019-04-07', 240, NULL),
('Candlewood Suites', 234, '2019-04-08', 279, NULL),
('Candlewood Suites', 234, '2019-04-09', 163, NULL),
('Candlewood Suites', 234, '2019-04-10', 353, NULL),
('Candlewood Suites', 234, '2019-04-11', 271, NULL),
('Candlewood Suites', 234, '2019-04-12', 111, NULL),
('Candlewood Suites', 234, '2019-04-13', 365, NULL),
('Candlewood Suites', 234, '2019-04-14', 200, NULL),
('Candlewood Suites', 234, '2019-04-15', 389, NULL),
('Candlewood Suites', 234, '2019-04-16', 206, NULL),
('Candlewood Suites', 234, '2019-04-17', 167, NULL),
('Candlewood Suites', 234, '2019-04-18', 315, NULL),
('Candlewood Suites', 234, '2019-04-19', 108, NULL),
('Candlewood Suites', 234, '2019-04-20', 242, NULL),
('Candlewood Suites', 234, '2019-04-21', 364, NULL),
('Candlewood Suites', 234, '2019-04-22', 204, NULL),
('Candlewood Suites', 234, '2019-04-23', 119, NULL),
('Candlewood Suites', 234, '2019-04-24', 312, NULL),
('Candlewood Suites', 234, '2019-04-25', 157, NULL),
('Candlewood Suites', 234, '2019-04-26', 266, NULL),
('Candlewood Suites', 234, '2019-04-27', 251, NULL),
('Candlewood Suites', 234, '2019-04-28', 126, NULL),
('Candlewood Suites', 234, '2019-04-29', 212, NULL),
('Candlewood Suites', 234, '2019-04-30', 361, NULL),
('Candlewood Suites', 234, '2019-05-01', 157, NULL),
('Candlewood Suites', 234, '2019-05-02', 165, NULL),
('Candlewood Suites', 234, '2019-05-03', 150, NULL),
('Candlewood Suites', 234, '2019-05-04', 178, NULL),
('Candlewood Suites', 234, '2019-05-05', 170, NULL),
('Candlewood Suites', 234, '2019-05-06', 362, NULL),
('Candlewood Suites', 234, '2019-05-07', 161, NULL),
('Candlewood Suites', 234, '2019-05-08', 303, NULL),
('Candlewood Suites', 234, '2019-05-09', 342, NULL),
('Candlewood Suites', 234, '2019-05-10', 118, NULL),
('Candlewood Suites', 234, '2019-05-11', 118, NULL),
('Candlewood Suites', 234, '2019-05-12', 327, NULL),
('Candlewood Suites', 234, '2019-05-13', 344, NULL),
('Candlewood Suites', 234, '2019-05-14', 181, NULL),
('Candlewood Suites', 234, '2019-05-15', 293, NULL),
('Candlewood Suites', 234, '2019-05-16', 371, NULL),
('Candlewood Suites', 234, '2019-05-17', 364, NULL),
('Candlewood Suites', 234, '2019-05-18', 378, NULL),
('Candlewood Suites', 234, '2019-05-19', 140, NULL),
('Candlewood Suites', 234, '2019-05-20', 153, NULL),
('Candlewood Suites', 234, '2019-05-21', 307, NULL),
('Candlewood Suites', 234, '2019-05-22', 318, NULL),
('Candlewood Suites', 234, '2019-05-23', 252, NULL),
('Candlewood Suites', 234, '2019-05-24', 243, NULL),
('Candlewood Suites', 234, '2019-05-25', 167, NULL),
('Candlewood Suites', 234, '2019-05-26', 273, NULL),
('Candlewood Suites', 234, '2019-05-27', 349, NULL),
('Candlewood Suites', 234, '2019-05-28', 133, NULL),
('Candlewood Suites', 234, '2019-05-29', 224, NULL),
('Candlewood Suites', 234, '2019-05-30', 109, NULL),
('Candlewood Suites', 234, '2019-05-31', 258, NULL),
('Candlewood Suites', 234, '2019-06-01', 116, NULL),
('Candlewood Suites', 234, '2019-06-02', 222, NULL),
('Candlewood Suites', 234, '2019-06-03', 154, NULL),
('Candlewood Suites', 234, '2019-06-04', 348, NULL),
('Candlewood Suites', 234, '2019-06-05', 151, NULL),
('Candlewood Suites', 234, '2019-06-06', 375, NULL),
('Candlewood Suites', 234, '2019-06-07', 260, NULL),
('Candlewood Suites', 234, '2019-06-08', 294, NULL),
('Candlewood Suites', 234, '2019-06-09', 273, NULL),
('Candlewood Suites', 234, '2019-06-10', 288, NULL),
('Candlewood Suites', 234, '2019-06-11', 188, NULL),
('Candlewood Suites', 234, '2019-06-12', 371, NULL),
('Candlewood Suites', 234, '2019-06-13', 299, NULL),
('Candlewood Suites', 234, '2019-06-14', 222, NULL),
('Candlewood Suites', 234, '2019-06-15', 208, NULL),
('Candlewood Suites', 234, '2019-06-16', 323, NULL),
('Candlewood Suites', 234, '2019-06-17', 279, NULL),
('Candlewood Suites', 234, '2019-06-18', 193, NULL),
('Candlewood Suites', 234, '2019-06-19', 332, NULL),
('Candlewood Suites', 234, '2019-06-20', 231, NULL),
('Candlewood Suites', 234, '2019-06-21', 216, NULL),
('Candlewood Suites', 234, '2019-06-22', 370, NULL),
('Candlewood Suites', 234, '2019-06-23', 178, NULL),
('Candlewood Suites', 234, '2019-06-24', 365, NULL),
('Candlewood Suites', 234, '2019-06-25', 351, NULL),
('Candlewood Suites', 234, '2019-06-26', 247, NULL),
('Candlewood Suites', 234, '2019-06-27', 329, NULL),
('Candlewood Suites', 234, '2019-06-28', 193, NULL),
('Candlewood Suites', 234, '2019-06-29', 399, NULL),
('Candlewood Suites', 234, '2019-06-30', 362, NULL),
('Candlewood Suites', 234, '2019-07-01', 337, NULL),
('Candlewood Suites', 234, '2019-07-02', 212, NULL),
('Candlewood Suites', 234, '2019-07-03', 169, NULL),
('Candlewood Suites', 234, '2019-07-04', 350, NULL),
('Candlewood Suites', 234, '2019-07-05', 192, NULL),
('Candlewood Suites', 234, '2019-07-06', 275, NULL),
('Candlewood Suites', 234, '2019-07-07', 211, NULL),
('Candlewood Suites', 234, '2019-07-08', 347, NULL),
('Candlewood Suites', 234, '2019-07-09', 259, NULL),
('Candlewood Suites', 234, '2019-07-10', 246, NULL),
('Candlewood Suites', 234, '2019-07-11', 397, NULL),
('Candlewood Suites', 234, '2019-07-12', 302, NULL),
('Candlewood Suites', 234, '2019-07-13', 276, NULL),
('Candlewood Suites', 234, '2019-07-14', 143, NULL),
('Candlewood Suites', 234, '2019-07-15', 125, NULL),
('Candlewood Suites', 234, '2019-07-16', 222, NULL),
('Candlewood Suites', 234, '2019-07-17', 291, NULL),
('Candlewood Suites', 234, '2019-07-18', 124, NULL),
('Candlewood Suites', 234, '2019-07-19', 174, NULL),
('Candlewood Suites', 234, '2019-07-20', 273, NULL),
('Candlewood Suites', 234, '2019-07-21', 279, NULL),
('Candlewood Suites', 234, '2019-07-22', 263, NULL),
('Candlewood Suites', 234, '2019-07-23', 327, NULL),
('Candlewood Suites', 234, '2019-07-24', 394, NULL),
('Candlewood Suites', 234, '2019-07-25', 209, NULL),
('Candlewood Suites', 234, '2019-07-26', 361, NULL),
('Candlewood Suites', 234, '2019-07-27', 280, NULL),
('Candlewood Suites', 234, '2019-07-28', 233, NULL),
('Candlewood Suites', 234, '2019-07-29', 311, NULL),
('Candlewood Suites', 234, '2019-07-30', 195, NULL),
('Candlewood Suites', 234, '2019-07-31', 109, NULL),
('Candlewood Suites', 234, '2019-08-01', 220, NULL),
('Candlewood Suites', 234, '2019-08-02', 325, NULL),
('Candlewood Suites', 234, '2019-08-03', 399, NULL),
('Candlewood Suites', 234, '2019-08-04', 225, NULL),
('Candlewood Suites', 234, '2019-08-05', 270, NULL),
('Candlewood Suites', 234, '2019-08-06', 210, NULL),
('Candlewood Suites', 234, '2019-08-07', 178, NULL),
('Candlewood Suites', 234, '2019-08-08', 151, NULL),
('Candlewood Suites', 234, '2019-08-09', 139, NULL),
('Candlewood Suites', 234, '2019-08-10', 292, NULL),
('Candlewood Suites', 234, '2019-08-11', 188, NULL),
('Candlewood Suites', 234, '2019-08-12', 105, NULL),
('Candlewood Suites', 234, '2019-08-13', 341, NULL),
('Candlewood Suites', 234, '2019-08-14', 357, NULL),
('Candlewood Suites', 234, '2019-08-15', 157, NULL),
('Candlewood Suites', 234, '2019-08-16', 237, NULL),
('Candlewood Suites', 234, '2019-08-17', 282, NULL),
('Candlewood Suites', 234, '2019-08-18', 189, NULL),
('Candlewood Suites', 234, '2019-08-19', 142, NULL),
('Candlewood Suites', 234, '2019-08-20', 232, NULL),
('Candlewood Suites', 234, '2019-08-21', 337, NULL),
('Candlewood Suites', 234, '2019-08-22', 321, NULL),
('Candlewood Suites', 234, '2019-08-23', 183, NULL),
('Candlewood Suites', 234, '2019-08-24', 329, NULL),
('Candlewood Suites', 234, '2019-08-25', 199, NULL),
('Candlewood Suites', 234, '2019-08-26', 136, NULL),
('Candlewood Suites', 234, '2019-08-27', 159, NULL),
('Candlewood Suites', 234, '2019-08-28', 322, NULL),
('Candlewood Suites', 234, '2019-08-29', 207, NULL),
('Candlewood Suites', 234, '2019-08-30', 158, NULL),
('Candlewood Suites', 234, '2019-08-31', 381, NULL),
('Candlewood Suites', 234, '2019-09-01', 374, NULL),
('Candlewood Suites', 234, '2019-09-02', 165, NULL),
('Candlewood Suites', 234, '2019-09-03', 136, NULL),
('Candlewood Suites', 234, '2019-09-04', 250, NULL),
('Candlewood Suites', 234, '2019-09-05', 123, NULL),
('Candlewood Suites', 234, '2019-09-06', 298, NULL),
('Candlewood Suites', 234, '2019-09-07', 375, NULL),
('Candlewood Suites', 234, '2019-09-08', 132, NULL),
('Candlewood Suites', 234, '2019-09-09', 225, NULL),
('Candlewood Suites', 234, '2019-09-10', 218, NULL),
('Candlewood Suites', 234, '2019-09-11', 396, NULL),
('Candlewood Suites', 234, '2019-09-12', 241, NULL),
('Candlewood Suites', 234, '2019-09-13', 157, NULL),
('Candlewood Suites', 234, '2019-09-14', 324, NULL),
('Candlewood Suites', 234, '2019-09-15', 211, NULL),
('Candlewood Suites', 234, '2019-09-16', 340, NULL),
('Candlewood Suites', 234, '2019-09-17', 214, NULL),
('Candlewood Suites', 234, '2019-09-18', 154, NULL),
('Candlewood Suites', 234, '2019-09-19', 329, NULL),
('Candlewood Suites', 234, '2019-09-20', 251, NULL),
('Candlewood Suites', 234, '2019-09-21', 374, NULL),
('Candlewood Suites', 234, '2019-09-22', 338, NULL),
('Candlewood Suites', 234, '2019-09-23', 374, NULL),
('Candlewood Suites', 234, '2019-09-24', 317, NULL),
('Candlewood Suites', 234, '2019-09-25', 155, NULL),
('Candlewood Suites', 234, '2019-09-26', 323, NULL),
('Candlewood Suites', 234, '2019-09-27', 255, NULL),
('Candlewood Suites', 234, '2019-09-28', 242, NULL),
('Candlewood Suites', 234, '2019-09-29', 140, NULL),
('Candlewood Suites', 234, '2019-09-30', 230, NULL),
('Candlewood Suites', 234, '2019-10-01', 149, NULL),
('Candlewood Suites', 234, '2019-10-02', 293, NULL),
('Candlewood Suites', 234, '2019-10-03', 352, NULL),
('Candlewood Suites', 234, '2019-10-04', 307, NULL),
('Candlewood Suites', 234, '2019-10-05', 270, NULL),
('Candlewood Suites', 234, '2019-10-06', 333, NULL),
('Candlewood Suites', 234, '2019-10-07', 249, NULL),
('Candlewood Suites', 234, '2019-10-08', 121, NULL),
('Candlewood Suites', 234, '2019-10-09', 156, NULL),
('Candlewood Suites', 234, '2019-10-10', 103, NULL),
('Candlewood Suites', 234, '2019-10-11', 399, NULL),
('Candlewood Suites', 234, '2019-10-12', 335, NULL),
('Candlewood Suites', 234, '2019-10-13', 238, NULL),
('Candlewood Suites', 234, '2019-10-14', 219, NULL),
('Candlewood Suites', 234, '2019-10-15', 169, NULL),
('Candlewood Suites', 234, '2019-10-16', 364, NULL),
('Candlewood Suites', 234, '2019-10-17', 181, NULL),
('Candlewood Suites', 234, '2019-10-18', 280, NULL),
('Candlewood Suites', 234, '2019-10-19', 109, NULL),
('Candlewood Suites', 234, '2019-10-20', 347, NULL),
('Candlewood Suites', 234, '2019-10-21', 314, NULL),
('Candlewood Suites', 234, '2019-10-22', 259, NULL),
('Candlewood Suites', 234, '2019-10-23', 198, NULL),
('Candlewood Suites', 234, '2019-10-24', 245, NULL),
('Candlewood Suites', 234, '2019-10-25', 179, NULL),
('Candlewood Suites', 234, '2019-10-26', 295, NULL),
('Candlewood Suites', 234, '2019-10-27', 353, NULL),
('Candlewood Suites', 234, '2019-10-28', 154, NULL),
('Candlewood Suites', 234, '2019-10-29', 396, NULL),
('Candlewood Suites', 234, '2019-10-30', 133, NULL),
('Candlewood Suites', 234, '2019-10-31', 265, NULL),
('Candlewood Suites', 234, '2019-11-01', 391, NULL),
('Candlewood Suites', 234, '2019-11-02', 259, NULL),
('Candlewood Suites', 234, '2019-11-03', 348, NULL),
('Candlewood Suites', 234, '2019-11-04', 382, NULL),
('Candlewood Suites', 234, '2019-11-05', 328, NULL),
('Candlewood Suites', 234, '2019-11-06', 326, NULL),
('Candlewood Suites', 234, '2019-11-07', 227, NULL),
('Candlewood Suites', 234, '2019-11-08', 353, NULL),
('Candlewood Suites', 234, '2019-11-09', 333, NULL),
('Candlewood Suites', 234, '2019-11-10', 230, NULL),
('Candlewood Suites', 234, '2019-11-11', 196, NULL),
('Candlewood Suites', 234, '2019-11-12', 338, NULL),
('Candlewood Suites', 234, '2019-11-13', 212, NULL),
('Candlewood Suites', 234, '2019-11-14', 314, NULL),
('Candlewood Suites', 234, '2019-11-15', 158, NULL),
('Candlewood Suites', 234, '2019-11-16', 163, NULL),
('Candlewood Suites', 234, '2019-11-17', 339, NULL),
('Candlewood Suites', 234, '2019-11-18', 361, NULL),
('Candlewood Suites', 234, '2019-11-19', 300, NULL),
('Candlewood Suites', 234, '2019-11-20', 397, NULL),
('Candlewood Suites', 234, '2019-11-21', 154, NULL),
('Candlewood Suites', 234, '2019-11-22', 276, NULL),
('Candlewood Suites', 234, '2019-11-23', 255, NULL),
('Candlewood Suites', 234, '2019-11-24', 388, NULL),
('Candlewood Suites', 234, '2019-11-25', 354, NULL),
('Candlewood Suites', 234, '2019-11-26', 289, NULL),
('Candlewood Suites', 234, '2019-11-27', 323, NULL),
('Candlewood Suites', 234, '2019-11-28', 322, NULL),
('Candlewood Suites', 234, '2019-11-29', 102, NULL),
('Candlewood Suites', 234, '2019-11-30', 355, NULL),
('Candlewood Suites', 234, '2019-12-01', 398, NULL),
('Candlewood Suites', 234, '2019-12-02', 310, NULL),
('Candlewood Suites', 234, '2019-12-03', 241, NULL),
('Candlewood Suites', 234, '2019-12-04', 205, NULL),
('Candlewood Suites', 234, '2019-12-05', 386, NULL),
('Candlewood Suites', 234, '2019-12-06', 225, NULL),
('Candlewood Suites', 234, '2019-12-07', 362, NULL),
('Candlewood Suites', 234, '2019-12-08', 211, NULL),
('Candlewood Suites', 234, '2019-12-09', 229, NULL),
('Candlewood Suites', 234, '2019-12-10', 193, NULL),
('Candlewood Suites', 234, '2019-12-11', 145, NULL),
('Candlewood Suites', 234, '2019-12-12', 368, NULL),
('Candlewood Suites', 234, '2019-12-13', 243, NULL),
('Candlewood Suites', 234, '2019-12-14', 109, NULL),
('Candlewood Suites', 234, '2019-12-15', 344, NULL),
('Candlewood Suites', 234, '2019-12-16', 257, NULL),
('Candlewood Suites', 234, '2019-12-17', 236, NULL),
('Candlewood Suites', 234, '2019-12-18', 359, NULL),
('Candlewood Suites', 234, '2019-12-19', 300, NULL),
('Candlewood Suites', 234, '2019-12-20', 290, NULL),
('Candlewood Suites', 234, '2019-12-21', 387, NULL),
('Candlewood Suites', 234, '2019-12-22', 346, NULL),
('Candlewood Suites', 234, '2019-12-23', 152, NULL),
('Candlewood Suites', 234, '2019-12-24', 274, NULL),
('Candlewood Suites', 234, '2019-12-25', 355, NULL),
('Candlewood Suites', 234, '2019-12-26', 201, NULL),
('Candlewood Suites', 234, '2019-12-27', 156, NULL),
('Candlewood Suites', 234, '2019-12-28', 343, NULL),
('Candlewood Suites', 234, '2019-12-29', 361, NULL),
('Candlewood Suites', 234, '2019-12-30', 222, NULL),
('Candlewood Suites', 234, '2019-12-31', 353, NULL),
('Candlewood Suites', 234, '2020-01-01', 102, NULL),
('Candlewood Suites', 234, '2020-01-02', 163, NULL),
('Candlewood Suites', 234, '2020-01-03', 379, NULL),
('Candlewood Suites', 234, '2020-01-04', 263, NULL),
('Candlewood Suites', 234, '2020-01-05', 135, NULL),
('Candlewood Suites', 234, '2020-01-06', 326, NULL),
('Candlewood Suites', 234, '2020-01-07', 136, NULL),
('Candlewood Suites', 234, '2020-01-08', 110, NULL),
('Candlewood Suites', 234, '2020-01-09', 258, NULL),
('Candlewood Suites', 234, '2020-01-10', 145, NULL),
('Candlewood Suites', 234, '2020-01-11', 303, NULL),
('Candlewood Suites', 234, '2020-01-12', 291, NULL),
('Candlewood Suites', 234, '2020-01-13', 296, NULL),
('Candlewood Suites', 234, '2020-01-14', 252, NULL),
('Candlewood Suites', 234, '2020-01-15', 117, NULL),
('Candlewood Suites', 234, '2020-01-16', 307, NULL),
('Candlewood Suites', 234, '2020-01-17', 384, NULL),
('Candlewood Suites', 234, '2020-01-18', 306, NULL),
('Candlewood Suites', 234, '2020-01-19', 147, NULL),
('Candlewood Suites', 234, '2020-01-20', 395, NULL),
('Candlewood Suites', 234, '2020-01-21', 101, NULL),
('Candlewood Suites', 234, '2020-01-22', 175, NULL),
('Candlewood Suites', 234, '2020-01-23', 139, NULL),
('Candlewood Suites', 234, '2020-01-24', 336, NULL),
('Candlewood Suites', 234, '2020-01-25', 298, NULL),
('Candlewood Suites', 234, '2020-01-26', 194, NULL),
('Candlewood Suites', 234, '2020-01-27', 359, NULL),
('Candlewood Suites', 234, '2020-01-28', 159, NULL),
('Candlewood Suites', 234, '2020-01-29', 197, NULL),
('Candlewood Suites', 234, '2020-01-30', 221, NULL),
('Candlewood Suites', 234, '2020-01-31', 103, NULL),
('Candlewood Suites', 234, '2020-02-01', 263, NULL),
('Candlewood Suites', 234, '2020-02-02', 318, NULL),
('Candlewood Suites', 234, '2020-02-03', 396, NULL),
('Candlewood Suites', 234, '2020-02-04', 344, NULL),
('Candlewood Suites', 248, '2019-01-01', 295, NULL),
('Candlewood Suites', 248, '2019-01-02', 242, NULL),
('Candlewood Suites', 248, '2019-01-03', 377, NULL),
('Candlewood Suites', 248, '2019-01-04', 277, NULL),
('Candlewood Suites', 248, '2019-01-05', 399, NULL),
('Candlewood Suites', 248, '2019-01-06', 285, NULL),
('Candlewood Suites', 248, '2019-01-07', 338, NULL),
('Candlewood Suites', 248, '2019-01-08', 219, NULL),
('Candlewood Suites', 248, '2019-01-09', 378, NULL),
('Candlewood Suites', 248, '2019-01-10', 117, NULL),
('Candlewood Suites', 248, '2019-01-11', 328, NULL),
('Candlewood Suites', 248, '2019-01-12', 336, NULL),
('Candlewood Suites', 248, '2019-01-13', 288, NULL),
('Candlewood Suites', 248, '2019-01-14', 196, NULL),
('Candlewood Suites', 248, '2019-01-15', 164, NULL),
('Candlewood Suites', 248, '2019-01-16', 118, NULL),
('Candlewood Suites', 248, '2019-01-17', 269, NULL),
('Candlewood Suites', 248, '2019-01-18', 198, NULL),
('Candlewood Suites', 248, '2019-01-19', 211, NULL),
('Candlewood Suites', 248, '2019-01-20', 172, NULL),
('Candlewood Suites', 248, '2019-01-21', 138, NULL),
('Candlewood Suites', 248, '2019-01-22', 154, NULL),
('Candlewood Suites', 248, '2019-01-23', 390, NULL),
('Candlewood Suites', 248, '2019-01-24', 156, NULL),
('Candlewood Suites', 248, '2019-01-25', 300, NULL),
('Candlewood Suites', 248, '2019-01-26', 348, NULL),
('Candlewood Suites', 248, '2019-01-27', 339, NULL),
('Candlewood Suites', 248, '2019-01-28', 354, NULL),
('Candlewood Suites', 248, '2019-01-29', 302, NULL),
('Candlewood Suites', 248, '2019-01-30', 345, NULL),
('Candlewood Suites', 248, '2019-01-31', 281, NULL),
('Candlewood Suites', 248, '2019-02-01', 296, NULL),
('Candlewood Suites', 248, '2019-02-02', 232, NULL),
('Candlewood Suites', 248, '2019-02-03', 340, NULL),
('Candlewood Suites', 248, '2019-02-04', 389, NULL),
('Candlewood Suites', 248, '2019-02-05', 366, NULL),
('Candlewood Suites', 248, '2019-02-06', 174, NULL),
('Candlewood Suites', 248, '2019-02-07', 367, NULL),
('Candlewood Suites', 248, '2019-02-08', 384, NULL),
('Candlewood Suites', 248, '2019-02-09', 392, NULL),
('Candlewood Suites', 248, '2019-02-10', 138, NULL),
('Candlewood Suites', 248, '2019-02-11', 358, NULL),
('Candlewood Suites', 248, '2019-02-12', 199, NULL),
('Candlewood Suites', 248, '2019-02-13', 308, NULL),
('Candlewood Suites', 248, '2019-02-14', 111, NULL),
('Candlewood Suites', 248, '2019-02-15', 285, NULL),
('Candlewood Suites', 248, '2019-02-16', 226, NULL),
('Candlewood Suites', 248, '2019-02-17', 131, NULL),
('Candlewood Suites', 248, '2019-02-18', 245, NULL),
('Candlewood Suites', 248, '2019-02-19', 271, NULL),
('Candlewood Suites', 248, '2019-02-20', 385, NULL),
('Candlewood Suites', 248, '2019-02-21', 293, NULL),
('Candlewood Suites', 248, '2019-02-22', 331, NULL),
('Candlewood Suites', 248, '2019-02-23', 215, NULL),
('Candlewood Suites', 248, '2019-02-24', 289, NULL),
('Candlewood Suites', 248, '2019-02-25', 331, NULL),
('Candlewood Suites', 248, '2019-02-26', 122, NULL),
('Candlewood Suites', 248, '2019-02-27', 243, NULL),
('Candlewood Suites', 248, '2019-02-28', 267, NULL),
('Candlewood Suites', 248, '2019-03-01', 359, NULL),
('Candlewood Suites', 248, '2019-03-02', 271, NULL),
('Candlewood Suites', 248, '2019-03-03', 396, NULL),
('Candlewood Suites', 248, '2019-03-04', 173, NULL),
('Candlewood Suites', 248, '2019-03-05', 133, NULL),
('Candlewood Suites', 248, '2019-03-06', 161, NULL),
('Candlewood Suites', 248, '2019-03-07', 365, NULL),
('Candlewood Suites', 248, '2019-03-08', 330, NULL),
('Candlewood Suites', 248, '2019-03-09', 237, NULL),
('Candlewood Suites', 248, '2019-03-10', 280, NULL),
('Candlewood Suites', 248, '2019-03-11', 144, NULL),
('Candlewood Suites', 248, '2019-03-12', 260, NULL),
('Candlewood Suites', 248, '2019-03-13', 228, NULL),
('Candlewood Suites', 248, '2019-03-14', 264, NULL),
('Candlewood Suites', 248, '2019-03-15', 318, NULL),
('Candlewood Suites', 248, '2019-03-16', 379, NULL),
('Candlewood Suites', 248, '2019-03-17', 360, NULL),
('Candlewood Suites', 248, '2019-03-18', 235, NULL),
('Candlewood Suites', 248, '2019-03-19', 158, NULL),
('Candlewood Suites', 248, '2019-03-20', 197, NULL),
('Candlewood Suites', 248, '2019-03-21', 190, NULL),
('Candlewood Suites', 248, '2019-03-22', 345, NULL),
('Candlewood Suites', 248, '2019-03-23', 343, NULL),
('Candlewood Suites', 248, '2019-03-24', 319, NULL),
('Candlewood Suites', 248, '2019-03-25', 302, NULL),
('Candlewood Suites', 248, '2019-03-26', 138, NULL),
('Candlewood Suites', 248, '2019-03-27', 230, NULL),
('Candlewood Suites', 248, '2019-03-28', 321, NULL),
('Candlewood Suites', 248, '2019-03-29', 182, NULL),
('Candlewood Suites', 248, '2019-03-30', 112, NULL),
('Candlewood Suites', 248, '2019-03-31', 119, NULL),
('Candlewood Suites', 248, '2019-04-01', 201, NULL),
('Candlewood Suites', 248, '2019-04-02', 304, NULL),
('Candlewood Suites', 248, '2019-04-03', 254, NULL),
('Candlewood Suites', 248, '2019-04-04', 252, NULL),
('Candlewood Suites', 248, '2019-04-05', 382, NULL),
('Candlewood Suites', 248, '2019-04-06', 395, NULL),
('Candlewood Suites', 248, '2019-04-07', 214, NULL),
('Candlewood Suites', 248, '2019-04-08', 207, NULL),
('Candlewood Suites', 248, '2019-04-09', 370, NULL),
('Candlewood Suites', 248, '2019-04-10', 157, NULL),
('Candlewood Suites', 248, '2019-04-11', 266, NULL),
('Candlewood Suites', 248, '2019-04-12', 211, NULL),
('Candlewood Suites', 248, '2019-04-13', 348, NULL),
('Candlewood Suites', 248, '2019-04-14', 334, NULL),
('Candlewood Suites', 248, '2019-04-15', 293, NULL),
('Candlewood Suites', 248, '2019-04-16', 174, NULL),
('Candlewood Suites', 248, '2019-04-17', 240, NULL),
('Candlewood Suites', 248, '2019-04-18', 300, NULL),
('Candlewood Suites', 248, '2019-04-19', 308, NULL),
('Candlewood Suites', 248, '2019-04-20', 380, NULL),
('Candlewood Suites', 248, '2019-04-21', 277, NULL),
('Candlewood Suites', 248, '2019-04-22', 219, NULL),
('Candlewood Suites', 248, '2019-04-23', 162, NULL),
('Candlewood Suites', 248, '2019-04-24', 248, NULL),
('Candlewood Suites', 248, '2019-04-25', 308, NULL),
('Candlewood Suites', 248, '2019-04-26', 168, NULL),
('Candlewood Suites', 248, '2019-04-27', 372, NULL),
('Candlewood Suites', 248, '2019-04-28', 193, NULL),
('Candlewood Suites', 248, '2019-04-29', 300, NULL),
('Candlewood Suites', 248, '2019-04-30', 181, NULL),
('Candlewood Suites', 248, '2019-05-01', 336, NULL),
('Candlewood Suites', 248, '2019-05-02', 159, NULL),
('Candlewood Suites', 248, '2019-05-03', 242, NULL),
('Candlewood Suites', 248, '2019-05-04', 391, NULL),
('Candlewood Suites', 248, '2019-05-05', 307, NULL),
('Candlewood Suites', 248, '2019-05-06', 206, NULL),
('Candlewood Suites', 248, '2019-05-07', 131, NULL),
('Candlewood Suites', 248, '2019-05-08', 114, NULL),
('Candlewood Suites', 248, '2019-05-09', 160, NULL),
('Candlewood Suites', 248, '2019-05-10', 362, NULL),
('Candlewood Suites', 248, '2019-05-11', 370, NULL),
('Candlewood Suites', 248, '2019-05-12', 273, NULL),
('Candlewood Suites', 248, '2019-05-13', 134, NULL),
('Candlewood Suites', 248, '2019-05-14', 315, NULL),
('Candlewood Suites', 248, '2019-05-15', 259, NULL),
('Candlewood Suites', 248, '2019-05-16', 136, NULL),
('Candlewood Suites', 248, '2019-05-17', 394, NULL),
('Candlewood Suites', 248, '2019-05-18', 225, NULL),
('Candlewood Suites', 248, '2019-05-19', 394, NULL),
('Candlewood Suites', 248, '2019-05-20', 391, NULL),
('Candlewood Suites', 248, '2019-05-21', 311, NULL),
('Candlewood Suites', 248, '2019-05-22', 241, NULL),
('Candlewood Suites', 248, '2019-05-23', 153, NULL),
('Candlewood Suites', 248, '2019-05-24', 332, NULL),
('Candlewood Suites', 248, '2019-05-25', 399, NULL),
('Candlewood Suites', 248, '2019-05-26', 190, NULL),
('Candlewood Suites', 248, '2019-05-27', 179, NULL),
('Candlewood Suites', 248, '2019-05-28', 111, NULL),
('Candlewood Suites', 248, '2019-05-29', 323, NULL),
('Candlewood Suites', 248, '2019-05-30', 142, NULL),
('Candlewood Suites', 248, '2019-05-31', 236, NULL),
('Candlewood Suites', 248, '2019-06-01', 366, NULL),
('Candlewood Suites', 248, '2019-06-02', 342, NULL),
('Candlewood Suites', 248, '2019-06-03', 243, NULL),
('Candlewood Suites', 248, '2019-06-04', 104, NULL),
('Candlewood Suites', 248, '2019-06-05', 133, NULL),
('Candlewood Suites', 248, '2019-06-06', 239, NULL),
('Candlewood Suites', 248, '2019-06-07', 193, NULL),
('Candlewood Suites', 248, '2019-06-08', 181, NULL),
('Candlewood Suites', 248, '2019-06-09', 132, NULL),
('Candlewood Suites', 248, '2019-06-10', 231, NULL),
('Candlewood Suites', 248, '2019-06-11', 393, NULL),
('Candlewood Suites', 248, '2019-06-12', 318, NULL),
('Candlewood Suites', 248, '2019-06-13', 365, NULL),
('Candlewood Suites', 248, '2019-06-14', 399, NULL),
('Candlewood Suites', 248, '2019-06-15', 204, NULL),
('Candlewood Suites', 248, '2019-06-16', 202, NULL),
('Candlewood Suites', 248, '2019-06-17', 107, NULL),
('Candlewood Suites', 248, '2019-06-18', 182, NULL),
('Candlewood Suites', 248, '2019-06-19', 105, NULL),
('Candlewood Suites', 248, '2019-06-20', 159, NULL),
('Candlewood Suites', 248, '2019-06-21', 147, NULL),
('Candlewood Suites', 248, '2019-06-22', 369, NULL),
('Candlewood Suites', 248, '2019-06-23', 348, NULL),
('Candlewood Suites', 248, '2019-06-24', 249, NULL),
('Candlewood Suites', 248, '2019-06-25', 300, NULL),
('Candlewood Suites', 248, '2019-06-26', 365, NULL),
('Candlewood Suites', 248, '2019-06-27', 152, NULL),
('Candlewood Suites', 248, '2019-06-28', 274, NULL),
('Candlewood Suites', 248, '2019-06-29', 159, NULL),
('Candlewood Suites', 248, '2019-06-30', 382, NULL),
('Candlewood Suites', 248, '2019-07-01', 326, NULL),
('Candlewood Suites', 248, '2019-07-02', 112, NULL),
('Candlewood Suites', 248, '2019-07-03', 179, NULL),
('Candlewood Suites', 248, '2019-07-04', 380, NULL),
('Candlewood Suites', 248, '2019-07-05', 292, NULL),
('Candlewood Suites', 248, '2019-07-06', 394, NULL),
('Candlewood Suites', 248, '2019-07-07', 298, NULL),
('Candlewood Suites', 248, '2019-07-08', 391, NULL),
('Candlewood Suites', 248, '2019-07-09', 157, NULL),
('Candlewood Suites', 248, '2019-07-10', 101, NULL),
('Candlewood Suites', 248, '2019-07-11', 204, NULL),
('Candlewood Suites', 248, '2019-07-12', 344, NULL),
('Candlewood Suites', 248, '2019-07-13', 127, NULL),
('Candlewood Suites', 248, '2019-07-14', 290, NULL),
('Candlewood Suites', 248, '2019-07-15', 279, NULL),
('Candlewood Suites', 248, '2019-07-16', 269, NULL),
('Candlewood Suites', 248, '2019-07-17', 202, NULL),
('Candlewood Suites', 248, '2019-07-18', 247, NULL),
('Candlewood Suites', 248, '2019-07-19', 217, NULL),
('Candlewood Suites', 248, '2019-07-20', 291, NULL),
('Candlewood Suites', 248, '2019-07-21', 178, NULL),
('Candlewood Suites', 248, '2019-07-22', 296, NULL),
('Candlewood Suites', 248, '2019-07-23', 222, NULL),
('Candlewood Suites', 248, '2019-07-24', 336, NULL),
('Candlewood Suites', 248, '2019-07-25', 245, NULL),
('Candlewood Suites', 248, '2019-07-26', 382, NULL),
('Candlewood Suites', 248, '2019-07-27', 115, NULL),
('Candlewood Suites', 248, '2019-07-28', 319, NULL),
('Candlewood Suites', 248, '2019-07-29', 211, NULL),
('Candlewood Suites', 248, '2019-07-30', 196, NULL),
('Candlewood Suites', 248, '2019-07-31', 272, NULL),
('Candlewood Suites', 248, '2019-08-01', 175, NULL),
('Candlewood Suites', 248, '2019-08-02', 365, NULL),
('Candlewood Suites', 248, '2019-08-03', 358, NULL),
('Candlewood Suites', 248, '2019-08-04', 149, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 248, '2019-08-05', 190, NULL),
('Candlewood Suites', 248, '2019-08-06', 227, NULL),
('Candlewood Suites', 248, '2019-08-07', 227, NULL),
('Candlewood Suites', 248, '2019-08-08', 151, NULL),
('Candlewood Suites', 248, '2019-08-09', 329, NULL),
('Candlewood Suites', 248, '2019-08-10', 149, NULL),
('Candlewood Suites', 248, '2019-08-11', 393, NULL),
('Candlewood Suites', 248, '2019-08-12', 348, NULL),
('Candlewood Suites', 248, '2019-08-13', 135, NULL),
('Candlewood Suites', 248, '2019-08-14', 105, NULL),
('Candlewood Suites', 248, '2019-08-15', 385, NULL),
('Candlewood Suites', 248, '2019-08-16', 272, NULL),
('Candlewood Suites', 248, '2019-08-17', 367, NULL),
('Candlewood Suites', 248, '2019-08-18', 388, NULL),
('Candlewood Suites', 248, '2019-08-19', 227, NULL),
('Candlewood Suites', 248, '2019-08-20', 303, NULL),
('Candlewood Suites', 248, '2019-08-21', 195, NULL),
('Candlewood Suites', 248, '2019-08-22', 273, NULL),
('Candlewood Suites', 248, '2019-08-23', 386, NULL),
('Candlewood Suites', 248, '2019-08-24', 326, NULL),
('Candlewood Suites', 248, '2019-08-25', 147, NULL),
('Candlewood Suites', 248, '2019-08-26', 225, NULL),
('Candlewood Suites', 248, '2019-08-27', 171, NULL),
('Candlewood Suites', 248, '2019-08-28', 315, NULL),
('Candlewood Suites', 248, '2019-08-29', 288, NULL),
('Candlewood Suites', 248, '2019-08-30', 282, NULL),
('Candlewood Suites', 248, '2019-08-31', 136, NULL),
('Candlewood Suites', 248, '2019-09-01', 158, NULL),
('Candlewood Suites', 248, '2019-09-02', 188, NULL),
('Candlewood Suites', 248, '2019-09-03', 249, NULL),
('Candlewood Suites', 248, '2019-09-04', 283, NULL),
('Candlewood Suites', 248, '2019-09-05', 283, NULL),
('Candlewood Suites', 248, '2019-09-06', 208, NULL),
('Candlewood Suites', 248, '2019-09-07', 197, NULL),
('Candlewood Suites', 248, '2019-09-08', 178, NULL),
('Candlewood Suites', 248, '2019-09-09', 206, NULL),
('Candlewood Suites', 248, '2019-09-10', 351, NULL),
('Candlewood Suites', 248, '2019-09-11', 274, NULL),
('Candlewood Suites', 248, '2019-09-12', 112, NULL),
('Candlewood Suites', 248, '2019-09-13', 360, NULL),
('Candlewood Suites', 248, '2019-09-14', 342, NULL),
('Candlewood Suites', 248, '2019-09-15', 330, NULL),
('Candlewood Suites', 248, '2019-09-16', 239, NULL),
('Candlewood Suites', 248, '2019-09-17', 127, NULL),
('Candlewood Suites', 248, '2019-09-18', 386, NULL),
('Candlewood Suites', 248, '2019-09-19', 268, NULL),
('Candlewood Suites', 248, '2019-09-20', 311, NULL),
('Candlewood Suites', 248, '2019-09-21', 355, NULL),
('Candlewood Suites', 248, '2019-09-22', 368, NULL),
('Candlewood Suites', 248, '2019-09-23', 297, NULL),
('Candlewood Suites', 248, '2019-09-24', 164, NULL),
('Candlewood Suites', 248, '2019-09-25', 246, NULL),
('Candlewood Suites', 248, '2019-09-26', 103, NULL),
('Candlewood Suites', 248, '2019-09-27', 232, NULL),
('Candlewood Suites', 248, '2019-09-28', 283, NULL),
('Candlewood Suites', 248, '2019-09-29', 314, NULL),
('Candlewood Suites', 248, '2019-09-30', 299, NULL),
('Candlewood Suites', 248, '2019-10-01', 278, NULL),
('Candlewood Suites', 248, '2019-10-02', 189, NULL),
('Candlewood Suites', 248, '2019-10-03', 256, NULL),
('Candlewood Suites', 248, '2019-10-04', 233, NULL),
('Candlewood Suites', 248, '2019-10-05', 192, NULL),
('Candlewood Suites', 248, '2019-10-06', 125, NULL),
('Candlewood Suites', 248, '2019-10-07', 182, NULL),
('Candlewood Suites', 248, '2019-10-08', 261, NULL),
('Candlewood Suites', 248, '2019-10-09', 126, NULL),
('Candlewood Suites', 248, '2019-10-10', 135, NULL),
('Candlewood Suites', 248, '2019-10-11', 363, NULL),
('Candlewood Suites', 248, '2019-10-12', 219, NULL),
('Candlewood Suites', 248, '2019-10-13', 128, NULL),
('Candlewood Suites', 248, '2019-10-14', 143, NULL),
('Candlewood Suites', 248, '2019-10-15', 363, NULL),
('Candlewood Suites', 248, '2019-10-16', 283, NULL),
('Candlewood Suites', 248, '2019-10-17', 110, NULL),
('Candlewood Suites', 248, '2019-10-18', 253, NULL),
('Candlewood Suites', 248, '2019-10-19', 326, NULL),
('Candlewood Suites', 248, '2019-10-20', 182, NULL),
('Candlewood Suites', 248, '2019-10-21', 231, NULL),
('Candlewood Suites', 248, '2019-10-22', 306, NULL),
('Candlewood Suites', 248, '2019-10-23', 212, NULL),
('Candlewood Suites', 248, '2019-10-24', 277, NULL),
('Candlewood Suites', 248, '2019-10-25', 347, NULL),
('Candlewood Suites', 248, '2019-10-26', 375, NULL),
('Candlewood Suites', 248, '2019-10-27', 276, NULL),
('Candlewood Suites', 248, '2019-10-28', 394, NULL),
('Candlewood Suites', 248, '2019-10-29', 129, NULL),
('Candlewood Suites', 248, '2019-10-30', 360, NULL),
('Candlewood Suites', 248, '2019-10-31', 307, NULL),
('Candlewood Suites', 248, '2019-11-01', 308, NULL),
('Candlewood Suites', 248, '2019-11-02', 244, NULL),
('Candlewood Suites', 248, '2019-11-03', 347, NULL),
('Candlewood Suites', 248, '2019-11-04', 213, NULL),
('Candlewood Suites', 248, '2019-11-05', 391, NULL),
('Candlewood Suites', 248, '2019-11-06', 183, NULL),
('Candlewood Suites', 248, '2019-11-07', 334, NULL),
('Candlewood Suites', 248, '2019-11-08', 277, NULL),
('Candlewood Suites', 248, '2019-11-09', 293, NULL),
('Candlewood Suites', 248, '2019-11-10', 320, NULL),
('Candlewood Suites', 248, '2019-11-11', 237, NULL),
('Candlewood Suites', 248, '2019-11-12', 243, NULL),
('Candlewood Suites', 248, '2019-11-13', 240, NULL),
('Candlewood Suites', 248, '2019-11-14', 181, NULL),
('Candlewood Suites', 248, '2019-11-15', 311, NULL),
('Candlewood Suites', 248, '2019-11-16', 299, NULL),
('Candlewood Suites', 248, '2019-11-17', 219, NULL),
('Candlewood Suites', 248, '2019-11-18', 332, NULL),
('Candlewood Suites', 248, '2019-11-19', 297, NULL),
('Candlewood Suites', 248, '2019-11-20', 125, NULL),
('Candlewood Suites', 248, '2019-11-21', 220, NULL),
('Candlewood Suites', 248, '2019-11-22', 169, NULL),
('Candlewood Suites', 248, '2019-11-23', 194, NULL),
('Candlewood Suites', 248, '2019-11-24', 367, NULL),
('Candlewood Suites', 248, '2019-11-25', 264, NULL),
('Candlewood Suites', 248, '2019-11-26', 369, NULL),
('Candlewood Suites', 248, '2019-11-27', 326, NULL),
('Candlewood Suites', 248, '2019-11-28', 172, NULL),
('Candlewood Suites', 248, '2019-11-29', 296, NULL),
('Candlewood Suites', 248, '2019-11-30', 285, NULL),
('Candlewood Suites', 248, '2019-12-01', 376, NULL),
('Candlewood Suites', 248, '2019-12-02', 204, NULL),
('Candlewood Suites', 248, '2019-12-03', 187, NULL),
('Candlewood Suites', 248, '2019-12-04', 291, NULL),
('Candlewood Suites', 248, '2019-12-05', 346, NULL),
('Candlewood Suites', 248, '2019-12-06', 365, NULL),
('Candlewood Suites', 248, '2019-12-07', 179, NULL),
('Candlewood Suites', 248, '2019-12-08', 316, NULL),
('Candlewood Suites', 248, '2019-12-09', 259, NULL),
('Candlewood Suites', 248, '2019-12-10', 174, NULL),
('Candlewood Suites', 248, '2019-12-11', 191, NULL),
('Candlewood Suites', 248, '2019-12-12', 385, NULL),
('Candlewood Suites', 248, '2019-12-13', 333, NULL),
('Candlewood Suites', 248, '2019-12-14', 199, NULL),
('Candlewood Suites', 248, '2019-12-15', 324, NULL),
('Candlewood Suites', 248, '2019-12-16', 274, NULL),
('Candlewood Suites', 248, '2019-12-17', 165, NULL),
('Candlewood Suites', 248, '2019-12-18', 299, NULL),
('Candlewood Suites', 248, '2019-12-19', 176, NULL),
('Candlewood Suites', 248, '2019-12-20', 145, NULL),
('Candlewood Suites', 248, '2019-12-21', 201, NULL),
('Candlewood Suites', 248, '2019-12-22', 128, NULL),
('Candlewood Suites', 248, '2019-12-23', 173, NULL),
('Candlewood Suites', 248, '2019-12-24', 394, NULL),
('Candlewood Suites', 248, '2019-12-25', 190, NULL),
('Candlewood Suites', 248, '2019-12-26', 186, NULL),
('Candlewood Suites', 248, '2019-12-27', 190, NULL),
('Candlewood Suites', 248, '2019-12-28', 188, NULL),
('Candlewood Suites', 248, '2019-12-29', 169, NULL),
('Candlewood Suites', 248, '2019-12-30', 171, NULL),
('Candlewood Suites', 248, '2019-12-31', 290, NULL),
('Candlewood Suites', 248, '2020-01-01', 244, NULL),
('Candlewood Suites', 248, '2020-01-02', 304, NULL),
('Candlewood Suites', 248, '2020-01-03', 174, NULL),
('Candlewood Suites', 248, '2020-01-04', 208, NULL),
('Candlewood Suites', 248, '2020-01-05', 305, NULL),
('Candlewood Suites', 248, '2020-01-06', 356, NULL),
('Candlewood Suites', 248, '2020-01-07', 390, NULL),
('Candlewood Suites', 248, '2020-01-08', 370, NULL),
('Candlewood Suites', 248, '2020-01-09', 204, NULL),
('Candlewood Suites', 248, '2020-01-10', 369, NULL),
('Candlewood Suites', 248, '2020-01-11', 309, NULL),
('Candlewood Suites', 248, '2020-01-12', 203, NULL),
('Candlewood Suites', 248, '2020-01-13', 277, NULL),
('Candlewood Suites', 248, '2020-01-14', 142, NULL),
('Candlewood Suites', 248, '2020-01-15', 170, NULL),
('Candlewood Suites', 248, '2020-01-16', 174, NULL),
('Candlewood Suites', 248, '2020-01-17', 142, NULL),
('Candlewood Suites', 248, '2020-01-18', 374, NULL),
('Candlewood Suites', 248, '2020-01-19', 134, NULL),
('Candlewood Suites', 248, '2020-01-20', 303, NULL),
('Candlewood Suites', 248, '2020-01-21', 278, NULL),
('Candlewood Suites', 248, '2020-01-22', 110, NULL),
('Candlewood Suites', 248, '2020-01-23', 196, NULL),
('Candlewood Suites', 248, '2020-01-24', 304, NULL),
('Candlewood Suites', 248, '2020-01-25', 343, NULL),
('Candlewood Suites', 248, '2020-01-26', 216, NULL),
('Candlewood Suites', 248, '2020-01-27', 185, NULL),
('Candlewood Suites', 248, '2020-01-28', 124, NULL),
('Candlewood Suites', 248, '2020-01-29', 154, NULL),
('Candlewood Suites', 248, '2020-01-30', 341, NULL),
('Candlewood Suites', 248, '2020-01-31', 241, NULL),
('Candlewood Suites', 248, '2020-02-01', 298, NULL),
('Candlewood Suites', 248, '2020-02-02', 359, NULL),
('Candlewood Suites', 248, '2020-02-03', 391, NULL),
('Candlewood Suites', 248, '2020-02-04', 350, NULL),
('Candlewood Suites', 260, '2019-01-01', 303, NULL),
('Candlewood Suites', 260, '2019-01-02', 203, NULL),
('Candlewood Suites', 260, '2019-01-03', 218, NULL),
('Candlewood Suites', 260, '2019-01-04', 198, NULL),
('Candlewood Suites', 260, '2019-01-05', 204, NULL),
('Candlewood Suites', 260, '2019-01-06', 188, NULL),
('Candlewood Suites', 260, '2019-01-07', 382, NULL),
('Candlewood Suites', 260, '2019-01-08', 246, NULL),
('Candlewood Suites', 260, '2019-01-09', 144, NULL),
('Candlewood Suites', 260, '2019-01-10', 356, NULL),
('Candlewood Suites', 260, '2019-01-11', 155, NULL),
('Candlewood Suites', 260, '2019-01-12', 318, NULL),
('Candlewood Suites', 260, '2019-01-13', 145, NULL),
('Candlewood Suites', 260, '2019-01-14', 341, NULL),
('Candlewood Suites', 260, '2019-01-15', 292, NULL),
('Candlewood Suites', 260, '2019-01-16', 146, NULL),
('Candlewood Suites', 260, '2019-01-17', 284, NULL),
('Candlewood Suites', 260, '2019-01-18', 289, NULL),
('Candlewood Suites', 260, '2019-01-19', 391, NULL),
('Candlewood Suites', 260, '2019-01-20', 171, NULL),
('Candlewood Suites', 260, '2019-01-21', 339, NULL),
('Candlewood Suites', 260, '2019-01-22', 399, NULL),
('Candlewood Suites', 260, '2019-01-23', 361, NULL),
('Candlewood Suites', 260, '2019-01-24', 352, NULL),
('Candlewood Suites', 260, '2019-01-25', 118, NULL),
('Candlewood Suites', 260, '2019-01-26', 311, NULL),
('Candlewood Suites', 260, '2019-01-27', 100, NULL),
('Candlewood Suites', 260, '2019-01-28', 139, NULL),
('Candlewood Suites', 260, '2019-01-29', 112, NULL),
('Candlewood Suites', 260, '2019-01-30', 364, NULL),
('Candlewood Suites', 260, '2019-01-31', 159, NULL),
('Candlewood Suites', 260, '2019-02-01', 300, NULL),
('Candlewood Suites', 260, '2019-02-02', 338, NULL),
('Candlewood Suites', 260, '2019-02-03', 124, NULL),
('Candlewood Suites', 260, '2019-02-04', 399, NULL),
('Candlewood Suites', 260, '2019-02-05', 265, NULL),
('Candlewood Suites', 260, '2019-02-06', 221, NULL),
('Candlewood Suites', 260, '2019-02-07', 292, NULL),
('Candlewood Suites', 260, '2019-02-08', 304, NULL),
('Candlewood Suites', 260, '2019-02-09', 321, NULL),
('Candlewood Suites', 260, '2019-02-10', 281, NULL),
('Candlewood Suites', 260, '2019-02-11', 276, NULL),
('Candlewood Suites', 260, '2019-02-12', 310, NULL),
('Candlewood Suites', 260, '2019-02-13', 160, NULL),
('Candlewood Suites', 260, '2019-02-14', 263, NULL),
('Candlewood Suites', 260, '2019-02-15', 393, NULL),
('Candlewood Suites', 260, '2019-02-16', 388, NULL),
('Candlewood Suites', 260, '2019-02-17', 195, NULL),
('Candlewood Suites', 260, '2019-02-18', 144, NULL),
('Candlewood Suites', 260, '2019-02-19', 287, NULL),
('Candlewood Suites', 260, '2019-02-20', 304, NULL),
('Candlewood Suites', 260, '2019-02-21', 329, NULL),
('Candlewood Suites', 260, '2019-02-22', 277, NULL),
('Candlewood Suites', 260, '2019-02-23', 171, NULL),
('Candlewood Suites', 260, '2019-02-24', 108, NULL),
('Candlewood Suites', 260, '2019-02-25', 159, NULL),
('Candlewood Suites', 260, '2019-02-26', 308, NULL),
('Candlewood Suites', 260, '2019-02-27', 327, NULL),
('Candlewood Suites', 260, '2019-02-28', 347, NULL),
('Candlewood Suites', 260, '2019-03-01', 225, NULL),
('Candlewood Suites', 260, '2019-03-02', 255, NULL),
('Candlewood Suites', 260, '2019-03-03', 177, NULL),
('Candlewood Suites', 260, '2019-03-04', 339, NULL),
('Candlewood Suites', 260, '2019-03-05', 162, NULL),
('Candlewood Suites', 260, '2019-03-06', 230, NULL),
('Candlewood Suites', 260, '2019-03-07', 179, NULL),
('Candlewood Suites', 260, '2019-03-08', 382, NULL),
('Candlewood Suites', 260, '2019-03-09', 325, NULL),
('Candlewood Suites', 260, '2019-03-10', 143, NULL),
('Candlewood Suites', 260, '2019-03-11', 379, NULL),
('Candlewood Suites', 260, '2019-03-12', 323, NULL),
('Candlewood Suites', 260, '2019-03-13', 292, NULL),
('Candlewood Suites', 260, '2019-03-14', 266, NULL),
('Candlewood Suites', 260, '2019-03-15', 253, NULL),
('Candlewood Suites', 260, '2019-03-16', 256, NULL),
('Candlewood Suites', 260, '2019-03-17', 198, NULL),
('Candlewood Suites', 260, '2019-03-18', 399, NULL),
('Candlewood Suites', 260, '2019-03-19', 378, NULL),
('Candlewood Suites', 260, '2019-03-20', 232, NULL),
('Candlewood Suites', 260, '2019-03-21', 195, NULL),
('Candlewood Suites', 260, '2019-03-22', 302, NULL),
('Candlewood Suites', 260, '2019-03-23', 154, NULL),
('Candlewood Suites', 260, '2019-03-24', 336, NULL),
('Candlewood Suites', 260, '2019-03-25', 383, NULL),
('Candlewood Suites', 260, '2019-03-26', 141, NULL),
('Candlewood Suites', 260, '2019-03-27', 152, NULL),
('Candlewood Suites', 260, '2019-03-28', 398, NULL),
('Candlewood Suites', 260, '2019-03-29', 213, NULL),
('Candlewood Suites', 260, '2019-03-30', 320, NULL),
('Candlewood Suites', 260, '2019-03-31', 239, NULL),
('Candlewood Suites', 260, '2019-04-01', 271, NULL),
('Candlewood Suites', 260, '2019-04-02', 399, NULL),
('Candlewood Suites', 260, '2019-04-03', 235, NULL),
('Candlewood Suites', 260, '2019-04-04', 130, NULL),
('Candlewood Suites', 260, '2019-04-05', 336, NULL),
('Candlewood Suites', 260, '2019-04-06', 392, NULL),
('Candlewood Suites', 260, '2019-04-07', 251, NULL),
('Candlewood Suites', 260, '2019-04-08', 399, NULL),
('Candlewood Suites', 260, '2019-04-09', 360, NULL),
('Candlewood Suites', 260, '2019-04-10', 224, NULL),
('Candlewood Suites', 260, '2019-04-11', 118, NULL),
('Candlewood Suites', 260, '2019-04-12', 322, NULL),
('Candlewood Suites', 260, '2019-04-13', 244, NULL),
('Candlewood Suites', 260, '2019-04-14', 367, NULL),
('Candlewood Suites', 260, '2019-04-15', 196, NULL),
('Candlewood Suites', 260, '2019-04-16', 151, NULL),
('Candlewood Suites', 260, '2019-04-17', 298, NULL),
('Candlewood Suites', 260, '2019-04-18', 156, NULL),
('Candlewood Suites', 260, '2019-04-19', 217, NULL),
('Candlewood Suites', 260, '2019-04-20', 175, NULL),
('Candlewood Suites', 260, '2019-04-21', 192, NULL),
('Candlewood Suites', 260, '2019-04-22', 385, NULL),
('Candlewood Suites', 260, '2019-04-23', 351, NULL),
('Candlewood Suites', 260, '2019-04-24', 205, NULL),
('Candlewood Suites', 260, '2019-04-25', 371, NULL),
('Candlewood Suites', 260, '2019-04-26', 241, NULL),
('Candlewood Suites', 260, '2019-04-27', 109, NULL),
('Candlewood Suites', 260, '2019-04-28', 190, NULL),
('Candlewood Suites', 260, '2019-04-29', 165, NULL),
('Candlewood Suites', 260, '2019-04-30', 323, NULL),
('Candlewood Suites', 260, '2019-05-01', 211, NULL),
('Candlewood Suites', 260, '2019-05-02', 201, NULL),
('Candlewood Suites', 260, '2019-05-03', 360, NULL),
('Candlewood Suites', 260, '2019-05-04', 124, NULL),
('Candlewood Suites', 260, '2019-05-05', 325, NULL),
('Candlewood Suites', 260, '2019-05-06', 146, NULL),
('Candlewood Suites', 260, '2019-05-07', 375, NULL),
('Candlewood Suites', 260, '2019-05-08', 163, NULL),
('Candlewood Suites', 260, '2019-05-09', 274, NULL),
('Candlewood Suites', 260, '2019-05-10', 154, NULL),
('Candlewood Suites', 260, '2019-05-11', 197, NULL),
('Candlewood Suites', 260, '2019-05-12', 284, NULL),
('Candlewood Suites', 260, '2019-05-13', 139, NULL),
('Candlewood Suites', 260, '2019-05-14', 332, NULL),
('Candlewood Suites', 260, '2019-05-15', 314, NULL),
('Candlewood Suites', 260, '2019-05-16', 371, NULL),
('Candlewood Suites', 260, '2019-05-17', 182, NULL),
('Candlewood Suites', 260, '2019-05-18', 190, NULL),
('Candlewood Suites', 260, '2019-05-19', 250, NULL),
('Candlewood Suites', 260, '2019-05-20', 199, NULL),
('Candlewood Suites', 260, '2019-05-21', 235, NULL),
('Candlewood Suites', 260, '2019-05-22', 149, NULL),
('Candlewood Suites', 260, '2019-05-23', 210, NULL),
('Candlewood Suites', 260, '2019-05-24', 230, NULL),
('Candlewood Suites', 260, '2019-05-25', 196, NULL),
('Candlewood Suites', 260, '2019-05-26', 331, NULL),
('Candlewood Suites', 260, '2019-05-27', 351, NULL),
('Candlewood Suites', 260, '2019-05-28', 359, NULL),
('Candlewood Suites', 260, '2019-05-29', 243, NULL),
('Candlewood Suites', 260, '2019-05-30', 285, NULL),
('Candlewood Suites', 260, '2019-05-31', 305, NULL),
('Candlewood Suites', 260, '2019-06-01', 183, NULL),
('Candlewood Suites', 260, '2019-06-02', 343, NULL),
('Candlewood Suites', 260, '2019-06-03', 353, NULL),
('Candlewood Suites', 260, '2019-06-04', 274, NULL),
('Candlewood Suites', 260, '2019-06-05', 112, NULL),
('Candlewood Suites', 260, '2019-06-06', 272, NULL),
('Candlewood Suites', 260, '2019-06-07', 386, NULL),
('Candlewood Suites', 260, '2019-06-08', 221, NULL),
('Candlewood Suites', 260, '2019-06-09', 341, NULL),
('Candlewood Suites', 260, '2019-06-10', 191, NULL),
('Candlewood Suites', 260, '2019-06-11', 105, NULL),
('Candlewood Suites', 260, '2019-06-12', 376, NULL),
('Candlewood Suites', 260, '2019-06-13', 229, NULL),
('Candlewood Suites', 260, '2019-06-14', 329, NULL),
('Candlewood Suites', 260, '2019-06-15', 294, NULL),
('Candlewood Suites', 260, '2019-06-16', 243, NULL),
('Candlewood Suites', 260, '2019-06-17', 199, NULL),
('Candlewood Suites', 260, '2019-06-18', 231, NULL),
('Candlewood Suites', 260, '2019-06-19', 329, NULL),
('Candlewood Suites', 260, '2019-06-20', 306, NULL),
('Candlewood Suites', 260, '2019-06-21', 288, NULL),
('Candlewood Suites', 260, '2019-06-22', 335, NULL),
('Candlewood Suites', 260, '2019-06-23', 207, NULL),
('Candlewood Suites', 260, '2019-06-24', 347, NULL),
('Candlewood Suites', 260, '2019-06-25', 347, NULL),
('Candlewood Suites', 260, '2019-06-26', 384, NULL),
('Candlewood Suites', 260, '2019-06-27', 272, NULL),
('Candlewood Suites', 260, '2019-06-28', 389, NULL),
('Candlewood Suites', 260, '2019-06-29', 399, NULL),
('Candlewood Suites', 260, '2019-06-30', 124, NULL),
('Candlewood Suites', 260, '2019-07-01', 220, NULL),
('Candlewood Suites', 260, '2019-07-02', 121, NULL),
('Candlewood Suites', 260, '2019-07-03', 288, NULL),
('Candlewood Suites', 260, '2019-07-04', 150, NULL),
('Candlewood Suites', 260, '2019-07-05', 185, NULL),
('Candlewood Suites', 260, '2019-07-06', 148, NULL),
('Candlewood Suites', 260, '2019-07-07', 156, NULL),
('Candlewood Suites', 260, '2019-07-08', 217, NULL),
('Candlewood Suites', 260, '2019-07-09', 209, NULL),
('Candlewood Suites', 260, '2019-07-10', 268, NULL),
('Candlewood Suites', 260, '2019-07-11', 330, NULL),
('Candlewood Suites', 260, '2019-07-12', 114, NULL),
('Candlewood Suites', 260, '2019-07-13', 308, NULL),
('Candlewood Suites', 260, '2019-07-14', 322, NULL),
('Candlewood Suites', 260, '2019-07-15', 324, NULL),
('Candlewood Suites', 260, '2019-07-16', 278, NULL),
('Candlewood Suites', 260, '2019-07-17', 339, NULL),
('Candlewood Suites', 260, '2019-07-18', 162, NULL),
('Candlewood Suites', 260, '2019-07-19', 166, NULL),
('Candlewood Suites', 260, '2019-07-20', 235, NULL),
('Candlewood Suites', 260, '2019-07-21', 251, NULL),
('Candlewood Suites', 260, '2019-07-22', 293, NULL),
('Candlewood Suites', 260, '2019-07-23', 327, NULL),
('Candlewood Suites', 260, '2019-07-24', 398, NULL),
('Candlewood Suites', 260, '2019-07-25', 199, NULL),
('Candlewood Suites', 260, '2019-07-26', 128, NULL),
('Candlewood Suites', 260, '2019-07-27', 238, NULL),
('Candlewood Suites', 260, '2019-07-28', 196, NULL),
('Candlewood Suites', 260, '2019-07-29', 326, NULL),
('Candlewood Suites', 260, '2019-07-30', 297, NULL),
('Candlewood Suites', 260, '2019-07-31', 331, NULL),
('Candlewood Suites', 260, '2019-08-01', 117, NULL),
('Candlewood Suites', 260, '2019-08-02', 151, NULL),
('Candlewood Suites', 260, '2019-08-03', 194, NULL),
('Candlewood Suites', 260, '2019-08-04', 273, NULL),
('Candlewood Suites', 260, '2019-08-05', 339, NULL),
('Candlewood Suites', 260, '2019-08-06', 105, NULL),
('Candlewood Suites', 260, '2019-08-07', 202, NULL),
('Candlewood Suites', 260, '2019-08-08', 204, NULL),
('Candlewood Suites', 260, '2019-08-09', 229, NULL),
('Candlewood Suites', 260, '2019-08-10', 369, NULL),
('Candlewood Suites', 260, '2019-08-11', 101, NULL),
('Candlewood Suites', 260, '2019-08-12', 124, NULL),
('Candlewood Suites', 260, '2019-08-13', 151, NULL),
('Candlewood Suites', 260, '2019-08-14', 254, NULL),
('Candlewood Suites', 260, '2019-08-15', 157, NULL),
('Candlewood Suites', 260, '2019-08-16', 252, NULL),
('Candlewood Suites', 260, '2019-08-17', 292, NULL),
('Candlewood Suites', 260, '2019-08-18', 375, NULL),
('Candlewood Suites', 260, '2019-08-19', 311, NULL),
('Candlewood Suites', 260, '2019-08-20', 121, NULL),
('Candlewood Suites', 260, '2019-08-21', 163, NULL),
('Candlewood Suites', 260, '2019-08-22', 305, NULL),
('Candlewood Suites', 260, '2019-08-23', 384, NULL),
('Candlewood Suites', 260, '2019-08-24', 241, NULL),
('Candlewood Suites', 260, '2019-08-25', 341, NULL),
('Candlewood Suites', 260, '2019-08-26', 318, NULL),
('Candlewood Suites', 260, '2019-08-27', 280, NULL),
('Candlewood Suites', 260, '2019-08-28', 210, NULL),
('Candlewood Suites', 260, '2019-08-29', 121, NULL),
('Candlewood Suites', 260, '2019-08-30', 238, NULL),
('Candlewood Suites', 260, '2019-08-31', 338, NULL),
('Candlewood Suites', 260, '2019-09-01', 169, NULL),
('Candlewood Suites', 260, '2019-09-02', 347, NULL),
('Candlewood Suites', 260, '2019-09-03', 140, NULL),
('Candlewood Suites', 260, '2019-09-04', 266, NULL),
('Candlewood Suites', 260, '2019-09-05', 350, NULL),
('Candlewood Suites', 260, '2019-09-06', 349, NULL),
('Candlewood Suites', 260, '2019-09-07', 360, NULL),
('Candlewood Suites', 260, '2019-09-08', 393, NULL),
('Candlewood Suites', 260, '2019-09-09', 256, NULL),
('Candlewood Suites', 260, '2019-09-10', 101, NULL),
('Candlewood Suites', 260, '2019-09-11', 384, NULL),
('Candlewood Suites', 260, '2019-09-12', 335, NULL),
('Candlewood Suites', 260, '2019-09-13', 329, NULL),
('Candlewood Suites', 260, '2019-09-14', 337, NULL),
('Candlewood Suites', 260, '2019-09-15', 318, NULL),
('Candlewood Suites', 260, '2019-09-16', 377, NULL),
('Candlewood Suites', 260, '2019-09-17', 196, NULL),
('Candlewood Suites', 260, '2019-09-18', 167, NULL),
('Candlewood Suites', 260, '2019-09-19', 255, NULL),
('Candlewood Suites', 260, '2019-09-20', 101, NULL),
('Candlewood Suites', 260, '2019-09-21', 253, NULL),
('Candlewood Suites', 260, '2019-09-22', 126, NULL),
('Candlewood Suites', 260, '2019-09-23', 262, NULL),
('Candlewood Suites', 260, '2019-09-24', 366, NULL),
('Candlewood Suites', 260, '2019-09-25', 367, NULL),
('Candlewood Suites', 260, '2019-09-26', 348, NULL),
('Candlewood Suites', 260, '2019-09-27', 293, NULL),
('Candlewood Suites', 260, '2019-09-28', 290, NULL),
('Candlewood Suites', 260, '2019-09-29', 151, NULL),
('Candlewood Suites', 260, '2019-09-30', 104, NULL),
('Candlewood Suites', 260, '2019-10-01', 244, NULL),
('Candlewood Suites', 260, '2019-10-02', 266, NULL),
('Candlewood Suites', 260, '2019-10-03', 123, NULL),
('Candlewood Suites', 260, '2019-10-04', 144, NULL),
('Candlewood Suites', 260, '2019-10-05', 350, NULL),
('Candlewood Suites', 260, '2019-10-06', 125, NULL),
('Candlewood Suites', 260, '2019-10-07', 363, NULL),
('Candlewood Suites', 260, '2019-10-08', 242, NULL),
('Candlewood Suites', 260, '2019-10-09', 362, NULL),
('Candlewood Suites', 260, '2019-10-10', 267, NULL),
('Candlewood Suites', 260, '2019-10-11', 219, NULL),
('Candlewood Suites', 260, '2019-10-12', 288, NULL),
('Candlewood Suites', 260, '2019-10-13', 128, NULL),
('Candlewood Suites', 260, '2019-10-14', 257, NULL),
('Candlewood Suites', 260, '2019-10-15', 310, NULL),
('Candlewood Suites', 260, '2019-10-16', 225, NULL),
('Candlewood Suites', 260, '2019-10-17', 208, NULL),
('Candlewood Suites', 260, '2019-10-18', 324, NULL),
('Candlewood Suites', 260, '2019-10-19', 306, NULL),
('Candlewood Suites', 260, '2019-10-20', 369, NULL),
('Candlewood Suites', 260, '2019-10-21', 113, NULL),
('Candlewood Suites', 260, '2019-10-22', 353, NULL),
('Candlewood Suites', 260, '2019-10-23', 365, NULL),
('Candlewood Suites', 260, '2019-10-24', 251, NULL),
('Candlewood Suites', 260, '2019-10-25', 201, NULL),
('Candlewood Suites', 260, '2019-10-26', 292, NULL),
('Candlewood Suites', 260, '2019-10-27', 219, NULL),
('Candlewood Suites', 260, '2019-10-28', 209, NULL),
('Candlewood Suites', 260, '2019-10-29', 257, NULL),
('Candlewood Suites', 260, '2019-10-30', 102, NULL),
('Candlewood Suites', 260, '2019-10-31', 338, NULL),
('Candlewood Suites', 260, '2019-11-01', 270, NULL),
('Candlewood Suites', 260, '2019-11-02', 345, NULL),
('Candlewood Suites', 260, '2019-11-03', 291, NULL),
('Candlewood Suites', 260, '2019-11-04', 121, NULL),
('Candlewood Suites', 260, '2019-11-05', 271, NULL),
('Candlewood Suites', 260, '2019-11-06', 139, NULL),
('Candlewood Suites', 260, '2019-11-07', 287, NULL),
('Candlewood Suites', 260, '2019-11-08', 229, NULL),
('Candlewood Suites', 260, '2019-11-09', 370, NULL),
('Candlewood Suites', 260, '2019-11-10', 210, NULL),
('Candlewood Suites', 260, '2019-11-11', 199, NULL),
('Candlewood Suites', 260, '2019-11-12', 399, NULL),
('Candlewood Suites', 260, '2019-11-13', 162, NULL),
('Candlewood Suites', 260, '2019-11-14', 164, NULL),
('Candlewood Suites', 260, '2019-11-15', 383, NULL),
('Candlewood Suites', 260, '2019-11-16', 304, NULL),
('Candlewood Suites', 260, '2019-11-17', 280, NULL),
('Candlewood Suites', 260, '2019-11-18', 175, NULL),
('Candlewood Suites', 260, '2019-11-19', 184, NULL),
('Candlewood Suites', 260, '2019-11-20', 235, NULL),
('Candlewood Suites', 260, '2019-11-21', 235, NULL),
('Candlewood Suites', 260, '2019-11-22', 219, NULL),
('Candlewood Suites', 260, '2019-11-23', 106, NULL),
('Candlewood Suites', 260, '2019-11-24', 270, NULL),
('Candlewood Suites', 260, '2019-11-25', 157, NULL),
('Candlewood Suites', 260, '2019-11-26', 276, NULL),
('Candlewood Suites', 260, '2019-11-27', 265, NULL),
('Candlewood Suites', 260, '2019-11-28', 397, NULL),
('Candlewood Suites', 260, '2019-11-29', 174, NULL),
('Candlewood Suites', 260, '2019-11-30', 263, NULL),
('Candlewood Suites', 260, '2019-12-01', 284, NULL),
('Candlewood Suites', 260, '2019-12-02', 290, NULL),
('Candlewood Suites', 260, '2019-12-03', 112, NULL),
('Candlewood Suites', 260, '2019-12-04', 138, NULL),
('Candlewood Suites', 260, '2019-12-05', 175, NULL),
('Candlewood Suites', 260, '2019-12-06', 151, NULL),
('Candlewood Suites', 260, '2019-12-07', 310, NULL),
('Candlewood Suites', 260, '2019-12-08', 249, NULL),
('Candlewood Suites', 260, '2019-12-09', 208, NULL),
('Candlewood Suites', 260, '2019-12-10', 191, NULL),
('Candlewood Suites', 260, '2019-12-11', 123, NULL),
('Candlewood Suites', 260, '2019-12-12', 121, NULL),
('Candlewood Suites', 260, '2019-12-13', 237, NULL),
('Candlewood Suites', 260, '2019-12-14', 266, NULL),
('Candlewood Suites', 260, '2019-12-15', 186, NULL),
('Candlewood Suites', 260, '2019-12-16', 200, NULL),
('Candlewood Suites', 260, '2019-12-17', 316, NULL),
('Candlewood Suites', 260, '2019-12-18', 320, NULL),
('Candlewood Suites', 260, '2019-12-19', 179, NULL),
('Candlewood Suites', 260, '2019-12-20', 356, NULL),
('Candlewood Suites', 260, '2019-12-21', 345, NULL),
('Candlewood Suites', 260, '2019-12-22', 399, NULL),
('Candlewood Suites', 260, '2019-12-23', 312, NULL),
('Candlewood Suites', 260, '2019-12-24', 150, NULL),
('Candlewood Suites', 260, '2019-12-25', 386, NULL),
('Candlewood Suites', 260, '2019-12-26', 225, NULL),
('Candlewood Suites', 260, '2019-12-27', 383, NULL),
('Candlewood Suites', 260, '2019-12-28', 110, NULL),
('Candlewood Suites', 260, '2019-12-29', 265, NULL),
('Candlewood Suites', 260, '2019-12-30', 387, NULL),
('Candlewood Suites', 260, '2019-12-31', 292, NULL),
('Candlewood Suites', 260, '2020-01-01', 212, NULL),
('Candlewood Suites', 260, '2020-01-02', 333, NULL),
('Candlewood Suites', 260, '2020-01-03', 233, NULL),
('Candlewood Suites', 260, '2020-01-04', 152, NULL),
('Candlewood Suites', 260, '2020-01-05', 124, NULL),
('Candlewood Suites', 260, '2020-01-06', 105, NULL),
('Candlewood Suites', 260, '2020-01-07', 242, NULL),
('Candlewood Suites', 260, '2020-01-08', 221, NULL),
('Candlewood Suites', 260, '2020-01-09', 145, NULL),
('Candlewood Suites', 260, '2020-01-10', 110, NULL),
('Candlewood Suites', 260, '2020-01-11', 238, NULL),
('Candlewood Suites', 260, '2020-01-12', 344, NULL),
('Candlewood Suites', 260, '2020-01-13', 397, NULL),
('Candlewood Suites', 260, '2020-01-14', 154, NULL),
('Candlewood Suites', 260, '2020-01-15', 102, NULL),
('Candlewood Suites', 260, '2020-01-16', 150, NULL),
('Candlewood Suites', 260, '2020-01-17', 359, NULL),
('Candlewood Suites', 260, '2020-01-18', 249, NULL),
('Candlewood Suites', 260, '2020-01-19', 129, NULL),
('Candlewood Suites', 260, '2020-01-20', 232, NULL),
('Candlewood Suites', 260, '2020-01-21', 389, NULL),
('Candlewood Suites', 260, '2020-01-22', 225, NULL),
('Candlewood Suites', 260, '2020-01-23', 164, NULL),
('Candlewood Suites', 260, '2020-01-24', 111, NULL),
('Candlewood Suites', 260, '2020-01-25', 119, NULL),
('Candlewood Suites', 260, '2020-01-26', 399, NULL),
('Candlewood Suites', 260, '2020-01-27', 350, NULL),
('Candlewood Suites', 260, '2020-01-28', 341, NULL),
('Candlewood Suites', 260, '2020-01-29', 381, NULL),
('Candlewood Suites', 260, '2020-01-30', 345, NULL),
('Candlewood Suites', 260, '2020-01-31', 198, NULL),
('Candlewood Suites', 260, '2020-02-01', 300, NULL),
('Candlewood Suites', 260, '2020-02-02', 143, NULL),
('Candlewood Suites', 260, '2020-02-03', 366, NULL),
('Candlewood Suites', 260, '2020-02-04', 318, NULL),
('Candlewood Suites', 276, '2019-01-01', 233, NULL),
('Candlewood Suites', 276, '2019-01-02', 187, NULL),
('Candlewood Suites', 276, '2019-01-03', 159, NULL),
('Candlewood Suites', 276, '2019-01-04', 361, NULL),
('Candlewood Suites', 276, '2019-01-05', 324, NULL),
('Candlewood Suites', 276, '2019-01-06', 286, NULL),
('Candlewood Suites', 276, '2019-01-07', 196, NULL),
('Candlewood Suites', 276, '2019-01-08', 174, NULL),
('Candlewood Suites', 276, '2019-01-09', 390, NULL),
('Candlewood Suites', 276, '2019-01-10', 130, NULL),
('Candlewood Suites', 276, '2019-01-11', 291, NULL),
('Candlewood Suites', 276, '2019-01-12', 185, NULL),
('Candlewood Suites', 276, '2019-01-13', 362, NULL),
('Candlewood Suites', 276, '2019-01-14', 117, NULL),
('Candlewood Suites', 276, '2019-01-15', 268, NULL),
('Candlewood Suites', 276, '2019-01-16', 275, NULL),
('Candlewood Suites', 276, '2019-01-17', 212, NULL),
('Candlewood Suites', 276, '2019-01-18', 152, NULL),
('Candlewood Suites', 276, '2019-01-19', 321, NULL),
('Candlewood Suites', 276, '2019-01-20', 237, NULL),
('Candlewood Suites', 276, '2019-01-21', 284, NULL),
('Candlewood Suites', 276, '2019-01-22', 232, NULL),
('Candlewood Suites', 276, '2019-01-23', 237, NULL),
('Candlewood Suites', 276, '2019-01-24', 293, NULL),
('Candlewood Suites', 276, '2019-01-25', 190, NULL),
('Candlewood Suites', 276, '2019-01-26', 110, NULL),
('Candlewood Suites', 276, '2019-01-27', 281, NULL),
('Candlewood Suites', 276, '2019-01-28', 135, NULL),
('Candlewood Suites', 276, '2019-01-29', 155, NULL),
('Candlewood Suites', 276, '2019-01-30', 383, NULL),
('Candlewood Suites', 276, '2019-01-31', 154, NULL),
('Candlewood Suites', 276, '2019-02-01', 211, NULL),
('Candlewood Suites', 276, '2019-02-02', 291, NULL),
('Candlewood Suites', 276, '2019-02-03', 101, NULL),
('Candlewood Suites', 276, '2019-02-04', 131, NULL),
('Candlewood Suites', 276, '2019-02-05', 128, NULL),
('Candlewood Suites', 276, '2019-02-06', 180, NULL),
('Candlewood Suites', 276, '2019-02-07', 259, NULL),
('Candlewood Suites', 276, '2019-02-08', 272, NULL),
('Candlewood Suites', 276, '2019-02-09', 329, NULL),
('Candlewood Suites', 276, '2019-02-10', 293, NULL),
('Candlewood Suites', 276, '2019-02-11', 205, NULL),
('Candlewood Suites', 276, '2019-02-12', 252, NULL),
('Candlewood Suites', 276, '2019-02-13', 377, NULL),
('Candlewood Suites', 276, '2019-02-14', 280, NULL),
('Candlewood Suites', 276, '2019-02-15', 109, NULL),
('Candlewood Suites', 276, '2019-02-16', 264, NULL),
('Candlewood Suites', 276, '2019-02-17', 181, NULL),
('Candlewood Suites', 276, '2019-02-18', 188, NULL),
('Candlewood Suites', 276, '2019-02-19', 222, NULL),
('Candlewood Suites', 276, '2019-02-20', 268, NULL),
('Candlewood Suites', 276, '2019-02-21', 367, NULL),
('Candlewood Suites', 276, '2019-02-22', 290, NULL),
('Candlewood Suites', 276, '2019-02-23', 109, NULL),
('Candlewood Suites', 276, '2019-02-24', 172, NULL),
('Candlewood Suites', 276, '2019-02-25', 303, NULL),
('Candlewood Suites', 276, '2019-02-26', 174, NULL),
('Candlewood Suites', 276, '2019-02-27', 205, NULL),
('Candlewood Suites', 276, '2019-02-28', 232, NULL),
('Candlewood Suites', 276, '2019-03-01', 248, NULL),
('Candlewood Suites', 276, '2019-03-02', 364, NULL),
('Candlewood Suites', 276, '2019-03-03', 199, NULL),
('Candlewood Suites', 276, '2019-03-04', 177, NULL),
('Candlewood Suites', 276, '2019-03-05', 308, NULL),
('Candlewood Suites', 276, '2019-03-06', 270, NULL),
('Candlewood Suites', 276, '2019-03-07', 299, NULL),
('Candlewood Suites', 276, '2019-03-08', 222, NULL),
('Candlewood Suites', 276, '2019-03-09', 213, NULL),
('Candlewood Suites', 276, '2019-03-10', 376, NULL),
('Candlewood Suites', 276, '2019-03-11', 166, NULL),
('Candlewood Suites', 276, '2019-03-12', 135, NULL),
('Candlewood Suites', 276, '2019-03-13', 375, NULL),
('Candlewood Suites', 276, '2019-03-14', 136, NULL),
('Candlewood Suites', 276, '2019-03-15', 210, NULL),
('Candlewood Suites', 276, '2019-03-16', 344, NULL),
('Candlewood Suites', 276, '2019-03-17', 109, NULL),
('Candlewood Suites', 276, '2019-03-18', 289, NULL),
('Candlewood Suites', 276, '2019-03-19', 116, NULL),
('Candlewood Suites', 276, '2019-03-20', 169, NULL),
('Candlewood Suites', 276, '2019-03-21', 303, NULL),
('Candlewood Suites', 276, '2019-03-22', 378, NULL),
('Candlewood Suites', 276, '2019-03-23', 242, NULL),
('Candlewood Suites', 276, '2019-03-24', 324, NULL),
('Candlewood Suites', 276, '2019-03-25', 308, NULL),
('Candlewood Suites', 276, '2019-03-26', 193, NULL),
('Candlewood Suites', 276, '2019-03-27', 272, NULL),
('Candlewood Suites', 276, '2019-03-28', 328, NULL),
('Candlewood Suites', 276, '2019-03-29', 120, NULL),
('Candlewood Suites', 276, '2019-03-30', 263, NULL),
('Candlewood Suites', 276, '2019-03-31', 140, NULL),
('Candlewood Suites', 276, '2019-04-01', 352, NULL),
('Candlewood Suites', 276, '2019-04-02', 382, NULL),
('Candlewood Suites', 276, '2019-04-03', 314, NULL),
('Candlewood Suites', 276, '2019-04-04', 391, NULL),
('Candlewood Suites', 276, '2019-04-05', 131, NULL),
('Candlewood Suites', 276, '2019-04-06', 375, NULL),
('Candlewood Suites', 276, '2019-04-07', 212, NULL),
('Candlewood Suites', 276, '2019-04-08', 372, NULL),
('Candlewood Suites', 276, '2019-04-09', 290, NULL),
('Candlewood Suites', 276, '2019-04-10', 250, NULL),
('Candlewood Suites', 276, '2019-04-11', 294, NULL),
('Candlewood Suites', 276, '2019-04-12', 278, NULL),
('Candlewood Suites', 276, '2019-04-13', 378, NULL),
('Candlewood Suites', 276, '2019-04-14', 133, NULL),
('Candlewood Suites', 276, '2019-04-15', 301, NULL),
('Candlewood Suites', 276, '2019-04-16', 136, NULL),
('Candlewood Suites', 276, '2019-04-17', 370, NULL),
('Candlewood Suites', 276, '2019-04-18', 381, NULL),
('Candlewood Suites', 276, '2019-04-19', 358, NULL),
('Candlewood Suites', 276, '2019-04-20', 234, NULL),
('Candlewood Suites', 276, '2019-04-21', 332, NULL),
('Candlewood Suites', 276, '2019-04-22', 268, NULL),
('Candlewood Suites', 276, '2019-04-23', 271, NULL),
('Candlewood Suites', 276, '2019-04-24', 181, NULL),
('Candlewood Suites', 276, '2019-04-25', 231, NULL),
('Candlewood Suites', 276, '2019-04-26', 305, NULL),
('Candlewood Suites', 276, '2019-04-27', 227, NULL),
('Candlewood Suites', 276, '2019-04-28', 269, NULL),
('Candlewood Suites', 276, '2019-04-29', 126, NULL),
('Candlewood Suites', 276, '2019-04-30', 372, NULL),
('Candlewood Suites', 276, '2019-05-01', 246, NULL),
('Candlewood Suites', 276, '2019-05-02', 130, NULL),
('Candlewood Suites', 276, '2019-05-03', 375, NULL),
('Candlewood Suites', 276, '2019-05-04', 244, NULL),
('Candlewood Suites', 276, '2019-05-05', 306, NULL),
('Candlewood Suites', 276, '2019-05-06', 312, NULL),
('Candlewood Suites', 276, '2019-05-07', 179, NULL),
('Candlewood Suites', 276, '2019-05-08', 374, NULL),
('Candlewood Suites', 276, '2019-05-09', 191, NULL),
('Candlewood Suites', 276, '2019-05-10', 188, NULL),
('Candlewood Suites', 276, '2019-05-11', 374, NULL),
('Candlewood Suites', 276, '2019-05-12', 203, NULL),
('Candlewood Suites', 276, '2019-05-13', 193, NULL),
('Candlewood Suites', 276, '2019-05-14', 313, NULL),
('Candlewood Suites', 276, '2019-05-15', 393, NULL),
('Candlewood Suites', 276, '2019-05-16', 145, NULL),
('Candlewood Suites', 276, '2019-05-17', 227, NULL),
('Candlewood Suites', 276, '2019-05-18', 176, NULL),
('Candlewood Suites', 276, '2019-05-19', 267, NULL),
('Candlewood Suites', 276, '2019-05-20', 319, NULL),
('Candlewood Suites', 276, '2019-05-21', 145, NULL),
('Candlewood Suites', 276, '2019-05-22', 226, NULL),
('Candlewood Suites', 276, '2019-05-23', 190, NULL),
('Candlewood Suites', 276, '2019-05-24', 356, NULL),
('Candlewood Suites', 276, '2019-05-25', 281, NULL),
('Candlewood Suites', 276, '2019-05-26', 383, NULL),
('Candlewood Suites', 276, '2019-05-27', 215, NULL),
('Candlewood Suites', 276, '2019-05-28', 161, NULL),
('Candlewood Suites', 276, '2019-05-29', 147, NULL),
('Candlewood Suites', 276, '2019-05-30', 299, NULL),
('Candlewood Suites', 276, '2019-05-31', 117, NULL),
('Candlewood Suites', 276, '2019-06-01', 316, NULL),
('Candlewood Suites', 276, '2019-06-02', 289, NULL),
('Candlewood Suites', 276, '2019-06-03', 336, NULL),
('Candlewood Suites', 276, '2019-06-04', 359, NULL),
('Candlewood Suites', 276, '2019-06-05', 362, NULL),
('Candlewood Suites', 276, '2019-06-06', 242, NULL),
('Candlewood Suites', 276, '2019-06-07', 351, NULL),
('Candlewood Suites', 276, '2019-06-08', 161, NULL),
('Candlewood Suites', 276, '2019-06-09', 312, NULL),
('Candlewood Suites', 276, '2019-06-10', 163, NULL),
('Candlewood Suites', 276, '2019-06-11', 145, NULL),
('Candlewood Suites', 276, '2019-06-12', 229, NULL),
('Candlewood Suites', 276, '2019-06-13', 248, NULL),
('Candlewood Suites', 276, '2019-06-14', 350, NULL),
('Candlewood Suites', 276, '2019-06-15', 159, NULL),
('Candlewood Suites', 276, '2019-06-16', 210, NULL),
('Candlewood Suites', 276, '2019-06-17', 274, NULL),
('Candlewood Suites', 276, '2019-06-18', 213, NULL),
('Candlewood Suites', 276, '2019-06-19', 331, NULL),
('Candlewood Suites', 276, '2019-06-20', 353, NULL),
('Candlewood Suites', 276, '2019-06-21', 300, NULL),
('Candlewood Suites', 276, '2019-06-22', 168, NULL),
('Candlewood Suites', 276, '2019-06-23', 192, NULL),
('Candlewood Suites', 276, '2019-06-24', 292, NULL),
('Candlewood Suites', 276, '2019-06-25', 133, NULL),
('Candlewood Suites', 276, '2019-06-26', 127, NULL),
('Candlewood Suites', 276, '2019-06-27', 206, NULL),
('Candlewood Suites', 276, '2019-06-28', 124, NULL),
('Candlewood Suites', 276, '2019-06-29', 217, NULL),
('Candlewood Suites', 276, '2019-06-30', 273, NULL),
('Candlewood Suites', 276, '2019-07-01', 322, NULL),
('Candlewood Suites', 276, '2019-07-02', 173, NULL),
('Candlewood Suites', 276, '2019-07-03', 206, NULL),
('Candlewood Suites', 276, '2019-07-04', 112, NULL),
('Candlewood Suites', 276, '2019-07-05', 247, NULL),
('Candlewood Suites', 276, '2019-07-06', 358, NULL),
('Candlewood Suites', 276, '2019-07-07', 385, NULL),
('Candlewood Suites', 276, '2019-07-08', 114, NULL),
('Candlewood Suites', 276, '2019-07-09', 175, NULL),
('Candlewood Suites', 276, '2019-07-10', 338, NULL),
('Candlewood Suites', 276, '2019-07-11', 337, NULL),
('Candlewood Suites', 276, '2019-07-12', 339, NULL),
('Candlewood Suites', 276, '2019-07-13', 158, NULL),
('Candlewood Suites', 276, '2019-07-14', 338, NULL),
('Candlewood Suites', 276, '2019-07-15', 383, NULL),
('Candlewood Suites', 276, '2019-07-16', 182, NULL),
('Candlewood Suites', 276, '2019-07-17', 391, NULL),
('Candlewood Suites', 276, '2019-07-18', 270, NULL),
('Candlewood Suites', 276, '2019-07-19', 378, NULL),
('Candlewood Suites', 276, '2019-07-20', 205, NULL),
('Candlewood Suites', 276, '2019-07-21', 324, NULL),
('Candlewood Suites', 276, '2019-07-22', 174, NULL),
('Candlewood Suites', 276, '2019-07-23', 271, NULL),
('Candlewood Suites', 276, '2019-07-24', 281, NULL),
('Candlewood Suites', 276, '2019-07-25', 163, NULL),
('Candlewood Suites', 276, '2019-07-26', 295, NULL),
('Candlewood Suites', 276, '2019-07-27', 146, NULL),
('Candlewood Suites', 276, '2019-07-28', 224, NULL),
('Candlewood Suites', 276, '2019-07-29', 297, NULL),
('Candlewood Suites', 276, '2019-07-30', 197, NULL),
('Candlewood Suites', 276, '2019-07-31', 141, NULL),
('Candlewood Suites', 276, '2019-08-01', 259, NULL),
('Candlewood Suites', 276, '2019-08-02', 162, NULL),
('Candlewood Suites', 276, '2019-08-03', 396, NULL),
('Candlewood Suites', 276, '2019-08-04', 215, NULL),
('Candlewood Suites', 276, '2019-08-05', 125, NULL),
('Candlewood Suites', 276, '2019-08-06', 344, NULL),
('Candlewood Suites', 276, '2019-08-07', 228, NULL),
('Candlewood Suites', 276, '2019-08-08', 165, NULL),
('Candlewood Suites', 276, '2019-08-09', 357, NULL),
('Candlewood Suites', 276, '2019-08-10', 100, NULL),
('Candlewood Suites', 276, '2019-08-11', 127, NULL),
('Candlewood Suites', 276, '2019-08-12', 379, NULL),
('Candlewood Suites', 276, '2019-08-13', 252, NULL),
('Candlewood Suites', 276, '2019-08-14', 257, NULL),
('Candlewood Suites', 276, '2019-08-15', 128, NULL),
('Candlewood Suites', 276, '2019-08-16', 343, NULL),
('Candlewood Suites', 276, '2019-08-17', 260, NULL),
('Candlewood Suites', 276, '2019-08-18', 310, NULL),
('Candlewood Suites', 276, '2019-08-19', 172, NULL),
('Candlewood Suites', 276, '2019-08-20', 194, NULL),
('Candlewood Suites', 276, '2019-08-21', 131, NULL),
('Candlewood Suites', 276, '2019-08-22', 308, NULL),
('Candlewood Suites', 276, '2019-08-23', 362, NULL),
('Candlewood Suites', 276, '2019-08-24', 127, NULL),
('Candlewood Suites', 276, '2019-08-25', 265, NULL),
('Candlewood Suites', 276, '2019-08-26', 217, NULL),
('Candlewood Suites', 276, '2019-08-27', 185, NULL),
('Candlewood Suites', 276, '2019-08-28', 304, NULL),
('Candlewood Suites', 276, '2019-08-29', 241, NULL),
('Candlewood Suites', 276, '2019-08-30', 242, NULL),
('Candlewood Suites', 276, '2019-08-31', 282, NULL),
('Candlewood Suites', 276, '2019-09-01', 272, NULL),
('Candlewood Suites', 276, '2019-09-02', 170, NULL),
('Candlewood Suites', 276, '2019-09-03', 151, NULL),
('Candlewood Suites', 276, '2019-09-04', 380, NULL),
('Candlewood Suites', 276, '2019-09-05', 199, NULL),
('Candlewood Suites', 276, '2019-09-06', 121, NULL),
('Candlewood Suites', 276, '2019-09-07', 211, NULL),
('Candlewood Suites', 276, '2019-09-08', 133, NULL),
('Candlewood Suites', 276, '2019-09-09', 260, NULL),
('Candlewood Suites', 276, '2019-09-10', 253, NULL),
('Candlewood Suites', 276, '2019-09-11', 398, NULL),
('Candlewood Suites', 276, '2019-09-12', 340, NULL),
('Candlewood Suites', 276, '2019-09-13', 165, NULL),
('Candlewood Suites', 276, '2019-09-14', 258, NULL),
('Candlewood Suites', 276, '2019-09-15', 198, NULL),
('Candlewood Suites', 276, '2019-09-16', 165, NULL),
('Candlewood Suites', 276, '2019-09-17', 198, NULL),
('Candlewood Suites', 276, '2019-09-18', 178, NULL),
('Candlewood Suites', 276, '2019-09-19', 370, NULL),
('Candlewood Suites', 276, '2019-09-20', 372, NULL),
('Candlewood Suites', 276, '2019-09-21', 102, NULL),
('Candlewood Suites', 276, '2019-09-22', 326, NULL),
('Candlewood Suites', 276, '2019-09-23', 318, NULL),
('Candlewood Suites', 276, '2019-09-24', 342, NULL),
('Candlewood Suites', 276, '2019-09-25', 395, NULL),
('Candlewood Suites', 276, '2019-09-26', 132, NULL),
('Candlewood Suites', 276, '2019-09-27', 370, NULL),
('Candlewood Suites', 276, '2019-09-28', 202, NULL),
('Candlewood Suites', 276, '2019-09-29', 315, NULL),
('Candlewood Suites', 276, '2019-09-30', 123, NULL),
('Candlewood Suites', 276, '2019-10-01', 288, NULL),
('Candlewood Suites', 276, '2019-10-02', 363, NULL),
('Candlewood Suites', 276, '2019-10-03', 346, NULL),
('Candlewood Suites', 276, '2019-10-04', 222, NULL),
('Candlewood Suites', 276, '2019-10-05', 173, NULL),
('Candlewood Suites', 276, '2019-10-06', 153, NULL),
('Candlewood Suites', 276, '2019-10-07', 270, NULL),
('Candlewood Suites', 276, '2019-10-08', 326, NULL),
('Candlewood Suites', 276, '2019-10-09', 132, NULL),
('Candlewood Suites', 276, '2019-10-10', 228, NULL),
('Candlewood Suites', 276, '2019-10-11', 206, NULL),
('Candlewood Suites', 276, '2019-10-12', 385, NULL),
('Candlewood Suites', 276, '2019-10-13', 156, NULL),
('Candlewood Suites', 276, '2019-10-14', 159, NULL),
('Candlewood Suites', 276, '2019-10-15', 363, NULL),
('Candlewood Suites', 276, '2019-10-16', 176, NULL),
('Candlewood Suites', 276, '2019-10-17', 308, NULL),
('Candlewood Suites', 276, '2019-10-18', 162, NULL),
('Candlewood Suites', 276, '2019-10-19', 153, NULL),
('Candlewood Suites', 276, '2019-10-20', 300, NULL),
('Candlewood Suites', 276, '2019-10-21', 374, NULL),
('Candlewood Suites', 276, '2019-10-22', 147, NULL),
('Candlewood Suites', 276, '2019-10-23', 188, NULL),
('Candlewood Suites', 276, '2019-10-24', 324, NULL),
('Candlewood Suites', 276, '2019-10-25', 166, NULL),
('Candlewood Suites', 276, '2019-10-26', 232, NULL),
('Candlewood Suites', 276, '2019-10-27', 170, NULL),
('Candlewood Suites', 276, '2019-10-28', 365, NULL),
('Candlewood Suites', 276, '2019-10-29', 197, NULL),
('Candlewood Suites', 276, '2019-10-30', 228, NULL),
('Candlewood Suites', 276, '2019-10-31', 372, NULL),
('Candlewood Suites', 276, '2019-11-01', 325, NULL),
('Candlewood Suites', 276, '2019-11-02', 293, NULL),
('Candlewood Suites', 276, '2019-11-03', 316, NULL),
('Candlewood Suites', 276, '2019-11-04', 166, NULL),
('Candlewood Suites', 276, '2019-11-05', 384, NULL),
('Candlewood Suites', 276, '2019-11-06', 346, NULL),
('Candlewood Suites', 276, '2019-11-07', 333, NULL),
('Candlewood Suites', 276, '2019-11-08', 211, NULL),
('Candlewood Suites', 276, '2019-11-09', 271, NULL),
('Candlewood Suites', 276, '2019-11-10', 290, NULL),
('Candlewood Suites', 276, '2019-11-11', 185, NULL),
('Candlewood Suites', 276, '2019-11-12', 268, NULL),
('Candlewood Suites', 276, '2019-11-13', 292, NULL),
('Candlewood Suites', 276, '2019-11-14', 177, NULL),
('Candlewood Suites', 276, '2019-11-15', 280, NULL),
('Candlewood Suites', 276, '2019-11-16', 223, NULL),
('Candlewood Suites', 276, '2019-11-17', 343, NULL),
('Candlewood Suites', 276, '2019-11-18', 381, NULL),
('Candlewood Suites', 276, '2019-11-19', 229, NULL),
('Candlewood Suites', 276, '2019-11-20', 100, NULL),
('Candlewood Suites', 276, '2019-11-21', 118, NULL),
('Candlewood Suites', 276, '2019-11-22', 188, NULL),
('Candlewood Suites', 276, '2019-11-23', 151, NULL),
('Candlewood Suites', 276, '2019-11-24', 150, NULL),
('Candlewood Suites', 276, '2019-11-25', 194, NULL),
('Candlewood Suites', 276, '2019-11-26', 175, NULL),
('Candlewood Suites', 276, '2019-11-27', 244, NULL),
('Candlewood Suites', 276, '2019-11-28', 168, NULL),
('Candlewood Suites', 276, '2019-11-29', 182, NULL),
('Candlewood Suites', 276, '2019-11-30', 359, NULL),
('Candlewood Suites', 276, '2019-12-01', 192, NULL),
('Candlewood Suites', 276, '2019-12-02', 138, NULL),
('Candlewood Suites', 276, '2019-12-03', 198, NULL),
('Candlewood Suites', 276, '2019-12-04', 318, NULL),
('Candlewood Suites', 276, '2019-12-05', 335, NULL),
('Candlewood Suites', 276, '2019-12-06', 160, NULL),
('Candlewood Suites', 276, '2019-12-07', 315, NULL),
('Candlewood Suites', 276, '2019-12-08', 198, NULL),
('Candlewood Suites', 276, '2019-12-09', 162, NULL),
('Candlewood Suites', 276, '2019-12-10', 337, NULL),
('Candlewood Suites', 276, '2019-12-11', 239, NULL),
('Candlewood Suites', 276, '2019-12-12', 253, NULL),
('Candlewood Suites', 276, '2019-12-13', 387, NULL),
('Candlewood Suites', 276, '2019-12-14', 336, NULL),
('Candlewood Suites', 276, '2019-12-15', 158, NULL),
('Candlewood Suites', 276, '2019-12-16', 376, NULL),
('Candlewood Suites', 276, '2019-12-17', 386, NULL),
('Candlewood Suites', 276, '2019-12-18', 300, NULL),
('Candlewood Suites', 276, '2019-12-19', 267, NULL),
('Candlewood Suites', 276, '2019-12-20', 344, NULL),
('Candlewood Suites', 276, '2019-12-21', 124, NULL),
('Candlewood Suites', 276, '2019-12-22', 315, NULL),
('Candlewood Suites', 276, '2019-12-23', 340, NULL),
('Candlewood Suites', 276, '2019-12-24', 367, NULL),
('Candlewood Suites', 276, '2019-12-25', 360, NULL),
('Candlewood Suites', 276, '2019-12-26', 169, NULL),
('Candlewood Suites', 276, '2019-12-27', 346, NULL),
('Candlewood Suites', 276, '2019-12-28', 188, NULL),
('Candlewood Suites', 276, '2019-12-29', 118, NULL),
('Candlewood Suites', 276, '2019-12-30', 125, NULL),
('Candlewood Suites', 276, '2019-12-31', 189, NULL),
('Candlewood Suites', 276, '2020-01-01', 228, NULL),
('Candlewood Suites', 276, '2020-01-02', 351, NULL),
('Candlewood Suites', 276, '2020-01-03', 244, NULL),
('Candlewood Suites', 276, '2020-01-04', 334, NULL),
('Candlewood Suites', 276, '2020-01-05', 202, NULL),
('Candlewood Suites', 276, '2020-01-06', 256, NULL),
('Candlewood Suites', 276, '2020-01-07', 244, NULL),
('Candlewood Suites', 276, '2020-01-08', 194, NULL),
('Candlewood Suites', 276, '2020-01-09', 313, NULL),
('Candlewood Suites', 276, '2020-01-10', 244, NULL),
('Candlewood Suites', 276, '2020-01-11', 163, NULL),
('Candlewood Suites', 276, '2020-01-12', 113, NULL),
('Candlewood Suites', 276, '2020-01-13', 156, NULL),
('Candlewood Suites', 276, '2020-01-14', 244, NULL),
('Candlewood Suites', 276, '2020-01-15', 201, NULL),
('Candlewood Suites', 276, '2020-01-16', 128, NULL),
('Candlewood Suites', 276, '2020-01-17', 370, NULL),
('Candlewood Suites', 276, '2020-01-18', 325, NULL),
('Candlewood Suites', 276, '2020-01-19', 145, NULL),
('Candlewood Suites', 276, '2020-01-20', 149, NULL),
('Candlewood Suites', 276, '2020-01-21', 112, NULL),
('Candlewood Suites', 276, '2020-01-22', 395, NULL),
('Candlewood Suites', 276, '2020-01-23', 134, NULL),
('Candlewood Suites', 276, '2020-01-24', 146, NULL),
('Candlewood Suites', 276, '2020-01-25', 369, NULL),
('Candlewood Suites', 276, '2020-01-26', 348, NULL),
('Candlewood Suites', 276, '2020-01-27', 194, NULL),
('Candlewood Suites', 276, '2020-01-28', 336, NULL),
('Candlewood Suites', 276, '2020-01-29', 145, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Candlewood Suites', 276, '2020-01-30', 302, NULL),
('Candlewood Suites', 276, '2020-01-31', 168, NULL),
('Candlewood Suites', 276, '2020-02-01', 210, NULL),
('Candlewood Suites', 276, '2020-02-02', 138, NULL),
('Candlewood Suites', 276, '2020-02-03', 261, NULL),
('Candlewood Suites', 276, '2020-02-04', 139, NULL),
('Candlewood Suites', 296, '2019-01-01', 157, NULL),
('Candlewood Suites', 296, '2019-01-02', 227, NULL),
('Candlewood Suites', 296, '2019-01-03', 341, NULL),
('Candlewood Suites', 296, '2019-01-04', 212, NULL),
('Candlewood Suites', 296, '2019-01-05', 308, NULL),
('Candlewood Suites', 296, '2019-01-06', 167, NULL),
('Candlewood Suites', 296, '2019-01-07', 333, NULL),
('Candlewood Suites', 296, '2019-01-08', 333, NULL),
('Candlewood Suites', 296, '2019-01-09', 215, NULL),
('Candlewood Suites', 296, '2019-01-10', 382, NULL),
('Candlewood Suites', 296, '2019-01-11', 292, NULL),
('Candlewood Suites', 296, '2019-01-12', 171, NULL),
('Candlewood Suites', 296, '2019-01-13', 376, NULL),
('Candlewood Suites', 296, '2019-01-14', 363, NULL),
('Candlewood Suites', 296, '2019-01-15', 363, NULL),
('Candlewood Suites', 296, '2019-01-16', 239, NULL),
('Candlewood Suites', 296, '2019-01-17', 109, NULL),
('Candlewood Suites', 296, '2019-01-18', 393, NULL),
('Candlewood Suites', 296, '2019-01-19', 332, NULL),
('Candlewood Suites', 296, '2019-01-20', 272, NULL),
('Candlewood Suites', 296, '2019-01-21', 302, NULL),
('Candlewood Suites', 296, '2019-01-22', 164, NULL),
('Candlewood Suites', 296, '2019-01-23', 302, NULL),
('Candlewood Suites', 296, '2019-01-24', 309, NULL),
('Candlewood Suites', 296, '2019-01-25', 197, NULL),
('Candlewood Suites', 296, '2019-01-26', 117, NULL),
('Candlewood Suites', 296, '2019-01-27', 106, NULL),
('Candlewood Suites', 296, '2019-01-28', 156, NULL),
('Candlewood Suites', 296, '2019-01-29', 337, NULL),
('Candlewood Suites', 296, '2019-01-30', 125, NULL),
('Candlewood Suites', 296, '2019-01-31', 191, NULL),
('Candlewood Suites', 296, '2019-02-01', 355, NULL),
('Candlewood Suites', 296, '2019-02-02', 341, NULL),
('Candlewood Suites', 296, '2019-02-03', 330, NULL),
('Candlewood Suites', 296, '2019-02-04', 259, NULL),
('Candlewood Suites', 296, '2019-02-05', 347, NULL),
('Candlewood Suites', 296, '2019-02-06', 138, NULL),
('Candlewood Suites', 296, '2019-02-07', 318, NULL),
('Candlewood Suites', 296, '2019-02-08', 347, NULL),
('Candlewood Suites', 296, '2019-02-09', 284, NULL),
('Candlewood Suites', 296, '2019-02-10', 220, NULL),
('Candlewood Suites', 296, '2019-02-11', 398, NULL),
('Candlewood Suites', 296, '2019-02-12', 232, NULL),
('Candlewood Suites', 296, '2019-02-13', 104, NULL),
('Candlewood Suites', 296, '2019-02-14', 211, NULL),
('Candlewood Suites', 296, '2019-02-15', 168, NULL),
('Candlewood Suites', 296, '2019-02-16', 355, NULL),
('Candlewood Suites', 296, '2019-02-17', 221, NULL),
('Candlewood Suites', 296, '2019-02-18', 107, NULL),
('Candlewood Suites', 296, '2019-02-19', 149, NULL),
('Candlewood Suites', 296, '2019-02-20', 328, NULL),
('Candlewood Suites', 296, '2019-02-21', 147, NULL),
('Candlewood Suites', 296, '2019-02-22', 221, NULL),
('Candlewood Suites', 296, '2019-02-23', 235, NULL),
('Candlewood Suites', 296, '2019-02-24', 137, NULL),
('Candlewood Suites', 296, '2019-02-25', 340, NULL),
('Candlewood Suites', 296, '2019-02-26', 148, NULL),
('Candlewood Suites', 296, '2019-02-27', 248, NULL),
('Candlewood Suites', 296, '2019-02-28', 322, NULL),
('Candlewood Suites', 296, '2019-03-01', 165, NULL),
('Candlewood Suites', 296, '2019-03-02', 356, NULL),
('Candlewood Suites', 296, '2019-03-03', 365, NULL),
('Candlewood Suites', 296, '2019-03-04', 370, NULL),
('Candlewood Suites', 296, '2019-03-05', 357, NULL),
('Candlewood Suites', 296, '2019-03-06', 258, NULL),
('Candlewood Suites', 296, '2019-03-07', 258, NULL),
('Candlewood Suites', 296, '2019-03-08', 161, NULL),
('Candlewood Suites', 296, '2019-03-09', 290, NULL),
('Candlewood Suites', 296, '2019-03-10', 152, NULL),
('Candlewood Suites', 296, '2019-03-11', 191, NULL),
('Candlewood Suites', 296, '2019-03-12', 206, NULL),
('Candlewood Suites', 296, '2019-03-13', 301, NULL),
('Candlewood Suites', 296, '2019-03-14', 385, NULL),
('Candlewood Suites', 296, '2019-03-15', 193, NULL),
('Candlewood Suites', 296, '2019-03-16', 251, NULL),
('Candlewood Suites', 296, '2019-03-17', 151, NULL),
('Candlewood Suites', 296, '2019-03-18', 150, NULL),
('Candlewood Suites', 296, '2019-03-19', 247, NULL),
('Candlewood Suites', 296, '2019-03-20', 349, NULL),
('Candlewood Suites', 296, '2019-03-21', 230, NULL),
('Candlewood Suites', 296, '2019-03-22', 282, NULL),
('Candlewood Suites', 296, '2019-03-23', 349, NULL),
('Candlewood Suites', 296, '2019-03-24', 213, NULL),
('Candlewood Suites', 296, '2019-03-25', 293, NULL),
('Candlewood Suites', 296, '2019-03-26', 142, NULL),
('Candlewood Suites', 296, '2019-03-27', 204, NULL),
('Candlewood Suites', 296, '2019-03-28', 347, NULL),
('Candlewood Suites', 296, '2019-03-29', 163, NULL),
('Candlewood Suites', 296, '2019-03-30', 257, NULL),
('Candlewood Suites', 296, '2019-03-31', 182, NULL),
('Candlewood Suites', 296, '2019-04-01', 249, NULL),
('Candlewood Suites', 296, '2019-04-02', 316, NULL),
('Candlewood Suites', 296, '2019-04-03', 166, NULL),
('Candlewood Suites', 296, '2019-04-04', 268, NULL),
('Candlewood Suites', 296, '2019-04-05', 151, NULL),
('Candlewood Suites', 296, '2019-04-06', 299, NULL),
('Candlewood Suites', 296, '2019-04-07', 210, NULL),
('Candlewood Suites', 296, '2019-04-08', 265, NULL),
('Candlewood Suites', 296, '2019-04-09', 272, NULL),
('Candlewood Suites', 296, '2019-04-10', 177, NULL),
('Candlewood Suites', 296, '2019-04-11', 118, NULL),
('Candlewood Suites', 296, '2019-04-12', 323, NULL),
('Candlewood Suites', 296, '2019-04-13', 157, NULL),
('Candlewood Suites', 296, '2019-04-14', 367, NULL),
('Candlewood Suites', 296, '2019-04-15', 217, NULL),
('Candlewood Suites', 296, '2019-04-16', 125, NULL),
('Candlewood Suites', 296, '2019-04-17', 256, NULL),
('Candlewood Suites', 296, '2019-04-18', 137, NULL),
('Candlewood Suites', 296, '2019-04-19', 143, NULL),
('Candlewood Suites', 296, '2019-04-20', 249, NULL),
('Candlewood Suites', 296, '2019-04-21', 382, NULL),
('Candlewood Suites', 296, '2019-04-22', 388, NULL),
('Candlewood Suites', 296, '2019-04-23', 204, NULL),
('Candlewood Suites', 296, '2019-04-24', 188, NULL),
('Candlewood Suites', 296, '2019-04-25', 242, NULL),
('Candlewood Suites', 296, '2019-04-26', 100, NULL),
('Candlewood Suites', 296, '2019-04-27', 108, NULL),
('Candlewood Suites', 296, '2019-04-28', 378, NULL),
('Candlewood Suites', 296, '2019-04-29', 335, NULL),
('Candlewood Suites', 296, '2019-04-30', 190, NULL),
('Candlewood Suites', 296, '2019-05-01', 198, NULL),
('Candlewood Suites', 296, '2019-05-02', 247, NULL),
('Candlewood Suites', 296, '2019-05-03', 395, NULL),
('Candlewood Suites', 296, '2019-05-04', 151, NULL),
('Candlewood Suites', 296, '2019-05-05', 153, NULL),
('Candlewood Suites', 296, '2019-05-06', 124, NULL),
('Candlewood Suites', 296, '2019-05-07', 274, NULL),
('Candlewood Suites', 296, '2019-05-08', 382, NULL),
('Candlewood Suites', 296, '2019-05-09', 335, NULL),
('Candlewood Suites', 296, '2019-05-10', 378, NULL),
('Candlewood Suites', 296, '2019-05-11', 279, NULL),
('Candlewood Suites', 296, '2019-05-12', 362, NULL),
('Candlewood Suites', 296, '2019-05-13', 147, NULL),
('Candlewood Suites', 296, '2019-05-14', 173, NULL),
('Candlewood Suites', 296, '2019-05-15', 323, NULL),
('Candlewood Suites', 296, '2019-05-16', 114, NULL),
('Candlewood Suites', 296, '2019-05-17', 188, NULL),
('Candlewood Suites', 296, '2019-05-18', 210, NULL),
('Candlewood Suites', 296, '2019-05-19', 187, NULL),
('Candlewood Suites', 296, '2019-05-20', 301, NULL),
('Candlewood Suites', 296, '2019-05-21', 217, NULL),
('Candlewood Suites', 296, '2019-05-22', 282, NULL),
('Candlewood Suites', 296, '2019-05-23', 222, NULL),
('Candlewood Suites', 296, '2019-05-24', 388, NULL),
('Candlewood Suites', 296, '2019-05-25', 118, NULL),
('Candlewood Suites', 296, '2019-05-26', 225, NULL),
('Candlewood Suites', 296, '2019-05-27', 226, NULL),
('Candlewood Suites', 296, '2019-05-28', 230, NULL),
('Candlewood Suites', 296, '2019-05-29', 207, NULL),
('Candlewood Suites', 296, '2019-05-30', 242, NULL),
('Candlewood Suites', 296, '2019-05-31', 171, NULL),
('Candlewood Suites', 296, '2019-06-01', 331, NULL),
('Candlewood Suites', 296, '2019-06-02', 319, NULL),
('Candlewood Suites', 296, '2019-06-03', 220, NULL),
('Candlewood Suites', 296, '2019-06-04', 276, NULL),
('Candlewood Suites', 296, '2019-06-05', 173, NULL),
('Candlewood Suites', 296, '2019-06-06', 297, NULL),
('Candlewood Suites', 296, '2019-06-07', 197, NULL),
('Candlewood Suites', 296, '2019-06-08', 345, NULL),
('Candlewood Suites', 296, '2019-06-09', 138, NULL),
('Candlewood Suites', 296, '2019-06-10', 143, NULL),
('Candlewood Suites', 296, '2019-06-11', 310, NULL),
('Candlewood Suites', 296, '2019-06-12', 214, NULL),
('Candlewood Suites', 296, '2019-06-13', 155, NULL),
('Candlewood Suites', 296, '2019-06-14', 364, NULL),
('Candlewood Suites', 296, '2019-06-15', 114, NULL),
('Candlewood Suites', 296, '2019-06-16', 220, NULL),
('Candlewood Suites', 296, '2019-06-17', 373, NULL),
('Candlewood Suites', 296, '2019-06-18', 269, NULL),
('Candlewood Suites', 296, '2019-06-19', 267, NULL),
('Candlewood Suites', 296, '2019-06-20', 145, NULL),
('Candlewood Suites', 296, '2019-06-21', 238, NULL),
('Candlewood Suites', 296, '2019-06-22', 336, NULL),
('Candlewood Suites', 296, '2019-06-23', 237, NULL),
('Candlewood Suites', 296, '2019-06-24', 319, NULL),
('Candlewood Suites', 296, '2019-06-25', 128, NULL),
('Candlewood Suites', 296, '2019-06-26', 283, NULL),
('Candlewood Suites', 296, '2019-06-27', 113, NULL),
('Candlewood Suites', 296, '2019-06-28', 253, NULL),
('Candlewood Suites', 296, '2019-06-29', 388, NULL),
('Candlewood Suites', 296, '2019-06-30', 293, NULL),
('Candlewood Suites', 296, '2019-07-01', 250, NULL),
('Candlewood Suites', 296, '2019-07-02', 100, NULL),
('Candlewood Suites', 296, '2019-07-03', 364, NULL),
('Candlewood Suites', 296, '2019-07-04', 309, NULL),
('Candlewood Suites', 296, '2019-07-05', 283, NULL),
('Candlewood Suites', 296, '2019-07-06', 347, NULL),
('Candlewood Suites', 296, '2019-07-07', 161, NULL),
('Candlewood Suites', 296, '2019-07-08', 116, NULL),
('Candlewood Suites', 296, '2019-07-09', 148, NULL),
('Candlewood Suites', 296, '2019-07-10', 187, NULL),
('Candlewood Suites', 296, '2019-07-11', 297, NULL),
('Candlewood Suites', 296, '2019-07-12', 354, NULL),
('Candlewood Suites', 296, '2019-07-13', 366, NULL),
('Candlewood Suites', 296, '2019-07-14', 325, NULL),
('Candlewood Suites', 296, '2019-07-15', 242, NULL),
('Candlewood Suites', 296, '2019-07-16', 277, NULL),
('Candlewood Suites', 296, '2019-07-17', 239, NULL),
('Candlewood Suites', 296, '2019-07-18', 162, NULL),
('Candlewood Suites', 296, '2019-07-19', 392, NULL),
('Candlewood Suites', 296, '2019-07-20', 219, NULL),
('Candlewood Suites', 296, '2019-07-21', 169, NULL),
('Candlewood Suites', 296, '2019-07-22', 194, NULL),
('Candlewood Suites', 296, '2019-07-23', 274, NULL),
('Candlewood Suites', 296, '2019-07-24', 112, NULL),
('Candlewood Suites', 296, '2019-07-25', 115, NULL),
('Candlewood Suites', 296, '2019-07-26', 391, NULL),
('Candlewood Suites', 296, '2019-07-27', 216, NULL),
('Candlewood Suites', 296, '2019-07-28', 134, NULL),
('Candlewood Suites', 296, '2019-07-29', 107, NULL),
('Candlewood Suites', 296, '2019-07-30', 293, NULL),
('Candlewood Suites', 296, '2019-07-31', 210, NULL),
('Candlewood Suites', 296, '2019-08-01', 246, NULL),
('Candlewood Suites', 296, '2019-08-02', 259, NULL),
('Candlewood Suites', 296, '2019-08-03', 397, NULL),
('Candlewood Suites', 296, '2019-08-04', 159, NULL),
('Candlewood Suites', 296, '2019-08-05', 107, NULL),
('Candlewood Suites', 296, '2019-08-06', 106, NULL),
('Candlewood Suites', 296, '2019-08-07', 136, NULL),
('Candlewood Suites', 296, '2019-08-08', 116, NULL),
('Candlewood Suites', 296, '2019-08-09', 399, NULL),
('Candlewood Suites', 296, '2019-08-10', 194, NULL),
('Candlewood Suites', 296, '2019-08-11', 232, NULL),
('Candlewood Suites', 296, '2019-08-12', 223, NULL),
('Candlewood Suites', 296, '2019-08-13', 105, NULL),
('Candlewood Suites', 296, '2019-08-14', 125, NULL),
('Candlewood Suites', 296, '2019-08-15', 370, NULL),
('Candlewood Suites', 296, '2019-08-16', 260, NULL),
('Candlewood Suites', 296, '2019-08-17', 325, NULL),
('Candlewood Suites', 296, '2019-08-18', 324, NULL),
('Candlewood Suites', 296, '2019-08-19', 127, NULL),
('Candlewood Suites', 296, '2019-08-20', 210, NULL),
('Candlewood Suites', 296, '2019-08-21', 366, NULL),
('Candlewood Suites', 296, '2019-08-22', 222, NULL),
('Candlewood Suites', 296, '2019-08-23', 256, NULL),
('Candlewood Suites', 296, '2019-08-24', 116, NULL),
('Candlewood Suites', 296, '2019-08-25', 200, NULL),
('Candlewood Suites', 296, '2019-08-26', 331, NULL),
('Candlewood Suites', 296, '2019-08-27', 287, NULL),
('Candlewood Suites', 296, '2019-08-28', 190, NULL),
('Candlewood Suites', 296, '2019-08-29', 141, NULL),
('Candlewood Suites', 296, '2019-08-30', 398, NULL),
('Candlewood Suites', 296, '2019-08-31', 297, NULL),
('Candlewood Suites', 296, '2019-09-01', 153, NULL),
('Candlewood Suites', 296, '2019-09-02', 310, NULL),
('Candlewood Suites', 296, '2019-09-03', 238, NULL),
('Candlewood Suites', 296, '2019-09-04', 102, NULL),
('Candlewood Suites', 296, '2019-09-05', 148, NULL),
('Candlewood Suites', 296, '2019-09-06', 356, NULL),
('Candlewood Suites', 296, '2019-09-07', 174, NULL),
('Candlewood Suites', 296, '2019-09-08', 285, NULL),
('Candlewood Suites', 296, '2019-09-09', 134, NULL),
('Candlewood Suites', 296, '2019-09-10', 262, NULL),
('Candlewood Suites', 296, '2019-09-11', 137, NULL),
('Candlewood Suites', 296, '2019-09-12', 295, NULL),
('Candlewood Suites', 296, '2019-09-13', 341, NULL),
('Candlewood Suites', 296, '2019-09-14', 182, NULL),
('Candlewood Suites', 296, '2019-09-15', 239, NULL),
('Candlewood Suites', 296, '2019-09-16', 198, NULL),
('Candlewood Suites', 296, '2019-09-17', 304, NULL),
('Candlewood Suites', 296, '2019-09-18', 290, NULL),
('Candlewood Suites', 296, '2019-09-19', 386, NULL),
('Candlewood Suites', 296, '2019-09-20', 256, NULL),
('Candlewood Suites', 296, '2019-09-21', 251, NULL),
('Candlewood Suites', 296, '2019-09-22', 251, NULL),
('Candlewood Suites', 296, '2019-09-23', 107, NULL),
('Candlewood Suites', 296, '2019-09-24', 210, NULL),
('Candlewood Suites', 296, '2019-09-25', 176, NULL),
('Candlewood Suites', 296, '2019-09-26', 117, NULL),
('Candlewood Suites', 296, '2019-09-27', 270, NULL),
('Candlewood Suites', 296, '2019-09-28', 340, NULL),
('Candlewood Suites', 296, '2019-09-29', 123, NULL),
('Candlewood Suites', 296, '2019-09-30', 205, NULL),
('Candlewood Suites', 296, '2019-10-01', 307, NULL),
('Candlewood Suites', 296, '2019-10-02', 317, NULL),
('Candlewood Suites', 296, '2019-10-03', 363, NULL),
('Candlewood Suites', 296, '2019-10-04', 279, NULL),
('Candlewood Suites', 296, '2019-10-05', 318, NULL),
('Candlewood Suites', 296, '2019-10-06', 290, NULL),
('Candlewood Suites', 296, '2019-10-07', 164, NULL),
('Candlewood Suites', 296, '2019-10-08', 206, NULL),
('Candlewood Suites', 296, '2019-10-09', 375, NULL),
('Candlewood Suites', 296, '2019-10-10', 242, NULL),
('Candlewood Suites', 296, '2019-10-11', 273, NULL),
('Candlewood Suites', 296, '2019-10-12', 360, NULL),
('Candlewood Suites', 296, '2019-10-13', 297, NULL),
('Candlewood Suites', 296, '2019-10-14', 222, NULL),
('Candlewood Suites', 296, '2019-10-15', 185, NULL),
('Candlewood Suites', 296, '2019-10-16', 106, NULL),
('Candlewood Suites', 296, '2019-10-17', 219, NULL),
('Candlewood Suites', 296, '2019-10-18', 337, NULL),
('Candlewood Suites', 296, '2019-10-19', 346, NULL),
('Candlewood Suites', 296, '2019-10-20', 292, NULL),
('Candlewood Suites', 296, '2019-10-21', 231, NULL),
('Candlewood Suites', 296, '2019-10-22', 179, NULL),
('Candlewood Suites', 296, '2019-10-23', 348, NULL),
('Candlewood Suites', 296, '2019-10-24', 167, NULL),
('Candlewood Suites', 296, '2019-10-25', 124, NULL),
('Candlewood Suites', 296, '2019-10-26', 186, NULL),
('Candlewood Suites', 296, '2019-10-27', 391, NULL),
('Candlewood Suites', 296, '2019-10-28', 196, NULL),
('Candlewood Suites', 296, '2019-10-29', 118, NULL),
('Candlewood Suites', 296, '2019-10-30', 138, NULL),
('Candlewood Suites', 296, '2019-10-31', 144, NULL),
('Candlewood Suites', 296, '2019-11-01', 115, NULL),
('Candlewood Suites', 296, '2019-11-02', 331, NULL),
('Candlewood Suites', 296, '2019-11-03', 305, NULL),
('Candlewood Suites', 296, '2019-11-04', 369, NULL),
('Candlewood Suites', 296, '2019-11-05', 106, NULL),
('Candlewood Suites', 296, '2019-11-06', 313, NULL),
('Candlewood Suites', 296, '2019-11-07', 107, NULL),
('Candlewood Suites', 296, '2019-11-08', 271, NULL),
('Candlewood Suites', 296, '2019-11-09', 145, NULL),
('Candlewood Suites', 296, '2019-11-10', 120, NULL),
('Candlewood Suites', 296, '2019-11-11', 229, NULL),
('Candlewood Suites', 296, '2019-11-12', 346, NULL),
('Candlewood Suites', 296, '2019-11-13', 275, NULL),
('Candlewood Suites', 296, '2019-11-14', 292, NULL),
('Candlewood Suites', 296, '2019-11-15', 154, NULL),
('Candlewood Suites', 296, '2019-11-16', 103, NULL),
('Candlewood Suites', 296, '2019-11-17', 177, NULL),
('Candlewood Suites', 296, '2019-11-18', 382, NULL),
('Candlewood Suites', 296, '2019-11-19', 195, NULL),
('Candlewood Suites', 296, '2019-11-20', 294, NULL),
('Candlewood Suites', 296, '2019-11-21', 385, NULL),
('Candlewood Suites', 296, '2019-11-22', 185, NULL),
('Candlewood Suites', 296, '2019-11-23', 335, NULL),
('Candlewood Suites', 296, '2019-11-24', 141, NULL),
('Candlewood Suites', 296, '2019-11-25', 398, NULL),
('Candlewood Suites', 296, '2019-11-26', 247, NULL),
('Candlewood Suites', 296, '2019-11-27', 326, NULL),
('Candlewood Suites', 296, '2019-11-28', 151, NULL),
('Candlewood Suites', 296, '2019-11-29', 288, NULL),
('Candlewood Suites', 296, '2019-11-30', 309, NULL),
('Candlewood Suites', 296, '2019-12-01', 309, NULL),
('Candlewood Suites', 296, '2019-12-02', 322, NULL),
('Candlewood Suites', 296, '2019-12-03', 256, NULL),
('Candlewood Suites', 296, '2019-12-04', 177, NULL),
('Candlewood Suites', 296, '2019-12-05', 153, NULL),
('Candlewood Suites', 296, '2019-12-06', 248, NULL),
('Candlewood Suites', 296, '2019-12-07', 244, NULL),
('Candlewood Suites', 296, '2019-12-08', 142, NULL),
('Candlewood Suites', 296, '2019-12-09', 390, NULL),
('Candlewood Suites', 296, '2019-12-10', 109, NULL),
('Candlewood Suites', 296, '2019-12-11', 129, NULL),
('Candlewood Suites', 296, '2019-12-12', 201, NULL),
('Candlewood Suites', 296, '2019-12-13', 224, NULL),
('Candlewood Suites', 296, '2019-12-14', 182, NULL),
('Candlewood Suites', 296, '2019-12-15', 135, NULL),
('Candlewood Suites', 296, '2019-12-16', 284, NULL),
('Candlewood Suites', 296, '2019-12-17', 285, NULL),
('Candlewood Suites', 296, '2019-12-18', 144, NULL),
('Candlewood Suites', 296, '2019-12-19', 398, NULL),
('Candlewood Suites', 296, '2019-12-20', 254, NULL),
('Candlewood Suites', 296, '2019-12-21', 385, NULL),
('Candlewood Suites', 296, '2019-12-22', 276, NULL),
('Candlewood Suites', 296, '2019-12-23', 364, NULL),
('Candlewood Suites', 296, '2019-12-24', 385, NULL),
('Candlewood Suites', 296, '2019-12-25', 241, NULL),
('Candlewood Suites', 296, '2019-12-26', 371, NULL),
('Candlewood Suites', 296, '2019-12-27', 183, NULL),
('Candlewood Suites', 296, '2019-12-28', 211, NULL),
('Candlewood Suites', 296, '2019-12-29', 296, NULL),
('Candlewood Suites', 296, '2019-12-30', 262, NULL),
('Candlewood Suites', 296, '2019-12-31', 268, NULL),
('Candlewood Suites', 296, '2020-01-01', 107, NULL),
('Candlewood Suites', 296, '2020-01-02', 359, NULL),
('Candlewood Suites', 296, '2020-01-03', 121, NULL),
('Candlewood Suites', 296, '2020-01-04', 217, NULL),
('Candlewood Suites', 296, '2020-01-05', 239, NULL),
('Candlewood Suites', 296, '2020-01-06', 266, NULL),
('Candlewood Suites', 296, '2020-01-07', 391, NULL),
('Candlewood Suites', 296, '2020-01-08', 207, NULL),
('Candlewood Suites', 296, '2020-01-09', 130, NULL),
('Candlewood Suites', 296, '2020-01-10', 189, NULL),
('Candlewood Suites', 296, '2020-01-11', 301, NULL),
('Candlewood Suites', 296, '2020-01-12', 330, NULL),
('Candlewood Suites', 296, '2020-01-13', 389, NULL),
('Candlewood Suites', 296, '2020-01-14', 359, NULL),
('Candlewood Suites', 296, '2020-01-15', 299, NULL),
('Candlewood Suites', 296, '2020-01-16', 392, NULL),
('Candlewood Suites', 296, '2020-01-17', 373, NULL),
('Candlewood Suites', 296, '2020-01-18', 177, NULL),
('Candlewood Suites', 296, '2020-01-19', 238, NULL),
('Candlewood Suites', 296, '2020-01-20', 252, NULL),
('Candlewood Suites', 296, '2020-01-21', 192, NULL),
('Candlewood Suites', 296, '2020-01-22', 301, NULL),
('Candlewood Suites', 296, '2020-01-23', 378, NULL),
('Candlewood Suites', 296, '2020-01-24', 296, NULL),
('Candlewood Suites', 296, '2020-01-25', 186, NULL),
('Candlewood Suites', 296, '2020-01-26', 144, NULL),
('Candlewood Suites', 296, '2020-01-27', 119, NULL),
('Candlewood Suites', 296, '2020-01-28', 258, NULL),
('Candlewood Suites', 296, '2020-01-29', 382, NULL),
('Candlewood Suites', 296, '2020-01-30', 377, NULL),
('Candlewood Suites', 296, '2020-01-31', 147, NULL),
('Candlewood Suites', 296, '2020-02-01', 349, NULL),
('Candlewood Suites', 296, '2020-02-02', 163, NULL),
('Candlewood Suites', 296, '2020-02-03', 106, NULL),
('Candlewood Suites', 296, '2020-02-04', 243, NULL),
('Candlewood Suites', 300, '2019-01-01', 286, NULL),
('Candlewood Suites', 300, '2019-01-02', 176, NULL),
('Candlewood Suites', 300, '2019-01-03', 229, NULL),
('Candlewood Suites', 300, '2019-01-04', 178, NULL),
('Candlewood Suites', 300, '2019-01-05', 168, NULL),
('Candlewood Suites', 300, '2019-01-06', 176, NULL),
('Candlewood Suites', 300, '2019-01-07', 379, NULL),
('Candlewood Suites', 300, '2019-01-08', 145, NULL),
('Candlewood Suites', 300, '2019-01-09', 108, NULL),
('Candlewood Suites', 300, '2019-01-10', 221, NULL),
('Candlewood Suites', 300, '2019-01-11', 187, NULL),
('Candlewood Suites', 300, '2019-01-12', 199, NULL),
('Candlewood Suites', 300, '2019-01-13', 393, NULL),
('Candlewood Suites', 300, '2019-01-14', 166, NULL),
('Candlewood Suites', 300, '2019-01-15', 311, NULL),
('Candlewood Suites', 300, '2019-01-16', 270, NULL),
('Candlewood Suites', 300, '2019-01-17', 111, NULL),
('Candlewood Suites', 300, '2019-01-18', 209, NULL),
('Candlewood Suites', 300, '2019-01-19', 300, NULL),
('Candlewood Suites', 300, '2019-01-20', 249, NULL),
('Candlewood Suites', 300, '2019-01-21', 257, NULL),
('Candlewood Suites', 300, '2019-01-22', 324, NULL),
('Candlewood Suites', 300, '2019-01-23', 398, NULL),
('Candlewood Suites', 300, '2019-01-24', 268, NULL),
('Candlewood Suites', 300, '2019-01-25', 315, NULL),
('Candlewood Suites', 300, '2019-01-26', 158, NULL),
('Candlewood Suites', 300, '2019-01-27', 190, NULL),
('Candlewood Suites', 300, '2019-01-28', 274, NULL),
('Candlewood Suites', 300, '2019-01-29', 223, NULL),
('Candlewood Suites', 300, '2019-01-30', 276, NULL),
('Candlewood Suites', 300, '2019-01-31', 394, NULL),
('Candlewood Suites', 300, '2019-02-01', 143, NULL),
('Candlewood Suites', 300, '2019-02-02', 134, NULL),
('Candlewood Suites', 300, '2019-02-03', 350, NULL),
('Candlewood Suites', 300, '2019-02-04', 201, NULL),
('Candlewood Suites', 300, '2019-02-05', 350, NULL),
('Candlewood Suites', 300, '2019-02-06', 349, NULL),
('Candlewood Suites', 300, '2019-02-07', 115, NULL),
('Candlewood Suites', 300, '2019-02-08', 219, NULL),
('Candlewood Suites', 300, '2019-02-09', 332, NULL),
('Candlewood Suites', 300, '2019-02-10', 124, NULL),
('Candlewood Suites', 300, '2019-02-11', 378, NULL),
('Candlewood Suites', 300, '2019-02-12', 303, NULL),
('Candlewood Suites', 300, '2019-02-13', 191, NULL),
('Candlewood Suites', 300, '2019-02-14', 115, NULL),
('Candlewood Suites', 300, '2019-02-15', 114, NULL),
('Candlewood Suites', 300, '2019-02-16', 285, NULL),
('Candlewood Suites', 300, '2019-02-17', 163, NULL),
('Candlewood Suites', 300, '2019-02-18', 173, NULL),
('Candlewood Suites', 300, '2019-02-19', 280, NULL),
('Candlewood Suites', 300, '2019-02-20', 136, NULL),
('Candlewood Suites', 300, '2019-02-21', 135, NULL),
('Candlewood Suites', 300, '2019-02-22', 135, NULL),
('Candlewood Suites', 300, '2019-02-23', 149, NULL),
('Candlewood Suites', 300, '2019-02-24', 372, NULL),
('Candlewood Suites', 300, '2019-02-25', 392, NULL),
('Candlewood Suites', 300, '2019-02-26', 118, NULL),
('Candlewood Suites', 300, '2019-02-27', 222, NULL),
('Candlewood Suites', 300, '2019-02-28', 215, NULL),
('Candlewood Suites', 300, '2019-03-01', 283, NULL),
('Candlewood Suites', 300, '2019-03-02', 289, NULL),
('Candlewood Suites', 300, '2019-03-03', 228, NULL),
('Candlewood Suites', 300, '2019-03-04', 318, NULL),
('Candlewood Suites', 300, '2019-03-05', 162, NULL),
('Candlewood Suites', 300, '2019-03-06', 383, NULL),
('Candlewood Suites', 300, '2019-03-07', 293, NULL),
('Candlewood Suites', 300, '2019-03-08', 343, NULL),
('Candlewood Suites', 300, '2019-03-09', 111, NULL),
('Candlewood Suites', 300, '2019-03-10', 130, NULL),
('Candlewood Suites', 300, '2019-03-11', 359, NULL),
('Candlewood Suites', 300, '2019-03-12', 228, NULL),
('Candlewood Suites', 300, '2019-03-13', 279, NULL),
('Candlewood Suites', 300, '2019-03-14', 216, NULL),
('Candlewood Suites', 300, '2019-03-15', 235, NULL),
('Candlewood Suites', 300, '2019-03-16', 123, NULL),
('Candlewood Suites', 300, '2019-03-17', 332, NULL),
('Candlewood Suites', 300, '2019-03-18', 385, NULL),
('Candlewood Suites', 300, '2019-03-19', 185, NULL),
('Candlewood Suites', 300, '2019-03-20', 241, NULL),
('Candlewood Suites', 300, '2019-03-21', 144, NULL),
('Candlewood Suites', 300, '2019-03-22', 177, NULL),
('Candlewood Suites', 300, '2019-03-23', 318, NULL),
('Candlewood Suites', 300, '2019-03-24', 293, NULL),
('Candlewood Suites', 300, '2019-03-25', 140, NULL),
('Candlewood Suites', 300, '2019-03-26', 332, NULL),
('Candlewood Suites', 300, '2019-03-27', 103, NULL),
('Candlewood Suites', 300, '2019-03-28', 350, NULL),
('Candlewood Suites', 300, '2019-03-29', 353, NULL),
('Candlewood Suites', 300, '2019-03-30', 394, NULL),
('Candlewood Suites', 300, '2019-03-31', 391, NULL),
('Candlewood Suites', 300, '2019-04-01', 389, NULL),
('Candlewood Suites', 300, '2019-04-02', 333, NULL),
('Candlewood Suites', 300, '2019-04-03', 388, NULL),
('Candlewood Suites', 300, '2019-04-04', 367, NULL),
('Candlewood Suites', 300, '2019-04-05', 259, NULL),
('Candlewood Suites', 300, '2019-04-06', 269, NULL),
('Candlewood Suites', 300, '2019-04-07', 314, NULL),
('Candlewood Suites', 300, '2019-04-08', 110, NULL),
('Candlewood Suites', 300, '2019-04-09', 391, NULL),
('Candlewood Suites', 300, '2019-04-10', 339, NULL),
('Candlewood Suites', 300, '2019-04-11', 205, NULL),
('Candlewood Suites', 300, '2019-04-12', 382, NULL),
('Candlewood Suites', 300, '2019-04-13', 151, NULL),
('Candlewood Suites', 300, '2019-04-14', 135, NULL),
('Candlewood Suites', 300, '2019-04-15', 382, NULL),
('Candlewood Suites', 300, '2019-04-16', 119, NULL),
('Candlewood Suites', 300, '2019-04-17', 370, NULL),
('Candlewood Suites', 300, '2019-04-18', 342, NULL),
('Candlewood Suites', 300, '2019-04-19', 141, NULL),
('Candlewood Suites', 300, '2019-04-20', 141, NULL),
('Candlewood Suites', 300, '2019-04-21', 217, NULL),
('Candlewood Suites', 300, '2019-04-22', 133, NULL),
('Candlewood Suites', 300, '2019-04-23', 106, NULL),
('Candlewood Suites', 300, '2019-04-24', 300, NULL),
('Candlewood Suites', 300, '2019-04-25', 119, NULL),
('Candlewood Suites', 300, '2019-04-26', 387, NULL),
('Candlewood Suites', 300, '2019-04-27', 361, NULL),
('Candlewood Suites', 300, '2019-04-28', 384, NULL),
('Candlewood Suites', 300, '2019-04-29', 296, NULL),
('Candlewood Suites', 300, '2019-04-30', 337, NULL),
('Candlewood Suites', 300, '2019-05-01', 151, NULL),
('Candlewood Suites', 300, '2019-05-02', 146, NULL),
('Candlewood Suites', 300, '2019-05-03', 150, NULL),
('Candlewood Suites', 300, '2019-05-04', 222, NULL),
('Candlewood Suites', 300, '2019-05-05', 350, NULL),
('Candlewood Suites', 300, '2019-05-06', 183, NULL),
('Candlewood Suites', 300, '2019-05-07', 132, NULL),
('Candlewood Suites', 300, '2019-05-08', 389, NULL),
('Candlewood Suites', 300, '2019-05-09', 103, NULL),
('Candlewood Suites', 300, '2019-05-10', 324, NULL),
('Candlewood Suites', 300, '2019-05-11', 175, NULL),
('Candlewood Suites', 300, '2019-05-12', 200, NULL),
('Candlewood Suites', 300, '2019-05-13', 356, NULL),
('Candlewood Suites', 300, '2019-05-14', 126, NULL),
('Candlewood Suites', 300, '2019-05-15', 337, NULL),
('Candlewood Suites', 300, '2019-05-16', 334, NULL),
('Candlewood Suites', 300, '2019-05-17', 158, NULL),
('Candlewood Suites', 300, '2019-05-18', 124, NULL),
('Candlewood Suites', 300, '2019-05-19', 336, NULL),
('Candlewood Suites', 300, '2019-05-20', 147, NULL),
('Candlewood Suites', 300, '2019-05-21', 253, NULL),
('Candlewood Suites', 300, '2019-05-22', 334, NULL),
('Candlewood Suites', 300, '2019-05-23', 139, NULL),
('Candlewood Suites', 300, '2019-05-24', 176, NULL),
('Candlewood Suites', 300, '2019-05-25', 249, NULL),
('Candlewood Suites', 300, '2019-05-26', 174, NULL),
('Candlewood Suites', 300, '2019-05-27', 384, NULL),
('Candlewood Suites', 300, '2019-05-28', 265, NULL),
('Candlewood Suites', 300, '2019-05-29', 192, NULL),
('Candlewood Suites', 300, '2019-05-30', 212, NULL),
('Candlewood Suites', 300, '2019-05-31', 107, NULL),
('Candlewood Suites', 300, '2019-06-01', 309, NULL),
('Candlewood Suites', 300, '2019-06-02', 327, NULL),
('Candlewood Suites', 300, '2019-06-03', 296, NULL),
('Candlewood Suites', 300, '2019-06-04', 200, NULL),
('Candlewood Suites', 300, '2019-06-05', 280, NULL),
('Candlewood Suites', 300, '2019-06-06', 358, NULL),
('Candlewood Suites', 300, '2019-06-07', 131, NULL),
('Candlewood Suites', 300, '2019-06-08', 241, NULL),
('Candlewood Suites', 300, '2019-06-09', 252, NULL),
('Candlewood Suites', 300, '2019-06-10', 127, NULL),
('Candlewood Suites', 300, '2019-06-11', 114, NULL),
('Candlewood Suites', 300, '2019-06-12', 286, NULL),
('Candlewood Suites', 300, '2019-06-13', 231, NULL),
('Candlewood Suites', 300, '2019-06-14', 369, NULL),
('Candlewood Suites', 300, '2019-06-15', 293, NULL),
('Candlewood Suites', 300, '2019-06-16', 369, NULL),
('Candlewood Suites', 300, '2019-06-17', 344, NULL),
('Candlewood Suites', 300, '2019-06-18', 309, NULL),
('Candlewood Suites', 300, '2019-06-19', 245, NULL),
('Candlewood Suites', 300, '2019-06-20', 170, NULL),
('Candlewood Suites', 300, '2019-06-21', 187, NULL),
('Candlewood Suites', 300, '2019-06-22', 176, NULL),
('Candlewood Suites', 300, '2019-06-23', 212, NULL),
('Candlewood Suites', 300, '2019-06-24', 318, NULL),
('Candlewood Suites', 300, '2019-06-25', 138, NULL),
('Candlewood Suites', 300, '2019-06-26', 334, NULL),
('Candlewood Suites', 300, '2019-06-27', 150, NULL),
('Candlewood Suites', 300, '2019-06-28', 196, NULL),
('Candlewood Suites', 300, '2019-06-29', 291, NULL),
('Candlewood Suites', 300, '2019-06-30', 248, NULL),
('Candlewood Suites', 300, '2019-07-01', 186, NULL),
('Candlewood Suites', 300, '2019-07-02', 184, NULL),
('Candlewood Suites', 300, '2019-07-03', 202, NULL),
('Candlewood Suites', 300, '2019-07-04', 209, NULL),
('Candlewood Suites', 300, '2019-07-05', 275, NULL),
('Candlewood Suites', 300, '2019-07-06', 259, NULL),
('Candlewood Suites', 300, '2019-07-07', 148, NULL),
('Candlewood Suites', 300, '2019-07-08', 138, NULL),
('Candlewood Suites', 300, '2019-07-09', 114, NULL),
('Candlewood Suites', 300, '2019-07-10', 119, NULL),
('Candlewood Suites', 300, '2019-07-11', 373, NULL),
('Candlewood Suites', 300, '2019-07-12', 353, NULL),
('Candlewood Suites', 300, '2019-07-13', 359, NULL),
('Candlewood Suites', 300, '2019-07-14', 213, NULL),
('Candlewood Suites', 300, '2019-07-15', 260, NULL),
('Candlewood Suites', 300, '2019-07-16', 140, NULL),
('Candlewood Suites', 300, '2019-07-17', 221, NULL),
('Candlewood Suites', 300, '2019-07-18', 204, NULL),
('Candlewood Suites', 300, '2019-07-19', 127, NULL),
('Candlewood Suites', 300, '2019-07-20', 382, NULL),
('Candlewood Suites', 300, '2019-07-21', 370, NULL),
('Candlewood Suites', 300, '2019-07-22', 347, NULL),
('Candlewood Suites', 300, '2019-07-23', 158, NULL),
('Candlewood Suites', 300, '2019-07-24', 218, NULL),
('Candlewood Suites', 300, '2019-07-25', 287, NULL),
('Candlewood Suites', 300, '2019-07-26', 371, NULL),
('Candlewood Suites', 300, '2019-07-27', 244, NULL),
('Candlewood Suites', 300, '2019-07-28', 198, NULL),
('Candlewood Suites', 300, '2019-07-29', 144, NULL),
('Candlewood Suites', 300, '2019-07-30', 178, NULL),
('Candlewood Suites', 300, '2019-07-31', 230, NULL),
('Candlewood Suites', 300, '2019-08-01', 352, NULL),
('Candlewood Suites', 300, '2019-08-02', 108, NULL),
('Candlewood Suites', 300, '2019-08-03', 399, NULL),
('Candlewood Suites', 300, '2019-08-04', 352, NULL),
('Candlewood Suites', 300, '2019-08-05', 364, NULL),
('Candlewood Suites', 300, '2019-08-06', 297, NULL),
('Candlewood Suites', 300, '2019-08-07', 195, NULL),
('Candlewood Suites', 300, '2019-08-08', 285, NULL),
('Candlewood Suites', 300, '2019-08-09', 224, NULL),
('Candlewood Suites', 300, '2019-08-10', 270, NULL),
('Candlewood Suites', 300, '2019-08-11', 379, NULL),
('Candlewood Suites', 300, '2019-08-12', 178, NULL),
('Candlewood Suites', 300, '2019-08-13', 272, NULL),
('Candlewood Suites', 300, '2019-08-14', 352, NULL),
('Candlewood Suites', 300, '2019-08-15', 165, NULL),
('Candlewood Suites', 300, '2019-08-16', 171, NULL),
('Candlewood Suites', 300, '2019-08-17', 147, NULL),
('Candlewood Suites', 300, '2019-08-18', 290, NULL),
('Candlewood Suites', 300, '2019-08-19', 318, NULL),
('Candlewood Suites', 300, '2019-08-20', 368, NULL),
('Candlewood Suites', 300, '2019-08-21', 136, NULL),
('Candlewood Suites', 300, '2019-08-22', 389, NULL),
('Candlewood Suites', 300, '2019-08-23', 397, NULL),
('Candlewood Suites', 300, '2019-08-24', 396, NULL),
('Candlewood Suites', 300, '2019-08-25', 107, NULL),
('Candlewood Suites', 300, '2019-08-26', 302, NULL),
('Candlewood Suites', 300, '2019-08-27', 181, NULL),
('Candlewood Suites', 300, '2019-08-28', 239, NULL),
('Candlewood Suites', 300, '2019-08-29', 184, NULL),
('Candlewood Suites', 300, '2019-08-30', 266, NULL),
('Candlewood Suites', 300, '2019-08-31', 240, NULL),
('Candlewood Suites', 300, '2019-09-01', 150, NULL),
('Candlewood Suites', 300, '2019-09-02', 341, NULL),
('Candlewood Suites', 300, '2019-09-03', 337, NULL),
('Candlewood Suites', 300, '2019-09-04', 169, NULL),
('Candlewood Suites', 300, '2019-09-05', 342, NULL),
('Candlewood Suites', 300, '2019-09-06', 121, NULL),
('Candlewood Suites', 300, '2019-09-07', 138, NULL),
('Candlewood Suites', 300, '2019-09-08', 326, NULL),
('Candlewood Suites', 300, '2019-09-09', 392, NULL),
('Candlewood Suites', 300, '2019-09-10', 150, NULL),
('Candlewood Suites', 300, '2019-09-11', 293, NULL),
('Candlewood Suites', 300, '2019-09-12', 354, NULL),
('Candlewood Suites', 300, '2019-09-13', 208, NULL),
('Candlewood Suites', 300, '2019-09-14', 335, NULL),
('Candlewood Suites', 300, '2019-09-15', 201, NULL),
('Candlewood Suites', 300, '2019-09-16', 394, NULL),
('Candlewood Suites', 300, '2019-09-17', 226, NULL),
('Candlewood Suites', 300, '2019-09-18', 217, NULL),
('Candlewood Suites', 300, '2019-09-19', 119, NULL),
('Candlewood Suites', 300, '2019-09-20', 368, NULL),
('Candlewood Suites', 300, '2019-09-21', 251, NULL),
('Candlewood Suites', 300, '2019-09-22', 177, NULL),
('Candlewood Suites', 300, '2019-09-23', 381, NULL),
('Candlewood Suites', 300, '2019-09-24', 227, NULL),
('Candlewood Suites', 300, '2019-09-25', 195, NULL),
('Candlewood Suites', 300, '2019-09-26', 389, NULL),
('Candlewood Suites', 300, '2019-09-27', 144, NULL),
('Candlewood Suites', 300, '2019-09-28', 394, NULL),
('Candlewood Suites', 300, '2019-09-29', 169, NULL),
('Candlewood Suites', 300, '2019-09-30', 255, NULL),
('Candlewood Suites', 300, '2019-10-01', 270, NULL),
('Candlewood Suites', 300, '2019-10-02', 397, NULL),
('Candlewood Suites', 300, '2019-10-03', 379, NULL),
('Candlewood Suites', 300, '2019-10-04', 330, NULL),
('Candlewood Suites', 300, '2019-10-05', 370, NULL),
('Candlewood Suites', 300, '2019-10-06', 293, NULL),
('Candlewood Suites', 300, '2019-10-07', 207, NULL),
('Candlewood Suites', 300, '2019-10-08', 252, NULL),
('Candlewood Suites', 300, '2019-10-09', 180, NULL),
('Candlewood Suites', 300, '2019-10-10', 126, NULL),
('Candlewood Suites', 300, '2019-10-11', 348, NULL),
('Candlewood Suites', 300, '2019-10-12', 244, NULL),
('Candlewood Suites', 300, '2019-10-13', 318, NULL),
('Candlewood Suites', 300, '2019-10-14', 235, NULL),
('Candlewood Suites', 300, '2019-10-15', 334, NULL),
('Candlewood Suites', 300, '2019-10-16', 200, NULL),
('Candlewood Suites', 300, '2019-10-17', 371, NULL),
('Candlewood Suites', 300, '2019-10-18', 200, NULL),
('Candlewood Suites', 300, '2019-10-19', 270, NULL),
('Candlewood Suites', 300, '2019-10-20', 160, NULL),
('Candlewood Suites', 300, '2019-10-21', 231, NULL),
('Candlewood Suites', 300, '2019-10-22', 354, NULL),
('Candlewood Suites', 300, '2019-10-23', 177, NULL),
('Candlewood Suites', 300, '2019-10-24', 366, NULL),
('Candlewood Suites', 300, '2019-10-25', 325, NULL),
('Candlewood Suites', 300, '2019-10-26', 134, NULL),
('Candlewood Suites', 300, '2019-10-27', 148, NULL),
('Candlewood Suites', 300, '2019-10-28', 385, NULL),
('Candlewood Suites', 300, '2019-10-29', 197, NULL),
('Candlewood Suites', 300, '2019-10-30', 204, NULL),
('Candlewood Suites', 300, '2019-10-31', 104, NULL),
('Candlewood Suites', 300, '2019-11-01', 103, NULL),
('Candlewood Suites', 300, '2019-11-02', 375, NULL),
('Candlewood Suites', 300, '2019-11-03', 177, NULL),
('Candlewood Suites', 300, '2019-11-04', 347, NULL),
('Candlewood Suites', 300, '2019-11-05', 178, NULL),
('Candlewood Suites', 300, '2019-11-06', 127, NULL),
('Candlewood Suites', 300, '2019-11-07', 337, NULL),
('Candlewood Suites', 300, '2019-11-08', 321, NULL),
('Candlewood Suites', 300, '2019-11-09', 111, NULL),
('Candlewood Suites', 300, '2019-11-10', 233, NULL),
('Candlewood Suites', 300, '2019-11-11', 188, NULL),
('Candlewood Suites', 300, '2019-11-12', 223, NULL),
('Candlewood Suites', 300, '2019-11-13', 399, NULL),
('Candlewood Suites', 300, '2019-11-14', 233, NULL),
('Candlewood Suites', 300, '2019-11-15', 130, NULL),
('Candlewood Suites', 300, '2019-11-16', 348, NULL),
('Candlewood Suites', 300, '2019-11-17', 357, NULL),
('Candlewood Suites', 300, '2019-11-18', 366, NULL),
('Candlewood Suites', 300, '2019-11-19', 186, NULL),
('Candlewood Suites', 300, '2019-11-20', 173, NULL),
('Candlewood Suites', 300, '2019-11-21', 271, NULL),
('Candlewood Suites', 300, '2019-11-22', 259, NULL),
('Candlewood Suites', 300, '2019-11-23', 224, NULL),
('Candlewood Suites', 300, '2019-11-24', 155, NULL),
('Candlewood Suites', 300, '2019-11-25', 111, NULL),
('Candlewood Suites', 300, '2019-11-26', 310, NULL),
('Candlewood Suites', 300, '2019-11-27', 198, NULL),
('Candlewood Suites', 300, '2019-11-28', 151, NULL),
('Candlewood Suites', 300, '2019-11-29', 197, NULL),
('Candlewood Suites', 300, '2019-11-30', 367, NULL),
('Candlewood Suites', 300, '2019-12-01', 269, NULL),
('Candlewood Suites', 300, '2019-12-02', 197, NULL),
('Candlewood Suites', 300, '2019-12-03', 286, NULL),
('Candlewood Suites', 300, '2019-12-04', 131, NULL),
('Candlewood Suites', 300, '2019-12-05', 259, NULL),
('Candlewood Suites', 300, '2019-12-06', 361, NULL),
('Candlewood Suites', 300, '2019-12-07', 174, NULL),
('Candlewood Suites', 300, '2019-12-08', 318, NULL),
('Candlewood Suites', 300, '2019-12-09', 161, NULL),
('Candlewood Suites', 300, '2019-12-10', 336, NULL),
('Candlewood Suites', 300, '2019-12-11', 126, NULL),
('Candlewood Suites', 300, '2019-12-12', 146, NULL),
('Candlewood Suites', 300, '2019-12-13', 161, NULL),
('Candlewood Suites', 300, '2019-12-14', 103, NULL),
('Candlewood Suites', 300, '2019-12-15', 399, NULL),
('Candlewood Suites', 300, '2019-12-16', 192, NULL),
('Candlewood Suites', 300, '2019-12-17', 164, NULL),
('Candlewood Suites', 300, '2019-12-18', 319, NULL),
('Candlewood Suites', 300, '2019-12-19', 191, NULL),
('Candlewood Suites', 300, '2019-12-20', 139, NULL),
('Candlewood Suites', 300, '2019-12-21', 254, NULL),
('Candlewood Suites', 300, '2019-12-22', 338, NULL),
('Candlewood Suites', 300, '2019-12-23', 101, NULL),
('Candlewood Suites', 300, '2019-12-24', 125, NULL),
('Candlewood Suites', 300, '2019-12-25', 326, NULL),
('Candlewood Suites', 300, '2019-12-26', 349, NULL),
('Candlewood Suites', 300, '2019-12-27', 379, NULL),
('Candlewood Suites', 300, '2019-12-28', 393, NULL),
('Candlewood Suites', 300, '2019-12-29', 126, NULL),
('Candlewood Suites', 300, '2019-12-30', 237, NULL),
('Candlewood Suites', 300, '2019-12-31', 377, NULL),
('Candlewood Suites', 300, '2020-01-01', 350, NULL),
('Candlewood Suites', 300, '2020-01-02', 342, NULL),
('Candlewood Suites', 300, '2020-01-03', 373, NULL),
('Candlewood Suites', 300, '2020-01-04', 282, NULL),
('Candlewood Suites', 300, '2020-01-05', 189, NULL),
('Candlewood Suites', 300, '2020-01-06', 161, NULL),
('Candlewood Suites', 300, '2020-01-07', 226, NULL),
('Candlewood Suites', 300, '2020-01-08', 353, NULL),
('Candlewood Suites', 300, '2020-01-09', 211, NULL),
('Candlewood Suites', 300, '2020-01-10', 116, NULL),
('Candlewood Suites', 300, '2020-01-11', 315, NULL),
('Candlewood Suites', 300, '2020-01-12', 315, NULL),
('Candlewood Suites', 300, '2020-01-13', 177, NULL),
('Candlewood Suites', 300, '2020-01-14', 366, NULL),
('Candlewood Suites', 300, '2020-01-15', 193, NULL),
('Candlewood Suites', 300, '2020-01-16', 274, NULL),
('Candlewood Suites', 300, '2020-01-17', 353, NULL),
('Candlewood Suites', 300, '2020-01-18', 112, NULL),
('Candlewood Suites', 300, '2020-01-19', 353, NULL),
('Candlewood Suites', 300, '2020-01-20', 113, NULL),
('Candlewood Suites', 300, '2020-01-21', 225, NULL),
('Candlewood Suites', 300, '2020-01-22', 220, NULL),
('Candlewood Suites', 300, '2020-01-23', 188, NULL),
('Candlewood Suites', 300, '2020-01-24', 344, NULL),
('Candlewood Suites', 300, '2020-01-25', 326, NULL),
('Candlewood Suites', 300, '2020-01-26', 175, NULL),
('Candlewood Suites', 300, '2020-01-27', 215, NULL),
('Candlewood Suites', 300, '2020-01-28', 183, NULL),
('Candlewood Suites', 300, '2020-01-29', 177, NULL),
('Candlewood Suites', 300, '2020-01-30', 277, NULL),
('Candlewood Suites', 300, '2020-01-31', 132, NULL),
('Candlewood Suites', 300, '2020-02-01', 116, NULL),
('Candlewood Suites', 300, '2020-02-02', 300, NULL),
('Candlewood Suites', 300, '2020-02-03', 248, NULL),
('Candlewood Suites', 300, '2020-02-04', 100, NULL),
('Cute Mountains Inn', 4, '2019-01-01', 259, NULL),
('Cute Mountains Inn', 4, '2019-01-02', 100, NULL),
('Cute Mountains Inn', 4, '2019-01-03', 321, NULL),
('Cute Mountains Inn', 4, '2019-01-04', 155, NULL),
('Cute Mountains Inn', 4, '2019-01-05', 117, NULL),
('Cute Mountains Inn', 4, '2019-01-06', 283, NULL),
('Cute Mountains Inn', 4, '2019-01-07', 194, 154),
('Cute Mountains Inn', 4, '2019-01-08', 224, 154),
('Cute Mountains Inn', 4, '2019-01-09', 394, 154),
('Cute Mountains Inn', 4, '2019-01-10', 161, 154),
('Cute Mountains Inn', 4, '2019-01-11', 258, 154),
('Cute Mountains Inn', 4, '2019-01-12', 381, 154),
('Cute Mountains Inn', 4, '2019-01-13', 137, 154),
('Cute Mountains Inn', 4, '2019-01-14', 239, 154),
('Cute Mountains Inn', 4, '2019-01-15', 366, NULL),
('Cute Mountains Inn', 4, '2019-01-16', 235, NULL),
('Cute Mountains Inn', 4, '2019-01-17', 128, NULL),
('Cute Mountains Inn', 4, '2019-01-18', 365, NULL),
('Cute Mountains Inn', 4, '2019-01-19', 104, NULL),
('Cute Mountains Inn', 4, '2019-01-20', 330, NULL),
('Cute Mountains Inn', 4, '2019-01-21', 279, NULL),
('Cute Mountains Inn', 4, '2019-01-22', 130, NULL),
('Cute Mountains Inn', 4, '2019-01-23', 384, NULL),
('Cute Mountains Inn', 4, '2019-01-24', 312, NULL),
('Cute Mountains Inn', 4, '2019-01-25', 286, NULL),
('Cute Mountains Inn', 4, '2019-01-26', 338, NULL),
('Cute Mountains Inn', 4, '2019-01-27', 230, NULL),
('Cute Mountains Inn', 4, '2019-01-28', 204, NULL),
('Cute Mountains Inn', 4, '2019-01-29', 305, NULL),
('Cute Mountains Inn', 4, '2019-01-30', 308, NULL),
('Cute Mountains Inn', 4, '2019-01-31', 398, NULL),
('Cute Mountains Inn', 4, '2019-02-01', 149, NULL),
('Cute Mountains Inn', 4, '2019-02-02', 149, NULL),
('Cute Mountains Inn', 4, '2019-02-03', 358, NULL),
('Cute Mountains Inn', 4, '2019-02-04', 127, NULL),
('Cute Mountains Inn', 4, '2019-02-05', 310, NULL),
('Cute Mountains Inn', 4, '2019-02-06', 333, NULL),
('Cute Mountains Inn', 4, '2019-02-07', 120, NULL),
('Cute Mountains Inn', 4, '2019-02-08', 257, NULL),
('Cute Mountains Inn', 4, '2019-02-09', 109, NULL),
('Cute Mountains Inn', 4, '2019-02-10', 158, NULL),
('Cute Mountains Inn', 4, '2019-02-11', 294, NULL),
('Cute Mountains Inn', 4, '2019-02-12', 119, 20),
('Cute Mountains Inn', 4, '2019-02-13', 244, 20),
('Cute Mountains Inn', 4, '2019-02-14', 143, 20),
('Cute Mountains Inn', 4, '2019-02-15', 265, 20),
('Cute Mountains Inn', 4, '2019-02-16', 259, 20),
('Cute Mountains Inn', 4, '2019-02-17', 353, 20),
('Cute Mountains Inn', 4, '2019-02-18', 145, 20),
('Cute Mountains Inn', 4, '2019-02-19', 255, 20),
('Cute Mountains Inn', 4, '2019-02-20', 198, 20),
('Cute Mountains Inn', 4, '2019-02-21', 134, NULL),
('Cute Mountains Inn', 4, '2019-02-22', 212, NULL),
('Cute Mountains Inn', 4, '2019-02-23', 240, NULL),
('Cute Mountains Inn', 4, '2019-02-24', 147, NULL),
('Cute Mountains Inn', 4, '2019-02-25', 240, NULL),
('Cute Mountains Inn', 4, '2019-02-26', 348, NULL),
('Cute Mountains Inn', 4, '2019-02-27', 269, NULL),
('Cute Mountains Inn', 4, '2019-02-28', 309, NULL),
('Cute Mountains Inn', 4, '2019-03-01', 218, NULL),
('Cute Mountains Inn', 4, '2019-03-02', 276, NULL),
('Cute Mountains Inn', 4, '2019-03-03', 246, NULL),
('Cute Mountains Inn', 4, '2019-03-04', 383, NULL),
('Cute Mountains Inn', 4, '2019-03-05', 240, NULL),
('Cute Mountains Inn', 4, '2019-03-06', 142, NULL),
('Cute Mountains Inn', 4, '2019-03-07', 291, NULL),
('Cute Mountains Inn', 4, '2019-03-08', 231, NULL),
('Cute Mountains Inn', 4, '2019-03-09', 186, NULL),
('Cute Mountains Inn', 4, '2019-03-10', 397, NULL),
('Cute Mountains Inn', 4, '2019-03-11', 224, NULL),
('Cute Mountains Inn', 4, '2019-03-12', 121, NULL),
('Cute Mountains Inn', 4, '2019-03-13', 394, NULL),
('Cute Mountains Inn', 4, '2019-03-14', 126, NULL),
('Cute Mountains Inn', 4, '2019-03-15', 197, NULL),
('Cute Mountains Inn', 4, '2019-03-16', 362, NULL),
('Cute Mountains Inn', 4, '2019-03-17', 205, NULL),
('Cute Mountains Inn', 4, '2019-03-18', 172, NULL),
('Cute Mountains Inn', 4, '2019-03-19', 385, 127),
('Cute Mountains Inn', 4, '2019-03-20', 357, 127),
('Cute Mountains Inn', 4, '2019-03-21', 228, 127),
('Cute Mountains Inn', 4, '2019-03-22', 240, 127),
('Cute Mountains Inn', 4, '2019-03-23', 142, 127),
('Cute Mountains Inn', 4, '2019-03-24', 125, 127),
('Cute Mountains Inn', 4, '2019-03-25', 323, 127),
('Cute Mountains Inn', 4, '2019-03-26', 234, 127),
('Cute Mountains Inn', 4, '2019-03-27', 105, 127),
('Cute Mountains Inn', 4, '2019-03-28', 311, 127),
('Cute Mountains Inn', 4, '2019-03-29', 277, 127),
('Cute Mountains Inn', 4, '2019-03-30', 203, 127),
('Cute Mountains Inn', 4, '2019-03-31', 112, 127),
('Cute Mountains Inn', 4, '2019-04-01', 196, 127),
('Cute Mountains Inn', 4, '2019-04-02', 317, 127),
('Cute Mountains Inn', 4, '2019-04-03', 143, 127),
('Cute Mountains Inn', 4, '2019-04-04', 330, 127),
('Cute Mountains Inn', 4, '2019-04-05', 144, 24),
('Cute Mountains Inn', 4, '2019-04-06', 351, 24),
('Cute Mountains Inn', 4, '2019-04-07', 242, 24),
('Cute Mountains Inn', 4, '2019-04-08', 256, 24),
('Cute Mountains Inn', 4, '2019-04-09', 137, 24),
('Cute Mountains Inn', 4, '2019-04-10', 162, 24),
('Cute Mountains Inn', 4, '2019-04-11', 273, 24),
('Cute Mountains Inn', 4, '2019-04-12', 243, 24),
('Cute Mountains Inn', 4, '2019-04-13', 186, 24),
('Cute Mountains Inn', 4, '2019-04-14', 374, 24),
('Cute Mountains Inn', 4, '2019-04-15', 260, 24),
('Cute Mountains Inn', 4, '2019-04-16', 120, 24),
('Cute Mountains Inn', 4, '2019-04-17', 385, 24),
('Cute Mountains Inn', 4, '2019-04-18', 299, 24),
('Cute Mountains Inn', 4, '2019-04-19', 178, 24),
('Cute Mountains Inn', 4, '2019-04-20', 158, NULL),
('Cute Mountains Inn', 4, '2019-04-21', 140, NULL),
('Cute Mountains Inn', 4, '2019-04-22', 303, NULL),
('Cute Mountains Inn', 4, '2019-04-23', 119, NULL),
('Cute Mountains Inn', 4, '2019-04-24', 237, NULL),
('Cute Mountains Inn', 4, '2019-04-25', 369, NULL),
('Cute Mountains Inn', 4, '2019-04-26', 336, NULL),
('Cute Mountains Inn', 4, '2019-04-27', 183, NULL),
('Cute Mountains Inn', 4, '2019-04-28', 384, NULL),
('Cute Mountains Inn', 4, '2019-04-29', 376, NULL),
('Cute Mountains Inn', 4, '2019-04-30', 116, NULL),
('Cute Mountains Inn', 4, '2019-05-01', 364, NULL),
('Cute Mountains Inn', 4, '2019-05-02', 188, NULL),
('Cute Mountains Inn', 4, '2019-05-03', 365, NULL),
('Cute Mountains Inn', 4, '2019-05-04', 258, NULL),
('Cute Mountains Inn', 4, '2019-05-05', 290, NULL),
('Cute Mountains Inn', 4, '2019-05-06', 144, NULL),
('Cute Mountains Inn', 4, '2019-05-07', 340, NULL),
('Cute Mountains Inn', 4, '2019-05-08', 100, NULL),
('Cute Mountains Inn', 4, '2019-05-09', 310, NULL),
('Cute Mountains Inn', 4, '2019-05-10', 387, NULL),
('Cute Mountains Inn', 4, '2019-05-11', 239, NULL),
('Cute Mountains Inn', 4, '2019-05-12', 116, NULL),
('Cute Mountains Inn', 4, '2019-05-13', 341, NULL),
('Cute Mountains Inn', 4, '2019-05-14', 309, NULL),
('Cute Mountains Inn', 4, '2019-05-15', 317, NULL),
('Cute Mountains Inn', 4, '2019-05-16', 328, NULL),
('Cute Mountains Inn', 4, '2019-05-17', 130, NULL),
('Cute Mountains Inn', 4, '2019-05-18', 190, NULL),
('Cute Mountains Inn', 4, '2019-05-19', 116, NULL),
('Cute Mountains Inn', 4, '2019-05-20', 332, NULL),
('Cute Mountains Inn', 4, '2019-05-21', 216, NULL),
('Cute Mountains Inn', 4, '2019-05-22', 124, NULL),
('Cute Mountains Inn', 4, '2019-05-23', 229, NULL),
('Cute Mountains Inn', 4, '2019-05-24', 215, NULL),
('Cute Mountains Inn', 4, '2019-05-25', 191, NULL),
('Cute Mountains Inn', 4, '2019-05-26', 398, NULL),
('Cute Mountains Inn', 4, '2019-05-27', 243, NULL),
('Cute Mountains Inn', 4, '2019-05-28', 236, NULL),
('Cute Mountains Inn', 4, '2019-05-29', 240, NULL),
('Cute Mountains Inn', 4, '2019-05-30', 235, NULL),
('Cute Mountains Inn', 4, '2019-05-31', 220, NULL),
('Cute Mountains Inn', 4, '2019-06-01', 150, NULL),
('Cute Mountains Inn', 4, '2019-06-02', 277, NULL),
('Cute Mountains Inn', 4, '2019-06-03', 118, NULL),
('Cute Mountains Inn', 4, '2019-06-04', 374, NULL),
('Cute Mountains Inn', 4, '2019-06-05', 180, NULL),
('Cute Mountains Inn', 4, '2019-06-06', 200, NULL),
('Cute Mountains Inn', 4, '2019-06-07', 268, 4),
('Cute Mountains Inn', 4, '2019-06-08', 369, 4),
('Cute Mountains Inn', 4, '2019-06-09', 149, 4),
('Cute Mountains Inn', 4, '2019-06-10', 106, 4),
('Cute Mountains Inn', 4, '2019-06-11', 141, 4),
('Cute Mountains Inn', 4, '2019-06-12', 388, 4),
('Cute Mountains Inn', 4, '2019-06-13', 289, 4),
('Cute Mountains Inn', 4, '2019-06-14', 356, 4),
('Cute Mountains Inn', 4, '2019-06-15', 124, 4),
('Cute Mountains Inn', 4, '2019-06-16', 187, 4),
('Cute Mountains Inn', 4, '2019-06-17', 201, 4),
('Cute Mountains Inn', 4, '2019-06-18', 336, 4),
('Cute Mountains Inn', 4, '2019-06-19', 322, 4),
('Cute Mountains Inn', 4, '2019-06-20', 314, 4),
('Cute Mountains Inn', 4, '2019-06-21', 122, 4),
('Cute Mountains Inn', 4, '2019-06-22', 375, 4),
('Cute Mountains Inn', 4, '2019-06-23', 250, 4),
('Cute Mountains Inn', 4, '2019-06-24', 233, NULL),
('Cute Mountains Inn', 4, '2019-06-25', 209, NULL),
('Cute Mountains Inn', 4, '2019-06-26', 120, NULL),
('Cute Mountains Inn', 4, '2019-06-27', 310, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 4, '2019-06-28', 119, NULL),
('Cute Mountains Inn', 4, '2019-06-29', 190, 8),
('Cute Mountains Inn', 4, '2019-06-30', 262, 8),
('Cute Mountains Inn', 4, '2019-07-01', 378, 8),
('Cute Mountains Inn', 4, '2019-07-02', 220, 8),
('Cute Mountains Inn', 4, '2019-07-03', 118, 8),
('Cute Mountains Inn', 4, '2019-07-04', 321, 8),
('Cute Mountains Inn', 4, '2019-07-05', 126, 8),
('Cute Mountains Inn', 4, '2019-07-06', 155, 8),
('Cute Mountains Inn', 4, '2019-07-07', 156, 8),
('Cute Mountains Inn', 4, '2019-07-08', 245, 8),
('Cute Mountains Inn', 4, '2019-07-09', 328, NULL),
('Cute Mountains Inn', 4, '2019-07-10', 234, NULL),
('Cute Mountains Inn', 4, '2019-07-11', 277, NULL),
('Cute Mountains Inn', 4, '2019-07-12', 304, NULL),
('Cute Mountains Inn', 4, '2019-07-13', 296, NULL),
('Cute Mountains Inn', 4, '2019-07-14', 288, NULL),
('Cute Mountains Inn', 4, '2019-07-15', 178, NULL),
('Cute Mountains Inn', 4, '2019-07-16', 368, NULL),
('Cute Mountains Inn', 4, '2019-07-17', 287, NULL),
('Cute Mountains Inn', 4, '2019-07-18', 131, NULL),
('Cute Mountains Inn', 4, '2019-07-19', 260, NULL),
('Cute Mountains Inn', 4, '2019-07-20', 251, NULL),
('Cute Mountains Inn', 4, '2019-07-21', 345, NULL),
('Cute Mountains Inn', 4, '2019-07-22', 154, NULL),
('Cute Mountains Inn', 4, '2019-07-23', 168, NULL),
('Cute Mountains Inn', 4, '2019-07-24', 354, NULL),
('Cute Mountains Inn', 4, '2019-07-25', 392, 30),
('Cute Mountains Inn', 4, '2019-07-26', 280, 30),
('Cute Mountains Inn', 4, '2019-07-27', 172, 30),
('Cute Mountains Inn', 4, '2019-07-28', 190, NULL),
('Cute Mountains Inn', 4, '2019-07-29', 298, NULL),
('Cute Mountains Inn', 4, '2019-07-30', 208, NULL),
('Cute Mountains Inn', 4, '2019-07-31', 118, NULL),
('Cute Mountains Inn', 4, '2019-08-01', 322, NULL),
('Cute Mountains Inn', 4, '2019-08-02', 264, NULL),
('Cute Mountains Inn', 4, '2019-08-03', 106, NULL),
('Cute Mountains Inn', 4, '2019-08-04', 281, 101),
('Cute Mountains Inn', 4, '2019-08-05', 199, 101),
('Cute Mountains Inn', 4, '2019-08-06', 169, 101),
('Cute Mountains Inn', 4, '2019-08-07', 170, 101),
('Cute Mountains Inn', 4, '2019-08-08', 379, 101),
('Cute Mountains Inn', 4, '2019-08-09', 125, 101),
('Cute Mountains Inn', 4, '2019-08-10', 368, 101),
('Cute Mountains Inn', 4, '2019-08-11', 201, 101),
('Cute Mountains Inn', 4, '2019-08-12', 123, 101),
('Cute Mountains Inn', 4, '2019-08-13', 347, 101),
('Cute Mountains Inn', 4, '2019-08-14', 387, 101),
('Cute Mountains Inn', 4, '2019-08-15', 217, 101),
('Cute Mountains Inn', 4, '2019-08-16', 275, 101),
('Cute Mountains Inn', 4, '2019-08-17', 257, 101),
('Cute Mountains Inn', 4, '2019-08-18', 379, 101),
('Cute Mountains Inn', 4, '2019-08-19', 212, 101),
('Cute Mountains Inn', 4, '2019-08-20', 209, 101),
('Cute Mountains Inn', 4, '2019-08-21', 384, 101),
('Cute Mountains Inn', 4, '2019-08-22', 279, 101),
('Cute Mountains Inn', 4, '2019-08-23', 217, 101),
('Cute Mountains Inn', 4, '2019-08-24', 336, 101),
('Cute Mountains Inn', 4, '2019-08-25', 135, 55),
('Cute Mountains Inn', 4, '2019-08-26', 119, 55),
('Cute Mountains Inn', 4, '2019-08-27', 242, 55),
('Cute Mountains Inn', 4, '2019-08-28', 227, 55),
('Cute Mountains Inn', 4, '2019-08-29', 399, 55),
('Cute Mountains Inn', 4, '2019-08-30', 334, 55),
('Cute Mountains Inn', 4, '2019-08-31', 207, 55),
('Cute Mountains Inn', 4, '2019-09-01', 191, 55),
('Cute Mountains Inn', 4, '2019-09-02', 377, 55),
('Cute Mountains Inn', 4, '2019-09-03', 269, 55),
('Cute Mountains Inn', 4, '2019-09-04', 143, 55),
('Cute Mountains Inn', 4, '2019-09-05', 267, 55),
('Cute Mountains Inn', 4, '2019-09-06', 337, 55),
('Cute Mountains Inn', 4, '2019-09-07', 369, 55),
('Cute Mountains Inn', 4, '2019-09-08', 374, 55),
('Cute Mountains Inn', 4, '2019-09-09', 257, 55),
('Cute Mountains Inn', 4, '2019-09-10', 167, 55),
('Cute Mountains Inn', 4, '2019-09-11', 353, 55),
('Cute Mountains Inn', 4, '2019-09-12', 187, 55),
('Cute Mountains Inn', 4, '2019-09-13', 218, 55),
('Cute Mountains Inn', 4, '2019-09-14', 130, NULL),
('Cute Mountains Inn', 4, '2019-09-15', 187, NULL),
('Cute Mountains Inn', 4, '2019-09-16', 375, NULL),
('Cute Mountains Inn', 4, '2019-09-17', 119, NULL),
('Cute Mountains Inn', 4, '2019-09-18', 115, NULL),
('Cute Mountains Inn', 4, '2019-09-19', 237, NULL),
('Cute Mountains Inn', 4, '2019-09-20', 371, NULL),
('Cute Mountains Inn', 4, '2019-09-21', 102, NULL),
('Cute Mountains Inn', 4, '2019-09-22', 332, NULL),
('Cute Mountains Inn', 4, '2019-09-23', 283, NULL),
('Cute Mountains Inn', 4, '2019-09-24', 105, NULL),
('Cute Mountains Inn', 4, '2019-09-25', 347, NULL),
('Cute Mountains Inn', 4, '2019-09-26', 295, NULL),
('Cute Mountains Inn', 4, '2019-09-27', 108, NULL),
('Cute Mountains Inn', 4, '2019-09-28', 253, NULL),
('Cute Mountains Inn', 4, '2019-09-29', 375, NULL),
('Cute Mountains Inn', 4, '2019-09-30', 260, NULL),
('Cute Mountains Inn', 4, '2019-10-01', 331, NULL),
('Cute Mountains Inn', 4, '2019-10-02', 334, NULL),
('Cute Mountains Inn', 4, '2019-10-03', 106, NULL),
('Cute Mountains Inn', 4, '2019-10-04', 114, NULL),
('Cute Mountains Inn', 4, '2019-10-05', 198, NULL),
('Cute Mountains Inn', 4, '2019-10-06', 194, NULL),
('Cute Mountains Inn', 4, '2019-10-07', 146, NULL),
('Cute Mountains Inn', 4, '2019-10-08', 244, NULL),
('Cute Mountains Inn', 4, '2019-10-09', 278, NULL),
('Cute Mountains Inn', 4, '2019-10-10', 103, NULL),
('Cute Mountains Inn', 4, '2019-10-11', 223, NULL),
('Cute Mountains Inn', 4, '2019-10-12', 343, NULL),
('Cute Mountains Inn', 4, '2019-10-13', 299, 82),
('Cute Mountains Inn', 4, '2019-10-14', 110, 82),
('Cute Mountains Inn', 4, '2019-10-15', 119, 82),
('Cute Mountains Inn', 4, '2019-10-16', 285, 82),
('Cute Mountains Inn', 4, '2019-10-17', 197, 82),
('Cute Mountains Inn', 4, '2019-10-18', 191, 82),
('Cute Mountains Inn', 4, '2019-10-19', 216, 82),
('Cute Mountains Inn', 4, '2019-10-20', 127, 82),
('Cute Mountains Inn', 4, '2019-10-21', 365, 82),
('Cute Mountains Inn', 4, '2019-10-22', 231, 82),
('Cute Mountains Inn', 4, '2019-10-23', 341, 82),
('Cute Mountains Inn', 4, '2019-10-24', 326, 82),
('Cute Mountains Inn', 4, '2019-10-25', 255, 82),
('Cute Mountains Inn', 4, '2019-10-26', 313, 82),
('Cute Mountains Inn', 4, '2019-10-27', 364, 82),
('Cute Mountains Inn', 4, '2019-10-28', 337, 82),
('Cute Mountains Inn', 4, '2019-10-29', 232, 82),
('Cute Mountains Inn', 4, '2019-10-30', 209, NULL),
('Cute Mountains Inn', 4, '2019-10-31', 292, NULL),
('Cute Mountains Inn', 4, '2019-11-01', 369, NULL),
('Cute Mountains Inn', 4, '2019-11-02', 182, NULL),
('Cute Mountains Inn', 4, '2019-11-03', 172, NULL),
('Cute Mountains Inn', 4, '2019-11-04', 228, NULL),
('Cute Mountains Inn', 4, '2019-11-05', 173, NULL),
('Cute Mountains Inn', 4, '2019-11-06', 196, NULL),
('Cute Mountains Inn', 4, '2019-11-07', 363, NULL),
('Cute Mountains Inn', 4, '2019-11-08', 391, NULL),
('Cute Mountains Inn', 4, '2019-11-09', 320, NULL),
('Cute Mountains Inn', 4, '2019-11-10', 106, NULL),
('Cute Mountains Inn', 4, '2019-11-11', 153, NULL),
('Cute Mountains Inn', 4, '2019-11-12', 279, NULL),
('Cute Mountains Inn', 4, '2019-11-13', 170, NULL),
('Cute Mountains Inn', 4, '2019-11-14', 186, NULL),
('Cute Mountains Inn', 4, '2019-11-15', 390, NULL),
('Cute Mountains Inn', 4, '2019-11-16', 132, NULL),
('Cute Mountains Inn', 4, '2019-11-17', 252, NULL),
('Cute Mountains Inn', 4, '2019-11-18', 286, NULL),
('Cute Mountains Inn', 4, '2019-11-19', 246, NULL),
('Cute Mountains Inn', 4, '2019-11-20', 181, NULL),
('Cute Mountains Inn', 4, '2019-11-21', 101, NULL),
('Cute Mountains Inn', 4, '2019-11-22', 342, NULL),
('Cute Mountains Inn', 4, '2019-11-23', 313, NULL),
('Cute Mountains Inn', 4, '2019-11-24', 251, NULL),
('Cute Mountains Inn', 4, '2019-11-25', 158, NULL),
('Cute Mountains Inn', 4, '2019-11-26', 111, NULL),
('Cute Mountains Inn', 4, '2019-11-27', 213, NULL),
('Cute Mountains Inn', 4, '2019-11-28', 202, NULL),
('Cute Mountains Inn', 4, '2019-11-29', 320, NULL),
('Cute Mountains Inn', 4, '2019-11-30', 209, NULL),
('Cute Mountains Inn', 4, '2019-12-01', 319, NULL),
('Cute Mountains Inn', 4, '2019-12-02', 218, NULL),
('Cute Mountains Inn', 4, '2019-12-03', 261, NULL),
('Cute Mountains Inn', 4, '2019-12-04', 325, NULL),
('Cute Mountains Inn', 4, '2019-12-05', 135, 72),
('Cute Mountains Inn', 4, '2019-12-06', 360, 72),
('Cute Mountains Inn', 4, '2019-12-07', 340, 72),
('Cute Mountains Inn', 4, '2019-12-08', 162, 72),
('Cute Mountains Inn', 4, '2019-12-09', 139, 72),
('Cute Mountains Inn', 4, '2019-12-10', 352, 72),
('Cute Mountains Inn', 4, '2019-12-11', 146, NULL),
('Cute Mountains Inn', 4, '2019-12-12', 327, NULL),
('Cute Mountains Inn', 4, '2019-12-13', 334, NULL),
('Cute Mountains Inn', 4, '2019-12-14', 170, NULL),
('Cute Mountains Inn', 4, '2019-12-15', 290, NULL),
('Cute Mountains Inn', 4, '2019-12-16', 307, NULL),
('Cute Mountains Inn', 4, '2019-12-17', 168, NULL),
('Cute Mountains Inn', 4, '2019-12-18', 164, NULL),
('Cute Mountains Inn', 4, '2019-12-19', 263, NULL),
('Cute Mountains Inn', 4, '2019-12-20', 133, NULL),
('Cute Mountains Inn', 4, '2019-12-21', 316, NULL),
('Cute Mountains Inn', 4, '2019-12-22', 160, 14),
('Cute Mountains Inn', 4, '2019-12-23', 215, 14),
('Cute Mountains Inn', 4, '2019-12-24', 269, 14),
('Cute Mountains Inn', 4, '2019-12-25', 206, 14),
('Cute Mountains Inn', 4, '2019-12-26', 230, 14),
('Cute Mountains Inn', 4, '2019-12-27', 343, 14),
('Cute Mountains Inn', 4, '2019-12-28', 329, 14),
('Cute Mountains Inn', 4, '2019-12-29', 244, 14),
('Cute Mountains Inn', 4, '2019-12-30', 301, 14),
('Cute Mountains Inn', 4, '2019-12-31', 379, 14),
('Cute Mountains Inn', 4, '2020-01-01', 128, 14),
('Cute Mountains Inn', 4, '2020-01-02', 234, 14),
('Cute Mountains Inn', 4, '2020-01-03', 201, 14),
('Cute Mountains Inn', 4, '2020-01-04', 359, 14),
('Cute Mountains Inn', 4, '2020-01-05', 127, 14),
('Cute Mountains Inn', 4, '2020-01-06', 207, 14),
('Cute Mountains Inn', 4, '2020-01-07', 157, 14),
('Cute Mountains Inn', 4, '2020-01-08', 146, 14),
('Cute Mountains Inn', 4, '2020-01-09', 265, 14),
('Cute Mountains Inn', 4, '2020-01-10', 211, 14),
('Cute Mountains Inn', 4, '2020-01-11', 276, 14),
('Cute Mountains Inn', 4, '2020-01-12', 184, 14),
('Cute Mountains Inn', 4, '2020-01-13', 220, NULL),
('Cute Mountains Inn', 4, '2020-01-14', 350, NULL),
('Cute Mountains Inn', 4, '2020-01-15', 269, NULL),
('Cute Mountains Inn', 4, '2020-01-16', 396, NULL),
('Cute Mountains Inn', 4, '2020-01-17', 250, NULL),
('Cute Mountains Inn', 4, '2020-01-18', 230, NULL),
('Cute Mountains Inn', 4, '2020-01-19', 353, NULL),
('Cute Mountains Inn', 4, '2020-01-20', 308, NULL),
('Cute Mountains Inn', 4, '2020-01-21', 151, NULL),
('Cute Mountains Inn', 4, '2020-01-22', 399, NULL),
('Cute Mountains Inn', 4, '2020-01-23', 308, NULL),
('Cute Mountains Inn', 4, '2020-01-24', 131, NULL),
('Cute Mountains Inn', 4, '2020-01-25', 372, NULL),
('Cute Mountains Inn', 4, '2020-01-26', 345, NULL),
('Cute Mountains Inn', 4, '2020-01-27', 319, NULL),
('Cute Mountains Inn', 4, '2020-01-28', 342, NULL),
('Cute Mountains Inn', 4, '2020-01-29', 237, NULL),
('Cute Mountains Inn', 4, '2020-01-30', 156, NULL),
('Cute Mountains Inn', 4, '2020-01-31', 117, 64),
('Cute Mountains Inn', 4, '2020-02-01', 334, 64),
('Cute Mountains Inn', 4, '2020-02-02', 310, 64),
('Cute Mountains Inn', 4, '2020-02-03', 223, 64),
('Cute Mountains Inn', 4, '2020-02-04', 270, NULL),
('Cute Mountains Inn', 9, '2019-01-01', 339, NULL),
('Cute Mountains Inn', 9, '2019-01-02', 171, NULL),
('Cute Mountains Inn', 9, '2019-01-03', 222, NULL),
('Cute Mountains Inn', 9, '2019-01-04', 142, NULL),
('Cute Mountains Inn', 9, '2019-01-05', 281, NULL),
('Cute Mountains Inn', 9, '2019-01-06', 184, NULL),
('Cute Mountains Inn', 9, '2019-01-07', 336, NULL),
('Cute Mountains Inn', 9, '2019-01-08', 287, NULL),
('Cute Mountains Inn', 9, '2019-01-09', 347, NULL),
('Cute Mountains Inn', 9, '2019-01-10', 340, NULL),
('Cute Mountains Inn', 9, '2019-01-11', 331, NULL),
('Cute Mountains Inn', 9, '2019-01-12', 311, NULL),
('Cute Mountains Inn', 9, '2019-01-13', 306, NULL),
('Cute Mountains Inn', 9, '2019-01-14', 298, NULL),
('Cute Mountains Inn', 9, '2019-01-15', 200, NULL),
('Cute Mountains Inn', 9, '2019-01-16', 262, NULL),
('Cute Mountains Inn', 9, '2019-01-17', 208, NULL),
('Cute Mountains Inn', 9, '2019-01-18', 198, NULL),
('Cute Mountains Inn', 9, '2019-01-19', 121, NULL),
('Cute Mountains Inn', 9, '2019-01-20', 202, NULL),
('Cute Mountains Inn', 9, '2019-01-21', 224, NULL),
('Cute Mountains Inn', 9, '2019-01-22', 180, NULL),
('Cute Mountains Inn', 9, '2019-01-23', 327, NULL),
('Cute Mountains Inn', 9, '2019-01-24', 357, NULL),
('Cute Mountains Inn', 9, '2019-01-25', 385, NULL),
('Cute Mountains Inn', 9, '2019-01-26', 218, NULL),
('Cute Mountains Inn', 9, '2019-01-27', 182, NULL),
('Cute Mountains Inn', 9, '2019-01-28', 100, NULL),
('Cute Mountains Inn', 9, '2019-01-29', 154, NULL),
('Cute Mountains Inn', 9, '2019-01-30', 310, NULL),
('Cute Mountains Inn', 9, '2019-01-31', 109, NULL),
('Cute Mountains Inn', 9, '2019-02-01', 216, NULL),
('Cute Mountains Inn', 9, '2019-02-02', 242, NULL),
('Cute Mountains Inn', 9, '2019-02-03', 342, NULL),
('Cute Mountains Inn', 9, '2019-02-04', 235, NULL),
('Cute Mountains Inn', 9, '2019-02-05', 399, NULL),
('Cute Mountains Inn', 9, '2019-02-06', 218, NULL),
('Cute Mountains Inn', 9, '2019-02-07', 155, NULL),
('Cute Mountains Inn', 9, '2019-02-08', 227, NULL),
('Cute Mountains Inn', 9, '2019-02-09', 348, NULL),
('Cute Mountains Inn', 9, '2019-02-10', 319, NULL),
('Cute Mountains Inn', 9, '2019-02-11', 238, NULL),
('Cute Mountains Inn', 9, '2019-02-12', 188, NULL),
('Cute Mountains Inn', 9, '2019-02-13', 246, NULL),
('Cute Mountains Inn', 9, '2019-02-14', 271, 60),
('Cute Mountains Inn', 9, '2019-02-15', 286, 60),
('Cute Mountains Inn', 9, '2019-02-16', 341, 60),
('Cute Mountains Inn', 9, '2019-02-17', 277, 60),
('Cute Mountains Inn', 9, '2019-02-18', 108, 60),
('Cute Mountains Inn', 9, '2019-02-19', 334, 60),
('Cute Mountains Inn', 9, '2019-02-20', 183, 60),
('Cute Mountains Inn', 9, '2019-02-21', 167, 60),
('Cute Mountains Inn', 9, '2019-02-22', 255, 60),
('Cute Mountains Inn', 9, '2019-02-23', 354, 60),
('Cute Mountains Inn', 9, '2019-02-24', 120, 60),
('Cute Mountains Inn', 9, '2019-02-25', 224, 60),
('Cute Mountains Inn', 9, '2019-02-26', 385, 60),
('Cute Mountains Inn', 9, '2019-02-27', 277, 60),
('Cute Mountains Inn', 9, '2019-02-28', 201, 60),
('Cute Mountains Inn', 9, '2019-03-01', 143, 60),
('Cute Mountains Inn', 9, '2019-03-02', 114, 60),
('Cute Mountains Inn', 9, '2019-03-03', 144, 60),
('Cute Mountains Inn', 9, '2019-03-04', 261, 60),
('Cute Mountains Inn', 9, '2019-03-05', 313, 60),
('Cute Mountains Inn', 9, '2019-03-06', 359, 60),
('Cute Mountains Inn', 9, '2019-03-07', 179, NULL),
('Cute Mountains Inn', 9, '2019-03-08', 326, NULL),
('Cute Mountains Inn', 9, '2019-03-09', 196, NULL),
('Cute Mountains Inn', 9, '2019-03-10', 297, NULL),
('Cute Mountains Inn', 9, '2019-03-11', 241, NULL),
('Cute Mountains Inn', 9, '2019-03-12', 121, NULL),
('Cute Mountains Inn', 9, '2019-03-13', 134, NULL),
('Cute Mountains Inn', 9, '2019-03-14', 185, NULL),
('Cute Mountains Inn', 9, '2019-03-15', 180, NULL),
('Cute Mountains Inn', 9, '2019-03-16', 141, NULL),
('Cute Mountains Inn', 9, '2019-03-17', 231, NULL),
('Cute Mountains Inn', 9, '2019-03-18', 206, NULL),
('Cute Mountains Inn', 9, '2019-03-19', 373, NULL),
('Cute Mountains Inn', 9, '2019-03-20', 364, NULL),
('Cute Mountains Inn', 9, '2019-03-21', 309, NULL),
('Cute Mountains Inn', 9, '2019-03-22', 269, NULL),
('Cute Mountains Inn', 9, '2019-03-23', 259, NULL),
('Cute Mountains Inn', 9, '2019-03-24', 247, NULL),
('Cute Mountains Inn', 9, '2019-03-25', 195, NULL),
('Cute Mountains Inn', 9, '2019-03-26', 374, NULL),
('Cute Mountains Inn', 9, '2019-03-27', 118, NULL),
('Cute Mountains Inn', 9, '2019-03-28', 105, NULL),
('Cute Mountains Inn', 9, '2019-03-29', 227, NULL),
('Cute Mountains Inn', 9, '2019-03-30', 332, NULL),
('Cute Mountains Inn', 9, '2019-03-31', 184, NULL),
('Cute Mountains Inn', 9, '2019-04-01', 317, NULL),
('Cute Mountains Inn', 9, '2019-04-02', 186, NULL),
('Cute Mountains Inn', 9, '2019-04-03', 352, NULL),
('Cute Mountains Inn', 9, '2019-04-04', 152, 74),
('Cute Mountains Inn', 9, '2019-04-05', 142, 74),
('Cute Mountains Inn', 9, '2019-04-06', 249, 74),
('Cute Mountains Inn', 9, '2019-04-07', 168, 74),
('Cute Mountains Inn', 9, '2019-04-08', 249, 74),
('Cute Mountains Inn', 9, '2019-04-09', 313, 74),
('Cute Mountains Inn', 9, '2019-04-10', 293, 74),
('Cute Mountains Inn', 9, '2019-04-11', 350, 74),
('Cute Mountains Inn', 9, '2019-04-12', 269, 74),
('Cute Mountains Inn', 9, '2019-04-13', 377, 74),
('Cute Mountains Inn', 9, '2019-04-14', 166, 74),
('Cute Mountains Inn', 9, '2019-04-15', 357, 74),
('Cute Mountains Inn', 9, '2019-04-16', 143, 74),
('Cute Mountains Inn', 9, '2019-04-17', 115, 74),
('Cute Mountains Inn', 9, '2019-04-18', 370, 74),
('Cute Mountains Inn', 9, '2019-04-19', 364, 74),
('Cute Mountains Inn', 9, '2019-04-20', 268, 74),
('Cute Mountains Inn', 9, '2019-04-21', 250, 74),
('Cute Mountains Inn', 9, '2019-04-22', 118, 74),
('Cute Mountains Inn', 9, '2019-04-23', 176, 74),
('Cute Mountains Inn', 9, '2019-04-24', 185, 74),
('Cute Mountains Inn', 9, '2019-04-25', 188, 74),
('Cute Mountains Inn', 9, '2019-04-26', 121, 74),
('Cute Mountains Inn', 9, '2019-04-27', 330, 74),
('Cute Mountains Inn', 9, '2019-04-28', 369, NULL),
('Cute Mountains Inn', 9, '2019-04-29', 293, NULL),
('Cute Mountains Inn', 9, '2019-04-30', 368, NULL),
('Cute Mountains Inn', 9, '2019-05-01', 365, NULL),
('Cute Mountains Inn', 9, '2019-05-02', 104, NULL),
('Cute Mountains Inn', 9, '2019-05-03', 375, NULL),
('Cute Mountains Inn', 9, '2019-05-04', 223, NULL),
('Cute Mountains Inn', 9, '2019-05-05', 301, NULL),
('Cute Mountains Inn', 9, '2019-05-06', 370, NULL),
('Cute Mountains Inn', 9, '2019-05-07', 305, NULL),
('Cute Mountains Inn', 9, '2019-05-08', 131, NULL),
('Cute Mountains Inn', 9, '2019-05-09', 239, NULL),
('Cute Mountains Inn', 9, '2019-05-10', 266, NULL),
('Cute Mountains Inn', 9, '2019-05-11', 270, NULL),
('Cute Mountains Inn', 9, '2019-05-12', 180, NULL),
('Cute Mountains Inn', 9, '2019-05-13', 238, NULL),
('Cute Mountains Inn', 9, '2019-05-14', 170, NULL),
('Cute Mountains Inn', 9, '2019-05-15', 173, NULL),
('Cute Mountains Inn', 9, '2019-05-16', 239, NULL),
('Cute Mountains Inn', 9, '2019-05-17', 377, NULL),
('Cute Mountains Inn', 9, '2019-05-18', 178, NULL),
('Cute Mountains Inn', 9, '2019-05-19', 376, NULL),
('Cute Mountains Inn', 9, '2019-05-20', 221, NULL),
('Cute Mountains Inn', 9, '2019-05-21', 218, NULL),
('Cute Mountains Inn', 9, '2019-05-22', 118, NULL),
('Cute Mountains Inn', 9, '2019-05-23', 328, NULL),
('Cute Mountains Inn', 9, '2019-05-24', 146, NULL),
('Cute Mountains Inn', 9, '2019-05-25', 106, NULL),
('Cute Mountains Inn', 9, '2019-05-26', 168, NULL),
('Cute Mountains Inn', 9, '2019-05-27', 262, NULL),
('Cute Mountains Inn', 9, '2019-05-28', 286, NULL),
('Cute Mountains Inn', 9, '2019-05-29', 226, NULL),
('Cute Mountains Inn', 9, '2019-05-30', 139, NULL),
('Cute Mountains Inn', 9, '2019-05-31', 379, NULL),
('Cute Mountains Inn', 9, '2019-06-01', 325, NULL),
('Cute Mountains Inn', 9, '2019-06-02', 307, NULL),
('Cute Mountains Inn', 9, '2019-06-03', 202, NULL),
('Cute Mountains Inn', 9, '2019-06-04', 271, NULL),
('Cute Mountains Inn', 9, '2019-06-05', 260, NULL),
('Cute Mountains Inn', 9, '2019-06-06', 125, NULL),
('Cute Mountains Inn', 9, '2019-06-07', 244, NULL),
('Cute Mountains Inn', 9, '2019-06-08', 125, NULL),
('Cute Mountains Inn', 9, '2019-06-09', 189, NULL),
('Cute Mountains Inn', 9, '2019-06-10', 349, NULL),
('Cute Mountains Inn', 9, '2019-06-11', 264, NULL),
('Cute Mountains Inn', 9, '2019-06-12', 384, 109),
('Cute Mountains Inn', 9, '2019-06-13', 354, 109),
('Cute Mountains Inn', 9, '2019-06-14', 270, 109),
('Cute Mountains Inn', 9, '2019-06-15', 242, 109),
('Cute Mountains Inn', 9, '2019-06-16', 327, 109),
('Cute Mountains Inn', 9, '2019-06-17', 173, 109),
('Cute Mountains Inn', 9, '2019-06-18', 353, 109),
('Cute Mountains Inn', 9, '2019-06-19', 176, 109),
('Cute Mountains Inn', 9, '2019-06-20', 359, 109),
('Cute Mountains Inn', 9, '2019-06-21', 249, 109),
('Cute Mountains Inn', 9, '2019-06-22', 346, NULL),
('Cute Mountains Inn', 9, '2019-06-23', 212, NULL),
('Cute Mountains Inn', 9, '2019-06-24', 111, NULL),
('Cute Mountains Inn', 9, '2019-06-25', 230, NULL),
('Cute Mountains Inn', 9, '2019-06-26', 102, NULL),
('Cute Mountains Inn', 9, '2019-06-27', 103, NULL),
('Cute Mountains Inn', 9, '2019-06-28', 210, NULL),
('Cute Mountains Inn', 9, '2019-06-29', 279, NULL),
('Cute Mountains Inn', 9, '2019-06-30', 165, NULL),
('Cute Mountains Inn', 9, '2019-07-01', 334, NULL),
('Cute Mountains Inn', 9, '2019-07-02', 146, NULL),
('Cute Mountains Inn', 9, '2019-07-03', 184, NULL),
('Cute Mountains Inn', 9, '2019-07-04', 277, NULL),
('Cute Mountains Inn', 9, '2019-07-05', 304, NULL),
('Cute Mountains Inn', 9, '2019-07-06', 201, NULL),
('Cute Mountains Inn', 9, '2019-07-07', 239, NULL),
('Cute Mountains Inn', 9, '2019-07-08', 112, NULL),
('Cute Mountains Inn', 9, '2019-07-09', 297, NULL),
('Cute Mountains Inn', 9, '2019-07-10', 116, NULL),
('Cute Mountains Inn', 9, '2019-07-11', 167, NULL),
('Cute Mountains Inn', 9, '2019-07-12', 361, NULL),
('Cute Mountains Inn', 9, '2019-07-13', 305, NULL),
('Cute Mountains Inn', 9, '2019-07-14', 105, NULL),
('Cute Mountains Inn', 9, '2019-07-15', 308, NULL),
('Cute Mountains Inn', 9, '2019-07-16', 124, NULL),
('Cute Mountains Inn', 9, '2019-07-17', 373, NULL),
('Cute Mountains Inn', 9, '2019-07-18', 246, NULL),
('Cute Mountains Inn', 9, '2019-07-19', 217, NULL),
('Cute Mountains Inn', 9, '2019-07-20', 312, NULL),
('Cute Mountains Inn', 9, '2019-07-21', 213, NULL),
('Cute Mountains Inn', 9, '2019-07-22', 230, NULL),
('Cute Mountains Inn', 9, '2019-07-23', 268, NULL),
('Cute Mountains Inn', 9, '2019-07-24', 115, NULL),
('Cute Mountains Inn', 9, '2019-07-25', 399, NULL),
('Cute Mountains Inn', 9, '2019-07-26', 190, NULL),
('Cute Mountains Inn', 9, '2019-07-27', 328, NULL),
('Cute Mountains Inn', 9, '2019-07-28', 253, NULL),
('Cute Mountains Inn', 9, '2019-07-29', 359, NULL),
('Cute Mountains Inn', 9, '2019-07-30', 109, NULL),
('Cute Mountains Inn', 9, '2019-07-31', 101, NULL),
('Cute Mountains Inn', 9, '2019-08-01', 155, NULL),
('Cute Mountains Inn', 9, '2019-08-02', 297, NULL),
('Cute Mountains Inn', 9, '2019-08-03', 131, NULL),
('Cute Mountains Inn', 9, '2019-08-04', 252, NULL),
('Cute Mountains Inn', 9, '2019-08-05', 101, NULL),
('Cute Mountains Inn', 9, '2019-08-06', 153, NULL),
('Cute Mountains Inn', 9, '2019-08-07', 165, NULL),
('Cute Mountains Inn', 9, '2019-08-08', 341, NULL),
('Cute Mountains Inn', 9, '2019-08-09', 153, 128),
('Cute Mountains Inn', 9, '2019-08-10', 332, 128),
('Cute Mountains Inn', 9, '2019-08-11', 366, 128),
('Cute Mountains Inn', 9, '2019-08-12', 283, 128),
('Cute Mountains Inn', 9, '2019-08-13', 217, 128),
('Cute Mountains Inn', 9, '2019-08-14', 181, 128),
('Cute Mountains Inn', 9, '2019-08-15', 189, 128),
('Cute Mountains Inn', 9, '2019-08-16', 164, 128),
('Cute Mountains Inn', 9, '2019-08-17', 145, 128),
('Cute Mountains Inn', 9, '2019-08-18', 324, 128),
('Cute Mountains Inn', 9, '2019-08-19', 307, 128),
('Cute Mountains Inn', 9, '2019-08-20', 141, 128),
('Cute Mountains Inn', 9, '2019-08-21', 212, 128),
('Cute Mountains Inn', 9, '2019-08-22', 128, 128),
('Cute Mountains Inn', 9, '2019-08-23', 396, 128),
('Cute Mountains Inn', 9, '2019-08-24', 389, NULL),
('Cute Mountains Inn', 9, '2019-08-25', 253, NULL),
('Cute Mountains Inn', 9, '2019-08-26', 188, NULL),
('Cute Mountains Inn', 9, '2019-08-27', 270, NULL),
('Cute Mountains Inn', 9, '2019-08-28', 319, NULL),
('Cute Mountains Inn', 9, '2019-08-29', 142, NULL),
('Cute Mountains Inn', 9, '2019-08-30', 173, NULL),
('Cute Mountains Inn', 9, '2019-08-31', 218, NULL),
('Cute Mountains Inn', 9, '2019-09-01', 106, NULL),
('Cute Mountains Inn', 9, '2019-09-02', 160, NULL),
('Cute Mountains Inn', 9, '2019-09-03', 237, NULL),
('Cute Mountains Inn', 9, '2019-09-04', 106, NULL),
('Cute Mountains Inn', 9, '2019-09-05', 209, NULL),
('Cute Mountains Inn', 9, '2019-09-06', 323, NULL),
('Cute Mountains Inn', 9, '2019-09-07', 131, NULL),
('Cute Mountains Inn', 9, '2019-09-08', 196, NULL),
('Cute Mountains Inn', 9, '2019-09-09', 308, 147),
('Cute Mountains Inn', 9, '2019-09-10', 285, 147),
('Cute Mountains Inn', 9, '2019-09-11', 188, 147),
('Cute Mountains Inn', 9, '2019-09-12', 374, 147),
('Cute Mountains Inn', 9, '2019-09-13', 367, 147),
('Cute Mountains Inn', 9, '2019-09-14', 146, 147),
('Cute Mountains Inn', 9, '2019-09-15', 233, 147),
('Cute Mountains Inn', 9, '2019-09-16', 295, 147),
('Cute Mountains Inn', 9, '2019-09-17', 116, 147),
('Cute Mountains Inn', 9, '2019-09-18', 123, 147),
('Cute Mountains Inn', 9, '2019-09-19', 130, 147),
('Cute Mountains Inn', 9, '2019-09-20', 354, 147),
('Cute Mountains Inn', 9, '2019-09-21', 257, 147),
('Cute Mountains Inn', 9, '2019-09-22', 129, 147),
('Cute Mountains Inn', 9, '2019-09-23', 174, 147),
('Cute Mountains Inn', 9, '2019-09-24', 345, 147),
('Cute Mountains Inn', 9, '2019-09-25', 151, 147),
('Cute Mountains Inn', 9, '2019-09-26', 206, 147),
('Cute Mountains Inn', 9, '2019-09-27', 308, 147),
('Cute Mountains Inn', 9, '2019-09-28', 281, 147),
('Cute Mountains Inn', 9, '2019-09-29', 371, 147),
('Cute Mountains Inn', 9, '2019-09-30', 138, 147),
('Cute Mountains Inn', 9, '2019-10-01', 147, 147),
('Cute Mountains Inn', 9, '2019-10-02', 379, NULL),
('Cute Mountains Inn', 9, '2019-10-03', 192, NULL),
('Cute Mountains Inn', 9, '2019-10-04', 379, NULL),
('Cute Mountains Inn', 9, '2019-10-05', 382, NULL),
('Cute Mountains Inn', 9, '2019-10-06', 293, NULL),
('Cute Mountains Inn', 9, '2019-10-07', 307, NULL),
('Cute Mountains Inn', 9, '2019-10-08', 364, NULL),
('Cute Mountains Inn', 9, '2019-10-09', 147, NULL),
('Cute Mountains Inn', 9, '2019-10-10', 339, NULL),
('Cute Mountains Inn', 9, '2019-10-11', 268, NULL),
('Cute Mountains Inn', 9, '2019-10-12', 284, NULL),
('Cute Mountains Inn', 9, '2019-10-13', 141, NULL),
('Cute Mountains Inn', 9, '2019-10-14', 345, NULL),
('Cute Mountains Inn', 9, '2019-10-15', 390, NULL),
('Cute Mountains Inn', 9, '2019-10-16', 127, NULL),
('Cute Mountains Inn', 9, '2019-10-17', 375, NULL),
('Cute Mountains Inn', 9, '2019-10-18', 253, NULL),
('Cute Mountains Inn', 9, '2019-10-19', 167, NULL),
('Cute Mountains Inn', 9, '2019-10-20', 356, NULL),
('Cute Mountains Inn', 9, '2019-10-21', 133, NULL),
('Cute Mountains Inn', 9, '2019-10-22', 296, NULL),
('Cute Mountains Inn', 9, '2019-10-23', 172, NULL),
('Cute Mountains Inn', 9, '2019-10-24', 135, NULL),
('Cute Mountains Inn', 9, '2019-10-25', 197, NULL),
('Cute Mountains Inn', 9, '2019-10-26', 165, NULL),
('Cute Mountains Inn', 9, '2019-10-27', 380, NULL),
('Cute Mountains Inn', 9, '2019-10-28', 129, NULL),
('Cute Mountains Inn', 9, '2019-10-29', 169, NULL),
('Cute Mountains Inn', 9, '2019-10-30', 332, NULL),
('Cute Mountains Inn', 9, '2019-10-31', 145, NULL),
('Cute Mountains Inn', 9, '2019-11-01', 236, NULL),
('Cute Mountains Inn', 9, '2019-11-02', 288, NULL),
('Cute Mountains Inn', 9, '2019-11-03', 229, NULL),
('Cute Mountains Inn', 9, '2019-11-04', 299, NULL),
('Cute Mountains Inn', 9, '2019-11-05', 232, NULL),
('Cute Mountains Inn', 9, '2019-11-06', 198, NULL),
('Cute Mountains Inn', 9, '2019-11-07', 104, NULL),
('Cute Mountains Inn', 9, '2019-11-08', 293, NULL),
('Cute Mountains Inn', 9, '2019-11-09', 267, NULL),
('Cute Mountains Inn', 9, '2019-11-10', 329, NULL),
('Cute Mountains Inn', 9, '2019-11-11', 102, NULL),
('Cute Mountains Inn', 9, '2019-11-12', 326, NULL),
('Cute Mountains Inn', 9, '2019-11-13', 154, NULL),
('Cute Mountains Inn', 9, '2019-11-14', 134, NULL),
('Cute Mountains Inn', 9, '2019-11-15', 259, NULL),
('Cute Mountains Inn', 9, '2019-11-16', 116, NULL),
('Cute Mountains Inn', 9, '2019-11-17', 392, NULL),
('Cute Mountains Inn', 9, '2019-11-18', 231, NULL),
('Cute Mountains Inn', 9, '2019-11-19', 275, NULL),
('Cute Mountains Inn', 9, '2019-11-20', 287, NULL),
('Cute Mountains Inn', 9, '2019-11-21', 192, NULL),
('Cute Mountains Inn', 9, '2019-11-22', 232, NULL),
('Cute Mountains Inn', 9, '2019-11-23', 196, NULL),
('Cute Mountains Inn', 9, '2019-11-24', 393, NULL),
('Cute Mountains Inn', 9, '2019-11-25', 361, NULL),
('Cute Mountains Inn', 9, '2019-11-26', 124, NULL),
('Cute Mountains Inn', 9, '2019-11-27', 371, NULL),
('Cute Mountains Inn', 9, '2019-11-28', 156, NULL),
('Cute Mountains Inn', 9, '2019-11-29', 310, NULL),
('Cute Mountains Inn', 9, '2019-11-30', 144, NULL),
('Cute Mountains Inn', 9, '2019-12-01', 390, 81),
('Cute Mountains Inn', 9, '2019-12-02', 102, 81),
('Cute Mountains Inn', 9, '2019-12-03', 350, 81),
('Cute Mountains Inn', 9, '2019-12-04', 234, 81),
('Cute Mountains Inn', 9, '2019-12-05', 101, 81),
('Cute Mountains Inn', 9, '2019-12-06', 320, 81),
('Cute Mountains Inn', 9, '2019-12-07', 179, 81),
('Cute Mountains Inn', 9, '2019-12-08', 359, 81),
('Cute Mountains Inn', 9, '2019-12-09', 112, 81),
('Cute Mountains Inn', 9, '2019-12-10', 352, 81),
('Cute Mountains Inn', 9, '2019-12-11', 252, 81),
('Cute Mountains Inn', 9, '2019-12-12', 197, 81),
('Cute Mountains Inn', 9, '2019-12-13', 186, 81),
('Cute Mountains Inn', 9, '2019-12-14', 142, 81),
('Cute Mountains Inn', 9, '2019-12-15', 154, 81),
('Cute Mountains Inn', 9, '2019-12-16', 261, 81),
('Cute Mountains Inn', 9, '2019-12-17', 250, 81),
('Cute Mountains Inn', 9, '2019-12-18', 362, 81),
('Cute Mountains Inn', 9, '2019-12-19', 342, 81),
('Cute Mountains Inn', 9, '2019-12-20', 147, NULL),
('Cute Mountains Inn', 9, '2019-12-21', 119, NULL),
('Cute Mountains Inn', 9, '2019-12-22', 289, NULL),
('Cute Mountains Inn', 9, '2019-12-23', 370, NULL),
('Cute Mountains Inn', 9, '2019-12-24', 273, NULL),
('Cute Mountains Inn', 9, '2019-12-25', 254, NULL),
('Cute Mountains Inn', 9, '2019-12-26', 304, NULL),
('Cute Mountains Inn', 9, '2019-12-27', 178, NULL),
('Cute Mountains Inn', 9, '2019-12-28', 370, NULL),
('Cute Mountains Inn', 9, '2019-12-29', 141, NULL),
('Cute Mountains Inn', 9, '2019-12-30', 392, NULL),
('Cute Mountains Inn', 9, '2019-12-31', 367, NULL),
('Cute Mountains Inn', 9, '2020-01-01', 391, NULL),
('Cute Mountains Inn', 9, '2020-01-02', 343, NULL),
('Cute Mountains Inn', 9, '2020-01-03', 388, NULL),
('Cute Mountains Inn', 9, '2020-01-04', 251, NULL),
('Cute Mountains Inn', 9, '2020-01-05', 272, NULL),
('Cute Mountains Inn', 9, '2020-01-06', 154, NULL),
('Cute Mountains Inn', 9, '2020-01-07', 306, NULL),
('Cute Mountains Inn', 9, '2020-01-08', 173, NULL),
('Cute Mountains Inn', 9, '2020-01-09', 295, NULL),
('Cute Mountains Inn', 9, '2020-01-10', 307, NULL),
('Cute Mountains Inn', 9, '2020-01-11', 332, NULL),
('Cute Mountains Inn', 9, '2020-01-12', 174, NULL),
('Cute Mountains Inn', 9, '2020-01-13', 167, NULL),
('Cute Mountains Inn', 9, '2020-01-14', 254, NULL),
('Cute Mountains Inn', 9, '2020-01-15', 364, NULL),
('Cute Mountains Inn', 9, '2020-01-16', 157, NULL),
('Cute Mountains Inn', 9, '2020-01-17', 392, 120),
('Cute Mountains Inn', 9, '2020-01-18', 116, 120),
('Cute Mountains Inn', 9, '2020-01-19', 306, 120),
('Cute Mountains Inn', 9, '2020-01-20', 202, 120),
('Cute Mountains Inn', 9, '2020-01-21', 277, 120),
('Cute Mountains Inn', 9, '2020-01-22', 333, 120),
('Cute Mountains Inn', 9, '2020-01-23', 274, 120),
('Cute Mountains Inn', 9, '2020-01-24', 122, 120),
('Cute Mountains Inn', 9, '2020-01-25', 182, 120),
('Cute Mountains Inn', 9, '2020-01-26', 202, 120),
('Cute Mountains Inn', 9, '2020-01-27', 249, 120),
('Cute Mountains Inn', 9, '2020-01-28', 159, 120),
('Cute Mountains Inn', 9, '2020-01-29', 254, 120),
('Cute Mountains Inn', 9, '2020-01-30', 147, 120),
('Cute Mountains Inn', 9, '2020-01-31', 388, 120),
('Cute Mountains Inn', 9, '2020-02-01', 324, 120),
('Cute Mountains Inn', 9, '2020-02-02', 254, 120),
('Cute Mountains Inn', 9, '2020-02-03', 269, NULL),
('Cute Mountains Inn', 9, '2020-02-04', 349, NULL),
('Cute Mountains Inn', 16, '2019-01-01', 216, NULL),
('Cute Mountains Inn', 16, '2019-01-02', 154, NULL),
('Cute Mountains Inn', 16, '2019-01-03', 345, NULL),
('Cute Mountains Inn', 16, '2019-01-04', 146, NULL),
('Cute Mountains Inn', 16, '2019-01-05', 355, NULL),
('Cute Mountains Inn', 16, '2019-01-06', 271, NULL),
('Cute Mountains Inn', 16, '2019-01-07', 397, NULL),
('Cute Mountains Inn', 16, '2019-01-08', 364, NULL),
('Cute Mountains Inn', 16, '2019-01-09', 153, NULL),
('Cute Mountains Inn', 16, '2019-01-10', 219, NULL),
('Cute Mountains Inn', 16, '2019-01-11', 179, NULL),
('Cute Mountains Inn', 16, '2019-01-12', 313, NULL),
('Cute Mountains Inn', 16, '2019-01-13', 120, NULL),
('Cute Mountains Inn', 16, '2019-01-14', 373, NULL),
('Cute Mountains Inn', 16, '2019-01-15', 100, NULL),
('Cute Mountains Inn', 16, '2019-01-16', 209, NULL),
('Cute Mountains Inn', 16, '2019-01-17', 255, NULL),
('Cute Mountains Inn', 16, '2019-01-18', 398, NULL),
('Cute Mountains Inn', 16, '2019-01-19', 193, NULL),
('Cute Mountains Inn', 16, '2019-01-20', 223, NULL),
('Cute Mountains Inn', 16, '2019-01-21', 184, NULL),
('Cute Mountains Inn', 16, '2019-01-22', 109, NULL),
('Cute Mountains Inn', 16, '2019-01-23', 385, NULL),
('Cute Mountains Inn', 16, '2019-01-24', 148, NULL),
('Cute Mountains Inn', 16, '2019-01-25', 368, NULL),
('Cute Mountains Inn', 16, '2019-01-26', 277, NULL),
('Cute Mountains Inn', 16, '2019-01-27', 119, NULL),
('Cute Mountains Inn', 16, '2019-01-28', 388, NULL),
('Cute Mountains Inn', 16, '2019-01-29', 355, NULL),
('Cute Mountains Inn', 16, '2019-01-30', 226, NULL),
('Cute Mountains Inn', 16, '2019-01-31', 152, NULL),
('Cute Mountains Inn', 16, '2019-02-01', 237, NULL),
('Cute Mountains Inn', 16, '2019-02-02', 363, NULL),
('Cute Mountains Inn', 16, '2019-02-03', 235, NULL),
('Cute Mountains Inn', 16, '2019-02-04', 392, NULL),
('Cute Mountains Inn', 16, '2019-02-05', 367, NULL),
('Cute Mountains Inn', 16, '2019-02-06', 292, NULL),
('Cute Mountains Inn', 16, '2019-02-07', 318, NULL),
('Cute Mountains Inn', 16, '2019-02-08', 264, NULL),
('Cute Mountains Inn', 16, '2019-02-09', 116, NULL),
('Cute Mountains Inn', 16, '2019-02-10', 122, NULL),
('Cute Mountains Inn', 16, '2019-02-11', 209, NULL),
('Cute Mountains Inn', 16, '2019-02-12', 182, NULL),
('Cute Mountains Inn', 16, '2019-02-13', 397, NULL),
('Cute Mountains Inn', 16, '2019-02-14', 228, NULL),
('Cute Mountains Inn', 16, '2019-02-15', 235, NULL),
('Cute Mountains Inn', 16, '2019-02-16', 229, NULL),
('Cute Mountains Inn', 16, '2019-02-17', 224, NULL),
('Cute Mountains Inn', 16, '2019-02-18', 302, NULL),
('Cute Mountains Inn', 16, '2019-02-19', 206, NULL),
('Cute Mountains Inn', 16, '2019-02-20', 222, NULL),
('Cute Mountains Inn', 16, '2019-02-21', 331, NULL),
('Cute Mountains Inn', 16, '2019-02-22', 242, NULL),
('Cute Mountains Inn', 16, '2019-02-23', 351, NULL),
('Cute Mountains Inn', 16, '2019-02-24', 361, NULL),
('Cute Mountains Inn', 16, '2019-02-25', 298, NULL),
('Cute Mountains Inn', 16, '2019-02-26', 183, NULL),
('Cute Mountains Inn', 16, '2019-02-27', 181, NULL),
('Cute Mountains Inn', 16, '2019-02-28', 276, NULL),
('Cute Mountains Inn', 16, '2019-03-01', 262, NULL),
('Cute Mountains Inn', 16, '2019-03-02', 243, NULL),
('Cute Mountains Inn', 16, '2019-03-03', 185, NULL),
('Cute Mountains Inn', 16, '2019-03-04', 356, NULL),
('Cute Mountains Inn', 16, '2019-03-05', 147, NULL),
('Cute Mountains Inn', 16, '2019-03-06', 369, NULL),
('Cute Mountains Inn', 16, '2019-03-07', 222, NULL),
('Cute Mountains Inn', 16, '2019-03-08', 236, NULL),
('Cute Mountains Inn', 16, '2019-03-09', 326, NULL),
('Cute Mountains Inn', 16, '2019-03-10', 192, NULL),
('Cute Mountains Inn', 16, '2019-03-11', 133, NULL),
('Cute Mountains Inn', 16, '2019-03-12', 142, NULL),
('Cute Mountains Inn', 16, '2019-03-13', 290, NULL),
('Cute Mountains Inn', 16, '2019-03-14', 145, NULL),
('Cute Mountains Inn', 16, '2019-03-15', 209, NULL),
('Cute Mountains Inn', 16, '2019-03-16', 121, NULL),
('Cute Mountains Inn', 16, '2019-03-17', 141, NULL),
('Cute Mountains Inn', 16, '2019-03-18', 116, NULL),
('Cute Mountains Inn', 16, '2019-03-19', 309, NULL),
('Cute Mountains Inn', 16, '2019-03-20', 350, NULL),
('Cute Mountains Inn', 16, '2019-03-21', 161, NULL),
('Cute Mountains Inn', 16, '2019-03-22', 227, NULL),
('Cute Mountains Inn', 16, '2019-03-23', 170, NULL),
('Cute Mountains Inn', 16, '2019-03-24', 160, NULL),
('Cute Mountains Inn', 16, '2019-03-25', 208, NULL),
('Cute Mountains Inn', 16, '2019-03-26', 169, NULL),
('Cute Mountains Inn', 16, '2019-03-27', 175, NULL),
('Cute Mountains Inn', 16, '2019-03-28', 391, NULL),
('Cute Mountains Inn', 16, '2019-03-29', 206, NULL),
('Cute Mountains Inn', 16, '2019-03-30', 352, NULL),
('Cute Mountains Inn', 16, '2019-03-31', 187, NULL),
('Cute Mountains Inn', 16, '2019-04-01', 295, NULL),
('Cute Mountains Inn', 16, '2019-04-02', 182, NULL),
('Cute Mountains Inn', 16, '2019-04-03', 330, NULL),
('Cute Mountains Inn', 16, '2019-04-04', 271, NULL),
('Cute Mountains Inn', 16, '2019-04-05', 180, NULL),
('Cute Mountains Inn', 16, '2019-04-06', 391, NULL),
('Cute Mountains Inn', 16, '2019-04-07', 313, NULL),
('Cute Mountains Inn', 16, '2019-04-08', 379, NULL),
('Cute Mountains Inn', 16, '2019-04-09', 157, 156),
('Cute Mountains Inn', 16, '2019-04-10', 281, 156),
('Cute Mountains Inn', 16, '2019-04-11', 231, 156),
('Cute Mountains Inn', 16, '2019-04-12', 216, 156),
('Cute Mountains Inn', 16, '2019-04-13', 329, 156),
('Cute Mountains Inn', 16, '2019-04-14', 208, 156),
('Cute Mountains Inn', 16, '2019-04-15', 302, 156),
('Cute Mountains Inn', 16, '2019-04-16', 254, 156),
('Cute Mountains Inn', 16, '2019-04-17', 220, 156),
('Cute Mountains Inn', 16, '2019-04-18', 253, 156),
('Cute Mountains Inn', 16, '2019-04-19', 289, 156),
('Cute Mountains Inn', 16, '2019-04-20', 165, 156),
('Cute Mountains Inn', 16, '2019-04-21', 131, 156),
('Cute Mountains Inn', 16, '2019-04-22', 180, 156),
('Cute Mountains Inn', 16, '2019-04-23', 126, NULL),
('Cute Mountains Inn', 16, '2019-04-24', 113, NULL),
('Cute Mountains Inn', 16, '2019-04-25', 332, NULL),
('Cute Mountains Inn', 16, '2019-04-26', 394, NULL),
('Cute Mountains Inn', 16, '2019-04-27', 103, NULL),
('Cute Mountains Inn', 16, '2019-04-28', 292, NULL),
('Cute Mountains Inn', 16, '2019-04-29', 236, NULL),
('Cute Mountains Inn', 16, '2019-04-30', 194, NULL),
('Cute Mountains Inn', 16, '2019-05-01', 333, NULL),
('Cute Mountains Inn', 16, '2019-05-02', 155, NULL),
('Cute Mountains Inn', 16, '2019-05-03', 381, NULL),
('Cute Mountains Inn', 16, '2019-05-04', 243, NULL),
('Cute Mountains Inn', 16, '2019-05-05', 237, NULL),
('Cute Mountains Inn', 16, '2019-05-06', 118, NULL),
('Cute Mountains Inn', 16, '2019-05-07', 105, NULL),
('Cute Mountains Inn', 16, '2019-05-08', 256, NULL),
('Cute Mountains Inn', 16, '2019-05-09', 168, NULL),
('Cute Mountains Inn', 16, '2019-05-10', 368, NULL),
('Cute Mountains Inn', 16, '2019-05-11', 232, NULL),
('Cute Mountains Inn', 16, '2019-05-12', 152, NULL),
('Cute Mountains Inn', 16, '2019-05-13', 366, NULL),
('Cute Mountains Inn', 16, '2019-05-14', 124, NULL),
('Cute Mountains Inn', 16, '2019-05-15', 116, NULL),
('Cute Mountains Inn', 16, '2019-05-16', 111, NULL),
('Cute Mountains Inn', 16, '2019-05-17', 194, NULL),
('Cute Mountains Inn', 16, '2019-05-18', 222, NULL),
('Cute Mountains Inn', 16, '2019-05-19', 229, NULL),
('Cute Mountains Inn', 16, '2019-05-20', 309, NULL),
('Cute Mountains Inn', 16, '2019-05-21', 344, NULL),
('Cute Mountains Inn', 16, '2019-05-22', 117, NULL),
('Cute Mountains Inn', 16, '2019-05-23', 253, NULL),
('Cute Mountains Inn', 16, '2019-05-24', 288, NULL),
('Cute Mountains Inn', 16, '2019-05-25', 161, NULL),
('Cute Mountains Inn', 16, '2019-05-26', 145, NULL),
('Cute Mountains Inn', 16, '2019-05-27', 182, NULL),
('Cute Mountains Inn', 16, '2019-05-28', 321, NULL),
('Cute Mountains Inn', 16, '2019-05-29', 308, NULL),
('Cute Mountains Inn', 16, '2019-05-30', 191, NULL),
('Cute Mountains Inn', 16, '2019-05-31', 237, NULL),
('Cute Mountains Inn', 16, '2019-06-01', 175, NULL),
('Cute Mountains Inn', 16, '2019-06-02', 303, NULL),
('Cute Mountains Inn', 16, '2019-06-03', 258, NULL),
('Cute Mountains Inn', 16, '2019-06-04', 134, NULL),
('Cute Mountains Inn', 16, '2019-06-05', 362, NULL),
('Cute Mountains Inn', 16, '2019-06-06', 227, NULL),
('Cute Mountains Inn', 16, '2019-06-07', 318, NULL),
('Cute Mountains Inn', 16, '2019-06-08', 317, NULL),
('Cute Mountains Inn', 16, '2019-06-09', 397, NULL),
('Cute Mountains Inn', 16, '2019-06-10', 127, NULL),
('Cute Mountains Inn', 16, '2019-06-11', 199, NULL),
('Cute Mountains Inn', 16, '2019-06-12', 357, NULL),
('Cute Mountains Inn', 16, '2019-06-13', 204, NULL),
('Cute Mountains Inn', 16, '2019-06-14', 186, NULL),
('Cute Mountains Inn', 16, '2019-06-15', 138, NULL),
('Cute Mountains Inn', 16, '2019-06-16', 377, NULL),
('Cute Mountains Inn', 16, '2019-06-17', 164, NULL),
('Cute Mountains Inn', 16, '2019-06-18', 358, NULL),
('Cute Mountains Inn', 16, '2019-06-19', 117, NULL),
('Cute Mountains Inn', 16, '2019-06-20', 155, NULL),
('Cute Mountains Inn', 16, '2019-06-21', 180, NULL),
('Cute Mountains Inn', 16, '2019-06-22', 207, NULL),
('Cute Mountains Inn', 16, '2019-06-23', 213, NULL),
('Cute Mountains Inn', 16, '2019-06-24', 356, NULL),
('Cute Mountains Inn', 16, '2019-06-25', 125, NULL),
('Cute Mountains Inn', 16, '2019-06-26', 347, NULL),
('Cute Mountains Inn', 16, '2019-06-27', 382, NULL),
('Cute Mountains Inn', 16, '2019-06-28', 294, NULL),
('Cute Mountains Inn', 16, '2019-06-29', 125, NULL),
('Cute Mountains Inn', 16, '2019-06-30', 238, NULL),
('Cute Mountains Inn', 16, '2019-07-01', 135, NULL),
('Cute Mountains Inn', 16, '2019-07-02', 274, NULL),
('Cute Mountains Inn', 16, '2019-07-03', 169, NULL),
('Cute Mountains Inn', 16, '2019-07-04', 323, NULL),
('Cute Mountains Inn', 16, '2019-07-05', 145, NULL),
('Cute Mountains Inn', 16, '2019-07-06', 138, NULL),
('Cute Mountains Inn', 16, '2019-07-07', 329, NULL),
('Cute Mountains Inn', 16, '2019-07-08', 324, NULL),
('Cute Mountains Inn', 16, '2019-07-09', 104, NULL),
('Cute Mountains Inn', 16, '2019-07-10', 379, NULL),
('Cute Mountains Inn', 16, '2019-07-11', 205, NULL),
('Cute Mountains Inn', 16, '2019-07-12', 193, NULL),
('Cute Mountains Inn', 16, '2019-07-13', 235, NULL),
('Cute Mountains Inn', 16, '2019-07-14', 159, NULL),
('Cute Mountains Inn', 16, '2019-07-15', 309, NULL),
('Cute Mountains Inn', 16, '2019-07-16', 313, NULL),
('Cute Mountains Inn', 16, '2019-07-17', 304, NULL),
('Cute Mountains Inn', 16, '2019-07-18', 136, NULL),
('Cute Mountains Inn', 16, '2019-07-19', 208, NULL),
('Cute Mountains Inn', 16, '2019-07-20', 108, NULL),
('Cute Mountains Inn', 16, '2019-07-21', 234, NULL),
('Cute Mountains Inn', 16, '2019-07-22', 289, NULL),
('Cute Mountains Inn', 16, '2019-07-23', 135, NULL),
('Cute Mountains Inn', 16, '2019-07-24', 314, NULL),
('Cute Mountains Inn', 16, '2019-07-25', 121, NULL),
('Cute Mountains Inn', 16, '2019-07-26', 310, NULL),
('Cute Mountains Inn', 16, '2019-07-27', 125, NULL),
('Cute Mountains Inn', 16, '2019-07-28', 297, NULL),
('Cute Mountains Inn', 16, '2019-07-29', 203, NULL),
('Cute Mountains Inn', 16, '2019-07-30', 123, NULL),
('Cute Mountains Inn', 16, '2019-07-31', 351, NULL),
('Cute Mountains Inn', 16, '2019-08-01', 309, NULL),
('Cute Mountains Inn', 16, '2019-08-02', 292, NULL),
('Cute Mountains Inn', 16, '2019-08-03', 240, NULL),
('Cute Mountains Inn', 16, '2019-08-04', 317, NULL),
('Cute Mountains Inn', 16, '2019-08-05', 111, NULL),
('Cute Mountains Inn', 16, '2019-08-06', 161, NULL),
('Cute Mountains Inn', 16, '2019-08-07', 214, NULL),
('Cute Mountains Inn', 16, '2019-08-08', 168, NULL),
('Cute Mountains Inn', 16, '2019-08-09', 289, NULL),
('Cute Mountains Inn', 16, '2019-08-10', 155, NULL),
('Cute Mountains Inn', 16, '2019-08-11', 231, NULL),
('Cute Mountains Inn', 16, '2019-08-12', 343, NULL),
('Cute Mountains Inn', 16, '2019-08-13', 247, NULL),
('Cute Mountains Inn', 16, '2019-08-14', 244, NULL),
('Cute Mountains Inn', 16, '2019-08-15', 194, NULL),
('Cute Mountains Inn', 16, '2019-08-16', 197, NULL),
('Cute Mountains Inn', 16, '2019-08-17', 154, NULL),
('Cute Mountains Inn', 16, '2019-08-18', 386, NULL),
('Cute Mountains Inn', 16, '2019-08-19', 199, NULL),
('Cute Mountains Inn', 16, '2019-08-20', 278, NULL),
('Cute Mountains Inn', 16, '2019-08-21', 109, NULL),
('Cute Mountains Inn', 16, '2019-08-22', 306, 161),
('Cute Mountains Inn', 16, '2019-08-23', 328, 161),
('Cute Mountains Inn', 16, '2019-08-24', 239, 161),
('Cute Mountains Inn', 16, '2019-08-25', 160, 161),
('Cute Mountains Inn', 16, '2019-08-26', 182, 161),
('Cute Mountains Inn', 16, '2019-08-27', 222, 161),
('Cute Mountains Inn', 16, '2019-08-28', 214, 161),
('Cute Mountains Inn', 16, '2019-08-29', 313, 161),
('Cute Mountains Inn', 16, '2019-08-30', 362, 161),
('Cute Mountains Inn', 16, '2019-08-31', 367, 161),
('Cute Mountains Inn', 16, '2019-09-01', 157, 161),
('Cute Mountains Inn', 16, '2019-09-02', 169, 161),
('Cute Mountains Inn', 16, '2019-09-03', 278, 161),
('Cute Mountains Inn', 16, '2019-09-04', 302, 161),
('Cute Mountains Inn', 16, '2019-09-05', 143, 161),
('Cute Mountains Inn', 16, '2019-09-06', 202, 161),
('Cute Mountains Inn', 16, '2019-09-07', 350, 161),
('Cute Mountains Inn', 16, '2019-09-08', 358, 161),
('Cute Mountains Inn', 16, '2019-09-09', 372, 161),
('Cute Mountains Inn', 16, '2019-09-10', 226, 161),
('Cute Mountains Inn', 16, '2019-09-11', 381, 161),
('Cute Mountains Inn', 16, '2019-09-12', 308, 161),
('Cute Mountains Inn', 16, '2019-09-13', 183, 161),
('Cute Mountains Inn', 16, '2019-09-14', 238, 161),
('Cute Mountains Inn', 16, '2019-09-15', 207, 161),
('Cute Mountains Inn', 16, '2019-09-16', 250, 161),
('Cute Mountains Inn', 16, '2019-09-17', 125, 161),
('Cute Mountains Inn', 16, '2019-09-18', 172, 161),
('Cute Mountains Inn', 16, '2019-09-19', 140, 161),
('Cute Mountains Inn', 16, '2019-09-20', 254, 161),
('Cute Mountains Inn', 16, '2019-09-21', 280, NULL),
('Cute Mountains Inn', 16, '2019-09-22', 152, NULL),
('Cute Mountains Inn', 16, '2019-09-23', 220, NULL),
('Cute Mountains Inn', 16, '2019-09-24', 110, NULL),
('Cute Mountains Inn', 16, '2019-09-25', 215, NULL),
('Cute Mountains Inn', 16, '2019-09-26', 346, NULL),
('Cute Mountains Inn', 16, '2019-09-27', 219, NULL),
('Cute Mountains Inn', 16, '2019-09-28', 247, NULL),
('Cute Mountains Inn', 16, '2019-09-29', 332, NULL),
('Cute Mountains Inn', 16, '2019-09-30', 110, NULL),
('Cute Mountains Inn', 16, '2019-10-01', 243, NULL),
('Cute Mountains Inn', 16, '2019-10-02', 194, NULL),
('Cute Mountains Inn', 16, '2019-10-03', 242, NULL),
('Cute Mountains Inn', 16, '2019-10-04', 256, NULL),
('Cute Mountains Inn', 16, '2019-10-05', 314, NULL),
('Cute Mountains Inn', 16, '2019-10-06', 184, NULL),
('Cute Mountains Inn', 16, '2019-10-07', 100, NULL),
('Cute Mountains Inn', 16, '2019-10-08', 389, NULL),
('Cute Mountains Inn', 16, '2019-10-09', 102, NULL),
('Cute Mountains Inn', 16, '2019-10-10', 386, NULL),
('Cute Mountains Inn', 16, '2019-10-11', 275, NULL),
('Cute Mountains Inn', 16, '2019-10-12', 290, NULL),
('Cute Mountains Inn', 16, '2019-10-13', 308, NULL),
('Cute Mountains Inn', 16, '2019-10-14', 397, NULL),
('Cute Mountains Inn', 16, '2019-10-15', 297, NULL),
('Cute Mountains Inn', 16, '2019-10-16', 278, NULL),
('Cute Mountains Inn', 16, '2019-10-17', 284, NULL),
('Cute Mountains Inn', 16, '2019-10-18', 292, NULL),
('Cute Mountains Inn', 16, '2019-10-19', 388, NULL),
('Cute Mountains Inn', 16, '2019-10-20', 398, NULL),
('Cute Mountains Inn', 16, '2019-10-21', 371, NULL),
('Cute Mountains Inn', 16, '2019-10-22', 387, NULL),
('Cute Mountains Inn', 16, '2019-10-23', 340, NULL),
('Cute Mountains Inn', 16, '2019-10-24', 198, NULL),
('Cute Mountains Inn', 16, '2019-10-25', 123, NULL),
('Cute Mountains Inn', 16, '2019-10-26', 387, NULL),
('Cute Mountains Inn', 16, '2019-10-27', 106, NULL),
('Cute Mountains Inn', 16, '2019-10-28', 138, NULL),
('Cute Mountains Inn', 16, '2019-10-29', 348, NULL),
('Cute Mountains Inn', 16, '2019-10-30', 334, NULL),
('Cute Mountains Inn', 16, '2019-10-31', 351, NULL),
('Cute Mountains Inn', 16, '2019-11-01', 275, NULL),
('Cute Mountains Inn', 16, '2019-11-02', 191, NULL),
('Cute Mountains Inn', 16, '2019-11-03', 230, NULL),
('Cute Mountains Inn', 16, '2019-11-04', 113, NULL),
('Cute Mountains Inn', 16, '2019-11-05', 242, NULL),
('Cute Mountains Inn', 16, '2019-11-06', 305, NULL),
('Cute Mountains Inn', 16, '2019-11-07', 232, NULL),
('Cute Mountains Inn', 16, '2019-11-08', 195, NULL),
('Cute Mountains Inn', 16, '2019-11-09', 277, NULL),
('Cute Mountains Inn', 16, '2019-11-10', 326, NULL),
('Cute Mountains Inn', 16, '2019-11-11', 252, NULL),
('Cute Mountains Inn', 16, '2019-11-12', 393, NULL),
('Cute Mountains Inn', 16, '2019-11-13', 162, NULL),
('Cute Mountains Inn', 16, '2019-11-14', 311, NULL),
('Cute Mountains Inn', 16, '2019-11-15', 324, 100),
('Cute Mountains Inn', 16, '2019-11-16', 386, 100),
('Cute Mountains Inn', 16, '2019-11-17', 203, 100),
('Cute Mountains Inn', 16, '2019-11-18', 198, 100),
('Cute Mountains Inn', 16, '2019-11-19', 237, 100),
('Cute Mountains Inn', 16, '2019-11-20', 194, 100),
('Cute Mountains Inn', 16, '2019-11-21', 259, 100),
('Cute Mountains Inn', 16, '2019-11-22', 334, 100),
('Cute Mountains Inn', 16, '2019-11-23', 240, 100),
('Cute Mountains Inn', 16, '2019-11-24', 211, 100),
('Cute Mountains Inn', 16, '2019-11-25', 329, 100),
('Cute Mountains Inn', 16, '2019-11-26', 189, 100),
('Cute Mountains Inn', 16, '2019-11-27', 218, 100),
('Cute Mountains Inn', 16, '2019-11-28', 377, 100),
('Cute Mountains Inn', 16, '2019-11-29', 188, 100),
('Cute Mountains Inn', 16, '2019-11-30', 293, 100),
('Cute Mountains Inn', 16, '2019-12-01', 294, 100),
('Cute Mountains Inn', 16, '2019-12-02', 357, 100),
('Cute Mountains Inn', 16, '2019-12-03', 265, 100),
('Cute Mountains Inn', 16, '2019-12-04', 394, 100),
('Cute Mountains Inn', 16, '2019-12-05', 302, 100),
('Cute Mountains Inn', 16, '2019-12-06', 121, 100),
('Cute Mountains Inn', 16, '2019-12-07', 376, 100),
('Cute Mountains Inn', 16, '2019-12-08', 310, 100),
('Cute Mountains Inn', 16, '2019-12-09', 342, 100),
('Cute Mountains Inn', 16, '2019-12-10', 305, 100),
('Cute Mountains Inn', 16, '2019-12-11', 122, NULL),
('Cute Mountains Inn', 16, '2019-12-12', 207, NULL),
('Cute Mountains Inn', 16, '2019-12-13', 129, NULL),
('Cute Mountains Inn', 16, '2019-12-14', 101, 93),
('Cute Mountains Inn', 16, '2019-12-15', 103, 93),
('Cute Mountains Inn', 16, '2019-12-16', 283, 93),
('Cute Mountains Inn', 16, '2019-12-17', 343, 93),
('Cute Mountains Inn', 16, '2019-12-18', 318, 93),
('Cute Mountains Inn', 16, '2019-12-19', 222, 93),
('Cute Mountains Inn', 16, '2019-12-20', 235, 93),
('Cute Mountains Inn', 16, '2019-12-21', 147, 93),
('Cute Mountains Inn', 16, '2019-12-22', 264, 93),
('Cute Mountains Inn', 16, '2019-12-23', 205, 93),
('Cute Mountains Inn', 16, '2019-12-24', 156, 93),
('Cute Mountains Inn', 16, '2019-12-25', 250, 93),
('Cute Mountains Inn', 16, '2019-12-26', 132, NULL),
('Cute Mountains Inn', 16, '2019-12-27', 362, NULL),
('Cute Mountains Inn', 16, '2019-12-28', 161, NULL),
('Cute Mountains Inn', 16, '2019-12-29', 173, NULL),
('Cute Mountains Inn', 16, '2019-12-30', 356, NULL),
('Cute Mountains Inn', 16, '2019-12-31', 297, NULL),
('Cute Mountains Inn', 16, '2020-01-01', 271, NULL),
('Cute Mountains Inn', 16, '2020-01-02', 313, NULL),
('Cute Mountains Inn', 16, '2020-01-03', 335, NULL),
('Cute Mountains Inn', 16, '2020-01-04', 377, NULL),
('Cute Mountains Inn', 16, '2020-01-05', 276, NULL),
('Cute Mountains Inn', 16, '2020-01-06', 350, NULL),
('Cute Mountains Inn', 16, '2020-01-07', 361, NULL),
('Cute Mountains Inn', 16, '2020-01-08', 324, NULL),
('Cute Mountains Inn', 16, '2020-01-09', 280, NULL),
('Cute Mountains Inn', 16, '2020-01-10', 202, NULL),
('Cute Mountains Inn', 16, '2020-01-11', 134, NULL),
('Cute Mountains Inn', 16, '2020-01-12', 219, NULL),
('Cute Mountains Inn', 16, '2020-01-13', 378, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 16, '2020-01-14', 118, NULL),
('Cute Mountains Inn', 16, '2020-01-15', 317, NULL),
('Cute Mountains Inn', 16, '2020-01-16', 100, NULL),
('Cute Mountains Inn', 16, '2020-01-17', 209, NULL),
('Cute Mountains Inn', 16, '2020-01-18', 389, NULL),
('Cute Mountains Inn', 16, '2020-01-19', 372, NULL),
('Cute Mountains Inn', 16, '2020-01-20', 288, NULL),
('Cute Mountains Inn', 16, '2020-01-21', 236, NULL),
('Cute Mountains Inn', 16, '2020-01-22', 370, NULL),
('Cute Mountains Inn', 16, '2020-01-23', 349, NULL),
('Cute Mountains Inn', 16, '2020-01-24', 120, NULL),
('Cute Mountains Inn', 16, '2020-01-25', 293, NULL),
('Cute Mountains Inn', 16, '2020-01-26', 172, NULL),
('Cute Mountains Inn', 16, '2020-01-27', 190, NULL),
('Cute Mountains Inn', 16, '2020-01-28', 270, NULL),
('Cute Mountains Inn', 16, '2020-01-29', 160, NULL),
('Cute Mountains Inn', 16, '2020-01-30', 170, NULL),
('Cute Mountains Inn', 16, '2020-01-31', 293, NULL),
('Cute Mountains Inn', 16, '2020-02-01', 216, NULL),
('Cute Mountains Inn', 16, '2020-02-02', 238, NULL),
('Cute Mountains Inn', 16, '2020-02-03', 278, NULL),
('Cute Mountains Inn', 16, '2020-02-04', 239, NULL),
('Cute Mountains Inn', 29, '2019-01-01', 266, NULL),
('Cute Mountains Inn', 29, '2019-01-02', 160, NULL),
('Cute Mountains Inn', 29, '2019-01-03', 359, NULL),
('Cute Mountains Inn', 29, '2019-01-04', 206, NULL),
('Cute Mountains Inn', 29, '2019-01-05', 233, NULL),
('Cute Mountains Inn', 29, '2019-01-06', 105, NULL),
('Cute Mountains Inn', 29, '2019-01-07', 280, NULL),
('Cute Mountains Inn', 29, '2019-01-08', 258, NULL),
('Cute Mountains Inn', 29, '2019-01-09', 225, NULL),
('Cute Mountains Inn', 29, '2019-01-10', 277, NULL),
('Cute Mountains Inn', 29, '2019-01-11', 104, NULL),
('Cute Mountains Inn', 29, '2019-01-12', 231, NULL),
('Cute Mountains Inn', 29, '2019-01-13', 181, NULL),
('Cute Mountains Inn', 29, '2019-01-14', 274, NULL),
('Cute Mountains Inn', 29, '2019-01-15', 100, NULL),
('Cute Mountains Inn', 29, '2019-01-16', 157, NULL),
('Cute Mountains Inn', 29, '2019-01-17', 254, NULL),
('Cute Mountains Inn', 29, '2019-01-18', 397, NULL),
('Cute Mountains Inn', 29, '2019-01-19', 204, NULL),
('Cute Mountains Inn', 29, '2019-01-20', 107, NULL),
('Cute Mountains Inn', 29, '2019-01-21', 150, NULL),
('Cute Mountains Inn', 29, '2019-01-22', 206, NULL),
('Cute Mountains Inn', 29, '2019-01-23', 244, NULL),
('Cute Mountains Inn', 29, '2019-01-24', 170, NULL),
('Cute Mountains Inn', 29, '2019-01-25', 284, NULL),
('Cute Mountains Inn', 29, '2019-01-26', 333, NULL),
('Cute Mountains Inn', 29, '2019-01-27', 252, NULL),
('Cute Mountains Inn', 29, '2019-01-28', 340, NULL),
('Cute Mountains Inn', 29, '2019-01-29', 314, NULL),
('Cute Mountains Inn', 29, '2019-01-30', 101, NULL),
('Cute Mountains Inn', 29, '2019-01-31', 334, NULL),
('Cute Mountains Inn', 29, '2019-02-01', 135, NULL),
('Cute Mountains Inn', 29, '2019-02-02', 390, NULL),
('Cute Mountains Inn', 29, '2019-02-03', 352, NULL),
('Cute Mountains Inn', 29, '2019-02-04', 258, NULL),
('Cute Mountains Inn', 29, '2019-02-05', 240, NULL),
('Cute Mountains Inn', 29, '2019-02-06', 107, NULL),
('Cute Mountains Inn', 29, '2019-02-07', 125, NULL),
('Cute Mountains Inn', 29, '2019-02-08', 240, NULL),
('Cute Mountains Inn', 29, '2019-02-09', 334, NULL),
('Cute Mountains Inn', 29, '2019-02-10', 155, NULL),
('Cute Mountains Inn', 29, '2019-02-11', 231, NULL),
('Cute Mountains Inn', 29, '2019-02-12', 248, NULL),
('Cute Mountains Inn', 29, '2019-02-13', 250, NULL),
('Cute Mountains Inn', 29, '2019-02-14', 226, NULL),
('Cute Mountains Inn', 29, '2019-02-15', 219, NULL),
('Cute Mountains Inn', 29, '2019-02-16', 320, NULL),
('Cute Mountains Inn', 29, '2019-02-17', 191, NULL),
('Cute Mountains Inn', 29, '2019-02-18', 188, NULL),
('Cute Mountains Inn', 29, '2019-02-19', 229, NULL),
('Cute Mountains Inn', 29, '2019-02-20', 161, NULL),
('Cute Mountains Inn', 29, '2019-02-21', 157, NULL),
('Cute Mountains Inn', 29, '2019-02-22', 344, NULL),
('Cute Mountains Inn', 29, '2019-02-23', 294, NULL),
('Cute Mountains Inn', 29, '2019-02-24', 145, NULL),
('Cute Mountains Inn', 29, '2019-02-25', 122, NULL),
('Cute Mountains Inn', 29, '2019-02-26', 260, NULL),
('Cute Mountains Inn', 29, '2019-02-27', 274, NULL),
('Cute Mountains Inn', 29, '2019-02-28', 379, NULL),
('Cute Mountains Inn', 29, '2019-03-01', 181, NULL),
('Cute Mountains Inn', 29, '2019-03-02', 172, NULL),
('Cute Mountains Inn', 29, '2019-03-03', 391, NULL),
('Cute Mountains Inn', 29, '2019-03-04', 298, NULL),
('Cute Mountains Inn', 29, '2019-03-05', 296, NULL),
('Cute Mountains Inn', 29, '2019-03-06', 369, NULL),
('Cute Mountains Inn', 29, '2019-03-07', 172, NULL),
('Cute Mountains Inn', 29, '2019-03-08', 105, NULL),
('Cute Mountains Inn', 29, '2019-03-09', 339, NULL),
('Cute Mountains Inn', 29, '2019-03-10', 271, NULL),
('Cute Mountains Inn', 29, '2019-03-11', 143, NULL),
('Cute Mountains Inn', 29, '2019-03-12', 248, NULL),
('Cute Mountains Inn', 29, '2019-03-13', 347, NULL),
('Cute Mountains Inn', 29, '2019-03-14', 369, NULL),
('Cute Mountains Inn', 29, '2019-03-15', 107, NULL),
('Cute Mountains Inn', 29, '2019-03-16', 382, NULL),
('Cute Mountains Inn', 29, '2019-03-17', 212, NULL),
('Cute Mountains Inn', 29, '2019-03-18', 164, NULL),
('Cute Mountains Inn', 29, '2019-03-19', 325, NULL),
('Cute Mountains Inn', 29, '2019-03-20', 256, NULL),
('Cute Mountains Inn', 29, '2019-03-21', 379, NULL),
('Cute Mountains Inn', 29, '2019-03-22', 228, NULL),
('Cute Mountains Inn', 29, '2019-03-23', 271, NULL),
('Cute Mountains Inn', 29, '2019-03-24', 261, NULL),
('Cute Mountains Inn', 29, '2019-03-25', 355, NULL),
('Cute Mountains Inn', 29, '2019-03-26', 225, NULL),
('Cute Mountains Inn', 29, '2019-03-27', 120, NULL),
('Cute Mountains Inn', 29, '2019-03-28', 340, NULL),
('Cute Mountains Inn', 29, '2019-03-29', 248, NULL),
('Cute Mountains Inn', 29, '2019-03-30', 364, NULL),
('Cute Mountains Inn', 29, '2019-03-31', 281, NULL),
('Cute Mountains Inn', 29, '2019-04-01', 127, NULL),
('Cute Mountains Inn', 29, '2019-04-02', 251, NULL),
('Cute Mountains Inn', 29, '2019-04-03', 197, NULL),
('Cute Mountains Inn', 29, '2019-04-04', 197, NULL),
('Cute Mountains Inn', 29, '2019-04-05', 375, NULL),
('Cute Mountains Inn', 29, '2019-04-06', 209, NULL),
('Cute Mountains Inn', 29, '2019-04-07', 361, NULL),
('Cute Mountains Inn', 29, '2019-04-08', 149, NULL),
('Cute Mountains Inn', 29, '2019-04-09', 345, NULL),
('Cute Mountains Inn', 29, '2019-04-10', 125, NULL),
('Cute Mountains Inn', 29, '2019-04-11', 307, NULL),
('Cute Mountains Inn', 29, '2019-04-12', 176, NULL),
('Cute Mountains Inn', 29, '2019-04-13', 114, NULL),
('Cute Mountains Inn', 29, '2019-04-14', 141, NULL),
('Cute Mountains Inn', 29, '2019-04-15', 343, NULL),
('Cute Mountains Inn', 29, '2019-04-16', 142, NULL),
('Cute Mountains Inn', 29, '2019-04-17', 356, NULL),
('Cute Mountains Inn', 29, '2019-04-18', 355, NULL),
('Cute Mountains Inn', 29, '2019-04-19', 251, NULL),
('Cute Mountains Inn', 29, '2019-04-20', 223, NULL),
('Cute Mountains Inn', 29, '2019-04-21', 104, NULL),
('Cute Mountains Inn', 29, '2019-04-22', 146, NULL),
('Cute Mountains Inn', 29, '2019-04-23', 302, NULL),
('Cute Mountains Inn', 29, '2019-04-24', 213, NULL),
('Cute Mountains Inn', 29, '2019-04-25', 399, NULL),
('Cute Mountains Inn', 29, '2019-04-26', 310, NULL),
('Cute Mountains Inn', 29, '2019-04-27', 324, NULL),
('Cute Mountains Inn', 29, '2019-04-28', 256, NULL),
('Cute Mountains Inn', 29, '2019-04-29', 203, NULL),
('Cute Mountains Inn', 29, '2019-04-30', 367, NULL),
('Cute Mountains Inn', 29, '2019-05-01', 172, NULL),
('Cute Mountains Inn', 29, '2019-05-02', 362, NULL),
('Cute Mountains Inn', 29, '2019-05-03', 379, NULL),
('Cute Mountains Inn', 29, '2019-05-04', 148, NULL),
('Cute Mountains Inn', 29, '2019-05-05', 183, NULL),
('Cute Mountains Inn', 29, '2019-05-06', 280, NULL),
('Cute Mountains Inn', 29, '2019-05-07', 110, NULL),
('Cute Mountains Inn', 29, '2019-05-08', 188, NULL),
('Cute Mountains Inn', 29, '2019-05-09', 321, NULL),
('Cute Mountains Inn', 29, '2019-05-10', 342, NULL),
('Cute Mountains Inn', 29, '2019-05-11', 250, NULL),
('Cute Mountains Inn', 29, '2019-05-12', 121, NULL),
('Cute Mountains Inn', 29, '2019-05-13', 115, NULL),
('Cute Mountains Inn', 29, '2019-05-14', 308, NULL),
('Cute Mountains Inn', 29, '2019-05-15', 261, NULL),
('Cute Mountains Inn', 29, '2019-05-16', 338, NULL),
('Cute Mountains Inn', 29, '2019-05-17', 340, NULL),
('Cute Mountains Inn', 29, '2019-05-18', 174, NULL),
('Cute Mountains Inn', 29, '2019-05-19', 220, NULL),
('Cute Mountains Inn', 29, '2019-05-20', 181, NULL),
('Cute Mountains Inn', 29, '2019-05-21', 367, NULL),
('Cute Mountains Inn', 29, '2019-05-22', 132, NULL),
('Cute Mountains Inn', 29, '2019-05-23', 183, NULL),
('Cute Mountains Inn', 29, '2019-05-24', 300, NULL),
('Cute Mountains Inn', 29, '2019-05-25', 387, NULL),
('Cute Mountains Inn', 29, '2019-05-26', 122, NULL),
('Cute Mountains Inn', 29, '2019-05-27', 325, NULL),
('Cute Mountains Inn', 29, '2019-05-28', 350, NULL),
('Cute Mountains Inn', 29, '2019-05-29', 163, NULL),
('Cute Mountains Inn', 29, '2019-05-30', 138, NULL),
('Cute Mountains Inn', 29, '2019-05-31', 250, NULL),
('Cute Mountains Inn', 29, '2019-06-01', 103, NULL),
('Cute Mountains Inn', 29, '2019-06-02', 196, NULL),
('Cute Mountains Inn', 29, '2019-06-03', 283, NULL),
('Cute Mountains Inn', 29, '2019-06-04', 356, NULL),
('Cute Mountains Inn', 29, '2019-06-05', 329, NULL),
('Cute Mountains Inn', 29, '2019-06-06', 360, NULL),
('Cute Mountains Inn', 29, '2019-06-07', 157, NULL),
('Cute Mountains Inn', 29, '2019-06-08', 209, NULL),
('Cute Mountains Inn', 29, '2019-06-09', 118, NULL),
('Cute Mountains Inn', 29, '2019-06-10', 387, NULL),
('Cute Mountains Inn', 29, '2019-06-11', 104, NULL),
('Cute Mountains Inn', 29, '2019-06-12', 234, NULL),
('Cute Mountains Inn', 29, '2019-06-13', 157, NULL),
('Cute Mountains Inn', 29, '2019-06-14', 320, NULL),
('Cute Mountains Inn', 29, '2019-06-15', 165, NULL),
('Cute Mountains Inn', 29, '2019-06-16', 205, NULL),
('Cute Mountains Inn', 29, '2019-06-17', 201, NULL),
('Cute Mountains Inn', 29, '2019-06-18', 331, NULL),
('Cute Mountains Inn', 29, '2019-06-19', 254, NULL),
('Cute Mountains Inn', 29, '2019-06-20', 196, NULL),
('Cute Mountains Inn', 29, '2019-06-21', 355, NULL),
('Cute Mountains Inn', 29, '2019-06-22', 195, NULL),
('Cute Mountains Inn', 29, '2019-06-23', 328, NULL),
('Cute Mountains Inn', 29, '2019-06-24', 148, NULL),
('Cute Mountains Inn', 29, '2019-06-25', 134, NULL),
('Cute Mountains Inn', 29, '2019-06-26', 131, NULL),
('Cute Mountains Inn', 29, '2019-06-27', 305, NULL),
('Cute Mountains Inn', 29, '2019-06-28', 140, NULL),
('Cute Mountains Inn', 29, '2019-06-29', 287, NULL),
('Cute Mountains Inn', 29, '2019-06-30', 298, NULL),
('Cute Mountains Inn', 29, '2019-07-01', 174, NULL),
('Cute Mountains Inn', 29, '2019-07-02', 231, NULL),
('Cute Mountains Inn', 29, '2019-07-03', 194, NULL),
('Cute Mountains Inn', 29, '2019-07-04', 385, NULL),
('Cute Mountains Inn', 29, '2019-07-05', 312, NULL),
('Cute Mountains Inn', 29, '2019-07-06', 288, NULL),
('Cute Mountains Inn', 29, '2019-07-07', 226, NULL),
('Cute Mountains Inn', 29, '2019-07-08', 287, NULL),
('Cute Mountains Inn', 29, '2019-07-09', 127, NULL),
('Cute Mountains Inn', 29, '2019-07-10', 247, NULL),
('Cute Mountains Inn', 29, '2019-07-11', 122, NULL),
('Cute Mountains Inn', 29, '2019-07-12', 383, NULL),
('Cute Mountains Inn', 29, '2019-07-13', 163, NULL),
('Cute Mountains Inn', 29, '2019-07-14', 382, NULL),
('Cute Mountains Inn', 29, '2019-07-15', 221, NULL),
('Cute Mountains Inn', 29, '2019-07-16', 196, NULL),
('Cute Mountains Inn', 29, '2019-07-17', 302, NULL),
('Cute Mountains Inn', 29, '2019-07-18', 144, NULL),
('Cute Mountains Inn', 29, '2019-07-19', 290, NULL),
('Cute Mountains Inn', 29, '2019-07-20', 104, NULL),
('Cute Mountains Inn', 29, '2019-07-21', 128, NULL),
('Cute Mountains Inn', 29, '2019-07-22', 353, NULL),
('Cute Mountains Inn', 29, '2019-07-23', 372, NULL),
('Cute Mountains Inn', 29, '2019-07-24', 227, NULL),
('Cute Mountains Inn', 29, '2019-07-25', 206, NULL),
('Cute Mountains Inn', 29, '2019-07-26', 281, NULL),
('Cute Mountains Inn', 29, '2019-07-27', 140, NULL),
('Cute Mountains Inn', 29, '2019-07-28', 328, NULL),
('Cute Mountains Inn', 29, '2019-07-29', 137, NULL),
('Cute Mountains Inn', 29, '2019-07-30', 185, NULL),
('Cute Mountains Inn', 29, '2019-07-31', 155, NULL),
('Cute Mountains Inn', 29, '2019-08-01', 382, NULL),
('Cute Mountains Inn', 29, '2019-08-02', 171, NULL),
('Cute Mountains Inn', 29, '2019-08-03', 108, NULL),
('Cute Mountains Inn', 29, '2019-08-04', 129, NULL),
('Cute Mountains Inn', 29, '2019-08-05', 150, NULL),
('Cute Mountains Inn', 29, '2019-08-06', 246, NULL),
('Cute Mountains Inn', 29, '2019-08-07', 176, NULL),
('Cute Mountains Inn', 29, '2019-08-08', 319, NULL),
('Cute Mountains Inn', 29, '2019-08-09', 287, NULL),
('Cute Mountains Inn', 29, '2019-08-10', 280, NULL),
('Cute Mountains Inn', 29, '2019-08-11', 254, NULL),
('Cute Mountains Inn', 29, '2019-08-12', 168, NULL),
('Cute Mountains Inn', 29, '2019-08-13', 183, NULL),
('Cute Mountains Inn', 29, '2019-08-14', 275, NULL),
('Cute Mountains Inn', 29, '2019-08-15', 305, NULL),
('Cute Mountains Inn', 29, '2019-08-16', 391, NULL),
('Cute Mountains Inn', 29, '2019-08-17', 236, NULL),
('Cute Mountains Inn', 29, '2019-08-18', 258, NULL),
('Cute Mountains Inn', 29, '2019-08-19', 276, NULL),
('Cute Mountains Inn', 29, '2019-08-20', 270, NULL),
('Cute Mountains Inn', 29, '2019-08-21', 111, NULL),
('Cute Mountains Inn', 29, '2019-08-22', 144, NULL),
('Cute Mountains Inn', 29, '2019-08-23', 353, NULL),
('Cute Mountains Inn', 29, '2019-08-24', 230, NULL),
('Cute Mountains Inn', 29, '2019-08-25', 243, NULL),
('Cute Mountains Inn', 29, '2019-08-26', 250, NULL),
('Cute Mountains Inn', 29, '2019-08-27', 201, NULL),
('Cute Mountains Inn', 29, '2019-08-28', 315, NULL),
('Cute Mountains Inn', 29, '2019-08-29', 139, NULL),
('Cute Mountains Inn', 29, '2019-08-30', 294, NULL),
('Cute Mountains Inn', 29, '2019-08-31', 181, NULL),
('Cute Mountains Inn', 29, '2019-09-01', 368, NULL),
('Cute Mountains Inn', 29, '2019-09-02', 268, NULL),
('Cute Mountains Inn', 29, '2019-09-03', 277, NULL),
('Cute Mountains Inn', 29, '2019-09-04', 192, NULL),
('Cute Mountains Inn', 29, '2019-09-05', 291, NULL),
('Cute Mountains Inn', 29, '2019-09-06', 244, NULL),
('Cute Mountains Inn', 29, '2019-09-07', 355, NULL),
('Cute Mountains Inn', 29, '2019-09-08', 200, NULL),
('Cute Mountains Inn', 29, '2019-09-09', 235, NULL),
('Cute Mountains Inn', 29, '2019-09-10', 175, NULL),
('Cute Mountains Inn', 29, '2019-09-11', 341, NULL),
('Cute Mountains Inn', 29, '2019-09-12', 320, NULL),
('Cute Mountains Inn', 29, '2019-09-13', 312, NULL),
('Cute Mountains Inn', 29, '2019-09-14', 354, NULL),
('Cute Mountains Inn', 29, '2019-09-15', 233, NULL),
('Cute Mountains Inn', 29, '2019-09-16', 264, NULL),
('Cute Mountains Inn', 29, '2019-09-17', 179, NULL),
('Cute Mountains Inn', 29, '2019-09-18', 391, NULL),
('Cute Mountains Inn', 29, '2019-09-19', 210, NULL),
('Cute Mountains Inn', 29, '2019-09-20', 111, NULL),
('Cute Mountains Inn', 29, '2019-09-21', 229, NULL),
('Cute Mountains Inn', 29, '2019-09-22', 270, NULL),
('Cute Mountains Inn', 29, '2019-09-23', 177, NULL),
('Cute Mountains Inn', 29, '2019-09-24', 314, NULL),
('Cute Mountains Inn', 29, '2019-09-25', 223, NULL),
('Cute Mountains Inn', 29, '2019-09-26', 113, NULL),
('Cute Mountains Inn', 29, '2019-09-27', 371, NULL),
('Cute Mountains Inn', 29, '2019-09-28', 292, NULL),
('Cute Mountains Inn', 29, '2019-09-29', 144, NULL),
('Cute Mountains Inn', 29, '2019-09-30', 337, NULL),
('Cute Mountains Inn', 29, '2019-10-01', 375, NULL),
('Cute Mountains Inn', 29, '2019-10-02', 332, NULL),
('Cute Mountains Inn', 29, '2019-10-03', 236, NULL),
('Cute Mountains Inn', 29, '2019-10-04', 342, NULL),
('Cute Mountains Inn', 29, '2019-10-05', 325, NULL),
('Cute Mountains Inn', 29, '2019-10-06', 240, NULL),
('Cute Mountains Inn', 29, '2019-10-07', 377, NULL),
('Cute Mountains Inn', 29, '2019-10-08', 152, NULL),
('Cute Mountains Inn', 29, '2019-10-09', 272, NULL),
('Cute Mountains Inn', 29, '2019-10-10', 214, NULL),
('Cute Mountains Inn', 29, '2019-10-11', 169, NULL),
('Cute Mountains Inn', 29, '2019-10-12', 199, NULL),
('Cute Mountains Inn', 29, '2019-10-13', 119, NULL),
('Cute Mountains Inn', 29, '2019-10-14', 248, NULL),
('Cute Mountains Inn', 29, '2019-10-15', 214, NULL),
('Cute Mountains Inn', 29, '2019-10-16', 312, NULL),
('Cute Mountains Inn', 29, '2019-10-17', 196, NULL),
('Cute Mountains Inn', 29, '2019-10-18', 304, NULL),
('Cute Mountains Inn', 29, '2019-10-19', 141, NULL),
('Cute Mountains Inn', 29, '2019-10-20', 223, NULL),
('Cute Mountains Inn', 29, '2019-10-21', 156, NULL),
('Cute Mountains Inn', 29, '2019-10-22', 345, NULL),
('Cute Mountains Inn', 29, '2019-10-23', 183, NULL),
('Cute Mountains Inn', 29, '2019-10-24', 186, NULL),
('Cute Mountains Inn', 29, '2019-10-25', 225, NULL),
('Cute Mountains Inn', 29, '2019-10-26', 140, NULL),
('Cute Mountains Inn', 29, '2019-10-27', 191, NULL),
('Cute Mountains Inn', 29, '2019-10-28', 202, NULL),
('Cute Mountains Inn', 29, '2019-10-29', 236, NULL),
('Cute Mountains Inn', 29, '2019-10-30', 275, NULL),
('Cute Mountains Inn', 29, '2019-10-31', 319, NULL),
('Cute Mountains Inn', 29, '2019-11-01', 268, NULL),
('Cute Mountains Inn', 29, '2019-11-02', 295, NULL),
('Cute Mountains Inn', 29, '2019-11-03', 361, NULL),
('Cute Mountains Inn', 29, '2019-11-04', 168, NULL),
('Cute Mountains Inn', 29, '2019-11-05', 113, NULL),
('Cute Mountains Inn', 29, '2019-11-06', 229, NULL),
('Cute Mountains Inn', 29, '2019-11-07', 147, NULL),
('Cute Mountains Inn', 29, '2019-11-08', 296, NULL),
('Cute Mountains Inn', 29, '2019-11-09', 185, NULL),
('Cute Mountains Inn', 29, '2019-11-10', 247, NULL),
('Cute Mountains Inn', 29, '2019-11-11', 256, NULL),
('Cute Mountains Inn', 29, '2019-11-12', 286, NULL),
('Cute Mountains Inn', 29, '2019-11-13', 248, NULL),
('Cute Mountains Inn', 29, '2019-11-14', 153, NULL),
('Cute Mountains Inn', 29, '2019-11-15', 143, NULL),
('Cute Mountains Inn', 29, '2019-11-16', 283, NULL),
('Cute Mountains Inn', 29, '2019-11-17', 339, NULL),
('Cute Mountains Inn', 29, '2019-11-18', 197, NULL),
('Cute Mountains Inn', 29, '2019-11-19', 259, NULL),
('Cute Mountains Inn', 29, '2019-11-20', 311, NULL),
('Cute Mountains Inn', 29, '2019-11-21', 317, NULL),
('Cute Mountains Inn', 29, '2019-11-22', 275, NULL),
('Cute Mountains Inn', 29, '2019-11-23', 214, NULL),
('Cute Mountains Inn', 29, '2019-11-24', 379, NULL),
('Cute Mountains Inn', 29, '2019-11-25', 163, NULL),
('Cute Mountains Inn', 29, '2019-11-26', 171, NULL),
('Cute Mountains Inn', 29, '2019-11-27', 178, NULL),
('Cute Mountains Inn', 29, '2019-11-28', 117, NULL),
('Cute Mountains Inn', 29, '2019-11-29', 212, NULL),
('Cute Mountains Inn', 29, '2019-11-30', 334, NULL),
('Cute Mountains Inn', 29, '2019-12-01', 198, NULL),
('Cute Mountains Inn', 29, '2019-12-02', 176, NULL),
('Cute Mountains Inn', 29, '2019-12-03', 177, NULL),
('Cute Mountains Inn', 29, '2019-12-04', 269, NULL),
('Cute Mountains Inn', 29, '2019-12-05', 205, NULL),
('Cute Mountains Inn', 29, '2019-12-06', 144, NULL),
('Cute Mountains Inn', 29, '2019-12-07', 341, NULL),
('Cute Mountains Inn', 29, '2019-12-08', 372, NULL),
('Cute Mountains Inn', 29, '2019-12-09', 376, NULL),
('Cute Mountains Inn', 29, '2019-12-10', 370, NULL),
('Cute Mountains Inn', 29, '2019-12-11', 357, NULL),
('Cute Mountains Inn', 29, '2019-12-12', 345, NULL),
('Cute Mountains Inn', 29, '2019-12-13', 286, NULL),
('Cute Mountains Inn', 29, '2019-12-14', 278, NULL),
('Cute Mountains Inn', 29, '2019-12-15', 251, NULL),
('Cute Mountains Inn', 29, '2019-12-16', 235, NULL),
('Cute Mountains Inn', 29, '2019-12-17', 266, NULL),
('Cute Mountains Inn', 29, '2019-12-18', 107, NULL),
('Cute Mountains Inn', 29, '2019-12-19', 284, NULL),
('Cute Mountains Inn', 29, '2019-12-20', 337, NULL),
('Cute Mountains Inn', 29, '2019-12-21', 278, NULL),
('Cute Mountains Inn', 29, '2019-12-22', 355, NULL),
('Cute Mountains Inn', 29, '2019-12-23', 116, NULL),
('Cute Mountains Inn', 29, '2019-12-24', 165, NULL),
('Cute Mountains Inn', 29, '2019-12-25', 392, NULL),
('Cute Mountains Inn', 29, '2019-12-26', 246, NULL),
('Cute Mountains Inn', 29, '2019-12-27', 276, NULL),
('Cute Mountains Inn', 29, '2019-12-28', 197, NULL),
('Cute Mountains Inn', 29, '2019-12-29', 341, NULL),
('Cute Mountains Inn', 29, '2019-12-30', 207, NULL),
('Cute Mountains Inn', 29, '2019-12-31', 286, NULL),
('Cute Mountains Inn', 29, '2020-01-01', 382, NULL),
('Cute Mountains Inn', 29, '2020-01-02', 136, NULL),
('Cute Mountains Inn', 29, '2020-01-03', 115, NULL),
('Cute Mountains Inn', 29, '2020-01-04', 133, NULL),
('Cute Mountains Inn', 29, '2020-01-05', 166, NULL),
('Cute Mountains Inn', 29, '2020-01-06', 290, NULL),
('Cute Mountains Inn', 29, '2020-01-07', 187, NULL),
('Cute Mountains Inn', 29, '2020-01-08', 105, NULL),
('Cute Mountains Inn', 29, '2020-01-09', 114, NULL),
('Cute Mountains Inn', 29, '2020-01-10', 289, NULL),
('Cute Mountains Inn', 29, '2020-01-11', 175, NULL),
('Cute Mountains Inn', 29, '2020-01-12', 173, NULL),
('Cute Mountains Inn', 29, '2020-01-13', 388, NULL),
('Cute Mountains Inn', 29, '2020-01-14', 331, NULL),
('Cute Mountains Inn', 29, '2020-01-15', 391, NULL),
('Cute Mountains Inn', 29, '2020-01-16', 229, NULL),
('Cute Mountains Inn', 29, '2020-01-17', 369, NULL),
('Cute Mountains Inn', 29, '2020-01-18', 296, NULL),
('Cute Mountains Inn', 29, '2020-01-19', 243, NULL),
('Cute Mountains Inn', 29, '2020-01-20', 133, NULL),
('Cute Mountains Inn', 29, '2020-01-21', 248, NULL),
('Cute Mountains Inn', 29, '2020-01-22', 150, NULL),
('Cute Mountains Inn', 29, '2020-01-23', 221, NULL),
('Cute Mountains Inn', 29, '2020-01-24', 132, NULL),
('Cute Mountains Inn', 29, '2020-01-25', 219, NULL),
('Cute Mountains Inn', 29, '2020-01-26', 156, NULL),
('Cute Mountains Inn', 29, '2020-01-27', 101, NULL),
('Cute Mountains Inn', 29, '2020-01-28', 175, NULL),
('Cute Mountains Inn', 29, '2020-01-29', 240, NULL),
('Cute Mountains Inn', 29, '2020-01-30', 310, NULL),
('Cute Mountains Inn', 29, '2020-01-31', 202, NULL),
('Cute Mountains Inn', 29, '2020-02-01', 310, NULL),
('Cute Mountains Inn', 29, '2020-02-02', 330, NULL),
('Cute Mountains Inn', 29, '2020-02-03', 184, NULL),
('Cute Mountains Inn', 29, '2020-02-04', 346, NULL),
('Cute Mountains Inn', 40, '2019-01-01', 280, NULL),
('Cute Mountains Inn', 40, '2019-01-02', 238, NULL),
('Cute Mountains Inn', 40, '2019-01-03', 360, NULL),
('Cute Mountains Inn', 40, '2019-01-04', 189, NULL),
('Cute Mountains Inn', 40, '2019-01-05', 299, NULL),
('Cute Mountains Inn', 40, '2019-01-06', 212, NULL),
('Cute Mountains Inn', 40, '2019-01-07', 108, NULL),
('Cute Mountains Inn', 40, '2019-01-08', 397, NULL),
('Cute Mountains Inn', 40, '2019-01-09', 264, NULL),
('Cute Mountains Inn', 40, '2019-01-10', 327, NULL),
('Cute Mountains Inn', 40, '2019-01-11', 183, NULL),
('Cute Mountains Inn', 40, '2019-01-12', 116, NULL),
('Cute Mountains Inn', 40, '2019-01-13', 148, NULL),
('Cute Mountains Inn', 40, '2019-01-14', 150, NULL),
('Cute Mountains Inn', 40, '2019-01-15', 103, NULL),
('Cute Mountains Inn', 40, '2019-01-16', 360, NULL),
('Cute Mountains Inn', 40, '2019-01-17', 102, NULL),
('Cute Mountains Inn', 40, '2019-01-18', 389, NULL),
('Cute Mountains Inn', 40, '2019-01-19', 339, NULL),
('Cute Mountains Inn', 40, '2019-01-20', 367, NULL),
('Cute Mountains Inn', 40, '2019-01-21', 399, NULL),
('Cute Mountains Inn', 40, '2019-01-22', 303, NULL),
('Cute Mountains Inn', 40, '2019-01-23', 267, NULL),
('Cute Mountains Inn', 40, '2019-01-24', 307, NULL),
('Cute Mountains Inn', 40, '2019-01-25', 219, NULL),
('Cute Mountains Inn', 40, '2019-01-26', 131, NULL),
('Cute Mountains Inn', 40, '2019-01-27', 202, NULL),
('Cute Mountains Inn', 40, '2019-01-28', 136, NULL),
('Cute Mountains Inn', 40, '2019-01-29', 104, NULL),
('Cute Mountains Inn', 40, '2019-01-30', 327, NULL),
('Cute Mountains Inn', 40, '2019-01-31', 215, NULL),
('Cute Mountains Inn', 40, '2019-02-01', 167, NULL),
('Cute Mountains Inn', 40, '2019-02-02', 161, NULL),
('Cute Mountains Inn', 40, '2019-02-03', 356, NULL),
('Cute Mountains Inn', 40, '2019-02-04', 314, NULL),
('Cute Mountains Inn', 40, '2019-02-05', 298, NULL),
('Cute Mountains Inn', 40, '2019-02-06', 159, NULL),
('Cute Mountains Inn', 40, '2019-02-07', 169, NULL),
('Cute Mountains Inn', 40, '2019-02-08', 310, NULL),
('Cute Mountains Inn', 40, '2019-02-09', 321, NULL),
('Cute Mountains Inn', 40, '2019-02-10', 310, NULL),
('Cute Mountains Inn', 40, '2019-02-11', 130, NULL),
('Cute Mountains Inn', 40, '2019-02-12', 295, NULL),
('Cute Mountains Inn', 40, '2019-02-13', 260, NULL),
('Cute Mountains Inn', 40, '2019-02-14', 345, NULL),
('Cute Mountains Inn', 40, '2019-02-15', 289, NULL),
('Cute Mountains Inn', 40, '2019-02-16', 216, NULL),
('Cute Mountains Inn', 40, '2019-02-17', 183, NULL),
('Cute Mountains Inn', 40, '2019-02-18', 232, NULL),
('Cute Mountains Inn', 40, '2019-02-19', 128, NULL),
('Cute Mountains Inn', 40, '2019-02-20', 340, NULL),
('Cute Mountains Inn', 40, '2019-02-21', 293, NULL),
('Cute Mountains Inn', 40, '2019-02-22', 296, NULL),
('Cute Mountains Inn', 40, '2019-02-23', 317, NULL),
('Cute Mountains Inn', 40, '2019-02-24', 141, NULL),
('Cute Mountains Inn', 40, '2019-02-25', 216, NULL),
('Cute Mountains Inn', 40, '2019-02-26', 353, NULL),
('Cute Mountains Inn', 40, '2019-02-27', 127, NULL),
('Cute Mountains Inn', 40, '2019-02-28', 366, NULL),
('Cute Mountains Inn', 40, '2019-03-01', 319, NULL),
('Cute Mountains Inn', 40, '2019-03-02', 334, NULL),
('Cute Mountains Inn', 40, '2019-03-03', 104, NULL),
('Cute Mountains Inn', 40, '2019-03-04', 324, NULL),
('Cute Mountains Inn', 40, '2019-03-05', 338, NULL),
('Cute Mountains Inn', 40, '2019-03-06', 337, NULL),
('Cute Mountains Inn', 40, '2019-03-07', 394, NULL),
('Cute Mountains Inn', 40, '2019-03-08', 317, NULL),
('Cute Mountains Inn', 40, '2019-03-09', 321, NULL),
('Cute Mountains Inn', 40, '2019-03-10', 379, NULL),
('Cute Mountains Inn', 40, '2019-03-11', 216, NULL),
('Cute Mountains Inn', 40, '2019-03-12', 113, NULL),
('Cute Mountains Inn', 40, '2019-03-13', 165, NULL),
('Cute Mountains Inn', 40, '2019-03-14', 113, NULL),
('Cute Mountains Inn', 40, '2019-03-15', 109, NULL),
('Cute Mountains Inn', 40, '2019-03-16', 248, NULL),
('Cute Mountains Inn', 40, '2019-03-17', 235, NULL),
('Cute Mountains Inn', 40, '2019-03-18', 370, NULL),
('Cute Mountains Inn', 40, '2019-03-19', 300, NULL),
('Cute Mountains Inn', 40, '2019-03-20', 133, NULL),
('Cute Mountains Inn', 40, '2019-03-21', 111, NULL),
('Cute Mountains Inn', 40, '2019-03-22', 360, NULL),
('Cute Mountains Inn', 40, '2019-03-23', 148, NULL),
('Cute Mountains Inn', 40, '2019-03-24', 125, NULL),
('Cute Mountains Inn', 40, '2019-03-25', 153, NULL),
('Cute Mountains Inn', 40, '2019-03-26', 218, NULL),
('Cute Mountains Inn', 40, '2019-03-27', 276, NULL),
('Cute Mountains Inn', 40, '2019-03-28', 127, NULL),
('Cute Mountains Inn', 40, '2019-03-29', 223, NULL),
('Cute Mountains Inn', 40, '2019-03-30', 363, NULL),
('Cute Mountains Inn', 40, '2019-03-31', 144, NULL),
('Cute Mountains Inn', 40, '2019-04-01', 247, NULL),
('Cute Mountains Inn', 40, '2019-04-02', 312, NULL),
('Cute Mountains Inn', 40, '2019-04-03', 193, NULL),
('Cute Mountains Inn', 40, '2019-04-04', 375, NULL),
('Cute Mountains Inn', 40, '2019-04-05', 335, NULL),
('Cute Mountains Inn', 40, '2019-04-06', 374, NULL),
('Cute Mountains Inn', 40, '2019-04-07', 169, NULL),
('Cute Mountains Inn', 40, '2019-04-08', 110, NULL),
('Cute Mountains Inn', 40, '2019-04-09', 255, NULL),
('Cute Mountains Inn', 40, '2019-04-10', 283, NULL),
('Cute Mountains Inn', 40, '2019-04-11', 140, NULL),
('Cute Mountains Inn', 40, '2019-04-12', 129, NULL),
('Cute Mountains Inn', 40, '2019-04-13', 384, NULL),
('Cute Mountains Inn', 40, '2019-04-14', 284, NULL),
('Cute Mountains Inn', 40, '2019-04-15', 107, NULL),
('Cute Mountains Inn', 40, '2019-04-16', 149, NULL),
('Cute Mountains Inn', 40, '2019-04-17', 120, NULL),
('Cute Mountains Inn', 40, '2019-04-18', 316, NULL),
('Cute Mountains Inn', 40, '2019-04-19', 288, NULL),
('Cute Mountains Inn', 40, '2019-04-20', 219, NULL),
('Cute Mountains Inn', 40, '2019-04-21', 328, NULL),
('Cute Mountains Inn', 40, '2019-04-22', 390, NULL),
('Cute Mountains Inn', 40, '2019-04-23', 131, NULL),
('Cute Mountains Inn', 40, '2019-04-24', 326, NULL),
('Cute Mountains Inn', 40, '2019-04-25', 299, NULL),
('Cute Mountains Inn', 40, '2019-04-26', 268, NULL),
('Cute Mountains Inn', 40, '2019-04-27', 310, NULL),
('Cute Mountains Inn', 40, '2019-04-28', 302, NULL),
('Cute Mountains Inn', 40, '2019-04-29', 207, NULL),
('Cute Mountains Inn', 40, '2019-04-30', 254, NULL),
('Cute Mountains Inn', 40, '2019-05-01', 362, NULL),
('Cute Mountains Inn', 40, '2019-05-02', 349, NULL),
('Cute Mountains Inn', 40, '2019-05-03', 354, NULL),
('Cute Mountains Inn', 40, '2019-05-04', 211, NULL),
('Cute Mountains Inn', 40, '2019-05-05', 105, NULL),
('Cute Mountains Inn', 40, '2019-05-06', 348, NULL),
('Cute Mountains Inn', 40, '2019-05-07', 134, NULL),
('Cute Mountains Inn', 40, '2019-05-08', 373, NULL),
('Cute Mountains Inn', 40, '2019-05-09', 102, NULL),
('Cute Mountains Inn', 40, '2019-05-10', 206, NULL),
('Cute Mountains Inn', 40, '2019-05-11', 155, NULL),
('Cute Mountains Inn', 40, '2019-05-12', 351, NULL),
('Cute Mountains Inn', 40, '2019-05-13', 279, NULL),
('Cute Mountains Inn', 40, '2019-05-14', 171, NULL),
('Cute Mountains Inn', 40, '2019-05-15', 257, NULL),
('Cute Mountains Inn', 40, '2019-05-16', 357, NULL),
('Cute Mountains Inn', 40, '2019-05-17', 119, NULL),
('Cute Mountains Inn', 40, '2019-05-18', 107, NULL),
('Cute Mountains Inn', 40, '2019-05-19', 311, NULL),
('Cute Mountains Inn', 40, '2019-05-20', 181, NULL),
('Cute Mountains Inn', 40, '2019-05-21', 103, NULL),
('Cute Mountains Inn', 40, '2019-05-22', 210, NULL),
('Cute Mountains Inn', 40, '2019-05-23', 356, NULL),
('Cute Mountains Inn', 40, '2019-05-24', 236, NULL),
('Cute Mountains Inn', 40, '2019-05-25', 151, NULL),
('Cute Mountains Inn', 40, '2019-05-26', 374, NULL),
('Cute Mountains Inn', 40, '2019-05-27', 379, NULL),
('Cute Mountains Inn', 40, '2019-05-28', 385, NULL),
('Cute Mountains Inn', 40, '2019-05-29', 393, NULL),
('Cute Mountains Inn', 40, '2019-05-30', 318, NULL),
('Cute Mountains Inn', 40, '2019-05-31', 137, NULL),
('Cute Mountains Inn', 40, '2019-06-01', 188, NULL),
('Cute Mountains Inn', 40, '2019-06-02', 273, NULL),
('Cute Mountains Inn', 40, '2019-06-03', 242, NULL),
('Cute Mountains Inn', 40, '2019-06-04', 379, NULL),
('Cute Mountains Inn', 40, '2019-06-05', 160, NULL),
('Cute Mountains Inn', 40, '2019-06-06', 119, NULL),
('Cute Mountains Inn', 40, '2019-06-07', 333, NULL),
('Cute Mountains Inn', 40, '2019-06-08', 297, NULL),
('Cute Mountains Inn', 40, '2019-06-09', 201, NULL),
('Cute Mountains Inn', 40, '2019-06-10', 257, NULL),
('Cute Mountains Inn', 40, '2019-06-11', 124, NULL),
('Cute Mountains Inn', 40, '2019-06-12', 297, NULL),
('Cute Mountains Inn', 40, '2019-06-13', 372, NULL),
('Cute Mountains Inn', 40, '2019-06-14', 341, NULL),
('Cute Mountains Inn', 40, '2019-06-15', 313, NULL),
('Cute Mountains Inn', 40, '2019-06-16', 391, NULL),
('Cute Mountains Inn', 40, '2019-06-17', 112, NULL),
('Cute Mountains Inn', 40, '2019-06-18', 183, NULL),
('Cute Mountains Inn', 40, '2019-06-19', 221, NULL),
('Cute Mountains Inn', 40, '2019-06-20', 118, NULL),
('Cute Mountains Inn', 40, '2019-06-21', 235, NULL),
('Cute Mountains Inn', 40, '2019-06-22', 255, NULL),
('Cute Mountains Inn', 40, '2019-06-23', 303, NULL),
('Cute Mountains Inn', 40, '2019-06-24', 174, NULL),
('Cute Mountains Inn', 40, '2019-06-25', 196, NULL),
('Cute Mountains Inn', 40, '2019-06-26', 113, NULL),
('Cute Mountains Inn', 40, '2019-06-27', 278, NULL),
('Cute Mountains Inn', 40, '2019-06-28', 316, NULL),
('Cute Mountains Inn', 40, '2019-06-29', 363, NULL),
('Cute Mountains Inn', 40, '2019-06-30', 376, NULL),
('Cute Mountains Inn', 40, '2019-07-01', 364, NULL),
('Cute Mountains Inn', 40, '2019-07-02', 233, NULL),
('Cute Mountains Inn', 40, '2019-07-03', 363, NULL),
('Cute Mountains Inn', 40, '2019-07-04', 256, NULL),
('Cute Mountains Inn', 40, '2019-07-05', 126, NULL),
('Cute Mountains Inn', 40, '2019-07-06', 326, NULL),
('Cute Mountains Inn', 40, '2019-07-07', 345, NULL),
('Cute Mountains Inn', 40, '2019-07-08', 360, NULL),
('Cute Mountains Inn', 40, '2019-07-09', 225, NULL),
('Cute Mountains Inn', 40, '2019-07-10', 298, NULL),
('Cute Mountains Inn', 40, '2019-07-11', 198, NULL),
('Cute Mountains Inn', 40, '2019-07-12', 337, NULL),
('Cute Mountains Inn', 40, '2019-07-13', 309, NULL),
('Cute Mountains Inn', 40, '2019-07-14', 135, NULL),
('Cute Mountains Inn', 40, '2019-07-15', 376, NULL),
('Cute Mountains Inn', 40, '2019-07-16', 242, NULL),
('Cute Mountains Inn', 40, '2019-07-17', 197, NULL),
('Cute Mountains Inn', 40, '2019-07-18', 214, NULL),
('Cute Mountains Inn', 40, '2019-07-19', 124, NULL),
('Cute Mountains Inn', 40, '2019-07-20', 395, NULL),
('Cute Mountains Inn', 40, '2019-07-21', 141, NULL),
('Cute Mountains Inn', 40, '2019-07-22', 201, NULL),
('Cute Mountains Inn', 40, '2019-07-23', 155, NULL),
('Cute Mountains Inn', 40, '2019-07-24', 392, NULL),
('Cute Mountains Inn', 40, '2019-07-25', 268, NULL),
('Cute Mountains Inn', 40, '2019-07-26', 374, NULL),
('Cute Mountains Inn', 40, '2019-07-27', 228, NULL),
('Cute Mountains Inn', 40, '2019-07-28', 348, NULL),
('Cute Mountains Inn', 40, '2019-07-29', 275, NULL),
('Cute Mountains Inn', 40, '2019-07-30', 157, NULL),
('Cute Mountains Inn', 40, '2019-07-31', 220, NULL),
('Cute Mountains Inn', 40, '2019-08-01', 285, NULL),
('Cute Mountains Inn', 40, '2019-08-02', 177, NULL),
('Cute Mountains Inn', 40, '2019-08-03', 320, NULL),
('Cute Mountains Inn', 40, '2019-08-04', 193, NULL),
('Cute Mountains Inn', 40, '2019-08-05', 317, NULL),
('Cute Mountains Inn', 40, '2019-08-06', 345, NULL),
('Cute Mountains Inn', 40, '2019-08-07', 137, NULL),
('Cute Mountains Inn', 40, '2019-08-08', 388, NULL),
('Cute Mountains Inn', 40, '2019-08-09', 167, NULL),
('Cute Mountains Inn', 40, '2019-08-10', 237, NULL),
('Cute Mountains Inn', 40, '2019-08-11', 179, NULL),
('Cute Mountains Inn', 40, '2019-08-12', 310, NULL),
('Cute Mountains Inn', 40, '2019-08-13', 375, NULL),
('Cute Mountains Inn', 40, '2019-08-14', 247, NULL),
('Cute Mountains Inn', 40, '2019-08-15', 244, NULL),
('Cute Mountains Inn', 40, '2019-08-16', 365, NULL),
('Cute Mountains Inn', 40, '2019-08-17', 318, NULL),
('Cute Mountains Inn', 40, '2019-08-18', 333, NULL),
('Cute Mountains Inn', 40, '2019-08-19', 383, NULL),
('Cute Mountains Inn', 40, '2019-08-20', 115, NULL),
('Cute Mountains Inn', 40, '2019-08-21', 126, NULL),
('Cute Mountains Inn', 40, '2019-08-22', 303, NULL),
('Cute Mountains Inn', 40, '2019-08-23', 383, NULL),
('Cute Mountains Inn', 40, '2019-08-24', 334, NULL),
('Cute Mountains Inn', 40, '2019-08-25', 333, NULL),
('Cute Mountains Inn', 40, '2019-08-26', 305, NULL),
('Cute Mountains Inn', 40, '2019-08-27', 240, NULL),
('Cute Mountains Inn', 40, '2019-08-28', 233, NULL),
('Cute Mountains Inn', 40, '2019-08-29', 259, NULL),
('Cute Mountains Inn', 40, '2019-08-30', 283, NULL),
('Cute Mountains Inn', 40, '2019-08-31', 306, NULL),
('Cute Mountains Inn', 40, '2019-09-01', 371, NULL),
('Cute Mountains Inn', 40, '2019-09-02', 133, NULL),
('Cute Mountains Inn', 40, '2019-09-03', 155, NULL),
('Cute Mountains Inn', 40, '2019-09-04', 254, NULL),
('Cute Mountains Inn', 40, '2019-09-05', 325, NULL),
('Cute Mountains Inn', 40, '2019-09-06', 214, NULL),
('Cute Mountains Inn', 40, '2019-09-07', 326, NULL),
('Cute Mountains Inn', 40, '2019-09-08', 128, NULL),
('Cute Mountains Inn', 40, '2019-09-09', 258, NULL),
('Cute Mountains Inn', 40, '2019-09-10', 399, NULL),
('Cute Mountains Inn', 40, '2019-09-11', 164, NULL),
('Cute Mountains Inn', 40, '2019-09-12', 276, NULL),
('Cute Mountains Inn', 40, '2019-09-13', 312, NULL),
('Cute Mountains Inn', 40, '2019-09-14', 357, NULL),
('Cute Mountains Inn', 40, '2019-09-15', 146, NULL),
('Cute Mountains Inn', 40, '2019-09-16', 174, NULL),
('Cute Mountains Inn', 40, '2019-09-17', 118, NULL),
('Cute Mountains Inn', 40, '2019-09-18', 139, NULL),
('Cute Mountains Inn', 40, '2019-09-19', 232, NULL),
('Cute Mountains Inn', 40, '2019-09-20', 293, NULL),
('Cute Mountains Inn', 40, '2019-09-21', 205, NULL),
('Cute Mountains Inn', 40, '2019-09-22', 198, NULL),
('Cute Mountains Inn', 40, '2019-09-23', 128, NULL),
('Cute Mountains Inn', 40, '2019-09-24', 241, NULL),
('Cute Mountains Inn', 40, '2019-09-25', 370, NULL),
('Cute Mountains Inn', 40, '2019-09-26', 330, NULL),
('Cute Mountains Inn', 40, '2019-09-27', 200, NULL),
('Cute Mountains Inn', 40, '2019-09-28', 319, NULL),
('Cute Mountains Inn', 40, '2019-09-29', 228, NULL),
('Cute Mountains Inn', 40, '2019-09-30', 354, NULL),
('Cute Mountains Inn', 40, '2019-10-01', 144, NULL),
('Cute Mountains Inn', 40, '2019-10-02', 380, NULL),
('Cute Mountains Inn', 40, '2019-10-03', 355, NULL),
('Cute Mountains Inn', 40, '2019-10-04', 241, NULL),
('Cute Mountains Inn', 40, '2019-10-05', 282, NULL),
('Cute Mountains Inn', 40, '2019-10-06', 249, NULL),
('Cute Mountains Inn', 40, '2019-10-07', 288, NULL),
('Cute Mountains Inn', 40, '2019-10-08', 393, NULL),
('Cute Mountains Inn', 40, '2019-10-09', 351, NULL),
('Cute Mountains Inn', 40, '2019-10-10', 111, NULL),
('Cute Mountains Inn', 40, '2019-10-11', 223, NULL),
('Cute Mountains Inn', 40, '2019-10-12', 324, NULL),
('Cute Mountains Inn', 40, '2019-10-13', 169, NULL),
('Cute Mountains Inn', 40, '2019-10-14', 251, NULL),
('Cute Mountains Inn', 40, '2019-10-15', 378, NULL),
('Cute Mountains Inn', 40, '2019-10-16', 324, NULL),
('Cute Mountains Inn', 40, '2019-10-17', 326, NULL),
('Cute Mountains Inn', 40, '2019-10-18', 243, NULL),
('Cute Mountains Inn', 40, '2019-10-19', 339, NULL),
('Cute Mountains Inn', 40, '2019-10-20', 120, NULL),
('Cute Mountains Inn', 40, '2019-10-21', 166, NULL),
('Cute Mountains Inn', 40, '2019-10-22', 167, NULL),
('Cute Mountains Inn', 40, '2019-10-23', 394, NULL),
('Cute Mountains Inn', 40, '2019-10-24', 236, NULL),
('Cute Mountains Inn', 40, '2019-10-25', 354, NULL),
('Cute Mountains Inn', 40, '2019-10-26', 338, NULL),
('Cute Mountains Inn', 40, '2019-10-27', 238, NULL),
('Cute Mountains Inn', 40, '2019-10-28', 198, NULL),
('Cute Mountains Inn', 40, '2019-10-29', 334, NULL),
('Cute Mountains Inn', 40, '2019-10-30', 274, NULL),
('Cute Mountains Inn', 40, '2019-10-31', 145, NULL),
('Cute Mountains Inn', 40, '2019-11-01', 113, NULL),
('Cute Mountains Inn', 40, '2019-11-02', 201, NULL),
('Cute Mountains Inn', 40, '2019-11-03', 119, NULL),
('Cute Mountains Inn', 40, '2019-11-04', 399, NULL),
('Cute Mountains Inn', 40, '2019-11-05', 341, NULL),
('Cute Mountains Inn', 40, '2019-11-06', 132, NULL),
('Cute Mountains Inn', 40, '2019-11-07', 240, NULL),
('Cute Mountains Inn', 40, '2019-11-08', 193, NULL),
('Cute Mountains Inn', 40, '2019-11-09', 293, NULL),
('Cute Mountains Inn', 40, '2019-11-10', 156, NULL),
('Cute Mountains Inn', 40, '2019-11-11', 124, NULL),
('Cute Mountains Inn', 40, '2019-11-12', 153, NULL),
('Cute Mountains Inn', 40, '2019-11-13', 356, NULL),
('Cute Mountains Inn', 40, '2019-11-14', 335, NULL),
('Cute Mountains Inn', 40, '2019-11-15', 244, NULL),
('Cute Mountains Inn', 40, '2019-11-16', 157, NULL),
('Cute Mountains Inn', 40, '2019-11-17', 386, NULL),
('Cute Mountains Inn', 40, '2019-11-18', 293, NULL),
('Cute Mountains Inn', 40, '2019-11-19', 185, NULL),
('Cute Mountains Inn', 40, '2019-11-20', 271, NULL),
('Cute Mountains Inn', 40, '2019-11-21', 110, NULL),
('Cute Mountains Inn', 40, '2019-11-22', 273, NULL),
('Cute Mountains Inn', 40, '2019-11-23', 248, NULL),
('Cute Mountains Inn', 40, '2019-11-24', 259, NULL),
('Cute Mountains Inn', 40, '2019-11-25', 328, NULL),
('Cute Mountains Inn', 40, '2019-11-26', 191, NULL),
('Cute Mountains Inn', 40, '2019-11-27', 134, NULL),
('Cute Mountains Inn', 40, '2019-11-28', 254, NULL),
('Cute Mountains Inn', 40, '2019-11-29', 397, NULL),
('Cute Mountains Inn', 40, '2019-11-30', 390, NULL),
('Cute Mountains Inn', 40, '2019-12-01', 311, NULL),
('Cute Mountains Inn', 40, '2019-12-02', 312, NULL),
('Cute Mountains Inn', 40, '2019-12-03', 290, NULL),
('Cute Mountains Inn', 40, '2019-12-04', 363, NULL),
('Cute Mountains Inn', 40, '2019-12-05', 318, NULL),
('Cute Mountains Inn', 40, '2019-12-06', 257, NULL),
('Cute Mountains Inn', 40, '2019-12-07', 178, NULL),
('Cute Mountains Inn', 40, '2019-12-08', 231, NULL),
('Cute Mountains Inn', 40, '2019-12-09', 152, NULL),
('Cute Mountains Inn', 40, '2019-12-10', 234, NULL),
('Cute Mountains Inn', 40, '2019-12-11', 116, NULL),
('Cute Mountains Inn', 40, '2019-12-12', 102, NULL),
('Cute Mountains Inn', 40, '2019-12-13', 346, NULL),
('Cute Mountains Inn', 40, '2019-12-14', 390, NULL),
('Cute Mountains Inn', 40, '2019-12-15', 247, NULL),
('Cute Mountains Inn', 40, '2019-12-16', 226, NULL),
('Cute Mountains Inn', 40, '2019-12-17', 202, NULL),
('Cute Mountains Inn', 40, '2019-12-18', 379, NULL),
('Cute Mountains Inn', 40, '2019-12-19', 356, NULL),
('Cute Mountains Inn', 40, '2019-12-20', 280, NULL),
('Cute Mountains Inn', 40, '2019-12-21', 250, NULL),
('Cute Mountains Inn', 40, '2019-12-22', 282, NULL),
('Cute Mountains Inn', 40, '2019-12-23', 166, NULL),
('Cute Mountains Inn', 40, '2019-12-24', 254, NULL),
('Cute Mountains Inn', 40, '2019-12-25', 210, NULL),
('Cute Mountains Inn', 40, '2019-12-26', 137, NULL),
('Cute Mountains Inn', 40, '2019-12-27', 195, NULL),
('Cute Mountains Inn', 40, '2019-12-28', 101, NULL),
('Cute Mountains Inn', 40, '2019-12-29', 190, NULL),
('Cute Mountains Inn', 40, '2019-12-30', 168, NULL),
('Cute Mountains Inn', 40, '2019-12-31', 137, NULL),
('Cute Mountains Inn', 40, '2020-01-01', 100, NULL),
('Cute Mountains Inn', 40, '2020-01-02', 244, NULL),
('Cute Mountains Inn', 40, '2020-01-03', 370, NULL),
('Cute Mountains Inn', 40, '2020-01-04', 334, NULL),
('Cute Mountains Inn', 40, '2020-01-05', 204, NULL),
('Cute Mountains Inn', 40, '2020-01-06', 299, NULL),
('Cute Mountains Inn', 40, '2020-01-07', 353, NULL),
('Cute Mountains Inn', 40, '2020-01-08', 353, NULL),
('Cute Mountains Inn', 40, '2020-01-09', 231, NULL),
('Cute Mountains Inn', 40, '2020-01-10', 142, NULL),
('Cute Mountains Inn', 40, '2020-01-11', 372, NULL),
('Cute Mountains Inn', 40, '2020-01-12', 111, NULL),
('Cute Mountains Inn', 40, '2020-01-13', 108, NULL),
('Cute Mountains Inn', 40, '2020-01-14', 303, NULL),
('Cute Mountains Inn', 40, '2020-01-15', 305, NULL),
('Cute Mountains Inn', 40, '2020-01-16', 145, NULL),
('Cute Mountains Inn', 40, '2020-01-17', 221, NULL),
('Cute Mountains Inn', 40, '2020-01-18', 215, NULL),
('Cute Mountains Inn', 40, '2020-01-19', 298, NULL),
('Cute Mountains Inn', 40, '2020-01-20', 302, NULL),
('Cute Mountains Inn', 40, '2020-01-21', 131, NULL),
('Cute Mountains Inn', 40, '2020-01-22', 140, NULL),
('Cute Mountains Inn', 40, '2020-01-23', 261, NULL),
('Cute Mountains Inn', 40, '2020-01-24', 201, NULL),
('Cute Mountains Inn', 40, '2020-01-25', 117, NULL),
('Cute Mountains Inn', 40, '2020-01-26', 166, NULL),
('Cute Mountains Inn', 40, '2020-01-27', 138, NULL),
('Cute Mountains Inn', 40, '2020-01-28', 265, NULL),
('Cute Mountains Inn', 40, '2020-01-29', 319, NULL),
('Cute Mountains Inn', 40, '2020-01-30', 338, NULL),
('Cute Mountains Inn', 40, '2020-01-31', 332, NULL),
('Cute Mountains Inn', 40, '2020-02-01', 203, NULL),
('Cute Mountains Inn', 40, '2020-02-02', 235, NULL),
('Cute Mountains Inn', 40, '2020-02-03', 285, NULL),
('Cute Mountains Inn', 40, '2020-02-04', 315, NULL),
('Cute Mountains Inn', 49, '2019-01-01', 205, NULL),
('Cute Mountains Inn', 49, '2019-01-02', 309, NULL),
('Cute Mountains Inn', 49, '2019-01-03', 324, NULL),
('Cute Mountains Inn', 49, '2019-01-04', 229, NULL),
('Cute Mountains Inn', 49, '2019-01-05', 396, NULL),
('Cute Mountains Inn', 49, '2019-01-06', 344, NULL),
('Cute Mountains Inn', 49, '2019-01-07', 202, NULL),
('Cute Mountains Inn', 49, '2019-01-08', 213, NULL),
('Cute Mountains Inn', 49, '2019-01-09', 249, NULL),
('Cute Mountains Inn', 49, '2019-01-10', 103, NULL),
('Cute Mountains Inn', 49, '2019-01-11', 204, NULL),
('Cute Mountains Inn', 49, '2019-01-12', 389, NULL),
('Cute Mountains Inn', 49, '2019-01-13', 398, NULL),
('Cute Mountains Inn', 49, '2019-01-14', 128, NULL),
('Cute Mountains Inn', 49, '2019-01-15', 114, NULL),
('Cute Mountains Inn', 49, '2019-01-16', 330, NULL),
('Cute Mountains Inn', 49, '2019-01-17', 252, NULL),
('Cute Mountains Inn', 49, '2019-01-18', 356, NULL),
('Cute Mountains Inn', 49, '2019-01-19', 385, NULL),
('Cute Mountains Inn', 49, '2019-01-20', 215, NULL),
('Cute Mountains Inn', 49, '2019-01-21', 245, NULL),
('Cute Mountains Inn', 49, '2019-01-22', 199, NULL),
('Cute Mountains Inn', 49, '2019-01-23', 203, NULL),
('Cute Mountains Inn', 49, '2019-01-24', 327, NULL),
('Cute Mountains Inn', 49, '2019-01-25', 141, NULL),
('Cute Mountains Inn', 49, '2019-01-26', 158, NULL),
('Cute Mountains Inn', 49, '2019-01-27', 154, NULL),
('Cute Mountains Inn', 49, '2019-01-28', 161, NULL),
('Cute Mountains Inn', 49, '2019-01-29', 381, NULL),
('Cute Mountains Inn', 49, '2019-01-30', 332, NULL),
('Cute Mountains Inn', 49, '2019-01-31', 271, NULL),
('Cute Mountains Inn', 49, '2019-02-01', 328, NULL),
('Cute Mountains Inn', 49, '2019-02-02', 136, NULL),
('Cute Mountains Inn', 49, '2019-02-03', 322, NULL),
('Cute Mountains Inn', 49, '2019-02-04', 396, NULL),
('Cute Mountains Inn', 49, '2019-02-05', 369, NULL),
('Cute Mountains Inn', 49, '2019-02-06', 374, NULL),
('Cute Mountains Inn', 49, '2019-02-07', 374, NULL),
('Cute Mountains Inn', 49, '2019-02-08', 131, NULL),
('Cute Mountains Inn', 49, '2019-02-09', 207, NULL),
('Cute Mountains Inn', 49, '2019-02-10', 383, NULL),
('Cute Mountains Inn', 49, '2019-02-11', 155, NULL),
('Cute Mountains Inn', 49, '2019-02-12', 330, NULL),
('Cute Mountains Inn', 49, '2019-02-13', 151, NULL),
('Cute Mountains Inn', 49, '2019-02-14', 350, NULL),
('Cute Mountains Inn', 49, '2019-02-15', 387, NULL),
('Cute Mountains Inn', 49, '2019-02-16', 320, NULL),
('Cute Mountains Inn', 49, '2019-02-17', 242, NULL),
('Cute Mountains Inn', 49, '2019-02-18', 199, NULL),
('Cute Mountains Inn', 49, '2019-02-19', 152, NULL),
('Cute Mountains Inn', 49, '2019-02-20', 217, NULL),
('Cute Mountains Inn', 49, '2019-02-21', 292, NULL),
('Cute Mountains Inn', 49, '2019-02-22', 349, NULL),
('Cute Mountains Inn', 49, '2019-02-23', 304, NULL),
('Cute Mountains Inn', 49, '2019-02-24', 173, NULL),
('Cute Mountains Inn', 49, '2019-02-25', 315, NULL),
('Cute Mountains Inn', 49, '2019-02-26', 285, NULL),
('Cute Mountains Inn', 49, '2019-02-27', 313, NULL),
('Cute Mountains Inn', 49, '2019-02-28', 294, NULL),
('Cute Mountains Inn', 49, '2019-03-01', 353, NULL),
('Cute Mountains Inn', 49, '2019-03-02', 154, NULL),
('Cute Mountains Inn', 49, '2019-03-03', 144, NULL),
('Cute Mountains Inn', 49, '2019-03-04', 326, NULL),
('Cute Mountains Inn', 49, '2019-03-05', 102, NULL),
('Cute Mountains Inn', 49, '2019-03-06', 179, NULL),
('Cute Mountains Inn', 49, '2019-03-07', 156, NULL),
('Cute Mountains Inn', 49, '2019-03-08', 271, NULL),
('Cute Mountains Inn', 49, '2019-03-09', 185, NULL),
('Cute Mountains Inn', 49, '2019-03-10', 382, NULL),
('Cute Mountains Inn', 49, '2019-03-11', 253, NULL),
('Cute Mountains Inn', 49, '2019-03-12', 325, NULL),
('Cute Mountains Inn', 49, '2019-03-13', 287, NULL),
('Cute Mountains Inn', 49, '2019-03-14', 257, NULL),
('Cute Mountains Inn', 49, '2019-03-15', 124, NULL),
('Cute Mountains Inn', 49, '2019-03-16', 295, NULL),
('Cute Mountains Inn', 49, '2019-03-17', 143, NULL),
('Cute Mountains Inn', 49, '2019-03-18', 357, NULL),
('Cute Mountains Inn', 49, '2019-03-19', 125, NULL),
('Cute Mountains Inn', 49, '2019-03-20', 395, NULL),
('Cute Mountains Inn', 49, '2019-03-21', 221, NULL),
('Cute Mountains Inn', 49, '2019-03-22', 114, NULL),
('Cute Mountains Inn', 49, '2019-03-23', 125, NULL),
('Cute Mountains Inn', 49, '2019-03-24', 342, NULL),
('Cute Mountains Inn', 49, '2019-03-25', 199, NULL),
('Cute Mountains Inn', 49, '2019-03-26', 314, NULL),
('Cute Mountains Inn', 49, '2019-03-27', 322, NULL),
('Cute Mountains Inn', 49, '2019-03-28', 115, NULL),
('Cute Mountains Inn', 49, '2019-03-29', 271, NULL),
('Cute Mountains Inn', 49, '2019-03-30', 325, NULL),
('Cute Mountains Inn', 49, '2019-03-31', 379, NULL),
('Cute Mountains Inn', 49, '2019-04-01', 158, NULL),
('Cute Mountains Inn', 49, '2019-04-02', 104, NULL),
('Cute Mountains Inn', 49, '2019-04-03', 277, NULL),
('Cute Mountains Inn', 49, '2019-04-04', 284, NULL),
('Cute Mountains Inn', 49, '2019-04-05', 149, NULL),
('Cute Mountains Inn', 49, '2019-04-06', 241, NULL),
('Cute Mountains Inn', 49, '2019-04-07', 261, NULL),
('Cute Mountains Inn', 49, '2019-04-08', 301, NULL),
('Cute Mountains Inn', 49, '2019-04-09', 140, NULL),
('Cute Mountains Inn', 49, '2019-04-10', 339, NULL),
('Cute Mountains Inn', 49, '2019-04-11', 282, NULL),
('Cute Mountains Inn', 49, '2019-04-12', 321, NULL),
('Cute Mountains Inn', 49, '2019-04-13', 277, NULL),
('Cute Mountains Inn', 49, '2019-04-14', 299, NULL),
('Cute Mountains Inn', 49, '2019-04-15', 307, NULL),
('Cute Mountains Inn', 49, '2019-04-16', 218, NULL),
('Cute Mountains Inn', 49, '2019-04-17', 332, NULL),
('Cute Mountains Inn', 49, '2019-04-18', 114, NULL),
('Cute Mountains Inn', 49, '2019-04-19', 290, NULL),
('Cute Mountains Inn', 49, '2019-04-20', 329, NULL),
('Cute Mountains Inn', 49, '2019-04-21', 327, NULL),
('Cute Mountains Inn', 49, '2019-04-22', 211, NULL),
('Cute Mountains Inn', 49, '2019-04-23', 249, NULL),
('Cute Mountains Inn', 49, '2019-04-24', 290, NULL),
('Cute Mountains Inn', 49, '2019-04-25', 199, NULL),
('Cute Mountains Inn', 49, '2019-04-26', 309, NULL),
('Cute Mountains Inn', 49, '2019-04-27', 181, NULL),
('Cute Mountains Inn', 49, '2019-04-28', 345, NULL),
('Cute Mountains Inn', 49, '2019-04-29', 326, NULL),
('Cute Mountains Inn', 49, '2019-04-30', 367, NULL),
('Cute Mountains Inn', 49, '2019-05-01', 296, NULL),
('Cute Mountains Inn', 49, '2019-05-02', 257, NULL),
('Cute Mountains Inn', 49, '2019-05-03', 234, NULL),
('Cute Mountains Inn', 49, '2019-05-04', 211, NULL),
('Cute Mountains Inn', 49, '2019-05-05', 175, NULL),
('Cute Mountains Inn', 49, '2019-05-06', 199, NULL),
('Cute Mountains Inn', 49, '2019-05-07', 240, NULL),
('Cute Mountains Inn', 49, '2019-05-08', 300, NULL),
('Cute Mountains Inn', 49, '2019-05-09', 346, NULL),
('Cute Mountains Inn', 49, '2019-05-10', 206, NULL),
('Cute Mountains Inn', 49, '2019-05-11', 228, NULL),
('Cute Mountains Inn', 49, '2019-05-12', 392, NULL),
('Cute Mountains Inn', 49, '2019-05-13', 353, NULL),
('Cute Mountains Inn', 49, '2019-05-14', 129, NULL),
('Cute Mountains Inn', 49, '2019-05-15', 103, NULL),
('Cute Mountains Inn', 49, '2019-05-16', 372, NULL),
('Cute Mountains Inn', 49, '2019-05-17', 376, NULL),
('Cute Mountains Inn', 49, '2019-05-18', 212, NULL),
('Cute Mountains Inn', 49, '2019-05-19', 197, NULL),
('Cute Mountains Inn', 49, '2019-05-20', 262, NULL),
('Cute Mountains Inn', 49, '2019-05-21', 216, NULL),
('Cute Mountains Inn', 49, '2019-05-22', 254, NULL),
('Cute Mountains Inn', 49, '2019-05-23', 233, NULL),
('Cute Mountains Inn', 49, '2019-05-24', 180, NULL),
('Cute Mountains Inn', 49, '2019-05-25', 397, NULL),
('Cute Mountains Inn', 49, '2019-05-26', 207, NULL),
('Cute Mountains Inn', 49, '2019-05-27', 219, NULL),
('Cute Mountains Inn', 49, '2019-05-28', 178, NULL),
('Cute Mountains Inn', 49, '2019-05-29', 174, NULL),
('Cute Mountains Inn', 49, '2019-05-30', 176, NULL),
('Cute Mountains Inn', 49, '2019-05-31', 138, NULL),
('Cute Mountains Inn', 49, '2019-06-01', 232, NULL),
('Cute Mountains Inn', 49, '2019-06-02', 374, NULL),
('Cute Mountains Inn', 49, '2019-06-03', 260, NULL),
('Cute Mountains Inn', 49, '2019-06-04', 126, NULL),
('Cute Mountains Inn', 49, '2019-06-05', 312, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 49, '2019-06-06', 315, NULL),
('Cute Mountains Inn', 49, '2019-06-07', 195, NULL),
('Cute Mountains Inn', 49, '2019-06-08', 159, NULL),
('Cute Mountains Inn', 49, '2019-06-09', 249, NULL),
('Cute Mountains Inn', 49, '2019-06-10', 323, NULL),
('Cute Mountains Inn', 49, '2019-06-11', 205, NULL),
('Cute Mountains Inn', 49, '2019-06-12', 383, NULL),
('Cute Mountains Inn', 49, '2019-06-13', 392, NULL),
('Cute Mountains Inn', 49, '2019-06-14', 346, NULL),
('Cute Mountains Inn', 49, '2019-06-15', 369, NULL),
('Cute Mountains Inn', 49, '2019-06-16', 344, NULL),
('Cute Mountains Inn', 49, '2019-06-17', 158, NULL),
('Cute Mountains Inn', 49, '2019-06-18', 120, NULL),
('Cute Mountains Inn', 49, '2019-06-19', 242, NULL),
('Cute Mountains Inn', 49, '2019-06-20', 204, NULL),
('Cute Mountains Inn', 49, '2019-06-21', 311, NULL),
('Cute Mountains Inn', 49, '2019-06-22', 293, NULL),
('Cute Mountains Inn', 49, '2019-06-23', 129, NULL),
('Cute Mountains Inn', 49, '2019-06-24', 327, NULL),
('Cute Mountains Inn', 49, '2019-06-25', 179, NULL),
('Cute Mountains Inn', 49, '2019-06-26', 374, NULL),
('Cute Mountains Inn', 49, '2019-06-27', 374, NULL),
('Cute Mountains Inn', 49, '2019-06-28', 163, NULL),
('Cute Mountains Inn', 49, '2019-06-29', 254, NULL),
('Cute Mountains Inn', 49, '2019-06-30', 285, NULL),
('Cute Mountains Inn', 49, '2019-07-01', 299, NULL),
('Cute Mountains Inn', 49, '2019-07-02', 372, NULL),
('Cute Mountains Inn', 49, '2019-07-03', 234, NULL),
('Cute Mountains Inn', 49, '2019-07-04', 324, NULL),
('Cute Mountains Inn', 49, '2019-07-05', 192, NULL),
('Cute Mountains Inn', 49, '2019-07-06', 368, NULL),
('Cute Mountains Inn', 49, '2019-07-07', 348, NULL),
('Cute Mountains Inn', 49, '2019-07-08', 243, NULL),
('Cute Mountains Inn', 49, '2019-07-09', 344, NULL),
('Cute Mountains Inn', 49, '2019-07-10', 348, NULL),
('Cute Mountains Inn', 49, '2019-07-11', 224, NULL),
('Cute Mountains Inn', 49, '2019-07-12', 138, NULL),
('Cute Mountains Inn', 49, '2019-07-13', 357, NULL),
('Cute Mountains Inn', 49, '2019-07-14', 327, NULL),
('Cute Mountains Inn', 49, '2019-07-15', 218, NULL),
('Cute Mountains Inn', 49, '2019-07-16', 224, NULL),
('Cute Mountains Inn', 49, '2019-07-17', 280, NULL),
('Cute Mountains Inn', 49, '2019-07-18', 235, NULL),
('Cute Mountains Inn', 49, '2019-07-19', 251, NULL),
('Cute Mountains Inn', 49, '2019-07-20', 364, NULL),
('Cute Mountains Inn', 49, '2019-07-21', 219, NULL),
('Cute Mountains Inn', 49, '2019-07-22', 146, NULL),
('Cute Mountains Inn', 49, '2019-07-23', 161, NULL),
('Cute Mountains Inn', 49, '2019-07-24', 280, NULL),
('Cute Mountains Inn', 49, '2019-07-25', 324, NULL),
('Cute Mountains Inn', 49, '2019-07-26', 328, NULL),
('Cute Mountains Inn', 49, '2019-07-27', 320, NULL),
('Cute Mountains Inn', 49, '2019-07-28', 358, NULL),
('Cute Mountains Inn', 49, '2019-07-29', 267, NULL),
('Cute Mountains Inn', 49, '2019-07-30', 130, NULL),
('Cute Mountains Inn', 49, '2019-07-31', 235, NULL),
('Cute Mountains Inn', 49, '2019-08-01', 177, NULL),
('Cute Mountains Inn', 49, '2019-08-02', 273, NULL),
('Cute Mountains Inn', 49, '2019-08-03', 276, NULL),
('Cute Mountains Inn', 49, '2019-08-04', 182, NULL),
('Cute Mountains Inn', 49, '2019-08-05', 137, NULL),
('Cute Mountains Inn', 49, '2019-08-06', 291, NULL),
('Cute Mountains Inn', 49, '2019-08-07', 360, NULL),
('Cute Mountains Inn', 49, '2019-08-08', 286, NULL),
('Cute Mountains Inn', 49, '2019-08-09', 176, NULL),
('Cute Mountains Inn', 49, '2019-08-10', 245, NULL),
('Cute Mountains Inn', 49, '2019-08-11', 335, NULL),
('Cute Mountains Inn', 49, '2019-08-12', 346, NULL),
('Cute Mountains Inn', 49, '2019-08-13', 324, NULL),
('Cute Mountains Inn', 49, '2019-08-14', 308, NULL),
('Cute Mountains Inn', 49, '2019-08-15', 205, NULL),
('Cute Mountains Inn', 49, '2019-08-16', 254, NULL),
('Cute Mountains Inn', 49, '2019-08-17', 185, NULL),
('Cute Mountains Inn', 49, '2019-08-18', 192, NULL),
('Cute Mountains Inn', 49, '2019-08-19', 387, NULL),
('Cute Mountains Inn', 49, '2019-08-20', 266, NULL),
('Cute Mountains Inn', 49, '2019-08-21', 199, NULL),
('Cute Mountains Inn', 49, '2019-08-22', 383, NULL),
('Cute Mountains Inn', 49, '2019-08-23', 155, NULL),
('Cute Mountains Inn', 49, '2019-08-24', 279, NULL),
('Cute Mountains Inn', 49, '2019-08-25', 239, NULL),
('Cute Mountains Inn', 49, '2019-08-26', 372, NULL),
('Cute Mountains Inn', 49, '2019-08-27', 196, NULL),
('Cute Mountains Inn', 49, '2019-08-28', 120, NULL),
('Cute Mountains Inn', 49, '2019-08-29', 176, NULL),
('Cute Mountains Inn', 49, '2019-08-30', 132, NULL),
('Cute Mountains Inn', 49, '2019-08-31', 286, NULL),
('Cute Mountains Inn', 49, '2019-09-01', 350, NULL),
('Cute Mountains Inn', 49, '2019-09-02', 362, NULL),
('Cute Mountains Inn', 49, '2019-09-03', 142, NULL),
('Cute Mountains Inn', 49, '2019-09-04', 296, NULL),
('Cute Mountains Inn', 49, '2019-09-05', 351, NULL),
('Cute Mountains Inn', 49, '2019-09-06', 237, NULL),
('Cute Mountains Inn', 49, '2019-09-07', 165, NULL),
('Cute Mountains Inn', 49, '2019-09-08', 239, NULL),
('Cute Mountains Inn', 49, '2019-09-09', 186, NULL),
('Cute Mountains Inn', 49, '2019-09-10', 170, NULL),
('Cute Mountains Inn', 49, '2019-09-11', 297, NULL),
('Cute Mountains Inn', 49, '2019-09-12', 319, NULL),
('Cute Mountains Inn', 49, '2019-09-13', 224, NULL),
('Cute Mountains Inn', 49, '2019-09-14', 322, NULL),
('Cute Mountains Inn', 49, '2019-09-15', 231, NULL),
('Cute Mountains Inn', 49, '2019-09-16', 275, NULL),
('Cute Mountains Inn', 49, '2019-09-17', 256, NULL),
('Cute Mountains Inn', 49, '2019-09-18', 324, NULL),
('Cute Mountains Inn', 49, '2019-09-19', 129, NULL),
('Cute Mountains Inn', 49, '2019-09-20', 134, NULL),
('Cute Mountains Inn', 49, '2019-09-21', 241, NULL),
('Cute Mountains Inn', 49, '2019-09-22', 380, NULL),
('Cute Mountains Inn', 49, '2019-09-23', 310, NULL),
('Cute Mountains Inn', 49, '2019-09-24', 163, NULL),
('Cute Mountains Inn', 49, '2019-09-25', 180, NULL),
('Cute Mountains Inn', 49, '2019-09-26', 308, NULL),
('Cute Mountains Inn', 49, '2019-09-27', 386, NULL),
('Cute Mountains Inn', 49, '2019-09-28', 320, NULL),
('Cute Mountains Inn', 49, '2019-09-29', 305, NULL),
('Cute Mountains Inn', 49, '2019-09-30', 360, NULL),
('Cute Mountains Inn', 49, '2019-10-01', 396, NULL),
('Cute Mountains Inn', 49, '2019-10-02', 204, NULL),
('Cute Mountains Inn', 49, '2019-10-03', 365, NULL),
('Cute Mountains Inn', 49, '2019-10-04', 382, NULL),
('Cute Mountains Inn', 49, '2019-10-05', 338, NULL),
('Cute Mountains Inn', 49, '2019-10-06', 125, NULL),
('Cute Mountains Inn', 49, '2019-10-07', 210, NULL),
('Cute Mountains Inn', 49, '2019-10-08', 210, NULL),
('Cute Mountains Inn', 49, '2019-10-09', 242, NULL),
('Cute Mountains Inn', 49, '2019-10-10', 113, NULL),
('Cute Mountains Inn', 49, '2019-10-11', 207, NULL),
('Cute Mountains Inn', 49, '2019-10-12', 326, NULL),
('Cute Mountains Inn', 49, '2019-10-13', 389, NULL),
('Cute Mountains Inn', 49, '2019-10-14', 112, NULL),
('Cute Mountains Inn', 49, '2019-10-15', 249, NULL),
('Cute Mountains Inn', 49, '2019-10-16', 285, NULL),
('Cute Mountains Inn', 49, '2019-10-17', 344, NULL),
('Cute Mountains Inn', 49, '2019-10-18', 206, NULL),
('Cute Mountains Inn', 49, '2019-10-19', 275, NULL),
('Cute Mountains Inn', 49, '2019-10-20', 133, NULL),
('Cute Mountains Inn', 49, '2019-10-21', 265, NULL),
('Cute Mountains Inn', 49, '2019-10-22', 300, NULL),
('Cute Mountains Inn', 49, '2019-10-23', 124, NULL),
('Cute Mountains Inn', 49, '2019-10-24', 222, NULL),
('Cute Mountains Inn', 49, '2019-10-25', 395, NULL),
('Cute Mountains Inn', 49, '2019-10-26', 273, NULL),
('Cute Mountains Inn', 49, '2019-10-27', 218, NULL),
('Cute Mountains Inn', 49, '2019-10-28', 284, NULL),
('Cute Mountains Inn', 49, '2019-10-29', 265, NULL),
('Cute Mountains Inn', 49, '2019-10-30', 145, NULL),
('Cute Mountains Inn', 49, '2019-10-31', 270, NULL),
('Cute Mountains Inn', 49, '2019-11-01', 261, NULL),
('Cute Mountains Inn', 49, '2019-11-02', 323, NULL),
('Cute Mountains Inn', 49, '2019-11-03', 311, NULL),
('Cute Mountains Inn', 49, '2019-11-04', 195, NULL),
('Cute Mountains Inn', 49, '2019-11-05', 364, NULL),
('Cute Mountains Inn', 49, '2019-11-06', 172, NULL),
('Cute Mountains Inn', 49, '2019-11-07', 358, NULL),
('Cute Mountains Inn', 49, '2019-11-08', 280, NULL),
('Cute Mountains Inn', 49, '2019-11-09', 209, NULL),
('Cute Mountains Inn', 49, '2019-11-10', 241, NULL),
('Cute Mountains Inn', 49, '2019-11-11', 352, NULL),
('Cute Mountains Inn', 49, '2019-11-12', 109, NULL),
('Cute Mountains Inn', 49, '2019-11-13', 335, NULL),
('Cute Mountains Inn', 49, '2019-11-14', 214, NULL),
('Cute Mountains Inn', 49, '2019-11-15', 393, NULL),
('Cute Mountains Inn', 49, '2019-11-16', 137, NULL),
('Cute Mountains Inn', 49, '2019-11-17', 215, NULL),
('Cute Mountains Inn', 49, '2019-11-18', 174, NULL),
('Cute Mountains Inn', 49, '2019-11-19', 349, NULL),
('Cute Mountains Inn', 49, '2019-11-20', 323, NULL),
('Cute Mountains Inn', 49, '2019-11-21', 399, NULL),
('Cute Mountains Inn', 49, '2019-11-22', 143, NULL),
('Cute Mountains Inn', 49, '2019-11-23', 200, NULL),
('Cute Mountains Inn', 49, '2019-11-24', 361, NULL),
('Cute Mountains Inn', 49, '2019-11-25', 154, NULL),
('Cute Mountains Inn', 49, '2019-11-26', 341, NULL),
('Cute Mountains Inn', 49, '2019-11-27', 337, NULL),
('Cute Mountains Inn', 49, '2019-11-28', 219, NULL),
('Cute Mountains Inn', 49, '2019-11-29', 349, NULL),
('Cute Mountains Inn', 49, '2019-11-30', 251, NULL),
('Cute Mountains Inn', 49, '2019-12-01', 259, NULL),
('Cute Mountains Inn', 49, '2019-12-02', 331, NULL),
('Cute Mountains Inn', 49, '2019-12-03', 219, NULL),
('Cute Mountains Inn', 49, '2019-12-04', 308, NULL),
('Cute Mountains Inn', 49, '2019-12-05', 279, NULL),
('Cute Mountains Inn', 49, '2019-12-06', 154, NULL),
('Cute Mountains Inn', 49, '2019-12-07', 367, NULL),
('Cute Mountains Inn', 49, '2019-12-08', 240, NULL),
('Cute Mountains Inn', 49, '2019-12-09', 133, NULL),
('Cute Mountains Inn', 49, '2019-12-10', 263, NULL),
('Cute Mountains Inn', 49, '2019-12-11', 310, NULL),
('Cute Mountains Inn', 49, '2019-12-12', 275, NULL),
('Cute Mountains Inn', 49, '2019-12-13', 170, NULL),
('Cute Mountains Inn', 49, '2019-12-14', 115, NULL),
('Cute Mountains Inn', 49, '2019-12-15', 384, NULL),
('Cute Mountains Inn', 49, '2019-12-16', 325, NULL),
('Cute Mountains Inn', 49, '2019-12-17', 110, NULL),
('Cute Mountains Inn', 49, '2019-12-18', 274, NULL),
('Cute Mountains Inn', 49, '2019-12-19', 229, NULL),
('Cute Mountains Inn', 49, '2019-12-20', 290, NULL),
('Cute Mountains Inn', 49, '2019-12-21', 318, NULL),
('Cute Mountains Inn', 49, '2019-12-22', 245, NULL),
('Cute Mountains Inn', 49, '2019-12-23', 382, NULL),
('Cute Mountains Inn', 49, '2019-12-24', 376, NULL),
('Cute Mountains Inn', 49, '2019-12-25', 375, NULL),
('Cute Mountains Inn', 49, '2019-12-26', 148, NULL),
('Cute Mountains Inn', 49, '2019-12-27', 346, NULL),
('Cute Mountains Inn', 49, '2019-12-28', 117, NULL),
('Cute Mountains Inn', 49, '2019-12-29', 126, NULL),
('Cute Mountains Inn', 49, '2019-12-30', 117, NULL),
('Cute Mountains Inn', 49, '2019-12-31', 331, NULL),
('Cute Mountains Inn', 49, '2020-01-01', 153, NULL),
('Cute Mountains Inn', 49, '2020-01-02', 110, NULL),
('Cute Mountains Inn', 49, '2020-01-03', 206, NULL),
('Cute Mountains Inn', 49, '2020-01-04', 272, NULL),
('Cute Mountains Inn', 49, '2020-01-05', 121, NULL),
('Cute Mountains Inn', 49, '2020-01-06', 225, NULL),
('Cute Mountains Inn', 49, '2020-01-07', 205, NULL),
('Cute Mountains Inn', 49, '2020-01-08', 148, NULL),
('Cute Mountains Inn', 49, '2020-01-09', 113, NULL),
('Cute Mountains Inn', 49, '2020-01-10', 344, NULL),
('Cute Mountains Inn', 49, '2020-01-11', 336, NULL),
('Cute Mountains Inn', 49, '2020-01-12', 236, NULL),
('Cute Mountains Inn', 49, '2020-01-13', 177, NULL),
('Cute Mountains Inn', 49, '2020-01-14', 119, NULL),
('Cute Mountains Inn', 49, '2020-01-15', 253, NULL),
('Cute Mountains Inn', 49, '2020-01-16', 238, NULL),
('Cute Mountains Inn', 49, '2020-01-17', 198, NULL),
('Cute Mountains Inn', 49, '2020-01-18', 388, NULL),
('Cute Mountains Inn', 49, '2020-01-19', 363, NULL),
('Cute Mountains Inn', 49, '2020-01-20', 110, NULL),
('Cute Mountains Inn', 49, '2020-01-21', 114, NULL),
('Cute Mountains Inn', 49, '2020-01-22', 149, NULL),
('Cute Mountains Inn', 49, '2020-01-23', 241, NULL),
('Cute Mountains Inn', 49, '2020-01-24', 208, NULL),
('Cute Mountains Inn', 49, '2020-01-25', 128, NULL),
('Cute Mountains Inn', 49, '2020-01-26', 263, NULL),
('Cute Mountains Inn', 49, '2020-01-27', 285, NULL),
('Cute Mountains Inn', 49, '2020-01-28', 102, NULL),
('Cute Mountains Inn', 49, '2020-01-29', 176, NULL),
('Cute Mountains Inn', 49, '2020-01-30', 362, NULL),
('Cute Mountains Inn', 49, '2020-01-31', 355, NULL),
('Cute Mountains Inn', 49, '2020-02-01', 283, NULL),
('Cute Mountains Inn', 49, '2020-02-02', 385, NULL),
('Cute Mountains Inn', 49, '2020-02-03', 174, NULL),
('Cute Mountains Inn', 49, '2020-02-04', 136, NULL),
('Cute Mountains Inn', 63, '2019-01-01', 386, NULL),
('Cute Mountains Inn', 63, '2019-01-02', 132, NULL),
('Cute Mountains Inn', 63, '2019-01-03', 142, NULL),
('Cute Mountains Inn', 63, '2019-01-04', 178, NULL),
('Cute Mountains Inn', 63, '2019-01-05', 386, NULL),
('Cute Mountains Inn', 63, '2019-01-06', 384, NULL),
('Cute Mountains Inn', 63, '2019-01-07', 283, NULL),
('Cute Mountains Inn', 63, '2019-01-08', 376, NULL),
('Cute Mountains Inn', 63, '2019-01-09', 352, NULL),
('Cute Mountains Inn', 63, '2019-01-10', 337, NULL),
('Cute Mountains Inn', 63, '2019-01-11', 370, NULL),
('Cute Mountains Inn', 63, '2019-01-12', 297, NULL),
('Cute Mountains Inn', 63, '2019-01-13', 248, NULL),
('Cute Mountains Inn', 63, '2019-01-14', 392, NULL),
('Cute Mountains Inn', 63, '2019-01-15', 163, NULL),
('Cute Mountains Inn', 63, '2019-01-16', 171, NULL),
('Cute Mountains Inn', 63, '2019-01-17', 253, NULL),
('Cute Mountains Inn', 63, '2019-01-18', 212, NULL),
('Cute Mountains Inn', 63, '2019-01-19', 207, NULL),
('Cute Mountains Inn', 63, '2019-01-20', 174, NULL),
('Cute Mountains Inn', 63, '2019-01-21', 229, NULL),
('Cute Mountains Inn', 63, '2019-01-22', 286, NULL),
('Cute Mountains Inn', 63, '2019-01-23', 112, NULL),
('Cute Mountains Inn', 63, '2019-01-24', 314, NULL),
('Cute Mountains Inn', 63, '2019-01-25', 249, NULL),
('Cute Mountains Inn', 63, '2019-01-26', 297, NULL),
('Cute Mountains Inn', 63, '2019-01-27', 363, NULL),
('Cute Mountains Inn', 63, '2019-01-28', 299, NULL),
('Cute Mountains Inn', 63, '2019-01-29', 292, NULL),
('Cute Mountains Inn', 63, '2019-01-30', 281, NULL),
('Cute Mountains Inn', 63, '2019-01-31', 310, NULL),
('Cute Mountains Inn', 63, '2019-02-01', 140, NULL),
('Cute Mountains Inn', 63, '2019-02-02', 399, NULL),
('Cute Mountains Inn', 63, '2019-02-03', 142, NULL),
('Cute Mountains Inn', 63, '2019-02-04', 337, NULL),
('Cute Mountains Inn', 63, '2019-02-05', 254, NULL),
('Cute Mountains Inn', 63, '2019-02-06', 393, NULL),
('Cute Mountains Inn', 63, '2019-02-07', 362, NULL),
('Cute Mountains Inn', 63, '2019-02-08', 226, NULL),
('Cute Mountains Inn', 63, '2019-02-09', 270, NULL),
('Cute Mountains Inn', 63, '2019-02-10', 287, NULL),
('Cute Mountains Inn', 63, '2019-02-11', 288, NULL),
('Cute Mountains Inn', 63, '2019-02-12', 368, NULL),
('Cute Mountains Inn', 63, '2019-02-13', 176, NULL),
('Cute Mountains Inn', 63, '2019-02-14', 314, NULL),
('Cute Mountains Inn', 63, '2019-02-15', 368, NULL),
('Cute Mountains Inn', 63, '2019-02-16', 252, NULL),
('Cute Mountains Inn', 63, '2019-02-17', 261, NULL),
('Cute Mountains Inn', 63, '2019-02-18', 200, NULL),
('Cute Mountains Inn', 63, '2019-02-19', 276, NULL),
('Cute Mountains Inn', 63, '2019-02-20', 265, NULL),
('Cute Mountains Inn', 63, '2019-02-21', 183, NULL),
('Cute Mountains Inn', 63, '2019-02-22', 158, NULL),
('Cute Mountains Inn', 63, '2019-02-23', 169, NULL),
('Cute Mountains Inn', 63, '2019-02-24', 340, NULL),
('Cute Mountains Inn', 63, '2019-02-25', 227, NULL),
('Cute Mountains Inn', 63, '2019-02-26', 268, NULL),
('Cute Mountains Inn', 63, '2019-02-27', 184, NULL),
('Cute Mountains Inn', 63, '2019-02-28', 273, NULL),
('Cute Mountains Inn', 63, '2019-03-01', 109, NULL),
('Cute Mountains Inn', 63, '2019-03-02', 268, NULL),
('Cute Mountains Inn', 63, '2019-03-03', 311, NULL),
('Cute Mountains Inn', 63, '2019-03-04', 259, NULL),
('Cute Mountains Inn', 63, '2019-03-05', 298, NULL),
('Cute Mountains Inn', 63, '2019-03-06', 384, NULL),
('Cute Mountains Inn', 63, '2019-03-07', 100, NULL),
('Cute Mountains Inn', 63, '2019-03-08', 303, NULL),
('Cute Mountains Inn', 63, '2019-03-09', 164, NULL),
('Cute Mountains Inn', 63, '2019-03-10', 372, NULL),
('Cute Mountains Inn', 63, '2019-03-11', 217, NULL),
('Cute Mountains Inn', 63, '2019-03-12', 283, NULL),
('Cute Mountains Inn', 63, '2019-03-13', 237, NULL),
('Cute Mountains Inn', 63, '2019-03-14', 249, NULL),
('Cute Mountains Inn', 63, '2019-03-15', 193, NULL),
('Cute Mountains Inn', 63, '2019-03-16', 332, NULL),
('Cute Mountains Inn', 63, '2019-03-17', 209, NULL),
('Cute Mountains Inn', 63, '2019-03-18', 279, NULL),
('Cute Mountains Inn', 63, '2019-03-19', 226, NULL),
('Cute Mountains Inn', 63, '2019-03-20', 278, NULL),
('Cute Mountains Inn', 63, '2019-03-21', 374, NULL),
('Cute Mountains Inn', 63, '2019-03-22', 293, NULL),
('Cute Mountains Inn', 63, '2019-03-23', 382, NULL),
('Cute Mountains Inn', 63, '2019-03-24', 338, NULL),
('Cute Mountains Inn', 63, '2019-03-25', 139, NULL),
('Cute Mountains Inn', 63, '2019-03-26', 218, NULL),
('Cute Mountains Inn', 63, '2019-03-27', 381, NULL),
('Cute Mountains Inn', 63, '2019-03-28', 395, NULL),
('Cute Mountains Inn', 63, '2019-03-29', 285, NULL),
('Cute Mountains Inn', 63, '2019-03-30', 138, NULL),
('Cute Mountains Inn', 63, '2019-03-31', 163, NULL),
('Cute Mountains Inn', 63, '2019-04-01', 249, NULL),
('Cute Mountains Inn', 63, '2019-04-02', 386, NULL),
('Cute Mountains Inn', 63, '2019-04-03', 107, NULL),
('Cute Mountains Inn', 63, '2019-04-04', 196, NULL),
('Cute Mountains Inn', 63, '2019-04-05', 242, NULL),
('Cute Mountains Inn', 63, '2019-04-06', 284, NULL),
('Cute Mountains Inn', 63, '2019-04-07', 399, NULL),
('Cute Mountains Inn', 63, '2019-04-08', 177, NULL),
('Cute Mountains Inn', 63, '2019-04-09', 134, NULL),
('Cute Mountains Inn', 63, '2019-04-10', 150, NULL),
('Cute Mountains Inn', 63, '2019-04-11', 291, NULL),
('Cute Mountains Inn', 63, '2019-04-12', 217, NULL),
('Cute Mountains Inn', 63, '2019-04-13', 133, NULL),
('Cute Mountains Inn', 63, '2019-04-14', 240, NULL),
('Cute Mountains Inn', 63, '2019-04-15', 215, NULL),
('Cute Mountains Inn', 63, '2019-04-16', 246, NULL),
('Cute Mountains Inn', 63, '2019-04-17', 300, NULL),
('Cute Mountains Inn', 63, '2019-04-18', 125, NULL),
('Cute Mountains Inn', 63, '2019-04-19', 187, NULL),
('Cute Mountains Inn', 63, '2019-04-20', 287, NULL),
('Cute Mountains Inn', 63, '2019-04-21', 251, NULL),
('Cute Mountains Inn', 63, '2019-04-22', 388, NULL),
('Cute Mountains Inn', 63, '2019-04-23', 154, NULL),
('Cute Mountains Inn', 63, '2019-04-24', 374, NULL),
('Cute Mountains Inn', 63, '2019-04-25', 298, NULL),
('Cute Mountains Inn', 63, '2019-04-26', 342, NULL),
('Cute Mountains Inn', 63, '2019-04-27', 175, NULL),
('Cute Mountains Inn', 63, '2019-04-28', 118, NULL),
('Cute Mountains Inn', 63, '2019-04-29', 309, NULL),
('Cute Mountains Inn', 63, '2019-04-30', 376, NULL),
('Cute Mountains Inn', 63, '2019-05-01', 293, NULL),
('Cute Mountains Inn', 63, '2019-05-02', 141, NULL),
('Cute Mountains Inn', 63, '2019-05-03', 309, NULL),
('Cute Mountains Inn', 63, '2019-05-04', 324, NULL),
('Cute Mountains Inn', 63, '2019-05-05', 159, NULL),
('Cute Mountains Inn', 63, '2019-05-06', 152, NULL),
('Cute Mountains Inn', 63, '2019-05-07', 398, NULL),
('Cute Mountains Inn', 63, '2019-05-08', 282, NULL),
('Cute Mountains Inn', 63, '2019-05-09', 127, NULL),
('Cute Mountains Inn', 63, '2019-05-10', 311, NULL),
('Cute Mountains Inn', 63, '2019-05-11', 272, NULL),
('Cute Mountains Inn', 63, '2019-05-12', 206, NULL),
('Cute Mountains Inn', 63, '2019-05-13', 225, NULL),
('Cute Mountains Inn', 63, '2019-05-14', 332, NULL),
('Cute Mountains Inn', 63, '2019-05-15', 243, NULL),
('Cute Mountains Inn', 63, '2019-05-16', 388, NULL),
('Cute Mountains Inn', 63, '2019-05-17', 225, NULL),
('Cute Mountains Inn', 63, '2019-05-18', 339, NULL),
('Cute Mountains Inn', 63, '2019-05-19', 252, NULL),
('Cute Mountains Inn', 63, '2019-05-20', 367, NULL),
('Cute Mountains Inn', 63, '2019-05-21', 370, NULL),
('Cute Mountains Inn', 63, '2019-05-22', 242, NULL),
('Cute Mountains Inn', 63, '2019-05-23', 295, NULL),
('Cute Mountains Inn', 63, '2019-05-24', 395, NULL),
('Cute Mountains Inn', 63, '2019-05-25', 230, NULL),
('Cute Mountains Inn', 63, '2019-05-26', 114, NULL),
('Cute Mountains Inn', 63, '2019-05-27', 160, NULL),
('Cute Mountains Inn', 63, '2019-05-28', 236, NULL),
('Cute Mountains Inn', 63, '2019-05-29', 193, NULL),
('Cute Mountains Inn', 63, '2019-05-30', 125, NULL),
('Cute Mountains Inn', 63, '2019-05-31', 180, NULL),
('Cute Mountains Inn', 63, '2019-06-01', 197, NULL),
('Cute Mountains Inn', 63, '2019-06-02', 354, NULL),
('Cute Mountains Inn', 63, '2019-06-03', 174, NULL),
('Cute Mountains Inn', 63, '2019-06-04', 296, NULL),
('Cute Mountains Inn', 63, '2019-06-05', 383, NULL),
('Cute Mountains Inn', 63, '2019-06-06', 221, NULL),
('Cute Mountains Inn', 63, '2019-06-07', 175, NULL),
('Cute Mountains Inn', 63, '2019-06-08', 106, NULL),
('Cute Mountains Inn', 63, '2019-06-09', 244, NULL),
('Cute Mountains Inn', 63, '2019-06-10', 145, NULL),
('Cute Mountains Inn', 63, '2019-06-11', 257, NULL),
('Cute Mountains Inn', 63, '2019-06-12', 324, NULL),
('Cute Mountains Inn', 63, '2019-06-13', 143, NULL),
('Cute Mountains Inn', 63, '2019-06-14', 309, NULL),
('Cute Mountains Inn', 63, '2019-06-15', 206, NULL),
('Cute Mountains Inn', 63, '2019-06-16', 146, NULL),
('Cute Mountains Inn', 63, '2019-06-17', 354, NULL),
('Cute Mountains Inn', 63, '2019-06-18', 253, NULL),
('Cute Mountains Inn', 63, '2019-06-19', 148, NULL),
('Cute Mountains Inn', 63, '2019-06-20', 265, NULL),
('Cute Mountains Inn', 63, '2019-06-21', 150, NULL),
('Cute Mountains Inn', 63, '2019-06-22', 298, NULL),
('Cute Mountains Inn', 63, '2019-06-23', 237, NULL),
('Cute Mountains Inn', 63, '2019-06-24', 114, NULL),
('Cute Mountains Inn', 63, '2019-06-25', 206, NULL),
('Cute Mountains Inn', 63, '2019-06-26', 233, NULL),
('Cute Mountains Inn', 63, '2019-06-27', 338, NULL),
('Cute Mountains Inn', 63, '2019-06-28', 367, NULL),
('Cute Mountains Inn', 63, '2019-06-29', 381, NULL),
('Cute Mountains Inn', 63, '2019-06-30', 200, NULL),
('Cute Mountains Inn', 63, '2019-07-01', 304, NULL),
('Cute Mountains Inn', 63, '2019-07-02', 164, NULL),
('Cute Mountains Inn', 63, '2019-07-03', 282, NULL),
('Cute Mountains Inn', 63, '2019-07-04', 155, NULL),
('Cute Mountains Inn', 63, '2019-07-05', 186, NULL),
('Cute Mountains Inn', 63, '2019-07-06', 161, NULL),
('Cute Mountains Inn', 63, '2019-07-07', 307, NULL),
('Cute Mountains Inn', 63, '2019-07-08', 333, NULL),
('Cute Mountains Inn', 63, '2019-07-09', 344, NULL),
('Cute Mountains Inn', 63, '2019-07-10', 146, NULL),
('Cute Mountains Inn', 63, '2019-07-11', 128, NULL),
('Cute Mountains Inn', 63, '2019-07-12', 178, NULL),
('Cute Mountains Inn', 63, '2019-07-13', 159, NULL),
('Cute Mountains Inn', 63, '2019-07-14', 232, NULL),
('Cute Mountains Inn', 63, '2019-07-15', 165, NULL),
('Cute Mountains Inn', 63, '2019-07-16', 291, NULL),
('Cute Mountains Inn', 63, '2019-07-17', 111, NULL),
('Cute Mountains Inn', 63, '2019-07-18', 135, NULL),
('Cute Mountains Inn', 63, '2019-07-19', 182, NULL),
('Cute Mountains Inn', 63, '2019-07-20', 234, NULL),
('Cute Mountains Inn', 63, '2019-07-21', 275, NULL),
('Cute Mountains Inn', 63, '2019-07-22', 326, NULL),
('Cute Mountains Inn', 63, '2019-07-23', 242, NULL),
('Cute Mountains Inn', 63, '2019-07-24', 125, NULL),
('Cute Mountains Inn', 63, '2019-07-25', 118, NULL),
('Cute Mountains Inn', 63, '2019-07-26', 119, NULL),
('Cute Mountains Inn', 63, '2019-07-27', 216, NULL),
('Cute Mountains Inn', 63, '2019-07-28', 348, NULL),
('Cute Mountains Inn', 63, '2019-07-29', 110, NULL),
('Cute Mountains Inn', 63, '2019-07-30', 382, NULL),
('Cute Mountains Inn', 63, '2019-07-31', 118, NULL),
('Cute Mountains Inn', 63, '2019-08-01', 232, NULL),
('Cute Mountains Inn', 63, '2019-08-02', 137, NULL),
('Cute Mountains Inn', 63, '2019-08-03', 320, NULL),
('Cute Mountains Inn', 63, '2019-08-04', 228, NULL),
('Cute Mountains Inn', 63, '2019-08-05', 236, NULL),
('Cute Mountains Inn', 63, '2019-08-06', 319, NULL),
('Cute Mountains Inn', 63, '2019-08-07', 389, NULL),
('Cute Mountains Inn', 63, '2019-08-08', 165, NULL),
('Cute Mountains Inn', 63, '2019-08-09', 281, NULL),
('Cute Mountains Inn', 63, '2019-08-10', 116, NULL),
('Cute Mountains Inn', 63, '2019-08-11', 138, NULL),
('Cute Mountains Inn', 63, '2019-08-12', 101, NULL),
('Cute Mountains Inn', 63, '2019-08-13', 398, NULL),
('Cute Mountains Inn', 63, '2019-08-14', 398, NULL),
('Cute Mountains Inn', 63, '2019-08-15', 193, NULL),
('Cute Mountains Inn', 63, '2019-08-16', 376, NULL),
('Cute Mountains Inn', 63, '2019-08-17', 169, NULL),
('Cute Mountains Inn', 63, '2019-08-18', 163, NULL),
('Cute Mountains Inn', 63, '2019-08-19', 388, NULL),
('Cute Mountains Inn', 63, '2019-08-20', 283, NULL),
('Cute Mountains Inn', 63, '2019-08-21', 216, NULL),
('Cute Mountains Inn', 63, '2019-08-22', 306, NULL),
('Cute Mountains Inn', 63, '2019-08-23', 128, NULL),
('Cute Mountains Inn', 63, '2019-08-24', 295, NULL),
('Cute Mountains Inn', 63, '2019-08-25', 398, NULL),
('Cute Mountains Inn', 63, '2019-08-26', 248, NULL),
('Cute Mountains Inn', 63, '2019-08-27', 162, NULL),
('Cute Mountains Inn', 63, '2019-08-28', 100, NULL),
('Cute Mountains Inn', 63, '2019-08-29', 303, NULL),
('Cute Mountains Inn', 63, '2019-08-30', 313, NULL),
('Cute Mountains Inn', 63, '2019-08-31', 115, NULL),
('Cute Mountains Inn', 63, '2019-09-01', 236, NULL),
('Cute Mountains Inn', 63, '2019-09-02', 111, NULL),
('Cute Mountains Inn', 63, '2019-09-03', 147, NULL),
('Cute Mountains Inn', 63, '2019-09-04', 319, NULL),
('Cute Mountains Inn', 63, '2019-09-05', 383, NULL),
('Cute Mountains Inn', 63, '2019-09-06', 144, NULL),
('Cute Mountains Inn', 63, '2019-09-07', 347, NULL),
('Cute Mountains Inn', 63, '2019-09-08', 112, NULL),
('Cute Mountains Inn', 63, '2019-09-09', 358, NULL),
('Cute Mountains Inn', 63, '2019-09-10', 151, NULL),
('Cute Mountains Inn', 63, '2019-09-11', 293, NULL),
('Cute Mountains Inn', 63, '2019-09-12', 368, NULL),
('Cute Mountains Inn', 63, '2019-09-13', 384, NULL),
('Cute Mountains Inn', 63, '2019-09-14', 140, NULL),
('Cute Mountains Inn', 63, '2019-09-15', 316, NULL),
('Cute Mountains Inn', 63, '2019-09-16', 155, NULL),
('Cute Mountains Inn', 63, '2019-09-17', 224, NULL),
('Cute Mountains Inn', 63, '2019-09-18', 204, NULL),
('Cute Mountains Inn', 63, '2019-09-19', 150, NULL),
('Cute Mountains Inn', 63, '2019-09-20', 290, NULL),
('Cute Mountains Inn', 63, '2019-09-21', 188, NULL),
('Cute Mountains Inn', 63, '2019-09-22', 306, NULL),
('Cute Mountains Inn', 63, '2019-09-23', 168, NULL),
('Cute Mountains Inn', 63, '2019-09-24', 294, NULL),
('Cute Mountains Inn', 63, '2019-09-25', 292, NULL),
('Cute Mountains Inn', 63, '2019-09-26', 153, NULL),
('Cute Mountains Inn', 63, '2019-09-27', 331, NULL),
('Cute Mountains Inn', 63, '2019-09-28', 244, NULL),
('Cute Mountains Inn', 63, '2019-09-29', 143, NULL),
('Cute Mountains Inn', 63, '2019-09-30', 338, NULL),
('Cute Mountains Inn', 63, '2019-10-01', 248, NULL),
('Cute Mountains Inn', 63, '2019-10-02', 380, NULL),
('Cute Mountains Inn', 63, '2019-10-03', 363, NULL),
('Cute Mountains Inn', 63, '2019-10-04', 186, NULL),
('Cute Mountains Inn', 63, '2019-10-05', 143, NULL),
('Cute Mountains Inn', 63, '2019-10-06', 378, NULL),
('Cute Mountains Inn', 63, '2019-10-07', 385, NULL),
('Cute Mountains Inn', 63, '2019-10-08', 371, NULL),
('Cute Mountains Inn', 63, '2019-10-09', 358, NULL),
('Cute Mountains Inn', 63, '2019-10-10', 133, NULL),
('Cute Mountains Inn', 63, '2019-10-11', 266, NULL),
('Cute Mountains Inn', 63, '2019-10-12', 257, NULL),
('Cute Mountains Inn', 63, '2019-10-13', 141, NULL),
('Cute Mountains Inn', 63, '2019-10-14', 308, NULL),
('Cute Mountains Inn', 63, '2019-10-15', 310, NULL),
('Cute Mountains Inn', 63, '2019-10-16', 352, NULL),
('Cute Mountains Inn', 63, '2019-10-17', 341, NULL),
('Cute Mountains Inn', 63, '2019-10-18', 198, NULL),
('Cute Mountains Inn', 63, '2019-10-19', 256, NULL),
('Cute Mountains Inn', 63, '2019-10-20', 205, NULL),
('Cute Mountains Inn', 63, '2019-10-21', 125, NULL),
('Cute Mountains Inn', 63, '2019-10-22', 300, NULL),
('Cute Mountains Inn', 63, '2019-10-23', 237, NULL),
('Cute Mountains Inn', 63, '2019-10-24', 303, NULL),
('Cute Mountains Inn', 63, '2019-10-25', 216, NULL),
('Cute Mountains Inn', 63, '2019-10-26', 250, NULL),
('Cute Mountains Inn', 63, '2019-10-27', 277, NULL),
('Cute Mountains Inn', 63, '2019-10-28', 127, NULL),
('Cute Mountains Inn', 63, '2019-10-29', 223, NULL),
('Cute Mountains Inn', 63, '2019-10-30', 104, NULL),
('Cute Mountains Inn', 63, '2019-10-31', 212, NULL),
('Cute Mountains Inn', 63, '2019-11-01', 270, NULL),
('Cute Mountains Inn', 63, '2019-11-02', 309, NULL),
('Cute Mountains Inn', 63, '2019-11-03', 197, NULL),
('Cute Mountains Inn', 63, '2019-11-04', 275, NULL),
('Cute Mountains Inn', 63, '2019-11-05', 398, NULL),
('Cute Mountains Inn', 63, '2019-11-06', 367, NULL),
('Cute Mountains Inn', 63, '2019-11-07', 373, NULL),
('Cute Mountains Inn', 63, '2019-11-08', 119, NULL),
('Cute Mountains Inn', 63, '2019-11-09', 368, NULL),
('Cute Mountains Inn', 63, '2019-11-10', 337, NULL),
('Cute Mountains Inn', 63, '2019-11-11', 390, NULL),
('Cute Mountains Inn', 63, '2019-11-12', 286, NULL),
('Cute Mountains Inn', 63, '2019-11-13', 208, NULL),
('Cute Mountains Inn', 63, '2019-11-14', 268, NULL),
('Cute Mountains Inn', 63, '2019-11-15', 234, NULL),
('Cute Mountains Inn', 63, '2019-11-16', 115, NULL),
('Cute Mountains Inn', 63, '2019-11-17', 116, NULL),
('Cute Mountains Inn', 63, '2019-11-18', 189, NULL),
('Cute Mountains Inn', 63, '2019-11-19', 188, NULL),
('Cute Mountains Inn', 63, '2019-11-20', 102, NULL),
('Cute Mountains Inn', 63, '2019-11-21', 367, NULL),
('Cute Mountains Inn', 63, '2019-11-22', 395, NULL),
('Cute Mountains Inn', 63, '2019-11-23', 156, NULL),
('Cute Mountains Inn', 63, '2019-11-24', 330, NULL),
('Cute Mountains Inn', 63, '2019-11-25', 284, NULL),
('Cute Mountains Inn', 63, '2019-11-26', 133, NULL),
('Cute Mountains Inn', 63, '2019-11-27', 282, NULL),
('Cute Mountains Inn', 63, '2019-11-28', 236, NULL),
('Cute Mountains Inn', 63, '2019-11-29', 155, NULL),
('Cute Mountains Inn', 63, '2019-11-30', 283, NULL),
('Cute Mountains Inn', 63, '2019-12-01', 262, NULL),
('Cute Mountains Inn', 63, '2019-12-02', 318, NULL),
('Cute Mountains Inn', 63, '2019-12-03', 125, NULL),
('Cute Mountains Inn', 63, '2019-12-04', 352, NULL),
('Cute Mountains Inn', 63, '2019-12-05', 339, NULL),
('Cute Mountains Inn', 63, '2019-12-06', 198, NULL),
('Cute Mountains Inn', 63, '2019-12-07', 304, NULL),
('Cute Mountains Inn', 63, '2019-12-08', 106, NULL),
('Cute Mountains Inn', 63, '2019-12-09', 111, NULL),
('Cute Mountains Inn', 63, '2019-12-10', 212, NULL),
('Cute Mountains Inn', 63, '2019-12-11', 201, NULL),
('Cute Mountains Inn', 63, '2019-12-12', 371, NULL),
('Cute Mountains Inn', 63, '2019-12-13', 313, NULL),
('Cute Mountains Inn', 63, '2019-12-14', 206, NULL),
('Cute Mountains Inn', 63, '2019-12-15', 180, NULL),
('Cute Mountains Inn', 63, '2019-12-16', 248, NULL),
('Cute Mountains Inn', 63, '2019-12-17', 148, NULL),
('Cute Mountains Inn', 63, '2019-12-18', 133, NULL),
('Cute Mountains Inn', 63, '2019-12-19', 277, NULL),
('Cute Mountains Inn', 63, '2019-12-20', 208, NULL),
('Cute Mountains Inn', 63, '2019-12-21', 137, NULL),
('Cute Mountains Inn', 63, '2019-12-22', 280, NULL),
('Cute Mountains Inn', 63, '2019-12-23', 113, NULL),
('Cute Mountains Inn', 63, '2019-12-24', 117, NULL),
('Cute Mountains Inn', 63, '2019-12-25', 244, NULL),
('Cute Mountains Inn', 63, '2019-12-26', 230, NULL),
('Cute Mountains Inn', 63, '2019-12-27', 147, NULL),
('Cute Mountains Inn', 63, '2019-12-28', 181, NULL),
('Cute Mountains Inn', 63, '2019-12-29', 262, NULL),
('Cute Mountains Inn', 63, '2019-12-30', 285, NULL),
('Cute Mountains Inn', 63, '2019-12-31', 242, NULL),
('Cute Mountains Inn', 63, '2020-01-01', 367, NULL),
('Cute Mountains Inn', 63, '2020-01-02', 318, NULL),
('Cute Mountains Inn', 63, '2020-01-03', 121, NULL),
('Cute Mountains Inn', 63, '2020-01-04', 259, NULL),
('Cute Mountains Inn', 63, '2020-01-05', 194, NULL),
('Cute Mountains Inn', 63, '2020-01-06', 131, NULL),
('Cute Mountains Inn', 63, '2020-01-07', 166, NULL),
('Cute Mountains Inn', 63, '2020-01-08', 182, NULL),
('Cute Mountains Inn', 63, '2020-01-09', 371, NULL),
('Cute Mountains Inn', 63, '2020-01-10', 295, NULL),
('Cute Mountains Inn', 63, '2020-01-11', 166, NULL),
('Cute Mountains Inn', 63, '2020-01-12', 145, NULL),
('Cute Mountains Inn', 63, '2020-01-13', 159, NULL),
('Cute Mountains Inn', 63, '2020-01-14', 189, NULL),
('Cute Mountains Inn', 63, '2020-01-15', 252, NULL),
('Cute Mountains Inn', 63, '2020-01-16', 355, NULL),
('Cute Mountains Inn', 63, '2020-01-17', 225, NULL),
('Cute Mountains Inn', 63, '2020-01-18', 294, NULL),
('Cute Mountains Inn', 63, '2020-01-19', 220, NULL),
('Cute Mountains Inn', 63, '2020-01-20', 144, NULL),
('Cute Mountains Inn', 63, '2020-01-21', 377, NULL),
('Cute Mountains Inn', 63, '2020-01-22', 229, NULL),
('Cute Mountains Inn', 63, '2020-01-23', 324, NULL),
('Cute Mountains Inn', 63, '2020-01-24', 340, NULL),
('Cute Mountains Inn', 63, '2020-01-25', 190, NULL),
('Cute Mountains Inn', 63, '2020-01-26', 118, NULL),
('Cute Mountains Inn', 63, '2020-01-27', 313, NULL),
('Cute Mountains Inn', 63, '2020-01-28', 213, NULL),
('Cute Mountains Inn', 63, '2020-01-29', 123, NULL),
('Cute Mountains Inn', 63, '2020-01-30', 396, NULL),
('Cute Mountains Inn', 63, '2020-01-31', 379, NULL),
('Cute Mountains Inn', 63, '2020-02-01', 107, NULL),
('Cute Mountains Inn', 63, '2020-02-02', 220, NULL),
('Cute Mountains Inn', 63, '2020-02-03', 214, NULL),
('Cute Mountains Inn', 63, '2020-02-04', 235, NULL),
('Cute Mountains Inn', 69, '2019-01-01', 313, NULL),
('Cute Mountains Inn', 69, '2019-01-02', 236, NULL),
('Cute Mountains Inn', 69, '2019-01-03', 238, NULL),
('Cute Mountains Inn', 69, '2019-01-04', 105, NULL),
('Cute Mountains Inn', 69, '2019-01-05', 343, NULL),
('Cute Mountains Inn', 69, '2019-01-06', 192, NULL),
('Cute Mountains Inn', 69, '2019-01-07', 113, NULL),
('Cute Mountains Inn', 69, '2019-01-08', 241, NULL),
('Cute Mountains Inn', 69, '2019-01-09', 313, NULL),
('Cute Mountains Inn', 69, '2019-01-10', 376, NULL),
('Cute Mountains Inn', 69, '2019-01-11', 240, NULL),
('Cute Mountains Inn', 69, '2019-01-12', 220, NULL),
('Cute Mountains Inn', 69, '2019-01-13', 243, NULL),
('Cute Mountains Inn', 69, '2019-01-14', 278, NULL),
('Cute Mountains Inn', 69, '2019-01-15', 371, NULL),
('Cute Mountains Inn', 69, '2019-01-16', 366, NULL),
('Cute Mountains Inn', 69, '2019-01-17', 109, NULL),
('Cute Mountains Inn', 69, '2019-01-18', 193, NULL),
('Cute Mountains Inn', 69, '2019-01-19', 382, NULL),
('Cute Mountains Inn', 69, '2019-01-20', 128, NULL),
('Cute Mountains Inn', 69, '2019-01-21', 311, NULL),
('Cute Mountains Inn', 69, '2019-01-22', 132, NULL),
('Cute Mountains Inn', 69, '2019-01-23', 154, NULL),
('Cute Mountains Inn', 69, '2019-01-24', 187, NULL),
('Cute Mountains Inn', 69, '2019-01-25', 124, NULL),
('Cute Mountains Inn', 69, '2019-01-26', 310, NULL),
('Cute Mountains Inn', 69, '2019-01-27', 354, NULL),
('Cute Mountains Inn', 69, '2019-01-28', 313, NULL),
('Cute Mountains Inn', 69, '2019-01-29', 219, NULL),
('Cute Mountains Inn', 69, '2019-01-30', 309, NULL),
('Cute Mountains Inn', 69, '2019-01-31', 337, NULL),
('Cute Mountains Inn', 69, '2019-02-01', 216, NULL),
('Cute Mountains Inn', 69, '2019-02-02', 286, NULL),
('Cute Mountains Inn', 69, '2019-02-03', 246, NULL),
('Cute Mountains Inn', 69, '2019-02-04', 397, NULL),
('Cute Mountains Inn', 69, '2019-02-05', 362, NULL),
('Cute Mountains Inn', 69, '2019-02-06', 143, NULL),
('Cute Mountains Inn', 69, '2019-02-07', 287, NULL),
('Cute Mountains Inn', 69, '2019-02-08', 338, NULL),
('Cute Mountains Inn', 69, '2019-02-09', 332, NULL),
('Cute Mountains Inn', 69, '2019-02-10', 185, NULL),
('Cute Mountains Inn', 69, '2019-02-11', 276, NULL),
('Cute Mountains Inn', 69, '2019-02-12', 148, NULL),
('Cute Mountains Inn', 69, '2019-02-13', 326, NULL),
('Cute Mountains Inn', 69, '2019-02-14', 122, NULL),
('Cute Mountains Inn', 69, '2019-02-15', 282, NULL),
('Cute Mountains Inn', 69, '2019-02-16', 199, NULL),
('Cute Mountains Inn', 69, '2019-02-17', 181, NULL),
('Cute Mountains Inn', 69, '2019-02-18', 302, NULL),
('Cute Mountains Inn', 69, '2019-02-19', 226, NULL),
('Cute Mountains Inn', 69, '2019-02-20', 275, NULL),
('Cute Mountains Inn', 69, '2019-02-21', 238, NULL),
('Cute Mountains Inn', 69, '2019-02-22', 244, NULL),
('Cute Mountains Inn', 69, '2019-02-23', 134, NULL),
('Cute Mountains Inn', 69, '2019-02-24', 182, NULL),
('Cute Mountains Inn', 69, '2019-02-25', 391, NULL),
('Cute Mountains Inn', 69, '2019-02-26', 383, NULL),
('Cute Mountains Inn', 69, '2019-02-27', 181, NULL),
('Cute Mountains Inn', 69, '2019-02-28', 384, NULL),
('Cute Mountains Inn', 69, '2019-03-01', 285, NULL),
('Cute Mountains Inn', 69, '2019-03-02', 178, NULL),
('Cute Mountains Inn', 69, '2019-03-03', 124, NULL),
('Cute Mountains Inn', 69, '2019-03-04', 216, NULL),
('Cute Mountains Inn', 69, '2019-03-05', 185, NULL),
('Cute Mountains Inn', 69, '2019-03-06', 383, NULL),
('Cute Mountains Inn', 69, '2019-03-07', 231, NULL),
('Cute Mountains Inn', 69, '2019-03-08', 303, NULL),
('Cute Mountains Inn', 69, '2019-03-09', 168, NULL),
('Cute Mountains Inn', 69, '2019-03-10', 317, NULL),
('Cute Mountains Inn', 69, '2019-03-11', 226, NULL),
('Cute Mountains Inn', 69, '2019-03-12', 341, NULL),
('Cute Mountains Inn', 69, '2019-03-13', 226, NULL),
('Cute Mountains Inn', 69, '2019-03-14', 372, NULL),
('Cute Mountains Inn', 69, '2019-03-15', 194, NULL),
('Cute Mountains Inn', 69, '2019-03-16', 373, NULL),
('Cute Mountains Inn', 69, '2019-03-17', 216, NULL),
('Cute Mountains Inn', 69, '2019-03-18', 223, NULL),
('Cute Mountains Inn', 69, '2019-03-19', 354, NULL),
('Cute Mountains Inn', 69, '2019-03-20', 104, NULL),
('Cute Mountains Inn', 69, '2019-03-21', 204, NULL),
('Cute Mountains Inn', 69, '2019-03-22', 122, NULL),
('Cute Mountains Inn', 69, '2019-03-23', 236, NULL),
('Cute Mountains Inn', 69, '2019-03-24', 263, NULL),
('Cute Mountains Inn', 69, '2019-03-25', 296, NULL),
('Cute Mountains Inn', 69, '2019-03-26', 349, NULL),
('Cute Mountains Inn', 69, '2019-03-27', 239, NULL),
('Cute Mountains Inn', 69, '2019-03-28', 331, NULL),
('Cute Mountains Inn', 69, '2019-03-29', 215, NULL),
('Cute Mountains Inn', 69, '2019-03-30', 216, NULL),
('Cute Mountains Inn', 69, '2019-03-31', 178, NULL),
('Cute Mountains Inn', 69, '2019-04-01', 370, NULL),
('Cute Mountains Inn', 69, '2019-04-02', 318, NULL),
('Cute Mountains Inn', 69, '2019-04-03', 201, NULL),
('Cute Mountains Inn', 69, '2019-04-04', 326, NULL),
('Cute Mountains Inn', 69, '2019-04-05', 364, NULL),
('Cute Mountains Inn', 69, '2019-04-06', 299, NULL),
('Cute Mountains Inn', 69, '2019-04-07', 214, NULL),
('Cute Mountains Inn', 69, '2019-04-08', 180, NULL),
('Cute Mountains Inn', 69, '2019-04-09', 152, NULL),
('Cute Mountains Inn', 69, '2019-04-10', 230, NULL),
('Cute Mountains Inn', 69, '2019-04-11', 211, NULL),
('Cute Mountains Inn', 69, '2019-04-12', 322, NULL),
('Cute Mountains Inn', 69, '2019-04-13', 335, NULL),
('Cute Mountains Inn', 69, '2019-04-14', 206, NULL),
('Cute Mountains Inn', 69, '2019-04-15', 353, NULL),
('Cute Mountains Inn', 69, '2019-04-16', 176, NULL),
('Cute Mountains Inn', 69, '2019-04-17', 103, NULL),
('Cute Mountains Inn', 69, '2019-04-18', 184, NULL),
('Cute Mountains Inn', 69, '2019-04-19', 266, NULL),
('Cute Mountains Inn', 69, '2019-04-20', 350, NULL),
('Cute Mountains Inn', 69, '2019-04-21', 177, NULL),
('Cute Mountains Inn', 69, '2019-04-22', 308, NULL),
('Cute Mountains Inn', 69, '2019-04-23', 223, NULL),
('Cute Mountains Inn', 69, '2019-04-24', 299, NULL),
('Cute Mountains Inn', 69, '2019-04-25', 193, NULL),
('Cute Mountains Inn', 69, '2019-04-26', 384, NULL),
('Cute Mountains Inn', 69, '2019-04-27', 232, NULL),
('Cute Mountains Inn', 69, '2019-04-28', 356, NULL),
('Cute Mountains Inn', 69, '2019-04-29', 169, NULL),
('Cute Mountains Inn', 69, '2019-04-30', 378, NULL),
('Cute Mountains Inn', 69, '2019-05-01', 177, NULL),
('Cute Mountains Inn', 69, '2019-05-02', 135, NULL),
('Cute Mountains Inn', 69, '2019-05-03', 141, NULL),
('Cute Mountains Inn', 69, '2019-05-04', 285, NULL),
('Cute Mountains Inn', 69, '2019-05-05', 173, NULL),
('Cute Mountains Inn', 69, '2019-05-06', 363, NULL),
('Cute Mountains Inn', 69, '2019-05-07', 272, NULL),
('Cute Mountains Inn', 69, '2019-05-08', 109, NULL),
('Cute Mountains Inn', 69, '2019-05-09', 398, NULL),
('Cute Mountains Inn', 69, '2019-05-10', 237, NULL),
('Cute Mountains Inn', 69, '2019-05-11', 278, NULL),
('Cute Mountains Inn', 69, '2019-05-12', 357, NULL),
('Cute Mountains Inn', 69, '2019-05-13', 267, NULL),
('Cute Mountains Inn', 69, '2019-05-14', 276, NULL),
('Cute Mountains Inn', 69, '2019-05-15', 209, NULL),
('Cute Mountains Inn', 69, '2019-05-16', 124, NULL),
('Cute Mountains Inn', 69, '2019-05-17', 195, NULL),
('Cute Mountains Inn', 69, '2019-05-18', 360, NULL),
('Cute Mountains Inn', 69, '2019-05-19', 272, NULL),
('Cute Mountains Inn', 69, '2019-05-20', 350, NULL),
('Cute Mountains Inn', 69, '2019-05-21', 202, NULL),
('Cute Mountains Inn', 69, '2019-05-22', 349, NULL),
('Cute Mountains Inn', 69, '2019-05-23', 379, NULL),
('Cute Mountains Inn', 69, '2019-05-24', 135, NULL),
('Cute Mountains Inn', 69, '2019-05-25', 159, NULL),
('Cute Mountains Inn', 69, '2019-05-26', 148, NULL),
('Cute Mountains Inn', 69, '2019-05-27', 341, NULL),
('Cute Mountains Inn', 69, '2019-05-28', 246, NULL),
('Cute Mountains Inn', 69, '2019-05-29', 344, NULL),
('Cute Mountains Inn', 69, '2019-05-30', 299, NULL),
('Cute Mountains Inn', 69, '2019-05-31', 384, NULL),
('Cute Mountains Inn', 69, '2019-06-01', 188, NULL),
('Cute Mountains Inn', 69, '2019-06-02', 246, NULL),
('Cute Mountains Inn', 69, '2019-06-03', 290, NULL),
('Cute Mountains Inn', 69, '2019-06-04', 100, NULL),
('Cute Mountains Inn', 69, '2019-06-05', 280, NULL),
('Cute Mountains Inn', 69, '2019-06-06', 358, NULL),
('Cute Mountains Inn', 69, '2019-06-07', 189, NULL),
('Cute Mountains Inn', 69, '2019-06-08', 250, NULL),
('Cute Mountains Inn', 69, '2019-06-09', 374, NULL),
('Cute Mountains Inn', 69, '2019-06-10', 254, NULL),
('Cute Mountains Inn', 69, '2019-06-11', 269, NULL),
('Cute Mountains Inn', 69, '2019-06-12', 374, NULL),
('Cute Mountains Inn', 69, '2019-06-13', 341, NULL),
('Cute Mountains Inn', 69, '2019-06-14', 108, NULL),
('Cute Mountains Inn', 69, '2019-06-15', 125, NULL),
('Cute Mountains Inn', 69, '2019-06-16', 197, NULL),
('Cute Mountains Inn', 69, '2019-06-17', 297, NULL),
('Cute Mountains Inn', 69, '2019-06-18', 204, NULL),
('Cute Mountains Inn', 69, '2019-06-19', 215, NULL),
('Cute Mountains Inn', 69, '2019-06-20', 313, NULL),
('Cute Mountains Inn', 69, '2019-06-21', 318, NULL),
('Cute Mountains Inn', 69, '2019-06-22', 213, NULL),
('Cute Mountains Inn', 69, '2019-06-23', 100, NULL),
('Cute Mountains Inn', 69, '2019-06-24', 388, NULL),
('Cute Mountains Inn', 69, '2019-06-25', 395, NULL),
('Cute Mountains Inn', 69, '2019-06-26', 243, NULL),
('Cute Mountains Inn', 69, '2019-06-27', 168, NULL),
('Cute Mountains Inn', 69, '2019-06-28', 345, NULL),
('Cute Mountains Inn', 69, '2019-06-29', 143, NULL),
('Cute Mountains Inn', 69, '2019-06-30', 343, NULL),
('Cute Mountains Inn', 69, '2019-07-01', 224, NULL),
('Cute Mountains Inn', 69, '2019-07-02', 202, NULL),
('Cute Mountains Inn', 69, '2019-07-03', 306, NULL),
('Cute Mountains Inn', 69, '2019-07-04', 302, NULL),
('Cute Mountains Inn', 69, '2019-07-05', 254, NULL),
('Cute Mountains Inn', 69, '2019-07-06', 204, NULL),
('Cute Mountains Inn', 69, '2019-07-07', 388, NULL),
('Cute Mountains Inn', 69, '2019-07-08', 237, NULL),
('Cute Mountains Inn', 69, '2019-07-09', 289, NULL),
('Cute Mountains Inn', 69, '2019-07-10', 189, NULL),
('Cute Mountains Inn', 69, '2019-07-11', 165, NULL),
('Cute Mountains Inn', 69, '2019-07-12', 377, NULL),
('Cute Mountains Inn', 69, '2019-07-13', 225, NULL),
('Cute Mountains Inn', 69, '2019-07-14', 380, NULL),
('Cute Mountains Inn', 69, '2019-07-15', 370, NULL),
('Cute Mountains Inn', 69, '2019-07-16', 383, NULL),
('Cute Mountains Inn', 69, '2019-07-17', 213, NULL),
('Cute Mountains Inn', 69, '2019-07-18', 169, NULL),
('Cute Mountains Inn', 69, '2019-07-19', 359, NULL),
('Cute Mountains Inn', 69, '2019-07-20', 280, NULL),
('Cute Mountains Inn', 69, '2019-07-21', 317, NULL),
('Cute Mountains Inn', 69, '2019-07-22', 195, NULL),
('Cute Mountains Inn', 69, '2019-07-23', 325, NULL),
('Cute Mountains Inn', 69, '2019-07-24', 285, NULL),
('Cute Mountains Inn', 69, '2019-07-25', 116, NULL),
('Cute Mountains Inn', 69, '2019-07-26', 113, NULL),
('Cute Mountains Inn', 69, '2019-07-27', 319, NULL),
('Cute Mountains Inn', 69, '2019-07-28', 264, NULL),
('Cute Mountains Inn', 69, '2019-07-29', 248, NULL),
('Cute Mountains Inn', 69, '2019-07-30', 220, NULL),
('Cute Mountains Inn', 69, '2019-07-31', 383, NULL),
('Cute Mountains Inn', 69, '2019-08-01', 227, NULL),
('Cute Mountains Inn', 69, '2019-08-02', 365, NULL),
('Cute Mountains Inn', 69, '2019-08-03', 372, NULL),
('Cute Mountains Inn', 69, '2019-08-04', 196, NULL),
('Cute Mountains Inn', 69, '2019-08-05', 368, NULL),
('Cute Mountains Inn', 69, '2019-08-06', 322, NULL),
('Cute Mountains Inn', 69, '2019-08-07', 164, NULL),
('Cute Mountains Inn', 69, '2019-08-08', 167, NULL),
('Cute Mountains Inn', 69, '2019-08-09', 175, NULL),
('Cute Mountains Inn', 69, '2019-08-10', 343, NULL),
('Cute Mountains Inn', 69, '2019-08-11', 183, NULL),
('Cute Mountains Inn', 69, '2019-08-12', 266, NULL),
('Cute Mountains Inn', 69, '2019-08-13', 316, NULL),
('Cute Mountains Inn', 69, '2019-08-14', 370, NULL),
('Cute Mountains Inn', 69, '2019-08-15', 252, NULL),
('Cute Mountains Inn', 69, '2019-08-16', 119, NULL),
('Cute Mountains Inn', 69, '2019-08-17', 192, NULL),
('Cute Mountains Inn', 69, '2019-08-18', 137, NULL),
('Cute Mountains Inn', 69, '2019-08-19', 376, NULL),
('Cute Mountains Inn', 69, '2019-08-20', 221, NULL),
('Cute Mountains Inn', 69, '2019-08-21', 386, NULL),
('Cute Mountains Inn', 69, '2019-08-22', 280, NULL),
('Cute Mountains Inn', 69, '2019-08-23', 376, NULL),
('Cute Mountains Inn', 69, '2019-08-24', 237, NULL),
('Cute Mountains Inn', 69, '2019-08-25', 271, NULL),
('Cute Mountains Inn', 69, '2019-08-26', 323, NULL),
('Cute Mountains Inn', 69, '2019-08-27', 122, NULL),
('Cute Mountains Inn', 69, '2019-08-28', 341, NULL),
('Cute Mountains Inn', 69, '2019-08-29', 287, NULL),
('Cute Mountains Inn', 69, '2019-08-30', 168, NULL),
('Cute Mountains Inn', 69, '2019-08-31', 216, NULL),
('Cute Mountains Inn', 69, '2019-09-01', 332, NULL),
('Cute Mountains Inn', 69, '2019-09-02', 269, NULL),
('Cute Mountains Inn', 69, '2019-09-03', 210, NULL),
('Cute Mountains Inn', 69, '2019-09-04', 309, NULL),
('Cute Mountains Inn', 69, '2019-09-05', 161, NULL),
('Cute Mountains Inn', 69, '2019-09-06', 212, NULL),
('Cute Mountains Inn', 69, '2019-09-07', 239, NULL),
('Cute Mountains Inn', 69, '2019-09-08', 344, NULL),
('Cute Mountains Inn', 69, '2019-09-09', 233, NULL),
('Cute Mountains Inn', 69, '2019-09-10', 147, NULL),
('Cute Mountains Inn', 69, '2019-09-11', 177, NULL),
('Cute Mountains Inn', 69, '2019-09-12', 186, NULL),
('Cute Mountains Inn', 69, '2019-09-13', 248, NULL),
('Cute Mountains Inn', 69, '2019-09-14', 237, NULL),
('Cute Mountains Inn', 69, '2019-09-15', 190, NULL),
('Cute Mountains Inn', 69, '2019-09-16', 150, NULL),
('Cute Mountains Inn', 69, '2019-09-17', 252, NULL),
('Cute Mountains Inn', 69, '2019-09-18', 249, NULL),
('Cute Mountains Inn', 69, '2019-09-19', 263, NULL),
('Cute Mountains Inn', 69, '2019-09-20', 350, NULL),
('Cute Mountains Inn', 69, '2019-09-21', 120, NULL),
('Cute Mountains Inn', 69, '2019-09-22', 291, NULL),
('Cute Mountains Inn', 69, '2019-09-23', 107, NULL),
('Cute Mountains Inn', 69, '2019-09-24', 281, NULL),
('Cute Mountains Inn', 69, '2019-09-25', 222, NULL),
('Cute Mountains Inn', 69, '2019-09-26', 341, NULL),
('Cute Mountains Inn', 69, '2019-09-27', 399, NULL),
('Cute Mountains Inn', 69, '2019-09-28', 159, NULL),
('Cute Mountains Inn', 69, '2019-09-29', 302, NULL),
('Cute Mountains Inn', 69, '2019-09-30', 213, NULL),
('Cute Mountains Inn', 69, '2019-10-01', 252, NULL),
('Cute Mountains Inn', 69, '2019-10-02', 287, NULL),
('Cute Mountains Inn', 69, '2019-10-03', 321, NULL),
('Cute Mountains Inn', 69, '2019-10-04', 283, NULL),
('Cute Mountains Inn', 69, '2019-10-05', 203, NULL),
('Cute Mountains Inn', 69, '2019-10-06', 217, NULL),
('Cute Mountains Inn', 69, '2019-10-07', 294, NULL),
('Cute Mountains Inn', 69, '2019-10-08', 225, NULL),
('Cute Mountains Inn', 69, '2019-10-09', 365, NULL),
('Cute Mountains Inn', 69, '2019-10-10', 227, NULL),
('Cute Mountains Inn', 69, '2019-10-11', 312, NULL),
('Cute Mountains Inn', 69, '2019-10-12', 206, NULL),
('Cute Mountains Inn', 69, '2019-10-13', 335, NULL),
('Cute Mountains Inn', 69, '2019-10-14', 206, NULL),
('Cute Mountains Inn', 69, '2019-10-15', 105, NULL),
('Cute Mountains Inn', 69, '2019-10-16', 206, NULL),
('Cute Mountains Inn', 69, '2019-10-17', 275, NULL),
('Cute Mountains Inn', 69, '2019-10-18', 276, NULL),
('Cute Mountains Inn', 69, '2019-10-19', 358, NULL),
('Cute Mountains Inn', 69, '2019-10-20', 225, NULL),
('Cute Mountains Inn', 69, '2019-10-21', 332, NULL),
('Cute Mountains Inn', 69, '2019-10-22', 200, NULL),
('Cute Mountains Inn', 69, '2019-10-23', 114, NULL),
('Cute Mountains Inn', 69, '2019-10-24', 149, NULL),
('Cute Mountains Inn', 69, '2019-10-25', 394, NULL),
('Cute Mountains Inn', 69, '2019-10-26', 331, NULL),
('Cute Mountains Inn', 69, '2019-10-27', 332, NULL),
('Cute Mountains Inn', 69, '2019-10-28', 283, NULL),
('Cute Mountains Inn', 69, '2019-10-29', 218, NULL),
('Cute Mountains Inn', 69, '2019-10-30', 286, NULL),
('Cute Mountains Inn', 69, '2019-10-31', 150, NULL),
('Cute Mountains Inn', 69, '2019-11-01', 164, NULL),
('Cute Mountains Inn', 69, '2019-11-02', 178, NULL),
('Cute Mountains Inn', 69, '2019-11-03', 255, NULL),
('Cute Mountains Inn', 69, '2019-11-04', 394, NULL),
('Cute Mountains Inn', 69, '2019-11-05', 200, NULL),
('Cute Mountains Inn', 69, '2019-11-06', 319, NULL),
('Cute Mountains Inn', 69, '2019-11-07', 392, NULL),
('Cute Mountains Inn', 69, '2019-11-08', 256, NULL),
('Cute Mountains Inn', 69, '2019-11-09', 214, NULL),
('Cute Mountains Inn', 69, '2019-11-10', 263, NULL),
('Cute Mountains Inn', 69, '2019-11-11', 194, NULL),
('Cute Mountains Inn', 69, '2019-11-12', 102, NULL),
('Cute Mountains Inn', 69, '2019-11-13', 234, NULL),
('Cute Mountains Inn', 69, '2019-11-14', 299, NULL),
('Cute Mountains Inn', 69, '2019-11-15', 192, NULL),
('Cute Mountains Inn', 69, '2019-11-16', 364, NULL),
('Cute Mountains Inn', 69, '2019-11-17', 137, NULL),
('Cute Mountains Inn', 69, '2019-11-18', 326, NULL),
('Cute Mountains Inn', 69, '2019-11-19', 395, NULL),
('Cute Mountains Inn', 69, '2019-11-20', 342, NULL),
('Cute Mountains Inn', 69, '2019-11-21', 238, NULL),
('Cute Mountains Inn', 69, '2019-11-22', 245, NULL),
('Cute Mountains Inn', 69, '2019-11-23', 380, NULL),
('Cute Mountains Inn', 69, '2019-11-24', 165, NULL),
('Cute Mountains Inn', 69, '2019-11-25', 258, NULL),
('Cute Mountains Inn', 69, '2019-11-26', 141, NULL),
('Cute Mountains Inn', 69, '2019-11-27', 302, NULL),
('Cute Mountains Inn', 69, '2019-11-28', 122, NULL),
('Cute Mountains Inn', 69, '2019-11-29', 230, NULL),
('Cute Mountains Inn', 69, '2019-11-30', 263, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 69, '2019-12-01', 136, NULL),
('Cute Mountains Inn', 69, '2019-12-02', 200, NULL),
('Cute Mountains Inn', 69, '2019-12-03', 170, NULL),
('Cute Mountains Inn', 69, '2019-12-04', 139, NULL),
('Cute Mountains Inn', 69, '2019-12-05', 157, NULL),
('Cute Mountains Inn', 69, '2019-12-06', 128, NULL),
('Cute Mountains Inn', 69, '2019-12-07', 318, NULL),
('Cute Mountains Inn', 69, '2019-12-08', 311, NULL),
('Cute Mountains Inn', 69, '2019-12-09', 357, NULL),
('Cute Mountains Inn', 69, '2019-12-10', 174, NULL),
('Cute Mountains Inn', 69, '2019-12-11', 279, NULL),
('Cute Mountains Inn', 69, '2019-12-12', 330, NULL),
('Cute Mountains Inn', 69, '2019-12-13', 358, NULL),
('Cute Mountains Inn', 69, '2019-12-14', 285, NULL),
('Cute Mountains Inn', 69, '2019-12-15', 248, NULL),
('Cute Mountains Inn', 69, '2019-12-16', 164, NULL),
('Cute Mountains Inn', 69, '2019-12-17', 310, NULL),
('Cute Mountains Inn', 69, '2019-12-18', 343, NULL),
('Cute Mountains Inn', 69, '2019-12-19', 297, NULL),
('Cute Mountains Inn', 69, '2019-12-20', 372, NULL),
('Cute Mountains Inn', 69, '2019-12-21', 234, NULL),
('Cute Mountains Inn', 69, '2019-12-22', 264, NULL),
('Cute Mountains Inn', 69, '2019-12-23', 220, NULL),
('Cute Mountains Inn', 69, '2019-12-24', 260, NULL),
('Cute Mountains Inn', 69, '2019-12-25', 295, NULL),
('Cute Mountains Inn', 69, '2019-12-26', 305, NULL),
('Cute Mountains Inn', 69, '2019-12-27', 198, NULL),
('Cute Mountains Inn', 69, '2019-12-28', 154, NULL),
('Cute Mountains Inn', 69, '2019-12-29', 232, NULL),
('Cute Mountains Inn', 69, '2019-12-30', 371, NULL),
('Cute Mountains Inn', 69, '2019-12-31', 117, NULL),
('Cute Mountains Inn', 69, '2020-01-01', 378, NULL),
('Cute Mountains Inn', 69, '2020-01-02', 261, NULL),
('Cute Mountains Inn', 69, '2020-01-03', 189, NULL),
('Cute Mountains Inn', 69, '2020-01-04', 378, NULL),
('Cute Mountains Inn', 69, '2020-01-05', 209, NULL),
('Cute Mountains Inn', 69, '2020-01-06', 178, NULL),
('Cute Mountains Inn', 69, '2020-01-07', 117, NULL),
('Cute Mountains Inn', 69, '2020-01-08', 367, NULL),
('Cute Mountains Inn', 69, '2020-01-09', 218, NULL),
('Cute Mountains Inn', 69, '2020-01-10', 344, NULL),
('Cute Mountains Inn', 69, '2020-01-11', 323, NULL),
('Cute Mountains Inn', 69, '2020-01-12', 221, NULL),
('Cute Mountains Inn', 69, '2020-01-13', 164, NULL),
('Cute Mountains Inn', 69, '2020-01-14', 190, NULL),
('Cute Mountains Inn', 69, '2020-01-15', 102, NULL),
('Cute Mountains Inn', 69, '2020-01-16', 363, NULL),
('Cute Mountains Inn', 69, '2020-01-17', 132, NULL),
('Cute Mountains Inn', 69, '2020-01-18', 207, NULL),
('Cute Mountains Inn', 69, '2020-01-19', 214, NULL),
('Cute Mountains Inn', 69, '2020-01-20', 292, NULL),
('Cute Mountains Inn', 69, '2020-01-21', 242, NULL),
('Cute Mountains Inn', 69, '2020-01-22', 298, NULL),
('Cute Mountains Inn', 69, '2020-01-23', 195, NULL),
('Cute Mountains Inn', 69, '2020-01-24', 374, NULL),
('Cute Mountains Inn', 69, '2020-01-25', 165, NULL),
('Cute Mountains Inn', 69, '2020-01-26', 302, NULL),
('Cute Mountains Inn', 69, '2020-01-27', 312, NULL),
('Cute Mountains Inn', 69, '2020-01-28', 359, NULL),
('Cute Mountains Inn', 69, '2020-01-29', 287, NULL),
('Cute Mountains Inn', 69, '2020-01-30', 197, NULL),
('Cute Mountains Inn', 69, '2020-01-31', 129, NULL),
('Cute Mountains Inn', 69, '2020-02-01', 185, NULL),
('Cute Mountains Inn', 69, '2020-02-02', 147, NULL),
('Cute Mountains Inn', 69, '2020-02-03', 150, NULL),
('Cute Mountains Inn', 69, '2020-02-04', 370, NULL),
('Cute Mountains Inn', 77, '2019-01-01', 307, NULL),
('Cute Mountains Inn', 77, '2019-01-02', 381, NULL),
('Cute Mountains Inn', 77, '2019-01-03', 363, NULL),
('Cute Mountains Inn', 77, '2019-01-04', 192, NULL),
('Cute Mountains Inn', 77, '2019-01-05', 158, NULL),
('Cute Mountains Inn', 77, '2019-01-06', 305, NULL),
('Cute Mountains Inn', 77, '2019-01-07', 216, NULL),
('Cute Mountains Inn', 77, '2019-01-08', 278, NULL),
('Cute Mountains Inn', 77, '2019-01-09', 110, NULL),
('Cute Mountains Inn', 77, '2019-01-10', 171, NULL),
('Cute Mountains Inn', 77, '2019-01-11', 292, NULL),
('Cute Mountains Inn', 77, '2019-01-12', 110, NULL),
('Cute Mountains Inn', 77, '2019-01-13', 374, NULL),
('Cute Mountains Inn', 77, '2019-01-14', 112, NULL),
('Cute Mountains Inn', 77, '2019-01-15', 370, NULL),
('Cute Mountains Inn', 77, '2019-01-16', 315, NULL),
('Cute Mountains Inn', 77, '2019-01-17', 289, NULL),
('Cute Mountains Inn', 77, '2019-01-18', 230, NULL),
('Cute Mountains Inn', 77, '2019-01-19', 288, NULL),
('Cute Mountains Inn', 77, '2019-01-20', 315, NULL),
('Cute Mountains Inn', 77, '2019-01-21', 168, NULL),
('Cute Mountains Inn', 77, '2019-01-22', 305, NULL),
('Cute Mountains Inn', 77, '2019-01-23', 334, NULL),
('Cute Mountains Inn', 77, '2019-01-24', 196, NULL),
('Cute Mountains Inn', 77, '2019-01-25', 372, NULL),
('Cute Mountains Inn', 77, '2019-01-26', 262, NULL),
('Cute Mountains Inn', 77, '2019-01-27', 283, NULL),
('Cute Mountains Inn', 77, '2019-01-28', 268, NULL),
('Cute Mountains Inn', 77, '2019-01-29', 119, NULL),
('Cute Mountains Inn', 77, '2019-01-30', 301, NULL),
('Cute Mountains Inn', 77, '2019-01-31', 355, NULL),
('Cute Mountains Inn', 77, '2019-02-01', 259, NULL),
('Cute Mountains Inn', 77, '2019-02-02', 134, NULL),
('Cute Mountains Inn', 77, '2019-02-03', 106, NULL),
('Cute Mountains Inn', 77, '2019-02-04', 277, NULL),
('Cute Mountains Inn', 77, '2019-02-05', 347, NULL),
('Cute Mountains Inn', 77, '2019-02-06', 335, NULL),
('Cute Mountains Inn', 77, '2019-02-07', 249, NULL),
('Cute Mountains Inn', 77, '2019-02-08', 310, NULL),
('Cute Mountains Inn', 77, '2019-02-09', 150, NULL),
('Cute Mountains Inn', 77, '2019-02-10', 264, NULL),
('Cute Mountains Inn', 77, '2019-02-11', 117, NULL),
('Cute Mountains Inn', 77, '2019-02-12', 138, NULL),
('Cute Mountains Inn', 77, '2019-02-13', 105, NULL),
('Cute Mountains Inn', 77, '2019-02-14', 168, NULL),
('Cute Mountains Inn', 77, '2019-02-15', 206, NULL),
('Cute Mountains Inn', 77, '2019-02-16', 139, NULL),
('Cute Mountains Inn', 77, '2019-02-17', 324, NULL),
('Cute Mountains Inn', 77, '2019-02-18', 209, NULL),
('Cute Mountains Inn', 77, '2019-02-19', 200, NULL),
('Cute Mountains Inn', 77, '2019-02-20', 179, NULL),
('Cute Mountains Inn', 77, '2019-02-21', 241, NULL),
('Cute Mountains Inn', 77, '2019-02-22', 346, NULL),
('Cute Mountains Inn', 77, '2019-02-23', 361, NULL),
('Cute Mountains Inn', 77, '2019-02-24', 390, NULL),
('Cute Mountains Inn', 77, '2019-02-25', 274, NULL),
('Cute Mountains Inn', 77, '2019-02-26', 113, NULL),
('Cute Mountains Inn', 77, '2019-02-27', 252, NULL),
('Cute Mountains Inn', 77, '2019-02-28', 399, NULL),
('Cute Mountains Inn', 77, '2019-03-01', 399, NULL),
('Cute Mountains Inn', 77, '2019-03-02', 289, NULL),
('Cute Mountains Inn', 77, '2019-03-03', 186, NULL),
('Cute Mountains Inn', 77, '2019-03-04', 206, NULL),
('Cute Mountains Inn', 77, '2019-03-05', 231, NULL),
('Cute Mountains Inn', 77, '2019-03-06', 366, NULL),
('Cute Mountains Inn', 77, '2019-03-07', 157, NULL),
('Cute Mountains Inn', 77, '2019-03-08', 205, NULL),
('Cute Mountains Inn', 77, '2019-03-09', 245, NULL),
('Cute Mountains Inn', 77, '2019-03-10', 368, NULL),
('Cute Mountains Inn', 77, '2019-03-11', 378, NULL),
('Cute Mountains Inn', 77, '2019-03-12', 155, NULL),
('Cute Mountains Inn', 77, '2019-03-13', 320, NULL),
('Cute Mountains Inn', 77, '2019-03-14', 115, NULL),
('Cute Mountains Inn', 77, '2019-03-15', 292, NULL),
('Cute Mountains Inn', 77, '2019-03-16', 173, NULL),
('Cute Mountains Inn', 77, '2019-03-17', 353, NULL),
('Cute Mountains Inn', 77, '2019-03-18', 179, NULL),
('Cute Mountains Inn', 77, '2019-03-19', 394, NULL),
('Cute Mountains Inn', 77, '2019-03-20', 187, NULL),
('Cute Mountains Inn', 77, '2019-03-21', 399, NULL),
('Cute Mountains Inn', 77, '2019-03-22', 232, NULL),
('Cute Mountains Inn', 77, '2019-03-23', 236, NULL),
('Cute Mountains Inn', 77, '2019-03-24', 200, NULL),
('Cute Mountains Inn', 77, '2019-03-25', 363, NULL),
('Cute Mountains Inn', 77, '2019-03-26', 391, NULL),
('Cute Mountains Inn', 77, '2019-03-27', 253, NULL),
('Cute Mountains Inn', 77, '2019-03-28', 368, NULL),
('Cute Mountains Inn', 77, '2019-03-29', 121, NULL),
('Cute Mountains Inn', 77, '2019-03-30', 264, NULL),
('Cute Mountains Inn', 77, '2019-03-31', 300, NULL),
('Cute Mountains Inn', 77, '2019-04-01', 103, NULL),
('Cute Mountains Inn', 77, '2019-04-02', 334, NULL),
('Cute Mountains Inn', 77, '2019-04-03', 287, NULL),
('Cute Mountains Inn', 77, '2019-04-04', 345, NULL),
('Cute Mountains Inn', 77, '2019-04-05', 395, NULL),
('Cute Mountains Inn', 77, '2019-04-06', 245, NULL),
('Cute Mountains Inn', 77, '2019-04-07', 371, NULL),
('Cute Mountains Inn', 77, '2019-04-08', 271, NULL),
('Cute Mountains Inn', 77, '2019-04-09', 258, NULL),
('Cute Mountains Inn', 77, '2019-04-10', 302, NULL),
('Cute Mountains Inn', 77, '2019-04-11', 379, NULL),
('Cute Mountains Inn', 77, '2019-04-12', 261, NULL),
('Cute Mountains Inn', 77, '2019-04-13', 276, NULL),
('Cute Mountains Inn', 77, '2019-04-14', 209, NULL),
('Cute Mountains Inn', 77, '2019-04-15', 120, NULL),
('Cute Mountains Inn', 77, '2019-04-16', 342, NULL),
('Cute Mountains Inn', 77, '2019-04-17', 117, NULL),
('Cute Mountains Inn', 77, '2019-04-18', 143, NULL),
('Cute Mountains Inn', 77, '2019-04-19', 366, NULL),
('Cute Mountains Inn', 77, '2019-04-20', 187, NULL),
('Cute Mountains Inn', 77, '2019-04-21', 330, NULL),
('Cute Mountains Inn', 77, '2019-04-22', 274, NULL),
('Cute Mountains Inn', 77, '2019-04-23', 253, NULL),
('Cute Mountains Inn', 77, '2019-04-24', 274, NULL),
('Cute Mountains Inn', 77, '2019-04-25', 273, NULL),
('Cute Mountains Inn', 77, '2019-04-26', 195, NULL),
('Cute Mountains Inn', 77, '2019-04-27', 234, NULL),
('Cute Mountains Inn', 77, '2019-04-28', 127, NULL),
('Cute Mountains Inn', 77, '2019-04-29', 116, NULL),
('Cute Mountains Inn', 77, '2019-04-30', 365, NULL),
('Cute Mountains Inn', 77, '2019-05-01', 207, NULL),
('Cute Mountains Inn', 77, '2019-05-02', 150, NULL),
('Cute Mountains Inn', 77, '2019-05-03', 279, NULL),
('Cute Mountains Inn', 77, '2019-05-04', 356, NULL),
('Cute Mountains Inn', 77, '2019-05-05', 288, NULL),
('Cute Mountains Inn', 77, '2019-05-06', 361, NULL),
('Cute Mountains Inn', 77, '2019-05-07', 364, NULL),
('Cute Mountains Inn', 77, '2019-05-08', 202, NULL),
('Cute Mountains Inn', 77, '2019-05-09', 308, NULL),
('Cute Mountains Inn', 77, '2019-05-10', 155, NULL),
('Cute Mountains Inn', 77, '2019-05-11', 174, NULL),
('Cute Mountains Inn', 77, '2019-05-12', 165, NULL),
('Cute Mountains Inn', 77, '2019-05-13', 260, NULL),
('Cute Mountains Inn', 77, '2019-05-14', 283, NULL),
('Cute Mountains Inn', 77, '2019-05-15', 216, NULL),
('Cute Mountains Inn', 77, '2019-05-16', 258, NULL),
('Cute Mountains Inn', 77, '2019-05-17', 202, NULL),
('Cute Mountains Inn', 77, '2019-05-18', 384, NULL),
('Cute Mountains Inn', 77, '2019-05-19', 202, NULL),
('Cute Mountains Inn', 77, '2019-05-20', 248, NULL),
('Cute Mountains Inn', 77, '2019-05-21', 399, NULL),
('Cute Mountains Inn', 77, '2019-05-22', 319, NULL),
('Cute Mountains Inn', 77, '2019-05-23', 311, NULL),
('Cute Mountains Inn', 77, '2019-05-24', 288, NULL),
('Cute Mountains Inn', 77, '2019-05-25', 306, NULL),
('Cute Mountains Inn', 77, '2019-05-26', 300, NULL),
('Cute Mountains Inn', 77, '2019-05-27', 229, NULL),
('Cute Mountains Inn', 77, '2019-05-28', 124, NULL),
('Cute Mountains Inn', 77, '2019-05-29', 140, NULL),
('Cute Mountains Inn', 77, '2019-05-30', 122, NULL),
('Cute Mountains Inn', 77, '2019-05-31', 381, NULL),
('Cute Mountains Inn', 77, '2019-06-01', 251, NULL),
('Cute Mountains Inn', 77, '2019-06-02', 371, NULL),
('Cute Mountains Inn', 77, '2019-06-03', 230, NULL),
('Cute Mountains Inn', 77, '2019-06-04', 116, NULL),
('Cute Mountains Inn', 77, '2019-06-05', 153, NULL),
('Cute Mountains Inn', 77, '2019-06-06', 128, NULL),
('Cute Mountains Inn', 77, '2019-06-07', 323, NULL),
('Cute Mountains Inn', 77, '2019-06-08', 236, NULL),
('Cute Mountains Inn', 77, '2019-06-09', 139, NULL),
('Cute Mountains Inn', 77, '2019-06-10', 139, NULL),
('Cute Mountains Inn', 77, '2019-06-11', 176, NULL),
('Cute Mountains Inn', 77, '2019-06-12', 197, NULL),
('Cute Mountains Inn', 77, '2019-06-13', 274, NULL),
('Cute Mountains Inn', 77, '2019-06-14', 111, NULL),
('Cute Mountains Inn', 77, '2019-06-15', 207, NULL),
('Cute Mountains Inn', 77, '2019-06-16', 149, NULL),
('Cute Mountains Inn', 77, '2019-06-17', 323, NULL),
('Cute Mountains Inn', 77, '2019-06-18', 164, NULL),
('Cute Mountains Inn', 77, '2019-06-19', 232, NULL),
('Cute Mountains Inn', 77, '2019-06-20', 369, NULL),
('Cute Mountains Inn', 77, '2019-06-21', 141, NULL),
('Cute Mountains Inn', 77, '2019-06-22', 371, NULL),
('Cute Mountains Inn', 77, '2019-06-23', 289, NULL),
('Cute Mountains Inn', 77, '2019-06-24', 300, NULL),
('Cute Mountains Inn', 77, '2019-06-25', 355, NULL),
('Cute Mountains Inn', 77, '2019-06-26', 116, NULL),
('Cute Mountains Inn', 77, '2019-06-27', 326, NULL),
('Cute Mountains Inn', 77, '2019-06-28', 227, NULL),
('Cute Mountains Inn', 77, '2019-06-29', 371, NULL),
('Cute Mountains Inn', 77, '2019-06-30', 118, NULL),
('Cute Mountains Inn', 77, '2019-07-01', 109, NULL),
('Cute Mountains Inn', 77, '2019-07-02', 121, NULL),
('Cute Mountains Inn', 77, '2019-07-03', 287, NULL),
('Cute Mountains Inn', 77, '2019-07-04', 347, NULL),
('Cute Mountains Inn', 77, '2019-07-05', 312, NULL),
('Cute Mountains Inn', 77, '2019-07-06', 136, NULL),
('Cute Mountains Inn', 77, '2019-07-07', 321, NULL),
('Cute Mountains Inn', 77, '2019-07-08', 385, NULL),
('Cute Mountains Inn', 77, '2019-07-09', 313, NULL),
('Cute Mountains Inn', 77, '2019-07-10', 108, NULL),
('Cute Mountains Inn', 77, '2019-07-11', 345, NULL),
('Cute Mountains Inn', 77, '2019-07-12', 352, NULL),
('Cute Mountains Inn', 77, '2019-07-13', 249, NULL),
('Cute Mountains Inn', 77, '2019-07-14', 202, NULL),
('Cute Mountains Inn', 77, '2019-07-15', 354, NULL),
('Cute Mountains Inn', 77, '2019-07-16', 345, NULL),
('Cute Mountains Inn', 77, '2019-07-17', 333, NULL),
('Cute Mountains Inn', 77, '2019-07-18', 343, NULL),
('Cute Mountains Inn', 77, '2019-07-19', 250, NULL),
('Cute Mountains Inn', 77, '2019-07-20', 296, NULL),
('Cute Mountains Inn', 77, '2019-07-21', 359, NULL),
('Cute Mountains Inn', 77, '2019-07-22', 195, NULL),
('Cute Mountains Inn', 77, '2019-07-23', 200, NULL),
('Cute Mountains Inn', 77, '2019-07-24', 350, NULL),
('Cute Mountains Inn', 77, '2019-07-25', 126, NULL),
('Cute Mountains Inn', 77, '2019-07-26', 109, NULL),
('Cute Mountains Inn', 77, '2019-07-27', 249, NULL),
('Cute Mountains Inn', 77, '2019-07-28', 176, NULL),
('Cute Mountains Inn', 77, '2019-07-29', 212, NULL),
('Cute Mountains Inn', 77, '2019-07-30', 153, NULL),
('Cute Mountains Inn', 77, '2019-07-31', 261, NULL),
('Cute Mountains Inn', 77, '2019-08-01', 343, NULL),
('Cute Mountains Inn', 77, '2019-08-02', 113, NULL),
('Cute Mountains Inn', 77, '2019-08-03', 201, NULL),
('Cute Mountains Inn', 77, '2019-08-04', 197, NULL),
('Cute Mountains Inn', 77, '2019-08-05', 132, NULL),
('Cute Mountains Inn', 77, '2019-08-06', 255, NULL),
('Cute Mountains Inn', 77, '2019-08-07', 153, NULL),
('Cute Mountains Inn', 77, '2019-08-08', 241, NULL),
('Cute Mountains Inn', 77, '2019-08-09', 235, NULL),
('Cute Mountains Inn', 77, '2019-08-10', 368, NULL),
('Cute Mountains Inn', 77, '2019-08-11', 104, NULL),
('Cute Mountains Inn', 77, '2019-08-12', 329, NULL),
('Cute Mountains Inn', 77, '2019-08-13', 289, NULL),
('Cute Mountains Inn', 77, '2019-08-14', 253, NULL),
('Cute Mountains Inn', 77, '2019-08-15', 282, NULL),
('Cute Mountains Inn', 77, '2019-08-16', 265, NULL),
('Cute Mountains Inn', 77, '2019-08-17', 355, NULL),
('Cute Mountains Inn', 77, '2019-08-18', 398, NULL),
('Cute Mountains Inn', 77, '2019-08-19', 320, NULL),
('Cute Mountains Inn', 77, '2019-08-20', 155, NULL),
('Cute Mountains Inn', 77, '2019-08-21', 283, NULL),
('Cute Mountains Inn', 77, '2019-08-22', 385, NULL),
('Cute Mountains Inn', 77, '2019-08-23', 194, NULL),
('Cute Mountains Inn', 77, '2019-08-24', 201, NULL),
('Cute Mountains Inn', 77, '2019-08-25', 362, NULL),
('Cute Mountains Inn', 77, '2019-08-26', 174, NULL),
('Cute Mountains Inn', 77, '2019-08-27', 322, NULL),
('Cute Mountains Inn', 77, '2019-08-28', 106, NULL),
('Cute Mountains Inn', 77, '2019-08-29', 126, NULL),
('Cute Mountains Inn', 77, '2019-08-30', 103, NULL),
('Cute Mountains Inn', 77, '2019-08-31', 336, NULL),
('Cute Mountains Inn', 77, '2019-09-01', 254, NULL),
('Cute Mountains Inn', 77, '2019-09-02', 314, NULL),
('Cute Mountains Inn', 77, '2019-09-03', 208, NULL),
('Cute Mountains Inn', 77, '2019-09-04', 185, NULL),
('Cute Mountains Inn', 77, '2019-09-05', 157, NULL),
('Cute Mountains Inn', 77, '2019-09-06', 225, NULL),
('Cute Mountains Inn', 77, '2019-09-07', 357, NULL),
('Cute Mountains Inn', 77, '2019-09-08', 384, NULL),
('Cute Mountains Inn', 77, '2019-09-09', 291, NULL),
('Cute Mountains Inn', 77, '2019-09-10', 183, NULL),
('Cute Mountains Inn', 77, '2019-09-11', 203, NULL),
('Cute Mountains Inn', 77, '2019-09-12', 323, NULL),
('Cute Mountains Inn', 77, '2019-09-13', 290, NULL),
('Cute Mountains Inn', 77, '2019-09-14', 363, NULL),
('Cute Mountains Inn', 77, '2019-09-15', 202, NULL),
('Cute Mountains Inn', 77, '2019-09-16', 184, NULL),
('Cute Mountains Inn', 77, '2019-09-17', 190, NULL),
('Cute Mountains Inn', 77, '2019-09-18', 234, NULL),
('Cute Mountains Inn', 77, '2019-09-19', 166, NULL),
('Cute Mountains Inn', 77, '2019-09-20', 181, NULL),
('Cute Mountains Inn', 77, '2019-09-21', 236, NULL),
('Cute Mountains Inn', 77, '2019-09-22', 135, NULL),
('Cute Mountains Inn', 77, '2019-09-23', 233, NULL),
('Cute Mountains Inn', 77, '2019-09-24', 123, NULL),
('Cute Mountains Inn', 77, '2019-09-25', 134, NULL),
('Cute Mountains Inn', 77, '2019-09-26', 247, NULL),
('Cute Mountains Inn', 77, '2019-09-27', 302, NULL),
('Cute Mountains Inn', 77, '2019-09-28', 264, NULL),
('Cute Mountains Inn', 77, '2019-09-29', 381, NULL),
('Cute Mountains Inn', 77, '2019-09-30', 248, NULL),
('Cute Mountains Inn', 77, '2019-10-01', 118, NULL),
('Cute Mountains Inn', 77, '2019-10-02', 197, NULL),
('Cute Mountains Inn', 77, '2019-10-03', 117, NULL),
('Cute Mountains Inn', 77, '2019-10-04', 159, NULL),
('Cute Mountains Inn', 77, '2019-10-05', 187, NULL),
('Cute Mountains Inn', 77, '2019-10-06', 150, NULL),
('Cute Mountains Inn', 77, '2019-10-07', 219, NULL),
('Cute Mountains Inn', 77, '2019-10-08', 215, NULL),
('Cute Mountains Inn', 77, '2019-10-09', 352, NULL),
('Cute Mountains Inn', 77, '2019-10-10', 335, NULL),
('Cute Mountains Inn', 77, '2019-10-11', 360, NULL),
('Cute Mountains Inn', 77, '2019-10-12', 161, NULL),
('Cute Mountains Inn', 77, '2019-10-13', 254, NULL),
('Cute Mountains Inn', 77, '2019-10-14', 304, NULL),
('Cute Mountains Inn', 77, '2019-10-15', 395, NULL),
('Cute Mountains Inn', 77, '2019-10-16', 176, NULL),
('Cute Mountains Inn', 77, '2019-10-17', 254, NULL),
('Cute Mountains Inn', 77, '2019-10-18', 384, NULL),
('Cute Mountains Inn', 77, '2019-10-19', 320, NULL),
('Cute Mountains Inn', 77, '2019-10-20', 113, NULL),
('Cute Mountains Inn', 77, '2019-10-21', 283, NULL),
('Cute Mountains Inn', 77, '2019-10-22', 303, NULL),
('Cute Mountains Inn', 77, '2019-10-23', 359, NULL),
('Cute Mountains Inn', 77, '2019-10-24', 335, NULL),
('Cute Mountains Inn', 77, '2019-10-25', 323, NULL),
('Cute Mountains Inn', 77, '2019-10-26', 206, NULL),
('Cute Mountains Inn', 77, '2019-10-27', 128, NULL),
('Cute Mountains Inn', 77, '2019-10-28', 334, NULL),
('Cute Mountains Inn', 77, '2019-10-29', 323, NULL),
('Cute Mountains Inn', 77, '2019-10-30', 119, NULL),
('Cute Mountains Inn', 77, '2019-10-31', 316, NULL),
('Cute Mountains Inn', 77, '2019-11-01', 212, NULL),
('Cute Mountains Inn', 77, '2019-11-02', 165, NULL),
('Cute Mountains Inn', 77, '2019-11-03', 283, NULL),
('Cute Mountains Inn', 77, '2019-11-04', 142, NULL),
('Cute Mountains Inn', 77, '2019-11-05', 307, NULL),
('Cute Mountains Inn', 77, '2019-11-06', 395, NULL),
('Cute Mountains Inn', 77, '2019-11-07', 138, NULL),
('Cute Mountains Inn', 77, '2019-11-08', 222, NULL),
('Cute Mountains Inn', 77, '2019-11-09', 167, NULL),
('Cute Mountains Inn', 77, '2019-11-10', 205, NULL),
('Cute Mountains Inn', 77, '2019-11-11', 301, NULL),
('Cute Mountains Inn', 77, '2019-11-12', 151, NULL),
('Cute Mountains Inn', 77, '2019-11-13', 149, NULL),
('Cute Mountains Inn', 77, '2019-11-14', 288, NULL),
('Cute Mountains Inn', 77, '2019-11-15', 158, NULL),
('Cute Mountains Inn', 77, '2019-11-16', 175, NULL),
('Cute Mountains Inn', 77, '2019-11-17', 235, NULL),
('Cute Mountains Inn', 77, '2019-11-18', 364, NULL),
('Cute Mountains Inn', 77, '2019-11-19', 113, NULL),
('Cute Mountains Inn', 77, '2019-11-20', 102, NULL),
('Cute Mountains Inn', 77, '2019-11-21', 288, NULL),
('Cute Mountains Inn', 77, '2019-11-22', 240, NULL),
('Cute Mountains Inn', 77, '2019-11-23', 132, NULL),
('Cute Mountains Inn', 77, '2019-11-24', 338, NULL),
('Cute Mountains Inn', 77, '2019-11-25', 340, NULL),
('Cute Mountains Inn', 77, '2019-11-26', 207, NULL),
('Cute Mountains Inn', 77, '2019-11-27', 262, NULL),
('Cute Mountains Inn', 77, '2019-11-28', 103, NULL),
('Cute Mountains Inn', 77, '2019-11-29', 284, NULL),
('Cute Mountains Inn', 77, '2019-11-30', 365, NULL),
('Cute Mountains Inn', 77, '2019-12-01', 395, NULL),
('Cute Mountains Inn', 77, '2019-12-02', 246, NULL),
('Cute Mountains Inn', 77, '2019-12-03', 375, NULL),
('Cute Mountains Inn', 77, '2019-12-04', 136, NULL),
('Cute Mountains Inn', 77, '2019-12-05', 271, NULL),
('Cute Mountains Inn', 77, '2019-12-06', 246, NULL),
('Cute Mountains Inn', 77, '2019-12-07', 277, NULL),
('Cute Mountains Inn', 77, '2019-12-08', 238, NULL),
('Cute Mountains Inn', 77, '2019-12-09', 150, NULL),
('Cute Mountains Inn', 77, '2019-12-10', 131, NULL),
('Cute Mountains Inn', 77, '2019-12-11', 391, NULL),
('Cute Mountains Inn', 77, '2019-12-12', 137, NULL),
('Cute Mountains Inn', 77, '2019-12-13', 148, NULL),
('Cute Mountains Inn', 77, '2019-12-14', 106, NULL),
('Cute Mountains Inn', 77, '2019-12-15', 301, NULL),
('Cute Mountains Inn', 77, '2019-12-16', 278, NULL),
('Cute Mountains Inn', 77, '2019-12-17', 106, NULL),
('Cute Mountains Inn', 77, '2019-12-18', 317, NULL),
('Cute Mountains Inn', 77, '2019-12-19', 255, NULL),
('Cute Mountains Inn', 77, '2019-12-20', 238, NULL),
('Cute Mountains Inn', 77, '2019-12-21', 358, NULL),
('Cute Mountains Inn', 77, '2019-12-22', 381, NULL),
('Cute Mountains Inn', 77, '2019-12-23', 360, NULL),
('Cute Mountains Inn', 77, '2019-12-24', 251, NULL),
('Cute Mountains Inn', 77, '2019-12-25', 345, NULL),
('Cute Mountains Inn', 77, '2019-12-26', 135, NULL),
('Cute Mountains Inn', 77, '2019-12-27', 150, NULL),
('Cute Mountains Inn', 77, '2019-12-28', 129, NULL),
('Cute Mountains Inn', 77, '2019-12-29', 275, NULL),
('Cute Mountains Inn', 77, '2019-12-30', 302, NULL),
('Cute Mountains Inn', 77, '2019-12-31', 359, NULL),
('Cute Mountains Inn', 77, '2020-01-01', 387, NULL),
('Cute Mountains Inn', 77, '2020-01-02', 251, NULL),
('Cute Mountains Inn', 77, '2020-01-03', 180, NULL),
('Cute Mountains Inn', 77, '2020-01-04', 115, NULL),
('Cute Mountains Inn', 77, '2020-01-05', 361, NULL),
('Cute Mountains Inn', 77, '2020-01-06', 397, NULL),
('Cute Mountains Inn', 77, '2020-01-07', 286, NULL),
('Cute Mountains Inn', 77, '2020-01-08', 289, NULL),
('Cute Mountains Inn', 77, '2020-01-09', 175, NULL),
('Cute Mountains Inn', 77, '2020-01-10', 135, NULL),
('Cute Mountains Inn', 77, '2020-01-11', 117, NULL),
('Cute Mountains Inn', 77, '2020-01-12', 268, NULL),
('Cute Mountains Inn', 77, '2020-01-13', 245, NULL),
('Cute Mountains Inn', 77, '2020-01-14', 280, NULL),
('Cute Mountains Inn', 77, '2020-01-15', 252, NULL),
('Cute Mountains Inn', 77, '2020-01-16', 349, NULL),
('Cute Mountains Inn', 77, '2020-01-17', 186, NULL),
('Cute Mountains Inn', 77, '2020-01-18', 355, NULL),
('Cute Mountains Inn', 77, '2020-01-19', 308, NULL),
('Cute Mountains Inn', 77, '2020-01-20', 329, NULL),
('Cute Mountains Inn', 77, '2020-01-21', 280, NULL),
('Cute Mountains Inn', 77, '2020-01-22', 103, NULL),
('Cute Mountains Inn', 77, '2020-01-23', 205, NULL),
('Cute Mountains Inn', 77, '2020-01-24', 153, NULL),
('Cute Mountains Inn', 77, '2020-01-25', 155, NULL),
('Cute Mountains Inn', 77, '2020-01-26', 157, NULL),
('Cute Mountains Inn', 77, '2020-01-27', 221, NULL),
('Cute Mountains Inn', 77, '2020-01-28', 157, NULL),
('Cute Mountains Inn', 77, '2020-01-29', 368, NULL),
('Cute Mountains Inn', 77, '2020-01-30', 294, NULL),
('Cute Mountains Inn', 77, '2020-01-31', 308, NULL),
('Cute Mountains Inn', 77, '2020-02-01', 206, NULL),
('Cute Mountains Inn', 77, '2020-02-02', 274, NULL),
('Cute Mountains Inn', 77, '2020-02-03', 309, NULL),
('Cute Mountains Inn', 77, '2020-02-04', 145, NULL),
('Cute Mountains Inn', 84, '2019-01-01', 197, NULL),
('Cute Mountains Inn', 84, '2019-01-02', 198, NULL),
('Cute Mountains Inn', 84, '2019-01-03', 101, NULL),
('Cute Mountains Inn', 84, '2019-01-04', 244, NULL),
('Cute Mountains Inn', 84, '2019-01-05', 261, NULL),
('Cute Mountains Inn', 84, '2019-01-06', 250, NULL),
('Cute Mountains Inn', 84, '2019-01-07', 343, NULL),
('Cute Mountains Inn', 84, '2019-01-08', 265, NULL),
('Cute Mountains Inn', 84, '2019-01-09', 112, NULL),
('Cute Mountains Inn', 84, '2019-01-10', 227, NULL),
('Cute Mountains Inn', 84, '2019-01-11', 338, NULL),
('Cute Mountains Inn', 84, '2019-01-12', 388, NULL),
('Cute Mountains Inn', 84, '2019-01-13', 143, NULL),
('Cute Mountains Inn', 84, '2019-01-14', 225, NULL),
('Cute Mountains Inn', 84, '2019-01-15', 334, NULL),
('Cute Mountains Inn', 84, '2019-01-16', 379, NULL),
('Cute Mountains Inn', 84, '2019-01-17', 116, NULL),
('Cute Mountains Inn', 84, '2019-01-18', 172, NULL),
('Cute Mountains Inn', 84, '2019-01-19', 196, NULL),
('Cute Mountains Inn', 84, '2019-01-20', 195, NULL),
('Cute Mountains Inn', 84, '2019-01-21', 108, NULL),
('Cute Mountains Inn', 84, '2019-01-22', 128, NULL),
('Cute Mountains Inn', 84, '2019-01-23', 207, NULL),
('Cute Mountains Inn', 84, '2019-01-24', 317, NULL),
('Cute Mountains Inn', 84, '2019-01-25', 190, NULL),
('Cute Mountains Inn', 84, '2019-01-26', 280, NULL),
('Cute Mountains Inn', 84, '2019-01-27', 254, NULL),
('Cute Mountains Inn', 84, '2019-01-28', 303, NULL),
('Cute Mountains Inn', 84, '2019-01-29', 137, NULL),
('Cute Mountains Inn', 84, '2019-01-30', 181, NULL),
('Cute Mountains Inn', 84, '2019-01-31', 368, NULL),
('Cute Mountains Inn', 84, '2019-02-01', 248, NULL),
('Cute Mountains Inn', 84, '2019-02-02', 313, NULL),
('Cute Mountains Inn', 84, '2019-02-03', 290, NULL),
('Cute Mountains Inn', 84, '2019-02-04', 395, NULL),
('Cute Mountains Inn', 84, '2019-02-05', 250, NULL),
('Cute Mountains Inn', 84, '2019-02-06', 250, NULL),
('Cute Mountains Inn', 84, '2019-02-07', 286, NULL),
('Cute Mountains Inn', 84, '2019-02-08', 137, NULL),
('Cute Mountains Inn', 84, '2019-02-09', 256, NULL),
('Cute Mountains Inn', 84, '2019-02-10', 367, NULL),
('Cute Mountains Inn', 84, '2019-02-11', 255, NULL),
('Cute Mountains Inn', 84, '2019-02-12', 146, NULL),
('Cute Mountains Inn', 84, '2019-02-13', 344, NULL),
('Cute Mountains Inn', 84, '2019-02-14', 376, NULL),
('Cute Mountains Inn', 84, '2019-02-15', 383, NULL),
('Cute Mountains Inn', 84, '2019-02-16', 300, NULL),
('Cute Mountains Inn', 84, '2019-02-17', 376, NULL),
('Cute Mountains Inn', 84, '2019-02-18', 342, NULL),
('Cute Mountains Inn', 84, '2019-02-19', 225, NULL),
('Cute Mountains Inn', 84, '2019-02-20', 271, NULL),
('Cute Mountains Inn', 84, '2019-02-21', 391, NULL),
('Cute Mountains Inn', 84, '2019-02-22', 299, NULL),
('Cute Mountains Inn', 84, '2019-02-23', 106, NULL),
('Cute Mountains Inn', 84, '2019-02-24', 107, NULL),
('Cute Mountains Inn', 84, '2019-02-25', 396, NULL),
('Cute Mountains Inn', 84, '2019-02-26', 216, NULL),
('Cute Mountains Inn', 84, '2019-02-27', 320, NULL),
('Cute Mountains Inn', 84, '2019-02-28', 145, NULL),
('Cute Mountains Inn', 84, '2019-03-01', 141, NULL),
('Cute Mountains Inn', 84, '2019-03-02', 208, NULL),
('Cute Mountains Inn', 84, '2019-03-03', 160, NULL),
('Cute Mountains Inn', 84, '2019-03-04', 281, NULL),
('Cute Mountains Inn', 84, '2019-03-05', 201, NULL),
('Cute Mountains Inn', 84, '2019-03-06', 282, NULL),
('Cute Mountains Inn', 84, '2019-03-07', 294, NULL),
('Cute Mountains Inn', 84, '2019-03-08', 320, NULL),
('Cute Mountains Inn', 84, '2019-03-09', 322, NULL),
('Cute Mountains Inn', 84, '2019-03-10', 192, NULL),
('Cute Mountains Inn', 84, '2019-03-11', 215, NULL),
('Cute Mountains Inn', 84, '2019-03-12', 255, NULL),
('Cute Mountains Inn', 84, '2019-03-13', 223, NULL),
('Cute Mountains Inn', 84, '2019-03-14', 258, NULL),
('Cute Mountains Inn', 84, '2019-03-15', 176, NULL),
('Cute Mountains Inn', 84, '2019-03-16', 244, NULL),
('Cute Mountains Inn', 84, '2019-03-17', 120, NULL),
('Cute Mountains Inn', 84, '2019-03-18', 127, NULL),
('Cute Mountains Inn', 84, '2019-03-19', 207, NULL),
('Cute Mountains Inn', 84, '2019-03-20', 224, NULL),
('Cute Mountains Inn', 84, '2019-03-21', 382, NULL),
('Cute Mountains Inn', 84, '2019-03-22', 393, NULL),
('Cute Mountains Inn', 84, '2019-03-23', 372, NULL),
('Cute Mountains Inn', 84, '2019-03-24', 113, NULL),
('Cute Mountains Inn', 84, '2019-03-25', 229, NULL),
('Cute Mountains Inn', 84, '2019-03-26', 208, NULL),
('Cute Mountains Inn', 84, '2019-03-27', 147, NULL),
('Cute Mountains Inn', 84, '2019-03-28', 151, NULL),
('Cute Mountains Inn', 84, '2019-03-29', 158, NULL),
('Cute Mountains Inn', 84, '2019-03-30', 273, NULL),
('Cute Mountains Inn', 84, '2019-03-31', 268, NULL),
('Cute Mountains Inn', 84, '2019-04-01', 207, NULL),
('Cute Mountains Inn', 84, '2019-04-02', 315, NULL),
('Cute Mountains Inn', 84, '2019-04-03', 133, NULL),
('Cute Mountains Inn', 84, '2019-04-04', 345, NULL),
('Cute Mountains Inn', 84, '2019-04-05', 181, NULL),
('Cute Mountains Inn', 84, '2019-04-06', 226, NULL),
('Cute Mountains Inn', 84, '2019-04-07', 215, NULL),
('Cute Mountains Inn', 84, '2019-04-08', 114, NULL),
('Cute Mountains Inn', 84, '2019-04-09', 137, NULL),
('Cute Mountains Inn', 84, '2019-04-10', 120, NULL),
('Cute Mountains Inn', 84, '2019-04-11', 265, NULL),
('Cute Mountains Inn', 84, '2019-04-12', 239, NULL),
('Cute Mountains Inn', 84, '2019-04-13', 274, NULL),
('Cute Mountains Inn', 84, '2019-04-14', 327, NULL),
('Cute Mountains Inn', 84, '2019-04-15', 340, NULL),
('Cute Mountains Inn', 84, '2019-04-16', 183, NULL),
('Cute Mountains Inn', 84, '2019-04-17', 177, NULL),
('Cute Mountains Inn', 84, '2019-04-18', 363, NULL),
('Cute Mountains Inn', 84, '2019-04-19', 336, NULL),
('Cute Mountains Inn', 84, '2019-04-20', 385, NULL),
('Cute Mountains Inn', 84, '2019-04-21', 121, NULL),
('Cute Mountains Inn', 84, '2019-04-22', 349, NULL),
('Cute Mountains Inn', 84, '2019-04-23', 197, NULL),
('Cute Mountains Inn', 84, '2019-04-24', 373, NULL),
('Cute Mountains Inn', 84, '2019-04-25', 388, NULL),
('Cute Mountains Inn', 84, '2019-04-26', 323, NULL),
('Cute Mountains Inn', 84, '2019-04-27', 376, NULL),
('Cute Mountains Inn', 84, '2019-04-28', 368, NULL),
('Cute Mountains Inn', 84, '2019-04-29', 275, NULL),
('Cute Mountains Inn', 84, '2019-04-30', 289, NULL),
('Cute Mountains Inn', 84, '2019-05-01', 102, NULL),
('Cute Mountains Inn', 84, '2019-05-02', 247, NULL),
('Cute Mountains Inn', 84, '2019-05-03', 272, NULL),
('Cute Mountains Inn', 84, '2019-05-04', 226, NULL),
('Cute Mountains Inn', 84, '2019-05-05', 223, NULL),
('Cute Mountains Inn', 84, '2019-05-06', 316, NULL),
('Cute Mountains Inn', 84, '2019-05-07', 307, NULL),
('Cute Mountains Inn', 84, '2019-05-08', 285, NULL),
('Cute Mountains Inn', 84, '2019-05-09', 247, NULL),
('Cute Mountains Inn', 84, '2019-05-10', 262, NULL),
('Cute Mountains Inn', 84, '2019-05-11', 236, NULL),
('Cute Mountains Inn', 84, '2019-05-12', 256, NULL),
('Cute Mountains Inn', 84, '2019-05-13', 102, NULL),
('Cute Mountains Inn', 84, '2019-05-14', 187, NULL),
('Cute Mountains Inn', 84, '2019-05-15', 352, NULL),
('Cute Mountains Inn', 84, '2019-05-16', 218, NULL),
('Cute Mountains Inn', 84, '2019-05-17', 323, NULL),
('Cute Mountains Inn', 84, '2019-05-18', 139, NULL),
('Cute Mountains Inn', 84, '2019-05-19', 397, NULL),
('Cute Mountains Inn', 84, '2019-05-20', 392, NULL),
('Cute Mountains Inn', 84, '2019-05-21', 392, NULL),
('Cute Mountains Inn', 84, '2019-05-22', 149, NULL),
('Cute Mountains Inn', 84, '2019-05-23', 317, NULL),
('Cute Mountains Inn', 84, '2019-05-24', 338, NULL),
('Cute Mountains Inn', 84, '2019-05-25', 353, NULL),
('Cute Mountains Inn', 84, '2019-05-26', 354, NULL),
('Cute Mountains Inn', 84, '2019-05-27', 320, NULL),
('Cute Mountains Inn', 84, '2019-05-28', 380, NULL),
('Cute Mountains Inn', 84, '2019-05-29', 169, NULL),
('Cute Mountains Inn', 84, '2019-05-30', 211, NULL),
('Cute Mountains Inn', 84, '2019-05-31', 354, NULL),
('Cute Mountains Inn', 84, '2019-06-01', 291, NULL),
('Cute Mountains Inn', 84, '2019-06-02', 115, NULL),
('Cute Mountains Inn', 84, '2019-06-03', 182, NULL),
('Cute Mountains Inn', 84, '2019-06-04', 177, NULL),
('Cute Mountains Inn', 84, '2019-06-05', 122, NULL),
('Cute Mountains Inn', 84, '2019-06-06', 365, NULL),
('Cute Mountains Inn', 84, '2019-06-07', 346, NULL),
('Cute Mountains Inn', 84, '2019-06-08', 328, NULL),
('Cute Mountains Inn', 84, '2019-06-09', 374, NULL),
('Cute Mountains Inn', 84, '2019-06-10', 132, NULL),
('Cute Mountains Inn', 84, '2019-06-11', 271, NULL),
('Cute Mountains Inn', 84, '2019-06-12', 364, NULL),
('Cute Mountains Inn', 84, '2019-06-13', 249, NULL),
('Cute Mountains Inn', 84, '2019-06-14', 131, NULL),
('Cute Mountains Inn', 84, '2019-06-15', 261, NULL),
('Cute Mountains Inn', 84, '2019-06-16', 355, NULL),
('Cute Mountains Inn', 84, '2019-06-17', 325, NULL),
('Cute Mountains Inn', 84, '2019-06-18', 107, NULL),
('Cute Mountains Inn', 84, '2019-06-19', 116, NULL),
('Cute Mountains Inn', 84, '2019-06-20', 209, NULL),
('Cute Mountains Inn', 84, '2019-06-21', 251, NULL),
('Cute Mountains Inn', 84, '2019-06-22', 218, NULL),
('Cute Mountains Inn', 84, '2019-06-23', 145, NULL),
('Cute Mountains Inn', 84, '2019-06-24', 234, NULL),
('Cute Mountains Inn', 84, '2019-06-25', 193, NULL),
('Cute Mountains Inn', 84, '2019-06-26', 350, NULL),
('Cute Mountains Inn', 84, '2019-06-27', 125, NULL),
('Cute Mountains Inn', 84, '2019-06-28', 301, NULL),
('Cute Mountains Inn', 84, '2019-06-29', 129, NULL),
('Cute Mountains Inn', 84, '2019-06-30', 358, NULL),
('Cute Mountains Inn', 84, '2019-07-01', 372, NULL),
('Cute Mountains Inn', 84, '2019-07-02', 196, NULL),
('Cute Mountains Inn', 84, '2019-07-03', 116, NULL),
('Cute Mountains Inn', 84, '2019-07-04', 127, NULL),
('Cute Mountains Inn', 84, '2019-07-05', 397, NULL),
('Cute Mountains Inn', 84, '2019-07-06', 270, NULL),
('Cute Mountains Inn', 84, '2019-07-07', 342, NULL),
('Cute Mountains Inn', 84, '2019-07-08', 218, NULL),
('Cute Mountains Inn', 84, '2019-07-09', 299, NULL),
('Cute Mountains Inn', 84, '2019-07-10', 172, NULL),
('Cute Mountains Inn', 84, '2019-07-11', 227, NULL),
('Cute Mountains Inn', 84, '2019-07-12', 228, NULL),
('Cute Mountains Inn', 84, '2019-07-13', 169, NULL),
('Cute Mountains Inn', 84, '2019-07-14', 372, NULL),
('Cute Mountains Inn', 84, '2019-07-15', 262, NULL),
('Cute Mountains Inn', 84, '2019-07-16', 176, NULL),
('Cute Mountains Inn', 84, '2019-07-17', 327, NULL),
('Cute Mountains Inn', 84, '2019-07-18', 207, NULL),
('Cute Mountains Inn', 84, '2019-07-19', 374, NULL),
('Cute Mountains Inn', 84, '2019-07-20', 244, NULL),
('Cute Mountains Inn', 84, '2019-07-21', 146, NULL),
('Cute Mountains Inn', 84, '2019-07-22', 290, NULL),
('Cute Mountains Inn', 84, '2019-07-23', 224, NULL),
('Cute Mountains Inn', 84, '2019-07-24', 196, NULL),
('Cute Mountains Inn', 84, '2019-07-25', 183, NULL),
('Cute Mountains Inn', 84, '2019-07-26', 104, NULL),
('Cute Mountains Inn', 84, '2019-07-27', 190, NULL),
('Cute Mountains Inn', 84, '2019-07-28', 290, NULL),
('Cute Mountains Inn', 84, '2019-07-29', 217, NULL),
('Cute Mountains Inn', 84, '2019-07-30', 307, NULL),
('Cute Mountains Inn', 84, '2019-07-31', 357, NULL),
('Cute Mountains Inn', 84, '2019-08-01', 332, NULL),
('Cute Mountains Inn', 84, '2019-08-02', 273, NULL),
('Cute Mountains Inn', 84, '2019-08-03', 390, NULL),
('Cute Mountains Inn', 84, '2019-08-04', 295, NULL),
('Cute Mountains Inn', 84, '2019-08-05', 357, NULL),
('Cute Mountains Inn', 84, '2019-08-06', 211, NULL),
('Cute Mountains Inn', 84, '2019-08-07', 176, NULL),
('Cute Mountains Inn', 84, '2019-08-08', 304, NULL),
('Cute Mountains Inn', 84, '2019-08-09', 251, NULL),
('Cute Mountains Inn', 84, '2019-08-10', 111, NULL),
('Cute Mountains Inn', 84, '2019-08-11', 170, NULL),
('Cute Mountains Inn', 84, '2019-08-12', 146, NULL),
('Cute Mountains Inn', 84, '2019-08-13', 395, NULL),
('Cute Mountains Inn', 84, '2019-08-14', 359, NULL),
('Cute Mountains Inn', 84, '2019-08-15', 254, NULL),
('Cute Mountains Inn', 84, '2019-08-16', 269, NULL),
('Cute Mountains Inn', 84, '2019-08-17', 198, NULL),
('Cute Mountains Inn', 84, '2019-08-18', 278, NULL),
('Cute Mountains Inn', 84, '2019-08-19', 372, NULL),
('Cute Mountains Inn', 84, '2019-08-20', 315, NULL),
('Cute Mountains Inn', 84, '2019-08-21', 154, NULL),
('Cute Mountains Inn', 84, '2019-08-22', 384, NULL),
('Cute Mountains Inn', 84, '2019-08-23', 344, NULL),
('Cute Mountains Inn', 84, '2019-08-24', 196, NULL),
('Cute Mountains Inn', 84, '2019-08-25', 298, NULL),
('Cute Mountains Inn', 84, '2019-08-26', 101, NULL),
('Cute Mountains Inn', 84, '2019-08-27', 248, NULL),
('Cute Mountains Inn', 84, '2019-08-28', 309, NULL),
('Cute Mountains Inn', 84, '2019-08-29', 270, NULL),
('Cute Mountains Inn', 84, '2019-08-30', 212, NULL),
('Cute Mountains Inn', 84, '2019-08-31', 331, NULL),
('Cute Mountains Inn', 84, '2019-09-01', 175, NULL),
('Cute Mountains Inn', 84, '2019-09-02', 364, NULL),
('Cute Mountains Inn', 84, '2019-09-03', 312, NULL),
('Cute Mountains Inn', 84, '2019-09-04', 200, NULL),
('Cute Mountains Inn', 84, '2019-09-05', 201, NULL),
('Cute Mountains Inn', 84, '2019-09-06', 392, NULL),
('Cute Mountains Inn', 84, '2019-09-07', 367, NULL),
('Cute Mountains Inn', 84, '2019-09-08', 189, NULL),
('Cute Mountains Inn', 84, '2019-09-09', 355, NULL),
('Cute Mountains Inn', 84, '2019-09-10', 373, NULL),
('Cute Mountains Inn', 84, '2019-09-11', 388, NULL),
('Cute Mountains Inn', 84, '2019-09-12', 359, NULL),
('Cute Mountains Inn', 84, '2019-09-13', 308, NULL),
('Cute Mountains Inn', 84, '2019-09-14', 106, NULL),
('Cute Mountains Inn', 84, '2019-09-15', 342, NULL),
('Cute Mountains Inn', 84, '2019-09-16', 371, NULL),
('Cute Mountains Inn', 84, '2019-09-17', 394, NULL),
('Cute Mountains Inn', 84, '2019-09-18', 322, NULL),
('Cute Mountains Inn', 84, '2019-09-19', 243, NULL),
('Cute Mountains Inn', 84, '2019-09-20', 356, NULL),
('Cute Mountains Inn', 84, '2019-09-21', 120, NULL),
('Cute Mountains Inn', 84, '2019-09-22', 305, NULL),
('Cute Mountains Inn', 84, '2019-09-23', 145, NULL),
('Cute Mountains Inn', 84, '2019-09-24', 275, NULL),
('Cute Mountains Inn', 84, '2019-09-25', 204, NULL),
('Cute Mountains Inn', 84, '2019-09-26', 111, NULL),
('Cute Mountains Inn', 84, '2019-09-27', 212, NULL),
('Cute Mountains Inn', 84, '2019-09-28', 143, NULL),
('Cute Mountains Inn', 84, '2019-09-29', 300, NULL),
('Cute Mountains Inn', 84, '2019-09-30', 203, NULL),
('Cute Mountains Inn', 84, '2019-10-01', 336, NULL),
('Cute Mountains Inn', 84, '2019-10-02', 324, NULL),
('Cute Mountains Inn', 84, '2019-10-03', 123, NULL),
('Cute Mountains Inn', 84, '2019-10-04', 144, NULL),
('Cute Mountains Inn', 84, '2019-10-05', 227, NULL),
('Cute Mountains Inn', 84, '2019-10-06', 300, NULL),
('Cute Mountains Inn', 84, '2019-10-07', 110, NULL),
('Cute Mountains Inn', 84, '2019-10-08', 299, NULL),
('Cute Mountains Inn', 84, '2019-10-09', 266, NULL),
('Cute Mountains Inn', 84, '2019-10-10', 298, NULL),
('Cute Mountains Inn', 84, '2019-10-11', 164, NULL),
('Cute Mountains Inn', 84, '2019-10-12', 387, NULL),
('Cute Mountains Inn', 84, '2019-10-13', 167, NULL),
('Cute Mountains Inn', 84, '2019-10-14', 203, NULL),
('Cute Mountains Inn', 84, '2019-10-15', 360, NULL),
('Cute Mountains Inn', 84, '2019-10-16', 162, NULL),
('Cute Mountains Inn', 84, '2019-10-17', 344, NULL),
('Cute Mountains Inn', 84, '2019-10-18', 394, NULL),
('Cute Mountains Inn', 84, '2019-10-19', 128, NULL),
('Cute Mountains Inn', 84, '2019-10-20', 388, NULL),
('Cute Mountains Inn', 84, '2019-10-21', 322, NULL),
('Cute Mountains Inn', 84, '2019-10-22', 212, NULL),
('Cute Mountains Inn', 84, '2019-10-23', 153, NULL),
('Cute Mountains Inn', 84, '2019-10-24', 230, NULL),
('Cute Mountains Inn', 84, '2019-10-25', 335, NULL),
('Cute Mountains Inn', 84, '2019-10-26', 239, NULL),
('Cute Mountains Inn', 84, '2019-10-27', 145, NULL),
('Cute Mountains Inn', 84, '2019-10-28', 122, NULL),
('Cute Mountains Inn', 84, '2019-10-29', 264, NULL),
('Cute Mountains Inn', 84, '2019-10-30', 238, NULL),
('Cute Mountains Inn', 84, '2019-10-31', 128, NULL),
('Cute Mountains Inn', 84, '2019-11-01', 167, NULL),
('Cute Mountains Inn', 84, '2019-11-02', 191, NULL),
('Cute Mountains Inn', 84, '2019-11-03', 250, NULL),
('Cute Mountains Inn', 84, '2019-11-04', 330, NULL),
('Cute Mountains Inn', 84, '2019-11-05', 234, NULL),
('Cute Mountains Inn', 84, '2019-11-06', 320, NULL),
('Cute Mountains Inn', 84, '2019-11-07', 318, NULL),
('Cute Mountains Inn', 84, '2019-11-08', 245, NULL),
('Cute Mountains Inn', 84, '2019-11-09', 394, NULL),
('Cute Mountains Inn', 84, '2019-11-10', 135, NULL),
('Cute Mountains Inn', 84, '2019-11-11', 222, NULL),
('Cute Mountains Inn', 84, '2019-11-12', 353, NULL),
('Cute Mountains Inn', 84, '2019-11-13', 241, NULL),
('Cute Mountains Inn', 84, '2019-11-14', 147, NULL),
('Cute Mountains Inn', 84, '2019-11-15', 112, NULL),
('Cute Mountains Inn', 84, '2019-11-16', 282, NULL),
('Cute Mountains Inn', 84, '2019-11-17', 367, NULL),
('Cute Mountains Inn', 84, '2019-11-18', 143, NULL),
('Cute Mountains Inn', 84, '2019-11-19', 181, NULL),
('Cute Mountains Inn', 84, '2019-11-20', 288, NULL),
('Cute Mountains Inn', 84, '2019-11-21', 326, NULL),
('Cute Mountains Inn', 84, '2019-11-22', 369, NULL),
('Cute Mountains Inn', 84, '2019-11-23', 320, NULL),
('Cute Mountains Inn', 84, '2019-11-24', 193, NULL),
('Cute Mountains Inn', 84, '2019-11-25', 225, NULL),
('Cute Mountains Inn', 84, '2019-11-26', 212, NULL),
('Cute Mountains Inn', 84, '2019-11-27', 307, NULL),
('Cute Mountains Inn', 84, '2019-11-28', 348, NULL),
('Cute Mountains Inn', 84, '2019-11-29', 329, NULL),
('Cute Mountains Inn', 84, '2019-11-30', 337, NULL),
('Cute Mountains Inn', 84, '2019-12-01', 268, NULL),
('Cute Mountains Inn', 84, '2019-12-02', 231, NULL),
('Cute Mountains Inn', 84, '2019-12-03', 367, NULL),
('Cute Mountains Inn', 84, '2019-12-04', 163, NULL),
('Cute Mountains Inn', 84, '2019-12-05', 184, NULL),
('Cute Mountains Inn', 84, '2019-12-06', 149, NULL),
('Cute Mountains Inn', 84, '2019-12-07', 331, NULL),
('Cute Mountains Inn', 84, '2019-12-08', 158, NULL),
('Cute Mountains Inn', 84, '2019-12-09', 182, NULL),
('Cute Mountains Inn', 84, '2019-12-10', 336, NULL),
('Cute Mountains Inn', 84, '2019-12-11', 119, NULL),
('Cute Mountains Inn', 84, '2019-12-12', 194, NULL),
('Cute Mountains Inn', 84, '2019-12-13', 168, NULL),
('Cute Mountains Inn', 84, '2019-12-14', 179, NULL),
('Cute Mountains Inn', 84, '2019-12-15', 360, NULL),
('Cute Mountains Inn', 84, '2019-12-16', 199, NULL),
('Cute Mountains Inn', 84, '2019-12-17', 103, NULL),
('Cute Mountains Inn', 84, '2019-12-18', 155, NULL),
('Cute Mountains Inn', 84, '2019-12-19', 287, NULL),
('Cute Mountains Inn', 84, '2019-12-20', 275, NULL),
('Cute Mountains Inn', 84, '2019-12-21', 391, NULL),
('Cute Mountains Inn', 84, '2019-12-22', 114, NULL),
('Cute Mountains Inn', 84, '2019-12-23', 140, NULL),
('Cute Mountains Inn', 84, '2019-12-24', 372, NULL),
('Cute Mountains Inn', 84, '2019-12-25', 141, NULL),
('Cute Mountains Inn', 84, '2019-12-26', 261, NULL),
('Cute Mountains Inn', 84, '2019-12-27', 356, NULL),
('Cute Mountains Inn', 84, '2019-12-28', 383, NULL),
('Cute Mountains Inn', 84, '2019-12-29', 279, NULL),
('Cute Mountains Inn', 84, '2019-12-30', 298, NULL),
('Cute Mountains Inn', 84, '2019-12-31', 146, NULL),
('Cute Mountains Inn', 84, '2020-01-01', 101, NULL),
('Cute Mountains Inn', 84, '2020-01-02', 374, NULL),
('Cute Mountains Inn', 84, '2020-01-03', 232, NULL),
('Cute Mountains Inn', 84, '2020-01-04', 239, NULL),
('Cute Mountains Inn', 84, '2020-01-05', 181, NULL),
('Cute Mountains Inn', 84, '2020-01-06', 151, NULL),
('Cute Mountains Inn', 84, '2020-01-07', 378, NULL),
('Cute Mountains Inn', 84, '2020-01-08', 243, NULL),
('Cute Mountains Inn', 84, '2020-01-09', 124, NULL),
('Cute Mountains Inn', 84, '2020-01-10', 145, NULL),
('Cute Mountains Inn', 84, '2020-01-11', 117, NULL),
('Cute Mountains Inn', 84, '2020-01-12', 278, NULL),
('Cute Mountains Inn', 84, '2020-01-13', 335, NULL),
('Cute Mountains Inn', 84, '2020-01-14', 131, NULL),
('Cute Mountains Inn', 84, '2020-01-15', 255, NULL),
('Cute Mountains Inn', 84, '2020-01-16', 256, NULL),
('Cute Mountains Inn', 84, '2020-01-17', 135, NULL),
('Cute Mountains Inn', 84, '2020-01-18', 153, NULL),
('Cute Mountains Inn', 84, '2020-01-19', 199, NULL),
('Cute Mountains Inn', 84, '2020-01-20', 371, NULL),
('Cute Mountains Inn', 84, '2020-01-21', 273, NULL),
('Cute Mountains Inn', 84, '2020-01-22', 122, NULL),
('Cute Mountains Inn', 84, '2020-01-23', 342, NULL),
('Cute Mountains Inn', 84, '2020-01-24', 144, NULL),
('Cute Mountains Inn', 84, '2020-01-25', 180, NULL),
('Cute Mountains Inn', 84, '2020-01-26', 380, NULL),
('Cute Mountains Inn', 84, '2020-01-27', 370, NULL),
('Cute Mountains Inn', 84, '2020-01-28', 209, NULL),
('Cute Mountains Inn', 84, '2020-01-29', 278, NULL),
('Cute Mountains Inn', 84, '2020-01-30', 183, NULL),
('Cute Mountains Inn', 84, '2020-01-31', 156, NULL),
('Cute Mountains Inn', 84, '2020-02-01', 374, NULL),
('Cute Mountains Inn', 84, '2020-02-02', 230, NULL),
('Cute Mountains Inn', 84, '2020-02-03', 397, NULL),
('Cute Mountains Inn', 84, '2020-02-04', 115, NULL),
('Cute Mountains Inn', 97, '2019-01-01', 265, NULL),
('Cute Mountains Inn', 97, '2019-01-02', 348, NULL),
('Cute Mountains Inn', 97, '2019-01-03', 217, NULL),
('Cute Mountains Inn', 97, '2019-01-04', 246, NULL),
('Cute Mountains Inn', 97, '2019-01-05', 132, NULL),
('Cute Mountains Inn', 97, '2019-01-06', 236, NULL),
('Cute Mountains Inn', 97, '2019-01-07', 365, NULL),
('Cute Mountains Inn', 97, '2019-01-08', 395, NULL),
('Cute Mountains Inn', 97, '2019-01-09', 129, NULL),
('Cute Mountains Inn', 97, '2019-01-10', 224, NULL),
('Cute Mountains Inn', 97, '2019-01-11', 116, NULL),
('Cute Mountains Inn', 97, '2019-01-12', 312, NULL),
('Cute Mountains Inn', 97, '2019-01-13', 390, NULL),
('Cute Mountains Inn', 97, '2019-01-14', 393, NULL),
('Cute Mountains Inn', 97, '2019-01-15', 162, NULL),
('Cute Mountains Inn', 97, '2019-01-16', 248, NULL),
('Cute Mountains Inn', 97, '2019-01-17', 215, NULL),
('Cute Mountains Inn', 97, '2019-01-18', 372, NULL),
('Cute Mountains Inn', 97, '2019-01-19', 316, NULL),
('Cute Mountains Inn', 97, '2019-01-20', 228, NULL),
('Cute Mountains Inn', 97, '2019-01-21', 235, NULL),
('Cute Mountains Inn', 97, '2019-01-22', 224, NULL),
('Cute Mountains Inn', 97, '2019-01-23', 236, NULL),
('Cute Mountains Inn', 97, '2019-01-24', 298, NULL),
('Cute Mountains Inn', 97, '2019-01-25', 335, NULL),
('Cute Mountains Inn', 97, '2019-01-26', 215, NULL),
('Cute Mountains Inn', 97, '2019-01-27', 319, NULL),
('Cute Mountains Inn', 97, '2019-01-28', 311, NULL),
('Cute Mountains Inn', 97, '2019-01-29', 227, NULL),
('Cute Mountains Inn', 97, '2019-01-30', 203, NULL),
('Cute Mountains Inn', 97, '2019-01-31', 373, NULL),
('Cute Mountains Inn', 97, '2019-02-01', 366, NULL),
('Cute Mountains Inn', 97, '2019-02-02', 164, NULL),
('Cute Mountains Inn', 97, '2019-02-03', 135, NULL),
('Cute Mountains Inn', 97, '2019-02-04', 142, NULL),
('Cute Mountains Inn', 97, '2019-02-05', 111, NULL),
('Cute Mountains Inn', 97, '2019-02-06', 144, NULL),
('Cute Mountains Inn', 97, '2019-02-07', 283, NULL),
('Cute Mountains Inn', 97, '2019-02-08', 255, NULL),
('Cute Mountains Inn', 97, '2019-02-09', 128, NULL),
('Cute Mountains Inn', 97, '2019-02-10', 343, NULL),
('Cute Mountains Inn', 97, '2019-02-11', 223, NULL),
('Cute Mountains Inn', 97, '2019-02-12', 217, NULL),
('Cute Mountains Inn', 97, '2019-02-13', 109, NULL),
('Cute Mountains Inn', 97, '2019-02-14', 376, NULL),
('Cute Mountains Inn', 97, '2019-02-15', 298, NULL),
('Cute Mountains Inn', 97, '2019-02-16', 384, NULL),
('Cute Mountains Inn', 97, '2019-02-17', 206, NULL),
('Cute Mountains Inn', 97, '2019-02-18', 383, NULL),
('Cute Mountains Inn', 97, '2019-02-19', 125, NULL),
('Cute Mountains Inn', 97, '2019-02-20', 119, NULL),
('Cute Mountains Inn', 97, '2019-02-21', 232, NULL),
('Cute Mountains Inn', 97, '2019-02-22', 356, NULL),
('Cute Mountains Inn', 97, '2019-02-23', 245, NULL),
('Cute Mountains Inn', 97, '2019-02-24', 164, NULL),
('Cute Mountains Inn', 97, '2019-02-25', 161, NULL),
('Cute Mountains Inn', 97, '2019-02-26', 340, NULL),
('Cute Mountains Inn', 97, '2019-02-27', 145, NULL),
('Cute Mountains Inn', 97, '2019-02-28', 330, NULL),
('Cute Mountains Inn', 97, '2019-03-01', 310, NULL),
('Cute Mountains Inn', 97, '2019-03-02', 375, NULL),
('Cute Mountains Inn', 97, '2019-03-03', 143, NULL),
('Cute Mountains Inn', 97, '2019-03-04', 386, NULL),
('Cute Mountains Inn', 97, '2019-03-05', 213, NULL),
('Cute Mountains Inn', 97, '2019-03-06', 213, NULL),
('Cute Mountains Inn', 97, '2019-03-07', 296, NULL),
('Cute Mountains Inn', 97, '2019-03-08', 282, NULL),
('Cute Mountains Inn', 97, '2019-03-09', 174, NULL),
('Cute Mountains Inn', 97, '2019-03-10', 354, NULL),
('Cute Mountains Inn', 97, '2019-03-11', 141, NULL),
('Cute Mountains Inn', 97, '2019-03-12', 110, NULL),
('Cute Mountains Inn', 97, '2019-03-13', 355, NULL),
('Cute Mountains Inn', 97, '2019-03-14', 247, NULL),
('Cute Mountains Inn', 97, '2019-03-15', 206, NULL),
('Cute Mountains Inn', 97, '2019-03-16', 303, NULL),
('Cute Mountains Inn', 97, '2019-03-17', 340, NULL),
('Cute Mountains Inn', 97, '2019-03-18', 299, NULL),
('Cute Mountains Inn', 97, '2019-03-19', 354, NULL),
('Cute Mountains Inn', 97, '2019-03-20', 161, NULL),
('Cute Mountains Inn', 97, '2019-03-21', 315, NULL),
('Cute Mountains Inn', 97, '2019-03-22', 269, NULL),
('Cute Mountains Inn', 97, '2019-03-23', 152, NULL),
('Cute Mountains Inn', 97, '2019-03-24', 164, NULL),
('Cute Mountains Inn', 97, '2019-03-25', 255, NULL),
('Cute Mountains Inn', 97, '2019-03-26', 366, NULL),
('Cute Mountains Inn', 97, '2019-03-27', 177, NULL),
('Cute Mountains Inn', 97, '2019-03-28', 151, NULL),
('Cute Mountains Inn', 97, '2019-03-29', 328, NULL),
('Cute Mountains Inn', 97, '2019-03-30', 174, NULL),
('Cute Mountains Inn', 97, '2019-03-31', 338, NULL),
('Cute Mountains Inn', 97, '2019-04-01', 327, NULL),
('Cute Mountains Inn', 97, '2019-04-02', 173, NULL),
('Cute Mountains Inn', 97, '2019-04-03', 302, NULL),
('Cute Mountains Inn', 97, '2019-04-04', 294, NULL),
('Cute Mountains Inn', 97, '2019-04-05', 221, NULL),
('Cute Mountains Inn', 97, '2019-04-06', 294, NULL),
('Cute Mountains Inn', 97, '2019-04-07', 161, NULL),
('Cute Mountains Inn', 97, '2019-04-08', 257, NULL),
('Cute Mountains Inn', 97, '2019-04-09', 109, NULL),
('Cute Mountains Inn', 97, '2019-04-10', 193, NULL),
('Cute Mountains Inn', 97, '2019-04-11', 389, NULL),
('Cute Mountains Inn', 97, '2019-04-12', 310, NULL),
('Cute Mountains Inn', 97, '2019-04-13', 145, NULL),
('Cute Mountains Inn', 97, '2019-04-14', 308, NULL),
('Cute Mountains Inn', 97, '2019-04-15', 344, NULL),
('Cute Mountains Inn', 97, '2019-04-16', 388, NULL),
('Cute Mountains Inn', 97, '2019-04-17', 136, NULL),
('Cute Mountains Inn', 97, '2019-04-18', 388, NULL),
('Cute Mountains Inn', 97, '2019-04-19', 182, NULL),
('Cute Mountains Inn', 97, '2019-04-20', 367, NULL),
('Cute Mountains Inn', 97, '2019-04-21', 116, NULL),
('Cute Mountains Inn', 97, '2019-04-22', 223, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 97, '2019-04-23', 125, NULL),
('Cute Mountains Inn', 97, '2019-04-24', 343, NULL),
('Cute Mountains Inn', 97, '2019-04-25', 119, NULL),
('Cute Mountains Inn', 97, '2019-04-26', 331, NULL),
('Cute Mountains Inn', 97, '2019-04-27', 178, NULL),
('Cute Mountains Inn', 97, '2019-04-28', 158, NULL),
('Cute Mountains Inn', 97, '2019-04-29', 325, NULL),
('Cute Mountains Inn', 97, '2019-04-30', 252, NULL),
('Cute Mountains Inn', 97, '2019-05-01', 393, NULL),
('Cute Mountains Inn', 97, '2019-05-02', 387, NULL),
('Cute Mountains Inn', 97, '2019-05-03', 125, NULL),
('Cute Mountains Inn', 97, '2019-05-04', 260, NULL),
('Cute Mountains Inn', 97, '2019-05-05', 148, NULL),
('Cute Mountains Inn', 97, '2019-05-06', 395, NULL),
('Cute Mountains Inn', 97, '2019-05-07', 341, NULL),
('Cute Mountains Inn', 97, '2019-05-08', 116, NULL),
('Cute Mountains Inn', 97, '2019-05-09', 212, NULL),
('Cute Mountains Inn', 97, '2019-05-10', 147, NULL),
('Cute Mountains Inn', 97, '2019-05-11', 258, NULL),
('Cute Mountains Inn', 97, '2019-05-12', 386, NULL),
('Cute Mountains Inn', 97, '2019-05-13', 231, NULL),
('Cute Mountains Inn', 97, '2019-05-14', 287, NULL),
('Cute Mountains Inn', 97, '2019-05-15', 113, NULL),
('Cute Mountains Inn', 97, '2019-05-16', 215, NULL),
('Cute Mountains Inn', 97, '2019-05-17', 311, NULL),
('Cute Mountains Inn', 97, '2019-05-18', 344, NULL),
('Cute Mountains Inn', 97, '2019-05-19', 376, NULL),
('Cute Mountains Inn', 97, '2019-05-20', 217, NULL),
('Cute Mountains Inn', 97, '2019-05-21', 364, NULL),
('Cute Mountains Inn', 97, '2019-05-22', 286, NULL),
('Cute Mountains Inn', 97, '2019-05-23', 253, NULL),
('Cute Mountains Inn', 97, '2019-05-24', 125, NULL),
('Cute Mountains Inn', 97, '2019-05-25', 149, NULL),
('Cute Mountains Inn', 97, '2019-05-26', 173, NULL),
('Cute Mountains Inn', 97, '2019-05-27', 212, NULL),
('Cute Mountains Inn', 97, '2019-05-28', 231, NULL),
('Cute Mountains Inn', 97, '2019-05-29', 326, NULL),
('Cute Mountains Inn', 97, '2019-05-30', 292, NULL),
('Cute Mountains Inn', 97, '2019-05-31', 226, NULL),
('Cute Mountains Inn', 97, '2019-06-01', 303, NULL),
('Cute Mountains Inn', 97, '2019-06-02', 262, NULL),
('Cute Mountains Inn', 97, '2019-06-03', 119, NULL),
('Cute Mountains Inn', 97, '2019-06-04', 140, NULL),
('Cute Mountains Inn', 97, '2019-06-05', 354, NULL),
('Cute Mountains Inn', 97, '2019-06-06', 141, NULL),
('Cute Mountains Inn', 97, '2019-06-07', 361, NULL),
('Cute Mountains Inn', 97, '2019-06-08', 232, NULL),
('Cute Mountains Inn', 97, '2019-06-09', 151, NULL),
('Cute Mountains Inn', 97, '2019-06-10', 142, NULL),
('Cute Mountains Inn', 97, '2019-06-11', 131, NULL),
('Cute Mountains Inn', 97, '2019-06-12', 230, NULL),
('Cute Mountains Inn', 97, '2019-06-13', 323, NULL),
('Cute Mountains Inn', 97, '2019-06-14', 222, NULL),
('Cute Mountains Inn', 97, '2019-06-15', 285, NULL),
('Cute Mountains Inn', 97, '2019-06-16', 327, NULL),
('Cute Mountains Inn', 97, '2019-06-17', 255, NULL),
('Cute Mountains Inn', 97, '2019-06-18', 244, NULL),
('Cute Mountains Inn', 97, '2019-06-19', 382, NULL),
('Cute Mountains Inn', 97, '2019-06-20', 137, NULL),
('Cute Mountains Inn', 97, '2019-06-21', 134, NULL),
('Cute Mountains Inn', 97, '2019-06-22', 175, NULL),
('Cute Mountains Inn', 97, '2019-06-23', 360, NULL),
('Cute Mountains Inn', 97, '2019-06-24', 171, NULL),
('Cute Mountains Inn', 97, '2019-06-25', 399, NULL),
('Cute Mountains Inn', 97, '2019-06-26', 103, NULL),
('Cute Mountains Inn', 97, '2019-06-27', 148, NULL),
('Cute Mountains Inn', 97, '2019-06-28', 125, NULL),
('Cute Mountains Inn', 97, '2019-06-29', 330, NULL),
('Cute Mountains Inn', 97, '2019-06-30', 140, NULL),
('Cute Mountains Inn', 97, '2019-07-01', 235, NULL),
('Cute Mountains Inn', 97, '2019-07-02', 220, NULL),
('Cute Mountains Inn', 97, '2019-07-03', 219, NULL),
('Cute Mountains Inn', 97, '2019-07-04', 394, NULL),
('Cute Mountains Inn', 97, '2019-07-05', 349, NULL),
('Cute Mountains Inn', 97, '2019-07-06', 241, NULL),
('Cute Mountains Inn', 97, '2019-07-07', 348, NULL),
('Cute Mountains Inn', 97, '2019-07-08', 132, NULL),
('Cute Mountains Inn', 97, '2019-07-09', 157, NULL),
('Cute Mountains Inn', 97, '2019-07-10', 138, NULL),
('Cute Mountains Inn', 97, '2019-07-11', 302, NULL),
('Cute Mountains Inn', 97, '2019-07-12', 286, NULL),
('Cute Mountains Inn', 97, '2019-07-13', 299, NULL),
('Cute Mountains Inn', 97, '2019-07-14', 252, NULL),
('Cute Mountains Inn', 97, '2019-07-15', 150, NULL),
('Cute Mountains Inn', 97, '2019-07-16', 344, NULL),
('Cute Mountains Inn', 97, '2019-07-17', 238, NULL),
('Cute Mountains Inn', 97, '2019-07-18', 205, NULL),
('Cute Mountains Inn', 97, '2019-07-19', 121, NULL),
('Cute Mountains Inn', 97, '2019-07-20', 232, NULL),
('Cute Mountains Inn', 97, '2019-07-21', 151, NULL),
('Cute Mountains Inn', 97, '2019-07-22', 168, NULL),
('Cute Mountains Inn', 97, '2019-07-23', 120, NULL),
('Cute Mountains Inn', 97, '2019-07-24', 129, NULL),
('Cute Mountains Inn', 97, '2019-07-25', 138, NULL),
('Cute Mountains Inn', 97, '2019-07-26', 396, NULL),
('Cute Mountains Inn', 97, '2019-07-27', 102, NULL),
('Cute Mountains Inn', 97, '2019-07-28', 222, NULL),
('Cute Mountains Inn', 97, '2019-07-29', 351, NULL),
('Cute Mountains Inn', 97, '2019-07-30', 374, NULL),
('Cute Mountains Inn', 97, '2019-07-31', 301, NULL),
('Cute Mountains Inn', 97, '2019-08-01', 232, NULL),
('Cute Mountains Inn', 97, '2019-08-02', 326, NULL),
('Cute Mountains Inn', 97, '2019-08-03', 347, NULL),
('Cute Mountains Inn', 97, '2019-08-04', 187, NULL),
('Cute Mountains Inn', 97, '2019-08-05', 389, NULL),
('Cute Mountains Inn', 97, '2019-08-06', 187, NULL),
('Cute Mountains Inn', 97, '2019-08-07', 319, NULL),
('Cute Mountains Inn', 97, '2019-08-08', 397, NULL),
('Cute Mountains Inn', 97, '2019-08-09', 149, NULL),
('Cute Mountains Inn', 97, '2019-08-10', 253, NULL),
('Cute Mountains Inn', 97, '2019-08-11', 140, NULL),
('Cute Mountains Inn', 97, '2019-08-12', 242, NULL),
('Cute Mountains Inn', 97, '2019-08-13', 109, NULL),
('Cute Mountains Inn', 97, '2019-08-14', 334, NULL),
('Cute Mountains Inn', 97, '2019-08-15', 324, NULL),
('Cute Mountains Inn', 97, '2019-08-16', 151, NULL),
('Cute Mountains Inn', 97, '2019-08-17', 125, NULL),
('Cute Mountains Inn', 97, '2019-08-18', 398, NULL),
('Cute Mountains Inn', 97, '2019-08-19', 200, NULL),
('Cute Mountains Inn', 97, '2019-08-20', 107, NULL),
('Cute Mountains Inn', 97, '2019-08-21', 125, NULL),
('Cute Mountains Inn', 97, '2019-08-22', 367, NULL),
('Cute Mountains Inn', 97, '2019-08-23', 138, NULL),
('Cute Mountains Inn', 97, '2019-08-24', 279, NULL),
('Cute Mountains Inn', 97, '2019-08-25', 302, NULL),
('Cute Mountains Inn', 97, '2019-08-26', 183, NULL),
('Cute Mountains Inn', 97, '2019-08-27', 175, NULL),
('Cute Mountains Inn', 97, '2019-08-28', 225, NULL),
('Cute Mountains Inn', 97, '2019-08-29', 274, NULL),
('Cute Mountains Inn', 97, '2019-08-30', 351, NULL),
('Cute Mountains Inn', 97, '2019-08-31', 249, NULL),
('Cute Mountains Inn', 97, '2019-09-01', 311, NULL),
('Cute Mountains Inn', 97, '2019-09-02', 176, NULL),
('Cute Mountains Inn', 97, '2019-09-03', 237, NULL),
('Cute Mountains Inn', 97, '2019-09-04', 344, NULL),
('Cute Mountains Inn', 97, '2019-09-05', 135, NULL),
('Cute Mountains Inn', 97, '2019-09-06', 287, NULL),
('Cute Mountains Inn', 97, '2019-09-07', 364, NULL),
('Cute Mountains Inn', 97, '2019-09-08', 292, NULL),
('Cute Mountains Inn', 97, '2019-09-09', 202, NULL),
('Cute Mountains Inn', 97, '2019-09-10', 319, NULL),
('Cute Mountains Inn', 97, '2019-09-11', 328, NULL),
('Cute Mountains Inn', 97, '2019-09-12', 125, NULL),
('Cute Mountains Inn', 97, '2019-09-13', 270, NULL),
('Cute Mountains Inn', 97, '2019-09-14', 239, NULL),
('Cute Mountains Inn', 97, '2019-09-15', 103, NULL),
('Cute Mountains Inn', 97, '2019-09-16', 305, NULL),
('Cute Mountains Inn', 97, '2019-09-17', 102, NULL),
('Cute Mountains Inn', 97, '2019-09-18', 210, NULL),
('Cute Mountains Inn', 97, '2019-09-19', 315, NULL),
('Cute Mountains Inn', 97, '2019-09-20', 235, NULL),
('Cute Mountains Inn', 97, '2019-09-21', 394, NULL),
('Cute Mountains Inn', 97, '2019-09-22', 122, NULL),
('Cute Mountains Inn', 97, '2019-09-23', 224, NULL),
('Cute Mountains Inn', 97, '2019-09-24', 304, NULL),
('Cute Mountains Inn', 97, '2019-09-25', 218, NULL),
('Cute Mountains Inn', 97, '2019-09-26', 317, NULL),
('Cute Mountains Inn', 97, '2019-09-27', 353, NULL),
('Cute Mountains Inn', 97, '2019-09-28', 126, NULL),
('Cute Mountains Inn', 97, '2019-09-29', 258, NULL),
('Cute Mountains Inn', 97, '2019-09-30', 172, NULL),
('Cute Mountains Inn', 97, '2019-10-01', 325, NULL),
('Cute Mountains Inn', 97, '2019-10-02', 328, NULL),
('Cute Mountains Inn', 97, '2019-10-03', 162, NULL),
('Cute Mountains Inn', 97, '2019-10-04', 147, NULL),
('Cute Mountains Inn', 97, '2019-10-05', 174, NULL),
('Cute Mountains Inn', 97, '2019-10-06', 351, NULL),
('Cute Mountains Inn', 97, '2019-10-07', 396, NULL),
('Cute Mountains Inn', 97, '2019-10-08', 150, NULL),
('Cute Mountains Inn', 97, '2019-10-09', 174, NULL),
('Cute Mountains Inn', 97, '2019-10-10', 382, NULL),
('Cute Mountains Inn', 97, '2019-10-11', 242, NULL),
('Cute Mountains Inn', 97, '2019-10-12', 153, NULL),
('Cute Mountains Inn', 97, '2019-10-13', 271, NULL),
('Cute Mountains Inn', 97, '2019-10-14', 302, NULL),
('Cute Mountains Inn', 97, '2019-10-15', 217, NULL),
('Cute Mountains Inn', 97, '2019-10-16', 181, NULL),
('Cute Mountains Inn', 97, '2019-10-17', 261, NULL),
('Cute Mountains Inn', 97, '2019-10-18', 116, NULL),
('Cute Mountains Inn', 97, '2019-10-19', 180, NULL),
('Cute Mountains Inn', 97, '2019-10-20', 304, NULL),
('Cute Mountains Inn', 97, '2019-10-21', 361, NULL),
('Cute Mountains Inn', 97, '2019-10-22', 352, NULL),
('Cute Mountains Inn', 97, '2019-10-23', 187, NULL),
('Cute Mountains Inn', 97, '2019-10-24', 345, NULL),
('Cute Mountains Inn', 97, '2019-10-25', 304, NULL),
('Cute Mountains Inn', 97, '2019-10-26', 177, NULL),
('Cute Mountains Inn', 97, '2019-10-27', 242, NULL),
('Cute Mountains Inn', 97, '2019-10-28', 109, NULL),
('Cute Mountains Inn', 97, '2019-10-29', 248, NULL),
('Cute Mountains Inn', 97, '2019-10-30', 132, NULL),
('Cute Mountains Inn', 97, '2019-10-31', 196, NULL),
('Cute Mountains Inn', 97, '2019-11-01', 101, NULL),
('Cute Mountains Inn', 97, '2019-11-02', 359, NULL),
('Cute Mountains Inn', 97, '2019-11-03', 304, NULL),
('Cute Mountains Inn', 97, '2019-11-04', 226, NULL),
('Cute Mountains Inn', 97, '2019-11-05', 150, NULL),
('Cute Mountains Inn', 97, '2019-11-06', 313, NULL),
('Cute Mountains Inn', 97, '2019-11-07', 177, NULL),
('Cute Mountains Inn', 97, '2019-11-08', 161, NULL),
('Cute Mountains Inn', 97, '2019-11-09', 167, NULL),
('Cute Mountains Inn', 97, '2019-11-10', 261, NULL),
('Cute Mountains Inn', 97, '2019-11-11', 109, NULL),
('Cute Mountains Inn', 97, '2019-11-12', 310, NULL),
('Cute Mountains Inn', 97, '2019-11-13', 361, NULL),
('Cute Mountains Inn', 97, '2019-11-14', 369, NULL),
('Cute Mountains Inn', 97, '2019-11-15', 288, NULL),
('Cute Mountains Inn', 97, '2019-11-16', 185, NULL),
('Cute Mountains Inn', 97, '2019-11-17', 131, NULL),
('Cute Mountains Inn', 97, '2019-11-18', 124, NULL),
('Cute Mountains Inn', 97, '2019-11-19', 164, NULL),
('Cute Mountains Inn', 97, '2019-11-20', 134, NULL),
('Cute Mountains Inn', 97, '2019-11-21', 368, NULL),
('Cute Mountains Inn', 97, '2019-11-22', 123, NULL),
('Cute Mountains Inn', 97, '2019-11-23', 205, NULL),
('Cute Mountains Inn', 97, '2019-11-24', 154, NULL),
('Cute Mountains Inn', 97, '2019-11-25', 305, NULL),
('Cute Mountains Inn', 97, '2019-11-26', 341, NULL),
('Cute Mountains Inn', 97, '2019-11-27', 349, NULL),
('Cute Mountains Inn', 97, '2019-11-28', 131, NULL),
('Cute Mountains Inn', 97, '2019-11-29', 393, NULL),
('Cute Mountains Inn', 97, '2019-11-30', 192, NULL),
('Cute Mountains Inn', 97, '2019-12-01', 355, NULL),
('Cute Mountains Inn', 97, '2019-12-02', 318, NULL),
('Cute Mountains Inn', 97, '2019-12-03', 309, NULL),
('Cute Mountains Inn', 97, '2019-12-04', 311, NULL),
('Cute Mountains Inn', 97, '2019-12-05', 305, NULL),
('Cute Mountains Inn', 97, '2019-12-06', 205, NULL),
('Cute Mountains Inn', 97, '2019-12-07', 124, NULL),
('Cute Mountains Inn', 97, '2019-12-08', 277, NULL),
('Cute Mountains Inn', 97, '2019-12-09', 360, NULL),
('Cute Mountains Inn', 97, '2019-12-10', 288, NULL),
('Cute Mountains Inn', 97, '2019-12-11', 220, NULL),
('Cute Mountains Inn', 97, '2019-12-12', 160, NULL),
('Cute Mountains Inn', 97, '2019-12-13', 296, NULL),
('Cute Mountains Inn', 97, '2019-12-14', 174, NULL),
('Cute Mountains Inn', 97, '2019-12-15', 198, NULL),
('Cute Mountains Inn', 97, '2019-12-16', 361, NULL),
('Cute Mountains Inn', 97, '2019-12-17', 394, NULL),
('Cute Mountains Inn', 97, '2019-12-18', 327, NULL),
('Cute Mountains Inn', 97, '2019-12-19', 268, NULL),
('Cute Mountains Inn', 97, '2019-12-20', 260, NULL),
('Cute Mountains Inn', 97, '2019-12-21', 179, NULL),
('Cute Mountains Inn', 97, '2019-12-22', 229, NULL),
('Cute Mountains Inn', 97, '2019-12-23', 122, NULL),
('Cute Mountains Inn', 97, '2019-12-24', 109, NULL),
('Cute Mountains Inn', 97, '2019-12-25', 168, NULL),
('Cute Mountains Inn', 97, '2019-12-26', 202, NULL),
('Cute Mountains Inn', 97, '2019-12-27', 331, NULL),
('Cute Mountains Inn', 97, '2019-12-28', 227, NULL),
('Cute Mountains Inn', 97, '2019-12-29', 169, NULL),
('Cute Mountains Inn', 97, '2019-12-30', 185, NULL),
('Cute Mountains Inn', 97, '2019-12-31', 154, NULL),
('Cute Mountains Inn', 97, '2020-01-01', 143, NULL),
('Cute Mountains Inn', 97, '2020-01-02', 116, NULL),
('Cute Mountains Inn', 97, '2020-01-03', 222, NULL),
('Cute Mountains Inn', 97, '2020-01-04', 152, NULL),
('Cute Mountains Inn', 97, '2020-01-05', 322, NULL),
('Cute Mountains Inn', 97, '2020-01-06', 366, NULL),
('Cute Mountains Inn', 97, '2020-01-07', 332, NULL),
('Cute Mountains Inn', 97, '2020-01-08', 252, NULL),
('Cute Mountains Inn', 97, '2020-01-09', 297, NULL),
('Cute Mountains Inn', 97, '2020-01-10', 217, NULL),
('Cute Mountains Inn', 97, '2020-01-11', 134, NULL),
('Cute Mountains Inn', 97, '2020-01-12', 187, NULL),
('Cute Mountains Inn', 97, '2020-01-13', 238, NULL),
('Cute Mountains Inn', 97, '2020-01-14', 316, NULL),
('Cute Mountains Inn', 97, '2020-01-15', 119, NULL),
('Cute Mountains Inn', 97, '2020-01-16', 134, NULL),
('Cute Mountains Inn', 97, '2020-01-17', 319, NULL),
('Cute Mountains Inn', 97, '2020-01-18', 200, NULL),
('Cute Mountains Inn', 97, '2020-01-19', 271, NULL),
('Cute Mountains Inn', 97, '2020-01-20', 167, NULL),
('Cute Mountains Inn', 97, '2020-01-21', 128, NULL),
('Cute Mountains Inn', 97, '2020-01-22', 200, NULL),
('Cute Mountains Inn', 97, '2020-01-23', 394, NULL),
('Cute Mountains Inn', 97, '2020-01-24', 162, NULL),
('Cute Mountains Inn', 97, '2020-01-25', 338, NULL),
('Cute Mountains Inn', 97, '2020-01-26', 127, NULL),
('Cute Mountains Inn', 97, '2020-01-27', 187, NULL),
('Cute Mountains Inn', 97, '2020-01-28', 173, NULL),
('Cute Mountains Inn', 97, '2020-01-29', 189, NULL),
('Cute Mountains Inn', 97, '2020-01-30', 231, NULL),
('Cute Mountains Inn', 97, '2020-01-31', 356, NULL),
('Cute Mountains Inn', 97, '2020-02-01', 252, NULL),
('Cute Mountains Inn', 97, '2020-02-02', 230, NULL),
('Cute Mountains Inn', 97, '2020-02-03', 355, NULL),
('Cute Mountains Inn', 97, '2020-02-04', 341, NULL),
('Cute Mountains Inn', 99, '2019-01-01', 334, NULL),
('Cute Mountains Inn', 99, '2019-01-02', 147, NULL),
('Cute Mountains Inn', 99, '2019-01-03', 384, NULL),
('Cute Mountains Inn', 99, '2019-01-04', 397, NULL),
('Cute Mountains Inn', 99, '2019-01-05', 377, NULL),
('Cute Mountains Inn', 99, '2019-01-06', 331, NULL),
('Cute Mountains Inn', 99, '2019-01-07', 399, NULL),
('Cute Mountains Inn', 99, '2019-01-08', 178, NULL),
('Cute Mountains Inn', 99, '2019-01-09', 210, NULL),
('Cute Mountains Inn', 99, '2019-01-10', 336, NULL),
('Cute Mountains Inn', 99, '2019-01-11', 365, NULL),
('Cute Mountains Inn', 99, '2019-01-12', 296, NULL),
('Cute Mountains Inn', 99, '2019-01-13', 222, NULL),
('Cute Mountains Inn', 99, '2019-01-14', 289, NULL),
('Cute Mountains Inn', 99, '2019-01-15', 310, NULL),
('Cute Mountains Inn', 99, '2019-01-16', 307, NULL),
('Cute Mountains Inn', 99, '2019-01-17', 327, NULL),
('Cute Mountains Inn', 99, '2019-01-18', 342, NULL),
('Cute Mountains Inn', 99, '2019-01-19', 293, NULL),
('Cute Mountains Inn', 99, '2019-01-20', 157, NULL),
('Cute Mountains Inn', 99, '2019-01-21', 153, NULL),
('Cute Mountains Inn', 99, '2019-01-22', 338, NULL),
('Cute Mountains Inn', 99, '2019-01-23', 160, NULL),
('Cute Mountains Inn', 99, '2019-01-24', 138, NULL),
('Cute Mountains Inn', 99, '2019-01-25', 104, NULL),
('Cute Mountains Inn', 99, '2019-01-26', 135, NULL),
('Cute Mountains Inn', 99, '2019-01-27', 135, NULL),
('Cute Mountains Inn', 99, '2019-01-28', 246, NULL),
('Cute Mountains Inn', 99, '2019-01-29', 328, NULL),
('Cute Mountains Inn', 99, '2019-01-30', 372, NULL),
('Cute Mountains Inn', 99, '2019-01-31', 361, NULL),
('Cute Mountains Inn', 99, '2019-02-01', 383, NULL),
('Cute Mountains Inn', 99, '2019-02-02', 383, NULL),
('Cute Mountains Inn', 99, '2019-02-03', 303, NULL),
('Cute Mountains Inn', 99, '2019-02-04', 328, NULL),
('Cute Mountains Inn', 99, '2019-02-05', 306, NULL),
('Cute Mountains Inn', 99, '2019-02-06', 172, NULL),
('Cute Mountains Inn', 99, '2019-02-07', 160, NULL),
('Cute Mountains Inn', 99, '2019-02-08', 164, NULL),
('Cute Mountains Inn', 99, '2019-02-09', 372, NULL),
('Cute Mountains Inn', 99, '2019-02-10', 214, NULL),
('Cute Mountains Inn', 99, '2019-02-11', 254, NULL),
('Cute Mountains Inn', 99, '2019-02-12', 246, NULL),
('Cute Mountains Inn', 99, '2019-02-13', 310, NULL),
('Cute Mountains Inn', 99, '2019-02-14', 353, NULL),
('Cute Mountains Inn', 99, '2019-02-15', 243, NULL),
('Cute Mountains Inn', 99, '2019-02-16', 321, NULL),
('Cute Mountains Inn', 99, '2019-02-17', 106, NULL),
('Cute Mountains Inn', 99, '2019-02-18', 190, NULL),
('Cute Mountains Inn', 99, '2019-02-19', 149, NULL),
('Cute Mountains Inn', 99, '2019-02-20', 283, NULL),
('Cute Mountains Inn', 99, '2019-02-21', 190, NULL),
('Cute Mountains Inn', 99, '2019-02-22', 184, NULL),
('Cute Mountains Inn', 99, '2019-02-23', 210, NULL),
('Cute Mountains Inn', 99, '2019-02-24', 100, NULL),
('Cute Mountains Inn', 99, '2019-02-25', 117, NULL),
('Cute Mountains Inn', 99, '2019-02-26', 354, NULL),
('Cute Mountains Inn', 99, '2019-02-27', 264, NULL),
('Cute Mountains Inn', 99, '2019-02-28', 216, NULL),
('Cute Mountains Inn', 99, '2019-03-01', 127, NULL),
('Cute Mountains Inn', 99, '2019-03-02', 250, NULL),
('Cute Mountains Inn', 99, '2019-03-03', 136, NULL),
('Cute Mountains Inn', 99, '2019-03-04', 387, NULL),
('Cute Mountains Inn', 99, '2019-03-05', 364, NULL),
('Cute Mountains Inn', 99, '2019-03-06', 120, NULL),
('Cute Mountains Inn', 99, '2019-03-07', 200, NULL),
('Cute Mountains Inn', 99, '2019-03-08', 354, NULL),
('Cute Mountains Inn', 99, '2019-03-09', 105, NULL),
('Cute Mountains Inn', 99, '2019-03-10', 196, NULL),
('Cute Mountains Inn', 99, '2019-03-11', 260, NULL),
('Cute Mountains Inn', 99, '2019-03-12', 287, NULL),
('Cute Mountains Inn', 99, '2019-03-13', 108, NULL),
('Cute Mountains Inn', 99, '2019-03-14', 359, NULL),
('Cute Mountains Inn', 99, '2019-03-15', 102, NULL),
('Cute Mountains Inn', 99, '2019-03-16', 384, NULL),
('Cute Mountains Inn', 99, '2019-03-17', 339, NULL),
('Cute Mountains Inn', 99, '2019-03-18', 115, NULL),
('Cute Mountains Inn', 99, '2019-03-19', 150, NULL),
('Cute Mountains Inn', 99, '2019-03-20', 333, NULL),
('Cute Mountains Inn', 99, '2019-03-21', 328, NULL),
('Cute Mountains Inn', 99, '2019-03-22', 369, NULL),
('Cute Mountains Inn', 99, '2019-03-23', 145, NULL),
('Cute Mountains Inn', 99, '2019-03-24', 380, NULL),
('Cute Mountains Inn', 99, '2019-03-25', 187, NULL),
('Cute Mountains Inn', 99, '2019-03-26', 209, NULL),
('Cute Mountains Inn', 99, '2019-03-27', 343, NULL),
('Cute Mountains Inn', 99, '2019-03-28', 202, NULL),
('Cute Mountains Inn', 99, '2019-03-29', 168, NULL),
('Cute Mountains Inn', 99, '2019-03-30', 249, NULL),
('Cute Mountains Inn', 99, '2019-03-31', 190, NULL),
('Cute Mountains Inn', 99, '2019-04-01', 315, NULL),
('Cute Mountains Inn', 99, '2019-04-02', 121, NULL),
('Cute Mountains Inn', 99, '2019-04-03', 113, NULL),
('Cute Mountains Inn', 99, '2019-04-04', 332, NULL),
('Cute Mountains Inn', 99, '2019-04-05', 163, NULL),
('Cute Mountains Inn', 99, '2019-04-06', 395, NULL),
('Cute Mountains Inn', 99, '2019-04-07', 363, NULL),
('Cute Mountains Inn', 99, '2019-04-08', 244, NULL),
('Cute Mountains Inn', 99, '2019-04-09', 334, NULL),
('Cute Mountains Inn', 99, '2019-04-10', 206, NULL),
('Cute Mountains Inn', 99, '2019-04-11', 151, NULL),
('Cute Mountains Inn', 99, '2019-04-12', 136, NULL),
('Cute Mountains Inn', 99, '2019-04-13', 103, NULL),
('Cute Mountains Inn', 99, '2019-04-14', 162, NULL),
('Cute Mountains Inn', 99, '2019-04-15', 298, NULL),
('Cute Mountains Inn', 99, '2019-04-16', 391, NULL),
('Cute Mountains Inn', 99, '2019-04-17', 348, NULL),
('Cute Mountains Inn', 99, '2019-04-18', 151, NULL),
('Cute Mountains Inn', 99, '2019-04-19', 100, NULL),
('Cute Mountains Inn', 99, '2019-04-20', 282, NULL),
('Cute Mountains Inn', 99, '2019-04-21', 117, NULL),
('Cute Mountains Inn', 99, '2019-04-22', 266, NULL),
('Cute Mountains Inn', 99, '2019-04-23', 235, NULL),
('Cute Mountains Inn', 99, '2019-04-24', 195, NULL),
('Cute Mountains Inn', 99, '2019-04-25', 232, NULL),
('Cute Mountains Inn', 99, '2019-04-26', 286, NULL),
('Cute Mountains Inn', 99, '2019-04-27', 263, NULL),
('Cute Mountains Inn', 99, '2019-04-28', 189, NULL),
('Cute Mountains Inn', 99, '2019-04-29', 104, NULL),
('Cute Mountains Inn', 99, '2019-04-30', 293, NULL),
('Cute Mountains Inn', 99, '2019-05-01', 358, NULL),
('Cute Mountains Inn', 99, '2019-05-02', 193, NULL),
('Cute Mountains Inn', 99, '2019-05-03', 308, NULL),
('Cute Mountains Inn', 99, '2019-05-04', 222, NULL),
('Cute Mountains Inn', 99, '2019-05-05', 274, NULL),
('Cute Mountains Inn', 99, '2019-05-06', 331, NULL),
('Cute Mountains Inn', 99, '2019-05-07', 387, NULL),
('Cute Mountains Inn', 99, '2019-05-08', 228, NULL),
('Cute Mountains Inn', 99, '2019-05-09', 221, NULL),
('Cute Mountains Inn', 99, '2019-05-10', 148, NULL),
('Cute Mountains Inn', 99, '2019-05-11', 182, NULL),
('Cute Mountains Inn', 99, '2019-05-12', 162, NULL),
('Cute Mountains Inn', 99, '2019-05-13', 146, NULL),
('Cute Mountains Inn', 99, '2019-05-14', 176, NULL),
('Cute Mountains Inn', 99, '2019-05-15', 308, NULL),
('Cute Mountains Inn', 99, '2019-05-16', 323, NULL),
('Cute Mountains Inn', 99, '2019-05-17', 185, NULL),
('Cute Mountains Inn', 99, '2019-05-18', 306, NULL),
('Cute Mountains Inn', 99, '2019-05-19', 292, NULL),
('Cute Mountains Inn', 99, '2019-05-20', 108, NULL),
('Cute Mountains Inn', 99, '2019-05-21', 242, NULL),
('Cute Mountains Inn', 99, '2019-05-22', 284, NULL),
('Cute Mountains Inn', 99, '2019-05-23', 216, NULL),
('Cute Mountains Inn', 99, '2019-05-24', 111, NULL),
('Cute Mountains Inn', 99, '2019-05-25', 186, NULL),
('Cute Mountains Inn', 99, '2019-05-26', 302, NULL),
('Cute Mountains Inn', 99, '2019-05-27', 303, NULL),
('Cute Mountains Inn', 99, '2019-05-28', 213, NULL),
('Cute Mountains Inn', 99, '2019-05-29', 125, NULL),
('Cute Mountains Inn', 99, '2019-05-30', 127, NULL),
('Cute Mountains Inn', 99, '2019-05-31', 270, NULL),
('Cute Mountains Inn', 99, '2019-06-01', 244, NULL),
('Cute Mountains Inn', 99, '2019-06-02', 265, NULL),
('Cute Mountains Inn', 99, '2019-06-03', 251, NULL),
('Cute Mountains Inn', 99, '2019-06-04', 369, NULL),
('Cute Mountains Inn', 99, '2019-06-05', 104, NULL),
('Cute Mountains Inn', 99, '2019-06-06', 114, NULL),
('Cute Mountains Inn', 99, '2019-06-07', 370, NULL),
('Cute Mountains Inn', 99, '2019-06-08', 375, NULL),
('Cute Mountains Inn', 99, '2019-06-09', 135, NULL),
('Cute Mountains Inn', 99, '2019-06-10', 216, NULL),
('Cute Mountains Inn', 99, '2019-06-11', 339, NULL),
('Cute Mountains Inn', 99, '2019-06-12', 259, NULL),
('Cute Mountains Inn', 99, '2019-06-13', 169, NULL),
('Cute Mountains Inn', 99, '2019-06-14', 317, NULL),
('Cute Mountains Inn', 99, '2019-06-15', 242, NULL),
('Cute Mountains Inn', 99, '2019-06-16', 172, NULL),
('Cute Mountains Inn', 99, '2019-06-17', 204, NULL),
('Cute Mountains Inn', 99, '2019-06-18', 201, NULL),
('Cute Mountains Inn', 99, '2019-06-19', 265, NULL),
('Cute Mountains Inn', 99, '2019-06-20', 260, NULL),
('Cute Mountains Inn', 99, '2019-06-21', 118, NULL),
('Cute Mountains Inn', 99, '2019-06-22', 122, NULL),
('Cute Mountains Inn', 99, '2019-06-23', 365, NULL),
('Cute Mountains Inn', 99, '2019-06-24', 356, NULL),
('Cute Mountains Inn', 99, '2019-06-25', 118, NULL),
('Cute Mountains Inn', 99, '2019-06-26', 264, NULL),
('Cute Mountains Inn', 99, '2019-06-27', 267, NULL),
('Cute Mountains Inn', 99, '2019-06-28', 223, NULL),
('Cute Mountains Inn', 99, '2019-06-29', 266, NULL),
('Cute Mountains Inn', 99, '2019-06-30', 125, NULL),
('Cute Mountains Inn', 99, '2019-07-01', 258, NULL),
('Cute Mountains Inn', 99, '2019-07-02', 112, NULL),
('Cute Mountains Inn', 99, '2019-07-03', 346, NULL),
('Cute Mountains Inn', 99, '2019-07-04', 291, NULL),
('Cute Mountains Inn', 99, '2019-07-05', 156, NULL),
('Cute Mountains Inn', 99, '2019-07-06', 295, NULL),
('Cute Mountains Inn', 99, '2019-07-07', 315, NULL),
('Cute Mountains Inn', 99, '2019-07-08', 208, NULL),
('Cute Mountains Inn', 99, '2019-07-09', 390, NULL),
('Cute Mountains Inn', 99, '2019-07-10', 374, NULL),
('Cute Mountains Inn', 99, '2019-07-11', 129, NULL),
('Cute Mountains Inn', 99, '2019-07-12', 347, NULL),
('Cute Mountains Inn', 99, '2019-07-13', 289, NULL),
('Cute Mountains Inn', 99, '2019-07-14', 348, NULL),
('Cute Mountains Inn', 99, '2019-07-15', 163, NULL),
('Cute Mountains Inn', 99, '2019-07-16', 194, NULL),
('Cute Mountains Inn', 99, '2019-07-17', 106, NULL),
('Cute Mountains Inn', 99, '2019-07-18', 307, NULL),
('Cute Mountains Inn', 99, '2019-07-19', 283, NULL),
('Cute Mountains Inn', 99, '2019-07-20', 328, NULL),
('Cute Mountains Inn', 99, '2019-07-21', 221, NULL),
('Cute Mountains Inn', 99, '2019-07-22', 169, NULL),
('Cute Mountains Inn', 99, '2019-07-23', 128, NULL),
('Cute Mountains Inn', 99, '2019-07-24', 258, NULL),
('Cute Mountains Inn', 99, '2019-07-25', 343, NULL),
('Cute Mountains Inn', 99, '2019-07-26', 369, NULL),
('Cute Mountains Inn', 99, '2019-07-27', 142, NULL),
('Cute Mountains Inn', 99, '2019-07-28', 141, NULL),
('Cute Mountains Inn', 99, '2019-07-29', 103, NULL),
('Cute Mountains Inn', 99, '2019-07-30', 251, NULL),
('Cute Mountains Inn', 99, '2019-07-31', 338, NULL),
('Cute Mountains Inn', 99, '2019-08-01', 365, NULL),
('Cute Mountains Inn', 99, '2019-08-02', 113, NULL),
('Cute Mountains Inn', 99, '2019-08-03', 167, NULL),
('Cute Mountains Inn', 99, '2019-08-04', 249, NULL),
('Cute Mountains Inn', 99, '2019-08-05', 173, NULL),
('Cute Mountains Inn', 99, '2019-08-06', 203, NULL),
('Cute Mountains Inn', 99, '2019-08-07', 370, NULL),
('Cute Mountains Inn', 99, '2019-08-08', 376, NULL),
('Cute Mountains Inn', 99, '2019-08-09', 193, NULL),
('Cute Mountains Inn', 99, '2019-08-10', 233, NULL),
('Cute Mountains Inn', 99, '2019-08-11', 389, NULL),
('Cute Mountains Inn', 99, '2019-08-12', 375, NULL),
('Cute Mountains Inn', 99, '2019-08-13', 163, NULL),
('Cute Mountains Inn', 99, '2019-08-14', 194, NULL),
('Cute Mountains Inn', 99, '2019-08-15', 160, NULL),
('Cute Mountains Inn', 99, '2019-08-16', 147, NULL),
('Cute Mountains Inn', 99, '2019-08-17', 231, NULL),
('Cute Mountains Inn', 99, '2019-08-18', 154, NULL),
('Cute Mountains Inn', 99, '2019-08-19', 383, NULL),
('Cute Mountains Inn', 99, '2019-08-20', 391, NULL),
('Cute Mountains Inn', 99, '2019-08-21', 361, NULL),
('Cute Mountains Inn', 99, '2019-08-22', 281, NULL),
('Cute Mountains Inn', 99, '2019-08-23', 158, NULL),
('Cute Mountains Inn', 99, '2019-08-24', 104, NULL),
('Cute Mountains Inn', 99, '2019-08-25', 220, NULL),
('Cute Mountains Inn', 99, '2019-08-26', 213, NULL),
('Cute Mountains Inn', 99, '2019-08-27', 330, NULL),
('Cute Mountains Inn', 99, '2019-08-28', 100, NULL),
('Cute Mountains Inn', 99, '2019-08-29', 159, NULL),
('Cute Mountains Inn', 99, '2019-08-30', 118, NULL),
('Cute Mountains Inn', 99, '2019-08-31', 154, NULL),
('Cute Mountains Inn', 99, '2019-09-01', 332, NULL),
('Cute Mountains Inn', 99, '2019-09-02', 288, NULL),
('Cute Mountains Inn', 99, '2019-09-03', 150, NULL),
('Cute Mountains Inn', 99, '2019-09-04', 121, NULL),
('Cute Mountains Inn', 99, '2019-09-05', 271, NULL),
('Cute Mountains Inn', 99, '2019-09-06', 157, NULL),
('Cute Mountains Inn', 99, '2019-09-07', 322, NULL),
('Cute Mountains Inn', 99, '2019-09-08', 193, NULL),
('Cute Mountains Inn', 99, '2019-09-09', 148, NULL),
('Cute Mountains Inn', 99, '2019-09-10', 376, NULL),
('Cute Mountains Inn', 99, '2019-09-11', 380, NULL),
('Cute Mountains Inn', 99, '2019-09-12', 351, NULL),
('Cute Mountains Inn', 99, '2019-09-13', 324, NULL),
('Cute Mountains Inn', 99, '2019-09-14', 180, NULL),
('Cute Mountains Inn', 99, '2019-09-15', 288, NULL),
('Cute Mountains Inn', 99, '2019-09-16', 310, NULL),
('Cute Mountains Inn', 99, '2019-09-17', 127, NULL),
('Cute Mountains Inn', 99, '2019-09-18', 284, NULL),
('Cute Mountains Inn', 99, '2019-09-19', 147, NULL),
('Cute Mountains Inn', 99, '2019-09-20', 310, NULL),
('Cute Mountains Inn', 99, '2019-09-21', 308, NULL),
('Cute Mountains Inn', 99, '2019-09-22', 192, NULL),
('Cute Mountains Inn', 99, '2019-09-23', 288, NULL),
('Cute Mountains Inn', 99, '2019-09-24', 295, NULL),
('Cute Mountains Inn', 99, '2019-09-25', 379, NULL),
('Cute Mountains Inn', 99, '2019-09-26', 252, NULL),
('Cute Mountains Inn', 99, '2019-09-27', 132, NULL),
('Cute Mountains Inn', 99, '2019-09-28', 398, NULL),
('Cute Mountains Inn', 99, '2019-09-29', 292, NULL),
('Cute Mountains Inn', 99, '2019-09-30', 149, NULL),
('Cute Mountains Inn', 99, '2019-10-01', 217, NULL),
('Cute Mountains Inn', 99, '2019-10-02', 269, NULL),
('Cute Mountains Inn', 99, '2019-10-03', 343, NULL),
('Cute Mountains Inn', 99, '2019-10-04', 202, NULL),
('Cute Mountains Inn', 99, '2019-10-05', 391, NULL),
('Cute Mountains Inn', 99, '2019-10-06', 155, NULL),
('Cute Mountains Inn', 99, '2019-10-07', 350, NULL),
('Cute Mountains Inn', 99, '2019-10-08', 355, NULL),
('Cute Mountains Inn', 99, '2019-10-09', 270, NULL),
('Cute Mountains Inn', 99, '2019-10-10', 316, NULL),
('Cute Mountains Inn', 99, '2019-10-11', 320, NULL),
('Cute Mountains Inn', 99, '2019-10-12', 105, NULL),
('Cute Mountains Inn', 99, '2019-10-13', 156, NULL),
('Cute Mountains Inn', 99, '2019-10-14', 201, NULL),
('Cute Mountains Inn', 99, '2019-10-15', 205, NULL),
('Cute Mountains Inn', 99, '2019-10-16', 320, NULL),
('Cute Mountains Inn', 99, '2019-10-17', 170, NULL),
('Cute Mountains Inn', 99, '2019-10-18', 201, NULL),
('Cute Mountains Inn', 99, '2019-10-19', 117, NULL),
('Cute Mountains Inn', 99, '2019-10-20', 257, NULL),
('Cute Mountains Inn', 99, '2019-10-21', 140, NULL),
('Cute Mountains Inn', 99, '2019-10-22', 125, NULL),
('Cute Mountains Inn', 99, '2019-10-23', 379, NULL),
('Cute Mountains Inn', 99, '2019-10-24', 336, NULL),
('Cute Mountains Inn', 99, '2019-10-25', 116, NULL),
('Cute Mountains Inn', 99, '2019-10-26', 367, NULL),
('Cute Mountains Inn', 99, '2019-10-27', 375, NULL),
('Cute Mountains Inn', 99, '2019-10-28', 380, NULL),
('Cute Mountains Inn', 99, '2019-10-29', 348, NULL),
('Cute Mountains Inn', 99, '2019-10-30', 148, NULL),
('Cute Mountains Inn', 99, '2019-10-31', 194, NULL),
('Cute Mountains Inn', 99, '2019-11-01', 204, NULL),
('Cute Mountains Inn', 99, '2019-11-02', 223, NULL),
('Cute Mountains Inn', 99, '2019-11-03', 370, NULL),
('Cute Mountains Inn', 99, '2019-11-04', 339, NULL),
('Cute Mountains Inn', 99, '2019-11-05', 249, NULL),
('Cute Mountains Inn', 99, '2019-11-06', 207, NULL),
('Cute Mountains Inn', 99, '2019-11-07', 130, NULL),
('Cute Mountains Inn', 99, '2019-11-08', 268, NULL),
('Cute Mountains Inn', 99, '2019-11-09', 154, NULL),
('Cute Mountains Inn', 99, '2019-11-10', 200, NULL),
('Cute Mountains Inn', 99, '2019-11-11', 377, NULL),
('Cute Mountains Inn', 99, '2019-11-12', 393, NULL),
('Cute Mountains Inn', 99, '2019-11-13', 381, NULL),
('Cute Mountains Inn', 99, '2019-11-14', 103, NULL),
('Cute Mountains Inn', 99, '2019-11-15', 107, NULL),
('Cute Mountains Inn', 99, '2019-11-16', 281, NULL),
('Cute Mountains Inn', 99, '2019-11-17', 353, NULL),
('Cute Mountains Inn', 99, '2019-11-18', 392, NULL),
('Cute Mountains Inn', 99, '2019-11-19', 177, NULL),
('Cute Mountains Inn', 99, '2019-11-20', 306, NULL),
('Cute Mountains Inn', 99, '2019-11-21', 164, NULL),
('Cute Mountains Inn', 99, '2019-11-22', 307, NULL),
('Cute Mountains Inn', 99, '2019-11-23', 264, NULL),
('Cute Mountains Inn', 99, '2019-11-24', 392, NULL),
('Cute Mountains Inn', 99, '2019-11-25', 152, NULL),
('Cute Mountains Inn', 99, '2019-11-26', 368, NULL),
('Cute Mountains Inn', 99, '2019-11-27', 124, NULL),
('Cute Mountains Inn', 99, '2019-11-28', 110, NULL),
('Cute Mountains Inn', 99, '2019-11-29', 281, NULL),
('Cute Mountains Inn', 99, '2019-11-30', 150, NULL),
('Cute Mountains Inn', 99, '2019-12-01', 269, NULL),
('Cute Mountains Inn', 99, '2019-12-02', 195, NULL),
('Cute Mountains Inn', 99, '2019-12-03', 343, NULL),
('Cute Mountains Inn', 99, '2019-12-04', 363, NULL),
('Cute Mountains Inn', 99, '2019-12-05', 277, NULL),
('Cute Mountains Inn', 99, '2019-12-06', 181, NULL),
('Cute Mountains Inn', 99, '2019-12-07', 131, NULL),
('Cute Mountains Inn', 99, '2019-12-08', 211, NULL),
('Cute Mountains Inn', 99, '2019-12-09', 254, NULL),
('Cute Mountains Inn', 99, '2019-12-10', 332, NULL),
('Cute Mountains Inn', 99, '2019-12-11', 347, NULL),
('Cute Mountains Inn', 99, '2019-12-12', 119, NULL),
('Cute Mountains Inn', 99, '2019-12-13', 275, NULL),
('Cute Mountains Inn', 99, '2019-12-14', 234, NULL),
('Cute Mountains Inn', 99, '2019-12-15', 109, NULL),
('Cute Mountains Inn', 99, '2019-12-16', 208, NULL),
('Cute Mountains Inn', 99, '2019-12-17', 363, NULL),
('Cute Mountains Inn', 99, '2019-12-18', 170, NULL),
('Cute Mountains Inn', 99, '2019-12-19', 380, NULL),
('Cute Mountains Inn', 99, '2019-12-20', 375, NULL),
('Cute Mountains Inn', 99, '2019-12-21', 223, NULL),
('Cute Mountains Inn', 99, '2019-12-22', 101, NULL),
('Cute Mountains Inn', 99, '2019-12-23', 391, NULL),
('Cute Mountains Inn', 99, '2019-12-24', 231, NULL),
('Cute Mountains Inn', 99, '2019-12-25', 317, NULL),
('Cute Mountains Inn', 99, '2019-12-26', 126, NULL),
('Cute Mountains Inn', 99, '2019-12-27', 187, NULL),
('Cute Mountains Inn', 99, '2019-12-28', 189, NULL),
('Cute Mountains Inn', 99, '2019-12-29', 209, NULL),
('Cute Mountains Inn', 99, '2019-12-30', 231, NULL),
('Cute Mountains Inn', 99, '2019-12-31', 234, NULL),
('Cute Mountains Inn', 99, '2020-01-01', 316, NULL),
('Cute Mountains Inn', 99, '2020-01-02', 261, NULL),
('Cute Mountains Inn', 99, '2020-01-03', 316, NULL),
('Cute Mountains Inn', 99, '2020-01-04', 242, NULL),
('Cute Mountains Inn', 99, '2020-01-05', 368, NULL),
('Cute Mountains Inn', 99, '2020-01-06', 376, NULL),
('Cute Mountains Inn', 99, '2020-01-07', 130, NULL),
('Cute Mountains Inn', 99, '2020-01-08', 129, NULL),
('Cute Mountains Inn', 99, '2020-01-09', 111, NULL),
('Cute Mountains Inn', 99, '2020-01-10', 254, NULL),
('Cute Mountains Inn', 99, '2020-01-11', 221, NULL),
('Cute Mountains Inn', 99, '2020-01-12', 300, NULL),
('Cute Mountains Inn', 99, '2020-01-13', 384, NULL),
('Cute Mountains Inn', 99, '2020-01-14', 187, NULL),
('Cute Mountains Inn', 99, '2020-01-15', 333, NULL),
('Cute Mountains Inn', 99, '2020-01-16', 104, NULL),
('Cute Mountains Inn', 99, '2020-01-17', 189, NULL),
('Cute Mountains Inn', 99, '2020-01-18', 142, NULL),
('Cute Mountains Inn', 99, '2020-01-19', 359, NULL),
('Cute Mountains Inn', 99, '2020-01-20', 222, NULL),
('Cute Mountains Inn', 99, '2020-01-21', 319, NULL),
('Cute Mountains Inn', 99, '2020-01-22', 234, NULL),
('Cute Mountains Inn', 99, '2020-01-23', 245, NULL),
('Cute Mountains Inn', 99, '2020-01-24', 276, NULL),
('Cute Mountains Inn', 99, '2020-01-25', 150, NULL),
('Cute Mountains Inn', 99, '2020-01-26', 295, NULL),
('Cute Mountains Inn', 99, '2020-01-27', 325, NULL),
('Cute Mountains Inn', 99, '2020-01-28', 138, NULL),
('Cute Mountains Inn', 99, '2020-01-29', 310, NULL),
('Cute Mountains Inn', 99, '2020-01-30', 208, NULL),
('Cute Mountains Inn', 99, '2020-01-31', 312, NULL),
('Cute Mountains Inn', 99, '2020-02-01', 340, NULL),
('Cute Mountains Inn', 99, '2020-02-02', 360, NULL),
('Cute Mountains Inn', 99, '2020-02-03', 186, NULL),
('Cute Mountains Inn', 99, '2020-02-04', 358, NULL),
('Cute Mountains Inn', 109, '2019-01-01', 176, NULL),
('Cute Mountains Inn', 109, '2019-01-02', 190, NULL),
('Cute Mountains Inn', 109, '2019-01-03', 268, NULL),
('Cute Mountains Inn', 109, '2019-01-04', 247, NULL),
('Cute Mountains Inn', 109, '2019-01-05', 189, NULL),
('Cute Mountains Inn', 109, '2019-01-06', 249, NULL),
('Cute Mountains Inn', 109, '2019-01-07', 199, NULL),
('Cute Mountains Inn', 109, '2019-01-08', 205, NULL),
('Cute Mountains Inn', 109, '2019-01-09', 262, NULL),
('Cute Mountains Inn', 109, '2019-01-10', 312, NULL),
('Cute Mountains Inn', 109, '2019-01-11', 179, NULL),
('Cute Mountains Inn', 109, '2019-01-12', 143, NULL),
('Cute Mountains Inn', 109, '2019-01-13', 141, NULL),
('Cute Mountains Inn', 109, '2019-01-14', 167, NULL),
('Cute Mountains Inn', 109, '2019-01-15', 365, NULL),
('Cute Mountains Inn', 109, '2019-01-16', 389, NULL),
('Cute Mountains Inn', 109, '2019-01-17', 292, NULL),
('Cute Mountains Inn', 109, '2019-01-18', 195, NULL),
('Cute Mountains Inn', 109, '2019-01-19', 115, NULL),
('Cute Mountains Inn', 109, '2019-01-20', 302, NULL),
('Cute Mountains Inn', 109, '2019-01-21', 259, NULL),
('Cute Mountains Inn', 109, '2019-01-22', 320, NULL),
('Cute Mountains Inn', 109, '2019-01-23', 291, NULL),
('Cute Mountains Inn', 109, '2019-01-24', 299, NULL),
('Cute Mountains Inn', 109, '2019-01-25', 318, NULL),
('Cute Mountains Inn', 109, '2019-01-26', 229, NULL),
('Cute Mountains Inn', 109, '2019-01-27', 218, NULL),
('Cute Mountains Inn', 109, '2019-01-28', 195, NULL),
('Cute Mountains Inn', 109, '2019-01-29', 258, NULL),
('Cute Mountains Inn', 109, '2019-01-30', 250, NULL),
('Cute Mountains Inn', 109, '2019-01-31', 287, NULL),
('Cute Mountains Inn', 109, '2019-02-01', 120, NULL),
('Cute Mountains Inn', 109, '2019-02-02', 121, NULL),
('Cute Mountains Inn', 109, '2019-02-03', 112, NULL),
('Cute Mountains Inn', 109, '2019-02-04', 212, NULL),
('Cute Mountains Inn', 109, '2019-02-05', 195, NULL),
('Cute Mountains Inn', 109, '2019-02-06', 329, NULL),
('Cute Mountains Inn', 109, '2019-02-07', 148, NULL),
('Cute Mountains Inn', 109, '2019-02-08', 255, NULL),
('Cute Mountains Inn', 109, '2019-02-09', 176, NULL),
('Cute Mountains Inn', 109, '2019-02-10', 241, NULL),
('Cute Mountains Inn', 109, '2019-02-11', 200, NULL),
('Cute Mountains Inn', 109, '2019-02-12', 181, NULL),
('Cute Mountains Inn', 109, '2019-02-13', 227, NULL),
('Cute Mountains Inn', 109, '2019-02-14', 237, NULL),
('Cute Mountains Inn', 109, '2019-02-15', 221, NULL),
('Cute Mountains Inn', 109, '2019-02-16', 351, NULL),
('Cute Mountains Inn', 109, '2019-02-17', 113, NULL),
('Cute Mountains Inn', 109, '2019-02-18', 299, NULL),
('Cute Mountains Inn', 109, '2019-02-19', 271, NULL),
('Cute Mountains Inn', 109, '2019-02-20', 358, NULL),
('Cute Mountains Inn', 109, '2019-02-21', 153, NULL),
('Cute Mountains Inn', 109, '2019-02-22', 354, NULL),
('Cute Mountains Inn', 109, '2019-02-23', 215, NULL),
('Cute Mountains Inn', 109, '2019-02-24', 208, NULL),
('Cute Mountains Inn', 109, '2019-02-25', 301, NULL),
('Cute Mountains Inn', 109, '2019-02-26', 351, NULL),
('Cute Mountains Inn', 109, '2019-02-27', 187, NULL),
('Cute Mountains Inn', 109, '2019-02-28', 288, NULL),
('Cute Mountains Inn', 109, '2019-03-01', 204, NULL),
('Cute Mountains Inn', 109, '2019-03-02', 328, NULL),
('Cute Mountains Inn', 109, '2019-03-03', 152, NULL),
('Cute Mountains Inn', 109, '2019-03-04', 378, NULL),
('Cute Mountains Inn', 109, '2019-03-05', 178, NULL),
('Cute Mountains Inn', 109, '2019-03-06', 159, NULL),
('Cute Mountains Inn', 109, '2019-03-07', 312, NULL),
('Cute Mountains Inn', 109, '2019-03-08', 221, NULL),
('Cute Mountains Inn', 109, '2019-03-09', 206, NULL),
('Cute Mountains Inn', 109, '2019-03-10', 120, NULL),
('Cute Mountains Inn', 109, '2019-03-11', 177, NULL),
('Cute Mountains Inn', 109, '2019-03-12', 106, NULL),
('Cute Mountains Inn', 109, '2019-03-13', 275, NULL),
('Cute Mountains Inn', 109, '2019-03-14', 355, NULL),
('Cute Mountains Inn', 109, '2019-03-15', 391, NULL),
('Cute Mountains Inn', 109, '2019-03-16', 310, NULL),
('Cute Mountains Inn', 109, '2019-03-17', 276, NULL),
('Cute Mountains Inn', 109, '2019-03-18', 178, NULL),
('Cute Mountains Inn', 109, '2019-03-19', 190, NULL),
('Cute Mountains Inn', 109, '2019-03-20', 181, NULL),
('Cute Mountains Inn', 109, '2019-03-21', 294, NULL),
('Cute Mountains Inn', 109, '2019-03-22', 338, NULL),
('Cute Mountains Inn', 109, '2019-03-23', 169, NULL),
('Cute Mountains Inn', 109, '2019-03-24', 111, NULL),
('Cute Mountains Inn', 109, '2019-03-25', 372, NULL),
('Cute Mountains Inn', 109, '2019-03-26', 148, NULL),
('Cute Mountains Inn', 109, '2019-03-27', 188, NULL),
('Cute Mountains Inn', 109, '2019-03-28', 159, NULL),
('Cute Mountains Inn', 109, '2019-03-29', 357, NULL),
('Cute Mountains Inn', 109, '2019-03-30', 327, NULL),
('Cute Mountains Inn', 109, '2019-03-31', 135, NULL),
('Cute Mountains Inn', 109, '2019-04-01', 192, NULL),
('Cute Mountains Inn', 109, '2019-04-02', 285, NULL),
('Cute Mountains Inn', 109, '2019-04-03', 158, NULL),
('Cute Mountains Inn', 109, '2019-04-04', 380, NULL),
('Cute Mountains Inn', 109, '2019-04-05', 351, NULL),
('Cute Mountains Inn', 109, '2019-04-06', 394, NULL),
('Cute Mountains Inn', 109, '2019-04-07', 330, NULL),
('Cute Mountains Inn', 109, '2019-04-08', 351, NULL),
('Cute Mountains Inn', 109, '2019-04-09', 346, NULL),
('Cute Mountains Inn', 109, '2019-04-10', 351, NULL),
('Cute Mountains Inn', 109, '2019-04-11', 389, NULL),
('Cute Mountains Inn', 109, '2019-04-12', 251, NULL),
('Cute Mountains Inn', 109, '2019-04-13', 279, NULL),
('Cute Mountains Inn', 109, '2019-04-14', 384, NULL),
('Cute Mountains Inn', 109, '2019-04-15', 361, NULL),
('Cute Mountains Inn', 109, '2019-04-16', 394, NULL),
('Cute Mountains Inn', 109, '2019-04-17', 332, NULL),
('Cute Mountains Inn', 109, '2019-04-18', 391, NULL),
('Cute Mountains Inn', 109, '2019-04-19', 157, NULL),
('Cute Mountains Inn', 109, '2019-04-20', 206, NULL),
('Cute Mountains Inn', 109, '2019-04-21', 138, NULL),
('Cute Mountains Inn', 109, '2019-04-22', 264, NULL),
('Cute Mountains Inn', 109, '2019-04-23', 102, NULL),
('Cute Mountains Inn', 109, '2019-04-24', 149, NULL),
('Cute Mountains Inn', 109, '2019-04-25', 104, NULL),
('Cute Mountains Inn', 109, '2019-04-26', 337, NULL),
('Cute Mountains Inn', 109, '2019-04-27', 379, NULL),
('Cute Mountains Inn', 109, '2019-04-28', 368, NULL),
('Cute Mountains Inn', 109, '2019-04-29', 345, NULL),
('Cute Mountains Inn', 109, '2019-04-30', 308, NULL),
('Cute Mountains Inn', 109, '2019-05-01', 212, NULL),
('Cute Mountains Inn', 109, '2019-05-02', 304, NULL),
('Cute Mountains Inn', 109, '2019-05-03', 164, NULL),
('Cute Mountains Inn', 109, '2019-05-04', 232, NULL),
('Cute Mountains Inn', 109, '2019-05-05', 226, NULL),
('Cute Mountains Inn', 109, '2019-05-06', 370, NULL),
('Cute Mountains Inn', 109, '2019-05-07', 211, NULL),
('Cute Mountains Inn', 109, '2019-05-08', 390, NULL),
('Cute Mountains Inn', 109, '2019-05-09', 369, NULL),
('Cute Mountains Inn', 109, '2019-05-10', 200, NULL),
('Cute Mountains Inn', 109, '2019-05-11', 337, NULL),
('Cute Mountains Inn', 109, '2019-05-12', 154, NULL),
('Cute Mountains Inn', 109, '2019-05-13', 241, NULL),
('Cute Mountains Inn', 109, '2019-05-14', 219, NULL),
('Cute Mountains Inn', 109, '2019-05-15', 204, NULL),
('Cute Mountains Inn', 109, '2019-05-16', 270, NULL),
('Cute Mountains Inn', 109, '2019-05-17', 195, NULL),
('Cute Mountains Inn', 109, '2019-05-18', 395, NULL),
('Cute Mountains Inn', 109, '2019-05-19', 233, NULL),
('Cute Mountains Inn', 109, '2019-05-20', 389, NULL),
('Cute Mountains Inn', 109, '2019-05-21', 321, NULL),
('Cute Mountains Inn', 109, '2019-05-22', 165, NULL),
('Cute Mountains Inn', 109, '2019-05-23', 222, NULL),
('Cute Mountains Inn', 109, '2019-05-24', 382, NULL),
('Cute Mountains Inn', 109, '2019-05-25', 384, NULL),
('Cute Mountains Inn', 109, '2019-05-26', 291, NULL),
('Cute Mountains Inn', 109, '2019-05-27', 180, NULL),
('Cute Mountains Inn', 109, '2019-05-28', 272, NULL),
('Cute Mountains Inn', 109, '2019-05-29', 145, NULL),
('Cute Mountains Inn', 109, '2019-05-30', 258, NULL),
('Cute Mountains Inn', 109, '2019-05-31', 271, NULL),
('Cute Mountains Inn', 109, '2019-06-01', 211, NULL),
('Cute Mountains Inn', 109, '2019-06-02', 140, NULL),
('Cute Mountains Inn', 109, '2019-06-03', 196, NULL),
('Cute Mountains Inn', 109, '2019-06-04', 124, NULL),
('Cute Mountains Inn', 109, '2019-06-05', 259, NULL),
('Cute Mountains Inn', 109, '2019-06-06', 345, NULL),
('Cute Mountains Inn', 109, '2019-06-07', 366, NULL),
('Cute Mountains Inn', 109, '2019-06-08', 183, NULL),
('Cute Mountains Inn', 109, '2019-06-09', 122, NULL),
('Cute Mountains Inn', 109, '2019-06-10', 256, NULL),
('Cute Mountains Inn', 109, '2019-06-11', 305, NULL),
('Cute Mountains Inn', 109, '2019-06-12', 205, NULL),
('Cute Mountains Inn', 109, '2019-06-13', 378, NULL),
('Cute Mountains Inn', 109, '2019-06-14', 222, NULL),
('Cute Mountains Inn', 109, '2019-06-15', 257, NULL),
('Cute Mountains Inn', 109, '2019-06-16', 378, NULL),
('Cute Mountains Inn', 109, '2019-06-17', 152, NULL),
('Cute Mountains Inn', 109, '2019-06-18', 172, NULL),
('Cute Mountains Inn', 109, '2019-06-19', 377, NULL),
('Cute Mountains Inn', 109, '2019-06-20', 189, NULL),
('Cute Mountains Inn', 109, '2019-06-21', 389, NULL),
('Cute Mountains Inn', 109, '2019-06-22', 285, NULL),
('Cute Mountains Inn', 109, '2019-06-23', 346, NULL),
('Cute Mountains Inn', 109, '2019-06-24', 265, NULL),
('Cute Mountains Inn', 109, '2019-06-25', 194, NULL),
('Cute Mountains Inn', 109, '2019-06-26', 314, NULL),
('Cute Mountains Inn', 109, '2019-06-27', 191, NULL),
('Cute Mountains Inn', 109, '2019-06-28', 338, NULL),
('Cute Mountains Inn', 109, '2019-06-29', 240, NULL),
('Cute Mountains Inn', 109, '2019-06-30', 106, NULL),
('Cute Mountains Inn', 109, '2019-07-01', 186, NULL),
('Cute Mountains Inn', 109, '2019-07-02', 102, NULL),
('Cute Mountains Inn', 109, '2019-07-03', 376, NULL),
('Cute Mountains Inn', 109, '2019-07-04', 173, NULL),
('Cute Mountains Inn', 109, '2019-07-05', 234, NULL),
('Cute Mountains Inn', 109, '2019-07-06', 354, NULL),
('Cute Mountains Inn', 109, '2019-07-07', 130, NULL),
('Cute Mountains Inn', 109, '2019-07-08', 246, NULL),
('Cute Mountains Inn', 109, '2019-07-09', 180, NULL),
('Cute Mountains Inn', 109, '2019-07-10', 157, NULL),
('Cute Mountains Inn', 109, '2019-07-11', 239, NULL),
('Cute Mountains Inn', 109, '2019-07-12', 179, NULL),
('Cute Mountains Inn', 109, '2019-07-13', 146, NULL),
('Cute Mountains Inn', 109, '2019-07-14', 281, NULL),
('Cute Mountains Inn', 109, '2019-07-15', 264, NULL),
('Cute Mountains Inn', 109, '2019-07-16', 137, NULL),
('Cute Mountains Inn', 109, '2019-07-17', 320, NULL),
('Cute Mountains Inn', 109, '2019-07-18', 220, NULL),
('Cute Mountains Inn', 109, '2019-07-19', 353, NULL),
('Cute Mountains Inn', 109, '2019-07-20', 244, NULL),
('Cute Mountains Inn', 109, '2019-07-21', 252, NULL),
('Cute Mountains Inn', 109, '2019-07-22', 242, NULL),
('Cute Mountains Inn', 109, '2019-07-23', 180, NULL),
('Cute Mountains Inn', 109, '2019-07-24', 206, NULL),
('Cute Mountains Inn', 109, '2019-07-25', 301, NULL),
('Cute Mountains Inn', 109, '2019-07-26', 257, NULL),
('Cute Mountains Inn', 109, '2019-07-27', 303, NULL),
('Cute Mountains Inn', 109, '2019-07-28', 237, NULL),
('Cute Mountains Inn', 109, '2019-07-29', 263, NULL),
('Cute Mountains Inn', 109, '2019-07-30', 333, NULL),
('Cute Mountains Inn', 109, '2019-07-31', 385, NULL),
('Cute Mountains Inn', 109, '2019-08-01', 128, NULL),
('Cute Mountains Inn', 109, '2019-08-02', 387, NULL),
('Cute Mountains Inn', 109, '2019-08-03', 292, NULL),
('Cute Mountains Inn', 109, '2019-08-04', 287, NULL),
('Cute Mountains Inn', 109, '2019-08-05', 199, NULL),
('Cute Mountains Inn', 109, '2019-08-06', 357, NULL),
('Cute Mountains Inn', 109, '2019-08-07', 193, NULL),
('Cute Mountains Inn', 109, '2019-08-08', 286, NULL),
('Cute Mountains Inn', 109, '2019-08-09', 117, NULL),
('Cute Mountains Inn', 109, '2019-08-10', 306, NULL),
('Cute Mountains Inn', 109, '2019-08-11', 226, NULL),
('Cute Mountains Inn', 109, '2019-08-12', 151, NULL),
('Cute Mountains Inn', 109, '2019-08-13', 385, NULL),
('Cute Mountains Inn', 109, '2019-08-14', 169, NULL),
('Cute Mountains Inn', 109, '2019-08-15', 326, NULL),
('Cute Mountains Inn', 109, '2019-08-16', 182, NULL),
('Cute Mountains Inn', 109, '2019-08-17', 382, NULL),
('Cute Mountains Inn', 109, '2019-08-18', 380, NULL),
('Cute Mountains Inn', 109, '2019-08-19', 319, NULL),
('Cute Mountains Inn', 109, '2019-08-20', 335, NULL),
('Cute Mountains Inn', 109, '2019-08-21', 130, NULL),
('Cute Mountains Inn', 109, '2019-08-22', 205, NULL),
('Cute Mountains Inn', 109, '2019-08-23', 278, NULL),
('Cute Mountains Inn', 109, '2019-08-24', 184, NULL),
('Cute Mountains Inn', 109, '2019-08-25', 394, NULL),
('Cute Mountains Inn', 109, '2019-08-26', 115, NULL),
('Cute Mountains Inn', 109, '2019-08-27', 127, NULL),
('Cute Mountains Inn', 109, '2019-08-28', 326, NULL),
('Cute Mountains Inn', 109, '2019-08-29', 175, NULL),
('Cute Mountains Inn', 109, '2019-08-30', 336, NULL),
('Cute Mountains Inn', 109, '2019-08-31', 222, NULL),
('Cute Mountains Inn', 109, '2019-09-01', 326, NULL),
('Cute Mountains Inn', 109, '2019-09-02', 213, NULL),
('Cute Mountains Inn', 109, '2019-09-03', 240, NULL),
('Cute Mountains Inn', 109, '2019-09-04', 373, NULL),
('Cute Mountains Inn', 109, '2019-09-05', 252, NULL),
('Cute Mountains Inn', 109, '2019-09-06', 123, NULL),
('Cute Mountains Inn', 109, '2019-09-07', 118, NULL),
('Cute Mountains Inn', 109, '2019-09-08', 291, NULL),
('Cute Mountains Inn', 109, '2019-09-09', 333, NULL),
('Cute Mountains Inn', 109, '2019-09-10', 223, NULL),
('Cute Mountains Inn', 109, '2019-09-11', 214, NULL),
('Cute Mountains Inn', 109, '2019-09-12', 380, NULL),
('Cute Mountains Inn', 109, '2019-09-13', 111, NULL),
('Cute Mountains Inn', 109, '2019-09-14', 383, NULL),
('Cute Mountains Inn', 109, '2019-09-15', 134, NULL),
('Cute Mountains Inn', 109, '2019-09-16', 238, NULL),
('Cute Mountains Inn', 109, '2019-09-17', 230, NULL),
('Cute Mountains Inn', 109, '2019-09-18', 392, NULL),
('Cute Mountains Inn', 109, '2019-09-19', 290, NULL),
('Cute Mountains Inn', 109, '2019-09-20', 145, NULL),
('Cute Mountains Inn', 109, '2019-09-21', 259, NULL),
('Cute Mountains Inn', 109, '2019-09-22', 198, NULL),
('Cute Mountains Inn', 109, '2019-09-23', 370, NULL),
('Cute Mountains Inn', 109, '2019-09-24', 164, NULL),
('Cute Mountains Inn', 109, '2019-09-25', 243, NULL),
('Cute Mountains Inn', 109, '2019-09-26', 207, NULL),
('Cute Mountains Inn', 109, '2019-09-27', 101, NULL),
('Cute Mountains Inn', 109, '2019-09-28', 314, NULL),
('Cute Mountains Inn', 109, '2019-09-29', 284, NULL),
('Cute Mountains Inn', 109, '2019-09-30', 131, NULL),
('Cute Mountains Inn', 109, '2019-10-01', 309, NULL),
('Cute Mountains Inn', 109, '2019-10-02', 264, NULL),
('Cute Mountains Inn', 109, '2019-10-03', 231, NULL),
('Cute Mountains Inn', 109, '2019-10-04', 168, NULL),
('Cute Mountains Inn', 109, '2019-10-05', 130, NULL),
('Cute Mountains Inn', 109, '2019-10-06', 222, NULL),
('Cute Mountains Inn', 109, '2019-10-07', 162, NULL),
('Cute Mountains Inn', 109, '2019-10-08', 324, NULL),
('Cute Mountains Inn', 109, '2019-10-09', 131, NULL),
('Cute Mountains Inn', 109, '2019-10-10', 337, NULL),
('Cute Mountains Inn', 109, '2019-10-11', 174, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 109, '2019-10-12', 264, NULL),
('Cute Mountains Inn', 109, '2019-10-13', 167, NULL),
('Cute Mountains Inn', 109, '2019-10-14', 299, NULL),
('Cute Mountains Inn', 109, '2019-10-15', 274, NULL),
('Cute Mountains Inn', 109, '2019-10-16', 357, NULL),
('Cute Mountains Inn', 109, '2019-10-17', 268, NULL),
('Cute Mountains Inn', 109, '2019-10-18', 259, NULL),
('Cute Mountains Inn', 109, '2019-10-19', 243, NULL),
('Cute Mountains Inn', 109, '2019-10-20', 272, NULL),
('Cute Mountains Inn', 109, '2019-10-21', 116, NULL),
('Cute Mountains Inn', 109, '2019-10-22', 369, NULL),
('Cute Mountains Inn', 109, '2019-10-23', 333, NULL),
('Cute Mountains Inn', 109, '2019-10-24', 246, NULL),
('Cute Mountains Inn', 109, '2019-10-25', 168, NULL),
('Cute Mountains Inn', 109, '2019-10-26', 304, NULL),
('Cute Mountains Inn', 109, '2019-10-27', 150, NULL),
('Cute Mountains Inn', 109, '2019-10-28', 274, NULL),
('Cute Mountains Inn', 109, '2019-10-29', 299, NULL),
('Cute Mountains Inn', 109, '2019-10-30', 242, NULL),
('Cute Mountains Inn', 109, '2019-10-31', 284, NULL),
('Cute Mountains Inn', 109, '2019-11-01', 316, NULL),
('Cute Mountains Inn', 109, '2019-11-02', 238, NULL),
('Cute Mountains Inn', 109, '2019-11-03', 239, NULL),
('Cute Mountains Inn', 109, '2019-11-04', 317, NULL),
('Cute Mountains Inn', 109, '2019-11-05', 395, NULL),
('Cute Mountains Inn', 109, '2019-11-06', 297, NULL),
('Cute Mountains Inn', 109, '2019-11-07', 318, NULL),
('Cute Mountains Inn', 109, '2019-11-08', 159, NULL),
('Cute Mountains Inn', 109, '2019-11-09', 171, NULL),
('Cute Mountains Inn', 109, '2019-11-10', 116, NULL),
('Cute Mountains Inn', 109, '2019-11-11', 260, NULL),
('Cute Mountains Inn', 109, '2019-11-12', 333, NULL),
('Cute Mountains Inn', 109, '2019-11-13', 121, NULL),
('Cute Mountains Inn', 109, '2019-11-14', 211, NULL),
('Cute Mountains Inn', 109, '2019-11-15', 168, NULL),
('Cute Mountains Inn', 109, '2019-11-16', 148, NULL),
('Cute Mountains Inn', 109, '2019-11-17', 372, NULL),
('Cute Mountains Inn', 109, '2019-11-18', 286, NULL),
('Cute Mountains Inn', 109, '2019-11-19', 296, NULL),
('Cute Mountains Inn', 109, '2019-11-20', 128, NULL),
('Cute Mountains Inn', 109, '2019-11-21', 214, NULL),
('Cute Mountains Inn', 109, '2019-11-22', 170, NULL),
('Cute Mountains Inn', 109, '2019-11-23', 307, NULL),
('Cute Mountains Inn', 109, '2019-11-24', 198, NULL),
('Cute Mountains Inn', 109, '2019-11-25', 343, NULL),
('Cute Mountains Inn', 109, '2019-11-26', 120, NULL),
('Cute Mountains Inn', 109, '2019-11-27', 374, NULL),
('Cute Mountains Inn', 109, '2019-11-28', 361, NULL),
('Cute Mountains Inn', 109, '2019-11-29', 125, NULL),
('Cute Mountains Inn', 109, '2019-11-30', 373, NULL),
('Cute Mountains Inn', 109, '2019-12-01', 183, NULL),
('Cute Mountains Inn', 109, '2019-12-02', 221, NULL),
('Cute Mountains Inn', 109, '2019-12-03', 389, NULL),
('Cute Mountains Inn', 109, '2019-12-04', 184, NULL),
('Cute Mountains Inn', 109, '2019-12-05', 369, NULL),
('Cute Mountains Inn', 109, '2019-12-06', 191, NULL),
('Cute Mountains Inn', 109, '2019-12-07', 180, NULL),
('Cute Mountains Inn', 109, '2019-12-08', 125, NULL),
('Cute Mountains Inn', 109, '2019-12-09', 389, NULL),
('Cute Mountains Inn', 109, '2019-12-10', 396, NULL),
('Cute Mountains Inn', 109, '2019-12-11', 374, NULL),
('Cute Mountains Inn', 109, '2019-12-12', 315, NULL),
('Cute Mountains Inn', 109, '2019-12-13', 390, NULL),
('Cute Mountains Inn', 109, '2019-12-14', 250, NULL),
('Cute Mountains Inn', 109, '2019-12-15', 154, NULL),
('Cute Mountains Inn', 109, '2019-12-16', 156, NULL),
('Cute Mountains Inn', 109, '2019-12-17', 235, NULL),
('Cute Mountains Inn', 109, '2019-12-18', 369, NULL),
('Cute Mountains Inn', 109, '2019-12-19', 396, NULL),
('Cute Mountains Inn', 109, '2019-12-20', 394, NULL),
('Cute Mountains Inn', 109, '2019-12-21', 180, NULL),
('Cute Mountains Inn', 109, '2019-12-22', 320, NULL),
('Cute Mountains Inn', 109, '2019-12-23', 289, NULL),
('Cute Mountains Inn', 109, '2019-12-24', 128, NULL),
('Cute Mountains Inn', 109, '2019-12-25', 385, NULL),
('Cute Mountains Inn', 109, '2019-12-26', 224, NULL),
('Cute Mountains Inn', 109, '2019-12-27', 144, NULL),
('Cute Mountains Inn', 109, '2019-12-28', 164, NULL),
('Cute Mountains Inn', 109, '2019-12-29', 140, NULL),
('Cute Mountains Inn', 109, '2019-12-30', 200, NULL),
('Cute Mountains Inn', 109, '2019-12-31', 307, NULL),
('Cute Mountains Inn', 109, '2020-01-01', 149, NULL),
('Cute Mountains Inn', 109, '2020-01-02', 256, NULL),
('Cute Mountains Inn', 109, '2020-01-03', 215, NULL),
('Cute Mountains Inn', 109, '2020-01-04', 356, NULL),
('Cute Mountains Inn', 109, '2020-01-05', 176, NULL),
('Cute Mountains Inn', 109, '2020-01-06', 385, NULL),
('Cute Mountains Inn', 109, '2020-01-07', 152, NULL),
('Cute Mountains Inn', 109, '2020-01-08', 392, NULL),
('Cute Mountains Inn', 109, '2020-01-09', 166, NULL),
('Cute Mountains Inn', 109, '2020-01-10', 217, NULL),
('Cute Mountains Inn', 109, '2020-01-11', 301, NULL),
('Cute Mountains Inn', 109, '2020-01-12', 240, NULL),
('Cute Mountains Inn', 109, '2020-01-13', 209, NULL),
('Cute Mountains Inn', 109, '2020-01-14', 188, NULL),
('Cute Mountains Inn', 109, '2020-01-15', 305, NULL),
('Cute Mountains Inn', 109, '2020-01-16', 318, NULL),
('Cute Mountains Inn', 109, '2020-01-17', 187, NULL),
('Cute Mountains Inn', 109, '2020-01-18', 313, NULL),
('Cute Mountains Inn', 109, '2020-01-19', 284, NULL),
('Cute Mountains Inn', 109, '2020-01-20', 212, NULL),
('Cute Mountains Inn', 109, '2020-01-21', 213, NULL),
('Cute Mountains Inn', 109, '2020-01-22', 173, NULL),
('Cute Mountains Inn', 109, '2020-01-23', 243, NULL),
('Cute Mountains Inn', 109, '2020-01-24', 194, NULL),
('Cute Mountains Inn', 109, '2020-01-25', 234, NULL),
('Cute Mountains Inn', 109, '2020-01-26', 395, NULL),
('Cute Mountains Inn', 109, '2020-01-27', 365, NULL),
('Cute Mountains Inn', 109, '2020-01-28', 372, NULL),
('Cute Mountains Inn', 109, '2020-01-29', 282, NULL),
('Cute Mountains Inn', 109, '2020-01-30', 245, NULL),
('Cute Mountains Inn', 109, '2020-01-31', 392, NULL),
('Cute Mountains Inn', 109, '2020-02-01', 245, NULL),
('Cute Mountains Inn', 109, '2020-02-02', 111, NULL),
('Cute Mountains Inn', 109, '2020-02-03', 366, NULL),
('Cute Mountains Inn', 109, '2020-02-04', 369, NULL),
('Cute Mountains Inn', 111, '2019-01-01', 380, NULL),
('Cute Mountains Inn', 111, '2019-01-02', 108, NULL),
('Cute Mountains Inn', 111, '2019-01-03', 389, NULL),
('Cute Mountains Inn', 111, '2019-01-04', 246, NULL),
('Cute Mountains Inn', 111, '2019-01-05', 313, NULL),
('Cute Mountains Inn', 111, '2019-01-06', 149, NULL),
('Cute Mountains Inn', 111, '2019-01-07', 297, NULL),
('Cute Mountains Inn', 111, '2019-01-08', 391, NULL),
('Cute Mountains Inn', 111, '2019-01-09', 282, NULL),
('Cute Mountains Inn', 111, '2019-01-10', 151, NULL),
('Cute Mountains Inn', 111, '2019-01-11', 299, NULL),
('Cute Mountains Inn', 111, '2019-01-12', 328, NULL),
('Cute Mountains Inn', 111, '2019-01-13', 238, NULL),
('Cute Mountains Inn', 111, '2019-01-14', 167, NULL),
('Cute Mountains Inn', 111, '2019-01-15', 196, NULL),
('Cute Mountains Inn', 111, '2019-01-16', 326, NULL),
('Cute Mountains Inn', 111, '2019-01-17', 378, NULL),
('Cute Mountains Inn', 111, '2019-01-18', 148, NULL),
('Cute Mountains Inn', 111, '2019-01-19', 198, NULL),
('Cute Mountains Inn', 111, '2019-01-20', 338, NULL),
('Cute Mountains Inn', 111, '2019-01-21', 137, NULL),
('Cute Mountains Inn', 111, '2019-01-22', 183, NULL),
('Cute Mountains Inn', 111, '2019-01-23', 276, NULL),
('Cute Mountains Inn', 111, '2019-01-24', 383, NULL),
('Cute Mountains Inn', 111, '2019-01-25', 276, NULL),
('Cute Mountains Inn', 111, '2019-01-26', 340, NULL),
('Cute Mountains Inn', 111, '2019-01-27', 286, NULL),
('Cute Mountains Inn', 111, '2019-01-28', 141, NULL),
('Cute Mountains Inn', 111, '2019-01-29', 208, NULL),
('Cute Mountains Inn', 111, '2019-01-30', 337, NULL),
('Cute Mountains Inn', 111, '2019-01-31', 251, NULL),
('Cute Mountains Inn', 111, '2019-02-01', 251, NULL),
('Cute Mountains Inn', 111, '2019-02-02', 258, NULL),
('Cute Mountains Inn', 111, '2019-02-03', 152, NULL),
('Cute Mountains Inn', 111, '2019-02-04', 278, NULL),
('Cute Mountains Inn', 111, '2019-02-05', 257, NULL),
('Cute Mountains Inn', 111, '2019-02-06', 127, NULL),
('Cute Mountains Inn', 111, '2019-02-07', 162, NULL),
('Cute Mountains Inn', 111, '2019-02-08', 386, NULL),
('Cute Mountains Inn', 111, '2019-02-09', 266, NULL),
('Cute Mountains Inn', 111, '2019-02-10', 165, NULL),
('Cute Mountains Inn', 111, '2019-02-11', 140, NULL),
('Cute Mountains Inn', 111, '2019-02-12', 369, NULL),
('Cute Mountains Inn', 111, '2019-02-13', 103, NULL),
('Cute Mountains Inn', 111, '2019-02-14', 328, NULL),
('Cute Mountains Inn', 111, '2019-02-15', 275, NULL),
('Cute Mountains Inn', 111, '2019-02-16', 396, NULL),
('Cute Mountains Inn', 111, '2019-02-17', 147, NULL),
('Cute Mountains Inn', 111, '2019-02-18', 228, NULL),
('Cute Mountains Inn', 111, '2019-02-19', 208, NULL),
('Cute Mountains Inn', 111, '2019-02-20', 242, NULL),
('Cute Mountains Inn', 111, '2019-02-21', 397, NULL),
('Cute Mountains Inn', 111, '2019-02-22', 217, NULL),
('Cute Mountains Inn', 111, '2019-02-23', 347, NULL),
('Cute Mountains Inn', 111, '2019-02-24', 340, NULL),
('Cute Mountains Inn', 111, '2019-02-25', 154, NULL),
('Cute Mountains Inn', 111, '2019-02-26', 292, NULL),
('Cute Mountains Inn', 111, '2019-02-27', 344, NULL),
('Cute Mountains Inn', 111, '2019-02-28', 393, NULL),
('Cute Mountains Inn', 111, '2019-03-01', 239, NULL),
('Cute Mountains Inn', 111, '2019-03-02', 189, NULL),
('Cute Mountains Inn', 111, '2019-03-03', 252, NULL),
('Cute Mountains Inn', 111, '2019-03-04', 331, NULL),
('Cute Mountains Inn', 111, '2019-03-05', 301, NULL),
('Cute Mountains Inn', 111, '2019-03-06', 339, NULL),
('Cute Mountains Inn', 111, '2019-03-07', 260, NULL),
('Cute Mountains Inn', 111, '2019-03-08', 247, NULL),
('Cute Mountains Inn', 111, '2019-03-09', 312, NULL),
('Cute Mountains Inn', 111, '2019-03-10', 211, NULL),
('Cute Mountains Inn', 111, '2019-03-11', 304, NULL),
('Cute Mountains Inn', 111, '2019-03-12', 168, NULL),
('Cute Mountains Inn', 111, '2019-03-13', 352, NULL),
('Cute Mountains Inn', 111, '2019-03-14', 300, NULL),
('Cute Mountains Inn', 111, '2019-03-15', 349, NULL),
('Cute Mountains Inn', 111, '2019-03-16', 297, NULL),
('Cute Mountains Inn', 111, '2019-03-17', 266, NULL),
('Cute Mountains Inn', 111, '2019-03-18', 144, NULL),
('Cute Mountains Inn', 111, '2019-03-19', 100, NULL),
('Cute Mountains Inn', 111, '2019-03-20', 108, NULL),
('Cute Mountains Inn', 111, '2019-03-21', 390, NULL),
('Cute Mountains Inn', 111, '2019-03-22', 185, NULL),
('Cute Mountains Inn', 111, '2019-03-23', 311, NULL),
('Cute Mountains Inn', 111, '2019-03-24', 215, NULL),
('Cute Mountains Inn', 111, '2019-03-25', 300, NULL),
('Cute Mountains Inn', 111, '2019-03-26', 314, NULL),
('Cute Mountains Inn', 111, '2019-03-27', 110, NULL),
('Cute Mountains Inn', 111, '2019-03-28', 388, NULL),
('Cute Mountains Inn', 111, '2019-03-29', 280, NULL),
('Cute Mountains Inn', 111, '2019-03-30', 187, NULL),
('Cute Mountains Inn', 111, '2019-03-31', 305, NULL),
('Cute Mountains Inn', 111, '2019-04-01', 216, NULL),
('Cute Mountains Inn', 111, '2019-04-02', 365, NULL),
('Cute Mountains Inn', 111, '2019-04-03', 353, NULL),
('Cute Mountains Inn', 111, '2019-04-04', 205, NULL),
('Cute Mountains Inn', 111, '2019-04-05', 266, NULL),
('Cute Mountains Inn', 111, '2019-04-06', 383, NULL),
('Cute Mountains Inn', 111, '2019-04-07', 162, NULL),
('Cute Mountains Inn', 111, '2019-04-08', 325, NULL),
('Cute Mountains Inn', 111, '2019-04-09', 327, NULL),
('Cute Mountains Inn', 111, '2019-04-10', 138, NULL),
('Cute Mountains Inn', 111, '2019-04-11', 192, NULL),
('Cute Mountains Inn', 111, '2019-04-12', 145, NULL),
('Cute Mountains Inn', 111, '2019-04-13', 386, NULL),
('Cute Mountains Inn', 111, '2019-04-14', 135, NULL),
('Cute Mountains Inn', 111, '2019-04-15', 212, NULL),
('Cute Mountains Inn', 111, '2019-04-16', 398, NULL),
('Cute Mountains Inn', 111, '2019-04-17', 215, NULL),
('Cute Mountains Inn', 111, '2019-04-18', 204, NULL),
('Cute Mountains Inn', 111, '2019-04-19', 384, NULL),
('Cute Mountains Inn', 111, '2019-04-20', 386, NULL),
('Cute Mountains Inn', 111, '2019-04-21', 238, NULL),
('Cute Mountains Inn', 111, '2019-04-22', 120, NULL),
('Cute Mountains Inn', 111, '2019-04-23', 306, NULL),
('Cute Mountains Inn', 111, '2019-04-24', 361, NULL),
('Cute Mountains Inn', 111, '2019-04-25', 326, NULL),
('Cute Mountains Inn', 111, '2019-04-26', 130, NULL),
('Cute Mountains Inn', 111, '2019-04-27', 110, NULL),
('Cute Mountains Inn', 111, '2019-04-28', 276, NULL),
('Cute Mountains Inn', 111, '2019-04-29', 115, NULL),
('Cute Mountains Inn', 111, '2019-04-30', 263, NULL),
('Cute Mountains Inn', 111, '2019-05-01', 185, NULL),
('Cute Mountains Inn', 111, '2019-05-02', 241, NULL),
('Cute Mountains Inn', 111, '2019-05-03', 100, NULL),
('Cute Mountains Inn', 111, '2019-05-04', 394, NULL),
('Cute Mountains Inn', 111, '2019-05-05', 209, NULL),
('Cute Mountains Inn', 111, '2019-05-06', 158, NULL),
('Cute Mountains Inn', 111, '2019-05-07', 396, NULL),
('Cute Mountains Inn', 111, '2019-05-08', 267, NULL),
('Cute Mountains Inn', 111, '2019-05-09', 180, NULL),
('Cute Mountains Inn', 111, '2019-05-10', 158, NULL),
('Cute Mountains Inn', 111, '2019-05-11', 140, NULL),
('Cute Mountains Inn', 111, '2019-05-12', 183, NULL),
('Cute Mountains Inn', 111, '2019-05-13', 365, NULL),
('Cute Mountains Inn', 111, '2019-05-14', 168, NULL),
('Cute Mountains Inn', 111, '2019-05-15', 297, NULL),
('Cute Mountains Inn', 111, '2019-05-16', 281, NULL),
('Cute Mountains Inn', 111, '2019-05-17', 320, NULL),
('Cute Mountains Inn', 111, '2019-05-18', 358, NULL),
('Cute Mountains Inn', 111, '2019-05-19', 188, NULL),
('Cute Mountains Inn', 111, '2019-05-20', 321, NULL),
('Cute Mountains Inn', 111, '2019-05-21', 179, NULL),
('Cute Mountains Inn', 111, '2019-05-22', 171, NULL),
('Cute Mountains Inn', 111, '2019-05-23', 363, NULL),
('Cute Mountains Inn', 111, '2019-05-24', 279, NULL),
('Cute Mountains Inn', 111, '2019-05-25', 362, NULL),
('Cute Mountains Inn', 111, '2019-05-26', 150, NULL),
('Cute Mountains Inn', 111, '2019-05-27', 189, NULL),
('Cute Mountains Inn', 111, '2019-05-28', 324, NULL),
('Cute Mountains Inn', 111, '2019-05-29', 253, NULL),
('Cute Mountains Inn', 111, '2019-05-30', 209, NULL),
('Cute Mountains Inn', 111, '2019-05-31', 148, NULL),
('Cute Mountains Inn', 111, '2019-06-01', 223, NULL),
('Cute Mountains Inn', 111, '2019-06-02', 107, NULL),
('Cute Mountains Inn', 111, '2019-06-03', 130, NULL),
('Cute Mountains Inn', 111, '2019-06-04', 313, NULL),
('Cute Mountains Inn', 111, '2019-06-05', 284, NULL),
('Cute Mountains Inn', 111, '2019-06-06', 385, NULL),
('Cute Mountains Inn', 111, '2019-06-07', 323, NULL),
('Cute Mountains Inn', 111, '2019-06-08', 287, NULL),
('Cute Mountains Inn', 111, '2019-06-09', 106, NULL),
('Cute Mountains Inn', 111, '2019-06-10', 230, NULL),
('Cute Mountains Inn', 111, '2019-06-11', 108, NULL),
('Cute Mountains Inn', 111, '2019-06-12', 146, NULL),
('Cute Mountains Inn', 111, '2019-06-13', 384, NULL),
('Cute Mountains Inn', 111, '2019-06-14', 357, NULL),
('Cute Mountains Inn', 111, '2019-06-15', 156, NULL),
('Cute Mountains Inn', 111, '2019-06-16', 374, NULL),
('Cute Mountains Inn', 111, '2019-06-17', 349, NULL),
('Cute Mountains Inn', 111, '2019-06-18', 159, NULL),
('Cute Mountains Inn', 111, '2019-06-19', 392, NULL),
('Cute Mountains Inn', 111, '2019-06-20', 366, NULL),
('Cute Mountains Inn', 111, '2019-06-21', 291, NULL),
('Cute Mountains Inn', 111, '2019-06-22', 360, NULL),
('Cute Mountains Inn', 111, '2019-06-23', 234, NULL),
('Cute Mountains Inn', 111, '2019-06-24', 159, NULL),
('Cute Mountains Inn', 111, '2019-06-25', 217, NULL),
('Cute Mountains Inn', 111, '2019-06-26', 378, NULL),
('Cute Mountains Inn', 111, '2019-06-27', 355, NULL),
('Cute Mountains Inn', 111, '2019-06-28', 322, NULL),
('Cute Mountains Inn', 111, '2019-06-29', 304, NULL),
('Cute Mountains Inn', 111, '2019-06-30', 356, NULL),
('Cute Mountains Inn', 111, '2019-07-01', 357, NULL),
('Cute Mountains Inn', 111, '2019-07-02', 374, NULL),
('Cute Mountains Inn', 111, '2019-07-03', 140, NULL),
('Cute Mountains Inn', 111, '2019-07-04', 192, NULL),
('Cute Mountains Inn', 111, '2019-07-05', 302, NULL),
('Cute Mountains Inn', 111, '2019-07-06', 185, NULL),
('Cute Mountains Inn', 111, '2019-07-07', 204, NULL),
('Cute Mountains Inn', 111, '2019-07-08', 205, NULL),
('Cute Mountains Inn', 111, '2019-07-09', 228, NULL),
('Cute Mountains Inn', 111, '2019-07-10', 163, NULL),
('Cute Mountains Inn', 111, '2019-07-11', 108, NULL),
('Cute Mountains Inn', 111, '2019-07-12', 351, NULL),
('Cute Mountains Inn', 111, '2019-07-13', 367, NULL),
('Cute Mountains Inn', 111, '2019-07-14', 265, NULL),
('Cute Mountains Inn', 111, '2019-07-15', 131, NULL),
('Cute Mountains Inn', 111, '2019-07-16', 304, NULL),
('Cute Mountains Inn', 111, '2019-07-17', 283, NULL),
('Cute Mountains Inn', 111, '2019-07-18', 378, NULL),
('Cute Mountains Inn', 111, '2019-07-19', 218, NULL),
('Cute Mountains Inn', 111, '2019-07-20', 137, NULL),
('Cute Mountains Inn', 111, '2019-07-21', 198, NULL),
('Cute Mountains Inn', 111, '2019-07-22', 302, NULL),
('Cute Mountains Inn', 111, '2019-07-23', 117, NULL),
('Cute Mountains Inn', 111, '2019-07-24', 154, NULL),
('Cute Mountains Inn', 111, '2019-07-25', 374, NULL),
('Cute Mountains Inn', 111, '2019-07-26', 379, NULL),
('Cute Mountains Inn', 111, '2019-07-27', 392, NULL),
('Cute Mountains Inn', 111, '2019-07-28', 366, NULL),
('Cute Mountains Inn', 111, '2019-07-29', 306, NULL),
('Cute Mountains Inn', 111, '2019-07-30', 211, NULL),
('Cute Mountains Inn', 111, '2019-07-31', 211, NULL),
('Cute Mountains Inn', 111, '2019-08-01', 345, NULL),
('Cute Mountains Inn', 111, '2019-08-02', 296, NULL),
('Cute Mountains Inn', 111, '2019-08-03', 260, NULL),
('Cute Mountains Inn', 111, '2019-08-04', 287, NULL),
('Cute Mountains Inn', 111, '2019-08-05', 379, NULL),
('Cute Mountains Inn', 111, '2019-08-06', 174, NULL),
('Cute Mountains Inn', 111, '2019-08-07', 355, NULL),
('Cute Mountains Inn', 111, '2019-08-08', 206, NULL),
('Cute Mountains Inn', 111, '2019-08-09', 208, NULL),
('Cute Mountains Inn', 111, '2019-08-10', 132, NULL),
('Cute Mountains Inn', 111, '2019-08-11', 163, NULL),
('Cute Mountains Inn', 111, '2019-08-12', 129, NULL),
('Cute Mountains Inn', 111, '2019-08-13', 138, NULL),
('Cute Mountains Inn', 111, '2019-08-14', 164, NULL),
('Cute Mountains Inn', 111, '2019-08-15', 152, NULL),
('Cute Mountains Inn', 111, '2019-08-16', 370, NULL),
('Cute Mountains Inn', 111, '2019-08-17', 216, NULL),
('Cute Mountains Inn', 111, '2019-08-18', 135, NULL),
('Cute Mountains Inn', 111, '2019-08-19', 343, NULL),
('Cute Mountains Inn', 111, '2019-08-20', 104, NULL),
('Cute Mountains Inn', 111, '2019-08-21', 369, NULL),
('Cute Mountains Inn', 111, '2019-08-22', 382, NULL),
('Cute Mountains Inn', 111, '2019-08-23', 217, NULL),
('Cute Mountains Inn', 111, '2019-08-24', 209, NULL),
('Cute Mountains Inn', 111, '2019-08-25', 309, NULL),
('Cute Mountains Inn', 111, '2019-08-26', 135, NULL),
('Cute Mountains Inn', 111, '2019-08-27', 143, NULL),
('Cute Mountains Inn', 111, '2019-08-28', 329, NULL),
('Cute Mountains Inn', 111, '2019-08-29', 297, NULL),
('Cute Mountains Inn', 111, '2019-08-30', 330, NULL),
('Cute Mountains Inn', 111, '2019-08-31', 249, NULL),
('Cute Mountains Inn', 111, '2019-09-01', 234, NULL),
('Cute Mountains Inn', 111, '2019-09-02', 101, NULL),
('Cute Mountains Inn', 111, '2019-09-03', 348, NULL),
('Cute Mountains Inn', 111, '2019-09-04', 203, NULL),
('Cute Mountains Inn', 111, '2019-09-05', 348, NULL),
('Cute Mountains Inn', 111, '2019-09-06', 347, NULL),
('Cute Mountains Inn', 111, '2019-09-07', 124, NULL),
('Cute Mountains Inn', 111, '2019-09-08', 177, NULL),
('Cute Mountains Inn', 111, '2019-09-09', 222, NULL),
('Cute Mountains Inn', 111, '2019-09-10', 187, NULL),
('Cute Mountains Inn', 111, '2019-09-11', 129, NULL),
('Cute Mountains Inn', 111, '2019-09-12', 146, NULL),
('Cute Mountains Inn', 111, '2019-09-13', 384, NULL),
('Cute Mountains Inn', 111, '2019-09-14', 375, NULL),
('Cute Mountains Inn', 111, '2019-09-15', 305, NULL),
('Cute Mountains Inn', 111, '2019-09-16', 162, NULL),
('Cute Mountains Inn', 111, '2019-09-17', 371, NULL),
('Cute Mountains Inn', 111, '2019-09-18', 107, NULL),
('Cute Mountains Inn', 111, '2019-09-19', 312, NULL),
('Cute Mountains Inn', 111, '2019-09-20', 294, NULL),
('Cute Mountains Inn', 111, '2019-09-21', 272, NULL),
('Cute Mountains Inn', 111, '2019-09-22', 311, NULL),
('Cute Mountains Inn', 111, '2019-09-23', 284, NULL),
('Cute Mountains Inn', 111, '2019-09-24', 135, NULL),
('Cute Mountains Inn', 111, '2019-09-25', 279, NULL),
('Cute Mountains Inn', 111, '2019-09-26', 181, NULL),
('Cute Mountains Inn', 111, '2019-09-27', 309, NULL),
('Cute Mountains Inn', 111, '2019-09-28', 277, NULL),
('Cute Mountains Inn', 111, '2019-09-29', 144, NULL),
('Cute Mountains Inn', 111, '2019-09-30', 108, NULL),
('Cute Mountains Inn', 111, '2019-10-01', 195, NULL),
('Cute Mountains Inn', 111, '2019-10-02', 110, NULL),
('Cute Mountains Inn', 111, '2019-10-03', 324, NULL),
('Cute Mountains Inn', 111, '2019-10-04', 138, NULL),
('Cute Mountains Inn', 111, '2019-10-05', 280, NULL),
('Cute Mountains Inn', 111, '2019-10-06', 245, NULL),
('Cute Mountains Inn', 111, '2019-10-07', 263, NULL),
('Cute Mountains Inn', 111, '2019-10-08', 157, NULL),
('Cute Mountains Inn', 111, '2019-10-09', 344, NULL),
('Cute Mountains Inn', 111, '2019-10-10', 335, NULL),
('Cute Mountains Inn', 111, '2019-10-11', 110, NULL),
('Cute Mountains Inn', 111, '2019-10-12', 307, NULL),
('Cute Mountains Inn', 111, '2019-10-13', 266, NULL),
('Cute Mountains Inn', 111, '2019-10-14', 194, NULL),
('Cute Mountains Inn', 111, '2019-10-15', 357, NULL),
('Cute Mountains Inn', 111, '2019-10-16', 128, NULL),
('Cute Mountains Inn', 111, '2019-10-17', 129, NULL),
('Cute Mountains Inn', 111, '2019-10-18', 289, NULL),
('Cute Mountains Inn', 111, '2019-10-19', 167, NULL),
('Cute Mountains Inn', 111, '2019-10-20', 192, NULL),
('Cute Mountains Inn', 111, '2019-10-21', 361, NULL),
('Cute Mountains Inn', 111, '2019-10-22', 170, NULL),
('Cute Mountains Inn', 111, '2019-10-23', 127, NULL),
('Cute Mountains Inn', 111, '2019-10-24', 124, NULL),
('Cute Mountains Inn', 111, '2019-10-25', 394, NULL),
('Cute Mountains Inn', 111, '2019-10-26', 322, NULL),
('Cute Mountains Inn', 111, '2019-10-27', 127, NULL),
('Cute Mountains Inn', 111, '2019-10-28', 129, NULL),
('Cute Mountains Inn', 111, '2019-10-29', 352, NULL),
('Cute Mountains Inn', 111, '2019-10-30', 367, NULL),
('Cute Mountains Inn', 111, '2019-10-31', 140, NULL),
('Cute Mountains Inn', 111, '2019-11-01', 270, NULL),
('Cute Mountains Inn', 111, '2019-11-02', 120, NULL),
('Cute Mountains Inn', 111, '2019-11-03', 285, NULL),
('Cute Mountains Inn', 111, '2019-11-04', 169, NULL),
('Cute Mountains Inn', 111, '2019-11-05', 230, NULL),
('Cute Mountains Inn', 111, '2019-11-06', 162, NULL),
('Cute Mountains Inn', 111, '2019-11-07', 202, NULL),
('Cute Mountains Inn', 111, '2019-11-08', 192, NULL),
('Cute Mountains Inn', 111, '2019-11-09', 295, NULL),
('Cute Mountains Inn', 111, '2019-11-10', 182, NULL),
('Cute Mountains Inn', 111, '2019-11-11', 367, NULL),
('Cute Mountains Inn', 111, '2019-11-12', 389, NULL),
('Cute Mountains Inn', 111, '2019-11-13', 262, NULL),
('Cute Mountains Inn', 111, '2019-11-14', 347, NULL),
('Cute Mountains Inn', 111, '2019-11-15', 120, NULL),
('Cute Mountains Inn', 111, '2019-11-16', 100, NULL),
('Cute Mountains Inn', 111, '2019-11-17', 100, NULL),
('Cute Mountains Inn', 111, '2019-11-18', 156, NULL),
('Cute Mountains Inn', 111, '2019-11-19', 250, NULL),
('Cute Mountains Inn', 111, '2019-11-20', 222, NULL),
('Cute Mountains Inn', 111, '2019-11-21', 177, NULL),
('Cute Mountains Inn', 111, '2019-11-22', 128, NULL),
('Cute Mountains Inn', 111, '2019-11-23', 345, NULL),
('Cute Mountains Inn', 111, '2019-11-24', 314, NULL),
('Cute Mountains Inn', 111, '2019-11-25', 262, NULL),
('Cute Mountains Inn', 111, '2019-11-26', 295, NULL),
('Cute Mountains Inn', 111, '2019-11-27', 198, NULL),
('Cute Mountains Inn', 111, '2019-11-28', 175, NULL),
('Cute Mountains Inn', 111, '2019-11-29', 283, NULL),
('Cute Mountains Inn', 111, '2019-11-30', 115, NULL),
('Cute Mountains Inn', 111, '2019-12-01', 309, NULL),
('Cute Mountains Inn', 111, '2019-12-02', 124, NULL),
('Cute Mountains Inn', 111, '2019-12-03', 219, NULL),
('Cute Mountains Inn', 111, '2019-12-04', 330, NULL),
('Cute Mountains Inn', 111, '2019-12-05', 314, NULL),
('Cute Mountains Inn', 111, '2019-12-06', 311, NULL),
('Cute Mountains Inn', 111, '2019-12-07', 109, NULL),
('Cute Mountains Inn', 111, '2019-12-08', 194, NULL),
('Cute Mountains Inn', 111, '2019-12-09', 183, NULL),
('Cute Mountains Inn', 111, '2019-12-10', 283, NULL),
('Cute Mountains Inn', 111, '2019-12-11', 131, NULL),
('Cute Mountains Inn', 111, '2019-12-12', 221, NULL),
('Cute Mountains Inn', 111, '2019-12-13', 124, NULL),
('Cute Mountains Inn', 111, '2019-12-14', 149, NULL),
('Cute Mountains Inn', 111, '2019-12-15', 342, NULL),
('Cute Mountains Inn', 111, '2019-12-16', 359, NULL),
('Cute Mountains Inn', 111, '2019-12-17', 283, NULL),
('Cute Mountains Inn', 111, '2019-12-18', 334, NULL),
('Cute Mountains Inn', 111, '2019-12-19', 142, NULL),
('Cute Mountains Inn', 111, '2019-12-20', 148, NULL),
('Cute Mountains Inn', 111, '2019-12-21', 129, NULL),
('Cute Mountains Inn', 111, '2019-12-22', 297, NULL),
('Cute Mountains Inn', 111, '2019-12-23', 171, NULL),
('Cute Mountains Inn', 111, '2019-12-24', 145, NULL),
('Cute Mountains Inn', 111, '2019-12-25', 272, NULL),
('Cute Mountains Inn', 111, '2019-12-26', 342, NULL),
('Cute Mountains Inn', 111, '2019-12-27', 359, NULL),
('Cute Mountains Inn', 111, '2019-12-28', 152, NULL),
('Cute Mountains Inn', 111, '2019-12-29', 273, NULL),
('Cute Mountains Inn', 111, '2019-12-30', 209, NULL),
('Cute Mountains Inn', 111, '2019-12-31', 133, NULL),
('Cute Mountains Inn', 111, '2020-01-01', 300, NULL),
('Cute Mountains Inn', 111, '2020-01-02', 397, NULL),
('Cute Mountains Inn', 111, '2020-01-03', 328, NULL),
('Cute Mountains Inn', 111, '2020-01-04', 355, NULL),
('Cute Mountains Inn', 111, '2020-01-05', 275, NULL),
('Cute Mountains Inn', 111, '2020-01-06', 394, NULL),
('Cute Mountains Inn', 111, '2020-01-07', 271, NULL),
('Cute Mountains Inn', 111, '2020-01-08', 272, NULL),
('Cute Mountains Inn', 111, '2020-01-09', 396, NULL),
('Cute Mountains Inn', 111, '2020-01-10', 226, NULL),
('Cute Mountains Inn', 111, '2020-01-11', 142, NULL),
('Cute Mountains Inn', 111, '2020-01-12', 201, NULL),
('Cute Mountains Inn', 111, '2020-01-13', 395, NULL),
('Cute Mountains Inn', 111, '2020-01-14', 280, NULL),
('Cute Mountains Inn', 111, '2020-01-15', 130, NULL),
('Cute Mountains Inn', 111, '2020-01-16', 279, NULL),
('Cute Mountains Inn', 111, '2020-01-17', 268, NULL),
('Cute Mountains Inn', 111, '2020-01-18', 136, NULL),
('Cute Mountains Inn', 111, '2020-01-19', 241, NULL),
('Cute Mountains Inn', 111, '2020-01-20', 291, NULL),
('Cute Mountains Inn', 111, '2020-01-21', 306, NULL),
('Cute Mountains Inn', 111, '2020-01-22', 361, NULL),
('Cute Mountains Inn', 111, '2020-01-23', 383, NULL),
('Cute Mountains Inn', 111, '2020-01-24', 342, NULL),
('Cute Mountains Inn', 111, '2020-01-25', 323, NULL),
('Cute Mountains Inn', 111, '2020-01-26', 389, NULL),
('Cute Mountains Inn', 111, '2020-01-27', 150, NULL),
('Cute Mountains Inn', 111, '2020-01-28', 148, NULL),
('Cute Mountains Inn', 111, '2020-01-29', 380, NULL),
('Cute Mountains Inn', 111, '2020-01-30', 205, NULL),
('Cute Mountains Inn', 111, '2020-01-31', 326, NULL),
('Cute Mountains Inn', 111, '2020-02-01', 105, NULL),
('Cute Mountains Inn', 111, '2020-02-02', 275, NULL),
('Cute Mountains Inn', 111, '2020-02-03', 273, NULL),
('Cute Mountains Inn', 111, '2020-02-04', 372, NULL),
('Cute Mountains Inn', 119, '2019-01-01', 373, NULL),
('Cute Mountains Inn', 119, '2019-01-02', 173, NULL),
('Cute Mountains Inn', 119, '2019-01-03', 144, NULL),
('Cute Mountains Inn', 119, '2019-01-04', 389, NULL),
('Cute Mountains Inn', 119, '2019-01-05', 300, NULL),
('Cute Mountains Inn', 119, '2019-01-06', 202, NULL),
('Cute Mountains Inn', 119, '2019-01-07', 188, NULL),
('Cute Mountains Inn', 119, '2019-01-08', 341, NULL),
('Cute Mountains Inn', 119, '2019-01-09', 225, NULL),
('Cute Mountains Inn', 119, '2019-01-10', 318, NULL),
('Cute Mountains Inn', 119, '2019-01-11', 260, NULL),
('Cute Mountains Inn', 119, '2019-01-12', 214, NULL),
('Cute Mountains Inn', 119, '2019-01-13', 369, NULL),
('Cute Mountains Inn', 119, '2019-01-14', 236, NULL),
('Cute Mountains Inn', 119, '2019-01-15', 385, NULL),
('Cute Mountains Inn', 119, '2019-01-16', 365, NULL),
('Cute Mountains Inn', 119, '2019-01-17', 314, NULL),
('Cute Mountains Inn', 119, '2019-01-18', 356, NULL),
('Cute Mountains Inn', 119, '2019-01-19', 246, NULL),
('Cute Mountains Inn', 119, '2019-01-20', 387, NULL),
('Cute Mountains Inn', 119, '2019-01-21', 107, NULL),
('Cute Mountains Inn', 119, '2019-01-22', 158, NULL),
('Cute Mountains Inn', 119, '2019-01-23', 108, NULL),
('Cute Mountains Inn', 119, '2019-01-24', 315, NULL),
('Cute Mountains Inn', 119, '2019-01-25', 328, NULL),
('Cute Mountains Inn', 119, '2019-01-26', 315, NULL),
('Cute Mountains Inn', 119, '2019-01-27', 375, NULL),
('Cute Mountains Inn', 119, '2019-01-28', 319, NULL),
('Cute Mountains Inn', 119, '2019-01-29', 165, NULL),
('Cute Mountains Inn', 119, '2019-01-30', 235, NULL),
('Cute Mountains Inn', 119, '2019-01-31', 295, NULL),
('Cute Mountains Inn', 119, '2019-02-01', 194, NULL),
('Cute Mountains Inn', 119, '2019-02-02', 226, NULL),
('Cute Mountains Inn', 119, '2019-02-03', 323, NULL),
('Cute Mountains Inn', 119, '2019-02-04', 354, NULL),
('Cute Mountains Inn', 119, '2019-02-05', 302, NULL),
('Cute Mountains Inn', 119, '2019-02-06', 150, NULL),
('Cute Mountains Inn', 119, '2019-02-07', 267, NULL),
('Cute Mountains Inn', 119, '2019-02-08', 165, NULL),
('Cute Mountains Inn', 119, '2019-02-09', 104, NULL),
('Cute Mountains Inn', 119, '2019-02-10', 302, NULL),
('Cute Mountains Inn', 119, '2019-02-11', 300, NULL),
('Cute Mountains Inn', 119, '2019-02-12', 299, NULL),
('Cute Mountains Inn', 119, '2019-02-13', 334, NULL),
('Cute Mountains Inn', 119, '2019-02-14', 228, NULL),
('Cute Mountains Inn', 119, '2019-02-15', 312, NULL),
('Cute Mountains Inn', 119, '2019-02-16', 225, NULL),
('Cute Mountains Inn', 119, '2019-02-17', 295, NULL),
('Cute Mountains Inn', 119, '2019-02-18', 143, NULL),
('Cute Mountains Inn', 119, '2019-02-19', 130, NULL),
('Cute Mountains Inn', 119, '2019-02-20', 336, NULL),
('Cute Mountains Inn', 119, '2019-02-21', 225, NULL),
('Cute Mountains Inn', 119, '2019-02-22', 223, NULL),
('Cute Mountains Inn', 119, '2019-02-23', 390, NULL),
('Cute Mountains Inn', 119, '2019-02-24', 379, NULL),
('Cute Mountains Inn', 119, '2019-02-25', 370, NULL),
('Cute Mountains Inn', 119, '2019-02-26', 308, NULL),
('Cute Mountains Inn', 119, '2019-02-27', 159, NULL),
('Cute Mountains Inn', 119, '2019-02-28', 100, NULL),
('Cute Mountains Inn', 119, '2019-03-01', 186, NULL),
('Cute Mountains Inn', 119, '2019-03-02', 160, NULL),
('Cute Mountains Inn', 119, '2019-03-03', 105, NULL),
('Cute Mountains Inn', 119, '2019-03-04', 121, NULL),
('Cute Mountains Inn', 119, '2019-03-05', 269, NULL),
('Cute Mountains Inn', 119, '2019-03-06', 215, NULL),
('Cute Mountains Inn', 119, '2019-03-07', 266, NULL),
('Cute Mountains Inn', 119, '2019-03-08', 170, NULL),
('Cute Mountains Inn', 119, '2019-03-09', 244, NULL),
('Cute Mountains Inn', 119, '2019-03-10', 296, NULL),
('Cute Mountains Inn', 119, '2019-03-11', 292, NULL),
('Cute Mountains Inn', 119, '2019-03-12', 121, NULL),
('Cute Mountains Inn', 119, '2019-03-13', 237, NULL),
('Cute Mountains Inn', 119, '2019-03-14', 335, NULL),
('Cute Mountains Inn', 119, '2019-03-15', 176, NULL),
('Cute Mountains Inn', 119, '2019-03-16', 157, NULL),
('Cute Mountains Inn', 119, '2019-03-17', 101, NULL),
('Cute Mountains Inn', 119, '2019-03-18', 388, NULL),
('Cute Mountains Inn', 119, '2019-03-19', 130, NULL),
('Cute Mountains Inn', 119, '2019-03-20', 196, NULL),
('Cute Mountains Inn', 119, '2019-03-21', 368, NULL),
('Cute Mountains Inn', 119, '2019-03-22', 110, NULL),
('Cute Mountains Inn', 119, '2019-03-23', 348, NULL),
('Cute Mountains Inn', 119, '2019-03-24', 341, NULL),
('Cute Mountains Inn', 119, '2019-03-25', 285, NULL),
('Cute Mountains Inn', 119, '2019-03-26', 127, NULL),
('Cute Mountains Inn', 119, '2019-03-27', 186, NULL),
('Cute Mountains Inn', 119, '2019-03-28', 163, NULL),
('Cute Mountains Inn', 119, '2019-03-29', 228, NULL),
('Cute Mountains Inn', 119, '2019-03-30', 157, NULL),
('Cute Mountains Inn', 119, '2019-03-31', 120, NULL),
('Cute Mountains Inn', 119, '2019-04-01', 107, NULL),
('Cute Mountains Inn', 119, '2019-04-02', 268, NULL),
('Cute Mountains Inn', 119, '2019-04-03', 290, NULL),
('Cute Mountains Inn', 119, '2019-04-04', 384, NULL),
('Cute Mountains Inn', 119, '2019-04-05', 180, NULL),
('Cute Mountains Inn', 119, '2019-04-06', 334, NULL),
('Cute Mountains Inn', 119, '2019-04-07', 320, NULL),
('Cute Mountains Inn', 119, '2019-04-08', 170, NULL),
('Cute Mountains Inn', 119, '2019-04-09', 196, NULL),
('Cute Mountains Inn', 119, '2019-04-10', 137, NULL),
('Cute Mountains Inn', 119, '2019-04-11', 291, NULL),
('Cute Mountains Inn', 119, '2019-04-12', 176, NULL),
('Cute Mountains Inn', 119, '2019-04-13', 395, NULL),
('Cute Mountains Inn', 119, '2019-04-14', 322, NULL),
('Cute Mountains Inn', 119, '2019-04-15', 175, NULL),
('Cute Mountains Inn', 119, '2019-04-16', 106, NULL),
('Cute Mountains Inn', 119, '2019-04-17', 280, NULL),
('Cute Mountains Inn', 119, '2019-04-18', 345, NULL),
('Cute Mountains Inn', 119, '2019-04-19', 151, NULL),
('Cute Mountains Inn', 119, '2019-04-20', 314, NULL),
('Cute Mountains Inn', 119, '2019-04-21', 378, NULL),
('Cute Mountains Inn', 119, '2019-04-22', 310, NULL),
('Cute Mountains Inn', 119, '2019-04-23', 225, NULL),
('Cute Mountains Inn', 119, '2019-04-24', 357, NULL),
('Cute Mountains Inn', 119, '2019-04-25', 317, NULL),
('Cute Mountains Inn', 119, '2019-04-26', 136, NULL),
('Cute Mountains Inn', 119, '2019-04-27', 213, NULL),
('Cute Mountains Inn', 119, '2019-04-28', 177, NULL),
('Cute Mountains Inn', 119, '2019-04-29', 337, NULL),
('Cute Mountains Inn', 119, '2019-04-30', 292, NULL),
('Cute Mountains Inn', 119, '2019-05-01', 190, NULL),
('Cute Mountains Inn', 119, '2019-05-02', 194, NULL),
('Cute Mountains Inn', 119, '2019-05-03', 206, NULL),
('Cute Mountains Inn', 119, '2019-05-04', 276, NULL),
('Cute Mountains Inn', 119, '2019-05-05', 269, NULL),
('Cute Mountains Inn', 119, '2019-05-06', 182, NULL),
('Cute Mountains Inn', 119, '2019-05-07', 348, NULL),
('Cute Mountains Inn', 119, '2019-05-08', 367, NULL),
('Cute Mountains Inn', 119, '2019-05-09', 296, NULL),
('Cute Mountains Inn', 119, '2019-05-10', 389, NULL),
('Cute Mountains Inn', 119, '2019-05-11', 188, NULL),
('Cute Mountains Inn', 119, '2019-05-12', 352, NULL),
('Cute Mountains Inn', 119, '2019-05-13', 103, NULL),
('Cute Mountains Inn', 119, '2019-05-14', 385, NULL),
('Cute Mountains Inn', 119, '2019-05-15', 174, NULL),
('Cute Mountains Inn', 119, '2019-05-16', 196, NULL),
('Cute Mountains Inn', 119, '2019-05-17', 316, NULL),
('Cute Mountains Inn', 119, '2019-05-18', 207, NULL),
('Cute Mountains Inn', 119, '2019-05-19', 143, NULL),
('Cute Mountains Inn', 119, '2019-05-20', 338, NULL),
('Cute Mountains Inn', 119, '2019-05-21', 134, NULL),
('Cute Mountains Inn', 119, '2019-05-22', 262, NULL),
('Cute Mountains Inn', 119, '2019-05-23', 148, NULL),
('Cute Mountains Inn', 119, '2019-05-24', 146, NULL),
('Cute Mountains Inn', 119, '2019-05-25', 259, NULL),
('Cute Mountains Inn', 119, '2019-05-26', 379, NULL),
('Cute Mountains Inn', 119, '2019-05-27', 307, NULL),
('Cute Mountains Inn', 119, '2019-05-28', 105, NULL),
('Cute Mountains Inn', 119, '2019-05-29', 131, NULL),
('Cute Mountains Inn', 119, '2019-05-30', 173, NULL),
('Cute Mountains Inn', 119, '2019-05-31', 127, NULL),
('Cute Mountains Inn', 119, '2019-06-01', 384, NULL),
('Cute Mountains Inn', 119, '2019-06-02', 315, NULL),
('Cute Mountains Inn', 119, '2019-06-03', 261, NULL),
('Cute Mountains Inn', 119, '2019-06-04', 195, NULL),
('Cute Mountains Inn', 119, '2019-06-05', 243, NULL),
('Cute Mountains Inn', 119, '2019-06-06', 189, NULL),
('Cute Mountains Inn', 119, '2019-06-07', 114, NULL),
('Cute Mountains Inn', 119, '2019-06-08', 189, NULL),
('Cute Mountains Inn', 119, '2019-06-09', 366, NULL),
('Cute Mountains Inn', 119, '2019-06-10', 283, NULL),
('Cute Mountains Inn', 119, '2019-06-11', 126, NULL),
('Cute Mountains Inn', 119, '2019-06-12', 319, NULL),
('Cute Mountains Inn', 119, '2019-06-13', 384, NULL),
('Cute Mountains Inn', 119, '2019-06-14', 119, NULL),
('Cute Mountains Inn', 119, '2019-06-15', 212, NULL),
('Cute Mountains Inn', 119, '2019-06-16', 337, NULL),
('Cute Mountains Inn', 119, '2019-06-17', 291, NULL),
('Cute Mountains Inn', 119, '2019-06-18', 179, NULL),
('Cute Mountains Inn', 119, '2019-06-19', 130, NULL),
('Cute Mountains Inn', 119, '2019-06-20', 261, NULL),
('Cute Mountains Inn', 119, '2019-06-21', 190, NULL),
('Cute Mountains Inn', 119, '2019-06-22', 245, NULL),
('Cute Mountains Inn', 119, '2019-06-23', 333, NULL),
('Cute Mountains Inn', 119, '2019-06-24', 201, NULL),
('Cute Mountains Inn', 119, '2019-06-25', 101, NULL),
('Cute Mountains Inn', 119, '2019-06-26', 248, NULL),
('Cute Mountains Inn', 119, '2019-06-27', 202, NULL),
('Cute Mountains Inn', 119, '2019-06-28', 198, NULL),
('Cute Mountains Inn', 119, '2019-06-29', 399, NULL),
('Cute Mountains Inn', 119, '2019-06-30', 163, NULL),
('Cute Mountains Inn', 119, '2019-07-01', 227, NULL),
('Cute Mountains Inn', 119, '2019-07-02', 265, NULL),
('Cute Mountains Inn', 119, '2019-07-03', 374, NULL),
('Cute Mountains Inn', 119, '2019-07-04', 343, NULL),
('Cute Mountains Inn', 119, '2019-07-05', 109, NULL),
('Cute Mountains Inn', 119, '2019-07-06', 364, NULL),
('Cute Mountains Inn', 119, '2019-07-07', 234, NULL),
('Cute Mountains Inn', 119, '2019-07-08', 189, NULL),
('Cute Mountains Inn', 119, '2019-07-09', 203, NULL),
('Cute Mountains Inn', 119, '2019-07-10', 244, NULL),
('Cute Mountains Inn', 119, '2019-07-11', 323, NULL),
('Cute Mountains Inn', 119, '2019-07-12', 220, NULL),
('Cute Mountains Inn', 119, '2019-07-13', 396, NULL),
('Cute Mountains Inn', 119, '2019-07-14', 380, NULL),
('Cute Mountains Inn', 119, '2019-07-15', 364, NULL),
('Cute Mountains Inn', 119, '2019-07-16', 110, NULL),
('Cute Mountains Inn', 119, '2019-07-17', 353, NULL),
('Cute Mountains Inn', 119, '2019-07-18', 231, NULL),
('Cute Mountains Inn', 119, '2019-07-19', 228, NULL),
('Cute Mountains Inn', 119, '2019-07-20', 153, NULL),
('Cute Mountains Inn', 119, '2019-07-21', 135, NULL),
('Cute Mountains Inn', 119, '2019-07-22', 387, NULL),
('Cute Mountains Inn', 119, '2019-07-23', 245, NULL),
('Cute Mountains Inn', 119, '2019-07-24', 355, NULL),
('Cute Mountains Inn', 119, '2019-07-25', 271, NULL),
('Cute Mountains Inn', 119, '2019-07-26', 125, NULL),
('Cute Mountains Inn', 119, '2019-07-27', 350, NULL),
('Cute Mountains Inn', 119, '2019-07-28', 117, NULL),
('Cute Mountains Inn', 119, '2019-07-29', 343, NULL),
('Cute Mountains Inn', 119, '2019-07-30', 257, NULL),
('Cute Mountains Inn', 119, '2019-07-31', 102, NULL),
('Cute Mountains Inn', 119, '2019-08-01', 344, NULL),
('Cute Mountains Inn', 119, '2019-08-02', 218, NULL),
('Cute Mountains Inn', 119, '2019-08-03', 323, NULL),
('Cute Mountains Inn', 119, '2019-08-04', 175, NULL),
('Cute Mountains Inn', 119, '2019-08-05', 297, NULL),
('Cute Mountains Inn', 119, '2019-08-06', 299, NULL),
('Cute Mountains Inn', 119, '2019-08-07', 197, NULL),
('Cute Mountains Inn', 119, '2019-08-08', 371, NULL),
('Cute Mountains Inn', 119, '2019-08-09', 287, NULL),
('Cute Mountains Inn', 119, '2019-08-10', 242, NULL),
('Cute Mountains Inn', 119, '2019-08-11', 338, NULL),
('Cute Mountains Inn', 119, '2019-08-12', 395, NULL),
('Cute Mountains Inn', 119, '2019-08-13', 336, NULL),
('Cute Mountains Inn', 119, '2019-08-14', 213, NULL),
('Cute Mountains Inn', 119, '2019-08-15', 284, NULL),
('Cute Mountains Inn', 119, '2019-08-16', 305, NULL),
('Cute Mountains Inn', 119, '2019-08-17', 137, NULL),
('Cute Mountains Inn', 119, '2019-08-18', 338, NULL),
('Cute Mountains Inn', 119, '2019-08-19', 359, NULL),
('Cute Mountains Inn', 119, '2019-08-20', 314, NULL),
('Cute Mountains Inn', 119, '2019-08-21', 154, NULL),
('Cute Mountains Inn', 119, '2019-08-22', 297, NULL),
('Cute Mountains Inn', 119, '2019-08-23', 151, NULL),
('Cute Mountains Inn', 119, '2019-08-24', 392, NULL),
('Cute Mountains Inn', 119, '2019-08-25', 264, NULL),
('Cute Mountains Inn', 119, '2019-08-26', 233, NULL),
('Cute Mountains Inn', 119, '2019-08-27', 236, NULL),
('Cute Mountains Inn', 119, '2019-08-28', 270, NULL),
('Cute Mountains Inn', 119, '2019-08-29', 259, NULL),
('Cute Mountains Inn', 119, '2019-08-30', 243, NULL),
('Cute Mountains Inn', 119, '2019-08-31', 181, NULL),
('Cute Mountains Inn', 119, '2019-09-01', 393, NULL),
('Cute Mountains Inn', 119, '2019-09-02', 366, NULL),
('Cute Mountains Inn', 119, '2019-09-03', 321, NULL),
('Cute Mountains Inn', 119, '2019-09-04', 397, NULL),
('Cute Mountains Inn', 119, '2019-09-05', 286, NULL),
('Cute Mountains Inn', 119, '2019-09-06', 367, NULL),
('Cute Mountains Inn', 119, '2019-09-07', 168, NULL),
('Cute Mountains Inn', 119, '2019-09-08', 211, NULL),
('Cute Mountains Inn', 119, '2019-09-09', 312, NULL),
('Cute Mountains Inn', 119, '2019-09-10', 168, NULL),
('Cute Mountains Inn', 119, '2019-09-11', 206, NULL),
('Cute Mountains Inn', 119, '2019-09-12', 390, NULL),
('Cute Mountains Inn', 119, '2019-09-13', 286, NULL),
('Cute Mountains Inn', 119, '2019-09-14', 327, NULL),
('Cute Mountains Inn', 119, '2019-09-15', 122, NULL),
('Cute Mountains Inn', 119, '2019-09-16', 294, NULL),
('Cute Mountains Inn', 119, '2019-09-17', 165, NULL),
('Cute Mountains Inn', 119, '2019-09-18', 158, NULL),
('Cute Mountains Inn', 119, '2019-09-19', 290, NULL),
('Cute Mountains Inn', 119, '2019-09-20', 335, NULL),
('Cute Mountains Inn', 119, '2019-09-21', 185, NULL),
('Cute Mountains Inn', 119, '2019-09-22', 265, NULL),
('Cute Mountains Inn', 119, '2019-09-23', 213, NULL),
('Cute Mountains Inn', 119, '2019-09-24', 385, NULL),
('Cute Mountains Inn', 119, '2019-09-25', 266, NULL),
('Cute Mountains Inn', 119, '2019-09-26', 185, NULL),
('Cute Mountains Inn', 119, '2019-09-27', 242, NULL),
('Cute Mountains Inn', 119, '2019-09-28', 342, NULL),
('Cute Mountains Inn', 119, '2019-09-29', 368, NULL),
('Cute Mountains Inn', 119, '2019-09-30', 348, NULL),
('Cute Mountains Inn', 119, '2019-10-01', 249, NULL),
('Cute Mountains Inn', 119, '2019-10-02', 261, NULL),
('Cute Mountains Inn', 119, '2019-10-03', 230, NULL),
('Cute Mountains Inn', 119, '2019-10-04', 383, NULL),
('Cute Mountains Inn', 119, '2019-10-05', 309, NULL),
('Cute Mountains Inn', 119, '2019-10-06', 160, NULL),
('Cute Mountains Inn', 119, '2019-10-07', 127, NULL),
('Cute Mountains Inn', 119, '2019-10-08', 314, NULL),
('Cute Mountains Inn', 119, '2019-10-09', 330, NULL),
('Cute Mountains Inn', 119, '2019-10-10', 267, NULL),
('Cute Mountains Inn', 119, '2019-10-11', 229, NULL),
('Cute Mountains Inn', 119, '2019-10-12', 344, NULL),
('Cute Mountains Inn', 119, '2019-10-13', 132, NULL),
('Cute Mountains Inn', 119, '2019-10-14', 272, NULL),
('Cute Mountains Inn', 119, '2019-10-15', 263, NULL),
('Cute Mountains Inn', 119, '2019-10-16', 366, NULL),
('Cute Mountains Inn', 119, '2019-10-17', 343, NULL),
('Cute Mountains Inn', 119, '2019-10-18', 271, NULL),
('Cute Mountains Inn', 119, '2019-10-19', 308, NULL),
('Cute Mountains Inn', 119, '2019-10-20', 343, NULL),
('Cute Mountains Inn', 119, '2019-10-21', 156, NULL),
('Cute Mountains Inn', 119, '2019-10-22', 244, NULL),
('Cute Mountains Inn', 119, '2019-10-23', 139, NULL),
('Cute Mountains Inn', 119, '2019-10-24', 379, NULL),
('Cute Mountains Inn', 119, '2019-10-25', 165, NULL),
('Cute Mountains Inn', 119, '2019-10-26', 297, NULL),
('Cute Mountains Inn', 119, '2019-10-27', 383, NULL),
('Cute Mountains Inn', 119, '2019-10-28', 326, NULL),
('Cute Mountains Inn', 119, '2019-10-29', 164, NULL),
('Cute Mountains Inn', 119, '2019-10-30', 111, NULL),
('Cute Mountains Inn', 119, '2019-10-31', 347, NULL),
('Cute Mountains Inn', 119, '2019-11-01', 301, NULL),
('Cute Mountains Inn', 119, '2019-11-02', 388, NULL),
('Cute Mountains Inn', 119, '2019-11-03', 309, NULL),
('Cute Mountains Inn', 119, '2019-11-04', 395, NULL),
('Cute Mountains Inn', 119, '2019-11-05', 163, NULL),
('Cute Mountains Inn', 119, '2019-11-06', 121, NULL),
('Cute Mountains Inn', 119, '2019-11-07', 258, NULL),
('Cute Mountains Inn', 119, '2019-11-08', 385, NULL),
('Cute Mountains Inn', 119, '2019-11-09', 260, NULL),
('Cute Mountains Inn', 119, '2019-11-10', 164, NULL),
('Cute Mountains Inn', 119, '2019-11-11', 358, NULL),
('Cute Mountains Inn', 119, '2019-11-12', 247, NULL),
('Cute Mountains Inn', 119, '2019-11-13', 251, NULL),
('Cute Mountains Inn', 119, '2019-11-14', 100, NULL),
('Cute Mountains Inn', 119, '2019-11-15', 297, NULL),
('Cute Mountains Inn', 119, '2019-11-16', 255, NULL),
('Cute Mountains Inn', 119, '2019-11-17', 188, NULL),
('Cute Mountains Inn', 119, '2019-11-18', 122, NULL),
('Cute Mountains Inn', 119, '2019-11-19', 261, NULL),
('Cute Mountains Inn', 119, '2019-11-20', 329, NULL),
('Cute Mountains Inn', 119, '2019-11-21', 147, NULL),
('Cute Mountains Inn', 119, '2019-11-22', 330, NULL),
('Cute Mountains Inn', 119, '2019-11-23', 104, NULL),
('Cute Mountains Inn', 119, '2019-11-24', 275, NULL),
('Cute Mountains Inn', 119, '2019-11-25', 179, NULL),
('Cute Mountains Inn', 119, '2019-11-26', 115, NULL),
('Cute Mountains Inn', 119, '2019-11-27', 368, NULL),
('Cute Mountains Inn', 119, '2019-11-28', 293, NULL),
('Cute Mountains Inn', 119, '2019-11-29', 341, NULL),
('Cute Mountains Inn', 119, '2019-11-30', 257, NULL),
('Cute Mountains Inn', 119, '2019-12-01', 295, NULL),
('Cute Mountains Inn', 119, '2019-12-02', 155, NULL),
('Cute Mountains Inn', 119, '2019-12-03', 127, NULL),
('Cute Mountains Inn', 119, '2019-12-04', 101, NULL),
('Cute Mountains Inn', 119, '2019-12-05', 365, NULL),
('Cute Mountains Inn', 119, '2019-12-06', 284, NULL),
('Cute Mountains Inn', 119, '2019-12-07', 205, NULL),
('Cute Mountains Inn', 119, '2019-12-08', 194, NULL),
('Cute Mountains Inn', 119, '2019-12-09', 250, NULL),
('Cute Mountains Inn', 119, '2019-12-10', 127, NULL),
('Cute Mountains Inn', 119, '2019-12-11', 334, NULL),
('Cute Mountains Inn', 119, '2019-12-12', 358, NULL),
('Cute Mountains Inn', 119, '2019-12-13', 250, NULL),
('Cute Mountains Inn', 119, '2019-12-14', 195, NULL),
('Cute Mountains Inn', 119, '2019-12-15', 250, NULL),
('Cute Mountains Inn', 119, '2019-12-16', 326, NULL),
('Cute Mountains Inn', 119, '2019-12-17', 314, NULL),
('Cute Mountains Inn', 119, '2019-12-18', 167, NULL),
('Cute Mountains Inn', 119, '2019-12-19', 321, NULL),
('Cute Mountains Inn', 119, '2019-12-20', 356, NULL),
('Cute Mountains Inn', 119, '2019-12-21', 305, NULL),
('Cute Mountains Inn', 119, '2019-12-22', 126, NULL),
('Cute Mountains Inn', 119, '2019-12-23', 187, NULL),
('Cute Mountains Inn', 119, '2019-12-24', 243, NULL),
('Cute Mountains Inn', 119, '2019-12-25', 104, NULL),
('Cute Mountains Inn', 119, '2019-12-26', 340, NULL),
('Cute Mountains Inn', 119, '2019-12-27', 363, NULL),
('Cute Mountains Inn', 119, '2019-12-28', 169, NULL),
('Cute Mountains Inn', 119, '2019-12-29', 245, NULL),
('Cute Mountains Inn', 119, '2019-12-30', 343, NULL),
('Cute Mountains Inn', 119, '2019-12-31', 246, NULL),
('Cute Mountains Inn', 119, '2020-01-01', 353, NULL),
('Cute Mountains Inn', 119, '2020-01-02', 219, NULL),
('Cute Mountains Inn', 119, '2020-01-03', 294, NULL),
('Cute Mountains Inn', 119, '2020-01-04', 306, NULL),
('Cute Mountains Inn', 119, '2020-01-05', 146, NULL),
('Cute Mountains Inn', 119, '2020-01-06', 119, NULL),
('Cute Mountains Inn', 119, '2020-01-07', 201, NULL),
('Cute Mountains Inn', 119, '2020-01-08', 384, NULL),
('Cute Mountains Inn', 119, '2020-01-09', 182, NULL),
('Cute Mountains Inn', 119, '2020-01-10', 377, NULL),
('Cute Mountains Inn', 119, '2020-01-11', 309, NULL),
('Cute Mountains Inn', 119, '2020-01-12', 187, NULL),
('Cute Mountains Inn', 119, '2020-01-13', 346, NULL),
('Cute Mountains Inn', 119, '2020-01-14', 135, NULL),
('Cute Mountains Inn', 119, '2020-01-15', 234, NULL),
('Cute Mountains Inn', 119, '2020-01-16', 342, NULL),
('Cute Mountains Inn', 119, '2020-01-17', 379, NULL),
('Cute Mountains Inn', 119, '2020-01-18', 242, NULL),
('Cute Mountains Inn', 119, '2020-01-19', 253, NULL),
('Cute Mountains Inn', 119, '2020-01-20', 121, NULL),
('Cute Mountains Inn', 119, '2020-01-21', 194, NULL),
('Cute Mountains Inn', 119, '2020-01-22', 286, NULL),
('Cute Mountains Inn', 119, '2020-01-23', 184, NULL),
('Cute Mountains Inn', 119, '2020-01-24', 131, NULL),
('Cute Mountains Inn', 119, '2020-01-25', 212, NULL),
('Cute Mountains Inn', 119, '2020-01-26', 361, NULL),
('Cute Mountains Inn', 119, '2020-01-27', 156, NULL),
('Cute Mountains Inn', 119, '2020-01-28', 126, NULL),
('Cute Mountains Inn', 119, '2020-01-29', 356, NULL),
('Cute Mountains Inn', 119, '2020-01-30', 188, NULL),
('Cute Mountains Inn', 119, '2020-01-31', 352, NULL),
('Cute Mountains Inn', 119, '2020-02-01', 292, NULL),
('Cute Mountains Inn', 119, '2020-02-02', 340, NULL),
('Cute Mountains Inn', 119, '2020-02-03', 166, NULL),
('Cute Mountains Inn', 119, '2020-02-04', 353, NULL),
('Cute Mountains Inn', 122, '2019-01-01', 323, NULL),
('Cute Mountains Inn', 122, '2019-01-02', 143, NULL),
('Cute Mountains Inn', 122, '2019-01-03', 350, NULL),
('Cute Mountains Inn', 122, '2019-01-04', 208, NULL),
('Cute Mountains Inn', 122, '2019-01-05', 160, NULL),
('Cute Mountains Inn', 122, '2019-01-06', 161, NULL),
('Cute Mountains Inn', 122, '2019-01-07', 250, NULL),
('Cute Mountains Inn', 122, '2019-01-08', 133, NULL),
('Cute Mountains Inn', 122, '2019-01-09', 178, NULL),
('Cute Mountains Inn', 122, '2019-01-10', 137, NULL),
('Cute Mountains Inn', 122, '2019-01-11', 305, NULL),
('Cute Mountains Inn', 122, '2019-01-12', 285, NULL),
('Cute Mountains Inn', 122, '2019-01-13', 129, NULL),
('Cute Mountains Inn', 122, '2019-01-14', 279, NULL),
('Cute Mountains Inn', 122, '2019-01-15', 337, NULL),
('Cute Mountains Inn', 122, '2019-01-16', 146, NULL),
('Cute Mountains Inn', 122, '2019-01-17', 338, NULL),
('Cute Mountains Inn', 122, '2019-01-18', 335, NULL),
('Cute Mountains Inn', 122, '2019-01-19', 237, NULL),
('Cute Mountains Inn', 122, '2019-01-20', 221, NULL),
('Cute Mountains Inn', 122, '2019-01-21', 326, NULL),
('Cute Mountains Inn', 122, '2019-01-22', 142, NULL),
('Cute Mountains Inn', 122, '2019-01-23', 214, NULL),
('Cute Mountains Inn', 122, '2019-01-24', 327, NULL),
('Cute Mountains Inn', 122, '2019-01-25', 112, NULL),
('Cute Mountains Inn', 122, '2019-01-26', 157, NULL),
('Cute Mountains Inn', 122, '2019-01-27', 319, NULL),
('Cute Mountains Inn', 122, '2019-01-28', 171, NULL),
('Cute Mountains Inn', 122, '2019-01-29', 102, NULL),
('Cute Mountains Inn', 122, '2019-01-30', 362, NULL),
('Cute Mountains Inn', 122, '2019-01-31', 322, NULL),
('Cute Mountains Inn', 122, '2019-02-01', 119, NULL),
('Cute Mountains Inn', 122, '2019-02-02', 259, NULL),
('Cute Mountains Inn', 122, '2019-02-03', 161, NULL),
('Cute Mountains Inn', 122, '2019-02-04', 236, NULL),
('Cute Mountains Inn', 122, '2019-02-05', 338, NULL),
('Cute Mountains Inn', 122, '2019-02-06', 270, NULL),
('Cute Mountains Inn', 122, '2019-02-07', 149, NULL),
('Cute Mountains Inn', 122, '2019-02-08', 165, NULL),
('Cute Mountains Inn', 122, '2019-02-09', 220, NULL),
('Cute Mountains Inn', 122, '2019-02-10', 314, NULL),
('Cute Mountains Inn', 122, '2019-02-11', 381, NULL),
('Cute Mountains Inn', 122, '2019-02-12', 292, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 122, '2019-02-13', 364, NULL),
('Cute Mountains Inn', 122, '2019-02-14', 356, NULL),
('Cute Mountains Inn', 122, '2019-02-15', 335, NULL),
('Cute Mountains Inn', 122, '2019-02-16', 139, NULL),
('Cute Mountains Inn', 122, '2019-02-17', 337, NULL),
('Cute Mountains Inn', 122, '2019-02-18', 230, NULL),
('Cute Mountains Inn', 122, '2019-02-19', 225, NULL),
('Cute Mountains Inn', 122, '2019-02-20', 255, NULL),
('Cute Mountains Inn', 122, '2019-02-21', 135, NULL),
('Cute Mountains Inn', 122, '2019-02-22', 364, NULL),
('Cute Mountains Inn', 122, '2019-02-23', 209, NULL),
('Cute Mountains Inn', 122, '2019-02-24', 174, NULL),
('Cute Mountains Inn', 122, '2019-02-25', 389, NULL),
('Cute Mountains Inn', 122, '2019-02-26', 264, NULL),
('Cute Mountains Inn', 122, '2019-02-27', 264, NULL),
('Cute Mountains Inn', 122, '2019-02-28', 124, NULL),
('Cute Mountains Inn', 122, '2019-03-01', 112, NULL),
('Cute Mountains Inn', 122, '2019-03-02', 136, NULL),
('Cute Mountains Inn', 122, '2019-03-03', 269, NULL),
('Cute Mountains Inn', 122, '2019-03-04', 112, NULL),
('Cute Mountains Inn', 122, '2019-03-05', 345, NULL),
('Cute Mountains Inn', 122, '2019-03-06', 258, NULL),
('Cute Mountains Inn', 122, '2019-03-07', 148, NULL),
('Cute Mountains Inn', 122, '2019-03-08', 309, NULL),
('Cute Mountains Inn', 122, '2019-03-09', 186, NULL),
('Cute Mountains Inn', 122, '2019-03-10', 146, NULL),
('Cute Mountains Inn', 122, '2019-03-11', 147, NULL),
('Cute Mountains Inn', 122, '2019-03-12', 305, NULL),
('Cute Mountains Inn', 122, '2019-03-13', 327, NULL),
('Cute Mountains Inn', 122, '2019-03-14', 376, NULL),
('Cute Mountains Inn', 122, '2019-03-15', 331, NULL),
('Cute Mountains Inn', 122, '2019-03-16', 395, NULL),
('Cute Mountains Inn', 122, '2019-03-17', 206, NULL),
('Cute Mountains Inn', 122, '2019-03-18', 207, NULL),
('Cute Mountains Inn', 122, '2019-03-19', 251, NULL),
('Cute Mountains Inn', 122, '2019-03-20', 258, NULL),
('Cute Mountains Inn', 122, '2019-03-21', 270, NULL),
('Cute Mountains Inn', 122, '2019-03-22', 196, NULL),
('Cute Mountains Inn', 122, '2019-03-23', 106, NULL),
('Cute Mountains Inn', 122, '2019-03-24', 361, NULL),
('Cute Mountains Inn', 122, '2019-03-25', 126, NULL),
('Cute Mountains Inn', 122, '2019-03-26', 192, NULL),
('Cute Mountains Inn', 122, '2019-03-27', 201, NULL),
('Cute Mountains Inn', 122, '2019-03-28', 154, NULL),
('Cute Mountains Inn', 122, '2019-03-29', 202, NULL),
('Cute Mountains Inn', 122, '2019-03-30', 121, NULL),
('Cute Mountains Inn', 122, '2019-03-31', 186, NULL),
('Cute Mountains Inn', 122, '2019-04-01', 386, NULL),
('Cute Mountains Inn', 122, '2019-04-02', 145, NULL),
('Cute Mountains Inn', 122, '2019-04-03', 294, NULL),
('Cute Mountains Inn', 122, '2019-04-04', 306, NULL),
('Cute Mountains Inn', 122, '2019-04-05', 302, NULL),
('Cute Mountains Inn', 122, '2019-04-06', 123, NULL),
('Cute Mountains Inn', 122, '2019-04-07', 115, NULL),
('Cute Mountains Inn', 122, '2019-04-08', 376, NULL),
('Cute Mountains Inn', 122, '2019-04-09', 201, NULL),
('Cute Mountains Inn', 122, '2019-04-10', 170, NULL),
('Cute Mountains Inn', 122, '2019-04-11', 181, NULL),
('Cute Mountains Inn', 122, '2019-04-12', 342, NULL),
('Cute Mountains Inn', 122, '2019-04-13', 117, NULL),
('Cute Mountains Inn', 122, '2019-04-14', 206, NULL),
('Cute Mountains Inn', 122, '2019-04-15', 140, NULL),
('Cute Mountains Inn', 122, '2019-04-16', 138, NULL),
('Cute Mountains Inn', 122, '2019-04-17', 358, NULL),
('Cute Mountains Inn', 122, '2019-04-18', 115, NULL),
('Cute Mountains Inn', 122, '2019-04-19', 103, NULL),
('Cute Mountains Inn', 122, '2019-04-20', 313, NULL),
('Cute Mountains Inn', 122, '2019-04-21', 178, NULL),
('Cute Mountains Inn', 122, '2019-04-22', 192, NULL),
('Cute Mountains Inn', 122, '2019-04-23', 107, NULL),
('Cute Mountains Inn', 122, '2019-04-24', 301, NULL),
('Cute Mountains Inn', 122, '2019-04-25', 206, NULL),
('Cute Mountains Inn', 122, '2019-04-26', 192, NULL),
('Cute Mountains Inn', 122, '2019-04-27', 335, NULL),
('Cute Mountains Inn', 122, '2019-04-28', 256, NULL),
('Cute Mountains Inn', 122, '2019-04-29', 344, NULL),
('Cute Mountains Inn', 122, '2019-04-30', 272, NULL),
('Cute Mountains Inn', 122, '2019-05-01', 295, NULL),
('Cute Mountains Inn', 122, '2019-05-02', 147, NULL),
('Cute Mountains Inn', 122, '2019-05-03', 333, NULL),
('Cute Mountains Inn', 122, '2019-05-04', 397, NULL),
('Cute Mountains Inn', 122, '2019-05-05', 315, NULL),
('Cute Mountains Inn', 122, '2019-05-06', 334, NULL),
('Cute Mountains Inn', 122, '2019-05-07', 151, NULL),
('Cute Mountains Inn', 122, '2019-05-08', 334, NULL),
('Cute Mountains Inn', 122, '2019-05-09', 240, NULL),
('Cute Mountains Inn', 122, '2019-05-10', 172, NULL),
('Cute Mountains Inn', 122, '2019-05-11', 123, NULL),
('Cute Mountains Inn', 122, '2019-05-12', 211, NULL),
('Cute Mountains Inn', 122, '2019-05-13', 222, NULL),
('Cute Mountains Inn', 122, '2019-05-14', 118, NULL),
('Cute Mountains Inn', 122, '2019-05-15', 177, NULL),
('Cute Mountains Inn', 122, '2019-05-16', 338, NULL),
('Cute Mountains Inn', 122, '2019-05-17', 221, NULL),
('Cute Mountains Inn', 122, '2019-05-18', 159, NULL),
('Cute Mountains Inn', 122, '2019-05-19', 351, NULL),
('Cute Mountains Inn', 122, '2019-05-20', 328, NULL),
('Cute Mountains Inn', 122, '2019-05-21', 332, NULL),
('Cute Mountains Inn', 122, '2019-05-22', 397, NULL),
('Cute Mountains Inn', 122, '2019-05-23', 152, NULL),
('Cute Mountains Inn', 122, '2019-05-24', 396, NULL),
('Cute Mountains Inn', 122, '2019-05-25', 111, NULL),
('Cute Mountains Inn', 122, '2019-05-26', 143, NULL),
('Cute Mountains Inn', 122, '2019-05-27', 268, NULL),
('Cute Mountains Inn', 122, '2019-05-28', 352, NULL),
('Cute Mountains Inn', 122, '2019-05-29', 397, NULL),
('Cute Mountains Inn', 122, '2019-05-30', 137, NULL),
('Cute Mountains Inn', 122, '2019-05-31', 391, NULL),
('Cute Mountains Inn', 122, '2019-06-01', 249, NULL),
('Cute Mountains Inn', 122, '2019-06-02', 256, NULL),
('Cute Mountains Inn', 122, '2019-06-03', 215, NULL),
('Cute Mountains Inn', 122, '2019-06-04', 235, NULL),
('Cute Mountains Inn', 122, '2019-06-05', 265, NULL),
('Cute Mountains Inn', 122, '2019-06-06', 290, NULL),
('Cute Mountains Inn', 122, '2019-06-07', 103, NULL),
('Cute Mountains Inn', 122, '2019-06-08', 286, NULL),
('Cute Mountains Inn', 122, '2019-06-09', 210, NULL),
('Cute Mountains Inn', 122, '2019-06-10', 325, NULL),
('Cute Mountains Inn', 122, '2019-06-11', 206, NULL),
('Cute Mountains Inn', 122, '2019-06-12', 157, NULL),
('Cute Mountains Inn', 122, '2019-06-13', 371, NULL),
('Cute Mountains Inn', 122, '2019-06-14', 324, NULL),
('Cute Mountains Inn', 122, '2019-06-15', 193, NULL),
('Cute Mountains Inn', 122, '2019-06-16', 165, NULL),
('Cute Mountains Inn', 122, '2019-06-17', 306, NULL),
('Cute Mountains Inn', 122, '2019-06-18', 318, NULL),
('Cute Mountains Inn', 122, '2019-06-19', 275, NULL),
('Cute Mountains Inn', 122, '2019-06-20', 109, NULL),
('Cute Mountains Inn', 122, '2019-06-21', 275, NULL),
('Cute Mountains Inn', 122, '2019-06-22', 344, NULL),
('Cute Mountains Inn', 122, '2019-06-23', 265, NULL),
('Cute Mountains Inn', 122, '2019-06-24', 126, NULL),
('Cute Mountains Inn', 122, '2019-06-25', 355, NULL),
('Cute Mountains Inn', 122, '2019-06-26', 308, NULL),
('Cute Mountains Inn', 122, '2019-06-27', 145, NULL),
('Cute Mountains Inn', 122, '2019-06-28', 224, NULL),
('Cute Mountains Inn', 122, '2019-06-29', 384, NULL),
('Cute Mountains Inn', 122, '2019-06-30', 248, NULL),
('Cute Mountains Inn', 122, '2019-07-01', 266, NULL),
('Cute Mountains Inn', 122, '2019-07-02', 103, NULL),
('Cute Mountains Inn', 122, '2019-07-03', 152, NULL),
('Cute Mountains Inn', 122, '2019-07-04', 140, NULL),
('Cute Mountains Inn', 122, '2019-07-05', 138, NULL),
('Cute Mountains Inn', 122, '2019-07-06', 266, NULL),
('Cute Mountains Inn', 122, '2019-07-07', 156, NULL),
('Cute Mountains Inn', 122, '2019-07-08', 229, NULL),
('Cute Mountains Inn', 122, '2019-07-09', 229, NULL),
('Cute Mountains Inn', 122, '2019-07-10', 333, NULL),
('Cute Mountains Inn', 122, '2019-07-11', 293, NULL),
('Cute Mountains Inn', 122, '2019-07-12', 249, NULL),
('Cute Mountains Inn', 122, '2019-07-13', 180, NULL),
('Cute Mountains Inn', 122, '2019-07-14', 105, NULL),
('Cute Mountains Inn', 122, '2019-07-15', 129, NULL),
('Cute Mountains Inn', 122, '2019-07-16', 139, NULL),
('Cute Mountains Inn', 122, '2019-07-17', 218, NULL),
('Cute Mountains Inn', 122, '2019-07-18', 221, NULL),
('Cute Mountains Inn', 122, '2019-07-19', 389, NULL),
('Cute Mountains Inn', 122, '2019-07-20', 257, NULL),
('Cute Mountains Inn', 122, '2019-07-21', 280, NULL),
('Cute Mountains Inn', 122, '2019-07-22', 328, NULL),
('Cute Mountains Inn', 122, '2019-07-23', 176, NULL),
('Cute Mountains Inn', 122, '2019-07-24', 312, NULL),
('Cute Mountains Inn', 122, '2019-07-25', 130, NULL),
('Cute Mountains Inn', 122, '2019-07-26', 288, NULL),
('Cute Mountains Inn', 122, '2019-07-27', 172, NULL),
('Cute Mountains Inn', 122, '2019-07-28', 287, NULL),
('Cute Mountains Inn', 122, '2019-07-29', 396, NULL),
('Cute Mountains Inn', 122, '2019-07-30', 252, NULL),
('Cute Mountains Inn', 122, '2019-07-31', 378, NULL),
('Cute Mountains Inn', 122, '2019-08-01', 283, NULL),
('Cute Mountains Inn', 122, '2019-08-02', 104, NULL),
('Cute Mountains Inn', 122, '2019-08-03', 138, NULL),
('Cute Mountains Inn', 122, '2019-08-04', 215, NULL),
('Cute Mountains Inn', 122, '2019-08-05', 249, NULL),
('Cute Mountains Inn', 122, '2019-08-06', 276, NULL),
('Cute Mountains Inn', 122, '2019-08-07', 121, NULL),
('Cute Mountains Inn', 122, '2019-08-08', 240, NULL),
('Cute Mountains Inn', 122, '2019-08-09', 115, NULL),
('Cute Mountains Inn', 122, '2019-08-10', 114, NULL),
('Cute Mountains Inn', 122, '2019-08-11', 201, NULL),
('Cute Mountains Inn', 122, '2019-08-12', 285, NULL),
('Cute Mountains Inn', 122, '2019-08-13', 267, NULL),
('Cute Mountains Inn', 122, '2019-08-14', 172, NULL),
('Cute Mountains Inn', 122, '2019-08-15', 262, NULL),
('Cute Mountains Inn', 122, '2019-08-16', 317, NULL),
('Cute Mountains Inn', 122, '2019-08-17', 236, NULL),
('Cute Mountains Inn', 122, '2019-08-18', 287, NULL),
('Cute Mountains Inn', 122, '2019-08-19', 365, NULL),
('Cute Mountains Inn', 122, '2019-08-20', 257, NULL),
('Cute Mountains Inn', 122, '2019-08-21', 162, NULL),
('Cute Mountains Inn', 122, '2019-08-22', 239, NULL),
('Cute Mountains Inn', 122, '2019-08-23', 303, NULL),
('Cute Mountains Inn', 122, '2019-08-24', 336, NULL),
('Cute Mountains Inn', 122, '2019-08-25', 296, NULL),
('Cute Mountains Inn', 122, '2019-08-26', 361, NULL),
('Cute Mountains Inn', 122, '2019-08-27', 350, NULL),
('Cute Mountains Inn', 122, '2019-08-28', 261, NULL),
('Cute Mountains Inn', 122, '2019-08-29', 306, NULL),
('Cute Mountains Inn', 122, '2019-08-30', 124, NULL),
('Cute Mountains Inn', 122, '2019-08-31', 358, NULL),
('Cute Mountains Inn', 122, '2019-09-01', 266, NULL),
('Cute Mountains Inn', 122, '2019-09-02', 228, NULL),
('Cute Mountains Inn', 122, '2019-09-03', 163, NULL),
('Cute Mountains Inn', 122, '2019-09-04', 376, NULL),
('Cute Mountains Inn', 122, '2019-09-05', 286, NULL),
('Cute Mountains Inn', 122, '2019-09-06', 394, NULL),
('Cute Mountains Inn', 122, '2019-09-07', 365, NULL),
('Cute Mountains Inn', 122, '2019-09-08', 125, NULL),
('Cute Mountains Inn', 122, '2019-09-09', 193, NULL),
('Cute Mountains Inn', 122, '2019-09-10', 177, NULL),
('Cute Mountains Inn', 122, '2019-09-11', 241, NULL),
('Cute Mountains Inn', 122, '2019-09-12', 215, NULL),
('Cute Mountains Inn', 122, '2019-09-13', 181, NULL),
('Cute Mountains Inn', 122, '2019-09-14', 112, NULL),
('Cute Mountains Inn', 122, '2019-09-15', 197, NULL),
('Cute Mountains Inn', 122, '2019-09-16', 284, NULL),
('Cute Mountains Inn', 122, '2019-09-17', 214, NULL),
('Cute Mountains Inn', 122, '2019-09-18', 373, NULL),
('Cute Mountains Inn', 122, '2019-09-19', 113, NULL),
('Cute Mountains Inn', 122, '2019-09-20', 395, NULL),
('Cute Mountains Inn', 122, '2019-09-21', 309, NULL),
('Cute Mountains Inn', 122, '2019-09-22', 291, NULL),
('Cute Mountains Inn', 122, '2019-09-23', 111, NULL),
('Cute Mountains Inn', 122, '2019-09-24', 219, NULL),
('Cute Mountains Inn', 122, '2019-09-25', 392, NULL),
('Cute Mountains Inn', 122, '2019-09-26', 281, NULL),
('Cute Mountains Inn', 122, '2019-09-27', 185, NULL),
('Cute Mountains Inn', 122, '2019-09-28', 179, NULL),
('Cute Mountains Inn', 122, '2019-09-29', 107, NULL),
('Cute Mountains Inn', 122, '2019-09-30', 118, NULL),
('Cute Mountains Inn', 122, '2019-10-01', 260, NULL),
('Cute Mountains Inn', 122, '2019-10-02', 273, NULL),
('Cute Mountains Inn', 122, '2019-10-03', 379, NULL),
('Cute Mountains Inn', 122, '2019-10-04', 203, NULL),
('Cute Mountains Inn', 122, '2019-10-05', 308, NULL),
('Cute Mountains Inn', 122, '2019-10-06', 267, NULL),
('Cute Mountains Inn', 122, '2019-10-07', 346, NULL),
('Cute Mountains Inn', 122, '2019-10-08', 399, NULL),
('Cute Mountains Inn', 122, '2019-10-09', 215, NULL),
('Cute Mountains Inn', 122, '2019-10-10', 228, NULL),
('Cute Mountains Inn', 122, '2019-10-11', 113, NULL),
('Cute Mountains Inn', 122, '2019-10-12', 399, NULL),
('Cute Mountains Inn', 122, '2019-10-13', 361, NULL),
('Cute Mountains Inn', 122, '2019-10-14', 381, NULL),
('Cute Mountains Inn', 122, '2019-10-15', 145, NULL),
('Cute Mountains Inn', 122, '2019-10-16', 149, NULL),
('Cute Mountains Inn', 122, '2019-10-17', 329, NULL),
('Cute Mountains Inn', 122, '2019-10-18', 386, NULL),
('Cute Mountains Inn', 122, '2019-10-19', 337, NULL),
('Cute Mountains Inn', 122, '2019-10-20', 138, NULL),
('Cute Mountains Inn', 122, '2019-10-21', 198, NULL),
('Cute Mountains Inn', 122, '2019-10-22', 312, NULL),
('Cute Mountains Inn', 122, '2019-10-23', 213, NULL),
('Cute Mountains Inn', 122, '2019-10-24', 225, NULL),
('Cute Mountains Inn', 122, '2019-10-25', 144, NULL),
('Cute Mountains Inn', 122, '2019-10-26', 121, NULL),
('Cute Mountains Inn', 122, '2019-10-27', 237, NULL),
('Cute Mountains Inn', 122, '2019-10-28', 242, NULL),
('Cute Mountains Inn', 122, '2019-10-29', 263, NULL),
('Cute Mountains Inn', 122, '2019-10-30', 256, NULL),
('Cute Mountains Inn', 122, '2019-10-31', 314, NULL),
('Cute Mountains Inn', 122, '2019-11-01', 296, NULL),
('Cute Mountains Inn', 122, '2019-11-02', 281, NULL),
('Cute Mountains Inn', 122, '2019-11-03', 292, NULL),
('Cute Mountains Inn', 122, '2019-11-04', 166, NULL),
('Cute Mountains Inn', 122, '2019-11-05', 325, NULL),
('Cute Mountains Inn', 122, '2019-11-06', 320, NULL),
('Cute Mountains Inn', 122, '2019-11-07', 282, NULL),
('Cute Mountains Inn', 122, '2019-11-08', 346, NULL),
('Cute Mountains Inn', 122, '2019-11-09', 316, NULL),
('Cute Mountains Inn', 122, '2019-11-10', 171, NULL),
('Cute Mountains Inn', 122, '2019-11-11', 290, NULL),
('Cute Mountains Inn', 122, '2019-11-12', 266, NULL),
('Cute Mountains Inn', 122, '2019-11-13', 367, NULL),
('Cute Mountains Inn', 122, '2019-11-14', 260, NULL),
('Cute Mountains Inn', 122, '2019-11-15', 126, NULL),
('Cute Mountains Inn', 122, '2019-11-16', 277, NULL),
('Cute Mountains Inn', 122, '2019-11-17', 240, NULL),
('Cute Mountains Inn', 122, '2019-11-18', 341, NULL),
('Cute Mountains Inn', 122, '2019-11-19', 155, NULL),
('Cute Mountains Inn', 122, '2019-11-20', 279, NULL),
('Cute Mountains Inn', 122, '2019-11-21', 103, NULL),
('Cute Mountains Inn', 122, '2019-11-22', 269, NULL),
('Cute Mountains Inn', 122, '2019-11-23', 285, NULL),
('Cute Mountains Inn', 122, '2019-11-24', 334, NULL),
('Cute Mountains Inn', 122, '2019-11-25', 312, NULL),
('Cute Mountains Inn', 122, '2019-11-26', 192, NULL),
('Cute Mountains Inn', 122, '2019-11-27', 246, NULL),
('Cute Mountains Inn', 122, '2019-11-28', 241, NULL),
('Cute Mountains Inn', 122, '2019-11-29', 155, NULL),
('Cute Mountains Inn', 122, '2019-11-30', 242, NULL),
('Cute Mountains Inn', 122, '2019-12-01', 148, NULL),
('Cute Mountains Inn', 122, '2019-12-02', 305, NULL),
('Cute Mountains Inn', 122, '2019-12-03', 177, NULL),
('Cute Mountains Inn', 122, '2019-12-04', 315, NULL),
('Cute Mountains Inn', 122, '2019-12-05', 182, NULL),
('Cute Mountains Inn', 122, '2019-12-06', 388, NULL),
('Cute Mountains Inn', 122, '2019-12-07', 300, NULL),
('Cute Mountains Inn', 122, '2019-12-08', 287, NULL),
('Cute Mountains Inn', 122, '2019-12-09', 301, NULL),
('Cute Mountains Inn', 122, '2019-12-10', 289, NULL),
('Cute Mountains Inn', 122, '2019-12-11', 278, NULL),
('Cute Mountains Inn', 122, '2019-12-12', 129, NULL),
('Cute Mountains Inn', 122, '2019-12-13', 181, NULL),
('Cute Mountains Inn', 122, '2019-12-14', 128, NULL),
('Cute Mountains Inn', 122, '2019-12-15', 126, NULL),
('Cute Mountains Inn', 122, '2019-12-16', 154, NULL),
('Cute Mountains Inn', 122, '2019-12-17', 321, NULL),
('Cute Mountains Inn', 122, '2019-12-18', 330, NULL),
('Cute Mountains Inn', 122, '2019-12-19', 181, NULL),
('Cute Mountains Inn', 122, '2019-12-20', 340, NULL),
('Cute Mountains Inn', 122, '2019-12-21', 140, NULL),
('Cute Mountains Inn', 122, '2019-12-22', 240, NULL),
('Cute Mountains Inn', 122, '2019-12-23', 326, NULL),
('Cute Mountains Inn', 122, '2019-12-24', 381, NULL),
('Cute Mountains Inn', 122, '2019-12-25', 208, NULL),
('Cute Mountains Inn', 122, '2019-12-26', 272, NULL),
('Cute Mountains Inn', 122, '2019-12-27', 339, NULL),
('Cute Mountains Inn', 122, '2019-12-28', 290, NULL),
('Cute Mountains Inn', 122, '2019-12-29', 308, NULL),
('Cute Mountains Inn', 122, '2019-12-30', 388, NULL),
('Cute Mountains Inn', 122, '2019-12-31', 133, NULL),
('Cute Mountains Inn', 122, '2020-01-01', 166, NULL),
('Cute Mountains Inn', 122, '2020-01-02', 103, NULL),
('Cute Mountains Inn', 122, '2020-01-03', 386, NULL),
('Cute Mountains Inn', 122, '2020-01-04', 367, NULL),
('Cute Mountains Inn', 122, '2020-01-05', 106, NULL),
('Cute Mountains Inn', 122, '2020-01-06', 212, NULL),
('Cute Mountains Inn', 122, '2020-01-07', 391, NULL),
('Cute Mountains Inn', 122, '2020-01-08', 104, NULL),
('Cute Mountains Inn', 122, '2020-01-09', 224, NULL),
('Cute Mountains Inn', 122, '2020-01-10', 209, NULL),
('Cute Mountains Inn', 122, '2020-01-11', 121, NULL),
('Cute Mountains Inn', 122, '2020-01-12', 230, NULL),
('Cute Mountains Inn', 122, '2020-01-13', 147, NULL),
('Cute Mountains Inn', 122, '2020-01-14', 337, NULL),
('Cute Mountains Inn', 122, '2020-01-15', 380, NULL),
('Cute Mountains Inn', 122, '2020-01-16', 171, NULL),
('Cute Mountains Inn', 122, '2020-01-17', 394, NULL),
('Cute Mountains Inn', 122, '2020-01-18', 105, NULL),
('Cute Mountains Inn', 122, '2020-01-19', 143, NULL),
('Cute Mountains Inn', 122, '2020-01-20', 232, NULL),
('Cute Mountains Inn', 122, '2020-01-21', 253, NULL),
('Cute Mountains Inn', 122, '2020-01-22', 246, NULL),
('Cute Mountains Inn', 122, '2020-01-23', 271, NULL),
('Cute Mountains Inn', 122, '2020-01-24', 130, NULL),
('Cute Mountains Inn', 122, '2020-01-25', 293, NULL),
('Cute Mountains Inn', 122, '2020-01-26', 239, NULL),
('Cute Mountains Inn', 122, '2020-01-27', 228, NULL),
('Cute Mountains Inn', 122, '2020-01-28', 384, NULL),
('Cute Mountains Inn', 122, '2020-01-29', 239, NULL),
('Cute Mountains Inn', 122, '2020-01-30', 225, NULL),
('Cute Mountains Inn', 122, '2020-01-31', 383, NULL),
('Cute Mountains Inn', 122, '2020-02-01', 145, NULL),
('Cute Mountains Inn', 122, '2020-02-02', 179, NULL),
('Cute Mountains Inn', 122, '2020-02-03', 210, NULL),
('Cute Mountains Inn', 122, '2020-02-04', 251, NULL),
('Cute Mountains Inn', 123, '2019-01-01', 396, NULL),
('Cute Mountains Inn', 123, '2019-01-02', 394, NULL),
('Cute Mountains Inn', 123, '2019-01-03', 320, NULL),
('Cute Mountains Inn', 123, '2019-01-04', 374, NULL),
('Cute Mountains Inn', 123, '2019-01-05', 399, NULL),
('Cute Mountains Inn', 123, '2019-01-06', 100, NULL),
('Cute Mountains Inn', 123, '2019-01-07', 287, NULL),
('Cute Mountains Inn', 123, '2019-01-08', 143, NULL),
('Cute Mountains Inn', 123, '2019-01-09', 114, NULL),
('Cute Mountains Inn', 123, '2019-01-10', 232, NULL),
('Cute Mountains Inn', 123, '2019-01-11', 343, NULL),
('Cute Mountains Inn', 123, '2019-01-12', 385, NULL),
('Cute Mountains Inn', 123, '2019-01-13', 341, NULL),
('Cute Mountains Inn', 123, '2019-01-14', 286, NULL),
('Cute Mountains Inn', 123, '2019-01-15', 131, NULL),
('Cute Mountains Inn', 123, '2019-01-16', 136, NULL),
('Cute Mountains Inn', 123, '2019-01-17', 346, NULL),
('Cute Mountains Inn', 123, '2019-01-18', 209, NULL),
('Cute Mountains Inn', 123, '2019-01-19', 348, NULL),
('Cute Mountains Inn', 123, '2019-01-20', 142, NULL),
('Cute Mountains Inn', 123, '2019-01-21', 310, NULL),
('Cute Mountains Inn', 123, '2019-01-22', 136, NULL),
('Cute Mountains Inn', 123, '2019-01-23', 345, NULL),
('Cute Mountains Inn', 123, '2019-01-24', 291, NULL),
('Cute Mountains Inn', 123, '2019-01-25', 377, NULL),
('Cute Mountains Inn', 123, '2019-01-26', 340, NULL),
('Cute Mountains Inn', 123, '2019-01-27', 369, NULL),
('Cute Mountains Inn', 123, '2019-01-28', 100, NULL),
('Cute Mountains Inn', 123, '2019-01-29', 214, NULL),
('Cute Mountains Inn', 123, '2019-01-30', 109, NULL),
('Cute Mountains Inn', 123, '2019-01-31', 326, NULL),
('Cute Mountains Inn', 123, '2019-02-01', 213, NULL),
('Cute Mountains Inn', 123, '2019-02-02', 214, NULL),
('Cute Mountains Inn', 123, '2019-02-03', 336, NULL),
('Cute Mountains Inn', 123, '2019-02-04', 321, NULL),
('Cute Mountains Inn', 123, '2019-02-05', 384, NULL),
('Cute Mountains Inn', 123, '2019-02-06', 198, NULL),
('Cute Mountains Inn', 123, '2019-02-07', 145, NULL),
('Cute Mountains Inn', 123, '2019-02-08', 234, NULL),
('Cute Mountains Inn', 123, '2019-02-09', 391, NULL),
('Cute Mountains Inn', 123, '2019-02-10', 268, NULL),
('Cute Mountains Inn', 123, '2019-02-11', 307, NULL),
('Cute Mountains Inn', 123, '2019-02-12', 160, NULL),
('Cute Mountains Inn', 123, '2019-02-13', 119, NULL),
('Cute Mountains Inn', 123, '2019-02-14', 396, NULL),
('Cute Mountains Inn', 123, '2019-02-15', 339, NULL),
('Cute Mountains Inn', 123, '2019-02-16', 222, NULL),
('Cute Mountains Inn', 123, '2019-02-17', 398, NULL),
('Cute Mountains Inn', 123, '2019-02-18', 322, NULL),
('Cute Mountains Inn', 123, '2019-02-19', 334, NULL),
('Cute Mountains Inn', 123, '2019-02-20', 165, NULL),
('Cute Mountains Inn', 123, '2019-02-21', 201, NULL),
('Cute Mountains Inn', 123, '2019-02-22', 153, NULL),
('Cute Mountains Inn', 123, '2019-02-23', 377, NULL),
('Cute Mountains Inn', 123, '2019-02-24', 234, NULL),
('Cute Mountains Inn', 123, '2019-02-25', 134, NULL),
('Cute Mountains Inn', 123, '2019-02-26', 298, NULL),
('Cute Mountains Inn', 123, '2019-02-27', 142, NULL),
('Cute Mountains Inn', 123, '2019-02-28', 220, NULL),
('Cute Mountains Inn', 123, '2019-03-01', 201, NULL),
('Cute Mountains Inn', 123, '2019-03-02', 101, NULL),
('Cute Mountains Inn', 123, '2019-03-03', 329, NULL),
('Cute Mountains Inn', 123, '2019-03-04', 100, NULL),
('Cute Mountains Inn', 123, '2019-03-05', 219, NULL),
('Cute Mountains Inn', 123, '2019-03-06', 249, NULL),
('Cute Mountains Inn', 123, '2019-03-07', 142, NULL),
('Cute Mountains Inn', 123, '2019-03-08', 338, NULL),
('Cute Mountains Inn', 123, '2019-03-09', 398, NULL),
('Cute Mountains Inn', 123, '2019-03-10', 345, NULL),
('Cute Mountains Inn', 123, '2019-03-11', 359, NULL),
('Cute Mountains Inn', 123, '2019-03-12', 160, NULL),
('Cute Mountains Inn', 123, '2019-03-13', 226, NULL),
('Cute Mountains Inn', 123, '2019-03-14', 177, NULL),
('Cute Mountains Inn', 123, '2019-03-15', 127, NULL),
('Cute Mountains Inn', 123, '2019-03-16', 202, NULL),
('Cute Mountains Inn', 123, '2019-03-17', 329, NULL),
('Cute Mountains Inn', 123, '2019-03-18', 374, NULL),
('Cute Mountains Inn', 123, '2019-03-19', 165, NULL),
('Cute Mountains Inn', 123, '2019-03-20', 302, NULL),
('Cute Mountains Inn', 123, '2019-03-21', 146, NULL),
('Cute Mountains Inn', 123, '2019-03-22', 250, NULL),
('Cute Mountains Inn', 123, '2019-03-23', 286, NULL),
('Cute Mountains Inn', 123, '2019-03-24', 381, NULL),
('Cute Mountains Inn', 123, '2019-03-25', 275, NULL),
('Cute Mountains Inn', 123, '2019-03-26', 180, NULL),
('Cute Mountains Inn', 123, '2019-03-27', 346, NULL),
('Cute Mountains Inn', 123, '2019-03-28', 180, NULL),
('Cute Mountains Inn', 123, '2019-03-29', 226, NULL),
('Cute Mountains Inn', 123, '2019-03-30', 335, NULL),
('Cute Mountains Inn', 123, '2019-03-31', 171, NULL),
('Cute Mountains Inn', 123, '2019-04-01', 310, NULL),
('Cute Mountains Inn', 123, '2019-04-02', 122, NULL),
('Cute Mountains Inn', 123, '2019-04-03', 199, NULL),
('Cute Mountains Inn', 123, '2019-04-04', 277, NULL),
('Cute Mountains Inn', 123, '2019-04-05', 270, NULL),
('Cute Mountains Inn', 123, '2019-04-06', 112, NULL),
('Cute Mountains Inn', 123, '2019-04-07', 116, NULL),
('Cute Mountains Inn', 123, '2019-04-08', 370, NULL),
('Cute Mountains Inn', 123, '2019-04-09', 318, NULL),
('Cute Mountains Inn', 123, '2019-04-10', 343, NULL),
('Cute Mountains Inn', 123, '2019-04-11', 232, NULL),
('Cute Mountains Inn', 123, '2019-04-12', 186, NULL),
('Cute Mountains Inn', 123, '2019-04-13', 201, NULL),
('Cute Mountains Inn', 123, '2019-04-14', 263, NULL),
('Cute Mountains Inn', 123, '2019-04-15', 377, NULL),
('Cute Mountains Inn', 123, '2019-04-16', 271, NULL),
('Cute Mountains Inn', 123, '2019-04-17', 250, NULL),
('Cute Mountains Inn', 123, '2019-04-18', 341, NULL),
('Cute Mountains Inn', 123, '2019-04-19', 261, NULL),
('Cute Mountains Inn', 123, '2019-04-20', 221, NULL),
('Cute Mountains Inn', 123, '2019-04-21', 255, NULL),
('Cute Mountains Inn', 123, '2019-04-22', 229, NULL),
('Cute Mountains Inn', 123, '2019-04-23', 362, NULL),
('Cute Mountains Inn', 123, '2019-04-24', 337, NULL),
('Cute Mountains Inn', 123, '2019-04-25', 282, NULL),
('Cute Mountains Inn', 123, '2019-04-26', 151, NULL),
('Cute Mountains Inn', 123, '2019-04-27', 338, NULL),
('Cute Mountains Inn', 123, '2019-04-28', 349, NULL),
('Cute Mountains Inn', 123, '2019-04-29', 307, NULL),
('Cute Mountains Inn', 123, '2019-04-30', 384, NULL),
('Cute Mountains Inn', 123, '2019-05-01', 205, NULL),
('Cute Mountains Inn', 123, '2019-05-02', 354, NULL),
('Cute Mountains Inn', 123, '2019-05-03', 348, NULL),
('Cute Mountains Inn', 123, '2019-05-04', 159, NULL),
('Cute Mountains Inn', 123, '2019-05-05', 370, NULL),
('Cute Mountains Inn', 123, '2019-05-06', 125, NULL),
('Cute Mountains Inn', 123, '2019-05-07', 211, NULL),
('Cute Mountains Inn', 123, '2019-05-08', 168, NULL),
('Cute Mountains Inn', 123, '2019-05-09', 213, NULL),
('Cute Mountains Inn', 123, '2019-05-10', 194, NULL),
('Cute Mountains Inn', 123, '2019-05-11', 252, NULL),
('Cute Mountains Inn', 123, '2019-05-12', 202, NULL),
('Cute Mountains Inn', 123, '2019-05-13', 399, NULL),
('Cute Mountains Inn', 123, '2019-05-14', 238, NULL),
('Cute Mountains Inn', 123, '2019-05-15', 265, NULL),
('Cute Mountains Inn', 123, '2019-05-16', 103, NULL),
('Cute Mountains Inn', 123, '2019-05-17', 358, NULL),
('Cute Mountains Inn', 123, '2019-05-18', 376, NULL),
('Cute Mountains Inn', 123, '2019-05-19', 326, NULL),
('Cute Mountains Inn', 123, '2019-05-20', 227, NULL),
('Cute Mountains Inn', 123, '2019-05-21', 258, NULL),
('Cute Mountains Inn', 123, '2019-05-22', 201, NULL),
('Cute Mountains Inn', 123, '2019-05-23', 217, NULL),
('Cute Mountains Inn', 123, '2019-05-24', 240, NULL),
('Cute Mountains Inn', 123, '2019-05-25', 278, NULL),
('Cute Mountains Inn', 123, '2019-05-26', 380, NULL),
('Cute Mountains Inn', 123, '2019-05-27', 322, NULL),
('Cute Mountains Inn', 123, '2019-05-28', 145, NULL),
('Cute Mountains Inn', 123, '2019-05-29', 293, NULL),
('Cute Mountains Inn', 123, '2019-05-30', 368, NULL),
('Cute Mountains Inn', 123, '2019-05-31', 276, NULL),
('Cute Mountains Inn', 123, '2019-06-01', 296, NULL),
('Cute Mountains Inn', 123, '2019-06-02', 235, NULL),
('Cute Mountains Inn', 123, '2019-06-03', 192, NULL),
('Cute Mountains Inn', 123, '2019-06-04', 189, NULL),
('Cute Mountains Inn', 123, '2019-06-05', 196, NULL),
('Cute Mountains Inn', 123, '2019-06-06', 185, NULL),
('Cute Mountains Inn', 123, '2019-06-07', 371, NULL),
('Cute Mountains Inn', 123, '2019-06-08', 161, NULL),
('Cute Mountains Inn', 123, '2019-06-09', 151, NULL),
('Cute Mountains Inn', 123, '2019-06-10', 375, NULL),
('Cute Mountains Inn', 123, '2019-06-11', 253, NULL),
('Cute Mountains Inn', 123, '2019-06-12', 326, NULL),
('Cute Mountains Inn', 123, '2019-06-13', 301, NULL),
('Cute Mountains Inn', 123, '2019-06-14', 265, NULL),
('Cute Mountains Inn', 123, '2019-06-15', 228, NULL),
('Cute Mountains Inn', 123, '2019-06-16', 312, NULL),
('Cute Mountains Inn', 123, '2019-06-17', 260, NULL),
('Cute Mountains Inn', 123, '2019-06-18', 355, NULL),
('Cute Mountains Inn', 123, '2019-06-19', 284, NULL),
('Cute Mountains Inn', 123, '2019-06-20', 262, NULL),
('Cute Mountains Inn', 123, '2019-06-21', 106, NULL),
('Cute Mountains Inn', 123, '2019-06-22', 289, NULL),
('Cute Mountains Inn', 123, '2019-06-23', 225, NULL),
('Cute Mountains Inn', 123, '2019-06-24', 231, NULL),
('Cute Mountains Inn', 123, '2019-06-25', 174, NULL),
('Cute Mountains Inn', 123, '2019-06-26', 396, NULL),
('Cute Mountains Inn', 123, '2019-06-27', 319, NULL),
('Cute Mountains Inn', 123, '2019-06-28', 127, NULL),
('Cute Mountains Inn', 123, '2019-06-29', 324, NULL),
('Cute Mountains Inn', 123, '2019-06-30', 352, NULL),
('Cute Mountains Inn', 123, '2019-07-01', 248, NULL),
('Cute Mountains Inn', 123, '2019-07-02', 221, NULL),
('Cute Mountains Inn', 123, '2019-07-03', 138, NULL),
('Cute Mountains Inn', 123, '2019-07-04', 169, NULL),
('Cute Mountains Inn', 123, '2019-07-05', 264, NULL),
('Cute Mountains Inn', 123, '2019-07-06', 137, NULL),
('Cute Mountains Inn', 123, '2019-07-07', 281, NULL),
('Cute Mountains Inn', 123, '2019-07-08', 178, NULL),
('Cute Mountains Inn', 123, '2019-07-09', 139, NULL),
('Cute Mountains Inn', 123, '2019-07-10', 231, NULL),
('Cute Mountains Inn', 123, '2019-07-11', 397, NULL),
('Cute Mountains Inn', 123, '2019-07-12', 182, NULL),
('Cute Mountains Inn', 123, '2019-07-13', 211, NULL),
('Cute Mountains Inn', 123, '2019-07-14', 188, NULL),
('Cute Mountains Inn', 123, '2019-07-15', 353, NULL),
('Cute Mountains Inn', 123, '2019-07-16', 265, NULL),
('Cute Mountains Inn', 123, '2019-07-17', 232, NULL),
('Cute Mountains Inn', 123, '2019-07-18', 315, NULL),
('Cute Mountains Inn', 123, '2019-07-19', 261, NULL),
('Cute Mountains Inn', 123, '2019-07-20', 124, NULL),
('Cute Mountains Inn', 123, '2019-07-21', 294, NULL),
('Cute Mountains Inn', 123, '2019-07-22', 381, NULL),
('Cute Mountains Inn', 123, '2019-07-23', 344, NULL),
('Cute Mountains Inn', 123, '2019-07-24', 394, NULL),
('Cute Mountains Inn', 123, '2019-07-25', 339, NULL),
('Cute Mountains Inn', 123, '2019-07-26', 364, NULL),
('Cute Mountains Inn', 123, '2019-07-27', 314, NULL),
('Cute Mountains Inn', 123, '2019-07-28', 386, NULL),
('Cute Mountains Inn', 123, '2019-07-29', 250, NULL),
('Cute Mountains Inn', 123, '2019-07-30', 391, NULL),
('Cute Mountains Inn', 123, '2019-07-31', 285, NULL),
('Cute Mountains Inn', 123, '2019-08-01', 284, NULL),
('Cute Mountains Inn', 123, '2019-08-02', 367, NULL),
('Cute Mountains Inn', 123, '2019-08-03', 222, NULL),
('Cute Mountains Inn', 123, '2019-08-04', 149, NULL),
('Cute Mountains Inn', 123, '2019-08-05', 255, NULL),
('Cute Mountains Inn', 123, '2019-08-06', 382, NULL),
('Cute Mountains Inn', 123, '2019-08-07', 215, NULL),
('Cute Mountains Inn', 123, '2019-08-08', 284, NULL),
('Cute Mountains Inn', 123, '2019-08-09', 212, NULL),
('Cute Mountains Inn', 123, '2019-08-10', 347, NULL),
('Cute Mountains Inn', 123, '2019-08-11', 191, NULL),
('Cute Mountains Inn', 123, '2019-08-12', 141, NULL),
('Cute Mountains Inn', 123, '2019-08-13', 227, NULL),
('Cute Mountains Inn', 123, '2019-08-14', 120, NULL),
('Cute Mountains Inn', 123, '2019-08-15', 359, NULL),
('Cute Mountains Inn', 123, '2019-08-16', 268, NULL),
('Cute Mountains Inn', 123, '2019-08-17', 371, NULL),
('Cute Mountains Inn', 123, '2019-08-18', 319, NULL),
('Cute Mountains Inn', 123, '2019-08-19', 352, NULL),
('Cute Mountains Inn', 123, '2019-08-20', 244, NULL),
('Cute Mountains Inn', 123, '2019-08-21', 251, NULL),
('Cute Mountains Inn', 123, '2019-08-22', 206, NULL),
('Cute Mountains Inn', 123, '2019-08-23', 364, NULL),
('Cute Mountains Inn', 123, '2019-08-24', 104, NULL),
('Cute Mountains Inn', 123, '2019-08-25', 285, NULL),
('Cute Mountains Inn', 123, '2019-08-26', 104, NULL),
('Cute Mountains Inn', 123, '2019-08-27', 344, NULL),
('Cute Mountains Inn', 123, '2019-08-28', 396, NULL),
('Cute Mountains Inn', 123, '2019-08-29', 354, NULL),
('Cute Mountains Inn', 123, '2019-08-30', 392, NULL),
('Cute Mountains Inn', 123, '2019-08-31', 245, NULL),
('Cute Mountains Inn', 123, '2019-09-01', 348, NULL),
('Cute Mountains Inn', 123, '2019-09-02', 241, NULL),
('Cute Mountains Inn', 123, '2019-09-03', 351, NULL),
('Cute Mountains Inn', 123, '2019-09-04', 289, NULL),
('Cute Mountains Inn', 123, '2019-09-05', 171, NULL),
('Cute Mountains Inn', 123, '2019-09-06', 170, NULL),
('Cute Mountains Inn', 123, '2019-09-07', 325, NULL),
('Cute Mountains Inn', 123, '2019-09-08', 191, NULL),
('Cute Mountains Inn', 123, '2019-09-09', 230, NULL),
('Cute Mountains Inn', 123, '2019-09-10', 281, NULL),
('Cute Mountains Inn', 123, '2019-09-11', 190, NULL),
('Cute Mountains Inn', 123, '2019-09-12', 103, NULL),
('Cute Mountains Inn', 123, '2019-09-13', 248, NULL),
('Cute Mountains Inn', 123, '2019-09-14', 377, NULL),
('Cute Mountains Inn', 123, '2019-09-15', 220, NULL),
('Cute Mountains Inn', 123, '2019-09-16', 141, NULL),
('Cute Mountains Inn', 123, '2019-09-17', 174, NULL),
('Cute Mountains Inn', 123, '2019-09-18', 388, NULL),
('Cute Mountains Inn', 123, '2019-09-19', 196, NULL),
('Cute Mountains Inn', 123, '2019-09-20', 270, NULL),
('Cute Mountains Inn', 123, '2019-09-21', 292, NULL),
('Cute Mountains Inn', 123, '2019-09-22', 262, NULL),
('Cute Mountains Inn', 123, '2019-09-23', 119, NULL),
('Cute Mountains Inn', 123, '2019-09-24', 143, NULL),
('Cute Mountains Inn', 123, '2019-09-25', 162, NULL),
('Cute Mountains Inn', 123, '2019-09-26', 152, NULL),
('Cute Mountains Inn', 123, '2019-09-27', 397, NULL),
('Cute Mountains Inn', 123, '2019-09-28', 371, NULL),
('Cute Mountains Inn', 123, '2019-09-29', 234, NULL),
('Cute Mountains Inn', 123, '2019-09-30', 347, NULL),
('Cute Mountains Inn', 123, '2019-10-01', 154, NULL),
('Cute Mountains Inn', 123, '2019-10-02', 184, NULL),
('Cute Mountains Inn', 123, '2019-10-03', 206, NULL),
('Cute Mountains Inn', 123, '2019-10-04', 365, NULL),
('Cute Mountains Inn', 123, '2019-10-05', 213, NULL),
('Cute Mountains Inn', 123, '2019-10-06', 155, NULL),
('Cute Mountains Inn', 123, '2019-10-07', 351, NULL),
('Cute Mountains Inn', 123, '2019-10-08', 355, NULL),
('Cute Mountains Inn', 123, '2019-10-09', 288, NULL),
('Cute Mountains Inn', 123, '2019-10-10', 241, NULL),
('Cute Mountains Inn', 123, '2019-10-11', 382, NULL),
('Cute Mountains Inn', 123, '2019-10-12', 265, NULL),
('Cute Mountains Inn', 123, '2019-10-13', 108, NULL),
('Cute Mountains Inn', 123, '2019-10-14', 386, NULL),
('Cute Mountains Inn', 123, '2019-10-15', 137, NULL),
('Cute Mountains Inn', 123, '2019-10-16', 147, NULL),
('Cute Mountains Inn', 123, '2019-10-17', 216, NULL),
('Cute Mountains Inn', 123, '2019-10-18', 117, NULL),
('Cute Mountains Inn', 123, '2019-10-19', 363, NULL),
('Cute Mountains Inn', 123, '2019-10-20', 162, NULL),
('Cute Mountains Inn', 123, '2019-10-21', 125, NULL),
('Cute Mountains Inn', 123, '2019-10-22', 128, NULL),
('Cute Mountains Inn', 123, '2019-10-23', 250, NULL),
('Cute Mountains Inn', 123, '2019-10-24', 189, NULL),
('Cute Mountains Inn', 123, '2019-10-25', 127, NULL),
('Cute Mountains Inn', 123, '2019-10-26', 214, NULL),
('Cute Mountains Inn', 123, '2019-10-27', 234, NULL),
('Cute Mountains Inn', 123, '2019-10-28', 135, NULL),
('Cute Mountains Inn', 123, '2019-10-29', 122, NULL),
('Cute Mountains Inn', 123, '2019-10-30', 246, NULL),
('Cute Mountains Inn', 123, '2019-10-31', 131, NULL),
('Cute Mountains Inn', 123, '2019-11-01', 179, NULL),
('Cute Mountains Inn', 123, '2019-11-02', 143, NULL),
('Cute Mountains Inn', 123, '2019-11-03', 132, NULL),
('Cute Mountains Inn', 123, '2019-11-04', 149, NULL),
('Cute Mountains Inn', 123, '2019-11-05', 139, NULL),
('Cute Mountains Inn', 123, '2019-11-06', 235, NULL),
('Cute Mountains Inn', 123, '2019-11-07', 237, NULL),
('Cute Mountains Inn', 123, '2019-11-08', 177, NULL),
('Cute Mountains Inn', 123, '2019-11-09', 101, NULL),
('Cute Mountains Inn', 123, '2019-11-10', 266, NULL),
('Cute Mountains Inn', 123, '2019-11-11', 277, NULL),
('Cute Mountains Inn', 123, '2019-11-12', 192, NULL),
('Cute Mountains Inn', 123, '2019-11-13', 382, NULL),
('Cute Mountains Inn', 123, '2019-11-14', 303, NULL),
('Cute Mountains Inn', 123, '2019-11-15', 239, NULL),
('Cute Mountains Inn', 123, '2019-11-16', 222, NULL),
('Cute Mountains Inn', 123, '2019-11-17', 234, NULL),
('Cute Mountains Inn', 123, '2019-11-18', 342, NULL),
('Cute Mountains Inn', 123, '2019-11-19', 192, NULL),
('Cute Mountains Inn', 123, '2019-11-20', 307, NULL),
('Cute Mountains Inn', 123, '2019-11-21', 276, NULL),
('Cute Mountains Inn', 123, '2019-11-22', 254, NULL),
('Cute Mountains Inn', 123, '2019-11-23', 112, NULL),
('Cute Mountains Inn', 123, '2019-11-24', 147, NULL),
('Cute Mountains Inn', 123, '2019-11-25', 324, NULL),
('Cute Mountains Inn', 123, '2019-11-26', 213, NULL),
('Cute Mountains Inn', 123, '2019-11-27', 329, NULL),
('Cute Mountains Inn', 123, '2019-11-28', 225, NULL),
('Cute Mountains Inn', 123, '2019-11-29', 254, NULL),
('Cute Mountains Inn', 123, '2019-11-30', 338, NULL),
('Cute Mountains Inn', 123, '2019-12-01', 356, NULL),
('Cute Mountains Inn', 123, '2019-12-02', 358, NULL),
('Cute Mountains Inn', 123, '2019-12-03', 106, NULL),
('Cute Mountains Inn', 123, '2019-12-04', 272, NULL),
('Cute Mountains Inn', 123, '2019-12-05', 316, NULL),
('Cute Mountains Inn', 123, '2019-12-06', 390, NULL),
('Cute Mountains Inn', 123, '2019-12-07', 186, NULL),
('Cute Mountains Inn', 123, '2019-12-08', 154, NULL),
('Cute Mountains Inn', 123, '2019-12-09', 354, NULL),
('Cute Mountains Inn', 123, '2019-12-10', 365, NULL),
('Cute Mountains Inn', 123, '2019-12-11', 288, NULL),
('Cute Mountains Inn', 123, '2019-12-12', 373, NULL),
('Cute Mountains Inn', 123, '2019-12-13', 354, NULL),
('Cute Mountains Inn', 123, '2019-12-14', 255, NULL),
('Cute Mountains Inn', 123, '2019-12-15', 377, NULL),
('Cute Mountains Inn', 123, '2019-12-16', 294, NULL),
('Cute Mountains Inn', 123, '2019-12-17', 262, NULL),
('Cute Mountains Inn', 123, '2019-12-18', 152, NULL),
('Cute Mountains Inn', 123, '2019-12-19', 142, NULL),
('Cute Mountains Inn', 123, '2019-12-20', 230, NULL),
('Cute Mountains Inn', 123, '2019-12-21', 287, NULL),
('Cute Mountains Inn', 123, '2019-12-22', 123, NULL),
('Cute Mountains Inn', 123, '2019-12-23', 369, NULL),
('Cute Mountains Inn', 123, '2019-12-24', 178, NULL),
('Cute Mountains Inn', 123, '2019-12-25', 325, NULL),
('Cute Mountains Inn', 123, '2019-12-26', 242, NULL),
('Cute Mountains Inn', 123, '2019-12-27', 208, NULL),
('Cute Mountains Inn', 123, '2019-12-28', 243, NULL),
('Cute Mountains Inn', 123, '2019-12-29', 105, NULL),
('Cute Mountains Inn', 123, '2019-12-30', 213, NULL),
('Cute Mountains Inn', 123, '2019-12-31', 124, NULL),
('Cute Mountains Inn', 123, '2020-01-01', 272, NULL),
('Cute Mountains Inn', 123, '2020-01-02', 361, NULL),
('Cute Mountains Inn', 123, '2020-01-03', 350, NULL),
('Cute Mountains Inn', 123, '2020-01-04', 218, NULL),
('Cute Mountains Inn', 123, '2020-01-05', 293, NULL),
('Cute Mountains Inn', 123, '2020-01-06', 305, NULL),
('Cute Mountains Inn', 123, '2020-01-07', 353, NULL),
('Cute Mountains Inn', 123, '2020-01-08', 168, NULL),
('Cute Mountains Inn', 123, '2020-01-09', 173, NULL),
('Cute Mountains Inn', 123, '2020-01-10', 113, NULL),
('Cute Mountains Inn', 123, '2020-01-11', 176, NULL),
('Cute Mountains Inn', 123, '2020-01-12', 189, NULL),
('Cute Mountains Inn', 123, '2020-01-13', 195, NULL),
('Cute Mountains Inn', 123, '2020-01-14', 282, NULL),
('Cute Mountains Inn', 123, '2020-01-15', 199, NULL),
('Cute Mountains Inn', 123, '2020-01-16', 331, NULL),
('Cute Mountains Inn', 123, '2020-01-17', 134, NULL),
('Cute Mountains Inn', 123, '2020-01-18', 298, NULL),
('Cute Mountains Inn', 123, '2020-01-19', 157, NULL),
('Cute Mountains Inn', 123, '2020-01-20', 399, NULL),
('Cute Mountains Inn', 123, '2020-01-21', 284, NULL),
('Cute Mountains Inn', 123, '2020-01-22', 276, NULL),
('Cute Mountains Inn', 123, '2020-01-23', 105, NULL),
('Cute Mountains Inn', 123, '2020-01-24', 158, NULL),
('Cute Mountains Inn', 123, '2020-01-25', 129, NULL),
('Cute Mountains Inn', 123, '2020-01-26', 313, NULL),
('Cute Mountains Inn', 123, '2020-01-27', 275, NULL),
('Cute Mountains Inn', 123, '2020-01-28', 242, NULL),
('Cute Mountains Inn', 123, '2020-01-29', 327, NULL),
('Cute Mountains Inn', 123, '2020-01-30', 161, NULL),
('Cute Mountains Inn', 123, '2020-01-31', 161, NULL),
('Cute Mountains Inn', 123, '2020-02-01', 351, NULL),
('Cute Mountains Inn', 123, '2020-02-02', 373, NULL),
('Cute Mountains Inn', 123, '2020-02-03', 156, NULL),
('Cute Mountains Inn', 123, '2020-02-04', 394, NULL),
('Cute Mountains Inn', 127, '2019-01-01', 311, NULL),
('Cute Mountains Inn', 127, '2019-01-02', 241, NULL),
('Cute Mountains Inn', 127, '2019-01-03', 150, NULL),
('Cute Mountains Inn', 127, '2019-01-04', 244, NULL),
('Cute Mountains Inn', 127, '2019-01-05', 219, NULL),
('Cute Mountains Inn', 127, '2019-01-06', 219, NULL),
('Cute Mountains Inn', 127, '2019-01-07', 287, NULL),
('Cute Mountains Inn', 127, '2019-01-08', 216, NULL),
('Cute Mountains Inn', 127, '2019-01-09', 238, NULL),
('Cute Mountains Inn', 127, '2019-01-10', 349, NULL),
('Cute Mountains Inn', 127, '2019-01-11', 102, NULL),
('Cute Mountains Inn', 127, '2019-01-12', 369, NULL),
('Cute Mountains Inn', 127, '2019-01-13', 318, NULL),
('Cute Mountains Inn', 127, '2019-01-14', 193, NULL),
('Cute Mountains Inn', 127, '2019-01-15', 145, NULL),
('Cute Mountains Inn', 127, '2019-01-16', 140, NULL),
('Cute Mountains Inn', 127, '2019-01-17', 317, NULL),
('Cute Mountains Inn', 127, '2019-01-18', 240, NULL),
('Cute Mountains Inn', 127, '2019-01-19', 328, NULL),
('Cute Mountains Inn', 127, '2019-01-20', 251, NULL),
('Cute Mountains Inn', 127, '2019-01-21', 173, NULL),
('Cute Mountains Inn', 127, '2019-01-22', 153, NULL),
('Cute Mountains Inn', 127, '2019-01-23', 383, NULL),
('Cute Mountains Inn', 127, '2019-01-24', 376, NULL),
('Cute Mountains Inn', 127, '2019-01-25', 248, NULL),
('Cute Mountains Inn', 127, '2019-01-26', 228, NULL),
('Cute Mountains Inn', 127, '2019-01-27', 191, NULL),
('Cute Mountains Inn', 127, '2019-01-28', 188, NULL),
('Cute Mountains Inn', 127, '2019-01-29', 364, NULL),
('Cute Mountains Inn', 127, '2019-01-30', 258, NULL),
('Cute Mountains Inn', 127, '2019-01-31', 264, NULL),
('Cute Mountains Inn', 127, '2019-02-01', 307, NULL),
('Cute Mountains Inn', 127, '2019-02-02', 196, NULL),
('Cute Mountains Inn', 127, '2019-02-03', 196, NULL),
('Cute Mountains Inn', 127, '2019-02-04', 195, NULL),
('Cute Mountains Inn', 127, '2019-02-05', 208, NULL),
('Cute Mountains Inn', 127, '2019-02-06', 382, NULL),
('Cute Mountains Inn', 127, '2019-02-07', 178, NULL),
('Cute Mountains Inn', 127, '2019-02-08', 274, NULL),
('Cute Mountains Inn', 127, '2019-02-09', 295, NULL),
('Cute Mountains Inn', 127, '2019-02-10', 295, NULL),
('Cute Mountains Inn', 127, '2019-02-11', 289, NULL),
('Cute Mountains Inn', 127, '2019-02-12', 128, NULL),
('Cute Mountains Inn', 127, '2019-02-13', 304, NULL),
('Cute Mountains Inn', 127, '2019-02-14', 213, NULL),
('Cute Mountains Inn', 127, '2019-02-15', 293, NULL),
('Cute Mountains Inn', 127, '2019-02-16', 291, NULL),
('Cute Mountains Inn', 127, '2019-02-17', 281, NULL),
('Cute Mountains Inn', 127, '2019-02-18', 221, NULL),
('Cute Mountains Inn', 127, '2019-02-19', 298, NULL),
('Cute Mountains Inn', 127, '2019-02-20', 263, NULL),
('Cute Mountains Inn', 127, '2019-02-21', 200, NULL),
('Cute Mountains Inn', 127, '2019-02-22', 172, NULL),
('Cute Mountains Inn', 127, '2019-02-23', 256, NULL),
('Cute Mountains Inn', 127, '2019-02-24', 248, NULL),
('Cute Mountains Inn', 127, '2019-02-25', 303, NULL),
('Cute Mountains Inn', 127, '2019-02-26', 296, NULL),
('Cute Mountains Inn', 127, '2019-02-27', 118, NULL),
('Cute Mountains Inn', 127, '2019-02-28', 327, NULL),
('Cute Mountains Inn', 127, '2019-03-01', 270, NULL),
('Cute Mountains Inn', 127, '2019-03-02', 296, NULL),
('Cute Mountains Inn', 127, '2019-03-03', 138, NULL),
('Cute Mountains Inn', 127, '2019-03-04', 361, NULL),
('Cute Mountains Inn', 127, '2019-03-05', 262, NULL),
('Cute Mountains Inn', 127, '2019-03-06', 369, NULL),
('Cute Mountains Inn', 127, '2019-03-07', 169, NULL),
('Cute Mountains Inn', 127, '2019-03-08', 362, NULL),
('Cute Mountains Inn', 127, '2019-03-09', 134, NULL),
('Cute Mountains Inn', 127, '2019-03-10', 287, NULL),
('Cute Mountains Inn', 127, '2019-03-11', 353, NULL),
('Cute Mountains Inn', 127, '2019-03-12', 385, NULL),
('Cute Mountains Inn', 127, '2019-03-13', 350, NULL),
('Cute Mountains Inn', 127, '2019-03-14', 257, NULL),
('Cute Mountains Inn', 127, '2019-03-15', 141, NULL),
('Cute Mountains Inn', 127, '2019-03-16', 328, NULL),
('Cute Mountains Inn', 127, '2019-03-17', 325, NULL),
('Cute Mountains Inn', 127, '2019-03-18', 249, NULL),
('Cute Mountains Inn', 127, '2019-03-19', 274, NULL),
('Cute Mountains Inn', 127, '2019-03-20', 337, NULL),
('Cute Mountains Inn', 127, '2019-03-21', 119, NULL),
('Cute Mountains Inn', 127, '2019-03-22', 263, NULL),
('Cute Mountains Inn', 127, '2019-03-23', 115, NULL),
('Cute Mountains Inn', 127, '2019-03-24', 125, NULL),
('Cute Mountains Inn', 127, '2019-03-25', 297, NULL),
('Cute Mountains Inn', 127, '2019-03-26', 225, NULL),
('Cute Mountains Inn', 127, '2019-03-27', 129, NULL),
('Cute Mountains Inn', 127, '2019-03-28', 337, NULL),
('Cute Mountains Inn', 127, '2019-03-29', 124, NULL),
('Cute Mountains Inn', 127, '2019-03-30', 315, NULL),
('Cute Mountains Inn', 127, '2019-03-31', 198, NULL),
('Cute Mountains Inn', 127, '2019-04-01', 292, NULL),
('Cute Mountains Inn', 127, '2019-04-02', 377, NULL),
('Cute Mountains Inn', 127, '2019-04-03', 314, NULL),
('Cute Mountains Inn', 127, '2019-04-04', 368, NULL),
('Cute Mountains Inn', 127, '2019-04-05', 345, NULL),
('Cute Mountains Inn', 127, '2019-04-06', 392, NULL),
('Cute Mountains Inn', 127, '2019-04-07', 137, NULL),
('Cute Mountains Inn', 127, '2019-04-08', 322, NULL),
('Cute Mountains Inn', 127, '2019-04-09', 288, NULL),
('Cute Mountains Inn', 127, '2019-04-10', 202, NULL),
('Cute Mountains Inn', 127, '2019-04-11', 220, NULL),
('Cute Mountains Inn', 127, '2019-04-12', 102, NULL),
('Cute Mountains Inn', 127, '2019-04-13', 256, NULL),
('Cute Mountains Inn', 127, '2019-04-14', 299, NULL),
('Cute Mountains Inn', 127, '2019-04-15', 167, NULL),
('Cute Mountains Inn', 127, '2019-04-16', 242, NULL),
('Cute Mountains Inn', 127, '2019-04-17', 376, NULL),
('Cute Mountains Inn', 127, '2019-04-18', 358, NULL),
('Cute Mountains Inn', 127, '2019-04-19', 296, NULL),
('Cute Mountains Inn', 127, '2019-04-20', 369, NULL),
('Cute Mountains Inn', 127, '2019-04-21', 341, NULL),
('Cute Mountains Inn', 127, '2019-04-22', 169, NULL),
('Cute Mountains Inn', 127, '2019-04-23', 189, NULL),
('Cute Mountains Inn', 127, '2019-04-24', 383, NULL),
('Cute Mountains Inn', 127, '2019-04-25', 390, NULL),
('Cute Mountains Inn', 127, '2019-04-26', 380, NULL),
('Cute Mountains Inn', 127, '2019-04-27', 285, NULL),
('Cute Mountains Inn', 127, '2019-04-28', 279, NULL),
('Cute Mountains Inn', 127, '2019-04-29', 104, NULL),
('Cute Mountains Inn', 127, '2019-04-30', 103, NULL),
('Cute Mountains Inn', 127, '2019-05-01', 343, NULL),
('Cute Mountains Inn', 127, '2019-05-02', 332, NULL),
('Cute Mountains Inn', 127, '2019-05-03', 341, NULL),
('Cute Mountains Inn', 127, '2019-05-04', 104, NULL),
('Cute Mountains Inn', 127, '2019-05-05', 207, NULL),
('Cute Mountains Inn', 127, '2019-05-06', 123, NULL),
('Cute Mountains Inn', 127, '2019-05-07', 202, NULL),
('Cute Mountains Inn', 127, '2019-05-08', 339, NULL),
('Cute Mountains Inn', 127, '2019-05-09', 245, NULL),
('Cute Mountains Inn', 127, '2019-05-10', 353, NULL),
('Cute Mountains Inn', 127, '2019-05-11', 189, NULL),
('Cute Mountains Inn', 127, '2019-05-12', 278, NULL),
('Cute Mountains Inn', 127, '2019-05-13', 331, NULL),
('Cute Mountains Inn', 127, '2019-05-14', 135, NULL),
('Cute Mountains Inn', 127, '2019-05-15', 393, NULL),
('Cute Mountains Inn', 127, '2019-05-16', 299, NULL),
('Cute Mountains Inn', 127, '2019-05-17', 127, NULL),
('Cute Mountains Inn', 127, '2019-05-18', 102, NULL),
('Cute Mountains Inn', 127, '2019-05-19', 176, NULL),
('Cute Mountains Inn', 127, '2019-05-20', 351, NULL),
('Cute Mountains Inn', 127, '2019-05-21', 195, NULL),
('Cute Mountains Inn', 127, '2019-05-22', 314, NULL),
('Cute Mountains Inn', 127, '2019-05-23', 228, NULL),
('Cute Mountains Inn', 127, '2019-05-24', 215, NULL),
('Cute Mountains Inn', 127, '2019-05-25', 358, NULL),
('Cute Mountains Inn', 127, '2019-05-26', 169, NULL),
('Cute Mountains Inn', 127, '2019-05-27', 103, NULL),
('Cute Mountains Inn', 127, '2019-05-28', 172, NULL),
('Cute Mountains Inn', 127, '2019-05-29', 173, NULL),
('Cute Mountains Inn', 127, '2019-05-30', 128, NULL),
('Cute Mountains Inn', 127, '2019-05-31', 108, NULL),
('Cute Mountains Inn', 127, '2019-06-01', 334, NULL),
('Cute Mountains Inn', 127, '2019-06-02', 308, NULL),
('Cute Mountains Inn', 127, '2019-06-03', 218, NULL),
('Cute Mountains Inn', 127, '2019-06-04', 143, NULL),
('Cute Mountains Inn', 127, '2019-06-05', 384, NULL),
('Cute Mountains Inn', 127, '2019-06-06', 255, NULL),
('Cute Mountains Inn', 127, '2019-06-07', 250, NULL),
('Cute Mountains Inn', 127, '2019-06-08', 149, NULL),
('Cute Mountains Inn', 127, '2019-06-09', 328, NULL),
('Cute Mountains Inn', 127, '2019-06-10', 203, NULL),
('Cute Mountains Inn', 127, '2019-06-11', 247, NULL),
('Cute Mountains Inn', 127, '2019-06-12', 162, NULL),
('Cute Mountains Inn', 127, '2019-06-13', 293, NULL),
('Cute Mountains Inn', 127, '2019-06-14', 251, NULL),
('Cute Mountains Inn', 127, '2019-06-15', 164, NULL),
('Cute Mountains Inn', 127, '2019-06-16', 365, NULL),
('Cute Mountains Inn', 127, '2019-06-17', 280, NULL),
('Cute Mountains Inn', 127, '2019-06-18', 120, NULL),
('Cute Mountains Inn', 127, '2019-06-19', 196, NULL),
('Cute Mountains Inn', 127, '2019-06-20', 285, NULL),
('Cute Mountains Inn', 127, '2019-06-21', 206, NULL),
('Cute Mountains Inn', 127, '2019-06-22', 311, NULL),
('Cute Mountains Inn', 127, '2019-06-23', 229, NULL),
('Cute Mountains Inn', 127, '2019-06-24', 374, NULL),
('Cute Mountains Inn', 127, '2019-06-25', 307, NULL),
('Cute Mountains Inn', 127, '2019-06-26', 355, NULL),
('Cute Mountains Inn', 127, '2019-06-27', 162, NULL),
('Cute Mountains Inn', 127, '2019-06-28', 162, NULL),
('Cute Mountains Inn', 127, '2019-06-29', 369, NULL),
('Cute Mountains Inn', 127, '2019-06-30', 315, NULL),
('Cute Mountains Inn', 127, '2019-07-01', 345, NULL),
('Cute Mountains Inn', 127, '2019-07-02', 395, NULL),
('Cute Mountains Inn', 127, '2019-07-03', 134, NULL),
('Cute Mountains Inn', 127, '2019-07-04', 326, NULL),
('Cute Mountains Inn', 127, '2019-07-05', 206, NULL),
('Cute Mountains Inn', 127, '2019-07-06', 389, NULL),
('Cute Mountains Inn', 127, '2019-07-07', 235, NULL),
('Cute Mountains Inn', 127, '2019-07-08', 106, NULL),
('Cute Mountains Inn', 127, '2019-07-09', 206, NULL),
('Cute Mountains Inn', 127, '2019-07-10', 358, NULL),
('Cute Mountains Inn', 127, '2019-07-11', 105, NULL),
('Cute Mountains Inn', 127, '2019-07-12', 367, NULL),
('Cute Mountains Inn', 127, '2019-07-13', 116, NULL),
('Cute Mountains Inn', 127, '2019-07-14', 224, NULL),
('Cute Mountains Inn', 127, '2019-07-15', 376, NULL),
('Cute Mountains Inn', 127, '2019-07-16', 209, NULL),
('Cute Mountains Inn', 127, '2019-07-17', 107, NULL),
('Cute Mountains Inn', 127, '2019-07-18', 212, NULL),
('Cute Mountains Inn', 127, '2019-07-19', 339, NULL),
('Cute Mountains Inn', 127, '2019-07-20', 352, NULL),
('Cute Mountains Inn', 127, '2019-07-21', 233, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 127, '2019-07-22', 223, NULL),
('Cute Mountains Inn', 127, '2019-07-23', 193, NULL),
('Cute Mountains Inn', 127, '2019-07-24', 337, NULL),
('Cute Mountains Inn', 127, '2019-07-25', 304, NULL),
('Cute Mountains Inn', 127, '2019-07-26', 259, NULL),
('Cute Mountains Inn', 127, '2019-07-27', 355, NULL),
('Cute Mountains Inn', 127, '2019-07-28', 368, NULL),
('Cute Mountains Inn', 127, '2019-07-29', 263, NULL),
('Cute Mountains Inn', 127, '2019-07-30', 200, NULL),
('Cute Mountains Inn', 127, '2019-07-31', 189, NULL),
('Cute Mountains Inn', 127, '2019-08-01', 174, NULL),
('Cute Mountains Inn', 127, '2019-08-02', 222, NULL),
('Cute Mountains Inn', 127, '2019-08-03', 296, NULL),
('Cute Mountains Inn', 127, '2019-08-04', 299, NULL),
('Cute Mountains Inn', 127, '2019-08-05', 128, NULL),
('Cute Mountains Inn', 127, '2019-08-06', 384, NULL),
('Cute Mountains Inn', 127, '2019-08-07', 313, NULL),
('Cute Mountains Inn', 127, '2019-08-08', 302, NULL),
('Cute Mountains Inn', 127, '2019-08-09', 317, NULL),
('Cute Mountains Inn', 127, '2019-08-10', 391, NULL),
('Cute Mountains Inn', 127, '2019-08-11', 255, NULL),
('Cute Mountains Inn', 127, '2019-08-12', 352, NULL),
('Cute Mountains Inn', 127, '2019-08-13', 235, NULL),
('Cute Mountains Inn', 127, '2019-08-14', 288, NULL),
('Cute Mountains Inn', 127, '2019-08-15', 308, NULL),
('Cute Mountains Inn', 127, '2019-08-16', 291, NULL),
('Cute Mountains Inn', 127, '2019-08-17', 146, NULL),
('Cute Mountains Inn', 127, '2019-08-18', 336, NULL),
('Cute Mountains Inn', 127, '2019-08-19', 264, NULL),
('Cute Mountains Inn', 127, '2019-08-20', 351, NULL),
('Cute Mountains Inn', 127, '2019-08-21', 369, NULL),
('Cute Mountains Inn', 127, '2019-08-22', 214, NULL),
('Cute Mountains Inn', 127, '2019-08-23', 210, NULL),
('Cute Mountains Inn', 127, '2019-08-24', 314, NULL),
('Cute Mountains Inn', 127, '2019-08-25', 137, NULL),
('Cute Mountains Inn', 127, '2019-08-26', 240, NULL),
('Cute Mountains Inn', 127, '2019-08-27', 269, NULL),
('Cute Mountains Inn', 127, '2019-08-28', 200, NULL),
('Cute Mountains Inn', 127, '2019-08-29', 150, NULL),
('Cute Mountains Inn', 127, '2019-08-30', 287, NULL),
('Cute Mountains Inn', 127, '2019-08-31', 353, NULL),
('Cute Mountains Inn', 127, '2019-09-01', 244, NULL),
('Cute Mountains Inn', 127, '2019-09-02', 124, NULL),
('Cute Mountains Inn', 127, '2019-09-03', 267, NULL),
('Cute Mountains Inn', 127, '2019-09-04', 219, NULL),
('Cute Mountains Inn', 127, '2019-09-05', 197, NULL),
('Cute Mountains Inn', 127, '2019-09-06', 167, NULL),
('Cute Mountains Inn', 127, '2019-09-07', 129, NULL),
('Cute Mountains Inn', 127, '2019-09-08', 182, NULL),
('Cute Mountains Inn', 127, '2019-09-09', 172, NULL),
('Cute Mountains Inn', 127, '2019-09-10', 175, NULL),
('Cute Mountains Inn', 127, '2019-09-11', 129, NULL),
('Cute Mountains Inn', 127, '2019-09-12', 370, NULL),
('Cute Mountains Inn', 127, '2019-09-13', 295, NULL),
('Cute Mountains Inn', 127, '2019-09-14', 249, NULL),
('Cute Mountains Inn', 127, '2019-09-15', 107, NULL),
('Cute Mountains Inn', 127, '2019-09-16', 351, NULL),
('Cute Mountains Inn', 127, '2019-09-17', 129, NULL),
('Cute Mountains Inn', 127, '2019-09-18', 123, NULL),
('Cute Mountains Inn', 127, '2019-09-19', 242, NULL),
('Cute Mountains Inn', 127, '2019-09-20', 367, NULL),
('Cute Mountains Inn', 127, '2019-09-21', 132, NULL),
('Cute Mountains Inn', 127, '2019-09-22', 335, NULL),
('Cute Mountains Inn', 127, '2019-09-23', 163, NULL),
('Cute Mountains Inn', 127, '2019-09-24', 256, NULL),
('Cute Mountains Inn', 127, '2019-09-25', 137, NULL),
('Cute Mountains Inn', 127, '2019-09-26', 116, NULL),
('Cute Mountains Inn', 127, '2019-09-27', 134, NULL),
('Cute Mountains Inn', 127, '2019-09-28', 319, NULL),
('Cute Mountains Inn', 127, '2019-09-29', 150, NULL),
('Cute Mountains Inn', 127, '2019-09-30', 380, NULL),
('Cute Mountains Inn', 127, '2019-10-01', 189, NULL),
('Cute Mountains Inn', 127, '2019-10-02', 303, NULL),
('Cute Mountains Inn', 127, '2019-10-03', 390, NULL),
('Cute Mountains Inn', 127, '2019-10-04', 215, NULL),
('Cute Mountains Inn', 127, '2019-10-05', 340, NULL),
('Cute Mountains Inn', 127, '2019-10-06', 176, NULL),
('Cute Mountains Inn', 127, '2019-10-07', 316, NULL),
('Cute Mountains Inn', 127, '2019-10-08', 178, NULL),
('Cute Mountains Inn', 127, '2019-10-09', 394, NULL),
('Cute Mountains Inn', 127, '2019-10-10', 119, NULL),
('Cute Mountains Inn', 127, '2019-10-11', 269, NULL),
('Cute Mountains Inn', 127, '2019-10-12', 329, NULL),
('Cute Mountains Inn', 127, '2019-10-13', 260, NULL),
('Cute Mountains Inn', 127, '2019-10-14', 390, NULL),
('Cute Mountains Inn', 127, '2019-10-15', 151, NULL),
('Cute Mountains Inn', 127, '2019-10-16', 188, NULL),
('Cute Mountains Inn', 127, '2019-10-17', 292, NULL),
('Cute Mountains Inn', 127, '2019-10-18', 230, NULL),
('Cute Mountains Inn', 127, '2019-10-19', 105, NULL),
('Cute Mountains Inn', 127, '2019-10-20', 295, NULL),
('Cute Mountains Inn', 127, '2019-10-21', 230, NULL),
('Cute Mountains Inn', 127, '2019-10-22', 204, NULL),
('Cute Mountains Inn', 127, '2019-10-23', 211, NULL),
('Cute Mountains Inn', 127, '2019-10-24', 172, NULL),
('Cute Mountains Inn', 127, '2019-10-25', 104, NULL),
('Cute Mountains Inn', 127, '2019-10-26', 309, NULL),
('Cute Mountains Inn', 127, '2019-10-27', 360, NULL),
('Cute Mountains Inn', 127, '2019-10-28', 147, NULL),
('Cute Mountains Inn', 127, '2019-10-29', 324, NULL),
('Cute Mountains Inn', 127, '2019-10-30', 360, NULL),
('Cute Mountains Inn', 127, '2019-10-31', 212, NULL),
('Cute Mountains Inn', 127, '2019-11-01', 207, NULL),
('Cute Mountains Inn', 127, '2019-11-02', 370, NULL),
('Cute Mountains Inn', 127, '2019-11-03', 286, NULL),
('Cute Mountains Inn', 127, '2019-11-04', 146, NULL),
('Cute Mountains Inn', 127, '2019-11-05', 221, NULL),
('Cute Mountains Inn', 127, '2019-11-06', 118, NULL),
('Cute Mountains Inn', 127, '2019-11-07', 238, NULL),
('Cute Mountains Inn', 127, '2019-11-08', 349, NULL),
('Cute Mountains Inn', 127, '2019-11-09', 359, NULL),
('Cute Mountains Inn', 127, '2019-11-10', 118, NULL),
('Cute Mountains Inn', 127, '2019-11-11', 114, NULL),
('Cute Mountains Inn', 127, '2019-11-12', 361, NULL),
('Cute Mountains Inn', 127, '2019-11-13', 109, NULL),
('Cute Mountains Inn', 127, '2019-11-14', 333, NULL),
('Cute Mountains Inn', 127, '2019-11-15', 118, NULL),
('Cute Mountains Inn', 127, '2019-11-16', 177, NULL),
('Cute Mountains Inn', 127, '2019-11-17', 353, NULL),
('Cute Mountains Inn', 127, '2019-11-18', 287, NULL),
('Cute Mountains Inn', 127, '2019-11-19', 396, NULL),
('Cute Mountains Inn', 127, '2019-11-20', 297, NULL),
('Cute Mountains Inn', 127, '2019-11-21', 369, NULL),
('Cute Mountains Inn', 127, '2019-11-22', 362, NULL),
('Cute Mountains Inn', 127, '2019-11-23', 206, NULL),
('Cute Mountains Inn', 127, '2019-11-24', 233, NULL),
('Cute Mountains Inn', 127, '2019-11-25', 284, NULL),
('Cute Mountains Inn', 127, '2019-11-26', 390, NULL),
('Cute Mountains Inn', 127, '2019-11-27', 204, NULL),
('Cute Mountains Inn', 127, '2019-11-28', 304, NULL),
('Cute Mountains Inn', 127, '2019-11-29', 103, NULL),
('Cute Mountains Inn', 127, '2019-11-30', 266, NULL),
('Cute Mountains Inn', 127, '2019-12-01', 336, NULL),
('Cute Mountains Inn', 127, '2019-12-02', 179, NULL),
('Cute Mountains Inn', 127, '2019-12-03', 197, NULL),
('Cute Mountains Inn', 127, '2019-12-04', 317, NULL),
('Cute Mountains Inn', 127, '2019-12-05', 335, NULL),
('Cute Mountains Inn', 127, '2019-12-06', 383, NULL),
('Cute Mountains Inn', 127, '2019-12-07', 231, NULL),
('Cute Mountains Inn', 127, '2019-12-08', 110, NULL),
('Cute Mountains Inn', 127, '2019-12-09', 167, NULL),
('Cute Mountains Inn', 127, '2019-12-10', 257, NULL),
('Cute Mountains Inn', 127, '2019-12-11', 208, NULL),
('Cute Mountains Inn', 127, '2019-12-12', 176, NULL),
('Cute Mountains Inn', 127, '2019-12-13', 229, NULL),
('Cute Mountains Inn', 127, '2019-12-14', 194, NULL),
('Cute Mountains Inn', 127, '2019-12-15', 208, NULL),
('Cute Mountains Inn', 127, '2019-12-16', 307, NULL),
('Cute Mountains Inn', 127, '2019-12-17', 247, NULL),
('Cute Mountains Inn', 127, '2019-12-18', 272, NULL),
('Cute Mountains Inn', 127, '2019-12-19', 366, NULL),
('Cute Mountains Inn', 127, '2019-12-20', 332, NULL),
('Cute Mountains Inn', 127, '2019-12-21', 312, NULL),
('Cute Mountains Inn', 127, '2019-12-22', 395, NULL),
('Cute Mountains Inn', 127, '2019-12-23', 165, NULL),
('Cute Mountains Inn', 127, '2019-12-24', 247, NULL),
('Cute Mountains Inn', 127, '2019-12-25', 305, NULL),
('Cute Mountains Inn', 127, '2019-12-26', 293, NULL),
('Cute Mountains Inn', 127, '2019-12-27', 222, NULL),
('Cute Mountains Inn', 127, '2019-12-28', 247, NULL),
('Cute Mountains Inn', 127, '2019-12-29', 100, NULL),
('Cute Mountains Inn', 127, '2019-12-30', 100, NULL),
('Cute Mountains Inn', 127, '2019-12-31', 125, NULL),
('Cute Mountains Inn', 127, '2020-01-01', 160, NULL),
('Cute Mountains Inn', 127, '2020-01-02', 193, NULL),
('Cute Mountains Inn', 127, '2020-01-03', 192, NULL),
('Cute Mountains Inn', 127, '2020-01-04', 188, NULL),
('Cute Mountains Inn', 127, '2020-01-05', 147, NULL),
('Cute Mountains Inn', 127, '2020-01-06', 189, NULL),
('Cute Mountains Inn', 127, '2020-01-07', 193, NULL),
('Cute Mountains Inn', 127, '2020-01-08', 131, NULL),
('Cute Mountains Inn', 127, '2020-01-09', 393, NULL),
('Cute Mountains Inn', 127, '2020-01-10', 138, NULL),
('Cute Mountains Inn', 127, '2020-01-11', 116, NULL),
('Cute Mountains Inn', 127, '2020-01-12', 156, NULL),
('Cute Mountains Inn', 127, '2020-01-13', 138, NULL),
('Cute Mountains Inn', 127, '2020-01-14', 299, NULL),
('Cute Mountains Inn', 127, '2020-01-15', 355, NULL),
('Cute Mountains Inn', 127, '2020-01-16', 144, NULL),
('Cute Mountains Inn', 127, '2020-01-17', 286, NULL),
('Cute Mountains Inn', 127, '2020-01-18', 174, NULL),
('Cute Mountains Inn', 127, '2020-01-19', 254, NULL),
('Cute Mountains Inn', 127, '2020-01-20', 298, NULL),
('Cute Mountains Inn', 127, '2020-01-21', 263, NULL),
('Cute Mountains Inn', 127, '2020-01-22', 242, NULL),
('Cute Mountains Inn', 127, '2020-01-23', 210, NULL),
('Cute Mountains Inn', 127, '2020-01-24', 301, NULL),
('Cute Mountains Inn', 127, '2020-01-25', 268, NULL),
('Cute Mountains Inn', 127, '2020-01-26', 148, NULL),
('Cute Mountains Inn', 127, '2020-01-27', 290, NULL),
('Cute Mountains Inn', 127, '2020-01-28', 259, NULL),
('Cute Mountains Inn', 127, '2020-01-29', 220, NULL),
('Cute Mountains Inn', 127, '2020-01-30', 333, NULL),
('Cute Mountains Inn', 127, '2020-01-31', 157, NULL),
('Cute Mountains Inn', 127, '2020-02-01', 317, NULL),
('Cute Mountains Inn', 127, '2020-02-02', 329, NULL),
('Cute Mountains Inn', 127, '2020-02-03', 349, NULL),
('Cute Mountains Inn', 127, '2020-02-04', 218, NULL),
('Cute Mountains Inn', 130, '2019-01-01', 269, NULL),
('Cute Mountains Inn', 130, '2019-01-02', 226, NULL),
('Cute Mountains Inn', 130, '2019-01-03', 290, NULL),
('Cute Mountains Inn', 130, '2019-01-04', 301, NULL),
('Cute Mountains Inn', 130, '2019-01-05', 397, NULL),
('Cute Mountains Inn', 130, '2019-01-06', 395, NULL),
('Cute Mountains Inn', 130, '2019-01-07', 172, NULL),
('Cute Mountains Inn', 130, '2019-01-08', 251, NULL),
('Cute Mountains Inn', 130, '2019-01-09', 150, NULL),
('Cute Mountains Inn', 130, '2019-01-10', 351, NULL),
('Cute Mountains Inn', 130, '2019-01-11', 280, NULL),
('Cute Mountains Inn', 130, '2019-01-12', 292, NULL),
('Cute Mountains Inn', 130, '2019-01-13', 167, NULL),
('Cute Mountains Inn', 130, '2019-01-14', 307, NULL),
('Cute Mountains Inn', 130, '2019-01-15', 231, NULL),
('Cute Mountains Inn', 130, '2019-01-16', 196, NULL),
('Cute Mountains Inn', 130, '2019-01-17', 148, NULL),
('Cute Mountains Inn', 130, '2019-01-18', 175, NULL),
('Cute Mountains Inn', 130, '2019-01-19', 197, NULL),
('Cute Mountains Inn', 130, '2019-01-20', 127, NULL),
('Cute Mountains Inn', 130, '2019-01-21', 134, NULL),
('Cute Mountains Inn', 130, '2019-01-22', 259, NULL),
('Cute Mountains Inn', 130, '2019-01-23', 182, NULL),
('Cute Mountains Inn', 130, '2019-01-24', 305, NULL),
('Cute Mountains Inn', 130, '2019-01-25', 310, NULL),
('Cute Mountains Inn', 130, '2019-01-26', 321, NULL),
('Cute Mountains Inn', 130, '2019-01-27', 346, NULL),
('Cute Mountains Inn', 130, '2019-01-28', 241, NULL),
('Cute Mountains Inn', 130, '2019-01-29', 179, NULL),
('Cute Mountains Inn', 130, '2019-01-30', 262, NULL),
('Cute Mountains Inn', 130, '2019-01-31', 244, NULL),
('Cute Mountains Inn', 130, '2019-02-01', 196, NULL),
('Cute Mountains Inn', 130, '2019-02-02', 239, NULL),
('Cute Mountains Inn', 130, '2019-02-03', 175, NULL),
('Cute Mountains Inn', 130, '2019-02-04', 212, NULL),
('Cute Mountains Inn', 130, '2019-02-05', 390, NULL),
('Cute Mountains Inn', 130, '2019-02-06', 316, NULL),
('Cute Mountains Inn', 130, '2019-02-07', 355, NULL),
('Cute Mountains Inn', 130, '2019-02-08', 268, NULL),
('Cute Mountains Inn', 130, '2019-02-09', 203, NULL),
('Cute Mountains Inn', 130, '2019-02-10', 272, NULL),
('Cute Mountains Inn', 130, '2019-02-11', 128, NULL),
('Cute Mountains Inn', 130, '2019-02-12', 359, NULL),
('Cute Mountains Inn', 130, '2019-02-13', 163, NULL),
('Cute Mountains Inn', 130, '2019-02-14', 377, NULL),
('Cute Mountains Inn', 130, '2019-02-15', 346, NULL),
('Cute Mountains Inn', 130, '2019-02-16', 390, NULL),
('Cute Mountains Inn', 130, '2019-02-17', 110, NULL),
('Cute Mountains Inn', 130, '2019-02-18', 341, NULL),
('Cute Mountains Inn', 130, '2019-02-19', 389, NULL),
('Cute Mountains Inn', 130, '2019-02-20', 118, NULL),
('Cute Mountains Inn', 130, '2019-02-21', 297, NULL),
('Cute Mountains Inn', 130, '2019-02-22', 303, NULL),
('Cute Mountains Inn', 130, '2019-02-23', 350, NULL),
('Cute Mountains Inn', 130, '2019-02-24', 138, NULL),
('Cute Mountains Inn', 130, '2019-02-25', 113, NULL),
('Cute Mountains Inn', 130, '2019-02-26', 189, NULL),
('Cute Mountains Inn', 130, '2019-02-27', 365, NULL),
('Cute Mountains Inn', 130, '2019-02-28', 278, NULL),
('Cute Mountains Inn', 130, '2019-03-01', 349, NULL),
('Cute Mountains Inn', 130, '2019-03-02', 178, NULL),
('Cute Mountains Inn', 130, '2019-03-03', 206, NULL),
('Cute Mountains Inn', 130, '2019-03-04', 208, NULL),
('Cute Mountains Inn', 130, '2019-03-05', 250, NULL),
('Cute Mountains Inn', 130, '2019-03-06', 398, NULL),
('Cute Mountains Inn', 130, '2019-03-07', 320, NULL),
('Cute Mountains Inn', 130, '2019-03-08', 395, NULL),
('Cute Mountains Inn', 130, '2019-03-09', 275, NULL),
('Cute Mountains Inn', 130, '2019-03-10', 299, NULL),
('Cute Mountains Inn', 130, '2019-03-11', 291, NULL),
('Cute Mountains Inn', 130, '2019-03-12', 146, NULL),
('Cute Mountains Inn', 130, '2019-03-13', 373, NULL),
('Cute Mountains Inn', 130, '2019-03-14', 352, NULL),
('Cute Mountains Inn', 130, '2019-03-15', 228, NULL),
('Cute Mountains Inn', 130, '2019-03-16', 336, NULL),
('Cute Mountains Inn', 130, '2019-03-17', 241, NULL),
('Cute Mountains Inn', 130, '2019-03-18', 321, NULL),
('Cute Mountains Inn', 130, '2019-03-19', 175, NULL),
('Cute Mountains Inn', 130, '2019-03-20', 378, NULL),
('Cute Mountains Inn', 130, '2019-03-21', 361, NULL),
('Cute Mountains Inn', 130, '2019-03-22', 166, NULL),
('Cute Mountains Inn', 130, '2019-03-23', 217, NULL),
('Cute Mountains Inn', 130, '2019-03-24', 280, NULL),
('Cute Mountains Inn', 130, '2019-03-25', 262, NULL),
('Cute Mountains Inn', 130, '2019-03-26', 184, NULL),
('Cute Mountains Inn', 130, '2019-03-27', 107, NULL),
('Cute Mountains Inn', 130, '2019-03-28', 147, NULL),
('Cute Mountains Inn', 130, '2019-03-29', 144, NULL),
('Cute Mountains Inn', 130, '2019-03-30', 167, NULL),
('Cute Mountains Inn', 130, '2019-03-31', 377, NULL),
('Cute Mountains Inn', 130, '2019-04-01', 133, NULL),
('Cute Mountains Inn', 130, '2019-04-02', 219, NULL),
('Cute Mountains Inn', 130, '2019-04-03', 275, NULL),
('Cute Mountains Inn', 130, '2019-04-04', 310, NULL),
('Cute Mountains Inn', 130, '2019-04-05', 217, NULL),
('Cute Mountains Inn', 130, '2019-04-06', 327, NULL),
('Cute Mountains Inn', 130, '2019-04-07', 237, NULL),
('Cute Mountains Inn', 130, '2019-04-08', 100, NULL),
('Cute Mountains Inn', 130, '2019-04-09', 387, NULL),
('Cute Mountains Inn', 130, '2019-04-10', 185, NULL),
('Cute Mountains Inn', 130, '2019-04-11', 302, NULL),
('Cute Mountains Inn', 130, '2019-04-12', 153, NULL),
('Cute Mountains Inn', 130, '2019-04-13', 276, NULL),
('Cute Mountains Inn', 130, '2019-04-14', 304, NULL),
('Cute Mountains Inn', 130, '2019-04-15', 201, NULL),
('Cute Mountains Inn', 130, '2019-04-16', 298, NULL),
('Cute Mountains Inn', 130, '2019-04-17', 132, NULL),
('Cute Mountains Inn', 130, '2019-04-18', 371, NULL),
('Cute Mountains Inn', 130, '2019-04-19', 299, NULL),
('Cute Mountains Inn', 130, '2019-04-20', 183, NULL),
('Cute Mountains Inn', 130, '2019-04-21', 240, NULL),
('Cute Mountains Inn', 130, '2019-04-22', 358, NULL),
('Cute Mountains Inn', 130, '2019-04-23', 361, NULL),
('Cute Mountains Inn', 130, '2019-04-24', 203, NULL),
('Cute Mountains Inn', 130, '2019-04-25', 106, NULL),
('Cute Mountains Inn', 130, '2019-04-26', 146, NULL),
('Cute Mountains Inn', 130, '2019-04-27', 311, NULL),
('Cute Mountains Inn', 130, '2019-04-28', 250, NULL),
('Cute Mountains Inn', 130, '2019-04-29', 100, NULL),
('Cute Mountains Inn', 130, '2019-04-30', 163, NULL),
('Cute Mountains Inn', 130, '2019-05-01', 398, NULL),
('Cute Mountains Inn', 130, '2019-05-02', 195, NULL),
('Cute Mountains Inn', 130, '2019-05-03', 259, NULL),
('Cute Mountains Inn', 130, '2019-05-04', 244, NULL),
('Cute Mountains Inn', 130, '2019-05-05', 124, NULL),
('Cute Mountains Inn', 130, '2019-05-06', 142, NULL),
('Cute Mountains Inn', 130, '2019-05-07', 278, NULL),
('Cute Mountains Inn', 130, '2019-05-08', 191, NULL),
('Cute Mountains Inn', 130, '2019-05-09', 184, NULL),
('Cute Mountains Inn', 130, '2019-05-10', 184, NULL),
('Cute Mountains Inn', 130, '2019-05-11', 391, NULL),
('Cute Mountains Inn', 130, '2019-05-12', 385, NULL),
('Cute Mountains Inn', 130, '2019-05-13', 357, NULL),
('Cute Mountains Inn', 130, '2019-05-14', 163, NULL),
('Cute Mountains Inn', 130, '2019-05-15', 173, NULL),
('Cute Mountains Inn', 130, '2019-05-16', 188, NULL),
('Cute Mountains Inn', 130, '2019-05-17', 360, NULL),
('Cute Mountains Inn', 130, '2019-05-18', 183, NULL),
('Cute Mountains Inn', 130, '2019-05-19', 104, NULL),
('Cute Mountains Inn', 130, '2019-05-20', 376, NULL),
('Cute Mountains Inn', 130, '2019-05-21', 101, NULL),
('Cute Mountains Inn', 130, '2019-05-22', 268, NULL),
('Cute Mountains Inn', 130, '2019-05-23', 388, NULL),
('Cute Mountains Inn', 130, '2019-05-24', 254, NULL),
('Cute Mountains Inn', 130, '2019-05-25', 256, NULL),
('Cute Mountains Inn', 130, '2019-05-26', 209, NULL),
('Cute Mountains Inn', 130, '2019-05-27', 352, NULL),
('Cute Mountains Inn', 130, '2019-05-28', 323, NULL),
('Cute Mountains Inn', 130, '2019-05-29', 187, NULL),
('Cute Mountains Inn', 130, '2019-05-30', 336, NULL),
('Cute Mountains Inn', 130, '2019-05-31', 212, NULL),
('Cute Mountains Inn', 130, '2019-06-01', 382, NULL),
('Cute Mountains Inn', 130, '2019-06-02', 134, NULL),
('Cute Mountains Inn', 130, '2019-06-03', 112, NULL),
('Cute Mountains Inn', 130, '2019-06-04', 346, NULL),
('Cute Mountains Inn', 130, '2019-06-05', 334, NULL),
('Cute Mountains Inn', 130, '2019-06-06', 321, NULL),
('Cute Mountains Inn', 130, '2019-06-07', 336, NULL),
('Cute Mountains Inn', 130, '2019-06-08', 163, NULL),
('Cute Mountains Inn', 130, '2019-06-09', 189, NULL),
('Cute Mountains Inn', 130, '2019-06-10', 389, NULL),
('Cute Mountains Inn', 130, '2019-06-11', 376, NULL),
('Cute Mountains Inn', 130, '2019-06-12', 330, NULL),
('Cute Mountains Inn', 130, '2019-06-13', 162, NULL),
('Cute Mountains Inn', 130, '2019-06-14', 363, NULL),
('Cute Mountains Inn', 130, '2019-06-15', 333, NULL),
('Cute Mountains Inn', 130, '2019-06-16', 190, NULL),
('Cute Mountains Inn', 130, '2019-06-17', 221, NULL),
('Cute Mountains Inn', 130, '2019-06-18', 335, NULL),
('Cute Mountains Inn', 130, '2019-06-19', 327, NULL),
('Cute Mountains Inn', 130, '2019-06-20', 241, NULL),
('Cute Mountains Inn', 130, '2019-06-21', 311, NULL),
('Cute Mountains Inn', 130, '2019-06-22', 290, NULL),
('Cute Mountains Inn', 130, '2019-06-23', 373, NULL),
('Cute Mountains Inn', 130, '2019-06-24', 181, NULL),
('Cute Mountains Inn', 130, '2019-06-25', 311, NULL),
('Cute Mountains Inn', 130, '2019-06-26', 190, NULL),
('Cute Mountains Inn', 130, '2019-06-27', 353, NULL),
('Cute Mountains Inn', 130, '2019-06-28', 329, NULL),
('Cute Mountains Inn', 130, '2019-06-29', 174, NULL),
('Cute Mountains Inn', 130, '2019-06-30', 121, NULL),
('Cute Mountains Inn', 130, '2019-07-01', 278, NULL),
('Cute Mountains Inn', 130, '2019-07-02', 315, NULL),
('Cute Mountains Inn', 130, '2019-07-03', 158, NULL),
('Cute Mountains Inn', 130, '2019-07-04', 125, NULL),
('Cute Mountains Inn', 130, '2019-07-05', 140, NULL),
('Cute Mountains Inn', 130, '2019-07-06', 236, NULL),
('Cute Mountains Inn', 130, '2019-07-07', 233, NULL),
('Cute Mountains Inn', 130, '2019-07-08', 196, NULL),
('Cute Mountains Inn', 130, '2019-07-09', 215, NULL),
('Cute Mountains Inn', 130, '2019-07-10', 399, NULL),
('Cute Mountains Inn', 130, '2019-07-11', 135, NULL),
('Cute Mountains Inn', 130, '2019-07-12', 289, NULL),
('Cute Mountains Inn', 130, '2019-07-13', 146, NULL),
('Cute Mountains Inn', 130, '2019-07-14', 157, NULL),
('Cute Mountains Inn', 130, '2019-07-15', 125, NULL),
('Cute Mountains Inn', 130, '2019-07-16', 149, NULL),
('Cute Mountains Inn', 130, '2019-07-17', 338, NULL),
('Cute Mountains Inn', 130, '2019-07-18', 314, NULL),
('Cute Mountains Inn', 130, '2019-07-19', 211, NULL),
('Cute Mountains Inn', 130, '2019-07-20', 388, NULL),
('Cute Mountains Inn', 130, '2019-07-21', 182, NULL),
('Cute Mountains Inn', 130, '2019-07-22', 169, NULL),
('Cute Mountains Inn', 130, '2019-07-23', 133, NULL),
('Cute Mountains Inn', 130, '2019-07-24', 102, NULL),
('Cute Mountains Inn', 130, '2019-07-25', 105, NULL),
('Cute Mountains Inn', 130, '2019-07-26', 103, NULL),
('Cute Mountains Inn', 130, '2019-07-27', 131, NULL),
('Cute Mountains Inn', 130, '2019-07-28', 281, NULL),
('Cute Mountains Inn', 130, '2019-07-29', 167, NULL),
('Cute Mountains Inn', 130, '2019-07-30', 329, NULL),
('Cute Mountains Inn', 130, '2019-07-31', 290, NULL),
('Cute Mountains Inn', 130, '2019-08-01', 216, NULL),
('Cute Mountains Inn', 130, '2019-08-02', 209, NULL),
('Cute Mountains Inn', 130, '2019-08-03', 113, NULL),
('Cute Mountains Inn', 130, '2019-08-04', 352, NULL),
('Cute Mountains Inn', 130, '2019-08-05', 376, NULL),
('Cute Mountains Inn', 130, '2019-08-06', 373, NULL),
('Cute Mountains Inn', 130, '2019-08-07', 218, NULL),
('Cute Mountains Inn', 130, '2019-08-08', 258, NULL),
('Cute Mountains Inn', 130, '2019-08-09', 251, NULL),
('Cute Mountains Inn', 130, '2019-08-10', 217, NULL),
('Cute Mountains Inn', 130, '2019-08-11', 300, NULL),
('Cute Mountains Inn', 130, '2019-08-12', 338, NULL),
('Cute Mountains Inn', 130, '2019-08-13', 392, NULL),
('Cute Mountains Inn', 130, '2019-08-14', 381, NULL),
('Cute Mountains Inn', 130, '2019-08-15', 363, NULL),
('Cute Mountains Inn', 130, '2019-08-16', 249, NULL),
('Cute Mountains Inn', 130, '2019-08-17', 119, NULL),
('Cute Mountains Inn', 130, '2019-08-18', 325, NULL),
('Cute Mountains Inn', 130, '2019-08-19', 164, NULL),
('Cute Mountains Inn', 130, '2019-08-20', 324, NULL),
('Cute Mountains Inn', 130, '2019-08-21', 391, NULL),
('Cute Mountains Inn', 130, '2019-08-22', 349, NULL),
('Cute Mountains Inn', 130, '2019-08-23', 159, NULL),
('Cute Mountains Inn', 130, '2019-08-24', 257, NULL),
('Cute Mountains Inn', 130, '2019-08-25', 334, NULL),
('Cute Mountains Inn', 130, '2019-08-26', 186, NULL),
('Cute Mountains Inn', 130, '2019-08-27', 213, NULL),
('Cute Mountains Inn', 130, '2019-08-28', 310, NULL),
('Cute Mountains Inn', 130, '2019-08-29', 191, NULL),
('Cute Mountains Inn', 130, '2019-08-30', 160, NULL),
('Cute Mountains Inn', 130, '2019-08-31', 331, NULL),
('Cute Mountains Inn', 130, '2019-09-01', 378, NULL),
('Cute Mountains Inn', 130, '2019-09-02', 398, NULL),
('Cute Mountains Inn', 130, '2019-09-03', 184, NULL),
('Cute Mountains Inn', 130, '2019-09-04', 128, NULL),
('Cute Mountains Inn', 130, '2019-09-05', 375, NULL),
('Cute Mountains Inn', 130, '2019-09-06', 227, NULL),
('Cute Mountains Inn', 130, '2019-09-07', 173, NULL),
('Cute Mountains Inn', 130, '2019-09-08', 238, NULL),
('Cute Mountains Inn', 130, '2019-09-09', 370, NULL),
('Cute Mountains Inn', 130, '2019-09-10', 233, NULL),
('Cute Mountains Inn', 130, '2019-09-11', 272, NULL),
('Cute Mountains Inn', 130, '2019-09-12', 240, NULL),
('Cute Mountains Inn', 130, '2019-09-13', 333, NULL),
('Cute Mountains Inn', 130, '2019-09-14', 315, NULL),
('Cute Mountains Inn', 130, '2019-09-15', 378, NULL),
('Cute Mountains Inn', 130, '2019-09-16', 334, NULL),
('Cute Mountains Inn', 130, '2019-09-17', 323, NULL),
('Cute Mountains Inn', 130, '2019-09-18', 252, NULL),
('Cute Mountains Inn', 130, '2019-09-19', 220, NULL),
('Cute Mountains Inn', 130, '2019-09-20', 323, NULL),
('Cute Mountains Inn', 130, '2019-09-21', 286, NULL),
('Cute Mountains Inn', 130, '2019-09-22', 189, NULL),
('Cute Mountains Inn', 130, '2019-09-23', 359, NULL),
('Cute Mountains Inn', 130, '2019-09-24', 152, NULL),
('Cute Mountains Inn', 130, '2019-09-25', 398, NULL),
('Cute Mountains Inn', 130, '2019-09-26', 326, NULL),
('Cute Mountains Inn', 130, '2019-09-27', 277, NULL),
('Cute Mountains Inn', 130, '2019-09-28', 383, NULL),
('Cute Mountains Inn', 130, '2019-09-29', 248, NULL),
('Cute Mountains Inn', 130, '2019-09-30', 158, NULL),
('Cute Mountains Inn', 130, '2019-10-01', 383, NULL),
('Cute Mountains Inn', 130, '2019-10-02', 260, NULL),
('Cute Mountains Inn', 130, '2019-10-03', 336, NULL),
('Cute Mountains Inn', 130, '2019-10-04', 184, NULL),
('Cute Mountains Inn', 130, '2019-10-05', 361, NULL),
('Cute Mountains Inn', 130, '2019-10-06', 316, NULL),
('Cute Mountains Inn', 130, '2019-10-07', 128, NULL),
('Cute Mountains Inn', 130, '2019-10-08', 324, NULL),
('Cute Mountains Inn', 130, '2019-10-09', 105, NULL),
('Cute Mountains Inn', 130, '2019-10-10', 375, NULL),
('Cute Mountains Inn', 130, '2019-10-11', 398, NULL),
('Cute Mountains Inn', 130, '2019-10-12', 148, NULL),
('Cute Mountains Inn', 130, '2019-10-13', 277, NULL),
('Cute Mountains Inn', 130, '2019-10-14', 392, NULL),
('Cute Mountains Inn', 130, '2019-10-15', 242, NULL),
('Cute Mountains Inn', 130, '2019-10-16', 100, NULL),
('Cute Mountains Inn', 130, '2019-10-17', 112, NULL),
('Cute Mountains Inn', 130, '2019-10-18', 101, NULL),
('Cute Mountains Inn', 130, '2019-10-19', 234, NULL),
('Cute Mountains Inn', 130, '2019-10-20', 290, NULL),
('Cute Mountains Inn', 130, '2019-10-21', 375, NULL),
('Cute Mountains Inn', 130, '2019-10-22', 235, NULL),
('Cute Mountains Inn', 130, '2019-10-23', 205, NULL),
('Cute Mountains Inn', 130, '2019-10-24', 191, NULL),
('Cute Mountains Inn', 130, '2019-10-25', 338, NULL),
('Cute Mountains Inn', 130, '2019-10-26', 202, NULL),
('Cute Mountains Inn', 130, '2019-10-27', 101, NULL),
('Cute Mountains Inn', 130, '2019-10-28', 229, NULL),
('Cute Mountains Inn', 130, '2019-10-29', 252, NULL),
('Cute Mountains Inn', 130, '2019-10-30', 366, NULL),
('Cute Mountains Inn', 130, '2019-10-31', 268, NULL),
('Cute Mountains Inn', 130, '2019-11-01', 398, NULL),
('Cute Mountains Inn', 130, '2019-11-02', 123, NULL),
('Cute Mountains Inn', 130, '2019-11-03', 333, NULL),
('Cute Mountains Inn', 130, '2019-11-04', 182, NULL),
('Cute Mountains Inn', 130, '2019-11-05', 287, NULL),
('Cute Mountains Inn', 130, '2019-11-06', 387, NULL),
('Cute Mountains Inn', 130, '2019-11-07', 380, NULL),
('Cute Mountains Inn', 130, '2019-11-08', 214, NULL),
('Cute Mountains Inn', 130, '2019-11-09', 191, NULL),
('Cute Mountains Inn', 130, '2019-11-10', 292, NULL),
('Cute Mountains Inn', 130, '2019-11-11', 242, NULL),
('Cute Mountains Inn', 130, '2019-11-12', 230, NULL),
('Cute Mountains Inn', 130, '2019-11-13', 203, NULL),
('Cute Mountains Inn', 130, '2019-11-14', 358, NULL),
('Cute Mountains Inn', 130, '2019-11-15', 372, NULL),
('Cute Mountains Inn', 130, '2019-11-16', 119, NULL),
('Cute Mountains Inn', 130, '2019-11-17', 364, NULL),
('Cute Mountains Inn', 130, '2019-11-18', 311, NULL),
('Cute Mountains Inn', 130, '2019-11-19', 105, NULL),
('Cute Mountains Inn', 130, '2019-11-20', 166, NULL),
('Cute Mountains Inn', 130, '2019-11-21', 320, NULL),
('Cute Mountains Inn', 130, '2019-11-22', 348, NULL),
('Cute Mountains Inn', 130, '2019-11-23', 297, NULL),
('Cute Mountains Inn', 130, '2019-11-24', 326, NULL),
('Cute Mountains Inn', 130, '2019-11-25', 349, NULL),
('Cute Mountains Inn', 130, '2019-11-26', 313, NULL),
('Cute Mountains Inn', 130, '2019-11-27', 237, NULL),
('Cute Mountains Inn', 130, '2019-11-28', 145, NULL),
('Cute Mountains Inn', 130, '2019-11-29', 255, NULL),
('Cute Mountains Inn', 130, '2019-11-30', 215, NULL),
('Cute Mountains Inn', 130, '2019-12-01', 212, NULL),
('Cute Mountains Inn', 130, '2019-12-02', 320, NULL),
('Cute Mountains Inn', 130, '2019-12-03', 270, NULL),
('Cute Mountains Inn', 130, '2019-12-04', 368, NULL),
('Cute Mountains Inn', 130, '2019-12-05', 328, NULL),
('Cute Mountains Inn', 130, '2019-12-06', 348, NULL),
('Cute Mountains Inn', 130, '2019-12-07', 194, NULL),
('Cute Mountains Inn', 130, '2019-12-08', 288, NULL),
('Cute Mountains Inn', 130, '2019-12-09', 274, NULL),
('Cute Mountains Inn', 130, '2019-12-10', 392, NULL),
('Cute Mountains Inn', 130, '2019-12-11', 375, NULL),
('Cute Mountains Inn', 130, '2019-12-12', 263, NULL),
('Cute Mountains Inn', 130, '2019-12-13', 284, NULL),
('Cute Mountains Inn', 130, '2019-12-14', 102, NULL),
('Cute Mountains Inn', 130, '2019-12-15', 112, NULL),
('Cute Mountains Inn', 130, '2019-12-16', 255, NULL),
('Cute Mountains Inn', 130, '2019-12-17', 348, NULL),
('Cute Mountains Inn', 130, '2019-12-18', 202, NULL),
('Cute Mountains Inn', 130, '2019-12-19', 107, NULL),
('Cute Mountains Inn', 130, '2019-12-20', 269, NULL),
('Cute Mountains Inn', 130, '2019-12-21', 303, NULL),
('Cute Mountains Inn', 130, '2019-12-22', 305, NULL),
('Cute Mountains Inn', 130, '2019-12-23', 220, NULL),
('Cute Mountains Inn', 130, '2019-12-24', 300, NULL),
('Cute Mountains Inn', 130, '2019-12-25', 149, NULL),
('Cute Mountains Inn', 130, '2019-12-26', 340, NULL),
('Cute Mountains Inn', 130, '2019-12-27', 386, NULL),
('Cute Mountains Inn', 130, '2019-12-28', 104, NULL),
('Cute Mountains Inn', 130, '2019-12-29', 386, NULL),
('Cute Mountains Inn', 130, '2019-12-30', 362, NULL),
('Cute Mountains Inn', 130, '2019-12-31', 150, NULL),
('Cute Mountains Inn', 130, '2020-01-01', 186, NULL),
('Cute Mountains Inn', 130, '2020-01-02', 386, NULL),
('Cute Mountains Inn', 130, '2020-01-03', 109, NULL),
('Cute Mountains Inn', 130, '2020-01-04', 189, NULL),
('Cute Mountains Inn', 130, '2020-01-05', 355, NULL),
('Cute Mountains Inn', 130, '2020-01-06', 232, NULL),
('Cute Mountains Inn', 130, '2020-01-07', 106, NULL),
('Cute Mountains Inn', 130, '2020-01-08', 350, NULL),
('Cute Mountains Inn', 130, '2020-01-09', 148, NULL),
('Cute Mountains Inn', 130, '2020-01-10', 250, NULL),
('Cute Mountains Inn', 130, '2020-01-11', 256, NULL),
('Cute Mountains Inn', 130, '2020-01-12', 113, NULL),
('Cute Mountains Inn', 130, '2020-01-13', 303, NULL),
('Cute Mountains Inn', 130, '2020-01-14', 247, NULL),
('Cute Mountains Inn', 130, '2020-01-15', 180, NULL),
('Cute Mountains Inn', 130, '2020-01-16', 228, NULL),
('Cute Mountains Inn', 130, '2020-01-17', 329, NULL),
('Cute Mountains Inn', 130, '2020-01-18', 176, NULL),
('Cute Mountains Inn', 130, '2020-01-19', 103, NULL),
('Cute Mountains Inn', 130, '2020-01-20', 192, NULL),
('Cute Mountains Inn', 130, '2020-01-21', 361, NULL),
('Cute Mountains Inn', 130, '2020-01-22', 280, NULL),
('Cute Mountains Inn', 130, '2020-01-23', 338, NULL),
('Cute Mountains Inn', 130, '2020-01-24', 330, NULL),
('Cute Mountains Inn', 130, '2020-01-25', 255, NULL),
('Cute Mountains Inn', 130, '2020-01-26', 301, NULL),
('Cute Mountains Inn', 130, '2020-01-27', 227, NULL),
('Cute Mountains Inn', 130, '2020-01-28', 171, NULL),
('Cute Mountains Inn', 130, '2020-01-29', 318, NULL),
('Cute Mountains Inn', 130, '2020-01-30', 182, NULL),
('Cute Mountains Inn', 130, '2020-01-31', 201, NULL),
('Cute Mountains Inn', 130, '2020-02-01', 134, NULL),
('Cute Mountains Inn', 130, '2020-02-02', 127, NULL),
('Cute Mountains Inn', 130, '2020-02-03', 278, NULL),
('Cute Mountains Inn', 130, '2020-02-04', 111, NULL),
('Cute Mountains Inn', 136, '2019-01-01', 311, NULL),
('Cute Mountains Inn', 136, '2019-01-02', 308, NULL),
('Cute Mountains Inn', 136, '2019-01-03', 302, NULL),
('Cute Mountains Inn', 136, '2019-01-04', 374, NULL),
('Cute Mountains Inn', 136, '2019-01-05', 331, NULL),
('Cute Mountains Inn', 136, '2019-01-06', 317, NULL),
('Cute Mountains Inn', 136, '2019-01-07', 202, NULL),
('Cute Mountains Inn', 136, '2019-01-08', 207, NULL),
('Cute Mountains Inn', 136, '2019-01-09', 235, NULL),
('Cute Mountains Inn', 136, '2019-01-10', 307, NULL),
('Cute Mountains Inn', 136, '2019-01-11', 394, NULL),
('Cute Mountains Inn', 136, '2019-01-12', 251, NULL),
('Cute Mountains Inn', 136, '2019-01-13', 382, NULL),
('Cute Mountains Inn', 136, '2019-01-14', 259, NULL),
('Cute Mountains Inn', 136, '2019-01-15', 323, NULL),
('Cute Mountains Inn', 136, '2019-01-16', 158, NULL),
('Cute Mountains Inn', 136, '2019-01-17', 291, NULL),
('Cute Mountains Inn', 136, '2019-01-18', 354, NULL),
('Cute Mountains Inn', 136, '2019-01-19', 203, NULL),
('Cute Mountains Inn', 136, '2019-01-20', 385, NULL),
('Cute Mountains Inn', 136, '2019-01-21', 350, NULL),
('Cute Mountains Inn', 136, '2019-01-22', 135, NULL),
('Cute Mountains Inn', 136, '2019-01-23', 260, NULL),
('Cute Mountains Inn', 136, '2019-01-24', 297, NULL),
('Cute Mountains Inn', 136, '2019-01-25', 105, NULL),
('Cute Mountains Inn', 136, '2019-01-26', 222, NULL),
('Cute Mountains Inn', 136, '2019-01-27', 160, NULL),
('Cute Mountains Inn', 136, '2019-01-28', 239, NULL),
('Cute Mountains Inn', 136, '2019-01-29', 305, NULL),
('Cute Mountains Inn', 136, '2019-01-30', 138, NULL),
('Cute Mountains Inn', 136, '2019-01-31', 327, NULL),
('Cute Mountains Inn', 136, '2019-02-01', 262, NULL),
('Cute Mountains Inn', 136, '2019-02-02', 207, NULL),
('Cute Mountains Inn', 136, '2019-02-03', 187, NULL),
('Cute Mountains Inn', 136, '2019-02-04', 375, NULL),
('Cute Mountains Inn', 136, '2019-02-05', 324, NULL),
('Cute Mountains Inn', 136, '2019-02-06', 334, NULL),
('Cute Mountains Inn', 136, '2019-02-07', 243, NULL),
('Cute Mountains Inn', 136, '2019-02-08', 118, NULL),
('Cute Mountains Inn', 136, '2019-02-09', 330, NULL),
('Cute Mountains Inn', 136, '2019-02-10', 377, NULL),
('Cute Mountains Inn', 136, '2019-02-11', 271, NULL),
('Cute Mountains Inn', 136, '2019-02-12', 110, NULL),
('Cute Mountains Inn', 136, '2019-02-13', 102, NULL),
('Cute Mountains Inn', 136, '2019-02-14', 248, NULL),
('Cute Mountains Inn', 136, '2019-02-15', 154, NULL),
('Cute Mountains Inn', 136, '2019-02-16', 377, NULL),
('Cute Mountains Inn', 136, '2019-02-17', 210, NULL),
('Cute Mountains Inn', 136, '2019-02-18', 342, NULL),
('Cute Mountains Inn', 136, '2019-02-19', 348, NULL),
('Cute Mountains Inn', 136, '2019-02-20', 302, NULL),
('Cute Mountains Inn', 136, '2019-02-21', 185, NULL),
('Cute Mountains Inn', 136, '2019-02-22', 301, NULL),
('Cute Mountains Inn', 136, '2019-02-23', 281, NULL),
('Cute Mountains Inn', 136, '2019-02-24', 147, NULL),
('Cute Mountains Inn', 136, '2019-02-25', 158, NULL),
('Cute Mountains Inn', 136, '2019-02-26', 255, NULL),
('Cute Mountains Inn', 136, '2019-02-27', 171, NULL),
('Cute Mountains Inn', 136, '2019-02-28', 308, NULL),
('Cute Mountains Inn', 136, '2019-03-01', 237, NULL),
('Cute Mountains Inn', 136, '2019-03-02', 201, NULL),
('Cute Mountains Inn', 136, '2019-03-03', 217, NULL),
('Cute Mountains Inn', 136, '2019-03-04', 155, NULL),
('Cute Mountains Inn', 136, '2019-03-05', 364, NULL),
('Cute Mountains Inn', 136, '2019-03-06', 186, NULL),
('Cute Mountains Inn', 136, '2019-03-07', 392, NULL),
('Cute Mountains Inn', 136, '2019-03-08', 190, NULL),
('Cute Mountains Inn', 136, '2019-03-09', 274, NULL),
('Cute Mountains Inn', 136, '2019-03-10', 236, NULL),
('Cute Mountains Inn', 136, '2019-03-11', 296, NULL),
('Cute Mountains Inn', 136, '2019-03-12', 376, NULL),
('Cute Mountains Inn', 136, '2019-03-13', 114, NULL),
('Cute Mountains Inn', 136, '2019-03-14', 290, NULL),
('Cute Mountains Inn', 136, '2019-03-15', 314, NULL),
('Cute Mountains Inn', 136, '2019-03-16', 294, NULL),
('Cute Mountains Inn', 136, '2019-03-17', 130, NULL),
('Cute Mountains Inn', 136, '2019-03-18', 160, NULL),
('Cute Mountains Inn', 136, '2019-03-19', 252, NULL),
('Cute Mountains Inn', 136, '2019-03-20', 180, NULL),
('Cute Mountains Inn', 136, '2019-03-21', 146, NULL),
('Cute Mountains Inn', 136, '2019-03-22', 242, NULL),
('Cute Mountains Inn', 136, '2019-03-23', 338, NULL),
('Cute Mountains Inn', 136, '2019-03-24', 328, NULL),
('Cute Mountains Inn', 136, '2019-03-25', 320, NULL),
('Cute Mountains Inn', 136, '2019-03-26', 146, NULL),
('Cute Mountains Inn', 136, '2019-03-27', 348, NULL),
('Cute Mountains Inn', 136, '2019-03-28', 226, NULL),
('Cute Mountains Inn', 136, '2019-03-29', 249, NULL),
('Cute Mountains Inn', 136, '2019-03-30', 394, NULL),
('Cute Mountains Inn', 136, '2019-03-31', 290, NULL),
('Cute Mountains Inn', 136, '2019-04-01', 286, NULL),
('Cute Mountains Inn', 136, '2019-04-02', 163, NULL),
('Cute Mountains Inn', 136, '2019-04-03', 331, NULL),
('Cute Mountains Inn', 136, '2019-04-04', 347, NULL),
('Cute Mountains Inn', 136, '2019-04-05', 250, NULL),
('Cute Mountains Inn', 136, '2019-04-06', 356, NULL),
('Cute Mountains Inn', 136, '2019-04-07', 373, NULL),
('Cute Mountains Inn', 136, '2019-04-08', 337, NULL),
('Cute Mountains Inn', 136, '2019-04-09', 369, NULL),
('Cute Mountains Inn', 136, '2019-04-10', 217, NULL),
('Cute Mountains Inn', 136, '2019-04-11', 151, NULL),
('Cute Mountains Inn', 136, '2019-04-12', 361, NULL),
('Cute Mountains Inn', 136, '2019-04-13', 212, NULL),
('Cute Mountains Inn', 136, '2019-04-14', 227, NULL),
('Cute Mountains Inn', 136, '2019-04-15', 107, NULL),
('Cute Mountains Inn', 136, '2019-04-16', 364, NULL),
('Cute Mountains Inn', 136, '2019-04-17', 333, NULL),
('Cute Mountains Inn', 136, '2019-04-18', 379, NULL),
('Cute Mountains Inn', 136, '2019-04-19', 205, NULL),
('Cute Mountains Inn', 136, '2019-04-20', 309, NULL),
('Cute Mountains Inn', 136, '2019-04-21', 376, NULL),
('Cute Mountains Inn', 136, '2019-04-22', 283, NULL),
('Cute Mountains Inn', 136, '2019-04-23', 237, NULL),
('Cute Mountains Inn', 136, '2019-04-24', 369, NULL),
('Cute Mountains Inn', 136, '2019-04-25', 158, NULL),
('Cute Mountains Inn', 136, '2019-04-26', 391, NULL),
('Cute Mountains Inn', 136, '2019-04-27', 300, NULL),
('Cute Mountains Inn', 136, '2019-04-28', 312, NULL),
('Cute Mountains Inn', 136, '2019-04-29', 390, NULL),
('Cute Mountains Inn', 136, '2019-04-30', 108, NULL),
('Cute Mountains Inn', 136, '2019-05-01', 264, NULL),
('Cute Mountains Inn', 136, '2019-05-02', 179, NULL),
('Cute Mountains Inn', 136, '2019-05-03', 176, NULL),
('Cute Mountains Inn', 136, '2019-05-04', 208, NULL),
('Cute Mountains Inn', 136, '2019-05-05', 200, NULL),
('Cute Mountains Inn', 136, '2019-05-06', 241, NULL),
('Cute Mountains Inn', 136, '2019-05-07', 386, NULL),
('Cute Mountains Inn', 136, '2019-05-08', 137, NULL),
('Cute Mountains Inn', 136, '2019-05-09', 389, NULL),
('Cute Mountains Inn', 136, '2019-05-10', 362, NULL),
('Cute Mountains Inn', 136, '2019-05-11', 388, NULL),
('Cute Mountains Inn', 136, '2019-05-12', 389, NULL),
('Cute Mountains Inn', 136, '2019-05-13', 392, NULL),
('Cute Mountains Inn', 136, '2019-05-14', 308, NULL),
('Cute Mountains Inn', 136, '2019-05-15', 185, NULL),
('Cute Mountains Inn', 136, '2019-05-16', 245, NULL),
('Cute Mountains Inn', 136, '2019-05-17', 120, NULL),
('Cute Mountains Inn', 136, '2019-05-18', 211, NULL),
('Cute Mountains Inn', 136, '2019-05-19', 193, NULL),
('Cute Mountains Inn', 136, '2019-05-20', 126, NULL),
('Cute Mountains Inn', 136, '2019-05-21', 120, NULL),
('Cute Mountains Inn', 136, '2019-05-22', 300, NULL),
('Cute Mountains Inn', 136, '2019-05-23', 260, NULL),
('Cute Mountains Inn', 136, '2019-05-24', 225, NULL),
('Cute Mountains Inn', 136, '2019-05-25', 108, NULL),
('Cute Mountains Inn', 136, '2019-05-26', 137, NULL),
('Cute Mountains Inn', 136, '2019-05-27', 150, NULL),
('Cute Mountains Inn', 136, '2019-05-28', 100, NULL),
('Cute Mountains Inn', 136, '2019-05-29', 318, NULL),
('Cute Mountains Inn', 136, '2019-05-30', 298, NULL),
('Cute Mountains Inn', 136, '2019-05-31', 335, NULL),
('Cute Mountains Inn', 136, '2019-06-01', 208, NULL),
('Cute Mountains Inn', 136, '2019-06-02', 245, NULL),
('Cute Mountains Inn', 136, '2019-06-03', 107, NULL),
('Cute Mountains Inn', 136, '2019-06-04', 304, NULL),
('Cute Mountains Inn', 136, '2019-06-05', 117, NULL),
('Cute Mountains Inn', 136, '2019-06-06', 139, NULL),
('Cute Mountains Inn', 136, '2019-06-07', 232, NULL),
('Cute Mountains Inn', 136, '2019-06-08', 269, NULL),
('Cute Mountains Inn', 136, '2019-06-09', 159, NULL),
('Cute Mountains Inn', 136, '2019-06-10', 335, NULL),
('Cute Mountains Inn', 136, '2019-06-11', 142, NULL),
('Cute Mountains Inn', 136, '2019-06-12', 164, NULL),
('Cute Mountains Inn', 136, '2019-06-13', 132, NULL),
('Cute Mountains Inn', 136, '2019-06-14', 360, NULL),
('Cute Mountains Inn', 136, '2019-06-15', 175, NULL),
('Cute Mountains Inn', 136, '2019-06-16', 355, NULL),
('Cute Mountains Inn', 136, '2019-06-17', 165, NULL),
('Cute Mountains Inn', 136, '2019-06-18', 315, NULL),
('Cute Mountains Inn', 136, '2019-06-19', 348, NULL),
('Cute Mountains Inn', 136, '2019-06-20', 248, NULL),
('Cute Mountains Inn', 136, '2019-06-21', 240, NULL),
('Cute Mountains Inn', 136, '2019-06-22', 116, NULL),
('Cute Mountains Inn', 136, '2019-06-23', 179, NULL),
('Cute Mountains Inn', 136, '2019-06-24', 281, NULL),
('Cute Mountains Inn', 136, '2019-06-25', 237, NULL),
('Cute Mountains Inn', 136, '2019-06-26', 385, NULL),
('Cute Mountains Inn', 136, '2019-06-27', 280, NULL),
('Cute Mountains Inn', 136, '2019-06-28', 162, NULL),
('Cute Mountains Inn', 136, '2019-06-29', 261, NULL),
('Cute Mountains Inn', 136, '2019-06-30', 160, NULL),
('Cute Mountains Inn', 136, '2019-07-01', 256, NULL),
('Cute Mountains Inn', 136, '2019-07-02', 288, NULL),
('Cute Mountains Inn', 136, '2019-07-03', 287, NULL),
('Cute Mountains Inn', 136, '2019-07-04', 146, NULL),
('Cute Mountains Inn', 136, '2019-07-05', 280, NULL),
('Cute Mountains Inn', 136, '2019-07-06', 212, NULL),
('Cute Mountains Inn', 136, '2019-07-07', 361, NULL),
('Cute Mountains Inn', 136, '2019-07-08', 260, NULL),
('Cute Mountains Inn', 136, '2019-07-09', 358, NULL),
('Cute Mountains Inn', 136, '2019-07-10', 220, NULL),
('Cute Mountains Inn', 136, '2019-07-11', 263, NULL),
('Cute Mountains Inn', 136, '2019-07-12', 243, NULL),
('Cute Mountains Inn', 136, '2019-07-13', 284, NULL),
('Cute Mountains Inn', 136, '2019-07-14', 311, NULL),
('Cute Mountains Inn', 136, '2019-07-15', 295, NULL),
('Cute Mountains Inn', 136, '2019-07-16', 318, NULL),
('Cute Mountains Inn', 136, '2019-07-17', 369, NULL),
('Cute Mountains Inn', 136, '2019-07-18', 235, NULL),
('Cute Mountains Inn', 136, '2019-07-19', 238, NULL),
('Cute Mountains Inn', 136, '2019-07-20', 184, NULL),
('Cute Mountains Inn', 136, '2019-07-21', 110, NULL),
('Cute Mountains Inn', 136, '2019-07-22', 380, NULL),
('Cute Mountains Inn', 136, '2019-07-23', 286, NULL),
('Cute Mountains Inn', 136, '2019-07-24', 302, NULL),
('Cute Mountains Inn', 136, '2019-07-25', 111, NULL),
('Cute Mountains Inn', 136, '2019-07-26', 236, NULL),
('Cute Mountains Inn', 136, '2019-07-27', 390, NULL),
('Cute Mountains Inn', 136, '2019-07-28', 204, NULL),
('Cute Mountains Inn', 136, '2019-07-29', 244, NULL),
('Cute Mountains Inn', 136, '2019-07-30', 343, NULL),
('Cute Mountains Inn', 136, '2019-07-31', 183, NULL),
('Cute Mountains Inn', 136, '2019-08-01', 161, NULL),
('Cute Mountains Inn', 136, '2019-08-02', 279, NULL),
('Cute Mountains Inn', 136, '2019-08-03', 176, NULL),
('Cute Mountains Inn', 136, '2019-08-04', 161, NULL),
('Cute Mountains Inn', 136, '2019-08-05', 194, NULL),
('Cute Mountains Inn', 136, '2019-08-06', 315, NULL),
('Cute Mountains Inn', 136, '2019-08-07', 353, NULL),
('Cute Mountains Inn', 136, '2019-08-08', 284, NULL),
('Cute Mountains Inn', 136, '2019-08-09', 201, NULL),
('Cute Mountains Inn', 136, '2019-08-10', 112, NULL),
('Cute Mountains Inn', 136, '2019-08-11', 336, NULL),
('Cute Mountains Inn', 136, '2019-08-12', 233, NULL),
('Cute Mountains Inn', 136, '2019-08-13', 257, NULL),
('Cute Mountains Inn', 136, '2019-08-14', 341, NULL),
('Cute Mountains Inn', 136, '2019-08-15', 193, NULL),
('Cute Mountains Inn', 136, '2019-08-16', 275, NULL),
('Cute Mountains Inn', 136, '2019-08-17', 359, NULL),
('Cute Mountains Inn', 136, '2019-08-18', 215, NULL),
('Cute Mountains Inn', 136, '2019-08-19', 230, NULL),
('Cute Mountains Inn', 136, '2019-08-20', 167, NULL),
('Cute Mountains Inn', 136, '2019-08-21', 148, NULL),
('Cute Mountains Inn', 136, '2019-08-22', 107, NULL),
('Cute Mountains Inn', 136, '2019-08-23', 364, NULL),
('Cute Mountains Inn', 136, '2019-08-24', 243, NULL),
('Cute Mountains Inn', 136, '2019-08-25', 257, NULL),
('Cute Mountains Inn', 136, '2019-08-26', 112, NULL),
('Cute Mountains Inn', 136, '2019-08-27', 157, NULL),
('Cute Mountains Inn', 136, '2019-08-28', 249, NULL),
('Cute Mountains Inn', 136, '2019-08-29', 105, NULL),
('Cute Mountains Inn', 136, '2019-08-30', 141, NULL),
('Cute Mountains Inn', 136, '2019-08-31', 197, NULL),
('Cute Mountains Inn', 136, '2019-09-01', 158, NULL),
('Cute Mountains Inn', 136, '2019-09-02', 317, NULL),
('Cute Mountains Inn', 136, '2019-09-03', 317, NULL),
('Cute Mountains Inn', 136, '2019-09-04', 185, NULL),
('Cute Mountains Inn', 136, '2019-09-05', 284, NULL),
('Cute Mountains Inn', 136, '2019-09-06', 236, NULL),
('Cute Mountains Inn', 136, '2019-09-07', 376, NULL),
('Cute Mountains Inn', 136, '2019-09-08', 243, NULL),
('Cute Mountains Inn', 136, '2019-09-09', 333, NULL),
('Cute Mountains Inn', 136, '2019-09-10', 242, NULL),
('Cute Mountains Inn', 136, '2019-09-11', 274, NULL),
('Cute Mountains Inn', 136, '2019-09-12', 294, NULL),
('Cute Mountains Inn', 136, '2019-09-13', 379, NULL),
('Cute Mountains Inn', 136, '2019-09-14', 128, NULL),
('Cute Mountains Inn', 136, '2019-09-15', 269, NULL),
('Cute Mountains Inn', 136, '2019-09-16', 216, NULL),
('Cute Mountains Inn', 136, '2019-09-17', 227, NULL),
('Cute Mountains Inn', 136, '2019-09-18', 191, NULL),
('Cute Mountains Inn', 136, '2019-09-19', 276, NULL),
('Cute Mountains Inn', 136, '2019-09-20', 116, NULL),
('Cute Mountains Inn', 136, '2019-09-21', 333, NULL),
('Cute Mountains Inn', 136, '2019-09-22', 144, NULL),
('Cute Mountains Inn', 136, '2019-09-23', 305, NULL),
('Cute Mountains Inn', 136, '2019-09-24', 191, NULL),
('Cute Mountains Inn', 136, '2019-09-25', 278, NULL),
('Cute Mountains Inn', 136, '2019-09-26', 280, NULL),
('Cute Mountains Inn', 136, '2019-09-27', 283, NULL),
('Cute Mountains Inn', 136, '2019-09-28', 258, NULL),
('Cute Mountains Inn', 136, '2019-09-29', 389, NULL),
('Cute Mountains Inn', 136, '2019-09-30', 153, NULL),
('Cute Mountains Inn', 136, '2019-10-01', 347, NULL),
('Cute Mountains Inn', 136, '2019-10-02', 295, NULL),
('Cute Mountains Inn', 136, '2019-10-03', 107, NULL),
('Cute Mountains Inn', 136, '2019-10-04', 173, NULL),
('Cute Mountains Inn', 136, '2019-10-05', 386, NULL),
('Cute Mountains Inn', 136, '2019-10-06', 349, NULL),
('Cute Mountains Inn', 136, '2019-10-07', 191, NULL),
('Cute Mountains Inn', 136, '2019-10-08', 386, NULL),
('Cute Mountains Inn', 136, '2019-10-09', 145, NULL),
('Cute Mountains Inn', 136, '2019-10-10', 220, NULL),
('Cute Mountains Inn', 136, '2019-10-11', 186, NULL),
('Cute Mountains Inn', 136, '2019-10-12', 253, NULL),
('Cute Mountains Inn', 136, '2019-10-13', 206, NULL),
('Cute Mountains Inn', 136, '2019-10-14', 391, NULL),
('Cute Mountains Inn', 136, '2019-10-15', 360, NULL),
('Cute Mountains Inn', 136, '2019-10-16', 137, NULL),
('Cute Mountains Inn', 136, '2019-10-17', 186, NULL),
('Cute Mountains Inn', 136, '2019-10-18', 313, NULL),
('Cute Mountains Inn', 136, '2019-10-19', 155, NULL),
('Cute Mountains Inn', 136, '2019-10-20', 166, NULL),
('Cute Mountains Inn', 136, '2019-10-21', 185, NULL),
('Cute Mountains Inn', 136, '2019-10-22', 166, NULL),
('Cute Mountains Inn', 136, '2019-10-23', 295, NULL),
('Cute Mountains Inn', 136, '2019-10-24', 340, NULL),
('Cute Mountains Inn', 136, '2019-10-25', 380, NULL),
('Cute Mountains Inn', 136, '2019-10-26', 284, NULL),
('Cute Mountains Inn', 136, '2019-10-27', 223, NULL),
('Cute Mountains Inn', 136, '2019-10-28', 307, NULL),
('Cute Mountains Inn', 136, '2019-10-29', 192, NULL),
('Cute Mountains Inn', 136, '2019-10-30', 348, NULL),
('Cute Mountains Inn', 136, '2019-10-31', 305, NULL),
('Cute Mountains Inn', 136, '2019-11-01', 368, NULL),
('Cute Mountains Inn', 136, '2019-11-02', 305, NULL),
('Cute Mountains Inn', 136, '2019-11-03', 107, NULL),
('Cute Mountains Inn', 136, '2019-11-04', 372, NULL),
('Cute Mountains Inn', 136, '2019-11-05', 372, NULL),
('Cute Mountains Inn', 136, '2019-11-06', 278, NULL),
('Cute Mountains Inn', 136, '2019-11-07', 187, NULL),
('Cute Mountains Inn', 136, '2019-11-08', 222, NULL),
('Cute Mountains Inn', 136, '2019-11-09', 378, NULL),
('Cute Mountains Inn', 136, '2019-11-10', 105, NULL),
('Cute Mountains Inn', 136, '2019-11-11', 165, NULL),
('Cute Mountains Inn', 136, '2019-11-12', 267, NULL),
('Cute Mountains Inn', 136, '2019-11-13', 285, NULL),
('Cute Mountains Inn', 136, '2019-11-14', 391, NULL),
('Cute Mountains Inn', 136, '2019-11-15', 207, NULL),
('Cute Mountains Inn', 136, '2019-11-16', 264, NULL),
('Cute Mountains Inn', 136, '2019-11-17', 361, NULL),
('Cute Mountains Inn', 136, '2019-11-18', 293, NULL),
('Cute Mountains Inn', 136, '2019-11-19', 137, NULL),
('Cute Mountains Inn', 136, '2019-11-20', 141, NULL),
('Cute Mountains Inn', 136, '2019-11-21', 394, NULL),
('Cute Mountains Inn', 136, '2019-11-22', 253, NULL),
('Cute Mountains Inn', 136, '2019-11-23', 166, NULL),
('Cute Mountains Inn', 136, '2019-11-24', 228, NULL),
('Cute Mountains Inn', 136, '2019-11-25', 191, NULL),
('Cute Mountains Inn', 136, '2019-11-26', 295, NULL),
('Cute Mountains Inn', 136, '2019-11-27', 171, NULL),
('Cute Mountains Inn', 136, '2019-11-28', 315, NULL),
('Cute Mountains Inn', 136, '2019-11-29', 265, NULL),
('Cute Mountains Inn', 136, '2019-11-30', 178, NULL),
('Cute Mountains Inn', 136, '2019-12-01', 253, NULL),
('Cute Mountains Inn', 136, '2019-12-02', 362, NULL),
('Cute Mountains Inn', 136, '2019-12-03', 359, NULL),
('Cute Mountains Inn', 136, '2019-12-04', 191, NULL),
('Cute Mountains Inn', 136, '2019-12-05', 234, NULL),
('Cute Mountains Inn', 136, '2019-12-06', 191, NULL),
('Cute Mountains Inn', 136, '2019-12-07', 181, NULL),
('Cute Mountains Inn', 136, '2019-12-08', 112, NULL),
('Cute Mountains Inn', 136, '2019-12-09', 170, NULL),
('Cute Mountains Inn', 136, '2019-12-10', 187, NULL),
('Cute Mountains Inn', 136, '2019-12-11', 251, NULL),
('Cute Mountains Inn', 136, '2019-12-12', 386, NULL),
('Cute Mountains Inn', 136, '2019-12-13', 333, NULL),
('Cute Mountains Inn', 136, '2019-12-14', 130, NULL),
('Cute Mountains Inn', 136, '2019-12-15', 134, NULL),
('Cute Mountains Inn', 136, '2019-12-16', 253, NULL),
('Cute Mountains Inn', 136, '2019-12-17', 302, NULL),
('Cute Mountains Inn', 136, '2019-12-18', 395, NULL),
('Cute Mountains Inn', 136, '2019-12-19', 238, NULL),
('Cute Mountains Inn', 136, '2019-12-20', 250, NULL),
('Cute Mountains Inn', 136, '2019-12-21', 177, NULL),
('Cute Mountains Inn', 136, '2019-12-22', 242, NULL),
('Cute Mountains Inn', 136, '2019-12-23', 206, NULL),
('Cute Mountains Inn', 136, '2019-12-24', 359, NULL),
('Cute Mountains Inn', 136, '2019-12-25', 330, NULL),
('Cute Mountains Inn', 136, '2019-12-26', 121, NULL),
('Cute Mountains Inn', 136, '2019-12-27', 265, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 136, '2019-12-28', 280, NULL),
('Cute Mountains Inn', 136, '2019-12-29', 330, NULL),
('Cute Mountains Inn', 136, '2019-12-30', 211, NULL),
('Cute Mountains Inn', 136, '2019-12-31', 279, NULL),
('Cute Mountains Inn', 136, '2020-01-01', 352, NULL),
('Cute Mountains Inn', 136, '2020-01-02', 350, NULL),
('Cute Mountains Inn', 136, '2020-01-03', 171, NULL),
('Cute Mountains Inn', 136, '2020-01-04', 281, NULL),
('Cute Mountains Inn', 136, '2020-01-05', 337, NULL),
('Cute Mountains Inn', 136, '2020-01-06', 191, NULL),
('Cute Mountains Inn', 136, '2020-01-07', 150, NULL),
('Cute Mountains Inn', 136, '2020-01-08', 357, NULL),
('Cute Mountains Inn', 136, '2020-01-09', 360, NULL),
('Cute Mountains Inn', 136, '2020-01-10', 140, NULL),
('Cute Mountains Inn', 136, '2020-01-11', 231, NULL),
('Cute Mountains Inn', 136, '2020-01-12', 300, NULL),
('Cute Mountains Inn', 136, '2020-01-13', 101, NULL),
('Cute Mountains Inn', 136, '2020-01-14', 240, NULL),
('Cute Mountains Inn', 136, '2020-01-15', 333, NULL),
('Cute Mountains Inn', 136, '2020-01-16', 306, NULL),
('Cute Mountains Inn', 136, '2020-01-17', 387, NULL),
('Cute Mountains Inn', 136, '2020-01-18', 259, NULL),
('Cute Mountains Inn', 136, '2020-01-19', 254, NULL),
('Cute Mountains Inn', 136, '2020-01-20', 270, NULL),
('Cute Mountains Inn', 136, '2020-01-21', 316, NULL),
('Cute Mountains Inn', 136, '2020-01-22', 277, NULL),
('Cute Mountains Inn', 136, '2020-01-23', 362, NULL),
('Cute Mountains Inn', 136, '2020-01-24', 347, NULL),
('Cute Mountains Inn', 136, '2020-01-25', 368, NULL),
('Cute Mountains Inn', 136, '2020-01-26', 360, NULL),
('Cute Mountains Inn', 136, '2020-01-27', 164, NULL),
('Cute Mountains Inn', 136, '2020-01-28', 278, NULL),
('Cute Mountains Inn', 136, '2020-01-29', 230, NULL),
('Cute Mountains Inn', 136, '2020-01-30', 113, NULL),
('Cute Mountains Inn', 136, '2020-01-31', 133, NULL),
('Cute Mountains Inn', 136, '2020-02-01', 221, NULL),
('Cute Mountains Inn', 136, '2020-02-02', 148, NULL),
('Cute Mountains Inn', 136, '2020-02-03', 243, NULL),
('Cute Mountains Inn', 136, '2020-02-04', 399, NULL),
('Cute Mountains Inn', 146, '2019-01-01', 351, NULL),
('Cute Mountains Inn', 146, '2019-01-02', 160, NULL),
('Cute Mountains Inn', 146, '2019-01-03', 241, NULL),
('Cute Mountains Inn', 146, '2019-01-04', 265, NULL),
('Cute Mountains Inn', 146, '2019-01-05', 361, NULL),
('Cute Mountains Inn', 146, '2019-01-06', 301, NULL),
('Cute Mountains Inn', 146, '2019-01-07', 395, NULL),
('Cute Mountains Inn', 146, '2019-01-08', 184, NULL),
('Cute Mountains Inn', 146, '2019-01-09', 327, NULL),
('Cute Mountains Inn', 146, '2019-01-10', 382, NULL),
('Cute Mountains Inn', 146, '2019-01-11', 130, NULL),
('Cute Mountains Inn', 146, '2019-01-12', 281, NULL),
('Cute Mountains Inn', 146, '2019-01-13', 111, NULL),
('Cute Mountains Inn', 146, '2019-01-14', 274, NULL),
('Cute Mountains Inn', 146, '2019-01-15', 221, NULL),
('Cute Mountains Inn', 146, '2019-01-16', 104, NULL),
('Cute Mountains Inn', 146, '2019-01-17', 311, NULL),
('Cute Mountains Inn', 146, '2019-01-18', 247, NULL),
('Cute Mountains Inn', 146, '2019-01-19', 323, NULL),
('Cute Mountains Inn', 146, '2019-01-20', 243, NULL),
('Cute Mountains Inn', 146, '2019-01-21', 351, NULL),
('Cute Mountains Inn', 146, '2019-01-22', 398, NULL),
('Cute Mountains Inn', 146, '2019-01-23', 354, NULL),
('Cute Mountains Inn', 146, '2019-01-24', 172, NULL),
('Cute Mountains Inn', 146, '2019-01-25', 397, NULL),
('Cute Mountains Inn', 146, '2019-01-26', 349, NULL),
('Cute Mountains Inn', 146, '2019-01-27', 263, NULL),
('Cute Mountains Inn', 146, '2019-01-28', 374, NULL),
('Cute Mountains Inn', 146, '2019-01-29', 289, NULL),
('Cute Mountains Inn', 146, '2019-01-30', 104, NULL),
('Cute Mountains Inn', 146, '2019-01-31', 203, NULL),
('Cute Mountains Inn', 146, '2019-02-01', 323, NULL),
('Cute Mountains Inn', 146, '2019-02-02', 220, NULL),
('Cute Mountains Inn', 146, '2019-02-03', 311, NULL),
('Cute Mountains Inn', 146, '2019-02-04', 240, NULL),
('Cute Mountains Inn', 146, '2019-02-05', 352, NULL),
('Cute Mountains Inn', 146, '2019-02-06', 324, NULL),
('Cute Mountains Inn', 146, '2019-02-07', 349, NULL),
('Cute Mountains Inn', 146, '2019-02-08', 287, NULL),
('Cute Mountains Inn', 146, '2019-02-09', 343, NULL),
('Cute Mountains Inn', 146, '2019-02-10', 371, NULL),
('Cute Mountains Inn', 146, '2019-02-11', 270, NULL),
('Cute Mountains Inn', 146, '2019-02-12', 272, NULL),
('Cute Mountains Inn', 146, '2019-02-13', 222, NULL),
('Cute Mountains Inn', 146, '2019-02-14', 310, NULL),
('Cute Mountains Inn', 146, '2019-02-15', 232, NULL),
('Cute Mountains Inn', 146, '2019-02-16', 316, NULL),
('Cute Mountains Inn', 146, '2019-02-17', 321, NULL),
('Cute Mountains Inn', 146, '2019-02-18', 286, NULL),
('Cute Mountains Inn', 146, '2019-02-19', 177, NULL),
('Cute Mountains Inn', 146, '2019-02-20', 159, NULL),
('Cute Mountains Inn', 146, '2019-02-21', 237, NULL),
('Cute Mountains Inn', 146, '2019-02-22', 194, NULL),
('Cute Mountains Inn', 146, '2019-02-23', 257, NULL),
('Cute Mountains Inn', 146, '2019-02-24', 223, NULL),
('Cute Mountains Inn', 146, '2019-02-25', 350, NULL),
('Cute Mountains Inn', 146, '2019-02-26', 308, NULL),
('Cute Mountains Inn', 146, '2019-02-27', 262, NULL),
('Cute Mountains Inn', 146, '2019-02-28', 308, NULL),
('Cute Mountains Inn', 146, '2019-03-01', 336, NULL),
('Cute Mountains Inn', 146, '2019-03-02', 372, NULL),
('Cute Mountains Inn', 146, '2019-03-03', 368, NULL),
('Cute Mountains Inn', 146, '2019-03-04', 351, NULL),
('Cute Mountains Inn', 146, '2019-03-05', 373, NULL),
('Cute Mountains Inn', 146, '2019-03-06', 236, NULL),
('Cute Mountains Inn', 146, '2019-03-07', 303, NULL),
('Cute Mountains Inn', 146, '2019-03-08', 266, NULL),
('Cute Mountains Inn', 146, '2019-03-09', 144, NULL),
('Cute Mountains Inn', 146, '2019-03-10', 183, NULL),
('Cute Mountains Inn', 146, '2019-03-11', 206, NULL),
('Cute Mountains Inn', 146, '2019-03-12', 143, NULL),
('Cute Mountains Inn', 146, '2019-03-13', 254, NULL),
('Cute Mountains Inn', 146, '2019-03-14', 296, NULL),
('Cute Mountains Inn', 146, '2019-03-15', 190, NULL),
('Cute Mountains Inn', 146, '2019-03-16', 365, NULL),
('Cute Mountains Inn', 146, '2019-03-17', 129, NULL),
('Cute Mountains Inn', 146, '2019-03-18', 336, NULL),
('Cute Mountains Inn', 146, '2019-03-19', 337, NULL),
('Cute Mountains Inn', 146, '2019-03-20', 269, NULL),
('Cute Mountains Inn', 146, '2019-03-21', 147, NULL),
('Cute Mountains Inn', 146, '2019-03-22', 310, NULL),
('Cute Mountains Inn', 146, '2019-03-23', 342, NULL),
('Cute Mountains Inn', 146, '2019-03-24', 399, NULL),
('Cute Mountains Inn', 146, '2019-03-25', 114, NULL),
('Cute Mountains Inn', 146, '2019-03-26', 378, NULL),
('Cute Mountains Inn', 146, '2019-03-27', 118, NULL),
('Cute Mountains Inn', 146, '2019-03-28', 289, NULL),
('Cute Mountains Inn', 146, '2019-03-29', 111, NULL),
('Cute Mountains Inn', 146, '2019-03-30', 166, NULL),
('Cute Mountains Inn', 146, '2019-03-31', 221, NULL),
('Cute Mountains Inn', 146, '2019-04-01', 334, NULL),
('Cute Mountains Inn', 146, '2019-04-02', 359, NULL),
('Cute Mountains Inn', 146, '2019-04-03', 133, NULL),
('Cute Mountains Inn', 146, '2019-04-04', 104, NULL),
('Cute Mountains Inn', 146, '2019-04-05', 198, NULL),
('Cute Mountains Inn', 146, '2019-04-06', 100, NULL),
('Cute Mountains Inn', 146, '2019-04-07', 154, NULL),
('Cute Mountains Inn', 146, '2019-04-08', 386, NULL),
('Cute Mountains Inn', 146, '2019-04-09', 285, NULL),
('Cute Mountains Inn', 146, '2019-04-10', 131, NULL),
('Cute Mountains Inn', 146, '2019-04-11', 349, NULL),
('Cute Mountains Inn', 146, '2019-04-12', 347, NULL),
('Cute Mountains Inn', 146, '2019-04-13', 134, NULL),
('Cute Mountains Inn', 146, '2019-04-14', 120, NULL),
('Cute Mountains Inn', 146, '2019-04-15', 132, NULL),
('Cute Mountains Inn', 146, '2019-04-16', 227, NULL),
('Cute Mountains Inn', 146, '2019-04-17', 268, NULL),
('Cute Mountains Inn', 146, '2019-04-18', 382, NULL),
('Cute Mountains Inn', 146, '2019-04-19', 331, NULL),
('Cute Mountains Inn', 146, '2019-04-20', 297, NULL),
('Cute Mountains Inn', 146, '2019-04-21', 164, NULL),
('Cute Mountains Inn', 146, '2019-04-22', 243, NULL),
('Cute Mountains Inn', 146, '2019-04-23', 303, NULL),
('Cute Mountains Inn', 146, '2019-04-24', 233, NULL),
('Cute Mountains Inn', 146, '2019-04-25', 374, NULL),
('Cute Mountains Inn', 146, '2019-04-26', 217, NULL),
('Cute Mountains Inn', 146, '2019-04-27', 167, NULL),
('Cute Mountains Inn', 146, '2019-04-28', 109, NULL),
('Cute Mountains Inn', 146, '2019-04-29', 349, NULL),
('Cute Mountains Inn', 146, '2019-04-30', 249, NULL),
('Cute Mountains Inn', 146, '2019-05-01', 325, NULL),
('Cute Mountains Inn', 146, '2019-05-02', 212, NULL),
('Cute Mountains Inn', 146, '2019-05-03', 300, NULL),
('Cute Mountains Inn', 146, '2019-05-04', 208, NULL),
('Cute Mountains Inn', 146, '2019-05-05', 229, NULL),
('Cute Mountains Inn', 146, '2019-05-06', 380, NULL),
('Cute Mountains Inn', 146, '2019-05-07', 394, NULL),
('Cute Mountains Inn', 146, '2019-05-08', 314, NULL),
('Cute Mountains Inn', 146, '2019-05-09', 393, NULL),
('Cute Mountains Inn', 146, '2019-05-10', 260, NULL),
('Cute Mountains Inn', 146, '2019-05-11', 367, NULL),
('Cute Mountains Inn', 146, '2019-05-12', 393, NULL),
('Cute Mountains Inn', 146, '2019-05-13', 190, NULL),
('Cute Mountains Inn', 146, '2019-05-14', 354, NULL),
('Cute Mountains Inn', 146, '2019-05-15', 308, NULL),
('Cute Mountains Inn', 146, '2019-05-16', 261, NULL),
('Cute Mountains Inn', 146, '2019-05-17', 323, NULL),
('Cute Mountains Inn', 146, '2019-05-18', 107, NULL),
('Cute Mountains Inn', 146, '2019-05-19', 254, NULL),
('Cute Mountains Inn', 146, '2019-05-20', 304, NULL),
('Cute Mountains Inn', 146, '2019-05-21', 197, NULL),
('Cute Mountains Inn', 146, '2019-05-22', 294, NULL),
('Cute Mountains Inn', 146, '2019-05-23', 333, NULL),
('Cute Mountains Inn', 146, '2019-05-24', 266, NULL),
('Cute Mountains Inn', 146, '2019-05-25', 271, NULL),
('Cute Mountains Inn', 146, '2019-05-26', 257, NULL),
('Cute Mountains Inn', 146, '2019-05-27', 194, NULL),
('Cute Mountains Inn', 146, '2019-05-28', 330, NULL),
('Cute Mountains Inn', 146, '2019-05-29', 327, NULL),
('Cute Mountains Inn', 146, '2019-05-30', 384, NULL),
('Cute Mountains Inn', 146, '2019-05-31', 342, NULL),
('Cute Mountains Inn', 146, '2019-06-01', 394, NULL),
('Cute Mountains Inn', 146, '2019-06-02', 125, NULL),
('Cute Mountains Inn', 146, '2019-06-03', 398, NULL),
('Cute Mountains Inn', 146, '2019-06-04', 383, NULL),
('Cute Mountains Inn', 146, '2019-06-05', 385, NULL),
('Cute Mountains Inn', 146, '2019-06-06', 232, NULL),
('Cute Mountains Inn', 146, '2019-06-07', 351, NULL),
('Cute Mountains Inn', 146, '2019-06-08', 154, NULL),
('Cute Mountains Inn', 146, '2019-06-09', 127, NULL),
('Cute Mountains Inn', 146, '2019-06-10', 110, NULL),
('Cute Mountains Inn', 146, '2019-06-11', 379, NULL),
('Cute Mountains Inn', 146, '2019-06-12', 331, NULL),
('Cute Mountains Inn', 146, '2019-06-13', 376, NULL),
('Cute Mountains Inn', 146, '2019-06-14', 314, NULL),
('Cute Mountains Inn', 146, '2019-06-15', 378, NULL),
('Cute Mountains Inn', 146, '2019-06-16', 208, NULL),
('Cute Mountains Inn', 146, '2019-06-17', 363, NULL),
('Cute Mountains Inn', 146, '2019-06-18', 173, NULL),
('Cute Mountains Inn', 146, '2019-06-19', 360, NULL),
('Cute Mountains Inn', 146, '2019-06-20', 117, NULL),
('Cute Mountains Inn', 146, '2019-06-21', 167, NULL),
('Cute Mountains Inn', 146, '2019-06-22', 210, NULL),
('Cute Mountains Inn', 146, '2019-06-23', 278, NULL),
('Cute Mountains Inn', 146, '2019-06-24', 162, NULL),
('Cute Mountains Inn', 146, '2019-06-25', 150, NULL),
('Cute Mountains Inn', 146, '2019-06-26', 356, NULL),
('Cute Mountains Inn', 146, '2019-06-27', 242, NULL),
('Cute Mountains Inn', 146, '2019-06-28', 322, NULL),
('Cute Mountains Inn', 146, '2019-06-29', 383, NULL),
('Cute Mountains Inn', 146, '2019-06-30', 338, NULL),
('Cute Mountains Inn', 146, '2019-07-01', 349, NULL),
('Cute Mountains Inn', 146, '2019-07-02', 396, NULL),
('Cute Mountains Inn', 146, '2019-07-03', 263, NULL),
('Cute Mountains Inn', 146, '2019-07-04', 254, NULL),
('Cute Mountains Inn', 146, '2019-07-05', 281, NULL),
('Cute Mountains Inn', 146, '2019-07-06', 253, NULL),
('Cute Mountains Inn', 146, '2019-07-07', 104, NULL),
('Cute Mountains Inn', 146, '2019-07-08', 315, NULL),
('Cute Mountains Inn', 146, '2019-07-09', 146, NULL),
('Cute Mountains Inn', 146, '2019-07-10', 105, NULL),
('Cute Mountains Inn', 146, '2019-07-11', 207, NULL),
('Cute Mountains Inn', 146, '2019-07-12', 251, NULL),
('Cute Mountains Inn', 146, '2019-07-13', 282, NULL),
('Cute Mountains Inn', 146, '2019-07-14', 387, NULL),
('Cute Mountains Inn', 146, '2019-07-15', 101, NULL),
('Cute Mountains Inn', 146, '2019-07-16', 143, NULL),
('Cute Mountains Inn', 146, '2019-07-17', 131, NULL),
('Cute Mountains Inn', 146, '2019-07-18', 132, NULL),
('Cute Mountains Inn', 146, '2019-07-19', 159, NULL),
('Cute Mountains Inn', 146, '2019-07-20', 256, NULL),
('Cute Mountains Inn', 146, '2019-07-21', 207, NULL),
('Cute Mountains Inn', 146, '2019-07-22', 391, NULL),
('Cute Mountains Inn', 146, '2019-07-23', 332, NULL),
('Cute Mountains Inn', 146, '2019-07-24', 203, NULL),
('Cute Mountains Inn', 146, '2019-07-25', 142, NULL),
('Cute Mountains Inn', 146, '2019-07-26', 174, NULL),
('Cute Mountains Inn', 146, '2019-07-27', 259, NULL),
('Cute Mountains Inn', 146, '2019-07-28', 377, NULL),
('Cute Mountains Inn', 146, '2019-07-29', 323, NULL),
('Cute Mountains Inn', 146, '2019-07-30', 331, NULL),
('Cute Mountains Inn', 146, '2019-07-31', 248, NULL),
('Cute Mountains Inn', 146, '2019-08-01', 355, NULL),
('Cute Mountains Inn', 146, '2019-08-02', 368, NULL),
('Cute Mountains Inn', 146, '2019-08-03', 144, NULL),
('Cute Mountains Inn', 146, '2019-08-04', 250, NULL),
('Cute Mountains Inn', 146, '2019-08-05', 345, NULL),
('Cute Mountains Inn', 146, '2019-08-06', 354, NULL),
('Cute Mountains Inn', 146, '2019-08-07', 109, NULL),
('Cute Mountains Inn', 146, '2019-08-08', 246, NULL),
('Cute Mountains Inn', 146, '2019-08-09', 154, NULL),
('Cute Mountains Inn', 146, '2019-08-10', 109, NULL),
('Cute Mountains Inn', 146, '2019-08-11', 382, NULL),
('Cute Mountains Inn', 146, '2019-08-12', 354, NULL),
('Cute Mountains Inn', 146, '2019-08-13', 309, NULL),
('Cute Mountains Inn', 146, '2019-08-14', 160, NULL),
('Cute Mountains Inn', 146, '2019-08-15', 378, NULL),
('Cute Mountains Inn', 146, '2019-08-16', 230, NULL),
('Cute Mountains Inn', 146, '2019-08-17', 136, NULL),
('Cute Mountains Inn', 146, '2019-08-18', 300, NULL),
('Cute Mountains Inn', 146, '2019-08-19', 259, NULL),
('Cute Mountains Inn', 146, '2019-08-20', 364, NULL),
('Cute Mountains Inn', 146, '2019-08-21', 369, NULL),
('Cute Mountains Inn', 146, '2019-08-22', 288, NULL),
('Cute Mountains Inn', 146, '2019-08-23', 346, NULL),
('Cute Mountains Inn', 146, '2019-08-24', 346, NULL),
('Cute Mountains Inn', 146, '2019-08-25', 183, NULL),
('Cute Mountains Inn', 146, '2019-08-26', 203, NULL),
('Cute Mountains Inn', 146, '2019-08-27', 350, NULL),
('Cute Mountains Inn', 146, '2019-08-28', 217, NULL),
('Cute Mountains Inn', 146, '2019-08-29', 154, NULL),
('Cute Mountains Inn', 146, '2019-08-30', 126, NULL),
('Cute Mountains Inn', 146, '2019-08-31', 193, NULL),
('Cute Mountains Inn', 146, '2019-09-01', 158, NULL),
('Cute Mountains Inn', 146, '2019-09-02', 290, NULL),
('Cute Mountains Inn', 146, '2019-09-03', 333, NULL),
('Cute Mountains Inn', 146, '2019-09-04', 142, NULL),
('Cute Mountains Inn', 146, '2019-09-05', 194, NULL),
('Cute Mountains Inn', 146, '2019-09-06', 397, NULL),
('Cute Mountains Inn', 146, '2019-09-07', 360, NULL),
('Cute Mountains Inn', 146, '2019-09-08', 103, NULL),
('Cute Mountains Inn', 146, '2019-09-09', 157, NULL),
('Cute Mountains Inn', 146, '2019-09-10', 109, NULL),
('Cute Mountains Inn', 146, '2019-09-11', 154, NULL),
('Cute Mountains Inn', 146, '2019-09-12', 349, NULL),
('Cute Mountains Inn', 146, '2019-09-13', 198, NULL),
('Cute Mountains Inn', 146, '2019-09-14', 197, NULL),
('Cute Mountains Inn', 146, '2019-09-15', 110, NULL),
('Cute Mountains Inn', 146, '2019-09-16', 278, NULL),
('Cute Mountains Inn', 146, '2019-09-17', 369, NULL),
('Cute Mountains Inn', 146, '2019-09-18', 101, NULL),
('Cute Mountains Inn', 146, '2019-09-19', 323, NULL),
('Cute Mountains Inn', 146, '2019-09-20', 113, NULL),
('Cute Mountains Inn', 146, '2019-09-21', 107, NULL),
('Cute Mountains Inn', 146, '2019-09-22', 350, NULL),
('Cute Mountains Inn', 146, '2019-09-23', 350, NULL),
('Cute Mountains Inn', 146, '2019-09-24', 101, NULL),
('Cute Mountains Inn', 146, '2019-09-25', 399, NULL),
('Cute Mountains Inn', 146, '2019-09-26', 325, NULL),
('Cute Mountains Inn', 146, '2019-09-27', 185, NULL),
('Cute Mountains Inn', 146, '2019-09-28', 339, NULL),
('Cute Mountains Inn', 146, '2019-09-29', 202, NULL),
('Cute Mountains Inn', 146, '2019-09-30', 193, NULL),
('Cute Mountains Inn', 146, '2019-10-01', 190, NULL),
('Cute Mountains Inn', 146, '2019-10-02', 293, NULL),
('Cute Mountains Inn', 146, '2019-10-03', 330, NULL),
('Cute Mountains Inn', 146, '2019-10-04', 212, NULL),
('Cute Mountains Inn', 146, '2019-10-05', 148, NULL),
('Cute Mountains Inn', 146, '2019-10-06', 100, NULL),
('Cute Mountains Inn', 146, '2019-10-07', 173, NULL),
('Cute Mountains Inn', 146, '2019-10-08', 261, NULL),
('Cute Mountains Inn', 146, '2019-10-09', 310, NULL),
('Cute Mountains Inn', 146, '2019-10-10', 172, NULL),
('Cute Mountains Inn', 146, '2019-10-11', 238, NULL),
('Cute Mountains Inn', 146, '2019-10-12', 121, NULL),
('Cute Mountains Inn', 146, '2019-10-13', 399, NULL),
('Cute Mountains Inn', 146, '2019-10-14', 380, NULL),
('Cute Mountains Inn', 146, '2019-10-15', 373, NULL),
('Cute Mountains Inn', 146, '2019-10-16', 285, NULL),
('Cute Mountains Inn', 146, '2019-10-17', 194, NULL),
('Cute Mountains Inn', 146, '2019-10-18', 261, NULL),
('Cute Mountains Inn', 146, '2019-10-19', 276, NULL),
('Cute Mountains Inn', 146, '2019-10-20', 159, NULL),
('Cute Mountains Inn', 146, '2019-10-21', 302, NULL),
('Cute Mountains Inn', 146, '2019-10-22', 325, NULL),
('Cute Mountains Inn', 146, '2019-10-23', 158, NULL),
('Cute Mountains Inn', 146, '2019-10-24', 127, NULL),
('Cute Mountains Inn', 146, '2019-10-25', 185, NULL),
('Cute Mountains Inn', 146, '2019-10-26', 115, NULL),
('Cute Mountains Inn', 146, '2019-10-27', 113, NULL),
('Cute Mountains Inn', 146, '2019-10-28', 149, NULL),
('Cute Mountains Inn', 146, '2019-10-29', 102, NULL),
('Cute Mountains Inn', 146, '2019-10-30', 244, NULL),
('Cute Mountains Inn', 146, '2019-10-31', 322, NULL),
('Cute Mountains Inn', 146, '2019-11-01', 246, NULL),
('Cute Mountains Inn', 146, '2019-11-02', 156, NULL),
('Cute Mountains Inn', 146, '2019-11-03', 339, NULL),
('Cute Mountains Inn', 146, '2019-11-04', 315, NULL),
('Cute Mountains Inn', 146, '2019-11-05', 302, NULL),
('Cute Mountains Inn', 146, '2019-11-06', 130, NULL),
('Cute Mountains Inn', 146, '2019-11-07', 296, NULL),
('Cute Mountains Inn', 146, '2019-11-08', 368, NULL),
('Cute Mountains Inn', 146, '2019-11-09', 316, NULL),
('Cute Mountains Inn', 146, '2019-11-10', 152, NULL),
('Cute Mountains Inn', 146, '2019-11-11', 302, NULL),
('Cute Mountains Inn', 146, '2019-11-12', 248, NULL),
('Cute Mountains Inn', 146, '2019-11-13', 116, NULL),
('Cute Mountains Inn', 146, '2019-11-14', 183, NULL),
('Cute Mountains Inn', 146, '2019-11-15', 119, NULL),
('Cute Mountains Inn', 146, '2019-11-16', 265, NULL),
('Cute Mountains Inn', 146, '2019-11-17', 313, NULL),
('Cute Mountains Inn', 146, '2019-11-18', 131, NULL),
('Cute Mountains Inn', 146, '2019-11-19', 270, NULL),
('Cute Mountains Inn', 146, '2019-11-20', 107, NULL),
('Cute Mountains Inn', 146, '2019-11-21', 308, NULL),
('Cute Mountains Inn', 146, '2019-11-22', 125, NULL),
('Cute Mountains Inn', 146, '2019-11-23', 137, NULL),
('Cute Mountains Inn', 146, '2019-11-24', 365, NULL),
('Cute Mountains Inn', 146, '2019-11-25', 111, NULL),
('Cute Mountains Inn', 146, '2019-11-26', 136, NULL),
('Cute Mountains Inn', 146, '2019-11-27', 346, NULL),
('Cute Mountains Inn', 146, '2019-11-28', 140, NULL),
('Cute Mountains Inn', 146, '2019-11-29', 160, NULL),
('Cute Mountains Inn', 146, '2019-11-30', 145, NULL),
('Cute Mountains Inn', 146, '2019-12-01', 231, NULL),
('Cute Mountains Inn', 146, '2019-12-02', 152, NULL),
('Cute Mountains Inn', 146, '2019-12-03', 284, NULL),
('Cute Mountains Inn', 146, '2019-12-04', 350, NULL),
('Cute Mountains Inn', 146, '2019-12-05', 385, NULL),
('Cute Mountains Inn', 146, '2019-12-06', 111, NULL),
('Cute Mountains Inn', 146, '2019-12-07', 223, NULL),
('Cute Mountains Inn', 146, '2019-12-08', 194, NULL),
('Cute Mountains Inn', 146, '2019-12-09', 230, NULL),
('Cute Mountains Inn', 146, '2019-12-10', 261, NULL),
('Cute Mountains Inn', 146, '2019-12-11', 329, NULL),
('Cute Mountains Inn', 146, '2019-12-12', 141, NULL),
('Cute Mountains Inn', 146, '2019-12-13', 115, NULL),
('Cute Mountains Inn', 146, '2019-12-14', 244, NULL),
('Cute Mountains Inn', 146, '2019-12-15', 236, NULL),
('Cute Mountains Inn', 146, '2019-12-16', 101, NULL),
('Cute Mountains Inn', 146, '2019-12-17', 365, NULL),
('Cute Mountains Inn', 146, '2019-12-18', 371, NULL),
('Cute Mountains Inn', 146, '2019-12-19', 167, NULL),
('Cute Mountains Inn', 146, '2019-12-20', 342, NULL),
('Cute Mountains Inn', 146, '2019-12-21', 179, NULL),
('Cute Mountains Inn', 146, '2019-12-22', 193, NULL),
('Cute Mountains Inn', 146, '2019-12-23', 268, NULL),
('Cute Mountains Inn', 146, '2019-12-24', 197, NULL),
('Cute Mountains Inn', 146, '2019-12-25', 206, NULL),
('Cute Mountains Inn', 146, '2019-12-26', 384, NULL),
('Cute Mountains Inn', 146, '2019-12-27', 369, NULL),
('Cute Mountains Inn', 146, '2019-12-28', 389, NULL),
('Cute Mountains Inn', 146, '2019-12-29', 393, NULL),
('Cute Mountains Inn', 146, '2019-12-30', 171, NULL),
('Cute Mountains Inn', 146, '2019-12-31', 243, NULL),
('Cute Mountains Inn', 146, '2020-01-01', 203, NULL),
('Cute Mountains Inn', 146, '2020-01-02', 194, NULL),
('Cute Mountains Inn', 146, '2020-01-03', 130, NULL),
('Cute Mountains Inn', 146, '2020-01-04', 136, NULL),
('Cute Mountains Inn', 146, '2020-01-05', 220, NULL),
('Cute Mountains Inn', 146, '2020-01-06', 160, NULL),
('Cute Mountains Inn', 146, '2020-01-07', 332, NULL),
('Cute Mountains Inn', 146, '2020-01-08', 338, NULL),
('Cute Mountains Inn', 146, '2020-01-09', 357, NULL),
('Cute Mountains Inn', 146, '2020-01-10', 147, NULL),
('Cute Mountains Inn', 146, '2020-01-11', 289, NULL),
('Cute Mountains Inn', 146, '2020-01-12', 161, NULL),
('Cute Mountains Inn', 146, '2020-01-13', 399, NULL),
('Cute Mountains Inn', 146, '2020-01-14', 359, NULL),
('Cute Mountains Inn', 146, '2020-01-15', 125, NULL),
('Cute Mountains Inn', 146, '2020-01-16', 146, NULL),
('Cute Mountains Inn', 146, '2020-01-17', 250, NULL),
('Cute Mountains Inn', 146, '2020-01-18', 369, NULL),
('Cute Mountains Inn', 146, '2020-01-19', 259, NULL),
('Cute Mountains Inn', 146, '2020-01-20', 372, NULL),
('Cute Mountains Inn', 146, '2020-01-21', 396, NULL),
('Cute Mountains Inn', 146, '2020-01-22', 145, NULL),
('Cute Mountains Inn', 146, '2020-01-23', 394, NULL),
('Cute Mountains Inn', 146, '2020-01-24', 347, NULL),
('Cute Mountains Inn', 146, '2020-01-25', 375, NULL),
('Cute Mountains Inn', 146, '2020-01-26', 200, NULL),
('Cute Mountains Inn', 146, '2020-01-27', 338, NULL),
('Cute Mountains Inn', 146, '2020-01-28', 175, NULL),
('Cute Mountains Inn', 146, '2020-01-29', 399, NULL),
('Cute Mountains Inn', 146, '2020-01-30', 219, NULL),
('Cute Mountains Inn', 146, '2020-01-31', 264, NULL),
('Cute Mountains Inn', 146, '2020-02-01', 302, NULL),
('Cute Mountains Inn', 146, '2020-02-02', 261, NULL),
('Cute Mountains Inn', 146, '2020-02-03', 280, NULL),
('Cute Mountains Inn', 146, '2020-02-04', 364, NULL),
('Cute Mountains Inn', 154, '2019-01-01', 122, NULL),
('Cute Mountains Inn', 154, '2019-01-02', 377, NULL),
('Cute Mountains Inn', 154, '2019-01-03', 197, NULL),
('Cute Mountains Inn', 154, '2019-01-04', 103, NULL),
('Cute Mountains Inn', 154, '2019-01-05', 116, NULL),
('Cute Mountains Inn', 154, '2019-01-06', 153, NULL),
('Cute Mountains Inn', 154, '2019-01-07', 369, NULL),
('Cute Mountains Inn', 154, '2019-01-08', 198, NULL),
('Cute Mountains Inn', 154, '2019-01-09', 230, NULL),
('Cute Mountains Inn', 154, '2019-01-10', 288, NULL),
('Cute Mountains Inn', 154, '2019-01-11', 267, NULL),
('Cute Mountains Inn', 154, '2019-01-12', 254, NULL),
('Cute Mountains Inn', 154, '2019-01-13', 209, NULL),
('Cute Mountains Inn', 154, '2019-01-14', 191, NULL),
('Cute Mountains Inn', 154, '2019-01-15', 335, NULL),
('Cute Mountains Inn', 154, '2019-01-16', 245, NULL),
('Cute Mountains Inn', 154, '2019-01-17', 281, NULL),
('Cute Mountains Inn', 154, '2019-01-18', 374, NULL),
('Cute Mountains Inn', 154, '2019-01-19', 309, NULL),
('Cute Mountains Inn', 154, '2019-01-20', 262, NULL),
('Cute Mountains Inn', 154, '2019-01-21', 305, NULL),
('Cute Mountains Inn', 154, '2019-01-22', 287, NULL),
('Cute Mountains Inn', 154, '2019-01-23', 292, NULL),
('Cute Mountains Inn', 154, '2019-01-24', 169, NULL),
('Cute Mountains Inn', 154, '2019-01-25', 371, NULL),
('Cute Mountains Inn', 154, '2019-01-26', 378, NULL),
('Cute Mountains Inn', 154, '2019-01-27', 133, NULL),
('Cute Mountains Inn', 154, '2019-01-28', 152, NULL),
('Cute Mountains Inn', 154, '2019-01-29', 131, NULL),
('Cute Mountains Inn', 154, '2019-01-30', 307, NULL),
('Cute Mountains Inn', 154, '2019-01-31', 237, NULL),
('Cute Mountains Inn', 154, '2019-02-01', 128, NULL),
('Cute Mountains Inn', 154, '2019-02-02', 377, NULL),
('Cute Mountains Inn', 154, '2019-02-03', 295, NULL),
('Cute Mountains Inn', 154, '2019-02-04', 277, NULL),
('Cute Mountains Inn', 154, '2019-02-05', 389, NULL),
('Cute Mountains Inn', 154, '2019-02-06', 219, NULL),
('Cute Mountains Inn', 154, '2019-02-07', 319, NULL),
('Cute Mountains Inn', 154, '2019-02-08', 380, NULL),
('Cute Mountains Inn', 154, '2019-02-09', 322, NULL),
('Cute Mountains Inn', 154, '2019-02-10', 322, NULL),
('Cute Mountains Inn', 154, '2019-02-11', 140, NULL),
('Cute Mountains Inn', 154, '2019-02-12', 334, NULL),
('Cute Mountains Inn', 154, '2019-02-13', 104, NULL),
('Cute Mountains Inn', 154, '2019-02-14', 105, NULL),
('Cute Mountains Inn', 154, '2019-02-15', 298, NULL),
('Cute Mountains Inn', 154, '2019-02-16', 350, NULL),
('Cute Mountains Inn', 154, '2019-02-17', 273, NULL),
('Cute Mountains Inn', 154, '2019-02-18', 306, NULL),
('Cute Mountains Inn', 154, '2019-02-19', 341, NULL),
('Cute Mountains Inn', 154, '2019-02-20', 387, NULL),
('Cute Mountains Inn', 154, '2019-02-21', 227, NULL),
('Cute Mountains Inn', 154, '2019-02-22', 267, NULL),
('Cute Mountains Inn', 154, '2019-02-23', 344, NULL),
('Cute Mountains Inn', 154, '2019-02-24', 273, NULL),
('Cute Mountains Inn', 154, '2019-02-25', 275, NULL),
('Cute Mountains Inn', 154, '2019-02-26', 376, NULL),
('Cute Mountains Inn', 154, '2019-02-27', 396, NULL),
('Cute Mountains Inn', 154, '2019-02-28', 216, NULL),
('Cute Mountains Inn', 154, '2019-03-01', 271, NULL),
('Cute Mountains Inn', 154, '2019-03-02', 258, NULL),
('Cute Mountains Inn', 154, '2019-03-03', 188, NULL),
('Cute Mountains Inn', 154, '2019-03-04', 292, NULL),
('Cute Mountains Inn', 154, '2019-03-05', 374, NULL),
('Cute Mountains Inn', 154, '2019-03-06', 224, NULL),
('Cute Mountains Inn', 154, '2019-03-07', 236, NULL),
('Cute Mountains Inn', 154, '2019-03-08', 361, NULL),
('Cute Mountains Inn', 154, '2019-03-09', 100, NULL),
('Cute Mountains Inn', 154, '2019-03-10', 107, NULL),
('Cute Mountains Inn', 154, '2019-03-11', 343, NULL),
('Cute Mountains Inn', 154, '2019-03-12', 385, NULL),
('Cute Mountains Inn', 154, '2019-03-13', 226, NULL),
('Cute Mountains Inn', 154, '2019-03-14', 210, NULL),
('Cute Mountains Inn', 154, '2019-03-15', 207, NULL),
('Cute Mountains Inn', 154, '2019-03-16', 242, NULL),
('Cute Mountains Inn', 154, '2019-03-17', 156, NULL),
('Cute Mountains Inn', 154, '2019-03-18', 202, NULL),
('Cute Mountains Inn', 154, '2019-03-19', 229, NULL),
('Cute Mountains Inn', 154, '2019-03-20', 103, NULL),
('Cute Mountains Inn', 154, '2019-03-21', 200, NULL),
('Cute Mountains Inn', 154, '2019-03-22', 126, NULL),
('Cute Mountains Inn', 154, '2019-03-23', 296, NULL),
('Cute Mountains Inn', 154, '2019-03-24', 311, NULL),
('Cute Mountains Inn', 154, '2019-03-25', 110, NULL),
('Cute Mountains Inn', 154, '2019-03-26', 154, NULL),
('Cute Mountains Inn', 154, '2019-03-27', 350, NULL),
('Cute Mountains Inn', 154, '2019-03-28', 367, NULL),
('Cute Mountains Inn', 154, '2019-03-29', 312, NULL),
('Cute Mountains Inn', 154, '2019-03-30', 151, NULL),
('Cute Mountains Inn', 154, '2019-03-31', 137, NULL),
('Cute Mountains Inn', 154, '2019-04-01', 112, NULL),
('Cute Mountains Inn', 154, '2019-04-02', 308, NULL),
('Cute Mountains Inn', 154, '2019-04-03', 173, NULL),
('Cute Mountains Inn', 154, '2019-04-04', 281, NULL),
('Cute Mountains Inn', 154, '2019-04-05', 143, NULL),
('Cute Mountains Inn', 154, '2019-04-06', 232, NULL),
('Cute Mountains Inn', 154, '2019-04-07', 152, NULL),
('Cute Mountains Inn', 154, '2019-04-08', 219, NULL),
('Cute Mountains Inn', 154, '2019-04-09', 219, NULL),
('Cute Mountains Inn', 154, '2019-04-10', 206, NULL),
('Cute Mountains Inn', 154, '2019-04-11', 292, NULL),
('Cute Mountains Inn', 154, '2019-04-12', 250, NULL),
('Cute Mountains Inn', 154, '2019-04-13', 234, NULL),
('Cute Mountains Inn', 154, '2019-04-14', 122, NULL),
('Cute Mountains Inn', 154, '2019-04-15', 240, NULL),
('Cute Mountains Inn', 154, '2019-04-16', 243, NULL),
('Cute Mountains Inn', 154, '2019-04-17', 241, NULL),
('Cute Mountains Inn', 154, '2019-04-18', 373, NULL),
('Cute Mountains Inn', 154, '2019-04-19', 338, NULL),
('Cute Mountains Inn', 154, '2019-04-20', 158, NULL),
('Cute Mountains Inn', 154, '2019-04-21', 191, NULL),
('Cute Mountains Inn', 154, '2019-04-22', 266, NULL),
('Cute Mountains Inn', 154, '2019-04-23', 104, NULL),
('Cute Mountains Inn', 154, '2019-04-24', 260, NULL),
('Cute Mountains Inn', 154, '2019-04-25', 398, NULL),
('Cute Mountains Inn', 154, '2019-04-26', 112, NULL),
('Cute Mountains Inn', 154, '2019-04-27', 138, NULL),
('Cute Mountains Inn', 154, '2019-04-28', 109, NULL),
('Cute Mountains Inn', 154, '2019-04-29', 174, NULL),
('Cute Mountains Inn', 154, '2019-04-30', 225, NULL),
('Cute Mountains Inn', 154, '2019-05-01', 134, NULL),
('Cute Mountains Inn', 154, '2019-05-02', 122, NULL),
('Cute Mountains Inn', 154, '2019-05-03', 274, NULL),
('Cute Mountains Inn', 154, '2019-05-04', 318, NULL),
('Cute Mountains Inn', 154, '2019-05-05', 143, NULL),
('Cute Mountains Inn', 154, '2019-05-06', 179, NULL),
('Cute Mountains Inn', 154, '2019-05-07', 112, NULL),
('Cute Mountains Inn', 154, '2019-05-08', 160, NULL),
('Cute Mountains Inn', 154, '2019-05-09', 100, NULL),
('Cute Mountains Inn', 154, '2019-05-10', 112, NULL),
('Cute Mountains Inn', 154, '2019-05-11', 271, NULL),
('Cute Mountains Inn', 154, '2019-05-12', 398, NULL),
('Cute Mountains Inn', 154, '2019-05-13', 273, NULL),
('Cute Mountains Inn', 154, '2019-05-14', 145, NULL),
('Cute Mountains Inn', 154, '2019-05-15', 285, NULL),
('Cute Mountains Inn', 154, '2019-05-16', 172, NULL),
('Cute Mountains Inn', 154, '2019-05-17', 252, NULL),
('Cute Mountains Inn', 154, '2019-05-18', 103, NULL),
('Cute Mountains Inn', 154, '2019-05-19', 292, NULL),
('Cute Mountains Inn', 154, '2019-05-20', 144, NULL),
('Cute Mountains Inn', 154, '2019-05-21', 226, NULL),
('Cute Mountains Inn', 154, '2019-05-22', 170, NULL),
('Cute Mountains Inn', 154, '2019-05-23', 188, NULL),
('Cute Mountains Inn', 154, '2019-05-24', 254, NULL),
('Cute Mountains Inn', 154, '2019-05-25', 333, NULL),
('Cute Mountains Inn', 154, '2019-05-26', 177, NULL),
('Cute Mountains Inn', 154, '2019-05-27', 122, NULL),
('Cute Mountains Inn', 154, '2019-05-28', 351, NULL),
('Cute Mountains Inn', 154, '2019-05-29', 284, NULL),
('Cute Mountains Inn', 154, '2019-05-30', 324, NULL),
('Cute Mountains Inn', 154, '2019-05-31', 305, NULL),
('Cute Mountains Inn', 154, '2019-06-01', 345, NULL),
('Cute Mountains Inn', 154, '2019-06-02', 392, NULL),
('Cute Mountains Inn', 154, '2019-06-03', 371, NULL),
('Cute Mountains Inn', 154, '2019-06-04', 303, NULL),
('Cute Mountains Inn', 154, '2019-06-05', 273, NULL),
('Cute Mountains Inn', 154, '2019-06-06', 346, NULL),
('Cute Mountains Inn', 154, '2019-06-07', 361, NULL),
('Cute Mountains Inn', 154, '2019-06-08', 165, NULL),
('Cute Mountains Inn', 154, '2019-06-09', 361, NULL),
('Cute Mountains Inn', 154, '2019-06-10', 347, NULL),
('Cute Mountains Inn', 154, '2019-06-11', 171, NULL),
('Cute Mountains Inn', 154, '2019-06-12', 166, NULL),
('Cute Mountains Inn', 154, '2019-06-13', 184, NULL),
('Cute Mountains Inn', 154, '2019-06-14', 392, NULL),
('Cute Mountains Inn', 154, '2019-06-15', 364, NULL),
('Cute Mountains Inn', 154, '2019-06-16', 175, NULL),
('Cute Mountains Inn', 154, '2019-06-17', 322, NULL),
('Cute Mountains Inn', 154, '2019-06-18', 119, NULL),
('Cute Mountains Inn', 154, '2019-06-19', 358, NULL),
('Cute Mountains Inn', 154, '2019-06-20', 342, NULL),
('Cute Mountains Inn', 154, '2019-06-21', 314, NULL),
('Cute Mountains Inn', 154, '2019-06-22', 305, NULL),
('Cute Mountains Inn', 154, '2019-06-23', 150, NULL),
('Cute Mountains Inn', 154, '2019-06-24', 168, NULL),
('Cute Mountains Inn', 154, '2019-06-25', 240, NULL),
('Cute Mountains Inn', 154, '2019-06-26', 227, NULL),
('Cute Mountains Inn', 154, '2019-06-27', 270, NULL),
('Cute Mountains Inn', 154, '2019-06-28', 123, NULL),
('Cute Mountains Inn', 154, '2019-06-29', 134, NULL),
('Cute Mountains Inn', 154, '2019-06-30', 209, NULL),
('Cute Mountains Inn', 154, '2019-07-01', 276, NULL),
('Cute Mountains Inn', 154, '2019-07-02', 115, NULL),
('Cute Mountains Inn', 154, '2019-07-03', 355, NULL),
('Cute Mountains Inn', 154, '2019-07-04', 134, NULL),
('Cute Mountains Inn', 154, '2019-07-05', 167, NULL),
('Cute Mountains Inn', 154, '2019-07-06', 229, NULL),
('Cute Mountains Inn', 154, '2019-07-07', 240, NULL),
('Cute Mountains Inn', 154, '2019-07-08', 395, NULL),
('Cute Mountains Inn', 154, '2019-07-09', 157, NULL),
('Cute Mountains Inn', 154, '2019-07-10', 366, NULL),
('Cute Mountains Inn', 154, '2019-07-11', 148, NULL),
('Cute Mountains Inn', 154, '2019-07-12', 126, NULL),
('Cute Mountains Inn', 154, '2019-07-13', 160, NULL),
('Cute Mountains Inn', 154, '2019-07-14', 304, NULL),
('Cute Mountains Inn', 154, '2019-07-15', 120, NULL),
('Cute Mountains Inn', 154, '2019-07-16', 264, NULL),
('Cute Mountains Inn', 154, '2019-07-17', 348, NULL),
('Cute Mountains Inn', 154, '2019-07-18', 158, NULL),
('Cute Mountains Inn', 154, '2019-07-19', 280, NULL),
('Cute Mountains Inn', 154, '2019-07-20', 330, NULL),
('Cute Mountains Inn', 154, '2019-07-21', 304, NULL),
('Cute Mountains Inn', 154, '2019-07-22', 116, NULL),
('Cute Mountains Inn', 154, '2019-07-23', 103, NULL),
('Cute Mountains Inn', 154, '2019-07-24', 308, NULL),
('Cute Mountains Inn', 154, '2019-07-25', 278, NULL),
('Cute Mountains Inn', 154, '2019-07-26', 361, NULL),
('Cute Mountains Inn', 154, '2019-07-27', 323, NULL),
('Cute Mountains Inn', 154, '2019-07-28', 272, NULL),
('Cute Mountains Inn', 154, '2019-07-29', 181, NULL),
('Cute Mountains Inn', 154, '2019-07-30', 224, NULL),
('Cute Mountains Inn', 154, '2019-07-31', 290, NULL),
('Cute Mountains Inn', 154, '2019-08-01', 293, NULL),
('Cute Mountains Inn', 154, '2019-08-02', 305, NULL),
('Cute Mountains Inn', 154, '2019-08-03', 394, NULL),
('Cute Mountains Inn', 154, '2019-08-04', 370, NULL),
('Cute Mountains Inn', 154, '2019-08-05', 143, NULL),
('Cute Mountains Inn', 154, '2019-08-06', 127, NULL),
('Cute Mountains Inn', 154, '2019-08-07', 290, NULL),
('Cute Mountains Inn', 154, '2019-08-08', 279, NULL),
('Cute Mountains Inn', 154, '2019-08-09', 366, NULL),
('Cute Mountains Inn', 154, '2019-08-10', 109, NULL),
('Cute Mountains Inn', 154, '2019-08-11', 201, NULL),
('Cute Mountains Inn', 154, '2019-08-12', 370, NULL),
('Cute Mountains Inn', 154, '2019-08-13', 373, NULL),
('Cute Mountains Inn', 154, '2019-08-14', 280, NULL),
('Cute Mountains Inn', 154, '2019-08-15', 312, NULL),
('Cute Mountains Inn', 154, '2019-08-16', 222, NULL),
('Cute Mountains Inn', 154, '2019-08-17', 104, NULL),
('Cute Mountains Inn', 154, '2019-08-18', 156, NULL),
('Cute Mountains Inn', 154, '2019-08-19', 204, NULL),
('Cute Mountains Inn', 154, '2019-08-20', 320, NULL),
('Cute Mountains Inn', 154, '2019-08-21', 101, NULL),
('Cute Mountains Inn', 154, '2019-08-22', 120, NULL),
('Cute Mountains Inn', 154, '2019-08-23', 239, NULL),
('Cute Mountains Inn', 154, '2019-08-24', 299, NULL),
('Cute Mountains Inn', 154, '2019-08-25', 346, NULL),
('Cute Mountains Inn', 154, '2019-08-26', 281, NULL),
('Cute Mountains Inn', 154, '2019-08-27', 277, NULL),
('Cute Mountains Inn', 154, '2019-08-28', 239, NULL),
('Cute Mountains Inn', 154, '2019-08-29', 356, NULL),
('Cute Mountains Inn', 154, '2019-08-30', 109, NULL),
('Cute Mountains Inn', 154, '2019-08-31', 272, NULL),
('Cute Mountains Inn', 154, '2019-09-01', 214, NULL),
('Cute Mountains Inn', 154, '2019-09-02', 103, NULL),
('Cute Mountains Inn', 154, '2019-09-03', 315, NULL),
('Cute Mountains Inn', 154, '2019-09-04', 356, NULL),
('Cute Mountains Inn', 154, '2019-09-05', 321, NULL),
('Cute Mountains Inn', 154, '2019-09-06', 277, NULL),
('Cute Mountains Inn', 154, '2019-09-07', 276, NULL),
('Cute Mountains Inn', 154, '2019-09-08', 286, NULL),
('Cute Mountains Inn', 154, '2019-09-09', 287, NULL),
('Cute Mountains Inn', 154, '2019-09-10', 322, NULL),
('Cute Mountains Inn', 154, '2019-09-11', 147, NULL),
('Cute Mountains Inn', 154, '2019-09-12', 163, NULL),
('Cute Mountains Inn', 154, '2019-09-13', 352, NULL),
('Cute Mountains Inn', 154, '2019-09-14', 199, NULL),
('Cute Mountains Inn', 154, '2019-09-15', 245, NULL),
('Cute Mountains Inn', 154, '2019-09-16', 342, NULL),
('Cute Mountains Inn', 154, '2019-09-17', 162, NULL),
('Cute Mountains Inn', 154, '2019-09-18', 130, NULL),
('Cute Mountains Inn', 154, '2019-09-19', 384, NULL),
('Cute Mountains Inn', 154, '2019-09-20', 114, NULL),
('Cute Mountains Inn', 154, '2019-09-21', 335, NULL),
('Cute Mountains Inn', 154, '2019-09-22', 320, NULL),
('Cute Mountains Inn', 154, '2019-09-23', 134, NULL),
('Cute Mountains Inn', 154, '2019-09-24', 132, NULL),
('Cute Mountains Inn', 154, '2019-09-25', 161, NULL),
('Cute Mountains Inn', 154, '2019-09-26', 384, NULL),
('Cute Mountains Inn', 154, '2019-09-27', 275, NULL),
('Cute Mountains Inn', 154, '2019-09-28', 225, NULL),
('Cute Mountains Inn', 154, '2019-09-29', 343, NULL),
('Cute Mountains Inn', 154, '2019-09-30', 104, NULL),
('Cute Mountains Inn', 154, '2019-10-01', 109, NULL),
('Cute Mountains Inn', 154, '2019-10-02', 183, NULL),
('Cute Mountains Inn', 154, '2019-10-03', 330, NULL),
('Cute Mountains Inn', 154, '2019-10-04', 145, NULL),
('Cute Mountains Inn', 154, '2019-10-05', 381, NULL),
('Cute Mountains Inn', 154, '2019-10-06', 253, NULL),
('Cute Mountains Inn', 154, '2019-10-07', 192, NULL),
('Cute Mountains Inn', 154, '2019-10-08', 347, NULL),
('Cute Mountains Inn', 154, '2019-10-09', 117, NULL),
('Cute Mountains Inn', 154, '2019-10-10', 102, NULL),
('Cute Mountains Inn', 154, '2019-10-11', 230, NULL),
('Cute Mountains Inn', 154, '2019-10-12', 346, NULL),
('Cute Mountains Inn', 154, '2019-10-13', 378, NULL),
('Cute Mountains Inn', 154, '2019-10-14', 325, NULL),
('Cute Mountains Inn', 154, '2019-10-15', 384, NULL),
('Cute Mountains Inn', 154, '2019-10-16', 313, NULL),
('Cute Mountains Inn', 154, '2019-10-17', 311, NULL),
('Cute Mountains Inn', 154, '2019-10-18', 269, NULL),
('Cute Mountains Inn', 154, '2019-10-19', 214, NULL),
('Cute Mountains Inn', 154, '2019-10-20', 199, NULL),
('Cute Mountains Inn', 154, '2019-10-21', 255, NULL),
('Cute Mountains Inn', 154, '2019-10-22', 128, NULL),
('Cute Mountains Inn', 154, '2019-10-23', 108, NULL),
('Cute Mountains Inn', 154, '2019-10-24', 117, NULL),
('Cute Mountains Inn', 154, '2019-10-25', 284, NULL),
('Cute Mountains Inn', 154, '2019-10-26', 225, NULL),
('Cute Mountains Inn', 154, '2019-10-27', 396, NULL),
('Cute Mountains Inn', 154, '2019-10-28', 322, NULL),
('Cute Mountains Inn', 154, '2019-10-29', 134, NULL),
('Cute Mountains Inn', 154, '2019-10-30', 377, NULL),
('Cute Mountains Inn', 154, '2019-10-31', 294, NULL),
('Cute Mountains Inn', 154, '2019-11-01', 328, NULL),
('Cute Mountains Inn', 154, '2019-11-02', 368, NULL),
('Cute Mountains Inn', 154, '2019-11-03', 371, NULL),
('Cute Mountains Inn', 154, '2019-11-04', 358, NULL),
('Cute Mountains Inn', 154, '2019-11-05', 291, NULL),
('Cute Mountains Inn', 154, '2019-11-06', 318, NULL),
('Cute Mountains Inn', 154, '2019-11-07', 217, NULL),
('Cute Mountains Inn', 154, '2019-11-08', 174, NULL),
('Cute Mountains Inn', 154, '2019-11-09', 348, NULL),
('Cute Mountains Inn', 154, '2019-11-10', 345, NULL),
('Cute Mountains Inn', 154, '2019-11-11', 314, NULL),
('Cute Mountains Inn', 154, '2019-11-12', 337, NULL),
('Cute Mountains Inn', 154, '2019-11-13', 225, NULL),
('Cute Mountains Inn', 154, '2019-11-14', 241, NULL),
('Cute Mountains Inn', 154, '2019-11-15', 176, NULL),
('Cute Mountains Inn', 154, '2019-11-16', 133, NULL),
('Cute Mountains Inn', 154, '2019-11-17', 381, NULL),
('Cute Mountains Inn', 154, '2019-11-18', 278, NULL),
('Cute Mountains Inn', 154, '2019-11-19', 240, NULL),
('Cute Mountains Inn', 154, '2019-11-20', 314, NULL),
('Cute Mountains Inn', 154, '2019-11-21', 261, NULL),
('Cute Mountains Inn', 154, '2019-11-22', 367, NULL),
('Cute Mountains Inn', 154, '2019-11-23', 391, NULL),
('Cute Mountains Inn', 154, '2019-11-24', 141, NULL),
('Cute Mountains Inn', 154, '2019-11-25', 181, NULL),
('Cute Mountains Inn', 154, '2019-11-26', 295, NULL),
('Cute Mountains Inn', 154, '2019-11-27', 218, NULL),
('Cute Mountains Inn', 154, '2019-11-28', 254, NULL),
('Cute Mountains Inn', 154, '2019-11-29', 206, NULL),
('Cute Mountains Inn', 154, '2019-11-30', 392, NULL),
('Cute Mountains Inn', 154, '2019-12-01', 297, NULL),
('Cute Mountains Inn', 154, '2019-12-02', 172, NULL),
('Cute Mountains Inn', 154, '2019-12-03', 244, NULL),
('Cute Mountains Inn', 154, '2019-12-04', 179, NULL),
('Cute Mountains Inn', 154, '2019-12-05', 226, NULL),
('Cute Mountains Inn', 154, '2019-12-06', 183, NULL),
('Cute Mountains Inn', 154, '2019-12-07', 171, NULL),
('Cute Mountains Inn', 154, '2019-12-08', 234, NULL),
('Cute Mountains Inn', 154, '2019-12-09', 241, NULL),
('Cute Mountains Inn', 154, '2019-12-10', 344, NULL),
('Cute Mountains Inn', 154, '2019-12-11', 194, NULL),
('Cute Mountains Inn', 154, '2019-12-12', 347, NULL),
('Cute Mountains Inn', 154, '2019-12-13', 374, NULL),
('Cute Mountains Inn', 154, '2019-12-14', 133, NULL),
('Cute Mountains Inn', 154, '2019-12-15', 376, NULL),
('Cute Mountains Inn', 154, '2019-12-16', 245, NULL),
('Cute Mountains Inn', 154, '2019-12-17', 220, NULL),
('Cute Mountains Inn', 154, '2019-12-18', 268, NULL),
('Cute Mountains Inn', 154, '2019-12-19', 321, NULL),
('Cute Mountains Inn', 154, '2019-12-20', 262, NULL),
('Cute Mountains Inn', 154, '2019-12-21', 262, NULL),
('Cute Mountains Inn', 154, '2019-12-22', 141, NULL),
('Cute Mountains Inn', 154, '2019-12-23', 324, NULL),
('Cute Mountains Inn', 154, '2019-12-24', 107, NULL),
('Cute Mountains Inn', 154, '2019-12-25', 237, NULL),
('Cute Mountains Inn', 154, '2019-12-26', 259, NULL),
('Cute Mountains Inn', 154, '2019-12-27', 351, NULL),
('Cute Mountains Inn', 154, '2019-12-28', 104, NULL),
('Cute Mountains Inn', 154, '2019-12-29', 277, NULL),
('Cute Mountains Inn', 154, '2019-12-30', 123, NULL),
('Cute Mountains Inn', 154, '2019-12-31', 280, NULL),
('Cute Mountains Inn', 154, '2020-01-01', 158, NULL),
('Cute Mountains Inn', 154, '2020-01-02', 121, NULL),
('Cute Mountains Inn', 154, '2020-01-03', 334, NULL),
('Cute Mountains Inn', 154, '2020-01-04', 338, NULL),
('Cute Mountains Inn', 154, '2020-01-05', 289, NULL),
('Cute Mountains Inn', 154, '2020-01-06', 128, NULL),
('Cute Mountains Inn', 154, '2020-01-07', 210, NULL),
('Cute Mountains Inn', 154, '2020-01-08', 218, NULL),
('Cute Mountains Inn', 154, '2020-01-09', 307, NULL),
('Cute Mountains Inn', 154, '2020-01-10', 218, NULL),
('Cute Mountains Inn', 154, '2020-01-11', 352, NULL),
('Cute Mountains Inn', 154, '2020-01-12', 104, NULL),
('Cute Mountains Inn', 154, '2020-01-13', 393, NULL),
('Cute Mountains Inn', 154, '2020-01-14', 378, NULL),
('Cute Mountains Inn', 154, '2020-01-15', 127, NULL),
('Cute Mountains Inn', 154, '2020-01-16', 312, NULL),
('Cute Mountains Inn', 154, '2020-01-17', 289, NULL),
('Cute Mountains Inn', 154, '2020-01-18', 370, NULL),
('Cute Mountains Inn', 154, '2020-01-19', 134, NULL),
('Cute Mountains Inn', 154, '2020-01-20', 350, NULL),
('Cute Mountains Inn', 154, '2020-01-21', 336, NULL),
('Cute Mountains Inn', 154, '2020-01-22', 394, NULL),
('Cute Mountains Inn', 154, '2020-01-23', 185, NULL),
('Cute Mountains Inn', 154, '2020-01-24', 292, NULL),
('Cute Mountains Inn', 154, '2020-01-25', 372, NULL),
('Cute Mountains Inn', 154, '2020-01-26', 120, NULL),
('Cute Mountains Inn', 154, '2020-01-27', 200, NULL),
('Cute Mountains Inn', 154, '2020-01-28', 244, NULL),
('Cute Mountains Inn', 154, '2020-01-29', 305, NULL),
('Cute Mountains Inn', 154, '2020-01-30', 356, NULL),
('Cute Mountains Inn', 154, '2020-01-31', 222, NULL),
('Cute Mountains Inn', 154, '2020-02-01', 148, NULL),
('Cute Mountains Inn', 154, '2020-02-02', 161, NULL),
('Cute Mountains Inn', 154, '2020-02-03', 273, NULL),
('Cute Mountains Inn', 154, '2020-02-04', 225, NULL),
('Cute Mountains Inn', 161, '2019-01-01', 357, NULL),
('Cute Mountains Inn', 161, '2019-01-02', 108, NULL),
('Cute Mountains Inn', 161, '2019-01-03', 165, NULL),
('Cute Mountains Inn', 161, '2019-01-04', 223, NULL),
('Cute Mountains Inn', 161, '2019-01-05', 294, NULL),
('Cute Mountains Inn', 161, '2019-01-06', 365, NULL),
('Cute Mountains Inn', 161, '2019-01-07', 262, NULL),
('Cute Mountains Inn', 161, '2019-01-08', 338, NULL),
('Cute Mountains Inn', 161, '2019-01-09', 368, NULL),
('Cute Mountains Inn', 161, '2019-01-10', 197, NULL),
('Cute Mountains Inn', 161, '2019-01-11', 249, NULL),
('Cute Mountains Inn', 161, '2019-01-12', 326, NULL),
('Cute Mountains Inn', 161, '2019-01-13', 313, NULL),
('Cute Mountains Inn', 161, '2019-01-14', 337, NULL),
('Cute Mountains Inn', 161, '2019-01-15', 315, NULL),
('Cute Mountains Inn', 161, '2019-01-16', 214, NULL),
('Cute Mountains Inn', 161, '2019-01-17', 374, NULL),
('Cute Mountains Inn', 161, '2019-01-18', 127, NULL),
('Cute Mountains Inn', 161, '2019-01-19', 174, NULL),
('Cute Mountains Inn', 161, '2019-01-20', 182, NULL),
('Cute Mountains Inn', 161, '2019-01-21', 372, NULL),
('Cute Mountains Inn', 161, '2019-01-22', 143, NULL),
('Cute Mountains Inn', 161, '2019-01-23', 296, NULL),
('Cute Mountains Inn', 161, '2019-01-24', 230, NULL),
('Cute Mountains Inn', 161, '2019-01-25', 265, NULL),
('Cute Mountains Inn', 161, '2019-01-26', 142, NULL),
('Cute Mountains Inn', 161, '2019-01-27', 379, NULL),
('Cute Mountains Inn', 161, '2019-01-28', 137, NULL),
('Cute Mountains Inn', 161, '2019-01-29', 289, NULL),
('Cute Mountains Inn', 161, '2019-01-30', 225, NULL),
('Cute Mountains Inn', 161, '2019-01-31', 173, NULL),
('Cute Mountains Inn', 161, '2019-02-01', 171, NULL),
('Cute Mountains Inn', 161, '2019-02-02', 225, NULL),
('Cute Mountains Inn', 161, '2019-02-03', 144, NULL),
('Cute Mountains Inn', 161, '2019-02-04', 263, NULL),
('Cute Mountains Inn', 161, '2019-02-05', 189, NULL),
('Cute Mountains Inn', 161, '2019-02-06', 322, NULL),
('Cute Mountains Inn', 161, '2019-02-07', 148, NULL),
('Cute Mountains Inn', 161, '2019-02-08', 341, NULL),
('Cute Mountains Inn', 161, '2019-02-09', 184, NULL),
('Cute Mountains Inn', 161, '2019-02-10', 397, NULL),
('Cute Mountains Inn', 161, '2019-02-11', 391, NULL),
('Cute Mountains Inn', 161, '2019-02-12', 154, NULL),
('Cute Mountains Inn', 161, '2019-02-13', 353, NULL),
('Cute Mountains Inn', 161, '2019-02-14', 398, NULL),
('Cute Mountains Inn', 161, '2019-02-15', 397, NULL),
('Cute Mountains Inn', 161, '2019-02-16', 102, NULL),
('Cute Mountains Inn', 161, '2019-02-17', 304, NULL),
('Cute Mountains Inn', 161, '2019-02-18', 273, NULL),
('Cute Mountains Inn', 161, '2019-02-19', 174, NULL),
('Cute Mountains Inn', 161, '2019-02-20', 161, NULL),
('Cute Mountains Inn', 161, '2019-02-21', 327, NULL),
('Cute Mountains Inn', 161, '2019-02-22', 354, NULL),
('Cute Mountains Inn', 161, '2019-02-23', 249, NULL),
('Cute Mountains Inn', 161, '2019-02-24', 295, NULL),
('Cute Mountains Inn', 161, '2019-02-25', 229, NULL),
('Cute Mountains Inn', 161, '2019-02-26', 256, NULL),
('Cute Mountains Inn', 161, '2019-02-27', 194, NULL),
('Cute Mountains Inn', 161, '2019-02-28', 358, NULL),
('Cute Mountains Inn', 161, '2019-03-01', 248, NULL),
('Cute Mountains Inn', 161, '2019-03-02', 373, NULL),
('Cute Mountains Inn', 161, '2019-03-03', 338, NULL),
('Cute Mountains Inn', 161, '2019-03-04', 307, NULL),
('Cute Mountains Inn', 161, '2019-03-05', 351, NULL),
('Cute Mountains Inn', 161, '2019-03-06', 310, NULL),
('Cute Mountains Inn', 161, '2019-03-07', 173, NULL),
('Cute Mountains Inn', 161, '2019-03-08', 307, NULL),
('Cute Mountains Inn', 161, '2019-03-09', 266, NULL),
('Cute Mountains Inn', 161, '2019-03-10', 189, NULL),
('Cute Mountains Inn', 161, '2019-03-11', 100, NULL),
('Cute Mountains Inn', 161, '2019-03-12', 199, NULL),
('Cute Mountains Inn', 161, '2019-03-13', 268, NULL),
('Cute Mountains Inn', 161, '2019-03-14', 361, NULL),
('Cute Mountains Inn', 161, '2019-03-15', 367, NULL),
('Cute Mountains Inn', 161, '2019-03-16', 314, NULL),
('Cute Mountains Inn', 161, '2019-03-17', 293, NULL),
('Cute Mountains Inn', 161, '2019-03-18', 201, NULL),
('Cute Mountains Inn', 161, '2019-03-19', 335, NULL),
('Cute Mountains Inn', 161, '2019-03-20', 209, NULL),
('Cute Mountains Inn', 161, '2019-03-21', 158, NULL),
('Cute Mountains Inn', 161, '2019-03-22', 201, NULL),
('Cute Mountains Inn', 161, '2019-03-23', 353, NULL),
('Cute Mountains Inn', 161, '2019-03-24', 258, NULL),
('Cute Mountains Inn', 161, '2019-03-25', 110, NULL),
('Cute Mountains Inn', 161, '2019-03-26', 137, NULL),
('Cute Mountains Inn', 161, '2019-03-27', 393, NULL),
('Cute Mountains Inn', 161, '2019-03-28', 268, NULL),
('Cute Mountains Inn', 161, '2019-03-29', 224, NULL),
('Cute Mountains Inn', 161, '2019-03-30', 155, NULL),
('Cute Mountains Inn', 161, '2019-03-31', 222, NULL),
('Cute Mountains Inn', 161, '2019-04-01', 358, NULL),
('Cute Mountains Inn', 161, '2019-04-02', 362, NULL),
('Cute Mountains Inn', 161, '2019-04-03', 367, NULL),
('Cute Mountains Inn', 161, '2019-04-04', 395, NULL),
('Cute Mountains Inn', 161, '2019-04-05', 320, NULL),
('Cute Mountains Inn', 161, '2019-04-06', 161, NULL),
('Cute Mountains Inn', 161, '2019-04-07', 197, NULL),
('Cute Mountains Inn', 161, '2019-04-08', 135, NULL),
('Cute Mountains Inn', 161, '2019-04-09', 142, NULL),
('Cute Mountains Inn', 161, '2019-04-10', 236, NULL),
('Cute Mountains Inn', 161, '2019-04-11', 315, NULL),
('Cute Mountains Inn', 161, '2019-04-12', 112, NULL),
('Cute Mountains Inn', 161, '2019-04-13', 368, NULL),
('Cute Mountains Inn', 161, '2019-04-14', 150, NULL),
('Cute Mountains Inn', 161, '2019-04-15', 106, NULL),
('Cute Mountains Inn', 161, '2019-04-16', 135, NULL),
('Cute Mountains Inn', 161, '2019-04-17', 301, NULL),
('Cute Mountains Inn', 161, '2019-04-18', 320, NULL),
('Cute Mountains Inn', 161, '2019-04-19', 298, NULL),
('Cute Mountains Inn', 161, '2019-04-20', 399, NULL),
('Cute Mountains Inn', 161, '2019-04-21', 366, NULL),
('Cute Mountains Inn', 161, '2019-04-22', 203, NULL),
('Cute Mountains Inn', 161, '2019-04-23', 110, NULL),
('Cute Mountains Inn', 161, '2019-04-24', 202, NULL),
('Cute Mountains Inn', 161, '2019-04-25', 170, NULL),
('Cute Mountains Inn', 161, '2019-04-26', 108, NULL),
('Cute Mountains Inn', 161, '2019-04-27', 386, NULL),
('Cute Mountains Inn', 161, '2019-04-28', 120, NULL),
('Cute Mountains Inn', 161, '2019-04-29', 324, NULL),
('Cute Mountains Inn', 161, '2019-04-30', 275, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 161, '2019-05-01', 194, NULL),
('Cute Mountains Inn', 161, '2019-05-02', 174, NULL),
('Cute Mountains Inn', 161, '2019-05-03', 369, NULL),
('Cute Mountains Inn', 161, '2019-05-04', 265, NULL),
('Cute Mountains Inn', 161, '2019-05-05', 231, NULL),
('Cute Mountains Inn', 161, '2019-05-06', 255, NULL),
('Cute Mountains Inn', 161, '2019-05-07', 179, NULL),
('Cute Mountains Inn', 161, '2019-05-08', 357, NULL),
('Cute Mountains Inn', 161, '2019-05-09', 120, NULL),
('Cute Mountains Inn', 161, '2019-05-10', 282, NULL),
('Cute Mountains Inn', 161, '2019-05-11', 155, NULL),
('Cute Mountains Inn', 161, '2019-05-12', 112, NULL),
('Cute Mountains Inn', 161, '2019-05-13', 399, NULL),
('Cute Mountains Inn', 161, '2019-05-14', 165, NULL),
('Cute Mountains Inn', 161, '2019-05-15', 102, NULL),
('Cute Mountains Inn', 161, '2019-05-16', 277, NULL),
('Cute Mountains Inn', 161, '2019-05-17', 195, NULL),
('Cute Mountains Inn', 161, '2019-05-18', 394, NULL),
('Cute Mountains Inn', 161, '2019-05-19', 296, NULL),
('Cute Mountains Inn', 161, '2019-05-20', 305, NULL),
('Cute Mountains Inn', 161, '2019-05-21', 138, NULL),
('Cute Mountains Inn', 161, '2019-05-22', 170, NULL),
('Cute Mountains Inn', 161, '2019-05-23', 140, NULL),
('Cute Mountains Inn', 161, '2019-05-24', 373, NULL),
('Cute Mountains Inn', 161, '2019-05-25', 151, NULL),
('Cute Mountains Inn', 161, '2019-05-26', 312, NULL),
('Cute Mountains Inn', 161, '2019-05-27', 227, NULL),
('Cute Mountains Inn', 161, '2019-05-28', 367, NULL),
('Cute Mountains Inn', 161, '2019-05-29', 338, NULL),
('Cute Mountains Inn', 161, '2019-05-30', 368, NULL),
('Cute Mountains Inn', 161, '2019-05-31', 399, NULL),
('Cute Mountains Inn', 161, '2019-06-01', 146, NULL),
('Cute Mountains Inn', 161, '2019-06-02', 286, NULL),
('Cute Mountains Inn', 161, '2019-06-03', 263, NULL),
('Cute Mountains Inn', 161, '2019-06-04', 267, NULL),
('Cute Mountains Inn', 161, '2019-06-05', 110, NULL),
('Cute Mountains Inn', 161, '2019-06-06', 335, NULL),
('Cute Mountains Inn', 161, '2019-06-07', 353, NULL),
('Cute Mountains Inn', 161, '2019-06-08', 263, NULL),
('Cute Mountains Inn', 161, '2019-06-09', 123, NULL),
('Cute Mountains Inn', 161, '2019-06-10', 105, NULL),
('Cute Mountains Inn', 161, '2019-06-11', 218, NULL),
('Cute Mountains Inn', 161, '2019-06-12', 336, NULL),
('Cute Mountains Inn', 161, '2019-06-13', 293, NULL),
('Cute Mountains Inn', 161, '2019-06-14', 315, NULL),
('Cute Mountains Inn', 161, '2019-06-15', 288, NULL),
('Cute Mountains Inn', 161, '2019-06-16', 149, NULL),
('Cute Mountains Inn', 161, '2019-06-17', 120, NULL),
('Cute Mountains Inn', 161, '2019-06-18', 277, NULL),
('Cute Mountains Inn', 161, '2019-06-19', 308, NULL),
('Cute Mountains Inn', 161, '2019-06-20', 360, NULL),
('Cute Mountains Inn', 161, '2019-06-21', 370, NULL),
('Cute Mountains Inn', 161, '2019-06-22', 193, NULL),
('Cute Mountains Inn', 161, '2019-06-23', 118, NULL),
('Cute Mountains Inn', 161, '2019-06-24', 253, NULL),
('Cute Mountains Inn', 161, '2019-06-25', 350, NULL),
('Cute Mountains Inn', 161, '2019-06-26', 265, NULL),
('Cute Mountains Inn', 161, '2019-06-27', 225, NULL),
('Cute Mountains Inn', 161, '2019-06-28', 149, NULL),
('Cute Mountains Inn', 161, '2019-06-29', 323, NULL),
('Cute Mountains Inn', 161, '2019-06-30', 231, NULL),
('Cute Mountains Inn', 161, '2019-07-01', 234, NULL),
('Cute Mountains Inn', 161, '2019-07-02', 188, NULL),
('Cute Mountains Inn', 161, '2019-07-03', 287, NULL),
('Cute Mountains Inn', 161, '2019-07-04', 109, NULL),
('Cute Mountains Inn', 161, '2019-07-05', 192, NULL),
('Cute Mountains Inn', 161, '2019-07-06', 288, NULL),
('Cute Mountains Inn', 161, '2019-07-07', 189, NULL),
('Cute Mountains Inn', 161, '2019-07-08', 328, NULL),
('Cute Mountains Inn', 161, '2019-07-09', 248, NULL),
('Cute Mountains Inn', 161, '2019-07-10', 214, NULL),
('Cute Mountains Inn', 161, '2019-07-11', 320, NULL),
('Cute Mountains Inn', 161, '2019-07-12', 375, NULL),
('Cute Mountains Inn', 161, '2019-07-13', 153, NULL),
('Cute Mountains Inn', 161, '2019-07-14', 257, NULL),
('Cute Mountains Inn', 161, '2019-07-15', 198, NULL),
('Cute Mountains Inn', 161, '2019-07-16', 192, NULL),
('Cute Mountains Inn', 161, '2019-07-17', 348, NULL),
('Cute Mountains Inn', 161, '2019-07-18', 292, NULL),
('Cute Mountains Inn', 161, '2019-07-19', 226, NULL),
('Cute Mountains Inn', 161, '2019-07-20', 183, NULL),
('Cute Mountains Inn', 161, '2019-07-21', 201, NULL),
('Cute Mountains Inn', 161, '2019-07-22', 208, NULL),
('Cute Mountains Inn', 161, '2019-07-23', 319, NULL),
('Cute Mountains Inn', 161, '2019-07-24', 231, NULL),
('Cute Mountains Inn', 161, '2019-07-25', 266, NULL),
('Cute Mountains Inn', 161, '2019-07-26', 283, NULL),
('Cute Mountains Inn', 161, '2019-07-27', 142, NULL),
('Cute Mountains Inn', 161, '2019-07-28', 132, NULL),
('Cute Mountains Inn', 161, '2019-07-29', 135, NULL),
('Cute Mountains Inn', 161, '2019-07-30', 328, NULL),
('Cute Mountains Inn', 161, '2019-07-31', 309, NULL),
('Cute Mountains Inn', 161, '2019-08-01', 302, NULL),
('Cute Mountains Inn', 161, '2019-08-02', 321, NULL),
('Cute Mountains Inn', 161, '2019-08-03', 237, NULL),
('Cute Mountains Inn', 161, '2019-08-04', 398, NULL),
('Cute Mountains Inn', 161, '2019-08-05', 182, NULL),
('Cute Mountains Inn', 161, '2019-08-06', 372, NULL),
('Cute Mountains Inn', 161, '2019-08-07', 122, NULL),
('Cute Mountains Inn', 161, '2019-08-08', 257, NULL),
('Cute Mountains Inn', 161, '2019-08-09', 371, NULL),
('Cute Mountains Inn', 161, '2019-08-10', 119, NULL),
('Cute Mountains Inn', 161, '2019-08-11', 359, NULL),
('Cute Mountains Inn', 161, '2019-08-12', 388, NULL),
('Cute Mountains Inn', 161, '2019-08-13', 241, NULL),
('Cute Mountains Inn', 161, '2019-08-14', 221, NULL),
('Cute Mountains Inn', 161, '2019-08-15', 324, NULL),
('Cute Mountains Inn', 161, '2019-08-16', 324, NULL),
('Cute Mountains Inn', 161, '2019-08-17', 313, NULL),
('Cute Mountains Inn', 161, '2019-08-18', 382, NULL),
('Cute Mountains Inn', 161, '2019-08-19', 145, NULL),
('Cute Mountains Inn', 161, '2019-08-20', 110, NULL),
('Cute Mountains Inn', 161, '2019-08-21', 199, NULL),
('Cute Mountains Inn', 161, '2019-08-22', 237, NULL),
('Cute Mountains Inn', 161, '2019-08-23', 356, NULL),
('Cute Mountains Inn', 161, '2019-08-24', 357, NULL),
('Cute Mountains Inn', 161, '2019-08-25', 182, NULL),
('Cute Mountains Inn', 161, '2019-08-26', 395, NULL),
('Cute Mountains Inn', 161, '2019-08-27', 235, NULL),
('Cute Mountains Inn', 161, '2019-08-28', 145, NULL),
('Cute Mountains Inn', 161, '2019-08-29', 317, NULL),
('Cute Mountains Inn', 161, '2019-08-30', 364, NULL),
('Cute Mountains Inn', 161, '2019-08-31', 382, NULL),
('Cute Mountains Inn', 161, '2019-09-01', 196, NULL),
('Cute Mountains Inn', 161, '2019-09-02', 143, NULL),
('Cute Mountains Inn', 161, '2019-09-03', 175, NULL),
('Cute Mountains Inn', 161, '2019-09-04', 352, NULL),
('Cute Mountains Inn', 161, '2019-09-05', 321, NULL),
('Cute Mountains Inn', 161, '2019-09-06', 395, NULL),
('Cute Mountains Inn', 161, '2019-09-07', 199, NULL),
('Cute Mountains Inn', 161, '2019-09-08', 122, NULL),
('Cute Mountains Inn', 161, '2019-09-09', 262, NULL),
('Cute Mountains Inn', 161, '2019-09-10', 282, NULL),
('Cute Mountains Inn', 161, '2019-09-11', 176, NULL),
('Cute Mountains Inn', 161, '2019-09-12', 267, NULL),
('Cute Mountains Inn', 161, '2019-09-13', 169, NULL),
('Cute Mountains Inn', 161, '2019-09-14', 307, NULL),
('Cute Mountains Inn', 161, '2019-09-15', 197, NULL),
('Cute Mountains Inn', 161, '2019-09-16', 176, NULL),
('Cute Mountains Inn', 161, '2019-09-17', 204, NULL),
('Cute Mountains Inn', 161, '2019-09-18', 247, NULL),
('Cute Mountains Inn', 161, '2019-09-19', 254, NULL),
('Cute Mountains Inn', 161, '2019-09-20', 134, NULL),
('Cute Mountains Inn', 161, '2019-09-21', 357, NULL),
('Cute Mountains Inn', 161, '2019-09-22', 148, NULL),
('Cute Mountains Inn', 161, '2019-09-23', 120, NULL),
('Cute Mountains Inn', 161, '2019-09-24', 257, NULL),
('Cute Mountains Inn', 161, '2019-09-25', 110, NULL),
('Cute Mountains Inn', 161, '2019-09-26', 246, NULL),
('Cute Mountains Inn', 161, '2019-09-27', 123, NULL),
('Cute Mountains Inn', 161, '2019-09-28', 306, NULL),
('Cute Mountains Inn', 161, '2019-09-29', 111, NULL),
('Cute Mountains Inn', 161, '2019-09-30', 140, NULL),
('Cute Mountains Inn', 161, '2019-10-01', 174, NULL),
('Cute Mountains Inn', 161, '2019-10-02', 236, NULL),
('Cute Mountains Inn', 161, '2019-10-03', 259, NULL),
('Cute Mountains Inn', 161, '2019-10-04', 289, NULL),
('Cute Mountains Inn', 161, '2019-10-05', 162, NULL),
('Cute Mountains Inn', 161, '2019-10-06', 265, NULL),
('Cute Mountains Inn', 161, '2019-10-07', 343, NULL),
('Cute Mountains Inn', 161, '2019-10-08', 251, NULL),
('Cute Mountains Inn', 161, '2019-10-09', 155, NULL),
('Cute Mountains Inn', 161, '2019-10-10', 195, NULL),
('Cute Mountains Inn', 161, '2019-10-11', 335, NULL),
('Cute Mountains Inn', 161, '2019-10-12', 367, NULL),
('Cute Mountains Inn', 161, '2019-10-13', 291, NULL),
('Cute Mountains Inn', 161, '2019-10-14', 389, NULL),
('Cute Mountains Inn', 161, '2019-10-15', 104, NULL),
('Cute Mountains Inn', 161, '2019-10-16', 311, NULL),
('Cute Mountains Inn', 161, '2019-10-17', 276, NULL),
('Cute Mountains Inn', 161, '2019-10-18', 163, NULL),
('Cute Mountains Inn', 161, '2019-10-19', 144, NULL),
('Cute Mountains Inn', 161, '2019-10-20', 117, NULL),
('Cute Mountains Inn', 161, '2019-10-21', 269, NULL),
('Cute Mountains Inn', 161, '2019-10-22', 164, NULL),
('Cute Mountains Inn', 161, '2019-10-23', 266, NULL),
('Cute Mountains Inn', 161, '2019-10-24', 102, NULL),
('Cute Mountains Inn', 161, '2019-10-25', 167, NULL),
('Cute Mountains Inn', 161, '2019-10-26', 379, NULL),
('Cute Mountains Inn', 161, '2019-10-27', 340, NULL),
('Cute Mountains Inn', 161, '2019-10-28', 164, NULL),
('Cute Mountains Inn', 161, '2019-10-29', 265, NULL),
('Cute Mountains Inn', 161, '2019-10-30', 153, NULL),
('Cute Mountains Inn', 161, '2019-10-31', 103, NULL),
('Cute Mountains Inn', 161, '2019-11-01', 201, NULL),
('Cute Mountains Inn', 161, '2019-11-02', 369, NULL),
('Cute Mountains Inn', 161, '2019-11-03', 141, NULL),
('Cute Mountains Inn', 161, '2019-11-04', 147, NULL),
('Cute Mountains Inn', 161, '2019-11-05', 152, NULL),
('Cute Mountains Inn', 161, '2019-11-06', 201, NULL),
('Cute Mountains Inn', 161, '2019-11-07', 100, NULL),
('Cute Mountains Inn', 161, '2019-11-08', 268, NULL),
('Cute Mountains Inn', 161, '2019-11-09', 394, NULL),
('Cute Mountains Inn', 161, '2019-11-10', 271, NULL),
('Cute Mountains Inn', 161, '2019-11-11', 263, NULL),
('Cute Mountains Inn', 161, '2019-11-12', 244, NULL),
('Cute Mountains Inn', 161, '2019-11-13', 381, NULL),
('Cute Mountains Inn', 161, '2019-11-14', 258, NULL),
('Cute Mountains Inn', 161, '2019-11-15', 122, NULL),
('Cute Mountains Inn', 161, '2019-11-16', 372, NULL),
('Cute Mountains Inn', 161, '2019-11-17', 267, NULL),
('Cute Mountains Inn', 161, '2019-11-18', 299, NULL),
('Cute Mountains Inn', 161, '2019-11-19', 290, NULL),
('Cute Mountains Inn', 161, '2019-11-20', 248, NULL),
('Cute Mountains Inn', 161, '2019-11-21', 282, NULL),
('Cute Mountains Inn', 161, '2019-11-22', 160, NULL),
('Cute Mountains Inn', 161, '2019-11-23', 244, NULL),
('Cute Mountains Inn', 161, '2019-11-24', 111, NULL),
('Cute Mountains Inn', 161, '2019-11-25', 172, NULL),
('Cute Mountains Inn', 161, '2019-11-26', 368, NULL),
('Cute Mountains Inn', 161, '2019-11-27', 250, NULL),
('Cute Mountains Inn', 161, '2019-11-28', 151, NULL),
('Cute Mountains Inn', 161, '2019-11-29', 149, NULL),
('Cute Mountains Inn', 161, '2019-11-30', 224, NULL),
('Cute Mountains Inn', 161, '2019-12-01', 393, NULL),
('Cute Mountains Inn', 161, '2019-12-02', 307, NULL),
('Cute Mountains Inn', 161, '2019-12-03', 271, NULL),
('Cute Mountains Inn', 161, '2019-12-04', 347, NULL),
('Cute Mountains Inn', 161, '2019-12-05', 174, NULL),
('Cute Mountains Inn', 161, '2019-12-06', 184, NULL),
('Cute Mountains Inn', 161, '2019-12-07', 387, NULL),
('Cute Mountains Inn', 161, '2019-12-08', 189, NULL),
('Cute Mountains Inn', 161, '2019-12-09', 116, NULL),
('Cute Mountains Inn', 161, '2019-12-10', 238, NULL),
('Cute Mountains Inn', 161, '2019-12-11', 183, NULL),
('Cute Mountains Inn', 161, '2019-12-12', 313, NULL),
('Cute Mountains Inn', 161, '2019-12-13', 227, NULL),
('Cute Mountains Inn', 161, '2019-12-14', 130, NULL),
('Cute Mountains Inn', 161, '2019-12-15', 176, NULL),
('Cute Mountains Inn', 161, '2019-12-16', 224, NULL),
('Cute Mountains Inn', 161, '2019-12-17', 208, NULL),
('Cute Mountains Inn', 161, '2019-12-18', 127, NULL),
('Cute Mountains Inn', 161, '2019-12-19', 105, NULL),
('Cute Mountains Inn', 161, '2019-12-20', 185, NULL),
('Cute Mountains Inn', 161, '2019-12-21', 376, NULL),
('Cute Mountains Inn', 161, '2019-12-22', 327, NULL),
('Cute Mountains Inn', 161, '2019-12-23', 117, NULL),
('Cute Mountains Inn', 161, '2019-12-24', 144, NULL),
('Cute Mountains Inn', 161, '2019-12-25', 170, NULL),
('Cute Mountains Inn', 161, '2019-12-26', 344, NULL),
('Cute Mountains Inn', 161, '2019-12-27', 249, NULL),
('Cute Mountains Inn', 161, '2019-12-28', 154, NULL),
('Cute Mountains Inn', 161, '2019-12-29', 106, NULL),
('Cute Mountains Inn', 161, '2019-12-30', 300, NULL),
('Cute Mountains Inn', 161, '2019-12-31', 272, NULL),
('Cute Mountains Inn', 161, '2020-01-01', 383, NULL),
('Cute Mountains Inn', 161, '2020-01-02', 221, NULL),
('Cute Mountains Inn', 161, '2020-01-03', 283, NULL),
('Cute Mountains Inn', 161, '2020-01-04', 283, NULL),
('Cute Mountains Inn', 161, '2020-01-05', 387, NULL),
('Cute Mountains Inn', 161, '2020-01-06', 361, NULL),
('Cute Mountains Inn', 161, '2020-01-07', 256, NULL),
('Cute Mountains Inn', 161, '2020-01-08', 277, NULL),
('Cute Mountains Inn', 161, '2020-01-09', 365, NULL),
('Cute Mountains Inn', 161, '2020-01-10', 248, NULL),
('Cute Mountains Inn', 161, '2020-01-11', 192, NULL),
('Cute Mountains Inn', 161, '2020-01-12', 240, NULL),
('Cute Mountains Inn', 161, '2020-01-13', 368, NULL),
('Cute Mountains Inn', 161, '2020-01-14', 110, NULL),
('Cute Mountains Inn', 161, '2020-01-15', 162, NULL),
('Cute Mountains Inn', 161, '2020-01-16', 125, NULL),
('Cute Mountains Inn', 161, '2020-01-17', 296, NULL),
('Cute Mountains Inn', 161, '2020-01-18', 340, NULL),
('Cute Mountains Inn', 161, '2020-01-19', 393, NULL),
('Cute Mountains Inn', 161, '2020-01-20', 235, NULL),
('Cute Mountains Inn', 161, '2020-01-21', 389, NULL),
('Cute Mountains Inn', 161, '2020-01-22', 236, NULL),
('Cute Mountains Inn', 161, '2020-01-23', 246, NULL),
('Cute Mountains Inn', 161, '2020-01-24', 321, NULL),
('Cute Mountains Inn', 161, '2020-01-25', 337, NULL),
('Cute Mountains Inn', 161, '2020-01-26', 202, NULL),
('Cute Mountains Inn', 161, '2020-01-27', 187, NULL),
('Cute Mountains Inn', 161, '2020-01-28', 294, NULL),
('Cute Mountains Inn', 161, '2020-01-29', 227, NULL),
('Cute Mountains Inn', 161, '2020-01-30', 123, NULL),
('Cute Mountains Inn', 161, '2020-01-31', 217, NULL),
('Cute Mountains Inn', 161, '2020-02-01', 334, NULL),
('Cute Mountains Inn', 161, '2020-02-02', 222, NULL),
('Cute Mountains Inn', 161, '2020-02-03', 124, NULL),
('Cute Mountains Inn', 161, '2020-02-04', 230, NULL),
('Cute Mountains Inn', 164, '2019-01-01', 118, NULL),
('Cute Mountains Inn', 164, '2019-01-02', 208, NULL),
('Cute Mountains Inn', 164, '2019-01-03', 133, NULL),
('Cute Mountains Inn', 164, '2019-01-04', 107, NULL),
('Cute Mountains Inn', 164, '2019-01-05', 123, NULL),
('Cute Mountains Inn', 164, '2019-01-06', 367, NULL),
('Cute Mountains Inn', 164, '2019-01-07', 102, NULL),
('Cute Mountains Inn', 164, '2019-01-08', 396, NULL),
('Cute Mountains Inn', 164, '2019-01-09', 149, NULL),
('Cute Mountains Inn', 164, '2019-01-10', 322, NULL),
('Cute Mountains Inn', 164, '2019-01-11', 341, NULL),
('Cute Mountains Inn', 164, '2019-01-12', 170, NULL),
('Cute Mountains Inn', 164, '2019-01-13', 237, NULL),
('Cute Mountains Inn', 164, '2019-01-14', 111, NULL),
('Cute Mountains Inn', 164, '2019-01-15', 168, NULL),
('Cute Mountains Inn', 164, '2019-01-16', 235, NULL),
('Cute Mountains Inn', 164, '2019-01-17', 326, NULL),
('Cute Mountains Inn', 164, '2019-01-18', 314, NULL),
('Cute Mountains Inn', 164, '2019-01-19', 146, NULL),
('Cute Mountains Inn', 164, '2019-01-20', 323, NULL),
('Cute Mountains Inn', 164, '2019-01-21', 246, NULL),
('Cute Mountains Inn', 164, '2019-01-22', 353, NULL),
('Cute Mountains Inn', 164, '2019-01-23', 206, NULL),
('Cute Mountains Inn', 164, '2019-01-24', 245, NULL),
('Cute Mountains Inn', 164, '2019-01-25', 111, NULL),
('Cute Mountains Inn', 164, '2019-01-26', 376, NULL),
('Cute Mountains Inn', 164, '2019-01-27', 195, NULL),
('Cute Mountains Inn', 164, '2019-01-28', 133, NULL),
('Cute Mountains Inn', 164, '2019-01-29', 352, NULL),
('Cute Mountains Inn', 164, '2019-01-30', 102, NULL),
('Cute Mountains Inn', 164, '2019-01-31', 357, NULL),
('Cute Mountains Inn', 164, '2019-02-01', 373, NULL),
('Cute Mountains Inn', 164, '2019-02-02', 197, NULL),
('Cute Mountains Inn', 164, '2019-02-03', 332, NULL),
('Cute Mountains Inn', 164, '2019-02-04', 386, NULL),
('Cute Mountains Inn', 164, '2019-02-05', 279, NULL),
('Cute Mountains Inn', 164, '2019-02-06', 256, NULL),
('Cute Mountains Inn', 164, '2019-02-07', 282, NULL),
('Cute Mountains Inn', 164, '2019-02-08', 165, NULL),
('Cute Mountains Inn', 164, '2019-02-09', 155, NULL),
('Cute Mountains Inn', 164, '2019-02-10', 318, NULL),
('Cute Mountains Inn', 164, '2019-02-11', 237, NULL),
('Cute Mountains Inn', 164, '2019-02-12', 269, NULL),
('Cute Mountains Inn', 164, '2019-02-13', 155, NULL),
('Cute Mountains Inn', 164, '2019-02-14', 373, NULL),
('Cute Mountains Inn', 164, '2019-02-15', 388, NULL),
('Cute Mountains Inn', 164, '2019-02-16', 262, NULL),
('Cute Mountains Inn', 164, '2019-02-17', 301, NULL),
('Cute Mountains Inn', 164, '2019-02-18', 349, NULL),
('Cute Mountains Inn', 164, '2019-02-19', 347, NULL),
('Cute Mountains Inn', 164, '2019-02-20', 143, NULL),
('Cute Mountains Inn', 164, '2019-02-21', 254, NULL),
('Cute Mountains Inn', 164, '2019-02-22', 272, NULL),
('Cute Mountains Inn', 164, '2019-02-23', 115, NULL),
('Cute Mountains Inn', 164, '2019-02-24', 257, NULL),
('Cute Mountains Inn', 164, '2019-02-25', 218, NULL),
('Cute Mountains Inn', 164, '2019-02-26', 355, NULL),
('Cute Mountains Inn', 164, '2019-02-27', 282, NULL),
('Cute Mountains Inn', 164, '2019-02-28', 141, NULL),
('Cute Mountains Inn', 164, '2019-03-01', 327, NULL),
('Cute Mountains Inn', 164, '2019-03-02', 392, NULL),
('Cute Mountains Inn', 164, '2019-03-03', 126, NULL),
('Cute Mountains Inn', 164, '2019-03-04', 258, NULL),
('Cute Mountains Inn', 164, '2019-03-05', 235, NULL),
('Cute Mountains Inn', 164, '2019-03-06', 179, NULL),
('Cute Mountains Inn', 164, '2019-03-07', 355, NULL),
('Cute Mountains Inn', 164, '2019-03-08', 353, NULL),
('Cute Mountains Inn', 164, '2019-03-09', 333, NULL),
('Cute Mountains Inn', 164, '2019-03-10', 222, NULL),
('Cute Mountains Inn', 164, '2019-03-11', 269, NULL),
('Cute Mountains Inn', 164, '2019-03-12', 342, NULL),
('Cute Mountains Inn', 164, '2019-03-13', 264, NULL),
('Cute Mountains Inn', 164, '2019-03-14', 176, NULL),
('Cute Mountains Inn', 164, '2019-03-15', 212, NULL),
('Cute Mountains Inn', 164, '2019-03-16', 147, NULL),
('Cute Mountains Inn', 164, '2019-03-17', 298, NULL),
('Cute Mountains Inn', 164, '2019-03-18', 300, NULL),
('Cute Mountains Inn', 164, '2019-03-19', 290, NULL),
('Cute Mountains Inn', 164, '2019-03-20', 338, NULL),
('Cute Mountains Inn', 164, '2019-03-21', 390, NULL),
('Cute Mountains Inn', 164, '2019-03-22', 227, NULL),
('Cute Mountains Inn', 164, '2019-03-23', 178, NULL),
('Cute Mountains Inn', 164, '2019-03-24', 259, NULL),
('Cute Mountains Inn', 164, '2019-03-25', 118, NULL),
('Cute Mountains Inn', 164, '2019-03-26', 124, NULL),
('Cute Mountains Inn', 164, '2019-03-27', 217, NULL),
('Cute Mountains Inn', 164, '2019-03-28', 142, NULL),
('Cute Mountains Inn', 164, '2019-03-29', 387, NULL),
('Cute Mountains Inn', 164, '2019-03-30', 223, NULL),
('Cute Mountains Inn', 164, '2019-03-31', 297, NULL),
('Cute Mountains Inn', 164, '2019-04-01', 156, NULL),
('Cute Mountains Inn', 164, '2019-04-02', 187, NULL),
('Cute Mountains Inn', 164, '2019-04-03', 314, NULL),
('Cute Mountains Inn', 164, '2019-04-04', 131, NULL),
('Cute Mountains Inn', 164, '2019-04-05', 174, NULL),
('Cute Mountains Inn', 164, '2019-04-06', 308, NULL),
('Cute Mountains Inn', 164, '2019-04-07', 129, NULL),
('Cute Mountains Inn', 164, '2019-04-08', 221, NULL),
('Cute Mountains Inn', 164, '2019-04-09', 252, NULL),
('Cute Mountains Inn', 164, '2019-04-10', 164, NULL),
('Cute Mountains Inn', 164, '2019-04-11', 301, NULL),
('Cute Mountains Inn', 164, '2019-04-12', 308, NULL),
('Cute Mountains Inn', 164, '2019-04-13', 138, NULL),
('Cute Mountains Inn', 164, '2019-04-14', 286, NULL),
('Cute Mountains Inn', 164, '2019-04-15', 307, NULL),
('Cute Mountains Inn', 164, '2019-04-16', 145, NULL),
('Cute Mountains Inn', 164, '2019-04-17', 384, NULL),
('Cute Mountains Inn', 164, '2019-04-18', 383, NULL),
('Cute Mountains Inn', 164, '2019-04-19', 377, NULL),
('Cute Mountains Inn', 164, '2019-04-20', 222, NULL),
('Cute Mountains Inn', 164, '2019-04-21', 254, NULL),
('Cute Mountains Inn', 164, '2019-04-22', 115, NULL),
('Cute Mountains Inn', 164, '2019-04-23', 139, NULL),
('Cute Mountains Inn', 164, '2019-04-24', 132, NULL),
('Cute Mountains Inn', 164, '2019-04-25', 153, NULL),
('Cute Mountains Inn', 164, '2019-04-26', 108, NULL),
('Cute Mountains Inn', 164, '2019-04-27', 220, NULL),
('Cute Mountains Inn', 164, '2019-04-28', 175, NULL),
('Cute Mountains Inn', 164, '2019-04-29', 398, NULL),
('Cute Mountains Inn', 164, '2019-04-30', 303, NULL),
('Cute Mountains Inn', 164, '2019-05-01', 171, NULL),
('Cute Mountains Inn', 164, '2019-05-02', 107, NULL),
('Cute Mountains Inn', 164, '2019-05-03', 324, NULL),
('Cute Mountains Inn', 164, '2019-05-04', 274, NULL),
('Cute Mountains Inn', 164, '2019-05-05', 325, NULL),
('Cute Mountains Inn', 164, '2019-05-06', 336, NULL),
('Cute Mountains Inn', 164, '2019-05-07', 161, NULL),
('Cute Mountains Inn', 164, '2019-05-08', 305, NULL),
('Cute Mountains Inn', 164, '2019-05-09', 201, NULL),
('Cute Mountains Inn', 164, '2019-05-10', 375, NULL),
('Cute Mountains Inn', 164, '2019-05-11', 163, NULL),
('Cute Mountains Inn', 164, '2019-05-12', 167, NULL),
('Cute Mountains Inn', 164, '2019-05-13', 173, NULL),
('Cute Mountains Inn', 164, '2019-05-14', 289, NULL),
('Cute Mountains Inn', 164, '2019-05-15', 156, NULL),
('Cute Mountains Inn', 164, '2019-05-16', 167, NULL),
('Cute Mountains Inn', 164, '2019-05-17', 117, NULL),
('Cute Mountains Inn', 164, '2019-05-18', 361, NULL),
('Cute Mountains Inn', 164, '2019-05-19', 205, NULL),
('Cute Mountains Inn', 164, '2019-05-20', 394, NULL),
('Cute Mountains Inn', 164, '2019-05-21', 213, NULL),
('Cute Mountains Inn', 164, '2019-05-22', 239, NULL),
('Cute Mountains Inn', 164, '2019-05-23', 339, NULL),
('Cute Mountains Inn', 164, '2019-05-24', 103, NULL),
('Cute Mountains Inn', 164, '2019-05-25', 257, NULL),
('Cute Mountains Inn', 164, '2019-05-26', 332, NULL),
('Cute Mountains Inn', 164, '2019-05-27', 372, NULL),
('Cute Mountains Inn', 164, '2019-05-28', 383, NULL),
('Cute Mountains Inn', 164, '2019-05-29', 139, NULL),
('Cute Mountains Inn', 164, '2019-05-30', 171, NULL),
('Cute Mountains Inn', 164, '2019-05-31', 383, NULL),
('Cute Mountains Inn', 164, '2019-06-01', 194, NULL),
('Cute Mountains Inn', 164, '2019-06-02', 152, NULL),
('Cute Mountains Inn', 164, '2019-06-03', 103, NULL),
('Cute Mountains Inn', 164, '2019-06-04', 324, NULL),
('Cute Mountains Inn', 164, '2019-06-05', 234, NULL),
('Cute Mountains Inn', 164, '2019-06-06', 237, NULL),
('Cute Mountains Inn', 164, '2019-06-07', 281, NULL),
('Cute Mountains Inn', 164, '2019-06-08', 120, NULL),
('Cute Mountains Inn', 164, '2019-06-09', 333, NULL),
('Cute Mountains Inn', 164, '2019-06-10', 284, NULL),
('Cute Mountains Inn', 164, '2019-06-11', 180, NULL),
('Cute Mountains Inn', 164, '2019-06-12', 184, NULL),
('Cute Mountains Inn', 164, '2019-06-13', 215, NULL),
('Cute Mountains Inn', 164, '2019-06-14', 301, NULL),
('Cute Mountains Inn', 164, '2019-06-15', 247, NULL),
('Cute Mountains Inn', 164, '2019-06-16', 122, NULL),
('Cute Mountains Inn', 164, '2019-06-17', 136, NULL),
('Cute Mountains Inn', 164, '2019-06-18', 330, NULL),
('Cute Mountains Inn', 164, '2019-06-19', 366, NULL),
('Cute Mountains Inn', 164, '2019-06-20', 376, NULL),
('Cute Mountains Inn', 164, '2019-06-21', 207, NULL),
('Cute Mountains Inn', 164, '2019-06-22', 252, NULL),
('Cute Mountains Inn', 164, '2019-06-23', 340, NULL),
('Cute Mountains Inn', 164, '2019-06-24', 364, NULL),
('Cute Mountains Inn', 164, '2019-06-25', 332, NULL),
('Cute Mountains Inn', 164, '2019-06-26', 245, NULL),
('Cute Mountains Inn', 164, '2019-06-27', 217, NULL),
('Cute Mountains Inn', 164, '2019-06-28', 279, NULL),
('Cute Mountains Inn', 164, '2019-06-29', 212, NULL),
('Cute Mountains Inn', 164, '2019-06-30', 128, NULL),
('Cute Mountains Inn', 164, '2019-07-01', 244, NULL),
('Cute Mountains Inn', 164, '2019-07-02', 195, NULL),
('Cute Mountains Inn', 164, '2019-07-03', 270, NULL),
('Cute Mountains Inn', 164, '2019-07-04', 344, NULL),
('Cute Mountains Inn', 164, '2019-07-05', 360, NULL),
('Cute Mountains Inn', 164, '2019-07-06', 352, NULL),
('Cute Mountains Inn', 164, '2019-07-07', 127, NULL),
('Cute Mountains Inn', 164, '2019-07-08', 358, NULL),
('Cute Mountains Inn', 164, '2019-07-09', 368, NULL),
('Cute Mountains Inn', 164, '2019-07-10', 173, NULL),
('Cute Mountains Inn', 164, '2019-07-11', 157, NULL),
('Cute Mountains Inn', 164, '2019-07-12', 199, NULL),
('Cute Mountains Inn', 164, '2019-07-13', 188, NULL),
('Cute Mountains Inn', 164, '2019-07-14', 272, NULL),
('Cute Mountains Inn', 164, '2019-07-15', 230, NULL),
('Cute Mountains Inn', 164, '2019-07-16', 366, NULL),
('Cute Mountains Inn', 164, '2019-07-17', 298, NULL),
('Cute Mountains Inn', 164, '2019-07-18', 287, NULL),
('Cute Mountains Inn', 164, '2019-07-19', 189, NULL),
('Cute Mountains Inn', 164, '2019-07-20', 123, NULL),
('Cute Mountains Inn', 164, '2019-07-21', 292, NULL),
('Cute Mountains Inn', 164, '2019-07-22', 294, NULL),
('Cute Mountains Inn', 164, '2019-07-23', 287, NULL),
('Cute Mountains Inn', 164, '2019-07-24', 131, NULL),
('Cute Mountains Inn', 164, '2019-07-25', 395, NULL),
('Cute Mountains Inn', 164, '2019-07-26', 233, NULL),
('Cute Mountains Inn', 164, '2019-07-27', 240, NULL),
('Cute Mountains Inn', 164, '2019-07-28', 342, NULL),
('Cute Mountains Inn', 164, '2019-07-29', 335, NULL),
('Cute Mountains Inn', 164, '2019-07-30', 268, NULL),
('Cute Mountains Inn', 164, '2019-07-31', 273, NULL),
('Cute Mountains Inn', 164, '2019-08-01', 229, NULL),
('Cute Mountains Inn', 164, '2019-08-02', 289, NULL),
('Cute Mountains Inn', 164, '2019-08-03', 203, NULL),
('Cute Mountains Inn', 164, '2019-08-04', 179, NULL),
('Cute Mountains Inn', 164, '2019-08-05', 380, NULL),
('Cute Mountains Inn', 164, '2019-08-06', 179, NULL),
('Cute Mountains Inn', 164, '2019-08-07', 242, NULL),
('Cute Mountains Inn', 164, '2019-08-08', 351, NULL),
('Cute Mountains Inn', 164, '2019-08-09', 358, NULL),
('Cute Mountains Inn', 164, '2019-08-10', 169, NULL),
('Cute Mountains Inn', 164, '2019-08-11', 193, NULL),
('Cute Mountains Inn', 164, '2019-08-12', 131, NULL),
('Cute Mountains Inn', 164, '2019-08-13', 288, NULL),
('Cute Mountains Inn', 164, '2019-08-14', 165, NULL),
('Cute Mountains Inn', 164, '2019-08-15', 286, NULL),
('Cute Mountains Inn', 164, '2019-08-16', 252, NULL),
('Cute Mountains Inn', 164, '2019-08-17', 253, NULL),
('Cute Mountains Inn', 164, '2019-08-18', 143, NULL),
('Cute Mountains Inn', 164, '2019-08-19', 313, NULL),
('Cute Mountains Inn', 164, '2019-08-20', 387, NULL),
('Cute Mountains Inn', 164, '2019-08-21', 291, NULL),
('Cute Mountains Inn', 164, '2019-08-22', 123, NULL),
('Cute Mountains Inn', 164, '2019-08-23', 365, NULL),
('Cute Mountains Inn', 164, '2019-08-24', 191, NULL),
('Cute Mountains Inn', 164, '2019-08-25', 372, NULL),
('Cute Mountains Inn', 164, '2019-08-26', 133, NULL),
('Cute Mountains Inn', 164, '2019-08-27', 245, NULL),
('Cute Mountains Inn', 164, '2019-08-28', 206, NULL),
('Cute Mountains Inn', 164, '2019-08-29', 119, NULL),
('Cute Mountains Inn', 164, '2019-08-30', 196, NULL),
('Cute Mountains Inn', 164, '2019-08-31', 394, NULL),
('Cute Mountains Inn', 164, '2019-09-01', 239, NULL),
('Cute Mountains Inn', 164, '2019-09-02', 308, NULL),
('Cute Mountains Inn', 164, '2019-09-03', 133, NULL),
('Cute Mountains Inn', 164, '2019-09-04', 294, NULL),
('Cute Mountains Inn', 164, '2019-09-05', 243, NULL),
('Cute Mountains Inn', 164, '2019-09-06', 144, NULL),
('Cute Mountains Inn', 164, '2019-09-07', 368, NULL),
('Cute Mountains Inn', 164, '2019-09-08', 252, NULL),
('Cute Mountains Inn', 164, '2019-09-09', 350, NULL),
('Cute Mountains Inn', 164, '2019-09-10', 346, NULL),
('Cute Mountains Inn', 164, '2019-09-11', 341, NULL),
('Cute Mountains Inn', 164, '2019-09-12', 149, NULL),
('Cute Mountains Inn', 164, '2019-09-13', 287, NULL),
('Cute Mountains Inn', 164, '2019-09-14', 238, NULL),
('Cute Mountains Inn', 164, '2019-09-15', 148, NULL),
('Cute Mountains Inn', 164, '2019-09-16', 355, NULL),
('Cute Mountains Inn', 164, '2019-09-17', 135, NULL),
('Cute Mountains Inn', 164, '2019-09-18', 146, NULL),
('Cute Mountains Inn', 164, '2019-09-19', 317, NULL),
('Cute Mountains Inn', 164, '2019-09-20', 226, NULL),
('Cute Mountains Inn', 164, '2019-09-21', 378, NULL),
('Cute Mountains Inn', 164, '2019-09-22', 284, NULL),
('Cute Mountains Inn', 164, '2019-09-23', 398, NULL),
('Cute Mountains Inn', 164, '2019-09-24', 189, NULL),
('Cute Mountains Inn', 164, '2019-09-25', 264, NULL),
('Cute Mountains Inn', 164, '2019-09-26', 276, NULL),
('Cute Mountains Inn', 164, '2019-09-27', 292, NULL),
('Cute Mountains Inn', 164, '2019-09-28', 158, NULL),
('Cute Mountains Inn', 164, '2019-09-29', 328, NULL),
('Cute Mountains Inn', 164, '2019-09-30', 291, NULL),
('Cute Mountains Inn', 164, '2019-10-01', 143, NULL),
('Cute Mountains Inn', 164, '2019-10-02', 233, NULL),
('Cute Mountains Inn', 164, '2019-10-03', 206, NULL),
('Cute Mountains Inn', 164, '2019-10-04', 312, NULL),
('Cute Mountains Inn', 164, '2019-10-05', 167, NULL),
('Cute Mountains Inn', 164, '2019-10-06', 169, NULL),
('Cute Mountains Inn', 164, '2019-10-07', 138, NULL),
('Cute Mountains Inn', 164, '2019-10-08', 116, NULL),
('Cute Mountains Inn', 164, '2019-10-09', 325, NULL),
('Cute Mountains Inn', 164, '2019-10-10', 270, NULL),
('Cute Mountains Inn', 164, '2019-10-11', 289, NULL),
('Cute Mountains Inn', 164, '2019-10-12', 100, NULL),
('Cute Mountains Inn', 164, '2019-10-13', 223, NULL),
('Cute Mountains Inn', 164, '2019-10-14', 267, NULL),
('Cute Mountains Inn', 164, '2019-10-15', 166, NULL),
('Cute Mountains Inn', 164, '2019-10-16', 217, NULL),
('Cute Mountains Inn', 164, '2019-10-17', 345, NULL),
('Cute Mountains Inn', 164, '2019-10-18', 206, NULL),
('Cute Mountains Inn', 164, '2019-10-19', 278, NULL),
('Cute Mountains Inn', 164, '2019-10-20', 187, NULL),
('Cute Mountains Inn', 164, '2019-10-21', 182, NULL),
('Cute Mountains Inn', 164, '2019-10-22', 337, NULL),
('Cute Mountains Inn', 164, '2019-10-23', 305, NULL),
('Cute Mountains Inn', 164, '2019-10-24', 360, NULL),
('Cute Mountains Inn', 164, '2019-10-25', 183, NULL),
('Cute Mountains Inn', 164, '2019-10-26', 221, NULL),
('Cute Mountains Inn', 164, '2019-10-27', 115, NULL),
('Cute Mountains Inn', 164, '2019-10-28', 353, NULL),
('Cute Mountains Inn', 164, '2019-10-29', 222, NULL),
('Cute Mountains Inn', 164, '2019-10-30', 134, NULL),
('Cute Mountains Inn', 164, '2019-10-31', 136, NULL),
('Cute Mountains Inn', 164, '2019-11-01', 222, NULL),
('Cute Mountains Inn', 164, '2019-11-02', 343, NULL),
('Cute Mountains Inn', 164, '2019-11-03', 393, NULL),
('Cute Mountains Inn', 164, '2019-11-04', 162, NULL),
('Cute Mountains Inn', 164, '2019-11-05', 389, NULL),
('Cute Mountains Inn', 164, '2019-11-06', 252, NULL),
('Cute Mountains Inn', 164, '2019-11-07', 347, NULL),
('Cute Mountains Inn', 164, '2019-11-08', 118, NULL),
('Cute Mountains Inn', 164, '2019-11-09', 224, NULL),
('Cute Mountains Inn', 164, '2019-11-10', 218, NULL),
('Cute Mountains Inn', 164, '2019-11-11', 275, NULL),
('Cute Mountains Inn', 164, '2019-11-12', 108, NULL),
('Cute Mountains Inn', 164, '2019-11-13', 228, NULL),
('Cute Mountains Inn', 164, '2019-11-14', 167, NULL),
('Cute Mountains Inn', 164, '2019-11-15', 282, NULL),
('Cute Mountains Inn', 164, '2019-11-16', 162, NULL),
('Cute Mountains Inn', 164, '2019-11-17', 392, NULL),
('Cute Mountains Inn', 164, '2019-11-18', 260, NULL),
('Cute Mountains Inn', 164, '2019-11-19', 333, NULL),
('Cute Mountains Inn', 164, '2019-11-20', 199, NULL),
('Cute Mountains Inn', 164, '2019-11-21', 228, NULL),
('Cute Mountains Inn', 164, '2019-11-22', 200, NULL),
('Cute Mountains Inn', 164, '2019-11-23', 249, NULL),
('Cute Mountains Inn', 164, '2019-11-24', 331, NULL),
('Cute Mountains Inn', 164, '2019-11-25', 219, NULL),
('Cute Mountains Inn', 164, '2019-11-26', 256, NULL),
('Cute Mountains Inn', 164, '2019-11-27', 198, NULL),
('Cute Mountains Inn', 164, '2019-11-28', 194, NULL),
('Cute Mountains Inn', 164, '2019-11-29', 331, NULL),
('Cute Mountains Inn', 164, '2019-11-30', 145, NULL),
('Cute Mountains Inn', 164, '2019-12-01', 372, NULL),
('Cute Mountains Inn', 164, '2019-12-02', 319, NULL),
('Cute Mountains Inn', 164, '2019-12-03', 221, NULL),
('Cute Mountains Inn', 164, '2019-12-04', 195, NULL),
('Cute Mountains Inn', 164, '2019-12-05', 394, NULL),
('Cute Mountains Inn', 164, '2019-12-06', 270, NULL),
('Cute Mountains Inn', 164, '2019-12-07', 121, NULL),
('Cute Mountains Inn', 164, '2019-12-08', 146, NULL),
('Cute Mountains Inn', 164, '2019-12-09', 358, NULL),
('Cute Mountains Inn', 164, '2019-12-10', 357, NULL),
('Cute Mountains Inn', 164, '2019-12-11', 232, NULL),
('Cute Mountains Inn', 164, '2019-12-12', 127, NULL),
('Cute Mountains Inn', 164, '2019-12-13', 212, NULL),
('Cute Mountains Inn', 164, '2019-12-14', 153, NULL),
('Cute Mountains Inn', 164, '2019-12-15', 250, NULL),
('Cute Mountains Inn', 164, '2019-12-16', 283, NULL),
('Cute Mountains Inn', 164, '2019-12-17', 277, NULL),
('Cute Mountains Inn', 164, '2019-12-18', 334, NULL),
('Cute Mountains Inn', 164, '2019-12-19', 362, NULL),
('Cute Mountains Inn', 164, '2019-12-20', 338, NULL),
('Cute Mountains Inn', 164, '2019-12-21', 393, NULL),
('Cute Mountains Inn', 164, '2019-12-22', 212, NULL),
('Cute Mountains Inn', 164, '2019-12-23', 113, NULL),
('Cute Mountains Inn', 164, '2019-12-24', 301, NULL),
('Cute Mountains Inn', 164, '2019-12-25', 338, NULL),
('Cute Mountains Inn', 164, '2019-12-26', 243, NULL),
('Cute Mountains Inn', 164, '2019-12-27', 392, NULL),
('Cute Mountains Inn', 164, '2019-12-28', 358, NULL),
('Cute Mountains Inn', 164, '2019-12-29', 199, NULL),
('Cute Mountains Inn', 164, '2019-12-30', 132, NULL),
('Cute Mountains Inn', 164, '2019-12-31', 121, NULL),
('Cute Mountains Inn', 164, '2020-01-01', 142, NULL),
('Cute Mountains Inn', 164, '2020-01-02', 342, NULL),
('Cute Mountains Inn', 164, '2020-01-03', 315, NULL),
('Cute Mountains Inn', 164, '2020-01-04', 300, NULL),
('Cute Mountains Inn', 164, '2020-01-05', 369, NULL),
('Cute Mountains Inn', 164, '2020-01-06', 119, NULL),
('Cute Mountains Inn', 164, '2020-01-07', 251, NULL),
('Cute Mountains Inn', 164, '2020-01-08', 330, NULL),
('Cute Mountains Inn', 164, '2020-01-09', 201, NULL),
('Cute Mountains Inn', 164, '2020-01-10', 185, NULL),
('Cute Mountains Inn', 164, '2020-01-11', 105, NULL),
('Cute Mountains Inn', 164, '2020-01-12', 188, NULL),
('Cute Mountains Inn', 164, '2020-01-13', 259, NULL),
('Cute Mountains Inn', 164, '2020-01-14', 220, NULL),
('Cute Mountains Inn', 164, '2020-01-15', 328, NULL),
('Cute Mountains Inn', 164, '2020-01-16', 187, NULL),
('Cute Mountains Inn', 164, '2020-01-17', 211, NULL),
('Cute Mountains Inn', 164, '2020-01-18', 191, NULL),
('Cute Mountains Inn', 164, '2020-01-19', 262, NULL),
('Cute Mountains Inn', 164, '2020-01-20', 327, NULL),
('Cute Mountains Inn', 164, '2020-01-21', 240, NULL),
('Cute Mountains Inn', 164, '2020-01-22', 200, NULL),
('Cute Mountains Inn', 164, '2020-01-23', 272, NULL),
('Cute Mountains Inn', 164, '2020-01-24', 330, NULL),
('Cute Mountains Inn', 164, '2020-01-25', 168, NULL),
('Cute Mountains Inn', 164, '2020-01-26', 250, NULL),
('Cute Mountains Inn', 164, '2020-01-27', 235, NULL),
('Cute Mountains Inn', 164, '2020-01-28', 340, NULL),
('Cute Mountains Inn', 164, '2020-01-29', 121, NULL),
('Cute Mountains Inn', 164, '2020-01-30', 347, NULL),
('Cute Mountains Inn', 164, '2020-01-31', 320, NULL),
('Cute Mountains Inn', 164, '2020-02-01', 227, NULL),
('Cute Mountains Inn', 164, '2020-02-02', 227, NULL),
('Cute Mountains Inn', 164, '2020-02-03', 301, NULL),
('Cute Mountains Inn', 164, '2020-02-04', 379, NULL),
('Cute Mountains Inn', 170, '2019-01-01', 321, NULL),
('Cute Mountains Inn', 170, '2019-01-02', 315, NULL),
('Cute Mountains Inn', 170, '2019-01-03', 370, NULL),
('Cute Mountains Inn', 170, '2019-01-04', 366, NULL),
('Cute Mountains Inn', 170, '2019-01-05', 236, NULL),
('Cute Mountains Inn', 170, '2019-01-06', 340, NULL),
('Cute Mountains Inn', 170, '2019-01-07', 224, NULL),
('Cute Mountains Inn', 170, '2019-01-08', 267, NULL),
('Cute Mountains Inn', 170, '2019-01-09', 144, NULL),
('Cute Mountains Inn', 170, '2019-01-10', 319, NULL),
('Cute Mountains Inn', 170, '2019-01-11', 261, NULL),
('Cute Mountains Inn', 170, '2019-01-12', 373, NULL),
('Cute Mountains Inn', 170, '2019-01-13', 146, NULL),
('Cute Mountains Inn', 170, '2019-01-14', 346, NULL),
('Cute Mountains Inn', 170, '2019-01-15', 398, NULL),
('Cute Mountains Inn', 170, '2019-01-16', 134, NULL),
('Cute Mountains Inn', 170, '2019-01-17', 110, NULL),
('Cute Mountains Inn', 170, '2019-01-18', 188, NULL),
('Cute Mountains Inn', 170, '2019-01-19', 108, NULL),
('Cute Mountains Inn', 170, '2019-01-20', 368, NULL),
('Cute Mountains Inn', 170, '2019-01-21', 316, NULL),
('Cute Mountains Inn', 170, '2019-01-22', 338, NULL),
('Cute Mountains Inn', 170, '2019-01-23', 342, NULL),
('Cute Mountains Inn', 170, '2019-01-24', 135, NULL),
('Cute Mountains Inn', 170, '2019-01-25', 259, NULL),
('Cute Mountains Inn', 170, '2019-01-26', 156, NULL),
('Cute Mountains Inn', 170, '2019-01-27', 337, NULL),
('Cute Mountains Inn', 170, '2019-01-28', 153, NULL),
('Cute Mountains Inn', 170, '2019-01-29', 192, NULL),
('Cute Mountains Inn', 170, '2019-01-30', 337, NULL),
('Cute Mountains Inn', 170, '2019-01-31', 266, NULL),
('Cute Mountains Inn', 170, '2019-02-01', 351, NULL),
('Cute Mountains Inn', 170, '2019-02-02', 211, NULL),
('Cute Mountains Inn', 170, '2019-02-03', 230, NULL),
('Cute Mountains Inn', 170, '2019-02-04', 142, NULL),
('Cute Mountains Inn', 170, '2019-02-05', 130, NULL),
('Cute Mountains Inn', 170, '2019-02-06', 211, NULL),
('Cute Mountains Inn', 170, '2019-02-07', 267, NULL),
('Cute Mountains Inn', 170, '2019-02-08', 304, NULL),
('Cute Mountains Inn', 170, '2019-02-09', 121, NULL),
('Cute Mountains Inn', 170, '2019-02-10', 303, NULL),
('Cute Mountains Inn', 170, '2019-02-11', 209, NULL),
('Cute Mountains Inn', 170, '2019-02-12', 184, NULL),
('Cute Mountains Inn', 170, '2019-02-13', 216, NULL),
('Cute Mountains Inn', 170, '2019-02-14', 274, NULL),
('Cute Mountains Inn', 170, '2019-02-15', 352, NULL),
('Cute Mountains Inn', 170, '2019-02-16', 304, NULL),
('Cute Mountains Inn', 170, '2019-02-17', 193, NULL),
('Cute Mountains Inn', 170, '2019-02-18', 223, NULL),
('Cute Mountains Inn', 170, '2019-02-19', 214, NULL),
('Cute Mountains Inn', 170, '2019-02-20', 135, NULL),
('Cute Mountains Inn', 170, '2019-02-21', 189, NULL),
('Cute Mountains Inn', 170, '2019-02-22', 196, NULL),
('Cute Mountains Inn', 170, '2019-02-23', 325, NULL),
('Cute Mountains Inn', 170, '2019-02-24', 302, NULL),
('Cute Mountains Inn', 170, '2019-02-25', 304, NULL),
('Cute Mountains Inn', 170, '2019-02-26', 306, NULL),
('Cute Mountains Inn', 170, '2019-02-27', 129, NULL),
('Cute Mountains Inn', 170, '2019-02-28', 131, NULL),
('Cute Mountains Inn', 170, '2019-03-01', 193, NULL),
('Cute Mountains Inn', 170, '2019-03-02', 140, NULL),
('Cute Mountains Inn', 170, '2019-03-03', 116, NULL),
('Cute Mountains Inn', 170, '2019-03-04', 272, NULL),
('Cute Mountains Inn', 170, '2019-03-05', 322, NULL),
('Cute Mountains Inn', 170, '2019-03-06', 165, NULL),
('Cute Mountains Inn', 170, '2019-03-07', 260, NULL),
('Cute Mountains Inn', 170, '2019-03-08', 144, NULL),
('Cute Mountains Inn', 170, '2019-03-09', 166, NULL),
('Cute Mountains Inn', 170, '2019-03-10', 143, NULL),
('Cute Mountains Inn', 170, '2019-03-11', 348, NULL),
('Cute Mountains Inn', 170, '2019-03-12', 111, NULL),
('Cute Mountains Inn', 170, '2019-03-13', 116, NULL),
('Cute Mountains Inn', 170, '2019-03-14', 296, NULL),
('Cute Mountains Inn', 170, '2019-03-15', 160, NULL),
('Cute Mountains Inn', 170, '2019-03-16', 293, NULL),
('Cute Mountains Inn', 170, '2019-03-17', 212, NULL),
('Cute Mountains Inn', 170, '2019-03-18', 197, NULL),
('Cute Mountains Inn', 170, '2019-03-19', 344, NULL),
('Cute Mountains Inn', 170, '2019-03-20', 362, NULL),
('Cute Mountains Inn', 170, '2019-03-21', 177, NULL),
('Cute Mountains Inn', 170, '2019-03-22', 130, NULL),
('Cute Mountains Inn', 170, '2019-03-23', 333, NULL),
('Cute Mountains Inn', 170, '2019-03-24', 121, NULL),
('Cute Mountains Inn', 170, '2019-03-25', 162, NULL),
('Cute Mountains Inn', 170, '2019-03-26', 107, NULL),
('Cute Mountains Inn', 170, '2019-03-27', 107, NULL),
('Cute Mountains Inn', 170, '2019-03-28', 103, NULL),
('Cute Mountains Inn', 170, '2019-03-29', 261, NULL),
('Cute Mountains Inn', 170, '2019-03-30', 249, NULL),
('Cute Mountains Inn', 170, '2019-03-31', 122, NULL),
('Cute Mountains Inn', 170, '2019-04-01', 207, NULL),
('Cute Mountains Inn', 170, '2019-04-02', 350, NULL),
('Cute Mountains Inn', 170, '2019-04-03', 370, NULL),
('Cute Mountains Inn', 170, '2019-04-04', 271, NULL),
('Cute Mountains Inn', 170, '2019-04-05', 107, NULL),
('Cute Mountains Inn', 170, '2019-04-06', 360, NULL),
('Cute Mountains Inn', 170, '2019-04-07', 257, NULL),
('Cute Mountains Inn', 170, '2019-04-08', 298, NULL),
('Cute Mountains Inn', 170, '2019-04-09', 133, NULL),
('Cute Mountains Inn', 170, '2019-04-10', 312, NULL),
('Cute Mountains Inn', 170, '2019-04-11', 157, NULL),
('Cute Mountains Inn', 170, '2019-04-12', 207, NULL),
('Cute Mountains Inn', 170, '2019-04-13', 388, NULL),
('Cute Mountains Inn', 170, '2019-04-14', 279, NULL),
('Cute Mountains Inn', 170, '2019-04-15', 221, NULL),
('Cute Mountains Inn', 170, '2019-04-16', 221, NULL),
('Cute Mountains Inn', 170, '2019-04-17', 317, NULL),
('Cute Mountains Inn', 170, '2019-04-18', 256, NULL),
('Cute Mountains Inn', 170, '2019-04-19', 292, NULL),
('Cute Mountains Inn', 170, '2019-04-20', 114, NULL),
('Cute Mountains Inn', 170, '2019-04-21', 373, NULL),
('Cute Mountains Inn', 170, '2019-04-22', 166, NULL),
('Cute Mountains Inn', 170, '2019-04-23', 264, NULL),
('Cute Mountains Inn', 170, '2019-04-24', 254, NULL),
('Cute Mountains Inn', 170, '2019-04-25', 157, NULL),
('Cute Mountains Inn', 170, '2019-04-26', 115, NULL),
('Cute Mountains Inn', 170, '2019-04-27', 142, NULL),
('Cute Mountains Inn', 170, '2019-04-28', 115, NULL),
('Cute Mountains Inn', 170, '2019-04-29', 318, NULL),
('Cute Mountains Inn', 170, '2019-04-30', 292, NULL),
('Cute Mountains Inn', 170, '2019-05-01', 174, NULL),
('Cute Mountains Inn', 170, '2019-05-02', 211, NULL),
('Cute Mountains Inn', 170, '2019-05-03', 116, NULL),
('Cute Mountains Inn', 170, '2019-05-04', 174, NULL),
('Cute Mountains Inn', 170, '2019-05-05', 235, NULL),
('Cute Mountains Inn', 170, '2019-05-06', 216, NULL),
('Cute Mountains Inn', 170, '2019-05-07', 167, NULL),
('Cute Mountains Inn', 170, '2019-05-08', 355, NULL),
('Cute Mountains Inn', 170, '2019-05-09', 245, NULL),
('Cute Mountains Inn', 170, '2019-05-10', 331, NULL),
('Cute Mountains Inn', 170, '2019-05-11', 252, NULL),
('Cute Mountains Inn', 170, '2019-05-12', 398, NULL),
('Cute Mountains Inn', 170, '2019-05-13', 171, NULL),
('Cute Mountains Inn', 170, '2019-05-14', 249, NULL),
('Cute Mountains Inn', 170, '2019-05-15', 374, NULL),
('Cute Mountains Inn', 170, '2019-05-16', 205, NULL),
('Cute Mountains Inn', 170, '2019-05-17', 202, NULL),
('Cute Mountains Inn', 170, '2019-05-18', 223, NULL),
('Cute Mountains Inn', 170, '2019-05-19', 340, NULL),
('Cute Mountains Inn', 170, '2019-05-20', 356, NULL),
('Cute Mountains Inn', 170, '2019-05-21', 251, NULL),
('Cute Mountains Inn', 170, '2019-05-22', 287, NULL),
('Cute Mountains Inn', 170, '2019-05-23', 273, NULL),
('Cute Mountains Inn', 170, '2019-05-24', 196, NULL),
('Cute Mountains Inn', 170, '2019-05-25', 132, NULL),
('Cute Mountains Inn', 170, '2019-05-26', 322, NULL),
('Cute Mountains Inn', 170, '2019-05-27', 178, NULL),
('Cute Mountains Inn', 170, '2019-05-28', 115, NULL),
('Cute Mountains Inn', 170, '2019-05-29', 182, NULL),
('Cute Mountains Inn', 170, '2019-05-30', 252, NULL),
('Cute Mountains Inn', 170, '2019-05-31', 315, NULL),
('Cute Mountains Inn', 170, '2019-06-01', 132, NULL),
('Cute Mountains Inn', 170, '2019-06-02', 105, NULL),
('Cute Mountains Inn', 170, '2019-06-03', 227, NULL),
('Cute Mountains Inn', 170, '2019-06-04', 121, NULL),
('Cute Mountains Inn', 170, '2019-06-05', 137, NULL),
('Cute Mountains Inn', 170, '2019-06-06', 379, NULL),
('Cute Mountains Inn', 170, '2019-06-07', 249, NULL),
('Cute Mountains Inn', 170, '2019-06-08', 310, NULL),
('Cute Mountains Inn', 170, '2019-06-09', 297, NULL),
('Cute Mountains Inn', 170, '2019-06-10', 105, NULL),
('Cute Mountains Inn', 170, '2019-06-11', 144, NULL),
('Cute Mountains Inn', 170, '2019-06-12', 110, NULL),
('Cute Mountains Inn', 170, '2019-06-13', 395, NULL),
('Cute Mountains Inn', 170, '2019-06-14', 160, NULL),
('Cute Mountains Inn', 170, '2019-06-15', 271, NULL),
('Cute Mountains Inn', 170, '2019-06-16', 362, NULL),
('Cute Mountains Inn', 170, '2019-06-17', 221, NULL),
('Cute Mountains Inn', 170, '2019-06-18', 120, NULL),
('Cute Mountains Inn', 170, '2019-06-19', 208, NULL),
('Cute Mountains Inn', 170, '2019-06-20', 100, NULL),
('Cute Mountains Inn', 170, '2019-06-21', 128, NULL),
('Cute Mountains Inn', 170, '2019-06-22', 282, NULL),
('Cute Mountains Inn', 170, '2019-06-23', 347, NULL),
('Cute Mountains Inn', 170, '2019-06-24', 361, NULL),
('Cute Mountains Inn', 170, '2019-06-25', 209, NULL),
('Cute Mountains Inn', 170, '2019-06-26', 331, NULL),
('Cute Mountains Inn', 170, '2019-06-27', 308, NULL),
('Cute Mountains Inn', 170, '2019-06-28', 248, NULL),
('Cute Mountains Inn', 170, '2019-06-29', 292, NULL),
('Cute Mountains Inn', 170, '2019-06-30', 147, NULL),
('Cute Mountains Inn', 170, '2019-07-01', 117, NULL),
('Cute Mountains Inn', 170, '2019-07-02', 313, NULL),
('Cute Mountains Inn', 170, '2019-07-03', 388, NULL),
('Cute Mountains Inn', 170, '2019-07-04', 392, NULL),
('Cute Mountains Inn', 170, '2019-07-05', 224, NULL),
('Cute Mountains Inn', 170, '2019-07-06', 195, NULL),
('Cute Mountains Inn', 170, '2019-07-07', 266, NULL),
('Cute Mountains Inn', 170, '2019-07-08', 107, NULL),
('Cute Mountains Inn', 170, '2019-07-09', 395, NULL),
('Cute Mountains Inn', 170, '2019-07-10', 124, NULL),
('Cute Mountains Inn', 170, '2019-07-11', 325, NULL),
('Cute Mountains Inn', 170, '2019-07-12', 371, NULL),
('Cute Mountains Inn', 170, '2019-07-13', 379, NULL),
('Cute Mountains Inn', 170, '2019-07-14', 192, NULL),
('Cute Mountains Inn', 170, '2019-07-15', 155, NULL),
('Cute Mountains Inn', 170, '2019-07-16', 255, NULL),
('Cute Mountains Inn', 170, '2019-07-17', 347, NULL),
('Cute Mountains Inn', 170, '2019-07-18', 160, NULL),
('Cute Mountains Inn', 170, '2019-07-19', 166, NULL),
('Cute Mountains Inn', 170, '2019-07-20', 266, NULL),
('Cute Mountains Inn', 170, '2019-07-21', 157, NULL),
('Cute Mountains Inn', 170, '2019-07-22', 145, NULL),
('Cute Mountains Inn', 170, '2019-07-23', 379, NULL),
('Cute Mountains Inn', 170, '2019-07-24', 166, NULL),
('Cute Mountains Inn', 170, '2019-07-25', 178, NULL),
('Cute Mountains Inn', 170, '2019-07-26', 218, NULL),
('Cute Mountains Inn', 170, '2019-07-27', 373, NULL),
('Cute Mountains Inn', 170, '2019-07-28', 314, NULL),
('Cute Mountains Inn', 170, '2019-07-29', 268, NULL),
('Cute Mountains Inn', 170, '2019-07-30', 256, NULL),
('Cute Mountains Inn', 170, '2019-07-31', 337, NULL),
('Cute Mountains Inn', 170, '2019-08-01', 141, NULL),
('Cute Mountains Inn', 170, '2019-08-02', 382, NULL),
('Cute Mountains Inn', 170, '2019-08-03', 207, NULL),
('Cute Mountains Inn', 170, '2019-08-04', 203, NULL),
('Cute Mountains Inn', 170, '2019-08-05', 353, NULL),
('Cute Mountains Inn', 170, '2019-08-06', 279, NULL),
('Cute Mountains Inn', 170, '2019-08-07', 145, NULL),
('Cute Mountains Inn', 170, '2019-08-08', 281, NULL),
('Cute Mountains Inn', 170, '2019-08-09', 276, NULL),
('Cute Mountains Inn', 170, '2019-08-10', 389, NULL),
('Cute Mountains Inn', 170, '2019-08-11', 388, NULL),
('Cute Mountains Inn', 170, '2019-08-12', 289, NULL),
('Cute Mountains Inn', 170, '2019-08-13', 314, NULL),
('Cute Mountains Inn', 170, '2019-08-14', 361, NULL),
('Cute Mountains Inn', 170, '2019-08-15', 357, NULL),
('Cute Mountains Inn', 170, '2019-08-16', 191, NULL),
('Cute Mountains Inn', 170, '2019-08-17', 225, NULL),
('Cute Mountains Inn', 170, '2019-08-18', 367, NULL),
('Cute Mountains Inn', 170, '2019-08-19', 130, NULL),
('Cute Mountains Inn', 170, '2019-08-20', 309, NULL),
('Cute Mountains Inn', 170, '2019-08-21', 161, NULL),
('Cute Mountains Inn', 170, '2019-08-22', 106, NULL),
('Cute Mountains Inn', 170, '2019-08-23', 356, NULL),
('Cute Mountains Inn', 170, '2019-08-24', 384, NULL),
('Cute Mountains Inn', 170, '2019-08-25', 315, NULL),
('Cute Mountains Inn', 170, '2019-08-26', 281, NULL),
('Cute Mountains Inn', 170, '2019-08-27', 119, NULL),
('Cute Mountains Inn', 170, '2019-08-28', 197, NULL),
('Cute Mountains Inn', 170, '2019-08-29', 142, NULL),
('Cute Mountains Inn', 170, '2019-08-30', 387, NULL),
('Cute Mountains Inn', 170, '2019-08-31', 124, NULL),
('Cute Mountains Inn', 170, '2019-09-01', 209, NULL),
('Cute Mountains Inn', 170, '2019-09-02', 112, NULL),
('Cute Mountains Inn', 170, '2019-09-03', 342, NULL),
('Cute Mountains Inn', 170, '2019-09-04', 316, NULL),
('Cute Mountains Inn', 170, '2019-09-05', 154, NULL),
('Cute Mountains Inn', 170, '2019-09-06', 338, NULL),
('Cute Mountains Inn', 170, '2019-09-07', 245, NULL),
('Cute Mountains Inn', 170, '2019-09-08', 196, NULL),
('Cute Mountains Inn', 170, '2019-09-09', 267, NULL),
('Cute Mountains Inn', 170, '2019-09-10', 184, NULL),
('Cute Mountains Inn', 170, '2019-09-11', 174, NULL),
('Cute Mountains Inn', 170, '2019-09-12', 142, NULL),
('Cute Mountains Inn', 170, '2019-09-13', 227, NULL),
('Cute Mountains Inn', 170, '2019-09-14', 170, NULL),
('Cute Mountains Inn', 170, '2019-09-15', 349, NULL),
('Cute Mountains Inn', 170, '2019-09-16', 248, NULL),
('Cute Mountains Inn', 170, '2019-09-17', 265, NULL),
('Cute Mountains Inn', 170, '2019-09-18', 189, NULL),
('Cute Mountains Inn', 170, '2019-09-19', 123, NULL),
('Cute Mountains Inn', 170, '2019-09-20', 331, NULL),
('Cute Mountains Inn', 170, '2019-09-21', 119, NULL),
('Cute Mountains Inn', 170, '2019-09-22', 275, NULL),
('Cute Mountains Inn', 170, '2019-09-23', 330, NULL),
('Cute Mountains Inn', 170, '2019-09-24', 376, NULL),
('Cute Mountains Inn', 170, '2019-09-25', 294, NULL),
('Cute Mountains Inn', 170, '2019-09-26', 246, NULL),
('Cute Mountains Inn', 170, '2019-09-27', 388, NULL),
('Cute Mountains Inn', 170, '2019-09-28', 372, NULL),
('Cute Mountains Inn', 170, '2019-09-29', 305, NULL),
('Cute Mountains Inn', 170, '2019-09-30', 337, NULL),
('Cute Mountains Inn', 170, '2019-10-01', 395, NULL),
('Cute Mountains Inn', 170, '2019-10-02', 356, NULL),
('Cute Mountains Inn', 170, '2019-10-03', 152, NULL),
('Cute Mountains Inn', 170, '2019-10-04', 291, NULL),
('Cute Mountains Inn', 170, '2019-10-05', 250, NULL),
('Cute Mountains Inn', 170, '2019-10-06', 247, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 170, '2019-10-07', 163, NULL),
('Cute Mountains Inn', 170, '2019-10-08', 328, NULL),
('Cute Mountains Inn', 170, '2019-10-09', 158, NULL),
('Cute Mountains Inn', 170, '2019-10-10', 366, NULL),
('Cute Mountains Inn', 170, '2019-10-11', 339, NULL),
('Cute Mountains Inn', 170, '2019-10-12', 199, NULL),
('Cute Mountains Inn', 170, '2019-10-13', 142, NULL),
('Cute Mountains Inn', 170, '2019-10-14', 370, NULL),
('Cute Mountains Inn', 170, '2019-10-15', 119, NULL),
('Cute Mountains Inn', 170, '2019-10-16', 353, NULL),
('Cute Mountains Inn', 170, '2019-10-17', 197, NULL),
('Cute Mountains Inn', 170, '2019-10-18', 141, NULL),
('Cute Mountains Inn', 170, '2019-10-19', 260, NULL),
('Cute Mountains Inn', 170, '2019-10-20', 187, NULL),
('Cute Mountains Inn', 170, '2019-10-21', 301, NULL),
('Cute Mountains Inn', 170, '2019-10-22', 195, NULL),
('Cute Mountains Inn', 170, '2019-10-23', 328, NULL),
('Cute Mountains Inn', 170, '2019-10-24', 194, NULL),
('Cute Mountains Inn', 170, '2019-10-25', 315, NULL),
('Cute Mountains Inn', 170, '2019-10-26', 167, NULL),
('Cute Mountains Inn', 170, '2019-10-27', 357, NULL),
('Cute Mountains Inn', 170, '2019-10-28', 275, NULL),
('Cute Mountains Inn', 170, '2019-10-29', 215, NULL),
('Cute Mountains Inn', 170, '2019-10-30', 111, NULL),
('Cute Mountains Inn', 170, '2019-10-31', 273, NULL),
('Cute Mountains Inn', 170, '2019-11-01', 106, NULL),
('Cute Mountains Inn', 170, '2019-11-02', 207, NULL),
('Cute Mountains Inn', 170, '2019-11-03', 241, NULL),
('Cute Mountains Inn', 170, '2019-11-04', 270, NULL),
('Cute Mountains Inn', 170, '2019-11-05', 188, NULL),
('Cute Mountains Inn', 170, '2019-11-06', 257, NULL),
('Cute Mountains Inn', 170, '2019-11-07', 139, NULL),
('Cute Mountains Inn', 170, '2019-11-08', 285, NULL),
('Cute Mountains Inn', 170, '2019-11-09', 142, NULL),
('Cute Mountains Inn', 170, '2019-11-10', 177, NULL),
('Cute Mountains Inn', 170, '2019-11-11', 187, NULL),
('Cute Mountains Inn', 170, '2019-11-12', 307, NULL),
('Cute Mountains Inn', 170, '2019-11-13', 197, NULL),
('Cute Mountains Inn', 170, '2019-11-14', 263, NULL),
('Cute Mountains Inn', 170, '2019-11-15', 344, NULL),
('Cute Mountains Inn', 170, '2019-11-16', 195, NULL),
('Cute Mountains Inn', 170, '2019-11-17', 162, NULL),
('Cute Mountains Inn', 170, '2019-11-18', 304, NULL),
('Cute Mountains Inn', 170, '2019-11-19', 393, NULL),
('Cute Mountains Inn', 170, '2019-11-20', 149, NULL),
('Cute Mountains Inn', 170, '2019-11-21', 195, NULL),
('Cute Mountains Inn', 170, '2019-11-22', 120, NULL),
('Cute Mountains Inn', 170, '2019-11-23', 110, NULL),
('Cute Mountains Inn', 170, '2019-11-24', 324, NULL),
('Cute Mountains Inn', 170, '2019-11-25', 180, NULL),
('Cute Mountains Inn', 170, '2019-11-26', 378, NULL),
('Cute Mountains Inn', 170, '2019-11-27', 141, NULL),
('Cute Mountains Inn', 170, '2019-11-28', 115, NULL),
('Cute Mountains Inn', 170, '2019-11-29', 206, NULL),
('Cute Mountains Inn', 170, '2019-11-30', 253, NULL),
('Cute Mountains Inn', 170, '2019-12-01', 281, NULL),
('Cute Mountains Inn', 170, '2019-12-02', 276, NULL),
('Cute Mountains Inn', 170, '2019-12-03', 193, NULL),
('Cute Mountains Inn', 170, '2019-12-04', 137, NULL),
('Cute Mountains Inn', 170, '2019-12-05', 149, NULL),
('Cute Mountains Inn', 170, '2019-12-06', 397, NULL),
('Cute Mountains Inn', 170, '2019-12-07', 248, NULL),
('Cute Mountains Inn', 170, '2019-12-08', 362, NULL),
('Cute Mountains Inn', 170, '2019-12-09', 139, NULL),
('Cute Mountains Inn', 170, '2019-12-10', 371, NULL),
('Cute Mountains Inn', 170, '2019-12-11', 214, NULL),
('Cute Mountains Inn', 170, '2019-12-12', 195, NULL),
('Cute Mountains Inn', 170, '2019-12-13', 281, NULL),
('Cute Mountains Inn', 170, '2019-12-14', 276, NULL),
('Cute Mountains Inn', 170, '2019-12-15', 324, NULL),
('Cute Mountains Inn', 170, '2019-12-16', 346, NULL),
('Cute Mountains Inn', 170, '2019-12-17', 362, NULL),
('Cute Mountains Inn', 170, '2019-12-18', 287, NULL),
('Cute Mountains Inn', 170, '2019-12-19', 197, NULL),
('Cute Mountains Inn', 170, '2019-12-20', 136, NULL),
('Cute Mountains Inn', 170, '2019-12-21', 137, NULL),
('Cute Mountains Inn', 170, '2019-12-22', 281, NULL),
('Cute Mountains Inn', 170, '2019-12-23', 115, NULL),
('Cute Mountains Inn', 170, '2019-12-24', 374, NULL),
('Cute Mountains Inn', 170, '2019-12-25', 181, NULL),
('Cute Mountains Inn', 170, '2019-12-26', 382, NULL),
('Cute Mountains Inn', 170, '2019-12-27', 213, NULL),
('Cute Mountains Inn', 170, '2019-12-28', 329, NULL),
('Cute Mountains Inn', 170, '2019-12-29', 277, NULL),
('Cute Mountains Inn', 170, '2019-12-30', 259, NULL),
('Cute Mountains Inn', 170, '2019-12-31', 287, NULL),
('Cute Mountains Inn', 170, '2020-01-01', 361, NULL),
('Cute Mountains Inn', 170, '2020-01-02', 347, NULL),
('Cute Mountains Inn', 170, '2020-01-03', 324, NULL),
('Cute Mountains Inn', 170, '2020-01-04', 254, NULL),
('Cute Mountains Inn', 170, '2020-01-05', 284, NULL),
('Cute Mountains Inn', 170, '2020-01-06', 315, NULL),
('Cute Mountains Inn', 170, '2020-01-07', 388, NULL),
('Cute Mountains Inn', 170, '2020-01-08', 119, NULL),
('Cute Mountains Inn', 170, '2020-01-09', 114, NULL),
('Cute Mountains Inn', 170, '2020-01-10', 383, NULL),
('Cute Mountains Inn', 170, '2020-01-11', 151, NULL),
('Cute Mountains Inn', 170, '2020-01-12', 122, NULL),
('Cute Mountains Inn', 170, '2020-01-13', 393, NULL),
('Cute Mountains Inn', 170, '2020-01-14', 367, NULL),
('Cute Mountains Inn', 170, '2020-01-15', 155, NULL),
('Cute Mountains Inn', 170, '2020-01-16', 163, NULL),
('Cute Mountains Inn', 170, '2020-01-17', 369, NULL),
('Cute Mountains Inn', 170, '2020-01-18', 136, NULL),
('Cute Mountains Inn', 170, '2020-01-19', 334, NULL),
('Cute Mountains Inn', 170, '2020-01-20', 230, NULL),
('Cute Mountains Inn', 170, '2020-01-21', 233, NULL),
('Cute Mountains Inn', 170, '2020-01-22', 191, NULL),
('Cute Mountains Inn', 170, '2020-01-23', 225, NULL),
('Cute Mountains Inn', 170, '2020-01-24', 288, NULL),
('Cute Mountains Inn', 170, '2020-01-25', 331, NULL),
('Cute Mountains Inn', 170, '2020-01-26', 246, NULL),
('Cute Mountains Inn', 170, '2020-01-27', 216, NULL),
('Cute Mountains Inn', 170, '2020-01-28', 119, NULL),
('Cute Mountains Inn', 170, '2020-01-29', 126, NULL),
('Cute Mountains Inn', 170, '2020-01-30', 365, NULL),
('Cute Mountains Inn', 170, '2020-01-31', 252, NULL),
('Cute Mountains Inn', 170, '2020-02-01', 333, NULL),
('Cute Mountains Inn', 170, '2020-02-02', 371, NULL),
('Cute Mountains Inn', 170, '2020-02-03', 136, NULL),
('Cute Mountains Inn', 170, '2020-02-04', 204, NULL),
('Cute Mountains Inn', 201, '2019-01-01', 253, NULL),
('Cute Mountains Inn', 201, '2019-01-02', 253, NULL),
('Cute Mountains Inn', 201, '2019-01-03', 152, NULL),
('Cute Mountains Inn', 201, '2019-01-04', 207, NULL),
('Cute Mountains Inn', 201, '2019-01-05', 109, NULL),
('Cute Mountains Inn', 201, '2019-01-06', 199, NULL),
('Cute Mountains Inn', 201, '2019-01-07', 114, NULL),
('Cute Mountains Inn', 201, '2019-01-08', 346, NULL),
('Cute Mountains Inn', 201, '2019-01-09', 174, NULL),
('Cute Mountains Inn', 201, '2019-01-10', 228, NULL),
('Cute Mountains Inn', 201, '2019-01-11', 181, NULL),
('Cute Mountains Inn', 201, '2019-01-12', 353, NULL),
('Cute Mountains Inn', 201, '2019-01-13', 222, NULL),
('Cute Mountains Inn', 201, '2019-01-14', 394, NULL),
('Cute Mountains Inn', 201, '2019-01-15', 186, NULL),
('Cute Mountains Inn', 201, '2019-01-16', 163, NULL),
('Cute Mountains Inn', 201, '2019-01-17', 374, NULL),
('Cute Mountains Inn', 201, '2019-01-18', 201, NULL),
('Cute Mountains Inn', 201, '2019-01-19', 301, NULL),
('Cute Mountains Inn', 201, '2019-01-20', 175, NULL),
('Cute Mountains Inn', 201, '2019-01-21', 143, NULL),
('Cute Mountains Inn', 201, '2019-01-22', 228, NULL),
('Cute Mountains Inn', 201, '2019-01-23', 395, NULL),
('Cute Mountains Inn', 201, '2019-01-24', 139, NULL),
('Cute Mountains Inn', 201, '2019-01-25', 264, NULL),
('Cute Mountains Inn', 201, '2019-01-26', 152, NULL),
('Cute Mountains Inn', 201, '2019-01-27', 103, NULL),
('Cute Mountains Inn', 201, '2019-01-28', 265, NULL),
('Cute Mountains Inn', 201, '2019-01-29', 105, NULL),
('Cute Mountains Inn', 201, '2019-01-30', 379, NULL),
('Cute Mountains Inn', 201, '2019-01-31', 160, NULL),
('Cute Mountains Inn', 201, '2019-02-01', 239, NULL),
('Cute Mountains Inn', 201, '2019-02-02', 363, NULL),
('Cute Mountains Inn', 201, '2019-02-03', 355, NULL),
('Cute Mountains Inn', 201, '2019-02-04', 350, NULL),
('Cute Mountains Inn', 201, '2019-02-05', 313, NULL),
('Cute Mountains Inn', 201, '2019-02-06', 191, NULL),
('Cute Mountains Inn', 201, '2019-02-07', 389, NULL),
('Cute Mountains Inn', 201, '2019-02-08', 326, NULL),
('Cute Mountains Inn', 201, '2019-02-09', 340, NULL),
('Cute Mountains Inn', 201, '2019-02-10', 159, NULL),
('Cute Mountains Inn', 201, '2019-02-11', 236, NULL),
('Cute Mountains Inn', 201, '2019-02-12', 314, NULL),
('Cute Mountains Inn', 201, '2019-02-13', 217, NULL),
('Cute Mountains Inn', 201, '2019-02-14', 149, NULL),
('Cute Mountains Inn', 201, '2019-02-15', 198, NULL),
('Cute Mountains Inn', 201, '2019-02-16', 336, NULL),
('Cute Mountains Inn', 201, '2019-02-17', 264, NULL),
('Cute Mountains Inn', 201, '2019-02-18', 272, NULL),
('Cute Mountains Inn', 201, '2019-02-19', 230, NULL),
('Cute Mountains Inn', 201, '2019-02-20', 144, NULL),
('Cute Mountains Inn', 201, '2019-02-21', 384, NULL),
('Cute Mountains Inn', 201, '2019-02-22', 365, NULL),
('Cute Mountains Inn', 201, '2019-02-23', 284, NULL),
('Cute Mountains Inn', 201, '2019-02-24', 340, NULL),
('Cute Mountains Inn', 201, '2019-02-25', 169, NULL),
('Cute Mountains Inn', 201, '2019-02-26', 365, NULL),
('Cute Mountains Inn', 201, '2019-02-27', 300, NULL),
('Cute Mountains Inn', 201, '2019-02-28', 132, NULL),
('Cute Mountains Inn', 201, '2019-03-01', 185, NULL),
('Cute Mountains Inn', 201, '2019-03-02', 325, NULL),
('Cute Mountains Inn', 201, '2019-03-03', 101, NULL),
('Cute Mountains Inn', 201, '2019-03-04', 186, NULL),
('Cute Mountains Inn', 201, '2019-03-05', 203, NULL),
('Cute Mountains Inn', 201, '2019-03-06', 190, NULL),
('Cute Mountains Inn', 201, '2019-03-07', 136, NULL),
('Cute Mountains Inn', 201, '2019-03-08', 163, NULL),
('Cute Mountains Inn', 201, '2019-03-09', 331, NULL),
('Cute Mountains Inn', 201, '2019-03-10', 250, NULL),
('Cute Mountains Inn', 201, '2019-03-11', 231, NULL),
('Cute Mountains Inn', 201, '2019-03-12', 331, NULL),
('Cute Mountains Inn', 201, '2019-03-13', 288, NULL),
('Cute Mountains Inn', 201, '2019-03-14', 256, NULL),
('Cute Mountains Inn', 201, '2019-03-15', 365, NULL),
('Cute Mountains Inn', 201, '2019-03-16', 324, NULL),
('Cute Mountains Inn', 201, '2019-03-17', 364, NULL),
('Cute Mountains Inn', 201, '2019-03-18', 286, NULL),
('Cute Mountains Inn', 201, '2019-03-19', 149, NULL),
('Cute Mountains Inn', 201, '2019-03-20', 396, NULL),
('Cute Mountains Inn', 201, '2019-03-21', 215, NULL),
('Cute Mountains Inn', 201, '2019-03-22', 173, NULL),
('Cute Mountains Inn', 201, '2019-03-23', 133, NULL),
('Cute Mountains Inn', 201, '2019-03-24', 327, NULL),
('Cute Mountains Inn', 201, '2019-03-25', 357, NULL),
('Cute Mountains Inn', 201, '2019-03-26', 363, NULL),
('Cute Mountains Inn', 201, '2019-03-27', 385, NULL),
('Cute Mountains Inn', 201, '2019-03-28', 292, NULL),
('Cute Mountains Inn', 201, '2019-03-29', 347, NULL),
('Cute Mountains Inn', 201, '2019-03-30', 178, NULL),
('Cute Mountains Inn', 201, '2019-03-31', 218, NULL),
('Cute Mountains Inn', 201, '2019-04-01', 166, NULL),
('Cute Mountains Inn', 201, '2019-04-02', 191, NULL),
('Cute Mountains Inn', 201, '2019-04-03', 210, NULL),
('Cute Mountains Inn', 201, '2019-04-04', 263, NULL),
('Cute Mountains Inn', 201, '2019-04-05', 214, NULL),
('Cute Mountains Inn', 201, '2019-04-06', 176, NULL),
('Cute Mountains Inn', 201, '2019-04-07', 199, NULL),
('Cute Mountains Inn', 201, '2019-04-08', 130, NULL),
('Cute Mountains Inn', 201, '2019-04-09', 111, NULL),
('Cute Mountains Inn', 201, '2019-04-10', 369, NULL),
('Cute Mountains Inn', 201, '2019-04-11', 384, NULL),
('Cute Mountains Inn', 201, '2019-04-12', 311, NULL),
('Cute Mountains Inn', 201, '2019-04-13', 226, NULL),
('Cute Mountains Inn', 201, '2019-04-14', 136, NULL),
('Cute Mountains Inn', 201, '2019-04-15', 383, NULL),
('Cute Mountains Inn', 201, '2019-04-16', 272, NULL),
('Cute Mountains Inn', 201, '2019-04-17', 333, NULL),
('Cute Mountains Inn', 201, '2019-04-18', 329, NULL),
('Cute Mountains Inn', 201, '2019-04-19', 229, NULL),
('Cute Mountains Inn', 201, '2019-04-20', 102, NULL),
('Cute Mountains Inn', 201, '2019-04-21', 106, NULL),
('Cute Mountains Inn', 201, '2019-04-22', 387, NULL),
('Cute Mountains Inn', 201, '2019-04-23', 204, NULL),
('Cute Mountains Inn', 201, '2019-04-24', 174, NULL),
('Cute Mountains Inn', 201, '2019-04-25', 224, NULL),
('Cute Mountains Inn', 201, '2019-04-26', 151, NULL),
('Cute Mountains Inn', 201, '2019-04-27', 249, NULL),
('Cute Mountains Inn', 201, '2019-04-28', 251, NULL),
('Cute Mountains Inn', 201, '2019-04-29', 299, NULL),
('Cute Mountains Inn', 201, '2019-04-30', 148, NULL),
('Cute Mountains Inn', 201, '2019-05-01', 257, NULL),
('Cute Mountains Inn', 201, '2019-05-02', 337, NULL),
('Cute Mountains Inn', 201, '2019-05-03', 106, NULL),
('Cute Mountains Inn', 201, '2019-05-04', 251, NULL),
('Cute Mountains Inn', 201, '2019-05-05', 398, NULL),
('Cute Mountains Inn', 201, '2019-05-06', 275, NULL),
('Cute Mountains Inn', 201, '2019-05-07', 254, NULL),
('Cute Mountains Inn', 201, '2019-05-08', 160, NULL),
('Cute Mountains Inn', 201, '2019-05-09', 222, NULL),
('Cute Mountains Inn', 201, '2019-05-10', 128, NULL),
('Cute Mountains Inn', 201, '2019-05-11', 369, NULL),
('Cute Mountains Inn', 201, '2019-05-12', 192, NULL),
('Cute Mountains Inn', 201, '2019-05-13', 236, NULL),
('Cute Mountains Inn', 201, '2019-05-14', 281, NULL),
('Cute Mountains Inn', 201, '2019-05-15', 101, NULL),
('Cute Mountains Inn', 201, '2019-05-16', 126, NULL),
('Cute Mountains Inn', 201, '2019-05-17', 257, NULL),
('Cute Mountains Inn', 201, '2019-05-18', 232, NULL),
('Cute Mountains Inn', 201, '2019-05-19', 384, NULL),
('Cute Mountains Inn', 201, '2019-05-20', 200, NULL),
('Cute Mountains Inn', 201, '2019-05-21', 217, NULL),
('Cute Mountains Inn', 201, '2019-05-22', 318, NULL),
('Cute Mountains Inn', 201, '2019-05-23', 249, NULL),
('Cute Mountains Inn', 201, '2019-05-24', 270, NULL),
('Cute Mountains Inn', 201, '2019-05-25', 390, NULL),
('Cute Mountains Inn', 201, '2019-05-26', 216, NULL),
('Cute Mountains Inn', 201, '2019-05-27', 277, NULL),
('Cute Mountains Inn', 201, '2019-05-28', 224, NULL),
('Cute Mountains Inn', 201, '2019-05-29', 392, NULL),
('Cute Mountains Inn', 201, '2019-05-30', 346, NULL),
('Cute Mountains Inn', 201, '2019-05-31', 327, NULL),
('Cute Mountains Inn', 201, '2019-06-01', 279, NULL),
('Cute Mountains Inn', 201, '2019-06-02', 267, NULL),
('Cute Mountains Inn', 201, '2019-06-03', 125, NULL),
('Cute Mountains Inn', 201, '2019-06-04', 132, NULL),
('Cute Mountains Inn', 201, '2019-06-05', 186, NULL),
('Cute Mountains Inn', 201, '2019-06-06', 187, NULL),
('Cute Mountains Inn', 201, '2019-06-07', 300, NULL),
('Cute Mountains Inn', 201, '2019-06-08', 192, NULL),
('Cute Mountains Inn', 201, '2019-06-09', 387, NULL),
('Cute Mountains Inn', 201, '2019-06-10', 172, NULL),
('Cute Mountains Inn', 201, '2019-06-11', 382, NULL),
('Cute Mountains Inn', 201, '2019-06-12', 198, NULL),
('Cute Mountains Inn', 201, '2019-06-13', 331, NULL),
('Cute Mountains Inn', 201, '2019-06-14', 399, NULL),
('Cute Mountains Inn', 201, '2019-06-15', 215, NULL),
('Cute Mountains Inn', 201, '2019-06-16', 145, NULL),
('Cute Mountains Inn', 201, '2019-06-17', 296, NULL),
('Cute Mountains Inn', 201, '2019-06-18', 110, NULL),
('Cute Mountains Inn', 201, '2019-06-19', 142, NULL),
('Cute Mountains Inn', 201, '2019-06-20', 174, NULL),
('Cute Mountains Inn', 201, '2019-06-21', 217, NULL),
('Cute Mountains Inn', 201, '2019-06-22', 252, NULL),
('Cute Mountains Inn', 201, '2019-06-23', 315, NULL),
('Cute Mountains Inn', 201, '2019-06-24', 315, NULL),
('Cute Mountains Inn', 201, '2019-06-25', 252, NULL),
('Cute Mountains Inn', 201, '2019-06-26', 220, NULL),
('Cute Mountains Inn', 201, '2019-06-27', 188, NULL),
('Cute Mountains Inn', 201, '2019-06-28', 302, NULL),
('Cute Mountains Inn', 201, '2019-06-29', 124, NULL),
('Cute Mountains Inn', 201, '2019-06-30', 253, NULL),
('Cute Mountains Inn', 201, '2019-07-01', 356, NULL),
('Cute Mountains Inn', 201, '2019-07-02', 281, NULL),
('Cute Mountains Inn', 201, '2019-07-03', 132, NULL),
('Cute Mountains Inn', 201, '2019-07-04', 228, NULL),
('Cute Mountains Inn', 201, '2019-07-05', 242, NULL),
('Cute Mountains Inn', 201, '2019-07-06', 120, NULL),
('Cute Mountains Inn', 201, '2019-07-07', 251, NULL),
('Cute Mountains Inn', 201, '2019-07-08', 259, NULL),
('Cute Mountains Inn', 201, '2019-07-09', 172, NULL),
('Cute Mountains Inn', 201, '2019-07-10', 301, NULL),
('Cute Mountains Inn', 201, '2019-07-11', 155, NULL),
('Cute Mountains Inn', 201, '2019-07-12', 258, NULL),
('Cute Mountains Inn', 201, '2019-07-13', 332, NULL),
('Cute Mountains Inn', 201, '2019-07-14', 342, NULL),
('Cute Mountains Inn', 201, '2019-07-15', 288, NULL),
('Cute Mountains Inn', 201, '2019-07-16', 379, NULL),
('Cute Mountains Inn', 201, '2019-07-17', 140, NULL),
('Cute Mountains Inn', 201, '2019-07-18', 141, NULL),
('Cute Mountains Inn', 201, '2019-07-19', 167, NULL),
('Cute Mountains Inn', 201, '2019-07-20', 262, NULL),
('Cute Mountains Inn', 201, '2019-07-21', 109, NULL),
('Cute Mountains Inn', 201, '2019-07-22', 342, NULL),
('Cute Mountains Inn', 201, '2019-07-23', 332, NULL),
('Cute Mountains Inn', 201, '2019-07-24', 334, NULL),
('Cute Mountains Inn', 201, '2019-07-25', 205, NULL),
('Cute Mountains Inn', 201, '2019-07-26', 291, NULL),
('Cute Mountains Inn', 201, '2019-07-27', 146, NULL),
('Cute Mountains Inn', 201, '2019-07-28', 146, NULL),
('Cute Mountains Inn', 201, '2019-07-29', 237, NULL),
('Cute Mountains Inn', 201, '2019-07-30', 377, NULL),
('Cute Mountains Inn', 201, '2019-07-31', 169, NULL),
('Cute Mountains Inn', 201, '2019-08-01', 219, NULL),
('Cute Mountains Inn', 201, '2019-08-02', 344, NULL),
('Cute Mountains Inn', 201, '2019-08-03', 325, NULL),
('Cute Mountains Inn', 201, '2019-08-04', 380, NULL),
('Cute Mountains Inn', 201, '2019-08-05', 229, NULL),
('Cute Mountains Inn', 201, '2019-08-06', 160, NULL),
('Cute Mountains Inn', 201, '2019-08-07', 199, NULL),
('Cute Mountains Inn', 201, '2019-08-08', 254, NULL),
('Cute Mountains Inn', 201, '2019-08-09', 206, NULL),
('Cute Mountains Inn', 201, '2019-08-10', 137, NULL),
('Cute Mountains Inn', 201, '2019-08-11', 361, NULL),
('Cute Mountains Inn', 201, '2019-08-12', 356, NULL),
('Cute Mountains Inn', 201, '2019-08-13', 307, NULL),
('Cute Mountains Inn', 201, '2019-08-14', 313, NULL),
('Cute Mountains Inn', 201, '2019-08-15', 230, NULL),
('Cute Mountains Inn', 201, '2019-08-16', 396, NULL),
('Cute Mountains Inn', 201, '2019-08-17', 266, NULL),
('Cute Mountains Inn', 201, '2019-08-18', 107, NULL),
('Cute Mountains Inn', 201, '2019-08-19', 211, NULL),
('Cute Mountains Inn', 201, '2019-08-20', 282, NULL),
('Cute Mountains Inn', 201, '2019-08-21', 132, NULL),
('Cute Mountains Inn', 201, '2019-08-22', 360, NULL),
('Cute Mountains Inn', 201, '2019-08-23', 286, NULL),
('Cute Mountains Inn', 201, '2019-08-24', 349, NULL),
('Cute Mountains Inn', 201, '2019-08-25', 357, NULL),
('Cute Mountains Inn', 201, '2019-08-26', 308, NULL),
('Cute Mountains Inn', 201, '2019-08-27', 360, NULL),
('Cute Mountains Inn', 201, '2019-08-28', 269, NULL),
('Cute Mountains Inn', 201, '2019-08-29', 255, NULL),
('Cute Mountains Inn', 201, '2019-08-30', 347, NULL),
('Cute Mountains Inn', 201, '2019-08-31', 241, NULL),
('Cute Mountains Inn', 201, '2019-09-01', 227, NULL),
('Cute Mountains Inn', 201, '2019-09-02', 137, NULL),
('Cute Mountains Inn', 201, '2019-09-03', 308, NULL),
('Cute Mountains Inn', 201, '2019-09-04', 298, NULL),
('Cute Mountains Inn', 201, '2019-09-05', 240, NULL),
('Cute Mountains Inn', 201, '2019-09-06', 257, NULL),
('Cute Mountains Inn', 201, '2019-09-07', 319, NULL),
('Cute Mountains Inn', 201, '2019-09-08', 125, NULL),
('Cute Mountains Inn', 201, '2019-09-09', 184, NULL),
('Cute Mountains Inn', 201, '2019-09-10', 381, NULL),
('Cute Mountains Inn', 201, '2019-09-11', 348, NULL),
('Cute Mountains Inn', 201, '2019-09-12', 167, NULL),
('Cute Mountains Inn', 201, '2019-09-13', 178, NULL),
('Cute Mountains Inn', 201, '2019-09-14', 334, NULL),
('Cute Mountains Inn', 201, '2019-09-15', 304, NULL),
('Cute Mountains Inn', 201, '2019-09-16', 376, NULL),
('Cute Mountains Inn', 201, '2019-09-17', 218, NULL),
('Cute Mountains Inn', 201, '2019-09-18', 109, NULL),
('Cute Mountains Inn', 201, '2019-09-19', 167, NULL),
('Cute Mountains Inn', 201, '2019-09-20', 276, NULL),
('Cute Mountains Inn', 201, '2019-09-21', 265, NULL),
('Cute Mountains Inn', 201, '2019-09-22', 125, NULL),
('Cute Mountains Inn', 201, '2019-09-23', 356, NULL),
('Cute Mountains Inn', 201, '2019-09-24', 312, NULL),
('Cute Mountains Inn', 201, '2019-09-25', 275, NULL),
('Cute Mountains Inn', 201, '2019-09-26', 303, NULL),
('Cute Mountains Inn', 201, '2019-09-27', 367, NULL),
('Cute Mountains Inn', 201, '2019-09-28', 386, NULL),
('Cute Mountains Inn', 201, '2019-09-29', 141, NULL),
('Cute Mountains Inn', 201, '2019-09-30', 109, NULL),
('Cute Mountains Inn', 201, '2019-10-01', 245, NULL),
('Cute Mountains Inn', 201, '2019-10-02', 382, NULL),
('Cute Mountains Inn', 201, '2019-10-03', 342, NULL),
('Cute Mountains Inn', 201, '2019-10-04', 118, NULL),
('Cute Mountains Inn', 201, '2019-10-05', 348, NULL),
('Cute Mountains Inn', 201, '2019-10-06', 330, NULL),
('Cute Mountains Inn', 201, '2019-10-07', 301, NULL),
('Cute Mountains Inn', 201, '2019-10-08', 292, NULL),
('Cute Mountains Inn', 201, '2019-10-09', 318, NULL),
('Cute Mountains Inn', 201, '2019-10-10', 318, NULL),
('Cute Mountains Inn', 201, '2019-10-11', 128, NULL),
('Cute Mountains Inn', 201, '2019-10-12', 294, NULL),
('Cute Mountains Inn', 201, '2019-10-13', 240, NULL),
('Cute Mountains Inn', 201, '2019-10-14', 350, NULL),
('Cute Mountains Inn', 201, '2019-10-15', 297, NULL),
('Cute Mountains Inn', 201, '2019-10-16', 114, NULL),
('Cute Mountains Inn', 201, '2019-10-17', 150, NULL),
('Cute Mountains Inn', 201, '2019-10-18', 288, NULL),
('Cute Mountains Inn', 201, '2019-10-19', 366, NULL),
('Cute Mountains Inn', 201, '2019-10-20', 274, NULL),
('Cute Mountains Inn', 201, '2019-10-21', 262, NULL),
('Cute Mountains Inn', 201, '2019-10-22', 164, NULL),
('Cute Mountains Inn', 201, '2019-10-23', 327, NULL),
('Cute Mountains Inn', 201, '2019-10-24', 393, NULL),
('Cute Mountains Inn', 201, '2019-10-25', 324, NULL),
('Cute Mountains Inn', 201, '2019-10-26', 371, NULL),
('Cute Mountains Inn', 201, '2019-10-27', 138, NULL),
('Cute Mountains Inn', 201, '2019-10-28', 219, NULL),
('Cute Mountains Inn', 201, '2019-10-29', 311, NULL),
('Cute Mountains Inn', 201, '2019-10-30', 353, NULL),
('Cute Mountains Inn', 201, '2019-10-31', 255, NULL),
('Cute Mountains Inn', 201, '2019-11-01', 365, NULL),
('Cute Mountains Inn', 201, '2019-11-02', 208, NULL),
('Cute Mountains Inn', 201, '2019-11-03', 228, NULL),
('Cute Mountains Inn', 201, '2019-11-04', 166, NULL),
('Cute Mountains Inn', 201, '2019-11-05', 272, NULL),
('Cute Mountains Inn', 201, '2019-11-06', 128, NULL),
('Cute Mountains Inn', 201, '2019-11-07', 151, NULL),
('Cute Mountains Inn', 201, '2019-11-08', 372, NULL),
('Cute Mountains Inn', 201, '2019-11-09', 235, NULL),
('Cute Mountains Inn', 201, '2019-11-10', 134, NULL),
('Cute Mountains Inn', 201, '2019-11-11', 308, NULL),
('Cute Mountains Inn', 201, '2019-11-12', 214, NULL),
('Cute Mountains Inn', 201, '2019-11-13', 203, NULL),
('Cute Mountains Inn', 201, '2019-11-14', 114, NULL),
('Cute Mountains Inn', 201, '2019-11-15', 174, NULL),
('Cute Mountains Inn', 201, '2019-11-16', 389, NULL),
('Cute Mountains Inn', 201, '2019-11-17', 134, NULL),
('Cute Mountains Inn', 201, '2019-11-18', 341, NULL),
('Cute Mountains Inn', 201, '2019-11-19', 268, NULL),
('Cute Mountains Inn', 201, '2019-11-20', 351, NULL),
('Cute Mountains Inn', 201, '2019-11-21', 190, NULL),
('Cute Mountains Inn', 201, '2019-11-22', 200, NULL),
('Cute Mountains Inn', 201, '2019-11-23', 307, NULL),
('Cute Mountains Inn', 201, '2019-11-24', 227, NULL),
('Cute Mountains Inn', 201, '2019-11-25', 144, NULL),
('Cute Mountains Inn', 201, '2019-11-26', 121, NULL),
('Cute Mountains Inn', 201, '2019-11-27', 313, NULL),
('Cute Mountains Inn', 201, '2019-11-28', 197, NULL),
('Cute Mountains Inn', 201, '2019-11-29', 240, NULL),
('Cute Mountains Inn', 201, '2019-11-30', 130, NULL),
('Cute Mountains Inn', 201, '2019-12-01', 189, NULL),
('Cute Mountains Inn', 201, '2019-12-02', 324, NULL),
('Cute Mountains Inn', 201, '2019-12-03', 201, NULL),
('Cute Mountains Inn', 201, '2019-12-04', 299, NULL),
('Cute Mountains Inn', 201, '2019-12-05', 362, NULL),
('Cute Mountains Inn', 201, '2019-12-06', 175, NULL),
('Cute Mountains Inn', 201, '2019-12-07', 174, NULL),
('Cute Mountains Inn', 201, '2019-12-08', 372, NULL),
('Cute Mountains Inn', 201, '2019-12-09', 124, NULL),
('Cute Mountains Inn', 201, '2019-12-10', 384, NULL),
('Cute Mountains Inn', 201, '2019-12-11', 273, NULL),
('Cute Mountains Inn', 201, '2019-12-12', 193, NULL),
('Cute Mountains Inn', 201, '2019-12-13', 370, NULL),
('Cute Mountains Inn', 201, '2019-12-14', 221, NULL),
('Cute Mountains Inn', 201, '2019-12-15', 168, NULL),
('Cute Mountains Inn', 201, '2019-12-16', 181, NULL),
('Cute Mountains Inn', 201, '2019-12-17', 278, NULL),
('Cute Mountains Inn', 201, '2019-12-18', 333, NULL),
('Cute Mountains Inn', 201, '2019-12-19', 399, NULL),
('Cute Mountains Inn', 201, '2019-12-20', 168, NULL),
('Cute Mountains Inn', 201, '2019-12-21', 305, NULL),
('Cute Mountains Inn', 201, '2019-12-22', 367, NULL),
('Cute Mountains Inn', 201, '2019-12-23', 138, NULL),
('Cute Mountains Inn', 201, '2019-12-24', 269, NULL),
('Cute Mountains Inn', 201, '2019-12-25', 391, NULL),
('Cute Mountains Inn', 201, '2019-12-26', 181, NULL),
('Cute Mountains Inn', 201, '2019-12-27', 391, NULL),
('Cute Mountains Inn', 201, '2019-12-28', 173, NULL),
('Cute Mountains Inn', 201, '2019-12-29', 388, NULL),
('Cute Mountains Inn', 201, '2019-12-30', 203, NULL),
('Cute Mountains Inn', 201, '2019-12-31', 372, NULL),
('Cute Mountains Inn', 201, '2020-01-01', 380, NULL),
('Cute Mountains Inn', 201, '2020-01-02', 312, NULL),
('Cute Mountains Inn', 201, '2020-01-03', 278, NULL),
('Cute Mountains Inn', 201, '2020-01-04', 270, NULL),
('Cute Mountains Inn', 201, '2020-01-05', 213, NULL),
('Cute Mountains Inn', 201, '2020-01-06', 217, NULL),
('Cute Mountains Inn', 201, '2020-01-07', 186, NULL),
('Cute Mountains Inn', 201, '2020-01-08', 104, NULL),
('Cute Mountains Inn', 201, '2020-01-09', 166, NULL),
('Cute Mountains Inn', 201, '2020-01-10', 361, NULL),
('Cute Mountains Inn', 201, '2020-01-11', 340, NULL),
('Cute Mountains Inn', 201, '2020-01-12', 243, NULL),
('Cute Mountains Inn', 201, '2020-01-13', 188, NULL),
('Cute Mountains Inn', 201, '2020-01-14', 178, NULL),
('Cute Mountains Inn', 201, '2020-01-15', 293, NULL),
('Cute Mountains Inn', 201, '2020-01-16', 155, NULL),
('Cute Mountains Inn', 201, '2020-01-17', 212, NULL),
('Cute Mountains Inn', 201, '2020-01-18', 308, NULL),
('Cute Mountains Inn', 201, '2020-01-19', 183, NULL),
('Cute Mountains Inn', 201, '2020-01-20', 370, NULL),
('Cute Mountains Inn', 201, '2020-01-21', 345, NULL),
('Cute Mountains Inn', 201, '2020-01-22', 257, NULL),
('Cute Mountains Inn', 201, '2020-01-23', 207, NULL),
('Cute Mountains Inn', 201, '2020-01-24', 349, NULL),
('Cute Mountains Inn', 201, '2020-01-25', 151, NULL),
('Cute Mountains Inn', 201, '2020-01-26', 377, NULL),
('Cute Mountains Inn', 201, '2020-01-27', 275, NULL),
('Cute Mountains Inn', 201, '2020-01-28', 376, NULL),
('Cute Mountains Inn', 201, '2020-01-29', 168, NULL),
('Cute Mountains Inn', 201, '2020-01-30', 388, NULL),
('Cute Mountains Inn', 201, '2020-01-31', 197, NULL),
('Cute Mountains Inn', 201, '2020-02-01', 285, NULL),
('Cute Mountains Inn', 201, '2020-02-02', 173, NULL),
('Cute Mountains Inn', 201, '2020-02-03', 275, NULL),
('Cute Mountains Inn', 201, '2020-02-04', 385, NULL),
('Cute Mountains Inn', 202, '2019-01-01', 203, NULL),
('Cute Mountains Inn', 202, '2019-01-02', 219, NULL),
('Cute Mountains Inn', 202, '2019-01-03', 152, NULL),
('Cute Mountains Inn', 202, '2019-01-04', 140, NULL),
('Cute Mountains Inn', 202, '2019-01-05', 339, NULL),
('Cute Mountains Inn', 202, '2019-01-06', 177, NULL),
('Cute Mountains Inn', 202, '2019-01-07', 100, NULL),
('Cute Mountains Inn', 202, '2019-01-08', 232, NULL),
('Cute Mountains Inn', 202, '2019-01-09', 339, NULL),
('Cute Mountains Inn', 202, '2019-01-10', 385, NULL),
('Cute Mountains Inn', 202, '2019-01-11', 324, NULL),
('Cute Mountains Inn', 202, '2019-01-12', 248, NULL),
('Cute Mountains Inn', 202, '2019-01-13', 271, NULL),
('Cute Mountains Inn', 202, '2019-01-14', 236, NULL),
('Cute Mountains Inn', 202, '2019-01-15', 236, NULL),
('Cute Mountains Inn', 202, '2019-01-16', 317, NULL),
('Cute Mountains Inn', 202, '2019-01-17', 238, NULL),
('Cute Mountains Inn', 202, '2019-01-18', 340, NULL),
('Cute Mountains Inn', 202, '2019-01-19', 182, NULL),
('Cute Mountains Inn', 202, '2019-01-20', 270, NULL),
('Cute Mountains Inn', 202, '2019-01-21', 268, NULL),
('Cute Mountains Inn', 202, '2019-01-22', 330, NULL),
('Cute Mountains Inn', 202, '2019-01-23', 246, NULL),
('Cute Mountains Inn', 202, '2019-01-24', 189, NULL),
('Cute Mountains Inn', 202, '2019-01-25', 144, NULL),
('Cute Mountains Inn', 202, '2019-01-26', 192, NULL),
('Cute Mountains Inn', 202, '2019-01-27', 302, NULL),
('Cute Mountains Inn', 202, '2019-01-28', 166, NULL),
('Cute Mountains Inn', 202, '2019-01-29', 151, NULL),
('Cute Mountains Inn', 202, '2019-01-30', 186, NULL),
('Cute Mountains Inn', 202, '2019-01-31', 204, NULL),
('Cute Mountains Inn', 202, '2019-02-01', 342, NULL),
('Cute Mountains Inn', 202, '2019-02-02', 181, NULL),
('Cute Mountains Inn', 202, '2019-02-03', 384, NULL),
('Cute Mountains Inn', 202, '2019-02-04', 326, NULL),
('Cute Mountains Inn', 202, '2019-02-05', 173, NULL),
('Cute Mountains Inn', 202, '2019-02-06', 219, NULL),
('Cute Mountains Inn', 202, '2019-02-07', 143, NULL),
('Cute Mountains Inn', 202, '2019-02-08', 315, NULL),
('Cute Mountains Inn', 202, '2019-02-09', 339, NULL),
('Cute Mountains Inn', 202, '2019-02-10', 387, NULL),
('Cute Mountains Inn', 202, '2019-02-11', 154, NULL),
('Cute Mountains Inn', 202, '2019-02-12', 317, NULL),
('Cute Mountains Inn', 202, '2019-02-13', 335, NULL),
('Cute Mountains Inn', 202, '2019-02-14', 125, NULL),
('Cute Mountains Inn', 202, '2019-02-15', 132, NULL),
('Cute Mountains Inn', 202, '2019-02-16', 368, NULL),
('Cute Mountains Inn', 202, '2019-02-17', 341, NULL),
('Cute Mountains Inn', 202, '2019-02-18', 288, NULL),
('Cute Mountains Inn', 202, '2019-02-19', 109, NULL),
('Cute Mountains Inn', 202, '2019-02-20', 214, NULL),
('Cute Mountains Inn', 202, '2019-02-21', 354, NULL),
('Cute Mountains Inn', 202, '2019-02-22', 238, NULL),
('Cute Mountains Inn', 202, '2019-02-23', 344, NULL),
('Cute Mountains Inn', 202, '2019-02-24', 394, NULL),
('Cute Mountains Inn', 202, '2019-02-25', 131, NULL),
('Cute Mountains Inn', 202, '2019-02-26', 206, NULL),
('Cute Mountains Inn', 202, '2019-02-27', 115, NULL),
('Cute Mountains Inn', 202, '2019-02-28', 168, NULL),
('Cute Mountains Inn', 202, '2019-03-01', 244, NULL),
('Cute Mountains Inn', 202, '2019-03-02', 205, NULL),
('Cute Mountains Inn', 202, '2019-03-03', 359, NULL),
('Cute Mountains Inn', 202, '2019-03-04', 316, NULL),
('Cute Mountains Inn', 202, '2019-03-05', 253, NULL),
('Cute Mountains Inn', 202, '2019-03-06', 354, NULL),
('Cute Mountains Inn', 202, '2019-03-07', 398, NULL),
('Cute Mountains Inn', 202, '2019-03-08', 284, NULL),
('Cute Mountains Inn', 202, '2019-03-09', 159, NULL),
('Cute Mountains Inn', 202, '2019-03-10', 123, NULL),
('Cute Mountains Inn', 202, '2019-03-11', 311, NULL),
('Cute Mountains Inn', 202, '2019-03-12', 324, NULL),
('Cute Mountains Inn', 202, '2019-03-13', 392, NULL),
('Cute Mountains Inn', 202, '2019-03-14', 290, NULL),
('Cute Mountains Inn', 202, '2019-03-15', 345, NULL),
('Cute Mountains Inn', 202, '2019-03-16', 341, NULL),
('Cute Mountains Inn', 202, '2019-03-17', 184, NULL),
('Cute Mountains Inn', 202, '2019-03-18', 139, NULL),
('Cute Mountains Inn', 202, '2019-03-19', 214, NULL),
('Cute Mountains Inn', 202, '2019-03-20', 195, NULL),
('Cute Mountains Inn', 202, '2019-03-21', 145, NULL),
('Cute Mountains Inn', 202, '2019-03-22', 376, NULL),
('Cute Mountains Inn', 202, '2019-03-23', 164, NULL),
('Cute Mountains Inn', 202, '2019-03-24', 273, NULL),
('Cute Mountains Inn', 202, '2019-03-25', 299, NULL),
('Cute Mountains Inn', 202, '2019-03-26', 195, NULL),
('Cute Mountains Inn', 202, '2019-03-27', 302, NULL),
('Cute Mountains Inn', 202, '2019-03-28', 150, NULL),
('Cute Mountains Inn', 202, '2019-03-29', 252, NULL),
('Cute Mountains Inn', 202, '2019-03-30', 341, NULL),
('Cute Mountains Inn', 202, '2019-03-31', 325, NULL),
('Cute Mountains Inn', 202, '2019-04-01', 108, NULL),
('Cute Mountains Inn', 202, '2019-04-02', 103, NULL),
('Cute Mountains Inn', 202, '2019-04-03', 139, NULL),
('Cute Mountains Inn', 202, '2019-04-04', 101, NULL),
('Cute Mountains Inn', 202, '2019-04-05', 349, NULL),
('Cute Mountains Inn', 202, '2019-04-06', 302, NULL),
('Cute Mountains Inn', 202, '2019-04-07', 125, NULL),
('Cute Mountains Inn', 202, '2019-04-08', 257, NULL),
('Cute Mountains Inn', 202, '2019-04-09', 358, NULL),
('Cute Mountains Inn', 202, '2019-04-10', 207, NULL),
('Cute Mountains Inn', 202, '2019-04-11', 149, NULL),
('Cute Mountains Inn', 202, '2019-04-12', 234, NULL),
('Cute Mountains Inn', 202, '2019-04-13', 166, NULL),
('Cute Mountains Inn', 202, '2019-04-14', 346, NULL),
('Cute Mountains Inn', 202, '2019-04-15', 255, NULL),
('Cute Mountains Inn', 202, '2019-04-16', 296, NULL),
('Cute Mountains Inn', 202, '2019-04-17', 315, NULL),
('Cute Mountains Inn', 202, '2019-04-18', 180, NULL),
('Cute Mountains Inn', 202, '2019-04-19', 171, NULL),
('Cute Mountains Inn', 202, '2019-04-20', 371, NULL),
('Cute Mountains Inn', 202, '2019-04-21', 211, NULL),
('Cute Mountains Inn', 202, '2019-04-22', 139, NULL),
('Cute Mountains Inn', 202, '2019-04-23', 130, NULL),
('Cute Mountains Inn', 202, '2019-04-24', 306, NULL),
('Cute Mountains Inn', 202, '2019-04-25', 253, NULL),
('Cute Mountains Inn', 202, '2019-04-26', 312, NULL),
('Cute Mountains Inn', 202, '2019-04-27', 118, NULL),
('Cute Mountains Inn', 202, '2019-04-28', 211, NULL),
('Cute Mountains Inn', 202, '2019-04-29', 142, NULL),
('Cute Mountains Inn', 202, '2019-04-30', 366, NULL),
('Cute Mountains Inn', 202, '2019-05-01', 364, NULL),
('Cute Mountains Inn', 202, '2019-05-02', 350, NULL),
('Cute Mountains Inn', 202, '2019-05-03', 385, NULL),
('Cute Mountains Inn', 202, '2019-05-04', 330, NULL),
('Cute Mountains Inn', 202, '2019-05-05', 288, NULL),
('Cute Mountains Inn', 202, '2019-05-06', 326, NULL),
('Cute Mountains Inn', 202, '2019-05-07', 370, NULL),
('Cute Mountains Inn', 202, '2019-05-08', 236, NULL),
('Cute Mountains Inn', 202, '2019-05-09', 276, NULL),
('Cute Mountains Inn', 202, '2019-05-10', 147, NULL),
('Cute Mountains Inn', 202, '2019-05-11', 389, NULL),
('Cute Mountains Inn', 202, '2019-05-12', 266, NULL),
('Cute Mountains Inn', 202, '2019-05-13', 267, NULL),
('Cute Mountains Inn', 202, '2019-05-14', 257, NULL),
('Cute Mountains Inn', 202, '2019-05-15', 185, NULL),
('Cute Mountains Inn', 202, '2019-05-16', 215, NULL),
('Cute Mountains Inn', 202, '2019-05-17', 280, NULL),
('Cute Mountains Inn', 202, '2019-05-18', 391, NULL),
('Cute Mountains Inn', 202, '2019-05-19', 203, NULL),
('Cute Mountains Inn', 202, '2019-05-20', 132, NULL),
('Cute Mountains Inn', 202, '2019-05-21', 233, NULL),
('Cute Mountains Inn', 202, '2019-05-22', 330, NULL),
('Cute Mountains Inn', 202, '2019-05-23', 328, NULL),
('Cute Mountains Inn', 202, '2019-05-24', 365, NULL),
('Cute Mountains Inn', 202, '2019-05-25', 254, NULL),
('Cute Mountains Inn', 202, '2019-05-26', 314, NULL),
('Cute Mountains Inn', 202, '2019-05-27', 148, NULL),
('Cute Mountains Inn', 202, '2019-05-28', 377, NULL),
('Cute Mountains Inn', 202, '2019-05-29', 114, NULL),
('Cute Mountains Inn', 202, '2019-05-30', 276, NULL),
('Cute Mountains Inn', 202, '2019-05-31', 289, NULL),
('Cute Mountains Inn', 202, '2019-06-01', 298, NULL),
('Cute Mountains Inn', 202, '2019-06-02', 322, NULL),
('Cute Mountains Inn', 202, '2019-06-03', 143, NULL),
('Cute Mountains Inn', 202, '2019-06-04', 198, NULL),
('Cute Mountains Inn', 202, '2019-06-05', 121, NULL),
('Cute Mountains Inn', 202, '2019-06-06', 297, NULL),
('Cute Mountains Inn', 202, '2019-06-07', 354, NULL),
('Cute Mountains Inn', 202, '2019-06-08', 229, NULL),
('Cute Mountains Inn', 202, '2019-06-09', 342, NULL),
('Cute Mountains Inn', 202, '2019-06-10', 149, NULL),
('Cute Mountains Inn', 202, '2019-06-11', 176, NULL),
('Cute Mountains Inn', 202, '2019-06-12', 262, NULL),
('Cute Mountains Inn', 202, '2019-06-13', 372, NULL),
('Cute Mountains Inn', 202, '2019-06-14', 217, NULL),
('Cute Mountains Inn', 202, '2019-06-15', 162, NULL),
('Cute Mountains Inn', 202, '2019-06-16', 139, NULL),
('Cute Mountains Inn', 202, '2019-06-17', 119, NULL),
('Cute Mountains Inn', 202, '2019-06-18', 391, NULL),
('Cute Mountains Inn', 202, '2019-06-19', 285, NULL),
('Cute Mountains Inn', 202, '2019-06-20', 167, NULL),
('Cute Mountains Inn', 202, '2019-06-21', 301, NULL),
('Cute Mountains Inn', 202, '2019-06-22', 316, NULL),
('Cute Mountains Inn', 202, '2019-06-23', 133, NULL),
('Cute Mountains Inn', 202, '2019-06-24', 393, NULL),
('Cute Mountains Inn', 202, '2019-06-25', 233, NULL),
('Cute Mountains Inn', 202, '2019-06-26', 306, NULL),
('Cute Mountains Inn', 202, '2019-06-27', 220, NULL),
('Cute Mountains Inn', 202, '2019-06-28', 366, NULL),
('Cute Mountains Inn', 202, '2019-06-29', 246, NULL),
('Cute Mountains Inn', 202, '2019-06-30', 124, NULL),
('Cute Mountains Inn', 202, '2019-07-01', 127, NULL),
('Cute Mountains Inn', 202, '2019-07-02', 367, NULL),
('Cute Mountains Inn', 202, '2019-07-03', 296, NULL),
('Cute Mountains Inn', 202, '2019-07-04', 167, NULL),
('Cute Mountains Inn', 202, '2019-07-05', 138, NULL),
('Cute Mountains Inn', 202, '2019-07-06', 217, NULL),
('Cute Mountains Inn', 202, '2019-07-07', 356, NULL),
('Cute Mountains Inn', 202, '2019-07-08', 278, NULL),
('Cute Mountains Inn', 202, '2019-07-09', 176, NULL),
('Cute Mountains Inn', 202, '2019-07-10', 132, NULL),
('Cute Mountains Inn', 202, '2019-07-11', 298, NULL),
('Cute Mountains Inn', 202, '2019-07-12', 376, NULL),
('Cute Mountains Inn', 202, '2019-07-13', 122, NULL),
('Cute Mountains Inn', 202, '2019-07-14', 138, NULL),
('Cute Mountains Inn', 202, '2019-07-15', 276, NULL),
('Cute Mountains Inn', 202, '2019-07-16', 128, NULL),
('Cute Mountains Inn', 202, '2019-07-17', 158, NULL),
('Cute Mountains Inn', 202, '2019-07-18', 124, NULL),
('Cute Mountains Inn', 202, '2019-07-19', 235, NULL),
('Cute Mountains Inn', 202, '2019-07-20', 112, NULL),
('Cute Mountains Inn', 202, '2019-07-21', 277, NULL),
('Cute Mountains Inn', 202, '2019-07-22', 275, NULL),
('Cute Mountains Inn', 202, '2019-07-23', 126, NULL),
('Cute Mountains Inn', 202, '2019-07-24', 175, NULL),
('Cute Mountains Inn', 202, '2019-07-25', 393, NULL),
('Cute Mountains Inn', 202, '2019-07-26', 100, NULL),
('Cute Mountains Inn', 202, '2019-07-27', 114, NULL),
('Cute Mountains Inn', 202, '2019-07-28', 289, NULL),
('Cute Mountains Inn', 202, '2019-07-29', 282, NULL),
('Cute Mountains Inn', 202, '2019-07-30', 118, NULL),
('Cute Mountains Inn', 202, '2019-07-31', 335, NULL),
('Cute Mountains Inn', 202, '2019-08-01', 271, NULL),
('Cute Mountains Inn', 202, '2019-08-02', 174, NULL),
('Cute Mountains Inn', 202, '2019-08-03', 303, NULL),
('Cute Mountains Inn', 202, '2019-08-04', 290, NULL),
('Cute Mountains Inn', 202, '2019-08-05', 284, NULL),
('Cute Mountains Inn', 202, '2019-08-06', 162, NULL),
('Cute Mountains Inn', 202, '2019-08-07', 160, NULL),
('Cute Mountains Inn', 202, '2019-08-08', 328, NULL),
('Cute Mountains Inn', 202, '2019-08-09', 103, NULL),
('Cute Mountains Inn', 202, '2019-08-10', 317, NULL),
('Cute Mountains Inn', 202, '2019-08-11', 242, NULL),
('Cute Mountains Inn', 202, '2019-08-12', 212, NULL),
('Cute Mountains Inn', 202, '2019-08-13', 195, NULL),
('Cute Mountains Inn', 202, '2019-08-14', 383, NULL),
('Cute Mountains Inn', 202, '2019-08-15', 279, NULL),
('Cute Mountains Inn', 202, '2019-08-16', 110, NULL),
('Cute Mountains Inn', 202, '2019-08-17', 257, NULL),
('Cute Mountains Inn', 202, '2019-08-18', 235, NULL),
('Cute Mountains Inn', 202, '2019-08-19', 265, NULL),
('Cute Mountains Inn', 202, '2019-08-20', 384, NULL),
('Cute Mountains Inn', 202, '2019-08-21', 376, NULL),
('Cute Mountains Inn', 202, '2019-08-22', 184, NULL),
('Cute Mountains Inn', 202, '2019-08-23', 264, NULL),
('Cute Mountains Inn', 202, '2019-08-24', 191, NULL),
('Cute Mountains Inn', 202, '2019-08-25', 143, NULL),
('Cute Mountains Inn', 202, '2019-08-26', 294, NULL),
('Cute Mountains Inn', 202, '2019-08-27', 146, NULL),
('Cute Mountains Inn', 202, '2019-08-28', 355, NULL),
('Cute Mountains Inn', 202, '2019-08-29', 151, NULL),
('Cute Mountains Inn', 202, '2019-08-30', 175, NULL),
('Cute Mountains Inn', 202, '2019-08-31', 134, NULL),
('Cute Mountains Inn', 202, '2019-09-01', 110, NULL),
('Cute Mountains Inn', 202, '2019-09-02', 250, NULL),
('Cute Mountains Inn', 202, '2019-09-03', 116, NULL),
('Cute Mountains Inn', 202, '2019-09-04', 141, NULL),
('Cute Mountains Inn', 202, '2019-09-05', 341, NULL),
('Cute Mountains Inn', 202, '2019-09-06', 170, NULL),
('Cute Mountains Inn', 202, '2019-09-07', 159, NULL),
('Cute Mountains Inn', 202, '2019-09-08', 238, NULL),
('Cute Mountains Inn', 202, '2019-09-09', 318, NULL),
('Cute Mountains Inn', 202, '2019-09-10', 355, NULL),
('Cute Mountains Inn', 202, '2019-09-11', 220, NULL),
('Cute Mountains Inn', 202, '2019-09-12', 306, NULL),
('Cute Mountains Inn', 202, '2019-09-13', 109, NULL),
('Cute Mountains Inn', 202, '2019-09-14', 164, NULL),
('Cute Mountains Inn', 202, '2019-09-15', 371, NULL),
('Cute Mountains Inn', 202, '2019-09-16', 136, NULL),
('Cute Mountains Inn', 202, '2019-09-17', 196, NULL),
('Cute Mountains Inn', 202, '2019-09-18', 177, NULL),
('Cute Mountains Inn', 202, '2019-09-19', 363, NULL),
('Cute Mountains Inn', 202, '2019-09-20', 288, NULL),
('Cute Mountains Inn', 202, '2019-09-21', 266, NULL),
('Cute Mountains Inn', 202, '2019-09-22', 301, NULL),
('Cute Mountains Inn', 202, '2019-09-23', 393, NULL),
('Cute Mountains Inn', 202, '2019-09-24', 333, NULL),
('Cute Mountains Inn', 202, '2019-09-25', 396, NULL),
('Cute Mountains Inn', 202, '2019-09-26', 376, NULL),
('Cute Mountains Inn', 202, '2019-09-27', 272, NULL),
('Cute Mountains Inn', 202, '2019-09-28', 114, NULL),
('Cute Mountains Inn', 202, '2019-09-29', 292, NULL),
('Cute Mountains Inn', 202, '2019-09-30', 337, NULL),
('Cute Mountains Inn', 202, '2019-10-01', 239, NULL),
('Cute Mountains Inn', 202, '2019-10-02', 144, NULL),
('Cute Mountains Inn', 202, '2019-10-03', 257, NULL),
('Cute Mountains Inn', 202, '2019-10-04', 221, NULL),
('Cute Mountains Inn', 202, '2019-10-05', 293, NULL),
('Cute Mountains Inn', 202, '2019-10-06', 209, NULL),
('Cute Mountains Inn', 202, '2019-10-07', 316, NULL),
('Cute Mountains Inn', 202, '2019-10-08', 376, NULL),
('Cute Mountains Inn', 202, '2019-10-09', 115, NULL),
('Cute Mountains Inn', 202, '2019-10-10', 395, NULL),
('Cute Mountains Inn', 202, '2019-10-11', 123, NULL),
('Cute Mountains Inn', 202, '2019-10-12', 174, NULL),
('Cute Mountains Inn', 202, '2019-10-13', 377, NULL),
('Cute Mountains Inn', 202, '2019-10-14', 240, NULL),
('Cute Mountains Inn', 202, '2019-10-15', 128, NULL),
('Cute Mountains Inn', 202, '2019-10-16', 313, NULL),
('Cute Mountains Inn', 202, '2019-10-17', 363, NULL),
('Cute Mountains Inn', 202, '2019-10-18', 318, NULL),
('Cute Mountains Inn', 202, '2019-10-19', 350, NULL),
('Cute Mountains Inn', 202, '2019-10-20', 110, NULL),
('Cute Mountains Inn', 202, '2019-10-21', 306, NULL),
('Cute Mountains Inn', 202, '2019-10-22', 134, NULL),
('Cute Mountains Inn', 202, '2019-10-23', 250, NULL),
('Cute Mountains Inn', 202, '2019-10-24', 381, NULL),
('Cute Mountains Inn', 202, '2019-10-25', 279, NULL),
('Cute Mountains Inn', 202, '2019-10-26', 357, NULL),
('Cute Mountains Inn', 202, '2019-10-27', 120, NULL),
('Cute Mountains Inn', 202, '2019-10-28', 167, NULL),
('Cute Mountains Inn', 202, '2019-10-29', 211, NULL),
('Cute Mountains Inn', 202, '2019-10-30', 135, NULL),
('Cute Mountains Inn', 202, '2019-10-31', 359, NULL),
('Cute Mountains Inn', 202, '2019-11-01', 207, NULL),
('Cute Mountains Inn', 202, '2019-11-02', 320, NULL),
('Cute Mountains Inn', 202, '2019-11-03', 318, NULL),
('Cute Mountains Inn', 202, '2019-11-04', 217, NULL),
('Cute Mountains Inn', 202, '2019-11-05', 398, NULL),
('Cute Mountains Inn', 202, '2019-11-06', 369, NULL),
('Cute Mountains Inn', 202, '2019-11-07', 242, NULL),
('Cute Mountains Inn', 202, '2019-11-08', 305, NULL),
('Cute Mountains Inn', 202, '2019-11-09', 351, NULL),
('Cute Mountains Inn', 202, '2019-11-10', 338, NULL),
('Cute Mountains Inn', 202, '2019-11-11', 282, NULL),
('Cute Mountains Inn', 202, '2019-11-12', 350, NULL),
('Cute Mountains Inn', 202, '2019-11-13', 323, NULL),
('Cute Mountains Inn', 202, '2019-11-14', 279, NULL),
('Cute Mountains Inn', 202, '2019-11-15', 341, NULL),
('Cute Mountains Inn', 202, '2019-11-16', 360, NULL),
('Cute Mountains Inn', 202, '2019-11-17', 382, NULL),
('Cute Mountains Inn', 202, '2019-11-18', 395, NULL),
('Cute Mountains Inn', 202, '2019-11-19', 362, NULL),
('Cute Mountains Inn', 202, '2019-11-20', 307, NULL),
('Cute Mountains Inn', 202, '2019-11-21', 268, NULL),
('Cute Mountains Inn', 202, '2019-11-22', 242, NULL),
('Cute Mountains Inn', 202, '2019-11-23', 203, NULL),
('Cute Mountains Inn', 202, '2019-11-24', 365, NULL),
('Cute Mountains Inn', 202, '2019-11-25', 378, NULL),
('Cute Mountains Inn', 202, '2019-11-26', 272, NULL),
('Cute Mountains Inn', 202, '2019-11-27', 141, NULL),
('Cute Mountains Inn', 202, '2019-11-28', 237, NULL),
('Cute Mountains Inn', 202, '2019-11-29', 182, NULL),
('Cute Mountains Inn', 202, '2019-11-30', 393, NULL),
('Cute Mountains Inn', 202, '2019-12-01', 305, NULL),
('Cute Mountains Inn', 202, '2019-12-02', 389, NULL),
('Cute Mountains Inn', 202, '2019-12-03', 328, NULL),
('Cute Mountains Inn', 202, '2019-12-04', 383, NULL),
('Cute Mountains Inn', 202, '2019-12-05', 363, NULL),
('Cute Mountains Inn', 202, '2019-12-06', 185, NULL),
('Cute Mountains Inn', 202, '2019-12-07', 329, NULL),
('Cute Mountains Inn', 202, '2019-12-08', 376, NULL),
('Cute Mountains Inn', 202, '2019-12-09', 104, NULL),
('Cute Mountains Inn', 202, '2019-12-10', 110, NULL),
('Cute Mountains Inn', 202, '2019-12-11', 324, NULL),
('Cute Mountains Inn', 202, '2019-12-12', 280, NULL),
('Cute Mountains Inn', 202, '2019-12-13', 307, NULL),
('Cute Mountains Inn', 202, '2019-12-14', 178, NULL),
('Cute Mountains Inn', 202, '2019-12-15', 371, NULL),
('Cute Mountains Inn', 202, '2019-12-16', 369, NULL),
('Cute Mountains Inn', 202, '2019-12-17', 207, NULL),
('Cute Mountains Inn', 202, '2019-12-18', 105, NULL),
('Cute Mountains Inn', 202, '2019-12-19', 106, NULL),
('Cute Mountains Inn', 202, '2019-12-20', 330, NULL),
('Cute Mountains Inn', 202, '2019-12-21', 116, NULL),
('Cute Mountains Inn', 202, '2019-12-22', 293, NULL),
('Cute Mountains Inn', 202, '2019-12-23', 243, NULL),
('Cute Mountains Inn', 202, '2019-12-24', 120, NULL),
('Cute Mountains Inn', 202, '2019-12-25', 112, NULL),
('Cute Mountains Inn', 202, '2019-12-26', 259, NULL),
('Cute Mountains Inn', 202, '2019-12-27', 315, NULL),
('Cute Mountains Inn', 202, '2019-12-28', 379, NULL),
('Cute Mountains Inn', 202, '2019-12-29', 108, NULL),
('Cute Mountains Inn', 202, '2019-12-30', 136, NULL),
('Cute Mountains Inn', 202, '2019-12-31', 300, NULL),
('Cute Mountains Inn', 202, '2020-01-01', 118, NULL),
('Cute Mountains Inn', 202, '2020-01-02', 120, NULL),
('Cute Mountains Inn', 202, '2020-01-03', 316, NULL),
('Cute Mountains Inn', 202, '2020-01-04', 186, NULL),
('Cute Mountains Inn', 202, '2020-01-05', 112, NULL),
('Cute Mountains Inn', 202, '2020-01-06', 340, NULL),
('Cute Mountains Inn', 202, '2020-01-07', 268, NULL),
('Cute Mountains Inn', 202, '2020-01-08', 367, NULL),
('Cute Mountains Inn', 202, '2020-01-09', 387, NULL),
('Cute Mountains Inn', 202, '2020-01-10', 257, NULL),
('Cute Mountains Inn', 202, '2020-01-11', 249, NULL),
('Cute Mountains Inn', 202, '2020-01-12', 151, NULL),
('Cute Mountains Inn', 202, '2020-01-13', 262, NULL),
('Cute Mountains Inn', 202, '2020-01-14', 289, NULL),
('Cute Mountains Inn', 202, '2020-01-15', 299, NULL),
('Cute Mountains Inn', 202, '2020-01-16', 188, NULL),
('Cute Mountains Inn', 202, '2020-01-17', 155, NULL),
('Cute Mountains Inn', 202, '2020-01-18', 133, NULL),
('Cute Mountains Inn', 202, '2020-01-19', 112, NULL),
('Cute Mountains Inn', 202, '2020-01-20', 160, NULL),
('Cute Mountains Inn', 202, '2020-01-21', 326, NULL),
('Cute Mountains Inn', 202, '2020-01-22', 312, NULL),
('Cute Mountains Inn', 202, '2020-01-23', 263, NULL),
('Cute Mountains Inn', 202, '2020-01-24', 183, NULL),
('Cute Mountains Inn', 202, '2020-01-25', 261, NULL),
('Cute Mountains Inn', 202, '2020-01-26', 149, NULL),
('Cute Mountains Inn', 202, '2020-01-27', 325, NULL),
('Cute Mountains Inn', 202, '2020-01-28', 223, NULL),
('Cute Mountains Inn', 202, '2020-01-29', 362, NULL),
('Cute Mountains Inn', 202, '2020-01-30', 143, NULL),
('Cute Mountains Inn', 202, '2020-01-31', 131, NULL),
('Cute Mountains Inn', 202, '2020-02-01', 326, NULL),
('Cute Mountains Inn', 202, '2020-02-02', 254, NULL),
('Cute Mountains Inn', 202, '2020-02-03', 271, NULL),
('Cute Mountains Inn', 202, '2020-02-04', 312, NULL),
('Cute Mountains Inn', 215, '2019-01-01', 154, NULL),
('Cute Mountains Inn', 215, '2019-01-02', 236, NULL),
('Cute Mountains Inn', 215, '2019-01-03', 202, NULL),
('Cute Mountains Inn', 215, '2019-01-04', 281, NULL),
('Cute Mountains Inn', 215, '2019-01-05', 366, NULL),
('Cute Mountains Inn', 215, '2019-01-06', 186, NULL),
('Cute Mountains Inn', 215, '2019-01-07', 358, NULL),
('Cute Mountains Inn', 215, '2019-01-08', 323, NULL),
('Cute Mountains Inn', 215, '2019-01-09', 173, NULL),
('Cute Mountains Inn', 215, '2019-01-10', 241, NULL),
('Cute Mountains Inn', 215, '2019-01-11', 378, NULL),
('Cute Mountains Inn', 215, '2019-01-12', 380, NULL),
('Cute Mountains Inn', 215, '2019-01-13', 288, NULL),
('Cute Mountains Inn', 215, '2019-01-14', 199, NULL),
('Cute Mountains Inn', 215, '2019-01-15', 224, NULL),
('Cute Mountains Inn', 215, '2019-01-16', 394, NULL),
('Cute Mountains Inn', 215, '2019-01-17', 270, NULL),
('Cute Mountains Inn', 215, '2019-01-18', 399, NULL),
('Cute Mountains Inn', 215, '2019-01-19', 206, NULL),
('Cute Mountains Inn', 215, '2019-01-20', 124, NULL),
('Cute Mountains Inn', 215, '2019-01-21', 208, NULL),
('Cute Mountains Inn', 215, '2019-01-22', 267, NULL),
('Cute Mountains Inn', 215, '2019-01-23', 248, NULL),
('Cute Mountains Inn', 215, '2019-01-24', 132, NULL),
('Cute Mountains Inn', 215, '2019-01-25', 130, NULL),
('Cute Mountains Inn', 215, '2019-01-26', 105, NULL),
('Cute Mountains Inn', 215, '2019-01-27', 203, NULL),
('Cute Mountains Inn', 215, '2019-01-28', 236, NULL),
('Cute Mountains Inn', 215, '2019-01-29', 338, NULL),
('Cute Mountains Inn', 215, '2019-01-30', 293, NULL),
('Cute Mountains Inn', 215, '2019-01-31', 138, NULL),
('Cute Mountains Inn', 215, '2019-02-01', 293, NULL),
('Cute Mountains Inn', 215, '2019-02-02', 317, NULL),
('Cute Mountains Inn', 215, '2019-02-03', 157, NULL),
('Cute Mountains Inn', 215, '2019-02-04', 179, NULL),
('Cute Mountains Inn', 215, '2019-02-05', 127, NULL),
('Cute Mountains Inn', 215, '2019-02-06', 126, NULL),
('Cute Mountains Inn', 215, '2019-02-07', 350, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 215, '2019-02-08', 201, NULL),
('Cute Mountains Inn', 215, '2019-02-09', 275, NULL),
('Cute Mountains Inn', 215, '2019-02-10', 158, NULL),
('Cute Mountains Inn', 215, '2019-02-11', 262, NULL),
('Cute Mountains Inn', 215, '2019-02-12', 245, NULL),
('Cute Mountains Inn', 215, '2019-02-13', 326, NULL),
('Cute Mountains Inn', 215, '2019-02-14', 380, NULL),
('Cute Mountains Inn', 215, '2019-02-15', 266, NULL),
('Cute Mountains Inn', 215, '2019-02-16', 132, NULL),
('Cute Mountains Inn', 215, '2019-02-17', 212, NULL),
('Cute Mountains Inn', 215, '2019-02-18', 226, NULL),
('Cute Mountains Inn', 215, '2019-02-19', 356, NULL),
('Cute Mountains Inn', 215, '2019-02-20', 242, NULL),
('Cute Mountains Inn', 215, '2019-02-21', 217, NULL),
('Cute Mountains Inn', 215, '2019-02-22', 297, NULL),
('Cute Mountains Inn', 215, '2019-02-23', 169, NULL),
('Cute Mountains Inn', 215, '2019-02-24', 250, NULL),
('Cute Mountains Inn', 215, '2019-02-25', 350, NULL),
('Cute Mountains Inn', 215, '2019-02-26', 139, NULL),
('Cute Mountains Inn', 215, '2019-02-27', 172, NULL),
('Cute Mountains Inn', 215, '2019-02-28', 345, NULL),
('Cute Mountains Inn', 215, '2019-03-01', 266, NULL),
('Cute Mountains Inn', 215, '2019-03-02', 251, NULL),
('Cute Mountains Inn', 215, '2019-03-03', 191, NULL),
('Cute Mountains Inn', 215, '2019-03-04', 322, NULL),
('Cute Mountains Inn', 215, '2019-03-05', 253, NULL),
('Cute Mountains Inn', 215, '2019-03-06', 200, NULL),
('Cute Mountains Inn', 215, '2019-03-07', 282, NULL),
('Cute Mountains Inn', 215, '2019-03-08', 229, NULL),
('Cute Mountains Inn', 215, '2019-03-09', 303, NULL),
('Cute Mountains Inn', 215, '2019-03-10', 366, NULL),
('Cute Mountains Inn', 215, '2019-03-11', 165, NULL),
('Cute Mountains Inn', 215, '2019-03-12', 224, NULL),
('Cute Mountains Inn', 215, '2019-03-13', 397, NULL),
('Cute Mountains Inn', 215, '2019-03-14', 282, NULL),
('Cute Mountains Inn', 215, '2019-03-15', 229, NULL),
('Cute Mountains Inn', 215, '2019-03-16', 335, NULL),
('Cute Mountains Inn', 215, '2019-03-17', 328, NULL),
('Cute Mountains Inn', 215, '2019-03-18', 340, NULL),
('Cute Mountains Inn', 215, '2019-03-19', 223, NULL),
('Cute Mountains Inn', 215, '2019-03-20', 289, NULL),
('Cute Mountains Inn', 215, '2019-03-21', 282, NULL),
('Cute Mountains Inn', 215, '2019-03-22', 360, NULL),
('Cute Mountains Inn', 215, '2019-03-23', 323, NULL),
('Cute Mountains Inn', 215, '2019-03-24', 283, NULL),
('Cute Mountains Inn', 215, '2019-03-25', 324, NULL),
('Cute Mountains Inn', 215, '2019-03-26', 386, NULL),
('Cute Mountains Inn', 215, '2019-03-27', 257, NULL),
('Cute Mountains Inn', 215, '2019-03-28', 376, NULL),
('Cute Mountains Inn', 215, '2019-03-29', 118, NULL),
('Cute Mountains Inn', 215, '2019-03-30', 174, NULL),
('Cute Mountains Inn', 215, '2019-03-31', 272, NULL),
('Cute Mountains Inn', 215, '2019-04-01', 245, NULL),
('Cute Mountains Inn', 215, '2019-04-02', 145, NULL),
('Cute Mountains Inn', 215, '2019-04-03', 265, NULL),
('Cute Mountains Inn', 215, '2019-04-04', 219, NULL),
('Cute Mountains Inn', 215, '2019-04-05', 106, NULL),
('Cute Mountains Inn', 215, '2019-04-06', 281, NULL),
('Cute Mountains Inn', 215, '2019-04-07', 229, NULL),
('Cute Mountains Inn', 215, '2019-04-08', 195, NULL),
('Cute Mountains Inn', 215, '2019-04-09', 156, NULL),
('Cute Mountains Inn', 215, '2019-04-10', 130, NULL),
('Cute Mountains Inn', 215, '2019-04-11', 392, NULL),
('Cute Mountains Inn', 215, '2019-04-12', 138, NULL),
('Cute Mountains Inn', 215, '2019-04-13', 353, NULL),
('Cute Mountains Inn', 215, '2019-04-14', 321, NULL),
('Cute Mountains Inn', 215, '2019-04-15', 324, NULL),
('Cute Mountains Inn', 215, '2019-04-16', 263, NULL),
('Cute Mountains Inn', 215, '2019-04-17', 176, NULL),
('Cute Mountains Inn', 215, '2019-04-18', 110, NULL),
('Cute Mountains Inn', 215, '2019-04-19', 368, NULL),
('Cute Mountains Inn', 215, '2019-04-20', 249, NULL),
('Cute Mountains Inn', 215, '2019-04-21', 336, NULL),
('Cute Mountains Inn', 215, '2019-04-22', 333, NULL),
('Cute Mountains Inn', 215, '2019-04-23', 237, NULL),
('Cute Mountains Inn', 215, '2019-04-24', 312, NULL),
('Cute Mountains Inn', 215, '2019-04-25', 192, NULL),
('Cute Mountains Inn', 215, '2019-04-26', 107, NULL),
('Cute Mountains Inn', 215, '2019-04-27', 345, NULL),
('Cute Mountains Inn', 215, '2019-04-28', 201, NULL),
('Cute Mountains Inn', 215, '2019-04-29', 313, NULL),
('Cute Mountains Inn', 215, '2019-04-30', 387, NULL),
('Cute Mountains Inn', 215, '2019-05-01', 348, NULL),
('Cute Mountains Inn', 215, '2019-05-02', 341, NULL),
('Cute Mountains Inn', 215, '2019-05-03', 306, NULL),
('Cute Mountains Inn', 215, '2019-05-04', 200, NULL),
('Cute Mountains Inn', 215, '2019-05-05', 147, NULL),
('Cute Mountains Inn', 215, '2019-05-06', 107, NULL),
('Cute Mountains Inn', 215, '2019-05-07', 386, NULL),
('Cute Mountains Inn', 215, '2019-05-08', 299, NULL),
('Cute Mountains Inn', 215, '2019-05-09', 313, NULL),
('Cute Mountains Inn', 215, '2019-05-10', 254, NULL),
('Cute Mountains Inn', 215, '2019-05-11', 139, NULL),
('Cute Mountains Inn', 215, '2019-05-12', 352, NULL),
('Cute Mountains Inn', 215, '2019-05-13', 227, NULL),
('Cute Mountains Inn', 215, '2019-05-14', 344, NULL),
('Cute Mountains Inn', 215, '2019-05-15', 223, NULL),
('Cute Mountains Inn', 215, '2019-05-16', 299, NULL),
('Cute Mountains Inn', 215, '2019-05-17', 231, NULL),
('Cute Mountains Inn', 215, '2019-05-18', 261, NULL),
('Cute Mountains Inn', 215, '2019-05-19', 360, NULL),
('Cute Mountains Inn', 215, '2019-05-20', 259, NULL),
('Cute Mountains Inn', 215, '2019-05-21', 113, NULL),
('Cute Mountains Inn', 215, '2019-05-22', 297, NULL),
('Cute Mountains Inn', 215, '2019-05-23', 194, NULL),
('Cute Mountains Inn', 215, '2019-05-24', 313, NULL),
('Cute Mountains Inn', 215, '2019-05-25', 300, NULL),
('Cute Mountains Inn', 215, '2019-05-26', 224, NULL),
('Cute Mountains Inn', 215, '2019-05-27', 111, NULL),
('Cute Mountains Inn', 215, '2019-05-28', 213, NULL),
('Cute Mountains Inn', 215, '2019-05-29', 194, NULL),
('Cute Mountains Inn', 215, '2019-05-30', 242, NULL),
('Cute Mountains Inn', 215, '2019-05-31', 368, NULL),
('Cute Mountains Inn', 215, '2019-06-01', 256, NULL),
('Cute Mountains Inn', 215, '2019-06-02', 107, NULL),
('Cute Mountains Inn', 215, '2019-06-03', 241, NULL),
('Cute Mountains Inn', 215, '2019-06-04', 194, NULL),
('Cute Mountains Inn', 215, '2019-06-05', 244, NULL),
('Cute Mountains Inn', 215, '2019-06-06', 226, NULL),
('Cute Mountains Inn', 215, '2019-06-07', 171, NULL),
('Cute Mountains Inn', 215, '2019-06-08', 172, NULL),
('Cute Mountains Inn', 215, '2019-06-09', 150, NULL),
('Cute Mountains Inn', 215, '2019-06-10', 126, NULL),
('Cute Mountains Inn', 215, '2019-06-11', 236, NULL),
('Cute Mountains Inn', 215, '2019-06-12', 316, NULL),
('Cute Mountains Inn', 215, '2019-06-13', 165, NULL),
('Cute Mountains Inn', 215, '2019-06-14', 386, NULL),
('Cute Mountains Inn', 215, '2019-06-15', 367, NULL),
('Cute Mountains Inn', 215, '2019-06-16', 161, NULL),
('Cute Mountains Inn', 215, '2019-06-17', 207, NULL),
('Cute Mountains Inn', 215, '2019-06-18', 324, NULL),
('Cute Mountains Inn', 215, '2019-06-19', 302, NULL),
('Cute Mountains Inn', 215, '2019-06-20', 215, NULL),
('Cute Mountains Inn', 215, '2019-06-21', 154, NULL),
('Cute Mountains Inn', 215, '2019-06-22', 124, NULL),
('Cute Mountains Inn', 215, '2019-06-23', 223, NULL),
('Cute Mountains Inn', 215, '2019-06-24', 318, NULL),
('Cute Mountains Inn', 215, '2019-06-25', 309, NULL),
('Cute Mountains Inn', 215, '2019-06-26', 173, NULL),
('Cute Mountains Inn', 215, '2019-06-27', 134, NULL),
('Cute Mountains Inn', 215, '2019-06-28', 224, NULL),
('Cute Mountains Inn', 215, '2019-06-29', 156, NULL),
('Cute Mountains Inn', 215, '2019-06-30', 361, NULL),
('Cute Mountains Inn', 215, '2019-07-01', 367, NULL),
('Cute Mountains Inn', 215, '2019-07-02', 293, NULL),
('Cute Mountains Inn', 215, '2019-07-03', 384, NULL),
('Cute Mountains Inn', 215, '2019-07-04', 352, NULL),
('Cute Mountains Inn', 215, '2019-07-05', 164, NULL),
('Cute Mountains Inn', 215, '2019-07-06', 324, NULL),
('Cute Mountains Inn', 215, '2019-07-07', 329, NULL),
('Cute Mountains Inn', 215, '2019-07-08', 211, NULL),
('Cute Mountains Inn', 215, '2019-07-09', 266, NULL),
('Cute Mountains Inn', 215, '2019-07-10', 258, NULL),
('Cute Mountains Inn', 215, '2019-07-11', 327, NULL),
('Cute Mountains Inn', 215, '2019-07-12', 106, NULL),
('Cute Mountains Inn', 215, '2019-07-13', 116, NULL),
('Cute Mountains Inn', 215, '2019-07-14', 162, NULL),
('Cute Mountains Inn', 215, '2019-07-15', 116, NULL),
('Cute Mountains Inn', 215, '2019-07-16', 303, NULL),
('Cute Mountains Inn', 215, '2019-07-17', 274, NULL),
('Cute Mountains Inn', 215, '2019-07-18', 397, NULL),
('Cute Mountains Inn', 215, '2019-07-19', 274, NULL),
('Cute Mountains Inn', 215, '2019-07-20', 273, NULL),
('Cute Mountains Inn', 215, '2019-07-21', 358, NULL),
('Cute Mountains Inn', 215, '2019-07-22', 251, NULL),
('Cute Mountains Inn', 215, '2019-07-23', 136, NULL),
('Cute Mountains Inn', 215, '2019-07-24', 375, NULL),
('Cute Mountains Inn', 215, '2019-07-25', 348, NULL),
('Cute Mountains Inn', 215, '2019-07-26', 128, NULL),
('Cute Mountains Inn', 215, '2019-07-27', 331, NULL),
('Cute Mountains Inn', 215, '2019-07-28', 305, NULL),
('Cute Mountains Inn', 215, '2019-07-29', 299, NULL),
('Cute Mountains Inn', 215, '2019-07-30', 261, NULL),
('Cute Mountains Inn', 215, '2019-07-31', 169, NULL),
('Cute Mountains Inn', 215, '2019-08-01', 298, NULL),
('Cute Mountains Inn', 215, '2019-08-02', 339, NULL),
('Cute Mountains Inn', 215, '2019-08-03', 142, NULL),
('Cute Mountains Inn', 215, '2019-08-04', 210, NULL),
('Cute Mountains Inn', 215, '2019-08-05', 335, NULL),
('Cute Mountains Inn', 215, '2019-08-06', 233, NULL),
('Cute Mountains Inn', 215, '2019-08-07', 105, NULL),
('Cute Mountains Inn', 215, '2019-08-08', 178, NULL),
('Cute Mountains Inn', 215, '2019-08-09', 397, NULL),
('Cute Mountains Inn', 215, '2019-08-10', 178, NULL),
('Cute Mountains Inn', 215, '2019-08-11', 326, NULL),
('Cute Mountains Inn', 215, '2019-08-12', 194, NULL),
('Cute Mountains Inn', 215, '2019-08-13', 255, NULL),
('Cute Mountains Inn', 215, '2019-08-14', 276, NULL),
('Cute Mountains Inn', 215, '2019-08-15', 304, NULL),
('Cute Mountains Inn', 215, '2019-08-16', 163, NULL),
('Cute Mountains Inn', 215, '2019-08-17', 387, NULL),
('Cute Mountains Inn', 215, '2019-08-18', 154, NULL),
('Cute Mountains Inn', 215, '2019-08-19', 292, NULL),
('Cute Mountains Inn', 215, '2019-08-20', 374, NULL),
('Cute Mountains Inn', 215, '2019-08-21', 186, NULL),
('Cute Mountains Inn', 215, '2019-08-22', 338, NULL),
('Cute Mountains Inn', 215, '2019-08-23', 363, NULL),
('Cute Mountains Inn', 215, '2019-08-24', 110, NULL),
('Cute Mountains Inn', 215, '2019-08-25', 146, NULL),
('Cute Mountains Inn', 215, '2019-08-26', 150, NULL),
('Cute Mountains Inn', 215, '2019-08-27', 150, NULL),
('Cute Mountains Inn', 215, '2019-08-28', 267, NULL),
('Cute Mountains Inn', 215, '2019-08-29', 188, NULL),
('Cute Mountains Inn', 215, '2019-08-30', 335, NULL),
('Cute Mountains Inn', 215, '2019-08-31', 145, NULL),
('Cute Mountains Inn', 215, '2019-09-01', 367, NULL),
('Cute Mountains Inn', 215, '2019-09-02', 138, NULL),
('Cute Mountains Inn', 215, '2019-09-03', 158, NULL),
('Cute Mountains Inn', 215, '2019-09-04', 310, NULL),
('Cute Mountains Inn', 215, '2019-09-05', 284, NULL),
('Cute Mountains Inn', 215, '2019-09-06', 280, NULL),
('Cute Mountains Inn', 215, '2019-09-07', 342, NULL),
('Cute Mountains Inn', 215, '2019-09-08', 115, NULL),
('Cute Mountains Inn', 215, '2019-09-09', 339, NULL),
('Cute Mountains Inn', 215, '2019-09-10', 231, NULL),
('Cute Mountains Inn', 215, '2019-09-11', 257, NULL),
('Cute Mountains Inn', 215, '2019-09-12', 331, NULL),
('Cute Mountains Inn', 215, '2019-09-13', 212, NULL),
('Cute Mountains Inn', 215, '2019-09-14', 316, NULL),
('Cute Mountains Inn', 215, '2019-09-15', 246, NULL),
('Cute Mountains Inn', 215, '2019-09-16', 355, NULL),
('Cute Mountains Inn', 215, '2019-09-17', 226, NULL),
('Cute Mountains Inn', 215, '2019-09-18', 159, NULL),
('Cute Mountains Inn', 215, '2019-09-19', 317, NULL),
('Cute Mountains Inn', 215, '2019-09-20', 213, NULL),
('Cute Mountains Inn', 215, '2019-09-21', 136, NULL),
('Cute Mountains Inn', 215, '2019-09-22', 131, NULL),
('Cute Mountains Inn', 215, '2019-09-23', 196, NULL),
('Cute Mountains Inn', 215, '2019-09-24', 329, NULL),
('Cute Mountains Inn', 215, '2019-09-25', 157, NULL),
('Cute Mountains Inn', 215, '2019-09-26', 271, NULL),
('Cute Mountains Inn', 215, '2019-09-27', 159, NULL),
('Cute Mountains Inn', 215, '2019-09-28', 215, NULL),
('Cute Mountains Inn', 215, '2019-09-29', 337, NULL),
('Cute Mountains Inn', 215, '2019-09-30', 358, NULL),
('Cute Mountains Inn', 215, '2019-10-01', 363, NULL),
('Cute Mountains Inn', 215, '2019-10-02', 373, NULL),
('Cute Mountains Inn', 215, '2019-10-03', 158, NULL),
('Cute Mountains Inn', 215, '2019-10-04', 350, NULL),
('Cute Mountains Inn', 215, '2019-10-05', 321, NULL),
('Cute Mountains Inn', 215, '2019-10-06', 254, NULL),
('Cute Mountains Inn', 215, '2019-10-07', 279, NULL),
('Cute Mountains Inn', 215, '2019-10-08', 303, NULL),
('Cute Mountains Inn', 215, '2019-10-09', 123, NULL),
('Cute Mountains Inn', 215, '2019-10-10', 321, NULL),
('Cute Mountains Inn', 215, '2019-10-11', 130, NULL),
('Cute Mountains Inn', 215, '2019-10-12', 188, NULL),
('Cute Mountains Inn', 215, '2019-10-13', 163, NULL),
('Cute Mountains Inn', 215, '2019-10-14', 350, NULL),
('Cute Mountains Inn', 215, '2019-10-15', 252, NULL),
('Cute Mountains Inn', 215, '2019-10-16', 224, NULL),
('Cute Mountains Inn', 215, '2019-10-17', 363, NULL),
('Cute Mountains Inn', 215, '2019-10-18', 326, NULL),
('Cute Mountains Inn', 215, '2019-10-19', 252, NULL),
('Cute Mountains Inn', 215, '2019-10-20', 228, NULL),
('Cute Mountains Inn', 215, '2019-10-21', 345, NULL),
('Cute Mountains Inn', 215, '2019-10-22', 379, NULL),
('Cute Mountains Inn', 215, '2019-10-23', 172, NULL),
('Cute Mountains Inn', 215, '2019-10-24', 328, NULL),
('Cute Mountains Inn', 215, '2019-10-25', 323, NULL),
('Cute Mountains Inn', 215, '2019-10-26', 273, NULL),
('Cute Mountains Inn', 215, '2019-10-27', 385, NULL),
('Cute Mountains Inn', 215, '2019-10-28', 378, NULL),
('Cute Mountains Inn', 215, '2019-10-29', 320, NULL),
('Cute Mountains Inn', 215, '2019-10-30', 115, NULL),
('Cute Mountains Inn', 215, '2019-10-31', 329, NULL),
('Cute Mountains Inn', 215, '2019-11-01', 142, NULL),
('Cute Mountains Inn', 215, '2019-11-02', 277, NULL),
('Cute Mountains Inn', 215, '2019-11-03', 208, NULL),
('Cute Mountains Inn', 215, '2019-11-04', 191, NULL),
('Cute Mountains Inn', 215, '2019-11-05', 176, NULL),
('Cute Mountains Inn', 215, '2019-11-06', 162, NULL),
('Cute Mountains Inn', 215, '2019-11-07', 354, NULL),
('Cute Mountains Inn', 215, '2019-11-08', 309, NULL),
('Cute Mountains Inn', 215, '2019-11-09', 350, NULL),
('Cute Mountains Inn', 215, '2019-11-10', 288, NULL),
('Cute Mountains Inn', 215, '2019-11-11', 385, NULL),
('Cute Mountains Inn', 215, '2019-11-12', 108, NULL),
('Cute Mountains Inn', 215, '2019-11-13', 308, NULL),
('Cute Mountains Inn', 215, '2019-11-14', 355, NULL),
('Cute Mountains Inn', 215, '2019-11-15', 181, NULL),
('Cute Mountains Inn', 215, '2019-11-16', 234, NULL),
('Cute Mountains Inn', 215, '2019-11-17', 211, NULL),
('Cute Mountains Inn', 215, '2019-11-18', 250, NULL),
('Cute Mountains Inn', 215, '2019-11-19', 305, NULL),
('Cute Mountains Inn', 215, '2019-11-20', 382, NULL),
('Cute Mountains Inn', 215, '2019-11-21', 367, NULL),
('Cute Mountains Inn', 215, '2019-11-22', 211, NULL),
('Cute Mountains Inn', 215, '2019-11-23', 294, NULL),
('Cute Mountains Inn', 215, '2019-11-24', 145, NULL),
('Cute Mountains Inn', 215, '2019-11-25', 161, NULL),
('Cute Mountains Inn', 215, '2019-11-26', 296, NULL),
('Cute Mountains Inn', 215, '2019-11-27', 266, NULL),
('Cute Mountains Inn', 215, '2019-11-28', 198, NULL),
('Cute Mountains Inn', 215, '2019-11-29', 391, NULL),
('Cute Mountains Inn', 215, '2019-11-30', 274, NULL),
('Cute Mountains Inn', 215, '2019-12-01', 259, NULL),
('Cute Mountains Inn', 215, '2019-12-02', 276, NULL),
('Cute Mountains Inn', 215, '2019-12-03', 339, NULL),
('Cute Mountains Inn', 215, '2019-12-04', 321, NULL),
('Cute Mountains Inn', 215, '2019-12-05', 329, NULL),
('Cute Mountains Inn', 215, '2019-12-06', 300, NULL),
('Cute Mountains Inn', 215, '2019-12-07', 123, NULL),
('Cute Mountains Inn', 215, '2019-12-08', 364, NULL),
('Cute Mountains Inn', 215, '2019-12-09', 348, NULL),
('Cute Mountains Inn', 215, '2019-12-10', 199, NULL),
('Cute Mountains Inn', 215, '2019-12-11', 102, NULL),
('Cute Mountains Inn', 215, '2019-12-12', 123, NULL),
('Cute Mountains Inn', 215, '2019-12-13', 326, NULL),
('Cute Mountains Inn', 215, '2019-12-14', 128, NULL),
('Cute Mountains Inn', 215, '2019-12-15', 351, NULL),
('Cute Mountains Inn', 215, '2019-12-16', 303, NULL),
('Cute Mountains Inn', 215, '2019-12-17', 399, NULL),
('Cute Mountains Inn', 215, '2019-12-18', 327, NULL),
('Cute Mountains Inn', 215, '2019-12-19', 132, NULL),
('Cute Mountains Inn', 215, '2019-12-20', 149, NULL),
('Cute Mountains Inn', 215, '2019-12-21', 164, NULL),
('Cute Mountains Inn', 215, '2019-12-22', 265, NULL),
('Cute Mountains Inn', 215, '2019-12-23', 102, NULL),
('Cute Mountains Inn', 215, '2019-12-24', 296, NULL),
('Cute Mountains Inn', 215, '2019-12-25', 189, NULL),
('Cute Mountains Inn', 215, '2019-12-26', 353, NULL),
('Cute Mountains Inn', 215, '2019-12-27', 304, NULL),
('Cute Mountains Inn', 215, '2019-12-28', 376, NULL),
('Cute Mountains Inn', 215, '2019-12-29', 179, NULL),
('Cute Mountains Inn', 215, '2019-12-30', 273, NULL),
('Cute Mountains Inn', 215, '2019-12-31', 286, NULL),
('Cute Mountains Inn', 215, '2020-01-01', 248, NULL),
('Cute Mountains Inn', 215, '2020-01-02', 165, NULL),
('Cute Mountains Inn', 215, '2020-01-03', 347, NULL),
('Cute Mountains Inn', 215, '2020-01-04', 322, NULL),
('Cute Mountains Inn', 215, '2020-01-05', 123, NULL),
('Cute Mountains Inn', 215, '2020-01-06', 350, NULL),
('Cute Mountains Inn', 215, '2020-01-07', 382, NULL),
('Cute Mountains Inn', 215, '2020-01-08', 223, NULL),
('Cute Mountains Inn', 215, '2020-01-09', 137, NULL),
('Cute Mountains Inn', 215, '2020-01-10', 104, NULL),
('Cute Mountains Inn', 215, '2020-01-11', 123, NULL),
('Cute Mountains Inn', 215, '2020-01-12', 227, NULL),
('Cute Mountains Inn', 215, '2020-01-13', 347, NULL),
('Cute Mountains Inn', 215, '2020-01-14', 210, NULL),
('Cute Mountains Inn', 215, '2020-01-15', 216, NULL),
('Cute Mountains Inn', 215, '2020-01-16', 372, NULL),
('Cute Mountains Inn', 215, '2020-01-17', 338, NULL),
('Cute Mountains Inn', 215, '2020-01-18', 240, NULL),
('Cute Mountains Inn', 215, '2020-01-19', 213, NULL),
('Cute Mountains Inn', 215, '2020-01-20', 191, NULL),
('Cute Mountains Inn', 215, '2020-01-21', 198, NULL),
('Cute Mountains Inn', 215, '2020-01-22', 387, NULL),
('Cute Mountains Inn', 215, '2020-01-23', 295, NULL),
('Cute Mountains Inn', 215, '2020-01-24', 368, NULL),
('Cute Mountains Inn', 215, '2020-01-25', 154, NULL),
('Cute Mountains Inn', 215, '2020-01-26', 115, NULL),
('Cute Mountains Inn', 215, '2020-01-27', 102, NULL),
('Cute Mountains Inn', 215, '2020-01-28', 185, NULL),
('Cute Mountains Inn', 215, '2020-01-29', 307, NULL),
('Cute Mountains Inn', 215, '2020-01-30', 351, NULL),
('Cute Mountains Inn', 215, '2020-01-31', 266, NULL),
('Cute Mountains Inn', 215, '2020-02-01', 377, NULL),
('Cute Mountains Inn', 215, '2020-02-02', 350, NULL),
('Cute Mountains Inn', 215, '2020-02-03', 127, NULL),
('Cute Mountains Inn', 215, '2020-02-04', 305, NULL),
('Cute Mountains Inn', 218, '2019-01-01', 360, NULL),
('Cute Mountains Inn', 218, '2019-01-02', 125, NULL),
('Cute Mountains Inn', 218, '2019-01-03', 156, NULL),
('Cute Mountains Inn', 218, '2019-01-04', 283, NULL),
('Cute Mountains Inn', 218, '2019-01-05', 116, NULL),
('Cute Mountains Inn', 218, '2019-01-06', 302, NULL),
('Cute Mountains Inn', 218, '2019-01-07', 192, NULL),
('Cute Mountains Inn', 218, '2019-01-08', 217, NULL),
('Cute Mountains Inn', 218, '2019-01-09', 350, NULL),
('Cute Mountains Inn', 218, '2019-01-10', 249, NULL),
('Cute Mountains Inn', 218, '2019-01-11', 219, NULL),
('Cute Mountains Inn', 218, '2019-01-12', 156, NULL),
('Cute Mountains Inn', 218, '2019-01-13', 230, NULL),
('Cute Mountains Inn', 218, '2019-01-14', 185, NULL),
('Cute Mountains Inn', 218, '2019-01-15', 312, NULL),
('Cute Mountains Inn', 218, '2019-01-16', 320, NULL),
('Cute Mountains Inn', 218, '2019-01-17', 235, NULL),
('Cute Mountains Inn', 218, '2019-01-18', 277, NULL),
('Cute Mountains Inn', 218, '2019-01-19', 385, NULL),
('Cute Mountains Inn', 218, '2019-01-20', 312, NULL),
('Cute Mountains Inn', 218, '2019-01-21', 139, NULL),
('Cute Mountains Inn', 218, '2019-01-22', 243, NULL),
('Cute Mountains Inn', 218, '2019-01-23', 101, NULL),
('Cute Mountains Inn', 218, '2019-01-24', 292, NULL),
('Cute Mountains Inn', 218, '2019-01-25', 117, NULL),
('Cute Mountains Inn', 218, '2019-01-26', 149, NULL),
('Cute Mountains Inn', 218, '2019-01-27', 310, NULL),
('Cute Mountains Inn', 218, '2019-01-28', 284, NULL),
('Cute Mountains Inn', 218, '2019-01-29', 237, NULL),
('Cute Mountains Inn', 218, '2019-01-30', 207, NULL),
('Cute Mountains Inn', 218, '2019-01-31', 279, NULL),
('Cute Mountains Inn', 218, '2019-02-01', 341, NULL),
('Cute Mountains Inn', 218, '2019-02-02', 341, NULL),
('Cute Mountains Inn', 218, '2019-02-03', 132, NULL),
('Cute Mountains Inn', 218, '2019-02-04', 118, NULL),
('Cute Mountains Inn', 218, '2019-02-05', 319, NULL),
('Cute Mountains Inn', 218, '2019-02-06', 170, NULL),
('Cute Mountains Inn', 218, '2019-02-07', 323, NULL),
('Cute Mountains Inn', 218, '2019-02-08', 258, NULL),
('Cute Mountains Inn', 218, '2019-02-09', 257, NULL),
('Cute Mountains Inn', 218, '2019-02-10', 128, NULL),
('Cute Mountains Inn', 218, '2019-02-11', 150, NULL),
('Cute Mountains Inn', 218, '2019-02-12', 173, NULL),
('Cute Mountains Inn', 218, '2019-02-13', 224, NULL),
('Cute Mountains Inn', 218, '2019-02-14', 224, NULL),
('Cute Mountains Inn', 218, '2019-02-15', 237, NULL),
('Cute Mountains Inn', 218, '2019-02-16', 357, NULL),
('Cute Mountains Inn', 218, '2019-02-17', 238, NULL),
('Cute Mountains Inn', 218, '2019-02-18', 167, NULL),
('Cute Mountains Inn', 218, '2019-02-19', 152, NULL),
('Cute Mountains Inn', 218, '2019-02-20', 165, NULL),
('Cute Mountains Inn', 218, '2019-02-21', 225, NULL),
('Cute Mountains Inn', 218, '2019-02-22', 371, NULL),
('Cute Mountains Inn', 218, '2019-02-23', 312, NULL),
('Cute Mountains Inn', 218, '2019-02-24', 270, NULL),
('Cute Mountains Inn', 218, '2019-02-25', 356, NULL),
('Cute Mountains Inn', 218, '2019-02-26', 274, NULL),
('Cute Mountains Inn', 218, '2019-02-27', 119, NULL),
('Cute Mountains Inn', 218, '2019-02-28', 221, NULL),
('Cute Mountains Inn', 218, '2019-03-01', 200, NULL),
('Cute Mountains Inn', 218, '2019-03-02', 242, NULL),
('Cute Mountains Inn', 218, '2019-03-03', 378, NULL),
('Cute Mountains Inn', 218, '2019-03-04', 263, NULL),
('Cute Mountains Inn', 218, '2019-03-05', 109, NULL),
('Cute Mountains Inn', 218, '2019-03-06', 139, NULL),
('Cute Mountains Inn', 218, '2019-03-07', 117, NULL),
('Cute Mountains Inn', 218, '2019-03-08', 196, NULL),
('Cute Mountains Inn', 218, '2019-03-09', 339, NULL),
('Cute Mountains Inn', 218, '2019-03-10', 161, NULL),
('Cute Mountains Inn', 218, '2019-03-11', 392, NULL),
('Cute Mountains Inn', 218, '2019-03-12', 352, NULL),
('Cute Mountains Inn', 218, '2019-03-13', 108, NULL),
('Cute Mountains Inn', 218, '2019-03-14', 143, NULL),
('Cute Mountains Inn', 218, '2019-03-15', 312, NULL),
('Cute Mountains Inn', 218, '2019-03-16', 252, NULL),
('Cute Mountains Inn', 218, '2019-03-17', 392, NULL),
('Cute Mountains Inn', 218, '2019-03-18', 282, NULL),
('Cute Mountains Inn', 218, '2019-03-19', 373, NULL),
('Cute Mountains Inn', 218, '2019-03-20', 160, NULL),
('Cute Mountains Inn', 218, '2019-03-21', 276, NULL),
('Cute Mountains Inn', 218, '2019-03-22', 271, NULL),
('Cute Mountains Inn', 218, '2019-03-23', 122, NULL),
('Cute Mountains Inn', 218, '2019-03-24', 198, NULL),
('Cute Mountains Inn', 218, '2019-03-25', 322, NULL),
('Cute Mountains Inn', 218, '2019-03-26', 345, NULL),
('Cute Mountains Inn', 218, '2019-03-27', 278, NULL),
('Cute Mountains Inn', 218, '2019-03-28', 128, NULL),
('Cute Mountains Inn', 218, '2019-03-29', 334, NULL),
('Cute Mountains Inn', 218, '2019-03-30', 349, NULL),
('Cute Mountains Inn', 218, '2019-03-31', 284, NULL),
('Cute Mountains Inn', 218, '2019-04-01', 201, NULL),
('Cute Mountains Inn', 218, '2019-04-02', 314, NULL),
('Cute Mountains Inn', 218, '2019-04-03', 210, NULL),
('Cute Mountains Inn', 218, '2019-04-04', 392, NULL),
('Cute Mountains Inn', 218, '2019-04-05', 283, NULL),
('Cute Mountains Inn', 218, '2019-04-06', 399, NULL),
('Cute Mountains Inn', 218, '2019-04-07', 368, NULL),
('Cute Mountains Inn', 218, '2019-04-08', 102, NULL),
('Cute Mountains Inn', 218, '2019-04-09', 208, NULL),
('Cute Mountains Inn', 218, '2019-04-10', 230, NULL),
('Cute Mountains Inn', 218, '2019-04-11', 216, NULL),
('Cute Mountains Inn', 218, '2019-04-12', 189, NULL),
('Cute Mountains Inn', 218, '2019-04-13', 266, NULL),
('Cute Mountains Inn', 218, '2019-04-14', 166, NULL),
('Cute Mountains Inn', 218, '2019-04-15', 154, NULL),
('Cute Mountains Inn', 218, '2019-04-16', 331, NULL),
('Cute Mountains Inn', 218, '2019-04-17', 136, NULL),
('Cute Mountains Inn', 218, '2019-04-18', 214, NULL),
('Cute Mountains Inn', 218, '2019-04-19', 327, NULL),
('Cute Mountains Inn', 218, '2019-04-20', 330, NULL),
('Cute Mountains Inn', 218, '2019-04-21', 346, NULL),
('Cute Mountains Inn', 218, '2019-04-22', 249, NULL),
('Cute Mountains Inn', 218, '2019-04-23', 394, NULL),
('Cute Mountains Inn', 218, '2019-04-24', 241, NULL),
('Cute Mountains Inn', 218, '2019-04-25', 104, NULL),
('Cute Mountains Inn', 218, '2019-04-26', 399, NULL),
('Cute Mountains Inn', 218, '2019-04-27', 374, NULL),
('Cute Mountains Inn', 218, '2019-04-28', 271, NULL),
('Cute Mountains Inn', 218, '2019-04-29', 138, NULL),
('Cute Mountains Inn', 218, '2019-04-30', 139, NULL),
('Cute Mountains Inn', 218, '2019-05-01', 248, NULL),
('Cute Mountains Inn', 218, '2019-05-02', 255, NULL),
('Cute Mountains Inn', 218, '2019-05-03', 276, NULL),
('Cute Mountains Inn', 218, '2019-05-04', 210, NULL),
('Cute Mountains Inn', 218, '2019-05-05', 370, NULL),
('Cute Mountains Inn', 218, '2019-05-06', 356, NULL),
('Cute Mountains Inn', 218, '2019-05-07', 120, NULL),
('Cute Mountains Inn', 218, '2019-05-08', 387, NULL),
('Cute Mountains Inn', 218, '2019-05-09', 339, NULL),
('Cute Mountains Inn', 218, '2019-05-10', 130, NULL),
('Cute Mountains Inn', 218, '2019-05-11', 327, NULL),
('Cute Mountains Inn', 218, '2019-05-12', 266, NULL),
('Cute Mountains Inn', 218, '2019-05-13', 234, NULL),
('Cute Mountains Inn', 218, '2019-05-14', 251, NULL),
('Cute Mountains Inn', 218, '2019-05-15', 158, NULL),
('Cute Mountains Inn', 218, '2019-05-16', 150, NULL),
('Cute Mountains Inn', 218, '2019-05-17', 214, NULL),
('Cute Mountains Inn', 218, '2019-05-18', 331, NULL),
('Cute Mountains Inn', 218, '2019-05-19', 194, NULL),
('Cute Mountains Inn', 218, '2019-05-20', 199, NULL),
('Cute Mountains Inn', 218, '2019-05-21', 366, NULL),
('Cute Mountains Inn', 218, '2019-05-22', 393, NULL),
('Cute Mountains Inn', 218, '2019-05-23', 185, NULL),
('Cute Mountains Inn', 218, '2019-05-24', 373, NULL),
('Cute Mountains Inn', 218, '2019-05-25', 341, NULL),
('Cute Mountains Inn', 218, '2019-05-26', 376, NULL),
('Cute Mountains Inn', 218, '2019-05-27', 312, NULL),
('Cute Mountains Inn', 218, '2019-05-28', 133, NULL),
('Cute Mountains Inn', 218, '2019-05-29', 229, NULL),
('Cute Mountains Inn', 218, '2019-05-30', 284, NULL),
('Cute Mountains Inn', 218, '2019-05-31', 271, NULL),
('Cute Mountains Inn', 218, '2019-06-01', 286, NULL),
('Cute Mountains Inn', 218, '2019-06-02', 373, NULL),
('Cute Mountains Inn', 218, '2019-06-03', 379, NULL),
('Cute Mountains Inn', 218, '2019-06-04', 277, NULL),
('Cute Mountains Inn', 218, '2019-06-05', 161, NULL),
('Cute Mountains Inn', 218, '2019-06-06', 139, NULL),
('Cute Mountains Inn', 218, '2019-06-07', 292, NULL),
('Cute Mountains Inn', 218, '2019-06-08', 371, NULL),
('Cute Mountains Inn', 218, '2019-06-09', 227, NULL),
('Cute Mountains Inn', 218, '2019-06-10', 385, NULL),
('Cute Mountains Inn', 218, '2019-06-11', 254, NULL),
('Cute Mountains Inn', 218, '2019-06-12', 393, NULL),
('Cute Mountains Inn', 218, '2019-06-13', 210, NULL),
('Cute Mountains Inn', 218, '2019-06-14', 279, NULL),
('Cute Mountains Inn', 218, '2019-06-15', 351, NULL),
('Cute Mountains Inn', 218, '2019-06-16', 288, NULL),
('Cute Mountains Inn', 218, '2019-06-17', 280, NULL),
('Cute Mountains Inn', 218, '2019-06-18', 346, NULL),
('Cute Mountains Inn', 218, '2019-06-19', 255, NULL),
('Cute Mountains Inn', 218, '2019-06-20', 174, NULL),
('Cute Mountains Inn', 218, '2019-06-21', 369, NULL),
('Cute Mountains Inn', 218, '2019-06-22', 173, NULL),
('Cute Mountains Inn', 218, '2019-06-23', 315, NULL),
('Cute Mountains Inn', 218, '2019-06-24', 310, NULL),
('Cute Mountains Inn', 218, '2019-06-25', 145, NULL),
('Cute Mountains Inn', 218, '2019-06-26', 148, NULL),
('Cute Mountains Inn', 218, '2019-06-27', 212, NULL),
('Cute Mountains Inn', 218, '2019-06-28', 223, NULL),
('Cute Mountains Inn', 218, '2019-06-29', 242, NULL),
('Cute Mountains Inn', 218, '2019-06-30', 134, NULL),
('Cute Mountains Inn', 218, '2019-07-01', 153, NULL),
('Cute Mountains Inn', 218, '2019-07-02', 264, NULL),
('Cute Mountains Inn', 218, '2019-07-03', 334, NULL),
('Cute Mountains Inn', 218, '2019-07-04', 259, NULL),
('Cute Mountains Inn', 218, '2019-07-05', 306, NULL),
('Cute Mountains Inn', 218, '2019-07-06', 270, NULL),
('Cute Mountains Inn', 218, '2019-07-07', 175, NULL),
('Cute Mountains Inn', 218, '2019-07-08', 122, NULL),
('Cute Mountains Inn', 218, '2019-07-09', 101, NULL),
('Cute Mountains Inn', 218, '2019-07-10', 194, NULL),
('Cute Mountains Inn', 218, '2019-07-11', 342, NULL),
('Cute Mountains Inn', 218, '2019-07-12', 203, NULL),
('Cute Mountains Inn', 218, '2019-07-13', 114, NULL),
('Cute Mountains Inn', 218, '2019-07-14', 298, NULL),
('Cute Mountains Inn', 218, '2019-07-15', 250, NULL),
('Cute Mountains Inn', 218, '2019-07-16', 135, NULL),
('Cute Mountains Inn', 218, '2019-07-17', 194, NULL),
('Cute Mountains Inn', 218, '2019-07-18', 313, NULL),
('Cute Mountains Inn', 218, '2019-07-19', 265, NULL),
('Cute Mountains Inn', 218, '2019-07-20', 333, NULL),
('Cute Mountains Inn', 218, '2019-07-21', 261, NULL),
('Cute Mountains Inn', 218, '2019-07-22', 329, NULL),
('Cute Mountains Inn', 218, '2019-07-23', 199, NULL),
('Cute Mountains Inn', 218, '2019-07-24', 347, NULL),
('Cute Mountains Inn', 218, '2019-07-25', 163, NULL),
('Cute Mountains Inn', 218, '2019-07-26', 240, NULL),
('Cute Mountains Inn', 218, '2019-07-27', 312, NULL),
('Cute Mountains Inn', 218, '2019-07-28', 261, NULL),
('Cute Mountains Inn', 218, '2019-07-29', 248, NULL),
('Cute Mountains Inn', 218, '2019-07-30', 249, NULL),
('Cute Mountains Inn', 218, '2019-07-31', 341, NULL),
('Cute Mountains Inn', 218, '2019-08-01', 279, NULL),
('Cute Mountains Inn', 218, '2019-08-02', 175, NULL),
('Cute Mountains Inn', 218, '2019-08-03', 301, NULL),
('Cute Mountains Inn', 218, '2019-08-04', 380, NULL),
('Cute Mountains Inn', 218, '2019-08-05', 124, NULL),
('Cute Mountains Inn', 218, '2019-08-06', 277, NULL),
('Cute Mountains Inn', 218, '2019-08-07', 245, NULL),
('Cute Mountains Inn', 218, '2019-08-08', 107, NULL),
('Cute Mountains Inn', 218, '2019-08-09', 378, NULL),
('Cute Mountains Inn', 218, '2019-08-10', 136, NULL),
('Cute Mountains Inn', 218, '2019-08-11', 205, NULL),
('Cute Mountains Inn', 218, '2019-08-12', 235, NULL),
('Cute Mountains Inn', 218, '2019-08-13', 290, NULL),
('Cute Mountains Inn', 218, '2019-08-14', 133, NULL),
('Cute Mountains Inn', 218, '2019-08-15', 285, NULL),
('Cute Mountains Inn', 218, '2019-08-16', 383, NULL),
('Cute Mountains Inn', 218, '2019-08-17', 164, NULL),
('Cute Mountains Inn', 218, '2019-08-18', 266, NULL),
('Cute Mountains Inn', 218, '2019-08-19', 266, NULL),
('Cute Mountains Inn', 218, '2019-08-20', 319, NULL),
('Cute Mountains Inn', 218, '2019-08-21', 301, NULL),
('Cute Mountains Inn', 218, '2019-08-22', 140, NULL),
('Cute Mountains Inn', 218, '2019-08-23', 322, NULL),
('Cute Mountains Inn', 218, '2019-08-24', 175, NULL),
('Cute Mountains Inn', 218, '2019-08-25', 199, NULL),
('Cute Mountains Inn', 218, '2019-08-26', 365, NULL),
('Cute Mountains Inn', 218, '2019-08-27', 211, NULL),
('Cute Mountains Inn', 218, '2019-08-28', 172, NULL),
('Cute Mountains Inn', 218, '2019-08-29', 388, NULL),
('Cute Mountains Inn', 218, '2019-08-30', 152, NULL),
('Cute Mountains Inn', 218, '2019-08-31', 226, NULL),
('Cute Mountains Inn', 218, '2019-09-01', 206, NULL),
('Cute Mountains Inn', 218, '2019-09-02', 141, NULL),
('Cute Mountains Inn', 218, '2019-09-03', 341, NULL),
('Cute Mountains Inn', 218, '2019-09-04', 129, NULL),
('Cute Mountains Inn', 218, '2019-09-05', 296, NULL),
('Cute Mountains Inn', 218, '2019-09-06', 193, NULL),
('Cute Mountains Inn', 218, '2019-09-07', 232, NULL),
('Cute Mountains Inn', 218, '2019-09-08', 363, NULL),
('Cute Mountains Inn', 218, '2019-09-09', 340, NULL),
('Cute Mountains Inn', 218, '2019-09-10', 292, NULL),
('Cute Mountains Inn', 218, '2019-09-11', 224, NULL),
('Cute Mountains Inn', 218, '2019-09-12', 337, NULL),
('Cute Mountains Inn', 218, '2019-09-13', 331, NULL),
('Cute Mountains Inn', 218, '2019-09-14', 390, NULL),
('Cute Mountains Inn', 218, '2019-09-15', 318, NULL),
('Cute Mountains Inn', 218, '2019-09-16', 364, NULL),
('Cute Mountains Inn', 218, '2019-09-17', 141, NULL),
('Cute Mountains Inn', 218, '2019-09-18', 166, NULL),
('Cute Mountains Inn', 218, '2019-09-19', 395, NULL),
('Cute Mountains Inn', 218, '2019-09-20', 103, NULL),
('Cute Mountains Inn', 218, '2019-09-21', 381, NULL),
('Cute Mountains Inn', 218, '2019-09-22', 251, NULL),
('Cute Mountains Inn', 218, '2019-09-23', 300, NULL),
('Cute Mountains Inn', 218, '2019-09-24', 245, NULL),
('Cute Mountains Inn', 218, '2019-09-25', 395, NULL),
('Cute Mountains Inn', 218, '2019-09-26', 130, NULL),
('Cute Mountains Inn', 218, '2019-09-27', 178, NULL),
('Cute Mountains Inn', 218, '2019-09-28', 331, NULL),
('Cute Mountains Inn', 218, '2019-09-29', 108, NULL),
('Cute Mountains Inn', 218, '2019-09-30', 381, NULL),
('Cute Mountains Inn', 218, '2019-10-01', 398, NULL),
('Cute Mountains Inn', 218, '2019-10-02', 134, NULL),
('Cute Mountains Inn', 218, '2019-10-03', 218, NULL),
('Cute Mountains Inn', 218, '2019-10-04', 387, NULL),
('Cute Mountains Inn', 218, '2019-10-05', 326, NULL),
('Cute Mountains Inn', 218, '2019-10-06', 246, NULL),
('Cute Mountains Inn', 218, '2019-10-07', 346, NULL),
('Cute Mountains Inn', 218, '2019-10-08', 290, NULL),
('Cute Mountains Inn', 218, '2019-10-09', 169, NULL),
('Cute Mountains Inn', 218, '2019-10-10', 320, NULL),
('Cute Mountains Inn', 218, '2019-10-11', 184, NULL),
('Cute Mountains Inn', 218, '2019-10-12', 319, NULL),
('Cute Mountains Inn', 218, '2019-10-13', 186, NULL),
('Cute Mountains Inn', 218, '2019-10-14', 332, NULL),
('Cute Mountains Inn', 218, '2019-10-15', 174, NULL),
('Cute Mountains Inn', 218, '2019-10-16', 381, NULL),
('Cute Mountains Inn', 218, '2019-10-17', 325, NULL),
('Cute Mountains Inn', 218, '2019-10-18', 276, NULL),
('Cute Mountains Inn', 218, '2019-10-19', 113, NULL),
('Cute Mountains Inn', 218, '2019-10-20', 109, NULL),
('Cute Mountains Inn', 218, '2019-10-21', 107, NULL),
('Cute Mountains Inn', 218, '2019-10-22', 194, NULL),
('Cute Mountains Inn', 218, '2019-10-23', 309, NULL),
('Cute Mountains Inn', 218, '2019-10-24', 396, NULL),
('Cute Mountains Inn', 218, '2019-10-25', 378, NULL),
('Cute Mountains Inn', 218, '2019-10-26', 195, NULL),
('Cute Mountains Inn', 218, '2019-10-27', 265, NULL),
('Cute Mountains Inn', 218, '2019-10-28', 391, NULL),
('Cute Mountains Inn', 218, '2019-10-29', 269, NULL),
('Cute Mountains Inn', 218, '2019-10-30', 370, NULL),
('Cute Mountains Inn', 218, '2019-10-31', 170, NULL),
('Cute Mountains Inn', 218, '2019-11-01', 288, NULL),
('Cute Mountains Inn', 218, '2019-11-02', 325, NULL),
('Cute Mountains Inn', 218, '2019-11-03', 283, NULL),
('Cute Mountains Inn', 218, '2019-11-04', 203, NULL),
('Cute Mountains Inn', 218, '2019-11-05', 185, NULL),
('Cute Mountains Inn', 218, '2019-11-06', 203, NULL),
('Cute Mountains Inn', 218, '2019-11-07', 346, NULL),
('Cute Mountains Inn', 218, '2019-11-08', 232, NULL),
('Cute Mountains Inn', 218, '2019-11-09', 298, NULL),
('Cute Mountains Inn', 218, '2019-11-10', 326, NULL),
('Cute Mountains Inn', 218, '2019-11-11', 379, NULL),
('Cute Mountains Inn', 218, '2019-11-12', 289, NULL),
('Cute Mountains Inn', 218, '2019-11-13', 172, NULL),
('Cute Mountains Inn', 218, '2019-11-14', 237, NULL),
('Cute Mountains Inn', 218, '2019-11-15', 382, NULL),
('Cute Mountains Inn', 218, '2019-11-16', 292, NULL),
('Cute Mountains Inn', 218, '2019-11-17', 108, NULL),
('Cute Mountains Inn', 218, '2019-11-18', 266, NULL),
('Cute Mountains Inn', 218, '2019-11-19', 342, NULL),
('Cute Mountains Inn', 218, '2019-11-20', 292, NULL),
('Cute Mountains Inn', 218, '2019-11-21', 332, NULL),
('Cute Mountains Inn', 218, '2019-11-22', 230, NULL),
('Cute Mountains Inn', 218, '2019-11-23', 163, NULL),
('Cute Mountains Inn', 218, '2019-11-24', 128, NULL),
('Cute Mountains Inn', 218, '2019-11-25', 170, NULL),
('Cute Mountains Inn', 218, '2019-11-26', 266, NULL),
('Cute Mountains Inn', 218, '2019-11-27', 206, NULL),
('Cute Mountains Inn', 218, '2019-11-28', 178, NULL),
('Cute Mountains Inn', 218, '2019-11-29', 109, NULL),
('Cute Mountains Inn', 218, '2019-11-30', 392, NULL),
('Cute Mountains Inn', 218, '2019-12-01', 277, NULL),
('Cute Mountains Inn', 218, '2019-12-02', 114, NULL),
('Cute Mountains Inn', 218, '2019-12-03', 311, NULL),
('Cute Mountains Inn', 218, '2019-12-04', 355, NULL),
('Cute Mountains Inn', 218, '2019-12-05', 159, NULL),
('Cute Mountains Inn', 218, '2019-12-06', 245, NULL),
('Cute Mountains Inn', 218, '2019-12-07', 128, NULL),
('Cute Mountains Inn', 218, '2019-12-08', 292, NULL),
('Cute Mountains Inn', 218, '2019-12-09', 130, NULL),
('Cute Mountains Inn', 218, '2019-12-10', 266, NULL),
('Cute Mountains Inn', 218, '2019-12-11', 340, NULL),
('Cute Mountains Inn', 218, '2019-12-12', 275, NULL),
('Cute Mountains Inn', 218, '2019-12-13', 311, NULL),
('Cute Mountains Inn', 218, '2019-12-14', 307, NULL),
('Cute Mountains Inn', 218, '2019-12-15', 242, NULL),
('Cute Mountains Inn', 218, '2019-12-16', 306, NULL),
('Cute Mountains Inn', 218, '2019-12-17', 377, NULL),
('Cute Mountains Inn', 218, '2019-12-18', 320, NULL),
('Cute Mountains Inn', 218, '2019-12-19', 242, NULL),
('Cute Mountains Inn', 218, '2019-12-20', 255, NULL),
('Cute Mountains Inn', 218, '2019-12-21', 372, NULL),
('Cute Mountains Inn', 218, '2019-12-22', 347, NULL),
('Cute Mountains Inn', 218, '2019-12-23', 283, NULL),
('Cute Mountains Inn', 218, '2019-12-24', 118, NULL),
('Cute Mountains Inn', 218, '2019-12-25', 207, NULL),
('Cute Mountains Inn', 218, '2019-12-26', 291, NULL),
('Cute Mountains Inn', 218, '2019-12-27', 173, NULL),
('Cute Mountains Inn', 218, '2019-12-28', 345, NULL),
('Cute Mountains Inn', 218, '2019-12-29', 171, NULL),
('Cute Mountains Inn', 218, '2019-12-30', 255, NULL),
('Cute Mountains Inn', 218, '2019-12-31', 128, NULL),
('Cute Mountains Inn', 218, '2020-01-01', 186, NULL),
('Cute Mountains Inn', 218, '2020-01-02', 366, NULL),
('Cute Mountains Inn', 218, '2020-01-03', 390, NULL),
('Cute Mountains Inn', 218, '2020-01-04', 354, NULL),
('Cute Mountains Inn', 218, '2020-01-05', 180, NULL),
('Cute Mountains Inn', 218, '2020-01-06', 330, NULL),
('Cute Mountains Inn', 218, '2020-01-07', 107, NULL),
('Cute Mountains Inn', 218, '2020-01-08', 214, NULL),
('Cute Mountains Inn', 218, '2020-01-09', 326, NULL),
('Cute Mountains Inn', 218, '2020-01-10', 248, NULL),
('Cute Mountains Inn', 218, '2020-01-11', 369, NULL),
('Cute Mountains Inn', 218, '2020-01-12', 283, NULL),
('Cute Mountains Inn', 218, '2020-01-13', 248, NULL),
('Cute Mountains Inn', 218, '2020-01-14', 385, NULL),
('Cute Mountains Inn', 218, '2020-01-15', 384, NULL),
('Cute Mountains Inn', 218, '2020-01-16', 296, NULL),
('Cute Mountains Inn', 218, '2020-01-17', 226, NULL),
('Cute Mountains Inn', 218, '2020-01-18', 103, NULL),
('Cute Mountains Inn', 218, '2020-01-19', 328, NULL),
('Cute Mountains Inn', 218, '2020-01-20', 375, NULL),
('Cute Mountains Inn', 218, '2020-01-21', 210, NULL),
('Cute Mountains Inn', 218, '2020-01-22', 303, NULL),
('Cute Mountains Inn', 218, '2020-01-23', 287, NULL),
('Cute Mountains Inn', 218, '2020-01-24', 290, NULL),
('Cute Mountains Inn', 218, '2020-01-25', 188, NULL),
('Cute Mountains Inn', 218, '2020-01-26', 330, NULL),
('Cute Mountains Inn', 218, '2020-01-27', 337, NULL),
('Cute Mountains Inn', 218, '2020-01-28', 159, NULL),
('Cute Mountains Inn', 218, '2020-01-29', 349, NULL),
('Cute Mountains Inn', 218, '2020-01-30', 328, NULL),
('Cute Mountains Inn', 218, '2020-01-31', 237, NULL),
('Cute Mountains Inn', 218, '2020-02-01', 209, NULL),
('Cute Mountains Inn', 218, '2020-02-02', 288, NULL),
('Cute Mountains Inn', 218, '2020-02-03', 323, NULL),
('Cute Mountains Inn', 218, '2020-02-04', 192, NULL),
('Cute Mountains Inn', 229, '2019-01-01', 341, NULL),
('Cute Mountains Inn', 229, '2019-01-02', 118, NULL),
('Cute Mountains Inn', 229, '2019-01-03', 376, NULL),
('Cute Mountains Inn', 229, '2019-01-04', 172, NULL),
('Cute Mountains Inn', 229, '2019-01-05', 283, NULL),
('Cute Mountains Inn', 229, '2019-01-06', 251, NULL),
('Cute Mountains Inn', 229, '2019-01-07', 387, NULL),
('Cute Mountains Inn', 229, '2019-01-08', 318, NULL),
('Cute Mountains Inn', 229, '2019-01-09', 230, NULL),
('Cute Mountains Inn', 229, '2019-01-10', 123, NULL),
('Cute Mountains Inn', 229, '2019-01-11', 161, NULL),
('Cute Mountains Inn', 229, '2019-01-12', 140, NULL),
('Cute Mountains Inn', 229, '2019-01-13', 184, NULL),
('Cute Mountains Inn', 229, '2019-01-14', 229, NULL),
('Cute Mountains Inn', 229, '2019-01-15', 188, NULL),
('Cute Mountains Inn', 229, '2019-01-16', 320, NULL),
('Cute Mountains Inn', 229, '2019-01-17', 268, NULL),
('Cute Mountains Inn', 229, '2019-01-18', 385, NULL),
('Cute Mountains Inn', 229, '2019-01-19', 307, NULL),
('Cute Mountains Inn', 229, '2019-01-20', 189, NULL),
('Cute Mountains Inn', 229, '2019-01-21', 271, NULL),
('Cute Mountains Inn', 229, '2019-01-22', 314, NULL),
('Cute Mountains Inn', 229, '2019-01-23', 262, NULL),
('Cute Mountains Inn', 229, '2019-01-24', 364, NULL),
('Cute Mountains Inn', 229, '2019-01-25', 397, NULL),
('Cute Mountains Inn', 229, '2019-01-26', 333, NULL),
('Cute Mountains Inn', 229, '2019-01-27', 240, NULL),
('Cute Mountains Inn', 229, '2019-01-28', 310, NULL),
('Cute Mountains Inn', 229, '2019-01-29', 372, NULL),
('Cute Mountains Inn', 229, '2019-01-30', 355, NULL),
('Cute Mountains Inn', 229, '2019-01-31', 283, NULL),
('Cute Mountains Inn', 229, '2019-02-01', 127, NULL),
('Cute Mountains Inn', 229, '2019-02-02', 356, NULL),
('Cute Mountains Inn', 229, '2019-02-03', 391, NULL),
('Cute Mountains Inn', 229, '2019-02-04', 253, NULL),
('Cute Mountains Inn', 229, '2019-02-05', 213, NULL),
('Cute Mountains Inn', 229, '2019-02-06', 375, NULL),
('Cute Mountains Inn', 229, '2019-02-07', 164, NULL),
('Cute Mountains Inn', 229, '2019-02-08', 289, NULL),
('Cute Mountains Inn', 229, '2019-02-09', 363, NULL),
('Cute Mountains Inn', 229, '2019-02-10', 370, NULL),
('Cute Mountains Inn', 229, '2019-02-11', 166, NULL),
('Cute Mountains Inn', 229, '2019-02-12', 331, NULL),
('Cute Mountains Inn', 229, '2019-02-13', 344, NULL),
('Cute Mountains Inn', 229, '2019-02-14', 179, NULL),
('Cute Mountains Inn', 229, '2019-02-15', 285, NULL),
('Cute Mountains Inn', 229, '2019-02-16', 387, NULL),
('Cute Mountains Inn', 229, '2019-02-17', 154, NULL),
('Cute Mountains Inn', 229, '2019-02-18', 356, NULL),
('Cute Mountains Inn', 229, '2019-02-19', 194, NULL),
('Cute Mountains Inn', 229, '2019-02-20', 302, NULL),
('Cute Mountains Inn', 229, '2019-02-21', 373, NULL),
('Cute Mountains Inn', 229, '2019-02-22', 265, NULL),
('Cute Mountains Inn', 229, '2019-02-23', 356, NULL),
('Cute Mountains Inn', 229, '2019-02-24', 199, NULL),
('Cute Mountains Inn', 229, '2019-02-25', 331, NULL),
('Cute Mountains Inn', 229, '2019-02-26', 256, NULL),
('Cute Mountains Inn', 229, '2019-02-27', 279, NULL),
('Cute Mountains Inn', 229, '2019-02-28', 271, NULL),
('Cute Mountains Inn', 229, '2019-03-01', 102, NULL),
('Cute Mountains Inn', 229, '2019-03-02', 354, NULL),
('Cute Mountains Inn', 229, '2019-03-03', 316, NULL),
('Cute Mountains Inn', 229, '2019-03-04', 248, NULL),
('Cute Mountains Inn', 229, '2019-03-05', 285, NULL),
('Cute Mountains Inn', 229, '2019-03-06', 297, NULL),
('Cute Mountains Inn', 229, '2019-03-07', 239, NULL),
('Cute Mountains Inn', 229, '2019-03-08', 192, NULL),
('Cute Mountains Inn', 229, '2019-03-09', 386, NULL),
('Cute Mountains Inn', 229, '2019-03-10', 207, NULL),
('Cute Mountains Inn', 229, '2019-03-11', 165, NULL),
('Cute Mountains Inn', 229, '2019-03-12', 386, NULL),
('Cute Mountains Inn', 229, '2019-03-13', 150, NULL),
('Cute Mountains Inn', 229, '2019-03-14', 370, NULL),
('Cute Mountains Inn', 229, '2019-03-15', 173, NULL),
('Cute Mountains Inn', 229, '2019-03-16', 157, NULL),
('Cute Mountains Inn', 229, '2019-03-17', 274, NULL),
('Cute Mountains Inn', 229, '2019-03-18', 290, NULL),
('Cute Mountains Inn', 229, '2019-03-19', 199, NULL),
('Cute Mountains Inn', 229, '2019-03-20', 134, NULL),
('Cute Mountains Inn', 229, '2019-03-21', 135, NULL),
('Cute Mountains Inn', 229, '2019-03-22', 175, NULL),
('Cute Mountains Inn', 229, '2019-03-23', 141, NULL),
('Cute Mountains Inn', 229, '2019-03-24', 343, NULL),
('Cute Mountains Inn', 229, '2019-03-25', 239, NULL),
('Cute Mountains Inn', 229, '2019-03-26', 168, NULL),
('Cute Mountains Inn', 229, '2019-03-27', 220, NULL),
('Cute Mountains Inn', 229, '2019-03-28', 314, NULL),
('Cute Mountains Inn', 229, '2019-03-29', 319, NULL),
('Cute Mountains Inn', 229, '2019-03-30', 221, NULL),
('Cute Mountains Inn', 229, '2019-03-31', 204, NULL),
('Cute Mountains Inn', 229, '2019-04-01', 169, NULL),
('Cute Mountains Inn', 229, '2019-04-02', 138, NULL),
('Cute Mountains Inn', 229, '2019-04-03', 153, NULL),
('Cute Mountains Inn', 229, '2019-04-04', 305, NULL),
('Cute Mountains Inn', 229, '2019-04-05', 395, NULL),
('Cute Mountains Inn', 229, '2019-04-06', 153, NULL),
('Cute Mountains Inn', 229, '2019-04-07', 153, NULL),
('Cute Mountains Inn', 229, '2019-04-08', 128, NULL),
('Cute Mountains Inn', 229, '2019-04-09', 170, NULL),
('Cute Mountains Inn', 229, '2019-04-10', 360, NULL),
('Cute Mountains Inn', 229, '2019-04-11', 102, NULL),
('Cute Mountains Inn', 229, '2019-04-12', 133, NULL),
('Cute Mountains Inn', 229, '2019-04-13', 173, NULL),
('Cute Mountains Inn', 229, '2019-04-14', 368, NULL),
('Cute Mountains Inn', 229, '2019-04-15', 300, NULL),
('Cute Mountains Inn', 229, '2019-04-16', 163, NULL),
('Cute Mountains Inn', 229, '2019-04-17', 354, NULL),
('Cute Mountains Inn', 229, '2019-04-18', 339, NULL),
('Cute Mountains Inn', 229, '2019-04-19', 132, NULL),
('Cute Mountains Inn', 229, '2019-04-20', 207, NULL),
('Cute Mountains Inn', 229, '2019-04-21', 326, NULL),
('Cute Mountains Inn', 229, '2019-04-22', 147, NULL),
('Cute Mountains Inn', 229, '2019-04-23', 263, NULL),
('Cute Mountains Inn', 229, '2019-04-24', 168, NULL),
('Cute Mountains Inn', 229, '2019-04-25', 142, NULL),
('Cute Mountains Inn', 229, '2019-04-26', 375, NULL),
('Cute Mountains Inn', 229, '2019-04-27', 132, NULL),
('Cute Mountains Inn', 229, '2019-04-28', 355, NULL),
('Cute Mountains Inn', 229, '2019-04-29', 254, NULL),
('Cute Mountains Inn', 229, '2019-04-30', 333, NULL),
('Cute Mountains Inn', 229, '2019-05-01', 396, NULL),
('Cute Mountains Inn', 229, '2019-05-02', 155, NULL),
('Cute Mountains Inn', 229, '2019-05-03', 363, NULL),
('Cute Mountains Inn', 229, '2019-05-04', 351, NULL),
('Cute Mountains Inn', 229, '2019-05-05', 111, NULL),
('Cute Mountains Inn', 229, '2019-05-06', 160, NULL),
('Cute Mountains Inn', 229, '2019-05-07', 244, NULL),
('Cute Mountains Inn', 229, '2019-05-08', 340, NULL),
('Cute Mountains Inn', 229, '2019-05-09', 356, NULL),
('Cute Mountains Inn', 229, '2019-05-10', 389, NULL),
('Cute Mountains Inn', 229, '2019-05-11', 222, NULL),
('Cute Mountains Inn', 229, '2019-05-12', 172, NULL),
('Cute Mountains Inn', 229, '2019-05-13', 390, NULL),
('Cute Mountains Inn', 229, '2019-05-14', 121, NULL),
('Cute Mountains Inn', 229, '2019-05-15', 324, NULL),
('Cute Mountains Inn', 229, '2019-05-16', 351, NULL),
('Cute Mountains Inn', 229, '2019-05-17', 278, NULL),
('Cute Mountains Inn', 229, '2019-05-18', 174, NULL),
('Cute Mountains Inn', 229, '2019-05-19', 391, NULL),
('Cute Mountains Inn', 229, '2019-05-20', 119, NULL),
('Cute Mountains Inn', 229, '2019-05-21', 194, NULL),
('Cute Mountains Inn', 229, '2019-05-22', 376, NULL),
('Cute Mountains Inn', 229, '2019-05-23', 245, NULL),
('Cute Mountains Inn', 229, '2019-05-24', 224, NULL),
('Cute Mountains Inn', 229, '2019-05-25', 103, NULL),
('Cute Mountains Inn', 229, '2019-05-26', 208, NULL),
('Cute Mountains Inn', 229, '2019-05-27', 225, NULL),
('Cute Mountains Inn', 229, '2019-05-28', 227, NULL),
('Cute Mountains Inn', 229, '2019-05-29', 163, NULL),
('Cute Mountains Inn', 229, '2019-05-30', 293, NULL),
('Cute Mountains Inn', 229, '2019-05-31', 153, NULL),
('Cute Mountains Inn', 229, '2019-06-01', 261, NULL),
('Cute Mountains Inn', 229, '2019-06-02', 244, NULL),
('Cute Mountains Inn', 229, '2019-06-03', 169, NULL),
('Cute Mountains Inn', 229, '2019-06-04', 105, NULL),
('Cute Mountains Inn', 229, '2019-06-05', 271, NULL),
('Cute Mountains Inn', 229, '2019-06-06', 217, NULL),
('Cute Mountains Inn', 229, '2019-06-07', 249, NULL),
('Cute Mountains Inn', 229, '2019-06-08', 340, NULL),
('Cute Mountains Inn', 229, '2019-06-09', 282, NULL),
('Cute Mountains Inn', 229, '2019-06-10', 248, NULL),
('Cute Mountains Inn', 229, '2019-06-11', 160, NULL),
('Cute Mountains Inn', 229, '2019-06-12', 320, NULL),
('Cute Mountains Inn', 229, '2019-06-13', 155, NULL),
('Cute Mountains Inn', 229, '2019-06-14', 140, NULL),
('Cute Mountains Inn', 229, '2019-06-15', 252, NULL),
('Cute Mountains Inn', 229, '2019-06-16', 256, NULL),
('Cute Mountains Inn', 229, '2019-06-17', 378, NULL),
('Cute Mountains Inn', 229, '2019-06-18', 360, NULL),
('Cute Mountains Inn', 229, '2019-06-19', 271, NULL),
('Cute Mountains Inn', 229, '2019-06-20', 126, NULL),
('Cute Mountains Inn', 229, '2019-06-21', 382, NULL),
('Cute Mountains Inn', 229, '2019-06-22', 395, NULL),
('Cute Mountains Inn', 229, '2019-06-23', 207, NULL),
('Cute Mountains Inn', 229, '2019-06-24', 199, NULL),
('Cute Mountains Inn', 229, '2019-06-25', 298, NULL),
('Cute Mountains Inn', 229, '2019-06-26', 120, NULL),
('Cute Mountains Inn', 229, '2019-06-27', 259, NULL),
('Cute Mountains Inn', 229, '2019-06-28', 344, NULL),
('Cute Mountains Inn', 229, '2019-06-29', 342, NULL),
('Cute Mountains Inn', 229, '2019-06-30', 386, NULL),
('Cute Mountains Inn', 229, '2019-07-01', 167, NULL),
('Cute Mountains Inn', 229, '2019-07-02', 341, NULL),
('Cute Mountains Inn', 229, '2019-07-03', 117, NULL),
('Cute Mountains Inn', 229, '2019-07-04', 138, NULL),
('Cute Mountains Inn', 229, '2019-07-05', 338, NULL),
('Cute Mountains Inn', 229, '2019-07-06', 278, NULL),
('Cute Mountains Inn', 229, '2019-07-07', 390, NULL),
('Cute Mountains Inn', 229, '2019-07-08', 178, NULL),
('Cute Mountains Inn', 229, '2019-07-09', 207, NULL),
('Cute Mountains Inn', 229, '2019-07-10', 396, NULL),
('Cute Mountains Inn', 229, '2019-07-11', 329, NULL),
('Cute Mountains Inn', 229, '2019-07-12', 296, NULL),
('Cute Mountains Inn', 229, '2019-07-13', 121, NULL),
('Cute Mountains Inn', 229, '2019-07-14', 306, NULL),
('Cute Mountains Inn', 229, '2019-07-15', 205, NULL),
('Cute Mountains Inn', 229, '2019-07-16', 264, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 229, '2019-07-17', 349, NULL),
('Cute Mountains Inn', 229, '2019-07-18', 276, NULL),
('Cute Mountains Inn', 229, '2019-07-19', 103, NULL),
('Cute Mountains Inn', 229, '2019-07-20', 144, NULL),
('Cute Mountains Inn', 229, '2019-07-21', 128, NULL),
('Cute Mountains Inn', 229, '2019-07-22', 193, NULL),
('Cute Mountains Inn', 229, '2019-07-23', 188, NULL),
('Cute Mountains Inn', 229, '2019-07-24', 211, NULL),
('Cute Mountains Inn', 229, '2019-07-25', 271, NULL),
('Cute Mountains Inn', 229, '2019-07-26', 116, NULL),
('Cute Mountains Inn', 229, '2019-07-27', 168, NULL),
('Cute Mountains Inn', 229, '2019-07-28', 288, NULL),
('Cute Mountains Inn', 229, '2019-07-29', 246, NULL),
('Cute Mountains Inn', 229, '2019-07-30', 362, NULL),
('Cute Mountains Inn', 229, '2019-07-31', 199, NULL),
('Cute Mountains Inn', 229, '2019-08-01', 100, NULL),
('Cute Mountains Inn', 229, '2019-08-02', 359, NULL),
('Cute Mountains Inn', 229, '2019-08-03', 380, NULL),
('Cute Mountains Inn', 229, '2019-08-04', 273, NULL),
('Cute Mountains Inn', 229, '2019-08-05', 115, NULL),
('Cute Mountains Inn', 229, '2019-08-06', 287, NULL),
('Cute Mountains Inn', 229, '2019-08-07', 212, NULL),
('Cute Mountains Inn', 229, '2019-08-08', 203, NULL),
('Cute Mountains Inn', 229, '2019-08-09', 297, NULL),
('Cute Mountains Inn', 229, '2019-08-10', 349, NULL),
('Cute Mountains Inn', 229, '2019-08-11', 247, NULL),
('Cute Mountains Inn', 229, '2019-08-12', 193, NULL),
('Cute Mountains Inn', 229, '2019-08-13', 285, NULL),
('Cute Mountains Inn', 229, '2019-08-14', 335, NULL),
('Cute Mountains Inn', 229, '2019-08-15', 114, NULL),
('Cute Mountains Inn', 229, '2019-08-16', 129, NULL),
('Cute Mountains Inn', 229, '2019-08-17', 161, NULL),
('Cute Mountains Inn', 229, '2019-08-18', 170, NULL),
('Cute Mountains Inn', 229, '2019-08-19', 356, NULL),
('Cute Mountains Inn', 229, '2019-08-20', 375, NULL),
('Cute Mountains Inn', 229, '2019-08-21', 247, NULL),
('Cute Mountains Inn', 229, '2019-08-22', 185, NULL),
('Cute Mountains Inn', 229, '2019-08-23', 123, NULL),
('Cute Mountains Inn', 229, '2019-08-24', 148, NULL),
('Cute Mountains Inn', 229, '2019-08-25', 158, NULL),
('Cute Mountains Inn', 229, '2019-08-26', 377, NULL),
('Cute Mountains Inn', 229, '2019-08-27', 208, NULL),
('Cute Mountains Inn', 229, '2019-08-28', 257, NULL),
('Cute Mountains Inn', 229, '2019-08-29', 375, NULL),
('Cute Mountains Inn', 229, '2019-08-30', 253, NULL),
('Cute Mountains Inn', 229, '2019-08-31', 293, NULL),
('Cute Mountains Inn', 229, '2019-09-01', 131, NULL),
('Cute Mountains Inn', 229, '2019-09-02', 190, NULL),
('Cute Mountains Inn', 229, '2019-09-03', 231, NULL),
('Cute Mountains Inn', 229, '2019-09-04', 217, NULL),
('Cute Mountains Inn', 229, '2019-09-05', 231, NULL),
('Cute Mountains Inn', 229, '2019-09-06', 324, NULL),
('Cute Mountains Inn', 229, '2019-09-07', 337, NULL),
('Cute Mountains Inn', 229, '2019-09-08', 170, NULL),
('Cute Mountains Inn', 229, '2019-09-09', 284, NULL),
('Cute Mountains Inn', 229, '2019-09-10', 365, NULL),
('Cute Mountains Inn', 229, '2019-09-11', 250, NULL),
('Cute Mountains Inn', 229, '2019-09-12', 291, NULL),
('Cute Mountains Inn', 229, '2019-09-13', 321, NULL),
('Cute Mountains Inn', 229, '2019-09-14', 300, NULL),
('Cute Mountains Inn', 229, '2019-09-15', 153, NULL),
('Cute Mountains Inn', 229, '2019-09-16', 358, NULL),
('Cute Mountains Inn', 229, '2019-09-17', 230, NULL),
('Cute Mountains Inn', 229, '2019-09-18', 251, NULL),
('Cute Mountains Inn', 229, '2019-09-19', 324, NULL),
('Cute Mountains Inn', 229, '2019-09-20', 374, NULL),
('Cute Mountains Inn', 229, '2019-09-21', 199, NULL),
('Cute Mountains Inn', 229, '2019-09-22', 161, NULL),
('Cute Mountains Inn', 229, '2019-09-23', 214, NULL),
('Cute Mountains Inn', 229, '2019-09-24', 139, NULL),
('Cute Mountains Inn', 229, '2019-09-25', 204, NULL),
('Cute Mountains Inn', 229, '2019-09-26', 335, NULL),
('Cute Mountains Inn', 229, '2019-09-27', 314, NULL),
('Cute Mountains Inn', 229, '2019-09-28', 312, NULL),
('Cute Mountains Inn', 229, '2019-09-29', 330, NULL),
('Cute Mountains Inn', 229, '2019-09-30', 129, NULL),
('Cute Mountains Inn', 229, '2019-10-01', 202, NULL),
('Cute Mountains Inn', 229, '2019-10-02', 352, NULL),
('Cute Mountains Inn', 229, '2019-10-03', 218, NULL),
('Cute Mountains Inn', 229, '2019-10-04', 184, NULL),
('Cute Mountains Inn', 229, '2019-10-05', 268, NULL),
('Cute Mountains Inn', 229, '2019-10-06', 368, NULL),
('Cute Mountains Inn', 229, '2019-10-07', 193, NULL),
('Cute Mountains Inn', 229, '2019-10-08', 141, NULL),
('Cute Mountains Inn', 229, '2019-10-09', 377, NULL),
('Cute Mountains Inn', 229, '2019-10-10', 237, NULL),
('Cute Mountains Inn', 229, '2019-10-11', 132, NULL),
('Cute Mountains Inn', 229, '2019-10-12', 332, NULL),
('Cute Mountains Inn', 229, '2019-10-13', 339, NULL),
('Cute Mountains Inn', 229, '2019-10-14', 211, NULL),
('Cute Mountains Inn', 229, '2019-10-15', 317, NULL),
('Cute Mountains Inn', 229, '2019-10-16', 235, NULL),
('Cute Mountains Inn', 229, '2019-10-17', 138, NULL),
('Cute Mountains Inn', 229, '2019-10-18', 304, NULL),
('Cute Mountains Inn', 229, '2019-10-19', 306, NULL),
('Cute Mountains Inn', 229, '2019-10-20', 363, NULL),
('Cute Mountains Inn', 229, '2019-10-21', 299, NULL),
('Cute Mountains Inn', 229, '2019-10-22', 331, NULL),
('Cute Mountains Inn', 229, '2019-10-23', 328, NULL),
('Cute Mountains Inn', 229, '2019-10-24', 298, NULL),
('Cute Mountains Inn', 229, '2019-10-25', 222, NULL),
('Cute Mountains Inn', 229, '2019-10-26', 356, NULL),
('Cute Mountains Inn', 229, '2019-10-27', 374, NULL),
('Cute Mountains Inn', 229, '2019-10-28', 122, NULL),
('Cute Mountains Inn', 229, '2019-10-29', 287, NULL),
('Cute Mountains Inn', 229, '2019-10-30', 205, NULL),
('Cute Mountains Inn', 229, '2019-10-31', 363, NULL),
('Cute Mountains Inn', 229, '2019-11-01', 314, NULL),
('Cute Mountains Inn', 229, '2019-11-02', 392, NULL),
('Cute Mountains Inn', 229, '2019-11-03', 394, NULL),
('Cute Mountains Inn', 229, '2019-11-04', 343, NULL),
('Cute Mountains Inn', 229, '2019-11-05', 298, NULL),
('Cute Mountains Inn', 229, '2019-11-06', 131, NULL),
('Cute Mountains Inn', 229, '2019-11-07', 266, NULL),
('Cute Mountains Inn', 229, '2019-11-08', 131, NULL),
('Cute Mountains Inn', 229, '2019-11-09', 341, NULL),
('Cute Mountains Inn', 229, '2019-11-10', 366, NULL),
('Cute Mountains Inn', 229, '2019-11-11', 339, NULL),
('Cute Mountains Inn', 229, '2019-11-12', 122, NULL),
('Cute Mountains Inn', 229, '2019-11-13', 134, NULL),
('Cute Mountains Inn', 229, '2019-11-14', 320, NULL),
('Cute Mountains Inn', 229, '2019-11-15', 368, NULL),
('Cute Mountains Inn', 229, '2019-11-16', 358, NULL),
('Cute Mountains Inn', 229, '2019-11-17', 110, NULL),
('Cute Mountains Inn', 229, '2019-11-18', 179, NULL),
('Cute Mountains Inn', 229, '2019-11-19', 395, NULL),
('Cute Mountains Inn', 229, '2019-11-20', 214, NULL),
('Cute Mountains Inn', 229, '2019-11-21', 160, NULL),
('Cute Mountains Inn', 229, '2019-11-22', 116, NULL),
('Cute Mountains Inn', 229, '2019-11-23', 131, NULL),
('Cute Mountains Inn', 229, '2019-11-24', 106, NULL),
('Cute Mountains Inn', 229, '2019-11-25', 267, NULL),
('Cute Mountains Inn', 229, '2019-11-26', 343, NULL),
('Cute Mountains Inn', 229, '2019-11-27', 136, NULL),
('Cute Mountains Inn', 229, '2019-11-28', 198, NULL),
('Cute Mountains Inn', 229, '2019-11-29', 173, NULL),
('Cute Mountains Inn', 229, '2019-11-30', 137, NULL),
('Cute Mountains Inn', 229, '2019-12-01', 212, NULL),
('Cute Mountains Inn', 229, '2019-12-02', 241, NULL),
('Cute Mountains Inn', 229, '2019-12-03', 138, NULL),
('Cute Mountains Inn', 229, '2019-12-04', 113, NULL),
('Cute Mountains Inn', 229, '2019-12-05', 306, NULL),
('Cute Mountains Inn', 229, '2019-12-06', 225, NULL),
('Cute Mountains Inn', 229, '2019-12-07', 170, NULL),
('Cute Mountains Inn', 229, '2019-12-08', 269, NULL),
('Cute Mountains Inn', 229, '2019-12-09', 107, NULL),
('Cute Mountains Inn', 229, '2019-12-10', 334, NULL),
('Cute Mountains Inn', 229, '2019-12-11', 391, NULL),
('Cute Mountains Inn', 229, '2019-12-12', 305, NULL),
('Cute Mountains Inn', 229, '2019-12-13', 175, NULL),
('Cute Mountains Inn', 229, '2019-12-14', 149, NULL),
('Cute Mountains Inn', 229, '2019-12-15', 356, NULL),
('Cute Mountains Inn', 229, '2019-12-16', 220, NULL),
('Cute Mountains Inn', 229, '2019-12-17', 289, NULL),
('Cute Mountains Inn', 229, '2019-12-18', 221, NULL),
('Cute Mountains Inn', 229, '2019-12-19', 115, NULL),
('Cute Mountains Inn', 229, '2019-12-20', 130, NULL),
('Cute Mountains Inn', 229, '2019-12-21', 369, NULL),
('Cute Mountains Inn', 229, '2019-12-22', 241, NULL),
('Cute Mountains Inn', 229, '2019-12-23', 110, NULL),
('Cute Mountains Inn', 229, '2019-12-24', 206, NULL),
('Cute Mountains Inn', 229, '2019-12-25', 371, NULL),
('Cute Mountains Inn', 229, '2019-12-26', 293, NULL),
('Cute Mountains Inn', 229, '2019-12-27', 154, NULL),
('Cute Mountains Inn', 229, '2019-12-28', 196, NULL),
('Cute Mountains Inn', 229, '2019-12-29', 219, NULL),
('Cute Mountains Inn', 229, '2019-12-30', 360, NULL),
('Cute Mountains Inn', 229, '2019-12-31', 285, NULL),
('Cute Mountains Inn', 229, '2020-01-01', 389, NULL),
('Cute Mountains Inn', 229, '2020-01-02', 335, NULL),
('Cute Mountains Inn', 229, '2020-01-03', 207, NULL),
('Cute Mountains Inn', 229, '2020-01-04', 104, NULL),
('Cute Mountains Inn', 229, '2020-01-05', 132, NULL),
('Cute Mountains Inn', 229, '2020-01-06', 201, NULL),
('Cute Mountains Inn', 229, '2020-01-07', 190, NULL),
('Cute Mountains Inn', 229, '2020-01-08', 300, NULL),
('Cute Mountains Inn', 229, '2020-01-09', 218, NULL),
('Cute Mountains Inn', 229, '2020-01-10', 226, NULL),
('Cute Mountains Inn', 229, '2020-01-11', 176, NULL),
('Cute Mountains Inn', 229, '2020-01-12', 333, NULL),
('Cute Mountains Inn', 229, '2020-01-13', 102, NULL),
('Cute Mountains Inn', 229, '2020-01-14', 293, NULL),
('Cute Mountains Inn', 229, '2020-01-15', 275, NULL),
('Cute Mountains Inn', 229, '2020-01-16', 268, NULL),
('Cute Mountains Inn', 229, '2020-01-17', 315, NULL),
('Cute Mountains Inn', 229, '2020-01-18', 295, NULL),
('Cute Mountains Inn', 229, '2020-01-19', 302, NULL),
('Cute Mountains Inn', 229, '2020-01-20', 302, NULL),
('Cute Mountains Inn', 229, '2020-01-21', 356, NULL),
('Cute Mountains Inn', 229, '2020-01-22', 251, NULL),
('Cute Mountains Inn', 229, '2020-01-23', 151, NULL),
('Cute Mountains Inn', 229, '2020-01-24', 246, NULL),
('Cute Mountains Inn', 229, '2020-01-25', 379, NULL),
('Cute Mountains Inn', 229, '2020-01-26', 305, NULL),
('Cute Mountains Inn', 229, '2020-01-27', 379, NULL),
('Cute Mountains Inn', 229, '2020-01-28', 142, NULL),
('Cute Mountains Inn', 229, '2020-01-29', 124, NULL),
('Cute Mountains Inn', 229, '2020-01-30', 186, NULL),
('Cute Mountains Inn', 229, '2020-01-31', 288, NULL),
('Cute Mountains Inn', 229, '2020-02-01', 111, NULL),
('Cute Mountains Inn', 229, '2020-02-02', 292, NULL),
('Cute Mountains Inn', 229, '2020-02-03', 236, NULL),
('Cute Mountains Inn', 229, '2020-02-04', 242, NULL),
('Cute Mountains Inn', 253, '2019-01-01', 226, NULL),
('Cute Mountains Inn', 253, '2019-01-02', 113, NULL),
('Cute Mountains Inn', 253, '2019-01-03', 109, NULL),
('Cute Mountains Inn', 253, '2019-01-04', 213, NULL),
('Cute Mountains Inn', 253, '2019-01-05', 367, NULL),
('Cute Mountains Inn', 253, '2019-01-06', 251, NULL),
('Cute Mountains Inn', 253, '2019-01-07', 358, NULL),
('Cute Mountains Inn', 253, '2019-01-08', 240, NULL),
('Cute Mountains Inn', 253, '2019-01-09', 300, NULL),
('Cute Mountains Inn', 253, '2019-01-10', 367, NULL),
('Cute Mountains Inn', 253, '2019-01-11', 347, NULL),
('Cute Mountains Inn', 253, '2019-01-12', 134, NULL),
('Cute Mountains Inn', 253, '2019-01-13', 130, NULL),
('Cute Mountains Inn', 253, '2019-01-14', 193, NULL),
('Cute Mountains Inn', 253, '2019-01-15', 205, NULL),
('Cute Mountains Inn', 253, '2019-01-16', 240, NULL),
('Cute Mountains Inn', 253, '2019-01-17', 233, NULL),
('Cute Mountains Inn', 253, '2019-01-18', 397, NULL),
('Cute Mountains Inn', 253, '2019-01-19', 280, NULL),
('Cute Mountains Inn', 253, '2019-01-20', 209, NULL),
('Cute Mountains Inn', 253, '2019-01-21', 237, NULL),
('Cute Mountains Inn', 253, '2019-01-22', 141, NULL),
('Cute Mountains Inn', 253, '2019-01-23', 307, NULL),
('Cute Mountains Inn', 253, '2019-01-24', 247, NULL),
('Cute Mountains Inn', 253, '2019-01-25', 332, NULL),
('Cute Mountains Inn', 253, '2019-01-26', 215, NULL),
('Cute Mountains Inn', 253, '2019-01-27', 172, NULL),
('Cute Mountains Inn', 253, '2019-01-28', 298, NULL),
('Cute Mountains Inn', 253, '2019-01-29', 150, NULL),
('Cute Mountains Inn', 253, '2019-01-30', 156, NULL),
('Cute Mountains Inn', 253, '2019-01-31', 178, NULL),
('Cute Mountains Inn', 253, '2019-02-01', 112, NULL),
('Cute Mountains Inn', 253, '2019-02-02', 357, NULL),
('Cute Mountains Inn', 253, '2019-02-03', 258, NULL),
('Cute Mountains Inn', 253, '2019-02-04', 213, NULL),
('Cute Mountains Inn', 253, '2019-02-05', 309, NULL),
('Cute Mountains Inn', 253, '2019-02-06', 365, NULL),
('Cute Mountains Inn', 253, '2019-02-07', 352, NULL),
('Cute Mountains Inn', 253, '2019-02-08', 271, NULL),
('Cute Mountains Inn', 253, '2019-02-09', 342, NULL),
('Cute Mountains Inn', 253, '2019-02-10', 163, NULL),
('Cute Mountains Inn', 253, '2019-02-11', 277, NULL),
('Cute Mountains Inn', 253, '2019-02-12', 137, NULL),
('Cute Mountains Inn', 253, '2019-02-13', 348, NULL),
('Cute Mountains Inn', 253, '2019-02-14', 123, NULL),
('Cute Mountains Inn', 253, '2019-02-15', 314, NULL),
('Cute Mountains Inn', 253, '2019-02-16', 166, NULL),
('Cute Mountains Inn', 253, '2019-02-17', 258, NULL),
('Cute Mountains Inn', 253, '2019-02-18', 280, NULL),
('Cute Mountains Inn', 253, '2019-02-19', 113, NULL),
('Cute Mountains Inn', 253, '2019-02-20', 314, NULL),
('Cute Mountains Inn', 253, '2019-02-21', 193, NULL),
('Cute Mountains Inn', 253, '2019-02-22', 112, NULL),
('Cute Mountains Inn', 253, '2019-02-23', 143, NULL),
('Cute Mountains Inn', 253, '2019-02-24', 385, NULL),
('Cute Mountains Inn', 253, '2019-02-25', 186, NULL),
('Cute Mountains Inn', 253, '2019-02-26', 359, NULL),
('Cute Mountains Inn', 253, '2019-02-27', 339, NULL),
('Cute Mountains Inn', 253, '2019-02-28', 292, NULL),
('Cute Mountains Inn', 253, '2019-03-01', 112, NULL),
('Cute Mountains Inn', 253, '2019-03-02', 348, NULL),
('Cute Mountains Inn', 253, '2019-03-03', 350, NULL),
('Cute Mountains Inn', 253, '2019-03-04', 354, NULL),
('Cute Mountains Inn', 253, '2019-03-05', 399, NULL),
('Cute Mountains Inn', 253, '2019-03-06', 369, NULL),
('Cute Mountains Inn', 253, '2019-03-07', 145, NULL),
('Cute Mountains Inn', 253, '2019-03-08', 274, NULL),
('Cute Mountains Inn', 253, '2019-03-09', 215, NULL),
('Cute Mountains Inn', 253, '2019-03-10', 154, NULL),
('Cute Mountains Inn', 253, '2019-03-11', 148, NULL),
('Cute Mountains Inn', 253, '2019-03-12', 175, NULL),
('Cute Mountains Inn', 253, '2019-03-13', 327, NULL),
('Cute Mountains Inn', 253, '2019-03-14', 119, NULL),
('Cute Mountains Inn', 253, '2019-03-15', 129, NULL),
('Cute Mountains Inn', 253, '2019-03-16', 226, NULL),
('Cute Mountains Inn', 253, '2019-03-17', 393, NULL),
('Cute Mountains Inn', 253, '2019-03-18', 206, NULL),
('Cute Mountains Inn', 253, '2019-03-19', 374, NULL),
('Cute Mountains Inn', 253, '2019-03-20', 389, NULL),
('Cute Mountains Inn', 253, '2019-03-21', 345, NULL),
('Cute Mountains Inn', 253, '2019-03-22', 266, NULL),
('Cute Mountains Inn', 253, '2019-03-23', 241, NULL),
('Cute Mountains Inn', 253, '2019-03-24', 120, NULL),
('Cute Mountains Inn', 253, '2019-03-25', 131, NULL),
('Cute Mountains Inn', 253, '2019-03-26', 304, NULL),
('Cute Mountains Inn', 253, '2019-03-27', 167, NULL),
('Cute Mountains Inn', 253, '2019-03-28', 188, NULL),
('Cute Mountains Inn', 253, '2019-03-29', 192, NULL),
('Cute Mountains Inn', 253, '2019-03-30', 261, NULL),
('Cute Mountains Inn', 253, '2019-03-31', 368, NULL),
('Cute Mountains Inn', 253, '2019-04-01', 145, NULL),
('Cute Mountains Inn', 253, '2019-04-02', 247, NULL),
('Cute Mountains Inn', 253, '2019-04-03', 337, NULL),
('Cute Mountains Inn', 253, '2019-04-04', 248, NULL),
('Cute Mountains Inn', 253, '2019-04-05', 128, NULL),
('Cute Mountains Inn', 253, '2019-04-06', 370, NULL),
('Cute Mountains Inn', 253, '2019-04-07', 163, NULL),
('Cute Mountains Inn', 253, '2019-04-08', 235, NULL),
('Cute Mountains Inn', 253, '2019-04-09', 127, NULL),
('Cute Mountains Inn', 253, '2019-04-10', 110, NULL),
('Cute Mountains Inn', 253, '2019-04-11', 362, NULL),
('Cute Mountains Inn', 253, '2019-04-12', 296, NULL),
('Cute Mountains Inn', 253, '2019-04-13', 266, NULL),
('Cute Mountains Inn', 253, '2019-04-14', 343, NULL),
('Cute Mountains Inn', 253, '2019-04-15', 339, NULL),
('Cute Mountains Inn', 253, '2019-04-16', 326, NULL),
('Cute Mountains Inn', 253, '2019-04-17', 362, NULL),
('Cute Mountains Inn', 253, '2019-04-18', 355, NULL),
('Cute Mountains Inn', 253, '2019-04-19', 178, NULL),
('Cute Mountains Inn', 253, '2019-04-20', 245, NULL),
('Cute Mountains Inn', 253, '2019-04-21', 191, NULL),
('Cute Mountains Inn', 253, '2019-04-22', 186, NULL),
('Cute Mountains Inn', 253, '2019-04-23', 332, NULL),
('Cute Mountains Inn', 253, '2019-04-24', 319, NULL),
('Cute Mountains Inn', 253, '2019-04-25', 298, NULL),
('Cute Mountains Inn', 253, '2019-04-26', 279, NULL),
('Cute Mountains Inn', 253, '2019-04-27', 338, NULL),
('Cute Mountains Inn', 253, '2019-04-28', 260, NULL),
('Cute Mountains Inn', 253, '2019-04-29', 154, NULL),
('Cute Mountains Inn', 253, '2019-04-30', 251, NULL),
('Cute Mountains Inn', 253, '2019-05-01', 237, NULL),
('Cute Mountains Inn', 253, '2019-05-02', 208, NULL),
('Cute Mountains Inn', 253, '2019-05-03', 287, NULL),
('Cute Mountains Inn', 253, '2019-05-04', 124, NULL),
('Cute Mountains Inn', 253, '2019-05-05', 243, NULL),
('Cute Mountains Inn', 253, '2019-05-06', 231, NULL),
('Cute Mountains Inn', 253, '2019-05-07', 161, NULL),
('Cute Mountains Inn', 253, '2019-05-08', 137, NULL),
('Cute Mountains Inn', 253, '2019-05-09', 364, NULL),
('Cute Mountains Inn', 253, '2019-05-10', 254, NULL),
('Cute Mountains Inn', 253, '2019-05-11', 327, NULL),
('Cute Mountains Inn', 253, '2019-05-12', 263, NULL),
('Cute Mountains Inn', 253, '2019-05-13', 248, NULL),
('Cute Mountains Inn', 253, '2019-05-14', 354, NULL),
('Cute Mountains Inn', 253, '2019-05-15', 146, NULL),
('Cute Mountains Inn', 253, '2019-05-16', 307, NULL),
('Cute Mountains Inn', 253, '2019-05-17', 348, NULL),
('Cute Mountains Inn', 253, '2019-05-18', 375, NULL),
('Cute Mountains Inn', 253, '2019-05-19', 373, NULL),
('Cute Mountains Inn', 253, '2019-05-20', 199, NULL),
('Cute Mountains Inn', 253, '2019-05-21', 373, NULL),
('Cute Mountains Inn', 253, '2019-05-22', 302, NULL),
('Cute Mountains Inn', 253, '2019-05-23', 270, NULL),
('Cute Mountains Inn', 253, '2019-05-24', 202, NULL),
('Cute Mountains Inn', 253, '2019-05-25', 295, NULL),
('Cute Mountains Inn', 253, '2019-05-26', 116, NULL),
('Cute Mountains Inn', 253, '2019-05-27', 391, NULL),
('Cute Mountains Inn', 253, '2019-05-28', 337, NULL),
('Cute Mountains Inn', 253, '2019-05-29', 331, NULL),
('Cute Mountains Inn', 253, '2019-05-30', 214, NULL),
('Cute Mountains Inn', 253, '2019-05-31', 150, NULL),
('Cute Mountains Inn', 253, '2019-06-01', 349, NULL),
('Cute Mountains Inn', 253, '2019-06-02', 299, NULL),
('Cute Mountains Inn', 253, '2019-06-03', 211, NULL),
('Cute Mountains Inn', 253, '2019-06-04', 195, NULL),
('Cute Mountains Inn', 253, '2019-06-05', 172, NULL),
('Cute Mountains Inn', 253, '2019-06-06', 268, NULL),
('Cute Mountains Inn', 253, '2019-06-07', 267, NULL),
('Cute Mountains Inn', 253, '2019-06-08', 186, NULL),
('Cute Mountains Inn', 253, '2019-06-09', 333, NULL),
('Cute Mountains Inn', 253, '2019-06-10', 284, NULL),
('Cute Mountains Inn', 253, '2019-06-11', 239, NULL),
('Cute Mountains Inn', 253, '2019-06-12', 322, NULL),
('Cute Mountains Inn', 253, '2019-06-13', 346, NULL),
('Cute Mountains Inn', 253, '2019-06-14', 363, NULL),
('Cute Mountains Inn', 253, '2019-06-15', 109, NULL),
('Cute Mountains Inn', 253, '2019-06-16', 318, NULL),
('Cute Mountains Inn', 253, '2019-06-17', 353, NULL),
('Cute Mountains Inn', 253, '2019-06-18', 363, NULL),
('Cute Mountains Inn', 253, '2019-06-19', 189, NULL),
('Cute Mountains Inn', 253, '2019-06-20', 310, NULL),
('Cute Mountains Inn', 253, '2019-06-21', 104, NULL),
('Cute Mountains Inn', 253, '2019-06-22', 154, NULL),
('Cute Mountains Inn', 253, '2019-06-23', 292, NULL),
('Cute Mountains Inn', 253, '2019-06-24', 266, NULL),
('Cute Mountains Inn', 253, '2019-06-25', 356, NULL),
('Cute Mountains Inn', 253, '2019-06-26', 357, NULL),
('Cute Mountains Inn', 253, '2019-06-27', 260, NULL),
('Cute Mountains Inn', 253, '2019-06-28', 353, NULL),
('Cute Mountains Inn', 253, '2019-06-29', 285, NULL),
('Cute Mountains Inn', 253, '2019-06-30', 228, NULL),
('Cute Mountains Inn', 253, '2019-07-01', 275, NULL),
('Cute Mountains Inn', 253, '2019-07-02', 214, NULL),
('Cute Mountains Inn', 253, '2019-07-03', 383, NULL),
('Cute Mountains Inn', 253, '2019-07-04', 113, NULL),
('Cute Mountains Inn', 253, '2019-07-05', 374, NULL),
('Cute Mountains Inn', 253, '2019-07-06', 179, NULL),
('Cute Mountains Inn', 253, '2019-07-07', 127, NULL),
('Cute Mountains Inn', 253, '2019-07-08', 126, NULL),
('Cute Mountains Inn', 253, '2019-07-09', 335, NULL),
('Cute Mountains Inn', 253, '2019-07-10', 399, NULL),
('Cute Mountains Inn', 253, '2019-07-11', 218, NULL),
('Cute Mountains Inn', 253, '2019-07-12', 173, NULL),
('Cute Mountains Inn', 253, '2019-07-13', 165, NULL),
('Cute Mountains Inn', 253, '2019-07-14', 234, NULL),
('Cute Mountains Inn', 253, '2019-07-15', 174, NULL),
('Cute Mountains Inn', 253, '2019-07-16', 216, NULL),
('Cute Mountains Inn', 253, '2019-07-17', 164, NULL),
('Cute Mountains Inn', 253, '2019-07-18', 339, NULL),
('Cute Mountains Inn', 253, '2019-07-19', 221, NULL),
('Cute Mountains Inn', 253, '2019-07-20', 222, NULL),
('Cute Mountains Inn', 253, '2019-07-21', 361, NULL),
('Cute Mountains Inn', 253, '2019-07-22', 178, NULL),
('Cute Mountains Inn', 253, '2019-07-23', 245, NULL),
('Cute Mountains Inn', 253, '2019-07-24', 214, NULL),
('Cute Mountains Inn', 253, '2019-07-25', 165, NULL),
('Cute Mountains Inn', 253, '2019-07-26', 362, NULL),
('Cute Mountains Inn', 253, '2019-07-27', 105, NULL),
('Cute Mountains Inn', 253, '2019-07-28', 258, NULL),
('Cute Mountains Inn', 253, '2019-07-29', 384, NULL),
('Cute Mountains Inn', 253, '2019-07-30', 363, NULL),
('Cute Mountains Inn', 253, '2019-07-31', 170, NULL),
('Cute Mountains Inn', 253, '2019-08-01', 163, NULL),
('Cute Mountains Inn', 253, '2019-08-02', 270, NULL),
('Cute Mountains Inn', 253, '2019-08-03', 297, NULL),
('Cute Mountains Inn', 253, '2019-08-04', 122, NULL),
('Cute Mountains Inn', 253, '2019-08-05', 104, NULL),
('Cute Mountains Inn', 253, '2019-08-06', 205, NULL),
('Cute Mountains Inn', 253, '2019-08-07', 224, NULL),
('Cute Mountains Inn', 253, '2019-08-08', 293, NULL),
('Cute Mountains Inn', 253, '2019-08-09', 253, NULL),
('Cute Mountains Inn', 253, '2019-08-10', 338, NULL),
('Cute Mountains Inn', 253, '2019-08-11', 222, NULL),
('Cute Mountains Inn', 253, '2019-08-12', 161, NULL),
('Cute Mountains Inn', 253, '2019-08-13', 157, NULL),
('Cute Mountains Inn', 253, '2019-08-14', 278, NULL),
('Cute Mountains Inn', 253, '2019-08-15', 215, NULL),
('Cute Mountains Inn', 253, '2019-08-16', 295, NULL),
('Cute Mountains Inn', 253, '2019-08-17', 211, NULL),
('Cute Mountains Inn', 253, '2019-08-18', 250, NULL),
('Cute Mountains Inn', 253, '2019-08-19', 282, NULL),
('Cute Mountains Inn', 253, '2019-08-20', 218, NULL),
('Cute Mountains Inn', 253, '2019-08-21', 234, NULL),
('Cute Mountains Inn', 253, '2019-08-22', 105, NULL),
('Cute Mountains Inn', 253, '2019-08-23', 147, NULL),
('Cute Mountains Inn', 253, '2019-08-24', 116, NULL),
('Cute Mountains Inn', 253, '2019-08-25', 392, NULL),
('Cute Mountains Inn', 253, '2019-08-26', 390, NULL),
('Cute Mountains Inn', 253, '2019-08-27', 308, NULL),
('Cute Mountains Inn', 253, '2019-08-28', 371, NULL),
('Cute Mountains Inn', 253, '2019-08-29', 314, NULL),
('Cute Mountains Inn', 253, '2019-08-30', 109, NULL),
('Cute Mountains Inn', 253, '2019-08-31', 388, NULL),
('Cute Mountains Inn', 253, '2019-09-01', 237, NULL),
('Cute Mountains Inn', 253, '2019-09-02', 129, NULL),
('Cute Mountains Inn', 253, '2019-09-03', 332, NULL),
('Cute Mountains Inn', 253, '2019-09-04', 299, NULL),
('Cute Mountains Inn', 253, '2019-09-05', 166, NULL),
('Cute Mountains Inn', 253, '2019-09-06', 340, NULL),
('Cute Mountains Inn', 253, '2019-09-07', 286, NULL),
('Cute Mountains Inn', 253, '2019-09-08', 260, NULL),
('Cute Mountains Inn', 253, '2019-09-09', 303, NULL),
('Cute Mountains Inn', 253, '2019-09-10', 252, NULL),
('Cute Mountains Inn', 253, '2019-09-11', 177, NULL),
('Cute Mountains Inn', 253, '2019-09-12', 347, NULL),
('Cute Mountains Inn', 253, '2019-09-13', 214, NULL),
('Cute Mountains Inn', 253, '2019-09-14', 232, NULL),
('Cute Mountains Inn', 253, '2019-09-15', 309, NULL),
('Cute Mountains Inn', 253, '2019-09-16', 297, NULL),
('Cute Mountains Inn', 253, '2019-09-17', 327, NULL),
('Cute Mountains Inn', 253, '2019-09-18', 360, NULL),
('Cute Mountains Inn', 253, '2019-09-19', 337, NULL),
('Cute Mountains Inn', 253, '2019-09-20', 263, NULL),
('Cute Mountains Inn', 253, '2019-09-21', 350, NULL),
('Cute Mountains Inn', 253, '2019-09-22', 253, NULL),
('Cute Mountains Inn', 253, '2019-09-23', 372, NULL),
('Cute Mountains Inn', 253, '2019-09-24', 161, NULL),
('Cute Mountains Inn', 253, '2019-09-25', 338, NULL),
('Cute Mountains Inn', 253, '2019-09-26', 285, NULL),
('Cute Mountains Inn', 253, '2019-09-27', 335, NULL),
('Cute Mountains Inn', 253, '2019-09-28', 169, NULL),
('Cute Mountains Inn', 253, '2019-09-29', 325, NULL),
('Cute Mountains Inn', 253, '2019-09-30', 305, NULL),
('Cute Mountains Inn', 253, '2019-10-01', 315, NULL),
('Cute Mountains Inn', 253, '2019-10-02', 359, NULL),
('Cute Mountains Inn', 253, '2019-10-03', 336, NULL),
('Cute Mountains Inn', 253, '2019-10-04', 262, NULL),
('Cute Mountains Inn', 253, '2019-10-05', 261, NULL),
('Cute Mountains Inn', 253, '2019-10-06', 104, NULL),
('Cute Mountains Inn', 253, '2019-10-07', 128, NULL),
('Cute Mountains Inn', 253, '2019-10-08', 337, NULL),
('Cute Mountains Inn', 253, '2019-10-09', 379, NULL),
('Cute Mountains Inn', 253, '2019-10-10', 127, NULL),
('Cute Mountains Inn', 253, '2019-10-11', 306, NULL),
('Cute Mountains Inn', 253, '2019-10-12', 302, NULL),
('Cute Mountains Inn', 253, '2019-10-13', 141, NULL),
('Cute Mountains Inn', 253, '2019-10-14', 258, NULL),
('Cute Mountains Inn', 253, '2019-10-15', 363, NULL),
('Cute Mountains Inn', 253, '2019-10-16', 232, NULL),
('Cute Mountains Inn', 253, '2019-10-17', 217, NULL),
('Cute Mountains Inn', 253, '2019-10-18', 293, NULL),
('Cute Mountains Inn', 253, '2019-10-19', 193, NULL),
('Cute Mountains Inn', 253, '2019-10-20', 189, NULL),
('Cute Mountains Inn', 253, '2019-10-21', 177, NULL),
('Cute Mountains Inn', 253, '2019-10-22', 377, NULL),
('Cute Mountains Inn', 253, '2019-10-23', 316, NULL),
('Cute Mountains Inn', 253, '2019-10-24', 204, NULL),
('Cute Mountains Inn', 253, '2019-10-25', 176, NULL),
('Cute Mountains Inn', 253, '2019-10-26', 197, NULL),
('Cute Mountains Inn', 253, '2019-10-27', 372, NULL),
('Cute Mountains Inn', 253, '2019-10-28', 235, NULL),
('Cute Mountains Inn', 253, '2019-10-29', 229, NULL),
('Cute Mountains Inn', 253, '2019-10-30', 116, NULL),
('Cute Mountains Inn', 253, '2019-10-31', 307, NULL),
('Cute Mountains Inn', 253, '2019-11-01', 308, NULL),
('Cute Mountains Inn', 253, '2019-11-02', 288, NULL),
('Cute Mountains Inn', 253, '2019-11-03', 119, NULL),
('Cute Mountains Inn', 253, '2019-11-04', 105, NULL),
('Cute Mountains Inn', 253, '2019-11-05', 237, NULL),
('Cute Mountains Inn', 253, '2019-11-06', 245, NULL),
('Cute Mountains Inn', 253, '2019-11-07', 196, NULL),
('Cute Mountains Inn', 253, '2019-11-08', 163, NULL),
('Cute Mountains Inn', 253, '2019-11-09', 112, NULL),
('Cute Mountains Inn', 253, '2019-11-10', 155, NULL),
('Cute Mountains Inn', 253, '2019-11-11', 161, NULL),
('Cute Mountains Inn', 253, '2019-11-12', 244, NULL),
('Cute Mountains Inn', 253, '2019-11-13', 355, NULL),
('Cute Mountains Inn', 253, '2019-11-14', 191, NULL),
('Cute Mountains Inn', 253, '2019-11-15', 293, NULL),
('Cute Mountains Inn', 253, '2019-11-16', 215, NULL),
('Cute Mountains Inn', 253, '2019-11-17', 125, NULL),
('Cute Mountains Inn', 253, '2019-11-18', 301, NULL),
('Cute Mountains Inn', 253, '2019-11-19', 247, NULL),
('Cute Mountains Inn', 253, '2019-11-20', 396, NULL),
('Cute Mountains Inn', 253, '2019-11-21', 304, NULL),
('Cute Mountains Inn', 253, '2019-11-22', 391, NULL),
('Cute Mountains Inn', 253, '2019-11-23', 370, NULL),
('Cute Mountains Inn', 253, '2019-11-24', 348, NULL),
('Cute Mountains Inn', 253, '2019-11-25', 126, NULL),
('Cute Mountains Inn', 253, '2019-11-26', 219, NULL),
('Cute Mountains Inn', 253, '2019-11-27', 260, NULL),
('Cute Mountains Inn', 253, '2019-11-28', 356, NULL),
('Cute Mountains Inn', 253, '2019-11-29', 136, NULL),
('Cute Mountains Inn', 253, '2019-11-30', 309, NULL),
('Cute Mountains Inn', 253, '2019-12-01', 130, NULL),
('Cute Mountains Inn', 253, '2019-12-02', 166, NULL),
('Cute Mountains Inn', 253, '2019-12-03', 259, NULL),
('Cute Mountains Inn', 253, '2019-12-04', 302, NULL),
('Cute Mountains Inn', 253, '2019-12-05', 353, NULL),
('Cute Mountains Inn', 253, '2019-12-06', 291, NULL),
('Cute Mountains Inn', 253, '2019-12-07', 369, NULL),
('Cute Mountains Inn', 253, '2019-12-08', 370, NULL),
('Cute Mountains Inn', 253, '2019-12-09', 344, NULL),
('Cute Mountains Inn', 253, '2019-12-10', 169, NULL),
('Cute Mountains Inn', 253, '2019-12-11', 239, NULL),
('Cute Mountains Inn', 253, '2019-12-12', 302, NULL),
('Cute Mountains Inn', 253, '2019-12-13', 144, NULL),
('Cute Mountains Inn', 253, '2019-12-14', 326, NULL),
('Cute Mountains Inn', 253, '2019-12-15', 357, NULL),
('Cute Mountains Inn', 253, '2019-12-16', 386, NULL),
('Cute Mountains Inn', 253, '2019-12-17', 214, NULL),
('Cute Mountains Inn', 253, '2019-12-18', 346, NULL),
('Cute Mountains Inn', 253, '2019-12-19', 349, NULL),
('Cute Mountains Inn', 253, '2019-12-20', 385, NULL),
('Cute Mountains Inn', 253, '2019-12-21', 329, NULL),
('Cute Mountains Inn', 253, '2019-12-22', 364, NULL),
('Cute Mountains Inn', 253, '2019-12-23', 201, NULL),
('Cute Mountains Inn', 253, '2019-12-24', 273, NULL),
('Cute Mountains Inn', 253, '2019-12-25', 233, NULL),
('Cute Mountains Inn', 253, '2019-12-26', 196, NULL),
('Cute Mountains Inn', 253, '2019-12-27', 151, NULL),
('Cute Mountains Inn', 253, '2019-12-28', 145, NULL),
('Cute Mountains Inn', 253, '2019-12-29', 184, NULL),
('Cute Mountains Inn', 253, '2019-12-30', 333, NULL),
('Cute Mountains Inn', 253, '2019-12-31', 339, NULL),
('Cute Mountains Inn', 253, '2020-01-01', 386, NULL),
('Cute Mountains Inn', 253, '2020-01-02', 179, NULL),
('Cute Mountains Inn', 253, '2020-01-03', 366, NULL),
('Cute Mountains Inn', 253, '2020-01-04', 259, NULL),
('Cute Mountains Inn', 253, '2020-01-05', 320, NULL),
('Cute Mountains Inn', 253, '2020-01-06', 217, NULL),
('Cute Mountains Inn', 253, '2020-01-07', 228, NULL),
('Cute Mountains Inn', 253, '2020-01-08', 159, NULL),
('Cute Mountains Inn', 253, '2020-01-09', 314, NULL),
('Cute Mountains Inn', 253, '2020-01-10', 290, NULL),
('Cute Mountains Inn', 253, '2020-01-11', 276, NULL),
('Cute Mountains Inn', 253, '2020-01-12', 119, NULL),
('Cute Mountains Inn', 253, '2020-01-13', 266, NULL),
('Cute Mountains Inn', 253, '2020-01-14', 214, NULL),
('Cute Mountains Inn', 253, '2020-01-15', 120, NULL),
('Cute Mountains Inn', 253, '2020-01-16', 349, NULL),
('Cute Mountains Inn', 253, '2020-01-17', 197, NULL),
('Cute Mountains Inn', 253, '2020-01-18', 167, NULL),
('Cute Mountains Inn', 253, '2020-01-19', 129, NULL),
('Cute Mountains Inn', 253, '2020-01-20', 288, NULL),
('Cute Mountains Inn', 253, '2020-01-21', 151, NULL),
('Cute Mountains Inn', 253, '2020-01-22', 250, NULL),
('Cute Mountains Inn', 253, '2020-01-23', 395, NULL),
('Cute Mountains Inn', 253, '2020-01-24', 260, NULL),
('Cute Mountains Inn', 253, '2020-01-25', 330, NULL),
('Cute Mountains Inn', 253, '2020-01-26', 136, NULL),
('Cute Mountains Inn', 253, '2020-01-27', 183, NULL),
('Cute Mountains Inn', 253, '2020-01-28', 130, NULL),
('Cute Mountains Inn', 253, '2020-01-29', 374, NULL),
('Cute Mountains Inn', 253, '2020-01-30', 146, NULL),
('Cute Mountains Inn', 253, '2020-01-31', 330, NULL),
('Cute Mountains Inn', 253, '2020-02-01', 131, NULL),
('Cute Mountains Inn', 253, '2020-02-02', 197, NULL),
('Cute Mountains Inn', 253, '2020-02-03', 113, NULL),
('Cute Mountains Inn', 253, '2020-02-04', 237, NULL),
('Cute Mountains Inn', 265, '2019-01-01', 309, NULL),
('Cute Mountains Inn', 265, '2019-01-02', 113, NULL),
('Cute Mountains Inn', 265, '2019-01-03', 220, NULL),
('Cute Mountains Inn', 265, '2019-01-04', 150, NULL),
('Cute Mountains Inn', 265, '2019-01-05', 285, NULL),
('Cute Mountains Inn', 265, '2019-01-06', 104, NULL),
('Cute Mountains Inn', 265, '2019-01-07', 229, NULL),
('Cute Mountains Inn', 265, '2019-01-08', 145, NULL),
('Cute Mountains Inn', 265, '2019-01-09', 110, NULL),
('Cute Mountains Inn', 265, '2019-01-10', 169, NULL),
('Cute Mountains Inn', 265, '2019-01-11', 253, NULL),
('Cute Mountains Inn', 265, '2019-01-12', 150, NULL),
('Cute Mountains Inn', 265, '2019-01-13', 300, NULL),
('Cute Mountains Inn', 265, '2019-01-14', 176, NULL),
('Cute Mountains Inn', 265, '2019-01-15', 361, NULL),
('Cute Mountains Inn', 265, '2019-01-16', 140, NULL),
('Cute Mountains Inn', 265, '2019-01-17', 260, NULL),
('Cute Mountains Inn', 265, '2019-01-18', 129, NULL),
('Cute Mountains Inn', 265, '2019-01-19', 380, NULL),
('Cute Mountains Inn', 265, '2019-01-20', 380, NULL),
('Cute Mountains Inn', 265, '2019-01-21', 271, NULL),
('Cute Mountains Inn', 265, '2019-01-22', 264, NULL),
('Cute Mountains Inn', 265, '2019-01-23', 351, NULL),
('Cute Mountains Inn', 265, '2019-01-24', 342, NULL),
('Cute Mountains Inn', 265, '2019-01-25', 369, NULL),
('Cute Mountains Inn', 265, '2019-01-26', 279, NULL),
('Cute Mountains Inn', 265, '2019-01-27', 338, NULL),
('Cute Mountains Inn', 265, '2019-01-28', 164, NULL),
('Cute Mountains Inn', 265, '2019-01-29', 135, NULL),
('Cute Mountains Inn', 265, '2019-01-30', 215, NULL),
('Cute Mountains Inn', 265, '2019-01-31', 240, NULL),
('Cute Mountains Inn', 265, '2019-02-01', 381, NULL),
('Cute Mountains Inn', 265, '2019-02-02', 318, NULL),
('Cute Mountains Inn', 265, '2019-02-03', 318, NULL),
('Cute Mountains Inn', 265, '2019-02-04', 205, NULL),
('Cute Mountains Inn', 265, '2019-02-05', 205, NULL),
('Cute Mountains Inn', 265, '2019-02-06', 301, NULL),
('Cute Mountains Inn', 265, '2019-02-07', 269, NULL),
('Cute Mountains Inn', 265, '2019-02-08', 389, NULL),
('Cute Mountains Inn', 265, '2019-02-09', 220, NULL),
('Cute Mountains Inn', 265, '2019-02-10', 209, NULL),
('Cute Mountains Inn', 265, '2019-02-11', 189, NULL),
('Cute Mountains Inn', 265, '2019-02-12', 191, NULL),
('Cute Mountains Inn', 265, '2019-02-13', 310, NULL),
('Cute Mountains Inn', 265, '2019-02-14', 281, NULL),
('Cute Mountains Inn', 265, '2019-02-15', 317, NULL),
('Cute Mountains Inn', 265, '2019-02-16', 170, NULL),
('Cute Mountains Inn', 265, '2019-02-17', 126, NULL),
('Cute Mountains Inn', 265, '2019-02-18', 231, NULL),
('Cute Mountains Inn', 265, '2019-02-19', 183, NULL),
('Cute Mountains Inn', 265, '2019-02-20', 264, NULL),
('Cute Mountains Inn', 265, '2019-02-21', 344, NULL),
('Cute Mountains Inn', 265, '2019-02-22', 267, NULL),
('Cute Mountains Inn', 265, '2019-02-23', 149, NULL),
('Cute Mountains Inn', 265, '2019-02-24', 328, NULL),
('Cute Mountains Inn', 265, '2019-02-25', 137, NULL),
('Cute Mountains Inn', 265, '2019-02-26', 326, NULL),
('Cute Mountains Inn', 265, '2019-02-27', 157, NULL),
('Cute Mountains Inn', 265, '2019-02-28', 249, NULL),
('Cute Mountains Inn', 265, '2019-03-01', 152, NULL),
('Cute Mountains Inn', 265, '2019-03-02', 278, NULL),
('Cute Mountains Inn', 265, '2019-03-03', 100, NULL),
('Cute Mountains Inn', 265, '2019-03-04', 324, NULL),
('Cute Mountains Inn', 265, '2019-03-05', 140, NULL),
('Cute Mountains Inn', 265, '2019-03-06', 252, NULL),
('Cute Mountains Inn', 265, '2019-03-07', 208, NULL),
('Cute Mountains Inn', 265, '2019-03-08', 393, NULL),
('Cute Mountains Inn', 265, '2019-03-09', 117, NULL),
('Cute Mountains Inn', 265, '2019-03-10', 349, NULL),
('Cute Mountains Inn', 265, '2019-03-11', 145, NULL),
('Cute Mountains Inn', 265, '2019-03-12', 218, NULL),
('Cute Mountains Inn', 265, '2019-03-13', 186, NULL),
('Cute Mountains Inn', 265, '2019-03-14', 285, NULL),
('Cute Mountains Inn', 265, '2019-03-15', 327, NULL),
('Cute Mountains Inn', 265, '2019-03-16', 262, NULL),
('Cute Mountains Inn', 265, '2019-03-17', 147, NULL),
('Cute Mountains Inn', 265, '2019-03-18', 358, NULL),
('Cute Mountains Inn', 265, '2019-03-19', 273, NULL),
('Cute Mountains Inn', 265, '2019-03-20', 246, NULL),
('Cute Mountains Inn', 265, '2019-03-21', 322, NULL),
('Cute Mountains Inn', 265, '2019-03-22', 103, NULL),
('Cute Mountains Inn', 265, '2019-03-23', 382, NULL),
('Cute Mountains Inn', 265, '2019-03-24', 372, NULL),
('Cute Mountains Inn', 265, '2019-03-25', 139, NULL),
('Cute Mountains Inn', 265, '2019-03-26', 319, NULL),
('Cute Mountains Inn', 265, '2019-03-27', 377, NULL),
('Cute Mountains Inn', 265, '2019-03-28', 198, NULL),
('Cute Mountains Inn', 265, '2019-03-29', 206, NULL),
('Cute Mountains Inn', 265, '2019-03-30', 240, NULL),
('Cute Mountains Inn', 265, '2019-03-31', 230, NULL),
('Cute Mountains Inn', 265, '2019-04-01', 119, NULL),
('Cute Mountains Inn', 265, '2019-04-02', 122, NULL),
('Cute Mountains Inn', 265, '2019-04-03', 225, NULL),
('Cute Mountains Inn', 265, '2019-04-04', 225, NULL),
('Cute Mountains Inn', 265, '2019-04-05', 255, NULL),
('Cute Mountains Inn', 265, '2019-04-06', 392, NULL),
('Cute Mountains Inn', 265, '2019-04-07', 256, NULL),
('Cute Mountains Inn', 265, '2019-04-08', 389, NULL),
('Cute Mountains Inn', 265, '2019-04-09', 328, NULL),
('Cute Mountains Inn', 265, '2019-04-10', 272, NULL),
('Cute Mountains Inn', 265, '2019-04-11', 204, NULL),
('Cute Mountains Inn', 265, '2019-04-12', 384, NULL),
('Cute Mountains Inn', 265, '2019-04-13', 111, NULL),
('Cute Mountains Inn', 265, '2019-04-14', 212, NULL),
('Cute Mountains Inn', 265, '2019-04-15', 394, NULL),
('Cute Mountains Inn', 265, '2019-04-16', 139, NULL),
('Cute Mountains Inn', 265, '2019-04-17', 349, NULL),
('Cute Mountains Inn', 265, '2019-04-18', 358, NULL),
('Cute Mountains Inn', 265, '2019-04-19', 394, NULL),
('Cute Mountains Inn', 265, '2019-04-20', 203, NULL),
('Cute Mountains Inn', 265, '2019-04-21', 179, NULL),
('Cute Mountains Inn', 265, '2019-04-22', 391, NULL),
('Cute Mountains Inn', 265, '2019-04-23', 173, NULL),
('Cute Mountains Inn', 265, '2019-04-24', 392, NULL),
('Cute Mountains Inn', 265, '2019-04-25', 366, NULL),
('Cute Mountains Inn', 265, '2019-04-26', 171, NULL),
('Cute Mountains Inn', 265, '2019-04-27', 298, NULL),
('Cute Mountains Inn', 265, '2019-04-28', 137, NULL),
('Cute Mountains Inn', 265, '2019-04-29', 209, NULL),
('Cute Mountains Inn', 265, '2019-04-30', 154, NULL),
('Cute Mountains Inn', 265, '2019-05-01', 197, NULL),
('Cute Mountains Inn', 265, '2019-05-02', 174, NULL),
('Cute Mountains Inn', 265, '2019-05-03', 246, NULL),
('Cute Mountains Inn', 265, '2019-05-04', 369, NULL),
('Cute Mountains Inn', 265, '2019-05-05', 185, NULL),
('Cute Mountains Inn', 265, '2019-05-06', 276, NULL),
('Cute Mountains Inn', 265, '2019-05-07', 272, NULL),
('Cute Mountains Inn', 265, '2019-05-08', 168, NULL),
('Cute Mountains Inn', 265, '2019-05-09', 353, NULL),
('Cute Mountains Inn', 265, '2019-05-10', 305, NULL),
('Cute Mountains Inn', 265, '2019-05-11', 271, NULL),
('Cute Mountains Inn', 265, '2019-05-12', 399, NULL),
('Cute Mountains Inn', 265, '2019-05-13', 272, NULL),
('Cute Mountains Inn', 265, '2019-05-14', 106, NULL),
('Cute Mountains Inn', 265, '2019-05-15', 259, NULL),
('Cute Mountains Inn', 265, '2019-05-16', 382, NULL),
('Cute Mountains Inn', 265, '2019-05-17', 208, NULL),
('Cute Mountains Inn', 265, '2019-05-18', 357, NULL),
('Cute Mountains Inn', 265, '2019-05-19', 292, NULL),
('Cute Mountains Inn', 265, '2019-05-20', 239, NULL),
('Cute Mountains Inn', 265, '2019-05-21', 283, NULL),
('Cute Mountains Inn', 265, '2019-05-22', 283, NULL),
('Cute Mountains Inn', 265, '2019-05-23', 217, NULL),
('Cute Mountains Inn', 265, '2019-05-24', 240, NULL),
('Cute Mountains Inn', 265, '2019-05-25', 166, NULL),
('Cute Mountains Inn', 265, '2019-05-26', 153, NULL),
('Cute Mountains Inn', 265, '2019-05-27', 282, NULL),
('Cute Mountains Inn', 265, '2019-05-28', 306, NULL),
('Cute Mountains Inn', 265, '2019-05-29', 164, NULL),
('Cute Mountains Inn', 265, '2019-05-30', 390, NULL),
('Cute Mountains Inn', 265, '2019-05-31', 193, NULL),
('Cute Mountains Inn', 265, '2019-06-01', 264, NULL),
('Cute Mountains Inn', 265, '2019-06-02', 365, NULL),
('Cute Mountains Inn', 265, '2019-06-03', 148, NULL),
('Cute Mountains Inn', 265, '2019-06-04', 259, NULL),
('Cute Mountains Inn', 265, '2019-06-05', 248, NULL),
('Cute Mountains Inn', 265, '2019-06-06', 288, NULL),
('Cute Mountains Inn', 265, '2019-06-07', 190, NULL),
('Cute Mountains Inn', 265, '2019-06-08', 113, NULL),
('Cute Mountains Inn', 265, '2019-06-09', 118, NULL),
('Cute Mountains Inn', 265, '2019-06-10', 278, NULL),
('Cute Mountains Inn', 265, '2019-06-11', 314, NULL),
('Cute Mountains Inn', 265, '2019-06-12', 249, NULL),
('Cute Mountains Inn', 265, '2019-06-13', 265, NULL),
('Cute Mountains Inn', 265, '2019-06-14', 396, NULL),
('Cute Mountains Inn', 265, '2019-06-15', 290, NULL),
('Cute Mountains Inn', 265, '2019-06-16', 124, NULL),
('Cute Mountains Inn', 265, '2019-06-17', 228, NULL),
('Cute Mountains Inn', 265, '2019-06-18', 336, NULL),
('Cute Mountains Inn', 265, '2019-06-19', 334, NULL),
('Cute Mountains Inn', 265, '2019-06-20', 169, NULL),
('Cute Mountains Inn', 265, '2019-06-21', 173, NULL),
('Cute Mountains Inn', 265, '2019-06-22', 385, NULL),
('Cute Mountains Inn', 265, '2019-06-23', 140, NULL),
('Cute Mountains Inn', 265, '2019-06-24', 334, NULL),
('Cute Mountains Inn', 265, '2019-06-25', 189, NULL),
('Cute Mountains Inn', 265, '2019-06-26', 124, NULL),
('Cute Mountains Inn', 265, '2019-06-27', 121, NULL),
('Cute Mountains Inn', 265, '2019-06-28', 334, NULL),
('Cute Mountains Inn', 265, '2019-06-29', 298, NULL),
('Cute Mountains Inn', 265, '2019-06-30', 185, NULL),
('Cute Mountains Inn', 265, '2019-07-01', 173, NULL),
('Cute Mountains Inn', 265, '2019-07-02', 248, NULL),
('Cute Mountains Inn', 265, '2019-07-03', 263, NULL),
('Cute Mountains Inn', 265, '2019-07-04', 350, NULL),
('Cute Mountains Inn', 265, '2019-07-05', 156, NULL),
('Cute Mountains Inn', 265, '2019-07-06', 262, NULL),
('Cute Mountains Inn', 265, '2019-07-07', 264, NULL),
('Cute Mountains Inn', 265, '2019-07-08', 293, NULL),
('Cute Mountains Inn', 265, '2019-07-09', 353, NULL),
('Cute Mountains Inn', 265, '2019-07-10', 107, NULL),
('Cute Mountains Inn', 265, '2019-07-11', 305, NULL),
('Cute Mountains Inn', 265, '2019-07-12', 179, NULL),
('Cute Mountains Inn', 265, '2019-07-13', 364, NULL),
('Cute Mountains Inn', 265, '2019-07-14', 154, NULL),
('Cute Mountains Inn', 265, '2019-07-15', 156, NULL),
('Cute Mountains Inn', 265, '2019-07-16', 189, NULL),
('Cute Mountains Inn', 265, '2019-07-17', 275, NULL),
('Cute Mountains Inn', 265, '2019-07-18', 170, NULL),
('Cute Mountains Inn', 265, '2019-07-19', 395, NULL),
('Cute Mountains Inn', 265, '2019-07-20', 278, NULL),
('Cute Mountains Inn', 265, '2019-07-21', 120, NULL),
('Cute Mountains Inn', 265, '2019-07-22', 213, NULL),
('Cute Mountains Inn', 265, '2019-07-23', 260, NULL),
('Cute Mountains Inn', 265, '2019-07-24', 337, NULL),
('Cute Mountains Inn', 265, '2019-07-25', 214, NULL),
('Cute Mountains Inn', 265, '2019-07-26', 161, NULL),
('Cute Mountains Inn', 265, '2019-07-27', 221, NULL),
('Cute Mountains Inn', 265, '2019-07-28', 327, NULL),
('Cute Mountains Inn', 265, '2019-07-29', 184, NULL),
('Cute Mountains Inn', 265, '2019-07-30', 332, NULL),
('Cute Mountains Inn', 265, '2019-07-31', 156, NULL),
('Cute Mountains Inn', 265, '2019-08-01', 118, NULL),
('Cute Mountains Inn', 265, '2019-08-02', 172, NULL),
('Cute Mountains Inn', 265, '2019-08-03', 245, NULL),
('Cute Mountains Inn', 265, '2019-08-04', 295, NULL),
('Cute Mountains Inn', 265, '2019-08-05', 376, NULL),
('Cute Mountains Inn', 265, '2019-08-06', 364, NULL),
('Cute Mountains Inn', 265, '2019-08-07', 386, NULL),
('Cute Mountains Inn', 265, '2019-08-08', 159, NULL),
('Cute Mountains Inn', 265, '2019-08-09', 272, NULL),
('Cute Mountains Inn', 265, '2019-08-10', 243, NULL),
('Cute Mountains Inn', 265, '2019-08-11', 269, NULL),
('Cute Mountains Inn', 265, '2019-08-12', 127, NULL),
('Cute Mountains Inn', 265, '2019-08-13', 128, NULL),
('Cute Mountains Inn', 265, '2019-08-14', 283, NULL),
('Cute Mountains Inn', 265, '2019-08-15', 333, NULL),
('Cute Mountains Inn', 265, '2019-08-16', 390, NULL),
('Cute Mountains Inn', 265, '2019-08-17', 175, NULL),
('Cute Mountains Inn', 265, '2019-08-18', 343, NULL),
('Cute Mountains Inn', 265, '2019-08-19', 241, NULL),
('Cute Mountains Inn', 265, '2019-08-20', 167, NULL),
('Cute Mountains Inn', 265, '2019-08-21', 330, NULL),
('Cute Mountains Inn', 265, '2019-08-22', 172, NULL),
('Cute Mountains Inn', 265, '2019-08-23', 267, NULL),
('Cute Mountains Inn', 265, '2019-08-24', 337, NULL),
('Cute Mountains Inn', 265, '2019-08-25', 188, NULL),
('Cute Mountains Inn', 265, '2019-08-26', 118, NULL),
('Cute Mountains Inn', 265, '2019-08-27', 213, NULL),
('Cute Mountains Inn', 265, '2019-08-28', 384, NULL),
('Cute Mountains Inn', 265, '2019-08-29', 345, NULL),
('Cute Mountains Inn', 265, '2019-08-30', 287, NULL),
('Cute Mountains Inn', 265, '2019-08-31', 361, NULL),
('Cute Mountains Inn', 265, '2019-09-01', 391, NULL),
('Cute Mountains Inn', 265, '2019-09-02', 277, NULL),
('Cute Mountains Inn', 265, '2019-09-03', 268, NULL),
('Cute Mountains Inn', 265, '2019-09-04', 145, NULL),
('Cute Mountains Inn', 265, '2019-09-05', 337, NULL),
('Cute Mountains Inn', 265, '2019-09-06', 329, NULL),
('Cute Mountains Inn', 265, '2019-09-07', 322, NULL),
('Cute Mountains Inn', 265, '2019-09-08', 392, NULL),
('Cute Mountains Inn', 265, '2019-09-09', 261, NULL),
('Cute Mountains Inn', 265, '2019-09-10', 363, NULL),
('Cute Mountains Inn', 265, '2019-09-11', 335, NULL),
('Cute Mountains Inn', 265, '2019-09-12', 162, NULL),
('Cute Mountains Inn', 265, '2019-09-13', 308, NULL),
('Cute Mountains Inn', 265, '2019-09-14', 159, NULL),
('Cute Mountains Inn', 265, '2019-09-15', 385, NULL),
('Cute Mountains Inn', 265, '2019-09-16', 313, NULL),
('Cute Mountains Inn', 265, '2019-09-17', 244, NULL),
('Cute Mountains Inn', 265, '2019-09-18', 347, NULL),
('Cute Mountains Inn', 265, '2019-09-19', 314, NULL),
('Cute Mountains Inn', 265, '2019-09-20', 393, NULL),
('Cute Mountains Inn', 265, '2019-09-21', 156, NULL),
('Cute Mountains Inn', 265, '2019-09-22', 382, NULL),
('Cute Mountains Inn', 265, '2019-09-23', 216, NULL),
('Cute Mountains Inn', 265, '2019-09-24', 288, NULL),
('Cute Mountains Inn', 265, '2019-09-25', 379, NULL),
('Cute Mountains Inn', 265, '2019-09-26', 320, NULL),
('Cute Mountains Inn', 265, '2019-09-27', 337, NULL),
('Cute Mountains Inn', 265, '2019-09-28', 108, NULL),
('Cute Mountains Inn', 265, '2019-09-29', 236, NULL),
('Cute Mountains Inn', 265, '2019-09-30', 136, NULL),
('Cute Mountains Inn', 265, '2019-10-01', 272, NULL),
('Cute Mountains Inn', 265, '2019-10-02', 339, NULL),
('Cute Mountains Inn', 265, '2019-10-03', 326, NULL),
('Cute Mountains Inn', 265, '2019-10-04', 356, NULL),
('Cute Mountains Inn', 265, '2019-10-05', 102, NULL),
('Cute Mountains Inn', 265, '2019-10-06', 215, NULL),
('Cute Mountains Inn', 265, '2019-10-07', 262, NULL),
('Cute Mountains Inn', 265, '2019-10-08', 262, NULL),
('Cute Mountains Inn', 265, '2019-10-09', 366, NULL),
('Cute Mountains Inn', 265, '2019-10-10', 122, NULL),
('Cute Mountains Inn', 265, '2019-10-11', 134, NULL),
('Cute Mountains Inn', 265, '2019-10-12', 117, NULL),
('Cute Mountains Inn', 265, '2019-10-13', 186, NULL),
('Cute Mountains Inn', 265, '2019-10-14', 256, NULL),
('Cute Mountains Inn', 265, '2019-10-15', 164, NULL),
('Cute Mountains Inn', 265, '2019-10-16', 356, NULL),
('Cute Mountains Inn', 265, '2019-10-17', 269, NULL),
('Cute Mountains Inn', 265, '2019-10-18', 152, NULL),
('Cute Mountains Inn', 265, '2019-10-19', 249, NULL),
('Cute Mountains Inn', 265, '2019-10-20', 354, NULL),
('Cute Mountains Inn', 265, '2019-10-21', 188, NULL),
('Cute Mountains Inn', 265, '2019-10-22', 189, NULL),
('Cute Mountains Inn', 265, '2019-10-23', 198, NULL),
('Cute Mountains Inn', 265, '2019-10-24', 324, NULL),
('Cute Mountains Inn', 265, '2019-10-25', 116, NULL),
('Cute Mountains Inn', 265, '2019-10-26', 116, NULL),
('Cute Mountains Inn', 265, '2019-10-27', 340, NULL),
('Cute Mountains Inn', 265, '2019-10-28', 113, NULL),
('Cute Mountains Inn', 265, '2019-10-29', 184, NULL),
('Cute Mountains Inn', 265, '2019-10-30', 167, NULL),
('Cute Mountains Inn', 265, '2019-10-31', 344, NULL),
('Cute Mountains Inn', 265, '2019-11-01', 198, NULL),
('Cute Mountains Inn', 265, '2019-11-02', 164, NULL),
('Cute Mountains Inn', 265, '2019-11-03', 215, NULL),
('Cute Mountains Inn', 265, '2019-11-04', 295, NULL),
('Cute Mountains Inn', 265, '2019-11-05', 190, NULL),
('Cute Mountains Inn', 265, '2019-11-06', 134, NULL),
('Cute Mountains Inn', 265, '2019-11-07', 380, NULL),
('Cute Mountains Inn', 265, '2019-11-08', 320, NULL),
('Cute Mountains Inn', 265, '2019-11-09', 338, NULL),
('Cute Mountains Inn', 265, '2019-11-10', 177, NULL),
('Cute Mountains Inn', 265, '2019-11-11', 288, NULL),
('Cute Mountains Inn', 265, '2019-11-12', 153, NULL),
('Cute Mountains Inn', 265, '2019-11-13', 373, NULL),
('Cute Mountains Inn', 265, '2019-11-14', 195, NULL),
('Cute Mountains Inn', 265, '2019-11-15', 262, NULL),
('Cute Mountains Inn', 265, '2019-11-16', 199, NULL),
('Cute Mountains Inn', 265, '2019-11-17', 194, NULL),
('Cute Mountains Inn', 265, '2019-11-18', 266, NULL),
('Cute Mountains Inn', 265, '2019-11-19', 254, NULL),
('Cute Mountains Inn', 265, '2019-11-20', 338, NULL),
('Cute Mountains Inn', 265, '2019-11-21', 343, NULL),
('Cute Mountains Inn', 265, '2019-11-22', 307, NULL),
('Cute Mountains Inn', 265, '2019-11-23', 155, NULL),
('Cute Mountains Inn', 265, '2019-11-24', 120, NULL),
('Cute Mountains Inn', 265, '2019-11-25', 329, NULL),
('Cute Mountains Inn', 265, '2019-11-26', 264, NULL),
('Cute Mountains Inn', 265, '2019-11-27', 195, NULL),
('Cute Mountains Inn', 265, '2019-11-28', 188, NULL),
('Cute Mountains Inn', 265, '2019-11-29', 365, NULL),
('Cute Mountains Inn', 265, '2019-11-30', 136, NULL),
('Cute Mountains Inn', 265, '2019-12-01', 212, NULL),
('Cute Mountains Inn', 265, '2019-12-02', 305, NULL),
('Cute Mountains Inn', 265, '2019-12-03', 181, NULL),
('Cute Mountains Inn', 265, '2019-12-04', 172, NULL),
('Cute Mountains Inn', 265, '2019-12-05', 150, NULL),
('Cute Mountains Inn', 265, '2019-12-06', 379, NULL),
('Cute Mountains Inn', 265, '2019-12-07', 334, NULL),
('Cute Mountains Inn', 265, '2019-12-08', 344, NULL),
('Cute Mountains Inn', 265, '2019-12-09', 398, NULL),
('Cute Mountains Inn', 265, '2019-12-10', 346, NULL),
('Cute Mountains Inn', 265, '2019-12-11', 220, NULL),
('Cute Mountains Inn', 265, '2019-12-12', 197, NULL),
('Cute Mountains Inn', 265, '2019-12-13', 395, NULL),
('Cute Mountains Inn', 265, '2019-12-14', 185, NULL),
('Cute Mountains Inn', 265, '2019-12-15', 318, NULL),
('Cute Mountains Inn', 265, '2019-12-16', 268, NULL),
('Cute Mountains Inn', 265, '2019-12-17', 104, NULL),
('Cute Mountains Inn', 265, '2019-12-18', 365, NULL),
('Cute Mountains Inn', 265, '2019-12-19', 399, NULL),
('Cute Mountains Inn', 265, '2019-12-20', 237, NULL),
('Cute Mountains Inn', 265, '2019-12-21', 140, NULL),
('Cute Mountains Inn', 265, '2019-12-22', 398, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 265, '2019-12-23', 276, NULL),
('Cute Mountains Inn', 265, '2019-12-24', 348, NULL),
('Cute Mountains Inn', 265, '2019-12-25', 255, NULL),
('Cute Mountains Inn', 265, '2019-12-26', 298, NULL),
('Cute Mountains Inn', 265, '2019-12-27', 195, NULL),
('Cute Mountains Inn', 265, '2019-12-28', 337, NULL),
('Cute Mountains Inn', 265, '2019-12-29', 160, NULL),
('Cute Mountains Inn', 265, '2019-12-30', 186, NULL),
('Cute Mountains Inn', 265, '2019-12-31', 142, NULL),
('Cute Mountains Inn', 265, '2020-01-01', 363, NULL),
('Cute Mountains Inn', 265, '2020-01-02', 388, NULL),
('Cute Mountains Inn', 265, '2020-01-03', 210, NULL),
('Cute Mountains Inn', 265, '2020-01-04', 283, NULL),
('Cute Mountains Inn', 265, '2020-01-05', 204, NULL),
('Cute Mountains Inn', 265, '2020-01-06', 380, NULL),
('Cute Mountains Inn', 265, '2020-01-07', 171, NULL),
('Cute Mountains Inn', 265, '2020-01-08', 394, NULL),
('Cute Mountains Inn', 265, '2020-01-09', 214, NULL),
('Cute Mountains Inn', 265, '2020-01-10', 372, NULL),
('Cute Mountains Inn', 265, '2020-01-11', 149, NULL),
('Cute Mountains Inn', 265, '2020-01-12', 394, NULL),
('Cute Mountains Inn', 265, '2020-01-13', 323, NULL),
('Cute Mountains Inn', 265, '2020-01-14', 388, NULL),
('Cute Mountains Inn', 265, '2020-01-15', 276, NULL),
('Cute Mountains Inn', 265, '2020-01-16', 242, NULL),
('Cute Mountains Inn', 265, '2020-01-17', 242, NULL),
('Cute Mountains Inn', 265, '2020-01-18', 152, NULL),
('Cute Mountains Inn', 265, '2020-01-19', 236, NULL),
('Cute Mountains Inn', 265, '2020-01-20', 131, NULL),
('Cute Mountains Inn', 265, '2020-01-21', 189, NULL),
('Cute Mountains Inn', 265, '2020-01-22', 395, NULL),
('Cute Mountains Inn', 265, '2020-01-23', 222, NULL),
('Cute Mountains Inn', 265, '2020-01-24', 163, NULL),
('Cute Mountains Inn', 265, '2020-01-25', 112, NULL),
('Cute Mountains Inn', 265, '2020-01-26', 267, NULL),
('Cute Mountains Inn', 265, '2020-01-27', 281, NULL),
('Cute Mountains Inn', 265, '2020-01-28', 127, NULL),
('Cute Mountains Inn', 265, '2020-01-29', 197, NULL),
('Cute Mountains Inn', 265, '2020-01-30', 375, NULL),
('Cute Mountains Inn', 265, '2020-01-31', 388, NULL),
('Cute Mountains Inn', 265, '2020-02-01', 222, NULL),
('Cute Mountains Inn', 265, '2020-02-02', 309, NULL),
('Cute Mountains Inn', 265, '2020-02-03', 354, NULL),
('Cute Mountains Inn', 265, '2020-02-04', 360, NULL),
('Cute Mountains Inn', 273, '2019-01-01', 164, NULL),
('Cute Mountains Inn', 273, '2019-01-02', 127, NULL),
('Cute Mountains Inn', 273, '2019-01-03', 373, NULL),
('Cute Mountains Inn', 273, '2019-01-04', 312, NULL),
('Cute Mountains Inn', 273, '2019-01-05', 224, NULL),
('Cute Mountains Inn', 273, '2019-01-06', 265, NULL),
('Cute Mountains Inn', 273, '2019-01-07', 272, NULL),
('Cute Mountains Inn', 273, '2019-01-08', 207, NULL),
('Cute Mountains Inn', 273, '2019-01-09', 152, NULL),
('Cute Mountains Inn', 273, '2019-01-10', 244, NULL),
('Cute Mountains Inn', 273, '2019-01-11', 124, NULL),
('Cute Mountains Inn', 273, '2019-01-12', 250, NULL),
('Cute Mountains Inn', 273, '2019-01-13', 108, NULL),
('Cute Mountains Inn', 273, '2019-01-14', 203, NULL),
('Cute Mountains Inn', 273, '2019-01-15', 189, NULL),
('Cute Mountains Inn', 273, '2019-01-16', 182, NULL),
('Cute Mountains Inn', 273, '2019-01-17', 205, NULL),
('Cute Mountains Inn', 273, '2019-01-18', 254, NULL),
('Cute Mountains Inn', 273, '2019-01-19', 363, NULL),
('Cute Mountains Inn', 273, '2019-01-20', 274, NULL),
('Cute Mountains Inn', 273, '2019-01-21', 248, NULL),
('Cute Mountains Inn', 273, '2019-01-22', 197, NULL),
('Cute Mountains Inn', 273, '2019-01-23', 132, NULL),
('Cute Mountains Inn', 273, '2019-01-24', 268, NULL),
('Cute Mountains Inn', 273, '2019-01-25', 149, NULL),
('Cute Mountains Inn', 273, '2019-01-26', 350, NULL),
('Cute Mountains Inn', 273, '2019-01-27', 177, NULL),
('Cute Mountains Inn', 273, '2019-01-28', 123, NULL),
('Cute Mountains Inn', 273, '2019-01-29', 124, NULL),
('Cute Mountains Inn', 273, '2019-01-30', 206, NULL),
('Cute Mountains Inn', 273, '2019-01-31', 269, NULL),
('Cute Mountains Inn', 273, '2019-02-01', 266, NULL),
('Cute Mountains Inn', 273, '2019-02-02', 120, NULL),
('Cute Mountains Inn', 273, '2019-02-03', 116, NULL),
('Cute Mountains Inn', 273, '2019-02-04', 289, NULL),
('Cute Mountains Inn', 273, '2019-02-05', 299, NULL),
('Cute Mountains Inn', 273, '2019-02-06', 310, NULL),
('Cute Mountains Inn', 273, '2019-02-07', 189, NULL),
('Cute Mountains Inn', 273, '2019-02-08', 134, NULL),
('Cute Mountains Inn', 273, '2019-02-09', 278, NULL),
('Cute Mountains Inn', 273, '2019-02-10', 155, NULL),
('Cute Mountains Inn', 273, '2019-02-11', 313, NULL),
('Cute Mountains Inn', 273, '2019-02-12', 146, NULL),
('Cute Mountains Inn', 273, '2019-02-13', 103, NULL),
('Cute Mountains Inn', 273, '2019-02-14', 338, NULL),
('Cute Mountains Inn', 273, '2019-02-15', 242, NULL),
('Cute Mountains Inn', 273, '2019-02-16', 252, NULL),
('Cute Mountains Inn', 273, '2019-02-17', 359, NULL),
('Cute Mountains Inn', 273, '2019-02-18', 217, NULL),
('Cute Mountains Inn', 273, '2019-02-19', 175, NULL),
('Cute Mountains Inn', 273, '2019-02-20', 280, NULL),
('Cute Mountains Inn', 273, '2019-02-21', 143, NULL),
('Cute Mountains Inn', 273, '2019-02-22', 299, NULL),
('Cute Mountains Inn', 273, '2019-02-23', 216, NULL),
('Cute Mountains Inn', 273, '2019-02-24', 386, NULL),
('Cute Mountains Inn', 273, '2019-02-25', 328, NULL),
('Cute Mountains Inn', 273, '2019-02-26', 153, NULL),
('Cute Mountains Inn', 273, '2019-02-27', 269, NULL),
('Cute Mountains Inn', 273, '2019-02-28', 268, NULL),
('Cute Mountains Inn', 273, '2019-03-01', 326, NULL),
('Cute Mountains Inn', 273, '2019-03-02', 245, NULL),
('Cute Mountains Inn', 273, '2019-03-03', 250, NULL),
('Cute Mountains Inn', 273, '2019-03-04', 158, NULL),
('Cute Mountains Inn', 273, '2019-03-05', 302, NULL),
('Cute Mountains Inn', 273, '2019-03-06', 356, NULL),
('Cute Mountains Inn', 273, '2019-03-07', 207, NULL),
('Cute Mountains Inn', 273, '2019-03-08', 143, NULL),
('Cute Mountains Inn', 273, '2019-03-09', 141, NULL),
('Cute Mountains Inn', 273, '2019-03-10', 281, NULL),
('Cute Mountains Inn', 273, '2019-03-11', 184, NULL),
('Cute Mountains Inn', 273, '2019-03-12', 163, NULL),
('Cute Mountains Inn', 273, '2019-03-13', 150, NULL),
('Cute Mountains Inn', 273, '2019-03-14', 370, NULL),
('Cute Mountains Inn', 273, '2019-03-15', 248, NULL),
('Cute Mountains Inn', 273, '2019-03-16', 232, NULL),
('Cute Mountains Inn', 273, '2019-03-17', 355, NULL),
('Cute Mountains Inn', 273, '2019-03-18', 172, NULL),
('Cute Mountains Inn', 273, '2019-03-19', 146, NULL),
('Cute Mountains Inn', 273, '2019-03-20', 262, NULL),
('Cute Mountains Inn', 273, '2019-03-21', 177, NULL),
('Cute Mountains Inn', 273, '2019-03-22', 219, NULL),
('Cute Mountains Inn', 273, '2019-03-23', 189, NULL),
('Cute Mountains Inn', 273, '2019-03-24', 200, NULL),
('Cute Mountains Inn', 273, '2019-03-25', 202, NULL),
('Cute Mountains Inn', 273, '2019-03-26', 284, NULL),
('Cute Mountains Inn', 273, '2019-03-27', 383, NULL),
('Cute Mountains Inn', 273, '2019-03-28', 325, NULL),
('Cute Mountains Inn', 273, '2019-03-29', 351, NULL),
('Cute Mountains Inn', 273, '2019-03-30', 319, NULL),
('Cute Mountains Inn', 273, '2019-03-31', 247, NULL),
('Cute Mountains Inn', 273, '2019-04-01', 359, NULL),
('Cute Mountains Inn', 273, '2019-04-02', 369, NULL),
('Cute Mountains Inn', 273, '2019-04-03', 316, NULL),
('Cute Mountains Inn', 273, '2019-04-04', 280, NULL),
('Cute Mountains Inn', 273, '2019-04-05', 192, NULL),
('Cute Mountains Inn', 273, '2019-04-06', 150, NULL),
('Cute Mountains Inn', 273, '2019-04-07', 390, NULL),
('Cute Mountains Inn', 273, '2019-04-08', 243, NULL),
('Cute Mountains Inn', 273, '2019-04-09', 257, NULL),
('Cute Mountains Inn', 273, '2019-04-10', 330, NULL),
('Cute Mountains Inn', 273, '2019-04-11', 134, NULL),
('Cute Mountains Inn', 273, '2019-04-12', 329, NULL),
('Cute Mountains Inn', 273, '2019-04-13', 259, NULL),
('Cute Mountains Inn', 273, '2019-04-14', 233, NULL),
('Cute Mountains Inn', 273, '2019-04-15', 255, NULL),
('Cute Mountains Inn', 273, '2019-04-16', 219, NULL),
('Cute Mountains Inn', 273, '2019-04-17', 257, NULL),
('Cute Mountains Inn', 273, '2019-04-18', 323, NULL),
('Cute Mountains Inn', 273, '2019-04-19', 136, NULL),
('Cute Mountains Inn', 273, '2019-04-20', 183, NULL),
('Cute Mountains Inn', 273, '2019-04-21', 221, NULL),
('Cute Mountains Inn', 273, '2019-04-22', 397, NULL),
('Cute Mountains Inn', 273, '2019-04-23', 368, NULL),
('Cute Mountains Inn', 273, '2019-04-24', 302, NULL),
('Cute Mountains Inn', 273, '2019-04-25', 234, NULL),
('Cute Mountains Inn', 273, '2019-04-26', 217, NULL),
('Cute Mountains Inn', 273, '2019-04-27', 374, NULL),
('Cute Mountains Inn', 273, '2019-04-28', 106, NULL),
('Cute Mountains Inn', 273, '2019-04-29', 183, NULL),
('Cute Mountains Inn', 273, '2019-04-30', 216, NULL),
('Cute Mountains Inn', 273, '2019-05-01', 177, NULL),
('Cute Mountains Inn', 273, '2019-05-02', 149, NULL),
('Cute Mountains Inn', 273, '2019-05-03', 271, NULL),
('Cute Mountains Inn', 273, '2019-05-04', 173, NULL),
('Cute Mountains Inn', 273, '2019-05-05', 395, NULL),
('Cute Mountains Inn', 273, '2019-05-06', 290, NULL),
('Cute Mountains Inn', 273, '2019-05-07', 178, NULL),
('Cute Mountains Inn', 273, '2019-05-08', 327, NULL),
('Cute Mountains Inn', 273, '2019-05-09', 273, NULL),
('Cute Mountains Inn', 273, '2019-05-10', 364, NULL),
('Cute Mountains Inn', 273, '2019-05-11', 276, NULL),
('Cute Mountains Inn', 273, '2019-05-12', 207, NULL),
('Cute Mountains Inn', 273, '2019-05-13', 217, NULL),
('Cute Mountains Inn', 273, '2019-05-14', 268, NULL),
('Cute Mountains Inn', 273, '2019-05-15', 158, NULL),
('Cute Mountains Inn', 273, '2019-05-16', 291, NULL),
('Cute Mountains Inn', 273, '2019-05-17', 197, NULL),
('Cute Mountains Inn', 273, '2019-05-18', 258, NULL),
('Cute Mountains Inn', 273, '2019-05-19', 243, NULL),
('Cute Mountains Inn', 273, '2019-05-20', 199, NULL),
('Cute Mountains Inn', 273, '2019-05-21', 198, NULL),
('Cute Mountains Inn', 273, '2019-05-22', 110, NULL),
('Cute Mountains Inn', 273, '2019-05-23', 172, NULL),
('Cute Mountains Inn', 273, '2019-05-24', 192, NULL),
('Cute Mountains Inn', 273, '2019-05-25', 145, NULL),
('Cute Mountains Inn', 273, '2019-05-26', 319, NULL),
('Cute Mountains Inn', 273, '2019-05-27', 135, NULL),
('Cute Mountains Inn', 273, '2019-05-28', 119, NULL),
('Cute Mountains Inn', 273, '2019-05-29', 330, NULL),
('Cute Mountains Inn', 273, '2019-05-30', 308, NULL),
('Cute Mountains Inn', 273, '2019-05-31', 114, NULL),
('Cute Mountains Inn', 273, '2019-06-01', 171, NULL),
('Cute Mountains Inn', 273, '2019-06-02', 229, NULL),
('Cute Mountains Inn', 273, '2019-06-03', 307, NULL),
('Cute Mountains Inn', 273, '2019-06-04', 310, NULL),
('Cute Mountains Inn', 273, '2019-06-05', 324, NULL),
('Cute Mountains Inn', 273, '2019-06-06', 239, NULL),
('Cute Mountains Inn', 273, '2019-06-07', 349, NULL),
('Cute Mountains Inn', 273, '2019-06-08', 208, NULL),
('Cute Mountains Inn', 273, '2019-06-09', 393, NULL),
('Cute Mountains Inn', 273, '2019-06-10', 139, NULL),
('Cute Mountains Inn', 273, '2019-06-11', 154, NULL),
('Cute Mountains Inn', 273, '2019-06-12', 181, NULL),
('Cute Mountains Inn', 273, '2019-06-13', 187, NULL),
('Cute Mountains Inn', 273, '2019-06-14', 190, NULL),
('Cute Mountains Inn', 273, '2019-06-15', 124, NULL),
('Cute Mountains Inn', 273, '2019-06-16', 165, NULL),
('Cute Mountains Inn', 273, '2019-06-17', 282, NULL),
('Cute Mountains Inn', 273, '2019-06-18', 191, NULL),
('Cute Mountains Inn', 273, '2019-06-19', 103, NULL),
('Cute Mountains Inn', 273, '2019-06-20', 118, NULL),
('Cute Mountains Inn', 273, '2019-06-21', 157, NULL),
('Cute Mountains Inn', 273, '2019-06-22', 166, NULL),
('Cute Mountains Inn', 273, '2019-06-23', 322, NULL),
('Cute Mountains Inn', 273, '2019-06-24', 170, NULL),
('Cute Mountains Inn', 273, '2019-06-25', 375, NULL),
('Cute Mountains Inn', 273, '2019-06-26', 352, NULL),
('Cute Mountains Inn', 273, '2019-06-27', 327, NULL),
('Cute Mountains Inn', 273, '2019-06-28', 210, NULL),
('Cute Mountains Inn', 273, '2019-06-29', 236, NULL),
('Cute Mountains Inn', 273, '2019-06-30', 139, NULL),
('Cute Mountains Inn', 273, '2019-07-01', 242, NULL),
('Cute Mountains Inn', 273, '2019-07-02', 199, NULL),
('Cute Mountains Inn', 273, '2019-07-03', 369, NULL),
('Cute Mountains Inn', 273, '2019-07-04', 115, NULL),
('Cute Mountains Inn', 273, '2019-07-05', 158, NULL),
('Cute Mountains Inn', 273, '2019-07-06', 376, NULL),
('Cute Mountains Inn', 273, '2019-07-07', 238, NULL),
('Cute Mountains Inn', 273, '2019-07-08', 391, NULL),
('Cute Mountains Inn', 273, '2019-07-09', 362, NULL),
('Cute Mountains Inn', 273, '2019-07-10', 139, NULL),
('Cute Mountains Inn', 273, '2019-07-11', 172, NULL),
('Cute Mountains Inn', 273, '2019-07-12', 274, NULL),
('Cute Mountains Inn', 273, '2019-07-13', 325, NULL),
('Cute Mountains Inn', 273, '2019-07-14', 268, NULL),
('Cute Mountains Inn', 273, '2019-07-15', 157, NULL),
('Cute Mountains Inn', 273, '2019-07-16', 198, NULL),
('Cute Mountains Inn', 273, '2019-07-17', 183, NULL),
('Cute Mountains Inn', 273, '2019-07-18', 335, NULL),
('Cute Mountains Inn', 273, '2019-07-19', 314, NULL),
('Cute Mountains Inn', 273, '2019-07-20', 324, NULL),
('Cute Mountains Inn', 273, '2019-07-21', 319, NULL),
('Cute Mountains Inn', 273, '2019-07-22', 132, NULL),
('Cute Mountains Inn', 273, '2019-07-23', 165, NULL),
('Cute Mountains Inn', 273, '2019-07-24', 344, NULL),
('Cute Mountains Inn', 273, '2019-07-25', 176, NULL),
('Cute Mountains Inn', 273, '2019-07-26', 222, NULL),
('Cute Mountains Inn', 273, '2019-07-27', 389, NULL),
('Cute Mountains Inn', 273, '2019-07-28', 163, NULL),
('Cute Mountains Inn', 273, '2019-07-29', 268, NULL),
('Cute Mountains Inn', 273, '2019-07-30', 172, NULL),
('Cute Mountains Inn', 273, '2019-07-31', 169, NULL),
('Cute Mountains Inn', 273, '2019-08-01', 302, NULL),
('Cute Mountains Inn', 273, '2019-08-02', 252, NULL),
('Cute Mountains Inn', 273, '2019-08-03', 233, NULL),
('Cute Mountains Inn', 273, '2019-08-04', 109, NULL),
('Cute Mountains Inn', 273, '2019-08-05', 268, NULL),
('Cute Mountains Inn', 273, '2019-08-06', 204, NULL),
('Cute Mountains Inn', 273, '2019-08-07', 259, NULL),
('Cute Mountains Inn', 273, '2019-08-08', 114, NULL),
('Cute Mountains Inn', 273, '2019-08-09', 204, NULL),
('Cute Mountains Inn', 273, '2019-08-10', 102, NULL),
('Cute Mountains Inn', 273, '2019-08-11', 278, NULL),
('Cute Mountains Inn', 273, '2019-08-12', 351, NULL),
('Cute Mountains Inn', 273, '2019-08-13', 371, NULL),
('Cute Mountains Inn', 273, '2019-08-14', 183, NULL),
('Cute Mountains Inn', 273, '2019-08-15', 320, NULL),
('Cute Mountains Inn', 273, '2019-08-16', 364, NULL),
('Cute Mountains Inn', 273, '2019-08-17', 141, NULL),
('Cute Mountains Inn', 273, '2019-08-18', 265, NULL),
('Cute Mountains Inn', 273, '2019-08-19', 261, NULL),
('Cute Mountains Inn', 273, '2019-08-20', 381, NULL),
('Cute Mountains Inn', 273, '2019-08-21', 248, NULL),
('Cute Mountains Inn', 273, '2019-08-22', 146, NULL),
('Cute Mountains Inn', 273, '2019-08-23', 194, NULL),
('Cute Mountains Inn', 273, '2019-08-24', 335, NULL),
('Cute Mountains Inn', 273, '2019-08-25', 263, NULL),
('Cute Mountains Inn', 273, '2019-08-26', 221, NULL),
('Cute Mountains Inn', 273, '2019-08-27', 345, NULL),
('Cute Mountains Inn', 273, '2019-08-28', 106, NULL),
('Cute Mountains Inn', 273, '2019-08-29', 382, NULL),
('Cute Mountains Inn', 273, '2019-08-30', 109, NULL),
('Cute Mountains Inn', 273, '2019-08-31', 242, NULL),
('Cute Mountains Inn', 273, '2019-09-01', 247, NULL),
('Cute Mountains Inn', 273, '2019-09-02', 297, NULL),
('Cute Mountains Inn', 273, '2019-09-03', 245, NULL),
('Cute Mountains Inn', 273, '2019-09-04', 328, NULL),
('Cute Mountains Inn', 273, '2019-09-05', 186, NULL),
('Cute Mountains Inn', 273, '2019-09-06', 224, NULL),
('Cute Mountains Inn', 273, '2019-09-07', 354, NULL),
('Cute Mountains Inn', 273, '2019-09-08', 180, NULL),
('Cute Mountains Inn', 273, '2019-09-09', 298, NULL),
('Cute Mountains Inn', 273, '2019-09-10', 360, NULL),
('Cute Mountains Inn', 273, '2019-09-11', 148, NULL),
('Cute Mountains Inn', 273, '2019-09-12', 270, NULL),
('Cute Mountains Inn', 273, '2019-09-13', 197, NULL),
('Cute Mountains Inn', 273, '2019-09-14', 301, NULL),
('Cute Mountains Inn', 273, '2019-09-15', 302, NULL),
('Cute Mountains Inn', 273, '2019-09-16', 275, NULL),
('Cute Mountains Inn', 273, '2019-09-17', 138, NULL),
('Cute Mountains Inn', 273, '2019-09-18', 253, NULL),
('Cute Mountains Inn', 273, '2019-09-19', 159, NULL),
('Cute Mountains Inn', 273, '2019-09-20', 178, NULL),
('Cute Mountains Inn', 273, '2019-09-21', 229, NULL),
('Cute Mountains Inn', 273, '2019-09-22', 151, NULL),
('Cute Mountains Inn', 273, '2019-09-23', 166, NULL),
('Cute Mountains Inn', 273, '2019-09-24', 256, NULL),
('Cute Mountains Inn', 273, '2019-09-25', 181, NULL),
('Cute Mountains Inn', 273, '2019-09-26', 347, NULL),
('Cute Mountains Inn', 273, '2019-09-27', 277, NULL),
('Cute Mountains Inn', 273, '2019-09-28', 236, NULL),
('Cute Mountains Inn', 273, '2019-09-29', 108, NULL),
('Cute Mountains Inn', 273, '2019-09-30', 268, NULL),
('Cute Mountains Inn', 273, '2019-10-01', 314, NULL),
('Cute Mountains Inn', 273, '2019-10-02', 217, NULL),
('Cute Mountains Inn', 273, '2019-10-03', 225, NULL),
('Cute Mountains Inn', 273, '2019-10-04', 297, NULL),
('Cute Mountains Inn', 273, '2019-10-05', 226, NULL),
('Cute Mountains Inn', 273, '2019-10-06', 362, NULL),
('Cute Mountains Inn', 273, '2019-10-07', 228, NULL),
('Cute Mountains Inn', 273, '2019-10-08', 198, NULL),
('Cute Mountains Inn', 273, '2019-10-09', 293, NULL),
('Cute Mountains Inn', 273, '2019-10-10', 130, NULL),
('Cute Mountains Inn', 273, '2019-10-11', 254, NULL),
('Cute Mountains Inn', 273, '2019-10-12', 179, NULL),
('Cute Mountains Inn', 273, '2019-10-13', 110, NULL),
('Cute Mountains Inn', 273, '2019-10-14', 107, NULL),
('Cute Mountains Inn', 273, '2019-10-15', 232, NULL),
('Cute Mountains Inn', 273, '2019-10-16', 382, NULL),
('Cute Mountains Inn', 273, '2019-10-17', 297, NULL),
('Cute Mountains Inn', 273, '2019-10-18', 381, NULL),
('Cute Mountains Inn', 273, '2019-10-19', 266, NULL),
('Cute Mountains Inn', 273, '2019-10-20', 206, NULL),
('Cute Mountains Inn', 273, '2019-10-21', 310, NULL),
('Cute Mountains Inn', 273, '2019-10-22', 316, NULL),
('Cute Mountains Inn', 273, '2019-10-23', 239, NULL),
('Cute Mountains Inn', 273, '2019-10-24', 310, NULL),
('Cute Mountains Inn', 273, '2019-10-25', 252, NULL),
('Cute Mountains Inn', 273, '2019-10-26', 189, NULL),
('Cute Mountains Inn', 273, '2019-10-27', 186, NULL),
('Cute Mountains Inn', 273, '2019-10-28', 358, NULL),
('Cute Mountains Inn', 273, '2019-10-29', 133, NULL),
('Cute Mountains Inn', 273, '2019-10-30', 385, NULL),
('Cute Mountains Inn', 273, '2019-10-31', 100, NULL),
('Cute Mountains Inn', 273, '2019-11-01', 267, NULL),
('Cute Mountains Inn', 273, '2019-11-02', 156, NULL),
('Cute Mountains Inn', 273, '2019-11-03', 320, NULL),
('Cute Mountains Inn', 273, '2019-11-04', 163, NULL),
('Cute Mountains Inn', 273, '2019-11-05', 142, NULL),
('Cute Mountains Inn', 273, '2019-11-06', 133, NULL),
('Cute Mountains Inn', 273, '2019-11-07', 311, NULL),
('Cute Mountains Inn', 273, '2019-11-08', 113, NULL),
('Cute Mountains Inn', 273, '2019-11-09', 352, NULL),
('Cute Mountains Inn', 273, '2019-11-10', 321, NULL),
('Cute Mountains Inn', 273, '2019-11-11', 258, NULL),
('Cute Mountains Inn', 273, '2019-11-12', 235, NULL),
('Cute Mountains Inn', 273, '2019-11-13', 101, NULL),
('Cute Mountains Inn', 273, '2019-11-14', 303, NULL),
('Cute Mountains Inn', 273, '2019-11-15', 332, NULL),
('Cute Mountains Inn', 273, '2019-11-16', 253, NULL),
('Cute Mountains Inn', 273, '2019-11-17', 198, NULL),
('Cute Mountains Inn', 273, '2019-11-18', 327, NULL),
('Cute Mountains Inn', 273, '2019-11-19', 126, NULL),
('Cute Mountains Inn', 273, '2019-11-20', 100, NULL),
('Cute Mountains Inn', 273, '2019-11-21', 102, NULL),
('Cute Mountains Inn', 273, '2019-11-22', 264, NULL),
('Cute Mountains Inn', 273, '2019-11-23', 166, NULL),
('Cute Mountains Inn', 273, '2019-11-24', 356, NULL),
('Cute Mountains Inn', 273, '2019-11-25', 267, NULL),
('Cute Mountains Inn', 273, '2019-11-26', 266, NULL),
('Cute Mountains Inn', 273, '2019-11-27', 395, NULL),
('Cute Mountains Inn', 273, '2019-11-28', 371, NULL),
('Cute Mountains Inn', 273, '2019-11-29', 116, NULL),
('Cute Mountains Inn', 273, '2019-11-30', 252, NULL),
('Cute Mountains Inn', 273, '2019-12-01', 273, NULL),
('Cute Mountains Inn', 273, '2019-12-02', 330, NULL),
('Cute Mountains Inn', 273, '2019-12-03', 330, NULL),
('Cute Mountains Inn', 273, '2019-12-04', 153, NULL),
('Cute Mountains Inn', 273, '2019-12-05', 191, NULL),
('Cute Mountains Inn', 273, '2019-12-06', 323, NULL),
('Cute Mountains Inn', 273, '2019-12-07', 162, NULL),
('Cute Mountains Inn', 273, '2019-12-08', 211, NULL),
('Cute Mountains Inn', 273, '2019-12-09', 262, NULL),
('Cute Mountains Inn', 273, '2019-12-10', 225, NULL),
('Cute Mountains Inn', 273, '2019-12-11', 284, NULL),
('Cute Mountains Inn', 273, '2019-12-12', 277, NULL),
('Cute Mountains Inn', 273, '2019-12-13', 244, NULL),
('Cute Mountains Inn', 273, '2019-12-14', 148, NULL),
('Cute Mountains Inn', 273, '2019-12-15', 117, NULL),
('Cute Mountains Inn', 273, '2019-12-16', 383, NULL),
('Cute Mountains Inn', 273, '2019-12-17', 377, NULL),
('Cute Mountains Inn', 273, '2019-12-18', 387, NULL),
('Cute Mountains Inn', 273, '2019-12-19', 249, NULL),
('Cute Mountains Inn', 273, '2019-12-20', 229, NULL),
('Cute Mountains Inn', 273, '2019-12-21', 213, NULL),
('Cute Mountains Inn', 273, '2019-12-22', 197, NULL),
('Cute Mountains Inn', 273, '2019-12-23', 378, NULL),
('Cute Mountains Inn', 273, '2019-12-24', 224, NULL),
('Cute Mountains Inn', 273, '2019-12-25', 173, NULL),
('Cute Mountains Inn', 273, '2019-12-26', 205, NULL),
('Cute Mountains Inn', 273, '2019-12-27', 123, NULL),
('Cute Mountains Inn', 273, '2019-12-28', 253, NULL),
('Cute Mountains Inn', 273, '2019-12-29', 151, NULL),
('Cute Mountains Inn', 273, '2019-12-30', 130, NULL),
('Cute Mountains Inn', 273, '2019-12-31', 192, NULL),
('Cute Mountains Inn', 273, '2020-01-01', 260, NULL),
('Cute Mountains Inn', 273, '2020-01-02', 105, NULL),
('Cute Mountains Inn', 273, '2020-01-03', 154, NULL),
('Cute Mountains Inn', 273, '2020-01-04', 239, NULL),
('Cute Mountains Inn', 273, '2020-01-05', 260, NULL),
('Cute Mountains Inn', 273, '2020-01-06', 251, NULL),
('Cute Mountains Inn', 273, '2020-01-07', 370, NULL),
('Cute Mountains Inn', 273, '2020-01-08', 194, NULL),
('Cute Mountains Inn', 273, '2020-01-09', 331, NULL),
('Cute Mountains Inn', 273, '2020-01-10', 288, NULL),
('Cute Mountains Inn', 273, '2020-01-11', 119, NULL),
('Cute Mountains Inn', 273, '2020-01-12', 314, NULL),
('Cute Mountains Inn', 273, '2020-01-13', 119, NULL),
('Cute Mountains Inn', 273, '2020-01-14', 300, NULL),
('Cute Mountains Inn', 273, '2020-01-15', 319, NULL),
('Cute Mountains Inn', 273, '2020-01-16', 363, NULL),
('Cute Mountains Inn', 273, '2020-01-17', 217, NULL),
('Cute Mountains Inn', 273, '2020-01-18', 157, NULL),
('Cute Mountains Inn', 273, '2020-01-19', 397, NULL),
('Cute Mountains Inn', 273, '2020-01-20', 294, NULL),
('Cute Mountains Inn', 273, '2020-01-21', 393, NULL),
('Cute Mountains Inn', 273, '2020-01-22', 225, NULL),
('Cute Mountains Inn', 273, '2020-01-23', 124, NULL),
('Cute Mountains Inn', 273, '2020-01-24', 238, NULL),
('Cute Mountains Inn', 273, '2020-01-25', 373, NULL),
('Cute Mountains Inn', 273, '2020-01-26', 225, NULL),
('Cute Mountains Inn', 273, '2020-01-27', 154, NULL),
('Cute Mountains Inn', 273, '2020-01-28', 144, NULL),
('Cute Mountains Inn', 273, '2020-01-29', 363, NULL),
('Cute Mountains Inn', 273, '2020-01-30', 135, NULL),
('Cute Mountains Inn', 273, '2020-01-31', 247, NULL),
('Cute Mountains Inn', 273, '2020-02-01', 315, NULL),
('Cute Mountains Inn', 273, '2020-02-02', 254, NULL),
('Cute Mountains Inn', 273, '2020-02-03', 132, NULL),
('Cute Mountains Inn', 273, '2020-02-04', 387, NULL),
('Cute Mountains Inn', 277, '2019-01-01', 397, NULL),
('Cute Mountains Inn', 277, '2019-01-02', 197, NULL),
('Cute Mountains Inn', 277, '2019-01-03', 203, NULL),
('Cute Mountains Inn', 277, '2019-01-04', 108, NULL),
('Cute Mountains Inn', 277, '2019-01-05', 166, NULL),
('Cute Mountains Inn', 277, '2019-01-06', 313, NULL),
('Cute Mountains Inn', 277, '2019-01-07', 275, NULL),
('Cute Mountains Inn', 277, '2019-01-08', 201, NULL),
('Cute Mountains Inn', 277, '2019-01-09', 329, NULL),
('Cute Mountains Inn', 277, '2019-01-10', 313, NULL),
('Cute Mountains Inn', 277, '2019-01-11', 361, NULL),
('Cute Mountains Inn', 277, '2019-01-12', 100, NULL),
('Cute Mountains Inn', 277, '2019-01-13', 144, NULL),
('Cute Mountains Inn', 277, '2019-01-14', 386, NULL),
('Cute Mountains Inn', 277, '2019-01-15', 366, NULL),
('Cute Mountains Inn', 277, '2019-01-16', 390, NULL),
('Cute Mountains Inn', 277, '2019-01-17', 144, NULL),
('Cute Mountains Inn', 277, '2019-01-18', 186, NULL),
('Cute Mountains Inn', 277, '2019-01-19', 273, NULL),
('Cute Mountains Inn', 277, '2019-01-20', 128, NULL),
('Cute Mountains Inn', 277, '2019-01-21', 326, NULL),
('Cute Mountains Inn', 277, '2019-01-22', 396, NULL),
('Cute Mountains Inn', 277, '2019-01-23', 109, NULL),
('Cute Mountains Inn', 277, '2019-01-24', 215, NULL),
('Cute Mountains Inn', 277, '2019-01-25', 140, NULL),
('Cute Mountains Inn', 277, '2019-01-26', 212, NULL),
('Cute Mountains Inn', 277, '2019-01-27', 372, NULL),
('Cute Mountains Inn', 277, '2019-01-28', 324, NULL),
('Cute Mountains Inn', 277, '2019-01-29', 117, NULL),
('Cute Mountains Inn', 277, '2019-01-30', 287, NULL),
('Cute Mountains Inn', 277, '2019-01-31', 224, NULL),
('Cute Mountains Inn', 277, '2019-02-01', 389, NULL),
('Cute Mountains Inn', 277, '2019-02-02', 148, NULL),
('Cute Mountains Inn', 277, '2019-02-03', 127, NULL),
('Cute Mountains Inn', 277, '2019-02-04', 129, NULL),
('Cute Mountains Inn', 277, '2019-02-05', 180, NULL),
('Cute Mountains Inn', 277, '2019-02-06', 245, NULL),
('Cute Mountains Inn', 277, '2019-02-07', 341, NULL),
('Cute Mountains Inn', 277, '2019-02-08', 302, NULL),
('Cute Mountains Inn', 277, '2019-02-09', 331, NULL),
('Cute Mountains Inn', 277, '2019-02-10', 349, NULL),
('Cute Mountains Inn', 277, '2019-02-11', 298, NULL),
('Cute Mountains Inn', 277, '2019-02-12', 359, NULL),
('Cute Mountains Inn', 277, '2019-02-13', 389, NULL),
('Cute Mountains Inn', 277, '2019-02-14', 144, NULL),
('Cute Mountains Inn', 277, '2019-02-15', 162, NULL),
('Cute Mountains Inn', 277, '2019-02-16', 349, NULL),
('Cute Mountains Inn', 277, '2019-02-17', 117, NULL),
('Cute Mountains Inn', 277, '2019-02-18', 292, NULL),
('Cute Mountains Inn', 277, '2019-02-19', 229, NULL),
('Cute Mountains Inn', 277, '2019-02-20', 207, NULL),
('Cute Mountains Inn', 277, '2019-02-21', 183, NULL),
('Cute Mountains Inn', 277, '2019-02-22', 295, NULL),
('Cute Mountains Inn', 277, '2019-02-23', 232, NULL),
('Cute Mountains Inn', 277, '2019-02-24', 247, NULL),
('Cute Mountains Inn', 277, '2019-02-25', 230, NULL),
('Cute Mountains Inn', 277, '2019-02-26', 289, NULL),
('Cute Mountains Inn', 277, '2019-02-27', 175, NULL),
('Cute Mountains Inn', 277, '2019-02-28', 196, NULL),
('Cute Mountains Inn', 277, '2019-03-01', 173, NULL),
('Cute Mountains Inn', 277, '2019-03-02', 292, NULL),
('Cute Mountains Inn', 277, '2019-03-03', 250, NULL),
('Cute Mountains Inn', 277, '2019-03-04', 320, NULL),
('Cute Mountains Inn', 277, '2019-03-05', 394, NULL),
('Cute Mountains Inn', 277, '2019-03-06', 325, NULL),
('Cute Mountains Inn', 277, '2019-03-07', 313, NULL),
('Cute Mountains Inn', 277, '2019-03-08', 336, NULL),
('Cute Mountains Inn', 277, '2019-03-09', 252, NULL),
('Cute Mountains Inn', 277, '2019-03-10', 261, NULL),
('Cute Mountains Inn', 277, '2019-03-11', 386, NULL),
('Cute Mountains Inn', 277, '2019-03-12', 365, NULL),
('Cute Mountains Inn', 277, '2019-03-13', 392, NULL),
('Cute Mountains Inn', 277, '2019-03-14', 296, NULL),
('Cute Mountains Inn', 277, '2019-03-15', 161, NULL),
('Cute Mountains Inn', 277, '2019-03-16', 275, NULL),
('Cute Mountains Inn', 277, '2019-03-17', 333, NULL),
('Cute Mountains Inn', 277, '2019-03-18', 290, NULL),
('Cute Mountains Inn', 277, '2019-03-19', 110, NULL),
('Cute Mountains Inn', 277, '2019-03-20', 171, NULL),
('Cute Mountains Inn', 277, '2019-03-21', 119, NULL),
('Cute Mountains Inn', 277, '2019-03-22', 385, NULL),
('Cute Mountains Inn', 277, '2019-03-23', 297, NULL),
('Cute Mountains Inn', 277, '2019-03-24', 386, NULL),
('Cute Mountains Inn', 277, '2019-03-25', 195, NULL),
('Cute Mountains Inn', 277, '2019-03-26', 363, NULL),
('Cute Mountains Inn', 277, '2019-03-27', 385, NULL),
('Cute Mountains Inn', 277, '2019-03-28', 333, NULL),
('Cute Mountains Inn', 277, '2019-03-29', 139, NULL),
('Cute Mountains Inn', 277, '2019-03-30', 173, NULL),
('Cute Mountains Inn', 277, '2019-03-31', 146, NULL),
('Cute Mountains Inn', 277, '2019-04-01', 141, NULL),
('Cute Mountains Inn', 277, '2019-04-02', 180, NULL),
('Cute Mountains Inn', 277, '2019-04-03', 207, NULL),
('Cute Mountains Inn', 277, '2019-04-04', 328, NULL),
('Cute Mountains Inn', 277, '2019-04-05', 396, NULL),
('Cute Mountains Inn', 277, '2019-04-06', 375, NULL),
('Cute Mountains Inn', 277, '2019-04-07', 185, NULL),
('Cute Mountains Inn', 277, '2019-04-08', 247, NULL),
('Cute Mountains Inn', 277, '2019-04-09', 201, NULL),
('Cute Mountains Inn', 277, '2019-04-10', 135, NULL),
('Cute Mountains Inn', 277, '2019-04-11', 259, NULL),
('Cute Mountains Inn', 277, '2019-04-12', 396, NULL),
('Cute Mountains Inn', 277, '2019-04-13', 263, NULL),
('Cute Mountains Inn', 277, '2019-04-14', 127, NULL),
('Cute Mountains Inn', 277, '2019-04-15', 294, NULL),
('Cute Mountains Inn', 277, '2019-04-16', 277, NULL),
('Cute Mountains Inn', 277, '2019-04-17', 139, NULL),
('Cute Mountains Inn', 277, '2019-04-18', 145, NULL),
('Cute Mountains Inn', 277, '2019-04-19', 298, NULL),
('Cute Mountains Inn', 277, '2019-04-20', 204, NULL),
('Cute Mountains Inn', 277, '2019-04-21', 168, NULL),
('Cute Mountains Inn', 277, '2019-04-22', 111, NULL),
('Cute Mountains Inn', 277, '2019-04-23', 321, NULL),
('Cute Mountains Inn', 277, '2019-04-24', 235, NULL),
('Cute Mountains Inn', 277, '2019-04-25', 274, NULL),
('Cute Mountains Inn', 277, '2019-04-26', 175, NULL),
('Cute Mountains Inn', 277, '2019-04-27', 276, NULL),
('Cute Mountains Inn', 277, '2019-04-28', 321, NULL),
('Cute Mountains Inn', 277, '2019-04-29', 188, NULL),
('Cute Mountains Inn', 277, '2019-04-30', 220, NULL),
('Cute Mountains Inn', 277, '2019-05-01', 193, NULL),
('Cute Mountains Inn', 277, '2019-05-02', 123, NULL),
('Cute Mountains Inn', 277, '2019-05-03', 217, NULL),
('Cute Mountains Inn', 277, '2019-05-04', 257, NULL),
('Cute Mountains Inn', 277, '2019-05-05', 122, NULL),
('Cute Mountains Inn', 277, '2019-05-06', 220, NULL),
('Cute Mountains Inn', 277, '2019-05-07', 275, NULL),
('Cute Mountains Inn', 277, '2019-05-08', 132, NULL),
('Cute Mountains Inn', 277, '2019-05-09', 207, NULL),
('Cute Mountains Inn', 277, '2019-05-10', 202, NULL),
('Cute Mountains Inn', 277, '2019-05-11', 165, NULL),
('Cute Mountains Inn', 277, '2019-05-12', 339, NULL),
('Cute Mountains Inn', 277, '2019-05-13', 167, NULL),
('Cute Mountains Inn', 277, '2019-05-14', 322, NULL),
('Cute Mountains Inn', 277, '2019-05-15', 213, NULL),
('Cute Mountains Inn', 277, '2019-05-16', 207, NULL),
('Cute Mountains Inn', 277, '2019-05-17', 259, NULL),
('Cute Mountains Inn', 277, '2019-05-18', 120, NULL),
('Cute Mountains Inn', 277, '2019-05-19', 238, NULL),
('Cute Mountains Inn', 277, '2019-05-20', 176, NULL),
('Cute Mountains Inn', 277, '2019-05-21', 338, NULL),
('Cute Mountains Inn', 277, '2019-05-22', 201, NULL),
('Cute Mountains Inn', 277, '2019-05-23', 113, NULL),
('Cute Mountains Inn', 277, '2019-05-24', 142, NULL),
('Cute Mountains Inn', 277, '2019-05-25', 130, NULL),
('Cute Mountains Inn', 277, '2019-05-26', 134, NULL),
('Cute Mountains Inn', 277, '2019-05-27', 330, NULL),
('Cute Mountains Inn', 277, '2019-05-28', 177, NULL),
('Cute Mountains Inn', 277, '2019-05-29', 159, NULL),
('Cute Mountains Inn', 277, '2019-05-30', 274, NULL),
('Cute Mountains Inn', 277, '2019-05-31', 191, NULL),
('Cute Mountains Inn', 277, '2019-06-01', 263, NULL),
('Cute Mountains Inn', 277, '2019-06-02', 251, NULL),
('Cute Mountains Inn', 277, '2019-06-03', 392, NULL),
('Cute Mountains Inn', 277, '2019-06-04', 375, NULL),
('Cute Mountains Inn', 277, '2019-06-05', 179, NULL),
('Cute Mountains Inn', 277, '2019-06-06', 229, NULL),
('Cute Mountains Inn', 277, '2019-06-07', 174, NULL),
('Cute Mountains Inn', 277, '2019-06-08', 301, NULL),
('Cute Mountains Inn', 277, '2019-06-09', 312, NULL),
('Cute Mountains Inn', 277, '2019-06-10', 362, NULL),
('Cute Mountains Inn', 277, '2019-06-11', 329, NULL),
('Cute Mountains Inn', 277, '2019-06-12', 356, NULL),
('Cute Mountains Inn', 277, '2019-06-13', 340, NULL),
('Cute Mountains Inn', 277, '2019-06-14', 263, NULL),
('Cute Mountains Inn', 277, '2019-06-15', 251, NULL),
('Cute Mountains Inn', 277, '2019-06-16', 353, NULL),
('Cute Mountains Inn', 277, '2019-06-17', 328, NULL),
('Cute Mountains Inn', 277, '2019-06-18', 148, NULL),
('Cute Mountains Inn', 277, '2019-06-19', 311, NULL),
('Cute Mountains Inn', 277, '2019-06-20', 284, NULL),
('Cute Mountains Inn', 277, '2019-06-21', 164, NULL),
('Cute Mountains Inn', 277, '2019-06-22', 176, NULL),
('Cute Mountains Inn', 277, '2019-06-23', 192, NULL),
('Cute Mountains Inn', 277, '2019-06-24', 351, NULL),
('Cute Mountains Inn', 277, '2019-06-25', 310, NULL),
('Cute Mountains Inn', 277, '2019-06-26', 389, NULL),
('Cute Mountains Inn', 277, '2019-06-27', 270, NULL),
('Cute Mountains Inn', 277, '2019-06-28', 248, NULL),
('Cute Mountains Inn', 277, '2019-06-29', 187, NULL),
('Cute Mountains Inn', 277, '2019-06-30', 343, NULL),
('Cute Mountains Inn', 277, '2019-07-01', 291, NULL),
('Cute Mountains Inn', 277, '2019-07-02', 151, NULL),
('Cute Mountains Inn', 277, '2019-07-03', 356, NULL),
('Cute Mountains Inn', 277, '2019-07-04', 322, NULL),
('Cute Mountains Inn', 277, '2019-07-05', 223, NULL),
('Cute Mountains Inn', 277, '2019-07-06', 394, NULL),
('Cute Mountains Inn', 277, '2019-07-07', 301, NULL),
('Cute Mountains Inn', 277, '2019-07-08', 376, NULL),
('Cute Mountains Inn', 277, '2019-07-09', 351, NULL),
('Cute Mountains Inn', 277, '2019-07-10', 273, NULL),
('Cute Mountains Inn', 277, '2019-07-11', 144, NULL),
('Cute Mountains Inn', 277, '2019-07-12', 135, NULL),
('Cute Mountains Inn', 277, '2019-07-13', 133, NULL),
('Cute Mountains Inn', 277, '2019-07-14', 180, NULL),
('Cute Mountains Inn', 277, '2019-07-15', 218, NULL),
('Cute Mountains Inn', 277, '2019-07-16', 323, NULL),
('Cute Mountains Inn', 277, '2019-07-17', 290, NULL),
('Cute Mountains Inn', 277, '2019-07-18', 163, NULL),
('Cute Mountains Inn', 277, '2019-07-19', 286, NULL),
('Cute Mountains Inn', 277, '2019-07-20', 385, NULL),
('Cute Mountains Inn', 277, '2019-07-21', 234, NULL),
('Cute Mountains Inn', 277, '2019-07-22', 222, NULL),
('Cute Mountains Inn', 277, '2019-07-23', 246, NULL),
('Cute Mountains Inn', 277, '2019-07-24', 308, NULL),
('Cute Mountains Inn', 277, '2019-07-25', 139, NULL),
('Cute Mountains Inn', 277, '2019-07-26', 227, NULL),
('Cute Mountains Inn', 277, '2019-07-27', 284, NULL),
('Cute Mountains Inn', 277, '2019-07-28', 331, NULL),
('Cute Mountains Inn', 277, '2019-07-29', 387, NULL),
('Cute Mountains Inn', 277, '2019-07-30', 364, NULL),
('Cute Mountains Inn', 277, '2019-07-31', 277, NULL),
('Cute Mountains Inn', 277, '2019-08-01', 155, NULL),
('Cute Mountains Inn', 277, '2019-08-02', 344, NULL),
('Cute Mountains Inn', 277, '2019-08-03', 332, NULL),
('Cute Mountains Inn', 277, '2019-08-04', 160, NULL),
('Cute Mountains Inn', 277, '2019-08-05', 112, NULL),
('Cute Mountains Inn', 277, '2019-08-06', 131, NULL),
('Cute Mountains Inn', 277, '2019-08-07', 336, NULL),
('Cute Mountains Inn', 277, '2019-08-08', 292, NULL),
('Cute Mountains Inn', 277, '2019-08-09', 105, NULL),
('Cute Mountains Inn', 277, '2019-08-10', 282, NULL),
('Cute Mountains Inn', 277, '2019-08-11', 183, NULL),
('Cute Mountains Inn', 277, '2019-08-12', 374, NULL),
('Cute Mountains Inn', 277, '2019-08-13', 169, NULL),
('Cute Mountains Inn', 277, '2019-08-14', 268, NULL),
('Cute Mountains Inn', 277, '2019-08-15', 201, NULL),
('Cute Mountains Inn', 277, '2019-08-16', 253, NULL),
('Cute Mountains Inn', 277, '2019-08-17', 379, NULL),
('Cute Mountains Inn', 277, '2019-08-18', 196, NULL),
('Cute Mountains Inn', 277, '2019-08-19', 180, NULL),
('Cute Mountains Inn', 277, '2019-08-20', 103, NULL),
('Cute Mountains Inn', 277, '2019-08-21', 152, NULL),
('Cute Mountains Inn', 277, '2019-08-22', 116, NULL),
('Cute Mountains Inn', 277, '2019-08-23', 371, NULL),
('Cute Mountains Inn', 277, '2019-08-24', 265, NULL),
('Cute Mountains Inn', 277, '2019-08-25', 354, NULL),
('Cute Mountains Inn', 277, '2019-08-26', 350, NULL),
('Cute Mountains Inn', 277, '2019-08-27', 386, NULL),
('Cute Mountains Inn', 277, '2019-08-28', 179, NULL),
('Cute Mountains Inn', 277, '2019-08-29', 178, NULL),
('Cute Mountains Inn', 277, '2019-08-30', 185, NULL),
('Cute Mountains Inn', 277, '2019-08-31', 329, NULL),
('Cute Mountains Inn', 277, '2019-09-01', 260, NULL),
('Cute Mountains Inn', 277, '2019-09-02', 256, NULL),
('Cute Mountains Inn', 277, '2019-09-03', 323, NULL),
('Cute Mountains Inn', 277, '2019-09-04', 205, NULL),
('Cute Mountains Inn', 277, '2019-09-05', 121, NULL),
('Cute Mountains Inn', 277, '2019-09-06', 336, NULL),
('Cute Mountains Inn', 277, '2019-09-07', 102, NULL),
('Cute Mountains Inn', 277, '2019-09-08', 224, NULL),
('Cute Mountains Inn', 277, '2019-09-09', 305, NULL),
('Cute Mountains Inn', 277, '2019-09-10', 314, NULL),
('Cute Mountains Inn', 277, '2019-09-11', 232, NULL),
('Cute Mountains Inn', 277, '2019-09-12', 165, NULL),
('Cute Mountains Inn', 277, '2019-09-13', 261, NULL),
('Cute Mountains Inn', 277, '2019-09-14', 328, NULL),
('Cute Mountains Inn', 277, '2019-09-15', 253, NULL),
('Cute Mountains Inn', 277, '2019-09-16', 334, NULL),
('Cute Mountains Inn', 277, '2019-09-17', 162, NULL),
('Cute Mountains Inn', 277, '2019-09-18', 128, NULL),
('Cute Mountains Inn', 277, '2019-09-19', 352, NULL),
('Cute Mountains Inn', 277, '2019-09-20', 210, NULL),
('Cute Mountains Inn', 277, '2019-09-21', 276, NULL),
('Cute Mountains Inn', 277, '2019-09-22', 109, NULL),
('Cute Mountains Inn', 277, '2019-09-23', 384, NULL),
('Cute Mountains Inn', 277, '2019-09-24', 318, NULL),
('Cute Mountains Inn', 277, '2019-09-25', 269, NULL),
('Cute Mountains Inn', 277, '2019-09-26', 377, NULL),
('Cute Mountains Inn', 277, '2019-09-27', 277, NULL),
('Cute Mountains Inn', 277, '2019-09-28', 153, NULL),
('Cute Mountains Inn', 277, '2019-09-29', 330, NULL),
('Cute Mountains Inn', 277, '2019-09-30', 231, NULL),
('Cute Mountains Inn', 277, '2019-10-01', 353, NULL),
('Cute Mountains Inn', 277, '2019-10-02', 271, NULL),
('Cute Mountains Inn', 277, '2019-10-03', 347, NULL),
('Cute Mountains Inn', 277, '2019-10-04', 318, NULL),
('Cute Mountains Inn', 277, '2019-10-05', 125, NULL),
('Cute Mountains Inn', 277, '2019-10-06', 166, NULL),
('Cute Mountains Inn', 277, '2019-10-07', 252, NULL),
('Cute Mountains Inn', 277, '2019-10-08', 107, NULL),
('Cute Mountains Inn', 277, '2019-10-09', 268, NULL),
('Cute Mountains Inn', 277, '2019-10-10', 186, NULL),
('Cute Mountains Inn', 277, '2019-10-11', 169, NULL),
('Cute Mountains Inn', 277, '2019-10-12', 143, NULL),
('Cute Mountains Inn', 277, '2019-10-13', 189, NULL),
('Cute Mountains Inn', 277, '2019-10-14', 270, NULL),
('Cute Mountains Inn', 277, '2019-10-15', 269, NULL),
('Cute Mountains Inn', 277, '2019-10-16', 143, NULL),
('Cute Mountains Inn', 277, '2019-10-17', 279, NULL),
('Cute Mountains Inn', 277, '2019-10-18', 151, NULL),
('Cute Mountains Inn', 277, '2019-10-19', 185, NULL),
('Cute Mountains Inn', 277, '2019-10-20', 166, NULL),
('Cute Mountains Inn', 277, '2019-10-21', 285, NULL),
('Cute Mountains Inn', 277, '2019-10-22', 315, NULL),
('Cute Mountains Inn', 277, '2019-10-23', 202, NULL),
('Cute Mountains Inn', 277, '2019-10-24', 178, NULL),
('Cute Mountains Inn', 277, '2019-10-25', 211, NULL),
('Cute Mountains Inn', 277, '2019-10-26', 196, NULL),
('Cute Mountains Inn', 277, '2019-10-27', 110, NULL),
('Cute Mountains Inn', 277, '2019-10-28', 151, NULL),
('Cute Mountains Inn', 277, '2019-10-29', 314, NULL),
('Cute Mountains Inn', 277, '2019-10-30', 125, NULL),
('Cute Mountains Inn', 277, '2019-10-31', 267, NULL),
('Cute Mountains Inn', 277, '2019-11-01', 340, NULL),
('Cute Mountains Inn', 277, '2019-11-02', 190, NULL),
('Cute Mountains Inn', 277, '2019-11-03', 254, NULL),
('Cute Mountains Inn', 277, '2019-11-04', 129, NULL),
('Cute Mountains Inn', 277, '2019-11-05', 337, NULL),
('Cute Mountains Inn', 277, '2019-11-06', 166, NULL),
('Cute Mountains Inn', 277, '2019-11-07', 319, NULL),
('Cute Mountains Inn', 277, '2019-11-08', 105, NULL),
('Cute Mountains Inn', 277, '2019-11-09', 348, NULL),
('Cute Mountains Inn', 277, '2019-11-10', 374, NULL),
('Cute Mountains Inn', 277, '2019-11-11', 325, NULL),
('Cute Mountains Inn', 277, '2019-11-12', 315, NULL),
('Cute Mountains Inn', 277, '2019-11-13', 188, NULL),
('Cute Mountains Inn', 277, '2019-11-14', 232, NULL),
('Cute Mountains Inn', 277, '2019-11-15', 173, NULL),
('Cute Mountains Inn', 277, '2019-11-16', 267, NULL),
('Cute Mountains Inn', 277, '2019-11-17', 306, NULL),
('Cute Mountains Inn', 277, '2019-11-18', 138, NULL),
('Cute Mountains Inn', 277, '2019-11-19', 371, NULL),
('Cute Mountains Inn', 277, '2019-11-20', 290, NULL),
('Cute Mountains Inn', 277, '2019-11-21', 281, NULL),
('Cute Mountains Inn', 277, '2019-11-22', 301, NULL),
('Cute Mountains Inn', 277, '2019-11-23', 264, NULL),
('Cute Mountains Inn', 277, '2019-11-24', 120, NULL),
('Cute Mountains Inn', 277, '2019-11-25', 249, NULL),
('Cute Mountains Inn', 277, '2019-11-26', 138, NULL),
('Cute Mountains Inn', 277, '2019-11-27', 390, NULL),
('Cute Mountains Inn', 277, '2019-11-28', 292, NULL),
('Cute Mountains Inn', 277, '2019-11-29', 285, NULL),
('Cute Mountains Inn', 277, '2019-11-30', 155, NULL),
('Cute Mountains Inn', 277, '2019-12-01', 327, NULL),
('Cute Mountains Inn', 277, '2019-12-02', 332, NULL),
('Cute Mountains Inn', 277, '2019-12-03', 105, NULL),
('Cute Mountains Inn', 277, '2019-12-04', 151, NULL),
('Cute Mountains Inn', 277, '2019-12-05', 105, NULL),
('Cute Mountains Inn', 277, '2019-12-06', 381, NULL),
('Cute Mountains Inn', 277, '2019-12-07', 309, NULL),
('Cute Mountains Inn', 277, '2019-12-08', 224, NULL),
('Cute Mountains Inn', 277, '2019-12-09', 313, NULL),
('Cute Mountains Inn', 277, '2019-12-10', 286, NULL),
('Cute Mountains Inn', 277, '2019-12-11', 360, NULL),
('Cute Mountains Inn', 277, '2019-12-12', 397, NULL),
('Cute Mountains Inn', 277, '2019-12-13', 236, NULL),
('Cute Mountains Inn', 277, '2019-12-14', 384, NULL),
('Cute Mountains Inn', 277, '2019-12-15', 134, NULL),
('Cute Mountains Inn', 277, '2019-12-16', 111, NULL),
('Cute Mountains Inn', 277, '2019-12-17', 273, NULL),
('Cute Mountains Inn', 277, '2019-12-18', 142, NULL),
('Cute Mountains Inn', 277, '2019-12-19', 248, NULL),
('Cute Mountains Inn', 277, '2019-12-20', 333, NULL),
('Cute Mountains Inn', 277, '2019-12-21', 244, NULL),
('Cute Mountains Inn', 277, '2019-12-22', 290, NULL),
('Cute Mountains Inn', 277, '2019-12-23', 362, NULL),
('Cute Mountains Inn', 277, '2019-12-24', 275, NULL),
('Cute Mountains Inn', 277, '2019-12-25', 302, NULL),
('Cute Mountains Inn', 277, '2019-12-26', 329, NULL),
('Cute Mountains Inn', 277, '2019-12-27', 231, NULL),
('Cute Mountains Inn', 277, '2019-12-28', 152, NULL),
('Cute Mountains Inn', 277, '2019-12-29', 173, NULL),
('Cute Mountains Inn', 277, '2019-12-30', 294, NULL),
('Cute Mountains Inn', 277, '2019-12-31', 137, NULL),
('Cute Mountains Inn', 277, '2020-01-01', 109, NULL),
('Cute Mountains Inn', 277, '2020-01-02', 159, NULL),
('Cute Mountains Inn', 277, '2020-01-03', 338, NULL),
('Cute Mountains Inn', 277, '2020-01-04', 248, NULL),
('Cute Mountains Inn', 277, '2020-01-05', 289, NULL),
('Cute Mountains Inn', 277, '2020-01-06', 313, NULL),
('Cute Mountains Inn', 277, '2020-01-07', 339, NULL),
('Cute Mountains Inn', 277, '2020-01-08', 290, NULL),
('Cute Mountains Inn', 277, '2020-01-09', 313, NULL),
('Cute Mountains Inn', 277, '2020-01-10', 228, NULL),
('Cute Mountains Inn', 277, '2020-01-11', 349, NULL),
('Cute Mountains Inn', 277, '2020-01-12', 289, NULL),
('Cute Mountains Inn', 277, '2020-01-13', 128, NULL),
('Cute Mountains Inn', 277, '2020-01-14', 237, NULL),
('Cute Mountains Inn', 277, '2020-01-15', 370, NULL),
('Cute Mountains Inn', 277, '2020-01-16', 389, NULL),
('Cute Mountains Inn', 277, '2020-01-17', 263, NULL),
('Cute Mountains Inn', 277, '2020-01-18', 229, NULL),
('Cute Mountains Inn', 277, '2020-01-19', 274, NULL),
('Cute Mountains Inn', 277, '2020-01-20', 377, NULL),
('Cute Mountains Inn', 277, '2020-01-21', 396, NULL),
('Cute Mountains Inn', 277, '2020-01-22', 140, NULL),
('Cute Mountains Inn', 277, '2020-01-23', 153, NULL),
('Cute Mountains Inn', 277, '2020-01-24', 300, NULL),
('Cute Mountains Inn', 277, '2020-01-25', 230, NULL),
('Cute Mountains Inn', 277, '2020-01-26', 223, NULL),
('Cute Mountains Inn', 277, '2020-01-27', 130, NULL),
('Cute Mountains Inn', 277, '2020-01-28', 238, NULL),
('Cute Mountains Inn', 277, '2020-01-29', 226, NULL),
('Cute Mountains Inn', 277, '2020-01-30', 350, NULL),
('Cute Mountains Inn', 277, '2020-01-31', 272, NULL),
('Cute Mountains Inn', 277, '2020-02-01', 213, NULL),
('Cute Mountains Inn', 277, '2020-02-02', 244, NULL),
('Cute Mountains Inn', 277, '2020-02-03', 100, NULL),
('Cute Mountains Inn', 277, '2020-02-04', 155, NULL),
('Cute Mountains Inn', 280, '2019-01-01', 191, NULL),
('Cute Mountains Inn', 280, '2019-01-02', 205, NULL),
('Cute Mountains Inn', 280, '2019-01-03', 100, NULL),
('Cute Mountains Inn', 280, '2019-01-04', 104, NULL),
('Cute Mountains Inn', 280, '2019-01-05', 361, NULL),
('Cute Mountains Inn', 280, '2019-01-06', 371, NULL),
('Cute Mountains Inn', 280, '2019-01-07', 159, NULL),
('Cute Mountains Inn', 280, '2019-01-08', 283, NULL),
('Cute Mountains Inn', 280, '2019-01-09', 188, NULL),
('Cute Mountains Inn', 280, '2019-01-10', 136, NULL),
('Cute Mountains Inn', 280, '2019-01-11', 133, NULL),
('Cute Mountains Inn', 280, '2019-01-12', 252, NULL),
('Cute Mountains Inn', 280, '2019-01-13', 295, NULL),
('Cute Mountains Inn', 280, '2019-01-14', 324, NULL),
('Cute Mountains Inn', 280, '2019-01-15', 260, NULL),
('Cute Mountains Inn', 280, '2019-01-16', 105, NULL),
('Cute Mountains Inn', 280, '2019-01-17', 307, NULL),
('Cute Mountains Inn', 280, '2019-01-18', 368, NULL),
('Cute Mountains Inn', 280, '2019-01-19', 176, NULL),
('Cute Mountains Inn', 280, '2019-01-20', 318, NULL),
('Cute Mountains Inn', 280, '2019-01-21', 186, NULL),
('Cute Mountains Inn', 280, '2019-01-22', 387, NULL),
('Cute Mountains Inn', 280, '2019-01-23', 350, NULL),
('Cute Mountains Inn', 280, '2019-01-24', 171, NULL),
('Cute Mountains Inn', 280, '2019-01-25', 153, NULL),
('Cute Mountains Inn', 280, '2019-01-26', 210, NULL),
('Cute Mountains Inn', 280, '2019-01-27', 331, NULL),
('Cute Mountains Inn', 280, '2019-01-28', 252, NULL),
('Cute Mountains Inn', 280, '2019-01-29', 112, NULL),
('Cute Mountains Inn', 280, '2019-01-30', 119, NULL),
('Cute Mountains Inn', 280, '2019-01-31', 215, NULL),
('Cute Mountains Inn', 280, '2019-02-01', 149, NULL),
('Cute Mountains Inn', 280, '2019-02-02', 278, NULL),
('Cute Mountains Inn', 280, '2019-02-03', 188, NULL),
('Cute Mountains Inn', 280, '2019-02-04', 278, NULL),
('Cute Mountains Inn', 280, '2019-02-05', 206, NULL),
('Cute Mountains Inn', 280, '2019-02-06', 199, NULL),
('Cute Mountains Inn', 280, '2019-02-07', 135, NULL),
('Cute Mountains Inn', 280, '2019-02-08', 107, NULL),
('Cute Mountains Inn', 280, '2019-02-09', 120, NULL),
('Cute Mountains Inn', 280, '2019-02-10', 280, NULL),
('Cute Mountains Inn', 280, '2019-02-11', 151, NULL),
('Cute Mountains Inn', 280, '2019-02-12', 354, NULL),
('Cute Mountains Inn', 280, '2019-02-13', 337, NULL),
('Cute Mountains Inn', 280, '2019-02-14', 207, NULL),
('Cute Mountains Inn', 280, '2019-02-15', 283, NULL),
('Cute Mountains Inn', 280, '2019-02-16', 289, NULL),
('Cute Mountains Inn', 280, '2019-02-17', 308, NULL),
('Cute Mountains Inn', 280, '2019-02-18', 110, NULL),
('Cute Mountains Inn', 280, '2019-02-19', 220, NULL),
('Cute Mountains Inn', 280, '2019-02-20', 397, NULL),
('Cute Mountains Inn', 280, '2019-02-21', 389, NULL),
('Cute Mountains Inn', 280, '2019-02-22', 176, NULL),
('Cute Mountains Inn', 280, '2019-02-23', 114, NULL),
('Cute Mountains Inn', 280, '2019-02-24', 276, NULL),
('Cute Mountains Inn', 280, '2019-02-25', 365, NULL),
('Cute Mountains Inn', 280, '2019-02-26', 285, NULL),
('Cute Mountains Inn', 280, '2019-02-27', 266, NULL),
('Cute Mountains Inn', 280, '2019-02-28', 373, NULL),
('Cute Mountains Inn', 280, '2019-03-01', 390, NULL),
('Cute Mountains Inn', 280, '2019-03-02', 324, NULL),
('Cute Mountains Inn', 280, '2019-03-03', 103, NULL),
('Cute Mountains Inn', 280, '2019-03-04', 125, NULL),
('Cute Mountains Inn', 280, '2019-03-05', 362, NULL),
('Cute Mountains Inn', 280, '2019-03-06', 155, NULL),
('Cute Mountains Inn', 280, '2019-03-07', 241, NULL),
('Cute Mountains Inn', 280, '2019-03-08', 252, NULL),
('Cute Mountains Inn', 280, '2019-03-09', 141, NULL),
('Cute Mountains Inn', 280, '2019-03-10', 362, NULL),
('Cute Mountains Inn', 280, '2019-03-11', 377, NULL),
('Cute Mountains Inn', 280, '2019-03-12', 334, NULL),
('Cute Mountains Inn', 280, '2019-03-13', 210, NULL),
('Cute Mountains Inn', 280, '2019-03-14', 269, NULL),
('Cute Mountains Inn', 280, '2019-03-15', 259, NULL),
('Cute Mountains Inn', 280, '2019-03-16', 279, NULL),
('Cute Mountains Inn', 280, '2019-03-17', 201, NULL),
('Cute Mountains Inn', 280, '2019-03-18', 231, NULL),
('Cute Mountains Inn', 280, '2019-03-19', 312, NULL),
('Cute Mountains Inn', 280, '2019-03-20', 272, NULL),
('Cute Mountains Inn', 280, '2019-03-21', 265, NULL),
('Cute Mountains Inn', 280, '2019-03-22', 269, NULL),
('Cute Mountains Inn', 280, '2019-03-23', 220, NULL),
('Cute Mountains Inn', 280, '2019-03-24', 329, NULL),
('Cute Mountains Inn', 280, '2019-03-25', 268, NULL),
('Cute Mountains Inn', 280, '2019-03-26', 264, NULL),
('Cute Mountains Inn', 280, '2019-03-27', 378, NULL),
('Cute Mountains Inn', 280, '2019-03-28', 289, NULL),
('Cute Mountains Inn', 280, '2019-03-29', 141, NULL),
('Cute Mountains Inn', 280, '2019-03-30', 110, NULL),
('Cute Mountains Inn', 280, '2019-03-31', 188, NULL),
('Cute Mountains Inn', 280, '2019-04-01', 125, NULL),
('Cute Mountains Inn', 280, '2019-04-02', 295, NULL),
('Cute Mountains Inn', 280, '2019-04-03', 285, NULL),
('Cute Mountains Inn', 280, '2019-04-04', 100, NULL),
('Cute Mountains Inn', 280, '2019-04-05', 103, NULL),
('Cute Mountains Inn', 280, '2019-04-06', 124, NULL),
('Cute Mountains Inn', 280, '2019-04-07', 256, NULL),
('Cute Mountains Inn', 280, '2019-04-08', 105, NULL),
('Cute Mountains Inn', 280, '2019-04-09', 135, NULL),
('Cute Mountains Inn', 280, '2019-04-10', 183, NULL),
('Cute Mountains Inn', 280, '2019-04-11', 193, NULL),
('Cute Mountains Inn', 280, '2019-04-12', 294, NULL),
('Cute Mountains Inn', 280, '2019-04-13', 138, NULL),
('Cute Mountains Inn', 280, '2019-04-14', 136, NULL),
('Cute Mountains Inn', 280, '2019-04-15', 306, NULL),
('Cute Mountains Inn', 280, '2019-04-16', 330, NULL),
('Cute Mountains Inn', 280, '2019-04-17', 124, NULL),
('Cute Mountains Inn', 280, '2019-04-18', 256, NULL),
('Cute Mountains Inn', 280, '2019-04-19', 383, NULL),
('Cute Mountains Inn', 280, '2019-04-20', 371, NULL),
('Cute Mountains Inn', 280, '2019-04-21', 376, NULL),
('Cute Mountains Inn', 280, '2019-04-22', 166, NULL),
('Cute Mountains Inn', 280, '2019-04-23', 100, NULL),
('Cute Mountains Inn', 280, '2019-04-24', 169, NULL),
('Cute Mountains Inn', 280, '2019-04-25', 267, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 280, '2019-04-26', 121, NULL),
('Cute Mountains Inn', 280, '2019-04-27', 158, NULL),
('Cute Mountains Inn', 280, '2019-04-28', 285, NULL),
('Cute Mountains Inn', 280, '2019-04-29', 294, NULL),
('Cute Mountains Inn', 280, '2019-04-30', 353, NULL),
('Cute Mountains Inn', 280, '2019-05-01', 334, NULL),
('Cute Mountains Inn', 280, '2019-05-02', 366, NULL),
('Cute Mountains Inn', 280, '2019-05-03', 173, NULL),
('Cute Mountains Inn', 280, '2019-05-04', 368, NULL),
('Cute Mountains Inn', 280, '2019-05-05', 227, NULL),
('Cute Mountains Inn', 280, '2019-05-06', 133, NULL),
('Cute Mountains Inn', 280, '2019-05-07', 141, NULL),
('Cute Mountains Inn', 280, '2019-05-08', 182, NULL),
('Cute Mountains Inn', 280, '2019-05-09', 115, NULL),
('Cute Mountains Inn', 280, '2019-05-10', 122, NULL),
('Cute Mountains Inn', 280, '2019-05-11', 200, NULL),
('Cute Mountains Inn', 280, '2019-05-12', 373, NULL),
('Cute Mountains Inn', 280, '2019-05-13', 387, NULL),
('Cute Mountains Inn', 280, '2019-05-14', 107, NULL),
('Cute Mountains Inn', 280, '2019-05-15', 191, NULL),
('Cute Mountains Inn', 280, '2019-05-16', 364, NULL),
('Cute Mountains Inn', 280, '2019-05-17', 305, NULL),
('Cute Mountains Inn', 280, '2019-05-18', 325, NULL),
('Cute Mountains Inn', 280, '2019-05-19', 362, NULL),
('Cute Mountains Inn', 280, '2019-05-20', 184, NULL),
('Cute Mountains Inn', 280, '2019-05-21', 399, NULL),
('Cute Mountains Inn', 280, '2019-05-22', 274, NULL),
('Cute Mountains Inn', 280, '2019-05-23', 247, NULL),
('Cute Mountains Inn', 280, '2019-05-24', 336, NULL),
('Cute Mountains Inn', 280, '2019-05-25', 112, NULL),
('Cute Mountains Inn', 280, '2019-05-26', 216, NULL),
('Cute Mountains Inn', 280, '2019-05-27', 244, NULL),
('Cute Mountains Inn', 280, '2019-05-28', 127, NULL),
('Cute Mountains Inn', 280, '2019-05-29', 305, NULL),
('Cute Mountains Inn', 280, '2019-05-30', 343, NULL),
('Cute Mountains Inn', 280, '2019-05-31', 214, NULL),
('Cute Mountains Inn', 280, '2019-06-01', 105, NULL),
('Cute Mountains Inn', 280, '2019-06-02', 170, NULL),
('Cute Mountains Inn', 280, '2019-06-03', 340, NULL),
('Cute Mountains Inn', 280, '2019-06-04', 245, NULL),
('Cute Mountains Inn', 280, '2019-06-05', 120, NULL),
('Cute Mountains Inn', 280, '2019-06-06', 329, NULL),
('Cute Mountains Inn', 280, '2019-06-07', 326, NULL),
('Cute Mountains Inn', 280, '2019-06-08', 182, NULL),
('Cute Mountains Inn', 280, '2019-06-09', 282, NULL),
('Cute Mountains Inn', 280, '2019-06-10', 394, NULL),
('Cute Mountains Inn', 280, '2019-06-11', 182, NULL),
('Cute Mountains Inn', 280, '2019-06-12', 237, NULL),
('Cute Mountains Inn', 280, '2019-06-13', 138, NULL),
('Cute Mountains Inn', 280, '2019-06-14', 345, NULL),
('Cute Mountains Inn', 280, '2019-06-15', 184, NULL),
('Cute Mountains Inn', 280, '2019-06-16', 271, NULL),
('Cute Mountains Inn', 280, '2019-06-17', 395, NULL),
('Cute Mountains Inn', 280, '2019-06-18', 366, NULL),
('Cute Mountains Inn', 280, '2019-06-19', 249, NULL),
('Cute Mountains Inn', 280, '2019-06-20', 366, NULL),
('Cute Mountains Inn', 280, '2019-06-21', 250, NULL),
('Cute Mountains Inn', 280, '2019-06-22', 282, NULL),
('Cute Mountains Inn', 280, '2019-06-23', 193, NULL),
('Cute Mountains Inn', 280, '2019-06-24', 245, NULL),
('Cute Mountains Inn', 280, '2019-06-25', 325, NULL),
('Cute Mountains Inn', 280, '2019-06-26', 190, NULL),
('Cute Mountains Inn', 280, '2019-06-27', 273, NULL),
('Cute Mountains Inn', 280, '2019-06-28', 210, NULL),
('Cute Mountains Inn', 280, '2019-06-29', 127, NULL),
('Cute Mountains Inn', 280, '2019-06-30', 299, NULL),
('Cute Mountains Inn', 280, '2019-07-01', 331, NULL),
('Cute Mountains Inn', 280, '2019-07-02', 358, NULL),
('Cute Mountains Inn', 280, '2019-07-03', 272, NULL),
('Cute Mountains Inn', 280, '2019-07-04', 269, NULL),
('Cute Mountains Inn', 280, '2019-07-05', 243, NULL),
('Cute Mountains Inn', 280, '2019-07-06', 141, NULL),
('Cute Mountains Inn', 280, '2019-07-07', 391, NULL),
('Cute Mountains Inn', 280, '2019-07-08', 306, NULL),
('Cute Mountains Inn', 280, '2019-07-09', 270, NULL),
('Cute Mountains Inn', 280, '2019-07-10', 248, NULL),
('Cute Mountains Inn', 280, '2019-07-11', 106, NULL),
('Cute Mountains Inn', 280, '2019-07-12', 354, NULL),
('Cute Mountains Inn', 280, '2019-07-13', 189, NULL),
('Cute Mountains Inn', 280, '2019-07-14', 297, NULL),
('Cute Mountains Inn', 280, '2019-07-15', 220, NULL),
('Cute Mountains Inn', 280, '2019-07-16', 320, NULL),
('Cute Mountains Inn', 280, '2019-07-17', 201, NULL),
('Cute Mountains Inn', 280, '2019-07-18', 311, NULL),
('Cute Mountains Inn', 280, '2019-07-19', 390, NULL),
('Cute Mountains Inn', 280, '2019-07-20', 256, NULL),
('Cute Mountains Inn', 280, '2019-07-21', 112, NULL),
('Cute Mountains Inn', 280, '2019-07-22', 314, NULL),
('Cute Mountains Inn', 280, '2019-07-23', 336, NULL),
('Cute Mountains Inn', 280, '2019-07-24', 110, NULL),
('Cute Mountains Inn', 280, '2019-07-25', 369, NULL),
('Cute Mountains Inn', 280, '2019-07-26', 368, NULL),
('Cute Mountains Inn', 280, '2019-07-27', 154, NULL),
('Cute Mountains Inn', 280, '2019-07-28', 170, NULL),
('Cute Mountains Inn', 280, '2019-07-29', 134, NULL),
('Cute Mountains Inn', 280, '2019-07-30', 303, NULL),
('Cute Mountains Inn', 280, '2019-07-31', 181, NULL),
('Cute Mountains Inn', 280, '2019-08-01', 369, NULL),
('Cute Mountains Inn', 280, '2019-08-02', 264, NULL),
('Cute Mountains Inn', 280, '2019-08-03', 263, NULL),
('Cute Mountains Inn', 280, '2019-08-04', 372, NULL),
('Cute Mountains Inn', 280, '2019-08-05', 259, NULL),
('Cute Mountains Inn', 280, '2019-08-06', 241, NULL),
('Cute Mountains Inn', 280, '2019-08-07', 206, NULL),
('Cute Mountains Inn', 280, '2019-08-08', 122, NULL),
('Cute Mountains Inn', 280, '2019-08-09', 112, NULL),
('Cute Mountains Inn', 280, '2019-08-10', 106, NULL),
('Cute Mountains Inn', 280, '2019-08-11', 285, NULL),
('Cute Mountains Inn', 280, '2019-08-12', 118, NULL),
('Cute Mountains Inn', 280, '2019-08-13', 235, NULL),
('Cute Mountains Inn', 280, '2019-08-14', 392, NULL),
('Cute Mountains Inn', 280, '2019-08-15', 247, NULL),
('Cute Mountains Inn', 280, '2019-08-16', 372, NULL),
('Cute Mountains Inn', 280, '2019-08-17', 176, NULL),
('Cute Mountains Inn', 280, '2019-08-18', 386, NULL),
('Cute Mountains Inn', 280, '2019-08-19', 321, NULL),
('Cute Mountains Inn', 280, '2019-08-20', 172, NULL),
('Cute Mountains Inn', 280, '2019-08-21', 214, NULL),
('Cute Mountains Inn', 280, '2019-08-22', 340, NULL),
('Cute Mountains Inn', 280, '2019-08-23', 272, NULL),
('Cute Mountains Inn', 280, '2019-08-24', 220, NULL),
('Cute Mountains Inn', 280, '2019-08-25', 280, NULL),
('Cute Mountains Inn', 280, '2019-08-26', 389, NULL),
('Cute Mountains Inn', 280, '2019-08-27', 196, NULL),
('Cute Mountains Inn', 280, '2019-08-28', 177, NULL),
('Cute Mountains Inn', 280, '2019-08-29', 242, NULL),
('Cute Mountains Inn', 280, '2019-08-30', 197, NULL),
('Cute Mountains Inn', 280, '2019-08-31', 217, NULL),
('Cute Mountains Inn', 280, '2019-09-01', 160, NULL),
('Cute Mountains Inn', 280, '2019-09-02', 287, NULL),
('Cute Mountains Inn', 280, '2019-09-03', 178, NULL),
('Cute Mountains Inn', 280, '2019-09-04', 240, NULL),
('Cute Mountains Inn', 280, '2019-09-05', 247, NULL),
('Cute Mountains Inn', 280, '2019-09-06', 306, NULL),
('Cute Mountains Inn', 280, '2019-09-07', 248, NULL),
('Cute Mountains Inn', 280, '2019-09-08', 181, NULL),
('Cute Mountains Inn', 280, '2019-09-09', 233, NULL),
('Cute Mountains Inn', 280, '2019-09-10', 389, NULL),
('Cute Mountains Inn', 280, '2019-09-11', 318, NULL),
('Cute Mountains Inn', 280, '2019-09-12', 215, NULL),
('Cute Mountains Inn', 280, '2019-09-13', 315, NULL),
('Cute Mountains Inn', 280, '2019-09-14', 338, NULL),
('Cute Mountains Inn', 280, '2019-09-15', 262, NULL),
('Cute Mountains Inn', 280, '2019-09-16', 147, NULL),
('Cute Mountains Inn', 280, '2019-09-17', 296, NULL),
('Cute Mountains Inn', 280, '2019-09-18', 379, NULL),
('Cute Mountains Inn', 280, '2019-09-19', 283, NULL),
('Cute Mountains Inn', 280, '2019-09-20', 117, NULL),
('Cute Mountains Inn', 280, '2019-09-21', 295, NULL),
('Cute Mountains Inn', 280, '2019-09-22', 295, NULL),
('Cute Mountains Inn', 280, '2019-09-23', 119, NULL),
('Cute Mountains Inn', 280, '2019-09-24', 121, NULL),
('Cute Mountains Inn', 280, '2019-09-25', 101, NULL),
('Cute Mountains Inn', 280, '2019-09-26', 144, NULL),
('Cute Mountains Inn', 280, '2019-09-27', 155, NULL),
('Cute Mountains Inn', 280, '2019-09-28', 259, NULL),
('Cute Mountains Inn', 280, '2019-09-29', 327, NULL),
('Cute Mountains Inn', 280, '2019-09-30', 252, NULL),
('Cute Mountains Inn', 280, '2019-10-01', 123, NULL),
('Cute Mountains Inn', 280, '2019-10-02', 303, NULL),
('Cute Mountains Inn', 280, '2019-10-03', 358, NULL),
('Cute Mountains Inn', 280, '2019-10-04', 300, NULL),
('Cute Mountains Inn', 280, '2019-10-05', 149, NULL),
('Cute Mountains Inn', 280, '2019-10-06', 245, NULL),
('Cute Mountains Inn', 280, '2019-10-07', 177, NULL),
('Cute Mountains Inn', 280, '2019-10-08', 139, NULL),
('Cute Mountains Inn', 280, '2019-10-09', 360, NULL),
('Cute Mountains Inn', 280, '2019-10-10', 139, NULL),
('Cute Mountains Inn', 280, '2019-10-11', 285, NULL),
('Cute Mountains Inn', 280, '2019-10-12', 378, NULL),
('Cute Mountains Inn', 280, '2019-10-13', 219, NULL),
('Cute Mountains Inn', 280, '2019-10-14', 329, NULL),
('Cute Mountains Inn', 280, '2019-10-15', 249, NULL),
('Cute Mountains Inn', 280, '2019-10-16', 370, NULL),
('Cute Mountains Inn', 280, '2019-10-17', 103, NULL),
('Cute Mountains Inn', 280, '2019-10-18', 114, NULL),
('Cute Mountains Inn', 280, '2019-10-19', 325, NULL),
('Cute Mountains Inn', 280, '2019-10-20', 114, NULL),
('Cute Mountains Inn', 280, '2019-10-21', 397, NULL),
('Cute Mountains Inn', 280, '2019-10-22', 226, NULL),
('Cute Mountains Inn', 280, '2019-10-23', 195, NULL),
('Cute Mountains Inn', 280, '2019-10-24', 162, NULL),
('Cute Mountains Inn', 280, '2019-10-25', 202, NULL),
('Cute Mountains Inn', 280, '2019-10-26', 315, NULL),
('Cute Mountains Inn', 280, '2019-10-27', 191, NULL),
('Cute Mountains Inn', 280, '2019-10-28', 182, NULL),
('Cute Mountains Inn', 280, '2019-10-29', 172, NULL),
('Cute Mountains Inn', 280, '2019-10-30', 270, NULL),
('Cute Mountains Inn', 280, '2019-10-31', 337, NULL),
('Cute Mountains Inn', 280, '2019-11-01', 202, NULL),
('Cute Mountains Inn', 280, '2019-11-02', 382, NULL),
('Cute Mountains Inn', 280, '2019-11-03', 211, NULL),
('Cute Mountains Inn', 280, '2019-11-04', 359, NULL),
('Cute Mountains Inn', 280, '2019-11-05', 260, NULL),
('Cute Mountains Inn', 280, '2019-11-06', 331, NULL),
('Cute Mountains Inn', 280, '2019-11-07', 259, NULL),
('Cute Mountains Inn', 280, '2019-11-08', 385, NULL),
('Cute Mountains Inn', 280, '2019-11-09', 282, NULL),
('Cute Mountains Inn', 280, '2019-11-10', 208, NULL),
('Cute Mountains Inn', 280, '2019-11-11', 154, NULL),
('Cute Mountains Inn', 280, '2019-11-12', 172, NULL),
('Cute Mountains Inn', 280, '2019-11-13', 235, NULL),
('Cute Mountains Inn', 280, '2019-11-14', 151, NULL),
('Cute Mountains Inn', 280, '2019-11-15', 372, NULL),
('Cute Mountains Inn', 280, '2019-11-16', 176, NULL),
('Cute Mountains Inn', 280, '2019-11-17', 240, NULL),
('Cute Mountains Inn', 280, '2019-11-18', 210, NULL),
('Cute Mountains Inn', 280, '2019-11-19', 175, NULL),
('Cute Mountains Inn', 280, '2019-11-20', 148, NULL),
('Cute Mountains Inn', 280, '2019-11-21', 101, NULL),
('Cute Mountains Inn', 280, '2019-11-22', 310, NULL),
('Cute Mountains Inn', 280, '2019-11-23', 125, NULL),
('Cute Mountains Inn', 280, '2019-11-24', 336, NULL),
('Cute Mountains Inn', 280, '2019-11-25', 343, NULL),
('Cute Mountains Inn', 280, '2019-11-26', 393, NULL),
('Cute Mountains Inn', 280, '2019-11-27', 364, NULL),
('Cute Mountains Inn', 280, '2019-11-28', 248, NULL),
('Cute Mountains Inn', 280, '2019-11-29', 379, NULL),
('Cute Mountains Inn', 280, '2019-11-30', 219, NULL),
('Cute Mountains Inn', 280, '2019-12-01', 116, NULL),
('Cute Mountains Inn', 280, '2019-12-02', 273, NULL),
('Cute Mountains Inn', 280, '2019-12-03', 337, NULL),
('Cute Mountains Inn', 280, '2019-12-04', 194, NULL),
('Cute Mountains Inn', 280, '2019-12-05', 153, NULL),
('Cute Mountains Inn', 280, '2019-12-06', 234, NULL),
('Cute Mountains Inn', 280, '2019-12-07', 359, NULL),
('Cute Mountains Inn', 280, '2019-12-08', 385, NULL),
('Cute Mountains Inn', 280, '2019-12-09', 382, NULL),
('Cute Mountains Inn', 280, '2019-12-10', 353, NULL),
('Cute Mountains Inn', 280, '2019-12-11', 249, NULL),
('Cute Mountains Inn', 280, '2019-12-12', 151, NULL),
('Cute Mountains Inn', 280, '2019-12-13', 349, NULL),
('Cute Mountains Inn', 280, '2019-12-14', 176, NULL),
('Cute Mountains Inn', 280, '2019-12-15', 218, NULL),
('Cute Mountains Inn', 280, '2019-12-16', 207, NULL),
('Cute Mountains Inn', 280, '2019-12-17', 133, NULL),
('Cute Mountains Inn', 280, '2019-12-18', 351, NULL),
('Cute Mountains Inn', 280, '2019-12-19', 393, NULL),
('Cute Mountains Inn', 280, '2019-12-20', 280, NULL),
('Cute Mountains Inn', 280, '2019-12-21', 184, NULL),
('Cute Mountains Inn', 280, '2019-12-22', 163, NULL),
('Cute Mountains Inn', 280, '2019-12-23', 275, NULL),
('Cute Mountains Inn', 280, '2019-12-24', 302, NULL),
('Cute Mountains Inn', 280, '2019-12-25', 292, NULL),
('Cute Mountains Inn', 280, '2019-12-26', 333, NULL),
('Cute Mountains Inn', 280, '2019-12-27', 384, NULL),
('Cute Mountains Inn', 280, '2019-12-28', 202, NULL),
('Cute Mountains Inn', 280, '2019-12-29', 313, NULL),
('Cute Mountains Inn', 280, '2019-12-30', 380, NULL),
('Cute Mountains Inn', 280, '2019-12-31', 307, NULL),
('Cute Mountains Inn', 280, '2020-01-01', 266, NULL),
('Cute Mountains Inn', 280, '2020-01-02', 383, NULL),
('Cute Mountains Inn', 280, '2020-01-03', 231, NULL),
('Cute Mountains Inn', 280, '2020-01-04', 121, NULL),
('Cute Mountains Inn', 280, '2020-01-05', 266, NULL),
('Cute Mountains Inn', 280, '2020-01-06', 115, NULL),
('Cute Mountains Inn', 280, '2020-01-07', 183, NULL),
('Cute Mountains Inn', 280, '2020-01-08', 168, NULL),
('Cute Mountains Inn', 280, '2020-01-09', 174, NULL),
('Cute Mountains Inn', 280, '2020-01-10', 175, NULL),
('Cute Mountains Inn', 280, '2020-01-11', 389, NULL),
('Cute Mountains Inn', 280, '2020-01-12', 101, NULL),
('Cute Mountains Inn', 280, '2020-01-13', 182, NULL),
('Cute Mountains Inn', 280, '2020-01-14', 185, NULL),
('Cute Mountains Inn', 280, '2020-01-15', 193, NULL),
('Cute Mountains Inn', 280, '2020-01-16', 158, NULL),
('Cute Mountains Inn', 280, '2020-01-17', 263, NULL),
('Cute Mountains Inn', 280, '2020-01-18', 273, NULL),
('Cute Mountains Inn', 280, '2020-01-19', 381, NULL),
('Cute Mountains Inn', 280, '2020-01-20', 302, NULL),
('Cute Mountains Inn', 280, '2020-01-21', 102, NULL),
('Cute Mountains Inn', 280, '2020-01-22', 227, NULL),
('Cute Mountains Inn', 280, '2020-01-23', 296, NULL),
('Cute Mountains Inn', 280, '2020-01-24', 385, NULL),
('Cute Mountains Inn', 280, '2020-01-25', 229, NULL),
('Cute Mountains Inn', 280, '2020-01-26', 342, NULL),
('Cute Mountains Inn', 280, '2020-01-27', 386, NULL),
('Cute Mountains Inn', 280, '2020-01-28', 361, NULL),
('Cute Mountains Inn', 280, '2020-01-29', 243, NULL),
('Cute Mountains Inn', 280, '2020-01-30', 346, NULL),
('Cute Mountains Inn', 280, '2020-01-31', 219, NULL),
('Cute Mountains Inn', 280, '2020-02-01', 319, NULL),
('Cute Mountains Inn', 280, '2020-02-02', 357, NULL),
('Cute Mountains Inn', 280, '2020-02-03', 305, NULL),
('Cute Mountains Inn', 280, '2020-02-04', 117, NULL),
('Cute Mountains Inn', 281, '2019-01-01', 263, NULL),
('Cute Mountains Inn', 281, '2019-01-02', 334, NULL),
('Cute Mountains Inn', 281, '2019-01-03', 389, NULL),
('Cute Mountains Inn', 281, '2019-01-04', 399, NULL),
('Cute Mountains Inn', 281, '2019-01-05', 305, NULL),
('Cute Mountains Inn', 281, '2019-01-06', 218, NULL),
('Cute Mountains Inn', 281, '2019-01-07', 168, NULL),
('Cute Mountains Inn', 281, '2019-01-08', 113, NULL),
('Cute Mountains Inn', 281, '2019-01-09', 156, NULL),
('Cute Mountains Inn', 281, '2019-01-10', 238, NULL),
('Cute Mountains Inn', 281, '2019-01-11', 382, NULL),
('Cute Mountains Inn', 281, '2019-01-12', 258, NULL),
('Cute Mountains Inn', 281, '2019-01-13', 346, NULL),
('Cute Mountains Inn', 281, '2019-01-14', 359, NULL),
('Cute Mountains Inn', 281, '2019-01-15', 104, NULL),
('Cute Mountains Inn', 281, '2019-01-16', 154, NULL),
('Cute Mountains Inn', 281, '2019-01-17', 101, NULL),
('Cute Mountains Inn', 281, '2019-01-18', 281, NULL),
('Cute Mountains Inn', 281, '2019-01-19', 262, NULL),
('Cute Mountains Inn', 281, '2019-01-20', 206, NULL),
('Cute Mountains Inn', 281, '2019-01-21', 151, NULL),
('Cute Mountains Inn', 281, '2019-01-22', 350, NULL),
('Cute Mountains Inn', 281, '2019-01-23', 124, NULL),
('Cute Mountains Inn', 281, '2019-01-24', 110, NULL),
('Cute Mountains Inn', 281, '2019-01-25', 245, NULL),
('Cute Mountains Inn', 281, '2019-01-26', 316, NULL),
('Cute Mountains Inn', 281, '2019-01-27', 136, NULL),
('Cute Mountains Inn', 281, '2019-01-28', 187, NULL),
('Cute Mountains Inn', 281, '2019-01-29', 109, NULL),
('Cute Mountains Inn', 281, '2019-01-30', 233, NULL),
('Cute Mountains Inn', 281, '2019-01-31', 302, NULL),
('Cute Mountains Inn', 281, '2019-02-01', 379, NULL),
('Cute Mountains Inn', 281, '2019-02-02', 247, NULL),
('Cute Mountains Inn', 281, '2019-02-03', 160, NULL),
('Cute Mountains Inn', 281, '2019-02-04', 302, NULL),
('Cute Mountains Inn', 281, '2019-02-05', 387, NULL),
('Cute Mountains Inn', 281, '2019-02-06', 159, NULL),
('Cute Mountains Inn', 281, '2019-02-07', 153, NULL),
('Cute Mountains Inn', 281, '2019-02-08', 130, NULL),
('Cute Mountains Inn', 281, '2019-02-09', 106, NULL),
('Cute Mountains Inn', 281, '2019-02-10', 255, NULL),
('Cute Mountains Inn', 281, '2019-02-11', 364, NULL),
('Cute Mountains Inn', 281, '2019-02-12', 295, NULL),
('Cute Mountains Inn', 281, '2019-02-13', 117, NULL),
('Cute Mountains Inn', 281, '2019-02-14', 206, NULL),
('Cute Mountains Inn', 281, '2019-02-15', 228, NULL),
('Cute Mountains Inn', 281, '2019-02-16', 301, NULL),
('Cute Mountains Inn', 281, '2019-02-17', 192, NULL),
('Cute Mountains Inn', 281, '2019-02-18', 175, NULL),
('Cute Mountains Inn', 281, '2019-02-19', 311, NULL),
('Cute Mountains Inn', 281, '2019-02-20', 362, NULL),
('Cute Mountains Inn', 281, '2019-02-21', 393, NULL),
('Cute Mountains Inn', 281, '2019-02-22', 197, NULL),
('Cute Mountains Inn', 281, '2019-02-23', 372, NULL),
('Cute Mountains Inn', 281, '2019-02-24', 241, NULL),
('Cute Mountains Inn', 281, '2019-02-25', 135, NULL),
('Cute Mountains Inn', 281, '2019-02-26', 157, NULL),
('Cute Mountains Inn', 281, '2019-02-27', 107, NULL),
('Cute Mountains Inn', 281, '2019-02-28', 280, NULL),
('Cute Mountains Inn', 281, '2019-03-01', 128, NULL),
('Cute Mountains Inn', 281, '2019-03-02', 345, NULL),
('Cute Mountains Inn', 281, '2019-03-03', 265, NULL),
('Cute Mountains Inn', 281, '2019-03-04', 167, NULL),
('Cute Mountains Inn', 281, '2019-03-05', 228, NULL),
('Cute Mountains Inn', 281, '2019-03-06', 302, NULL),
('Cute Mountains Inn', 281, '2019-03-07', 169, NULL),
('Cute Mountains Inn', 281, '2019-03-08', 154, NULL),
('Cute Mountains Inn', 281, '2019-03-09', 147, NULL),
('Cute Mountains Inn', 281, '2019-03-10', 327, NULL),
('Cute Mountains Inn', 281, '2019-03-11', 329, NULL),
('Cute Mountains Inn', 281, '2019-03-12', 177, NULL),
('Cute Mountains Inn', 281, '2019-03-13', 374, NULL),
('Cute Mountains Inn', 281, '2019-03-14', 359, NULL),
('Cute Mountains Inn', 281, '2019-03-15', 116, NULL),
('Cute Mountains Inn', 281, '2019-03-16', 171, NULL),
('Cute Mountains Inn', 281, '2019-03-17', 207, NULL),
('Cute Mountains Inn', 281, '2019-03-18', 187, NULL),
('Cute Mountains Inn', 281, '2019-03-19', 231, NULL),
('Cute Mountains Inn', 281, '2019-03-20', 148, NULL),
('Cute Mountains Inn', 281, '2019-03-21', 266, NULL),
('Cute Mountains Inn', 281, '2019-03-22', 389, NULL),
('Cute Mountains Inn', 281, '2019-03-23', 107, NULL),
('Cute Mountains Inn', 281, '2019-03-24', 387, NULL),
('Cute Mountains Inn', 281, '2019-03-25', 356, NULL),
('Cute Mountains Inn', 281, '2019-03-26', 130, NULL),
('Cute Mountains Inn', 281, '2019-03-27', 336, NULL),
('Cute Mountains Inn', 281, '2019-03-28', 347, NULL),
('Cute Mountains Inn', 281, '2019-03-29', 191, NULL),
('Cute Mountains Inn', 281, '2019-03-30', 233, NULL),
('Cute Mountains Inn', 281, '2019-03-31', 103, NULL),
('Cute Mountains Inn', 281, '2019-04-01', 105, NULL),
('Cute Mountains Inn', 281, '2019-04-02', 232, NULL),
('Cute Mountains Inn', 281, '2019-04-03', 103, NULL),
('Cute Mountains Inn', 281, '2019-04-04', 314, NULL),
('Cute Mountains Inn', 281, '2019-04-05', 129, NULL),
('Cute Mountains Inn', 281, '2019-04-06', 294, NULL),
('Cute Mountains Inn', 281, '2019-04-07', 323, NULL),
('Cute Mountains Inn', 281, '2019-04-08', 287, NULL),
('Cute Mountains Inn', 281, '2019-04-09', 274, NULL),
('Cute Mountains Inn', 281, '2019-04-10', 112, NULL),
('Cute Mountains Inn', 281, '2019-04-11', 390, NULL),
('Cute Mountains Inn', 281, '2019-04-12', 180, NULL),
('Cute Mountains Inn', 281, '2019-04-13', 100, NULL),
('Cute Mountains Inn', 281, '2019-04-14', 200, NULL),
('Cute Mountains Inn', 281, '2019-04-15', 249, NULL),
('Cute Mountains Inn', 281, '2019-04-16', 118, NULL),
('Cute Mountains Inn', 281, '2019-04-17', 106, NULL),
('Cute Mountains Inn', 281, '2019-04-18', 144, NULL),
('Cute Mountains Inn', 281, '2019-04-19', 324, NULL),
('Cute Mountains Inn', 281, '2019-04-20', 245, NULL),
('Cute Mountains Inn', 281, '2019-04-21', 378, NULL),
('Cute Mountains Inn', 281, '2019-04-22', 399, NULL),
('Cute Mountains Inn', 281, '2019-04-23', 341, NULL),
('Cute Mountains Inn', 281, '2019-04-24', 340, NULL),
('Cute Mountains Inn', 281, '2019-04-25', 115, NULL),
('Cute Mountains Inn', 281, '2019-04-26', 282, NULL),
('Cute Mountains Inn', 281, '2019-04-27', 165, NULL),
('Cute Mountains Inn', 281, '2019-04-28', 365, NULL),
('Cute Mountains Inn', 281, '2019-04-29', 203, NULL),
('Cute Mountains Inn', 281, '2019-04-30', 107, NULL),
('Cute Mountains Inn', 281, '2019-05-01', 392, NULL),
('Cute Mountains Inn', 281, '2019-05-02', 165, NULL),
('Cute Mountains Inn', 281, '2019-05-03', 112, NULL),
('Cute Mountains Inn', 281, '2019-05-04', 368, NULL),
('Cute Mountains Inn', 281, '2019-05-05', 366, NULL),
('Cute Mountains Inn', 281, '2019-05-06', 202, NULL),
('Cute Mountains Inn', 281, '2019-05-07', 379, NULL),
('Cute Mountains Inn', 281, '2019-05-08', 112, NULL),
('Cute Mountains Inn', 281, '2019-05-09', 154, NULL),
('Cute Mountains Inn', 281, '2019-05-10', 205, NULL),
('Cute Mountains Inn', 281, '2019-05-11', 104, NULL),
('Cute Mountains Inn', 281, '2019-05-12', 150, NULL),
('Cute Mountains Inn', 281, '2019-05-13', 135, NULL),
('Cute Mountains Inn', 281, '2019-05-14', 368, NULL),
('Cute Mountains Inn', 281, '2019-05-15', 218, NULL),
('Cute Mountains Inn', 281, '2019-05-16', 201, NULL),
('Cute Mountains Inn', 281, '2019-05-17', 351, NULL),
('Cute Mountains Inn', 281, '2019-05-18', 265, NULL),
('Cute Mountains Inn', 281, '2019-05-19', 396, NULL),
('Cute Mountains Inn', 281, '2019-05-20', 291, NULL),
('Cute Mountains Inn', 281, '2019-05-21', 279, NULL),
('Cute Mountains Inn', 281, '2019-05-22', 368, NULL),
('Cute Mountains Inn', 281, '2019-05-23', 199, NULL),
('Cute Mountains Inn', 281, '2019-05-24', 255, NULL),
('Cute Mountains Inn', 281, '2019-05-25', 372, NULL),
('Cute Mountains Inn', 281, '2019-05-26', 280, NULL),
('Cute Mountains Inn', 281, '2019-05-27', 133, NULL),
('Cute Mountains Inn', 281, '2019-05-28', 305, NULL),
('Cute Mountains Inn', 281, '2019-05-29', 348, NULL),
('Cute Mountains Inn', 281, '2019-05-30', 194, NULL),
('Cute Mountains Inn', 281, '2019-05-31', 399, NULL),
('Cute Mountains Inn', 281, '2019-06-01', 235, NULL),
('Cute Mountains Inn', 281, '2019-06-02', 296, NULL),
('Cute Mountains Inn', 281, '2019-06-03', 126, NULL),
('Cute Mountains Inn', 281, '2019-06-04', 302, NULL),
('Cute Mountains Inn', 281, '2019-06-05', 265, NULL),
('Cute Mountains Inn', 281, '2019-06-06', 258, NULL),
('Cute Mountains Inn', 281, '2019-06-07', 106, NULL),
('Cute Mountains Inn', 281, '2019-06-08', 209, NULL),
('Cute Mountains Inn', 281, '2019-06-09', 376, NULL),
('Cute Mountains Inn', 281, '2019-06-10', 183, NULL),
('Cute Mountains Inn', 281, '2019-06-11', 126, NULL),
('Cute Mountains Inn', 281, '2019-06-12', 319, NULL),
('Cute Mountains Inn', 281, '2019-06-13', 173, NULL),
('Cute Mountains Inn', 281, '2019-06-14', 239, NULL),
('Cute Mountains Inn', 281, '2019-06-15', 368, NULL),
('Cute Mountains Inn', 281, '2019-06-16', 195, NULL),
('Cute Mountains Inn', 281, '2019-06-17', 292, NULL),
('Cute Mountains Inn', 281, '2019-06-18', 387, NULL),
('Cute Mountains Inn', 281, '2019-06-19', 214, NULL),
('Cute Mountains Inn', 281, '2019-06-20', 279, NULL),
('Cute Mountains Inn', 281, '2019-06-21', 358, NULL),
('Cute Mountains Inn', 281, '2019-06-22', 180, NULL),
('Cute Mountains Inn', 281, '2019-06-23', 291, NULL),
('Cute Mountains Inn', 281, '2019-06-24', 374, NULL),
('Cute Mountains Inn', 281, '2019-06-25', 296, NULL),
('Cute Mountains Inn', 281, '2019-06-26', 282, NULL),
('Cute Mountains Inn', 281, '2019-06-27', 155, NULL),
('Cute Mountains Inn', 281, '2019-06-28', 208, NULL),
('Cute Mountains Inn', 281, '2019-06-29', 276, NULL),
('Cute Mountains Inn', 281, '2019-06-30', 367, NULL),
('Cute Mountains Inn', 281, '2019-07-01', 380, NULL),
('Cute Mountains Inn', 281, '2019-07-02', 336, NULL),
('Cute Mountains Inn', 281, '2019-07-03', 194, NULL),
('Cute Mountains Inn', 281, '2019-07-04', 278, NULL),
('Cute Mountains Inn', 281, '2019-07-05', 145, NULL),
('Cute Mountains Inn', 281, '2019-07-06', 326, NULL),
('Cute Mountains Inn', 281, '2019-07-07', 351, NULL),
('Cute Mountains Inn', 281, '2019-07-08', 302, NULL),
('Cute Mountains Inn', 281, '2019-07-09', 198, NULL),
('Cute Mountains Inn', 281, '2019-07-10', 321, NULL),
('Cute Mountains Inn', 281, '2019-07-11', 299, NULL),
('Cute Mountains Inn', 281, '2019-07-12', 367, NULL),
('Cute Mountains Inn', 281, '2019-07-13', 148, NULL),
('Cute Mountains Inn', 281, '2019-07-14', 244, NULL),
('Cute Mountains Inn', 281, '2019-07-15', 345, NULL),
('Cute Mountains Inn', 281, '2019-07-16', 232, NULL),
('Cute Mountains Inn', 281, '2019-07-17', 334, NULL),
('Cute Mountains Inn', 281, '2019-07-18', 365, NULL),
('Cute Mountains Inn', 281, '2019-07-19', 390, NULL),
('Cute Mountains Inn', 281, '2019-07-20', 326, NULL),
('Cute Mountains Inn', 281, '2019-07-21', 360, NULL),
('Cute Mountains Inn', 281, '2019-07-22', 204, NULL),
('Cute Mountains Inn', 281, '2019-07-23', 243, NULL),
('Cute Mountains Inn', 281, '2019-07-24', 125, NULL),
('Cute Mountains Inn', 281, '2019-07-25', 126, NULL),
('Cute Mountains Inn', 281, '2019-07-26', 161, NULL),
('Cute Mountains Inn', 281, '2019-07-27', 117, NULL),
('Cute Mountains Inn', 281, '2019-07-28', 357, NULL),
('Cute Mountains Inn', 281, '2019-07-29', 310, NULL),
('Cute Mountains Inn', 281, '2019-07-30', 322, NULL),
('Cute Mountains Inn', 281, '2019-07-31', 273, NULL),
('Cute Mountains Inn', 281, '2019-08-01', 382, NULL),
('Cute Mountains Inn', 281, '2019-08-02', 189, NULL),
('Cute Mountains Inn', 281, '2019-08-03', 220, NULL),
('Cute Mountains Inn', 281, '2019-08-04', 382, NULL),
('Cute Mountains Inn', 281, '2019-08-05', 256, NULL),
('Cute Mountains Inn', 281, '2019-08-06', 112, NULL),
('Cute Mountains Inn', 281, '2019-08-07', 221, NULL),
('Cute Mountains Inn', 281, '2019-08-08', 233, NULL),
('Cute Mountains Inn', 281, '2019-08-09', 148, NULL),
('Cute Mountains Inn', 281, '2019-08-10', 182, NULL),
('Cute Mountains Inn', 281, '2019-08-11', 173, NULL),
('Cute Mountains Inn', 281, '2019-08-12', 267, NULL),
('Cute Mountains Inn', 281, '2019-08-13', 266, NULL),
('Cute Mountains Inn', 281, '2019-08-14', 157, NULL),
('Cute Mountains Inn', 281, '2019-08-15', 230, NULL),
('Cute Mountains Inn', 281, '2019-08-16', 101, NULL),
('Cute Mountains Inn', 281, '2019-08-17', 241, NULL),
('Cute Mountains Inn', 281, '2019-08-18', 341, NULL),
('Cute Mountains Inn', 281, '2019-08-19', 364, NULL),
('Cute Mountains Inn', 281, '2019-08-20', 151, NULL),
('Cute Mountains Inn', 281, '2019-08-21', 217, NULL),
('Cute Mountains Inn', 281, '2019-08-22', 355, NULL),
('Cute Mountains Inn', 281, '2019-08-23', 150, NULL),
('Cute Mountains Inn', 281, '2019-08-24', 208, NULL),
('Cute Mountains Inn', 281, '2019-08-25', 239, NULL),
('Cute Mountains Inn', 281, '2019-08-26', 195, NULL),
('Cute Mountains Inn', 281, '2019-08-27', 321, NULL),
('Cute Mountains Inn', 281, '2019-08-28', 249, NULL),
('Cute Mountains Inn', 281, '2019-08-29', 279, NULL),
('Cute Mountains Inn', 281, '2019-08-30', 330, NULL),
('Cute Mountains Inn', 281, '2019-08-31', 299, NULL),
('Cute Mountains Inn', 281, '2019-09-01', 222, NULL),
('Cute Mountains Inn', 281, '2019-09-02', 270, NULL),
('Cute Mountains Inn', 281, '2019-09-03', 122, NULL),
('Cute Mountains Inn', 281, '2019-09-04', 185, NULL),
('Cute Mountains Inn', 281, '2019-09-05', 171, NULL),
('Cute Mountains Inn', 281, '2019-09-06', 123, NULL),
('Cute Mountains Inn', 281, '2019-09-07', 235, NULL),
('Cute Mountains Inn', 281, '2019-09-08', 135, NULL),
('Cute Mountains Inn', 281, '2019-09-09', 151, NULL),
('Cute Mountains Inn', 281, '2019-09-10', 303, NULL),
('Cute Mountains Inn', 281, '2019-09-11', 193, NULL),
('Cute Mountains Inn', 281, '2019-09-12', 181, NULL),
('Cute Mountains Inn', 281, '2019-09-13', 391, NULL),
('Cute Mountains Inn', 281, '2019-09-14', 305, NULL),
('Cute Mountains Inn', 281, '2019-09-15', 152, NULL),
('Cute Mountains Inn', 281, '2019-09-16', 234, NULL),
('Cute Mountains Inn', 281, '2019-09-17', 295, NULL),
('Cute Mountains Inn', 281, '2019-09-18', 212, NULL),
('Cute Mountains Inn', 281, '2019-09-19', 260, NULL),
('Cute Mountains Inn', 281, '2019-09-20', 157, NULL),
('Cute Mountains Inn', 281, '2019-09-21', 247, NULL),
('Cute Mountains Inn', 281, '2019-09-22', 146, NULL),
('Cute Mountains Inn', 281, '2019-09-23', 246, NULL),
('Cute Mountains Inn', 281, '2019-09-24', 153, NULL),
('Cute Mountains Inn', 281, '2019-09-25', 200, NULL),
('Cute Mountains Inn', 281, '2019-09-26', 388, NULL),
('Cute Mountains Inn', 281, '2019-09-27', 142, NULL),
('Cute Mountains Inn', 281, '2019-09-28', 135, NULL),
('Cute Mountains Inn', 281, '2019-09-29', 247, NULL),
('Cute Mountains Inn', 281, '2019-09-30', 168, NULL),
('Cute Mountains Inn', 281, '2019-10-01', 358, NULL),
('Cute Mountains Inn', 281, '2019-10-02', 304, NULL),
('Cute Mountains Inn', 281, '2019-10-03', 353, NULL),
('Cute Mountains Inn', 281, '2019-10-04', 146, NULL),
('Cute Mountains Inn', 281, '2019-10-05', 271, NULL),
('Cute Mountains Inn', 281, '2019-10-06', 329, NULL),
('Cute Mountains Inn', 281, '2019-10-07', 329, NULL),
('Cute Mountains Inn', 281, '2019-10-08', 277, NULL),
('Cute Mountains Inn', 281, '2019-10-09', 297, NULL),
('Cute Mountains Inn', 281, '2019-10-10', 338, NULL),
('Cute Mountains Inn', 281, '2019-10-11', 216, NULL),
('Cute Mountains Inn', 281, '2019-10-12', 163, NULL),
('Cute Mountains Inn', 281, '2019-10-13', 125, NULL),
('Cute Mountains Inn', 281, '2019-10-14', 133, NULL),
('Cute Mountains Inn', 281, '2019-10-15', 337, NULL),
('Cute Mountains Inn', 281, '2019-10-16', 124, NULL),
('Cute Mountains Inn', 281, '2019-10-17', 179, NULL),
('Cute Mountains Inn', 281, '2019-10-18', 315, NULL),
('Cute Mountains Inn', 281, '2019-10-19', 370, NULL),
('Cute Mountains Inn', 281, '2019-10-20', 273, NULL),
('Cute Mountains Inn', 281, '2019-10-21', 128, NULL),
('Cute Mountains Inn', 281, '2019-10-22', 387, NULL),
('Cute Mountains Inn', 281, '2019-10-23', 267, NULL),
('Cute Mountains Inn', 281, '2019-10-24', 175, NULL),
('Cute Mountains Inn', 281, '2019-10-25', 278, NULL),
('Cute Mountains Inn', 281, '2019-10-26', 286, NULL),
('Cute Mountains Inn', 281, '2019-10-27', 225, NULL),
('Cute Mountains Inn', 281, '2019-10-28', 356, NULL),
('Cute Mountains Inn', 281, '2019-10-29', 118, NULL),
('Cute Mountains Inn', 281, '2019-10-30', 276, NULL),
('Cute Mountains Inn', 281, '2019-10-31', 186, NULL),
('Cute Mountains Inn', 281, '2019-11-01', 191, NULL),
('Cute Mountains Inn', 281, '2019-11-02', 339, NULL),
('Cute Mountains Inn', 281, '2019-11-03', 194, NULL),
('Cute Mountains Inn', 281, '2019-11-04', 107, NULL),
('Cute Mountains Inn', 281, '2019-11-05', 190, NULL),
('Cute Mountains Inn', 281, '2019-11-06', 159, NULL),
('Cute Mountains Inn', 281, '2019-11-07', 241, NULL),
('Cute Mountains Inn', 281, '2019-11-08', 314, NULL),
('Cute Mountains Inn', 281, '2019-11-09', 270, NULL),
('Cute Mountains Inn', 281, '2019-11-10', 118, NULL),
('Cute Mountains Inn', 281, '2019-11-11', 292, NULL),
('Cute Mountains Inn', 281, '2019-11-12', 115, NULL),
('Cute Mountains Inn', 281, '2019-11-13', 211, NULL),
('Cute Mountains Inn', 281, '2019-11-14', 260, NULL),
('Cute Mountains Inn', 281, '2019-11-15', 343, NULL),
('Cute Mountains Inn', 281, '2019-11-16', 282, NULL),
('Cute Mountains Inn', 281, '2019-11-17', 179, NULL),
('Cute Mountains Inn', 281, '2019-11-18', 237, NULL),
('Cute Mountains Inn', 281, '2019-11-19', 264, NULL),
('Cute Mountains Inn', 281, '2019-11-20', 372, NULL),
('Cute Mountains Inn', 281, '2019-11-21', 163, NULL),
('Cute Mountains Inn', 281, '2019-11-22', 251, NULL),
('Cute Mountains Inn', 281, '2019-11-23', 331, NULL),
('Cute Mountains Inn', 281, '2019-11-24', 317, NULL),
('Cute Mountains Inn', 281, '2019-11-25', 271, NULL),
('Cute Mountains Inn', 281, '2019-11-26', 252, NULL),
('Cute Mountains Inn', 281, '2019-11-27', 252, NULL),
('Cute Mountains Inn', 281, '2019-11-28', 264, NULL),
('Cute Mountains Inn', 281, '2019-11-29', 340, NULL),
('Cute Mountains Inn', 281, '2019-11-30', 229, NULL),
('Cute Mountains Inn', 281, '2019-12-01', 101, NULL),
('Cute Mountains Inn', 281, '2019-12-02', 271, NULL),
('Cute Mountains Inn', 281, '2019-12-03', 369, NULL),
('Cute Mountains Inn', 281, '2019-12-04', 121, NULL),
('Cute Mountains Inn', 281, '2019-12-05', 352, NULL),
('Cute Mountains Inn', 281, '2019-12-06', 227, NULL),
('Cute Mountains Inn', 281, '2019-12-07', 171, NULL),
('Cute Mountains Inn', 281, '2019-12-08', 254, NULL),
('Cute Mountains Inn', 281, '2019-12-09', 272, NULL),
('Cute Mountains Inn', 281, '2019-12-10', 211, NULL),
('Cute Mountains Inn', 281, '2019-12-11', 363, NULL),
('Cute Mountains Inn', 281, '2019-12-12', 368, NULL),
('Cute Mountains Inn', 281, '2019-12-13', 335, NULL),
('Cute Mountains Inn', 281, '2019-12-14', 231, NULL),
('Cute Mountains Inn', 281, '2019-12-15', 290, NULL),
('Cute Mountains Inn', 281, '2019-12-16', 304, NULL),
('Cute Mountains Inn', 281, '2019-12-17', 350, NULL),
('Cute Mountains Inn', 281, '2019-12-18', 329, NULL),
('Cute Mountains Inn', 281, '2019-12-19', 222, NULL),
('Cute Mountains Inn', 281, '2019-12-20', 302, NULL),
('Cute Mountains Inn', 281, '2019-12-21', 385, NULL),
('Cute Mountains Inn', 281, '2019-12-22', 143, NULL),
('Cute Mountains Inn', 281, '2019-12-23', 190, NULL),
('Cute Mountains Inn', 281, '2019-12-24', 287, NULL),
('Cute Mountains Inn', 281, '2019-12-25', 152, NULL),
('Cute Mountains Inn', 281, '2019-12-26', 277, NULL),
('Cute Mountains Inn', 281, '2019-12-27', 230, NULL),
('Cute Mountains Inn', 281, '2019-12-28', 153, NULL),
('Cute Mountains Inn', 281, '2019-12-29', 348, NULL),
('Cute Mountains Inn', 281, '2019-12-30', 317, NULL),
('Cute Mountains Inn', 281, '2019-12-31', 124, NULL),
('Cute Mountains Inn', 281, '2020-01-01', 305, NULL),
('Cute Mountains Inn', 281, '2020-01-02', 140, NULL),
('Cute Mountains Inn', 281, '2020-01-03', 341, NULL),
('Cute Mountains Inn', 281, '2020-01-04', 361, NULL),
('Cute Mountains Inn', 281, '2020-01-05', 362, NULL),
('Cute Mountains Inn', 281, '2020-01-06', 137, NULL),
('Cute Mountains Inn', 281, '2020-01-07', 102, NULL),
('Cute Mountains Inn', 281, '2020-01-08', 170, NULL),
('Cute Mountains Inn', 281, '2020-01-09', 131, NULL),
('Cute Mountains Inn', 281, '2020-01-10', 390, NULL),
('Cute Mountains Inn', 281, '2020-01-11', 199, NULL),
('Cute Mountains Inn', 281, '2020-01-12', 142, NULL),
('Cute Mountains Inn', 281, '2020-01-13', 128, NULL),
('Cute Mountains Inn', 281, '2020-01-14', 114, NULL),
('Cute Mountains Inn', 281, '2020-01-15', 354, NULL),
('Cute Mountains Inn', 281, '2020-01-16', 125, NULL),
('Cute Mountains Inn', 281, '2020-01-17', 126, NULL),
('Cute Mountains Inn', 281, '2020-01-18', 282, NULL),
('Cute Mountains Inn', 281, '2020-01-19', 386, NULL),
('Cute Mountains Inn', 281, '2020-01-20', 281, NULL),
('Cute Mountains Inn', 281, '2020-01-21', 122, NULL),
('Cute Mountains Inn', 281, '2020-01-22', 316, NULL),
('Cute Mountains Inn', 281, '2020-01-23', 322, NULL),
('Cute Mountains Inn', 281, '2020-01-24', 328, NULL),
('Cute Mountains Inn', 281, '2020-01-25', 356, NULL),
('Cute Mountains Inn', 281, '2020-01-26', 343, NULL),
('Cute Mountains Inn', 281, '2020-01-27', 241, NULL),
('Cute Mountains Inn', 281, '2020-01-28', 392, NULL),
('Cute Mountains Inn', 281, '2020-01-29', 137, NULL),
('Cute Mountains Inn', 281, '2020-01-30', 283, NULL),
('Cute Mountains Inn', 281, '2020-01-31', 182, NULL),
('Cute Mountains Inn', 281, '2020-02-01', 257, NULL),
('Cute Mountains Inn', 281, '2020-02-02', 354, NULL),
('Cute Mountains Inn', 281, '2020-02-03', 226, NULL),
('Cute Mountains Inn', 281, '2020-02-04', 321, NULL),
('Cute Mountains Inn', 292, '2019-01-01', 346, NULL),
('Cute Mountains Inn', 292, '2019-01-02', 354, NULL),
('Cute Mountains Inn', 292, '2019-01-03', 345, NULL),
('Cute Mountains Inn', 292, '2019-01-04', 383, NULL),
('Cute Mountains Inn', 292, '2019-01-05', 342, NULL),
('Cute Mountains Inn', 292, '2019-01-06', 177, NULL),
('Cute Mountains Inn', 292, '2019-01-07', 265, NULL),
('Cute Mountains Inn', 292, '2019-01-08', 218, NULL),
('Cute Mountains Inn', 292, '2019-01-09', 115, NULL),
('Cute Mountains Inn', 292, '2019-01-10', 383, NULL),
('Cute Mountains Inn', 292, '2019-01-11', 212, NULL),
('Cute Mountains Inn', 292, '2019-01-12', 135, NULL),
('Cute Mountains Inn', 292, '2019-01-13', 142, NULL),
('Cute Mountains Inn', 292, '2019-01-14', 126, NULL),
('Cute Mountains Inn', 292, '2019-01-15', 242, NULL),
('Cute Mountains Inn', 292, '2019-01-16', 355, NULL),
('Cute Mountains Inn', 292, '2019-01-17', 388, NULL),
('Cute Mountains Inn', 292, '2019-01-18', 203, NULL),
('Cute Mountains Inn', 292, '2019-01-19', 384, NULL),
('Cute Mountains Inn', 292, '2019-01-20', 279, NULL),
('Cute Mountains Inn', 292, '2019-01-21', 101, NULL),
('Cute Mountains Inn', 292, '2019-01-22', 190, NULL),
('Cute Mountains Inn', 292, '2019-01-23', 370, NULL),
('Cute Mountains Inn', 292, '2019-01-24', 238, NULL),
('Cute Mountains Inn', 292, '2019-01-25', 369, NULL),
('Cute Mountains Inn', 292, '2019-01-26', 250, NULL),
('Cute Mountains Inn', 292, '2019-01-27', 187, NULL),
('Cute Mountains Inn', 292, '2019-01-28', 382, NULL),
('Cute Mountains Inn', 292, '2019-01-29', 109, NULL),
('Cute Mountains Inn', 292, '2019-01-30', 111, NULL),
('Cute Mountains Inn', 292, '2019-01-31', 166, NULL),
('Cute Mountains Inn', 292, '2019-02-01', 146, NULL),
('Cute Mountains Inn', 292, '2019-02-02', 300, NULL),
('Cute Mountains Inn', 292, '2019-02-03', 135, NULL),
('Cute Mountains Inn', 292, '2019-02-04', 278, NULL),
('Cute Mountains Inn', 292, '2019-02-05', 320, NULL),
('Cute Mountains Inn', 292, '2019-02-06', 399, NULL),
('Cute Mountains Inn', 292, '2019-02-07', 260, NULL),
('Cute Mountains Inn', 292, '2019-02-08', 230, NULL),
('Cute Mountains Inn', 292, '2019-02-09', 372, NULL),
('Cute Mountains Inn', 292, '2019-02-10', 333, NULL),
('Cute Mountains Inn', 292, '2019-02-11', 366, NULL),
('Cute Mountains Inn', 292, '2019-02-12', 313, NULL),
('Cute Mountains Inn', 292, '2019-02-13', 373, NULL),
('Cute Mountains Inn', 292, '2019-02-14', 307, NULL),
('Cute Mountains Inn', 292, '2019-02-15', 192, NULL),
('Cute Mountains Inn', 292, '2019-02-16', 236, NULL),
('Cute Mountains Inn', 292, '2019-02-17', 234, NULL),
('Cute Mountains Inn', 292, '2019-02-18', 143, NULL),
('Cute Mountains Inn', 292, '2019-02-19', 199, NULL),
('Cute Mountains Inn', 292, '2019-02-20', 220, NULL),
('Cute Mountains Inn', 292, '2019-02-21', 399, NULL),
('Cute Mountains Inn', 292, '2019-02-22', 358, NULL),
('Cute Mountains Inn', 292, '2019-02-23', 221, NULL),
('Cute Mountains Inn', 292, '2019-02-24', 278, NULL),
('Cute Mountains Inn', 292, '2019-02-25', 381, NULL),
('Cute Mountains Inn', 292, '2019-02-26', 133, NULL),
('Cute Mountains Inn', 292, '2019-02-27', 238, NULL),
('Cute Mountains Inn', 292, '2019-02-28', 179, NULL),
('Cute Mountains Inn', 292, '2019-03-01', 274, NULL),
('Cute Mountains Inn', 292, '2019-03-02', 353, NULL),
('Cute Mountains Inn', 292, '2019-03-03', 316, NULL),
('Cute Mountains Inn', 292, '2019-03-04', 359, NULL),
('Cute Mountains Inn', 292, '2019-03-05', 254, NULL),
('Cute Mountains Inn', 292, '2019-03-06', 346, NULL),
('Cute Mountains Inn', 292, '2019-03-07', 322, NULL),
('Cute Mountains Inn', 292, '2019-03-08', 213, NULL),
('Cute Mountains Inn', 292, '2019-03-09', 213, NULL),
('Cute Mountains Inn', 292, '2019-03-10', 148, NULL),
('Cute Mountains Inn', 292, '2019-03-11', 113, NULL),
('Cute Mountains Inn', 292, '2019-03-12', 383, NULL),
('Cute Mountains Inn', 292, '2019-03-13', 242, NULL),
('Cute Mountains Inn', 292, '2019-03-14', 287, NULL),
('Cute Mountains Inn', 292, '2019-03-15', 300, NULL),
('Cute Mountains Inn', 292, '2019-03-16', 219, NULL),
('Cute Mountains Inn', 292, '2019-03-17', 330, NULL),
('Cute Mountains Inn', 292, '2019-03-18', 140, NULL),
('Cute Mountains Inn', 292, '2019-03-19', 118, NULL),
('Cute Mountains Inn', 292, '2019-03-20', 125, NULL),
('Cute Mountains Inn', 292, '2019-03-21', 137, NULL),
('Cute Mountains Inn', 292, '2019-03-22', 138, NULL),
('Cute Mountains Inn', 292, '2019-03-23', 379, NULL),
('Cute Mountains Inn', 292, '2019-03-24', 248, NULL),
('Cute Mountains Inn', 292, '2019-03-25', 278, NULL),
('Cute Mountains Inn', 292, '2019-03-26', 361, NULL),
('Cute Mountains Inn', 292, '2019-03-27', 146, NULL),
('Cute Mountains Inn', 292, '2019-03-28', 167, NULL),
('Cute Mountains Inn', 292, '2019-03-29', 130, NULL),
('Cute Mountains Inn', 292, '2019-03-30', 133, NULL),
('Cute Mountains Inn', 292, '2019-03-31', 151, NULL),
('Cute Mountains Inn', 292, '2019-04-01', 350, NULL),
('Cute Mountains Inn', 292, '2019-04-02', 179, NULL),
('Cute Mountains Inn', 292, '2019-04-03', 164, NULL),
('Cute Mountains Inn', 292, '2019-04-04', 273, NULL),
('Cute Mountains Inn', 292, '2019-04-05', 236, NULL),
('Cute Mountains Inn', 292, '2019-04-06', 101, NULL),
('Cute Mountains Inn', 292, '2019-04-07', 150, NULL),
('Cute Mountains Inn', 292, '2019-04-08', 119, NULL),
('Cute Mountains Inn', 292, '2019-04-09', 263, NULL),
('Cute Mountains Inn', 292, '2019-04-10', 211, NULL),
('Cute Mountains Inn', 292, '2019-04-11', 372, NULL),
('Cute Mountains Inn', 292, '2019-04-12', 218, NULL),
('Cute Mountains Inn', 292, '2019-04-13', 289, NULL),
('Cute Mountains Inn', 292, '2019-04-14', 192, NULL),
('Cute Mountains Inn', 292, '2019-04-15', 225, NULL),
('Cute Mountains Inn', 292, '2019-04-16', 399, NULL),
('Cute Mountains Inn', 292, '2019-04-17', 358, NULL),
('Cute Mountains Inn', 292, '2019-04-18', 152, NULL),
('Cute Mountains Inn', 292, '2019-04-19', 369, NULL),
('Cute Mountains Inn', 292, '2019-04-20', 313, NULL),
('Cute Mountains Inn', 292, '2019-04-21', 362, NULL),
('Cute Mountains Inn', 292, '2019-04-22', 197, NULL),
('Cute Mountains Inn', 292, '2019-04-23', 104, NULL),
('Cute Mountains Inn', 292, '2019-04-24', 195, NULL),
('Cute Mountains Inn', 292, '2019-04-25', 274, NULL),
('Cute Mountains Inn', 292, '2019-04-26', 348, NULL),
('Cute Mountains Inn', 292, '2019-04-27', 250, NULL),
('Cute Mountains Inn', 292, '2019-04-28', 271, NULL),
('Cute Mountains Inn', 292, '2019-04-29', 337, NULL),
('Cute Mountains Inn', 292, '2019-04-30', 273, NULL),
('Cute Mountains Inn', 292, '2019-05-01', 258, NULL),
('Cute Mountains Inn', 292, '2019-05-02', 224, NULL),
('Cute Mountains Inn', 292, '2019-05-03', 243, NULL),
('Cute Mountains Inn', 292, '2019-05-04', 338, NULL),
('Cute Mountains Inn', 292, '2019-05-05', 151, NULL),
('Cute Mountains Inn', 292, '2019-05-06', 214, NULL),
('Cute Mountains Inn', 292, '2019-05-07', 173, NULL),
('Cute Mountains Inn', 292, '2019-05-08', 215, NULL),
('Cute Mountains Inn', 292, '2019-05-09', 328, NULL),
('Cute Mountains Inn', 292, '2019-05-10', 256, NULL),
('Cute Mountains Inn', 292, '2019-05-11', 119, NULL),
('Cute Mountains Inn', 292, '2019-05-12', 133, NULL),
('Cute Mountains Inn', 292, '2019-05-13', 315, NULL),
('Cute Mountains Inn', 292, '2019-05-14', 220, NULL),
('Cute Mountains Inn', 292, '2019-05-15', 117, NULL),
('Cute Mountains Inn', 292, '2019-05-16', 112, NULL),
('Cute Mountains Inn', 292, '2019-05-17', 138, NULL),
('Cute Mountains Inn', 292, '2019-05-18', 252, NULL),
('Cute Mountains Inn', 292, '2019-05-19', 194, NULL),
('Cute Mountains Inn', 292, '2019-05-20', 205, NULL),
('Cute Mountains Inn', 292, '2019-05-21', 399, NULL),
('Cute Mountains Inn', 292, '2019-05-22', 318, NULL),
('Cute Mountains Inn', 292, '2019-05-23', 153, NULL),
('Cute Mountains Inn', 292, '2019-05-24', 166, NULL),
('Cute Mountains Inn', 292, '2019-05-25', 223, NULL),
('Cute Mountains Inn', 292, '2019-05-26', 350, NULL),
('Cute Mountains Inn', 292, '2019-05-27', 131, NULL),
('Cute Mountains Inn', 292, '2019-05-28', 147, NULL),
('Cute Mountains Inn', 292, '2019-05-29', 124, NULL),
('Cute Mountains Inn', 292, '2019-05-30', 142, NULL),
('Cute Mountains Inn', 292, '2019-05-31', 352, NULL),
('Cute Mountains Inn', 292, '2019-06-01', 163, NULL),
('Cute Mountains Inn', 292, '2019-06-02', 269, NULL),
('Cute Mountains Inn', 292, '2019-06-03', 108, NULL),
('Cute Mountains Inn', 292, '2019-06-04', 376, NULL),
('Cute Mountains Inn', 292, '2019-06-05', 265, NULL),
('Cute Mountains Inn', 292, '2019-06-06', 205, NULL),
('Cute Mountains Inn', 292, '2019-06-07', 353, NULL),
('Cute Mountains Inn', 292, '2019-06-08', 398, NULL),
('Cute Mountains Inn', 292, '2019-06-09', 331, NULL),
('Cute Mountains Inn', 292, '2019-06-10', 232, NULL),
('Cute Mountains Inn', 292, '2019-06-11', 283, NULL),
('Cute Mountains Inn', 292, '2019-06-12', 183, NULL),
('Cute Mountains Inn', 292, '2019-06-13', 350, NULL),
('Cute Mountains Inn', 292, '2019-06-14', 359, NULL),
('Cute Mountains Inn', 292, '2019-06-15', 288, NULL),
('Cute Mountains Inn', 292, '2019-06-16', 363, NULL),
('Cute Mountains Inn', 292, '2019-06-17', 175, NULL),
('Cute Mountains Inn', 292, '2019-06-18', 136, NULL),
('Cute Mountains Inn', 292, '2019-06-19', 221, NULL),
('Cute Mountains Inn', 292, '2019-06-20', 198, NULL),
('Cute Mountains Inn', 292, '2019-06-21', 343, NULL),
('Cute Mountains Inn', 292, '2019-06-22', 257, NULL),
('Cute Mountains Inn', 292, '2019-06-23', 175, NULL),
('Cute Mountains Inn', 292, '2019-06-24', 135, NULL),
('Cute Mountains Inn', 292, '2019-06-25', 105, NULL),
('Cute Mountains Inn', 292, '2019-06-26', 141, NULL),
('Cute Mountains Inn', 292, '2019-06-27', 156, NULL),
('Cute Mountains Inn', 292, '2019-06-28', 308, NULL),
('Cute Mountains Inn', 292, '2019-06-29', 299, NULL),
('Cute Mountains Inn', 292, '2019-06-30', 238, NULL),
('Cute Mountains Inn', 292, '2019-07-01', 209, NULL),
('Cute Mountains Inn', 292, '2019-07-02', 210, NULL),
('Cute Mountains Inn', 292, '2019-07-03', 356, NULL),
('Cute Mountains Inn', 292, '2019-07-04', 183, NULL),
('Cute Mountains Inn', 292, '2019-07-05', 196, NULL),
('Cute Mountains Inn', 292, '2019-07-06', 207, NULL),
('Cute Mountains Inn', 292, '2019-07-07', 183, NULL),
('Cute Mountains Inn', 292, '2019-07-08', 194, NULL),
('Cute Mountains Inn', 292, '2019-07-09', 381, NULL),
('Cute Mountains Inn', 292, '2019-07-10', 164, NULL),
('Cute Mountains Inn', 292, '2019-07-11', 178, NULL),
('Cute Mountains Inn', 292, '2019-07-12', 370, NULL),
('Cute Mountains Inn', 292, '2019-07-13', 372, NULL),
('Cute Mountains Inn', 292, '2019-07-14', 231, NULL),
('Cute Mountains Inn', 292, '2019-07-15', 367, NULL),
('Cute Mountains Inn', 292, '2019-07-16', 101, NULL),
('Cute Mountains Inn', 292, '2019-07-17', 367, NULL),
('Cute Mountains Inn', 292, '2019-07-18', 193, NULL),
('Cute Mountains Inn', 292, '2019-07-19', 381, NULL),
('Cute Mountains Inn', 292, '2019-07-20', 160, NULL),
('Cute Mountains Inn', 292, '2019-07-21', 164, NULL),
('Cute Mountains Inn', 292, '2019-07-22', 278, NULL),
('Cute Mountains Inn', 292, '2019-07-23', 107, NULL),
('Cute Mountains Inn', 292, '2019-07-24', 198, NULL),
('Cute Mountains Inn', 292, '2019-07-25', 324, NULL),
('Cute Mountains Inn', 292, '2019-07-26', 200, NULL),
('Cute Mountains Inn', 292, '2019-07-27', 324, NULL),
('Cute Mountains Inn', 292, '2019-07-28', 275, NULL),
('Cute Mountains Inn', 292, '2019-07-29', 146, NULL),
('Cute Mountains Inn', 292, '2019-07-30', 305, NULL),
('Cute Mountains Inn', 292, '2019-07-31', 121, NULL),
('Cute Mountains Inn', 292, '2019-08-01', 104, NULL),
('Cute Mountains Inn', 292, '2019-08-02', 352, NULL),
('Cute Mountains Inn', 292, '2019-08-03', 211, NULL),
('Cute Mountains Inn', 292, '2019-08-04', 396, NULL),
('Cute Mountains Inn', 292, '2019-08-05', 107, NULL),
('Cute Mountains Inn', 292, '2019-08-06', 341, NULL),
('Cute Mountains Inn', 292, '2019-08-07', 386, NULL),
('Cute Mountains Inn', 292, '2019-08-08', 399, NULL),
('Cute Mountains Inn', 292, '2019-08-09', 303, NULL),
('Cute Mountains Inn', 292, '2019-08-10', 194, NULL),
('Cute Mountains Inn', 292, '2019-08-11', 213, NULL),
('Cute Mountains Inn', 292, '2019-08-12', 285, NULL),
('Cute Mountains Inn', 292, '2019-08-13', 226, NULL),
('Cute Mountains Inn', 292, '2019-08-14', 107, NULL),
('Cute Mountains Inn', 292, '2019-08-15', 312, NULL),
('Cute Mountains Inn', 292, '2019-08-16', 192, NULL),
('Cute Mountains Inn', 292, '2019-08-17', 279, NULL),
('Cute Mountains Inn', 292, '2019-08-18', 148, NULL),
('Cute Mountains Inn', 292, '2019-08-19', 158, NULL),
('Cute Mountains Inn', 292, '2019-08-20', 143, NULL),
('Cute Mountains Inn', 292, '2019-08-21', 342, NULL),
('Cute Mountains Inn', 292, '2019-08-22', 356, NULL),
('Cute Mountains Inn', 292, '2019-08-23', 133, NULL),
('Cute Mountains Inn', 292, '2019-08-24', 278, NULL),
('Cute Mountains Inn', 292, '2019-08-25', 255, NULL),
('Cute Mountains Inn', 292, '2019-08-26', 309, NULL),
('Cute Mountains Inn', 292, '2019-08-27', 320, NULL),
('Cute Mountains Inn', 292, '2019-08-28', 315, NULL),
('Cute Mountains Inn', 292, '2019-08-29', 270, NULL),
('Cute Mountains Inn', 292, '2019-08-30', 360, NULL),
('Cute Mountains Inn', 292, '2019-08-31', 146, NULL),
('Cute Mountains Inn', 292, '2019-09-01', 228, NULL),
('Cute Mountains Inn', 292, '2019-09-02', 390, NULL),
('Cute Mountains Inn', 292, '2019-09-03', 276, NULL),
('Cute Mountains Inn', 292, '2019-09-04', 107, NULL),
('Cute Mountains Inn', 292, '2019-09-05', 314, NULL),
('Cute Mountains Inn', 292, '2019-09-06', 196, NULL),
('Cute Mountains Inn', 292, '2019-09-07', 330, NULL),
('Cute Mountains Inn', 292, '2019-09-08', 330, NULL),
('Cute Mountains Inn', 292, '2019-09-09', 255, NULL),
('Cute Mountains Inn', 292, '2019-09-10', 249, NULL),
('Cute Mountains Inn', 292, '2019-09-11', 211, NULL),
('Cute Mountains Inn', 292, '2019-09-12', 161, NULL),
('Cute Mountains Inn', 292, '2019-09-13', 313, NULL),
('Cute Mountains Inn', 292, '2019-09-14', 113, NULL),
('Cute Mountains Inn', 292, '2019-09-15', 171, NULL),
('Cute Mountains Inn', 292, '2019-09-16', 330, NULL),
('Cute Mountains Inn', 292, '2019-09-17', 187, NULL),
('Cute Mountains Inn', 292, '2019-09-18', 125, NULL),
('Cute Mountains Inn', 292, '2019-09-19', 350, NULL),
('Cute Mountains Inn', 292, '2019-09-20', 332, NULL),
('Cute Mountains Inn', 292, '2019-09-21', 249, NULL),
('Cute Mountains Inn', 292, '2019-09-22', 345, NULL),
('Cute Mountains Inn', 292, '2019-09-23', 174, NULL),
('Cute Mountains Inn', 292, '2019-09-24', 301, NULL),
('Cute Mountains Inn', 292, '2019-09-25', 298, NULL),
('Cute Mountains Inn', 292, '2019-09-26', 207, NULL),
('Cute Mountains Inn', 292, '2019-09-27', 145, NULL),
('Cute Mountains Inn', 292, '2019-09-28', 398, NULL),
('Cute Mountains Inn', 292, '2019-09-29', 155, NULL),
('Cute Mountains Inn', 292, '2019-09-30', 286, NULL),
('Cute Mountains Inn', 292, '2019-10-01', 121, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Cute Mountains Inn', 292, '2019-10-02', 209, NULL),
('Cute Mountains Inn', 292, '2019-10-03', 290, NULL),
('Cute Mountains Inn', 292, '2019-10-04', 330, NULL),
('Cute Mountains Inn', 292, '2019-10-05', 207, NULL),
('Cute Mountains Inn', 292, '2019-10-06', 209, NULL),
('Cute Mountains Inn', 292, '2019-10-07', 116, NULL),
('Cute Mountains Inn', 292, '2019-10-08', 268, NULL),
('Cute Mountains Inn', 292, '2019-10-09', 308, NULL),
('Cute Mountains Inn', 292, '2019-10-10', 274, NULL),
('Cute Mountains Inn', 292, '2019-10-11', 124, NULL),
('Cute Mountains Inn', 292, '2019-10-12', 182, NULL),
('Cute Mountains Inn', 292, '2019-10-13', 171, NULL),
('Cute Mountains Inn', 292, '2019-10-14', 179, NULL),
('Cute Mountains Inn', 292, '2019-10-15', 240, NULL),
('Cute Mountains Inn', 292, '2019-10-16', 307, NULL),
('Cute Mountains Inn', 292, '2019-10-17', 188, NULL),
('Cute Mountains Inn', 292, '2019-10-18', 232, NULL),
('Cute Mountains Inn', 292, '2019-10-19', 176, NULL),
('Cute Mountains Inn', 292, '2019-10-20', 321, NULL),
('Cute Mountains Inn', 292, '2019-10-21', 253, NULL),
('Cute Mountains Inn', 292, '2019-10-22', 255, NULL),
('Cute Mountains Inn', 292, '2019-10-23', 353, NULL),
('Cute Mountains Inn', 292, '2019-10-24', 292, NULL),
('Cute Mountains Inn', 292, '2019-10-25', 381, NULL),
('Cute Mountains Inn', 292, '2019-10-26', 389, NULL),
('Cute Mountains Inn', 292, '2019-10-27', 152, NULL),
('Cute Mountains Inn', 292, '2019-10-28', 234, NULL),
('Cute Mountains Inn', 292, '2019-10-29', 275, NULL),
('Cute Mountains Inn', 292, '2019-10-30', 169, NULL),
('Cute Mountains Inn', 292, '2019-10-31', 118, NULL),
('Cute Mountains Inn', 292, '2019-11-01', 248, NULL),
('Cute Mountains Inn', 292, '2019-11-02', 151, NULL),
('Cute Mountains Inn', 292, '2019-11-03', 236, NULL),
('Cute Mountains Inn', 292, '2019-11-04', 260, NULL),
('Cute Mountains Inn', 292, '2019-11-05', 372, NULL),
('Cute Mountains Inn', 292, '2019-11-06', 302, NULL),
('Cute Mountains Inn', 292, '2019-11-07', 326, NULL),
('Cute Mountains Inn', 292, '2019-11-08', 312, NULL),
('Cute Mountains Inn', 292, '2019-11-09', 104, NULL),
('Cute Mountains Inn', 292, '2019-11-10', 167, NULL),
('Cute Mountains Inn', 292, '2019-11-11', 301, NULL),
('Cute Mountains Inn', 292, '2019-11-12', 258, NULL),
('Cute Mountains Inn', 292, '2019-11-13', 254, NULL),
('Cute Mountains Inn', 292, '2019-11-14', 149, NULL),
('Cute Mountains Inn', 292, '2019-11-15', 196, NULL),
('Cute Mountains Inn', 292, '2019-11-16', 179, NULL),
('Cute Mountains Inn', 292, '2019-11-17', 379, NULL),
('Cute Mountains Inn', 292, '2019-11-18', 154, NULL),
('Cute Mountains Inn', 292, '2019-11-19', 396, NULL),
('Cute Mountains Inn', 292, '2019-11-20', 116, NULL),
('Cute Mountains Inn', 292, '2019-11-21', 112, NULL),
('Cute Mountains Inn', 292, '2019-11-22', 222, NULL),
('Cute Mountains Inn', 292, '2019-11-23', 280, NULL),
('Cute Mountains Inn', 292, '2019-11-24', 180, NULL),
('Cute Mountains Inn', 292, '2019-11-25', 225, NULL),
('Cute Mountains Inn', 292, '2019-11-26', 279, NULL),
('Cute Mountains Inn', 292, '2019-11-27', 367, NULL),
('Cute Mountains Inn', 292, '2019-11-28', 178, NULL),
('Cute Mountains Inn', 292, '2019-11-29', 162, NULL),
('Cute Mountains Inn', 292, '2019-11-30', 389, NULL),
('Cute Mountains Inn', 292, '2019-12-01', 357, NULL),
('Cute Mountains Inn', 292, '2019-12-02', 134, NULL),
('Cute Mountains Inn', 292, '2019-12-03', 135, NULL),
('Cute Mountains Inn', 292, '2019-12-04', 221, NULL),
('Cute Mountains Inn', 292, '2019-12-05', 299, NULL),
('Cute Mountains Inn', 292, '2019-12-06', 334, NULL),
('Cute Mountains Inn', 292, '2019-12-07', 277, NULL),
('Cute Mountains Inn', 292, '2019-12-08', 317, NULL),
('Cute Mountains Inn', 292, '2019-12-09', 115, NULL),
('Cute Mountains Inn', 292, '2019-12-10', 196, NULL),
('Cute Mountains Inn', 292, '2019-12-11', 372, NULL),
('Cute Mountains Inn', 292, '2019-12-12', 384, NULL),
('Cute Mountains Inn', 292, '2019-12-13', 229, NULL),
('Cute Mountains Inn', 292, '2019-12-14', 225, NULL),
('Cute Mountains Inn', 292, '2019-12-15', 395, NULL),
('Cute Mountains Inn', 292, '2019-12-16', 198, NULL),
('Cute Mountains Inn', 292, '2019-12-17', 349, NULL),
('Cute Mountains Inn', 292, '2019-12-18', 190, NULL),
('Cute Mountains Inn', 292, '2019-12-19', 131, NULL),
('Cute Mountains Inn', 292, '2019-12-20', 272, NULL),
('Cute Mountains Inn', 292, '2019-12-21', 377, NULL),
('Cute Mountains Inn', 292, '2019-12-22', 129, NULL),
('Cute Mountains Inn', 292, '2019-12-23', 326, NULL),
('Cute Mountains Inn', 292, '2019-12-24', 130, NULL),
('Cute Mountains Inn', 292, '2019-12-25', 388, NULL),
('Cute Mountains Inn', 292, '2019-12-26', 288, NULL),
('Cute Mountains Inn', 292, '2019-12-27', 197, NULL),
('Cute Mountains Inn', 292, '2019-12-28', 363, NULL),
('Cute Mountains Inn', 292, '2019-12-29', 103, NULL),
('Cute Mountains Inn', 292, '2019-12-30', 347, NULL),
('Cute Mountains Inn', 292, '2019-12-31', 199, NULL),
('Cute Mountains Inn', 292, '2020-01-01', 326, NULL),
('Cute Mountains Inn', 292, '2020-01-02', 348, NULL),
('Cute Mountains Inn', 292, '2020-01-03', 312, NULL),
('Cute Mountains Inn', 292, '2020-01-04', 144, NULL),
('Cute Mountains Inn', 292, '2020-01-05', 314, NULL),
('Cute Mountains Inn', 292, '2020-01-06', 242, NULL),
('Cute Mountains Inn', 292, '2020-01-07', 158, NULL),
('Cute Mountains Inn', 292, '2020-01-08', 246, NULL),
('Cute Mountains Inn', 292, '2020-01-09', 334, NULL),
('Cute Mountains Inn', 292, '2020-01-10', 126, NULL),
('Cute Mountains Inn', 292, '2020-01-11', 329, NULL),
('Cute Mountains Inn', 292, '2020-01-12', 307, NULL),
('Cute Mountains Inn', 292, '2020-01-13', 295, NULL),
('Cute Mountains Inn', 292, '2020-01-14', 216, NULL),
('Cute Mountains Inn', 292, '2020-01-15', 194, NULL),
('Cute Mountains Inn', 292, '2020-01-16', 350, NULL),
('Cute Mountains Inn', 292, '2020-01-17', 344, NULL),
('Cute Mountains Inn', 292, '2020-01-18', 189, NULL),
('Cute Mountains Inn', 292, '2020-01-19', 384, NULL),
('Cute Mountains Inn', 292, '2020-01-20', 398, NULL),
('Cute Mountains Inn', 292, '2020-01-21', 205, NULL),
('Cute Mountains Inn', 292, '2020-01-22', 199, NULL),
('Cute Mountains Inn', 292, '2020-01-23', 322, NULL),
('Cute Mountains Inn', 292, '2020-01-24', 384, NULL),
('Cute Mountains Inn', 292, '2020-01-25', 395, NULL),
('Cute Mountains Inn', 292, '2020-01-26', 289, NULL),
('Cute Mountains Inn', 292, '2020-01-27', 250, NULL),
('Cute Mountains Inn', 292, '2020-01-28', 178, NULL),
('Cute Mountains Inn', 292, '2020-01-29', 157, NULL),
('Cute Mountains Inn', 292, '2020-01-30', 275, NULL),
('Cute Mountains Inn', 292, '2020-01-31', 151, NULL),
('Cute Mountains Inn', 292, '2020-02-01', 227, NULL),
('Cute Mountains Inn', 292, '2020-02-02', 300, NULL),
('Cute Mountains Inn', 292, '2020-02-03', 114, NULL),
('Cute Mountains Inn', 292, '2020-02-04', 251, NULL),
('Cute Mountains Inn', 298, '2019-01-01', 239, NULL),
('Cute Mountains Inn', 298, '2019-01-02', 368, NULL),
('Cute Mountains Inn', 298, '2019-01-03', 160, NULL),
('Cute Mountains Inn', 298, '2019-01-04', 318, NULL),
('Cute Mountains Inn', 298, '2019-01-05', 395, NULL),
('Cute Mountains Inn', 298, '2019-01-06', 131, NULL),
('Cute Mountains Inn', 298, '2019-01-07', 123, NULL),
('Cute Mountains Inn', 298, '2019-01-08', 350, NULL),
('Cute Mountains Inn', 298, '2019-01-09', 310, NULL),
('Cute Mountains Inn', 298, '2019-01-10', 202, NULL),
('Cute Mountains Inn', 298, '2019-01-11', 116, NULL),
('Cute Mountains Inn', 298, '2019-01-12', 101, NULL),
('Cute Mountains Inn', 298, '2019-01-13', 175, NULL),
('Cute Mountains Inn', 298, '2019-01-14', 353, NULL),
('Cute Mountains Inn', 298, '2019-01-15', 196, NULL),
('Cute Mountains Inn', 298, '2019-01-16', 316, NULL),
('Cute Mountains Inn', 298, '2019-01-17', 334, NULL),
('Cute Mountains Inn', 298, '2019-01-18', 373, NULL),
('Cute Mountains Inn', 298, '2019-01-19', 133, NULL),
('Cute Mountains Inn', 298, '2019-01-20', 374, NULL),
('Cute Mountains Inn', 298, '2019-01-21', 249, NULL),
('Cute Mountains Inn', 298, '2019-01-22', 399, NULL),
('Cute Mountains Inn', 298, '2019-01-23', 178, NULL),
('Cute Mountains Inn', 298, '2019-01-24', 159, NULL),
('Cute Mountains Inn', 298, '2019-01-25', 109, NULL),
('Cute Mountains Inn', 298, '2019-01-26', 202, NULL),
('Cute Mountains Inn', 298, '2019-01-27', 131, NULL),
('Cute Mountains Inn', 298, '2019-01-28', 347, NULL),
('Cute Mountains Inn', 298, '2019-01-29', 118, NULL),
('Cute Mountains Inn', 298, '2019-01-30', 354, NULL),
('Cute Mountains Inn', 298, '2019-01-31', 126, NULL),
('Cute Mountains Inn', 298, '2019-02-01', 393, NULL),
('Cute Mountains Inn', 298, '2019-02-02', 359, NULL),
('Cute Mountains Inn', 298, '2019-02-03', 396, NULL),
('Cute Mountains Inn', 298, '2019-02-04', 383, NULL),
('Cute Mountains Inn', 298, '2019-02-05', 339, NULL),
('Cute Mountains Inn', 298, '2019-02-06', 219, NULL),
('Cute Mountains Inn', 298, '2019-02-07', 140, NULL),
('Cute Mountains Inn', 298, '2019-02-08', 362, NULL),
('Cute Mountains Inn', 298, '2019-02-09', 242, NULL),
('Cute Mountains Inn', 298, '2019-02-10', 203, NULL),
('Cute Mountains Inn', 298, '2019-02-11', 339, NULL),
('Cute Mountains Inn', 298, '2019-02-12', 280, NULL),
('Cute Mountains Inn', 298, '2019-02-13', 216, NULL),
('Cute Mountains Inn', 298, '2019-02-14', 217, NULL),
('Cute Mountains Inn', 298, '2019-02-15', 177, NULL),
('Cute Mountains Inn', 298, '2019-02-16', 180, NULL),
('Cute Mountains Inn', 298, '2019-02-17', 193, NULL),
('Cute Mountains Inn', 298, '2019-02-18', 393, NULL),
('Cute Mountains Inn', 298, '2019-02-19', 262, NULL),
('Cute Mountains Inn', 298, '2019-02-20', 215, NULL),
('Cute Mountains Inn', 298, '2019-02-21', 115, NULL),
('Cute Mountains Inn', 298, '2019-02-22', 200, NULL),
('Cute Mountains Inn', 298, '2019-02-23', 191, NULL),
('Cute Mountains Inn', 298, '2019-02-24', 268, NULL),
('Cute Mountains Inn', 298, '2019-02-25', 200, NULL),
('Cute Mountains Inn', 298, '2019-02-26', 395, NULL),
('Cute Mountains Inn', 298, '2019-02-27', 171, NULL),
('Cute Mountains Inn', 298, '2019-02-28', 255, NULL),
('Cute Mountains Inn', 298, '2019-03-01', 286, NULL),
('Cute Mountains Inn', 298, '2019-03-02', 333, NULL),
('Cute Mountains Inn', 298, '2019-03-03', 384, NULL),
('Cute Mountains Inn', 298, '2019-03-04', 295, NULL),
('Cute Mountains Inn', 298, '2019-03-05', 189, NULL),
('Cute Mountains Inn', 298, '2019-03-06', 123, NULL),
('Cute Mountains Inn', 298, '2019-03-07', 103, NULL),
('Cute Mountains Inn', 298, '2019-03-08', 203, NULL),
('Cute Mountains Inn', 298, '2019-03-09', 223, NULL),
('Cute Mountains Inn', 298, '2019-03-10', 261, NULL),
('Cute Mountains Inn', 298, '2019-03-11', 379, NULL),
('Cute Mountains Inn', 298, '2019-03-12', 383, NULL),
('Cute Mountains Inn', 298, '2019-03-13', 286, NULL),
('Cute Mountains Inn', 298, '2019-03-14', 257, NULL),
('Cute Mountains Inn', 298, '2019-03-15', 154, NULL),
('Cute Mountains Inn', 298, '2019-03-16', 182, NULL),
('Cute Mountains Inn', 298, '2019-03-17', 333, NULL),
('Cute Mountains Inn', 298, '2019-03-18', 342, NULL),
('Cute Mountains Inn', 298, '2019-03-19', 399, NULL),
('Cute Mountains Inn', 298, '2019-03-20', 382, NULL),
('Cute Mountains Inn', 298, '2019-03-21', 385, NULL),
('Cute Mountains Inn', 298, '2019-03-22', 324, NULL),
('Cute Mountains Inn', 298, '2019-03-23', 272, NULL),
('Cute Mountains Inn', 298, '2019-03-24', 279, NULL),
('Cute Mountains Inn', 298, '2019-03-25', 222, NULL),
('Cute Mountains Inn', 298, '2019-03-26', 114, NULL),
('Cute Mountains Inn', 298, '2019-03-27', 224, NULL),
('Cute Mountains Inn', 298, '2019-03-28', 297, NULL),
('Cute Mountains Inn', 298, '2019-03-29', 279, NULL),
('Cute Mountains Inn', 298, '2019-03-30', 168, NULL),
('Cute Mountains Inn', 298, '2019-03-31', 347, NULL),
('Cute Mountains Inn', 298, '2019-04-01', 134, NULL),
('Cute Mountains Inn', 298, '2019-04-02', 399, NULL),
('Cute Mountains Inn', 298, '2019-04-03', 110, NULL),
('Cute Mountains Inn', 298, '2019-04-04', 323, NULL),
('Cute Mountains Inn', 298, '2019-04-05', 393, NULL),
('Cute Mountains Inn', 298, '2019-04-06', 122, NULL),
('Cute Mountains Inn', 298, '2019-04-07', 279, NULL),
('Cute Mountains Inn', 298, '2019-04-08', 233, NULL),
('Cute Mountains Inn', 298, '2019-04-09', 397, NULL),
('Cute Mountains Inn', 298, '2019-04-10', 319, NULL),
('Cute Mountains Inn', 298, '2019-04-11', 291, NULL),
('Cute Mountains Inn', 298, '2019-04-12', 153, NULL),
('Cute Mountains Inn', 298, '2019-04-13', 146, NULL),
('Cute Mountains Inn', 298, '2019-04-14', 262, NULL),
('Cute Mountains Inn', 298, '2019-04-15', 278, NULL),
('Cute Mountains Inn', 298, '2019-04-16', 345, NULL),
('Cute Mountains Inn', 298, '2019-04-17', 171, NULL),
('Cute Mountains Inn', 298, '2019-04-18', 228, NULL),
('Cute Mountains Inn', 298, '2019-04-19', 173, NULL),
('Cute Mountains Inn', 298, '2019-04-20', 132, NULL),
('Cute Mountains Inn', 298, '2019-04-21', 279, NULL),
('Cute Mountains Inn', 298, '2019-04-22', 288, NULL),
('Cute Mountains Inn', 298, '2019-04-23', 297, NULL),
('Cute Mountains Inn', 298, '2019-04-24', 154, NULL),
('Cute Mountains Inn', 298, '2019-04-25', 324, NULL),
('Cute Mountains Inn', 298, '2019-04-26', 193, NULL),
('Cute Mountains Inn', 298, '2019-04-27', 354, NULL),
('Cute Mountains Inn', 298, '2019-04-28', 158, NULL),
('Cute Mountains Inn', 298, '2019-04-29', 375, NULL),
('Cute Mountains Inn', 298, '2019-04-30', 348, NULL),
('Cute Mountains Inn', 298, '2019-05-01', 313, NULL),
('Cute Mountains Inn', 298, '2019-05-02', 228, NULL),
('Cute Mountains Inn', 298, '2019-05-03', 179, NULL),
('Cute Mountains Inn', 298, '2019-05-04', 188, NULL),
('Cute Mountains Inn', 298, '2019-05-05', 156, NULL),
('Cute Mountains Inn', 298, '2019-05-06', 363, NULL),
('Cute Mountains Inn', 298, '2019-05-07', 230, NULL),
('Cute Mountains Inn', 298, '2019-05-08', 338, NULL),
('Cute Mountains Inn', 298, '2019-05-09', 175, NULL),
('Cute Mountains Inn', 298, '2019-05-10', 268, NULL),
('Cute Mountains Inn', 298, '2019-05-11', 186, NULL),
('Cute Mountains Inn', 298, '2019-05-12', 113, NULL),
('Cute Mountains Inn', 298, '2019-05-13', 170, NULL),
('Cute Mountains Inn', 298, '2019-05-14', 198, NULL),
('Cute Mountains Inn', 298, '2019-05-15', 129, NULL),
('Cute Mountains Inn', 298, '2019-05-16', 157, NULL),
('Cute Mountains Inn', 298, '2019-05-17', 137, NULL),
('Cute Mountains Inn', 298, '2019-05-18', 365, NULL),
('Cute Mountains Inn', 298, '2019-05-19', 285, NULL),
('Cute Mountains Inn', 298, '2019-05-20', 353, NULL),
('Cute Mountains Inn', 298, '2019-05-21', 157, NULL),
('Cute Mountains Inn', 298, '2019-05-22', 389, NULL),
('Cute Mountains Inn', 298, '2019-05-23', 371, NULL),
('Cute Mountains Inn', 298, '2019-05-24', 264, NULL),
('Cute Mountains Inn', 298, '2019-05-25', 198, NULL),
('Cute Mountains Inn', 298, '2019-05-26', 211, NULL),
('Cute Mountains Inn', 298, '2019-05-27', 159, NULL),
('Cute Mountains Inn', 298, '2019-05-28', 318, NULL),
('Cute Mountains Inn', 298, '2019-05-29', 378, NULL),
('Cute Mountains Inn', 298, '2019-05-30', 330, NULL),
('Cute Mountains Inn', 298, '2019-05-31', 163, NULL),
('Cute Mountains Inn', 298, '2019-06-01', 308, NULL),
('Cute Mountains Inn', 298, '2019-06-02', 358, NULL),
('Cute Mountains Inn', 298, '2019-06-03', 362, NULL),
('Cute Mountains Inn', 298, '2019-06-04', 273, NULL),
('Cute Mountains Inn', 298, '2019-06-05', 131, NULL),
('Cute Mountains Inn', 298, '2019-06-06', 151, NULL),
('Cute Mountains Inn', 298, '2019-06-07', 149, NULL),
('Cute Mountains Inn', 298, '2019-06-08', 363, NULL),
('Cute Mountains Inn', 298, '2019-06-09', 128, NULL),
('Cute Mountains Inn', 298, '2019-06-10', 214, NULL),
('Cute Mountains Inn', 298, '2019-06-11', 337, NULL),
('Cute Mountains Inn', 298, '2019-06-12', 161, NULL),
('Cute Mountains Inn', 298, '2019-06-13', 231, NULL),
('Cute Mountains Inn', 298, '2019-06-14', 377, NULL),
('Cute Mountains Inn', 298, '2019-06-15', 235, NULL),
('Cute Mountains Inn', 298, '2019-06-16', 230, NULL),
('Cute Mountains Inn', 298, '2019-06-17', 201, NULL),
('Cute Mountains Inn', 298, '2019-06-18', 320, NULL),
('Cute Mountains Inn', 298, '2019-06-19', 364, NULL),
('Cute Mountains Inn', 298, '2019-06-20', 353, NULL),
('Cute Mountains Inn', 298, '2019-06-21', 238, NULL),
('Cute Mountains Inn', 298, '2019-06-22', 344, NULL),
('Cute Mountains Inn', 298, '2019-06-23', 203, NULL),
('Cute Mountains Inn', 298, '2019-06-24', 354, NULL),
('Cute Mountains Inn', 298, '2019-06-25', 136, NULL),
('Cute Mountains Inn', 298, '2019-06-26', 360, NULL),
('Cute Mountains Inn', 298, '2019-06-27', 216, NULL),
('Cute Mountains Inn', 298, '2019-06-28', 218, NULL),
('Cute Mountains Inn', 298, '2019-06-29', 269, NULL),
('Cute Mountains Inn', 298, '2019-06-30', 289, NULL),
('Cute Mountains Inn', 298, '2019-07-01', 106, NULL),
('Cute Mountains Inn', 298, '2019-07-02', 239, NULL),
('Cute Mountains Inn', 298, '2019-07-03', 196, NULL),
('Cute Mountains Inn', 298, '2019-07-04', 281, NULL),
('Cute Mountains Inn', 298, '2019-07-05', 147, NULL),
('Cute Mountains Inn', 298, '2019-07-06', 256, NULL),
('Cute Mountains Inn', 298, '2019-07-07', 363, NULL),
('Cute Mountains Inn', 298, '2019-07-08', 263, NULL),
('Cute Mountains Inn', 298, '2019-07-09', 309, NULL),
('Cute Mountains Inn', 298, '2019-07-10', 358, NULL),
('Cute Mountains Inn', 298, '2019-07-11', 194, NULL),
('Cute Mountains Inn', 298, '2019-07-12', 352, NULL),
('Cute Mountains Inn', 298, '2019-07-13', 116, NULL),
('Cute Mountains Inn', 298, '2019-07-14', 324, NULL),
('Cute Mountains Inn', 298, '2019-07-15', 100, NULL),
('Cute Mountains Inn', 298, '2019-07-16', 311, NULL),
('Cute Mountains Inn', 298, '2019-07-17', 137, NULL),
('Cute Mountains Inn', 298, '2019-07-18', 373, NULL),
('Cute Mountains Inn', 298, '2019-07-19', 336, NULL),
('Cute Mountains Inn', 298, '2019-07-20', 322, NULL),
('Cute Mountains Inn', 298, '2019-07-21', 242, NULL),
('Cute Mountains Inn', 298, '2019-07-22', 378, NULL),
('Cute Mountains Inn', 298, '2019-07-23', 308, NULL),
('Cute Mountains Inn', 298, '2019-07-24', 215, NULL),
('Cute Mountains Inn', 298, '2019-07-25', 244, NULL),
('Cute Mountains Inn', 298, '2019-07-26', 116, NULL),
('Cute Mountains Inn', 298, '2019-07-27', 270, NULL),
('Cute Mountains Inn', 298, '2019-07-28', 206, NULL),
('Cute Mountains Inn', 298, '2019-07-29', 303, NULL),
('Cute Mountains Inn', 298, '2019-07-30', 157, NULL),
('Cute Mountains Inn', 298, '2019-07-31', 289, NULL),
('Cute Mountains Inn', 298, '2019-08-01', 173, NULL),
('Cute Mountains Inn', 298, '2019-08-02', 192, NULL),
('Cute Mountains Inn', 298, '2019-08-03', 295, NULL),
('Cute Mountains Inn', 298, '2019-08-04', 134, NULL),
('Cute Mountains Inn', 298, '2019-08-05', 264, NULL),
('Cute Mountains Inn', 298, '2019-08-06', 366, NULL),
('Cute Mountains Inn', 298, '2019-08-07', 268, NULL),
('Cute Mountains Inn', 298, '2019-08-08', 297, NULL),
('Cute Mountains Inn', 298, '2019-08-09', 369, NULL),
('Cute Mountains Inn', 298, '2019-08-10', 324, NULL),
('Cute Mountains Inn', 298, '2019-08-11', 147, NULL),
('Cute Mountains Inn', 298, '2019-08-12', 221, NULL),
('Cute Mountains Inn', 298, '2019-08-13', 232, NULL),
('Cute Mountains Inn', 298, '2019-08-14', 267, NULL),
('Cute Mountains Inn', 298, '2019-08-15', 172, NULL),
('Cute Mountains Inn', 298, '2019-08-16', 256, NULL),
('Cute Mountains Inn', 298, '2019-08-17', 270, NULL),
('Cute Mountains Inn', 298, '2019-08-18', 219, NULL),
('Cute Mountains Inn', 298, '2019-08-19', 197, NULL),
('Cute Mountains Inn', 298, '2019-08-20', 159, NULL),
('Cute Mountains Inn', 298, '2019-08-21', 359, NULL),
('Cute Mountains Inn', 298, '2019-08-22', 313, NULL),
('Cute Mountains Inn', 298, '2019-08-23', 114, NULL),
('Cute Mountains Inn', 298, '2019-08-24', 367, NULL),
('Cute Mountains Inn', 298, '2019-08-25', 159, NULL),
('Cute Mountains Inn', 298, '2019-08-26', 261, NULL),
('Cute Mountains Inn', 298, '2019-08-27', 236, NULL),
('Cute Mountains Inn', 298, '2019-08-28', 126, NULL),
('Cute Mountains Inn', 298, '2019-08-29', 112, NULL),
('Cute Mountains Inn', 298, '2019-08-30', 110, NULL),
('Cute Mountains Inn', 298, '2019-08-31', 332, NULL),
('Cute Mountains Inn', 298, '2019-09-01', 377, NULL),
('Cute Mountains Inn', 298, '2019-09-02', 141, NULL),
('Cute Mountains Inn', 298, '2019-09-03', 316, NULL),
('Cute Mountains Inn', 298, '2019-09-04', 180, NULL),
('Cute Mountains Inn', 298, '2019-09-05', 361, NULL),
('Cute Mountains Inn', 298, '2019-09-06', 213, NULL),
('Cute Mountains Inn', 298, '2019-09-07', 248, NULL),
('Cute Mountains Inn', 298, '2019-09-08', 248, NULL),
('Cute Mountains Inn', 298, '2019-09-09', 123, NULL),
('Cute Mountains Inn', 298, '2019-09-10', 238, NULL),
('Cute Mountains Inn', 298, '2019-09-11', 375, NULL),
('Cute Mountains Inn', 298, '2019-09-12', 161, NULL),
('Cute Mountains Inn', 298, '2019-09-13', 292, NULL),
('Cute Mountains Inn', 298, '2019-09-14', 150, NULL),
('Cute Mountains Inn', 298, '2019-09-15', 303, NULL),
('Cute Mountains Inn', 298, '2019-09-16', 247, NULL),
('Cute Mountains Inn', 298, '2019-09-17', 252, NULL),
('Cute Mountains Inn', 298, '2019-09-18', 191, NULL),
('Cute Mountains Inn', 298, '2019-09-19', 273, NULL),
('Cute Mountains Inn', 298, '2019-09-20', 192, NULL),
('Cute Mountains Inn', 298, '2019-09-21', 106, NULL),
('Cute Mountains Inn', 298, '2019-09-22', 289, NULL),
('Cute Mountains Inn', 298, '2019-09-23', 333, NULL),
('Cute Mountains Inn', 298, '2019-09-24', 346, NULL),
('Cute Mountains Inn', 298, '2019-09-25', 192, NULL),
('Cute Mountains Inn', 298, '2019-09-26', 375, NULL),
('Cute Mountains Inn', 298, '2019-09-27', 202, NULL),
('Cute Mountains Inn', 298, '2019-09-28', 286, NULL),
('Cute Mountains Inn', 298, '2019-09-29', 234, NULL),
('Cute Mountains Inn', 298, '2019-09-30', 223, NULL),
('Cute Mountains Inn', 298, '2019-10-01', 333, NULL),
('Cute Mountains Inn', 298, '2019-10-02', 333, NULL),
('Cute Mountains Inn', 298, '2019-10-03', 290, NULL),
('Cute Mountains Inn', 298, '2019-10-04', 212, NULL),
('Cute Mountains Inn', 298, '2019-10-05', 123, NULL),
('Cute Mountains Inn', 298, '2019-10-06', 260, NULL),
('Cute Mountains Inn', 298, '2019-10-07', 391, NULL),
('Cute Mountains Inn', 298, '2019-10-08', 109, NULL),
('Cute Mountains Inn', 298, '2019-10-09', 246, NULL),
('Cute Mountains Inn', 298, '2019-10-10', 257, NULL),
('Cute Mountains Inn', 298, '2019-10-11', 176, NULL),
('Cute Mountains Inn', 298, '2019-10-12', 322, NULL),
('Cute Mountains Inn', 298, '2019-10-13', 379, NULL),
('Cute Mountains Inn', 298, '2019-10-14', 398, NULL),
('Cute Mountains Inn', 298, '2019-10-15', 390, NULL),
('Cute Mountains Inn', 298, '2019-10-16', 165, NULL),
('Cute Mountains Inn', 298, '2019-10-17', 302, NULL),
('Cute Mountains Inn', 298, '2019-10-18', 119, NULL),
('Cute Mountains Inn', 298, '2019-10-19', 272, NULL),
('Cute Mountains Inn', 298, '2019-10-20', 389, NULL),
('Cute Mountains Inn', 298, '2019-10-21', 179, NULL),
('Cute Mountains Inn', 298, '2019-10-22', 315, NULL),
('Cute Mountains Inn', 298, '2019-10-23', 263, NULL),
('Cute Mountains Inn', 298, '2019-10-24', 232, NULL),
('Cute Mountains Inn', 298, '2019-10-25', 374, NULL),
('Cute Mountains Inn', 298, '2019-10-26', 384, NULL),
('Cute Mountains Inn', 298, '2019-10-27', 286, NULL),
('Cute Mountains Inn', 298, '2019-10-28', 304, NULL),
('Cute Mountains Inn', 298, '2019-10-29', 322, NULL),
('Cute Mountains Inn', 298, '2019-10-30', 218, NULL),
('Cute Mountains Inn', 298, '2019-10-31', 232, NULL),
('Cute Mountains Inn', 298, '2019-11-01', 267, NULL),
('Cute Mountains Inn', 298, '2019-11-02', 236, NULL),
('Cute Mountains Inn', 298, '2019-11-03', 201, NULL),
('Cute Mountains Inn', 298, '2019-11-04', 277, NULL),
('Cute Mountains Inn', 298, '2019-11-05', 291, NULL),
('Cute Mountains Inn', 298, '2019-11-06', 333, NULL),
('Cute Mountains Inn', 298, '2019-11-07', 209, NULL),
('Cute Mountains Inn', 298, '2019-11-08', 221, NULL),
('Cute Mountains Inn', 298, '2019-11-09', 209, NULL),
('Cute Mountains Inn', 298, '2019-11-10', 383, NULL),
('Cute Mountains Inn', 298, '2019-11-11', 230, NULL),
('Cute Mountains Inn', 298, '2019-11-12', 247, NULL),
('Cute Mountains Inn', 298, '2019-11-13', 235, NULL),
('Cute Mountains Inn', 298, '2019-11-14', 162, NULL),
('Cute Mountains Inn', 298, '2019-11-15', 154, NULL),
('Cute Mountains Inn', 298, '2019-11-16', 253, NULL),
('Cute Mountains Inn', 298, '2019-11-17', 355, NULL),
('Cute Mountains Inn', 298, '2019-11-18', 261, NULL),
('Cute Mountains Inn', 298, '2019-11-19', 187, NULL),
('Cute Mountains Inn', 298, '2019-11-20', 266, NULL),
('Cute Mountains Inn', 298, '2019-11-21', 273, NULL),
('Cute Mountains Inn', 298, '2019-11-22', 261, NULL),
('Cute Mountains Inn', 298, '2019-11-23', 309, NULL),
('Cute Mountains Inn', 298, '2019-11-24', 151, NULL),
('Cute Mountains Inn', 298, '2019-11-25', 212, NULL),
('Cute Mountains Inn', 298, '2019-11-26', 241, NULL),
('Cute Mountains Inn', 298, '2019-11-27', 380, NULL),
('Cute Mountains Inn', 298, '2019-11-28', 297, NULL),
('Cute Mountains Inn', 298, '2019-11-29', 292, NULL),
('Cute Mountains Inn', 298, '2019-11-30', 259, NULL),
('Cute Mountains Inn', 298, '2019-12-01', 181, NULL),
('Cute Mountains Inn', 298, '2019-12-02', 358, NULL),
('Cute Mountains Inn', 298, '2019-12-03', 367, NULL),
('Cute Mountains Inn', 298, '2019-12-04', 343, NULL),
('Cute Mountains Inn', 298, '2019-12-05', 342, NULL),
('Cute Mountains Inn', 298, '2019-12-06', 288, NULL),
('Cute Mountains Inn', 298, '2019-12-07', 172, NULL),
('Cute Mountains Inn', 298, '2019-12-08', 121, NULL),
('Cute Mountains Inn', 298, '2019-12-09', 260, NULL),
('Cute Mountains Inn', 298, '2019-12-10', 247, NULL),
('Cute Mountains Inn', 298, '2019-12-11', 371, NULL),
('Cute Mountains Inn', 298, '2019-12-12', 118, NULL),
('Cute Mountains Inn', 298, '2019-12-13', 339, NULL),
('Cute Mountains Inn', 298, '2019-12-14', 335, NULL),
('Cute Mountains Inn', 298, '2019-12-15', 108, NULL),
('Cute Mountains Inn', 298, '2019-12-16', 281, NULL),
('Cute Mountains Inn', 298, '2019-12-17', 295, NULL),
('Cute Mountains Inn', 298, '2019-12-18', 165, NULL),
('Cute Mountains Inn', 298, '2019-12-19', 188, NULL),
('Cute Mountains Inn', 298, '2019-12-20', 352, NULL),
('Cute Mountains Inn', 298, '2019-12-21', 328, NULL),
('Cute Mountains Inn', 298, '2019-12-22', 117, NULL),
('Cute Mountains Inn', 298, '2019-12-23', 359, NULL),
('Cute Mountains Inn', 298, '2019-12-24', 289, NULL),
('Cute Mountains Inn', 298, '2019-12-25', 183, NULL),
('Cute Mountains Inn', 298, '2019-12-26', 207, NULL),
('Cute Mountains Inn', 298, '2019-12-27', 194, NULL),
('Cute Mountains Inn', 298, '2019-12-28', 353, NULL),
('Cute Mountains Inn', 298, '2019-12-29', 268, NULL),
('Cute Mountains Inn', 298, '2019-12-30', 383, NULL),
('Cute Mountains Inn', 298, '2019-12-31', 226, NULL),
('Cute Mountains Inn', 298, '2020-01-01', 314, NULL),
('Cute Mountains Inn', 298, '2020-01-02', 322, NULL),
('Cute Mountains Inn', 298, '2020-01-03', 139, NULL),
('Cute Mountains Inn', 298, '2020-01-04', 135, NULL),
('Cute Mountains Inn', 298, '2020-01-05', 383, NULL),
('Cute Mountains Inn', 298, '2020-01-06', 397, NULL),
('Cute Mountains Inn', 298, '2020-01-07', 387, NULL),
('Cute Mountains Inn', 298, '2020-01-08', 321, NULL),
('Cute Mountains Inn', 298, '2020-01-09', 277, NULL),
('Cute Mountains Inn', 298, '2020-01-10', 262, NULL),
('Cute Mountains Inn', 298, '2020-01-11', 346, NULL),
('Cute Mountains Inn', 298, '2020-01-12', 107, NULL),
('Cute Mountains Inn', 298, '2020-01-13', 389, NULL),
('Cute Mountains Inn', 298, '2020-01-14', 340, NULL),
('Cute Mountains Inn', 298, '2020-01-15', 106, NULL),
('Cute Mountains Inn', 298, '2020-01-16', 374, NULL),
('Cute Mountains Inn', 298, '2020-01-17', 340, NULL),
('Cute Mountains Inn', 298, '2020-01-18', 300, NULL),
('Cute Mountains Inn', 298, '2020-01-19', 363, NULL),
('Cute Mountains Inn', 298, '2020-01-20', 148, NULL),
('Cute Mountains Inn', 298, '2020-01-21', 258, NULL),
('Cute Mountains Inn', 298, '2020-01-22', 247, NULL),
('Cute Mountains Inn', 298, '2020-01-23', 243, NULL),
('Cute Mountains Inn', 298, '2020-01-24', 239, NULL),
('Cute Mountains Inn', 298, '2020-01-25', 206, NULL),
('Cute Mountains Inn', 298, '2020-01-26', 316, NULL),
('Cute Mountains Inn', 298, '2020-01-27', 125, NULL),
('Cute Mountains Inn', 298, '2020-01-28', 211, NULL),
('Cute Mountains Inn', 298, '2020-01-29', 275, NULL),
('Cute Mountains Inn', 298, '2020-01-30', 125, NULL),
('Cute Mountains Inn', 298, '2020-01-31', 111, NULL),
('Cute Mountains Inn', 298, '2020-02-01', 264, NULL),
('Cute Mountains Inn', 298, '2020-02-02', 339, NULL),
('Cute Mountains Inn', 298, '2020-02-03', 394, NULL),
('Cute Mountains Inn', 298, '2020-02-04', 196, NULL),
('Cute Mountains Inn', 299, '2019-01-01', 359, NULL),
('Cute Mountains Inn', 299, '2019-01-02', 379, NULL),
('Cute Mountains Inn', 299, '2019-01-03', 265, NULL),
('Cute Mountains Inn', 299, '2019-01-04', 342, NULL),
('Cute Mountains Inn', 299, '2019-01-05', 249, NULL),
('Cute Mountains Inn', 299, '2019-01-06', 326, NULL),
('Cute Mountains Inn', 299, '2019-01-07', 318, NULL),
('Cute Mountains Inn', 299, '2019-01-08', 399, NULL),
('Cute Mountains Inn', 299, '2019-01-09', 204, NULL),
('Cute Mountains Inn', 299, '2019-01-10', 363, NULL),
('Cute Mountains Inn', 299, '2019-01-11', 145, NULL),
('Cute Mountains Inn', 299, '2019-01-12', 300, NULL),
('Cute Mountains Inn', 299, '2019-01-13', 348, NULL),
('Cute Mountains Inn', 299, '2019-01-14', 387, NULL),
('Cute Mountains Inn', 299, '2019-01-15', 153, NULL),
('Cute Mountains Inn', 299, '2019-01-16', 113, NULL),
('Cute Mountains Inn', 299, '2019-01-17', 110, NULL),
('Cute Mountains Inn', 299, '2019-01-18', 255, NULL),
('Cute Mountains Inn', 299, '2019-01-19', 315, NULL),
('Cute Mountains Inn', 299, '2019-01-20', 337, NULL),
('Cute Mountains Inn', 299, '2019-01-21', 246, NULL),
('Cute Mountains Inn', 299, '2019-01-22', 124, NULL),
('Cute Mountains Inn', 299, '2019-01-23', 279, NULL),
('Cute Mountains Inn', 299, '2019-01-24', 283, NULL),
('Cute Mountains Inn', 299, '2019-01-25', 237, NULL),
('Cute Mountains Inn', 299, '2019-01-26', 163, NULL),
('Cute Mountains Inn', 299, '2019-01-27', 292, NULL),
('Cute Mountains Inn', 299, '2019-01-28', 192, NULL),
('Cute Mountains Inn', 299, '2019-01-29', 164, NULL),
('Cute Mountains Inn', 299, '2019-01-30', 137, NULL),
('Cute Mountains Inn', 299, '2019-01-31', 329, NULL),
('Cute Mountains Inn', 299, '2019-02-01', 229, NULL),
('Cute Mountains Inn', 299, '2019-02-02', 196, NULL),
('Cute Mountains Inn', 299, '2019-02-03', 274, NULL),
('Cute Mountains Inn', 299, '2019-02-04', 382, NULL),
('Cute Mountains Inn', 299, '2019-02-05', 336, NULL),
('Cute Mountains Inn', 299, '2019-02-06', 100, NULL),
('Cute Mountains Inn', 299, '2019-02-07', 124, NULL),
('Cute Mountains Inn', 299, '2019-02-08', 120, NULL),
('Cute Mountains Inn', 299, '2019-02-09', 293, NULL),
('Cute Mountains Inn', 299, '2019-02-10', 215, NULL),
('Cute Mountains Inn', 299, '2019-02-11', 196, NULL),
('Cute Mountains Inn', 299, '2019-02-12', 364, NULL),
('Cute Mountains Inn', 299, '2019-02-13', 163, NULL),
('Cute Mountains Inn', 299, '2019-02-14', 363, NULL),
('Cute Mountains Inn', 299, '2019-02-15', 211, NULL),
('Cute Mountains Inn', 299, '2019-02-16', 391, NULL),
('Cute Mountains Inn', 299, '2019-02-17', 166, NULL),
('Cute Mountains Inn', 299, '2019-02-18', 235, NULL),
('Cute Mountains Inn', 299, '2019-02-19', 314, NULL),
('Cute Mountains Inn', 299, '2019-02-20', 315, NULL),
('Cute Mountains Inn', 299, '2019-02-21', 181, NULL),
('Cute Mountains Inn', 299, '2019-02-22', 127, NULL),
('Cute Mountains Inn', 299, '2019-02-23', 190, NULL),
('Cute Mountains Inn', 299, '2019-02-24', 105, NULL),
('Cute Mountains Inn', 299, '2019-02-25', 359, NULL),
('Cute Mountains Inn', 299, '2019-02-26', 274, NULL),
('Cute Mountains Inn', 299, '2019-02-27', 340, NULL),
('Cute Mountains Inn', 299, '2019-02-28', 342, NULL),
('Cute Mountains Inn', 299, '2019-03-01', 209, NULL),
('Cute Mountains Inn', 299, '2019-03-02', 205, NULL),
('Cute Mountains Inn', 299, '2019-03-03', 275, NULL),
('Cute Mountains Inn', 299, '2019-03-04', 299, NULL),
('Cute Mountains Inn', 299, '2019-03-05', 381, NULL),
('Cute Mountains Inn', 299, '2019-03-06', 377, NULL),
('Cute Mountains Inn', 299, '2019-03-07', 351, NULL),
('Cute Mountains Inn', 299, '2019-03-08', 277, NULL),
('Cute Mountains Inn', 299, '2019-03-09', 378, NULL),
('Cute Mountains Inn', 299, '2019-03-10', 162, NULL),
('Cute Mountains Inn', 299, '2019-03-11', 255, NULL),
('Cute Mountains Inn', 299, '2019-03-12', 368, NULL),
('Cute Mountains Inn', 299, '2019-03-13', 307, NULL),
('Cute Mountains Inn', 299, '2019-03-14', 327, NULL),
('Cute Mountains Inn', 299, '2019-03-15', 372, NULL),
('Cute Mountains Inn', 299, '2019-03-16', 154, NULL),
('Cute Mountains Inn', 299, '2019-03-17', 276, NULL),
('Cute Mountains Inn', 299, '2019-03-18', 291, NULL),
('Cute Mountains Inn', 299, '2019-03-19', 340, NULL),
('Cute Mountains Inn', 299, '2019-03-20', 235, NULL),
('Cute Mountains Inn', 299, '2019-03-21', 217, NULL),
('Cute Mountains Inn', 299, '2019-03-22', 206, NULL),
('Cute Mountains Inn', 299, '2019-03-23', 122, NULL),
('Cute Mountains Inn', 299, '2019-03-24', 253, NULL),
('Cute Mountains Inn', 299, '2019-03-25', 175, NULL),
('Cute Mountains Inn', 299, '2019-03-26', 286, NULL),
('Cute Mountains Inn', 299, '2019-03-27', 282, NULL),
('Cute Mountains Inn', 299, '2019-03-28', 285, NULL),
('Cute Mountains Inn', 299, '2019-03-29', 306, NULL),
('Cute Mountains Inn', 299, '2019-03-30', 341, NULL),
('Cute Mountains Inn', 299, '2019-03-31', 281, NULL),
('Cute Mountains Inn', 299, '2019-04-01', 122, NULL),
('Cute Mountains Inn', 299, '2019-04-02', 158, NULL),
('Cute Mountains Inn', 299, '2019-04-03', 260, NULL),
('Cute Mountains Inn', 299, '2019-04-04', 396, NULL),
('Cute Mountains Inn', 299, '2019-04-05', 256, NULL),
('Cute Mountains Inn', 299, '2019-04-06', 210, NULL),
('Cute Mountains Inn', 299, '2019-04-07', 246, NULL),
('Cute Mountains Inn', 299, '2019-04-08', 112, NULL),
('Cute Mountains Inn', 299, '2019-04-09', 193, NULL),
('Cute Mountains Inn', 299, '2019-04-10', 261, NULL),
('Cute Mountains Inn', 299, '2019-04-11', 239, NULL),
('Cute Mountains Inn', 299, '2019-04-12', 309, NULL),
('Cute Mountains Inn', 299, '2019-04-13', 362, NULL),
('Cute Mountains Inn', 299, '2019-04-14', 334, NULL),
('Cute Mountains Inn', 299, '2019-04-15', 315, NULL),
('Cute Mountains Inn', 299, '2019-04-16', 127, NULL),
('Cute Mountains Inn', 299, '2019-04-17', 283, NULL),
('Cute Mountains Inn', 299, '2019-04-18', 286, NULL),
('Cute Mountains Inn', 299, '2019-04-19', 259, NULL),
('Cute Mountains Inn', 299, '2019-04-20', 219, NULL),
('Cute Mountains Inn', 299, '2019-04-21', 207, NULL),
('Cute Mountains Inn', 299, '2019-04-22', 148, NULL),
('Cute Mountains Inn', 299, '2019-04-23', 174, NULL),
('Cute Mountains Inn', 299, '2019-04-24', 385, NULL),
('Cute Mountains Inn', 299, '2019-04-25', 399, NULL),
('Cute Mountains Inn', 299, '2019-04-26', 121, NULL),
('Cute Mountains Inn', 299, '2019-04-27', 323, NULL),
('Cute Mountains Inn', 299, '2019-04-28', 179, NULL),
('Cute Mountains Inn', 299, '2019-04-29', 163, NULL),
('Cute Mountains Inn', 299, '2019-04-30', 219, NULL),
('Cute Mountains Inn', 299, '2019-05-01', 392, NULL),
('Cute Mountains Inn', 299, '2019-05-02', 369, NULL),
('Cute Mountains Inn', 299, '2019-05-03', 368, NULL),
('Cute Mountains Inn', 299, '2019-05-04', 125, NULL),
('Cute Mountains Inn', 299, '2019-05-05', 229, NULL),
('Cute Mountains Inn', 299, '2019-05-06', 173, NULL),
('Cute Mountains Inn', 299, '2019-05-07', 232, NULL),
('Cute Mountains Inn', 299, '2019-05-08', 347, NULL),
('Cute Mountains Inn', 299, '2019-05-09', 395, NULL),
('Cute Mountains Inn', 299, '2019-05-10', 174, NULL),
('Cute Mountains Inn', 299, '2019-05-11', 172, NULL),
('Cute Mountains Inn', 299, '2019-05-12', 369, NULL),
('Cute Mountains Inn', 299, '2019-05-13', 105, NULL),
('Cute Mountains Inn', 299, '2019-05-14', 230, NULL),
('Cute Mountains Inn', 299, '2019-05-15', 198, NULL),
('Cute Mountains Inn', 299, '2019-05-16', 352, NULL),
('Cute Mountains Inn', 299, '2019-05-17', 171, NULL),
('Cute Mountains Inn', 299, '2019-05-18', 368, NULL),
('Cute Mountains Inn', 299, '2019-05-19', 140, NULL),
('Cute Mountains Inn', 299, '2019-05-20', 149, NULL),
('Cute Mountains Inn', 299, '2019-05-21', 390, NULL),
('Cute Mountains Inn', 299, '2019-05-22', 290, NULL),
('Cute Mountains Inn', 299, '2019-05-23', 394, NULL),
('Cute Mountains Inn', 299, '2019-05-24', 123, NULL),
('Cute Mountains Inn', 299, '2019-05-25', 225, NULL),
('Cute Mountains Inn', 299, '2019-05-26', 205, NULL),
('Cute Mountains Inn', 299, '2019-05-27', 301, NULL),
('Cute Mountains Inn', 299, '2019-05-28', 151, NULL),
('Cute Mountains Inn', 299, '2019-05-29', 218, NULL),
('Cute Mountains Inn', 299, '2019-05-30', 224, NULL),
('Cute Mountains Inn', 299, '2019-05-31', 260, NULL),
('Cute Mountains Inn', 299, '2019-06-01', 352, NULL),
('Cute Mountains Inn', 299, '2019-06-02', 284, NULL),
('Cute Mountains Inn', 299, '2019-06-03', 186, NULL),
('Cute Mountains Inn', 299, '2019-06-04', 137, NULL),
('Cute Mountains Inn', 299, '2019-06-05', 358, NULL),
('Cute Mountains Inn', 299, '2019-06-06', 342, NULL),
('Cute Mountains Inn', 299, '2019-06-07', 186, NULL),
('Cute Mountains Inn', 299, '2019-06-08', 221, NULL),
('Cute Mountains Inn', 299, '2019-06-09', 146, NULL),
('Cute Mountains Inn', 299, '2019-06-10', 273, NULL),
('Cute Mountains Inn', 299, '2019-06-11', 138, NULL),
('Cute Mountains Inn', 299, '2019-06-12', 156, NULL),
('Cute Mountains Inn', 299, '2019-06-13', 307, NULL),
('Cute Mountains Inn', 299, '2019-06-14', 108, NULL),
('Cute Mountains Inn', 299, '2019-06-15', 213, NULL),
('Cute Mountains Inn', 299, '2019-06-16', 262, NULL),
('Cute Mountains Inn', 299, '2019-06-17', 381, NULL),
('Cute Mountains Inn', 299, '2019-06-18', 193, NULL),
('Cute Mountains Inn', 299, '2019-06-19', 158, NULL),
('Cute Mountains Inn', 299, '2019-06-20', 172, NULL),
('Cute Mountains Inn', 299, '2019-06-21', 365, NULL),
('Cute Mountains Inn', 299, '2019-06-22', 250, NULL),
('Cute Mountains Inn', 299, '2019-06-23', 389, NULL),
('Cute Mountains Inn', 299, '2019-06-24', 365, NULL),
('Cute Mountains Inn', 299, '2019-06-25', 268, NULL),
('Cute Mountains Inn', 299, '2019-06-26', 379, NULL),
('Cute Mountains Inn', 299, '2019-06-27', 211, NULL),
('Cute Mountains Inn', 299, '2019-06-28', 367, NULL),
('Cute Mountains Inn', 299, '2019-06-29', 349, NULL),
('Cute Mountains Inn', 299, '2019-06-30', 330, NULL),
('Cute Mountains Inn', 299, '2019-07-01', 101, NULL),
('Cute Mountains Inn', 299, '2019-07-02', 167, NULL),
('Cute Mountains Inn', 299, '2019-07-03', 111, NULL),
('Cute Mountains Inn', 299, '2019-07-04', 157, NULL),
('Cute Mountains Inn', 299, '2019-07-05', 345, NULL),
('Cute Mountains Inn', 299, '2019-07-06', 262, NULL),
('Cute Mountains Inn', 299, '2019-07-07', 265, NULL),
('Cute Mountains Inn', 299, '2019-07-08', 336, NULL),
('Cute Mountains Inn', 299, '2019-07-09', 302, NULL),
('Cute Mountains Inn', 299, '2019-07-10', 299, NULL),
('Cute Mountains Inn', 299, '2019-07-11', 334, NULL),
('Cute Mountains Inn', 299, '2019-07-12', 251, NULL),
('Cute Mountains Inn', 299, '2019-07-13', 267, NULL),
('Cute Mountains Inn', 299, '2019-07-14', 228, NULL),
('Cute Mountains Inn', 299, '2019-07-15', 201, NULL),
('Cute Mountains Inn', 299, '2019-07-16', 253, NULL),
('Cute Mountains Inn', 299, '2019-07-17', 382, NULL),
('Cute Mountains Inn', 299, '2019-07-18', 285, NULL),
('Cute Mountains Inn', 299, '2019-07-19', 135, NULL),
('Cute Mountains Inn', 299, '2019-07-20', 133, NULL),
('Cute Mountains Inn', 299, '2019-07-21', 320, NULL),
('Cute Mountains Inn', 299, '2019-07-22', 359, NULL),
('Cute Mountains Inn', 299, '2019-07-23', 220, NULL),
('Cute Mountains Inn', 299, '2019-07-24', 382, NULL),
('Cute Mountains Inn', 299, '2019-07-25', 147, NULL),
('Cute Mountains Inn', 299, '2019-07-26', 183, NULL),
('Cute Mountains Inn', 299, '2019-07-27', 279, NULL),
('Cute Mountains Inn', 299, '2019-07-28', 104, NULL),
('Cute Mountains Inn', 299, '2019-07-29', 376, NULL),
('Cute Mountains Inn', 299, '2019-07-30', 372, NULL),
('Cute Mountains Inn', 299, '2019-07-31', 381, NULL),
('Cute Mountains Inn', 299, '2019-08-01', 154, NULL),
('Cute Mountains Inn', 299, '2019-08-02', 108, NULL),
('Cute Mountains Inn', 299, '2019-08-03', 144, NULL),
('Cute Mountains Inn', 299, '2019-08-04', 283, NULL),
('Cute Mountains Inn', 299, '2019-08-05', 302, NULL),
('Cute Mountains Inn', 299, '2019-08-06', 111, NULL),
('Cute Mountains Inn', 299, '2019-08-07', 382, NULL),
('Cute Mountains Inn', 299, '2019-08-08', 190, NULL),
('Cute Mountains Inn', 299, '2019-08-09', 240, NULL),
('Cute Mountains Inn', 299, '2019-08-10', 339, NULL),
('Cute Mountains Inn', 299, '2019-08-11', 297, NULL),
('Cute Mountains Inn', 299, '2019-08-12', 152, NULL),
('Cute Mountains Inn', 299, '2019-08-13', 382, NULL),
('Cute Mountains Inn', 299, '2019-08-14', 315, NULL),
('Cute Mountains Inn', 299, '2019-08-15', 121, NULL),
('Cute Mountains Inn', 299, '2019-08-16', 306, NULL),
('Cute Mountains Inn', 299, '2019-08-17', 116, NULL),
('Cute Mountains Inn', 299, '2019-08-18', 252, NULL),
('Cute Mountains Inn', 299, '2019-08-19', 114, NULL),
('Cute Mountains Inn', 299, '2019-08-20', 266, NULL),
('Cute Mountains Inn', 299, '2019-08-21', 371, NULL),
('Cute Mountains Inn', 299, '2019-08-22', 396, NULL),
('Cute Mountains Inn', 299, '2019-08-23', 372, NULL),
('Cute Mountains Inn', 299, '2019-08-24', 301, NULL),
('Cute Mountains Inn', 299, '2019-08-25', 231, NULL),
('Cute Mountains Inn', 299, '2019-08-26', 279, NULL),
('Cute Mountains Inn', 299, '2019-08-27', 119, NULL),
('Cute Mountains Inn', 299, '2019-08-28', 187, NULL),
('Cute Mountains Inn', 299, '2019-08-29', 249, NULL),
('Cute Mountains Inn', 299, '2019-08-30', 271, NULL),
('Cute Mountains Inn', 299, '2019-08-31', 224, NULL),
('Cute Mountains Inn', 299, '2019-09-01', 201, NULL),
('Cute Mountains Inn', 299, '2019-09-02', 333, NULL),
('Cute Mountains Inn', 299, '2019-09-03', 352, NULL),
('Cute Mountains Inn', 299, '2019-09-04', 179, NULL),
('Cute Mountains Inn', 299, '2019-09-05', 161, NULL),
('Cute Mountains Inn', 299, '2019-09-06', 377, NULL),
('Cute Mountains Inn', 299, '2019-09-07', 150, NULL),
('Cute Mountains Inn', 299, '2019-09-08', 151, NULL),
('Cute Mountains Inn', 299, '2019-09-09', 350, NULL),
('Cute Mountains Inn', 299, '2019-09-10', 342, NULL),
('Cute Mountains Inn', 299, '2019-09-11', 246, NULL),
('Cute Mountains Inn', 299, '2019-09-12', 224, NULL),
('Cute Mountains Inn', 299, '2019-09-13', 122, NULL),
('Cute Mountains Inn', 299, '2019-09-14', 310, NULL),
('Cute Mountains Inn', 299, '2019-09-15', 301, NULL),
('Cute Mountains Inn', 299, '2019-09-16', 145, NULL),
('Cute Mountains Inn', 299, '2019-09-17', 297, NULL),
('Cute Mountains Inn', 299, '2019-09-18', 177, NULL),
('Cute Mountains Inn', 299, '2019-09-19', 213, NULL),
('Cute Mountains Inn', 299, '2019-09-20', 163, NULL),
('Cute Mountains Inn', 299, '2019-09-21', 285, NULL),
('Cute Mountains Inn', 299, '2019-09-22', 311, NULL),
('Cute Mountains Inn', 299, '2019-09-23', 144, NULL),
('Cute Mountains Inn', 299, '2019-09-24', 129, NULL),
('Cute Mountains Inn', 299, '2019-09-25', 264, NULL),
('Cute Mountains Inn', 299, '2019-09-26', 252, NULL),
('Cute Mountains Inn', 299, '2019-09-27', 172, NULL),
('Cute Mountains Inn', 299, '2019-09-28', 135, NULL),
('Cute Mountains Inn', 299, '2019-09-29', 304, NULL),
('Cute Mountains Inn', 299, '2019-09-30', 159, NULL),
('Cute Mountains Inn', 299, '2019-10-01', 303, NULL),
('Cute Mountains Inn', 299, '2019-10-02', 339, NULL),
('Cute Mountains Inn', 299, '2019-10-03', 183, NULL),
('Cute Mountains Inn', 299, '2019-10-04', 270, NULL),
('Cute Mountains Inn', 299, '2019-10-05', 194, NULL),
('Cute Mountains Inn', 299, '2019-10-06', 274, NULL),
('Cute Mountains Inn', 299, '2019-10-07', 307, NULL),
('Cute Mountains Inn', 299, '2019-10-08', 240, NULL),
('Cute Mountains Inn', 299, '2019-10-09', 208, NULL),
('Cute Mountains Inn', 299, '2019-10-10', 364, NULL),
('Cute Mountains Inn', 299, '2019-10-11', 107, NULL),
('Cute Mountains Inn', 299, '2019-10-12', 362, NULL),
('Cute Mountains Inn', 299, '2019-10-13', 383, NULL),
('Cute Mountains Inn', 299, '2019-10-14', 154, NULL),
('Cute Mountains Inn', 299, '2019-10-15', 228, NULL),
('Cute Mountains Inn', 299, '2019-10-16', 103, NULL),
('Cute Mountains Inn', 299, '2019-10-17', 246, NULL),
('Cute Mountains Inn', 299, '2019-10-18', 399, NULL),
('Cute Mountains Inn', 299, '2019-10-19', 132, NULL),
('Cute Mountains Inn', 299, '2019-10-20', 280, NULL),
('Cute Mountains Inn', 299, '2019-10-21', 337, NULL),
('Cute Mountains Inn', 299, '2019-10-22', 110, NULL),
('Cute Mountains Inn', 299, '2019-10-23', 157, NULL),
('Cute Mountains Inn', 299, '2019-10-24', 186, NULL),
('Cute Mountains Inn', 299, '2019-10-25', 328, NULL),
('Cute Mountains Inn', 299, '2019-10-26', 355, NULL),
('Cute Mountains Inn', 299, '2019-10-27', 276, NULL),
('Cute Mountains Inn', 299, '2019-10-28', 119, NULL),
('Cute Mountains Inn', 299, '2019-10-29', 384, NULL),
('Cute Mountains Inn', 299, '2019-10-30', 184, NULL),
('Cute Mountains Inn', 299, '2019-10-31', 106, NULL),
('Cute Mountains Inn', 299, '2019-11-01', 193, NULL),
('Cute Mountains Inn', 299, '2019-11-02', 331, NULL),
('Cute Mountains Inn', 299, '2019-11-03', 195, NULL),
('Cute Mountains Inn', 299, '2019-11-04', 208, NULL),
('Cute Mountains Inn', 299, '2019-11-05', 240, NULL),
('Cute Mountains Inn', 299, '2019-11-06', 361, NULL),
('Cute Mountains Inn', 299, '2019-11-07', 267, NULL),
('Cute Mountains Inn', 299, '2019-11-08', 368, NULL),
('Cute Mountains Inn', 299, '2019-11-09', 332, NULL),
('Cute Mountains Inn', 299, '2019-11-10', 112, NULL),
('Cute Mountains Inn', 299, '2019-11-11', 145, NULL),
('Cute Mountains Inn', 299, '2019-11-12', 359, NULL),
('Cute Mountains Inn', 299, '2019-11-13', 313, NULL),
('Cute Mountains Inn', 299, '2019-11-14', 267, NULL),
('Cute Mountains Inn', 299, '2019-11-15', 381, NULL),
('Cute Mountains Inn', 299, '2019-11-16', 327, NULL),
('Cute Mountains Inn', 299, '2019-11-17', 241, NULL),
('Cute Mountains Inn', 299, '2019-11-18', 144, NULL),
('Cute Mountains Inn', 299, '2019-11-19', 247, NULL),
('Cute Mountains Inn', 299, '2019-11-20', 280, NULL),
('Cute Mountains Inn', 299, '2019-11-21', 328, NULL),
('Cute Mountains Inn', 299, '2019-11-22', 238, NULL),
('Cute Mountains Inn', 299, '2019-11-23', 305, NULL),
('Cute Mountains Inn', 299, '2019-11-24', 113, NULL),
('Cute Mountains Inn', 299, '2019-11-25', 286, NULL),
('Cute Mountains Inn', 299, '2019-11-26', 266, NULL),
('Cute Mountains Inn', 299, '2019-11-27', 399, NULL),
('Cute Mountains Inn', 299, '2019-11-28', 250, NULL),
('Cute Mountains Inn', 299, '2019-11-29', 273, NULL),
('Cute Mountains Inn', 299, '2019-11-30', 326, NULL),
('Cute Mountains Inn', 299, '2019-12-01', 335, NULL),
('Cute Mountains Inn', 299, '2019-12-02', 388, NULL),
('Cute Mountains Inn', 299, '2019-12-03', 131, NULL),
('Cute Mountains Inn', 299, '2019-12-04', 352, NULL),
('Cute Mountains Inn', 299, '2019-12-05', 113, NULL),
('Cute Mountains Inn', 299, '2019-12-06', 342, NULL),
('Cute Mountains Inn', 299, '2019-12-07', 232, NULL),
('Cute Mountains Inn', 299, '2019-12-08', 157, NULL),
('Cute Mountains Inn', 299, '2019-12-09', 254, NULL),
('Cute Mountains Inn', 299, '2019-12-10', 248, NULL),
('Cute Mountains Inn', 299, '2019-12-11', 341, NULL),
('Cute Mountains Inn', 299, '2019-12-12', 240, NULL),
('Cute Mountains Inn', 299, '2019-12-13', 312, NULL),
('Cute Mountains Inn', 299, '2019-12-14', 300, NULL),
('Cute Mountains Inn', 299, '2019-12-15', 153, NULL),
('Cute Mountains Inn', 299, '2019-12-16', 109, NULL),
('Cute Mountains Inn', 299, '2019-12-17', 329, NULL),
('Cute Mountains Inn', 299, '2019-12-18', 156, NULL),
('Cute Mountains Inn', 299, '2019-12-19', 149, NULL),
('Cute Mountains Inn', 299, '2019-12-20', 245, NULL),
('Cute Mountains Inn', 299, '2019-12-21', 111, NULL),
('Cute Mountains Inn', 299, '2019-12-22', 397, NULL),
('Cute Mountains Inn', 299, '2019-12-23', 118, NULL),
('Cute Mountains Inn', 299, '2019-12-24', 354, NULL),
('Cute Mountains Inn', 299, '2019-12-25', 250, NULL),
('Cute Mountains Inn', 299, '2019-12-26', 371, NULL),
('Cute Mountains Inn', 299, '2019-12-27', 282, NULL),
('Cute Mountains Inn', 299, '2019-12-28', 278, NULL),
('Cute Mountains Inn', 299, '2019-12-29', 334, NULL),
('Cute Mountains Inn', 299, '2019-12-30', 176, NULL),
('Cute Mountains Inn', 299, '2019-12-31', 133, NULL),
('Cute Mountains Inn', 299, '2020-01-01', 196, NULL),
('Cute Mountains Inn', 299, '2020-01-02', 168, NULL),
('Cute Mountains Inn', 299, '2020-01-03', 258, NULL),
('Cute Mountains Inn', 299, '2020-01-04', 147, NULL),
('Cute Mountains Inn', 299, '2020-01-05', 276, NULL),
('Cute Mountains Inn', 299, '2020-01-06', 260, NULL),
('Cute Mountains Inn', 299, '2020-01-07', 161, NULL),
('Cute Mountains Inn', 299, '2020-01-08', 168, NULL),
('Cute Mountains Inn', 299, '2020-01-09', 284, NULL),
('Cute Mountains Inn', 299, '2020-01-10', 230, NULL),
('Cute Mountains Inn', 299, '2020-01-11', 345, NULL),
('Cute Mountains Inn', 299, '2020-01-12', 115, NULL),
('Cute Mountains Inn', 299, '2020-01-13', 362, NULL),
('Cute Mountains Inn', 299, '2020-01-14', 350, NULL),
('Cute Mountains Inn', 299, '2020-01-15', 149, NULL),
('Cute Mountains Inn', 299, '2020-01-16', 122, NULL),
('Cute Mountains Inn', 299, '2020-01-17', 268, NULL),
('Cute Mountains Inn', 299, '2020-01-18', 233, NULL),
('Cute Mountains Inn', 299, '2020-01-19', 266, NULL),
('Cute Mountains Inn', 299, '2020-01-20', 346, NULL),
('Cute Mountains Inn', 299, '2020-01-21', 276, NULL),
('Cute Mountains Inn', 299, '2020-01-22', 237, NULL),
('Cute Mountains Inn', 299, '2020-01-23', 149, NULL),
('Cute Mountains Inn', 299, '2020-01-24', 240, NULL),
('Cute Mountains Inn', 299, '2020-01-25', 346, NULL),
('Cute Mountains Inn', 299, '2020-01-26', 312, NULL),
('Cute Mountains Inn', 299, '2020-01-27', 377, NULL),
('Cute Mountains Inn', 299, '2020-01-28', 125, NULL),
('Cute Mountains Inn', 299, '2020-01-29', 204, NULL),
('Cute Mountains Inn', 299, '2020-01-30', 303, NULL),
('Cute Mountains Inn', 299, '2020-01-31', 301, NULL),
('Cute Mountains Inn', 299, '2020-02-01', 238, NULL),
('Cute Mountains Inn', 299, '2020-02-02', 396, NULL),
('Cute Mountains Inn', 299, '2020-02-03', 330, NULL),
('Cute Mountains Inn', 299, '2020-02-04', 126, NULL),
('Hampton Inn', 18, '2019-01-01', 377, NULL),
('Hampton Inn', 18, '2019-01-02', 390, NULL),
('Hampton Inn', 18, '2019-01-03', 145, NULL),
('Hampton Inn', 18, '2019-01-04', 357, NULL),
('Hampton Inn', 18, '2019-01-05', 263, NULL),
('Hampton Inn', 18, '2019-01-06', 235, NULL),
('Hampton Inn', 18, '2019-01-07', 223, NULL),
('Hampton Inn', 18, '2019-01-08', 243, NULL),
('Hampton Inn', 18, '2019-01-09', 291, NULL),
('Hampton Inn', 18, '2019-01-10', 210, NULL),
('Hampton Inn', 18, '2019-01-11', 277, NULL),
('Hampton Inn', 18, '2019-01-12', 197, NULL),
('Hampton Inn', 18, '2019-01-13', 217, NULL),
('Hampton Inn', 18, '2019-01-14', 175, NULL),
('Hampton Inn', 18, '2019-01-15', 380, NULL),
('Hampton Inn', 18, '2019-01-16', 117, NULL),
('Hampton Inn', 18, '2019-01-17', 345, NULL),
('Hampton Inn', 18, '2019-01-18', 357, NULL),
('Hampton Inn', 18, '2019-01-19', 175, NULL),
('Hampton Inn', 18, '2019-01-20', 162, NULL),
('Hampton Inn', 18, '2019-01-21', 380, NULL),
('Hampton Inn', 18, '2019-01-22', 226, NULL),
('Hampton Inn', 18, '2019-01-23', 161, NULL),
('Hampton Inn', 18, '2019-01-24', 236, NULL),
('Hampton Inn', 18, '2019-01-25', 159, NULL),
('Hampton Inn', 18, '2019-01-26', 108, NULL),
('Hampton Inn', 18, '2019-01-27', 366, NULL),
('Hampton Inn', 18, '2019-01-28', 119, NULL),
('Hampton Inn', 18, '2019-01-29', 365, NULL),
('Hampton Inn', 18, '2019-01-30', 123, NULL),
('Hampton Inn', 18, '2019-01-31', 271, NULL),
('Hampton Inn', 18, '2019-02-01', 167, NULL),
('Hampton Inn', 18, '2019-02-02', 103, NULL),
('Hampton Inn', 18, '2019-02-03', 382, NULL),
('Hampton Inn', 18, '2019-02-04', 361, NULL),
('Hampton Inn', 18, '2019-02-05', 265, 155),
('Hampton Inn', 18, '2019-02-06', 343, 155),
('Hampton Inn', 18, '2019-02-07', 398, 155),
('Hampton Inn', 18, '2019-02-08', 316, 155);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 18, '2019-02-09', 340, 155),
('Hampton Inn', 18, '2019-02-10', 366, 155),
('Hampton Inn', 18, '2019-02-11', 163, 155),
('Hampton Inn', 18, '2019-02-12', 280, 155),
('Hampton Inn', 18, '2019-02-13', 367, 155),
('Hampton Inn', 18, '2019-02-14', 168, 155),
('Hampton Inn', 18, '2019-02-15', 123, 155),
('Hampton Inn', 18, '2019-02-16', 115, 155),
('Hampton Inn', 18, '2019-02-17', 152, 155),
('Hampton Inn', 18, '2019-02-18', 196, 155),
('Hampton Inn', 18, '2019-02-19', 383, 155),
('Hampton Inn', 18, '2019-02-20', 229, 155),
('Hampton Inn', 18, '2019-02-21', 159, 155),
('Hampton Inn', 18, '2019-02-22', 235, 155),
('Hampton Inn', 18, '2019-02-23', 277, 155),
('Hampton Inn', 18, '2019-02-24', 222, 155),
('Hampton Inn', 18, '2019-02-25', 197, 155),
('Hampton Inn', 18, '2019-02-26', 385, 155),
('Hampton Inn', 18, '2019-02-27', 186, 155),
('Hampton Inn', 18, '2019-02-28', 243, NULL),
('Hampton Inn', 18, '2019-03-01', 386, NULL),
('Hampton Inn', 18, '2019-03-02', 228, NULL),
('Hampton Inn', 18, '2019-03-03', 121, 42),
('Hampton Inn', 18, '2019-03-04', 211, 42),
('Hampton Inn', 18, '2019-03-05', 341, 42),
('Hampton Inn', 18, '2019-03-06', 218, 42),
('Hampton Inn', 18, '2019-03-07', 148, 42),
('Hampton Inn', 18, '2019-03-08', 378, 42),
('Hampton Inn', 18, '2019-03-09', 221, 42),
('Hampton Inn', 18, '2019-03-10', 227, 42),
('Hampton Inn', 18, '2019-03-11', 341, 42),
('Hampton Inn', 18, '2019-03-12', 290, 42),
('Hampton Inn', 18, '2019-03-13', 277, 42),
('Hampton Inn', 18, '2019-03-14', 165, 42),
('Hampton Inn', 18, '2019-03-15', 397, 42),
('Hampton Inn', 18, '2019-03-16', 123, 42),
('Hampton Inn', 18, '2019-03-17', 278, NULL),
('Hampton Inn', 18, '2019-03-18', 329, NULL),
('Hampton Inn', 18, '2019-03-19', 102, NULL),
('Hampton Inn', 18, '2019-03-20', 230, NULL),
('Hampton Inn', 18, '2019-03-21', 131, NULL),
('Hampton Inn', 18, '2019-03-22', 259, NULL),
('Hampton Inn', 18, '2019-03-23', 297, NULL),
('Hampton Inn', 18, '2019-03-24', 329, NULL),
('Hampton Inn', 18, '2019-03-25', 111, NULL),
('Hampton Inn', 18, '2019-03-26', 388, NULL),
('Hampton Inn', 18, '2019-03-27', 338, NULL),
('Hampton Inn', 18, '2019-03-28', 135, NULL),
('Hampton Inn', 18, '2019-03-29', 293, NULL),
('Hampton Inn', 18, '2019-03-30', 202, NULL),
('Hampton Inn', 18, '2019-03-31', 266, NULL),
('Hampton Inn', 18, '2019-04-01', 109, NULL),
('Hampton Inn', 18, '2019-04-02', 392, NULL),
('Hampton Inn', 18, '2019-04-03', 270, NULL),
('Hampton Inn', 18, '2019-04-04', 313, NULL),
('Hampton Inn', 18, '2019-04-05', 304, NULL),
('Hampton Inn', 18, '2019-04-06', 283, NULL),
('Hampton Inn', 18, '2019-04-07', 295, NULL),
('Hampton Inn', 18, '2019-04-08', 359, 143),
('Hampton Inn', 18, '2019-04-09', 275, 143),
('Hampton Inn', 18, '2019-04-10', 250, 143),
('Hampton Inn', 18, '2019-04-11', 220, 143),
('Hampton Inn', 18, '2019-04-12', 387, 143),
('Hampton Inn', 18, '2019-04-13', 373, 143),
('Hampton Inn', 18, '2019-04-14', 186, 143),
('Hampton Inn', 18, '2019-04-15', 342, 143),
('Hampton Inn', 18, '2019-04-16', 398, 143),
('Hampton Inn', 18, '2019-04-17', 202, 143),
('Hampton Inn', 18, '2019-04-18', 347, 143),
('Hampton Inn', 18, '2019-04-19', 375, 143),
('Hampton Inn', 18, '2019-04-20', 301, 143),
('Hampton Inn', 18, '2019-04-21', 399, 143),
('Hampton Inn', 18, '2019-04-22', 377, 143),
('Hampton Inn', 18, '2019-04-23', 181, 143),
('Hampton Inn', 18, '2019-04-24', 164, 143),
('Hampton Inn', 18, '2019-04-25', 324, 143),
('Hampton Inn', 18, '2019-04-26', 227, 143),
('Hampton Inn', 18, '2019-04-27', 154, 143),
('Hampton Inn', 18, '2019-04-28', 323, 143),
('Hampton Inn', 18, '2019-04-29', 191, 143),
('Hampton Inn', 18, '2019-04-30', 254, NULL),
('Hampton Inn', 18, '2019-05-01', 324, NULL),
('Hampton Inn', 18, '2019-05-02', 162, NULL),
('Hampton Inn', 18, '2019-05-03', 303, NULL),
('Hampton Inn', 18, '2019-05-04', 259, NULL),
('Hampton Inn', 18, '2019-05-05', 275, NULL),
('Hampton Inn', 18, '2019-05-06', 278, NULL),
('Hampton Inn', 18, '2019-05-07', 371, NULL),
('Hampton Inn', 18, '2019-05-08', 323, NULL),
('Hampton Inn', 18, '2019-05-09', 150, NULL),
('Hampton Inn', 18, '2019-05-10', 264, NULL),
('Hampton Inn', 18, '2019-05-11', 205, NULL),
('Hampton Inn', 18, '2019-05-12', 204, NULL),
('Hampton Inn', 18, '2019-05-13', 215, NULL),
('Hampton Inn', 18, '2019-05-14', 157, NULL),
('Hampton Inn', 18, '2019-05-15', 200, NULL),
('Hampton Inn', 18, '2019-05-16', 288, NULL),
('Hampton Inn', 18, '2019-05-17', 346, NULL),
('Hampton Inn', 18, '2019-05-18', 345, NULL),
('Hampton Inn', 18, '2019-05-19', 349, NULL),
('Hampton Inn', 18, '2019-05-20', 188, 51),
('Hampton Inn', 18, '2019-05-21', 180, 51),
('Hampton Inn', 18, '2019-05-22', 183, 51),
('Hampton Inn', 18, '2019-05-23', 160, 51),
('Hampton Inn', 18, '2019-05-24', 325, 51),
('Hampton Inn', 18, '2019-05-25', 128, 51),
('Hampton Inn', 18, '2019-05-26', 292, 51),
('Hampton Inn', 18, '2019-05-27', 329, 51),
('Hampton Inn', 18, '2019-05-28', 299, 51),
('Hampton Inn', 18, '2019-05-29', 158, 51),
('Hampton Inn', 18, '2019-05-30', 332, 51),
('Hampton Inn', 18, '2019-05-31', 110, 51),
('Hampton Inn', 18, '2019-06-01', 135, 51),
('Hampton Inn', 18, '2019-06-02', 246, 51),
('Hampton Inn', 18, '2019-06-03', 346, 51),
('Hampton Inn', 18, '2019-06-04', 368, 51),
('Hampton Inn', 18, '2019-06-05', 101, 51),
('Hampton Inn', 18, '2019-06-06', 257, 51),
('Hampton Inn', 18, '2019-06-07', 385, NULL),
('Hampton Inn', 18, '2019-06-08', 216, NULL),
('Hampton Inn', 18, '2019-06-09', 248, NULL),
('Hampton Inn', 18, '2019-06-10', 323, NULL),
('Hampton Inn', 18, '2019-06-11', 179, NULL),
('Hampton Inn', 18, '2019-06-12', 197, 37),
('Hampton Inn', 18, '2019-06-13', 142, 37),
('Hampton Inn', 18, '2019-06-14', 210, 37),
('Hampton Inn', 18, '2019-06-15', 261, 37),
('Hampton Inn', 18, '2019-06-16', 223, 37),
('Hampton Inn', 18, '2019-06-17', 300, 37),
('Hampton Inn', 18, '2019-06-18', 206, 37),
('Hampton Inn', 18, '2019-06-19', 196, 37),
('Hampton Inn', 18, '2019-06-20', 299, 37),
('Hampton Inn', 18, '2019-06-21', 109, 37),
('Hampton Inn', 18, '2019-06-22', 120, 37),
('Hampton Inn', 18, '2019-06-23', 338, 37),
('Hampton Inn', 18, '2019-06-24', 364, 37),
('Hampton Inn', 18, '2019-06-25', 232, 37),
('Hampton Inn', 18, '2019-06-26', 114, 37),
('Hampton Inn', 18, '2019-06-27', 310, 37),
('Hampton Inn', 18, '2019-06-28', 181, 37),
('Hampton Inn', 18, '2019-06-29', 238, 37),
('Hampton Inn', 18, '2019-06-30', 385, 37),
('Hampton Inn', 18, '2019-07-01', 390, 37),
('Hampton Inn', 18, '2019-07-02', 317, 37),
('Hampton Inn', 18, '2019-07-03', 170, 37),
('Hampton Inn', 18, '2019-07-04', 143, 37),
('Hampton Inn', 18, '2019-07-05', 285, 37),
('Hampton Inn', 18, '2019-07-06', 142, 37),
('Hampton Inn', 18, '2019-07-07', 139, 37),
('Hampton Inn', 18, '2019-07-08', 190, 37),
('Hampton Inn', 18, '2019-07-09', 187, 37),
('Hampton Inn', 18, '2019-07-10', 322, NULL),
('Hampton Inn', 18, '2019-07-11', 389, NULL),
('Hampton Inn', 18, '2019-07-12', 398, 49),
('Hampton Inn', 18, '2019-07-13', 286, 49),
('Hampton Inn', 18, '2019-07-14', 369, 49),
('Hampton Inn', 18, '2019-07-15', 306, 49),
('Hampton Inn', 18, '2019-07-16', 230, 49),
('Hampton Inn', 18, '2019-07-17', 200, 49),
('Hampton Inn', 18, '2019-07-18', 208, 49),
('Hampton Inn', 18, '2019-07-19', 171, 49),
('Hampton Inn', 18, '2019-07-20', 197, 49),
('Hampton Inn', 18, '2019-07-21', 172, 49),
('Hampton Inn', 18, '2019-07-22', 260, 49),
('Hampton Inn', 18, '2019-07-23', 373, 49),
('Hampton Inn', 18, '2019-07-24', 265, 49),
('Hampton Inn', 18, '2019-07-25', 206, 49),
('Hampton Inn', 18, '2019-07-26', 169, 49),
('Hampton Inn', 18, '2019-07-27', 185, 49),
('Hampton Inn', 18, '2019-07-28', 102, NULL),
('Hampton Inn', 18, '2019-07-29', 273, NULL),
('Hampton Inn', 18, '2019-07-30', 388, NULL),
('Hampton Inn', 18, '2019-07-31', 340, NULL),
('Hampton Inn', 18, '2019-08-01', 153, NULL),
('Hampton Inn', 18, '2019-08-02', 162, NULL),
('Hampton Inn', 18, '2019-08-03', 334, NULL),
('Hampton Inn', 18, '2019-08-04', 314, NULL),
('Hampton Inn', 18, '2019-08-05', 319, NULL),
('Hampton Inn', 18, '2019-08-06', 255, 62),
('Hampton Inn', 18, '2019-08-07', 108, 62),
('Hampton Inn', 18, '2019-08-08', 259, 62),
('Hampton Inn', 18, '2019-08-09', 293, 62),
('Hampton Inn', 18, '2019-08-10', 323, 62),
('Hampton Inn', 18, '2019-08-11', 342, 62),
('Hampton Inn', 18, '2019-08-12', 299, 62),
('Hampton Inn', 18, '2019-08-13', 217, 62),
('Hampton Inn', 18, '2019-08-14', 375, 62),
('Hampton Inn', 18, '2019-08-15', 291, 62),
('Hampton Inn', 18, '2019-08-16', 360, 62),
('Hampton Inn', 18, '2019-08-17', 270, 62),
('Hampton Inn', 18, '2019-08-18', 204, 62),
('Hampton Inn', 18, '2019-08-19', 179, 62),
('Hampton Inn', 18, '2019-08-20', 155, 62),
('Hampton Inn', 18, '2019-08-21', 378, 62),
('Hampton Inn', 18, '2019-08-22', 345, 62),
('Hampton Inn', 18, '2019-08-23', 218, 62),
('Hampton Inn', 18, '2019-08-24', 305, NULL),
('Hampton Inn', 18, '2019-08-25', 279, NULL),
('Hampton Inn', 18, '2019-08-26', 210, NULL),
('Hampton Inn', 18, '2019-08-27', 389, NULL),
('Hampton Inn', 18, '2019-08-28', 159, NULL),
('Hampton Inn', 18, '2019-08-29', 212, 21),
('Hampton Inn', 18, '2019-08-30', 324, 21),
('Hampton Inn', 18, '2019-08-31', 323, 21),
('Hampton Inn', 18, '2019-09-01', 376, 21),
('Hampton Inn', 18, '2019-09-02', 245, 21),
('Hampton Inn', 18, '2019-09-03', 110, 21),
('Hampton Inn', 18, '2019-09-04', 255, 21),
('Hampton Inn', 18, '2019-09-05', 223, 21),
('Hampton Inn', 18, '2019-09-06', 248, 21),
('Hampton Inn', 18, '2019-09-07', 208, 21),
('Hampton Inn', 18, '2019-09-08', 210, 21),
('Hampton Inn', 18, '2019-09-09', 380, 21),
('Hampton Inn', 18, '2019-09-10', 297, 21),
('Hampton Inn', 18, '2019-09-11', 303, 21),
('Hampton Inn', 18, '2019-09-12', 236, 21),
('Hampton Inn', 18, '2019-09-13', 232, 21),
('Hampton Inn', 18, '2019-09-14', 102, 21),
('Hampton Inn', 18, '2019-09-15', 196, 21),
('Hampton Inn', 18, '2019-09-16', 186, 21),
('Hampton Inn', 18, '2019-09-17', 332, 21),
('Hampton Inn', 18, '2019-09-18', 213, 21),
('Hampton Inn', 18, '2019-09-19', 146, 21),
('Hampton Inn', 18, '2019-09-20', 140, 21),
('Hampton Inn', 18, '2019-09-21', 104, 21),
('Hampton Inn', 18, '2019-09-22', 286, 21),
('Hampton Inn', 18, '2019-09-23', 222, 21),
('Hampton Inn', 18, '2019-09-24', 106, 21),
('Hampton Inn', 18, '2019-09-25', 344, 21),
('Hampton Inn', 18, '2019-09-26', 336, NULL),
('Hampton Inn', 18, '2019-09-27', 158, NULL),
('Hampton Inn', 18, '2019-09-28', 320, NULL),
('Hampton Inn', 18, '2019-09-29', 119, NULL),
('Hampton Inn', 18, '2019-09-30', 328, NULL),
('Hampton Inn', 18, '2019-10-01', 114, NULL),
('Hampton Inn', 18, '2019-10-02', 297, NULL),
('Hampton Inn', 18, '2019-10-03', 243, NULL),
('Hampton Inn', 18, '2019-10-04', 316, NULL),
('Hampton Inn', 18, '2019-10-05', 201, NULL),
('Hampton Inn', 18, '2019-10-06', 191, NULL),
('Hampton Inn', 18, '2019-10-07', 266, NULL),
('Hampton Inn', 18, '2019-10-08', 173, NULL),
('Hampton Inn', 18, '2019-10-09', 202, NULL),
('Hampton Inn', 18, '2019-10-10', 347, NULL),
('Hampton Inn', 18, '2019-10-11', 206, NULL),
('Hampton Inn', 18, '2019-10-12', 148, NULL),
('Hampton Inn', 18, '2019-10-13', 381, NULL),
('Hampton Inn', 18, '2019-10-14', 378, NULL),
('Hampton Inn', 18, '2019-10-15', 172, NULL),
('Hampton Inn', 18, '2019-10-16', 220, NULL),
('Hampton Inn', 18, '2019-10-17', 224, NULL),
('Hampton Inn', 18, '2019-10-18', 337, NULL),
('Hampton Inn', 18, '2019-10-19', 345, NULL),
('Hampton Inn', 18, '2019-10-20', 136, NULL),
('Hampton Inn', 18, '2019-10-21', 147, NULL),
('Hampton Inn', 18, '2019-10-22', 107, NULL),
('Hampton Inn', 18, '2019-10-23', 195, NULL),
('Hampton Inn', 18, '2019-10-24', 134, NULL),
('Hampton Inn', 18, '2019-10-25', 116, NULL),
('Hampton Inn', 18, '2019-10-26', 224, NULL),
('Hampton Inn', 18, '2019-10-27', 123, NULL),
('Hampton Inn', 18, '2019-10-28', 182, NULL),
('Hampton Inn', 18, '2019-10-29', 256, NULL),
('Hampton Inn', 18, '2019-10-30', 166, NULL),
('Hampton Inn', 18, '2019-10-31', 336, NULL),
('Hampton Inn', 18, '2019-11-01', 364, NULL),
('Hampton Inn', 18, '2019-11-02', 244, NULL),
('Hampton Inn', 18, '2019-11-03', 274, NULL),
('Hampton Inn', 18, '2019-11-04', 109, NULL),
('Hampton Inn', 18, '2019-11-05', 228, NULL),
('Hampton Inn', 18, '2019-11-06', 106, NULL),
('Hampton Inn', 18, '2019-11-07', 307, NULL),
('Hampton Inn', 18, '2019-11-08', 178, NULL),
('Hampton Inn', 18, '2019-11-09', 335, NULL),
('Hampton Inn', 18, '2019-11-10', 214, NULL),
('Hampton Inn', 18, '2019-11-11', 237, NULL),
('Hampton Inn', 18, '2019-11-12', 358, NULL),
('Hampton Inn', 18, '2019-11-13', 161, NULL),
('Hampton Inn', 18, '2019-11-14', 148, NULL),
('Hampton Inn', 18, '2019-11-15', 143, NULL),
('Hampton Inn', 18, '2019-11-16', 178, 188),
('Hampton Inn', 18, '2019-11-17', 339, 188),
('Hampton Inn', 18, '2019-11-18', 138, 188),
('Hampton Inn', 18, '2019-11-19', 275, 188),
('Hampton Inn', 18, '2019-11-20', 203, 188),
('Hampton Inn', 18, '2019-11-21', 122, 188),
('Hampton Inn', 18, '2019-11-22', 306, 188),
('Hampton Inn', 18, '2019-11-23', 198, 188),
('Hampton Inn', 18, '2019-11-24', 313, 188),
('Hampton Inn', 18, '2019-11-25', 394, 188),
('Hampton Inn', 18, '2019-11-26', 210, 188),
('Hampton Inn', 18, '2019-11-27', 158, NULL),
('Hampton Inn', 18, '2019-11-28', 261, NULL),
('Hampton Inn', 18, '2019-11-29', 391, NULL),
('Hampton Inn', 18, '2019-11-30', 156, NULL),
('Hampton Inn', 18, '2019-12-01', 132, NULL),
('Hampton Inn', 18, '2019-12-02', 166, NULL),
('Hampton Inn', 18, '2019-12-03', 357, NULL),
('Hampton Inn', 18, '2019-12-04', 334, NULL),
('Hampton Inn', 18, '2019-12-05', 337, NULL),
('Hampton Inn', 18, '2019-12-06', 144, NULL),
('Hampton Inn', 18, '2019-12-07', 241, NULL),
('Hampton Inn', 18, '2019-12-08', 323, NULL),
('Hampton Inn', 18, '2019-12-09', 389, NULL),
('Hampton Inn', 18, '2019-12-10', 397, NULL),
('Hampton Inn', 18, '2019-12-11', 190, NULL),
('Hampton Inn', 18, '2019-12-12', 146, NULL),
('Hampton Inn', 18, '2019-12-13', 141, NULL),
('Hampton Inn', 18, '2019-12-14', 395, NULL),
('Hampton Inn', 18, '2019-12-15', 343, NULL),
('Hampton Inn', 18, '2019-12-16', 201, NULL),
('Hampton Inn', 18, '2019-12-17', 362, NULL),
('Hampton Inn', 18, '2019-12-18', 187, NULL),
('Hampton Inn', 18, '2019-12-19', 380, NULL),
('Hampton Inn', 18, '2019-12-20', 369, NULL),
('Hampton Inn', 18, '2019-12-21', 369, NULL),
('Hampton Inn', 18, '2019-12-22', 336, NULL),
('Hampton Inn', 18, '2019-12-23', 314, NULL),
('Hampton Inn', 18, '2019-12-24', 204, NULL),
('Hampton Inn', 18, '2019-12-25', 303, NULL),
('Hampton Inn', 18, '2019-12-26', 237, NULL),
('Hampton Inn', 18, '2019-12-27', 127, NULL),
('Hampton Inn', 18, '2019-12-28', 232, NULL),
('Hampton Inn', 18, '2019-12-29', 164, NULL),
('Hampton Inn', 18, '2019-12-30', 232, NULL),
('Hampton Inn', 18, '2019-12-31', 187, NULL),
('Hampton Inn', 18, '2020-01-01', 236, NULL),
('Hampton Inn', 18, '2020-01-02', 373, NULL),
('Hampton Inn', 18, '2020-01-03', 174, NULL),
('Hampton Inn', 18, '2020-01-04', 229, NULL),
('Hampton Inn', 18, '2020-01-05', 131, NULL),
('Hampton Inn', 18, '2020-01-06', 310, NULL),
('Hampton Inn', 18, '2020-01-07', 146, NULL),
('Hampton Inn', 18, '2020-01-08', 375, NULL),
('Hampton Inn', 18, '2020-01-09', 190, NULL),
('Hampton Inn', 18, '2020-01-10', 266, NULL),
('Hampton Inn', 18, '2020-01-11', 288, NULL),
('Hampton Inn', 18, '2020-01-12', 156, NULL),
('Hampton Inn', 18, '2020-01-13', 243, NULL),
('Hampton Inn', 18, '2020-01-14', 333, NULL),
('Hampton Inn', 18, '2020-01-15', 326, NULL),
('Hampton Inn', 18, '2020-01-16', 286, NULL),
('Hampton Inn', 18, '2020-01-17', 221, NULL),
('Hampton Inn', 18, '2020-01-18', 164, NULL),
('Hampton Inn', 18, '2020-01-19', 141, NULL),
('Hampton Inn', 18, '2020-01-20', 288, NULL),
('Hampton Inn', 18, '2020-01-21', 208, NULL),
('Hampton Inn', 18, '2020-01-22', 345, NULL),
('Hampton Inn', 18, '2020-01-23', 217, NULL),
('Hampton Inn', 18, '2020-01-24', 386, NULL),
('Hampton Inn', 18, '2020-01-25', 114, NULL),
('Hampton Inn', 18, '2020-01-26', 212, NULL),
('Hampton Inn', 18, '2020-01-27', 209, NULL),
('Hampton Inn', 18, '2020-01-28', 193, NULL),
('Hampton Inn', 18, '2020-01-29', 396, NULL),
('Hampton Inn', 18, '2020-01-30', 138, NULL),
('Hampton Inn', 18, '2020-01-31', 173, NULL),
('Hampton Inn', 18, '2020-02-01', 302, NULL),
('Hampton Inn', 18, '2020-02-02', 264, NULL),
('Hampton Inn', 18, '2020-02-03', 365, NULL),
('Hampton Inn', 18, '2020-02-04', 242, NULL),
('Hampton Inn', 20, '2019-01-01', 110, NULL),
('Hampton Inn', 20, '2019-01-02', 115, NULL),
('Hampton Inn', 20, '2019-01-03', 133, NULL),
('Hampton Inn', 20, '2019-01-04', 361, NULL),
('Hampton Inn', 20, '2019-01-05', 169, NULL),
('Hampton Inn', 20, '2019-01-06', 100, NULL),
('Hampton Inn', 20, '2019-01-07', 363, NULL),
('Hampton Inn', 20, '2019-01-08', 220, NULL),
('Hampton Inn', 20, '2019-01-09', 145, NULL),
('Hampton Inn', 20, '2019-01-10', 162, NULL),
('Hampton Inn', 20, '2019-01-11', 249, NULL),
('Hampton Inn', 20, '2019-01-12', 285, NULL),
('Hampton Inn', 20, '2019-01-13', 241, NULL),
('Hampton Inn', 20, '2019-01-14', 215, NULL),
('Hampton Inn', 20, '2019-01-15', 143, NULL),
('Hampton Inn', 20, '2019-01-16', 146, NULL),
('Hampton Inn', 20, '2019-01-17', 397, NULL),
('Hampton Inn', 20, '2019-01-18', 319, NULL),
('Hampton Inn', 20, '2019-01-19', 132, NULL),
('Hampton Inn', 20, '2019-01-20', 300, NULL),
('Hampton Inn', 20, '2019-01-21', 164, NULL),
('Hampton Inn', 20, '2019-01-22', 357, NULL),
('Hampton Inn', 20, '2019-01-23', 170, NULL),
('Hampton Inn', 20, '2019-01-24', 234, NULL),
('Hampton Inn', 20, '2019-01-25', 286, NULL),
('Hampton Inn', 20, '2019-01-26', 251, NULL),
('Hampton Inn', 20, '2019-01-27', 258, NULL),
('Hampton Inn', 20, '2019-01-28', 220, NULL),
('Hampton Inn', 20, '2019-01-29', 334, NULL),
('Hampton Inn', 20, '2019-01-30', 107, NULL),
('Hampton Inn', 20, '2019-01-31', 268, NULL),
('Hampton Inn', 20, '2019-02-01', 350, NULL),
('Hampton Inn', 20, '2019-02-02', 129, NULL),
('Hampton Inn', 20, '2019-02-03', 390, NULL),
('Hampton Inn', 20, '2019-02-04', 259, NULL),
('Hampton Inn', 20, '2019-02-05', 214, NULL),
('Hampton Inn', 20, '2019-02-06', 113, NULL),
('Hampton Inn', 20, '2019-02-07', 318, NULL),
('Hampton Inn', 20, '2019-02-08', 219, NULL),
('Hampton Inn', 20, '2019-02-09', 123, NULL),
('Hampton Inn', 20, '2019-02-10', 187, NULL),
('Hampton Inn', 20, '2019-02-11', 129, NULL),
('Hampton Inn', 20, '2019-02-12', 208, NULL),
('Hampton Inn', 20, '2019-02-13', 346, NULL),
('Hampton Inn', 20, '2019-02-14', 250, NULL),
('Hampton Inn', 20, '2019-02-15', 183, NULL),
('Hampton Inn', 20, '2019-02-16', 205, NULL),
('Hampton Inn', 20, '2019-02-17', 163, NULL),
('Hampton Inn', 20, '2019-02-18', 175, NULL),
('Hampton Inn', 20, '2019-02-19', 273, 104),
('Hampton Inn', 20, '2019-02-20', 102, 104),
('Hampton Inn', 20, '2019-02-21', 151, 104),
('Hampton Inn', 20, '2019-02-22', 394, 104),
('Hampton Inn', 20, '2019-02-23', 118, 104),
('Hampton Inn', 20, '2019-02-24', 396, 104),
('Hampton Inn', 20, '2019-02-25', 106, 104),
('Hampton Inn', 20, '2019-02-26', 106, 104),
('Hampton Inn', 20, '2019-02-27', 113, 104),
('Hampton Inn', 20, '2019-02-28', 391, 104),
('Hampton Inn', 20, '2019-03-01', 303, 104),
('Hampton Inn', 20, '2019-03-02', 126, 104),
('Hampton Inn', 20, '2019-03-03', 281, 104),
('Hampton Inn', 20, '2019-03-04', 359, 104),
('Hampton Inn', 20, '2019-03-05', 161, 104),
('Hampton Inn', 20, '2019-03-06', 161, 104),
('Hampton Inn', 20, '2019-03-07', 184, 104),
('Hampton Inn', 20, '2019-03-08', 357, 104),
('Hampton Inn', 20, '2019-03-09', 171, 104),
('Hampton Inn', 20, '2019-03-10', 252, NULL),
('Hampton Inn', 20, '2019-03-11', 238, NULL),
('Hampton Inn', 20, '2019-03-12', 247, NULL),
('Hampton Inn', 20, '2019-03-13', 366, 146),
('Hampton Inn', 20, '2019-03-14', 345, 146),
('Hampton Inn', 20, '2019-03-15', 172, 146),
('Hampton Inn', 20, '2019-03-16', 354, 146),
('Hampton Inn', 20, '2019-03-17', 165, 146),
('Hampton Inn', 20, '2019-03-18', 372, 146),
('Hampton Inn', 20, '2019-03-19', 293, 146),
('Hampton Inn', 20, '2019-03-20', 346, 146),
('Hampton Inn', 20, '2019-03-21', 202, 146),
('Hampton Inn', 20, '2019-03-22', 276, 146),
('Hampton Inn', 20, '2019-03-23', 117, 146),
('Hampton Inn', 20, '2019-03-24', 186, 146),
('Hampton Inn', 20, '2019-03-25', 229, 146),
('Hampton Inn', 20, '2019-03-26', 382, 146),
('Hampton Inn', 20, '2019-03-27', 143, 146),
('Hampton Inn', 20, '2019-03-28', 319, 146),
('Hampton Inn', 20, '2019-03-29', 147, 146),
('Hampton Inn', 20, '2019-03-30', 187, 146),
('Hampton Inn', 20, '2019-03-31', 387, 146),
('Hampton Inn', 20, '2019-04-01', 379, 146),
('Hampton Inn', 20, '2019-04-02', 188, 146),
('Hampton Inn', 20, '2019-04-03', 172, 146),
('Hampton Inn', 20, '2019-04-04', 275, 146),
('Hampton Inn', 20, '2019-04-05', 350, 146),
('Hampton Inn', 20, '2019-04-06', 387, 146),
('Hampton Inn', 20, '2019-04-07', 339, 146),
('Hampton Inn', 20, '2019-04-08', 162, NULL),
('Hampton Inn', 20, '2019-04-09', 396, NULL),
('Hampton Inn', 20, '2019-04-10', 366, NULL),
('Hampton Inn', 20, '2019-04-11', 286, NULL),
('Hampton Inn', 20, '2019-04-12', 311, NULL),
('Hampton Inn', 20, '2019-04-13', 380, NULL),
('Hampton Inn', 20, '2019-04-14', 129, NULL),
('Hampton Inn', 20, '2019-04-15', 368, NULL),
('Hampton Inn', 20, '2019-04-16', 313, NULL),
('Hampton Inn', 20, '2019-04-17', 360, NULL),
('Hampton Inn', 20, '2019-04-18', 177, 158),
('Hampton Inn', 20, '2019-04-19', 399, 158),
('Hampton Inn', 20, '2019-04-20', 147, 158),
('Hampton Inn', 20, '2019-04-21', 376, 158),
('Hampton Inn', 20, '2019-04-22', 140, 158),
('Hampton Inn', 20, '2019-04-23', 282, 158),
('Hampton Inn', 20, '2019-04-24', 168, 158),
('Hampton Inn', 20, '2019-04-25', 322, 158),
('Hampton Inn', 20, '2019-04-26', 372, 158),
('Hampton Inn', 20, '2019-04-27', 301, 158),
('Hampton Inn', 20, '2019-04-28', 378, 158),
('Hampton Inn', 20, '2019-04-29', 366, 158),
('Hampton Inn', 20, '2019-04-30', 212, NULL),
('Hampton Inn', 20, '2019-05-01', 343, NULL),
('Hampton Inn', 20, '2019-05-02', 201, NULL),
('Hampton Inn', 20, '2019-05-03', 309, NULL),
('Hampton Inn', 20, '2019-05-04', 224, NULL),
('Hampton Inn', 20, '2019-05-05', 291, NULL),
('Hampton Inn', 20, '2019-05-06', 171, NULL),
('Hampton Inn', 20, '2019-05-07', 158, NULL),
('Hampton Inn', 20, '2019-05-08', 175, NULL),
('Hampton Inn', 20, '2019-05-09', 367, NULL),
('Hampton Inn', 20, '2019-05-10', 100, 144),
('Hampton Inn', 20, '2019-05-11', 106, 144),
('Hampton Inn', 20, '2019-05-12', 114, 144),
('Hampton Inn', 20, '2019-05-13', 361, 144),
('Hampton Inn', 20, '2019-05-14', 294, 144),
('Hampton Inn', 20, '2019-05-15', 308, 144),
('Hampton Inn', 20, '2019-05-16', 285, 144),
('Hampton Inn', 20, '2019-05-17', 215, 144),
('Hampton Inn', 20, '2019-05-18', 224, 144),
('Hampton Inn', 20, '2019-05-19', 322, 144),
('Hampton Inn', 20, '2019-05-20', 392, 144),
('Hampton Inn', 20, '2019-05-21', 231, 144),
('Hampton Inn', 20, '2019-05-22', 244, 144),
('Hampton Inn', 20, '2019-05-23', 116, 144),
('Hampton Inn', 20, '2019-05-24', 256, 144),
('Hampton Inn', 20, '2019-05-25', 169, 144),
('Hampton Inn', 20, '2019-05-26', 147, 144),
('Hampton Inn', 20, '2019-05-27', 340, 144),
('Hampton Inn', 20, '2019-05-28', 344, 144),
('Hampton Inn', 20, '2019-05-29', 336, 144),
('Hampton Inn', 20, '2019-05-30', 286, 144),
('Hampton Inn', 20, '2019-05-31', 270, 144),
('Hampton Inn', 20, '2019-06-01', 121, 144),
('Hampton Inn', 20, '2019-06-02', 278, 144),
('Hampton Inn', 20, '2019-06-03', 170, 144),
('Hampton Inn', 20, '2019-06-04', 127, 144),
('Hampton Inn', 20, '2019-06-05', 230, 144),
('Hampton Inn', 20, '2019-06-06', 157, 144),
('Hampton Inn', 20, '2019-06-07', 366, 144),
('Hampton Inn', 20, '2019-06-08', 319, 144),
('Hampton Inn', 20, '2019-06-09', 103, NULL),
('Hampton Inn', 20, '2019-06-10', 398, NULL),
('Hampton Inn', 20, '2019-06-11', 384, NULL),
('Hampton Inn', 20, '2019-06-12', 118, NULL),
('Hampton Inn', 20, '2019-06-13', 291, NULL),
('Hampton Inn', 20, '2019-06-14', 328, NULL),
('Hampton Inn', 20, '2019-06-15', 265, NULL),
('Hampton Inn', 20, '2019-06-16', 227, NULL),
('Hampton Inn', 20, '2019-06-17', 258, NULL),
('Hampton Inn', 20, '2019-06-18', 353, NULL),
('Hampton Inn', 20, '2019-06-19', 109, NULL),
('Hampton Inn', 20, '2019-06-20', 283, NULL),
('Hampton Inn', 20, '2019-06-21', 253, NULL),
('Hampton Inn', 20, '2019-06-22', 347, NULL),
('Hampton Inn', 20, '2019-06-23', 124, NULL),
('Hampton Inn', 20, '2019-06-24', 326, NULL),
('Hampton Inn', 20, '2019-06-25', 257, NULL),
('Hampton Inn', 20, '2019-06-26', 233, NULL),
('Hampton Inn', 20, '2019-06-27', 216, NULL),
('Hampton Inn', 20, '2019-06-28', 303, NULL),
('Hampton Inn', 20, '2019-06-29', 343, NULL),
('Hampton Inn', 20, '2019-06-30', 236, NULL),
('Hampton Inn', 20, '2019-07-01', 346, NULL),
('Hampton Inn', 20, '2019-07-02', 386, NULL),
('Hampton Inn', 20, '2019-07-03', 119, NULL),
('Hampton Inn', 20, '2019-07-04', 145, NULL),
('Hampton Inn', 20, '2019-07-05', 291, NULL),
('Hampton Inn', 20, '2019-07-06', 122, NULL),
('Hampton Inn', 20, '2019-07-07', 101, NULL),
('Hampton Inn', 20, '2019-07-08', 142, NULL),
('Hampton Inn', 20, '2019-07-09', 226, 92),
('Hampton Inn', 20, '2019-07-10', 314, 92),
('Hampton Inn', 20, '2019-07-11', 243, 92),
('Hampton Inn', 20, '2019-07-12', 237, 92),
('Hampton Inn', 20, '2019-07-13', 228, 92),
('Hampton Inn', 20, '2019-07-14', 160, 92),
('Hampton Inn', 20, '2019-07-15', 228, 92),
('Hampton Inn', 20, '2019-07-16', 292, 92),
('Hampton Inn', 20, '2019-07-17', 355, 92),
('Hampton Inn', 20, '2019-07-18', 384, 92),
('Hampton Inn', 20, '2019-07-19', 349, 92),
('Hampton Inn', 20, '2019-07-20', 186, 92),
('Hampton Inn', 20, '2019-07-21', 399, 92),
('Hampton Inn', 20, '2019-07-22', 123, 92),
('Hampton Inn', 20, '2019-07-23', 209, 92),
('Hampton Inn', 20, '2019-07-24', 377, 92),
('Hampton Inn', 20, '2019-07-25', 187, 92),
('Hampton Inn', 20, '2019-07-26', 194, 92),
('Hampton Inn', 20, '2019-07-27', 287, 92),
('Hampton Inn', 20, '2019-07-28', 101, 92),
('Hampton Inn', 20, '2019-07-29', 138, 92),
('Hampton Inn', 20, '2019-07-30', 126, 92),
('Hampton Inn', 20, '2019-07-31', 155, 92),
('Hampton Inn', 20, '2019-08-01', 204, 92),
('Hampton Inn', 20, '2019-08-02', 386, 92),
('Hampton Inn', 20, '2019-08-03', 237, 92),
('Hampton Inn', 20, '2019-08-04', 321, 92),
('Hampton Inn', 20, '2019-08-05', 289, 92),
('Hampton Inn', 20, '2019-08-06', 245, 92),
('Hampton Inn', 20, '2019-08-07', 196, NULL),
('Hampton Inn', 20, '2019-08-08', 325, NULL),
('Hampton Inn', 20, '2019-08-09', 346, NULL),
('Hampton Inn', 20, '2019-08-10', 197, NULL),
('Hampton Inn', 20, '2019-08-11', 119, NULL),
('Hampton Inn', 20, '2019-08-12', 338, NULL),
('Hampton Inn', 20, '2019-08-13', 137, NULL),
('Hampton Inn', 20, '2019-08-14', 229, NULL),
('Hampton Inn', 20, '2019-08-15', 394, NULL),
('Hampton Inn', 20, '2019-08-16', 183, NULL),
('Hampton Inn', 20, '2019-08-17', 300, NULL),
('Hampton Inn', 20, '2019-08-18', 162, NULL),
('Hampton Inn', 20, '2019-08-19', 155, NULL),
('Hampton Inn', 20, '2019-08-20', 175, NULL),
('Hampton Inn', 20, '2019-08-21', 379, NULL),
('Hampton Inn', 20, '2019-08-22', 135, NULL),
('Hampton Inn', 20, '2019-08-23', 177, NULL),
('Hampton Inn', 20, '2019-08-24', 221, NULL),
('Hampton Inn', 20, '2019-08-25', 304, NULL),
('Hampton Inn', 20, '2019-08-26', 114, NULL),
('Hampton Inn', 20, '2019-08-27', 287, NULL),
('Hampton Inn', 20, '2019-08-28', 135, NULL),
('Hampton Inn', 20, '2019-08-29', 212, NULL),
('Hampton Inn', 20, '2019-08-30', 108, NULL),
('Hampton Inn', 20, '2019-08-31', 244, NULL),
('Hampton Inn', 20, '2019-09-01', 276, NULL),
('Hampton Inn', 20, '2019-09-02', 127, NULL),
('Hampton Inn', 20, '2019-09-03', 298, NULL),
('Hampton Inn', 20, '2019-09-04', 337, NULL),
('Hampton Inn', 20, '2019-09-05', 233, NULL),
('Hampton Inn', 20, '2019-09-06', 307, NULL),
('Hampton Inn', 20, '2019-09-07', 190, NULL),
('Hampton Inn', 20, '2019-09-08', 200, NULL),
('Hampton Inn', 20, '2019-09-09', 152, NULL),
('Hampton Inn', 20, '2019-09-10', 359, 25),
('Hampton Inn', 20, '2019-09-11', 379, 25),
('Hampton Inn', 20, '2019-09-12', 111, 25),
('Hampton Inn', 20, '2019-09-13', 397, 25),
('Hampton Inn', 20, '2019-09-14', 381, 25),
('Hampton Inn', 20, '2019-09-15', 279, 25),
('Hampton Inn', 20, '2019-09-16', 396, 25),
('Hampton Inn', 20, '2019-09-17', 367, 25),
('Hampton Inn', 20, '2019-09-18', 135, 25),
('Hampton Inn', 20, '2019-09-19', 292, 25),
('Hampton Inn', 20, '2019-09-20', 112, NULL),
('Hampton Inn', 20, '2019-09-21', 168, NULL),
('Hampton Inn', 20, '2019-09-22', 100, NULL),
('Hampton Inn', 20, '2019-09-23', 279, NULL),
('Hampton Inn', 20, '2019-09-24', 345, NULL),
('Hampton Inn', 20, '2019-09-25', 231, NULL),
('Hampton Inn', 20, '2019-09-26', 225, NULL),
('Hampton Inn', 20, '2019-09-27', 174, NULL),
('Hampton Inn', 20, '2019-09-28', 193, NULL),
('Hampton Inn', 20, '2019-09-29', 182, NULL),
('Hampton Inn', 20, '2019-09-30', 160, NULL),
('Hampton Inn', 20, '2019-10-01', 161, NULL),
('Hampton Inn', 20, '2019-10-02', 369, NULL),
('Hampton Inn', 20, '2019-10-03', 269, NULL),
('Hampton Inn', 20, '2019-10-04', 368, NULL),
('Hampton Inn', 20, '2019-10-05', 324, NULL),
('Hampton Inn', 20, '2019-10-06', 334, NULL),
('Hampton Inn', 20, '2019-10-07', 307, NULL),
('Hampton Inn', 20, '2019-10-08', 348, NULL),
('Hampton Inn', 20, '2019-10-09', 286, NULL),
('Hampton Inn', 20, '2019-10-10', 244, NULL),
('Hampton Inn', 20, '2019-10-11', 309, NULL),
('Hampton Inn', 20, '2019-10-12', 151, NULL),
('Hampton Inn', 20, '2019-10-13', 353, NULL),
('Hampton Inn', 20, '2019-10-14', 126, NULL),
('Hampton Inn', 20, '2019-10-15', 375, NULL),
('Hampton Inn', 20, '2019-10-16', 394, NULL),
('Hampton Inn', 20, '2019-10-17', 282, NULL),
('Hampton Inn', 20, '2019-10-18', 388, NULL),
('Hampton Inn', 20, '2019-10-19', 328, NULL),
('Hampton Inn', 20, '2019-10-20', 341, NULL),
('Hampton Inn', 20, '2019-10-21', 226, NULL),
('Hampton Inn', 20, '2019-10-22', 105, NULL),
('Hampton Inn', 20, '2019-10-23', 105, NULL),
('Hampton Inn', 20, '2019-10-24', 313, NULL),
('Hampton Inn', 20, '2019-10-25', 100, NULL),
('Hampton Inn', 20, '2019-10-26', 256, NULL),
('Hampton Inn', 20, '2019-10-27', 287, NULL),
('Hampton Inn', 20, '2019-10-28', 155, NULL),
('Hampton Inn', 20, '2019-10-29', 327, NULL),
('Hampton Inn', 20, '2019-10-30', 179, NULL),
('Hampton Inn', 20, '2019-10-31', 362, NULL),
('Hampton Inn', 20, '2019-11-01', 239, NULL),
('Hampton Inn', 20, '2019-11-02', 129, NULL),
('Hampton Inn', 20, '2019-11-03', 386, NULL),
('Hampton Inn', 20, '2019-11-04', 122, NULL),
('Hampton Inn', 20, '2019-11-05', 319, NULL),
('Hampton Inn', 20, '2019-11-06', 246, NULL),
('Hampton Inn', 20, '2019-11-07', 334, NULL),
('Hampton Inn', 20, '2019-11-08', 286, NULL),
('Hampton Inn', 20, '2019-11-09', 279, NULL),
('Hampton Inn', 20, '2019-11-10', 333, NULL),
('Hampton Inn', 20, '2019-11-11', 350, NULL),
('Hampton Inn', 20, '2019-11-12', 312, NULL),
('Hampton Inn', 20, '2019-11-13', 366, NULL),
('Hampton Inn', 20, '2019-11-14', 138, NULL),
('Hampton Inn', 20, '2019-11-15', 373, NULL),
('Hampton Inn', 20, '2019-11-16', 109, NULL),
('Hampton Inn', 20, '2019-11-17', 275, NULL),
('Hampton Inn', 20, '2019-11-18', 158, NULL),
('Hampton Inn', 20, '2019-11-19', 235, NULL),
('Hampton Inn', 20, '2019-11-20', 376, NULL),
('Hampton Inn', 20, '2019-11-21', 125, NULL),
('Hampton Inn', 20, '2019-11-22', 116, NULL),
('Hampton Inn', 20, '2019-11-23', 277, NULL),
('Hampton Inn', 20, '2019-11-24', 228, NULL),
('Hampton Inn', 20, '2019-11-25', 113, NULL),
('Hampton Inn', 20, '2019-11-26', 153, NULL),
('Hampton Inn', 20, '2019-11-27', 392, NULL),
('Hampton Inn', 20, '2019-11-28', 157, NULL),
('Hampton Inn', 20, '2019-11-29', 136, NULL),
('Hampton Inn', 20, '2019-11-30', 302, NULL),
('Hampton Inn', 20, '2019-12-01', 158, NULL),
('Hampton Inn', 20, '2019-12-02', 169, NULL),
('Hampton Inn', 20, '2019-12-03', 391, NULL),
('Hampton Inn', 20, '2019-12-04', 213, NULL),
('Hampton Inn', 20, '2019-12-05', 349, NULL),
('Hampton Inn', 20, '2019-12-06', 195, NULL),
('Hampton Inn', 20, '2019-12-07', 111, NULL),
('Hampton Inn', 20, '2019-12-08', 142, NULL),
('Hampton Inn', 20, '2019-12-09', 187, NULL),
('Hampton Inn', 20, '2019-12-10', 244, NULL),
('Hampton Inn', 20, '2019-12-11', 129, NULL),
('Hampton Inn', 20, '2019-12-12', 210, NULL),
('Hampton Inn', 20, '2019-12-13', 268, NULL),
('Hampton Inn', 20, '2019-12-14', 376, NULL),
('Hampton Inn', 20, '2019-12-15', 255, NULL),
('Hampton Inn', 20, '2019-12-16', 280, NULL),
('Hampton Inn', 20, '2019-12-17', 122, NULL),
('Hampton Inn', 20, '2019-12-18', 365, NULL),
('Hampton Inn', 20, '2019-12-19', 153, NULL),
('Hampton Inn', 20, '2019-12-20', 112, NULL),
('Hampton Inn', 20, '2019-12-21', 216, NULL),
('Hampton Inn', 20, '2019-12-22', 390, NULL),
('Hampton Inn', 20, '2019-12-23', 216, NULL),
('Hampton Inn', 20, '2019-12-24', 159, NULL),
('Hampton Inn', 20, '2019-12-25', 365, NULL),
('Hampton Inn', 20, '2019-12-26', 270, NULL),
('Hampton Inn', 20, '2019-12-27', 290, NULL),
('Hampton Inn', 20, '2019-12-28', 224, NULL),
('Hampton Inn', 20, '2019-12-29', 321, NULL),
('Hampton Inn', 20, '2019-12-30', 231, NULL),
('Hampton Inn', 20, '2019-12-31', 135, NULL),
('Hampton Inn', 20, '2020-01-01', 193, NULL),
('Hampton Inn', 20, '2020-01-02', 360, NULL),
('Hampton Inn', 20, '2020-01-03', 297, NULL),
('Hampton Inn', 20, '2020-01-04', 306, NULL),
('Hampton Inn', 20, '2020-01-05', 328, NULL),
('Hampton Inn', 20, '2020-01-06', 369, NULL),
('Hampton Inn', 20, '2020-01-07', 145, NULL),
('Hampton Inn', 20, '2020-01-08', 374, NULL),
('Hampton Inn', 20, '2020-01-09', 299, NULL),
('Hampton Inn', 20, '2020-01-10', 238, NULL),
('Hampton Inn', 20, '2020-01-11', 306, NULL),
('Hampton Inn', 20, '2020-01-12', 335, NULL),
('Hampton Inn', 20, '2020-01-13', 331, NULL),
('Hampton Inn', 20, '2020-01-14', 215, NULL),
('Hampton Inn', 20, '2020-01-15', 186, NULL),
('Hampton Inn', 20, '2020-01-16', 368, NULL),
('Hampton Inn', 20, '2020-01-17', 202, NULL),
('Hampton Inn', 20, '2020-01-18', 323, NULL),
('Hampton Inn', 20, '2020-01-19', 105, NULL),
('Hampton Inn', 20, '2020-01-20', 304, NULL),
('Hampton Inn', 20, '2020-01-21', 111, NULL),
('Hampton Inn', 20, '2020-01-22', 316, NULL),
('Hampton Inn', 20, '2020-01-23', 238, NULL),
('Hampton Inn', 20, '2020-01-24', 209, NULL),
('Hampton Inn', 20, '2020-01-25', 330, NULL),
('Hampton Inn', 20, '2020-01-26', 325, NULL),
('Hampton Inn', 20, '2020-01-27', 114, NULL),
('Hampton Inn', 20, '2020-01-28', 189, NULL),
('Hampton Inn', 20, '2020-01-29', 366, NULL),
('Hampton Inn', 20, '2020-01-30', 283, NULL),
('Hampton Inn', 20, '2020-01-31', 162, NULL),
('Hampton Inn', 20, '2020-02-01', 396, NULL),
('Hampton Inn', 20, '2020-02-02', 330, NULL),
('Hampton Inn', 20, '2020-02-03', 138, NULL),
('Hampton Inn', 20, '2020-02-04', 132, NULL),
('Hampton Inn', 28, '2019-01-01', 218, NULL),
('Hampton Inn', 28, '2019-01-02', 204, NULL),
('Hampton Inn', 28, '2019-01-03', 128, NULL),
('Hampton Inn', 28, '2019-01-04', 333, NULL),
('Hampton Inn', 28, '2019-01-05', 254, NULL),
('Hampton Inn', 28, '2019-01-06', 296, NULL),
('Hampton Inn', 28, '2019-01-07', 143, NULL),
('Hampton Inn', 28, '2019-01-08', 270, NULL),
('Hampton Inn', 28, '2019-01-09', 353, NULL),
('Hampton Inn', 28, '2019-01-10', 378, NULL),
('Hampton Inn', 28, '2019-01-11', 317, NULL),
('Hampton Inn', 28, '2019-01-12', 136, NULL),
('Hampton Inn', 28, '2019-01-13', 155, NULL),
('Hampton Inn', 28, '2019-01-14', 152, NULL),
('Hampton Inn', 28, '2019-01-15', 374, NULL),
('Hampton Inn', 28, '2019-01-16', 278, NULL),
('Hampton Inn', 28, '2019-01-17', 249, NULL),
('Hampton Inn', 28, '2019-01-18', 125, NULL),
('Hampton Inn', 28, '2019-01-19', 335, NULL),
('Hampton Inn', 28, '2019-01-20', 316, NULL),
('Hampton Inn', 28, '2019-01-21', 180, NULL),
('Hampton Inn', 28, '2019-01-22', 106, NULL),
('Hampton Inn', 28, '2019-01-23', 267, NULL),
('Hampton Inn', 28, '2019-01-24', 363, NULL),
('Hampton Inn', 28, '2019-01-25', 254, NULL),
('Hampton Inn', 28, '2019-01-26', 232, NULL),
('Hampton Inn', 28, '2019-01-27', 390, NULL),
('Hampton Inn', 28, '2019-01-28', 341, NULL),
('Hampton Inn', 28, '2019-01-29', 176, NULL),
('Hampton Inn', 28, '2019-01-30', 366, NULL),
('Hampton Inn', 28, '2019-01-31', 125, NULL),
('Hampton Inn', 28, '2019-02-01', 246, NULL),
('Hampton Inn', 28, '2019-02-02', 235, NULL),
('Hampton Inn', 28, '2019-02-03', 102, NULL),
('Hampton Inn', 28, '2019-02-04', 115, NULL),
('Hampton Inn', 28, '2019-02-05', 177, NULL),
('Hampton Inn', 28, '2019-02-06', 338, NULL),
('Hampton Inn', 28, '2019-02-07', 299, NULL),
('Hampton Inn', 28, '2019-02-08', 349, NULL),
('Hampton Inn', 28, '2019-02-09', 393, NULL),
('Hampton Inn', 28, '2019-02-10', 335, NULL),
('Hampton Inn', 28, '2019-02-11', 357, NULL),
('Hampton Inn', 28, '2019-02-12', 102, NULL),
('Hampton Inn', 28, '2019-02-13', 231, NULL),
('Hampton Inn', 28, '2019-02-14', 346, NULL),
('Hampton Inn', 28, '2019-02-15', 147, NULL),
('Hampton Inn', 28, '2019-02-16', 279, NULL),
('Hampton Inn', 28, '2019-02-17', 260, NULL),
('Hampton Inn', 28, '2019-02-18', 188, NULL),
('Hampton Inn', 28, '2019-02-19', 117, NULL),
('Hampton Inn', 28, '2019-02-20', 322, NULL),
('Hampton Inn', 28, '2019-02-21', 182, NULL),
('Hampton Inn', 28, '2019-02-22', 267, NULL),
('Hampton Inn', 28, '2019-02-23', 258, NULL),
('Hampton Inn', 28, '2019-02-24', 316, NULL),
('Hampton Inn', 28, '2019-02-25', 141, NULL),
('Hampton Inn', 28, '2019-02-26', 173, NULL),
('Hampton Inn', 28, '2019-02-27', 205, NULL),
('Hampton Inn', 28, '2019-02-28', 226, NULL),
('Hampton Inn', 28, '2019-03-01', 259, NULL),
('Hampton Inn', 28, '2019-03-02', 146, NULL),
('Hampton Inn', 28, '2019-03-03', 344, NULL),
('Hampton Inn', 28, '2019-03-04', 163, NULL),
('Hampton Inn', 28, '2019-03-05', 283, NULL),
('Hampton Inn', 28, '2019-03-06', 350, NULL),
('Hampton Inn', 28, '2019-03-07', 379, NULL),
('Hampton Inn', 28, '2019-03-08', 252, NULL),
('Hampton Inn', 28, '2019-03-09', 395, NULL),
('Hampton Inn', 28, '2019-03-10', 176, NULL),
('Hampton Inn', 28, '2019-03-11', 370, NULL),
('Hampton Inn', 28, '2019-03-12', 267, NULL),
('Hampton Inn', 28, '2019-03-13', 299, NULL),
('Hampton Inn', 28, '2019-03-14', 228, NULL),
('Hampton Inn', 28, '2019-03-15', 167, NULL),
('Hampton Inn', 28, '2019-03-16', 101, NULL),
('Hampton Inn', 28, '2019-03-17', 190, NULL),
('Hampton Inn', 28, '2019-03-18', 175, NULL),
('Hampton Inn', 28, '2019-03-19', 160, NULL),
('Hampton Inn', 28, '2019-03-20', 339, NULL),
('Hampton Inn', 28, '2019-03-21', 219, NULL),
('Hampton Inn', 28, '2019-03-22', 203, NULL),
('Hampton Inn', 28, '2019-03-23', 197, NULL),
('Hampton Inn', 28, '2019-03-24', 141, NULL),
('Hampton Inn', 28, '2019-03-25', 112, NULL),
('Hampton Inn', 28, '2019-03-26', 349, NULL),
('Hampton Inn', 28, '2019-03-27', 201, NULL),
('Hampton Inn', 28, '2019-03-28', 191, NULL),
('Hampton Inn', 28, '2019-03-29', 359, NULL),
('Hampton Inn', 28, '2019-03-30', 229, NULL),
('Hampton Inn', 28, '2019-03-31', 136, NULL),
('Hampton Inn', 28, '2019-04-01', 268, NULL),
('Hampton Inn', 28, '2019-04-02', 266, NULL),
('Hampton Inn', 28, '2019-04-03', 251, NULL),
('Hampton Inn', 28, '2019-04-04', 338, NULL),
('Hampton Inn', 28, '2019-04-05', 138, NULL),
('Hampton Inn', 28, '2019-04-06', 387, NULL),
('Hampton Inn', 28, '2019-04-07', 107, NULL),
('Hampton Inn', 28, '2019-04-08', 234, NULL),
('Hampton Inn', 28, '2019-04-09', 157, NULL),
('Hampton Inn', 28, '2019-04-10', 383, NULL),
('Hampton Inn', 28, '2019-04-11', 369, NULL),
('Hampton Inn', 28, '2019-04-12', 293, NULL),
('Hampton Inn', 28, '2019-04-13', 381, NULL),
('Hampton Inn', 28, '2019-04-14', 287, NULL),
('Hampton Inn', 28, '2019-04-15', 112, NULL),
('Hampton Inn', 28, '2019-04-16', 271, NULL),
('Hampton Inn', 28, '2019-04-17', 197, 159),
('Hampton Inn', 28, '2019-04-18', 343, 159),
('Hampton Inn', 28, '2019-04-19', 173, 159),
('Hampton Inn', 28, '2019-04-20', 335, 159),
('Hampton Inn', 28, '2019-04-21', 284, 159),
('Hampton Inn', 28, '2019-04-22', 373, 159),
('Hampton Inn', 28, '2019-04-23', 170, 159),
('Hampton Inn', 28, '2019-04-24', 245, NULL),
('Hampton Inn', 28, '2019-04-25', 241, NULL),
('Hampton Inn', 28, '2019-04-26', 178, NULL),
('Hampton Inn', 28, '2019-04-27', 344, NULL),
('Hampton Inn', 28, '2019-04-28', 219, NULL),
('Hampton Inn', 28, '2019-04-29', 258, NULL),
('Hampton Inn', 28, '2019-04-30', 200, NULL),
('Hampton Inn', 28, '2019-05-01', 344, NULL),
('Hampton Inn', 28, '2019-05-02', 120, NULL),
('Hampton Inn', 28, '2019-05-03', 240, NULL),
('Hampton Inn', 28, '2019-05-04', 244, NULL),
('Hampton Inn', 28, '2019-05-05', 231, NULL),
('Hampton Inn', 28, '2019-05-06', 223, NULL),
('Hampton Inn', 28, '2019-05-07', 178, NULL),
('Hampton Inn', 28, '2019-05-08', 105, NULL),
('Hampton Inn', 28, '2019-05-09', 384, NULL),
('Hampton Inn', 28, '2019-05-10', 210, NULL),
('Hampton Inn', 28, '2019-05-11', 118, NULL),
('Hampton Inn', 28, '2019-05-12', 159, NULL),
('Hampton Inn', 28, '2019-05-13', 159, NULL),
('Hampton Inn', 28, '2019-05-14', 300, NULL),
('Hampton Inn', 28, '2019-05-15', 242, NULL),
('Hampton Inn', 28, '2019-05-16', 162, NULL),
('Hampton Inn', 28, '2019-05-17', 239, NULL),
('Hampton Inn', 28, '2019-05-18', 283, NULL),
('Hampton Inn', 28, '2019-05-19', 167, NULL),
('Hampton Inn', 28, '2019-05-20', 398, NULL),
('Hampton Inn', 28, '2019-05-21', 217, NULL),
('Hampton Inn', 28, '2019-05-22', 273, NULL),
('Hampton Inn', 28, '2019-05-23', 301, NULL),
('Hampton Inn', 28, '2019-05-24', 204, NULL),
('Hampton Inn', 28, '2019-05-25', 361, NULL),
('Hampton Inn', 28, '2019-05-26', 361, NULL),
('Hampton Inn', 28, '2019-05-27', 317, NULL),
('Hampton Inn', 28, '2019-05-28', 124, NULL),
('Hampton Inn', 28, '2019-05-29', 206, NULL),
('Hampton Inn', 28, '2019-05-30', 336, NULL),
('Hampton Inn', 28, '2019-05-31', 323, NULL),
('Hampton Inn', 28, '2019-06-01', 102, NULL),
('Hampton Inn', 28, '2019-06-02', 253, NULL),
('Hampton Inn', 28, '2019-06-03', 315, NULL),
('Hampton Inn', 28, '2019-06-04', 332, NULL),
('Hampton Inn', 28, '2019-06-05', 146, NULL),
('Hampton Inn', 28, '2019-06-06', 218, NULL),
('Hampton Inn', 28, '2019-06-07', 278, NULL),
('Hampton Inn', 28, '2019-06-08', 246, NULL),
('Hampton Inn', 28, '2019-06-09', 273, NULL),
('Hampton Inn', 28, '2019-06-10', 319, NULL),
('Hampton Inn', 28, '2019-06-11', 380, NULL),
('Hampton Inn', 28, '2019-06-12', 197, NULL),
('Hampton Inn', 28, '2019-06-13', 330, NULL),
('Hampton Inn', 28, '2019-06-14', 308, NULL),
('Hampton Inn', 28, '2019-06-15', 145, NULL),
('Hampton Inn', 28, '2019-06-16', 366, NULL),
('Hampton Inn', 28, '2019-06-17', 292, NULL),
('Hampton Inn', 28, '2019-06-18', 145, NULL),
('Hampton Inn', 28, '2019-06-19', 156, NULL),
('Hampton Inn', 28, '2019-06-20', 117, NULL),
('Hampton Inn', 28, '2019-06-21', 239, NULL),
('Hampton Inn', 28, '2019-06-22', 379, NULL),
('Hampton Inn', 28, '2019-06-23', 107, NULL),
('Hampton Inn', 28, '2019-06-24', 136, NULL),
('Hampton Inn', 28, '2019-06-25', 190, NULL),
('Hampton Inn', 28, '2019-06-26', 125, NULL),
('Hampton Inn', 28, '2019-06-27', 353, NULL),
('Hampton Inn', 28, '2019-06-28', 272, NULL),
('Hampton Inn', 28, '2019-06-29', 301, NULL),
('Hampton Inn', 28, '2019-06-30', 224, NULL),
('Hampton Inn', 28, '2019-07-01', 161, NULL),
('Hampton Inn', 28, '2019-07-02', 281, NULL),
('Hampton Inn', 28, '2019-07-03', 283, NULL),
('Hampton Inn', 28, '2019-07-04', 195, NULL),
('Hampton Inn', 28, '2019-07-05', 200, NULL),
('Hampton Inn', 28, '2019-07-06', 386, NULL),
('Hampton Inn', 28, '2019-07-07', 286, NULL),
('Hampton Inn', 28, '2019-07-08', 343, NULL),
('Hampton Inn', 28, '2019-07-09', 172, NULL),
('Hampton Inn', 28, '2019-07-10', 204, NULL),
('Hampton Inn', 28, '2019-07-11', 248, NULL),
('Hampton Inn', 28, '2019-07-12', 191, NULL),
('Hampton Inn', 28, '2019-07-13', 183, NULL),
('Hampton Inn', 28, '2019-07-14', 194, NULL),
('Hampton Inn', 28, '2019-07-15', 123, NULL),
('Hampton Inn', 28, '2019-07-16', 370, NULL),
('Hampton Inn', 28, '2019-07-17', 175, NULL),
('Hampton Inn', 28, '2019-07-18', 295, NULL),
('Hampton Inn', 28, '2019-07-19', 231, NULL),
('Hampton Inn', 28, '2019-07-20', 242, NULL),
('Hampton Inn', 28, '2019-07-21', 181, NULL),
('Hampton Inn', 28, '2019-07-22', 336, NULL),
('Hampton Inn', 28, '2019-07-23', 123, NULL),
('Hampton Inn', 28, '2019-07-24', 394, NULL),
('Hampton Inn', 28, '2019-07-25', 220, NULL),
('Hampton Inn', 28, '2019-07-26', 365, NULL),
('Hampton Inn', 28, '2019-07-27', 181, NULL),
('Hampton Inn', 28, '2019-07-28', 396, NULL),
('Hampton Inn', 28, '2019-07-29', 370, NULL),
('Hampton Inn', 28, '2019-07-30', 266, NULL),
('Hampton Inn', 28, '2019-07-31', 258, NULL),
('Hampton Inn', 28, '2019-08-01', 163, 107),
('Hampton Inn', 28, '2019-08-02', 145, 107),
('Hampton Inn', 28, '2019-08-03', 386, 107),
('Hampton Inn', 28, '2019-08-04', 263, 107),
('Hampton Inn', 28, '2019-08-05', 390, 107),
('Hampton Inn', 28, '2019-08-06', 360, 107),
('Hampton Inn', 28, '2019-08-07', 254, 107),
('Hampton Inn', 28, '2019-08-08', 147, 107),
('Hampton Inn', 28, '2019-08-09', 152, 107),
('Hampton Inn', 28, '2019-08-10', 218, 107),
('Hampton Inn', 28, '2019-08-11', 372, 107),
('Hampton Inn', 28, '2019-08-12', 392, 107),
('Hampton Inn', 28, '2019-08-13', 237, 107),
('Hampton Inn', 28, '2019-08-14', 220, 107),
('Hampton Inn', 28, '2019-08-15', 398, 107),
('Hampton Inn', 28, '2019-08-16', 335, NULL),
('Hampton Inn', 28, '2019-08-17', 293, NULL),
('Hampton Inn', 28, '2019-08-18', 100, NULL),
('Hampton Inn', 28, '2019-08-19', 136, NULL),
('Hampton Inn', 28, '2019-08-20', 314, 86),
('Hampton Inn', 28, '2019-08-21', 359, 86),
('Hampton Inn', 28, '2019-08-22', 140, 86),
('Hampton Inn', 28, '2019-08-23', 129, 86),
('Hampton Inn', 28, '2019-08-24', 389, 86),
('Hampton Inn', 28, '2019-08-25', 281, 86),
('Hampton Inn', 28, '2019-08-26', 142, 86),
('Hampton Inn', 28, '2019-08-27', 170, 86),
('Hampton Inn', 28, '2019-08-28', 399, 86),
('Hampton Inn', 28, '2019-08-29', 323, 86),
('Hampton Inn', 28, '2019-08-30', 370, 86),
('Hampton Inn', 28, '2019-08-31', 150, 86),
('Hampton Inn', 28, '2019-09-01', 154, 86),
('Hampton Inn', 28, '2019-09-02', 101, 86),
('Hampton Inn', 28, '2019-09-03', 160, 86),
('Hampton Inn', 28, '2019-09-04', 223, 86),
('Hampton Inn', 28, '2019-09-05', 395, 86),
('Hampton Inn', 28, '2019-09-06', 391, 86),
('Hampton Inn', 28, '2019-09-07', 225, 86),
('Hampton Inn', 28, '2019-09-08', 268, 86),
('Hampton Inn', 28, '2019-09-09', 122, 86),
('Hampton Inn', 28, '2019-09-10', 204, 86),
('Hampton Inn', 28, '2019-09-11', 288, 86),
('Hampton Inn', 28, '2019-09-12', 344, 86),
('Hampton Inn', 28, '2019-09-13', 289, 86),
('Hampton Inn', 28, '2019-09-14', 297, 86),
('Hampton Inn', 28, '2019-09-15', 109, 86),
('Hampton Inn', 28, '2019-09-16', 122, 86),
('Hampton Inn', 28, '2019-09-17', 140, 86),
('Hampton Inn', 28, '2019-09-18', 238, NULL),
('Hampton Inn', 28, '2019-09-19', 323, NULL),
('Hampton Inn', 28, '2019-09-20', 340, NULL),
('Hampton Inn', 28, '2019-09-21', 128, NULL),
('Hampton Inn', 28, '2019-09-22', 142, NULL),
('Hampton Inn', 28, '2019-09-23', 329, NULL),
('Hampton Inn', 28, '2019-09-24', 108, NULL),
('Hampton Inn', 28, '2019-09-25', 323, NULL),
('Hampton Inn', 28, '2019-09-26', 315, NULL),
('Hampton Inn', 28, '2019-09-27', 297, NULL),
('Hampton Inn', 28, '2019-09-28', 205, NULL),
('Hampton Inn', 28, '2019-09-29', 155, NULL),
('Hampton Inn', 28, '2019-09-30', 320, NULL),
('Hampton Inn', 28, '2019-10-01', 363, NULL),
('Hampton Inn', 28, '2019-10-02', 254, NULL),
('Hampton Inn', 28, '2019-10-03', 214, NULL),
('Hampton Inn', 28, '2019-10-04', 194, NULL),
('Hampton Inn', 28, '2019-10-05', 317, NULL),
('Hampton Inn', 28, '2019-10-06', 397, NULL),
('Hampton Inn', 28, '2019-10-07', 336, NULL),
('Hampton Inn', 28, '2019-10-08', 219, NULL),
('Hampton Inn', 28, '2019-10-09', 123, NULL),
('Hampton Inn', 28, '2019-10-10', 381, NULL),
('Hampton Inn', 28, '2019-10-11', 228, NULL),
('Hampton Inn', 28, '2019-10-12', 212, NULL),
('Hampton Inn', 28, '2019-10-13', 226, NULL),
('Hampton Inn', 28, '2019-10-14', 297, NULL),
('Hampton Inn', 28, '2019-10-15', 362, NULL),
('Hampton Inn', 28, '2019-10-16', 309, NULL),
('Hampton Inn', 28, '2019-10-17', 341, NULL),
('Hampton Inn', 28, '2019-10-18', 232, NULL),
('Hampton Inn', 28, '2019-10-19', 206, NULL),
('Hampton Inn', 28, '2019-10-20', 295, NULL),
('Hampton Inn', 28, '2019-10-21', 291, NULL),
('Hampton Inn', 28, '2019-10-22', 105, NULL),
('Hampton Inn', 28, '2019-10-23', 139, NULL),
('Hampton Inn', 28, '2019-10-24', 163, NULL),
('Hampton Inn', 28, '2019-10-25', 349, NULL),
('Hampton Inn', 28, '2019-10-26', 209, NULL),
('Hampton Inn', 28, '2019-10-27', 367, NULL),
('Hampton Inn', 28, '2019-10-28', 129, NULL),
('Hampton Inn', 28, '2019-10-29', 166, NULL),
('Hampton Inn', 28, '2019-10-30', 296, NULL),
('Hampton Inn', 28, '2019-10-31', 103, NULL),
('Hampton Inn', 28, '2019-11-01', 307, NULL),
('Hampton Inn', 28, '2019-11-02', 114, NULL),
('Hampton Inn', 28, '2019-11-03', 106, NULL),
('Hampton Inn', 28, '2019-11-04', 182, NULL),
('Hampton Inn', 28, '2019-11-05', 213, NULL),
('Hampton Inn', 28, '2019-11-06', 215, NULL),
('Hampton Inn', 28, '2019-11-07', 353, NULL),
('Hampton Inn', 28, '2019-11-08', 197, NULL),
('Hampton Inn', 28, '2019-11-09', 293, NULL),
('Hampton Inn', 28, '2019-11-10', 323, NULL),
('Hampton Inn', 28, '2019-11-11', 339, NULL),
('Hampton Inn', 28, '2019-11-12', 388, NULL),
('Hampton Inn', 28, '2019-11-13', 349, NULL),
('Hampton Inn', 28, '2019-11-14', 148, NULL),
('Hampton Inn', 28, '2019-11-15', 138, NULL),
('Hampton Inn', 28, '2019-11-16', 212, NULL),
('Hampton Inn', 28, '2019-11-17', 258, NULL),
('Hampton Inn', 28, '2019-11-18', 278, NULL),
('Hampton Inn', 28, '2019-11-19', 248, NULL),
('Hampton Inn', 28, '2019-11-20', 270, NULL),
('Hampton Inn', 28, '2019-11-21', 160, NULL),
('Hampton Inn', 28, '2019-11-22', 162, NULL),
('Hampton Inn', 28, '2019-11-23', 390, NULL),
('Hampton Inn', 28, '2019-11-24', 100, NULL),
('Hampton Inn', 28, '2019-11-25', 184, NULL),
('Hampton Inn', 28, '2019-11-26', 335, NULL),
('Hampton Inn', 28, '2019-11-27', 186, NULL),
('Hampton Inn', 28, '2019-11-28', 201, NULL),
('Hampton Inn', 28, '2019-11-29', 309, NULL),
('Hampton Inn', 28, '2019-11-30', 343, NULL),
('Hampton Inn', 28, '2019-12-01', 293, NULL),
('Hampton Inn', 28, '2019-12-02', 247, NULL),
('Hampton Inn', 28, '2019-12-03', 184, NULL),
('Hampton Inn', 28, '2019-12-04', 263, NULL),
('Hampton Inn', 28, '2019-12-05', 334, NULL),
('Hampton Inn', 28, '2019-12-06', 144, NULL),
('Hampton Inn', 28, '2019-12-07', 333, NULL),
('Hampton Inn', 28, '2019-12-08', 241, NULL),
('Hampton Inn', 28, '2019-12-09', 265, NULL),
('Hampton Inn', 28, '2019-12-10', 229, NULL),
('Hampton Inn', 28, '2019-12-11', 277, NULL),
('Hampton Inn', 28, '2019-12-12', 212, NULL),
('Hampton Inn', 28, '2019-12-13', 220, NULL),
('Hampton Inn', 28, '2019-12-14', 296, NULL),
('Hampton Inn', 28, '2019-12-15', 148, NULL),
('Hampton Inn', 28, '2019-12-16', 398, NULL),
('Hampton Inn', 28, '2019-12-17', 327, NULL),
('Hampton Inn', 28, '2019-12-18', 267, NULL),
('Hampton Inn', 28, '2019-12-19', 127, NULL),
('Hampton Inn', 28, '2019-12-20', 251, NULL),
('Hampton Inn', 28, '2019-12-21', 172, NULL),
('Hampton Inn', 28, '2019-12-22', 241, NULL),
('Hampton Inn', 28, '2019-12-23', 337, NULL),
('Hampton Inn', 28, '2019-12-24', 382, NULL),
('Hampton Inn', 28, '2019-12-25', 215, NULL),
('Hampton Inn', 28, '2019-12-26', 241, NULL),
('Hampton Inn', 28, '2019-12-27', 368, NULL),
('Hampton Inn', 28, '2019-12-28', 326, NULL),
('Hampton Inn', 28, '2019-12-29', 113, NULL),
('Hampton Inn', 28, '2019-12-30', 359, NULL),
('Hampton Inn', 28, '2019-12-31', 316, NULL),
('Hampton Inn', 28, '2020-01-01', 159, NULL),
('Hampton Inn', 28, '2020-01-02', 284, NULL),
('Hampton Inn', 28, '2020-01-03', 263, NULL),
('Hampton Inn', 28, '2020-01-04', 143, NULL),
('Hampton Inn', 28, '2020-01-05', 249, NULL),
('Hampton Inn', 28, '2020-01-06', 215, NULL),
('Hampton Inn', 28, '2020-01-07', 189, NULL),
('Hampton Inn', 28, '2020-01-08', 345, NULL),
('Hampton Inn', 28, '2020-01-09', 225, NULL),
('Hampton Inn', 28, '2020-01-10', 295, NULL),
('Hampton Inn', 28, '2020-01-11', 267, NULL),
('Hampton Inn', 28, '2020-01-12', 210, NULL),
('Hampton Inn', 28, '2020-01-13', 227, NULL),
('Hampton Inn', 28, '2020-01-14', 277, NULL),
('Hampton Inn', 28, '2020-01-15', 150, NULL),
('Hampton Inn', 28, '2020-01-16', 280, NULL),
('Hampton Inn', 28, '2020-01-17', 246, NULL),
('Hampton Inn', 28, '2020-01-18', 124, NULL),
('Hampton Inn', 28, '2020-01-19', 305, NULL),
('Hampton Inn', 28, '2020-01-20', 254, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 28, '2020-01-21', 132, NULL),
('Hampton Inn', 28, '2020-01-22', 145, NULL),
('Hampton Inn', 28, '2020-01-23', 139, NULL),
('Hampton Inn', 28, '2020-01-24', 389, NULL),
('Hampton Inn', 28, '2020-01-25', 311, NULL),
('Hampton Inn', 28, '2020-01-26', 292, NULL),
('Hampton Inn', 28, '2020-01-27', 144, NULL),
('Hampton Inn', 28, '2020-01-28', 265, NULL),
('Hampton Inn', 28, '2020-01-29', 243, NULL),
('Hampton Inn', 28, '2020-01-30', 301, NULL),
('Hampton Inn', 28, '2020-01-31', 192, NULL),
('Hampton Inn', 28, '2020-02-01', 375, NULL),
('Hampton Inn', 28, '2020-02-02', 162, NULL),
('Hampton Inn', 28, '2020-02-03', 393, NULL),
('Hampton Inn', 28, '2020-02-04', 134, NULL),
('Hampton Inn', 37, '2019-01-01', 360, NULL),
('Hampton Inn', 37, '2019-01-02', 277, NULL),
('Hampton Inn', 37, '2019-01-03', 142, NULL),
('Hampton Inn', 37, '2019-01-04', 182, NULL),
('Hampton Inn', 37, '2019-01-05', 366, NULL),
('Hampton Inn', 37, '2019-01-06', 181, NULL),
('Hampton Inn', 37, '2019-01-07', 129, NULL),
('Hampton Inn', 37, '2019-01-08', 291, NULL),
('Hampton Inn', 37, '2019-01-09', 328, NULL),
('Hampton Inn', 37, '2019-01-10', 105, NULL),
('Hampton Inn', 37, '2019-01-11', 136, NULL),
('Hampton Inn', 37, '2019-01-12', 323, NULL),
('Hampton Inn', 37, '2019-01-13', 251, NULL),
('Hampton Inn', 37, '2019-01-14', 313, NULL),
('Hampton Inn', 37, '2019-01-15', 143, NULL),
('Hampton Inn', 37, '2019-01-16', 256, NULL),
('Hampton Inn', 37, '2019-01-17', 253, NULL),
('Hampton Inn', 37, '2019-01-18', 167, NULL),
('Hampton Inn', 37, '2019-01-19', 281, NULL),
('Hampton Inn', 37, '2019-01-20', 280, NULL),
('Hampton Inn', 37, '2019-01-21', 307, NULL),
('Hampton Inn', 37, '2019-01-22', 262, NULL),
('Hampton Inn', 37, '2019-01-23', 125, NULL),
('Hampton Inn', 37, '2019-01-24', 111, NULL),
('Hampton Inn', 37, '2019-01-25', 312, NULL),
('Hampton Inn', 37, '2019-01-26', 308, NULL),
('Hampton Inn', 37, '2019-01-27', 176, NULL),
('Hampton Inn', 37, '2019-01-28', 347, NULL),
('Hampton Inn', 37, '2019-01-29', 379, NULL),
('Hampton Inn', 37, '2019-01-30', 209, NULL),
('Hampton Inn', 37, '2019-01-31', 322, NULL),
('Hampton Inn', 37, '2019-02-01', 382, NULL),
('Hampton Inn', 37, '2019-02-02', 390, NULL),
('Hampton Inn', 37, '2019-02-03', 143, NULL),
('Hampton Inn', 37, '2019-02-04', 297, NULL),
('Hampton Inn', 37, '2019-02-05', 144, NULL),
('Hampton Inn', 37, '2019-02-06', 351, NULL),
('Hampton Inn', 37, '2019-02-07', 139, NULL),
('Hampton Inn', 37, '2019-02-08', 386, NULL),
('Hampton Inn', 37, '2019-02-09', 297, NULL),
('Hampton Inn', 37, '2019-02-10', 116, NULL),
('Hampton Inn', 37, '2019-02-11', 397, NULL),
('Hampton Inn', 37, '2019-02-12', 386, NULL),
('Hampton Inn', 37, '2019-02-13', 316, NULL),
('Hampton Inn', 37, '2019-02-14', 279, NULL),
('Hampton Inn', 37, '2019-02-15', 388, NULL),
('Hampton Inn', 37, '2019-02-16', 380, NULL),
('Hampton Inn', 37, '2019-02-17', 111, NULL),
('Hampton Inn', 37, '2019-02-18', 314, NULL),
('Hampton Inn', 37, '2019-02-19', 266, NULL),
('Hampton Inn', 37, '2019-02-20', 306, NULL),
('Hampton Inn', 37, '2019-02-21', 355, NULL),
('Hampton Inn', 37, '2019-02-22', 351, NULL),
('Hampton Inn', 37, '2019-02-23', 237, NULL),
('Hampton Inn', 37, '2019-02-24', 291, NULL),
('Hampton Inn', 37, '2019-02-25', 285, NULL),
('Hampton Inn', 37, '2019-02-26', 149, NULL),
('Hampton Inn', 37, '2019-02-27', 288, NULL),
('Hampton Inn', 37, '2019-02-28', 157, NULL),
('Hampton Inn', 37, '2019-03-01', 285, NULL),
('Hampton Inn', 37, '2019-03-02', 251, NULL),
('Hampton Inn', 37, '2019-03-03', 177, NULL),
('Hampton Inn', 37, '2019-03-04', 239, NULL),
('Hampton Inn', 37, '2019-03-05', 230, NULL),
('Hampton Inn', 37, '2019-03-06', 270, NULL),
('Hampton Inn', 37, '2019-03-07', 343, NULL),
('Hampton Inn', 37, '2019-03-08', 389, NULL),
('Hampton Inn', 37, '2019-03-09', 161, NULL),
('Hampton Inn', 37, '2019-03-10', 327, NULL),
('Hampton Inn', 37, '2019-03-11', 137, NULL),
('Hampton Inn', 37, '2019-03-12', 193, NULL),
('Hampton Inn', 37, '2019-03-13', 297, NULL),
('Hampton Inn', 37, '2019-03-14', 305, NULL),
('Hampton Inn', 37, '2019-03-15', 221, NULL),
('Hampton Inn', 37, '2019-03-16', 244, NULL),
('Hampton Inn', 37, '2019-03-17', 355, NULL),
('Hampton Inn', 37, '2019-03-18', 257, NULL),
('Hampton Inn', 37, '2019-03-19', 119, NULL),
('Hampton Inn', 37, '2019-03-20', 257, NULL),
('Hampton Inn', 37, '2019-03-21', 391, NULL),
('Hampton Inn', 37, '2019-03-22', 388, NULL),
('Hampton Inn', 37, '2019-03-23', 235, NULL),
('Hampton Inn', 37, '2019-03-24', 351, NULL),
('Hampton Inn', 37, '2019-03-25', 373, NULL),
('Hampton Inn', 37, '2019-03-26', 197, NULL),
('Hampton Inn', 37, '2019-03-27', 179, NULL),
('Hampton Inn', 37, '2019-03-28', 199, NULL),
('Hampton Inn', 37, '2019-03-29', 352, NULL),
('Hampton Inn', 37, '2019-03-30', 184, NULL),
('Hampton Inn', 37, '2019-03-31', 322, NULL),
('Hampton Inn', 37, '2019-04-01', 105, NULL),
('Hampton Inn', 37, '2019-04-02', 363, NULL),
('Hampton Inn', 37, '2019-04-03', 337, NULL),
('Hampton Inn', 37, '2019-04-04', 167, NULL),
('Hampton Inn', 37, '2019-04-05', 143, NULL),
('Hampton Inn', 37, '2019-04-06', 372, NULL),
('Hampton Inn', 37, '2019-04-07', 322, NULL),
('Hampton Inn', 37, '2019-04-08', 282, NULL),
('Hampton Inn', 37, '2019-04-09', 397, NULL),
('Hampton Inn', 37, '2019-04-10', 115, NULL),
('Hampton Inn', 37, '2019-04-11', 288, NULL),
('Hampton Inn', 37, '2019-04-12', 133, NULL),
('Hampton Inn', 37, '2019-04-13', 365, NULL),
('Hampton Inn', 37, '2019-04-14', 347, NULL),
('Hampton Inn', 37, '2019-04-15', 255, NULL),
('Hampton Inn', 37, '2019-04-16', 317, NULL),
('Hampton Inn', 37, '2019-04-17', 102, NULL),
('Hampton Inn', 37, '2019-04-18', 185, NULL),
('Hampton Inn', 37, '2019-04-19', 167, NULL),
('Hampton Inn', 37, '2019-04-20', 233, NULL),
('Hampton Inn', 37, '2019-04-21', 192, NULL),
('Hampton Inn', 37, '2019-04-22', 143, 198),
('Hampton Inn', 37, '2019-04-23', 202, 198),
('Hampton Inn', 37, '2019-04-24', 322, 198),
('Hampton Inn', 37, '2019-04-25', 138, 198),
('Hampton Inn', 37, '2019-04-26', 277, 198),
('Hampton Inn', 37, '2019-04-27', 117, 198),
('Hampton Inn', 37, '2019-04-28', 164, 198),
('Hampton Inn', 37, '2019-04-29', 394, 198),
('Hampton Inn', 37, '2019-04-30', 265, 198),
('Hampton Inn', 37, '2019-05-01', 293, 198),
('Hampton Inn', 37, '2019-05-02', 196, 198),
('Hampton Inn', 37, '2019-05-03', 171, 198),
('Hampton Inn', 37, '2019-05-04', 145, 198),
('Hampton Inn', 37, '2019-05-05', 184, 198),
('Hampton Inn', 37, '2019-05-06', 200, 198),
('Hampton Inn', 37, '2019-05-07', 316, 198),
('Hampton Inn', 37, '2019-05-08', 199, 198),
('Hampton Inn', 37, '2019-05-09', 119, 198),
('Hampton Inn', 37, '2019-05-10', 348, 198),
('Hampton Inn', 37, '2019-05-11', 170, 198),
('Hampton Inn', 37, '2019-05-12', 353, 198),
('Hampton Inn', 37, '2019-05-13', 215, 198),
('Hampton Inn', 37, '2019-05-14', 220, 198),
('Hampton Inn', 37, '2019-05-15', 187, 198),
('Hampton Inn', 37, '2019-05-16', 155, 198),
('Hampton Inn', 37, '2019-05-17', 150, 198),
('Hampton Inn', 37, '2019-05-18', 343, 198),
('Hampton Inn', 37, '2019-05-19', 368, 198),
('Hampton Inn', 37, '2019-05-20', 115, 198),
('Hampton Inn', 37, '2019-05-21', 289, 198),
('Hampton Inn', 37, '2019-05-22', 233, NULL),
('Hampton Inn', 37, '2019-05-23', 156, NULL),
('Hampton Inn', 37, '2019-05-24', 152, NULL),
('Hampton Inn', 37, '2019-05-25', 296, NULL),
('Hampton Inn', 37, '2019-05-26', 363, NULL),
('Hampton Inn', 37, '2019-05-27', 163, NULL),
('Hampton Inn', 37, '2019-05-28', 390, NULL),
('Hampton Inn', 37, '2019-05-29', 221, NULL),
('Hampton Inn', 37, '2019-05-30', 122, NULL),
('Hampton Inn', 37, '2019-05-31', 106, NULL),
('Hampton Inn', 37, '2019-06-01', 346, NULL),
('Hampton Inn', 37, '2019-06-02', 332, NULL),
('Hampton Inn', 37, '2019-06-03', 364, NULL),
('Hampton Inn', 37, '2019-06-04', 278, NULL),
('Hampton Inn', 37, '2019-06-05', 241, NULL),
('Hampton Inn', 37, '2019-06-06', 217, NULL),
('Hampton Inn', 37, '2019-06-07', 190, NULL),
('Hampton Inn', 37, '2019-06-08', 175, NULL),
('Hampton Inn', 37, '2019-06-09', 354, NULL),
('Hampton Inn', 37, '2019-06-10', 303, NULL),
('Hampton Inn', 37, '2019-06-11', 348, NULL),
('Hampton Inn', 37, '2019-06-12', 235, NULL),
('Hampton Inn', 37, '2019-06-13', 376, NULL),
('Hampton Inn', 37, '2019-06-14', 159, NULL),
('Hampton Inn', 37, '2019-06-15', 128, NULL),
('Hampton Inn', 37, '2019-06-16', 149, NULL),
('Hampton Inn', 37, '2019-06-17', 286, NULL),
('Hampton Inn', 37, '2019-06-18', 168, NULL),
('Hampton Inn', 37, '2019-06-19', 352, NULL),
('Hampton Inn', 37, '2019-06-20', 235, NULL),
('Hampton Inn', 37, '2019-06-21', 334, NULL),
('Hampton Inn', 37, '2019-06-22', 152, NULL),
('Hampton Inn', 37, '2019-06-23', 362, NULL),
('Hampton Inn', 37, '2019-06-24', 203, NULL),
('Hampton Inn', 37, '2019-06-25', 380, NULL),
('Hampton Inn', 37, '2019-06-26', 124, NULL),
('Hampton Inn', 37, '2019-06-27', 114, NULL),
('Hampton Inn', 37, '2019-06-28', 353, NULL),
('Hampton Inn', 37, '2019-06-29', 375, NULL),
('Hampton Inn', 37, '2019-06-30', 312, NULL),
('Hampton Inn', 37, '2019-07-01', 266, NULL),
('Hampton Inn', 37, '2019-07-02', 147, NULL),
('Hampton Inn', 37, '2019-07-03', 360, NULL),
('Hampton Inn', 37, '2019-07-04', 143, NULL),
('Hampton Inn', 37, '2019-07-05', 328, NULL),
('Hampton Inn', 37, '2019-07-06', 263, NULL),
('Hampton Inn', 37, '2019-07-07', 130, NULL),
('Hampton Inn', 37, '2019-07-08', 288, NULL),
('Hampton Inn', 37, '2019-07-09', 383, NULL),
('Hampton Inn', 37, '2019-07-10', 279, NULL),
('Hampton Inn', 37, '2019-07-11', 112, NULL),
('Hampton Inn', 37, '2019-07-12', 145, NULL),
('Hampton Inn', 37, '2019-07-13', 131, NULL),
('Hampton Inn', 37, '2019-07-14', 390, NULL),
('Hampton Inn', 37, '2019-07-15', 133, NULL),
('Hampton Inn', 37, '2019-07-16', 277, NULL),
('Hampton Inn', 37, '2019-07-17', 311, NULL),
('Hampton Inn', 37, '2019-07-18', 226, NULL),
('Hampton Inn', 37, '2019-07-19', 310, NULL),
('Hampton Inn', 37, '2019-07-20', 252, NULL),
('Hampton Inn', 37, '2019-07-21', 210, NULL),
('Hampton Inn', 37, '2019-07-22', 309, NULL),
('Hampton Inn', 37, '2019-07-23', 191, NULL),
('Hampton Inn', 37, '2019-07-24', 139, NULL),
('Hampton Inn', 37, '2019-07-25', 137, NULL),
('Hampton Inn', 37, '2019-07-26', 242, NULL),
('Hampton Inn', 37, '2019-07-27', 247, NULL),
('Hampton Inn', 37, '2019-07-28', 379, NULL),
('Hampton Inn', 37, '2019-07-29', 137, NULL),
('Hampton Inn', 37, '2019-07-30', 252, NULL),
('Hampton Inn', 37, '2019-07-31', 126, NULL),
('Hampton Inn', 37, '2019-08-01', 100, NULL),
('Hampton Inn', 37, '2019-08-02', 368, NULL),
('Hampton Inn', 37, '2019-08-03', 217, NULL),
('Hampton Inn', 37, '2019-08-04', 251, NULL),
('Hampton Inn', 37, '2019-08-05', 384, NULL),
('Hampton Inn', 37, '2019-08-06', 365, NULL),
('Hampton Inn', 37, '2019-08-07', 284, NULL),
('Hampton Inn', 37, '2019-08-08', 262, NULL),
('Hampton Inn', 37, '2019-08-09', 223, NULL),
('Hampton Inn', 37, '2019-08-10', 101, NULL),
('Hampton Inn', 37, '2019-08-11', 201, NULL),
('Hampton Inn', 37, '2019-08-12', 250, NULL),
('Hampton Inn', 37, '2019-08-13', 372, NULL),
('Hampton Inn', 37, '2019-08-14', 313, NULL),
('Hampton Inn', 37, '2019-08-15', 106, NULL),
('Hampton Inn', 37, '2019-08-16', 128, NULL),
('Hampton Inn', 37, '2019-08-17', 164, NULL),
('Hampton Inn', 37, '2019-08-18', 215, NULL),
('Hampton Inn', 37, '2019-08-19', 117, NULL),
('Hampton Inn', 37, '2019-08-20', 343, NULL),
('Hampton Inn', 37, '2019-08-21', 259, NULL),
('Hampton Inn', 37, '2019-08-22', 198, NULL),
('Hampton Inn', 37, '2019-08-23', 317, NULL),
('Hampton Inn', 37, '2019-08-24', 286, NULL),
('Hampton Inn', 37, '2019-08-25', 395, NULL),
('Hampton Inn', 37, '2019-08-26', 268, NULL),
('Hampton Inn', 37, '2019-08-27', 189, NULL),
('Hampton Inn', 37, '2019-08-28', 288, NULL),
('Hampton Inn', 37, '2019-08-29', 281, NULL),
('Hampton Inn', 37, '2019-08-30', 227, NULL),
('Hampton Inn', 37, '2019-08-31', 219, NULL),
('Hampton Inn', 37, '2019-09-01', 140, NULL),
('Hampton Inn', 37, '2019-09-02', 325, NULL),
('Hampton Inn', 37, '2019-09-03', 107, NULL),
('Hampton Inn', 37, '2019-09-04', 303, 132),
('Hampton Inn', 37, '2019-09-05', 276, 132),
('Hampton Inn', 37, '2019-09-06', 336, 132),
('Hampton Inn', 37, '2019-09-07', 155, 132),
('Hampton Inn', 37, '2019-09-08', 342, 132),
('Hampton Inn', 37, '2019-09-09', 354, 132),
('Hampton Inn', 37, '2019-09-10', 143, 132),
('Hampton Inn', 37, '2019-09-11', 203, 132),
('Hampton Inn', 37, '2019-09-12', 390, 132),
('Hampton Inn', 37, '2019-09-13', 153, 132),
('Hampton Inn', 37, '2019-09-14', 245, 132),
('Hampton Inn', 37, '2019-09-15', 206, 132),
('Hampton Inn', 37, '2019-09-16', 224, 132),
('Hampton Inn', 37, '2019-09-17', 101, 132),
('Hampton Inn', 37, '2019-09-18', 383, 132),
('Hampton Inn', 37, '2019-09-19', 338, 132),
('Hampton Inn', 37, '2019-09-20', 363, 132),
('Hampton Inn', 37, '2019-09-21', 336, 132),
('Hampton Inn', 37, '2019-09-22', 308, 132),
('Hampton Inn', 37, '2019-09-23', 109, 132),
('Hampton Inn', 37, '2019-09-24', 305, 132),
('Hampton Inn', 37, '2019-09-25', 221, 132),
('Hampton Inn', 37, '2019-09-26', 204, 132),
('Hampton Inn', 37, '2019-09-27', 262, 132),
('Hampton Inn', 37, '2019-09-28', 350, 132),
('Hampton Inn', 37, '2019-09-29', 129, 132),
('Hampton Inn', 37, '2019-09-30', 119, NULL),
('Hampton Inn', 37, '2019-10-01', 335, NULL),
('Hampton Inn', 37, '2019-10-02', 362, NULL),
('Hampton Inn', 37, '2019-10-03', 165, NULL),
('Hampton Inn', 37, '2019-10-04', 365, NULL),
('Hampton Inn', 37, '2019-10-05', 216, NULL),
('Hampton Inn', 37, '2019-10-06', 281, NULL),
('Hampton Inn', 37, '2019-10-07', 363, NULL),
('Hampton Inn', 37, '2019-10-08', 252, NULL),
('Hampton Inn', 37, '2019-10-09', 258, NULL),
('Hampton Inn', 37, '2019-10-10', 173, NULL),
('Hampton Inn', 37, '2019-10-11', 115, NULL),
('Hampton Inn', 37, '2019-10-12', 210, NULL),
('Hampton Inn', 37, '2019-10-13', 268, NULL),
('Hampton Inn', 37, '2019-10-14', 109, NULL),
('Hampton Inn', 37, '2019-10-15', 286, NULL),
('Hampton Inn', 37, '2019-10-16', 263, NULL),
('Hampton Inn', 37, '2019-10-17', 156, NULL),
('Hampton Inn', 37, '2019-10-18', 193, NULL),
('Hampton Inn', 37, '2019-10-19', 245, NULL),
('Hampton Inn', 37, '2019-10-20', 353, NULL),
('Hampton Inn', 37, '2019-10-21', 374, NULL),
('Hampton Inn', 37, '2019-10-22', 110, NULL),
('Hampton Inn', 37, '2019-10-23', 283, NULL),
('Hampton Inn', 37, '2019-10-24', 377, NULL),
('Hampton Inn', 37, '2019-10-25', 148, NULL),
('Hampton Inn', 37, '2019-10-26', 178, NULL),
('Hampton Inn', 37, '2019-10-27', 273, NULL),
('Hampton Inn', 37, '2019-10-28', 381, NULL),
('Hampton Inn', 37, '2019-10-29', 352, NULL),
('Hampton Inn', 37, '2019-10-30', 244, NULL),
('Hampton Inn', 37, '2019-10-31', 229, NULL),
('Hampton Inn', 37, '2019-11-01', 115, NULL),
('Hampton Inn', 37, '2019-11-02', 385, NULL),
('Hampton Inn', 37, '2019-11-03', 175, NULL),
('Hampton Inn', 37, '2019-11-04', 143, NULL),
('Hampton Inn', 37, '2019-11-05', 306, NULL),
('Hampton Inn', 37, '2019-11-06', 235, NULL),
('Hampton Inn', 37, '2019-11-07', 360, NULL),
('Hampton Inn', 37, '2019-11-08', 326, NULL),
('Hampton Inn', 37, '2019-11-09', 226, NULL),
('Hampton Inn', 37, '2019-11-10', 219, NULL),
('Hampton Inn', 37, '2019-11-11', 248, NULL),
('Hampton Inn', 37, '2019-11-12', 301, NULL),
('Hampton Inn', 37, '2019-11-13', 245, NULL),
('Hampton Inn', 37, '2019-11-14', 226, NULL),
('Hampton Inn', 37, '2019-11-15', 370, NULL),
('Hampton Inn', 37, '2019-11-16', 334, NULL),
('Hampton Inn', 37, '2019-11-17', 363, NULL),
('Hampton Inn', 37, '2019-11-18', 215, NULL),
('Hampton Inn', 37, '2019-11-19', 138, NULL),
('Hampton Inn', 37, '2019-11-20', 123, NULL),
('Hampton Inn', 37, '2019-11-21', 324, NULL),
('Hampton Inn', 37, '2019-11-22', 362, NULL),
('Hampton Inn', 37, '2019-11-23', 120, NULL),
('Hampton Inn', 37, '2019-11-24', 316, NULL),
('Hampton Inn', 37, '2019-11-25', 183, NULL),
('Hampton Inn', 37, '2019-11-26', 218, NULL),
('Hampton Inn', 37, '2019-11-27', 254, NULL),
('Hampton Inn', 37, '2019-11-28', 137, NULL),
('Hampton Inn', 37, '2019-11-29', 138, NULL),
('Hampton Inn', 37, '2019-11-30', 107, NULL),
('Hampton Inn', 37, '2019-12-01', 290, NULL),
('Hampton Inn', 37, '2019-12-02', 328, NULL),
('Hampton Inn', 37, '2019-12-03', 246, NULL),
('Hampton Inn', 37, '2019-12-04', 275, NULL),
('Hampton Inn', 37, '2019-12-05', 224, NULL),
('Hampton Inn', 37, '2019-12-06', 333, NULL),
('Hampton Inn', 37, '2019-12-07', 334, NULL),
('Hampton Inn', 37, '2019-12-08', 379, NULL),
('Hampton Inn', 37, '2019-12-09', 367, NULL),
('Hampton Inn', 37, '2019-12-10', 312, NULL),
('Hampton Inn', 37, '2019-12-11', 298, NULL),
('Hampton Inn', 37, '2019-12-12', 330, NULL),
('Hampton Inn', 37, '2019-12-13', 196, NULL),
('Hampton Inn', 37, '2019-12-14', 253, NULL),
('Hampton Inn', 37, '2019-12-15', 175, NULL),
('Hampton Inn', 37, '2019-12-16', 152, NULL),
('Hampton Inn', 37, '2019-12-17', 267, NULL),
('Hampton Inn', 37, '2019-12-18', 141, NULL),
('Hampton Inn', 37, '2019-12-19', 376, NULL),
('Hampton Inn', 37, '2019-12-20', 221, NULL),
('Hampton Inn', 37, '2019-12-21', 111, NULL),
('Hampton Inn', 37, '2019-12-22', 234, NULL),
('Hampton Inn', 37, '2019-12-23', 340, NULL),
('Hampton Inn', 37, '2019-12-24', 136, NULL),
('Hampton Inn', 37, '2019-12-25', 184, NULL),
('Hampton Inn', 37, '2019-12-26', 296, NULL),
('Hampton Inn', 37, '2019-12-27', 271, NULL),
('Hampton Inn', 37, '2019-12-28', 261, NULL),
('Hampton Inn', 37, '2019-12-29', 104, NULL),
('Hampton Inn', 37, '2019-12-30', 101, NULL),
('Hampton Inn', 37, '2019-12-31', 176, NULL),
('Hampton Inn', 37, '2020-01-01', 116, NULL),
('Hampton Inn', 37, '2020-01-02', 239, NULL),
('Hampton Inn', 37, '2020-01-03', 323, NULL),
('Hampton Inn', 37, '2020-01-04', 297, NULL),
('Hampton Inn', 37, '2020-01-05', 158, NULL),
('Hampton Inn', 37, '2020-01-06', 168, NULL),
('Hampton Inn', 37, '2020-01-07', 111, NULL),
('Hampton Inn', 37, '2020-01-08', 203, NULL),
('Hampton Inn', 37, '2020-01-09', 129, NULL),
('Hampton Inn', 37, '2020-01-10', 360, NULL),
('Hampton Inn', 37, '2020-01-11', 318, NULL),
('Hampton Inn', 37, '2020-01-12', 242, NULL),
('Hampton Inn', 37, '2020-01-13', 342, NULL),
('Hampton Inn', 37, '2020-01-14', 339, NULL),
('Hampton Inn', 37, '2020-01-15', 393, NULL),
('Hampton Inn', 37, '2020-01-16', 196, NULL),
('Hampton Inn', 37, '2020-01-17', 224, NULL),
('Hampton Inn', 37, '2020-01-18', 151, NULL),
('Hampton Inn', 37, '2020-01-19', 208, NULL),
('Hampton Inn', 37, '2020-01-20', 258, NULL),
('Hampton Inn', 37, '2020-01-21', 228, NULL),
('Hampton Inn', 37, '2020-01-22', 277, NULL),
('Hampton Inn', 37, '2020-01-23', 181, NULL),
('Hampton Inn', 37, '2020-01-24', 316, NULL),
('Hampton Inn', 37, '2020-01-25', 164, NULL),
('Hampton Inn', 37, '2020-01-26', 383, NULL),
('Hampton Inn', 37, '2020-01-27', 278, NULL),
('Hampton Inn', 37, '2020-01-28', 360, NULL),
('Hampton Inn', 37, '2020-01-29', 320, NULL),
('Hampton Inn', 37, '2020-01-30', 257, NULL),
('Hampton Inn', 37, '2020-01-31', 375, NULL),
('Hampton Inn', 37, '2020-02-01', 286, NULL),
('Hampton Inn', 37, '2020-02-02', 317, NULL),
('Hampton Inn', 37, '2020-02-03', 253, NULL),
('Hampton Inn', 37, '2020-02-04', 174, NULL),
('Hampton Inn', 38, '2019-01-01', 148, NULL),
('Hampton Inn', 38, '2019-01-02', 374, NULL),
('Hampton Inn', 38, '2019-01-03', 226, NULL),
('Hampton Inn', 38, '2019-01-04', 113, NULL),
('Hampton Inn', 38, '2019-01-05', 367, NULL),
('Hampton Inn', 38, '2019-01-06', 216, NULL),
('Hampton Inn', 38, '2019-01-07', 116, NULL),
('Hampton Inn', 38, '2019-01-08', 246, NULL),
('Hampton Inn', 38, '2019-01-09', 180, NULL),
('Hampton Inn', 38, '2019-01-10', 191, NULL),
('Hampton Inn', 38, '2019-01-11', 232, NULL),
('Hampton Inn', 38, '2019-01-12', 210, NULL),
('Hampton Inn', 38, '2019-01-13', 391, NULL),
('Hampton Inn', 38, '2019-01-14', 111, NULL),
('Hampton Inn', 38, '2019-01-15', 393, NULL),
('Hampton Inn', 38, '2019-01-16', 347, NULL),
('Hampton Inn', 38, '2019-01-17', 122, NULL),
('Hampton Inn', 38, '2019-01-18', 364, NULL),
('Hampton Inn', 38, '2019-01-19', 297, NULL),
('Hampton Inn', 38, '2019-01-20', 351, NULL),
('Hampton Inn', 38, '2019-01-21', 298, NULL),
('Hampton Inn', 38, '2019-01-22', 291, NULL),
('Hampton Inn', 38, '2019-01-23', 323, NULL),
('Hampton Inn', 38, '2019-01-24', 267, NULL),
('Hampton Inn', 38, '2019-01-25', 100, NULL),
('Hampton Inn', 38, '2019-01-26', 144, NULL),
('Hampton Inn', 38, '2019-01-27', 211, NULL),
('Hampton Inn', 38, '2019-01-28', 312, NULL),
('Hampton Inn', 38, '2019-01-29', 368, NULL),
('Hampton Inn', 38, '2019-01-30', 149, NULL),
('Hampton Inn', 38, '2019-01-31', 238, NULL),
('Hampton Inn', 38, '2019-02-01', 174, NULL),
('Hampton Inn', 38, '2019-02-02', 246, NULL),
('Hampton Inn', 38, '2019-02-03', 308, NULL),
('Hampton Inn', 38, '2019-02-04', 140, NULL),
('Hampton Inn', 38, '2019-02-05', 389, NULL),
('Hampton Inn', 38, '2019-02-06', 343, NULL),
('Hampton Inn', 38, '2019-02-07', 298, NULL),
('Hampton Inn', 38, '2019-02-08', 184, NULL),
('Hampton Inn', 38, '2019-02-09', 207, NULL),
('Hampton Inn', 38, '2019-02-10', 377, NULL),
('Hampton Inn', 38, '2019-02-11', 216, NULL),
('Hampton Inn', 38, '2019-02-12', 324, NULL),
('Hampton Inn', 38, '2019-02-13', 189, NULL),
('Hampton Inn', 38, '2019-02-14', 258, NULL),
('Hampton Inn', 38, '2019-02-15', 197, NULL),
('Hampton Inn', 38, '2019-02-16', 362, NULL),
('Hampton Inn', 38, '2019-02-17', 274, NULL),
('Hampton Inn', 38, '2019-02-18', 310, NULL),
('Hampton Inn', 38, '2019-02-19', 281, NULL),
('Hampton Inn', 38, '2019-02-20', 166, NULL),
('Hampton Inn', 38, '2019-02-21', 229, NULL),
('Hampton Inn', 38, '2019-02-22', 257, NULL),
('Hampton Inn', 38, '2019-02-23', 312, NULL),
('Hampton Inn', 38, '2019-02-24', 110, NULL),
('Hampton Inn', 38, '2019-02-25', 305, NULL),
('Hampton Inn', 38, '2019-02-26', 127, NULL),
('Hampton Inn', 38, '2019-02-27', 124, NULL),
('Hampton Inn', 38, '2019-02-28', 306, NULL),
('Hampton Inn', 38, '2019-03-01', 250, NULL),
('Hampton Inn', 38, '2019-03-02', 120, NULL),
('Hampton Inn', 38, '2019-03-03', 351, NULL),
('Hampton Inn', 38, '2019-03-04', 305, NULL),
('Hampton Inn', 38, '2019-03-05', 204, NULL),
('Hampton Inn', 38, '2019-03-06', 197, NULL),
('Hampton Inn', 38, '2019-03-07', 178, NULL),
('Hampton Inn', 38, '2019-03-08', 191, NULL),
('Hampton Inn', 38, '2019-03-09', 121, NULL),
('Hampton Inn', 38, '2019-03-10', 106, NULL),
('Hampton Inn', 38, '2019-03-11', 372, NULL),
('Hampton Inn', 38, '2019-03-12', 364, NULL),
('Hampton Inn', 38, '2019-03-13', 190, NULL),
('Hampton Inn', 38, '2019-03-14', 143, NULL),
('Hampton Inn', 38, '2019-03-15', 206, NULL),
('Hampton Inn', 38, '2019-03-16', 217, NULL),
('Hampton Inn', 38, '2019-03-17', 206, NULL),
('Hampton Inn', 38, '2019-03-18', 360, NULL),
('Hampton Inn', 38, '2019-03-19', 317, NULL),
('Hampton Inn', 38, '2019-03-20', 170, NULL),
('Hampton Inn', 38, '2019-03-21', 298, NULL),
('Hampton Inn', 38, '2019-03-22', 333, NULL),
('Hampton Inn', 38, '2019-03-23', 184, NULL),
('Hampton Inn', 38, '2019-03-24', 331, NULL),
('Hampton Inn', 38, '2019-03-25', 229, NULL),
('Hampton Inn', 38, '2019-03-26', 141, NULL),
('Hampton Inn', 38, '2019-03-27', 191, NULL),
('Hampton Inn', 38, '2019-03-28', 321, NULL),
('Hampton Inn', 38, '2019-03-29', 282, NULL),
('Hampton Inn', 38, '2019-03-30', 134, NULL),
('Hampton Inn', 38, '2019-03-31', 204, NULL),
('Hampton Inn', 38, '2019-04-01', 222, NULL),
('Hampton Inn', 38, '2019-04-02', 320, NULL),
('Hampton Inn', 38, '2019-04-03', 231, NULL),
('Hampton Inn', 38, '2019-04-04', 320, NULL),
('Hampton Inn', 38, '2019-04-05', 200, NULL),
('Hampton Inn', 38, '2019-04-06', 300, NULL),
('Hampton Inn', 38, '2019-04-07', 286, NULL),
('Hampton Inn', 38, '2019-04-08', 311, NULL),
('Hampton Inn', 38, '2019-04-09', 216, NULL),
('Hampton Inn', 38, '2019-04-10', 229, NULL),
('Hampton Inn', 38, '2019-04-11', 235, NULL),
('Hampton Inn', 38, '2019-04-12', 285, NULL),
('Hampton Inn', 38, '2019-04-13', 283, NULL),
('Hampton Inn', 38, '2019-04-14', 176, NULL),
('Hampton Inn', 38, '2019-04-15', 242, NULL),
('Hampton Inn', 38, '2019-04-16', 370, NULL),
('Hampton Inn', 38, '2019-04-17', 123, NULL),
('Hampton Inn', 38, '2019-04-18', 396, NULL),
('Hampton Inn', 38, '2019-04-19', 217, NULL),
('Hampton Inn', 38, '2019-04-20', 360, NULL),
('Hampton Inn', 38, '2019-04-21', 307, NULL),
('Hampton Inn', 38, '2019-04-22', 396, NULL),
('Hampton Inn', 38, '2019-04-23', 399, NULL),
('Hampton Inn', 38, '2019-04-24', 177, NULL),
('Hampton Inn', 38, '2019-04-25', 166, NULL),
('Hampton Inn', 38, '2019-04-26', 150, NULL),
('Hampton Inn', 38, '2019-04-27', 352, NULL),
('Hampton Inn', 38, '2019-04-28', 362, NULL),
('Hampton Inn', 38, '2019-04-29', 196, NULL),
('Hampton Inn', 38, '2019-04-30', 324, NULL),
('Hampton Inn', 38, '2019-05-01', 331, NULL),
('Hampton Inn', 38, '2019-05-02', 221, NULL),
('Hampton Inn', 38, '2019-05-03', 338, NULL),
('Hampton Inn', 38, '2019-05-04', 196, NULL),
('Hampton Inn', 38, '2019-05-05', 124, NULL),
('Hampton Inn', 38, '2019-05-06', 234, NULL),
('Hampton Inn', 38, '2019-05-07', 345, NULL),
('Hampton Inn', 38, '2019-05-08', 280, NULL),
('Hampton Inn', 38, '2019-05-09', 244, NULL),
('Hampton Inn', 38, '2019-05-10', 113, NULL),
('Hampton Inn', 38, '2019-05-11', 397, NULL),
('Hampton Inn', 38, '2019-05-12', 290, NULL),
('Hampton Inn', 38, '2019-05-13', 196, NULL),
('Hampton Inn', 38, '2019-05-14', 101, NULL),
('Hampton Inn', 38, '2019-05-15', 109, NULL),
('Hampton Inn', 38, '2019-05-16', 189, NULL),
('Hampton Inn', 38, '2019-05-17', 235, NULL),
('Hampton Inn', 38, '2019-05-18', 166, NULL),
('Hampton Inn', 38, '2019-05-19', 338, NULL),
('Hampton Inn', 38, '2019-05-20', 182, NULL),
('Hampton Inn', 38, '2019-05-21', 397, NULL),
('Hampton Inn', 38, '2019-05-22', 246, NULL),
('Hampton Inn', 38, '2019-05-23', 377, NULL),
('Hampton Inn', 38, '2019-05-24', 349, NULL),
('Hampton Inn', 38, '2019-05-25', 298, NULL),
('Hampton Inn', 38, '2019-05-26', 332, NULL),
('Hampton Inn', 38, '2019-05-27', 364, NULL),
('Hampton Inn', 38, '2019-05-28', 276, NULL),
('Hampton Inn', 38, '2019-05-29', 389, NULL),
('Hampton Inn', 38, '2019-05-30', 104, NULL),
('Hampton Inn', 38, '2019-05-31', 360, NULL),
('Hampton Inn', 38, '2019-06-01', 125, NULL),
('Hampton Inn', 38, '2019-06-02', 201, NULL),
('Hampton Inn', 38, '2019-06-03', 176, NULL),
('Hampton Inn', 38, '2019-06-04', 297, NULL),
('Hampton Inn', 38, '2019-06-05', 367, NULL),
('Hampton Inn', 38, '2019-06-06', 331, NULL),
('Hampton Inn', 38, '2019-06-07', 317, NULL),
('Hampton Inn', 38, '2019-06-08', 338, NULL),
('Hampton Inn', 38, '2019-06-09', 253, NULL),
('Hampton Inn', 38, '2019-06-10', 159, NULL),
('Hampton Inn', 38, '2019-06-11', 202, NULL),
('Hampton Inn', 38, '2019-06-12', 183, NULL),
('Hampton Inn', 38, '2019-06-13', 191, NULL),
('Hampton Inn', 38, '2019-06-14', 370, NULL),
('Hampton Inn', 38, '2019-06-15', 107, NULL),
('Hampton Inn', 38, '2019-06-16', 146, NULL),
('Hampton Inn', 38, '2019-06-17', 153, NULL),
('Hampton Inn', 38, '2019-06-18', 306, NULL),
('Hampton Inn', 38, '2019-06-19', 295, NULL),
('Hampton Inn', 38, '2019-06-20', 124, NULL),
('Hampton Inn', 38, '2019-06-21', 254, NULL),
('Hampton Inn', 38, '2019-06-22', 123, NULL),
('Hampton Inn', 38, '2019-06-23', 188, NULL),
('Hampton Inn', 38, '2019-06-24', 210, NULL),
('Hampton Inn', 38, '2019-06-25', 332, NULL),
('Hampton Inn', 38, '2019-06-26', 147, NULL),
('Hampton Inn', 38, '2019-06-27', 314, NULL),
('Hampton Inn', 38, '2019-06-28', 250, NULL),
('Hampton Inn', 38, '2019-06-29', 275, NULL),
('Hampton Inn', 38, '2019-06-30', 188, NULL),
('Hampton Inn', 38, '2019-07-01', 150, NULL),
('Hampton Inn', 38, '2019-07-02', 390, NULL),
('Hampton Inn', 38, '2019-07-03', 251, NULL),
('Hampton Inn', 38, '2019-07-04', 328, NULL),
('Hampton Inn', 38, '2019-07-05', 342, NULL),
('Hampton Inn', 38, '2019-07-06', 357, NULL),
('Hampton Inn', 38, '2019-07-07', 292, NULL),
('Hampton Inn', 38, '2019-07-08', 313, NULL),
('Hampton Inn', 38, '2019-07-09', 396, NULL),
('Hampton Inn', 38, '2019-07-10', 383, NULL),
('Hampton Inn', 38, '2019-07-11', 315, NULL),
('Hampton Inn', 38, '2019-07-12', 355, NULL),
('Hampton Inn', 38, '2019-07-13', 307, NULL),
('Hampton Inn', 38, '2019-07-14', 370, NULL),
('Hampton Inn', 38, '2019-07-15', 193, NULL),
('Hampton Inn', 38, '2019-07-16', 173, NULL),
('Hampton Inn', 38, '2019-07-17', 329, NULL),
('Hampton Inn', 38, '2019-07-18', 146, NULL),
('Hampton Inn', 38, '2019-07-19', 155, NULL),
('Hampton Inn', 38, '2019-07-20', 134, NULL),
('Hampton Inn', 38, '2019-07-21', 105, NULL),
('Hampton Inn', 38, '2019-07-22', 141, NULL),
('Hampton Inn', 38, '2019-07-23', 187, NULL),
('Hampton Inn', 38, '2019-07-24', 312, NULL),
('Hampton Inn', 38, '2019-07-25', 225, NULL),
('Hampton Inn', 38, '2019-07-26', 315, NULL),
('Hampton Inn', 38, '2019-07-27', 290, NULL),
('Hampton Inn', 38, '2019-07-28', 309, NULL),
('Hampton Inn', 38, '2019-07-29', 374, NULL),
('Hampton Inn', 38, '2019-07-30', 364, NULL),
('Hampton Inn', 38, '2019-07-31', 355, NULL),
('Hampton Inn', 38, '2019-08-01', 211, NULL),
('Hampton Inn', 38, '2019-08-02', 104, NULL),
('Hampton Inn', 38, '2019-08-03', 129, NULL),
('Hampton Inn', 38, '2019-08-04', 366, NULL),
('Hampton Inn', 38, '2019-08-05', 348, NULL),
('Hampton Inn', 38, '2019-08-06', 347, NULL),
('Hampton Inn', 38, '2019-08-07', 260, NULL),
('Hampton Inn', 38, '2019-08-08', 171, NULL),
('Hampton Inn', 38, '2019-08-09', 259, NULL),
('Hampton Inn', 38, '2019-08-10', 351, NULL),
('Hampton Inn', 38, '2019-08-11', 390, NULL),
('Hampton Inn', 38, '2019-08-12', 272, NULL),
('Hampton Inn', 38, '2019-08-13', 151, NULL),
('Hampton Inn', 38, '2019-08-14', 207, NULL),
('Hampton Inn', 38, '2019-08-15', 136, NULL),
('Hampton Inn', 38, '2019-08-16', 134, NULL),
('Hampton Inn', 38, '2019-08-17', 141, NULL),
('Hampton Inn', 38, '2019-08-18', 375, NULL),
('Hampton Inn', 38, '2019-08-19', 376, NULL),
('Hampton Inn', 38, '2019-08-20', 373, NULL),
('Hampton Inn', 38, '2019-08-21', 117, NULL),
('Hampton Inn', 38, '2019-08-22', 168, NULL),
('Hampton Inn', 38, '2019-08-23', 196, NULL),
('Hampton Inn', 38, '2019-08-24', 163, NULL),
('Hampton Inn', 38, '2019-08-25', 133, NULL),
('Hampton Inn', 38, '2019-08-26', 213, NULL),
('Hampton Inn', 38, '2019-08-27', 335, NULL),
('Hampton Inn', 38, '2019-08-28', 144, NULL),
('Hampton Inn', 38, '2019-08-29', 337, NULL),
('Hampton Inn', 38, '2019-08-30', 223, NULL),
('Hampton Inn', 38, '2019-08-31', 246, NULL),
('Hampton Inn', 38, '2019-09-01', 138, NULL),
('Hampton Inn', 38, '2019-09-02', 322, NULL),
('Hampton Inn', 38, '2019-09-03', 255, NULL),
('Hampton Inn', 38, '2019-09-04', 148, NULL),
('Hampton Inn', 38, '2019-09-05', 398, NULL),
('Hampton Inn', 38, '2019-09-06', 107, NULL),
('Hampton Inn', 38, '2019-09-07', 302, NULL),
('Hampton Inn', 38, '2019-09-08', 207, NULL),
('Hampton Inn', 38, '2019-09-09', 105, NULL),
('Hampton Inn', 38, '2019-09-10', 303, 166),
('Hampton Inn', 38, '2019-09-11', 349, 166),
('Hampton Inn', 38, '2019-09-12', 220, 166),
('Hampton Inn', 38, '2019-09-13', 399, 166),
('Hampton Inn', 38, '2019-09-14', 235, 166),
('Hampton Inn', 38, '2019-09-15', 306, 166),
('Hampton Inn', 38, '2019-09-16', 355, 166),
('Hampton Inn', 38, '2019-09-17', 284, 166),
('Hampton Inn', 38, '2019-09-18', 204, 166),
('Hampton Inn', 38, '2019-09-19', 322, 166),
('Hampton Inn', 38, '2019-09-20', 397, 166),
('Hampton Inn', 38, '2019-09-21', 298, 166),
('Hampton Inn', 38, '2019-09-22', 118, 166),
('Hampton Inn', 38, '2019-09-23', 358, 166),
('Hampton Inn', 38, '2019-09-24', 203, 166),
('Hampton Inn', 38, '2019-09-25', 339, 166),
('Hampton Inn', 38, '2019-09-26', 275, 166),
('Hampton Inn', 38, '2019-09-27', 319, 166),
('Hampton Inn', 38, '2019-09-28', 133, 166),
('Hampton Inn', 38, '2019-09-29', 383, 166),
('Hampton Inn', 38, '2019-09-30', 134, 166),
('Hampton Inn', 38, '2019-10-01', 185, 166),
('Hampton Inn', 38, '2019-10-02', 351, 166),
('Hampton Inn', 38, '2019-10-03', 381, 166),
('Hampton Inn', 38, '2019-10-04', 246, 166),
('Hampton Inn', 38, '2019-10-05', 327, NULL),
('Hampton Inn', 38, '2019-10-06', 116, NULL),
('Hampton Inn', 38, '2019-10-07', 106, NULL),
('Hampton Inn', 38, '2019-10-08', 205, NULL),
('Hampton Inn', 38, '2019-10-09', 224, NULL),
('Hampton Inn', 38, '2019-10-10', 222, NULL),
('Hampton Inn', 38, '2019-10-11', 393, NULL),
('Hampton Inn', 38, '2019-10-12', 311, NULL),
('Hampton Inn', 38, '2019-10-13', 266, NULL),
('Hampton Inn', 38, '2019-10-14', 155, NULL),
('Hampton Inn', 38, '2019-10-15', 244, NULL),
('Hampton Inn', 38, '2019-10-16', 287, NULL),
('Hampton Inn', 38, '2019-10-17', 260, NULL),
('Hampton Inn', 38, '2019-10-18', 172, NULL),
('Hampton Inn', 38, '2019-10-19', 209, NULL),
('Hampton Inn', 38, '2019-10-20', 182, NULL),
('Hampton Inn', 38, '2019-10-21', 300, NULL),
('Hampton Inn', 38, '2019-10-22', 137, NULL),
('Hampton Inn', 38, '2019-10-23', 296, NULL),
('Hampton Inn', 38, '2019-10-24', 394, NULL),
('Hampton Inn', 38, '2019-10-25', 192, NULL),
('Hampton Inn', 38, '2019-10-26', 164, NULL),
('Hampton Inn', 38, '2019-10-27', 167, NULL),
('Hampton Inn', 38, '2019-10-28', 218, NULL),
('Hampton Inn', 38, '2019-10-29', 260, NULL),
('Hampton Inn', 38, '2019-10-30', 231, NULL),
('Hampton Inn', 38, '2019-10-31', 136, NULL),
('Hampton Inn', 38, '2019-11-01', 158, NULL),
('Hampton Inn', 38, '2019-11-02', 283, NULL),
('Hampton Inn', 38, '2019-11-03', 155, NULL),
('Hampton Inn', 38, '2019-11-04', 372, NULL),
('Hampton Inn', 38, '2019-11-05', 193, NULL),
('Hampton Inn', 38, '2019-11-06', 133, NULL),
('Hampton Inn', 38, '2019-11-07', 343, NULL),
('Hampton Inn', 38, '2019-11-08', 339, NULL),
('Hampton Inn', 38, '2019-11-09', 152, NULL),
('Hampton Inn', 38, '2019-11-10', 326, NULL),
('Hampton Inn', 38, '2019-11-11', 121, NULL),
('Hampton Inn', 38, '2019-11-12', 245, NULL),
('Hampton Inn', 38, '2019-11-13', 382, NULL),
('Hampton Inn', 38, '2019-11-14', 287, NULL),
('Hampton Inn', 38, '2019-11-15', 136, NULL),
('Hampton Inn', 38, '2019-11-16', 335, NULL),
('Hampton Inn', 38, '2019-11-17', 343, NULL),
('Hampton Inn', 38, '2019-11-18', 140, NULL),
('Hampton Inn', 38, '2019-11-19', 147, NULL),
('Hampton Inn', 38, '2019-11-20', 306, NULL),
('Hampton Inn', 38, '2019-11-21', 144, NULL),
('Hampton Inn', 38, '2019-11-22', 324, NULL),
('Hampton Inn', 38, '2019-11-23', 231, NULL),
('Hampton Inn', 38, '2019-11-24', 279, NULL),
('Hampton Inn', 38, '2019-11-25', 262, NULL),
('Hampton Inn', 38, '2019-11-26', 285, NULL),
('Hampton Inn', 38, '2019-11-27', 312, NULL),
('Hampton Inn', 38, '2019-11-28', 279, NULL),
('Hampton Inn', 38, '2019-11-29', 262, NULL),
('Hampton Inn', 38, '2019-11-30', 308, NULL),
('Hampton Inn', 38, '2019-12-01', 172, NULL),
('Hampton Inn', 38, '2019-12-02', 199, NULL),
('Hampton Inn', 38, '2019-12-03', 280, NULL),
('Hampton Inn', 38, '2019-12-04', 188, NULL),
('Hampton Inn', 38, '2019-12-05', 319, NULL),
('Hampton Inn', 38, '2019-12-06', 237, NULL),
('Hampton Inn', 38, '2019-12-07', 271, NULL),
('Hampton Inn', 38, '2019-12-08', 173, NULL),
('Hampton Inn', 38, '2019-12-09', 339, NULL),
('Hampton Inn', 38, '2019-12-10', 176, NULL),
('Hampton Inn', 38, '2019-12-11', 258, NULL),
('Hampton Inn', 38, '2019-12-12', 316, NULL),
('Hampton Inn', 38, '2019-12-13', 219, NULL),
('Hampton Inn', 38, '2019-12-14', 276, NULL),
('Hampton Inn', 38, '2019-12-15', 330, NULL),
('Hampton Inn', 38, '2019-12-16', 366, NULL),
('Hampton Inn', 38, '2019-12-17', 256, NULL),
('Hampton Inn', 38, '2019-12-18', 102, NULL),
('Hampton Inn', 38, '2019-12-19', 200, NULL),
('Hampton Inn', 38, '2019-12-20', 252, NULL),
('Hampton Inn', 38, '2019-12-21', 243, NULL),
('Hampton Inn', 38, '2019-12-22', 350, NULL),
('Hampton Inn', 38, '2019-12-23', 290, NULL),
('Hampton Inn', 38, '2019-12-24', 332, NULL),
('Hampton Inn', 38, '2019-12-25', 172, NULL),
('Hampton Inn', 38, '2019-12-26', 358, NULL),
('Hampton Inn', 38, '2019-12-27', 154, NULL),
('Hampton Inn', 38, '2019-12-28', 224, NULL),
('Hampton Inn', 38, '2019-12-29', 380, NULL),
('Hampton Inn', 38, '2019-12-30', 231, NULL),
('Hampton Inn', 38, '2019-12-31', 133, NULL),
('Hampton Inn', 38, '2020-01-01', 302, NULL),
('Hampton Inn', 38, '2020-01-02', 243, NULL),
('Hampton Inn', 38, '2020-01-03', 126, NULL),
('Hampton Inn', 38, '2020-01-04', 356, NULL),
('Hampton Inn', 38, '2020-01-05', 246, NULL),
('Hampton Inn', 38, '2020-01-06', 397, NULL),
('Hampton Inn', 38, '2020-01-07', 189, NULL),
('Hampton Inn', 38, '2020-01-08', 180, NULL),
('Hampton Inn', 38, '2020-01-09', 171, NULL),
('Hampton Inn', 38, '2020-01-10', 218, NULL),
('Hampton Inn', 38, '2020-01-11', 389, NULL),
('Hampton Inn', 38, '2020-01-12', 180, NULL),
('Hampton Inn', 38, '2020-01-13', 329, NULL),
('Hampton Inn', 38, '2020-01-14', 165, NULL),
('Hampton Inn', 38, '2020-01-15', 216, NULL),
('Hampton Inn', 38, '2020-01-16', 341, NULL),
('Hampton Inn', 38, '2020-01-17', 284, NULL),
('Hampton Inn', 38, '2020-01-18', 284, NULL),
('Hampton Inn', 38, '2020-01-19', 327, NULL),
('Hampton Inn', 38, '2020-01-20', 128, NULL),
('Hampton Inn', 38, '2020-01-21', 343, NULL),
('Hampton Inn', 38, '2020-01-22', 253, NULL),
('Hampton Inn', 38, '2020-01-23', 391, NULL),
('Hampton Inn', 38, '2020-01-24', 315, NULL),
('Hampton Inn', 38, '2020-01-25', 389, NULL),
('Hampton Inn', 38, '2020-01-26', 339, NULL),
('Hampton Inn', 38, '2020-01-27', 260, NULL),
('Hampton Inn', 38, '2020-01-28', 305, NULL),
('Hampton Inn', 38, '2020-01-29', 169, NULL),
('Hampton Inn', 38, '2020-01-30', 280, NULL),
('Hampton Inn', 38, '2020-01-31', 299, NULL),
('Hampton Inn', 38, '2020-02-01', 205, NULL),
('Hampton Inn', 38, '2020-02-02', 103, NULL),
('Hampton Inn', 38, '2020-02-03', 285, NULL),
('Hampton Inn', 38, '2020-02-04', 371, NULL),
('Hampton Inn', 43, '2019-01-01', 160, NULL),
('Hampton Inn', 43, '2019-01-02', 341, NULL),
('Hampton Inn', 43, '2019-01-03', 306, NULL),
('Hampton Inn', 43, '2019-01-04', 218, NULL),
('Hampton Inn', 43, '2019-01-05', 337, NULL),
('Hampton Inn', 43, '2019-01-06', 138, NULL),
('Hampton Inn', 43, '2019-01-07', 391, NULL),
('Hampton Inn', 43, '2019-01-08', 258, NULL),
('Hampton Inn', 43, '2019-01-09', 120, NULL),
('Hampton Inn', 43, '2019-01-10', 243, NULL),
('Hampton Inn', 43, '2019-01-11', 352, NULL),
('Hampton Inn', 43, '2019-01-12', 279, NULL),
('Hampton Inn', 43, '2019-01-13', 201, NULL),
('Hampton Inn', 43, '2019-01-14', 117, NULL),
('Hampton Inn', 43, '2019-01-15', 237, NULL),
('Hampton Inn', 43, '2019-01-16', 265, NULL),
('Hampton Inn', 43, '2019-01-17', 350, NULL),
('Hampton Inn', 43, '2019-01-18', 318, NULL),
('Hampton Inn', 43, '2019-01-19', 246, NULL),
('Hampton Inn', 43, '2019-01-20', 218, NULL),
('Hampton Inn', 43, '2019-01-21', 168, NULL),
('Hampton Inn', 43, '2019-01-22', 270, NULL),
('Hampton Inn', 43, '2019-01-23', 243, NULL),
('Hampton Inn', 43, '2019-01-24', 301, NULL),
('Hampton Inn', 43, '2019-01-25', 365, NULL),
('Hampton Inn', 43, '2019-01-26', 297, NULL),
('Hampton Inn', 43, '2019-01-27', 126, NULL),
('Hampton Inn', 43, '2019-01-28', 118, NULL),
('Hampton Inn', 43, '2019-01-29', 301, NULL),
('Hampton Inn', 43, '2019-01-30', 319, NULL),
('Hampton Inn', 43, '2019-01-31', 124, NULL),
('Hampton Inn', 43, '2019-02-01', 223, NULL),
('Hampton Inn', 43, '2019-02-02', 260, NULL),
('Hampton Inn', 43, '2019-02-03', 112, NULL),
('Hampton Inn', 43, '2019-02-04', 309, NULL),
('Hampton Inn', 43, '2019-02-05', 215, NULL),
('Hampton Inn', 43, '2019-02-06', 263, NULL),
('Hampton Inn', 43, '2019-02-07', 374, NULL),
('Hampton Inn', 43, '2019-02-08', 265, NULL),
('Hampton Inn', 43, '2019-02-09', 343, NULL),
('Hampton Inn', 43, '2019-02-10', 237, NULL),
('Hampton Inn', 43, '2019-02-11', 389, NULL),
('Hampton Inn', 43, '2019-02-12', 365, NULL),
('Hampton Inn', 43, '2019-02-13', 195, NULL),
('Hampton Inn', 43, '2019-02-14', 355, NULL),
('Hampton Inn', 43, '2019-02-15', 322, NULL),
('Hampton Inn', 43, '2019-02-16', 273, NULL),
('Hampton Inn', 43, '2019-02-17', 338, NULL),
('Hampton Inn', 43, '2019-02-18', 205, NULL),
('Hampton Inn', 43, '2019-02-19', 205, NULL),
('Hampton Inn', 43, '2019-02-20', 109, NULL),
('Hampton Inn', 43, '2019-02-21', 283, NULL),
('Hampton Inn', 43, '2019-02-22', 131, NULL),
('Hampton Inn', 43, '2019-02-23', 149, NULL),
('Hampton Inn', 43, '2019-02-24', 175, NULL),
('Hampton Inn', 43, '2019-02-25', 270, NULL),
('Hampton Inn', 43, '2019-02-26', 387, NULL),
('Hampton Inn', 43, '2019-02-27', 258, NULL),
('Hampton Inn', 43, '2019-02-28', 359, NULL),
('Hampton Inn', 43, '2019-03-01', 294, NULL),
('Hampton Inn', 43, '2019-03-02', 348, NULL),
('Hampton Inn', 43, '2019-03-03', 228, NULL),
('Hampton Inn', 43, '2019-03-04', 108, NULL),
('Hampton Inn', 43, '2019-03-05', 232, NULL),
('Hampton Inn', 43, '2019-03-06', 377, NULL),
('Hampton Inn', 43, '2019-03-07', 364, NULL),
('Hampton Inn', 43, '2019-03-08', 290, NULL),
('Hampton Inn', 43, '2019-03-09', 324, NULL),
('Hampton Inn', 43, '2019-03-10', 351, NULL),
('Hampton Inn', 43, '2019-03-11', 153, NULL),
('Hampton Inn', 43, '2019-03-12', 241, NULL),
('Hampton Inn', 43, '2019-03-13', 258, NULL),
('Hampton Inn', 43, '2019-03-14', 300, NULL),
('Hampton Inn', 43, '2019-03-15', 266, NULL),
('Hampton Inn', 43, '2019-03-16', 252, NULL),
('Hampton Inn', 43, '2019-03-17', 165, NULL),
('Hampton Inn', 43, '2019-03-18', 329, NULL),
('Hampton Inn', 43, '2019-03-19', 229, NULL),
('Hampton Inn', 43, '2019-03-20', 279, NULL),
('Hampton Inn', 43, '2019-03-21', 218, NULL),
('Hampton Inn', 43, '2019-03-22', 102, NULL),
('Hampton Inn', 43, '2019-03-23', 114, NULL),
('Hampton Inn', 43, '2019-03-24', 201, NULL),
('Hampton Inn', 43, '2019-03-25', 227, NULL),
('Hampton Inn', 43, '2019-03-26', 313, NULL),
('Hampton Inn', 43, '2019-03-27', 318, NULL),
('Hampton Inn', 43, '2019-03-28', 309, NULL),
('Hampton Inn', 43, '2019-03-29', 258, NULL),
('Hampton Inn', 43, '2019-03-30', 320, NULL),
('Hampton Inn', 43, '2019-03-31', 251, NULL),
('Hampton Inn', 43, '2019-04-01', 393, NULL),
('Hampton Inn', 43, '2019-04-02', 112, NULL),
('Hampton Inn', 43, '2019-04-03', 348, NULL),
('Hampton Inn', 43, '2019-04-04', 100, NULL),
('Hampton Inn', 43, '2019-04-05', 173, NULL),
('Hampton Inn', 43, '2019-04-06', 286, NULL),
('Hampton Inn', 43, '2019-04-07', 365, NULL),
('Hampton Inn', 43, '2019-04-08', 309, NULL),
('Hampton Inn', 43, '2019-04-09', 387, NULL),
('Hampton Inn', 43, '2019-04-10', 397, NULL),
('Hampton Inn', 43, '2019-04-11', 209, NULL),
('Hampton Inn', 43, '2019-04-12', 326, NULL),
('Hampton Inn', 43, '2019-04-13', 221, NULL),
('Hampton Inn', 43, '2019-04-14', 339, NULL),
('Hampton Inn', 43, '2019-04-15', 343, NULL),
('Hampton Inn', 43, '2019-04-16', 203, NULL),
('Hampton Inn', 43, '2019-04-17', 207, NULL),
('Hampton Inn', 43, '2019-04-18', 125, NULL),
('Hampton Inn', 43, '2019-04-19', 183, NULL),
('Hampton Inn', 43, '2019-04-20', 103, NULL),
('Hampton Inn', 43, '2019-04-21', 262, NULL),
('Hampton Inn', 43, '2019-04-22', 253, NULL),
('Hampton Inn', 43, '2019-04-23', 393, NULL),
('Hampton Inn', 43, '2019-04-24', 121, NULL),
('Hampton Inn', 43, '2019-04-25', 317, NULL),
('Hampton Inn', 43, '2019-04-26', 122, NULL),
('Hampton Inn', 43, '2019-04-27', 111, NULL),
('Hampton Inn', 43, '2019-04-28', 320, NULL),
('Hampton Inn', 43, '2019-04-29', 297, NULL),
('Hampton Inn', 43, '2019-04-30', 126, NULL),
('Hampton Inn', 43, '2019-05-01', 377, NULL),
('Hampton Inn', 43, '2019-05-02', 119, NULL),
('Hampton Inn', 43, '2019-05-03', 174, NULL),
('Hampton Inn', 43, '2019-05-04', 145, NULL),
('Hampton Inn', 43, '2019-05-05', 272, NULL),
('Hampton Inn', 43, '2019-05-06', 169, NULL),
('Hampton Inn', 43, '2019-05-07', 379, NULL),
('Hampton Inn', 43, '2019-05-08', 104, NULL),
('Hampton Inn', 43, '2019-05-09', 163, NULL),
('Hampton Inn', 43, '2019-05-10', 319, NULL),
('Hampton Inn', 43, '2019-05-11', 178, NULL),
('Hampton Inn', 43, '2019-05-12', 290, NULL),
('Hampton Inn', 43, '2019-05-13', 236, NULL),
('Hampton Inn', 43, '2019-05-14', 344, NULL),
('Hampton Inn', 43, '2019-05-15', 184, NULL),
('Hampton Inn', 43, '2019-05-16', 383, NULL),
('Hampton Inn', 43, '2019-05-17', 323, NULL),
('Hampton Inn', 43, '2019-05-18', 304, NULL),
('Hampton Inn', 43, '2019-05-19', 187, NULL),
('Hampton Inn', 43, '2019-05-20', 163, NULL),
('Hampton Inn', 43, '2019-05-21', 118, NULL),
('Hampton Inn', 43, '2019-05-22', 133, NULL),
('Hampton Inn', 43, '2019-05-23', 120, NULL),
('Hampton Inn', 43, '2019-05-24', 288, NULL),
('Hampton Inn', 43, '2019-05-25', 204, NULL),
('Hampton Inn', 43, '2019-05-26', 171, NULL),
('Hampton Inn', 43, '2019-05-27', 333, NULL),
('Hampton Inn', 43, '2019-05-28', 111, NULL),
('Hampton Inn', 43, '2019-05-29', 282, NULL),
('Hampton Inn', 43, '2019-05-30', 353, NULL),
('Hampton Inn', 43, '2019-05-31', 182, NULL),
('Hampton Inn', 43, '2019-06-01', 389, NULL),
('Hampton Inn', 43, '2019-06-02', 211, NULL),
('Hampton Inn', 43, '2019-06-03', 291, NULL),
('Hampton Inn', 43, '2019-06-04', 249, NULL),
('Hampton Inn', 43, '2019-06-05', 114, NULL),
('Hampton Inn', 43, '2019-06-06', 306, NULL),
('Hampton Inn', 43, '2019-06-07', 318, NULL),
('Hampton Inn', 43, '2019-06-08', 164, NULL),
('Hampton Inn', 43, '2019-06-09', 103, NULL),
('Hampton Inn', 43, '2019-06-10', 385, NULL),
('Hampton Inn', 43, '2019-06-11', 165, NULL),
('Hampton Inn', 43, '2019-06-12', 109, NULL),
('Hampton Inn', 43, '2019-06-13', 327, NULL),
('Hampton Inn', 43, '2019-06-14', 375, NULL),
('Hampton Inn', 43, '2019-06-15', 350, NULL),
('Hampton Inn', 43, '2019-06-16', 187, NULL),
('Hampton Inn', 43, '2019-06-17', 108, NULL),
('Hampton Inn', 43, '2019-06-18', 325, NULL),
('Hampton Inn', 43, '2019-06-19', 317, NULL),
('Hampton Inn', 43, '2019-06-20', 116, NULL),
('Hampton Inn', 43, '2019-06-21', 169, NULL),
('Hampton Inn', 43, '2019-06-22', 362, NULL),
('Hampton Inn', 43, '2019-06-23', 358, NULL),
('Hampton Inn', 43, '2019-06-24', 341, NULL),
('Hampton Inn', 43, '2019-06-25', 117, NULL),
('Hampton Inn', 43, '2019-06-26', 262, NULL),
('Hampton Inn', 43, '2019-06-27', 227, NULL),
('Hampton Inn', 43, '2019-06-28', 391, NULL),
('Hampton Inn', 43, '2019-06-29', 149, NULL),
('Hampton Inn', 43, '2019-06-30', 204, NULL),
('Hampton Inn', 43, '2019-07-01', 154, NULL),
('Hampton Inn', 43, '2019-07-02', 212, NULL),
('Hampton Inn', 43, '2019-07-03', 376, NULL),
('Hampton Inn', 43, '2019-07-04', 214, NULL),
('Hampton Inn', 43, '2019-07-05', 325, NULL),
('Hampton Inn', 43, '2019-07-06', 297, NULL),
('Hampton Inn', 43, '2019-07-07', 370, NULL),
('Hampton Inn', 43, '2019-07-08', 300, NULL),
('Hampton Inn', 43, '2019-07-09', 135, NULL),
('Hampton Inn', 43, '2019-07-10', 379, NULL),
('Hampton Inn', 43, '2019-07-11', 241, NULL),
('Hampton Inn', 43, '2019-07-12', 338, NULL),
('Hampton Inn', 43, '2019-07-13', 143, NULL),
('Hampton Inn', 43, '2019-07-14', 280, NULL),
('Hampton Inn', 43, '2019-07-15', 166, NULL),
('Hampton Inn', 43, '2019-07-16', 233, NULL),
('Hampton Inn', 43, '2019-07-17', 311, NULL),
('Hampton Inn', 43, '2019-07-18', 253, NULL),
('Hampton Inn', 43, '2019-07-19', 349, NULL),
('Hampton Inn', 43, '2019-07-20', 113, NULL),
('Hampton Inn', 43, '2019-07-21', 397, NULL),
('Hampton Inn', 43, '2019-07-22', 276, NULL),
('Hampton Inn', 43, '2019-07-23', 263, NULL),
('Hampton Inn', 43, '2019-07-24', 143, NULL),
('Hampton Inn', 43, '2019-07-25', 315, NULL),
('Hampton Inn', 43, '2019-07-26', 150, NULL),
('Hampton Inn', 43, '2019-07-27', 312, NULL),
('Hampton Inn', 43, '2019-07-28', 307, NULL),
('Hampton Inn', 43, '2019-07-29', 160, NULL),
('Hampton Inn', 43, '2019-07-30', 364, NULL),
('Hampton Inn', 43, '2019-07-31', 399, NULL),
('Hampton Inn', 43, '2019-08-01', 359, NULL),
('Hampton Inn', 43, '2019-08-02', 218, NULL),
('Hampton Inn', 43, '2019-08-03', 193, NULL),
('Hampton Inn', 43, '2019-08-04', 379, NULL),
('Hampton Inn', 43, '2019-08-05', 190, NULL),
('Hampton Inn', 43, '2019-08-06', 242, NULL),
('Hampton Inn', 43, '2019-08-07', 347, NULL),
('Hampton Inn', 43, '2019-08-08', 268, NULL),
('Hampton Inn', 43, '2019-08-09', 226, NULL),
('Hampton Inn', 43, '2019-08-10', 154, NULL),
('Hampton Inn', 43, '2019-08-11', 349, NULL),
('Hampton Inn', 43, '2019-08-12', 211, NULL),
('Hampton Inn', 43, '2019-08-13', 140, NULL),
('Hampton Inn', 43, '2019-08-14', 297, NULL),
('Hampton Inn', 43, '2019-08-15', 265, NULL),
('Hampton Inn', 43, '2019-08-16', 185, NULL),
('Hampton Inn', 43, '2019-08-17', 114, NULL),
('Hampton Inn', 43, '2019-08-18', 231, NULL),
('Hampton Inn', 43, '2019-08-19', 228, NULL),
('Hampton Inn', 43, '2019-08-20', 137, NULL),
('Hampton Inn', 43, '2019-08-21', 311, NULL),
('Hampton Inn', 43, '2019-08-22', 147, NULL),
('Hampton Inn', 43, '2019-08-23', 231, NULL),
('Hampton Inn', 43, '2019-08-24', 158, NULL),
('Hampton Inn', 43, '2019-08-25', 280, NULL),
('Hampton Inn', 43, '2019-08-26', 164, NULL),
('Hampton Inn', 43, '2019-08-27', 108, NULL),
('Hampton Inn', 43, '2019-08-28', 355, NULL),
('Hampton Inn', 43, '2019-08-29', 140, NULL),
('Hampton Inn', 43, '2019-08-30', 336, NULL),
('Hampton Inn', 43, '2019-08-31', 175, NULL),
('Hampton Inn', 43, '2019-09-01', 174, NULL),
('Hampton Inn', 43, '2019-09-02', 237, NULL),
('Hampton Inn', 43, '2019-09-03', 254, NULL),
('Hampton Inn', 43, '2019-09-04', 333, NULL),
('Hampton Inn', 43, '2019-09-05', 159, NULL),
('Hampton Inn', 43, '2019-09-06', 328, NULL),
('Hampton Inn', 43, '2019-09-07', 347, NULL),
('Hampton Inn', 43, '2019-09-08', 209, NULL),
('Hampton Inn', 43, '2019-09-09', 262, NULL),
('Hampton Inn', 43, '2019-09-10', 388, NULL),
('Hampton Inn', 43, '2019-09-11', 138, NULL),
('Hampton Inn', 43, '2019-09-12', 129, NULL),
('Hampton Inn', 43, '2019-09-13', 236, NULL),
('Hampton Inn', 43, '2019-09-14', 338, NULL),
('Hampton Inn', 43, '2019-09-15', 210, 193),
('Hampton Inn', 43, '2019-09-16', 103, 193),
('Hampton Inn', 43, '2019-09-17', 117, 193),
('Hampton Inn', 43, '2019-09-18', 368, 193),
('Hampton Inn', 43, '2019-09-19', 198, 193),
('Hampton Inn', 43, '2019-09-20', 195, 193),
('Hampton Inn', 43, '2019-09-21', 380, 193),
('Hampton Inn', 43, '2019-09-22', 166, NULL),
('Hampton Inn', 43, '2019-09-23', 165, NULL),
('Hampton Inn', 43, '2019-09-24', 301, NULL),
('Hampton Inn', 43, '2019-09-25', 330, NULL),
('Hampton Inn', 43, '2019-09-26', 361, NULL),
('Hampton Inn', 43, '2019-09-27', 112, NULL),
('Hampton Inn', 43, '2019-09-28', 115, NULL),
('Hampton Inn', 43, '2019-09-29', 226, NULL),
('Hampton Inn', 43, '2019-09-30', 216, NULL),
('Hampton Inn', 43, '2019-10-01', 119, NULL),
('Hampton Inn', 43, '2019-10-02', 267, NULL),
('Hampton Inn', 43, '2019-10-03', 113, NULL),
('Hampton Inn', 43, '2019-10-04', 336, NULL),
('Hampton Inn', 43, '2019-10-05', 287, NULL),
('Hampton Inn', 43, '2019-10-06', 239, NULL),
('Hampton Inn', 43, '2019-10-07', 242, NULL),
('Hampton Inn', 43, '2019-10-08', 168, NULL),
('Hampton Inn', 43, '2019-10-09', 245, NULL),
('Hampton Inn', 43, '2019-10-10', 192, NULL),
('Hampton Inn', 43, '2019-10-11', 318, NULL),
('Hampton Inn', 43, '2019-10-12', 229, NULL),
('Hampton Inn', 43, '2019-10-13', 124, NULL),
('Hampton Inn', 43, '2019-10-14', 346, NULL),
('Hampton Inn', 43, '2019-10-15', 260, NULL),
('Hampton Inn', 43, '2019-10-16', 250, NULL),
('Hampton Inn', 43, '2019-10-17', 133, NULL),
('Hampton Inn', 43, '2019-10-18', 183, NULL),
('Hampton Inn', 43, '2019-10-19', 211, NULL),
('Hampton Inn', 43, '2019-10-20', 349, NULL),
('Hampton Inn', 43, '2019-10-21', 277, NULL),
('Hampton Inn', 43, '2019-10-22', 253, NULL),
('Hampton Inn', 43, '2019-10-23', 234, NULL),
('Hampton Inn', 43, '2019-10-24', 142, NULL),
('Hampton Inn', 43, '2019-10-25', 116, NULL),
('Hampton Inn', 43, '2019-10-26', 187, NULL),
('Hampton Inn', 43, '2019-10-27', 215, NULL),
('Hampton Inn', 43, '2019-10-28', 148, NULL),
('Hampton Inn', 43, '2019-10-29', 148, NULL),
('Hampton Inn', 43, '2019-10-30', 327, NULL),
('Hampton Inn', 43, '2019-10-31', 194, NULL),
('Hampton Inn', 43, '2019-11-01', 344, NULL),
('Hampton Inn', 43, '2019-11-02', 160, NULL),
('Hampton Inn', 43, '2019-11-03', 150, NULL),
('Hampton Inn', 43, '2019-11-04', 131, NULL),
('Hampton Inn', 43, '2019-11-05', 247, NULL),
('Hampton Inn', 43, '2019-11-06', 158, NULL),
('Hampton Inn', 43, '2019-11-07', 235, NULL),
('Hampton Inn', 43, '2019-11-08', 317, NULL),
('Hampton Inn', 43, '2019-11-09', 284, NULL),
('Hampton Inn', 43, '2019-11-10', 271, NULL),
('Hampton Inn', 43, '2019-11-11', 364, NULL),
('Hampton Inn', 43, '2019-11-12', 221, NULL),
('Hampton Inn', 43, '2019-11-13', 172, NULL),
('Hampton Inn', 43, '2019-11-14', 358, NULL),
('Hampton Inn', 43, '2019-11-15', 370, NULL),
('Hampton Inn', 43, '2019-11-16', 272, NULL),
('Hampton Inn', 43, '2019-11-17', 227, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 43, '2019-11-18', 257, NULL),
('Hampton Inn', 43, '2019-11-19', 220, NULL),
('Hampton Inn', 43, '2019-11-20', 161, NULL),
('Hampton Inn', 43, '2019-11-21', 246, NULL),
('Hampton Inn', 43, '2019-11-22', 134, NULL),
('Hampton Inn', 43, '2019-11-23', 394, NULL),
('Hampton Inn', 43, '2019-11-24', 350, NULL),
('Hampton Inn', 43, '2019-11-25', 360, NULL),
('Hampton Inn', 43, '2019-11-26', 373, NULL),
('Hampton Inn', 43, '2019-11-27', 100, NULL),
('Hampton Inn', 43, '2019-11-28', 286, NULL),
('Hampton Inn', 43, '2019-11-29', 198, NULL),
('Hampton Inn', 43, '2019-11-30', 220, NULL),
('Hampton Inn', 43, '2019-12-01', 191, NULL),
('Hampton Inn', 43, '2019-12-02', 213, NULL),
('Hampton Inn', 43, '2019-12-03', 264, NULL),
('Hampton Inn', 43, '2019-12-04', 316, NULL),
('Hampton Inn', 43, '2019-12-05', 223, NULL),
('Hampton Inn', 43, '2019-12-06', 385, NULL),
('Hampton Inn', 43, '2019-12-07', 252, NULL),
('Hampton Inn', 43, '2019-12-08', 228, NULL),
('Hampton Inn', 43, '2019-12-09', 197, NULL),
('Hampton Inn', 43, '2019-12-10', 143, NULL),
('Hampton Inn', 43, '2019-12-11', 295, NULL),
('Hampton Inn', 43, '2019-12-12', 188, NULL),
('Hampton Inn', 43, '2019-12-13', 110, NULL),
('Hampton Inn', 43, '2019-12-14', 221, NULL),
('Hampton Inn', 43, '2019-12-15', 126, NULL),
('Hampton Inn', 43, '2019-12-16', 372, NULL),
('Hampton Inn', 43, '2019-12-17', 380, NULL),
('Hampton Inn', 43, '2019-12-18', 287, NULL),
('Hampton Inn', 43, '2019-12-19', 372, NULL),
('Hampton Inn', 43, '2019-12-20', 196, NULL),
('Hampton Inn', 43, '2019-12-21', 179, NULL),
('Hampton Inn', 43, '2019-12-22', 348, NULL),
('Hampton Inn', 43, '2019-12-23', 331, NULL),
('Hampton Inn', 43, '2019-12-24', 253, NULL),
('Hampton Inn', 43, '2019-12-25', 211, NULL),
('Hampton Inn', 43, '2019-12-26', 200, NULL),
('Hampton Inn', 43, '2019-12-27', 155, NULL),
('Hampton Inn', 43, '2019-12-28', 238, NULL),
('Hampton Inn', 43, '2019-12-29', 289, NULL),
('Hampton Inn', 43, '2019-12-30', 151, NULL),
('Hampton Inn', 43, '2019-12-31', 337, NULL),
('Hampton Inn', 43, '2020-01-01', 165, NULL),
('Hampton Inn', 43, '2020-01-02', 399, NULL),
('Hampton Inn', 43, '2020-01-03', 164, NULL),
('Hampton Inn', 43, '2020-01-04', 188, NULL),
('Hampton Inn', 43, '2020-01-05', 354, NULL),
('Hampton Inn', 43, '2020-01-06', 182, NULL),
('Hampton Inn', 43, '2020-01-07', 214, NULL),
('Hampton Inn', 43, '2020-01-08', 191, NULL),
('Hampton Inn', 43, '2020-01-09', 369, NULL),
('Hampton Inn', 43, '2020-01-10', 208, NULL),
('Hampton Inn', 43, '2020-01-11', 292, NULL),
('Hampton Inn', 43, '2020-01-12', 376, NULL),
('Hampton Inn', 43, '2020-01-13', 221, NULL),
('Hampton Inn', 43, '2020-01-14', 308, NULL),
('Hampton Inn', 43, '2020-01-15', 100, NULL),
('Hampton Inn', 43, '2020-01-16', 116, NULL),
('Hampton Inn', 43, '2020-01-17', 350, NULL),
('Hampton Inn', 43, '2020-01-18', 268, NULL),
('Hampton Inn', 43, '2020-01-19', 313, NULL),
('Hampton Inn', 43, '2020-01-20', 369, NULL),
('Hampton Inn', 43, '2020-01-21', 333, NULL),
('Hampton Inn', 43, '2020-01-22', 332, NULL),
('Hampton Inn', 43, '2020-01-23', 112, NULL),
('Hampton Inn', 43, '2020-01-24', 227, NULL),
('Hampton Inn', 43, '2020-01-25', 154, NULL),
('Hampton Inn', 43, '2020-01-26', 148, NULL),
('Hampton Inn', 43, '2020-01-27', 365, NULL),
('Hampton Inn', 43, '2020-01-28', 344, NULL),
('Hampton Inn', 43, '2020-01-29', 387, NULL),
('Hampton Inn', 43, '2020-01-30', 233, NULL),
('Hampton Inn', 43, '2020-01-31', 272, NULL),
('Hampton Inn', 43, '2020-02-01', 369, NULL),
('Hampton Inn', 43, '2020-02-02', 361, NULL),
('Hampton Inn', 43, '2020-02-03', 266, NULL),
('Hampton Inn', 43, '2020-02-04', 332, NULL),
('Hampton Inn', 44, '2019-01-01', 255, NULL),
('Hampton Inn', 44, '2019-01-02', 182, NULL),
('Hampton Inn', 44, '2019-01-03', 153, NULL),
('Hampton Inn', 44, '2019-01-04', 352, NULL),
('Hampton Inn', 44, '2019-01-05', 186, NULL),
('Hampton Inn', 44, '2019-01-06', 244, NULL),
('Hampton Inn', 44, '2019-01-07', 311, NULL),
('Hampton Inn', 44, '2019-01-08', 150, NULL),
('Hampton Inn', 44, '2019-01-09', 259, NULL),
('Hampton Inn', 44, '2019-01-10', 240, NULL),
('Hampton Inn', 44, '2019-01-11', 362, NULL),
('Hampton Inn', 44, '2019-01-12', 367, NULL),
('Hampton Inn', 44, '2019-01-13', 335, NULL),
('Hampton Inn', 44, '2019-01-14', 154, NULL),
('Hampton Inn', 44, '2019-01-15', 205, NULL),
('Hampton Inn', 44, '2019-01-16', 183, NULL),
('Hampton Inn', 44, '2019-01-17', 386, NULL),
('Hampton Inn', 44, '2019-01-18', 397, NULL),
('Hampton Inn', 44, '2019-01-19', 238, NULL),
('Hampton Inn', 44, '2019-01-20', 235, NULL),
('Hampton Inn', 44, '2019-01-21', 146, NULL),
('Hampton Inn', 44, '2019-01-22', 376, NULL),
('Hampton Inn', 44, '2019-01-23', 144, NULL),
('Hampton Inn', 44, '2019-01-24', 306, NULL),
('Hampton Inn', 44, '2019-01-25', 222, NULL),
('Hampton Inn', 44, '2019-01-26', 351, NULL),
('Hampton Inn', 44, '2019-01-27', 198, NULL),
('Hampton Inn', 44, '2019-01-28', 158, NULL),
('Hampton Inn', 44, '2019-01-29', 302, NULL),
('Hampton Inn', 44, '2019-01-30', 149, NULL),
('Hampton Inn', 44, '2019-01-31', 107, NULL),
('Hampton Inn', 44, '2019-02-01', 192, NULL),
('Hampton Inn', 44, '2019-02-02', 161, NULL),
('Hampton Inn', 44, '2019-02-03', 134, NULL),
('Hampton Inn', 44, '2019-02-04', 125, NULL),
('Hampton Inn', 44, '2019-02-05', 107, NULL),
('Hampton Inn', 44, '2019-02-06', 185, NULL),
('Hampton Inn', 44, '2019-02-07', 276, NULL),
('Hampton Inn', 44, '2019-02-08', 371, NULL),
('Hampton Inn', 44, '2019-02-09', 395, NULL),
('Hampton Inn', 44, '2019-02-10', 255, NULL),
('Hampton Inn', 44, '2019-02-11', 296, NULL),
('Hampton Inn', 44, '2019-02-12', 150, NULL),
('Hampton Inn', 44, '2019-02-13', 311, NULL),
('Hampton Inn', 44, '2019-02-14', 301, NULL),
('Hampton Inn', 44, '2019-02-15', 320, NULL),
('Hampton Inn', 44, '2019-02-16', 180, NULL),
('Hampton Inn', 44, '2019-02-17', 169, NULL),
('Hampton Inn', 44, '2019-02-18', 298, NULL),
('Hampton Inn', 44, '2019-02-19', 383, NULL),
('Hampton Inn', 44, '2019-02-20', 251, NULL),
('Hampton Inn', 44, '2019-02-21', 328, NULL),
('Hampton Inn', 44, '2019-02-22', 384, NULL),
('Hampton Inn', 44, '2019-02-23', 311, NULL),
('Hampton Inn', 44, '2019-02-24', 145, NULL),
('Hampton Inn', 44, '2019-02-25', 336, NULL),
('Hampton Inn', 44, '2019-02-26', 253, NULL),
('Hampton Inn', 44, '2019-02-27', 220, NULL),
('Hampton Inn', 44, '2019-02-28', 180, NULL),
('Hampton Inn', 44, '2019-03-01', 322, NULL),
('Hampton Inn', 44, '2019-03-02', 379, NULL),
('Hampton Inn', 44, '2019-03-03', 286, NULL),
('Hampton Inn', 44, '2019-03-04', 124, NULL),
('Hampton Inn', 44, '2019-03-05', 145, NULL),
('Hampton Inn', 44, '2019-03-06', 293, NULL),
('Hampton Inn', 44, '2019-03-07', 283, NULL),
('Hampton Inn', 44, '2019-03-08', 175, NULL),
('Hampton Inn', 44, '2019-03-09', 257, NULL),
('Hampton Inn', 44, '2019-03-10', 138, NULL),
('Hampton Inn', 44, '2019-03-11', 149, NULL),
('Hampton Inn', 44, '2019-03-12', 314, NULL),
('Hampton Inn', 44, '2019-03-13', 320, NULL),
('Hampton Inn', 44, '2019-03-14', 372, NULL),
('Hampton Inn', 44, '2019-03-15', 312, NULL),
('Hampton Inn', 44, '2019-03-16', 212, NULL),
('Hampton Inn', 44, '2019-03-17', 106, NULL),
('Hampton Inn', 44, '2019-03-18', 169, NULL),
('Hampton Inn', 44, '2019-03-19', 393, NULL),
('Hampton Inn', 44, '2019-03-20', 186, NULL),
('Hampton Inn', 44, '2019-03-21', 397, NULL),
('Hampton Inn', 44, '2019-03-22', 309, NULL),
('Hampton Inn', 44, '2019-03-23', 218, NULL),
('Hampton Inn', 44, '2019-03-24', 214, NULL),
('Hampton Inn', 44, '2019-03-25', 350, NULL),
('Hampton Inn', 44, '2019-03-26', 142, NULL),
('Hampton Inn', 44, '2019-03-27', 317, NULL),
('Hampton Inn', 44, '2019-03-28', 182, NULL),
('Hampton Inn', 44, '2019-03-29', 343, NULL),
('Hampton Inn', 44, '2019-03-30', 197, NULL),
('Hampton Inn', 44, '2019-03-31', 244, NULL),
('Hampton Inn', 44, '2019-04-01', 298, NULL),
('Hampton Inn', 44, '2019-04-02', 399, NULL),
('Hampton Inn', 44, '2019-04-03', 345, NULL),
('Hampton Inn', 44, '2019-04-04', 341, NULL),
('Hampton Inn', 44, '2019-04-05', 167, NULL),
('Hampton Inn', 44, '2019-04-06', 130, NULL),
('Hampton Inn', 44, '2019-04-07', 269, NULL),
('Hampton Inn', 44, '2019-04-08', 210, NULL),
('Hampton Inn', 44, '2019-04-09', 288, NULL),
('Hampton Inn', 44, '2019-04-10', 302, NULL),
('Hampton Inn', 44, '2019-04-11', 243, NULL),
('Hampton Inn', 44, '2019-04-12', 378, NULL),
('Hampton Inn', 44, '2019-04-13', 156, NULL),
('Hampton Inn', 44, '2019-04-14', 169, NULL),
('Hampton Inn', 44, '2019-04-15', 293, NULL),
('Hampton Inn', 44, '2019-04-16', 102, NULL),
('Hampton Inn', 44, '2019-04-17', 269, NULL),
('Hampton Inn', 44, '2019-04-18', 239, NULL),
('Hampton Inn', 44, '2019-04-19', 165, NULL),
('Hampton Inn', 44, '2019-04-20', 233, NULL),
('Hampton Inn', 44, '2019-04-21', 287, NULL),
('Hampton Inn', 44, '2019-04-22', 278, NULL),
('Hampton Inn', 44, '2019-04-23', 365, NULL),
('Hampton Inn', 44, '2019-04-24', 272, NULL),
('Hampton Inn', 44, '2019-04-25', 386, NULL),
('Hampton Inn', 44, '2019-04-26', 360, NULL),
('Hampton Inn', 44, '2019-04-27', 299, NULL),
('Hampton Inn', 44, '2019-04-28', 112, NULL),
('Hampton Inn', 44, '2019-04-29', 200, NULL),
('Hampton Inn', 44, '2019-04-30', 159, NULL),
('Hampton Inn', 44, '2019-05-01', 192, NULL),
('Hampton Inn', 44, '2019-05-02', 133, NULL),
('Hampton Inn', 44, '2019-05-03', 359, NULL),
('Hampton Inn', 44, '2019-05-04', 335, NULL),
('Hampton Inn', 44, '2019-05-05', 286, NULL),
('Hampton Inn', 44, '2019-05-06', 346, NULL),
('Hampton Inn', 44, '2019-05-07', 159, NULL),
('Hampton Inn', 44, '2019-05-08', 182, NULL),
('Hampton Inn', 44, '2019-05-09', 286, NULL),
('Hampton Inn', 44, '2019-05-10', 259, NULL),
('Hampton Inn', 44, '2019-05-11', 197, NULL),
('Hampton Inn', 44, '2019-05-12', 179, NULL),
('Hampton Inn', 44, '2019-05-13', 192, NULL),
('Hampton Inn', 44, '2019-05-14', 120, NULL),
('Hampton Inn', 44, '2019-05-15', 195, NULL),
('Hampton Inn', 44, '2019-05-16', 345, NULL),
('Hampton Inn', 44, '2019-05-17', 214, NULL),
('Hampton Inn', 44, '2019-05-18', 323, NULL),
('Hampton Inn', 44, '2019-05-19', 123, NULL),
('Hampton Inn', 44, '2019-05-20', 171, NULL),
('Hampton Inn', 44, '2019-05-21', 198, NULL),
('Hampton Inn', 44, '2019-05-22', 125, NULL),
('Hampton Inn', 44, '2019-05-23', 267, NULL),
('Hampton Inn', 44, '2019-05-24', 296, NULL),
('Hampton Inn', 44, '2019-05-25', 328, NULL),
('Hampton Inn', 44, '2019-05-26', 360, NULL),
('Hampton Inn', 44, '2019-05-27', 172, NULL),
('Hampton Inn', 44, '2019-05-28', 229, NULL),
('Hampton Inn', 44, '2019-05-29', 143, NULL),
('Hampton Inn', 44, '2019-05-30', 153, NULL),
('Hampton Inn', 44, '2019-05-31', 333, NULL),
('Hampton Inn', 44, '2019-06-01', 270, NULL),
('Hampton Inn', 44, '2019-06-02', 351, NULL),
('Hampton Inn', 44, '2019-06-03', 224, NULL),
('Hampton Inn', 44, '2019-06-04', 256, NULL),
('Hampton Inn', 44, '2019-06-05', 268, NULL),
('Hampton Inn', 44, '2019-06-06', 136, NULL),
('Hampton Inn', 44, '2019-06-07', 236, NULL),
('Hampton Inn', 44, '2019-06-08', 307, NULL),
('Hampton Inn', 44, '2019-06-09', 258, NULL),
('Hampton Inn', 44, '2019-06-10', 151, NULL),
('Hampton Inn', 44, '2019-06-11', 122, NULL),
('Hampton Inn', 44, '2019-06-12', 196, NULL),
('Hampton Inn', 44, '2019-06-13', 364, NULL),
('Hampton Inn', 44, '2019-06-14', 365, NULL),
('Hampton Inn', 44, '2019-06-15', 132, NULL),
('Hampton Inn', 44, '2019-06-16', 395, NULL),
('Hampton Inn', 44, '2019-06-17', 281, NULL),
('Hampton Inn', 44, '2019-06-18', 309, NULL),
('Hampton Inn', 44, '2019-06-19', 302, NULL),
('Hampton Inn', 44, '2019-06-20', 110, NULL),
('Hampton Inn', 44, '2019-06-21', 282, NULL),
('Hampton Inn', 44, '2019-06-22', 140, NULL),
('Hampton Inn', 44, '2019-06-23', 223, NULL),
('Hampton Inn', 44, '2019-06-24', 374, NULL),
('Hampton Inn', 44, '2019-06-25', 390, NULL),
('Hampton Inn', 44, '2019-06-26', 170, NULL),
('Hampton Inn', 44, '2019-06-27', 396, NULL),
('Hampton Inn', 44, '2019-06-28', 204, NULL),
('Hampton Inn', 44, '2019-06-29', 122, NULL),
('Hampton Inn', 44, '2019-06-30', 356, NULL),
('Hampton Inn', 44, '2019-07-01', 217, NULL),
('Hampton Inn', 44, '2019-07-02', 389, NULL),
('Hampton Inn', 44, '2019-07-03', 127, NULL),
('Hampton Inn', 44, '2019-07-04', 284, NULL),
('Hampton Inn', 44, '2019-07-05', 199, NULL),
('Hampton Inn', 44, '2019-07-06', 314, NULL),
('Hampton Inn', 44, '2019-07-07', 273, NULL),
('Hampton Inn', 44, '2019-07-08', 163, NULL),
('Hampton Inn', 44, '2019-07-09', 288, NULL),
('Hampton Inn', 44, '2019-07-10', 347, NULL),
('Hampton Inn', 44, '2019-07-11', 161, NULL),
('Hampton Inn', 44, '2019-07-12', 225, NULL),
('Hampton Inn', 44, '2019-07-13', 293, NULL),
('Hampton Inn', 44, '2019-07-14', 192, NULL),
('Hampton Inn', 44, '2019-07-15', 154, NULL),
('Hampton Inn', 44, '2019-07-16', 250, NULL),
('Hampton Inn', 44, '2019-07-17', 171, NULL),
('Hampton Inn', 44, '2019-07-18', 127, NULL),
('Hampton Inn', 44, '2019-07-19', 279, NULL),
('Hampton Inn', 44, '2019-07-20', 365, NULL),
('Hampton Inn', 44, '2019-07-21', 371, NULL),
('Hampton Inn', 44, '2019-07-22', 259, NULL),
('Hampton Inn', 44, '2019-07-23', 355, NULL),
('Hampton Inn', 44, '2019-07-24', 280, NULL),
('Hampton Inn', 44, '2019-07-25', 201, NULL),
('Hampton Inn', 44, '2019-07-26', 304, NULL),
('Hampton Inn', 44, '2019-07-27', 288, NULL),
('Hampton Inn', 44, '2019-07-28', 211, NULL),
('Hampton Inn', 44, '2019-07-29', 180, NULL),
('Hampton Inn', 44, '2019-07-30', 328, NULL),
('Hampton Inn', 44, '2019-07-31', 231, NULL),
('Hampton Inn', 44, '2019-08-01', 159, NULL),
('Hampton Inn', 44, '2019-08-02', 378, NULL),
('Hampton Inn', 44, '2019-08-03', 177, NULL),
('Hampton Inn', 44, '2019-08-04', 395, NULL),
('Hampton Inn', 44, '2019-08-05', 107, NULL),
('Hampton Inn', 44, '2019-08-06', 366, NULL),
('Hampton Inn', 44, '2019-08-07', 255, NULL),
('Hampton Inn', 44, '2019-08-08', 128, NULL),
('Hampton Inn', 44, '2019-08-09', 255, NULL),
('Hampton Inn', 44, '2019-08-10', 216, NULL),
('Hampton Inn', 44, '2019-08-11', 175, NULL),
('Hampton Inn', 44, '2019-08-12', 141, NULL),
('Hampton Inn', 44, '2019-08-13', 149, NULL),
('Hampton Inn', 44, '2019-08-14', 165, NULL),
('Hampton Inn', 44, '2019-08-15', 217, NULL),
('Hampton Inn', 44, '2019-08-16', 127, NULL),
('Hampton Inn', 44, '2019-08-17', 346, NULL),
('Hampton Inn', 44, '2019-08-18', 232, NULL),
('Hampton Inn', 44, '2019-08-19', 215, NULL),
('Hampton Inn', 44, '2019-08-20', 366, NULL),
('Hampton Inn', 44, '2019-08-21', 205, NULL),
('Hampton Inn', 44, '2019-08-22', 130, NULL),
('Hampton Inn', 44, '2019-08-23', 167, NULL),
('Hampton Inn', 44, '2019-08-24', 202, NULL),
('Hampton Inn', 44, '2019-08-25', 303, NULL),
('Hampton Inn', 44, '2019-08-26', 379, NULL),
('Hampton Inn', 44, '2019-08-27', 336, NULL),
('Hampton Inn', 44, '2019-08-28', 344, NULL),
('Hampton Inn', 44, '2019-08-29', 192, NULL),
('Hampton Inn', 44, '2019-08-30', 310, NULL),
('Hampton Inn', 44, '2019-08-31', 337, NULL),
('Hampton Inn', 44, '2019-09-01', 353, NULL),
('Hampton Inn', 44, '2019-09-02', 118, NULL),
('Hampton Inn', 44, '2019-09-03', 108, NULL),
('Hampton Inn', 44, '2019-09-04', 219, NULL),
('Hampton Inn', 44, '2019-09-05', 104, NULL),
('Hampton Inn', 44, '2019-09-06', 321, NULL),
('Hampton Inn', 44, '2019-09-07', 128, NULL),
('Hampton Inn', 44, '2019-09-08', 325, NULL),
('Hampton Inn', 44, '2019-09-09', 298, NULL),
('Hampton Inn', 44, '2019-09-10', 331, NULL),
('Hampton Inn', 44, '2019-09-11', 142, NULL),
('Hampton Inn', 44, '2019-09-12', 184, NULL),
('Hampton Inn', 44, '2019-09-13', 183, NULL),
('Hampton Inn', 44, '2019-09-14', 286, NULL),
('Hampton Inn', 44, '2019-09-15', 331, NULL),
('Hampton Inn', 44, '2019-09-16', 251, NULL),
('Hampton Inn', 44, '2019-09-17', 235, NULL),
('Hampton Inn', 44, '2019-09-18', 232, NULL),
('Hampton Inn', 44, '2019-09-19', 223, NULL),
('Hampton Inn', 44, '2019-09-20', 286, NULL),
('Hampton Inn', 44, '2019-09-21', 309, NULL),
('Hampton Inn', 44, '2019-09-22', 377, NULL),
('Hampton Inn', 44, '2019-09-23', 249, NULL),
('Hampton Inn', 44, '2019-09-24', 196, NULL),
('Hampton Inn', 44, '2019-09-25', 233, NULL),
('Hampton Inn', 44, '2019-09-26', 284, NULL),
('Hampton Inn', 44, '2019-09-27', 102, NULL),
('Hampton Inn', 44, '2019-09-28', 376, NULL),
('Hampton Inn', 44, '2019-09-29', 181, NULL),
('Hampton Inn', 44, '2019-09-30', 278, NULL),
('Hampton Inn', 44, '2019-10-01', 242, NULL),
('Hampton Inn', 44, '2019-10-02', 183, NULL),
('Hampton Inn', 44, '2019-10-03', 221, NULL),
('Hampton Inn', 44, '2019-10-04', 241, NULL),
('Hampton Inn', 44, '2019-10-05', 353, NULL),
('Hampton Inn', 44, '2019-10-06', 146, NULL),
('Hampton Inn', 44, '2019-10-07', 193, NULL),
('Hampton Inn', 44, '2019-10-08', 127, NULL),
('Hampton Inn', 44, '2019-10-09', 152, NULL),
('Hampton Inn', 44, '2019-10-10', 195, NULL),
('Hampton Inn', 44, '2019-10-11', 310, NULL),
('Hampton Inn', 44, '2019-10-12', 110, NULL),
('Hampton Inn', 44, '2019-10-13', 324, NULL),
('Hampton Inn', 44, '2019-10-14', 266, NULL),
('Hampton Inn', 44, '2019-10-15', 170, NULL),
('Hampton Inn', 44, '2019-10-16', 287, NULL),
('Hampton Inn', 44, '2019-10-17', 383, NULL),
('Hampton Inn', 44, '2019-10-18', 297, NULL),
('Hampton Inn', 44, '2019-10-19', 329, NULL),
('Hampton Inn', 44, '2019-10-20', 203, NULL),
('Hampton Inn', 44, '2019-10-21', 385, NULL),
('Hampton Inn', 44, '2019-10-22', 158, NULL),
('Hampton Inn', 44, '2019-10-23', 182, NULL),
('Hampton Inn', 44, '2019-10-24', 328, NULL),
('Hampton Inn', 44, '2019-10-25', 205, NULL),
('Hampton Inn', 44, '2019-10-26', 341, NULL),
('Hampton Inn', 44, '2019-10-27', 173, NULL),
('Hampton Inn', 44, '2019-10-28', 286, NULL),
('Hampton Inn', 44, '2019-10-29', 158, NULL),
('Hampton Inn', 44, '2019-10-30', 240, NULL),
('Hampton Inn', 44, '2019-10-31', 162, NULL),
('Hampton Inn', 44, '2019-11-01', 245, NULL),
('Hampton Inn', 44, '2019-11-02', 150, NULL),
('Hampton Inn', 44, '2019-11-03', 188, NULL),
('Hampton Inn', 44, '2019-11-04', 339, NULL),
('Hampton Inn', 44, '2019-11-05', 255, NULL),
('Hampton Inn', 44, '2019-11-06', 294, NULL),
('Hampton Inn', 44, '2019-11-07', 349, NULL),
('Hampton Inn', 44, '2019-11-08', 168, NULL),
('Hampton Inn', 44, '2019-11-09', 264, NULL),
('Hampton Inn', 44, '2019-11-10', 278, NULL),
('Hampton Inn', 44, '2019-11-11', 157, NULL),
('Hampton Inn', 44, '2019-11-12', 271, NULL),
('Hampton Inn', 44, '2019-11-13', 217, NULL),
('Hampton Inn', 44, '2019-11-14', 227, NULL),
('Hampton Inn', 44, '2019-11-15', 143, NULL),
('Hampton Inn', 44, '2019-11-16', 255, NULL),
('Hampton Inn', 44, '2019-11-17', 306, NULL),
('Hampton Inn', 44, '2019-11-18', 165, NULL),
('Hampton Inn', 44, '2019-11-19', 262, NULL),
('Hampton Inn', 44, '2019-11-20', 390, NULL),
('Hampton Inn', 44, '2019-11-21', 398, NULL),
('Hampton Inn', 44, '2019-11-22', 199, NULL),
('Hampton Inn', 44, '2019-11-23', 278, NULL),
('Hampton Inn', 44, '2019-11-24', 213, NULL),
('Hampton Inn', 44, '2019-11-25', 316, NULL),
('Hampton Inn', 44, '2019-11-26', 308, NULL),
('Hampton Inn', 44, '2019-11-27', 362, NULL),
('Hampton Inn', 44, '2019-11-28', 194, NULL),
('Hampton Inn', 44, '2019-11-29', 105, NULL),
('Hampton Inn', 44, '2019-11-30', 374, NULL),
('Hampton Inn', 44, '2019-12-01', 341, NULL),
('Hampton Inn', 44, '2019-12-02', 366, NULL),
('Hampton Inn', 44, '2019-12-03', 380, NULL),
('Hampton Inn', 44, '2019-12-04', 318, NULL),
('Hampton Inn', 44, '2019-12-05', 360, NULL),
('Hampton Inn', 44, '2019-12-06', 215, NULL),
('Hampton Inn', 44, '2019-12-07', 348, NULL),
('Hampton Inn', 44, '2019-12-08', 222, NULL),
('Hampton Inn', 44, '2019-12-09', 166, NULL),
('Hampton Inn', 44, '2019-12-10', 386, NULL),
('Hampton Inn', 44, '2019-12-11', 304, NULL),
('Hampton Inn', 44, '2019-12-12', 195, NULL),
('Hampton Inn', 44, '2019-12-13', 392, NULL),
('Hampton Inn', 44, '2019-12-14', 177, NULL),
('Hampton Inn', 44, '2019-12-15', 140, NULL),
('Hampton Inn', 44, '2019-12-16', 364, NULL),
('Hampton Inn', 44, '2019-12-17', 132, NULL),
('Hampton Inn', 44, '2019-12-18', 131, NULL),
('Hampton Inn', 44, '2019-12-19', 261, NULL),
('Hampton Inn', 44, '2019-12-20', 124, NULL),
('Hampton Inn', 44, '2019-12-21', 369, NULL),
('Hampton Inn', 44, '2019-12-22', 289, NULL),
('Hampton Inn', 44, '2019-12-23', 385, NULL),
('Hampton Inn', 44, '2019-12-24', 172, NULL),
('Hampton Inn', 44, '2019-12-25', 139, NULL),
('Hampton Inn', 44, '2019-12-26', 129, NULL),
('Hampton Inn', 44, '2019-12-27', 216, NULL),
('Hampton Inn', 44, '2019-12-28', 121, NULL),
('Hampton Inn', 44, '2019-12-29', 204, NULL),
('Hampton Inn', 44, '2019-12-30', 263, NULL),
('Hampton Inn', 44, '2019-12-31', 287, NULL),
('Hampton Inn', 44, '2020-01-01', 120, NULL),
('Hampton Inn', 44, '2020-01-02', 268, NULL),
('Hampton Inn', 44, '2020-01-03', 343, NULL),
('Hampton Inn', 44, '2020-01-04', 374, NULL),
('Hampton Inn', 44, '2020-01-05', 332, NULL),
('Hampton Inn', 44, '2020-01-06', 219, NULL),
('Hampton Inn', 44, '2020-01-07', 100, NULL),
('Hampton Inn', 44, '2020-01-08', 316, NULL),
('Hampton Inn', 44, '2020-01-09', 331, NULL),
('Hampton Inn', 44, '2020-01-10', 289, NULL),
('Hampton Inn', 44, '2020-01-11', 194, NULL),
('Hampton Inn', 44, '2020-01-12', 342, NULL),
('Hampton Inn', 44, '2020-01-13', 315, NULL),
('Hampton Inn', 44, '2020-01-14', 348, NULL),
('Hampton Inn', 44, '2020-01-15', 355, NULL),
('Hampton Inn', 44, '2020-01-16', 361, NULL),
('Hampton Inn', 44, '2020-01-17', 198, NULL),
('Hampton Inn', 44, '2020-01-18', 389, NULL),
('Hampton Inn', 44, '2020-01-19', 181, NULL),
('Hampton Inn', 44, '2020-01-20', 160, NULL),
('Hampton Inn', 44, '2020-01-21', 236, NULL),
('Hampton Inn', 44, '2020-01-22', 201, NULL),
('Hampton Inn', 44, '2020-01-23', 188, NULL),
('Hampton Inn', 44, '2020-01-24', 390, NULL),
('Hampton Inn', 44, '2020-01-25', 102, NULL),
('Hampton Inn', 44, '2020-01-26', 221, NULL),
('Hampton Inn', 44, '2020-01-27', 346, NULL),
('Hampton Inn', 44, '2020-01-28', 109, NULL),
('Hampton Inn', 44, '2020-01-29', 127, NULL),
('Hampton Inn', 44, '2020-01-30', 224, NULL),
('Hampton Inn', 44, '2020-01-31', 364, NULL),
('Hampton Inn', 44, '2020-02-01', 228, NULL),
('Hampton Inn', 44, '2020-02-02', 199, NULL),
('Hampton Inn', 44, '2020-02-03', 376, NULL),
('Hampton Inn', 44, '2020-02-04', 149, NULL),
('Hampton Inn', 56, '2019-01-01', 398, NULL),
('Hampton Inn', 56, '2019-01-02', 387, NULL),
('Hampton Inn', 56, '2019-01-03', 347, NULL),
('Hampton Inn', 56, '2019-01-04', 106, NULL),
('Hampton Inn', 56, '2019-01-05', 120, NULL),
('Hampton Inn', 56, '2019-01-06', 104, NULL),
('Hampton Inn', 56, '2019-01-07', 280, NULL),
('Hampton Inn', 56, '2019-01-08', 180, NULL),
('Hampton Inn', 56, '2019-01-09', 237, NULL),
('Hampton Inn', 56, '2019-01-10', 372, NULL),
('Hampton Inn', 56, '2019-01-11', 357, NULL),
('Hampton Inn', 56, '2019-01-12', 300, NULL),
('Hampton Inn', 56, '2019-01-13', 370, NULL),
('Hampton Inn', 56, '2019-01-14', 317, NULL),
('Hampton Inn', 56, '2019-01-15', 215, NULL),
('Hampton Inn', 56, '2019-01-16', 324, NULL),
('Hampton Inn', 56, '2019-01-17', 179, NULL),
('Hampton Inn', 56, '2019-01-18', 333, NULL),
('Hampton Inn', 56, '2019-01-19', 351, NULL),
('Hampton Inn', 56, '2019-01-20', 122, NULL),
('Hampton Inn', 56, '2019-01-21', 125, NULL),
('Hampton Inn', 56, '2019-01-22', 373, NULL),
('Hampton Inn', 56, '2019-01-23', 193, NULL),
('Hampton Inn', 56, '2019-01-24', 228, NULL),
('Hampton Inn', 56, '2019-01-25', 218, NULL),
('Hampton Inn', 56, '2019-01-26', 168, NULL),
('Hampton Inn', 56, '2019-01-27', 214, NULL),
('Hampton Inn', 56, '2019-01-28', 334, NULL),
('Hampton Inn', 56, '2019-01-29', 209, NULL),
('Hampton Inn', 56, '2019-01-30', 287, NULL),
('Hampton Inn', 56, '2019-01-31', 362, NULL),
('Hampton Inn', 56, '2019-02-01', 194, NULL),
('Hampton Inn', 56, '2019-02-02', 225, NULL),
('Hampton Inn', 56, '2019-02-03', 238, NULL),
('Hampton Inn', 56, '2019-02-04', 198, NULL),
('Hampton Inn', 56, '2019-02-05', 389, NULL),
('Hampton Inn', 56, '2019-02-06', 338, NULL),
('Hampton Inn', 56, '2019-02-07', 160, NULL),
('Hampton Inn', 56, '2019-02-08', 360, NULL),
('Hampton Inn', 56, '2019-02-09', 247, NULL),
('Hampton Inn', 56, '2019-02-10', 165, NULL),
('Hampton Inn', 56, '2019-02-11', 214, NULL),
('Hampton Inn', 56, '2019-02-12', 158, NULL),
('Hampton Inn', 56, '2019-02-13', 270, NULL),
('Hampton Inn', 56, '2019-02-14', 342, NULL),
('Hampton Inn', 56, '2019-02-15', 235, NULL),
('Hampton Inn', 56, '2019-02-16', 279, NULL),
('Hampton Inn', 56, '2019-02-17', 329, NULL),
('Hampton Inn', 56, '2019-02-18', 175, NULL),
('Hampton Inn', 56, '2019-02-19', 299, NULL),
('Hampton Inn', 56, '2019-02-20', 226, NULL),
('Hampton Inn', 56, '2019-02-21', 393, NULL),
('Hampton Inn', 56, '2019-02-22', 229, NULL),
('Hampton Inn', 56, '2019-02-23', 106, NULL),
('Hampton Inn', 56, '2019-02-24', 102, NULL),
('Hampton Inn', 56, '2019-02-25', 169, NULL),
('Hampton Inn', 56, '2019-02-26', 307, NULL),
('Hampton Inn', 56, '2019-02-27', 224, NULL),
('Hampton Inn', 56, '2019-02-28', 323, NULL),
('Hampton Inn', 56, '2019-03-01', 326, NULL),
('Hampton Inn', 56, '2019-03-02', 152, NULL),
('Hampton Inn', 56, '2019-03-03', 346, NULL),
('Hampton Inn', 56, '2019-03-04', 199, NULL),
('Hampton Inn', 56, '2019-03-05', 231, NULL),
('Hampton Inn', 56, '2019-03-06', 234, NULL),
('Hampton Inn', 56, '2019-03-07', 225, NULL),
('Hampton Inn', 56, '2019-03-08', 208, NULL),
('Hampton Inn', 56, '2019-03-09', 214, NULL),
('Hampton Inn', 56, '2019-03-10', 136, NULL),
('Hampton Inn', 56, '2019-03-11', 184, NULL),
('Hampton Inn', 56, '2019-03-12', 149, NULL),
('Hampton Inn', 56, '2019-03-13', 128, NULL),
('Hampton Inn', 56, '2019-03-14', 262, NULL),
('Hampton Inn', 56, '2019-03-15', 362, NULL),
('Hampton Inn', 56, '2019-03-16', 204, NULL),
('Hampton Inn', 56, '2019-03-17', 238, NULL),
('Hampton Inn', 56, '2019-03-18', 355, NULL),
('Hampton Inn', 56, '2019-03-19', 278, NULL),
('Hampton Inn', 56, '2019-03-20', 295, NULL),
('Hampton Inn', 56, '2019-03-21', 331, NULL),
('Hampton Inn', 56, '2019-03-22', 240, NULL),
('Hampton Inn', 56, '2019-03-23', 348, NULL),
('Hampton Inn', 56, '2019-03-24', 369, NULL),
('Hampton Inn', 56, '2019-03-25', 368, NULL),
('Hampton Inn', 56, '2019-03-26', 273, NULL),
('Hampton Inn', 56, '2019-03-27', 234, NULL),
('Hampton Inn', 56, '2019-03-28', 185, NULL),
('Hampton Inn', 56, '2019-03-29', 242, NULL),
('Hampton Inn', 56, '2019-03-30', 228, NULL),
('Hampton Inn', 56, '2019-03-31', 368, NULL),
('Hampton Inn', 56, '2019-04-01', 215, NULL),
('Hampton Inn', 56, '2019-04-02', 361, NULL),
('Hampton Inn', 56, '2019-04-03', 284, NULL),
('Hampton Inn', 56, '2019-04-04', 107, NULL),
('Hampton Inn', 56, '2019-04-05', 213, NULL),
('Hampton Inn', 56, '2019-04-06', 291, NULL),
('Hampton Inn', 56, '2019-04-07', 151, NULL),
('Hampton Inn', 56, '2019-04-08', 325, NULL),
('Hampton Inn', 56, '2019-04-09', 180, NULL),
('Hampton Inn', 56, '2019-04-10', 220, NULL),
('Hampton Inn', 56, '2019-04-11', 187, NULL),
('Hampton Inn', 56, '2019-04-12', 211, NULL),
('Hampton Inn', 56, '2019-04-13', 317, NULL),
('Hampton Inn', 56, '2019-04-14', 326, NULL),
('Hampton Inn', 56, '2019-04-15', 334, NULL),
('Hampton Inn', 56, '2019-04-16', 104, NULL),
('Hampton Inn', 56, '2019-04-17', 324, NULL),
('Hampton Inn', 56, '2019-04-18', 122, NULL),
('Hampton Inn', 56, '2019-04-19', 175, NULL),
('Hampton Inn', 56, '2019-04-20', 157, NULL),
('Hampton Inn', 56, '2019-04-21', 249, NULL),
('Hampton Inn', 56, '2019-04-22', 230, NULL),
('Hampton Inn', 56, '2019-04-23', 248, NULL),
('Hampton Inn', 56, '2019-04-24', 298, NULL),
('Hampton Inn', 56, '2019-04-25', 281, NULL),
('Hampton Inn', 56, '2019-04-26', 132, NULL),
('Hampton Inn', 56, '2019-04-27', 165, NULL),
('Hampton Inn', 56, '2019-04-28', 103, NULL),
('Hampton Inn', 56, '2019-04-29', 310, NULL),
('Hampton Inn', 56, '2019-04-30', 316, NULL),
('Hampton Inn', 56, '2019-05-01', 331, NULL),
('Hampton Inn', 56, '2019-05-02', 208, NULL),
('Hampton Inn', 56, '2019-05-03', 274, NULL),
('Hampton Inn', 56, '2019-05-04', 244, NULL),
('Hampton Inn', 56, '2019-05-05', 214, NULL),
('Hampton Inn', 56, '2019-05-06', 222, NULL),
('Hampton Inn', 56, '2019-05-07', 159, NULL),
('Hampton Inn', 56, '2019-05-08', 196, NULL),
('Hampton Inn', 56, '2019-05-09', 239, NULL),
('Hampton Inn', 56, '2019-05-10', 239, NULL),
('Hampton Inn', 56, '2019-05-11', 350, NULL),
('Hampton Inn', 56, '2019-05-12', 226, NULL),
('Hampton Inn', 56, '2019-05-13', 154, NULL),
('Hampton Inn', 56, '2019-05-14', 365, NULL),
('Hampton Inn', 56, '2019-05-15', 322, NULL),
('Hampton Inn', 56, '2019-05-16', 179, NULL),
('Hampton Inn', 56, '2019-05-17', 299, NULL),
('Hampton Inn', 56, '2019-05-18', 301, NULL),
('Hampton Inn', 56, '2019-05-19', 252, NULL),
('Hampton Inn', 56, '2019-05-20', 268, NULL),
('Hampton Inn', 56, '2019-05-21', 237, NULL),
('Hampton Inn', 56, '2019-05-22', 128, NULL),
('Hampton Inn', 56, '2019-05-23', 275, NULL),
('Hampton Inn', 56, '2019-05-24', 217, NULL),
('Hampton Inn', 56, '2019-05-25', 326, NULL),
('Hampton Inn', 56, '2019-05-26', 288, NULL),
('Hampton Inn', 56, '2019-05-27', 361, NULL),
('Hampton Inn', 56, '2019-05-28', 113, NULL),
('Hampton Inn', 56, '2019-05-29', 369, NULL),
('Hampton Inn', 56, '2019-05-30', 206, NULL),
('Hampton Inn', 56, '2019-05-31', 117, NULL),
('Hampton Inn', 56, '2019-06-01', 381, NULL),
('Hampton Inn', 56, '2019-06-02', 121, NULL),
('Hampton Inn', 56, '2019-06-03', 148, NULL),
('Hampton Inn', 56, '2019-06-04', 135, NULL),
('Hampton Inn', 56, '2019-06-05', 298, NULL),
('Hampton Inn', 56, '2019-06-06', 263, NULL),
('Hampton Inn', 56, '2019-06-07', 130, NULL),
('Hampton Inn', 56, '2019-06-08', 345, NULL),
('Hampton Inn', 56, '2019-06-09', 281, NULL),
('Hampton Inn', 56, '2019-06-10', 398, NULL),
('Hampton Inn', 56, '2019-06-11', 314, NULL),
('Hampton Inn', 56, '2019-06-12', 257, NULL),
('Hampton Inn', 56, '2019-06-13', 138, NULL),
('Hampton Inn', 56, '2019-06-14', 300, NULL),
('Hampton Inn', 56, '2019-06-15', 109, NULL),
('Hampton Inn', 56, '2019-06-16', 115, NULL),
('Hampton Inn', 56, '2019-06-17', 383, NULL),
('Hampton Inn', 56, '2019-06-18', 169, NULL),
('Hampton Inn', 56, '2019-06-19', 160, NULL),
('Hampton Inn', 56, '2019-06-20', 101, NULL),
('Hampton Inn', 56, '2019-06-21', 205, NULL),
('Hampton Inn', 56, '2019-06-22', 114, NULL),
('Hampton Inn', 56, '2019-06-23', 244, NULL),
('Hampton Inn', 56, '2019-06-24', 147, NULL),
('Hampton Inn', 56, '2019-06-25', 301, NULL),
('Hampton Inn', 56, '2019-06-26', 263, NULL),
('Hampton Inn', 56, '2019-06-27', 296, NULL),
('Hampton Inn', 56, '2019-06-28', 347, NULL),
('Hampton Inn', 56, '2019-06-29', 365, NULL),
('Hampton Inn', 56, '2019-06-30', 169, NULL),
('Hampton Inn', 56, '2019-07-01', 224, NULL),
('Hampton Inn', 56, '2019-07-02', 311, NULL),
('Hampton Inn', 56, '2019-07-03', 308, NULL),
('Hampton Inn', 56, '2019-07-04', 379, NULL),
('Hampton Inn', 56, '2019-07-05', 221, NULL),
('Hampton Inn', 56, '2019-07-06', 281, NULL),
('Hampton Inn', 56, '2019-07-07', 159, NULL),
('Hampton Inn', 56, '2019-07-08', 115, NULL),
('Hampton Inn', 56, '2019-07-09', 334, NULL),
('Hampton Inn', 56, '2019-07-10', 197, NULL),
('Hampton Inn', 56, '2019-07-11', 283, NULL),
('Hampton Inn', 56, '2019-07-12', 310, NULL),
('Hampton Inn', 56, '2019-07-13', 337, NULL),
('Hampton Inn', 56, '2019-07-14', 320, NULL),
('Hampton Inn', 56, '2019-07-15', 173, NULL),
('Hampton Inn', 56, '2019-07-16', 150, NULL),
('Hampton Inn', 56, '2019-07-17', 124, NULL),
('Hampton Inn', 56, '2019-07-18', 375, NULL),
('Hampton Inn', 56, '2019-07-19', 249, NULL),
('Hampton Inn', 56, '2019-07-20', 187, NULL),
('Hampton Inn', 56, '2019-07-21', 264, NULL),
('Hampton Inn', 56, '2019-07-22', 367, NULL),
('Hampton Inn', 56, '2019-07-23', 285, NULL),
('Hampton Inn', 56, '2019-07-24', 270, NULL),
('Hampton Inn', 56, '2019-07-25', 260, NULL),
('Hampton Inn', 56, '2019-07-26', 372, NULL),
('Hampton Inn', 56, '2019-07-27', 104, NULL),
('Hampton Inn', 56, '2019-07-28', 332, NULL),
('Hampton Inn', 56, '2019-07-29', 319, NULL),
('Hampton Inn', 56, '2019-07-30', 148, NULL),
('Hampton Inn', 56, '2019-07-31', 157, NULL),
('Hampton Inn', 56, '2019-08-01', 221, NULL),
('Hampton Inn', 56, '2019-08-02', 238, NULL),
('Hampton Inn', 56, '2019-08-03', 210, NULL),
('Hampton Inn', 56, '2019-08-04', 141, NULL),
('Hampton Inn', 56, '2019-08-05', 164, NULL),
('Hampton Inn', 56, '2019-08-06', 105, NULL),
('Hampton Inn', 56, '2019-08-07', 135, NULL),
('Hampton Inn', 56, '2019-08-08', 335, NULL),
('Hampton Inn', 56, '2019-08-09', 198, NULL),
('Hampton Inn', 56, '2019-08-10', 217, NULL),
('Hampton Inn', 56, '2019-08-11', 328, NULL),
('Hampton Inn', 56, '2019-08-12', 274, NULL),
('Hampton Inn', 56, '2019-08-13', 222, NULL),
('Hampton Inn', 56, '2019-08-14', 133, NULL),
('Hampton Inn', 56, '2019-08-15', 188, NULL),
('Hampton Inn', 56, '2019-08-16', 280, NULL),
('Hampton Inn', 56, '2019-08-17', 389, NULL),
('Hampton Inn', 56, '2019-08-18', 367, NULL),
('Hampton Inn', 56, '2019-08-19', 291, NULL),
('Hampton Inn', 56, '2019-08-20', 122, NULL),
('Hampton Inn', 56, '2019-08-21', 290, NULL),
('Hampton Inn', 56, '2019-08-22', 111, NULL),
('Hampton Inn', 56, '2019-08-23', 343, NULL),
('Hampton Inn', 56, '2019-08-24', 136, NULL),
('Hampton Inn', 56, '2019-08-25', 275, NULL),
('Hampton Inn', 56, '2019-08-26', 104, NULL),
('Hampton Inn', 56, '2019-08-27', 355, NULL),
('Hampton Inn', 56, '2019-08-28', 255, NULL),
('Hampton Inn', 56, '2019-08-29', 140, NULL),
('Hampton Inn', 56, '2019-08-30', 144, NULL),
('Hampton Inn', 56, '2019-08-31', 158, NULL),
('Hampton Inn', 56, '2019-09-01', 244, NULL),
('Hampton Inn', 56, '2019-09-02', 381, NULL),
('Hampton Inn', 56, '2019-09-03', 275, NULL),
('Hampton Inn', 56, '2019-09-04', 296, NULL),
('Hampton Inn', 56, '2019-09-05', 245, NULL),
('Hampton Inn', 56, '2019-09-06', 219, NULL),
('Hampton Inn', 56, '2019-09-07', 398, NULL),
('Hampton Inn', 56, '2019-09-08', 298, NULL),
('Hampton Inn', 56, '2019-09-09', 303, NULL),
('Hampton Inn', 56, '2019-09-10', 393, NULL),
('Hampton Inn', 56, '2019-09-11', 199, NULL),
('Hampton Inn', 56, '2019-09-12', 136, NULL),
('Hampton Inn', 56, '2019-09-13', 109, NULL),
('Hampton Inn', 56, '2019-09-14', 315, NULL),
('Hampton Inn', 56, '2019-09-15', 329, NULL),
('Hampton Inn', 56, '2019-09-16', 247, NULL),
('Hampton Inn', 56, '2019-09-17', 123, NULL),
('Hampton Inn', 56, '2019-09-18', 255, NULL),
('Hampton Inn', 56, '2019-09-19', 122, NULL),
('Hampton Inn', 56, '2019-09-20', 147, NULL),
('Hampton Inn', 56, '2019-09-21', 304, NULL),
('Hampton Inn', 56, '2019-09-22', 385, NULL),
('Hampton Inn', 56, '2019-09-23', 350, NULL),
('Hampton Inn', 56, '2019-09-24', 275, NULL),
('Hampton Inn', 56, '2019-09-25', 376, NULL),
('Hampton Inn', 56, '2019-09-26', 235, NULL),
('Hampton Inn', 56, '2019-09-27', 376, NULL),
('Hampton Inn', 56, '2019-09-28', 235, NULL),
('Hampton Inn', 56, '2019-09-29', 126, NULL),
('Hampton Inn', 56, '2019-09-30', 344, NULL),
('Hampton Inn', 56, '2019-10-01', 152, NULL),
('Hampton Inn', 56, '2019-10-02', 313, NULL),
('Hampton Inn', 56, '2019-10-03', 367, NULL),
('Hampton Inn', 56, '2019-10-04', 396, NULL),
('Hampton Inn', 56, '2019-10-05', 207, NULL),
('Hampton Inn', 56, '2019-10-06', 214, NULL),
('Hampton Inn', 56, '2019-10-07', 137, NULL),
('Hampton Inn', 56, '2019-10-08', 331, NULL),
('Hampton Inn', 56, '2019-10-09', 225, NULL),
('Hampton Inn', 56, '2019-10-10', 298, NULL),
('Hampton Inn', 56, '2019-10-11', 200, NULL),
('Hampton Inn', 56, '2019-10-12', 366, NULL),
('Hampton Inn', 56, '2019-10-13', 246, NULL),
('Hampton Inn', 56, '2019-10-14', 192, NULL),
('Hampton Inn', 56, '2019-10-15', 271, NULL),
('Hampton Inn', 56, '2019-10-16', 287, NULL),
('Hampton Inn', 56, '2019-10-17', 219, NULL),
('Hampton Inn', 56, '2019-10-18', 236, NULL),
('Hampton Inn', 56, '2019-10-19', 312, NULL),
('Hampton Inn', 56, '2019-10-20', 166, NULL),
('Hampton Inn', 56, '2019-10-21', 396, NULL),
('Hampton Inn', 56, '2019-10-22', 228, NULL),
('Hampton Inn', 56, '2019-10-23', 109, NULL),
('Hampton Inn', 56, '2019-10-24', 217, NULL),
('Hampton Inn', 56, '2019-10-25', 279, NULL),
('Hampton Inn', 56, '2019-10-26', 146, NULL),
('Hampton Inn', 56, '2019-10-27', 123, NULL),
('Hampton Inn', 56, '2019-10-28', 285, NULL),
('Hampton Inn', 56, '2019-10-29', 248, NULL),
('Hampton Inn', 56, '2019-10-30', 120, NULL),
('Hampton Inn', 56, '2019-10-31', 131, NULL),
('Hampton Inn', 56, '2019-11-01', 396, NULL),
('Hampton Inn', 56, '2019-11-02', 172, NULL),
('Hampton Inn', 56, '2019-11-03', 392, NULL),
('Hampton Inn', 56, '2019-11-04', 303, NULL),
('Hampton Inn', 56, '2019-11-05', 136, NULL),
('Hampton Inn', 56, '2019-11-06', 293, NULL),
('Hampton Inn', 56, '2019-11-07', 338, NULL),
('Hampton Inn', 56, '2019-11-08', 389, NULL),
('Hampton Inn', 56, '2019-11-09', 368, NULL),
('Hampton Inn', 56, '2019-11-10', 178, NULL),
('Hampton Inn', 56, '2019-11-11', 195, NULL),
('Hampton Inn', 56, '2019-11-12', 294, NULL),
('Hampton Inn', 56, '2019-11-13', 168, NULL),
('Hampton Inn', 56, '2019-11-14', 264, NULL),
('Hampton Inn', 56, '2019-11-15', 107, NULL),
('Hampton Inn', 56, '2019-11-16', 360, NULL),
('Hampton Inn', 56, '2019-11-17', 150, NULL),
('Hampton Inn', 56, '2019-11-18', 255, NULL),
('Hampton Inn', 56, '2019-11-19', 250, NULL),
('Hampton Inn', 56, '2019-11-20', 165, NULL),
('Hampton Inn', 56, '2019-11-21', 251, NULL),
('Hampton Inn', 56, '2019-11-22', 193, NULL),
('Hampton Inn', 56, '2019-11-23', 110, NULL),
('Hampton Inn', 56, '2019-11-24', 214, NULL),
('Hampton Inn', 56, '2019-11-25', 398, NULL),
('Hampton Inn', 56, '2019-11-26', 322, NULL),
('Hampton Inn', 56, '2019-11-27', 213, NULL),
('Hampton Inn', 56, '2019-11-28', 313, NULL),
('Hampton Inn', 56, '2019-11-29', 132, NULL),
('Hampton Inn', 56, '2019-11-30', 214, NULL),
('Hampton Inn', 56, '2019-12-01', 130, NULL),
('Hampton Inn', 56, '2019-12-02', 194, NULL),
('Hampton Inn', 56, '2019-12-03', 108, NULL),
('Hampton Inn', 56, '2019-12-04', 239, NULL),
('Hampton Inn', 56, '2019-12-05', 132, NULL),
('Hampton Inn', 56, '2019-12-06', 122, NULL),
('Hampton Inn', 56, '2019-12-07', 286, NULL),
('Hampton Inn', 56, '2019-12-08', 326, NULL),
('Hampton Inn', 56, '2019-12-09', 140, NULL),
('Hampton Inn', 56, '2019-12-10', 203, NULL),
('Hampton Inn', 56, '2019-12-11', 236, NULL),
('Hampton Inn', 56, '2019-12-12', 312, NULL),
('Hampton Inn', 56, '2019-12-13', 332, NULL),
('Hampton Inn', 56, '2019-12-14', 123, NULL),
('Hampton Inn', 56, '2019-12-15', 223, NULL),
('Hampton Inn', 56, '2019-12-16', 303, NULL),
('Hampton Inn', 56, '2019-12-17', 322, NULL),
('Hampton Inn', 56, '2019-12-18', 296, NULL),
('Hampton Inn', 56, '2019-12-19', 389, NULL),
('Hampton Inn', 56, '2019-12-20', 235, NULL),
('Hampton Inn', 56, '2019-12-21', 306, NULL),
('Hampton Inn', 56, '2019-12-22', 300, NULL),
('Hampton Inn', 56, '2019-12-23', 233, NULL),
('Hampton Inn', 56, '2019-12-24', 300, NULL),
('Hampton Inn', 56, '2019-12-25', 261, NULL),
('Hampton Inn', 56, '2019-12-26', 245, NULL),
('Hampton Inn', 56, '2019-12-27', 215, NULL),
('Hampton Inn', 56, '2019-12-28', 390, NULL),
('Hampton Inn', 56, '2019-12-29', 353, NULL),
('Hampton Inn', 56, '2019-12-30', 162, NULL),
('Hampton Inn', 56, '2019-12-31', 322, NULL),
('Hampton Inn', 56, '2020-01-01', 305, NULL),
('Hampton Inn', 56, '2020-01-02', 344, NULL),
('Hampton Inn', 56, '2020-01-03', 225, NULL),
('Hampton Inn', 56, '2020-01-04', 308, NULL),
('Hampton Inn', 56, '2020-01-05', 200, NULL),
('Hampton Inn', 56, '2020-01-06', 149, NULL),
('Hampton Inn', 56, '2020-01-07', 362, NULL),
('Hampton Inn', 56, '2020-01-08', 306, NULL),
('Hampton Inn', 56, '2020-01-09', 148, NULL),
('Hampton Inn', 56, '2020-01-10', 119, NULL),
('Hampton Inn', 56, '2020-01-11', 294, NULL),
('Hampton Inn', 56, '2020-01-12', 180, NULL),
('Hampton Inn', 56, '2020-01-13', 216, NULL),
('Hampton Inn', 56, '2020-01-14', 115, NULL),
('Hampton Inn', 56, '2020-01-15', 173, NULL),
('Hampton Inn', 56, '2020-01-16', 155, NULL),
('Hampton Inn', 56, '2020-01-17', 139, NULL),
('Hampton Inn', 56, '2020-01-18', 142, NULL),
('Hampton Inn', 56, '2020-01-19', 170, NULL),
('Hampton Inn', 56, '2020-01-20', 195, NULL),
('Hampton Inn', 56, '2020-01-21', 381, NULL),
('Hampton Inn', 56, '2020-01-22', 209, NULL),
('Hampton Inn', 56, '2020-01-23', 202, NULL),
('Hampton Inn', 56, '2020-01-24', 268, NULL),
('Hampton Inn', 56, '2020-01-25', 247, NULL),
('Hampton Inn', 56, '2020-01-26', 264, NULL),
('Hampton Inn', 56, '2020-01-27', 234, NULL),
('Hampton Inn', 56, '2020-01-28', 310, NULL),
('Hampton Inn', 56, '2020-01-29', 276, NULL),
('Hampton Inn', 56, '2020-01-30', 322, NULL),
('Hampton Inn', 56, '2020-01-31', 303, NULL),
('Hampton Inn', 56, '2020-02-01', 237, NULL),
('Hampton Inn', 56, '2020-02-02', 112, NULL),
('Hampton Inn', 56, '2020-02-03', 383, NULL),
('Hampton Inn', 56, '2020-02-04', 248, NULL),
('Hampton Inn', 57, '2019-01-01', 226, NULL),
('Hampton Inn', 57, '2019-01-02', 389, NULL),
('Hampton Inn', 57, '2019-01-03', 277, NULL),
('Hampton Inn', 57, '2019-01-04', 274, NULL),
('Hampton Inn', 57, '2019-01-05', 240, NULL),
('Hampton Inn', 57, '2019-01-06', 289, NULL),
('Hampton Inn', 57, '2019-01-07', 367, NULL),
('Hampton Inn', 57, '2019-01-08', 348, NULL),
('Hampton Inn', 57, '2019-01-09', 308, NULL),
('Hampton Inn', 57, '2019-01-10', 141, NULL),
('Hampton Inn', 57, '2019-01-11', 299, NULL),
('Hampton Inn', 57, '2019-01-12', 300, NULL),
('Hampton Inn', 57, '2019-01-13', 145, NULL),
('Hampton Inn', 57, '2019-01-14', 125, NULL),
('Hampton Inn', 57, '2019-01-15', 359, NULL),
('Hampton Inn', 57, '2019-01-16', 369, NULL),
('Hampton Inn', 57, '2019-01-17', 239, NULL),
('Hampton Inn', 57, '2019-01-18', 373, NULL),
('Hampton Inn', 57, '2019-01-19', 343, NULL),
('Hampton Inn', 57, '2019-01-20', 104, NULL),
('Hampton Inn', 57, '2019-01-21', 391, NULL),
('Hampton Inn', 57, '2019-01-22', 336, NULL),
('Hampton Inn', 57, '2019-01-23', 133, NULL),
('Hampton Inn', 57, '2019-01-24', 120, NULL),
('Hampton Inn', 57, '2019-01-25', 323, NULL),
('Hampton Inn', 57, '2019-01-26', 284, NULL),
('Hampton Inn', 57, '2019-01-27', 374, NULL),
('Hampton Inn', 57, '2019-01-28', 199, NULL),
('Hampton Inn', 57, '2019-01-29', 337, NULL),
('Hampton Inn', 57, '2019-01-30', 287, NULL),
('Hampton Inn', 57, '2019-01-31', 189, NULL),
('Hampton Inn', 57, '2019-02-01', 293, NULL),
('Hampton Inn', 57, '2019-02-02', 243, NULL),
('Hampton Inn', 57, '2019-02-03', 388, NULL),
('Hampton Inn', 57, '2019-02-04', 218, NULL),
('Hampton Inn', 57, '2019-02-05', 326, NULL),
('Hampton Inn', 57, '2019-02-06', 134, NULL),
('Hampton Inn', 57, '2019-02-07', 172, NULL),
('Hampton Inn', 57, '2019-02-08', 290, NULL),
('Hampton Inn', 57, '2019-02-09', 251, NULL),
('Hampton Inn', 57, '2019-02-10', 260, NULL),
('Hampton Inn', 57, '2019-02-11', 383, NULL),
('Hampton Inn', 57, '2019-02-12', 240, NULL),
('Hampton Inn', 57, '2019-02-13', 318, NULL),
('Hampton Inn', 57, '2019-02-14', 105, NULL),
('Hampton Inn', 57, '2019-02-15', 114, NULL),
('Hampton Inn', 57, '2019-02-16', 156, NULL),
('Hampton Inn', 57, '2019-02-17', 141, NULL),
('Hampton Inn', 57, '2019-02-18', 182, NULL),
('Hampton Inn', 57, '2019-02-19', 248, NULL),
('Hampton Inn', 57, '2019-02-20', 280, NULL),
('Hampton Inn', 57, '2019-02-21', 279, NULL),
('Hampton Inn', 57, '2019-02-22', 194, NULL),
('Hampton Inn', 57, '2019-02-23', 398, NULL),
('Hampton Inn', 57, '2019-02-24', 274, NULL),
('Hampton Inn', 57, '2019-02-25', 338, NULL),
('Hampton Inn', 57, '2019-02-26', 376, NULL),
('Hampton Inn', 57, '2019-02-27', 363, NULL),
('Hampton Inn', 57, '2019-02-28', 374, NULL),
('Hampton Inn', 57, '2019-03-01', 268, NULL),
('Hampton Inn', 57, '2019-03-02', 123, NULL),
('Hampton Inn', 57, '2019-03-03', 174, NULL),
('Hampton Inn', 57, '2019-03-04', 224, NULL),
('Hampton Inn', 57, '2019-03-05', 320, NULL),
('Hampton Inn', 57, '2019-03-06', 194, NULL),
('Hampton Inn', 57, '2019-03-07', 177, NULL),
('Hampton Inn', 57, '2019-03-08', 115, NULL),
('Hampton Inn', 57, '2019-03-09', 200, NULL),
('Hampton Inn', 57, '2019-03-10', 168, NULL),
('Hampton Inn', 57, '2019-03-11', 375, NULL),
('Hampton Inn', 57, '2019-03-12', 300, NULL),
('Hampton Inn', 57, '2019-03-13', 178, NULL),
('Hampton Inn', 57, '2019-03-14', 394, NULL),
('Hampton Inn', 57, '2019-03-15', 175, NULL),
('Hampton Inn', 57, '2019-03-16', 282, NULL),
('Hampton Inn', 57, '2019-03-17', 174, NULL),
('Hampton Inn', 57, '2019-03-18', 271, NULL),
('Hampton Inn', 57, '2019-03-19', 112, NULL),
('Hampton Inn', 57, '2019-03-20', 215, NULL),
('Hampton Inn', 57, '2019-03-21', 366, NULL),
('Hampton Inn', 57, '2019-03-22', 174, NULL),
('Hampton Inn', 57, '2019-03-23', 389, NULL),
('Hampton Inn', 57, '2019-03-24', 201, NULL),
('Hampton Inn', 57, '2019-03-25', 389, NULL),
('Hampton Inn', 57, '2019-03-26', 238, NULL),
('Hampton Inn', 57, '2019-03-27', 117, NULL),
('Hampton Inn', 57, '2019-03-28', 278, NULL),
('Hampton Inn', 57, '2019-03-29', 379, NULL),
('Hampton Inn', 57, '2019-03-30', 147, NULL),
('Hampton Inn', 57, '2019-03-31', 110, NULL),
('Hampton Inn', 57, '2019-04-01', 381, NULL),
('Hampton Inn', 57, '2019-04-02', 206, NULL),
('Hampton Inn', 57, '2019-04-03', 284, NULL),
('Hampton Inn', 57, '2019-04-04', 310, NULL),
('Hampton Inn', 57, '2019-04-05', 168, NULL),
('Hampton Inn', 57, '2019-04-06', 366, NULL),
('Hampton Inn', 57, '2019-04-07', 146, NULL),
('Hampton Inn', 57, '2019-04-08', 294, NULL),
('Hampton Inn', 57, '2019-04-09', 235, NULL),
('Hampton Inn', 57, '2019-04-10', 392, NULL),
('Hampton Inn', 57, '2019-04-11', 105, NULL),
('Hampton Inn', 57, '2019-04-12', 123, NULL),
('Hampton Inn', 57, '2019-04-13', 117, NULL),
('Hampton Inn', 57, '2019-04-14', 126, NULL),
('Hampton Inn', 57, '2019-04-15', 392, NULL),
('Hampton Inn', 57, '2019-04-16', 113, NULL),
('Hampton Inn', 57, '2019-04-17', 115, NULL),
('Hampton Inn', 57, '2019-04-18', 392, NULL),
('Hampton Inn', 57, '2019-04-19', 280, NULL),
('Hampton Inn', 57, '2019-04-20', 288, NULL),
('Hampton Inn', 57, '2019-04-21', 287, NULL),
('Hampton Inn', 57, '2019-04-22', 219, NULL),
('Hampton Inn', 57, '2019-04-23', 345, NULL),
('Hampton Inn', 57, '2019-04-24', 277, NULL),
('Hampton Inn', 57, '2019-04-25', 147, NULL),
('Hampton Inn', 57, '2019-04-26', 383, NULL),
('Hampton Inn', 57, '2019-04-27', 125, NULL),
('Hampton Inn', 57, '2019-04-28', 378, NULL),
('Hampton Inn', 57, '2019-04-29', 251, NULL),
('Hampton Inn', 57, '2019-04-30', 106, NULL),
('Hampton Inn', 57, '2019-05-01', 379, NULL),
('Hampton Inn', 57, '2019-05-02', 240, NULL),
('Hampton Inn', 57, '2019-05-03', 193, NULL),
('Hampton Inn', 57, '2019-05-04', 113, NULL),
('Hampton Inn', 57, '2019-05-05', 112, NULL),
('Hampton Inn', 57, '2019-05-06', 272, NULL),
('Hampton Inn', 57, '2019-05-07', 221, NULL),
('Hampton Inn', 57, '2019-05-08', 336, NULL),
('Hampton Inn', 57, '2019-05-09', 238, NULL),
('Hampton Inn', 57, '2019-05-10', 317, NULL),
('Hampton Inn', 57, '2019-05-11', 162, NULL),
('Hampton Inn', 57, '2019-05-12', 196, NULL),
('Hampton Inn', 57, '2019-05-13', 395, NULL),
('Hampton Inn', 57, '2019-05-14', 168, NULL),
('Hampton Inn', 57, '2019-05-15', 324, NULL),
('Hampton Inn', 57, '2019-05-16', 359, NULL),
('Hampton Inn', 57, '2019-05-17', 154, NULL),
('Hampton Inn', 57, '2019-05-18', 139, NULL),
('Hampton Inn', 57, '2019-05-19', 195, NULL),
('Hampton Inn', 57, '2019-05-20', 126, NULL),
('Hampton Inn', 57, '2019-05-21', 190, NULL),
('Hampton Inn', 57, '2019-05-22', 165, NULL),
('Hampton Inn', 57, '2019-05-23', 177, NULL),
('Hampton Inn', 57, '2019-05-24', 395, NULL),
('Hampton Inn', 57, '2019-05-25', 245, NULL),
('Hampton Inn', 57, '2019-05-26', 260, NULL),
('Hampton Inn', 57, '2019-05-27', 289, NULL),
('Hampton Inn', 57, '2019-05-28', 379, NULL),
('Hampton Inn', 57, '2019-05-29', 119, NULL),
('Hampton Inn', 57, '2019-05-30', 170, NULL),
('Hampton Inn', 57, '2019-05-31', 389, NULL),
('Hampton Inn', 57, '2019-06-01', 396, NULL),
('Hampton Inn', 57, '2019-06-02', 353, NULL),
('Hampton Inn', 57, '2019-06-03', 268, NULL),
('Hampton Inn', 57, '2019-06-04', 106, NULL),
('Hampton Inn', 57, '2019-06-05', 285, NULL),
('Hampton Inn', 57, '2019-06-06', 208, NULL),
('Hampton Inn', 57, '2019-06-07', 139, NULL),
('Hampton Inn', 57, '2019-06-08', 105, NULL),
('Hampton Inn', 57, '2019-06-09', 232, NULL),
('Hampton Inn', 57, '2019-06-10', 237, NULL),
('Hampton Inn', 57, '2019-06-11', 205, NULL),
('Hampton Inn', 57, '2019-06-12', 294, NULL),
('Hampton Inn', 57, '2019-06-13', 397, NULL),
('Hampton Inn', 57, '2019-06-14', 304, NULL),
('Hampton Inn', 57, '2019-06-15', 352, NULL),
('Hampton Inn', 57, '2019-06-16', 189, NULL),
('Hampton Inn', 57, '2019-06-17', 373, NULL),
('Hampton Inn', 57, '2019-06-18', 120, NULL),
('Hampton Inn', 57, '2019-06-19', 392, NULL),
('Hampton Inn', 57, '2019-06-20', 375, NULL),
('Hampton Inn', 57, '2019-06-21', 378, NULL),
('Hampton Inn', 57, '2019-06-22', 351, NULL),
('Hampton Inn', 57, '2019-06-23', 149, NULL),
('Hampton Inn', 57, '2019-06-24', 115, NULL),
('Hampton Inn', 57, '2019-06-25', 235, NULL),
('Hampton Inn', 57, '2019-06-26', 108, NULL),
('Hampton Inn', 57, '2019-06-27', 195, NULL),
('Hampton Inn', 57, '2019-06-28', 124, NULL),
('Hampton Inn', 57, '2019-06-29', 156, NULL),
('Hampton Inn', 57, '2019-06-30', 280, NULL),
('Hampton Inn', 57, '2019-07-01', 369, NULL),
('Hampton Inn', 57, '2019-07-02', 287, NULL),
('Hampton Inn', 57, '2019-07-03', 159, NULL),
('Hampton Inn', 57, '2019-07-04', 343, NULL),
('Hampton Inn', 57, '2019-07-05', 109, NULL),
('Hampton Inn', 57, '2019-07-06', 362, NULL),
('Hampton Inn', 57, '2019-07-07', 173, NULL),
('Hampton Inn', 57, '2019-07-08', 287, NULL),
('Hampton Inn', 57, '2019-07-09', 108, NULL),
('Hampton Inn', 57, '2019-07-10', 143, NULL),
('Hampton Inn', 57, '2019-07-11', 230, NULL),
('Hampton Inn', 57, '2019-07-12', 178, NULL),
('Hampton Inn', 57, '2019-07-13', 108, NULL),
('Hampton Inn', 57, '2019-07-14', 322, NULL),
('Hampton Inn', 57, '2019-07-15', 301, NULL),
('Hampton Inn', 57, '2019-07-16', 201, NULL),
('Hampton Inn', 57, '2019-07-17', 305, NULL),
('Hampton Inn', 57, '2019-07-18', 193, NULL),
('Hampton Inn', 57, '2019-07-19', 310, NULL),
('Hampton Inn', 57, '2019-07-20', 339, NULL),
('Hampton Inn', 57, '2019-07-21', 107, NULL),
('Hampton Inn', 57, '2019-07-22', 358, NULL),
('Hampton Inn', 57, '2019-07-23', 259, NULL),
('Hampton Inn', 57, '2019-07-24', 113, NULL),
('Hampton Inn', 57, '2019-07-25', 299, NULL),
('Hampton Inn', 57, '2019-07-26', 249, NULL),
('Hampton Inn', 57, '2019-07-27', 157, NULL),
('Hampton Inn', 57, '2019-07-28', 327, NULL),
('Hampton Inn', 57, '2019-07-29', 354, NULL),
('Hampton Inn', 57, '2019-07-30', 256, NULL),
('Hampton Inn', 57, '2019-07-31', 294, NULL),
('Hampton Inn', 57, '2019-08-01', 226, NULL),
('Hampton Inn', 57, '2019-08-02', 256, NULL),
('Hampton Inn', 57, '2019-08-03', 117, NULL),
('Hampton Inn', 57, '2019-08-04', 320, NULL),
('Hampton Inn', 57, '2019-08-05', 102, NULL),
('Hampton Inn', 57, '2019-08-06', 227, NULL),
('Hampton Inn', 57, '2019-08-07', 113, NULL),
('Hampton Inn', 57, '2019-08-08', 293, NULL),
('Hampton Inn', 57, '2019-08-09', 125, NULL),
('Hampton Inn', 57, '2019-08-10', 338, NULL),
('Hampton Inn', 57, '2019-08-11', 117, NULL),
('Hampton Inn', 57, '2019-08-12', 244, NULL),
('Hampton Inn', 57, '2019-08-13', 266, NULL),
('Hampton Inn', 57, '2019-08-14', 370, NULL),
('Hampton Inn', 57, '2019-08-15', 192, NULL),
('Hampton Inn', 57, '2019-08-16', 317, NULL),
('Hampton Inn', 57, '2019-08-17', 206, NULL),
('Hampton Inn', 57, '2019-08-18', 140, NULL),
('Hampton Inn', 57, '2019-08-19', 109, NULL),
('Hampton Inn', 57, '2019-08-20', 311, NULL),
('Hampton Inn', 57, '2019-08-21', 135, NULL),
('Hampton Inn', 57, '2019-08-22', 365, NULL),
('Hampton Inn', 57, '2019-08-23', 215, NULL),
('Hampton Inn', 57, '2019-08-24', 275, NULL),
('Hampton Inn', 57, '2019-08-25', 365, NULL),
('Hampton Inn', 57, '2019-08-26', 185, NULL),
('Hampton Inn', 57, '2019-08-27', 371, NULL),
('Hampton Inn', 57, '2019-08-28', 145, NULL),
('Hampton Inn', 57, '2019-08-29', 324, NULL),
('Hampton Inn', 57, '2019-08-30', 288, NULL),
('Hampton Inn', 57, '2019-08-31', 282, NULL),
('Hampton Inn', 57, '2019-09-01', 362, NULL),
('Hampton Inn', 57, '2019-09-02', 250, NULL),
('Hampton Inn', 57, '2019-09-03', 353, NULL),
('Hampton Inn', 57, '2019-09-04', 126, NULL),
('Hampton Inn', 57, '2019-09-05', 211, NULL),
('Hampton Inn', 57, '2019-09-06', 335, NULL),
('Hampton Inn', 57, '2019-09-07', 308, NULL),
('Hampton Inn', 57, '2019-09-08', 117, NULL),
('Hampton Inn', 57, '2019-09-09', 220, NULL),
('Hampton Inn', 57, '2019-09-10', 269, NULL),
('Hampton Inn', 57, '2019-09-11', 168, NULL),
('Hampton Inn', 57, '2019-09-12', 327, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 57, '2019-09-13', 196, NULL),
('Hampton Inn', 57, '2019-09-14', 319, NULL),
('Hampton Inn', 57, '2019-09-15', 249, NULL),
('Hampton Inn', 57, '2019-09-16', 380, NULL),
('Hampton Inn', 57, '2019-09-17', 113, NULL),
('Hampton Inn', 57, '2019-09-18', 180, NULL),
('Hampton Inn', 57, '2019-09-19', 140, NULL),
('Hampton Inn', 57, '2019-09-20', 374, NULL),
('Hampton Inn', 57, '2019-09-21', 193, NULL),
('Hampton Inn', 57, '2019-09-22', 398, NULL),
('Hampton Inn', 57, '2019-09-23', 305, NULL),
('Hampton Inn', 57, '2019-09-24', 390, NULL),
('Hampton Inn', 57, '2019-09-25', 180, NULL),
('Hampton Inn', 57, '2019-09-26', 222, NULL),
('Hampton Inn', 57, '2019-09-27', 273, NULL),
('Hampton Inn', 57, '2019-09-28', 250, NULL),
('Hampton Inn', 57, '2019-09-29', 290, NULL),
('Hampton Inn', 57, '2019-09-30', 185, NULL),
('Hampton Inn', 57, '2019-10-01', 234, NULL),
('Hampton Inn', 57, '2019-10-02', 318, NULL),
('Hampton Inn', 57, '2019-10-03', 174, NULL),
('Hampton Inn', 57, '2019-10-04', 261, NULL),
('Hampton Inn', 57, '2019-10-05', 176, NULL),
('Hampton Inn', 57, '2019-10-06', 231, NULL),
('Hampton Inn', 57, '2019-10-07', 308, NULL),
('Hampton Inn', 57, '2019-10-08', 275, NULL),
('Hampton Inn', 57, '2019-10-09', 272, NULL),
('Hampton Inn', 57, '2019-10-10', 204, NULL),
('Hampton Inn', 57, '2019-10-11', 268, NULL),
('Hampton Inn', 57, '2019-10-12', 198, NULL),
('Hampton Inn', 57, '2019-10-13', 159, NULL),
('Hampton Inn', 57, '2019-10-14', 365, NULL),
('Hampton Inn', 57, '2019-10-15', 147, NULL),
('Hampton Inn', 57, '2019-10-16', 175, NULL),
('Hampton Inn', 57, '2019-10-17', 145, NULL),
('Hampton Inn', 57, '2019-10-18', 191, NULL),
('Hampton Inn', 57, '2019-10-19', 172, NULL),
('Hampton Inn', 57, '2019-10-20', 121, NULL),
('Hampton Inn', 57, '2019-10-21', 125, NULL),
('Hampton Inn', 57, '2019-10-22', 267, NULL),
('Hampton Inn', 57, '2019-10-23', 198, NULL),
('Hampton Inn', 57, '2019-10-24', 298, NULL),
('Hampton Inn', 57, '2019-10-25', 379, NULL),
('Hampton Inn', 57, '2019-10-26', 207, NULL),
('Hampton Inn', 57, '2019-10-27', 295, NULL),
('Hampton Inn', 57, '2019-10-28', 170, NULL),
('Hampton Inn', 57, '2019-10-29', 364, NULL),
('Hampton Inn', 57, '2019-10-30', 378, NULL),
('Hampton Inn', 57, '2019-10-31', 367, NULL),
('Hampton Inn', 57, '2019-11-01', 247, NULL),
('Hampton Inn', 57, '2019-11-02', 310, NULL),
('Hampton Inn', 57, '2019-11-03', 393, NULL),
('Hampton Inn', 57, '2019-11-04', 100, NULL),
('Hampton Inn', 57, '2019-11-05', 115, NULL),
('Hampton Inn', 57, '2019-11-06', 187, NULL),
('Hampton Inn', 57, '2019-11-07', 243, NULL),
('Hampton Inn', 57, '2019-11-08', 143, NULL),
('Hampton Inn', 57, '2019-11-09', 347, NULL),
('Hampton Inn', 57, '2019-11-10', 257, NULL),
('Hampton Inn', 57, '2019-11-11', 102, NULL),
('Hampton Inn', 57, '2019-11-12', 256, NULL),
('Hampton Inn', 57, '2019-11-13', 388, NULL),
('Hampton Inn', 57, '2019-11-14', 238, NULL),
('Hampton Inn', 57, '2019-11-15', 304, NULL),
('Hampton Inn', 57, '2019-11-16', 335, NULL),
('Hampton Inn', 57, '2019-11-17', 333, NULL),
('Hampton Inn', 57, '2019-11-18', 379, NULL),
('Hampton Inn', 57, '2019-11-19', 362, NULL),
('Hampton Inn', 57, '2019-11-20', 157, NULL),
('Hampton Inn', 57, '2019-11-21', 265, NULL),
('Hampton Inn', 57, '2019-11-22', 268, NULL),
('Hampton Inn', 57, '2019-11-23', 214, NULL),
('Hampton Inn', 57, '2019-11-24', 332, NULL),
('Hampton Inn', 57, '2019-11-25', 345, NULL),
('Hampton Inn', 57, '2019-11-26', 285, NULL),
('Hampton Inn', 57, '2019-11-27', 177, NULL),
('Hampton Inn', 57, '2019-11-28', 281, NULL),
('Hampton Inn', 57, '2019-11-29', 246, NULL),
('Hampton Inn', 57, '2019-11-30', 147, NULL),
('Hampton Inn', 57, '2019-12-01', 128, NULL),
('Hampton Inn', 57, '2019-12-02', 371, NULL),
('Hampton Inn', 57, '2019-12-03', 201, NULL),
('Hampton Inn', 57, '2019-12-04', 143, NULL),
('Hampton Inn', 57, '2019-12-05', 380, NULL),
('Hampton Inn', 57, '2019-12-06', 163, NULL),
('Hampton Inn', 57, '2019-12-07', 286, NULL),
('Hampton Inn', 57, '2019-12-08', 265, NULL),
('Hampton Inn', 57, '2019-12-09', 103, NULL),
('Hampton Inn', 57, '2019-12-10', 356, NULL),
('Hampton Inn', 57, '2019-12-11', 166, NULL),
('Hampton Inn', 57, '2019-12-12', 274, NULL),
('Hampton Inn', 57, '2019-12-13', 384, NULL),
('Hampton Inn', 57, '2019-12-14', 286, NULL),
('Hampton Inn', 57, '2019-12-15', 295, NULL),
('Hampton Inn', 57, '2019-12-16', 323, NULL),
('Hampton Inn', 57, '2019-12-17', 215, NULL),
('Hampton Inn', 57, '2019-12-18', 385, NULL),
('Hampton Inn', 57, '2019-12-19', 163, NULL),
('Hampton Inn', 57, '2019-12-20', 102, NULL),
('Hampton Inn', 57, '2019-12-21', 326, NULL),
('Hampton Inn', 57, '2019-12-22', 237, NULL),
('Hampton Inn', 57, '2019-12-23', 209, NULL),
('Hampton Inn', 57, '2019-12-24', 284, NULL),
('Hampton Inn', 57, '2019-12-25', 190, NULL),
('Hampton Inn', 57, '2019-12-26', 139, NULL),
('Hampton Inn', 57, '2019-12-27', 325, NULL),
('Hampton Inn', 57, '2019-12-28', 289, NULL),
('Hampton Inn', 57, '2019-12-29', 153, NULL),
('Hampton Inn', 57, '2019-12-30', 220, NULL),
('Hampton Inn', 57, '2019-12-31', 352, NULL),
('Hampton Inn', 57, '2020-01-01', 163, NULL),
('Hampton Inn', 57, '2020-01-02', 216, NULL),
('Hampton Inn', 57, '2020-01-03', 293, NULL),
('Hampton Inn', 57, '2020-01-04', 316, NULL),
('Hampton Inn', 57, '2020-01-05', 203, NULL),
('Hampton Inn', 57, '2020-01-06', 290, NULL),
('Hampton Inn', 57, '2020-01-07', 209, NULL),
('Hampton Inn', 57, '2020-01-08', 183, NULL),
('Hampton Inn', 57, '2020-01-09', 247, NULL),
('Hampton Inn', 57, '2020-01-10', 232, NULL),
('Hampton Inn', 57, '2020-01-11', 190, NULL),
('Hampton Inn', 57, '2020-01-12', 374, NULL),
('Hampton Inn', 57, '2020-01-13', 335, NULL),
('Hampton Inn', 57, '2020-01-14', 331, NULL),
('Hampton Inn', 57, '2020-01-15', 302, NULL),
('Hampton Inn', 57, '2020-01-16', 193, NULL),
('Hampton Inn', 57, '2020-01-17', 303, NULL),
('Hampton Inn', 57, '2020-01-18', 344, NULL),
('Hampton Inn', 57, '2020-01-19', 206, NULL),
('Hampton Inn', 57, '2020-01-20', 393, NULL),
('Hampton Inn', 57, '2020-01-21', 198, NULL),
('Hampton Inn', 57, '2020-01-22', 345, NULL),
('Hampton Inn', 57, '2020-01-23', 346, NULL),
('Hampton Inn', 57, '2020-01-24', 373, NULL),
('Hampton Inn', 57, '2020-01-25', 232, NULL),
('Hampton Inn', 57, '2020-01-26', 255, NULL),
('Hampton Inn', 57, '2020-01-27', 335, NULL),
('Hampton Inn', 57, '2020-01-28', 225, NULL),
('Hampton Inn', 57, '2020-01-29', 299, NULL),
('Hampton Inn', 57, '2020-01-30', 239, NULL),
('Hampton Inn', 57, '2020-01-31', 322, NULL),
('Hampton Inn', 57, '2020-02-01', 399, NULL),
('Hampton Inn', 57, '2020-02-02', 164, NULL),
('Hampton Inn', 57, '2020-02-03', 387, NULL),
('Hampton Inn', 57, '2020-02-04', 392, NULL),
('Hampton Inn', 61, '2019-01-01', 134, NULL),
('Hampton Inn', 61, '2019-01-02', 387, NULL),
('Hampton Inn', 61, '2019-01-03', 243, NULL),
('Hampton Inn', 61, '2019-01-04', 353, NULL),
('Hampton Inn', 61, '2019-01-05', 142, NULL),
('Hampton Inn', 61, '2019-01-06', 135, NULL),
('Hampton Inn', 61, '2019-01-07', 298, NULL),
('Hampton Inn', 61, '2019-01-08', 200, NULL),
('Hampton Inn', 61, '2019-01-09', 129, NULL),
('Hampton Inn', 61, '2019-01-10', 388, NULL),
('Hampton Inn', 61, '2019-01-11', 325, NULL),
('Hampton Inn', 61, '2019-01-12', 197, NULL),
('Hampton Inn', 61, '2019-01-13', 118, NULL),
('Hampton Inn', 61, '2019-01-14', 176, NULL),
('Hampton Inn', 61, '2019-01-15', 150, NULL),
('Hampton Inn', 61, '2019-01-16', 172, NULL),
('Hampton Inn', 61, '2019-01-17', 258, NULL),
('Hampton Inn', 61, '2019-01-18', 166, NULL),
('Hampton Inn', 61, '2019-01-19', 262, NULL),
('Hampton Inn', 61, '2019-01-20', 357, NULL),
('Hampton Inn', 61, '2019-01-21', 279, NULL),
('Hampton Inn', 61, '2019-01-22', 164, NULL),
('Hampton Inn', 61, '2019-01-23', 289, NULL),
('Hampton Inn', 61, '2019-01-24', 119, NULL),
('Hampton Inn', 61, '2019-01-25', 264, NULL),
('Hampton Inn', 61, '2019-01-26', 219, NULL),
('Hampton Inn', 61, '2019-01-27', 229, NULL),
('Hampton Inn', 61, '2019-01-28', 191, NULL),
('Hampton Inn', 61, '2019-01-29', 360, NULL),
('Hampton Inn', 61, '2019-01-30', 175, NULL),
('Hampton Inn', 61, '2019-01-31', 361, NULL),
('Hampton Inn', 61, '2019-02-01', 184, NULL),
('Hampton Inn', 61, '2019-02-02', 142, NULL),
('Hampton Inn', 61, '2019-02-03', 226, NULL),
('Hampton Inn', 61, '2019-02-04', 396, NULL),
('Hampton Inn', 61, '2019-02-05', 365, NULL),
('Hampton Inn', 61, '2019-02-06', 158, NULL),
('Hampton Inn', 61, '2019-02-07', 282, NULL),
('Hampton Inn', 61, '2019-02-08', 269, NULL),
('Hampton Inn', 61, '2019-02-09', 114, NULL),
('Hampton Inn', 61, '2019-02-10', 105, NULL),
('Hampton Inn', 61, '2019-02-11', 273, NULL),
('Hampton Inn', 61, '2019-02-12', 326, NULL),
('Hampton Inn', 61, '2019-02-13', 378, NULL),
('Hampton Inn', 61, '2019-02-14', 299, NULL),
('Hampton Inn', 61, '2019-02-15', 364, NULL),
('Hampton Inn', 61, '2019-02-16', 142, NULL),
('Hampton Inn', 61, '2019-02-17', 218, NULL),
('Hampton Inn', 61, '2019-02-18', 283, NULL),
('Hampton Inn', 61, '2019-02-19', 245, NULL),
('Hampton Inn', 61, '2019-02-20', 323, NULL),
('Hampton Inn', 61, '2019-02-21', 119, NULL),
('Hampton Inn', 61, '2019-02-22', 182, NULL),
('Hampton Inn', 61, '2019-02-23', 375, NULL),
('Hampton Inn', 61, '2019-02-24', 364, NULL),
('Hampton Inn', 61, '2019-02-25', 185, NULL),
('Hampton Inn', 61, '2019-02-26', 258, NULL),
('Hampton Inn', 61, '2019-02-27', 142, NULL),
('Hampton Inn', 61, '2019-02-28', 201, NULL),
('Hampton Inn', 61, '2019-03-01', 260, NULL),
('Hampton Inn', 61, '2019-03-02', 358, NULL),
('Hampton Inn', 61, '2019-03-03', 333, NULL),
('Hampton Inn', 61, '2019-03-04', 121, NULL),
('Hampton Inn', 61, '2019-03-05', 209, NULL),
('Hampton Inn', 61, '2019-03-06', 166, NULL),
('Hampton Inn', 61, '2019-03-07', 111, NULL),
('Hampton Inn', 61, '2019-03-08', 150, NULL),
('Hampton Inn', 61, '2019-03-09', 256, NULL),
('Hampton Inn', 61, '2019-03-10', 333, NULL),
('Hampton Inn', 61, '2019-03-11', 324, NULL),
('Hampton Inn', 61, '2019-03-12', 357, NULL),
('Hampton Inn', 61, '2019-03-13', 108, NULL),
('Hampton Inn', 61, '2019-03-14', 182, NULL),
('Hampton Inn', 61, '2019-03-15', 291, NULL),
('Hampton Inn', 61, '2019-03-16', 102, NULL),
('Hampton Inn', 61, '2019-03-17', 353, NULL),
('Hampton Inn', 61, '2019-03-18', 189, NULL),
('Hampton Inn', 61, '2019-03-19', 225, NULL),
('Hampton Inn', 61, '2019-03-20', 390, NULL),
('Hampton Inn', 61, '2019-03-21', 135, NULL),
('Hampton Inn', 61, '2019-03-22', 348, NULL),
('Hampton Inn', 61, '2019-03-23', 200, NULL),
('Hampton Inn', 61, '2019-03-24', 101, NULL),
('Hampton Inn', 61, '2019-03-25', 143, NULL),
('Hampton Inn', 61, '2019-03-26', 273, NULL),
('Hampton Inn', 61, '2019-03-27', 383, NULL),
('Hampton Inn', 61, '2019-03-28', 135, NULL),
('Hampton Inn', 61, '2019-03-29', 171, NULL),
('Hampton Inn', 61, '2019-03-30', 250, NULL),
('Hampton Inn', 61, '2019-03-31', 246, NULL),
('Hampton Inn', 61, '2019-04-01', 262, NULL),
('Hampton Inn', 61, '2019-04-02', 148, NULL),
('Hampton Inn', 61, '2019-04-03', 170, NULL),
('Hampton Inn', 61, '2019-04-04', 229, NULL),
('Hampton Inn', 61, '2019-04-05', 398, NULL),
('Hampton Inn', 61, '2019-04-06', 260, NULL),
('Hampton Inn', 61, '2019-04-07', 178, NULL),
('Hampton Inn', 61, '2019-04-08', 395, NULL),
('Hampton Inn', 61, '2019-04-09', 236, NULL),
('Hampton Inn', 61, '2019-04-10', 300, NULL),
('Hampton Inn', 61, '2019-04-11', 166, NULL),
('Hampton Inn', 61, '2019-04-12', 183, NULL),
('Hampton Inn', 61, '2019-04-13', 135, NULL),
('Hampton Inn', 61, '2019-04-14', 151, NULL),
('Hampton Inn', 61, '2019-04-15', 258, NULL),
('Hampton Inn', 61, '2019-04-16', 153, NULL),
('Hampton Inn', 61, '2019-04-17', 102, NULL),
('Hampton Inn', 61, '2019-04-18', 296, NULL),
('Hampton Inn', 61, '2019-04-19', 178, NULL),
('Hampton Inn', 61, '2019-04-20', 268, NULL),
('Hampton Inn', 61, '2019-04-21', 286, NULL),
('Hampton Inn', 61, '2019-04-22', 303, NULL),
('Hampton Inn', 61, '2019-04-23', 282, NULL),
('Hampton Inn', 61, '2019-04-24', 388, NULL),
('Hampton Inn', 61, '2019-04-25', 391, NULL),
('Hampton Inn', 61, '2019-04-26', 218, NULL),
('Hampton Inn', 61, '2019-04-27', 332, NULL),
('Hampton Inn', 61, '2019-04-28', 281, NULL),
('Hampton Inn', 61, '2019-04-29', 222, NULL),
('Hampton Inn', 61, '2019-04-30', 382, NULL),
('Hampton Inn', 61, '2019-05-01', 201, NULL),
('Hampton Inn', 61, '2019-05-02', 180, NULL),
('Hampton Inn', 61, '2019-05-03', 343, NULL),
('Hampton Inn', 61, '2019-05-04', 335, NULL),
('Hampton Inn', 61, '2019-05-05', 118, NULL),
('Hampton Inn', 61, '2019-05-06', 293, NULL),
('Hampton Inn', 61, '2019-05-07', 227, NULL),
('Hampton Inn', 61, '2019-05-08', 391, NULL),
('Hampton Inn', 61, '2019-05-09', 373, NULL),
('Hampton Inn', 61, '2019-05-10', 168, NULL),
('Hampton Inn', 61, '2019-05-11', 260, NULL),
('Hampton Inn', 61, '2019-05-12', 200, NULL),
('Hampton Inn', 61, '2019-05-13', 212, NULL),
('Hampton Inn', 61, '2019-05-14', 243, NULL),
('Hampton Inn', 61, '2019-05-15', 257, NULL),
('Hampton Inn', 61, '2019-05-16', 260, NULL),
('Hampton Inn', 61, '2019-05-17', 373, NULL),
('Hampton Inn', 61, '2019-05-18', 292, NULL),
('Hampton Inn', 61, '2019-05-19', 116, NULL),
('Hampton Inn', 61, '2019-05-20', 326, NULL),
('Hampton Inn', 61, '2019-05-21', 141, NULL),
('Hampton Inn', 61, '2019-05-22', 342, NULL),
('Hampton Inn', 61, '2019-05-23', 259, NULL),
('Hampton Inn', 61, '2019-05-24', 328, NULL),
('Hampton Inn', 61, '2019-05-25', 149, NULL),
('Hampton Inn', 61, '2019-05-26', 336, NULL),
('Hampton Inn', 61, '2019-05-27', 266, NULL),
('Hampton Inn', 61, '2019-05-28', 255, NULL),
('Hampton Inn', 61, '2019-05-29', 288, NULL),
('Hampton Inn', 61, '2019-05-30', 136, NULL),
('Hampton Inn', 61, '2019-05-31', 293, NULL),
('Hampton Inn', 61, '2019-06-01', 140, NULL),
('Hampton Inn', 61, '2019-06-02', 102, NULL),
('Hampton Inn', 61, '2019-06-03', 195, NULL),
('Hampton Inn', 61, '2019-06-04', 325, NULL),
('Hampton Inn', 61, '2019-06-05', 135, NULL),
('Hampton Inn', 61, '2019-06-06', 150, NULL),
('Hampton Inn', 61, '2019-06-07', 208, NULL),
('Hampton Inn', 61, '2019-06-08', 289, NULL),
('Hampton Inn', 61, '2019-06-09', 219, NULL),
('Hampton Inn', 61, '2019-06-10', 192, NULL),
('Hampton Inn', 61, '2019-06-11', 281, NULL),
('Hampton Inn', 61, '2019-06-12', 301, NULL),
('Hampton Inn', 61, '2019-06-13', 272, NULL),
('Hampton Inn', 61, '2019-06-14', 224, NULL),
('Hampton Inn', 61, '2019-06-15', 130, NULL),
('Hampton Inn', 61, '2019-06-16', 201, NULL),
('Hampton Inn', 61, '2019-06-17', 317, NULL),
('Hampton Inn', 61, '2019-06-18', 292, NULL),
('Hampton Inn', 61, '2019-06-19', 183, NULL),
('Hampton Inn', 61, '2019-06-20', 274, NULL),
('Hampton Inn', 61, '2019-06-21', 275, NULL),
('Hampton Inn', 61, '2019-06-22', 111, NULL),
('Hampton Inn', 61, '2019-06-23', 216, NULL),
('Hampton Inn', 61, '2019-06-24', 333, NULL),
('Hampton Inn', 61, '2019-06-25', 173, NULL),
('Hampton Inn', 61, '2019-06-26', 252, NULL),
('Hampton Inn', 61, '2019-06-27', 286, NULL),
('Hampton Inn', 61, '2019-06-28', 380, NULL),
('Hampton Inn', 61, '2019-06-29', 188, NULL),
('Hampton Inn', 61, '2019-06-30', 191, NULL),
('Hampton Inn', 61, '2019-07-01', 174, NULL),
('Hampton Inn', 61, '2019-07-02', 102, NULL),
('Hampton Inn', 61, '2019-07-03', 372, NULL),
('Hampton Inn', 61, '2019-07-04', 180, NULL),
('Hampton Inn', 61, '2019-07-05', 380, NULL),
('Hampton Inn', 61, '2019-07-06', 268, NULL),
('Hampton Inn', 61, '2019-07-07', 289, NULL),
('Hampton Inn', 61, '2019-07-08', 389, NULL),
('Hampton Inn', 61, '2019-07-09', 339, NULL),
('Hampton Inn', 61, '2019-07-10', 328, NULL),
('Hampton Inn', 61, '2019-07-11', 202, NULL),
('Hampton Inn', 61, '2019-07-12', 160, NULL),
('Hampton Inn', 61, '2019-07-13', 327, NULL),
('Hampton Inn', 61, '2019-07-14', 252, NULL),
('Hampton Inn', 61, '2019-07-15', 287, NULL),
('Hampton Inn', 61, '2019-07-16', 156, NULL),
('Hampton Inn', 61, '2019-07-17', 155, NULL),
('Hampton Inn', 61, '2019-07-18', 344, NULL),
('Hampton Inn', 61, '2019-07-19', 101, NULL),
('Hampton Inn', 61, '2019-07-20', 133, NULL),
('Hampton Inn', 61, '2019-07-21', 243, NULL),
('Hampton Inn', 61, '2019-07-22', 289, NULL),
('Hampton Inn', 61, '2019-07-23', 342, NULL),
('Hampton Inn', 61, '2019-07-24', 253, NULL),
('Hampton Inn', 61, '2019-07-25', 316, NULL),
('Hampton Inn', 61, '2019-07-26', 327, NULL),
('Hampton Inn', 61, '2019-07-27', 373, NULL),
('Hampton Inn', 61, '2019-07-28', 238, NULL),
('Hampton Inn', 61, '2019-07-29', 116, NULL),
('Hampton Inn', 61, '2019-07-30', 139, NULL),
('Hampton Inn', 61, '2019-07-31', 301, NULL),
('Hampton Inn', 61, '2019-08-01', 367, NULL),
('Hampton Inn', 61, '2019-08-02', 168, NULL),
('Hampton Inn', 61, '2019-08-03', 157, NULL),
('Hampton Inn', 61, '2019-08-04', 179, NULL),
('Hampton Inn', 61, '2019-08-05', 215, NULL),
('Hampton Inn', 61, '2019-08-06', 120, NULL),
('Hampton Inn', 61, '2019-08-07', 357, NULL),
('Hampton Inn', 61, '2019-08-08', 362, NULL),
('Hampton Inn', 61, '2019-08-09', 232, NULL),
('Hampton Inn', 61, '2019-08-10', 342, NULL),
('Hampton Inn', 61, '2019-08-11', 100, NULL),
('Hampton Inn', 61, '2019-08-12', 299, NULL),
('Hampton Inn', 61, '2019-08-13', 266, NULL),
('Hampton Inn', 61, '2019-08-14', 151, NULL),
('Hampton Inn', 61, '2019-08-15', 297, NULL),
('Hampton Inn', 61, '2019-08-16', 347, NULL),
('Hampton Inn', 61, '2019-08-17', 365, NULL),
('Hampton Inn', 61, '2019-08-18', 100, NULL),
('Hampton Inn', 61, '2019-08-19', 174, NULL),
('Hampton Inn', 61, '2019-08-20', 188, NULL),
('Hampton Inn', 61, '2019-08-21', 305, NULL),
('Hampton Inn', 61, '2019-08-22', 193, NULL),
('Hampton Inn', 61, '2019-08-23', 248, NULL),
('Hampton Inn', 61, '2019-08-24', 265, NULL),
('Hampton Inn', 61, '2019-08-25', 303, NULL),
('Hampton Inn', 61, '2019-08-26', 213, NULL),
('Hampton Inn', 61, '2019-08-27', 387, NULL),
('Hampton Inn', 61, '2019-08-28', 160, NULL),
('Hampton Inn', 61, '2019-08-29', 201, NULL),
('Hampton Inn', 61, '2019-08-30', 310, NULL),
('Hampton Inn', 61, '2019-08-31', 236, NULL),
('Hampton Inn', 61, '2019-09-01', 379, NULL),
('Hampton Inn', 61, '2019-09-02', 306, NULL),
('Hampton Inn', 61, '2019-09-03', 239, NULL),
('Hampton Inn', 61, '2019-09-04', 243, NULL),
('Hampton Inn', 61, '2019-09-05', 220, NULL),
('Hampton Inn', 61, '2019-09-06', 316, NULL),
('Hampton Inn', 61, '2019-09-07', 246, NULL),
('Hampton Inn', 61, '2019-09-08', 189, NULL),
('Hampton Inn', 61, '2019-09-09', 393, NULL),
('Hampton Inn', 61, '2019-09-10', 370, NULL),
('Hampton Inn', 61, '2019-09-11', 144, NULL),
('Hampton Inn', 61, '2019-09-12', 226, NULL),
('Hampton Inn', 61, '2019-09-13', 251, NULL),
('Hampton Inn', 61, '2019-09-14', 251, NULL),
('Hampton Inn', 61, '2019-09-15', 161, NULL),
('Hampton Inn', 61, '2019-09-16', 161, NULL),
('Hampton Inn', 61, '2019-09-17', 393, NULL),
('Hampton Inn', 61, '2019-09-18', 336, NULL),
('Hampton Inn', 61, '2019-09-19', 234, NULL),
('Hampton Inn', 61, '2019-09-20', 132, NULL),
('Hampton Inn', 61, '2019-09-21', 252, NULL),
('Hampton Inn', 61, '2019-09-22', 133, NULL),
('Hampton Inn', 61, '2019-09-23', 376, NULL),
('Hampton Inn', 61, '2019-09-24', 125, NULL),
('Hampton Inn', 61, '2019-09-25', 275, NULL),
('Hampton Inn', 61, '2019-09-26', 308, NULL),
('Hampton Inn', 61, '2019-09-27', 138, NULL),
('Hampton Inn', 61, '2019-09-28', 144, NULL),
('Hampton Inn', 61, '2019-09-29', 372, NULL),
('Hampton Inn', 61, '2019-09-30', 392, NULL),
('Hampton Inn', 61, '2019-10-01', 314, NULL),
('Hampton Inn', 61, '2019-10-02', 253, NULL),
('Hampton Inn', 61, '2019-10-03', 270, NULL),
('Hampton Inn', 61, '2019-10-04', 315, NULL),
('Hampton Inn', 61, '2019-10-05', 160, NULL),
('Hampton Inn', 61, '2019-10-06', 113, NULL),
('Hampton Inn', 61, '2019-10-07', 129, NULL),
('Hampton Inn', 61, '2019-10-08', 283, NULL),
('Hampton Inn', 61, '2019-10-09', 285, NULL),
('Hampton Inn', 61, '2019-10-10', 329, NULL),
('Hampton Inn', 61, '2019-10-11', 341, NULL),
('Hampton Inn', 61, '2019-10-12', 392, NULL),
('Hampton Inn', 61, '2019-10-13', 258, NULL),
('Hampton Inn', 61, '2019-10-14', 246, NULL),
('Hampton Inn', 61, '2019-10-15', 121, NULL),
('Hampton Inn', 61, '2019-10-16', 216, NULL),
('Hampton Inn', 61, '2019-10-17', 268, NULL),
('Hampton Inn', 61, '2019-10-18', 149, NULL),
('Hampton Inn', 61, '2019-10-19', 127, NULL),
('Hampton Inn', 61, '2019-10-20', 307, NULL),
('Hampton Inn', 61, '2019-10-21', 236, NULL),
('Hampton Inn', 61, '2019-10-22', 252, NULL),
('Hampton Inn', 61, '2019-10-23', 264, NULL),
('Hampton Inn', 61, '2019-10-24', 140, NULL),
('Hampton Inn', 61, '2019-10-25', 360, NULL),
('Hampton Inn', 61, '2019-10-26', 196, NULL),
('Hampton Inn', 61, '2019-10-27', 107, NULL),
('Hampton Inn', 61, '2019-10-28', 195, NULL),
('Hampton Inn', 61, '2019-10-29', 377, NULL),
('Hampton Inn', 61, '2019-10-30', 234, NULL),
('Hampton Inn', 61, '2019-10-31', 144, NULL),
('Hampton Inn', 61, '2019-11-01', 244, NULL),
('Hampton Inn', 61, '2019-11-02', 337, NULL),
('Hampton Inn', 61, '2019-11-03', 390, NULL),
('Hampton Inn', 61, '2019-11-04', 390, NULL),
('Hampton Inn', 61, '2019-11-05', 368, NULL),
('Hampton Inn', 61, '2019-11-06', 255, NULL),
('Hampton Inn', 61, '2019-11-07', 103, NULL),
('Hampton Inn', 61, '2019-11-08', 348, NULL),
('Hampton Inn', 61, '2019-11-09', 232, NULL),
('Hampton Inn', 61, '2019-11-10', 350, NULL),
('Hampton Inn', 61, '2019-11-11', 128, NULL),
('Hampton Inn', 61, '2019-11-12', 299, NULL),
('Hampton Inn', 61, '2019-11-13', 139, NULL),
('Hampton Inn', 61, '2019-11-14', 298, NULL),
('Hampton Inn', 61, '2019-11-15', 202, NULL),
('Hampton Inn', 61, '2019-11-16', 196, NULL),
('Hampton Inn', 61, '2019-11-17', 217, NULL),
('Hampton Inn', 61, '2019-11-18', 131, NULL),
('Hampton Inn', 61, '2019-11-19', 362, NULL),
('Hampton Inn', 61, '2019-11-20', 189, NULL),
('Hampton Inn', 61, '2019-11-21', 171, NULL),
('Hampton Inn', 61, '2019-11-22', 360, NULL),
('Hampton Inn', 61, '2019-11-23', 342, NULL),
('Hampton Inn', 61, '2019-11-24', 320, NULL),
('Hampton Inn', 61, '2019-11-25', 131, NULL),
('Hampton Inn', 61, '2019-11-26', 361, NULL),
('Hampton Inn', 61, '2019-11-27', 149, NULL),
('Hampton Inn', 61, '2019-11-28', 368, NULL),
('Hampton Inn', 61, '2019-11-29', 135, NULL),
('Hampton Inn', 61, '2019-11-30', 295, NULL),
('Hampton Inn', 61, '2019-12-01', 149, NULL),
('Hampton Inn', 61, '2019-12-02', 274, NULL),
('Hampton Inn', 61, '2019-12-03', 279, NULL),
('Hampton Inn', 61, '2019-12-04', 200, NULL),
('Hampton Inn', 61, '2019-12-05', 206, NULL),
('Hampton Inn', 61, '2019-12-06', 351, NULL),
('Hampton Inn', 61, '2019-12-07', 174, NULL),
('Hampton Inn', 61, '2019-12-08', 247, NULL),
('Hampton Inn', 61, '2019-12-09', 296, NULL),
('Hampton Inn', 61, '2019-12-10', 173, NULL),
('Hampton Inn', 61, '2019-12-11', 326, NULL),
('Hampton Inn', 61, '2019-12-12', 335, NULL),
('Hampton Inn', 61, '2019-12-13', 225, NULL),
('Hampton Inn', 61, '2019-12-14', 360, NULL),
('Hampton Inn', 61, '2019-12-15', 106, NULL),
('Hampton Inn', 61, '2019-12-16', 307, NULL),
('Hampton Inn', 61, '2019-12-17', 306, NULL),
('Hampton Inn', 61, '2019-12-18', 337, NULL),
('Hampton Inn', 61, '2019-12-19', 146, NULL),
('Hampton Inn', 61, '2019-12-20', 304, NULL),
('Hampton Inn', 61, '2019-12-21', 310, NULL),
('Hampton Inn', 61, '2019-12-22', 183, NULL),
('Hampton Inn', 61, '2019-12-23', 248, NULL),
('Hampton Inn', 61, '2019-12-24', 122, NULL),
('Hampton Inn', 61, '2019-12-25', 368, NULL),
('Hampton Inn', 61, '2019-12-26', 160, NULL),
('Hampton Inn', 61, '2019-12-27', 282, NULL),
('Hampton Inn', 61, '2019-12-28', 173, NULL),
('Hampton Inn', 61, '2019-12-29', 206, NULL),
('Hampton Inn', 61, '2019-12-30', 215, NULL),
('Hampton Inn', 61, '2019-12-31', 394, NULL),
('Hampton Inn', 61, '2020-01-01', 104, NULL),
('Hampton Inn', 61, '2020-01-02', 250, NULL),
('Hampton Inn', 61, '2020-01-03', 392, NULL),
('Hampton Inn', 61, '2020-01-04', 258, NULL),
('Hampton Inn', 61, '2020-01-05', 318, NULL),
('Hampton Inn', 61, '2020-01-06', 301, NULL),
('Hampton Inn', 61, '2020-01-07', 158, NULL),
('Hampton Inn', 61, '2020-01-08', 198, NULL),
('Hampton Inn', 61, '2020-01-09', 394, NULL),
('Hampton Inn', 61, '2020-01-10', 100, NULL),
('Hampton Inn', 61, '2020-01-11', 266, NULL),
('Hampton Inn', 61, '2020-01-12', 330, NULL),
('Hampton Inn', 61, '2020-01-13', 327, NULL),
('Hampton Inn', 61, '2020-01-14', 309, NULL),
('Hampton Inn', 61, '2020-01-15', 292, NULL),
('Hampton Inn', 61, '2020-01-16', 100, NULL),
('Hampton Inn', 61, '2020-01-17', 397, NULL),
('Hampton Inn', 61, '2020-01-18', 294, NULL),
('Hampton Inn', 61, '2020-01-19', 121, NULL),
('Hampton Inn', 61, '2020-01-20', 381, NULL),
('Hampton Inn', 61, '2020-01-21', 346, NULL),
('Hampton Inn', 61, '2020-01-22', 396, NULL),
('Hampton Inn', 61, '2020-01-23', 128, NULL),
('Hampton Inn', 61, '2020-01-24', 362, NULL),
('Hampton Inn', 61, '2020-01-25', 318, NULL),
('Hampton Inn', 61, '2020-01-26', 385, NULL),
('Hampton Inn', 61, '2020-01-27', 271, NULL),
('Hampton Inn', 61, '2020-01-28', 397, NULL),
('Hampton Inn', 61, '2020-01-29', 266, NULL),
('Hampton Inn', 61, '2020-01-30', 129, NULL),
('Hampton Inn', 61, '2020-01-31', 302, NULL),
('Hampton Inn', 61, '2020-02-01', 287, NULL),
('Hampton Inn', 61, '2020-02-02', 383, NULL),
('Hampton Inn', 61, '2020-02-03', 386, NULL),
('Hampton Inn', 61, '2020-02-04', 217, NULL),
('Hampton Inn', 66, '2019-01-01', 194, NULL),
('Hampton Inn', 66, '2019-01-02', 365, NULL),
('Hampton Inn', 66, '2019-01-03', 284, NULL),
('Hampton Inn', 66, '2019-01-04', 243, NULL),
('Hampton Inn', 66, '2019-01-05', 190, NULL),
('Hampton Inn', 66, '2019-01-06', 309, NULL),
('Hampton Inn', 66, '2019-01-07', 287, NULL),
('Hampton Inn', 66, '2019-01-08', 159, NULL),
('Hampton Inn', 66, '2019-01-09', 220, NULL),
('Hampton Inn', 66, '2019-01-10', 220, NULL),
('Hampton Inn', 66, '2019-01-11', 326, NULL),
('Hampton Inn', 66, '2019-01-12', 288, NULL),
('Hampton Inn', 66, '2019-01-13', 353, NULL),
('Hampton Inn', 66, '2019-01-14', 102, NULL),
('Hampton Inn', 66, '2019-01-15', 175, NULL),
('Hampton Inn', 66, '2019-01-16', 257, NULL),
('Hampton Inn', 66, '2019-01-17', 175, NULL),
('Hampton Inn', 66, '2019-01-18', 211, NULL),
('Hampton Inn', 66, '2019-01-19', 183, NULL),
('Hampton Inn', 66, '2019-01-20', 173, NULL),
('Hampton Inn', 66, '2019-01-21', 122, NULL),
('Hampton Inn', 66, '2019-01-22', 309, NULL),
('Hampton Inn', 66, '2019-01-23', 344, NULL),
('Hampton Inn', 66, '2019-01-24', 134, NULL),
('Hampton Inn', 66, '2019-01-25', 248, NULL),
('Hampton Inn', 66, '2019-01-26', 141, NULL),
('Hampton Inn', 66, '2019-01-27', 225, NULL),
('Hampton Inn', 66, '2019-01-28', 257, NULL),
('Hampton Inn', 66, '2019-01-29', 390, NULL),
('Hampton Inn', 66, '2019-01-30', 214, NULL),
('Hampton Inn', 66, '2019-01-31', 239, NULL),
('Hampton Inn', 66, '2019-02-01', 243, NULL),
('Hampton Inn', 66, '2019-02-02', 180, NULL),
('Hampton Inn', 66, '2019-02-03', 166, NULL),
('Hampton Inn', 66, '2019-02-04', 328, NULL),
('Hampton Inn', 66, '2019-02-05', 146, NULL),
('Hampton Inn', 66, '2019-02-06', 287, NULL),
('Hampton Inn', 66, '2019-02-07', 194, NULL),
('Hampton Inn', 66, '2019-02-08', 375, NULL),
('Hampton Inn', 66, '2019-02-09', 316, NULL),
('Hampton Inn', 66, '2019-02-10', 244, NULL),
('Hampton Inn', 66, '2019-02-11', 116, NULL),
('Hampton Inn', 66, '2019-02-12', 213, NULL),
('Hampton Inn', 66, '2019-02-13', 239, NULL),
('Hampton Inn', 66, '2019-02-14', 180, NULL),
('Hampton Inn', 66, '2019-02-15', 181, NULL),
('Hampton Inn', 66, '2019-02-16', 146, NULL),
('Hampton Inn', 66, '2019-02-17', 266, NULL),
('Hampton Inn', 66, '2019-02-18', 172, NULL),
('Hampton Inn', 66, '2019-02-19', 383, NULL),
('Hampton Inn', 66, '2019-02-20', 373, NULL),
('Hampton Inn', 66, '2019-02-21', 257, NULL),
('Hampton Inn', 66, '2019-02-22', 229, NULL),
('Hampton Inn', 66, '2019-02-23', 280, NULL),
('Hampton Inn', 66, '2019-02-24', 298, NULL),
('Hampton Inn', 66, '2019-02-25', 111, NULL),
('Hampton Inn', 66, '2019-02-26', 364, NULL),
('Hampton Inn', 66, '2019-02-27', 124, NULL),
('Hampton Inn', 66, '2019-02-28', 385, NULL),
('Hampton Inn', 66, '2019-03-01', 399, NULL),
('Hampton Inn', 66, '2019-03-02', 124, NULL),
('Hampton Inn', 66, '2019-03-03', 144, NULL),
('Hampton Inn', 66, '2019-03-04', 134, NULL),
('Hampton Inn', 66, '2019-03-05', 284, NULL),
('Hampton Inn', 66, '2019-03-06', 151, NULL),
('Hampton Inn', 66, '2019-03-07', 223, NULL),
('Hampton Inn', 66, '2019-03-08', 306, NULL),
('Hampton Inn', 66, '2019-03-09', 280, NULL),
('Hampton Inn', 66, '2019-03-10', 163, NULL),
('Hampton Inn', 66, '2019-03-11', 395, NULL),
('Hampton Inn', 66, '2019-03-12', 185, NULL),
('Hampton Inn', 66, '2019-03-13', 205, NULL),
('Hampton Inn', 66, '2019-03-14', 230, NULL),
('Hampton Inn', 66, '2019-03-15', 231, NULL),
('Hampton Inn', 66, '2019-03-16', 164, NULL),
('Hampton Inn', 66, '2019-03-17', 245, NULL),
('Hampton Inn', 66, '2019-03-18', 333, NULL),
('Hampton Inn', 66, '2019-03-19', 391, NULL),
('Hampton Inn', 66, '2019-03-20', 304, NULL),
('Hampton Inn', 66, '2019-03-21', 377, NULL),
('Hampton Inn', 66, '2019-03-22', 222, NULL),
('Hampton Inn', 66, '2019-03-23', 335, NULL),
('Hampton Inn', 66, '2019-03-24', 101, NULL),
('Hampton Inn', 66, '2019-03-25', 350, NULL),
('Hampton Inn', 66, '2019-03-26', 252, NULL),
('Hampton Inn', 66, '2019-03-27', 267, NULL),
('Hampton Inn', 66, '2019-03-28', 343, NULL),
('Hampton Inn', 66, '2019-03-29', 220, NULL),
('Hampton Inn', 66, '2019-03-30', 112, NULL),
('Hampton Inn', 66, '2019-03-31', 199, NULL),
('Hampton Inn', 66, '2019-04-01', 365, NULL),
('Hampton Inn', 66, '2019-04-02', 322, NULL),
('Hampton Inn', 66, '2019-04-03', 198, NULL),
('Hampton Inn', 66, '2019-04-04', 115, NULL),
('Hampton Inn', 66, '2019-04-05', 189, NULL),
('Hampton Inn', 66, '2019-04-06', 399, NULL),
('Hampton Inn', 66, '2019-04-07', 353, NULL),
('Hampton Inn', 66, '2019-04-08', 396, NULL),
('Hampton Inn', 66, '2019-04-09', 376, NULL),
('Hampton Inn', 66, '2019-04-10', 226, NULL),
('Hampton Inn', 66, '2019-04-11', 116, NULL),
('Hampton Inn', 66, '2019-04-12', 144, NULL),
('Hampton Inn', 66, '2019-04-13', 225, NULL),
('Hampton Inn', 66, '2019-04-14', 279, NULL),
('Hampton Inn', 66, '2019-04-15', 315, NULL),
('Hampton Inn', 66, '2019-04-16', 329, NULL),
('Hampton Inn', 66, '2019-04-17', 367, NULL),
('Hampton Inn', 66, '2019-04-18', 202, NULL),
('Hampton Inn', 66, '2019-04-19', 248, NULL),
('Hampton Inn', 66, '2019-04-20', 378, NULL),
('Hampton Inn', 66, '2019-04-21', 169, NULL),
('Hampton Inn', 66, '2019-04-22', 159, NULL),
('Hampton Inn', 66, '2019-04-23', 274, NULL),
('Hampton Inn', 66, '2019-04-24', 110, NULL),
('Hampton Inn', 66, '2019-04-25', 216, NULL),
('Hampton Inn', 66, '2019-04-26', 142, NULL),
('Hampton Inn', 66, '2019-04-27', 284, NULL),
('Hampton Inn', 66, '2019-04-28', 173, NULL),
('Hampton Inn', 66, '2019-04-29', 260, NULL),
('Hampton Inn', 66, '2019-04-30', 294, NULL),
('Hampton Inn', 66, '2019-05-01', 369, NULL),
('Hampton Inn', 66, '2019-05-02', 377, NULL),
('Hampton Inn', 66, '2019-05-03', 136, NULL),
('Hampton Inn', 66, '2019-05-04', 337, NULL),
('Hampton Inn', 66, '2019-05-05', 154, NULL),
('Hampton Inn', 66, '2019-05-06', 252, NULL),
('Hampton Inn', 66, '2019-05-07', 371, NULL),
('Hampton Inn', 66, '2019-05-08', 249, NULL),
('Hampton Inn', 66, '2019-05-09', 152, NULL),
('Hampton Inn', 66, '2019-05-10', 390, NULL),
('Hampton Inn', 66, '2019-05-11', 116, NULL),
('Hampton Inn', 66, '2019-05-12', 312, NULL),
('Hampton Inn', 66, '2019-05-13', 377, NULL),
('Hampton Inn', 66, '2019-05-14', 314, NULL),
('Hampton Inn', 66, '2019-05-15', 215, NULL),
('Hampton Inn', 66, '2019-05-16', 123, NULL),
('Hampton Inn', 66, '2019-05-17', 104, NULL),
('Hampton Inn', 66, '2019-05-18', 342, NULL),
('Hampton Inn', 66, '2019-05-19', 199, NULL),
('Hampton Inn', 66, '2019-05-20', 251, NULL),
('Hampton Inn', 66, '2019-05-21', 333, NULL),
('Hampton Inn', 66, '2019-05-22', 214, NULL),
('Hampton Inn', 66, '2019-05-23', 363, NULL),
('Hampton Inn', 66, '2019-05-24', 352, NULL),
('Hampton Inn', 66, '2019-05-25', 212, NULL),
('Hampton Inn', 66, '2019-05-26', 203, NULL),
('Hampton Inn', 66, '2019-05-27', 360, NULL),
('Hampton Inn', 66, '2019-05-28', 337, NULL),
('Hampton Inn', 66, '2019-05-29', 381, NULL),
('Hampton Inn', 66, '2019-05-30', 368, NULL),
('Hampton Inn', 66, '2019-05-31', 201, NULL),
('Hampton Inn', 66, '2019-06-01', 310, NULL),
('Hampton Inn', 66, '2019-06-02', 253, NULL),
('Hampton Inn', 66, '2019-06-03', 375, NULL),
('Hampton Inn', 66, '2019-06-04', 309, NULL),
('Hampton Inn', 66, '2019-06-05', 318, NULL),
('Hampton Inn', 66, '2019-06-06', 329, NULL),
('Hampton Inn', 66, '2019-06-07', 224, NULL),
('Hampton Inn', 66, '2019-06-08', 129, NULL),
('Hampton Inn', 66, '2019-06-09', 298, NULL),
('Hampton Inn', 66, '2019-06-10', 151, NULL),
('Hampton Inn', 66, '2019-06-11', 394, NULL),
('Hampton Inn', 66, '2019-06-12', 223, NULL),
('Hampton Inn', 66, '2019-06-13', 371, NULL),
('Hampton Inn', 66, '2019-06-14', 105, NULL),
('Hampton Inn', 66, '2019-06-15', 395, NULL),
('Hampton Inn', 66, '2019-06-16', 340, NULL),
('Hampton Inn', 66, '2019-06-17', 365, NULL),
('Hampton Inn', 66, '2019-06-18', 100, NULL),
('Hampton Inn', 66, '2019-06-19', 238, NULL),
('Hampton Inn', 66, '2019-06-20', 146, NULL),
('Hampton Inn', 66, '2019-06-21', 142, NULL),
('Hampton Inn', 66, '2019-06-22', 306, NULL),
('Hampton Inn', 66, '2019-06-23', 231, NULL),
('Hampton Inn', 66, '2019-06-24', 321, NULL),
('Hampton Inn', 66, '2019-06-25', 359, NULL),
('Hampton Inn', 66, '2019-06-26', 236, NULL),
('Hampton Inn', 66, '2019-06-27', 145, NULL),
('Hampton Inn', 66, '2019-06-28', 231, NULL),
('Hampton Inn', 66, '2019-06-29', 374, NULL),
('Hampton Inn', 66, '2019-06-30', 314, NULL),
('Hampton Inn', 66, '2019-07-01', 262, NULL),
('Hampton Inn', 66, '2019-07-02', 151, NULL),
('Hampton Inn', 66, '2019-07-03', 385, NULL),
('Hampton Inn', 66, '2019-07-04', 369, NULL),
('Hampton Inn', 66, '2019-07-05', 275, NULL),
('Hampton Inn', 66, '2019-07-06', 154, NULL),
('Hampton Inn', 66, '2019-07-07', 228, NULL),
('Hampton Inn', 66, '2019-07-08', 386, NULL),
('Hampton Inn', 66, '2019-07-09', 373, NULL),
('Hampton Inn', 66, '2019-07-10', 208, NULL),
('Hampton Inn', 66, '2019-07-11', 222, NULL),
('Hampton Inn', 66, '2019-07-12', 167, NULL),
('Hampton Inn', 66, '2019-07-13', 313, NULL),
('Hampton Inn', 66, '2019-07-14', 194, NULL),
('Hampton Inn', 66, '2019-07-15', 131, NULL),
('Hampton Inn', 66, '2019-07-16', 377, NULL),
('Hampton Inn', 66, '2019-07-17', 361, NULL),
('Hampton Inn', 66, '2019-07-18', 139, NULL),
('Hampton Inn', 66, '2019-07-19', 377, NULL),
('Hampton Inn', 66, '2019-07-20', 151, NULL),
('Hampton Inn', 66, '2019-07-21', 194, NULL),
('Hampton Inn', 66, '2019-07-22', 273, NULL),
('Hampton Inn', 66, '2019-07-23', 234, NULL),
('Hampton Inn', 66, '2019-07-24', 228, NULL),
('Hampton Inn', 66, '2019-07-25', 281, NULL),
('Hampton Inn', 66, '2019-07-26', 191, NULL),
('Hampton Inn', 66, '2019-07-27', 396, NULL),
('Hampton Inn', 66, '2019-07-28', 113, NULL),
('Hampton Inn', 66, '2019-07-29', 318, NULL),
('Hampton Inn', 66, '2019-07-30', 124, NULL),
('Hampton Inn', 66, '2019-07-31', 221, NULL),
('Hampton Inn', 66, '2019-08-01', 160, NULL),
('Hampton Inn', 66, '2019-08-02', 271, NULL),
('Hampton Inn', 66, '2019-08-03', 335, NULL),
('Hampton Inn', 66, '2019-08-04', 135, NULL),
('Hampton Inn', 66, '2019-08-05', 371, NULL),
('Hampton Inn', 66, '2019-08-06', 120, NULL),
('Hampton Inn', 66, '2019-08-07', 146, NULL),
('Hampton Inn', 66, '2019-08-08', 229, NULL),
('Hampton Inn', 66, '2019-08-09', 386, NULL),
('Hampton Inn', 66, '2019-08-10', 293, NULL),
('Hampton Inn', 66, '2019-08-11', 349, NULL),
('Hampton Inn', 66, '2019-08-12', 366, NULL),
('Hampton Inn', 66, '2019-08-13', 129, NULL),
('Hampton Inn', 66, '2019-08-14', 146, NULL),
('Hampton Inn', 66, '2019-08-15', 208, NULL),
('Hampton Inn', 66, '2019-08-16', 386, NULL),
('Hampton Inn', 66, '2019-08-17', 209, NULL),
('Hampton Inn', 66, '2019-08-18', 278, NULL),
('Hampton Inn', 66, '2019-08-19', 143, NULL),
('Hampton Inn', 66, '2019-08-20', 207, NULL),
('Hampton Inn', 66, '2019-08-21', 124, NULL),
('Hampton Inn', 66, '2019-08-22', 371, NULL),
('Hampton Inn', 66, '2019-08-23', 194, NULL),
('Hampton Inn', 66, '2019-08-24', 102, NULL),
('Hampton Inn', 66, '2019-08-25', 321, NULL),
('Hampton Inn', 66, '2019-08-26', 111, NULL),
('Hampton Inn', 66, '2019-08-27', 124, NULL),
('Hampton Inn', 66, '2019-08-28', 266, NULL),
('Hampton Inn', 66, '2019-08-29', 232, NULL),
('Hampton Inn', 66, '2019-08-30', 286, NULL),
('Hampton Inn', 66, '2019-08-31', 236, NULL),
('Hampton Inn', 66, '2019-09-01', 107, NULL),
('Hampton Inn', 66, '2019-09-02', 381, NULL),
('Hampton Inn', 66, '2019-09-03', 339, NULL),
('Hampton Inn', 66, '2019-09-04', 138, NULL),
('Hampton Inn', 66, '2019-09-05', 369, NULL),
('Hampton Inn', 66, '2019-09-06', 175, NULL),
('Hampton Inn', 66, '2019-09-07', 206, NULL),
('Hampton Inn', 66, '2019-09-08', 196, NULL),
('Hampton Inn', 66, '2019-09-09', 305, NULL),
('Hampton Inn', 66, '2019-09-10', 343, NULL),
('Hampton Inn', 66, '2019-09-11', 117, NULL),
('Hampton Inn', 66, '2019-09-12', 352, NULL),
('Hampton Inn', 66, '2019-09-13', 271, NULL),
('Hampton Inn', 66, '2019-09-14', 198, NULL),
('Hampton Inn', 66, '2019-09-15', 256, NULL),
('Hampton Inn', 66, '2019-09-16', 165, NULL),
('Hampton Inn', 66, '2019-09-17', 329, NULL),
('Hampton Inn', 66, '2019-09-18', 140, NULL),
('Hampton Inn', 66, '2019-09-19', 353, NULL),
('Hampton Inn', 66, '2019-09-20', 337, NULL),
('Hampton Inn', 66, '2019-09-21', 285, NULL),
('Hampton Inn', 66, '2019-09-22', 271, NULL),
('Hampton Inn', 66, '2019-09-23', 265, NULL),
('Hampton Inn', 66, '2019-09-24', 254, NULL),
('Hampton Inn', 66, '2019-09-25', 137, NULL),
('Hampton Inn', 66, '2019-09-26', 175, NULL),
('Hampton Inn', 66, '2019-09-27', 373, NULL),
('Hampton Inn', 66, '2019-09-28', 171, NULL),
('Hampton Inn', 66, '2019-09-29', 291, NULL),
('Hampton Inn', 66, '2019-09-30', 105, NULL),
('Hampton Inn', 66, '2019-10-01', 168, NULL),
('Hampton Inn', 66, '2019-10-02', 211, NULL),
('Hampton Inn', 66, '2019-10-03', 126, NULL),
('Hampton Inn', 66, '2019-10-04', 393, NULL),
('Hampton Inn', 66, '2019-10-05', 171, NULL),
('Hampton Inn', 66, '2019-10-06', 371, NULL),
('Hampton Inn', 66, '2019-10-07', 220, NULL),
('Hampton Inn', 66, '2019-10-08', 190, NULL),
('Hampton Inn', 66, '2019-10-09', 209, NULL),
('Hampton Inn', 66, '2019-10-10', 334, NULL),
('Hampton Inn', 66, '2019-10-11', 200, NULL),
('Hampton Inn', 66, '2019-10-12', 367, NULL),
('Hampton Inn', 66, '2019-10-13', 114, NULL),
('Hampton Inn', 66, '2019-10-14', 339, NULL),
('Hampton Inn', 66, '2019-10-15', 364, NULL),
('Hampton Inn', 66, '2019-10-16', 152, NULL),
('Hampton Inn', 66, '2019-10-17', 207, NULL),
('Hampton Inn', 66, '2019-10-18', 371, NULL),
('Hampton Inn', 66, '2019-10-19', 317, NULL),
('Hampton Inn', 66, '2019-10-20', 174, NULL),
('Hampton Inn', 66, '2019-10-21', 107, NULL),
('Hampton Inn', 66, '2019-10-22', 362, NULL),
('Hampton Inn', 66, '2019-10-23', 329, NULL),
('Hampton Inn', 66, '2019-10-24', 307, NULL),
('Hampton Inn', 66, '2019-10-25', 263, NULL),
('Hampton Inn', 66, '2019-10-26', 260, NULL),
('Hampton Inn', 66, '2019-10-27', 151, NULL),
('Hampton Inn', 66, '2019-10-28', 367, NULL),
('Hampton Inn', 66, '2019-10-29', 395, NULL),
('Hampton Inn', 66, '2019-10-30', 237, NULL),
('Hampton Inn', 66, '2019-10-31', 118, NULL),
('Hampton Inn', 66, '2019-11-01', 380, NULL),
('Hampton Inn', 66, '2019-11-02', 353, NULL),
('Hampton Inn', 66, '2019-11-03', 370, NULL),
('Hampton Inn', 66, '2019-11-04', 350, NULL),
('Hampton Inn', 66, '2019-11-05', 194, NULL),
('Hampton Inn', 66, '2019-11-06', 315, NULL),
('Hampton Inn', 66, '2019-11-07', 286, NULL),
('Hampton Inn', 66, '2019-11-08', 312, NULL),
('Hampton Inn', 66, '2019-11-09', 320, NULL),
('Hampton Inn', 66, '2019-11-10', 282, NULL),
('Hampton Inn', 66, '2019-11-11', 233, NULL),
('Hampton Inn', 66, '2019-11-12', 326, NULL),
('Hampton Inn', 66, '2019-11-13', 329, NULL),
('Hampton Inn', 66, '2019-11-14', 377, NULL),
('Hampton Inn', 66, '2019-11-15', 297, NULL),
('Hampton Inn', 66, '2019-11-16', 175, NULL),
('Hampton Inn', 66, '2019-11-17', 284, NULL),
('Hampton Inn', 66, '2019-11-18', 319, NULL),
('Hampton Inn', 66, '2019-11-19', 324, NULL),
('Hampton Inn', 66, '2019-11-20', 377, NULL),
('Hampton Inn', 66, '2019-11-21', 261, NULL),
('Hampton Inn', 66, '2019-11-22', 299, NULL),
('Hampton Inn', 66, '2019-11-23', 369, NULL),
('Hampton Inn', 66, '2019-11-24', 204, NULL),
('Hampton Inn', 66, '2019-11-25', 121, NULL),
('Hampton Inn', 66, '2019-11-26', 250, NULL),
('Hampton Inn', 66, '2019-11-27', 112, NULL),
('Hampton Inn', 66, '2019-11-28', 298, NULL),
('Hampton Inn', 66, '2019-11-29', 138, NULL),
('Hampton Inn', 66, '2019-11-30', 331, NULL),
('Hampton Inn', 66, '2019-12-01', 264, NULL),
('Hampton Inn', 66, '2019-12-02', 158, NULL),
('Hampton Inn', 66, '2019-12-03', 396, NULL),
('Hampton Inn', 66, '2019-12-04', 169, NULL),
('Hampton Inn', 66, '2019-12-05', 389, NULL),
('Hampton Inn', 66, '2019-12-06', 268, NULL),
('Hampton Inn', 66, '2019-12-07', 211, NULL),
('Hampton Inn', 66, '2019-12-08', 340, NULL),
('Hampton Inn', 66, '2019-12-09', 171, NULL),
('Hampton Inn', 66, '2019-12-10', 296, NULL),
('Hampton Inn', 66, '2019-12-11', 129, NULL),
('Hampton Inn', 66, '2019-12-12', 155, NULL),
('Hampton Inn', 66, '2019-12-13', 173, NULL),
('Hampton Inn', 66, '2019-12-14', 244, NULL),
('Hampton Inn', 66, '2019-12-15', 148, NULL),
('Hampton Inn', 66, '2019-12-16', 167, NULL),
('Hampton Inn', 66, '2019-12-17', 189, NULL),
('Hampton Inn', 66, '2019-12-18', 132, NULL),
('Hampton Inn', 66, '2019-12-19', 144, NULL),
('Hampton Inn', 66, '2019-12-20', 218, NULL),
('Hampton Inn', 66, '2019-12-21', 173, NULL),
('Hampton Inn', 66, '2019-12-22', 106, NULL),
('Hampton Inn', 66, '2019-12-23', 214, NULL),
('Hampton Inn', 66, '2019-12-24', 258, NULL),
('Hampton Inn', 66, '2019-12-25', 271, NULL),
('Hampton Inn', 66, '2019-12-26', 283, NULL),
('Hampton Inn', 66, '2019-12-27', 334, NULL),
('Hampton Inn', 66, '2019-12-28', 201, NULL),
('Hampton Inn', 66, '2019-12-29', 172, NULL),
('Hampton Inn', 66, '2019-12-30', 316, NULL),
('Hampton Inn', 66, '2019-12-31', 213, NULL),
('Hampton Inn', 66, '2020-01-01', 230, NULL),
('Hampton Inn', 66, '2020-01-02', 199, NULL),
('Hampton Inn', 66, '2020-01-03', 381, NULL),
('Hampton Inn', 66, '2020-01-04', 242, NULL),
('Hampton Inn', 66, '2020-01-05', 282, NULL),
('Hampton Inn', 66, '2020-01-06', 238, NULL),
('Hampton Inn', 66, '2020-01-07', 363, NULL),
('Hampton Inn', 66, '2020-01-08', 340, NULL),
('Hampton Inn', 66, '2020-01-09', 227, NULL),
('Hampton Inn', 66, '2020-01-10', 305, NULL),
('Hampton Inn', 66, '2020-01-11', 362, NULL),
('Hampton Inn', 66, '2020-01-12', 128, NULL),
('Hampton Inn', 66, '2020-01-13', 229, NULL),
('Hampton Inn', 66, '2020-01-14', 153, NULL),
('Hampton Inn', 66, '2020-01-15', 156, NULL),
('Hampton Inn', 66, '2020-01-16', 123, NULL),
('Hampton Inn', 66, '2020-01-17', 378, NULL),
('Hampton Inn', 66, '2020-01-18', 340, NULL),
('Hampton Inn', 66, '2020-01-19', 188, NULL),
('Hampton Inn', 66, '2020-01-20', 327, NULL),
('Hampton Inn', 66, '2020-01-21', 138, NULL),
('Hampton Inn', 66, '2020-01-22', 244, NULL),
('Hampton Inn', 66, '2020-01-23', 100, NULL),
('Hampton Inn', 66, '2020-01-24', 291, NULL),
('Hampton Inn', 66, '2020-01-25', 195, NULL),
('Hampton Inn', 66, '2020-01-26', 162, NULL),
('Hampton Inn', 66, '2020-01-27', 252, NULL),
('Hampton Inn', 66, '2020-01-28', 310, NULL),
('Hampton Inn', 66, '2020-01-29', 333, NULL),
('Hampton Inn', 66, '2020-01-30', 131, NULL),
('Hampton Inn', 66, '2020-01-31', 144, NULL),
('Hampton Inn', 66, '2020-02-01', 137, NULL),
('Hampton Inn', 66, '2020-02-02', 123, NULL),
('Hampton Inn', 66, '2020-02-03', 372, NULL),
('Hampton Inn', 66, '2020-02-04', 110, NULL),
('Hampton Inn', 68, '2019-01-01', 169, NULL),
('Hampton Inn', 68, '2019-01-02', 268, NULL),
('Hampton Inn', 68, '2019-01-03', 292, NULL),
('Hampton Inn', 68, '2019-01-04', 355, NULL),
('Hampton Inn', 68, '2019-01-05', 124, NULL),
('Hampton Inn', 68, '2019-01-06', 140, NULL),
('Hampton Inn', 68, '2019-01-07', 145, NULL),
('Hampton Inn', 68, '2019-01-08', 392, NULL),
('Hampton Inn', 68, '2019-01-09', 315, NULL),
('Hampton Inn', 68, '2019-01-10', 136, NULL),
('Hampton Inn', 68, '2019-01-11', 258, NULL),
('Hampton Inn', 68, '2019-01-12', 149, NULL),
('Hampton Inn', 68, '2019-01-13', 114, NULL),
('Hampton Inn', 68, '2019-01-14', 185, NULL),
('Hampton Inn', 68, '2019-01-15', 327, NULL),
('Hampton Inn', 68, '2019-01-16', 367, NULL),
('Hampton Inn', 68, '2019-01-17', 302, NULL),
('Hampton Inn', 68, '2019-01-18', 157, NULL),
('Hampton Inn', 68, '2019-01-19', 328, NULL),
('Hampton Inn', 68, '2019-01-20', 295, NULL),
('Hampton Inn', 68, '2019-01-21', 274, NULL),
('Hampton Inn', 68, '2019-01-22', 356, NULL),
('Hampton Inn', 68, '2019-01-23', 154, NULL),
('Hampton Inn', 68, '2019-01-24', 214, NULL),
('Hampton Inn', 68, '2019-01-25', 351, NULL),
('Hampton Inn', 68, '2019-01-26', 252, NULL),
('Hampton Inn', 68, '2019-01-27', 338, NULL),
('Hampton Inn', 68, '2019-01-28', 316, NULL),
('Hampton Inn', 68, '2019-01-29', 172, NULL),
('Hampton Inn', 68, '2019-01-30', 148, NULL),
('Hampton Inn', 68, '2019-01-31', 313, NULL),
('Hampton Inn', 68, '2019-02-01', 263, NULL),
('Hampton Inn', 68, '2019-02-02', 373, NULL),
('Hampton Inn', 68, '2019-02-03', 354, NULL),
('Hampton Inn', 68, '2019-02-04', 349, NULL),
('Hampton Inn', 68, '2019-02-05', 137, NULL),
('Hampton Inn', 68, '2019-02-06', 261, NULL),
('Hampton Inn', 68, '2019-02-07', 322, NULL),
('Hampton Inn', 68, '2019-02-08', 368, NULL),
('Hampton Inn', 68, '2019-02-09', 241, NULL),
('Hampton Inn', 68, '2019-02-10', 205, NULL),
('Hampton Inn', 68, '2019-02-11', 261, NULL),
('Hampton Inn', 68, '2019-02-12', 284, NULL),
('Hampton Inn', 68, '2019-02-13', 263, NULL),
('Hampton Inn', 68, '2019-02-14', 204, NULL),
('Hampton Inn', 68, '2019-02-15', 311, NULL),
('Hampton Inn', 68, '2019-02-16', 202, NULL),
('Hampton Inn', 68, '2019-02-17', 276, NULL),
('Hampton Inn', 68, '2019-02-18', 209, NULL),
('Hampton Inn', 68, '2019-02-19', 177, NULL),
('Hampton Inn', 68, '2019-02-20', 196, NULL),
('Hampton Inn', 68, '2019-02-21', 227, NULL),
('Hampton Inn', 68, '2019-02-22', 201, NULL),
('Hampton Inn', 68, '2019-02-23', 176, NULL),
('Hampton Inn', 68, '2019-02-24', 301, NULL),
('Hampton Inn', 68, '2019-02-25', 202, NULL),
('Hampton Inn', 68, '2019-02-26', 344, NULL),
('Hampton Inn', 68, '2019-02-27', 391, NULL),
('Hampton Inn', 68, '2019-02-28', 324, NULL),
('Hampton Inn', 68, '2019-03-01', 214, NULL),
('Hampton Inn', 68, '2019-03-02', 347, NULL),
('Hampton Inn', 68, '2019-03-03', 219, NULL),
('Hampton Inn', 68, '2019-03-04', 207, NULL),
('Hampton Inn', 68, '2019-03-05', 392, NULL),
('Hampton Inn', 68, '2019-03-06', 157, NULL),
('Hampton Inn', 68, '2019-03-07', 383, NULL),
('Hampton Inn', 68, '2019-03-08', 380, NULL),
('Hampton Inn', 68, '2019-03-09', 232, NULL),
('Hampton Inn', 68, '2019-03-10', 314, NULL),
('Hampton Inn', 68, '2019-03-11', 304, NULL),
('Hampton Inn', 68, '2019-03-12', 356, NULL),
('Hampton Inn', 68, '2019-03-13', 301, NULL),
('Hampton Inn', 68, '2019-03-14', 204, NULL),
('Hampton Inn', 68, '2019-03-15', 182, NULL),
('Hampton Inn', 68, '2019-03-16', 113, NULL),
('Hampton Inn', 68, '2019-03-17', 368, NULL),
('Hampton Inn', 68, '2019-03-18', 398, NULL),
('Hampton Inn', 68, '2019-03-19', 279, NULL),
('Hampton Inn', 68, '2019-03-20', 253, NULL),
('Hampton Inn', 68, '2019-03-21', 183, NULL),
('Hampton Inn', 68, '2019-03-22', 264, NULL),
('Hampton Inn', 68, '2019-03-23', 375, NULL),
('Hampton Inn', 68, '2019-03-24', 104, NULL),
('Hampton Inn', 68, '2019-03-25', 319, NULL),
('Hampton Inn', 68, '2019-03-26', 339, NULL),
('Hampton Inn', 68, '2019-03-27', 383, NULL),
('Hampton Inn', 68, '2019-03-28', 310, NULL),
('Hampton Inn', 68, '2019-03-29', 188, NULL),
('Hampton Inn', 68, '2019-03-30', 311, NULL),
('Hampton Inn', 68, '2019-03-31', 157, NULL),
('Hampton Inn', 68, '2019-04-01', 342, NULL),
('Hampton Inn', 68, '2019-04-02', 167, NULL),
('Hampton Inn', 68, '2019-04-03', 380, NULL),
('Hampton Inn', 68, '2019-04-04', 391, NULL),
('Hampton Inn', 68, '2019-04-05', 250, NULL),
('Hampton Inn', 68, '2019-04-06', 219, NULL),
('Hampton Inn', 68, '2019-04-07', 233, NULL),
('Hampton Inn', 68, '2019-04-08', 394, NULL),
('Hampton Inn', 68, '2019-04-09', 173, NULL),
('Hampton Inn', 68, '2019-04-10', 131, NULL),
('Hampton Inn', 68, '2019-04-11', 281, NULL),
('Hampton Inn', 68, '2019-04-12', 374, NULL),
('Hampton Inn', 68, '2019-04-13', 319, NULL),
('Hampton Inn', 68, '2019-04-14', 240, NULL),
('Hampton Inn', 68, '2019-04-15', 101, NULL),
('Hampton Inn', 68, '2019-04-16', 185, NULL),
('Hampton Inn', 68, '2019-04-17', 227, NULL),
('Hampton Inn', 68, '2019-04-18', 325, NULL),
('Hampton Inn', 68, '2019-04-19', 306, NULL),
('Hampton Inn', 68, '2019-04-20', 387, NULL),
('Hampton Inn', 68, '2019-04-21', 190, NULL),
('Hampton Inn', 68, '2019-04-22', 385, NULL),
('Hampton Inn', 68, '2019-04-23', 126, NULL),
('Hampton Inn', 68, '2019-04-24', 187, NULL),
('Hampton Inn', 68, '2019-04-25', 106, NULL),
('Hampton Inn', 68, '2019-04-26', 258, NULL),
('Hampton Inn', 68, '2019-04-27', 323, NULL),
('Hampton Inn', 68, '2019-04-28', 222, NULL),
('Hampton Inn', 68, '2019-04-29', 235, NULL),
('Hampton Inn', 68, '2019-04-30', 224, NULL),
('Hampton Inn', 68, '2019-05-01', 244, NULL),
('Hampton Inn', 68, '2019-05-02', 345, NULL),
('Hampton Inn', 68, '2019-05-03', 153, NULL),
('Hampton Inn', 68, '2019-05-04', 281, NULL),
('Hampton Inn', 68, '2019-05-05', 319, NULL),
('Hampton Inn', 68, '2019-05-06', 280, NULL),
('Hampton Inn', 68, '2019-05-07', 173, NULL),
('Hampton Inn', 68, '2019-05-08', 273, NULL),
('Hampton Inn', 68, '2019-05-09', 143, NULL),
('Hampton Inn', 68, '2019-05-10', 148, NULL),
('Hampton Inn', 68, '2019-05-11', 299, NULL),
('Hampton Inn', 68, '2019-05-12', 264, NULL),
('Hampton Inn', 68, '2019-05-13', 250, NULL),
('Hampton Inn', 68, '2019-05-14', 141, NULL),
('Hampton Inn', 68, '2019-05-15', 201, NULL),
('Hampton Inn', 68, '2019-05-16', 334, NULL),
('Hampton Inn', 68, '2019-05-17', 203, NULL),
('Hampton Inn', 68, '2019-05-18', 137, NULL),
('Hampton Inn', 68, '2019-05-19', 245, NULL),
('Hampton Inn', 68, '2019-05-20', 179, NULL),
('Hampton Inn', 68, '2019-05-21', 246, NULL),
('Hampton Inn', 68, '2019-05-22', 244, NULL),
('Hampton Inn', 68, '2019-05-23', 342, NULL),
('Hampton Inn', 68, '2019-05-24', 377, NULL),
('Hampton Inn', 68, '2019-05-25', 212, NULL),
('Hampton Inn', 68, '2019-05-26', 205, NULL),
('Hampton Inn', 68, '2019-05-27', 303, NULL),
('Hampton Inn', 68, '2019-05-28', 222, NULL),
('Hampton Inn', 68, '2019-05-29', 344, NULL),
('Hampton Inn', 68, '2019-05-30', 133, NULL),
('Hampton Inn', 68, '2019-05-31', 323, NULL),
('Hampton Inn', 68, '2019-06-01', 131, NULL),
('Hampton Inn', 68, '2019-06-02', 259, NULL),
('Hampton Inn', 68, '2019-06-03', 288, NULL),
('Hampton Inn', 68, '2019-06-04', 171, NULL),
('Hampton Inn', 68, '2019-06-05', 184, NULL),
('Hampton Inn', 68, '2019-06-06', 193, NULL),
('Hampton Inn', 68, '2019-06-07', 393, NULL),
('Hampton Inn', 68, '2019-06-08', 279, NULL),
('Hampton Inn', 68, '2019-06-09', 132, NULL),
('Hampton Inn', 68, '2019-06-10', 380, NULL),
('Hampton Inn', 68, '2019-06-11', 126, NULL),
('Hampton Inn', 68, '2019-06-12', 112, NULL),
('Hampton Inn', 68, '2019-06-13', 338, NULL),
('Hampton Inn', 68, '2019-06-14', 354, NULL),
('Hampton Inn', 68, '2019-06-15', 288, NULL),
('Hampton Inn', 68, '2019-06-16', 395, NULL),
('Hampton Inn', 68, '2019-06-17', 174, NULL),
('Hampton Inn', 68, '2019-06-18', 125, NULL),
('Hampton Inn', 68, '2019-06-19', 242, NULL),
('Hampton Inn', 68, '2019-06-20', 107, NULL),
('Hampton Inn', 68, '2019-06-21', 386, NULL),
('Hampton Inn', 68, '2019-06-22', 197, NULL),
('Hampton Inn', 68, '2019-06-23', 108, NULL),
('Hampton Inn', 68, '2019-06-24', 208, NULL),
('Hampton Inn', 68, '2019-06-25', 278, NULL),
('Hampton Inn', 68, '2019-06-26', 323, NULL),
('Hampton Inn', 68, '2019-06-27', 368, NULL),
('Hampton Inn', 68, '2019-06-28', 212, NULL),
('Hampton Inn', 68, '2019-06-29', 303, NULL),
('Hampton Inn', 68, '2019-06-30', 299, NULL),
('Hampton Inn', 68, '2019-07-01', 390, NULL),
('Hampton Inn', 68, '2019-07-02', 350, NULL),
('Hampton Inn', 68, '2019-07-03', 108, NULL),
('Hampton Inn', 68, '2019-07-04', 306, NULL),
('Hampton Inn', 68, '2019-07-05', 136, NULL),
('Hampton Inn', 68, '2019-07-06', 165, NULL),
('Hampton Inn', 68, '2019-07-07', 171, NULL),
('Hampton Inn', 68, '2019-07-08', 361, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 68, '2019-07-09', 145, NULL),
('Hampton Inn', 68, '2019-07-10', 258, NULL),
('Hampton Inn', 68, '2019-07-11', 103, NULL),
('Hampton Inn', 68, '2019-07-12', 254, NULL),
('Hampton Inn', 68, '2019-07-13', 185, NULL),
('Hampton Inn', 68, '2019-07-14', 117, NULL),
('Hampton Inn', 68, '2019-07-15', 295, NULL),
('Hampton Inn', 68, '2019-07-16', 119, NULL),
('Hampton Inn', 68, '2019-07-17', 341, NULL),
('Hampton Inn', 68, '2019-07-18', 166, NULL),
('Hampton Inn', 68, '2019-07-19', 280, NULL),
('Hampton Inn', 68, '2019-07-20', 258, NULL),
('Hampton Inn', 68, '2019-07-21', 143, NULL),
('Hampton Inn', 68, '2019-07-22', 398, NULL),
('Hampton Inn', 68, '2019-07-23', 343, NULL),
('Hampton Inn', 68, '2019-07-24', 279, NULL),
('Hampton Inn', 68, '2019-07-25', 357, NULL),
('Hampton Inn', 68, '2019-07-26', 176, NULL),
('Hampton Inn', 68, '2019-07-27', 163, NULL),
('Hampton Inn', 68, '2019-07-28', 349, NULL),
('Hampton Inn', 68, '2019-07-29', 243, NULL),
('Hampton Inn', 68, '2019-07-30', 107, NULL),
('Hampton Inn', 68, '2019-07-31', 105, NULL),
('Hampton Inn', 68, '2019-08-01', 197, NULL),
('Hampton Inn', 68, '2019-08-02', 151, NULL),
('Hampton Inn', 68, '2019-08-03', 204, NULL),
('Hampton Inn', 68, '2019-08-04', 340, NULL),
('Hampton Inn', 68, '2019-08-05', 212, NULL),
('Hampton Inn', 68, '2019-08-06', 140, NULL),
('Hampton Inn', 68, '2019-08-07', 162, NULL),
('Hampton Inn', 68, '2019-08-08', 262, NULL),
('Hampton Inn', 68, '2019-08-09', 233, NULL),
('Hampton Inn', 68, '2019-08-10', 342, NULL),
('Hampton Inn', 68, '2019-08-11', 144, NULL),
('Hampton Inn', 68, '2019-08-12', 231, NULL),
('Hampton Inn', 68, '2019-08-13', 351, NULL),
('Hampton Inn', 68, '2019-08-14', 176, NULL),
('Hampton Inn', 68, '2019-08-15', 351, NULL),
('Hampton Inn', 68, '2019-08-16', 188, NULL),
('Hampton Inn', 68, '2019-08-17', 151, NULL),
('Hampton Inn', 68, '2019-08-18', 391, NULL),
('Hampton Inn', 68, '2019-08-19', 394, NULL),
('Hampton Inn', 68, '2019-08-20', 374, NULL),
('Hampton Inn', 68, '2019-08-21', 203, NULL),
('Hampton Inn', 68, '2019-08-22', 274, NULL),
('Hampton Inn', 68, '2019-08-23', 125, NULL),
('Hampton Inn', 68, '2019-08-24', 216, NULL),
('Hampton Inn', 68, '2019-08-25', 294, NULL),
('Hampton Inn', 68, '2019-08-26', 117, NULL),
('Hampton Inn', 68, '2019-08-27', 258, NULL),
('Hampton Inn', 68, '2019-08-28', 151, NULL),
('Hampton Inn', 68, '2019-08-29', 158, NULL),
('Hampton Inn', 68, '2019-08-30', 102, NULL),
('Hampton Inn', 68, '2019-08-31', 370, NULL),
('Hampton Inn', 68, '2019-09-01', 202, NULL),
('Hampton Inn', 68, '2019-09-02', 288, NULL),
('Hampton Inn', 68, '2019-09-03', 276, NULL),
('Hampton Inn', 68, '2019-09-04', 161, NULL),
('Hampton Inn', 68, '2019-09-05', 185, NULL),
('Hampton Inn', 68, '2019-09-06', 127, NULL),
('Hampton Inn', 68, '2019-09-07', 192, NULL),
('Hampton Inn', 68, '2019-09-08', 312, NULL),
('Hampton Inn', 68, '2019-09-09', 246, NULL),
('Hampton Inn', 68, '2019-09-10', 207, NULL),
('Hampton Inn', 68, '2019-09-11', 352, NULL),
('Hampton Inn', 68, '2019-09-12', 383, NULL),
('Hampton Inn', 68, '2019-09-13', 201, NULL),
('Hampton Inn', 68, '2019-09-14', 138, NULL),
('Hampton Inn', 68, '2019-09-15', 100, NULL),
('Hampton Inn', 68, '2019-09-16', 244, NULL),
('Hampton Inn', 68, '2019-09-17', 368, NULL),
('Hampton Inn', 68, '2019-09-18', 191, NULL),
('Hampton Inn', 68, '2019-09-19', 363, NULL),
('Hampton Inn', 68, '2019-09-20', 290, NULL),
('Hampton Inn', 68, '2019-09-21', 268, NULL),
('Hampton Inn', 68, '2019-09-22', 259, NULL),
('Hampton Inn', 68, '2019-09-23', 398, NULL),
('Hampton Inn', 68, '2019-09-24', 195, NULL),
('Hampton Inn', 68, '2019-09-25', 357, NULL),
('Hampton Inn', 68, '2019-09-26', 150, NULL),
('Hampton Inn', 68, '2019-09-27', 150, NULL),
('Hampton Inn', 68, '2019-09-28', 325, NULL),
('Hampton Inn', 68, '2019-09-29', 239, NULL),
('Hampton Inn', 68, '2019-09-30', 149, NULL),
('Hampton Inn', 68, '2019-10-01', 399, NULL),
('Hampton Inn', 68, '2019-10-02', 194, NULL),
('Hampton Inn', 68, '2019-10-03', 323, NULL),
('Hampton Inn', 68, '2019-10-04', 323, NULL),
('Hampton Inn', 68, '2019-10-05', 275, NULL),
('Hampton Inn', 68, '2019-10-06', 220, NULL),
('Hampton Inn', 68, '2019-10-07', 317, NULL),
('Hampton Inn', 68, '2019-10-08', 303, NULL),
('Hampton Inn', 68, '2019-10-09', 392, NULL),
('Hampton Inn', 68, '2019-10-10', 284, NULL),
('Hampton Inn', 68, '2019-10-11', 178, NULL),
('Hampton Inn', 68, '2019-10-12', 261, NULL),
('Hampton Inn', 68, '2019-10-13', 297, NULL),
('Hampton Inn', 68, '2019-10-14', 255, NULL),
('Hampton Inn', 68, '2019-10-15', 160, NULL),
('Hampton Inn', 68, '2019-10-16', 316, NULL),
('Hampton Inn', 68, '2019-10-17', 131, NULL),
('Hampton Inn', 68, '2019-10-18', 108, NULL),
('Hampton Inn', 68, '2019-10-19', 207, NULL),
('Hampton Inn', 68, '2019-10-20', 148, NULL),
('Hampton Inn', 68, '2019-10-21', 328, NULL),
('Hampton Inn', 68, '2019-10-22', 351, NULL),
('Hampton Inn', 68, '2019-10-23', 150, NULL),
('Hampton Inn', 68, '2019-10-24', 115, NULL),
('Hampton Inn', 68, '2019-10-25', 134, NULL),
('Hampton Inn', 68, '2019-10-26', 314, NULL),
('Hampton Inn', 68, '2019-10-27', 334, NULL),
('Hampton Inn', 68, '2019-10-28', 249, NULL),
('Hampton Inn', 68, '2019-10-29', 143, NULL),
('Hampton Inn', 68, '2019-10-30', 381, NULL),
('Hampton Inn', 68, '2019-10-31', 360, NULL),
('Hampton Inn', 68, '2019-11-01', 169, NULL),
('Hampton Inn', 68, '2019-11-02', 354, NULL),
('Hampton Inn', 68, '2019-11-03', 282, NULL),
('Hampton Inn', 68, '2019-11-04', 183, NULL),
('Hampton Inn', 68, '2019-11-05', 365, NULL),
('Hampton Inn', 68, '2019-11-06', 108, NULL),
('Hampton Inn', 68, '2019-11-07', 120, NULL),
('Hampton Inn', 68, '2019-11-08', 115, NULL),
('Hampton Inn', 68, '2019-11-09', 203, NULL),
('Hampton Inn', 68, '2019-11-10', 259, NULL),
('Hampton Inn', 68, '2019-11-11', 381, NULL),
('Hampton Inn', 68, '2019-11-12', 335, NULL),
('Hampton Inn', 68, '2019-11-13', 229, NULL),
('Hampton Inn', 68, '2019-11-14', 291, NULL),
('Hampton Inn', 68, '2019-11-15', 180, NULL),
('Hampton Inn', 68, '2019-11-16', 188, NULL),
('Hampton Inn', 68, '2019-11-17', 370, NULL),
('Hampton Inn', 68, '2019-11-18', 204, NULL),
('Hampton Inn', 68, '2019-11-19', 136, NULL),
('Hampton Inn', 68, '2019-11-20', 317, NULL),
('Hampton Inn', 68, '2019-11-21', 391, NULL),
('Hampton Inn', 68, '2019-11-22', 316, NULL),
('Hampton Inn', 68, '2019-11-23', 120, NULL),
('Hampton Inn', 68, '2019-11-24', 259, NULL),
('Hampton Inn', 68, '2019-11-25', 113, NULL),
('Hampton Inn', 68, '2019-11-26', 369, NULL),
('Hampton Inn', 68, '2019-11-27', 314, NULL),
('Hampton Inn', 68, '2019-11-28', 287, NULL),
('Hampton Inn', 68, '2019-11-29', 186, NULL),
('Hampton Inn', 68, '2019-11-30', 374, NULL),
('Hampton Inn', 68, '2019-12-01', 171, NULL),
('Hampton Inn', 68, '2019-12-02', 168, NULL),
('Hampton Inn', 68, '2019-12-03', 143, NULL),
('Hampton Inn', 68, '2019-12-04', 146, NULL),
('Hampton Inn', 68, '2019-12-05', 328, NULL),
('Hampton Inn', 68, '2019-12-06', 185, NULL),
('Hampton Inn', 68, '2019-12-07', 136, NULL),
('Hampton Inn', 68, '2019-12-08', 258, NULL),
('Hampton Inn', 68, '2019-12-09', 167, NULL),
('Hampton Inn', 68, '2019-12-10', 260, NULL),
('Hampton Inn', 68, '2019-12-11', 171, NULL),
('Hampton Inn', 68, '2019-12-12', 268, NULL),
('Hampton Inn', 68, '2019-12-13', 389, NULL),
('Hampton Inn', 68, '2019-12-14', 340, NULL),
('Hampton Inn', 68, '2019-12-15', 322, NULL),
('Hampton Inn', 68, '2019-12-16', 114, NULL),
('Hampton Inn', 68, '2019-12-17', 227, NULL),
('Hampton Inn', 68, '2019-12-18', 151, NULL),
('Hampton Inn', 68, '2019-12-19', 183, NULL),
('Hampton Inn', 68, '2019-12-20', 375, NULL),
('Hampton Inn', 68, '2019-12-21', 138, NULL),
('Hampton Inn', 68, '2019-12-22', 182, NULL),
('Hampton Inn', 68, '2019-12-23', 225, NULL),
('Hampton Inn', 68, '2019-12-24', 225, NULL),
('Hampton Inn', 68, '2019-12-25', 152, NULL),
('Hampton Inn', 68, '2019-12-26', 234, NULL),
('Hampton Inn', 68, '2019-12-27', 124, NULL),
('Hampton Inn', 68, '2019-12-28', 384, NULL),
('Hampton Inn', 68, '2019-12-29', 141, NULL),
('Hampton Inn', 68, '2019-12-30', 237, NULL),
('Hampton Inn', 68, '2019-12-31', 385, NULL),
('Hampton Inn', 68, '2020-01-01', 137, NULL),
('Hampton Inn', 68, '2020-01-02', 148, NULL),
('Hampton Inn', 68, '2020-01-03', 328, NULL),
('Hampton Inn', 68, '2020-01-04', 336, NULL),
('Hampton Inn', 68, '2020-01-05', 354, NULL),
('Hampton Inn', 68, '2020-01-06', 186, NULL),
('Hampton Inn', 68, '2020-01-07', 342, NULL),
('Hampton Inn', 68, '2020-01-08', 105, NULL),
('Hampton Inn', 68, '2020-01-09', 156, NULL),
('Hampton Inn', 68, '2020-01-10', 226, NULL),
('Hampton Inn', 68, '2020-01-11', 314, NULL),
('Hampton Inn', 68, '2020-01-12', 153, NULL),
('Hampton Inn', 68, '2020-01-13', 367, NULL),
('Hampton Inn', 68, '2020-01-14', 339, NULL),
('Hampton Inn', 68, '2020-01-15', 101, NULL),
('Hampton Inn', 68, '2020-01-16', 213, NULL),
('Hampton Inn', 68, '2020-01-17', 299, NULL),
('Hampton Inn', 68, '2020-01-18', 116, NULL),
('Hampton Inn', 68, '2020-01-19', 176, NULL),
('Hampton Inn', 68, '2020-01-20', 392, NULL),
('Hampton Inn', 68, '2020-01-21', 154, NULL),
('Hampton Inn', 68, '2020-01-22', 236, NULL),
('Hampton Inn', 68, '2020-01-23', 319, NULL),
('Hampton Inn', 68, '2020-01-24', 268, NULL),
('Hampton Inn', 68, '2020-01-25', 221, NULL),
('Hampton Inn', 68, '2020-01-26', 153, NULL),
('Hampton Inn', 68, '2020-01-27', 348, NULL),
('Hampton Inn', 68, '2020-01-28', 258, NULL),
('Hampton Inn', 68, '2020-01-29', 168, NULL),
('Hampton Inn', 68, '2020-01-30', 165, NULL),
('Hampton Inn', 68, '2020-01-31', 317, NULL),
('Hampton Inn', 68, '2020-02-01', 326, NULL),
('Hampton Inn', 68, '2020-02-02', 269, NULL),
('Hampton Inn', 68, '2020-02-03', 301, NULL),
('Hampton Inn', 68, '2020-02-04', 101, NULL),
('Hampton Inn', 71, '2019-01-01', 162, NULL),
('Hampton Inn', 71, '2019-01-02', 143, NULL),
('Hampton Inn', 71, '2019-01-03', 209, NULL),
('Hampton Inn', 71, '2019-01-04', 348, NULL),
('Hampton Inn', 71, '2019-01-05', 252, NULL),
('Hampton Inn', 71, '2019-01-06', 273, NULL),
('Hampton Inn', 71, '2019-01-07', 361, NULL),
('Hampton Inn', 71, '2019-01-08', 186, NULL),
('Hampton Inn', 71, '2019-01-09', 213, NULL),
('Hampton Inn', 71, '2019-01-10', 221, NULL),
('Hampton Inn', 71, '2019-01-11', 211, NULL),
('Hampton Inn', 71, '2019-01-12', 382, NULL),
('Hampton Inn', 71, '2019-01-13', 311, NULL),
('Hampton Inn', 71, '2019-01-14', 220, NULL),
('Hampton Inn', 71, '2019-01-15', 111, NULL),
('Hampton Inn', 71, '2019-01-16', 364, NULL),
('Hampton Inn', 71, '2019-01-17', 283, NULL),
('Hampton Inn', 71, '2019-01-18', 352, NULL),
('Hampton Inn', 71, '2019-01-19', 394, NULL),
('Hampton Inn', 71, '2019-01-20', 255, NULL),
('Hampton Inn', 71, '2019-01-21', 306, NULL),
('Hampton Inn', 71, '2019-01-22', 151, NULL),
('Hampton Inn', 71, '2019-01-23', 238, NULL),
('Hampton Inn', 71, '2019-01-24', 267, NULL),
('Hampton Inn', 71, '2019-01-25', 310, NULL),
('Hampton Inn', 71, '2019-01-26', 135, NULL),
('Hampton Inn', 71, '2019-01-27', 316, NULL),
('Hampton Inn', 71, '2019-01-28', 108, NULL),
('Hampton Inn', 71, '2019-01-29', 187, NULL),
('Hampton Inn', 71, '2019-01-30', 298, NULL),
('Hampton Inn', 71, '2019-01-31', 147, NULL),
('Hampton Inn', 71, '2019-02-01', 185, NULL),
('Hampton Inn', 71, '2019-02-02', 327, NULL),
('Hampton Inn', 71, '2019-02-03', 270, NULL),
('Hampton Inn', 71, '2019-02-04', 364, NULL),
('Hampton Inn', 71, '2019-02-05', 147, NULL),
('Hampton Inn', 71, '2019-02-06', 344, NULL),
('Hampton Inn', 71, '2019-02-07', 331, NULL),
('Hampton Inn', 71, '2019-02-08', 316, NULL),
('Hampton Inn', 71, '2019-02-09', 157, NULL),
('Hampton Inn', 71, '2019-02-10', 195, NULL),
('Hampton Inn', 71, '2019-02-11', 259, NULL),
('Hampton Inn', 71, '2019-02-12', 383, NULL),
('Hampton Inn', 71, '2019-02-13', 196, NULL),
('Hampton Inn', 71, '2019-02-14', 382, NULL),
('Hampton Inn', 71, '2019-02-15', 314, NULL),
('Hampton Inn', 71, '2019-02-16', 173, NULL),
('Hampton Inn', 71, '2019-02-17', 183, NULL),
('Hampton Inn', 71, '2019-02-18', 129, NULL),
('Hampton Inn', 71, '2019-02-19', 236, NULL),
('Hampton Inn', 71, '2019-02-20', 365, NULL),
('Hampton Inn', 71, '2019-02-21', 267, NULL),
('Hampton Inn', 71, '2019-02-22', 216, NULL),
('Hampton Inn', 71, '2019-02-23', 239, NULL),
('Hampton Inn', 71, '2019-02-24', 212, NULL),
('Hampton Inn', 71, '2019-02-25', 275, NULL),
('Hampton Inn', 71, '2019-02-26', 232, NULL),
('Hampton Inn', 71, '2019-02-27', 285, NULL),
('Hampton Inn', 71, '2019-02-28', 365, NULL),
('Hampton Inn', 71, '2019-03-01', 373, NULL),
('Hampton Inn', 71, '2019-03-02', 364, NULL),
('Hampton Inn', 71, '2019-03-03', 263, NULL),
('Hampton Inn', 71, '2019-03-04', 236, NULL),
('Hampton Inn', 71, '2019-03-05', 112, NULL),
('Hampton Inn', 71, '2019-03-06', 234, NULL),
('Hampton Inn', 71, '2019-03-07', 245, NULL),
('Hampton Inn', 71, '2019-03-08', 284, NULL),
('Hampton Inn', 71, '2019-03-09', 220, NULL),
('Hampton Inn', 71, '2019-03-10', 381, NULL),
('Hampton Inn', 71, '2019-03-11', 235, NULL),
('Hampton Inn', 71, '2019-03-12', 224, NULL),
('Hampton Inn', 71, '2019-03-13', 193, NULL),
('Hampton Inn', 71, '2019-03-14', 231, NULL),
('Hampton Inn', 71, '2019-03-15', 116, NULL),
('Hampton Inn', 71, '2019-03-16', 275, NULL),
('Hampton Inn', 71, '2019-03-17', 103, NULL),
('Hampton Inn', 71, '2019-03-18', 291, NULL),
('Hampton Inn', 71, '2019-03-19', 123, NULL),
('Hampton Inn', 71, '2019-03-20', 255, NULL),
('Hampton Inn', 71, '2019-03-21', 283, NULL),
('Hampton Inn', 71, '2019-03-22', 256, NULL),
('Hampton Inn', 71, '2019-03-23', 170, NULL),
('Hampton Inn', 71, '2019-03-24', 115, NULL),
('Hampton Inn', 71, '2019-03-25', 146, NULL),
('Hampton Inn', 71, '2019-03-26', 242, NULL),
('Hampton Inn', 71, '2019-03-27', 118, NULL),
('Hampton Inn', 71, '2019-03-28', 122, NULL),
('Hampton Inn', 71, '2019-03-29', 180, NULL),
('Hampton Inn', 71, '2019-03-30', 217, NULL),
('Hampton Inn', 71, '2019-03-31', 388, NULL),
('Hampton Inn', 71, '2019-04-01', 214, NULL),
('Hampton Inn', 71, '2019-04-02', 370, NULL),
('Hampton Inn', 71, '2019-04-03', 307, NULL),
('Hampton Inn', 71, '2019-04-04', 309, NULL),
('Hampton Inn', 71, '2019-04-05', 284, NULL),
('Hampton Inn', 71, '2019-04-06', 395, NULL),
('Hampton Inn', 71, '2019-04-07', 305, NULL),
('Hampton Inn', 71, '2019-04-08', 383, NULL),
('Hampton Inn', 71, '2019-04-09', 236, NULL),
('Hampton Inn', 71, '2019-04-10', 178, NULL),
('Hampton Inn', 71, '2019-04-11', 360, NULL),
('Hampton Inn', 71, '2019-04-12', 137, NULL),
('Hampton Inn', 71, '2019-04-13', 220, NULL),
('Hampton Inn', 71, '2019-04-14', 263, NULL),
('Hampton Inn', 71, '2019-04-15', 363, NULL),
('Hampton Inn', 71, '2019-04-16', 139, NULL),
('Hampton Inn', 71, '2019-04-17', 235, NULL),
('Hampton Inn', 71, '2019-04-18', 319, NULL),
('Hampton Inn', 71, '2019-04-19', 386, NULL),
('Hampton Inn', 71, '2019-04-20', 399, NULL),
('Hampton Inn', 71, '2019-04-21', 343, NULL),
('Hampton Inn', 71, '2019-04-22', 151, NULL),
('Hampton Inn', 71, '2019-04-23', 308, NULL),
('Hampton Inn', 71, '2019-04-24', 204, NULL),
('Hampton Inn', 71, '2019-04-25', 383, NULL),
('Hampton Inn', 71, '2019-04-26', 162, NULL),
('Hampton Inn', 71, '2019-04-27', 367, NULL),
('Hampton Inn', 71, '2019-04-28', 190, NULL),
('Hampton Inn', 71, '2019-04-29', 293, NULL),
('Hampton Inn', 71, '2019-04-30', 137, NULL),
('Hampton Inn', 71, '2019-05-01', 312, NULL),
('Hampton Inn', 71, '2019-05-02', 196, NULL),
('Hampton Inn', 71, '2019-05-03', 258, NULL),
('Hampton Inn', 71, '2019-05-04', 294, NULL),
('Hampton Inn', 71, '2019-05-05', 132, NULL),
('Hampton Inn', 71, '2019-05-06', 247, NULL),
('Hampton Inn', 71, '2019-05-07', 256, NULL),
('Hampton Inn', 71, '2019-05-08', 216, NULL),
('Hampton Inn', 71, '2019-05-09', 158, NULL),
('Hampton Inn', 71, '2019-05-10', 369, NULL),
('Hampton Inn', 71, '2019-05-11', 146, NULL),
('Hampton Inn', 71, '2019-05-12', 281, NULL),
('Hampton Inn', 71, '2019-05-13', 317, NULL),
('Hampton Inn', 71, '2019-05-14', 262, NULL),
('Hampton Inn', 71, '2019-05-15', 264, NULL),
('Hampton Inn', 71, '2019-05-16', 304, NULL),
('Hampton Inn', 71, '2019-05-17', 302, NULL),
('Hampton Inn', 71, '2019-05-18', 157, NULL),
('Hampton Inn', 71, '2019-05-19', 228, NULL),
('Hampton Inn', 71, '2019-05-20', 344, NULL),
('Hampton Inn', 71, '2019-05-21', 129, NULL),
('Hampton Inn', 71, '2019-05-22', 180, NULL),
('Hampton Inn', 71, '2019-05-23', 219, NULL),
('Hampton Inn', 71, '2019-05-24', 128, NULL),
('Hampton Inn', 71, '2019-05-25', 324, NULL),
('Hampton Inn', 71, '2019-05-26', 316, NULL),
('Hampton Inn', 71, '2019-05-27', 337, NULL),
('Hampton Inn', 71, '2019-05-28', 298, NULL),
('Hampton Inn', 71, '2019-05-29', 177, NULL),
('Hampton Inn', 71, '2019-05-30', 363, NULL),
('Hampton Inn', 71, '2019-05-31', 314, NULL),
('Hampton Inn', 71, '2019-06-01', 226, NULL),
('Hampton Inn', 71, '2019-06-02', 136, NULL),
('Hampton Inn', 71, '2019-06-03', 215, NULL),
('Hampton Inn', 71, '2019-06-04', 128, NULL),
('Hampton Inn', 71, '2019-06-05', 170, NULL),
('Hampton Inn', 71, '2019-06-06', 179, NULL),
('Hampton Inn', 71, '2019-06-07', 297, NULL),
('Hampton Inn', 71, '2019-06-08', 309, NULL),
('Hampton Inn', 71, '2019-06-09', 269, NULL),
('Hampton Inn', 71, '2019-06-10', 145, NULL),
('Hampton Inn', 71, '2019-06-11', 250, NULL),
('Hampton Inn', 71, '2019-06-12', 394, NULL),
('Hampton Inn', 71, '2019-06-13', 177, NULL),
('Hampton Inn', 71, '2019-06-14', 158, NULL),
('Hampton Inn', 71, '2019-06-15', 153, NULL),
('Hampton Inn', 71, '2019-06-16', 256, NULL),
('Hampton Inn', 71, '2019-06-17', 278, NULL),
('Hampton Inn', 71, '2019-06-18', 226, NULL),
('Hampton Inn', 71, '2019-06-19', 396, NULL),
('Hampton Inn', 71, '2019-06-20', 298, NULL),
('Hampton Inn', 71, '2019-06-21', 205, NULL),
('Hampton Inn', 71, '2019-06-22', 268, NULL),
('Hampton Inn', 71, '2019-06-23', 347, NULL),
('Hampton Inn', 71, '2019-06-24', 275, NULL),
('Hampton Inn', 71, '2019-06-25', 214, NULL),
('Hampton Inn', 71, '2019-06-26', 206, NULL),
('Hampton Inn', 71, '2019-06-27', 105, NULL),
('Hampton Inn', 71, '2019-06-28', 267, NULL),
('Hampton Inn', 71, '2019-06-29', 296, NULL),
('Hampton Inn', 71, '2019-06-30', 155, NULL),
('Hampton Inn', 71, '2019-07-01', 162, NULL),
('Hampton Inn', 71, '2019-07-02', 299, NULL),
('Hampton Inn', 71, '2019-07-03', 184, NULL),
('Hampton Inn', 71, '2019-07-04', 325, NULL),
('Hampton Inn', 71, '2019-07-05', 356, NULL),
('Hampton Inn', 71, '2019-07-06', 264, NULL),
('Hampton Inn', 71, '2019-07-07', 374, NULL),
('Hampton Inn', 71, '2019-07-08', 250, NULL),
('Hampton Inn', 71, '2019-07-09', 109, NULL),
('Hampton Inn', 71, '2019-07-10', 265, NULL),
('Hampton Inn', 71, '2019-07-11', 349, NULL),
('Hampton Inn', 71, '2019-07-12', 370, NULL),
('Hampton Inn', 71, '2019-07-13', 186, NULL),
('Hampton Inn', 71, '2019-07-14', 201, NULL),
('Hampton Inn', 71, '2019-07-15', 385, NULL),
('Hampton Inn', 71, '2019-07-16', 264, NULL),
('Hampton Inn', 71, '2019-07-17', 222, NULL),
('Hampton Inn', 71, '2019-07-18', 314, NULL),
('Hampton Inn', 71, '2019-07-19', 172, NULL),
('Hampton Inn', 71, '2019-07-20', 135, NULL),
('Hampton Inn', 71, '2019-07-21', 334, NULL),
('Hampton Inn', 71, '2019-07-22', 173, NULL),
('Hampton Inn', 71, '2019-07-23', 315, NULL),
('Hampton Inn', 71, '2019-07-24', 314, NULL),
('Hampton Inn', 71, '2019-07-25', 242, NULL),
('Hampton Inn', 71, '2019-07-26', 205, NULL),
('Hampton Inn', 71, '2019-07-27', 126, NULL),
('Hampton Inn', 71, '2019-07-28', 106, NULL),
('Hampton Inn', 71, '2019-07-29', 163, NULL),
('Hampton Inn', 71, '2019-07-30', 363, NULL),
('Hampton Inn', 71, '2019-07-31', 362, NULL),
('Hampton Inn', 71, '2019-08-01', 106, NULL),
('Hampton Inn', 71, '2019-08-02', 142, NULL),
('Hampton Inn', 71, '2019-08-03', 217, NULL),
('Hampton Inn', 71, '2019-08-04', 293, NULL),
('Hampton Inn', 71, '2019-08-05', 146, NULL),
('Hampton Inn', 71, '2019-08-06', 240, NULL),
('Hampton Inn', 71, '2019-08-07', 273, NULL),
('Hampton Inn', 71, '2019-08-08', 224, NULL),
('Hampton Inn', 71, '2019-08-09', 208, NULL),
('Hampton Inn', 71, '2019-08-10', 130, NULL),
('Hampton Inn', 71, '2019-08-11', 176, NULL),
('Hampton Inn', 71, '2019-08-12', 257, NULL),
('Hampton Inn', 71, '2019-08-13', 366, NULL),
('Hampton Inn', 71, '2019-08-14', 345, NULL),
('Hampton Inn', 71, '2019-08-15', 130, NULL),
('Hampton Inn', 71, '2019-08-16', 284, NULL),
('Hampton Inn', 71, '2019-08-17', 329, NULL),
('Hampton Inn', 71, '2019-08-18', 121, NULL),
('Hampton Inn', 71, '2019-08-19', 239, NULL),
('Hampton Inn', 71, '2019-08-20', 248, NULL),
('Hampton Inn', 71, '2019-08-21', 243, NULL),
('Hampton Inn', 71, '2019-08-22', 161, NULL),
('Hampton Inn', 71, '2019-08-23', 245, NULL),
('Hampton Inn', 71, '2019-08-24', 372, NULL),
('Hampton Inn', 71, '2019-08-25', 108, NULL),
('Hampton Inn', 71, '2019-08-26', 151, NULL),
('Hampton Inn', 71, '2019-08-27', 219, NULL),
('Hampton Inn', 71, '2019-08-28', 157, NULL),
('Hampton Inn', 71, '2019-08-29', 295, NULL),
('Hampton Inn', 71, '2019-08-30', 153, NULL),
('Hampton Inn', 71, '2019-08-31', 145, NULL),
('Hampton Inn', 71, '2019-09-01', 287, NULL),
('Hampton Inn', 71, '2019-09-02', 196, NULL),
('Hampton Inn', 71, '2019-09-03', 265, NULL),
('Hampton Inn', 71, '2019-09-04', 291, NULL),
('Hampton Inn', 71, '2019-09-05', 318, NULL),
('Hampton Inn', 71, '2019-09-06', 312, NULL),
('Hampton Inn', 71, '2019-09-07', 243, NULL),
('Hampton Inn', 71, '2019-09-08', 273, NULL),
('Hampton Inn', 71, '2019-09-09', 217, NULL),
('Hampton Inn', 71, '2019-09-10', 205, NULL),
('Hampton Inn', 71, '2019-09-11', 109, NULL),
('Hampton Inn', 71, '2019-09-12', 160, NULL),
('Hampton Inn', 71, '2019-09-13', 392, NULL),
('Hampton Inn', 71, '2019-09-14', 298, NULL),
('Hampton Inn', 71, '2019-09-15', 231, NULL),
('Hampton Inn', 71, '2019-09-16', 326, NULL),
('Hampton Inn', 71, '2019-09-17', 151, NULL),
('Hampton Inn', 71, '2019-09-18', 135, NULL),
('Hampton Inn', 71, '2019-09-19', 357, NULL),
('Hampton Inn', 71, '2019-09-20', 341, NULL),
('Hampton Inn', 71, '2019-09-21', 387, NULL),
('Hampton Inn', 71, '2019-09-22', 379, NULL),
('Hampton Inn', 71, '2019-09-23', 195, NULL),
('Hampton Inn', 71, '2019-09-24', 116, NULL),
('Hampton Inn', 71, '2019-09-25', 377, NULL),
('Hampton Inn', 71, '2019-09-26', 126, NULL),
('Hampton Inn', 71, '2019-09-27', 131, NULL),
('Hampton Inn', 71, '2019-09-28', 111, NULL),
('Hampton Inn', 71, '2019-09-29', 224, NULL),
('Hampton Inn', 71, '2019-09-30', 333, NULL),
('Hampton Inn', 71, '2019-10-01', 194, NULL),
('Hampton Inn', 71, '2019-10-02', 240, NULL),
('Hampton Inn', 71, '2019-10-03', 236, NULL),
('Hampton Inn', 71, '2019-10-04', 333, NULL),
('Hampton Inn', 71, '2019-10-05', 164, NULL),
('Hampton Inn', 71, '2019-10-06', 187, NULL),
('Hampton Inn', 71, '2019-10-07', 223, NULL),
('Hampton Inn', 71, '2019-10-08', 243, NULL),
('Hampton Inn', 71, '2019-10-09', 331, NULL),
('Hampton Inn', 71, '2019-10-10', 316, NULL),
('Hampton Inn', 71, '2019-10-11', 192, NULL),
('Hampton Inn', 71, '2019-10-12', 105, NULL),
('Hampton Inn', 71, '2019-10-13', 144, NULL),
('Hampton Inn', 71, '2019-10-14', 161, NULL),
('Hampton Inn', 71, '2019-10-15', 205, NULL),
('Hampton Inn', 71, '2019-10-16', 123, NULL),
('Hampton Inn', 71, '2019-10-17', 236, NULL),
('Hampton Inn', 71, '2019-10-18', 229, NULL),
('Hampton Inn', 71, '2019-10-19', 285, NULL),
('Hampton Inn', 71, '2019-10-20', 120, NULL),
('Hampton Inn', 71, '2019-10-21', 318, NULL),
('Hampton Inn', 71, '2019-10-22', 272, NULL),
('Hampton Inn', 71, '2019-10-23', 264, NULL),
('Hampton Inn', 71, '2019-10-24', 155, NULL),
('Hampton Inn', 71, '2019-10-25', 382, NULL),
('Hampton Inn', 71, '2019-10-26', 389, NULL),
('Hampton Inn', 71, '2019-10-27', 217, NULL),
('Hampton Inn', 71, '2019-10-28', 344, NULL),
('Hampton Inn', 71, '2019-10-29', 332, NULL),
('Hampton Inn', 71, '2019-10-30', 197, NULL),
('Hampton Inn', 71, '2019-10-31', 148, NULL),
('Hampton Inn', 71, '2019-11-01', 205, NULL),
('Hampton Inn', 71, '2019-11-02', 312, NULL),
('Hampton Inn', 71, '2019-11-03', 200, NULL),
('Hampton Inn', 71, '2019-11-04', 363, NULL),
('Hampton Inn', 71, '2019-11-05', 246, NULL),
('Hampton Inn', 71, '2019-11-06', 398, NULL),
('Hampton Inn', 71, '2019-11-07', 244, NULL),
('Hampton Inn', 71, '2019-11-08', 140, NULL),
('Hampton Inn', 71, '2019-11-09', 257, NULL),
('Hampton Inn', 71, '2019-11-10', 348, NULL),
('Hampton Inn', 71, '2019-11-11', 208, NULL),
('Hampton Inn', 71, '2019-11-12', 297, NULL),
('Hampton Inn', 71, '2019-11-13', 360, NULL),
('Hampton Inn', 71, '2019-11-14', 226, NULL),
('Hampton Inn', 71, '2019-11-15', 208, NULL),
('Hampton Inn', 71, '2019-11-16', 316, NULL),
('Hampton Inn', 71, '2019-11-17', 301, NULL),
('Hampton Inn', 71, '2019-11-18', 262, NULL),
('Hampton Inn', 71, '2019-11-19', 209, NULL),
('Hampton Inn', 71, '2019-11-20', 356, NULL),
('Hampton Inn', 71, '2019-11-21', 175, NULL),
('Hampton Inn', 71, '2019-11-22', 281, NULL),
('Hampton Inn', 71, '2019-11-23', 294, NULL),
('Hampton Inn', 71, '2019-11-24', 284, NULL),
('Hampton Inn', 71, '2019-11-25', 104, NULL),
('Hampton Inn', 71, '2019-11-26', 393, NULL),
('Hampton Inn', 71, '2019-11-27', 234, NULL),
('Hampton Inn', 71, '2019-11-28', 140, NULL),
('Hampton Inn', 71, '2019-11-29', 116, NULL),
('Hampton Inn', 71, '2019-11-30', 176, NULL),
('Hampton Inn', 71, '2019-12-01', 266, NULL),
('Hampton Inn', 71, '2019-12-02', 265, NULL),
('Hampton Inn', 71, '2019-12-03', 326, NULL),
('Hampton Inn', 71, '2019-12-04', 124, NULL),
('Hampton Inn', 71, '2019-12-05', 375, NULL),
('Hampton Inn', 71, '2019-12-06', 322, NULL),
('Hampton Inn', 71, '2019-12-07', 244, NULL),
('Hampton Inn', 71, '2019-12-08', 172, NULL),
('Hampton Inn', 71, '2019-12-09', 222, NULL),
('Hampton Inn', 71, '2019-12-10', 315, NULL),
('Hampton Inn', 71, '2019-12-11', 366, NULL),
('Hampton Inn', 71, '2019-12-12', 178, NULL),
('Hampton Inn', 71, '2019-12-13', 129, NULL),
('Hampton Inn', 71, '2019-12-14', 267, NULL),
('Hampton Inn', 71, '2019-12-15', 166, NULL),
('Hampton Inn', 71, '2019-12-16', 271, NULL),
('Hampton Inn', 71, '2019-12-17', 170, NULL),
('Hampton Inn', 71, '2019-12-18', 257, NULL),
('Hampton Inn', 71, '2019-12-19', 384, NULL),
('Hampton Inn', 71, '2019-12-20', 224, NULL),
('Hampton Inn', 71, '2019-12-21', 368, NULL),
('Hampton Inn', 71, '2019-12-22', 192, NULL),
('Hampton Inn', 71, '2019-12-23', 384, NULL),
('Hampton Inn', 71, '2019-12-24', 253, NULL),
('Hampton Inn', 71, '2019-12-25', 146, NULL),
('Hampton Inn', 71, '2019-12-26', 225, NULL),
('Hampton Inn', 71, '2019-12-27', 120, NULL),
('Hampton Inn', 71, '2019-12-28', 318, NULL),
('Hampton Inn', 71, '2019-12-29', 392, NULL),
('Hampton Inn', 71, '2019-12-30', 138, NULL),
('Hampton Inn', 71, '2019-12-31', 287, NULL),
('Hampton Inn', 71, '2020-01-01', 197, NULL),
('Hampton Inn', 71, '2020-01-02', 341, NULL),
('Hampton Inn', 71, '2020-01-03', 399, NULL),
('Hampton Inn', 71, '2020-01-04', 255, NULL),
('Hampton Inn', 71, '2020-01-05', 227, NULL),
('Hampton Inn', 71, '2020-01-06', 118, NULL),
('Hampton Inn', 71, '2020-01-07', 222, NULL),
('Hampton Inn', 71, '2020-01-08', 309, NULL),
('Hampton Inn', 71, '2020-01-09', 300, NULL),
('Hampton Inn', 71, '2020-01-10', 117, NULL),
('Hampton Inn', 71, '2020-01-11', 383, NULL),
('Hampton Inn', 71, '2020-01-12', 282, NULL),
('Hampton Inn', 71, '2020-01-13', 146, NULL),
('Hampton Inn', 71, '2020-01-14', 236, NULL),
('Hampton Inn', 71, '2020-01-15', 239, NULL),
('Hampton Inn', 71, '2020-01-16', 297, NULL),
('Hampton Inn', 71, '2020-01-17', 261, NULL),
('Hampton Inn', 71, '2020-01-18', 360, NULL),
('Hampton Inn', 71, '2020-01-19', 219, NULL),
('Hampton Inn', 71, '2020-01-20', 279, NULL),
('Hampton Inn', 71, '2020-01-21', 254, NULL),
('Hampton Inn', 71, '2020-01-22', 347, NULL),
('Hampton Inn', 71, '2020-01-23', 294, NULL),
('Hampton Inn', 71, '2020-01-24', 368, NULL),
('Hampton Inn', 71, '2020-01-25', 122, NULL),
('Hampton Inn', 71, '2020-01-26', 181, NULL),
('Hampton Inn', 71, '2020-01-27', 282, NULL),
('Hampton Inn', 71, '2020-01-28', 261, NULL),
('Hampton Inn', 71, '2020-01-29', 340, NULL),
('Hampton Inn', 71, '2020-01-30', 334, NULL),
('Hampton Inn', 71, '2020-01-31', 151, NULL),
('Hampton Inn', 71, '2020-02-01', 217, NULL),
('Hampton Inn', 71, '2020-02-02', 277, NULL),
('Hampton Inn', 71, '2020-02-03', 289, NULL),
('Hampton Inn', 71, '2020-02-04', 374, NULL),
('Hampton Inn', 78, '2019-01-01', 206, NULL),
('Hampton Inn', 78, '2019-01-02', 113, NULL),
('Hampton Inn', 78, '2019-01-03', 367, NULL),
('Hampton Inn', 78, '2019-01-04', 274, NULL),
('Hampton Inn', 78, '2019-01-05', 187, NULL),
('Hampton Inn', 78, '2019-01-06', 245, NULL),
('Hampton Inn', 78, '2019-01-07', 371, NULL),
('Hampton Inn', 78, '2019-01-08', 255, NULL),
('Hampton Inn', 78, '2019-01-09', 323, NULL),
('Hampton Inn', 78, '2019-01-10', 299, NULL),
('Hampton Inn', 78, '2019-01-11', 184, NULL),
('Hampton Inn', 78, '2019-01-12', 164, NULL),
('Hampton Inn', 78, '2019-01-13', 214, NULL),
('Hampton Inn', 78, '2019-01-14', 143, NULL),
('Hampton Inn', 78, '2019-01-15', 371, NULL),
('Hampton Inn', 78, '2019-01-16', 320, NULL),
('Hampton Inn', 78, '2019-01-17', 109, NULL),
('Hampton Inn', 78, '2019-01-18', 292, NULL),
('Hampton Inn', 78, '2019-01-19', 285, NULL),
('Hampton Inn', 78, '2019-01-20', 290, NULL),
('Hampton Inn', 78, '2019-01-21', 308, NULL),
('Hampton Inn', 78, '2019-01-22', 188, NULL),
('Hampton Inn', 78, '2019-01-23', 328, NULL),
('Hampton Inn', 78, '2019-01-24', 294, NULL),
('Hampton Inn', 78, '2019-01-25', 399, NULL),
('Hampton Inn', 78, '2019-01-26', 120, NULL),
('Hampton Inn', 78, '2019-01-27', 167, NULL),
('Hampton Inn', 78, '2019-01-28', 391, NULL),
('Hampton Inn', 78, '2019-01-29', 322, NULL),
('Hampton Inn', 78, '2019-01-30', 347, NULL),
('Hampton Inn', 78, '2019-01-31', 296, NULL),
('Hampton Inn', 78, '2019-02-01', 338, NULL),
('Hampton Inn', 78, '2019-02-02', 116, NULL),
('Hampton Inn', 78, '2019-02-03', 190, NULL),
('Hampton Inn', 78, '2019-02-04', 372, NULL),
('Hampton Inn', 78, '2019-02-05', 223, NULL),
('Hampton Inn', 78, '2019-02-06', 239, NULL),
('Hampton Inn', 78, '2019-02-07', 290, NULL),
('Hampton Inn', 78, '2019-02-08', 377, NULL),
('Hampton Inn', 78, '2019-02-09', 263, NULL),
('Hampton Inn', 78, '2019-02-10', 261, NULL),
('Hampton Inn', 78, '2019-02-11', 110, NULL),
('Hampton Inn', 78, '2019-02-12', 365, NULL),
('Hampton Inn', 78, '2019-02-13', 390, NULL),
('Hampton Inn', 78, '2019-02-14', 297, NULL),
('Hampton Inn', 78, '2019-02-15', 236, NULL),
('Hampton Inn', 78, '2019-02-16', 161, NULL),
('Hampton Inn', 78, '2019-02-17', 287, NULL),
('Hampton Inn', 78, '2019-02-18', 221, NULL),
('Hampton Inn', 78, '2019-02-19', 252, NULL),
('Hampton Inn', 78, '2019-02-20', 234, NULL),
('Hampton Inn', 78, '2019-02-21', 253, NULL),
('Hampton Inn', 78, '2019-02-22', 377, NULL),
('Hampton Inn', 78, '2019-02-23', 266, NULL),
('Hampton Inn', 78, '2019-02-24', 357, NULL),
('Hampton Inn', 78, '2019-02-25', 371, NULL),
('Hampton Inn', 78, '2019-02-26', 326, NULL),
('Hampton Inn', 78, '2019-02-27', 154, NULL),
('Hampton Inn', 78, '2019-02-28', 154, NULL),
('Hampton Inn', 78, '2019-03-01', 223, NULL),
('Hampton Inn', 78, '2019-03-02', 377, NULL),
('Hampton Inn', 78, '2019-03-03', 259, NULL),
('Hampton Inn', 78, '2019-03-04', 158, NULL),
('Hampton Inn', 78, '2019-03-05', 181, NULL),
('Hampton Inn', 78, '2019-03-06', 298, NULL),
('Hampton Inn', 78, '2019-03-07', 276, NULL),
('Hampton Inn', 78, '2019-03-08', 179, NULL),
('Hampton Inn', 78, '2019-03-09', 304, NULL),
('Hampton Inn', 78, '2019-03-10', 266, NULL),
('Hampton Inn', 78, '2019-03-11', 165, NULL),
('Hampton Inn', 78, '2019-03-12', 252, NULL),
('Hampton Inn', 78, '2019-03-13', 260, NULL),
('Hampton Inn', 78, '2019-03-14', 144, NULL),
('Hampton Inn', 78, '2019-03-15', 236, NULL),
('Hampton Inn', 78, '2019-03-16', 334, NULL),
('Hampton Inn', 78, '2019-03-17', 211, NULL),
('Hampton Inn', 78, '2019-03-18', 161, NULL),
('Hampton Inn', 78, '2019-03-19', 281, NULL),
('Hampton Inn', 78, '2019-03-20', 115, NULL),
('Hampton Inn', 78, '2019-03-21', 165, NULL),
('Hampton Inn', 78, '2019-03-22', 387, NULL),
('Hampton Inn', 78, '2019-03-23', 226, NULL),
('Hampton Inn', 78, '2019-03-24', 166, NULL),
('Hampton Inn', 78, '2019-03-25', 275, NULL),
('Hampton Inn', 78, '2019-03-26', 395, NULL),
('Hampton Inn', 78, '2019-03-27', 240, NULL),
('Hampton Inn', 78, '2019-03-28', 178, NULL),
('Hampton Inn', 78, '2019-03-29', 236, NULL),
('Hampton Inn', 78, '2019-03-30', 353, NULL),
('Hampton Inn', 78, '2019-03-31', 172, NULL),
('Hampton Inn', 78, '2019-04-01', 244, NULL),
('Hampton Inn', 78, '2019-04-02', 351, NULL),
('Hampton Inn', 78, '2019-04-03', 295, NULL),
('Hampton Inn', 78, '2019-04-04', 273, NULL),
('Hampton Inn', 78, '2019-04-05', 273, NULL),
('Hampton Inn', 78, '2019-04-06', 321, NULL),
('Hampton Inn', 78, '2019-04-07', 129, NULL),
('Hampton Inn', 78, '2019-04-08', 332, NULL),
('Hampton Inn', 78, '2019-04-09', 263, NULL),
('Hampton Inn', 78, '2019-04-10', 397, NULL),
('Hampton Inn', 78, '2019-04-11', 258, NULL),
('Hampton Inn', 78, '2019-04-12', 362, NULL),
('Hampton Inn', 78, '2019-04-13', 345, NULL),
('Hampton Inn', 78, '2019-04-14', 199, NULL),
('Hampton Inn', 78, '2019-04-15', 210, NULL),
('Hampton Inn', 78, '2019-04-16', 341, NULL),
('Hampton Inn', 78, '2019-04-17', 393, NULL),
('Hampton Inn', 78, '2019-04-18', 221, NULL),
('Hampton Inn', 78, '2019-04-19', 312, NULL),
('Hampton Inn', 78, '2019-04-20', 135, NULL),
('Hampton Inn', 78, '2019-04-21', 146, NULL),
('Hampton Inn', 78, '2019-04-22', 101, NULL),
('Hampton Inn', 78, '2019-04-23', 163, NULL),
('Hampton Inn', 78, '2019-04-24', 362, NULL),
('Hampton Inn', 78, '2019-04-25', 299, NULL),
('Hampton Inn', 78, '2019-04-26', 236, NULL),
('Hampton Inn', 78, '2019-04-27', 164, NULL),
('Hampton Inn', 78, '2019-04-28', 187, NULL),
('Hampton Inn', 78, '2019-04-29', 364, NULL),
('Hampton Inn', 78, '2019-04-30', 212, NULL),
('Hampton Inn', 78, '2019-05-01', 129, NULL),
('Hampton Inn', 78, '2019-05-02', 146, NULL),
('Hampton Inn', 78, '2019-05-03', 129, NULL),
('Hampton Inn', 78, '2019-05-04', 229, NULL),
('Hampton Inn', 78, '2019-05-05', 203, NULL),
('Hampton Inn', 78, '2019-05-06', 292, NULL),
('Hampton Inn', 78, '2019-05-07', 360, NULL),
('Hampton Inn', 78, '2019-05-08', 164, NULL),
('Hampton Inn', 78, '2019-05-09', 261, NULL),
('Hampton Inn', 78, '2019-05-10', 101, NULL),
('Hampton Inn', 78, '2019-05-11', 335, NULL),
('Hampton Inn', 78, '2019-05-12', 213, NULL),
('Hampton Inn', 78, '2019-05-13', 137, NULL),
('Hampton Inn', 78, '2019-05-14', 187, NULL),
('Hampton Inn', 78, '2019-05-15', 315, NULL),
('Hampton Inn', 78, '2019-05-16', 117, NULL),
('Hampton Inn', 78, '2019-05-17', 201, NULL),
('Hampton Inn', 78, '2019-05-18', 276, NULL),
('Hampton Inn', 78, '2019-05-19', 305, NULL),
('Hampton Inn', 78, '2019-05-20', 181, NULL),
('Hampton Inn', 78, '2019-05-21', 110, NULL),
('Hampton Inn', 78, '2019-05-22', 370, NULL),
('Hampton Inn', 78, '2019-05-23', 269, NULL),
('Hampton Inn', 78, '2019-05-24', 312, NULL),
('Hampton Inn', 78, '2019-05-25', 283, NULL),
('Hampton Inn', 78, '2019-05-26', 265, NULL),
('Hampton Inn', 78, '2019-05-27', 377, NULL),
('Hampton Inn', 78, '2019-05-28', 124, NULL),
('Hampton Inn', 78, '2019-05-29', 353, NULL),
('Hampton Inn', 78, '2019-05-30', 117, NULL),
('Hampton Inn', 78, '2019-05-31', 199, NULL),
('Hampton Inn', 78, '2019-06-01', 336, NULL),
('Hampton Inn', 78, '2019-06-02', 102, NULL),
('Hampton Inn', 78, '2019-06-03', 113, NULL),
('Hampton Inn', 78, '2019-06-04', 327, NULL),
('Hampton Inn', 78, '2019-06-05', 198, NULL),
('Hampton Inn', 78, '2019-06-06', 218, NULL),
('Hampton Inn', 78, '2019-06-07', 206, NULL),
('Hampton Inn', 78, '2019-06-08', 310, NULL),
('Hampton Inn', 78, '2019-06-09', 248, NULL),
('Hampton Inn', 78, '2019-06-10', 386, NULL),
('Hampton Inn', 78, '2019-06-11', 172, NULL),
('Hampton Inn', 78, '2019-06-12', 331, NULL),
('Hampton Inn', 78, '2019-06-13', 373, NULL),
('Hampton Inn', 78, '2019-06-14', 227, NULL),
('Hampton Inn', 78, '2019-06-15', 104, NULL),
('Hampton Inn', 78, '2019-06-16', 297, NULL),
('Hampton Inn', 78, '2019-06-17', 166, NULL),
('Hampton Inn', 78, '2019-06-18', 355, NULL),
('Hampton Inn', 78, '2019-06-19', 256, NULL),
('Hampton Inn', 78, '2019-06-20', 170, NULL),
('Hampton Inn', 78, '2019-06-21', 367, NULL),
('Hampton Inn', 78, '2019-06-22', 349, NULL),
('Hampton Inn', 78, '2019-06-23', 114, NULL),
('Hampton Inn', 78, '2019-06-24', 354, NULL),
('Hampton Inn', 78, '2019-06-25', 134, NULL),
('Hampton Inn', 78, '2019-06-26', 265, NULL),
('Hampton Inn', 78, '2019-06-27', 220, NULL),
('Hampton Inn', 78, '2019-06-28', 302, NULL),
('Hampton Inn', 78, '2019-06-29', 171, NULL),
('Hampton Inn', 78, '2019-06-30', 380, NULL),
('Hampton Inn', 78, '2019-07-01', 144, NULL),
('Hampton Inn', 78, '2019-07-02', 344, NULL),
('Hampton Inn', 78, '2019-07-03', 198, NULL),
('Hampton Inn', 78, '2019-07-04', 306, NULL),
('Hampton Inn', 78, '2019-07-05', 370, NULL),
('Hampton Inn', 78, '2019-07-06', 127, NULL),
('Hampton Inn', 78, '2019-07-07', 358, NULL),
('Hampton Inn', 78, '2019-07-08', 366, NULL),
('Hampton Inn', 78, '2019-07-09', 311, NULL),
('Hampton Inn', 78, '2019-07-10', 155, NULL),
('Hampton Inn', 78, '2019-07-11', 135, NULL),
('Hampton Inn', 78, '2019-07-12', 387, NULL),
('Hampton Inn', 78, '2019-07-13', 274, NULL),
('Hampton Inn', 78, '2019-07-14', 255, NULL),
('Hampton Inn', 78, '2019-07-15', 339, NULL),
('Hampton Inn', 78, '2019-07-16', 264, NULL),
('Hampton Inn', 78, '2019-07-17', 288, NULL),
('Hampton Inn', 78, '2019-07-18', 370, NULL),
('Hampton Inn', 78, '2019-07-19', 219, NULL),
('Hampton Inn', 78, '2019-07-20', 103, NULL),
('Hampton Inn', 78, '2019-07-21', 240, NULL),
('Hampton Inn', 78, '2019-07-22', 168, NULL),
('Hampton Inn', 78, '2019-07-23', 146, NULL),
('Hampton Inn', 78, '2019-07-24', 334, NULL),
('Hampton Inn', 78, '2019-07-25', 341, NULL),
('Hampton Inn', 78, '2019-07-26', 398, NULL),
('Hampton Inn', 78, '2019-07-27', 341, NULL),
('Hampton Inn', 78, '2019-07-28', 285, NULL),
('Hampton Inn', 78, '2019-07-29', 283, NULL),
('Hampton Inn', 78, '2019-07-30', 192, NULL),
('Hampton Inn', 78, '2019-07-31', 194, NULL),
('Hampton Inn', 78, '2019-08-01', 141, NULL),
('Hampton Inn', 78, '2019-08-02', 160, NULL),
('Hampton Inn', 78, '2019-08-03', 371, NULL),
('Hampton Inn', 78, '2019-08-04', 345, NULL),
('Hampton Inn', 78, '2019-08-05', 297, NULL),
('Hampton Inn', 78, '2019-08-06', 379, NULL),
('Hampton Inn', 78, '2019-08-07', 179, NULL),
('Hampton Inn', 78, '2019-08-08', 231, NULL),
('Hampton Inn', 78, '2019-08-09', 243, NULL),
('Hampton Inn', 78, '2019-08-10', 125, NULL),
('Hampton Inn', 78, '2019-08-11', 348, NULL),
('Hampton Inn', 78, '2019-08-12', 194, NULL),
('Hampton Inn', 78, '2019-08-13', 377, NULL),
('Hampton Inn', 78, '2019-08-14', 196, NULL),
('Hampton Inn', 78, '2019-08-15', 100, NULL),
('Hampton Inn', 78, '2019-08-16', 154, NULL),
('Hampton Inn', 78, '2019-08-17', 191, NULL),
('Hampton Inn', 78, '2019-08-18', 232, NULL),
('Hampton Inn', 78, '2019-08-19', 216, NULL),
('Hampton Inn', 78, '2019-08-20', 319, NULL),
('Hampton Inn', 78, '2019-08-21', 205, NULL),
('Hampton Inn', 78, '2019-08-22', 180, NULL),
('Hampton Inn', 78, '2019-08-23', 150, NULL),
('Hampton Inn', 78, '2019-08-24', 215, NULL),
('Hampton Inn', 78, '2019-08-25', 160, NULL),
('Hampton Inn', 78, '2019-08-26', 303, NULL),
('Hampton Inn', 78, '2019-08-27', 221, NULL),
('Hampton Inn', 78, '2019-08-28', 234, NULL),
('Hampton Inn', 78, '2019-08-29', 302, NULL),
('Hampton Inn', 78, '2019-08-30', 359, NULL),
('Hampton Inn', 78, '2019-08-31', 114, NULL),
('Hampton Inn', 78, '2019-09-01', 129, NULL),
('Hampton Inn', 78, '2019-09-02', 319, NULL),
('Hampton Inn', 78, '2019-09-03', 396, NULL),
('Hampton Inn', 78, '2019-09-04', 271, NULL),
('Hampton Inn', 78, '2019-09-05', 337, NULL),
('Hampton Inn', 78, '2019-09-06', 180, NULL),
('Hampton Inn', 78, '2019-09-07', 238, NULL),
('Hampton Inn', 78, '2019-09-08', 331, NULL),
('Hampton Inn', 78, '2019-09-09', 248, NULL),
('Hampton Inn', 78, '2019-09-10', 306, NULL),
('Hampton Inn', 78, '2019-09-11', 292, NULL),
('Hampton Inn', 78, '2019-09-12', 152, NULL),
('Hampton Inn', 78, '2019-09-13', 359, NULL),
('Hampton Inn', 78, '2019-09-14', 375, NULL),
('Hampton Inn', 78, '2019-09-15', 156, NULL),
('Hampton Inn', 78, '2019-09-16', 198, NULL),
('Hampton Inn', 78, '2019-09-17', 154, NULL),
('Hampton Inn', 78, '2019-09-18', 302, NULL),
('Hampton Inn', 78, '2019-09-19', 297, NULL),
('Hampton Inn', 78, '2019-09-20', 135, NULL),
('Hampton Inn', 78, '2019-09-21', 130, NULL),
('Hampton Inn', 78, '2019-09-22', 121, NULL),
('Hampton Inn', 78, '2019-09-23', 280, NULL),
('Hampton Inn', 78, '2019-09-24', 194, NULL),
('Hampton Inn', 78, '2019-09-25', 112, NULL),
('Hampton Inn', 78, '2019-09-26', 383, NULL),
('Hampton Inn', 78, '2019-09-27', 108, NULL),
('Hampton Inn', 78, '2019-09-28', 379, NULL),
('Hampton Inn', 78, '2019-09-29', 301, NULL),
('Hampton Inn', 78, '2019-09-30', 218, NULL),
('Hampton Inn', 78, '2019-10-01', 272, NULL),
('Hampton Inn', 78, '2019-10-02', 219, NULL),
('Hampton Inn', 78, '2019-10-03', 112, NULL),
('Hampton Inn', 78, '2019-10-04', 298, NULL),
('Hampton Inn', 78, '2019-10-05', 195, NULL),
('Hampton Inn', 78, '2019-10-06', 175, NULL),
('Hampton Inn', 78, '2019-10-07', 367, NULL),
('Hampton Inn', 78, '2019-10-08', 205, NULL),
('Hampton Inn', 78, '2019-10-09', 381, NULL),
('Hampton Inn', 78, '2019-10-10', 332, NULL),
('Hampton Inn', 78, '2019-10-11', 326, NULL),
('Hampton Inn', 78, '2019-10-12', 242, NULL),
('Hampton Inn', 78, '2019-10-13', 328, NULL),
('Hampton Inn', 78, '2019-10-14', 237, NULL),
('Hampton Inn', 78, '2019-10-15', 148, NULL),
('Hampton Inn', 78, '2019-10-16', 166, NULL),
('Hampton Inn', 78, '2019-10-17', 384, NULL),
('Hampton Inn', 78, '2019-10-18', 119, NULL),
('Hampton Inn', 78, '2019-10-19', 105, NULL),
('Hampton Inn', 78, '2019-10-20', 354, NULL),
('Hampton Inn', 78, '2019-10-21', 208, NULL),
('Hampton Inn', 78, '2019-10-22', 207, NULL),
('Hampton Inn', 78, '2019-10-23', 172, NULL),
('Hampton Inn', 78, '2019-10-24', 329, NULL),
('Hampton Inn', 78, '2019-10-25', 210, NULL),
('Hampton Inn', 78, '2019-10-26', 304, NULL),
('Hampton Inn', 78, '2019-10-27', 285, NULL),
('Hampton Inn', 78, '2019-10-28', 272, NULL),
('Hampton Inn', 78, '2019-10-29', 229, NULL),
('Hampton Inn', 78, '2019-10-30', 340, NULL),
('Hampton Inn', 78, '2019-10-31', 158, NULL),
('Hampton Inn', 78, '2019-11-01', 119, NULL),
('Hampton Inn', 78, '2019-11-02', 398, NULL),
('Hampton Inn', 78, '2019-11-03', 357, NULL),
('Hampton Inn', 78, '2019-11-04', 268, NULL),
('Hampton Inn', 78, '2019-11-05', 337, NULL),
('Hampton Inn', 78, '2019-11-06', 365, NULL),
('Hampton Inn', 78, '2019-11-07', 160, NULL),
('Hampton Inn', 78, '2019-11-08', 256, NULL),
('Hampton Inn', 78, '2019-11-09', 275, NULL),
('Hampton Inn', 78, '2019-11-10', 266, NULL),
('Hampton Inn', 78, '2019-11-11', 396, NULL),
('Hampton Inn', 78, '2019-11-12', 381, NULL),
('Hampton Inn', 78, '2019-11-13', 113, NULL),
('Hampton Inn', 78, '2019-11-14', 156, NULL),
('Hampton Inn', 78, '2019-11-15', 399, NULL),
('Hampton Inn', 78, '2019-11-16', 316, NULL),
('Hampton Inn', 78, '2019-11-17', 293, NULL),
('Hampton Inn', 78, '2019-11-18', 297, NULL),
('Hampton Inn', 78, '2019-11-19', 237, NULL),
('Hampton Inn', 78, '2019-11-20', 129, NULL),
('Hampton Inn', 78, '2019-11-21', 200, NULL),
('Hampton Inn', 78, '2019-11-22', 360, NULL),
('Hampton Inn', 78, '2019-11-23', 110, NULL),
('Hampton Inn', 78, '2019-11-24', 245, NULL),
('Hampton Inn', 78, '2019-11-25', 378, NULL),
('Hampton Inn', 78, '2019-11-26', 161, NULL),
('Hampton Inn', 78, '2019-11-27', 128, NULL),
('Hampton Inn', 78, '2019-11-28', 341, NULL),
('Hampton Inn', 78, '2019-11-29', 220, NULL),
('Hampton Inn', 78, '2019-11-30', 259, NULL),
('Hampton Inn', 78, '2019-12-01', 119, NULL),
('Hampton Inn', 78, '2019-12-02', 122, NULL),
('Hampton Inn', 78, '2019-12-03', 203, NULL),
('Hampton Inn', 78, '2019-12-04', 383, NULL),
('Hampton Inn', 78, '2019-12-05', 189, NULL),
('Hampton Inn', 78, '2019-12-06', 358, NULL),
('Hampton Inn', 78, '2019-12-07', 116, NULL),
('Hampton Inn', 78, '2019-12-08', 286, NULL),
('Hampton Inn', 78, '2019-12-09', 209, NULL),
('Hampton Inn', 78, '2019-12-10', 394, NULL),
('Hampton Inn', 78, '2019-12-11', 316, NULL),
('Hampton Inn', 78, '2019-12-12', 285, NULL),
('Hampton Inn', 78, '2019-12-13', 276, NULL),
('Hampton Inn', 78, '2019-12-14', 217, NULL),
('Hampton Inn', 78, '2019-12-15', 365, NULL),
('Hampton Inn', 78, '2019-12-16', 313, NULL),
('Hampton Inn', 78, '2019-12-17', 367, NULL),
('Hampton Inn', 78, '2019-12-18', 134, NULL),
('Hampton Inn', 78, '2019-12-19', 371, NULL),
('Hampton Inn', 78, '2019-12-20', 193, NULL),
('Hampton Inn', 78, '2019-12-21', 129, NULL),
('Hampton Inn', 78, '2019-12-22', 313, NULL),
('Hampton Inn', 78, '2019-12-23', 246, NULL),
('Hampton Inn', 78, '2019-12-24', 189, NULL),
('Hampton Inn', 78, '2019-12-25', 175, NULL),
('Hampton Inn', 78, '2019-12-26', 320, NULL),
('Hampton Inn', 78, '2019-12-27', 129, NULL),
('Hampton Inn', 78, '2019-12-28', 339, NULL),
('Hampton Inn', 78, '2019-12-29', 235, NULL),
('Hampton Inn', 78, '2019-12-30', 179, NULL),
('Hampton Inn', 78, '2019-12-31', 182, NULL),
('Hampton Inn', 78, '2020-01-01', 173, NULL),
('Hampton Inn', 78, '2020-01-02', 263, NULL),
('Hampton Inn', 78, '2020-01-03', 311, NULL),
('Hampton Inn', 78, '2020-01-04', 166, NULL),
('Hampton Inn', 78, '2020-01-05', 274, NULL),
('Hampton Inn', 78, '2020-01-06', 232, NULL),
('Hampton Inn', 78, '2020-01-07', 286, NULL),
('Hampton Inn', 78, '2020-01-08', 229, NULL),
('Hampton Inn', 78, '2020-01-09', 330, NULL),
('Hampton Inn', 78, '2020-01-10', 106, NULL),
('Hampton Inn', 78, '2020-01-11', 274, NULL),
('Hampton Inn', 78, '2020-01-12', 250, NULL),
('Hampton Inn', 78, '2020-01-13', 130, NULL),
('Hampton Inn', 78, '2020-01-14', 363, NULL),
('Hampton Inn', 78, '2020-01-15', 194, NULL),
('Hampton Inn', 78, '2020-01-16', 148, NULL),
('Hampton Inn', 78, '2020-01-17', 310, NULL),
('Hampton Inn', 78, '2020-01-18', 154, NULL),
('Hampton Inn', 78, '2020-01-19', 167, NULL),
('Hampton Inn', 78, '2020-01-20', 121, NULL),
('Hampton Inn', 78, '2020-01-21', 111, NULL),
('Hampton Inn', 78, '2020-01-22', 329, NULL),
('Hampton Inn', 78, '2020-01-23', 114, NULL),
('Hampton Inn', 78, '2020-01-24', 335, NULL),
('Hampton Inn', 78, '2020-01-25', 145, NULL),
('Hampton Inn', 78, '2020-01-26', 348, NULL),
('Hampton Inn', 78, '2020-01-27', 270, NULL),
('Hampton Inn', 78, '2020-01-28', 132, NULL),
('Hampton Inn', 78, '2020-01-29', 199, NULL),
('Hampton Inn', 78, '2020-01-30', 177, NULL),
('Hampton Inn', 78, '2020-01-31', 306, NULL),
('Hampton Inn', 78, '2020-02-01', 309, NULL),
('Hampton Inn', 78, '2020-02-02', 179, NULL),
('Hampton Inn', 78, '2020-02-03', 143, NULL),
('Hampton Inn', 78, '2020-02-04', 266, NULL),
('Hampton Inn', 100, '2019-01-01', 142, NULL),
('Hampton Inn', 100, '2019-01-02', 337, NULL),
('Hampton Inn', 100, '2019-01-03', 212, NULL),
('Hampton Inn', 100, '2019-01-04', 227, NULL),
('Hampton Inn', 100, '2019-01-05', 380, NULL),
('Hampton Inn', 100, '2019-01-06', 306, NULL),
('Hampton Inn', 100, '2019-01-07', 375, NULL),
('Hampton Inn', 100, '2019-01-08', 317, NULL),
('Hampton Inn', 100, '2019-01-09', 276, NULL),
('Hampton Inn', 100, '2019-01-10', 130, NULL),
('Hampton Inn', 100, '2019-01-11', 185, NULL),
('Hampton Inn', 100, '2019-01-12', 175, NULL),
('Hampton Inn', 100, '2019-01-13', 337, NULL),
('Hampton Inn', 100, '2019-01-14', 255, NULL),
('Hampton Inn', 100, '2019-01-15', 226, NULL),
('Hampton Inn', 100, '2019-01-16', 110, NULL),
('Hampton Inn', 100, '2019-01-17', 196, NULL),
('Hampton Inn', 100, '2019-01-18', 304, NULL),
('Hampton Inn', 100, '2019-01-19', 145, NULL),
('Hampton Inn', 100, '2019-01-20', 286, NULL),
('Hampton Inn', 100, '2019-01-21', 221, NULL),
('Hampton Inn', 100, '2019-01-22', 388, NULL),
('Hampton Inn', 100, '2019-01-23', 229, NULL),
('Hampton Inn', 100, '2019-01-24', 272, NULL),
('Hampton Inn', 100, '2019-01-25', 365, NULL),
('Hampton Inn', 100, '2019-01-26', 396, NULL),
('Hampton Inn', 100, '2019-01-27', 387, NULL),
('Hampton Inn', 100, '2019-01-28', 333, NULL),
('Hampton Inn', 100, '2019-01-29', 348, NULL),
('Hampton Inn', 100, '2019-01-30', 143, NULL),
('Hampton Inn', 100, '2019-01-31', 341, NULL),
('Hampton Inn', 100, '2019-02-01', 134, NULL),
('Hampton Inn', 100, '2019-02-02', 102, NULL),
('Hampton Inn', 100, '2019-02-03', 338, NULL),
('Hampton Inn', 100, '2019-02-04', 371, NULL),
('Hampton Inn', 100, '2019-02-05', 274, NULL),
('Hampton Inn', 100, '2019-02-06', 363, NULL),
('Hampton Inn', 100, '2019-02-07', 358, NULL),
('Hampton Inn', 100, '2019-02-08', 236, NULL),
('Hampton Inn', 100, '2019-02-09', 144, NULL),
('Hampton Inn', 100, '2019-02-10', 320, NULL),
('Hampton Inn', 100, '2019-02-11', 275, NULL),
('Hampton Inn', 100, '2019-02-12', 274, NULL),
('Hampton Inn', 100, '2019-02-13', 366, NULL),
('Hampton Inn', 100, '2019-02-14', 241, NULL),
('Hampton Inn', 100, '2019-02-15', 141, NULL),
('Hampton Inn', 100, '2019-02-16', 187, NULL),
('Hampton Inn', 100, '2019-02-17', 186, NULL),
('Hampton Inn', 100, '2019-02-18', 319, NULL),
('Hampton Inn', 100, '2019-02-19', 153, NULL),
('Hampton Inn', 100, '2019-02-20', 277, NULL),
('Hampton Inn', 100, '2019-02-21', 364, NULL),
('Hampton Inn', 100, '2019-02-22', 237, NULL),
('Hampton Inn', 100, '2019-02-23', 216, NULL),
('Hampton Inn', 100, '2019-02-24', 149, NULL),
('Hampton Inn', 100, '2019-02-25', 332, NULL),
('Hampton Inn', 100, '2019-02-26', 235, NULL),
('Hampton Inn', 100, '2019-02-27', 114, NULL),
('Hampton Inn', 100, '2019-02-28', 176, NULL),
('Hampton Inn', 100, '2019-03-01', 199, NULL),
('Hampton Inn', 100, '2019-03-02', 393, NULL),
('Hampton Inn', 100, '2019-03-03', 108, NULL),
('Hampton Inn', 100, '2019-03-04', 282, NULL),
('Hampton Inn', 100, '2019-03-05', 171, NULL),
('Hampton Inn', 100, '2019-03-06', 388, NULL),
('Hampton Inn', 100, '2019-03-07', 245, NULL),
('Hampton Inn', 100, '2019-03-08', 244, NULL),
('Hampton Inn', 100, '2019-03-09', 164, NULL),
('Hampton Inn', 100, '2019-03-10', 387, NULL),
('Hampton Inn', 100, '2019-03-11', 318, NULL),
('Hampton Inn', 100, '2019-03-12', 190, NULL),
('Hampton Inn', 100, '2019-03-13', 323, NULL),
('Hampton Inn', 100, '2019-03-14', 225, NULL),
('Hampton Inn', 100, '2019-03-15', 130, NULL),
('Hampton Inn', 100, '2019-03-16', 149, NULL),
('Hampton Inn', 100, '2019-03-17', 347, NULL),
('Hampton Inn', 100, '2019-03-18', 135, NULL),
('Hampton Inn', 100, '2019-03-19', 334, NULL),
('Hampton Inn', 100, '2019-03-20', 309, NULL),
('Hampton Inn', 100, '2019-03-21', 176, NULL),
('Hampton Inn', 100, '2019-03-22', 167, NULL),
('Hampton Inn', 100, '2019-03-23', 222, NULL),
('Hampton Inn', 100, '2019-03-24', 386, NULL),
('Hampton Inn', 100, '2019-03-25', 238, NULL),
('Hampton Inn', 100, '2019-03-26', 246, NULL),
('Hampton Inn', 100, '2019-03-27', 147, NULL),
('Hampton Inn', 100, '2019-03-28', 127, NULL),
('Hampton Inn', 100, '2019-03-29', 242, NULL),
('Hampton Inn', 100, '2019-03-30', 113, NULL),
('Hampton Inn', 100, '2019-03-31', 195, NULL),
('Hampton Inn', 100, '2019-04-01', 179, NULL),
('Hampton Inn', 100, '2019-04-02', 244, NULL),
('Hampton Inn', 100, '2019-04-03', 153, NULL),
('Hampton Inn', 100, '2019-04-04', 338, NULL),
('Hampton Inn', 100, '2019-04-05', 110, NULL),
('Hampton Inn', 100, '2019-04-06', 320, NULL),
('Hampton Inn', 100, '2019-04-07', 227, NULL),
('Hampton Inn', 100, '2019-04-08', 111, NULL),
('Hampton Inn', 100, '2019-04-09', 206, NULL),
('Hampton Inn', 100, '2019-04-10', 152, NULL),
('Hampton Inn', 100, '2019-04-11', 108, NULL),
('Hampton Inn', 100, '2019-04-12', 101, NULL),
('Hampton Inn', 100, '2019-04-13', 364, NULL),
('Hampton Inn', 100, '2019-04-14', 103, NULL),
('Hampton Inn', 100, '2019-04-15', 163, NULL),
('Hampton Inn', 100, '2019-04-16', 286, NULL),
('Hampton Inn', 100, '2019-04-17', 264, NULL),
('Hampton Inn', 100, '2019-04-18', 350, NULL),
('Hampton Inn', 100, '2019-04-19', 305, NULL),
('Hampton Inn', 100, '2019-04-20', 279, NULL),
('Hampton Inn', 100, '2019-04-21', 201, NULL),
('Hampton Inn', 100, '2019-04-22', 251, NULL),
('Hampton Inn', 100, '2019-04-23', 392, NULL),
('Hampton Inn', 100, '2019-04-24', 196, NULL),
('Hampton Inn', 100, '2019-04-25', 244, NULL),
('Hampton Inn', 100, '2019-04-26', 296, NULL),
('Hampton Inn', 100, '2019-04-27', 220, NULL),
('Hampton Inn', 100, '2019-04-28', 265, NULL),
('Hampton Inn', 100, '2019-04-29', 238, NULL),
('Hampton Inn', 100, '2019-04-30', 252, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 100, '2019-05-01', 208, NULL),
('Hampton Inn', 100, '2019-05-02', 342, NULL),
('Hampton Inn', 100, '2019-05-03', 373, NULL),
('Hampton Inn', 100, '2019-05-04', 160, NULL),
('Hampton Inn', 100, '2019-05-05', 221, NULL),
('Hampton Inn', 100, '2019-05-06', 321, NULL),
('Hampton Inn', 100, '2019-05-07', 334, NULL),
('Hampton Inn', 100, '2019-05-08', 370, NULL),
('Hampton Inn', 100, '2019-05-09', 131, NULL),
('Hampton Inn', 100, '2019-05-10', 199, NULL),
('Hampton Inn', 100, '2019-05-11', 237, NULL),
('Hampton Inn', 100, '2019-05-12', 124, NULL),
('Hampton Inn', 100, '2019-05-13', 236, NULL),
('Hampton Inn', 100, '2019-05-14', 349, NULL),
('Hampton Inn', 100, '2019-05-15', 382, NULL),
('Hampton Inn', 100, '2019-05-16', 173, NULL),
('Hampton Inn', 100, '2019-05-17', 299, NULL),
('Hampton Inn', 100, '2019-05-18', 209, NULL),
('Hampton Inn', 100, '2019-05-19', 142, NULL),
('Hampton Inn', 100, '2019-05-20', 373, NULL),
('Hampton Inn', 100, '2019-05-21', 363, NULL),
('Hampton Inn', 100, '2019-05-22', 308, NULL),
('Hampton Inn', 100, '2019-05-23', 289, NULL),
('Hampton Inn', 100, '2019-05-24', 177, NULL),
('Hampton Inn', 100, '2019-05-25', 347, NULL),
('Hampton Inn', 100, '2019-05-26', 278, NULL),
('Hampton Inn', 100, '2019-05-27', 174, NULL),
('Hampton Inn', 100, '2019-05-28', 229, NULL),
('Hampton Inn', 100, '2019-05-29', 234, NULL),
('Hampton Inn', 100, '2019-05-30', 295, NULL),
('Hampton Inn', 100, '2019-05-31', 256, NULL),
('Hampton Inn', 100, '2019-06-01', 305, NULL),
('Hampton Inn', 100, '2019-06-02', 305, NULL),
('Hampton Inn', 100, '2019-06-03', 122, NULL),
('Hampton Inn', 100, '2019-06-04', 252, NULL),
('Hampton Inn', 100, '2019-06-05', 380, NULL),
('Hampton Inn', 100, '2019-06-06', 153, NULL),
('Hampton Inn', 100, '2019-06-07', 341, NULL),
('Hampton Inn', 100, '2019-06-08', 224, NULL),
('Hampton Inn', 100, '2019-06-09', 332, NULL),
('Hampton Inn', 100, '2019-06-10', 194, NULL),
('Hampton Inn', 100, '2019-06-11', 309, NULL),
('Hampton Inn', 100, '2019-06-12', 375, NULL),
('Hampton Inn', 100, '2019-06-13', 336, NULL),
('Hampton Inn', 100, '2019-06-14', 264, NULL),
('Hampton Inn', 100, '2019-06-15', 260, NULL),
('Hampton Inn', 100, '2019-06-16', 318, NULL),
('Hampton Inn', 100, '2019-06-17', 199, NULL),
('Hampton Inn', 100, '2019-06-18', 399, NULL),
('Hampton Inn', 100, '2019-06-19', 292, NULL),
('Hampton Inn', 100, '2019-06-20', 155, NULL),
('Hampton Inn', 100, '2019-06-21', 221, NULL),
('Hampton Inn', 100, '2019-06-22', 241, NULL),
('Hampton Inn', 100, '2019-06-23', 329, NULL),
('Hampton Inn', 100, '2019-06-24', 242, NULL),
('Hampton Inn', 100, '2019-06-25', 229, NULL),
('Hampton Inn', 100, '2019-06-26', 307, NULL),
('Hampton Inn', 100, '2019-06-27', 389, NULL),
('Hampton Inn', 100, '2019-06-28', 307, NULL),
('Hampton Inn', 100, '2019-06-29', 166, NULL),
('Hampton Inn', 100, '2019-06-30', 132, NULL),
('Hampton Inn', 100, '2019-07-01', 133, NULL),
('Hampton Inn', 100, '2019-07-02', 121, NULL),
('Hampton Inn', 100, '2019-07-03', 340, NULL),
('Hampton Inn', 100, '2019-07-04', 155, NULL),
('Hampton Inn', 100, '2019-07-05', 385, NULL),
('Hampton Inn', 100, '2019-07-06', 344, NULL),
('Hampton Inn', 100, '2019-07-07', 268, NULL),
('Hampton Inn', 100, '2019-07-08', 382, NULL),
('Hampton Inn', 100, '2019-07-09', 227, NULL),
('Hampton Inn', 100, '2019-07-10', 177, NULL),
('Hampton Inn', 100, '2019-07-11', 131, NULL),
('Hampton Inn', 100, '2019-07-12', 127, NULL),
('Hampton Inn', 100, '2019-07-13', 113, NULL),
('Hampton Inn', 100, '2019-07-14', 275, NULL),
('Hampton Inn', 100, '2019-07-15', 139, NULL),
('Hampton Inn', 100, '2019-07-16', 126, NULL),
('Hampton Inn', 100, '2019-07-17', 375, NULL),
('Hampton Inn', 100, '2019-07-18', 210, NULL),
('Hampton Inn', 100, '2019-07-19', 180, NULL),
('Hampton Inn', 100, '2019-07-20', 312, NULL),
('Hampton Inn', 100, '2019-07-21', 398, NULL),
('Hampton Inn', 100, '2019-07-22', 225, NULL),
('Hampton Inn', 100, '2019-07-23', 286, NULL),
('Hampton Inn', 100, '2019-07-24', 329, NULL),
('Hampton Inn', 100, '2019-07-25', 280, NULL),
('Hampton Inn', 100, '2019-07-26', 377, NULL),
('Hampton Inn', 100, '2019-07-27', 326, NULL),
('Hampton Inn', 100, '2019-07-28', 108, NULL),
('Hampton Inn', 100, '2019-07-29', 229, NULL),
('Hampton Inn', 100, '2019-07-30', 372, NULL),
('Hampton Inn', 100, '2019-07-31', 386, NULL),
('Hampton Inn', 100, '2019-08-01', 286, NULL),
('Hampton Inn', 100, '2019-08-02', 273, NULL),
('Hampton Inn', 100, '2019-08-03', 206, NULL),
('Hampton Inn', 100, '2019-08-04', 148, NULL),
('Hampton Inn', 100, '2019-08-05', 345, NULL),
('Hampton Inn', 100, '2019-08-06', 178, NULL),
('Hampton Inn', 100, '2019-08-07', 274, NULL),
('Hampton Inn', 100, '2019-08-08', 386, NULL),
('Hampton Inn', 100, '2019-08-09', 189, NULL),
('Hampton Inn', 100, '2019-08-10', 137, NULL),
('Hampton Inn', 100, '2019-08-11', 213, NULL),
('Hampton Inn', 100, '2019-08-12', 398, NULL),
('Hampton Inn', 100, '2019-08-13', 387, NULL),
('Hampton Inn', 100, '2019-08-14', 147, NULL),
('Hampton Inn', 100, '2019-08-15', 310, NULL),
('Hampton Inn', 100, '2019-08-16', 121, NULL),
('Hampton Inn', 100, '2019-08-17', 169, NULL),
('Hampton Inn', 100, '2019-08-18', 399, NULL),
('Hampton Inn', 100, '2019-08-19', 265, NULL),
('Hampton Inn', 100, '2019-08-20', 151, NULL),
('Hampton Inn', 100, '2019-08-21', 199, NULL),
('Hampton Inn', 100, '2019-08-22', 321, NULL),
('Hampton Inn', 100, '2019-08-23', 217, NULL),
('Hampton Inn', 100, '2019-08-24', 158, NULL),
('Hampton Inn', 100, '2019-08-25', 376, NULL),
('Hampton Inn', 100, '2019-08-26', 364, NULL),
('Hampton Inn', 100, '2019-08-27', 347, NULL),
('Hampton Inn', 100, '2019-08-28', 300, NULL),
('Hampton Inn', 100, '2019-08-29', 225, NULL),
('Hampton Inn', 100, '2019-08-30', 337, NULL),
('Hampton Inn', 100, '2019-08-31', 335, NULL),
('Hampton Inn', 100, '2019-09-01', 287, NULL),
('Hampton Inn', 100, '2019-09-02', 306, NULL),
('Hampton Inn', 100, '2019-09-03', 185, NULL),
('Hampton Inn', 100, '2019-09-04', 384, NULL),
('Hampton Inn', 100, '2019-09-05', 329, NULL),
('Hampton Inn', 100, '2019-09-06', 164, NULL),
('Hampton Inn', 100, '2019-09-07', 362, NULL),
('Hampton Inn', 100, '2019-09-08', 136, NULL),
('Hampton Inn', 100, '2019-09-09', 188, NULL),
('Hampton Inn', 100, '2019-09-10', 214, NULL),
('Hampton Inn', 100, '2019-09-11', 132, NULL),
('Hampton Inn', 100, '2019-09-12', 181, NULL),
('Hampton Inn', 100, '2019-09-13', 218, NULL),
('Hampton Inn', 100, '2019-09-14', 282, NULL),
('Hampton Inn', 100, '2019-09-15', 289, NULL),
('Hampton Inn', 100, '2019-09-16', 213, NULL),
('Hampton Inn', 100, '2019-09-17', 217, NULL),
('Hampton Inn', 100, '2019-09-18', 107, NULL),
('Hampton Inn', 100, '2019-09-19', 313, NULL),
('Hampton Inn', 100, '2019-09-20', 154, NULL),
('Hampton Inn', 100, '2019-09-21', 290, NULL),
('Hampton Inn', 100, '2019-09-22', 269, NULL),
('Hampton Inn', 100, '2019-09-23', 118, NULL),
('Hampton Inn', 100, '2019-09-24', 222, NULL),
('Hampton Inn', 100, '2019-09-25', 231, NULL),
('Hampton Inn', 100, '2019-09-26', 234, NULL),
('Hampton Inn', 100, '2019-09-27', 346, NULL),
('Hampton Inn', 100, '2019-09-28', 263, NULL),
('Hampton Inn', 100, '2019-09-29', 135, NULL),
('Hampton Inn', 100, '2019-09-30', 293, NULL),
('Hampton Inn', 100, '2019-10-01', 377, NULL),
('Hampton Inn', 100, '2019-10-02', 276, NULL),
('Hampton Inn', 100, '2019-10-03', 354, NULL),
('Hampton Inn', 100, '2019-10-04', 392, NULL),
('Hampton Inn', 100, '2019-10-05', 386, NULL),
('Hampton Inn', 100, '2019-10-06', 213, NULL),
('Hampton Inn', 100, '2019-10-07', 164, NULL),
('Hampton Inn', 100, '2019-10-08', 200, NULL),
('Hampton Inn', 100, '2019-10-09', 214, NULL),
('Hampton Inn', 100, '2019-10-10', 309, NULL),
('Hampton Inn', 100, '2019-10-11', 353, NULL),
('Hampton Inn', 100, '2019-10-12', 194, NULL),
('Hampton Inn', 100, '2019-10-13', 208, NULL),
('Hampton Inn', 100, '2019-10-14', 305, NULL),
('Hampton Inn', 100, '2019-10-15', 323, NULL),
('Hampton Inn', 100, '2019-10-16', 364, NULL),
('Hampton Inn', 100, '2019-10-17', 216, NULL),
('Hampton Inn', 100, '2019-10-18', 108, NULL),
('Hampton Inn', 100, '2019-10-19', 170, NULL),
('Hampton Inn', 100, '2019-10-20', 111, NULL),
('Hampton Inn', 100, '2019-10-21', 285, NULL),
('Hampton Inn', 100, '2019-10-22', 117, NULL),
('Hampton Inn', 100, '2019-10-23', 267, NULL),
('Hampton Inn', 100, '2019-10-24', 180, NULL),
('Hampton Inn', 100, '2019-10-25', 103, NULL),
('Hampton Inn', 100, '2019-10-26', 254, NULL),
('Hampton Inn', 100, '2019-10-27', 374, NULL),
('Hampton Inn', 100, '2019-10-28', 232, NULL),
('Hampton Inn', 100, '2019-10-29', 350, NULL),
('Hampton Inn', 100, '2019-10-30', 112, NULL),
('Hampton Inn', 100, '2019-10-31', 249, NULL),
('Hampton Inn', 100, '2019-11-01', 180, NULL),
('Hampton Inn', 100, '2019-11-02', 354, NULL),
('Hampton Inn', 100, '2019-11-03', 182, NULL),
('Hampton Inn', 100, '2019-11-04', 149, NULL),
('Hampton Inn', 100, '2019-11-05', 245, NULL),
('Hampton Inn', 100, '2019-11-06', 234, NULL),
('Hampton Inn', 100, '2019-11-07', 270, NULL),
('Hampton Inn', 100, '2019-11-08', 160, NULL),
('Hampton Inn', 100, '2019-11-09', 205, NULL),
('Hampton Inn', 100, '2019-11-10', 187, NULL),
('Hampton Inn', 100, '2019-11-11', 356, NULL),
('Hampton Inn', 100, '2019-11-12', 314, NULL),
('Hampton Inn', 100, '2019-11-13', 287, NULL),
('Hampton Inn', 100, '2019-11-14', 304, NULL),
('Hampton Inn', 100, '2019-11-15', 375, NULL),
('Hampton Inn', 100, '2019-11-16', 232, NULL),
('Hampton Inn', 100, '2019-11-17', 162, NULL),
('Hampton Inn', 100, '2019-11-18', 303, NULL),
('Hampton Inn', 100, '2019-11-19', 159, NULL),
('Hampton Inn', 100, '2019-11-20', 379, NULL),
('Hampton Inn', 100, '2019-11-21', 376, NULL),
('Hampton Inn', 100, '2019-11-22', 257, NULL),
('Hampton Inn', 100, '2019-11-23', 168, NULL),
('Hampton Inn', 100, '2019-11-24', 271, NULL),
('Hampton Inn', 100, '2019-11-25', 281, NULL),
('Hampton Inn', 100, '2019-11-26', 125, NULL),
('Hampton Inn', 100, '2019-11-27', 140, NULL),
('Hampton Inn', 100, '2019-11-28', 286, NULL),
('Hampton Inn', 100, '2019-11-29', 355, NULL),
('Hampton Inn', 100, '2019-11-30', 366, NULL),
('Hampton Inn', 100, '2019-12-01', 294, NULL),
('Hampton Inn', 100, '2019-12-02', 316, NULL),
('Hampton Inn', 100, '2019-12-03', 235, NULL),
('Hampton Inn', 100, '2019-12-04', 241, NULL),
('Hampton Inn', 100, '2019-12-05', 323, NULL),
('Hampton Inn', 100, '2019-12-06', 122, NULL),
('Hampton Inn', 100, '2019-12-07', 346, NULL),
('Hampton Inn', 100, '2019-12-08', 214, NULL),
('Hampton Inn', 100, '2019-12-09', 281, NULL),
('Hampton Inn', 100, '2019-12-10', 328, NULL),
('Hampton Inn', 100, '2019-12-11', 385, NULL),
('Hampton Inn', 100, '2019-12-12', 192, NULL),
('Hampton Inn', 100, '2019-12-13', 294, NULL),
('Hampton Inn', 100, '2019-12-14', 186, NULL),
('Hampton Inn', 100, '2019-12-15', 328, NULL),
('Hampton Inn', 100, '2019-12-16', 354, NULL),
('Hampton Inn', 100, '2019-12-17', 327, NULL),
('Hampton Inn', 100, '2019-12-18', 398, NULL),
('Hampton Inn', 100, '2019-12-19', 303, NULL),
('Hampton Inn', 100, '2019-12-20', 196, NULL),
('Hampton Inn', 100, '2019-12-21', 341, NULL),
('Hampton Inn', 100, '2019-12-22', 289, NULL),
('Hampton Inn', 100, '2019-12-23', 279, NULL),
('Hampton Inn', 100, '2019-12-24', 388, NULL),
('Hampton Inn', 100, '2019-12-25', 336, NULL),
('Hampton Inn', 100, '2019-12-26', 226, NULL),
('Hampton Inn', 100, '2019-12-27', 186, NULL),
('Hampton Inn', 100, '2019-12-28', 341, NULL),
('Hampton Inn', 100, '2019-12-29', 200, NULL),
('Hampton Inn', 100, '2019-12-30', 381, NULL),
('Hampton Inn', 100, '2019-12-31', 247, NULL),
('Hampton Inn', 100, '2020-01-01', 176, NULL),
('Hampton Inn', 100, '2020-01-02', 192, NULL),
('Hampton Inn', 100, '2020-01-03', 257, NULL),
('Hampton Inn', 100, '2020-01-04', 268, NULL),
('Hampton Inn', 100, '2020-01-05', 287, NULL),
('Hampton Inn', 100, '2020-01-06', 105, NULL),
('Hampton Inn', 100, '2020-01-07', 365, NULL),
('Hampton Inn', 100, '2020-01-08', 119, NULL),
('Hampton Inn', 100, '2020-01-09', 350, NULL),
('Hampton Inn', 100, '2020-01-10', 381, NULL),
('Hampton Inn', 100, '2020-01-11', 120, NULL),
('Hampton Inn', 100, '2020-01-12', 303, NULL),
('Hampton Inn', 100, '2020-01-13', 115, NULL),
('Hampton Inn', 100, '2020-01-14', 106, NULL),
('Hampton Inn', 100, '2020-01-15', 154, NULL),
('Hampton Inn', 100, '2020-01-16', 348, NULL),
('Hampton Inn', 100, '2020-01-17', 366, NULL),
('Hampton Inn', 100, '2020-01-18', 188, NULL),
('Hampton Inn', 100, '2020-01-19', 376, NULL),
('Hampton Inn', 100, '2020-01-20', 268, NULL),
('Hampton Inn', 100, '2020-01-21', 294, NULL),
('Hampton Inn', 100, '2020-01-22', 205, NULL),
('Hampton Inn', 100, '2020-01-23', 188, NULL),
('Hampton Inn', 100, '2020-01-24', 172, NULL),
('Hampton Inn', 100, '2020-01-25', 260, NULL),
('Hampton Inn', 100, '2020-01-26', 195, NULL),
('Hampton Inn', 100, '2020-01-27', 102, NULL),
('Hampton Inn', 100, '2020-01-28', 379, NULL),
('Hampton Inn', 100, '2020-01-29', 175, NULL),
('Hampton Inn', 100, '2020-01-30', 382, NULL),
('Hampton Inn', 100, '2020-01-31', 375, NULL),
('Hampton Inn', 100, '2020-02-01', 195, NULL),
('Hampton Inn', 100, '2020-02-02', 262, NULL),
('Hampton Inn', 100, '2020-02-03', 349, NULL),
('Hampton Inn', 100, '2020-02-04', 109, NULL),
('Hampton Inn', 101, '2019-01-01', 295, NULL),
('Hampton Inn', 101, '2019-01-02', 344, NULL),
('Hampton Inn', 101, '2019-01-03', 158, NULL),
('Hampton Inn', 101, '2019-01-04', 213, NULL),
('Hampton Inn', 101, '2019-01-05', 342, NULL),
('Hampton Inn', 101, '2019-01-06', 397, NULL),
('Hampton Inn', 101, '2019-01-07', 361, NULL),
('Hampton Inn', 101, '2019-01-08', 119, NULL),
('Hampton Inn', 101, '2019-01-09', 312, NULL),
('Hampton Inn', 101, '2019-01-10', 256, NULL),
('Hampton Inn', 101, '2019-01-11', 275, NULL),
('Hampton Inn', 101, '2019-01-12', 283, NULL),
('Hampton Inn', 101, '2019-01-13', 344, NULL),
('Hampton Inn', 101, '2019-01-14', 148, NULL),
('Hampton Inn', 101, '2019-01-15', 214, NULL),
('Hampton Inn', 101, '2019-01-16', 390, NULL),
('Hampton Inn', 101, '2019-01-17', 257, NULL),
('Hampton Inn', 101, '2019-01-18', 242, NULL),
('Hampton Inn', 101, '2019-01-19', 367, NULL),
('Hampton Inn', 101, '2019-01-20', 159, NULL),
('Hampton Inn', 101, '2019-01-21', 384, NULL),
('Hampton Inn', 101, '2019-01-22', 376, NULL),
('Hampton Inn', 101, '2019-01-23', 359, NULL),
('Hampton Inn', 101, '2019-01-24', 377, NULL),
('Hampton Inn', 101, '2019-01-25', 230, NULL),
('Hampton Inn', 101, '2019-01-26', 321, NULL),
('Hampton Inn', 101, '2019-01-27', 136, NULL),
('Hampton Inn', 101, '2019-01-28', 394, NULL),
('Hampton Inn', 101, '2019-01-29', 373, NULL),
('Hampton Inn', 101, '2019-01-30', 172, NULL),
('Hampton Inn', 101, '2019-01-31', 116, NULL),
('Hampton Inn', 101, '2019-02-01', 157, NULL),
('Hampton Inn', 101, '2019-02-02', 359, NULL),
('Hampton Inn', 101, '2019-02-03', 123, NULL),
('Hampton Inn', 101, '2019-02-04', 338, NULL),
('Hampton Inn', 101, '2019-02-05', 303, NULL),
('Hampton Inn', 101, '2019-02-06', 100, NULL),
('Hampton Inn', 101, '2019-02-07', 221, NULL),
('Hampton Inn', 101, '2019-02-08', 252, NULL),
('Hampton Inn', 101, '2019-02-09', 132, NULL),
('Hampton Inn', 101, '2019-02-10', 117, NULL),
('Hampton Inn', 101, '2019-02-11', 347, NULL),
('Hampton Inn', 101, '2019-02-12', 176, NULL),
('Hampton Inn', 101, '2019-02-13', 259, NULL),
('Hampton Inn', 101, '2019-02-14', 216, NULL),
('Hampton Inn', 101, '2019-02-15', 194, NULL),
('Hampton Inn', 101, '2019-02-16', 352, NULL),
('Hampton Inn', 101, '2019-02-17', 272, NULL),
('Hampton Inn', 101, '2019-02-18', 231, NULL),
('Hampton Inn', 101, '2019-02-19', 207, NULL),
('Hampton Inn', 101, '2019-02-20', 284, NULL),
('Hampton Inn', 101, '2019-02-21', 363, NULL),
('Hampton Inn', 101, '2019-02-22', 257, NULL),
('Hampton Inn', 101, '2019-02-23', 184, NULL),
('Hampton Inn', 101, '2019-02-24', 174, NULL),
('Hampton Inn', 101, '2019-02-25', 147, NULL),
('Hampton Inn', 101, '2019-02-26', 398, NULL),
('Hampton Inn', 101, '2019-02-27', 310, NULL),
('Hampton Inn', 101, '2019-02-28', 316, NULL),
('Hampton Inn', 101, '2019-03-01', 226, NULL),
('Hampton Inn', 101, '2019-03-02', 136, NULL),
('Hampton Inn', 101, '2019-03-03', 264, NULL),
('Hampton Inn', 101, '2019-03-04', 235, NULL),
('Hampton Inn', 101, '2019-03-05', 211, NULL),
('Hampton Inn', 101, '2019-03-06', 346, NULL),
('Hampton Inn', 101, '2019-03-07', 297, NULL),
('Hampton Inn', 101, '2019-03-08', 284, NULL),
('Hampton Inn', 101, '2019-03-09', 106, NULL),
('Hampton Inn', 101, '2019-03-10', 136, NULL),
('Hampton Inn', 101, '2019-03-11', 396, NULL),
('Hampton Inn', 101, '2019-03-12', 395, NULL),
('Hampton Inn', 101, '2019-03-13', 135, NULL),
('Hampton Inn', 101, '2019-03-14', 296, NULL),
('Hampton Inn', 101, '2019-03-15', 145, NULL),
('Hampton Inn', 101, '2019-03-16', 240, NULL),
('Hampton Inn', 101, '2019-03-17', 101, NULL),
('Hampton Inn', 101, '2019-03-18', 392, NULL),
('Hampton Inn', 101, '2019-03-19', 128, NULL),
('Hampton Inn', 101, '2019-03-20', 202, NULL),
('Hampton Inn', 101, '2019-03-21', 289, NULL),
('Hampton Inn', 101, '2019-03-22', 174, NULL),
('Hampton Inn', 101, '2019-03-23', 331, NULL),
('Hampton Inn', 101, '2019-03-24', 130, NULL),
('Hampton Inn', 101, '2019-03-25', 263, NULL),
('Hampton Inn', 101, '2019-03-26', 247, NULL),
('Hampton Inn', 101, '2019-03-27', 214, NULL),
('Hampton Inn', 101, '2019-03-28', 301, NULL),
('Hampton Inn', 101, '2019-03-29', 101, NULL),
('Hampton Inn', 101, '2019-03-30', 309, NULL),
('Hampton Inn', 101, '2019-03-31', 361, NULL),
('Hampton Inn', 101, '2019-04-01', 362, NULL),
('Hampton Inn', 101, '2019-04-02', 366, NULL),
('Hampton Inn', 101, '2019-04-03', 382, NULL),
('Hampton Inn', 101, '2019-04-04', 172, NULL),
('Hampton Inn', 101, '2019-04-05', 233, NULL),
('Hampton Inn', 101, '2019-04-06', 239, NULL),
('Hampton Inn', 101, '2019-04-07', 350, NULL),
('Hampton Inn', 101, '2019-04-08', 362, NULL),
('Hampton Inn', 101, '2019-04-09', 142, NULL),
('Hampton Inn', 101, '2019-04-10', 369, NULL),
('Hampton Inn', 101, '2019-04-11', 267, NULL),
('Hampton Inn', 101, '2019-04-12', 222, NULL),
('Hampton Inn', 101, '2019-04-13', 385, NULL),
('Hampton Inn', 101, '2019-04-14', 119, NULL),
('Hampton Inn', 101, '2019-04-15', 383, NULL),
('Hampton Inn', 101, '2019-04-16', 309, NULL),
('Hampton Inn', 101, '2019-04-17', 339, NULL),
('Hampton Inn', 101, '2019-04-18', 386, NULL),
('Hampton Inn', 101, '2019-04-19', 187, NULL),
('Hampton Inn', 101, '2019-04-20', 292, NULL),
('Hampton Inn', 101, '2019-04-21', 166, NULL),
('Hampton Inn', 101, '2019-04-22', 253, NULL),
('Hampton Inn', 101, '2019-04-23', 169, NULL),
('Hampton Inn', 101, '2019-04-24', 396, NULL),
('Hampton Inn', 101, '2019-04-25', 223, NULL),
('Hampton Inn', 101, '2019-04-26', 373, NULL),
('Hampton Inn', 101, '2019-04-27', 209, NULL),
('Hampton Inn', 101, '2019-04-28', 365, NULL),
('Hampton Inn', 101, '2019-04-29', 302, NULL),
('Hampton Inn', 101, '2019-04-30', 225, NULL),
('Hampton Inn', 101, '2019-05-01', 254, NULL),
('Hampton Inn', 101, '2019-05-02', 271, NULL),
('Hampton Inn', 101, '2019-05-03', 178, NULL),
('Hampton Inn', 101, '2019-05-04', 317, NULL),
('Hampton Inn', 101, '2019-05-05', 396, NULL),
('Hampton Inn', 101, '2019-05-06', 331, NULL),
('Hampton Inn', 101, '2019-05-07', 187, NULL),
('Hampton Inn', 101, '2019-05-08', 359, NULL),
('Hampton Inn', 101, '2019-05-09', 375, NULL),
('Hampton Inn', 101, '2019-05-10', 294, NULL),
('Hampton Inn', 101, '2019-05-11', 379, NULL),
('Hampton Inn', 101, '2019-05-12', 182, NULL),
('Hampton Inn', 101, '2019-05-13', 368, NULL),
('Hampton Inn', 101, '2019-05-14', 185, NULL),
('Hampton Inn', 101, '2019-05-15', 268, NULL),
('Hampton Inn', 101, '2019-05-16', 117, NULL),
('Hampton Inn', 101, '2019-05-17', 192, NULL),
('Hampton Inn', 101, '2019-05-18', 117, NULL),
('Hampton Inn', 101, '2019-05-19', 297, NULL),
('Hampton Inn', 101, '2019-05-20', 324, NULL),
('Hampton Inn', 101, '2019-05-21', 186, NULL),
('Hampton Inn', 101, '2019-05-22', 332, NULL),
('Hampton Inn', 101, '2019-05-23', 237, NULL),
('Hampton Inn', 101, '2019-05-24', 147, NULL),
('Hampton Inn', 101, '2019-05-25', 185, NULL),
('Hampton Inn', 101, '2019-05-26', 196, NULL),
('Hampton Inn', 101, '2019-05-27', 238, NULL),
('Hampton Inn', 101, '2019-05-28', 373, NULL),
('Hampton Inn', 101, '2019-05-29', 313, NULL),
('Hampton Inn', 101, '2019-05-30', 125, NULL),
('Hampton Inn', 101, '2019-05-31', 285, NULL),
('Hampton Inn', 101, '2019-06-01', 115, NULL),
('Hampton Inn', 101, '2019-06-02', 221, NULL),
('Hampton Inn', 101, '2019-06-03', 170, NULL),
('Hampton Inn', 101, '2019-06-04', 179, NULL),
('Hampton Inn', 101, '2019-06-05', 306, NULL),
('Hampton Inn', 101, '2019-06-06', 312, NULL),
('Hampton Inn', 101, '2019-06-07', 386, NULL),
('Hampton Inn', 101, '2019-06-08', 391, NULL),
('Hampton Inn', 101, '2019-06-09', 219, NULL),
('Hampton Inn', 101, '2019-06-10', 316, NULL),
('Hampton Inn', 101, '2019-06-11', 330, NULL),
('Hampton Inn', 101, '2019-06-12', 184, NULL),
('Hampton Inn', 101, '2019-06-13', 159, NULL),
('Hampton Inn', 101, '2019-06-14', 236, NULL),
('Hampton Inn', 101, '2019-06-15', 290, NULL),
('Hampton Inn', 101, '2019-06-16', 299, NULL),
('Hampton Inn', 101, '2019-06-17', 396, NULL),
('Hampton Inn', 101, '2019-06-18', 228, NULL),
('Hampton Inn', 101, '2019-06-19', 292, NULL),
('Hampton Inn', 101, '2019-06-20', 165, NULL),
('Hampton Inn', 101, '2019-06-21', 204, NULL),
('Hampton Inn', 101, '2019-06-22', 357, NULL),
('Hampton Inn', 101, '2019-06-23', 303, NULL),
('Hampton Inn', 101, '2019-06-24', 352, NULL),
('Hampton Inn', 101, '2019-06-25', 345, NULL),
('Hampton Inn', 101, '2019-06-26', 338, NULL),
('Hampton Inn', 101, '2019-06-27', 283, NULL),
('Hampton Inn', 101, '2019-06-28', 232, NULL),
('Hampton Inn', 101, '2019-06-29', 218, NULL),
('Hampton Inn', 101, '2019-06-30', 321, NULL),
('Hampton Inn', 101, '2019-07-01', 132, NULL),
('Hampton Inn', 101, '2019-07-02', 377, NULL),
('Hampton Inn', 101, '2019-07-03', 104, NULL),
('Hampton Inn', 101, '2019-07-04', 358, NULL),
('Hampton Inn', 101, '2019-07-05', 113, NULL),
('Hampton Inn', 101, '2019-07-06', 339, NULL),
('Hampton Inn', 101, '2019-07-07', 165, NULL),
('Hampton Inn', 101, '2019-07-08', 111, NULL),
('Hampton Inn', 101, '2019-07-09', 103, NULL),
('Hampton Inn', 101, '2019-07-10', 320, NULL),
('Hampton Inn', 101, '2019-07-11', 148, NULL),
('Hampton Inn', 101, '2019-07-12', 274, NULL),
('Hampton Inn', 101, '2019-07-13', 244, NULL),
('Hampton Inn', 101, '2019-07-14', 207, NULL),
('Hampton Inn', 101, '2019-07-15', 178, NULL),
('Hampton Inn', 101, '2019-07-16', 340, NULL),
('Hampton Inn', 101, '2019-07-17', 311, NULL),
('Hampton Inn', 101, '2019-07-18', 139, NULL),
('Hampton Inn', 101, '2019-07-19', 144, NULL),
('Hampton Inn', 101, '2019-07-20', 248, NULL),
('Hampton Inn', 101, '2019-07-21', 273, NULL),
('Hampton Inn', 101, '2019-07-22', 220, NULL),
('Hampton Inn', 101, '2019-07-23', 292, NULL),
('Hampton Inn', 101, '2019-07-24', 243, NULL),
('Hampton Inn', 101, '2019-07-25', 277, NULL),
('Hampton Inn', 101, '2019-07-26', 291, NULL),
('Hampton Inn', 101, '2019-07-27', 208, NULL),
('Hampton Inn', 101, '2019-07-28', 186, NULL),
('Hampton Inn', 101, '2019-07-29', 197, NULL),
('Hampton Inn', 101, '2019-07-30', 285, NULL),
('Hampton Inn', 101, '2019-07-31', 349, NULL),
('Hampton Inn', 101, '2019-08-01', 307, NULL),
('Hampton Inn', 101, '2019-08-02', 186, NULL),
('Hampton Inn', 101, '2019-08-03', 115, NULL),
('Hampton Inn', 101, '2019-08-04', 205, NULL),
('Hampton Inn', 101, '2019-08-05', 135, NULL),
('Hampton Inn', 101, '2019-08-06', 251, NULL),
('Hampton Inn', 101, '2019-08-07', 136, NULL),
('Hampton Inn', 101, '2019-08-08', 239, NULL),
('Hampton Inn', 101, '2019-08-09', 120, NULL),
('Hampton Inn', 101, '2019-08-10', 208, NULL),
('Hampton Inn', 101, '2019-08-11', 220, NULL),
('Hampton Inn', 101, '2019-08-12', 110, NULL),
('Hampton Inn', 101, '2019-08-13', 103, NULL),
('Hampton Inn', 101, '2019-08-14', 348, NULL),
('Hampton Inn', 101, '2019-08-15', 249, NULL),
('Hampton Inn', 101, '2019-08-16', 343, NULL),
('Hampton Inn', 101, '2019-08-17', 174, NULL),
('Hampton Inn', 101, '2019-08-18', 299, NULL),
('Hampton Inn', 101, '2019-08-19', 274, NULL),
('Hampton Inn', 101, '2019-08-20', 299, NULL),
('Hampton Inn', 101, '2019-08-21', 281, NULL),
('Hampton Inn', 101, '2019-08-22', 364, NULL),
('Hampton Inn', 101, '2019-08-23', 236, NULL),
('Hampton Inn', 101, '2019-08-24', 344, NULL),
('Hampton Inn', 101, '2019-08-25', 100, NULL),
('Hampton Inn', 101, '2019-08-26', 213, NULL),
('Hampton Inn', 101, '2019-08-27', 375, NULL),
('Hampton Inn', 101, '2019-08-28', 397, NULL),
('Hampton Inn', 101, '2019-08-29', 118, NULL),
('Hampton Inn', 101, '2019-08-30', 209, NULL),
('Hampton Inn', 101, '2019-08-31', 335, NULL),
('Hampton Inn', 101, '2019-09-01', 349, NULL),
('Hampton Inn', 101, '2019-09-02', 174, NULL),
('Hampton Inn', 101, '2019-09-03', 238, NULL),
('Hampton Inn', 101, '2019-09-04', 107, NULL),
('Hampton Inn', 101, '2019-09-05', 237, NULL),
('Hampton Inn', 101, '2019-09-06', 182, NULL),
('Hampton Inn', 101, '2019-09-07', 396, NULL),
('Hampton Inn', 101, '2019-09-08', 189, NULL),
('Hampton Inn', 101, '2019-09-09', 397, NULL),
('Hampton Inn', 101, '2019-09-10', 354, NULL),
('Hampton Inn', 101, '2019-09-11', 287, NULL),
('Hampton Inn', 101, '2019-09-12', 346, NULL),
('Hampton Inn', 101, '2019-09-13', 214, NULL),
('Hampton Inn', 101, '2019-09-14', 187, NULL),
('Hampton Inn', 101, '2019-09-15', 274, NULL),
('Hampton Inn', 101, '2019-09-16', 370, NULL),
('Hampton Inn', 101, '2019-09-17', 223, NULL),
('Hampton Inn', 101, '2019-09-18', 129, NULL),
('Hampton Inn', 101, '2019-09-19', 274, NULL),
('Hampton Inn', 101, '2019-09-20', 263, NULL),
('Hampton Inn', 101, '2019-09-21', 360, NULL),
('Hampton Inn', 101, '2019-09-22', 283, NULL),
('Hampton Inn', 101, '2019-09-23', 250, NULL),
('Hampton Inn', 101, '2019-09-24', 129, NULL),
('Hampton Inn', 101, '2019-09-25', 121, NULL),
('Hampton Inn', 101, '2019-09-26', 222, NULL),
('Hampton Inn', 101, '2019-09-27', 107, NULL),
('Hampton Inn', 101, '2019-09-28', 378, NULL),
('Hampton Inn', 101, '2019-09-29', 270, NULL),
('Hampton Inn', 101, '2019-09-30', 110, NULL),
('Hampton Inn', 101, '2019-10-01', 370, NULL),
('Hampton Inn', 101, '2019-10-02', 322, NULL),
('Hampton Inn', 101, '2019-10-03', 132, NULL),
('Hampton Inn', 101, '2019-10-04', 367, NULL),
('Hampton Inn', 101, '2019-10-05', 342, NULL),
('Hampton Inn', 101, '2019-10-06', 142, NULL),
('Hampton Inn', 101, '2019-10-07', 221, NULL),
('Hampton Inn', 101, '2019-10-08', 286, NULL),
('Hampton Inn', 101, '2019-10-09', 126, NULL),
('Hampton Inn', 101, '2019-10-10', 152, NULL),
('Hampton Inn', 101, '2019-10-11', 390, NULL),
('Hampton Inn', 101, '2019-10-12', 147, NULL),
('Hampton Inn', 101, '2019-10-13', 256, NULL),
('Hampton Inn', 101, '2019-10-14', 114, NULL),
('Hampton Inn', 101, '2019-10-15', 173, NULL),
('Hampton Inn', 101, '2019-10-16', 321, NULL),
('Hampton Inn', 101, '2019-10-17', 127, NULL),
('Hampton Inn', 101, '2019-10-18', 387, NULL),
('Hampton Inn', 101, '2019-10-19', 137, NULL),
('Hampton Inn', 101, '2019-10-20', 295, NULL),
('Hampton Inn', 101, '2019-10-21', 104, NULL),
('Hampton Inn', 101, '2019-10-22', 168, NULL),
('Hampton Inn', 101, '2019-10-23', 122, NULL),
('Hampton Inn', 101, '2019-10-24', 116, NULL),
('Hampton Inn', 101, '2019-10-25', 387, NULL),
('Hampton Inn', 101, '2019-10-26', 257, NULL),
('Hampton Inn', 101, '2019-10-27', 315, NULL),
('Hampton Inn', 101, '2019-10-28', 241, NULL),
('Hampton Inn', 101, '2019-10-29', 366, NULL),
('Hampton Inn', 101, '2019-10-30', 341, NULL),
('Hampton Inn', 101, '2019-10-31', 372, NULL),
('Hampton Inn', 101, '2019-11-01', 142, NULL),
('Hampton Inn', 101, '2019-11-02', 176, NULL),
('Hampton Inn', 101, '2019-11-03', 341, NULL),
('Hampton Inn', 101, '2019-11-04', 143, NULL),
('Hampton Inn', 101, '2019-11-05', 113, NULL),
('Hampton Inn', 101, '2019-11-06', 273, NULL),
('Hampton Inn', 101, '2019-11-07', 169, NULL),
('Hampton Inn', 101, '2019-11-08', 233, NULL),
('Hampton Inn', 101, '2019-11-09', 102, NULL),
('Hampton Inn', 101, '2019-11-10', 335, NULL),
('Hampton Inn', 101, '2019-11-11', 195, NULL),
('Hampton Inn', 101, '2019-11-12', 327, NULL),
('Hampton Inn', 101, '2019-11-13', 397, NULL),
('Hampton Inn', 101, '2019-11-14', 352, NULL),
('Hampton Inn', 101, '2019-11-15', 278, NULL),
('Hampton Inn', 101, '2019-11-16', 111, NULL),
('Hampton Inn', 101, '2019-11-17', 132, NULL),
('Hampton Inn', 101, '2019-11-18', 221, NULL),
('Hampton Inn', 101, '2019-11-19', 284, NULL),
('Hampton Inn', 101, '2019-11-20', 207, NULL),
('Hampton Inn', 101, '2019-11-21', 282, NULL),
('Hampton Inn', 101, '2019-11-22', 107, NULL),
('Hampton Inn', 101, '2019-11-23', 111, NULL),
('Hampton Inn', 101, '2019-11-24', 222, NULL),
('Hampton Inn', 101, '2019-11-25', 171, NULL),
('Hampton Inn', 101, '2019-11-26', 344, NULL),
('Hampton Inn', 101, '2019-11-27', 215, NULL),
('Hampton Inn', 101, '2019-11-28', 308, NULL),
('Hampton Inn', 101, '2019-11-29', 114, NULL),
('Hampton Inn', 101, '2019-11-30', 353, NULL),
('Hampton Inn', 101, '2019-12-01', 113, NULL),
('Hampton Inn', 101, '2019-12-02', 215, NULL),
('Hampton Inn', 101, '2019-12-03', 167, NULL),
('Hampton Inn', 101, '2019-12-04', 259, NULL),
('Hampton Inn', 101, '2019-12-05', 347, NULL),
('Hampton Inn', 101, '2019-12-06', 337, NULL),
('Hampton Inn', 101, '2019-12-07', 384, NULL),
('Hampton Inn', 101, '2019-12-08', 114, NULL),
('Hampton Inn', 101, '2019-12-09', 378, NULL),
('Hampton Inn', 101, '2019-12-10', 358, NULL),
('Hampton Inn', 101, '2019-12-11', 278, NULL),
('Hampton Inn', 101, '2019-12-12', 305, NULL),
('Hampton Inn', 101, '2019-12-13', 242, NULL),
('Hampton Inn', 101, '2019-12-14', 176, NULL),
('Hampton Inn', 101, '2019-12-15', 147, NULL),
('Hampton Inn', 101, '2019-12-16', 128, NULL),
('Hampton Inn', 101, '2019-12-17', 132, NULL),
('Hampton Inn', 101, '2019-12-18', 287, NULL),
('Hampton Inn', 101, '2019-12-19', 301, NULL),
('Hampton Inn', 101, '2019-12-20', 302, NULL),
('Hampton Inn', 101, '2019-12-21', 317, NULL),
('Hampton Inn', 101, '2019-12-22', 107, NULL),
('Hampton Inn', 101, '2019-12-23', 257, NULL),
('Hampton Inn', 101, '2019-12-24', 371, NULL),
('Hampton Inn', 101, '2019-12-25', 158, NULL),
('Hampton Inn', 101, '2019-12-26', 371, NULL),
('Hampton Inn', 101, '2019-12-27', 143, NULL),
('Hampton Inn', 101, '2019-12-28', 288, NULL),
('Hampton Inn', 101, '2019-12-29', 196, NULL),
('Hampton Inn', 101, '2019-12-30', 370, NULL),
('Hampton Inn', 101, '2019-12-31', 291, NULL),
('Hampton Inn', 101, '2020-01-01', 262, NULL),
('Hampton Inn', 101, '2020-01-02', 371, NULL),
('Hampton Inn', 101, '2020-01-03', 253, NULL),
('Hampton Inn', 101, '2020-01-04', 142, NULL),
('Hampton Inn', 101, '2020-01-05', 215, NULL),
('Hampton Inn', 101, '2020-01-06', 329, NULL),
('Hampton Inn', 101, '2020-01-07', 266, NULL),
('Hampton Inn', 101, '2020-01-08', 106, NULL),
('Hampton Inn', 101, '2020-01-09', 360, NULL),
('Hampton Inn', 101, '2020-01-10', 289, NULL),
('Hampton Inn', 101, '2020-01-11', 279, NULL),
('Hampton Inn', 101, '2020-01-12', 367, NULL),
('Hampton Inn', 101, '2020-01-13', 383, NULL),
('Hampton Inn', 101, '2020-01-14', 243, NULL),
('Hampton Inn', 101, '2020-01-15', 389, NULL),
('Hampton Inn', 101, '2020-01-16', 298, NULL),
('Hampton Inn', 101, '2020-01-17', 200, NULL),
('Hampton Inn', 101, '2020-01-18', 382, NULL),
('Hampton Inn', 101, '2020-01-19', 380, NULL),
('Hampton Inn', 101, '2020-01-20', 278, NULL),
('Hampton Inn', 101, '2020-01-21', 135, NULL),
('Hampton Inn', 101, '2020-01-22', 239, NULL),
('Hampton Inn', 101, '2020-01-23', 198, NULL),
('Hampton Inn', 101, '2020-01-24', 355, NULL),
('Hampton Inn', 101, '2020-01-25', 165, NULL),
('Hampton Inn', 101, '2020-01-26', 132, NULL),
('Hampton Inn', 101, '2020-01-27', 203, NULL),
('Hampton Inn', 101, '2020-01-28', 197, NULL),
('Hampton Inn', 101, '2020-01-29', 179, NULL),
('Hampton Inn', 101, '2020-01-30', 378, NULL),
('Hampton Inn', 101, '2020-01-31', 260, NULL),
('Hampton Inn', 101, '2020-02-01', 247, NULL),
('Hampton Inn', 101, '2020-02-02', 374, NULL),
('Hampton Inn', 101, '2020-02-03', 314, NULL),
('Hampton Inn', 101, '2020-02-04', 249, NULL),
('Hampton Inn', 104, '2019-01-01', 348, NULL),
('Hampton Inn', 104, '2019-01-02', 310, NULL),
('Hampton Inn', 104, '2019-01-03', 354, NULL),
('Hampton Inn', 104, '2019-01-04', 286, NULL),
('Hampton Inn', 104, '2019-01-05', 167, NULL),
('Hampton Inn', 104, '2019-01-06', 369, NULL),
('Hampton Inn', 104, '2019-01-07', 280, NULL),
('Hampton Inn', 104, '2019-01-08', 147, NULL),
('Hampton Inn', 104, '2019-01-09', 330, NULL),
('Hampton Inn', 104, '2019-01-10', 189, NULL),
('Hampton Inn', 104, '2019-01-11', 119, NULL),
('Hampton Inn', 104, '2019-01-12', 192, NULL),
('Hampton Inn', 104, '2019-01-13', 311, NULL),
('Hampton Inn', 104, '2019-01-14', 174, NULL),
('Hampton Inn', 104, '2019-01-15', 296, NULL),
('Hampton Inn', 104, '2019-01-16', 322, NULL),
('Hampton Inn', 104, '2019-01-17', 294, NULL),
('Hampton Inn', 104, '2019-01-18', 201, NULL),
('Hampton Inn', 104, '2019-01-19', 104, NULL),
('Hampton Inn', 104, '2019-01-20', 138, NULL),
('Hampton Inn', 104, '2019-01-21', 256, NULL),
('Hampton Inn', 104, '2019-01-22', 317, NULL),
('Hampton Inn', 104, '2019-01-23', 111, NULL),
('Hampton Inn', 104, '2019-01-24', 368, NULL),
('Hampton Inn', 104, '2019-01-25', 255, NULL),
('Hampton Inn', 104, '2019-01-26', 317, NULL),
('Hampton Inn', 104, '2019-01-27', 317, NULL),
('Hampton Inn', 104, '2019-01-28', 270, NULL),
('Hampton Inn', 104, '2019-01-29', 125, NULL),
('Hampton Inn', 104, '2019-01-30', 332, NULL),
('Hampton Inn', 104, '2019-01-31', 358, NULL),
('Hampton Inn', 104, '2019-02-01', 282, NULL),
('Hampton Inn', 104, '2019-02-02', 192, NULL),
('Hampton Inn', 104, '2019-02-03', 100, NULL),
('Hampton Inn', 104, '2019-02-04', 179, NULL),
('Hampton Inn', 104, '2019-02-05', 295, NULL),
('Hampton Inn', 104, '2019-02-06', 211, NULL),
('Hampton Inn', 104, '2019-02-07', 229, NULL),
('Hampton Inn', 104, '2019-02-08', 153, NULL),
('Hampton Inn', 104, '2019-02-09', 129, NULL),
('Hampton Inn', 104, '2019-02-10', 127, NULL),
('Hampton Inn', 104, '2019-02-11', 210, NULL),
('Hampton Inn', 104, '2019-02-12', 258, NULL),
('Hampton Inn', 104, '2019-02-13', 397, NULL),
('Hampton Inn', 104, '2019-02-14', 255, NULL),
('Hampton Inn', 104, '2019-02-15', 151, NULL),
('Hampton Inn', 104, '2019-02-16', 198, NULL),
('Hampton Inn', 104, '2019-02-17', 101, NULL),
('Hampton Inn', 104, '2019-02-18', 399, NULL),
('Hampton Inn', 104, '2019-02-19', 179, NULL),
('Hampton Inn', 104, '2019-02-20', 190, NULL),
('Hampton Inn', 104, '2019-02-21', 322, NULL),
('Hampton Inn', 104, '2019-02-22', 175, NULL),
('Hampton Inn', 104, '2019-02-23', 170, NULL),
('Hampton Inn', 104, '2019-02-24', 323, NULL),
('Hampton Inn', 104, '2019-02-25', 238, NULL),
('Hampton Inn', 104, '2019-02-26', 285, NULL),
('Hampton Inn', 104, '2019-02-27', 208, NULL),
('Hampton Inn', 104, '2019-02-28', 352, NULL),
('Hampton Inn', 104, '2019-03-01', 133, NULL),
('Hampton Inn', 104, '2019-03-02', 300, NULL),
('Hampton Inn', 104, '2019-03-03', 296, NULL),
('Hampton Inn', 104, '2019-03-04', 232, NULL),
('Hampton Inn', 104, '2019-03-05', 145, NULL),
('Hampton Inn', 104, '2019-03-06', 166, NULL),
('Hampton Inn', 104, '2019-03-07', 351, NULL),
('Hampton Inn', 104, '2019-03-08', 289, NULL),
('Hampton Inn', 104, '2019-03-09', 238, NULL),
('Hampton Inn', 104, '2019-03-10', 322, NULL),
('Hampton Inn', 104, '2019-03-11', 326, NULL),
('Hampton Inn', 104, '2019-03-12', 104, NULL),
('Hampton Inn', 104, '2019-03-13', 205, NULL),
('Hampton Inn', 104, '2019-03-14', 103, NULL),
('Hampton Inn', 104, '2019-03-15', 233, NULL),
('Hampton Inn', 104, '2019-03-16', 357, NULL),
('Hampton Inn', 104, '2019-03-17', 267, NULL),
('Hampton Inn', 104, '2019-03-18', 255, NULL),
('Hampton Inn', 104, '2019-03-19', 139, NULL),
('Hampton Inn', 104, '2019-03-20', 281, NULL),
('Hampton Inn', 104, '2019-03-21', 214, NULL),
('Hampton Inn', 104, '2019-03-22', 271, NULL),
('Hampton Inn', 104, '2019-03-23', 291, NULL),
('Hampton Inn', 104, '2019-03-24', 294, NULL),
('Hampton Inn', 104, '2019-03-25', 202, NULL),
('Hampton Inn', 104, '2019-03-26', 397, NULL),
('Hampton Inn', 104, '2019-03-27', 228, NULL),
('Hampton Inn', 104, '2019-03-28', 124, NULL),
('Hampton Inn', 104, '2019-03-29', 280, NULL),
('Hampton Inn', 104, '2019-03-30', 205, NULL),
('Hampton Inn', 104, '2019-03-31', 218, NULL),
('Hampton Inn', 104, '2019-04-01', 273, NULL),
('Hampton Inn', 104, '2019-04-02', 102, NULL),
('Hampton Inn', 104, '2019-04-03', 151, NULL),
('Hampton Inn', 104, '2019-04-04', 348, NULL),
('Hampton Inn', 104, '2019-04-05', 137, NULL),
('Hampton Inn', 104, '2019-04-06', 133, NULL),
('Hampton Inn', 104, '2019-04-07', 368, NULL),
('Hampton Inn', 104, '2019-04-08', 179, NULL),
('Hampton Inn', 104, '2019-04-09', 294, NULL),
('Hampton Inn', 104, '2019-04-10', 388, NULL),
('Hampton Inn', 104, '2019-04-11', 312, NULL),
('Hampton Inn', 104, '2019-04-12', 104, NULL),
('Hampton Inn', 104, '2019-04-13', 133, NULL),
('Hampton Inn', 104, '2019-04-14', 188, NULL),
('Hampton Inn', 104, '2019-04-15', 129, NULL),
('Hampton Inn', 104, '2019-04-16', 286, NULL),
('Hampton Inn', 104, '2019-04-17', 206, NULL),
('Hampton Inn', 104, '2019-04-18', 179, NULL),
('Hampton Inn', 104, '2019-04-19', 223, NULL),
('Hampton Inn', 104, '2019-04-20', 223, NULL),
('Hampton Inn', 104, '2019-04-21', 130, NULL),
('Hampton Inn', 104, '2019-04-22', 112, NULL),
('Hampton Inn', 104, '2019-04-23', 172, NULL),
('Hampton Inn', 104, '2019-04-24', 391, NULL),
('Hampton Inn', 104, '2019-04-25', 285, NULL),
('Hampton Inn', 104, '2019-04-26', 275, NULL),
('Hampton Inn', 104, '2019-04-27', 287, NULL),
('Hampton Inn', 104, '2019-04-28', 331, NULL),
('Hampton Inn', 104, '2019-04-29', 393, NULL),
('Hampton Inn', 104, '2019-04-30', 270, NULL),
('Hampton Inn', 104, '2019-05-01', 246, NULL),
('Hampton Inn', 104, '2019-05-02', 232, NULL),
('Hampton Inn', 104, '2019-05-03', 272, NULL),
('Hampton Inn', 104, '2019-05-04', 104, NULL),
('Hampton Inn', 104, '2019-05-05', 318, NULL),
('Hampton Inn', 104, '2019-05-06', 293, NULL),
('Hampton Inn', 104, '2019-05-07', 137, NULL),
('Hampton Inn', 104, '2019-05-08', 287, NULL),
('Hampton Inn', 104, '2019-05-09', 182, NULL),
('Hampton Inn', 104, '2019-05-10', 171, NULL),
('Hampton Inn', 104, '2019-05-11', 186, NULL),
('Hampton Inn', 104, '2019-05-12', 140, NULL),
('Hampton Inn', 104, '2019-05-13', 132, NULL),
('Hampton Inn', 104, '2019-05-14', 379, NULL),
('Hampton Inn', 104, '2019-05-15', 392, NULL),
('Hampton Inn', 104, '2019-05-16', 265, NULL),
('Hampton Inn', 104, '2019-05-17', 263, NULL),
('Hampton Inn', 104, '2019-05-18', 160, NULL),
('Hampton Inn', 104, '2019-05-19', 357, NULL),
('Hampton Inn', 104, '2019-05-20', 102, NULL),
('Hampton Inn', 104, '2019-05-21', 343, NULL),
('Hampton Inn', 104, '2019-05-22', 336, NULL),
('Hampton Inn', 104, '2019-05-23', 221, NULL),
('Hampton Inn', 104, '2019-05-24', 108, NULL),
('Hampton Inn', 104, '2019-05-25', 386, NULL),
('Hampton Inn', 104, '2019-05-26', 345, NULL),
('Hampton Inn', 104, '2019-05-27', 271, NULL),
('Hampton Inn', 104, '2019-05-28', 180, NULL),
('Hampton Inn', 104, '2019-05-29', 161, NULL),
('Hampton Inn', 104, '2019-05-30', 239, NULL),
('Hampton Inn', 104, '2019-05-31', 255, NULL),
('Hampton Inn', 104, '2019-06-01', 160, NULL),
('Hampton Inn', 104, '2019-06-02', 387, NULL),
('Hampton Inn', 104, '2019-06-03', 383, NULL),
('Hampton Inn', 104, '2019-06-04', 341, NULL),
('Hampton Inn', 104, '2019-06-05', 289, NULL),
('Hampton Inn', 104, '2019-06-06', 101, NULL),
('Hampton Inn', 104, '2019-06-07', 206, NULL),
('Hampton Inn', 104, '2019-06-08', 284, NULL),
('Hampton Inn', 104, '2019-06-09', 297, NULL),
('Hampton Inn', 104, '2019-06-10', 297, NULL),
('Hampton Inn', 104, '2019-06-11', 322, NULL),
('Hampton Inn', 104, '2019-06-12', 292, NULL),
('Hampton Inn', 104, '2019-06-13', 290, NULL),
('Hampton Inn', 104, '2019-06-14', 290, NULL),
('Hampton Inn', 104, '2019-06-15', 270, NULL),
('Hampton Inn', 104, '2019-06-16', 141, NULL),
('Hampton Inn', 104, '2019-06-17', 385, NULL),
('Hampton Inn', 104, '2019-06-18', 143, NULL),
('Hampton Inn', 104, '2019-06-19', 184, NULL),
('Hampton Inn', 104, '2019-06-20', 261, NULL),
('Hampton Inn', 104, '2019-06-21', 257, NULL),
('Hampton Inn', 104, '2019-06-22', 364, NULL),
('Hampton Inn', 104, '2019-06-23', 131, NULL),
('Hampton Inn', 104, '2019-06-24', 333, NULL),
('Hampton Inn', 104, '2019-06-25', 339, NULL),
('Hampton Inn', 104, '2019-06-26', 371, NULL),
('Hampton Inn', 104, '2019-06-27', 150, NULL),
('Hampton Inn', 104, '2019-06-28', 139, NULL),
('Hampton Inn', 104, '2019-06-29', 194, NULL),
('Hampton Inn', 104, '2019-06-30', 208, NULL),
('Hampton Inn', 104, '2019-07-01', 163, NULL),
('Hampton Inn', 104, '2019-07-02', 222, NULL),
('Hampton Inn', 104, '2019-07-03', 300, NULL),
('Hampton Inn', 104, '2019-07-04', 327, NULL),
('Hampton Inn', 104, '2019-07-05', 211, NULL),
('Hampton Inn', 104, '2019-07-06', 263, NULL),
('Hampton Inn', 104, '2019-07-07', 221, NULL),
('Hampton Inn', 104, '2019-07-08', 208, NULL),
('Hampton Inn', 104, '2019-07-09', 334, NULL),
('Hampton Inn', 104, '2019-07-10', 371, NULL),
('Hampton Inn', 104, '2019-07-11', 249, NULL),
('Hampton Inn', 104, '2019-07-12', 289, NULL),
('Hampton Inn', 104, '2019-07-13', 181, NULL),
('Hampton Inn', 104, '2019-07-14', 112, NULL),
('Hampton Inn', 104, '2019-07-15', 377, NULL),
('Hampton Inn', 104, '2019-07-16', 324, NULL),
('Hampton Inn', 104, '2019-07-17', 332, NULL),
('Hampton Inn', 104, '2019-07-18', 266, NULL),
('Hampton Inn', 104, '2019-07-19', 379, NULL),
('Hampton Inn', 104, '2019-07-20', 207, NULL),
('Hampton Inn', 104, '2019-07-21', 371, NULL),
('Hampton Inn', 104, '2019-07-22', 324, NULL),
('Hampton Inn', 104, '2019-07-23', 202, NULL),
('Hampton Inn', 104, '2019-07-24', 129, NULL),
('Hampton Inn', 104, '2019-07-25', 146, NULL),
('Hampton Inn', 104, '2019-07-26', 226, NULL),
('Hampton Inn', 104, '2019-07-27', 262, NULL),
('Hampton Inn', 104, '2019-07-28', 205, NULL),
('Hampton Inn', 104, '2019-07-29', 198, NULL),
('Hampton Inn', 104, '2019-07-30', 210, NULL),
('Hampton Inn', 104, '2019-07-31', 185, NULL),
('Hampton Inn', 104, '2019-08-01', 280, NULL),
('Hampton Inn', 104, '2019-08-02', 312, NULL),
('Hampton Inn', 104, '2019-08-03', 159, NULL),
('Hampton Inn', 104, '2019-08-04', 183, NULL),
('Hampton Inn', 104, '2019-08-05', 143, NULL),
('Hampton Inn', 104, '2019-08-06', 324, NULL),
('Hampton Inn', 104, '2019-08-07', 359, NULL),
('Hampton Inn', 104, '2019-08-08', 235, NULL),
('Hampton Inn', 104, '2019-08-09', 230, NULL),
('Hampton Inn', 104, '2019-08-10', 231, NULL),
('Hampton Inn', 104, '2019-08-11', 364, NULL),
('Hampton Inn', 104, '2019-08-12', 155, NULL),
('Hampton Inn', 104, '2019-08-13', 158, NULL),
('Hampton Inn', 104, '2019-08-14', 297, NULL),
('Hampton Inn', 104, '2019-08-15', 216, NULL),
('Hampton Inn', 104, '2019-08-16', 354, NULL),
('Hampton Inn', 104, '2019-08-17', 263, NULL),
('Hampton Inn', 104, '2019-08-18', 200, NULL),
('Hampton Inn', 104, '2019-08-19', 178, NULL),
('Hampton Inn', 104, '2019-08-20', 343, NULL),
('Hampton Inn', 104, '2019-08-21', 108, NULL),
('Hampton Inn', 104, '2019-08-22', 157, NULL),
('Hampton Inn', 104, '2019-08-23', 128, NULL),
('Hampton Inn', 104, '2019-08-24', 249, NULL),
('Hampton Inn', 104, '2019-08-25', 171, NULL),
('Hampton Inn', 104, '2019-08-26', 171, NULL),
('Hampton Inn', 104, '2019-08-27', 134, NULL),
('Hampton Inn', 104, '2019-08-28', 385, NULL),
('Hampton Inn', 104, '2019-08-29', 119, NULL),
('Hampton Inn', 104, '2019-08-30', 236, NULL),
('Hampton Inn', 104, '2019-08-31', 269, NULL),
('Hampton Inn', 104, '2019-09-01', 185, NULL),
('Hampton Inn', 104, '2019-09-02', 152, NULL),
('Hampton Inn', 104, '2019-09-03', 234, NULL),
('Hampton Inn', 104, '2019-09-04', 183, NULL),
('Hampton Inn', 104, '2019-09-05', 399, NULL),
('Hampton Inn', 104, '2019-09-06', 317, NULL),
('Hampton Inn', 104, '2019-09-07', 195, NULL),
('Hampton Inn', 104, '2019-09-08', 137, NULL),
('Hampton Inn', 104, '2019-09-09', 120, NULL),
('Hampton Inn', 104, '2019-09-10', 126, NULL),
('Hampton Inn', 104, '2019-09-11', 337, NULL),
('Hampton Inn', 104, '2019-09-12', 191, NULL),
('Hampton Inn', 104, '2019-09-13', 316, NULL),
('Hampton Inn', 104, '2019-09-14', 286, NULL),
('Hampton Inn', 104, '2019-09-15', 107, NULL),
('Hampton Inn', 104, '2019-09-16', 214, NULL),
('Hampton Inn', 104, '2019-09-17', 363, NULL),
('Hampton Inn', 104, '2019-09-18', 224, NULL),
('Hampton Inn', 104, '2019-09-19', 333, NULL),
('Hampton Inn', 104, '2019-09-20', 153, NULL),
('Hampton Inn', 104, '2019-09-21', 232, NULL),
('Hampton Inn', 104, '2019-09-22', 206, NULL),
('Hampton Inn', 104, '2019-09-23', 198, NULL),
('Hampton Inn', 104, '2019-09-24', 181, NULL),
('Hampton Inn', 104, '2019-09-25', 113, NULL),
('Hampton Inn', 104, '2019-09-26', 311, NULL),
('Hampton Inn', 104, '2019-09-27', 297, NULL),
('Hampton Inn', 104, '2019-09-28', 104, NULL),
('Hampton Inn', 104, '2019-09-29', 247, NULL),
('Hampton Inn', 104, '2019-09-30', 173, NULL),
('Hampton Inn', 104, '2019-10-01', 321, NULL),
('Hampton Inn', 104, '2019-10-02', 381, NULL),
('Hampton Inn', 104, '2019-10-03', 100, NULL),
('Hampton Inn', 104, '2019-10-04', 258, NULL),
('Hampton Inn', 104, '2019-10-05', 155, NULL),
('Hampton Inn', 104, '2019-10-06', 269, NULL),
('Hampton Inn', 104, '2019-10-07', 214, NULL),
('Hampton Inn', 104, '2019-10-08', 128, NULL),
('Hampton Inn', 104, '2019-10-09', 188, NULL),
('Hampton Inn', 104, '2019-10-10', 333, NULL),
('Hampton Inn', 104, '2019-10-11', 189, NULL),
('Hampton Inn', 104, '2019-10-12', 353, NULL),
('Hampton Inn', 104, '2019-10-13', 256, NULL),
('Hampton Inn', 104, '2019-10-14', 156, NULL),
('Hampton Inn', 104, '2019-10-15', 395, NULL),
('Hampton Inn', 104, '2019-10-16', 115, NULL),
('Hampton Inn', 104, '2019-10-17', 190, NULL),
('Hampton Inn', 104, '2019-10-18', 308, NULL),
('Hampton Inn', 104, '2019-10-19', 374, NULL),
('Hampton Inn', 104, '2019-10-20', 141, NULL),
('Hampton Inn', 104, '2019-10-21', 163, NULL),
('Hampton Inn', 104, '2019-10-22', 387, NULL),
('Hampton Inn', 104, '2019-10-23', 307, NULL),
('Hampton Inn', 104, '2019-10-24', 238, NULL),
('Hampton Inn', 104, '2019-10-25', 324, NULL),
('Hampton Inn', 104, '2019-10-26', 125, NULL),
('Hampton Inn', 104, '2019-10-27', 354, NULL),
('Hampton Inn', 104, '2019-10-28', 113, NULL),
('Hampton Inn', 104, '2019-10-29', 378, NULL),
('Hampton Inn', 104, '2019-10-30', 367, NULL),
('Hampton Inn', 104, '2019-10-31', 111, NULL),
('Hampton Inn', 104, '2019-11-01', 370, NULL),
('Hampton Inn', 104, '2019-11-02', 320, NULL),
('Hampton Inn', 104, '2019-11-03', 159, NULL),
('Hampton Inn', 104, '2019-11-04', 167, NULL),
('Hampton Inn', 104, '2019-11-05', 333, NULL),
('Hampton Inn', 104, '2019-11-06', 265, NULL),
('Hampton Inn', 104, '2019-11-07', 234, NULL),
('Hampton Inn', 104, '2019-11-08', 283, NULL),
('Hampton Inn', 104, '2019-11-09', 395, NULL),
('Hampton Inn', 104, '2019-11-10', 115, NULL),
('Hampton Inn', 104, '2019-11-11', 106, NULL),
('Hampton Inn', 104, '2019-11-12', 293, NULL),
('Hampton Inn', 104, '2019-11-13', 123, NULL),
('Hampton Inn', 104, '2019-11-14', 147, NULL),
('Hampton Inn', 104, '2019-11-15', 164, NULL),
('Hampton Inn', 104, '2019-11-16', 362, NULL),
('Hampton Inn', 104, '2019-11-17', 377, NULL),
('Hampton Inn', 104, '2019-11-18', 100, NULL),
('Hampton Inn', 104, '2019-11-19', 243, NULL),
('Hampton Inn', 104, '2019-11-20', 398, NULL),
('Hampton Inn', 104, '2019-11-21', 183, NULL),
('Hampton Inn', 104, '2019-11-22', 263, NULL),
('Hampton Inn', 104, '2019-11-23', 251, NULL),
('Hampton Inn', 104, '2019-11-24', 196, NULL),
('Hampton Inn', 104, '2019-11-25', 214, NULL),
('Hampton Inn', 104, '2019-11-26', 344, NULL),
('Hampton Inn', 104, '2019-11-27', 258, NULL),
('Hampton Inn', 104, '2019-11-28', 281, NULL),
('Hampton Inn', 104, '2019-11-29', 307, NULL),
('Hampton Inn', 104, '2019-11-30', 270, NULL),
('Hampton Inn', 104, '2019-12-01', 186, NULL),
('Hampton Inn', 104, '2019-12-02', 326, NULL),
('Hampton Inn', 104, '2019-12-03', 331, NULL),
('Hampton Inn', 104, '2019-12-04', 171, NULL),
('Hampton Inn', 104, '2019-12-05', 368, NULL),
('Hampton Inn', 104, '2019-12-06', 320, NULL),
('Hampton Inn', 104, '2019-12-07', 182, NULL),
('Hampton Inn', 104, '2019-12-08', 127, NULL),
('Hampton Inn', 104, '2019-12-09', 345, NULL),
('Hampton Inn', 104, '2019-12-10', 105, NULL),
('Hampton Inn', 104, '2019-12-11', 133, NULL),
('Hampton Inn', 104, '2019-12-12', 252, NULL),
('Hampton Inn', 104, '2019-12-13', 229, NULL),
('Hampton Inn', 104, '2019-12-14', 226, NULL),
('Hampton Inn', 104, '2019-12-15', 250, NULL),
('Hampton Inn', 104, '2019-12-16', 381, NULL),
('Hampton Inn', 104, '2019-12-17', 182, NULL),
('Hampton Inn', 104, '2019-12-18', 144, NULL),
('Hampton Inn', 104, '2019-12-19', 197, NULL),
('Hampton Inn', 104, '2019-12-20', 219, NULL),
('Hampton Inn', 104, '2019-12-21', 163, NULL),
('Hampton Inn', 104, '2019-12-22', 170, NULL),
('Hampton Inn', 104, '2019-12-23', 349, NULL),
('Hampton Inn', 104, '2019-12-24', 294, NULL),
('Hampton Inn', 104, '2019-12-25', 283, NULL),
('Hampton Inn', 104, '2019-12-26', 180, NULL),
('Hampton Inn', 104, '2019-12-27', 359, NULL),
('Hampton Inn', 104, '2019-12-28', 320, NULL),
('Hampton Inn', 104, '2019-12-29', 281, NULL),
('Hampton Inn', 104, '2019-12-30', 307, NULL),
('Hampton Inn', 104, '2019-12-31', 312, NULL),
('Hampton Inn', 104, '2020-01-01', 384, NULL),
('Hampton Inn', 104, '2020-01-02', 281, NULL),
('Hampton Inn', 104, '2020-01-03', 395, NULL),
('Hampton Inn', 104, '2020-01-04', 105, NULL),
('Hampton Inn', 104, '2020-01-05', 115, NULL),
('Hampton Inn', 104, '2020-01-06', 330, NULL),
('Hampton Inn', 104, '2020-01-07', 136, NULL),
('Hampton Inn', 104, '2020-01-08', 377, NULL),
('Hampton Inn', 104, '2020-01-09', 350, NULL),
('Hampton Inn', 104, '2020-01-10', 200, NULL),
('Hampton Inn', 104, '2020-01-11', 335, NULL),
('Hampton Inn', 104, '2020-01-12', 227, NULL),
('Hampton Inn', 104, '2020-01-13', 271, NULL),
('Hampton Inn', 104, '2020-01-14', 198, NULL),
('Hampton Inn', 104, '2020-01-15', 184, NULL),
('Hampton Inn', 104, '2020-01-16', 345, NULL),
('Hampton Inn', 104, '2020-01-17', 102, NULL),
('Hampton Inn', 104, '2020-01-18', 345, NULL),
('Hampton Inn', 104, '2020-01-19', 374, NULL),
('Hampton Inn', 104, '2020-01-20', 187, NULL),
('Hampton Inn', 104, '2020-01-21', 293, NULL),
('Hampton Inn', 104, '2020-01-22', 179, NULL),
('Hampton Inn', 104, '2020-01-23', 325, NULL),
('Hampton Inn', 104, '2020-01-24', 259, NULL),
('Hampton Inn', 104, '2020-01-25', 248, NULL),
('Hampton Inn', 104, '2020-01-26', 277, NULL),
('Hampton Inn', 104, '2020-01-27', 306, NULL),
('Hampton Inn', 104, '2020-01-28', 351, NULL),
('Hampton Inn', 104, '2020-01-29', 272, NULL),
('Hampton Inn', 104, '2020-01-30', 346, NULL),
('Hampton Inn', 104, '2020-01-31', 373, NULL),
('Hampton Inn', 104, '2020-02-01', 251, NULL),
('Hampton Inn', 104, '2020-02-02', 387, NULL),
('Hampton Inn', 104, '2020-02-03', 125, NULL),
('Hampton Inn', 104, '2020-02-04', 216, NULL),
('Hampton Inn', 115, '2019-01-01', 155, NULL),
('Hampton Inn', 115, '2019-01-02', 119, NULL),
('Hampton Inn', 115, '2019-01-03', 298, NULL),
('Hampton Inn', 115, '2019-01-04', 392, NULL),
('Hampton Inn', 115, '2019-01-05', 311, NULL),
('Hampton Inn', 115, '2019-01-06', 252, NULL),
('Hampton Inn', 115, '2019-01-07', 217, NULL),
('Hampton Inn', 115, '2019-01-08', 276, NULL),
('Hampton Inn', 115, '2019-01-09', 316, NULL),
('Hampton Inn', 115, '2019-01-10', 379, NULL),
('Hampton Inn', 115, '2019-01-11', 271, NULL),
('Hampton Inn', 115, '2019-01-12', 308, NULL),
('Hampton Inn', 115, '2019-01-13', 121, NULL),
('Hampton Inn', 115, '2019-01-14', 328, NULL),
('Hampton Inn', 115, '2019-01-15', 136, NULL),
('Hampton Inn', 115, '2019-01-16', 338, NULL),
('Hampton Inn', 115, '2019-01-17', 301, NULL),
('Hampton Inn', 115, '2019-01-18', 179, NULL),
('Hampton Inn', 115, '2019-01-19', 217, NULL),
('Hampton Inn', 115, '2019-01-20', 112, NULL),
('Hampton Inn', 115, '2019-01-21', 327, NULL),
('Hampton Inn', 115, '2019-01-22', 357, NULL),
('Hampton Inn', 115, '2019-01-23', 277, NULL),
('Hampton Inn', 115, '2019-01-24', 310, NULL),
('Hampton Inn', 115, '2019-01-25', 187, NULL),
('Hampton Inn', 115, '2019-01-26', 224, NULL),
('Hampton Inn', 115, '2019-01-27', 178, NULL),
('Hampton Inn', 115, '2019-01-28', 370, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 115, '2019-01-29', 305, NULL),
('Hampton Inn', 115, '2019-01-30', 145, NULL),
('Hampton Inn', 115, '2019-01-31', 143, NULL),
('Hampton Inn', 115, '2019-02-01', 241, NULL),
('Hampton Inn', 115, '2019-02-02', 381, NULL),
('Hampton Inn', 115, '2019-02-03', 333, NULL),
('Hampton Inn', 115, '2019-02-04', 381, NULL),
('Hampton Inn', 115, '2019-02-05', 166, NULL),
('Hampton Inn', 115, '2019-02-06', 357, NULL),
('Hampton Inn', 115, '2019-02-07', 384, NULL),
('Hampton Inn', 115, '2019-02-08', 209, NULL),
('Hampton Inn', 115, '2019-02-09', 147, NULL),
('Hampton Inn', 115, '2019-02-10', 182, NULL),
('Hampton Inn', 115, '2019-02-11', 208, NULL),
('Hampton Inn', 115, '2019-02-12', 364, NULL),
('Hampton Inn', 115, '2019-02-13', 210, NULL),
('Hampton Inn', 115, '2019-02-14', 228, NULL),
('Hampton Inn', 115, '2019-02-15', 371, NULL),
('Hampton Inn', 115, '2019-02-16', 133, NULL),
('Hampton Inn', 115, '2019-02-17', 189, NULL),
('Hampton Inn', 115, '2019-02-18', 302, NULL),
('Hampton Inn', 115, '2019-02-19', 172, NULL),
('Hampton Inn', 115, '2019-02-20', 299, NULL),
('Hampton Inn', 115, '2019-02-21', 123, NULL),
('Hampton Inn', 115, '2019-02-22', 302, NULL),
('Hampton Inn', 115, '2019-02-23', 201, NULL),
('Hampton Inn', 115, '2019-02-24', 393, NULL),
('Hampton Inn', 115, '2019-02-25', 348, NULL),
('Hampton Inn', 115, '2019-02-26', 134, NULL),
('Hampton Inn', 115, '2019-02-27', 311, NULL),
('Hampton Inn', 115, '2019-02-28', 116, NULL),
('Hampton Inn', 115, '2019-03-01', 186, NULL),
('Hampton Inn', 115, '2019-03-02', 392, NULL),
('Hampton Inn', 115, '2019-03-03', 290, NULL),
('Hampton Inn', 115, '2019-03-04', 356, NULL),
('Hampton Inn', 115, '2019-03-05', 291, NULL),
('Hampton Inn', 115, '2019-03-06', 292, NULL),
('Hampton Inn', 115, '2019-03-07', 164, NULL),
('Hampton Inn', 115, '2019-03-08', 193, NULL),
('Hampton Inn', 115, '2019-03-09', 172, NULL),
('Hampton Inn', 115, '2019-03-10', 200, NULL),
('Hampton Inn', 115, '2019-03-11', 344, NULL),
('Hampton Inn', 115, '2019-03-12', 134, NULL),
('Hampton Inn', 115, '2019-03-13', 222, NULL),
('Hampton Inn', 115, '2019-03-14', 130, NULL),
('Hampton Inn', 115, '2019-03-15', 331, NULL),
('Hampton Inn', 115, '2019-03-16', 363, NULL),
('Hampton Inn', 115, '2019-03-17', 331, NULL),
('Hampton Inn', 115, '2019-03-18', 301, NULL),
('Hampton Inn', 115, '2019-03-19', 210, NULL),
('Hampton Inn', 115, '2019-03-20', 103, NULL),
('Hampton Inn', 115, '2019-03-21', 106, NULL),
('Hampton Inn', 115, '2019-03-22', 132, NULL),
('Hampton Inn', 115, '2019-03-23', 362, NULL),
('Hampton Inn', 115, '2019-03-24', 381, NULL),
('Hampton Inn', 115, '2019-03-25', 121, NULL),
('Hampton Inn', 115, '2019-03-26', 245, NULL),
('Hampton Inn', 115, '2019-03-27', 101, NULL),
('Hampton Inn', 115, '2019-03-28', 217, NULL),
('Hampton Inn', 115, '2019-03-29', 397, NULL),
('Hampton Inn', 115, '2019-03-30', 300, NULL),
('Hampton Inn', 115, '2019-03-31', 210, NULL),
('Hampton Inn', 115, '2019-04-01', 181, NULL),
('Hampton Inn', 115, '2019-04-02', 210, NULL),
('Hampton Inn', 115, '2019-04-03', 110, NULL),
('Hampton Inn', 115, '2019-04-04', 223, NULL),
('Hampton Inn', 115, '2019-04-05', 185, NULL),
('Hampton Inn', 115, '2019-04-06', 148, NULL),
('Hampton Inn', 115, '2019-04-07', 389, NULL),
('Hampton Inn', 115, '2019-04-08', 306, NULL),
('Hampton Inn', 115, '2019-04-09', 343, NULL),
('Hampton Inn', 115, '2019-04-10', 137, NULL),
('Hampton Inn', 115, '2019-04-11', 361, NULL),
('Hampton Inn', 115, '2019-04-12', 354, NULL),
('Hampton Inn', 115, '2019-04-13', 313, NULL),
('Hampton Inn', 115, '2019-04-14', 184, NULL),
('Hampton Inn', 115, '2019-04-15', 297, NULL),
('Hampton Inn', 115, '2019-04-16', 107, NULL),
('Hampton Inn', 115, '2019-04-17', 211, NULL),
('Hampton Inn', 115, '2019-04-18', 238, NULL),
('Hampton Inn', 115, '2019-04-19', 152, NULL),
('Hampton Inn', 115, '2019-04-20', 141, NULL),
('Hampton Inn', 115, '2019-04-21', 350, NULL),
('Hampton Inn', 115, '2019-04-22', 300, NULL),
('Hampton Inn', 115, '2019-04-23', 253, NULL),
('Hampton Inn', 115, '2019-04-24', 367, NULL),
('Hampton Inn', 115, '2019-04-25', 355, NULL),
('Hampton Inn', 115, '2019-04-26', 159, NULL),
('Hampton Inn', 115, '2019-04-27', 107, NULL),
('Hampton Inn', 115, '2019-04-28', 161, NULL),
('Hampton Inn', 115, '2019-04-29', 363, NULL),
('Hampton Inn', 115, '2019-04-30', 274, NULL),
('Hampton Inn', 115, '2019-05-01', 367, NULL),
('Hampton Inn', 115, '2019-05-02', 246, NULL),
('Hampton Inn', 115, '2019-05-03', 126, NULL),
('Hampton Inn', 115, '2019-05-04', 368, NULL),
('Hampton Inn', 115, '2019-05-05', 304, NULL),
('Hampton Inn', 115, '2019-05-06', 371, NULL),
('Hampton Inn', 115, '2019-05-07', 325, NULL),
('Hampton Inn', 115, '2019-05-08', 260, NULL),
('Hampton Inn', 115, '2019-05-09', 286, NULL),
('Hampton Inn', 115, '2019-05-10', 173, NULL),
('Hampton Inn', 115, '2019-05-11', 293, NULL),
('Hampton Inn', 115, '2019-05-12', 351, NULL),
('Hampton Inn', 115, '2019-05-13', 358, NULL),
('Hampton Inn', 115, '2019-05-14', 342, NULL),
('Hampton Inn', 115, '2019-05-15', 157, NULL),
('Hampton Inn', 115, '2019-05-16', 276, NULL),
('Hampton Inn', 115, '2019-05-17', 341, NULL),
('Hampton Inn', 115, '2019-05-18', 350, NULL),
('Hampton Inn', 115, '2019-05-19', 194, NULL),
('Hampton Inn', 115, '2019-05-20', 339, NULL),
('Hampton Inn', 115, '2019-05-21', 154, NULL),
('Hampton Inn', 115, '2019-05-22', 286, NULL),
('Hampton Inn', 115, '2019-05-23', 293, NULL),
('Hampton Inn', 115, '2019-05-24', 297, NULL),
('Hampton Inn', 115, '2019-05-25', 376, NULL),
('Hampton Inn', 115, '2019-05-26', 136, NULL),
('Hampton Inn', 115, '2019-05-27', 241, NULL),
('Hampton Inn', 115, '2019-05-28', 278, NULL),
('Hampton Inn', 115, '2019-05-29', 368, NULL),
('Hampton Inn', 115, '2019-05-30', 122, NULL),
('Hampton Inn', 115, '2019-05-31', 320, NULL),
('Hampton Inn', 115, '2019-06-01', 358, NULL),
('Hampton Inn', 115, '2019-06-02', 276, NULL),
('Hampton Inn', 115, '2019-06-03', 107, NULL),
('Hampton Inn', 115, '2019-06-04', 168, NULL),
('Hampton Inn', 115, '2019-06-05', 128, NULL),
('Hampton Inn', 115, '2019-06-06', 371, NULL),
('Hampton Inn', 115, '2019-06-07', 374, NULL),
('Hampton Inn', 115, '2019-06-08', 146, NULL),
('Hampton Inn', 115, '2019-06-09', 128, NULL),
('Hampton Inn', 115, '2019-06-10', 137, NULL),
('Hampton Inn', 115, '2019-06-11', 221, NULL),
('Hampton Inn', 115, '2019-06-12', 212, NULL),
('Hampton Inn', 115, '2019-06-13', 271, NULL),
('Hampton Inn', 115, '2019-06-14', 344, NULL),
('Hampton Inn', 115, '2019-06-15', 380, NULL),
('Hampton Inn', 115, '2019-06-16', 309, NULL),
('Hampton Inn', 115, '2019-06-17', 336, NULL),
('Hampton Inn', 115, '2019-06-18', 235, NULL),
('Hampton Inn', 115, '2019-06-19', 247, NULL),
('Hampton Inn', 115, '2019-06-20', 112, NULL),
('Hampton Inn', 115, '2019-06-21', 274, NULL),
('Hampton Inn', 115, '2019-06-22', 350, NULL),
('Hampton Inn', 115, '2019-06-23', 243, NULL),
('Hampton Inn', 115, '2019-06-24', 208, NULL),
('Hampton Inn', 115, '2019-06-25', 260, NULL),
('Hampton Inn', 115, '2019-06-26', 140, NULL),
('Hampton Inn', 115, '2019-06-27', 101, NULL),
('Hampton Inn', 115, '2019-06-28', 198, NULL),
('Hampton Inn', 115, '2019-06-29', 218, NULL),
('Hampton Inn', 115, '2019-06-30', 279, NULL),
('Hampton Inn', 115, '2019-07-01', 320, NULL),
('Hampton Inn', 115, '2019-07-02', 181, NULL),
('Hampton Inn', 115, '2019-07-03', 189, NULL),
('Hampton Inn', 115, '2019-07-04', 162, NULL),
('Hampton Inn', 115, '2019-07-05', 315, NULL),
('Hampton Inn', 115, '2019-07-06', 199, NULL),
('Hampton Inn', 115, '2019-07-07', 210, NULL),
('Hampton Inn', 115, '2019-07-08', 310, NULL),
('Hampton Inn', 115, '2019-07-09', 360, NULL),
('Hampton Inn', 115, '2019-07-10', 197, NULL),
('Hampton Inn', 115, '2019-07-11', 100, NULL),
('Hampton Inn', 115, '2019-07-12', 224, NULL),
('Hampton Inn', 115, '2019-07-13', 374, NULL),
('Hampton Inn', 115, '2019-07-14', 137, NULL),
('Hampton Inn', 115, '2019-07-15', 348, NULL),
('Hampton Inn', 115, '2019-07-16', 200, NULL),
('Hampton Inn', 115, '2019-07-17', 324, NULL),
('Hampton Inn', 115, '2019-07-18', 213, NULL),
('Hampton Inn', 115, '2019-07-19', 163, NULL),
('Hampton Inn', 115, '2019-07-20', 193, NULL),
('Hampton Inn', 115, '2019-07-21', 338, NULL),
('Hampton Inn', 115, '2019-07-22', 262, NULL),
('Hampton Inn', 115, '2019-07-23', 337, NULL),
('Hampton Inn', 115, '2019-07-24', 115, NULL),
('Hampton Inn', 115, '2019-07-25', 100, NULL),
('Hampton Inn', 115, '2019-07-26', 154, NULL),
('Hampton Inn', 115, '2019-07-27', 289, NULL),
('Hampton Inn', 115, '2019-07-28', 368, NULL),
('Hampton Inn', 115, '2019-07-29', 297, NULL),
('Hampton Inn', 115, '2019-07-30', 397, NULL),
('Hampton Inn', 115, '2019-07-31', 378, NULL),
('Hampton Inn', 115, '2019-08-01', 379, NULL),
('Hampton Inn', 115, '2019-08-02', 304, NULL),
('Hampton Inn', 115, '2019-08-03', 352, NULL),
('Hampton Inn', 115, '2019-08-04', 201, NULL),
('Hampton Inn', 115, '2019-08-05', 208, NULL),
('Hampton Inn', 115, '2019-08-06', 168, NULL),
('Hampton Inn', 115, '2019-08-07', 385, NULL),
('Hampton Inn', 115, '2019-08-08', 358, NULL),
('Hampton Inn', 115, '2019-08-09', 391, NULL),
('Hampton Inn', 115, '2019-08-10', 132, NULL),
('Hampton Inn', 115, '2019-08-11', 161, NULL),
('Hampton Inn', 115, '2019-08-12', 345, NULL),
('Hampton Inn', 115, '2019-08-13', 380, NULL),
('Hampton Inn', 115, '2019-08-14', 344, NULL),
('Hampton Inn', 115, '2019-08-15', 232, NULL),
('Hampton Inn', 115, '2019-08-16', 341, NULL),
('Hampton Inn', 115, '2019-08-17', 393, NULL),
('Hampton Inn', 115, '2019-08-18', 302, NULL),
('Hampton Inn', 115, '2019-08-19', 269, NULL),
('Hampton Inn', 115, '2019-08-20', 117, NULL),
('Hampton Inn', 115, '2019-08-21', 198, NULL),
('Hampton Inn', 115, '2019-08-22', 193, NULL),
('Hampton Inn', 115, '2019-08-23', 133, NULL),
('Hampton Inn', 115, '2019-08-24', 111, NULL),
('Hampton Inn', 115, '2019-08-25', 156, NULL),
('Hampton Inn', 115, '2019-08-26', 116, NULL),
('Hampton Inn', 115, '2019-08-27', 343, NULL),
('Hampton Inn', 115, '2019-08-28', 336, NULL),
('Hampton Inn', 115, '2019-08-29', 138, NULL),
('Hampton Inn', 115, '2019-08-30', 151, NULL),
('Hampton Inn', 115, '2019-08-31', 241, NULL),
('Hampton Inn', 115, '2019-09-01', 379, NULL),
('Hampton Inn', 115, '2019-09-02', 140, NULL),
('Hampton Inn', 115, '2019-09-03', 359, NULL),
('Hampton Inn', 115, '2019-09-04', 193, NULL),
('Hampton Inn', 115, '2019-09-05', 282, NULL),
('Hampton Inn', 115, '2019-09-06', 342, NULL),
('Hampton Inn', 115, '2019-09-07', 286, NULL),
('Hampton Inn', 115, '2019-09-08', 317, NULL),
('Hampton Inn', 115, '2019-09-09', 210, NULL),
('Hampton Inn', 115, '2019-09-10', 370, NULL),
('Hampton Inn', 115, '2019-09-11', 124, NULL),
('Hampton Inn', 115, '2019-09-12', 116, NULL),
('Hampton Inn', 115, '2019-09-13', 241, NULL),
('Hampton Inn', 115, '2019-09-14', 172, NULL),
('Hampton Inn', 115, '2019-09-15', 214, NULL),
('Hampton Inn', 115, '2019-09-16', 160, NULL),
('Hampton Inn', 115, '2019-09-17', 148, NULL),
('Hampton Inn', 115, '2019-09-18', 334, NULL),
('Hampton Inn', 115, '2019-09-19', 142, NULL),
('Hampton Inn', 115, '2019-09-20', 176, NULL),
('Hampton Inn', 115, '2019-09-21', 279, NULL),
('Hampton Inn', 115, '2019-09-22', 383, NULL),
('Hampton Inn', 115, '2019-09-23', 140, NULL),
('Hampton Inn', 115, '2019-09-24', 118, NULL),
('Hampton Inn', 115, '2019-09-25', 101, NULL),
('Hampton Inn', 115, '2019-09-26', 188, NULL),
('Hampton Inn', 115, '2019-09-27', 165, NULL),
('Hampton Inn', 115, '2019-09-28', 185, NULL),
('Hampton Inn', 115, '2019-09-29', 328, NULL),
('Hampton Inn', 115, '2019-09-30', 136, NULL),
('Hampton Inn', 115, '2019-10-01', 395, NULL),
('Hampton Inn', 115, '2019-10-02', 240, NULL),
('Hampton Inn', 115, '2019-10-03', 305, NULL),
('Hampton Inn', 115, '2019-10-04', 390, NULL),
('Hampton Inn', 115, '2019-10-05', 248, NULL),
('Hampton Inn', 115, '2019-10-06', 222, NULL),
('Hampton Inn', 115, '2019-10-07', 305, NULL),
('Hampton Inn', 115, '2019-10-08', 282, NULL),
('Hampton Inn', 115, '2019-10-09', 161, NULL),
('Hampton Inn', 115, '2019-10-10', 211, NULL),
('Hampton Inn', 115, '2019-10-11', 277, NULL),
('Hampton Inn', 115, '2019-10-12', 324, NULL),
('Hampton Inn', 115, '2019-10-13', 116, NULL),
('Hampton Inn', 115, '2019-10-14', 337, NULL),
('Hampton Inn', 115, '2019-10-15', 159, NULL),
('Hampton Inn', 115, '2019-10-16', 110, NULL),
('Hampton Inn', 115, '2019-10-17', 166, NULL),
('Hampton Inn', 115, '2019-10-18', 280, NULL),
('Hampton Inn', 115, '2019-10-19', 158, NULL),
('Hampton Inn', 115, '2019-10-20', 320, NULL),
('Hampton Inn', 115, '2019-10-21', 104, NULL),
('Hampton Inn', 115, '2019-10-22', 132, NULL),
('Hampton Inn', 115, '2019-10-23', 169, NULL),
('Hampton Inn', 115, '2019-10-24', 146, NULL),
('Hampton Inn', 115, '2019-10-25', 362, NULL),
('Hampton Inn', 115, '2019-10-26', 354, NULL),
('Hampton Inn', 115, '2019-10-27', 127, NULL),
('Hampton Inn', 115, '2019-10-28', 340, NULL),
('Hampton Inn', 115, '2019-10-29', 394, NULL),
('Hampton Inn', 115, '2019-10-30', 113, NULL),
('Hampton Inn', 115, '2019-10-31', 240, NULL),
('Hampton Inn', 115, '2019-11-01', 128, NULL),
('Hampton Inn', 115, '2019-11-02', 372, NULL),
('Hampton Inn', 115, '2019-11-03', 274, NULL),
('Hampton Inn', 115, '2019-11-04', 306, NULL),
('Hampton Inn', 115, '2019-11-05', 325, NULL),
('Hampton Inn', 115, '2019-11-06', 108, NULL),
('Hampton Inn', 115, '2019-11-07', 266, NULL),
('Hampton Inn', 115, '2019-11-08', 320, NULL),
('Hampton Inn', 115, '2019-11-09', 371, NULL),
('Hampton Inn', 115, '2019-11-10', 371, NULL),
('Hampton Inn', 115, '2019-11-11', 147, NULL),
('Hampton Inn', 115, '2019-11-12', 385, NULL),
('Hampton Inn', 115, '2019-11-13', 226, NULL),
('Hampton Inn', 115, '2019-11-14', 180, NULL),
('Hampton Inn', 115, '2019-11-15', 189, NULL),
('Hampton Inn', 115, '2019-11-16', 175, NULL),
('Hampton Inn', 115, '2019-11-17', 186, NULL),
('Hampton Inn', 115, '2019-11-18', 334, NULL),
('Hampton Inn', 115, '2019-11-19', 265, NULL),
('Hampton Inn', 115, '2019-11-20', 369, NULL),
('Hampton Inn', 115, '2019-11-21', 269, NULL),
('Hampton Inn', 115, '2019-11-22', 293, NULL),
('Hampton Inn', 115, '2019-11-23', 224, NULL),
('Hampton Inn', 115, '2019-11-24', 214, NULL),
('Hampton Inn', 115, '2019-11-25', 155, NULL),
('Hampton Inn', 115, '2019-11-26', 288, NULL),
('Hampton Inn', 115, '2019-11-27', 244, NULL),
('Hampton Inn', 115, '2019-11-28', 383, NULL),
('Hampton Inn', 115, '2019-11-29', 194, NULL),
('Hampton Inn', 115, '2019-11-30', 189, NULL),
('Hampton Inn', 115, '2019-12-01', 190, NULL),
('Hampton Inn', 115, '2019-12-02', 284, NULL),
('Hampton Inn', 115, '2019-12-03', 156, NULL),
('Hampton Inn', 115, '2019-12-04', 279, NULL),
('Hampton Inn', 115, '2019-12-05', 100, NULL),
('Hampton Inn', 115, '2019-12-06', 187, NULL),
('Hampton Inn', 115, '2019-12-07', 256, NULL),
('Hampton Inn', 115, '2019-12-08', 193, NULL),
('Hampton Inn', 115, '2019-12-09', 195, NULL),
('Hampton Inn', 115, '2019-12-10', 252, NULL),
('Hampton Inn', 115, '2019-12-11', 333, NULL),
('Hampton Inn', 115, '2019-12-12', 242, NULL),
('Hampton Inn', 115, '2019-12-13', 320, NULL),
('Hampton Inn', 115, '2019-12-14', 201, NULL),
('Hampton Inn', 115, '2019-12-15', 108, NULL),
('Hampton Inn', 115, '2019-12-16', 220, NULL),
('Hampton Inn', 115, '2019-12-17', 114, NULL),
('Hampton Inn', 115, '2019-12-18', 360, NULL),
('Hampton Inn', 115, '2019-12-19', 282, NULL),
('Hampton Inn', 115, '2019-12-20', 393, NULL),
('Hampton Inn', 115, '2019-12-21', 365, NULL),
('Hampton Inn', 115, '2019-12-22', 129, NULL),
('Hampton Inn', 115, '2019-12-23', 276, NULL),
('Hampton Inn', 115, '2019-12-24', 259, NULL),
('Hampton Inn', 115, '2019-12-25', 240, NULL),
('Hampton Inn', 115, '2019-12-26', 284, NULL),
('Hampton Inn', 115, '2019-12-27', 365, NULL),
('Hampton Inn', 115, '2019-12-28', 334, NULL),
('Hampton Inn', 115, '2019-12-29', 117, NULL),
('Hampton Inn', 115, '2019-12-30', 324, NULL),
('Hampton Inn', 115, '2019-12-31', 290, NULL),
('Hampton Inn', 115, '2020-01-01', 131, NULL),
('Hampton Inn', 115, '2020-01-02', 193, NULL),
('Hampton Inn', 115, '2020-01-03', 216, NULL),
('Hampton Inn', 115, '2020-01-04', 300, NULL),
('Hampton Inn', 115, '2020-01-05', 131, NULL),
('Hampton Inn', 115, '2020-01-06', 264, NULL),
('Hampton Inn', 115, '2020-01-07', 383, NULL),
('Hampton Inn', 115, '2020-01-08', 266, NULL),
('Hampton Inn', 115, '2020-01-09', 270, NULL),
('Hampton Inn', 115, '2020-01-10', 333, NULL),
('Hampton Inn', 115, '2020-01-11', 138, NULL),
('Hampton Inn', 115, '2020-01-12', 236, NULL),
('Hampton Inn', 115, '2020-01-13', 106, NULL),
('Hampton Inn', 115, '2020-01-14', 162, NULL),
('Hampton Inn', 115, '2020-01-15', 254, NULL),
('Hampton Inn', 115, '2020-01-16', 133, NULL),
('Hampton Inn', 115, '2020-01-17', 109, NULL),
('Hampton Inn', 115, '2020-01-18', 179, NULL),
('Hampton Inn', 115, '2020-01-19', 329, NULL),
('Hampton Inn', 115, '2020-01-20', 302, NULL),
('Hampton Inn', 115, '2020-01-21', 361, NULL),
('Hampton Inn', 115, '2020-01-22', 379, NULL),
('Hampton Inn', 115, '2020-01-23', 333, NULL),
('Hampton Inn', 115, '2020-01-24', 132, NULL),
('Hampton Inn', 115, '2020-01-25', 345, NULL),
('Hampton Inn', 115, '2020-01-26', 289, NULL),
('Hampton Inn', 115, '2020-01-27', 224, NULL),
('Hampton Inn', 115, '2020-01-28', 164, NULL),
('Hampton Inn', 115, '2020-01-29', 121, NULL),
('Hampton Inn', 115, '2020-01-30', 195, NULL),
('Hampton Inn', 115, '2020-01-31', 385, NULL),
('Hampton Inn', 115, '2020-02-01', 114, NULL),
('Hampton Inn', 115, '2020-02-02', 111, NULL),
('Hampton Inn', 115, '2020-02-03', 184, NULL),
('Hampton Inn', 115, '2020-02-04', 235, NULL),
('Hampton Inn', 124, '2019-01-01', 231, NULL),
('Hampton Inn', 124, '2019-01-02', 164, NULL),
('Hampton Inn', 124, '2019-01-03', 326, NULL),
('Hampton Inn', 124, '2019-01-04', 103, NULL),
('Hampton Inn', 124, '2019-01-05', 353, NULL),
('Hampton Inn', 124, '2019-01-06', 355, NULL),
('Hampton Inn', 124, '2019-01-07', 144, NULL),
('Hampton Inn', 124, '2019-01-08', 239, NULL),
('Hampton Inn', 124, '2019-01-09', 192, NULL),
('Hampton Inn', 124, '2019-01-10', 327, NULL),
('Hampton Inn', 124, '2019-01-11', 300, NULL),
('Hampton Inn', 124, '2019-01-12', 267, NULL),
('Hampton Inn', 124, '2019-01-13', 175, NULL),
('Hampton Inn', 124, '2019-01-14', 118, NULL),
('Hampton Inn', 124, '2019-01-15', 294, NULL),
('Hampton Inn', 124, '2019-01-16', 327, NULL),
('Hampton Inn', 124, '2019-01-17', 225, NULL),
('Hampton Inn', 124, '2019-01-18', 192, NULL),
('Hampton Inn', 124, '2019-01-19', 375, NULL),
('Hampton Inn', 124, '2019-01-20', 348, NULL),
('Hampton Inn', 124, '2019-01-21', 170, NULL),
('Hampton Inn', 124, '2019-01-22', 136, NULL),
('Hampton Inn', 124, '2019-01-23', 351, NULL),
('Hampton Inn', 124, '2019-01-24', 345, NULL),
('Hampton Inn', 124, '2019-01-25', 367, NULL),
('Hampton Inn', 124, '2019-01-26', 370, NULL),
('Hampton Inn', 124, '2019-01-27', 141, NULL),
('Hampton Inn', 124, '2019-01-28', 341, NULL),
('Hampton Inn', 124, '2019-01-29', 152, NULL),
('Hampton Inn', 124, '2019-01-30', 229, NULL),
('Hampton Inn', 124, '2019-01-31', 140, NULL),
('Hampton Inn', 124, '2019-02-01', 258, NULL),
('Hampton Inn', 124, '2019-02-02', 332, NULL),
('Hampton Inn', 124, '2019-02-03', 365, NULL),
('Hampton Inn', 124, '2019-02-04', 366, NULL),
('Hampton Inn', 124, '2019-02-05', 144, NULL),
('Hampton Inn', 124, '2019-02-06', 152, NULL),
('Hampton Inn', 124, '2019-02-07', 232, NULL),
('Hampton Inn', 124, '2019-02-08', 188, NULL),
('Hampton Inn', 124, '2019-02-09', 251, NULL),
('Hampton Inn', 124, '2019-02-10', 131, NULL),
('Hampton Inn', 124, '2019-02-11', 313, NULL),
('Hampton Inn', 124, '2019-02-12', 344, NULL),
('Hampton Inn', 124, '2019-02-13', 357, NULL),
('Hampton Inn', 124, '2019-02-14', 276, NULL),
('Hampton Inn', 124, '2019-02-15', 101, NULL),
('Hampton Inn', 124, '2019-02-16', 274, NULL),
('Hampton Inn', 124, '2019-02-17', 241, NULL),
('Hampton Inn', 124, '2019-02-18', 213, NULL),
('Hampton Inn', 124, '2019-02-19', 225, NULL),
('Hampton Inn', 124, '2019-02-20', 225, NULL),
('Hampton Inn', 124, '2019-02-21', 150, NULL),
('Hampton Inn', 124, '2019-02-22', 285, NULL),
('Hampton Inn', 124, '2019-02-23', 392, NULL),
('Hampton Inn', 124, '2019-02-24', 299, NULL),
('Hampton Inn', 124, '2019-02-25', 329, NULL),
('Hampton Inn', 124, '2019-02-26', 313, NULL),
('Hampton Inn', 124, '2019-02-27', 231, NULL),
('Hampton Inn', 124, '2019-02-28', 322, NULL),
('Hampton Inn', 124, '2019-03-01', 133, NULL),
('Hampton Inn', 124, '2019-03-02', 361, NULL),
('Hampton Inn', 124, '2019-03-03', 163, NULL),
('Hampton Inn', 124, '2019-03-04', 385, NULL),
('Hampton Inn', 124, '2019-03-05', 319, NULL),
('Hampton Inn', 124, '2019-03-06', 262, NULL),
('Hampton Inn', 124, '2019-03-07', 270, NULL),
('Hampton Inn', 124, '2019-03-08', 299, NULL),
('Hampton Inn', 124, '2019-03-09', 349, NULL),
('Hampton Inn', 124, '2019-03-10', 236, NULL),
('Hampton Inn', 124, '2019-03-11', 340, NULL),
('Hampton Inn', 124, '2019-03-12', 260, NULL),
('Hampton Inn', 124, '2019-03-13', 396, NULL),
('Hampton Inn', 124, '2019-03-14', 240, NULL),
('Hampton Inn', 124, '2019-03-15', 256, NULL),
('Hampton Inn', 124, '2019-03-16', 347, NULL),
('Hampton Inn', 124, '2019-03-17', 155, NULL),
('Hampton Inn', 124, '2019-03-18', 341, NULL),
('Hampton Inn', 124, '2019-03-19', 233, NULL),
('Hampton Inn', 124, '2019-03-20', 169, NULL),
('Hampton Inn', 124, '2019-03-21', 389, NULL),
('Hampton Inn', 124, '2019-03-22', 347, NULL),
('Hampton Inn', 124, '2019-03-23', 238, NULL),
('Hampton Inn', 124, '2019-03-24', 322, NULL),
('Hampton Inn', 124, '2019-03-25', 199, NULL),
('Hampton Inn', 124, '2019-03-26', 233, NULL),
('Hampton Inn', 124, '2019-03-27', 322, NULL),
('Hampton Inn', 124, '2019-03-28', 315, NULL),
('Hampton Inn', 124, '2019-03-29', 144, NULL),
('Hampton Inn', 124, '2019-03-30', 186, NULL),
('Hampton Inn', 124, '2019-03-31', 295, NULL),
('Hampton Inn', 124, '2019-04-01', 288, NULL),
('Hampton Inn', 124, '2019-04-02', 344, NULL),
('Hampton Inn', 124, '2019-04-03', 298, NULL),
('Hampton Inn', 124, '2019-04-04', 271, NULL),
('Hampton Inn', 124, '2019-04-05', 116, NULL),
('Hampton Inn', 124, '2019-04-06', 242, NULL),
('Hampton Inn', 124, '2019-04-07', 145, NULL),
('Hampton Inn', 124, '2019-04-08', 295, NULL),
('Hampton Inn', 124, '2019-04-09', 134, NULL),
('Hampton Inn', 124, '2019-04-10', 318, NULL),
('Hampton Inn', 124, '2019-04-11', 167, NULL),
('Hampton Inn', 124, '2019-04-12', 158, NULL),
('Hampton Inn', 124, '2019-04-13', 163, NULL),
('Hampton Inn', 124, '2019-04-14', 256, NULL),
('Hampton Inn', 124, '2019-04-15', 396, NULL),
('Hampton Inn', 124, '2019-04-16', 174, NULL),
('Hampton Inn', 124, '2019-04-17', 340, NULL),
('Hampton Inn', 124, '2019-04-18', 254, NULL),
('Hampton Inn', 124, '2019-04-19', 292, NULL),
('Hampton Inn', 124, '2019-04-20', 236, NULL),
('Hampton Inn', 124, '2019-04-21', 363, NULL),
('Hampton Inn', 124, '2019-04-22', 167, NULL),
('Hampton Inn', 124, '2019-04-23', 347, NULL),
('Hampton Inn', 124, '2019-04-24', 263, NULL),
('Hampton Inn', 124, '2019-04-25', 220, NULL),
('Hampton Inn', 124, '2019-04-26', 171, NULL),
('Hampton Inn', 124, '2019-04-27', 174, NULL),
('Hampton Inn', 124, '2019-04-28', 311, NULL),
('Hampton Inn', 124, '2019-04-29', 234, NULL),
('Hampton Inn', 124, '2019-04-30', 159, NULL),
('Hampton Inn', 124, '2019-05-01', 100, NULL),
('Hampton Inn', 124, '2019-05-02', 135, NULL),
('Hampton Inn', 124, '2019-05-03', 314, NULL),
('Hampton Inn', 124, '2019-05-04', 229, NULL),
('Hampton Inn', 124, '2019-05-05', 164, NULL),
('Hampton Inn', 124, '2019-05-06', 277, NULL),
('Hampton Inn', 124, '2019-05-07', 214, NULL),
('Hampton Inn', 124, '2019-05-08', 337, NULL),
('Hampton Inn', 124, '2019-05-09', 183, NULL),
('Hampton Inn', 124, '2019-05-10', 253, NULL),
('Hampton Inn', 124, '2019-05-11', 208, NULL),
('Hampton Inn', 124, '2019-05-12', 337, NULL),
('Hampton Inn', 124, '2019-05-13', 392, NULL),
('Hampton Inn', 124, '2019-05-14', 173, NULL),
('Hampton Inn', 124, '2019-05-15', 109, NULL),
('Hampton Inn', 124, '2019-05-16', 186, NULL),
('Hampton Inn', 124, '2019-05-17', 214, NULL),
('Hampton Inn', 124, '2019-05-18', 269, NULL),
('Hampton Inn', 124, '2019-05-19', 100, NULL),
('Hampton Inn', 124, '2019-05-20', 390, NULL),
('Hampton Inn', 124, '2019-05-21', 242, NULL),
('Hampton Inn', 124, '2019-05-22', 322, NULL),
('Hampton Inn', 124, '2019-05-23', 101, NULL),
('Hampton Inn', 124, '2019-05-24', 162, NULL),
('Hampton Inn', 124, '2019-05-25', 323, NULL),
('Hampton Inn', 124, '2019-05-26', 149, NULL),
('Hampton Inn', 124, '2019-05-27', 294, NULL),
('Hampton Inn', 124, '2019-05-28', 154, NULL),
('Hampton Inn', 124, '2019-05-29', 359, NULL),
('Hampton Inn', 124, '2019-05-30', 392, NULL),
('Hampton Inn', 124, '2019-05-31', 136, NULL),
('Hampton Inn', 124, '2019-06-01', 308, NULL),
('Hampton Inn', 124, '2019-06-02', 116, NULL),
('Hampton Inn', 124, '2019-06-03', 186, NULL),
('Hampton Inn', 124, '2019-06-04', 319, NULL),
('Hampton Inn', 124, '2019-06-05', 274, NULL),
('Hampton Inn', 124, '2019-06-06', 251, NULL),
('Hampton Inn', 124, '2019-06-07', 250, NULL),
('Hampton Inn', 124, '2019-06-08', 378, NULL),
('Hampton Inn', 124, '2019-06-09', 249, NULL),
('Hampton Inn', 124, '2019-06-10', 293, NULL),
('Hampton Inn', 124, '2019-06-11', 341, NULL),
('Hampton Inn', 124, '2019-06-12', 383, NULL),
('Hampton Inn', 124, '2019-06-13', 385, NULL),
('Hampton Inn', 124, '2019-06-14', 148, NULL),
('Hampton Inn', 124, '2019-06-15', 390, NULL),
('Hampton Inn', 124, '2019-06-16', 124, NULL),
('Hampton Inn', 124, '2019-06-17', 126, NULL),
('Hampton Inn', 124, '2019-06-18', 344, NULL),
('Hampton Inn', 124, '2019-06-19', 282, NULL),
('Hampton Inn', 124, '2019-06-20', 275, NULL),
('Hampton Inn', 124, '2019-06-21', 198, NULL),
('Hampton Inn', 124, '2019-06-22', 256, NULL),
('Hampton Inn', 124, '2019-06-23', 124, NULL),
('Hampton Inn', 124, '2019-06-24', 242, NULL),
('Hampton Inn', 124, '2019-06-25', 185, NULL),
('Hampton Inn', 124, '2019-06-26', 389, NULL),
('Hampton Inn', 124, '2019-06-27', 256, NULL),
('Hampton Inn', 124, '2019-06-28', 173, NULL),
('Hampton Inn', 124, '2019-06-29', 106, NULL),
('Hampton Inn', 124, '2019-06-30', 369, NULL),
('Hampton Inn', 124, '2019-07-01', 111, NULL),
('Hampton Inn', 124, '2019-07-02', 137, NULL),
('Hampton Inn', 124, '2019-07-03', 244, NULL),
('Hampton Inn', 124, '2019-07-04', 329, NULL),
('Hampton Inn', 124, '2019-07-05', 243, NULL),
('Hampton Inn', 124, '2019-07-06', 106, NULL),
('Hampton Inn', 124, '2019-07-07', 287, NULL),
('Hampton Inn', 124, '2019-07-08', 228, NULL),
('Hampton Inn', 124, '2019-07-09', 100, NULL),
('Hampton Inn', 124, '2019-07-10', 370, NULL),
('Hampton Inn', 124, '2019-07-11', 254, NULL),
('Hampton Inn', 124, '2019-07-12', 155, NULL),
('Hampton Inn', 124, '2019-07-13', 328, NULL),
('Hampton Inn', 124, '2019-07-14', 253, NULL),
('Hampton Inn', 124, '2019-07-15', 211, NULL),
('Hampton Inn', 124, '2019-07-16', 230, NULL),
('Hampton Inn', 124, '2019-07-17', 228, NULL),
('Hampton Inn', 124, '2019-07-18', 168, NULL),
('Hampton Inn', 124, '2019-07-19', 178, NULL),
('Hampton Inn', 124, '2019-07-20', 241, NULL),
('Hampton Inn', 124, '2019-07-21', 176, NULL),
('Hampton Inn', 124, '2019-07-22', 240, NULL),
('Hampton Inn', 124, '2019-07-23', 377, NULL),
('Hampton Inn', 124, '2019-07-24', 391, NULL),
('Hampton Inn', 124, '2019-07-25', 261, NULL),
('Hampton Inn', 124, '2019-07-26', 295, NULL),
('Hampton Inn', 124, '2019-07-27', 258, NULL),
('Hampton Inn', 124, '2019-07-28', 226, NULL),
('Hampton Inn', 124, '2019-07-29', 194, NULL),
('Hampton Inn', 124, '2019-07-30', 355, NULL),
('Hampton Inn', 124, '2019-07-31', 337, NULL),
('Hampton Inn', 124, '2019-08-01', 354, NULL),
('Hampton Inn', 124, '2019-08-02', 184, NULL),
('Hampton Inn', 124, '2019-08-03', 282, NULL),
('Hampton Inn', 124, '2019-08-04', 356, NULL),
('Hampton Inn', 124, '2019-08-05', 211, NULL),
('Hampton Inn', 124, '2019-08-06', 368, NULL),
('Hampton Inn', 124, '2019-08-07', 149, NULL),
('Hampton Inn', 124, '2019-08-08', 388, NULL),
('Hampton Inn', 124, '2019-08-09', 266, NULL),
('Hampton Inn', 124, '2019-08-10', 168, NULL),
('Hampton Inn', 124, '2019-08-11', 210, NULL),
('Hampton Inn', 124, '2019-08-12', 262, NULL),
('Hampton Inn', 124, '2019-08-13', 126, NULL),
('Hampton Inn', 124, '2019-08-14', 130, NULL),
('Hampton Inn', 124, '2019-08-15', 115, NULL),
('Hampton Inn', 124, '2019-08-16', 241, NULL),
('Hampton Inn', 124, '2019-08-17', 178, NULL),
('Hampton Inn', 124, '2019-08-18', 212, NULL),
('Hampton Inn', 124, '2019-08-19', 112, NULL),
('Hampton Inn', 124, '2019-08-20', 356, NULL),
('Hampton Inn', 124, '2019-08-21', 267, NULL),
('Hampton Inn', 124, '2019-08-22', 394, NULL),
('Hampton Inn', 124, '2019-08-23', 181, NULL),
('Hampton Inn', 124, '2019-08-24', 311, NULL),
('Hampton Inn', 124, '2019-08-25', 170, NULL),
('Hampton Inn', 124, '2019-08-26', 267, NULL),
('Hampton Inn', 124, '2019-08-27', 316, NULL),
('Hampton Inn', 124, '2019-08-28', 127, NULL),
('Hampton Inn', 124, '2019-08-29', 233, NULL),
('Hampton Inn', 124, '2019-08-30', 248, NULL),
('Hampton Inn', 124, '2019-08-31', 297, NULL),
('Hampton Inn', 124, '2019-09-01', 338, NULL),
('Hampton Inn', 124, '2019-09-02', 146, NULL),
('Hampton Inn', 124, '2019-09-03', 392, NULL),
('Hampton Inn', 124, '2019-09-04', 320, NULL),
('Hampton Inn', 124, '2019-09-05', 116, NULL),
('Hampton Inn', 124, '2019-09-06', 357, NULL),
('Hampton Inn', 124, '2019-09-07', 147, NULL),
('Hampton Inn', 124, '2019-09-08', 176, NULL),
('Hampton Inn', 124, '2019-09-09', 292, NULL),
('Hampton Inn', 124, '2019-09-10', 173, NULL),
('Hampton Inn', 124, '2019-09-11', 111, NULL),
('Hampton Inn', 124, '2019-09-12', 207, NULL),
('Hampton Inn', 124, '2019-09-13', 156, NULL),
('Hampton Inn', 124, '2019-09-14', 202, NULL),
('Hampton Inn', 124, '2019-09-15', 346, NULL),
('Hampton Inn', 124, '2019-09-16', 358, NULL),
('Hampton Inn', 124, '2019-09-17', 151, NULL),
('Hampton Inn', 124, '2019-09-18', 297, NULL),
('Hampton Inn', 124, '2019-09-19', 213, NULL),
('Hampton Inn', 124, '2019-09-20', 324, NULL),
('Hampton Inn', 124, '2019-09-21', 299, NULL),
('Hampton Inn', 124, '2019-09-22', 299, NULL),
('Hampton Inn', 124, '2019-09-23', 308, NULL),
('Hampton Inn', 124, '2019-09-24', 246, NULL),
('Hampton Inn', 124, '2019-09-25', 365, NULL),
('Hampton Inn', 124, '2019-09-26', 208, NULL),
('Hampton Inn', 124, '2019-09-27', 135, NULL),
('Hampton Inn', 124, '2019-09-28', 215, NULL),
('Hampton Inn', 124, '2019-09-29', 196, NULL),
('Hampton Inn', 124, '2019-09-30', 359, NULL),
('Hampton Inn', 124, '2019-10-01', 310, NULL),
('Hampton Inn', 124, '2019-10-02', 260, NULL),
('Hampton Inn', 124, '2019-10-03', 225, NULL),
('Hampton Inn', 124, '2019-10-04', 177, NULL),
('Hampton Inn', 124, '2019-10-05', 375, NULL),
('Hampton Inn', 124, '2019-10-06', 202, NULL),
('Hampton Inn', 124, '2019-10-07', 187, NULL),
('Hampton Inn', 124, '2019-10-08', 326, NULL),
('Hampton Inn', 124, '2019-10-09', 143, NULL),
('Hampton Inn', 124, '2019-10-10', 255, NULL),
('Hampton Inn', 124, '2019-10-11', 118, NULL),
('Hampton Inn', 124, '2019-10-12', 160, NULL),
('Hampton Inn', 124, '2019-10-13', 309, NULL),
('Hampton Inn', 124, '2019-10-14', 219, NULL),
('Hampton Inn', 124, '2019-10-15', 110, NULL),
('Hampton Inn', 124, '2019-10-16', 107, NULL),
('Hampton Inn', 124, '2019-10-17', 161, NULL),
('Hampton Inn', 124, '2019-10-18', 379, NULL),
('Hampton Inn', 124, '2019-10-19', 168, NULL),
('Hampton Inn', 124, '2019-10-20', 179, NULL),
('Hampton Inn', 124, '2019-10-21', 232, NULL),
('Hampton Inn', 124, '2019-10-22', 300, NULL),
('Hampton Inn', 124, '2019-10-23', 127, NULL),
('Hampton Inn', 124, '2019-10-24', 213, NULL),
('Hampton Inn', 124, '2019-10-25', 138, NULL),
('Hampton Inn', 124, '2019-10-26', 396, NULL),
('Hampton Inn', 124, '2019-10-27', 370, NULL),
('Hampton Inn', 124, '2019-10-28', 362, NULL),
('Hampton Inn', 124, '2019-10-29', 134, NULL),
('Hampton Inn', 124, '2019-10-30', 263, NULL),
('Hampton Inn', 124, '2019-10-31', 166, NULL),
('Hampton Inn', 124, '2019-11-01', 327, NULL),
('Hampton Inn', 124, '2019-11-02', 199, NULL),
('Hampton Inn', 124, '2019-11-03', 193, NULL),
('Hampton Inn', 124, '2019-11-04', 331, NULL),
('Hampton Inn', 124, '2019-11-05', 228, NULL),
('Hampton Inn', 124, '2019-11-06', 245, NULL),
('Hampton Inn', 124, '2019-11-07', 229, NULL),
('Hampton Inn', 124, '2019-11-08', 351, NULL),
('Hampton Inn', 124, '2019-11-09', 268, NULL),
('Hampton Inn', 124, '2019-11-10', 209, NULL),
('Hampton Inn', 124, '2019-11-11', 317, NULL),
('Hampton Inn', 124, '2019-11-12', 348, NULL),
('Hampton Inn', 124, '2019-11-13', 359, NULL),
('Hampton Inn', 124, '2019-11-14', 361, NULL),
('Hampton Inn', 124, '2019-11-15', 352, NULL),
('Hampton Inn', 124, '2019-11-16', 292, NULL),
('Hampton Inn', 124, '2019-11-17', 302, NULL),
('Hampton Inn', 124, '2019-11-18', 371, NULL),
('Hampton Inn', 124, '2019-11-19', 197, NULL),
('Hampton Inn', 124, '2019-11-20', 250, NULL),
('Hampton Inn', 124, '2019-11-21', 397, NULL),
('Hampton Inn', 124, '2019-11-22', 277, NULL),
('Hampton Inn', 124, '2019-11-23', 267, NULL),
('Hampton Inn', 124, '2019-11-24', 381, NULL),
('Hampton Inn', 124, '2019-11-25', 334, NULL),
('Hampton Inn', 124, '2019-11-26', 309, NULL),
('Hampton Inn', 124, '2019-11-27', 348, NULL),
('Hampton Inn', 124, '2019-11-28', 372, NULL),
('Hampton Inn', 124, '2019-11-29', 248, NULL),
('Hampton Inn', 124, '2019-11-30', 335, NULL),
('Hampton Inn', 124, '2019-12-01', 292, NULL),
('Hampton Inn', 124, '2019-12-02', 345, NULL),
('Hampton Inn', 124, '2019-12-03', 285, NULL),
('Hampton Inn', 124, '2019-12-04', 181, NULL),
('Hampton Inn', 124, '2019-12-05', 198, NULL),
('Hampton Inn', 124, '2019-12-06', 179, NULL),
('Hampton Inn', 124, '2019-12-07', 338, NULL),
('Hampton Inn', 124, '2019-12-08', 183, NULL),
('Hampton Inn', 124, '2019-12-09', 139, NULL),
('Hampton Inn', 124, '2019-12-10', 247, NULL),
('Hampton Inn', 124, '2019-12-11', 264, NULL),
('Hampton Inn', 124, '2019-12-12', 355, NULL),
('Hampton Inn', 124, '2019-12-13', 214, NULL),
('Hampton Inn', 124, '2019-12-14', 226, NULL),
('Hampton Inn', 124, '2019-12-15', 290, NULL),
('Hampton Inn', 124, '2019-12-16', 158, NULL),
('Hampton Inn', 124, '2019-12-17', 226, NULL),
('Hampton Inn', 124, '2019-12-18', 367, NULL),
('Hampton Inn', 124, '2019-12-19', 120, NULL),
('Hampton Inn', 124, '2019-12-20', 308, NULL),
('Hampton Inn', 124, '2019-12-21', 337, NULL),
('Hampton Inn', 124, '2019-12-22', 334, NULL),
('Hampton Inn', 124, '2019-12-23', 233, NULL),
('Hampton Inn', 124, '2019-12-24', 310, NULL),
('Hampton Inn', 124, '2019-12-25', 253, NULL),
('Hampton Inn', 124, '2019-12-26', 181, NULL),
('Hampton Inn', 124, '2019-12-27', 348, NULL),
('Hampton Inn', 124, '2019-12-28', 310, NULL),
('Hampton Inn', 124, '2019-12-29', 241, NULL),
('Hampton Inn', 124, '2019-12-30', 300, NULL),
('Hampton Inn', 124, '2019-12-31', 116, NULL),
('Hampton Inn', 124, '2020-01-01', 304, NULL),
('Hampton Inn', 124, '2020-01-02', 323, NULL),
('Hampton Inn', 124, '2020-01-03', 397, NULL),
('Hampton Inn', 124, '2020-01-04', 185, NULL),
('Hampton Inn', 124, '2020-01-05', 209, NULL),
('Hampton Inn', 124, '2020-01-06', 230, NULL),
('Hampton Inn', 124, '2020-01-07', 209, NULL),
('Hampton Inn', 124, '2020-01-08', 101, NULL),
('Hampton Inn', 124, '2020-01-09', 202, NULL),
('Hampton Inn', 124, '2020-01-10', 365, NULL),
('Hampton Inn', 124, '2020-01-11', 186, NULL),
('Hampton Inn', 124, '2020-01-12', 398, NULL),
('Hampton Inn', 124, '2020-01-13', 218, NULL),
('Hampton Inn', 124, '2020-01-14', 116, NULL),
('Hampton Inn', 124, '2020-01-15', 317, NULL),
('Hampton Inn', 124, '2020-01-16', 129, NULL),
('Hampton Inn', 124, '2020-01-17', 142, NULL),
('Hampton Inn', 124, '2020-01-18', 360, NULL),
('Hampton Inn', 124, '2020-01-19', 125, NULL),
('Hampton Inn', 124, '2020-01-20', 249, NULL),
('Hampton Inn', 124, '2020-01-21', 228, NULL),
('Hampton Inn', 124, '2020-01-22', 358, NULL),
('Hampton Inn', 124, '2020-01-23', 290, NULL),
('Hampton Inn', 124, '2020-01-24', 385, NULL),
('Hampton Inn', 124, '2020-01-25', 281, NULL),
('Hampton Inn', 124, '2020-01-26', 213, NULL),
('Hampton Inn', 124, '2020-01-27', 100, NULL),
('Hampton Inn', 124, '2020-01-28', 268, NULL),
('Hampton Inn', 124, '2020-01-29', 291, NULL),
('Hampton Inn', 124, '2020-01-30', 138, NULL),
('Hampton Inn', 124, '2020-01-31', 110, NULL),
('Hampton Inn', 124, '2020-02-01', 317, NULL),
('Hampton Inn', 124, '2020-02-02', 197, NULL),
('Hampton Inn', 124, '2020-02-03', 147, NULL),
('Hampton Inn', 124, '2020-02-04', 127, NULL),
('Hampton Inn', 129, '2019-01-01', 290, NULL),
('Hampton Inn', 129, '2019-01-02', 366, NULL),
('Hampton Inn', 129, '2019-01-03', 338, NULL),
('Hampton Inn', 129, '2019-01-04', 138, NULL),
('Hampton Inn', 129, '2019-01-05', 132, NULL),
('Hampton Inn', 129, '2019-01-06', 320, NULL),
('Hampton Inn', 129, '2019-01-07', 271, NULL),
('Hampton Inn', 129, '2019-01-08', 269, NULL),
('Hampton Inn', 129, '2019-01-09', 210, NULL),
('Hampton Inn', 129, '2019-01-10', 100, NULL),
('Hampton Inn', 129, '2019-01-11', 287, NULL),
('Hampton Inn', 129, '2019-01-12', 312, NULL),
('Hampton Inn', 129, '2019-01-13', 110, NULL),
('Hampton Inn', 129, '2019-01-14', 108, NULL),
('Hampton Inn', 129, '2019-01-15', 364, NULL),
('Hampton Inn', 129, '2019-01-16', 222, NULL),
('Hampton Inn', 129, '2019-01-17', 123, NULL),
('Hampton Inn', 129, '2019-01-18', 324, NULL),
('Hampton Inn', 129, '2019-01-19', 226, NULL),
('Hampton Inn', 129, '2019-01-20', 105, NULL),
('Hampton Inn', 129, '2019-01-21', 368, NULL),
('Hampton Inn', 129, '2019-01-22', 109, NULL),
('Hampton Inn', 129, '2019-01-23', 225, NULL),
('Hampton Inn', 129, '2019-01-24', 397, NULL),
('Hampton Inn', 129, '2019-01-25', 277, NULL),
('Hampton Inn', 129, '2019-01-26', 179, NULL),
('Hampton Inn', 129, '2019-01-27', 370, NULL),
('Hampton Inn', 129, '2019-01-28', 196, NULL),
('Hampton Inn', 129, '2019-01-29', 344, NULL),
('Hampton Inn', 129, '2019-01-30', 312, NULL),
('Hampton Inn', 129, '2019-01-31', 171, NULL),
('Hampton Inn', 129, '2019-02-01', 170, NULL),
('Hampton Inn', 129, '2019-02-02', 116, NULL),
('Hampton Inn', 129, '2019-02-03', 126, NULL),
('Hampton Inn', 129, '2019-02-04', 290, NULL),
('Hampton Inn', 129, '2019-02-05', 122, NULL),
('Hampton Inn', 129, '2019-02-06', 187, NULL),
('Hampton Inn', 129, '2019-02-07', 211, NULL),
('Hampton Inn', 129, '2019-02-08', 210, NULL),
('Hampton Inn', 129, '2019-02-09', 114, NULL),
('Hampton Inn', 129, '2019-02-10', 310, NULL),
('Hampton Inn', 129, '2019-02-11', 239, NULL),
('Hampton Inn', 129, '2019-02-12', 230, NULL),
('Hampton Inn', 129, '2019-02-13', 158, NULL),
('Hampton Inn', 129, '2019-02-14', 297, NULL),
('Hampton Inn', 129, '2019-02-15', 195, NULL),
('Hampton Inn', 129, '2019-02-16', 273, NULL),
('Hampton Inn', 129, '2019-02-17', 241, NULL),
('Hampton Inn', 129, '2019-02-18', 362, NULL),
('Hampton Inn', 129, '2019-02-19', 209, NULL),
('Hampton Inn', 129, '2019-02-20', 129, NULL),
('Hampton Inn', 129, '2019-02-21', 283, NULL),
('Hampton Inn', 129, '2019-02-22', 120, NULL),
('Hampton Inn', 129, '2019-02-23', 361, NULL),
('Hampton Inn', 129, '2019-02-24', 215, NULL),
('Hampton Inn', 129, '2019-02-25', 199, NULL),
('Hampton Inn', 129, '2019-02-26', 163, NULL),
('Hampton Inn', 129, '2019-02-27', 121, NULL),
('Hampton Inn', 129, '2019-02-28', 262, NULL),
('Hampton Inn', 129, '2019-03-01', 308, NULL),
('Hampton Inn', 129, '2019-03-02', 230, NULL),
('Hampton Inn', 129, '2019-03-03', 144, NULL),
('Hampton Inn', 129, '2019-03-04', 158, NULL),
('Hampton Inn', 129, '2019-03-05', 322, NULL),
('Hampton Inn', 129, '2019-03-06', 336, NULL),
('Hampton Inn', 129, '2019-03-07', 156, NULL),
('Hampton Inn', 129, '2019-03-08', 215, NULL),
('Hampton Inn', 129, '2019-03-09', 227, NULL),
('Hampton Inn', 129, '2019-03-10', 178, NULL),
('Hampton Inn', 129, '2019-03-11', 270, NULL),
('Hampton Inn', 129, '2019-03-12', 200, NULL),
('Hampton Inn', 129, '2019-03-13', 314, NULL),
('Hampton Inn', 129, '2019-03-14', 113, NULL),
('Hampton Inn', 129, '2019-03-15', 187, NULL),
('Hampton Inn', 129, '2019-03-16', 243, NULL),
('Hampton Inn', 129, '2019-03-17', 282, NULL),
('Hampton Inn', 129, '2019-03-18', 103, NULL),
('Hampton Inn', 129, '2019-03-19', 138, NULL),
('Hampton Inn', 129, '2019-03-20', 139, NULL),
('Hampton Inn', 129, '2019-03-21', 327, NULL),
('Hampton Inn', 129, '2019-03-22', 340, NULL),
('Hampton Inn', 129, '2019-03-23', 306, NULL),
('Hampton Inn', 129, '2019-03-24', 369, NULL),
('Hampton Inn', 129, '2019-03-25', 235, NULL),
('Hampton Inn', 129, '2019-03-26', 333, NULL),
('Hampton Inn', 129, '2019-03-27', 305, NULL),
('Hampton Inn', 129, '2019-03-28', 222, NULL),
('Hampton Inn', 129, '2019-03-29', 332, NULL),
('Hampton Inn', 129, '2019-03-30', 229, NULL),
('Hampton Inn', 129, '2019-03-31', 146, NULL),
('Hampton Inn', 129, '2019-04-01', 194, NULL),
('Hampton Inn', 129, '2019-04-02', 389, NULL),
('Hampton Inn', 129, '2019-04-03', 160, NULL),
('Hampton Inn', 129, '2019-04-04', 287, NULL),
('Hampton Inn', 129, '2019-04-05', 226, NULL),
('Hampton Inn', 129, '2019-04-06', 366, NULL),
('Hampton Inn', 129, '2019-04-07', 359, NULL),
('Hampton Inn', 129, '2019-04-08', 156, NULL),
('Hampton Inn', 129, '2019-04-09', 141, NULL),
('Hampton Inn', 129, '2019-04-10', 181, NULL),
('Hampton Inn', 129, '2019-04-11', 252, NULL),
('Hampton Inn', 129, '2019-04-12', 231, NULL),
('Hampton Inn', 129, '2019-04-13', 380, NULL),
('Hampton Inn', 129, '2019-04-14', 330, NULL),
('Hampton Inn', 129, '2019-04-15', 390, NULL),
('Hampton Inn', 129, '2019-04-16', 151, NULL),
('Hampton Inn', 129, '2019-04-17', 365, NULL),
('Hampton Inn', 129, '2019-04-18', 155, NULL),
('Hampton Inn', 129, '2019-04-19', 305, NULL),
('Hampton Inn', 129, '2019-04-20', 358, NULL),
('Hampton Inn', 129, '2019-04-21', 366, NULL),
('Hampton Inn', 129, '2019-04-22', 135, NULL),
('Hampton Inn', 129, '2019-04-23', 279, NULL),
('Hampton Inn', 129, '2019-04-24', 116, NULL),
('Hampton Inn', 129, '2019-04-25', 235, NULL),
('Hampton Inn', 129, '2019-04-26', 276, NULL),
('Hampton Inn', 129, '2019-04-27', 152, NULL),
('Hampton Inn', 129, '2019-04-28', 372, NULL),
('Hampton Inn', 129, '2019-04-29', 284, NULL),
('Hampton Inn', 129, '2019-04-30', 175, NULL),
('Hampton Inn', 129, '2019-05-01', 197, NULL),
('Hampton Inn', 129, '2019-05-02', 136, NULL),
('Hampton Inn', 129, '2019-05-03', 192, NULL),
('Hampton Inn', 129, '2019-05-04', 244, NULL),
('Hampton Inn', 129, '2019-05-05', 108, NULL),
('Hampton Inn', 129, '2019-05-06', 172, NULL),
('Hampton Inn', 129, '2019-05-07', 296, NULL),
('Hampton Inn', 129, '2019-05-08', 206, NULL),
('Hampton Inn', 129, '2019-05-09', 259, NULL),
('Hampton Inn', 129, '2019-05-10', 347, NULL),
('Hampton Inn', 129, '2019-05-11', 361, NULL),
('Hampton Inn', 129, '2019-05-12', 232, NULL),
('Hampton Inn', 129, '2019-05-13', 189, NULL),
('Hampton Inn', 129, '2019-05-14', 341, NULL),
('Hampton Inn', 129, '2019-05-15', 275, NULL),
('Hampton Inn', 129, '2019-05-16', 302, NULL),
('Hampton Inn', 129, '2019-05-17', 251, NULL),
('Hampton Inn', 129, '2019-05-18', 195, NULL),
('Hampton Inn', 129, '2019-05-19', 121, NULL),
('Hampton Inn', 129, '2019-05-20', 233, NULL),
('Hampton Inn', 129, '2019-05-21', 350, NULL),
('Hampton Inn', 129, '2019-05-22', 354, NULL),
('Hampton Inn', 129, '2019-05-23', 129, NULL),
('Hampton Inn', 129, '2019-05-24', 118, NULL),
('Hampton Inn', 129, '2019-05-25', 388, NULL),
('Hampton Inn', 129, '2019-05-26', 236, NULL),
('Hampton Inn', 129, '2019-05-27', 344, NULL),
('Hampton Inn', 129, '2019-05-28', 135, NULL),
('Hampton Inn', 129, '2019-05-29', 291, NULL),
('Hampton Inn', 129, '2019-05-30', 297, NULL),
('Hampton Inn', 129, '2019-05-31', 222, NULL),
('Hampton Inn', 129, '2019-06-01', 368, NULL),
('Hampton Inn', 129, '2019-06-02', 254, NULL),
('Hampton Inn', 129, '2019-06-03', 210, NULL),
('Hampton Inn', 129, '2019-06-04', 391, NULL),
('Hampton Inn', 129, '2019-06-05', 286, NULL),
('Hampton Inn', 129, '2019-06-06', 343, NULL),
('Hampton Inn', 129, '2019-06-07', 332, NULL),
('Hampton Inn', 129, '2019-06-08', 155, NULL),
('Hampton Inn', 129, '2019-06-09', 163, NULL),
('Hampton Inn', 129, '2019-06-10', 355, NULL),
('Hampton Inn', 129, '2019-06-11', 341, NULL),
('Hampton Inn', 129, '2019-06-12', 280, NULL),
('Hampton Inn', 129, '2019-06-13', 115, NULL),
('Hampton Inn', 129, '2019-06-14', 211, NULL),
('Hampton Inn', 129, '2019-06-15', 111, NULL),
('Hampton Inn', 129, '2019-06-16', 190, NULL),
('Hampton Inn', 129, '2019-06-17', 123, NULL),
('Hampton Inn', 129, '2019-06-18', 314, NULL),
('Hampton Inn', 129, '2019-06-19', 269, NULL),
('Hampton Inn', 129, '2019-06-20', 342, NULL),
('Hampton Inn', 129, '2019-06-21', 371, NULL),
('Hampton Inn', 129, '2019-06-22', 132, NULL),
('Hampton Inn', 129, '2019-06-23', 389, NULL),
('Hampton Inn', 129, '2019-06-24', 186, NULL),
('Hampton Inn', 129, '2019-06-25', 343, NULL),
('Hampton Inn', 129, '2019-06-26', 223, NULL),
('Hampton Inn', 129, '2019-06-27', 278, NULL),
('Hampton Inn', 129, '2019-06-28', 172, NULL),
('Hampton Inn', 129, '2019-06-29', 377, NULL),
('Hampton Inn', 129, '2019-06-30', 312, NULL),
('Hampton Inn', 129, '2019-07-01', 397, NULL),
('Hampton Inn', 129, '2019-07-02', 341, NULL),
('Hampton Inn', 129, '2019-07-03', 254, NULL),
('Hampton Inn', 129, '2019-07-04', 161, NULL),
('Hampton Inn', 129, '2019-07-05', 173, NULL),
('Hampton Inn', 129, '2019-07-06', 132, NULL),
('Hampton Inn', 129, '2019-07-07', 105, NULL),
('Hampton Inn', 129, '2019-07-08', 108, NULL),
('Hampton Inn', 129, '2019-07-09', 221, NULL),
('Hampton Inn', 129, '2019-07-10', 261, NULL),
('Hampton Inn', 129, '2019-07-11', 270, NULL),
('Hampton Inn', 129, '2019-07-12', 303, NULL),
('Hampton Inn', 129, '2019-07-13', 118, NULL),
('Hampton Inn', 129, '2019-07-14', 153, NULL),
('Hampton Inn', 129, '2019-07-15', 210, NULL),
('Hampton Inn', 129, '2019-07-16', 149, NULL),
('Hampton Inn', 129, '2019-07-17', 367, NULL),
('Hampton Inn', 129, '2019-07-18', 101, NULL),
('Hampton Inn', 129, '2019-07-19', 302, NULL),
('Hampton Inn', 129, '2019-07-20', 227, NULL),
('Hampton Inn', 129, '2019-07-21', 367, NULL),
('Hampton Inn', 129, '2019-07-22', 313, NULL),
('Hampton Inn', 129, '2019-07-23', 174, NULL),
('Hampton Inn', 129, '2019-07-24', 309, NULL),
('Hampton Inn', 129, '2019-07-25', 308, NULL),
('Hampton Inn', 129, '2019-07-26', 312, NULL),
('Hampton Inn', 129, '2019-07-27', 323, NULL),
('Hampton Inn', 129, '2019-07-28', 228, NULL),
('Hampton Inn', 129, '2019-07-29', 280, NULL),
('Hampton Inn', 129, '2019-07-30', 184, NULL),
('Hampton Inn', 129, '2019-07-31', 150, NULL),
('Hampton Inn', 129, '2019-08-01', 234, NULL),
('Hampton Inn', 129, '2019-08-02', 206, NULL),
('Hampton Inn', 129, '2019-08-03', 253, NULL),
('Hampton Inn', 129, '2019-08-04', 177, NULL),
('Hampton Inn', 129, '2019-08-05', 331, NULL),
('Hampton Inn', 129, '2019-08-06', 335, NULL),
('Hampton Inn', 129, '2019-08-07', 390, NULL),
('Hampton Inn', 129, '2019-08-08', 166, NULL),
('Hampton Inn', 129, '2019-08-09', 355, NULL),
('Hampton Inn', 129, '2019-08-10', 344, NULL),
('Hampton Inn', 129, '2019-08-11', 170, NULL),
('Hampton Inn', 129, '2019-08-12', 174, NULL),
('Hampton Inn', 129, '2019-08-13', 291, NULL),
('Hampton Inn', 129, '2019-08-14', 116, NULL),
('Hampton Inn', 129, '2019-08-15', 379, NULL),
('Hampton Inn', 129, '2019-08-16', 385, NULL),
('Hampton Inn', 129, '2019-08-17', 212, NULL),
('Hampton Inn', 129, '2019-08-18', 355, NULL),
('Hampton Inn', 129, '2019-08-19', 251, NULL),
('Hampton Inn', 129, '2019-08-20', 129, NULL),
('Hampton Inn', 129, '2019-08-21', 339, NULL),
('Hampton Inn', 129, '2019-08-22', 394, NULL),
('Hampton Inn', 129, '2019-08-23', 108, NULL),
('Hampton Inn', 129, '2019-08-24', 220, NULL),
('Hampton Inn', 129, '2019-08-25', 280, NULL),
('Hampton Inn', 129, '2019-08-26', 287, NULL),
('Hampton Inn', 129, '2019-08-27', 151, NULL),
('Hampton Inn', 129, '2019-08-28', 126, NULL),
('Hampton Inn', 129, '2019-08-29', 355, NULL),
('Hampton Inn', 129, '2019-08-30', 387, NULL),
('Hampton Inn', 129, '2019-08-31', 364, NULL),
('Hampton Inn', 129, '2019-09-01', 156, NULL),
('Hampton Inn', 129, '2019-09-02', 208, NULL),
('Hampton Inn', 129, '2019-09-03', 185, NULL),
('Hampton Inn', 129, '2019-09-04', 319, NULL),
('Hampton Inn', 129, '2019-09-05', 233, NULL),
('Hampton Inn', 129, '2019-09-06', 359, NULL),
('Hampton Inn', 129, '2019-09-07', 377, NULL),
('Hampton Inn', 129, '2019-09-08', 129, NULL),
('Hampton Inn', 129, '2019-09-09', 132, NULL),
('Hampton Inn', 129, '2019-09-10', 255, NULL),
('Hampton Inn', 129, '2019-09-11', 385, NULL),
('Hampton Inn', 129, '2019-09-12', 290, NULL),
('Hampton Inn', 129, '2019-09-13', 256, NULL),
('Hampton Inn', 129, '2019-09-14', 396, NULL),
('Hampton Inn', 129, '2019-09-15', 391, NULL),
('Hampton Inn', 129, '2019-09-16', 311, NULL),
('Hampton Inn', 129, '2019-09-17', 210, NULL),
('Hampton Inn', 129, '2019-09-18', 383, NULL),
('Hampton Inn', 129, '2019-09-19', 240, NULL),
('Hampton Inn', 129, '2019-09-20', 391, NULL),
('Hampton Inn', 129, '2019-09-21', 261, NULL),
('Hampton Inn', 129, '2019-09-22', 244, NULL),
('Hampton Inn', 129, '2019-09-23', 118, NULL),
('Hampton Inn', 129, '2019-09-24', 175, NULL),
('Hampton Inn', 129, '2019-09-25', 224, NULL),
('Hampton Inn', 129, '2019-09-26', 376, NULL),
('Hampton Inn', 129, '2019-09-27', 381, NULL),
('Hampton Inn', 129, '2019-09-28', 119, NULL),
('Hampton Inn', 129, '2019-09-29', 198, NULL),
('Hampton Inn', 129, '2019-09-30', 390, NULL),
('Hampton Inn', 129, '2019-10-01', 269, NULL),
('Hampton Inn', 129, '2019-10-02', 179, NULL),
('Hampton Inn', 129, '2019-10-03', 111, NULL),
('Hampton Inn', 129, '2019-10-04', 216, NULL),
('Hampton Inn', 129, '2019-10-05', 134, NULL),
('Hampton Inn', 129, '2019-10-06', 245, NULL),
('Hampton Inn', 129, '2019-10-07', 217, NULL),
('Hampton Inn', 129, '2019-10-08', 385, NULL),
('Hampton Inn', 129, '2019-10-09', 134, NULL),
('Hampton Inn', 129, '2019-10-10', 244, NULL),
('Hampton Inn', 129, '2019-10-11', 260, NULL),
('Hampton Inn', 129, '2019-10-12', 331, NULL),
('Hampton Inn', 129, '2019-10-13', 197, NULL),
('Hampton Inn', 129, '2019-10-14', 284, NULL),
('Hampton Inn', 129, '2019-10-15', 272, NULL),
('Hampton Inn', 129, '2019-10-16', 106, NULL),
('Hampton Inn', 129, '2019-10-17', 208, NULL),
('Hampton Inn', 129, '2019-10-18', 355, NULL),
('Hampton Inn', 129, '2019-10-19', 269, NULL),
('Hampton Inn', 129, '2019-10-20', 134, NULL),
('Hampton Inn', 129, '2019-10-21', 150, NULL),
('Hampton Inn', 129, '2019-10-22', 105, NULL),
('Hampton Inn', 129, '2019-10-23', 329, NULL),
('Hampton Inn', 129, '2019-10-24', 229, NULL),
('Hampton Inn', 129, '2019-10-25', 105, NULL),
('Hampton Inn', 129, '2019-10-26', 220, NULL),
('Hampton Inn', 129, '2019-10-27', 173, NULL),
('Hampton Inn', 129, '2019-10-28', 390, NULL),
('Hampton Inn', 129, '2019-10-29', 291, NULL),
('Hampton Inn', 129, '2019-10-30', 277, NULL),
('Hampton Inn', 129, '2019-10-31', 311, NULL),
('Hampton Inn', 129, '2019-11-01', 252, NULL),
('Hampton Inn', 129, '2019-11-02', 380, NULL),
('Hampton Inn', 129, '2019-11-03', 343, NULL),
('Hampton Inn', 129, '2019-11-04', 339, NULL),
('Hampton Inn', 129, '2019-11-05', 363, NULL),
('Hampton Inn', 129, '2019-11-06', 199, NULL),
('Hampton Inn', 129, '2019-11-07', 248, NULL),
('Hampton Inn', 129, '2019-11-08', 393, NULL),
('Hampton Inn', 129, '2019-11-09', 128, NULL),
('Hampton Inn', 129, '2019-11-10', 135, NULL),
('Hampton Inn', 129, '2019-11-11', 145, NULL),
('Hampton Inn', 129, '2019-11-12', 185, NULL),
('Hampton Inn', 129, '2019-11-13', 118, NULL),
('Hampton Inn', 129, '2019-11-14', 266, NULL),
('Hampton Inn', 129, '2019-11-15', 192, NULL),
('Hampton Inn', 129, '2019-11-16', 235, NULL),
('Hampton Inn', 129, '2019-11-17', 253, NULL),
('Hampton Inn', 129, '2019-11-18', 156, NULL),
('Hampton Inn', 129, '2019-11-19', 389, NULL),
('Hampton Inn', 129, '2019-11-20', 346, NULL),
('Hampton Inn', 129, '2019-11-21', 180, NULL),
('Hampton Inn', 129, '2019-11-22', 109, NULL),
('Hampton Inn', 129, '2019-11-23', 262, NULL),
('Hampton Inn', 129, '2019-11-24', 267, NULL),
('Hampton Inn', 129, '2019-11-25', 204, NULL),
('Hampton Inn', 129, '2019-11-26', 281, NULL),
('Hampton Inn', 129, '2019-11-27', 309, NULL),
('Hampton Inn', 129, '2019-11-28', 312, NULL),
('Hampton Inn', 129, '2019-11-29', 259, NULL),
('Hampton Inn', 129, '2019-11-30', 108, NULL),
('Hampton Inn', 129, '2019-12-01', 191, NULL),
('Hampton Inn', 129, '2019-12-02', 174, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 129, '2019-12-03', 257, NULL),
('Hampton Inn', 129, '2019-12-04', 269, NULL),
('Hampton Inn', 129, '2019-12-05', 287, NULL),
('Hampton Inn', 129, '2019-12-06', 233, NULL),
('Hampton Inn', 129, '2019-12-07', 223, NULL),
('Hampton Inn', 129, '2019-12-08', 240, NULL),
('Hampton Inn', 129, '2019-12-09', 309, NULL),
('Hampton Inn', 129, '2019-12-10', 381, NULL),
('Hampton Inn', 129, '2019-12-11', 224, NULL),
('Hampton Inn', 129, '2019-12-12', 351, NULL),
('Hampton Inn', 129, '2019-12-13', 308, NULL),
('Hampton Inn', 129, '2019-12-14', 128, NULL),
('Hampton Inn', 129, '2019-12-15', 127, NULL),
('Hampton Inn', 129, '2019-12-16', 332, NULL),
('Hampton Inn', 129, '2019-12-17', 385, NULL),
('Hampton Inn', 129, '2019-12-18', 357, NULL),
('Hampton Inn', 129, '2019-12-19', 255, NULL),
('Hampton Inn', 129, '2019-12-20', 263, NULL),
('Hampton Inn', 129, '2019-12-21', 192, NULL),
('Hampton Inn', 129, '2019-12-22', 286, NULL),
('Hampton Inn', 129, '2019-12-23', 238, NULL),
('Hampton Inn', 129, '2019-12-24', 375, NULL),
('Hampton Inn', 129, '2019-12-25', 143, NULL),
('Hampton Inn', 129, '2019-12-26', 253, NULL),
('Hampton Inn', 129, '2019-12-27', 247, NULL),
('Hampton Inn', 129, '2019-12-28', 147, NULL),
('Hampton Inn', 129, '2019-12-29', 156, NULL),
('Hampton Inn', 129, '2019-12-30', 129, NULL),
('Hampton Inn', 129, '2019-12-31', 207, NULL),
('Hampton Inn', 129, '2020-01-01', 129, NULL),
('Hampton Inn', 129, '2020-01-02', 335, NULL),
('Hampton Inn', 129, '2020-01-03', 335, NULL),
('Hampton Inn', 129, '2020-01-04', 226, NULL),
('Hampton Inn', 129, '2020-01-05', 253, NULL),
('Hampton Inn', 129, '2020-01-06', 259, NULL),
('Hampton Inn', 129, '2020-01-07', 395, NULL),
('Hampton Inn', 129, '2020-01-08', 205, NULL),
('Hampton Inn', 129, '2020-01-09', 102, NULL),
('Hampton Inn', 129, '2020-01-10', 126, NULL),
('Hampton Inn', 129, '2020-01-11', 115, NULL),
('Hampton Inn', 129, '2020-01-12', 283, NULL),
('Hampton Inn', 129, '2020-01-13', 371, NULL),
('Hampton Inn', 129, '2020-01-14', 296, NULL),
('Hampton Inn', 129, '2020-01-15', 124, NULL),
('Hampton Inn', 129, '2020-01-16', 149, NULL),
('Hampton Inn', 129, '2020-01-17', 282, NULL),
('Hampton Inn', 129, '2020-01-18', 262, NULL),
('Hampton Inn', 129, '2020-01-19', 140, NULL),
('Hampton Inn', 129, '2020-01-20', 240, NULL),
('Hampton Inn', 129, '2020-01-21', 259, NULL),
('Hampton Inn', 129, '2020-01-22', 256, NULL),
('Hampton Inn', 129, '2020-01-23', 352, NULL),
('Hampton Inn', 129, '2020-01-24', 226, NULL),
('Hampton Inn', 129, '2020-01-25', 270, NULL),
('Hampton Inn', 129, '2020-01-26', 399, NULL),
('Hampton Inn', 129, '2020-01-27', 329, NULL),
('Hampton Inn', 129, '2020-01-28', 149, NULL),
('Hampton Inn', 129, '2020-01-29', 390, NULL),
('Hampton Inn', 129, '2020-01-30', 306, NULL),
('Hampton Inn', 129, '2020-01-31', 193, NULL),
('Hampton Inn', 129, '2020-02-01', 244, NULL),
('Hampton Inn', 129, '2020-02-02', 250, NULL),
('Hampton Inn', 129, '2020-02-03', 382, NULL),
('Hampton Inn', 129, '2020-02-04', 130, NULL),
('Hampton Inn', 142, '2019-01-01', 358, NULL),
('Hampton Inn', 142, '2019-01-02', 338, NULL),
('Hampton Inn', 142, '2019-01-03', 312, NULL),
('Hampton Inn', 142, '2019-01-04', 284, NULL),
('Hampton Inn', 142, '2019-01-05', 101, NULL),
('Hampton Inn', 142, '2019-01-06', 134, NULL),
('Hampton Inn', 142, '2019-01-07', 224, NULL),
('Hampton Inn', 142, '2019-01-08', 228, NULL),
('Hampton Inn', 142, '2019-01-09', 377, NULL),
('Hampton Inn', 142, '2019-01-10', 319, NULL),
('Hampton Inn', 142, '2019-01-11', 134, NULL),
('Hampton Inn', 142, '2019-01-12', 360, NULL),
('Hampton Inn', 142, '2019-01-13', 228, NULL),
('Hampton Inn', 142, '2019-01-14', 388, NULL),
('Hampton Inn', 142, '2019-01-15', 236, NULL),
('Hampton Inn', 142, '2019-01-16', 328, NULL),
('Hampton Inn', 142, '2019-01-17', 139, NULL),
('Hampton Inn', 142, '2019-01-18', 344, NULL),
('Hampton Inn', 142, '2019-01-19', 204, NULL),
('Hampton Inn', 142, '2019-01-20', 280, NULL),
('Hampton Inn', 142, '2019-01-21', 333, NULL),
('Hampton Inn', 142, '2019-01-22', 335, NULL),
('Hampton Inn', 142, '2019-01-23', 274, NULL),
('Hampton Inn', 142, '2019-01-24', 252, NULL),
('Hampton Inn', 142, '2019-01-25', 182, NULL),
('Hampton Inn', 142, '2019-01-26', 286, NULL),
('Hampton Inn', 142, '2019-01-27', 126, NULL),
('Hampton Inn', 142, '2019-01-28', 157, NULL),
('Hampton Inn', 142, '2019-01-29', 264, NULL),
('Hampton Inn', 142, '2019-01-30', 174, NULL),
('Hampton Inn', 142, '2019-01-31', 338, NULL),
('Hampton Inn', 142, '2019-02-01', 274, NULL),
('Hampton Inn', 142, '2019-02-02', 384, NULL),
('Hampton Inn', 142, '2019-02-03', 335, NULL),
('Hampton Inn', 142, '2019-02-04', 251, NULL),
('Hampton Inn', 142, '2019-02-05', 378, NULL),
('Hampton Inn', 142, '2019-02-06', 382, NULL),
('Hampton Inn', 142, '2019-02-07', 256, NULL),
('Hampton Inn', 142, '2019-02-08', 388, NULL),
('Hampton Inn', 142, '2019-02-09', 318, NULL),
('Hampton Inn', 142, '2019-02-10', 155, NULL),
('Hampton Inn', 142, '2019-02-11', 157, NULL),
('Hampton Inn', 142, '2019-02-12', 318, NULL),
('Hampton Inn', 142, '2019-02-13', 218, NULL),
('Hampton Inn', 142, '2019-02-14', 257, NULL),
('Hampton Inn', 142, '2019-02-15', 273, NULL),
('Hampton Inn', 142, '2019-02-16', 141, NULL),
('Hampton Inn', 142, '2019-02-17', 384, NULL),
('Hampton Inn', 142, '2019-02-18', 169, NULL),
('Hampton Inn', 142, '2019-02-19', 272, NULL),
('Hampton Inn', 142, '2019-02-20', 169, NULL),
('Hampton Inn', 142, '2019-02-21', 263, NULL),
('Hampton Inn', 142, '2019-02-22', 246, NULL),
('Hampton Inn', 142, '2019-02-23', 229, NULL),
('Hampton Inn', 142, '2019-02-24', 378, NULL),
('Hampton Inn', 142, '2019-02-25', 210, NULL),
('Hampton Inn', 142, '2019-02-26', 379, NULL),
('Hampton Inn', 142, '2019-02-27', 114, NULL),
('Hampton Inn', 142, '2019-02-28', 247, NULL),
('Hampton Inn', 142, '2019-03-01', 143, NULL),
('Hampton Inn', 142, '2019-03-02', 269, NULL),
('Hampton Inn', 142, '2019-03-03', 131, NULL),
('Hampton Inn', 142, '2019-03-04', 137, NULL),
('Hampton Inn', 142, '2019-03-05', 257, NULL),
('Hampton Inn', 142, '2019-03-06', 193, NULL),
('Hampton Inn', 142, '2019-03-07', 172, NULL),
('Hampton Inn', 142, '2019-03-08', 380, NULL),
('Hampton Inn', 142, '2019-03-09', 287, NULL),
('Hampton Inn', 142, '2019-03-10', 385, NULL),
('Hampton Inn', 142, '2019-03-11', 231, NULL),
('Hampton Inn', 142, '2019-03-12', 121, NULL),
('Hampton Inn', 142, '2019-03-13', 281, NULL),
('Hampton Inn', 142, '2019-03-14', 344, NULL),
('Hampton Inn', 142, '2019-03-15', 366, NULL),
('Hampton Inn', 142, '2019-03-16', 377, NULL),
('Hampton Inn', 142, '2019-03-17', 245, NULL),
('Hampton Inn', 142, '2019-03-18', 293, NULL),
('Hampton Inn', 142, '2019-03-19', 191, NULL),
('Hampton Inn', 142, '2019-03-20', 388, NULL),
('Hampton Inn', 142, '2019-03-21', 370, NULL),
('Hampton Inn', 142, '2019-03-22', 261, NULL),
('Hampton Inn', 142, '2019-03-23', 114, NULL),
('Hampton Inn', 142, '2019-03-24', 179, NULL),
('Hampton Inn', 142, '2019-03-25', 177, NULL),
('Hampton Inn', 142, '2019-03-26', 263, NULL),
('Hampton Inn', 142, '2019-03-27', 163, NULL),
('Hampton Inn', 142, '2019-03-28', 366, NULL),
('Hampton Inn', 142, '2019-03-29', 226, NULL),
('Hampton Inn', 142, '2019-03-30', 187, NULL),
('Hampton Inn', 142, '2019-03-31', 346, NULL),
('Hampton Inn', 142, '2019-04-01', 310, NULL),
('Hampton Inn', 142, '2019-04-02', 217, NULL),
('Hampton Inn', 142, '2019-04-03', 107, NULL),
('Hampton Inn', 142, '2019-04-04', 223, NULL),
('Hampton Inn', 142, '2019-04-05', 380, NULL),
('Hampton Inn', 142, '2019-04-06', 107, NULL),
('Hampton Inn', 142, '2019-04-07', 358, NULL),
('Hampton Inn', 142, '2019-04-08', 397, NULL),
('Hampton Inn', 142, '2019-04-09', 203, NULL),
('Hampton Inn', 142, '2019-04-10', 152, NULL),
('Hampton Inn', 142, '2019-04-11', 361, NULL),
('Hampton Inn', 142, '2019-04-12', 279, NULL),
('Hampton Inn', 142, '2019-04-13', 110, NULL),
('Hampton Inn', 142, '2019-04-14', 179, NULL),
('Hampton Inn', 142, '2019-04-15', 362, NULL),
('Hampton Inn', 142, '2019-04-16', 132, NULL),
('Hampton Inn', 142, '2019-04-17', 105, NULL),
('Hampton Inn', 142, '2019-04-18', 215, NULL),
('Hampton Inn', 142, '2019-04-19', 250, NULL),
('Hampton Inn', 142, '2019-04-20', 382, NULL),
('Hampton Inn', 142, '2019-04-21', 342, NULL),
('Hampton Inn', 142, '2019-04-22', 375, NULL),
('Hampton Inn', 142, '2019-04-23', 254, NULL),
('Hampton Inn', 142, '2019-04-24', 290, NULL),
('Hampton Inn', 142, '2019-04-25', 118, NULL),
('Hampton Inn', 142, '2019-04-26', 167, NULL),
('Hampton Inn', 142, '2019-04-27', 136, NULL),
('Hampton Inn', 142, '2019-04-28', 227, NULL),
('Hampton Inn', 142, '2019-04-29', 317, NULL),
('Hampton Inn', 142, '2019-04-30', 296, NULL),
('Hampton Inn', 142, '2019-05-01', 287, NULL),
('Hampton Inn', 142, '2019-05-02', 177, NULL),
('Hampton Inn', 142, '2019-05-03', 220, NULL),
('Hampton Inn', 142, '2019-05-04', 132, NULL),
('Hampton Inn', 142, '2019-05-05', 249, NULL),
('Hampton Inn', 142, '2019-05-06', 228, NULL),
('Hampton Inn', 142, '2019-05-07', 138, NULL),
('Hampton Inn', 142, '2019-05-08', 221, NULL),
('Hampton Inn', 142, '2019-05-09', 345, NULL),
('Hampton Inn', 142, '2019-05-10', 277, NULL),
('Hampton Inn', 142, '2019-05-11', 180, NULL),
('Hampton Inn', 142, '2019-05-12', 349, NULL),
('Hampton Inn', 142, '2019-05-13', 271, NULL),
('Hampton Inn', 142, '2019-05-14', 184, NULL),
('Hampton Inn', 142, '2019-05-15', 347, NULL),
('Hampton Inn', 142, '2019-05-16', 250, NULL),
('Hampton Inn', 142, '2019-05-17', 213, NULL),
('Hampton Inn', 142, '2019-05-18', 370, NULL),
('Hampton Inn', 142, '2019-05-19', 202, NULL),
('Hampton Inn', 142, '2019-05-20', 197, NULL),
('Hampton Inn', 142, '2019-05-21', 326, NULL),
('Hampton Inn', 142, '2019-05-22', 104, NULL),
('Hampton Inn', 142, '2019-05-23', 240, NULL),
('Hampton Inn', 142, '2019-05-24', 307, NULL),
('Hampton Inn', 142, '2019-05-25', 270, NULL),
('Hampton Inn', 142, '2019-05-26', 334, NULL),
('Hampton Inn', 142, '2019-05-27', 141, NULL),
('Hampton Inn', 142, '2019-05-28', 115, NULL),
('Hampton Inn', 142, '2019-05-29', 276, NULL),
('Hampton Inn', 142, '2019-05-30', 207, NULL),
('Hampton Inn', 142, '2019-05-31', 301, NULL),
('Hampton Inn', 142, '2019-06-01', 217, NULL),
('Hampton Inn', 142, '2019-06-02', 221, NULL),
('Hampton Inn', 142, '2019-06-03', 394, NULL),
('Hampton Inn', 142, '2019-06-04', 299, NULL),
('Hampton Inn', 142, '2019-06-05', 211, NULL),
('Hampton Inn', 142, '2019-06-06', 263, NULL),
('Hampton Inn', 142, '2019-06-07', 207, NULL),
('Hampton Inn', 142, '2019-06-08', 139, NULL),
('Hampton Inn', 142, '2019-06-09', 268, NULL),
('Hampton Inn', 142, '2019-06-10', 199, NULL),
('Hampton Inn', 142, '2019-06-11', 284, NULL),
('Hampton Inn', 142, '2019-06-12', 150, NULL),
('Hampton Inn', 142, '2019-06-13', 221, NULL),
('Hampton Inn', 142, '2019-06-14', 212, NULL),
('Hampton Inn', 142, '2019-06-15', 187, NULL),
('Hampton Inn', 142, '2019-06-16', 182, NULL),
('Hampton Inn', 142, '2019-06-17', 138, NULL),
('Hampton Inn', 142, '2019-06-18', 140, NULL),
('Hampton Inn', 142, '2019-06-19', 398, NULL),
('Hampton Inn', 142, '2019-06-20', 183, NULL),
('Hampton Inn', 142, '2019-06-21', 259, NULL),
('Hampton Inn', 142, '2019-06-22', 393, NULL),
('Hampton Inn', 142, '2019-06-23', 277, NULL),
('Hampton Inn', 142, '2019-06-24', 104, NULL),
('Hampton Inn', 142, '2019-06-25', 161, NULL),
('Hampton Inn', 142, '2019-06-26', 151, NULL),
('Hampton Inn', 142, '2019-06-27', 223, NULL),
('Hampton Inn', 142, '2019-06-28', 243, NULL),
('Hampton Inn', 142, '2019-06-29', 267, NULL),
('Hampton Inn', 142, '2019-06-30', 351, NULL),
('Hampton Inn', 142, '2019-07-01', 351, NULL),
('Hampton Inn', 142, '2019-07-02', 298, NULL),
('Hampton Inn', 142, '2019-07-03', 140, NULL),
('Hampton Inn', 142, '2019-07-04', 317, NULL),
('Hampton Inn', 142, '2019-07-05', 335, NULL),
('Hampton Inn', 142, '2019-07-06', 243, NULL),
('Hampton Inn', 142, '2019-07-07', 165, NULL),
('Hampton Inn', 142, '2019-07-08', 357, NULL),
('Hampton Inn', 142, '2019-07-09', 106, NULL),
('Hampton Inn', 142, '2019-07-10', 396, NULL),
('Hampton Inn', 142, '2019-07-11', 189, NULL),
('Hampton Inn', 142, '2019-07-12', 351, NULL),
('Hampton Inn', 142, '2019-07-13', 108, NULL),
('Hampton Inn', 142, '2019-07-14', 208, NULL),
('Hampton Inn', 142, '2019-07-15', 319, NULL),
('Hampton Inn', 142, '2019-07-16', 255, NULL),
('Hampton Inn', 142, '2019-07-17', 150, NULL),
('Hampton Inn', 142, '2019-07-18', 202, NULL),
('Hampton Inn', 142, '2019-07-19', 278, NULL),
('Hampton Inn', 142, '2019-07-20', 315, NULL),
('Hampton Inn', 142, '2019-07-21', 307, NULL),
('Hampton Inn', 142, '2019-07-22', 147, NULL),
('Hampton Inn', 142, '2019-07-23', 242, NULL),
('Hampton Inn', 142, '2019-07-24', 272, NULL),
('Hampton Inn', 142, '2019-07-25', 354, NULL),
('Hampton Inn', 142, '2019-07-26', 277, NULL),
('Hampton Inn', 142, '2019-07-27', 142, NULL),
('Hampton Inn', 142, '2019-07-28', 360, NULL),
('Hampton Inn', 142, '2019-07-29', 120, NULL),
('Hampton Inn', 142, '2019-07-30', 355, NULL),
('Hampton Inn', 142, '2019-07-31', 238, NULL),
('Hampton Inn', 142, '2019-08-01', 307, NULL),
('Hampton Inn', 142, '2019-08-02', 379, NULL),
('Hampton Inn', 142, '2019-08-03', 322, NULL),
('Hampton Inn', 142, '2019-08-04', 316, NULL),
('Hampton Inn', 142, '2019-08-05', 324, NULL),
('Hampton Inn', 142, '2019-08-06', 171, NULL),
('Hampton Inn', 142, '2019-08-07', 203, NULL),
('Hampton Inn', 142, '2019-08-08', 167, NULL),
('Hampton Inn', 142, '2019-08-09', 281, NULL),
('Hampton Inn', 142, '2019-08-10', 218, NULL),
('Hampton Inn', 142, '2019-08-11', 120, NULL),
('Hampton Inn', 142, '2019-08-12', 286, NULL),
('Hampton Inn', 142, '2019-08-13', 376, NULL),
('Hampton Inn', 142, '2019-08-14', 391, NULL),
('Hampton Inn', 142, '2019-08-15', 248, NULL),
('Hampton Inn', 142, '2019-08-16', 200, NULL),
('Hampton Inn', 142, '2019-08-17', 124, NULL),
('Hampton Inn', 142, '2019-08-18', 138, NULL),
('Hampton Inn', 142, '2019-08-19', 221, NULL),
('Hampton Inn', 142, '2019-08-20', 379, NULL),
('Hampton Inn', 142, '2019-08-21', 197, NULL),
('Hampton Inn', 142, '2019-08-22', 386, NULL),
('Hampton Inn', 142, '2019-08-23', 195, NULL),
('Hampton Inn', 142, '2019-08-24', 368, NULL),
('Hampton Inn', 142, '2019-08-25', 192, NULL),
('Hampton Inn', 142, '2019-08-26', 236, NULL),
('Hampton Inn', 142, '2019-08-27', 305, NULL),
('Hampton Inn', 142, '2019-08-28', 149, NULL),
('Hampton Inn', 142, '2019-08-29', 374, NULL),
('Hampton Inn', 142, '2019-08-30', 193, NULL),
('Hampton Inn', 142, '2019-08-31', 230, NULL),
('Hampton Inn', 142, '2019-09-01', 266, NULL),
('Hampton Inn', 142, '2019-09-02', 203, NULL),
('Hampton Inn', 142, '2019-09-03', 248, NULL),
('Hampton Inn', 142, '2019-09-04', 234, NULL),
('Hampton Inn', 142, '2019-09-05', 119, NULL),
('Hampton Inn', 142, '2019-09-06', 327, NULL),
('Hampton Inn', 142, '2019-09-07', 146, NULL),
('Hampton Inn', 142, '2019-09-08', 317, NULL),
('Hampton Inn', 142, '2019-09-09', 281, NULL),
('Hampton Inn', 142, '2019-09-10', 357, NULL),
('Hampton Inn', 142, '2019-09-11', 290, NULL),
('Hampton Inn', 142, '2019-09-12', 127, NULL),
('Hampton Inn', 142, '2019-09-13', 114, NULL),
('Hampton Inn', 142, '2019-09-14', 374, NULL),
('Hampton Inn', 142, '2019-09-15', 216, NULL),
('Hampton Inn', 142, '2019-09-16', 383, NULL),
('Hampton Inn', 142, '2019-09-17', 199, NULL),
('Hampton Inn', 142, '2019-09-18', 325, NULL),
('Hampton Inn', 142, '2019-09-19', 163, NULL),
('Hampton Inn', 142, '2019-09-20', 286, NULL),
('Hampton Inn', 142, '2019-09-21', 308, NULL),
('Hampton Inn', 142, '2019-09-22', 223, NULL),
('Hampton Inn', 142, '2019-09-23', 166, NULL),
('Hampton Inn', 142, '2019-09-24', 340, NULL),
('Hampton Inn', 142, '2019-09-25', 227, NULL),
('Hampton Inn', 142, '2019-09-26', 256, NULL),
('Hampton Inn', 142, '2019-09-27', 198, NULL),
('Hampton Inn', 142, '2019-09-28', 152, NULL),
('Hampton Inn', 142, '2019-09-29', 302, NULL),
('Hampton Inn', 142, '2019-09-30', 173, NULL),
('Hampton Inn', 142, '2019-10-01', 315, NULL),
('Hampton Inn', 142, '2019-10-02', 315, NULL),
('Hampton Inn', 142, '2019-10-03', 381, NULL),
('Hampton Inn', 142, '2019-10-04', 151, NULL),
('Hampton Inn', 142, '2019-10-05', 343, NULL),
('Hampton Inn', 142, '2019-10-06', 219, NULL),
('Hampton Inn', 142, '2019-10-07', 127, NULL),
('Hampton Inn', 142, '2019-10-08', 247, NULL),
('Hampton Inn', 142, '2019-10-09', 141, NULL),
('Hampton Inn', 142, '2019-10-10', 356, NULL),
('Hampton Inn', 142, '2019-10-11', 248, NULL),
('Hampton Inn', 142, '2019-10-12', 175, NULL),
('Hampton Inn', 142, '2019-10-13', 262, NULL),
('Hampton Inn', 142, '2019-10-14', 364, NULL),
('Hampton Inn', 142, '2019-10-15', 333, NULL),
('Hampton Inn', 142, '2019-10-16', 109, NULL),
('Hampton Inn', 142, '2019-10-17', 157, NULL),
('Hampton Inn', 142, '2019-10-18', 236, NULL),
('Hampton Inn', 142, '2019-10-19', 142, NULL),
('Hampton Inn', 142, '2019-10-20', 336, NULL),
('Hampton Inn', 142, '2019-10-21', 255, NULL),
('Hampton Inn', 142, '2019-10-22', 123, NULL),
('Hampton Inn', 142, '2019-10-23', 262, NULL),
('Hampton Inn', 142, '2019-10-24', 107, NULL),
('Hampton Inn', 142, '2019-10-25', 310, NULL),
('Hampton Inn', 142, '2019-10-26', 111, NULL),
('Hampton Inn', 142, '2019-10-27', 254, NULL),
('Hampton Inn', 142, '2019-10-28', 164, NULL),
('Hampton Inn', 142, '2019-10-29', 353, NULL),
('Hampton Inn', 142, '2019-10-30', 195, NULL),
('Hampton Inn', 142, '2019-10-31', 358, NULL),
('Hampton Inn', 142, '2019-11-01', 179, NULL),
('Hampton Inn', 142, '2019-11-02', 303, NULL),
('Hampton Inn', 142, '2019-11-03', 135, NULL),
('Hampton Inn', 142, '2019-11-04', 300, NULL),
('Hampton Inn', 142, '2019-11-05', 132, NULL),
('Hampton Inn', 142, '2019-11-06', 163, NULL),
('Hampton Inn', 142, '2019-11-07', 151, NULL),
('Hampton Inn', 142, '2019-11-08', 215, NULL),
('Hampton Inn', 142, '2019-11-09', 336, NULL),
('Hampton Inn', 142, '2019-11-10', 249, NULL),
('Hampton Inn', 142, '2019-11-11', 275, NULL),
('Hampton Inn', 142, '2019-11-12', 379, NULL),
('Hampton Inn', 142, '2019-11-13', 312, NULL),
('Hampton Inn', 142, '2019-11-14', 147, NULL),
('Hampton Inn', 142, '2019-11-15', 104, NULL),
('Hampton Inn', 142, '2019-11-16', 198, NULL),
('Hampton Inn', 142, '2019-11-17', 260, NULL),
('Hampton Inn', 142, '2019-11-18', 167, NULL),
('Hampton Inn', 142, '2019-11-19', 355, NULL),
('Hampton Inn', 142, '2019-11-20', 280, NULL),
('Hampton Inn', 142, '2019-11-21', 208, NULL),
('Hampton Inn', 142, '2019-11-22', 211, NULL),
('Hampton Inn', 142, '2019-11-23', 108, NULL),
('Hampton Inn', 142, '2019-11-24', 391, NULL),
('Hampton Inn', 142, '2019-11-25', 220, NULL),
('Hampton Inn', 142, '2019-11-26', 379, NULL),
('Hampton Inn', 142, '2019-11-27', 100, NULL),
('Hampton Inn', 142, '2019-11-28', 344, NULL),
('Hampton Inn', 142, '2019-11-29', 150, NULL),
('Hampton Inn', 142, '2019-11-30', 335, NULL),
('Hampton Inn', 142, '2019-12-01', 281, NULL),
('Hampton Inn', 142, '2019-12-02', 336, NULL),
('Hampton Inn', 142, '2019-12-03', 332, NULL),
('Hampton Inn', 142, '2019-12-04', 103, NULL),
('Hampton Inn', 142, '2019-12-05', 143, NULL),
('Hampton Inn', 142, '2019-12-06', 230, NULL),
('Hampton Inn', 142, '2019-12-07', 299, NULL),
('Hampton Inn', 142, '2019-12-08', 248, NULL),
('Hampton Inn', 142, '2019-12-09', 129, NULL),
('Hampton Inn', 142, '2019-12-10', 161, NULL),
('Hampton Inn', 142, '2019-12-11', 230, NULL),
('Hampton Inn', 142, '2019-12-12', 291, NULL),
('Hampton Inn', 142, '2019-12-13', 200, NULL),
('Hampton Inn', 142, '2019-12-14', 163, NULL),
('Hampton Inn', 142, '2019-12-15', 264, NULL),
('Hampton Inn', 142, '2019-12-16', 186, NULL),
('Hampton Inn', 142, '2019-12-17', 250, NULL),
('Hampton Inn', 142, '2019-12-18', 286, NULL),
('Hampton Inn', 142, '2019-12-19', 214, NULL),
('Hampton Inn', 142, '2019-12-20', 289, NULL),
('Hampton Inn', 142, '2019-12-21', 149, NULL),
('Hampton Inn', 142, '2019-12-22', 329, NULL),
('Hampton Inn', 142, '2019-12-23', 390, NULL),
('Hampton Inn', 142, '2019-12-24', 244, NULL),
('Hampton Inn', 142, '2019-12-25', 159, NULL),
('Hampton Inn', 142, '2019-12-26', 325, NULL),
('Hampton Inn', 142, '2019-12-27', 389, NULL),
('Hampton Inn', 142, '2019-12-28', 308, NULL),
('Hampton Inn', 142, '2019-12-29', 259, NULL),
('Hampton Inn', 142, '2019-12-30', 245, NULL),
('Hampton Inn', 142, '2019-12-31', 288, NULL),
('Hampton Inn', 142, '2020-01-01', 235, NULL),
('Hampton Inn', 142, '2020-01-02', 308, NULL),
('Hampton Inn', 142, '2020-01-03', 386, NULL),
('Hampton Inn', 142, '2020-01-04', 176, NULL),
('Hampton Inn', 142, '2020-01-05', 239, NULL),
('Hampton Inn', 142, '2020-01-06', 204, NULL),
('Hampton Inn', 142, '2020-01-07', 349, NULL),
('Hampton Inn', 142, '2020-01-08', 322, NULL),
('Hampton Inn', 142, '2020-01-09', 101, NULL),
('Hampton Inn', 142, '2020-01-10', 336, NULL),
('Hampton Inn', 142, '2020-01-11', 220, NULL),
('Hampton Inn', 142, '2020-01-12', 123, NULL),
('Hampton Inn', 142, '2020-01-13', 200, NULL),
('Hampton Inn', 142, '2020-01-14', 130, NULL),
('Hampton Inn', 142, '2020-01-15', 169, NULL),
('Hampton Inn', 142, '2020-01-16', 256, NULL),
('Hampton Inn', 142, '2020-01-17', 286, NULL),
('Hampton Inn', 142, '2020-01-18', 134, NULL),
('Hampton Inn', 142, '2020-01-19', 223, NULL),
('Hampton Inn', 142, '2020-01-20', 352, NULL),
('Hampton Inn', 142, '2020-01-21', 208, NULL),
('Hampton Inn', 142, '2020-01-22', 103, NULL),
('Hampton Inn', 142, '2020-01-23', 189, NULL),
('Hampton Inn', 142, '2020-01-24', 179, NULL),
('Hampton Inn', 142, '2020-01-25', 108, NULL),
('Hampton Inn', 142, '2020-01-26', 358, NULL),
('Hampton Inn', 142, '2020-01-27', 346, NULL),
('Hampton Inn', 142, '2020-01-28', 141, NULL),
('Hampton Inn', 142, '2020-01-29', 379, NULL),
('Hampton Inn', 142, '2020-01-30', 116, NULL),
('Hampton Inn', 142, '2020-01-31', 235, NULL),
('Hampton Inn', 142, '2020-02-01', 172, NULL),
('Hampton Inn', 142, '2020-02-02', 260, NULL),
('Hampton Inn', 142, '2020-02-03', 171, NULL),
('Hampton Inn', 142, '2020-02-04', 170, NULL),
('Hampton Inn', 144, '2019-01-01', 220, NULL),
('Hampton Inn', 144, '2019-01-02', 193, NULL),
('Hampton Inn', 144, '2019-01-03', 148, NULL),
('Hampton Inn', 144, '2019-01-04', 303, NULL),
('Hampton Inn', 144, '2019-01-05', 311, NULL),
('Hampton Inn', 144, '2019-01-06', 212, NULL),
('Hampton Inn', 144, '2019-01-07', 208, NULL),
('Hampton Inn', 144, '2019-01-08', 236, NULL),
('Hampton Inn', 144, '2019-01-09', 254, NULL),
('Hampton Inn', 144, '2019-01-10', 296, NULL),
('Hampton Inn', 144, '2019-01-11', 308, NULL),
('Hampton Inn', 144, '2019-01-12', 164, NULL),
('Hampton Inn', 144, '2019-01-13', 108, NULL),
('Hampton Inn', 144, '2019-01-14', 313, NULL),
('Hampton Inn', 144, '2019-01-15', 291, NULL),
('Hampton Inn', 144, '2019-01-16', 275, NULL),
('Hampton Inn', 144, '2019-01-17', 226, NULL),
('Hampton Inn', 144, '2019-01-18', 347, NULL),
('Hampton Inn', 144, '2019-01-19', 242, NULL),
('Hampton Inn', 144, '2019-01-20', 388, NULL),
('Hampton Inn', 144, '2019-01-21', 159, NULL),
('Hampton Inn', 144, '2019-01-22', 352, NULL),
('Hampton Inn', 144, '2019-01-23', 296, NULL),
('Hampton Inn', 144, '2019-01-24', 269, NULL),
('Hampton Inn', 144, '2019-01-25', 281, NULL),
('Hampton Inn', 144, '2019-01-26', 194, NULL),
('Hampton Inn', 144, '2019-01-27', 322, NULL),
('Hampton Inn', 144, '2019-01-28', 395, NULL),
('Hampton Inn', 144, '2019-01-29', 189, NULL),
('Hampton Inn', 144, '2019-01-30', 134, NULL),
('Hampton Inn', 144, '2019-01-31', 177, NULL),
('Hampton Inn', 144, '2019-02-01', 163, NULL),
('Hampton Inn', 144, '2019-02-02', 271, NULL),
('Hampton Inn', 144, '2019-02-03', 296, NULL),
('Hampton Inn', 144, '2019-02-04', 286, NULL),
('Hampton Inn', 144, '2019-02-05', 227, NULL),
('Hampton Inn', 144, '2019-02-06', 350, NULL),
('Hampton Inn', 144, '2019-02-07', 251, NULL),
('Hampton Inn', 144, '2019-02-08', 312, NULL),
('Hampton Inn', 144, '2019-02-09', 246, NULL),
('Hampton Inn', 144, '2019-02-10', 348, NULL),
('Hampton Inn', 144, '2019-02-11', 268, NULL),
('Hampton Inn', 144, '2019-02-12', 202, NULL),
('Hampton Inn', 144, '2019-02-13', 217, NULL),
('Hampton Inn', 144, '2019-02-14', 293, NULL),
('Hampton Inn', 144, '2019-02-15', 380, NULL),
('Hampton Inn', 144, '2019-02-16', 389, NULL),
('Hampton Inn', 144, '2019-02-17', 194, NULL),
('Hampton Inn', 144, '2019-02-18', 258, NULL),
('Hampton Inn', 144, '2019-02-19', 332, NULL),
('Hampton Inn', 144, '2019-02-20', 358, NULL),
('Hampton Inn', 144, '2019-02-21', 365, NULL),
('Hampton Inn', 144, '2019-02-22', 171, NULL),
('Hampton Inn', 144, '2019-02-23', 262, NULL),
('Hampton Inn', 144, '2019-02-24', 247, NULL),
('Hampton Inn', 144, '2019-02-25', 353, NULL),
('Hampton Inn', 144, '2019-02-26', 104, NULL),
('Hampton Inn', 144, '2019-02-27', 105, NULL),
('Hampton Inn', 144, '2019-02-28', 349, NULL),
('Hampton Inn', 144, '2019-03-01', 290, NULL),
('Hampton Inn', 144, '2019-03-02', 255, NULL),
('Hampton Inn', 144, '2019-03-03', 126, NULL),
('Hampton Inn', 144, '2019-03-04', 108, NULL),
('Hampton Inn', 144, '2019-03-05', 217, NULL),
('Hampton Inn', 144, '2019-03-06', 159, NULL),
('Hampton Inn', 144, '2019-03-07', 291, NULL),
('Hampton Inn', 144, '2019-03-08', 254, NULL),
('Hampton Inn', 144, '2019-03-09', 358, NULL),
('Hampton Inn', 144, '2019-03-10', 393, NULL),
('Hampton Inn', 144, '2019-03-11', 245, NULL),
('Hampton Inn', 144, '2019-03-12', 203, NULL),
('Hampton Inn', 144, '2019-03-13', 366, NULL),
('Hampton Inn', 144, '2019-03-14', 383, NULL),
('Hampton Inn', 144, '2019-03-15', 273, NULL),
('Hampton Inn', 144, '2019-03-16', 156, NULL),
('Hampton Inn', 144, '2019-03-17', 278, NULL),
('Hampton Inn', 144, '2019-03-18', 154, NULL),
('Hampton Inn', 144, '2019-03-19', 142, NULL),
('Hampton Inn', 144, '2019-03-20', 224, NULL),
('Hampton Inn', 144, '2019-03-21', 169, NULL),
('Hampton Inn', 144, '2019-03-22', 185, NULL),
('Hampton Inn', 144, '2019-03-23', 153, NULL),
('Hampton Inn', 144, '2019-03-24', 287, NULL),
('Hampton Inn', 144, '2019-03-25', 379, NULL),
('Hampton Inn', 144, '2019-03-26', 220, NULL),
('Hampton Inn', 144, '2019-03-27', 397, NULL),
('Hampton Inn', 144, '2019-03-28', 164, NULL),
('Hampton Inn', 144, '2019-03-29', 337, NULL),
('Hampton Inn', 144, '2019-03-30', 150, NULL),
('Hampton Inn', 144, '2019-03-31', 293, NULL),
('Hampton Inn', 144, '2019-04-01', 268, NULL),
('Hampton Inn', 144, '2019-04-02', 116, NULL),
('Hampton Inn', 144, '2019-04-03', 256, NULL),
('Hampton Inn', 144, '2019-04-04', 153, NULL),
('Hampton Inn', 144, '2019-04-05', 222, NULL),
('Hampton Inn', 144, '2019-04-06', 236, NULL),
('Hampton Inn', 144, '2019-04-07', 313, NULL),
('Hampton Inn', 144, '2019-04-08', 215, NULL),
('Hampton Inn', 144, '2019-04-09', 194, NULL),
('Hampton Inn', 144, '2019-04-10', 115, NULL),
('Hampton Inn', 144, '2019-04-11', 347, NULL),
('Hampton Inn', 144, '2019-04-12', 305, NULL),
('Hampton Inn', 144, '2019-04-13', 210, NULL),
('Hampton Inn', 144, '2019-04-14', 109, NULL),
('Hampton Inn', 144, '2019-04-15', 243, NULL),
('Hampton Inn', 144, '2019-04-16', 108, NULL),
('Hampton Inn', 144, '2019-04-17', 230, NULL),
('Hampton Inn', 144, '2019-04-18', 209, NULL),
('Hampton Inn', 144, '2019-04-19', 237, NULL),
('Hampton Inn', 144, '2019-04-20', 138, NULL),
('Hampton Inn', 144, '2019-04-21', 213, NULL),
('Hampton Inn', 144, '2019-04-22', 168, NULL),
('Hampton Inn', 144, '2019-04-23', 334, NULL),
('Hampton Inn', 144, '2019-04-24', 101, NULL),
('Hampton Inn', 144, '2019-04-25', 385, NULL),
('Hampton Inn', 144, '2019-04-26', 209, NULL),
('Hampton Inn', 144, '2019-04-27', 125, NULL),
('Hampton Inn', 144, '2019-04-28', 219, NULL),
('Hampton Inn', 144, '2019-04-29', 332, NULL),
('Hampton Inn', 144, '2019-04-30', 258, NULL),
('Hampton Inn', 144, '2019-05-01', 145, NULL),
('Hampton Inn', 144, '2019-05-02', 375, NULL),
('Hampton Inn', 144, '2019-05-03', 126, NULL),
('Hampton Inn', 144, '2019-05-04', 127, NULL),
('Hampton Inn', 144, '2019-05-05', 224, NULL),
('Hampton Inn', 144, '2019-05-06', 226, NULL),
('Hampton Inn', 144, '2019-05-07', 302, NULL),
('Hampton Inn', 144, '2019-05-08', 385, NULL),
('Hampton Inn', 144, '2019-05-09', 251, NULL),
('Hampton Inn', 144, '2019-05-10', 243, NULL),
('Hampton Inn', 144, '2019-05-11', 320, NULL),
('Hampton Inn', 144, '2019-05-12', 352, NULL),
('Hampton Inn', 144, '2019-05-13', 385, NULL),
('Hampton Inn', 144, '2019-05-14', 100, NULL),
('Hampton Inn', 144, '2019-05-15', 211, NULL),
('Hampton Inn', 144, '2019-05-16', 247, NULL),
('Hampton Inn', 144, '2019-05-17', 210, NULL),
('Hampton Inn', 144, '2019-05-18', 266, NULL),
('Hampton Inn', 144, '2019-05-19', 249, NULL),
('Hampton Inn', 144, '2019-05-20', 186, NULL),
('Hampton Inn', 144, '2019-05-21', 178, NULL),
('Hampton Inn', 144, '2019-05-22', 257, NULL),
('Hampton Inn', 144, '2019-05-23', 115, NULL),
('Hampton Inn', 144, '2019-05-24', 181, NULL),
('Hampton Inn', 144, '2019-05-25', 386, NULL),
('Hampton Inn', 144, '2019-05-26', 262, NULL),
('Hampton Inn', 144, '2019-05-27', 174, NULL),
('Hampton Inn', 144, '2019-05-28', 371, NULL),
('Hampton Inn', 144, '2019-05-29', 109, NULL),
('Hampton Inn', 144, '2019-05-30', 346, NULL),
('Hampton Inn', 144, '2019-05-31', 140, NULL),
('Hampton Inn', 144, '2019-06-01', 180, NULL),
('Hampton Inn', 144, '2019-06-02', 243, NULL),
('Hampton Inn', 144, '2019-06-03', 338, NULL),
('Hampton Inn', 144, '2019-06-04', 221, NULL),
('Hampton Inn', 144, '2019-06-05', 395, NULL),
('Hampton Inn', 144, '2019-06-06', 186, NULL),
('Hampton Inn', 144, '2019-06-07', 241, NULL),
('Hampton Inn', 144, '2019-06-08', 130, NULL),
('Hampton Inn', 144, '2019-06-09', 152, NULL),
('Hampton Inn', 144, '2019-06-10', 127, NULL),
('Hampton Inn', 144, '2019-06-11', 296, NULL),
('Hampton Inn', 144, '2019-06-12', 110, NULL),
('Hampton Inn', 144, '2019-06-13', 359, NULL),
('Hampton Inn', 144, '2019-06-14', 328, NULL),
('Hampton Inn', 144, '2019-06-15', 201, NULL),
('Hampton Inn', 144, '2019-06-16', 237, NULL),
('Hampton Inn', 144, '2019-06-17', 221, NULL),
('Hampton Inn', 144, '2019-06-18', 260, NULL),
('Hampton Inn', 144, '2019-06-19', 186, NULL),
('Hampton Inn', 144, '2019-06-20', 392, NULL),
('Hampton Inn', 144, '2019-06-21', 385, NULL),
('Hampton Inn', 144, '2019-06-22', 270, NULL),
('Hampton Inn', 144, '2019-06-23', 116, NULL),
('Hampton Inn', 144, '2019-06-24', 165, NULL),
('Hampton Inn', 144, '2019-06-25', 278, NULL),
('Hampton Inn', 144, '2019-06-26', 285, NULL),
('Hampton Inn', 144, '2019-06-27', 180, NULL),
('Hampton Inn', 144, '2019-06-28', 298, NULL),
('Hampton Inn', 144, '2019-06-29', 106, NULL),
('Hampton Inn', 144, '2019-06-30', 122, NULL),
('Hampton Inn', 144, '2019-07-01', 163, NULL),
('Hampton Inn', 144, '2019-07-02', 365, NULL),
('Hampton Inn', 144, '2019-07-03', 137, NULL),
('Hampton Inn', 144, '2019-07-04', 103, NULL),
('Hampton Inn', 144, '2019-07-05', 156, NULL),
('Hampton Inn', 144, '2019-07-06', 120, NULL),
('Hampton Inn', 144, '2019-07-07', 112, NULL),
('Hampton Inn', 144, '2019-07-08', 160, NULL),
('Hampton Inn', 144, '2019-07-09', 368, NULL),
('Hampton Inn', 144, '2019-07-10', 198, NULL),
('Hampton Inn', 144, '2019-07-11', 334, NULL),
('Hampton Inn', 144, '2019-07-12', 147, NULL),
('Hampton Inn', 144, '2019-07-13', 384, NULL),
('Hampton Inn', 144, '2019-07-14', 179, NULL),
('Hampton Inn', 144, '2019-07-15', 264, NULL),
('Hampton Inn', 144, '2019-07-16', 130, NULL),
('Hampton Inn', 144, '2019-07-17', 153, NULL),
('Hampton Inn', 144, '2019-07-18', 309, NULL),
('Hampton Inn', 144, '2019-07-19', 383, NULL),
('Hampton Inn', 144, '2019-07-20', 193, NULL),
('Hampton Inn', 144, '2019-07-21', 336, NULL),
('Hampton Inn', 144, '2019-07-22', 296, NULL),
('Hampton Inn', 144, '2019-07-23', 285, NULL),
('Hampton Inn', 144, '2019-07-24', 335, NULL),
('Hampton Inn', 144, '2019-07-25', 150, NULL),
('Hampton Inn', 144, '2019-07-26', 350, NULL),
('Hampton Inn', 144, '2019-07-27', 243, NULL),
('Hampton Inn', 144, '2019-07-28', 117, NULL),
('Hampton Inn', 144, '2019-07-29', 258, NULL),
('Hampton Inn', 144, '2019-07-30', 223, NULL),
('Hampton Inn', 144, '2019-07-31', 343, NULL),
('Hampton Inn', 144, '2019-08-01', 137, NULL),
('Hampton Inn', 144, '2019-08-02', 276, NULL),
('Hampton Inn', 144, '2019-08-03', 150, NULL),
('Hampton Inn', 144, '2019-08-04', 351, NULL),
('Hampton Inn', 144, '2019-08-05', 229, NULL),
('Hampton Inn', 144, '2019-08-06', 352, NULL),
('Hampton Inn', 144, '2019-08-07', 347, NULL),
('Hampton Inn', 144, '2019-08-08', 236, NULL),
('Hampton Inn', 144, '2019-08-09', 239, NULL),
('Hampton Inn', 144, '2019-08-10', 256, NULL),
('Hampton Inn', 144, '2019-08-11', 288, NULL),
('Hampton Inn', 144, '2019-08-12', 206, NULL),
('Hampton Inn', 144, '2019-08-13', 310, NULL),
('Hampton Inn', 144, '2019-08-14', 306, NULL),
('Hampton Inn', 144, '2019-08-15', 306, NULL),
('Hampton Inn', 144, '2019-08-16', 348, NULL),
('Hampton Inn', 144, '2019-08-17', 187, NULL),
('Hampton Inn', 144, '2019-08-18', 127, NULL),
('Hampton Inn', 144, '2019-08-19', 252, NULL),
('Hampton Inn', 144, '2019-08-20', 207, NULL),
('Hampton Inn', 144, '2019-08-21', 169, NULL),
('Hampton Inn', 144, '2019-08-22', 350, NULL),
('Hampton Inn', 144, '2019-08-23', 253, NULL),
('Hampton Inn', 144, '2019-08-24', 180, NULL),
('Hampton Inn', 144, '2019-08-25', 322, NULL),
('Hampton Inn', 144, '2019-08-26', 221, NULL),
('Hampton Inn', 144, '2019-08-27', 376, NULL),
('Hampton Inn', 144, '2019-08-28', 268, NULL),
('Hampton Inn', 144, '2019-08-29', 107, NULL),
('Hampton Inn', 144, '2019-08-30', 303, NULL),
('Hampton Inn', 144, '2019-08-31', 259, NULL),
('Hampton Inn', 144, '2019-09-01', 161, NULL),
('Hampton Inn', 144, '2019-09-02', 290, NULL),
('Hampton Inn', 144, '2019-09-03', 286, NULL),
('Hampton Inn', 144, '2019-09-04', 116, NULL),
('Hampton Inn', 144, '2019-09-05', 397, NULL),
('Hampton Inn', 144, '2019-09-06', 159, NULL),
('Hampton Inn', 144, '2019-09-07', 398, NULL),
('Hampton Inn', 144, '2019-09-08', 198, NULL),
('Hampton Inn', 144, '2019-09-09', 311, NULL),
('Hampton Inn', 144, '2019-09-10', 319, NULL),
('Hampton Inn', 144, '2019-09-11', 195, NULL),
('Hampton Inn', 144, '2019-09-12', 265, NULL),
('Hampton Inn', 144, '2019-09-13', 302, NULL),
('Hampton Inn', 144, '2019-09-14', 284, NULL),
('Hampton Inn', 144, '2019-09-15', 108, NULL),
('Hampton Inn', 144, '2019-09-16', 280, NULL),
('Hampton Inn', 144, '2019-09-17', 263, NULL),
('Hampton Inn', 144, '2019-09-18', 377, NULL),
('Hampton Inn', 144, '2019-09-19', 293, NULL),
('Hampton Inn', 144, '2019-09-20', 155, NULL),
('Hampton Inn', 144, '2019-09-21', 356, NULL),
('Hampton Inn', 144, '2019-09-22', 284, NULL),
('Hampton Inn', 144, '2019-09-23', 376, NULL),
('Hampton Inn', 144, '2019-09-24', 176, NULL),
('Hampton Inn', 144, '2019-09-25', 361, NULL),
('Hampton Inn', 144, '2019-09-26', 354, NULL),
('Hampton Inn', 144, '2019-09-27', 349, NULL),
('Hampton Inn', 144, '2019-09-28', 304, NULL),
('Hampton Inn', 144, '2019-09-29', 218, NULL),
('Hampton Inn', 144, '2019-09-30', 196, NULL),
('Hampton Inn', 144, '2019-10-01', 368, NULL),
('Hampton Inn', 144, '2019-10-02', 341, NULL),
('Hampton Inn', 144, '2019-10-03', 272, NULL),
('Hampton Inn', 144, '2019-10-04', 305, NULL),
('Hampton Inn', 144, '2019-10-05', 314, NULL),
('Hampton Inn', 144, '2019-10-06', 260, NULL),
('Hampton Inn', 144, '2019-10-07', 182, NULL),
('Hampton Inn', 144, '2019-10-08', 282, NULL),
('Hampton Inn', 144, '2019-10-09', 203, NULL),
('Hampton Inn', 144, '2019-10-10', 349, NULL),
('Hampton Inn', 144, '2019-10-11', 358, NULL),
('Hampton Inn', 144, '2019-10-12', 383, NULL),
('Hampton Inn', 144, '2019-10-13', 317, NULL),
('Hampton Inn', 144, '2019-10-14', 267, NULL),
('Hampton Inn', 144, '2019-10-15', 149, NULL),
('Hampton Inn', 144, '2019-10-16', 130, NULL),
('Hampton Inn', 144, '2019-10-17', 362, NULL),
('Hampton Inn', 144, '2019-10-18', 318, NULL),
('Hampton Inn', 144, '2019-10-19', 103, NULL),
('Hampton Inn', 144, '2019-10-20', 277, NULL),
('Hampton Inn', 144, '2019-10-21', 123, NULL),
('Hampton Inn', 144, '2019-10-22', 204, NULL),
('Hampton Inn', 144, '2019-10-23', 225, NULL),
('Hampton Inn', 144, '2019-10-24', 350, NULL),
('Hampton Inn', 144, '2019-10-25', 235, NULL),
('Hampton Inn', 144, '2019-10-26', 394, NULL),
('Hampton Inn', 144, '2019-10-27', 351, NULL),
('Hampton Inn', 144, '2019-10-28', 149, NULL),
('Hampton Inn', 144, '2019-10-29', 193, NULL),
('Hampton Inn', 144, '2019-10-30', 348, NULL),
('Hampton Inn', 144, '2019-10-31', 156, NULL),
('Hampton Inn', 144, '2019-11-01', 341, NULL),
('Hampton Inn', 144, '2019-11-02', 276, NULL),
('Hampton Inn', 144, '2019-11-03', 146, NULL),
('Hampton Inn', 144, '2019-11-04', 384, NULL),
('Hampton Inn', 144, '2019-11-05', 372, NULL),
('Hampton Inn', 144, '2019-11-06', 119, NULL),
('Hampton Inn', 144, '2019-11-07', 211, NULL),
('Hampton Inn', 144, '2019-11-08', 395, NULL),
('Hampton Inn', 144, '2019-11-09', 297, NULL),
('Hampton Inn', 144, '2019-11-10', 141, NULL),
('Hampton Inn', 144, '2019-11-11', 239, NULL),
('Hampton Inn', 144, '2019-11-12', 343, NULL),
('Hampton Inn', 144, '2019-11-13', 208, NULL),
('Hampton Inn', 144, '2019-11-14', 139, NULL),
('Hampton Inn', 144, '2019-11-15', 146, NULL),
('Hampton Inn', 144, '2019-11-16', 184, NULL),
('Hampton Inn', 144, '2019-11-17', 141, NULL),
('Hampton Inn', 144, '2019-11-18', 266, NULL),
('Hampton Inn', 144, '2019-11-19', 210, NULL),
('Hampton Inn', 144, '2019-11-20', 260, NULL),
('Hampton Inn', 144, '2019-11-21', 399, NULL),
('Hampton Inn', 144, '2019-11-22', 331, NULL),
('Hampton Inn', 144, '2019-11-23', 258, NULL),
('Hampton Inn', 144, '2019-11-24', 154, NULL),
('Hampton Inn', 144, '2019-11-25', 389, NULL),
('Hampton Inn', 144, '2019-11-26', 352, NULL),
('Hampton Inn', 144, '2019-11-27', 373, NULL),
('Hampton Inn', 144, '2019-11-28', 385, NULL),
('Hampton Inn', 144, '2019-11-29', 174, NULL),
('Hampton Inn', 144, '2019-11-30', 351, NULL),
('Hampton Inn', 144, '2019-12-01', 132, NULL),
('Hampton Inn', 144, '2019-12-02', 158, NULL),
('Hampton Inn', 144, '2019-12-03', 189, NULL),
('Hampton Inn', 144, '2019-12-04', 207, NULL),
('Hampton Inn', 144, '2019-12-05', 355, NULL),
('Hampton Inn', 144, '2019-12-06', 350, NULL),
('Hampton Inn', 144, '2019-12-07', 127, NULL),
('Hampton Inn', 144, '2019-12-08', 123, NULL),
('Hampton Inn', 144, '2019-12-09', 220, NULL),
('Hampton Inn', 144, '2019-12-10', 163, NULL),
('Hampton Inn', 144, '2019-12-11', 375, NULL),
('Hampton Inn', 144, '2019-12-12', 301, NULL),
('Hampton Inn', 144, '2019-12-13', 275, NULL),
('Hampton Inn', 144, '2019-12-14', 330, NULL),
('Hampton Inn', 144, '2019-12-15', 241, NULL),
('Hampton Inn', 144, '2019-12-16', 135, NULL),
('Hampton Inn', 144, '2019-12-17', 295, NULL),
('Hampton Inn', 144, '2019-12-18', 257, NULL),
('Hampton Inn', 144, '2019-12-19', 206, NULL),
('Hampton Inn', 144, '2019-12-20', 257, NULL),
('Hampton Inn', 144, '2019-12-21', 368, NULL),
('Hampton Inn', 144, '2019-12-22', 385, NULL),
('Hampton Inn', 144, '2019-12-23', 238, NULL),
('Hampton Inn', 144, '2019-12-24', 298, NULL),
('Hampton Inn', 144, '2019-12-25', 265, NULL),
('Hampton Inn', 144, '2019-12-26', 165, NULL),
('Hampton Inn', 144, '2019-12-27', 208, NULL),
('Hampton Inn', 144, '2019-12-28', 101, NULL),
('Hampton Inn', 144, '2019-12-29', 126, NULL),
('Hampton Inn', 144, '2019-12-30', 140, NULL),
('Hampton Inn', 144, '2019-12-31', 121, NULL),
('Hampton Inn', 144, '2020-01-01', 386, NULL),
('Hampton Inn', 144, '2020-01-02', 134, NULL),
('Hampton Inn', 144, '2020-01-03', 227, NULL),
('Hampton Inn', 144, '2020-01-04', 102, NULL),
('Hampton Inn', 144, '2020-01-05', 336, NULL),
('Hampton Inn', 144, '2020-01-06', 144, NULL),
('Hampton Inn', 144, '2020-01-07', 161, NULL),
('Hampton Inn', 144, '2020-01-08', 297, NULL),
('Hampton Inn', 144, '2020-01-09', 103, NULL),
('Hampton Inn', 144, '2020-01-10', 305, NULL),
('Hampton Inn', 144, '2020-01-11', 353, NULL),
('Hampton Inn', 144, '2020-01-12', 266, NULL),
('Hampton Inn', 144, '2020-01-13', 391, NULL),
('Hampton Inn', 144, '2020-01-14', 266, NULL),
('Hampton Inn', 144, '2020-01-15', 375, NULL),
('Hampton Inn', 144, '2020-01-16', 133, NULL),
('Hampton Inn', 144, '2020-01-17', 186, NULL),
('Hampton Inn', 144, '2020-01-18', 381, NULL),
('Hampton Inn', 144, '2020-01-19', 298, NULL),
('Hampton Inn', 144, '2020-01-20', 340, NULL),
('Hampton Inn', 144, '2020-01-21', 166, NULL),
('Hampton Inn', 144, '2020-01-22', 250, NULL),
('Hampton Inn', 144, '2020-01-23', 392, NULL),
('Hampton Inn', 144, '2020-01-24', 116, NULL),
('Hampton Inn', 144, '2020-01-25', 232, NULL),
('Hampton Inn', 144, '2020-01-26', 194, NULL),
('Hampton Inn', 144, '2020-01-27', 343, NULL),
('Hampton Inn', 144, '2020-01-28', 159, NULL),
('Hampton Inn', 144, '2020-01-29', 325, NULL),
('Hampton Inn', 144, '2020-01-30', 164, NULL),
('Hampton Inn', 144, '2020-01-31', 196, NULL),
('Hampton Inn', 144, '2020-02-01', 325, NULL),
('Hampton Inn', 144, '2020-02-02', 151, NULL),
('Hampton Inn', 144, '2020-02-03', 210, NULL),
('Hampton Inn', 144, '2020-02-04', 359, NULL),
('Hampton Inn', 147, '2019-01-01', 227, NULL),
('Hampton Inn', 147, '2019-01-02', 152, NULL),
('Hampton Inn', 147, '2019-01-03', 302, NULL),
('Hampton Inn', 147, '2019-01-04', 265, NULL),
('Hampton Inn', 147, '2019-01-05', 251, NULL),
('Hampton Inn', 147, '2019-01-06', 259, NULL),
('Hampton Inn', 147, '2019-01-07', 267, NULL),
('Hampton Inn', 147, '2019-01-08', 393, NULL),
('Hampton Inn', 147, '2019-01-09', 338, NULL),
('Hampton Inn', 147, '2019-01-10', 125, NULL),
('Hampton Inn', 147, '2019-01-11', 142, NULL),
('Hampton Inn', 147, '2019-01-12', 242, NULL),
('Hampton Inn', 147, '2019-01-13', 357, NULL),
('Hampton Inn', 147, '2019-01-14', 302, NULL),
('Hampton Inn', 147, '2019-01-15', 348, NULL),
('Hampton Inn', 147, '2019-01-16', 292, NULL),
('Hampton Inn', 147, '2019-01-17', 312, NULL),
('Hampton Inn', 147, '2019-01-18', 304, NULL),
('Hampton Inn', 147, '2019-01-19', 201, NULL),
('Hampton Inn', 147, '2019-01-20', 100, NULL),
('Hampton Inn', 147, '2019-01-21', 296, NULL),
('Hampton Inn', 147, '2019-01-22', 353, NULL),
('Hampton Inn', 147, '2019-01-23', 257, NULL),
('Hampton Inn', 147, '2019-01-24', 191, NULL),
('Hampton Inn', 147, '2019-01-25', 161, NULL),
('Hampton Inn', 147, '2019-01-26', 313, NULL),
('Hampton Inn', 147, '2019-01-27', 233, NULL),
('Hampton Inn', 147, '2019-01-28', 206, NULL),
('Hampton Inn', 147, '2019-01-29', 355, NULL),
('Hampton Inn', 147, '2019-01-30', 348, NULL),
('Hampton Inn', 147, '2019-01-31', 373, NULL),
('Hampton Inn', 147, '2019-02-01', 193, NULL),
('Hampton Inn', 147, '2019-02-02', 105, NULL),
('Hampton Inn', 147, '2019-02-03', 378, NULL),
('Hampton Inn', 147, '2019-02-04', 277, NULL),
('Hampton Inn', 147, '2019-02-05', 202, NULL),
('Hampton Inn', 147, '2019-02-06', 203, NULL),
('Hampton Inn', 147, '2019-02-07', 387, NULL),
('Hampton Inn', 147, '2019-02-08', 298, NULL),
('Hampton Inn', 147, '2019-02-09', 179, NULL),
('Hampton Inn', 147, '2019-02-10', 275, NULL),
('Hampton Inn', 147, '2019-02-11', 169, NULL),
('Hampton Inn', 147, '2019-02-12', 257, NULL),
('Hampton Inn', 147, '2019-02-13', 332, NULL),
('Hampton Inn', 147, '2019-02-14', 297, NULL),
('Hampton Inn', 147, '2019-02-15', 382, NULL),
('Hampton Inn', 147, '2019-02-16', 220, NULL),
('Hampton Inn', 147, '2019-02-17', 320, NULL),
('Hampton Inn', 147, '2019-02-18', 386, NULL),
('Hampton Inn', 147, '2019-02-19', 144, NULL),
('Hampton Inn', 147, '2019-02-20', 284, NULL),
('Hampton Inn', 147, '2019-02-21', 339, NULL),
('Hampton Inn', 147, '2019-02-22', 316, NULL),
('Hampton Inn', 147, '2019-02-23', 224, NULL),
('Hampton Inn', 147, '2019-02-24', 301, NULL),
('Hampton Inn', 147, '2019-02-25', 134, NULL),
('Hampton Inn', 147, '2019-02-26', 183, NULL),
('Hampton Inn', 147, '2019-02-27', 387, NULL),
('Hampton Inn', 147, '2019-02-28', 303, NULL),
('Hampton Inn', 147, '2019-03-01', 321, NULL),
('Hampton Inn', 147, '2019-03-02', 369, NULL),
('Hampton Inn', 147, '2019-03-03', 137, NULL),
('Hampton Inn', 147, '2019-03-04', 330, NULL),
('Hampton Inn', 147, '2019-03-05', 216, NULL),
('Hampton Inn', 147, '2019-03-06', 117, NULL),
('Hampton Inn', 147, '2019-03-07', 242, NULL),
('Hampton Inn', 147, '2019-03-08', 330, NULL),
('Hampton Inn', 147, '2019-03-09', 229, NULL),
('Hampton Inn', 147, '2019-03-10', 107, NULL),
('Hampton Inn', 147, '2019-03-11', 134, NULL),
('Hampton Inn', 147, '2019-03-12', 255, NULL),
('Hampton Inn', 147, '2019-03-13', 287, NULL),
('Hampton Inn', 147, '2019-03-14', 182, NULL),
('Hampton Inn', 147, '2019-03-15', 165, NULL),
('Hampton Inn', 147, '2019-03-16', 149, NULL),
('Hampton Inn', 147, '2019-03-17', 258, NULL),
('Hampton Inn', 147, '2019-03-18', 394, NULL),
('Hampton Inn', 147, '2019-03-19', 337, NULL),
('Hampton Inn', 147, '2019-03-20', 158, NULL),
('Hampton Inn', 147, '2019-03-21', 237, NULL),
('Hampton Inn', 147, '2019-03-22', 342, NULL),
('Hampton Inn', 147, '2019-03-23', 324, NULL),
('Hampton Inn', 147, '2019-03-24', 198, NULL),
('Hampton Inn', 147, '2019-03-25', 368, NULL),
('Hampton Inn', 147, '2019-03-26', 208, NULL),
('Hampton Inn', 147, '2019-03-27', 200, NULL),
('Hampton Inn', 147, '2019-03-28', 221, NULL),
('Hampton Inn', 147, '2019-03-29', 307, NULL),
('Hampton Inn', 147, '2019-03-30', 391, NULL),
('Hampton Inn', 147, '2019-03-31', 328, NULL),
('Hampton Inn', 147, '2019-04-01', 309, NULL),
('Hampton Inn', 147, '2019-04-02', 130, NULL),
('Hampton Inn', 147, '2019-04-03', 259, NULL),
('Hampton Inn', 147, '2019-04-04', 299, NULL),
('Hampton Inn', 147, '2019-04-05', 173, NULL),
('Hampton Inn', 147, '2019-04-06', 162, NULL),
('Hampton Inn', 147, '2019-04-07', 392, NULL),
('Hampton Inn', 147, '2019-04-08', 388, NULL),
('Hampton Inn', 147, '2019-04-09', 262, NULL),
('Hampton Inn', 147, '2019-04-10', 321, NULL),
('Hampton Inn', 147, '2019-04-11', 254, NULL),
('Hampton Inn', 147, '2019-04-12', 289, NULL),
('Hampton Inn', 147, '2019-04-13', 321, NULL),
('Hampton Inn', 147, '2019-04-14', 207, NULL),
('Hampton Inn', 147, '2019-04-15', 327, NULL),
('Hampton Inn', 147, '2019-04-16', 345, NULL),
('Hampton Inn', 147, '2019-04-17', 137, NULL),
('Hampton Inn', 147, '2019-04-18', 300, NULL),
('Hampton Inn', 147, '2019-04-19', 335, NULL),
('Hampton Inn', 147, '2019-04-20', 344, NULL),
('Hampton Inn', 147, '2019-04-21', 239, NULL),
('Hampton Inn', 147, '2019-04-22', 217, NULL),
('Hampton Inn', 147, '2019-04-23', 207, NULL),
('Hampton Inn', 147, '2019-04-24', 138, NULL),
('Hampton Inn', 147, '2019-04-25', 271, NULL),
('Hampton Inn', 147, '2019-04-26', 144, NULL),
('Hampton Inn', 147, '2019-04-27', 119, NULL),
('Hampton Inn', 147, '2019-04-28', 316, NULL),
('Hampton Inn', 147, '2019-04-29', 311, NULL),
('Hampton Inn', 147, '2019-04-30', 303, NULL),
('Hampton Inn', 147, '2019-05-01', 362, NULL),
('Hampton Inn', 147, '2019-05-02', 347, NULL),
('Hampton Inn', 147, '2019-05-03', 168, NULL),
('Hampton Inn', 147, '2019-05-04', 142, NULL),
('Hampton Inn', 147, '2019-05-05', 270, NULL),
('Hampton Inn', 147, '2019-05-06', 347, NULL),
('Hampton Inn', 147, '2019-05-07', 395, NULL),
('Hampton Inn', 147, '2019-05-08', 263, NULL),
('Hampton Inn', 147, '2019-05-09', 118, NULL),
('Hampton Inn', 147, '2019-05-10', 284, NULL),
('Hampton Inn', 147, '2019-05-11', 361, NULL),
('Hampton Inn', 147, '2019-05-12', 310, NULL),
('Hampton Inn', 147, '2019-05-13', 113, NULL),
('Hampton Inn', 147, '2019-05-14', 149, NULL),
('Hampton Inn', 147, '2019-05-15', 216, NULL),
('Hampton Inn', 147, '2019-05-16', 384, NULL),
('Hampton Inn', 147, '2019-05-17', 312, NULL),
('Hampton Inn', 147, '2019-05-18', 120, NULL),
('Hampton Inn', 147, '2019-05-19', 241, NULL),
('Hampton Inn', 147, '2019-05-20', 238, NULL),
('Hampton Inn', 147, '2019-05-21', 113, NULL),
('Hampton Inn', 147, '2019-05-22', 272, NULL),
('Hampton Inn', 147, '2019-05-23', 355, NULL),
('Hampton Inn', 147, '2019-05-24', 185, NULL),
('Hampton Inn', 147, '2019-05-25', 123, NULL),
('Hampton Inn', 147, '2019-05-26', 209, NULL),
('Hampton Inn', 147, '2019-05-27', 348, NULL),
('Hampton Inn', 147, '2019-05-28', 211, NULL),
('Hampton Inn', 147, '2019-05-29', 219, NULL),
('Hampton Inn', 147, '2019-05-30', 107, NULL),
('Hampton Inn', 147, '2019-05-31', 297, NULL),
('Hampton Inn', 147, '2019-06-01', 149, NULL),
('Hampton Inn', 147, '2019-06-02', 154, NULL),
('Hampton Inn', 147, '2019-06-03', 110, NULL),
('Hampton Inn', 147, '2019-06-04', 109, NULL),
('Hampton Inn', 147, '2019-06-05', 344, NULL),
('Hampton Inn', 147, '2019-06-06', 344, NULL),
('Hampton Inn', 147, '2019-06-07', 186, NULL),
('Hampton Inn', 147, '2019-06-08', 133, NULL),
('Hampton Inn', 147, '2019-06-09', 155, NULL),
('Hampton Inn', 147, '2019-06-10', 241, NULL),
('Hampton Inn', 147, '2019-06-11', 227, NULL),
('Hampton Inn', 147, '2019-06-12', 302, NULL),
('Hampton Inn', 147, '2019-06-13', 131, NULL),
('Hampton Inn', 147, '2019-06-14', 305, NULL),
('Hampton Inn', 147, '2019-06-15', 346, NULL),
('Hampton Inn', 147, '2019-06-16', 242, NULL),
('Hampton Inn', 147, '2019-06-17', 293, NULL),
('Hampton Inn', 147, '2019-06-18', 177, NULL),
('Hampton Inn', 147, '2019-06-19', 234, NULL),
('Hampton Inn', 147, '2019-06-20', 110, NULL),
('Hampton Inn', 147, '2019-06-21', 149, NULL),
('Hampton Inn', 147, '2019-06-22', 371, NULL),
('Hampton Inn', 147, '2019-06-23', 251, NULL),
('Hampton Inn', 147, '2019-06-24', 113, NULL),
('Hampton Inn', 147, '2019-06-25', 206, NULL),
('Hampton Inn', 147, '2019-06-26', 272, NULL),
('Hampton Inn', 147, '2019-06-27', 132, NULL),
('Hampton Inn', 147, '2019-06-28', 361, NULL),
('Hampton Inn', 147, '2019-06-29', 229, NULL),
('Hampton Inn', 147, '2019-06-30', 355, NULL),
('Hampton Inn', 147, '2019-07-01', 264, NULL),
('Hampton Inn', 147, '2019-07-02', 234, NULL),
('Hampton Inn', 147, '2019-07-03', 164, NULL),
('Hampton Inn', 147, '2019-07-04', 364, NULL),
('Hampton Inn', 147, '2019-07-05', 275, NULL),
('Hampton Inn', 147, '2019-07-06', 371, NULL),
('Hampton Inn', 147, '2019-07-07', 265, NULL),
('Hampton Inn', 147, '2019-07-08', 232, NULL),
('Hampton Inn', 147, '2019-07-09', 222, NULL),
('Hampton Inn', 147, '2019-07-10', 302, NULL),
('Hampton Inn', 147, '2019-07-11', 103, NULL),
('Hampton Inn', 147, '2019-07-12', 183, NULL),
('Hampton Inn', 147, '2019-07-13', 296, NULL),
('Hampton Inn', 147, '2019-07-14', 172, NULL),
('Hampton Inn', 147, '2019-07-15', 266, NULL),
('Hampton Inn', 147, '2019-07-16', 383, NULL),
('Hampton Inn', 147, '2019-07-17', 212, NULL),
('Hampton Inn', 147, '2019-07-18', 239, NULL),
('Hampton Inn', 147, '2019-07-19', 383, NULL),
('Hampton Inn', 147, '2019-07-20', 223, NULL),
('Hampton Inn', 147, '2019-07-21', 360, NULL),
('Hampton Inn', 147, '2019-07-22', 340, NULL),
('Hampton Inn', 147, '2019-07-23', 303, NULL),
('Hampton Inn', 147, '2019-07-24', 158, NULL),
('Hampton Inn', 147, '2019-07-25', 186, NULL),
('Hampton Inn', 147, '2019-07-26', 219, NULL),
('Hampton Inn', 147, '2019-07-27', 390, NULL),
('Hampton Inn', 147, '2019-07-28', 305, NULL),
('Hampton Inn', 147, '2019-07-29', 230, NULL),
('Hampton Inn', 147, '2019-07-30', 251, NULL),
('Hampton Inn', 147, '2019-07-31', 303, NULL),
('Hampton Inn', 147, '2019-08-01', 261, NULL),
('Hampton Inn', 147, '2019-08-02', 147, NULL),
('Hampton Inn', 147, '2019-08-03', 284, NULL),
('Hampton Inn', 147, '2019-08-04', 108, NULL),
('Hampton Inn', 147, '2019-08-05', 370, NULL),
('Hampton Inn', 147, '2019-08-06', 248, NULL),
('Hampton Inn', 147, '2019-08-07', 126, NULL),
('Hampton Inn', 147, '2019-08-08', 279, NULL),
('Hampton Inn', 147, '2019-08-09', 254, NULL),
('Hampton Inn', 147, '2019-08-10', 228, NULL),
('Hampton Inn', 147, '2019-08-11', 384, NULL),
('Hampton Inn', 147, '2019-08-12', 374, NULL),
('Hampton Inn', 147, '2019-08-13', 321, NULL),
('Hampton Inn', 147, '2019-08-14', 260, NULL),
('Hampton Inn', 147, '2019-08-15', 384, NULL),
('Hampton Inn', 147, '2019-08-16', 140, NULL),
('Hampton Inn', 147, '2019-08-17', 163, NULL),
('Hampton Inn', 147, '2019-08-18', 123, NULL),
('Hampton Inn', 147, '2019-08-19', 197, NULL),
('Hampton Inn', 147, '2019-08-20', 100, NULL),
('Hampton Inn', 147, '2019-08-21', 154, NULL),
('Hampton Inn', 147, '2019-08-22', 191, NULL),
('Hampton Inn', 147, '2019-08-23', 280, NULL),
('Hampton Inn', 147, '2019-08-24', 297, NULL),
('Hampton Inn', 147, '2019-08-25', 332, NULL),
('Hampton Inn', 147, '2019-08-26', 295, NULL),
('Hampton Inn', 147, '2019-08-27', 265, NULL),
('Hampton Inn', 147, '2019-08-28', 192, NULL),
('Hampton Inn', 147, '2019-08-29', 214, NULL),
('Hampton Inn', 147, '2019-08-30', 238, NULL),
('Hampton Inn', 147, '2019-08-31', 205, NULL),
('Hampton Inn', 147, '2019-09-01', 209, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 147, '2019-09-02', 142, NULL),
('Hampton Inn', 147, '2019-09-03', 285, NULL),
('Hampton Inn', 147, '2019-09-04', 376, NULL),
('Hampton Inn', 147, '2019-09-05', 326, NULL),
('Hampton Inn', 147, '2019-09-06', 315, NULL),
('Hampton Inn', 147, '2019-09-07', 251, NULL),
('Hampton Inn', 147, '2019-09-08', 239, NULL),
('Hampton Inn', 147, '2019-09-09', 311, NULL),
('Hampton Inn', 147, '2019-09-10', 124, NULL),
('Hampton Inn', 147, '2019-09-11', 306, NULL),
('Hampton Inn', 147, '2019-09-12', 245, NULL),
('Hampton Inn', 147, '2019-09-13', 166, NULL),
('Hampton Inn', 147, '2019-09-14', 197, NULL),
('Hampton Inn', 147, '2019-09-15', 393, NULL),
('Hampton Inn', 147, '2019-09-16', 153, NULL),
('Hampton Inn', 147, '2019-09-17', 321, NULL),
('Hampton Inn', 147, '2019-09-18', 210, NULL),
('Hampton Inn', 147, '2019-09-19', 278, NULL),
('Hampton Inn', 147, '2019-09-20', 116, NULL),
('Hampton Inn', 147, '2019-09-21', 158, NULL),
('Hampton Inn', 147, '2019-09-22', 353, NULL),
('Hampton Inn', 147, '2019-09-23', 382, NULL),
('Hampton Inn', 147, '2019-09-24', 361, NULL),
('Hampton Inn', 147, '2019-09-25', 125, NULL),
('Hampton Inn', 147, '2019-09-26', 304, NULL),
('Hampton Inn', 147, '2019-09-27', 151, NULL),
('Hampton Inn', 147, '2019-09-28', 362, NULL),
('Hampton Inn', 147, '2019-09-29', 383, NULL),
('Hampton Inn', 147, '2019-09-30', 360, NULL),
('Hampton Inn', 147, '2019-10-01', 195, NULL),
('Hampton Inn', 147, '2019-10-02', 358, NULL),
('Hampton Inn', 147, '2019-10-03', 119, NULL),
('Hampton Inn', 147, '2019-10-04', 374, NULL),
('Hampton Inn', 147, '2019-10-05', 142, NULL),
('Hampton Inn', 147, '2019-10-06', 245, NULL),
('Hampton Inn', 147, '2019-10-07', 133, NULL),
('Hampton Inn', 147, '2019-10-08', 269, NULL),
('Hampton Inn', 147, '2019-10-09', 191, NULL),
('Hampton Inn', 147, '2019-10-10', 278, NULL),
('Hampton Inn', 147, '2019-10-11', 346, NULL),
('Hampton Inn', 147, '2019-10-12', 390, NULL),
('Hampton Inn', 147, '2019-10-13', 101, NULL),
('Hampton Inn', 147, '2019-10-14', 145, NULL),
('Hampton Inn', 147, '2019-10-15', 247, NULL),
('Hampton Inn', 147, '2019-10-16', 220, NULL),
('Hampton Inn', 147, '2019-10-17', 340, NULL),
('Hampton Inn', 147, '2019-10-18', 183, NULL),
('Hampton Inn', 147, '2019-10-19', 287, NULL),
('Hampton Inn', 147, '2019-10-20', 278, NULL),
('Hampton Inn', 147, '2019-10-21', 353, NULL),
('Hampton Inn', 147, '2019-10-22', 250, NULL),
('Hampton Inn', 147, '2019-10-23', 240, NULL),
('Hampton Inn', 147, '2019-10-24', 127, NULL),
('Hampton Inn', 147, '2019-10-25', 146, NULL),
('Hampton Inn', 147, '2019-10-26', 341, NULL),
('Hampton Inn', 147, '2019-10-27', 295, NULL),
('Hampton Inn', 147, '2019-10-28', 156, NULL),
('Hampton Inn', 147, '2019-10-29', 108, NULL),
('Hampton Inn', 147, '2019-10-30', 154, NULL),
('Hampton Inn', 147, '2019-10-31', 210, NULL),
('Hampton Inn', 147, '2019-11-01', 170, NULL),
('Hampton Inn', 147, '2019-11-02', 370, NULL),
('Hampton Inn', 147, '2019-11-03', 226, NULL),
('Hampton Inn', 147, '2019-11-04', 319, NULL),
('Hampton Inn', 147, '2019-11-05', 163, NULL),
('Hampton Inn', 147, '2019-11-06', 306, NULL),
('Hampton Inn', 147, '2019-11-07', 206, NULL),
('Hampton Inn', 147, '2019-11-08', 331, NULL),
('Hampton Inn', 147, '2019-11-09', 378, NULL),
('Hampton Inn', 147, '2019-11-10', 159, NULL),
('Hampton Inn', 147, '2019-11-11', 273, NULL),
('Hampton Inn', 147, '2019-11-12', 178, NULL),
('Hampton Inn', 147, '2019-11-13', 303, NULL),
('Hampton Inn', 147, '2019-11-14', 152, NULL),
('Hampton Inn', 147, '2019-11-15', 320, NULL),
('Hampton Inn', 147, '2019-11-16', 230, NULL),
('Hampton Inn', 147, '2019-11-17', 126, NULL),
('Hampton Inn', 147, '2019-11-18', 131, NULL),
('Hampton Inn', 147, '2019-11-19', 184, NULL),
('Hampton Inn', 147, '2019-11-20', 364, NULL),
('Hampton Inn', 147, '2019-11-21', 372, NULL),
('Hampton Inn', 147, '2019-11-22', 321, NULL),
('Hampton Inn', 147, '2019-11-23', 265, NULL),
('Hampton Inn', 147, '2019-11-24', 399, NULL),
('Hampton Inn', 147, '2019-11-25', 286, NULL),
('Hampton Inn', 147, '2019-11-26', 224, NULL),
('Hampton Inn', 147, '2019-11-27', 266, NULL),
('Hampton Inn', 147, '2019-11-28', 194, NULL),
('Hampton Inn', 147, '2019-11-29', 321, NULL),
('Hampton Inn', 147, '2019-11-30', 350, NULL),
('Hampton Inn', 147, '2019-12-01', 318, NULL),
('Hampton Inn', 147, '2019-12-02', 281, NULL),
('Hampton Inn', 147, '2019-12-03', 148, NULL),
('Hampton Inn', 147, '2019-12-04', 326, NULL),
('Hampton Inn', 147, '2019-12-05', 345, NULL),
('Hampton Inn', 147, '2019-12-06', 359, NULL),
('Hampton Inn', 147, '2019-12-07', 238, NULL),
('Hampton Inn', 147, '2019-12-08', 372, NULL),
('Hampton Inn', 147, '2019-12-09', 313, NULL),
('Hampton Inn', 147, '2019-12-10', 232, NULL),
('Hampton Inn', 147, '2019-12-11', 188, NULL),
('Hampton Inn', 147, '2019-12-12', 234, NULL),
('Hampton Inn', 147, '2019-12-13', 375, NULL),
('Hampton Inn', 147, '2019-12-14', 165, NULL),
('Hampton Inn', 147, '2019-12-15', 313, NULL),
('Hampton Inn', 147, '2019-12-16', 315, NULL),
('Hampton Inn', 147, '2019-12-17', 327, NULL),
('Hampton Inn', 147, '2019-12-18', 327, NULL),
('Hampton Inn', 147, '2019-12-19', 288, NULL),
('Hampton Inn', 147, '2019-12-20', 321, NULL),
('Hampton Inn', 147, '2019-12-21', 394, NULL),
('Hampton Inn', 147, '2019-12-22', 241, NULL),
('Hampton Inn', 147, '2019-12-23', 219, NULL),
('Hampton Inn', 147, '2019-12-24', 359, NULL),
('Hampton Inn', 147, '2019-12-25', 150, NULL),
('Hampton Inn', 147, '2019-12-26', 351, NULL),
('Hampton Inn', 147, '2019-12-27', 371, NULL),
('Hampton Inn', 147, '2019-12-28', 379, NULL),
('Hampton Inn', 147, '2019-12-29', 353, NULL),
('Hampton Inn', 147, '2019-12-30', 166, NULL),
('Hampton Inn', 147, '2019-12-31', 241, NULL),
('Hampton Inn', 147, '2020-01-01', 227, NULL),
('Hampton Inn', 147, '2020-01-02', 248, NULL),
('Hampton Inn', 147, '2020-01-03', 177, NULL),
('Hampton Inn', 147, '2020-01-04', 183, NULL),
('Hampton Inn', 147, '2020-01-05', 263, NULL),
('Hampton Inn', 147, '2020-01-06', 310, NULL),
('Hampton Inn', 147, '2020-01-07', 257, NULL),
('Hampton Inn', 147, '2020-01-08', 117, NULL),
('Hampton Inn', 147, '2020-01-09', 111, NULL),
('Hampton Inn', 147, '2020-01-10', 116, NULL),
('Hampton Inn', 147, '2020-01-11', 108, NULL),
('Hampton Inn', 147, '2020-01-12', 261, NULL),
('Hampton Inn', 147, '2020-01-13', 356, NULL),
('Hampton Inn', 147, '2020-01-14', 237, NULL),
('Hampton Inn', 147, '2020-01-15', 368, NULL),
('Hampton Inn', 147, '2020-01-16', 397, NULL),
('Hampton Inn', 147, '2020-01-17', 269, NULL),
('Hampton Inn', 147, '2020-01-18', 206, NULL),
('Hampton Inn', 147, '2020-01-19', 121, NULL),
('Hampton Inn', 147, '2020-01-20', 245, NULL),
('Hampton Inn', 147, '2020-01-21', 105, NULL),
('Hampton Inn', 147, '2020-01-22', 242, NULL),
('Hampton Inn', 147, '2020-01-23', 393, NULL),
('Hampton Inn', 147, '2020-01-24', 244, NULL),
('Hampton Inn', 147, '2020-01-25', 133, NULL),
('Hampton Inn', 147, '2020-01-26', 397, NULL),
('Hampton Inn', 147, '2020-01-27', 279, NULL),
('Hampton Inn', 147, '2020-01-28', 270, NULL),
('Hampton Inn', 147, '2020-01-29', 388, NULL),
('Hampton Inn', 147, '2020-01-30', 370, NULL),
('Hampton Inn', 147, '2020-01-31', 178, NULL),
('Hampton Inn', 147, '2020-02-01', 110, NULL),
('Hampton Inn', 147, '2020-02-02', 174, NULL),
('Hampton Inn', 147, '2020-02-03', 135, NULL),
('Hampton Inn', 147, '2020-02-04', 286, NULL),
('Hampton Inn', 151, '2019-01-01', 374, NULL),
('Hampton Inn', 151, '2019-01-02', 381, NULL),
('Hampton Inn', 151, '2019-01-03', 368, NULL),
('Hampton Inn', 151, '2019-01-04', 315, NULL),
('Hampton Inn', 151, '2019-01-05', 225, NULL),
('Hampton Inn', 151, '2019-01-06', 260, NULL),
('Hampton Inn', 151, '2019-01-07', 314, NULL),
('Hampton Inn', 151, '2019-01-08', 258, NULL),
('Hampton Inn', 151, '2019-01-09', 231, NULL),
('Hampton Inn', 151, '2019-01-10', 234, NULL),
('Hampton Inn', 151, '2019-01-11', 284, NULL),
('Hampton Inn', 151, '2019-01-12', 318, NULL),
('Hampton Inn', 151, '2019-01-13', 162, NULL),
('Hampton Inn', 151, '2019-01-14', 170, NULL),
('Hampton Inn', 151, '2019-01-15', 166, NULL),
('Hampton Inn', 151, '2019-01-16', 234, NULL),
('Hampton Inn', 151, '2019-01-17', 184, NULL),
('Hampton Inn', 151, '2019-01-18', 381, NULL),
('Hampton Inn', 151, '2019-01-19', 178, NULL),
('Hampton Inn', 151, '2019-01-20', 136, NULL),
('Hampton Inn', 151, '2019-01-21', 305, NULL),
('Hampton Inn', 151, '2019-01-22', 311, NULL),
('Hampton Inn', 151, '2019-01-23', 300, NULL),
('Hampton Inn', 151, '2019-01-24', 347, NULL),
('Hampton Inn', 151, '2019-01-25', 163, NULL),
('Hampton Inn', 151, '2019-01-26', 282, NULL),
('Hampton Inn', 151, '2019-01-27', 100, NULL),
('Hampton Inn', 151, '2019-01-28', 347, NULL),
('Hampton Inn', 151, '2019-01-29', 209, NULL),
('Hampton Inn', 151, '2019-01-30', 340, NULL),
('Hampton Inn', 151, '2019-01-31', 334, NULL),
('Hampton Inn', 151, '2019-02-01', 377, NULL),
('Hampton Inn', 151, '2019-02-02', 213, NULL),
('Hampton Inn', 151, '2019-02-03', 304, NULL),
('Hampton Inn', 151, '2019-02-04', 129, NULL),
('Hampton Inn', 151, '2019-02-05', 227, NULL),
('Hampton Inn', 151, '2019-02-06', 165, NULL),
('Hampton Inn', 151, '2019-02-07', 180, NULL),
('Hampton Inn', 151, '2019-02-08', 151, NULL),
('Hampton Inn', 151, '2019-02-09', 356, NULL),
('Hampton Inn', 151, '2019-02-10', 230, NULL),
('Hampton Inn', 151, '2019-02-11', 241, NULL),
('Hampton Inn', 151, '2019-02-12', 277, NULL),
('Hampton Inn', 151, '2019-02-13', 310, NULL),
('Hampton Inn', 151, '2019-02-14', 207, NULL),
('Hampton Inn', 151, '2019-02-15', 371, NULL),
('Hampton Inn', 151, '2019-02-16', 133, NULL),
('Hampton Inn', 151, '2019-02-17', 320, NULL),
('Hampton Inn', 151, '2019-02-18', 158, NULL),
('Hampton Inn', 151, '2019-02-19', 224, NULL),
('Hampton Inn', 151, '2019-02-20', 247, NULL),
('Hampton Inn', 151, '2019-02-21', 202, NULL),
('Hampton Inn', 151, '2019-02-22', 370, NULL),
('Hampton Inn', 151, '2019-02-23', 233, NULL),
('Hampton Inn', 151, '2019-02-24', 365, NULL),
('Hampton Inn', 151, '2019-02-25', 115, NULL),
('Hampton Inn', 151, '2019-02-26', 203, NULL),
('Hampton Inn', 151, '2019-02-27', 318, NULL),
('Hampton Inn', 151, '2019-02-28', 371, NULL),
('Hampton Inn', 151, '2019-03-01', 336, NULL),
('Hampton Inn', 151, '2019-03-02', 380, NULL),
('Hampton Inn', 151, '2019-03-03', 205, NULL),
('Hampton Inn', 151, '2019-03-04', 329, NULL),
('Hampton Inn', 151, '2019-03-05', 331, NULL),
('Hampton Inn', 151, '2019-03-06', 309, NULL),
('Hampton Inn', 151, '2019-03-07', 237, NULL),
('Hampton Inn', 151, '2019-03-08', 191, NULL),
('Hampton Inn', 151, '2019-03-09', 272, NULL),
('Hampton Inn', 151, '2019-03-10', 159, NULL),
('Hampton Inn', 151, '2019-03-11', 133, NULL),
('Hampton Inn', 151, '2019-03-12', 267, NULL),
('Hampton Inn', 151, '2019-03-13', 236, NULL),
('Hampton Inn', 151, '2019-03-14', 261, NULL),
('Hampton Inn', 151, '2019-03-15', 206, NULL),
('Hampton Inn', 151, '2019-03-16', 179, NULL),
('Hampton Inn', 151, '2019-03-17', 354, NULL),
('Hampton Inn', 151, '2019-03-18', 208, NULL),
('Hampton Inn', 151, '2019-03-19', 260, NULL),
('Hampton Inn', 151, '2019-03-20', 318, NULL),
('Hampton Inn', 151, '2019-03-21', 275, NULL),
('Hampton Inn', 151, '2019-03-22', 156, NULL),
('Hampton Inn', 151, '2019-03-23', 161, NULL),
('Hampton Inn', 151, '2019-03-24', 331, NULL),
('Hampton Inn', 151, '2019-03-25', 300, NULL),
('Hampton Inn', 151, '2019-03-26', 283, NULL),
('Hampton Inn', 151, '2019-03-27', 306, NULL),
('Hampton Inn', 151, '2019-03-28', 216, NULL),
('Hampton Inn', 151, '2019-03-29', 123, NULL),
('Hampton Inn', 151, '2019-03-30', 202, NULL),
('Hampton Inn', 151, '2019-03-31', 359, NULL),
('Hampton Inn', 151, '2019-04-01', 344, NULL),
('Hampton Inn', 151, '2019-04-02', 201, NULL),
('Hampton Inn', 151, '2019-04-03', 128, NULL),
('Hampton Inn', 151, '2019-04-04', 336, NULL),
('Hampton Inn', 151, '2019-04-05', 399, NULL),
('Hampton Inn', 151, '2019-04-06', 299, NULL),
('Hampton Inn', 151, '2019-04-07', 323, NULL),
('Hampton Inn', 151, '2019-04-08', 293, NULL),
('Hampton Inn', 151, '2019-04-09', 329, NULL),
('Hampton Inn', 151, '2019-04-10', 262, NULL),
('Hampton Inn', 151, '2019-04-11', 130, NULL),
('Hampton Inn', 151, '2019-04-12', 130, NULL),
('Hampton Inn', 151, '2019-04-13', 275, NULL),
('Hampton Inn', 151, '2019-04-14', 310, NULL),
('Hampton Inn', 151, '2019-04-15', 207, NULL),
('Hampton Inn', 151, '2019-04-16', 103, NULL),
('Hampton Inn', 151, '2019-04-17', 195, NULL),
('Hampton Inn', 151, '2019-04-18', 175, NULL),
('Hampton Inn', 151, '2019-04-19', 263, NULL),
('Hampton Inn', 151, '2019-04-20', 307, NULL),
('Hampton Inn', 151, '2019-04-21', 158, NULL),
('Hampton Inn', 151, '2019-04-22', 181, NULL),
('Hampton Inn', 151, '2019-04-23', 233, NULL),
('Hampton Inn', 151, '2019-04-24', 285, NULL),
('Hampton Inn', 151, '2019-04-25', 100, NULL),
('Hampton Inn', 151, '2019-04-26', 292, NULL),
('Hampton Inn', 151, '2019-04-27', 121, NULL),
('Hampton Inn', 151, '2019-04-28', 224, NULL),
('Hampton Inn', 151, '2019-04-29', 159, NULL),
('Hampton Inn', 151, '2019-04-30', 342, NULL),
('Hampton Inn', 151, '2019-05-01', 379, NULL),
('Hampton Inn', 151, '2019-05-02', 209, NULL),
('Hampton Inn', 151, '2019-05-03', 365, NULL),
('Hampton Inn', 151, '2019-05-04', 228, NULL),
('Hampton Inn', 151, '2019-05-05', 280, NULL),
('Hampton Inn', 151, '2019-05-06', 357, NULL),
('Hampton Inn', 151, '2019-05-07', 370, NULL),
('Hampton Inn', 151, '2019-05-08', 362, NULL),
('Hampton Inn', 151, '2019-05-09', 339, NULL),
('Hampton Inn', 151, '2019-05-10', 291, NULL),
('Hampton Inn', 151, '2019-05-11', 146, NULL),
('Hampton Inn', 151, '2019-05-12', 397, NULL),
('Hampton Inn', 151, '2019-05-13', 213, NULL),
('Hampton Inn', 151, '2019-05-14', 344, NULL),
('Hampton Inn', 151, '2019-05-15', 348, NULL),
('Hampton Inn', 151, '2019-05-16', 178, NULL),
('Hampton Inn', 151, '2019-05-17', 230, NULL),
('Hampton Inn', 151, '2019-05-18', 302, NULL),
('Hampton Inn', 151, '2019-05-19', 358, NULL),
('Hampton Inn', 151, '2019-05-20', 234, NULL),
('Hampton Inn', 151, '2019-05-21', 233, NULL),
('Hampton Inn', 151, '2019-05-22', 193, NULL),
('Hampton Inn', 151, '2019-05-23', 131, NULL),
('Hampton Inn', 151, '2019-05-24', 281, NULL),
('Hampton Inn', 151, '2019-05-25', 256, NULL),
('Hampton Inn', 151, '2019-05-26', 160, NULL),
('Hampton Inn', 151, '2019-05-27', 218, NULL),
('Hampton Inn', 151, '2019-05-28', 140, NULL),
('Hampton Inn', 151, '2019-05-29', 369, NULL),
('Hampton Inn', 151, '2019-05-30', 300, NULL),
('Hampton Inn', 151, '2019-05-31', 365, NULL),
('Hampton Inn', 151, '2019-06-01', 106, NULL),
('Hampton Inn', 151, '2019-06-02', 240, NULL),
('Hampton Inn', 151, '2019-06-03', 337, NULL),
('Hampton Inn', 151, '2019-06-04', 381, NULL),
('Hampton Inn', 151, '2019-06-05', 137, NULL),
('Hampton Inn', 151, '2019-06-06', 159, NULL),
('Hampton Inn', 151, '2019-06-07', 108, NULL),
('Hampton Inn', 151, '2019-06-08', 176, NULL),
('Hampton Inn', 151, '2019-06-09', 218, NULL),
('Hampton Inn', 151, '2019-06-10', 124, NULL),
('Hampton Inn', 151, '2019-06-11', 149, NULL),
('Hampton Inn', 151, '2019-06-12', 178, NULL),
('Hampton Inn', 151, '2019-06-13', 379, NULL),
('Hampton Inn', 151, '2019-06-14', 140, NULL),
('Hampton Inn', 151, '2019-06-15', 125, NULL),
('Hampton Inn', 151, '2019-06-16', 100, NULL),
('Hampton Inn', 151, '2019-06-17', 100, NULL),
('Hampton Inn', 151, '2019-06-18', 309, NULL),
('Hampton Inn', 151, '2019-06-19', 212, NULL),
('Hampton Inn', 151, '2019-06-20', 175, NULL),
('Hampton Inn', 151, '2019-06-21', 389, NULL),
('Hampton Inn', 151, '2019-06-22', 346, NULL),
('Hampton Inn', 151, '2019-06-23', 208, NULL),
('Hampton Inn', 151, '2019-06-24', 270, NULL),
('Hampton Inn', 151, '2019-06-25', 398, NULL),
('Hampton Inn', 151, '2019-06-26', 104, NULL),
('Hampton Inn', 151, '2019-06-27', 319, NULL),
('Hampton Inn', 151, '2019-06-28', 213, NULL),
('Hampton Inn', 151, '2019-06-29', 128, NULL),
('Hampton Inn', 151, '2019-06-30', 109, NULL),
('Hampton Inn', 151, '2019-07-01', 129, NULL),
('Hampton Inn', 151, '2019-07-02', 273, NULL),
('Hampton Inn', 151, '2019-07-03', 312, NULL),
('Hampton Inn', 151, '2019-07-04', 210, NULL),
('Hampton Inn', 151, '2019-07-05', 209, NULL),
('Hampton Inn', 151, '2019-07-06', 197, NULL),
('Hampton Inn', 151, '2019-07-07', 289, NULL),
('Hampton Inn', 151, '2019-07-08', 278, NULL),
('Hampton Inn', 151, '2019-07-09', 207, NULL),
('Hampton Inn', 151, '2019-07-10', 216, NULL),
('Hampton Inn', 151, '2019-07-11', 313, NULL),
('Hampton Inn', 151, '2019-07-12', 373, NULL),
('Hampton Inn', 151, '2019-07-13', 231, NULL),
('Hampton Inn', 151, '2019-07-14', 223, NULL),
('Hampton Inn', 151, '2019-07-15', 138, NULL),
('Hampton Inn', 151, '2019-07-16', 226, NULL),
('Hampton Inn', 151, '2019-07-17', 204, NULL),
('Hampton Inn', 151, '2019-07-18', 168, NULL),
('Hampton Inn', 151, '2019-07-19', 366, NULL),
('Hampton Inn', 151, '2019-07-20', 134, NULL),
('Hampton Inn', 151, '2019-07-21', 390, NULL),
('Hampton Inn', 151, '2019-07-22', 112, NULL),
('Hampton Inn', 151, '2019-07-23', 260, NULL),
('Hampton Inn', 151, '2019-07-24', 284, NULL),
('Hampton Inn', 151, '2019-07-25', 382, NULL),
('Hampton Inn', 151, '2019-07-26', 246, NULL),
('Hampton Inn', 151, '2019-07-27', 220, NULL),
('Hampton Inn', 151, '2019-07-28', 174, NULL),
('Hampton Inn', 151, '2019-07-29', 277, NULL),
('Hampton Inn', 151, '2019-07-30', 188, NULL),
('Hampton Inn', 151, '2019-07-31', 384, NULL),
('Hampton Inn', 151, '2019-08-01', 197, NULL),
('Hampton Inn', 151, '2019-08-02', 106, NULL),
('Hampton Inn', 151, '2019-08-03', 273, NULL),
('Hampton Inn', 151, '2019-08-04', 286, NULL),
('Hampton Inn', 151, '2019-08-05', 167, NULL),
('Hampton Inn', 151, '2019-08-06', 383, NULL),
('Hampton Inn', 151, '2019-08-07', 390, NULL),
('Hampton Inn', 151, '2019-08-08', 289, NULL),
('Hampton Inn', 151, '2019-08-09', 152, NULL),
('Hampton Inn', 151, '2019-08-10', 274, NULL),
('Hampton Inn', 151, '2019-08-11', 354, NULL),
('Hampton Inn', 151, '2019-08-12', 251, NULL),
('Hampton Inn', 151, '2019-08-13', 276, NULL),
('Hampton Inn', 151, '2019-08-14', 281, NULL),
('Hampton Inn', 151, '2019-08-15', 305, NULL),
('Hampton Inn', 151, '2019-08-16', 155, NULL),
('Hampton Inn', 151, '2019-08-17', 155, NULL),
('Hampton Inn', 151, '2019-08-18', 132, NULL),
('Hampton Inn', 151, '2019-08-19', 132, NULL),
('Hampton Inn', 151, '2019-08-20', 378, NULL),
('Hampton Inn', 151, '2019-08-21', 163, NULL),
('Hampton Inn', 151, '2019-08-22', 105, NULL),
('Hampton Inn', 151, '2019-08-23', 242, NULL),
('Hampton Inn', 151, '2019-08-24', 245, NULL),
('Hampton Inn', 151, '2019-08-25', 296, NULL),
('Hampton Inn', 151, '2019-08-26', 114, NULL),
('Hampton Inn', 151, '2019-08-27', 399, NULL),
('Hampton Inn', 151, '2019-08-28', 355, NULL),
('Hampton Inn', 151, '2019-08-29', 350, NULL),
('Hampton Inn', 151, '2019-08-30', 181, NULL),
('Hampton Inn', 151, '2019-08-31', 147, NULL),
('Hampton Inn', 151, '2019-09-01', 164, NULL),
('Hampton Inn', 151, '2019-09-02', 339, NULL),
('Hampton Inn', 151, '2019-09-03', 169, NULL),
('Hampton Inn', 151, '2019-09-04', 235, NULL),
('Hampton Inn', 151, '2019-09-05', 339, NULL),
('Hampton Inn', 151, '2019-09-06', 396, NULL),
('Hampton Inn', 151, '2019-09-07', 263, NULL),
('Hampton Inn', 151, '2019-09-08', 204, NULL),
('Hampton Inn', 151, '2019-09-09', 225, NULL),
('Hampton Inn', 151, '2019-09-10', 166, NULL),
('Hampton Inn', 151, '2019-09-11', 245, NULL),
('Hampton Inn', 151, '2019-09-12', 333, NULL),
('Hampton Inn', 151, '2019-09-13', 128, NULL),
('Hampton Inn', 151, '2019-09-14', 334, NULL),
('Hampton Inn', 151, '2019-09-15', 343, NULL),
('Hampton Inn', 151, '2019-09-16', 124, NULL),
('Hampton Inn', 151, '2019-09-17', 116, NULL),
('Hampton Inn', 151, '2019-09-18', 120, NULL),
('Hampton Inn', 151, '2019-09-19', 109, NULL),
('Hampton Inn', 151, '2019-09-20', 318, NULL),
('Hampton Inn', 151, '2019-09-21', 223, NULL),
('Hampton Inn', 151, '2019-09-22', 212, NULL),
('Hampton Inn', 151, '2019-09-23', 385, NULL),
('Hampton Inn', 151, '2019-09-24', 277, NULL),
('Hampton Inn', 151, '2019-09-25', 344, NULL),
('Hampton Inn', 151, '2019-09-26', 356, NULL),
('Hampton Inn', 151, '2019-09-27', 208, NULL),
('Hampton Inn', 151, '2019-09-28', 201, NULL),
('Hampton Inn', 151, '2019-09-29', 262, NULL),
('Hampton Inn', 151, '2019-09-30', 214, NULL),
('Hampton Inn', 151, '2019-10-01', 373, NULL),
('Hampton Inn', 151, '2019-10-02', 369, NULL),
('Hampton Inn', 151, '2019-10-03', 280, NULL),
('Hampton Inn', 151, '2019-10-04', 257, NULL),
('Hampton Inn', 151, '2019-10-05', 267, NULL),
('Hampton Inn', 151, '2019-10-06', 344, NULL),
('Hampton Inn', 151, '2019-10-07', 317, NULL),
('Hampton Inn', 151, '2019-10-08', 399, NULL),
('Hampton Inn', 151, '2019-10-09', 249, NULL),
('Hampton Inn', 151, '2019-10-10', 241, NULL),
('Hampton Inn', 151, '2019-10-11', 260, NULL),
('Hampton Inn', 151, '2019-10-12', 100, NULL),
('Hampton Inn', 151, '2019-10-13', 352, NULL),
('Hampton Inn', 151, '2019-10-14', 125, NULL),
('Hampton Inn', 151, '2019-10-15', 386, NULL),
('Hampton Inn', 151, '2019-10-16', 311, NULL),
('Hampton Inn', 151, '2019-10-17', 215, NULL),
('Hampton Inn', 151, '2019-10-18', 162, NULL),
('Hampton Inn', 151, '2019-10-19', 129, NULL),
('Hampton Inn', 151, '2019-10-20', 157, NULL),
('Hampton Inn', 151, '2019-10-21', 394, NULL),
('Hampton Inn', 151, '2019-10-22', 239, NULL),
('Hampton Inn', 151, '2019-10-23', 126, NULL),
('Hampton Inn', 151, '2019-10-24', 386, NULL),
('Hampton Inn', 151, '2019-10-25', 224, NULL),
('Hampton Inn', 151, '2019-10-26', 120, NULL),
('Hampton Inn', 151, '2019-10-27', 321, NULL),
('Hampton Inn', 151, '2019-10-28', 231, NULL),
('Hampton Inn', 151, '2019-10-29', 159, NULL),
('Hampton Inn', 151, '2019-10-30', 228, NULL),
('Hampton Inn', 151, '2019-10-31', 179, NULL),
('Hampton Inn', 151, '2019-11-01', 325, NULL),
('Hampton Inn', 151, '2019-11-02', 325, NULL),
('Hampton Inn', 151, '2019-11-03', 293, NULL),
('Hampton Inn', 151, '2019-11-04', 345, NULL),
('Hampton Inn', 151, '2019-11-05', 199, NULL),
('Hampton Inn', 151, '2019-11-06', 172, NULL),
('Hampton Inn', 151, '2019-11-07', 295, NULL),
('Hampton Inn', 151, '2019-11-08', 372, NULL),
('Hampton Inn', 151, '2019-11-09', 300, NULL),
('Hampton Inn', 151, '2019-11-10', 271, NULL),
('Hampton Inn', 151, '2019-11-11', 247, NULL),
('Hampton Inn', 151, '2019-11-12', 361, NULL),
('Hampton Inn', 151, '2019-11-13', 191, NULL),
('Hampton Inn', 151, '2019-11-14', 245, NULL),
('Hampton Inn', 151, '2019-11-15', 161, NULL),
('Hampton Inn', 151, '2019-11-16', 198, NULL),
('Hampton Inn', 151, '2019-11-17', 108, NULL),
('Hampton Inn', 151, '2019-11-18', 358, NULL),
('Hampton Inn', 151, '2019-11-19', 190, NULL),
('Hampton Inn', 151, '2019-11-20', 338, NULL),
('Hampton Inn', 151, '2019-11-21', 265, NULL),
('Hampton Inn', 151, '2019-11-22', 215, NULL),
('Hampton Inn', 151, '2019-11-23', 150, NULL),
('Hampton Inn', 151, '2019-11-24', 235, NULL),
('Hampton Inn', 151, '2019-11-25', 165, NULL),
('Hampton Inn', 151, '2019-11-26', 265, NULL),
('Hampton Inn', 151, '2019-11-27', 111, NULL),
('Hampton Inn', 151, '2019-11-28', 314, NULL),
('Hampton Inn', 151, '2019-11-29', 383, NULL),
('Hampton Inn', 151, '2019-11-30', 299, NULL),
('Hampton Inn', 151, '2019-12-01', 193, NULL),
('Hampton Inn', 151, '2019-12-02', 233, NULL),
('Hampton Inn', 151, '2019-12-03', 373, NULL),
('Hampton Inn', 151, '2019-12-04', 310, NULL),
('Hampton Inn', 151, '2019-12-05', 262, NULL),
('Hampton Inn', 151, '2019-12-06', 348, NULL),
('Hampton Inn', 151, '2019-12-07', 111, NULL),
('Hampton Inn', 151, '2019-12-08', 191, NULL),
('Hampton Inn', 151, '2019-12-09', 205, NULL),
('Hampton Inn', 151, '2019-12-10', 274, NULL),
('Hampton Inn', 151, '2019-12-11', 314, NULL),
('Hampton Inn', 151, '2019-12-12', 166, NULL),
('Hampton Inn', 151, '2019-12-13', 353, NULL),
('Hampton Inn', 151, '2019-12-14', 332, NULL),
('Hampton Inn', 151, '2019-12-15', 142, NULL),
('Hampton Inn', 151, '2019-12-16', 173, NULL),
('Hampton Inn', 151, '2019-12-17', 348, NULL),
('Hampton Inn', 151, '2019-12-18', 164, NULL),
('Hampton Inn', 151, '2019-12-19', 121, NULL),
('Hampton Inn', 151, '2019-12-20', 131, NULL),
('Hampton Inn', 151, '2019-12-21', 166, NULL),
('Hampton Inn', 151, '2019-12-22', 248, NULL),
('Hampton Inn', 151, '2019-12-23', 284, NULL),
('Hampton Inn', 151, '2019-12-24', 199, NULL),
('Hampton Inn', 151, '2019-12-25', 153, NULL),
('Hampton Inn', 151, '2019-12-26', 261, NULL),
('Hampton Inn', 151, '2019-12-27', 233, NULL),
('Hampton Inn', 151, '2019-12-28', 295, NULL),
('Hampton Inn', 151, '2019-12-29', 389, NULL),
('Hampton Inn', 151, '2019-12-30', 309, NULL),
('Hampton Inn', 151, '2019-12-31', 143, NULL),
('Hampton Inn', 151, '2020-01-01', 178, NULL),
('Hampton Inn', 151, '2020-01-02', 138, NULL),
('Hampton Inn', 151, '2020-01-03', 106, NULL),
('Hampton Inn', 151, '2020-01-04', 211, NULL),
('Hampton Inn', 151, '2020-01-05', 208, NULL),
('Hampton Inn', 151, '2020-01-06', 116, NULL),
('Hampton Inn', 151, '2020-01-07', 101, NULL),
('Hampton Inn', 151, '2020-01-08', 197, NULL),
('Hampton Inn', 151, '2020-01-09', 147, NULL),
('Hampton Inn', 151, '2020-01-10', 164, NULL),
('Hampton Inn', 151, '2020-01-11', 282, NULL),
('Hampton Inn', 151, '2020-01-12', 106, NULL),
('Hampton Inn', 151, '2020-01-13', 206, NULL),
('Hampton Inn', 151, '2020-01-14', 289, NULL),
('Hampton Inn', 151, '2020-01-15', 316, NULL),
('Hampton Inn', 151, '2020-01-16', 286, NULL),
('Hampton Inn', 151, '2020-01-17', 390, NULL),
('Hampton Inn', 151, '2020-01-18', 387, NULL),
('Hampton Inn', 151, '2020-01-19', 209, NULL),
('Hampton Inn', 151, '2020-01-20', 106, NULL),
('Hampton Inn', 151, '2020-01-21', 226, NULL),
('Hampton Inn', 151, '2020-01-22', 362, NULL),
('Hampton Inn', 151, '2020-01-23', 389, NULL),
('Hampton Inn', 151, '2020-01-24', 174, NULL),
('Hampton Inn', 151, '2020-01-25', 173, NULL),
('Hampton Inn', 151, '2020-01-26', 103, NULL),
('Hampton Inn', 151, '2020-01-27', 268, NULL),
('Hampton Inn', 151, '2020-01-28', 175, NULL),
('Hampton Inn', 151, '2020-01-29', 268, NULL),
('Hampton Inn', 151, '2020-01-30', 360, NULL),
('Hampton Inn', 151, '2020-01-31', 203, NULL),
('Hampton Inn', 151, '2020-02-01', 378, NULL),
('Hampton Inn', 151, '2020-02-02', 318, NULL),
('Hampton Inn', 151, '2020-02-03', 246, NULL),
('Hampton Inn', 151, '2020-02-04', 253, NULL),
('Hampton Inn', 168, '2019-01-01', 193, NULL),
('Hampton Inn', 168, '2019-01-02', 148, NULL),
('Hampton Inn', 168, '2019-01-03', 234, NULL),
('Hampton Inn', 168, '2019-01-04', 382, NULL),
('Hampton Inn', 168, '2019-01-05', 271, NULL),
('Hampton Inn', 168, '2019-01-06', 124, NULL),
('Hampton Inn', 168, '2019-01-07', 366, NULL),
('Hampton Inn', 168, '2019-01-08', 314, NULL),
('Hampton Inn', 168, '2019-01-09', 341, NULL),
('Hampton Inn', 168, '2019-01-10', 398, NULL),
('Hampton Inn', 168, '2019-01-11', 294, NULL),
('Hampton Inn', 168, '2019-01-12', 166, NULL),
('Hampton Inn', 168, '2019-01-13', 241, NULL),
('Hampton Inn', 168, '2019-01-14', 148, NULL),
('Hampton Inn', 168, '2019-01-15', 288, NULL),
('Hampton Inn', 168, '2019-01-16', 196, NULL),
('Hampton Inn', 168, '2019-01-17', 186, NULL),
('Hampton Inn', 168, '2019-01-18', 294, NULL),
('Hampton Inn', 168, '2019-01-19', 188, NULL),
('Hampton Inn', 168, '2019-01-20', 281, NULL),
('Hampton Inn', 168, '2019-01-21', 236, NULL),
('Hampton Inn', 168, '2019-01-22', 396, NULL),
('Hampton Inn', 168, '2019-01-23', 326, NULL),
('Hampton Inn', 168, '2019-01-24', 162, NULL),
('Hampton Inn', 168, '2019-01-25', 231, NULL),
('Hampton Inn', 168, '2019-01-26', 371, NULL),
('Hampton Inn', 168, '2019-01-27', 300, NULL),
('Hampton Inn', 168, '2019-01-28', 117, NULL),
('Hampton Inn', 168, '2019-01-29', 178, NULL),
('Hampton Inn', 168, '2019-01-30', 255, NULL),
('Hampton Inn', 168, '2019-01-31', 149, NULL),
('Hampton Inn', 168, '2019-02-01', 307, NULL),
('Hampton Inn', 168, '2019-02-02', 348, NULL),
('Hampton Inn', 168, '2019-02-03', 284, NULL),
('Hampton Inn', 168, '2019-02-04', 314, NULL),
('Hampton Inn', 168, '2019-02-05', 130, NULL),
('Hampton Inn', 168, '2019-02-06', 119, NULL),
('Hampton Inn', 168, '2019-02-07', 242, NULL),
('Hampton Inn', 168, '2019-02-08', 362, NULL),
('Hampton Inn', 168, '2019-02-09', 245, NULL),
('Hampton Inn', 168, '2019-02-10', 227, NULL),
('Hampton Inn', 168, '2019-02-11', 297, NULL),
('Hampton Inn', 168, '2019-02-12', 216, NULL),
('Hampton Inn', 168, '2019-02-13', 154, NULL),
('Hampton Inn', 168, '2019-02-14', 343, NULL),
('Hampton Inn', 168, '2019-02-15', 310, NULL),
('Hampton Inn', 168, '2019-02-16', 205, NULL),
('Hampton Inn', 168, '2019-02-17', 241, NULL),
('Hampton Inn', 168, '2019-02-18', 130, NULL),
('Hampton Inn', 168, '2019-02-19', 291, NULL),
('Hampton Inn', 168, '2019-02-20', 285, NULL),
('Hampton Inn', 168, '2019-02-21', 191, NULL),
('Hampton Inn', 168, '2019-02-22', 201, NULL),
('Hampton Inn', 168, '2019-02-23', 394, NULL),
('Hampton Inn', 168, '2019-02-24', 220, NULL),
('Hampton Inn', 168, '2019-02-25', 370, NULL),
('Hampton Inn', 168, '2019-02-26', 370, NULL),
('Hampton Inn', 168, '2019-02-27', 330, NULL),
('Hampton Inn', 168, '2019-02-28', 246, NULL),
('Hampton Inn', 168, '2019-03-01', 315, NULL),
('Hampton Inn', 168, '2019-03-02', 392, NULL),
('Hampton Inn', 168, '2019-03-03', 215, NULL),
('Hampton Inn', 168, '2019-03-04', 253, NULL),
('Hampton Inn', 168, '2019-03-05', 305, NULL),
('Hampton Inn', 168, '2019-03-06', 194, NULL),
('Hampton Inn', 168, '2019-03-07', 361, NULL),
('Hampton Inn', 168, '2019-03-08', 166, NULL),
('Hampton Inn', 168, '2019-03-09', 274, NULL),
('Hampton Inn', 168, '2019-03-10', 374, NULL),
('Hampton Inn', 168, '2019-03-11', 165, NULL),
('Hampton Inn', 168, '2019-03-12', 167, NULL),
('Hampton Inn', 168, '2019-03-13', 222, NULL),
('Hampton Inn', 168, '2019-03-14', 359, NULL),
('Hampton Inn', 168, '2019-03-15', 134, NULL),
('Hampton Inn', 168, '2019-03-16', 346, NULL),
('Hampton Inn', 168, '2019-03-17', 297, NULL),
('Hampton Inn', 168, '2019-03-18', 356, NULL),
('Hampton Inn', 168, '2019-03-19', 189, NULL),
('Hampton Inn', 168, '2019-03-20', 115, NULL),
('Hampton Inn', 168, '2019-03-21', 266, NULL),
('Hampton Inn', 168, '2019-03-22', 255, NULL),
('Hampton Inn', 168, '2019-03-23', 334, NULL),
('Hampton Inn', 168, '2019-03-24', 360, NULL),
('Hampton Inn', 168, '2019-03-25', 298, NULL),
('Hampton Inn', 168, '2019-03-26', 391, NULL),
('Hampton Inn', 168, '2019-03-27', 232, NULL),
('Hampton Inn', 168, '2019-03-28', 318, NULL),
('Hampton Inn', 168, '2019-03-29', 194, NULL),
('Hampton Inn', 168, '2019-03-30', 339, NULL),
('Hampton Inn', 168, '2019-03-31', 114, NULL),
('Hampton Inn', 168, '2019-04-01', 392, NULL),
('Hampton Inn', 168, '2019-04-02', 216, NULL),
('Hampton Inn', 168, '2019-04-03', 363, NULL),
('Hampton Inn', 168, '2019-04-04', 382, NULL),
('Hampton Inn', 168, '2019-04-05', 175, NULL),
('Hampton Inn', 168, '2019-04-06', 312, NULL),
('Hampton Inn', 168, '2019-04-07', 339, NULL),
('Hampton Inn', 168, '2019-04-08', 204, NULL),
('Hampton Inn', 168, '2019-04-09', 160, NULL),
('Hampton Inn', 168, '2019-04-10', 248, NULL),
('Hampton Inn', 168, '2019-04-11', 390, NULL),
('Hampton Inn', 168, '2019-04-12', 282, NULL),
('Hampton Inn', 168, '2019-04-13', 314, NULL),
('Hampton Inn', 168, '2019-04-14', 229, NULL),
('Hampton Inn', 168, '2019-04-15', 256, NULL),
('Hampton Inn', 168, '2019-04-16', 279, NULL),
('Hampton Inn', 168, '2019-04-17', 165, NULL),
('Hampton Inn', 168, '2019-04-18', 177, NULL),
('Hampton Inn', 168, '2019-04-19', 211, NULL),
('Hampton Inn', 168, '2019-04-20', 104, NULL),
('Hampton Inn', 168, '2019-04-21', 270, NULL),
('Hampton Inn', 168, '2019-04-22', 156, NULL),
('Hampton Inn', 168, '2019-04-23', 144, NULL),
('Hampton Inn', 168, '2019-04-24', 313, NULL),
('Hampton Inn', 168, '2019-04-25', 188, NULL),
('Hampton Inn', 168, '2019-04-26', 328, NULL),
('Hampton Inn', 168, '2019-04-27', 146, NULL),
('Hampton Inn', 168, '2019-04-28', 370, NULL),
('Hampton Inn', 168, '2019-04-29', 362, NULL),
('Hampton Inn', 168, '2019-04-30', 100, NULL),
('Hampton Inn', 168, '2019-05-01', 108, NULL),
('Hampton Inn', 168, '2019-05-02', 203, NULL),
('Hampton Inn', 168, '2019-05-03', 319, NULL),
('Hampton Inn', 168, '2019-05-04', 315, NULL),
('Hampton Inn', 168, '2019-05-05', 190, NULL),
('Hampton Inn', 168, '2019-05-06', 346, NULL),
('Hampton Inn', 168, '2019-05-07', 267, NULL),
('Hampton Inn', 168, '2019-05-08', 321, NULL),
('Hampton Inn', 168, '2019-05-09', 339, NULL),
('Hampton Inn', 168, '2019-05-10', 206, NULL),
('Hampton Inn', 168, '2019-05-11', 147, NULL),
('Hampton Inn', 168, '2019-05-12', 356, NULL),
('Hampton Inn', 168, '2019-05-13', 324, NULL),
('Hampton Inn', 168, '2019-05-14', 276, NULL),
('Hampton Inn', 168, '2019-05-15', 392, NULL),
('Hampton Inn', 168, '2019-05-16', 240, NULL),
('Hampton Inn', 168, '2019-05-17', 114, NULL),
('Hampton Inn', 168, '2019-05-18', 152, NULL),
('Hampton Inn', 168, '2019-05-19', 366, NULL),
('Hampton Inn', 168, '2019-05-20', 356, NULL),
('Hampton Inn', 168, '2019-05-21', 124, NULL),
('Hampton Inn', 168, '2019-05-22', 347, NULL),
('Hampton Inn', 168, '2019-05-23', 391, NULL),
('Hampton Inn', 168, '2019-05-24', 152, NULL),
('Hampton Inn', 168, '2019-05-25', 209, NULL),
('Hampton Inn', 168, '2019-05-26', 372, NULL),
('Hampton Inn', 168, '2019-05-27', 248, NULL),
('Hampton Inn', 168, '2019-05-28', 269, NULL),
('Hampton Inn', 168, '2019-05-29', 186, NULL),
('Hampton Inn', 168, '2019-05-30', 179, NULL),
('Hampton Inn', 168, '2019-05-31', 235, NULL),
('Hampton Inn', 168, '2019-06-01', 282, NULL),
('Hampton Inn', 168, '2019-06-02', 339, NULL),
('Hampton Inn', 168, '2019-06-03', 357, NULL),
('Hampton Inn', 168, '2019-06-04', 280, NULL),
('Hampton Inn', 168, '2019-06-05', 150, NULL),
('Hampton Inn', 168, '2019-06-06', 264, NULL),
('Hampton Inn', 168, '2019-06-07', 183, NULL),
('Hampton Inn', 168, '2019-06-08', 383, NULL),
('Hampton Inn', 168, '2019-06-09', 228, NULL),
('Hampton Inn', 168, '2019-06-10', 396, NULL),
('Hampton Inn', 168, '2019-06-11', 264, NULL),
('Hampton Inn', 168, '2019-06-12', 186, NULL),
('Hampton Inn', 168, '2019-06-13', 203, NULL),
('Hampton Inn', 168, '2019-06-14', 284, NULL),
('Hampton Inn', 168, '2019-06-15', 388, NULL),
('Hampton Inn', 168, '2019-06-16', 273, NULL),
('Hampton Inn', 168, '2019-06-17', 124, NULL),
('Hampton Inn', 168, '2019-06-18', 313, NULL),
('Hampton Inn', 168, '2019-06-19', 259, NULL),
('Hampton Inn', 168, '2019-06-20', 145, NULL),
('Hampton Inn', 168, '2019-06-21', 199, NULL),
('Hampton Inn', 168, '2019-06-22', 215, NULL),
('Hampton Inn', 168, '2019-06-23', 187, NULL),
('Hampton Inn', 168, '2019-06-24', 312, NULL),
('Hampton Inn', 168, '2019-06-25', 373, NULL),
('Hampton Inn', 168, '2019-06-26', 208, NULL),
('Hampton Inn', 168, '2019-06-27', 200, NULL),
('Hampton Inn', 168, '2019-06-28', 184, NULL),
('Hampton Inn', 168, '2019-06-29', 152, NULL),
('Hampton Inn', 168, '2019-06-30', 280, NULL),
('Hampton Inn', 168, '2019-07-01', 357, NULL),
('Hampton Inn', 168, '2019-07-02', 266, NULL),
('Hampton Inn', 168, '2019-07-03', 370, NULL),
('Hampton Inn', 168, '2019-07-04', 161, NULL),
('Hampton Inn', 168, '2019-07-05', 119, NULL),
('Hampton Inn', 168, '2019-07-06', 370, NULL),
('Hampton Inn', 168, '2019-07-07', 253, NULL),
('Hampton Inn', 168, '2019-07-08', 295, NULL),
('Hampton Inn', 168, '2019-07-09', 269, NULL),
('Hampton Inn', 168, '2019-07-10', 373, NULL),
('Hampton Inn', 168, '2019-07-11', 259, NULL),
('Hampton Inn', 168, '2019-07-12', 317, NULL),
('Hampton Inn', 168, '2019-07-13', 168, NULL),
('Hampton Inn', 168, '2019-07-14', 200, NULL),
('Hampton Inn', 168, '2019-07-15', 391, NULL),
('Hampton Inn', 168, '2019-07-16', 182, NULL),
('Hampton Inn', 168, '2019-07-17', 285, NULL),
('Hampton Inn', 168, '2019-07-18', 322, NULL),
('Hampton Inn', 168, '2019-07-19', 281, NULL),
('Hampton Inn', 168, '2019-07-20', 201, NULL),
('Hampton Inn', 168, '2019-07-21', 170, NULL),
('Hampton Inn', 168, '2019-07-22', 340, NULL),
('Hampton Inn', 168, '2019-07-23', 290, NULL),
('Hampton Inn', 168, '2019-07-24', 248, NULL),
('Hampton Inn', 168, '2019-07-25', 351, NULL),
('Hampton Inn', 168, '2019-07-26', 174, NULL),
('Hampton Inn', 168, '2019-07-27', 132, NULL),
('Hampton Inn', 168, '2019-07-28', 156, NULL),
('Hampton Inn', 168, '2019-07-29', 295, NULL),
('Hampton Inn', 168, '2019-07-30', 385, NULL),
('Hampton Inn', 168, '2019-07-31', 314, NULL),
('Hampton Inn', 168, '2019-08-01', 103, NULL),
('Hampton Inn', 168, '2019-08-02', 289, NULL),
('Hampton Inn', 168, '2019-08-03', 113, NULL),
('Hampton Inn', 168, '2019-08-04', 106, NULL),
('Hampton Inn', 168, '2019-08-05', 225, NULL),
('Hampton Inn', 168, '2019-08-06', 171, NULL),
('Hampton Inn', 168, '2019-08-07', 274, NULL),
('Hampton Inn', 168, '2019-08-08', 207, NULL),
('Hampton Inn', 168, '2019-08-09', 199, NULL),
('Hampton Inn', 168, '2019-08-10', 284, NULL),
('Hampton Inn', 168, '2019-08-11', 219, NULL),
('Hampton Inn', 168, '2019-08-12', 336, NULL),
('Hampton Inn', 168, '2019-08-13', 316, NULL),
('Hampton Inn', 168, '2019-08-14', 224, NULL),
('Hampton Inn', 168, '2019-08-15', 273, NULL),
('Hampton Inn', 168, '2019-08-16', 258, NULL),
('Hampton Inn', 168, '2019-08-17', 185, NULL),
('Hampton Inn', 168, '2019-08-18', 192, NULL),
('Hampton Inn', 168, '2019-08-19', 266, NULL),
('Hampton Inn', 168, '2019-08-20', 291, NULL),
('Hampton Inn', 168, '2019-08-21', 254, NULL),
('Hampton Inn', 168, '2019-08-22', 154, NULL),
('Hampton Inn', 168, '2019-08-23', 272, NULL),
('Hampton Inn', 168, '2019-08-24', 234, NULL),
('Hampton Inn', 168, '2019-08-25', 383, NULL),
('Hampton Inn', 168, '2019-08-26', 186, NULL),
('Hampton Inn', 168, '2019-08-27', 198, NULL),
('Hampton Inn', 168, '2019-08-28', 203, NULL),
('Hampton Inn', 168, '2019-08-29', 109, NULL),
('Hampton Inn', 168, '2019-08-30', 390, NULL),
('Hampton Inn', 168, '2019-08-31', 321, NULL),
('Hampton Inn', 168, '2019-09-01', 390, NULL),
('Hampton Inn', 168, '2019-09-02', 271, NULL),
('Hampton Inn', 168, '2019-09-03', 189, NULL),
('Hampton Inn', 168, '2019-09-04', 248, NULL),
('Hampton Inn', 168, '2019-09-05', 321, NULL),
('Hampton Inn', 168, '2019-09-06', 337, NULL),
('Hampton Inn', 168, '2019-09-07', 161, NULL),
('Hampton Inn', 168, '2019-09-08', 202, NULL),
('Hampton Inn', 168, '2019-09-09', 393, NULL),
('Hampton Inn', 168, '2019-09-10', 357, NULL),
('Hampton Inn', 168, '2019-09-11', 209, NULL),
('Hampton Inn', 168, '2019-09-12', 227, NULL),
('Hampton Inn', 168, '2019-09-13', 343, NULL),
('Hampton Inn', 168, '2019-09-14', 378, NULL),
('Hampton Inn', 168, '2019-09-15', 135, NULL),
('Hampton Inn', 168, '2019-09-16', 361, NULL),
('Hampton Inn', 168, '2019-09-17', 119, NULL),
('Hampton Inn', 168, '2019-09-18', 169, NULL),
('Hampton Inn', 168, '2019-09-19', 215, NULL),
('Hampton Inn', 168, '2019-09-20', 244, NULL),
('Hampton Inn', 168, '2019-09-21', 239, NULL),
('Hampton Inn', 168, '2019-09-22', 204, NULL),
('Hampton Inn', 168, '2019-09-23', 378, NULL),
('Hampton Inn', 168, '2019-09-24', 203, NULL),
('Hampton Inn', 168, '2019-09-25', 346, NULL),
('Hampton Inn', 168, '2019-09-26', 171, NULL),
('Hampton Inn', 168, '2019-09-27', 186, NULL),
('Hampton Inn', 168, '2019-09-28', 118, NULL),
('Hampton Inn', 168, '2019-09-29', 361, NULL),
('Hampton Inn', 168, '2019-09-30', 192, NULL),
('Hampton Inn', 168, '2019-10-01', 281, NULL),
('Hampton Inn', 168, '2019-10-02', 370, NULL),
('Hampton Inn', 168, '2019-10-03', 341, NULL),
('Hampton Inn', 168, '2019-10-04', 363, NULL),
('Hampton Inn', 168, '2019-10-05', 212, NULL),
('Hampton Inn', 168, '2019-10-06', 284, NULL),
('Hampton Inn', 168, '2019-10-07', 187, NULL),
('Hampton Inn', 168, '2019-10-08', 188, NULL),
('Hampton Inn', 168, '2019-10-09', 271, NULL),
('Hampton Inn', 168, '2019-10-10', 272, NULL),
('Hampton Inn', 168, '2019-10-11', 159, NULL),
('Hampton Inn', 168, '2019-10-12', 129, NULL),
('Hampton Inn', 168, '2019-10-13', 159, NULL),
('Hampton Inn', 168, '2019-10-14', 392, NULL),
('Hampton Inn', 168, '2019-10-15', 191, NULL),
('Hampton Inn', 168, '2019-10-16', 196, NULL),
('Hampton Inn', 168, '2019-10-17', 255, NULL),
('Hampton Inn', 168, '2019-10-18', 162, NULL),
('Hampton Inn', 168, '2019-10-19', 283, NULL),
('Hampton Inn', 168, '2019-10-20', 155, NULL),
('Hampton Inn', 168, '2019-10-21', 212, NULL),
('Hampton Inn', 168, '2019-10-22', 347, NULL),
('Hampton Inn', 168, '2019-10-23', 109, NULL),
('Hampton Inn', 168, '2019-10-24', 248, NULL),
('Hampton Inn', 168, '2019-10-25', 285, NULL),
('Hampton Inn', 168, '2019-10-26', 379, NULL),
('Hampton Inn', 168, '2019-10-27', 323, NULL),
('Hampton Inn', 168, '2019-10-28', 289, NULL),
('Hampton Inn', 168, '2019-10-29', 372, NULL),
('Hampton Inn', 168, '2019-10-30', 276, NULL),
('Hampton Inn', 168, '2019-10-31', 165, NULL),
('Hampton Inn', 168, '2019-11-01', 115, NULL),
('Hampton Inn', 168, '2019-11-02', 117, NULL),
('Hampton Inn', 168, '2019-11-03', 387, NULL),
('Hampton Inn', 168, '2019-11-04', 368, NULL),
('Hampton Inn', 168, '2019-11-05', 106, NULL),
('Hampton Inn', 168, '2019-11-06', 141, NULL),
('Hampton Inn', 168, '2019-11-07', 156, NULL),
('Hampton Inn', 168, '2019-11-08', 166, NULL),
('Hampton Inn', 168, '2019-11-09', 266, NULL),
('Hampton Inn', 168, '2019-11-10', 181, NULL),
('Hampton Inn', 168, '2019-11-11', 319, NULL),
('Hampton Inn', 168, '2019-11-12', 272, NULL),
('Hampton Inn', 168, '2019-11-13', 250, NULL),
('Hampton Inn', 168, '2019-11-14', 368, NULL),
('Hampton Inn', 168, '2019-11-15', 345, NULL),
('Hampton Inn', 168, '2019-11-16', 199, NULL),
('Hampton Inn', 168, '2019-11-17', 362, NULL),
('Hampton Inn', 168, '2019-11-18', 395, NULL),
('Hampton Inn', 168, '2019-11-19', 298, NULL),
('Hampton Inn', 168, '2019-11-20', 201, NULL),
('Hampton Inn', 168, '2019-11-21', 108, NULL),
('Hampton Inn', 168, '2019-11-22', 311, NULL),
('Hampton Inn', 168, '2019-11-23', 157, NULL),
('Hampton Inn', 168, '2019-11-24', 175, NULL),
('Hampton Inn', 168, '2019-11-25', 165, NULL),
('Hampton Inn', 168, '2019-11-26', 251, NULL),
('Hampton Inn', 168, '2019-11-27', 256, NULL),
('Hampton Inn', 168, '2019-11-28', 287, NULL),
('Hampton Inn', 168, '2019-11-29', 251, NULL),
('Hampton Inn', 168, '2019-11-30', 346, NULL),
('Hampton Inn', 168, '2019-12-01', 213, NULL),
('Hampton Inn', 168, '2019-12-02', 223, NULL),
('Hampton Inn', 168, '2019-12-03', 122, NULL),
('Hampton Inn', 168, '2019-12-04', 174, NULL),
('Hampton Inn', 168, '2019-12-05', 176, NULL),
('Hampton Inn', 168, '2019-12-06', 264, NULL),
('Hampton Inn', 168, '2019-12-07', 341, NULL),
('Hampton Inn', 168, '2019-12-08', 340, NULL),
('Hampton Inn', 168, '2019-12-09', 287, NULL),
('Hampton Inn', 168, '2019-12-10', 272, NULL),
('Hampton Inn', 168, '2019-12-11', 305, NULL),
('Hampton Inn', 168, '2019-12-12', 330, NULL),
('Hampton Inn', 168, '2019-12-13', 240, NULL),
('Hampton Inn', 168, '2019-12-14', 166, NULL),
('Hampton Inn', 168, '2019-12-15', 271, NULL),
('Hampton Inn', 168, '2019-12-16', 119, NULL),
('Hampton Inn', 168, '2019-12-17', 358, NULL),
('Hampton Inn', 168, '2019-12-18', 342, NULL),
('Hampton Inn', 168, '2019-12-19', 245, NULL),
('Hampton Inn', 168, '2019-12-20', 194, NULL),
('Hampton Inn', 168, '2019-12-21', 148, NULL),
('Hampton Inn', 168, '2019-12-22', 118, NULL),
('Hampton Inn', 168, '2019-12-23', 361, NULL),
('Hampton Inn', 168, '2019-12-24', 121, NULL),
('Hampton Inn', 168, '2019-12-25', 218, NULL),
('Hampton Inn', 168, '2019-12-26', 150, NULL),
('Hampton Inn', 168, '2019-12-27', 254, NULL),
('Hampton Inn', 168, '2019-12-28', 238, NULL),
('Hampton Inn', 168, '2019-12-29', 187, NULL),
('Hampton Inn', 168, '2019-12-30', 349, NULL),
('Hampton Inn', 168, '2019-12-31', 192, NULL),
('Hampton Inn', 168, '2020-01-01', 107, NULL),
('Hampton Inn', 168, '2020-01-02', 144, NULL),
('Hampton Inn', 168, '2020-01-03', 198, NULL),
('Hampton Inn', 168, '2020-01-04', 106, NULL),
('Hampton Inn', 168, '2020-01-05', 153, NULL),
('Hampton Inn', 168, '2020-01-06', 152, NULL),
('Hampton Inn', 168, '2020-01-07', 236, NULL),
('Hampton Inn', 168, '2020-01-08', 235, NULL),
('Hampton Inn', 168, '2020-01-09', 301, NULL),
('Hampton Inn', 168, '2020-01-10', 374, NULL),
('Hampton Inn', 168, '2020-01-11', 384, NULL),
('Hampton Inn', 168, '2020-01-12', 247, NULL),
('Hampton Inn', 168, '2020-01-13', 161, NULL),
('Hampton Inn', 168, '2020-01-14', 336, NULL),
('Hampton Inn', 168, '2020-01-15', 375, NULL),
('Hampton Inn', 168, '2020-01-16', 142, NULL),
('Hampton Inn', 168, '2020-01-17', 141, NULL),
('Hampton Inn', 168, '2020-01-18', 319, NULL),
('Hampton Inn', 168, '2020-01-19', 284, NULL),
('Hampton Inn', 168, '2020-01-20', 297, NULL),
('Hampton Inn', 168, '2020-01-21', 119, NULL),
('Hampton Inn', 168, '2020-01-22', 381, NULL),
('Hampton Inn', 168, '2020-01-23', 366, NULL),
('Hampton Inn', 168, '2020-01-24', 338, NULL),
('Hampton Inn', 168, '2020-01-25', 365, NULL),
('Hampton Inn', 168, '2020-01-26', 124, NULL),
('Hampton Inn', 168, '2020-01-27', 101, NULL),
('Hampton Inn', 168, '2020-01-28', 265, NULL),
('Hampton Inn', 168, '2020-01-29', 374, NULL),
('Hampton Inn', 168, '2020-01-30', 292, NULL),
('Hampton Inn', 168, '2020-01-31', 382, NULL),
('Hampton Inn', 168, '2020-02-01', 259, NULL),
('Hampton Inn', 168, '2020-02-02', 371, NULL),
('Hampton Inn', 168, '2020-02-03', 128, NULL),
('Hampton Inn', 168, '2020-02-04', 308, NULL),
('Hampton Inn', 185, '2019-01-01', 340, NULL),
('Hampton Inn', 185, '2019-01-02', 100, NULL),
('Hampton Inn', 185, '2019-01-03', 268, NULL),
('Hampton Inn', 185, '2019-01-04', 265, NULL),
('Hampton Inn', 185, '2019-01-05', 279, NULL),
('Hampton Inn', 185, '2019-01-06', 341, NULL),
('Hampton Inn', 185, '2019-01-07', 191, NULL),
('Hampton Inn', 185, '2019-01-08', 396, NULL),
('Hampton Inn', 185, '2019-01-09', 313, NULL),
('Hampton Inn', 185, '2019-01-10', 288, NULL),
('Hampton Inn', 185, '2019-01-11', 220, NULL),
('Hampton Inn', 185, '2019-01-12', 374, NULL),
('Hampton Inn', 185, '2019-01-13', 320, NULL),
('Hampton Inn', 185, '2019-01-14', 128, NULL),
('Hampton Inn', 185, '2019-01-15', 242, NULL),
('Hampton Inn', 185, '2019-01-16', 176, NULL),
('Hampton Inn', 185, '2019-01-17', 276, NULL),
('Hampton Inn', 185, '2019-01-18', 226, NULL),
('Hampton Inn', 185, '2019-01-19', 306, NULL),
('Hampton Inn', 185, '2019-01-20', 299, NULL),
('Hampton Inn', 185, '2019-01-21', 165, NULL),
('Hampton Inn', 185, '2019-01-22', 349, NULL),
('Hampton Inn', 185, '2019-01-23', 333, NULL),
('Hampton Inn', 185, '2019-01-24', 271, NULL),
('Hampton Inn', 185, '2019-01-25', 266, NULL),
('Hampton Inn', 185, '2019-01-26', 310, NULL),
('Hampton Inn', 185, '2019-01-27', 201, NULL),
('Hampton Inn', 185, '2019-01-28', 343, NULL),
('Hampton Inn', 185, '2019-01-29', 163, NULL),
('Hampton Inn', 185, '2019-01-30', 157, NULL),
('Hampton Inn', 185, '2019-01-31', 246, NULL),
('Hampton Inn', 185, '2019-02-01', 305, NULL),
('Hampton Inn', 185, '2019-02-02', 103, NULL),
('Hampton Inn', 185, '2019-02-03', 111, NULL),
('Hampton Inn', 185, '2019-02-04', 182, NULL),
('Hampton Inn', 185, '2019-02-05', 169, NULL),
('Hampton Inn', 185, '2019-02-06', 299, NULL),
('Hampton Inn', 185, '2019-02-07', 271, NULL),
('Hampton Inn', 185, '2019-02-08', 357, NULL),
('Hampton Inn', 185, '2019-02-09', 356, NULL),
('Hampton Inn', 185, '2019-02-10', 345, NULL),
('Hampton Inn', 185, '2019-02-11', 366, NULL),
('Hampton Inn', 185, '2019-02-12', 147, NULL),
('Hampton Inn', 185, '2019-02-13', 341, NULL),
('Hampton Inn', 185, '2019-02-14', 397, NULL),
('Hampton Inn', 185, '2019-02-15', 337, NULL),
('Hampton Inn', 185, '2019-02-16', 229, NULL),
('Hampton Inn', 185, '2019-02-17', 144, NULL),
('Hampton Inn', 185, '2019-02-18', 376, NULL),
('Hampton Inn', 185, '2019-02-19', 383, NULL),
('Hampton Inn', 185, '2019-02-20', 284, NULL),
('Hampton Inn', 185, '2019-02-21', 249, NULL),
('Hampton Inn', 185, '2019-02-22', 396, NULL),
('Hampton Inn', 185, '2019-02-23', 270, NULL),
('Hampton Inn', 185, '2019-02-24', 207, NULL),
('Hampton Inn', 185, '2019-02-25', 208, NULL),
('Hampton Inn', 185, '2019-02-26', 238, NULL),
('Hampton Inn', 185, '2019-02-27', 296, NULL),
('Hampton Inn', 185, '2019-02-28', 317, NULL),
('Hampton Inn', 185, '2019-03-01', 171, NULL),
('Hampton Inn', 185, '2019-03-02', 120, NULL),
('Hampton Inn', 185, '2019-03-03', 363, NULL),
('Hampton Inn', 185, '2019-03-04', 180, NULL),
('Hampton Inn', 185, '2019-03-05', 134, NULL),
('Hampton Inn', 185, '2019-03-06', 242, NULL),
('Hampton Inn', 185, '2019-03-07', 393, NULL),
('Hampton Inn', 185, '2019-03-08', 157, NULL),
('Hampton Inn', 185, '2019-03-09', 156, NULL),
('Hampton Inn', 185, '2019-03-10', 395, NULL),
('Hampton Inn', 185, '2019-03-11', 325, NULL),
('Hampton Inn', 185, '2019-03-12', 238, NULL),
('Hampton Inn', 185, '2019-03-13', 301, NULL),
('Hampton Inn', 185, '2019-03-14', 312, NULL),
('Hampton Inn', 185, '2019-03-15', 256, NULL),
('Hampton Inn', 185, '2019-03-16', 197, NULL),
('Hampton Inn', 185, '2019-03-17', 324, NULL),
('Hampton Inn', 185, '2019-03-18', 159, NULL),
('Hampton Inn', 185, '2019-03-19', 366, NULL),
('Hampton Inn', 185, '2019-03-20', 120, NULL),
('Hampton Inn', 185, '2019-03-21', 107, NULL),
('Hampton Inn', 185, '2019-03-22', 109, NULL),
('Hampton Inn', 185, '2019-03-23', 189, NULL),
('Hampton Inn', 185, '2019-03-24', 108, NULL),
('Hampton Inn', 185, '2019-03-25', 189, NULL),
('Hampton Inn', 185, '2019-03-26', 105, NULL),
('Hampton Inn', 185, '2019-03-27', 143, NULL),
('Hampton Inn', 185, '2019-03-28', 241, NULL),
('Hampton Inn', 185, '2019-03-29', 204, NULL),
('Hampton Inn', 185, '2019-03-30', 390, NULL),
('Hampton Inn', 185, '2019-03-31', 294, NULL),
('Hampton Inn', 185, '2019-04-01', 229, NULL),
('Hampton Inn', 185, '2019-04-02', 376, NULL),
('Hampton Inn', 185, '2019-04-03', 131, NULL),
('Hampton Inn', 185, '2019-04-04', 201, NULL),
('Hampton Inn', 185, '2019-04-05', 180, NULL),
('Hampton Inn', 185, '2019-04-06', 261, NULL),
('Hampton Inn', 185, '2019-04-07', 327, NULL),
('Hampton Inn', 185, '2019-04-08', 341, NULL),
('Hampton Inn', 185, '2019-04-09', 314, NULL),
('Hampton Inn', 185, '2019-04-10', 355, NULL),
('Hampton Inn', 185, '2019-04-11', 259, NULL),
('Hampton Inn', 185, '2019-04-12', 322, NULL),
('Hampton Inn', 185, '2019-04-13', 343, NULL),
('Hampton Inn', 185, '2019-04-14', 114, NULL),
('Hampton Inn', 185, '2019-04-15', 260, NULL),
('Hampton Inn', 185, '2019-04-16', 386, NULL),
('Hampton Inn', 185, '2019-04-17', 138, NULL),
('Hampton Inn', 185, '2019-04-18', 259, NULL),
('Hampton Inn', 185, '2019-04-19', 169, NULL),
('Hampton Inn', 185, '2019-04-20', 398, NULL),
('Hampton Inn', 185, '2019-04-21', 179, NULL),
('Hampton Inn', 185, '2019-04-22', 139, NULL),
('Hampton Inn', 185, '2019-04-23', 224, NULL),
('Hampton Inn', 185, '2019-04-24', 310, NULL),
('Hampton Inn', 185, '2019-04-25', 239, NULL),
('Hampton Inn', 185, '2019-04-26', 366, NULL),
('Hampton Inn', 185, '2019-04-27', 269, NULL),
('Hampton Inn', 185, '2019-04-28', 180, NULL),
('Hampton Inn', 185, '2019-04-29', 332, NULL),
('Hampton Inn', 185, '2019-04-30', 276, NULL),
('Hampton Inn', 185, '2019-05-01', 202, NULL),
('Hampton Inn', 185, '2019-05-02', 290, NULL),
('Hampton Inn', 185, '2019-05-03', 104, NULL),
('Hampton Inn', 185, '2019-05-04', 193, NULL),
('Hampton Inn', 185, '2019-05-05', 310, NULL),
('Hampton Inn', 185, '2019-05-06', 260, NULL),
('Hampton Inn', 185, '2019-05-07', 125, NULL),
('Hampton Inn', 185, '2019-05-08', 118, NULL),
('Hampton Inn', 185, '2019-05-09', 279, NULL),
('Hampton Inn', 185, '2019-05-10', 356, NULL),
('Hampton Inn', 185, '2019-05-11', 196, NULL),
('Hampton Inn', 185, '2019-05-12', 187, NULL),
('Hampton Inn', 185, '2019-05-13', 282, NULL),
('Hampton Inn', 185, '2019-05-14', 245, NULL),
('Hampton Inn', 185, '2019-05-15', 216, NULL),
('Hampton Inn', 185, '2019-05-16', 265, NULL),
('Hampton Inn', 185, '2019-05-17', 382, NULL),
('Hampton Inn', 185, '2019-05-18', 353, NULL),
('Hampton Inn', 185, '2019-05-19', 359, NULL),
('Hampton Inn', 185, '2019-05-20', 378, NULL),
('Hampton Inn', 185, '2019-05-21', 124, NULL),
('Hampton Inn', 185, '2019-05-22', 159, NULL),
('Hampton Inn', 185, '2019-05-23', 261, NULL),
('Hampton Inn', 185, '2019-05-24', 119, NULL),
('Hampton Inn', 185, '2019-05-25', 181, NULL),
('Hampton Inn', 185, '2019-05-26', 383, NULL),
('Hampton Inn', 185, '2019-05-27', 186, NULL),
('Hampton Inn', 185, '2019-05-28', 225, NULL),
('Hampton Inn', 185, '2019-05-29', 325, NULL),
('Hampton Inn', 185, '2019-05-30', 195, NULL),
('Hampton Inn', 185, '2019-05-31', 281, NULL),
('Hampton Inn', 185, '2019-06-01', 394, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 185, '2019-06-02', 275, NULL),
('Hampton Inn', 185, '2019-06-03', 372, NULL),
('Hampton Inn', 185, '2019-06-04', 159, NULL),
('Hampton Inn', 185, '2019-06-05', 243, NULL),
('Hampton Inn', 185, '2019-06-06', 143, NULL),
('Hampton Inn', 185, '2019-06-07', 191, NULL),
('Hampton Inn', 185, '2019-06-08', 385, NULL),
('Hampton Inn', 185, '2019-06-09', 387, NULL),
('Hampton Inn', 185, '2019-06-10', 310, NULL),
('Hampton Inn', 185, '2019-06-11', 174, NULL),
('Hampton Inn', 185, '2019-06-12', 298, NULL),
('Hampton Inn', 185, '2019-06-13', 380, NULL),
('Hampton Inn', 185, '2019-06-14', 304, NULL),
('Hampton Inn', 185, '2019-06-15', 266, NULL),
('Hampton Inn', 185, '2019-06-16', 364, NULL),
('Hampton Inn', 185, '2019-06-17', 218, NULL),
('Hampton Inn', 185, '2019-06-18', 238, NULL),
('Hampton Inn', 185, '2019-06-19', 261, NULL),
('Hampton Inn', 185, '2019-06-20', 101, NULL),
('Hampton Inn', 185, '2019-06-21', 330, NULL),
('Hampton Inn', 185, '2019-06-22', 241, NULL),
('Hampton Inn', 185, '2019-06-23', 210, NULL),
('Hampton Inn', 185, '2019-06-24', 349, NULL),
('Hampton Inn', 185, '2019-06-25', 270, NULL),
('Hampton Inn', 185, '2019-06-26', 327, NULL),
('Hampton Inn', 185, '2019-06-27', 243, NULL),
('Hampton Inn', 185, '2019-06-28', 180, NULL),
('Hampton Inn', 185, '2019-06-29', 275, NULL),
('Hampton Inn', 185, '2019-06-30', 376, NULL),
('Hampton Inn', 185, '2019-07-01', 397, NULL),
('Hampton Inn', 185, '2019-07-02', 111, NULL),
('Hampton Inn', 185, '2019-07-03', 212, NULL),
('Hampton Inn', 185, '2019-07-04', 373, NULL),
('Hampton Inn', 185, '2019-07-05', 171, NULL),
('Hampton Inn', 185, '2019-07-06', 260, NULL),
('Hampton Inn', 185, '2019-07-07', 295, NULL),
('Hampton Inn', 185, '2019-07-08', 243, NULL),
('Hampton Inn', 185, '2019-07-09', 323, NULL),
('Hampton Inn', 185, '2019-07-10', 217, NULL),
('Hampton Inn', 185, '2019-07-11', 254, NULL),
('Hampton Inn', 185, '2019-07-12', 365, NULL),
('Hampton Inn', 185, '2019-07-13', 346, NULL),
('Hampton Inn', 185, '2019-07-14', 233, NULL),
('Hampton Inn', 185, '2019-07-15', 243, NULL),
('Hampton Inn', 185, '2019-07-16', 131, NULL),
('Hampton Inn', 185, '2019-07-17', 111, NULL),
('Hampton Inn', 185, '2019-07-18', 109, NULL),
('Hampton Inn', 185, '2019-07-19', 209, NULL),
('Hampton Inn', 185, '2019-07-20', 203, NULL),
('Hampton Inn', 185, '2019-07-21', 180, NULL),
('Hampton Inn', 185, '2019-07-22', 367, NULL),
('Hampton Inn', 185, '2019-07-23', 271, NULL),
('Hampton Inn', 185, '2019-07-24', 287, NULL),
('Hampton Inn', 185, '2019-07-25', 210, NULL),
('Hampton Inn', 185, '2019-07-26', 331, NULL),
('Hampton Inn', 185, '2019-07-27', 201, NULL),
('Hampton Inn', 185, '2019-07-28', 160, NULL),
('Hampton Inn', 185, '2019-07-29', 247, NULL),
('Hampton Inn', 185, '2019-07-30', 361, NULL),
('Hampton Inn', 185, '2019-07-31', 317, NULL),
('Hampton Inn', 185, '2019-08-01', 124, NULL),
('Hampton Inn', 185, '2019-08-02', 127, NULL),
('Hampton Inn', 185, '2019-08-03', 244, NULL),
('Hampton Inn', 185, '2019-08-04', 175, NULL),
('Hampton Inn', 185, '2019-08-05', 223, NULL),
('Hampton Inn', 185, '2019-08-06', 206, NULL),
('Hampton Inn', 185, '2019-08-07', 398, NULL),
('Hampton Inn', 185, '2019-08-08', 369, NULL),
('Hampton Inn', 185, '2019-08-09', 139, NULL),
('Hampton Inn', 185, '2019-08-10', 201, NULL),
('Hampton Inn', 185, '2019-08-11', 234, NULL),
('Hampton Inn', 185, '2019-08-12', 228, NULL),
('Hampton Inn', 185, '2019-08-13', 353, NULL),
('Hampton Inn', 185, '2019-08-14', 180, NULL),
('Hampton Inn', 185, '2019-08-15', 351, NULL),
('Hampton Inn', 185, '2019-08-16', 123, NULL),
('Hampton Inn', 185, '2019-08-17', 363, NULL),
('Hampton Inn', 185, '2019-08-18', 164, NULL),
('Hampton Inn', 185, '2019-08-19', 236, NULL),
('Hampton Inn', 185, '2019-08-20', 220, NULL),
('Hampton Inn', 185, '2019-08-21', 380, NULL),
('Hampton Inn', 185, '2019-08-22', 355, NULL),
('Hampton Inn', 185, '2019-08-23', 233, NULL),
('Hampton Inn', 185, '2019-08-24', 335, NULL),
('Hampton Inn', 185, '2019-08-25', 328, NULL),
('Hampton Inn', 185, '2019-08-26', 188, NULL),
('Hampton Inn', 185, '2019-08-27', 295, NULL),
('Hampton Inn', 185, '2019-08-28', 149, NULL),
('Hampton Inn', 185, '2019-08-29', 294, NULL),
('Hampton Inn', 185, '2019-08-30', 108, NULL),
('Hampton Inn', 185, '2019-08-31', 163, NULL),
('Hampton Inn', 185, '2019-09-01', 160, NULL),
('Hampton Inn', 185, '2019-09-02', 238, NULL),
('Hampton Inn', 185, '2019-09-03', 338, NULL),
('Hampton Inn', 185, '2019-09-04', 133, NULL),
('Hampton Inn', 185, '2019-09-05', 185, NULL),
('Hampton Inn', 185, '2019-09-06', 396, NULL),
('Hampton Inn', 185, '2019-09-07', 219, NULL),
('Hampton Inn', 185, '2019-09-08', 299, NULL),
('Hampton Inn', 185, '2019-09-09', 289, NULL),
('Hampton Inn', 185, '2019-09-10', 288, NULL),
('Hampton Inn', 185, '2019-09-11', 209, NULL),
('Hampton Inn', 185, '2019-09-12', 340, NULL),
('Hampton Inn', 185, '2019-09-13', 331, NULL),
('Hampton Inn', 185, '2019-09-14', 191, NULL),
('Hampton Inn', 185, '2019-09-15', 146, NULL),
('Hampton Inn', 185, '2019-09-16', 136, NULL),
('Hampton Inn', 185, '2019-09-17', 148, NULL),
('Hampton Inn', 185, '2019-09-18', 388, NULL),
('Hampton Inn', 185, '2019-09-19', 345, NULL),
('Hampton Inn', 185, '2019-09-20', 165, NULL),
('Hampton Inn', 185, '2019-09-21', 126, NULL),
('Hampton Inn', 185, '2019-09-22', 281, NULL),
('Hampton Inn', 185, '2019-09-23', 337, NULL),
('Hampton Inn', 185, '2019-09-24', 384, NULL),
('Hampton Inn', 185, '2019-09-25', 296, NULL),
('Hampton Inn', 185, '2019-09-26', 286, NULL),
('Hampton Inn', 185, '2019-09-27', 207, NULL),
('Hampton Inn', 185, '2019-09-28', 187, NULL),
('Hampton Inn', 185, '2019-09-29', 318, NULL),
('Hampton Inn', 185, '2019-09-30', 216, NULL),
('Hampton Inn', 185, '2019-10-01', 186, NULL),
('Hampton Inn', 185, '2019-10-02', 346, NULL),
('Hampton Inn', 185, '2019-10-03', 167, NULL),
('Hampton Inn', 185, '2019-10-04', 342, NULL),
('Hampton Inn', 185, '2019-10-05', 159, NULL),
('Hampton Inn', 185, '2019-10-06', 291, NULL),
('Hampton Inn', 185, '2019-10-07', 185, NULL),
('Hampton Inn', 185, '2019-10-08', 243, NULL),
('Hampton Inn', 185, '2019-10-09', 210, NULL),
('Hampton Inn', 185, '2019-10-10', 236, NULL),
('Hampton Inn', 185, '2019-10-11', 215, NULL),
('Hampton Inn', 185, '2019-10-12', 249, NULL),
('Hampton Inn', 185, '2019-10-13', 238, NULL),
('Hampton Inn', 185, '2019-10-14', 283, NULL),
('Hampton Inn', 185, '2019-10-15', 298, NULL),
('Hampton Inn', 185, '2019-10-16', 246, NULL),
('Hampton Inn', 185, '2019-10-17', 232, NULL),
('Hampton Inn', 185, '2019-10-18', 226, NULL),
('Hampton Inn', 185, '2019-10-19', 329, NULL),
('Hampton Inn', 185, '2019-10-20', 201, NULL),
('Hampton Inn', 185, '2019-10-21', 377, NULL),
('Hampton Inn', 185, '2019-10-22', 318, NULL),
('Hampton Inn', 185, '2019-10-23', 367, NULL),
('Hampton Inn', 185, '2019-10-24', 283, NULL),
('Hampton Inn', 185, '2019-10-25', 354, NULL),
('Hampton Inn', 185, '2019-10-26', 237, NULL),
('Hampton Inn', 185, '2019-10-27', 251, NULL),
('Hampton Inn', 185, '2019-10-28', 353, NULL),
('Hampton Inn', 185, '2019-10-29', 383, NULL),
('Hampton Inn', 185, '2019-10-30', 297, NULL),
('Hampton Inn', 185, '2019-10-31', 192, NULL),
('Hampton Inn', 185, '2019-11-01', 100, NULL),
('Hampton Inn', 185, '2019-11-02', 107, NULL),
('Hampton Inn', 185, '2019-11-03', 355, NULL),
('Hampton Inn', 185, '2019-11-04', 107, NULL),
('Hampton Inn', 185, '2019-11-05', 133, NULL),
('Hampton Inn', 185, '2019-11-06', 393, NULL),
('Hampton Inn', 185, '2019-11-07', 397, NULL),
('Hampton Inn', 185, '2019-11-08', 213, NULL),
('Hampton Inn', 185, '2019-11-09', 330, NULL),
('Hampton Inn', 185, '2019-11-10', 289, NULL),
('Hampton Inn', 185, '2019-11-11', 151, NULL),
('Hampton Inn', 185, '2019-11-12', 177, NULL),
('Hampton Inn', 185, '2019-11-13', 274, NULL),
('Hampton Inn', 185, '2019-11-14', 106, NULL),
('Hampton Inn', 185, '2019-11-15', 243, NULL),
('Hampton Inn', 185, '2019-11-16', 303, NULL),
('Hampton Inn', 185, '2019-11-17', 188, NULL),
('Hampton Inn', 185, '2019-11-18', 204, NULL),
('Hampton Inn', 185, '2019-11-19', 223, NULL),
('Hampton Inn', 185, '2019-11-20', 189, NULL),
('Hampton Inn', 185, '2019-11-21', 246, NULL),
('Hampton Inn', 185, '2019-11-22', 211, NULL),
('Hampton Inn', 185, '2019-11-23', 234, NULL),
('Hampton Inn', 185, '2019-11-24', 372, NULL),
('Hampton Inn', 185, '2019-11-25', 230, NULL),
('Hampton Inn', 185, '2019-11-26', 363, NULL),
('Hampton Inn', 185, '2019-11-27', 251, NULL),
('Hampton Inn', 185, '2019-11-28', 395, NULL),
('Hampton Inn', 185, '2019-11-29', 308, NULL),
('Hampton Inn', 185, '2019-11-30', 133, NULL),
('Hampton Inn', 185, '2019-12-01', 384, NULL),
('Hampton Inn', 185, '2019-12-02', 316, NULL),
('Hampton Inn', 185, '2019-12-03', 293, NULL),
('Hampton Inn', 185, '2019-12-04', 139, NULL),
('Hampton Inn', 185, '2019-12-05', 294, NULL),
('Hampton Inn', 185, '2019-12-06', 175, NULL),
('Hampton Inn', 185, '2019-12-07', 372, NULL),
('Hampton Inn', 185, '2019-12-08', 128, NULL),
('Hampton Inn', 185, '2019-12-09', 122, NULL),
('Hampton Inn', 185, '2019-12-10', 139, NULL),
('Hampton Inn', 185, '2019-12-11', 185, NULL),
('Hampton Inn', 185, '2019-12-12', 152, NULL),
('Hampton Inn', 185, '2019-12-13', 341, NULL),
('Hampton Inn', 185, '2019-12-14', 335, NULL),
('Hampton Inn', 185, '2019-12-15', 230, NULL),
('Hampton Inn', 185, '2019-12-16', 276, NULL),
('Hampton Inn', 185, '2019-12-17', 350, NULL),
('Hampton Inn', 185, '2019-12-18', 219, NULL),
('Hampton Inn', 185, '2019-12-19', 160, NULL),
('Hampton Inn', 185, '2019-12-20', 178, NULL),
('Hampton Inn', 185, '2019-12-21', 145, NULL),
('Hampton Inn', 185, '2019-12-22', 348, NULL),
('Hampton Inn', 185, '2019-12-23', 256, NULL),
('Hampton Inn', 185, '2019-12-24', 206, NULL),
('Hampton Inn', 185, '2019-12-25', 232, NULL),
('Hampton Inn', 185, '2019-12-26', 169, NULL),
('Hampton Inn', 185, '2019-12-27', 168, NULL),
('Hampton Inn', 185, '2019-12-28', 207, NULL),
('Hampton Inn', 185, '2019-12-29', 268, NULL),
('Hampton Inn', 185, '2019-12-30', 117, NULL),
('Hampton Inn', 185, '2019-12-31', 133, NULL),
('Hampton Inn', 185, '2020-01-01', 205, NULL),
('Hampton Inn', 185, '2020-01-02', 209, NULL),
('Hampton Inn', 185, '2020-01-03', 273, NULL),
('Hampton Inn', 185, '2020-01-04', 396, NULL),
('Hampton Inn', 185, '2020-01-05', 343, NULL),
('Hampton Inn', 185, '2020-01-06', 314, NULL),
('Hampton Inn', 185, '2020-01-07', 179, NULL),
('Hampton Inn', 185, '2020-01-08', 182, NULL),
('Hampton Inn', 185, '2020-01-09', 364, NULL),
('Hampton Inn', 185, '2020-01-10', 379, NULL),
('Hampton Inn', 185, '2020-01-11', 377, NULL),
('Hampton Inn', 185, '2020-01-12', 220, NULL),
('Hampton Inn', 185, '2020-01-13', 387, NULL),
('Hampton Inn', 185, '2020-01-14', 111, NULL),
('Hampton Inn', 185, '2020-01-15', 228, NULL),
('Hampton Inn', 185, '2020-01-16', 353, NULL),
('Hampton Inn', 185, '2020-01-17', 337, NULL),
('Hampton Inn', 185, '2020-01-18', 335, NULL),
('Hampton Inn', 185, '2020-01-19', 391, NULL),
('Hampton Inn', 185, '2020-01-20', 167, NULL),
('Hampton Inn', 185, '2020-01-21', 115, NULL),
('Hampton Inn', 185, '2020-01-22', 120, NULL),
('Hampton Inn', 185, '2020-01-23', 263, NULL),
('Hampton Inn', 185, '2020-01-24', 168, NULL),
('Hampton Inn', 185, '2020-01-25', 305, NULL),
('Hampton Inn', 185, '2020-01-26', 211, NULL),
('Hampton Inn', 185, '2020-01-27', 203, NULL),
('Hampton Inn', 185, '2020-01-28', 100, NULL),
('Hampton Inn', 185, '2020-01-29', 369, NULL),
('Hampton Inn', 185, '2020-01-30', 277, NULL),
('Hampton Inn', 185, '2020-01-31', 302, NULL),
('Hampton Inn', 185, '2020-02-01', 364, NULL),
('Hampton Inn', 185, '2020-02-02', 199, NULL),
('Hampton Inn', 185, '2020-02-03', 101, NULL),
('Hampton Inn', 185, '2020-02-04', 382, NULL),
('Hampton Inn', 191, '2019-01-01', 125, NULL),
('Hampton Inn', 191, '2019-01-02', 255, NULL),
('Hampton Inn', 191, '2019-01-03', 236, NULL),
('Hampton Inn', 191, '2019-01-04', 379, NULL),
('Hampton Inn', 191, '2019-01-05', 185, NULL),
('Hampton Inn', 191, '2019-01-06', 330, NULL),
('Hampton Inn', 191, '2019-01-07', 358, NULL),
('Hampton Inn', 191, '2019-01-08', 337, NULL),
('Hampton Inn', 191, '2019-01-09', 141, NULL),
('Hampton Inn', 191, '2019-01-10', 146, NULL),
('Hampton Inn', 191, '2019-01-11', 118, NULL),
('Hampton Inn', 191, '2019-01-12', 374, NULL),
('Hampton Inn', 191, '2019-01-13', 178, NULL),
('Hampton Inn', 191, '2019-01-14', 398, NULL),
('Hampton Inn', 191, '2019-01-15', 244, NULL),
('Hampton Inn', 191, '2019-01-16', 194, NULL),
('Hampton Inn', 191, '2019-01-17', 125, NULL),
('Hampton Inn', 191, '2019-01-18', 147, NULL),
('Hampton Inn', 191, '2019-01-19', 264, NULL),
('Hampton Inn', 191, '2019-01-20', 252, NULL),
('Hampton Inn', 191, '2019-01-21', 320, NULL),
('Hampton Inn', 191, '2019-01-22', 155, NULL),
('Hampton Inn', 191, '2019-01-23', 286, NULL),
('Hampton Inn', 191, '2019-01-24', 169, NULL),
('Hampton Inn', 191, '2019-01-25', 238, NULL),
('Hampton Inn', 191, '2019-01-26', 337, NULL),
('Hampton Inn', 191, '2019-01-27', 305, NULL),
('Hampton Inn', 191, '2019-01-28', 364, NULL),
('Hampton Inn', 191, '2019-01-29', 181, NULL),
('Hampton Inn', 191, '2019-01-30', 220, NULL),
('Hampton Inn', 191, '2019-01-31', 381, NULL),
('Hampton Inn', 191, '2019-02-01', 205, NULL),
('Hampton Inn', 191, '2019-02-02', 271, NULL),
('Hampton Inn', 191, '2019-02-03', 201, NULL),
('Hampton Inn', 191, '2019-02-04', 171, NULL),
('Hampton Inn', 191, '2019-02-05', 356, NULL),
('Hampton Inn', 191, '2019-02-06', 139, NULL),
('Hampton Inn', 191, '2019-02-07', 229, NULL),
('Hampton Inn', 191, '2019-02-08', 299, NULL),
('Hampton Inn', 191, '2019-02-09', 345, NULL),
('Hampton Inn', 191, '2019-02-10', 346, NULL),
('Hampton Inn', 191, '2019-02-11', 238, NULL),
('Hampton Inn', 191, '2019-02-12', 291, NULL),
('Hampton Inn', 191, '2019-02-13', 243, NULL),
('Hampton Inn', 191, '2019-02-14', 254, NULL),
('Hampton Inn', 191, '2019-02-15', 354, NULL),
('Hampton Inn', 191, '2019-02-16', 129, NULL),
('Hampton Inn', 191, '2019-02-17', 197, NULL),
('Hampton Inn', 191, '2019-02-18', 191, NULL),
('Hampton Inn', 191, '2019-02-19', 340, NULL),
('Hampton Inn', 191, '2019-02-20', 166, NULL),
('Hampton Inn', 191, '2019-02-21', 273, NULL),
('Hampton Inn', 191, '2019-02-22', 376, NULL),
('Hampton Inn', 191, '2019-02-23', 369, NULL),
('Hampton Inn', 191, '2019-02-24', 276, NULL),
('Hampton Inn', 191, '2019-02-25', 131, NULL),
('Hampton Inn', 191, '2019-02-26', 281, NULL),
('Hampton Inn', 191, '2019-02-27', 392, NULL),
('Hampton Inn', 191, '2019-02-28', 146, NULL),
('Hampton Inn', 191, '2019-03-01', 108, NULL),
('Hampton Inn', 191, '2019-03-02', 226, NULL),
('Hampton Inn', 191, '2019-03-03', 167, NULL),
('Hampton Inn', 191, '2019-03-04', 339, NULL),
('Hampton Inn', 191, '2019-03-05', 253, NULL),
('Hampton Inn', 191, '2019-03-06', 229, NULL),
('Hampton Inn', 191, '2019-03-07', 184, NULL),
('Hampton Inn', 191, '2019-03-08', 185, NULL),
('Hampton Inn', 191, '2019-03-09', 155, NULL),
('Hampton Inn', 191, '2019-03-10', 150, NULL),
('Hampton Inn', 191, '2019-03-11', 133, NULL),
('Hampton Inn', 191, '2019-03-12', 288, NULL),
('Hampton Inn', 191, '2019-03-13', 141, NULL),
('Hampton Inn', 191, '2019-03-14', 384, NULL),
('Hampton Inn', 191, '2019-03-15', 177, NULL),
('Hampton Inn', 191, '2019-03-16', 144, NULL),
('Hampton Inn', 191, '2019-03-17', 330, NULL),
('Hampton Inn', 191, '2019-03-18', 226, NULL),
('Hampton Inn', 191, '2019-03-19', 262, NULL),
('Hampton Inn', 191, '2019-03-20', 158, NULL),
('Hampton Inn', 191, '2019-03-21', 235, NULL),
('Hampton Inn', 191, '2019-03-22', 277, NULL),
('Hampton Inn', 191, '2019-03-23', 144, NULL),
('Hampton Inn', 191, '2019-03-24', 261, NULL),
('Hampton Inn', 191, '2019-03-25', 253, NULL),
('Hampton Inn', 191, '2019-03-26', 153, NULL),
('Hampton Inn', 191, '2019-03-27', 221, NULL),
('Hampton Inn', 191, '2019-03-28', 150, NULL),
('Hampton Inn', 191, '2019-03-29', 339, NULL),
('Hampton Inn', 191, '2019-03-30', 235, NULL),
('Hampton Inn', 191, '2019-03-31', 127, NULL),
('Hampton Inn', 191, '2019-04-01', 171, NULL),
('Hampton Inn', 191, '2019-04-02', 235, NULL),
('Hampton Inn', 191, '2019-04-03', 366, NULL),
('Hampton Inn', 191, '2019-04-04', 363, NULL),
('Hampton Inn', 191, '2019-04-05', 274, NULL),
('Hampton Inn', 191, '2019-04-06', 272, NULL),
('Hampton Inn', 191, '2019-04-07', 219, NULL),
('Hampton Inn', 191, '2019-04-08', 391, NULL),
('Hampton Inn', 191, '2019-04-09', 390, NULL),
('Hampton Inn', 191, '2019-04-10', 328, NULL),
('Hampton Inn', 191, '2019-04-11', 327, NULL),
('Hampton Inn', 191, '2019-04-12', 365, NULL),
('Hampton Inn', 191, '2019-04-13', 375, NULL),
('Hampton Inn', 191, '2019-04-14', 384, NULL),
('Hampton Inn', 191, '2019-04-15', 131, NULL),
('Hampton Inn', 191, '2019-04-16', 395, NULL),
('Hampton Inn', 191, '2019-04-17', 398, NULL),
('Hampton Inn', 191, '2019-04-18', 365, NULL),
('Hampton Inn', 191, '2019-04-19', 110, NULL),
('Hampton Inn', 191, '2019-04-20', 381, NULL),
('Hampton Inn', 191, '2019-04-21', 285, NULL),
('Hampton Inn', 191, '2019-04-22', 124, NULL),
('Hampton Inn', 191, '2019-04-23', 289, NULL),
('Hampton Inn', 191, '2019-04-24', 213, NULL),
('Hampton Inn', 191, '2019-04-25', 234, NULL),
('Hampton Inn', 191, '2019-04-26', 145, NULL),
('Hampton Inn', 191, '2019-04-27', 206, NULL),
('Hampton Inn', 191, '2019-04-28', 289, NULL),
('Hampton Inn', 191, '2019-04-29', 177, NULL),
('Hampton Inn', 191, '2019-04-30', 381, NULL),
('Hampton Inn', 191, '2019-05-01', 289, NULL),
('Hampton Inn', 191, '2019-05-02', 143, NULL),
('Hampton Inn', 191, '2019-05-03', 360, NULL),
('Hampton Inn', 191, '2019-05-04', 218, NULL),
('Hampton Inn', 191, '2019-05-05', 283, NULL),
('Hampton Inn', 191, '2019-05-06', 160, NULL),
('Hampton Inn', 191, '2019-05-07', 324, NULL),
('Hampton Inn', 191, '2019-05-08', 128, NULL),
('Hampton Inn', 191, '2019-05-09', 281, NULL),
('Hampton Inn', 191, '2019-05-10', 163, NULL),
('Hampton Inn', 191, '2019-05-11', 139, NULL),
('Hampton Inn', 191, '2019-05-12', 371, NULL),
('Hampton Inn', 191, '2019-05-13', 338, NULL),
('Hampton Inn', 191, '2019-05-14', 299, NULL),
('Hampton Inn', 191, '2019-05-15', 104, NULL),
('Hampton Inn', 191, '2019-05-16', 208, NULL),
('Hampton Inn', 191, '2019-05-17', 269, NULL),
('Hampton Inn', 191, '2019-05-18', 311, NULL),
('Hampton Inn', 191, '2019-05-19', 295, NULL),
('Hampton Inn', 191, '2019-05-20', 124, NULL),
('Hampton Inn', 191, '2019-05-21', 146, NULL),
('Hampton Inn', 191, '2019-05-22', 253, NULL),
('Hampton Inn', 191, '2019-05-23', 333, NULL),
('Hampton Inn', 191, '2019-05-24', 337, NULL),
('Hampton Inn', 191, '2019-05-25', 178, NULL),
('Hampton Inn', 191, '2019-05-26', 397, NULL),
('Hampton Inn', 191, '2019-05-27', 385, NULL),
('Hampton Inn', 191, '2019-05-28', 220, NULL),
('Hampton Inn', 191, '2019-05-29', 368, NULL),
('Hampton Inn', 191, '2019-05-30', 338, NULL),
('Hampton Inn', 191, '2019-05-31', 299, NULL),
('Hampton Inn', 191, '2019-06-01', 126, NULL),
('Hampton Inn', 191, '2019-06-02', 259, NULL),
('Hampton Inn', 191, '2019-06-03', 390, NULL),
('Hampton Inn', 191, '2019-06-04', 153, NULL),
('Hampton Inn', 191, '2019-06-05', 362, NULL),
('Hampton Inn', 191, '2019-06-06', 126, NULL),
('Hampton Inn', 191, '2019-06-07', 305, NULL),
('Hampton Inn', 191, '2019-06-08', 377, NULL),
('Hampton Inn', 191, '2019-06-09', 251, NULL),
('Hampton Inn', 191, '2019-06-10', 263, NULL),
('Hampton Inn', 191, '2019-06-11', 277, NULL),
('Hampton Inn', 191, '2019-06-12', 231, NULL),
('Hampton Inn', 191, '2019-06-13', 292, NULL),
('Hampton Inn', 191, '2019-06-14', 266, NULL),
('Hampton Inn', 191, '2019-06-15', 368, NULL),
('Hampton Inn', 191, '2019-06-16', 304, NULL),
('Hampton Inn', 191, '2019-06-17', 320, NULL),
('Hampton Inn', 191, '2019-06-18', 152, NULL),
('Hampton Inn', 191, '2019-06-19', 128, NULL),
('Hampton Inn', 191, '2019-06-20', 272, NULL),
('Hampton Inn', 191, '2019-06-21', 353, NULL),
('Hampton Inn', 191, '2019-06-22', 158, NULL),
('Hampton Inn', 191, '2019-06-23', 393, NULL),
('Hampton Inn', 191, '2019-06-24', 110, NULL),
('Hampton Inn', 191, '2019-06-25', 131, NULL),
('Hampton Inn', 191, '2019-06-26', 312, NULL),
('Hampton Inn', 191, '2019-06-27', 215, NULL),
('Hampton Inn', 191, '2019-06-28', 249, NULL),
('Hampton Inn', 191, '2019-06-29', 222, NULL),
('Hampton Inn', 191, '2019-06-30', 341, NULL),
('Hampton Inn', 191, '2019-07-01', 214, NULL),
('Hampton Inn', 191, '2019-07-02', 256, NULL),
('Hampton Inn', 191, '2019-07-03', 149, NULL),
('Hampton Inn', 191, '2019-07-04', 383, NULL),
('Hampton Inn', 191, '2019-07-05', 396, NULL),
('Hampton Inn', 191, '2019-07-06', 392, NULL),
('Hampton Inn', 191, '2019-07-07', 319, NULL),
('Hampton Inn', 191, '2019-07-08', 230, NULL),
('Hampton Inn', 191, '2019-07-09', 108, NULL),
('Hampton Inn', 191, '2019-07-10', 167, NULL),
('Hampton Inn', 191, '2019-07-11', 393, NULL),
('Hampton Inn', 191, '2019-07-12', 174, NULL),
('Hampton Inn', 191, '2019-07-13', 225, NULL),
('Hampton Inn', 191, '2019-07-14', 164, NULL),
('Hampton Inn', 191, '2019-07-15', 241, NULL),
('Hampton Inn', 191, '2019-07-16', 311, NULL),
('Hampton Inn', 191, '2019-07-17', 203, NULL),
('Hampton Inn', 191, '2019-07-18', 377, NULL),
('Hampton Inn', 191, '2019-07-19', 104, NULL),
('Hampton Inn', 191, '2019-07-20', 312, NULL),
('Hampton Inn', 191, '2019-07-21', 291, NULL),
('Hampton Inn', 191, '2019-07-22', 113, NULL),
('Hampton Inn', 191, '2019-07-23', 386, NULL),
('Hampton Inn', 191, '2019-07-24', 293, NULL),
('Hampton Inn', 191, '2019-07-25', 196, NULL),
('Hampton Inn', 191, '2019-07-26', 133, NULL),
('Hampton Inn', 191, '2019-07-27', 206, NULL),
('Hampton Inn', 191, '2019-07-28', 232, NULL),
('Hampton Inn', 191, '2019-07-29', 250, NULL),
('Hampton Inn', 191, '2019-07-30', 252, NULL),
('Hampton Inn', 191, '2019-07-31', 244, NULL),
('Hampton Inn', 191, '2019-08-01', 209, NULL),
('Hampton Inn', 191, '2019-08-02', 270, NULL),
('Hampton Inn', 191, '2019-08-03', 184, NULL),
('Hampton Inn', 191, '2019-08-04', 156, NULL),
('Hampton Inn', 191, '2019-08-05', 340, NULL),
('Hampton Inn', 191, '2019-08-06', 118, NULL),
('Hampton Inn', 191, '2019-08-07', 171, NULL),
('Hampton Inn', 191, '2019-08-08', 224, NULL),
('Hampton Inn', 191, '2019-08-09', 299, NULL),
('Hampton Inn', 191, '2019-08-10', 352, NULL),
('Hampton Inn', 191, '2019-08-11', 114, NULL),
('Hampton Inn', 191, '2019-08-12', 333, NULL),
('Hampton Inn', 191, '2019-08-13', 118, NULL),
('Hampton Inn', 191, '2019-08-14', 126, NULL),
('Hampton Inn', 191, '2019-08-15', 235, NULL),
('Hampton Inn', 191, '2019-08-16', 341, NULL),
('Hampton Inn', 191, '2019-08-17', 257, NULL),
('Hampton Inn', 191, '2019-08-18', 145, NULL),
('Hampton Inn', 191, '2019-08-19', 281, NULL),
('Hampton Inn', 191, '2019-08-20', 127, NULL),
('Hampton Inn', 191, '2019-08-21', 141, NULL),
('Hampton Inn', 191, '2019-08-22', 315, NULL),
('Hampton Inn', 191, '2019-08-23', 250, NULL),
('Hampton Inn', 191, '2019-08-24', 276, NULL),
('Hampton Inn', 191, '2019-08-25', 391, NULL),
('Hampton Inn', 191, '2019-08-26', 281, NULL),
('Hampton Inn', 191, '2019-08-27', 179, NULL),
('Hampton Inn', 191, '2019-08-28', 335, NULL),
('Hampton Inn', 191, '2019-08-29', 142, NULL),
('Hampton Inn', 191, '2019-08-30', 170, NULL),
('Hampton Inn', 191, '2019-08-31', 355, NULL),
('Hampton Inn', 191, '2019-09-01', 131, NULL),
('Hampton Inn', 191, '2019-09-02', 276, NULL),
('Hampton Inn', 191, '2019-09-03', 123, NULL),
('Hampton Inn', 191, '2019-09-04', 122, NULL),
('Hampton Inn', 191, '2019-09-05', 163, NULL),
('Hampton Inn', 191, '2019-09-06', 271, NULL),
('Hampton Inn', 191, '2019-09-07', 213, NULL),
('Hampton Inn', 191, '2019-09-08', 188, NULL),
('Hampton Inn', 191, '2019-09-09', 166, NULL),
('Hampton Inn', 191, '2019-09-10', 267, NULL),
('Hampton Inn', 191, '2019-09-11', 318, NULL),
('Hampton Inn', 191, '2019-09-12', 318, NULL),
('Hampton Inn', 191, '2019-09-13', 226, NULL),
('Hampton Inn', 191, '2019-09-14', 321, NULL),
('Hampton Inn', 191, '2019-09-15', 226, NULL),
('Hampton Inn', 191, '2019-09-16', 395, NULL),
('Hampton Inn', 191, '2019-09-17', 283, NULL),
('Hampton Inn', 191, '2019-09-18', 132, NULL),
('Hampton Inn', 191, '2019-09-19', 383, NULL),
('Hampton Inn', 191, '2019-09-20', 293, NULL),
('Hampton Inn', 191, '2019-09-21', 116, NULL),
('Hampton Inn', 191, '2019-09-22', 396, NULL),
('Hampton Inn', 191, '2019-09-23', 150, NULL),
('Hampton Inn', 191, '2019-09-24', 312, NULL),
('Hampton Inn', 191, '2019-09-25', 345, NULL),
('Hampton Inn', 191, '2019-09-26', 219, NULL),
('Hampton Inn', 191, '2019-09-27', 380, NULL),
('Hampton Inn', 191, '2019-09-28', 181, NULL),
('Hampton Inn', 191, '2019-09-29', 110, NULL),
('Hampton Inn', 191, '2019-09-30', 105, NULL),
('Hampton Inn', 191, '2019-10-01', 286, NULL),
('Hampton Inn', 191, '2019-10-02', 218, NULL),
('Hampton Inn', 191, '2019-10-03', 312, NULL),
('Hampton Inn', 191, '2019-10-04', 222, NULL),
('Hampton Inn', 191, '2019-10-05', 361, NULL),
('Hampton Inn', 191, '2019-10-06', 204, NULL),
('Hampton Inn', 191, '2019-10-07', 266, NULL),
('Hampton Inn', 191, '2019-10-08', 253, NULL),
('Hampton Inn', 191, '2019-10-09', 135, NULL),
('Hampton Inn', 191, '2019-10-10', 267, NULL),
('Hampton Inn', 191, '2019-10-11', 200, NULL),
('Hampton Inn', 191, '2019-10-12', 159, NULL),
('Hampton Inn', 191, '2019-10-13', 313, NULL),
('Hampton Inn', 191, '2019-10-14', 142, NULL),
('Hampton Inn', 191, '2019-10-15', 215, NULL),
('Hampton Inn', 191, '2019-10-16', 242, NULL),
('Hampton Inn', 191, '2019-10-17', 293, NULL),
('Hampton Inn', 191, '2019-10-18', 241, NULL),
('Hampton Inn', 191, '2019-10-19', 396, NULL),
('Hampton Inn', 191, '2019-10-20', 144, NULL),
('Hampton Inn', 191, '2019-10-21', 250, NULL),
('Hampton Inn', 191, '2019-10-22', 151, NULL),
('Hampton Inn', 191, '2019-10-23', 208, NULL),
('Hampton Inn', 191, '2019-10-24', 270, NULL),
('Hampton Inn', 191, '2019-10-25', 214, NULL),
('Hampton Inn', 191, '2019-10-26', 249, NULL),
('Hampton Inn', 191, '2019-10-27', 186, NULL),
('Hampton Inn', 191, '2019-10-28', 196, NULL),
('Hampton Inn', 191, '2019-10-29', 100, NULL),
('Hampton Inn', 191, '2019-10-30', 256, NULL),
('Hampton Inn', 191, '2019-10-31', 363, NULL),
('Hampton Inn', 191, '2019-11-01', 358, NULL),
('Hampton Inn', 191, '2019-11-02', 386, NULL),
('Hampton Inn', 191, '2019-11-03', 215, NULL),
('Hampton Inn', 191, '2019-11-04', 231, NULL),
('Hampton Inn', 191, '2019-11-05', 250, NULL),
('Hampton Inn', 191, '2019-11-06', 241, NULL),
('Hampton Inn', 191, '2019-11-07', 217, NULL),
('Hampton Inn', 191, '2019-11-08', 167, NULL),
('Hampton Inn', 191, '2019-11-09', 153, NULL),
('Hampton Inn', 191, '2019-11-10', 203, NULL),
('Hampton Inn', 191, '2019-11-11', 300, NULL),
('Hampton Inn', 191, '2019-11-12', 268, NULL),
('Hampton Inn', 191, '2019-11-13', 222, NULL),
('Hampton Inn', 191, '2019-11-14', 229, NULL),
('Hampton Inn', 191, '2019-11-15', 382, NULL),
('Hampton Inn', 191, '2019-11-16', 217, NULL),
('Hampton Inn', 191, '2019-11-17', 355, NULL),
('Hampton Inn', 191, '2019-11-18', 334, NULL),
('Hampton Inn', 191, '2019-11-19', 120, NULL),
('Hampton Inn', 191, '2019-11-20', 245, NULL),
('Hampton Inn', 191, '2019-11-21', 207, NULL),
('Hampton Inn', 191, '2019-11-22', 321, NULL),
('Hampton Inn', 191, '2019-11-23', 301, NULL),
('Hampton Inn', 191, '2019-11-24', 334, NULL),
('Hampton Inn', 191, '2019-11-25', 256, NULL),
('Hampton Inn', 191, '2019-11-26', 364, NULL),
('Hampton Inn', 191, '2019-11-27', 385, NULL),
('Hampton Inn', 191, '2019-11-28', 116, NULL),
('Hampton Inn', 191, '2019-11-29', 386, NULL),
('Hampton Inn', 191, '2019-11-30', 126, NULL),
('Hampton Inn', 191, '2019-12-01', 284, NULL),
('Hampton Inn', 191, '2019-12-02', 212, NULL),
('Hampton Inn', 191, '2019-12-03', 100, NULL),
('Hampton Inn', 191, '2019-12-04', 373, NULL),
('Hampton Inn', 191, '2019-12-05', 242, NULL),
('Hampton Inn', 191, '2019-12-06', 285, NULL),
('Hampton Inn', 191, '2019-12-07', 139, NULL),
('Hampton Inn', 191, '2019-12-08', 120, NULL),
('Hampton Inn', 191, '2019-12-09', 248, NULL),
('Hampton Inn', 191, '2019-12-10', 380, NULL),
('Hampton Inn', 191, '2019-12-11', 210, NULL),
('Hampton Inn', 191, '2019-12-12', 270, NULL),
('Hampton Inn', 191, '2019-12-13', 287, NULL),
('Hampton Inn', 191, '2019-12-14', 176, NULL),
('Hampton Inn', 191, '2019-12-15', 238, NULL),
('Hampton Inn', 191, '2019-12-16', 324, NULL),
('Hampton Inn', 191, '2019-12-17', 277, NULL),
('Hampton Inn', 191, '2019-12-18', 268, NULL),
('Hampton Inn', 191, '2019-12-19', 268, NULL),
('Hampton Inn', 191, '2019-12-20', 207, NULL),
('Hampton Inn', 191, '2019-12-21', 179, NULL),
('Hampton Inn', 191, '2019-12-22', 385, NULL),
('Hampton Inn', 191, '2019-12-23', 397, NULL),
('Hampton Inn', 191, '2019-12-24', 270, NULL),
('Hampton Inn', 191, '2019-12-25', 104, NULL),
('Hampton Inn', 191, '2019-12-26', 297, NULL),
('Hampton Inn', 191, '2019-12-27', 280, NULL),
('Hampton Inn', 191, '2019-12-28', 218, NULL),
('Hampton Inn', 191, '2019-12-29', 378, NULL),
('Hampton Inn', 191, '2019-12-30', 340, NULL),
('Hampton Inn', 191, '2019-12-31', 288, NULL),
('Hampton Inn', 191, '2020-01-01', 302, NULL),
('Hampton Inn', 191, '2020-01-02', 215, NULL),
('Hampton Inn', 191, '2020-01-03', 372, NULL),
('Hampton Inn', 191, '2020-01-04', 363, NULL),
('Hampton Inn', 191, '2020-01-05', 253, NULL),
('Hampton Inn', 191, '2020-01-06', 114, NULL),
('Hampton Inn', 191, '2020-01-07', 387, NULL),
('Hampton Inn', 191, '2020-01-08', 109, NULL),
('Hampton Inn', 191, '2020-01-09', 220, NULL),
('Hampton Inn', 191, '2020-01-10', 371, NULL),
('Hampton Inn', 191, '2020-01-11', 331, NULL),
('Hampton Inn', 191, '2020-01-12', 257, NULL),
('Hampton Inn', 191, '2020-01-13', 156, NULL),
('Hampton Inn', 191, '2020-01-14', 346, NULL),
('Hampton Inn', 191, '2020-01-15', 216, NULL),
('Hampton Inn', 191, '2020-01-16', 337, NULL),
('Hampton Inn', 191, '2020-01-17', 261, NULL),
('Hampton Inn', 191, '2020-01-18', 317, NULL),
('Hampton Inn', 191, '2020-01-19', 106, NULL),
('Hampton Inn', 191, '2020-01-20', 142, NULL),
('Hampton Inn', 191, '2020-01-21', 119, NULL),
('Hampton Inn', 191, '2020-01-22', 258, NULL),
('Hampton Inn', 191, '2020-01-23', 116, NULL),
('Hampton Inn', 191, '2020-01-24', 328, NULL),
('Hampton Inn', 191, '2020-01-25', 331, NULL),
('Hampton Inn', 191, '2020-01-26', 282, NULL),
('Hampton Inn', 191, '2020-01-27', 310, NULL),
('Hampton Inn', 191, '2020-01-28', 208, NULL),
('Hampton Inn', 191, '2020-01-29', 323, NULL),
('Hampton Inn', 191, '2020-01-30', 113, NULL),
('Hampton Inn', 191, '2020-01-31', 263, NULL),
('Hampton Inn', 191, '2020-02-01', 341, NULL),
('Hampton Inn', 191, '2020-02-02', 382, NULL),
('Hampton Inn', 191, '2020-02-03', 321, NULL),
('Hampton Inn', 191, '2020-02-04', 286, NULL),
('Hampton Inn', 192, '2019-01-01', 103, NULL),
('Hampton Inn', 192, '2019-01-02', 274, NULL),
('Hampton Inn', 192, '2019-01-03', 279, NULL),
('Hampton Inn', 192, '2019-01-04', 102, NULL),
('Hampton Inn', 192, '2019-01-05', 287, NULL),
('Hampton Inn', 192, '2019-01-06', 231, NULL),
('Hampton Inn', 192, '2019-01-07', 215, NULL),
('Hampton Inn', 192, '2019-01-08', 397, NULL),
('Hampton Inn', 192, '2019-01-09', 268, NULL),
('Hampton Inn', 192, '2019-01-10', 368, NULL),
('Hampton Inn', 192, '2019-01-11', 129, NULL),
('Hampton Inn', 192, '2019-01-12', 350, NULL),
('Hampton Inn', 192, '2019-01-13', 129, NULL),
('Hampton Inn', 192, '2019-01-14', 306, NULL),
('Hampton Inn', 192, '2019-01-15', 397, NULL),
('Hampton Inn', 192, '2019-01-16', 341, NULL),
('Hampton Inn', 192, '2019-01-17', 295, NULL),
('Hampton Inn', 192, '2019-01-18', 259, NULL),
('Hampton Inn', 192, '2019-01-19', 306, NULL),
('Hampton Inn', 192, '2019-01-20', 261, NULL),
('Hampton Inn', 192, '2019-01-21', 104, NULL),
('Hampton Inn', 192, '2019-01-22', 228, NULL),
('Hampton Inn', 192, '2019-01-23', 333, NULL),
('Hampton Inn', 192, '2019-01-24', 233, NULL),
('Hampton Inn', 192, '2019-01-25', 295, NULL),
('Hampton Inn', 192, '2019-01-26', 358, NULL),
('Hampton Inn', 192, '2019-01-27', 224, NULL),
('Hampton Inn', 192, '2019-01-28', 393, NULL),
('Hampton Inn', 192, '2019-01-29', 318, NULL),
('Hampton Inn', 192, '2019-01-30', 231, NULL),
('Hampton Inn', 192, '2019-01-31', 167, NULL),
('Hampton Inn', 192, '2019-02-01', 309, NULL),
('Hampton Inn', 192, '2019-02-02', 349, NULL),
('Hampton Inn', 192, '2019-02-03', 273, NULL),
('Hampton Inn', 192, '2019-02-04', 208, NULL),
('Hampton Inn', 192, '2019-02-05', 274, NULL),
('Hampton Inn', 192, '2019-02-06', 296, NULL),
('Hampton Inn', 192, '2019-02-07', 234, NULL),
('Hampton Inn', 192, '2019-02-08', 326, NULL),
('Hampton Inn', 192, '2019-02-09', 258, NULL),
('Hampton Inn', 192, '2019-02-10', 296, NULL),
('Hampton Inn', 192, '2019-02-11', 291, NULL),
('Hampton Inn', 192, '2019-02-12', 314, NULL),
('Hampton Inn', 192, '2019-02-13', 392, NULL),
('Hampton Inn', 192, '2019-02-14', 281, NULL),
('Hampton Inn', 192, '2019-02-15', 360, NULL),
('Hampton Inn', 192, '2019-02-16', 159, NULL),
('Hampton Inn', 192, '2019-02-17', 152, NULL),
('Hampton Inn', 192, '2019-02-18', 330, NULL),
('Hampton Inn', 192, '2019-02-19', 154, NULL),
('Hampton Inn', 192, '2019-02-20', 179, NULL),
('Hampton Inn', 192, '2019-02-21', 219, NULL),
('Hampton Inn', 192, '2019-02-22', 295, NULL),
('Hampton Inn', 192, '2019-02-23', 336, NULL),
('Hampton Inn', 192, '2019-02-24', 358, NULL),
('Hampton Inn', 192, '2019-02-25', 230, NULL),
('Hampton Inn', 192, '2019-02-26', 292, NULL),
('Hampton Inn', 192, '2019-02-27', 373, NULL),
('Hampton Inn', 192, '2019-02-28', 280, NULL),
('Hampton Inn', 192, '2019-03-01', 227, NULL),
('Hampton Inn', 192, '2019-03-02', 370, NULL),
('Hampton Inn', 192, '2019-03-03', 248, NULL),
('Hampton Inn', 192, '2019-03-04', 157, NULL),
('Hampton Inn', 192, '2019-03-05', 165, NULL),
('Hampton Inn', 192, '2019-03-06', 319, NULL),
('Hampton Inn', 192, '2019-03-07', 239, NULL),
('Hampton Inn', 192, '2019-03-08', 356, NULL),
('Hampton Inn', 192, '2019-03-09', 210, NULL),
('Hampton Inn', 192, '2019-03-10', 368, NULL),
('Hampton Inn', 192, '2019-03-11', 190, NULL),
('Hampton Inn', 192, '2019-03-12', 329, NULL),
('Hampton Inn', 192, '2019-03-13', 302, NULL),
('Hampton Inn', 192, '2019-03-14', 287, NULL),
('Hampton Inn', 192, '2019-03-15', 319, NULL),
('Hampton Inn', 192, '2019-03-16', 332, NULL),
('Hampton Inn', 192, '2019-03-17', 279, NULL),
('Hampton Inn', 192, '2019-03-18', 253, NULL),
('Hampton Inn', 192, '2019-03-19', 114, NULL),
('Hampton Inn', 192, '2019-03-20', 329, NULL),
('Hampton Inn', 192, '2019-03-21', 156, NULL),
('Hampton Inn', 192, '2019-03-22', 361, NULL),
('Hampton Inn', 192, '2019-03-23', 351, NULL),
('Hampton Inn', 192, '2019-03-24', 283, NULL),
('Hampton Inn', 192, '2019-03-25', 298, NULL),
('Hampton Inn', 192, '2019-03-26', 349, NULL),
('Hampton Inn', 192, '2019-03-27', 276, NULL),
('Hampton Inn', 192, '2019-03-28', 229, NULL),
('Hampton Inn', 192, '2019-03-29', 383, NULL),
('Hampton Inn', 192, '2019-03-30', 204, NULL),
('Hampton Inn', 192, '2019-03-31', 254, NULL),
('Hampton Inn', 192, '2019-04-01', 368, NULL),
('Hampton Inn', 192, '2019-04-02', 246, NULL),
('Hampton Inn', 192, '2019-04-03', 138, NULL),
('Hampton Inn', 192, '2019-04-04', 212, NULL),
('Hampton Inn', 192, '2019-04-05', 130, NULL),
('Hampton Inn', 192, '2019-04-06', 178, NULL),
('Hampton Inn', 192, '2019-04-07', 316, NULL),
('Hampton Inn', 192, '2019-04-08', 235, NULL),
('Hampton Inn', 192, '2019-04-09', 309, NULL),
('Hampton Inn', 192, '2019-04-10', 179, NULL),
('Hampton Inn', 192, '2019-04-11', 157, NULL),
('Hampton Inn', 192, '2019-04-12', 159, NULL),
('Hampton Inn', 192, '2019-04-13', 145, NULL),
('Hampton Inn', 192, '2019-04-14', 279, NULL),
('Hampton Inn', 192, '2019-04-15', 377, NULL),
('Hampton Inn', 192, '2019-04-16', 118, NULL),
('Hampton Inn', 192, '2019-04-17', 277, NULL),
('Hampton Inn', 192, '2019-04-18', 347, NULL),
('Hampton Inn', 192, '2019-04-19', 242, NULL),
('Hampton Inn', 192, '2019-04-20', 310, NULL),
('Hampton Inn', 192, '2019-04-21', 187, NULL),
('Hampton Inn', 192, '2019-04-22', 105, NULL),
('Hampton Inn', 192, '2019-04-23', 373, NULL),
('Hampton Inn', 192, '2019-04-24', 335, NULL),
('Hampton Inn', 192, '2019-04-25', 351, NULL),
('Hampton Inn', 192, '2019-04-26', 129, NULL),
('Hampton Inn', 192, '2019-04-27', 126, NULL),
('Hampton Inn', 192, '2019-04-28', 206, NULL),
('Hampton Inn', 192, '2019-04-29', 387, NULL),
('Hampton Inn', 192, '2019-04-30', 375, NULL),
('Hampton Inn', 192, '2019-05-01', 137, NULL),
('Hampton Inn', 192, '2019-05-02', 343, NULL),
('Hampton Inn', 192, '2019-05-03', 188, NULL),
('Hampton Inn', 192, '2019-05-04', 112, NULL),
('Hampton Inn', 192, '2019-05-05', 382, NULL),
('Hampton Inn', 192, '2019-05-06', 222, NULL),
('Hampton Inn', 192, '2019-05-07', 247, NULL),
('Hampton Inn', 192, '2019-05-08', 187, NULL),
('Hampton Inn', 192, '2019-05-09', 168, NULL),
('Hampton Inn', 192, '2019-05-10', 249, NULL),
('Hampton Inn', 192, '2019-05-11', 307, NULL),
('Hampton Inn', 192, '2019-05-12', 291, NULL),
('Hampton Inn', 192, '2019-05-13', 144, NULL),
('Hampton Inn', 192, '2019-05-14', 362, NULL),
('Hampton Inn', 192, '2019-05-15', 373, NULL),
('Hampton Inn', 192, '2019-05-16', 146, NULL),
('Hampton Inn', 192, '2019-05-17', 101, NULL),
('Hampton Inn', 192, '2019-05-18', 396, NULL),
('Hampton Inn', 192, '2019-05-19', 299, NULL),
('Hampton Inn', 192, '2019-05-20', 285, NULL),
('Hampton Inn', 192, '2019-05-21', 258, NULL),
('Hampton Inn', 192, '2019-05-22', 389, NULL),
('Hampton Inn', 192, '2019-05-23', 183, NULL),
('Hampton Inn', 192, '2019-05-24', 331, NULL),
('Hampton Inn', 192, '2019-05-25', 249, NULL),
('Hampton Inn', 192, '2019-05-26', 137, NULL),
('Hampton Inn', 192, '2019-05-27', 369, NULL),
('Hampton Inn', 192, '2019-05-28', 323, NULL),
('Hampton Inn', 192, '2019-05-29', 164, NULL),
('Hampton Inn', 192, '2019-05-30', 107, NULL),
('Hampton Inn', 192, '2019-05-31', 253, NULL),
('Hampton Inn', 192, '2019-06-01', 249, NULL),
('Hampton Inn', 192, '2019-06-02', 372, NULL),
('Hampton Inn', 192, '2019-06-03', 135, NULL),
('Hampton Inn', 192, '2019-06-04', 191, NULL),
('Hampton Inn', 192, '2019-06-05', 384, NULL),
('Hampton Inn', 192, '2019-06-06', 101, NULL),
('Hampton Inn', 192, '2019-06-07', 251, NULL),
('Hampton Inn', 192, '2019-06-08', 330, NULL),
('Hampton Inn', 192, '2019-06-09', 295, NULL),
('Hampton Inn', 192, '2019-06-10', 286, NULL),
('Hampton Inn', 192, '2019-06-11', 162, NULL),
('Hampton Inn', 192, '2019-06-12', 163, NULL),
('Hampton Inn', 192, '2019-06-13', 218, NULL),
('Hampton Inn', 192, '2019-06-14', 321, NULL),
('Hampton Inn', 192, '2019-06-15', 340, NULL),
('Hampton Inn', 192, '2019-06-16', 328, NULL),
('Hampton Inn', 192, '2019-06-17', 247, NULL),
('Hampton Inn', 192, '2019-06-18', 247, NULL),
('Hampton Inn', 192, '2019-06-19', 359, NULL),
('Hampton Inn', 192, '2019-06-20', 358, NULL),
('Hampton Inn', 192, '2019-06-21', 377, NULL),
('Hampton Inn', 192, '2019-06-22', 269, NULL),
('Hampton Inn', 192, '2019-06-23', 332, NULL),
('Hampton Inn', 192, '2019-06-24', 302, NULL),
('Hampton Inn', 192, '2019-06-25', 345, NULL),
('Hampton Inn', 192, '2019-06-26', 177, NULL),
('Hampton Inn', 192, '2019-06-27', 246, NULL),
('Hampton Inn', 192, '2019-06-28', 307, NULL),
('Hampton Inn', 192, '2019-06-29', 187, NULL),
('Hampton Inn', 192, '2019-06-30', 177, NULL),
('Hampton Inn', 192, '2019-07-01', 378, NULL),
('Hampton Inn', 192, '2019-07-02', 250, NULL),
('Hampton Inn', 192, '2019-07-03', 311, NULL),
('Hampton Inn', 192, '2019-07-04', 398, NULL),
('Hampton Inn', 192, '2019-07-05', 169, NULL),
('Hampton Inn', 192, '2019-07-06', 179, NULL),
('Hampton Inn', 192, '2019-07-07', 311, NULL),
('Hampton Inn', 192, '2019-07-08', 320, NULL),
('Hampton Inn', 192, '2019-07-09', 371, NULL),
('Hampton Inn', 192, '2019-07-10', 385, NULL),
('Hampton Inn', 192, '2019-07-11', 207, NULL),
('Hampton Inn', 192, '2019-07-12', 276, NULL),
('Hampton Inn', 192, '2019-07-13', 291, NULL),
('Hampton Inn', 192, '2019-07-14', 320, NULL),
('Hampton Inn', 192, '2019-07-15', 376, NULL),
('Hampton Inn', 192, '2019-07-16', 162, NULL),
('Hampton Inn', 192, '2019-07-17', 281, NULL),
('Hampton Inn', 192, '2019-07-18', 261, NULL),
('Hampton Inn', 192, '2019-07-19', 391, NULL),
('Hampton Inn', 192, '2019-07-20', 254, NULL),
('Hampton Inn', 192, '2019-07-21', 215, NULL),
('Hampton Inn', 192, '2019-07-22', 263, NULL),
('Hampton Inn', 192, '2019-07-23', 117, NULL),
('Hampton Inn', 192, '2019-07-24', 206, NULL),
('Hampton Inn', 192, '2019-07-25', 254, NULL),
('Hampton Inn', 192, '2019-07-26', 175, NULL),
('Hampton Inn', 192, '2019-07-27', 331, NULL),
('Hampton Inn', 192, '2019-07-28', 279, NULL),
('Hampton Inn', 192, '2019-07-29', 108, NULL),
('Hampton Inn', 192, '2019-07-30', 379, NULL),
('Hampton Inn', 192, '2019-07-31', 170, NULL),
('Hampton Inn', 192, '2019-08-01', 276, NULL),
('Hampton Inn', 192, '2019-08-02', 268, NULL),
('Hampton Inn', 192, '2019-08-03', 388, NULL),
('Hampton Inn', 192, '2019-08-04', 154, NULL),
('Hampton Inn', 192, '2019-08-05', 331, NULL),
('Hampton Inn', 192, '2019-08-06', 172, NULL),
('Hampton Inn', 192, '2019-08-07', 161, NULL),
('Hampton Inn', 192, '2019-08-08', 216, NULL),
('Hampton Inn', 192, '2019-08-09', 380, NULL),
('Hampton Inn', 192, '2019-08-10', 158, NULL),
('Hampton Inn', 192, '2019-08-11', 366, NULL),
('Hampton Inn', 192, '2019-08-12', 280, NULL),
('Hampton Inn', 192, '2019-08-13', 330, NULL),
('Hampton Inn', 192, '2019-08-14', 293, NULL),
('Hampton Inn', 192, '2019-08-15', 324, NULL),
('Hampton Inn', 192, '2019-08-16', 336, NULL),
('Hampton Inn', 192, '2019-08-17', 398, NULL),
('Hampton Inn', 192, '2019-08-18', 133, NULL),
('Hampton Inn', 192, '2019-08-19', 298, NULL),
('Hampton Inn', 192, '2019-08-20', 176, NULL),
('Hampton Inn', 192, '2019-08-21', 363, NULL),
('Hampton Inn', 192, '2019-08-22', 111, NULL),
('Hampton Inn', 192, '2019-08-23', 152, NULL),
('Hampton Inn', 192, '2019-08-24', 274, NULL),
('Hampton Inn', 192, '2019-08-25', 273, NULL),
('Hampton Inn', 192, '2019-08-26', 141, NULL),
('Hampton Inn', 192, '2019-08-27', 212, NULL),
('Hampton Inn', 192, '2019-08-28', 230, NULL),
('Hampton Inn', 192, '2019-08-29', 331, NULL),
('Hampton Inn', 192, '2019-08-30', 128, NULL),
('Hampton Inn', 192, '2019-08-31', 288, NULL),
('Hampton Inn', 192, '2019-09-01', 376, NULL),
('Hampton Inn', 192, '2019-09-02', 268, NULL),
('Hampton Inn', 192, '2019-09-03', 104, NULL),
('Hampton Inn', 192, '2019-09-04', 114, NULL),
('Hampton Inn', 192, '2019-09-05', 162, NULL),
('Hampton Inn', 192, '2019-09-06', 365, NULL),
('Hampton Inn', 192, '2019-09-07', 308, NULL),
('Hampton Inn', 192, '2019-09-08', 244, NULL),
('Hampton Inn', 192, '2019-09-09', 162, NULL),
('Hampton Inn', 192, '2019-09-10', 375, NULL),
('Hampton Inn', 192, '2019-09-11', 262, NULL),
('Hampton Inn', 192, '2019-09-12', 169, NULL),
('Hampton Inn', 192, '2019-09-13', 338, NULL),
('Hampton Inn', 192, '2019-09-14', 333, NULL),
('Hampton Inn', 192, '2019-09-15', 290, NULL),
('Hampton Inn', 192, '2019-09-16', 268, NULL),
('Hampton Inn', 192, '2019-09-17', 270, NULL),
('Hampton Inn', 192, '2019-09-18', 296, NULL),
('Hampton Inn', 192, '2019-09-19', 180, NULL),
('Hampton Inn', 192, '2019-09-20', 270, NULL),
('Hampton Inn', 192, '2019-09-21', 103, NULL),
('Hampton Inn', 192, '2019-09-22', 138, NULL),
('Hampton Inn', 192, '2019-09-23', 240, NULL),
('Hampton Inn', 192, '2019-09-24', 309, NULL),
('Hampton Inn', 192, '2019-09-25', 136, NULL),
('Hampton Inn', 192, '2019-09-26', 135, NULL),
('Hampton Inn', 192, '2019-09-27', 278, NULL),
('Hampton Inn', 192, '2019-09-28', 246, NULL),
('Hampton Inn', 192, '2019-09-29', 396, NULL),
('Hampton Inn', 192, '2019-09-30', 379, NULL),
('Hampton Inn', 192, '2019-10-01', 175, NULL),
('Hampton Inn', 192, '2019-10-02', 252, NULL),
('Hampton Inn', 192, '2019-10-03', 359, NULL),
('Hampton Inn', 192, '2019-10-04', 286, NULL),
('Hampton Inn', 192, '2019-10-05', 327, NULL),
('Hampton Inn', 192, '2019-10-06', 346, NULL),
('Hampton Inn', 192, '2019-10-07', 376, NULL),
('Hampton Inn', 192, '2019-10-08', 134, NULL),
('Hampton Inn', 192, '2019-10-09', 246, NULL),
('Hampton Inn', 192, '2019-10-10', 227, NULL),
('Hampton Inn', 192, '2019-10-11', 254, NULL),
('Hampton Inn', 192, '2019-10-12', 246, NULL),
('Hampton Inn', 192, '2019-10-13', 151, NULL),
('Hampton Inn', 192, '2019-10-14', 360, NULL),
('Hampton Inn', 192, '2019-10-15', 383, NULL),
('Hampton Inn', 192, '2019-10-16', 373, NULL),
('Hampton Inn', 192, '2019-10-17', 369, NULL),
('Hampton Inn', 192, '2019-10-18', 128, NULL),
('Hampton Inn', 192, '2019-10-19', 295, NULL),
('Hampton Inn', 192, '2019-10-20', 314, NULL),
('Hampton Inn', 192, '2019-10-21', 319, NULL),
('Hampton Inn', 192, '2019-10-22', 299, NULL),
('Hampton Inn', 192, '2019-10-23', 141, NULL),
('Hampton Inn', 192, '2019-10-24', 104, NULL),
('Hampton Inn', 192, '2019-10-25', 210, NULL),
('Hampton Inn', 192, '2019-10-26', 133, NULL),
('Hampton Inn', 192, '2019-10-27', 380, NULL),
('Hampton Inn', 192, '2019-10-28', 123, NULL),
('Hampton Inn', 192, '2019-10-29', 153, NULL),
('Hampton Inn', 192, '2019-10-30', 292, NULL),
('Hampton Inn', 192, '2019-10-31', 241, NULL),
('Hampton Inn', 192, '2019-11-01', 188, NULL),
('Hampton Inn', 192, '2019-11-02', 309, NULL),
('Hampton Inn', 192, '2019-11-03', 209, NULL),
('Hampton Inn', 192, '2019-11-04', 136, NULL),
('Hampton Inn', 192, '2019-11-05', 151, NULL),
('Hampton Inn', 192, '2019-11-06', 229, NULL),
('Hampton Inn', 192, '2019-11-07', 396, NULL),
('Hampton Inn', 192, '2019-11-08', 399, NULL),
('Hampton Inn', 192, '2019-11-09', 275, NULL),
('Hampton Inn', 192, '2019-11-10', 351, NULL),
('Hampton Inn', 192, '2019-11-11', 347, NULL),
('Hampton Inn', 192, '2019-11-12', 113, NULL),
('Hampton Inn', 192, '2019-11-13', 190, NULL),
('Hampton Inn', 192, '2019-11-14', 124, NULL),
('Hampton Inn', 192, '2019-11-15', 181, NULL),
('Hampton Inn', 192, '2019-11-16', 378, NULL),
('Hampton Inn', 192, '2019-11-17', 210, NULL),
('Hampton Inn', 192, '2019-11-18', 358, NULL),
('Hampton Inn', 192, '2019-11-19', 133, NULL),
('Hampton Inn', 192, '2019-11-20', 259, NULL),
('Hampton Inn', 192, '2019-11-21', 196, NULL),
('Hampton Inn', 192, '2019-11-22', 275, NULL),
('Hampton Inn', 192, '2019-11-23', 102, NULL),
('Hampton Inn', 192, '2019-11-24', 156, NULL),
('Hampton Inn', 192, '2019-11-25', 189, NULL),
('Hampton Inn', 192, '2019-11-26', 329, NULL),
('Hampton Inn', 192, '2019-11-27', 173, NULL),
('Hampton Inn', 192, '2019-11-28', 194, NULL),
('Hampton Inn', 192, '2019-11-29', 307, NULL),
('Hampton Inn', 192, '2019-11-30', 133, NULL),
('Hampton Inn', 192, '2019-12-01', 166, NULL),
('Hampton Inn', 192, '2019-12-02', 312, NULL),
('Hampton Inn', 192, '2019-12-03', 121, NULL),
('Hampton Inn', 192, '2019-12-04', 150, NULL),
('Hampton Inn', 192, '2019-12-05', 227, NULL),
('Hampton Inn', 192, '2019-12-06', 201, NULL),
('Hampton Inn', 192, '2019-12-07', 381, NULL),
('Hampton Inn', 192, '2019-12-08', 115, NULL),
('Hampton Inn', 192, '2019-12-09', 177, NULL),
('Hampton Inn', 192, '2019-12-10', 185, NULL),
('Hampton Inn', 192, '2019-12-11', 398, NULL),
('Hampton Inn', 192, '2019-12-12', 196, NULL),
('Hampton Inn', 192, '2019-12-13', 314, NULL),
('Hampton Inn', 192, '2019-12-14', 376, NULL),
('Hampton Inn', 192, '2019-12-15', 100, NULL),
('Hampton Inn', 192, '2019-12-16', 392, NULL),
('Hampton Inn', 192, '2019-12-17', 233, NULL),
('Hampton Inn', 192, '2019-12-18', 285, NULL),
('Hampton Inn', 192, '2019-12-19', 158, NULL),
('Hampton Inn', 192, '2019-12-20', 102, NULL),
('Hampton Inn', 192, '2019-12-21', 362, NULL),
('Hampton Inn', 192, '2019-12-22', 181, NULL),
('Hampton Inn', 192, '2019-12-23', 218, NULL),
('Hampton Inn', 192, '2019-12-24', 333, NULL),
('Hampton Inn', 192, '2019-12-25', 324, NULL),
('Hampton Inn', 192, '2019-12-26', 276, NULL),
('Hampton Inn', 192, '2019-12-27', 197, NULL),
('Hampton Inn', 192, '2019-12-28', 372, NULL),
('Hampton Inn', 192, '2019-12-29', 387, NULL),
('Hampton Inn', 192, '2019-12-30', 348, NULL),
('Hampton Inn', 192, '2019-12-31', 340, NULL),
('Hampton Inn', 192, '2020-01-01', 196, NULL),
('Hampton Inn', 192, '2020-01-02', 347, NULL),
('Hampton Inn', 192, '2020-01-03', 340, NULL),
('Hampton Inn', 192, '2020-01-04', 227, NULL),
('Hampton Inn', 192, '2020-01-05', 136, NULL),
('Hampton Inn', 192, '2020-01-06', 129, NULL),
('Hampton Inn', 192, '2020-01-07', 399, NULL),
('Hampton Inn', 192, '2020-01-08', 196, NULL),
('Hampton Inn', 192, '2020-01-09', 208, NULL),
('Hampton Inn', 192, '2020-01-10', 319, NULL),
('Hampton Inn', 192, '2020-01-11', 124, NULL),
('Hampton Inn', 192, '2020-01-12', 225, NULL),
('Hampton Inn', 192, '2020-01-13', 116, NULL),
('Hampton Inn', 192, '2020-01-14', 101, NULL),
('Hampton Inn', 192, '2020-01-15', 296, NULL),
('Hampton Inn', 192, '2020-01-16', 228, NULL),
('Hampton Inn', 192, '2020-01-17', 197, NULL),
('Hampton Inn', 192, '2020-01-18', 182, NULL),
('Hampton Inn', 192, '2020-01-19', 158, NULL),
('Hampton Inn', 192, '2020-01-20', 112, NULL),
('Hampton Inn', 192, '2020-01-21', 152, NULL),
('Hampton Inn', 192, '2020-01-22', 229, NULL),
('Hampton Inn', 192, '2020-01-23', 294, NULL),
('Hampton Inn', 192, '2020-01-24', 133, NULL),
('Hampton Inn', 192, '2020-01-25', 340, NULL),
('Hampton Inn', 192, '2020-01-26', 380, NULL),
('Hampton Inn', 192, '2020-01-27', 244, NULL),
('Hampton Inn', 192, '2020-01-28', 338, NULL),
('Hampton Inn', 192, '2020-01-29', 107, NULL),
('Hampton Inn', 192, '2020-01-30', 234, NULL),
('Hampton Inn', 192, '2020-01-31', 310, NULL),
('Hampton Inn', 192, '2020-02-01', 213, NULL),
('Hampton Inn', 192, '2020-02-02', 315, NULL),
('Hampton Inn', 192, '2020-02-03', 303, NULL),
('Hampton Inn', 192, '2020-02-04', 185, NULL),
('Hampton Inn', 195, '2019-01-01', 341, NULL),
('Hampton Inn', 195, '2019-01-02', 207, NULL),
('Hampton Inn', 195, '2019-01-03', 285, NULL),
('Hampton Inn', 195, '2019-01-04', 172, NULL),
('Hampton Inn', 195, '2019-01-05', 180, NULL),
('Hampton Inn', 195, '2019-01-06', 363, NULL),
('Hampton Inn', 195, '2019-01-07', 205, NULL),
('Hampton Inn', 195, '2019-01-08', 277, NULL),
('Hampton Inn', 195, '2019-01-09', 217, NULL),
('Hampton Inn', 195, '2019-01-10', 103, NULL),
('Hampton Inn', 195, '2019-01-11', 193, NULL),
('Hampton Inn', 195, '2019-01-12', 227, NULL),
('Hampton Inn', 195, '2019-01-13', 312, NULL),
('Hampton Inn', 195, '2019-01-14', 237, NULL),
('Hampton Inn', 195, '2019-01-15', 254, NULL),
('Hampton Inn', 195, '2019-01-16', 125, NULL),
('Hampton Inn', 195, '2019-01-17', 101, NULL),
('Hampton Inn', 195, '2019-01-18', 154, NULL),
('Hampton Inn', 195, '2019-01-19', 339, NULL),
('Hampton Inn', 195, '2019-01-20', 152, NULL),
('Hampton Inn', 195, '2019-01-21', 362, NULL),
('Hampton Inn', 195, '2019-01-22', 276, NULL),
('Hampton Inn', 195, '2019-01-23', 109, NULL),
('Hampton Inn', 195, '2019-01-24', 260, NULL),
('Hampton Inn', 195, '2019-01-25', 358, NULL),
('Hampton Inn', 195, '2019-01-26', 377, NULL),
('Hampton Inn', 195, '2019-01-27', 104, NULL),
('Hampton Inn', 195, '2019-01-28', 174, NULL),
('Hampton Inn', 195, '2019-01-29', 347, NULL),
('Hampton Inn', 195, '2019-01-30', 396, NULL),
('Hampton Inn', 195, '2019-01-31', 194, NULL),
('Hampton Inn', 195, '2019-02-01', 230, NULL),
('Hampton Inn', 195, '2019-02-02', 231, NULL),
('Hampton Inn', 195, '2019-02-03', 365, NULL),
('Hampton Inn', 195, '2019-02-04', 130, NULL),
('Hampton Inn', 195, '2019-02-05', 202, NULL),
('Hampton Inn', 195, '2019-02-06', 367, NULL),
('Hampton Inn', 195, '2019-02-07', 383, NULL),
('Hampton Inn', 195, '2019-02-08', 334, NULL),
('Hampton Inn', 195, '2019-02-09', 157, NULL),
('Hampton Inn', 195, '2019-02-10', 342, NULL),
('Hampton Inn', 195, '2019-02-11', 342, NULL),
('Hampton Inn', 195, '2019-02-12', 295, NULL),
('Hampton Inn', 195, '2019-02-13', 232, NULL),
('Hampton Inn', 195, '2019-02-14', 244, NULL),
('Hampton Inn', 195, '2019-02-15', 337, NULL),
('Hampton Inn', 195, '2019-02-16', 309, NULL),
('Hampton Inn', 195, '2019-02-17', 373, NULL),
('Hampton Inn', 195, '2019-02-18', 375, NULL),
('Hampton Inn', 195, '2019-02-19', 248, NULL),
('Hampton Inn', 195, '2019-02-20', 299, NULL),
('Hampton Inn', 195, '2019-02-21', 178, NULL),
('Hampton Inn', 195, '2019-02-22', 246, NULL),
('Hampton Inn', 195, '2019-02-23', 175, NULL),
('Hampton Inn', 195, '2019-02-24', 264, NULL),
('Hampton Inn', 195, '2019-02-25', 357, NULL),
('Hampton Inn', 195, '2019-02-26', 218, NULL),
('Hampton Inn', 195, '2019-02-27', 290, NULL),
('Hampton Inn', 195, '2019-02-28', 264, NULL),
('Hampton Inn', 195, '2019-03-01', 113, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 195, '2019-03-02', 172, NULL),
('Hampton Inn', 195, '2019-03-03', 340, NULL),
('Hampton Inn', 195, '2019-03-04', 269, NULL),
('Hampton Inn', 195, '2019-03-05', 265, NULL),
('Hampton Inn', 195, '2019-03-06', 207, NULL),
('Hampton Inn', 195, '2019-03-07', 245, NULL),
('Hampton Inn', 195, '2019-03-08', 225, NULL),
('Hampton Inn', 195, '2019-03-09', 184, NULL),
('Hampton Inn', 195, '2019-03-10', 391, NULL),
('Hampton Inn', 195, '2019-03-11', 152, NULL),
('Hampton Inn', 195, '2019-03-12', 378, NULL),
('Hampton Inn', 195, '2019-03-13', 389, NULL),
('Hampton Inn', 195, '2019-03-14', 181, NULL),
('Hampton Inn', 195, '2019-03-15', 363, NULL),
('Hampton Inn', 195, '2019-03-16', 228, NULL),
('Hampton Inn', 195, '2019-03-17', 304, NULL),
('Hampton Inn', 195, '2019-03-18', 188, NULL),
('Hampton Inn', 195, '2019-03-19', 286, NULL),
('Hampton Inn', 195, '2019-03-20', 170, NULL),
('Hampton Inn', 195, '2019-03-21', 274, NULL),
('Hampton Inn', 195, '2019-03-22', 274, NULL),
('Hampton Inn', 195, '2019-03-23', 324, NULL),
('Hampton Inn', 195, '2019-03-24', 231, NULL),
('Hampton Inn', 195, '2019-03-25', 333, NULL),
('Hampton Inn', 195, '2019-03-26', 288, NULL),
('Hampton Inn', 195, '2019-03-27', 317, NULL),
('Hampton Inn', 195, '2019-03-28', 295, NULL),
('Hampton Inn', 195, '2019-03-29', 199, NULL),
('Hampton Inn', 195, '2019-03-30', 217, NULL),
('Hampton Inn', 195, '2019-03-31', 188, NULL),
('Hampton Inn', 195, '2019-04-01', 327, NULL),
('Hampton Inn', 195, '2019-04-02', 127, NULL),
('Hampton Inn', 195, '2019-04-03', 395, NULL),
('Hampton Inn', 195, '2019-04-04', 170, NULL),
('Hampton Inn', 195, '2019-04-05', 331, NULL),
('Hampton Inn', 195, '2019-04-06', 275, NULL),
('Hampton Inn', 195, '2019-04-07', 220, NULL),
('Hampton Inn', 195, '2019-04-08', 202, NULL),
('Hampton Inn', 195, '2019-04-09', 276, NULL),
('Hampton Inn', 195, '2019-04-10', 109, NULL),
('Hampton Inn', 195, '2019-04-11', 306, NULL),
('Hampton Inn', 195, '2019-04-12', 202, NULL),
('Hampton Inn', 195, '2019-04-13', 101, NULL),
('Hampton Inn', 195, '2019-04-14', 145, NULL),
('Hampton Inn', 195, '2019-04-15', 191, NULL),
('Hampton Inn', 195, '2019-04-16', 206, NULL),
('Hampton Inn', 195, '2019-04-17', 389, NULL),
('Hampton Inn', 195, '2019-04-18', 242, NULL),
('Hampton Inn', 195, '2019-04-19', 184, NULL),
('Hampton Inn', 195, '2019-04-20', 306, NULL),
('Hampton Inn', 195, '2019-04-21', 280, NULL),
('Hampton Inn', 195, '2019-04-22', 352, NULL),
('Hampton Inn', 195, '2019-04-23', 296, NULL),
('Hampton Inn', 195, '2019-04-24', 338, NULL),
('Hampton Inn', 195, '2019-04-25', 355, NULL),
('Hampton Inn', 195, '2019-04-26', 111, NULL),
('Hampton Inn', 195, '2019-04-27', 212, NULL),
('Hampton Inn', 195, '2019-04-28', 362, NULL),
('Hampton Inn', 195, '2019-04-29', 106, NULL),
('Hampton Inn', 195, '2019-04-30', 335, NULL),
('Hampton Inn', 195, '2019-05-01', 320, NULL),
('Hampton Inn', 195, '2019-05-02', 286, NULL),
('Hampton Inn', 195, '2019-05-03', 361, NULL),
('Hampton Inn', 195, '2019-05-04', 107, NULL),
('Hampton Inn', 195, '2019-05-05', 363, NULL),
('Hampton Inn', 195, '2019-05-06', 232, NULL),
('Hampton Inn', 195, '2019-05-07', 164, NULL),
('Hampton Inn', 195, '2019-05-08', 152, NULL),
('Hampton Inn', 195, '2019-05-09', 197, NULL),
('Hampton Inn', 195, '2019-05-10', 356, NULL),
('Hampton Inn', 195, '2019-05-11', 119, NULL),
('Hampton Inn', 195, '2019-05-12', 245, NULL),
('Hampton Inn', 195, '2019-05-13', 207, NULL),
('Hampton Inn', 195, '2019-05-14', 214, NULL),
('Hampton Inn', 195, '2019-05-15', 253, NULL),
('Hampton Inn', 195, '2019-05-16', 305, NULL),
('Hampton Inn', 195, '2019-05-17', 196, NULL),
('Hampton Inn', 195, '2019-05-18', 347, NULL),
('Hampton Inn', 195, '2019-05-19', 211, NULL),
('Hampton Inn', 195, '2019-05-20', 352, NULL),
('Hampton Inn', 195, '2019-05-21', 155, NULL),
('Hampton Inn', 195, '2019-05-22', 185, NULL),
('Hampton Inn', 195, '2019-05-23', 115, NULL),
('Hampton Inn', 195, '2019-05-24', 243, NULL),
('Hampton Inn', 195, '2019-05-25', 308, NULL),
('Hampton Inn', 195, '2019-05-26', 297, NULL),
('Hampton Inn', 195, '2019-05-27', 289, NULL),
('Hampton Inn', 195, '2019-05-28', 256, NULL),
('Hampton Inn', 195, '2019-05-29', 217, NULL),
('Hampton Inn', 195, '2019-05-30', 321, NULL),
('Hampton Inn', 195, '2019-05-31', 270, NULL),
('Hampton Inn', 195, '2019-06-01', 164, NULL),
('Hampton Inn', 195, '2019-06-02', 381, NULL),
('Hampton Inn', 195, '2019-06-03', 303, NULL),
('Hampton Inn', 195, '2019-06-04', 397, NULL),
('Hampton Inn', 195, '2019-06-05', 135, NULL),
('Hampton Inn', 195, '2019-06-06', 329, NULL),
('Hampton Inn', 195, '2019-06-07', 243, NULL),
('Hampton Inn', 195, '2019-06-08', 120, NULL),
('Hampton Inn', 195, '2019-06-09', 322, NULL),
('Hampton Inn', 195, '2019-06-10', 239, NULL),
('Hampton Inn', 195, '2019-06-11', 183, NULL),
('Hampton Inn', 195, '2019-06-12', 322, NULL),
('Hampton Inn', 195, '2019-06-13', 115, NULL),
('Hampton Inn', 195, '2019-06-14', 105, NULL),
('Hampton Inn', 195, '2019-06-15', 197, NULL),
('Hampton Inn', 195, '2019-06-16', 329, NULL),
('Hampton Inn', 195, '2019-06-17', 174, NULL),
('Hampton Inn', 195, '2019-06-18', 380, NULL),
('Hampton Inn', 195, '2019-06-19', 109, NULL),
('Hampton Inn', 195, '2019-06-20', 272, NULL),
('Hampton Inn', 195, '2019-06-21', 126, NULL),
('Hampton Inn', 195, '2019-06-22', 171, NULL),
('Hampton Inn', 195, '2019-06-23', 382, NULL),
('Hampton Inn', 195, '2019-06-24', 182, NULL),
('Hampton Inn', 195, '2019-06-25', 333, NULL),
('Hampton Inn', 195, '2019-06-26', 151, NULL),
('Hampton Inn', 195, '2019-06-27', 187, NULL),
('Hampton Inn', 195, '2019-06-28', 386, NULL),
('Hampton Inn', 195, '2019-06-29', 167, NULL),
('Hampton Inn', 195, '2019-06-30', 362, NULL),
('Hampton Inn', 195, '2019-07-01', 252, NULL),
('Hampton Inn', 195, '2019-07-02', 383, NULL),
('Hampton Inn', 195, '2019-07-03', 110, NULL),
('Hampton Inn', 195, '2019-07-04', 142, NULL),
('Hampton Inn', 195, '2019-07-05', 159, NULL),
('Hampton Inn', 195, '2019-07-06', 220, NULL),
('Hampton Inn', 195, '2019-07-07', 197, NULL),
('Hampton Inn', 195, '2019-07-08', 210, NULL),
('Hampton Inn', 195, '2019-07-09', 231, NULL),
('Hampton Inn', 195, '2019-07-10', 122, NULL),
('Hampton Inn', 195, '2019-07-11', 353, NULL),
('Hampton Inn', 195, '2019-07-12', 158, NULL),
('Hampton Inn', 195, '2019-07-13', 377, NULL),
('Hampton Inn', 195, '2019-07-14', 111, NULL),
('Hampton Inn', 195, '2019-07-15', 158, NULL),
('Hampton Inn', 195, '2019-07-16', 378, NULL),
('Hampton Inn', 195, '2019-07-17', 397, NULL),
('Hampton Inn', 195, '2019-07-18', 375, NULL),
('Hampton Inn', 195, '2019-07-19', 343, NULL),
('Hampton Inn', 195, '2019-07-20', 234, NULL),
('Hampton Inn', 195, '2019-07-21', 101, NULL),
('Hampton Inn', 195, '2019-07-22', 280, NULL),
('Hampton Inn', 195, '2019-07-23', 227, NULL),
('Hampton Inn', 195, '2019-07-24', 349, NULL),
('Hampton Inn', 195, '2019-07-25', 279, NULL),
('Hampton Inn', 195, '2019-07-26', 377, NULL),
('Hampton Inn', 195, '2019-07-27', 338, NULL),
('Hampton Inn', 195, '2019-07-28', 300, NULL),
('Hampton Inn', 195, '2019-07-29', 289, NULL),
('Hampton Inn', 195, '2019-07-30', 136, NULL),
('Hampton Inn', 195, '2019-07-31', 319, NULL),
('Hampton Inn', 195, '2019-08-01', 353, NULL),
('Hampton Inn', 195, '2019-08-02', 132, NULL),
('Hampton Inn', 195, '2019-08-03', 388, NULL),
('Hampton Inn', 195, '2019-08-04', 203, NULL),
('Hampton Inn', 195, '2019-08-05', 236, NULL),
('Hampton Inn', 195, '2019-08-06', 108, NULL),
('Hampton Inn', 195, '2019-08-07', 191, NULL),
('Hampton Inn', 195, '2019-08-08', 307, NULL),
('Hampton Inn', 195, '2019-08-09', 301, NULL),
('Hampton Inn', 195, '2019-08-10', 235, NULL),
('Hampton Inn', 195, '2019-08-11', 190, NULL),
('Hampton Inn', 195, '2019-08-12', 301, NULL),
('Hampton Inn', 195, '2019-08-13', 297, NULL),
('Hampton Inn', 195, '2019-08-14', 385, NULL),
('Hampton Inn', 195, '2019-08-15', 216, NULL),
('Hampton Inn', 195, '2019-08-16', 259, NULL),
('Hampton Inn', 195, '2019-08-17', 221, NULL),
('Hampton Inn', 195, '2019-08-18', 130, NULL),
('Hampton Inn', 195, '2019-08-19', 250, NULL),
('Hampton Inn', 195, '2019-08-20', 398, NULL),
('Hampton Inn', 195, '2019-08-21', 395, NULL),
('Hampton Inn', 195, '2019-08-22', 109, NULL),
('Hampton Inn', 195, '2019-08-23', 210, NULL),
('Hampton Inn', 195, '2019-08-24', 145, NULL),
('Hampton Inn', 195, '2019-08-25', 394, NULL),
('Hampton Inn', 195, '2019-08-26', 362, NULL),
('Hampton Inn', 195, '2019-08-27', 123, NULL),
('Hampton Inn', 195, '2019-08-28', 346, NULL),
('Hampton Inn', 195, '2019-08-29', 227, NULL),
('Hampton Inn', 195, '2019-08-30', 328, NULL),
('Hampton Inn', 195, '2019-08-31', 272, NULL),
('Hampton Inn', 195, '2019-09-01', 187, NULL),
('Hampton Inn', 195, '2019-09-02', 111, NULL),
('Hampton Inn', 195, '2019-09-03', 351, NULL),
('Hampton Inn', 195, '2019-09-04', 103, NULL),
('Hampton Inn', 195, '2019-09-05', 220, NULL),
('Hampton Inn', 195, '2019-09-06', 314, NULL),
('Hampton Inn', 195, '2019-09-07', 199, NULL),
('Hampton Inn', 195, '2019-09-08', 255, NULL),
('Hampton Inn', 195, '2019-09-09', 215, NULL),
('Hampton Inn', 195, '2019-09-10', 374, NULL),
('Hampton Inn', 195, '2019-09-11', 260, NULL),
('Hampton Inn', 195, '2019-09-12', 392, NULL),
('Hampton Inn', 195, '2019-09-13', 310, NULL),
('Hampton Inn', 195, '2019-09-14', 301, NULL),
('Hampton Inn', 195, '2019-09-15', 376, NULL),
('Hampton Inn', 195, '2019-09-16', 355, NULL),
('Hampton Inn', 195, '2019-09-17', 104, NULL),
('Hampton Inn', 195, '2019-09-18', 387, NULL),
('Hampton Inn', 195, '2019-09-19', 253, NULL),
('Hampton Inn', 195, '2019-09-20', 371, NULL),
('Hampton Inn', 195, '2019-09-21', 366, NULL),
('Hampton Inn', 195, '2019-09-22', 303, NULL),
('Hampton Inn', 195, '2019-09-23', 352, NULL),
('Hampton Inn', 195, '2019-09-24', 209, NULL),
('Hampton Inn', 195, '2019-09-25', 147, NULL),
('Hampton Inn', 195, '2019-09-26', 219, NULL),
('Hampton Inn', 195, '2019-09-27', 150, NULL),
('Hampton Inn', 195, '2019-09-28', 287, NULL),
('Hampton Inn', 195, '2019-09-29', 351, NULL),
('Hampton Inn', 195, '2019-09-30', 278, NULL),
('Hampton Inn', 195, '2019-10-01', 216, NULL),
('Hampton Inn', 195, '2019-10-02', 206, NULL),
('Hampton Inn', 195, '2019-10-03', 159, NULL),
('Hampton Inn', 195, '2019-10-04', 365, NULL),
('Hampton Inn', 195, '2019-10-05', 153, NULL),
('Hampton Inn', 195, '2019-10-06', 119, NULL),
('Hampton Inn', 195, '2019-10-07', 380, NULL),
('Hampton Inn', 195, '2019-10-08', 114, NULL),
('Hampton Inn', 195, '2019-10-09', 125, NULL),
('Hampton Inn', 195, '2019-10-10', 233, NULL),
('Hampton Inn', 195, '2019-10-11', 271, NULL),
('Hampton Inn', 195, '2019-10-12', 354, NULL),
('Hampton Inn', 195, '2019-10-13', 317, NULL),
('Hampton Inn', 195, '2019-10-14', 376, NULL),
('Hampton Inn', 195, '2019-10-15', 273, NULL),
('Hampton Inn', 195, '2019-10-16', 140, NULL),
('Hampton Inn', 195, '2019-10-17', 266, NULL),
('Hampton Inn', 195, '2019-10-18', 119, NULL),
('Hampton Inn', 195, '2019-10-19', 186, NULL),
('Hampton Inn', 195, '2019-10-20', 140, NULL),
('Hampton Inn', 195, '2019-10-21', 147, NULL),
('Hampton Inn', 195, '2019-10-22', 345, NULL),
('Hampton Inn', 195, '2019-10-23', 283, NULL),
('Hampton Inn', 195, '2019-10-24', 210, NULL),
('Hampton Inn', 195, '2019-10-25', 308, NULL),
('Hampton Inn', 195, '2019-10-26', 118, NULL),
('Hampton Inn', 195, '2019-10-27', 340, NULL),
('Hampton Inn', 195, '2019-10-28', 226, NULL),
('Hampton Inn', 195, '2019-10-29', 364, NULL),
('Hampton Inn', 195, '2019-10-30', 294, NULL),
('Hampton Inn', 195, '2019-10-31', 317, NULL),
('Hampton Inn', 195, '2019-11-01', 368, NULL),
('Hampton Inn', 195, '2019-11-02', 289, NULL),
('Hampton Inn', 195, '2019-11-03', 302, NULL),
('Hampton Inn', 195, '2019-11-04', 187, NULL),
('Hampton Inn', 195, '2019-11-05', 205, NULL),
('Hampton Inn', 195, '2019-11-06', 320, NULL),
('Hampton Inn', 195, '2019-11-07', 328, NULL),
('Hampton Inn', 195, '2019-11-08', 194, NULL),
('Hampton Inn', 195, '2019-11-09', 218, NULL),
('Hampton Inn', 195, '2019-11-10', 145, NULL),
('Hampton Inn', 195, '2019-11-11', 134, NULL),
('Hampton Inn', 195, '2019-11-12', 258, NULL),
('Hampton Inn', 195, '2019-11-13', 182, NULL),
('Hampton Inn', 195, '2019-11-14', 134, NULL),
('Hampton Inn', 195, '2019-11-15', 258, NULL),
('Hampton Inn', 195, '2019-11-16', 240, NULL),
('Hampton Inn', 195, '2019-11-17', 184, NULL),
('Hampton Inn', 195, '2019-11-18', 388, NULL),
('Hampton Inn', 195, '2019-11-19', 206, NULL),
('Hampton Inn', 195, '2019-11-20', 158, NULL),
('Hampton Inn', 195, '2019-11-21', 260, NULL),
('Hampton Inn', 195, '2019-11-22', 312, NULL),
('Hampton Inn', 195, '2019-11-23', 110, NULL),
('Hampton Inn', 195, '2019-11-24', 280, NULL),
('Hampton Inn', 195, '2019-11-25', 380, NULL),
('Hampton Inn', 195, '2019-11-26', 154, NULL),
('Hampton Inn', 195, '2019-11-27', 211, NULL),
('Hampton Inn', 195, '2019-11-28', 222, NULL),
('Hampton Inn', 195, '2019-11-29', 278, NULL),
('Hampton Inn', 195, '2019-11-30', 189, NULL),
('Hampton Inn', 195, '2019-12-01', 181, NULL),
('Hampton Inn', 195, '2019-12-02', 226, NULL),
('Hampton Inn', 195, '2019-12-03', 207, NULL),
('Hampton Inn', 195, '2019-12-04', 132, NULL),
('Hampton Inn', 195, '2019-12-05', 313, NULL),
('Hampton Inn', 195, '2019-12-06', 351, NULL),
('Hampton Inn', 195, '2019-12-07', 186, NULL),
('Hampton Inn', 195, '2019-12-08', 118, NULL),
('Hampton Inn', 195, '2019-12-09', 339, NULL),
('Hampton Inn', 195, '2019-12-10', 284, NULL),
('Hampton Inn', 195, '2019-12-11', 358, NULL),
('Hampton Inn', 195, '2019-12-12', 368, NULL),
('Hampton Inn', 195, '2019-12-13', 306, NULL),
('Hampton Inn', 195, '2019-12-14', 352, NULL),
('Hampton Inn', 195, '2019-12-15', 287, NULL),
('Hampton Inn', 195, '2019-12-16', 290, NULL),
('Hampton Inn', 195, '2019-12-17', 237, NULL),
('Hampton Inn', 195, '2019-12-18', 220, NULL),
('Hampton Inn', 195, '2019-12-19', 186, NULL),
('Hampton Inn', 195, '2019-12-20', 390, NULL),
('Hampton Inn', 195, '2019-12-21', 271, NULL),
('Hampton Inn', 195, '2019-12-22', 249, NULL),
('Hampton Inn', 195, '2019-12-23', 399, NULL),
('Hampton Inn', 195, '2019-12-24', 154, NULL),
('Hampton Inn', 195, '2019-12-25', 309, NULL),
('Hampton Inn', 195, '2019-12-26', 391, NULL),
('Hampton Inn', 195, '2019-12-27', 345, NULL),
('Hampton Inn', 195, '2019-12-28', 207, NULL),
('Hampton Inn', 195, '2019-12-29', 103, NULL),
('Hampton Inn', 195, '2019-12-30', 319, NULL),
('Hampton Inn', 195, '2019-12-31', 138, NULL),
('Hampton Inn', 195, '2020-01-01', 276, NULL),
('Hampton Inn', 195, '2020-01-02', 389, NULL),
('Hampton Inn', 195, '2020-01-03', 183, NULL),
('Hampton Inn', 195, '2020-01-04', 247, NULL),
('Hampton Inn', 195, '2020-01-05', 122, NULL),
('Hampton Inn', 195, '2020-01-06', 204, NULL),
('Hampton Inn', 195, '2020-01-07', 135, NULL),
('Hampton Inn', 195, '2020-01-08', 255, NULL),
('Hampton Inn', 195, '2020-01-09', 282, NULL),
('Hampton Inn', 195, '2020-01-10', 385, NULL),
('Hampton Inn', 195, '2020-01-11', 128, NULL),
('Hampton Inn', 195, '2020-01-12', 256, NULL),
('Hampton Inn', 195, '2020-01-13', 314, NULL),
('Hampton Inn', 195, '2020-01-14', 266, NULL),
('Hampton Inn', 195, '2020-01-15', 133, NULL),
('Hampton Inn', 195, '2020-01-16', 331, NULL),
('Hampton Inn', 195, '2020-01-17', 101, NULL),
('Hampton Inn', 195, '2020-01-18', 157, NULL),
('Hampton Inn', 195, '2020-01-19', 373, NULL),
('Hampton Inn', 195, '2020-01-20', 333, NULL),
('Hampton Inn', 195, '2020-01-21', 300, NULL),
('Hampton Inn', 195, '2020-01-22', 274, NULL),
('Hampton Inn', 195, '2020-01-23', 120, NULL),
('Hampton Inn', 195, '2020-01-24', 185, NULL),
('Hampton Inn', 195, '2020-01-25', 309, NULL),
('Hampton Inn', 195, '2020-01-26', 355, NULL),
('Hampton Inn', 195, '2020-01-27', 188, NULL),
('Hampton Inn', 195, '2020-01-28', 369, NULL),
('Hampton Inn', 195, '2020-01-29', 367, NULL),
('Hampton Inn', 195, '2020-01-30', 130, NULL),
('Hampton Inn', 195, '2020-01-31', 360, NULL),
('Hampton Inn', 195, '2020-02-01', 242, NULL),
('Hampton Inn', 195, '2020-02-02', 329, NULL),
('Hampton Inn', 195, '2020-02-03', 151, NULL),
('Hampton Inn', 195, '2020-02-04', 266, NULL),
('Hampton Inn', 252, '2019-01-01', 395, NULL),
('Hampton Inn', 252, '2019-01-02', 112, NULL),
('Hampton Inn', 252, '2019-01-03', 192, NULL),
('Hampton Inn', 252, '2019-01-04', 154, NULL),
('Hampton Inn', 252, '2019-01-05', 240, NULL),
('Hampton Inn', 252, '2019-01-06', 121, NULL),
('Hampton Inn', 252, '2019-01-07', 278, NULL),
('Hampton Inn', 252, '2019-01-08', 392, NULL),
('Hampton Inn', 252, '2019-01-09', 183, NULL),
('Hampton Inn', 252, '2019-01-10', 210, NULL),
('Hampton Inn', 252, '2019-01-11', 179, NULL),
('Hampton Inn', 252, '2019-01-12', 286, NULL),
('Hampton Inn', 252, '2019-01-13', 173, NULL),
('Hampton Inn', 252, '2019-01-14', 166, NULL),
('Hampton Inn', 252, '2019-01-15', 278, NULL),
('Hampton Inn', 252, '2019-01-16', 103, NULL),
('Hampton Inn', 252, '2019-01-17', 119, NULL),
('Hampton Inn', 252, '2019-01-18', 194, NULL),
('Hampton Inn', 252, '2019-01-19', 376, NULL),
('Hampton Inn', 252, '2019-01-20', 177, NULL),
('Hampton Inn', 252, '2019-01-21', 199, NULL),
('Hampton Inn', 252, '2019-01-22', 298, NULL),
('Hampton Inn', 252, '2019-01-23', 344, NULL),
('Hampton Inn', 252, '2019-01-24', 199, NULL),
('Hampton Inn', 252, '2019-01-25', 206, NULL),
('Hampton Inn', 252, '2019-01-26', 114, NULL),
('Hampton Inn', 252, '2019-01-27', 348, NULL),
('Hampton Inn', 252, '2019-01-28', 190, NULL),
('Hampton Inn', 252, '2019-01-29', 380, NULL),
('Hampton Inn', 252, '2019-01-30', 285, NULL),
('Hampton Inn', 252, '2019-01-31', 371, NULL),
('Hampton Inn', 252, '2019-02-01', 123, NULL),
('Hampton Inn', 252, '2019-02-02', 307, NULL),
('Hampton Inn', 252, '2019-02-03', 303, NULL),
('Hampton Inn', 252, '2019-02-04', 223, NULL),
('Hampton Inn', 252, '2019-02-05', 387, NULL),
('Hampton Inn', 252, '2019-02-06', 247, NULL),
('Hampton Inn', 252, '2019-02-07', 213, NULL),
('Hampton Inn', 252, '2019-02-08', 293, NULL),
('Hampton Inn', 252, '2019-02-09', 210, NULL),
('Hampton Inn', 252, '2019-02-10', 124, NULL),
('Hampton Inn', 252, '2019-02-11', 136, NULL),
('Hampton Inn', 252, '2019-02-12', 136, NULL),
('Hampton Inn', 252, '2019-02-13', 185, NULL),
('Hampton Inn', 252, '2019-02-14', 276, NULL),
('Hampton Inn', 252, '2019-02-15', 208, NULL),
('Hampton Inn', 252, '2019-02-16', 367, NULL),
('Hampton Inn', 252, '2019-02-17', 107, NULL),
('Hampton Inn', 252, '2019-02-18', 187, NULL),
('Hampton Inn', 252, '2019-02-19', 381, NULL),
('Hampton Inn', 252, '2019-02-20', 255, NULL),
('Hampton Inn', 252, '2019-02-21', 134, NULL),
('Hampton Inn', 252, '2019-02-22', 247, NULL),
('Hampton Inn', 252, '2019-02-23', 368, NULL),
('Hampton Inn', 252, '2019-02-24', 147, NULL),
('Hampton Inn', 252, '2019-02-25', 397, NULL),
('Hampton Inn', 252, '2019-02-26', 115, NULL),
('Hampton Inn', 252, '2019-02-27', 229, NULL),
('Hampton Inn', 252, '2019-02-28', 381, NULL),
('Hampton Inn', 252, '2019-03-01', 382, NULL),
('Hampton Inn', 252, '2019-03-02', 252, NULL),
('Hampton Inn', 252, '2019-03-03', 255, NULL),
('Hampton Inn', 252, '2019-03-04', 174, NULL),
('Hampton Inn', 252, '2019-03-05', 131, NULL),
('Hampton Inn', 252, '2019-03-06', 281, NULL),
('Hampton Inn', 252, '2019-03-07', 110, NULL),
('Hampton Inn', 252, '2019-03-08', 258, NULL),
('Hampton Inn', 252, '2019-03-09', 192, NULL),
('Hampton Inn', 252, '2019-03-10', 151, NULL),
('Hampton Inn', 252, '2019-03-11', 391, NULL),
('Hampton Inn', 252, '2019-03-12', 205, NULL),
('Hampton Inn', 252, '2019-03-13', 337, NULL),
('Hampton Inn', 252, '2019-03-14', 246, NULL),
('Hampton Inn', 252, '2019-03-15', 161, NULL),
('Hampton Inn', 252, '2019-03-16', 344, NULL),
('Hampton Inn', 252, '2019-03-17', 284, NULL),
('Hampton Inn', 252, '2019-03-18', 381, NULL),
('Hampton Inn', 252, '2019-03-19', 386, NULL),
('Hampton Inn', 252, '2019-03-20', 365, NULL),
('Hampton Inn', 252, '2019-03-21', 202, NULL),
('Hampton Inn', 252, '2019-03-22', 188, NULL),
('Hampton Inn', 252, '2019-03-23', 168, NULL),
('Hampton Inn', 252, '2019-03-24', 205, NULL),
('Hampton Inn', 252, '2019-03-25', 369, NULL),
('Hampton Inn', 252, '2019-03-26', 295, NULL),
('Hampton Inn', 252, '2019-03-27', 356, NULL),
('Hampton Inn', 252, '2019-03-28', 389, NULL),
('Hampton Inn', 252, '2019-03-29', 345, NULL),
('Hampton Inn', 252, '2019-03-30', 372, NULL),
('Hampton Inn', 252, '2019-03-31', 380, NULL),
('Hampton Inn', 252, '2019-04-01', 130, NULL),
('Hampton Inn', 252, '2019-04-02', 398, NULL),
('Hampton Inn', 252, '2019-04-03', 259, NULL),
('Hampton Inn', 252, '2019-04-04', 114, NULL),
('Hampton Inn', 252, '2019-04-05', 266, NULL),
('Hampton Inn', 252, '2019-04-06', 139, NULL),
('Hampton Inn', 252, '2019-04-07', 354, NULL),
('Hampton Inn', 252, '2019-04-08', 203, NULL),
('Hampton Inn', 252, '2019-04-09', 353, NULL),
('Hampton Inn', 252, '2019-04-10', 209, NULL),
('Hampton Inn', 252, '2019-04-11', 357, NULL),
('Hampton Inn', 252, '2019-04-12', 134, NULL),
('Hampton Inn', 252, '2019-04-13', 272, NULL),
('Hampton Inn', 252, '2019-04-14', 389, NULL),
('Hampton Inn', 252, '2019-04-15', 324, NULL),
('Hampton Inn', 252, '2019-04-16', 275, NULL),
('Hampton Inn', 252, '2019-04-17', 115, NULL),
('Hampton Inn', 252, '2019-04-18', 369, NULL),
('Hampton Inn', 252, '2019-04-19', 393, NULL),
('Hampton Inn', 252, '2019-04-20', 201, NULL),
('Hampton Inn', 252, '2019-04-21', 139, NULL),
('Hampton Inn', 252, '2019-04-22', 148, NULL),
('Hampton Inn', 252, '2019-04-23', 264, NULL),
('Hampton Inn', 252, '2019-04-24', 285, NULL),
('Hampton Inn', 252, '2019-04-25', 321, NULL),
('Hampton Inn', 252, '2019-04-26', 369, NULL),
('Hampton Inn', 252, '2019-04-27', 283, NULL),
('Hampton Inn', 252, '2019-04-28', 195, NULL),
('Hampton Inn', 252, '2019-04-29', 169, NULL),
('Hampton Inn', 252, '2019-04-30', 150, NULL),
('Hampton Inn', 252, '2019-05-01', 190, NULL),
('Hampton Inn', 252, '2019-05-02', 302, NULL),
('Hampton Inn', 252, '2019-05-03', 241, NULL),
('Hampton Inn', 252, '2019-05-04', 398, NULL),
('Hampton Inn', 252, '2019-05-05', 270, NULL),
('Hampton Inn', 252, '2019-05-06', 393, NULL),
('Hampton Inn', 252, '2019-05-07', 279, NULL),
('Hampton Inn', 252, '2019-05-08', 101, NULL),
('Hampton Inn', 252, '2019-05-09', 383, NULL),
('Hampton Inn', 252, '2019-05-10', 334, NULL),
('Hampton Inn', 252, '2019-05-11', 174, NULL),
('Hampton Inn', 252, '2019-05-12', 250, NULL),
('Hampton Inn', 252, '2019-05-13', 203, NULL),
('Hampton Inn', 252, '2019-05-14', 185, NULL),
('Hampton Inn', 252, '2019-05-15', 346, NULL),
('Hampton Inn', 252, '2019-05-16', 389, NULL),
('Hampton Inn', 252, '2019-05-17', 278, NULL),
('Hampton Inn', 252, '2019-05-18', 149, NULL),
('Hampton Inn', 252, '2019-05-19', 360, NULL),
('Hampton Inn', 252, '2019-05-20', 208, NULL),
('Hampton Inn', 252, '2019-05-21', 201, NULL),
('Hampton Inn', 252, '2019-05-22', 259, NULL),
('Hampton Inn', 252, '2019-05-23', 228, NULL),
('Hampton Inn', 252, '2019-05-24', 121, NULL),
('Hampton Inn', 252, '2019-05-25', 397, NULL),
('Hampton Inn', 252, '2019-05-26', 372, NULL),
('Hampton Inn', 252, '2019-05-27', 238, NULL),
('Hampton Inn', 252, '2019-05-28', 212, NULL),
('Hampton Inn', 252, '2019-05-29', 193, NULL),
('Hampton Inn', 252, '2019-05-30', 283, NULL),
('Hampton Inn', 252, '2019-05-31', 190, NULL),
('Hampton Inn', 252, '2019-06-01', 276, NULL),
('Hampton Inn', 252, '2019-06-02', 391, NULL),
('Hampton Inn', 252, '2019-06-03', 114, NULL),
('Hampton Inn', 252, '2019-06-04', 112, NULL),
('Hampton Inn', 252, '2019-06-05', 324, NULL),
('Hampton Inn', 252, '2019-06-06', 341, NULL),
('Hampton Inn', 252, '2019-06-07', 360, NULL),
('Hampton Inn', 252, '2019-06-08', 110, NULL),
('Hampton Inn', 252, '2019-06-09', 325, NULL),
('Hampton Inn', 252, '2019-06-10', 240, NULL),
('Hampton Inn', 252, '2019-06-11', 328, NULL),
('Hampton Inn', 252, '2019-06-12', 120, NULL),
('Hampton Inn', 252, '2019-06-13', 122, NULL),
('Hampton Inn', 252, '2019-06-14', 363, NULL),
('Hampton Inn', 252, '2019-06-15', 166, NULL),
('Hampton Inn', 252, '2019-06-16', 260, NULL),
('Hampton Inn', 252, '2019-06-17', 331, NULL),
('Hampton Inn', 252, '2019-06-18', 161, NULL),
('Hampton Inn', 252, '2019-06-19', 271, NULL),
('Hampton Inn', 252, '2019-06-20', 187, NULL),
('Hampton Inn', 252, '2019-06-21', 297, NULL),
('Hampton Inn', 252, '2019-06-22', 246, NULL),
('Hampton Inn', 252, '2019-06-23', 215, NULL),
('Hampton Inn', 252, '2019-06-24', 202, NULL),
('Hampton Inn', 252, '2019-06-25', 231, NULL),
('Hampton Inn', 252, '2019-06-26', 127, NULL),
('Hampton Inn', 252, '2019-06-27', 399, NULL),
('Hampton Inn', 252, '2019-06-28', 308, NULL),
('Hampton Inn', 252, '2019-06-29', 174, NULL),
('Hampton Inn', 252, '2019-06-30', 278, NULL),
('Hampton Inn', 252, '2019-07-01', 325, NULL),
('Hampton Inn', 252, '2019-07-02', 163, NULL),
('Hampton Inn', 252, '2019-07-03', 118, NULL),
('Hampton Inn', 252, '2019-07-04', 317, NULL),
('Hampton Inn', 252, '2019-07-05', 185, NULL),
('Hampton Inn', 252, '2019-07-06', 165, NULL),
('Hampton Inn', 252, '2019-07-07', 252, NULL),
('Hampton Inn', 252, '2019-07-08', 290, NULL),
('Hampton Inn', 252, '2019-07-09', 245, NULL),
('Hampton Inn', 252, '2019-07-10', 259, NULL),
('Hampton Inn', 252, '2019-07-11', 148, NULL),
('Hampton Inn', 252, '2019-07-12', 162, NULL),
('Hampton Inn', 252, '2019-07-13', 315, NULL),
('Hampton Inn', 252, '2019-07-14', 395, NULL),
('Hampton Inn', 252, '2019-07-15', 163, NULL),
('Hampton Inn', 252, '2019-07-16', 103, NULL),
('Hampton Inn', 252, '2019-07-17', 144, NULL),
('Hampton Inn', 252, '2019-07-18', 390, NULL),
('Hampton Inn', 252, '2019-07-19', 143, NULL),
('Hampton Inn', 252, '2019-07-20', 310, NULL),
('Hampton Inn', 252, '2019-07-21', 362, NULL),
('Hampton Inn', 252, '2019-07-22', 209, NULL),
('Hampton Inn', 252, '2019-07-23', 386, NULL),
('Hampton Inn', 252, '2019-07-24', 129, NULL),
('Hampton Inn', 252, '2019-07-25', 236, NULL),
('Hampton Inn', 252, '2019-07-26', 359, NULL),
('Hampton Inn', 252, '2019-07-27', 297, NULL),
('Hampton Inn', 252, '2019-07-28', 264, NULL),
('Hampton Inn', 252, '2019-07-29', 123, NULL),
('Hampton Inn', 252, '2019-07-30', 347, NULL),
('Hampton Inn', 252, '2019-07-31', 383, NULL),
('Hampton Inn', 252, '2019-08-01', 238, NULL),
('Hampton Inn', 252, '2019-08-02', 358, NULL),
('Hampton Inn', 252, '2019-08-03', 378, NULL),
('Hampton Inn', 252, '2019-08-04', 152, NULL),
('Hampton Inn', 252, '2019-08-05', 388, NULL),
('Hampton Inn', 252, '2019-08-06', 225, NULL),
('Hampton Inn', 252, '2019-08-07', 372, NULL),
('Hampton Inn', 252, '2019-08-08', 189, NULL),
('Hampton Inn', 252, '2019-08-09', 265, NULL),
('Hampton Inn', 252, '2019-08-10', 303, NULL),
('Hampton Inn', 252, '2019-08-11', 351, NULL),
('Hampton Inn', 252, '2019-08-12', 265, NULL),
('Hampton Inn', 252, '2019-08-13', 394, NULL),
('Hampton Inn', 252, '2019-08-14', 346, NULL),
('Hampton Inn', 252, '2019-08-15', 307, NULL),
('Hampton Inn', 252, '2019-08-16', 187, NULL),
('Hampton Inn', 252, '2019-08-17', 111, NULL),
('Hampton Inn', 252, '2019-08-18', 153, NULL),
('Hampton Inn', 252, '2019-08-19', 253, NULL),
('Hampton Inn', 252, '2019-08-20', 163, NULL),
('Hampton Inn', 252, '2019-08-21', 187, NULL),
('Hampton Inn', 252, '2019-08-22', 112, NULL),
('Hampton Inn', 252, '2019-08-23', 194, NULL),
('Hampton Inn', 252, '2019-08-24', 101, NULL),
('Hampton Inn', 252, '2019-08-25', 150, NULL),
('Hampton Inn', 252, '2019-08-26', 387, NULL),
('Hampton Inn', 252, '2019-08-27', 180, NULL),
('Hampton Inn', 252, '2019-08-28', 338, NULL),
('Hampton Inn', 252, '2019-08-29', 345, NULL),
('Hampton Inn', 252, '2019-08-30', 258, NULL),
('Hampton Inn', 252, '2019-08-31', 399, NULL),
('Hampton Inn', 252, '2019-09-01', 309, NULL),
('Hampton Inn', 252, '2019-09-02', 251, NULL),
('Hampton Inn', 252, '2019-09-03', 144, NULL),
('Hampton Inn', 252, '2019-09-04', 373, NULL),
('Hampton Inn', 252, '2019-09-05', 217, NULL),
('Hampton Inn', 252, '2019-09-06', 375, NULL),
('Hampton Inn', 252, '2019-09-07', 275, NULL),
('Hampton Inn', 252, '2019-09-08', 146, NULL),
('Hampton Inn', 252, '2019-09-09', 188, NULL),
('Hampton Inn', 252, '2019-09-10', 345, NULL),
('Hampton Inn', 252, '2019-09-11', 113, NULL),
('Hampton Inn', 252, '2019-09-12', 152, NULL),
('Hampton Inn', 252, '2019-09-13', 139, NULL),
('Hampton Inn', 252, '2019-09-14', 106, NULL),
('Hampton Inn', 252, '2019-09-15', 308, NULL),
('Hampton Inn', 252, '2019-09-16', 273, NULL),
('Hampton Inn', 252, '2019-09-17', 208, NULL),
('Hampton Inn', 252, '2019-09-18', 345, NULL),
('Hampton Inn', 252, '2019-09-19', 323, NULL),
('Hampton Inn', 252, '2019-09-20', 346, NULL),
('Hampton Inn', 252, '2019-09-21', 222, NULL),
('Hampton Inn', 252, '2019-09-22', 101, NULL),
('Hampton Inn', 252, '2019-09-23', 341, NULL),
('Hampton Inn', 252, '2019-09-24', 318, NULL),
('Hampton Inn', 252, '2019-09-25', 228, NULL),
('Hampton Inn', 252, '2019-09-26', 291, NULL),
('Hampton Inn', 252, '2019-09-27', 117, NULL),
('Hampton Inn', 252, '2019-09-28', 296, NULL),
('Hampton Inn', 252, '2019-09-29', 168, NULL),
('Hampton Inn', 252, '2019-09-30', 154, NULL),
('Hampton Inn', 252, '2019-10-01', 154, NULL),
('Hampton Inn', 252, '2019-10-02', 174, NULL),
('Hampton Inn', 252, '2019-10-03', 217, NULL),
('Hampton Inn', 252, '2019-10-04', 269, NULL),
('Hampton Inn', 252, '2019-10-05', 282, NULL),
('Hampton Inn', 252, '2019-10-06', 356, NULL),
('Hampton Inn', 252, '2019-10-07', 374, NULL),
('Hampton Inn', 252, '2019-10-08', 366, NULL),
('Hampton Inn', 252, '2019-10-09', 387, NULL),
('Hampton Inn', 252, '2019-10-10', 386, NULL),
('Hampton Inn', 252, '2019-10-11', 192, NULL),
('Hampton Inn', 252, '2019-10-12', 333, NULL),
('Hampton Inn', 252, '2019-10-13', 134, NULL),
('Hampton Inn', 252, '2019-10-14', 101, NULL),
('Hampton Inn', 252, '2019-10-15', 113, NULL),
('Hampton Inn', 252, '2019-10-16', 382, NULL),
('Hampton Inn', 252, '2019-10-17', 125, NULL),
('Hampton Inn', 252, '2019-10-18', 110, NULL),
('Hampton Inn', 252, '2019-10-19', 245, NULL),
('Hampton Inn', 252, '2019-10-20', 260, NULL),
('Hampton Inn', 252, '2019-10-21', 278, NULL),
('Hampton Inn', 252, '2019-10-22', 127, NULL),
('Hampton Inn', 252, '2019-10-23', 289, NULL),
('Hampton Inn', 252, '2019-10-24', 339, NULL),
('Hampton Inn', 252, '2019-10-25', 212, NULL),
('Hampton Inn', 252, '2019-10-26', 390, NULL),
('Hampton Inn', 252, '2019-10-27', 161, NULL),
('Hampton Inn', 252, '2019-10-28', 364, NULL),
('Hampton Inn', 252, '2019-10-29', 362, NULL),
('Hampton Inn', 252, '2019-10-30', 191, NULL),
('Hampton Inn', 252, '2019-10-31', 163, NULL),
('Hampton Inn', 252, '2019-11-01', 275, NULL),
('Hampton Inn', 252, '2019-11-02', 119, NULL),
('Hampton Inn', 252, '2019-11-03', 183, NULL),
('Hampton Inn', 252, '2019-11-04', 128, NULL),
('Hampton Inn', 252, '2019-11-05', 171, NULL),
('Hampton Inn', 252, '2019-11-06', 214, NULL),
('Hampton Inn', 252, '2019-11-07', 353, NULL),
('Hampton Inn', 252, '2019-11-08', 274, NULL),
('Hampton Inn', 252, '2019-11-09', 166, NULL),
('Hampton Inn', 252, '2019-11-10', 174, NULL),
('Hampton Inn', 252, '2019-11-11', 132, NULL),
('Hampton Inn', 252, '2019-11-12', 253, NULL),
('Hampton Inn', 252, '2019-11-13', 243, NULL),
('Hampton Inn', 252, '2019-11-14', 200, NULL),
('Hampton Inn', 252, '2019-11-15', 346, NULL),
('Hampton Inn', 252, '2019-11-16', 267, NULL),
('Hampton Inn', 252, '2019-11-17', 192, NULL),
('Hampton Inn', 252, '2019-11-18', 167, NULL),
('Hampton Inn', 252, '2019-11-19', 229, NULL),
('Hampton Inn', 252, '2019-11-20', 213, NULL),
('Hampton Inn', 252, '2019-11-21', 313, NULL),
('Hampton Inn', 252, '2019-11-22', 334, NULL),
('Hampton Inn', 252, '2019-11-23', 142, NULL),
('Hampton Inn', 252, '2019-11-24', 230, NULL),
('Hampton Inn', 252, '2019-11-25', 335, NULL),
('Hampton Inn', 252, '2019-11-26', 282, NULL),
('Hampton Inn', 252, '2019-11-27', 135, NULL),
('Hampton Inn', 252, '2019-11-28', 128, NULL),
('Hampton Inn', 252, '2019-11-29', 368, NULL),
('Hampton Inn', 252, '2019-11-30', 146, NULL),
('Hampton Inn', 252, '2019-12-01', 306, NULL),
('Hampton Inn', 252, '2019-12-02', 394, NULL),
('Hampton Inn', 252, '2019-12-03', 272, NULL),
('Hampton Inn', 252, '2019-12-04', 109, NULL),
('Hampton Inn', 252, '2019-12-05', 181, NULL),
('Hampton Inn', 252, '2019-12-06', 152, NULL),
('Hampton Inn', 252, '2019-12-07', 287, NULL),
('Hampton Inn', 252, '2019-12-08', 146, NULL),
('Hampton Inn', 252, '2019-12-09', 164, NULL),
('Hampton Inn', 252, '2019-12-10', 165, NULL),
('Hampton Inn', 252, '2019-12-11', 196, NULL),
('Hampton Inn', 252, '2019-12-12', 253, NULL),
('Hampton Inn', 252, '2019-12-13', 190, NULL),
('Hampton Inn', 252, '2019-12-14', 232, NULL),
('Hampton Inn', 252, '2019-12-15', 133, NULL),
('Hampton Inn', 252, '2019-12-16', 174, NULL),
('Hampton Inn', 252, '2019-12-17', 386, NULL),
('Hampton Inn', 252, '2019-12-18', 144, NULL),
('Hampton Inn', 252, '2019-12-19', 357, NULL),
('Hampton Inn', 252, '2019-12-20', 343, NULL),
('Hampton Inn', 252, '2019-12-21', 172, NULL),
('Hampton Inn', 252, '2019-12-22', 305, NULL),
('Hampton Inn', 252, '2019-12-23', 340, NULL),
('Hampton Inn', 252, '2019-12-24', 270, NULL),
('Hampton Inn', 252, '2019-12-25', 172, NULL),
('Hampton Inn', 252, '2019-12-26', 126, NULL),
('Hampton Inn', 252, '2019-12-27', 135, NULL),
('Hampton Inn', 252, '2019-12-28', 120, NULL),
('Hampton Inn', 252, '2019-12-29', 153, NULL),
('Hampton Inn', 252, '2019-12-30', 154, NULL),
('Hampton Inn', 252, '2019-12-31', 169, NULL),
('Hampton Inn', 252, '2020-01-01', 392, NULL),
('Hampton Inn', 252, '2020-01-02', 204, NULL),
('Hampton Inn', 252, '2020-01-03', 399, NULL),
('Hampton Inn', 252, '2020-01-04', 155, NULL),
('Hampton Inn', 252, '2020-01-05', 104, NULL),
('Hampton Inn', 252, '2020-01-06', 233, NULL),
('Hampton Inn', 252, '2020-01-07', 279, NULL),
('Hampton Inn', 252, '2020-01-08', 287, NULL),
('Hampton Inn', 252, '2020-01-09', 385, NULL),
('Hampton Inn', 252, '2020-01-10', 268, NULL),
('Hampton Inn', 252, '2020-01-11', 168, NULL),
('Hampton Inn', 252, '2020-01-12', 207, NULL),
('Hampton Inn', 252, '2020-01-13', 221, NULL),
('Hampton Inn', 252, '2020-01-14', 327, NULL),
('Hampton Inn', 252, '2020-01-15', 276, NULL),
('Hampton Inn', 252, '2020-01-16', 270, NULL),
('Hampton Inn', 252, '2020-01-17', 114, NULL),
('Hampton Inn', 252, '2020-01-18', 143, NULL),
('Hampton Inn', 252, '2020-01-19', 392, NULL),
('Hampton Inn', 252, '2020-01-20', 330, NULL),
('Hampton Inn', 252, '2020-01-21', 348, NULL),
('Hampton Inn', 252, '2020-01-22', 283, NULL),
('Hampton Inn', 252, '2020-01-23', 222, NULL),
('Hampton Inn', 252, '2020-01-24', 126, NULL),
('Hampton Inn', 252, '2020-01-25', 126, NULL),
('Hampton Inn', 252, '2020-01-26', 234, NULL),
('Hampton Inn', 252, '2020-01-27', 109, NULL),
('Hampton Inn', 252, '2020-01-28', 131, NULL),
('Hampton Inn', 252, '2020-01-29', 213, NULL),
('Hampton Inn', 252, '2020-01-30', 150, NULL),
('Hampton Inn', 252, '2020-01-31', 173, NULL),
('Hampton Inn', 252, '2020-02-01', 174, NULL),
('Hampton Inn', 252, '2020-02-02', 301, NULL),
('Hampton Inn', 252, '2020-02-03', 348, NULL),
('Hampton Inn', 252, '2020-02-04', 375, NULL),
('Hampton Inn', 256, '2019-01-01', 252, NULL),
('Hampton Inn', 256, '2019-01-02', 141, NULL),
('Hampton Inn', 256, '2019-01-03', 302, NULL),
('Hampton Inn', 256, '2019-01-04', 156, NULL),
('Hampton Inn', 256, '2019-01-05', 263, NULL),
('Hampton Inn', 256, '2019-01-06', 319, NULL),
('Hampton Inn', 256, '2019-01-07', 375, NULL),
('Hampton Inn', 256, '2019-01-08', 132, NULL),
('Hampton Inn', 256, '2019-01-09', 162, NULL),
('Hampton Inn', 256, '2019-01-10', 341, NULL),
('Hampton Inn', 256, '2019-01-11', 217, NULL),
('Hampton Inn', 256, '2019-01-12', 351, NULL),
('Hampton Inn', 256, '2019-01-13', 130, NULL),
('Hampton Inn', 256, '2019-01-14', 318, NULL),
('Hampton Inn', 256, '2019-01-15', 230, NULL),
('Hampton Inn', 256, '2019-01-16', 340, NULL),
('Hampton Inn', 256, '2019-01-17', 195, NULL),
('Hampton Inn', 256, '2019-01-18', 109, NULL),
('Hampton Inn', 256, '2019-01-19', 164, NULL),
('Hampton Inn', 256, '2019-01-20', 330, NULL),
('Hampton Inn', 256, '2019-01-21', 109, NULL),
('Hampton Inn', 256, '2019-01-22', 263, NULL),
('Hampton Inn', 256, '2019-01-23', 394, NULL),
('Hampton Inn', 256, '2019-01-24', 117, NULL),
('Hampton Inn', 256, '2019-01-25', 156, NULL),
('Hampton Inn', 256, '2019-01-26', 238, NULL),
('Hampton Inn', 256, '2019-01-27', 129, NULL),
('Hampton Inn', 256, '2019-01-28', 328, NULL),
('Hampton Inn', 256, '2019-01-29', 159, NULL),
('Hampton Inn', 256, '2019-01-30', 139, NULL),
('Hampton Inn', 256, '2019-01-31', 274, NULL),
('Hampton Inn', 256, '2019-02-01', 128, NULL),
('Hampton Inn', 256, '2019-02-02', 144, NULL),
('Hampton Inn', 256, '2019-02-03', 324, NULL),
('Hampton Inn', 256, '2019-02-04', 326, NULL),
('Hampton Inn', 256, '2019-02-05', 330, NULL),
('Hampton Inn', 256, '2019-02-06', 332, NULL),
('Hampton Inn', 256, '2019-02-07', 115, NULL),
('Hampton Inn', 256, '2019-02-08', 362, NULL),
('Hampton Inn', 256, '2019-02-09', 181, NULL),
('Hampton Inn', 256, '2019-02-10', 392, NULL),
('Hampton Inn', 256, '2019-02-11', 157, NULL),
('Hampton Inn', 256, '2019-02-12', 293, NULL),
('Hampton Inn', 256, '2019-02-13', 128, NULL),
('Hampton Inn', 256, '2019-02-14', 251, NULL),
('Hampton Inn', 256, '2019-02-15', 227, NULL),
('Hampton Inn', 256, '2019-02-16', 210, NULL),
('Hampton Inn', 256, '2019-02-17', 217, NULL),
('Hampton Inn', 256, '2019-02-18', 311, NULL),
('Hampton Inn', 256, '2019-02-19', 159, NULL),
('Hampton Inn', 256, '2019-02-20', 280, NULL),
('Hampton Inn', 256, '2019-02-21', 336, NULL),
('Hampton Inn', 256, '2019-02-22', 399, NULL),
('Hampton Inn', 256, '2019-02-23', 314, NULL),
('Hampton Inn', 256, '2019-02-24', 142, NULL),
('Hampton Inn', 256, '2019-02-25', 215, NULL),
('Hampton Inn', 256, '2019-02-26', 121, NULL),
('Hampton Inn', 256, '2019-02-27', 178, NULL),
('Hampton Inn', 256, '2019-02-28', 112, NULL),
('Hampton Inn', 256, '2019-03-01', 273, NULL),
('Hampton Inn', 256, '2019-03-02', 343, NULL),
('Hampton Inn', 256, '2019-03-03', 155, NULL),
('Hampton Inn', 256, '2019-03-04', 262, NULL),
('Hampton Inn', 256, '2019-03-05', 363, NULL),
('Hampton Inn', 256, '2019-03-06', 385, NULL),
('Hampton Inn', 256, '2019-03-07', 315, NULL),
('Hampton Inn', 256, '2019-03-08', 215, NULL),
('Hampton Inn', 256, '2019-03-09', 309, NULL),
('Hampton Inn', 256, '2019-03-10', 381, NULL),
('Hampton Inn', 256, '2019-03-11', 199, NULL),
('Hampton Inn', 256, '2019-03-12', 390, NULL),
('Hampton Inn', 256, '2019-03-13', 120, NULL),
('Hampton Inn', 256, '2019-03-14', 286, NULL),
('Hampton Inn', 256, '2019-03-15', 215, NULL),
('Hampton Inn', 256, '2019-03-16', 335, NULL),
('Hampton Inn', 256, '2019-03-17', 111, NULL),
('Hampton Inn', 256, '2019-03-18', 341, NULL),
('Hampton Inn', 256, '2019-03-19', 373, NULL),
('Hampton Inn', 256, '2019-03-20', 317, NULL),
('Hampton Inn', 256, '2019-03-21', 387, NULL),
('Hampton Inn', 256, '2019-03-22', 319, NULL),
('Hampton Inn', 256, '2019-03-23', 367, NULL),
('Hampton Inn', 256, '2019-03-24', 234, NULL),
('Hampton Inn', 256, '2019-03-25', 146, NULL),
('Hampton Inn', 256, '2019-03-26', 212, NULL),
('Hampton Inn', 256, '2019-03-27', 129, NULL),
('Hampton Inn', 256, '2019-03-28', 359, NULL),
('Hampton Inn', 256, '2019-03-29', 129, NULL),
('Hampton Inn', 256, '2019-03-30', 211, NULL),
('Hampton Inn', 256, '2019-03-31', 336, NULL),
('Hampton Inn', 256, '2019-04-01', 173, NULL),
('Hampton Inn', 256, '2019-04-02', 311, NULL),
('Hampton Inn', 256, '2019-04-03', 310, NULL),
('Hampton Inn', 256, '2019-04-04', 260, NULL),
('Hampton Inn', 256, '2019-04-05', 238, NULL),
('Hampton Inn', 256, '2019-04-06', 373, NULL),
('Hampton Inn', 256, '2019-04-07', 109, NULL),
('Hampton Inn', 256, '2019-04-08', 313, NULL),
('Hampton Inn', 256, '2019-04-09', 237, NULL),
('Hampton Inn', 256, '2019-04-10', 319, NULL),
('Hampton Inn', 256, '2019-04-11', 170, NULL),
('Hampton Inn', 256, '2019-04-12', 262, NULL),
('Hampton Inn', 256, '2019-04-13', 357, NULL),
('Hampton Inn', 256, '2019-04-14', 209, NULL),
('Hampton Inn', 256, '2019-04-15', 348, NULL),
('Hampton Inn', 256, '2019-04-16', 357, NULL),
('Hampton Inn', 256, '2019-04-17', 209, NULL),
('Hampton Inn', 256, '2019-04-18', 120, NULL),
('Hampton Inn', 256, '2019-04-19', 113, NULL),
('Hampton Inn', 256, '2019-04-20', 288, NULL),
('Hampton Inn', 256, '2019-04-21', 357, NULL),
('Hampton Inn', 256, '2019-04-22', 182, NULL),
('Hampton Inn', 256, '2019-04-23', 332, NULL),
('Hampton Inn', 256, '2019-04-24', 309, NULL),
('Hampton Inn', 256, '2019-04-25', 141, NULL),
('Hampton Inn', 256, '2019-04-26', 211, NULL),
('Hampton Inn', 256, '2019-04-27', 381, NULL),
('Hampton Inn', 256, '2019-04-28', 389, NULL),
('Hampton Inn', 256, '2019-04-29', 130, NULL),
('Hampton Inn', 256, '2019-04-30', 246, NULL),
('Hampton Inn', 256, '2019-05-01', 190, NULL),
('Hampton Inn', 256, '2019-05-02', 255, NULL),
('Hampton Inn', 256, '2019-05-03', 324, NULL),
('Hampton Inn', 256, '2019-05-04', 371, NULL),
('Hampton Inn', 256, '2019-05-05', 159, NULL),
('Hampton Inn', 256, '2019-05-06', 272, NULL),
('Hampton Inn', 256, '2019-05-07', 204, NULL),
('Hampton Inn', 256, '2019-05-08', 248, NULL),
('Hampton Inn', 256, '2019-05-09', 323, NULL),
('Hampton Inn', 256, '2019-05-10', 201, NULL),
('Hampton Inn', 256, '2019-05-11', 114, NULL),
('Hampton Inn', 256, '2019-05-12', 115, NULL),
('Hampton Inn', 256, '2019-05-13', 296, NULL),
('Hampton Inn', 256, '2019-05-14', 181, NULL),
('Hampton Inn', 256, '2019-05-15', 271, NULL),
('Hampton Inn', 256, '2019-05-16', 330, NULL),
('Hampton Inn', 256, '2019-05-17', 102, NULL),
('Hampton Inn', 256, '2019-05-18', 205, NULL),
('Hampton Inn', 256, '2019-05-19', 165, NULL),
('Hampton Inn', 256, '2019-05-20', 186, NULL),
('Hampton Inn', 256, '2019-05-21', 141, NULL),
('Hampton Inn', 256, '2019-05-22', 340, NULL),
('Hampton Inn', 256, '2019-05-23', 394, NULL),
('Hampton Inn', 256, '2019-05-24', 377, NULL),
('Hampton Inn', 256, '2019-05-25', 358, NULL),
('Hampton Inn', 256, '2019-05-26', 271, NULL),
('Hampton Inn', 256, '2019-05-27', 225, NULL),
('Hampton Inn', 256, '2019-05-28', 193, NULL),
('Hampton Inn', 256, '2019-05-29', 217, NULL),
('Hampton Inn', 256, '2019-05-30', 354, NULL),
('Hampton Inn', 256, '2019-05-31', 340, NULL),
('Hampton Inn', 256, '2019-06-01', 189, NULL),
('Hampton Inn', 256, '2019-06-02', 110, NULL),
('Hampton Inn', 256, '2019-06-03', 159, NULL),
('Hampton Inn', 256, '2019-06-04', 168, NULL),
('Hampton Inn', 256, '2019-06-05', 214, NULL),
('Hampton Inn', 256, '2019-06-06', 319, NULL),
('Hampton Inn', 256, '2019-06-07', 373, NULL),
('Hampton Inn', 256, '2019-06-08', 390, NULL),
('Hampton Inn', 256, '2019-06-09', 261, NULL),
('Hampton Inn', 256, '2019-06-10', 384, NULL),
('Hampton Inn', 256, '2019-06-11', 391, NULL),
('Hampton Inn', 256, '2019-06-12', 137, NULL),
('Hampton Inn', 256, '2019-06-13', 166, NULL),
('Hampton Inn', 256, '2019-06-14', 202, NULL),
('Hampton Inn', 256, '2019-06-15', 140, NULL),
('Hampton Inn', 256, '2019-06-16', 216, NULL),
('Hampton Inn', 256, '2019-06-17', 134, NULL),
('Hampton Inn', 256, '2019-06-18', 162, NULL),
('Hampton Inn', 256, '2019-06-19', 328, NULL),
('Hampton Inn', 256, '2019-06-20', 322, NULL),
('Hampton Inn', 256, '2019-06-21', 109, NULL),
('Hampton Inn', 256, '2019-06-22', 321, NULL),
('Hampton Inn', 256, '2019-06-23', 130, NULL),
('Hampton Inn', 256, '2019-06-24', 367, NULL),
('Hampton Inn', 256, '2019-06-25', 357, NULL),
('Hampton Inn', 256, '2019-06-26', 379, NULL),
('Hampton Inn', 256, '2019-06-27', 132, NULL),
('Hampton Inn', 256, '2019-06-28', 286, NULL),
('Hampton Inn', 256, '2019-06-29', 271, NULL),
('Hampton Inn', 256, '2019-06-30', 206, NULL),
('Hampton Inn', 256, '2019-07-01', 168, NULL),
('Hampton Inn', 256, '2019-07-02', 169, NULL),
('Hampton Inn', 256, '2019-07-03', 159, NULL),
('Hampton Inn', 256, '2019-07-04', 161, NULL),
('Hampton Inn', 256, '2019-07-05', 351, NULL),
('Hampton Inn', 256, '2019-07-06', 363, NULL),
('Hampton Inn', 256, '2019-07-07', 270, NULL),
('Hampton Inn', 256, '2019-07-08', 122, NULL),
('Hampton Inn', 256, '2019-07-09', 131, NULL),
('Hampton Inn', 256, '2019-07-10', 229, NULL),
('Hampton Inn', 256, '2019-07-11', 179, NULL),
('Hampton Inn', 256, '2019-07-12', 238, NULL),
('Hampton Inn', 256, '2019-07-13', 344, NULL),
('Hampton Inn', 256, '2019-07-14', 343, NULL),
('Hampton Inn', 256, '2019-07-15', 240, NULL),
('Hampton Inn', 256, '2019-07-16', 184, NULL),
('Hampton Inn', 256, '2019-07-17', 327, NULL),
('Hampton Inn', 256, '2019-07-18', 127, NULL),
('Hampton Inn', 256, '2019-07-19', 187, NULL),
('Hampton Inn', 256, '2019-07-20', 148, NULL),
('Hampton Inn', 256, '2019-07-21', 209, NULL),
('Hampton Inn', 256, '2019-07-22', 104, NULL),
('Hampton Inn', 256, '2019-07-23', 247, NULL),
('Hampton Inn', 256, '2019-07-24', 397, NULL),
('Hampton Inn', 256, '2019-07-25', 243, NULL),
('Hampton Inn', 256, '2019-07-26', 263, NULL),
('Hampton Inn', 256, '2019-07-27', 371, NULL),
('Hampton Inn', 256, '2019-07-28', 321, NULL),
('Hampton Inn', 256, '2019-07-29', 250, NULL),
('Hampton Inn', 256, '2019-07-30', 325, NULL),
('Hampton Inn', 256, '2019-07-31', 259, NULL),
('Hampton Inn', 256, '2019-08-01', 332, NULL),
('Hampton Inn', 256, '2019-08-02', 391, NULL),
('Hampton Inn', 256, '2019-08-03', 325, NULL),
('Hampton Inn', 256, '2019-08-04', 353, NULL),
('Hampton Inn', 256, '2019-08-05', 231, NULL),
('Hampton Inn', 256, '2019-08-06', 101, NULL),
('Hampton Inn', 256, '2019-08-07', 288, NULL),
('Hampton Inn', 256, '2019-08-08', 223, NULL),
('Hampton Inn', 256, '2019-08-09', 323, NULL),
('Hampton Inn', 256, '2019-08-10', 107, NULL),
('Hampton Inn', 256, '2019-08-11', 187, NULL),
('Hampton Inn', 256, '2019-08-12', 322, NULL),
('Hampton Inn', 256, '2019-08-13', 381, NULL),
('Hampton Inn', 256, '2019-08-14', 177, NULL),
('Hampton Inn', 256, '2019-08-15', 190, NULL),
('Hampton Inn', 256, '2019-08-16', 360, NULL),
('Hampton Inn', 256, '2019-08-17', 391, NULL),
('Hampton Inn', 256, '2019-08-18', 273, NULL),
('Hampton Inn', 256, '2019-08-19', 119, NULL),
('Hampton Inn', 256, '2019-08-20', 123, NULL),
('Hampton Inn', 256, '2019-08-21', 248, NULL),
('Hampton Inn', 256, '2019-08-22', 135, NULL),
('Hampton Inn', 256, '2019-08-23', 241, NULL),
('Hampton Inn', 256, '2019-08-24', 270, NULL),
('Hampton Inn', 256, '2019-08-25', 366, NULL),
('Hampton Inn', 256, '2019-08-26', 150, NULL),
('Hampton Inn', 256, '2019-08-27', 131, NULL),
('Hampton Inn', 256, '2019-08-28', 254, NULL),
('Hampton Inn', 256, '2019-08-29', 342, NULL),
('Hampton Inn', 256, '2019-08-30', 206, NULL),
('Hampton Inn', 256, '2019-08-31', 178, NULL),
('Hampton Inn', 256, '2019-09-01', 285, NULL),
('Hampton Inn', 256, '2019-09-02', 225, NULL),
('Hampton Inn', 256, '2019-09-03', 167, NULL),
('Hampton Inn', 256, '2019-09-04', 255, NULL),
('Hampton Inn', 256, '2019-09-05', 325, NULL),
('Hampton Inn', 256, '2019-09-06', 233, NULL),
('Hampton Inn', 256, '2019-09-07', 376, NULL),
('Hampton Inn', 256, '2019-09-08', 165, NULL),
('Hampton Inn', 256, '2019-09-09', 194, NULL),
('Hampton Inn', 256, '2019-09-10', 202, NULL),
('Hampton Inn', 256, '2019-09-11', 287, NULL),
('Hampton Inn', 256, '2019-09-12', 387, NULL),
('Hampton Inn', 256, '2019-09-13', 265, NULL),
('Hampton Inn', 256, '2019-09-14', 129, NULL),
('Hampton Inn', 256, '2019-09-15', 312, NULL),
('Hampton Inn', 256, '2019-09-16', 199, NULL),
('Hampton Inn', 256, '2019-09-17', 327, NULL),
('Hampton Inn', 256, '2019-09-18', 165, NULL),
('Hampton Inn', 256, '2019-09-19', 158, NULL),
('Hampton Inn', 256, '2019-09-20', 218, NULL),
('Hampton Inn', 256, '2019-09-21', 212, NULL),
('Hampton Inn', 256, '2019-09-22', 397, NULL),
('Hampton Inn', 256, '2019-09-23', 247, NULL),
('Hampton Inn', 256, '2019-09-24', 264, NULL),
('Hampton Inn', 256, '2019-09-25', 297, NULL),
('Hampton Inn', 256, '2019-09-26', 397, NULL),
('Hampton Inn', 256, '2019-09-27', 334, NULL),
('Hampton Inn', 256, '2019-09-28', 221, NULL),
('Hampton Inn', 256, '2019-09-29', 288, NULL),
('Hampton Inn', 256, '2019-09-30', 138, NULL),
('Hampton Inn', 256, '2019-10-01', 324, NULL),
('Hampton Inn', 256, '2019-10-02', 155, NULL),
('Hampton Inn', 256, '2019-10-03', 212, NULL),
('Hampton Inn', 256, '2019-10-04', 147, NULL),
('Hampton Inn', 256, '2019-10-05', 255, NULL),
('Hampton Inn', 256, '2019-10-06', 123, NULL),
('Hampton Inn', 256, '2019-10-07', 328, NULL),
('Hampton Inn', 256, '2019-10-08', 190, NULL),
('Hampton Inn', 256, '2019-10-09', 261, NULL),
('Hampton Inn', 256, '2019-10-10', 230, NULL),
('Hampton Inn', 256, '2019-10-11', 348, NULL),
('Hampton Inn', 256, '2019-10-12', 203, NULL),
('Hampton Inn', 256, '2019-10-13', 220, NULL),
('Hampton Inn', 256, '2019-10-14', 175, NULL),
('Hampton Inn', 256, '2019-10-15', 247, NULL),
('Hampton Inn', 256, '2019-10-16', 189, NULL),
('Hampton Inn', 256, '2019-10-17', 327, NULL),
('Hampton Inn', 256, '2019-10-18', 392, NULL),
('Hampton Inn', 256, '2019-10-19', 270, NULL),
('Hampton Inn', 256, '2019-10-20', 180, NULL),
('Hampton Inn', 256, '2019-10-21', 251, NULL),
('Hampton Inn', 256, '2019-10-22', 102, NULL),
('Hampton Inn', 256, '2019-10-23', 199, NULL),
('Hampton Inn', 256, '2019-10-24', 365, NULL),
('Hampton Inn', 256, '2019-10-25', 334, NULL),
('Hampton Inn', 256, '2019-10-26', 299, NULL),
('Hampton Inn', 256, '2019-10-27', 288, NULL),
('Hampton Inn', 256, '2019-10-28', 141, NULL),
('Hampton Inn', 256, '2019-10-29', 317, NULL),
('Hampton Inn', 256, '2019-10-30', 276, NULL),
('Hampton Inn', 256, '2019-10-31', 364, NULL),
('Hampton Inn', 256, '2019-11-01', 172, NULL),
('Hampton Inn', 256, '2019-11-02', 226, NULL),
('Hampton Inn', 256, '2019-11-03', 208, NULL),
('Hampton Inn', 256, '2019-11-04', 279, NULL),
('Hampton Inn', 256, '2019-11-05', 140, NULL),
('Hampton Inn', 256, '2019-11-06', 309, NULL),
('Hampton Inn', 256, '2019-11-07', 381, NULL),
('Hampton Inn', 256, '2019-11-08', 390, NULL),
('Hampton Inn', 256, '2019-11-09', 374, NULL),
('Hampton Inn', 256, '2019-11-10', 337, NULL),
('Hampton Inn', 256, '2019-11-11', 158, NULL),
('Hampton Inn', 256, '2019-11-12', 390, NULL),
('Hampton Inn', 256, '2019-11-13', 268, NULL),
('Hampton Inn', 256, '2019-11-14', 198, NULL),
('Hampton Inn', 256, '2019-11-15', 259, NULL),
('Hampton Inn', 256, '2019-11-16', 215, NULL),
('Hampton Inn', 256, '2019-11-17', 308, NULL),
('Hampton Inn', 256, '2019-11-18', 172, NULL),
('Hampton Inn', 256, '2019-11-19', 130, NULL),
('Hampton Inn', 256, '2019-11-20', 191, NULL),
('Hampton Inn', 256, '2019-11-21', 383, NULL),
('Hampton Inn', 256, '2019-11-22', 333, NULL),
('Hampton Inn', 256, '2019-11-23', 281, NULL),
('Hampton Inn', 256, '2019-11-24', 212, NULL),
('Hampton Inn', 256, '2019-11-25', 132, NULL),
('Hampton Inn', 256, '2019-11-26', 248, NULL),
('Hampton Inn', 256, '2019-11-27', 244, NULL),
('Hampton Inn', 256, '2019-11-28', 176, NULL),
('Hampton Inn', 256, '2019-11-29', 307, NULL),
('Hampton Inn', 256, '2019-11-30', 361, NULL),
('Hampton Inn', 256, '2019-12-01', 289, NULL),
('Hampton Inn', 256, '2019-12-02', 294, NULL),
('Hampton Inn', 256, '2019-12-03', 338, NULL),
('Hampton Inn', 256, '2019-12-04', 348, NULL),
('Hampton Inn', 256, '2019-12-05', 168, NULL),
('Hampton Inn', 256, '2019-12-06', 208, NULL),
('Hampton Inn', 256, '2019-12-07', 180, NULL),
('Hampton Inn', 256, '2019-12-08', 274, NULL),
('Hampton Inn', 256, '2019-12-09', 305, NULL),
('Hampton Inn', 256, '2019-12-10', 173, NULL),
('Hampton Inn', 256, '2019-12-11', 108, NULL),
('Hampton Inn', 256, '2019-12-12', 362, NULL),
('Hampton Inn', 256, '2019-12-13', 233, NULL),
('Hampton Inn', 256, '2019-12-14', 305, NULL),
('Hampton Inn', 256, '2019-12-15', 307, NULL),
('Hampton Inn', 256, '2019-12-16', 200, NULL),
('Hampton Inn', 256, '2019-12-17', 220, NULL),
('Hampton Inn', 256, '2019-12-18', 263, NULL),
('Hampton Inn', 256, '2019-12-19', 227, NULL),
('Hampton Inn', 256, '2019-12-20', 145, NULL),
('Hampton Inn', 256, '2019-12-21', 249, NULL),
('Hampton Inn', 256, '2019-12-22', 376, NULL),
('Hampton Inn', 256, '2019-12-23', 104, NULL),
('Hampton Inn', 256, '2019-12-24', 190, NULL),
('Hampton Inn', 256, '2019-12-25', 136, NULL),
('Hampton Inn', 256, '2019-12-26', 260, NULL),
('Hampton Inn', 256, '2019-12-27', 140, NULL),
('Hampton Inn', 256, '2019-12-28', 177, NULL),
('Hampton Inn', 256, '2019-12-29', 359, NULL),
('Hampton Inn', 256, '2019-12-30', 311, NULL),
('Hampton Inn', 256, '2019-12-31', 334, NULL),
('Hampton Inn', 256, '2020-01-01', 134, NULL),
('Hampton Inn', 256, '2020-01-02', 353, NULL),
('Hampton Inn', 256, '2020-01-03', 144, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 256, '2020-01-04', 235, NULL),
('Hampton Inn', 256, '2020-01-05', 353, NULL),
('Hampton Inn', 256, '2020-01-06', 155, NULL),
('Hampton Inn', 256, '2020-01-07', 291, NULL),
('Hampton Inn', 256, '2020-01-08', 273, NULL),
('Hampton Inn', 256, '2020-01-09', 378, NULL),
('Hampton Inn', 256, '2020-01-10', 385, NULL),
('Hampton Inn', 256, '2020-01-11', 356, NULL),
('Hampton Inn', 256, '2020-01-12', 165, NULL),
('Hampton Inn', 256, '2020-01-13', 364, NULL),
('Hampton Inn', 256, '2020-01-14', 139, NULL),
('Hampton Inn', 256, '2020-01-15', 284, NULL),
('Hampton Inn', 256, '2020-01-16', 259, NULL),
('Hampton Inn', 256, '2020-01-17', 169, NULL),
('Hampton Inn', 256, '2020-01-18', 141, NULL),
('Hampton Inn', 256, '2020-01-19', 140, NULL),
('Hampton Inn', 256, '2020-01-20', 253, NULL),
('Hampton Inn', 256, '2020-01-21', 140, NULL),
('Hampton Inn', 256, '2020-01-22', 193, NULL),
('Hampton Inn', 256, '2020-01-23', 348, NULL),
('Hampton Inn', 256, '2020-01-24', 274, NULL),
('Hampton Inn', 256, '2020-01-25', 204, NULL),
('Hampton Inn', 256, '2020-01-26', 305, NULL),
('Hampton Inn', 256, '2020-01-27', 184, NULL),
('Hampton Inn', 256, '2020-01-28', 349, NULL),
('Hampton Inn', 256, '2020-01-29', 167, NULL),
('Hampton Inn', 256, '2020-01-30', 258, NULL),
('Hampton Inn', 256, '2020-01-31', 284, NULL),
('Hampton Inn', 256, '2020-02-01', 345, NULL),
('Hampton Inn', 256, '2020-02-02', 119, NULL),
('Hampton Inn', 256, '2020-02-03', 286, NULL),
('Hampton Inn', 256, '2020-02-04', 378, NULL),
('Hampton Inn', 267, '2019-01-01', 277, NULL),
('Hampton Inn', 267, '2019-01-02', 271, NULL),
('Hampton Inn', 267, '2019-01-03', 238, NULL),
('Hampton Inn', 267, '2019-01-04', 219, NULL),
('Hampton Inn', 267, '2019-01-05', 192, NULL),
('Hampton Inn', 267, '2019-01-06', 233, NULL),
('Hampton Inn', 267, '2019-01-07', 341, NULL),
('Hampton Inn', 267, '2019-01-08', 282, NULL),
('Hampton Inn', 267, '2019-01-09', 164, NULL),
('Hampton Inn', 267, '2019-01-10', 377, NULL),
('Hampton Inn', 267, '2019-01-11', 147, NULL),
('Hampton Inn', 267, '2019-01-12', 194, NULL),
('Hampton Inn', 267, '2019-01-13', 332, NULL),
('Hampton Inn', 267, '2019-01-14', 396, NULL),
('Hampton Inn', 267, '2019-01-15', 215, NULL),
('Hampton Inn', 267, '2019-01-16', 391, NULL),
('Hampton Inn', 267, '2019-01-17', 218, NULL),
('Hampton Inn', 267, '2019-01-18', 165, NULL),
('Hampton Inn', 267, '2019-01-19', 194, NULL),
('Hampton Inn', 267, '2019-01-20', 120, NULL),
('Hampton Inn', 267, '2019-01-21', 150, NULL),
('Hampton Inn', 267, '2019-01-22', 318, NULL),
('Hampton Inn', 267, '2019-01-23', 239, NULL),
('Hampton Inn', 267, '2019-01-24', 189, NULL),
('Hampton Inn', 267, '2019-01-25', 364, NULL),
('Hampton Inn', 267, '2019-01-26', 147, NULL),
('Hampton Inn', 267, '2019-01-27', 103, NULL),
('Hampton Inn', 267, '2019-01-28', 372, NULL),
('Hampton Inn', 267, '2019-01-29', 157, NULL),
('Hampton Inn', 267, '2019-01-30', 340, NULL),
('Hampton Inn', 267, '2019-01-31', 157, NULL),
('Hampton Inn', 267, '2019-02-01', 170, NULL),
('Hampton Inn', 267, '2019-02-02', 298, NULL),
('Hampton Inn', 267, '2019-02-03', 308, NULL),
('Hampton Inn', 267, '2019-02-04', 262, NULL),
('Hampton Inn', 267, '2019-02-05', 390, NULL),
('Hampton Inn', 267, '2019-02-06', 220, NULL),
('Hampton Inn', 267, '2019-02-07', 139, NULL),
('Hampton Inn', 267, '2019-02-08', 233, NULL),
('Hampton Inn', 267, '2019-02-09', 173, NULL),
('Hampton Inn', 267, '2019-02-10', 290, NULL),
('Hampton Inn', 267, '2019-02-11', 276, NULL),
('Hampton Inn', 267, '2019-02-12', 361, NULL),
('Hampton Inn', 267, '2019-02-13', 286, NULL),
('Hampton Inn', 267, '2019-02-14', 326, NULL),
('Hampton Inn', 267, '2019-02-15', 111, NULL),
('Hampton Inn', 267, '2019-02-16', 149, NULL),
('Hampton Inn', 267, '2019-02-17', 367, NULL),
('Hampton Inn', 267, '2019-02-18', 294, NULL),
('Hampton Inn', 267, '2019-02-19', 155, NULL),
('Hampton Inn', 267, '2019-02-20', 234, NULL),
('Hampton Inn', 267, '2019-02-21', 280, NULL),
('Hampton Inn', 267, '2019-02-22', 252, NULL),
('Hampton Inn', 267, '2019-02-23', 366, NULL),
('Hampton Inn', 267, '2019-02-24', 169, NULL),
('Hampton Inn', 267, '2019-02-25', 386, NULL),
('Hampton Inn', 267, '2019-02-26', 162, NULL),
('Hampton Inn', 267, '2019-02-27', 101, NULL),
('Hampton Inn', 267, '2019-02-28', 218, NULL),
('Hampton Inn', 267, '2019-03-01', 121, NULL),
('Hampton Inn', 267, '2019-03-02', 260, NULL),
('Hampton Inn', 267, '2019-03-03', 211, NULL),
('Hampton Inn', 267, '2019-03-04', 391, NULL),
('Hampton Inn', 267, '2019-03-05', 119, NULL),
('Hampton Inn', 267, '2019-03-06', 381, NULL),
('Hampton Inn', 267, '2019-03-07', 245, NULL),
('Hampton Inn', 267, '2019-03-08', 200, NULL),
('Hampton Inn', 267, '2019-03-09', 269, NULL),
('Hampton Inn', 267, '2019-03-10', 152, NULL),
('Hampton Inn', 267, '2019-03-11', 321, NULL),
('Hampton Inn', 267, '2019-03-12', 336, NULL),
('Hampton Inn', 267, '2019-03-13', 389, NULL),
('Hampton Inn', 267, '2019-03-14', 293, NULL),
('Hampton Inn', 267, '2019-03-15', 192, NULL),
('Hampton Inn', 267, '2019-03-16', 244, NULL),
('Hampton Inn', 267, '2019-03-17', 200, NULL),
('Hampton Inn', 267, '2019-03-18', 164, NULL),
('Hampton Inn', 267, '2019-03-19', 309, NULL),
('Hampton Inn', 267, '2019-03-20', 391, NULL),
('Hampton Inn', 267, '2019-03-21', 333, NULL),
('Hampton Inn', 267, '2019-03-22', 330, NULL),
('Hampton Inn', 267, '2019-03-23', 334, NULL),
('Hampton Inn', 267, '2019-03-24', 156, NULL),
('Hampton Inn', 267, '2019-03-25', 126, NULL),
('Hampton Inn', 267, '2019-03-26', 374, NULL),
('Hampton Inn', 267, '2019-03-27', 379, NULL),
('Hampton Inn', 267, '2019-03-28', 231, NULL),
('Hampton Inn', 267, '2019-03-29', 112, NULL),
('Hampton Inn', 267, '2019-03-30', 138, NULL),
('Hampton Inn', 267, '2019-03-31', 142, NULL),
('Hampton Inn', 267, '2019-04-01', 372, NULL),
('Hampton Inn', 267, '2019-04-02', 259, NULL),
('Hampton Inn', 267, '2019-04-03', 373, NULL),
('Hampton Inn', 267, '2019-04-04', 259, NULL),
('Hampton Inn', 267, '2019-04-05', 289, NULL),
('Hampton Inn', 267, '2019-04-06', 147, NULL),
('Hampton Inn', 267, '2019-04-07', 282, NULL),
('Hampton Inn', 267, '2019-04-08', 253, NULL),
('Hampton Inn', 267, '2019-04-09', 328, NULL),
('Hampton Inn', 267, '2019-04-10', 270, NULL),
('Hampton Inn', 267, '2019-04-11', 280, NULL),
('Hampton Inn', 267, '2019-04-12', 210, NULL),
('Hampton Inn', 267, '2019-04-13', 271, NULL),
('Hampton Inn', 267, '2019-04-14', 380, NULL),
('Hampton Inn', 267, '2019-04-15', 371, NULL),
('Hampton Inn', 267, '2019-04-16', 262, NULL),
('Hampton Inn', 267, '2019-04-17', 300, NULL),
('Hampton Inn', 267, '2019-04-18', 292, NULL),
('Hampton Inn', 267, '2019-04-19', 189, NULL),
('Hampton Inn', 267, '2019-04-20', 139, NULL),
('Hampton Inn', 267, '2019-04-21', 370, NULL),
('Hampton Inn', 267, '2019-04-22', 369, NULL),
('Hampton Inn', 267, '2019-04-23', 167, NULL),
('Hampton Inn', 267, '2019-04-24', 294, NULL),
('Hampton Inn', 267, '2019-04-25', 243, NULL),
('Hampton Inn', 267, '2019-04-26', 148, NULL),
('Hampton Inn', 267, '2019-04-27', 354, NULL),
('Hampton Inn', 267, '2019-04-28', 359, NULL),
('Hampton Inn', 267, '2019-04-29', 341, NULL),
('Hampton Inn', 267, '2019-04-30', 378, NULL),
('Hampton Inn', 267, '2019-05-01', 282, NULL),
('Hampton Inn', 267, '2019-05-02', 266, NULL),
('Hampton Inn', 267, '2019-05-03', 198, NULL),
('Hampton Inn', 267, '2019-05-04', 259, NULL),
('Hampton Inn', 267, '2019-05-05', 188, NULL),
('Hampton Inn', 267, '2019-05-06', 378, NULL),
('Hampton Inn', 267, '2019-05-07', 383, NULL),
('Hampton Inn', 267, '2019-05-08', 236, NULL),
('Hampton Inn', 267, '2019-05-09', 365, NULL),
('Hampton Inn', 267, '2019-05-10', 203, NULL),
('Hampton Inn', 267, '2019-05-11', 247, NULL),
('Hampton Inn', 267, '2019-05-12', 326, NULL),
('Hampton Inn', 267, '2019-05-13', 170, NULL),
('Hampton Inn', 267, '2019-05-14', 252, NULL),
('Hampton Inn', 267, '2019-05-15', 219, NULL),
('Hampton Inn', 267, '2019-05-16', 385, NULL),
('Hampton Inn', 267, '2019-05-17', 177, NULL),
('Hampton Inn', 267, '2019-05-18', 176, NULL),
('Hampton Inn', 267, '2019-05-19', 245, NULL),
('Hampton Inn', 267, '2019-05-20', 204, NULL),
('Hampton Inn', 267, '2019-05-21', 304, NULL),
('Hampton Inn', 267, '2019-05-22', 225, NULL),
('Hampton Inn', 267, '2019-05-23', 286, NULL),
('Hampton Inn', 267, '2019-05-24', 224, NULL),
('Hampton Inn', 267, '2019-05-25', 201, NULL),
('Hampton Inn', 267, '2019-05-26', 140, NULL),
('Hampton Inn', 267, '2019-05-27', 310, NULL),
('Hampton Inn', 267, '2019-05-28', 227, NULL),
('Hampton Inn', 267, '2019-05-29', 104, NULL),
('Hampton Inn', 267, '2019-05-30', 223, NULL),
('Hampton Inn', 267, '2019-05-31', 130, NULL),
('Hampton Inn', 267, '2019-06-01', 315, NULL),
('Hampton Inn', 267, '2019-06-02', 180, NULL),
('Hampton Inn', 267, '2019-06-03', 356, NULL),
('Hampton Inn', 267, '2019-06-04', 105, NULL),
('Hampton Inn', 267, '2019-06-05', 300, NULL),
('Hampton Inn', 267, '2019-06-06', 173, NULL),
('Hampton Inn', 267, '2019-06-07', 385, NULL),
('Hampton Inn', 267, '2019-06-08', 319, NULL),
('Hampton Inn', 267, '2019-06-09', 232, NULL),
('Hampton Inn', 267, '2019-06-10', 200, NULL),
('Hampton Inn', 267, '2019-06-11', 273, NULL),
('Hampton Inn', 267, '2019-06-12', 226, NULL),
('Hampton Inn', 267, '2019-06-13', 363, NULL),
('Hampton Inn', 267, '2019-06-14', 122, NULL),
('Hampton Inn', 267, '2019-06-15', 100, NULL),
('Hampton Inn', 267, '2019-06-16', 198, NULL),
('Hampton Inn', 267, '2019-06-17', 176, NULL),
('Hampton Inn', 267, '2019-06-18', 229, NULL),
('Hampton Inn', 267, '2019-06-19', 125, NULL),
('Hampton Inn', 267, '2019-06-20', 347, NULL),
('Hampton Inn', 267, '2019-06-21', 155, NULL),
('Hampton Inn', 267, '2019-06-22', 166, NULL),
('Hampton Inn', 267, '2019-06-23', 207, NULL),
('Hampton Inn', 267, '2019-06-24', 230, NULL),
('Hampton Inn', 267, '2019-06-25', 391, NULL),
('Hampton Inn', 267, '2019-06-26', 214, NULL),
('Hampton Inn', 267, '2019-06-27', 264, NULL),
('Hampton Inn', 267, '2019-06-28', 104, NULL),
('Hampton Inn', 267, '2019-06-29', 133, NULL),
('Hampton Inn', 267, '2019-06-30', 395, NULL),
('Hampton Inn', 267, '2019-07-01', 366, NULL),
('Hampton Inn', 267, '2019-07-02', 253, NULL),
('Hampton Inn', 267, '2019-07-03', 340, NULL),
('Hampton Inn', 267, '2019-07-04', 351, NULL),
('Hampton Inn', 267, '2019-07-05', 202, NULL),
('Hampton Inn', 267, '2019-07-06', 321, NULL),
('Hampton Inn', 267, '2019-07-07', 196, NULL),
('Hampton Inn', 267, '2019-07-08', 239, NULL),
('Hampton Inn', 267, '2019-07-09', 120, NULL),
('Hampton Inn', 267, '2019-07-10', 266, NULL),
('Hampton Inn', 267, '2019-07-11', 352, NULL),
('Hampton Inn', 267, '2019-07-12', 306, NULL),
('Hampton Inn', 267, '2019-07-13', 374, NULL),
('Hampton Inn', 267, '2019-07-14', 129, NULL),
('Hampton Inn', 267, '2019-07-15', 313, NULL),
('Hampton Inn', 267, '2019-07-16', 209, NULL),
('Hampton Inn', 267, '2019-07-17', 205, NULL),
('Hampton Inn', 267, '2019-07-18', 265, NULL),
('Hampton Inn', 267, '2019-07-19', 108, NULL),
('Hampton Inn', 267, '2019-07-20', 308, NULL),
('Hampton Inn', 267, '2019-07-21', 158, NULL),
('Hampton Inn', 267, '2019-07-22', 397, NULL),
('Hampton Inn', 267, '2019-07-23', 278, NULL),
('Hampton Inn', 267, '2019-07-24', 300, NULL),
('Hampton Inn', 267, '2019-07-25', 105, NULL),
('Hampton Inn', 267, '2019-07-26', 139, NULL),
('Hampton Inn', 267, '2019-07-27', 263, NULL),
('Hampton Inn', 267, '2019-07-28', 114, NULL),
('Hampton Inn', 267, '2019-07-29', 181, NULL),
('Hampton Inn', 267, '2019-07-30', 183, NULL),
('Hampton Inn', 267, '2019-07-31', 346, NULL),
('Hampton Inn', 267, '2019-08-01', 245, NULL),
('Hampton Inn', 267, '2019-08-02', 184, NULL),
('Hampton Inn', 267, '2019-08-03', 394, NULL),
('Hampton Inn', 267, '2019-08-04', 311, NULL),
('Hampton Inn', 267, '2019-08-05', 193, NULL),
('Hampton Inn', 267, '2019-08-06', 330, NULL),
('Hampton Inn', 267, '2019-08-07', 223, NULL),
('Hampton Inn', 267, '2019-08-08', 149, NULL),
('Hampton Inn', 267, '2019-08-09', 121, NULL),
('Hampton Inn', 267, '2019-08-10', 129, NULL),
('Hampton Inn', 267, '2019-08-11', 384, NULL),
('Hampton Inn', 267, '2019-08-12', 117, NULL),
('Hampton Inn', 267, '2019-08-13', 322, NULL),
('Hampton Inn', 267, '2019-08-14', 347, NULL),
('Hampton Inn', 267, '2019-08-15', 229, NULL),
('Hampton Inn', 267, '2019-08-16', 238, NULL),
('Hampton Inn', 267, '2019-08-17', 322, NULL),
('Hampton Inn', 267, '2019-08-18', 210, NULL),
('Hampton Inn', 267, '2019-08-19', 333, NULL),
('Hampton Inn', 267, '2019-08-20', 328, NULL),
('Hampton Inn', 267, '2019-08-21', 282, NULL),
('Hampton Inn', 267, '2019-08-22', 240, NULL),
('Hampton Inn', 267, '2019-08-23', 224, NULL),
('Hampton Inn', 267, '2019-08-24', 346, NULL),
('Hampton Inn', 267, '2019-08-25', 384, NULL),
('Hampton Inn', 267, '2019-08-26', 391, NULL),
('Hampton Inn', 267, '2019-08-27', 318, NULL),
('Hampton Inn', 267, '2019-08-28', 155, NULL),
('Hampton Inn', 267, '2019-08-29', 276, NULL),
('Hampton Inn', 267, '2019-08-30', 157, NULL),
('Hampton Inn', 267, '2019-08-31', 196, NULL),
('Hampton Inn', 267, '2019-09-01', 399, NULL),
('Hampton Inn', 267, '2019-09-02', 272, NULL),
('Hampton Inn', 267, '2019-09-03', 304, NULL),
('Hampton Inn', 267, '2019-09-04', 359, NULL),
('Hampton Inn', 267, '2019-09-05', 273, NULL),
('Hampton Inn', 267, '2019-09-06', 242, NULL),
('Hampton Inn', 267, '2019-09-07', 355, NULL),
('Hampton Inn', 267, '2019-09-08', 288, NULL),
('Hampton Inn', 267, '2019-09-09', 310, NULL),
('Hampton Inn', 267, '2019-09-10', 178, NULL),
('Hampton Inn', 267, '2019-09-11', 395, NULL),
('Hampton Inn', 267, '2019-09-12', 178, NULL),
('Hampton Inn', 267, '2019-09-13', 207, NULL),
('Hampton Inn', 267, '2019-09-14', 226, NULL),
('Hampton Inn', 267, '2019-09-15', 238, NULL),
('Hampton Inn', 267, '2019-09-16', 378, NULL),
('Hampton Inn', 267, '2019-09-17', 314, NULL),
('Hampton Inn', 267, '2019-09-18', 290, NULL),
('Hampton Inn', 267, '2019-09-19', 319, NULL),
('Hampton Inn', 267, '2019-09-20', 254, NULL),
('Hampton Inn', 267, '2019-09-21', 295, NULL),
('Hampton Inn', 267, '2019-09-22', 384, NULL),
('Hampton Inn', 267, '2019-09-23', 112, NULL),
('Hampton Inn', 267, '2019-09-24', 266, NULL),
('Hampton Inn', 267, '2019-09-25', 102, NULL),
('Hampton Inn', 267, '2019-09-26', 115, NULL),
('Hampton Inn', 267, '2019-09-27', 319, NULL),
('Hampton Inn', 267, '2019-09-28', 117, NULL),
('Hampton Inn', 267, '2019-09-29', 237, NULL),
('Hampton Inn', 267, '2019-09-30', 129, NULL),
('Hampton Inn', 267, '2019-10-01', 157, NULL),
('Hampton Inn', 267, '2019-10-02', 153, NULL),
('Hampton Inn', 267, '2019-10-03', 308, NULL),
('Hampton Inn', 267, '2019-10-04', 131, NULL),
('Hampton Inn', 267, '2019-10-05', 329, NULL),
('Hampton Inn', 267, '2019-10-06', 348, NULL),
('Hampton Inn', 267, '2019-10-07', 121, NULL),
('Hampton Inn', 267, '2019-10-08', 351, NULL),
('Hampton Inn', 267, '2019-10-09', 346, NULL),
('Hampton Inn', 267, '2019-10-10', 194, NULL),
('Hampton Inn', 267, '2019-10-11', 164, NULL),
('Hampton Inn', 267, '2019-10-12', 216, NULL),
('Hampton Inn', 267, '2019-10-13', 299, NULL),
('Hampton Inn', 267, '2019-10-14', 176, NULL),
('Hampton Inn', 267, '2019-10-15', 198, NULL),
('Hampton Inn', 267, '2019-10-16', 298, NULL),
('Hampton Inn', 267, '2019-10-17', 262, NULL),
('Hampton Inn', 267, '2019-10-18', 334, NULL),
('Hampton Inn', 267, '2019-10-19', 215, NULL),
('Hampton Inn', 267, '2019-10-20', 320, NULL),
('Hampton Inn', 267, '2019-10-21', 322, NULL),
('Hampton Inn', 267, '2019-10-22', 330, NULL),
('Hampton Inn', 267, '2019-10-23', 330, NULL),
('Hampton Inn', 267, '2019-10-24', 107, NULL),
('Hampton Inn', 267, '2019-10-25', 334, NULL),
('Hampton Inn', 267, '2019-10-26', 224, NULL),
('Hampton Inn', 267, '2019-10-27', 255, NULL),
('Hampton Inn', 267, '2019-10-28', 113, NULL),
('Hampton Inn', 267, '2019-10-29', 399, NULL),
('Hampton Inn', 267, '2019-10-30', 106, NULL),
('Hampton Inn', 267, '2019-10-31', 330, NULL),
('Hampton Inn', 267, '2019-11-01', 237, NULL),
('Hampton Inn', 267, '2019-11-02', 373, NULL),
('Hampton Inn', 267, '2019-11-03', 394, NULL),
('Hampton Inn', 267, '2019-11-04', 309, NULL),
('Hampton Inn', 267, '2019-11-05', 390, NULL),
('Hampton Inn', 267, '2019-11-06', 206, NULL),
('Hampton Inn', 267, '2019-11-07', 147, NULL),
('Hampton Inn', 267, '2019-11-08', 127, NULL),
('Hampton Inn', 267, '2019-11-09', 372, NULL),
('Hampton Inn', 267, '2019-11-10', 160, NULL),
('Hampton Inn', 267, '2019-11-11', 293, NULL),
('Hampton Inn', 267, '2019-11-12', 194, NULL),
('Hampton Inn', 267, '2019-11-13', 212, NULL),
('Hampton Inn', 267, '2019-11-14', 290, NULL),
('Hampton Inn', 267, '2019-11-15', 156, NULL),
('Hampton Inn', 267, '2019-11-16', 173, NULL),
('Hampton Inn', 267, '2019-11-17', 263, NULL),
('Hampton Inn', 267, '2019-11-18', 259, NULL),
('Hampton Inn', 267, '2019-11-19', 163, NULL),
('Hampton Inn', 267, '2019-11-20', 216, NULL),
('Hampton Inn', 267, '2019-11-21', 279, NULL),
('Hampton Inn', 267, '2019-11-22', 266, NULL),
('Hampton Inn', 267, '2019-11-23', 279, NULL),
('Hampton Inn', 267, '2019-11-24', 268, NULL),
('Hampton Inn', 267, '2019-11-25', 155, NULL),
('Hampton Inn', 267, '2019-11-26', 294, NULL),
('Hampton Inn', 267, '2019-11-27', 113, NULL),
('Hampton Inn', 267, '2019-11-28', 395, NULL),
('Hampton Inn', 267, '2019-11-29', 331, NULL),
('Hampton Inn', 267, '2019-11-30', 369, NULL),
('Hampton Inn', 267, '2019-12-01', 125, NULL),
('Hampton Inn', 267, '2019-12-02', 187, NULL),
('Hampton Inn', 267, '2019-12-03', 174, NULL),
('Hampton Inn', 267, '2019-12-04', 115, NULL),
('Hampton Inn', 267, '2019-12-05', 199, NULL),
('Hampton Inn', 267, '2019-12-06', 183, NULL),
('Hampton Inn', 267, '2019-12-07', 236, NULL),
('Hampton Inn', 267, '2019-12-08', 233, NULL),
('Hampton Inn', 267, '2019-12-09', 334, NULL),
('Hampton Inn', 267, '2019-12-10', 273, NULL),
('Hampton Inn', 267, '2019-12-11', 154, NULL),
('Hampton Inn', 267, '2019-12-12', 354, NULL),
('Hampton Inn', 267, '2019-12-13', 194, NULL),
('Hampton Inn', 267, '2019-12-14', 128, NULL),
('Hampton Inn', 267, '2019-12-15', 137, NULL),
('Hampton Inn', 267, '2019-12-16', 380, NULL),
('Hampton Inn', 267, '2019-12-17', 141, NULL),
('Hampton Inn', 267, '2019-12-18', 182, NULL),
('Hampton Inn', 267, '2019-12-19', 265, NULL),
('Hampton Inn', 267, '2019-12-20', 196, NULL),
('Hampton Inn', 267, '2019-12-21', 327, NULL),
('Hampton Inn', 267, '2019-12-22', 268, NULL),
('Hampton Inn', 267, '2019-12-23', 302, NULL),
('Hampton Inn', 267, '2019-12-24', 339, NULL),
('Hampton Inn', 267, '2019-12-25', 362, NULL),
('Hampton Inn', 267, '2019-12-26', 221, NULL),
('Hampton Inn', 267, '2019-12-27', 197, NULL),
('Hampton Inn', 267, '2019-12-28', 125, NULL),
('Hampton Inn', 267, '2019-12-29', 333, NULL),
('Hampton Inn', 267, '2019-12-30', 397, NULL),
('Hampton Inn', 267, '2019-12-31', 162, NULL),
('Hampton Inn', 267, '2020-01-01', 294, NULL),
('Hampton Inn', 267, '2020-01-02', 155, NULL),
('Hampton Inn', 267, '2020-01-03', 325, NULL),
('Hampton Inn', 267, '2020-01-04', 311, NULL),
('Hampton Inn', 267, '2020-01-05', 154, NULL),
('Hampton Inn', 267, '2020-01-06', 274, NULL),
('Hampton Inn', 267, '2020-01-07', 218, NULL),
('Hampton Inn', 267, '2020-01-08', 102, NULL),
('Hampton Inn', 267, '2020-01-09', 337, NULL),
('Hampton Inn', 267, '2020-01-10', 123, NULL),
('Hampton Inn', 267, '2020-01-11', 276, NULL),
('Hampton Inn', 267, '2020-01-12', 107, NULL),
('Hampton Inn', 267, '2020-01-13', 156, NULL),
('Hampton Inn', 267, '2020-01-14', 214, NULL),
('Hampton Inn', 267, '2020-01-15', 190, NULL),
('Hampton Inn', 267, '2020-01-16', 384, NULL),
('Hampton Inn', 267, '2020-01-17', 101, NULL),
('Hampton Inn', 267, '2020-01-18', 177, NULL),
('Hampton Inn', 267, '2020-01-19', 325, NULL),
('Hampton Inn', 267, '2020-01-20', 176, NULL),
('Hampton Inn', 267, '2020-01-21', 156, NULL),
('Hampton Inn', 267, '2020-01-22', 318, NULL),
('Hampton Inn', 267, '2020-01-23', 377, NULL),
('Hampton Inn', 267, '2020-01-24', 295, NULL),
('Hampton Inn', 267, '2020-01-25', 243, NULL),
('Hampton Inn', 267, '2020-01-26', 124, NULL),
('Hampton Inn', 267, '2020-01-27', 191, NULL),
('Hampton Inn', 267, '2020-01-28', 350, NULL),
('Hampton Inn', 267, '2020-01-29', 395, NULL),
('Hampton Inn', 267, '2020-01-30', 141, NULL),
('Hampton Inn', 267, '2020-01-31', 200, NULL),
('Hampton Inn', 267, '2020-02-01', 203, NULL),
('Hampton Inn', 267, '2020-02-02', 193, NULL),
('Hampton Inn', 267, '2020-02-03', 289, NULL),
('Hampton Inn', 267, '2020-02-04', 367, NULL),
('Hampton Inn', 270, '2019-01-01', 229, NULL),
('Hampton Inn', 270, '2019-01-02', 230, NULL),
('Hampton Inn', 270, '2019-01-03', 181, NULL),
('Hampton Inn', 270, '2019-01-04', 225, NULL),
('Hampton Inn', 270, '2019-01-05', 373, NULL),
('Hampton Inn', 270, '2019-01-06', 107, NULL),
('Hampton Inn', 270, '2019-01-07', 180, NULL),
('Hampton Inn', 270, '2019-01-08', 315, NULL),
('Hampton Inn', 270, '2019-01-09', 235, NULL),
('Hampton Inn', 270, '2019-01-10', 161, NULL),
('Hampton Inn', 270, '2019-01-11', 283, NULL),
('Hampton Inn', 270, '2019-01-12', 120, NULL),
('Hampton Inn', 270, '2019-01-13', 271, NULL),
('Hampton Inn', 270, '2019-01-14', 324, NULL),
('Hampton Inn', 270, '2019-01-15', 285, NULL),
('Hampton Inn', 270, '2019-01-16', 235, NULL),
('Hampton Inn', 270, '2019-01-17', 107, NULL),
('Hampton Inn', 270, '2019-01-18', 396, NULL),
('Hampton Inn', 270, '2019-01-19', 379, NULL),
('Hampton Inn', 270, '2019-01-20', 110, NULL),
('Hampton Inn', 270, '2019-01-21', 324, NULL),
('Hampton Inn', 270, '2019-01-22', 105, NULL),
('Hampton Inn', 270, '2019-01-23', 213, NULL),
('Hampton Inn', 270, '2019-01-24', 194, NULL),
('Hampton Inn', 270, '2019-01-25', 352, NULL),
('Hampton Inn', 270, '2019-01-26', 224, NULL),
('Hampton Inn', 270, '2019-01-27', 330, NULL),
('Hampton Inn', 270, '2019-01-28', 174, NULL),
('Hampton Inn', 270, '2019-01-29', 207, NULL),
('Hampton Inn', 270, '2019-01-30', 284, NULL),
('Hampton Inn', 270, '2019-01-31', 162, NULL),
('Hampton Inn', 270, '2019-02-01', 368, NULL),
('Hampton Inn', 270, '2019-02-02', 361, NULL),
('Hampton Inn', 270, '2019-02-03', 171, NULL),
('Hampton Inn', 270, '2019-02-04', 235, NULL),
('Hampton Inn', 270, '2019-02-05', 261, NULL),
('Hampton Inn', 270, '2019-02-06', 305, NULL),
('Hampton Inn', 270, '2019-02-07', 248, NULL),
('Hampton Inn', 270, '2019-02-08', 280, NULL),
('Hampton Inn', 270, '2019-02-09', 226, NULL),
('Hampton Inn', 270, '2019-02-10', 173, NULL),
('Hampton Inn', 270, '2019-02-11', 208, NULL),
('Hampton Inn', 270, '2019-02-12', 223, NULL),
('Hampton Inn', 270, '2019-02-13', 345, NULL),
('Hampton Inn', 270, '2019-02-14', 178, NULL),
('Hampton Inn', 270, '2019-02-15', 377, NULL),
('Hampton Inn', 270, '2019-02-16', 314, NULL),
('Hampton Inn', 270, '2019-02-17', 181, NULL),
('Hampton Inn', 270, '2019-02-18', 139, NULL),
('Hampton Inn', 270, '2019-02-19', 196, NULL),
('Hampton Inn', 270, '2019-02-20', 231, NULL),
('Hampton Inn', 270, '2019-02-21', 291, NULL),
('Hampton Inn', 270, '2019-02-22', 263, NULL),
('Hampton Inn', 270, '2019-02-23', 191, NULL),
('Hampton Inn', 270, '2019-02-24', 322, NULL),
('Hampton Inn', 270, '2019-02-25', 282, NULL),
('Hampton Inn', 270, '2019-02-26', 345, NULL),
('Hampton Inn', 270, '2019-02-27', 170, NULL),
('Hampton Inn', 270, '2019-02-28', 356, NULL),
('Hampton Inn', 270, '2019-03-01', 286, NULL),
('Hampton Inn', 270, '2019-03-02', 172, NULL),
('Hampton Inn', 270, '2019-03-03', 192, NULL),
('Hampton Inn', 270, '2019-03-04', 170, NULL),
('Hampton Inn', 270, '2019-03-05', 310, NULL),
('Hampton Inn', 270, '2019-03-06', 351, NULL),
('Hampton Inn', 270, '2019-03-07', 179, NULL),
('Hampton Inn', 270, '2019-03-08', 257, NULL),
('Hampton Inn', 270, '2019-03-09', 320, NULL),
('Hampton Inn', 270, '2019-03-10', 118, NULL),
('Hampton Inn', 270, '2019-03-11', 308, NULL),
('Hampton Inn', 270, '2019-03-12', 111, NULL),
('Hampton Inn', 270, '2019-03-13', 285, NULL),
('Hampton Inn', 270, '2019-03-14', 207, NULL),
('Hampton Inn', 270, '2019-03-15', 216, NULL),
('Hampton Inn', 270, '2019-03-16', 116, NULL),
('Hampton Inn', 270, '2019-03-17', 270, NULL),
('Hampton Inn', 270, '2019-03-18', 299, NULL),
('Hampton Inn', 270, '2019-03-19', 327, NULL),
('Hampton Inn', 270, '2019-03-20', 305, NULL),
('Hampton Inn', 270, '2019-03-21', 102, NULL),
('Hampton Inn', 270, '2019-03-22', 293, NULL),
('Hampton Inn', 270, '2019-03-23', 170, NULL),
('Hampton Inn', 270, '2019-03-24', 277, NULL),
('Hampton Inn', 270, '2019-03-25', 390, NULL),
('Hampton Inn', 270, '2019-03-26', 235, NULL),
('Hampton Inn', 270, '2019-03-27', 208, NULL),
('Hampton Inn', 270, '2019-03-28', 278, NULL),
('Hampton Inn', 270, '2019-03-29', 372, NULL),
('Hampton Inn', 270, '2019-03-30', 260, NULL),
('Hampton Inn', 270, '2019-03-31', 201, NULL),
('Hampton Inn', 270, '2019-04-01', 345, NULL),
('Hampton Inn', 270, '2019-04-02', 263, NULL),
('Hampton Inn', 270, '2019-04-03', 237, NULL),
('Hampton Inn', 270, '2019-04-04', 114, NULL),
('Hampton Inn', 270, '2019-04-05', 334, NULL),
('Hampton Inn', 270, '2019-04-06', 117, NULL),
('Hampton Inn', 270, '2019-04-07', 387, NULL),
('Hampton Inn', 270, '2019-04-08', 229, NULL),
('Hampton Inn', 270, '2019-04-09', 227, NULL),
('Hampton Inn', 270, '2019-04-10', 293, NULL),
('Hampton Inn', 270, '2019-04-11', 189, NULL),
('Hampton Inn', 270, '2019-04-12', 164, NULL),
('Hampton Inn', 270, '2019-04-13', 181, NULL),
('Hampton Inn', 270, '2019-04-14', 272, NULL),
('Hampton Inn', 270, '2019-04-15', 109, NULL),
('Hampton Inn', 270, '2019-04-16', 139, NULL),
('Hampton Inn', 270, '2019-04-17', 174, NULL),
('Hampton Inn', 270, '2019-04-18', 102, NULL),
('Hampton Inn', 270, '2019-04-19', 203, NULL),
('Hampton Inn', 270, '2019-04-20', 328, NULL),
('Hampton Inn', 270, '2019-04-21', 379, NULL),
('Hampton Inn', 270, '2019-04-22', 300, NULL),
('Hampton Inn', 270, '2019-04-23', 341, NULL),
('Hampton Inn', 270, '2019-04-24', 140, NULL),
('Hampton Inn', 270, '2019-04-25', 393, NULL),
('Hampton Inn', 270, '2019-04-26', 307, NULL),
('Hampton Inn', 270, '2019-04-27', 229, NULL),
('Hampton Inn', 270, '2019-04-28', 231, NULL),
('Hampton Inn', 270, '2019-04-29', 316, NULL),
('Hampton Inn', 270, '2019-04-30', 154, NULL),
('Hampton Inn', 270, '2019-05-01', 139, NULL),
('Hampton Inn', 270, '2019-05-02', 168, NULL),
('Hampton Inn', 270, '2019-05-03', 217, NULL),
('Hampton Inn', 270, '2019-05-04', 384, NULL),
('Hampton Inn', 270, '2019-05-05', 364, NULL),
('Hampton Inn', 270, '2019-05-06', 377, NULL),
('Hampton Inn', 270, '2019-05-07', 304, NULL),
('Hampton Inn', 270, '2019-05-08', 339, NULL),
('Hampton Inn', 270, '2019-05-09', 157, NULL),
('Hampton Inn', 270, '2019-05-10', 315, NULL),
('Hampton Inn', 270, '2019-05-11', 196, NULL),
('Hampton Inn', 270, '2019-05-12', 287, NULL),
('Hampton Inn', 270, '2019-05-13', 163, NULL),
('Hampton Inn', 270, '2019-05-14', 318, NULL),
('Hampton Inn', 270, '2019-05-15', 181, NULL),
('Hampton Inn', 270, '2019-05-16', 234, NULL),
('Hampton Inn', 270, '2019-05-17', 180, NULL),
('Hampton Inn', 270, '2019-05-18', 167, NULL),
('Hampton Inn', 270, '2019-05-19', 330, NULL),
('Hampton Inn', 270, '2019-05-20', 363, NULL),
('Hampton Inn', 270, '2019-05-21', 395, NULL),
('Hampton Inn', 270, '2019-05-22', 307, NULL),
('Hampton Inn', 270, '2019-05-23', 149, NULL),
('Hampton Inn', 270, '2019-05-24', 188, NULL),
('Hampton Inn', 270, '2019-05-25', 130, NULL),
('Hampton Inn', 270, '2019-05-26', 388, NULL),
('Hampton Inn', 270, '2019-05-27', 178, NULL),
('Hampton Inn', 270, '2019-05-28', 158, NULL),
('Hampton Inn', 270, '2019-05-29', 369, NULL),
('Hampton Inn', 270, '2019-05-30', 252, NULL),
('Hampton Inn', 270, '2019-05-31', 131, NULL),
('Hampton Inn', 270, '2019-06-01', 308, NULL),
('Hampton Inn', 270, '2019-06-02', 170, NULL),
('Hampton Inn', 270, '2019-06-03', 301, NULL),
('Hampton Inn', 270, '2019-06-04', 222, NULL),
('Hampton Inn', 270, '2019-06-05', 156, NULL),
('Hampton Inn', 270, '2019-06-06', 106, NULL),
('Hampton Inn', 270, '2019-06-07', 106, NULL),
('Hampton Inn', 270, '2019-06-08', 329, NULL),
('Hampton Inn', 270, '2019-06-09', 274, NULL),
('Hampton Inn', 270, '2019-06-10', 347, NULL),
('Hampton Inn', 270, '2019-06-11', 392, NULL),
('Hampton Inn', 270, '2019-06-12', 317, NULL),
('Hampton Inn', 270, '2019-06-13', 316, NULL),
('Hampton Inn', 270, '2019-06-14', 205, NULL),
('Hampton Inn', 270, '2019-06-15', 283, NULL),
('Hampton Inn', 270, '2019-06-16', 243, NULL),
('Hampton Inn', 270, '2019-06-17', 381, NULL),
('Hampton Inn', 270, '2019-06-18', 261, NULL),
('Hampton Inn', 270, '2019-06-19', 144, NULL),
('Hampton Inn', 270, '2019-06-20', 372, NULL),
('Hampton Inn', 270, '2019-06-21', 347, NULL),
('Hampton Inn', 270, '2019-06-22', 369, NULL),
('Hampton Inn', 270, '2019-06-23', 243, NULL),
('Hampton Inn', 270, '2019-06-24', 250, NULL),
('Hampton Inn', 270, '2019-06-25', 184, NULL),
('Hampton Inn', 270, '2019-06-26', 137, NULL),
('Hampton Inn', 270, '2019-06-27', 223, NULL),
('Hampton Inn', 270, '2019-06-28', 162, NULL),
('Hampton Inn', 270, '2019-06-29', 352, NULL),
('Hampton Inn', 270, '2019-06-30', 360, NULL),
('Hampton Inn', 270, '2019-07-01', 326, NULL),
('Hampton Inn', 270, '2019-07-02', 361, NULL),
('Hampton Inn', 270, '2019-07-03', 226, NULL),
('Hampton Inn', 270, '2019-07-04', 273, NULL),
('Hampton Inn', 270, '2019-07-05', 155, NULL),
('Hampton Inn', 270, '2019-07-06', 118, NULL),
('Hampton Inn', 270, '2019-07-07', 368, NULL),
('Hampton Inn', 270, '2019-07-08', 132, NULL),
('Hampton Inn', 270, '2019-07-09', 109, NULL),
('Hampton Inn', 270, '2019-07-10', 246, NULL),
('Hampton Inn', 270, '2019-07-11', 226, NULL),
('Hampton Inn', 270, '2019-07-12', 115, NULL),
('Hampton Inn', 270, '2019-07-13', 139, NULL),
('Hampton Inn', 270, '2019-07-14', 116, NULL),
('Hampton Inn', 270, '2019-07-15', 147, NULL),
('Hampton Inn', 270, '2019-07-16', 393, NULL),
('Hampton Inn', 270, '2019-07-17', 243, NULL),
('Hampton Inn', 270, '2019-07-18', 245, NULL),
('Hampton Inn', 270, '2019-07-19', 177, NULL),
('Hampton Inn', 270, '2019-07-20', 398, NULL),
('Hampton Inn', 270, '2019-07-21', 364, NULL),
('Hampton Inn', 270, '2019-07-22', 372, NULL),
('Hampton Inn', 270, '2019-07-23', 248, NULL),
('Hampton Inn', 270, '2019-07-24', 211, NULL),
('Hampton Inn', 270, '2019-07-25', 299, NULL),
('Hampton Inn', 270, '2019-07-26', 107, NULL),
('Hampton Inn', 270, '2019-07-27', 103, NULL),
('Hampton Inn', 270, '2019-07-28', 105, NULL),
('Hampton Inn', 270, '2019-07-29', 357, NULL),
('Hampton Inn', 270, '2019-07-30', 143, NULL),
('Hampton Inn', 270, '2019-07-31', 256, NULL),
('Hampton Inn', 270, '2019-08-01', 131, NULL),
('Hampton Inn', 270, '2019-08-02', 248, NULL),
('Hampton Inn', 270, '2019-08-03', 293, NULL),
('Hampton Inn', 270, '2019-08-04', 396, NULL),
('Hampton Inn', 270, '2019-08-05', 174, NULL),
('Hampton Inn', 270, '2019-08-06', 346, NULL),
('Hampton Inn', 270, '2019-08-07', 155, NULL),
('Hampton Inn', 270, '2019-08-08', 277, NULL),
('Hampton Inn', 270, '2019-08-09', 136, NULL),
('Hampton Inn', 270, '2019-08-10', 224, NULL),
('Hampton Inn', 270, '2019-08-11', 357, NULL),
('Hampton Inn', 270, '2019-08-12', 121, NULL),
('Hampton Inn', 270, '2019-08-13', 368, NULL),
('Hampton Inn', 270, '2019-08-14', 206, NULL),
('Hampton Inn', 270, '2019-08-15', 174, NULL),
('Hampton Inn', 270, '2019-08-16', 312, NULL),
('Hampton Inn', 270, '2019-08-17', 340, NULL),
('Hampton Inn', 270, '2019-08-18', 130, NULL),
('Hampton Inn', 270, '2019-08-19', 309, NULL),
('Hampton Inn', 270, '2019-08-20', 269, NULL),
('Hampton Inn', 270, '2019-08-21', 268, NULL),
('Hampton Inn', 270, '2019-08-22', 394, NULL),
('Hampton Inn', 270, '2019-08-23', 295, NULL),
('Hampton Inn', 270, '2019-08-24', 223, NULL),
('Hampton Inn', 270, '2019-08-25', 119, NULL),
('Hampton Inn', 270, '2019-08-26', 203, NULL),
('Hampton Inn', 270, '2019-08-27', 195, NULL),
('Hampton Inn', 270, '2019-08-28', 214, NULL),
('Hampton Inn', 270, '2019-08-29', 256, NULL),
('Hampton Inn', 270, '2019-08-30', 366, NULL),
('Hampton Inn', 270, '2019-08-31', 345, NULL),
('Hampton Inn', 270, '2019-09-01', 140, NULL),
('Hampton Inn', 270, '2019-09-02', 286, NULL),
('Hampton Inn', 270, '2019-09-03', 320, NULL),
('Hampton Inn', 270, '2019-09-04', 328, NULL),
('Hampton Inn', 270, '2019-09-05', 290, NULL),
('Hampton Inn', 270, '2019-09-06', 109, NULL),
('Hampton Inn', 270, '2019-09-07', 250, NULL),
('Hampton Inn', 270, '2019-09-08', 247, NULL),
('Hampton Inn', 270, '2019-09-09', 265, NULL),
('Hampton Inn', 270, '2019-09-10', 183, NULL),
('Hampton Inn', 270, '2019-09-11', 114, NULL),
('Hampton Inn', 270, '2019-09-12', 229, NULL),
('Hampton Inn', 270, '2019-09-13', 142, NULL),
('Hampton Inn', 270, '2019-09-14', 343, NULL),
('Hampton Inn', 270, '2019-09-15', 154, NULL),
('Hampton Inn', 270, '2019-09-16', 294, NULL),
('Hampton Inn', 270, '2019-09-17', 191, NULL),
('Hampton Inn', 270, '2019-09-18', 254, NULL),
('Hampton Inn', 270, '2019-09-19', 123, NULL),
('Hampton Inn', 270, '2019-09-20', 213, NULL),
('Hampton Inn', 270, '2019-09-21', 141, NULL),
('Hampton Inn', 270, '2019-09-22', 327, NULL),
('Hampton Inn', 270, '2019-09-23', 321, NULL),
('Hampton Inn', 270, '2019-09-24', 141, NULL),
('Hampton Inn', 270, '2019-09-25', 119, NULL),
('Hampton Inn', 270, '2019-09-26', 185, NULL),
('Hampton Inn', 270, '2019-09-27', 195, NULL),
('Hampton Inn', 270, '2019-09-28', 121, NULL),
('Hampton Inn', 270, '2019-09-29', 221, NULL),
('Hampton Inn', 270, '2019-09-30', 129, NULL),
('Hampton Inn', 270, '2019-10-01', 314, NULL),
('Hampton Inn', 270, '2019-10-02', 198, NULL),
('Hampton Inn', 270, '2019-10-03', 203, NULL),
('Hampton Inn', 270, '2019-10-04', 112, NULL),
('Hampton Inn', 270, '2019-10-05', 178, NULL),
('Hampton Inn', 270, '2019-10-06', 373, NULL),
('Hampton Inn', 270, '2019-10-07', 120, NULL),
('Hampton Inn', 270, '2019-10-08', 188, NULL),
('Hampton Inn', 270, '2019-10-09', 248, NULL),
('Hampton Inn', 270, '2019-10-10', 182, NULL),
('Hampton Inn', 270, '2019-10-11', 279, NULL),
('Hampton Inn', 270, '2019-10-12', 371, NULL),
('Hampton Inn', 270, '2019-10-13', 135, NULL),
('Hampton Inn', 270, '2019-10-14', 252, NULL),
('Hampton Inn', 270, '2019-10-15', 147, NULL),
('Hampton Inn', 270, '2019-10-16', 227, NULL),
('Hampton Inn', 270, '2019-10-17', 226, NULL),
('Hampton Inn', 270, '2019-10-18', 392, NULL),
('Hampton Inn', 270, '2019-10-19', 163, NULL),
('Hampton Inn', 270, '2019-10-20', 363, NULL),
('Hampton Inn', 270, '2019-10-21', 155, NULL),
('Hampton Inn', 270, '2019-10-22', 343, NULL),
('Hampton Inn', 270, '2019-10-23', 350, NULL),
('Hampton Inn', 270, '2019-10-24', 243, NULL),
('Hampton Inn', 270, '2019-10-25', 269, NULL),
('Hampton Inn', 270, '2019-10-26', 125, NULL),
('Hampton Inn', 270, '2019-10-27', 310, NULL),
('Hampton Inn', 270, '2019-10-28', 344, NULL),
('Hampton Inn', 270, '2019-10-29', 344, NULL),
('Hampton Inn', 270, '2019-10-30', 203, NULL),
('Hampton Inn', 270, '2019-10-31', 158, NULL),
('Hampton Inn', 270, '2019-11-01', 269, NULL),
('Hampton Inn', 270, '2019-11-02', 189, NULL),
('Hampton Inn', 270, '2019-11-03', 344, NULL),
('Hampton Inn', 270, '2019-11-04', 311, NULL),
('Hampton Inn', 270, '2019-11-05', 228, NULL),
('Hampton Inn', 270, '2019-11-06', 301, NULL),
('Hampton Inn', 270, '2019-11-07', 391, NULL),
('Hampton Inn', 270, '2019-11-08', 265, NULL),
('Hampton Inn', 270, '2019-11-09', 339, NULL),
('Hampton Inn', 270, '2019-11-10', 292, NULL),
('Hampton Inn', 270, '2019-11-11', 294, NULL),
('Hampton Inn', 270, '2019-11-12', 301, NULL),
('Hampton Inn', 270, '2019-11-13', 155, NULL),
('Hampton Inn', 270, '2019-11-14', 155, NULL),
('Hampton Inn', 270, '2019-11-15', 203, NULL),
('Hampton Inn', 270, '2019-11-16', 123, NULL),
('Hampton Inn', 270, '2019-11-17', 292, NULL),
('Hampton Inn', 270, '2019-11-18', 379, NULL),
('Hampton Inn', 270, '2019-11-19', 324, NULL),
('Hampton Inn', 270, '2019-11-20', 109, NULL),
('Hampton Inn', 270, '2019-11-21', 146, NULL),
('Hampton Inn', 270, '2019-11-22', 231, NULL),
('Hampton Inn', 270, '2019-11-23', 152, NULL),
('Hampton Inn', 270, '2019-11-24', 306, NULL),
('Hampton Inn', 270, '2019-11-25', 283, NULL),
('Hampton Inn', 270, '2019-11-26', 328, NULL),
('Hampton Inn', 270, '2019-11-27', 337, NULL),
('Hampton Inn', 270, '2019-11-28', 149, NULL),
('Hampton Inn', 270, '2019-11-29', 334, NULL),
('Hampton Inn', 270, '2019-11-30', 363, NULL),
('Hampton Inn', 270, '2019-12-01', 260, NULL),
('Hampton Inn', 270, '2019-12-02', 252, NULL),
('Hampton Inn', 270, '2019-12-03', 358, NULL),
('Hampton Inn', 270, '2019-12-04', 332, NULL),
('Hampton Inn', 270, '2019-12-05', 391, NULL),
('Hampton Inn', 270, '2019-12-06', 191, NULL),
('Hampton Inn', 270, '2019-12-07', 243, NULL),
('Hampton Inn', 270, '2019-12-08', 243, NULL),
('Hampton Inn', 270, '2019-12-09', 354, NULL),
('Hampton Inn', 270, '2019-12-10', 146, NULL),
('Hampton Inn', 270, '2019-12-11', 344, NULL),
('Hampton Inn', 270, '2019-12-12', 281, NULL),
('Hampton Inn', 270, '2019-12-13', 172, NULL),
('Hampton Inn', 270, '2019-12-14', 226, NULL),
('Hampton Inn', 270, '2019-12-15', 262, NULL),
('Hampton Inn', 270, '2019-12-16', 301, NULL),
('Hampton Inn', 270, '2019-12-17', 248, NULL),
('Hampton Inn', 270, '2019-12-18', 320, NULL),
('Hampton Inn', 270, '2019-12-19', 243, NULL),
('Hampton Inn', 270, '2019-12-20', 148, NULL),
('Hampton Inn', 270, '2019-12-21', 190, NULL),
('Hampton Inn', 270, '2019-12-22', 112, NULL),
('Hampton Inn', 270, '2019-12-23', 196, NULL),
('Hampton Inn', 270, '2019-12-24', 128, NULL),
('Hampton Inn', 270, '2019-12-25', 102, NULL),
('Hampton Inn', 270, '2019-12-26', 224, NULL),
('Hampton Inn', 270, '2019-12-27', 164, NULL),
('Hampton Inn', 270, '2019-12-28', 296, NULL),
('Hampton Inn', 270, '2019-12-29', 192, NULL),
('Hampton Inn', 270, '2019-12-30', 349, NULL),
('Hampton Inn', 270, '2019-12-31', 310, NULL),
('Hampton Inn', 270, '2020-01-01', 367, NULL),
('Hampton Inn', 270, '2020-01-02', 216, NULL),
('Hampton Inn', 270, '2020-01-03', 194, NULL),
('Hampton Inn', 270, '2020-01-04', 151, NULL),
('Hampton Inn', 270, '2020-01-05', 212, NULL),
('Hampton Inn', 270, '2020-01-06', 208, NULL),
('Hampton Inn', 270, '2020-01-07', 116, NULL),
('Hampton Inn', 270, '2020-01-08', 193, NULL),
('Hampton Inn', 270, '2020-01-09', 151, NULL),
('Hampton Inn', 270, '2020-01-10', 259, NULL),
('Hampton Inn', 270, '2020-01-11', 211, NULL),
('Hampton Inn', 270, '2020-01-12', 240, NULL),
('Hampton Inn', 270, '2020-01-13', 188, NULL),
('Hampton Inn', 270, '2020-01-14', 253, NULL),
('Hampton Inn', 270, '2020-01-15', 301, NULL),
('Hampton Inn', 270, '2020-01-16', 143, NULL),
('Hampton Inn', 270, '2020-01-17', 200, NULL),
('Hampton Inn', 270, '2020-01-18', 361, NULL),
('Hampton Inn', 270, '2020-01-19', 204, NULL),
('Hampton Inn', 270, '2020-01-20', 322, NULL),
('Hampton Inn', 270, '2020-01-21', 260, NULL),
('Hampton Inn', 270, '2020-01-22', 310, NULL),
('Hampton Inn', 270, '2020-01-23', 139, NULL),
('Hampton Inn', 270, '2020-01-24', 253, NULL),
('Hampton Inn', 270, '2020-01-25', 203, NULL),
('Hampton Inn', 270, '2020-01-26', 206, NULL),
('Hampton Inn', 270, '2020-01-27', 303, NULL),
('Hampton Inn', 270, '2020-01-28', 307, NULL),
('Hampton Inn', 270, '2020-01-29', 173, NULL),
('Hampton Inn', 270, '2020-01-30', 134, NULL),
('Hampton Inn', 270, '2020-01-31', 350, NULL),
('Hampton Inn', 270, '2020-02-01', 179, NULL),
('Hampton Inn', 270, '2020-02-02', 209, NULL),
('Hampton Inn', 270, '2020-02-03', 188, NULL),
('Hampton Inn', 270, '2020-02-04', 302, NULL),
('Hampton Inn', 288, '2019-01-01', 215, NULL),
('Hampton Inn', 288, '2019-01-02', 238, NULL),
('Hampton Inn', 288, '2019-01-03', 394, NULL),
('Hampton Inn', 288, '2019-01-04', 370, NULL),
('Hampton Inn', 288, '2019-01-05', 289, NULL),
('Hampton Inn', 288, '2019-01-06', 337, NULL),
('Hampton Inn', 288, '2019-01-07', 379, NULL),
('Hampton Inn', 288, '2019-01-08', 331, NULL),
('Hampton Inn', 288, '2019-01-09', 283, NULL),
('Hampton Inn', 288, '2019-01-10', 177, NULL),
('Hampton Inn', 288, '2019-01-11', 277, NULL),
('Hampton Inn', 288, '2019-01-12', 219, NULL),
('Hampton Inn', 288, '2019-01-13', 258, NULL),
('Hampton Inn', 288, '2019-01-14', 331, NULL),
('Hampton Inn', 288, '2019-01-15', 379, NULL),
('Hampton Inn', 288, '2019-01-16', 203, NULL),
('Hampton Inn', 288, '2019-01-17', 381, NULL),
('Hampton Inn', 288, '2019-01-18', 185, NULL),
('Hampton Inn', 288, '2019-01-19', 313, NULL),
('Hampton Inn', 288, '2019-01-20', 390, NULL),
('Hampton Inn', 288, '2019-01-21', 167, NULL),
('Hampton Inn', 288, '2019-01-22', 372, NULL),
('Hampton Inn', 288, '2019-01-23', 248, NULL),
('Hampton Inn', 288, '2019-01-24', 304, NULL),
('Hampton Inn', 288, '2019-01-25', 267, NULL),
('Hampton Inn', 288, '2019-01-26', 278, NULL),
('Hampton Inn', 288, '2019-01-27', 338, NULL),
('Hampton Inn', 288, '2019-01-28', 258, NULL),
('Hampton Inn', 288, '2019-01-29', 165, NULL),
('Hampton Inn', 288, '2019-01-30', 300, NULL),
('Hampton Inn', 288, '2019-01-31', 240, NULL),
('Hampton Inn', 288, '2019-02-01', 328, NULL),
('Hampton Inn', 288, '2019-02-02', 210, NULL),
('Hampton Inn', 288, '2019-02-03', 131, NULL),
('Hampton Inn', 288, '2019-02-04', 287, NULL),
('Hampton Inn', 288, '2019-02-05', 337, NULL),
('Hampton Inn', 288, '2019-02-06', 164, NULL),
('Hampton Inn', 288, '2019-02-07', 123, NULL),
('Hampton Inn', 288, '2019-02-08', 300, NULL),
('Hampton Inn', 288, '2019-02-09', 209, NULL),
('Hampton Inn', 288, '2019-02-10', 194, NULL),
('Hampton Inn', 288, '2019-02-11', 116, NULL),
('Hampton Inn', 288, '2019-02-12', 235, NULL),
('Hampton Inn', 288, '2019-02-13', 167, NULL),
('Hampton Inn', 288, '2019-02-14', 112, NULL),
('Hampton Inn', 288, '2019-02-15', 250, NULL),
('Hampton Inn', 288, '2019-02-16', 125, NULL),
('Hampton Inn', 288, '2019-02-17', 305, NULL),
('Hampton Inn', 288, '2019-02-18', 313, NULL),
('Hampton Inn', 288, '2019-02-19', 118, NULL),
('Hampton Inn', 288, '2019-02-20', 354, NULL),
('Hampton Inn', 288, '2019-02-21', 216, NULL),
('Hampton Inn', 288, '2019-02-22', 161, NULL),
('Hampton Inn', 288, '2019-02-23', 356, NULL),
('Hampton Inn', 288, '2019-02-24', 102, NULL),
('Hampton Inn', 288, '2019-02-25', 155, NULL),
('Hampton Inn', 288, '2019-02-26', 238, NULL),
('Hampton Inn', 288, '2019-02-27', 151, NULL),
('Hampton Inn', 288, '2019-02-28', 126, NULL),
('Hampton Inn', 288, '2019-03-01', 365, NULL),
('Hampton Inn', 288, '2019-03-02', 282, NULL),
('Hampton Inn', 288, '2019-03-03', 229, NULL),
('Hampton Inn', 288, '2019-03-04', 178, NULL),
('Hampton Inn', 288, '2019-03-05', 190, NULL),
('Hampton Inn', 288, '2019-03-06', 213, NULL),
('Hampton Inn', 288, '2019-03-07', 362, NULL),
('Hampton Inn', 288, '2019-03-08', 285, NULL),
('Hampton Inn', 288, '2019-03-09', 391, NULL),
('Hampton Inn', 288, '2019-03-10', 337, NULL),
('Hampton Inn', 288, '2019-03-11', 177, NULL),
('Hampton Inn', 288, '2019-03-12', 346, NULL),
('Hampton Inn', 288, '2019-03-13', 158, NULL),
('Hampton Inn', 288, '2019-03-14', 357, NULL),
('Hampton Inn', 288, '2019-03-15', 103, NULL),
('Hampton Inn', 288, '2019-03-16', 347, NULL),
('Hampton Inn', 288, '2019-03-17', 351, NULL),
('Hampton Inn', 288, '2019-03-18', 300, NULL),
('Hampton Inn', 288, '2019-03-19', 309, NULL),
('Hampton Inn', 288, '2019-03-20', 252, NULL),
('Hampton Inn', 288, '2019-03-21', 313, NULL),
('Hampton Inn', 288, '2019-03-22', 374, NULL),
('Hampton Inn', 288, '2019-03-23', 348, NULL),
('Hampton Inn', 288, '2019-03-24', 217, NULL),
('Hampton Inn', 288, '2019-03-25', 274, NULL),
('Hampton Inn', 288, '2019-03-26', 252, NULL),
('Hampton Inn', 288, '2019-03-27', 104, NULL),
('Hampton Inn', 288, '2019-03-28', 298, NULL),
('Hampton Inn', 288, '2019-03-29', 225, NULL),
('Hampton Inn', 288, '2019-03-30', 184, NULL),
('Hampton Inn', 288, '2019-03-31', 178, NULL),
('Hampton Inn', 288, '2019-04-01', 207, NULL),
('Hampton Inn', 288, '2019-04-02', 137, NULL),
('Hampton Inn', 288, '2019-04-03', 268, NULL),
('Hampton Inn', 288, '2019-04-04', 296, NULL),
('Hampton Inn', 288, '2019-04-05', 105, NULL),
('Hampton Inn', 288, '2019-04-06', 346, NULL),
('Hampton Inn', 288, '2019-04-07', 389, NULL),
('Hampton Inn', 288, '2019-04-08', 287, NULL),
('Hampton Inn', 288, '2019-04-09', 352, NULL),
('Hampton Inn', 288, '2019-04-10', 257, NULL),
('Hampton Inn', 288, '2019-04-11', 305, NULL),
('Hampton Inn', 288, '2019-04-12', 393, NULL),
('Hampton Inn', 288, '2019-04-13', 296, NULL),
('Hampton Inn', 288, '2019-04-14', 121, NULL),
('Hampton Inn', 288, '2019-04-15', 232, NULL),
('Hampton Inn', 288, '2019-04-16', 111, NULL),
('Hampton Inn', 288, '2019-04-17', 171, NULL),
('Hampton Inn', 288, '2019-04-18', 132, NULL),
('Hampton Inn', 288, '2019-04-19', 350, NULL),
('Hampton Inn', 288, '2019-04-20', 226, NULL),
('Hampton Inn', 288, '2019-04-21', 383, NULL),
('Hampton Inn', 288, '2019-04-22', 291, NULL),
('Hampton Inn', 288, '2019-04-23', 205, NULL),
('Hampton Inn', 288, '2019-04-24', 321, NULL),
('Hampton Inn', 288, '2019-04-25', 235, NULL),
('Hampton Inn', 288, '2019-04-26', 393, NULL),
('Hampton Inn', 288, '2019-04-27', 283, NULL),
('Hampton Inn', 288, '2019-04-28', 276, NULL),
('Hampton Inn', 288, '2019-04-29', 158, NULL),
('Hampton Inn', 288, '2019-04-30', 137, NULL),
('Hampton Inn', 288, '2019-05-01', 349, NULL),
('Hampton Inn', 288, '2019-05-02', 240, NULL),
('Hampton Inn', 288, '2019-05-03', 390, NULL),
('Hampton Inn', 288, '2019-05-04', 145, NULL),
('Hampton Inn', 288, '2019-05-05', 254, NULL),
('Hampton Inn', 288, '2019-05-06', 351, NULL),
('Hampton Inn', 288, '2019-05-07', 272, NULL),
('Hampton Inn', 288, '2019-05-08', 288, NULL),
('Hampton Inn', 288, '2019-05-09', 193, NULL),
('Hampton Inn', 288, '2019-05-10', 265, NULL),
('Hampton Inn', 288, '2019-05-11', 137, NULL),
('Hampton Inn', 288, '2019-05-12', 358, NULL),
('Hampton Inn', 288, '2019-05-13', 204, NULL),
('Hampton Inn', 288, '2019-05-14', 133, NULL),
('Hampton Inn', 288, '2019-05-15', 147, NULL),
('Hampton Inn', 288, '2019-05-16', 215, NULL),
('Hampton Inn', 288, '2019-05-17', 267, NULL),
('Hampton Inn', 288, '2019-05-18', 205, NULL),
('Hampton Inn', 288, '2019-05-19', 218, NULL),
('Hampton Inn', 288, '2019-05-20', 206, NULL),
('Hampton Inn', 288, '2019-05-21', 365, NULL),
('Hampton Inn', 288, '2019-05-22', 157, NULL),
('Hampton Inn', 288, '2019-05-23', 387, NULL),
('Hampton Inn', 288, '2019-05-24', 171, NULL),
('Hampton Inn', 288, '2019-05-25', 250, NULL),
('Hampton Inn', 288, '2019-05-26', 220, NULL),
('Hampton Inn', 288, '2019-05-27', 160, NULL),
('Hampton Inn', 288, '2019-05-28', 312, NULL),
('Hampton Inn', 288, '2019-05-29', 233, NULL),
('Hampton Inn', 288, '2019-05-30', 193, NULL),
('Hampton Inn', 288, '2019-05-31', 168, NULL),
('Hampton Inn', 288, '2019-06-01', 198, NULL),
('Hampton Inn', 288, '2019-06-02', 209, NULL),
('Hampton Inn', 288, '2019-06-03', 337, NULL),
('Hampton Inn', 288, '2019-06-04', 396, NULL),
('Hampton Inn', 288, '2019-06-05', 381, NULL),
('Hampton Inn', 288, '2019-06-06', 215, NULL),
('Hampton Inn', 288, '2019-06-07', 178, NULL),
('Hampton Inn', 288, '2019-06-08', 287, NULL),
('Hampton Inn', 288, '2019-06-09', 277, NULL),
('Hampton Inn', 288, '2019-06-10', 138, NULL),
('Hampton Inn', 288, '2019-06-11', 140, NULL),
('Hampton Inn', 288, '2019-06-12', 207, NULL),
('Hampton Inn', 288, '2019-06-13', 394, NULL),
('Hampton Inn', 288, '2019-06-14', 257, NULL),
('Hampton Inn', 288, '2019-06-15', 117, NULL),
('Hampton Inn', 288, '2019-06-16', 220, NULL),
('Hampton Inn', 288, '2019-06-17', 377, NULL),
('Hampton Inn', 288, '2019-06-18', 216, NULL),
('Hampton Inn', 288, '2019-06-19', 247, NULL),
('Hampton Inn', 288, '2019-06-20', 118, NULL),
('Hampton Inn', 288, '2019-06-21', 272, NULL),
('Hampton Inn', 288, '2019-06-22', 345, NULL),
('Hampton Inn', 288, '2019-06-23', 197, NULL),
('Hampton Inn', 288, '2019-06-24', 160, NULL),
('Hampton Inn', 288, '2019-06-25', 248, NULL),
('Hampton Inn', 288, '2019-06-26', 240, NULL),
('Hampton Inn', 288, '2019-06-27', 225, NULL),
('Hampton Inn', 288, '2019-06-28', 399, NULL),
('Hampton Inn', 288, '2019-06-29', 363, NULL),
('Hampton Inn', 288, '2019-06-30', 215, NULL),
('Hampton Inn', 288, '2019-07-01', 131, NULL),
('Hampton Inn', 288, '2019-07-02', 347, NULL),
('Hampton Inn', 288, '2019-07-03', 308, NULL),
('Hampton Inn', 288, '2019-07-04', 215, NULL),
('Hampton Inn', 288, '2019-07-05', 372, NULL),
('Hampton Inn', 288, '2019-07-06', 126, NULL),
('Hampton Inn', 288, '2019-07-07', 254, NULL),
('Hampton Inn', 288, '2019-07-08', 144, NULL),
('Hampton Inn', 288, '2019-07-09', 385, NULL),
('Hampton Inn', 288, '2019-07-10', 333, NULL),
('Hampton Inn', 288, '2019-07-11', 272, NULL),
('Hampton Inn', 288, '2019-07-12', 158, NULL),
('Hampton Inn', 288, '2019-07-13', 373, NULL),
('Hampton Inn', 288, '2019-07-14', 395, NULL),
('Hampton Inn', 288, '2019-07-15', 293, NULL),
('Hampton Inn', 288, '2019-07-16', 339, NULL),
('Hampton Inn', 288, '2019-07-17', 202, NULL),
('Hampton Inn', 288, '2019-07-18', 330, NULL),
('Hampton Inn', 288, '2019-07-19', 164, NULL),
('Hampton Inn', 288, '2019-07-20', 366, NULL),
('Hampton Inn', 288, '2019-07-21', 346, NULL),
('Hampton Inn', 288, '2019-07-22', 268, NULL),
('Hampton Inn', 288, '2019-07-23', 308, NULL),
('Hampton Inn', 288, '2019-07-24', 352, NULL),
('Hampton Inn', 288, '2019-07-25', 180, NULL),
('Hampton Inn', 288, '2019-07-26', 320, NULL),
('Hampton Inn', 288, '2019-07-27', 225, NULL),
('Hampton Inn', 288, '2019-07-28', 384, NULL),
('Hampton Inn', 288, '2019-07-29', 242, NULL),
('Hampton Inn', 288, '2019-07-30', 366, NULL),
('Hampton Inn', 288, '2019-07-31', 141, NULL),
('Hampton Inn', 288, '2019-08-01', 120, NULL),
('Hampton Inn', 288, '2019-08-02', 290, NULL),
('Hampton Inn', 288, '2019-08-03', 183, NULL),
('Hampton Inn', 288, '2019-08-04', 347, NULL),
('Hampton Inn', 288, '2019-08-05', 189, NULL),
('Hampton Inn', 288, '2019-08-06', 341, NULL),
('Hampton Inn', 288, '2019-08-07', 303, NULL),
('Hampton Inn', 288, '2019-08-08', 237, NULL),
('Hampton Inn', 288, '2019-08-09', 216, NULL),
('Hampton Inn', 288, '2019-08-10', 335, NULL),
('Hampton Inn', 288, '2019-08-11', 232, NULL),
('Hampton Inn', 288, '2019-08-12', 152, NULL),
('Hampton Inn', 288, '2019-08-13', 175, NULL),
('Hampton Inn', 288, '2019-08-14', 188, NULL),
('Hampton Inn', 288, '2019-08-15', 383, NULL),
('Hampton Inn', 288, '2019-08-16', 144, NULL),
('Hampton Inn', 288, '2019-08-17', 335, NULL),
('Hampton Inn', 288, '2019-08-18', 219, NULL),
('Hampton Inn', 288, '2019-08-19', 149, NULL),
('Hampton Inn', 288, '2019-08-20', 262, NULL),
('Hampton Inn', 288, '2019-08-21', 391, NULL),
('Hampton Inn', 288, '2019-08-22', 251, NULL),
('Hampton Inn', 288, '2019-08-23', 105, NULL),
('Hampton Inn', 288, '2019-08-24', 277, NULL),
('Hampton Inn', 288, '2019-08-25', 247, NULL),
('Hampton Inn', 288, '2019-08-26', 343, NULL),
('Hampton Inn', 288, '2019-08-27', 222, NULL),
('Hampton Inn', 288, '2019-08-28', 206, NULL),
('Hampton Inn', 288, '2019-08-29', 350, NULL),
('Hampton Inn', 288, '2019-08-30', 359, NULL),
('Hampton Inn', 288, '2019-08-31', 136, NULL),
('Hampton Inn', 288, '2019-09-01', 302, NULL),
('Hampton Inn', 288, '2019-09-02', 212, NULL),
('Hampton Inn', 288, '2019-09-03', 287, NULL),
('Hampton Inn', 288, '2019-09-04', 164, NULL),
('Hampton Inn', 288, '2019-09-05', 231, NULL),
('Hampton Inn', 288, '2019-09-06', 322, NULL),
('Hampton Inn', 288, '2019-09-07', 385, NULL),
('Hampton Inn', 288, '2019-09-08', 270, NULL),
('Hampton Inn', 288, '2019-09-09', 297, NULL),
('Hampton Inn', 288, '2019-09-10', 283, NULL),
('Hampton Inn', 288, '2019-09-11', 186, NULL),
('Hampton Inn', 288, '2019-09-12', 211, NULL),
('Hampton Inn', 288, '2019-09-13', 290, NULL),
('Hampton Inn', 288, '2019-09-14', 339, NULL),
('Hampton Inn', 288, '2019-09-15', 256, NULL),
('Hampton Inn', 288, '2019-09-16', 235, NULL),
('Hampton Inn', 288, '2019-09-17', 211, NULL),
('Hampton Inn', 288, '2019-09-18', 301, NULL),
('Hampton Inn', 288, '2019-09-19', 160, NULL),
('Hampton Inn', 288, '2019-09-20', 207, NULL),
('Hampton Inn', 288, '2019-09-21', 320, NULL),
('Hampton Inn', 288, '2019-09-22', 384, NULL),
('Hampton Inn', 288, '2019-09-23', 267, NULL),
('Hampton Inn', 288, '2019-09-24', 105, NULL),
('Hampton Inn', 288, '2019-09-25', 191, NULL),
('Hampton Inn', 288, '2019-09-26', 181, NULL),
('Hampton Inn', 288, '2019-09-27', 220, NULL),
('Hampton Inn', 288, '2019-09-28', 157, NULL),
('Hampton Inn', 288, '2019-09-29', 295, NULL),
('Hampton Inn', 288, '2019-09-30', 161, NULL),
('Hampton Inn', 288, '2019-10-01', 398, NULL),
('Hampton Inn', 288, '2019-10-02', 135, NULL),
('Hampton Inn', 288, '2019-10-03', 294, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hampton Inn', 288, '2019-10-04', 368, NULL),
('Hampton Inn', 288, '2019-10-05', 107, NULL),
('Hampton Inn', 288, '2019-10-06', 120, NULL),
('Hampton Inn', 288, '2019-10-07', 138, NULL),
('Hampton Inn', 288, '2019-10-08', 385, NULL),
('Hampton Inn', 288, '2019-10-09', 100, NULL),
('Hampton Inn', 288, '2019-10-10', 227, NULL),
('Hampton Inn', 288, '2019-10-11', 201, NULL),
('Hampton Inn', 288, '2019-10-12', 208, NULL),
('Hampton Inn', 288, '2019-10-13', 277, NULL),
('Hampton Inn', 288, '2019-10-14', 335, NULL),
('Hampton Inn', 288, '2019-10-15', 345, NULL),
('Hampton Inn', 288, '2019-10-16', 141, NULL),
('Hampton Inn', 288, '2019-10-17', 248, NULL),
('Hampton Inn', 288, '2019-10-18', 259, NULL),
('Hampton Inn', 288, '2019-10-19', 374, NULL),
('Hampton Inn', 288, '2019-10-20', 152, NULL),
('Hampton Inn', 288, '2019-10-21', 311, NULL),
('Hampton Inn', 288, '2019-10-22', 324, NULL),
('Hampton Inn', 288, '2019-10-23', 362, NULL),
('Hampton Inn', 288, '2019-10-24', 194, NULL),
('Hampton Inn', 288, '2019-10-25', 245, NULL),
('Hampton Inn', 288, '2019-10-26', 152, NULL),
('Hampton Inn', 288, '2019-10-27', 389, NULL),
('Hampton Inn', 288, '2019-10-28', 381, NULL),
('Hampton Inn', 288, '2019-10-29', 125, NULL),
('Hampton Inn', 288, '2019-10-30', 298, NULL),
('Hampton Inn', 288, '2019-10-31', 300, NULL),
('Hampton Inn', 288, '2019-11-01', 234, NULL),
('Hampton Inn', 288, '2019-11-02', 327, NULL),
('Hampton Inn', 288, '2019-11-03', 138, NULL),
('Hampton Inn', 288, '2019-11-04', 229, NULL),
('Hampton Inn', 288, '2019-11-05', 172, NULL),
('Hampton Inn', 288, '2019-11-06', 189, NULL),
('Hampton Inn', 288, '2019-11-07', 217, NULL),
('Hampton Inn', 288, '2019-11-08', 247, NULL),
('Hampton Inn', 288, '2019-11-09', 182, NULL),
('Hampton Inn', 288, '2019-11-10', 279, NULL),
('Hampton Inn', 288, '2019-11-11', 191, NULL),
('Hampton Inn', 288, '2019-11-12', 220, NULL),
('Hampton Inn', 288, '2019-11-13', 339, NULL),
('Hampton Inn', 288, '2019-11-14', 107, NULL),
('Hampton Inn', 288, '2019-11-15', 148, NULL),
('Hampton Inn', 288, '2019-11-16', 294, NULL),
('Hampton Inn', 288, '2019-11-17', 272, NULL),
('Hampton Inn', 288, '2019-11-18', 120, NULL),
('Hampton Inn', 288, '2019-11-19', 132, NULL),
('Hampton Inn', 288, '2019-11-20', 397, NULL),
('Hampton Inn', 288, '2019-11-21', 393, NULL),
('Hampton Inn', 288, '2019-11-22', 255, NULL),
('Hampton Inn', 288, '2019-11-23', 125, NULL),
('Hampton Inn', 288, '2019-11-24', 324, NULL),
('Hampton Inn', 288, '2019-11-25', 248, NULL),
('Hampton Inn', 288, '2019-11-26', 359, NULL),
('Hampton Inn', 288, '2019-11-27', 345, NULL),
('Hampton Inn', 288, '2019-11-28', 360, NULL),
('Hampton Inn', 288, '2019-11-29', 277, NULL),
('Hampton Inn', 288, '2019-11-30', 307, NULL),
('Hampton Inn', 288, '2019-12-01', 225, NULL),
('Hampton Inn', 288, '2019-12-02', 299, NULL),
('Hampton Inn', 288, '2019-12-03', 269, NULL),
('Hampton Inn', 288, '2019-12-04', 316, NULL),
('Hampton Inn', 288, '2019-12-05', 356, NULL),
('Hampton Inn', 288, '2019-12-06', 306, NULL),
('Hampton Inn', 288, '2019-12-07', 107, NULL),
('Hampton Inn', 288, '2019-12-08', 117, NULL),
('Hampton Inn', 288, '2019-12-09', 369, NULL),
('Hampton Inn', 288, '2019-12-10', 111, NULL),
('Hampton Inn', 288, '2019-12-11', 259, NULL),
('Hampton Inn', 288, '2019-12-12', 245, NULL),
('Hampton Inn', 288, '2019-12-13', 177, NULL),
('Hampton Inn', 288, '2019-12-14', 347, NULL),
('Hampton Inn', 288, '2019-12-15', 202, NULL),
('Hampton Inn', 288, '2019-12-16', 266, NULL),
('Hampton Inn', 288, '2019-12-17', 116, NULL),
('Hampton Inn', 288, '2019-12-18', 358, NULL),
('Hampton Inn', 288, '2019-12-19', 320, NULL),
('Hampton Inn', 288, '2019-12-20', 352, NULL),
('Hampton Inn', 288, '2019-12-21', 170, NULL),
('Hampton Inn', 288, '2019-12-22', 258, NULL),
('Hampton Inn', 288, '2019-12-23', 276, NULL),
('Hampton Inn', 288, '2019-12-24', 121, NULL),
('Hampton Inn', 288, '2019-12-25', 224, NULL),
('Hampton Inn', 288, '2019-12-26', 360, NULL),
('Hampton Inn', 288, '2019-12-27', 131, NULL),
('Hampton Inn', 288, '2019-12-28', 103, NULL),
('Hampton Inn', 288, '2019-12-29', 160, NULL),
('Hampton Inn', 288, '2019-12-30', 156, NULL),
('Hampton Inn', 288, '2019-12-31', 365, NULL),
('Hampton Inn', 288, '2020-01-01', 256, NULL),
('Hampton Inn', 288, '2020-01-02', 215, NULL),
('Hampton Inn', 288, '2020-01-03', 193, NULL),
('Hampton Inn', 288, '2020-01-04', 321, NULL),
('Hampton Inn', 288, '2020-01-05', 197, NULL),
('Hampton Inn', 288, '2020-01-06', 117, NULL),
('Hampton Inn', 288, '2020-01-07', 126, NULL),
('Hampton Inn', 288, '2020-01-08', 258, NULL),
('Hampton Inn', 288, '2020-01-09', 244, NULL),
('Hampton Inn', 288, '2020-01-10', 228, NULL),
('Hampton Inn', 288, '2020-01-11', 131, NULL),
('Hampton Inn', 288, '2020-01-12', 178, NULL),
('Hampton Inn', 288, '2020-01-13', 376, NULL),
('Hampton Inn', 288, '2020-01-14', 226, NULL),
('Hampton Inn', 288, '2020-01-15', 235, NULL),
('Hampton Inn', 288, '2020-01-16', 363, NULL),
('Hampton Inn', 288, '2020-01-17', 296, NULL),
('Hampton Inn', 288, '2020-01-18', 277, NULL),
('Hampton Inn', 288, '2020-01-19', 245, NULL),
('Hampton Inn', 288, '2020-01-20', 383, NULL),
('Hampton Inn', 288, '2020-01-21', 133, NULL),
('Hampton Inn', 288, '2020-01-22', 198, NULL),
('Hampton Inn', 288, '2020-01-23', 366, NULL),
('Hampton Inn', 288, '2020-01-24', 279, NULL),
('Hampton Inn', 288, '2020-01-25', 184, NULL),
('Hampton Inn', 288, '2020-01-26', 260, NULL),
('Hampton Inn', 288, '2020-01-27', 244, NULL),
('Hampton Inn', 288, '2020-01-28', 383, NULL),
('Hampton Inn', 288, '2020-01-29', 184, NULL),
('Hampton Inn', 288, '2020-01-30', 145, NULL),
('Hampton Inn', 288, '2020-01-31', 148, NULL),
('Hampton Inn', 288, '2020-02-01', 189, NULL),
('Hampton Inn', 288, '2020-02-02', 367, NULL),
('Hampton Inn', 288, '2020-02-03', 270, NULL),
('Hampton Inn', 288, '2020-02-04', 310, NULL),
('Hampton Inn', 291, '2019-01-01', 289, NULL),
('Hampton Inn', 291, '2019-01-02', 101, NULL),
('Hampton Inn', 291, '2019-01-03', 127, NULL),
('Hampton Inn', 291, '2019-01-04', 177, NULL),
('Hampton Inn', 291, '2019-01-05', 228, NULL),
('Hampton Inn', 291, '2019-01-06', 366, NULL),
('Hampton Inn', 291, '2019-01-07', 356, NULL),
('Hampton Inn', 291, '2019-01-08', 310, NULL),
('Hampton Inn', 291, '2019-01-09', 312, NULL),
('Hampton Inn', 291, '2019-01-10', 301, NULL),
('Hampton Inn', 291, '2019-01-11', 135, NULL),
('Hampton Inn', 291, '2019-01-12', 333, NULL),
('Hampton Inn', 291, '2019-01-13', 377, NULL),
('Hampton Inn', 291, '2019-01-14', 287, NULL),
('Hampton Inn', 291, '2019-01-15', 344, NULL),
('Hampton Inn', 291, '2019-01-16', 211, NULL),
('Hampton Inn', 291, '2019-01-17', 285, NULL),
('Hampton Inn', 291, '2019-01-18', 237, NULL),
('Hampton Inn', 291, '2019-01-19', 327, NULL),
('Hampton Inn', 291, '2019-01-20', 322, NULL),
('Hampton Inn', 291, '2019-01-21', 367, NULL),
('Hampton Inn', 291, '2019-01-22', 246, NULL),
('Hampton Inn', 291, '2019-01-23', 201, NULL),
('Hampton Inn', 291, '2019-01-24', 236, NULL),
('Hampton Inn', 291, '2019-01-25', 180, NULL),
('Hampton Inn', 291, '2019-01-26', 319, NULL),
('Hampton Inn', 291, '2019-01-27', 304, NULL),
('Hampton Inn', 291, '2019-01-28', 365, NULL),
('Hampton Inn', 291, '2019-01-29', 103, NULL),
('Hampton Inn', 291, '2019-01-30', 249, NULL),
('Hampton Inn', 291, '2019-01-31', 316, NULL),
('Hampton Inn', 291, '2019-02-01', 138, NULL),
('Hampton Inn', 291, '2019-02-02', 170, NULL),
('Hampton Inn', 291, '2019-02-03', 341, NULL),
('Hampton Inn', 291, '2019-02-04', 329, NULL),
('Hampton Inn', 291, '2019-02-05', 201, NULL),
('Hampton Inn', 291, '2019-02-06', 108, NULL),
('Hampton Inn', 291, '2019-02-07', 371, NULL),
('Hampton Inn', 291, '2019-02-08', 260, NULL),
('Hampton Inn', 291, '2019-02-09', 269, NULL),
('Hampton Inn', 291, '2019-02-10', 355, NULL),
('Hampton Inn', 291, '2019-02-11', 155, NULL),
('Hampton Inn', 291, '2019-02-12', 106, NULL),
('Hampton Inn', 291, '2019-02-13', 303, NULL),
('Hampton Inn', 291, '2019-02-14', 226, NULL),
('Hampton Inn', 291, '2019-02-15', 320, NULL),
('Hampton Inn', 291, '2019-02-16', 182, NULL),
('Hampton Inn', 291, '2019-02-17', 284, NULL),
('Hampton Inn', 291, '2019-02-18', 150, NULL),
('Hampton Inn', 291, '2019-02-19', 200, NULL),
('Hampton Inn', 291, '2019-02-20', 377, NULL),
('Hampton Inn', 291, '2019-02-21', 106, NULL),
('Hampton Inn', 291, '2019-02-22', 218, NULL),
('Hampton Inn', 291, '2019-02-23', 209, NULL),
('Hampton Inn', 291, '2019-02-24', 345, NULL),
('Hampton Inn', 291, '2019-02-25', 128, NULL),
('Hampton Inn', 291, '2019-02-26', 359, NULL),
('Hampton Inn', 291, '2019-02-27', 146, NULL),
('Hampton Inn', 291, '2019-02-28', 362, NULL),
('Hampton Inn', 291, '2019-03-01', 271, NULL),
('Hampton Inn', 291, '2019-03-02', 194, NULL),
('Hampton Inn', 291, '2019-03-03', 166, NULL),
('Hampton Inn', 291, '2019-03-04', 281, NULL),
('Hampton Inn', 291, '2019-03-05', 224, NULL),
('Hampton Inn', 291, '2019-03-06', 211, NULL),
('Hampton Inn', 291, '2019-03-07', 275, NULL),
('Hampton Inn', 291, '2019-03-08', 254, NULL),
('Hampton Inn', 291, '2019-03-09', 296, NULL),
('Hampton Inn', 291, '2019-03-10', 329, NULL),
('Hampton Inn', 291, '2019-03-11', 162, NULL),
('Hampton Inn', 291, '2019-03-12', 399, NULL),
('Hampton Inn', 291, '2019-03-13', 137, NULL),
('Hampton Inn', 291, '2019-03-14', 165, NULL),
('Hampton Inn', 291, '2019-03-15', 369, NULL),
('Hampton Inn', 291, '2019-03-16', 389, NULL),
('Hampton Inn', 291, '2019-03-17', 246, NULL),
('Hampton Inn', 291, '2019-03-18', 206, NULL),
('Hampton Inn', 291, '2019-03-19', 165, NULL),
('Hampton Inn', 291, '2019-03-20', 245, NULL),
('Hampton Inn', 291, '2019-03-21', 258, NULL),
('Hampton Inn', 291, '2019-03-22', 294, NULL),
('Hampton Inn', 291, '2019-03-23', 232, NULL),
('Hampton Inn', 291, '2019-03-24', 156, NULL),
('Hampton Inn', 291, '2019-03-25', 102, NULL),
('Hampton Inn', 291, '2019-03-26', 156, NULL),
('Hampton Inn', 291, '2019-03-27', 395, NULL),
('Hampton Inn', 291, '2019-03-28', 254, NULL),
('Hampton Inn', 291, '2019-03-29', 208, NULL),
('Hampton Inn', 291, '2019-03-30', 340, NULL),
('Hampton Inn', 291, '2019-03-31', 189, NULL),
('Hampton Inn', 291, '2019-04-01', 201, NULL),
('Hampton Inn', 291, '2019-04-02', 396, NULL),
('Hampton Inn', 291, '2019-04-03', 226, NULL),
('Hampton Inn', 291, '2019-04-04', 137, NULL),
('Hampton Inn', 291, '2019-04-05', 320, NULL),
('Hampton Inn', 291, '2019-04-06', 379, NULL),
('Hampton Inn', 291, '2019-04-07', 385, NULL),
('Hampton Inn', 291, '2019-04-08', 348, NULL),
('Hampton Inn', 291, '2019-04-09', 380, NULL),
('Hampton Inn', 291, '2019-04-10', 304, NULL),
('Hampton Inn', 291, '2019-04-11', 260, NULL),
('Hampton Inn', 291, '2019-04-12', 170, NULL),
('Hampton Inn', 291, '2019-04-13', 235, NULL),
('Hampton Inn', 291, '2019-04-14', 290, NULL),
('Hampton Inn', 291, '2019-04-15', 134, NULL),
('Hampton Inn', 291, '2019-04-16', 336, NULL),
('Hampton Inn', 291, '2019-04-17', 234, NULL),
('Hampton Inn', 291, '2019-04-18', 256, NULL),
('Hampton Inn', 291, '2019-04-19', 140, NULL),
('Hampton Inn', 291, '2019-04-20', 347, NULL),
('Hampton Inn', 291, '2019-04-21', 379, NULL),
('Hampton Inn', 291, '2019-04-22', 157, NULL),
('Hampton Inn', 291, '2019-04-23', 202, NULL),
('Hampton Inn', 291, '2019-04-24', 186, NULL),
('Hampton Inn', 291, '2019-04-25', 195, NULL),
('Hampton Inn', 291, '2019-04-26', 342, NULL),
('Hampton Inn', 291, '2019-04-27', 330, NULL),
('Hampton Inn', 291, '2019-04-28', 288, NULL),
('Hampton Inn', 291, '2019-04-29', 341, NULL),
('Hampton Inn', 291, '2019-04-30', 123, NULL),
('Hampton Inn', 291, '2019-05-01', 328, NULL),
('Hampton Inn', 291, '2019-05-02', 298, NULL),
('Hampton Inn', 291, '2019-05-03', 302, NULL),
('Hampton Inn', 291, '2019-05-04', 370, NULL),
('Hampton Inn', 291, '2019-05-05', 381, NULL),
('Hampton Inn', 291, '2019-05-06', 225, NULL),
('Hampton Inn', 291, '2019-05-07', 347, NULL),
('Hampton Inn', 291, '2019-05-08', 321, NULL),
('Hampton Inn', 291, '2019-05-09', 392, NULL),
('Hampton Inn', 291, '2019-05-10', 280, NULL),
('Hampton Inn', 291, '2019-05-11', 297, NULL),
('Hampton Inn', 291, '2019-05-12', 229, NULL),
('Hampton Inn', 291, '2019-05-13', 134, NULL),
('Hampton Inn', 291, '2019-05-14', 210, NULL),
('Hampton Inn', 291, '2019-05-15', 396, NULL),
('Hampton Inn', 291, '2019-05-16', 272, NULL),
('Hampton Inn', 291, '2019-05-17', 397, NULL),
('Hampton Inn', 291, '2019-05-18', 126, NULL),
('Hampton Inn', 291, '2019-05-19', 300, NULL),
('Hampton Inn', 291, '2019-05-20', 138, NULL),
('Hampton Inn', 291, '2019-05-21', 239, NULL),
('Hampton Inn', 291, '2019-05-22', 367, NULL),
('Hampton Inn', 291, '2019-05-23', 187, NULL),
('Hampton Inn', 291, '2019-05-24', 190, NULL),
('Hampton Inn', 291, '2019-05-25', 161, NULL),
('Hampton Inn', 291, '2019-05-26', 134, NULL),
('Hampton Inn', 291, '2019-05-27', 168, NULL),
('Hampton Inn', 291, '2019-05-28', 383, NULL),
('Hampton Inn', 291, '2019-05-29', 260, NULL),
('Hampton Inn', 291, '2019-05-30', 109, NULL),
('Hampton Inn', 291, '2019-05-31', 344, NULL),
('Hampton Inn', 291, '2019-06-01', 265, NULL),
('Hampton Inn', 291, '2019-06-02', 136, NULL),
('Hampton Inn', 291, '2019-06-03', 382, NULL),
('Hampton Inn', 291, '2019-06-04', 314, NULL),
('Hampton Inn', 291, '2019-06-05', 139, NULL),
('Hampton Inn', 291, '2019-06-06', 354, NULL),
('Hampton Inn', 291, '2019-06-07', 169, NULL),
('Hampton Inn', 291, '2019-06-08', 349, NULL),
('Hampton Inn', 291, '2019-06-09', 165, NULL),
('Hampton Inn', 291, '2019-06-10', 146, NULL),
('Hampton Inn', 291, '2019-06-11', 326, NULL),
('Hampton Inn', 291, '2019-06-12', 285, NULL),
('Hampton Inn', 291, '2019-06-13', 323, NULL),
('Hampton Inn', 291, '2019-06-14', 273, NULL),
('Hampton Inn', 291, '2019-06-15', 234, NULL),
('Hampton Inn', 291, '2019-06-16', 275, NULL),
('Hampton Inn', 291, '2019-06-17', 340, NULL),
('Hampton Inn', 291, '2019-06-18', 199, NULL),
('Hampton Inn', 291, '2019-06-19', 101, NULL),
('Hampton Inn', 291, '2019-06-20', 275, NULL),
('Hampton Inn', 291, '2019-06-21', 217, NULL),
('Hampton Inn', 291, '2019-06-22', 221, NULL),
('Hampton Inn', 291, '2019-06-23', 156, NULL),
('Hampton Inn', 291, '2019-06-24', 251, NULL),
('Hampton Inn', 291, '2019-06-25', 289, NULL),
('Hampton Inn', 291, '2019-06-26', 390, NULL),
('Hampton Inn', 291, '2019-06-27', 356, NULL),
('Hampton Inn', 291, '2019-06-28', 210, NULL),
('Hampton Inn', 291, '2019-06-29', 361, NULL),
('Hampton Inn', 291, '2019-06-30', 195, NULL),
('Hampton Inn', 291, '2019-07-01', 179, NULL),
('Hampton Inn', 291, '2019-07-02', 251, NULL),
('Hampton Inn', 291, '2019-07-03', 162, NULL),
('Hampton Inn', 291, '2019-07-04', 155, NULL),
('Hampton Inn', 291, '2019-07-05', 395, NULL),
('Hampton Inn', 291, '2019-07-06', 178, NULL),
('Hampton Inn', 291, '2019-07-07', 365, NULL),
('Hampton Inn', 291, '2019-07-08', 223, NULL),
('Hampton Inn', 291, '2019-07-09', 299, NULL),
('Hampton Inn', 291, '2019-07-10', 229, NULL),
('Hampton Inn', 291, '2019-07-11', 281, NULL),
('Hampton Inn', 291, '2019-07-12', 346, NULL),
('Hampton Inn', 291, '2019-07-13', 148, NULL),
('Hampton Inn', 291, '2019-07-14', 329, NULL),
('Hampton Inn', 291, '2019-07-15', 327, NULL),
('Hampton Inn', 291, '2019-07-16', 116, NULL),
('Hampton Inn', 291, '2019-07-17', 182, NULL),
('Hampton Inn', 291, '2019-07-18', 217, NULL),
('Hampton Inn', 291, '2019-07-19', 189, NULL),
('Hampton Inn', 291, '2019-07-20', 237, NULL),
('Hampton Inn', 291, '2019-07-21', 237, NULL),
('Hampton Inn', 291, '2019-07-22', 125, NULL),
('Hampton Inn', 291, '2019-07-23', 397, NULL),
('Hampton Inn', 291, '2019-07-24', 129, NULL),
('Hampton Inn', 291, '2019-07-25', 204, NULL),
('Hampton Inn', 291, '2019-07-26', 278, NULL),
('Hampton Inn', 291, '2019-07-27', 119, NULL),
('Hampton Inn', 291, '2019-07-28', 307, NULL),
('Hampton Inn', 291, '2019-07-29', 340, NULL),
('Hampton Inn', 291, '2019-07-30', 101, NULL),
('Hampton Inn', 291, '2019-07-31', 140, NULL),
('Hampton Inn', 291, '2019-08-01', 106, NULL),
('Hampton Inn', 291, '2019-08-02', 304, NULL),
('Hampton Inn', 291, '2019-08-03', 236, NULL),
('Hampton Inn', 291, '2019-08-04', 146, NULL),
('Hampton Inn', 291, '2019-08-05', 325, NULL),
('Hampton Inn', 291, '2019-08-06', 269, NULL),
('Hampton Inn', 291, '2019-08-07', 352, NULL),
('Hampton Inn', 291, '2019-08-08', 255, NULL),
('Hampton Inn', 291, '2019-08-09', 273, NULL),
('Hampton Inn', 291, '2019-08-10', 303, NULL),
('Hampton Inn', 291, '2019-08-11', 292, NULL),
('Hampton Inn', 291, '2019-08-12', 296, NULL),
('Hampton Inn', 291, '2019-08-13', 271, NULL),
('Hampton Inn', 291, '2019-08-14', 222, NULL),
('Hampton Inn', 291, '2019-08-15', 392, NULL),
('Hampton Inn', 291, '2019-08-16', 284, NULL),
('Hampton Inn', 291, '2019-08-17', 255, NULL),
('Hampton Inn', 291, '2019-08-18', 307, NULL),
('Hampton Inn', 291, '2019-08-19', 318, NULL),
('Hampton Inn', 291, '2019-08-20', 104, NULL),
('Hampton Inn', 291, '2019-08-21', 151, NULL),
('Hampton Inn', 291, '2019-08-22', 273, NULL),
('Hampton Inn', 291, '2019-08-23', 139, NULL),
('Hampton Inn', 291, '2019-08-24', 317, NULL),
('Hampton Inn', 291, '2019-08-25', 177, NULL),
('Hampton Inn', 291, '2019-08-26', 106, NULL),
('Hampton Inn', 291, '2019-08-27', 124, NULL),
('Hampton Inn', 291, '2019-08-28', 289, NULL),
('Hampton Inn', 291, '2019-08-29', 285, NULL),
('Hampton Inn', 291, '2019-08-30', 298, NULL),
('Hampton Inn', 291, '2019-08-31', 148, NULL),
('Hampton Inn', 291, '2019-09-01', 389, NULL),
('Hampton Inn', 291, '2019-09-02', 103, NULL),
('Hampton Inn', 291, '2019-09-03', 377, NULL),
('Hampton Inn', 291, '2019-09-04', 337, NULL),
('Hampton Inn', 291, '2019-09-05', 188, NULL),
('Hampton Inn', 291, '2019-09-06', 283, NULL),
('Hampton Inn', 291, '2019-09-07', 174, NULL),
('Hampton Inn', 291, '2019-09-08', 208, NULL),
('Hampton Inn', 291, '2019-09-09', 289, NULL),
('Hampton Inn', 291, '2019-09-10', 166, NULL),
('Hampton Inn', 291, '2019-09-11', 187, NULL),
('Hampton Inn', 291, '2019-09-12', 268, NULL),
('Hampton Inn', 291, '2019-09-13', 326, NULL),
('Hampton Inn', 291, '2019-09-14', 265, NULL),
('Hampton Inn', 291, '2019-09-15', 119, NULL),
('Hampton Inn', 291, '2019-09-16', 192, NULL),
('Hampton Inn', 291, '2019-09-17', 383, NULL),
('Hampton Inn', 291, '2019-09-18', 345, NULL),
('Hampton Inn', 291, '2019-09-19', 329, NULL),
('Hampton Inn', 291, '2019-09-20', 294, NULL),
('Hampton Inn', 291, '2019-09-21', 178, NULL),
('Hampton Inn', 291, '2019-09-22', 242, NULL),
('Hampton Inn', 291, '2019-09-23', 275, NULL),
('Hampton Inn', 291, '2019-09-24', 303, NULL),
('Hampton Inn', 291, '2019-09-25', 196, NULL),
('Hampton Inn', 291, '2019-09-26', 251, NULL),
('Hampton Inn', 291, '2019-09-27', 115, NULL),
('Hampton Inn', 291, '2019-09-28', 322, NULL),
('Hampton Inn', 291, '2019-09-29', 110, NULL),
('Hampton Inn', 291, '2019-09-30', 318, NULL),
('Hampton Inn', 291, '2019-10-01', 350, NULL),
('Hampton Inn', 291, '2019-10-02', 278, NULL),
('Hampton Inn', 291, '2019-10-03', 160, NULL),
('Hampton Inn', 291, '2019-10-04', 205, NULL),
('Hampton Inn', 291, '2019-10-05', 199, NULL),
('Hampton Inn', 291, '2019-10-06', 282, NULL),
('Hampton Inn', 291, '2019-10-07', 232, NULL),
('Hampton Inn', 291, '2019-10-08', 363, NULL),
('Hampton Inn', 291, '2019-10-09', 259, NULL),
('Hampton Inn', 291, '2019-10-10', 191, NULL),
('Hampton Inn', 291, '2019-10-11', 371, NULL),
('Hampton Inn', 291, '2019-10-12', 129, NULL),
('Hampton Inn', 291, '2019-10-13', 283, NULL),
('Hampton Inn', 291, '2019-10-14', 220, NULL),
('Hampton Inn', 291, '2019-10-15', 282, NULL),
('Hampton Inn', 291, '2019-10-16', 224, NULL),
('Hampton Inn', 291, '2019-10-17', 162, NULL),
('Hampton Inn', 291, '2019-10-18', 319, NULL),
('Hampton Inn', 291, '2019-10-19', 380, NULL),
('Hampton Inn', 291, '2019-10-20', 174, NULL),
('Hampton Inn', 291, '2019-10-21', 389, NULL),
('Hampton Inn', 291, '2019-10-22', 192, NULL),
('Hampton Inn', 291, '2019-10-23', 359, NULL),
('Hampton Inn', 291, '2019-10-24', 142, NULL),
('Hampton Inn', 291, '2019-10-25', 316, NULL),
('Hampton Inn', 291, '2019-10-26', 288, NULL),
('Hampton Inn', 291, '2019-10-27', 313, NULL),
('Hampton Inn', 291, '2019-10-28', 175, NULL),
('Hampton Inn', 291, '2019-10-29', 392, NULL),
('Hampton Inn', 291, '2019-10-30', 183, NULL),
('Hampton Inn', 291, '2019-10-31', 327, NULL),
('Hampton Inn', 291, '2019-11-01', 265, NULL),
('Hampton Inn', 291, '2019-11-02', 368, NULL),
('Hampton Inn', 291, '2019-11-03', 158, NULL),
('Hampton Inn', 291, '2019-11-04', 111, NULL),
('Hampton Inn', 291, '2019-11-05', 374, NULL),
('Hampton Inn', 291, '2019-11-06', 241, NULL),
('Hampton Inn', 291, '2019-11-07', 111, NULL),
('Hampton Inn', 291, '2019-11-08', 338, NULL),
('Hampton Inn', 291, '2019-11-09', 392, NULL),
('Hampton Inn', 291, '2019-11-10', 121, NULL),
('Hampton Inn', 291, '2019-11-11', 272, NULL),
('Hampton Inn', 291, '2019-11-12', 101, NULL),
('Hampton Inn', 291, '2019-11-13', 233, NULL),
('Hampton Inn', 291, '2019-11-14', 268, NULL),
('Hampton Inn', 291, '2019-11-15', 333, NULL),
('Hampton Inn', 291, '2019-11-16', 102, NULL),
('Hampton Inn', 291, '2019-11-17', 386, NULL),
('Hampton Inn', 291, '2019-11-18', 264, NULL),
('Hampton Inn', 291, '2019-11-19', 187, NULL),
('Hampton Inn', 291, '2019-11-20', 361, NULL),
('Hampton Inn', 291, '2019-11-21', 228, NULL),
('Hampton Inn', 291, '2019-11-22', 186, NULL),
('Hampton Inn', 291, '2019-11-23', 367, NULL),
('Hampton Inn', 291, '2019-11-24', 306, NULL),
('Hampton Inn', 291, '2019-11-25', 292, NULL),
('Hampton Inn', 291, '2019-11-26', 110, NULL),
('Hampton Inn', 291, '2019-11-27', 314, NULL),
('Hampton Inn', 291, '2019-11-28', 353, NULL),
('Hampton Inn', 291, '2019-11-29', 284, NULL),
('Hampton Inn', 291, '2019-11-30', 349, NULL),
('Hampton Inn', 291, '2019-12-01', 245, NULL),
('Hampton Inn', 291, '2019-12-02', 341, NULL),
('Hampton Inn', 291, '2019-12-03', 172, NULL),
('Hampton Inn', 291, '2019-12-04', 186, NULL),
('Hampton Inn', 291, '2019-12-05', 211, NULL),
('Hampton Inn', 291, '2019-12-06', 259, NULL),
('Hampton Inn', 291, '2019-12-07', 308, NULL),
('Hampton Inn', 291, '2019-12-08', 358, NULL),
('Hampton Inn', 291, '2019-12-09', 385, NULL),
('Hampton Inn', 291, '2019-12-10', 319, NULL),
('Hampton Inn', 291, '2019-12-11', 163, NULL),
('Hampton Inn', 291, '2019-12-12', 281, NULL),
('Hampton Inn', 291, '2019-12-13', 271, NULL),
('Hampton Inn', 291, '2019-12-14', 357, NULL),
('Hampton Inn', 291, '2019-12-15', 122, NULL),
('Hampton Inn', 291, '2019-12-16', 328, NULL),
('Hampton Inn', 291, '2019-12-17', 335, NULL),
('Hampton Inn', 291, '2019-12-18', 128, NULL),
('Hampton Inn', 291, '2019-12-19', 172, NULL),
('Hampton Inn', 291, '2019-12-20', 318, NULL),
('Hampton Inn', 291, '2019-12-21', 180, NULL),
('Hampton Inn', 291, '2019-12-22', 254, NULL),
('Hampton Inn', 291, '2019-12-23', 394, NULL),
('Hampton Inn', 291, '2019-12-24', 121, NULL),
('Hampton Inn', 291, '2019-12-25', 117, NULL),
('Hampton Inn', 291, '2019-12-26', 126, NULL),
('Hampton Inn', 291, '2019-12-27', 361, NULL),
('Hampton Inn', 291, '2019-12-28', 130, NULL),
('Hampton Inn', 291, '2019-12-29', 126, NULL),
('Hampton Inn', 291, '2019-12-30', 234, NULL),
('Hampton Inn', 291, '2019-12-31', 193, NULL),
('Hampton Inn', 291, '2020-01-01', 378, NULL),
('Hampton Inn', 291, '2020-01-02', 326, NULL),
('Hampton Inn', 291, '2020-01-03', 285, NULL),
('Hampton Inn', 291, '2020-01-04', 151, NULL),
('Hampton Inn', 291, '2020-01-05', 252, NULL),
('Hampton Inn', 291, '2020-01-06', 163, NULL),
('Hampton Inn', 291, '2020-01-07', 185, NULL),
('Hampton Inn', 291, '2020-01-08', 312, NULL),
('Hampton Inn', 291, '2020-01-09', 368, NULL),
('Hampton Inn', 291, '2020-01-10', 264, NULL),
('Hampton Inn', 291, '2020-01-11', 221, NULL),
('Hampton Inn', 291, '2020-01-12', 370, NULL),
('Hampton Inn', 291, '2020-01-13', 314, NULL),
('Hampton Inn', 291, '2020-01-14', 269, NULL),
('Hampton Inn', 291, '2020-01-15', 173, NULL),
('Hampton Inn', 291, '2020-01-16', 386, NULL),
('Hampton Inn', 291, '2020-01-17', 181, NULL),
('Hampton Inn', 291, '2020-01-18', 203, NULL),
('Hampton Inn', 291, '2020-01-19', 213, NULL),
('Hampton Inn', 291, '2020-01-20', 250, NULL),
('Hampton Inn', 291, '2020-01-21', 384, NULL),
('Hampton Inn', 291, '2020-01-22', 260, NULL),
('Hampton Inn', 291, '2020-01-23', 113, NULL),
('Hampton Inn', 291, '2020-01-24', 238, NULL),
('Hampton Inn', 291, '2020-01-25', 215, NULL),
('Hampton Inn', 291, '2020-01-26', 283, NULL),
('Hampton Inn', 291, '2020-01-27', 209, NULL),
('Hampton Inn', 291, '2020-01-28', 295, NULL),
('Hampton Inn', 291, '2020-01-29', 298, NULL),
('Hampton Inn', 291, '2020-01-30', 222, NULL),
('Hampton Inn', 291, '2020-01-31', 194, NULL),
('Hampton Inn', 291, '2020-02-01', 306, NULL),
('Hampton Inn', 291, '2020-02-02', 210, NULL),
('Hampton Inn', 291, '2020-02-03', 390, NULL),
('Hampton Inn', 291, '2020-02-04', 243, NULL),
('Hi-Way Inn', 12, '2019-01-01', 100, NULL),
('Hi-Way Inn', 12, '2019-01-02', 293, NULL),
('Hi-Way Inn', 12, '2019-01-03', 252, NULL),
('Hi-Way Inn', 12, '2019-01-04', 272, NULL),
('Hi-Way Inn', 12, '2019-01-05', 173, NULL),
('Hi-Way Inn', 12, '2019-01-06', 120, 9),
('Hi-Way Inn', 12, '2019-01-07', 243, 9),
('Hi-Way Inn', 12, '2019-01-08', 159, 9),
('Hi-Way Inn', 12, '2019-01-09', 311, 9),
('Hi-Way Inn', 12, '2019-01-10', 273, 9),
('Hi-Way Inn', 12, '2019-01-11', 345, 9),
('Hi-Way Inn', 12, '2019-01-12', 310, 9),
('Hi-Way Inn', 12, '2019-01-13', 111, 9),
('Hi-Way Inn', 12, '2019-01-14', 339, 9),
('Hi-Way Inn', 12, '2019-01-15', 181, 9),
('Hi-Way Inn', 12, '2019-01-16', 347, 9),
('Hi-Way Inn', 12, '2019-01-17', 180, 9),
('Hi-Way Inn', 12, '2019-01-18', 233, 9),
('Hi-Way Inn', 12, '2019-01-19', 298, 9),
('Hi-Way Inn', 12, '2019-01-20', 338, 9),
('Hi-Way Inn', 12, '2019-01-21', 331, 9),
('Hi-Way Inn', 12, '2019-01-22', 312, 9),
('Hi-Way Inn', 12, '2019-01-23', 162, 9),
('Hi-Way Inn', 12, '2019-01-24', 170, 9),
('Hi-Way Inn', 12, '2019-01-25', 302, NULL),
('Hi-Way Inn', 12, '2019-01-26', 362, NULL),
('Hi-Way Inn', 12, '2019-01-27', 104, NULL),
('Hi-Way Inn', 12, '2019-01-28', 353, NULL),
('Hi-Way Inn', 12, '2019-01-29', 222, NULL),
('Hi-Way Inn', 12, '2019-01-30', 247, NULL),
('Hi-Way Inn', 12, '2019-01-31', 158, NULL),
('Hi-Way Inn', 12, '2019-02-01', 208, NULL),
('Hi-Way Inn', 12, '2019-02-02', 117, NULL),
('Hi-Way Inn', 12, '2019-02-03', 311, NULL),
('Hi-Way Inn', 12, '2019-02-04', 387, NULL),
('Hi-Way Inn', 12, '2019-02-05', 194, NULL),
('Hi-Way Inn', 12, '2019-02-06', 250, NULL),
('Hi-Way Inn', 12, '2019-02-07', 188, NULL),
('Hi-Way Inn', 12, '2019-02-08', 299, NULL),
('Hi-Way Inn', 12, '2019-02-09', 318, NULL),
('Hi-Way Inn', 12, '2019-02-10', 191, NULL),
('Hi-Way Inn', 12, '2019-02-11', 327, NULL),
('Hi-Way Inn', 12, '2019-02-12', 324, 157),
('Hi-Way Inn', 12, '2019-02-13', 314, 157),
('Hi-Way Inn', 12, '2019-02-14', 395, 157),
('Hi-Way Inn', 12, '2019-02-15', 153, 157),
('Hi-Way Inn', 12, '2019-02-16', 137, 157),
('Hi-Way Inn', 12, '2019-02-17', 105, NULL),
('Hi-Way Inn', 12, '2019-02-18', 309, NULL),
('Hi-Way Inn', 12, '2019-02-19', 247, NULL),
('Hi-Way Inn', 12, '2019-02-20', 125, NULL),
('Hi-Way Inn', 12, '2019-02-21', 382, NULL),
('Hi-Way Inn', 12, '2019-02-22', 205, NULL),
('Hi-Way Inn', 12, '2019-02-23', 176, NULL),
('Hi-Way Inn', 12, '2019-02-24', 118, NULL),
('Hi-Way Inn', 12, '2019-02-25', 374, NULL),
('Hi-Way Inn', 12, '2019-02-26', 381, NULL),
('Hi-Way Inn', 12, '2019-02-27', 174, NULL),
('Hi-Way Inn', 12, '2019-02-28', 131, NULL),
('Hi-Way Inn', 12, '2019-03-01', 158, NULL),
('Hi-Way Inn', 12, '2019-03-02', 325, 1),
('Hi-Way Inn', 12, '2019-03-03', 347, 1),
('Hi-Way Inn', 12, '2019-03-04', 171, 1),
('Hi-Way Inn', 12, '2019-03-05', 147, 1),
('Hi-Way Inn', 12, '2019-03-06', 318, 1),
('Hi-Way Inn', 12, '2019-03-07', 188, 1),
('Hi-Way Inn', 12, '2019-03-08', 316, NULL),
('Hi-Way Inn', 12, '2019-03-09', 208, NULL),
('Hi-Way Inn', 12, '2019-03-10', 236, NULL),
('Hi-Way Inn', 12, '2019-03-11', 180, NULL),
('Hi-Way Inn', 12, '2019-03-12', 257, NULL),
('Hi-Way Inn', 12, '2019-03-13', 110, NULL),
('Hi-Way Inn', 12, '2019-03-14', 254, NULL),
('Hi-Way Inn', 12, '2019-03-15', 235, NULL),
('Hi-Way Inn', 12, '2019-03-16', 206, NULL),
('Hi-Way Inn', 12, '2019-03-17', 376, 181),
('Hi-Way Inn', 12, '2019-03-18', 328, 181),
('Hi-Way Inn', 12, '2019-03-19', 398, 181),
('Hi-Way Inn', 12, '2019-03-20', 368, 181),
('Hi-Way Inn', 12, '2019-03-21', 250, 181),
('Hi-Way Inn', 12, '2019-03-22', 249, 181),
('Hi-Way Inn', 12, '2019-03-23', 313, 181),
('Hi-Way Inn', 12, '2019-03-24', 328, 181),
('Hi-Way Inn', 12, '2019-03-25', 186, 181),
('Hi-Way Inn', 12, '2019-03-26', 226, 181),
('Hi-Way Inn', 12, '2019-03-27', 366, 181),
('Hi-Way Inn', 12, '2019-03-28', 277, 181),
('Hi-Way Inn', 12, '2019-03-29', 265, 181),
('Hi-Way Inn', 12, '2019-03-30', 148, NULL),
('Hi-Way Inn', 12, '2019-03-31', 313, NULL),
('Hi-Way Inn', 12, '2019-04-01', 287, NULL),
('Hi-Way Inn', 12, '2019-04-02', 272, NULL),
('Hi-Way Inn', 12, '2019-04-03', 230, NULL),
('Hi-Way Inn', 12, '2019-04-04', 298, NULL),
('Hi-Way Inn', 12, '2019-04-05', 287, NULL),
('Hi-Way Inn', 12, '2019-04-06', 158, NULL),
('Hi-Way Inn', 12, '2019-04-07', 356, NULL),
('Hi-Way Inn', 12, '2019-04-08', 181, NULL),
('Hi-Way Inn', 12, '2019-04-09', 146, NULL),
('Hi-Way Inn', 12, '2019-04-10', 349, NULL),
('Hi-Way Inn', 12, '2019-04-11', 286, NULL),
('Hi-Way Inn', 12, '2019-04-12', 174, NULL),
('Hi-Way Inn', 12, '2019-04-13', 188, NULL),
('Hi-Way Inn', 12, '2019-04-14', 388, NULL),
('Hi-Way Inn', 12, '2019-04-15', 175, NULL),
('Hi-Way Inn', 12, '2019-04-16', 349, NULL),
('Hi-Way Inn', 12, '2019-04-17', 257, NULL),
('Hi-Way Inn', 12, '2019-04-18', 186, NULL),
('Hi-Way Inn', 12, '2019-04-19', 153, NULL),
('Hi-Way Inn', 12, '2019-04-20', 358, 89),
('Hi-Way Inn', 12, '2019-04-21', 348, 89),
('Hi-Way Inn', 12, '2019-04-22', 112, 89),
('Hi-Way Inn', 12, '2019-04-23', 294, 89),
('Hi-Way Inn', 12, '2019-04-24', 165, 89),
('Hi-Way Inn', 12, '2019-04-25', 173, 89),
('Hi-Way Inn', 12, '2019-04-26', 134, 89),
('Hi-Way Inn', 12, '2019-04-27', 102, 89),
('Hi-Way Inn', 12, '2019-04-28', 211, 89),
('Hi-Way Inn', 12, '2019-04-29', 234, 89),
('Hi-Way Inn', 12, '2019-04-30', 106, 89),
('Hi-Way Inn', 12, '2019-05-01', 192, 89),
('Hi-Way Inn', 12, '2019-05-02', 369, 89),
('Hi-Way Inn', 12, '2019-05-03', 239, 89),
('Hi-Way Inn', 12, '2019-05-04', 119, 89),
('Hi-Way Inn', 12, '2019-05-05', 142, 89),
('Hi-Way Inn', 12, '2019-05-06', 271, 89),
('Hi-Way Inn', 12, '2019-05-07', 218, 89),
('Hi-Way Inn', 12, '2019-05-08', 342, 89),
('Hi-Way Inn', 12, '2019-05-09', 384, 89),
('Hi-Way Inn', 12, '2019-05-10', 205, NULL),
('Hi-Way Inn', 12, '2019-05-11', 374, 79),
('Hi-Way Inn', 12, '2019-05-12', 271, 79),
('Hi-Way Inn', 12, '2019-05-13', 255, 79),
('Hi-Way Inn', 12, '2019-05-14', 255, 79),
('Hi-Way Inn', 12, '2019-05-15', 238, 79),
('Hi-Way Inn', 12, '2019-05-16', 318, 79),
('Hi-Way Inn', 12, '2019-05-17', 186, 79),
('Hi-Way Inn', 12, '2019-05-18', 217, 79),
('Hi-Way Inn', 12, '2019-05-19', 147, 79),
('Hi-Way Inn', 12, '2019-05-20', 273, 79),
('Hi-Way Inn', 12, '2019-05-21', 302, 79),
('Hi-Way Inn', 12, '2019-05-22', 363, 79),
('Hi-Way Inn', 12, '2019-05-23', 276, 79),
('Hi-Way Inn', 12, '2019-05-24', 339, 79),
('Hi-Way Inn', 12, '2019-05-25', 256, 79),
('Hi-Way Inn', 12, '2019-05-26', 213, 79),
('Hi-Way Inn', 12, '2019-05-27', 259, 79),
('Hi-Way Inn', 12, '2019-05-28', 281, 79),
('Hi-Way Inn', 12, '2019-05-29', 202, 79),
('Hi-Way Inn', 12, '2019-05-30', 167, 79),
('Hi-Way Inn', 12, '2019-05-31', 218, 79),
('Hi-Way Inn', 12, '2019-06-01', 330, 79),
('Hi-Way Inn', 12, '2019-06-02', 253, 79),
('Hi-Way Inn', 12, '2019-06-03', 199, 79),
('Hi-Way Inn', 12, '2019-06-04', 280, 79),
('Hi-Way Inn', 12, '2019-06-05', 352, NULL),
('Hi-Way Inn', 12, '2019-06-06', 127, NULL),
('Hi-Way Inn', 12, '2019-06-07', 215, NULL),
('Hi-Way Inn', 12, '2019-06-08', 184, NULL),
('Hi-Way Inn', 12, '2019-06-09', 191, NULL),
('Hi-Way Inn', 12, '2019-06-10', 219, NULL),
('Hi-Way Inn', 12, '2019-06-11', 209, NULL),
('Hi-Way Inn', 12, '2019-06-12', 107, NULL),
('Hi-Way Inn', 12, '2019-06-13', 335, NULL),
('Hi-Way Inn', 12, '2019-06-14', 193, NULL),
('Hi-Way Inn', 12, '2019-06-15', 121, NULL),
('Hi-Way Inn', 12, '2019-06-16', 313, NULL),
('Hi-Way Inn', 12, '2019-06-17', 170, NULL),
('Hi-Way Inn', 12, '2019-06-18', 249, NULL),
('Hi-Way Inn', 12, '2019-06-19', 267, NULL),
('Hi-Way Inn', 12, '2019-06-20', 320, NULL),
('Hi-Way Inn', 12, '2019-06-21', 172, NULL),
('Hi-Way Inn', 12, '2019-06-22', 271, NULL),
('Hi-Way Inn', 12, '2019-06-23', 388, NULL),
('Hi-Way Inn', 12, '2019-06-24', 374, NULL),
('Hi-Way Inn', 12, '2019-06-25', 300, 66),
('Hi-Way Inn', 12, '2019-06-26', 230, 66),
('Hi-Way Inn', 12, '2019-06-27', 107, 66),
('Hi-Way Inn', 12, '2019-06-28', 355, 66),
('Hi-Way Inn', 12, '2019-06-29', 314, 66),
('Hi-Way Inn', 12, '2019-06-30', 230, 66),
('Hi-Way Inn', 12, '2019-07-01', 103, 66),
('Hi-Way Inn', 12, '2019-07-02', 116, 66),
('Hi-Way Inn', 12, '2019-07-03', 387, 66),
('Hi-Way Inn', 12, '2019-07-04', 331, 66),
('Hi-Way Inn', 12, '2019-07-05', 159, 66),
('Hi-Way Inn', 12, '2019-07-06', 112, 66),
('Hi-Way Inn', 12, '2019-07-07', 363, 66),
('Hi-Way Inn', 12, '2019-07-08', 285, 66),
('Hi-Way Inn', 12, '2019-07-09', 241, 66),
('Hi-Way Inn', 12, '2019-07-10', 344, 66),
('Hi-Way Inn', 12, '2019-07-11', 191, 66),
('Hi-Way Inn', 12, '2019-07-12', 254, 66),
('Hi-Way Inn', 12, '2019-07-13', 123, 66),
('Hi-Way Inn', 12, '2019-07-14', 358, 66),
('Hi-Way Inn', 12, '2019-07-15', 356, 66),
('Hi-Way Inn', 12, '2019-07-16', 366, 66),
('Hi-Way Inn', 12, '2019-07-17', 204, 66),
('Hi-Way Inn', 12, '2019-07-18', 292, 66),
('Hi-Way Inn', 12, '2019-07-19', 352, NULL),
('Hi-Way Inn', 12, '2019-07-20', 287, NULL),
('Hi-Way Inn', 12, '2019-07-21', 349, NULL),
('Hi-Way Inn', 12, '2019-07-22', 324, NULL),
('Hi-Way Inn', 12, '2019-07-23', 362, NULL),
('Hi-Way Inn', 12, '2019-07-24', 392, NULL),
('Hi-Way Inn', 12, '2019-07-25', 380, NULL),
('Hi-Way Inn', 12, '2019-07-26', 329, NULL),
('Hi-Way Inn', 12, '2019-07-27', 118, NULL),
('Hi-Way Inn', 12, '2019-07-28', 285, NULL),
('Hi-Way Inn', 12, '2019-07-29', 275, NULL),
('Hi-Way Inn', 12, '2019-07-30', 210, NULL),
('Hi-Way Inn', 12, '2019-07-31', 174, NULL),
('Hi-Way Inn', 12, '2019-08-01', 370, NULL),
('Hi-Way Inn', 12, '2019-08-02', 250, NULL),
('Hi-Way Inn', 12, '2019-08-03', 231, NULL),
('Hi-Way Inn', 12, '2019-08-04', 188, NULL),
('Hi-Way Inn', 12, '2019-08-05', 360, 29),
('Hi-Way Inn', 12, '2019-08-06', 221, 29),
('Hi-Way Inn', 12, '2019-08-07', 151, 29),
('Hi-Way Inn', 12, '2019-08-08', 164, 29),
('Hi-Way Inn', 12, '2019-08-09', 317, 29),
('Hi-Way Inn', 12, '2019-08-10', 111, 29),
('Hi-Way Inn', 12, '2019-08-11', 364, 29),
('Hi-Way Inn', 12, '2019-08-12', 328, 29),
('Hi-Way Inn', 12, '2019-08-13', 131, 29),
('Hi-Way Inn', 12, '2019-08-14', 146, NULL),
('Hi-Way Inn', 12, '2019-08-15', 114, NULL),
('Hi-Way Inn', 12, '2019-08-16', 291, NULL),
('Hi-Way Inn', 12, '2019-08-17', 169, NULL),
('Hi-Way Inn', 12, '2019-08-18', 177, NULL),
('Hi-Way Inn', 12, '2019-08-19', 143, NULL),
('Hi-Way Inn', 12, '2019-08-20', 235, NULL),
('Hi-Way Inn', 12, '2019-08-21', 384, NULL),
('Hi-Way Inn', 12, '2019-08-22', 215, NULL),
('Hi-Way Inn', 12, '2019-08-23', 284, NULL),
('Hi-Way Inn', 12, '2019-08-24', 354, NULL),
('Hi-Way Inn', 12, '2019-08-25', 344, NULL),
('Hi-Way Inn', 12, '2019-08-26', 302, NULL),
('Hi-Way Inn', 12, '2019-08-27', 156, NULL),
('Hi-Way Inn', 12, '2019-08-28', 129, NULL),
('Hi-Way Inn', 12, '2019-08-29', 276, NULL),
('Hi-Way Inn', 12, '2019-08-30', 314, NULL),
('Hi-Way Inn', 12, '2019-08-31', 231, NULL),
('Hi-Way Inn', 12, '2019-09-01', 343, NULL),
('Hi-Way Inn', 12, '2019-09-02', 382, NULL),
('Hi-Way Inn', 12, '2019-09-03', 322, NULL),
('Hi-Way Inn', 12, '2019-09-04', 194, 18),
('Hi-Way Inn', 12, '2019-09-05', 146, 18),
('Hi-Way Inn', 12, '2019-09-06', 349, 18),
('Hi-Way Inn', 12, '2019-09-07', 214, 18),
('Hi-Way Inn', 12, '2019-09-08', 133, 18),
('Hi-Way Inn', 12, '2019-09-09', 155, 18),
('Hi-Way Inn', 12, '2019-09-10', 181, 18),
('Hi-Way Inn', 12, '2019-09-11', 279, 18),
('Hi-Way Inn', 12, '2019-09-12', 310, 18),
('Hi-Way Inn', 12, '2019-09-13', 358, 18),
('Hi-Way Inn', 12, '2019-09-14', 211, 18),
('Hi-Way Inn', 12, '2019-09-15', 329, NULL),
('Hi-Way Inn', 12, '2019-09-16', 159, NULL),
('Hi-Way Inn', 12, '2019-09-17', 281, NULL),
('Hi-Way Inn', 12, '2019-09-18', 124, 88),
('Hi-Way Inn', 12, '2019-09-19', 164, 88),
('Hi-Way Inn', 12, '2019-09-20', 150, 88),
('Hi-Way Inn', 12, '2019-09-21', 132, 88),
('Hi-Way Inn', 12, '2019-09-22', 255, 88),
('Hi-Way Inn', 12, '2019-09-23', 176, 88),
('Hi-Way Inn', 12, '2019-09-24', 201, 88),
('Hi-Way Inn', 12, '2019-09-25', 309, 88),
('Hi-Way Inn', 12, '2019-09-26', 313, 88),
('Hi-Way Inn', 12, '2019-09-27', 115, 88),
('Hi-Way Inn', 12, '2019-09-28', 141, 88),
('Hi-Way Inn', 12, '2019-09-29', 166, 88),
('Hi-Way Inn', 12, '2019-09-30', 105, NULL),
('Hi-Way Inn', 12, '2019-10-01', 156, NULL),
('Hi-Way Inn', 12, '2019-10-02', 288, NULL),
('Hi-Way Inn', 12, '2019-10-03', 121, NULL),
('Hi-Way Inn', 12, '2019-10-04', 122, NULL),
('Hi-Way Inn', 12, '2019-10-05', 274, NULL),
('Hi-Way Inn', 12, '2019-10-06', 351, NULL),
('Hi-Way Inn', 12, '2019-10-07', 345, NULL),
('Hi-Way Inn', 12, '2019-10-08', 258, NULL),
('Hi-Way Inn', 12, '2019-10-09', 295, NULL),
('Hi-Way Inn', 12, '2019-10-10', 172, NULL),
('Hi-Way Inn', 12, '2019-10-11', 251, NULL),
('Hi-Way Inn', 12, '2019-10-12', 219, NULL),
('Hi-Way Inn', 12, '2019-10-13', 182, NULL),
('Hi-Way Inn', 12, '2019-10-14', 295, NULL),
('Hi-Way Inn', 12, '2019-10-15', 277, NULL),
('Hi-Way Inn', 12, '2019-10-16', 299, NULL),
('Hi-Way Inn', 12, '2019-10-17', 264, NULL),
('Hi-Way Inn', 12, '2019-10-18', 120, NULL),
('Hi-Way Inn', 12, '2019-10-19', 379, NULL),
('Hi-Way Inn', 12, '2019-10-20', 315, 56),
('Hi-Way Inn', 12, '2019-10-21', 313, 56),
('Hi-Way Inn', 12, '2019-10-22', 187, 56),
('Hi-Way Inn', 12, '2019-10-23', 309, 56),
('Hi-Way Inn', 12, '2019-10-24', 329, 56),
('Hi-Way Inn', 12, '2019-10-25', 145, 56),
('Hi-Way Inn', 12, '2019-10-26', 281, 56),
('Hi-Way Inn', 12, '2019-10-27', 299, 56),
('Hi-Way Inn', 12, '2019-10-28', 230, 56),
('Hi-Way Inn', 12, '2019-10-29', 288, 56),
('Hi-Way Inn', 12, '2019-10-30', 219, 56),
('Hi-Way Inn', 12, '2019-10-31', 337, 56),
('Hi-Way Inn', 12, '2019-11-01', 221, 56),
('Hi-Way Inn', 12, '2019-11-02', 158, 56),
('Hi-Way Inn', 12, '2019-11-03', 276, 56),
('Hi-Way Inn', 12, '2019-11-04', 370, 56),
('Hi-Way Inn', 12, '2019-11-05', 357, 56),
('Hi-Way Inn', 12, '2019-11-06', 241, 56),
('Hi-Way Inn', 12, '2019-11-07', 106, 56),
('Hi-Way Inn', 12, '2019-11-08', 252, 56),
('Hi-Way Inn', 12, '2019-11-09', 114, 56),
('Hi-Way Inn', 12, '2019-11-10', 268, 56),
('Hi-Way Inn', 12, '2019-11-11', 388, 56),
('Hi-Way Inn', 12, '2019-11-12', 344, 56),
('Hi-Way Inn', 12, '2019-11-13', 346, 56),
('Hi-Way Inn', 12, '2019-11-14', 323, 56),
('Hi-Way Inn', 12, '2019-11-15', 220, 56),
('Hi-Way Inn', 12, '2019-11-16', 127, 56),
('Hi-Way Inn', 12, '2019-11-17', 114, 56),
('Hi-Way Inn', 12, '2019-11-18', 262, NULL),
('Hi-Way Inn', 12, '2019-11-19', 140, NULL),
('Hi-Way Inn', 12, '2019-11-20', 212, NULL),
('Hi-Way Inn', 12, '2019-11-21', 161, NULL),
('Hi-Way Inn', 12, '2019-11-22', 364, NULL),
('Hi-Way Inn', 12, '2019-11-23', 161, NULL),
('Hi-Way Inn', 12, '2019-11-24', 156, NULL),
('Hi-Way Inn', 12, '2019-11-25', 316, NULL),
('Hi-Way Inn', 12, '2019-11-26', 274, NULL),
('Hi-Way Inn', 12, '2019-11-27', 135, NULL),
('Hi-Way Inn', 12, '2019-11-28', 287, NULL),
('Hi-Way Inn', 12, '2019-11-29', 191, NULL),
('Hi-Way Inn', 12, '2019-11-30', 124, NULL),
('Hi-Way Inn', 12, '2019-12-01', 151, NULL),
('Hi-Way Inn', 12, '2019-12-02', 110, NULL),
('Hi-Way Inn', 12, '2019-12-03', 254, NULL),
('Hi-Way Inn', 12, '2019-12-04', 179, NULL),
('Hi-Way Inn', 12, '2019-12-05', 184, NULL),
('Hi-Way Inn', 12, '2019-12-06', 277, NULL),
('Hi-Way Inn', 12, '2019-12-07', 218, NULL),
('Hi-Way Inn', 12, '2019-12-08', 136, NULL),
('Hi-Way Inn', 12, '2019-12-09', 120, NULL),
('Hi-Way Inn', 12, '2019-12-10', 261, NULL),
('Hi-Way Inn', 12, '2019-12-11', 237, NULL),
('Hi-Way Inn', 12, '2019-12-12', 270, NULL),
('Hi-Way Inn', 12, '2019-12-13', 123, NULL),
('Hi-Way Inn', 12, '2019-12-14', 343, NULL),
('Hi-Way Inn', 12, '2019-12-15', 204, NULL),
('Hi-Way Inn', 12, '2019-12-16', 140, NULL),
('Hi-Way Inn', 12, '2019-12-17', 330, NULL),
('Hi-Way Inn', 12, '2019-12-18', 368, NULL),
('Hi-Way Inn', 12, '2019-12-19', 399, NULL),
('Hi-Way Inn', 12, '2019-12-20', 132, NULL),
('Hi-Way Inn', 12, '2019-12-21', 289, NULL),
('Hi-Way Inn', 12, '2019-12-22', 397, NULL),
('Hi-Way Inn', 12, '2019-12-23', 143, NULL),
('Hi-Way Inn', 12, '2019-12-24', 143, 53),
('Hi-Way Inn', 12, '2019-12-25', 113, 53),
('Hi-Way Inn', 12, '2019-12-26', 351, 53),
('Hi-Way Inn', 12, '2019-12-27', 113, 53),
('Hi-Way Inn', 12, '2019-12-28', 241, 53),
('Hi-Way Inn', 12, '2019-12-29', 349, 53),
('Hi-Way Inn', 12, '2019-12-30', 300, 53),
('Hi-Way Inn', 12, '2019-12-31', 373, 53),
('Hi-Way Inn', 12, '2020-01-01', 121, 53),
('Hi-Way Inn', 12, '2020-01-02', 289, 53),
('Hi-Way Inn', 12, '2020-01-03', 147, 53),
('Hi-Way Inn', 12, '2020-01-04', 296, 53),
('Hi-Way Inn', 12, '2020-01-05', 269, NULL),
('Hi-Way Inn', 12, '2020-01-06', 362, NULL),
('Hi-Way Inn', 12, '2020-01-07', 144, NULL),
('Hi-Way Inn', 12, '2020-01-08', 386, NULL),
('Hi-Way Inn', 12, '2020-01-09', 108, NULL),
('Hi-Way Inn', 12, '2020-01-10', 235, NULL),
('Hi-Way Inn', 12, '2020-01-11', 313, NULL),
('Hi-Way Inn', 12, '2020-01-12', 316, NULL),
('Hi-Way Inn', 12, '2020-01-13', 345, 87),
('Hi-Way Inn', 12, '2020-01-14', 268, 87),
('Hi-Way Inn', 12, '2020-01-15', 362, 87),
('Hi-Way Inn', 12, '2020-01-16', 142, 87),
('Hi-Way Inn', 12, '2020-01-17', 216, 87),
('Hi-Way Inn', 12, '2020-01-18', 383, 87),
('Hi-Way Inn', 12, '2020-01-19', 232, 87),
('Hi-Way Inn', 12, '2020-01-20', 300, 87),
('Hi-Way Inn', 12, '2020-01-21', 222, 87),
('Hi-Way Inn', 12, '2020-01-22', 306, 87),
('Hi-Way Inn', 12, '2020-01-23', 266, 87),
('Hi-Way Inn', 12, '2020-01-24', 253, 87),
('Hi-Way Inn', 12, '2020-01-25', 122, 87),
('Hi-Way Inn', 12, '2020-01-26', 233, 87),
('Hi-Way Inn', 12, '2020-01-27', 217, 87),
('Hi-Way Inn', 12, '2020-01-28', 228, 87),
('Hi-Way Inn', 12, '2020-01-29', 240, NULL),
('Hi-Way Inn', 12, '2020-01-30', 278, NULL),
('Hi-Way Inn', 12, '2020-01-31', 126, NULL),
('Hi-Way Inn', 12, '2020-02-01', 265, NULL),
('Hi-Way Inn', 12, '2020-02-02', 146, NULL),
('Hi-Way Inn', 12, '2020-02-03', 138, NULL),
('Hi-Way Inn', 12, '2020-02-04', 187, NULL),
('Hi-Way Inn', 14, '2019-01-01', 134, NULL),
('Hi-Way Inn', 14, '2019-01-02', 159, NULL),
('Hi-Way Inn', 14, '2019-01-03', 182, NULL),
('Hi-Way Inn', 14, '2019-01-04', 132, NULL),
('Hi-Way Inn', 14, '2019-01-05', 383, NULL),
('Hi-Way Inn', 14, '2019-01-06', 303, NULL),
('Hi-Way Inn', 14, '2019-01-07', 348, NULL),
('Hi-Way Inn', 14, '2019-01-08', 363, NULL),
('Hi-Way Inn', 14, '2019-01-09', 217, NULL),
('Hi-Way Inn', 14, '2019-01-10', 362, NULL),
('Hi-Way Inn', 14, '2019-01-11', 321, NULL),
('Hi-Way Inn', 14, '2019-01-12', 151, NULL),
('Hi-Way Inn', 14, '2019-01-13', 227, NULL),
('Hi-Way Inn', 14, '2019-01-14', 137, NULL),
('Hi-Way Inn', 14, '2019-01-15', 375, NULL),
('Hi-Way Inn', 14, '2019-01-16', 103, NULL),
('Hi-Way Inn', 14, '2019-01-17', 246, NULL),
('Hi-Way Inn', 14, '2019-01-18', 352, NULL),
('Hi-Way Inn', 14, '2019-01-19', 110, NULL),
('Hi-Way Inn', 14, '2019-01-20', 328, NULL),
('Hi-Way Inn', 14, '2019-01-21', 157, NULL),
('Hi-Way Inn', 14, '2019-01-22', 123, NULL),
('Hi-Way Inn', 14, '2019-01-23', 108, NULL),
('Hi-Way Inn', 14, '2019-01-24', 340, NULL),
('Hi-Way Inn', 14, '2019-01-25', 269, NULL),
('Hi-Way Inn', 14, '2019-01-26', 155, NULL),
('Hi-Way Inn', 14, '2019-01-27', 110, NULL),
('Hi-Way Inn', 14, '2019-01-28', 270, NULL),
('Hi-Way Inn', 14, '2019-01-29', 102, NULL),
('Hi-Way Inn', 14, '2019-01-30', 387, NULL),
('Hi-Way Inn', 14, '2019-01-31', 344, NULL),
('Hi-Way Inn', 14, '2019-02-01', 225, NULL),
('Hi-Way Inn', 14, '2019-02-02', 276, NULL),
('Hi-Way Inn', 14, '2019-02-03', 136, NULL),
('Hi-Way Inn', 14, '2019-02-04', 248, NULL),
('Hi-Way Inn', 14, '2019-02-05', 270, NULL),
('Hi-Way Inn', 14, '2019-02-06', 223, NULL),
('Hi-Way Inn', 14, '2019-02-07', 328, NULL),
('Hi-Way Inn', 14, '2019-02-08', 317, NULL),
('Hi-Way Inn', 14, '2019-02-09', 383, NULL),
('Hi-Way Inn', 14, '2019-02-10', 391, NULL),
('Hi-Way Inn', 14, '2019-02-11', 169, NULL),
('Hi-Way Inn', 14, '2019-02-12', 303, NULL),
('Hi-Way Inn', 14, '2019-02-13', 262, NULL),
('Hi-Way Inn', 14, '2019-02-14', 296, NULL),
('Hi-Way Inn', 14, '2019-02-15', 304, NULL),
('Hi-Way Inn', 14, '2019-02-16', 338, NULL),
('Hi-Way Inn', 14, '2019-02-17', 174, NULL),
('Hi-Way Inn', 14, '2019-02-18', 398, 2),
('Hi-Way Inn', 14, '2019-02-19', 235, 2),
('Hi-Way Inn', 14, '2019-02-20', 295, 2),
('Hi-Way Inn', 14, '2019-02-21', 294, 2),
('Hi-Way Inn', 14, '2019-02-22', 270, 2),
('Hi-Way Inn', 14, '2019-02-23', 154, 2),
('Hi-Way Inn', 14, '2019-02-24', 356, 2),
('Hi-Way Inn', 14, '2019-02-25', 189, 2),
('Hi-Way Inn', 14, '2019-02-26', 126, 2),
('Hi-Way Inn', 14, '2019-02-27', 335, 2),
('Hi-Way Inn', 14, '2019-02-28', 370, 2),
('Hi-Way Inn', 14, '2019-03-01', 178, 2),
('Hi-Way Inn', 14, '2019-03-02', 344, 2),
('Hi-Way Inn', 14, '2019-03-03', 236, 2),
('Hi-Way Inn', 14, '2019-03-04', 211, 2),
('Hi-Way Inn', 14, '2019-03-05', 267, 2),
('Hi-Way Inn', 14, '2019-03-06', 259, 2),
('Hi-Way Inn', 14, '2019-03-07', 315, 2),
('Hi-Way Inn', 14, '2019-03-08', 120, 2),
('Hi-Way Inn', 14, '2019-03-09', 352, NULL),
('Hi-Way Inn', 14, '2019-03-10', 391, NULL),
('Hi-Way Inn', 14, '2019-03-11', 316, NULL),
('Hi-Way Inn', 14, '2019-03-12', 289, NULL),
('Hi-Way Inn', 14, '2019-03-13', 339, NULL),
('Hi-Way Inn', 14, '2019-03-14', 375, NULL),
('Hi-Way Inn', 14, '2019-03-15', 269, NULL),
('Hi-Way Inn', 14, '2019-03-16', 363, NULL),
('Hi-Way Inn', 14, '2019-03-17', 143, NULL),
('Hi-Way Inn', 14, '2019-03-18', 323, NULL),
('Hi-Way Inn', 14, '2019-03-19', 195, NULL),
('Hi-Way Inn', 14, '2019-03-20', 106, NULL),
('Hi-Way Inn', 14, '2019-03-21', 380, NULL),
('Hi-Way Inn', 14, '2019-03-22', 262, NULL),
('Hi-Way Inn', 14, '2019-03-23', 173, NULL),
('Hi-Way Inn', 14, '2019-03-24', 173, NULL),
('Hi-Way Inn', 14, '2019-03-25', 225, NULL),
('Hi-Way Inn', 14, '2019-03-26', 263, NULL),
('Hi-Way Inn', 14, '2019-03-27', 243, NULL),
('Hi-Way Inn', 14, '2019-03-28', 223, NULL),
('Hi-Way Inn', 14, '2019-03-29', 302, NULL),
('Hi-Way Inn', 14, '2019-03-30', 223, NULL),
('Hi-Way Inn', 14, '2019-03-31', 297, NULL),
('Hi-Way Inn', 14, '2019-04-01', 129, NULL),
('Hi-Way Inn', 14, '2019-04-02', 372, NULL),
('Hi-Way Inn', 14, '2019-04-03', 370, NULL),
('Hi-Way Inn', 14, '2019-04-04', 380, NULL),
('Hi-Way Inn', 14, '2019-04-05', 376, NULL),
('Hi-Way Inn', 14, '2019-04-06', 153, NULL),
('Hi-Way Inn', 14, '2019-04-07', 226, NULL),
('Hi-Way Inn', 14, '2019-04-08', 359, NULL),
('Hi-Way Inn', 14, '2019-04-09', 391, NULL),
('Hi-Way Inn', 14, '2019-04-10', 134, NULL),
('Hi-Way Inn', 14, '2019-04-11', 252, NULL),
('Hi-Way Inn', 14, '2019-04-12', 258, NULL),
('Hi-Way Inn', 14, '2019-04-13', 135, NULL),
('Hi-Way Inn', 14, '2019-04-14', 371, NULL),
('Hi-Way Inn', 14, '2019-04-15', 373, NULL),
('Hi-Way Inn', 14, '2019-04-16', 339, NULL),
('Hi-Way Inn', 14, '2019-04-17', 185, NULL),
('Hi-Way Inn', 14, '2019-04-18', 362, NULL),
('Hi-Way Inn', 14, '2019-04-19', 245, NULL),
('Hi-Way Inn', 14, '2019-04-20', 348, NULL),
('Hi-Way Inn', 14, '2019-04-21', 202, NULL),
('Hi-Way Inn', 14, '2019-04-22', 289, NULL),
('Hi-Way Inn', 14, '2019-04-23', 167, NULL),
('Hi-Way Inn', 14, '2019-04-24', 167, NULL),
('Hi-Way Inn', 14, '2019-04-25', 179, NULL),
('Hi-Way Inn', 14, '2019-04-26', 143, NULL),
('Hi-Way Inn', 14, '2019-04-27', 319, NULL),
('Hi-Way Inn', 14, '2019-04-28', 394, NULL),
('Hi-Way Inn', 14, '2019-04-29', 345, NULL),
('Hi-Way Inn', 14, '2019-04-30', 360, NULL),
('Hi-Way Inn', 14, '2019-05-01', 179, NULL),
('Hi-Way Inn', 14, '2019-05-02', 251, NULL),
('Hi-Way Inn', 14, '2019-05-03', 188, NULL),
('Hi-Way Inn', 14, '2019-05-04', 283, NULL),
('Hi-Way Inn', 14, '2019-05-05', 367, NULL),
('Hi-Way Inn', 14, '2019-05-06', 280, NULL),
('Hi-Way Inn', 14, '2019-05-07', 252, NULL),
('Hi-Way Inn', 14, '2019-05-08', 348, NULL),
('Hi-Way Inn', 14, '2019-05-09', 344, NULL),
('Hi-Way Inn', 14, '2019-05-10', 386, NULL),
('Hi-Way Inn', 14, '2019-05-11', 281, NULL),
('Hi-Way Inn', 14, '2019-05-12', 268, NULL),
('Hi-Way Inn', 14, '2019-05-13', 177, NULL),
('Hi-Way Inn', 14, '2019-05-14', 243, NULL),
('Hi-Way Inn', 14, '2019-05-15', 204, NULL),
('Hi-Way Inn', 14, '2019-05-16', 372, NULL),
('Hi-Way Inn', 14, '2019-05-17', 240, NULL),
('Hi-Way Inn', 14, '2019-05-18', 308, NULL),
('Hi-Way Inn', 14, '2019-05-19', 334, NULL),
('Hi-Way Inn', 14, '2019-05-20', 250, NULL),
('Hi-Way Inn', 14, '2019-05-21', 394, NULL),
('Hi-Way Inn', 14, '2019-05-22', 315, NULL),
('Hi-Way Inn', 14, '2019-05-23', 120, NULL),
('Hi-Way Inn', 14, '2019-05-24', 125, NULL),
('Hi-Way Inn', 14, '2019-05-25', 395, NULL),
('Hi-Way Inn', 14, '2019-05-26', 263, NULL),
('Hi-Way Inn', 14, '2019-05-27', 389, NULL),
('Hi-Way Inn', 14, '2019-05-28', 156, NULL),
('Hi-Way Inn', 14, '2019-05-29', 130, NULL),
('Hi-Way Inn', 14, '2019-05-30', 107, NULL),
('Hi-Way Inn', 14, '2019-05-31', 260, NULL),
('Hi-Way Inn', 14, '2019-06-01', 157, NULL),
('Hi-Way Inn', 14, '2019-06-02', 159, NULL),
('Hi-Way Inn', 14, '2019-06-03', 349, NULL),
('Hi-Way Inn', 14, '2019-06-04', 362, NULL),
('Hi-Way Inn', 14, '2019-06-05', 343, NULL),
('Hi-Way Inn', 14, '2019-06-06', 372, NULL),
('Hi-Way Inn', 14, '2019-06-07', 167, NULL),
('Hi-Way Inn', 14, '2019-06-08', 372, 116),
('Hi-Way Inn', 14, '2019-06-09', 362, 116),
('Hi-Way Inn', 14, '2019-06-10', 258, 116),
('Hi-Way Inn', 14, '2019-06-11', 268, 116),
('Hi-Way Inn', 14, '2019-06-12', 178, 116),
('Hi-Way Inn', 14, '2019-06-13', 303, 116),
('Hi-Way Inn', 14, '2019-06-14', 346, 116),
('Hi-Way Inn', 14, '2019-06-15', 104, 116),
('Hi-Way Inn', 14, '2019-06-16', 342, 116),
('Hi-Way Inn', 14, '2019-06-17', 331, 116),
('Hi-Way Inn', 14, '2019-06-18', 246, 116),
('Hi-Way Inn', 14, '2019-06-19', 332, 116),
('Hi-Way Inn', 14, '2019-06-20', 377, 116),
('Hi-Way Inn', 14, '2019-06-21', 107, 116),
('Hi-Way Inn', 14, '2019-06-22', 291, 116),
('Hi-Way Inn', 14, '2019-06-23', 171, 116),
('Hi-Way Inn', 14, '2019-06-24', 120, 116),
('Hi-Way Inn', 14, '2019-06-25', 234, 116),
('Hi-Way Inn', 14, '2019-06-26', 183, 116),
('Hi-Way Inn', 14, '2019-06-27', 265, 116),
('Hi-Way Inn', 14, '2019-06-28', 145, NULL),
('Hi-Way Inn', 14, '2019-06-29', 388, NULL),
('Hi-Way Inn', 14, '2019-06-30', 166, NULL),
('Hi-Way Inn', 14, '2019-07-01', 176, NULL),
('Hi-Way Inn', 14, '2019-07-02', 328, NULL),
('Hi-Way Inn', 14, '2019-07-03', 148, NULL),
('Hi-Way Inn', 14, '2019-07-04', 189, NULL),
('Hi-Way Inn', 14, '2019-07-05', 112, NULL),
('Hi-Way Inn', 14, '2019-07-06', 224, NULL),
('Hi-Way Inn', 14, '2019-07-07', 321, NULL),
('Hi-Way Inn', 14, '2019-07-08', 357, NULL),
('Hi-Way Inn', 14, '2019-07-09', 208, NULL),
('Hi-Way Inn', 14, '2019-07-10', 333, NULL),
('Hi-Way Inn', 14, '2019-07-11', 312, NULL),
('Hi-Way Inn', 14, '2019-07-12', 136, NULL),
('Hi-Way Inn', 14, '2019-07-13', 373, NULL),
('Hi-Way Inn', 14, '2019-07-14', 103, NULL),
('Hi-Way Inn', 14, '2019-07-15', 399, NULL),
('Hi-Way Inn', 14, '2019-07-16', 182, NULL),
('Hi-Way Inn', 14, '2019-07-17', 376, NULL),
('Hi-Way Inn', 14, '2019-07-18', 113, NULL),
('Hi-Way Inn', 14, '2019-07-19', 193, NULL),
('Hi-Way Inn', 14, '2019-07-20', 323, NULL),
('Hi-Way Inn', 14, '2019-07-21', 336, NULL),
('Hi-Way Inn', 14, '2019-07-22', 243, NULL),
('Hi-Way Inn', 14, '2019-07-23', 219, NULL),
('Hi-Way Inn', 14, '2019-07-24', 270, NULL),
('Hi-Way Inn', 14, '2019-07-25', 289, NULL),
('Hi-Way Inn', 14, '2019-07-26', 114, NULL),
('Hi-Way Inn', 14, '2019-07-27', 137, 77),
('Hi-Way Inn', 14, '2019-07-28', 101, 77),
('Hi-Way Inn', 14, '2019-07-29', 253, 77),
('Hi-Way Inn', 14, '2019-07-30', 345, 77),
('Hi-Way Inn', 14, '2019-07-31', 353, 77),
('Hi-Way Inn', 14, '2019-08-01', 235, 77),
('Hi-Way Inn', 14, '2019-08-02', 238, 77),
('Hi-Way Inn', 14, '2019-08-03', 350, 77),
('Hi-Way Inn', 14, '2019-08-04', 106, 77),
('Hi-Way Inn', 14, '2019-08-05', 124, 77),
('Hi-Way Inn', 14, '2019-08-06', 197, 77),
('Hi-Way Inn', 14, '2019-08-07', 201, 77),
('Hi-Way Inn', 14, '2019-08-08', 257, 77),
('Hi-Way Inn', 14, '2019-08-09', 366, 77),
('Hi-Way Inn', 14, '2019-08-10', 145, 77),
('Hi-Way Inn', 14, '2019-08-11', 245, 77),
('Hi-Way Inn', 14, '2019-08-12', 351, 77);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 14, '2019-08-13', 341, 77),
('Hi-Way Inn', 14, '2019-08-14', 265, 77),
('Hi-Way Inn', 14, '2019-08-15', 193, 77),
('Hi-Way Inn', 14, '2019-08-16', 202, 77),
('Hi-Way Inn', 14, '2019-08-17', 281, 77),
('Hi-Way Inn', 14, '2019-08-18', 167, 77),
('Hi-Way Inn', 14, '2019-08-19', 261, 77),
('Hi-Way Inn', 14, '2019-08-20', 164, 77),
('Hi-Way Inn', 14, '2019-08-21', 167, NULL),
('Hi-Way Inn', 14, '2019-08-22', 154, NULL),
('Hi-Way Inn', 14, '2019-08-23', 300, NULL),
('Hi-Way Inn', 14, '2019-08-24', 121, NULL),
('Hi-Way Inn', 14, '2019-08-25', 192, NULL),
('Hi-Way Inn', 14, '2019-08-26', 191, NULL),
('Hi-Way Inn', 14, '2019-08-27', 309, NULL),
('Hi-Way Inn', 14, '2019-08-28', 276, NULL),
('Hi-Way Inn', 14, '2019-08-29', 126, NULL),
('Hi-Way Inn', 14, '2019-08-30', 274, NULL),
('Hi-Way Inn', 14, '2019-08-31', 313, NULL),
('Hi-Way Inn', 14, '2019-09-01', 147, NULL),
('Hi-Way Inn', 14, '2019-09-02', 299, NULL),
('Hi-Way Inn', 14, '2019-09-03', 382, NULL),
('Hi-Way Inn', 14, '2019-09-04', 161, NULL),
('Hi-Way Inn', 14, '2019-09-05', 365, NULL),
('Hi-Way Inn', 14, '2019-09-06', 199, NULL),
('Hi-Way Inn', 14, '2019-09-07', 152, NULL),
('Hi-Way Inn', 14, '2019-09-08', 239, NULL),
('Hi-Way Inn', 14, '2019-09-09', 108, NULL),
('Hi-Way Inn', 14, '2019-09-10', 306, NULL),
('Hi-Way Inn', 14, '2019-09-11', 134, NULL),
('Hi-Way Inn', 14, '2019-09-12', 347, NULL),
('Hi-Way Inn', 14, '2019-09-13', 114, NULL),
('Hi-Way Inn', 14, '2019-09-14', 160, 65),
('Hi-Way Inn', 14, '2019-09-15', 288, 65),
('Hi-Way Inn', 14, '2019-09-16', 116, 65),
('Hi-Way Inn', 14, '2019-09-17', 159, 65),
('Hi-Way Inn', 14, '2019-09-18', 384, 65),
('Hi-Way Inn', 14, '2019-09-19', 337, 65),
('Hi-Way Inn', 14, '2019-09-20', 369, 65),
('Hi-Way Inn', 14, '2019-09-21', 325, 65),
('Hi-Way Inn', 14, '2019-09-22', 152, 65),
('Hi-Way Inn', 14, '2019-09-23', 252, 65),
('Hi-Way Inn', 14, '2019-09-24', 295, 65),
('Hi-Way Inn', 14, '2019-09-25', 256, 65),
('Hi-Way Inn', 14, '2019-09-26', 110, NULL),
('Hi-Way Inn', 14, '2019-09-27', 132, NULL),
('Hi-Way Inn', 14, '2019-09-28', 236, NULL),
('Hi-Way Inn', 14, '2019-09-29', 103, NULL),
('Hi-Way Inn', 14, '2019-09-30', 374, NULL),
('Hi-Way Inn', 14, '2019-10-01', 232, NULL),
('Hi-Way Inn', 14, '2019-10-02', 204, NULL),
('Hi-Way Inn', 14, '2019-10-03', 322, NULL),
('Hi-Way Inn', 14, '2019-10-04', 197, NULL),
('Hi-Way Inn', 14, '2019-10-05', 374, NULL),
('Hi-Way Inn', 14, '2019-10-06', 211, NULL),
('Hi-Way Inn', 14, '2019-10-07', 330, NULL),
('Hi-Way Inn', 14, '2019-10-08', 103, NULL),
('Hi-Way Inn', 14, '2019-10-09', 298, NULL),
('Hi-Way Inn', 14, '2019-10-10', 188, NULL),
('Hi-Way Inn', 14, '2019-10-11', 342, NULL),
('Hi-Way Inn', 14, '2019-10-12', 312, NULL),
('Hi-Way Inn', 14, '2019-10-13', 261, NULL),
('Hi-Way Inn', 14, '2019-10-14', 117, NULL),
('Hi-Way Inn', 14, '2019-10-15', 141, NULL),
('Hi-Way Inn', 14, '2019-10-16', 122, NULL),
('Hi-Way Inn', 14, '2019-10-17', 137, NULL),
('Hi-Way Inn', 14, '2019-10-18', 141, NULL),
('Hi-Way Inn', 14, '2019-10-19', 354, NULL),
('Hi-Way Inn', 14, '2019-10-20', 351, NULL),
('Hi-Way Inn', 14, '2019-10-21', 298, NULL),
('Hi-Way Inn', 14, '2019-10-22', 261, NULL),
('Hi-Way Inn', 14, '2019-10-23', 371, NULL),
('Hi-Way Inn', 14, '2019-10-24', 219, NULL),
('Hi-Way Inn', 14, '2019-10-25', 280, NULL),
('Hi-Way Inn', 14, '2019-10-26', 144, NULL),
('Hi-Way Inn', 14, '2019-10-27', 157, NULL),
('Hi-Way Inn', 14, '2019-10-28', 228, NULL),
('Hi-Way Inn', 14, '2019-10-29', 165, NULL),
('Hi-Way Inn', 14, '2019-10-30', 149, NULL),
('Hi-Way Inn', 14, '2019-10-31', 304, NULL),
('Hi-Way Inn', 14, '2019-11-01', 211, NULL),
('Hi-Way Inn', 14, '2019-11-02', 189, NULL),
('Hi-Way Inn', 14, '2019-11-03', 207, NULL),
('Hi-Way Inn', 14, '2019-11-04', 217, NULL),
('Hi-Way Inn', 14, '2019-11-05', 261, NULL),
('Hi-Way Inn', 14, '2019-11-06', 381, NULL),
('Hi-Way Inn', 14, '2019-11-07', 398, NULL),
('Hi-Way Inn', 14, '2019-11-08', 146, NULL),
('Hi-Way Inn', 14, '2019-11-09', 195, NULL),
('Hi-Way Inn', 14, '2019-11-10', 277, NULL),
('Hi-Way Inn', 14, '2019-11-11', 124, NULL),
('Hi-Way Inn', 14, '2019-11-12', 120, NULL),
('Hi-Way Inn', 14, '2019-11-13', 333, NULL),
('Hi-Way Inn', 14, '2019-11-14', 109, NULL),
('Hi-Way Inn', 14, '2019-11-15', 302, NULL),
('Hi-Way Inn', 14, '2019-11-16', 231, NULL),
('Hi-Way Inn', 14, '2019-11-17', 211, NULL),
('Hi-Way Inn', 14, '2019-11-18', 115, NULL),
('Hi-Way Inn', 14, '2019-11-19', 339, NULL),
('Hi-Way Inn', 14, '2019-11-20', 176, NULL),
('Hi-Way Inn', 14, '2019-11-21', 321, NULL),
('Hi-Way Inn', 14, '2019-11-22', 261, NULL),
('Hi-Way Inn', 14, '2019-11-23', 206, NULL),
('Hi-Way Inn', 14, '2019-11-24', 363, NULL),
('Hi-Way Inn', 14, '2019-11-25', 307, NULL),
('Hi-Way Inn', 14, '2019-11-26', 339, NULL),
('Hi-Way Inn', 14, '2019-11-27', 234, NULL),
('Hi-Way Inn', 14, '2019-11-28', 274, NULL),
('Hi-Way Inn', 14, '2019-11-29', 305, NULL),
('Hi-Way Inn', 14, '2019-11-30', 372, NULL),
('Hi-Way Inn', 14, '2019-12-01', 220, NULL),
('Hi-Way Inn', 14, '2019-12-02', 326, NULL),
('Hi-Way Inn', 14, '2019-12-03', 352, NULL),
('Hi-Way Inn', 14, '2019-12-04', 239, NULL),
('Hi-Way Inn', 14, '2019-12-05', 189, NULL),
('Hi-Way Inn', 14, '2019-12-06', 208, NULL),
('Hi-Way Inn', 14, '2019-12-07', 366, NULL),
('Hi-Way Inn', 14, '2019-12-08', 110, NULL),
('Hi-Way Inn', 14, '2019-12-09', 242, NULL),
('Hi-Way Inn', 14, '2019-12-10', 248, NULL),
('Hi-Way Inn', 14, '2019-12-11', 299, NULL),
('Hi-Way Inn', 14, '2019-12-12', 110, NULL),
('Hi-Way Inn', 14, '2019-12-13', 303, NULL),
('Hi-Way Inn', 14, '2019-12-14', 246, NULL),
('Hi-Way Inn', 14, '2019-12-15', 257, NULL),
('Hi-Way Inn', 14, '2019-12-16', 218, NULL),
('Hi-Way Inn', 14, '2019-12-17', 244, NULL),
('Hi-Way Inn', 14, '2019-12-18', 155, NULL),
('Hi-Way Inn', 14, '2019-12-19', 181, NULL),
('Hi-Way Inn', 14, '2019-12-20', 206, NULL),
('Hi-Way Inn', 14, '2019-12-21', 208, NULL),
('Hi-Way Inn', 14, '2019-12-22', 225, NULL),
('Hi-Way Inn', 14, '2019-12-23', 332, NULL),
('Hi-Way Inn', 14, '2019-12-24', 254, NULL),
('Hi-Way Inn', 14, '2019-12-25', 116, NULL),
('Hi-Way Inn', 14, '2019-12-26', 377, NULL),
('Hi-Way Inn', 14, '2019-12-27', 284, NULL),
('Hi-Way Inn', 14, '2019-12-28', 117, NULL),
('Hi-Way Inn', 14, '2019-12-29', 369, NULL),
('Hi-Way Inn', 14, '2019-12-30', 101, NULL),
('Hi-Way Inn', 14, '2019-12-31', 287, 69),
('Hi-Way Inn', 14, '2020-01-01', 274, 69),
('Hi-Way Inn', 14, '2020-01-02', 364, 69),
('Hi-Way Inn', 14, '2020-01-03', 382, 69),
('Hi-Way Inn', 14, '2020-01-04', 325, 69),
('Hi-Way Inn', 14, '2020-01-05', 190, 69),
('Hi-Way Inn', 14, '2020-01-06', 321, 69),
('Hi-Way Inn', 14, '2020-01-07', 369, 69),
('Hi-Way Inn', 14, '2020-01-08', 295, 69),
('Hi-Way Inn', 14, '2020-01-09', 236, 69),
('Hi-Way Inn', 14, '2020-01-10', 285, 69),
('Hi-Way Inn', 14, '2020-01-11', 201, 69),
('Hi-Way Inn', 14, '2020-01-12', 373, 69),
('Hi-Way Inn', 14, '2020-01-13', 381, 69),
('Hi-Way Inn', 14, '2020-01-14', 133, 69),
('Hi-Way Inn', 14, '2020-01-15', 288, NULL),
('Hi-Way Inn', 14, '2020-01-16', 353, NULL),
('Hi-Way Inn', 14, '2020-01-17', 138, NULL),
('Hi-Way Inn', 14, '2020-01-18', 308, NULL),
('Hi-Way Inn', 14, '2020-01-19', 122, NULL),
('Hi-Way Inn', 14, '2020-01-20', 349, NULL),
('Hi-Way Inn', 14, '2020-01-21', 158, NULL),
('Hi-Way Inn', 14, '2020-01-22', 352, NULL),
('Hi-Way Inn', 14, '2020-01-23', 291, NULL),
('Hi-Way Inn', 14, '2020-01-24', 149, NULL),
('Hi-Way Inn', 14, '2020-01-25', 165, NULL),
('Hi-Way Inn', 14, '2020-01-26', 218, NULL),
('Hi-Way Inn', 14, '2020-01-27', 356, NULL),
('Hi-Way Inn', 14, '2020-01-28', 155, NULL),
('Hi-Way Inn', 14, '2020-01-29', 208, NULL),
('Hi-Way Inn', 14, '2020-01-30', 326, NULL),
('Hi-Way Inn', 14, '2020-01-31', 249, NULL),
('Hi-Way Inn', 14, '2020-02-01', 308, NULL),
('Hi-Way Inn', 14, '2020-02-02', 301, NULL),
('Hi-Way Inn', 14, '2020-02-03', 323, NULL),
('Hi-Way Inn', 14, '2020-02-04', 106, NULL),
('Hi-Way Inn', 72, '2019-01-01', 272, NULL),
('Hi-Way Inn', 72, '2019-01-02', 120, NULL),
('Hi-Way Inn', 72, '2019-01-03', 352, NULL),
('Hi-Way Inn', 72, '2019-01-04', 345, NULL),
('Hi-Way Inn', 72, '2019-01-05', 396, NULL),
('Hi-Way Inn', 72, '2019-01-06', 154, NULL),
('Hi-Way Inn', 72, '2019-01-07', 312, NULL),
('Hi-Way Inn', 72, '2019-01-08', 340, NULL),
('Hi-Way Inn', 72, '2019-01-09', 356, NULL),
('Hi-Way Inn', 72, '2019-01-10', 290, NULL),
('Hi-Way Inn', 72, '2019-01-11', 171, NULL),
('Hi-Way Inn', 72, '2019-01-12', 328, NULL),
('Hi-Way Inn', 72, '2019-01-13', 103, NULL),
('Hi-Way Inn', 72, '2019-01-14', 166, NULL),
('Hi-Way Inn', 72, '2019-01-15', 332, NULL),
('Hi-Way Inn', 72, '2019-01-16', 275, NULL),
('Hi-Way Inn', 72, '2019-01-17', 292, NULL),
('Hi-Way Inn', 72, '2019-01-18', 362, NULL),
('Hi-Way Inn', 72, '2019-01-19', 157, NULL),
('Hi-Way Inn', 72, '2019-01-20', 223, NULL),
('Hi-Way Inn', 72, '2019-01-21', 292, NULL),
('Hi-Way Inn', 72, '2019-01-22', 182, NULL),
('Hi-Way Inn', 72, '2019-01-23', 254, NULL),
('Hi-Way Inn', 72, '2019-01-24', 194, NULL),
('Hi-Way Inn', 72, '2019-01-25', 339, NULL),
('Hi-Way Inn', 72, '2019-01-26', 188, NULL),
('Hi-Way Inn', 72, '2019-01-27', 136, NULL),
('Hi-Way Inn', 72, '2019-01-28', 191, NULL),
('Hi-Way Inn', 72, '2019-01-29', 346, NULL),
('Hi-Way Inn', 72, '2019-01-30', 195, NULL),
('Hi-Way Inn', 72, '2019-01-31', 248, NULL),
('Hi-Way Inn', 72, '2019-02-01', 100, NULL),
('Hi-Way Inn', 72, '2019-02-02', 331, NULL),
('Hi-Way Inn', 72, '2019-02-03', 245, NULL),
('Hi-Way Inn', 72, '2019-02-04', 280, NULL),
('Hi-Way Inn', 72, '2019-02-05', 366, NULL),
('Hi-Way Inn', 72, '2019-02-06', 268, NULL),
('Hi-Way Inn', 72, '2019-02-07', 374, NULL),
('Hi-Way Inn', 72, '2019-02-08', 290, NULL),
('Hi-Way Inn', 72, '2019-02-09', 263, NULL),
('Hi-Way Inn', 72, '2019-02-10', 383, NULL),
('Hi-Way Inn', 72, '2019-02-11', 366, NULL),
('Hi-Way Inn', 72, '2019-02-12', 146, NULL),
('Hi-Way Inn', 72, '2019-02-13', 267, NULL),
('Hi-Way Inn', 72, '2019-02-14', 195, NULL),
('Hi-Way Inn', 72, '2019-02-15', 360, NULL),
('Hi-Way Inn', 72, '2019-02-16', 280, NULL),
('Hi-Way Inn', 72, '2019-02-17', 153, NULL),
('Hi-Way Inn', 72, '2019-02-18', 361, NULL),
('Hi-Way Inn', 72, '2019-02-19', 336, NULL),
('Hi-Way Inn', 72, '2019-02-20', 101, NULL),
('Hi-Way Inn', 72, '2019-02-21', 223, NULL),
('Hi-Way Inn', 72, '2019-02-22', 338, NULL),
('Hi-Way Inn', 72, '2019-02-23', 141, NULL),
('Hi-Way Inn', 72, '2019-02-24', 127, NULL),
('Hi-Way Inn', 72, '2019-02-25', 323, NULL),
('Hi-Way Inn', 72, '2019-02-26', 290, NULL),
('Hi-Way Inn', 72, '2019-02-27', 154, NULL),
('Hi-Way Inn', 72, '2019-02-28', 158, NULL),
('Hi-Way Inn', 72, '2019-03-01', 315, NULL),
('Hi-Way Inn', 72, '2019-03-02', 344, NULL),
('Hi-Way Inn', 72, '2019-03-03', 338, 57),
('Hi-Way Inn', 72, '2019-03-04', 145, 34),
('Hi-Way Inn', 72, '2019-03-05', 193, 34),
('Hi-Way Inn', 72, '2019-03-06', 239, 34),
('Hi-Way Inn', 72, '2019-03-07', 310, 34),
('Hi-Way Inn', 72, '2019-03-08', 152, 34),
('Hi-Way Inn', 72, '2019-03-09', 135, 34),
('Hi-Way Inn', 72, '2019-03-10', 250, 34),
('Hi-Way Inn', 72, '2019-03-11', 339, 34),
('Hi-Way Inn', 72, '2019-03-12', 273, 34),
('Hi-Way Inn', 72, '2019-03-13', 366, 34),
('Hi-Way Inn', 72, '2019-03-14', 112, 34),
('Hi-Way Inn', 72, '2019-03-15', 241, 34),
('Hi-Way Inn', 72, '2019-03-16', 197, 34),
('Hi-Way Inn', 72, '2019-03-17', 387, 34),
('Hi-Way Inn', 72, '2019-03-18', 232, 34),
('Hi-Way Inn', 72, '2019-03-19', 281, 34),
('Hi-Way Inn', 72, '2019-03-20', 228, 34),
('Hi-Way Inn', 72, '2019-03-21', 148, 34),
('Hi-Way Inn', 72, '2019-03-22', 165, 34),
('Hi-Way Inn', 72, '2019-03-23', 125, 34),
('Hi-Way Inn', 72, '2019-03-24', 384, 34),
('Hi-Way Inn', 72, '2019-03-25', 167, 34),
('Hi-Way Inn', 72, '2019-03-26', 235, 34),
('Hi-Way Inn', 72, '2019-03-27', 317, 34),
('Hi-Way Inn', 72, '2019-03-28', 183, 34),
('Hi-Way Inn', 72, '2019-03-29', 316, 34),
('Hi-Way Inn', 72, '2019-03-30', 271, 34),
('Hi-Way Inn', 72, '2019-03-31', 145, 34),
('Hi-Way Inn', 72, '2019-04-01', 287, 34),
('Hi-Way Inn', 72, '2019-04-02', 345, NULL),
('Hi-Way Inn', 72, '2019-04-03', 163, NULL),
('Hi-Way Inn', 72, '2019-04-04', 306, NULL),
('Hi-Way Inn', 72, '2019-04-05', 318, NULL),
('Hi-Way Inn', 72, '2019-04-06', 190, NULL),
('Hi-Way Inn', 72, '2019-04-07', 265, NULL),
('Hi-Way Inn', 72, '2019-04-08', 252, NULL),
('Hi-Way Inn', 72, '2019-04-09', 215, NULL),
('Hi-Way Inn', 72, '2019-04-10', 124, NULL),
('Hi-Way Inn', 72, '2019-04-11', 299, NULL),
('Hi-Way Inn', 72, '2019-04-12', 370, NULL),
('Hi-Way Inn', 72, '2019-04-13', 312, NULL),
('Hi-Way Inn', 72, '2019-04-14', 292, NULL),
('Hi-Way Inn', 72, '2019-04-15', 340, NULL),
('Hi-Way Inn', 72, '2019-04-16', 246, NULL),
('Hi-Way Inn', 72, '2019-04-17', 353, NULL),
('Hi-Way Inn', 72, '2019-04-18', 253, NULL),
('Hi-Way Inn', 72, '2019-04-19', 368, NULL),
('Hi-Way Inn', 72, '2019-04-20', 266, NULL),
('Hi-Way Inn', 72, '2019-04-21', 166, NULL),
('Hi-Way Inn', 72, '2019-04-22', 109, NULL),
('Hi-Way Inn', 72, '2019-04-23', 151, NULL),
('Hi-Way Inn', 72, '2019-04-24', 240, NULL),
('Hi-Way Inn', 72, '2019-04-25', 276, NULL),
('Hi-Way Inn', 72, '2019-04-26', 215, NULL),
('Hi-Way Inn', 72, '2019-04-27', 292, NULL),
('Hi-Way Inn', 72, '2019-04-28', 336, NULL),
('Hi-Way Inn', 72, '2019-04-29', 326, NULL),
('Hi-Way Inn', 72, '2019-04-30', 182, NULL),
('Hi-Way Inn', 72, '2019-05-01', 219, NULL),
('Hi-Way Inn', 72, '2019-05-02', 348, NULL),
('Hi-Way Inn', 72, '2019-05-03', 126, NULL),
('Hi-Way Inn', 72, '2019-05-04', 360, NULL),
('Hi-Way Inn', 72, '2019-05-05', 110, NULL),
('Hi-Way Inn', 72, '2019-05-06', 187, NULL),
('Hi-Way Inn', 72, '2019-05-07', 208, NULL),
('Hi-Way Inn', 72, '2019-05-08', 315, NULL),
('Hi-Way Inn', 72, '2019-05-09', 168, NULL),
('Hi-Way Inn', 72, '2019-05-10', 316, NULL),
('Hi-Way Inn', 72, '2019-05-11', 182, NULL),
('Hi-Way Inn', 72, '2019-05-12', 128, NULL),
('Hi-Way Inn', 72, '2019-05-13', 319, NULL),
('Hi-Way Inn', 72, '2019-05-14', 351, NULL),
('Hi-Way Inn', 72, '2019-05-15', 204, NULL),
('Hi-Way Inn', 72, '2019-05-16', 206, NULL),
('Hi-Way Inn', 72, '2019-05-17', 242, NULL),
('Hi-Way Inn', 72, '2019-05-18', 188, NULL),
('Hi-Way Inn', 72, '2019-05-19', 228, NULL),
('Hi-Way Inn', 72, '2019-05-20', 335, NULL),
('Hi-Way Inn', 72, '2019-05-21', 362, NULL),
('Hi-Way Inn', 72, '2019-05-22', 385, NULL),
('Hi-Way Inn', 72, '2019-05-23', 272, NULL),
('Hi-Way Inn', 72, '2019-05-24', 108, NULL),
('Hi-Way Inn', 72, '2019-05-25', 210, NULL),
('Hi-Way Inn', 72, '2019-05-26', 276, NULL),
('Hi-Way Inn', 72, '2019-05-27', 172, NULL),
('Hi-Way Inn', 72, '2019-05-28', 138, NULL),
('Hi-Way Inn', 72, '2019-05-29', 243, NULL),
('Hi-Way Inn', 72, '2019-05-30', 234, NULL),
('Hi-Way Inn', 72, '2019-05-31', 244, NULL),
('Hi-Way Inn', 72, '2019-06-01', 294, NULL),
('Hi-Way Inn', 72, '2019-06-02', 237, NULL),
('Hi-Way Inn', 72, '2019-06-03', 147, NULL),
('Hi-Way Inn', 72, '2019-06-04', 269, NULL),
('Hi-Way Inn', 72, '2019-06-05', 261, NULL),
('Hi-Way Inn', 72, '2019-06-06', 180, NULL),
('Hi-Way Inn', 72, '2019-06-07', 389, NULL),
('Hi-Way Inn', 72, '2019-06-08', 309, NULL),
('Hi-Way Inn', 72, '2019-06-09', 239, NULL),
('Hi-Way Inn', 72, '2019-06-10', 232, NULL),
('Hi-Way Inn', 72, '2019-06-11', 312, NULL),
('Hi-Way Inn', 72, '2019-06-12', 171, NULL),
('Hi-Way Inn', 72, '2019-06-13', 112, NULL),
('Hi-Way Inn', 72, '2019-06-14', 150, NULL),
('Hi-Way Inn', 72, '2019-06-15', 359, NULL),
('Hi-Way Inn', 72, '2019-06-16', 373, NULL),
('Hi-Way Inn', 72, '2019-06-17', 144, NULL),
('Hi-Way Inn', 72, '2019-06-18', 383, NULL),
('Hi-Way Inn', 72, '2019-06-19', 161, NULL),
('Hi-Way Inn', 72, '2019-06-20', 223, NULL),
('Hi-Way Inn', 72, '2019-06-21', 221, NULL),
('Hi-Way Inn', 72, '2019-06-22', 242, NULL),
('Hi-Way Inn', 72, '2019-06-23', 193, NULL),
('Hi-Way Inn', 72, '2019-06-24', 275, NULL),
('Hi-Way Inn', 72, '2019-06-25', 169, NULL),
('Hi-Way Inn', 72, '2019-06-26', 125, NULL),
('Hi-Way Inn', 72, '2019-06-27', 305, NULL),
('Hi-Way Inn', 72, '2019-06-28', 160, NULL),
('Hi-Way Inn', 72, '2019-06-29', 298, NULL),
('Hi-Way Inn', 72, '2019-06-30', 341, NULL),
('Hi-Way Inn', 72, '2019-07-01', 175, NULL),
('Hi-Way Inn', 72, '2019-07-02', 293, NULL),
('Hi-Way Inn', 72, '2019-07-03', 382, NULL),
('Hi-Way Inn', 72, '2019-07-04', 152, NULL),
('Hi-Way Inn', 72, '2019-07-05', 281, NULL),
('Hi-Way Inn', 72, '2019-07-06', 387, NULL),
('Hi-Way Inn', 72, '2019-07-07', 118, NULL),
('Hi-Way Inn', 72, '2019-07-08', 229, NULL),
('Hi-Way Inn', 72, '2019-07-09', 215, NULL),
('Hi-Way Inn', 72, '2019-07-10', 233, NULL),
('Hi-Way Inn', 72, '2019-07-11', 287, NULL),
('Hi-Way Inn', 72, '2019-07-12', 117, NULL),
('Hi-Way Inn', 72, '2019-07-13', 193, NULL),
('Hi-Way Inn', 72, '2019-07-14', 240, NULL),
('Hi-Way Inn', 72, '2019-07-15', 228, NULL),
('Hi-Way Inn', 72, '2019-07-16', 311, NULL),
('Hi-Way Inn', 72, '2019-07-17', 266, NULL),
('Hi-Way Inn', 72, '2019-07-18', 190, NULL),
('Hi-Way Inn', 72, '2019-07-19', 112, NULL),
('Hi-Way Inn', 72, '2019-07-20', 356, NULL),
('Hi-Way Inn', 72, '2019-07-21', 234, NULL),
('Hi-Way Inn', 72, '2019-07-22', 146, NULL),
('Hi-Way Inn', 72, '2019-07-23', 210, NULL),
('Hi-Way Inn', 72, '2019-07-24', 375, NULL),
('Hi-Way Inn', 72, '2019-07-25', 206, NULL),
('Hi-Way Inn', 72, '2019-07-26', 382, NULL),
('Hi-Way Inn', 72, '2019-07-27', 228, NULL),
('Hi-Way Inn', 72, '2019-07-28', 153, NULL),
('Hi-Way Inn', 72, '2019-07-29', 343, NULL),
('Hi-Way Inn', 72, '2019-07-30', 396, NULL),
('Hi-Way Inn', 72, '2019-07-31', 242, NULL),
('Hi-Way Inn', 72, '2019-08-01', 263, NULL),
('Hi-Way Inn', 72, '2019-08-02', 341, NULL),
('Hi-Way Inn', 72, '2019-08-03', 357, NULL),
('Hi-Way Inn', 72, '2019-08-04', 167, NULL),
('Hi-Way Inn', 72, '2019-08-05', 341, NULL),
('Hi-Way Inn', 72, '2019-08-06', 225, NULL),
('Hi-Way Inn', 72, '2019-08-07', 154, NULL),
('Hi-Way Inn', 72, '2019-08-08', 393, NULL),
('Hi-Way Inn', 72, '2019-08-09', 178, NULL),
('Hi-Way Inn', 72, '2019-08-10', 294, NULL),
('Hi-Way Inn', 72, '2019-08-11', 334, NULL),
('Hi-Way Inn', 72, '2019-08-12', 371, NULL),
('Hi-Way Inn', 72, '2019-08-13', 311, NULL),
('Hi-Way Inn', 72, '2019-08-14', 187, NULL),
('Hi-Way Inn', 72, '2019-08-15', 223, NULL),
('Hi-Way Inn', 72, '2019-08-16', 338, NULL),
('Hi-Way Inn', 72, '2019-08-17', 198, NULL),
('Hi-Way Inn', 72, '2019-08-18', 204, NULL),
('Hi-Way Inn', 72, '2019-08-19', 179, NULL),
('Hi-Way Inn', 72, '2019-08-20', 314, NULL),
('Hi-Way Inn', 72, '2019-08-21', 182, NULL),
('Hi-Way Inn', 72, '2019-08-22', 328, NULL),
('Hi-Way Inn', 72, '2019-08-23', 250, NULL),
('Hi-Way Inn', 72, '2019-08-24', 343, NULL),
('Hi-Way Inn', 72, '2019-08-25', 125, NULL),
('Hi-Way Inn', 72, '2019-08-26', 249, NULL),
('Hi-Way Inn', 72, '2019-08-27', 379, NULL),
('Hi-Way Inn', 72, '2019-08-28', 293, NULL),
('Hi-Way Inn', 72, '2019-08-29', 300, NULL),
('Hi-Way Inn', 72, '2019-08-30', 332, NULL),
('Hi-Way Inn', 72, '2019-08-31', 174, NULL),
('Hi-Way Inn', 72, '2019-09-01', 206, NULL),
('Hi-Way Inn', 72, '2019-09-02', 251, NULL),
('Hi-Way Inn', 72, '2019-09-03', 245, NULL),
('Hi-Way Inn', 72, '2019-09-04', 122, NULL),
('Hi-Way Inn', 72, '2019-09-05', 387, NULL),
('Hi-Way Inn', 72, '2019-09-06', 146, NULL),
('Hi-Way Inn', 72, '2019-09-07', 315, NULL),
('Hi-Way Inn', 72, '2019-09-08', 398, NULL),
('Hi-Way Inn', 72, '2019-09-09', 278, NULL),
('Hi-Way Inn', 72, '2019-09-10', 291, NULL),
('Hi-Way Inn', 72, '2019-09-11', 336, NULL),
('Hi-Way Inn', 72, '2019-09-12', 105, NULL),
('Hi-Way Inn', 72, '2019-09-13', 296, NULL),
('Hi-Way Inn', 72, '2019-09-14', 369, NULL),
('Hi-Way Inn', 72, '2019-09-15', 354, NULL),
('Hi-Way Inn', 72, '2019-09-16', 306, NULL),
('Hi-Way Inn', 72, '2019-09-17', 153, NULL),
('Hi-Way Inn', 72, '2019-09-18', 247, NULL),
('Hi-Way Inn', 72, '2019-09-19', 194, NULL),
('Hi-Way Inn', 72, '2019-09-20', 394, NULL),
('Hi-Way Inn', 72, '2019-09-21', 229, NULL),
('Hi-Way Inn', 72, '2019-09-22', 193, NULL),
('Hi-Way Inn', 72, '2019-09-23', 336, NULL),
('Hi-Way Inn', 72, '2019-09-24', 175, NULL),
('Hi-Way Inn', 72, '2019-09-25', 255, NULL),
('Hi-Way Inn', 72, '2019-09-26', 111, NULL),
('Hi-Way Inn', 72, '2019-09-27', 216, NULL),
('Hi-Way Inn', 72, '2019-09-28', 361, NULL),
('Hi-Way Inn', 72, '2019-09-29', 214, NULL),
('Hi-Way Inn', 72, '2019-09-30', 257, NULL),
('Hi-Way Inn', 72, '2019-10-01', 292, NULL),
('Hi-Way Inn', 72, '2019-10-02', 358, NULL),
('Hi-Way Inn', 72, '2019-10-03', 250, NULL),
('Hi-Way Inn', 72, '2019-10-04', 218, NULL),
('Hi-Way Inn', 72, '2019-10-05', 351, NULL),
('Hi-Way Inn', 72, '2019-10-06', 201, NULL),
('Hi-Way Inn', 72, '2019-10-07', 215, NULL),
('Hi-Way Inn', 72, '2019-10-08', 243, NULL),
('Hi-Way Inn', 72, '2019-10-09', 205, NULL),
('Hi-Way Inn', 72, '2019-10-10', 325, NULL),
('Hi-Way Inn', 72, '2019-10-11', 258, NULL),
('Hi-Way Inn', 72, '2019-10-12', 200, NULL),
('Hi-Way Inn', 72, '2019-10-13', 359, NULL),
('Hi-Way Inn', 72, '2019-10-14', 201, NULL),
('Hi-Way Inn', 72, '2019-10-15', 371, NULL),
('Hi-Way Inn', 72, '2019-10-16', 213, NULL),
('Hi-Way Inn', 72, '2019-10-17', 392, NULL),
('Hi-Way Inn', 72, '2019-10-18', 246, NULL),
('Hi-Way Inn', 72, '2019-10-19', 235, NULL),
('Hi-Way Inn', 72, '2019-10-20', 110, NULL),
('Hi-Way Inn', 72, '2019-10-21', 151, NULL),
('Hi-Way Inn', 72, '2019-10-22', 346, NULL),
('Hi-Way Inn', 72, '2019-10-23', 229, NULL),
('Hi-Way Inn', 72, '2019-10-24', 309, NULL),
('Hi-Way Inn', 72, '2019-10-25', 263, NULL),
('Hi-Way Inn', 72, '2019-10-26', 375, NULL),
('Hi-Way Inn', 72, '2019-10-27', 387, NULL),
('Hi-Way Inn', 72, '2019-10-28', 350, NULL),
('Hi-Way Inn', 72, '2019-10-29', 161, NULL),
('Hi-Way Inn', 72, '2019-10-30', 288, NULL),
('Hi-Way Inn', 72, '2019-10-31', 107, NULL),
('Hi-Way Inn', 72, '2019-11-01', 291, NULL),
('Hi-Way Inn', 72, '2019-11-02', 372, NULL),
('Hi-Way Inn', 72, '2019-11-03', 108, NULL),
('Hi-Way Inn', 72, '2019-11-04', 177, NULL),
('Hi-Way Inn', 72, '2019-11-05', 135, NULL),
('Hi-Way Inn', 72, '2019-11-06', 182, NULL),
('Hi-Way Inn', 72, '2019-11-07', 372, NULL),
('Hi-Way Inn', 72, '2019-11-08', 173, NULL),
('Hi-Way Inn', 72, '2019-11-09', 232, NULL),
('Hi-Way Inn', 72, '2019-11-10', 183, NULL),
('Hi-Way Inn', 72, '2019-11-11', 255, NULL),
('Hi-Way Inn', 72, '2019-11-12', 366, NULL),
('Hi-Way Inn', 72, '2019-11-13', 229, NULL),
('Hi-Way Inn', 72, '2019-11-14', 379, NULL),
('Hi-Way Inn', 72, '2019-11-15', 152, NULL),
('Hi-Way Inn', 72, '2019-11-16', 374, NULL),
('Hi-Way Inn', 72, '2019-11-17', 314, NULL),
('Hi-Way Inn', 72, '2019-11-18', 292, NULL),
('Hi-Way Inn', 72, '2019-11-19', 275, NULL),
('Hi-Way Inn', 72, '2019-11-20', 147, NULL),
('Hi-Way Inn', 72, '2019-11-21', 124, NULL),
('Hi-Way Inn', 72, '2019-11-22', 116, NULL),
('Hi-Way Inn', 72, '2019-11-23', 146, NULL),
('Hi-Way Inn', 72, '2019-11-24', 348, NULL),
('Hi-Way Inn', 72, '2019-11-25', 186, NULL),
('Hi-Way Inn', 72, '2019-11-26', 174, NULL),
('Hi-Way Inn', 72, '2019-11-27', 364, NULL),
('Hi-Way Inn', 72, '2019-11-28', 112, NULL),
('Hi-Way Inn', 72, '2019-11-29', 249, NULL),
('Hi-Way Inn', 72, '2019-11-30', 188, NULL),
('Hi-Way Inn', 72, '2019-12-01', 249, NULL),
('Hi-Way Inn', 72, '2019-12-02', 301, NULL),
('Hi-Way Inn', 72, '2019-12-03', 301, NULL),
('Hi-Way Inn', 72, '2019-12-04', 259, NULL),
('Hi-Way Inn', 72, '2019-12-05', 294, NULL),
('Hi-Way Inn', 72, '2019-12-06', 110, NULL),
('Hi-Way Inn', 72, '2019-12-07', 179, NULL),
('Hi-Way Inn', 72, '2019-12-08', 342, NULL),
('Hi-Way Inn', 72, '2019-12-09', 152, NULL),
('Hi-Way Inn', 72, '2019-12-10', 359, NULL),
('Hi-Way Inn', 72, '2019-12-11', 382, NULL),
('Hi-Way Inn', 72, '2019-12-12', 240, NULL),
('Hi-Way Inn', 72, '2019-12-13', 145, NULL),
('Hi-Way Inn', 72, '2019-12-14', 103, NULL),
('Hi-Way Inn', 72, '2019-12-15', 271, NULL),
('Hi-Way Inn', 72, '2019-12-16', 272, NULL),
('Hi-Way Inn', 72, '2019-12-17', 130, NULL),
('Hi-Way Inn', 72, '2019-12-18', 174, NULL),
('Hi-Way Inn', 72, '2019-12-19', 209, NULL),
('Hi-Way Inn', 72, '2019-12-20', 237, NULL),
('Hi-Way Inn', 72, '2019-12-21', 373, NULL),
('Hi-Way Inn', 72, '2019-12-22', 133, NULL),
('Hi-Way Inn', 72, '2019-12-23', 231, NULL),
('Hi-Way Inn', 72, '2019-12-24', 142, NULL),
('Hi-Way Inn', 72, '2019-12-25', 139, NULL),
('Hi-Way Inn', 72, '2019-12-26', 131, NULL),
('Hi-Way Inn', 72, '2019-12-27', 380, NULL),
('Hi-Way Inn', 72, '2019-12-28', 361, NULL),
('Hi-Way Inn', 72, '2019-12-29', 399, NULL),
('Hi-Way Inn', 72, '2019-12-30', 103, NULL),
('Hi-Way Inn', 72, '2019-12-31', 214, NULL),
('Hi-Way Inn', 72, '2020-01-01', 306, NULL),
('Hi-Way Inn', 72, '2020-01-02', 257, NULL),
('Hi-Way Inn', 72, '2020-01-03', 169, NULL),
('Hi-Way Inn', 72, '2020-01-04', 337, NULL),
('Hi-Way Inn', 72, '2020-01-05', 344, NULL),
('Hi-Way Inn', 72, '2020-01-06', 122, NULL),
('Hi-Way Inn', 72, '2020-01-07', 111, NULL),
('Hi-Way Inn', 72, '2020-01-08', 219, NULL),
('Hi-Way Inn', 72, '2020-01-09', 158, NULL),
('Hi-Way Inn', 72, '2020-01-10', 320, NULL),
('Hi-Way Inn', 72, '2020-01-11', 268, NULL),
('Hi-Way Inn', 72, '2020-01-12', 215, NULL),
('Hi-Way Inn', 72, '2020-01-13', 169, NULL),
('Hi-Way Inn', 72, '2020-01-14', 361, NULL),
('Hi-Way Inn', 72, '2020-01-15', 256, NULL),
('Hi-Way Inn', 72, '2020-01-16', 339, NULL),
('Hi-Way Inn', 72, '2020-01-17', 242, NULL),
('Hi-Way Inn', 72, '2020-01-18', 293, NULL),
('Hi-Way Inn', 72, '2020-01-19', 115, NULL),
('Hi-Way Inn', 72, '2020-01-20', 148, NULL),
('Hi-Way Inn', 72, '2020-01-21', 327, NULL),
('Hi-Way Inn', 72, '2020-01-22', 142, NULL),
('Hi-Way Inn', 72, '2020-01-23', 258, NULL),
('Hi-Way Inn', 72, '2020-01-24', 190, NULL),
('Hi-Way Inn', 72, '2020-01-25', 359, NULL),
('Hi-Way Inn', 72, '2020-01-26', 291, NULL),
('Hi-Way Inn', 72, '2020-01-27', 132, NULL),
('Hi-Way Inn', 72, '2020-01-28', 292, NULL),
('Hi-Way Inn', 72, '2020-01-29', 219, NULL),
('Hi-Way Inn', 72, '2020-01-30', 395, NULL),
('Hi-Way Inn', 72, '2020-01-31', 166, NULL),
('Hi-Way Inn', 72, '2020-02-01', 344, NULL),
('Hi-Way Inn', 72, '2020-02-02', 369, NULL),
('Hi-Way Inn', 72, '2020-02-03', 201, NULL),
('Hi-Way Inn', 72, '2020-02-04', 167, NULL),
('Hi-Way Inn', 76, '2019-01-01', 257, NULL),
('Hi-Way Inn', 76, '2019-01-02', 323, NULL),
('Hi-Way Inn', 76, '2019-01-03', 217, NULL),
('Hi-Way Inn', 76, '2019-01-04', 329, NULL),
('Hi-Way Inn', 76, '2019-01-05', 132, NULL),
('Hi-Way Inn', 76, '2019-01-06', 362, NULL),
('Hi-Way Inn', 76, '2019-01-07', 117, NULL),
('Hi-Way Inn', 76, '2019-01-08', 213, NULL),
('Hi-Way Inn', 76, '2019-01-09', 127, NULL),
('Hi-Way Inn', 76, '2019-01-10', 268, NULL),
('Hi-Way Inn', 76, '2019-01-11', 392, NULL),
('Hi-Way Inn', 76, '2019-01-12', 184, NULL),
('Hi-Way Inn', 76, '2019-01-13', 331, NULL),
('Hi-Way Inn', 76, '2019-01-14', 323, NULL),
('Hi-Way Inn', 76, '2019-01-15', 134, NULL),
('Hi-Way Inn', 76, '2019-01-16', 364, NULL),
('Hi-Way Inn', 76, '2019-01-17', 321, NULL),
('Hi-Way Inn', 76, '2019-01-18', 355, NULL),
('Hi-Way Inn', 76, '2019-01-19', 355, NULL),
('Hi-Way Inn', 76, '2019-01-20', 334, NULL),
('Hi-Way Inn', 76, '2019-01-21', 290, NULL),
('Hi-Way Inn', 76, '2019-01-22', 139, NULL),
('Hi-Way Inn', 76, '2019-01-23', 245, NULL),
('Hi-Way Inn', 76, '2019-01-24', 151, NULL),
('Hi-Way Inn', 76, '2019-01-25', 188, NULL),
('Hi-Way Inn', 76, '2019-01-26', 374, NULL),
('Hi-Way Inn', 76, '2019-01-27', 251, NULL),
('Hi-Way Inn', 76, '2019-01-28', 345, NULL),
('Hi-Way Inn', 76, '2019-01-29', 122, NULL),
('Hi-Way Inn', 76, '2019-01-30', 315, NULL),
('Hi-Way Inn', 76, '2019-01-31', 107, NULL),
('Hi-Way Inn', 76, '2019-02-01', 326, NULL),
('Hi-Way Inn', 76, '2019-02-02', 127, NULL),
('Hi-Way Inn', 76, '2019-02-03', 118, NULL),
('Hi-Way Inn', 76, '2019-02-04', 255, 167),
('Hi-Way Inn', 76, '2019-02-05', 322, 167),
('Hi-Way Inn', 76, '2019-02-06', 269, 167),
('Hi-Way Inn', 76, '2019-02-07', 189, 167),
('Hi-Way Inn', 76, '2019-02-08', 398, 167),
('Hi-Way Inn', 76, '2019-02-09', 364, 167),
('Hi-Way Inn', 76, '2019-02-10', 342, 167),
('Hi-Way Inn', 76, '2019-02-11', 324, 167),
('Hi-Way Inn', 76, '2019-02-12', 319, 167),
('Hi-Way Inn', 76, '2019-02-13', 152, 167),
('Hi-Way Inn', 76, '2019-02-14', 288, 167),
('Hi-Way Inn', 76, '2019-02-15', 189, 167),
('Hi-Way Inn', 76, '2019-02-16', 287, 167),
('Hi-Way Inn', 76, '2019-02-17', 147, 167),
('Hi-Way Inn', 76, '2019-02-18', 213, 167),
('Hi-Way Inn', 76, '2019-02-19', 276, 167),
('Hi-Way Inn', 76, '2019-02-20', 117, 167),
('Hi-Way Inn', 76, '2019-02-21', 135, 167),
('Hi-Way Inn', 76, '2019-02-22', 179, 167),
('Hi-Way Inn', 76, '2019-02-23', 144, 167),
('Hi-Way Inn', 76, '2019-02-24', 366, 167),
('Hi-Way Inn', 76, '2019-02-25', 346, 167),
('Hi-Way Inn', 76, '2019-02-26', 371, 167),
('Hi-Way Inn', 76, '2019-02-27', 266, 167),
('Hi-Way Inn', 76, '2019-02-28', 182, 167),
('Hi-Way Inn', 76, '2019-03-01', 343, 167),
('Hi-Way Inn', 76, '2019-03-02', 289, 167),
('Hi-Way Inn', 76, '2019-03-03', 285, 167),
('Hi-Way Inn', 76, '2019-03-04', 290, 167),
('Hi-Way Inn', 76, '2019-03-05', 364, 167),
('Hi-Way Inn', 76, '2019-03-06', 317, NULL),
('Hi-Way Inn', 76, '2019-03-07', 207, NULL),
('Hi-Way Inn', 76, '2019-03-08', 300, 197),
('Hi-Way Inn', 76, '2019-03-09', 120, 197),
('Hi-Way Inn', 76, '2019-03-10', 278, 197),
('Hi-Way Inn', 76, '2019-03-11', 349, 197),
('Hi-Way Inn', 76, '2019-03-12', 100, 197),
('Hi-Way Inn', 76, '2019-03-13', 114, 197),
('Hi-Way Inn', 76, '2019-03-14', 236, 197),
('Hi-Way Inn', 76, '2019-03-15', 298, 197),
('Hi-Way Inn', 76, '2019-03-16', 395, 197),
('Hi-Way Inn', 76, '2019-03-17', 208, 197),
('Hi-Way Inn', 76, '2019-03-18', 390, NULL),
('Hi-Way Inn', 76, '2019-03-19', 121, NULL),
('Hi-Way Inn', 76, '2019-03-20', 123, NULL),
('Hi-Way Inn', 76, '2019-03-21', 100, NULL),
('Hi-Way Inn', 76, '2019-03-22', 239, NULL),
('Hi-Way Inn', 76, '2019-03-23', 305, NULL),
('Hi-Way Inn', 76, '2019-03-24', 398, NULL),
('Hi-Way Inn', 76, '2019-03-25', 360, NULL),
('Hi-Way Inn', 76, '2019-03-26', 289, NULL),
('Hi-Way Inn', 76, '2019-03-27', 159, NULL),
('Hi-Way Inn', 76, '2019-03-28', 150, NULL),
('Hi-Way Inn', 76, '2019-03-29', 273, NULL),
('Hi-Way Inn', 76, '2019-03-30', 287, NULL),
('Hi-Way Inn', 76, '2019-03-31', 337, NULL),
('Hi-Way Inn', 76, '2019-04-01', 347, NULL),
('Hi-Way Inn', 76, '2019-04-02', 209, NULL),
('Hi-Way Inn', 76, '2019-04-03', 204, NULL),
('Hi-Way Inn', 76, '2019-04-04', 292, NULL),
('Hi-Way Inn', 76, '2019-04-05', 363, NULL),
('Hi-Way Inn', 76, '2019-04-06', 392, NULL),
('Hi-Way Inn', 76, '2019-04-07', 246, NULL),
('Hi-Way Inn', 76, '2019-04-08', 384, NULL),
('Hi-Way Inn', 76, '2019-04-09', 104, NULL),
('Hi-Way Inn', 76, '2019-04-10', 118, NULL),
('Hi-Way Inn', 76, '2019-04-11', 341, NULL),
('Hi-Way Inn', 76, '2019-04-12', 377, NULL),
('Hi-Way Inn', 76, '2019-04-13', 157, NULL),
('Hi-Way Inn', 76, '2019-04-14', 247, NULL),
('Hi-Way Inn', 76, '2019-04-15', 183, NULL),
('Hi-Way Inn', 76, '2019-04-16', 112, NULL),
('Hi-Way Inn', 76, '2019-04-17', 209, NULL),
('Hi-Way Inn', 76, '2019-04-18', 378, NULL),
('Hi-Way Inn', 76, '2019-04-19', 104, NULL),
('Hi-Way Inn', 76, '2019-04-20', 188, NULL),
('Hi-Way Inn', 76, '2019-04-21', 125, NULL),
('Hi-Way Inn', 76, '2019-04-22', 178, NULL),
('Hi-Way Inn', 76, '2019-04-23', 154, NULL),
('Hi-Way Inn', 76, '2019-04-24', 302, NULL),
('Hi-Way Inn', 76, '2019-04-25', 143, NULL),
('Hi-Way Inn', 76, '2019-04-26', 245, NULL),
('Hi-Way Inn', 76, '2019-04-27', 100, NULL),
('Hi-Way Inn', 76, '2019-04-28', 398, NULL),
('Hi-Way Inn', 76, '2019-04-29', 194, NULL),
('Hi-Way Inn', 76, '2019-04-30', 332, NULL),
('Hi-Way Inn', 76, '2019-05-01', 160, NULL),
('Hi-Way Inn', 76, '2019-05-02', 288, NULL),
('Hi-Way Inn', 76, '2019-05-03', 268, NULL),
('Hi-Way Inn', 76, '2019-05-04', 250, NULL),
('Hi-Way Inn', 76, '2019-05-05', 249, NULL),
('Hi-Way Inn', 76, '2019-05-06', 297, NULL),
('Hi-Way Inn', 76, '2019-05-07', 182, NULL),
('Hi-Way Inn', 76, '2019-05-08', 131, NULL),
('Hi-Way Inn', 76, '2019-05-09', 310, NULL),
('Hi-Way Inn', 76, '2019-05-10', 323, NULL),
('Hi-Way Inn', 76, '2019-05-11', 270, NULL),
('Hi-Way Inn', 76, '2019-05-12', 336, NULL),
('Hi-Way Inn', 76, '2019-05-13', 365, NULL),
('Hi-Way Inn', 76, '2019-05-14', 325, NULL),
('Hi-Way Inn', 76, '2019-05-15', 307, NULL),
('Hi-Way Inn', 76, '2019-05-16', 116, NULL),
('Hi-Way Inn', 76, '2019-05-17', 389, NULL),
('Hi-Way Inn', 76, '2019-05-18', 215, NULL),
('Hi-Way Inn', 76, '2019-05-19', 342, NULL),
('Hi-Way Inn', 76, '2019-05-20', 224, NULL),
('Hi-Way Inn', 76, '2019-05-21', 232, NULL),
('Hi-Way Inn', 76, '2019-05-22', 280, NULL),
('Hi-Way Inn', 76, '2019-05-23', 300, NULL),
('Hi-Way Inn', 76, '2019-05-24', 365, NULL),
('Hi-Way Inn', 76, '2019-05-25', 366, NULL),
('Hi-Way Inn', 76, '2019-05-26', 192, NULL),
('Hi-Way Inn', 76, '2019-05-27', 193, NULL),
('Hi-Way Inn', 76, '2019-05-28', 122, NULL),
('Hi-Way Inn', 76, '2019-05-29', 129, NULL),
('Hi-Way Inn', 76, '2019-05-30', 151, NULL),
('Hi-Way Inn', 76, '2019-05-31', 343, NULL),
('Hi-Way Inn', 76, '2019-06-01', 300, NULL),
('Hi-Way Inn', 76, '2019-06-02', 309, NULL),
('Hi-Way Inn', 76, '2019-06-03', 192, NULL),
('Hi-Way Inn', 76, '2019-06-04', 158, NULL),
('Hi-Way Inn', 76, '2019-06-05', 174, NULL),
('Hi-Way Inn', 76, '2019-06-06', 286, NULL),
('Hi-Way Inn', 76, '2019-06-07', 144, NULL),
('Hi-Way Inn', 76, '2019-06-08', 328, NULL),
('Hi-Way Inn', 76, '2019-06-09', 310, NULL),
('Hi-Way Inn', 76, '2019-06-10', 285, NULL),
('Hi-Way Inn', 76, '2019-06-11', 359, NULL),
('Hi-Way Inn', 76, '2019-06-12', 221, NULL),
('Hi-Way Inn', 76, '2019-06-13', 151, NULL),
('Hi-Way Inn', 76, '2019-06-14', 214, NULL),
('Hi-Way Inn', 76, '2019-06-15', 181, NULL),
('Hi-Way Inn', 76, '2019-06-16', 136, NULL),
('Hi-Way Inn', 76, '2019-06-17', 227, NULL),
('Hi-Way Inn', 76, '2019-06-18', 179, NULL),
('Hi-Way Inn', 76, '2019-06-19', 308, NULL),
('Hi-Way Inn', 76, '2019-06-20', 187, NULL),
('Hi-Way Inn', 76, '2019-06-21', 386, NULL),
('Hi-Way Inn', 76, '2019-06-22', 238, NULL),
('Hi-Way Inn', 76, '2019-06-23', 354, NULL),
('Hi-Way Inn', 76, '2019-06-24', 318, NULL),
('Hi-Way Inn', 76, '2019-06-25', 346, NULL),
('Hi-Way Inn', 76, '2019-06-26', 276, NULL),
('Hi-Way Inn', 76, '2019-06-27', 332, NULL),
('Hi-Way Inn', 76, '2019-06-28', 268, NULL),
('Hi-Way Inn', 76, '2019-06-29', 226, NULL),
('Hi-Way Inn', 76, '2019-06-30', 209, NULL),
('Hi-Way Inn', 76, '2019-07-01', 244, NULL),
('Hi-Way Inn', 76, '2019-07-02', 378, NULL),
('Hi-Way Inn', 76, '2019-07-03', 167, NULL),
('Hi-Way Inn', 76, '2019-07-04', 396, NULL),
('Hi-Way Inn', 76, '2019-07-05', 372, NULL),
('Hi-Way Inn', 76, '2019-07-06', 265, NULL),
('Hi-Way Inn', 76, '2019-07-07', 125, NULL),
('Hi-Way Inn', 76, '2019-07-08', 276, NULL),
('Hi-Way Inn', 76, '2019-07-09', 355, NULL),
('Hi-Way Inn', 76, '2019-07-10', 366, NULL),
('Hi-Way Inn', 76, '2019-07-11', 398, NULL),
('Hi-Way Inn', 76, '2019-07-12', 376, NULL),
('Hi-Way Inn', 76, '2019-07-13', 348, NULL),
('Hi-Way Inn', 76, '2019-07-14', 194, NULL),
('Hi-Way Inn', 76, '2019-07-15', 142, NULL),
('Hi-Way Inn', 76, '2019-07-16', 310, NULL),
('Hi-Way Inn', 76, '2019-07-17', 103, NULL),
('Hi-Way Inn', 76, '2019-07-18', 209, NULL),
('Hi-Way Inn', 76, '2019-07-19', 182, NULL),
('Hi-Way Inn', 76, '2019-07-20', 109, NULL),
('Hi-Way Inn', 76, '2019-07-21', 361, NULL),
('Hi-Way Inn', 76, '2019-07-22', 199, NULL),
('Hi-Way Inn', 76, '2019-07-23', 295, NULL),
('Hi-Way Inn', 76, '2019-07-24', 365, NULL),
('Hi-Way Inn', 76, '2019-07-25', 363, NULL),
('Hi-Way Inn', 76, '2019-07-26', 269, NULL),
('Hi-Way Inn', 76, '2019-07-27', 330, NULL),
('Hi-Way Inn', 76, '2019-07-28', 362, NULL),
('Hi-Way Inn', 76, '2019-07-29', 255, NULL),
('Hi-Way Inn', 76, '2019-07-30', 246, NULL),
('Hi-Way Inn', 76, '2019-07-31', 350, NULL),
('Hi-Way Inn', 76, '2019-08-01', 211, NULL),
('Hi-Way Inn', 76, '2019-08-02', 293, NULL),
('Hi-Way Inn', 76, '2019-08-03', 335, NULL),
('Hi-Way Inn', 76, '2019-08-04', 117, NULL),
('Hi-Way Inn', 76, '2019-08-05', 332, NULL),
('Hi-Way Inn', 76, '2019-08-06', 133, NULL),
('Hi-Way Inn', 76, '2019-08-07', 364, NULL),
('Hi-Way Inn', 76, '2019-08-08', 194, NULL),
('Hi-Way Inn', 76, '2019-08-09', 296, NULL),
('Hi-Way Inn', 76, '2019-08-10', 333, NULL),
('Hi-Way Inn', 76, '2019-08-11', 234, NULL),
('Hi-Way Inn', 76, '2019-08-12', 103, NULL),
('Hi-Way Inn', 76, '2019-08-13', 136, NULL),
('Hi-Way Inn', 76, '2019-08-14', 343, NULL),
('Hi-Way Inn', 76, '2019-08-15', 138, NULL),
('Hi-Way Inn', 76, '2019-08-16', 386, NULL),
('Hi-Way Inn', 76, '2019-08-17', 346, NULL),
('Hi-Way Inn', 76, '2019-08-18', 120, NULL),
('Hi-Way Inn', 76, '2019-08-19', 310, NULL),
('Hi-Way Inn', 76, '2019-08-20', 379, NULL),
('Hi-Way Inn', 76, '2019-08-21', 312, NULL),
('Hi-Way Inn', 76, '2019-08-22', 176, NULL),
('Hi-Way Inn', 76, '2019-08-23', 251, NULL),
('Hi-Way Inn', 76, '2019-08-24', 354, NULL),
('Hi-Way Inn', 76, '2019-08-25', 252, NULL),
('Hi-Way Inn', 76, '2019-08-26', 274, NULL),
('Hi-Way Inn', 76, '2019-08-27', 267, NULL),
('Hi-Way Inn', 76, '2019-08-28', 240, NULL),
('Hi-Way Inn', 76, '2019-08-29', 125, NULL),
('Hi-Way Inn', 76, '2019-08-30', 137, NULL),
('Hi-Way Inn', 76, '2019-08-31', 128, NULL),
('Hi-Way Inn', 76, '2019-09-01', 188, NULL),
('Hi-Way Inn', 76, '2019-09-02', 258, NULL),
('Hi-Way Inn', 76, '2019-09-03', 278, NULL),
('Hi-Way Inn', 76, '2019-09-04', 329, NULL),
('Hi-Way Inn', 76, '2019-09-05', 142, NULL),
('Hi-Way Inn', 76, '2019-09-06', 334, NULL),
('Hi-Way Inn', 76, '2019-09-07', 123, NULL),
('Hi-Way Inn', 76, '2019-09-08', 273, NULL),
('Hi-Way Inn', 76, '2019-09-09', 364, NULL),
('Hi-Way Inn', 76, '2019-09-10', 135, NULL),
('Hi-Way Inn', 76, '2019-09-11', 275, NULL),
('Hi-Way Inn', 76, '2019-09-12', 282, NULL),
('Hi-Way Inn', 76, '2019-09-13', 139, NULL),
('Hi-Way Inn', 76, '2019-09-14', 362, NULL),
('Hi-Way Inn', 76, '2019-09-15', 207, NULL),
('Hi-Way Inn', 76, '2019-09-16', 180, NULL),
('Hi-Way Inn', 76, '2019-09-17', 188, NULL),
('Hi-Way Inn', 76, '2019-09-18', 284, NULL),
('Hi-Way Inn', 76, '2019-09-19', 158, NULL),
('Hi-Way Inn', 76, '2019-09-20', 162, NULL),
('Hi-Way Inn', 76, '2019-09-21', 371, NULL),
('Hi-Way Inn', 76, '2019-09-22', 111, NULL),
('Hi-Way Inn', 76, '2019-09-23', 221, NULL),
('Hi-Way Inn', 76, '2019-09-24', 190, NULL),
('Hi-Way Inn', 76, '2019-09-25', 109, NULL),
('Hi-Way Inn', 76, '2019-09-26', 126, NULL),
('Hi-Way Inn', 76, '2019-09-27', 283, NULL),
('Hi-Way Inn', 76, '2019-09-28', 396, NULL),
('Hi-Way Inn', 76, '2019-09-29', 364, NULL),
('Hi-Way Inn', 76, '2019-09-30', 360, NULL),
('Hi-Way Inn', 76, '2019-10-01', 362, NULL),
('Hi-Way Inn', 76, '2019-10-02', 177, NULL),
('Hi-Way Inn', 76, '2019-10-03', 185, NULL),
('Hi-Way Inn', 76, '2019-10-04', 100, NULL),
('Hi-Way Inn', 76, '2019-10-05', 230, NULL),
('Hi-Way Inn', 76, '2019-10-06', 271, NULL),
('Hi-Way Inn', 76, '2019-10-07', 285, NULL),
('Hi-Way Inn', 76, '2019-10-08', 207, NULL),
('Hi-Way Inn', 76, '2019-10-09', 331, NULL),
('Hi-Way Inn', 76, '2019-10-10', 363, NULL),
('Hi-Way Inn', 76, '2019-10-11', 166, NULL),
('Hi-Way Inn', 76, '2019-10-12', 265, NULL),
('Hi-Way Inn', 76, '2019-10-13', 312, NULL),
('Hi-Way Inn', 76, '2019-10-14', 251, NULL),
('Hi-Way Inn', 76, '2019-10-15', 136, NULL),
('Hi-Way Inn', 76, '2019-10-16', 300, NULL),
('Hi-Way Inn', 76, '2019-10-17', 252, NULL),
('Hi-Way Inn', 76, '2019-10-18', 108, NULL),
('Hi-Way Inn', 76, '2019-10-19', 311, NULL),
('Hi-Way Inn', 76, '2019-10-20', 298, NULL),
('Hi-Way Inn', 76, '2019-10-21', 362, NULL),
('Hi-Way Inn', 76, '2019-10-22', 248, NULL),
('Hi-Way Inn', 76, '2019-10-23', 231, NULL),
('Hi-Way Inn', 76, '2019-10-24', 188, NULL),
('Hi-Way Inn', 76, '2019-10-25', 379, NULL),
('Hi-Way Inn', 76, '2019-10-26', 145, NULL),
('Hi-Way Inn', 76, '2019-10-27', 166, NULL),
('Hi-Way Inn', 76, '2019-10-28', 367, NULL),
('Hi-Way Inn', 76, '2019-10-29', 212, NULL),
('Hi-Way Inn', 76, '2019-10-30', 292, NULL),
('Hi-Way Inn', 76, '2019-10-31', 127, NULL),
('Hi-Way Inn', 76, '2019-11-01', 123, NULL),
('Hi-Way Inn', 76, '2019-11-02', 293, NULL),
('Hi-Way Inn', 76, '2019-11-03', 121, NULL),
('Hi-Way Inn', 76, '2019-11-04', 135, NULL),
('Hi-Way Inn', 76, '2019-11-05', 394, NULL),
('Hi-Way Inn', 76, '2019-11-06', 269, NULL),
('Hi-Way Inn', 76, '2019-11-07', 267, NULL),
('Hi-Way Inn', 76, '2019-11-08', 327, NULL),
('Hi-Way Inn', 76, '2019-11-09', 178, NULL),
('Hi-Way Inn', 76, '2019-11-10', 282, NULL),
('Hi-Way Inn', 76, '2019-11-11', 206, NULL),
('Hi-Way Inn', 76, '2019-11-12', 169, NULL),
('Hi-Way Inn', 76, '2019-11-13', 343, NULL),
('Hi-Way Inn', 76, '2019-11-14', 269, NULL),
('Hi-Way Inn', 76, '2019-11-15', 354, NULL),
('Hi-Way Inn', 76, '2019-11-16', 179, NULL),
('Hi-Way Inn', 76, '2019-11-17', 236, NULL),
('Hi-Way Inn', 76, '2019-11-18', 116, NULL),
('Hi-Way Inn', 76, '2019-11-19', 259, NULL),
('Hi-Way Inn', 76, '2019-11-20', 108, NULL),
('Hi-Way Inn', 76, '2019-11-21', 155, NULL),
('Hi-Way Inn', 76, '2019-11-22', 295, NULL),
('Hi-Way Inn', 76, '2019-11-23', 312, NULL),
('Hi-Way Inn', 76, '2019-11-24', 253, NULL),
('Hi-Way Inn', 76, '2019-11-25', 208, NULL),
('Hi-Way Inn', 76, '2019-11-26', 354, NULL),
('Hi-Way Inn', 76, '2019-11-27', 121, NULL),
('Hi-Way Inn', 76, '2019-11-28', 237, NULL),
('Hi-Way Inn', 76, '2019-11-29', 231, NULL),
('Hi-Way Inn', 76, '2019-11-30', 325, NULL),
('Hi-Way Inn', 76, '2019-12-01', 184, NULL),
('Hi-Way Inn', 76, '2019-12-02', 127, NULL),
('Hi-Way Inn', 76, '2019-12-03', 349, NULL),
('Hi-Way Inn', 76, '2019-12-04', 176, NULL),
('Hi-Way Inn', 76, '2019-12-05', 204, NULL),
('Hi-Way Inn', 76, '2019-12-06', 128, NULL),
('Hi-Way Inn', 76, '2019-12-07', 295, NULL),
('Hi-Way Inn', 76, '2019-12-08', 378, NULL),
('Hi-Way Inn', 76, '2019-12-09', 235, NULL),
('Hi-Way Inn', 76, '2019-12-10', 349, NULL),
('Hi-Way Inn', 76, '2019-12-11', 315, NULL),
('Hi-Way Inn', 76, '2019-12-12', 171, NULL),
('Hi-Way Inn', 76, '2019-12-13', 317, NULL),
('Hi-Way Inn', 76, '2019-12-14', 278, NULL),
('Hi-Way Inn', 76, '2019-12-15', 185, NULL),
('Hi-Way Inn', 76, '2019-12-16', 305, NULL),
('Hi-Way Inn', 76, '2019-12-17', 117, NULL),
('Hi-Way Inn', 76, '2019-12-18', 306, NULL),
('Hi-Way Inn', 76, '2019-12-19', 101, NULL),
('Hi-Way Inn', 76, '2019-12-20', 165, NULL),
('Hi-Way Inn', 76, '2019-12-21', 242, NULL),
('Hi-Way Inn', 76, '2019-12-22', 189, NULL),
('Hi-Way Inn', 76, '2019-12-23', 360, NULL),
('Hi-Way Inn', 76, '2019-12-24', 147, NULL),
('Hi-Way Inn', 76, '2019-12-25', 250, NULL),
('Hi-Way Inn', 76, '2019-12-26', 327, NULL),
('Hi-Way Inn', 76, '2019-12-27', 351, NULL),
('Hi-Way Inn', 76, '2019-12-28', 155, NULL),
('Hi-Way Inn', 76, '2019-12-29', 186, NULL),
('Hi-Way Inn', 76, '2019-12-30', 113, NULL),
('Hi-Way Inn', 76, '2019-12-31', 113, NULL),
('Hi-Way Inn', 76, '2020-01-01', 308, NULL),
('Hi-Way Inn', 76, '2020-01-02', 392, NULL),
('Hi-Way Inn', 76, '2020-01-03', 197, NULL),
('Hi-Way Inn', 76, '2020-01-04', 313, NULL),
('Hi-Way Inn', 76, '2020-01-05', 151, NULL),
('Hi-Way Inn', 76, '2020-01-06', 147, NULL),
('Hi-Way Inn', 76, '2020-01-07', 250, NULL),
('Hi-Way Inn', 76, '2020-01-08', 107, NULL),
('Hi-Way Inn', 76, '2020-01-09', 282, NULL),
('Hi-Way Inn', 76, '2020-01-10', 347, NULL),
('Hi-Way Inn', 76, '2020-01-11', 338, NULL),
('Hi-Way Inn', 76, '2020-01-12', 158, NULL),
('Hi-Way Inn', 76, '2020-01-13', 205, NULL),
('Hi-Way Inn', 76, '2020-01-14', 106, NULL),
('Hi-Way Inn', 76, '2020-01-15', 316, NULL),
('Hi-Way Inn', 76, '2020-01-16', 235, NULL),
('Hi-Way Inn', 76, '2020-01-17', 397, NULL),
('Hi-Way Inn', 76, '2020-01-18', 139, NULL),
('Hi-Way Inn', 76, '2020-01-19', 109, NULL),
('Hi-Way Inn', 76, '2020-01-20', 192, NULL),
('Hi-Way Inn', 76, '2020-01-21', 159, NULL),
('Hi-Way Inn', 76, '2020-01-22', 152, NULL),
('Hi-Way Inn', 76, '2020-01-23', 319, NULL),
('Hi-Way Inn', 76, '2020-01-24', 102, NULL),
('Hi-Way Inn', 76, '2020-01-25', 301, NULL),
('Hi-Way Inn', 76, '2020-01-26', 103, NULL),
('Hi-Way Inn', 76, '2020-01-27', 390, NULL),
('Hi-Way Inn', 76, '2020-01-28', 295, NULL),
('Hi-Way Inn', 76, '2020-01-29', 371, NULL),
('Hi-Way Inn', 76, '2020-01-30', 296, NULL),
('Hi-Way Inn', 76, '2020-01-31', 286, NULL),
('Hi-Way Inn', 76, '2020-02-01', 398, NULL),
('Hi-Way Inn', 76, '2020-02-02', 241, NULL),
('Hi-Way Inn', 76, '2020-02-03', 236, NULL),
('Hi-Way Inn', 76, '2020-02-04', 120, NULL),
('Hi-Way Inn', 79, '2019-01-01', 368, NULL),
('Hi-Way Inn', 79, '2019-01-02', 256, NULL),
('Hi-Way Inn', 79, '2019-01-03', 227, NULL),
('Hi-Way Inn', 79, '2019-01-04', 210, NULL),
('Hi-Way Inn', 79, '2019-01-05', 273, NULL),
('Hi-Way Inn', 79, '2019-01-06', 350, NULL),
('Hi-Way Inn', 79, '2019-01-07', 151, NULL),
('Hi-Way Inn', 79, '2019-01-08', 245, NULL),
('Hi-Way Inn', 79, '2019-01-09', 366, NULL),
('Hi-Way Inn', 79, '2019-01-10', 371, NULL),
('Hi-Way Inn', 79, '2019-01-11', 146, NULL),
('Hi-Way Inn', 79, '2019-01-12', 138, NULL),
('Hi-Way Inn', 79, '2019-01-13', 350, NULL),
('Hi-Way Inn', 79, '2019-01-14', 115, NULL),
('Hi-Way Inn', 79, '2019-01-15', 174, NULL),
('Hi-Way Inn', 79, '2019-01-16', 296, NULL),
('Hi-Way Inn', 79, '2019-01-17', 330, NULL),
('Hi-Way Inn', 79, '2019-01-18', 290, NULL),
('Hi-Way Inn', 79, '2019-01-19', 306, NULL),
('Hi-Way Inn', 79, '2019-01-20', 302, NULL),
('Hi-Way Inn', 79, '2019-01-21', 174, NULL),
('Hi-Way Inn', 79, '2019-01-22', 352, NULL),
('Hi-Way Inn', 79, '2019-01-23', 366, NULL),
('Hi-Way Inn', 79, '2019-01-24', 370, NULL),
('Hi-Way Inn', 79, '2019-01-25', 124, NULL),
('Hi-Way Inn', 79, '2019-01-26', 306, NULL),
('Hi-Way Inn', 79, '2019-01-27', 149, NULL),
('Hi-Way Inn', 79, '2019-01-28', 154, NULL),
('Hi-Way Inn', 79, '2019-01-29', 372, NULL),
('Hi-Way Inn', 79, '2019-01-30', 289, NULL),
('Hi-Way Inn', 79, '2019-01-31', 291, NULL),
('Hi-Way Inn', 79, '2019-02-01', 330, NULL),
('Hi-Way Inn', 79, '2019-02-02', 143, NULL),
('Hi-Way Inn', 79, '2019-02-03', 357, NULL),
('Hi-Way Inn', 79, '2019-02-04', 337, NULL),
('Hi-Way Inn', 79, '2019-02-05', 110, NULL),
('Hi-Way Inn', 79, '2019-02-06', 142, NULL),
('Hi-Way Inn', 79, '2019-02-07', 322, NULL),
('Hi-Way Inn', 79, '2019-02-08', 121, NULL),
('Hi-Way Inn', 79, '2019-02-09', 332, NULL),
('Hi-Way Inn', 79, '2019-02-10', 161, NULL),
('Hi-Way Inn', 79, '2019-02-11', 122, NULL),
('Hi-Way Inn', 79, '2019-02-12', 159, NULL),
('Hi-Way Inn', 79, '2019-02-13', 159, NULL),
('Hi-Way Inn', 79, '2019-02-14', 154, NULL),
('Hi-Way Inn', 79, '2019-02-15', 366, NULL),
('Hi-Way Inn', 79, '2019-02-16', 195, NULL),
('Hi-Way Inn', 79, '2019-02-17', 175, NULL),
('Hi-Way Inn', 79, '2019-02-18', 182, NULL),
('Hi-Way Inn', 79, '2019-02-19', 273, NULL),
('Hi-Way Inn', 79, '2019-02-20', 186, NULL),
('Hi-Way Inn', 79, '2019-02-21', 208, NULL),
('Hi-Way Inn', 79, '2019-02-22', 383, NULL),
('Hi-Way Inn', 79, '2019-02-23', 199, NULL),
('Hi-Way Inn', 79, '2019-02-24', 151, NULL),
('Hi-Way Inn', 79, '2019-02-25', 364, NULL),
('Hi-Way Inn', 79, '2019-02-26', 284, NULL),
('Hi-Way Inn', 79, '2019-02-27', 168, NULL),
('Hi-Way Inn', 79, '2019-02-28', 337, NULL),
('Hi-Way Inn', 79, '2019-03-01', 368, NULL),
('Hi-Way Inn', 79, '2019-03-02', 315, NULL),
('Hi-Way Inn', 79, '2019-03-03', 311, NULL),
('Hi-Way Inn', 79, '2019-03-04', 315, NULL),
('Hi-Way Inn', 79, '2019-03-05', 244, NULL),
('Hi-Way Inn', 79, '2019-03-06', 171, NULL),
('Hi-Way Inn', 79, '2019-03-07', 304, NULL),
('Hi-Way Inn', 79, '2019-03-08', 343, NULL),
('Hi-Way Inn', 79, '2019-03-09', 395, NULL),
('Hi-Way Inn', 79, '2019-03-10', 239, NULL),
('Hi-Way Inn', 79, '2019-03-11', 327, NULL),
('Hi-Way Inn', 79, '2019-03-12', 182, NULL),
('Hi-Way Inn', 79, '2019-03-13', 274, NULL),
('Hi-Way Inn', 79, '2019-03-14', 146, NULL),
('Hi-Way Inn', 79, '2019-03-15', 367, NULL),
('Hi-Way Inn', 79, '2019-03-16', 385, NULL),
('Hi-Way Inn', 79, '2019-03-17', 379, NULL),
('Hi-Way Inn', 79, '2019-03-18', 258, NULL),
('Hi-Way Inn', 79, '2019-03-19', 262, NULL),
('Hi-Way Inn', 79, '2019-03-20', 132, NULL),
('Hi-Way Inn', 79, '2019-03-21', 256, NULL),
('Hi-Way Inn', 79, '2019-03-22', 301, NULL),
('Hi-Way Inn', 79, '2019-03-23', 150, NULL),
('Hi-Way Inn', 79, '2019-03-24', 139, NULL),
('Hi-Way Inn', 79, '2019-03-25', 299, NULL),
('Hi-Way Inn', 79, '2019-03-26', 339, NULL),
('Hi-Way Inn', 79, '2019-03-27', 343, NULL),
('Hi-Way Inn', 79, '2019-03-28', 399, NULL),
('Hi-Way Inn', 79, '2019-03-29', 318, NULL),
('Hi-Way Inn', 79, '2019-03-30', 222, NULL),
('Hi-Way Inn', 79, '2019-03-31', 250, NULL),
('Hi-Way Inn', 79, '2019-04-01', 173, NULL),
('Hi-Way Inn', 79, '2019-04-02', 211, NULL),
('Hi-Way Inn', 79, '2019-04-03', 131, NULL),
('Hi-Way Inn', 79, '2019-04-04', 140, NULL),
('Hi-Way Inn', 79, '2019-04-05', 161, NULL),
('Hi-Way Inn', 79, '2019-04-06', 392, NULL),
('Hi-Way Inn', 79, '2019-04-07', 334, NULL),
('Hi-Way Inn', 79, '2019-04-08', 166, NULL),
('Hi-Way Inn', 79, '2019-04-09', 375, NULL),
('Hi-Way Inn', 79, '2019-04-10', 117, NULL),
('Hi-Way Inn', 79, '2019-04-11', 110, NULL),
('Hi-Way Inn', 79, '2019-04-12', 377, NULL),
('Hi-Way Inn', 79, '2019-04-13', 348, NULL),
('Hi-Way Inn', 79, '2019-04-14', 261, NULL),
('Hi-Way Inn', 79, '2019-04-15', 397, NULL),
('Hi-Way Inn', 79, '2019-04-16', 326, NULL),
('Hi-Way Inn', 79, '2019-04-17', 188, NULL),
('Hi-Way Inn', 79, '2019-04-18', 131, NULL),
('Hi-Way Inn', 79, '2019-04-19', 218, NULL),
('Hi-Way Inn', 79, '2019-04-20', 342, NULL),
('Hi-Way Inn', 79, '2019-04-21', 326, NULL),
('Hi-Way Inn', 79, '2019-04-22', 166, NULL),
('Hi-Way Inn', 79, '2019-04-23', 217, NULL),
('Hi-Way Inn', 79, '2019-04-24', 391, NULL),
('Hi-Way Inn', 79, '2019-04-25', 390, NULL),
('Hi-Way Inn', 79, '2019-04-26', 180, NULL),
('Hi-Way Inn', 79, '2019-04-27', 126, NULL),
('Hi-Way Inn', 79, '2019-04-28', 285, NULL),
('Hi-Way Inn', 79, '2019-04-29', 193, NULL),
('Hi-Way Inn', 79, '2019-04-30', 112, NULL),
('Hi-Way Inn', 79, '2019-05-01', 341, NULL),
('Hi-Way Inn', 79, '2019-05-02', 295, NULL),
('Hi-Way Inn', 79, '2019-05-03', 260, NULL),
('Hi-Way Inn', 79, '2019-05-04', 373, NULL),
('Hi-Way Inn', 79, '2019-05-05', 216, NULL),
('Hi-Way Inn', 79, '2019-05-06', 225, NULL),
('Hi-Way Inn', 79, '2019-05-07', 186, NULL),
('Hi-Way Inn', 79, '2019-05-08', 210, NULL),
('Hi-Way Inn', 79, '2019-05-09', 345, NULL),
('Hi-Way Inn', 79, '2019-05-10', 266, NULL),
('Hi-Way Inn', 79, '2019-05-11', 104, NULL),
('Hi-Way Inn', 79, '2019-05-12', 297, NULL),
('Hi-Way Inn', 79, '2019-05-13', 166, NULL),
('Hi-Way Inn', 79, '2019-05-14', 174, NULL),
('Hi-Way Inn', 79, '2019-05-15', 227, NULL),
('Hi-Way Inn', 79, '2019-05-16', 162, NULL),
('Hi-Way Inn', 79, '2019-05-17', 221, NULL),
('Hi-Way Inn', 79, '2019-05-18', 114, NULL),
('Hi-Way Inn', 79, '2019-05-19', 326, NULL),
('Hi-Way Inn', 79, '2019-05-20', 317, NULL),
('Hi-Way Inn', 79, '2019-05-21', 272, NULL),
('Hi-Way Inn', 79, '2019-05-22', 146, NULL),
('Hi-Way Inn', 79, '2019-05-23', 284, NULL),
('Hi-Way Inn', 79, '2019-05-24', 200, NULL),
('Hi-Way Inn', 79, '2019-05-25', 198, NULL),
('Hi-Way Inn', 79, '2019-05-26', 333, NULL),
('Hi-Way Inn', 79, '2019-05-27', 349, NULL),
('Hi-Way Inn', 79, '2019-05-28', 398, NULL),
('Hi-Way Inn', 79, '2019-05-29', 113, NULL),
('Hi-Way Inn', 79, '2019-05-30', 254, NULL),
('Hi-Way Inn', 79, '2019-05-31', 283, NULL),
('Hi-Way Inn', 79, '2019-06-01', 217, NULL),
('Hi-Way Inn', 79, '2019-06-02', 133, NULL),
('Hi-Way Inn', 79, '2019-06-03', 120, NULL),
('Hi-Way Inn', 79, '2019-06-04', 186, NULL),
('Hi-Way Inn', 79, '2019-06-05', 290, NULL),
('Hi-Way Inn', 79, '2019-06-06', 190, NULL),
('Hi-Way Inn', 79, '2019-06-07', 355, NULL),
('Hi-Way Inn', 79, '2019-06-08', 315, NULL),
('Hi-Way Inn', 79, '2019-06-09', 132, NULL),
('Hi-Way Inn', 79, '2019-06-10', 332, NULL),
('Hi-Way Inn', 79, '2019-06-11', 156, NULL),
('Hi-Way Inn', 79, '2019-06-12', 195, NULL),
('Hi-Way Inn', 79, '2019-06-13', 320, NULL),
('Hi-Way Inn', 79, '2019-06-14', 219, NULL),
('Hi-Way Inn', 79, '2019-06-15', 330, NULL),
('Hi-Way Inn', 79, '2019-06-16', 364, NULL),
('Hi-Way Inn', 79, '2019-06-17', 306, NULL),
('Hi-Way Inn', 79, '2019-06-18', 248, NULL),
('Hi-Way Inn', 79, '2019-06-19', 356, NULL),
('Hi-Way Inn', 79, '2019-06-20', 164, NULL),
('Hi-Way Inn', 79, '2019-06-21', 267, NULL),
('Hi-Way Inn', 79, '2019-06-22', 365, NULL),
('Hi-Way Inn', 79, '2019-06-23', 192, NULL),
('Hi-Way Inn', 79, '2019-06-24', 365, NULL),
('Hi-Way Inn', 79, '2019-06-25', 223, NULL),
('Hi-Way Inn', 79, '2019-06-26', 306, NULL),
('Hi-Way Inn', 79, '2019-06-27', 346, NULL),
('Hi-Way Inn', 79, '2019-06-28', 157, NULL),
('Hi-Way Inn', 79, '2019-06-29', 138, NULL),
('Hi-Way Inn', 79, '2019-06-30', 221, NULL),
('Hi-Way Inn', 79, '2019-07-01', 297, NULL),
('Hi-Way Inn', 79, '2019-07-02', 315, NULL),
('Hi-Way Inn', 79, '2019-07-03', 187, NULL),
('Hi-Way Inn', 79, '2019-07-04', 225, NULL),
('Hi-Way Inn', 79, '2019-07-05', 316, NULL),
('Hi-Way Inn', 79, '2019-07-06', 363, NULL),
('Hi-Way Inn', 79, '2019-07-07', 173, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 79, '2019-07-08', 292, NULL),
('Hi-Way Inn', 79, '2019-07-09', 128, NULL),
('Hi-Way Inn', 79, '2019-07-10', 131, NULL),
('Hi-Way Inn', 79, '2019-07-11', 131, NULL),
('Hi-Way Inn', 79, '2019-07-12', 229, NULL),
('Hi-Way Inn', 79, '2019-07-13', 160, NULL),
('Hi-Way Inn', 79, '2019-07-14', 151, NULL),
('Hi-Way Inn', 79, '2019-07-15', 227, NULL),
('Hi-Way Inn', 79, '2019-07-16', 219, NULL),
('Hi-Way Inn', 79, '2019-07-17', 218, NULL),
('Hi-Way Inn', 79, '2019-07-18', 375, NULL),
('Hi-Way Inn', 79, '2019-07-19', 172, NULL),
('Hi-Way Inn', 79, '2019-07-20', 281, NULL),
('Hi-Way Inn', 79, '2019-07-21', 105, NULL),
('Hi-Way Inn', 79, '2019-07-22', 157, NULL),
('Hi-Way Inn', 79, '2019-07-23', 145, NULL),
('Hi-Way Inn', 79, '2019-07-24', 301, NULL),
('Hi-Way Inn', 79, '2019-07-25', 196, NULL),
('Hi-Way Inn', 79, '2019-07-26', 101, NULL),
('Hi-Way Inn', 79, '2019-07-27', 266, NULL),
('Hi-Way Inn', 79, '2019-07-28', 350, NULL),
('Hi-Way Inn', 79, '2019-07-29', 145, NULL),
('Hi-Way Inn', 79, '2019-07-30', 242, NULL),
('Hi-Way Inn', 79, '2019-07-31', 328, NULL),
('Hi-Way Inn', 79, '2019-08-01', 166, NULL),
('Hi-Way Inn', 79, '2019-08-02', 343, NULL),
('Hi-Way Inn', 79, '2019-08-03', 204, NULL),
('Hi-Way Inn', 79, '2019-08-04', 285, NULL),
('Hi-Way Inn', 79, '2019-08-05', 240, NULL),
('Hi-Way Inn', 79, '2019-08-06', 191, NULL),
('Hi-Way Inn', 79, '2019-08-07', 359, NULL),
('Hi-Way Inn', 79, '2019-08-08', 293, NULL),
('Hi-Way Inn', 79, '2019-08-09', 244, NULL),
('Hi-Way Inn', 79, '2019-08-10', 387, NULL),
('Hi-Way Inn', 79, '2019-08-11', 368, NULL),
('Hi-Way Inn', 79, '2019-08-12', 204, NULL),
('Hi-Way Inn', 79, '2019-08-13', 245, NULL),
('Hi-Way Inn', 79, '2019-08-14', 151, NULL),
('Hi-Way Inn', 79, '2019-08-15', 219, NULL),
('Hi-Way Inn', 79, '2019-08-16', 217, NULL),
('Hi-Way Inn', 79, '2019-08-17', 139, NULL),
('Hi-Way Inn', 79, '2019-08-18', 188, NULL),
('Hi-Way Inn', 79, '2019-08-19', 313, NULL),
('Hi-Way Inn', 79, '2019-08-20', 254, NULL),
('Hi-Way Inn', 79, '2019-08-21', 312, NULL),
('Hi-Way Inn', 79, '2019-08-22', 396, NULL),
('Hi-Way Inn', 79, '2019-08-23', 104, NULL),
('Hi-Way Inn', 79, '2019-08-24', 339, NULL),
('Hi-Way Inn', 79, '2019-08-25', 187, NULL),
('Hi-Way Inn', 79, '2019-08-26', 224, NULL),
('Hi-Way Inn', 79, '2019-08-27', 398, NULL),
('Hi-Way Inn', 79, '2019-08-28', 220, NULL),
('Hi-Way Inn', 79, '2019-08-29', 224, NULL),
('Hi-Way Inn', 79, '2019-08-30', 190, NULL),
('Hi-Way Inn', 79, '2019-08-31', 321, NULL),
('Hi-Way Inn', 79, '2019-09-01', 224, NULL),
('Hi-Way Inn', 79, '2019-09-02', 140, NULL),
('Hi-Way Inn', 79, '2019-09-03', 256, NULL),
('Hi-Way Inn', 79, '2019-09-04', 278, NULL),
('Hi-Way Inn', 79, '2019-09-05', 351, NULL),
('Hi-Way Inn', 79, '2019-09-06', 233, NULL),
('Hi-Way Inn', 79, '2019-09-07', 169, NULL),
('Hi-Way Inn', 79, '2019-09-08', 373, NULL),
('Hi-Way Inn', 79, '2019-09-09', 289, NULL),
('Hi-Way Inn', 79, '2019-09-10', 301, NULL),
('Hi-Way Inn', 79, '2019-09-11', 269, NULL),
('Hi-Way Inn', 79, '2019-09-12', 398, NULL),
('Hi-Way Inn', 79, '2019-09-13', 308, NULL),
('Hi-Way Inn', 79, '2019-09-14', 306, NULL),
('Hi-Way Inn', 79, '2019-09-15', 173, NULL),
('Hi-Way Inn', 79, '2019-09-16', 185, NULL),
('Hi-Way Inn', 79, '2019-09-17', 382, NULL),
('Hi-Way Inn', 79, '2019-09-18', 280, NULL),
('Hi-Way Inn', 79, '2019-09-19', 109, NULL),
('Hi-Way Inn', 79, '2019-09-20', 132, NULL),
('Hi-Way Inn', 79, '2019-09-21', 167, NULL),
('Hi-Way Inn', 79, '2019-09-22', 176, NULL),
('Hi-Way Inn', 79, '2019-09-23', 300, NULL),
('Hi-Way Inn', 79, '2019-09-24', 323, NULL),
('Hi-Way Inn', 79, '2019-09-25', 280, NULL),
('Hi-Way Inn', 79, '2019-09-26', 198, NULL),
('Hi-Way Inn', 79, '2019-09-27', 369, NULL),
('Hi-Way Inn', 79, '2019-09-28', 199, NULL),
('Hi-Way Inn', 79, '2019-09-29', 177, NULL),
('Hi-Way Inn', 79, '2019-09-30', 332, NULL),
('Hi-Way Inn', 79, '2019-10-01', 237, NULL),
('Hi-Way Inn', 79, '2019-10-02', 313, NULL),
('Hi-Way Inn', 79, '2019-10-03', 375, NULL),
('Hi-Way Inn', 79, '2019-10-04', 345, NULL),
('Hi-Way Inn', 79, '2019-10-05', 299, NULL),
('Hi-Way Inn', 79, '2019-10-06', 355, NULL),
('Hi-Way Inn', 79, '2019-10-07', 382, NULL),
('Hi-Way Inn', 79, '2019-10-08', 206, NULL),
('Hi-Way Inn', 79, '2019-10-09', 340, NULL),
('Hi-Way Inn', 79, '2019-10-10', 141, NULL),
('Hi-Way Inn', 79, '2019-10-11', 255, NULL),
('Hi-Way Inn', 79, '2019-10-12', 328, NULL),
('Hi-Way Inn', 79, '2019-10-13', 383, NULL),
('Hi-Way Inn', 79, '2019-10-14', 256, NULL),
('Hi-Way Inn', 79, '2019-10-15', 364, NULL),
('Hi-Way Inn', 79, '2019-10-16', 160, NULL),
('Hi-Way Inn', 79, '2019-10-17', 282, NULL),
('Hi-Way Inn', 79, '2019-10-18', 301, NULL),
('Hi-Way Inn', 79, '2019-10-19', 152, NULL),
('Hi-Way Inn', 79, '2019-10-20', 162, NULL),
('Hi-Way Inn', 79, '2019-10-21', 360, NULL),
('Hi-Way Inn', 79, '2019-10-22', 101, NULL),
('Hi-Way Inn', 79, '2019-10-23', 367, NULL),
('Hi-Way Inn', 79, '2019-10-24', 213, NULL),
('Hi-Way Inn', 79, '2019-10-25', 103, NULL),
('Hi-Way Inn', 79, '2019-10-26', 399, NULL),
('Hi-Way Inn', 79, '2019-10-27', 170, NULL),
('Hi-Way Inn', 79, '2019-10-28', 384, NULL),
('Hi-Way Inn', 79, '2019-10-29', 176, NULL),
('Hi-Way Inn', 79, '2019-10-30', 196, NULL),
('Hi-Way Inn', 79, '2019-10-31', 213, NULL),
('Hi-Way Inn', 79, '2019-11-01', 244, NULL),
('Hi-Way Inn', 79, '2019-11-02', 250, NULL),
('Hi-Way Inn', 79, '2019-11-03', 182, NULL),
('Hi-Way Inn', 79, '2019-11-04', 343, NULL),
('Hi-Way Inn', 79, '2019-11-05', 266, NULL),
('Hi-Way Inn', 79, '2019-11-06', 399, NULL),
('Hi-Way Inn', 79, '2019-11-07', 119, NULL),
('Hi-Way Inn', 79, '2019-11-08', 119, NULL),
('Hi-Way Inn', 79, '2019-11-09', 394, NULL),
('Hi-Way Inn', 79, '2019-11-10', 163, NULL),
('Hi-Way Inn', 79, '2019-11-11', 164, NULL),
('Hi-Way Inn', 79, '2019-11-12', 251, NULL),
('Hi-Way Inn', 79, '2019-11-13', 331, NULL),
('Hi-Way Inn', 79, '2019-11-14', 108, NULL),
('Hi-Way Inn', 79, '2019-11-15', 314, NULL),
('Hi-Way Inn', 79, '2019-11-16', 272, NULL),
('Hi-Way Inn', 79, '2019-11-17', 139, NULL),
('Hi-Way Inn', 79, '2019-11-18', 203, NULL),
('Hi-Way Inn', 79, '2019-11-19', 372, NULL),
('Hi-Way Inn', 79, '2019-11-20', 297, NULL),
('Hi-Way Inn', 79, '2019-11-21', 304, NULL),
('Hi-Way Inn', 79, '2019-11-22', 130, NULL),
('Hi-Way Inn', 79, '2019-11-23', 125, NULL),
('Hi-Way Inn', 79, '2019-11-24', 120, NULL),
('Hi-Way Inn', 79, '2019-11-25', 383, NULL),
('Hi-Way Inn', 79, '2019-11-26', 247, NULL),
('Hi-Way Inn', 79, '2019-11-27', 311, NULL),
('Hi-Way Inn', 79, '2019-11-28', 151, NULL),
('Hi-Way Inn', 79, '2019-11-29', 307, NULL),
('Hi-Way Inn', 79, '2019-11-30', 361, NULL),
('Hi-Way Inn', 79, '2019-12-01', 373, NULL),
('Hi-Way Inn', 79, '2019-12-02', 234, NULL),
('Hi-Way Inn', 79, '2019-12-03', 143, NULL),
('Hi-Way Inn', 79, '2019-12-04', 307, NULL),
('Hi-Way Inn', 79, '2019-12-05', 339, NULL),
('Hi-Way Inn', 79, '2019-12-06', 211, NULL),
('Hi-Way Inn', 79, '2019-12-07', 240, NULL),
('Hi-Way Inn', 79, '2019-12-08', 167, NULL),
('Hi-Way Inn', 79, '2019-12-09', 318, NULL),
('Hi-Way Inn', 79, '2019-12-10', 271, NULL),
('Hi-Way Inn', 79, '2019-12-11', 328, NULL),
('Hi-Way Inn', 79, '2019-12-12', 334, NULL),
('Hi-Way Inn', 79, '2019-12-13', 153, NULL),
('Hi-Way Inn', 79, '2019-12-14', 381, NULL),
('Hi-Way Inn', 79, '2019-12-15', 313, NULL),
('Hi-Way Inn', 79, '2019-12-16', 310, NULL),
('Hi-Way Inn', 79, '2019-12-17', 399, NULL),
('Hi-Way Inn', 79, '2019-12-18', 305, NULL),
('Hi-Way Inn', 79, '2019-12-19', 381, NULL),
('Hi-Way Inn', 79, '2019-12-20', 315, NULL),
('Hi-Way Inn', 79, '2019-12-21', 293, NULL),
('Hi-Way Inn', 79, '2019-12-22', 147, NULL),
('Hi-Way Inn', 79, '2019-12-23', 106, NULL),
('Hi-Way Inn', 79, '2019-12-24', 209, NULL),
('Hi-Way Inn', 79, '2019-12-25', 133, NULL),
('Hi-Way Inn', 79, '2019-12-26', 243, NULL),
('Hi-Way Inn', 79, '2019-12-27', 213, NULL),
('Hi-Way Inn', 79, '2019-12-28', 191, NULL),
('Hi-Way Inn', 79, '2019-12-29', 235, NULL),
('Hi-Way Inn', 79, '2019-12-30', 158, NULL),
('Hi-Way Inn', 79, '2019-12-31', 120, NULL),
('Hi-Way Inn', 79, '2020-01-01', 223, NULL),
('Hi-Way Inn', 79, '2020-01-02', 190, NULL),
('Hi-Way Inn', 79, '2020-01-03', 379, NULL),
('Hi-Way Inn', 79, '2020-01-04', 152, NULL),
('Hi-Way Inn', 79, '2020-01-05', 224, NULL),
('Hi-Way Inn', 79, '2020-01-06', 267, NULL),
('Hi-Way Inn', 79, '2020-01-07', 219, NULL),
('Hi-Way Inn', 79, '2020-01-08', 382, NULL),
('Hi-Way Inn', 79, '2020-01-09', 236, NULL),
('Hi-Way Inn', 79, '2020-01-10', 374, NULL),
('Hi-Way Inn', 79, '2020-01-11', 187, NULL),
('Hi-Way Inn', 79, '2020-01-12', 346, NULL),
('Hi-Way Inn', 79, '2020-01-13', 119, NULL),
('Hi-Way Inn', 79, '2020-01-14', 247, NULL),
('Hi-Way Inn', 79, '2020-01-15', 112, NULL),
('Hi-Way Inn', 79, '2020-01-16', 362, NULL),
('Hi-Way Inn', 79, '2020-01-17', 261, NULL),
('Hi-Way Inn', 79, '2020-01-18', 316, NULL),
('Hi-Way Inn', 79, '2020-01-19', 399, NULL),
('Hi-Way Inn', 79, '2020-01-20', 117, NULL),
('Hi-Way Inn', 79, '2020-01-21', 314, NULL),
('Hi-Way Inn', 79, '2020-01-22', 237, NULL),
('Hi-Way Inn', 79, '2020-01-23', 121, NULL),
('Hi-Way Inn', 79, '2020-01-24', 142, NULL),
('Hi-Way Inn', 79, '2020-01-25', 330, NULL),
('Hi-Way Inn', 79, '2020-01-26', 140, NULL),
('Hi-Way Inn', 79, '2020-01-27', 254, NULL),
('Hi-Way Inn', 79, '2020-01-28', 200, NULL),
('Hi-Way Inn', 79, '2020-01-29', 197, NULL),
('Hi-Way Inn', 79, '2020-01-30', 196, NULL),
('Hi-Way Inn', 79, '2020-01-31', 232, NULL),
('Hi-Way Inn', 79, '2020-02-01', 257, NULL),
('Hi-Way Inn', 79, '2020-02-02', 298, NULL),
('Hi-Way Inn', 79, '2020-02-03', 177, NULL),
('Hi-Way Inn', 79, '2020-02-04', 300, NULL),
('Hi-Way Inn', 87, '2019-01-01', 369, NULL),
('Hi-Way Inn', 87, '2019-01-02', 209, NULL),
('Hi-Way Inn', 87, '2019-01-03', 384, NULL),
('Hi-Way Inn', 87, '2019-01-04', 265, NULL),
('Hi-Way Inn', 87, '2019-01-05', 270, NULL),
('Hi-Way Inn', 87, '2019-01-06', 265, NULL),
('Hi-Way Inn', 87, '2019-01-07', 302, NULL),
('Hi-Way Inn', 87, '2019-01-08', 186, NULL),
('Hi-Way Inn', 87, '2019-01-09', 152, NULL),
('Hi-Way Inn', 87, '2019-01-10', 352, NULL),
('Hi-Way Inn', 87, '2019-01-11', 356, NULL),
('Hi-Way Inn', 87, '2019-01-12', 337, NULL),
('Hi-Way Inn', 87, '2019-01-13', 355, NULL),
('Hi-Way Inn', 87, '2019-01-14', 106, NULL),
('Hi-Way Inn', 87, '2019-01-15', 372, NULL),
('Hi-Way Inn', 87, '2019-01-16', 289, NULL),
('Hi-Way Inn', 87, '2019-01-17', 288, NULL),
('Hi-Way Inn', 87, '2019-01-18', 285, NULL),
('Hi-Way Inn', 87, '2019-01-19', 365, NULL),
('Hi-Way Inn', 87, '2019-01-20', 106, NULL),
('Hi-Way Inn', 87, '2019-01-21', 200, NULL),
('Hi-Way Inn', 87, '2019-01-22', 343, NULL),
('Hi-Way Inn', 87, '2019-01-23', 394, NULL),
('Hi-Way Inn', 87, '2019-01-24', 100, NULL),
('Hi-Way Inn', 87, '2019-01-25', 258, NULL),
('Hi-Way Inn', 87, '2019-01-26', 309, NULL),
('Hi-Way Inn', 87, '2019-01-27', 190, NULL),
('Hi-Way Inn', 87, '2019-01-28', 236, NULL),
('Hi-Way Inn', 87, '2019-01-29', 197, NULL),
('Hi-Way Inn', 87, '2019-01-30', 101, NULL),
('Hi-Way Inn', 87, '2019-01-31', 135, NULL),
('Hi-Way Inn', 87, '2019-02-01', 275, NULL),
('Hi-Way Inn', 87, '2019-02-02', 236, NULL),
('Hi-Way Inn', 87, '2019-02-03', 133, NULL),
('Hi-Way Inn', 87, '2019-02-04', 219, NULL),
('Hi-Way Inn', 87, '2019-02-05', 385, NULL),
('Hi-Way Inn', 87, '2019-02-06', 103, NULL),
('Hi-Way Inn', 87, '2019-02-07', 343, NULL),
('Hi-Way Inn', 87, '2019-02-08', 210, NULL),
('Hi-Way Inn', 87, '2019-02-09', 168, NULL),
('Hi-Way Inn', 87, '2019-02-10', 280, NULL),
('Hi-Way Inn', 87, '2019-02-11', 137, NULL),
('Hi-Way Inn', 87, '2019-02-12', 337, NULL),
('Hi-Way Inn', 87, '2019-02-13', 238, NULL),
('Hi-Way Inn', 87, '2019-02-14', 107, NULL),
('Hi-Way Inn', 87, '2019-02-15', 264, NULL),
('Hi-Way Inn', 87, '2019-02-16', 314, NULL),
('Hi-Way Inn', 87, '2019-02-17', 333, NULL),
('Hi-Way Inn', 87, '2019-02-18', 171, NULL),
('Hi-Way Inn', 87, '2019-02-19', 138, NULL),
('Hi-Way Inn', 87, '2019-02-20', 178, NULL),
('Hi-Way Inn', 87, '2019-02-21', 234, NULL),
('Hi-Way Inn', 87, '2019-02-22', 379, NULL),
('Hi-Way Inn', 87, '2019-02-23', 161, NULL),
('Hi-Way Inn', 87, '2019-02-24', 157, NULL),
('Hi-Way Inn', 87, '2019-02-25', 384, NULL),
('Hi-Way Inn', 87, '2019-02-26', 211, NULL),
('Hi-Way Inn', 87, '2019-02-27', 242, NULL),
('Hi-Way Inn', 87, '2019-02-28', 139, NULL),
('Hi-Way Inn', 87, '2019-03-01', 114, NULL),
('Hi-Way Inn', 87, '2019-03-02', 307, NULL),
('Hi-Way Inn', 87, '2019-03-03', 302, NULL),
('Hi-Way Inn', 87, '2019-03-04', 308, NULL),
('Hi-Way Inn', 87, '2019-03-05', 326, NULL),
('Hi-Way Inn', 87, '2019-03-06', 105, NULL),
('Hi-Way Inn', 87, '2019-03-07', 201, NULL),
('Hi-Way Inn', 87, '2019-03-08', 119, NULL),
('Hi-Way Inn', 87, '2019-03-09', 317, NULL),
('Hi-Way Inn', 87, '2019-03-10', 261, NULL),
('Hi-Way Inn', 87, '2019-03-11', 190, NULL),
('Hi-Way Inn', 87, '2019-03-12', 212, NULL),
('Hi-Way Inn', 87, '2019-03-13', 329, NULL),
('Hi-Way Inn', 87, '2019-03-14', 222, NULL),
('Hi-Way Inn', 87, '2019-03-15', 242, NULL),
('Hi-Way Inn', 87, '2019-03-16', 339, NULL),
('Hi-Way Inn', 87, '2019-03-17', 269, NULL),
('Hi-Way Inn', 87, '2019-03-18', 317, NULL),
('Hi-Way Inn', 87, '2019-03-19', 248, NULL),
('Hi-Way Inn', 87, '2019-03-20', 189, NULL),
('Hi-Way Inn', 87, '2019-03-21', 282, NULL),
('Hi-Way Inn', 87, '2019-03-22', 390, NULL),
('Hi-Way Inn', 87, '2019-03-23', 337, NULL),
('Hi-Way Inn', 87, '2019-03-24', 301, NULL),
('Hi-Way Inn', 87, '2019-03-25', 317, NULL),
('Hi-Way Inn', 87, '2019-03-26', 131, NULL),
('Hi-Way Inn', 87, '2019-03-27', 240, NULL),
('Hi-Way Inn', 87, '2019-03-28', 245, NULL),
('Hi-Way Inn', 87, '2019-03-29', 370, NULL),
('Hi-Way Inn', 87, '2019-03-30', 148, NULL),
('Hi-Way Inn', 87, '2019-03-31', 138, NULL),
('Hi-Way Inn', 87, '2019-04-01', 326, NULL),
('Hi-Way Inn', 87, '2019-04-02', 328, NULL),
('Hi-Way Inn', 87, '2019-04-03', 244, NULL),
('Hi-Way Inn', 87, '2019-04-04', 324, NULL),
('Hi-Way Inn', 87, '2019-04-05', 215, NULL),
('Hi-Way Inn', 87, '2019-04-06', 383, NULL),
('Hi-Way Inn', 87, '2019-04-07', 232, NULL),
('Hi-Way Inn', 87, '2019-04-08', 178, NULL),
('Hi-Way Inn', 87, '2019-04-09', 266, NULL),
('Hi-Way Inn', 87, '2019-04-10', 133, NULL),
('Hi-Way Inn', 87, '2019-04-11', 327, NULL),
('Hi-Way Inn', 87, '2019-04-12', 351, NULL),
('Hi-Way Inn', 87, '2019-04-13', 269, NULL),
('Hi-Way Inn', 87, '2019-04-14', 162, NULL),
('Hi-Way Inn', 87, '2019-04-15', 134, NULL),
('Hi-Way Inn', 87, '2019-04-16', 294, NULL),
('Hi-Way Inn', 87, '2019-04-17', 213, NULL),
('Hi-Way Inn', 87, '2019-04-18', 323, NULL),
('Hi-Way Inn', 87, '2019-04-19', 379, NULL),
('Hi-Way Inn', 87, '2019-04-20', 147, NULL),
('Hi-Way Inn', 87, '2019-04-21', 257, NULL),
('Hi-Way Inn', 87, '2019-04-22', 194, NULL),
('Hi-Way Inn', 87, '2019-04-23', 225, NULL),
('Hi-Way Inn', 87, '2019-04-24', 346, NULL),
('Hi-Way Inn', 87, '2019-04-25', 222, NULL),
('Hi-Way Inn', 87, '2019-04-26', 367, NULL),
('Hi-Way Inn', 87, '2019-04-27', 231, NULL),
('Hi-Way Inn', 87, '2019-04-28', 129, NULL),
('Hi-Way Inn', 87, '2019-04-29', 284, NULL),
('Hi-Way Inn', 87, '2019-04-30', 366, NULL),
('Hi-Way Inn', 87, '2019-05-01', 228, NULL),
('Hi-Way Inn', 87, '2019-05-02', 215, NULL),
('Hi-Way Inn', 87, '2019-05-03', 395, NULL),
('Hi-Way Inn', 87, '2019-05-04', 116, NULL),
('Hi-Way Inn', 87, '2019-05-05', 233, NULL),
('Hi-Way Inn', 87, '2019-05-06', 132, NULL),
('Hi-Way Inn', 87, '2019-05-07', 286, NULL),
('Hi-Way Inn', 87, '2019-05-08', 259, NULL),
('Hi-Way Inn', 87, '2019-05-09', 394, NULL),
('Hi-Way Inn', 87, '2019-05-10', 264, NULL),
('Hi-Way Inn', 87, '2019-05-11', 212, NULL),
('Hi-Way Inn', 87, '2019-05-12', 378, NULL),
('Hi-Way Inn', 87, '2019-05-13', 238, NULL),
('Hi-Way Inn', 87, '2019-05-14', 396, NULL),
('Hi-Way Inn', 87, '2019-05-15', 114, NULL),
('Hi-Way Inn', 87, '2019-05-16', 363, NULL),
('Hi-Way Inn', 87, '2019-05-17', 136, NULL),
('Hi-Way Inn', 87, '2019-05-18', 125, NULL),
('Hi-Way Inn', 87, '2019-05-19', 202, NULL),
('Hi-Way Inn', 87, '2019-05-20', 211, NULL),
('Hi-Way Inn', 87, '2019-05-21', 267, NULL),
('Hi-Way Inn', 87, '2019-05-22', 393, NULL),
('Hi-Way Inn', 87, '2019-05-23', 121, NULL),
('Hi-Way Inn', 87, '2019-05-24', 107, NULL),
('Hi-Way Inn', 87, '2019-05-25', 394, NULL),
('Hi-Way Inn', 87, '2019-05-26', 390, NULL),
('Hi-Way Inn', 87, '2019-05-27', 166, NULL),
('Hi-Way Inn', 87, '2019-05-28', 325, NULL),
('Hi-Way Inn', 87, '2019-05-29', 380, NULL),
('Hi-Way Inn', 87, '2019-05-30', 115, NULL),
('Hi-Way Inn', 87, '2019-05-31', 285, NULL),
('Hi-Way Inn', 87, '2019-06-01', 386, NULL),
('Hi-Way Inn', 87, '2019-06-02', 240, NULL),
('Hi-Way Inn', 87, '2019-06-03', 223, NULL),
('Hi-Way Inn', 87, '2019-06-04', 357, NULL),
('Hi-Way Inn', 87, '2019-06-05', 226, NULL),
('Hi-Way Inn', 87, '2019-06-06', 294, NULL),
('Hi-Way Inn', 87, '2019-06-07', 343, NULL),
('Hi-Way Inn', 87, '2019-06-08', 191, NULL),
('Hi-Way Inn', 87, '2019-06-09', 230, NULL),
('Hi-Way Inn', 87, '2019-06-10', 106, NULL),
('Hi-Way Inn', 87, '2019-06-11', 207, NULL),
('Hi-Way Inn', 87, '2019-06-12', 209, NULL),
('Hi-Way Inn', 87, '2019-06-13', 148, NULL),
('Hi-Way Inn', 87, '2019-06-14', 356, NULL),
('Hi-Way Inn', 87, '2019-06-15', 109, NULL),
('Hi-Way Inn', 87, '2019-06-16', 111, NULL),
('Hi-Way Inn', 87, '2019-06-17', 147, NULL),
('Hi-Way Inn', 87, '2019-06-18', 302, NULL),
('Hi-Way Inn', 87, '2019-06-19', 159, NULL),
('Hi-Way Inn', 87, '2019-06-20', 163, NULL),
('Hi-Way Inn', 87, '2019-06-21', 377, NULL),
('Hi-Way Inn', 87, '2019-06-22', 110, NULL),
('Hi-Way Inn', 87, '2019-06-23', 395, NULL),
('Hi-Way Inn', 87, '2019-06-24', 171, NULL),
('Hi-Way Inn', 87, '2019-06-25', 276, NULL),
('Hi-Way Inn', 87, '2019-06-26', 302, NULL),
('Hi-Way Inn', 87, '2019-06-27', 332, NULL),
('Hi-Way Inn', 87, '2019-06-28', 183, NULL),
('Hi-Way Inn', 87, '2019-06-29', 212, NULL),
('Hi-Way Inn', 87, '2019-06-30', 380, NULL),
('Hi-Way Inn', 87, '2019-07-01', 354, NULL),
('Hi-Way Inn', 87, '2019-07-02', 342, NULL),
('Hi-Way Inn', 87, '2019-07-03', 336, NULL),
('Hi-Way Inn', 87, '2019-07-04', 134, NULL),
('Hi-Way Inn', 87, '2019-07-05', 365, NULL),
('Hi-Way Inn', 87, '2019-07-06', 319, NULL),
('Hi-Way Inn', 87, '2019-07-07', 391, NULL),
('Hi-Way Inn', 87, '2019-07-08', 233, NULL),
('Hi-Way Inn', 87, '2019-07-09', 375, NULL),
('Hi-Way Inn', 87, '2019-07-10', 356, NULL),
('Hi-Way Inn', 87, '2019-07-11', 261, NULL),
('Hi-Way Inn', 87, '2019-07-12', 217, NULL),
('Hi-Way Inn', 87, '2019-07-13', 259, NULL),
('Hi-Way Inn', 87, '2019-07-14', 373, NULL),
('Hi-Way Inn', 87, '2019-07-15', 309, NULL),
('Hi-Way Inn', 87, '2019-07-16', 366, NULL),
('Hi-Way Inn', 87, '2019-07-17', 379, NULL),
('Hi-Way Inn', 87, '2019-07-18', 251, NULL),
('Hi-Way Inn', 87, '2019-07-19', 214, NULL),
('Hi-Way Inn', 87, '2019-07-20', 377, NULL),
('Hi-Way Inn', 87, '2019-07-21', 242, NULL),
('Hi-Way Inn', 87, '2019-07-22', 391, NULL),
('Hi-Way Inn', 87, '2019-07-23', 341, NULL),
('Hi-Way Inn', 87, '2019-07-24', 309, NULL),
('Hi-Way Inn', 87, '2019-07-25', 391, NULL),
('Hi-Way Inn', 87, '2019-07-26', 198, NULL),
('Hi-Way Inn', 87, '2019-07-27', 241, NULL),
('Hi-Way Inn', 87, '2019-07-28', 266, NULL),
('Hi-Way Inn', 87, '2019-07-29', 162, NULL),
('Hi-Way Inn', 87, '2019-07-30', 374, NULL),
('Hi-Way Inn', 87, '2019-07-31', 188, NULL),
('Hi-Way Inn', 87, '2019-08-01', 397, NULL),
('Hi-Way Inn', 87, '2019-08-02', 137, NULL),
('Hi-Way Inn', 87, '2019-08-03', 215, NULL),
('Hi-Way Inn', 87, '2019-08-04', 375, NULL),
('Hi-Way Inn', 87, '2019-08-05', 105, NULL),
('Hi-Way Inn', 87, '2019-08-06', 156, NULL),
('Hi-Way Inn', 87, '2019-08-07', 306, NULL),
('Hi-Way Inn', 87, '2019-08-08', 185, NULL),
('Hi-Way Inn', 87, '2019-08-09', 233, NULL),
('Hi-Way Inn', 87, '2019-08-10', 234, NULL),
('Hi-Way Inn', 87, '2019-08-11', 140, NULL),
('Hi-Way Inn', 87, '2019-08-12', 310, NULL),
('Hi-Way Inn', 87, '2019-08-13', 120, NULL),
('Hi-Way Inn', 87, '2019-08-14', 228, NULL),
('Hi-Way Inn', 87, '2019-08-15', 283, NULL),
('Hi-Way Inn', 87, '2019-08-16', 125, NULL),
('Hi-Way Inn', 87, '2019-08-17', 157, NULL),
('Hi-Way Inn', 87, '2019-08-18', 180, NULL),
('Hi-Way Inn', 87, '2019-08-19', 236, NULL),
('Hi-Way Inn', 87, '2019-08-20', 333, NULL),
('Hi-Way Inn', 87, '2019-08-21', 225, NULL),
('Hi-Way Inn', 87, '2019-08-22', 153, NULL),
('Hi-Way Inn', 87, '2019-08-23', 268, NULL),
('Hi-Way Inn', 87, '2019-08-24', 233, NULL),
('Hi-Way Inn', 87, '2019-08-25', 377, NULL),
('Hi-Way Inn', 87, '2019-08-26', 196, NULL),
('Hi-Way Inn', 87, '2019-08-27', 189, NULL),
('Hi-Way Inn', 87, '2019-08-28', 281, NULL),
('Hi-Way Inn', 87, '2019-08-29', 346, NULL),
('Hi-Way Inn', 87, '2019-08-30', 139, NULL),
('Hi-Way Inn', 87, '2019-08-31', 221, NULL),
('Hi-Way Inn', 87, '2019-09-01', 156, NULL),
('Hi-Way Inn', 87, '2019-09-02', 123, NULL),
('Hi-Way Inn', 87, '2019-09-03', 345, NULL),
('Hi-Way Inn', 87, '2019-09-04', 306, NULL),
('Hi-Way Inn', 87, '2019-09-05', 327, NULL),
('Hi-Way Inn', 87, '2019-09-06', 364, NULL),
('Hi-Way Inn', 87, '2019-09-07', 377, NULL),
('Hi-Way Inn', 87, '2019-09-08', 347, NULL),
('Hi-Way Inn', 87, '2019-09-09', 253, NULL),
('Hi-Way Inn', 87, '2019-09-10', 103, NULL),
('Hi-Way Inn', 87, '2019-09-11', 119, NULL),
('Hi-Way Inn', 87, '2019-09-12', 142, NULL),
('Hi-Way Inn', 87, '2019-09-13', 123, NULL),
('Hi-Way Inn', 87, '2019-09-14', 343, NULL),
('Hi-Way Inn', 87, '2019-09-15', 144, NULL),
('Hi-Way Inn', 87, '2019-09-16', 283, NULL),
('Hi-Way Inn', 87, '2019-09-17', 344, NULL),
('Hi-Way Inn', 87, '2019-09-18', 149, NULL),
('Hi-Way Inn', 87, '2019-09-19', 272, NULL),
('Hi-Way Inn', 87, '2019-09-20', 374, NULL),
('Hi-Way Inn', 87, '2019-09-21', 224, NULL),
('Hi-Way Inn', 87, '2019-09-22', 147, NULL),
('Hi-Way Inn', 87, '2019-09-23', 137, NULL),
('Hi-Way Inn', 87, '2019-09-24', 347, NULL),
('Hi-Way Inn', 87, '2019-09-25', 371, NULL),
('Hi-Way Inn', 87, '2019-09-26', 214, NULL),
('Hi-Way Inn', 87, '2019-09-27', 295, NULL),
('Hi-Way Inn', 87, '2019-09-28', 308, NULL),
('Hi-Way Inn', 87, '2019-09-29', 296, NULL),
('Hi-Way Inn', 87, '2019-09-30', 179, NULL),
('Hi-Way Inn', 87, '2019-10-01', 300, NULL),
('Hi-Way Inn', 87, '2019-10-02', 336, NULL),
('Hi-Way Inn', 87, '2019-10-03', 318, NULL),
('Hi-Way Inn', 87, '2019-10-04', 126, NULL),
('Hi-Way Inn', 87, '2019-10-05', 105, NULL),
('Hi-Way Inn', 87, '2019-10-06', 260, NULL),
('Hi-Way Inn', 87, '2019-10-07', 355, NULL),
('Hi-Way Inn', 87, '2019-10-08', 310, NULL),
('Hi-Way Inn', 87, '2019-10-09', 308, NULL),
('Hi-Way Inn', 87, '2019-10-10', 116, NULL),
('Hi-Way Inn', 87, '2019-10-11', 379, NULL),
('Hi-Way Inn', 87, '2019-10-12', 145, NULL),
('Hi-Way Inn', 87, '2019-10-13', 279, NULL),
('Hi-Way Inn', 87, '2019-10-14', 127, NULL),
('Hi-Way Inn', 87, '2019-10-15', 116, NULL),
('Hi-Way Inn', 87, '2019-10-16', 100, NULL),
('Hi-Way Inn', 87, '2019-10-17', 257, NULL),
('Hi-Way Inn', 87, '2019-10-18', 181, NULL),
('Hi-Way Inn', 87, '2019-10-19', 327, NULL),
('Hi-Way Inn', 87, '2019-10-20', 116, NULL),
('Hi-Way Inn', 87, '2019-10-21', 311, NULL),
('Hi-Way Inn', 87, '2019-10-22', 261, NULL),
('Hi-Way Inn', 87, '2019-10-23', 145, NULL),
('Hi-Way Inn', 87, '2019-10-24', 102, NULL),
('Hi-Way Inn', 87, '2019-10-25', 181, NULL),
('Hi-Way Inn', 87, '2019-10-26', 263, NULL),
('Hi-Way Inn', 87, '2019-10-27', 250, NULL),
('Hi-Way Inn', 87, '2019-10-28', 119, NULL),
('Hi-Way Inn', 87, '2019-10-29', 143, NULL),
('Hi-Way Inn', 87, '2019-10-30', 304, NULL),
('Hi-Way Inn', 87, '2019-10-31', 286, NULL),
('Hi-Way Inn', 87, '2019-11-01', 152, NULL),
('Hi-Way Inn', 87, '2019-11-02', 272, NULL),
('Hi-Way Inn', 87, '2019-11-03', 147, NULL),
('Hi-Way Inn', 87, '2019-11-04', 313, NULL),
('Hi-Way Inn', 87, '2019-11-05', 348, NULL),
('Hi-Way Inn', 87, '2019-11-06', 190, NULL),
('Hi-Way Inn', 87, '2019-11-07', 295, NULL),
('Hi-Way Inn', 87, '2019-11-08', 113, NULL),
('Hi-Way Inn', 87, '2019-11-09', 137, NULL),
('Hi-Way Inn', 87, '2019-11-10', 169, NULL),
('Hi-Way Inn', 87, '2019-11-11', 104, NULL),
('Hi-Way Inn', 87, '2019-11-12', 347, NULL),
('Hi-Way Inn', 87, '2019-11-13', 224, NULL),
('Hi-Way Inn', 87, '2019-11-14', 234, NULL),
('Hi-Way Inn', 87, '2019-11-15', 109, NULL),
('Hi-Way Inn', 87, '2019-11-16', 125, NULL),
('Hi-Way Inn', 87, '2019-11-17', 187, NULL),
('Hi-Way Inn', 87, '2019-11-18', 268, NULL),
('Hi-Way Inn', 87, '2019-11-19', 384, NULL),
('Hi-Way Inn', 87, '2019-11-20', 163, NULL),
('Hi-Way Inn', 87, '2019-11-21', 358, NULL),
('Hi-Way Inn', 87, '2019-11-22', 265, NULL),
('Hi-Way Inn', 87, '2019-11-23', 187, NULL),
('Hi-Way Inn', 87, '2019-11-24', 342, NULL),
('Hi-Way Inn', 87, '2019-11-25', 294, NULL),
('Hi-Way Inn', 87, '2019-11-26', 374, NULL),
('Hi-Way Inn', 87, '2019-11-27', 193, NULL),
('Hi-Way Inn', 87, '2019-11-28', 246, NULL),
('Hi-Way Inn', 87, '2019-11-29', 145, NULL),
('Hi-Way Inn', 87, '2019-11-30', 129, NULL),
('Hi-Way Inn', 87, '2019-12-01', 316, NULL),
('Hi-Way Inn', 87, '2019-12-02', 390, NULL),
('Hi-Way Inn', 87, '2019-12-03', 170, NULL),
('Hi-Way Inn', 87, '2019-12-04', 305, NULL),
('Hi-Way Inn', 87, '2019-12-05', 385, NULL),
('Hi-Way Inn', 87, '2019-12-06', 272, NULL),
('Hi-Way Inn', 87, '2019-12-07', 214, NULL),
('Hi-Way Inn', 87, '2019-12-08', 200, NULL),
('Hi-Way Inn', 87, '2019-12-09', 187, NULL),
('Hi-Way Inn', 87, '2019-12-10', 208, NULL),
('Hi-Way Inn', 87, '2019-12-11', 296, NULL),
('Hi-Way Inn', 87, '2019-12-12', 156, NULL),
('Hi-Way Inn', 87, '2019-12-13', 311, NULL),
('Hi-Way Inn', 87, '2019-12-14', 370, NULL),
('Hi-Way Inn', 87, '2019-12-15', 312, NULL),
('Hi-Way Inn', 87, '2019-12-16', 235, NULL),
('Hi-Way Inn', 87, '2019-12-17', 342, NULL),
('Hi-Way Inn', 87, '2019-12-18', 210, NULL),
('Hi-Way Inn', 87, '2019-12-19', 302, NULL),
('Hi-Way Inn', 87, '2019-12-20', 381, NULL),
('Hi-Way Inn', 87, '2019-12-21', 337, NULL),
('Hi-Way Inn', 87, '2019-12-22', 370, NULL),
('Hi-Way Inn', 87, '2019-12-23', 252, NULL),
('Hi-Way Inn', 87, '2019-12-24', 207, NULL),
('Hi-Way Inn', 87, '2019-12-25', 114, NULL),
('Hi-Way Inn', 87, '2019-12-26', 133, NULL),
('Hi-Way Inn', 87, '2019-12-27', 213, NULL),
('Hi-Way Inn', 87, '2019-12-28', 390, NULL),
('Hi-Way Inn', 87, '2019-12-29', 216, NULL),
('Hi-Way Inn', 87, '2019-12-30', 351, NULL),
('Hi-Way Inn', 87, '2019-12-31', 163, NULL),
('Hi-Way Inn', 87, '2020-01-01', 390, NULL),
('Hi-Way Inn', 87, '2020-01-02', 275, NULL),
('Hi-Way Inn', 87, '2020-01-03', 305, NULL),
('Hi-Way Inn', 87, '2020-01-04', 323, NULL),
('Hi-Way Inn', 87, '2020-01-05', 268, NULL),
('Hi-Way Inn', 87, '2020-01-06', 198, NULL),
('Hi-Way Inn', 87, '2020-01-07', 242, NULL),
('Hi-Way Inn', 87, '2020-01-08', 288, NULL),
('Hi-Way Inn', 87, '2020-01-09', 233, NULL),
('Hi-Way Inn', 87, '2020-01-10', 129, NULL),
('Hi-Way Inn', 87, '2020-01-11', 122, NULL),
('Hi-Way Inn', 87, '2020-01-12', 258, NULL),
('Hi-Way Inn', 87, '2020-01-13', 182, NULL),
('Hi-Way Inn', 87, '2020-01-14', 217, NULL),
('Hi-Way Inn', 87, '2020-01-15', 114, NULL),
('Hi-Way Inn', 87, '2020-01-16', 103, NULL),
('Hi-Way Inn', 87, '2020-01-17', 314, NULL),
('Hi-Way Inn', 87, '2020-01-18', 163, NULL),
('Hi-Way Inn', 87, '2020-01-19', 370, NULL),
('Hi-Way Inn', 87, '2020-01-20', 212, NULL),
('Hi-Way Inn', 87, '2020-01-21', 395, NULL),
('Hi-Way Inn', 87, '2020-01-22', 327, NULL),
('Hi-Way Inn', 87, '2020-01-23', 146, NULL),
('Hi-Way Inn', 87, '2020-01-24', 303, NULL),
('Hi-Way Inn', 87, '2020-01-25', 345, NULL),
('Hi-Way Inn', 87, '2020-01-26', 291, NULL),
('Hi-Way Inn', 87, '2020-01-27', 302, NULL),
('Hi-Way Inn', 87, '2020-01-28', 315, NULL),
('Hi-Way Inn', 87, '2020-01-29', 375, NULL),
('Hi-Way Inn', 87, '2020-01-30', 291, NULL),
('Hi-Way Inn', 87, '2020-01-31', 201, NULL),
('Hi-Way Inn', 87, '2020-02-01', 292, NULL),
('Hi-Way Inn', 87, '2020-02-02', 369, NULL),
('Hi-Way Inn', 87, '2020-02-03', 377, NULL),
('Hi-Way Inn', 87, '2020-02-04', 141, NULL),
('Hi-Way Inn', 94, '2019-01-01', 342, NULL),
('Hi-Way Inn', 94, '2019-01-02', 180, NULL),
('Hi-Way Inn', 94, '2019-01-03', 239, NULL),
('Hi-Way Inn', 94, '2019-01-04', 293, NULL),
('Hi-Way Inn', 94, '2019-01-05', 130, NULL),
('Hi-Way Inn', 94, '2019-01-06', 176, NULL),
('Hi-Way Inn', 94, '2019-01-07', 359, NULL),
('Hi-Way Inn', 94, '2019-01-08', 394, NULL),
('Hi-Way Inn', 94, '2019-01-09', 161, NULL),
('Hi-Way Inn', 94, '2019-01-10', 247, NULL),
('Hi-Way Inn', 94, '2019-01-11', 343, NULL),
('Hi-Way Inn', 94, '2019-01-12', 273, NULL),
('Hi-Way Inn', 94, '2019-01-13', 325, NULL),
('Hi-Way Inn', 94, '2019-01-14', 384, NULL),
('Hi-Way Inn', 94, '2019-01-15', 335, NULL),
('Hi-Way Inn', 94, '2019-01-16', 156, NULL),
('Hi-Way Inn', 94, '2019-01-17', 348, NULL),
('Hi-Way Inn', 94, '2019-01-18', 157, NULL),
('Hi-Way Inn', 94, '2019-01-19', 208, NULL),
('Hi-Way Inn', 94, '2019-01-20', 125, NULL),
('Hi-Way Inn', 94, '2019-01-21', 379, NULL),
('Hi-Way Inn', 94, '2019-01-22', 257, NULL),
('Hi-Way Inn', 94, '2019-01-23', 172, NULL),
('Hi-Way Inn', 94, '2019-01-24', 190, NULL),
('Hi-Way Inn', 94, '2019-01-25', 216, NULL),
('Hi-Way Inn', 94, '2019-01-26', 229, NULL),
('Hi-Way Inn', 94, '2019-01-27', 106, NULL),
('Hi-Way Inn', 94, '2019-01-28', 316, NULL),
('Hi-Way Inn', 94, '2019-01-29', 369, NULL),
('Hi-Way Inn', 94, '2019-01-30', 138, NULL),
('Hi-Way Inn', 94, '2019-01-31', 301, NULL),
('Hi-Way Inn', 94, '2019-02-01', 285, NULL),
('Hi-Way Inn', 94, '2019-02-02', 350, NULL),
('Hi-Way Inn', 94, '2019-02-03', 391, NULL),
('Hi-Way Inn', 94, '2019-02-04', 284, NULL),
('Hi-Way Inn', 94, '2019-02-05', 297, NULL),
('Hi-Way Inn', 94, '2019-02-06', 291, NULL),
('Hi-Way Inn', 94, '2019-02-07', 351, NULL),
('Hi-Way Inn', 94, '2019-02-08', 287, NULL),
('Hi-Way Inn', 94, '2019-02-09', 344, NULL),
('Hi-Way Inn', 94, '2019-02-10', 219, NULL),
('Hi-Way Inn', 94, '2019-02-11', 219, NULL),
('Hi-Way Inn', 94, '2019-02-12', 211, NULL),
('Hi-Way Inn', 94, '2019-02-13', 312, NULL),
('Hi-Way Inn', 94, '2019-02-14', 275, NULL),
('Hi-Way Inn', 94, '2019-02-15', 120, NULL),
('Hi-Way Inn', 94, '2019-02-16', 286, NULL),
('Hi-Way Inn', 94, '2019-02-17', 143, NULL),
('Hi-Way Inn', 94, '2019-02-18', 210, NULL),
('Hi-Way Inn', 94, '2019-02-19', 372, NULL),
('Hi-Way Inn', 94, '2019-02-20', 231, NULL),
('Hi-Way Inn', 94, '2019-02-21', 146, NULL),
('Hi-Way Inn', 94, '2019-02-22', 348, NULL),
('Hi-Way Inn', 94, '2019-02-23', 108, NULL),
('Hi-Way Inn', 94, '2019-02-24', 232, NULL),
('Hi-Way Inn', 94, '2019-02-25', 125, NULL),
('Hi-Way Inn', 94, '2019-02-26', 102, NULL),
('Hi-Way Inn', 94, '2019-02-27', 306, NULL),
('Hi-Way Inn', 94, '2019-02-28', 183, NULL),
('Hi-Way Inn', 94, '2019-03-01', 266, NULL),
('Hi-Way Inn', 94, '2019-03-02', 193, NULL),
('Hi-Way Inn', 94, '2019-03-03', 177, NULL),
('Hi-Way Inn', 94, '2019-03-04', 194, NULL),
('Hi-Way Inn', 94, '2019-03-05', 201, NULL),
('Hi-Way Inn', 94, '2019-03-06', 211, NULL),
('Hi-Way Inn', 94, '2019-03-07', 292, NULL),
('Hi-Way Inn', 94, '2019-03-08', 363, NULL),
('Hi-Way Inn', 94, '2019-03-09', 301, NULL),
('Hi-Way Inn', 94, '2019-03-10', 190, NULL),
('Hi-Way Inn', 94, '2019-03-11', 167, NULL),
('Hi-Way Inn', 94, '2019-03-12', 113, NULL),
('Hi-Way Inn', 94, '2019-03-13', 121, NULL),
('Hi-Way Inn', 94, '2019-03-14', 274, NULL),
('Hi-Way Inn', 94, '2019-03-15', 308, NULL),
('Hi-Way Inn', 94, '2019-03-16', 141, NULL),
('Hi-Way Inn', 94, '2019-03-17', 112, NULL),
('Hi-Way Inn', 94, '2019-03-18', 111, NULL),
('Hi-Way Inn', 94, '2019-03-19', 354, NULL),
('Hi-Way Inn', 94, '2019-03-20', 151, NULL),
('Hi-Way Inn', 94, '2019-03-21', 240, NULL),
('Hi-Way Inn', 94, '2019-03-22', 347, NULL),
('Hi-Way Inn', 94, '2019-03-23', 234, NULL),
('Hi-Way Inn', 94, '2019-03-24', 390, NULL),
('Hi-Way Inn', 94, '2019-03-25', 287, NULL),
('Hi-Way Inn', 94, '2019-03-26', 135, NULL),
('Hi-Way Inn', 94, '2019-03-27', 371, NULL),
('Hi-Way Inn', 94, '2019-03-28', 231, NULL),
('Hi-Way Inn', 94, '2019-03-29', 198, NULL),
('Hi-Way Inn', 94, '2019-03-30', 277, NULL),
('Hi-Way Inn', 94, '2019-03-31', 143, NULL),
('Hi-Way Inn', 94, '2019-04-01', 109, NULL),
('Hi-Way Inn', 94, '2019-04-02', 307, NULL),
('Hi-Way Inn', 94, '2019-04-03', 129, NULL),
('Hi-Way Inn', 94, '2019-04-04', 202, NULL),
('Hi-Way Inn', 94, '2019-04-05', 194, NULL),
('Hi-Way Inn', 94, '2019-04-06', 340, NULL),
('Hi-Way Inn', 94, '2019-04-07', 358, NULL),
('Hi-Way Inn', 94, '2019-04-08', 294, NULL),
('Hi-Way Inn', 94, '2019-04-09', 102, NULL),
('Hi-Way Inn', 94, '2019-04-10', 216, NULL),
('Hi-Way Inn', 94, '2019-04-11', 306, NULL),
('Hi-Way Inn', 94, '2019-04-12', 227, NULL),
('Hi-Way Inn', 94, '2019-04-13', 201, NULL),
('Hi-Way Inn', 94, '2019-04-14', 227, NULL),
('Hi-Way Inn', 94, '2019-04-15', 280, NULL),
('Hi-Way Inn', 94, '2019-04-16', 393, NULL),
('Hi-Way Inn', 94, '2019-04-17', 101, NULL),
('Hi-Way Inn', 94, '2019-04-18', 223, NULL),
('Hi-Way Inn', 94, '2019-04-19', 239, NULL),
('Hi-Way Inn', 94, '2019-04-20', 208, NULL),
('Hi-Way Inn', 94, '2019-04-21', 207, NULL),
('Hi-Way Inn', 94, '2019-04-22', 372, NULL),
('Hi-Way Inn', 94, '2019-04-23', 376, NULL),
('Hi-Way Inn', 94, '2019-04-24', 161, NULL),
('Hi-Way Inn', 94, '2019-04-25', 139, NULL),
('Hi-Way Inn', 94, '2019-04-26', 295, NULL),
('Hi-Way Inn', 94, '2019-04-27', 377, NULL),
('Hi-Way Inn', 94, '2019-04-28', 290, NULL),
('Hi-Way Inn', 94, '2019-04-29', 139, NULL),
('Hi-Way Inn', 94, '2019-04-30', 193, NULL),
('Hi-Way Inn', 94, '2019-05-01', 316, NULL),
('Hi-Way Inn', 94, '2019-05-02', 389, NULL),
('Hi-Way Inn', 94, '2019-05-03', 197, NULL),
('Hi-Way Inn', 94, '2019-05-04', 260, NULL),
('Hi-Way Inn', 94, '2019-05-05', 118, NULL),
('Hi-Way Inn', 94, '2019-05-06', 186, NULL),
('Hi-Way Inn', 94, '2019-05-07', 171, NULL),
('Hi-Way Inn', 94, '2019-05-08', 264, NULL),
('Hi-Way Inn', 94, '2019-05-09', 236, NULL),
('Hi-Way Inn', 94, '2019-05-10', 120, NULL),
('Hi-Way Inn', 94, '2019-05-11', 346, NULL),
('Hi-Way Inn', 94, '2019-05-12', 298, NULL),
('Hi-Way Inn', 94, '2019-05-13', 291, NULL),
('Hi-Way Inn', 94, '2019-05-14', 159, NULL),
('Hi-Way Inn', 94, '2019-05-15', 389, NULL),
('Hi-Way Inn', 94, '2019-05-16', 328, NULL),
('Hi-Way Inn', 94, '2019-05-17', 221, NULL),
('Hi-Way Inn', 94, '2019-05-18', 182, NULL),
('Hi-Way Inn', 94, '2019-05-19', 234, NULL),
('Hi-Way Inn', 94, '2019-05-20', 304, NULL),
('Hi-Way Inn', 94, '2019-05-21', 116, NULL),
('Hi-Way Inn', 94, '2019-05-22', 224, NULL),
('Hi-Way Inn', 94, '2019-05-23', 253, NULL),
('Hi-Way Inn', 94, '2019-05-24', 134, NULL),
('Hi-Way Inn', 94, '2019-05-25', 377, NULL),
('Hi-Way Inn', 94, '2019-05-26', 253, NULL),
('Hi-Way Inn', 94, '2019-05-27', 285, NULL),
('Hi-Way Inn', 94, '2019-05-28', 330, NULL),
('Hi-Way Inn', 94, '2019-05-29', 260, NULL),
('Hi-Way Inn', 94, '2019-05-30', 315, NULL),
('Hi-Way Inn', 94, '2019-05-31', 178, NULL),
('Hi-Way Inn', 94, '2019-06-01', 279, NULL),
('Hi-Way Inn', 94, '2019-06-02', 100, NULL),
('Hi-Way Inn', 94, '2019-06-03', 355, NULL),
('Hi-Way Inn', 94, '2019-06-04', 227, NULL),
('Hi-Way Inn', 94, '2019-06-05', 164, NULL),
('Hi-Way Inn', 94, '2019-06-06', 201, NULL),
('Hi-Way Inn', 94, '2019-06-07', 250, NULL),
('Hi-Way Inn', 94, '2019-06-08', 210, NULL),
('Hi-Way Inn', 94, '2019-06-09', 356, NULL),
('Hi-Way Inn', 94, '2019-06-10', 333, NULL),
('Hi-Way Inn', 94, '2019-06-11', 167, NULL),
('Hi-Way Inn', 94, '2019-06-12', 361, NULL),
('Hi-Way Inn', 94, '2019-06-13', 279, NULL),
('Hi-Way Inn', 94, '2019-06-14', 124, NULL),
('Hi-Way Inn', 94, '2019-06-15', 353, NULL),
('Hi-Way Inn', 94, '2019-06-16', 265, NULL),
('Hi-Way Inn', 94, '2019-06-17', 318, NULL),
('Hi-Way Inn', 94, '2019-06-18', 365, NULL),
('Hi-Way Inn', 94, '2019-06-19', 228, NULL),
('Hi-Way Inn', 94, '2019-06-20', 221, NULL),
('Hi-Way Inn', 94, '2019-06-21', 384, NULL),
('Hi-Way Inn', 94, '2019-06-22', 258, NULL),
('Hi-Way Inn', 94, '2019-06-23', 103, NULL),
('Hi-Way Inn', 94, '2019-06-24', 260, NULL),
('Hi-Way Inn', 94, '2019-06-25', 313, NULL),
('Hi-Way Inn', 94, '2019-06-26', 194, NULL),
('Hi-Way Inn', 94, '2019-06-27', 223, NULL),
('Hi-Way Inn', 94, '2019-06-28', 346, NULL),
('Hi-Way Inn', 94, '2019-06-29', 248, NULL),
('Hi-Way Inn', 94, '2019-06-30', 237, NULL),
('Hi-Way Inn', 94, '2019-07-01', 181, NULL),
('Hi-Way Inn', 94, '2019-07-02', 365, NULL),
('Hi-Way Inn', 94, '2019-07-03', 117, NULL),
('Hi-Way Inn', 94, '2019-07-04', 198, NULL),
('Hi-Way Inn', 94, '2019-07-05', 175, NULL),
('Hi-Way Inn', 94, '2019-07-06', 107, NULL),
('Hi-Way Inn', 94, '2019-07-07', 134, NULL),
('Hi-Way Inn', 94, '2019-07-08', 190, NULL),
('Hi-Way Inn', 94, '2019-07-09', 193, NULL),
('Hi-Way Inn', 94, '2019-07-10', 391, NULL),
('Hi-Way Inn', 94, '2019-07-11', 211, NULL),
('Hi-Way Inn', 94, '2019-07-12', 300, NULL),
('Hi-Way Inn', 94, '2019-07-13', 114, NULL),
('Hi-Way Inn', 94, '2019-07-14', 112, NULL),
('Hi-Way Inn', 94, '2019-07-15', 166, NULL),
('Hi-Way Inn', 94, '2019-07-16', 173, NULL),
('Hi-Way Inn', 94, '2019-07-17', 244, NULL),
('Hi-Way Inn', 94, '2019-07-18', 328, NULL),
('Hi-Way Inn', 94, '2019-07-19', 156, NULL),
('Hi-Way Inn', 94, '2019-07-20', 344, NULL),
('Hi-Way Inn', 94, '2019-07-21', 194, NULL),
('Hi-Way Inn', 94, '2019-07-22', 184, NULL),
('Hi-Way Inn', 94, '2019-07-23', 268, NULL),
('Hi-Way Inn', 94, '2019-07-24', 243, NULL),
('Hi-Way Inn', 94, '2019-07-25', 369, NULL),
('Hi-Way Inn', 94, '2019-07-26', 286, NULL),
('Hi-Way Inn', 94, '2019-07-27', 306, NULL),
('Hi-Way Inn', 94, '2019-07-28', 182, NULL),
('Hi-Way Inn', 94, '2019-07-29', 276, NULL),
('Hi-Way Inn', 94, '2019-07-30', 143, NULL),
('Hi-Way Inn', 94, '2019-07-31', 156, NULL),
('Hi-Way Inn', 94, '2019-08-01', 189, NULL),
('Hi-Way Inn', 94, '2019-08-02', 155, NULL),
('Hi-Way Inn', 94, '2019-08-03', 366, NULL),
('Hi-Way Inn', 94, '2019-08-04', 320, NULL),
('Hi-Way Inn', 94, '2019-08-05', 306, NULL),
('Hi-Way Inn', 94, '2019-08-06', 109, NULL),
('Hi-Way Inn', 94, '2019-08-07', 352, NULL),
('Hi-Way Inn', 94, '2019-08-08', 244, NULL),
('Hi-Way Inn', 94, '2019-08-09', 334, NULL),
('Hi-Way Inn', 94, '2019-08-10', 211, NULL),
('Hi-Way Inn', 94, '2019-08-11', 398, NULL),
('Hi-Way Inn', 94, '2019-08-12', 239, NULL),
('Hi-Way Inn', 94, '2019-08-13', 366, NULL),
('Hi-Way Inn', 94, '2019-08-14', 288, NULL),
('Hi-Way Inn', 94, '2019-08-15', 358, NULL),
('Hi-Way Inn', 94, '2019-08-16', 174, NULL),
('Hi-Way Inn', 94, '2019-08-17', 268, NULL),
('Hi-Way Inn', 94, '2019-08-18', 235, NULL),
('Hi-Way Inn', 94, '2019-08-19', 143, NULL),
('Hi-Way Inn', 94, '2019-08-20', 203, NULL),
('Hi-Way Inn', 94, '2019-08-21', 389, NULL),
('Hi-Way Inn', 94, '2019-08-22', 377, NULL),
('Hi-Way Inn', 94, '2019-08-23', 329, NULL),
('Hi-Way Inn', 94, '2019-08-24', 351, NULL),
('Hi-Way Inn', 94, '2019-08-25', 326, NULL),
('Hi-Way Inn', 94, '2019-08-26', 210, NULL),
('Hi-Way Inn', 94, '2019-08-27', 253, NULL),
('Hi-Way Inn', 94, '2019-08-28', 344, NULL),
('Hi-Way Inn', 94, '2019-08-29', 359, NULL),
('Hi-Way Inn', 94, '2019-08-30', 324, NULL),
('Hi-Way Inn', 94, '2019-08-31', 341, NULL),
('Hi-Way Inn', 94, '2019-09-01', 308, NULL),
('Hi-Way Inn', 94, '2019-09-02', 396, NULL),
('Hi-Way Inn', 94, '2019-09-03', 260, NULL),
('Hi-Way Inn', 94, '2019-09-04', 294, NULL),
('Hi-Way Inn', 94, '2019-09-05', 185, NULL),
('Hi-Way Inn', 94, '2019-09-06', 123, NULL),
('Hi-Way Inn', 94, '2019-09-07', 377, NULL),
('Hi-Way Inn', 94, '2019-09-08', 215, NULL),
('Hi-Way Inn', 94, '2019-09-09', 297, NULL),
('Hi-Way Inn', 94, '2019-09-10', 110, NULL),
('Hi-Way Inn', 94, '2019-09-11', 288, NULL),
('Hi-Way Inn', 94, '2019-09-12', 318, NULL),
('Hi-Way Inn', 94, '2019-09-13', 192, NULL),
('Hi-Way Inn', 94, '2019-09-14', 396, NULL),
('Hi-Way Inn', 94, '2019-09-15', 101, NULL),
('Hi-Way Inn', 94, '2019-09-16', 161, NULL),
('Hi-Way Inn', 94, '2019-09-17', 177, NULL),
('Hi-Way Inn', 94, '2019-09-18', 106, NULL),
('Hi-Way Inn', 94, '2019-09-19', 335, NULL),
('Hi-Way Inn', 94, '2019-09-20', 174, NULL),
('Hi-Way Inn', 94, '2019-09-21', 220, NULL),
('Hi-Way Inn', 94, '2019-09-22', 109, NULL),
('Hi-Way Inn', 94, '2019-09-23', 286, NULL),
('Hi-Way Inn', 94, '2019-09-24', 365, NULL),
('Hi-Way Inn', 94, '2019-09-25', 318, NULL),
('Hi-Way Inn', 94, '2019-09-26', 375, NULL),
('Hi-Way Inn', 94, '2019-09-27', 269, NULL),
('Hi-Way Inn', 94, '2019-09-28', 243, NULL),
('Hi-Way Inn', 94, '2019-09-29', 249, NULL),
('Hi-Way Inn', 94, '2019-09-30', 101, NULL),
('Hi-Way Inn', 94, '2019-10-01', 390, NULL),
('Hi-Way Inn', 94, '2019-10-02', 338, NULL),
('Hi-Way Inn', 94, '2019-10-03', 368, NULL),
('Hi-Way Inn', 94, '2019-10-04', 395, NULL),
('Hi-Way Inn', 94, '2019-10-05', 129, NULL),
('Hi-Way Inn', 94, '2019-10-06', 138, NULL),
('Hi-Way Inn', 94, '2019-10-07', 231, NULL),
('Hi-Way Inn', 94, '2019-10-08', 232, NULL),
('Hi-Way Inn', 94, '2019-10-09', 121, NULL),
('Hi-Way Inn', 94, '2019-10-10', 359, NULL),
('Hi-Way Inn', 94, '2019-10-11', 128, NULL),
('Hi-Way Inn', 94, '2019-10-12', 239, NULL),
('Hi-Way Inn', 94, '2019-10-13', 146, NULL),
('Hi-Way Inn', 94, '2019-10-14', 366, NULL),
('Hi-Way Inn', 94, '2019-10-15', 286, NULL),
('Hi-Way Inn', 94, '2019-10-16', 220, NULL),
('Hi-Way Inn', 94, '2019-10-17', 339, NULL),
('Hi-Way Inn', 94, '2019-10-18', 202, NULL),
('Hi-Way Inn', 94, '2019-10-19', 179, NULL),
('Hi-Way Inn', 94, '2019-10-20', 294, NULL),
('Hi-Way Inn', 94, '2019-10-21', 376, NULL),
('Hi-Way Inn', 94, '2019-10-22', 304, NULL),
('Hi-Way Inn', 94, '2019-10-23', 125, NULL),
('Hi-Way Inn', 94, '2019-10-24', 371, NULL),
('Hi-Way Inn', 94, '2019-10-25', 196, NULL),
('Hi-Way Inn', 94, '2019-10-26', 317, NULL),
('Hi-Way Inn', 94, '2019-10-27', 344, NULL),
('Hi-Way Inn', 94, '2019-10-28', 244, NULL),
('Hi-Way Inn', 94, '2019-10-29', 387, NULL),
('Hi-Way Inn', 94, '2019-10-30', 234, NULL),
('Hi-Way Inn', 94, '2019-10-31', 392, NULL),
('Hi-Way Inn', 94, '2019-11-01', 229, NULL),
('Hi-Way Inn', 94, '2019-11-02', 209, NULL),
('Hi-Way Inn', 94, '2019-11-03', 390, NULL),
('Hi-Way Inn', 94, '2019-11-04', 134, NULL),
('Hi-Way Inn', 94, '2019-11-05', 241, NULL),
('Hi-Way Inn', 94, '2019-11-06', 253, NULL),
('Hi-Way Inn', 94, '2019-11-07', 118, NULL),
('Hi-Way Inn', 94, '2019-11-08', 109, NULL),
('Hi-Way Inn', 94, '2019-11-09', 304, NULL),
('Hi-Way Inn', 94, '2019-11-10', 257, NULL),
('Hi-Way Inn', 94, '2019-11-11', 229, NULL),
('Hi-Way Inn', 94, '2019-11-12', 283, NULL),
('Hi-Way Inn', 94, '2019-11-13', 330, NULL),
('Hi-Way Inn', 94, '2019-11-14', 147, NULL),
('Hi-Way Inn', 94, '2019-11-15', 102, NULL),
('Hi-Way Inn', 94, '2019-11-16', 311, NULL),
('Hi-Way Inn', 94, '2019-11-17', 119, NULL),
('Hi-Way Inn', 94, '2019-11-18', 332, NULL),
('Hi-Way Inn', 94, '2019-11-19', 105, NULL),
('Hi-Way Inn', 94, '2019-11-20', 125, NULL),
('Hi-Way Inn', 94, '2019-11-21', 176, NULL),
('Hi-Way Inn', 94, '2019-11-22', 234, NULL),
('Hi-Way Inn', 94, '2019-11-23', 162, NULL),
('Hi-Way Inn', 94, '2019-11-24', 350, NULL),
('Hi-Way Inn', 94, '2019-11-25', 220, NULL),
('Hi-Way Inn', 94, '2019-11-26', 132, NULL),
('Hi-Way Inn', 94, '2019-11-27', 233, NULL),
('Hi-Way Inn', 94, '2019-11-28', 374, NULL),
('Hi-Way Inn', 94, '2019-11-29', 302, NULL),
('Hi-Way Inn', 94, '2019-11-30', 364, NULL),
('Hi-Way Inn', 94, '2019-12-01', 360, NULL),
('Hi-Way Inn', 94, '2019-12-02', 248, NULL),
('Hi-Way Inn', 94, '2019-12-03', 320, NULL),
('Hi-Way Inn', 94, '2019-12-04', 204, NULL),
('Hi-Way Inn', 94, '2019-12-05', 205, NULL),
('Hi-Way Inn', 94, '2019-12-06', 326, NULL),
('Hi-Way Inn', 94, '2019-12-07', 251, NULL),
('Hi-Way Inn', 94, '2019-12-08', 100, NULL),
('Hi-Way Inn', 94, '2019-12-09', 181, NULL),
('Hi-Way Inn', 94, '2019-12-10', 126, NULL),
('Hi-Way Inn', 94, '2019-12-11', 396, NULL),
('Hi-Way Inn', 94, '2019-12-12', 282, NULL),
('Hi-Way Inn', 94, '2019-12-13', 398, NULL),
('Hi-Way Inn', 94, '2019-12-14', 307, NULL),
('Hi-Way Inn', 94, '2019-12-15', 220, NULL),
('Hi-Way Inn', 94, '2019-12-16', 144, NULL),
('Hi-Way Inn', 94, '2019-12-17', 115, NULL),
('Hi-Way Inn', 94, '2019-12-18', 335, NULL),
('Hi-Way Inn', 94, '2019-12-19', 269, NULL),
('Hi-Way Inn', 94, '2019-12-20', 262, NULL),
('Hi-Way Inn', 94, '2019-12-21', 108, NULL),
('Hi-Way Inn', 94, '2019-12-22', 108, NULL),
('Hi-Way Inn', 94, '2019-12-23', 241, NULL),
('Hi-Way Inn', 94, '2019-12-24', 306, NULL),
('Hi-Way Inn', 94, '2019-12-25', 373, NULL),
('Hi-Way Inn', 94, '2019-12-26', 138, NULL),
('Hi-Way Inn', 94, '2019-12-27', 325, NULL),
('Hi-Way Inn', 94, '2019-12-28', 376, NULL),
('Hi-Way Inn', 94, '2019-12-29', 276, NULL),
('Hi-Way Inn', 94, '2019-12-30', 280, NULL),
('Hi-Way Inn', 94, '2019-12-31', 357, NULL),
('Hi-Way Inn', 94, '2020-01-01', 283, NULL),
('Hi-Way Inn', 94, '2020-01-02', 106, NULL),
('Hi-Way Inn', 94, '2020-01-03', 287, NULL),
('Hi-Way Inn', 94, '2020-01-04', 160, NULL),
('Hi-Way Inn', 94, '2020-01-05', 267, NULL),
('Hi-Way Inn', 94, '2020-01-06', 386, NULL),
('Hi-Way Inn', 94, '2020-01-07', 155, NULL),
('Hi-Way Inn', 94, '2020-01-08', 196, NULL),
('Hi-Way Inn', 94, '2020-01-09', 359, NULL),
('Hi-Way Inn', 94, '2020-01-10', 322, NULL),
('Hi-Way Inn', 94, '2020-01-11', 249, NULL),
('Hi-Way Inn', 94, '2020-01-12', 150, NULL),
('Hi-Way Inn', 94, '2020-01-13', 151, NULL),
('Hi-Way Inn', 94, '2020-01-14', 247, NULL),
('Hi-Way Inn', 94, '2020-01-15', 132, NULL),
('Hi-Way Inn', 94, '2020-01-16', 229, NULL),
('Hi-Way Inn', 94, '2020-01-17', 387, NULL),
('Hi-Way Inn', 94, '2020-01-18', 368, NULL),
('Hi-Way Inn', 94, '2020-01-19', 255, NULL),
('Hi-Way Inn', 94, '2020-01-20', 306, NULL),
('Hi-Way Inn', 94, '2020-01-21', 332, NULL),
('Hi-Way Inn', 94, '2020-01-22', 227, NULL),
('Hi-Way Inn', 94, '2020-01-23', 271, NULL),
('Hi-Way Inn', 94, '2020-01-24', 389, NULL),
('Hi-Way Inn', 94, '2020-01-25', 338, NULL),
('Hi-Way Inn', 94, '2020-01-26', 335, NULL),
('Hi-Way Inn', 94, '2020-01-27', 348, NULL),
('Hi-Way Inn', 94, '2020-01-28', 276, NULL),
('Hi-Way Inn', 94, '2020-01-29', 284, NULL),
('Hi-Way Inn', 94, '2020-01-30', 169, NULL),
('Hi-Way Inn', 94, '2020-01-31', 210, NULL),
('Hi-Way Inn', 94, '2020-02-01', 291, NULL),
('Hi-Way Inn', 94, '2020-02-02', 252, NULL),
('Hi-Way Inn', 94, '2020-02-03', 356, NULL),
('Hi-Way Inn', 94, '2020-02-04', 304, NULL),
('Hi-Way Inn', 117, '2019-01-01', 205, NULL),
('Hi-Way Inn', 117, '2019-01-02', 171, NULL),
('Hi-Way Inn', 117, '2019-01-03', 245, NULL),
('Hi-Way Inn', 117, '2019-01-04', 272, NULL),
('Hi-Way Inn', 117, '2019-01-05', 339, NULL),
('Hi-Way Inn', 117, '2019-01-06', 285, NULL),
('Hi-Way Inn', 117, '2019-01-07', 190, NULL),
('Hi-Way Inn', 117, '2019-01-08', 112, NULL),
('Hi-Way Inn', 117, '2019-01-09', 249, NULL),
('Hi-Way Inn', 117, '2019-01-10', 380, NULL),
('Hi-Way Inn', 117, '2019-01-11', 247, NULL),
('Hi-Way Inn', 117, '2019-01-12', 253, NULL),
('Hi-Way Inn', 117, '2019-01-13', 162, NULL),
('Hi-Way Inn', 117, '2019-01-14', 306, NULL),
('Hi-Way Inn', 117, '2019-01-15', 159, NULL),
('Hi-Way Inn', 117, '2019-01-16', 114, NULL),
('Hi-Way Inn', 117, '2019-01-17', 178, NULL),
('Hi-Way Inn', 117, '2019-01-18', 130, NULL),
('Hi-Way Inn', 117, '2019-01-19', 144, NULL),
('Hi-Way Inn', 117, '2019-01-20', 210, NULL),
('Hi-Way Inn', 117, '2019-01-21', 296, NULL),
('Hi-Way Inn', 117, '2019-01-22', 159, NULL),
('Hi-Way Inn', 117, '2019-01-23', 178, NULL),
('Hi-Way Inn', 117, '2019-01-24', 250, NULL),
('Hi-Way Inn', 117, '2019-01-25', 209, NULL),
('Hi-Way Inn', 117, '2019-01-26', 117, NULL),
('Hi-Way Inn', 117, '2019-01-27', 160, NULL),
('Hi-Way Inn', 117, '2019-01-28', 176, NULL),
('Hi-Way Inn', 117, '2019-01-29', 253, NULL),
('Hi-Way Inn', 117, '2019-01-30', 290, NULL),
('Hi-Way Inn', 117, '2019-01-31', 101, NULL),
('Hi-Way Inn', 117, '2019-02-01', 198, NULL),
('Hi-Way Inn', 117, '2019-02-02', 344, NULL),
('Hi-Way Inn', 117, '2019-02-03', 258, NULL),
('Hi-Way Inn', 117, '2019-02-04', 363, NULL),
('Hi-Way Inn', 117, '2019-02-05', 230, NULL),
('Hi-Way Inn', 117, '2019-02-06', 148, NULL),
('Hi-Way Inn', 117, '2019-02-07', 325, NULL),
('Hi-Way Inn', 117, '2019-02-08', 105, NULL),
('Hi-Way Inn', 117, '2019-02-09', 219, NULL),
('Hi-Way Inn', 117, '2019-02-10', 154, NULL),
('Hi-Way Inn', 117, '2019-02-11', 284, NULL),
('Hi-Way Inn', 117, '2019-02-12', 242, NULL),
('Hi-Way Inn', 117, '2019-02-13', 148, NULL),
('Hi-Way Inn', 117, '2019-02-14', 352, NULL),
('Hi-Way Inn', 117, '2019-02-15', 312, NULL),
('Hi-Way Inn', 117, '2019-02-16', 390, NULL),
('Hi-Way Inn', 117, '2019-02-17', 214, NULL),
('Hi-Way Inn', 117, '2019-02-18', 136, NULL),
('Hi-Way Inn', 117, '2019-02-19', 147, NULL),
('Hi-Way Inn', 117, '2019-02-20', 223, NULL),
('Hi-Way Inn', 117, '2019-02-21', 227, NULL),
('Hi-Way Inn', 117, '2019-02-22', 201, NULL),
('Hi-Way Inn', 117, '2019-02-23', 258, NULL),
('Hi-Way Inn', 117, '2019-02-24', 289, NULL),
('Hi-Way Inn', 117, '2019-02-25', 274, NULL),
('Hi-Way Inn', 117, '2019-02-26', 376, NULL),
('Hi-Way Inn', 117, '2019-02-27', 104, NULL),
('Hi-Way Inn', 117, '2019-02-28', 100, NULL),
('Hi-Way Inn', 117, '2019-03-01', 289, NULL),
('Hi-Way Inn', 117, '2019-03-02', 243, NULL),
('Hi-Way Inn', 117, '2019-03-03', 177, NULL),
('Hi-Way Inn', 117, '2019-03-04', 245, NULL),
('Hi-Way Inn', 117, '2019-03-05', 226, NULL),
('Hi-Way Inn', 117, '2019-03-06', 341, NULL),
('Hi-Way Inn', 117, '2019-03-07', 159, NULL),
('Hi-Way Inn', 117, '2019-03-08', 161, NULL),
('Hi-Way Inn', 117, '2019-03-09', 154, NULL),
('Hi-Way Inn', 117, '2019-03-10', 365, NULL),
('Hi-Way Inn', 117, '2019-03-11', 166, NULL),
('Hi-Way Inn', 117, '2019-03-12', 128, NULL),
('Hi-Way Inn', 117, '2019-03-13', 120, NULL),
('Hi-Way Inn', 117, '2019-03-14', 304, NULL),
('Hi-Way Inn', 117, '2019-03-15', 116, NULL),
('Hi-Way Inn', 117, '2019-03-16', 190, NULL),
('Hi-Way Inn', 117, '2019-03-17', 252, NULL),
('Hi-Way Inn', 117, '2019-03-18', 108, NULL),
('Hi-Way Inn', 117, '2019-03-19', 326, NULL),
('Hi-Way Inn', 117, '2019-03-20', 389, NULL),
('Hi-Way Inn', 117, '2019-03-21', 256, NULL),
('Hi-Way Inn', 117, '2019-03-22', 163, NULL),
('Hi-Way Inn', 117, '2019-03-23', 361, NULL),
('Hi-Way Inn', 117, '2019-03-24', 345, NULL),
('Hi-Way Inn', 117, '2019-03-25', 386, NULL),
('Hi-Way Inn', 117, '2019-03-26', 184, NULL),
('Hi-Way Inn', 117, '2019-03-27', 136, NULL),
('Hi-Way Inn', 117, '2019-03-28', 318, NULL),
('Hi-Way Inn', 117, '2019-03-29', 380, NULL),
('Hi-Way Inn', 117, '2019-03-30', 240, NULL),
('Hi-Way Inn', 117, '2019-03-31', 202, NULL),
('Hi-Way Inn', 117, '2019-04-01', 371, NULL),
('Hi-Way Inn', 117, '2019-04-02', 151, NULL),
('Hi-Way Inn', 117, '2019-04-03', 113, NULL),
('Hi-Way Inn', 117, '2019-04-04', 237, NULL),
('Hi-Way Inn', 117, '2019-04-05', 226, NULL),
('Hi-Way Inn', 117, '2019-04-06', 150, NULL),
('Hi-Way Inn', 117, '2019-04-07', 394, NULL),
('Hi-Way Inn', 117, '2019-04-08', 233, NULL),
('Hi-Way Inn', 117, '2019-04-09', 215, NULL),
('Hi-Way Inn', 117, '2019-04-10', 279, NULL),
('Hi-Way Inn', 117, '2019-04-11', 147, NULL),
('Hi-Way Inn', 117, '2019-04-12', 281, NULL),
('Hi-Way Inn', 117, '2019-04-13', 100, NULL),
('Hi-Way Inn', 117, '2019-04-14', 252, NULL),
('Hi-Way Inn', 117, '2019-04-15', 297, NULL),
('Hi-Way Inn', 117, '2019-04-16', 383, NULL),
('Hi-Way Inn', 117, '2019-04-17', 367, NULL),
('Hi-Way Inn', 117, '2019-04-18', 348, NULL),
('Hi-Way Inn', 117, '2019-04-19', 261, NULL),
('Hi-Way Inn', 117, '2019-04-20', 201, NULL),
('Hi-Way Inn', 117, '2019-04-21', 167, NULL),
('Hi-Way Inn', 117, '2019-04-22', 278, NULL),
('Hi-Way Inn', 117, '2019-04-23', 204, NULL),
('Hi-Way Inn', 117, '2019-04-24', 268, NULL),
('Hi-Way Inn', 117, '2019-04-25', 232, NULL),
('Hi-Way Inn', 117, '2019-04-26', 274, NULL),
('Hi-Way Inn', 117, '2019-04-27', 193, NULL),
('Hi-Way Inn', 117, '2019-04-28', 365, NULL),
('Hi-Way Inn', 117, '2019-04-29', 345, NULL),
('Hi-Way Inn', 117, '2019-04-30', 368, NULL),
('Hi-Way Inn', 117, '2019-05-01', 197, NULL),
('Hi-Way Inn', 117, '2019-05-02', 299, NULL),
('Hi-Way Inn', 117, '2019-05-03', 301, NULL),
('Hi-Way Inn', 117, '2019-05-04', 253, NULL),
('Hi-Way Inn', 117, '2019-05-05', 390, NULL),
('Hi-Way Inn', 117, '2019-05-06', 134, NULL),
('Hi-Way Inn', 117, '2019-05-07', 199, NULL),
('Hi-Way Inn', 117, '2019-05-08', 143, NULL),
('Hi-Way Inn', 117, '2019-05-09', 198, NULL),
('Hi-Way Inn', 117, '2019-05-10', 308, NULL),
('Hi-Way Inn', 117, '2019-05-11', 397, NULL),
('Hi-Way Inn', 117, '2019-05-12', 259, NULL),
('Hi-Way Inn', 117, '2019-05-13', 341, NULL),
('Hi-Way Inn', 117, '2019-05-14', 106, NULL),
('Hi-Way Inn', 117, '2019-05-15', 304, NULL),
('Hi-Way Inn', 117, '2019-05-16', 154, NULL),
('Hi-Way Inn', 117, '2019-05-17', 295, NULL),
('Hi-Way Inn', 117, '2019-05-18', 136, NULL),
('Hi-Way Inn', 117, '2019-05-19', 164, NULL),
('Hi-Way Inn', 117, '2019-05-20', 188, NULL),
('Hi-Way Inn', 117, '2019-05-21', 282, NULL),
('Hi-Way Inn', 117, '2019-05-22', 145, NULL),
('Hi-Way Inn', 117, '2019-05-23', 202, NULL),
('Hi-Way Inn', 117, '2019-05-24', 249, NULL),
('Hi-Way Inn', 117, '2019-05-25', 301, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 117, '2019-05-26', 293, NULL),
('Hi-Way Inn', 117, '2019-05-27', 228, NULL),
('Hi-Way Inn', 117, '2019-05-28', 276, NULL),
('Hi-Way Inn', 117, '2019-05-29', 362, NULL),
('Hi-Way Inn', 117, '2019-05-30', 231, NULL),
('Hi-Way Inn', 117, '2019-05-31', 233, NULL),
('Hi-Way Inn', 117, '2019-06-01', 140, NULL),
('Hi-Way Inn', 117, '2019-06-02', 282, NULL),
('Hi-Way Inn', 117, '2019-06-03', 105, NULL),
('Hi-Way Inn', 117, '2019-06-04', 263, NULL),
('Hi-Way Inn', 117, '2019-06-05', 339, NULL),
('Hi-Way Inn', 117, '2019-06-06', 322, NULL),
('Hi-Way Inn', 117, '2019-06-07', 120, NULL),
('Hi-Way Inn', 117, '2019-06-08', 378, NULL),
('Hi-Way Inn', 117, '2019-06-09', 391, NULL),
('Hi-Way Inn', 117, '2019-06-10', 347, NULL),
('Hi-Way Inn', 117, '2019-06-11', 116, NULL),
('Hi-Way Inn', 117, '2019-06-12', 178, NULL),
('Hi-Way Inn', 117, '2019-06-13', 252, NULL),
('Hi-Way Inn', 117, '2019-06-14', 352, NULL),
('Hi-Way Inn', 117, '2019-06-15', 141, NULL),
('Hi-Way Inn', 117, '2019-06-16', 294, NULL),
('Hi-Way Inn', 117, '2019-06-17', 151, NULL),
('Hi-Way Inn', 117, '2019-06-18', 223, NULL),
('Hi-Way Inn', 117, '2019-06-19', 262, NULL),
('Hi-Way Inn', 117, '2019-06-20', 217, NULL),
('Hi-Way Inn', 117, '2019-06-21', 389, NULL),
('Hi-Way Inn', 117, '2019-06-22', 261, NULL),
('Hi-Way Inn', 117, '2019-06-23', 131, NULL),
('Hi-Way Inn', 117, '2019-06-24', 388, NULL),
('Hi-Way Inn', 117, '2019-06-25', 337, NULL),
('Hi-Way Inn', 117, '2019-06-26', 266, NULL),
('Hi-Way Inn', 117, '2019-06-27', 321, NULL),
('Hi-Way Inn', 117, '2019-06-28', 180, NULL),
('Hi-Way Inn', 117, '2019-06-29', 202, NULL),
('Hi-Way Inn', 117, '2019-06-30', 244, NULL),
('Hi-Way Inn', 117, '2019-07-01', 341, NULL),
('Hi-Way Inn', 117, '2019-07-02', 398, NULL),
('Hi-Way Inn', 117, '2019-07-03', 380, NULL),
('Hi-Way Inn', 117, '2019-07-04', 189, NULL),
('Hi-Way Inn', 117, '2019-07-05', 284, NULL),
('Hi-Way Inn', 117, '2019-07-06', 380, NULL),
('Hi-Way Inn', 117, '2019-07-07', 299, NULL),
('Hi-Way Inn', 117, '2019-07-08', 150, NULL),
('Hi-Way Inn', 117, '2019-07-09', 341, NULL),
('Hi-Way Inn', 117, '2019-07-10', 188, NULL),
('Hi-Way Inn', 117, '2019-07-11', 174, NULL),
('Hi-Way Inn', 117, '2019-07-12', 151, NULL),
('Hi-Way Inn', 117, '2019-07-13', 295, NULL),
('Hi-Way Inn', 117, '2019-07-14', 243, NULL),
('Hi-Way Inn', 117, '2019-07-15', 103, NULL),
('Hi-Way Inn', 117, '2019-07-16', 269, NULL),
('Hi-Way Inn', 117, '2019-07-17', 285, NULL),
('Hi-Way Inn', 117, '2019-07-18', 187, NULL),
('Hi-Way Inn', 117, '2019-07-19', 340, NULL),
('Hi-Way Inn', 117, '2019-07-20', 188, NULL),
('Hi-Way Inn', 117, '2019-07-21', 145, NULL),
('Hi-Way Inn', 117, '2019-07-22', 248, NULL),
('Hi-Way Inn', 117, '2019-07-23', 218, NULL),
('Hi-Way Inn', 117, '2019-07-24', 190, NULL),
('Hi-Way Inn', 117, '2019-07-25', 272, NULL),
('Hi-Way Inn', 117, '2019-07-26', 136, NULL),
('Hi-Way Inn', 117, '2019-07-27', 108, NULL),
('Hi-Way Inn', 117, '2019-07-28', 312, NULL),
('Hi-Way Inn', 117, '2019-07-29', 193, NULL),
('Hi-Way Inn', 117, '2019-07-30', 394, NULL),
('Hi-Way Inn', 117, '2019-07-31', 116, NULL),
('Hi-Way Inn', 117, '2019-08-01', 252, NULL),
('Hi-Way Inn', 117, '2019-08-02', 263, NULL),
('Hi-Way Inn', 117, '2019-08-03', 182, NULL),
('Hi-Way Inn', 117, '2019-08-04', 375, NULL),
('Hi-Way Inn', 117, '2019-08-05', 215, NULL),
('Hi-Way Inn', 117, '2019-08-06', 278, NULL),
('Hi-Way Inn', 117, '2019-08-07', 142, NULL),
('Hi-Way Inn', 117, '2019-08-08', 265, NULL),
('Hi-Way Inn', 117, '2019-08-09', 273, NULL),
('Hi-Way Inn', 117, '2019-08-10', 254, NULL),
('Hi-Way Inn', 117, '2019-08-11', 267, NULL),
('Hi-Way Inn', 117, '2019-08-12', 164, NULL),
('Hi-Way Inn', 117, '2019-08-13', 168, NULL),
('Hi-Way Inn', 117, '2019-08-14', 356, NULL),
('Hi-Way Inn', 117, '2019-08-15', 244, NULL),
('Hi-Way Inn', 117, '2019-08-16', 395, NULL),
('Hi-Way Inn', 117, '2019-08-17', 172, NULL),
('Hi-Way Inn', 117, '2019-08-18', 236, NULL),
('Hi-Way Inn', 117, '2019-08-19', 205, NULL),
('Hi-Way Inn', 117, '2019-08-20', 217, NULL),
('Hi-Way Inn', 117, '2019-08-21', 272, NULL),
('Hi-Way Inn', 117, '2019-08-22', 125, NULL),
('Hi-Way Inn', 117, '2019-08-23', 142, NULL),
('Hi-Way Inn', 117, '2019-08-24', 354, NULL),
('Hi-Way Inn', 117, '2019-08-25', 399, NULL),
('Hi-Way Inn', 117, '2019-08-26', 363, NULL),
('Hi-Way Inn', 117, '2019-08-27', 297, NULL),
('Hi-Way Inn', 117, '2019-08-28', 177, NULL),
('Hi-Way Inn', 117, '2019-08-29', 358, NULL),
('Hi-Way Inn', 117, '2019-08-30', 203, NULL),
('Hi-Way Inn', 117, '2019-08-31', 344, NULL),
('Hi-Way Inn', 117, '2019-09-01', 372, NULL),
('Hi-Way Inn', 117, '2019-09-02', 311, NULL),
('Hi-Way Inn', 117, '2019-09-03', 166, NULL),
('Hi-Way Inn', 117, '2019-09-04', 151, NULL),
('Hi-Way Inn', 117, '2019-09-05', 143, NULL),
('Hi-Way Inn', 117, '2019-09-06', 322, NULL),
('Hi-Way Inn', 117, '2019-09-07', 355, NULL),
('Hi-Way Inn', 117, '2019-09-08', 235, NULL),
('Hi-Way Inn', 117, '2019-09-09', 328, NULL),
('Hi-Way Inn', 117, '2019-09-10', 141, NULL),
('Hi-Way Inn', 117, '2019-09-11', 383, NULL),
('Hi-Way Inn', 117, '2019-09-12', 163, NULL),
('Hi-Way Inn', 117, '2019-09-13', 190, NULL),
('Hi-Way Inn', 117, '2019-09-14', 255, NULL),
('Hi-Way Inn', 117, '2019-09-15', 274, NULL),
('Hi-Way Inn', 117, '2019-09-16', 158, NULL),
('Hi-Way Inn', 117, '2019-09-17', 354, NULL),
('Hi-Way Inn', 117, '2019-09-18', 284, NULL),
('Hi-Way Inn', 117, '2019-09-19', 158, NULL),
('Hi-Way Inn', 117, '2019-09-20', 246, NULL),
('Hi-Way Inn', 117, '2019-09-21', 327, NULL),
('Hi-Way Inn', 117, '2019-09-22', 303, NULL),
('Hi-Way Inn', 117, '2019-09-23', 317, NULL),
('Hi-Way Inn', 117, '2019-09-24', 388, NULL),
('Hi-Way Inn', 117, '2019-09-25', 379, NULL),
('Hi-Way Inn', 117, '2019-09-26', 235, NULL),
('Hi-Way Inn', 117, '2019-09-27', 358, NULL),
('Hi-Way Inn', 117, '2019-09-28', 190, NULL),
('Hi-Way Inn', 117, '2019-09-29', 257, NULL),
('Hi-Way Inn', 117, '2019-09-30', 168, NULL),
('Hi-Way Inn', 117, '2019-10-01', 348, NULL),
('Hi-Way Inn', 117, '2019-10-02', 285, NULL),
('Hi-Way Inn', 117, '2019-10-03', 186, NULL),
('Hi-Way Inn', 117, '2019-10-04', 299, NULL),
('Hi-Way Inn', 117, '2019-10-05', 232, NULL),
('Hi-Way Inn', 117, '2019-10-06', 110, NULL),
('Hi-Way Inn', 117, '2019-10-07', 291, NULL),
('Hi-Way Inn', 117, '2019-10-08', 131, NULL),
('Hi-Way Inn', 117, '2019-10-09', 180, NULL),
('Hi-Way Inn', 117, '2019-10-10', 145, NULL),
('Hi-Way Inn', 117, '2019-10-11', 304, NULL),
('Hi-Way Inn', 117, '2019-10-12', 361, NULL),
('Hi-Way Inn', 117, '2019-10-13', 395, NULL),
('Hi-Way Inn', 117, '2019-10-14', 150, NULL),
('Hi-Way Inn', 117, '2019-10-15', 381, NULL),
('Hi-Way Inn', 117, '2019-10-16', 100, NULL),
('Hi-Way Inn', 117, '2019-10-17', 223, NULL),
('Hi-Way Inn', 117, '2019-10-18', 368, NULL),
('Hi-Way Inn', 117, '2019-10-19', 114, NULL),
('Hi-Way Inn', 117, '2019-10-20', 123, NULL),
('Hi-Way Inn', 117, '2019-10-21', 246, NULL),
('Hi-Way Inn', 117, '2019-10-22', 337, NULL),
('Hi-Way Inn', 117, '2019-10-23', 389, NULL),
('Hi-Way Inn', 117, '2019-10-24', 251, NULL),
('Hi-Way Inn', 117, '2019-10-25', 337, NULL),
('Hi-Way Inn', 117, '2019-10-26', 398, NULL),
('Hi-Way Inn', 117, '2019-10-27', 267, NULL),
('Hi-Way Inn', 117, '2019-10-28', 162, NULL),
('Hi-Way Inn', 117, '2019-10-29', 207, NULL),
('Hi-Way Inn', 117, '2019-10-30', 159, NULL),
('Hi-Way Inn', 117, '2019-10-31', 103, NULL),
('Hi-Way Inn', 117, '2019-11-01', 288, NULL),
('Hi-Way Inn', 117, '2019-11-02', 128, NULL),
('Hi-Way Inn', 117, '2019-11-03', 207, NULL),
('Hi-Way Inn', 117, '2019-11-04', 231, NULL),
('Hi-Way Inn', 117, '2019-11-05', 363, NULL),
('Hi-Way Inn', 117, '2019-11-06', 296, NULL),
('Hi-Way Inn', 117, '2019-11-07', 206, NULL),
('Hi-Way Inn', 117, '2019-11-08', 107, NULL),
('Hi-Way Inn', 117, '2019-11-09', 109, NULL),
('Hi-Way Inn', 117, '2019-11-10', 379, NULL),
('Hi-Way Inn', 117, '2019-11-11', 132, NULL),
('Hi-Way Inn', 117, '2019-11-12', 273, NULL),
('Hi-Way Inn', 117, '2019-11-13', 277, NULL),
('Hi-Way Inn', 117, '2019-11-14', 232, NULL),
('Hi-Way Inn', 117, '2019-11-15', 383, NULL),
('Hi-Way Inn', 117, '2019-11-16', 178, NULL),
('Hi-Way Inn', 117, '2019-11-17', 234, NULL),
('Hi-Way Inn', 117, '2019-11-18', 156, NULL),
('Hi-Way Inn', 117, '2019-11-19', 171, NULL),
('Hi-Way Inn', 117, '2019-11-20', 334, NULL),
('Hi-Way Inn', 117, '2019-11-21', 308, NULL),
('Hi-Way Inn', 117, '2019-11-22', 275, NULL),
('Hi-Way Inn', 117, '2019-11-23', 148, NULL),
('Hi-Way Inn', 117, '2019-11-24', 326, NULL),
('Hi-Way Inn', 117, '2019-11-25', 118, NULL),
('Hi-Way Inn', 117, '2019-11-26', 336, NULL),
('Hi-Way Inn', 117, '2019-11-27', 186, NULL),
('Hi-Way Inn', 117, '2019-11-28', 136, NULL),
('Hi-Way Inn', 117, '2019-11-29', 376, NULL),
('Hi-Way Inn', 117, '2019-11-30', 134, NULL),
('Hi-Way Inn', 117, '2019-12-01', 151, NULL),
('Hi-Way Inn', 117, '2019-12-02', 271, NULL),
('Hi-Way Inn', 117, '2019-12-03', 389, NULL),
('Hi-Way Inn', 117, '2019-12-04', 308, NULL),
('Hi-Way Inn', 117, '2019-12-05', 371, NULL),
('Hi-Way Inn', 117, '2019-12-06', 115, NULL),
('Hi-Way Inn', 117, '2019-12-07', 212, NULL),
('Hi-Way Inn', 117, '2019-12-08', 399, NULL),
('Hi-Way Inn', 117, '2019-12-09', 243, NULL),
('Hi-Way Inn', 117, '2019-12-10', 207, NULL),
('Hi-Way Inn', 117, '2019-12-11', 392, NULL),
('Hi-Way Inn', 117, '2019-12-12', 241, NULL),
('Hi-Way Inn', 117, '2019-12-13', 359, NULL),
('Hi-Way Inn', 117, '2019-12-14', 328, NULL),
('Hi-Way Inn', 117, '2019-12-15', 366, NULL),
('Hi-Way Inn', 117, '2019-12-16', 217, NULL),
('Hi-Way Inn', 117, '2019-12-17', 349, NULL),
('Hi-Way Inn', 117, '2019-12-18', 344, NULL),
('Hi-Way Inn', 117, '2019-12-19', 336, NULL),
('Hi-Way Inn', 117, '2019-12-20', 365, NULL),
('Hi-Way Inn', 117, '2019-12-21', 328, NULL),
('Hi-Way Inn', 117, '2019-12-22', 229, NULL),
('Hi-Way Inn', 117, '2019-12-23', 350, NULL),
('Hi-Way Inn', 117, '2019-12-24', 212, NULL),
('Hi-Way Inn', 117, '2019-12-25', 224, NULL),
('Hi-Way Inn', 117, '2019-12-26', 193, NULL),
('Hi-Way Inn', 117, '2019-12-27', 290, NULL),
('Hi-Way Inn', 117, '2019-12-28', 314, NULL),
('Hi-Way Inn', 117, '2019-12-29', 331, NULL),
('Hi-Way Inn', 117, '2019-12-30', 248, NULL),
('Hi-Way Inn', 117, '2019-12-31', 295, NULL),
('Hi-Way Inn', 117, '2020-01-01', 144, NULL),
('Hi-Way Inn', 117, '2020-01-02', 204, NULL),
('Hi-Way Inn', 117, '2020-01-03', 121, NULL),
('Hi-Way Inn', 117, '2020-01-04', 332, NULL),
('Hi-Way Inn', 117, '2020-01-05', 131, NULL),
('Hi-Way Inn', 117, '2020-01-06', 338, NULL),
('Hi-Way Inn', 117, '2020-01-07', 250, NULL),
('Hi-Way Inn', 117, '2020-01-08', 315, NULL),
('Hi-Way Inn', 117, '2020-01-09', 396, NULL),
('Hi-Way Inn', 117, '2020-01-10', 225, NULL),
('Hi-Way Inn', 117, '2020-01-11', 179, NULL),
('Hi-Way Inn', 117, '2020-01-12', 177, NULL),
('Hi-Way Inn', 117, '2020-01-13', 111, NULL),
('Hi-Way Inn', 117, '2020-01-14', 185, NULL),
('Hi-Way Inn', 117, '2020-01-15', 219, NULL),
('Hi-Way Inn', 117, '2020-01-16', 138, NULL),
('Hi-Way Inn', 117, '2020-01-17', 295, NULL),
('Hi-Way Inn', 117, '2020-01-18', 351, NULL),
('Hi-Way Inn', 117, '2020-01-19', 362, NULL),
('Hi-Way Inn', 117, '2020-01-20', 195, NULL),
('Hi-Way Inn', 117, '2020-01-21', 376, NULL),
('Hi-Way Inn', 117, '2020-01-22', 355, NULL),
('Hi-Way Inn', 117, '2020-01-23', 215, NULL),
('Hi-Way Inn', 117, '2020-01-24', 336, NULL),
('Hi-Way Inn', 117, '2020-01-25', 253, NULL),
('Hi-Way Inn', 117, '2020-01-26', 103, NULL),
('Hi-Way Inn', 117, '2020-01-27', 137, NULL),
('Hi-Way Inn', 117, '2020-01-28', 335, NULL),
('Hi-Way Inn', 117, '2020-01-29', 194, NULL),
('Hi-Way Inn', 117, '2020-01-30', 173, NULL),
('Hi-Way Inn', 117, '2020-01-31', 347, NULL),
('Hi-Way Inn', 117, '2020-02-01', 180, NULL),
('Hi-Way Inn', 117, '2020-02-02', 355, NULL),
('Hi-Way Inn', 117, '2020-02-03', 251, NULL),
('Hi-Way Inn', 117, '2020-02-04', 399, NULL),
('Hi-Way Inn', 149, '2019-01-01', 197, NULL),
('Hi-Way Inn', 149, '2019-01-02', 216, NULL),
('Hi-Way Inn', 149, '2019-01-03', 109, NULL),
('Hi-Way Inn', 149, '2019-01-04', 383, NULL),
('Hi-Way Inn', 149, '2019-01-05', 308, NULL),
('Hi-Way Inn', 149, '2019-01-06', 196, NULL),
('Hi-Way Inn', 149, '2019-01-07', 371, NULL),
('Hi-Way Inn', 149, '2019-01-08', 181, NULL),
('Hi-Way Inn', 149, '2019-01-09', 364, NULL),
('Hi-Way Inn', 149, '2019-01-10', 158, NULL),
('Hi-Way Inn', 149, '2019-01-11', 106, NULL),
('Hi-Way Inn', 149, '2019-01-12', 345, NULL),
('Hi-Way Inn', 149, '2019-01-13', 337, NULL),
('Hi-Way Inn', 149, '2019-01-14', 276, NULL),
('Hi-Way Inn', 149, '2019-01-15', 293, NULL),
('Hi-Way Inn', 149, '2019-01-16', 303, NULL),
('Hi-Way Inn', 149, '2019-01-17', 349, NULL),
('Hi-Way Inn', 149, '2019-01-18', 380, NULL),
('Hi-Way Inn', 149, '2019-01-19', 299, NULL),
('Hi-Way Inn', 149, '2019-01-20', 274, NULL),
('Hi-Way Inn', 149, '2019-01-21', 243, NULL),
('Hi-Way Inn', 149, '2019-01-22', 223, NULL),
('Hi-Way Inn', 149, '2019-01-23', 275, NULL),
('Hi-Way Inn', 149, '2019-01-24', 281, NULL),
('Hi-Way Inn', 149, '2019-01-25', 297, NULL),
('Hi-Way Inn', 149, '2019-01-26', 399, NULL),
('Hi-Way Inn', 149, '2019-01-27', 381, NULL),
('Hi-Way Inn', 149, '2019-01-28', 129, NULL),
('Hi-Way Inn', 149, '2019-01-29', 360, NULL),
('Hi-Way Inn', 149, '2019-01-30', 333, NULL),
('Hi-Way Inn', 149, '2019-01-31', 101, NULL),
('Hi-Way Inn', 149, '2019-02-01', 337, NULL),
('Hi-Way Inn', 149, '2019-02-02', 271, NULL),
('Hi-Way Inn', 149, '2019-02-03', 318, NULL),
('Hi-Way Inn', 149, '2019-02-04', 263, NULL),
('Hi-Way Inn', 149, '2019-02-05', 161, NULL),
('Hi-Way Inn', 149, '2019-02-06', 366, NULL),
('Hi-Way Inn', 149, '2019-02-07', 172, NULL),
('Hi-Way Inn', 149, '2019-02-08', 167, NULL),
('Hi-Way Inn', 149, '2019-02-09', 263, NULL),
('Hi-Way Inn', 149, '2019-02-10', 316, NULL),
('Hi-Way Inn', 149, '2019-02-11', 365, NULL),
('Hi-Way Inn', 149, '2019-02-12', 177, NULL),
('Hi-Way Inn', 149, '2019-02-13', 305, NULL),
('Hi-Way Inn', 149, '2019-02-14', 238, NULL),
('Hi-Way Inn', 149, '2019-02-15', 199, NULL),
('Hi-Way Inn', 149, '2019-02-16', 393, NULL),
('Hi-Way Inn', 149, '2019-02-17', 241, NULL),
('Hi-Way Inn', 149, '2019-02-18', 251, NULL),
('Hi-Way Inn', 149, '2019-02-19', 117, NULL),
('Hi-Way Inn', 149, '2019-02-20', 323, NULL),
('Hi-Way Inn', 149, '2019-02-21', 299, NULL),
('Hi-Way Inn', 149, '2019-02-22', 162, NULL),
('Hi-Way Inn', 149, '2019-02-23', 266, NULL),
('Hi-Way Inn', 149, '2019-02-24', 351, NULL),
('Hi-Way Inn', 149, '2019-02-25', 298, NULL),
('Hi-Way Inn', 149, '2019-02-26', 275, NULL),
('Hi-Way Inn', 149, '2019-02-27', 101, NULL),
('Hi-Way Inn', 149, '2019-02-28', 152, NULL),
('Hi-Way Inn', 149, '2019-03-01', 248, NULL),
('Hi-Way Inn', 149, '2019-03-02', 235, NULL),
('Hi-Way Inn', 149, '2019-03-03', 256, NULL),
('Hi-Way Inn', 149, '2019-03-04', 247, NULL),
('Hi-Way Inn', 149, '2019-03-05', 126, NULL),
('Hi-Way Inn', 149, '2019-03-06', 372, NULL),
('Hi-Way Inn', 149, '2019-03-07', 120, NULL),
('Hi-Way Inn', 149, '2019-03-08', 217, NULL),
('Hi-Way Inn', 149, '2019-03-09', 366, NULL),
('Hi-Way Inn', 149, '2019-03-10', 256, NULL),
('Hi-Way Inn', 149, '2019-03-11', 228, NULL),
('Hi-Way Inn', 149, '2019-03-12', 202, NULL),
('Hi-Way Inn', 149, '2019-03-13', 138, NULL),
('Hi-Way Inn', 149, '2019-03-14', 299, NULL),
('Hi-Way Inn', 149, '2019-03-15', 155, NULL),
('Hi-Way Inn', 149, '2019-03-16', 128, NULL),
('Hi-Way Inn', 149, '2019-03-17', 225, NULL),
('Hi-Way Inn', 149, '2019-03-18', 104, NULL),
('Hi-Way Inn', 149, '2019-03-19', 168, NULL),
('Hi-Way Inn', 149, '2019-03-20', 191, NULL),
('Hi-Way Inn', 149, '2019-03-21', 161, NULL),
('Hi-Way Inn', 149, '2019-03-22', 276, NULL),
('Hi-Way Inn', 149, '2019-03-23', 103, NULL),
('Hi-Way Inn', 149, '2019-03-24', 157, NULL),
('Hi-Way Inn', 149, '2019-03-25', 368, NULL),
('Hi-Way Inn', 149, '2019-03-26', 115, NULL),
('Hi-Way Inn', 149, '2019-03-27', 369, NULL),
('Hi-Way Inn', 149, '2019-03-28', 199, NULL),
('Hi-Way Inn', 149, '2019-03-29', 308, NULL),
('Hi-Way Inn', 149, '2019-03-30', 270, NULL),
('Hi-Way Inn', 149, '2019-03-31', 178, NULL),
('Hi-Way Inn', 149, '2019-04-01', 227, NULL),
('Hi-Way Inn', 149, '2019-04-02', 337, NULL),
('Hi-Way Inn', 149, '2019-04-03', 379, NULL),
('Hi-Way Inn', 149, '2019-04-04', 180, NULL),
('Hi-Way Inn', 149, '2019-04-05', 150, NULL),
('Hi-Way Inn', 149, '2019-04-06', 232, NULL),
('Hi-Way Inn', 149, '2019-04-07', 198, NULL),
('Hi-Way Inn', 149, '2019-04-08', 186, NULL),
('Hi-Way Inn', 149, '2019-04-09', 371, NULL),
('Hi-Way Inn', 149, '2019-04-10', 347, NULL),
('Hi-Way Inn', 149, '2019-04-11', 321, NULL),
('Hi-Way Inn', 149, '2019-04-12', 326, NULL),
('Hi-Way Inn', 149, '2019-04-13', 399, NULL),
('Hi-Way Inn', 149, '2019-04-14', 177, NULL),
('Hi-Way Inn', 149, '2019-04-15', 248, NULL),
('Hi-Way Inn', 149, '2019-04-16', 336, NULL),
('Hi-Way Inn', 149, '2019-04-17', 231, NULL),
('Hi-Way Inn', 149, '2019-04-18', 369, NULL),
('Hi-Way Inn', 149, '2019-04-19', 188, NULL),
('Hi-Way Inn', 149, '2019-04-20', 280, NULL),
('Hi-Way Inn', 149, '2019-04-21', 111, NULL),
('Hi-Way Inn', 149, '2019-04-22', 178, NULL),
('Hi-Way Inn', 149, '2019-04-23', 395, NULL),
('Hi-Way Inn', 149, '2019-04-24', 155, NULL),
('Hi-Way Inn', 149, '2019-04-25', 341, NULL),
('Hi-Way Inn', 149, '2019-04-26', 387, NULL),
('Hi-Way Inn', 149, '2019-04-27', 336, NULL),
('Hi-Way Inn', 149, '2019-04-28', 255, NULL),
('Hi-Way Inn', 149, '2019-04-29', 310, NULL),
('Hi-Way Inn', 149, '2019-04-30', 263, NULL),
('Hi-Way Inn', 149, '2019-05-01', 238, NULL),
('Hi-Way Inn', 149, '2019-05-02', 230, NULL),
('Hi-Way Inn', 149, '2019-05-03', 214, NULL),
('Hi-Way Inn', 149, '2019-05-04', 385, NULL),
('Hi-Way Inn', 149, '2019-05-05', 296, NULL),
('Hi-Way Inn', 149, '2019-05-06', 312, NULL),
('Hi-Way Inn', 149, '2019-05-07', 382, NULL),
('Hi-Way Inn', 149, '2019-05-08', 123, NULL),
('Hi-Way Inn', 149, '2019-05-09', 182, NULL),
('Hi-Way Inn', 149, '2019-05-10', 180, NULL),
('Hi-Way Inn', 149, '2019-05-11', 248, NULL),
('Hi-Way Inn', 149, '2019-05-12', 299, NULL),
('Hi-Way Inn', 149, '2019-05-13', 131, NULL),
('Hi-Way Inn', 149, '2019-05-14', 252, NULL),
('Hi-Way Inn', 149, '2019-05-15', 252, NULL),
('Hi-Way Inn', 149, '2019-05-16', 286, NULL),
('Hi-Way Inn', 149, '2019-05-17', 113, NULL),
('Hi-Way Inn', 149, '2019-05-18', 336, NULL),
('Hi-Way Inn', 149, '2019-05-19', 320, NULL),
('Hi-Way Inn', 149, '2019-05-20', 228, NULL),
('Hi-Way Inn', 149, '2019-05-21', 362, NULL),
('Hi-Way Inn', 149, '2019-05-22', 250, NULL),
('Hi-Way Inn', 149, '2019-05-23', 151, NULL),
('Hi-Way Inn', 149, '2019-05-24', 144, NULL),
('Hi-Way Inn', 149, '2019-05-25', 275, NULL),
('Hi-Way Inn', 149, '2019-05-26', 309, NULL),
('Hi-Way Inn', 149, '2019-05-27', 184, NULL),
('Hi-Way Inn', 149, '2019-05-28', 290, NULL),
('Hi-Way Inn', 149, '2019-05-29', 332, NULL),
('Hi-Way Inn', 149, '2019-05-30', 110, NULL),
('Hi-Way Inn', 149, '2019-05-31', 234, NULL),
('Hi-Way Inn', 149, '2019-06-01', 361, NULL),
('Hi-Way Inn', 149, '2019-06-02', 111, NULL),
('Hi-Way Inn', 149, '2019-06-03', 264, NULL),
('Hi-Way Inn', 149, '2019-06-04', 237, NULL),
('Hi-Way Inn', 149, '2019-06-05', 204, NULL),
('Hi-Way Inn', 149, '2019-06-06', 310, NULL),
('Hi-Way Inn', 149, '2019-06-07', 354, NULL),
('Hi-Way Inn', 149, '2019-06-08', 261, NULL),
('Hi-Way Inn', 149, '2019-06-09', 188, NULL),
('Hi-Way Inn', 149, '2019-06-10', 339, NULL),
('Hi-Way Inn', 149, '2019-06-11', 276, NULL),
('Hi-Way Inn', 149, '2019-06-12', 309, NULL),
('Hi-Way Inn', 149, '2019-06-13', 325, NULL),
('Hi-Way Inn', 149, '2019-06-14', 390, NULL),
('Hi-Way Inn', 149, '2019-06-15', 146, NULL),
('Hi-Way Inn', 149, '2019-06-16', 272, NULL),
('Hi-Way Inn', 149, '2019-06-17', 303, NULL),
('Hi-Way Inn', 149, '2019-06-18', 217, NULL),
('Hi-Way Inn', 149, '2019-06-19', 228, NULL),
('Hi-Way Inn', 149, '2019-06-20', 322, NULL),
('Hi-Way Inn', 149, '2019-06-21', 393, NULL),
('Hi-Way Inn', 149, '2019-06-22', 130, NULL),
('Hi-Way Inn', 149, '2019-06-23', 243, NULL),
('Hi-Way Inn', 149, '2019-06-24', 161, NULL),
('Hi-Way Inn', 149, '2019-06-25', 345, NULL),
('Hi-Way Inn', 149, '2019-06-26', 345, NULL),
('Hi-Way Inn', 149, '2019-06-27', 236, NULL),
('Hi-Way Inn', 149, '2019-06-28', 362, NULL),
('Hi-Way Inn', 149, '2019-06-29', 166, NULL),
('Hi-Way Inn', 149, '2019-06-30', 110, NULL),
('Hi-Way Inn', 149, '2019-07-01', 165, NULL),
('Hi-Way Inn', 149, '2019-07-02', 196, NULL),
('Hi-Way Inn', 149, '2019-07-03', 247, NULL),
('Hi-Way Inn', 149, '2019-07-04', 251, NULL),
('Hi-Way Inn', 149, '2019-07-05', 195, NULL),
('Hi-Way Inn', 149, '2019-07-06', 279, NULL),
('Hi-Way Inn', 149, '2019-07-07', 392, NULL),
('Hi-Way Inn', 149, '2019-07-08', 382, NULL),
('Hi-Way Inn', 149, '2019-07-09', 125, NULL),
('Hi-Way Inn', 149, '2019-07-10', 265, NULL),
('Hi-Way Inn', 149, '2019-07-11', 136, NULL),
('Hi-Way Inn', 149, '2019-07-12', 355, NULL),
('Hi-Way Inn', 149, '2019-07-13', 133, NULL),
('Hi-Way Inn', 149, '2019-07-14', 181, NULL),
('Hi-Way Inn', 149, '2019-07-15', 219, NULL),
('Hi-Way Inn', 149, '2019-07-16', 124, NULL),
('Hi-Way Inn', 149, '2019-07-17', 292, NULL),
('Hi-Way Inn', 149, '2019-07-18', 154, NULL),
('Hi-Way Inn', 149, '2019-07-19', 231, NULL),
('Hi-Way Inn', 149, '2019-07-20', 109, NULL),
('Hi-Way Inn', 149, '2019-07-21', 342, NULL),
('Hi-Way Inn', 149, '2019-07-22', 290, NULL),
('Hi-Way Inn', 149, '2019-07-23', 188, NULL),
('Hi-Way Inn', 149, '2019-07-24', 122, NULL),
('Hi-Way Inn', 149, '2019-07-25', 154, NULL),
('Hi-Way Inn', 149, '2019-07-26', 323, NULL),
('Hi-Way Inn', 149, '2019-07-27', 125, NULL),
('Hi-Way Inn', 149, '2019-07-28', 314, NULL),
('Hi-Way Inn', 149, '2019-07-29', 337, NULL),
('Hi-Way Inn', 149, '2019-07-30', 241, NULL),
('Hi-Way Inn', 149, '2019-07-31', 313, NULL),
('Hi-Way Inn', 149, '2019-08-01', 296, NULL),
('Hi-Way Inn', 149, '2019-08-02', 154, NULL),
('Hi-Way Inn', 149, '2019-08-03', 314, NULL),
('Hi-Way Inn', 149, '2019-08-04', 214, NULL),
('Hi-Way Inn', 149, '2019-08-05', 359, NULL),
('Hi-Way Inn', 149, '2019-08-06', 361, NULL),
('Hi-Way Inn', 149, '2019-08-07', 156, NULL),
('Hi-Way Inn', 149, '2019-08-08', 196, NULL),
('Hi-Way Inn', 149, '2019-08-09', 261, NULL),
('Hi-Way Inn', 149, '2019-08-10', 238, NULL),
('Hi-Way Inn', 149, '2019-08-11', 344, NULL),
('Hi-Way Inn', 149, '2019-08-12', 306, NULL),
('Hi-Way Inn', 149, '2019-08-13', 243, NULL),
('Hi-Way Inn', 149, '2019-08-14', 217, NULL),
('Hi-Way Inn', 149, '2019-08-15', 343, NULL),
('Hi-Way Inn', 149, '2019-08-16', 155, NULL),
('Hi-Way Inn', 149, '2019-08-17', 253, NULL),
('Hi-Way Inn', 149, '2019-08-18', 377, NULL),
('Hi-Way Inn', 149, '2019-08-19', 197, NULL),
('Hi-Way Inn', 149, '2019-08-20', 378, NULL),
('Hi-Way Inn', 149, '2019-08-21', 394, NULL),
('Hi-Way Inn', 149, '2019-08-22', 296, NULL),
('Hi-Way Inn', 149, '2019-08-23', 223, NULL),
('Hi-Way Inn', 149, '2019-08-24', 317, NULL),
('Hi-Way Inn', 149, '2019-08-25', 318, NULL),
('Hi-Way Inn', 149, '2019-08-26', 184, NULL),
('Hi-Way Inn', 149, '2019-08-27', 328, NULL),
('Hi-Way Inn', 149, '2019-08-28', 355, NULL),
('Hi-Way Inn', 149, '2019-08-29', 314, NULL),
('Hi-Way Inn', 149, '2019-08-30', 244, NULL),
('Hi-Way Inn', 149, '2019-08-31', 296, NULL),
('Hi-Way Inn', 149, '2019-09-01', 239, NULL),
('Hi-Way Inn', 149, '2019-09-02', 270, NULL),
('Hi-Way Inn', 149, '2019-09-03', 251, NULL),
('Hi-Way Inn', 149, '2019-09-04', 376, NULL),
('Hi-Way Inn', 149, '2019-09-05', 362, NULL),
('Hi-Way Inn', 149, '2019-09-06', 242, NULL),
('Hi-Way Inn', 149, '2019-09-07', 246, NULL),
('Hi-Way Inn', 149, '2019-09-08', 132, NULL),
('Hi-Way Inn', 149, '2019-09-09', 349, NULL),
('Hi-Way Inn', 149, '2019-09-10', 279, NULL),
('Hi-Way Inn', 149, '2019-09-11', 354, NULL),
('Hi-Way Inn', 149, '2019-09-12', 362, NULL),
('Hi-Way Inn', 149, '2019-09-13', 275, NULL),
('Hi-Way Inn', 149, '2019-09-14', 286, NULL),
('Hi-Way Inn', 149, '2019-09-15', 369, NULL),
('Hi-Way Inn', 149, '2019-09-16', 208, NULL),
('Hi-Way Inn', 149, '2019-09-17', 238, NULL),
('Hi-Way Inn', 149, '2019-09-18', 103, NULL),
('Hi-Way Inn', 149, '2019-09-19', 284, NULL),
('Hi-Way Inn', 149, '2019-09-20', 312, NULL),
('Hi-Way Inn', 149, '2019-09-21', 275, NULL),
('Hi-Way Inn', 149, '2019-09-22', 189, NULL),
('Hi-Way Inn', 149, '2019-09-23', 330, NULL),
('Hi-Way Inn', 149, '2019-09-24', 142, NULL),
('Hi-Way Inn', 149, '2019-09-25', 239, NULL),
('Hi-Way Inn', 149, '2019-09-26', 248, NULL),
('Hi-Way Inn', 149, '2019-09-27', 287, NULL),
('Hi-Way Inn', 149, '2019-09-28', 124, NULL),
('Hi-Way Inn', 149, '2019-09-29', 137, NULL),
('Hi-Way Inn', 149, '2019-09-30', 139, NULL),
('Hi-Way Inn', 149, '2019-10-01', 170, NULL),
('Hi-Way Inn', 149, '2019-10-02', 310, NULL),
('Hi-Way Inn', 149, '2019-10-03', 324, NULL),
('Hi-Way Inn', 149, '2019-10-04', 208, NULL),
('Hi-Way Inn', 149, '2019-10-05', 372, NULL),
('Hi-Way Inn', 149, '2019-10-06', 338, NULL),
('Hi-Way Inn', 149, '2019-10-07', 360, NULL),
('Hi-Way Inn', 149, '2019-10-08', 160, NULL),
('Hi-Way Inn', 149, '2019-10-09', 137, NULL),
('Hi-Way Inn', 149, '2019-10-10', 147, NULL),
('Hi-Way Inn', 149, '2019-10-11', 139, NULL),
('Hi-Way Inn', 149, '2019-10-12', 388, NULL),
('Hi-Way Inn', 149, '2019-10-13', 239, NULL),
('Hi-Way Inn', 149, '2019-10-14', 151, NULL),
('Hi-Way Inn', 149, '2019-10-15', 351, NULL),
('Hi-Way Inn', 149, '2019-10-16', 343, NULL),
('Hi-Way Inn', 149, '2019-10-17', 298, NULL),
('Hi-Way Inn', 149, '2019-10-18', 236, NULL),
('Hi-Way Inn', 149, '2019-10-19', 235, NULL),
('Hi-Way Inn', 149, '2019-10-20', 233, NULL),
('Hi-Way Inn', 149, '2019-10-21', 305, NULL),
('Hi-Way Inn', 149, '2019-10-22', 372, NULL),
('Hi-Way Inn', 149, '2019-10-23', 269, NULL),
('Hi-Way Inn', 149, '2019-10-24', 340, NULL),
('Hi-Way Inn', 149, '2019-10-25', 396, NULL),
('Hi-Way Inn', 149, '2019-10-26', 340, NULL),
('Hi-Way Inn', 149, '2019-10-27', 205, NULL),
('Hi-Way Inn', 149, '2019-10-28', 281, NULL),
('Hi-Way Inn', 149, '2019-10-29', 376, NULL),
('Hi-Way Inn', 149, '2019-10-30', 292, NULL),
('Hi-Way Inn', 149, '2019-10-31', 139, NULL),
('Hi-Way Inn', 149, '2019-11-01', 354, NULL),
('Hi-Way Inn', 149, '2019-11-02', 216, NULL),
('Hi-Way Inn', 149, '2019-11-03', 368, NULL),
('Hi-Way Inn', 149, '2019-11-04', 353, NULL),
('Hi-Way Inn', 149, '2019-11-05', 392, NULL),
('Hi-Way Inn', 149, '2019-11-06', 319, NULL),
('Hi-Way Inn', 149, '2019-11-07', 276, NULL),
('Hi-Way Inn', 149, '2019-11-08', 108, NULL),
('Hi-Way Inn', 149, '2019-11-09', 132, NULL),
('Hi-Way Inn', 149, '2019-11-10', 124, NULL),
('Hi-Way Inn', 149, '2019-11-11', 174, NULL),
('Hi-Way Inn', 149, '2019-11-12', 115, NULL),
('Hi-Way Inn', 149, '2019-11-13', 294, NULL),
('Hi-Way Inn', 149, '2019-11-14', 322, NULL),
('Hi-Way Inn', 149, '2019-11-15', 311, NULL),
('Hi-Way Inn', 149, '2019-11-16', 160, NULL),
('Hi-Way Inn', 149, '2019-11-17', 113, NULL),
('Hi-Way Inn', 149, '2019-11-18', 287, NULL),
('Hi-Way Inn', 149, '2019-11-19', 140, NULL),
('Hi-Way Inn', 149, '2019-11-20', 298, NULL),
('Hi-Way Inn', 149, '2019-11-21', 311, NULL),
('Hi-Way Inn', 149, '2019-11-22', 274, NULL),
('Hi-Way Inn', 149, '2019-11-23', 155, NULL),
('Hi-Way Inn', 149, '2019-11-24', 180, NULL),
('Hi-Way Inn', 149, '2019-11-25', 133, NULL),
('Hi-Way Inn', 149, '2019-11-26', 286, NULL),
('Hi-Way Inn', 149, '2019-11-27', 132, NULL),
('Hi-Way Inn', 149, '2019-11-28', 356, NULL),
('Hi-Way Inn', 149, '2019-11-29', 273, NULL),
('Hi-Way Inn', 149, '2019-11-30', 377, NULL),
('Hi-Way Inn', 149, '2019-12-01', 178, NULL),
('Hi-Way Inn', 149, '2019-12-02', 213, NULL),
('Hi-Way Inn', 149, '2019-12-03', 286, NULL),
('Hi-Way Inn', 149, '2019-12-04', 228, NULL),
('Hi-Way Inn', 149, '2019-12-05', 241, NULL),
('Hi-Way Inn', 149, '2019-12-06', 399, NULL),
('Hi-Way Inn', 149, '2019-12-07', 210, NULL),
('Hi-Way Inn', 149, '2019-12-08', 397, NULL),
('Hi-Way Inn', 149, '2019-12-09', 274, NULL),
('Hi-Way Inn', 149, '2019-12-10', 260, NULL),
('Hi-Way Inn', 149, '2019-12-11', 373, NULL),
('Hi-Way Inn', 149, '2019-12-12', 261, NULL),
('Hi-Way Inn', 149, '2019-12-13', 199, NULL),
('Hi-Way Inn', 149, '2019-12-14', 320, NULL),
('Hi-Way Inn', 149, '2019-12-15', 170, NULL),
('Hi-Way Inn', 149, '2019-12-16', 252, NULL),
('Hi-Way Inn', 149, '2019-12-17', 103, NULL),
('Hi-Way Inn', 149, '2019-12-18', 317, NULL),
('Hi-Way Inn', 149, '2019-12-19', 176, NULL),
('Hi-Way Inn', 149, '2019-12-20', 341, NULL),
('Hi-Way Inn', 149, '2019-12-21', 318, NULL),
('Hi-Way Inn', 149, '2019-12-22', 122, NULL),
('Hi-Way Inn', 149, '2019-12-23', 326, NULL),
('Hi-Way Inn', 149, '2019-12-24', 339, NULL),
('Hi-Way Inn', 149, '2019-12-25', 200, NULL),
('Hi-Way Inn', 149, '2019-12-26', 150, NULL),
('Hi-Way Inn', 149, '2019-12-27', 373, NULL),
('Hi-Way Inn', 149, '2019-12-28', 340, NULL),
('Hi-Way Inn', 149, '2019-12-29', 130, NULL),
('Hi-Way Inn', 149, '2019-12-30', 299, NULL),
('Hi-Way Inn', 149, '2019-12-31', 306, NULL),
('Hi-Way Inn', 149, '2020-01-01', 371, NULL),
('Hi-Way Inn', 149, '2020-01-02', 302, NULL),
('Hi-Way Inn', 149, '2020-01-03', 247, NULL),
('Hi-Way Inn', 149, '2020-01-04', 179, NULL),
('Hi-Way Inn', 149, '2020-01-05', 356, NULL),
('Hi-Way Inn', 149, '2020-01-06', 133, NULL),
('Hi-Way Inn', 149, '2020-01-07', 384, NULL),
('Hi-Way Inn', 149, '2020-01-08', 288, NULL),
('Hi-Way Inn', 149, '2020-01-09', 203, NULL),
('Hi-Way Inn', 149, '2020-01-10', 358, NULL),
('Hi-Way Inn', 149, '2020-01-11', 349, NULL),
('Hi-Way Inn', 149, '2020-01-12', 338, NULL),
('Hi-Way Inn', 149, '2020-01-13', 303, NULL),
('Hi-Way Inn', 149, '2020-01-14', 382, NULL),
('Hi-Way Inn', 149, '2020-01-15', 302, NULL),
('Hi-Way Inn', 149, '2020-01-16', 205, NULL),
('Hi-Way Inn', 149, '2020-01-17', 213, NULL),
('Hi-Way Inn', 149, '2020-01-18', 251, NULL),
('Hi-Way Inn', 149, '2020-01-19', 348, NULL),
('Hi-Way Inn', 149, '2020-01-20', 257, NULL),
('Hi-Way Inn', 149, '2020-01-21', 186, NULL),
('Hi-Way Inn', 149, '2020-01-22', 393, NULL),
('Hi-Way Inn', 149, '2020-01-23', 165, NULL),
('Hi-Way Inn', 149, '2020-01-24', 115, NULL),
('Hi-Way Inn', 149, '2020-01-25', 154, NULL),
('Hi-Way Inn', 149, '2020-01-26', 313, NULL),
('Hi-Way Inn', 149, '2020-01-27', 138, NULL),
('Hi-Way Inn', 149, '2020-01-28', 149, NULL),
('Hi-Way Inn', 149, '2020-01-29', 321, NULL),
('Hi-Way Inn', 149, '2020-01-30', 260, NULL),
('Hi-Way Inn', 149, '2020-01-31', 107, NULL),
('Hi-Way Inn', 149, '2020-02-01', 228, NULL),
('Hi-Way Inn', 149, '2020-02-02', 317, NULL),
('Hi-Way Inn', 149, '2020-02-03', 385, NULL),
('Hi-Way Inn', 149, '2020-02-04', 385, NULL),
('Hi-Way Inn', 165, '2019-01-01', 271, NULL),
('Hi-Way Inn', 165, '2019-01-02', 169, NULL),
('Hi-Way Inn', 165, '2019-01-03', 311, NULL),
('Hi-Way Inn', 165, '2019-01-04', 398, NULL),
('Hi-Way Inn', 165, '2019-01-05', 124, NULL),
('Hi-Way Inn', 165, '2019-01-06', 325, NULL),
('Hi-Way Inn', 165, '2019-01-07', 286, NULL),
('Hi-Way Inn', 165, '2019-01-08', 170, NULL),
('Hi-Way Inn', 165, '2019-01-09', 372, NULL),
('Hi-Way Inn', 165, '2019-01-10', 153, NULL),
('Hi-Way Inn', 165, '2019-01-11', 292, NULL),
('Hi-Way Inn', 165, '2019-01-12', 270, NULL),
('Hi-Way Inn', 165, '2019-01-13', 198, NULL),
('Hi-Way Inn', 165, '2019-01-14', 365, NULL),
('Hi-Way Inn', 165, '2019-01-15', 289, NULL),
('Hi-Way Inn', 165, '2019-01-16', 173, NULL),
('Hi-Way Inn', 165, '2019-01-17', 208, NULL),
('Hi-Way Inn', 165, '2019-01-18', 210, NULL),
('Hi-Way Inn', 165, '2019-01-19', 361, NULL),
('Hi-Way Inn', 165, '2019-01-20', 340, NULL),
('Hi-Way Inn', 165, '2019-01-21', 227, NULL),
('Hi-Way Inn', 165, '2019-01-22', 240, NULL),
('Hi-Way Inn', 165, '2019-01-23', 141, NULL),
('Hi-Way Inn', 165, '2019-01-24', 254, NULL),
('Hi-Way Inn', 165, '2019-01-25', 157, NULL),
('Hi-Way Inn', 165, '2019-01-26', 343, NULL),
('Hi-Way Inn', 165, '2019-01-27', 128, NULL),
('Hi-Way Inn', 165, '2019-01-28', 320, NULL),
('Hi-Way Inn', 165, '2019-01-29', 342, NULL),
('Hi-Way Inn', 165, '2019-01-30', 398, NULL),
('Hi-Way Inn', 165, '2019-01-31', 104, NULL),
('Hi-Way Inn', 165, '2019-02-01', 391, NULL),
('Hi-Way Inn', 165, '2019-02-02', 224, NULL),
('Hi-Way Inn', 165, '2019-02-03', 117, NULL),
('Hi-Way Inn', 165, '2019-02-04', 129, NULL),
('Hi-Way Inn', 165, '2019-02-05', 316, NULL),
('Hi-Way Inn', 165, '2019-02-06', 385, NULL),
('Hi-Way Inn', 165, '2019-02-07', 388, NULL),
('Hi-Way Inn', 165, '2019-02-08', 120, NULL),
('Hi-Way Inn', 165, '2019-02-09', 260, NULL),
('Hi-Way Inn', 165, '2019-02-10', 116, NULL),
('Hi-Way Inn', 165, '2019-02-11', 272, NULL),
('Hi-Way Inn', 165, '2019-02-12', 360, NULL),
('Hi-Way Inn', 165, '2019-02-13', 380, NULL),
('Hi-Way Inn', 165, '2019-02-14', 336, NULL),
('Hi-Way Inn', 165, '2019-02-15', 259, NULL),
('Hi-Way Inn', 165, '2019-02-16', 393, NULL),
('Hi-Way Inn', 165, '2019-02-17', 165, NULL),
('Hi-Way Inn', 165, '2019-02-18', 147, NULL),
('Hi-Way Inn', 165, '2019-02-19', 346, NULL),
('Hi-Way Inn', 165, '2019-02-20', 245, NULL),
('Hi-Way Inn', 165, '2019-02-21', 115, NULL),
('Hi-Way Inn', 165, '2019-02-22', 106, NULL),
('Hi-Way Inn', 165, '2019-02-23', 157, NULL),
('Hi-Way Inn', 165, '2019-02-24', 187, NULL),
('Hi-Way Inn', 165, '2019-02-25', 268, NULL),
('Hi-Way Inn', 165, '2019-02-26', 149, NULL),
('Hi-Way Inn', 165, '2019-02-27', 395, NULL),
('Hi-Way Inn', 165, '2019-02-28', 359, NULL),
('Hi-Way Inn', 165, '2019-03-01', 275, NULL),
('Hi-Way Inn', 165, '2019-03-02', 347, NULL),
('Hi-Way Inn', 165, '2019-03-03', 351, NULL),
('Hi-Way Inn', 165, '2019-03-04', 397, NULL),
('Hi-Way Inn', 165, '2019-03-05', 154, NULL),
('Hi-Way Inn', 165, '2019-03-06', 138, NULL),
('Hi-Way Inn', 165, '2019-03-07', 324, NULL),
('Hi-Way Inn', 165, '2019-03-08', 202, NULL),
('Hi-Way Inn', 165, '2019-03-09', 367, NULL),
('Hi-Way Inn', 165, '2019-03-10', 386, NULL),
('Hi-Way Inn', 165, '2019-03-11', 245, NULL),
('Hi-Way Inn', 165, '2019-03-12', 225, NULL),
('Hi-Way Inn', 165, '2019-03-13', 230, NULL),
('Hi-Way Inn', 165, '2019-03-14', 185, NULL),
('Hi-Way Inn', 165, '2019-03-15', 328, NULL),
('Hi-Way Inn', 165, '2019-03-16', 268, NULL),
('Hi-Way Inn', 165, '2019-03-17', 269, NULL),
('Hi-Way Inn', 165, '2019-03-18', 398, NULL),
('Hi-Way Inn', 165, '2019-03-19', 361, NULL),
('Hi-Way Inn', 165, '2019-03-20', 291, NULL),
('Hi-Way Inn', 165, '2019-03-21', 237, NULL),
('Hi-Way Inn', 165, '2019-03-22', 190, NULL),
('Hi-Way Inn', 165, '2019-03-23', 231, NULL),
('Hi-Way Inn', 165, '2019-03-24', 249, NULL),
('Hi-Way Inn', 165, '2019-03-25', 285, NULL),
('Hi-Way Inn', 165, '2019-03-26', 223, NULL),
('Hi-Way Inn', 165, '2019-03-27', 134, NULL),
('Hi-Way Inn', 165, '2019-03-28', 243, NULL),
('Hi-Way Inn', 165, '2019-03-29', 300, NULL),
('Hi-Way Inn', 165, '2019-03-30', 230, NULL),
('Hi-Way Inn', 165, '2019-03-31', 188, NULL),
('Hi-Way Inn', 165, '2019-04-01', 224, NULL),
('Hi-Way Inn', 165, '2019-04-02', 231, NULL),
('Hi-Way Inn', 165, '2019-04-03', 256, NULL),
('Hi-Way Inn', 165, '2019-04-04', 389, NULL),
('Hi-Way Inn', 165, '2019-04-05', 269, NULL),
('Hi-Way Inn', 165, '2019-04-06', 312, NULL),
('Hi-Way Inn', 165, '2019-04-07', 310, NULL),
('Hi-Way Inn', 165, '2019-04-08', 131, NULL),
('Hi-Way Inn', 165, '2019-04-09', 207, NULL),
('Hi-Way Inn', 165, '2019-04-10', 200, NULL),
('Hi-Way Inn', 165, '2019-04-11', 162, NULL),
('Hi-Way Inn', 165, '2019-04-12', 387, NULL),
('Hi-Way Inn', 165, '2019-04-13', 394, NULL),
('Hi-Way Inn', 165, '2019-04-14', 332, NULL),
('Hi-Way Inn', 165, '2019-04-15', 248, NULL),
('Hi-Way Inn', 165, '2019-04-16', 131, NULL),
('Hi-Way Inn', 165, '2019-04-17', 255, NULL),
('Hi-Way Inn', 165, '2019-04-18', 103, NULL),
('Hi-Way Inn', 165, '2019-04-19', 355, NULL),
('Hi-Way Inn', 165, '2019-04-20', 399, NULL),
('Hi-Way Inn', 165, '2019-04-21', 255, NULL),
('Hi-Way Inn', 165, '2019-04-22', 253, NULL),
('Hi-Way Inn', 165, '2019-04-23', 361, NULL),
('Hi-Way Inn', 165, '2019-04-24', 173, NULL),
('Hi-Way Inn', 165, '2019-04-25', 310, NULL),
('Hi-Way Inn', 165, '2019-04-26', 113, NULL),
('Hi-Way Inn', 165, '2019-04-27', 101, NULL),
('Hi-Way Inn', 165, '2019-04-28', 380, NULL),
('Hi-Way Inn', 165, '2019-04-29', 116, NULL),
('Hi-Way Inn', 165, '2019-04-30', 111, NULL),
('Hi-Way Inn', 165, '2019-05-01', 197, NULL),
('Hi-Way Inn', 165, '2019-05-02', 155, NULL),
('Hi-Way Inn', 165, '2019-05-03', 369, NULL),
('Hi-Way Inn', 165, '2019-05-04', 166, NULL),
('Hi-Way Inn', 165, '2019-05-05', 211, NULL),
('Hi-Way Inn', 165, '2019-05-06', 160, NULL),
('Hi-Way Inn', 165, '2019-05-07', 314, NULL),
('Hi-Way Inn', 165, '2019-05-08', 389, NULL),
('Hi-Way Inn', 165, '2019-05-09', 215, NULL),
('Hi-Way Inn', 165, '2019-05-10', 177, NULL),
('Hi-Way Inn', 165, '2019-05-11', 249, NULL),
('Hi-Way Inn', 165, '2019-05-12', 321, NULL),
('Hi-Way Inn', 165, '2019-05-13', 136, NULL),
('Hi-Way Inn', 165, '2019-05-14', 245, NULL),
('Hi-Way Inn', 165, '2019-05-15', 248, NULL),
('Hi-Way Inn', 165, '2019-05-16', 270, NULL),
('Hi-Way Inn', 165, '2019-05-17', 179, NULL),
('Hi-Way Inn', 165, '2019-05-18', 272, NULL),
('Hi-Way Inn', 165, '2019-05-19', 109, NULL),
('Hi-Way Inn', 165, '2019-05-20', 178, NULL),
('Hi-Way Inn', 165, '2019-05-21', 263, NULL),
('Hi-Way Inn', 165, '2019-05-22', 117, NULL),
('Hi-Way Inn', 165, '2019-05-23', 348, NULL),
('Hi-Way Inn', 165, '2019-05-24', 172, NULL),
('Hi-Way Inn', 165, '2019-05-25', 373, NULL),
('Hi-Way Inn', 165, '2019-05-26', 266, NULL),
('Hi-Way Inn', 165, '2019-05-27', 137, NULL),
('Hi-Way Inn', 165, '2019-05-28', 222, NULL),
('Hi-Way Inn', 165, '2019-05-29', 171, NULL),
('Hi-Way Inn', 165, '2019-05-30', 359, NULL),
('Hi-Way Inn', 165, '2019-05-31', 371, NULL),
('Hi-Way Inn', 165, '2019-06-01', 386, NULL),
('Hi-Way Inn', 165, '2019-06-02', 207, NULL),
('Hi-Way Inn', 165, '2019-06-03', 302, NULL),
('Hi-Way Inn', 165, '2019-06-04', 295, NULL),
('Hi-Way Inn', 165, '2019-06-05', 204, NULL),
('Hi-Way Inn', 165, '2019-06-06', 182, NULL),
('Hi-Way Inn', 165, '2019-06-07', 108, NULL),
('Hi-Way Inn', 165, '2019-06-08', 369, NULL),
('Hi-Way Inn', 165, '2019-06-09', 267, NULL),
('Hi-Way Inn', 165, '2019-06-10', 252, NULL),
('Hi-Way Inn', 165, '2019-06-11', 335, NULL),
('Hi-Way Inn', 165, '2019-06-12', 310, NULL),
('Hi-Way Inn', 165, '2019-06-13', 168, NULL),
('Hi-Way Inn', 165, '2019-06-14', 193, NULL),
('Hi-Way Inn', 165, '2019-06-15', 205, NULL),
('Hi-Way Inn', 165, '2019-06-16', 381, NULL),
('Hi-Way Inn', 165, '2019-06-17', 359, NULL),
('Hi-Way Inn', 165, '2019-06-18', 317, NULL),
('Hi-Way Inn', 165, '2019-06-19', 253, NULL),
('Hi-Way Inn', 165, '2019-06-20', 260, NULL),
('Hi-Way Inn', 165, '2019-06-21', 101, NULL),
('Hi-Way Inn', 165, '2019-06-22', 368, NULL),
('Hi-Way Inn', 165, '2019-06-23', 126, NULL),
('Hi-Way Inn', 165, '2019-06-24', 140, NULL),
('Hi-Way Inn', 165, '2019-06-25', 318, NULL),
('Hi-Way Inn', 165, '2019-06-26', 229, NULL),
('Hi-Way Inn', 165, '2019-06-27', 119, NULL),
('Hi-Way Inn', 165, '2019-06-28', 269, NULL),
('Hi-Way Inn', 165, '2019-06-29', 125, NULL),
('Hi-Way Inn', 165, '2019-06-30', 317, NULL),
('Hi-Way Inn', 165, '2019-07-01', 303, NULL),
('Hi-Way Inn', 165, '2019-07-02', 287, NULL),
('Hi-Way Inn', 165, '2019-07-03', 296, NULL),
('Hi-Way Inn', 165, '2019-07-04', 288, NULL),
('Hi-Way Inn', 165, '2019-07-05', 323, NULL),
('Hi-Way Inn', 165, '2019-07-06', 154, NULL),
('Hi-Way Inn', 165, '2019-07-07', 365, NULL),
('Hi-Way Inn', 165, '2019-07-08', 159, NULL),
('Hi-Way Inn', 165, '2019-07-09', 105, NULL),
('Hi-Way Inn', 165, '2019-07-10', 363, NULL),
('Hi-Way Inn', 165, '2019-07-11', 360, NULL),
('Hi-Way Inn', 165, '2019-07-12', 322, NULL),
('Hi-Way Inn', 165, '2019-07-13', 282, NULL),
('Hi-Way Inn', 165, '2019-07-14', 373, NULL),
('Hi-Way Inn', 165, '2019-07-15', 385, NULL),
('Hi-Way Inn', 165, '2019-07-16', 313, NULL),
('Hi-Way Inn', 165, '2019-07-17', 205, NULL),
('Hi-Way Inn', 165, '2019-07-18', 109, NULL),
('Hi-Way Inn', 165, '2019-07-19', 334, NULL),
('Hi-Way Inn', 165, '2019-07-20', 182, NULL),
('Hi-Way Inn', 165, '2019-07-21', 277, NULL),
('Hi-Way Inn', 165, '2019-07-22', 305, NULL),
('Hi-Way Inn', 165, '2019-07-23', 187, NULL),
('Hi-Way Inn', 165, '2019-07-24', 241, NULL),
('Hi-Way Inn', 165, '2019-07-25', 153, NULL),
('Hi-Way Inn', 165, '2019-07-26', 208, NULL),
('Hi-Way Inn', 165, '2019-07-27', 199, NULL),
('Hi-Way Inn', 165, '2019-07-28', 232, NULL),
('Hi-Way Inn', 165, '2019-07-29', 106, NULL),
('Hi-Way Inn', 165, '2019-07-30', 222, NULL),
('Hi-Way Inn', 165, '2019-07-31', 218, NULL),
('Hi-Way Inn', 165, '2019-08-01', 324, NULL),
('Hi-Way Inn', 165, '2019-08-02', 179, NULL),
('Hi-Way Inn', 165, '2019-08-03', 326, NULL),
('Hi-Way Inn', 165, '2019-08-04', 145, NULL),
('Hi-Way Inn', 165, '2019-08-05', 149, NULL),
('Hi-Way Inn', 165, '2019-08-06', 275, NULL),
('Hi-Way Inn', 165, '2019-08-07', 255, NULL),
('Hi-Way Inn', 165, '2019-08-08', 383, NULL),
('Hi-Way Inn', 165, '2019-08-09', 388, NULL),
('Hi-Way Inn', 165, '2019-08-10', 326, NULL),
('Hi-Way Inn', 165, '2019-08-11', 219, NULL),
('Hi-Way Inn', 165, '2019-08-12', 338, NULL),
('Hi-Way Inn', 165, '2019-08-13', 310, NULL),
('Hi-Way Inn', 165, '2019-08-14', 219, NULL),
('Hi-Way Inn', 165, '2019-08-15', 287, NULL),
('Hi-Way Inn', 165, '2019-08-16', 388, NULL),
('Hi-Way Inn', 165, '2019-08-17', 351, NULL),
('Hi-Way Inn', 165, '2019-08-18', 175, NULL),
('Hi-Way Inn', 165, '2019-08-19', 273, NULL),
('Hi-Way Inn', 165, '2019-08-20', 238, NULL),
('Hi-Way Inn', 165, '2019-08-21', 154, NULL),
('Hi-Way Inn', 165, '2019-08-22', 104, NULL),
('Hi-Way Inn', 165, '2019-08-23', 288, NULL),
('Hi-Way Inn', 165, '2019-08-24', 123, NULL),
('Hi-Way Inn', 165, '2019-08-25', 291, NULL),
('Hi-Way Inn', 165, '2019-08-26', 332, NULL),
('Hi-Way Inn', 165, '2019-08-27', 350, NULL),
('Hi-Way Inn', 165, '2019-08-28', 244, NULL),
('Hi-Way Inn', 165, '2019-08-29', 395, NULL),
('Hi-Way Inn', 165, '2019-08-30', 210, NULL),
('Hi-Way Inn', 165, '2019-08-31', 351, NULL),
('Hi-Way Inn', 165, '2019-09-01', 276, NULL),
('Hi-Way Inn', 165, '2019-09-02', 315, NULL),
('Hi-Way Inn', 165, '2019-09-03', 358, NULL),
('Hi-Way Inn', 165, '2019-09-04', 127, NULL),
('Hi-Way Inn', 165, '2019-09-05', 379, NULL),
('Hi-Way Inn', 165, '2019-09-06', 146, NULL),
('Hi-Way Inn', 165, '2019-09-07', 365, NULL),
('Hi-Way Inn', 165, '2019-09-08', 155, NULL),
('Hi-Way Inn', 165, '2019-09-09', 360, NULL),
('Hi-Way Inn', 165, '2019-09-10', 270, NULL),
('Hi-Way Inn', 165, '2019-09-11', 222, NULL),
('Hi-Way Inn', 165, '2019-09-12', 322, NULL),
('Hi-Way Inn', 165, '2019-09-13', 104, NULL),
('Hi-Way Inn', 165, '2019-09-14', 267, NULL),
('Hi-Way Inn', 165, '2019-09-15', 324, NULL),
('Hi-Way Inn', 165, '2019-09-16', 164, NULL),
('Hi-Way Inn', 165, '2019-09-17', 329, NULL),
('Hi-Way Inn', 165, '2019-09-18', 161, NULL),
('Hi-Way Inn', 165, '2019-09-19', 246, NULL),
('Hi-Way Inn', 165, '2019-09-20', 120, NULL),
('Hi-Way Inn', 165, '2019-09-21', 296, NULL),
('Hi-Way Inn', 165, '2019-09-22', 235, NULL),
('Hi-Way Inn', 165, '2019-09-23', 300, NULL),
('Hi-Way Inn', 165, '2019-09-24', 349, NULL),
('Hi-Way Inn', 165, '2019-09-25', 259, NULL),
('Hi-Way Inn', 165, '2019-09-26', 136, NULL),
('Hi-Way Inn', 165, '2019-09-27', 259, NULL),
('Hi-Way Inn', 165, '2019-09-28', 249, NULL),
('Hi-Way Inn', 165, '2019-09-29', 114, NULL),
('Hi-Way Inn', 165, '2019-09-30', 391, NULL),
('Hi-Way Inn', 165, '2019-10-01', 306, NULL),
('Hi-Way Inn', 165, '2019-10-02', 295, NULL),
('Hi-Way Inn', 165, '2019-10-03', 366, NULL),
('Hi-Way Inn', 165, '2019-10-04', 346, NULL),
('Hi-Way Inn', 165, '2019-10-05', 164, NULL),
('Hi-Way Inn', 165, '2019-10-06', 357, NULL),
('Hi-Way Inn', 165, '2019-10-07', 230, NULL),
('Hi-Way Inn', 165, '2019-10-08', 305, NULL),
('Hi-Way Inn', 165, '2019-10-09', 344, NULL),
('Hi-Way Inn', 165, '2019-10-10', 204, NULL),
('Hi-Way Inn', 165, '2019-10-11', 281, NULL),
('Hi-Way Inn', 165, '2019-10-12', 160, NULL),
('Hi-Way Inn', 165, '2019-10-13', 209, NULL),
('Hi-Way Inn', 165, '2019-10-14', 205, NULL),
('Hi-Way Inn', 165, '2019-10-15', 212, NULL),
('Hi-Way Inn', 165, '2019-10-16', 115, NULL),
('Hi-Way Inn', 165, '2019-10-17', 122, NULL),
('Hi-Way Inn', 165, '2019-10-18', 276, NULL),
('Hi-Way Inn', 165, '2019-10-19', 132, NULL),
('Hi-Way Inn', 165, '2019-10-20', 398, NULL),
('Hi-Way Inn', 165, '2019-10-21', 387, NULL),
('Hi-Way Inn', 165, '2019-10-22', 152, NULL),
('Hi-Way Inn', 165, '2019-10-23', 380, NULL),
('Hi-Way Inn', 165, '2019-10-24', 248, NULL),
('Hi-Way Inn', 165, '2019-10-25', 271, NULL),
('Hi-Way Inn', 165, '2019-10-26', 105, NULL),
('Hi-Way Inn', 165, '2019-10-27', 125, NULL),
('Hi-Way Inn', 165, '2019-10-28', 220, NULL),
('Hi-Way Inn', 165, '2019-10-29', 259, NULL),
('Hi-Way Inn', 165, '2019-10-30', 285, NULL),
('Hi-Way Inn', 165, '2019-10-31', 287, NULL),
('Hi-Way Inn', 165, '2019-11-01', 205, NULL),
('Hi-Way Inn', 165, '2019-11-02', 297, NULL),
('Hi-Way Inn', 165, '2019-11-03', 217, NULL),
('Hi-Way Inn', 165, '2019-11-04', 373, NULL),
('Hi-Way Inn', 165, '2019-11-05', 170, NULL),
('Hi-Way Inn', 165, '2019-11-06', 309, NULL),
('Hi-Way Inn', 165, '2019-11-07', 361, NULL),
('Hi-Way Inn', 165, '2019-11-08', 119, NULL),
('Hi-Way Inn', 165, '2019-11-09', 234, NULL),
('Hi-Way Inn', 165, '2019-11-10', 284, NULL),
('Hi-Way Inn', 165, '2019-11-11', 373, NULL),
('Hi-Way Inn', 165, '2019-11-12', 259, NULL),
('Hi-Way Inn', 165, '2019-11-13', 243, NULL),
('Hi-Way Inn', 165, '2019-11-14', 211, NULL),
('Hi-Way Inn', 165, '2019-11-15', 308, NULL),
('Hi-Way Inn', 165, '2019-11-16', 164, NULL),
('Hi-Way Inn', 165, '2019-11-17', 364, NULL),
('Hi-Way Inn', 165, '2019-11-18', 264, NULL),
('Hi-Way Inn', 165, '2019-11-19', 389, NULL),
('Hi-Way Inn', 165, '2019-11-20', 386, NULL),
('Hi-Way Inn', 165, '2019-11-21', 231, NULL),
('Hi-Way Inn', 165, '2019-11-22', 146, NULL),
('Hi-Way Inn', 165, '2019-11-23', 232, NULL),
('Hi-Way Inn', 165, '2019-11-24', 123, NULL),
('Hi-Way Inn', 165, '2019-11-25', 209, NULL),
('Hi-Way Inn', 165, '2019-11-26', 323, NULL),
('Hi-Way Inn', 165, '2019-11-27', 303, NULL),
('Hi-Way Inn', 165, '2019-11-28', 373, NULL),
('Hi-Way Inn', 165, '2019-11-29', 140, NULL),
('Hi-Way Inn', 165, '2019-11-30', 183, NULL),
('Hi-Way Inn', 165, '2019-12-01', 337, NULL),
('Hi-Way Inn', 165, '2019-12-02', 150, NULL),
('Hi-Way Inn', 165, '2019-12-03', 163, NULL),
('Hi-Way Inn', 165, '2019-12-04', 114, NULL),
('Hi-Way Inn', 165, '2019-12-05', 292, NULL),
('Hi-Way Inn', 165, '2019-12-06', 348, NULL),
('Hi-Way Inn', 165, '2019-12-07', 313, NULL),
('Hi-Way Inn', 165, '2019-12-08', 389, NULL),
('Hi-Way Inn', 165, '2019-12-09', 241, NULL),
('Hi-Way Inn', 165, '2019-12-10', 277, NULL),
('Hi-Way Inn', 165, '2019-12-11', 289, NULL),
('Hi-Way Inn', 165, '2019-12-12', 183, NULL),
('Hi-Way Inn', 165, '2019-12-13', 118, NULL),
('Hi-Way Inn', 165, '2019-12-14', 216, NULL),
('Hi-Way Inn', 165, '2019-12-15', 251, NULL),
('Hi-Way Inn', 165, '2019-12-16', 212, NULL),
('Hi-Way Inn', 165, '2019-12-17', 265, NULL),
('Hi-Way Inn', 165, '2019-12-18', 154, NULL),
('Hi-Way Inn', 165, '2019-12-19', 370, NULL),
('Hi-Way Inn', 165, '2019-12-20', 210, NULL),
('Hi-Way Inn', 165, '2019-12-21', 207, NULL),
('Hi-Way Inn', 165, '2019-12-22', 126, NULL),
('Hi-Way Inn', 165, '2019-12-23', 180, NULL),
('Hi-Way Inn', 165, '2019-12-24', 363, NULL),
('Hi-Way Inn', 165, '2019-12-25', 231, NULL),
('Hi-Way Inn', 165, '2019-12-26', 370, NULL),
('Hi-Way Inn', 165, '2019-12-27', 296, NULL),
('Hi-Way Inn', 165, '2019-12-28', 361, NULL),
('Hi-Way Inn', 165, '2019-12-29', 156, NULL),
('Hi-Way Inn', 165, '2019-12-30', 354, NULL),
('Hi-Way Inn', 165, '2019-12-31', 243, NULL),
('Hi-Way Inn', 165, '2020-01-01', 122, NULL),
('Hi-Way Inn', 165, '2020-01-02', 199, NULL),
('Hi-Way Inn', 165, '2020-01-03', 169, NULL),
('Hi-Way Inn', 165, '2020-01-04', 100, NULL),
('Hi-Way Inn', 165, '2020-01-05', 387, NULL),
('Hi-Way Inn', 165, '2020-01-06', 150, NULL),
('Hi-Way Inn', 165, '2020-01-07', 170, NULL),
('Hi-Way Inn', 165, '2020-01-08', 394, NULL),
('Hi-Way Inn', 165, '2020-01-09', 328, NULL),
('Hi-Way Inn', 165, '2020-01-10', 118, NULL),
('Hi-Way Inn', 165, '2020-01-11', 209, NULL),
('Hi-Way Inn', 165, '2020-01-12', 156, NULL),
('Hi-Way Inn', 165, '2020-01-13', 180, NULL),
('Hi-Way Inn', 165, '2020-01-14', 358, NULL),
('Hi-Way Inn', 165, '2020-01-15', 152, NULL),
('Hi-Way Inn', 165, '2020-01-16', 209, NULL),
('Hi-Way Inn', 165, '2020-01-17', 380, NULL),
('Hi-Way Inn', 165, '2020-01-18', 104, NULL),
('Hi-Way Inn', 165, '2020-01-19', 252, NULL),
('Hi-Way Inn', 165, '2020-01-20', 300, NULL),
('Hi-Way Inn', 165, '2020-01-21', 301, NULL),
('Hi-Way Inn', 165, '2020-01-22', 202, NULL),
('Hi-Way Inn', 165, '2020-01-23', 381, NULL),
('Hi-Way Inn', 165, '2020-01-24', 367, NULL),
('Hi-Way Inn', 165, '2020-01-25', 210, NULL),
('Hi-Way Inn', 165, '2020-01-26', 254, NULL),
('Hi-Way Inn', 165, '2020-01-27', 180, NULL),
('Hi-Way Inn', 165, '2020-01-28', 238, NULL),
('Hi-Way Inn', 165, '2020-01-29', 321, NULL),
('Hi-Way Inn', 165, '2020-01-30', 380, NULL),
('Hi-Way Inn', 165, '2020-01-31', 293, NULL),
('Hi-Way Inn', 165, '2020-02-01', 198, NULL),
('Hi-Way Inn', 165, '2020-02-02', 120, NULL),
('Hi-Way Inn', 165, '2020-02-03', 174, NULL),
('Hi-Way Inn', 165, '2020-02-04', 325, NULL),
('Hi-Way Inn', 183, '2019-01-01', 367, NULL),
('Hi-Way Inn', 183, '2019-01-02', 398, NULL),
('Hi-Way Inn', 183, '2019-01-03', 229, NULL),
('Hi-Way Inn', 183, '2019-01-04', 141, NULL),
('Hi-Way Inn', 183, '2019-01-05', 196, NULL),
('Hi-Way Inn', 183, '2019-01-06', 340, NULL),
('Hi-Way Inn', 183, '2019-01-07', 218, NULL),
('Hi-Way Inn', 183, '2019-01-08', 207, NULL),
('Hi-Way Inn', 183, '2019-01-09', 370, NULL),
('Hi-Way Inn', 183, '2019-01-10', 191, NULL),
('Hi-Way Inn', 183, '2019-01-11', 141, NULL),
('Hi-Way Inn', 183, '2019-01-12', 214, NULL),
('Hi-Way Inn', 183, '2019-01-13', 181, NULL),
('Hi-Way Inn', 183, '2019-01-14', 294, NULL),
('Hi-Way Inn', 183, '2019-01-15', 165, NULL),
('Hi-Way Inn', 183, '2019-01-16', 158, NULL),
('Hi-Way Inn', 183, '2019-01-17', 194, NULL),
('Hi-Way Inn', 183, '2019-01-18', 111, NULL),
('Hi-Way Inn', 183, '2019-01-19', 207, NULL),
('Hi-Way Inn', 183, '2019-01-20', 180, NULL),
('Hi-Way Inn', 183, '2019-01-21', 305, NULL),
('Hi-Way Inn', 183, '2019-01-22', 131, NULL),
('Hi-Way Inn', 183, '2019-01-23', 380, NULL),
('Hi-Way Inn', 183, '2019-01-24', 329, NULL),
('Hi-Way Inn', 183, '2019-01-25', 397, NULL),
('Hi-Way Inn', 183, '2019-01-26', 119, NULL),
('Hi-Way Inn', 183, '2019-01-27', 296, NULL),
('Hi-Way Inn', 183, '2019-01-28', 214, NULL),
('Hi-Way Inn', 183, '2019-01-29', 230, NULL),
('Hi-Way Inn', 183, '2019-01-30', 290, NULL),
('Hi-Way Inn', 183, '2019-01-31', 118, NULL),
('Hi-Way Inn', 183, '2019-02-01', 246, NULL),
('Hi-Way Inn', 183, '2019-02-02', 205, NULL),
('Hi-Way Inn', 183, '2019-02-03', 130, NULL),
('Hi-Way Inn', 183, '2019-02-04', 357, NULL),
('Hi-Way Inn', 183, '2019-02-05', 394, NULL),
('Hi-Way Inn', 183, '2019-02-06', 130, NULL),
('Hi-Way Inn', 183, '2019-02-07', 123, NULL),
('Hi-Way Inn', 183, '2019-02-08', 299, NULL),
('Hi-Way Inn', 183, '2019-02-09', 110, NULL),
('Hi-Way Inn', 183, '2019-02-10', 134, NULL),
('Hi-Way Inn', 183, '2019-02-11', 166, NULL),
('Hi-Way Inn', 183, '2019-02-12', 268, NULL),
('Hi-Way Inn', 183, '2019-02-13', 288, NULL),
('Hi-Way Inn', 183, '2019-02-14', 264, NULL),
('Hi-Way Inn', 183, '2019-02-15', 298, NULL),
('Hi-Way Inn', 183, '2019-02-16', 386, NULL),
('Hi-Way Inn', 183, '2019-02-17', 303, NULL),
('Hi-Way Inn', 183, '2019-02-18', 183, NULL),
('Hi-Way Inn', 183, '2019-02-19', 381, NULL),
('Hi-Way Inn', 183, '2019-02-20', 158, NULL),
('Hi-Way Inn', 183, '2019-02-21', 178, NULL),
('Hi-Way Inn', 183, '2019-02-22', 246, NULL),
('Hi-Way Inn', 183, '2019-02-23', 188, NULL),
('Hi-Way Inn', 183, '2019-02-24', 384, NULL),
('Hi-Way Inn', 183, '2019-02-25', 347, NULL),
('Hi-Way Inn', 183, '2019-02-26', 118, NULL),
('Hi-Way Inn', 183, '2019-02-27', 375, NULL),
('Hi-Way Inn', 183, '2019-02-28', 338, NULL),
('Hi-Way Inn', 183, '2019-03-01', 229, NULL),
('Hi-Way Inn', 183, '2019-03-02', 331, NULL),
('Hi-Way Inn', 183, '2019-03-03', 285, NULL),
('Hi-Way Inn', 183, '2019-03-04', 247, NULL),
('Hi-Way Inn', 183, '2019-03-05', 292, NULL),
('Hi-Way Inn', 183, '2019-03-06', 374, NULL),
('Hi-Way Inn', 183, '2019-03-07', 260, NULL),
('Hi-Way Inn', 183, '2019-03-08', 259, NULL),
('Hi-Way Inn', 183, '2019-03-09', 341, NULL),
('Hi-Way Inn', 183, '2019-03-10', 163, NULL),
('Hi-Way Inn', 183, '2019-03-11', 142, NULL),
('Hi-Way Inn', 183, '2019-03-12', 121, NULL),
('Hi-Way Inn', 183, '2019-03-13', 337, NULL),
('Hi-Way Inn', 183, '2019-03-14', 226, NULL),
('Hi-Way Inn', 183, '2019-03-15', 175, NULL),
('Hi-Way Inn', 183, '2019-03-16', 257, NULL),
('Hi-Way Inn', 183, '2019-03-17', 271, NULL),
('Hi-Way Inn', 183, '2019-03-18', 380, NULL),
('Hi-Way Inn', 183, '2019-03-19', 303, NULL),
('Hi-Way Inn', 183, '2019-03-20', 180, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 183, '2019-03-21', 302, NULL),
('Hi-Way Inn', 183, '2019-03-22', 323, NULL),
('Hi-Way Inn', 183, '2019-03-23', 146, NULL),
('Hi-Way Inn', 183, '2019-03-24', 376, NULL),
('Hi-Way Inn', 183, '2019-03-25', 221, NULL),
('Hi-Way Inn', 183, '2019-03-26', 373, NULL),
('Hi-Way Inn', 183, '2019-03-27', 367, NULL),
('Hi-Way Inn', 183, '2019-03-28', 216, NULL),
('Hi-Way Inn', 183, '2019-03-29', 178, NULL),
('Hi-Way Inn', 183, '2019-03-30', 243, NULL),
('Hi-Way Inn', 183, '2019-03-31', 304, NULL),
('Hi-Way Inn', 183, '2019-04-01', 340, NULL),
('Hi-Way Inn', 183, '2019-04-02', 347, NULL),
('Hi-Way Inn', 183, '2019-04-03', 344, NULL),
('Hi-Way Inn', 183, '2019-04-04', 107, NULL),
('Hi-Way Inn', 183, '2019-04-05', 198, NULL),
('Hi-Way Inn', 183, '2019-04-06', 162, NULL),
('Hi-Way Inn', 183, '2019-04-07', 254, NULL),
('Hi-Way Inn', 183, '2019-04-08', 299, NULL),
('Hi-Way Inn', 183, '2019-04-09', 124, NULL),
('Hi-Way Inn', 183, '2019-04-10', 161, NULL),
('Hi-Way Inn', 183, '2019-04-11', 347, NULL),
('Hi-Way Inn', 183, '2019-04-12', 256, NULL),
('Hi-Way Inn', 183, '2019-04-13', 374, NULL),
('Hi-Way Inn', 183, '2019-04-14', 127, NULL),
('Hi-Way Inn', 183, '2019-04-15', 397, NULL),
('Hi-Way Inn', 183, '2019-04-16', 148, NULL),
('Hi-Way Inn', 183, '2019-04-17', 184, NULL),
('Hi-Way Inn', 183, '2019-04-18', 209, NULL),
('Hi-Way Inn', 183, '2019-04-19', 214, NULL),
('Hi-Way Inn', 183, '2019-04-20', 156, NULL),
('Hi-Way Inn', 183, '2019-04-21', 242, NULL),
('Hi-Way Inn', 183, '2019-04-22', 334, NULL),
('Hi-Way Inn', 183, '2019-04-23', 219, NULL),
('Hi-Way Inn', 183, '2019-04-24', 301, NULL),
('Hi-Way Inn', 183, '2019-04-25', 126, NULL),
('Hi-Way Inn', 183, '2019-04-26', 204, NULL),
('Hi-Way Inn', 183, '2019-04-27', 295, NULL),
('Hi-Way Inn', 183, '2019-04-28', 136, NULL),
('Hi-Way Inn', 183, '2019-04-29', 151, NULL),
('Hi-Way Inn', 183, '2019-04-30', 265, NULL),
('Hi-Way Inn', 183, '2019-05-01', 175, NULL),
('Hi-Way Inn', 183, '2019-05-02', 285, NULL),
('Hi-Way Inn', 183, '2019-05-03', 203, NULL),
('Hi-Way Inn', 183, '2019-05-04', 177, NULL),
('Hi-Way Inn', 183, '2019-05-05', 366, NULL),
('Hi-Way Inn', 183, '2019-05-06', 365, NULL),
('Hi-Way Inn', 183, '2019-05-07', 325, NULL),
('Hi-Way Inn', 183, '2019-05-08', 276, NULL),
('Hi-Way Inn', 183, '2019-05-09', 133, NULL),
('Hi-Way Inn', 183, '2019-05-10', 247, NULL),
('Hi-Way Inn', 183, '2019-05-11', 101, NULL),
('Hi-Way Inn', 183, '2019-05-12', 309, NULL),
('Hi-Way Inn', 183, '2019-05-13', 184, NULL),
('Hi-Way Inn', 183, '2019-05-14', 370, NULL),
('Hi-Way Inn', 183, '2019-05-15', 388, NULL),
('Hi-Way Inn', 183, '2019-05-16', 390, NULL),
('Hi-Way Inn', 183, '2019-05-17', 157, NULL),
('Hi-Way Inn', 183, '2019-05-18', 251, NULL),
('Hi-Way Inn', 183, '2019-05-19', 384, NULL),
('Hi-Way Inn', 183, '2019-05-20', 105, NULL),
('Hi-Way Inn', 183, '2019-05-21', 131, NULL),
('Hi-Way Inn', 183, '2019-05-22', 337, NULL),
('Hi-Way Inn', 183, '2019-05-23', 290, NULL),
('Hi-Way Inn', 183, '2019-05-24', 329, NULL),
('Hi-Way Inn', 183, '2019-05-25', 341, NULL),
('Hi-Way Inn', 183, '2019-05-26', 301, NULL),
('Hi-Way Inn', 183, '2019-05-27', 334, NULL),
('Hi-Way Inn', 183, '2019-05-28', 140, NULL),
('Hi-Way Inn', 183, '2019-05-29', 361, NULL),
('Hi-Way Inn', 183, '2019-05-30', 164, NULL),
('Hi-Way Inn', 183, '2019-05-31', 152, NULL),
('Hi-Way Inn', 183, '2019-06-01', 146, NULL),
('Hi-Way Inn', 183, '2019-06-02', 302, NULL),
('Hi-Way Inn', 183, '2019-06-03', 320, NULL),
('Hi-Way Inn', 183, '2019-06-04', 365, NULL),
('Hi-Way Inn', 183, '2019-06-05', 310, NULL),
('Hi-Way Inn', 183, '2019-06-06', 181, NULL),
('Hi-Way Inn', 183, '2019-06-07', 279, NULL),
('Hi-Way Inn', 183, '2019-06-08', 364, NULL),
('Hi-Way Inn', 183, '2019-06-09', 373, NULL),
('Hi-Way Inn', 183, '2019-06-10', 145, NULL),
('Hi-Way Inn', 183, '2019-06-11', 147, NULL),
('Hi-Way Inn', 183, '2019-06-12', 224, NULL),
('Hi-Way Inn', 183, '2019-06-13', 366, NULL),
('Hi-Way Inn', 183, '2019-06-14', 296, NULL),
('Hi-Way Inn', 183, '2019-06-15', 189, NULL),
('Hi-Way Inn', 183, '2019-06-16', 388, NULL),
('Hi-Way Inn', 183, '2019-06-17', 188, NULL),
('Hi-Way Inn', 183, '2019-06-18', 235, NULL),
('Hi-Way Inn', 183, '2019-06-19', 182, NULL),
('Hi-Way Inn', 183, '2019-06-20', 235, NULL),
('Hi-Way Inn', 183, '2019-06-21', 124, NULL),
('Hi-Way Inn', 183, '2019-06-22', 150, NULL),
('Hi-Way Inn', 183, '2019-06-23', 399, NULL),
('Hi-Way Inn', 183, '2019-06-24', 120, NULL),
('Hi-Way Inn', 183, '2019-06-25', 152, NULL),
('Hi-Way Inn', 183, '2019-06-26', 312, NULL),
('Hi-Way Inn', 183, '2019-06-27', 385, NULL),
('Hi-Way Inn', 183, '2019-06-28', 161, NULL),
('Hi-Way Inn', 183, '2019-06-29', 327, NULL),
('Hi-Way Inn', 183, '2019-06-30', 256, NULL),
('Hi-Way Inn', 183, '2019-07-01', 318, NULL),
('Hi-Way Inn', 183, '2019-07-02', 146, NULL),
('Hi-Way Inn', 183, '2019-07-03', 340, NULL),
('Hi-Way Inn', 183, '2019-07-04', 289, NULL),
('Hi-Way Inn', 183, '2019-07-05', 330, NULL),
('Hi-Way Inn', 183, '2019-07-06', 134, NULL),
('Hi-Way Inn', 183, '2019-07-07', 249, NULL),
('Hi-Way Inn', 183, '2019-07-08', 149, NULL),
('Hi-Way Inn', 183, '2019-07-09', 349, NULL),
('Hi-Way Inn', 183, '2019-07-10', 322, NULL),
('Hi-Way Inn', 183, '2019-07-11', 392, NULL),
('Hi-Way Inn', 183, '2019-07-12', 147, NULL),
('Hi-Way Inn', 183, '2019-07-13', 312, NULL),
('Hi-Way Inn', 183, '2019-07-14', 324, NULL),
('Hi-Way Inn', 183, '2019-07-15', 270, NULL),
('Hi-Way Inn', 183, '2019-07-16', 195, NULL),
('Hi-Way Inn', 183, '2019-07-17', 351, NULL),
('Hi-Way Inn', 183, '2019-07-18', 281, NULL),
('Hi-Way Inn', 183, '2019-07-19', 281, NULL),
('Hi-Way Inn', 183, '2019-07-20', 183, NULL),
('Hi-Way Inn', 183, '2019-07-21', 259, NULL),
('Hi-Way Inn', 183, '2019-07-22', 256, NULL),
('Hi-Way Inn', 183, '2019-07-23', 271, NULL),
('Hi-Way Inn', 183, '2019-07-24', 139, NULL),
('Hi-Way Inn', 183, '2019-07-25', 206, NULL),
('Hi-Way Inn', 183, '2019-07-26', 270, NULL),
('Hi-Way Inn', 183, '2019-07-27', 219, NULL),
('Hi-Way Inn', 183, '2019-07-28', 121, NULL),
('Hi-Way Inn', 183, '2019-07-29', 320, NULL),
('Hi-Way Inn', 183, '2019-07-30', 290, NULL),
('Hi-Way Inn', 183, '2019-07-31', 351, NULL),
('Hi-Way Inn', 183, '2019-08-01', 330, NULL),
('Hi-Way Inn', 183, '2019-08-02', 333, NULL),
('Hi-Way Inn', 183, '2019-08-03', 288, NULL),
('Hi-Way Inn', 183, '2019-08-04', 284, NULL),
('Hi-Way Inn', 183, '2019-08-05', 170, NULL),
('Hi-Way Inn', 183, '2019-08-06', 190, NULL),
('Hi-Way Inn', 183, '2019-08-07', 105, NULL),
('Hi-Way Inn', 183, '2019-08-08', 330, NULL),
('Hi-Way Inn', 183, '2019-08-09', 156, NULL),
('Hi-Way Inn', 183, '2019-08-10', 218, NULL),
('Hi-Way Inn', 183, '2019-08-11', 264, NULL),
('Hi-Way Inn', 183, '2019-08-12', 373, NULL),
('Hi-Way Inn', 183, '2019-08-13', 124, NULL),
('Hi-Way Inn', 183, '2019-08-14', 342, NULL),
('Hi-Way Inn', 183, '2019-08-15', 304, NULL),
('Hi-Way Inn', 183, '2019-08-16', 177, NULL),
('Hi-Way Inn', 183, '2019-08-17', 298, NULL),
('Hi-Way Inn', 183, '2019-08-18', 247, NULL),
('Hi-Way Inn', 183, '2019-08-19', 373, NULL),
('Hi-Way Inn', 183, '2019-08-20', 259, NULL),
('Hi-Way Inn', 183, '2019-08-21', 389, NULL),
('Hi-Way Inn', 183, '2019-08-22', 134, NULL),
('Hi-Way Inn', 183, '2019-08-23', 374, NULL),
('Hi-Way Inn', 183, '2019-08-24', 164, NULL),
('Hi-Way Inn', 183, '2019-08-25', 104, NULL),
('Hi-Way Inn', 183, '2019-08-26', 108, NULL),
('Hi-Way Inn', 183, '2019-08-27', 366, NULL),
('Hi-Way Inn', 183, '2019-08-28', 353, NULL),
('Hi-Way Inn', 183, '2019-08-29', 333, NULL),
('Hi-Way Inn', 183, '2019-08-30', 219, NULL),
('Hi-Way Inn', 183, '2019-08-31', 167, NULL),
('Hi-Way Inn', 183, '2019-09-01', 266, NULL),
('Hi-Way Inn', 183, '2019-09-02', 367, NULL),
('Hi-Way Inn', 183, '2019-09-03', 335, NULL),
('Hi-Way Inn', 183, '2019-09-04', 305, NULL),
('Hi-Way Inn', 183, '2019-09-05', 109, NULL),
('Hi-Way Inn', 183, '2019-09-06', 204, NULL),
('Hi-Way Inn', 183, '2019-09-07', 386, NULL),
('Hi-Way Inn', 183, '2019-09-08', 277, NULL),
('Hi-Way Inn', 183, '2019-09-09', 356, NULL),
('Hi-Way Inn', 183, '2019-09-10', 112, NULL),
('Hi-Way Inn', 183, '2019-09-11', 246, NULL),
('Hi-Way Inn', 183, '2019-09-12', 125, NULL),
('Hi-Way Inn', 183, '2019-09-13', 198, NULL),
('Hi-Way Inn', 183, '2019-09-14', 375, NULL),
('Hi-Way Inn', 183, '2019-09-15', 111, NULL),
('Hi-Way Inn', 183, '2019-09-16', 396, NULL),
('Hi-Way Inn', 183, '2019-09-17', 233, NULL),
('Hi-Way Inn', 183, '2019-09-18', 399, NULL),
('Hi-Way Inn', 183, '2019-09-19', 280, NULL),
('Hi-Way Inn', 183, '2019-09-20', 166, NULL),
('Hi-Way Inn', 183, '2019-09-21', 254, NULL),
('Hi-Way Inn', 183, '2019-09-22', 210, NULL),
('Hi-Way Inn', 183, '2019-09-23', 108, NULL),
('Hi-Way Inn', 183, '2019-09-24', 318, NULL),
('Hi-Way Inn', 183, '2019-09-25', 181, NULL),
('Hi-Way Inn', 183, '2019-09-26', 136, NULL),
('Hi-Way Inn', 183, '2019-09-27', 337, NULL),
('Hi-Way Inn', 183, '2019-09-28', 174, NULL),
('Hi-Way Inn', 183, '2019-09-29', 359, NULL),
('Hi-Way Inn', 183, '2019-09-30', 237, NULL),
('Hi-Way Inn', 183, '2019-10-01', 322, NULL),
('Hi-Way Inn', 183, '2019-10-02', 144, NULL),
('Hi-Way Inn', 183, '2019-10-03', 157, NULL),
('Hi-Way Inn', 183, '2019-10-04', 105, NULL),
('Hi-Way Inn', 183, '2019-10-05', 205, NULL),
('Hi-Way Inn', 183, '2019-10-06', 374, NULL),
('Hi-Way Inn', 183, '2019-10-07', 271, NULL),
('Hi-Way Inn', 183, '2019-10-08', 346, NULL),
('Hi-Way Inn', 183, '2019-10-09', 313, NULL),
('Hi-Way Inn', 183, '2019-10-10', 178, NULL),
('Hi-Way Inn', 183, '2019-10-11', 290, NULL),
('Hi-Way Inn', 183, '2019-10-12', 135, NULL),
('Hi-Way Inn', 183, '2019-10-13', 229, NULL),
('Hi-Way Inn', 183, '2019-10-14', 172, NULL),
('Hi-Way Inn', 183, '2019-10-15', 207, NULL),
('Hi-Way Inn', 183, '2019-10-16', 345, NULL),
('Hi-Way Inn', 183, '2019-10-17', 216, NULL),
('Hi-Way Inn', 183, '2019-10-18', 274, NULL),
('Hi-Way Inn', 183, '2019-10-19', 156, NULL),
('Hi-Way Inn', 183, '2019-10-20', 292, NULL),
('Hi-Way Inn', 183, '2019-10-21', 322, NULL),
('Hi-Way Inn', 183, '2019-10-22', 143, NULL),
('Hi-Way Inn', 183, '2019-10-23', 394, NULL),
('Hi-Way Inn', 183, '2019-10-24', 123, NULL),
('Hi-Way Inn', 183, '2019-10-25', 369, NULL),
('Hi-Way Inn', 183, '2019-10-26', 305, NULL),
('Hi-Way Inn', 183, '2019-10-27', 211, NULL),
('Hi-Way Inn', 183, '2019-10-28', 156, NULL),
('Hi-Way Inn', 183, '2019-10-29', 368, NULL),
('Hi-Way Inn', 183, '2019-10-30', 150, NULL),
('Hi-Way Inn', 183, '2019-10-31', 318, NULL),
('Hi-Way Inn', 183, '2019-11-01', 165, NULL),
('Hi-Way Inn', 183, '2019-11-02', 137, NULL),
('Hi-Way Inn', 183, '2019-11-03', 183, NULL),
('Hi-Way Inn', 183, '2019-11-04', 108, NULL),
('Hi-Way Inn', 183, '2019-11-05', 177, NULL),
('Hi-Way Inn', 183, '2019-11-06', 189, NULL),
('Hi-Way Inn', 183, '2019-11-07', 280, NULL),
('Hi-Way Inn', 183, '2019-11-08', 174, NULL),
('Hi-Way Inn', 183, '2019-11-09', 373, NULL),
('Hi-Way Inn', 183, '2019-11-10', 347, NULL),
('Hi-Way Inn', 183, '2019-11-11', 343, NULL),
('Hi-Way Inn', 183, '2019-11-12', 250, NULL),
('Hi-Way Inn', 183, '2019-11-13', 231, NULL),
('Hi-Way Inn', 183, '2019-11-14', 293, NULL),
('Hi-Way Inn', 183, '2019-11-15', 206, NULL),
('Hi-Way Inn', 183, '2019-11-16', 242, NULL),
('Hi-Way Inn', 183, '2019-11-17', 180, NULL),
('Hi-Way Inn', 183, '2019-11-18', 363, NULL),
('Hi-Way Inn', 183, '2019-11-19', 224, NULL),
('Hi-Way Inn', 183, '2019-11-20', 336, NULL),
('Hi-Way Inn', 183, '2019-11-21', 124, NULL),
('Hi-Way Inn', 183, '2019-11-22', 107, NULL),
('Hi-Way Inn', 183, '2019-11-23', 296, NULL),
('Hi-Way Inn', 183, '2019-11-24', 273, NULL),
('Hi-Way Inn', 183, '2019-11-25', 248, NULL),
('Hi-Way Inn', 183, '2019-11-26', 357, NULL),
('Hi-Way Inn', 183, '2019-11-27', 118, NULL),
('Hi-Way Inn', 183, '2019-11-28', 397, NULL),
('Hi-Way Inn', 183, '2019-11-29', 381, NULL),
('Hi-Way Inn', 183, '2019-11-30', 285, NULL),
('Hi-Way Inn', 183, '2019-12-01', 152, NULL),
('Hi-Way Inn', 183, '2019-12-02', 313, NULL),
('Hi-Way Inn', 183, '2019-12-03', 157, NULL),
('Hi-Way Inn', 183, '2019-12-04', 388, NULL),
('Hi-Way Inn', 183, '2019-12-05', 336, NULL),
('Hi-Way Inn', 183, '2019-12-06', 145, NULL),
('Hi-Way Inn', 183, '2019-12-07', 235, NULL),
('Hi-Way Inn', 183, '2019-12-08', 353, NULL),
('Hi-Way Inn', 183, '2019-12-09', 286, NULL),
('Hi-Way Inn', 183, '2019-12-10', 207, NULL),
('Hi-Way Inn', 183, '2019-12-11', 228, NULL),
('Hi-Way Inn', 183, '2019-12-12', 332, NULL),
('Hi-Way Inn', 183, '2019-12-13', 193, NULL),
('Hi-Way Inn', 183, '2019-12-14', 321, NULL),
('Hi-Way Inn', 183, '2019-12-15', 344, NULL),
('Hi-Way Inn', 183, '2019-12-16', 202, NULL),
('Hi-Way Inn', 183, '2019-12-17', 317, NULL),
('Hi-Way Inn', 183, '2019-12-18', 320, NULL),
('Hi-Way Inn', 183, '2019-12-19', 323, NULL),
('Hi-Way Inn', 183, '2019-12-20', 229, NULL),
('Hi-Way Inn', 183, '2019-12-21', 281, NULL),
('Hi-Way Inn', 183, '2019-12-22', 163, NULL),
('Hi-Way Inn', 183, '2019-12-23', 125, NULL),
('Hi-Way Inn', 183, '2019-12-24', 397, NULL),
('Hi-Way Inn', 183, '2019-12-25', 153, NULL),
('Hi-Way Inn', 183, '2019-12-26', 100, NULL),
('Hi-Way Inn', 183, '2019-12-27', 263, NULL),
('Hi-Way Inn', 183, '2019-12-28', 385, NULL),
('Hi-Way Inn', 183, '2019-12-29', 293, NULL),
('Hi-Way Inn', 183, '2019-12-30', 171, NULL),
('Hi-Way Inn', 183, '2019-12-31', 198, NULL),
('Hi-Way Inn', 183, '2020-01-01', 301, NULL),
('Hi-Way Inn', 183, '2020-01-02', 289, NULL),
('Hi-Way Inn', 183, '2020-01-03', 308, NULL),
('Hi-Way Inn', 183, '2020-01-04', 163, NULL),
('Hi-Way Inn', 183, '2020-01-05', 166, NULL),
('Hi-Way Inn', 183, '2020-01-06', 254, NULL),
('Hi-Way Inn', 183, '2020-01-07', 198, NULL),
('Hi-Way Inn', 183, '2020-01-08', 108, NULL),
('Hi-Way Inn', 183, '2020-01-09', 331, NULL),
('Hi-Way Inn', 183, '2020-01-10', 316, NULL),
('Hi-Way Inn', 183, '2020-01-11', 199, NULL),
('Hi-Way Inn', 183, '2020-01-12', 267, NULL),
('Hi-Way Inn', 183, '2020-01-13', 193, NULL),
('Hi-Way Inn', 183, '2020-01-14', 241, NULL),
('Hi-Way Inn', 183, '2020-01-15', 355, NULL),
('Hi-Way Inn', 183, '2020-01-16', 331, NULL),
('Hi-Way Inn', 183, '2020-01-17', 263, NULL),
('Hi-Way Inn', 183, '2020-01-18', 267, NULL),
('Hi-Way Inn', 183, '2020-01-19', 119, NULL),
('Hi-Way Inn', 183, '2020-01-20', 329, NULL),
('Hi-Way Inn', 183, '2020-01-21', 249, NULL),
('Hi-Way Inn', 183, '2020-01-22', 331, NULL),
('Hi-Way Inn', 183, '2020-01-23', 110, NULL),
('Hi-Way Inn', 183, '2020-01-24', 189, NULL),
('Hi-Way Inn', 183, '2020-01-25', 187, NULL),
('Hi-Way Inn', 183, '2020-01-26', 230, NULL),
('Hi-Way Inn', 183, '2020-01-27', 387, NULL),
('Hi-Way Inn', 183, '2020-01-28', 343, NULL),
('Hi-Way Inn', 183, '2020-01-29', 243, NULL),
('Hi-Way Inn', 183, '2020-01-30', 122, NULL),
('Hi-Way Inn', 183, '2020-01-31', 146, NULL),
('Hi-Way Inn', 183, '2020-02-01', 208, NULL),
('Hi-Way Inn', 183, '2020-02-02', 150, NULL),
('Hi-Way Inn', 183, '2020-02-03', 216, NULL),
('Hi-Way Inn', 183, '2020-02-04', 373, NULL),
('Hi-Way Inn', 188, '2019-01-01', 320, NULL),
('Hi-Way Inn', 188, '2019-01-02', 182, NULL),
('Hi-Way Inn', 188, '2019-01-03', 111, NULL),
('Hi-Way Inn', 188, '2019-01-04', 312, NULL),
('Hi-Way Inn', 188, '2019-01-05', 207, NULL),
('Hi-Way Inn', 188, '2019-01-06', 326, NULL),
('Hi-Way Inn', 188, '2019-01-07', 134, NULL),
('Hi-Way Inn', 188, '2019-01-08', 127, NULL),
('Hi-Way Inn', 188, '2019-01-09', 335, NULL),
('Hi-Way Inn', 188, '2019-01-10', 396, NULL),
('Hi-Way Inn', 188, '2019-01-11', 328, NULL),
('Hi-Way Inn', 188, '2019-01-12', 161, NULL),
('Hi-Way Inn', 188, '2019-01-13', 212, NULL),
('Hi-Way Inn', 188, '2019-01-14', 279, NULL),
('Hi-Way Inn', 188, '2019-01-15', 159, NULL),
('Hi-Way Inn', 188, '2019-01-16', 171, NULL),
('Hi-Way Inn', 188, '2019-01-17', 247, NULL),
('Hi-Way Inn', 188, '2019-01-18', 123, NULL),
('Hi-Way Inn', 188, '2019-01-19', 155, NULL),
('Hi-Way Inn', 188, '2019-01-20', 382, NULL),
('Hi-Way Inn', 188, '2019-01-21', 147, NULL),
('Hi-Way Inn', 188, '2019-01-22', 133, NULL),
('Hi-Way Inn', 188, '2019-01-23', 176, NULL),
('Hi-Way Inn', 188, '2019-01-24', 181, NULL),
('Hi-Way Inn', 188, '2019-01-25', 214, NULL),
('Hi-Way Inn', 188, '2019-01-26', 368, NULL),
('Hi-Way Inn', 188, '2019-01-27', 397, NULL),
('Hi-Way Inn', 188, '2019-01-28', 308, NULL),
('Hi-Way Inn', 188, '2019-01-29', 325, NULL),
('Hi-Way Inn', 188, '2019-01-30', 155, NULL),
('Hi-Way Inn', 188, '2019-01-31', 178, NULL),
('Hi-Way Inn', 188, '2019-02-01', 259, NULL),
('Hi-Way Inn', 188, '2019-02-02', 253, NULL),
('Hi-Way Inn', 188, '2019-02-03', 198, NULL),
('Hi-Way Inn', 188, '2019-02-04', 396, NULL),
('Hi-Way Inn', 188, '2019-02-05', 326, NULL),
('Hi-Way Inn', 188, '2019-02-06', 294, NULL),
('Hi-Way Inn', 188, '2019-02-07', 251, NULL),
('Hi-Way Inn', 188, '2019-02-08', 137, NULL),
('Hi-Way Inn', 188, '2019-02-09', 272, NULL),
('Hi-Way Inn', 188, '2019-02-10', 222, NULL),
('Hi-Way Inn', 188, '2019-02-11', 214, NULL),
('Hi-Way Inn', 188, '2019-02-12', 161, NULL),
('Hi-Way Inn', 188, '2019-02-13', 199, NULL),
('Hi-Way Inn', 188, '2019-02-14', 212, NULL),
('Hi-Way Inn', 188, '2019-02-15', 313, NULL),
('Hi-Way Inn', 188, '2019-02-16', 354, NULL),
('Hi-Way Inn', 188, '2019-02-17', 320, NULL),
('Hi-Way Inn', 188, '2019-02-18', 374, NULL),
('Hi-Way Inn', 188, '2019-02-19', 165, NULL),
('Hi-Way Inn', 188, '2019-02-20', 253, NULL),
('Hi-Way Inn', 188, '2019-02-21', 146, NULL),
('Hi-Way Inn', 188, '2019-02-22', 212, NULL),
('Hi-Way Inn', 188, '2019-02-23', 370, NULL),
('Hi-Way Inn', 188, '2019-02-24', 359, NULL),
('Hi-Way Inn', 188, '2019-02-25', 229, NULL),
('Hi-Way Inn', 188, '2019-02-26', 343, NULL),
('Hi-Way Inn', 188, '2019-02-27', 287, NULL),
('Hi-Way Inn', 188, '2019-02-28', 215, NULL),
('Hi-Way Inn', 188, '2019-03-01', 220, NULL),
('Hi-Way Inn', 188, '2019-03-02', 215, NULL),
('Hi-Way Inn', 188, '2019-03-03', 275, NULL),
('Hi-Way Inn', 188, '2019-03-04', 244, NULL),
('Hi-Way Inn', 188, '2019-03-05', 300, NULL),
('Hi-Way Inn', 188, '2019-03-06', 157, NULL),
('Hi-Way Inn', 188, '2019-03-07', 230, NULL),
('Hi-Way Inn', 188, '2019-03-08', 290, NULL),
('Hi-Way Inn', 188, '2019-03-09', 202, NULL),
('Hi-Way Inn', 188, '2019-03-10', 155, NULL),
('Hi-Way Inn', 188, '2019-03-11', 177, NULL),
('Hi-Way Inn', 188, '2019-03-12', 129, NULL),
('Hi-Way Inn', 188, '2019-03-13', 294, NULL),
('Hi-Way Inn', 188, '2019-03-14', 178, NULL),
('Hi-Way Inn', 188, '2019-03-15', 392, NULL),
('Hi-Way Inn', 188, '2019-03-16', 381, NULL),
('Hi-Way Inn', 188, '2019-03-17', 147, NULL),
('Hi-Way Inn', 188, '2019-03-18', 307, NULL),
('Hi-Way Inn', 188, '2019-03-19', 334, NULL),
('Hi-Way Inn', 188, '2019-03-20', 229, NULL),
('Hi-Way Inn', 188, '2019-03-21', 100, NULL),
('Hi-Way Inn', 188, '2019-03-22', 346, NULL),
('Hi-Way Inn', 188, '2019-03-23', 237, NULL),
('Hi-Way Inn', 188, '2019-03-24', 133, NULL),
('Hi-Way Inn', 188, '2019-03-25', 149, NULL),
('Hi-Way Inn', 188, '2019-03-26', 194, NULL),
('Hi-Way Inn', 188, '2019-03-27', 132, NULL),
('Hi-Way Inn', 188, '2019-03-28', 251, NULL),
('Hi-Way Inn', 188, '2019-03-29', 190, NULL),
('Hi-Way Inn', 188, '2019-03-30', 122, NULL),
('Hi-Way Inn', 188, '2019-03-31', 255, NULL),
('Hi-Way Inn', 188, '2019-04-01', 328, NULL),
('Hi-Way Inn', 188, '2019-04-02', 340, NULL),
('Hi-Way Inn', 188, '2019-04-03', 251, NULL),
('Hi-Way Inn', 188, '2019-04-04', 167, NULL),
('Hi-Way Inn', 188, '2019-04-05', 385, NULL),
('Hi-Way Inn', 188, '2019-04-06', 375, NULL),
('Hi-Way Inn', 188, '2019-04-07', 242, NULL),
('Hi-Way Inn', 188, '2019-04-08', 102, NULL),
('Hi-Way Inn', 188, '2019-04-09', 199, NULL),
('Hi-Way Inn', 188, '2019-04-10', 103, NULL),
('Hi-Way Inn', 188, '2019-04-11', 251, NULL),
('Hi-Way Inn', 188, '2019-04-12', 321, NULL),
('Hi-Way Inn', 188, '2019-04-13', 287, NULL),
('Hi-Way Inn', 188, '2019-04-14', 141, NULL),
('Hi-Way Inn', 188, '2019-04-15', 243, NULL),
('Hi-Way Inn', 188, '2019-04-16', 248, NULL),
('Hi-Way Inn', 188, '2019-04-17', 356, NULL),
('Hi-Way Inn', 188, '2019-04-18', 337, NULL),
('Hi-Way Inn', 188, '2019-04-19', 204, NULL),
('Hi-Way Inn', 188, '2019-04-20', 382, NULL),
('Hi-Way Inn', 188, '2019-04-21', 346, NULL),
('Hi-Way Inn', 188, '2019-04-22', 212, NULL),
('Hi-Way Inn', 188, '2019-04-23', 214, NULL),
('Hi-Way Inn', 188, '2019-04-24', 288, NULL),
('Hi-Way Inn', 188, '2019-04-25', 202, NULL),
('Hi-Way Inn', 188, '2019-04-26', 283, NULL),
('Hi-Way Inn', 188, '2019-04-27', 175, NULL),
('Hi-Way Inn', 188, '2019-04-28', 340, NULL),
('Hi-Way Inn', 188, '2019-04-29', 305, NULL),
('Hi-Way Inn', 188, '2019-04-30', 295, NULL),
('Hi-Way Inn', 188, '2019-05-01', 181, NULL),
('Hi-Way Inn', 188, '2019-05-02', 261, NULL),
('Hi-Way Inn', 188, '2019-05-03', 106, NULL),
('Hi-Way Inn', 188, '2019-05-04', 287, NULL),
('Hi-Way Inn', 188, '2019-05-05', 200, NULL),
('Hi-Way Inn', 188, '2019-05-06', 346, NULL),
('Hi-Way Inn', 188, '2019-05-07', 285, NULL),
('Hi-Way Inn', 188, '2019-05-08', 112, NULL),
('Hi-Way Inn', 188, '2019-05-09', 220, NULL),
('Hi-Way Inn', 188, '2019-05-10', 304, NULL),
('Hi-Way Inn', 188, '2019-05-11', 259, NULL),
('Hi-Way Inn', 188, '2019-05-12', 183, NULL),
('Hi-Way Inn', 188, '2019-05-13', 116, NULL),
('Hi-Way Inn', 188, '2019-05-14', 115, NULL),
('Hi-Way Inn', 188, '2019-05-15', 193, NULL),
('Hi-Way Inn', 188, '2019-05-16', 142, NULL),
('Hi-Way Inn', 188, '2019-05-17', 147, NULL),
('Hi-Way Inn', 188, '2019-05-18', 341, NULL),
('Hi-Way Inn', 188, '2019-05-19', 294, NULL),
('Hi-Way Inn', 188, '2019-05-20', 191, NULL),
('Hi-Way Inn', 188, '2019-05-21', 367, NULL),
('Hi-Way Inn', 188, '2019-05-22', 331, NULL),
('Hi-Way Inn', 188, '2019-05-23', 307, NULL),
('Hi-Way Inn', 188, '2019-05-24', 132, NULL),
('Hi-Way Inn', 188, '2019-05-25', 184, NULL),
('Hi-Way Inn', 188, '2019-05-26', 309, NULL),
('Hi-Way Inn', 188, '2019-05-27', 261, NULL),
('Hi-Way Inn', 188, '2019-05-28', 235, NULL),
('Hi-Way Inn', 188, '2019-05-29', 294, NULL),
('Hi-Way Inn', 188, '2019-05-30', 245, NULL),
('Hi-Way Inn', 188, '2019-05-31', 150, NULL),
('Hi-Way Inn', 188, '2019-06-01', 373, NULL),
('Hi-Way Inn', 188, '2019-06-02', 191, NULL),
('Hi-Way Inn', 188, '2019-06-03', 294, NULL),
('Hi-Way Inn', 188, '2019-06-04', 241, NULL),
('Hi-Way Inn', 188, '2019-06-05', 238, NULL),
('Hi-Way Inn', 188, '2019-06-06', 260, NULL),
('Hi-Way Inn', 188, '2019-06-07', 370, NULL),
('Hi-Way Inn', 188, '2019-06-08', 315, NULL),
('Hi-Way Inn', 188, '2019-06-09', 362, NULL),
('Hi-Way Inn', 188, '2019-06-10', 168, NULL),
('Hi-Way Inn', 188, '2019-06-11', 229, NULL),
('Hi-Way Inn', 188, '2019-06-12', 389, NULL),
('Hi-Way Inn', 188, '2019-06-13', 325, NULL),
('Hi-Way Inn', 188, '2019-06-14', 201, NULL),
('Hi-Way Inn', 188, '2019-06-15', 232, NULL),
('Hi-Way Inn', 188, '2019-06-16', 398, NULL),
('Hi-Way Inn', 188, '2019-06-17', 362, NULL),
('Hi-Way Inn', 188, '2019-06-18', 126, NULL),
('Hi-Way Inn', 188, '2019-06-19', 352, NULL),
('Hi-Way Inn', 188, '2019-06-20', 294, NULL),
('Hi-Way Inn', 188, '2019-06-21', 218, NULL),
('Hi-Way Inn', 188, '2019-06-22', 147, NULL),
('Hi-Way Inn', 188, '2019-06-23', 317, NULL),
('Hi-Way Inn', 188, '2019-06-24', 378, NULL),
('Hi-Way Inn', 188, '2019-06-25', 309, NULL),
('Hi-Way Inn', 188, '2019-06-26', 173, NULL),
('Hi-Way Inn', 188, '2019-06-27', 269, NULL),
('Hi-Way Inn', 188, '2019-06-28', 200, NULL),
('Hi-Way Inn', 188, '2019-06-29', 262, NULL),
('Hi-Way Inn', 188, '2019-06-30', 229, NULL),
('Hi-Way Inn', 188, '2019-07-01', 282, NULL),
('Hi-Way Inn', 188, '2019-07-02', 370, NULL),
('Hi-Way Inn', 188, '2019-07-03', 113, NULL),
('Hi-Way Inn', 188, '2019-07-04', 183, NULL),
('Hi-Way Inn', 188, '2019-07-05', 281, NULL),
('Hi-Way Inn', 188, '2019-07-06', 109, NULL),
('Hi-Way Inn', 188, '2019-07-07', 352, NULL),
('Hi-Way Inn', 188, '2019-07-08', 168, NULL),
('Hi-Way Inn', 188, '2019-07-09', 132, NULL),
('Hi-Way Inn', 188, '2019-07-10', 121, NULL),
('Hi-Way Inn', 188, '2019-07-11', 179, NULL),
('Hi-Way Inn', 188, '2019-07-12', 268, NULL),
('Hi-Way Inn', 188, '2019-07-13', 312, NULL),
('Hi-Way Inn', 188, '2019-07-14', 100, NULL),
('Hi-Way Inn', 188, '2019-07-15', 394, NULL),
('Hi-Way Inn', 188, '2019-07-16', 237, NULL),
('Hi-Way Inn', 188, '2019-07-17', 142, NULL),
('Hi-Way Inn', 188, '2019-07-18', 380, NULL),
('Hi-Way Inn', 188, '2019-07-19', 301, NULL),
('Hi-Way Inn', 188, '2019-07-20', 268, NULL),
('Hi-Way Inn', 188, '2019-07-21', 366, NULL),
('Hi-Way Inn', 188, '2019-07-22', 264, NULL),
('Hi-Way Inn', 188, '2019-07-23', 395, NULL),
('Hi-Way Inn', 188, '2019-07-24', 171, NULL),
('Hi-Way Inn', 188, '2019-07-25', 171, NULL),
('Hi-Way Inn', 188, '2019-07-26', 328, NULL),
('Hi-Way Inn', 188, '2019-07-27', 101, NULL),
('Hi-Way Inn', 188, '2019-07-28', 111, NULL),
('Hi-Way Inn', 188, '2019-07-29', 284, NULL),
('Hi-Way Inn', 188, '2019-07-30', 385, NULL),
('Hi-Way Inn', 188, '2019-07-31', 102, NULL),
('Hi-Way Inn', 188, '2019-08-01', 282, NULL),
('Hi-Way Inn', 188, '2019-08-02', 128, NULL),
('Hi-Way Inn', 188, '2019-08-03', 361, NULL),
('Hi-Way Inn', 188, '2019-08-04', 284, NULL),
('Hi-Way Inn', 188, '2019-08-05', 301, NULL),
('Hi-Way Inn', 188, '2019-08-06', 325, NULL),
('Hi-Way Inn', 188, '2019-08-07', 264, NULL),
('Hi-Way Inn', 188, '2019-08-08', 398, NULL),
('Hi-Way Inn', 188, '2019-08-09', 117, NULL),
('Hi-Way Inn', 188, '2019-08-10', 310, NULL),
('Hi-Way Inn', 188, '2019-08-11', 263, NULL),
('Hi-Way Inn', 188, '2019-08-12', 149, NULL),
('Hi-Way Inn', 188, '2019-08-13', 191, NULL),
('Hi-Way Inn', 188, '2019-08-14', 354, NULL),
('Hi-Way Inn', 188, '2019-08-15', 258, NULL),
('Hi-Way Inn', 188, '2019-08-16', 224, NULL),
('Hi-Way Inn', 188, '2019-08-17', 337, NULL),
('Hi-Way Inn', 188, '2019-08-18', 311, NULL),
('Hi-Way Inn', 188, '2019-08-19', 347, NULL),
('Hi-Way Inn', 188, '2019-08-20', 179, NULL),
('Hi-Way Inn', 188, '2019-08-21', 183, NULL),
('Hi-Way Inn', 188, '2019-08-22', 257, NULL),
('Hi-Way Inn', 188, '2019-08-23', 304, NULL),
('Hi-Way Inn', 188, '2019-08-24', 351, NULL),
('Hi-Way Inn', 188, '2019-08-25', 147, NULL),
('Hi-Way Inn', 188, '2019-08-26', 347, NULL),
('Hi-Way Inn', 188, '2019-08-27', 382, NULL),
('Hi-Way Inn', 188, '2019-08-28', 337, NULL),
('Hi-Way Inn', 188, '2019-08-29', 383, NULL),
('Hi-Way Inn', 188, '2019-08-30', 367, NULL),
('Hi-Way Inn', 188, '2019-08-31', 280, NULL),
('Hi-Way Inn', 188, '2019-09-01', 103, NULL),
('Hi-Way Inn', 188, '2019-09-02', 189, NULL),
('Hi-Way Inn', 188, '2019-09-03', 201, NULL),
('Hi-Way Inn', 188, '2019-09-04', 147, NULL),
('Hi-Way Inn', 188, '2019-09-05', 209, NULL),
('Hi-Way Inn', 188, '2019-09-06', 182, NULL),
('Hi-Way Inn', 188, '2019-09-07', 136, NULL),
('Hi-Way Inn', 188, '2019-09-08', 224, NULL),
('Hi-Way Inn', 188, '2019-09-09', 301, NULL),
('Hi-Way Inn', 188, '2019-09-10', 252, NULL),
('Hi-Way Inn', 188, '2019-09-11', 166, NULL),
('Hi-Way Inn', 188, '2019-09-12', 157, NULL),
('Hi-Way Inn', 188, '2019-09-13', 278, NULL),
('Hi-Way Inn', 188, '2019-09-14', 376, NULL),
('Hi-Way Inn', 188, '2019-09-15', 385, NULL),
('Hi-Way Inn', 188, '2019-09-16', 190, NULL),
('Hi-Way Inn', 188, '2019-09-17', 378, NULL),
('Hi-Way Inn', 188, '2019-09-18', 211, NULL),
('Hi-Way Inn', 188, '2019-09-19', 263, NULL),
('Hi-Way Inn', 188, '2019-09-20', 368, NULL),
('Hi-Way Inn', 188, '2019-09-21', 283, NULL),
('Hi-Way Inn', 188, '2019-09-22', 244, NULL),
('Hi-Way Inn', 188, '2019-09-23', 143, NULL),
('Hi-Way Inn', 188, '2019-09-24', 143, NULL),
('Hi-Way Inn', 188, '2019-09-25', 325, NULL),
('Hi-Way Inn', 188, '2019-09-26', 174, NULL),
('Hi-Way Inn', 188, '2019-09-27', 207, NULL),
('Hi-Way Inn', 188, '2019-09-28', 325, NULL),
('Hi-Way Inn', 188, '2019-09-29', 156, NULL),
('Hi-Way Inn', 188, '2019-09-30', 215, NULL),
('Hi-Way Inn', 188, '2019-10-01', 294, NULL),
('Hi-Way Inn', 188, '2019-10-02', 337, NULL),
('Hi-Way Inn', 188, '2019-10-03', 189, NULL),
('Hi-Way Inn', 188, '2019-10-04', 286, NULL),
('Hi-Way Inn', 188, '2019-10-05', 133, NULL),
('Hi-Way Inn', 188, '2019-10-06', 100, NULL),
('Hi-Way Inn', 188, '2019-10-07', 263, NULL),
('Hi-Way Inn', 188, '2019-10-08', 115, NULL),
('Hi-Way Inn', 188, '2019-10-09', 133, NULL),
('Hi-Way Inn', 188, '2019-10-10', 178, NULL),
('Hi-Way Inn', 188, '2019-10-11', 208, NULL),
('Hi-Way Inn', 188, '2019-10-12', 397, NULL),
('Hi-Way Inn', 188, '2019-10-13', 117, NULL),
('Hi-Way Inn', 188, '2019-10-14', 146, NULL),
('Hi-Way Inn', 188, '2019-10-15', 298, NULL),
('Hi-Way Inn', 188, '2019-10-16', 383, NULL),
('Hi-Way Inn', 188, '2019-10-17', 314, NULL),
('Hi-Way Inn', 188, '2019-10-18', 141, NULL),
('Hi-Way Inn', 188, '2019-10-19', 283, NULL),
('Hi-Way Inn', 188, '2019-10-20', 165, NULL),
('Hi-Way Inn', 188, '2019-10-21', 349, NULL),
('Hi-Way Inn', 188, '2019-10-22', 161, NULL),
('Hi-Way Inn', 188, '2019-10-23', 131, NULL),
('Hi-Way Inn', 188, '2019-10-24', 369, NULL),
('Hi-Way Inn', 188, '2019-10-25', 331, NULL),
('Hi-Way Inn', 188, '2019-10-26', 211, NULL),
('Hi-Way Inn', 188, '2019-10-27', 281, NULL),
('Hi-Way Inn', 188, '2019-10-28', 322, NULL),
('Hi-Way Inn', 188, '2019-10-29', 363, NULL),
('Hi-Way Inn', 188, '2019-10-30', 394, NULL),
('Hi-Way Inn', 188, '2019-10-31', 328, NULL),
('Hi-Way Inn', 188, '2019-11-01', 112, NULL),
('Hi-Way Inn', 188, '2019-11-02', 293, NULL),
('Hi-Way Inn', 188, '2019-11-03', 163, NULL),
('Hi-Way Inn', 188, '2019-11-04', 222, NULL),
('Hi-Way Inn', 188, '2019-11-05', 274, NULL),
('Hi-Way Inn', 188, '2019-11-06', 219, NULL),
('Hi-Way Inn', 188, '2019-11-07', 217, NULL),
('Hi-Way Inn', 188, '2019-11-08', 111, NULL),
('Hi-Way Inn', 188, '2019-11-09', 164, NULL),
('Hi-Way Inn', 188, '2019-11-10', 184, NULL),
('Hi-Way Inn', 188, '2019-11-11', 197, NULL),
('Hi-Way Inn', 188, '2019-11-12', 375, NULL),
('Hi-Way Inn', 188, '2019-11-13', 328, NULL),
('Hi-Way Inn', 188, '2019-11-14', 129, NULL),
('Hi-Way Inn', 188, '2019-11-15', 306, NULL),
('Hi-Way Inn', 188, '2019-11-16', 320, NULL),
('Hi-Way Inn', 188, '2019-11-17', 311, NULL),
('Hi-Way Inn', 188, '2019-11-18', 320, NULL),
('Hi-Way Inn', 188, '2019-11-19', 152, NULL),
('Hi-Way Inn', 188, '2019-11-20', 125, NULL),
('Hi-Way Inn', 188, '2019-11-21', 127, NULL),
('Hi-Way Inn', 188, '2019-11-22', 298, NULL),
('Hi-Way Inn', 188, '2019-11-23', 385, NULL),
('Hi-Way Inn', 188, '2019-11-24', 299, NULL),
('Hi-Way Inn', 188, '2019-11-25', 211, NULL),
('Hi-Way Inn', 188, '2019-11-26', 115, NULL),
('Hi-Way Inn', 188, '2019-11-27', 184, NULL),
('Hi-Way Inn', 188, '2019-11-28', 166, NULL),
('Hi-Way Inn', 188, '2019-11-29', 184, NULL),
('Hi-Way Inn', 188, '2019-11-30', 177, NULL),
('Hi-Way Inn', 188, '2019-12-01', 247, NULL),
('Hi-Way Inn', 188, '2019-12-02', 117, NULL),
('Hi-Way Inn', 188, '2019-12-03', 199, NULL),
('Hi-Way Inn', 188, '2019-12-04', 298, NULL),
('Hi-Way Inn', 188, '2019-12-05', 105, NULL),
('Hi-Way Inn', 188, '2019-12-06', 182, NULL),
('Hi-Way Inn', 188, '2019-12-07', 137, NULL),
('Hi-Way Inn', 188, '2019-12-08', 200, NULL),
('Hi-Way Inn', 188, '2019-12-09', 305, NULL),
('Hi-Way Inn', 188, '2019-12-10', 105, NULL),
('Hi-Way Inn', 188, '2019-12-11', 174, NULL),
('Hi-Way Inn', 188, '2019-12-12', 110, NULL),
('Hi-Way Inn', 188, '2019-12-13', 211, NULL),
('Hi-Way Inn', 188, '2019-12-14', 258, NULL),
('Hi-Way Inn', 188, '2019-12-15', 271, NULL),
('Hi-Way Inn', 188, '2019-12-16', 274, NULL),
('Hi-Way Inn', 188, '2019-12-17', 393, NULL),
('Hi-Way Inn', 188, '2019-12-18', 139, NULL),
('Hi-Way Inn', 188, '2019-12-19', 108, NULL),
('Hi-Way Inn', 188, '2019-12-20', 116, NULL),
('Hi-Way Inn', 188, '2019-12-21', 383, NULL),
('Hi-Way Inn', 188, '2019-12-22', 336, NULL),
('Hi-Way Inn', 188, '2019-12-23', 286, NULL),
('Hi-Way Inn', 188, '2019-12-24', 195, NULL),
('Hi-Way Inn', 188, '2019-12-25', 273, NULL),
('Hi-Way Inn', 188, '2019-12-26', 192, NULL),
('Hi-Way Inn', 188, '2019-12-27', 325, NULL),
('Hi-Way Inn', 188, '2019-12-28', 140, NULL),
('Hi-Way Inn', 188, '2019-12-29', 294, NULL),
('Hi-Way Inn', 188, '2019-12-30', 293, NULL),
('Hi-Way Inn', 188, '2019-12-31', 161, NULL),
('Hi-Way Inn', 188, '2020-01-01', 138, NULL),
('Hi-Way Inn', 188, '2020-01-02', 148, NULL),
('Hi-Way Inn', 188, '2020-01-03', 330, NULL),
('Hi-Way Inn', 188, '2020-01-04', 115, NULL),
('Hi-Way Inn', 188, '2020-01-05', 171, NULL),
('Hi-Way Inn', 188, '2020-01-06', 118, NULL),
('Hi-Way Inn', 188, '2020-01-07', 383, NULL),
('Hi-Way Inn', 188, '2020-01-08', 159, NULL),
('Hi-Way Inn', 188, '2020-01-09', 272, NULL),
('Hi-Way Inn', 188, '2020-01-10', 224, NULL),
('Hi-Way Inn', 188, '2020-01-11', 268, NULL),
('Hi-Way Inn', 188, '2020-01-12', 169, NULL),
('Hi-Way Inn', 188, '2020-01-13', 326, NULL),
('Hi-Way Inn', 188, '2020-01-14', 335, NULL),
('Hi-Way Inn', 188, '2020-01-15', 319, NULL),
('Hi-Way Inn', 188, '2020-01-16', 331, NULL),
('Hi-Way Inn', 188, '2020-01-17', 373, NULL),
('Hi-Way Inn', 188, '2020-01-18', 324, NULL),
('Hi-Way Inn', 188, '2020-01-19', 338, NULL),
('Hi-Way Inn', 188, '2020-01-20', 345, NULL),
('Hi-Way Inn', 188, '2020-01-21', 241, NULL),
('Hi-Way Inn', 188, '2020-01-22', 348, NULL),
('Hi-Way Inn', 188, '2020-01-23', 208, NULL),
('Hi-Way Inn', 188, '2020-01-24', 344, NULL),
('Hi-Way Inn', 188, '2020-01-25', 209, NULL),
('Hi-Way Inn', 188, '2020-01-26', 291, NULL),
('Hi-Way Inn', 188, '2020-01-27', 394, NULL),
('Hi-Way Inn', 188, '2020-01-28', 303, NULL),
('Hi-Way Inn', 188, '2020-01-29', 152, NULL),
('Hi-Way Inn', 188, '2020-01-30', 268, NULL),
('Hi-Way Inn', 188, '2020-01-31', 349, NULL),
('Hi-Way Inn', 188, '2020-02-01', 345, NULL),
('Hi-Way Inn', 188, '2020-02-02', 292, NULL),
('Hi-Way Inn', 188, '2020-02-03', 156, NULL),
('Hi-Way Inn', 188, '2020-02-04', 190, NULL),
('Hi-Way Inn', 196, '2019-01-01', 399, NULL),
('Hi-Way Inn', 196, '2019-01-02', 215, NULL),
('Hi-Way Inn', 196, '2019-01-03', 369, NULL),
('Hi-Way Inn', 196, '2019-01-04', 136, NULL),
('Hi-Way Inn', 196, '2019-01-05', 350, NULL),
('Hi-Way Inn', 196, '2019-01-06', 211, NULL),
('Hi-Way Inn', 196, '2019-01-07', 216, NULL),
('Hi-Way Inn', 196, '2019-01-08', 212, NULL),
('Hi-Way Inn', 196, '2019-01-09', 163, NULL),
('Hi-Way Inn', 196, '2019-01-10', 107, NULL),
('Hi-Way Inn', 196, '2019-01-11', 220, NULL),
('Hi-Way Inn', 196, '2019-01-12', 362, NULL),
('Hi-Way Inn', 196, '2019-01-13', 116, NULL),
('Hi-Way Inn', 196, '2019-01-14', 111, NULL),
('Hi-Way Inn', 196, '2019-01-15', 201, NULL),
('Hi-Way Inn', 196, '2019-01-16', 282, NULL),
('Hi-Way Inn', 196, '2019-01-17', 253, NULL),
('Hi-Way Inn', 196, '2019-01-18', 186, NULL),
('Hi-Way Inn', 196, '2019-01-19', 354, NULL),
('Hi-Way Inn', 196, '2019-01-20', 367, NULL),
('Hi-Way Inn', 196, '2019-01-21', 320, NULL),
('Hi-Way Inn', 196, '2019-01-22', 175, NULL),
('Hi-Way Inn', 196, '2019-01-23', 244, NULL),
('Hi-Way Inn', 196, '2019-01-24', 121, NULL),
('Hi-Way Inn', 196, '2019-01-25', 379, NULL),
('Hi-Way Inn', 196, '2019-01-26', 183, NULL),
('Hi-Way Inn', 196, '2019-01-27', 396, NULL),
('Hi-Way Inn', 196, '2019-01-28', 201, NULL),
('Hi-Way Inn', 196, '2019-01-29', 236, NULL),
('Hi-Way Inn', 196, '2019-01-30', 107, NULL),
('Hi-Way Inn', 196, '2019-01-31', 137, NULL),
('Hi-Way Inn', 196, '2019-02-01', 154, NULL),
('Hi-Way Inn', 196, '2019-02-02', 250, NULL),
('Hi-Way Inn', 196, '2019-02-03', 204, NULL),
('Hi-Way Inn', 196, '2019-02-04', 211, NULL),
('Hi-Way Inn', 196, '2019-02-05', 347, NULL),
('Hi-Way Inn', 196, '2019-02-06', 380, NULL),
('Hi-Way Inn', 196, '2019-02-07', 189, NULL),
('Hi-Way Inn', 196, '2019-02-08', 288, NULL),
('Hi-Way Inn', 196, '2019-02-09', 328, NULL),
('Hi-Way Inn', 196, '2019-02-10', 309, NULL),
('Hi-Way Inn', 196, '2019-02-11', 172, NULL),
('Hi-Way Inn', 196, '2019-02-12', 204, NULL),
('Hi-Way Inn', 196, '2019-02-13', 330, NULL),
('Hi-Way Inn', 196, '2019-02-14', 170, NULL),
('Hi-Way Inn', 196, '2019-02-15', 274, NULL),
('Hi-Way Inn', 196, '2019-02-16', 212, NULL),
('Hi-Way Inn', 196, '2019-02-17', 290, NULL),
('Hi-Way Inn', 196, '2019-02-18', 323, NULL),
('Hi-Way Inn', 196, '2019-02-19', 183, NULL),
('Hi-Way Inn', 196, '2019-02-20', 392, NULL),
('Hi-Way Inn', 196, '2019-02-21', 396, NULL),
('Hi-Way Inn', 196, '2019-02-22', 223, NULL),
('Hi-Way Inn', 196, '2019-02-23', 286, NULL),
('Hi-Way Inn', 196, '2019-02-24', 245, NULL),
('Hi-Way Inn', 196, '2019-02-25', 307, NULL),
('Hi-Way Inn', 196, '2019-02-26', 363, NULL),
('Hi-Way Inn', 196, '2019-02-27', 212, NULL),
('Hi-Way Inn', 196, '2019-02-28', 260, NULL),
('Hi-Way Inn', 196, '2019-03-01', 312, NULL),
('Hi-Way Inn', 196, '2019-03-02', 280, NULL),
('Hi-Way Inn', 196, '2019-03-03', 121, NULL),
('Hi-Way Inn', 196, '2019-03-04', 378, NULL),
('Hi-Way Inn', 196, '2019-03-05', 222, NULL),
('Hi-Way Inn', 196, '2019-03-06', 161, NULL),
('Hi-Way Inn', 196, '2019-03-07', 270, NULL),
('Hi-Way Inn', 196, '2019-03-08', 274, NULL),
('Hi-Way Inn', 196, '2019-03-09', 187, NULL),
('Hi-Way Inn', 196, '2019-03-10', 188, NULL),
('Hi-Way Inn', 196, '2019-03-11', 357, NULL),
('Hi-Way Inn', 196, '2019-03-12', 184, NULL),
('Hi-Way Inn', 196, '2019-03-13', 360, NULL),
('Hi-Way Inn', 196, '2019-03-14', 112, NULL),
('Hi-Way Inn', 196, '2019-03-15', 137, NULL),
('Hi-Way Inn', 196, '2019-03-16', 136, NULL),
('Hi-Way Inn', 196, '2019-03-17', 122, NULL),
('Hi-Way Inn', 196, '2019-03-18', 295, NULL),
('Hi-Way Inn', 196, '2019-03-19', 362, NULL),
('Hi-Way Inn', 196, '2019-03-20', 205, NULL),
('Hi-Way Inn', 196, '2019-03-21', 393, NULL),
('Hi-Way Inn', 196, '2019-03-22', 363, NULL),
('Hi-Way Inn', 196, '2019-03-23', 348, NULL),
('Hi-Way Inn', 196, '2019-03-24', 338, NULL),
('Hi-Way Inn', 196, '2019-03-25', 285, NULL),
('Hi-Way Inn', 196, '2019-03-26', 352, NULL),
('Hi-Way Inn', 196, '2019-03-27', 359, NULL),
('Hi-Way Inn', 196, '2019-03-28', 209, NULL),
('Hi-Way Inn', 196, '2019-03-29', 315, NULL),
('Hi-Way Inn', 196, '2019-03-30', 382, NULL),
('Hi-Way Inn', 196, '2019-03-31', 266, NULL),
('Hi-Way Inn', 196, '2019-04-01', 221, NULL),
('Hi-Way Inn', 196, '2019-04-02', 259, NULL),
('Hi-Way Inn', 196, '2019-04-03', 124, NULL),
('Hi-Way Inn', 196, '2019-04-04', 117, NULL),
('Hi-Way Inn', 196, '2019-04-05', 329, NULL),
('Hi-Way Inn', 196, '2019-04-06', 391, NULL),
('Hi-Way Inn', 196, '2019-04-07', 346, NULL),
('Hi-Way Inn', 196, '2019-04-08', 111, NULL),
('Hi-Way Inn', 196, '2019-04-09', 222, NULL),
('Hi-Way Inn', 196, '2019-04-10', 234, NULL),
('Hi-Way Inn', 196, '2019-04-11', 113, NULL),
('Hi-Way Inn', 196, '2019-04-12', 139, NULL),
('Hi-Way Inn', 196, '2019-04-13', 213, NULL),
('Hi-Way Inn', 196, '2019-04-14', 223, NULL),
('Hi-Way Inn', 196, '2019-04-15', 225, NULL),
('Hi-Way Inn', 196, '2019-04-16', 398, NULL),
('Hi-Way Inn', 196, '2019-04-17', 228, NULL),
('Hi-Way Inn', 196, '2019-04-18', 359, NULL),
('Hi-Way Inn', 196, '2019-04-19', 278, NULL),
('Hi-Way Inn', 196, '2019-04-20', 143, NULL),
('Hi-Way Inn', 196, '2019-04-21', 303, NULL),
('Hi-Way Inn', 196, '2019-04-22', 257, NULL),
('Hi-Way Inn', 196, '2019-04-23', 316, NULL),
('Hi-Way Inn', 196, '2019-04-24', 134, NULL),
('Hi-Way Inn', 196, '2019-04-25', 232, NULL),
('Hi-Way Inn', 196, '2019-04-26', 105, NULL),
('Hi-Way Inn', 196, '2019-04-27', 189, NULL),
('Hi-Way Inn', 196, '2019-04-28', 294, NULL),
('Hi-Way Inn', 196, '2019-04-29', 374, NULL),
('Hi-Way Inn', 196, '2019-04-30', 281, NULL),
('Hi-Way Inn', 196, '2019-05-01', 282, NULL),
('Hi-Way Inn', 196, '2019-05-02', 349, NULL),
('Hi-Way Inn', 196, '2019-05-03', 123, NULL),
('Hi-Way Inn', 196, '2019-05-04', 205, NULL),
('Hi-Way Inn', 196, '2019-05-05', 100, NULL),
('Hi-Way Inn', 196, '2019-05-06', 233, NULL),
('Hi-Way Inn', 196, '2019-05-07', 349, NULL),
('Hi-Way Inn', 196, '2019-05-08', 231, NULL),
('Hi-Way Inn', 196, '2019-05-09', 299, NULL),
('Hi-Way Inn', 196, '2019-05-10', 379, NULL),
('Hi-Way Inn', 196, '2019-05-11', 294, NULL),
('Hi-Way Inn', 196, '2019-05-12', 187, NULL),
('Hi-Way Inn', 196, '2019-05-13', 228, NULL),
('Hi-Way Inn', 196, '2019-05-14', 266, NULL),
('Hi-Way Inn', 196, '2019-05-15', 301, NULL),
('Hi-Way Inn', 196, '2019-05-16', 342, NULL),
('Hi-Way Inn', 196, '2019-05-17', 166, NULL),
('Hi-Way Inn', 196, '2019-05-18', 250, NULL),
('Hi-Way Inn', 196, '2019-05-19', 218, NULL),
('Hi-Way Inn', 196, '2019-05-20', 241, NULL),
('Hi-Way Inn', 196, '2019-05-21', 142, NULL),
('Hi-Way Inn', 196, '2019-05-22', 247, NULL),
('Hi-Way Inn', 196, '2019-05-23', 263, NULL),
('Hi-Way Inn', 196, '2019-05-24', 172, NULL),
('Hi-Way Inn', 196, '2019-05-25', 101, NULL),
('Hi-Way Inn', 196, '2019-05-26', 243, NULL),
('Hi-Way Inn', 196, '2019-05-27', 202, NULL),
('Hi-Way Inn', 196, '2019-05-28', 356, NULL),
('Hi-Way Inn', 196, '2019-05-29', 286, NULL),
('Hi-Way Inn', 196, '2019-05-30', 333, NULL),
('Hi-Way Inn', 196, '2019-05-31', 193, NULL),
('Hi-Way Inn', 196, '2019-06-01', 129, NULL),
('Hi-Way Inn', 196, '2019-06-02', 249, NULL),
('Hi-Way Inn', 196, '2019-06-03', 109, NULL),
('Hi-Way Inn', 196, '2019-06-04', 311, NULL),
('Hi-Way Inn', 196, '2019-06-05', 161, NULL),
('Hi-Way Inn', 196, '2019-06-06', 356, NULL),
('Hi-Way Inn', 196, '2019-06-07', 316, NULL),
('Hi-Way Inn', 196, '2019-06-08', 384, NULL),
('Hi-Way Inn', 196, '2019-06-09', 294, NULL),
('Hi-Way Inn', 196, '2019-06-10', 306, NULL),
('Hi-Way Inn', 196, '2019-06-11', 304, NULL),
('Hi-Way Inn', 196, '2019-06-12', 277, NULL),
('Hi-Way Inn', 196, '2019-06-13', 127, NULL),
('Hi-Way Inn', 196, '2019-06-14', 316, NULL),
('Hi-Way Inn', 196, '2019-06-15', 193, NULL),
('Hi-Way Inn', 196, '2019-06-16', 125, NULL),
('Hi-Way Inn', 196, '2019-06-17', 246, NULL),
('Hi-Way Inn', 196, '2019-06-18', 126, NULL),
('Hi-Way Inn', 196, '2019-06-19', 215, NULL),
('Hi-Way Inn', 196, '2019-06-20', 368, NULL),
('Hi-Way Inn', 196, '2019-06-21', 321, NULL),
('Hi-Way Inn', 196, '2019-06-22', 184, NULL),
('Hi-Way Inn', 196, '2019-06-23', 289, NULL),
('Hi-Way Inn', 196, '2019-06-24', 229, NULL),
('Hi-Way Inn', 196, '2019-06-25', 388, NULL),
('Hi-Way Inn', 196, '2019-06-26', 130, NULL),
('Hi-Way Inn', 196, '2019-06-27', 390, NULL),
('Hi-Way Inn', 196, '2019-06-28', 118, NULL),
('Hi-Way Inn', 196, '2019-06-29', 229, NULL),
('Hi-Way Inn', 196, '2019-06-30', 280, NULL),
('Hi-Way Inn', 196, '2019-07-01', 355, NULL),
('Hi-Way Inn', 196, '2019-07-02', 114, NULL),
('Hi-Way Inn', 196, '2019-07-03', 347, NULL),
('Hi-Way Inn', 196, '2019-07-04', 245, NULL),
('Hi-Way Inn', 196, '2019-07-05', 317, NULL),
('Hi-Way Inn', 196, '2019-07-06', 345, NULL),
('Hi-Way Inn', 196, '2019-07-07', 310, NULL),
('Hi-Way Inn', 196, '2019-07-08', 293, NULL),
('Hi-Way Inn', 196, '2019-07-09', 113, NULL),
('Hi-Way Inn', 196, '2019-07-10', 138, NULL),
('Hi-Way Inn', 196, '2019-07-11', 222, NULL),
('Hi-Way Inn', 196, '2019-07-12', 202, NULL),
('Hi-Way Inn', 196, '2019-07-13', 226, NULL),
('Hi-Way Inn', 196, '2019-07-14', 330, NULL),
('Hi-Way Inn', 196, '2019-07-15', 162, NULL),
('Hi-Way Inn', 196, '2019-07-16', 200, NULL),
('Hi-Way Inn', 196, '2019-07-17', 154, NULL),
('Hi-Way Inn', 196, '2019-07-18', 359, NULL),
('Hi-Way Inn', 196, '2019-07-19', 262, NULL),
('Hi-Way Inn', 196, '2019-07-20', 393, NULL),
('Hi-Way Inn', 196, '2019-07-21', 351, NULL),
('Hi-Way Inn', 196, '2019-07-22', 155, NULL),
('Hi-Way Inn', 196, '2019-07-23', 163, NULL),
('Hi-Way Inn', 196, '2019-07-24', 339, NULL),
('Hi-Way Inn', 196, '2019-07-25', 138, NULL),
('Hi-Way Inn', 196, '2019-07-26', 128, NULL),
('Hi-Way Inn', 196, '2019-07-27', 350, NULL),
('Hi-Way Inn', 196, '2019-07-28', 391, NULL),
('Hi-Way Inn', 196, '2019-07-29', 359, NULL),
('Hi-Way Inn', 196, '2019-07-30', 356, NULL),
('Hi-Way Inn', 196, '2019-07-31', 259, NULL),
('Hi-Way Inn', 196, '2019-08-01', 319, NULL),
('Hi-Way Inn', 196, '2019-08-02', 143, NULL),
('Hi-Way Inn', 196, '2019-08-03', 241, NULL),
('Hi-Way Inn', 196, '2019-08-04', 171, NULL),
('Hi-Way Inn', 196, '2019-08-05', 298, NULL),
('Hi-Way Inn', 196, '2019-08-06', 356, NULL),
('Hi-Way Inn', 196, '2019-08-07', 302, NULL),
('Hi-Way Inn', 196, '2019-08-08', 304, NULL),
('Hi-Way Inn', 196, '2019-08-09', 317, NULL),
('Hi-Way Inn', 196, '2019-08-10', 200, NULL),
('Hi-Way Inn', 196, '2019-08-11', 124, NULL),
('Hi-Way Inn', 196, '2019-08-12', 128, NULL),
('Hi-Way Inn', 196, '2019-08-13', 182, NULL),
('Hi-Way Inn', 196, '2019-08-14', 344, NULL),
('Hi-Way Inn', 196, '2019-08-15', 281, NULL),
('Hi-Way Inn', 196, '2019-08-16', 186, NULL),
('Hi-Way Inn', 196, '2019-08-17', 393, NULL),
('Hi-Way Inn', 196, '2019-08-18', 114, NULL),
('Hi-Way Inn', 196, '2019-08-19', 216, NULL),
('Hi-Way Inn', 196, '2019-08-20', 321, NULL),
('Hi-Way Inn', 196, '2019-08-21', 250, NULL),
('Hi-Way Inn', 196, '2019-08-22', 185, NULL),
('Hi-Way Inn', 196, '2019-08-23', 300, NULL),
('Hi-Way Inn', 196, '2019-08-24', 264, NULL),
('Hi-Way Inn', 196, '2019-08-25', 325, NULL),
('Hi-Way Inn', 196, '2019-08-26', 110, NULL),
('Hi-Way Inn', 196, '2019-08-27', 109, NULL),
('Hi-Way Inn', 196, '2019-08-28', 227, NULL),
('Hi-Way Inn', 196, '2019-08-29', 215, NULL),
('Hi-Way Inn', 196, '2019-08-30', 179, NULL),
('Hi-Way Inn', 196, '2019-08-31', 202, NULL),
('Hi-Way Inn', 196, '2019-09-01', 217, NULL),
('Hi-Way Inn', 196, '2019-09-02', 344, NULL),
('Hi-Way Inn', 196, '2019-09-03', 199, NULL),
('Hi-Way Inn', 196, '2019-09-04', 321, NULL),
('Hi-Way Inn', 196, '2019-09-05', 321, NULL),
('Hi-Way Inn', 196, '2019-09-06', 197, NULL),
('Hi-Way Inn', 196, '2019-09-07', 325, NULL),
('Hi-Way Inn', 196, '2019-09-08', 187, NULL),
('Hi-Way Inn', 196, '2019-09-09', 336, NULL),
('Hi-Way Inn', 196, '2019-09-10', 226, NULL),
('Hi-Way Inn', 196, '2019-09-11', 292, NULL),
('Hi-Way Inn', 196, '2019-09-12', 312, NULL),
('Hi-Way Inn', 196, '2019-09-13', 398, NULL),
('Hi-Way Inn', 196, '2019-09-14', 354, NULL),
('Hi-Way Inn', 196, '2019-09-15', 292, NULL),
('Hi-Way Inn', 196, '2019-09-16', 260, NULL),
('Hi-Way Inn', 196, '2019-09-17', 191, NULL),
('Hi-Way Inn', 196, '2019-09-18', 361, NULL),
('Hi-Way Inn', 196, '2019-09-19', 374, NULL),
('Hi-Way Inn', 196, '2019-09-20', 345, NULL),
('Hi-Way Inn', 196, '2019-09-21', 256, NULL),
('Hi-Way Inn', 196, '2019-09-22', 193, NULL),
('Hi-Way Inn', 196, '2019-09-23', 291, NULL),
('Hi-Way Inn', 196, '2019-09-24', 262, NULL),
('Hi-Way Inn', 196, '2019-09-25', 385, NULL),
('Hi-Way Inn', 196, '2019-09-26', 364, NULL),
('Hi-Way Inn', 196, '2019-09-27', 226, NULL),
('Hi-Way Inn', 196, '2019-09-28', 103, NULL),
('Hi-Way Inn', 196, '2019-09-29', 202, NULL),
('Hi-Way Inn', 196, '2019-09-30', 262, NULL),
('Hi-Way Inn', 196, '2019-10-01', 103, NULL),
('Hi-Way Inn', 196, '2019-10-02', 256, NULL),
('Hi-Way Inn', 196, '2019-10-03', 374, NULL),
('Hi-Way Inn', 196, '2019-10-04', 117, NULL),
('Hi-Way Inn', 196, '2019-10-05', 251, NULL),
('Hi-Way Inn', 196, '2019-10-06', 178, NULL),
('Hi-Way Inn', 196, '2019-10-07', 103, NULL),
('Hi-Way Inn', 196, '2019-10-08', 340, NULL),
('Hi-Way Inn', 196, '2019-10-09', 226, NULL),
('Hi-Way Inn', 196, '2019-10-10', 255, NULL),
('Hi-Way Inn', 196, '2019-10-11', 368, NULL),
('Hi-Way Inn', 196, '2019-10-12', 279, NULL),
('Hi-Way Inn', 196, '2019-10-13', 398, NULL),
('Hi-Way Inn', 196, '2019-10-14', 116, NULL),
('Hi-Way Inn', 196, '2019-10-15', 172, NULL),
('Hi-Way Inn', 196, '2019-10-16', 179, NULL),
('Hi-Way Inn', 196, '2019-10-17', 223, NULL),
('Hi-Way Inn', 196, '2019-10-18', 383, NULL),
('Hi-Way Inn', 196, '2019-10-19', 250, NULL),
('Hi-Way Inn', 196, '2019-10-20', 151, NULL),
('Hi-Way Inn', 196, '2019-10-21', 379, NULL),
('Hi-Way Inn', 196, '2019-10-22', 275, NULL),
('Hi-Way Inn', 196, '2019-10-23', 273, NULL),
('Hi-Way Inn', 196, '2019-10-24', 178, NULL),
('Hi-Way Inn', 196, '2019-10-25', 150, NULL),
('Hi-Way Inn', 196, '2019-10-26', 340, NULL),
('Hi-Way Inn', 196, '2019-10-27', 373, NULL),
('Hi-Way Inn', 196, '2019-10-28', 140, NULL),
('Hi-Way Inn', 196, '2019-10-29', 313, NULL),
('Hi-Way Inn', 196, '2019-10-30', 219, NULL),
('Hi-Way Inn', 196, '2019-10-31', 287, NULL),
('Hi-Way Inn', 196, '2019-11-01', 265, NULL),
('Hi-Way Inn', 196, '2019-11-02', 356, NULL),
('Hi-Way Inn', 196, '2019-11-03', 166, NULL),
('Hi-Way Inn', 196, '2019-11-04', 385, NULL),
('Hi-Way Inn', 196, '2019-11-05', 138, NULL),
('Hi-Way Inn', 196, '2019-11-06', 126, NULL),
('Hi-Way Inn', 196, '2019-11-07', 144, NULL),
('Hi-Way Inn', 196, '2019-11-08', 236, NULL),
('Hi-Way Inn', 196, '2019-11-09', 203, NULL),
('Hi-Way Inn', 196, '2019-11-10', 379, NULL),
('Hi-Way Inn', 196, '2019-11-11', 157, NULL),
('Hi-Way Inn', 196, '2019-11-12', 123, NULL),
('Hi-Way Inn', 196, '2019-11-13', 247, NULL),
('Hi-Way Inn', 196, '2019-11-14', 269, NULL),
('Hi-Way Inn', 196, '2019-11-15', 213, NULL),
('Hi-Way Inn', 196, '2019-11-16', 173, NULL),
('Hi-Way Inn', 196, '2019-11-17', 316, NULL),
('Hi-Way Inn', 196, '2019-11-18', 113, NULL),
('Hi-Way Inn', 196, '2019-11-19', 292, NULL),
('Hi-Way Inn', 196, '2019-11-20', 117, NULL),
('Hi-Way Inn', 196, '2019-11-21', 164, NULL),
('Hi-Way Inn', 196, '2019-11-22', 171, NULL),
('Hi-Way Inn', 196, '2019-11-23', 336, NULL),
('Hi-Way Inn', 196, '2019-11-24', 276, NULL),
('Hi-Way Inn', 196, '2019-11-25', 214, NULL),
('Hi-Way Inn', 196, '2019-11-26', 306, NULL),
('Hi-Way Inn', 196, '2019-11-27', 164, NULL),
('Hi-Way Inn', 196, '2019-11-28', 141, NULL),
('Hi-Way Inn', 196, '2019-11-29', 278, NULL),
('Hi-Way Inn', 196, '2019-11-30', 230, NULL),
('Hi-Way Inn', 196, '2019-12-01', 381, NULL),
('Hi-Way Inn', 196, '2019-12-02', 146, NULL),
('Hi-Way Inn', 196, '2019-12-03', 124, NULL),
('Hi-Way Inn', 196, '2019-12-04', 227, NULL),
('Hi-Way Inn', 196, '2019-12-05', 319, NULL),
('Hi-Way Inn', 196, '2019-12-06', 374, NULL),
('Hi-Way Inn', 196, '2019-12-07', 181, NULL),
('Hi-Way Inn', 196, '2019-12-08', 140, NULL),
('Hi-Way Inn', 196, '2019-12-09', 267, NULL),
('Hi-Way Inn', 196, '2019-12-10', 104, NULL),
('Hi-Way Inn', 196, '2019-12-11', 386, NULL),
('Hi-Way Inn', 196, '2019-12-12', 353, NULL),
('Hi-Way Inn', 196, '2019-12-13', 379, NULL),
('Hi-Way Inn', 196, '2019-12-14', 228, NULL),
('Hi-Way Inn', 196, '2019-12-15', 223, NULL),
('Hi-Way Inn', 196, '2019-12-16', 367, NULL),
('Hi-Way Inn', 196, '2019-12-17', 313, NULL),
('Hi-Way Inn', 196, '2019-12-18', 232, NULL),
('Hi-Way Inn', 196, '2019-12-19', 369, NULL),
('Hi-Way Inn', 196, '2019-12-20', 392, NULL),
('Hi-Way Inn', 196, '2019-12-21', 375, NULL),
('Hi-Way Inn', 196, '2019-12-22', 194, NULL),
('Hi-Way Inn', 196, '2019-12-23', 356, NULL),
('Hi-Way Inn', 196, '2019-12-24', 286, NULL),
('Hi-Way Inn', 196, '2019-12-25', 208, NULL),
('Hi-Way Inn', 196, '2019-12-26', 261, NULL),
('Hi-Way Inn', 196, '2019-12-27', 137, NULL),
('Hi-Way Inn', 196, '2019-12-28', 348, NULL),
('Hi-Way Inn', 196, '2019-12-29', 194, NULL),
('Hi-Way Inn', 196, '2019-12-30', 253, NULL),
('Hi-Way Inn', 196, '2019-12-31', 113, NULL),
('Hi-Way Inn', 196, '2020-01-01', 286, NULL),
('Hi-Way Inn', 196, '2020-01-02', 372, NULL),
('Hi-Way Inn', 196, '2020-01-03', 330, NULL),
('Hi-Way Inn', 196, '2020-01-04', 286, NULL),
('Hi-Way Inn', 196, '2020-01-05', 258, NULL),
('Hi-Way Inn', 196, '2020-01-06', 329, NULL),
('Hi-Way Inn', 196, '2020-01-07', 320, NULL),
('Hi-Way Inn', 196, '2020-01-08', 370, NULL),
('Hi-Way Inn', 196, '2020-01-09', 267, NULL),
('Hi-Way Inn', 196, '2020-01-10', 375, NULL),
('Hi-Way Inn', 196, '2020-01-11', 342, NULL),
('Hi-Way Inn', 196, '2020-01-12', 244, NULL),
('Hi-Way Inn', 196, '2020-01-13', 352, NULL),
('Hi-Way Inn', 196, '2020-01-14', 251, NULL),
('Hi-Way Inn', 196, '2020-01-15', 130, NULL),
('Hi-Way Inn', 196, '2020-01-16', 260, NULL),
('Hi-Way Inn', 196, '2020-01-17', 379, NULL),
('Hi-Way Inn', 196, '2020-01-18', 120, NULL),
('Hi-Way Inn', 196, '2020-01-19', 334, NULL),
('Hi-Way Inn', 196, '2020-01-20', 338, NULL),
('Hi-Way Inn', 196, '2020-01-21', 360, NULL),
('Hi-Way Inn', 196, '2020-01-22', 348, NULL),
('Hi-Way Inn', 196, '2020-01-23', 311, NULL),
('Hi-Way Inn', 196, '2020-01-24', 156, NULL),
('Hi-Way Inn', 196, '2020-01-25', 382, NULL),
('Hi-Way Inn', 196, '2020-01-26', 365, NULL),
('Hi-Way Inn', 196, '2020-01-27', 109, NULL),
('Hi-Way Inn', 196, '2020-01-28', 387, NULL),
('Hi-Way Inn', 196, '2020-01-29', 232, NULL),
('Hi-Way Inn', 196, '2020-01-30', 277, NULL),
('Hi-Way Inn', 196, '2020-01-31', 308, NULL),
('Hi-Way Inn', 196, '2020-02-01', 103, NULL),
('Hi-Way Inn', 196, '2020-02-02', 312, NULL),
('Hi-Way Inn', 196, '2020-02-03', 335, NULL),
('Hi-Way Inn', 196, '2020-02-04', 333, NULL),
('Hi-Way Inn', 197, '2019-01-01', 336, NULL),
('Hi-Way Inn', 197, '2019-01-02', 132, NULL),
('Hi-Way Inn', 197, '2019-01-03', 212, NULL),
('Hi-Way Inn', 197, '2019-01-04', 245, NULL),
('Hi-Way Inn', 197, '2019-01-05', 130, NULL),
('Hi-Way Inn', 197, '2019-01-06', 278, NULL),
('Hi-Way Inn', 197, '2019-01-07', 280, NULL),
('Hi-Way Inn', 197, '2019-01-08', 282, NULL),
('Hi-Way Inn', 197, '2019-01-09', 312, NULL),
('Hi-Way Inn', 197, '2019-01-10', 149, NULL),
('Hi-Way Inn', 197, '2019-01-11', 317, NULL),
('Hi-Way Inn', 197, '2019-01-12', 330, NULL),
('Hi-Way Inn', 197, '2019-01-13', 147, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 197, '2019-01-14', 221, NULL),
('Hi-Way Inn', 197, '2019-01-15', 129, NULL),
('Hi-Way Inn', 197, '2019-01-16', 198, NULL),
('Hi-Way Inn', 197, '2019-01-17', 126, NULL),
('Hi-Way Inn', 197, '2019-01-18', 160, NULL),
('Hi-Way Inn', 197, '2019-01-19', 307, NULL),
('Hi-Way Inn', 197, '2019-01-20', 290, NULL),
('Hi-Way Inn', 197, '2019-01-21', 158, NULL),
('Hi-Way Inn', 197, '2019-01-22', 377, NULL),
('Hi-Way Inn', 197, '2019-01-23', 290, NULL),
('Hi-Way Inn', 197, '2019-01-24', 260, NULL),
('Hi-Way Inn', 197, '2019-01-25', 253, NULL),
('Hi-Way Inn', 197, '2019-01-26', 312, NULL),
('Hi-Way Inn', 197, '2019-01-27', 390, NULL),
('Hi-Way Inn', 197, '2019-01-28', 282, NULL),
('Hi-Way Inn', 197, '2019-01-29', 105, NULL),
('Hi-Way Inn', 197, '2019-01-30', 272, NULL),
('Hi-Way Inn', 197, '2019-01-31', 350, NULL),
('Hi-Way Inn', 197, '2019-02-01', 194, NULL),
('Hi-Way Inn', 197, '2019-02-02', 391, NULL),
('Hi-Way Inn', 197, '2019-02-03', 323, NULL),
('Hi-Way Inn', 197, '2019-02-04', 366, NULL),
('Hi-Way Inn', 197, '2019-02-05', 359, NULL),
('Hi-Way Inn', 197, '2019-02-06', 321, NULL),
('Hi-Way Inn', 197, '2019-02-07', 390, NULL),
('Hi-Way Inn', 197, '2019-02-08', 330, NULL),
('Hi-Way Inn', 197, '2019-02-09', 127, NULL),
('Hi-Way Inn', 197, '2019-02-10', 179, NULL),
('Hi-Way Inn', 197, '2019-02-11', 119, NULL),
('Hi-Way Inn', 197, '2019-02-12', 135, NULL),
('Hi-Way Inn', 197, '2019-02-13', 354, NULL),
('Hi-Way Inn', 197, '2019-02-14', 116, NULL),
('Hi-Way Inn', 197, '2019-02-15', 330, NULL),
('Hi-Way Inn', 197, '2019-02-16', 197, NULL),
('Hi-Way Inn', 197, '2019-02-17', 394, NULL),
('Hi-Way Inn', 197, '2019-02-18', 393, NULL),
('Hi-Way Inn', 197, '2019-02-19', 319, NULL),
('Hi-Way Inn', 197, '2019-02-20', 204, NULL),
('Hi-Way Inn', 197, '2019-02-21', 242, NULL),
('Hi-Way Inn', 197, '2019-02-22', 379, NULL),
('Hi-Way Inn', 197, '2019-02-23', 221, NULL),
('Hi-Way Inn', 197, '2019-02-24', 348, NULL),
('Hi-Way Inn', 197, '2019-02-25', 147, NULL),
('Hi-Way Inn', 197, '2019-02-26', 385, NULL),
('Hi-Way Inn', 197, '2019-02-27', 399, NULL),
('Hi-Way Inn', 197, '2019-02-28', 255, NULL),
('Hi-Way Inn', 197, '2019-03-01', 204, NULL),
('Hi-Way Inn', 197, '2019-03-02', 358, NULL),
('Hi-Way Inn', 197, '2019-03-03', 279, NULL),
('Hi-Way Inn', 197, '2019-03-04', 158, NULL),
('Hi-Way Inn', 197, '2019-03-05', 111, NULL),
('Hi-Way Inn', 197, '2019-03-06', 237, NULL),
('Hi-Way Inn', 197, '2019-03-07', 261, NULL),
('Hi-Way Inn', 197, '2019-03-08', 399, NULL),
('Hi-Way Inn', 197, '2019-03-09', 230, NULL),
('Hi-Way Inn', 197, '2019-03-10', 377, NULL),
('Hi-Way Inn', 197, '2019-03-11', 254, NULL),
('Hi-Way Inn', 197, '2019-03-12', 132, NULL),
('Hi-Way Inn', 197, '2019-03-13', 219, NULL),
('Hi-Way Inn', 197, '2019-03-14', 226, NULL),
('Hi-Way Inn', 197, '2019-03-15', 309, NULL),
('Hi-Way Inn', 197, '2019-03-16', 339, NULL),
('Hi-Way Inn', 197, '2019-03-17', 372, NULL),
('Hi-Way Inn', 197, '2019-03-18', 156, NULL),
('Hi-Way Inn', 197, '2019-03-19', 107, NULL),
('Hi-Way Inn', 197, '2019-03-20', 241, NULL),
('Hi-Way Inn', 197, '2019-03-21', 365, NULL),
('Hi-Way Inn', 197, '2019-03-22', 378, NULL),
('Hi-Way Inn', 197, '2019-03-23', 328, NULL),
('Hi-Way Inn', 197, '2019-03-24', 289, NULL),
('Hi-Way Inn', 197, '2019-03-25', 277, NULL),
('Hi-Way Inn', 197, '2019-03-26', 178, NULL),
('Hi-Way Inn', 197, '2019-03-27', 398, NULL),
('Hi-Way Inn', 197, '2019-03-28', 192, NULL),
('Hi-Way Inn', 197, '2019-03-29', 305, NULL),
('Hi-Way Inn', 197, '2019-03-30', 247, NULL),
('Hi-Way Inn', 197, '2019-03-31', 166, NULL),
('Hi-Way Inn', 197, '2019-04-01', 319, NULL),
('Hi-Way Inn', 197, '2019-04-02', 178, NULL),
('Hi-Way Inn', 197, '2019-04-03', 366, NULL),
('Hi-Way Inn', 197, '2019-04-04', 282, NULL),
('Hi-Way Inn', 197, '2019-04-05', 389, NULL),
('Hi-Way Inn', 197, '2019-04-06', 129, NULL),
('Hi-Way Inn', 197, '2019-04-07', 308, NULL),
('Hi-Way Inn', 197, '2019-04-08', 152, NULL),
('Hi-Way Inn', 197, '2019-04-09', 116, NULL),
('Hi-Way Inn', 197, '2019-04-10', 161, NULL),
('Hi-Way Inn', 197, '2019-04-11', 315, NULL),
('Hi-Way Inn', 197, '2019-04-12', 231, NULL),
('Hi-Way Inn', 197, '2019-04-13', 106, NULL),
('Hi-Way Inn', 197, '2019-04-14', 292, NULL),
('Hi-Way Inn', 197, '2019-04-15', 294, NULL),
('Hi-Way Inn', 197, '2019-04-16', 246, NULL),
('Hi-Way Inn', 197, '2019-04-17', 271, NULL),
('Hi-Way Inn', 197, '2019-04-18', 385, NULL),
('Hi-Way Inn', 197, '2019-04-19', 381, NULL),
('Hi-Way Inn', 197, '2019-04-20', 368, NULL),
('Hi-Way Inn', 197, '2019-04-21', 378, NULL),
('Hi-Way Inn', 197, '2019-04-22', 250, NULL),
('Hi-Way Inn', 197, '2019-04-23', 235, NULL),
('Hi-Way Inn', 197, '2019-04-24', 310, NULL),
('Hi-Way Inn', 197, '2019-04-25', 157, NULL),
('Hi-Way Inn', 197, '2019-04-26', 173, NULL),
('Hi-Way Inn', 197, '2019-04-27', 319, NULL),
('Hi-Way Inn', 197, '2019-04-28', 348, NULL),
('Hi-Way Inn', 197, '2019-04-29', 257, NULL),
('Hi-Way Inn', 197, '2019-04-30', 121, NULL),
('Hi-Way Inn', 197, '2019-05-01', 169, NULL),
('Hi-Way Inn', 197, '2019-05-02', 263, NULL),
('Hi-Way Inn', 197, '2019-05-03', 199, NULL),
('Hi-Way Inn', 197, '2019-05-04', 365, NULL),
('Hi-Way Inn', 197, '2019-05-05', 102, NULL),
('Hi-Way Inn', 197, '2019-05-06', 329, NULL),
('Hi-Way Inn', 197, '2019-05-07', 189, NULL),
('Hi-Way Inn', 197, '2019-05-08', 122, NULL),
('Hi-Way Inn', 197, '2019-05-09', 139, NULL),
('Hi-Way Inn', 197, '2019-05-10', 283, NULL),
('Hi-Way Inn', 197, '2019-05-11', 291, NULL),
('Hi-Way Inn', 197, '2019-05-12', 288, NULL),
('Hi-Way Inn', 197, '2019-05-13', 390, NULL),
('Hi-Way Inn', 197, '2019-05-14', 287, NULL),
('Hi-Way Inn', 197, '2019-05-15', 227, NULL),
('Hi-Way Inn', 197, '2019-05-16', 283, NULL),
('Hi-Way Inn', 197, '2019-05-17', 291, NULL),
('Hi-Way Inn', 197, '2019-05-18', 131, NULL),
('Hi-Way Inn', 197, '2019-05-19', 107, NULL),
('Hi-Way Inn', 197, '2019-05-20', 232, NULL),
('Hi-Way Inn', 197, '2019-05-21', 110, NULL),
('Hi-Way Inn', 197, '2019-05-22', 143, NULL),
('Hi-Way Inn', 197, '2019-05-23', 297, NULL),
('Hi-Way Inn', 197, '2019-05-24', 364, NULL),
('Hi-Way Inn', 197, '2019-05-25', 152, NULL),
('Hi-Way Inn', 197, '2019-05-26', 187, NULL),
('Hi-Way Inn', 197, '2019-05-27', 129, NULL),
('Hi-Way Inn', 197, '2019-05-28', 373, NULL),
('Hi-Way Inn', 197, '2019-05-29', 149, NULL),
('Hi-Way Inn', 197, '2019-05-30', 231, NULL),
('Hi-Way Inn', 197, '2019-05-31', 116, NULL),
('Hi-Way Inn', 197, '2019-06-01', 326, NULL),
('Hi-Way Inn', 197, '2019-06-02', 272, NULL),
('Hi-Way Inn', 197, '2019-06-03', 164, NULL),
('Hi-Way Inn', 197, '2019-06-04', 132, NULL),
('Hi-Way Inn', 197, '2019-06-05', 293, NULL),
('Hi-Way Inn', 197, '2019-06-06', 302, NULL),
('Hi-Way Inn', 197, '2019-06-07', 372, NULL),
('Hi-Way Inn', 197, '2019-06-08', 276, NULL),
('Hi-Way Inn', 197, '2019-06-09', 285, NULL),
('Hi-Way Inn', 197, '2019-06-10', 327, NULL),
('Hi-Way Inn', 197, '2019-06-11', 136, NULL),
('Hi-Way Inn', 197, '2019-06-12', 115, NULL),
('Hi-Way Inn', 197, '2019-06-13', 163, NULL),
('Hi-Way Inn', 197, '2019-06-14', 277, NULL),
('Hi-Way Inn', 197, '2019-06-15', 169, NULL),
('Hi-Way Inn', 197, '2019-06-16', 232, NULL),
('Hi-Way Inn', 197, '2019-06-17', 343, NULL),
('Hi-Way Inn', 197, '2019-06-18', 151, NULL),
('Hi-Way Inn', 197, '2019-06-19', 221, NULL),
('Hi-Way Inn', 197, '2019-06-20', 257, NULL),
('Hi-Way Inn', 197, '2019-06-21', 250, NULL),
('Hi-Way Inn', 197, '2019-06-22', 381, NULL),
('Hi-Way Inn', 197, '2019-06-23', 393, NULL),
('Hi-Way Inn', 197, '2019-06-24', 214, NULL),
('Hi-Way Inn', 197, '2019-06-25', 316, NULL),
('Hi-Way Inn', 197, '2019-06-26', 331, NULL),
('Hi-Way Inn', 197, '2019-06-27', 145, NULL),
('Hi-Way Inn', 197, '2019-06-28', 188, NULL),
('Hi-Way Inn', 197, '2019-06-29', 260, NULL),
('Hi-Way Inn', 197, '2019-06-30', 313, NULL),
('Hi-Way Inn', 197, '2019-07-01', 230, NULL),
('Hi-Way Inn', 197, '2019-07-02', 259, NULL),
('Hi-Way Inn', 197, '2019-07-03', 396, NULL),
('Hi-Way Inn', 197, '2019-07-04', 279, NULL),
('Hi-Way Inn', 197, '2019-07-05', 343, NULL),
('Hi-Way Inn', 197, '2019-07-06', 397, NULL),
('Hi-Way Inn', 197, '2019-07-07', 398, NULL),
('Hi-Way Inn', 197, '2019-07-08', 262, NULL),
('Hi-Way Inn', 197, '2019-07-09', 371, NULL),
('Hi-Way Inn', 197, '2019-07-10', 227, NULL),
('Hi-Way Inn', 197, '2019-07-11', 172, NULL),
('Hi-Way Inn', 197, '2019-07-12', 104, NULL),
('Hi-Way Inn', 197, '2019-07-13', 393, NULL),
('Hi-Way Inn', 197, '2019-07-14', 348, NULL),
('Hi-Way Inn', 197, '2019-07-15', 127, NULL),
('Hi-Way Inn', 197, '2019-07-16', 190, NULL),
('Hi-Way Inn', 197, '2019-07-17', 247, NULL),
('Hi-Way Inn', 197, '2019-07-18', 256, NULL),
('Hi-Way Inn', 197, '2019-07-19', 308, NULL),
('Hi-Way Inn', 197, '2019-07-20', 162, NULL),
('Hi-Way Inn', 197, '2019-07-21', 258, NULL),
('Hi-Way Inn', 197, '2019-07-22', 182, NULL),
('Hi-Way Inn', 197, '2019-07-23', 131, NULL),
('Hi-Way Inn', 197, '2019-07-24', 183, NULL),
('Hi-Way Inn', 197, '2019-07-25', 375, NULL),
('Hi-Way Inn', 197, '2019-07-26', 160, NULL),
('Hi-Way Inn', 197, '2019-07-27', 146, NULL),
('Hi-Way Inn', 197, '2019-07-28', 324, NULL),
('Hi-Way Inn', 197, '2019-07-29', 244, NULL),
('Hi-Way Inn', 197, '2019-07-30', 223, NULL),
('Hi-Way Inn', 197, '2019-07-31', 290, NULL),
('Hi-Way Inn', 197, '2019-08-01', 349, NULL),
('Hi-Way Inn', 197, '2019-08-02', 230, NULL),
('Hi-Way Inn', 197, '2019-08-03', 322, NULL),
('Hi-Way Inn', 197, '2019-08-04', 201, NULL),
('Hi-Way Inn', 197, '2019-08-05', 188, NULL),
('Hi-Way Inn', 197, '2019-08-06', 105, NULL),
('Hi-Way Inn', 197, '2019-08-07', 319, NULL),
('Hi-Way Inn', 197, '2019-08-08', 226, NULL),
('Hi-Way Inn', 197, '2019-08-09', 233, NULL),
('Hi-Way Inn', 197, '2019-08-10', 268, NULL),
('Hi-Way Inn', 197, '2019-08-11', 332, NULL),
('Hi-Way Inn', 197, '2019-08-12', 391, NULL),
('Hi-Way Inn', 197, '2019-08-13', 239, NULL),
('Hi-Way Inn', 197, '2019-08-14', 260, NULL),
('Hi-Way Inn', 197, '2019-08-15', 232, NULL),
('Hi-Way Inn', 197, '2019-08-16', 161, NULL),
('Hi-Way Inn', 197, '2019-08-17', 253, NULL),
('Hi-Way Inn', 197, '2019-08-18', 139, NULL),
('Hi-Way Inn', 197, '2019-08-19', 241, NULL),
('Hi-Way Inn', 197, '2019-08-20', 366, NULL),
('Hi-Way Inn', 197, '2019-08-21', 299, NULL),
('Hi-Way Inn', 197, '2019-08-22', 353, NULL),
('Hi-Way Inn', 197, '2019-08-23', 186, NULL),
('Hi-Way Inn', 197, '2019-08-24', 166, NULL),
('Hi-Way Inn', 197, '2019-08-25', 183, NULL),
('Hi-Way Inn', 197, '2019-08-26', 310, NULL),
('Hi-Way Inn', 197, '2019-08-27', 203, NULL),
('Hi-Way Inn', 197, '2019-08-28', 325, NULL),
('Hi-Way Inn', 197, '2019-08-29', 128, NULL),
('Hi-Way Inn', 197, '2019-08-30', 293, NULL),
('Hi-Way Inn', 197, '2019-08-31', 371, NULL),
('Hi-Way Inn', 197, '2019-09-01', 378, NULL),
('Hi-Way Inn', 197, '2019-09-02', 152, NULL),
('Hi-Way Inn', 197, '2019-09-03', 296, NULL),
('Hi-Way Inn', 197, '2019-09-04', 165, NULL),
('Hi-Way Inn', 197, '2019-09-05', 275, NULL),
('Hi-Way Inn', 197, '2019-09-06', 342, NULL),
('Hi-Way Inn', 197, '2019-09-07', 214, NULL),
('Hi-Way Inn', 197, '2019-09-08', 165, NULL),
('Hi-Way Inn', 197, '2019-09-09', 377, NULL),
('Hi-Way Inn', 197, '2019-09-10', 274, NULL),
('Hi-Way Inn', 197, '2019-09-11', 263, NULL),
('Hi-Way Inn', 197, '2019-09-12', 390, NULL),
('Hi-Way Inn', 197, '2019-09-13', 155, NULL),
('Hi-Way Inn', 197, '2019-09-14', 244, NULL),
('Hi-Way Inn', 197, '2019-09-15', 204, NULL),
('Hi-Way Inn', 197, '2019-09-16', 334, NULL),
('Hi-Way Inn', 197, '2019-09-17', 323, NULL),
('Hi-Way Inn', 197, '2019-09-18', 169, NULL),
('Hi-Way Inn', 197, '2019-09-19', 381, NULL),
('Hi-Way Inn', 197, '2019-09-20', 222, NULL),
('Hi-Way Inn', 197, '2019-09-21', 329, NULL),
('Hi-Way Inn', 197, '2019-09-22', 131, NULL),
('Hi-Way Inn', 197, '2019-09-23', 325, NULL),
('Hi-Way Inn', 197, '2019-09-24', 179, NULL),
('Hi-Way Inn', 197, '2019-09-25', 249, NULL),
('Hi-Way Inn', 197, '2019-09-26', 296, NULL),
('Hi-Way Inn', 197, '2019-09-27', 110, NULL),
('Hi-Way Inn', 197, '2019-09-28', 338, NULL),
('Hi-Way Inn', 197, '2019-09-29', 143, NULL),
('Hi-Way Inn', 197, '2019-09-30', 267, NULL),
('Hi-Way Inn', 197, '2019-10-01', 133, NULL),
('Hi-Way Inn', 197, '2019-10-02', 166, NULL),
('Hi-Way Inn', 197, '2019-10-03', 305, NULL),
('Hi-Way Inn', 197, '2019-10-04', 227, NULL),
('Hi-Way Inn', 197, '2019-10-05', 158, NULL),
('Hi-Way Inn', 197, '2019-10-06', 191, NULL),
('Hi-Way Inn', 197, '2019-10-07', 227, NULL),
('Hi-Way Inn', 197, '2019-10-08', 353, NULL),
('Hi-Way Inn', 197, '2019-10-09', 332, NULL),
('Hi-Way Inn', 197, '2019-10-10', 342, NULL),
('Hi-Way Inn', 197, '2019-10-11', 218, NULL),
('Hi-Way Inn', 197, '2019-10-12', 104, NULL),
('Hi-Way Inn', 197, '2019-10-13', 340, NULL),
('Hi-Way Inn', 197, '2019-10-14', 342, NULL),
('Hi-Way Inn', 197, '2019-10-15', 165, NULL),
('Hi-Way Inn', 197, '2019-10-16', 246, NULL),
('Hi-Way Inn', 197, '2019-10-17', 372, NULL),
('Hi-Way Inn', 197, '2019-10-18', 195, NULL),
('Hi-Way Inn', 197, '2019-10-19', 299, NULL),
('Hi-Way Inn', 197, '2019-10-20', 159, NULL),
('Hi-Way Inn', 197, '2019-10-21', 148, NULL),
('Hi-Way Inn', 197, '2019-10-22', 193, NULL),
('Hi-Way Inn', 197, '2019-10-23', 272, NULL),
('Hi-Way Inn', 197, '2019-10-24', 284, NULL),
('Hi-Way Inn', 197, '2019-10-25', 256, NULL),
('Hi-Way Inn', 197, '2019-10-26', 369, NULL),
('Hi-Way Inn', 197, '2019-10-27', 322, NULL),
('Hi-Way Inn', 197, '2019-10-28', 238, NULL),
('Hi-Way Inn', 197, '2019-10-29', 376, NULL),
('Hi-Way Inn', 197, '2019-10-30', 116, NULL),
('Hi-Way Inn', 197, '2019-10-31', 353, NULL),
('Hi-Way Inn', 197, '2019-11-01', 288, NULL),
('Hi-Way Inn', 197, '2019-11-02', 200, NULL),
('Hi-Way Inn', 197, '2019-11-03', 242, NULL),
('Hi-Way Inn', 197, '2019-11-04', 260, NULL),
('Hi-Way Inn', 197, '2019-11-05', 371, NULL),
('Hi-Way Inn', 197, '2019-11-06', 176, NULL),
('Hi-Way Inn', 197, '2019-11-07', 270, NULL),
('Hi-Way Inn', 197, '2019-11-08', 146, NULL),
('Hi-Way Inn', 197, '2019-11-09', 123, NULL),
('Hi-Way Inn', 197, '2019-11-10', 345, NULL),
('Hi-Way Inn', 197, '2019-11-11', 394, NULL),
('Hi-Way Inn', 197, '2019-11-12', 292, NULL),
('Hi-Way Inn', 197, '2019-11-13', 151, NULL),
('Hi-Way Inn', 197, '2019-11-14', 258, NULL),
('Hi-Way Inn', 197, '2019-11-15', 347, NULL),
('Hi-Way Inn', 197, '2019-11-16', 103, NULL),
('Hi-Way Inn', 197, '2019-11-17', 246, NULL),
('Hi-Way Inn', 197, '2019-11-18', 107, NULL),
('Hi-Way Inn', 197, '2019-11-19', 302, NULL),
('Hi-Way Inn', 197, '2019-11-20', 109, NULL),
('Hi-Way Inn', 197, '2019-11-21', 338, NULL),
('Hi-Way Inn', 197, '2019-11-22', 160, NULL),
('Hi-Way Inn', 197, '2019-11-23', 127, NULL),
('Hi-Way Inn', 197, '2019-11-24', 382, NULL),
('Hi-Way Inn', 197, '2019-11-25', 336, NULL),
('Hi-Way Inn', 197, '2019-11-26', 187, NULL),
('Hi-Way Inn', 197, '2019-11-27', 169, NULL),
('Hi-Way Inn', 197, '2019-11-28', 105, NULL),
('Hi-Way Inn', 197, '2019-11-29', 138, NULL),
('Hi-Way Inn', 197, '2019-11-30', 218, NULL),
('Hi-Way Inn', 197, '2019-12-01', 162, NULL),
('Hi-Way Inn', 197, '2019-12-02', 277, NULL),
('Hi-Way Inn', 197, '2019-12-03', 221, NULL),
('Hi-Way Inn', 197, '2019-12-04', 142, NULL),
('Hi-Way Inn', 197, '2019-12-05', 278, NULL),
('Hi-Way Inn', 197, '2019-12-06', 327, NULL),
('Hi-Way Inn', 197, '2019-12-07', 394, NULL),
('Hi-Way Inn', 197, '2019-12-08', 300, NULL),
('Hi-Way Inn', 197, '2019-12-09', 323, NULL),
('Hi-Way Inn', 197, '2019-12-10', 104, NULL),
('Hi-Way Inn', 197, '2019-12-11', 108, NULL),
('Hi-Way Inn', 197, '2019-12-12', 138, NULL),
('Hi-Way Inn', 197, '2019-12-13', 260, NULL),
('Hi-Way Inn', 197, '2019-12-14', 267, NULL),
('Hi-Way Inn', 197, '2019-12-15', 202, NULL),
('Hi-Way Inn', 197, '2019-12-16', 314, NULL),
('Hi-Way Inn', 197, '2019-12-17', 288, NULL),
('Hi-Way Inn', 197, '2019-12-18', 347, NULL),
('Hi-Way Inn', 197, '2019-12-19', 224, NULL),
('Hi-Way Inn', 197, '2019-12-20', 313, NULL),
('Hi-Way Inn', 197, '2019-12-21', 326, NULL),
('Hi-Way Inn', 197, '2019-12-22', 160, NULL),
('Hi-Way Inn', 197, '2019-12-23', 222, NULL),
('Hi-Way Inn', 197, '2019-12-24', 146, NULL),
('Hi-Way Inn', 197, '2019-12-25', 121, NULL),
('Hi-Way Inn', 197, '2019-12-26', 328, NULL),
('Hi-Way Inn', 197, '2019-12-27', 211, NULL),
('Hi-Way Inn', 197, '2019-12-28', 319, NULL),
('Hi-Way Inn', 197, '2019-12-29', 289, NULL),
('Hi-Way Inn', 197, '2019-12-30', 289, NULL),
('Hi-Way Inn', 197, '2019-12-31', 280, NULL),
('Hi-Way Inn', 197, '2020-01-01', 317, NULL),
('Hi-Way Inn', 197, '2020-01-02', 119, NULL),
('Hi-Way Inn', 197, '2020-01-03', 258, NULL),
('Hi-Way Inn', 197, '2020-01-04', 387, NULL),
('Hi-Way Inn', 197, '2020-01-05', 379, NULL),
('Hi-Way Inn', 197, '2020-01-06', 292, NULL),
('Hi-Way Inn', 197, '2020-01-07', 352, NULL),
('Hi-Way Inn', 197, '2020-01-08', 373, NULL),
('Hi-Way Inn', 197, '2020-01-09', 120, NULL),
('Hi-Way Inn', 197, '2020-01-10', 203, NULL),
('Hi-Way Inn', 197, '2020-01-11', 207, NULL),
('Hi-Way Inn', 197, '2020-01-12', 315, NULL),
('Hi-Way Inn', 197, '2020-01-13', 381, NULL),
('Hi-Way Inn', 197, '2020-01-14', 153, NULL),
('Hi-Way Inn', 197, '2020-01-15', 196, NULL),
('Hi-Way Inn', 197, '2020-01-16', 209, NULL),
('Hi-Way Inn', 197, '2020-01-17', 376, NULL),
('Hi-Way Inn', 197, '2020-01-18', 129, NULL),
('Hi-Way Inn', 197, '2020-01-19', 255, NULL),
('Hi-Way Inn', 197, '2020-01-20', 257, NULL),
('Hi-Way Inn', 197, '2020-01-21', 378, NULL),
('Hi-Way Inn', 197, '2020-01-22', 295, NULL),
('Hi-Way Inn', 197, '2020-01-23', 232, NULL),
('Hi-Way Inn', 197, '2020-01-24', 248, NULL),
('Hi-Way Inn', 197, '2020-01-25', 285, NULL),
('Hi-Way Inn', 197, '2020-01-26', 252, NULL),
('Hi-Way Inn', 197, '2020-01-27', 165, NULL),
('Hi-Way Inn', 197, '2020-01-28', 326, NULL),
('Hi-Way Inn', 197, '2020-01-29', 304, NULL),
('Hi-Way Inn', 197, '2020-01-30', 179, NULL),
('Hi-Way Inn', 197, '2020-01-31', 396, NULL),
('Hi-Way Inn', 197, '2020-02-01', 279, NULL),
('Hi-Way Inn', 197, '2020-02-02', 282, NULL),
('Hi-Way Inn', 197, '2020-02-03', 206, NULL),
('Hi-Way Inn', 197, '2020-02-04', 393, NULL),
('Hi-Way Inn', 208, '2019-01-01', 384, NULL),
('Hi-Way Inn', 208, '2019-01-02', 215, NULL),
('Hi-Way Inn', 208, '2019-01-03', 156, NULL),
('Hi-Way Inn', 208, '2019-01-04', 116, NULL),
('Hi-Way Inn', 208, '2019-01-05', 398, NULL),
('Hi-Way Inn', 208, '2019-01-06', 357, NULL),
('Hi-Way Inn', 208, '2019-01-07', 352, NULL),
('Hi-Way Inn', 208, '2019-01-08', 374, NULL),
('Hi-Way Inn', 208, '2019-01-09', 373, NULL),
('Hi-Way Inn', 208, '2019-01-10', 323, NULL),
('Hi-Way Inn', 208, '2019-01-11', 226, NULL),
('Hi-Way Inn', 208, '2019-01-12', 162, NULL),
('Hi-Way Inn', 208, '2019-01-13', 285, NULL),
('Hi-Way Inn', 208, '2019-01-14', 372, NULL),
('Hi-Way Inn', 208, '2019-01-15', 240, NULL),
('Hi-Way Inn', 208, '2019-01-16', 343, NULL),
('Hi-Way Inn', 208, '2019-01-17', 372, NULL),
('Hi-Way Inn', 208, '2019-01-18', 143, NULL),
('Hi-Way Inn', 208, '2019-01-19', 372, NULL),
('Hi-Way Inn', 208, '2019-01-20', 251, NULL),
('Hi-Way Inn', 208, '2019-01-21', 332, NULL),
('Hi-Way Inn', 208, '2019-01-22', 361, NULL),
('Hi-Way Inn', 208, '2019-01-23', 318, NULL),
('Hi-Way Inn', 208, '2019-01-24', 240, NULL),
('Hi-Way Inn', 208, '2019-01-25', 328, NULL),
('Hi-Way Inn', 208, '2019-01-26', 311, NULL),
('Hi-Way Inn', 208, '2019-01-27', 363, NULL),
('Hi-Way Inn', 208, '2019-01-28', 105, NULL),
('Hi-Way Inn', 208, '2019-01-29', 319, NULL),
('Hi-Way Inn', 208, '2019-01-30', 338, NULL),
('Hi-Way Inn', 208, '2019-01-31', 340, NULL),
('Hi-Way Inn', 208, '2019-02-01', 107, NULL),
('Hi-Way Inn', 208, '2019-02-02', 205, NULL),
('Hi-Way Inn', 208, '2019-02-03', 307, NULL),
('Hi-Way Inn', 208, '2019-02-04', 199, NULL),
('Hi-Way Inn', 208, '2019-02-05', 353, NULL),
('Hi-Way Inn', 208, '2019-02-06', 364, NULL),
('Hi-Way Inn', 208, '2019-02-07', 383, NULL),
('Hi-Way Inn', 208, '2019-02-08', 385, NULL),
('Hi-Way Inn', 208, '2019-02-09', 152, NULL),
('Hi-Way Inn', 208, '2019-02-10', 169, NULL),
('Hi-Way Inn', 208, '2019-02-11', 278, NULL),
('Hi-Way Inn', 208, '2019-02-12', 263, NULL),
('Hi-Way Inn', 208, '2019-02-13', 379, NULL),
('Hi-Way Inn', 208, '2019-02-14', 269, NULL),
('Hi-Way Inn', 208, '2019-02-15', 128, NULL),
('Hi-Way Inn', 208, '2019-02-16', 250, NULL),
('Hi-Way Inn', 208, '2019-02-17', 397, NULL),
('Hi-Way Inn', 208, '2019-02-18', 296, NULL),
('Hi-Way Inn', 208, '2019-02-19', 349, NULL),
('Hi-Way Inn', 208, '2019-02-20', 344, NULL),
('Hi-Way Inn', 208, '2019-02-21', 222, NULL),
('Hi-Way Inn', 208, '2019-02-22', 225, NULL),
('Hi-Way Inn', 208, '2019-02-23', 149, NULL),
('Hi-Way Inn', 208, '2019-02-24', 307, NULL),
('Hi-Way Inn', 208, '2019-02-25', 317, NULL),
('Hi-Way Inn', 208, '2019-02-26', 136, NULL),
('Hi-Way Inn', 208, '2019-02-27', 358, NULL),
('Hi-Way Inn', 208, '2019-02-28', 396, NULL),
('Hi-Way Inn', 208, '2019-03-01', 281, NULL),
('Hi-Way Inn', 208, '2019-03-02', 249, NULL),
('Hi-Way Inn', 208, '2019-03-03', 333, NULL),
('Hi-Way Inn', 208, '2019-03-04', 157, NULL),
('Hi-Way Inn', 208, '2019-03-05', 389, NULL),
('Hi-Way Inn', 208, '2019-03-06', 302, NULL),
('Hi-Way Inn', 208, '2019-03-07', 395, NULL),
('Hi-Way Inn', 208, '2019-03-08', 173, NULL),
('Hi-Way Inn', 208, '2019-03-09', 190, NULL),
('Hi-Way Inn', 208, '2019-03-10', 322, NULL),
('Hi-Way Inn', 208, '2019-03-11', 399, NULL),
('Hi-Way Inn', 208, '2019-03-12', 310, NULL),
('Hi-Way Inn', 208, '2019-03-13', 214, NULL),
('Hi-Way Inn', 208, '2019-03-14', 393, NULL),
('Hi-Way Inn', 208, '2019-03-15', 134, NULL),
('Hi-Way Inn', 208, '2019-03-16', 284, NULL),
('Hi-Way Inn', 208, '2019-03-17', 192, NULL),
('Hi-Way Inn', 208, '2019-03-18', 395, NULL),
('Hi-Way Inn', 208, '2019-03-19', 249, NULL),
('Hi-Way Inn', 208, '2019-03-20', 187, NULL),
('Hi-Way Inn', 208, '2019-03-21', 247, NULL),
('Hi-Way Inn', 208, '2019-03-22', 101, NULL),
('Hi-Way Inn', 208, '2019-03-23', 198, NULL),
('Hi-Way Inn', 208, '2019-03-24', 334, NULL),
('Hi-Way Inn', 208, '2019-03-25', 132, NULL),
('Hi-Way Inn', 208, '2019-03-26', 334, NULL),
('Hi-Way Inn', 208, '2019-03-27', 215, NULL),
('Hi-Way Inn', 208, '2019-03-28', 235, NULL),
('Hi-Way Inn', 208, '2019-03-29', 183, NULL),
('Hi-Way Inn', 208, '2019-03-30', 289, NULL),
('Hi-Way Inn', 208, '2019-03-31', 231, NULL),
('Hi-Way Inn', 208, '2019-04-01', 234, NULL),
('Hi-Way Inn', 208, '2019-04-02', 313, NULL),
('Hi-Way Inn', 208, '2019-04-03', 160, NULL),
('Hi-Way Inn', 208, '2019-04-04', 362, NULL),
('Hi-Way Inn', 208, '2019-04-05', 262, NULL),
('Hi-Way Inn', 208, '2019-04-06', 271, NULL),
('Hi-Way Inn', 208, '2019-04-07', 101, NULL),
('Hi-Way Inn', 208, '2019-04-08', 325, NULL),
('Hi-Way Inn', 208, '2019-04-09', 116, NULL),
('Hi-Way Inn', 208, '2019-04-10', 304, NULL),
('Hi-Way Inn', 208, '2019-04-11', 235, NULL),
('Hi-Way Inn', 208, '2019-04-12', 340, NULL),
('Hi-Way Inn', 208, '2019-04-13', 392, NULL),
('Hi-Way Inn', 208, '2019-04-14', 392, NULL),
('Hi-Way Inn', 208, '2019-04-15', 399, NULL),
('Hi-Way Inn', 208, '2019-04-16', 234, NULL),
('Hi-Way Inn', 208, '2019-04-17', 273, NULL),
('Hi-Way Inn', 208, '2019-04-18', 149, NULL),
('Hi-Way Inn', 208, '2019-04-19', 370, NULL),
('Hi-Way Inn', 208, '2019-04-20', 112, NULL),
('Hi-Way Inn', 208, '2019-04-21', 281, NULL),
('Hi-Way Inn', 208, '2019-04-22', 379, NULL),
('Hi-Way Inn', 208, '2019-04-23', 129, NULL),
('Hi-Way Inn', 208, '2019-04-24', 147, NULL),
('Hi-Way Inn', 208, '2019-04-25', 286, NULL),
('Hi-Way Inn', 208, '2019-04-26', 152, NULL),
('Hi-Way Inn', 208, '2019-04-27', 330, NULL),
('Hi-Way Inn', 208, '2019-04-28', 159, NULL),
('Hi-Way Inn', 208, '2019-04-29', 362, NULL),
('Hi-Way Inn', 208, '2019-04-30', 261, NULL),
('Hi-Way Inn', 208, '2019-05-01', 200, NULL),
('Hi-Way Inn', 208, '2019-05-02', 168, NULL),
('Hi-Way Inn', 208, '2019-05-03', 225, NULL),
('Hi-Way Inn', 208, '2019-05-04', 210, NULL),
('Hi-Way Inn', 208, '2019-05-05', 109, NULL),
('Hi-Way Inn', 208, '2019-05-06', 247, NULL),
('Hi-Way Inn', 208, '2019-05-07', 398, NULL),
('Hi-Way Inn', 208, '2019-05-08', 117, NULL),
('Hi-Way Inn', 208, '2019-05-09', 295, NULL),
('Hi-Way Inn', 208, '2019-05-10', 179, NULL),
('Hi-Way Inn', 208, '2019-05-11', 175, NULL),
('Hi-Way Inn', 208, '2019-05-12', 180, NULL),
('Hi-Way Inn', 208, '2019-05-13', 270, NULL),
('Hi-Way Inn', 208, '2019-05-14', 236, NULL),
('Hi-Way Inn', 208, '2019-05-15', 132, NULL),
('Hi-Way Inn', 208, '2019-05-16', 288, NULL),
('Hi-Way Inn', 208, '2019-05-17', 258, NULL),
('Hi-Way Inn', 208, '2019-05-18', 102, NULL),
('Hi-Way Inn', 208, '2019-05-19', 383, NULL),
('Hi-Way Inn', 208, '2019-05-20', 337, NULL),
('Hi-Way Inn', 208, '2019-05-21', 323, NULL),
('Hi-Way Inn', 208, '2019-05-22', 176, NULL),
('Hi-Way Inn', 208, '2019-05-23', 297, NULL),
('Hi-Way Inn', 208, '2019-05-24', 305, NULL),
('Hi-Way Inn', 208, '2019-05-25', 357, NULL),
('Hi-Way Inn', 208, '2019-05-26', 105, NULL),
('Hi-Way Inn', 208, '2019-05-27', 241, NULL),
('Hi-Way Inn', 208, '2019-05-28', 101, NULL),
('Hi-Way Inn', 208, '2019-05-29', 388, NULL),
('Hi-Way Inn', 208, '2019-05-30', 355, NULL),
('Hi-Way Inn', 208, '2019-05-31', 199, NULL),
('Hi-Way Inn', 208, '2019-06-01', 245, NULL),
('Hi-Way Inn', 208, '2019-06-02', 214, NULL),
('Hi-Way Inn', 208, '2019-06-03', 394, NULL),
('Hi-Way Inn', 208, '2019-06-04', 227, NULL),
('Hi-Way Inn', 208, '2019-06-05', 281, NULL),
('Hi-Way Inn', 208, '2019-06-06', 340, NULL),
('Hi-Way Inn', 208, '2019-06-07', 209, NULL),
('Hi-Way Inn', 208, '2019-06-08', 126, NULL),
('Hi-Way Inn', 208, '2019-06-09', 143, NULL),
('Hi-Way Inn', 208, '2019-06-10', 316, NULL),
('Hi-Way Inn', 208, '2019-06-11', 268, NULL),
('Hi-Way Inn', 208, '2019-06-12', 247, NULL),
('Hi-Way Inn', 208, '2019-06-13', 332, NULL),
('Hi-Way Inn', 208, '2019-06-14', 337, NULL),
('Hi-Way Inn', 208, '2019-06-15', 168, NULL),
('Hi-Way Inn', 208, '2019-06-16', 386, NULL),
('Hi-Way Inn', 208, '2019-06-17', 281, NULL),
('Hi-Way Inn', 208, '2019-06-18', 278, NULL),
('Hi-Way Inn', 208, '2019-06-19', 358, NULL),
('Hi-Way Inn', 208, '2019-06-20', 383, NULL),
('Hi-Way Inn', 208, '2019-06-21', 186, NULL),
('Hi-Way Inn', 208, '2019-06-22', 352, NULL),
('Hi-Way Inn', 208, '2019-06-23', 399, NULL),
('Hi-Way Inn', 208, '2019-06-24', 285, NULL),
('Hi-Way Inn', 208, '2019-06-25', 315, NULL),
('Hi-Way Inn', 208, '2019-06-26', 267, NULL),
('Hi-Way Inn', 208, '2019-06-27', 356, NULL),
('Hi-Way Inn', 208, '2019-06-28', 187, NULL),
('Hi-Way Inn', 208, '2019-06-29', 212, NULL),
('Hi-Way Inn', 208, '2019-06-30', 325, NULL),
('Hi-Way Inn', 208, '2019-07-01', 286, NULL),
('Hi-Way Inn', 208, '2019-07-02', 256, NULL),
('Hi-Way Inn', 208, '2019-07-03', 241, NULL),
('Hi-Way Inn', 208, '2019-07-04', 261, NULL),
('Hi-Way Inn', 208, '2019-07-05', 366, NULL),
('Hi-Way Inn', 208, '2019-07-06', 251, NULL),
('Hi-Way Inn', 208, '2019-07-07', 360, NULL),
('Hi-Way Inn', 208, '2019-07-08', 331, NULL),
('Hi-Way Inn', 208, '2019-07-09', 214, NULL),
('Hi-Way Inn', 208, '2019-07-10', 324, NULL),
('Hi-Way Inn', 208, '2019-07-11', 395, NULL),
('Hi-Way Inn', 208, '2019-07-12', 114, NULL),
('Hi-Way Inn', 208, '2019-07-13', 289, NULL),
('Hi-Way Inn', 208, '2019-07-14', 354, NULL),
('Hi-Way Inn', 208, '2019-07-15', 349, NULL),
('Hi-Way Inn', 208, '2019-07-16', 249, NULL),
('Hi-Way Inn', 208, '2019-07-17', 374, NULL),
('Hi-Way Inn', 208, '2019-07-18', 102, NULL),
('Hi-Way Inn', 208, '2019-07-19', 356, NULL),
('Hi-Way Inn', 208, '2019-07-20', 131, NULL),
('Hi-Way Inn', 208, '2019-07-21', 137, NULL),
('Hi-Way Inn', 208, '2019-07-22', 348, NULL),
('Hi-Way Inn', 208, '2019-07-23', 364, NULL),
('Hi-Way Inn', 208, '2019-07-24', 100, NULL),
('Hi-Way Inn', 208, '2019-07-25', 161, NULL),
('Hi-Way Inn', 208, '2019-07-26', 314, NULL),
('Hi-Way Inn', 208, '2019-07-27', 180, NULL),
('Hi-Way Inn', 208, '2019-07-28', 345, NULL),
('Hi-Way Inn', 208, '2019-07-29', 345, NULL),
('Hi-Way Inn', 208, '2019-07-30', 248, NULL),
('Hi-Way Inn', 208, '2019-07-31', 274, NULL),
('Hi-Way Inn', 208, '2019-08-01', 389, NULL),
('Hi-Way Inn', 208, '2019-08-02', 323, NULL),
('Hi-Way Inn', 208, '2019-08-03', 188, NULL),
('Hi-Way Inn', 208, '2019-08-04', 395, NULL),
('Hi-Way Inn', 208, '2019-08-05', 247, NULL),
('Hi-Way Inn', 208, '2019-08-06', 260, NULL),
('Hi-Way Inn', 208, '2019-08-07', 291, NULL),
('Hi-Way Inn', 208, '2019-08-08', 117, NULL),
('Hi-Way Inn', 208, '2019-08-09', 116, NULL),
('Hi-Way Inn', 208, '2019-08-10', 342, NULL),
('Hi-Way Inn', 208, '2019-08-11', 286, NULL),
('Hi-Way Inn', 208, '2019-08-12', 274, NULL),
('Hi-Way Inn', 208, '2019-08-13', 249, NULL),
('Hi-Way Inn', 208, '2019-08-14', 167, NULL),
('Hi-Way Inn', 208, '2019-08-15', 218, NULL),
('Hi-Way Inn', 208, '2019-08-16', 147, NULL),
('Hi-Way Inn', 208, '2019-08-17', 288, NULL),
('Hi-Way Inn', 208, '2019-08-18', 254, NULL),
('Hi-Way Inn', 208, '2019-08-19', 155, NULL),
('Hi-Way Inn', 208, '2019-08-20', 167, NULL),
('Hi-Way Inn', 208, '2019-08-21', 345, NULL),
('Hi-Way Inn', 208, '2019-08-22', 213, NULL),
('Hi-Way Inn', 208, '2019-08-23', 232, NULL),
('Hi-Way Inn', 208, '2019-08-24', 240, NULL),
('Hi-Way Inn', 208, '2019-08-25', 141, NULL),
('Hi-Way Inn', 208, '2019-08-26', 221, NULL),
('Hi-Way Inn', 208, '2019-08-27', 288, NULL),
('Hi-Way Inn', 208, '2019-08-28', 242, NULL),
('Hi-Way Inn', 208, '2019-08-29', 196, NULL),
('Hi-Way Inn', 208, '2019-08-30', 228, NULL),
('Hi-Way Inn', 208, '2019-08-31', 250, NULL),
('Hi-Way Inn', 208, '2019-09-01', 240, NULL),
('Hi-Way Inn', 208, '2019-09-02', 232, NULL),
('Hi-Way Inn', 208, '2019-09-03', 182, NULL),
('Hi-Way Inn', 208, '2019-09-04', 360, NULL),
('Hi-Way Inn', 208, '2019-09-05', 315, NULL),
('Hi-Way Inn', 208, '2019-09-06', 117, NULL),
('Hi-Way Inn', 208, '2019-09-07', 298, NULL),
('Hi-Way Inn', 208, '2019-09-08', 162, NULL),
('Hi-Way Inn', 208, '2019-09-09', 178, NULL),
('Hi-Way Inn', 208, '2019-09-10', 291, NULL),
('Hi-Way Inn', 208, '2019-09-11', 340, NULL),
('Hi-Way Inn', 208, '2019-09-12', 314, NULL),
('Hi-Way Inn', 208, '2019-09-13', 383, NULL),
('Hi-Way Inn', 208, '2019-09-14', 356, NULL),
('Hi-Way Inn', 208, '2019-09-15', 345, NULL),
('Hi-Way Inn', 208, '2019-09-16', 188, NULL),
('Hi-Way Inn', 208, '2019-09-17', 344, NULL),
('Hi-Way Inn', 208, '2019-09-18', 265, NULL),
('Hi-Way Inn', 208, '2019-09-19', 386, NULL),
('Hi-Way Inn', 208, '2019-09-20', 275, NULL),
('Hi-Way Inn', 208, '2019-09-21', 176, NULL),
('Hi-Way Inn', 208, '2019-09-22', 277, NULL),
('Hi-Way Inn', 208, '2019-09-23', 355, NULL),
('Hi-Way Inn', 208, '2019-09-24', 313, NULL),
('Hi-Way Inn', 208, '2019-09-25', 293, NULL),
('Hi-Way Inn', 208, '2019-09-26', 290, NULL),
('Hi-Way Inn', 208, '2019-09-27', 374, NULL),
('Hi-Way Inn', 208, '2019-09-28', 385, NULL),
('Hi-Way Inn', 208, '2019-09-29', 309, NULL),
('Hi-Way Inn', 208, '2019-09-30', 149, NULL),
('Hi-Way Inn', 208, '2019-10-01', 257, NULL),
('Hi-Way Inn', 208, '2019-10-02', 264, NULL),
('Hi-Way Inn', 208, '2019-10-03', 303, NULL),
('Hi-Way Inn', 208, '2019-10-04', 384, NULL),
('Hi-Way Inn', 208, '2019-10-05', 236, NULL),
('Hi-Way Inn', 208, '2019-10-06', 319, NULL),
('Hi-Way Inn', 208, '2019-10-07', 126, NULL),
('Hi-Way Inn', 208, '2019-10-08', 345, NULL),
('Hi-Way Inn', 208, '2019-10-09', 283, NULL),
('Hi-Way Inn', 208, '2019-10-10', 246, NULL),
('Hi-Way Inn', 208, '2019-10-11', 186, NULL),
('Hi-Way Inn', 208, '2019-10-12', 183, NULL),
('Hi-Way Inn', 208, '2019-10-13', 105, NULL),
('Hi-Way Inn', 208, '2019-10-14', 361, NULL),
('Hi-Way Inn', 208, '2019-10-15', 210, NULL),
('Hi-Way Inn', 208, '2019-10-16', 293, NULL),
('Hi-Way Inn', 208, '2019-10-17', 194, NULL),
('Hi-Way Inn', 208, '2019-10-18', 325, NULL),
('Hi-Way Inn', 208, '2019-10-19', 345, NULL),
('Hi-Way Inn', 208, '2019-10-20', 242, NULL),
('Hi-Way Inn', 208, '2019-10-21', 103, NULL),
('Hi-Way Inn', 208, '2019-10-22', 341, NULL),
('Hi-Way Inn', 208, '2019-10-23', 143, NULL),
('Hi-Way Inn', 208, '2019-10-24', 188, NULL),
('Hi-Way Inn', 208, '2019-10-25', 129, NULL),
('Hi-Way Inn', 208, '2019-10-26', 124, NULL),
('Hi-Way Inn', 208, '2019-10-27', 391, NULL),
('Hi-Way Inn', 208, '2019-10-28', 368, NULL),
('Hi-Way Inn', 208, '2019-10-29', 241, NULL),
('Hi-Way Inn', 208, '2019-10-30', 124, NULL),
('Hi-Way Inn', 208, '2019-10-31', 204, NULL),
('Hi-Way Inn', 208, '2019-11-01', 247, NULL),
('Hi-Way Inn', 208, '2019-11-02', 133, NULL),
('Hi-Way Inn', 208, '2019-11-03', 314, NULL),
('Hi-Way Inn', 208, '2019-11-04', 346, NULL),
('Hi-Way Inn', 208, '2019-11-05', 139, NULL),
('Hi-Way Inn', 208, '2019-11-06', 100, NULL),
('Hi-Way Inn', 208, '2019-11-07', 220, NULL),
('Hi-Way Inn', 208, '2019-11-08', 224, NULL),
('Hi-Way Inn', 208, '2019-11-09', 206, NULL),
('Hi-Way Inn', 208, '2019-11-10', 186, NULL),
('Hi-Way Inn', 208, '2019-11-11', 202, NULL),
('Hi-Way Inn', 208, '2019-11-12', 390, NULL),
('Hi-Way Inn', 208, '2019-11-13', 216, NULL),
('Hi-Way Inn', 208, '2019-11-14', 385, NULL),
('Hi-Way Inn', 208, '2019-11-15', 397, NULL),
('Hi-Way Inn', 208, '2019-11-16', 200, NULL),
('Hi-Way Inn', 208, '2019-11-17', 183, NULL),
('Hi-Way Inn', 208, '2019-11-18', 397, NULL),
('Hi-Way Inn', 208, '2019-11-19', 237, NULL),
('Hi-Way Inn', 208, '2019-11-20', 395, NULL),
('Hi-Way Inn', 208, '2019-11-21', 201, NULL),
('Hi-Way Inn', 208, '2019-11-22', 187, NULL),
('Hi-Way Inn', 208, '2019-11-23', 125, NULL),
('Hi-Way Inn', 208, '2019-11-24', 383, NULL),
('Hi-Way Inn', 208, '2019-11-25', 340, NULL),
('Hi-Way Inn', 208, '2019-11-26', 216, NULL),
('Hi-Way Inn', 208, '2019-11-27', 253, NULL),
('Hi-Way Inn', 208, '2019-11-28', 304, NULL),
('Hi-Way Inn', 208, '2019-11-29', 357, NULL),
('Hi-Way Inn', 208, '2019-11-30', 303, NULL),
('Hi-Way Inn', 208, '2019-12-01', 171, NULL),
('Hi-Way Inn', 208, '2019-12-02', 249, NULL),
('Hi-Way Inn', 208, '2019-12-03', 335, NULL),
('Hi-Way Inn', 208, '2019-12-04', 229, NULL),
('Hi-Way Inn', 208, '2019-12-05', 335, NULL),
('Hi-Way Inn', 208, '2019-12-06', 113, NULL),
('Hi-Way Inn', 208, '2019-12-07', 129, NULL),
('Hi-Way Inn', 208, '2019-12-08', 381, NULL),
('Hi-Way Inn', 208, '2019-12-09', 112, NULL),
('Hi-Way Inn', 208, '2019-12-10', 109, NULL),
('Hi-Way Inn', 208, '2019-12-11', 184, NULL),
('Hi-Way Inn', 208, '2019-12-12', 130, NULL),
('Hi-Way Inn', 208, '2019-12-13', 363, NULL),
('Hi-Way Inn', 208, '2019-12-14', 249, NULL),
('Hi-Way Inn', 208, '2019-12-15', 242, NULL),
('Hi-Way Inn', 208, '2019-12-16', 366, NULL),
('Hi-Way Inn', 208, '2019-12-17', 399, NULL),
('Hi-Way Inn', 208, '2019-12-18', 340, NULL),
('Hi-Way Inn', 208, '2019-12-19', 210, NULL),
('Hi-Way Inn', 208, '2019-12-20', 289, NULL),
('Hi-Way Inn', 208, '2019-12-21', 107, NULL),
('Hi-Way Inn', 208, '2019-12-22', 121, NULL),
('Hi-Way Inn', 208, '2019-12-23', 241, NULL),
('Hi-Way Inn', 208, '2019-12-24', 373, NULL),
('Hi-Way Inn', 208, '2019-12-25', 181, NULL),
('Hi-Way Inn', 208, '2019-12-26', 157, NULL),
('Hi-Way Inn', 208, '2019-12-27', 243, NULL),
('Hi-Way Inn', 208, '2019-12-28', 151, NULL),
('Hi-Way Inn', 208, '2019-12-29', 164, NULL),
('Hi-Way Inn', 208, '2019-12-30', 284, NULL),
('Hi-Way Inn', 208, '2019-12-31', 362, NULL),
('Hi-Way Inn', 208, '2020-01-01', 329, NULL),
('Hi-Way Inn', 208, '2020-01-02', 278, NULL),
('Hi-Way Inn', 208, '2020-01-03', 200, NULL),
('Hi-Way Inn', 208, '2020-01-04', 379, NULL),
('Hi-Way Inn', 208, '2020-01-05', 120, NULL),
('Hi-Way Inn', 208, '2020-01-06', 373, NULL),
('Hi-Way Inn', 208, '2020-01-07', 102, NULL),
('Hi-Way Inn', 208, '2020-01-08', 355, NULL),
('Hi-Way Inn', 208, '2020-01-09', 297, NULL),
('Hi-Way Inn', 208, '2020-01-10', 390, NULL),
('Hi-Way Inn', 208, '2020-01-11', 210, NULL),
('Hi-Way Inn', 208, '2020-01-12', 141, NULL),
('Hi-Way Inn', 208, '2020-01-13', 152, NULL),
('Hi-Way Inn', 208, '2020-01-14', 210, NULL),
('Hi-Way Inn', 208, '2020-01-15', 188, NULL),
('Hi-Way Inn', 208, '2020-01-16', 164, NULL),
('Hi-Way Inn', 208, '2020-01-17', 343, NULL),
('Hi-Way Inn', 208, '2020-01-18', 185, NULL),
('Hi-Way Inn', 208, '2020-01-19', 176, NULL),
('Hi-Way Inn', 208, '2020-01-20', 170, NULL),
('Hi-Way Inn', 208, '2020-01-21', 109, NULL),
('Hi-Way Inn', 208, '2020-01-22', 331, NULL),
('Hi-Way Inn', 208, '2020-01-23', 126, NULL),
('Hi-Way Inn', 208, '2020-01-24', 371, NULL),
('Hi-Way Inn', 208, '2020-01-25', 178, NULL),
('Hi-Way Inn', 208, '2020-01-26', 366, NULL),
('Hi-Way Inn', 208, '2020-01-27', 398, NULL),
('Hi-Way Inn', 208, '2020-01-28', 370, NULL),
('Hi-Way Inn', 208, '2020-01-29', 123, NULL),
('Hi-Way Inn', 208, '2020-01-30', 267, NULL),
('Hi-Way Inn', 208, '2020-01-31', 354, NULL),
('Hi-Way Inn', 208, '2020-02-01', 388, NULL),
('Hi-Way Inn', 208, '2020-02-02', 373, NULL),
('Hi-Way Inn', 208, '2020-02-03', 227, NULL),
('Hi-Way Inn', 208, '2020-02-04', 269, NULL),
('Hi-Way Inn', 232, '2019-01-01', 214, NULL),
('Hi-Way Inn', 232, '2019-01-02', 279, NULL),
('Hi-Way Inn', 232, '2019-01-03', 342, NULL),
('Hi-Way Inn', 232, '2019-01-04', 349, NULL),
('Hi-Way Inn', 232, '2019-01-05', 301, NULL),
('Hi-Way Inn', 232, '2019-01-06', 251, NULL),
('Hi-Way Inn', 232, '2019-01-07', 221, NULL),
('Hi-Way Inn', 232, '2019-01-08', 325, NULL),
('Hi-Way Inn', 232, '2019-01-09', 229, NULL),
('Hi-Way Inn', 232, '2019-01-10', 170, NULL),
('Hi-Way Inn', 232, '2019-01-11', 379, NULL),
('Hi-Way Inn', 232, '2019-01-12', 322, NULL),
('Hi-Way Inn', 232, '2019-01-13', 286, NULL),
('Hi-Way Inn', 232, '2019-01-14', 197, NULL),
('Hi-Way Inn', 232, '2019-01-15', 114, NULL),
('Hi-Way Inn', 232, '2019-01-16', 120, NULL),
('Hi-Way Inn', 232, '2019-01-17', 183, NULL),
('Hi-Way Inn', 232, '2019-01-18', 134, NULL),
('Hi-Way Inn', 232, '2019-01-19', 240, NULL),
('Hi-Way Inn', 232, '2019-01-20', 284, NULL),
('Hi-Way Inn', 232, '2019-01-21', 186, NULL),
('Hi-Way Inn', 232, '2019-01-22', 275, NULL),
('Hi-Way Inn', 232, '2019-01-23', 320, NULL),
('Hi-Way Inn', 232, '2019-01-24', 322, NULL),
('Hi-Way Inn', 232, '2019-01-25', 182, NULL),
('Hi-Way Inn', 232, '2019-01-26', 221, NULL),
('Hi-Way Inn', 232, '2019-01-27', 245, NULL),
('Hi-Way Inn', 232, '2019-01-28', 181, NULL),
('Hi-Way Inn', 232, '2019-01-29', 278, NULL),
('Hi-Way Inn', 232, '2019-01-30', 174, NULL),
('Hi-Way Inn', 232, '2019-01-31', 252, NULL),
('Hi-Way Inn', 232, '2019-02-01', 157, NULL),
('Hi-Way Inn', 232, '2019-02-02', 352, NULL),
('Hi-Way Inn', 232, '2019-02-03', 163, NULL),
('Hi-Way Inn', 232, '2019-02-04', 395, NULL),
('Hi-Way Inn', 232, '2019-02-05', 290, NULL),
('Hi-Way Inn', 232, '2019-02-06', 157, NULL),
('Hi-Way Inn', 232, '2019-02-07', 347, NULL),
('Hi-Way Inn', 232, '2019-02-08', 238, NULL),
('Hi-Way Inn', 232, '2019-02-09', 278, NULL),
('Hi-Way Inn', 232, '2019-02-10', 207, NULL),
('Hi-Way Inn', 232, '2019-02-11', 335, NULL),
('Hi-Way Inn', 232, '2019-02-12', 210, NULL),
('Hi-Way Inn', 232, '2019-02-13', 136, NULL),
('Hi-Way Inn', 232, '2019-02-14', 300, NULL),
('Hi-Way Inn', 232, '2019-02-15', 151, NULL),
('Hi-Way Inn', 232, '2019-02-16', 259, NULL),
('Hi-Way Inn', 232, '2019-02-17', 106, NULL),
('Hi-Way Inn', 232, '2019-02-18', 204, NULL),
('Hi-Way Inn', 232, '2019-02-19', 386, NULL),
('Hi-Way Inn', 232, '2019-02-20', 107, NULL),
('Hi-Way Inn', 232, '2019-02-21', 286, NULL),
('Hi-Way Inn', 232, '2019-02-22', 189, NULL),
('Hi-Way Inn', 232, '2019-02-23', 282, NULL),
('Hi-Way Inn', 232, '2019-02-24', 389, NULL),
('Hi-Way Inn', 232, '2019-02-25', 142, NULL),
('Hi-Way Inn', 232, '2019-02-26', 325, NULL),
('Hi-Way Inn', 232, '2019-02-27', 193, NULL),
('Hi-Way Inn', 232, '2019-02-28', 215, NULL),
('Hi-Way Inn', 232, '2019-03-01', 397, NULL),
('Hi-Way Inn', 232, '2019-03-02', 371, NULL),
('Hi-Way Inn', 232, '2019-03-03', 130, NULL),
('Hi-Way Inn', 232, '2019-03-04', 210, NULL),
('Hi-Way Inn', 232, '2019-03-05', 314, NULL),
('Hi-Way Inn', 232, '2019-03-06', 100, NULL),
('Hi-Way Inn', 232, '2019-03-07', 194, NULL),
('Hi-Way Inn', 232, '2019-03-08', 171, NULL),
('Hi-Way Inn', 232, '2019-03-09', 161, NULL),
('Hi-Way Inn', 232, '2019-03-10', 378, NULL),
('Hi-Way Inn', 232, '2019-03-11', 233, NULL),
('Hi-Way Inn', 232, '2019-03-12', 156, NULL),
('Hi-Way Inn', 232, '2019-03-13', 316, NULL),
('Hi-Way Inn', 232, '2019-03-14', 290, NULL),
('Hi-Way Inn', 232, '2019-03-15', 242, NULL),
('Hi-Way Inn', 232, '2019-03-16', 305, NULL),
('Hi-Way Inn', 232, '2019-03-17', 344, NULL),
('Hi-Way Inn', 232, '2019-03-18', 207, NULL),
('Hi-Way Inn', 232, '2019-03-19', 224, NULL),
('Hi-Way Inn', 232, '2019-03-20', 113, NULL),
('Hi-Way Inn', 232, '2019-03-21', 343, NULL),
('Hi-Way Inn', 232, '2019-03-22', 172, NULL),
('Hi-Way Inn', 232, '2019-03-23', 205, NULL),
('Hi-Way Inn', 232, '2019-03-24', 103, NULL),
('Hi-Way Inn', 232, '2019-03-25', 327, NULL),
('Hi-Way Inn', 232, '2019-03-26', 139, NULL),
('Hi-Way Inn', 232, '2019-03-27', 381, NULL),
('Hi-Way Inn', 232, '2019-03-28', 198, NULL),
('Hi-Way Inn', 232, '2019-03-29', 201, NULL),
('Hi-Way Inn', 232, '2019-03-30', 304, NULL),
('Hi-Way Inn', 232, '2019-03-31', 259, NULL),
('Hi-Way Inn', 232, '2019-04-01', 112, NULL),
('Hi-Way Inn', 232, '2019-04-02', 332, NULL),
('Hi-Way Inn', 232, '2019-04-03', 203, NULL),
('Hi-Way Inn', 232, '2019-04-04', 265, NULL),
('Hi-Way Inn', 232, '2019-04-05', 342, NULL),
('Hi-Way Inn', 232, '2019-04-06', 271, NULL),
('Hi-Way Inn', 232, '2019-04-07', 380, NULL),
('Hi-Way Inn', 232, '2019-04-08', 172, NULL),
('Hi-Way Inn', 232, '2019-04-09', 129, NULL),
('Hi-Way Inn', 232, '2019-04-10', 338, NULL),
('Hi-Way Inn', 232, '2019-04-11', 129, NULL),
('Hi-Way Inn', 232, '2019-04-12', 307, NULL),
('Hi-Way Inn', 232, '2019-04-13', 344, NULL),
('Hi-Way Inn', 232, '2019-04-14', 385, NULL),
('Hi-Way Inn', 232, '2019-04-15', 110, NULL),
('Hi-Way Inn', 232, '2019-04-16', 335, NULL),
('Hi-Way Inn', 232, '2019-04-17', 154, NULL),
('Hi-Way Inn', 232, '2019-04-18', 389, NULL),
('Hi-Way Inn', 232, '2019-04-19', 309, NULL),
('Hi-Way Inn', 232, '2019-04-20', 257, NULL),
('Hi-Way Inn', 232, '2019-04-21', 174, NULL),
('Hi-Way Inn', 232, '2019-04-22', 146, NULL),
('Hi-Way Inn', 232, '2019-04-23', 140, NULL),
('Hi-Way Inn', 232, '2019-04-24', 305, NULL),
('Hi-Way Inn', 232, '2019-04-25', 263, NULL),
('Hi-Way Inn', 232, '2019-04-26', 143, NULL),
('Hi-Way Inn', 232, '2019-04-27', 295, NULL),
('Hi-Way Inn', 232, '2019-04-28', 252, NULL),
('Hi-Way Inn', 232, '2019-04-29', 340, NULL),
('Hi-Way Inn', 232, '2019-04-30', 242, NULL),
('Hi-Way Inn', 232, '2019-05-01', 392, NULL),
('Hi-Way Inn', 232, '2019-05-02', 251, NULL),
('Hi-Way Inn', 232, '2019-05-03', 127, NULL),
('Hi-Way Inn', 232, '2019-05-04', 156, NULL),
('Hi-Way Inn', 232, '2019-05-05', 139, NULL),
('Hi-Way Inn', 232, '2019-05-06', 150, NULL),
('Hi-Way Inn', 232, '2019-05-07', 127, NULL),
('Hi-Way Inn', 232, '2019-05-08', 118, NULL),
('Hi-Way Inn', 232, '2019-05-09', 361, NULL),
('Hi-Way Inn', 232, '2019-05-10', 248, NULL),
('Hi-Way Inn', 232, '2019-05-11', 203, NULL),
('Hi-Way Inn', 232, '2019-05-12', 236, NULL),
('Hi-Way Inn', 232, '2019-05-13', 378, NULL),
('Hi-Way Inn', 232, '2019-05-14', 219, NULL),
('Hi-Way Inn', 232, '2019-05-15', 178, NULL),
('Hi-Way Inn', 232, '2019-05-16', 193, NULL),
('Hi-Way Inn', 232, '2019-05-17', 316, NULL),
('Hi-Way Inn', 232, '2019-05-18', 319, NULL),
('Hi-Way Inn', 232, '2019-05-19', 295, NULL),
('Hi-Way Inn', 232, '2019-05-20', 291, NULL),
('Hi-Way Inn', 232, '2019-05-21', 285, NULL),
('Hi-Way Inn', 232, '2019-05-22', 348, NULL),
('Hi-Way Inn', 232, '2019-05-23', 194, NULL),
('Hi-Way Inn', 232, '2019-05-24', 333, NULL),
('Hi-Way Inn', 232, '2019-05-25', 330, NULL),
('Hi-Way Inn', 232, '2019-05-26', 168, NULL),
('Hi-Way Inn', 232, '2019-05-27', 115, NULL),
('Hi-Way Inn', 232, '2019-05-28', 184, NULL),
('Hi-Way Inn', 232, '2019-05-29', 194, NULL),
('Hi-Way Inn', 232, '2019-05-30', 385, NULL),
('Hi-Way Inn', 232, '2019-05-31', 251, NULL),
('Hi-Way Inn', 232, '2019-06-01', 149, NULL),
('Hi-Way Inn', 232, '2019-06-02', 154, NULL),
('Hi-Way Inn', 232, '2019-06-03', 177, NULL),
('Hi-Way Inn', 232, '2019-06-04', 339, NULL),
('Hi-Way Inn', 232, '2019-06-05', 125, NULL),
('Hi-Way Inn', 232, '2019-06-06', 398, NULL),
('Hi-Way Inn', 232, '2019-06-07', 130, NULL),
('Hi-Way Inn', 232, '2019-06-08', 303, NULL),
('Hi-Way Inn', 232, '2019-06-09', 360, NULL),
('Hi-Way Inn', 232, '2019-06-10', 201, NULL),
('Hi-Way Inn', 232, '2019-06-11', 231, NULL),
('Hi-Way Inn', 232, '2019-06-12', 188, NULL),
('Hi-Way Inn', 232, '2019-06-13', 174, NULL),
('Hi-Way Inn', 232, '2019-06-14', 157, NULL),
('Hi-Way Inn', 232, '2019-06-15', 234, NULL),
('Hi-Way Inn', 232, '2019-06-16', 232, NULL),
('Hi-Way Inn', 232, '2019-06-17', 275, NULL),
('Hi-Way Inn', 232, '2019-06-18', 238, NULL),
('Hi-Way Inn', 232, '2019-06-19', 130, NULL),
('Hi-Way Inn', 232, '2019-06-20', 142, NULL),
('Hi-Way Inn', 232, '2019-06-21', 380, NULL),
('Hi-Way Inn', 232, '2019-06-22', 220, NULL),
('Hi-Way Inn', 232, '2019-06-23', 117, NULL),
('Hi-Way Inn', 232, '2019-06-24', 380, NULL),
('Hi-Way Inn', 232, '2019-06-25', 226, NULL),
('Hi-Way Inn', 232, '2019-06-26', 242, NULL),
('Hi-Way Inn', 232, '2019-06-27', 343, NULL),
('Hi-Way Inn', 232, '2019-06-28', 270, NULL),
('Hi-Way Inn', 232, '2019-06-29', 181, NULL),
('Hi-Way Inn', 232, '2019-06-30', 288, NULL),
('Hi-Way Inn', 232, '2019-07-01', 343, NULL),
('Hi-Way Inn', 232, '2019-07-02', 101, NULL),
('Hi-Way Inn', 232, '2019-07-03', 215, NULL),
('Hi-Way Inn', 232, '2019-07-04', 366, NULL),
('Hi-Way Inn', 232, '2019-07-05', 398, NULL),
('Hi-Way Inn', 232, '2019-07-06', 263, NULL),
('Hi-Way Inn', 232, '2019-07-07', 205, NULL),
('Hi-Way Inn', 232, '2019-07-08', 169, NULL),
('Hi-Way Inn', 232, '2019-07-09', 159, NULL),
('Hi-Way Inn', 232, '2019-07-10', 238, NULL),
('Hi-Way Inn', 232, '2019-07-11', 159, NULL),
('Hi-Way Inn', 232, '2019-07-12', 157, NULL),
('Hi-Way Inn', 232, '2019-07-13', 166, NULL),
('Hi-Way Inn', 232, '2019-07-14', 324, NULL),
('Hi-Way Inn', 232, '2019-07-15', 366, NULL),
('Hi-Way Inn', 232, '2019-07-16', 276, NULL),
('Hi-Way Inn', 232, '2019-07-17', 129, NULL),
('Hi-Way Inn', 232, '2019-07-18', 243, NULL),
('Hi-Way Inn', 232, '2019-07-19', 154, NULL),
('Hi-Way Inn', 232, '2019-07-20', 371, NULL),
('Hi-Way Inn', 232, '2019-07-21', 110, NULL),
('Hi-Way Inn', 232, '2019-07-22', 192, NULL),
('Hi-Way Inn', 232, '2019-07-23', 128, NULL),
('Hi-Way Inn', 232, '2019-07-24', 152, NULL),
('Hi-Way Inn', 232, '2019-07-25', 184, NULL),
('Hi-Way Inn', 232, '2019-07-26', 392, NULL),
('Hi-Way Inn', 232, '2019-07-27', 362, NULL),
('Hi-Way Inn', 232, '2019-07-28', 354, NULL),
('Hi-Way Inn', 232, '2019-07-29', 292, NULL),
('Hi-Way Inn', 232, '2019-07-30', 174, NULL),
('Hi-Way Inn', 232, '2019-07-31', 100, NULL),
('Hi-Way Inn', 232, '2019-08-01', 197, NULL),
('Hi-Way Inn', 232, '2019-08-02', 225, NULL),
('Hi-Way Inn', 232, '2019-08-03', 175, NULL),
('Hi-Way Inn', 232, '2019-08-04', 370, NULL),
('Hi-Way Inn', 232, '2019-08-05', 269, NULL),
('Hi-Way Inn', 232, '2019-08-06', 282, NULL),
('Hi-Way Inn', 232, '2019-08-07', 397, NULL),
('Hi-Way Inn', 232, '2019-08-08', 108, NULL),
('Hi-Way Inn', 232, '2019-08-09', 381, NULL),
('Hi-Way Inn', 232, '2019-08-10', 207, NULL),
('Hi-Way Inn', 232, '2019-08-11', 337, NULL),
('Hi-Way Inn', 232, '2019-08-12', 398, NULL),
('Hi-Way Inn', 232, '2019-08-13', 130, NULL),
('Hi-Way Inn', 232, '2019-08-14', 257, NULL),
('Hi-Way Inn', 232, '2019-08-15', 295, NULL),
('Hi-Way Inn', 232, '2019-08-16', 152, NULL),
('Hi-Way Inn', 232, '2019-08-17', 282, NULL),
('Hi-Way Inn', 232, '2019-08-18', 151, NULL),
('Hi-Way Inn', 232, '2019-08-19', 253, NULL),
('Hi-Way Inn', 232, '2019-08-20', 238, NULL),
('Hi-Way Inn', 232, '2019-08-21', 130, NULL),
('Hi-Way Inn', 232, '2019-08-22', 206, NULL),
('Hi-Way Inn', 232, '2019-08-23', 203, NULL),
('Hi-Way Inn', 232, '2019-08-24', 301, NULL),
('Hi-Way Inn', 232, '2019-08-25', 356, NULL),
('Hi-Way Inn', 232, '2019-08-26', 375, NULL),
('Hi-Way Inn', 232, '2019-08-27', 130, NULL),
('Hi-Way Inn', 232, '2019-08-28', 137, NULL),
('Hi-Way Inn', 232, '2019-08-29', 194, NULL),
('Hi-Way Inn', 232, '2019-08-30', 160, NULL),
('Hi-Way Inn', 232, '2019-08-31', 338, NULL),
('Hi-Way Inn', 232, '2019-09-01', 264, NULL),
('Hi-Way Inn', 232, '2019-09-02', 304, NULL),
('Hi-Way Inn', 232, '2019-09-03', 224, NULL),
('Hi-Way Inn', 232, '2019-09-04', 308, NULL),
('Hi-Way Inn', 232, '2019-09-05', 349, NULL),
('Hi-Way Inn', 232, '2019-09-06', 360, NULL),
('Hi-Way Inn', 232, '2019-09-07', 148, NULL),
('Hi-Way Inn', 232, '2019-09-08', 218, NULL),
('Hi-Way Inn', 232, '2019-09-09', 261, NULL),
('Hi-Way Inn', 232, '2019-09-10', 236, NULL),
('Hi-Way Inn', 232, '2019-09-11', 210, NULL),
('Hi-Way Inn', 232, '2019-09-12', 300, NULL),
('Hi-Way Inn', 232, '2019-09-13', 149, NULL),
('Hi-Way Inn', 232, '2019-09-14', 350, NULL),
('Hi-Way Inn', 232, '2019-09-15', 113, NULL),
('Hi-Way Inn', 232, '2019-09-16', 138, NULL),
('Hi-Way Inn', 232, '2019-09-17', 348, NULL),
('Hi-Way Inn', 232, '2019-09-18', 116, NULL),
('Hi-Way Inn', 232, '2019-09-19', 387, NULL),
('Hi-Way Inn', 232, '2019-09-20', 308, NULL),
('Hi-Way Inn', 232, '2019-09-21', 396, NULL),
('Hi-Way Inn', 232, '2019-09-22', 295, NULL),
('Hi-Way Inn', 232, '2019-09-23', 101, NULL),
('Hi-Way Inn', 232, '2019-09-24', 328, NULL),
('Hi-Way Inn', 232, '2019-09-25', 317, NULL),
('Hi-Way Inn', 232, '2019-09-26', 162, NULL),
('Hi-Way Inn', 232, '2019-09-27', 237, NULL),
('Hi-Way Inn', 232, '2019-09-28', 210, NULL),
('Hi-Way Inn', 232, '2019-09-29', 116, NULL),
('Hi-Way Inn', 232, '2019-09-30', 145, NULL),
('Hi-Way Inn', 232, '2019-10-01', 188, NULL),
('Hi-Way Inn', 232, '2019-10-02', 123, NULL),
('Hi-Way Inn', 232, '2019-10-03', 198, NULL),
('Hi-Way Inn', 232, '2019-10-04', 242, NULL),
('Hi-Way Inn', 232, '2019-10-05', 307, NULL),
('Hi-Way Inn', 232, '2019-10-06', 325, NULL),
('Hi-Way Inn', 232, '2019-10-07', 149, NULL),
('Hi-Way Inn', 232, '2019-10-08', 268, NULL),
('Hi-Way Inn', 232, '2019-10-09', 318, NULL),
('Hi-Way Inn', 232, '2019-10-10', 106, NULL),
('Hi-Way Inn', 232, '2019-10-11', 176, NULL),
('Hi-Way Inn', 232, '2019-10-12', 206, NULL),
('Hi-Way Inn', 232, '2019-10-13', 307, NULL),
('Hi-Way Inn', 232, '2019-10-14', 381, NULL),
('Hi-Way Inn', 232, '2019-10-15', 156, NULL),
('Hi-Way Inn', 232, '2019-10-16', 330, NULL),
('Hi-Way Inn', 232, '2019-10-17', 355, NULL),
('Hi-Way Inn', 232, '2019-10-18', 340, NULL),
('Hi-Way Inn', 232, '2019-10-19', 130, NULL),
('Hi-Way Inn', 232, '2019-10-20', 336, NULL),
('Hi-Way Inn', 232, '2019-10-21', 274, NULL),
('Hi-Way Inn', 232, '2019-10-22', 127, NULL),
('Hi-Way Inn', 232, '2019-10-23', 398, NULL),
('Hi-Way Inn', 232, '2019-10-24', 285, NULL),
('Hi-Way Inn', 232, '2019-10-25', 379, NULL),
('Hi-Way Inn', 232, '2019-10-26', 315, NULL),
('Hi-Way Inn', 232, '2019-10-27', 289, NULL),
('Hi-Way Inn', 232, '2019-10-28', 127, NULL),
('Hi-Way Inn', 232, '2019-10-29', 277, NULL),
('Hi-Way Inn', 232, '2019-10-30', 174, NULL),
('Hi-Way Inn', 232, '2019-10-31', 160, NULL),
('Hi-Way Inn', 232, '2019-11-01', 269, NULL),
('Hi-Way Inn', 232, '2019-11-02', 267, NULL),
('Hi-Way Inn', 232, '2019-11-03', 145, NULL),
('Hi-Way Inn', 232, '2019-11-04', 249, NULL),
('Hi-Way Inn', 232, '2019-11-05', 386, NULL),
('Hi-Way Inn', 232, '2019-11-06', 175, NULL),
('Hi-Way Inn', 232, '2019-11-07', 189, NULL),
('Hi-Way Inn', 232, '2019-11-08', 280, NULL),
('Hi-Way Inn', 232, '2019-11-09', 263, NULL),
('Hi-Way Inn', 232, '2019-11-10', 398, NULL),
('Hi-Way Inn', 232, '2019-11-11', 326, NULL),
('Hi-Way Inn', 232, '2019-11-12', 373, NULL),
('Hi-Way Inn', 232, '2019-11-13', 228, NULL),
('Hi-Way Inn', 232, '2019-11-14', 149, NULL),
('Hi-Way Inn', 232, '2019-11-15', 243, NULL),
('Hi-Way Inn', 232, '2019-11-16', 291, NULL),
('Hi-Way Inn', 232, '2019-11-17', 377, NULL),
('Hi-Way Inn', 232, '2019-11-18', 365, NULL),
('Hi-Way Inn', 232, '2019-11-19', 178, NULL),
('Hi-Way Inn', 232, '2019-11-20', 348, NULL),
('Hi-Way Inn', 232, '2019-11-21', 192, NULL),
('Hi-Way Inn', 232, '2019-11-22', 357, NULL),
('Hi-Way Inn', 232, '2019-11-23', 145, NULL),
('Hi-Way Inn', 232, '2019-11-24', 369, NULL),
('Hi-Way Inn', 232, '2019-11-25', 290, NULL),
('Hi-Way Inn', 232, '2019-11-26', 120, NULL),
('Hi-Way Inn', 232, '2019-11-27', 360, NULL),
('Hi-Way Inn', 232, '2019-11-28', 204, NULL),
('Hi-Way Inn', 232, '2019-11-29', 370, NULL),
('Hi-Way Inn', 232, '2019-11-30', 162, NULL),
('Hi-Way Inn', 232, '2019-12-01', 268, NULL),
('Hi-Way Inn', 232, '2019-12-02', 314, NULL),
('Hi-Way Inn', 232, '2019-12-03', 313, NULL),
('Hi-Way Inn', 232, '2019-12-04', 322, NULL),
('Hi-Way Inn', 232, '2019-12-05', 143, NULL),
('Hi-Way Inn', 232, '2019-12-06', 384, NULL),
('Hi-Way Inn', 232, '2019-12-07', 263, NULL),
('Hi-Way Inn', 232, '2019-12-08', 307, NULL),
('Hi-Way Inn', 232, '2019-12-09', 391, NULL),
('Hi-Way Inn', 232, '2019-12-10', 132, NULL),
('Hi-Way Inn', 232, '2019-12-11', 196, NULL),
('Hi-Way Inn', 232, '2019-12-12', 135, NULL),
('Hi-Way Inn', 232, '2019-12-13', 338, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 232, '2019-12-14', 344, NULL),
('Hi-Way Inn', 232, '2019-12-15', 205, NULL),
('Hi-Way Inn', 232, '2019-12-16', 192, NULL),
('Hi-Way Inn', 232, '2019-12-17', 131, NULL),
('Hi-Way Inn', 232, '2019-12-18', 259, NULL),
('Hi-Way Inn', 232, '2019-12-19', 281, NULL),
('Hi-Way Inn', 232, '2019-12-20', 106, NULL),
('Hi-Way Inn', 232, '2019-12-21', 357, NULL),
('Hi-Way Inn', 232, '2019-12-22', 323, NULL),
('Hi-Way Inn', 232, '2019-12-23', 141, NULL),
('Hi-Way Inn', 232, '2019-12-24', 127, NULL),
('Hi-Way Inn', 232, '2019-12-25', 141, NULL),
('Hi-Way Inn', 232, '2019-12-26', 303, NULL),
('Hi-Way Inn', 232, '2019-12-27', 181, NULL),
('Hi-Way Inn', 232, '2019-12-28', 299, NULL),
('Hi-Way Inn', 232, '2019-12-29', 151, NULL),
('Hi-Way Inn', 232, '2019-12-30', 155, NULL),
('Hi-Way Inn', 232, '2019-12-31', 271, NULL),
('Hi-Way Inn', 232, '2020-01-01', 293, NULL),
('Hi-Way Inn', 232, '2020-01-02', 334, NULL),
('Hi-Way Inn', 232, '2020-01-03', 126, NULL),
('Hi-Way Inn', 232, '2020-01-04', 334, NULL),
('Hi-Way Inn', 232, '2020-01-05', 263, NULL),
('Hi-Way Inn', 232, '2020-01-06', 289, NULL),
('Hi-Way Inn', 232, '2020-01-07', 255, NULL),
('Hi-Way Inn', 232, '2020-01-08', 259, NULL),
('Hi-Way Inn', 232, '2020-01-09', 128, NULL),
('Hi-Way Inn', 232, '2020-01-10', 343, NULL),
('Hi-Way Inn', 232, '2020-01-11', 329, NULL),
('Hi-Way Inn', 232, '2020-01-12', 259, NULL),
('Hi-Way Inn', 232, '2020-01-13', 115, NULL),
('Hi-Way Inn', 232, '2020-01-14', 191, NULL),
('Hi-Way Inn', 232, '2020-01-15', 253, NULL),
('Hi-Way Inn', 232, '2020-01-16', 394, NULL),
('Hi-Way Inn', 232, '2020-01-17', 188, NULL),
('Hi-Way Inn', 232, '2020-01-18', 139, NULL),
('Hi-Way Inn', 232, '2020-01-19', 314, NULL),
('Hi-Way Inn', 232, '2020-01-20', 281, NULL),
('Hi-Way Inn', 232, '2020-01-21', 211, NULL),
('Hi-Way Inn', 232, '2020-01-22', 373, NULL),
('Hi-Way Inn', 232, '2020-01-23', 136, NULL),
('Hi-Way Inn', 232, '2020-01-24', 111, NULL),
('Hi-Way Inn', 232, '2020-01-25', 235, NULL),
('Hi-Way Inn', 232, '2020-01-26', 376, NULL),
('Hi-Way Inn', 232, '2020-01-27', 196, NULL),
('Hi-Way Inn', 232, '2020-01-28', 171, NULL),
('Hi-Way Inn', 232, '2020-01-29', 207, NULL),
('Hi-Way Inn', 232, '2020-01-30', 398, NULL),
('Hi-Way Inn', 232, '2020-01-31', 183, NULL),
('Hi-Way Inn', 232, '2020-02-01', 101, NULL),
('Hi-Way Inn', 232, '2020-02-02', 322, NULL),
('Hi-Way Inn', 232, '2020-02-03', 119, NULL),
('Hi-Way Inn', 232, '2020-02-04', 363, NULL),
('Hi-Way Inn', 254, '2019-01-01', 116, NULL),
('Hi-Way Inn', 254, '2019-01-02', 351, NULL),
('Hi-Way Inn', 254, '2019-01-03', 243, NULL),
('Hi-Way Inn', 254, '2019-01-04', 394, NULL),
('Hi-Way Inn', 254, '2019-01-05', 210, NULL),
('Hi-Way Inn', 254, '2019-01-06', 382, NULL),
('Hi-Way Inn', 254, '2019-01-07', 250, NULL),
('Hi-Way Inn', 254, '2019-01-08', 102, NULL),
('Hi-Way Inn', 254, '2019-01-09', 226, NULL),
('Hi-Way Inn', 254, '2019-01-10', 379, NULL),
('Hi-Way Inn', 254, '2019-01-11', 219, NULL),
('Hi-Way Inn', 254, '2019-01-12', 122, NULL),
('Hi-Way Inn', 254, '2019-01-13', 176, NULL),
('Hi-Way Inn', 254, '2019-01-14', 369, NULL),
('Hi-Way Inn', 254, '2019-01-15', 352, NULL),
('Hi-Way Inn', 254, '2019-01-16', 374, NULL),
('Hi-Way Inn', 254, '2019-01-17', 300, NULL),
('Hi-Way Inn', 254, '2019-01-18', 142, NULL),
('Hi-Way Inn', 254, '2019-01-19', 284, NULL),
('Hi-Way Inn', 254, '2019-01-20', 269, NULL),
('Hi-Way Inn', 254, '2019-01-21', 133, NULL),
('Hi-Way Inn', 254, '2019-01-22', 191, NULL),
('Hi-Way Inn', 254, '2019-01-23', 249, NULL),
('Hi-Way Inn', 254, '2019-01-24', 187, NULL),
('Hi-Way Inn', 254, '2019-01-25', 125, NULL),
('Hi-Way Inn', 254, '2019-01-26', 371, NULL),
('Hi-Way Inn', 254, '2019-01-27', 336, NULL),
('Hi-Way Inn', 254, '2019-01-28', 192, NULL),
('Hi-Way Inn', 254, '2019-01-29', 333, NULL),
('Hi-Way Inn', 254, '2019-01-30', 356, NULL),
('Hi-Way Inn', 254, '2019-01-31', 141, NULL),
('Hi-Way Inn', 254, '2019-02-01', 363, NULL),
('Hi-Way Inn', 254, '2019-02-02', 146, NULL),
('Hi-Way Inn', 254, '2019-02-03', 396, NULL),
('Hi-Way Inn', 254, '2019-02-04', 379, NULL),
('Hi-Way Inn', 254, '2019-02-05', 291, NULL),
('Hi-Way Inn', 254, '2019-02-06', 192, NULL),
('Hi-Way Inn', 254, '2019-02-07', 186, NULL),
('Hi-Way Inn', 254, '2019-02-08', 234, NULL),
('Hi-Way Inn', 254, '2019-02-09', 237, NULL),
('Hi-Way Inn', 254, '2019-02-10', 131, NULL),
('Hi-Way Inn', 254, '2019-02-11', 142, NULL),
('Hi-Way Inn', 254, '2019-02-12', 164, NULL),
('Hi-Way Inn', 254, '2019-02-13', 342, NULL),
('Hi-Way Inn', 254, '2019-02-14', 291, NULL),
('Hi-Way Inn', 254, '2019-02-15', 273, NULL),
('Hi-Way Inn', 254, '2019-02-16', 148, NULL),
('Hi-Way Inn', 254, '2019-02-17', 138, NULL),
('Hi-Way Inn', 254, '2019-02-18', 329, NULL),
('Hi-Way Inn', 254, '2019-02-19', 184, NULL),
('Hi-Way Inn', 254, '2019-02-20', 302, NULL),
('Hi-Way Inn', 254, '2019-02-21', 364, NULL),
('Hi-Way Inn', 254, '2019-02-22', 170, NULL),
('Hi-Way Inn', 254, '2019-02-23', 262, NULL),
('Hi-Way Inn', 254, '2019-02-24', 324, NULL),
('Hi-Way Inn', 254, '2019-02-25', 259, NULL),
('Hi-Way Inn', 254, '2019-02-26', 217, NULL),
('Hi-Way Inn', 254, '2019-02-27', 393, NULL),
('Hi-Way Inn', 254, '2019-02-28', 387, NULL),
('Hi-Way Inn', 254, '2019-03-01', 141, NULL),
('Hi-Way Inn', 254, '2019-03-02', 109, NULL),
('Hi-Way Inn', 254, '2019-03-03', 151, NULL),
('Hi-Way Inn', 254, '2019-03-04', 181, NULL),
('Hi-Way Inn', 254, '2019-03-05', 302, NULL),
('Hi-Way Inn', 254, '2019-03-06', 393, NULL),
('Hi-Way Inn', 254, '2019-03-07', 286, NULL),
('Hi-Way Inn', 254, '2019-03-08', 236, NULL),
('Hi-Way Inn', 254, '2019-03-09', 137, NULL),
('Hi-Way Inn', 254, '2019-03-10', 224, NULL),
('Hi-Way Inn', 254, '2019-03-11', 171, NULL),
('Hi-Way Inn', 254, '2019-03-12', 349, NULL),
('Hi-Way Inn', 254, '2019-03-13', 239, NULL),
('Hi-Way Inn', 254, '2019-03-14', 172, NULL),
('Hi-Way Inn', 254, '2019-03-15', 111, NULL),
('Hi-Way Inn', 254, '2019-03-16', 275, NULL),
('Hi-Way Inn', 254, '2019-03-17', 145, NULL),
('Hi-Way Inn', 254, '2019-03-18', 350, NULL),
('Hi-Way Inn', 254, '2019-03-19', 275, NULL),
('Hi-Way Inn', 254, '2019-03-20', 207, NULL),
('Hi-Way Inn', 254, '2019-03-21', 272, NULL),
('Hi-Way Inn', 254, '2019-03-22', 158, NULL),
('Hi-Way Inn', 254, '2019-03-23', 331, NULL),
('Hi-Way Inn', 254, '2019-03-24', 314, NULL),
('Hi-Way Inn', 254, '2019-03-25', 241, NULL),
('Hi-Way Inn', 254, '2019-03-26', 191, NULL),
('Hi-Way Inn', 254, '2019-03-27', 262, NULL),
('Hi-Way Inn', 254, '2019-03-28', 186, NULL),
('Hi-Way Inn', 254, '2019-03-29', 353, NULL),
('Hi-Way Inn', 254, '2019-03-30', 253, NULL),
('Hi-Way Inn', 254, '2019-03-31', 202, NULL),
('Hi-Way Inn', 254, '2019-04-01', 359, NULL),
('Hi-Way Inn', 254, '2019-04-02', 320, NULL),
('Hi-Way Inn', 254, '2019-04-03', 135, NULL),
('Hi-Way Inn', 254, '2019-04-04', 137, NULL),
('Hi-Way Inn', 254, '2019-04-05', 223, NULL),
('Hi-Way Inn', 254, '2019-04-06', 142, NULL),
('Hi-Way Inn', 254, '2019-04-07', 299, NULL),
('Hi-Way Inn', 254, '2019-04-08', 384, NULL),
('Hi-Way Inn', 254, '2019-04-09', 198, NULL),
('Hi-Way Inn', 254, '2019-04-10', 379, NULL),
('Hi-Way Inn', 254, '2019-04-11', 143, NULL),
('Hi-Way Inn', 254, '2019-04-12', 114, NULL),
('Hi-Way Inn', 254, '2019-04-13', 141, NULL),
('Hi-Way Inn', 254, '2019-04-14', 349, NULL),
('Hi-Way Inn', 254, '2019-04-15', 153, NULL),
('Hi-Way Inn', 254, '2019-04-16', 272, NULL),
('Hi-Way Inn', 254, '2019-04-17', 150, NULL),
('Hi-Way Inn', 254, '2019-04-18', 197, NULL),
('Hi-Way Inn', 254, '2019-04-19', 334, NULL),
('Hi-Way Inn', 254, '2019-04-20', 249, NULL),
('Hi-Way Inn', 254, '2019-04-21', 225, NULL),
('Hi-Way Inn', 254, '2019-04-22', 395, NULL),
('Hi-Way Inn', 254, '2019-04-23', 212, NULL),
('Hi-Way Inn', 254, '2019-04-24', 384, NULL),
('Hi-Way Inn', 254, '2019-04-25', 356, NULL),
('Hi-Way Inn', 254, '2019-04-26', 158, NULL),
('Hi-Way Inn', 254, '2019-04-27', 383, NULL),
('Hi-Way Inn', 254, '2019-04-28', 385, NULL),
('Hi-Way Inn', 254, '2019-04-29', 214, NULL),
('Hi-Way Inn', 254, '2019-04-30', 329, NULL),
('Hi-Way Inn', 254, '2019-05-01', 360, NULL),
('Hi-Way Inn', 254, '2019-05-02', 351, NULL),
('Hi-Way Inn', 254, '2019-05-03', 164, NULL),
('Hi-Way Inn', 254, '2019-05-04', 352, NULL),
('Hi-Way Inn', 254, '2019-05-05', 269, NULL),
('Hi-Way Inn', 254, '2019-05-06', 207, NULL),
('Hi-Way Inn', 254, '2019-05-07', 238, NULL),
('Hi-Way Inn', 254, '2019-05-08', 140, NULL),
('Hi-Way Inn', 254, '2019-05-09', 221, NULL),
('Hi-Way Inn', 254, '2019-05-10', 301, NULL),
('Hi-Way Inn', 254, '2019-05-11', 388, NULL),
('Hi-Way Inn', 254, '2019-05-12', 242, NULL),
('Hi-Way Inn', 254, '2019-05-13', 383, NULL),
('Hi-Way Inn', 254, '2019-05-14', 288, NULL),
('Hi-Way Inn', 254, '2019-05-15', 398, NULL),
('Hi-Way Inn', 254, '2019-05-16', 303, NULL),
('Hi-Way Inn', 254, '2019-05-17', 107, NULL),
('Hi-Way Inn', 254, '2019-05-18', 291, NULL),
('Hi-Way Inn', 254, '2019-05-19', 228, NULL),
('Hi-Way Inn', 254, '2019-05-20', 343, NULL),
('Hi-Way Inn', 254, '2019-05-21', 358, NULL),
('Hi-Way Inn', 254, '2019-05-22', 213, NULL),
('Hi-Way Inn', 254, '2019-05-23', 279, NULL),
('Hi-Way Inn', 254, '2019-05-24', 352, NULL),
('Hi-Way Inn', 254, '2019-05-25', 180, NULL),
('Hi-Way Inn', 254, '2019-05-26', 122, NULL),
('Hi-Way Inn', 254, '2019-05-27', 353, NULL),
('Hi-Way Inn', 254, '2019-05-28', 216, NULL),
('Hi-Way Inn', 254, '2019-05-29', 304, NULL),
('Hi-Way Inn', 254, '2019-05-30', 160, NULL),
('Hi-Way Inn', 254, '2019-05-31', 257, NULL),
('Hi-Way Inn', 254, '2019-06-01', 207, NULL),
('Hi-Way Inn', 254, '2019-06-02', 329, NULL),
('Hi-Way Inn', 254, '2019-06-03', 203, NULL),
('Hi-Way Inn', 254, '2019-06-04', 317, NULL),
('Hi-Way Inn', 254, '2019-06-05', 283, NULL),
('Hi-Way Inn', 254, '2019-06-06', 267, NULL),
('Hi-Way Inn', 254, '2019-06-07', 223, NULL),
('Hi-Way Inn', 254, '2019-06-08', 139, NULL),
('Hi-Way Inn', 254, '2019-06-09', 372, NULL),
('Hi-Way Inn', 254, '2019-06-10', 256, NULL),
('Hi-Way Inn', 254, '2019-06-11', 253, NULL),
('Hi-Way Inn', 254, '2019-06-12', 100, NULL),
('Hi-Way Inn', 254, '2019-06-13', 372, NULL),
('Hi-Way Inn', 254, '2019-06-14', 272, NULL),
('Hi-Way Inn', 254, '2019-06-15', 266, NULL),
('Hi-Way Inn', 254, '2019-06-16', 206, NULL),
('Hi-Way Inn', 254, '2019-06-17', 134, NULL),
('Hi-Way Inn', 254, '2019-06-18', 256, NULL),
('Hi-Way Inn', 254, '2019-06-19', 376, NULL),
('Hi-Way Inn', 254, '2019-06-20', 361, NULL),
('Hi-Way Inn', 254, '2019-06-21', 345, NULL),
('Hi-Way Inn', 254, '2019-06-22', 244, NULL),
('Hi-Way Inn', 254, '2019-06-23', 188, NULL),
('Hi-Way Inn', 254, '2019-06-24', 347, NULL),
('Hi-Way Inn', 254, '2019-06-25', 388, NULL),
('Hi-Way Inn', 254, '2019-06-26', 310, NULL),
('Hi-Way Inn', 254, '2019-06-27', 250, NULL),
('Hi-Way Inn', 254, '2019-06-28', 390, NULL),
('Hi-Way Inn', 254, '2019-06-29', 171, NULL),
('Hi-Way Inn', 254, '2019-06-30', 363, NULL),
('Hi-Way Inn', 254, '2019-07-01', 154, NULL),
('Hi-Way Inn', 254, '2019-07-02', 240, NULL),
('Hi-Way Inn', 254, '2019-07-03', 253, NULL),
('Hi-Way Inn', 254, '2019-07-04', 350, NULL),
('Hi-Way Inn', 254, '2019-07-05', 193, NULL),
('Hi-Way Inn', 254, '2019-07-06', 163, NULL),
('Hi-Way Inn', 254, '2019-07-07', 146, NULL),
('Hi-Way Inn', 254, '2019-07-08', 354, NULL),
('Hi-Way Inn', 254, '2019-07-09', 354, NULL),
('Hi-Way Inn', 254, '2019-07-10', 121, NULL),
('Hi-Way Inn', 254, '2019-07-11', 110, NULL),
('Hi-Way Inn', 254, '2019-07-12', 347, NULL),
('Hi-Way Inn', 254, '2019-07-13', 162, NULL),
('Hi-Way Inn', 254, '2019-07-14', 160, NULL),
('Hi-Way Inn', 254, '2019-07-15', 382, NULL),
('Hi-Way Inn', 254, '2019-07-16', 234, NULL),
('Hi-Way Inn', 254, '2019-07-17', 323, NULL),
('Hi-Way Inn', 254, '2019-07-18', 207, NULL),
('Hi-Way Inn', 254, '2019-07-19', 204, NULL),
('Hi-Way Inn', 254, '2019-07-20', 163, NULL),
('Hi-Way Inn', 254, '2019-07-21', 343, NULL),
('Hi-Way Inn', 254, '2019-07-22', 118, NULL),
('Hi-Way Inn', 254, '2019-07-23', 347, NULL),
('Hi-Way Inn', 254, '2019-07-24', 358, NULL),
('Hi-Way Inn', 254, '2019-07-25', 335, NULL),
('Hi-Way Inn', 254, '2019-07-26', 318, NULL),
('Hi-Way Inn', 254, '2019-07-27', 271, NULL),
('Hi-Way Inn', 254, '2019-07-28', 337, NULL),
('Hi-Way Inn', 254, '2019-07-29', 325, NULL),
('Hi-Way Inn', 254, '2019-07-30', 323, NULL),
('Hi-Way Inn', 254, '2019-07-31', 176, NULL),
('Hi-Way Inn', 254, '2019-08-01', 319, NULL),
('Hi-Way Inn', 254, '2019-08-02', 355, NULL),
('Hi-Way Inn', 254, '2019-08-03', 211, NULL),
('Hi-Way Inn', 254, '2019-08-04', 267, NULL),
('Hi-Way Inn', 254, '2019-08-05', 207, NULL),
('Hi-Way Inn', 254, '2019-08-06', 233, NULL),
('Hi-Way Inn', 254, '2019-08-07', 114, NULL),
('Hi-Way Inn', 254, '2019-08-08', 390, NULL),
('Hi-Way Inn', 254, '2019-08-09', 256, NULL),
('Hi-Way Inn', 254, '2019-08-10', 208, NULL),
('Hi-Way Inn', 254, '2019-08-11', 126, NULL),
('Hi-Way Inn', 254, '2019-08-12', 167, NULL),
('Hi-Way Inn', 254, '2019-08-13', 101, NULL),
('Hi-Way Inn', 254, '2019-08-14', 383, NULL),
('Hi-Way Inn', 254, '2019-08-15', 121, NULL),
('Hi-Way Inn', 254, '2019-08-16', 222, NULL),
('Hi-Way Inn', 254, '2019-08-17', 146, NULL),
('Hi-Way Inn', 254, '2019-08-18', 194, NULL),
('Hi-Way Inn', 254, '2019-08-19', 102, NULL),
('Hi-Way Inn', 254, '2019-08-20', 288, NULL),
('Hi-Way Inn', 254, '2019-08-21', 114, NULL),
('Hi-Way Inn', 254, '2019-08-22', 289, NULL),
('Hi-Way Inn', 254, '2019-08-23', 219, NULL),
('Hi-Way Inn', 254, '2019-08-24', 386, NULL),
('Hi-Way Inn', 254, '2019-08-25', 359, NULL),
('Hi-Way Inn', 254, '2019-08-26', 212, NULL),
('Hi-Way Inn', 254, '2019-08-27', 286, NULL),
('Hi-Way Inn', 254, '2019-08-28', 159, NULL),
('Hi-Way Inn', 254, '2019-08-29', 284, NULL),
('Hi-Way Inn', 254, '2019-08-30', 319, NULL),
('Hi-Way Inn', 254, '2019-08-31', 240, NULL),
('Hi-Way Inn', 254, '2019-09-01', 201, NULL),
('Hi-Way Inn', 254, '2019-09-02', 122, NULL),
('Hi-Way Inn', 254, '2019-09-03', 174, NULL),
('Hi-Way Inn', 254, '2019-09-04', 361, NULL),
('Hi-Way Inn', 254, '2019-09-05', 101, NULL),
('Hi-Way Inn', 254, '2019-09-06', 151, NULL),
('Hi-Way Inn', 254, '2019-09-07', 348, NULL),
('Hi-Way Inn', 254, '2019-09-08', 204, NULL),
('Hi-Way Inn', 254, '2019-09-09', 372, NULL),
('Hi-Way Inn', 254, '2019-09-10', 208, NULL),
('Hi-Way Inn', 254, '2019-09-11', 229, NULL),
('Hi-Way Inn', 254, '2019-09-12', 158, NULL),
('Hi-Way Inn', 254, '2019-09-13', 398, NULL),
('Hi-Way Inn', 254, '2019-09-14', 281, NULL),
('Hi-Way Inn', 254, '2019-09-15', 330, NULL),
('Hi-Way Inn', 254, '2019-09-16', 328, NULL),
('Hi-Way Inn', 254, '2019-09-17', 308, NULL),
('Hi-Way Inn', 254, '2019-09-18', 286, NULL),
('Hi-Way Inn', 254, '2019-09-19', 375, NULL),
('Hi-Way Inn', 254, '2019-09-20', 317, NULL),
('Hi-Way Inn', 254, '2019-09-21', 151, NULL),
('Hi-Way Inn', 254, '2019-09-22', 242, NULL),
('Hi-Way Inn', 254, '2019-09-23', 239, NULL),
('Hi-Way Inn', 254, '2019-09-24', 303, NULL),
('Hi-Way Inn', 254, '2019-09-25', 307, NULL),
('Hi-Way Inn', 254, '2019-09-26', 142, NULL),
('Hi-Way Inn', 254, '2019-09-27', 264, NULL),
('Hi-Way Inn', 254, '2019-09-28', 396, NULL),
('Hi-Way Inn', 254, '2019-09-29', 155, NULL),
('Hi-Way Inn', 254, '2019-09-30', 179, NULL),
('Hi-Way Inn', 254, '2019-10-01', 369, NULL),
('Hi-Way Inn', 254, '2019-10-02', 321, NULL),
('Hi-Way Inn', 254, '2019-10-03', 283, NULL),
('Hi-Way Inn', 254, '2019-10-04', 258, NULL),
('Hi-Way Inn', 254, '2019-10-05', 126, NULL),
('Hi-Way Inn', 254, '2019-10-06', 269, NULL),
('Hi-Way Inn', 254, '2019-10-07', 268, NULL),
('Hi-Way Inn', 254, '2019-10-08', 206, NULL),
('Hi-Way Inn', 254, '2019-10-09', 340, NULL),
('Hi-Way Inn', 254, '2019-10-10', 291, NULL),
('Hi-Way Inn', 254, '2019-10-11', 222, NULL),
('Hi-Way Inn', 254, '2019-10-12', 381, NULL),
('Hi-Way Inn', 254, '2019-10-13', 219, NULL),
('Hi-Way Inn', 254, '2019-10-14', 123, NULL),
('Hi-Way Inn', 254, '2019-10-15', 351, NULL),
('Hi-Way Inn', 254, '2019-10-16', 368, NULL),
('Hi-Way Inn', 254, '2019-10-17', 195, NULL),
('Hi-Way Inn', 254, '2019-10-18', 324, NULL),
('Hi-Way Inn', 254, '2019-10-19', 116, NULL),
('Hi-Way Inn', 254, '2019-10-20', 253, NULL),
('Hi-Way Inn', 254, '2019-10-21', 359, NULL),
('Hi-Way Inn', 254, '2019-10-22', 112, NULL),
('Hi-Way Inn', 254, '2019-10-23', 260, NULL),
('Hi-Way Inn', 254, '2019-10-24', 163, NULL),
('Hi-Way Inn', 254, '2019-10-25', 207, NULL),
('Hi-Way Inn', 254, '2019-10-26', 201, NULL),
('Hi-Way Inn', 254, '2019-10-27', 172, NULL),
('Hi-Way Inn', 254, '2019-10-28', 330, NULL),
('Hi-Way Inn', 254, '2019-10-29', 264, NULL),
('Hi-Way Inn', 254, '2019-10-30', 396, NULL),
('Hi-Way Inn', 254, '2019-10-31', 390, NULL),
('Hi-Way Inn', 254, '2019-11-01', 206, NULL),
('Hi-Way Inn', 254, '2019-11-02', 236, NULL),
('Hi-Way Inn', 254, '2019-11-03', 283, NULL),
('Hi-Way Inn', 254, '2019-11-04', 108, NULL),
('Hi-Way Inn', 254, '2019-11-05', 211, NULL),
('Hi-Way Inn', 254, '2019-11-06', 176, NULL),
('Hi-Way Inn', 254, '2019-11-07', 188, NULL),
('Hi-Way Inn', 254, '2019-11-08', 331, NULL),
('Hi-Way Inn', 254, '2019-11-09', 299, NULL),
('Hi-Way Inn', 254, '2019-11-10', 132, NULL),
('Hi-Way Inn', 254, '2019-11-11', 325, NULL),
('Hi-Way Inn', 254, '2019-11-12', 298, NULL),
('Hi-Way Inn', 254, '2019-11-13', 392, NULL),
('Hi-Way Inn', 254, '2019-11-14', 391, NULL),
('Hi-Way Inn', 254, '2019-11-15', 225, NULL),
('Hi-Way Inn', 254, '2019-11-16', 157, NULL),
('Hi-Way Inn', 254, '2019-11-17', 338, NULL),
('Hi-Way Inn', 254, '2019-11-18', 233, NULL),
('Hi-Way Inn', 254, '2019-11-19', 381, NULL),
('Hi-Way Inn', 254, '2019-11-20', 158, NULL),
('Hi-Way Inn', 254, '2019-11-21', 256, NULL),
('Hi-Way Inn', 254, '2019-11-22', 225, NULL),
('Hi-Way Inn', 254, '2019-11-23', 249, NULL),
('Hi-Way Inn', 254, '2019-11-24', 296, NULL),
('Hi-Way Inn', 254, '2019-11-25', 333, NULL),
('Hi-Way Inn', 254, '2019-11-26', 154, NULL),
('Hi-Way Inn', 254, '2019-11-27', 340, NULL),
('Hi-Way Inn', 254, '2019-11-28', 310, NULL),
('Hi-Way Inn', 254, '2019-11-29', 381, NULL),
('Hi-Way Inn', 254, '2019-11-30', 101, NULL),
('Hi-Way Inn', 254, '2019-12-01', 127, NULL),
('Hi-Way Inn', 254, '2019-12-02', 122, NULL),
('Hi-Way Inn', 254, '2019-12-03', 159, NULL),
('Hi-Way Inn', 254, '2019-12-04', 220, NULL),
('Hi-Way Inn', 254, '2019-12-05', 209, NULL),
('Hi-Way Inn', 254, '2019-12-06', 283, NULL),
('Hi-Way Inn', 254, '2019-12-07', 226, NULL),
('Hi-Way Inn', 254, '2019-12-08', 292, NULL),
('Hi-Way Inn', 254, '2019-12-09', 321, NULL),
('Hi-Way Inn', 254, '2019-12-10', 233, NULL),
('Hi-Way Inn', 254, '2019-12-11', 330, NULL),
('Hi-Way Inn', 254, '2019-12-12', 187, NULL),
('Hi-Way Inn', 254, '2019-12-13', 201, NULL),
('Hi-Way Inn', 254, '2019-12-14', 275, NULL),
('Hi-Way Inn', 254, '2019-12-15', 201, NULL),
('Hi-Way Inn', 254, '2019-12-16', 362, NULL),
('Hi-Way Inn', 254, '2019-12-17', 258, NULL),
('Hi-Way Inn', 254, '2019-12-18', 176, NULL),
('Hi-Way Inn', 254, '2019-12-19', 377, NULL),
('Hi-Way Inn', 254, '2019-12-20', 163, NULL),
('Hi-Way Inn', 254, '2019-12-21', 163, NULL),
('Hi-Way Inn', 254, '2019-12-22', 255, NULL),
('Hi-Way Inn', 254, '2019-12-23', 181, NULL),
('Hi-Way Inn', 254, '2019-12-24', 316, NULL),
('Hi-Way Inn', 254, '2019-12-25', 365, NULL),
('Hi-Way Inn', 254, '2019-12-26', 344, NULL),
('Hi-Way Inn', 254, '2019-12-27', 380, NULL),
('Hi-Way Inn', 254, '2019-12-28', 343, NULL),
('Hi-Way Inn', 254, '2019-12-29', 166, NULL),
('Hi-Way Inn', 254, '2019-12-30', 123, NULL),
('Hi-Way Inn', 254, '2019-12-31', 170, NULL),
('Hi-Way Inn', 254, '2020-01-01', 381, NULL),
('Hi-Way Inn', 254, '2020-01-02', 137, NULL),
('Hi-Way Inn', 254, '2020-01-03', 232, NULL),
('Hi-Way Inn', 254, '2020-01-04', 131, NULL),
('Hi-Way Inn', 254, '2020-01-05', 257, NULL),
('Hi-Way Inn', 254, '2020-01-06', 227, NULL),
('Hi-Way Inn', 254, '2020-01-07', 267, NULL),
('Hi-Way Inn', 254, '2020-01-08', 130, NULL),
('Hi-Way Inn', 254, '2020-01-09', 250, NULL),
('Hi-Way Inn', 254, '2020-01-10', 143, NULL),
('Hi-Way Inn', 254, '2020-01-11', 316, NULL),
('Hi-Way Inn', 254, '2020-01-12', 176, NULL),
('Hi-Way Inn', 254, '2020-01-13', 322, NULL),
('Hi-Way Inn', 254, '2020-01-14', 227, NULL),
('Hi-Way Inn', 254, '2020-01-15', 303, NULL),
('Hi-Way Inn', 254, '2020-01-16', 177, NULL),
('Hi-Way Inn', 254, '2020-01-17', 111, NULL),
('Hi-Way Inn', 254, '2020-01-18', 339, NULL),
('Hi-Way Inn', 254, '2020-01-19', 341, NULL),
('Hi-Way Inn', 254, '2020-01-20', 195, NULL),
('Hi-Way Inn', 254, '2020-01-21', 329, NULL),
('Hi-Way Inn', 254, '2020-01-22', 172, NULL),
('Hi-Way Inn', 254, '2020-01-23', 201, NULL),
('Hi-Way Inn', 254, '2020-01-24', 242, NULL),
('Hi-Way Inn', 254, '2020-01-25', 244, NULL),
('Hi-Way Inn', 254, '2020-01-26', 380, NULL),
('Hi-Way Inn', 254, '2020-01-27', 286, NULL),
('Hi-Way Inn', 254, '2020-01-28', 245, NULL),
('Hi-Way Inn', 254, '2020-01-29', 263, NULL),
('Hi-Way Inn', 254, '2020-01-30', 190, NULL),
('Hi-Way Inn', 254, '2020-01-31', 355, NULL),
('Hi-Way Inn', 254, '2020-02-01', 145, NULL),
('Hi-Way Inn', 254, '2020-02-02', 390, NULL),
('Hi-Way Inn', 254, '2020-02-03', 111, NULL),
('Hi-Way Inn', 254, '2020-02-04', 312, NULL),
('Hi-Way Inn', 263, '2019-01-01', 139, NULL),
('Hi-Way Inn', 263, '2019-01-02', 216, NULL),
('Hi-Way Inn', 263, '2019-01-03', 388, NULL),
('Hi-Way Inn', 263, '2019-01-04', 225, NULL),
('Hi-Way Inn', 263, '2019-01-05', 348, NULL),
('Hi-Way Inn', 263, '2019-01-06', 161, NULL),
('Hi-Way Inn', 263, '2019-01-07', 185, NULL),
('Hi-Way Inn', 263, '2019-01-08', 337, NULL),
('Hi-Way Inn', 263, '2019-01-09', 345, NULL),
('Hi-Way Inn', 263, '2019-01-10', 387, NULL),
('Hi-Way Inn', 263, '2019-01-11', 156, NULL),
('Hi-Way Inn', 263, '2019-01-12', 146, NULL),
('Hi-Way Inn', 263, '2019-01-13', 221, NULL),
('Hi-Way Inn', 263, '2019-01-14', 255, NULL),
('Hi-Way Inn', 263, '2019-01-15', 119, NULL),
('Hi-Way Inn', 263, '2019-01-16', 209, NULL),
('Hi-Way Inn', 263, '2019-01-17', 251, NULL),
('Hi-Way Inn', 263, '2019-01-18', 207, NULL),
('Hi-Way Inn', 263, '2019-01-19', 302, NULL),
('Hi-Way Inn', 263, '2019-01-20', 391, NULL),
('Hi-Way Inn', 263, '2019-01-21', 309, NULL),
('Hi-Way Inn', 263, '2019-01-22', 330, NULL),
('Hi-Way Inn', 263, '2019-01-23', 186, NULL),
('Hi-Way Inn', 263, '2019-01-24', 171, NULL),
('Hi-Way Inn', 263, '2019-01-25', 279, NULL),
('Hi-Way Inn', 263, '2019-01-26', 194, NULL),
('Hi-Way Inn', 263, '2019-01-27', 245, NULL),
('Hi-Way Inn', 263, '2019-01-28', 316, NULL),
('Hi-Way Inn', 263, '2019-01-29', 134, NULL),
('Hi-Way Inn', 263, '2019-01-30', 261, NULL),
('Hi-Way Inn', 263, '2019-01-31', 150, NULL),
('Hi-Way Inn', 263, '2019-02-01', 343, NULL),
('Hi-Way Inn', 263, '2019-02-02', 173, NULL),
('Hi-Way Inn', 263, '2019-02-03', 192, NULL),
('Hi-Way Inn', 263, '2019-02-04', 313, NULL),
('Hi-Way Inn', 263, '2019-02-05', 187, NULL),
('Hi-Way Inn', 263, '2019-02-06', 390, NULL),
('Hi-Way Inn', 263, '2019-02-07', 389, NULL),
('Hi-Way Inn', 263, '2019-02-08', 355, NULL),
('Hi-Way Inn', 263, '2019-02-09', 249, NULL),
('Hi-Way Inn', 263, '2019-02-10', 232, NULL),
('Hi-Way Inn', 263, '2019-02-11', 207, NULL),
('Hi-Way Inn', 263, '2019-02-12', 390, NULL),
('Hi-Way Inn', 263, '2019-02-13', 301, NULL),
('Hi-Way Inn', 263, '2019-02-14', 154, NULL),
('Hi-Way Inn', 263, '2019-02-15', 214, NULL),
('Hi-Way Inn', 263, '2019-02-16', 161, NULL),
('Hi-Way Inn', 263, '2019-02-17', 275, NULL),
('Hi-Way Inn', 263, '2019-02-18', 334, NULL),
('Hi-Way Inn', 263, '2019-02-19', 264, NULL),
('Hi-Way Inn', 263, '2019-02-20', 192, NULL),
('Hi-Way Inn', 263, '2019-02-21', 264, NULL),
('Hi-Way Inn', 263, '2019-02-22', 184, NULL),
('Hi-Way Inn', 263, '2019-02-23', 366, NULL),
('Hi-Way Inn', 263, '2019-02-24', 354, NULL),
('Hi-Way Inn', 263, '2019-02-25', 171, NULL),
('Hi-Way Inn', 263, '2019-02-26', 311, NULL),
('Hi-Way Inn', 263, '2019-02-27', 386, NULL),
('Hi-Way Inn', 263, '2019-02-28', 290, NULL),
('Hi-Way Inn', 263, '2019-03-01', 314, NULL),
('Hi-Way Inn', 263, '2019-03-02', 231, NULL),
('Hi-Way Inn', 263, '2019-03-03', 267, NULL),
('Hi-Way Inn', 263, '2019-03-04', 173, NULL),
('Hi-Way Inn', 263, '2019-03-05', 169, NULL),
('Hi-Way Inn', 263, '2019-03-06', 367, NULL),
('Hi-Way Inn', 263, '2019-03-07', 146, NULL),
('Hi-Way Inn', 263, '2019-03-08', 268, NULL),
('Hi-Way Inn', 263, '2019-03-09', 100, NULL),
('Hi-Way Inn', 263, '2019-03-10', 187, NULL),
('Hi-Way Inn', 263, '2019-03-11', 355, NULL),
('Hi-Way Inn', 263, '2019-03-12', 276, NULL),
('Hi-Way Inn', 263, '2019-03-13', 148, NULL),
('Hi-Way Inn', 263, '2019-03-14', 187, NULL),
('Hi-Way Inn', 263, '2019-03-15', 329, NULL),
('Hi-Way Inn', 263, '2019-03-16', 361, NULL),
('Hi-Way Inn', 263, '2019-03-17', 193, NULL),
('Hi-Way Inn', 263, '2019-03-18', 130, NULL),
('Hi-Way Inn', 263, '2019-03-19', 302, NULL),
('Hi-Way Inn', 263, '2019-03-20', 295, NULL),
('Hi-Way Inn', 263, '2019-03-21', 231, NULL),
('Hi-Way Inn', 263, '2019-03-22', 173, NULL),
('Hi-Way Inn', 263, '2019-03-23', 341, NULL),
('Hi-Way Inn', 263, '2019-03-24', 259, NULL),
('Hi-Way Inn', 263, '2019-03-25', 123, NULL),
('Hi-Way Inn', 263, '2019-03-26', 141, NULL),
('Hi-Way Inn', 263, '2019-03-27', 366, NULL),
('Hi-Way Inn', 263, '2019-03-28', 238, NULL),
('Hi-Way Inn', 263, '2019-03-29', 165, NULL),
('Hi-Way Inn', 263, '2019-03-30', 255, NULL),
('Hi-Way Inn', 263, '2019-03-31', 134, NULL),
('Hi-Way Inn', 263, '2019-04-01', 160, NULL),
('Hi-Way Inn', 263, '2019-04-02', 207, NULL),
('Hi-Way Inn', 263, '2019-04-03', 265, NULL),
('Hi-Way Inn', 263, '2019-04-04', 393, NULL),
('Hi-Way Inn', 263, '2019-04-05', 288, NULL),
('Hi-Way Inn', 263, '2019-04-06', 396, NULL),
('Hi-Way Inn', 263, '2019-04-07', 253, NULL),
('Hi-Way Inn', 263, '2019-04-08', 105, NULL),
('Hi-Way Inn', 263, '2019-04-09', 205, NULL),
('Hi-Way Inn', 263, '2019-04-10', 181, NULL),
('Hi-Way Inn', 263, '2019-04-11', 228, NULL),
('Hi-Way Inn', 263, '2019-04-12', 149, NULL),
('Hi-Way Inn', 263, '2019-04-13', 175, NULL),
('Hi-Way Inn', 263, '2019-04-14', 190, NULL),
('Hi-Way Inn', 263, '2019-04-15', 339, NULL),
('Hi-Way Inn', 263, '2019-04-16', 256, NULL),
('Hi-Way Inn', 263, '2019-04-17', 188, NULL),
('Hi-Way Inn', 263, '2019-04-18', 320, NULL),
('Hi-Way Inn', 263, '2019-04-19', 343, NULL),
('Hi-Way Inn', 263, '2019-04-20', 374, NULL),
('Hi-Way Inn', 263, '2019-04-21', 205, NULL),
('Hi-Way Inn', 263, '2019-04-22', 238, NULL),
('Hi-Way Inn', 263, '2019-04-23', 243, NULL),
('Hi-Way Inn', 263, '2019-04-24', 304, NULL),
('Hi-Way Inn', 263, '2019-04-25', 289, NULL),
('Hi-Way Inn', 263, '2019-04-26', 261, NULL),
('Hi-Way Inn', 263, '2019-04-27', 332, NULL),
('Hi-Way Inn', 263, '2019-04-28', 169, NULL),
('Hi-Way Inn', 263, '2019-04-29', 251, NULL),
('Hi-Way Inn', 263, '2019-04-30', 219, NULL),
('Hi-Way Inn', 263, '2019-05-01', 224, NULL),
('Hi-Way Inn', 263, '2019-05-02', 305, NULL),
('Hi-Way Inn', 263, '2019-05-03', 336, NULL),
('Hi-Way Inn', 263, '2019-05-04', 290, NULL),
('Hi-Way Inn', 263, '2019-05-05', 227, NULL),
('Hi-Way Inn', 263, '2019-05-06', 188, NULL),
('Hi-Way Inn', 263, '2019-05-07', 110, NULL),
('Hi-Way Inn', 263, '2019-05-08', 248, NULL),
('Hi-Way Inn', 263, '2019-05-09', 223, NULL),
('Hi-Way Inn', 263, '2019-05-10', 364, NULL),
('Hi-Way Inn', 263, '2019-05-11', 332, NULL),
('Hi-Way Inn', 263, '2019-05-12', 100, NULL),
('Hi-Way Inn', 263, '2019-05-13', 381, NULL),
('Hi-Way Inn', 263, '2019-05-14', 382, NULL),
('Hi-Way Inn', 263, '2019-05-15', 154, NULL),
('Hi-Way Inn', 263, '2019-05-16', 236, NULL),
('Hi-Way Inn', 263, '2019-05-17', 388, NULL),
('Hi-Way Inn', 263, '2019-05-18', 397, NULL),
('Hi-Way Inn', 263, '2019-05-19', 154, NULL),
('Hi-Way Inn', 263, '2019-05-20', 143, NULL),
('Hi-Way Inn', 263, '2019-05-21', 236, NULL),
('Hi-Way Inn', 263, '2019-05-22', 224, NULL),
('Hi-Way Inn', 263, '2019-05-23', 112, NULL),
('Hi-Way Inn', 263, '2019-05-24', 359, NULL),
('Hi-Way Inn', 263, '2019-05-25', 111, NULL),
('Hi-Way Inn', 263, '2019-05-26', 308, NULL),
('Hi-Way Inn', 263, '2019-05-27', 121, NULL),
('Hi-Way Inn', 263, '2019-05-28', 132, NULL),
('Hi-Way Inn', 263, '2019-05-29', 241, NULL),
('Hi-Way Inn', 263, '2019-05-30', 144, NULL),
('Hi-Way Inn', 263, '2019-05-31', 135, NULL),
('Hi-Way Inn', 263, '2019-06-01', 188, NULL),
('Hi-Way Inn', 263, '2019-06-02', 182, NULL),
('Hi-Way Inn', 263, '2019-06-03', 385, NULL),
('Hi-Way Inn', 263, '2019-06-04', 167, NULL),
('Hi-Way Inn', 263, '2019-06-05', 340, NULL),
('Hi-Way Inn', 263, '2019-06-06', 343, NULL),
('Hi-Way Inn', 263, '2019-06-07', 328, NULL),
('Hi-Way Inn', 263, '2019-06-08', 287, NULL),
('Hi-Way Inn', 263, '2019-06-09', 380, NULL),
('Hi-Way Inn', 263, '2019-06-10', 279, NULL),
('Hi-Way Inn', 263, '2019-06-11', 172, NULL),
('Hi-Way Inn', 263, '2019-06-12', 137, NULL),
('Hi-Way Inn', 263, '2019-06-13', 340, NULL),
('Hi-Way Inn', 263, '2019-06-14', 190, NULL),
('Hi-Way Inn', 263, '2019-06-15', 229, NULL),
('Hi-Way Inn', 263, '2019-06-16', 233, NULL),
('Hi-Way Inn', 263, '2019-06-17', 344, NULL),
('Hi-Way Inn', 263, '2019-06-18', 165, NULL),
('Hi-Way Inn', 263, '2019-06-19', 192, NULL),
('Hi-Way Inn', 263, '2019-06-20', 379, NULL),
('Hi-Way Inn', 263, '2019-06-21', 184, NULL),
('Hi-Way Inn', 263, '2019-06-22', 159, NULL),
('Hi-Way Inn', 263, '2019-06-23', 192, NULL),
('Hi-Way Inn', 263, '2019-06-24', 194, NULL),
('Hi-Way Inn', 263, '2019-06-25', 262, NULL),
('Hi-Way Inn', 263, '2019-06-26', 122, NULL),
('Hi-Way Inn', 263, '2019-06-27', 120, NULL),
('Hi-Way Inn', 263, '2019-06-28', 141, NULL),
('Hi-Way Inn', 263, '2019-06-29', 212, NULL),
('Hi-Way Inn', 263, '2019-06-30', 254, NULL),
('Hi-Way Inn', 263, '2019-07-01', 242, NULL),
('Hi-Way Inn', 263, '2019-07-02', 196, NULL),
('Hi-Way Inn', 263, '2019-07-03', 222, NULL),
('Hi-Way Inn', 263, '2019-07-04', 253, NULL),
('Hi-Way Inn', 263, '2019-07-05', 273, NULL),
('Hi-Way Inn', 263, '2019-07-06', 227, NULL),
('Hi-Way Inn', 263, '2019-07-07', 318, NULL),
('Hi-Way Inn', 263, '2019-07-08', 264, NULL),
('Hi-Way Inn', 263, '2019-07-09', 293, NULL),
('Hi-Way Inn', 263, '2019-07-10', 388, NULL),
('Hi-Way Inn', 263, '2019-07-11', 273, NULL),
('Hi-Way Inn', 263, '2019-07-12', 261, NULL),
('Hi-Way Inn', 263, '2019-07-13', 215, NULL),
('Hi-Way Inn', 263, '2019-07-14', 330, NULL),
('Hi-Way Inn', 263, '2019-07-15', 114, NULL),
('Hi-Way Inn', 263, '2019-07-16', 243, NULL),
('Hi-Way Inn', 263, '2019-07-17', 228, NULL),
('Hi-Way Inn', 263, '2019-07-18', 209, NULL),
('Hi-Way Inn', 263, '2019-07-19', 158, NULL),
('Hi-Way Inn', 263, '2019-07-20', 201, NULL),
('Hi-Way Inn', 263, '2019-07-21', 385, NULL),
('Hi-Way Inn', 263, '2019-07-22', 212, NULL),
('Hi-Way Inn', 263, '2019-07-23', 354, NULL),
('Hi-Way Inn', 263, '2019-07-24', 334, NULL),
('Hi-Way Inn', 263, '2019-07-25', 125, NULL),
('Hi-Way Inn', 263, '2019-07-26', 314, NULL),
('Hi-Way Inn', 263, '2019-07-27', 168, NULL),
('Hi-Way Inn', 263, '2019-07-28', 224, NULL),
('Hi-Way Inn', 263, '2019-07-29', 350, NULL),
('Hi-Way Inn', 263, '2019-07-30', 396, NULL),
('Hi-Way Inn', 263, '2019-07-31', 182, NULL),
('Hi-Way Inn', 263, '2019-08-01', 304, NULL),
('Hi-Way Inn', 263, '2019-08-02', 101, NULL),
('Hi-Way Inn', 263, '2019-08-03', 131, NULL),
('Hi-Way Inn', 263, '2019-08-04', 125, NULL),
('Hi-Way Inn', 263, '2019-08-05', 129, NULL),
('Hi-Way Inn', 263, '2019-08-06', 220, NULL),
('Hi-Way Inn', 263, '2019-08-07', 179, NULL),
('Hi-Way Inn', 263, '2019-08-08', 325, NULL),
('Hi-Way Inn', 263, '2019-08-09', 338, NULL),
('Hi-Way Inn', 263, '2019-08-10', 322, NULL),
('Hi-Way Inn', 263, '2019-08-11', 120, NULL),
('Hi-Way Inn', 263, '2019-08-12', 144, NULL),
('Hi-Way Inn', 263, '2019-08-13', 316, NULL),
('Hi-Way Inn', 263, '2019-08-14', 145, NULL),
('Hi-Way Inn', 263, '2019-08-15', 221, NULL),
('Hi-Way Inn', 263, '2019-08-16', 252, NULL),
('Hi-Way Inn', 263, '2019-08-17', 385, NULL),
('Hi-Way Inn', 263, '2019-08-18', 116, NULL),
('Hi-Way Inn', 263, '2019-08-19', 253, NULL),
('Hi-Way Inn', 263, '2019-08-20', 329, NULL),
('Hi-Way Inn', 263, '2019-08-21', 382, NULL),
('Hi-Way Inn', 263, '2019-08-22', 131, NULL),
('Hi-Way Inn', 263, '2019-08-23', 388, NULL),
('Hi-Way Inn', 263, '2019-08-24', 327, NULL),
('Hi-Way Inn', 263, '2019-08-25', 327, NULL),
('Hi-Way Inn', 263, '2019-08-26', 134, NULL),
('Hi-Way Inn', 263, '2019-08-27', 343, NULL),
('Hi-Way Inn', 263, '2019-08-28', 285, NULL),
('Hi-Way Inn', 263, '2019-08-29', 139, NULL),
('Hi-Way Inn', 263, '2019-08-30', 115, NULL),
('Hi-Way Inn', 263, '2019-08-31', 387, NULL),
('Hi-Way Inn', 263, '2019-09-01', 113, NULL),
('Hi-Way Inn', 263, '2019-09-02', 200, NULL),
('Hi-Way Inn', 263, '2019-09-03', 398, NULL),
('Hi-Way Inn', 263, '2019-09-04', 180, NULL),
('Hi-Way Inn', 263, '2019-09-05', 259, NULL),
('Hi-Way Inn', 263, '2019-09-06', 174, NULL),
('Hi-Way Inn', 263, '2019-09-07', 295, NULL),
('Hi-Way Inn', 263, '2019-09-08', 266, NULL),
('Hi-Way Inn', 263, '2019-09-09', 376, NULL),
('Hi-Way Inn', 263, '2019-09-10', 230, NULL),
('Hi-Way Inn', 263, '2019-09-11', 118, NULL),
('Hi-Way Inn', 263, '2019-09-12', 390, NULL),
('Hi-Way Inn', 263, '2019-09-13', 241, NULL),
('Hi-Way Inn', 263, '2019-09-14', 258, NULL),
('Hi-Way Inn', 263, '2019-09-15', 312, NULL),
('Hi-Way Inn', 263, '2019-09-16', 228, NULL),
('Hi-Way Inn', 263, '2019-09-17', 399, NULL),
('Hi-Way Inn', 263, '2019-09-18', 381, NULL),
('Hi-Way Inn', 263, '2019-09-19', 316, NULL),
('Hi-Way Inn', 263, '2019-09-20', 262, NULL),
('Hi-Way Inn', 263, '2019-09-21', 368, NULL),
('Hi-Way Inn', 263, '2019-09-22', 227, NULL),
('Hi-Way Inn', 263, '2019-09-23', 192, NULL),
('Hi-Way Inn', 263, '2019-09-24', 130, NULL),
('Hi-Way Inn', 263, '2019-09-25', 182, NULL),
('Hi-Way Inn', 263, '2019-09-26', 124, NULL),
('Hi-Way Inn', 263, '2019-09-27', 210, NULL),
('Hi-Way Inn', 263, '2019-09-28', 349, NULL),
('Hi-Way Inn', 263, '2019-09-29', 325, NULL),
('Hi-Way Inn', 263, '2019-09-30', 358, NULL),
('Hi-Way Inn', 263, '2019-10-01', 282, NULL),
('Hi-Way Inn', 263, '2019-10-02', 238, NULL),
('Hi-Way Inn', 263, '2019-10-03', 120, NULL),
('Hi-Way Inn', 263, '2019-10-04', 162, NULL),
('Hi-Way Inn', 263, '2019-10-05', 211, NULL),
('Hi-Way Inn', 263, '2019-10-06', 270, NULL),
('Hi-Way Inn', 263, '2019-10-07', 191, NULL),
('Hi-Way Inn', 263, '2019-10-08', 125, NULL),
('Hi-Way Inn', 263, '2019-10-09', 350, NULL),
('Hi-Way Inn', 263, '2019-10-10', 138, NULL),
('Hi-Way Inn', 263, '2019-10-11', 183, NULL),
('Hi-Way Inn', 263, '2019-10-12', 289, NULL),
('Hi-Way Inn', 263, '2019-10-13', 376, NULL),
('Hi-Way Inn', 263, '2019-10-14', 270, NULL),
('Hi-Way Inn', 263, '2019-10-15', 287, NULL),
('Hi-Way Inn', 263, '2019-10-16', 153, NULL),
('Hi-Way Inn', 263, '2019-10-17', 107, NULL),
('Hi-Way Inn', 263, '2019-10-18', 202, NULL),
('Hi-Way Inn', 263, '2019-10-19', 391, NULL),
('Hi-Way Inn', 263, '2019-10-20', 158, NULL),
('Hi-Way Inn', 263, '2019-10-21', 274, NULL),
('Hi-Way Inn', 263, '2019-10-22', 381, NULL),
('Hi-Way Inn', 263, '2019-10-23', 309, NULL),
('Hi-Way Inn', 263, '2019-10-24', 160, NULL),
('Hi-Way Inn', 263, '2019-10-25', 101, NULL),
('Hi-Way Inn', 263, '2019-10-26', 261, NULL),
('Hi-Way Inn', 263, '2019-10-27', 195, NULL),
('Hi-Way Inn', 263, '2019-10-28', 270, NULL),
('Hi-Way Inn', 263, '2019-10-29', 387, NULL),
('Hi-Way Inn', 263, '2019-10-30', 157, NULL),
('Hi-Way Inn', 263, '2019-10-31', 171, NULL),
('Hi-Way Inn', 263, '2019-11-01', 121, NULL),
('Hi-Way Inn', 263, '2019-11-02', 281, NULL),
('Hi-Way Inn', 263, '2019-11-03', 282, NULL),
('Hi-Way Inn', 263, '2019-11-04', 292, NULL),
('Hi-Way Inn', 263, '2019-11-05', 397, NULL),
('Hi-Way Inn', 263, '2019-11-06', 254, NULL),
('Hi-Way Inn', 263, '2019-11-07', 272, NULL),
('Hi-Way Inn', 263, '2019-11-08', 116, NULL),
('Hi-Way Inn', 263, '2019-11-09', 304, NULL),
('Hi-Way Inn', 263, '2019-11-10', 265, NULL),
('Hi-Way Inn', 263, '2019-11-11', 247, NULL),
('Hi-Way Inn', 263, '2019-11-12', 270, NULL),
('Hi-Way Inn', 263, '2019-11-13', 278, NULL),
('Hi-Way Inn', 263, '2019-11-14', 208, NULL),
('Hi-Way Inn', 263, '2019-11-15', 298, NULL),
('Hi-Way Inn', 263, '2019-11-16', 112, NULL),
('Hi-Way Inn', 263, '2019-11-17', 159, NULL),
('Hi-Way Inn', 263, '2019-11-18', 271, NULL),
('Hi-Way Inn', 263, '2019-11-19', 372, NULL),
('Hi-Way Inn', 263, '2019-11-20', 245, NULL),
('Hi-Way Inn', 263, '2019-11-21', 306, NULL),
('Hi-Way Inn', 263, '2019-11-22', 254, NULL),
('Hi-Way Inn', 263, '2019-11-23', 114, NULL),
('Hi-Way Inn', 263, '2019-11-24', 273, NULL),
('Hi-Way Inn', 263, '2019-11-25', 395, NULL),
('Hi-Way Inn', 263, '2019-11-26', 309, NULL),
('Hi-Way Inn', 263, '2019-11-27', 222, NULL),
('Hi-Way Inn', 263, '2019-11-28', 238, NULL),
('Hi-Way Inn', 263, '2019-11-29', 397, NULL),
('Hi-Way Inn', 263, '2019-11-30', 219, NULL),
('Hi-Way Inn', 263, '2019-12-01', 332, NULL),
('Hi-Way Inn', 263, '2019-12-02', 172, NULL),
('Hi-Way Inn', 263, '2019-12-03', 358, NULL),
('Hi-Way Inn', 263, '2019-12-04', 337, NULL),
('Hi-Way Inn', 263, '2019-12-05', 217, NULL),
('Hi-Way Inn', 263, '2019-12-06', 163, NULL),
('Hi-Way Inn', 263, '2019-12-07', 245, NULL),
('Hi-Way Inn', 263, '2019-12-08', 139, NULL),
('Hi-Way Inn', 263, '2019-12-09', 330, NULL),
('Hi-Way Inn', 263, '2019-12-10', 372, NULL),
('Hi-Way Inn', 263, '2019-12-11', 362, NULL),
('Hi-Way Inn', 263, '2019-12-12', 130, NULL),
('Hi-Way Inn', 263, '2019-12-13', 192, NULL),
('Hi-Way Inn', 263, '2019-12-14', 245, NULL),
('Hi-Way Inn', 263, '2019-12-15', 288, NULL),
('Hi-Way Inn', 263, '2019-12-16', 235, NULL),
('Hi-Way Inn', 263, '2019-12-17', 200, NULL),
('Hi-Way Inn', 263, '2019-12-18', 301, NULL),
('Hi-Way Inn', 263, '2019-12-19', 340, NULL),
('Hi-Way Inn', 263, '2019-12-20', 100, NULL),
('Hi-Way Inn', 263, '2019-12-21', 244, NULL),
('Hi-Way Inn', 263, '2019-12-22', 204, NULL),
('Hi-Way Inn', 263, '2019-12-23', 382, NULL),
('Hi-Way Inn', 263, '2019-12-24', 198, NULL),
('Hi-Way Inn', 263, '2019-12-25', 100, NULL),
('Hi-Way Inn', 263, '2019-12-26', 113, NULL),
('Hi-Way Inn', 263, '2019-12-27', 356, NULL),
('Hi-Way Inn', 263, '2019-12-28', 119, NULL),
('Hi-Way Inn', 263, '2019-12-29', 275, NULL),
('Hi-Way Inn', 263, '2019-12-30', 349, NULL),
('Hi-Way Inn', 263, '2019-12-31', 238, NULL),
('Hi-Way Inn', 263, '2020-01-01', 324, NULL),
('Hi-Way Inn', 263, '2020-01-02', 183, NULL),
('Hi-Way Inn', 263, '2020-01-03', 383, NULL),
('Hi-Way Inn', 263, '2020-01-04', 156, NULL),
('Hi-Way Inn', 263, '2020-01-05', 394, NULL),
('Hi-Way Inn', 263, '2020-01-06', 169, NULL),
('Hi-Way Inn', 263, '2020-01-07', 173, NULL),
('Hi-Way Inn', 263, '2020-01-08', 372, NULL),
('Hi-Way Inn', 263, '2020-01-09', 164, NULL),
('Hi-Way Inn', 263, '2020-01-10', 187, NULL),
('Hi-Way Inn', 263, '2020-01-11', 195, NULL),
('Hi-Way Inn', 263, '2020-01-12', 302, NULL),
('Hi-Way Inn', 263, '2020-01-13', 266, NULL),
('Hi-Way Inn', 263, '2020-01-14', 163, NULL),
('Hi-Way Inn', 263, '2020-01-15', 354, NULL),
('Hi-Way Inn', 263, '2020-01-16', 205, NULL),
('Hi-Way Inn', 263, '2020-01-17', 190, NULL),
('Hi-Way Inn', 263, '2020-01-18', 280, NULL),
('Hi-Way Inn', 263, '2020-01-19', 367, NULL),
('Hi-Way Inn', 263, '2020-01-20', 332, NULL),
('Hi-Way Inn', 263, '2020-01-21', 313, NULL),
('Hi-Way Inn', 263, '2020-01-22', 242, NULL),
('Hi-Way Inn', 263, '2020-01-23', 197, NULL),
('Hi-Way Inn', 263, '2020-01-24', 179, NULL),
('Hi-Way Inn', 263, '2020-01-25', 113, NULL),
('Hi-Way Inn', 263, '2020-01-26', 375, NULL),
('Hi-Way Inn', 263, '2020-01-27', 143, NULL),
('Hi-Way Inn', 263, '2020-01-28', 314, NULL),
('Hi-Way Inn', 263, '2020-01-29', 296, NULL),
('Hi-Way Inn', 263, '2020-01-30', 258, NULL),
('Hi-Way Inn', 263, '2020-01-31', 225, NULL),
('Hi-Way Inn', 263, '2020-02-01', 320, NULL),
('Hi-Way Inn', 263, '2020-02-02', 286, NULL),
('Hi-Way Inn', 263, '2020-02-03', 100, NULL),
('Hi-Way Inn', 263, '2020-02-04', 371, NULL),
('Hi-Way Inn', 268, '2019-01-01', 246, NULL),
('Hi-Way Inn', 268, '2019-01-02', 230, NULL),
('Hi-Way Inn', 268, '2019-01-03', 211, NULL),
('Hi-Way Inn', 268, '2019-01-04', 145, NULL),
('Hi-Way Inn', 268, '2019-01-05', 111, NULL),
('Hi-Way Inn', 268, '2019-01-06', 159, NULL),
('Hi-Way Inn', 268, '2019-01-07', 376, NULL),
('Hi-Way Inn', 268, '2019-01-08', 377, NULL),
('Hi-Way Inn', 268, '2019-01-09', 344, NULL),
('Hi-Way Inn', 268, '2019-01-10', 398, NULL),
('Hi-Way Inn', 268, '2019-01-11', 325, NULL),
('Hi-Way Inn', 268, '2019-01-12', 265, NULL),
('Hi-Way Inn', 268, '2019-01-13', 177, NULL),
('Hi-Way Inn', 268, '2019-01-14', 370, NULL),
('Hi-Way Inn', 268, '2019-01-15', 339, NULL),
('Hi-Way Inn', 268, '2019-01-16', 123, NULL),
('Hi-Way Inn', 268, '2019-01-17', 255, NULL),
('Hi-Way Inn', 268, '2019-01-18', 209, NULL),
('Hi-Way Inn', 268, '2019-01-19', 259, NULL),
('Hi-Way Inn', 268, '2019-01-20', 151, NULL),
('Hi-Way Inn', 268, '2019-01-21', 147, NULL),
('Hi-Way Inn', 268, '2019-01-22', 377, NULL),
('Hi-Way Inn', 268, '2019-01-23', 383, NULL),
('Hi-Way Inn', 268, '2019-01-24', 195, NULL),
('Hi-Way Inn', 268, '2019-01-25', 321, NULL),
('Hi-Way Inn', 268, '2019-01-26', 359, NULL),
('Hi-Way Inn', 268, '2019-01-27', 116, NULL),
('Hi-Way Inn', 268, '2019-01-28', 307, NULL),
('Hi-Way Inn', 268, '2019-01-29', 172, NULL),
('Hi-Way Inn', 268, '2019-01-30', 138, NULL),
('Hi-Way Inn', 268, '2019-01-31', 228, NULL),
('Hi-Way Inn', 268, '2019-02-01', 228, NULL),
('Hi-Way Inn', 268, '2019-02-02', 330, NULL),
('Hi-Way Inn', 268, '2019-02-03', 272, NULL),
('Hi-Way Inn', 268, '2019-02-04', 328, NULL),
('Hi-Way Inn', 268, '2019-02-05', 260, NULL),
('Hi-Way Inn', 268, '2019-02-06', 377, NULL),
('Hi-Way Inn', 268, '2019-02-07', 388, NULL),
('Hi-Way Inn', 268, '2019-02-08', 373, NULL),
('Hi-Way Inn', 268, '2019-02-09', 137, NULL),
('Hi-Way Inn', 268, '2019-02-10', 370, NULL),
('Hi-Way Inn', 268, '2019-02-11', 209, NULL),
('Hi-Way Inn', 268, '2019-02-12', 157, NULL),
('Hi-Way Inn', 268, '2019-02-13', 382, NULL),
('Hi-Way Inn', 268, '2019-02-14', 399, NULL),
('Hi-Way Inn', 268, '2019-02-15', 148, NULL),
('Hi-Way Inn', 268, '2019-02-16', 263, NULL),
('Hi-Way Inn', 268, '2019-02-17', 260, NULL),
('Hi-Way Inn', 268, '2019-02-18', 284, NULL),
('Hi-Way Inn', 268, '2019-02-19', 369, NULL),
('Hi-Way Inn', 268, '2019-02-20', 255, NULL),
('Hi-Way Inn', 268, '2019-02-21', 126, NULL),
('Hi-Way Inn', 268, '2019-02-22', 310, NULL),
('Hi-Way Inn', 268, '2019-02-23', 343, NULL),
('Hi-Way Inn', 268, '2019-02-24', 397, NULL),
('Hi-Way Inn', 268, '2019-02-25', 278, NULL),
('Hi-Way Inn', 268, '2019-02-26', 203, NULL),
('Hi-Way Inn', 268, '2019-02-27', 354, NULL),
('Hi-Way Inn', 268, '2019-02-28', 191, NULL),
('Hi-Way Inn', 268, '2019-03-01', 148, NULL),
('Hi-Way Inn', 268, '2019-03-02', 128, NULL),
('Hi-Way Inn', 268, '2019-03-03', 180, NULL),
('Hi-Way Inn', 268, '2019-03-04', 226, NULL),
('Hi-Way Inn', 268, '2019-03-05', 141, NULL),
('Hi-Way Inn', 268, '2019-03-06', 256, NULL),
('Hi-Way Inn', 268, '2019-03-07', 372, NULL),
('Hi-Way Inn', 268, '2019-03-08', 232, NULL),
('Hi-Way Inn', 268, '2019-03-09', 291, NULL),
('Hi-Way Inn', 268, '2019-03-10', 164, NULL),
('Hi-Way Inn', 268, '2019-03-11', 262, NULL),
('Hi-Way Inn', 268, '2019-03-12', 236, NULL),
('Hi-Way Inn', 268, '2019-03-13', 221, NULL),
('Hi-Way Inn', 268, '2019-03-14', 323, NULL),
('Hi-Way Inn', 268, '2019-03-15', 313, NULL),
('Hi-Way Inn', 268, '2019-03-16', 280, NULL),
('Hi-Way Inn', 268, '2019-03-17', 132, NULL),
('Hi-Way Inn', 268, '2019-03-18', 101, NULL),
('Hi-Way Inn', 268, '2019-03-19', 285, NULL),
('Hi-Way Inn', 268, '2019-03-20', 155, NULL),
('Hi-Way Inn', 268, '2019-03-21', 240, NULL),
('Hi-Way Inn', 268, '2019-03-22', 291, NULL),
('Hi-Way Inn', 268, '2019-03-23', 314, NULL),
('Hi-Way Inn', 268, '2019-03-24', 256, NULL),
('Hi-Way Inn', 268, '2019-03-25', 391, NULL),
('Hi-Way Inn', 268, '2019-03-26', 331, NULL),
('Hi-Way Inn', 268, '2019-03-27', 344, NULL),
('Hi-Way Inn', 268, '2019-03-28', 231, NULL),
('Hi-Way Inn', 268, '2019-03-29', 266, NULL),
('Hi-Way Inn', 268, '2019-03-30', 114, NULL),
('Hi-Way Inn', 268, '2019-03-31', 265, NULL),
('Hi-Way Inn', 268, '2019-04-01', 222, NULL),
('Hi-Way Inn', 268, '2019-04-02', 275, NULL),
('Hi-Way Inn', 268, '2019-04-03', 222, NULL),
('Hi-Way Inn', 268, '2019-04-04', 252, NULL),
('Hi-Way Inn', 268, '2019-04-05', 375, NULL),
('Hi-Way Inn', 268, '2019-04-06', 255, NULL),
('Hi-Way Inn', 268, '2019-04-07', 272, NULL),
('Hi-Way Inn', 268, '2019-04-08', 171, NULL),
('Hi-Way Inn', 268, '2019-04-09', 332, NULL),
('Hi-Way Inn', 268, '2019-04-10', 267, NULL),
('Hi-Way Inn', 268, '2019-04-11', 313, NULL),
('Hi-Way Inn', 268, '2019-04-12', 304, NULL),
('Hi-Way Inn', 268, '2019-04-13', 353, NULL),
('Hi-Way Inn', 268, '2019-04-14', 106, NULL),
('Hi-Way Inn', 268, '2019-04-15', 233, NULL),
('Hi-Way Inn', 268, '2019-04-16', 366, NULL),
('Hi-Way Inn', 268, '2019-04-17', 392, NULL),
('Hi-Way Inn', 268, '2019-04-18', 309, NULL),
('Hi-Way Inn', 268, '2019-04-19', 312, NULL),
('Hi-Way Inn', 268, '2019-04-20', 122, NULL),
('Hi-Way Inn', 268, '2019-04-21', 250, NULL),
('Hi-Way Inn', 268, '2019-04-22', 206, NULL),
('Hi-Way Inn', 268, '2019-04-23', 180, NULL),
('Hi-Way Inn', 268, '2019-04-24', 271, NULL),
('Hi-Way Inn', 268, '2019-04-25', 281, NULL),
('Hi-Way Inn', 268, '2019-04-26', 132, NULL),
('Hi-Way Inn', 268, '2019-04-27', 113, NULL),
('Hi-Way Inn', 268, '2019-04-28', 189, NULL),
('Hi-Way Inn', 268, '2019-04-29', 215, NULL),
('Hi-Way Inn', 268, '2019-04-30', 307, NULL),
('Hi-Way Inn', 268, '2019-05-01', 242, NULL),
('Hi-Way Inn', 268, '2019-05-02', 369, NULL),
('Hi-Way Inn', 268, '2019-05-03', 190, NULL),
('Hi-Way Inn', 268, '2019-05-04', 294, NULL),
('Hi-Way Inn', 268, '2019-05-05', 229, NULL),
('Hi-Way Inn', 268, '2019-05-06', 216, NULL),
('Hi-Way Inn', 268, '2019-05-07', 335, NULL),
('Hi-Way Inn', 268, '2019-05-08', 122, NULL),
('Hi-Way Inn', 268, '2019-05-09', 350, NULL),
('Hi-Way Inn', 268, '2019-05-10', 215, NULL),
('Hi-Way Inn', 268, '2019-05-11', 397, NULL),
('Hi-Way Inn', 268, '2019-05-12', 276, NULL),
('Hi-Way Inn', 268, '2019-05-13', 355, NULL),
('Hi-Way Inn', 268, '2019-05-14', 346, NULL),
('Hi-Way Inn', 268, '2019-05-15', 379, NULL),
('Hi-Way Inn', 268, '2019-05-16', 171, NULL),
('Hi-Way Inn', 268, '2019-05-17', 318, NULL),
('Hi-Way Inn', 268, '2019-05-18', 112, NULL),
('Hi-Way Inn', 268, '2019-05-19', 288, NULL),
('Hi-Way Inn', 268, '2019-05-20', 188, NULL),
('Hi-Way Inn', 268, '2019-05-21', 307, NULL),
('Hi-Way Inn', 268, '2019-05-22', 380, NULL),
('Hi-Way Inn', 268, '2019-05-23', 224, NULL),
('Hi-Way Inn', 268, '2019-05-24', 339, NULL),
('Hi-Way Inn', 268, '2019-05-25', 213, NULL),
('Hi-Way Inn', 268, '2019-05-26', 175, NULL),
('Hi-Way Inn', 268, '2019-05-27', 344, NULL),
('Hi-Way Inn', 268, '2019-05-28', 211, NULL),
('Hi-Way Inn', 268, '2019-05-29', 193, NULL),
('Hi-Way Inn', 268, '2019-05-30', 141, NULL),
('Hi-Way Inn', 268, '2019-05-31', 102, NULL),
('Hi-Way Inn', 268, '2019-06-01', 219, NULL),
('Hi-Way Inn', 268, '2019-06-02', 125, NULL),
('Hi-Way Inn', 268, '2019-06-03', 319, NULL),
('Hi-Way Inn', 268, '2019-06-04', 385, NULL),
('Hi-Way Inn', 268, '2019-06-05', 152, NULL),
('Hi-Way Inn', 268, '2019-06-06', 214, NULL),
('Hi-Way Inn', 268, '2019-06-07', 270, NULL),
('Hi-Way Inn', 268, '2019-06-08', 318, NULL),
('Hi-Way Inn', 268, '2019-06-09', 385, NULL),
('Hi-Way Inn', 268, '2019-06-10', 228, NULL),
('Hi-Way Inn', 268, '2019-06-11', 300, NULL),
('Hi-Way Inn', 268, '2019-06-12', 284, NULL),
('Hi-Way Inn', 268, '2019-06-13', 183, NULL),
('Hi-Way Inn', 268, '2019-06-14', 334, NULL),
('Hi-Way Inn', 268, '2019-06-15', 248, NULL),
('Hi-Way Inn', 268, '2019-06-16', 149, NULL),
('Hi-Way Inn', 268, '2019-06-17', 319, NULL),
('Hi-Way Inn', 268, '2019-06-18', 258, NULL),
('Hi-Way Inn', 268, '2019-06-19', 331, NULL),
('Hi-Way Inn', 268, '2019-06-20', 114, NULL),
('Hi-Way Inn', 268, '2019-06-21', 387, NULL),
('Hi-Way Inn', 268, '2019-06-22', 264, NULL),
('Hi-Way Inn', 268, '2019-06-23', 294, NULL),
('Hi-Way Inn', 268, '2019-06-24', 131, NULL),
('Hi-Way Inn', 268, '2019-06-25', 344, NULL),
('Hi-Way Inn', 268, '2019-06-26', 182, NULL),
('Hi-Way Inn', 268, '2019-06-27', 349, NULL),
('Hi-Way Inn', 268, '2019-06-28', 334, NULL),
('Hi-Way Inn', 268, '2019-06-29', 147, NULL),
('Hi-Way Inn', 268, '2019-06-30', 379, NULL),
('Hi-Way Inn', 268, '2019-07-01', 351, NULL),
('Hi-Way Inn', 268, '2019-07-02', 160, NULL),
('Hi-Way Inn', 268, '2019-07-03', 250, NULL),
('Hi-Way Inn', 268, '2019-07-04', 115, NULL),
('Hi-Way Inn', 268, '2019-07-05', 387, NULL),
('Hi-Way Inn', 268, '2019-07-06', 245, NULL),
('Hi-Way Inn', 268, '2019-07-07', 149, NULL),
('Hi-Way Inn', 268, '2019-07-08', 157, NULL),
('Hi-Way Inn', 268, '2019-07-09', 303, NULL),
('Hi-Way Inn', 268, '2019-07-10', 278, NULL),
('Hi-Way Inn', 268, '2019-07-11', 336, NULL),
('Hi-Way Inn', 268, '2019-07-12', 168, NULL),
('Hi-Way Inn', 268, '2019-07-13', 187, NULL),
('Hi-Way Inn', 268, '2019-07-14', 167, NULL),
('Hi-Way Inn', 268, '2019-07-15', 225, NULL),
('Hi-Way Inn', 268, '2019-07-16', 115, NULL),
('Hi-Way Inn', 268, '2019-07-17', 372, NULL),
('Hi-Way Inn', 268, '2019-07-18', 326, NULL),
('Hi-Way Inn', 268, '2019-07-19', 379, NULL),
('Hi-Way Inn', 268, '2019-07-20', 116, NULL),
('Hi-Way Inn', 268, '2019-07-21', 194, NULL),
('Hi-Way Inn', 268, '2019-07-22', 308, NULL),
('Hi-Way Inn', 268, '2019-07-23', 328, NULL),
('Hi-Way Inn', 268, '2019-07-24', 197, NULL),
('Hi-Way Inn', 268, '2019-07-25', 119, NULL),
('Hi-Way Inn', 268, '2019-07-26', 215, NULL),
('Hi-Way Inn', 268, '2019-07-27', 230, NULL),
('Hi-Way Inn', 268, '2019-07-28', 311, NULL),
('Hi-Way Inn', 268, '2019-07-29', 374, NULL),
('Hi-Way Inn', 268, '2019-07-30', 309, NULL),
('Hi-Way Inn', 268, '2019-07-31', 284, NULL),
('Hi-Way Inn', 268, '2019-08-01', 163, NULL),
('Hi-Way Inn', 268, '2019-08-02', 241, NULL),
('Hi-Way Inn', 268, '2019-08-03', 222, NULL),
('Hi-Way Inn', 268, '2019-08-04', 325, NULL),
('Hi-Way Inn', 268, '2019-08-05', 222, NULL),
('Hi-Way Inn', 268, '2019-08-06', 299, NULL),
('Hi-Way Inn', 268, '2019-08-07', 153, NULL),
('Hi-Way Inn', 268, '2019-08-08', 357, NULL),
('Hi-Way Inn', 268, '2019-08-09', 222, NULL),
('Hi-Way Inn', 268, '2019-08-10', 285, NULL),
('Hi-Way Inn', 268, '2019-08-11', 124, NULL),
('Hi-Way Inn', 268, '2019-08-12', 118, NULL),
('Hi-Way Inn', 268, '2019-08-13', 278, NULL),
('Hi-Way Inn', 268, '2019-08-14', 375, NULL),
('Hi-Way Inn', 268, '2019-08-15', 342, NULL),
('Hi-Way Inn', 268, '2019-08-16', 194, NULL),
('Hi-Way Inn', 268, '2019-08-17', 185, NULL),
('Hi-Way Inn', 268, '2019-08-18', 200, NULL),
('Hi-Way Inn', 268, '2019-08-19', 256, NULL),
('Hi-Way Inn', 268, '2019-08-20', 380, NULL),
('Hi-Way Inn', 268, '2019-08-21', 269, NULL),
('Hi-Way Inn', 268, '2019-08-22', 286, NULL),
('Hi-Way Inn', 268, '2019-08-23', 284, NULL),
('Hi-Way Inn', 268, '2019-08-24', 377, NULL),
('Hi-Way Inn', 268, '2019-08-25', 158, NULL),
('Hi-Way Inn', 268, '2019-08-26', 235, NULL),
('Hi-Way Inn', 268, '2019-08-27', 156, NULL),
('Hi-Way Inn', 268, '2019-08-28', 246, NULL),
('Hi-Way Inn', 268, '2019-08-29', 341, NULL),
('Hi-Way Inn', 268, '2019-08-30', 117, NULL),
('Hi-Way Inn', 268, '2019-08-31', 213, NULL),
('Hi-Way Inn', 268, '2019-09-01', 161, NULL),
('Hi-Way Inn', 268, '2019-09-02', 233, NULL),
('Hi-Way Inn', 268, '2019-09-03', 170, NULL),
('Hi-Way Inn', 268, '2019-09-04', 317, NULL),
('Hi-Way Inn', 268, '2019-09-05', 293, NULL),
('Hi-Way Inn', 268, '2019-09-06', 317, NULL),
('Hi-Way Inn', 268, '2019-09-07', 330, NULL),
('Hi-Way Inn', 268, '2019-09-08', 317, NULL),
('Hi-Way Inn', 268, '2019-09-09', 365, NULL),
('Hi-Way Inn', 268, '2019-09-10', 126, NULL),
('Hi-Way Inn', 268, '2019-09-11', 103, NULL),
('Hi-Way Inn', 268, '2019-09-12', 176, NULL),
('Hi-Way Inn', 268, '2019-09-13', 213, NULL),
('Hi-Way Inn', 268, '2019-09-14', 346, NULL),
('Hi-Way Inn', 268, '2019-09-15', 170, NULL),
('Hi-Way Inn', 268, '2019-09-16', 354, NULL),
('Hi-Way Inn', 268, '2019-09-17', 371, NULL),
('Hi-Way Inn', 268, '2019-09-18', 350, NULL),
('Hi-Way Inn', 268, '2019-09-19', 358, NULL),
('Hi-Way Inn', 268, '2019-09-20', 260, NULL),
('Hi-Way Inn', 268, '2019-09-21', 388, NULL),
('Hi-Way Inn', 268, '2019-09-22', 309, NULL),
('Hi-Way Inn', 268, '2019-09-23', 142, NULL),
('Hi-Way Inn', 268, '2019-09-24', 243, NULL),
('Hi-Way Inn', 268, '2019-09-25', 193, NULL),
('Hi-Way Inn', 268, '2019-09-26', 395, NULL),
('Hi-Way Inn', 268, '2019-09-27', 160, NULL),
('Hi-Way Inn', 268, '2019-09-28', 159, NULL),
('Hi-Way Inn', 268, '2019-09-29', 164, NULL),
('Hi-Way Inn', 268, '2019-09-30', 256, NULL),
('Hi-Way Inn', 268, '2019-10-01', 204, NULL),
('Hi-Way Inn', 268, '2019-10-02', 130, NULL),
('Hi-Way Inn', 268, '2019-10-03', 252, NULL),
('Hi-Way Inn', 268, '2019-10-04', 238, NULL),
('Hi-Way Inn', 268, '2019-10-05', 278, NULL),
('Hi-Way Inn', 268, '2019-10-06', 144, NULL),
('Hi-Way Inn', 268, '2019-10-07', 355, NULL),
('Hi-Way Inn', 268, '2019-10-08', 207, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 268, '2019-10-09', 328, NULL),
('Hi-Way Inn', 268, '2019-10-10', 316, NULL),
('Hi-Way Inn', 268, '2019-10-11', 150, NULL),
('Hi-Way Inn', 268, '2019-10-12', 199, NULL),
('Hi-Way Inn', 268, '2019-10-13', 224, NULL),
('Hi-Way Inn', 268, '2019-10-14', 284, NULL),
('Hi-Way Inn', 268, '2019-10-15', 281, NULL),
('Hi-Way Inn', 268, '2019-10-16', 161, NULL),
('Hi-Way Inn', 268, '2019-10-17', 152, NULL),
('Hi-Way Inn', 268, '2019-10-18', 237, NULL),
('Hi-Way Inn', 268, '2019-10-19', 308, NULL),
('Hi-Way Inn', 268, '2019-10-20', 231, NULL),
('Hi-Way Inn', 268, '2019-10-21', 193, NULL),
('Hi-Way Inn', 268, '2019-10-22', 269, NULL),
('Hi-Way Inn', 268, '2019-10-23', 364, NULL),
('Hi-Way Inn', 268, '2019-10-24', 210, NULL),
('Hi-Way Inn', 268, '2019-10-25', 384, NULL),
('Hi-Way Inn', 268, '2019-10-26', 301, NULL),
('Hi-Way Inn', 268, '2019-10-27', 359, NULL),
('Hi-Way Inn', 268, '2019-10-28', 259, NULL),
('Hi-Way Inn', 268, '2019-10-29', 144, NULL),
('Hi-Way Inn', 268, '2019-10-30', 100, NULL),
('Hi-Way Inn', 268, '2019-10-31', 186, NULL),
('Hi-Way Inn', 268, '2019-11-01', 191, NULL),
('Hi-Way Inn', 268, '2019-11-02', 295, NULL),
('Hi-Way Inn', 268, '2019-11-03', 159, NULL),
('Hi-Way Inn', 268, '2019-11-04', 140, NULL),
('Hi-Way Inn', 268, '2019-11-05', 353, NULL),
('Hi-Way Inn', 268, '2019-11-06', 341, NULL),
('Hi-Way Inn', 268, '2019-11-07', 395, NULL),
('Hi-Way Inn', 268, '2019-11-08', 388, NULL),
('Hi-Way Inn', 268, '2019-11-09', 223, NULL),
('Hi-Way Inn', 268, '2019-11-10', 229, NULL),
('Hi-Way Inn', 268, '2019-11-11', 160, NULL),
('Hi-Way Inn', 268, '2019-11-12', 359, NULL),
('Hi-Way Inn', 268, '2019-11-13', 113, NULL),
('Hi-Way Inn', 268, '2019-11-14', 369, NULL),
('Hi-Way Inn', 268, '2019-11-15', 117, NULL),
('Hi-Way Inn', 268, '2019-11-16', 288, NULL),
('Hi-Way Inn', 268, '2019-11-17', 283, NULL),
('Hi-Way Inn', 268, '2019-11-18', 256, NULL),
('Hi-Way Inn', 268, '2019-11-19', 317, NULL),
('Hi-Way Inn', 268, '2019-11-20', 354, NULL),
('Hi-Way Inn', 268, '2019-11-21', 363, NULL),
('Hi-Way Inn', 268, '2019-11-22', 197, NULL),
('Hi-Way Inn', 268, '2019-11-23', 320, NULL),
('Hi-Way Inn', 268, '2019-11-24', 380, NULL),
('Hi-Way Inn', 268, '2019-11-25', 276, NULL),
('Hi-Way Inn', 268, '2019-11-26', 382, NULL),
('Hi-Way Inn', 268, '2019-11-27', 289, NULL),
('Hi-Way Inn', 268, '2019-11-28', 159, NULL),
('Hi-Way Inn', 268, '2019-11-29', 142, NULL),
('Hi-Way Inn', 268, '2019-11-30', 392, NULL),
('Hi-Way Inn', 268, '2019-12-01', 278, NULL),
('Hi-Way Inn', 268, '2019-12-02', 392, NULL),
('Hi-Way Inn', 268, '2019-12-03', 314, NULL),
('Hi-Way Inn', 268, '2019-12-04', 325, NULL),
('Hi-Way Inn', 268, '2019-12-05', 359, NULL),
('Hi-Way Inn', 268, '2019-12-06', 167, NULL),
('Hi-Way Inn', 268, '2019-12-07', 144, NULL),
('Hi-Way Inn', 268, '2019-12-08', 319, NULL),
('Hi-Way Inn', 268, '2019-12-09', 289, NULL),
('Hi-Way Inn', 268, '2019-12-10', 160, NULL),
('Hi-Way Inn', 268, '2019-12-11', 120, NULL),
('Hi-Way Inn', 268, '2019-12-12', 290, NULL),
('Hi-Way Inn', 268, '2019-12-13', 258, NULL),
('Hi-Way Inn', 268, '2019-12-14', 300, NULL),
('Hi-Way Inn', 268, '2019-12-15', 139, NULL),
('Hi-Way Inn', 268, '2019-12-16', 290, NULL),
('Hi-Way Inn', 268, '2019-12-17', 126, NULL),
('Hi-Way Inn', 268, '2019-12-18', 280, NULL),
('Hi-Way Inn', 268, '2019-12-19', 172, NULL),
('Hi-Way Inn', 268, '2019-12-20', 211, NULL),
('Hi-Way Inn', 268, '2019-12-21', 332, NULL),
('Hi-Way Inn', 268, '2019-12-22', 156, NULL),
('Hi-Way Inn', 268, '2019-12-23', 370, NULL),
('Hi-Way Inn', 268, '2019-12-24', 245, NULL),
('Hi-Way Inn', 268, '2019-12-25', 206, NULL),
('Hi-Way Inn', 268, '2019-12-26', 333, NULL),
('Hi-Way Inn', 268, '2019-12-27', 240, NULL),
('Hi-Way Inn', 268, '2019-12-28', 366, NULL),
('Hi-Way Inn', 268, '2019-12-29', 178, NULL),
('Hi-Way Inn', 268, '2019-12-30', 379, NULL),
('Hi-Way Inn', 268, '2019-12-31', 280, NULL),
('Hi-Way Inn', 268, '2020-01-01', 378, NULL),
('Hi-Way Inn', 268, '2020-01-02', 106, NULL),
('Hi-Way Inn', 268, '2020-01-03', 220, NULL),
('Hi-Way Inn', 268, '2020-01-04', 286, NULL),
('Hi-Way Inn', 268, '2020-01-05', 201, NULL),
('Hi-Way Inn', 268, '2020-01-06', 365, NULL),
('Hi-Way Inn', 268, '2020-01-07', 262, NULL),
('Hi-Way Inn', 268, '2020-01-08', 171, NULL),
('Hi-Way Inn', 268, '2020-01-09', 273, NULL),
('Hi-Way Inn', 268, '2020-01-10', 109, NULL),
('Hi-Way Inn', 268, '2020-01-11', 226, NULL),
('Hi-Way Inn', 268, '2020-01-12', 285, NULL),
('Hi-Way Inn', 268, '2020-01-13', 262, NULL),
('Hi-Way Inn', 268, '2020-01-14', 336, NULL),
('Hi-Way Inn', 268, '2020-01-15', 161, NULL),
('Hi-Way Inn', 268, '2020-01-16', 392, NULL),
('Hi-Way Inn', 268, '2020-01-17', 220, NULL),
('Hi-Way Inn', 268, '2020-01-18', 285, NULL),
('Hi-Way Inn', 268, '2020-01-19', 110, NULL),
('Hi-Way Inn', 268, '2020-01-20', 377, NULL),
('Hi-Way Inn', 268, '2020-01-21', 179, NULL),
('Hi-Way Inn', 268, '2020-01-22', 294, NULL),
('Hi-Way Inn', 268, '2020-01-23', 282, NULL),
('Hi-Way Inn', 268, '2020-01-24', 369, NULL),
('Hi-Way Inn', 268, '2020-01-25', 334, NULL),
('Hi-Way Inn', 268, '2020-01-26', 334, NULL),
('Hi-Way Inn', 268, '2020-01-27', 359, NULL),
('Hi-Way Inn', 268, '2020-01-28', 133, NULL),
('Hi-Way Inn', 268, '2020-01-29', 290, NULL),
('Hi-Way Inn', 268, '2020-01-30', 317, NULL),
('Hi-Way Inn', 268, '2020-01-31', 262, NULL),
('Hi-Way Inn', 268, '2020-02-01', 164, NULL),
('Hi-Way Inn', 268, '2020-02-02', 159, NULL),
('Hi-Way Inn', 268, '2020-02-03', 367, NULL),
('Hi-Way Inn', 268, '2020-02-04', 217, NULL),
('Hi-Way Inn', 287, '2019-01-01', 116, NULL),
('Hi-Way Inn', 287, '2019-01-02', 103, NULL),
('Hi-Way Inn', 287, '2019-01-03', 394, NULL),
('Hi-Way Inn', 287, '2019-01-04', 250, NULL),
('Hi-Way Inn', 287, '2019-01-05', 313, NULL),
('Hi-Way Inn', 287, '2019-01-06', 213, NULL),
('Hi-Way Inn', 287, '2019-01-07', 324, NULL),
('Hi-Way Inn', 287, '2019-01-08', 178, NULL),
('Hi-Way Inn', 287, '2019-01-09', 289, NULL),
('Hi-Way Inn', 287, '2019-01-10', 131, NULL),
('Hi-Way Inn', 287, '2019-01-11', 157, NULL),
('Hi-Way Inn', 287, '2019-01-12', 188, NULL),
('Hi-Way Inn', 287, '2019-01-13', 125, NULL),
('Hi-Way Inn', 287, '2019-01-14', 385, NULL),
('Hi-Way Inn', 287, '2019-01-15', 338, NULL),
('Hi-Way Inn', 287, '2019-01-16', 189, NULL),
('Hi-Way Inn', 287, '2019-01-17', 122, NULL),
('Hi-Way Inn', 287, '2019-01-18', 327, NULL),
('Hi-Way Inn', 287, '2019-01-19', 289, NULL),
('Hi-Way Inn', 287, '2019-01-20', 383, NULL),
('Hi-Way Inn', 287, '2019-01-21', 306, NULL),
('Hi-Way Inn', 287, '2019-01-22', 194, NULL),
('Hi-Way Inn', 287, '2019-01-23', 355, NULL),
('Hi-Way Inn', 287, '2019-01-24', 360, NULL),
('Hi-Way Inn', 287, '2019-01-25', 368, NULL),
('Hi-Way Inn', 287, '2019-01-26', 210, NULL),
('Hi-Way Inn', 287, '2019-01-27', 348, NULL),
('Hi-Way Inn', 287, '2019-01-28', 185, NULL),
('Hi-Way Inn', 287, '2019-01-29', 357, NULL),
('Hi-Way Inn', 287, '2019-01-30', 106, NULL),
('Hi-Way Inn', 287, '2019-01-31', 289, NULL),
('Hi-Way Inn', 287, '2019-02-01', 312, NULL),
('Hi-Way Inn', 287, '2019-02-02', 132, NULL),
('Hi-Way Inn', 287, '2019-02-03', 385, NULL),
('Hi-Way Inn', 287, '2019-02-04', 301, NULL),
('Hi-Way Inn', 287, '2019-02-05', 340, NULL),
('Hi-Way Inn', 287, '2019-02-06', 315, NULL),
('Hi-Way Inn', 287, '2019-02-07', 372, NULL),
('Hi-Way Inn', 287, '2019-02-08', 100, NULL),
('Hi-Way Inn', 287, '2019-02-09', 137, NULL),
('Hi-Way Inn', 287, '2019-02-10', 155, NULL),
('Hi-Way Inn', 287, '2019-02-11', 322, NULL),
('Hi-Way Inn', 287, '2019-02-12', 118, NULL),
('Hi-Way Inn', 287, '2019-02-13', 307, NULL),
('Hi-Way Inn', 287, '2019-02-14', 234, NULL),
('Hi-Way Inn', 287, '2019-02-15', 299, NULL),
('Hi-Way Inn', 287, '2019-02-16', 132, NULL),
('Hi-Way Inn', 287, '2019-02-17', 374, NULL),
('Hi-Way Inn', 287, '2019-02-18', 319, NULL),
('Hi-Way Inn', 287, '2019-02-19', 353, NULL),
('Hi-Way Inn', 287, '2019-02-20', 300, NULL),
('Hi-Way Inn', 287, '2019-02-21', 341, NULL),
('Hi-Way Inn', 287, '2019-02-22', 301, NULL),
('Hi-Way Inn', 287, '2019-02-23', 219, NULL),
('Hi-Way Inn', 287, '2019-02-24', 227, NULL),
('Hi-Way Inn', 287, '2019-02-25', 179, NULL),
('Hi-Way Inn', 287, '2019-02-26', 284, NULL),
('Hi-Way Inn', 287, '2019-02-27', 209, NULL),
('Hi-Way Inn', 287, '2019-02-28', 286, NULL),
('Hi-Way Inn', 287, '2019-03-01', 300, NULL),
('Hi-Way Inn', 287, '2019-03-02', 150, NULL),
('Hi-Way Inn', 287, '2019-03-03', 302, NULL),
('Hi-Way Inn', 287, '2019-03-04', 210, NULL),
('Hi-Way Inn', 287, '2019-03-05', 396, NULL),
('Hi-Way Inn', 287, '2019-03-06', 381, NULL),
('Hi-Way Inn', 287, '2019-03-07', 124, NULL),
('Hi-Way Inn', 287, '2019-03-08', 256, NULL),
('Hi-Way Inn', 287, '2019-03-09', 154, NULL),
('Hi-Way Inn', 287, '2019-03-10', 159, NULL),
('Hi-Way Inn', 287, '2019-03-11', 144, NULL),
('Hi-Way Inn', 287, '2019-03-12', 251, NULL),
('Hi-Way Inn', 287, '2019-03-13', 263, NULL),
('Hi-Way Inn', 287, '2019-03-14', 352, NULL),
('Hi-Way Inn', 287, '2019-03-15', 178, NULL),
('Hi-Way Inn', 287, '2019-03-16', 215, NULL),
('Hi-Way Inn', 287, '2019-03-17', 280, NULL),
('Hi-Way Inn', 287, '2019-03-18', 316, NULL),
('Hi-Way Inn', 287, '2019-03-19', 121, NULL),
('Hi-Way Inn', 287, '2019-03-20', 388, NULL),
('Hi-Way Inn', 287, '2019-03-21', 108, NULL),
('Hi-Way Inn', 287, '2019-03-22', 238, NULL),
('Hi-Way Inn', 287, '2019-03-23', 147, NULL),
('Hi-Way Inn', 287, '2019-03-24', 102, NULL),
('Hi-Way Inn', 287, '2019-03-25', 289, NULL),
('Hi-Way Inn', 287, '2019-03-26', 232, NULL),
('Hi-Way Inn', 287, '2019-03-27', 225, NULL),
('Hi-Way Inn', 287, '2019-03-28', 343, NULL),
('Hi-Way Inn', 287, '2019-03-29', 137, NULL),
('Hi-Way Inn', 287, '2019-03-30', 308, NULL),
('Hi-Way Inn', 287, '2019-03-31', 224, NULL),
('Hi-Way Inn', 287, '2019-04-01', 232, NULL),
('Hi-Way Inn', 287, '2019-04-02', 354, NULL),
('Hi-Way Inn', 287, '2019-04-03', 216, NULL),
('Hi-Way Inn', 287, '2019-04-04', 284, NULL),
('Hi-Way Inn', 287, '2019-04-05', 312, NULL),
('Hi-Way Inn', 287, '2019-04-06', 290, NULL),
('Hi-Way Inn', 287, '2019-04-07', 200, NULL),
('Hi-Way Inn', 287, '2019-04-08', 144, NULL),
('Hi-Way Inn', 287, '2019-04-09', 343, NULL),
('Hi-Way Inn', 287, '2019-04-10', 395, NULL),
('Hi-Way Inn', 287, '2019-04-11', 179, NULL),
('Hi-Way Inn', 287, '2019-04-12', 373, NULL),
('Hi-Way Inn', 287, '2019-04-13', 238, NULL),
('Hi-Way Inn', 287, '2019-04-14', 158, NULL),
('Hi-Way Inn', 287, '2019-04-15', 350, NULL),
('Hi-Way Inn', 287, '2019-04-16', 359, NULL),
('Hi-Way Inn', 287, '2019-04-17', 396, NULL),
('Hi-Way Inn', 287, '2019-04-18', 184, NULL),
('Hi-Way Inn', 287, '2019-04-19', 134, NULL),
('Hi-Way Inn', 287, '2019-04-20', 291, NULL),
('Hi-Way Inn', 287, '2019-04-21', 237, NULL),
('Hi-Way Inn', 287, '2019-04-22', 216, NULL),
('Hi-Way Inn', 287, '2019-04-23', 370, NULL),
('Hi-Way Inn', 287, '2019-04-24', 344, NULL),
('Hi-Way Inn', 287, '2019-04-25', 137, NULL),
('Hi-Way Inn', 287, '2019-04-26', 376, NULL),
('Hi-Way Inn', 287, '2019-04-27', 369, NULL),
('Hi-Way Inn', 287, '2019-04-28', 339, NULL),
('Hi-Way Inn', 287, '2019-04-29', 222, NULL),
('Hi-Way Inn', 287, '2019-04-30', 179, NULL),
('Hi-Way Inn', 287, '2019-05-01', 137, NULL),
('Hi-Way Inn', 287, '2019-05-02', 233, NULL),
('Hi-Way Inn', 287, '2019-05-03', 142, NULL),
('Hi-Way Inn', 287, '2019-05-04', 201, NULL),
('Hi-Way Inn', 287, '2019-05-05', 364, NULL),
('Hi-Way Inn', 287, '2019-05-06', 120, NULL),
('Hi-Way Inn', 287, '2019-05-07', 349, NULL),
('Hi-Way Inn', 287, '2019-05-08', 363, NULL),
('Hi-Way Inn', 287, '2019-05-09', 382, NULL),
('Hi-Way Inn', 287, '2019-05-10', 186, NULL),
('Hi-Way Inn', 287, '2019-05-11', 291, NULL),
('Hi-Way Inn', 287, '2019-05-12', 380, NULL),
('Hi-Way Inn', 287, '2019-05-13', 231, NULL),
('Hi-Way Inn', 287, '2019-05-14', 185, NULL),
('Hi-Way Inn', 287, '2019-05-15', 134, NULL),
('Hi-Way Inn', 287, '2019-05-16', 348, NULL),
('Hi-Way Inn', 287, '2019-05-17', 328, NULL),
('Hi-Way Inn', 287, '2019-05-18', 169, NULL),
('Hi-Way Inn', 287, '2019-05-19', 276, NULL),
('Hi-Way Inn', 287, '2019-05-20', 109, NULL),
('Hi-Way Inn', 287, '2019-05-21', 126, NULL),
('Hi-Way Inn', 287, '2019-05-22', 228, NULL),
('Hi-Way Inn', 287, '2019-05-23', 385, NULL),
('Hi-Way Inn', 287, '2019-05-24', 218, NULL),
('Hi-Way Inn', 287, '2019-05-25', 335, NULL),
('Hi-Way Inn', 287, '2019-05-26', 152, NULL),
('Hi-Way Inn', 287, '2019-05-27', 361, NULL),
('Hi-Way Inn', 287, '2019-05-28', 261, NULL),
('Hi-Way Inn', 287, '2019-05-29', 143, NULL),
('Hi-Way Inn', 287, '2019-05-30', 175, NULL),
('Hi-Way Inn', 287, '2019-05-31', 305, NULL),
('Hi-Way Inn', 287, '2019-06-01', 133, NULL),
('Hi-Way Inn', 287, '2019-06-02', 280, NULL),
('Hi-Way Inn', 287, '2019-06-03', 338, NULL),
('Hi-Way Inn', 287, '2019-06-04', 124, NULL),
('Hi-Way Inn', 287, '2019-06-05', 240, NULL),
('Hi-Way Inn', 287, '2019-06-06', 242, NULL),
('Hi-Way Inn', 287, '2019-06-07', 267, NULL),
('Hi-Way Inn', 287, '2019-06-08', 328, NULL),
('Hi-Way Inn', 287, '2019-06-09', 384, NULL),
('Hi-Way Inn', 287, '2019-06-10', 203, NULL),
('Hi-Way Inn', 287, '2019-06-11', 284, NULL),
('Hi-Way Inn', 287, '2019-06-12', 309, NULL),
('Hi-Way Inn', 287, '2019-06-13', 397, NULL),
('Hi-Way Inn', 287, '2019-06-14', 100, NULL),
('Hi-Way Inn', 287, '2019-06-15', 151, NULL),
('Hi-Way Inn', 287, '2019-06-16', 247, NULL),
('Hi-Way Inn', 287, '2019-06-17', 162, NULL),
('Hi-Way Inn', 287, '2019-06-18', 396, NULL),
('Hi-Way Inn', 287, '2019-06-19', 378, NULL),
('Hi-Way Inn', 287, '2019-06-20', 232, NULL),
('Hi-Way Inn', 287, '2019-06-21', 381, NULL),
('Hi-Way Inn', 287, '2019-06-22', 143, NULL),
('Hi-Way Inn', 287, '2019-06-23', 197, NULL),
('Hi-Way Inn', 287, '2019-06-24', 272, NULL),
('Hi-Way Inn', 287, '2019-06-25', 237, NULL),
('Hi-Way Inn', 287, '2019-06-26', 143, NULL),
('Hi-Way Inn', 287, '2019-06-27', 386, NULL),
('Hi-Way Inn', 287, '2019-06-28', 250, NULL),
('Hi-Way Inn', 287, '2019-06-29', 298, NULL),
('Hi-Way Inn', 287, '2019-06-30', 135, NULL),
('Hi-Way Inn', 287, '2019-07-01', 326, NULL),
('Hi-Way Inn', 287, '2019-07-02', 112, NULL),
('Hi-Way Inn', 287, '2019-07-03', 184, NULL),
('Hi-Way Inn', 287, '2019-07-04', 316, NULL),
('Hi-Way Inn', 287, '2019-07-05', 116, NULL),
('Hi-Way Inn', 287, '2019-07-06', 146, NULL),
('Hi-Way Inn', 287, '2019-07-07', 293, NULL),
('Hi-Way Inn', 287, '2019-07-08', 195, NULL),
('Hi-Way Inn', 287, '2019-07-09', 235, NULL),
('Hi-Way Inn', 287, '2019-07-10', 129, NULL),
('Hi-Way Inn', 287, '2019-07-11', 160, NULL),
('Hi-Way Inn', 287, '2019-07-12', 256, NULL),
('Hi-Way Inn', 287, '2019-07-13', 191, NULL),
('Hi-Way Inn', 287, '2019-07-14', 347, NULL),
('Hi-Way Inn', 287, '2019-07-15', 381, NULL),
('Hi-Way Inn', 287, '2019-07-16', 345, NULL),
('Hi-Way Inn', 287, '2019-07-17', 178, NULL),
('Hi-Way Inn', 287, '2019-07-18', 300, NULL),
('Hi-Way Inn', 287, '2019-07-19', 122, NULL),
('Hi-Way Inn', 287, '2019-07-20', 178, NULL),
('Hi-Way Inn', 287, '2019-07-21', 317, NULL),
('Hi-Way Inn', 287, '2019-07-22', 202, NULL),
('Hi-Way Inn', 287, '2019-07-23', 179, NULL),
('Hi-Way Inn', 287, '2019-07-24', 182, NULL),
('Hi-Way Inn', 287, '2019-07-25', 120, NULL),
('Hi-Way Inn', 287, '2019-07-26', 337, NULL),
('Hi-Way Inn', 287, '2019-07-27', 243, NULL),
('Hi-Way Inn', 287, '2019-07-28', 180, NULL),
('Hi-Way Inn', 287, '2019-07-29', 120, NULL),
('Hi-Way Inn', 287, '2019-07-30', 261, NULL),
('Hi-Way Inn', 287, '2019-07-31', 172, NULL),
('Hi-Way Inn', 287, '2019-08-01', 106, NULL),
('Hi-Way Inn', 287, '2019-08-02', 201, NULL),
('Hi-Way Inn', 287, '2019-08-03', 318, NULL),
('Hi-Way Inn', 287, '2019-08-04', 249, NULL),
('Hi-Way Inn', 287, '2019-08-05', 325, NULL),
('Hi-Way Inn', 287, '2019-08-06', 138, NULL),
('Hi-Way Inn', 287, '2019-08-07', 127, NULL),
('Hi-Way Inn', 287, '2019-08-08', 112, NULL),
('Hi-Way Inn', 287, '2019-08-09', 299, NULL),
('Hi-Way Inn', 287, '2019-08-10', 362, NULL),
('Hi-Way Inn', 287, '2019-08-11', 158, NULL),
('Hi-Way Inn', 287, '2019-08-12', 357, NULL),
('Hi-Way Inn', 287, '2019-08-13', 342, NULL),
('Hi-Way Inn', 287, '2019-08-14', 141, NULL),
('Hi-Way Inn', 287, '2019-08-15', 346, NULL),
('Hi-Way Inn', 287, '2019-08-16', 115, NULL),
('Hi-Way Inn', 287, '2019-08-17', 272, NULL),
('Hi-Way Inn', 287, '2019-08-18', 251, NULL),
('Hi-Way Inn', 287, '2019-08-19', 123, NULL),
('Hi-Way Inn', 287, '2019-08-20', 216, NULL),
('Hi-Way Inn', 287, '2019-08-21', 399, NULL),
('Hi-Way Inn', 287, '2019-08-22', 337, NULL),
('Hi-Way Inn', 287, '2019-08-23', 157, NULL),
('Hi-Way Inn', 287, '2019-08-24', 206, NULL),
('Hi-Way Inn', 287, '2019-08-25', 310, NULL),
('Hi-Way Inn', 287, '2019-08-26', 374, NULL),
('Hi-Way Inn', 287, '2019-08-27', 253, NULL),
('Hi-Way Inn', 287, '2019-08-28', 279, NULL),
('Hi-Way Inn', 287, '2019-08-29', 292, NULL),
('Hi-Way Inn', 287, '2019-08-30', 141, NULL),
('Hi-Way Inn', 287, '2019-08-31', 108, NULL),
('Hi-Way Inn', 287, '2019-09-01', 368, NULL),
('Hi-Way Inn', 287, '2019-09-02', 165, NULL),
('Hi-Way Inn', 287, '2019-09-03', 154, NULL),
('Hi-Way Inn', 287, '2019-09-04', 347, NULL),
('Hi-Way Inn', 287, '2019-09-05', 290, NULL),
('Hi-Way Inn', 287, '2019-09-06', 363, NULL),
('Hi-Way Inn', 287, '2019-09-07', 366, NULL),
('Hi-Way Inn', 287, '2019-09-08', 387, NULL),
('Hi-Way Inn', 287, '2019-09-09', 297, NULL),
('Hi-Way Inn', 287, '2019-09-10', 140, NULL),
('Hi-Way Inn', 287, '2019-09-11', 360, NULL),
('Hi-Way Inn', 287, '2019-09-12', 211, NULL),
('Hi-Way Inn', 287, '2019-09-13', 241, NULL),
('Hi-Way Inn', 287, '2019-09-14', 257, NULL),
('Hi-Way Inn', 287, '2019-09-15', 115, NULL),
('Hi-Way Inn', 287, '2019-09-16', 385, NULL),
('Hi-Way Inn', 287, '2019-09-17', 260, NULL),
('Hi-Way Inn', 287, '2019-09-18', 206, NULL),
('Hi-Way Inn', 287, '2019-09-19', 139, NULL),
('Hi-Way Inn', 287, '2019-09-20', 115, NULL),
('Hi-Way Inn', 287, '2019-09-21', 138, NULL),
('Hi-Way Inn', 287, '2019-09-22', 165, NULL),
('Hi-Way Inn', 287, '2019-09-23', 338, NULL),
('Hi-Way Inn', 287, '2019-09-24', 126, NULL),
('Hi-Way Inn', 287, '2019-09-25', 318, NULL),
('Hi-Way Inn', 287, '2019-09-26', 304, NULL),
('Hi-Way Inn', 287, '2019-09-27', 371, NULL),
('Hi-Way Inn', 287, '2019-09-28', 248, NULL),
('Hi-Way Inn', 287, '2019-09-29', 343, NULL),
('Hi-Way Inn', 287, '2019-09-30', 105, NULL),
('Hi-Way Inn', 287, '2019-10-01', 372, NULL),
('Hi-Way Inn', 287, '2019-10-02', 133, NULL),
('Hi-Way Inn', 287, '2019-10-03', 199, NULL),
('Hi-Way Inn', 287, '2019-10-04', 306, NULL),
('Hi-Way Inn', 287, '2019-10-05', 356, NULL),
('Hi-Way Inn', 287, '2019-10-06', 110, NULL),
('Hi-Way Inn', 287, '2019-10-07', 203, NULL),
('Hi-Way Inn', 287, '2019-10-08', 262, NULL),
('Hi-Way Inn', 287, '2019-10-09', 193, NULL),
('Hi-Way Inn', 287, '2019-10-10', 168, NULL),
('Hi-Way Inn', 287, '2019-10-11', 399, NULL),
('Hi-Way Inn', 287, '2019-10-12', 330, NULL),
('Hi-Way Inn', 287, '2019-10-13', 191, NULL),
('Hi-Way Inn', 287, '2019-10-14', 211, NULL),
('Hi-Way Inn', 287, '2019-10-15', 145, NULL),
('Hi-Way Inn', 287, '2019-10-16', 247, NULL),
('Hi-Way Inn', 287, '2019-10-17', 338, NULL),
('Hi-Way Inn', 287, '2019-10-18', 182, NULL),
('Hi-Way Inn', 287, '2019-10-19', 265, NULL),
('Hi-Way Inn', 287, '2019-10-20', 283, NULL),
('Hi-Way Inn', 287, '2019-10-21', 343, NULL),
('Hi-Way Inn', 287, '2019-10-22', 103, NULL),
('Hi-Way Inn', 287, '2019-10-23', 194, NULL),
('Hi-Way Inn', 287, '2019-10-24', 172, NULL),
('Hi-Way Inn', 287, '2019-10-25', 319, NULL),
('Hi-Way Inn', 287, '2019-10-26', 326, NULL),
('Hi-Way Inn', 287, '2019-10-27', 209, NULL),
('Hi-Way Inn', 287, '2019-10-28', 386, NULL),
('Hi-Way Inn', 287, '2019-10-29', 361, NULL),
('Hi-Way Inn', 287, '2019-10-30', 229, NULL),
('Hi-Way Inn', 287, '2019-10-31', 315, NULL),
('Hi-Way Inn', 287, '2019-11-01', 191, NULL),
('Hi-Way Inn', 287, '2019-11-02', 231, NULL),
('Hi-Way Inn', 287, '2019-11-03', 150, NULL),
('Hi-Way Inn', 287, '2019-11-04', 321, NULL),
('Hi-Way Inn', 287, '2019-11-05', 176, NULL),
('Hi-Way Inn', 287, '2019-11-06', 247, NULL),
('Hi-Way Inn', 287, '2019-11-07', 163, NULL),
('Hi-Way Inn', 287, '2019-11-08', 293, NULL),
('Hi-Way Inn', 287, '2019-11-09', 104, NULL),
('Hi-Way Inn', 287, '2019-11-10', 251, NULL),
('Hi-Way Inn', 287, '2019-11-11', 260, NULL),
('Hi-Way Inn', 287, '2019-11-12', 282, NULL),
('Hi-Way Inn', 287, '2019-11-13', 232, NULL),
('Hi-Way Inn', 287, '2019-11-14', 222, NULL),
('Hi-Way Inn', 287, '2019-11-15', 189, NULL),
('Hi-Way Inn', 287, '2019-11-16', 105, NULL),
('Hi-Way Inn', 287, '2019-11-17', 237, NULL),
('Hi-Way Inn', 287, '2019-11-18', 369, NULL),
('Hi-Way Inn', 287, '2019-11-19', 370, NULL),
('Hi-Way Inn', 287, '2019-11-20', 332, NULL),
('Hi-Way Inn', 287, '2019-11-21', 197, NULL),
('Hi-Way Inn', 287, '2019-11-22', 123, NULL),
('Hi-Way Inn', 287, '2019-11-23', 260, NULL),
('Hi-Way Inn', 287, '2019-11-24', 382, NULL),
('Hi-Way Inn', 287, '2019-11-25', 394, NULL),
('Hi-Way Inn', 287, '2019-11-26', 285, NULL),
('Hi-Way Inn', 287, '2019-11-27', 382, NULL),
('Hi-Way Inn', 287, '2019-11-28', 282, NULL),
('Hi-Way Inn', 287, '2019-11-29', 319, NULL),
('Hi-Way Inn', 287, '2019-11-30', 302, NULL),
('Hi-Way Inn', 287, '2019-12-01', 294, NULL),
('Hi-Way Inn', 287, '2019-12-02', 146, NULL),
('Hi-Way Inn', 287, '2019-12-03', 396, NULL),
('Hi-Way Inn', 287, '2019-12-04', 213, NULL),
('Hi-Way Inn', 287, '2019-12-05', 143, NULL),
('Hi-Way Inn', 287, '2019-12-06', 244, NULL),
('Hi-Way Inn', 287, '2019-12-07', 188, NULL),
('Hi-Way Inn', 287, '2019-12-08', 178, NULL),
('Hi-Way Inn', 287, '2019-12-09', 356, NULL),
('Hi-Way Inn', 287, '2019-12-10', 183, NULL),
('Hi-Way Inn', 287, '2019-12-11', 316, NULL),
('Hi-Way Inn', 287, '2019-12-12', 361, NULL),
('Hi-Way Inn', 287, '2019-12-13', 314, NULL),
('Hi-Way Inn', 287, '2019-12-14', 363, NULL),
('Hi-Way Inn', 287, '2019-12-15', 331, NULL),
('Hi-Way Inn', 287, '2019-12-16', 346, NULL),
('Hi-Way Inn', 287, '2019-12-17', 231, NULL),
('Hi-Way Inn', 287, '2019-12-18', 395, NULL),
('Hi-Way Inn', 287, '2019-12-19', 338, NULL),
('Hi-Way Inn', 287, '2019-12-20', 357, NULL),
('Hi-Way Inn', 287, '2019-12-21', 230, NULL),
('Hi-Way Inn', 287, '2019-12-22', 370, NULL),
('Hi-Way Inn', 287, '2019-12-23', 304, NULL),
('Hi-Way Inn', 287, '2019-12-24', 229, NULL),
('Hi-Way Inn', 287, '2019-12-25', 332, NULL),
('Hi-Way Inn', 287, '2019-12-26', 325, NULL),
('Hi-Way Inn', 287, '2019-12-27', 334, NULL),
('Hi-Way Inn', 287, '2019-12-28', 174, NULL),
('Hi-Way Inn', 287, '2019-12-29', 264, NULL),
('Hi-Way Inn', 287, '2019-12-30', 150, NULL),
('Hi-Way Inn', 287, '2019-12-31', 285, NULL),
('Hi-Way Inn', 287, '2020-01-01', 218, NULL),
('Hi-Way Inn', 287, '2020-01-02', 182, NULL),
('Hi-Way Inn', 287, '2020-01-03', 149, NULL),
('Hi-Way Inn', 287, '2020-01-04', 264, NULL),
('Hi-Way Inn', 287, '2020-01-05', 322, NULL),
('Hi-Way Inn', 287, '2020-01-06', 318, NULL),
('Hi-Way Inn', 287, '2020-01-07', 391, NULL),
('Hi-Way Inn', 287, '2020-01-08', 241, NULL),
('Hi-Way Inn', 287, '2020-01-09', 174, NULL),
('Hi-Way Inn', 287, '2020-01-10', 183, NULL),
('Hi-Way Inn', 287, '2020-01-11', 144, NULL),
('Hi-Way Inn', 287, '2020-01-12', 116, NULL),
('Hi-Way Inn', 287, '2020-01-13', 115, NULL),
('Hi-Way Inn', 287, '2020-01-14', 189, NULL),
('Hi-Way Inn', 287, '2020-01-15', 244, NULL),
('Hi-Way Inn', 287, '2020-01-16', 347, NULL),
('Hi-Way Inn', 287, '2020-01-17', 129, NULL),
('Hi-Way Inn', 287, '2020-01-18', 184, NULL),
('Hi-Way Inn', 287, '2020-01-19', 252, NULL),
('Hi-Way Inn', 287, '2020-01-20', 190, NULL),
('Hi-Way Inn', 287, '2020-01-21', 156, NULL),
('Hi-Way Inn', 287, '2020-01-22', 344, NULL),
('Hi-Way Inn', 287, '2020-01-23', 122, NULL),
('Hi-Way Inn', 287, '2020-01-24', 308, NULL),
('Hi-Way Inn', 287, '2020-01-25', 333, NULL),
('Hi-Way Inn', 287, '2020-01-26', 145, NULL),
('Hi-Way Inn', 287, '2020-01-27', 364, NULL),
('Hi-Way Inn', 287, '2020-01-28', 227, NULL),
('Hi-Way Inn', 287, '2020-01-29', 163, NULL),
('Hi-Way Inn', 287, '2020-01-30', 114, NULL),
('Hi-Way Inn', 287, '2020-01-31', 236, NULL),
('Hi-Way Inn', 287, '2020-02-01', 363, NULL),
('Hi-Way Inn', 287, '2020-02-02', 138, NULL),
('Hi-Way Inn', 287, '2020-02-03', 237, NULL),
('Hi-Way Inn', 287, '2020-02-04', 176, NULL),
('Hi-Way Inn', 294, '2019-01-01', 340, NULL),
('Hi-Way Inn', 294, '2019-01-02', 323, NULL),
('Hi-Way Inn', 294, '2019-01-03', 338, NULL),
('Hi-Way Inn', 294, '2019-01-04', 113, NULL),
('Hi-Way Inn', 294, '2019-01-05', 231, NULL),
('Hi-Way Inn', 294, '2019-01-06', 188, NULL),
('Hi-Way Inn', 294, '2019-01-07', 394, NULL),
('Hi-Way Inn', 294, '2019-01-08', 256, NULL),
('Hi-Way Inn', 294, '2019-01-09', 312, NULL),
('Hi-Way Inn', 294, '2019-01-10', 261, NULL),
('Hi-Way Inn', 294, '2019-01-11', 310, NULL),
('Hi-Way Inn', 294, '2019-01-12', 346, NULL),
('Hi-Way Inn', 294, '2019-01-13', 292, NULL),
('Hi-Way Inn', 294, '2019-01-14', 117, NULL),
('Hi-Way Inn', 294, '2019-01-15', 272, NULL),
('Hi-Way Inn', 294, '2019-01-16', 176, NULL),
('Hi-Way Inn', 294, '2019-01-17', 345, NULL),
('Hi-Way Inn', 294, '2019-01-18', 307, NULL),
('Hi-Way Inn', 294, '2019-01-19', 268, NULL),
('Hi-Way Inn', 294, '2019-01-20', 163, NULL),
('Hi-Way Inn', 294, '2019-01-21', 390, NULL),
('Hi-Way Inn', 294, '2019-01-22', 342, NULL),
('Hi-Way Inn', 294, '2019-01-23', 228, NULL),
('Hi-Way Inn', 294, '2019-01-24', 218, NULL),
('Hi-Way Inn', 294, '2019-01-25', 180, NULL),
('Hi-Way Inn', 294, '2019-01-26', 176, NULL),
('Hi-Way Inn', 294, '2019-01-27', 393, NULL),
('Hi-Way Inn', 294, '2019-01-28', 203, NULL),
('Hi-Way Inn', 294, '2019-01-29', 269, NULL),
('Hi-Way Inn', 294, '2019-01-30', 315, NULL),
('Hi-Way Inn', 294, '2019-01-31', 361, NULL),
('Hi-Way Inn', 294, '2019-02-01', 175, NULL),
('Hi-Way Inn', 294, '2019-02-02', 171, NULL),
('Hi-Way Inn', 294, '2019-02-03', 109, NULL),
('Hi-Way Inn', 294, '2019-02-04', 121, NULL),
('Hi-Way Inn', 294, '2019-02-05', 220, NULL),
('Hi-Way Inn', 294, '2019-02-06', 342, NULL),
('Hi-Way Inn', 294, '2019-02-07', 296, NULL),
('Hi-Way Inn', 294, '2019-02-08', 182, NULL),
('Hi-Way Inn', 294, '2019-02-09', 175, NULL),
('Hi-Way Inn', 294, '2019-02-10', 166, NULL),
('Hi-Way Inn', 294, '2019-02-11', 284, NULL),
('Hi-Way Inn', 294, '2019-02-12', 319, NULL),
('Hi-Way Inn', 294, '2019-02-13', 288, NULL),
('Hi-Way Inn', 294, '2019-02-14', 172, NULL),
('Hi-Way Inn', 294, '2019-02-15', 354, NULL),
('Hi-Way Inn', 294, '2019-02-16', 374, NULL),
('Hi-Way Inn', 294, '2019-02-17', 391, NULL),
('Hi-Way Inn', 294, '2019-02-18', 344, NULL),
('Hi-Way Inn', 294, '2019-02-19', 259, NULL),
('Hi-Way Inn', 294, '2019-02-20', 336, NULL),
('Hi-Way Inn', 294, '2019-02-21', 325, NULL),
('Hi-Way Inn', 294, '2019-02-22', 173, NULL),
('Hi-Way Inn', 294, '2019-02-23', 268, NULL),
('Hi-Way Inn', 294, '2019-02-24', 142, NULL),
('Hi-Way Inn', 294, '2019-02-25', 262, NULL),
('Hi-Way Inn', 294, '2019-02-26', 113, NULL),
('Hi-Way Inn', 294, '2019-02-27', 184, NULL),
('Hi-Way Inn', 294, '2019-02-28', 156, NULL),
('Hi-Way Inn', 294, '2019-03-01', 356, NULL),
('Hi-Way Inn', 294, '2019-03-02', 266, NULL),
('Hi-Way Inn', 294, '2019-03-03', 267, NULL),
('Hi-Way Inn', 294, '2019-03-04', 272, NULL),
('Hi-Way Inn', 294, '2019-03-05', 260, NULL),
('Hi-Way Inn', 294, '2019-03-06', 134, NULL),
('Hi-Way Inn', 294, '2019-03-07', 303, NULL),
('Hi-Way Inn', 294, '2019-03-08', 184, NULL),
('Hi-Way Inn', 294, '2019-03-09', 398, NULL),
('Hi-Way Inn', 294, '2019-03-10', 204, NULL),
('Hi-Way Inn', 294, '2019-03-11', 138, NULL),
('Hi-Way Inn', 294, '2019-03-12', 147, NULL),
('Hi-Way Inn', 294, '2019-03-13', 250, NULL),
('Hi-Way Inn', 294, '2019-03-14', 393, NULL),
('Hi-Way Inn', 294, '2019-03-15', 151, NULL),
('Hi-Way Inn', 294, '2019-03-16', 138, NULL),
('Hi-Way Inn', 294, '2019-03-17', 307, NULL),
('Hi-Way Inn', 294, '2019-03-18', 275, NULL),
('Hi-Way Inn', 294, '2019-03-19', 248, NULL),
('Hi-Way Inn', 294, '2019-03-20', 179, NULL),
('Hi-Way Inn', 294, '2019-03-21', 320, NULL),
('Hi-Way Inn', 294, '2019-03-22', 218, NULL),
('Hi-Way Inn', 294, '2019-03-23', 292, NULL),
('Hi-Way Inn', 294, '2019-03-24', 241, NULL),
('Hi-Way Inn', 294, '2019-03-25', 172, NULL),
('Hi-Way Inn', 294, '2019-03-26', 369, NULL),
('Hi-Way Inn', 294, '2019-03-27', 291, NULL),
('Hi-Way Inn', 294, '2019-03-28', 322, NULL),
('Hi-Way Inn', 294, '2019-03-29', 385, NULL),
('Hi-Way Inn', 294, '2019-03-30', 199, NULL),
('Hi-Way Inn', 294, '2019-03-31', 226, NULL),
('Hi-Way Inn', 294, '2019-04-01', 393, NULL),
('Hi-Way Inn', 294, '2019-04-02', 244, NULL),
('Hi-Way Inn', 294, '2019-04-03', 313, NULL),
('Hi-Way Inn', 294, '2019-04-04', 263, NULL),
('Hi-Way Inn', 294, '2019-04-05', 334, NULL),
('Hi-Way Inn', 294, '2019-04-06', 283, NULL),
('Hi-Way Inn', 294, '2019-04-07', 385, NULL),
('Hi-Way Inn', 294, '2019-04-08', 107, NULL),
('Hi-Way Inn', 294, '2019-04-09', 320, NULL),
('Hi-Way Inn', 294, '2019-04-10', 172, NULL),
('Hi-Way Inn', 294, '2019-04-11', 159, NULL),
('Hi-Way Inn', 294, '2019-04-12', 253, NULL),
('Hi-Way Inn', 294, '2019-04-13', 334, NULL),
('Hi-Way Inn', 294, '2019-04-14', 371, NULL),
('Hi-Way Inn', 294, '2019-04-15', 351, NULL),
('Hi-Way Inn', 294, '2019-04-16', 301, NULL),
('Hi-Way Inn', 294, '2019-04-17', 105, NULL),
('Hi-Way Inn', 294, '2019-04-18', 195, NULL),
('Hi-Way Inn', 294, '2019-04-19', 233, NULL),
('Hi-Way Inn', 294, '2019-04-20', 387, NULL),
('Hi-Way Inn', 294, '2019-04-21', 335, NULL),
('Hi-Way Inn', 294, '2019-04-22', 364, NULL),
('Hi-Way Inn', 294, '2019-04-23', 312, NULL),
('Hi-Way Inn', 294, '2019-04-24', 208, NULL),
('Hi-Way Inn', 294, '2019-04-25', 341, NULL),
('Hi-Way Inn', 294, '2019-04-26', 187, NULL),
('Hi-Way Inn', 294, '2019-04-27', 205, NULL),
('Hi-Way Inn', 294, '2019-04-28', 130, NULL),
('Hi-Way Inn', 294, '2019-04-29', 365, NULL),
('Hi-Way Inn', 294, '2019-04-30', 175, NULL),
('Hi-Way Inn', 294, '2019-05-01', 161, NULL),
('Hi-Way Inn', 294, '2019-05-02', 260, NULL),
('Hi-Way Inn', 294, '2019-05-03', 340, NULL),
('Hi-Way Inn', 294, '2019-05-04', 323, NULL),
('Hi-Way Inn', 294, '2019-05-05', 135, NULL),
('Hi-Way Inn', 294, '2019-05-06', 151, NULL),
('Hi-Way Inn', 294, '2019-05-07', 338, NULL),
('Hi-Way Inn', 294, '2019-05-08', 152, NULL),
('Hi-Way Inn', 294, '2019-05-09', 160, NULL),
('Hi-Way Inn', 294, '2019-05-10', 183, NULL),
('Hi-Way Inn', 294, '2019-05-11', 163, NULL),
('Hi-Way Inn', 294, '2019-05-12', 371, NULL),
('Hi-Way Inn', 294, '2019-05-13', 293, NULL),
('Hi-Way Inn', 294, '2019-05-14', 386, NULL),
('Hi-Way Inn', 294, '2019-05-15', 332, NULL),
('Hi-Way Inn', 294, '2019-05-16', 228, NULL),
('Hi-Way Inn', 294, '2019-05-17', 287, NULL),
('Hi-Way Inn', 294, '2019-05-18', 108, NULL),
('Hi-Way Inn', 294, '2019-05-19', 119, NULL),
('Hi-Way Inn', 294, '2019-05-20', 183, NULL),
('Hi-Way Inn', 294, '2019-05-21', 212, NULL),
('Hi-Way Inn', 294, '2019-05-22', 200, NULL),
('Hi-Way Inn', 294, '2019-05-23', 253, NULL),
('Hi-Way Inn', 294, '2019-05-24', 275, NULL),
('Hi-Way Inn', 294, '2019-05-25', 338, NULL),
('Hi-Way Inn', 294, '2019-05-26', 137, NULL),
('Hi-Way Inn', 294, '2019-05-27', 372, NULL),
('Hi-Way Inn', 294, '2019-05-28', 270, NULL),
('Hi-Way Inn', 294, '2019-05-29', 336, NULL),
('Hi-Way Inn', 294, '2019-05-30', 350, NULL),
('Hi-Way Inn', 294, '2019-05-31', 219, NULL),
('Hi-Way Inn', 294, '2019-06-01', 208, NULL),
('Hi-Way Inn', 294, '2019-06-02', 324, NULL),
('Hi-Way Inn', 294, '2019-06-03', 335, NULL),
('Hi-Way Inn', 294, '2019-06-04', 266, NULL),
('Hi-Way Inn', 294, '2019-06-05', 346, NULL),
('Hi-Way Inn', 294, '2019-06-06', 170, NULL),
('Hi-Way Inn', 294, '2019-06-07', 126, NULL),
('Hi-Way Inn', 294, '2019-06-08', 286, NULL),
('Hi-Way Inn', 294, '2019-06-09', 366, NULL),
('Hi-Way Inn', 294, '2019-06-10', 230, NULL),
('Hi-Way Inn', 294, '2019-06-11', 123, NULL),
('Hi-Way Inn', 294, '2019-06-12', 296, NULL),
('Hi-Way Inn', 294, '2019-06-13', 135, NULL),
('Hi-Way Inn', 294, '2019-06-14', 300, NULL),
('Hi-Way Inn', 294, '2019-06-15', 213, NULL),
('Hi-Way Inn', 294, '2019-06-16', 387, NULL),
('Hi-Way Inn', 294, '2019-06-17', 354, NULL),
('Hi-Way Inn', 294, '2019-06-18', 205, NULL),
('Hi-Way Inn', 294, '2019-06-19', 197, NULL),
('Hi-Way Inn', 294, '2019-06-20', 118, NULL),
('Hi-Way Inn', 294, '2019-06-21', 347, NULL),
('Hi-Way Inn', 294, '2019-06-22', 123, NULL),
('Hi-Way Inn', 294, '2019-06-23', 301, NULL),
('Hi-Way Inn', 294, '2019-06-24', 267, NULL),
('Hi-Way Inn', 294, '2019-06-25', 352, NULL),
('Hi-Way Inn', 294, '2019-06-26', 373, NULL),
('Hi-Way Inn', 294, '2019-06-27', 184, NULL),
('Hi-Way Inn', 294, '2019-06-28', 146, NULL),
('Hi-Way Inn', 294, '2019-06-29', 351, NULL),
('Hi-Way Inn', 294, '2019-06-30', 336, NULL),
('Hi-Way Inn', 294, '2019-07-01', 180, NULL),
('Hi-Way Inn', 294, '2019-07-02', 281, NULL),
('Hi-Way Inn', 294, '2019-07-03', 372, NULL),
('Hi-Way Inn', 294, '2019-07-04', 237, NULL),
('Hi-Way Inn', 294, '2019-07-05', 218, NULL),
('Hi-Way Inn', 294, '2019-07-06', 194, NULL),
('Hi-Way Inn', 294, '2019-07-07', 317, NULL),
('Hi-Way Inn', 294, '2019-07-08', 104, NULL),
('Hi-Way Inn', 294, '2019-07-09', 169, NULL),
('Hi-Way Inn', 294, '2019-07-10', 310, NULL),
('Hi-Way Inn', 294, '2019-07-11', 292, NULL),
('Hi-Way Inn', 294, '2019-07-12', 376, NULL),
('Hi-Way Inn', 294, '2019-07-13', 296, NULL),
('Hi-Way Inn', 294, '2019-07-14', 233, NULL),
('Hi-Way Inn', 294, '2019-07-15', 232, NULL),
('Hi-Way Inn', 294, '2019-07-16', 381, NULL),
('Hi-Way Inn', 294, '2019-07-17', 275, NULL),
('Hi-Way Inn', 294, '2019-07-18', 124, NULL),
('Hi-Way Inn', 294, '2019-07-19', 273, NULL),
('Hi-Way Inn', 294, '2019-07-20', 142, NULL),
('Hi-Way Inn', 294, '2019-07-21', 303, NULL),
('Hi-Way Inn', 294, '2019-07-22', 289, NULL),
('Hi-Way Inn', 294, '2019-07-23', 113, NULL),
('Hi-Way Inn', 294, '2019-07-24', 222, NULL),
('Hi-Way Inn', 294, '2019-07-25', 145, NULL),
('Hi-Way Inn', 294, '2019-07-26', 337, NULL),
('Hi-Way Inn', 294, '2019-07-27', 129, NULL),
('Hi-Way Inn', 294, '2019-07-28', 169, NULL),
('Hi-Way Inn', 294, '2019-07-29', 280, NULL),
('Hi-Way Inn', 294, '2019-07-30', 275, NULL),
('Hi-Way Inn', 294, '2019-07-31', 211, NULL),
('Hi-Way Inn', 294, '2019-08-01', 239, NULL),
('Hi-Way Inn', 294, '2019-08-02', 185, NULL),
('Hi-Way Inn', 294, '2019-08-03', 226, NULL),
('Hi-Way Inn', 294, '2019-08-04', 170, NULL),
('Hi-Way Inn', 294, '2019-08-05', 261, NULL),
('Hi-Way Inn', 294, '2019-08-06', 294, NULL),
('Hi-Way Inn', 294, '2019-08-07', 378, NULL),
('Hi-Way Inn', 294, '2019-08-08', 288, NULL),
('Hi-Way Inn', 294, '2019-08-09', 128, NULL),
('Hi-Way Inn', 294, '2019-08-10', 252, NULL),
('Hi-Way Inn', 294, '2019-08-11', 318, NULL),
('Hi-Way Inn', 294, '2019-08-12', 135, NULL),
('Hi-Way Inn', 294, '2019-08-13', 177, NULL),
('Hi-Way Inn', 294, '2019-08-14', 380, NULL),
('Hi-Way Inn', 294, '2019-08-15', 306, NULL),
('Hi-Way Inn', 294, '2019-08-16', 192, NULL),
('Hi-Way Inn', 294, '2019-08-17', 105, NULL),
('Hi-Way Inn', 294, '2019-08-18', 254, NULL),
('Hi-Way Inn', 294, '2019-08-19', 346, NULL),
('Hi-Way Inn', 294, '2019-08-20', 139, NULL),
('Hi-Way Inn', 294, '2019-08-21', 187, NULL),
('Hi-Way Inn', 294, '2019-08-22', 129, NULL),
('Hi-Way Inn', 294, '2019-08-23', 131, NULL),
('Hi-Way Inn', 294, '2019-08-24', 101, NULL),
('Hi-Way Inn', 294, '2019-08-25', 377, NULL),
('Hi-Way Inn', 294, '2019-08-26', 165, NULL),
('Hi-Way Inn', 294, '2019-08-27', 395, NULL),
('Hi-Way Inn', 294, '2019-08-28', 255, NULL),
('Hi-Way Inn', 294, '2019-08-29', 335, NULL),
('Hi-Way Inn', 294, '2019-08-30', 254, NULL),
('Hi-Way Inn', 294, '2019-08-31', 399, NULL),
('Hi-Way Inn', 294, '2019-09-01', 359, NULL),
('Hi-Way Inn', 294, '2019-09-02', 327, NULL),
('Hi-Way Inn', 294, '2019-09-03', 161, NULL),
('Hi-Way Inn', 294, '2019-09-04', 385, NULL),
('Hi-Way Inn', 294, '2019-09-05', 170, NULL),
('Hi-Way Inn', 294, '2019-09-06', 167, NULL),
('Hi-Way Inn', 294, '2019-09-07', 142, NULL),
('Hi-Way Inn', 294, '2019-09-08', 286, NULL),
('Hi-Way Inn', 294, '2019-09-09', 289, NULL),
('Hi-Way Inn', 294, '2019-09-10', 222, NULL),
('Hi-Way Inn', 294, '2019-09-11', 195, NULL),
('Hi-Way Inn', 294, '2019-09-12', 128, NULL),
('Hi-Way Inn', 294, '2019-09-13', 166, NULL),
('Hi-Way Inn', 294, '2019-09-14', 145, NULL),
('Hi-Way Inn', 294, '2019-09-15', 264, NULL),
('Hi-Way Inn', 294, '2019-09-16', 167, NULL),
('Hi-Way Inn', 294, '2019-09-17', 388, NULL),
('Hi-Way Inn', 294, '2019-09-18', 182, NULL),
('Hi-Way Inn', 294, '2019-09-19', 121, NULL),
('Hi-Way Inn', 294, '2019-09-20', 293, NULL),
('Hi-Way Inn', 294, '2019-09-21', 324, NULL),
('Hi-Way Inn', 294, '2019-09-22', 397, NULL),
('Hi-Way Inn', 294, '2019-09-23', 263, NULL),
('Hi-Way Inn', 294, '2019-09-24', 399, NULL),
('Hi-Way Inn', 294, '2019-09-25', 312, NULL),
('Hi-Way Inn', 294, '2019-09-26', 237, NULL),
('Hi-Way Inn', 294, '2019-09-27', 373, NULL),
('Hi-Way Inn', 294, '2019-09-28', 365, NULL),
('Hi-Way Inn', 294, '2019-09-29', 224, NULL),
('Hi-Way Inn', 294, '2019-09-30', 259, NULL),
('Hi-Way Inn', 294, '2019-10-01', 250, NULL),
('Hi-Way Inn', 294, '2019-10-02', 176, NULL),
('Hi-Way Inn', 294, '2019-10-03', 141, NULL),
('Hi-Way Inn', 294, '2019-10-04', 115, NULL),
('Hi-Way Inn', 294, '2019-10-05', 247, NULL),
('Hi-Way Inn', 294, '2019-10-06', 320, NULL),
('Hi-Way Inn', 294, '2019-10-07', 149, NULL),
('Hi-Way Inn', 294, '2019-10-08', 287, NULL),
('Hi-Way Inn', 294, '2019-10-09', 180, NULL),
('Hi-Way Inn', 294, '2019-10-10', 394, NULL),
('Hi-Way Inn', 294, '2019-10-11', 249, NULL),
('Hi-Way Inn', 294, '2019-10-12', 354, NULL),
('Hi-Way Inn', 294, '2019-10-13', 182, NULL),
('Hi-Way Inn', 294, '2019-10-14', 103, NULL),
('Hi-Way Inn', 294, '2019-10-15', 383, NULL),
('Hi-Way Inn', 294, '2019-10-16', 350, NULL),
('Hi-Way Inn', 294, '2019-10-17', 235, NULL),
('Hi-Way Inn', 294, '2019-10-18', 399, NULL),
('Hi-Way Inn', 294, '2019-10-19', 303, NULL),
('Hi-Way Inn', 294, '2019-10-20', 322, NULL),
('Hi-Way Inn', 294, '2019-10-21', 139, NULL),
('Hi-Way Inn', 294, '2019-10-22', 208, NULL),
('Hi-Way Inn', 294, '2019-10-23', 377, NULL),
('Hi-Way Inn', 294, '2019-10-24', 132, NULL),
('Hi-Way Inn', 294, '2019-10-25', 343, NULL),
('Hi-Way Inn', 294, '2019-10-26', 324, NULL),
('Hi-Way Inn', 294, '2019-10-27', 169, NULL),
('Hi-Way Inn', 294, '2019-10-28', 154, NULL),
('Hi-Way Inn', 294, '2019-10-29', 372, NULL),
('Hi-Way Inn', 294, '2019-10-30', 144, NULL),
('Hi-Way Inn', 294, '2019-10-31', 318, NULL),
('Hi-Way Inn', 294, '2019-11-01', 282, NULL),
('Hi-Way Inn', 294, '2019-11-02', 173, NULL),
('Hi-Way Inn', 294, '2019-11-03', 172, NULL),
('Hi-Way Inn', 294, '2019-11-04', 187, NULL),
('Hi-Way Inn', 294, '2019-11-05', 321, NULL),
('Hi-Way Inn', 294, '2019-11-06', 109, NULL),
('Hi-Way Inn', 294, '2019-11-07', 127, NULL),
('Hi-Way Inn', 294, '2019-11-08', 199, NULL),
('Hi-Way Inn', 294, '2019-11-09', 352, NULL),
('Hi-Way Inn', 294, '2019-11-10', 168, NULL),
('Hi-Way Inn', 294, '2019-11-11', 122, NULL),
('Hi-Way Inn', 294, '2019-11-12', 237, NULL),
('Hi-Way Inn', 294, '2019-11-13', 120, NULL),
('Hi-Way Inn', 294, '2019-11-14', 204, NULL),
('Hi-Way Inn', 294, '2019-11-15', 195, NULL),
('Hi-Way Inn', 294, '2019-11-16', 159, NULL),
('Hi-Way Inn', 294, '2019-11-17', 236, NULL),
('Hi-Way Inn', 294, '2019-11-18', 378, NULL),
('Hi-Way Inn', 294, '2019-11-19', 197, NULL),
('Hi-Way Inn', 294, '2019-11-20', 198, NULL),
('Hi-Way Inn', 294, '2019-11-21', 396, NULL),
('Hi-Way Inn', 294, '2019-11-22', 223, NULL),
('Hi-Way Inn', 294, '2019-11-23', 240, NULL),
('Hi-Way Inn', 294, '2019-11-24', 369, NULL),
('Hi-Way Inn', 294, '2019-11-25', 143, NULL),
('Hi-Way Inn', 294, '2019-11-26', 181, NULL),
('Hi-Way Inn', 294, '2019-11-27', 342, NULL),
('Hi-Way Inn', 294, '2019-11-28', 236, NULL),
('Hi-Way Inn', 294, '2019-11-29', 168, NULL),
('Hi-Way Inn', 294, '2019-11-30', 237, NULL),
('Hi-Way Inn', 294, '2019-12-01', 239, NULL),
('Hi-Way Inn', 294, '2019-12-02', 354, NULL),
('Hi-Way Inn', 294, '2019-12-03', 338, NULL),
('Hi-Way Inn', 294, '2019-12-04', 290, NULL),
('Hi-Way Inn', 294, '2019-12-05', 140, NULL),
('Hi-Way Inn', 294, '2019-12-06', 320, NULL),
('Hi-Way Inn', 294, '2019-12-07', 106, NULL),
('Hi-Way Inn', 294, '2019-12-08', 133, NULL),
('Hi-Way Inn', 294, '2019-12-09', 214, NULL),
('Hi-Way Inn', 294, '2019-12-10', 338, NULL),
('Hi-Way Inn', 294, '2019-12-11', 219, NULL),
('Hi-Way Inn', 294, '2019-12-12', 234, NULL),
('Hi-Way Inn', 294, '2019-12-13', 396, NULL),
('Hi-Way Inn', 294, '2019-12-14', 216, NULL),
('Hi-Way Inn', 294, '2019-12-15', 237, NULL),
('Hi-Way Inn', 294, '2019-12-16', 158, NULL),
('Hi-Way Inn', 294, '2019-12-17', 378, NULL),
('Hi-Way Inn', 294, '2019-12-18', 135, NULL),
('Hi-Way Inn', 294, '2019-12-19', 176, NULL),
('Hi-Way Inn', 294, '2019-12-20', 150, NULL),
('Hi-Way Inn', 294, '2019-12-21', 356, NULL),
('Hi-Way Inn', 294, '2019-12-22', 381, NULL),
('Hi-Way Inn', 294, '2019-12-23', 312, NULL),
('Hi-Way Inn', 294, '2019-12-24', 310, NULL),
('Hi-Way Inn', 294, '2019-12-25', 342, NULL),
('Hi-Way Inn', 294, '2019-12-26', 228, NULL),
('Hi-Way Inn', 294, '2019-12-27', 251, NULL),
('Hi-Way Inn', 294, '2019-12-28', 274, NULL),
('Hi-Way Inn', 294, '2019-12-29', 388, NULL),
('Hi-Way Inn', 294, '2019-12-30', 110, NULL),
('Hi-Way Inn', 294, '2019-12-31', 187, NULL),
('Hi-Way Inn', 294, '2020-01-01', 158, NULL),
('Hi-Way Inn', 294, '2020-01-02', 190, NULL),
('Hi-Way Inn', 294, '2020-01-03', 286, NULL),
('Hi-Way Inn', 294, '2020-01-04', 360, NULL),
('Hi-Way Inn', 294, '2020-01-05', 310, NULL),
('Hi-Way Inn', 294, '2020-01-06', 397, NULL),
('Hi-Way Inn', 294, '2020-01-07', 172, NULL),
('Hi-Way Inn', 294, '2020-01-08', 291, NULL),
('Hi-Way Inn', 294, '2020-01-09', 252, NULL),
('Hi-Way Inn', 294, '2020-01-10', 188, NULL),
('Hi-Way Inn', 294, '2020-01-11', 243, NULL),
('Hi-Way Inn', 294, '2020-01-12', 229, NULL),
('Hi-Way Inn', 294, '2020-01-13', 286, NULL),
('Hi-Way Inn', 294, '2020-01-14', 138, NULL),
('Hi-Way Inn', 294, '2020-01-15', 339, NULL),
('Hi-Way Inn', 294, '2020-01-16', 161, NULL),
('Hi-Way Inn', 294, '2020-01-17', 185, NULL),
('Hi-Way Inn', 294, '2020-01-18', 268, NULL),
('Hi-Way Inn', 294, '2020-01-19', 229, NULL),
('Hi-Way Inn', 294, '2020-01-20', 319, NULL),
('Hi-Way Inn', 294, '2020-01-21', 143, NULL),
('Hi-Way Inn', 294, '2020-01-22', 137, NULL),
('Hi-Way Inn', 294, '2020-01-23', 264, NULL),
('Hi-Way Inn', 294, '2020-01-24', 335, NULL),
('Hi-Way Inn', 294, '2020-01-25', 265, NULL),
('Hi-Way Inn', 294, '2020-01-26', 223, NULL),
('Hi-Way Inn', 294, '2020-01-27', 345, NULL),
('Hi-Way Inn', 294, '2020-01-28', 334, NULL),
('Hi-Way Inn', 294, '2020-01-29', 144, NULL),
('Hi-Way Inn', 294, '2020-01-30', 119, NULL),
('Hi-Way Inn', 294, '2020-01-31', 293, NULL),
('Hi-Way Inn', 294, '2020-02-01', 321, NULL),
('Hi-Way Inn', 294, '2020-02-02', 114, NULL),
('Hi-Way Inn', 294, '2020-02-03', 283, NULL),
('Hi-Way Inn', 294, '2020-02-04', 126, NULL),
('Hi-Way Inn', 295, '2019-01-01', 354, NULL),
('Hi-Way Inn', 295, '2019-01-02', 308, NULL),
('Hi-Way Inn', 295, '2019-01-03', 107, NULL),
('Hi-Way Inn', 295, '2019-01-04', 317, NULL),
('Hi-Way Inn', 295, '2019-01-05', 118, NULL),
('Hi-Way Inn', 295, '2019-01-06', 202, NULL),
('Hi-Way Inn', 295, '2019-01-07', 298, NULL),
('Hi-Way Inn', 295, '2019-01-08', 348, NULL),
('Hi-Way Inn', 295, '2019-01-09', 293, NULL),
('Hi-Way Inn', 295, '2019-01-10', 213, NULL),
('Hi-Way Inn', 295, '2019-01-11', 380, NULL),
('Hi-Way Inn', 295, '2019-01-12', 164, NULL),
('Hi-Way Inn', 295, '2019-01-13', 387, NULL),
('Hi-Way Inn', 295, '2019-01-14', 228, NULL),
('Hi-Way Inn', 295, '2019-01-15', 247, NULL),
('Hi-Way Inn', 295, '2019-01-16', 213, NULL),
('Hi-Way Inn', 295, '2019-01-17', 360, NULL),
('Hi-Way Inn', 295, '2019-01-18', 154, NULL),
('Hi-Way Inn', 295, '2019-01-19', 372, NULL),
('Hi-Way Inn', 295, '2019-01-20', 166, NULL),
('Hi-Way Inn', 295, '2019-01-21', 333, NULL),
('Hi-Way Inn', 295, '2019-01-22', 129, NULL),
('Hi-Way Inn', 295, '2019-01-23', 275, NULL),
('Hi-Way Inn', 295, '2019-01-24', 210, NULL),
('Hi-Way Inn', 295, '2019-01-25', 295, NULL),
('Hi-Way Inn', 295, '2019-01-26', 149, NULL),
('Hi-Way Inn', 295, '2019-01-27', 221, NULL),
('Hi-Way Inn', 295, '2019-01-28', 363, NULL),
('Hi-Way Inn', 295, '2019-01-29', 175, NULL),
('Hi-Way Inn', 295, '2019-01-30', 257, NULL),
('Hi-Way Inn', 295, '2019-01-31', 239, NULL),
('Hi-Way Inn', 295, '2019-02-01', 140, NULL),
('Hi-Way Inn', 295, '2019-02-02', 358, NULL),
('Hi-Way Inn', 295, '2019-02-03', 191, NULL),
('Hi-Way Inn', 295, '2019-02-04', 203, NULL),
('Hi-Way Inn', 295, '2019-02-05', 283, NULL),
('Hi-Way Inn', 295, '2019-02-06', 367, NULL),
('Hi-Way Inn', 295, '2019-02-07', 266, NULL),
('Hi-Way Inn', 295, '2019-02-08', 209, NULL),
('Hi-Way Inn', 295, '2019-02-09', 364, NULL),
('Hi-Way Inn', 295, '2019-02-10', 264, NULL),
('Hi-Way Inn', 295, '2019-02-11', 356, NULL),
('Hi-Way Inn', 295, '2019-02-12', 241, NULL),
('Hi-Way Inn', 295, '2019-02-13', 120, NULL),
('Hi-Way Inn', 295, '2019-02-14', 358, NULL),
('Hi-Way Inn', 295, '2019-02-15', 170, NULL),
('Hi-Way Inn', 295, '2019-02-16', 171, NULL),
('Hi-Way Inn', 295, '2019-02-17', 134, NULL),
('Hi-Way Inn', 295, '2019-02-18', 361, NULL),
('Hi-Way Inn', 295, '2019-02-19', 135, NULL),
('Hi-Way Inn', 295, '2019-02-20', 378, NULL),
('Hi-Way Inn', 295, '2019-02-21', 205, NULL),
('Hi-Way Inn', 295, '2019-02-22', 164, NULL),
('Hi-Way Inn', 295, '2019-02-23', 281, NULL),
('Hi-Way Inn', 295, '2019-02-24', 232, NULL),
('Hi-Way Inn', 295, '2019-02-25', 372, NULL),
('Hi-Way Inn', 295, '2019-02-26', 212, NULL),
('Hi-Way Inn', 295, '2019-02-27', 195, NULL),
('Hi-Way Inn', 295, '2019-02-28', 122, NULL),
('Hi-Way Inn', 295, '2019-03-01', 179, NULL),
('Hi-Way Inn', 295, '2019-03-02', 180, NULL),
('Hi-Way Inn', 295, '2019-03-03', 333, NULL),
('Hi-Way Inn', 295, '2019-03-04', 330, NULL),
('Hi-Way Inn', 295, '2019-03-05', 311, NULL),
('Hi-Way Inn', 295, '2019-03-06', 331, NULL),
('Hi-Way Inn', 295, '2019-03-07', 146, NULL),
('Hi-Way Inn', 295, '2019-03-08', 354, NULL),
('Hi-Way Inn', 295, '2019-03-09', 227, NULL),
('Hi-Way Inn', 295, '2019-03-10', 145, NULL),
('Hi-Way Inn', 295, '2019-03-11', 157, NULL),
('Hi-Way Inn', 295, '2019-03-12', 183, NULL),
('Hi-Way Inn', 295, '2019-03-13', 363, NULL),
('Hi-Way Inn', 295, '2019-03-14', 208, NULL),
('Hi-Way Inn', 295, '2019-03-15', 123, NULL),
('Hi-Way Inn', 295, '2019-03-16', 247, NULL),
('Hi-Way Inn', 295, '2019-03-17', 294, NULL),
('Hi-Way Inn', 295, '2019-03-18', 330, NULL),
('Hi-Way Inn', 295, '2019-03-19', 179, NULL),
('Hi-Way Inn', 295, '2019-03-20', 229, NULL),
('Hi-Way Inn', 295, '2019-03-21', 277, NULL),
('Hi-Way Inn', 295, '2019-03-22', 274, NULL),
('Hi-Way Inn', 295, '2019-03-23', 321, NULL),
('Hi-Way Inn', 295, '2019-03-24', 203, NULL),
('Hi-Way Inn', 295, '2019-03-25', 193, NULL),
('Hi-Way Inn', 295, '2019-03-26', 147, NULL),
('Hi-Way Inn', 295, '2019-03-27', 381, NULL),
('Hi-Way Inn', 295, '2019-03-28', 183, NULL),
('Hi-Way Inn', 295, '2019-03-29', 216, NULL),
('Hi-Way Inn', 295, '2019-03-30', 270, NULL),
('Hi-Way Inn', 295, '2019-03-31', 357, NULL),
('Hi-Way Inn', 295, '2019-04-01', 272, NULL),
('Hi-Way Inn', 295, '2019-04-02', 361, NULL),
('Hi-Way Inn', 295, '2019-04-03', 217, NULL),
('Hi-Way Inn', 295, '2019-04-04', 366, NULL),
('Hi-Way Inn', 295, '2019-04-05', 336, NULL),
('Hi-Way Inn', 295, '2019-04-06', 147, NULL),
('Hi-Way Inn', 295, '2019-04-07', 327, NULL),
('Hi-Way Inn', 295, '2019-04-08', 304, NULL),
('Hi-Way Inn', 295, '2019-04-09', 173, NULL),
('Hi-Way Inn', 295, '2019-04-10', 177, NULL),
('Hi-Way Inn', 295, '2019-04-11', 156, NULL),
('Hi-Way Inn', 295, '2019-04-12', 346, NULL),
('Hi-Way Inn', 295, '2019-04-13', 255, NULL),
('Hi-Way Inn', 295, '2019-04-14', 384, NULL),
('Hi-Way Inn', 295, '2019-04-15', 307, NULL),
('Hi-Way Inn', 295, '2019-04-16', 328, NULL),
('Hi-Way Inn', 295, '2019-04-17', 136, NULL),
('Hi-Way Inn', 295, '2019-04-18', 322, NULL),
('Hi-Way Inn', 295, '2019-04-19', 363, NULL),
('Hi-Way Inn', 295, '2019-04-20', 363, NULL),
('Hi-Way Inn', 295, '2019-04-21', 262, NULL),
('Hi-Way Inn', 295, '2019-04-22', 172, NULL),
('Hi-Way Inn', 295, '2019-04-23', 350, NULL),
('Hi-Way Inn', 295, '2019-04-24', 207, NULL),
('Hi-Way Inn', 295, '2019-04-25', 295, NULL),
('Hi-Way Inn', 295, '2019-04-26', 306, NULL),
('Hi-Way Inn', 295, '2019-04-27', 117, NULL),
('Hi-Way Inn', 295, '2019-04-28', 132, NULL),
('Hi-Way Inn', 295, '2019-04-29', 159, NULL),
('Hi-Way Inn', 295, '2019-04-30', 238, NULL),
('Hi-Way Inn', 295, '2019-05-01', 294, NULL),
('Hi-Way Inn', 295, '2019-05-02', 199, NULL),
('Hi-Way Inn', 295, '2019-05-03', 276, NULL),
('Hi-Way Inn', 295, '2019-05-04', 312, NULL),
('Hi-Way Inn', 295, '2019-05-05', 381, NULL),
('Hi-Way Inn', 295, '2019-05-06', 296, NULL),
('Hi-Way Inn', 295, '2019-05-07', 244, NULL),
('Hi-Way Inn', 295, '2019-05-08', 170, NULL),
('Hi-Way Inn', 295, '2019-05-09', 157, NULL),
('Hi-Way Inn', 295, '2019-05-10', 259, NULL),
('Hi-Way Inn', 295, '2019-05-11', 143, NULL),
('Hi-Way Inn', 295, '2019-05-12', 316, NULL),
('Hi-Way Inn', 295, '2019-05-13', 371, NULL),
('Hi-Way Inn', 295, '2019-05-14', 378, NULL),
('Hi-Way Inn', 295, '2019-05-15', 259, NULL),
('Hi-Way Inn', 295, '2019-05-16', 297, NULL),
('Hi-Way Inn', 295, '2019-05-17', 350, NULL),
('Hi-Way Inn', 295, '2019-05-18', 236, NULL),
('Hi-Way Inn', 295, '2019-05-19', 266, NULL),
('Hi-Way Inn', 295, '2019-05-20', 186, NULL),
('Hi-Way Inn', 295, '2019-05-21', 280, NULL),
('Hi-Way Inn', 295, '2019-05-22', 218, NULL),
('Hi-Way Inn', 295, '2019-05-23', 313, NULL),
('Hi-Way Inn', 295, '2019-05-24', 321, NULL),
('Hi-Way Inn', 295, '2019-05-25', 282, NULL),
('Hi-Way Inn', 295, '2019-05-26', 127, NULL),
('Hi-Way Inn', 295, '2019-05-27', 380, NULL),
('Hi-Way Inn', 295, '2019-05-28', 170, NULL),
('Hi-Way Inn', 295, '2019-05-29', 252, NULL),
('Hi-Way Inn', 295, '2019-05-30', 225, NULL),
('Hi-Way Inn', 295, '2019-05-31', 380, NULL),
('Hi-Way Inn', 295, '2019-06-01', 240, NULL),
('Hi-Way Inn', 295, '2019-06-02', 382, NULL),
('Hi-Way Inn', 295, '2019-06-03', 262, NULL),
('Hi-Way Inn', 295, '2019-06-04', 258, NULL),
('Hi-Way Inn', 295, '2019-06-05', 310, NULL),
('Hi-Way Inn', 295, '2019-06-06', 323, NULL),
('Hi-Way Inn', 295, '2019-06-07', 327, NULL),
('Hi-Way Inn', 295, '2019-06-08', 348, NULL),
('Hi-Way Inn', 295, '2019-06-09', 280, NULL),
('Hi-Way Inn', 295, '2019-06-10', 142, NULL),
('Hi-Way Inn', 295, '2019-06-11', 262, NULL),
('Hi-Way Inn', 295, '2019-06-12', 152, NULL),
('Hi-Way Inn', 295, '2019-06-13', 286, NULL),
('Hi-Way Inn', 295, '2019-06-14', 200, NULL),
('Hi-Way Inn', 295, '2019-06-15', 212, NULL),
('Hi-Way Inn', 295, '2019-06-16', 193, NULL),
('Hi-Way Inn', 295, '2019-06-17', 283, NULL),
('Hi-Way Inn', 295, '2019-06-18', 338, NULL),
('Hi-Way Inn', 295, '2019-06-19', 351, NULL),
('Hi-Way Inn', 295, '2019-06-20', 395, NULL),
('Hi-Way Inn', 295, '2019-06-21', 192, NULL),
('Hi-Way Inn', 295, '2019-06-22', 387, NULL),
('Hi-Way Inn', 295, '2019-06-23', 213, NULL),
('Hi-Way Inn', 295, '2019-06-24', 121, NULL),
('Hi-Way Inn', 295, '2019-06-25', 350, NULL),
('Hi-Way Inn', 295, '2019-06-26', 133, NULL),
('Hi-Way Inn', 295, '2019-06-27', 264, NULL),
('Hi-Way Inn', 295, '2019-06-28', 182, NULL),
('Hi-Way Inn', 295, '2019-06-29', 160, NULL),
('Hi-Way Inn', 295, '2019-06-30', 279, NULL),
('Hi-Way Inn', 295, '2019-07-01', 120, NULL),
('Hi-Way Inn', 295, '2019-07-02', 370, NULL),
('Hi-Way Inn', 295, '2019-07-03', 307, NULL),
('Hi-Way Inn', 295, '2019-07-04', 138, NULL),
('Hi-Way Inn', 295, '2019-07-05', 345, NULL),
('Hi-Way Inn', 295, '2019-07-06', 134, NULL),
('Hi-Way Inn', 295, '2019-07-07', 306, NULL),
('Hi-Way Inn', 295, '2019-07-08', 135, NULL),
('Hi-Way Inn', 295, '2019-07-09', 340, NULL),
('Hi-Way Inn', 295, '2019-07-10', 162, NULL),
('Hi-Way Inn', 295, '2019-07-11', 280, NULL),
('Hi-Way Inn', 295, '2019-07-12', 112, NULL),
('Hi-Way Inn', 295, '2019-07-13', 208, NULL),
('Hi-Way Inn', 295, '2019-07-14', 326, NULL),
('Hi-Way Inn', 295, '2019-07-15', 219, NULL),
('Hi-Way Inn', 295, '2019-07-16', 169, NULL),
('Hi-Way Inn', 295, '2019-07-17', 140, NULL),
('Hi-Way Inn', 295, '2019-07-18', 221, NULL),
('Hi-Way Inn', 295, '2019-07-19', 301, NULL),
('Hi-Way Inn', 295, '2019-07-20', 376, NULL),
('Hi-Way Inn', 295, '2019-07-21', 163, NULL),
('Hi-Way Inn', 295, '2019-07-22', 140, NULL),
('Hi-Way Inn', 295, '2019-07-23', 226, NULL),
('Hi-Way Inn', 295, '2019-07-24', 162, NULL),
('Hi-Way Inn', 295, '2019-07-25', 267, NULL),
('Hi-Way Inn', 295, '2019-07-26', 278, NULL),
('Hi-Way Inn', 295, '2019-07-27', 117, NULL),
('Hi-Way Inn', 295, '2019-07-28', 204, NULL),
('Hi-Way Inn', 295, '2019-07-29', 340, NULL),
('Hi-Way Inn', 295, '2019-07-30', 193, NULL),
('Hi-Way Inn', 295, '2019-07-31', 140, NULL),
('Hi-Way Inn', 295, '2019-08-01', 176, NULL),
('Hi-Way Inn', 295, '2019-08-02', 222, NULL),
('Hi-Way Inn', 295, '2019-08-03', 376, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hi-Way Inn', 295, '2019-08-04', 306, NULL),
('Hi-Way Inn', 295, '2019-08-05', 228, NULL),
('Hi-Way Inn', 295, '2019-08-06', 355, NULL),
('Hi-Way Inn', 295, '2019-08-07', 209, NULL),
('Hi-Way Inn', 295, '2019-08-08', 105, NULL),
('Hi-Way Inn', 295, '2019-08-09', 243, NULL),
('Hi-Way Inn', 295, '2019-08-10', 376, NULL),
('Hi-Way Inn', 295, '2019-08-11', 116, NULL),
('Hi-Way Inn', 295, '2019-08-12', 102, NULL),
('Hi-Way Inn', 295, '2019-08-13', 358, NULL),
('Hi-Way Inn', 295, '2019-08-14', 178, NULL),
('Hi-Way Inn', 295, '2019-08-15', 390, NULL),
('Hi-Way Inn', 295, '2019-08-16', 219, NULL),
('Hi-Way Inn', 295, '2019-08-17', 212, NULL),
('Hi-Way Inn', 295, '2019-08-18', 121, NULL),
('Hi-Way Inn', 295, '2019-08-19', 363, NULL),
('Hi-Way Inn', 295, '2019-08-20', 247, NULL),
('Hi-Way Inn', 295, '2019-08-21', 240, NULL),
('Hi-Way Inn', 295, '2019-08-22', 132, NULL),
('Hi-Way Inn', 295, '2019-08-23', 387, NULL),
('Hi-Way Inn', 295, '2019-08-24', 384, NULL),
('Hi-Way Inn', 295, '2019-08-25', 256, NULL),
('Hi-Way Inn', 295, '2019-08-26', 203, NULL),
('Hi-Way Inn', 295, '2019-08-27', 218, NULL),
('Hi-Way Inn', 295, '2019-08-28', 341, NULL),
('Hi-Way Inn', 295, '2019-08-29', 102, NULL),
('Hi-Way Inn', 295, '2019-08-30', 149, NULL),
('Hi-Way Inn', 295, '2019-08-31', 373, NULL),
('Hi-Way Inn', 295, '2019-09-01', 292, NULL),
('Hi-Way Inn', 295, '2019-09-02', 140, NULL),
('Hi-Way Inn', 295, '2019-09-03', 244, NULL),
('Hi-Way Inn', 295, '2019-09-04', 183, NULL),
('Hi-Way Inn', 295, '2019-09-05', 180, NULL),
('Hi-Way Inn', 295, '2019-09-06', 247, NULL),
('Hi-Way Inn', 295, '2019-09-07', 113, NULL),
('Hi-Way Inn', 295, '2019-09-08', 171, NULL),
('Hi-Way Inn', 295, '2019-09-09', 156, NULL),
('Hi-Way Inn', 295, '2019-09-10', 290, NULL),
('Hi-Way Inn', 295, '2019-09-11', 392, NULL),
('Hi-Way Inn', 295, '2019-09-12', 209, NULL),
('Hi-Way Inn', 295, '2019-09-13', 310, NULL),
('Hi-Way Inn', 295, '2019-09-14', 157, NULL),
('Hi-Way Inn', 295, '2019-09-15', 279, NULL),
('Hi-Way Inn', 295, '2019-09-16', 178, NULL),
('Hi-Way Inn', 295, '2019-09-17', 157, NULL),
('Hi-Way Inn', 295, '2019-09-18', 191, NULL),
('Hi-Way Inn', 295, '2019-09-19', 391, NULL),
('Hi-Way Inn', 295, '2019-09-20', 120, NULL),
('Hi-Way Inn', 295, '2019-09-21', 209, NULL),
('Hi-Way Inn', 295, '2019-09-22', 190, NULL),
('Hi-Way Inn', 295, '2019-09-23', 200, NULL),
('Hi-Way Inn', 295, '2019-09-24', 317, NULL),
('Hi-Way Inn', 295, '2019-09-25', 207, NULL),
('Hi-Way Inn', 295, '2019-09-26', 170, NULL),
('Hi-Way Inn', 295, '2019-09-27', 352, NULL),
('Hi-Way Inn', 295, '2019-09-28', 381, NULL),
('Hi-Way Inn', 295, '2019-09-29', 290, NULL),
('Hi-Way Inn', 295, '2019-09-30', 281, NULL),
('Hi-Way Inn', 295, '2019-10-01', 335, NULL),
('Hi-Way Inn', 295, '2019-10-02', 384, NULL),
('Hi-Way Inn', 295, '2019-10-03', 310, NULL),
('Hi-Way Inn', 295, '2019-10-04', 158, NULL),
('Hi-Way Inn', 295, '2019-10-05', 369, NULL),
('Hi-Way Inn', 295, '2019-10-06', 268, NULL),
('Hi-Way Inn', 295, '2019-10-07', 338, NULL),
('Hi-Way Inn', 295, '2019-10-08', 250, NULL),
('Hi-Way Inn', 295, '2019-10-09', 222, NULL),
('Hi-Way Inn', 295, '2019-10-10', 164, NULL),
('Hi-Way Inn', 295, '2019-10-11', 246, NULL),
('Hi-Way Inn', 295, '2019-10-12', 380, NULL),
('Hi-Way Inn', 295, '2019-10-13', 240, NULL),
('Hi-Way Inn', 295, '2019-10-14', 382, NULL),
('Hi-Way Inn', 295, '2019-10-15', 181, NULL),
('Hi-Way Inn', 295, '2019-10-16', 311, NULL),
('Hi-Way Inn', 295, '2019-10-17', 364, NULL),
('Hi-Way Inn', 295, '2019-10-18', 150, NULL),
('Hi-Way Inn', 295, '2019-10-19', 320, NULL),
('Hi-Way Inn', 295, '2019-10-20', 361, NULL),
('Hi-Way Inn', 295, '2019-10-21', 164, NULL),
('Hi-Way Inn', 295, '2019-10-22', 331, NULL),
('Hi-Way Inn', 295, '2019-10-23', 306, NULL),
('Hi-Way Inn', 295, '2019-10-24', 345, NULL),
('Hi-Way Inn', 295, '2019-10-25', 358, NULL),
('Hi-Way Inn', 295, '2019-10-26', 244, NULL),
('Hi-Way Inn', 295, '2019-10-27', 118, NULL),
('Hi-Way Inn', 295, '2019-10-28', 114, NULL),
('Hi-Way Inn', 295, '2019-10-29', 379, NULL),
('Hi-Way Inn', 295, '2019-10-30', 233, NULL),
('Hi-Way Inn', 295, '2019-10-31', 246, NULL),
('Hi-Way Inn', 295, '2019-11-01', 139, NULL),
('Hi-Way Inn', 295, '2019-11-02', 374, NULL),
('Hi-Way Inn', 295, '2019-11-03', 312, NULL),
('Hi-Way Inn', 295, '2019-11-04', 173, NULL),
('Hi-Way Inn', 295, '2019-11-05', 377, NULL),
('Hi-Way Inn', 295, '2019-11-06', 307, NULL),
('Hi-Way Inn', 295, '2019-11-07', 349, NULL),
('Hi-Way Inn', 295, '2019-11-08', 317, NULL),
('Hi-Way Inn', 295, '2019-11-09', 148, NULL),
('Hi-Way Inn', 295, '2019-11-10', 288, NULL),
('Hi-Way Inn', 295, '2019-11-11', 327, NULL),
('Hi-Way Inn', 295, '2019-11-12', 238, NULL),
('Hi-Way Inn', 295, '2019-11-13', 106, NULL),
('Hi-Way Inn', 295, '2019-11-14', 252, NULL),
('Hi-Way Inn', 295, '2019-11-15', 307, NULL),
('Hi-Way Inn', 295, '2019-11-16', 384, NULL),
('Hi-Way Inn', 295, '2019-11-17', 371, NULL),
('Hi-Way Inn', 295, '2019-11-18', 384, NULL),
('Hi-Way Inn', 295, '2019-11-19', 377, NULL),
('Hi-Way Inn', 295, '2019-11-20', 197, NULL),
('Hi-Way Inn', 295, '2019-11-21', 391, NULL),
('Hi-Way Inn', 295, '2019-11-22', 346, NULL),
('Hi-Way Inn', 295, '2019-11-23', 320, NULL),
('Hi-Way Inn', 295, '2019-11-24', 301, NULL),
('Hi-Way Inn', 295, '2019-11-25', 333, NULL),
('Hi-Way Inn', 295, '2019-11-26', 250, NULL),
('Hi-Way Inn', 295, '2019-11-27', 162, NULL),
('Hi-Way Inn', 295, '2019-11-28', 232, NULL),
('Hi-Way Inn', 295, '2019-11-29', 386, NULL),
('Hi-Way Inn', 295, '2019-11-30', 177, NULL),
('Hi-Way Inn', 295, '2019-12-01', 211, NULL),
('Hi-Way Inn', 295, '2019-12-02', 331, NULL),
('Hi-Way Inn', 295, '2019-12-03', 105, NULL),
('Hi-Way Inn', 295, '2019-12-04', 114, NULL),
('Hi-Way Inn', 295, '2019-12-05', 172, NULL),
('Hi-Way Inn', 295, '2019-12-06', 170, NULL),
('Hi-Way Inn', 295, '2019-12-07', 169, NULL),
('Hi-Way Inn', 295, '2019-12-08', 332, NULL),
('Hi-Way Inn', 295, '2019-12-09', 203, NULL),
('Hi-Way Inn', 295, '2019-12-10', 141, NULL),
('Hi-Way Inn', 295, '2019-12-11', 346, NULL),
('Hi-Way Inn', 295, '2019-12-12', 290, NULL),
('Hi-Way Inn', 295, '2019-12-13', 339, NULL),
('Hi-Way Inn', 295, '2019-12-14', 193, NULL),
('Hi-Way Inn', 295, '2019-12-15', 394, NULL),
('Hi-Way Inn', 295, '2019-12-16', 253, NULL),
('Hi-Way Inn', 295, '2019-12-17', 197, NULL),
('Hi-Way Inn', 295, '2019-12-18', 294, NULL),
('Hi-Way Inn', 295, '2019-12-19', 365, NULL),
('Hi-Way Inn', 295, '2019-12-20', 180, NULL),
('Hi-Way Inn', 295, '2019-12-21', 387, NULL),
('Hi-Way Inn', 295, '2019-12-22', 395, NULL),
('Hi-Way Inn', 295, '2019-12-23', 247, NULL),
('Hi-Way Inn', 295, '2019-12-24', 163, NULL),
('Hi-Way Inn', 295, '2019-12-25', 313, NULL),
('Hi-Way Inn', 295, '2019-12-26', 366, NULL),
('Hi-Way Inn', 295, '2019-12-27', 151, NULL),
('Hi-Way Inn', 295, '2019-12-28', 147, NULL),
('Hi-Way Inn', 295, '2019-12-29', 147, NULL),
('Hi-Way Inn', 295, '2019-12-30', 302, NULL),
('Hi-Way Inn', 295, '2019-12-31', 281, NULL),
('Hi-Way Inn', 295, '2020-01-01', 335, NULL),
('Hi-Way Inn', 295, '2020-01-02', 306, NULL),
('Hi-Way Inn', 295, '2020-01-03', 285, NULL),
('Hi-Way Inn', 295, '2020-01-04', 310, NULL),
('Hi-Way Inn', 295, '2020-01-05', 182, NULL),
('Hi-Way Inn', 295, '2020-01-06', 331, NULL),
('Hi-Way Inn', 295, '2020-01-07', 187, NULL),
('Hi-Way Inn', 295, '2020-01-08', 331, NULL),
('Hi-Way Inn', 295, '2020-01-09', 339, NULL),
('Hi-Way Inn', 295, '2020-01-10', 291, NULL),
('Hi-Way Inn', 295, '2020-01-11', 383, NULL),
('Hi-Way Inn', 295, '2020-01-12', 394, NULL),
('Hi-Way Inn', 295, '2020-01-13', 389, NULL),
('Hi-Way Inn', 295, '2020-01-14', 326, NULL),
('Hi-Way Inn', 295, '2020-01-15', 261, NULL),
('Hi-Way Inn', 295, '2020-01-16', 264, NULL),
('Hi-Way Inn', 295, '2020-01-17', 137, NULL),
('Hi-Way Inn', 295, '2020-01-18', 385, NULL),
('Hi-Way Inn', 295, '2020-01-19', 291, NULL),
('Hi-Way Inn', 295, '2020-01-20', 326, NULL),
('Hi-Way Inn', 295, '2020-01-21', 146, NULL),
('Hi-Way Inn', 295, '2020-01-22', 155, NULL),
('Hi-Way Inn', 295, '2020-01-23', 256, NULL),
('Hi-Way Inn', 295, '2020-01-24', 351, NULL),
('Hi-Way Inn', 295, '2020-01-25', 224, NULL),
('Hi-Way Inn', 295, '2020-01-26', 280, NULL),
('Hi-Way Inn', 295, '2020-01-27', 234, NULL),
('Hi-Way Inn', 295, '2020-01-28', 290, NULL),
('Hi-Way Inn', 295, '2020-01-29', 134, NULL),
('Hi-Way Inn', 295, '2020-01-30', 152, NULL),
('Hi-Way Inn', 295, '2020-01-31', 359, NULL),
('Hi-Way Inn', 295, '2020-02-01', 117, NULL),
('Hi-Way Inn', 295, '2020-02-02', 356, NULL),
('Hi-Way Inn', 295, '2020-02-03', 303, NULL),
('Hi-Way Inn', 295, '2020-02-04', 305, NULL),
('Hilton Downtown', 8, '2019-01-01', 352, NULL),
('Hilton Downtown', 8, '2019-01-02', 169, NULL),
('Hilton Downtown', 8, '2019-01-03', 322, NULL),
('Hilton Downtown', 8, '2019-01-04', 245, NULL),
('Hilton Downtown', 8, '2019-01-05', 397, NULL),
('Hilton Downtown', 8, '2019-01-06', 347, NULL),
('Hilton Downtown', 8, '2019-01-07', 207, NULL),
('Hilton Downtown', 8, '2019-01-08', 271, NULL),
('Hilton Downtown', 8, '2019-01-09', 132, NULL),
('Hilton Downtown', 8, '2019-01-10', 184, NULL),
('Hilton Downtown', 8, '2019-01-11', 271, NULL),
('Hilton Downtown', 8, '2019-01-12', 285, NULL),
('Hilton Downtown', 8, '2019-01-13', 361, NULL),
('Hilton Downtown', 8, '2019-01-14', 390, NULL),
('Hilton Downtown', 8, '2019-01-15', 318, NULL),
('Hilton Downtown', 8, '2019-01-16', 139, NULL),
('Hilton Downtown', 8, '2019-01-17', 366, NULL),
('Hilton Downtown', 8, '2019-01-18', 348, NULL),
('Hilton Downtown', 8, '2019-01-19', 360, NULL),
('Hilton Downtown', 8, '2019-01-20', 239, NULL),
('Hilton Downtown', 8, '2019-01-21', 396, NULL),
('Hilton Downtown', 8, '2019-01-22', 120, NULL),
('Hilton Downtown', 8, '2019-01-23', 293, NULL),
('Hilton Downtown', 8, '2019-01-24', 294, NULL),
('Hilton Downtown', 8, '2019-01-25', 235, NULL),
('Hilton Downtown', 8, '2019-01-26', 117, NULL),
('Hilton Downtown', 8, '2019-01-27', 128, NULL),
('Hilton Downtown', 8, '2019-01-28', 204, NULL),
('Hilton Downtown', 8, '2019-01-29', 266, NULL),
('Hilton Downtown', 8, '2019-01-30', 241, NULL),
('Hilton Downtown', 8, '2019-01-31', 314, NULL),
('Hilton Downtown', 8, '2019-02-01', 377, NULL),
('Hilton Downtown', 8, '2019-02-02', 277, NULL),
('Hilton Downtown', 8, '2019-02-03', 230, NULL),
('Hilton Downtown', 8, '2019-02-04', 253, NULL),
('Hilton Downtown', 8, '2019-02-05', 355, NULL),
('Hilton Downtown', 8, '2019-02-06', 109, NULL),
('Hilton Downtown', 8, '2019-02-07', 340, NULL),
('Hilton Downtown', 8, '2019-02-08', 101, NULL),
('Hilton Downtown', 8, '2019-02-09', 294, 187),
('Hilton Downtown', 8, '2019-02-10', 123, 187),
('Hilton Downtown', 8, '2019-02-11', 228, 187),
('Hilton Downtown', 8, '2019-02-12', 149, 187),
('Hilton Downtown', 8, '2019-02-13', 235, 187),
('Hilton Downtown', 8, '2019-02-14', 277, 187),
('Hilton Downtown', 8, '2019-02-15', 292, 187),
('Hilton Downtown', 8, '2019-02-16', 234, 187),
('Hilton Downtown', 8, '2019-02-17', 298, 187),
('Hilton Downtown', 8, '2019-02-18', 374, 187),
('Hilton Downtown', 8, '2019-02-19', 397, 187),
('Hilton Downtown', 8, '2019-02-20', 185, 187),
('Hilton Downtown', 8, '2019-02-21', 251, NULL),
('Hilton Downtown', 8, '2019-02-22', 202, NULL),
('Hilton Downtown', 8, '2019-02-23', 203, NULL),
('Hilton Downtown', 8, '2019-02-24', 331, NULL),
('Hilton Downtown', 8, '2019-02-25', 374, NULL),
('Hilton Downtown', 8, '2019-02-26', 321, NULL),
('Hilton Downtown', 8, '2019-02-27', 324, NULL),
('Hilton Downtown', 8, '2019-02-28', 343, NULL),
('Hilton Downtown', 8, '2019-03-01', 327, NULL),
('Hilton Downtown', 8, '2019-03-02', 304, NULL),
('Hilton Downtown', 8, '2019-03-03', 163, 7),
('Hilton Downtown', 8, '2019-03-04', 135, 7),
('Hilton Downtown', 8, '2019-03-05', 376, 7),
('Hilton Downtown', 8, '2019-03-06', 252, 7),
('Hilton Downtown', 8, '2019-03-07', 319, 7),
('Hilton Downtown', 8, '2019-03-08', 217, 7),
('Hilton Downtown', 8, '2019-03-09', 144, 7),
('Hilton Downtown', 8, '2019-03-10', 313, 7),
('Hilton Downtown', 8, '2019-03-11', 273, 7),
('Hilton Downtown', 8, '2019-03-12', 375, 7),
('Hilton Downtown', 8, '2019-03-13', 365, 7),
('Hilton Downtown', 8, '2019-03-14', 361, 7),
('Hilton Downtown', 8, '2019-03-15', 362, 7),
('Hilton Downtown', 8, '2019-03-16', 119, 7),
('Hilton Downtown', 8, '2019-03-17', 148, 7),
('Hilton Downtown', 8, '2019-03-18', 125, 7),
('Hilton Downtown', 8, '2019-03-19', 350, 7),
('Hilton Downtown', 8, '2019-03-20', 210, 7),
('Hilton Downtown', 8, '2019-03-21', 325, 7),
('Hilton Downtown', 8, '2019-03-22', 319, 7),
('Hilton Downtown', 8, '2019-03-23', 328, 7),
('Hilton Downtown', 8, '2019-03-24', 189, 7),
('Hilton Downtown', 8, '2019-03-25', 350, 61),
('Hilton Downtown', 8, '2019-03-26', 131, 61),
('Hilton Downtown', 8, '2019-03-27', 334, 61),
('Hilton Downtown', 8, '2019-03-28', 147, 61),
('Hilton Downtown', 8, '2019-03-29', 125, 61),
('Hilton Downtown', 8, '2019-03-30', 355, 61),
('Hilton Downtown', 8, '2019-03-31', 107, 61),
('Hilton Downtown', 8, '2019-04-01', 380, 61),
('Hilton Downtown', 8, '2019-04-02', 373, 61),
('Hilton Downtown', 8, '2019-04-03', 347, 61),
('Hilton Downtown', 8, '2019-04-04', 338, 61),
('Hilton Downtown', 8, '2019-04-05', 278, 61),
('Hilton Downtown', 8, '2019-04-06', 384, 61),
('Hilton Downtown', 8, '2019-04-07', 380, 61),
('Hilton Downtown', 8, '2019-04-08', 200, 61),
('Hilton Downtown', 8, '2019-04-09', 105, 61),
('Hilton Downtown', 8, '2019-04-10', 267, 61),
('Hilton Downtown', 8, '2019-04-11', 205, 61),
('Hilton Downtown', 8, '2019-04-12', 271, 61),
('Hilton Downtown', 8, '2019-04-13', 174, 145),
('Hilton Downtown', 8, '2019-04-14', 108, 145),
('Hilton Downtown', 8, '2019-04-15', 383, 145),
('Hilton Downtown', 8, '2019-04-16', 339, 145),
('Hilton Downtown', 8, '2019-04-17', 266, 145),
('Hilton Downtown', 8, '2019-04-18', 326, 145),
('Hilton Downtown', 8, '2019-04-19', 119, 145),
('Hilton Downtown', 8, '2019-04-20', 253, 145),
('Hilton Downtown', 8, '2019-04-21', 207, 145),
('Hilton Downtown', 8, '2019-04-22', 267, 145),
('Hilton Downtown', 8, '2019-04-23', 114, 145),
('Hilton Downtown', 8, '2019-04-24', 310, 145),
('Hilton Downtown', 8, '2019-04-25', 354, 145),
('Hilton Downtown', 8, '2019-04-26', 271, 145),
('Hilton Downtown', 8, '2019-04-27', 173, 145),
('Hilton Downtown', 8, '2019-04-28', 172, 145),
('Hilton Downtown', 8, '2019-04-29', 200, 145),
('Hilton Downtown', 8, '2019-04-30', 266, 145),
('Hilton Downtown', 8, '2019-05-01', 286, 145),
('Hilton Downtown', 8, '2019-05-02', 114, 145),
('Hilton Downtown', 8, '2019-05-03', 260, 145),
('Hilton Downtown', 8, '2019-05-04', 192, NULL),
('Hilton Downtown', 8, '2019-05-05', 202, NULL),
('Hilton Downtown', 8, '2019-05-06', 326, NULL),
('Hilton Downtown', 8, '2019-05-07', 107, NULL),
('Hilton Downtown', 8, '2019-05-08', 296, NULL),
('Hilton Downtown', 8, '2019-05-09', 205, NULL),
('Hilton Downtown', 8, '2019-05-10', 348, NULL),
('Hilton Downtown', 8, '2019-05-11', 126, NULL),
('Hilton Downtown', 8, '2019-05-12', 368, NULL),
('Hilton Downtown', 8, '2019-05-13', 277, NULL),
('Hilton Downtown', 8, '2019-05-14', 330, NULL),
('Hilton Downtown', 8, '2019-05-15', 199, NULL),
('Hilton Downtown', 8, '2019-05-16', 102, NULL),
('Hilton Downtown', 8, '2019-05-17', 192, 149),
('Hilton Downtown', 8, '2019-05-18', 156, 149),
('Hilton Downtown', 8, '2019-05-19', 272, 149),
('Hilton Downtown', 8, '2019-05-20', 284, 149),
('Hilton Downtown', 8, '2019-05-21', 367, 149),
('Hilton Downtown', 8, '2019-05-22', 390, 149),
('Hilton Downtown', 8, '2019-05-23', 104, 149),
('Hilton Downtown', 8, '2019-05-24', 380, 149),
('Hilton Downtown', 8, '2019-05-25', 300, 149),
('Hilton Downtown', 8, '2019-05-26', 127, NULL),
('Hilton Downtown', 8, '2019-05-27', 382, NULL),
('Hilton Downtown', 8, '2019-05-28', 238, NULL),
('Hilton Downtown', 8, '2019-05-29', 152, NULL),
('Hilton Downtown', 8, '2019-05-30', 276, NULL),
('Hilton Downtown', 8, '2019-05-31', 245, NULL),
('Hilton Downtown', 8, '2019-06-01', 178, NULL),
('Hilton Downtown', 8, '2019-06-02', 239, NULL),
('Hilton Downtown', 8, '2019-06-03', 206, NULL),
('Hilton Downtown', 8, '2019-06-04', 393, NULL),
('Hilton Downtown', 8, '2019-06-05', 112, NULL),
('Hilton Downtown', 8, '2019-06-06', 107, NULL),
('Hilton Downtown', 8, '2019-06-07', 259, NULL),
('Hilton Downtown', 8, '2019-06-08', 184, NULL),
('Hilton Downtown', 8, '2019-06-09', 203, NULL),
('Hilton Downtown', 8, '2019-06-10', 222, NULL),
('Hilton Downtown', 8, '2019-06-11', 244, NULL),
('Hilton Downtown', 8, '2019-06-12', 372, NULL),
('Hilton Downtown', 8, '2019-06-13', 326, NULL),
('Hilton Downtown', 8, '2019-06-14', 302, NULL),
('Hilton Downtown', 8, '2019-06-15', 321, NULL),
('Hilton Downtown', 8, '2019-06-16', 307, 171),
('Hilton Downtown', 8, '2019-06-17', 255, 171),
('Hilton Downtown', 8, '2019-06-18', 376, 171),
('Hilton Downtown', 8, '2019-06-19', 166, 171),
('Hilton Downtown', 8, '2019-06-20', 321, 171),
('Hilton Downtown', 8, '2019-06-21', 121, 171),
('Hilton Downtown', 8, '2019-06-22', 267, 171),
('Hilton Downtown', 8, '2019-06-23', 366, 171),
('Hilton Downtown', 8, '2019-06-24', 305, 171),
('Hilton Downtown', 8, '2019-06-25', 294, NULL),
('Hilton Downtown', 8, '2019-06-26', 347, 39),
('Hilton Downtown', 8, '2019-06-27', 367, 39),
('Hilton Downtown', 8, '2019-06-28', 371, 39),
('Hilton Downtown', 8, '2019-06-29', 249, 39),
('Hilton Downtown', 8, '2019-06-30', 287, 39),
('Hilton Downtown', 8, '2019-07-01', 262, 39),
('Hilton Downtown', 8, '2019-07-02', 307, 39),
('Hilton Downtown', 8, '2019-07-03', 322, 39),
('Hilton Downtown', 8, '2019-07-04', 179, 39),
('Hilton Downtown', 8, '2019-07-05', 372, 39),
('Hilton Downtown', 8, '2019-07-06', 288, 39),
('Hilton Downtown', 8, '2019-07-07', 182, 39),
('Hilton Downtown', 8, '2019-07-08', 265, 39),
('Hilton Downtown', 8, '2019-07-09', 192, 39),
('Hilton Downtown', 8, '2019-07-10', 381, 39),
('Hilton Downtown', 8, '2019-07-11', 126, 39),
('Hilton Downtown', 8, '2019-07-12', 233, 39),
('Hilton Downtown', 8, '2019-07-13', 353, 39),
('Hilton Downtown', 8, '2019-07-14', 233, 39),
('Hilton Downtown', 8, '2019-07-15', 297, 39),
('Hilton Downtown', 8, '2019-07-16', 205, 39),
('Hilton Downtown', 8, '2019-07-17', 375, 39),
('Hilton Downtown', 8, '2019-07-18', 332, 39),
('Hilton Downtown', 8, '2019-07-19', 285, NULL),
('Hilton Downtown', 8, '2019-07-20', 155, NULL),
('Hilton Downtown', 8, '2019-07-21', 110, NULL),
('Hilton Downtown', 8, '2019-07-22', 331, NULL),
('Hilton Downtown', 8, '2019-07-23', 392, NULL),
('Hilton Downtown', 8, '2019-07-24', 345, NULL),
('Hilton Downtown', 8, '2019-07-25', 197, NULL),
('Hilton Downtown', 8, '2019-07-26', 277, NULL),
('Hilton Downtown', 8, '2019-07-27', 397, NULL),
('Hilton Downtown', 8, '2019-07-28', 113, NULL),
('Hilton Downtown', 8, '2019-07-29', 159, NULL),
('Hilton Downtown', 8, '2019-07-30', 341, NULL),
('Hilton Downtown', 8, '2019-07-31', 267, NULL),
('Hilton Downtown', 8, '2019-08-01', 366, NULL),
('Hilton Downtown', 8, '2019-08-02', 154, NULL),
('Hilton Downtown', 8, '2019-08-03', 203, NULL),
('Hilton Downtown', 8, '2019-08-04', 319, NULL),
('Hilton Downtown', 8, '2019-08-05', 260, NULL),
('Hilton Downtown', 8, '2019-08-06', 193, NULL),
('Hilton Downtown', 8, '2019-08-07', 110, NULL),
('Hilton Downtown', 8, '2019-08-08', 163, NULL),
('Hilton Downtown', 8, '2019-08-09', 131, NULL),
('Hilton Downtown', 8, '2019-08-10', 126, NULL),
('Hilton Downtown', 8, '2019-08-11', 127, NULL),
('Hilton Downtown', 8, '2019-08-12', 305, NULL),
('Hilton Downtown', 8, '2019-08-13', 258, NULL),
('Hilton Downtown', 8, '2019-08-14', 253, NULL),
('Hilton Downtown', 8, '2019-08-15', 335, NULL),
('Hilton Downtown', 8, '2019-08-16', 117, NULL),
('Hilton Downtown', 8, '2019-08-17', 343, NULL),
('Hilton Downtown', 8, '2019-08-18', 342, NULL),
('Hilton Downtown', 8, '2019-08-19', 379, NULL),
('Hilton Downtown', 8, '2019-08-20', 120, NULL),
('Hilton Downtown', 8, '2019-08-21', 241, NULL),
('Hilton Downtown', 8, '2019-08-22', 176, NULL),
('Hilton Downtown', 8, '2019-08-23', 242, NULL),
('Hilton Downtown', 8, '2019-08-24', 319, NULL),
('Hilton Downtown', 8, '2019-08-25', 348, NULL),
('Hilton Downtown', 8, '2019-08-26', 123, NULL),
('Hilton Downtown', 8, '2019-08-27', 105, NULL),
('Hilton Downtown', 8, '2019-08-28', 238, NULL),
('Hilton Downtown', 8, '2019-08-29', 303, NULL),
('Hilton Downtown', 8, '2019-08-30', 184, NULL),
('Hilton Downtown', 8, '2019-08-31', 267, NULL),
('Hilton Downtown', 8, '2019-09-01', 282, NULL),
('Hilton Downtown', 8, '2019-09-02', 221, NULL),
('Hilton Downtown', 8, '2019-09-03', 339, NULL),
('Hilton Downtown', 8, '2019-09-04', 261, 22),
('Hilton Downtown', 8, '2019-09-05', 293, 22),
('Hilton Downtown', 8, '2019-09-06', 334, 22),
('Hilton Downtown', 8, '2019-09-07', 338, 22),
('Hilton Downtown', 8, '2019-09-08', 196, 22),
('Hilton Downtown', 8, '2019-09-09', 114, NULL),
('Hilton Downtown', 8, '2019-09-10', 384, NULL),
('Hilton Downtown', 8, '2019-09-11', 375, NULL),
('Hilton Downtown', 8, '2019-09-12', 259, NULL),
('Hilton Downtown', 8, '2019-09-13', 350, NULL),
('Hilton Downtown', 8, '2019-09-14', 251, NULL),
('Hilton Downtown', 8, '2019-09-15', 200, NULL),
('Hilton Downtown', 8, '2019-09-16', 289, NULL),
('Hilton Downtown', 8, '2019-09-17', 125, NULL),
('Hilton Downtown', 8, '2019-09-18', 308, NULL),
('Hilton Downtown', 8, '2019-09-19', 291, NULL),
('Hilton Downtown', 8, '2019-09-20', 222, NULL),
('Hilton Downtown', 8, '2019-09-21', 273, NULL),
('Hilton Downtown', 8, '2019-09-22', 262, NULL),
('Hilton Downtown', 8, '2019-09-23', 113, NULL),
('Hilton Downtown', 8, '2019-09-24', 288, NULL),
('Hilton Downtown', 8, '2019-09-25', 299, NULL),
('Hilton Downtown', 8, '2019-09-26', 342, NULL),
('Hilton Downtown', 8, '2019-09-27', 244, NULL),
('Hilton Downtown', 8, '2019-09-28', 109, NULL),
('Hilton Downtown', 8, '2019-09-29', 382, NULL),
('Hilton Downtown', 8, '2019-09-30', 228, NULL),
('Hilton Downtown', 8, '2019-10-01', 223, NULL),
('Hilton Downtown', 8, '2019-10-02', 391, NULL),
('Hilton Downtown', 8, '2019-10-03', 125, NULL),
('Hilton Downtown', 8, '2019-10-04', 347, NULL),
('Hilton Downtown', 8, '2019-10-05', 101, NULL),
('Hilton Downtown', 8, '2019-10-06', 280, NULL),
('Hilton Downtown', 8, '2019-10-07', 243, NULL),
('Hilton Downtown', 8, '2019-10-08', 292, NULL),
('Hilton Downtown', 8, '2019-10-09', 171, NULL),
('Hilton Downtown', 8, '2019-10-10', 141, NULL),
('Hilton Downtown', 8, '2019-10-11', 384, NULL),
('Hilton Downtown', 8, '2019-10-12', 137, NULL),
('Hilton Downtown', 8, '2019-10-13', 252, NULL),
('Hilton Downtown', 8, '2019-10-14', 303, NULL),
('Hilton Downtown', 8, '2019-10-15', 256, NULL),
('Hilton Downtown', 8, '2019-10-16', 105, NULL),
('Hilton Downtown', 8, '2019-10-17', 113, NULL),
('Hilton Downtown', 8, '2019-10-18', 352, 105),
('Hilton Downtown', 8, '2019-10-19', 291, 105),
('Hilton Downtown', 8, '2019-10-20', 142, 105),
('Hilton Downtown', 8, '2019-10-21', 304, 105),
('Hilton Downtown', 8, '2019-10-22', 332, 105),
('Hilton Downtown', 8, '2019-10-23', 301, 105),
('Hilton Downtown', 8, '2019-10-24', 327, 105),
('Hilton Downtown', 8, '2019-10-25', 363, 105),
('Hilton Downtown', 8, '2019-10-26', 151, 105),
('Hilton Downtown', 8, '2019-10-27', 286, 105),
('Hilton Downtown', 8, '2019-10-28', 307, 105),
('Hilton Downtown', 8, '2019-10-29', 377, 105),
('Hilton Downtown', 8, '2019-10-30', 336, 105),
('Hilton Downtown', 8, '2019-10-31', 177, 105),
('Hilton Downtown', 8, '2019-11-01', 348, 105),
('Hilton Downtown', 8, '2019-11-02', 349, 105),
('Hilton Downtown', 8, '2019-11-03', 344, 105),
('Hilton Downtown', 8, '2019-11-04', 206, 105),
('Hilton Downtown', 8, '2019-11-05', 223, 105),
('Hilton Downtown', 8, '2019-11-06', 209, 105),
('Hilton Downtown', 8, '2019-11-07', 365, 105),
('Hilton Downtown', 8, '2019-11-08', 288, 105),
('Hilton Downtown', 8, '2019-11-09', 183, 105),
('Hilton Downtown', 8, '2019-11-10', 235, NULL),
('Hilton Downtown', 8, '2019-11-11', 273, NULL),
('Hilton Downtown', 8, '2019-11-12', 379, NULL),
('Hilton Downtown', 8, '2019-11-13', 368, NULL),
('Hilton Downtown', 8, '2019-11-14', 251, NULL),
('Hilton Downtown', 8, '2019-11-15', 253, NULL),
('Hilton Downtown', 8, '2019-11-16', 144, NULL),
('Hilton Downtown', 8, '2019-11-17', 146, NULL),
('Hilton Downtown', 8, '2019-11-18', 385, NULL),
('Hilton Downtown', 8, '2019-11-19', 294, NULL),
('Hilton Downtown', 8, '2019-11-20', 292, NULL),
('Hilton Downtown', 8, '2019-11-21', 367, NULL),
('Hilton Downtown', 8, '2019-11-22', 362, NULL),
('Hilton Downtown', 8, '2019-11-23', 180, NULL),
('Hilton Downtown', 8, '2019-11-24', 298, NULL),
('Hilton Downtown', 8, '2019-11-25', 237, NULL),
('Hilton Downtown', 8, '2019-11-26', 308, NULL),
('Hilton Downtown', 8, '2019-11-27', 288, NULL),
('Hilton Downtown', 8, '2019-11-28', 354, NULL),
('Hilton Downtown', 8, '2019-11-29', 124, 148),
('Hilton Downtown', 8, '2019-11-30', 376, 148),
('Hilton Downtown', 8, '2019-12-01', 240, 148),
('Hilton Downtown', 8, '2019-12-02', 193, 148),
('Hilton Downtown', 8, '2019-12-03', 309, 148),
('Hilton Downtown', 8, '2019-12-04', 201, 148),
('Hilton Downtown', 8, '2019-12-05', 338, 148),
('Hilton Downtown', 8, '2019-12-06', 389, 148),
('Hilton Downtown', 8, '2019-12-07', 128, 148),
('Hilton Downtown', 8, '2019-12-08', 260, 148),
('Hilton Downtown', 8, '2019-12-09', 271, 148),
('Hilton Downtown', 8, '2019-12-10', 190, 148),
('Hilton Downtown', 8, '2019-12-11', 373, 148),
('Hilton Downtown', 8, '2019-12-12', 347, 148),
('Hilton Downtown', 8, '2019-12-13', 107, 148),
('Hilton Downtown', 8, '2019-12-14', 217, 148),
('Hilton Downtown', 8, '2019-12-15', 258, 148),
('Hilton Downtown', 8, '2019-12-16', 391, 148),
('Hilton Downtown', 8, '2019-12-17', 352, 148),
('Hilton Downtown', 8, '2019-12-18', 362, 148),
('Hilton Downtown', 8, '2019-12-19', 300, 148),
('Hilton Downtown', 8, '2019-12-20', 350, 148),
('Hilton Downtown', 8, '2019-12-21', 170, 148),
('Hilton Downtown', 8, '2019-12-22', 132, 148),
('Hilton Downtown', 8, '2019-12-23', 198, 148),
('Hilton Downtown', 8, '2019-12-24', 385, 148),
('Hilton Downtown', 8, '2019-12-25', 141, 148),
('Hilton Downtown', 8, '2019-12-26', 147, 148),
('Hilton Downtown', 8, '2019-12-27', 204, 148),
('Hilton Downtown', 8, '2019-12-28', 115, 148),
('Hilton Downtown', 8, '2019-12-29', 374, NULL),
('Hilton Downtown', 8, '2019-12-30', 180, NULL),
('Hilton Downtown', 8, '2019-12-31', 144, NULL),
('Hilton Downtown', 8, '2020-01-01', 201, NULL),
('Hilton Downtown', 8, '2020-01-02', 262, NULL),
('Hilton Downtown', 8, '2020-01-03', 166, NULL),
('Hilton Downtown', 8, '2020-01-04', 371, NULL),
('Hilton Downtown', 8, '2020-01-05', 181, NULL),
('Hilton Downtown', 8, '2020-01-06', 365, NULL),
('Hilton Downtown', 8, '2020-01-07', 317, NULL),
('Hilton Downtown', 8, '2020-01-08', 384, NULL),
('Hilton Downtown', 8, '2020-01-09', 237, NULL),
('Hilton Downtown', 8, '2020-01-10', 192, NULL),
('Hilton Downtown', 8, '2020-01-11', 187, 33),
('Hilton Downtown', 8, '2020-01-12', 287, 33),
('Hilton Downtown', 8, '2020-01-13', 385, 33),
('Hilton Downtown', 8, '2020-01-14', 213, 33),
('Hilton Downtown', 8, '2020-01-15', 190, 33),
('Hilton Downtown', 8, '2020-01-16', 137, 33),
('Hilton Downtown', 8, '2020-01-17', 332, 33),
('Hilton Downtown', 8, '2020-01-18', 123, 33),
('Hilton Downtown', 8, '2020-01-19', 369, 33),
('Hilton Downtown', 8, '2020-01-20', 272, 33),
('Hilton Downtown', 8, '2020-01-21', 202, 33),
('Hilton Downtown', 8, '2020-01-22', 266, 33),
('Hilton Downtown', 8, '2020-01-23', 386, 33),
('Hilton Downtown', 8, '2020-01-24', 352, 33),
('Hilton Downtown', 8, '2020-01-25', 224, 33),
('Hilton Downtown', 8, '2020-01-26', 331, 33),
('Hilton Downtown', 8, '2020-01-27', 335, NULL),
('Hilton Downtown', 8, '2020-01-28', 349, NULL),
('Hilton Downtown', 8, '2020-01-29', 137, NULL),
('Hilton Downtown', 8, '2020-01-30', 305, NULL),
('Hilton Downtown', 8, '2020-01-31', 218, NULL),
('Hilton Downtown', 8, '2020-02-01', 124, NULL),
('Hilton Downtown', 8, '2020-02-02', 137, NULL),
('Hilton Downtown', 8, '2020-02-03', 270, NULL),
('Hilton Downtown', 8, '2020-02-04', 148, NULL),
('Hilton Downtown', 10, '2019-01-01', 298, NULL),
('Hilton Downtown', 10, '2019-01-02', 125, NULL),
('Hilton Downtown', 10, '2019-01-03', 290, NULL),
('Hilton Downtown', 10, '2019-01-04', 175, NULL),
('Hilton Downtown', 10, '2019-01-05', 329, NULL),
('Hilton Downtown', 10, '2019-01-06', 127, NULL),
('Hilton Downtown', 10, '2019-01-07', 344, NULL),
('Hilton Downtown', 10, '2019-01-08', 211, NULL),
('Hilton Downtown', 10, '2019-01-09', 280, NULL),
('Hilton Downtown', 10, '2019-01-10', 179, NULL),
('Hilton Downtown', 10, '2019-01-11', 113, NULL),
('Hilton Downtown', 10, '2019-01-12', 233, NULL),
('Hilton Downtown', 10, '2019-01-13', 243, NULL),
('Hilton Downtown', 10, '2019-01-14', 266, NULL),
('Hilton Downtown', 10, '2019-01-15', 151, NULL),
('Hilton Downtown', 10, '2019-01-16', 255, NULL),
('Hilton Downtown', 10, '2019-01-17', 348, NULL),
('Hilton Downtown', 10, '2019-01-18', 282, NULL),
('Hilton Downtown', 10, '2019-01-19', 281, NULL),
('Hilton Downtown', 10, '2019-01-20', 300, NULL),
('Hilton Downtown', 10, '2019-01-21', 280, NULL),
('Hilton Downtown', 10, '2019-01-22', 114, NULL),
('Hilton Downtown', 10, '2019-01-23', 240, NULL),
('Hilton Downtown', 10, '2019-01-24', 144, NULL),
('Hilton Downtown', 10, '2019-01-25', 191, NULL),
('Hilton Downtown', 10, '2019-01-26', 339, NULL),
('Hilton Downtown', 10, '2019-01-27', 176, NULL),
('Hilton Downtown', 10, '2019-01-28', 134, NULL),
('Hilton Downtown', 10, '2019-01-29', 109, NULL),
('Hilton Downtown', 10, '2019-01-30', 333, NULL),
('Hilton Downtown', 10, '2019-01-31', 151, NULL),
('Hilton Downtown', 10, '2019-02-01', 165, NULL),
('Hilton Downtown', 10, '2019-02-02', 211, NULL),
('Hilton Downtown', 10, '2019-02-03', 176, NULL),
('Hilton Downtown', 10, '2019-02-04', 258, NULL),
('Hilton Downtown', 10, '2019-02-05', 224, NULL),
('Hilton Downtown', 10, '2019-02-06', 244, 195),
('Hilton Downtown', 10, '2019-02-07', 205, 195),
('Hilton Downtown', 10, '2019-02-08', 377, 195),
('Hilton Downtown', 10, '2019-02-09', 282, 195),
('Hilton Downtown', 10, '2019-02-10', 324, 195),
('Hilton Downtown', 10, '2019-02-11', 272, 195),
('Hilton Downtown', 10, '2019-02-12', 220, 195),
('Hilton Downtown', 10, '2019-02-13', 116, NULL),
('Hilton Downtown', 10, '2019-02-14', 210, NULL),
('Hilton Downtown', 10, '2019-02-15', 247, NULL),
('Hilton Downtown', 10, '2019-02-16', 259, NULL),
('Hilton Downtown', 10, '2019-02-17', 386, NULL),
('Hilton Downtown', 10, '2019-02-18', 389, NULL),
('Hilton Downtown', 10, '2019-02-19', 284, NULL),
('Hilton Downtown', 10, '2019-02-20', 290, NULL),
('Hilton Downtown', 10, '2019-02-21', 240, NULL),
('Hilton Downtown', 10, '2019-02-22', 117, NULL),
('Hilton Downtown', 10, '2019-02-23', 374, NULL),
('Hilton Downtown', 10, '2019-02-24', 262, NULL),
('Hilton Downtown', 10, '2019-02-25', 354, NULL),
('Hilton Downtown', 10, '2019-02-26', 268, NULL),
('Hilton Downtown', 10, '2019-02-27', 336, NULL),
('Hilton Downtown', 10, '2019-02-28', 351, NULL),
('Hilton Downtown', 10, '2019-03-01', 100, NULL),
('Hilton Downtown', 10, '2019-03-02', 281, NULL),
('Hilton Downtown', 10, '2019-03-03', 315, NULL),
('Hilton Downtown', 10, '2019-03-04', 185, NULL),
('Hilton Downtown', 10, '2019-03-05', 247, NULL),
('Hilton Downtown', 10, '2019-03-06', 169, NULL),
('Hilton Downtown', 10, '2019-03-07', 157, NULL),
('Hilton Downtown', 10, '2019-03-08', 224, NULL),
('Hilton Downtown', 10, '2019-03-09', 238, NULL),
('Hilton Downtown', 10, '2019-03-10', 130, NULL),
('Hilton Downtown', 10, '2019-03-11', 194, NULL),
('Hilton Downtown', 10, '2019-03-12', 325, NULL),
('Hilton Downtown', 10, '2019-03-13', 339, NULL),
('Hilton Downtown', 10, '2019-03-14', 184, NULL),
('Hilton Downtown', 10, '2019-03-15', 142, NULL),
('Hilton Downtown', 10, '2019-03-16', 355, NULL),
('Hilton Downtown', 10, '2019-03-17', 359, NULL),
('Hilton Downtown', 10, '2019-03-18', 136, NULL),
('Hilton Downtown', 10, '2019-03-19', 215, NULL),
('Hilton Downtown', 10, '2019-03-20', 264, NULL),
('Hilton Downtown', 10, '2019-03-21', 395, NULL),
('Hilton Downtown', 10, '2019-03-22', 371, NULL),
('Hilton Downtown', 10, '2019-03-23', 279, NULL),
('Hilton Downtown', 10, '2019-03-24', 239, NULL),
('Hilton Downtown', 10, '2019-03-25', 173, NULL),
('Hilton Downtown', 10, '2019-03-26', 116, NULL),
('Hilton Downtown', 10, '2019-03-27', 126, NULL),
('Hilton Downtown', 10, '2019-03-28', 386, NULL),
('Hilton Downtown', 10, '2019-03-29', 176, NULL),
('Hilton Downtown', 10, '2019-03-30', 263, NULL),
('Hilton Downtown', 10, '2019-03-31', 264, NULL),
('Hilton Downtown', 10, '2019-04-01', 383, NULL),
('Hilton Downtown', 10, '2019-04-02', 384, NULL),
('Hilton Downtown', 10, '2019-04-03', 385, NULL),
('Hilton Downtown', 10, '2019-04-04', 193, NULL),
('Hilton Downtown', 10, '2019-04-05', 281, NULL),
('Hilton Downtown', 10, '2019-04-06', 183, NULL),
('Hilton Downtown', 10, '2019-04-07', 217, 80),
('Hilton Downtown', 10, '2019-04-08', 286, 80),
('Hilton Downtown', 10, '2019-04-09', 205, 80),
('Hilton Downtown', 10, '2019-04-10', 107, 80),
('Hilton Downtown', 10, '2019-04-11', 155, 80),
('Hilton Downtown', 10, '2019-04-12', 218, 80),
('Hilton Downtown', 10, '2019-04-13', 308, 80),
('Hilton Downtown', 10, '2019-04-14', 188, 80),
('Hilton Downtown', 10, '2019-04-15', 295, 80),
('Hilton Downtown', 10, '2019-04-16', 310, 80),
('Hilton Downtown', 10, '2019-04-17', 221, 80),
('Hilton Downtown', 10, '2019-04-18', 266, 80),
('Hilton Downtown', 10, '2019-04-19', 304, 80),
('Hilton Downtown', 10, '2019-04-20', 377, 80),
('Hilton Downtown', 10, '2019-04-21', 149, 80),
('Hilton Downtown', 10, '2019-04-22', 120, 80),
('Hilton Downtown', 10, '2019-04-23', 322, 80),
('Hilton Downtown', 10, '2019-04-24', 231, 80),
('Hilton Downtown', 10, '2019-04-25', 183, 80),
('Hilton Downtown', 10, '2019-04-26', 337, 80),
('Hilton Downtown', 10, '2019-04-27', 112, 80),
('Hilton Downtown', 10, '2019-04-28', 365, 80),
('Hilton Downtown', 10, '2019-04-29', 122, 80),
('Hilton Downtown', 10, '2019-04-30', 218, 80),
('Hilton Downtown', 10, '2019-05-01', 149, NULL),
('Hilton Downtown', 10, '2019-05-02', 176, NULL),
('Hilton Downtown', 10, '2019-05-03', 370, NULL),
('Hilton Downtown', 10, '2019-05-04', 226, NULL),
('Hilton Downtown', 10, '2019-05-05', 366, NULL),
('Hilton Downtown', 10, '2019-05-06', 344, NULL),
('Hilton Downtown', 10, '2019-05-07', 302, NULL),
('Hilton Downtown', 10, '2019-05-08', 269, NULL),
('Hilton Downtown', 10, '2019-05-09', 156, NULL),
('Hilton Downtown', 10, '2019-05-10', 263, NULL),
('Hilton Downtown', 10, '2019-05-11', 100, NULL),
('Hilton Downtown', 10, '2019-05-12', 194, NULL),
('Hilton Downtown', 10, '2019-05-13', 174, NULL),
('Hilton Downtown', 10, '2019-05-14', 119, NULL),
('Hilton Downtown', 10, '2019-05-15', 121, NULL),
('Hilton Downtown', 10, '2019-05-16', 119, NULL),
('Hilton Downtown', 10, '2019-05-17', 109, NULL),
('Hilton Downtown', 10, '2019-05-18', 271, NULL),
('Hilton Downtown', 10, '2019-05-19', 163, NULL),
('Hilton Downtown', 10, '2019-05-20', 163, NULL),
('Hilton Downtown', 10, '2019-05-21', 294, NULL),
('Hilton Downtown', 10, '2019-05-22', 295, NULL),
('Hilton Downtown', 10, '2019-05-23', 384, NULL),
('Hilton Downtown', 10, '2019-05-24', 237, NULL),
('Hilton Downtown', 10, '2019-05-25', 251, NULL),
('Hilton Downtown', 10, '2019-05-26', 153, NULL),
('Hilton Downtown', 10, '2019-05-27', 371, NULL),
('Hilton Downtown', 10, '2019-05-28', 280, NULL),
('Hilton Downtown', 10, '2019-05-29', 206, NULL),
('Hilton Downtown', 10, '2019-05-30', 305, NULL),
('Hilton Downtown', 10, '2019-05-31', 286, NULL),
('Hilton Downtown', 10, '2019-06-01', 368, NULL),
('Hilton Downtown', 10, '2019-06-02', 250, NULL),
('Hilton Downtown', 10, '2019-06-03', 142, NULL),
('Hilton Downtown', 10, '2019-06-04', 193, NULL),
('Hilton Downtown', 10, '2019-06-05', 130, NULL),
('Hilton Downtown', 10, '2019-06-06', 366, NULL),
('Hilton Downtown', 10, '2019-06-07', 213, NULL),
('Hilton Downtown', 10, '2019-06-08', 373, NULL),
('Hilton Downtown', 10, '2019-06-09', 374, NULL),
('Hilton Downtown', 10, '2019-06-10', 284, NULL),
('Hilton Downtown', 10, '2019-06-11', 332, NULL),
('Hilton Downtown', 10, '2019-06-12', 107, NULL),
('Hilton Downtown', 10, '2019-06-13', 371, NULL),
('Hilton Downtown', 10, '2019-06-14', 208, NULL),
('Hilton Downtown', 10, '2019-06-15', 270, NULL),
('Hilton Downtown', 10, '2019-06-16', 254, NULL),
('Hilton Downtown', 10, '2019-06-17', 328, NULL),
('Hilton Downtown', 10, '2019-06-18', 166, 196),
('Hilton Downtown', 10, '2019-06-19', 277, 196),
('Hilton Downtown', 10, '2019-06-20', 322, 196),
('Hilton Downtown', 10, '2019-06-21', 227, 196),
('Hilton Downtown', 10, '2019-06-22', 373, 196),
('Hilton Downtown', 10, '2019-06-23', 189, 196),
('Hilton Downtown', 10, '2019-06-24', 161, 196),
('Hilton Downtown', 10, '2019-06-25', 320, 196),
('Hilton Downtown', 10, '2019-06-26', 336, 196),
('Hilton Downtown', 10, '2019-06-27', 346, 196),
('Hilton Downtown', 10, '2019-06-28', 311, 196),
('Hilton Downtown', 10, '2019-06-29', 364, 196),
('Hilton Downtown', 10, '2019-06-30', 197, 196),
('Hilton Downtown', 10, '2019-07-01', 252, 196),
('Hilton Downtown', 10, '2019-07-02', 324, 196),
('Hilton Downtown', 10, '2019-07-03', 286, 196),
('Hilton Downtown', 10, '2019-07-04', 382, 196),
('Hilton Downtown', 10, '2019-07-05', 124, 196),
('Hilton Downtown', 10, '2019-07-06', 341, 196),
('Hilton Downtown', 10, '2019-07-07', 190, 196),
('Hilton Downtown', 10, '2019-07-08', 221, 196),
('Hilton Downtown', 10, '2019-07-09', 139, 196),
('Hilton Downtown', 10, '2019-07-10', 118, NULL),
('Hilton Downtown', 10, '2019-07-11', 291, 46),
('Hilton Downtown', 10, '2019-07-12', 131, 46),
('Hilton Downtown', 10, '2019-07-13', 141, 46),
('Hilton Downtown', 10, '2019-07-14', 387, 46),
('Hilton Downtown', 10, '2019-07-15', 130, 46),
('Hilton Downtown', 10, '2019-07-16', 117, 46),
('Hilton Downtown', 10, '2019-07-17', 156, 46),
('Hilton Downtown', 10, '2019-07-18', 300, 46),
('Hilton Downtown', 10, '2019-07-19', 125, 46),
('Hilton Downtown', 10, '2019-07-20', 149, 46),
('Hilton Downtown', 10, '2019-07-21', 259, 46),
('Hilton Downtown', 10, '2019-07-22', 238, 46),
('Hilton Downtown', 10, '2019-07-23', 282, 46),
('Hilton Downtown', 10, '2019-07-24', 242, 46),
('Hilton Downtown', 10, '2019-07-25', 386, 46),
('Hilton Downtown', 10, '2019-07-26', 150, 46),
('Hilton Downtown', 10, '2019-07-27', 334, 46),
('Hilton Downtown', 10, '2019-07-28', 156, 46),
('Hilton Downtown', 10, '2019-07-29', 275, 46),
('Hilton Downtown', 10, '2019-07-30', 126, 46),
('Hilton Downtown', 10, '2019-07-31', 216, 46),
('Hilton Downtown', 10, '2019-08-01', 304, 46),
('Hilton Downtown', 10, '2019-08-02', 304, NULL),
('Hilton Downtown', 10, '2019-08-03', 387, NULL),
('Hilton Downtown', 10, '2019-08-04', 276, NULL),
('Hilton Downtown', 10, '2019-08-05', 215, NULL),
('Hilton Downtown', 10, '2019-08-06', 103, NULL),
('Hilton Downtown', 10, '2019-08-07', 123, NULL),
('Hilton Downtown', 10, '2019-08-08', 100, NULL),
('Hilton Downtown', 10, '2019-08-09', 125, NULL),
('Hilton Downtown', 10, '2019-08-10', 303, NULL),
('Hilton Downtown', 10, '2019-08-11', 188, NULL),
('Hilton Downtown', 10, '2019-08-12', 220, NULL),
('Hilton Downtown', 10, '2019-08-13', 120, NULL),
('Hilton Downtown', 10, '2019-08-14', 328, NULL),
('Hilton Downtown', 10, '2019-08-15', 105, NULL),
('Hilton Downtown', 10, '2019-08-16', 129, NULL),
('Hilton Downtown', 10, '2019-08-17', 381, NULL),
('Hilton Downtown', 10, '2019-08-18', 348, NULL),
('Hilton Downtown', 10, '2019-08-19', 106, NULL),
('Hilton Downtown', 10, '2019-08-20', 358, NULL),
('Hilton Downtown', 10, '2019-08-21', 385, NULL),
('Hilton Downtown', 10, '2019-08-22', 382, NULL),
('Hilton Downtown', 10, '2019-08-23', 251, NULL),
('Hilton Downtown', 10, '2019-08-24', 343, NULL),
('Hilton Downtown', 10, '2019-08-25', 272, NULL),
('Hilton Downtown', 10, '2019-08-26', 203, NULL),
('Hilton Downtown', 10, '2019-08-27', 371, NULL),
('Hilton Downtown', 10, '2019-08-28', 369, NULL),
('Hilton Downtown', 10, '2019-08-29', 212, NULL),
('Hilton Downtown', 10, '2019-08-30', 372, NULL),
('Hilton Downtown', 10, '2019-08-31', 116, NULL),
('Hilton Downtown', 10, '2019-09-01', 134, NULL),
('Hilton Downtown', 10, '2019-09-02', 287, NULL),
('Hilton Downtown', 10, '2019-09-03', 262, NULL),
('Hilton Downtown', 10, '2019-09-04', 355, NULL),
('Hilton Downtown', 10, '2019-09-05', 222, NULL),
('Hilton Downtown', 10, '2019-09-06', 228, NULL),
('Hilton Downtown', 10, '2019-09-07', 352, NULL),
('Hilton Downtown', 10, '2019-09-08', 367, NULL),
('Hilton Downtown', 10, '2019-09-09', 303, NULL),
('Hilton Downtown', 10, '2019-09-10', 354, NULL),
('Hilton Downtown', 10, '2019-09-11', 301, NULL),
('Hilton Downtown', 10, '2019-09-12', 271, NULL),
('Hilton Downtown', 10, '2019-09-13', 123, NULL),
('Hilton Downtown', 10, '2019-09-14', 382, NULL),
('Hilton Downtown', 10, '2019-09-15', 367, NULL),
('Hilton Downtown', 10, '2019-09-16', 214, NULL),
('Hilton Downtown', 10, '2019-09-17', 353, NULL),
('Hilton Downtown', 10, '2019-09-18', 271, NULL),
('Hilton Downtown', 10, '2019-09-19', 183, NULL),
('Hilton Downtown', 10, '2019-09-20', 350, NULL),
('Hilton Downtown', 10, '2019-09-21', 338, NULL),
('Hilton Downtown', 10, '2019-09-22', 338, NULL),
('Hilton Downtown', 10, '2019-09-23', 165, NULL),
('Hilton Downtown', 10, '2019-09-24', 391, NULL),
('Hilton Downtown', 10, '2019-09-25', 175, NULL),
('Hilton Downtown', 10, '2019-09-26', 198, NULL),
('Hilton Downtown', 10, '2019-09-27', 363, NULL),
('Hilton Downtown', 10, '2019-09-28', 202, NULL),
('Hilton Downtown', 10, '2019-09-29', 338, NULL),
('Hilton Downtown', 10, '2019-09-30', 199, NULL),
('Hilton Downtown', 10, '2019-10-01', 313, NULL),
('Hilton Downtown', 10, '2019-10-02', 105, NULL),
('Hilton Downtown', 10, '2019-10-03', 197, NULL),
('Hilton Downtown', 10, '2019-10-04', 260, NULL),
('Hilton Downtown', 10, '2019-10-05', 202, NULL),
('Hilton Downtown', 10, '2019-10-06', 198, NULL),
('Hilton Downtown', 10, '2019-10-07', 101, NULL),
('Hilton Downtown', 10, '2019-10-08', 309, NULL),
('Hilton Downtown', 10, '2019-10-09', 390, NULL),
('Hilton Downtown', 10, '2019-10-10', 110, NULL),
('Hilton Downtown', 10, '2019-10-11', 183, NULL),
('Hilton Downtown', 10, '2019-10-12', 349, NULL),
('Hilton Downtown', 10, '2019-10-13', 143, NULL),
('Hilton Downtown', 10, '2019-10-14', 266, NULL),
('Hilton Downtown', 10, '2019-10-15', 340, NULL),
('Hilton Downtown', 10, '2019-10-16', 391, 168),
('Hilton Downtown', 10, '2019-10-17', 276, 168),
('Hilton Downtown', 10, '2019-10-18', 310, 168),
('Hilton Downtown', 10, '2019-10-19', 398, 168),
('Hilton Downtown', 10, '2019-10-20', 124, 168),
('Hilton Downtown', 10, '2019-10-21', 327, 168),
('Hilton Downtown', 10, '2019-10-22', 268, 168),
('Hilton Downtown', 10, '2019-10-23', 184, 168),
('Hilton Downtown', 10, '2019-10-24', 202, 168),
('Hilton Downtown', 10, '2019-10-25', 342, 168),
('Hilton Downtown', 10, '2019-10-26', 220, 168),
('Hilton Downtown', 10, '2019-10-27', 375, 168),
('Hilton Downtown', 10, '2019-10-28', 194, 168),
('Hilton Downtown', 10, '2019-10-29', 350, 168),
('Hilton Downtown', 10, '2019-10-30', 279, 168),
('Hilton Downtown', 10, '2019-10-31', 347, 168),
('Hilton Downtown', 10, '2019-11-01', 323, 168),
('Hilton Downtown', 10, '2019-11-02', 224, 168),
('Hilton Downtown', 10, '2019-11-03', 384, 168),
('Hilton Downtown', 10, '2019-11-04', 110, 168),
('Hilton Downtown', 10, '2019-11-05', 186, 168),
('Hilton Downtown', 10, '2019-11-06', 323, 168),
('Hilton Downtown', 10, '2019-11-07', 378, 168),
('Hilton Downtown', 10, '2019-11-08', 389, 168),
('Hilton Downtown', 10, '2019-11-09', 372, 168),
('Hilton Downtown', 10, '2019-11-10', 214, 168),
('Hilton Downtown', 10, '2019-11-11', 285, 168),
('Hilton Downtown', 10, '2019-11-12', 180, 168),
('Hilton Downtown', 10, '2019-11-13', 225, 168),
('Hilton Downtown', 10, '2019-11-14', 100, NULL),
('Hilton Downtown', 10, '2019-11-15', 243, NULL),
('Hilton Downtown', 10, '2019-11-16', 368, NULL),
('Hilton Downtown', 10, '2019-11-17', 119, NULL),
('Hilton Downtown', 10, '2019-11-18', 372, NULL),
('Hilton Downtown', 10, '2019-11-19', 241, NULL),
('Hilton Downtown', 10, '2019-11-20', 167, NULL),
('Hilton Downtown', 10, '2019-11-21', 261, NULL),
('Hilton Downtown', 10, '2019-11-22', 374, NULL),
('Hilton Downtown', 10, '2019-11-23', 141, NULL),
('Hilton Downtown', 10, '2019-11-24', 187, NULL),
('Hilton Downtown', 10, '2019-11-25', 385, NULL),
('Hilton Downtown', 10, '2019-11-26', 391, NULL),
('Hilton Downtown', 10, '2019-11-27', 255, NULL),
('Hilton Downtown', 10, '2019-11-28', 374, NULL),
('Hilton Downtown', 10, '2019-11-29', 264, NULL),
('Hilton Downtown', 10, '2019-11-30', 348, NULL),
('Hilton Downtown', 10, '2019-12-01', 168, NULL),
('Hilton Downtown', 10, '2019-12-02', 174, NULL),
('Hilton Downtown', 10, '2019-12-03', 233, NULL),
('Hilton Downtown', 10, '2019-12-04', 262, NULL),
('Hilton Downtown', 10, '2019-12-05', 175, NULL),
('Hilton Downtown', 10, '2019-12-06', 136, NULL),
('Hilton Downtown', 10, '2019-12-07', 332, NULL),
('Hilton Downtown', 10, '2019-12-08', 208, NULL),
('Hilton Downtown', 10, '2019-12-09', 348, NULL),
('Hilton Downtown', 10, '2019-12-10', 129, NULL),
('Hilton Downtown', 10, '2019-12-11', 131, NULL),
('Hilton Downtown', 10, '2019-12-12', 164, NULL),
('Hilton Downtown', 10, '2019-12-13', 318, NULL),
('Hilton Downtown', 10, '2019-12-14', 105, NULL),
('Hilton Downtown', 10, '2019-12-15', 309, NULL),
('Hilton Downtown', 10, '2019-12-16', 198, NULL),
('Hilton Downtown', 10, '2019-12-17', 169, NULL),
('Hilton Downtown', 10, '2019-12-18', 229, NULL),
('Hilton Downtown', 10, '2019-12-19', 304, NULL),
('Hilton Downtown', 10, '2019-12-20', 212, NULL),
('Hilton Downtown', 10, '2019-12-21', 190, NULL),
('Hilton Downtown', 10, '2019-12-22', 278, NULL),
('Hilton Downtown', 10, '2019-12-23', 151, NULL),
('Hilton Downtown', 10, '2019-12-24', 137, NULL),
('Hilton Downtown', 10, '2019-12-25', 266, NULL),
('Hilton Downtown', 10, '2019-12-26', 138, NULL),
('Hilton Downtown', 10, '2019-12-27', 166, NULL),
('Hilton Downtown', 10, '2019-12-28', 333, NULL),
('Hilton Downtown', 10, '2019-12-29', 129, NULL),
('Hilton Downtown', 10, '2019-12-30', 196, NULL),
('Hilton Downtown', 10, '2019-12-31', 377, NULL),
('Hilton Downtown', 10, '2020-01-01', 200, NULL),
('Hilton Downtown', 10, '2020-01-02', 290, NULL),
('Hilton Downtown', 10, '2020-01-03', 175, NULL),
('Hilton Downtown', 10, '2020-01-04', 225, NULL),
('Hilton Downtown', 10, '2020-01-05', 259, NULL),
('Hilton Downtown', 10, '2020-01-06', 131, NULL),
('Hilton Downtown', 10, '2020-01-07', 326, NULL),
('Hilton Downtown', 10, '2020-01-08', 226, NULL),
('Hilton Downtown', 10, '2020-01-09', 369, NULL),
('Hilton Downtown', 10, '2020-01-10', 286, NULL),
('Hilton Downtown', 10, '2020-01-11', 286, NULL),
('Hilton Downtown', 10, '2020-01-12', 152, NULL),
('Hilton Downtown', 10, '2020-01-13', 358, NULL),
('Hilton Downtown', 10, '2020-01-14', 290, NULL),
('Hilton Downtown', 10, '2020-01-15', 365, NULL),
('Hilton Downtown', 10, '2020-01-16', 394, NULL),
('Hilton Downtown', 10, '2020-01-17', 250, 126),
('Hilton Downtown', 10, '2020-01-18', 262, 126),
('Hilton Downtown', 10, '2020-01-19', 273, 126),
('Hilton Downtown', 10, '2020-01-20', 285, 126),
('Hilton Downtown', 10, '2020-01-21', 174, 126),
('Hilton Downtown', 10, '2020-01-22', 166, 126),
('Hilton Downtown', 10, '2020-01-23', 162, 126),
('Hilton Downtown', 10, '2020-01-24', 305, NULL),
('Hilton Downtown', 10, '2020-01-25', 351, NULL),
('Hilton Downtown', 10, '2020-01-26', 115, NULL),
('Hilton Downtown', 10, '2020-01-27', 273, NULL),
('Hilton Downtown', 10, '2020-01-28', 176, NULL),
('Hilton Downtown', 10, '2020-01-29', 182, NULL),
('Hilton Downtown', 10, '2020-01-30', 370, NULL),
('Hilton Downtown', 10, '2020-01-31', 210, NULL),
('Hilton Downtown', 10, '2020-02-01', 169, NULL),
('Hilton Downtown', 10, '2020-02-02', 117, NULL),
('Hilton Downtown', 10, '2020-02-03', 338, NULL),
('Hilton Downtown', 10, '2020-02-04', 324, NULL),
('Hilton Downtown', 17, '2019-01-01', 335, NULL),
('Hilton Downtown', 17, '2019-01-02', 318, NULL),
('Hilton Downtown', 17, '2019-01-03', 383, NULL),
('Hilton Downtown', 17, '2019-01-04', 343, NULL),
('Hilton Downtown', 17, '2019-01-05', 358, NULL),
('Hilton Downtown', 17, '2019-01-06', 396, NULL),
('Hilton Downtown', 17, '2019-01-07', 399, NULL),
('Hilton Downtown', 17, '2019-01-08', 142, NULL),
('Hilton Downtown', 17, '2019-01-09', 305, NULL),
('Hilton Downtown', 17, '2019-01-10', 243, NULL),
('Hilton Downtown', 17, '2019-01-11', 256, NULL),
('Hilton Downtown', 17, '2019-01-12', 212, NULL),
('Hilton Downtown', 17, '2019-01-13', 334, NULL),
('Hilton Downtown', 17, '2019-01-14', 363, NULL),
('Hilton Downtown', 17, '2019-01-15', 302, NULL),
('Hilton Downtown', 17, '2019-01-16', 159, NULL),
('Hilton Downtown', 17, '2019-01-17', 246, NULL),
('Hilton Downtown', 17, '2019-01-18', 264, NULL),
('Hilton Downtown', 17, '2019-01-19', 226, NULL),
('Hilton Downtown', 17, '2019-01-20', 382, NULL),
('Hilton Downtown', 17, '2019-01-21', 115, NULL),
('Hilton Downtown', 17, '2019-01-22', 107, NULL),
('Hilton Downtown', 17, '2019-01-23', 223, NULL),
('Hilton Downtown', 17, '2019-01-24', 335, NULL),
('Hilton Downtown', 17, '2019-01-25', 149, NULL),
('Hilton Downtown', 17, '2019-01-26', 347, NULL),
('Hilton Downtown', 17, '2019-01-27', 397, NULL),
('Hilton Downtown', 17, '2019-01-28', 260, NULL),
('Hilton Downtown', 17, '2019-01-29', 247, NULL),
('Hilton Downtown', 17, '2019-01-30', 246, NULL),
('Hilton Downtown', 17, '2019-01-31', 314, NULL),
('Hilton Downtown', 17, '2019-02-01', 196, NULL),
('Hilton Downtown', 17, '2019-02-02', 125, NULL),
('Hilton Downtown', 17, '2019-02-03', 390, NULL),
('Hilton Downtown', 17, '2019-02-04', 131, NULL),
('Hilton Downtown', 17, '2019-02-05', 257, NULL),
('Hilton Downtown', 17, '2019-02-06', 194, NULL),
('Hilton Downtown', 17, '2019-02-07', 205, NULL),
('Hilton Downtown', 17, '2019-02-08', 285, NULL),
('Hilton Downtown', 17, '2019-02-09', 125, NULL),
('Hilton Downtown', 17, '2019-02-10', 253, NULL),
('Hilton Downtown', 17, '2019-02-11', 276, NULL),
('Hilton Downtown', 17, '2019-02-12', 256, NULL),
('Hilton Downtown', 17, '2019-02-13', 376, NULL),
('Hilton Downtown', 17, '2019-02-14', 120, NULL),
('Hilton Downtown', 17, '2019-02-15', 261, NULL),
('Hilton Downtown', 17, '2019-02-16', 192, NULL),
('Hilton Downtown', 17, '2019-02-17', 339, NULL),
('Hilton Downtown', 17, '2019-02-18', 123, NULL),
('Hilton Downtown', 17, '2019-02-19', 126, NULL),
('Hilton Downtown', 17, '2019-02-20', 197, NULL),
('Hilton Downtown', 17, '2019-02-21', 347, NULL),
('Hilton Downtown', 17, '2019-02-22', 178, NULL),
('Hilton Downtown', 17, '2019-02-23', 260, NULL),
('Hilton Downtown', 17, '2019-02-24', 216, NULL),
('Hilton Downtown', 17, '2019-02-25', 251, NULL),
('Hilton Downtown', 17, '2019-02-26', 279, NULL),
('Hilton Downtown', 17, '2019-02-27', 308, NULL),
('Hilton Downtown', 17, '2019-02-28', 324, NULL),
('Hilton Downtown', 17, '2019-03-01', 318, NULL),
('Hilton Downtown', 17, '2019-03-02', 394, NULL),
('Hilton Downtown', 17, '2019-03-03', 388, NULL),
('Hilton Downtown', 17, '2019-03-04', 122, NULL),
('Hilton Downtown', 17, '2019-03-05', 309, NULL),
('Hilton Downtown', 17, '2019-03-06', 287, NULL),
('Hilton Downtown', 17, '2019-03-07', 329, NULL),
('Hilton Downtown', 17, '2019-03-08', 370, NULL),
('Hilton Downtown', 17, '2019-03-09', 360, NULL),
('Hilton Downtown', 17, '2019-03-10', 213, NULL),
('Hilton Downtown', 17, '2019-03-11', 353, NULL),
('Hilton Downtown', 17, '2019-03-12', 102, NULL),
('Hilton Downtown', 17, '2019-03-13', 197, NULL),
('Hilton Downtown', 17, '2019-03-14', 336, NULL),
('Hilton Downtown', 17, '2019-03-15', 123, NULL),
('Hilton Downtown', 17, '2019-03-16', 120, NULL),
('Hilton Downtown', 17, '2019-03-17', 352, NULL),
('Hilton Downtown', 17, '2019-03-18', 206, NULL),
('Hilton Downtown', 17, '2019-03-19', 226, NULL),
('Hilton Downtown', 17, '2019-03-20', 291, NULL),
('Hilton Downtown', 17, '2019-03-21', 299, NULL),
('Hilton Downtown', 17, '2019-03-22', 200, NULL),
('Hilton Downtown', 17, '2019-03-23', 310, NULL),
('Hilton Downtown', 17, '2019-03-24', 228, NULL),
('Hilton Downtown', 17, '2019-03-25', 315, NULL),
('Hilton Downtown', 17, '2019-03-26', 385, NULL),
('Hilton Downtown', 17, '2019-03-27', 128, NULL),
('Hilton Downtown', 17, '2019-03-28', 192, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 17, '2019-03-29', 105, NULL),
('Hilton Downtown', 17, '2019-03-30', 153, NULL),
('Hilton Downtown', 17, '2019-03-31', 298, NULL),
('Hilton Downtown', 17, '2019-04-01', 377, NULL),
('Hilton Downtown', 17, '2019-04-02', 100, NULL),
('Hilton Downtown', 17, '2019-04-03', 184, NULL),
('Hilton Downtown', 17, '2019-04-04', 153, NULL),
('Hilton Downtown', 17, '2019-04-05', 172, NULL),
('Hilton Downtown', 17, '2019-04-06', 261, 185),
('Hilton Downtown', 17, '2019-04-07', 147, 185),
('Hilton Downtown', 17, '2019-04-08', 131, 185),
('Hilton Downtown', 17, '2019-04-09', 311, 185),
('Hilton Downtown', 17, '2019-04-10', 234, 185),
('Hilton Downtown', 17, '2019-04-11', 362, 185),
('Hilton Downtown', 17, '2019-04-12', 176, 185),
('Hilton Downtown', 17, '2019-04-13', 315, 185),
('Hilton Downtown', 17, '2019-04-14', 217, 185),
('Hilton Downtown', 17, '2019-04-15', 225, 185),
('Hilton Downtown', 17, '2019-04-16', 132, 185),
('Hilton Downtown', 17, '2019-04-17', 207, 185),
('Hilton Downtown', 17, '2019-04-18', 253, 185),
('Hilton Downtown', 17, '2019-04-19', 163, 185),
('Hilton Downtown', 17, '2019-04-20', 129, 185),
('Hilton Downtown', 17, '2019-04-21', 326, 185),
('Hilton Downtown', 17, '2019-04-22', 298, 185),
('Hilton Downtown', 17, '2019-04-23', 268, 185),
('Hilton Downtown', 17, '2019-04-24', 123, 185),
('Hilton Downtown', 17, '2019-04-25', 357, 185),
('Hilton Downtown', 17, '2019-04-26', 170, 185),
('Hilton Downtown', 17, '2019-04-27', 243, 185),
('Hilton Downtown', 17, '2019-04-28', 308, 185),
('Hilton Downtown', 17, '2019-04-29', 213, 185),
('Hilton Downtown', 17, '2019-04-30', 190, 185),
('Hilton Downtown', 17, '2019-05-01', 390, 185),
('Hilton Downtown', 17, '2019-05-02', 139, 185),
('Hilton Downtown', 17, '2019-05-03', 374, 185),
('Hilton Downtown', 17, '2019-05-04', 154, 185),
('Hilton Downtown', 17, '2019-05-05', 224, NULL),
('Hilton Downtown', 17, '2019-05-06', 341, NULL),
('Hilton Downtown', 17, '2019-05-07', 190, NULL),
('Hilton Downtown', 17, '2019-05-08', 357, NULL),
('Hilton Downtown', 17, '2019-05-09', 362, NULL),
('Hilton Downtown', 17, '2019-05-10', 170, NULL),
('Hilton Downtown', 17, '2019-05-11', 322, NULL),
('Hilton Downtown', 17, '2019-05-12', 367, NULL),
('Hilton Downtown', 17, '2019-05-13', 240, NULL),
('Hilton Downtown', 17, '2019-05-14', 105, NULL),
('Hilton Downtown', 17, '2019-05-15', 205, NULL),
('Hilton Downtown', 17, '2019-05-16', 189, NULL),
('Hilton Downtown', 17, '2019-05-17', 170, NULL),
('Hilton Downtown', 17, '2019-05-18', 190, NULL),
('Hilton Downtown', 17, '2019-05-19', 198, NULL),
('Hilton Downtown', 17, '2019-05-20', 164, NULL),
('Hilton Downtown', 17, '2019-05-21', 269, NULL),
('Hilton Downtown', 17, '2019-05-22', 206, NULL),
('Hilton Downtown', 17, '2019-05-23', 305, NULL),
('Hilton Downtown', 17, '2019-05-24', 247, NULL),
('Hilton Downtown', 17, '2019-05-25', 257, NULL),
('Hilton Downtown', 17, '2019-05-26', 284, NULL),
('Hilton Downtown', 17, '2019-05-27', 311, NULL),
('Hilton Downtown', 17, '2019-05-28', 289, NULL),
('Hilton Downtown', 17, '2019-05-29', 175, NULL),
('Hilton Downtown', 17, '2019-05-30', 296, NULL),
('Hilton Downtown', 17, '2019-05-31', 297, NULL),
('Hilton Downtown', 17, '2019-06-01', 309, NULL),
('Hilton Downtown', 17, '2019-06-02', 134, NULL),
('Hilton Downtown', 17, '2019-06-03', 292, NULL),
('Hilton Downtown', 17, '2019-06-04', 284, NULL),
('Hilton Downtown', 17, '2019-06-05', 216, NULL),
('Hilton Downtown', 17, '2019-06-06', 209, NULL),
('Hilton Downtown', 17, '2019-06-07', 189, NULL),
('Hilton Downtown', 17, '2019-06-08', 316, NULL),
('Hilton Downtown', 17, '2019-06-09', 263, NULL),
('Hilton Downtown', 17, '2019-06-10', 356, NULL),
('Hilton Downtown', 17, '2019-06-11', 228, NULL),
('Hilton Downtown', 17, '2019-06-12', 219, NULL),
('Hilton Downtown', 17, '2019-06-13', 178, NULL),
('Hilton Downtown', 17, '2019-06-14', 334, NULL),
('Hilton Downtown', 17, '2019-06-15', 290, NULL),
('Hilton Downtown', 17, '2019-06-16', 249, NULL),
('Hilton Downtown', 17, '2019-06-17', 174, NULL),
('Hilton Downtown', 17, '2019-06-18', 205, NULL),
('Hilton Downtown', 17, '2019-06-19', 189, NULL),
('Hilton Downtown', 17, '2019-06-20', 245, NULL),
('Hilton Downtown', 17, '2019-06-21', 371, NULL),
('Hilton Downtown', 17, '2019-06-22', 366, NULL),
('Hilton Downtown', 17, '2019-06-23', 349, NULL),
('Hilton Downtown', 17, '2019-06-24', 389, NULL),
('Hilton Downtown', 17, '2019-06-25', 318, 151),
('Hilton Downtown', 17, '2019-06-26', 241, 151),
('Hilton Downtown', 17, '2019-06-27', 226, 151),
('Hilton Downtown', 17, '2019-06-28', 343, 151),
('Hilton Downtown', 17, '2019-06-29', 373, 151),
('Hilton Downtown', 17, '2019-06-30', 324, 151),
('Hilton Downtown', 17, '2019-07-01', 375, 151),
('Hilton Downtown', 17, '2019-07-02', 301, 151),
('Hilton Downtown', 17, '2019-07-03', 368, 151),
('Hilton Downtown', 17, '2019-07-04', 375, 151),
('Hilton Downtown', 17, '2019-07-05', 306, 151),
('Hilton Downtown', 17, '2019-07-06', 138, 151),
('Hilton Downtown', 17, '2019-07-07', 304, 151),
('Hilton Downtown', 17, '2019-07-08', 209, 151),
('Hilton Downtown', 17, '2019-07-09', 323, 151),
('Hilton Downtown', 17, '2019-07-10', 249, 151),
('Hilton Downtown', 17, '2019-07-11', 377, 151),
('Hilton Downtown', 17, '2019-07-12', 156, 151),
('Hilton Downtown', 17, '2019-07-13', 147, 151),
('Hilton Downtown', 17, '2019-07-14', 236, 151),
('Hilton Downtown', 17, '2019-07-15', 261, 151),
('Hilton Downtown', 17, '2019-07-16', 169, 151),
('Hilton Downtown', 17, '2019-07-17', 155, 151),
('Hilton Downtown', 17, '2019-07-18', 102, 151),
('Hilton Downtown', 17, '2019-07-19', 268, 151),
('Hilton Downtown', 17, '2019-07-20', 180, 151),
('Hilton Downtown', 17, '2019-07-21', 267, 151),
('Hilton Downtown', 17, '2019-07-22', 399, 151),
('Hilton Downtown', 17, '2019-07-23', 134, 151),
('Hilton Downtown', 17, '2019-07-24', 374, NULL),
('Hilton Downtown', 17, '2019-07-25', 341, NULL),
('Hilton Downtown', 17, '2019-07-26', 123, NULL),
('Hilton Downtown', 17, '2019-07-27', 379, NULL),
('Hilton Downtown', 17, '2019-07-28', 342, NULL),
('Hilton Downtown', 17, '2019-07-29', 200, NULL),
('Hilton Downtown', 17, '2019-07-30', 108, NULL),
('Hilton Downtown', 17, '2019-07-31', 177, NULL),
('Hilton Downtown', 17, '2019-08-01', 320, NULL),
('Hilton Downtown', 17, '2019-08-02', 358, NULL),
('Hilton Downtown', 17, '2019-08-03', 328, NULL),
('Hilton Downtown', 17, '2019-08-04', 324, NULL),
('Hilton Downtown', 17, '2019-08-05', 196, NULL),
('Hilton Downtown', 17, '2019-08-06', 134, NULL),
('Hilton Downtown', 17, '2019-08-07', 188, NULL),
('Hilton Downtown', 17, '2019-08-08', 209, NULL),
('Hilton Downtown', 17, '2019-08-09', 135, NULL),
('Hilton Downtown', 17, '2019-08-10', 135, NULL),
('Hilton Downtown', 17, '2019-08-11', 160, NULL),
('Hilton Downtown', 17, '2019-08-12', 387, NULL),
('Hilton Downtown', 17, '2019-08-13', 326, NULL),
('Hilton Downtown', 17, '2019-08-14', 184, NULL),
('Hilton Downtown', 17, '2019-08-15', 321, NULL),
('Hilton Downtown', 17, '2019-08-16', 193, NULL),
('Hilton Downtown', 17, '2019-08-17', 175, NULL),
('Hilton Downtown', 17, '2019-08-18', 314, NULL),
('Hilton Downtown', 17, '2019-08-19', 192, NULL),
('Hilton Downtown', 17, '2019-08-20', 131, NULL),
('Hilton Downtown', 17, '2019-08-21', 201, NULL),
('Hilton Downtown', 17, '2019-08-22', 384, NULL),
('Hilton Downtown', 17, '2019-08-23', 127, NULL),
('Hilton Downtown', 17, '2019-08-24', 358, NULL),
('Hilton Downtown', 17, '2019-08-25', 217, NULL),
('Hilton Downtown', 17, '2019-08-26', 250, NULL),
('Hilton Downtown', 17, '2019-08-27', 240, NULL),
('Hilton Downtown', 17, '2019-08-28', 131, NULL),
('Hilton Downtown', 17, '2019-08-29', 352, NULL),
('Hilton Downtown', 17, '2019-08-30', 310, NULL),
('Hilton Downtown', 17, '2019-08-31', 279, NULL),
('Hilton Downtown', 17, '2019-09-01', 324, NULL),
('Hilton Downtown', 17, '2019-09-02', 370, NULL),
('Hilton Downtown', 17, '2019-09-03', 192, NULL),
('Hilton Downtown', 17, '2019-09-04', 294, NULL),
('Hilton Downtown', 17, '2019-09-05', 134, NULL),
('Hilton Downtown', 17, '2019-09-06', 339, NULL),
('Hilton Downtown', 17, '2019-09-07', 347, NULL),
('Hilton Downtown', 17, '2019-09-08', 249, NULL),
('Hilton Downtown', 17, '2019-09-09', 172, NULL),
('Hilton Downtown', 17, '2019-09-10', 216, NULL),
('Hilton Downtown', 17, '2019-09-11', 279, NULL),
('Hilton Downtown', 17, '2019-09-12', 179, NULL),
('Hilton Downtown', 17, '2019-09-13', 366, NULL),
('Hilton Downtown', 17, '2019-09-14', 158, NULL),
('Hilton Downtown', 17, '2019-09-15', 232, NULL),
('Hilton Downtown', 17, '2019-09-16', 104, NULL),
('Hilton Downtown', 17, '2019-09-17', 391, NULL),
('Hilton Downtown', 17, '2019-09-18', 329, NULL),
('Hilton Downtown', 17, '2019-09-19', 242, NULL),
('Hilton Downtown', 17, '2019-09-20', 384, NULL),
('Hilton Downtown', 17, '2019-09-21', 170, NULL),
('Hilton Downtown', 17, '2019-09-22', 204, NULL),
('Hilton Downtown', 17, '2019-09-23', 389, NULL),
('Hilton Downtown', 17, '2019-09-24', 391, NULL),
('Hilton Downtown', 17, '2019-09-25', 180, NULL),
('Hilton Downtown', 17, '2019-09-26', 168, NULL),
('Hilton Downtown', 17, '2019-09-27', 382, NULL),
('Hilton Downtown', 17, '2019-09-28', 285, NULL),
('Hilton Downtown', 17, '2019-09-29', 144, NULL),
('Hilton Downtown', 17, '2019-09-30', 210, NULL),
('Hilton Downtown', 17, '2019-10-01', 195, NULL),
('Hilton Downtown', 17, '2019-10-02', 151, NULL),
('Hilton Downtown', 17, '2019-10-03', 210, NULL),
('Hilton Downtown', 17, '2019-10-04', 161, NULL),
('Hilton Downtown', 17, '2019-10-05', 306, NULL),
('Hilton Downtown', 17, '2019-10-06', 349, NULL),
('Hilton Downtown', 17, '2019-10-07', 275, NULL),
('Hilton Downtown', 17, '2019-10-08', 270, NULL),
('Hilton Downtown', 17, '2019-10-09', 136, NULL),
('Hilton Downtown', 17, '2019-10-10', 331, NULL),
('Hilton Downtown', 17, '2019-10-11', 263, NULL),
('Hilton Downtown', 17, '2019-10-12', 332, NULL),
('Hilton Downtown', 17, '2019-10-13', 159, NULL),
('Hilton Downtown', 17, '2019-10-14', 325, NULL),
('Hilton Downtown', 17, '2019-10-15', 229, NULL),
('Hilton Downtown', 17, '2019-10-16', 341, NULL),
('Hilton Downtown', 17, '2019-10-17', 339, NULL),
('Hilton Downtown', 17, '2019-10-18', 397, NULL),
('Hilton Downtown', 17, '2019-10-19', 115, NULL),
('Hilton Downtown', 17, '2019-10-20', 396, NULL),
('Hilton Downtown', 17, '2019-10-21', 325, NULL),
('Hilton Downtown', 17, '2019-10-22', 242, NULL),
('Hilton Downtown', 17, '2019-10-23', 219, NULL),
('Hilton Downtown', 17, '2019-10-24', 230, NULL),
('Hilton Downtown', 17, '2019-10-25', 218, NULL),
('Hilton Downtown', 17, '2019-10-26', 248, NULL),
('Hilton Downtown', 17, '2019-10-27', 316, NULL),
('Hilton Downtown', 17, '2019-10-28', 248, NULL),
('Hilton Downtown', 17, '2019-10-29', 221, NULL),
('Hilton Downtown', 17, '2019-10-30', 289, NULL),
('Hilton Downtown', 17, '2019-10-31', 204, NULL),
('Hilton Downtown', 17, '2019-11-01', 171, NULL),
('Hilton Downtown', 17, '2019-11-02', 273, NULL),
('Hilton Downtown', 17, '2019-11-03', 189, NULL),
('Hilton Downtown', 17, '2019-11-04', 133, NULL),
('Hilton Downtown', 17, '2019-11-05', 161, NULL),
('Hilton Downtown', 17, '2019-11-06', 289, NULL),
('Hilton Downtown', 17, '2019-11-07', 394, NULL),
('Hilton Downtown', 17, '2019-11-08', 383, NULL),
('Hilton Downtown', 17, '2019-11-09', 310, NULL),
('Hilton Downtown', 17, '2019-11-10', 265, NULL),
('Hilton Downtown', 17, '2019-11-11', 204, NULL),
('Hilton Downtown', 17, '2019-11-12', 265, NULL),
('Hilton Downtown', 17, '2019-11-13', 222, NULL),
('Hilton Downtown', 17, '2019-11-14', 245, NULL),
('Hilton Downtown', 17, '2019-11-15', 355, NULL),
('Hilton Downtown', 17, '2019-11-16', 109, NULL),
('Hilton Downtown', 17, '2019-11-17', 357, NULL),
('Hilton Downtown', 17, '2019-11-18', 308, NULL),
('Hilton Downtown', 17, '2019-11-19', 223, NULL),
('Hilton Downtown', 17, '2019-11-20', 163, NULL),
('Hilton Downtown', 17, '2019-11-21', 107, NULL),
('Hilton Downtown', 17, '2019-11-22', 382, NULL),
('Hilton Downtown', 17, '2019-11-23', 364, NULL),
('Hilton Downtown', 17, '2019-11-24', 242, NULL),
('Hilton Downtown', 17, '2019-11-25', 218, NULL),
('Hilton Downtown', 17, '2019-11-26', 331, NULL),
('Hilton Downtown', 17, '2019-11-27', 310, NULL),
('Hilton Downtown', 17, '2019-11-28', 107, NULL),
('Hilton Downtown', 17, '2019-11-29', 249, NULL),
('Hilton Downtown', 17, '2019-11-30', 213, NULL),
('Hilton Downtown', 17, '2019-12-01', 320, NULL),
('Hilton Downtown', 17, '2019-12-02', 193, NULL),
('Hilton Downtown', 17, '2019-12-03', 136, NULL),
('Hilton Downtown', 17, '2019-12-04', 308, NULL),
('Hilton Downtown', 17, '2019-12-05', 361, NULL),
('Hilton Downtown', 17, '2019-12-06', 314, NULL),
('Hilton Downtown', 17, '2019-12-07', 277, NULL),
('Hilton Downtown', 17, '2019-12-08', 158, NULL),
('Hilton Downtown', 17, '2019-12-09', 229, NULL),
('Hilton Downtown', 17, '2019-12-10', 276, NULL),
('Hilton Downtown', 17, '2019-12-11', 333, NULL),
('Hilton Downtown', 17, '2019-12-12', 281, NULL),
('Hilton Downtown', 17, '2019-12-13', 270, NULL),
('Hilton Downtown', 17, '2019-12-14', 376, NULL),
('Hilton Downtown', 17, '2019-12-15', 371, NULL),
('Hilton Downtown', 17, '2019-12-16', 317, NULL),
('Hilton Downtown', 17, '2019-12-17', 290, NULL),
('Hilton Downtown', 17, '2019-12-18', 262, NULL),
('Hilton Downtown', 17, '2019-12-19', 220, NULL),
('Hilton Downtown', 17, '2019-12-20', 210, NULL),
('Hilton Downtown', 17, '2019-12-21', 342, NULL),
('Hilton Downtown', 17, '2019-12-22', 293, NULL),
('Hilton Downtown', 17, '2019-12-23', 361, NULL),
('Hilton Downtown', 17, '2019-12-24', 329, NULL),
('Hilton Downtown', 17, '2019-12-25', 205, NULL),
('Hilton Downtown', 17, '2019-12-26', 147, NULL),
('Hilton Downtown', 17, '2019-12-27', 118, NULL),
('Hilton Downtown', 17, '2019-12-28', 322, NULL),
('Hilton Downtown', 17, '2019-12-29', 322, NULL),
('Hilton Downtown', 17, '2019-12-30', 339, NULL),
('Hilton Downtown', 17, '2019-12-31', 156, NULL),
('Hilton Downtown', 17, '2020-01-01', 298, NULL),
('Hilton Downtown', 17, '2020-01-02', 267, NULL),
('Hilton Downtown', 17, '2020-01-03', 277, NULL),
('Hilton Downtown', 17, '2020-01-04', 211, NULL),
('Hilton Downtown', 17, '2020-01-05', 354, NULL),
('Hilton Downtown', 17, '2020-01-06', 360, NULL),
('Hilton Downtown', 17, '2020-01-07', 280, NULL),
('Hilton Downtown', 17, '2020-01-08', 181, NULL),
('Hilton Downtown', 17, '2020-01-09', 136, NULL),
('Hilton Downtown', 17, '2020-01-10', 156, NULL),
('Hilton Downtown', 17, '2020-01-11', 170, NULL),
('Hilton Downtown', 17, '2020-01-12', 100, NULL),
('Hilton Downtown', 17, '2020-01-13', 238, NULL),
('Hilton Downtown', 17, '2020-01-14', 111, NULL),
('Hilton Downtown', 17, '2020-01-15', 259, NULL),
('Hilton Downtown', 17, '2020-01-16', 258, NULL),
('Hilton Downtown', 17, '2020-01-17', 152, NULL),
('Hilton Downtown', 17, '2020-01-18', 239, NULL),
('Hilton Downtown', 17, '2020-01-19', 158, NULL),
('Hilton Downtown', 17, '2020-01-20', 208, NULL),
('Hilton Downtown', 17, '2020-01-21', 162, NULL),
('Hilton Downtown', 17, '2020-01-22', 230, NULL),
('Hilton Downtown', 17, '2020-01-23', 155, NULL),
('Hilton Downtown', 17, '2020-01-24', 371, NULL),
('Hilton Downtown', 17, '2020-01-25', 381, NULL),
('Hilton Downtown', 17, '2020-01-26', 385, NULL),
('Hilton Downtown', 17, '2020-01-27', 259, NULL),
('Hilton Downtown', 17, '2020-01-28', 334, NULL),
('Hilton Downtown', 17, '2020-01-29', 101, NULL),
('Hilton Downtown', 17, '2020-01-30', 237, NULL),
('Hilton Downtown', 17, '2020-01-31', 298, NULL),
('Hilton Downtown', 17, '2020-02-01', 374, NULL),
('Hilton Downtown', 17, '2020-02-02', 376, NULL),
('Hilton Downtown', 17, '2020-02-03', 182, NULL),
('Hilton Downtown', 17, '2020-02-04', 177, NULL),
('Hilton Downtown', 54, '2019-01-01', 380, NULL),
('Hilton Downtown', 54, '2019-01-02', 213, NULL),
('Hilton Downtown', 54, '2019-01-03', 346, NULL),
('Hilton Downtown', 54, '2019-01-04', 188, NULL),
('Hilton Downtown', 54, '2019-01-05', 101, NULL),
('Hilton Downtown', 54, '2019-01-06', 301, NULL),
('Hilton Downtown', 54, '2019-01-07', 265, NULL),
('Hilton Downtown', 54, '2019-01-08', 279, NULL),
('Hilton Downtown', 54, '2019-01-09', 284, NULL),
('Hilton Downtown', 54, '2019-01-10', 281, NULL),
('Hilton Downtown', 54, '2019-01-11', 240, NULL),
('Hilton Downtown', 54, '2019-01-12', 261, NULL),
('Hilton Downtown', 54, '2019-01-13', 241, NULL),
('Hilton Downtown', 54, '2019-01-14', 316, NULL),
('Hilton Downtown', 54, '2019-01-15', 356, NULL),
('Hilton Downtown', 54, '2019-01-16', 230, NULL),
('Hilton Downtown', 54, '2019-01-17', 385, NULL),
('Hilton Downtown', 54, '2019-01-18', 374, NULL),
('Hilton Downtown', 54, '2019-01-19', 190, NULL),
('Hilton Downtown', 54, '2019-01-20', 311, NULL),
('Hilton Downtown', 54, '2019-01-21', 234, NULL),
('Hilton Downtown', 54, '2019-01-22', 397, NULL),
('Hilton Downtown', 54, '2019-01-23', 293, NULL),
('Hilton Downtown', 54, '2019-01-24', 246, NULL),
('Hilton Downtown', 54, '2019-01-25', 372, NULL),
('Hilton Downtown', 54, '2019-01-26', 315, NULL),
('Hilton Downtown', 54, '2019-01-27', 159, NULL),
('Hilton Downtown', 54, '2019-01-28', 195, NULL),
('Hilton Downtown', 54, '2019-01-29', 208, NULL),
('Hilton Downtown', 54, '2019-01-30', 129, NULL),
('Hilton Downtown', 54, '2019-01-31', 118, NULL),
('Hilton Downtown', 54, '2019-02-01', 384, NULL),
('Hilton Downtown', 54, '2019-02-02', 192, NULL),
('Hilton Downtown', 54, '2019-02-03', 124, NULL),
('Hilton Downtown', 54, '2019-02-04', 380, NULL),
('Hilton Downtown', 54, '2019-02-05', 213, NULL),
('Hilton Downtown', 54, '2019-02-06', 140, NULL),
('Hilton Downtown', 54, '2019-02-07', 310, NULL),
('Hilton Downtown', 54, '2019-02-08', 193, NULL),
('Hilton Downtown', 54, '2019-02-09', 281, NULL),
('Hilton Downtown', 54, '2019-02-10', 192, NULL),
('Hilton Downtown', 54, '2019-02-11', 165, NULL),
('Hilton Downtown', 54, '2019-02-12', 219, NULL),
('Hilton Downtown', 54, '2019-02-13', 233, NULL),
('Hilton Downtown', 54, '2019-02-14', 172, NULL),
('Hilton Downtown', 54, '2019-02-15', 165, NULL),
('Hilton Downtown', 54, '2019-02-16', 386, NULL),
('Hilton Downtown', 54, '2019-02-17', 135, NULL),
('Hilton Downtown', 54, '2019-02-18', 247, NULL),
('Hilton Downtown', 54, '2019-02-19', 282, NULL),
('Hilton Downtown', 54, '2019-02-20', 313, NULL),
('Hilton Downtown', 54, '2019-02-21', 315, NULL),
('Hilton Downtown', 54, '2019-02-22', 142, NULL),
('Hilton Downtown', 54, '2019-02-23', 379, NULL),
('Hilton Downtown', 54, '2019-02-24', 196, NULL),
('Hilton Downtown', 54, '2019-02-25', 390, NULL),
('Hilton Downtown', 54, '2019-02-26', 192, NULL),
('Hilton Downtown', 54, '2019-02-27', 131, NULL),
('Hilton Downtown', 54, '2019-02-28', 170, NULL),
('Hilton Downtown', 54, '2019-03-01', 291, NULL),
('Hilton Downtown', 54, '2019-03-02', 127, NULL),
('Hilton Downtown', 54, '2019-03-03', 296, NULL),
('Hilton Downtown', 54, '2019-03-04', 254, NULL),
('Hilton Downtown', 54, '2019-03-05', 103, NULL),
('Hilton Downtown', 54, '2019-03-06', 228, NULL),
('Hilton Downtown', 54, '2019-03-07', 175, NULL),
('Hilton Downtown', 54, '2019-03-08', 178, NULL),
('Hilton Downtown', 54, '2019-03-09', 384, NULL),
('Hilton Downtown', 54, '2019-03-10', 275, NULL),
('Hilton Downtown', 54, '2019-03-11', 181, NULL),
('Hilton Downtown', 54, '2019-03-12', 334, NULL),
('Hilton Downtown', 54, '2019-03-13', 171, NULL),
('Hilton Downtown', 54, '2019-03-14', 127, NULL),
('Hilton Downtown', 54, '2019-03-15', 389, NULL),
('Hilton Downtown', 54, '2019-03-16', 334, NULL),
('Hilton Downtown', 54, '2019-03-17', 283, NULL),
('Hilton Downtown', 54, '2019-03-18', 221, NULL),
('Hilton Downtown', 54, '2019-03-19', 384, NULL),
('Hilton Downtown', 54, '2019-03-20', 263, NULL),
('Hilton Downtown', 54, '2019-03-21', 210, NULL),
('Hilton Downtown', 54, '2019-03-22', 387, NULL),
('Hilton Downtown', 54, '2019-03-23', 312, NULL),
('Hilton Downtown', 54, '2019-03-24', 324, NULL),
('Hilton Downtown', 54, '2019-03-25', 357, NULL),
('Hilton Downtown', 54, '2019-03-26', 277, NULL),
('Hilton Downtown', 54, '2019-03-27', 165, NULL),
('Hilton Downtown', 54, '2019-03-28', 300, NULL),
('Hilton Downtown', 54, '2019-03-29', 199, NULL),
('Hilton Downtown', 54, '2019-03-30', 175, NULL),
('Hilton Downtown', 54, '2019-03-31', 302, NULL),
('Hilton Downtown', 54, '2019-04-01', 337, NULL),
('Hilton Downtown', 54, '2019-04-02', 149, NULL),
('Hilton Downtown', 54, '2019-04-03', 265, NULL),
('Hilton Downtown', 54, '2019-04-04', 385, NULL),
('Hilton Downtown', 54, '2019-04-05', 217, NULL),
('Hilton Downtown', 54, '2019-04-06', 356, NULL),
('Hilton Downtown', 54, '2019-04-07', 283, NULL),
('Hilton Downtown', 54, '2019-04-08', 299, NULL),
('Hilton Downtown', 54, '2019-04-09', 243, NULL),
('Hilton Downtown', 54, '2019-04-10', 148, NULL),
('Hilton Downtown', 54, '2019-04-11', 345, NULL),
('Hilton Downtown', 54, '2019-04-12', 129, NULL),
('Hilton Downtown', 54, '2019-04-13', 253, NULL),
('Hilton Downtown', 54, '2019-04-14', 120, NULL),
('Hilton Downtown', 54, '2019-04-15', 142, NULL),
('Hilton Downtown', 54, '2019-04-16', 233, NULL),
('Hilton Downtown', 54, '2019-04-17', 274, NULL),
('Hilton Downtown', 54, '2019-04-18', 367, NULL),
('Hilton Downtown', 54, '2019-04-19', 103, NULL),
('Hilton Downtown', 54, '2019-04-20', 313, NULL),
('Hilton Downtown', 54, '2019-04-21', 185, NULL),
('Hilton Downtown', 54, '2019-04-22', 131, NULL),
('Hilton Downtown', 54, '2019-04-23', 273, NULL),
('Hilton Downtown', 54, '2019-04-24', 126, NULL),
('Hilton Downtown', 54, '2019-04-25', 233, NULL),
('Hilton Downtown', 54, '2019-04-26', 342, NULL),
('Hilton Downtown', 54, '2019-04-27', 181, NULL),
('Hilton Downtown', 54, '2019-04-28', 346, NULL),
('Hilton Downtown', 54, '2019-04-29', 300, NULL),
('Hilton Downtown', 54, '2019-04-30', 198, NULL),
('Hilton Downtown', 54, '2019-05-01', 201, NULL),
('Hilton Downtown', 54, '2019-05-02', 365, NULL),
('Hilton Downtown', 54, '2019-05-03', 358, NULL),
('Hilton Downtown', 54, '2019-05-04', 291, NULL),
('Hilton Downtown', 54, '2019-05-05', 223, NULL),
('Hilton Downtown', 54, '2019-05-06', 274, NULL),
('Hilton Downtown', 54, '2019-05-07', 245, NULL),
('Hilton Downtown', 54, '2019-05-08', 279, NULL),
('Hilton Downtown', 54, '2019-05-09', 345, NULL),
('Hilton Downtown', 54, '2019-05-10', 261, NULL),
('Hilton Downtown', 54, '2019-05-11', 313, NULL),
('Hilton Downtown', 54, '2019-05-12', 254, NULL),
('Hilton Downtown', 54, '2019-05-13', 279, NULL),
('Hilton Downtown', 54, '2019-05-14', 368, NULL),
('Hilton Downtown', 54, '2019-05-15', 264, NULL),
('Hilton Downtown', 54, '2019-05-16', 189, NULL),
('Hilton Downtown', 54, '2019-05-17', 125, NULL),
('Hilton Downtown', 54, '2019-05-18', 338, NULL),
('Hilton Downtown', 54, '2019-05-19', 103, NULL),
('Hilton Downtown', 54, '2019-05-20', 230, NULL),
('Hilton Downtown', 54, '2019-05-21', 364, NULL),
('Hilton Downtown', 54, '2019-05-22', 348, NULL),
('Hilton Downtown', 54, '2019-05-23', 277, NULL),
('Hilton Downtown', 54, '2019-05-24', 122, NULL),
('Hilton Downtown', 54, '2019-05-25', 131, NULL),
('Hilton Downtown', 54, '2019-05-26', 262, NULL),
('Hilton Downtown', 54, '2019-05-27', 342, NULL),
('Hilton Downtown', 54, '2019-05-28', 204, NULL),
('Hilton Downtown', 54, '2019-05-29', 155, NULL),
('Hilton Downtown', 54, '2019-05-30', 167, NULL),
('Hilton Downtown', 54, '2019-05-31', 225, NULL),
('Hilton Downtown', 54, '2019-06-01', 342, NULL),
('Hilton Downtown', 54, '2019-06-02', 121, NULL),
('Hilton Downtown', 54, '2019-06-03', 335, NULL),
('Hilton Downtown', 54, '2019-06-04', 142, NULL),
('Hilton Downtown', 54, '2019-06-05', 291, NULL),
('Hilton Downtown', 54, '2019-06-06', 146, NULL),
('Hilton Downtown', 54, '2019-06-07', 206, NULL),
('Hilton Downtown', 54, '2019-06-08', 360, NULL),
('Hilton Downtown', 54, '2019-06-09', 392, NULL),
('Hilton Downtown', 54, '2019-06-10', 226, NULL),
('Hilton Downtown', 54, '2019-06-11', 347, NULL),
('Hilton Downtown', 54, '2019-06-12', 373, NULL),
('Hilton Downtown', 54, '2019-06-13', 279, NULL),
('Hilton Downtown', 54, '2019-06-14', 350, NULL),
('Hilton Downtown', 54, '2019-06-15', 237, NULL),
('Hilton Downtown', 54, '2019-06-16', 383, NULL),
('Hilton Downtown', 54, '2019-06-17', 388, NULL),
('Hilton Downtown', 54, '2019-06-18', 125, NULL),
('Hilton Downtown', 54, '2019-06-19', 313, NULL),
('Hilton Downtown', 54, '2019-06-20', 162, NULL),
('Hilton Downtown', 54, '2019-06-21', 178, NULL),
('Hilton Downtown', 54, '2019-06-22', 310, NULL),
('Hilton Downtown', 54, '2019-06-23', 179, NULL),
('Hilton Downtown', 54, '2019-06-24', 165, NULL),
('Hilton Downtown', 54, '2019-06-25', 232, NULL),
('Hilton Downtown', 54, '2019-06-26', 398, NULL),
('Hilton Downtown', 54, '2019-06-27', 296, NULL),
('Hilton Downtown', 54, '2019-06-28', 383, NULL),
('Hilton Downtown', 54, '2019-06-29', 373, NULL),
('Hilton Downtown', 54, '2019-06-30', 332, NULL),
('Hilton Downtown', 54, '2019-07-01', 117, NULL),
('Hilton Downtown', 54, '2019-07-02', 132, NULL),
('Hilton Downtown', 54, '2019-07-03', 281, NULL),
('Hilton Downtown', 54, '2019-07-04', 327, NULL),
('Hilton Downtown', 54, '2019-07-05', 159, NULL),
('Hilton Downtown', 54, '2019-07-06', 169, NULL),
('Hilton Downtown', 54, '2019-07-07', 253, NULL),
('Hilton Downtown', 54, '2019-07-08', 281, NULL),
('Hilton Downtown', 54, '2019-07-09', 196, NULL),
('Hilton Downtown', 54, '2019-07-10', 193, NULL),
('Hilton Downtown', 54, '2019-07-11', 313, NULL),
('Hilton Downtown', 54, '2019-07-12', 289, NULL),
('Hilton Downtown', 54, '2019-07-13', 212, NULL),
('Hilton Downtown', 54, '2019-07-14', 219, NULL),
('Hilton Downtown', 54, '2019-07-15', 213, NULL),
('Hilton Downtown', 54, '2019-07-16', 395, NULL),
('Hilton Downtown', 54, '2019-07-17', 209, NULL),
('Hilton Downtown', 54, '2019-07-18', 111, NULL),
('Hilton Downtown', 54, '2019-07-19', 265, NULL),
('Hilton Downtown', 54, '2019-07-20', 351, NULL),
('Hilton Downtown', 54, '2019-07-21', 159, NULL),
('Hilton Downtown', 54, '2019-07-22', 278, NULL),
('Hilton Downtown', 54, '2019-07-23', 326, NULL),
('Hilton Downtown', 54, '2019-07-24', 143, NULL),
('Hilton Downtown', 54, '2019-07-25', 145, NULL),
('Hilton Downtown', 54, '2019-07-26', 363, NULL),
('Hilton Downtown', 54, '2019-07-27', 196, NULL),
('Hilton Downtown', 54, '2019-07-28', 241, NULL),
('Hilton Downtown', 54, '2019-07-29', 376, NULL),
('Hilton Downtown', 54, '2019-07-30', 362, NULL),
('Hilton Downtown', 54, '2019-07-31', 140, NULL),
('Hilton Downtown', 54, '2019-08-01', 291, NULL),
('Hilton Downtown', 54, '2019-08-02', 181, NULL),
('Hilton Downtown', 54, '2019-08-03', 378, NULL),
('Hilton Downtown', 54, '2019-08-04', 393, NULL),
('Hilton Downtown', 54, '2019-08-05', 234, NULL),
('Hilton Downtown', 54, '2019-08-06', 261, NULL),
('Hilton Downtown', 54, '2019-08-07', 173, NULL),
('Hilton Downtown', 54, '2019-08-08', 349, NULL),
('Hilton Downtown', 54, '2019-08-09', 199, NULL),
('Hilton Downtown', 54, '2019-08-10', 268, NULL),
('Hilton Downtown', 54, '2019-08-11', 138, NULL),
('Hilton Downtown', 54, '2019-08-12', 274, NULL),
('Hilton Downtown', 54, '2019-08-13', 269, NULL),
('Hilton Downtown', 54, '2019-08-14', 135, NULL),
('Hilton Downtown', 54, '2019-08-15', 291, NULL),
('Hilton Downtown', 54, '2019-08-16', 180, NULL),
('Hilton Downtown', 54, '2019-08-17', 231, NULL),
('Hilton Downtown', 54, '2019-08-18', 126, NULL),
('Hilton Downtown', 54, '2019-08-19', 242, NULL),
('Hilton Downtown', 54, '2019-08-20', 380, NULL),
('Hilton Downtown', 54, '2019-08-21', 353, NULL),
('Hilton Downtown', 54, '2019-08-22', 376, NULL),
('Hilton Downtown', 54, '2019-08-23', 385, NULL),
('Hilton Downtown', 54, '2019-08-24', 363, NULL),
('Hilton Downtown', 54, '2019-08-25', 168, NULL),
('Hilton Downtown', 54, '2019-08-26', 240, NULL),
('Hilton Downtown', 54, '2019-08-27', 290, NULL),
('Hilton Downtown', 54, '2019-08-28', 351, NULL),
('Hilton Downtown', 54, '2019-08-29', 122, NULL),
('Hilton Downtown', 54, '2019-08-30', 332, NULL),
('Hilton Downtown', 54, '2019-08-31', 350, NULL),
('Hilton Downtown', 54, '2019-09-01', 218, NULL),
('Hilton Downtown', 54, '2019-09-02', 291, NULL),
('Hilton Downtown', 54, '2019-09-03', 375, NULL),
('Hilton Downtown', 54, '2019-09-04', 307, NULL),
('Hilton Downtown', 54, '2019-09-05', 202, NULL),
('Hilton Downtown', 54, '2019-09-06', 314, NULL),
('Hilton Downtown', 54, '2019-09-07', 280, NULL),
('Hilton Downtown', 54, '2019-09-08', 343, NULL),
('Hilton Downtown', 54, '2019-09-09', 153, NULL),
('Hilton Downtown', 54, '2019-09-10', 217, NULL),
('Hilton Downtown', 54, '2019-09-11', 392, NULL),
('Hilton Downtown', 54, '2019-09-12', 281, NULL),
('Hilton Downtown', 54, '2019-09-13', 159, NULL),
('Hilton Downtown', 54, '2019-09-14', 143, NULL),
('Hilton Downtown', 54, '2019-09-15', 263, NULL),
('Hilton Downtown', 54, '2019-09-16', 377, NULL),
('Hilton Downtown', 54, '2019-09-17', 198, NULL),
('Hilton Downtown', 54, '2019-09-18', 132, NULL),
('Hilton Downtown', 54, '2019-09-19', 263, NULL),
('Hilton Downtown', 54, '2019-09-20', 170, NULL),
('Hilton Downtown', 54, '2019-09-21', 337, NULL),
('Hilton Downtown', 54, '2019-09-22', 208, NULL),
('Hilton Downtown', 54, '2019-09-23', 147, NULL),
('Hilton Downtown', 54, '2019-09-24', 382, NULL),
('Hilton Downtown', 54, '2019-09-25', 272, NULL),
('Hilton Downtown', 54, '2019-09-26', 144, NULL),
('Hilton Downtown', 54, '2019-09-27', 124, NULL),
('Hilton Downtown', 54, '2019-09-28', 118, NULL),
('Hilton Downtown', 54, '2019-09-29', 208, NULL),
('Hilton Downtown', 54, '2019-09-30', 356, NULL),
('Hilton Downtown', 54, '2019-10-01', 238, NULL),
('Hilton Downtown', 54, '2019-10-02', 340, NULL),
('Hilton Downtown', 54, '2019-10-03', 358, NULL),
('Hilton Downtown', 54, '2019-10-04', 224, NULL),
('Hilton Downtown', 54, '2019-10-05', 223, NULL),
('Hilton Downtown', 54, '2019-10-06', 152, NULL),
('Hilton Downtown', 54, '2019-10-07', 375, NULL),
('Hilton Downtown', 54, '2019-10-08', 321, NULL),
('Hilton Downtown', 54, '2019-10-09', 309, NULL),
('Hilton Downtown', 54, '2019-10-10', 325, NULL),
('Hilton Downtown', 54, '2019-10-11', 365, NULL),
('Hilton Downtown', 54, '2019-10-12', 212, NULL),
('Hilton Downtown', 54, '2019-10-13', 267, NULL),
('Hilton Downtown', 54, '2019-10-14', 128, NULL),
('Hilton Downtown', 54, '2019-10-15', 327, NULL),
('Hilton Downtown', 54, '2019-10-16', 133, NULL),
('Hilton Downtown', 54, '2019-10-17', 170, NULL),
('Hilton Downtown', 54, '2019-10-18', 353, NULL),
('Hilton Downtown', 54, '2019-10-19', 184, NULL),
('Hilton Downtown', 54, '2019-10-20', 310, NULL),
('Hilton Downtown', 54, '2019-10-21', 246, NULL),
('Hilton Downtown', 54, '2019-10-22', 308, NULL),
('Hilton Downtown', 54, '2019-10-23', 144, NULL),
('Hilton Downtown', 54, '2019-10-24', 144, NULL),
('Hilton Downtown', 54, '2019-10-25', 267, NULL),
('Hilton Downtown', 54, '2019-10-26', 183, NULL),
('Hilton Downtown', 54, '2019-10-27', 358, NULL),
('Hilton Downtown', 54, '2019-10-28', 262, NULL),
('Hilton Downtown', 54, '2019-10-29', 253, NULL),
('Hilton Downtown', 54, '2019-10-30', 210, NULL),
('Hilton Downtown', 54, '2019-10-31', 181, NULL),
('Hilton Downtown', 54, '2019-11-01', 387, NULL),
('Hilton Downtown', 54, '2019-11-02', 295, NULL),
('Hilton Downtown', 54, '2019-11-03', 293, NULL),
('Hilton Downtown', 54, '2019-11-04', 237, NULL),
('Hilton Downtown', 54, '2019-11-05', 147, NULL),
('Hilton Downtown', 54, '2019-11-06', 374, NULL),
('Hilton Downtown', 54, '2019-11-07', 137, NULL),
('Hilton Downtown', 54, '2019-11-08', 349, NULL),
('Hilton Downtown', 54, '2019-11-09', 336, NULL),
('Hilton Downtown', 54, '2019-11-10', 284, NULL),
('Hilton Downtown', 54, '2019-11-11', 367, NULL),
('Hilton Downtown', 54, '2019-11-12', 384, NULL),
('Hilton Downtown', 54, '2019-11-13', 333, NULL),
('Hilton Downtown', 54, '2019-11-14', 227, NULL),
('Hilton Downtown', 54, '2019-11-15', 349, NULL),
('Hilton Downtown', 54, '2019-11-16', 241, NULL),
('Hilton Downtown', 54, '2019-11-17', 130, NULL),
('Hilton Downtown', 54, '2019-11-18', 324, NULL),
('Hilton Downtown', 54, '2019-11-19', 291, NULL),
('Hilton Downtown', 54, '2019-11-20', 211, NULL),
('Hilton Downtown', 54, '2019-11-21', 251, NULL),
('Hilton Downtown', 54, '2019-11-22', 390, NULL),
('Hilton Downtown', 54, '2019-11-23', 399, NULL),
('Hilton Downtown', 54, '2019-11-24', 249, NULL),
('Hilton Downtown', 54, '2019-11-25', 132, NULL),
('Hilton Downtown', 54, '2019-11-26', 383, NULL),
('Hilton Downtown', 54, '2019-11-27', 388, NULL),
('Hilton Downtown', 54, '2019-11-28', 216, NULL),
('Hilton Downtown', 54, '2019-11-29', 352, NULL),
('Hilton Downtown', 54, '2019-11-30', 223, NULL),
('Hilton Downtown', 54, '2019-12-01', 398, NULL),
('Hilton Downtown', 54, '2019-12-02', 343, NULL),
('Hilton Downtown', 54, '2019-12-03', 181, NULL),
('Hilton Downtown', 54, '2019-12-04', 354, NULL),
('Hilton Downtown', 54, '2019-12-05', 281, NULL),
('Hilton Downtown', 54, '2019-12-06', 162, NULL),
('Hilton Downtown', 54, '2019-12-07', 289, NULL),
('Hilton Downtown', 54, '2019-12-08', 366, NULL),
('Hilton Downtown', 54, '2019-12-09', 299, NULL),
('Hilton Downtown', 54, '2019-12-10', 294, NULL),
('Hilton Downtown', 54, '2019-12-11', 273, NULL),
('Hilton Downtown', 54, '2019-12-12', 212, NULL),
('Hilton Downtown', 54, '2019-12-13', 298, NULL),
('Hilton Downtown', 54, '2019-12-14', 266, NULL),
('Hilton Downtown', 54, '2019-12-15', 231, NULL),
('Hilton Downtown', 54, '2019-12-16', 293, NULL),
('Hilton Downtown', 54, '2019-12-17', 244, NULL),
('Hilton Downtown', 54, '2019-12-18', 220, NULL),
('Hilton Downtown', 54, '2019-12-19', 388, NULL),
('Hilton Downtown', 54, '2019-12-20', 314, NULL),
('Hilton Downtown', 54, '2019-12-21', 137, NULL),
('Hilton Downtown', 54, '2019-12-22', 233, NULL),
('Hilton Downtown', 54, '2019-12-23', 355, NULL),
('Hilton Downtown', 54, '2019-12-24', 236, NULL),
('Hilton Downtown', 54, '2019-12-25', 131, NULL),
('Hilton Downtown', 54, '2019-12-26', 223, NULL),
('Hilton Downtown', 54, '2019-12-27', 292, NULL),
('Hilton Downtown', 54, '2019-12-28', 211, NULL),
('Hilton Downtown', 54, '2019-12-29', 223, NULL),
('Hilton Downtown', 54, '2019-12-30', 107, NULL),
('Hilton Downtown', 54, '2019-12-31', 147, NULL),
('Hilton Downtown', 54, '2020-01-01', 192, NULL),
('Hilton Downtown', 54, '2020-01-02', 364, NULL),
('Hilton Downtown', 54, '2020-01-03', 162, NULL),
('Hilton Downtown', 54, '2020-01-04', 283, NULL),
('Hilton Downtown', 54, '2020-01-05', 295, NULL),
('Hilton Downtown', 54, '2020-01-06', 108, NULL),
('Hilton Downtown', 54, '2020-01-07', 321, NULL),
('Hilton Downtown', 54, '2020-01-08', 128, NULL),
('Hilton Downtown', 54, '2020-01-09', 373, NULL),
('Hilton Downtown', 54, '2020-01-10', 123, NULL),
('Hilton Downtown', 54, '2020-01-11', 193, NULL),
('Hilton Downtown', 54, '2020-01-12', 244, NULL),
('Hilton Downtown', 54, '2020-01-13', 315, NULL),
('Hilton Downtown', 54, '2020-01-14', 185, NULL),
('Hilton Downtown', 54, '2020-01-15', 398, NULL),
('Hilton Downtown', 54, '2020-01-16', 307, NULL),
('Hilton Downtown', 54, '2020-01-17', 214, NULL),
('Hilton Downtown', 54, '2020-01-18', 309, NULL),
('Hilton Downtown', 54, '2020-01-19', 172, NULL),
('Hilton Downtown', 54, '2020-01-20', 386, NULL),
('Hilton Downtown', 54, '2020-01-21', 189, NULL),
('Hilton Downtown', 54, '2020-01-22', 253, NULL),
('Hilton Downtown', 54, '2020-01-23', 188, NULL),
('Hilton Downtown', 54, '2020-01-24', 241, NULL),
('Hilton Downtown', 54, '2020-01-25', 155, NULL),
('Hilton Downtown', 54, '2020-01-26', 279, NULL),
('Hilton Downtown', 54, '2020-01-27', 378, NULL),
('Hilton Downtown', 54, '2020-01-28', 142, NULL),
('Hilton Downtown', 54, '2020-01-29', 158, NULL),
('Hilton Downtown', 54, '2020-01-30', 272, NULL),
('Hilton Downtown', 54, '2020-01-31', 159, NULL),
('Hilton Downtown', 54, '2020-02-01', 364, NULL),
('Hilton Downtown', 54, '2020-02-02', 228, NULL),
('Hilton Downtown', 54, '2020-02-03', 396, NULL),
('Hilton Downtown', 54, '2020-02-04', 115, NULL),
('Hilton Downtown', 81, '2019-01-01', 197, NULL),
('Hilton Downtown', 81, '2019-01-02', 315, NULL),
('Hilton Downtown', 81, '2019-01-03', 180, NULL),
('Hilton Downtown', 81, '2019-01-04', 112, NULL),
('Hilton Downtown', 81, '2019-01-05', 231, NULL),
('Hilton Downtown', 81, '2019-01-06', 216, NULL),
('Hilton Downtown', 81, '2019-01-07', 328, NULL),
('Hilton Downtown', 81, '2019-01-08', 271, NULL),
('Hilton Downtown', 81, '2019-01-09', 105, NULL),
('Hilton Downtown', 81, '2019-01-10', 275, NULL),
('Hilton Downtown', 81, '2019-01-11', 331, NULL),
('Hilton Downtown', 81, '2019-01-12', 269, NULL),
('Hilton Downtown', 81, '2019-01-13', 102, NULL),
('Hilton Downtown', 81, '2019-01-14', 390, NULL),
('Hilton Downtown', 81, '2019-01-15', 177, NULL),
('Hilton Downtown', 81, '2019-01-16', 276, NULL),
('Hilton Downtown', 81, '2019-01-17', 186, NULL),
('Hilton Downtown', 81, '2019-01-18', 379, NULL),
('Hilton Downtown', 81, '2019-01-19', 170, NULL),
('Hilton Downtown', 81, '2019-01-20', 308, NULL),
('Hilton Downtown', 81, '2019-01-21', 127, NULL),
('Hilton Downtown', 81, '2019-01-22', 363, NULL),
('Hilton Downtown', 81, '2019-01-23', 396, NULL),
('Hilton Downtown', 81, '2019-01-24', 124, NULL),
('Hilton Downtown', 81, '2019-01-25', 114, NULL),
('Hilton Downtown', 81, '2019-01-26', 135, NULL),
('Hilton Downtown', 81, '2019-01-27', 105, NULL),
('Hilton Downtown', 81, '2019-01-28', 398, NULL),
('Hilton Downtown', 81, '2019-01-29', 198, NULL),
('Hilton Downtown', 81, '2019-01-30', 109, NULL),
('Hilton Downtown', 81, '2019-01-31', 150, NULL),
('Hilton Downtown', 81, '2019-02-01', 333, NULL),
('Hilton Downtown', 81, '2019-02-02', 185, NULL),
('Hilton Downtown', 81, '2019-02-03', 251, NULL),
('Hilton Downtown', 81, '2019-02-04', 209, NULL),
('Hilton Downtown', 81, '2019-02-05', 194, NULL),
('Hilton Downtown', 81, '2019-02-06', 319, NULL),
('Hilton Downtown', 81, '2019-02-07', 235, NULL),
('Hilton Downtown', 81, '2019-02-08', 312, NULL),
('Hilton Downtown', 81, '2019-02-09', 329, NULL),
('Hilton Downtown', 81, '2019-02-10', 103, NULL),
('Hilton Downtown', 81, '2019-02-11', 199, NULL),
('Hilton Downtown', 81, '2019-02-12', 227, NULL),
('Hilton Downtown', 81, '2019-02-13', 238, NULL),
('Hilton Downtown', 81, '2019-02-14', 399, NULL),
('Hilton Downtown', 81, '2019-02-15', 243, NULL),
('Hilton Downtown', 81, '2019-02-16', 352, NULL),
('Hilton Downtown', 81, '2019-02-17', 159, NULL),
('Hilton Downtown', 81, '2019-02-18', 168, NULL),
('Hilton Downtown', 81, '2019-02-19', 330, NULL),
('Hilton Downtown', 81, '2019-02-20', 276, NULL),
('Hilton Downtown', 81, '2019-02-21', 133, NULL),
('Hilton Downtown', 81, '2019-02-22', 378, NULL),
('Hilton Downtown', 81, '2019-02-23', 114, NULL),
('Hilton Downtown', 81, '2019-02-24', 234, NULL),
('Hilton Downtown', 81, '2019-02-25', 200, NULL),
('Hilton Downtown', 81, '2019-02-26', 321, NULL),
('Hilton Downtown', 81, '2019-02-27', 230, NULL),
('Hilton Downtown', 81, '2019-02-28', 379, NULL),
('Hilton Downtown', 81, '2019-03-01', 103, NULL),
('Hilton Downtown', 81, '2019-03-02', 255, NULL),
('Hilton Downtown', 81, '2019-03-03', 215, NULL),
('Hilton Downtown', 81, '2019-03-04', 206, NULL),
('Hilton Downtown', 81, '2019-03-05', 388, NULL),
('Hilton Downtown', 81, '2019-03-06', 179, NULL),
('Hilton Downtown', 81, '2019-03-07', 390, NULL),
('Hilton Downtown', 81, '2019-03-08', 279, NULL),
('Hilton Downtown', 81, '2019-03-09', 142, NULL),
('Hilton Downtown', 81, '2019-03-10', 337, NULL),
('Hilton Downtown', 81, '2019-03-11', 346, NULL),
('Hilton Downtown', 81, '2019-03-12', 364, NULL),
('Hilton Downtown', 81, '2019-03-13', 165, NULL),
('Hilton Downtown', 81, '2019-03-14', 129, NULL),
('Hilton Downtown', 81, '2019-03-15', 277, NULL),
('Hilton Downtown', 81, '2019-03-16', 312, NULL),
('Hilton Downtown', 81, '2019-03-17', 262, NULL),
('Hilton Downtown', 81, '2019-03-18', 389, NULL),
('Hilton Downtown', 81, '2019-03-19', 244, NULL),
('Hilton Downtown', 81, '2019-03-20', 343, NULL),
('Hilton Downtown', 81, '2019-03-21', 353, NULL),
('Hilton Downtown', 81, '2019-03-22', 334, NULL),
('Hilton Downtown', 81, '2019-03-23', 234, NULL),
('Hilton Downtown', 81, '2019-03-24', 235, NULL),
('Hilton Downtown', 81, '2019-03-25', 140, NULL),
('Hilton Downtown', 81, '2019-03-26', 131, NULL),
('Hilton Downtown', 81, '2019-03-27', 341, NULL),
('Hilton Downtown', 81, '2019-03-28', 227, NULL),
('Hilton Downtown', 81, '2019-03-29', 279, NULL),
('Hilton Downtown', 81, '2019-03-30', 317, NULL),
('Hilton Downtown', 81, '2019-03-31', 213, NULL),
('Hilton Downtown', 81, '2019-04-01', 152, NULL),
('Hilton Downtown', 81, '2019-04-02', 346, NULL),
('Hilton Downtown', 81, '2019-04-03', 375, NULL),
('Hilton Downtown', 81, '2019-04-04', 168, NULL),
('Hilton Downtown', 81, '2019-04-05', 170, NULL),
('Hilton Downtown', 81, '2019-04-06', 298, NULL),
('Hilton Downtown', 81, '2019-04-07', 275, NULL),
('Hilton Downtown', 81, '2019-04-08', 100, NULL),
('Hilton Downtown', 81, '2019-04-09', 179, NULL),
('Hilton Downtown', 81, '2019-04-10', 238, NULL),
('Hilton Downtown', 81, '2019-04-11', 241, NULL),
('Hilton Downtown', 81, '2019-04-12', 319, NULL),
('Hilton Downtown', 81, '2019-04-13', 222, NULL),
('Hilton Downtown', 81, '2019-04-14', 151, NULL),
('Hilton Downtown', 81, '2019-04-15', 234, NULL),
('Hilton Downtown', 81, '2019-04-16', 369, NULL),
('Hilton Downtown', 81, '2019-04-17', 351, NULL),
('Hilton Downtown', 81, '2019-04-18', 376, NULL),
('Hilton Downtown', 81, '2019-04-19', 225, NULL),
('Hilton Downtown', 81, '2019-04-20', 179, NULL),
('Hilton Downtown', 81, '2019-04-21', 144, NULL),
('Hilton Downtown', 81, '2019-04-22', 262, NULL),
('Hilton Downtown', 81, '2019-04-23', 163, NULL),
('Hilton Downtown', 81, '2019-04-24', 161, NULL),
('Hilton Downtown', 81, '2019-04-25', 296, NULL),
('Hilton Downtown', 81, '2019-04-26', 200, NULL),
('Hilton Downtown', 81, '2019-04-27', 376, NULL),
('Hilton Downtown', 81, '2019-04-28', 107, NULL),
('Hilton Downtown', 81, '2019-04-29', 162, NULL),
('Hilton Downtown', 81, '2019-04-30', 320, NULL),
('Hilton Downtown', 81, '2019-05-01', 334, NULL),
('Hilton Downtown', 81, '2019-05-02', 110, NULL),
('Hilton Downtown', 81, '2019-05-03', 269, NULL),
('Hilton Downtown', 81, '2019-05-04', 294, NULL),
('Hilton Downtown', 81, '2019-05-05', 344, NULL),
('Hilton Downtown', 81, '2019-05-06', 248, NULL),
('Hilton Downtown', 81, '2019-05-07', 256, NULL),
('Hilton Downtown', 81, '2019-05-08', 225, NULL),
('Hilton Downtown', 81, '2019-05-09', 239, NULL),
('Hilton Downtown', 81, '2019-05-10', 394, NULL),
('Hilton Downtown', 81, '2019-05-11', 199, NULL),
('Hilton Downtown', 81, '2019-05-12', 369, NULL),
('Hilton Downtown', 81, '2019-05-13', 275, NULL),
('Hilton Downtown', 81, '2019-05-14', 224, NULL),
('Hilton Downtown', 81, '2019-05-15', 304, NULL),
('Hilton Downtown', 81, '2019-05-16', 279, NULL),
('Hilton Downtown', 81, '2019-05-17', 315, NULL),
('Hilton Downtown', 81, '2019-05-18', 119, NULL),
('Hilton Downtown', 81, '2019-05-19', 122, NULL),
('Hilton Downtown', 81, '2019-05-20', 258, NULL),
('Hilton Downtown', 81, '2019-05-21', 314, NULL),
('Hilton Downtown', 81, '2019-05-22', 121, NULL),
('Hilton Downtown', 81, '2019-05-23', 367, NULL),
('Hilton Downtown', 81, '2019-05-24', 371, NULL),
('Hilton Downtown', 81, '2019-05-25', 384, NULL),
('Hilton Downtown', 81, '2019-05-26', 358, NULL),
('Hilton Downtown', 81, '2019-05-27', 376, NULL),
('Hilton Downtown', 81, '2019-05-28', 353, NULL),
('Hilton Downtown', 81, '2019-05-29', 150, NULL),
('Hilton Downtown', 81, '2019-05-30', 149, NULL),
('Hilton Downtown', 81, '2019-05-31', 137, NULL),
('Hilton Downtown', 81, '2019-06-01', 381, NULL),
('Hilton Downtown', 81, '2019-06-02', 103, NULL),
('Hilton Downtown', 81, '2019-06-03', 399, NULL),
('Hilton Downtown', 81, '2019-06-04', 359, NULL),
('Hilton Downtown', 81, '2019-06-05', 105, NULL),
('Hilton Downtown', 81, '2019-06-06', 305, NULL),
('Hilton Downtown', 81, '2019-06-07', 364, NULL),
('Hilton Downtown', 81, '2019-06-08', 154, NULL),
('Hilton Downtown', 81, '2019-06-09', 174, NULL),
('Hilton Downtown', 81, '2019-06-10', 263, NULL),
('Hilton Downtown', 81, '2019-06-11', 350, NULL),
('Hilton Downtown', 81, '2019-06-12', 211, NULL),
('Hilton Downtown', 81, '2019-06-13', 161, NULL),
('Hilton Downtown', 81, '2019-06-14', 345, NULL),
('Hilton Downtown', 81, '2019-06-15', 216, NULL),
('Hilton Downtown', 81, '2019-06-16', 168, NULL),
('Hilton Downtown', 81, '2019-06-17', 116, NULL),
('Hilton Downtown', 81, '2019-06-18', 212, NULL),
('Hilton Downtown', 81, '2019-06-19', 299, NULL),
('Hilton Downtown', 81, '2019-06-20', 274, NULL),
('Hilton Downtown', 81, '2019-06-21', 274, NULL),
('Hilton Downtown', 81, '2019-06-22', 351, NULL),
('Hilton Downtown', 81, '2019-06-23', 350, NULL),
('Hilton Downtown', 81, '2019-06-24', 157, NULL),
('Hilton Downtown', 81, '2019-06-25', 106, NULL),
('Hilton Downtown', 81, '2019-06-26', 268, NULL),
('Hilton Downtown', 81, '2019-06-27', 100, NULL),
('Hilton Downtown', 81, '2019-06-28', 185, NULL),
('Hilton Downtown', 81, '2019-06-29', 347, NULL),
('Hilton Downtown', 81, '2019-06-30', 287, NULL),
('Hilton Downtown', 81, '2019-07-01', 260, NULL),
('Hilton Downtown', 81, '2019-07-02', 259, NULL),
('Hilton Downtown', 81, '2019-07-03', 202, NULL),
('Hilton Downtown', 81, '2019-07-04', 110, NULL),
('Hilton Downtown', 81, '2019-07-05', 379, NULL),
('Hilton Downtown', 81, '2019-07-06', 329, NULL),
('Hilton Downtown', 81, '2019-07-07', 251, NULL),
('Hilton Downtown', 81, '2019-07-08', 379, NULL),
('Hilton Downtown', 81, '2019-07-09', 210, NULL),
('Hilton Downtown', 81, '2019-07-10', 118, NULL),
('Hilton Downtown', 81, '2019-07-11', 334, NULL),
('Hilton Downtown', 81, '2019-07-12', 274, NULL),
('Hilton Downtown', 81, '2019-07-13', 218, NULL),
('Hilton Downtown', 81, '2019-07-14', 290, NULL),
('Hilton Downtown', 81, '2019-07-15', 184, NULL),
('Hilton Downtown', 81, '2019-07-16', 169, NULL),
('Hilton Downtown', 81, '2019-07-17', 178, NULL),
('Hilton Downtown', 81, '2019-07-18', 151, NULL),
('Hilton Downtown', 81, '2019-07-19', 122, NULL),
('Hilton Downtown', 81, '2019-07-20', 218, NULL),
('Hilton Downtown', 81, '2019-07-21', 196, NULL),
('Hilton Downtown', 81, '2019-07-22', 395, NULL),
('Hilton Downtown', 81, '2019-07-23', 226, NULL),
('Hilton Downtown', 81, '2019-07-24', 396, NULL),
('Hilton Downtown', 81, '2019-07-25', 203, NULL),
('Hilton Downtown', 81, '2019-07-26', 147, NULL),
('Hilton Downtown', 81, '2019-07-27', 342, NULL),
('Hilton Downtown', 81, '2019-07-28', 378, NULL),
('Hilton Downtown', 81, '2019-07-29', 281, NULL),
('Hilton Downtown', 81, '2019-07-30', 188, NULL),
('Hilton Downtown', 81, '2019-07-31', 368, NULL),
('Hilton Downtown', 81, '2019-08-01', 392, NULL),
('Hilton Downtown', 81, '2019-08-02', 329, NULL),
('Hilton Downtown', 81, '2019-08-03', 205, NULL),
('Hilton Downtown', 81, '2019-08-04', 294, NULL),
('Hilton Downtown', 81, '2019-08-05', 183, NULL),
('Hilton Downtown', 81, '2019-08-06', 206, NULL),
('Hilton Downtown', 81, '2019-08-07', 198, NULL),
('Hilton Downtown', 81, '2019-08-08', 116, NULL),
('Hilton Downtown', 81, '2019-08-09', 192, NULL),
('Hilton Downtown', 81, '2019-08-10', 234, NULL),
('Hilton Downtown', 81, '2019-08-11', 109, NULL),
('Hilton Downtown', 81, '2019-08-12', 111, NULL),
('Hilton Downtown', 81, '2019-08-13', 270, NULL),
('Hilton Downtown', 81, '2019-08-14', 325, NULL),
('Hilton Downtown', 81, '2019-08-15', 393, NULL),
('Hilton Downtown', 81, '2019-08-16', 221, NULL),
('Hilton Downtown', 81, '2019-08-17', 233, NULL),
('Hilton Downtown', 81, '2019-08-18', 189, NULL),
('Hilton Downtown', 81, '2019-08-19', 234, NULL),
('Hilton Downtown', 81, '2019-08-20', 210, NULL),
('Hilton Downtown', 81, '2019-08-21', 161, NULL),
('Hilton Downtown', 81, '2019-08-22', 326, NULL),
('Hilton Downtown', 81, '2019-08-23', 243, NULL),
('Hilton Downtown', 81, '2019-08-24', 339, NULL),
('Hilton Downtown', 81, '2019-08-25', 392, NULL),
('Hilton Downtown', 81, '2019-08-26', 349, NULL),
('Hilton Downtown', 81, '2019-08-27', 330, NULL),
('Hilton Downtown', 81, '2019-08-28', 359, NULL),
('Hilton Downtown', 81, '2019-08-29', 354, NULL),
('Hilton Downtown', 81, '2019-08-30', 333, NULL),
('Hilton Downtown', 81, '2019-08-31', 212, NULL),
('Hilton Downtown', 81, '2019-09-01', 319, NULL),
('Hilton Downtown', 81, '2019-09-02', 244, NULL),
('Hilton Downtown', 81, '2019-09-03', 301, NULL),
('Hilton Downtown', 81, '2019-09-04', 252, NULL),
('Hilton Downtown', 81, '2019-09-05', 210, NULL),
('Hilton Downtown', 81, '2019-09-06', 150, NULL),
('Hilton Downtown', 81, '2019-09-07', 261, NULL),
('Hilton Downtown', 81, '2019-09-08', 267, NULL),
('Hilton Downtown', 81, '2019-09-09', 150, NULL),
('Hilton Downtown', 81, '2019-09-10', 341, NULL),
('Hilton Downtown', 81, '2019-09-11', 126, NULL),
('Hilton Downtown', 81, '2019-09-12', 171, NULL),
('Hilton Downtown', 81, '2019-09-13', 198, NULL),
('Hilton Downtown', 81, '2019-09-14', 143, NULL),
('Hilton Downtown', 81, '2019-09-15', 218, NULL),
('Hilton Downtown', 81, '2019-09-16', 276, NULL),
('Hilton Downtown', 81, '2019-09-17', 318, NULL),
('Hilton Downtown', 81, '2019-09-18', 176, NULL),
('Hilton Downtown', 81, '2019-09-19', 190, NULL),
('Hilton Downtown', 81, '2019-09-20', 200, NULL),
('Hilton Downtown', 81, '2019-09-21', 176, NULL),
('Hilton Downtown', 81, '2019-09-22', 327, NULL),
('Hilton Downtown', 81, '2019-09-23', 370, NULL),
('Hilton Downtown', 81, '2019-09-24', 338, NULL),
('Hilton Downtown', 81, '2019-09-25', 123, NULL),
('Hilton Downtown', 81, '2019-09-26', 117, NULL),
('Hilton Downtown', 81, '2019-09-27', 274, NULL),
('Hilton Downtown', 81, '2019-09-28', 236, NULL),
('Hilton Downtown', 81, '2019-09-29', 206, NULL),
('Hilton Downtown', 81, '2019-09-30', 147, NULL),
('Hilton Downtown', 81, '2019-10-01', 206, NULL),
('Hilton Downtown', 81, '2019-10-02', 250, NULL),
('Hilton Downtown', 81, '2019-10-03', 161, NULL),
('Hilton Downtown', 81, '2019-10-04', 238, NULL),
('Hilton Downtown', 81, '2019-10-05', 100, NULL),
('Hilton Downtown', 81, '2019-10-06', 214, NULL),
('Hilton Downtown', 81, '2019-10-07', 348, NULL),
('Hilton Downtown', 81, '2019-10-08', 399, NULL),
('Hilton Downtown', 81, '2019-10-09', 141, NULL),
('Hilton Downtown', 81, '2019-10-10', 233, NULL),
('Hilton Downtown', 81, '2019-10-11', 337, NULL),
('Hilton Downtown', 81, '2019-10-12', 266, NULL),
('Hilton Downtown', 81, '2019-10-13', 158, NULL),
('Hilton Downtown', 81, '2019-10-14', 163, NULL),
('Hilton Downtown', 81, '2019-10-15', 250, NULL),
('Hilton Downtown', 81, '2019-10-16', 144, NULL),
('Hilton Downtown', 81, '2019-10-17', 333, NULL),
('Hilton Downtown', 81, '2019-10-18', 175, NULL),
('Hilton Downtown', 81, '2019-10-19', 176, NULL),
('Hilton Downtown', 81, '2019-10-20', 260, NULL),
('Hilton Downtown', 81, '2019-10-21', 152, NULL),
('Hilton Downtown', 81, '2019-10-22', 116, NULL),
('Hilton Downtown', 81, '2019-10-23', 263, NULL),
('Hilton Downtown', 81, '2019-10-24', 232, NULL),
('Hilton Downtown', 81, '2019-10-25', 282, NULL),
('Hilton Downtown', 81, '2019-10-26', 368, NULL),
('Hilton Downtown', 81, '2019-10-27', 141, NULL),
('Hilton Downtown', 81, '2019-10-28', 163, NULL),
('Hilton Downtown', 81, '2019-10-29', 205, NULL),
('Hilton Downtown', 81, '2019-10-30', 381, NULL),
('Hilton Downtown', 81, '2019-10-31', 192, NULL),
('Hilton Downtown', 81, '2019-11-01', 121, NULL),
('Hilton Downtown', 81, '2019-11-02', 256, NULL),
('Hilton Downtown', 81, '2019-11-03', 199, NULL),
('Hilton Downtown', 81, '2019-11-04', 385, NULL),
('Hilton Downtown', 81, '2019-11-05', 152, NULL),
('Hilton Downtown', 81, '2019-11-06', 307, NULL),
('Hilton Downtown', 81, '2019-11-07', 305, NULL),
('Hilton Downtown', 81, '2019-11-08', 197, NULL),
('Hilton Downtown', 81, '2019-11-09', 352, NULL),
('Hilton Downtown', 81, '2019-11-10', 223, NULL),
('Hilton Downtown', 81, '2019-11-11', 225, NULL),
('Hilton Downtown', 81, '2019-11-12', 128, NULL),
('Hilton Downtown', 81, '2019-11-13', 302, NULL),
('Hilton Downtown', 81, '2019-11-14', 299, NULL),
('Hilton Downtown', 81, '2019-11-15', 280, NULL),
('Hilton Downtown', 81, '2019-11-16', 180, NULL),
('Hilton Downtown', 81, '2019-11-17', 378, NULL),
('Hilton Downtown', 81, '2019-11-18', 296, NULL),
('Hilton Downtown', 81, '2019-11-19', 388, NULL),
('Hilton Downtown', 81, '2019-11-20', 167, NULL),
('Hilton Downtown', 81, '2019-11-21', 233, NULL),
('Hilton Downtown', 81, '2019-11-22', 103, NULL),
('Hilton Downtown', 81, '2019-11-23', 202, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 81, '2019-11-24', 118, NULL),
('Hilton Downtown', 81, '2019-11-25', 207, NULL),
('Hilton Downtown', 81, '2019-11-26', 221, NULL),
('Hilton Downtown', 81, '2019-11-27', 308, NULL),
('Hilton Downtown', 81, '2019-11-28', 359, NULL),
('Hilton Downtown', 81, '2019-11-29', 313, NULL),
('Hilton Downtown', 81, '2019-11-30', 374, NULL),
('Hilton Downtown', 81, '2019-12-01', 331, NULL),
('Hilton Downtown', 81, '2019-12-02', 137, NULL),
('Hilton Downtown', 81, '2019-12-03', 398, NULL),
('Hilton Downtown', 81, '2019-12-04', 145, NULL),
('Hilton Downtown', 81, '2019-12-05', 225, NULL),
('Hilton Downtown', 81, '2019-12-06', 368, NULL),
('Hilton Downtown', 81, '2019-12-07', 215, NULL),
('Hilton Downtown', 81, '2019-12-08', 357, NULL),
('Hilton Downtown', 81, '2019-12-09', 111, NULL),
('Hilton Downtown', 81, '2019-12-10', 243, NULL),
('Hilton Downtown', 81, '2019-12-11', 267, NULL),
('Hilton Downtown', 81, '2019-12-12', 116, NULL),
('Hilton Downtown', 81, '2019-12-13', 278, NULL),
('Hilton Downtown', 81, '2019-12-14', 101, NULL),
('Hilton Downtown', 81, '2019-12-15', 241, NULL),
('Hilton Downtown', 81, '2019-12-16', 113, NULL),
('Hilton Downtown', 81, '2019-12-17', 252, NULL),
('Hilton Downtown', 81, '2019-12-18', 216, NULL),
('Hilton Downtown', 81, '2019-12-19', 279, NULL),
('Hilton Downtown', 81, '2019-12-20', 239, NULL),
('Hilton Downtown', 81, '2019-12-21', 162, NULL),
('Hilton Downtown', 81, '2019-12-22', 186, NULL),
('Hilton Downtown', 81, '2019-12-23', 289, NULL),
('Hilton Downtown', 81, '2019-12-24', 392, NULL),
('Hilton Downtown', 81, '2019-12-25', 240, NULL),
('Hilton Downtown', 81, '2019-12-26', 276, NULL),
('Hilton Downtown', 81, '2019-12-27', 108, NULL),
('Hilton Downtown', 81, '2019-12-28', 290, NULL),
('Hilton Downtown', 81, '2019-12-29', 350, NULL),
('Hilton Downtown', 81, '2019-12-30', 321, NULL),
('Hilton Downtown', 81, '2019-12-31', 169, NULL),
('Hilton Downtown', 81, '2020-01-01', 267, NULL),
('Hilton Downtown', 81, '2020-01-02', 319, NULL),
('Hilton Downtown', 81, '2020-01-03', 177, NULL),
('Hilton Downtown', 81, '2020-01-04', 382, NULL),
('Hilton Downtown', 81, '2020-01-05', 312, NULL),
('Hilton Downtown', 81, '2020-01-06', 260, NULL),
('Hilton Downtown', 81, '2020-01-07', 368, NULL),
('Hilton Downtown', 81, '2020-01-08', 298, NULL),
('Hilton Downtown', 81, '2020-01-09', 157, NULL),
('Hilton Downtown', 81, '2020-01-10', 345, NULL),
('Hilton Downtown', 81, '2020-01-11', 356, NULL),
('Hilton Downtown', 81, '2020-01-12', 220, NULL),
('Hilton Downtown', 81, '2020-01-13', 160, NULL),
('Hilton Downtown', 81, '2020-01-14', 191, NULL),
('Hilton Downtown', 81, '2020-01-15', 213, NULL),
('Hilton Downtown', 81, '2020-01-16', 364, NULL),
('Hilton Downtown', 81, '2020-01-17', 213, NULL),
('Hilton Downtown', 81, '2020-01-18', 128, NULL),
('Hilton Downtown', 81, '2020-01-19', 284, NULL),
('Hilton Downtown', 81, '2020-01-20', 305, NULL),
('Hilton Downtown', 81, '2020-01-21', 361, NULL),
('Hilton Downtown', 81, '2020-01-22', 177, NULL),
('Hilton Downtown', 81, '2020-01-23', 374, NULL),
('Hilton Downtown', 81, '2020-01-24', 291, NULL),
('Hilton Downtown', 81, '2020-01-25', 133, NULL),
('Hilton Downtown', 81, '2020-01-26', 139, NULL),
('Hilton Downtown', 81, '2020-01-27', 114, NULL),
('Hilton Downtown', 81, '2020-01-28', 210, NULL),
('Hilton Downtown', 81, '2020-01-29', 390, NULL),
('Hilton Downtown', 81, '2020-01-30', 252, NULL),
('Hilton Downtown', 81, '2020-01-31', 103, NULL),
('Hilton Downtown', 81, '2020-02-01', 298, NULL),
('Hilton Downtown', 81, '2020-02-02', 215, NULL),
('Hilton Downtown', 81, '2020-02-03', 133, NULL),
('Hilton Downtown', 81, '2020-02-04', 242, NULL),
('Hilton Downtown', 85, '2019-01-01', 346, NULL),
('Hilton Downtown', 85, '2019-01-02', 234, NULL),
('Hilton Downtown', 85, '2019-01-03', 364, NULL),
('Hilton Downtown', 85, '2019-01-04', 197, NULL),
('Hilton Downtown', 85, '2019-01-05', 153, NULL),
('Hilton Downtown', 85, '2019-01-06', 379, NULL),
('Hilton Downtown', 85, '2019-01-07', 145, NULL),
('Hilton Downtown', 85, '2019-01-08', 117, NULL),
('Hilton Downtown', 85, '2019-01-09', 176, NULL),
('Hilton Downtown', 85, '2019-01-10', 131, NULL),
('Hilton Downtown', 85, '2019-01-11', 237, NULL),
('Hilton Downtown', 85, '2019-01-12', 163, NULL),
('Hilton Downtown', 85, '2019-01-13', 290, NULL),
('Hilton Downtown', 85, '2019-01-14', 303, NULL),
('Hilton Downtown', 85, '2019-01-15', 315, NULL),
('Hilton Downtown', 85, '2019-01-16', 288, NULL),
('Hilton Downtown', 85, '2019-01-17', 275, NULL),
('Hilton Downtown', 85, '2019-01-18', 373, NULL),
('Hilton Downtown', 85, '2019-01-19', 180, NULL),
('Hilton Downtown', 85, '2019-01-20', 208, NULL),
('Hilton Downtown', 85, '2019-01-21', 133, NULL),
('Hilton Downtown', 85, '2019-01-22', 224, NULL),
('Hilton Downtown', 85, '2019-01-23', 102, NULL),
('Hilton Downtown', 85, '2019-01-24', 384, NULL),
('Hilton Downtown', 85, '2019-01-25', 256, NULL),
('Hilton Downtown', 85, '2019-01-26', 231, NULL),
('Hilton Downtown', 85, '2019-01-27', 247, NULL),
('Hilton Downtown', 85, '2019-01-28', 106, NULL),
('Hilton Downtown', 85, '2019-01-29', 268, NULL),
('Hilton Downtown', 85, '2019-01-30', 360, NULL),
('Hilton Downtown', 85, '2019-01-31', 295, NULL),
('Hilton Downtown', 85, '2019-02-01', 113, NULL),
('Hilton Downtown', 85, '2019-02-02', 251, NULL),
('Hilton Downtown', 85, '2019-02-03', 181, NULL),
('Hilton Downtown', 85, '2019-02-04', 106, NULL),
('Hilton Downtown', 85, '2019-02-05', 230, NULL),
('Hilton Downtown', 85, '2019-02-06', 174, NULL),
('Hilton Downtown', 85, '2019-02-07', 144, NULL),
('Hilton Downtown', 85, '2019-02-08', 282, NULL),
('Hilton Downtown', 85, '2019-02-09', 102, NULL),
('Hilton Downtown', 85, '2019-02-10', 140, NULL),
('Hilton Downtown', 85, '2019-02-11', 398, NULL),
('Hilton Downtown', 85, '2019-02-12', 381, NULL),
('Hilton Downtown', 85, '2019-02-13', 391, NULL),
('Hilton Downtown', 85, '2019-02-14', 182, NULL),
('Hilton Downtown', 85, '2019-02-15', 320, NULL),
('Hilton Downtown', 85, '2019-02-16', 205, NULL),
('Hilton Downtown', 85, '2019-02-17', 292, NULL),
('Hilton Downtown', 85, '2019-02-18', 299, NULL),
('Hilton Downtown', 85, '2019-02-19', 107, NULL),
('Hilton Downtown', 85, '2019-02-20', 342, NULL),
('Hilton Downtown', 85, '2019-02-21', 222, NULL),
('Hilton Downtown', 85, '2019-02-22', 162, NULL),
('Hilton Downtown', 85, '2019-02-23', 236, NULL),
('Hilton Downtown', 85, '2019-02-24', 179, NULL),
('Hilton Downtown', 85, '2019-02-25', 331, NULL),
('Hilton Downtown', 85, '2019-02-26', 332, NULL),
('Hilton Downtown', 85, '2019-02-27', 361, NULL),
('Hilton Downtown', 85, '2019-02-28', 386, NULL),
('Hilton Downtown', 85, '2019-03-01', 143, NULL),
('Hilton Downtown', 85, '2019-03-02', 191, NULL),
('Hilton Downtown', 85, '2019-03-03', 388, NULL),
('Hilton Downtown', 85, '2019-03-04', 166, NULL),
('Hilton Downtown', 85, '2019-03-05', 330, NULL),
('Hilton Downtown', 85, '2019-03-06', 115, NULL),
('Hilton Downtown', 85, '2019-03-07', 123, NULL),
('Hilton Downtown', 85, '2019-03-08', 163, NULL),
('Hilton Downtown', 85, '2019-03-09', 357, NULL),
('Hilton Downtown', 85, '2019-03-10', 161, NULL),
('Hilton Downtown', 85, '2019-03-11', 189, NULL),
('Hilton Downtown', 85, '2019-03-12', 121, NULL),
('Hilton Downtown', 85, '2019-03-13', 213, NULL),
('Hilton Downtown', 85, '2019-03-14', 163, NULL),
('Hilton Downtown', 85, '2019-03-15', 118, NULL),
('Hilton Downtown', 85, '2019-03-16', 156, NULL),
('Hilton Downtown', 85, '2019-03-17', 358, NULL),
('Hilton Downtown', 85, '2019-03-18', 281, NULL),
('Hilton Downtown', 85, '2019-03-19', 269, NULL),
('Hilton Downtown', 85, '2019-03-20', 228, NULL),
('Hilton Downtown', 85, '2019-03-21', 136, NULL),
('Hilton Downtown', 85, '2019-03-22', 111, NULL),
('Hilton Downtown', 85, '2019-03-23', 132, NULL),
('Hilton Downtown', 85, '2019-03-24', 106, NULL),
('Hilton Downtown', 85, '2019-03-25', 131, NULL),
('Hilton Downtown', 85, '2019-03-26', 326, NULL),
('Hilton Downtown', 85, '2019-03-27', 211, NULL),
('Hilton Downtown', 85, '2019-03-28', 133, NULL),
('Hilton Downtown', 85, '2019-03-29', 397, NULL),
('Hilton Downtown', 85, '2019-03-30', 362, NULL),
('Hilton Downtown', 85, '2019-03-31', 362, NULL),
('Hilton Downtown', 85, '2019-04-01', 252, NULL),
('Hilton Downtown', 85, '2019-04-02', 281, NULL),
('Hilton Downtown', 85, '2019-04-03', 381, NULL),
('Hilton Downtown', 85, '2019-04-04', 184, NULL),
('Hilton Downtown', 85, '2019-04-05', 399, NULL),
('Hilton Downtown', 85, '2019-04-06', 321, NULL),
('Hilton Downtown', 85, '2019-04-07', 126, NULL),
('Hilton Downtown', 85, '2019-04-08', 105, NULL),
('Hilton Downtown', 85, '2019-04-09', 369, NULL),
('Hilton Downtown', 85, '2019-04-10', 349, NULL),
('Hilton Downtown', 85, '2019-04-11', 369, NULL),
('Hilton Downtown', 85, '2019-04-12', 206, NULL),
('Hilton Downtown', 85, '2019-04-13', 252, NULL),
('Hilton Downtown', 85, '2019-04-14', 296, NULL),
('Hilton Downtown', 85, '2019-04-15', 347, NULL),
('Hilton Downtown', 85, '2019-04-16', 145, NULL),
('Hilton Downtown', 85, '2019-04-17', 234, NULL),
('Hilton Downtown', 85, '2019-04-18', 382, NULL),
('Hilton Downtown', 85, '2019-04-19', 120, NULL),
('Hilton Downtown', 85, '2019-04-20', 158, NULL),
('Hilton Downtown', 85, '2019-04-21', 367, NULL),
('Hilton Downtown', 85, '2019-04-22', 218, NULL),
('Hilton Downtown', 85, '2019-04-23', 196, NULL),
('Hilton Downtown', 85, '2019-04-24', 328, NULL),
('Hilton Downtown', 85, '2019-04-25', 381, NULL),
('Hilton Downtown', 85, '2019-04-26', 174, NULL),
('Hilton Downtown', 85, '2019-04-27', 337, NULL),
('Hilton Downtown', 85, '2019-04-28', 297, NULL),
('Hilton Downtown', 85, '2019-04-29', 110, NULL),
('Hilton Downtown', 85, '2019-04-30', 306, NULL),
('Hilton Downtown', 85, '2019-05-01', 371, NULL),
('Hilton Downtown', 85, '2019-05-02', 254, NULL),
('Hilton Downtown', 85, '2019-05-03', 172, NULL),
('Hilton Downtown', 85, '2019-05-04', 199, NULL),
('Hilton Downtown', 85, '2019-05-05', 352, NULL),
('Hilton Downtown', 85, '2019-05-06', 319, NULL),
('Hilton Downtown', 85, '2019-05-07', 147, NULL),
('Hilton Downtown', 85, '2019-05-08', 189, NULL),
('Hilton Downtown', 85, '2019-05-09', 360, NULL),
('Hilton Downtown', 85, '2019-05-10', 191, NULL),
('Hilton Downtown', 85, '2019-05-11', 256, NULL),
('Hilton Downtown', 85, '2019-05-12', 382, NULL),
('Hilton Downtown', 85, '2019-05-13', 137, NULL),
('Hilton Downtown', 85, '2019-05-14', 217, NULL),
('Hilton Downtown', 85, '2019-05-15', 329, NULL),
('Hilton Downtown', 85, '2019-05-16', 126, NULL),
('Hilton Downtown', 85, '2019-05-17', 198, NULL),
('Hilton Downtown', 85, '2019-05-18', 381, NULL),
('Hilton Downtown', 85, '2019-05-19', 199, NULL),
('Hilton Downtown', 85, '2019-05-20', 201, NULL),
('Hilton Downtown', 85, '2019-05-21', 378, NULL),
('Hilton Downtown', 85, '2019-05-22', 361, NULL),
('Hilton Downtown', 85, '2019-05-23', 307, NULL),
('Hilton Downtown', 85, '2019-05-24', 187, NULL),
('Hilton Downtown', 85, '2019-05-25', 230, NULL),
('Hilton Downtown', 85, '2019-05-26', 305, NULL),
('Hilton Downtown', 85, '2019-05-27', 156, NULL),
('Hilton Downtown', 85, '2019-05-28', 153, NULL),
('Hilton Downtown', 85, '2019-05-29', 187, NULL),
('Hilton Downtown', 85, '2019-05-30', 142, NULL),
('Hilton Downtown', 85, '2019-05-31', 207, NULL),
('Hilton Downtown', 85, '2019-06-01', 179, NULL),
('Hilton Downtown', 85, '2019-06-02', 350, NULL),
('Hilton Downtown', 85, '2019-06-03', 292, NULL),
('Hilton Downtown', 85, '2019-06-04', 369, NULL),
('Hilton Downtown', 85, '2019-06-05', 152, NULL),
('Hilton Downtown', 85, '2019-06-06', 385, NULL),
('Hilton Downtown', 85, '2019-06-07', 201, NULL),
('Hilton Downtown', 85, '2019-06-08', 190, NULL),
('Hilton Downtown', 85, '2019-06-09', 191, NULL),
('Hilton Downtown', 85, '2019-06-10', 236, NULL),
('Hilton Downtown', 85, '2019-06-11', 312, NULL),
('Hilton Downtown', 85, '2019-06-12', 136, NULL),
('Hilton Downtown', 85, '2019-06-13', 166, NULL),
('Hilton Downtown', 85, '2019-06-14', 277, NULL),
('Hilton Downtown', 85, '2019-06-15', 268, NULL),
('Hilton Downtown', 85, '2019-06-16', 195, NULL),
('Hilton Downtown', 85, '2019-06-17', 216, NULL),
('Hilton Downtown', 85, '2019-06-18', 286, NULL),
('Hilton Downtown', 85, '2019-06-19', 158, NULL),
('Hilton Downtown', 85, '2019-06-20', 187, NULL),
('Hilton Downtown', 85, '2019-06-21', 138, NULL),
('Hilton Downtown', 85, '2019-06-22', 128, NULL),
('Hilton Downtown', 85, '2019-06-23', 210, NULL),
('Hilton Downtown', 85, '2019-06-24', 190, NULL),
('Hilton Downtown', 85, '2019-06-25', 333, NULL),
('Hilton Downtown', 85, '2019-06-26', 345, NULL),
('Hilton Downtown', 85, '2019-06-27', 115, NULL),
('Hilton Downtown', 85, '2019-06-28', 277, NULL),
('Hilton Downtown', 85, '2019-06-29', 216, NULL),
('Hilton Downtown', 85, '2019-06-30', 339, NULL),
('Hilton Downtown', 85, '2019-07-01', 249, NULL),
('Hilton Downtown', 85, '2019-07-02', 198, NULL),
('Hilton Downtown', 85, '2019-07-03', 367, NULL),
('Hilton Downtown', 85, '2019-07-04', 372, NULL),
('Hilton Downtown', 85, '2019-07-05', 115, NULL),
('Hilton Downtown', 85, '2019-07-06', 141, NULL),
('Hilton Downtown', 85, '2019-07-07', 399, NULL),
('Hilton Downtown', 85, '2019-07-08', 353, NULL),
('Hilton Downtown', 85, '2019-07-09', 366, NULL),
('Hilton Downtown', 85, '2019-07-10', 213, NULL),
('Hilton Downtown', 85, '2019-07-11', 330, NULL),
('Hilton Downtown', 85, '2019-07-12', 106, NULL),
('Hilton Downtown', 85, '2019-07-13', 354, NULL),
('Hilton Downtown', 85, '2019-07-14', 390, NULL),
('Hilton Downtown', 85, '2019-07-15', 181, NULL),
('Hilton Downtown', 85, '2019-07-16', 161, NULL),
('Hilton Downtown', 85, '2019-07-17', 166, NULL),
('Hilton Downtown', 85, '2019-07-18', 322, NULL),
('Hilton Downtown', 85, '2019-07-19', 314, NULL),
('Hilton Downtown', 85, '2019-07-20', 238, NULL),
('Hilton Downtown', 85, '2019-07-21', 100, NULL),
('Hilton Downtown', 85, '2019-07-22', 142, NULL),
('Hilton Downtown', 85, '2019-07-23', 354, NULL),
('Hilton Downtown', 85, '2019-07-24', 250, NULL),
('Hilton Downtown', 85, '2019-07-25', 183, NULL),
('Hilton Downtown', 85, '2019-07-26', 149, NULL),
('Hilton Downtown', 85, '2019-07-27', 123, NULL),
('Hilton Downtown', 85, '2019-07-28', 168, NULL),
('Hilton Downtown', 85, '2019-07-29', 177, NULL),
('Hilton Downtown', 85, '2019-07-30', 353, NULL),
('Hilton Downtown', 85, '2019-07-31', 122, NULL),
('Hilton Downtown', 85, '2019-08-01', 390, NULL),
('Hilton Downtown', 85, '2019-08-02', 102, NULL),
('Hilton Downtown', 85, '2019-08-03', 392, NULL),
('Hilton Downtown', 85, '2019-08-04', 190, NULL),
('Hilton Downtown', 85, '2019-08-05', 116, NULL),
('Hilton Downtown', 85, '2019-08-06', 146, NULL),
('Hilton Downtown', 85, '2019-08-07', 373, NULL),
('Hilton Downtown', 85, '2019-08-08', 334, NULL),
('Hilton Downtown', 85, '2019-08-09', 261, NULL),
('Hilton Downtown', 85, '2019-08-10', 268, NULL),
('Hilton Downtown', 85, '2019-08-11', 331, NULL),
('Hilton Downtown', 85, '2019-08-12', 234, NULL),
('Hilton Downtown', 85, '2019-08-13', 140, NULL),
('Hilton Downtown', 85, '2019-08-14', 218, NULL),
('Hilton Downtown', 85, '2019-08-15', 391, NULL),
('Hilton Downtown', 85, '2019-08-16', 166, NULL),
('Hilton Downtown', 85, '2019-08-17', 371, NULL),
('Hilton Downtown', 85, '2019-08-18', 166, NULL),
('Hilton Downtown', 85, '2019-08-19', 344, NULL),
('Hilton Downtown', 85, '2019-08-20', 110, NULL),
('Hilton Downtown', 85, '2019-08-21', 249, NULL),
('Hilton Downtown', 85, '2019-08-22', 105, NULL),
('Hilton Downtown', 85, '2019-08-23', 261, NULL),
('Hilton Downtown', 85, '2019-08-24', 210, NULL),
('Hilton Downtown', 85, '2019-08-25', 154, NULL),
('Hilton Downtown', 85, '2019-08-26', 326, NULL),
('Hilton Downtown', 85, '2019-08-27', 380, NULL),
('Hilton Downtown', 85, '2019-08-28', 342, NULL),
('Hilton Downtown', 85, '2019-08-29', 106, NULL),
('Hilton Downtown', 85, '2019-08-30', 271, NULL),
('Hilton Downtown', 85, '2019-08-31', 210, NULL),
('Hilton Downtown', 85, '2019-09-01', 240, NULL),
('Hilton Downtown', 85, '2019-09-02', 247, NULL),
('Hilton Downtown', 85, '2019-09-03', 279, NULL),
('Hilton Downtown', 85, '2019-09-04', 238, NULL),
('Hilton Downtown', 85, '2019-09-05', 345, NULL),
('Hilton Downtown', 85, '2019-09-06', 310, NULL),
('Hilton Downtown', 85, '2019-09-07', 363, NULL),
('Hilton Downtown', 85, '2019-09-08', 210, NULL),
('Hilton Downtown', 85, '2019-09-09', 191, NULL),
('Hilton Downtown', 85, '2019-09-10', 352, NULL),
('Hilton Downtown', 85, '2019-09-11', 254, NULL),
('Hilton Downtown', 85, '2019-09-12', 210, NULL),
('Hilton Downtown', 85, '2019-09-13', 113, NULL),
('Hilton Downtown', 85, '2019-09-14', 184, NULL),
('Hilton Downtown', 85, '2019-09-15', 201, NULL),
('Hilton Downtown', 85, '2019-09-16', 147, NULL),
('Hilton Downtown', 85, '2019-09-17', 295, NULL),
('Hilton Downtown', 85, '2019-09-18', 384, NULL),
('Hilton Downtown', 85, '2019-09-19', 360, NULL),
('Hilton Downtown', 85, '2019-09-20', 391, NULL),
('Hilton Downtown', 85, '2019-09-21', 371, NULL),
('Hilton Downtown', 85, '2019-09-22', 314, NULL),
('Hilton Downtown', 85, '2019-09-23', 109, NULL),
('Hilton Downtown', 85, '2019-09-24', 144, NULL),
('Hilton Downtown', 85, '2019-09-25', 301, NULL),
('Hilton Downtown', 85, '2019-09-26', 353, NULL),
('Hilton Downtown', 85, '2019-09-27', 299, NULL),
('Hilton Downtown', 85, '2019-09-28', 128, NULL),
('Hilton Downtown', 85, '2019-09-29', 309, NULL),
('Hilton Downtown', 85, '2019-09-30', 170, NULL),
('Hilton Downtown', 85, '2019-10-01', 214, NULL),
('Hilton Downtown', 85, '2019-10-02', 128, NULL),
('Hilton Downtown', 85, '2019-10-03', 233, NULL),
('Hilton Downtown', 85, '2019-10-04', 118, NULL),
('Hilton Downtown', 85, '2019-10-05', 331, NULL),
('Hilton Downtown', 85, '2019-10-06', 213, NULL),
('Hilton Downtown', 85, '2019-10-07', 216, NULL),
('Hilton Downtown', 85, '2019-10-08', 330, NULL),
('Hilton Downtown', 85, '2019-10-09', 276, NULL),
('Hilton Downtown', 85, '2019-10-10', 389, NULL),
('Hilton Downtown', 85, '2019-10-11', 190, NULL),
('Hilton Downtown', 85, '2019-10-12', 294, NULL),
('Hilton Downtown', 85, '2019-10-13', 189, NULL),
('Hilton Downtown', 85, '2019-10-14', 331, NULL),
('Hilton Downtown', 85, '2019-10-15', 169, NULL),
('Hilton Downtown', 85, '2019-10-16', 219, NULL),
('Hilton Downtown', 85, '2019-10-17', 156, NULL),
('Hilton Downtown', 85, '2019-10-18', 315, NULL),
('Hilton Downtown', 85, '2019-10-19', 226, NULL),
('Hilton Downtown', 85, '2019-10-20', 272, NULL),
('Hilton Downtown', 85, '2019-10-21', 225, NULL),
('Hilton Downtown', 85, '2019-10-22', 156, NULL),
('Hilton Downtown', 85, '2019-10-23', 184, NULL),
('Hilton Downtown', 85, '2019-10-24', 325, NULL),
('Hilton Downtown', 85, '2019-10-25', 209, NULL),
('Hilton Downtown', 85, '2019-10-26', 294, NULL),
('Hilton Downtown', 85, '2019-10-27', 133, NULL),
('Hilton Downtown', 85, '2019-10-28', 230, NULL),
('Hilton Downtown', 85, '2019-10-29', 166, NULL),
('Hilton Downtown', 85, '2019-10-30', 278, NULL),
('Hilton Downtown', 85, '2019-10-31', 317, NULL),
('Hilton Downtown', 85, '2019-11-01', 247, NULL),
('Hilton Downtown', 85, '2019-11-02', 294, NULL),
('Hilton Downtown', 85, '2019-11-03', 317, NULL),
('Hilton Downtown', 85, '2019-11-04', 214, NULL),
('Hilton Downtown', 85, '2019-11-05', 220, NULL),
('Hilton Downtown', 85, '2019-11-06', 312, NULL),
('Hilton Downtown', 85, '2019-11-07', 115, NULL),
('Hilton Downtown', 85, '2019-11-08', 136, NULL),
('Hilton Downtown', 85, '2019-11-09', 351, NULL),
('Hilton Downtown', 85, '2019-11-10', 164, NULL),
('Hilton Downtown', 85, '2019-11-11', 224, NULL),
('Hilton Downtown', 85, '2019-11-12', 286, NULL),
('Hilton Downtown', 85, '2019-11-13', 109, NULL),
('Hilton Downtown', 85, '2019-11-14', 117, NULL),
('Hilton Downtown', 85, '2019-11-15', 253, NULL),
('Hilton Downtown', 85, '2019-11-16', 375, NULL),
('Hilton Downtown', 85, '2019-11-17', 200, NULL),
('Hilton Downtown', 85, '2019-11-18', 110, NULL),
('Hilton Downtown', 85, '2019-11-19', 368, NULL),
('Hilton Downtown', 85, '2019-11-20', 105, NULL),
('Hilton Downtown', 85, '2019-11-21', 314, NULL),
('Hilton Downtown', 85, '2019-11-22', 145, NULL),
('Hilton Downtown', 85, '2019-11-23', 314, NULL),
('Hilton Downtown', 85, '2019-11-24', 344, NULL),
('Hilton Downtown', 85, '2019-11-25', 239, NULL),
('Hilton Downtown', 85, '2019-11-26', 158, NULL),
('Hilton Downtown', 85, '2019-11-27', 277, NULL),
('Hilton Downtown', 85, '2019-11-28', 148, NULL),
('Hilton Downtown', 85, '2019-11-29', 111, NULL),
('Hilton Downtown', 85, '2019-11-30', 203, NULL),
('Hilton Downtown', 85, '2019-12-01', 361, NULL),
('Hilton Downtown', 85, '2019-12-02', 156, NULL),
('Hilton Downtown', 85, '2019-12-03', 149, NULL),
('Hilton Downtown', 85, '2019-12-04', 163, NULL),
('Hilton Downtown', 85, '2019-12-05', 179, NULL),
('Hilton Downtown', 85, '2019-12-06', 357, NULL),
('Hilton Downtown', 85, '2019-12-07', 107, NULL),
('Hilton Downtown', 85, '2019-12-08', 287, NULL),
('Hilton Downtown', 85, '2019-12-09', 158, NULL),
('Hilton Downtown', 85, '2019-12-10', 231, NULL),
('Hilton Downtown', 85, '2019-12-11', 118, NULL),
('Hilton Downtown', 85, '2019-12-12', 147, NULL),
('Hilton Downtown', 85, '2019-12-13', 399, NULL),
('Hilton Downtown', 85, '2019-12-14', 209, NULL),
('Hilton Downtown', 85, '2019-12-15', 112, NULL),
('Hilton Downtown', 85, '2019-12-16', 189, NULL),
('Hilton Downtown', 85, '2019-12-17', 126, NULL),
('Hilton Downtown', 85, '2019-12-18', 322, NULL),
('Hilton Downtown', 85, '2019-12-19', 135, NULL),
('Hilton Downtown', 85, '2019-12-20', 154, NULL),
('Hilton Downtown', 85, '2019-12-21', 298, NULL),
('Hilton Downtown', 85, '2019-12-22', 130, NULL),
('Hilton Downtown', 85, '2019-12-23', 281, NULL),
('Hilton Downtown', 85, '2019-12-24', 252, NULL),
('Hilton Downtown', 85, '2019-12-25', 107, NULL),
('Hilton Downtown', 85, '2019-12-26', 312, NULL),
('Hilton Downtown', 85, '2019-12-27', 165, NULL),
('Hilton Downtown', 85, '2019-12-28', 118, NULL),
('Hilton Downtown', 85, '2019-12-29', 383, NULL),
('Hilton Downtown', 85, '2019-12-30', 283, NULL),
('Hilton Downtown', 85, '2019-12-31', 306, NULL),
('Hilton Downtown', 85, '2020-01-01', 360, NULL),
('Hilton Downtown', 85, '2020-01-02', 104, NULL),
('Hilton Downtown', 85, '2020-01-03', 302, NULL),
('Hilton Downtown', 85, '2020-01-04', 359, NULL),
('Hilton Downtown', 85, '2020-01-05', 275, NULL),
('Hilton Downtown', 85, '2020-01-06', 277, NULL),
('Hilton Downtown', 85, '2020-01-07', 177, NULL),
('Hilton Downtown', 85, '2020-01-08', 107, NULL),
('Hilton Downtown', 85, '2020-01-09', 166, NULL),
('Hilton Downtown', 85, '2020-01-10', 360, NULL),
('Hilton Downtown', 85, '2020-01-11', 199, NULL),
('Hilton Downtown', 85, '2020-01-12', 270, NULL),
('Hilton Downtown', 85, '2020-01-13', 356, NULL),
('Hilton Downtown', 85, '2020-01-14', 302, NULL),
('Hilton Downtown', 85, '2020-01-15', 371, NULL),
('Hilton Downtown', 85, '2020-01-16', 201, NULL),
('Hilton Downtown', 85, '2020-01-17', 322, NULL),
('Hilton Downtown', 85, '2020-01-18', 213, NULL),
('Hilton Downtown', 85, '2020-01-19', 205, NULL),
('Hilton Downtown', 85, '2020-01-20', 269, NULL),
('Hilton Downtown', 85, '2020-01-21', 236, NULL),
('Hilton Downtown', 85, '2020-01-22', 324, NULL),
('Hilton Downtown', 85, '2020-01-23', 309, NULL),
('Hilton Downtown', 85, '2020-01-24', 332, NULL),
('Hilton Downtown', 85, '2020-01-25', 399, NULL),
('Hilton Downtown', 85, '2020-01-26', 359, NULL),
('Hilton Downtown', 85, '2020-01-27', 234, NULL),
('Hilton Downtown', 85, '2020-01-28', 225, NULL),
('Hilton Downtown', 85, '2020-01-29', 175, NULL),
('Hilton Downtown', 85, '2020-01-30', 344, NULL),
('Hilton Downtown', 85, '2020-01-31', 237, NULL),
('Hilton Downtown', 85, '2020-02-01', 299, NULL),
('Hilton Downtown', 85, '2020-02-02', 290, NULL),
('Hilton Downtown', 85, '2020-02-03', 278, NULL),
('Hilton Downtown', 85, '2020-02-04', 168, NULL),
('Hilton Downtown', 95, '2019-01-01', 140, NULL),
('Hilton Downtown', 95, '2019-01-02', 125, NULL),
('Hilton Downtown', 95, '2019-01-03', 279, NULL),
('Hilton Downtown', 95, '2019-01-04', 249, NULL),
('Hilton Downtown', 95, '2019-01-05', 273, NULL),
('Hilton Downtown', 95, '2019-01-06', 248, NULL),
('Hilton Downtown', 95, '2019-01-07', 243, NULL),
('Hilton Downtown', 95, '2019-01-08', 273, NULL),
('Hilton Downtown', 95, '2019-01-09', 164, NULL),
('Hilton Downtown', 95, '2019-01-10', 331, NULL),
('Hilton Downtown', 95, '2019-01-11', 393, NULL),
('Hilton Downtown', 95, '2019-01-12', 207, NULL),
('Hilton Downtown', 95, '2019-01-13', 142, NULL),
('Hilton Downtown', 95, '2019-01-14', 247, NULL),
('Hilton Downtown', 95, '2019-01-15', 344, NULL),
('Hilton Downtown', 95, '2019-01-16', 212, NULL),
('Hilton Downtown', 95, '2019-01-17', 118, NULL),
('Hilton Downtown', 95, '2019-01-18', 329, NULL),
('Hilton Downtown', 95, '2019-01-19', 293, NULL),
('Hilton Downtown', 95, '2019-01-20', 318, NULL),
('Hilton Downtown', 95, '2019-01-21', 184, NULL),
('Hilton Downtown', 95, '2019-01-22', 232, NULL),
('Hilton Downtown', 95, '2019-01-23', 124, NULL),
('Hilton Downtown', 95, '2019-01-24', 248, NULL),
('Hilton Downtown', 95, '2019-01-25', 237, NULL),
('Hilton Downtown', 95, '2019-01-26', 351, NULL),
('Hilton Downtown', 95, '2019-01-27', 219, NULL),
('Hilton Downtown', 95, '2019-01-28', 133, NULL),
('Hilton Downtown', 95, '2019-01-29', 346, NULL),
('Hilton Downtown', 95, '2019-01-30', 172, NULL),
('Hilton Downtown', 95, '2019-01-31', 327, NULL),
('Hilton Downtown', 95, '2019-02-01', 366, NULL),
('Hilton Downtown', 95, '2019-02-02', 300, NULL),
('Hilton Downtown', 95, '2019-02-03', 354, NULL),
('Hilton Downtown', 95, '2019-02-04', 102, NULL),
('Hilton Downtown', 95, '2019-02-05', 171, NULL),
('Hilton Downtown', 95, '2019-02-06', 115, NULL),
('Hilton Downtown', 95, '2019-02-07', 217, NULL),
('Hilton Downtown', 95, '2019-02-08', 375, NULL),
('Hilton Downtown', 95, '2019-02-09', 324, NULL),
('Hilton Downtown', 95, '2019-02-10', 292, NULL),
('Hilton Downtown', 95, '2019-02-11', 397, NULL),
('Hilton Downtown', 95, '2019-02-12', 225, NULL),
('Hilton Downtown', 95, '2019-02-13', 241, NULL),
('Hilton Downtown', 95, '2019-02-14', 211, NULL),
('Hilton Downtown', 95, '2019-02-15', 172, NULL),
('Hilton Downtown', 95, '2019-02-16', 166, NULL),
('Hilton Downtown', 95, '2019-02-17', 282, NULL),
('Hilton Downtown', 95, '2019-02-18', 291, NULL),
('Hilton Downtown', 95, '2019-02-19', 344, NULL),
('Hilton Downtown', 95, '2019-02-20', 181, NULL),
('Hilton Downtown', 95, '2019-02-21', 311, NULL),
('Hilton Downtown', 95, '2019-02-22', 175, NULL),
('Hilton Downtown', 95, '2019-02-23', 135, NULL),
('Hilton Downtown', 95, '2019-02-24', 395, NULL),
('Hilton Downtown', 95, '2019-02-25', 353, NULL),
('Hilton Downtown', 95, '2019-02-26', 296, NULL),
('Hilton Downtown', 95, '2019-02-27', 114, NULL),
('Hilton Downtown', 95, '2019-02-28', 393, NULL),
('Hilton Downtown', 95, '2019-03-01', 305, NULL),
('Hilton Downtown', 95, '2019-03-02', 393, NULL),
('Hilton Downtown', 95, '2019-03-03', 294, NULL),
('Hilton Downtown', 95, '2019-03-04', 115, NULL),
('Hilton Downtown', 95, '2019-03-05', 388, NULL),
('Hilton Downtown', 95, '2019-03-06', 235, NULL),
('Hilton Downtown', 95, '2019-03-07', 248, NULL),
('Hilton Downtown', 95, '2019-03-08', 179, NULL),
('Hilton Downtown', 95, '2019-03-09', 359, NULL),
('Hilton Downtown', 95, '2019-03-10', 294, NULL),
('Hilton Downtown', 95, '2019-03-11', 108, NULL),
('Hilton Downtown', 95, '2019-03-12', 313, NULL),
('Hilton Downtown', 95, '2019-03-13', 168, NULL),
('Hilton Downtown', 95, '2019-03-14', 328, NULL),
('Hilton Downtown', 95, '2019-03-15', 259, NULL),
('Hilton Downtown', 95, '2019-03-16', 347, NULL),
('Hilton Downtown', 95, '2019-03-17', 306, NULL),
('Hilton Downtown', 95, '2019-03-18', 141, NULL),
('Hilton Downtown', 95, '2019-03-19', 213, NULL),
('Hilton Downtown', 95, '2019-03-20', 308, NULL),
('Hilton Downtown', 95, '2019-03-21', 120, NULL),
('Hilton Downtown', 95, '2019-03-22', 355, NULL),
('Hilton Downtown', 95, '2019-03-23', 158, NULL),
('Hilton Downtown', 95, '2019-03-24', 325, NULL),
('Hilton Downtown', 95, '2019-03-25', 134, NULL),
('Hilton Downtown', 95, '2019-03-26', 237, NULL),
('Hilton Downtown', 95, '2019-03-27', 234, NULL),
('Hilton Downtown', 95, '2019-03-28', 187, NULL),
('Hilton Downtown', 95, '2019-03-29', 151, NULL),
('Hilton Downtown', 95, '2019-03-30', 156, NULL),
('Hilton Downtown', 95, '2019-03-31', 169, NULL),
('Hilton Downtown', 95, '2019-04-01', 105, NULL),
('Hilton Downtown', 95, '2019-04-02', 269, NULL),
('Hilton Downtown', 95, '2019-04-03', 380, NULL),
('Hilton Downtown', 95, '2019-04-04', 319, NULL),
('Hilton Downtown', 95, '2019-04-05', 187, NULL),
('Hilton Downtown', 95, '2019-04-06', 312, NULL),
('Hilton Downtown', 95, '2019-04-07', 304, NULL),
('Hilton Downtown', 95, '2019-04-08', 125, NULL),
('Hilton Downtown', 95, '2019-04-09', 306, NULL),
('Hilton Downtown', 95, '2019-04-10', 330, NULL),
('Hilton Downtown', 95, '2019-04-11', 122, NULL),
('Hilton Downtown', 95, '2019-04-12', 273, NULL),
('Hilton Downtown', 95, '2019-04-13', 195, NULL),
('Hilton Downtown', 95, '2019-04-14', 325, NULL),
('Hilton Downtown', 95, '2019-04-15', 333, NULL),
('Hilton Downtown', 95, '2019-04-16', 117, NULL),
('Hilton Downtown', 95, '2019-04-17', 315, NULL),
('Hilton Downtown', 95, '2019-04-18', 379, NULL),
('Hilton Downtown', 95, '2019-04-19', 124, NULL),
('Hilton Downtown', 95, '2019-04-20', 150, NULL),
('Hilton Downtown', 95, '2019-04-21', 105, NULL),
('Hilton Downtown', 95, '2019-04-22', 203, NULL),
('Hilton Downtown', 95, '2019-04-23', 391, NULL),
('Hilton Downtown', 95, '2019-04-24', 155, NULL),
('Hilton Downtown', 95, '2019-04-25', 318, NULL),
('Hilton Downtown', 95, '2019-04-26', 170, NULL),
('Hilton Downtown', 95, '2019-04-27', 156, NULL),
('Hilton Downtown', 95, '2019-04-28', 165, NULL),
('Hilton Downtown', 95, '2019-04-29', 263, NULL),
('Hilton Downtown', 95, '2019-04-30', 173, NULL),
('Hilton Downtown', 95, '2019-05-01', 150, NULL),
('Hilton Downtown', 95, '2019-05-02', 242, NULL),
('Hilton Downtown', 95, '2019-05-03', 254, NULL),
('Hilton Downtown', 95, '2019-05-04', 313, NULL),
('Hilton Downtown', 95, '2019-05-05', 327, NULL),
('Hilton Downtown', 95, '2019-05-06', 151, NULL),
('Hilton Downtown', 95, '2019-05-07', 165, NULL),
('Hilton Downtown', 95, '2019-05-08', 169, NULL),
('Hilton Downtown', 95, '2019-05-09', 383, NULL),
('Hilton Downtown', 95, '2019-05-10', 272, NULL),
('Hilton Downtown', 95, '2019-05-11', 284, NULL),
('Hilton Downtown', 95, '2019-05-12', 103, NULL),
('Hilton Downtown', 95, '2019-05-13', 360, NULL),
('Hilton Downtown', 95, '2019-05-14', 313, NULL),
('Hilton Downtown', 95, '2019-05-15', 335, NULL),
('Hilton Downtown', 95, '2019-05-16', 296, NULL),
('Hilton Downtown', 95, '2019-05-17', 246, NULL),
('Hilton Downtown', 95, '2019-05-18', 247, NULL),
('Hilton Downtown', 95, '2019-05-19', 232, NULL),
('Hilton Downtown', 95, '2019-05-20', 132, NULL),
('Hilton Downtown', 95, '2019-05-21', 247, NULL),
('Hilton Downtown', 95, '2019-05-22', 142, NULL),
('Hilton Downtown', 95, '2019-05-23', 334, NULL),
('Hilton Downtown', 95, '2019-05-24', 326, NULL),
('Hilton Downtown', 95, '2019-05-25', 197, NULL),
('Hilton Downtown', 95, '2019-05-26', 351, NULL),
('Hilton Downtown', 95, '2019-05-27', 150, NULL),
('Hilton Downtown', 95, '2019-05-28', 207, NULL),
('Hilton Downtown', 95, '2019-05-29', 384, NULL),
('Hilton Downtown', 95, '2019-05-30', 166, NULL),
('Hilton Downtown', 95, '2019-05-31', 227, NULL),
('Hilton Downtown', 95, '2019-06-01', 255, NULL),
('Hilton Downtown', 95, '2019-06-02', 145, NULL),
('Hilton Downtown', 95, '2019-06-03', 163, NULL),
('Hilton Downtown', 95, '2019-06-04', 369, NULL),
('Hilton Downtown', 95, '2019-06-05', 345, NULL),
('Hilton Downtown', 95, '2019-06-06', 313, NULL),
('Hilton Downtown', 95, '2019-06-07', 113, NULL),
('Hilton Downtown', 95, '2019-06-08', 389, NULL),
('Hilton Downtown', 95, '2019-06-09', 335, NULL),
('Hilton Downtown', 95, '2019-06-10', 294, NULL),
('Hilton Downtown', 95, '2019-06-11', 108, NULL),
('Hilton Downtown', 95, '2019-06-12', 246, NULL),
('Hilton Downtown', 95, '2019-06-13', 251, NULL),
('Hilton Downtown', 95, '2019-06-14', 250, NULL),
('Hilton Downtown', 95, '2019-06-15', 295, NULL),
('Hilton Downtown', 95, '2019-06-16', 368, NULL),
('Hilton Downtown', 95, '2019-06-17', 335, NULL),
('Hilton Downtown', 95, '2019-06-18', 394, NULL),
('Hilton Downtown', 95, '2019-06-19', 390, NULL),
('Hilton Downtown', 95, '2019-06-20', 310, NULL),
('Hilton Downtown', 95, '2019-06-21', 370, NULL),
('Hilton Downtown', 95, '2019-06-22', 385, NULL),
('Hilton Downtown', 95, '2019-06-23', 203, NULL),
('Hilton Downtown', 95, '2019-06-24', 380, NULL),
('Hilton Downtown', 95, '2019-06-25', 348, NULL),
('Hilton Downtown', 95, '2019-06-26', 222, NULL),
('Hilton Downtown', 95, '2019-06-27', 174, NULL),
('Hilton Downtown', 95, '2019-06-28', 133, NULL),
('Hilton Downtown', 95, '2019-06-29', 240, NULL),
('Hilton Downtown', 95, '2019-06-30', 134, NULL),
('Hilton Downtown', 95, '2019-07-01', 366, NULL),
('Hilton Downtown', 95, '2019-07-02', 113, NULL),
('Hilton Downtown', 95, '2019-07-03', 229, NULL),
('Hilton Downtown', 95, '2019-07-04', 229, NULL),
('Hilton Downtown', 95, '2019-07-05', 241, NULL),
('Hilton Downtown', 95, '2019-07-06', 218, NULL),
('Hilton Downtown', 95, '2019-07-07', 240, NULL),
('Hilton Downtown', 95, '2019-07-08', 228, NULL),
('Hilton Downtown', 95, '2019-07-09', 198, NULL),
('Hilton Downtown', 95, '2019-07-10', 311, NULL),
('Hilton Downtown', 95, '2019-07-11', 249, NULL),
('Hilton Downtown', 95, '2019-07-12', 209, NULL),
('Hilton Downtown', 95, '2019-07-13', 117, NULL),
('Hilton Downtown', 95, '2019-07-14', 384, NULL),
('Hilton Downtown', 95, '2019-07-15', 252, NULL),
('Hilton Downtown', 95, '2019-07-16', 198, NULL),
('Hilton Downtown', 95, '2019-07-17', 197, NULL),
('Hilton Downtown', 95, '2019-07-18', 157, NULL),
('Hilton Downtown', 95, '2019-07-19', 205, NULL),
('Hilton Downtown', 95, '2019-07-20', 134, NULL),
('Hilton Downtown', 95, '2019-07-21', 114, NULL),
('Hilton Downtown', 95, '2019-07-22', 327, NULL),
('Hilton Downtown', 95, '2019-07-23', 394, NULL),
('Hilton Downtown', 95, '2019-07-24', 265, NULL),
('Hilton Downtown', 95, '2019-07-25', 204, NULL),
('Hilton Downtown', 95, '2019-07-26', 202, NULL),
('Hilton Downtown', 95, '2019-07-27', 388, NULL),
('Hilton Downtown', 95, '2019-07-28', 208, NULL),
('Hilton Downtown', 95, '2019-07-29', 241, NULL),
('Hilton Downtown', 95, '2019-07-30', 200, NULL),
('Hilton Downtown', 95, '2019-07-31', 306, NULL),
('Hilton Downtown', 95, '2019-08-01', 373, NULL),
('Hilton Downtown', 95, '2019-08-02', 326, NULL),
('Hilton Downtown', 95, '2019-08-03', 344, NULL),
('Hilton Downtown', 95, '2019-08-04', 269, NULL),
('Hilton Downtown', 95, '2019-08-05', 230, NULL),
('Hilton Downtown', 95, '2019-08-06', 314, NULL),
('Hilton Downtown', 95, '2019-08-07', 269, NULL),
('Hilton Downtown', 95, '2019-08-08', 322, NULL),
('Hilton Downtown', 95, '2019-08-09', 330, NULL),
('Hilton Downtown', 95, '2019-08-10', 237, NULL),
('Hilton Downtown', 95, '2019-08-11', 329, NULL),
('Hilton Downtown', 95, '2019-08-12', 136, NULL),
('Hilton Downtown', 95, '2019-08-13', 394, NULL),
('Hilton Downtown', 95, '2019-08-14', 317, NULL),
('Hilton Downtown', 95, '2019-08-15', 378, NULL),
('Hilton Downtown', 95, '2019-08-16', 367, NULL),
('Hilton Downtown', 95, '2019-08-17', 157, NULL),
('Hilton Downtown', 95, '2019-08-18', 165, NULL),
('Hilton Downtown', 95, '2019-08-19', 319, NULL),
('Hilton Downtown', 95, '2019-08-20', 119, NULL),
('Hilton Downtown', 95, '2019-08-21', 359, NULL),
('Hilton Downtown', 95, '2019-08-22', 345, NULL),
('Hilton Downtown', 95, '2019-08-23', 177, NULL),
('Hilton Downtown', 95, '2019-08-24', 231, NULL),
('Hilton Downtown', 95, '2019-08-25', 395, NULL),
('Hilton Downtown', 95, '2019-08-26', 185, NULL),
('Hilton Downtown', 95, '2019-08-27', 212, NULL),
('Hilton Downtown', 95, '2019-08-28', 237, NULL),
('Hilton Downtown', 95, '2019-08-29', 266, NULL),
('Hilton Downtown', 95, '2019-08-30', 254, NULL),
('Hilton Downtown', 95, '2019-08-31', 314, NULL),
('Hilton Downtown', 95, '2019-09-01', 146, NULL),
('Hilton Downtown', 95, '2019-09-02', 104, NULL),
('Hilton Downtown', 95, '2019-09-03', 393, NULL),
('Hilton Downtown', 95, '2019-09-04', 334, NULL),
('Hilton Downtown', 95, '2019-09-05', 394, NULL),
('Hilton Downtown', 95, '2019-09-06', 100, NULL),
('Hilton Downtown', 95, '2019-09-07', 332, NULL),
('Hilton Downtown', 95, '2019-09-08', 148, NULL),
('Hilton Downtown', 95, '2019-09-09', 106, NULL),
('Hilton Downtown', 95, '2019-09-10', 337, NULL),
('Hilton Downtown', 95, '2019-09-11', 190, NULL),
('Hilton Downtown', 95, '2019-09-12', 139, NULL),
('Hilton Downtown', 95, '2019-09-13', 172, NULL),
('Hilton Downtown', 95, '2019-09-14', 395, NULL),
('Hilton Downtown', 95, '2019-09-15', 253, NULL),
('Hilton Downtown', 95, '2019-09-16', 107, NULL),
('Hilton Downtown', 95, '2019-09-17', 120, NULL),
('Hilton Downtown', 95, '2019-09-18', 394, NULL),
('Hilton Downtown', 95, '2019-09-19', 231, NULL),
('Hilton Downtown', 95, '2019-09-20', 357, NULL),
('Hilton Downtown', 95, '2019-09-21', 328, NULL),
('Hilton Downtown', 95, '2019-09-22', 188, NULL),
('Hilton Downtown', 95, '2019-09-23', 234, NULL),
('Hilton Downtown', 95, '2019-09-24', 209, NULL),
('Hilton Downtown', 95, '2019-09-25', 134, NULL),
('Hilton Downtown', 95, '2019-09-26', 115, NULL),
('Hilton Downtown', 95, '2019-09-27', 271, NULL),
('Hilton Downtown', 95, '2019-09-28', 133, NULL),
('Hilton Downtown', 95, '2019-09-29', 226, NULL),
('Hilton Downtown', 95, '2019-09-30', 308, NULL),
('Hilton Downtown', 95, '2019-10-01', 354, NULL),
('Hilton Downtown', 95, '2019-10-02', 390, NULL),
('Hilton Downtown', 95, '2019-10-03', 284, NULL),
('Hilton Downtown', 95, '2019-10-04', 376, NULL),
('Hilton Downtown', 95, '2019-10-05', 356, NULL),
('Hilton Downtown', 95, '2019-10-06', 326, NULL),
('Hilton Downtown', 95, '2019-10-07', 238, NULL),
('Hilton Downtown', 95, '2019-10-08', 356, NULL),
('Hilton Downtown', 95, '2019-10-09', 260, NULL),
('Hilton Downtown', 95, '2019-10-10', 248, NULL),
('Hilton Downtown', 95, '2019-10-11', 138, NULL),
('Hilton Downtown', 95, '2019-10-12', 271, NULL),
('Hilton Downtown', 95, '2019-10-13', 373, NULL),
('Hilton Downtown', 95, '2019-10-14', 166, NULL),
('Hilton Downtown', 95, '2019-10-15', 293, NULL),
('Hilton Downtown', 95, '2019-10-16', 265, NULL),
('Hilton Downtown', 95, '2019-10-17', 283, NULL),
('Hilton Downtown', 95, '2019-10-18', 353, NULL),
('Hilton Downtown', 95, '2019-10-19', 205, NULL),
('Hilton Downtown', 95, '2019-10-20', 182, NULL),
('Hilton Downtown', 95, '2019-10-21', 270, NULL),
('Hilton Downtown', 95, '2019-10-22', 333, NULL),
('Hilton Downtown', 95, '2019-10-23', 332, NULL),
('Hilton Downtown', 95, '2019-10-24', 233, NULL),
('Hilton Downtown', 95, '2019-10-25', 100, NULL),
('Hilton Downtown', 95, '2019-10-26', 266, NULL),
('Hilton Downtown', 95, '2019-10-27', 142, NULL),
('Hilton Downtown', 95, '2019-10-28', 264, NULL),
('Hilton Downtown', 95, '2019-10-29', 117, NULL),
('Hilton Downtown', 95, '2019-10-30', 145, NULL),
('Hilton Downtown', 95, '2019-10-31', 309, NULL),
('Hilton Downtown', 95, '2019-11-01', 170, NULL),
('Hilton Downtown', 95, '2019-11-02', 305, NULL),
('Hilton Downtown', 95, '2019-11-03', 286, NULL),
('Hilton Downtown', 95, '2019-11-04', 117, NULL),
('Hilton Downtown', 95, '2019-11-05', 245, NULL),
('Hilton Downtown', 95, '2019-11-06', 241, NULL),
('Hilton Downtown', 95, '2019-11-07', 161, NULL),
('Hilton Downtown', 95, '2019-11-08', 291, NULL),
('Hilton Downtown', 95, '2019-11-09', 299, NULL),
('Hilton Downtown', 95, '2019-11-10', 354, NULL),
('Hilton Downtown', 95, '2019-11-11', 343, NULL),
('Hilton Downtown', 95, '2019-11-12', 348, NULL),
('Hilton Downtown', 95, '2019-11-13', 142, NULL),
('Hilton Downtown', 95, '2019-11-14', 186, NULL),
('Hilton Downtown', 95, '2019-11-15', 326, NULL),
('Hilton Downtown', 95, '2019-11-16', 335, NULL),
('Hilton Downtown', 95, '2019-11-17', 365, NULL),
('Hilton Downtown', 95, '2019-11-18', 162, NULL),
('Hilton Downtown', 95, '2019-11-19', 275, NULL),
('Hilton Downtown', 95, '2019-11-20', 223, NULL),
('Hilton Downtown', 95, '2019-11-21', 173, NULL),
('Hilton Downtown', 95, '2019-11-22', 318, NULL),
('Hilton Downtown', 95, '2019-11-23', 267, NULL),
('Hilton Downtown', 95, '2019-11-24', 367, NULL),
('Hilton Downtown', 95, '2019-11-25', 173, NULL),
('Hilton Downtown', 95, '2019-11-26', 326, NULL),
('Hilton Downtown', 95, '2019-11-27', 359, NULL),
('Hilton Downtown', 95, '2019-11-28', 163, NULL),
('Hilton Downtown', 95, '2019-11-29', 117, NULL),
('Hilton Downtown', 95, '2019-11-30', 394, NULL),
('Hilton Downtown', 95, '2019-12-01', 114, NULL),
('Hilton Downtown', 95, '2019-12-02', 270, NULL),
('Hilton Downtown', 95, '2019-12-03', 349, NULL),
('Hilton Downtown', 95, '2019-12-04', 282, NULL),
('Hilton Downtown', 95, '2019-12-05', 122, NULL),
('Hilton Downtown', 95, '2019-12-06', 280, NULL),
('Hilton Downtown', 95, '2019-12-07', 392, NULL),
('Hilton Downtown', 95, '2019-12-08', 266, NULL),
('Hilton Downtown', 95, '2019-12-09', 358, NULL),
('Hilton Downtown', 95, '2019-12-10', 326, NULL),
('Hilton Downtown', 95, '2019-12-11', 291, NULL),
('Hilton Downtown', 95, '2019-12-12', 289, NULL),
('Hilton Downtown', 95, '2019-12-13', 158, NULL),
('Hilton Downtown', 95, '2019-12-14', 341, NULL),
('Hilton Downtown', 95, '2019-12-15', 338, NULL),
('Hilton Downtown', 95, '2019-12-16', 203, NULL),
('Hilton Downtown', 95, '2019-12-17', 374, NULL),
('Hilton Downtown', 95, '2019-12-18', 260, NULL),
('Hilton Downtown', 95, '2019-12-19', 336, NULL),
('Hilton Downtown', 95, '2019-12-20', 255, NULL),
('Hilton Downtown', 95, '2019-12-21', 306, NULL),
('Hilton Downtown', 95, '2019-12-22', 291, NULL),
('Hilton Downtown', 95, '2019-12-23', 140, NULL),
('Hilton Downtown', 95, '2019-12-24', 285, NULL),
('Hilton Downtown', 95, '2019-12-25', 314, NULL),
('Hilton Downtown', 95, '2019-12-26', 330, NULL),
('Hilton Downtown', 95, '2019-12-27', 101, NULL),
('Hilton Downtown', 95, '2019-12-28', 220, NULL),
('Hilton Downtown', 95, '2019-12-29', 166, NULL),
('Hilton Downtown', 95, '2019-12-30', 351, NULL),
('Hilton Downtown', 95, '2019-12-31', 320, NULL),
('Hilton Downtown', 95, '2020-01-01', 300, NULL),
('Hilton Downtown', 95, '2020-01-02', 363, NULL),
('Hilton Downtown', 95, '2020-01-03', 279, NULL),
('Hilton Downtown', 95, '2020-01-04', 252, NULL),
('Hilton Downtown', 95, '2020-01-05', 339, NULL),
('Hilton Downtown', 95, '2020-01-06', 207, NULL),
('Hilton Downtown', 95, '2020-01-07', 282, NULL),
('Hilton Downtown', 95, '2020-01-08', 139, NULL),
('Hilton Downtown', 95, '2020-01-09', 259, NULL),
('Hilton Downtown', 95, '2020-01-10', 362, NULL),
('Hilton Downtown', 95, '2020-01-11', 129, NULL),
('Hilton Downtown', 95, '2020-01-12', 288, NULL),
('Hilton Downtown', 95, '2020-01-13', 302, NULL),
('Hilton Downtown', 95, '2020-01-14', 238, NULL),
('Hilton Downtown', 95, '2020-01-15', 217, NULL),
('Hilton Downtown', 95, '2020-01-16', 111, NULL),
('Hilton Downtown', 95, '2020-01-17', 271, NULL),
('Hilton Downtown', 95, '2020-01-18', 283, NULL),
('Hilton Downtown', 95, '2020-01-19', 375, NULL),
('Hilton Downtown', 95, '2020-01-20', 330, NULL),
('Hilton Downtown', 95, '2020-01-21', 298, NULL),
('Hilton Downtown', 95, '2020-01-22', 389, NULL),
('Hilton Downtown', 95, '2020-01-23', 321, NULL),
('Hilton Downtown', 95, '2020-01-24', 390, NULL),
('Hilton Downtown', 95, '2020-01-25', 297, NULL),
('Hilton Downtown', 95, '2020-01-26', 379, NULL),
('Hilton Downtown', 95, '2020-01-27', 130, NULL),
('Hilton Downtown', 95, '2020-01-28', 393, NULL),
('Hilton Downtown', 95, '2020-01-29', 206, NULL),
('Hilton Downtown', 95, '2020-01-30', 264, NULL),
('Hilton Downtown', 95, '2020-01-31', 175, NULL),
('Hilton Downtown', 95, '2020-02-01', 203, NULL),
('Hilton Downtown', 95, '2020-02-02', 108, NULL),
('Hilton Downtown', 95, '2020-02-03', 292, NULL),
('Hilton Downtown', 95, '2020-02-04', 312, NULL),
('Hilton Downtown', 98, '2019-01-01', 163, NULL),
('Hilton Downtown', 98, '2019-01-02', 124, NULL),
('Hilton Downtown', 98, '2019-01-03', 204, NULL),
('Hilton Downtown', 98, '2019-01-04', 254, NULL),
('Hilton Downtown', 98, '2019-01-05', 208, NULL),
('Hilton Downtown', 98, '2019-01-06', 303, NULL),
('Hilton Downtown', 98, '2019-01-07', 379, NULL),
('Hilton Downtown', 98, '2019-01-08', 315, NULL),
('Hilton Downtown', 98, '2019-01-09', 193, NULL),
('Hilton Downtown', 98, '2019-01-10', 262, NULL),
('Hilton Downtown', 98, '2019-01-11', 255, NULL),
('Hilton Downtown', 98, '2019-01-12', 147, NULL),
('Hilton Downtown', 98, '2019-01-13', 342, NULL),
('Hilton Downtown', 98, '2019-01-14', 228, NULL),
('Hilton Downtown', 98, '2019-01-15', 377, NULL),
('Hilton Downtown', 98, '2019-01-16', 395, NULL),
('Hilton Downtown', 98, '2019-01-17', 264, NULL),
('Hilton Downtown', 98, '2019-01-18', 126, NULL),
('Hilton Downtown', 98, '2019-01-19', 223, NULL),
('Hilton Downtown', 98, '2019-01-20', 265, NULL),
('Hilton Downtown', 98, '2019-01-21', 123, NULL),
('Hilton Downtown', 98, '2019-01-22', 390, NULL),
('Hilton Downtown', 98, '2019-01-23', 215, NULL),
('Hilton Downtown', 98, '2019-01-24', 288, NULL),
('Hilton Downtown', 98, '2019-01-25', 317, NULL),
('Hilton Downtown', 98, '2019-01-26', 363, NULL),
('Hilton Downtown', 98, '2019-01-27', 256, NULL),
('Hilton Downtown', 98, '2019-01-28', 251, NULL),
('Hilton Downtown', 98, '2019-01-29', 229, NULL),
('Hilton Downtown', 98, '2019-01-30', 280, NULL),
('Hilton Downtown', 98, '2019-01-31', 348, NULL),
('Hilton Downtown', 98, '2019-02-01', 190, NULL),
('Hilton Downtown', 98, '2019-02-02', 348, NULL),
('Hilton Downtown', 98, '2019-02-03', 228, NULL),
('Hilton Downtown', 98, '2019-02-04', 391, NULL),
('Hilton Downtown', 98, '2019-02-05', 363, NULL),
('Hilton Downtown', 98, '2019-02-06', 252, NULL),
('Hilton Downtown', 98, '2019-02-07', 252, NULL),
('Hilton Downtown', 98, '2019-02-08', 330, NULL),
('Hilton Downtown', 98, '2019-02-09', 316, NULL),
('Hilton Downtown', 98, '2019-02-10', 337, NULL),
('Hilton Downtown', 98, '2019-02-11', 388, NULL),
('Hilton Downtown', 98, '2019-02-12', 180, NULL),
('Hilton Downtown', 98, '2019-02-13', 234, NULL),
('Hilton Downtown', 98, '2019-02-14', 112, NULL),
('Hilton Downtown', 98, '2019-02-15', 398, NULL),
('Hilton Downtown', 98, '2019-02-16', 119, NULL),
('Hilton Downtown', 98, '2019-02-17', 134, NULL),
('Hilton Downtown', 98, '2019-02-18', 159, NULL),
('Hilton Downtown', 98, '2019-02-19', 101, NULL),
('Hilton Downtown', 98, '2019-02-20', 381, NULL),
('Hilton Downtown', 98, '2019-02-21', 191, NULL),
('Hilton Downtown', 98, '2019-02-22', 293, NULL),
('Hilton Downtown', 98, '2019-02-23', 171, NULL),
('Hilton Downtown', 98, '2019-02-24', 140, NULL),
('Hilton Downtown', 98, '2019-02-25', 375, NULL),
('Hilton Downtown', 98, '2019-02-26', 385, NULL),
('Hilton Downtown', 98, '2019-02-27', 286, NULL),
('Hilton Downtown', 98, '2019-02-28', 105, NULL),
('Hilton Downtown', 98, '2019-03-01', 398, NULL),
('Hilton Downtown', 98, '2019-03-02', 393, NULL),
('Hilton Downtown', 98, '2019-03-03', 207, NULL),
('Hilton Downtown', 98, '2019-03-04', 278, NULL),
('Hilton Downtown', 98, '2019-03-05', 252, NULL),
('Hilton Downtown', 98, '2019-03-06', 132, NULL),
('Hilton Downtown', 98, '2019-03-07', 172, NULL),
('Hilton Downtown', 98, '2019-03-08', 306, NULL),
('Hilton Downtown', 98, '2019-03-09', 324, NULL),
('Hilton Downtown', 98, '2019-03-10', 289, NULL),
('Hilton Downtown', 98, '2019-03-11', 174, NULL),
('Hilton Downtown', 98, '2019-03-12', 204, NULL),
('Hilton Downtown', 98, '2019-03-13', 101, NULL),
('Hilton Downtown', 98, '2019-03-14', 151, NULL),
('Hilton Downtown', 98, '2019-03-15', 243, NULL),
('Hilton Downtown', 98, '2019-03-16', 267, NULL),
('Hilton Downtown', 98, '2019-03-17', 358, NULL),
('Hilton Downtown', 98, '2019-03-18', 360, NULL),
('Hilton Downtown', 98, '2019-03-19', 158, NULL),
('Hilton Downtown', 98, '2019-03-20', 158, NULL),
('Hilton Downtown', 98, '2019-03-21', 393, NULL),
('Hilton Downtown', 98, '2019-03-22', 139, NULL),
('Hilton Downtown', 98, '2019-03-23', 294, NULL),
('Hilton Downtown', 98, '2019-03-24', 307, NULL),
('Hilton Downtown', 98, '2019-03-25', 179, NULL),
('Hilton Downtown', 98, '2019-03-26', 107, NULL),
('Hilton Downtown', 98, '2019-03-27', 135, NULL),
('Hilton Downtown', 98, '2019-03-28', 134, NULL),
('Hilton Downtown', 98, '2019-03-29', 364, NULL),
('Hilton Downtown', 98, '2019-03-30', 198, NULL),
('Hilton Downtown', 98, '2019-03-31', 262, NULL),
('Hilton Downtown', 98, '2019-04-01', 269, NULL),
('Hilton Downtown', 98, '2019-04-02', 102, NULL),
('Hilton Downtown', 98, '2019-04-03', 356, NULL),
('Hilton Downtown', 98, '2019-04-04', 342, NULL),
('Hilton Downtown', 98, '2019-04-05', 240, NULL),
('Hilton Downtown', 98, '2019-04-06', 199, NULL),
('Hilton Downtown', 98, '2019-04-07', 145, NULL),
('Hilton Downtown', 98, '2019-04-08', 213, NULL),
('Hilton Downtown', 98, '2019-04-09', 326, NULL),
('Hilton Downtown', 98, '2019-04-10', 204, NULL),
('Hilton Downtown', 98, '2019-04-11', 306, NULL),
('Hilton Downtown', 98, '2019-04-12', 349, NULL),
('Hilton Downtown', 98, '2019-04-13', 116, NULL),
('Hilton Downtown', 98, '2019-04-14', 338, NULL),
('Hilton Downtown', 98, '2019-04-15', 222, NULL),
('Hilton Downtown', 98, '2019-04-16', 354, NULL),
('Hilton Downtown', 98, '2019-04-17', 175, NULL),
('Hilton Downtown', 98, '2019-04-18', 353, NULL),
('Hilton Downtown', 98, '2019-04-19', 159, NULL),
('Hilton Downtown', 98, '2019-04-20', 179, NULL),
('Hilton Downtown', 98, '2019-04-21', 224, NULL),
('Hilton Downtown', 98, '2019-04-22', 262, NULL),
('Hilton Downtown', 98, '2019-04-23', 366, NULL),
('Hilton Downtown', 98, '2019-04-24', 293, NULL),
('Hilton Downtown', 98, '2019-04-25', 347, NULL),
('Hilton Downtown', 98, '2019-04-26', 229, NULL),
('Hilton Downtown', 98, '2019-04-27', 271, NULL),
('Hilton Downtown', 98, '2019-04-28', 132, NULL),
('Hilton Downtown', 98, '2019-04-29', 285, NULL),
('Hilton Downtown', 98, '2019-04-30', 144, NULL),
('Hilton Downtown', 98, '2019-05-01', 140, NULL),
('Hilton Downtown', 98, '2019-05-02', 348, NULL),
('Hilton Downtown', 98, '2019-05-03', 353, NULL),
('Hilton Downtown', 98, '2019-05-04', 267, NULL),
('Hilton Downtown', 98, '2019-05-05', 179, NULL),
('Hilton Downtown', 98, '2019-05-06', 300, NULL),
('Hilton Downtown', 98, '2019-05-07', 285, NULL),
('Hilton Downtown', 98, '2019-05-08', 178, NULL),
('Hilton Downtown', 98, '2019-05-09', 137, NULL),
('Hilton Downtown', 98, '2019-05-10', 386, NULL),
('Hilton Downtown', 98, '2019-05-11', 251, NULL),
('Hilton Downtown', 98, '2019-05-12', 170, NULL),
('Hilton Downtown', 98, '2019-05-13', 391, NULL),
('Hilton Downtown', 98, '2019-05-14', 215, NULL),
('Hilton Downtown', 98, '2019-05-15', 286, NULL),
('Hilton Downtown', 98, '2019-05-16', 104, NULL),
('Hilton Downtown', 98, '2019-05-17', 238, NULL),
('Hilton Downtown', 98, '2019-05-18', 296, NULL),
('Hilton Downtown', 98, '2019-05-19', 161, NULL),
('Hilton Downtown', 98, '2019-05-20', 257, NULL),
('Hilton Downtown', 98, '2019-05-21', 303, NULL),
('Hilton Downtown', 98, '2019-05-22', 130, NULL),
('Hilton Downtown', 98, '2019-05-23', 350, NULL),
('Hilton Downtown', 98, '2019-05-24', 367, NULL),
('Hilton Downtown', 98, '2019-05-25', 196, NULL),
('Hilton Downtown', 98, '2019-05-26', 142, NULL),
('Hilton Downtown', 98, '2019-05-27', 184, NULL),
('Hilton Downtown', 98, '2019-05-28', 178, NULL),
('Hilton Downtown', 98, '2019-05-29', 362, NULL),
('Hilton Downtown', 98, '2019-05-30', 303, NULL),
('Hilton Downtown', 98, '2019-05-31', 116, NULL),
('Hilton Downtown', 98, '2019-06-01', 338, NULL),
('Hilton Downtown', 98, '2019-06-02', 173, NULL),
('Hilton Downtown', 98, '2019-06-03', 139, NULL),
('Hilton Downtown', 98, '2019-06-04', 339, NULL),
('Hilton Downtown', 98, '2019-06-05', 270, NULL),
('Hilton Downtown', 98, '2019-06-06', 310, NULL),
('Hilton Downtown', 98, '2019-06-07', 162, NULL),
('Hilton Downtown', 98, '2019-06-08', 377, NULL),
('Hilton Downtown', 98, '2019-06-09', 103, NULL),
('Hilton Downtown', 98, '2019-06-10', 360, NULL),
('Hilton Downtown', 98, '2019-06-11', 105, NULL),
('Hilton Downtown', 98, '2019-06-12', 123, NULL),
('Hilton Downtown', 98, '2019-06-13', 354, NULL),
('Hilton Downtown', 98, '2019-06-14', 321, NULL),
('Hilton Downtown', 98, '2019-06-15', 272, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 98, '2019-06-16', 257, NULL),
('Hilton Downtown', 98, '2019-06-17', 328, NULL),
('Hilton Downtown', 98, '2019-06-18', 112, NULL),
('Hilton Downtown', 98, '2019-06-19', 180, NULL),
('Hilton Downtown', 98, '2019-06-20', 292, NULL),
('Hilton Downtown', 98, '2019-06-21', 138, NULL),
('Hilton Downtown', 98, '2019-06-22', 244, NULL),
('Hilton Downtown', 98, '2019-06-23', 283, NULL),
('Hilton Downtown', 98, '2019-06-24', 329, NULL),
('Hilton Downtown', 98, '2019-06-25', 342, NULL),
('Hilton Downtown', 98, '2019-06-26', 277, NULL),
('Hilton Downtown', 98, '2019-06-27', 124, NULL),
('Hilton Downtown', 98, '2019-06-28', 331, NULL),
('Hilton Downtown', 98, '2019-06-29', 154, NULL),
('Hilton Downtown', 98, '2019-06-30', 153, NULL),
('Hilton Downtown', 98, '2019-07-01', 382, NULL),
('Hilton Downtown', 98, '2019-07-02', 172, NULL),
('Hilton Downtown', 98, '2019-07-03', 246, NULL),
('Hilton Downtown', 98, '2019-07-04', 231, NULL),
('Hilton Downtown', 98, '2019-07-05', 158, NULL),
('Hilton Downtown', 98, '2019-07-06', 267, NULL),
('Hilton Downtown', 98, '2019-07-07', 206, NULL),
('Hilton Downtown', 98, '2019-07-08', 281, NULL),
('Hilton Downtown', 98, '2019-07-09', 393, NULL),
('Hilton Downtown', 98, '2019-07-10', 214, NULL),
('Hilton Downtown', 98, '2019-07-11', 158, NULL),
('Hilton Downtown', 98, '2019-07-12', 327, NULL),
('Hilton Downtown', 98, '2019-07-13', 322, NULL),
('Hilton Downtown', 98, '2019-07-14', 348, NULL),
('Hilton Downtown', 98, '2019-07-15', 319, NULL),
('Hilton Downtown', 98, '2019-07-16', 108, NULL),
('Hilton Downtown', 98, '2019-07-17', 385, NULL),
('Hilton Downtown', 98, '2019-07-18', 319, NULL),
('Hilton Downtown', 98, '2019-07-19', 285, NULL),
('Hilton Downtown', 98, '2019-07-20', 158, NULL),
('Hilton Downtown', 98, '2019-07-21', 170, NULL),
('Hilton Downtown', 98, '2019-07-22', 207, NULL),
('Hilton Downtown', 98, '2019-07-23', 206, NULL),
('Hilton Downtown', 98, '2019-07-24', 174, NULL),
('Hilton Downtown', 98, '2019-07-25', 371, NULL),
('Hilton Downtown', 98, '2019-07-26', 164, NULL),
('Hilton Downtown', 98, '2019-07-27', 273, NULL),
('Hilton Downtown', 98, '2019-07-28', 137, NULL),
('Hilton Downtown', 98, '2019-07-29', 274, NULL),
('Hilton Downtown', 98, '2019-07-30', 143, NULL),
('Hilton Downtown', 98, '2019-07-31', 165, NULL),
('Hilton Downtown', 98, '2019-08-01', 295, NULL),
('Hilton Downtown', 98, '2019-08-02', 324, NULL),
('Hilton Downtown', 98, '2019-08-03', 146, NULL),
('Hilton Downtown', 98, '2019-08-04', 376, NULL),
('Hilton Downtown', 98, '2019-08-05', 100, NULL),
('Hilton Downtown', 98, '2019-08-06', 134, NULL),
('Hilton Downtown', 98, '2019-08-07', 129, NULL),
('Hilton Downtown', 98, '2019-08-08', 211, NULL),
('Hilton Downtown', 98, '2019-08-09', 170, NULL),
('Hilton Downtown', 98, '2019-08-10', 283, NULL),
('Hilton Downtown', 98, '2019-08-11', 254, NULL),
('Hilton Downtown', 98, '2019-08-12', 180, NULL),
('Hilton Downtown', 98, '2019-08-13', 248, NULL),
('Hilton Downtown', 98, '2019-08-14', 233, NULL),
('Hilton Downtown', 98, '2019-08-15', 315, NULL),
('Hilton Downtown', 98, '2019-08-16', 338, NULL),
('Hilton Downtown', 98, '2019-08-17', 173, NULL),
('Hilton Downtown', 98, '2019-08-18', 226, NULL),
('Hilton Downtown', 98, '2019-08-19', 165, NULL),
('Hilton Downtown', 98, '2019-08-20', 164, NULL),
('Hilton Downtown', 98, '2019-08-21', 350, NULL),
('Hilton Downtown', 98, '2019-08-22', 113, NULL),
('Hilton Downtown', 98, '2019-08-23', 301, NULL),
('Hilton Downtown', 98, '2019-08-24', 127, NULL),
('Hilton Downtown', 98, '2019-08-25', 216, NULL),
('Hilton Downtown', 98, '2019-08-26', 147, NULL),
('Hilton Downtown', 98, '2019-08-27', 118, NULL),
('Hilton Downtown', 98, '2019-08-28', 357, NULL),
('Hilton Downtown', 98, '2019-08-29', 314, NULL),
('Hilton Downtown', 98, '2019-08-30', 357, NULL),
('Hilton Downtown', 98, '2019-08-31', 242, NULL),
('Hilton Downtown', 98, '2019-09-01', 208, NULL),
('Hilton Downtown', 98, '2019-09-02', 278, NULL),
('Hilton Downtown', 98, '2019-09-03', 129, NULL),
('Hilton Downtown', 98, '2019-09-04', 256, NULL),
('Hilton Downtown', 98, '2019-09-05', 237, NULL),
('Hilton Downtown', 98, '2019-09-06', 372, NULL),
('Hilton Downtown', 98, '2019-09-07', 173, NULL),
('Hilton Downtown', 98, '2019-09-08', 310, NULL),
('Hilton Downtown', 98, '2019-09-09', 158, NULL),
('Hilton Downtown', 98, '2019-09-10', 230, NULL),
('Hilton Downtown', 98, '2019-09-11', 390, NULL),
('Hilton Downtown', 98, '2019-09-12', 264, NULL),
('Hilton Downtown', 98, '2019-09-13', 122, NULL),
('Hilton Downtown', 98, '2019-09-14', 123, NULL),
('Hilton Downtown', 98, '2019-09-15', 263, NULL),
('Hilton Downtown', 98, '2019-09-16', 296, NULL),
('Hilton Downtown', 98, '2019-09-17', 218, NULL),
('Hilton Downtown', 98, '2019-09-18', 117, NULL),
('Hilton Downtown', 98, '2019-09-19', 274, NULL),
('Hilton Downtown', 98, '2019-09-20', 209, NULL),
('Hilton Downtown', 98, '2019-09-21', 124, NULL),
('Hilton Downtown', 98, '2019-09-22', 201, NULL),
('Hilton Downtown', 98, '2019-09-23', 144, NULL),
('Hilton Downtown', 98, '2019-09-24', 210, NULL),
('Hilton Downtown', 98, '2019-09-25', 267, NULL),
('Hilton Downtown', 98, '2019-09-26', 317, NULL),
('Hilton Downtown', 98, '2019-09-27', 359, NULL),
('Hilton Downtown', 98, '2019-09-28', 179, NULL),
('Hilton Downtown', 98, '2019-09-29', 102, NULL),
('Hilton Downtown', 98, '2019-09-30', 331, NULL),
('Hilton Downtown', 98, '2019-10-01', 127, NULL),
('Hilton Downtown', 98, '2019-10-02', 269, NULL),
('Hilton Downtown', 98, '2019-10-03', 319, NULL),
('Hilton Downtown', 98, '2019-10-04', 226, NULL),
('Hilton Downtown', 98, '2019-10-05', 386, NULL),
('Hilton Downtown', 98, '2019-10-06', 289, NULL),
('Hilton Downtown', 98, '2019-10-07', 142, NULL),
('Hilton Downtown', 98, '2019-10-08', 390, NULL),
('Hilton Downtown', 98, '2019-10-09', 370, NULL),
('Hilton Downtown', 98, '2019-10-10', 272, NULL),
('Hilton Downtown', 98, '2019-10-11', 323, NULL),
('Hilton Downtown', 98, '2019-10-12', 375, NULL),
('Hilton Downtown', 98, '2019-10-13', 298, NULL),
('Hilton Downtown', 98, '2019-10-14', 337, NULL),
('Hilton Downtown', 98, '2019-10-15', 261, NULL),
('Hilton Downtown', 98, '2019-10-16', 269, NULL),
('Hilton Downtown', 98, '2019-10-17', 245, NULL),
('Hilton Downtown', 98, '2019-10-18', 118, NULL),
('Hilton Downtown', 98, '2019-10-19', 248, NULL),
('Hilton Downtown', 98, '2019-10-20', 294, NULL),
('Hilton Downtown', 98, '2019-10-21', 274, NULL),
('Hilton Downtown', 98, '2019-10-22', 195, NULL),
('Hilton Downtown', 98, '2019-10-23', 107, NULL),
('Hilton Downtown', 98, '2019-10-24', 390, NULL),
('Hilton Downtown', 98, '2019-10-25', 374, NULL),
('Hilton Downtown', 98, '2019-10-26', 350, NULL),
('Hilton Downtown', 98, '2019-10-27', 211, NULL),
('Hilton Downtown', 98, '2019-10-28', 228, NULL),
('Hilton Downtown', 98, '2019-10-29', 287, NULL),
('Hilton Downtown', 98, '2019-10-30', 391, NULL),
('Hilton Downtown', 98, '2019-10-31', 195, NULL),
('Hilton Downtown', 98, '2019-11-01', 312, NULL),
('Hilton Downtown', 98, '2019-11-02', 244, NULL),
('Hilton Downtown', 98, '2019-11-03', 382, NULL),
('Hilton Downtown', 98, '2019-11-04', 141, NULL),
('Hilton Downtown', 98, '2019-11-05', 167, NULL),
('Hilton Downtown', 98, '2019-11-06', 168, NULL),
('Hilton Downtown', 98, '2019-11-07', 361, NULL),
('Hilton Downtown', 98, '2019-11-08', 348, NULL),
('Hilton Downtown', 98, '2019-11-09', 343, NULL),
('Hilton Downtown', 98, '2019-11-10', 275, NULL),
('Hilton Downtown', 98, '2019-11-11', 347, NULL),
('Hilton Downtown', 98, '2019-11-12', 180, NULL),
('Hilton Downtown', 98, '2019-11-13', 283, NULL),
('Hilton Downtown', 98, '2019-11-14', 180, NULL),
('Hilton Downtown', 98, '2019-11-15', 171, NULL),
('Hilton Downtown', 98, '2019-11-16', 151, NULL),
('Hilton Downtown', 98, '2019-11-17', 227, NULL),
('Hilton Downtown', 98, '2019-11-18', 380, NULL),
('Hilton Downtown', 98, '2019-11-19', 174, NULL),
('Hilton Downtown', 98, '2019-11-20', 100, NULL),
('Hilton Downtown', 98, '2019-11-21', 120, NULL),
('Hilton Downtown', 98, '2019-11-22', 157, NULL),
('Hilton Downtown', 98, '2019-11-23', 291, NULL),
('Hilton Downtown', 98, '2019-11-24', 105, NULL),
('Hilton Downtown', 98, '2019-11-25', 352, NULL),
('Hilton Downtown', 98, '2019-11-26', 157, NULL),
('Hilton Downtown', 98, '2019-11-27', 268, NULL),
('Hilton Downtown', 98, '2019-11-28', 273, NULL),
('Hilton Downtown', 98, '2019-11-29', 153, NULL),
('Hilton Downtown', 98, '2019-11-30', 361, NULL),
('Hilton Downtown', 98, '2019-12-01', 284, NULL),
('Hilton Downtown', 98, '2019-12-02', 184, NULL),
('Hilton Downtown', 98, '2019-12-03', 300, NULL),
('Hilton Downtown', 98, '2019-12-04', 219, NULL),
('Hilton Downtown', 98, '2019-12-05', 275, NULL),
('Hilton Downtown', 98, '2019-12-06', 230, NULL),
('Hilton Downtown', 98, '2019-12-07', 340, NULL),
('Hilton Downtown', 98, '2019-12-08', 367, NULL),
('Hilton Downtown', 98, '2019-12-09', 316, NULL),
('Hilton Downtown', 98, '2019-12-10', 239, NULL),
('Hilton Downtown', 98, '2019-12-11', 398, NULL),
('Hilton Downtown', 98, '2019-12-12', 302, NULL),
('Hilton Downtown', 98, '2019-12-13', 397, NULL),
('Hilton Downtown', 98, '2019-12-14', 379, NULL),
('Hilton Downtown', 98, '2019-12-15', 356, NULL),
('Hilton Downtown', 98, '2019-12-16', 351, NULL),
('Hilton Downtown', 98, '2019-12-17', 193, NULL),
('Hilton Downtown', 98, '2019-12-18', 236, NULL),
('Hilton Downtown', 98, '2019-12-19', 278, NULL),
('Hilton Downtown', 98, '2019-12-20', 111, NULL),
('Hilton Downtown', 98, '2019-12-21', 237, NULL),
('Hilton Downtown', 98, '2019-12-22', 368, NULL),
('Hilton Downtown', 98, '2019-12-23', 357, NULL),
('Hilton Downtown', 98, '2019-12-24', 270, NULL),
('Hilton Downtown', 98, '2019-12-25', 250, NULL),
('Hilton Downtown', 98, '2019-12-26', 314, NULL),
('Hilton Downtown', 98, '2019-12-27', 211, NULL),
('Hilton Downtown', 98, '2019-12-28', 345, NULL),
('Hilton Downtown', 98, '2019-12-29', 181, NULL),
('Hilton Downtown', 98, '2019-12-30', 206, NULL),
('Hilton Downtown', 98, '2019-12-31', 284, NULL),
('Hilton Downtown', 98, '2020-01-01', 320, NULL),
('Hilton Downtown', 98, '2020-01-02', 202, NULL),
('Hilton Downtown', 98, '2020-01-03', 388, NULL),
('Hilton Downtown', 98, '2020-01-04', 384, NULL),
('Hilton Downtown', 98, '2020-01-05', 171, NULL),
('Hilton Downtown', 98, '2020-01-06', 104, NULL),
('Hilton Downtown', 98, '2020-01-07', 177, NULL),
('Hilton Downtown', 98, '2020-01-08', 278, NULL),
('Hilton Downtown', 98, '2020-01-09', 397, NULL),
('Hilton Downtown', 98, '2020-01-10', 334, NULL),
('Hilton Downtown', 98, '2020-01-11', 247, NULL),
('Hilton Downtown', 98, '2020-01-12', 231, NULL),
('Hilton Downtown', 98, '2020-01-13', 341, NULL),
('Hilton Downtown', 98, '2020-01-14', 185, NULL),
('Hilton Downtown', 98, '2020-01-15', 171, NULL),
('Hilton Downtown', 98, '2020-01-16', 152, NULL),
('Hilton Downtown', 98, '2020-01-17', 290, NULL),
('Hilton Downtown', 98, '2020-01-18', 375, NULL),
('Hilton Downtown', 98, '2020-01-19', 262, NULL),
('Hilton Downtown', 98, '2020-01-20', 144, NULL),
('Hilton Downtown', 98, '2020-01-21', 384, NULL),
('Hilton Downtown', 98, '2020-01-22', 276, NULL),
('Hilton Downtown', 98, '2020-01-23', 279, NULL),
('Hilton Downtown', 98, '2020-01-24', 254, NULL),
('Hilton Downtown', 98, '2020-01-25', 189, NULL),
('Hilton Downtown', 98, '2020-01-26', 117, NULL),
('Hilton Downtown', 98, '2020-01-27', 150, NULL),
('Hilton Downtown', 98, '2020-01-28', 291, NULL),
('Hilton Downtown', 98, '2020-01-29', 104, NULL),
('Hilton Downtown', 98, '2020-01-30', 188, NULL),
('Hilton Downtown', 98, '2020-01-31', 368, NULL),
('Hilton Downtown', 98, '2020-02-01', 317, NULL),
('Hilton Downtown', 98, '2020-02-02', 168, NULL),
('Hilton Downtown', 98, '2020-02-03', 225, NULL),
('Hilton Downtown', 98, '2020-02-04', 359, NULL),
('Hilton Downtown', 103, '2019-01-01', 295, NULL),
('Hilton Downtown', 103, '2019-01-02', 146, NULL),
('Hilton Downtown', 103, '2019-01-03', 385, NULL),
('Hilton Downtown', 103, '2019-01-04', 124, NULL),
('Hilton Downtown', 103, '2019-01-05', 122, NULL),
('Hilton Downtown', 103, '2019-01-06', 373, NULL),
('Hilton Downtown', 103, '2019-01-07', 168, NULL),
('Hilton Downtown', 103, '2019-01-08', 356, NULL),
('Hilton Downtown', 103, '2019-01-09', 371, NULL),
('Hilton Downtown', 103, '2019-01-10', 220, NULL),
('Hilton Downtown', 103, '2019-01-11', 296, NULL),
('Hilton Downtown', 103, '2019-01-12', 317, NULL),
('Hilton Downtown', 103, '2019-01-13', 285, NULL),
('Hilton Downtown', 103, '2019-01-14', 296, NULL),
('Hilton Downtown', 103, '2019-01-15', 153, NULL),
('Hilton Downtown', 103, '2019-01-16', 342, NULL),
('Hilton Downtown', 103, '2019-01-17', 267, NULL),
('Hilton Downtown', 103, '2019-01-18', 143, NULL),
('Hilton Downtown', 103, '2019-01-19', 136, NULL),
('Hilton Downtown', 103, '2019-01-20', 274, NULL),
('Hilton Downtown', 103, '2019-01-21', 263, NULL),
('Hilton Downtown', 103, '2019-01-22', 252, NULL),
('Hilton Downtown', 103, '2019-01-23', 304, NULL),
('Hilton Downtown', 103, '2019-01-24', 295, NULL),
('Hilton Downtown', 103, '2019-01-25', 177, NULL),
('Hilton Downtown', 103, '2019-01-26', 363, NULL),
('Hilton Downtown', 103, '2019-01-27', 222, NULL),
('Hilton Downtown', 103, '2019-01-28', 156, NULL),
('Hilton Downtown', 103, '2019-01-29', 305, NULL),
('Hilton Downtown', 103, '2019-01-30', 186, NULL),
('Hilton Downtown', 103, '2019-01-31', 359, NULL),
('Hilton Downtown', 103, '2019-02-01', 356, NULL),
('Hilton Downtown', 103, '2019-02-02', 140, NULL),
('Hilton Downtown', 103, '2019-02-03', 276, NULL),
('Hilton Downtown', 103, '2019-02-04', 351, NULL),
('Hilton Downtown', 103, '2019-02-05', 302, NULL),
('Hilton Downtown', 103, '2019-02-06', 214, NULL),
('Hilton Downtown', 103, '2019-02-07', 209, NULL),
('Hilton Downtown', 103, '2019-02-08', 123, NULL),
('Hilton Downtown', 103, '2019-02-09', 207, NULL),
('Hilton Downtown', 103, '2019-02-10', 113, NULL),
('Hilton Downtown', 103, '2019-02-11', 352, NULL),
('Hilton Downtown', 103, '2019-02-12', 125, NULL),
('Hilton Downtown', 103, '2019-02-13', 346, NULL),
('Hilton Downtown', 103, '2019-02-14', 125, NULL),
('Hilton Downtown', 103, '2019-02-15', 177, NULL),
('Hilton Downtown', 103, '2019-02-16', 296, NULL),
('Hilton Downtown', 103, '2019-02-17', 325, NULL),
('Hilton Downtown', 103, '2019-02-18', 122, NULL),
('Hilton Downtown', 103, '2019-02-19', 271, NULL),
('Hilton Downtown', 103, '2019-02-20', 363, NULL),
('Hilton Downtown', 103, '2019-02-21', 221, NULL),
('Hilton Downtown', 103, '2019-02-22', 238, NULL),
('Hilton Downtown', 103, '2019-02-23', 349, NULL),
('Hilton Downtown', 103, '2019-02-24', 316, NULL),
('Hilton Downtown', 103, '2019-02-25', 114, NULL),
('Hilton Downtown', 103, '2019-02-26', 339, NULL),
('Hilton Downtown', 103, '2019-02-27', 391, NULL),
('Hilton Downtown', 103, '2019-02-28', 150, NULL),
('Hilton Downtown', 103, '2019-03-01', 374, NULL),
('Hilton Downtown', 103, '2019-03-02', 388, NULL),
('Hilton Downtown', 103, '2019-03-03', 354, NULL),
('Hilton Downtown', 103, '2019-03-04', 343, NULL),
('Hilton Downtown', 103, '2019-03-05', 294, NULL),
('Hilton Downtown', 103, '2019-03-06', 155, NULL),
('Hilton Downtown', 103, '2019-03-07', 315, NULL),
('Hilton Downtown', 103, '2019-03-08', 295, NULL),
('Hilton Downtown', 103, '2019-03-09', 144, NULL),
('Hilton Downtown', 103, '2019-03-10', 164, NULL),
('Hilton Downtown', 103, '2019-03-11', 144, NULL),
('Hilton Downtown', 103, '2019-03-12', 280, NULL),
('Hilton Downtown', 103, '2019-03-13', 201, NULL),
('Hilton Downtown', 103, '2019-03-14', 271, NULL),
('Hilton Downtown', 103, '2019-03-15', 339, NULL),
('Hilton Downtown', 103, '2019-03-16', 194, NULL),
('Hilton Downtown', 103, '2019-03-17', 172, NULL),
('Hilton Downtown', 103, '2019-03-18', 377, NULL),
('Hilton Downtown', 103, '2019-03-19', 352, NULL),
('Hilton Downtown', 103, '2019-03-20', 367, NULL),
('Hilton Downtown', 103, '2019-03-21', 307, NULL),
('Hilton Downtown', 103, '2019-03-22', 133, NULL),
('Hilton Downtown', 103, '2019-03-23', 299, NULL),
('Hilton Downtown', 103, '2019-03-24', 162, NULL),
('Hilton Downtown', 103, '2019-03-25', 392, NULL),
('Hilton Downtown', 103, '2019-03-26', 327, NULL),
('Hilton Downtown', 103, '2019-03-27', 174, NULL),
('Hilton Downtown', 103, '2019-03-28', 309, NULL),
('Hilton Downtown', 103, '2019-03-29', 369, NULL),
('Hilton Downtown', 103, '2019-03-30', 119, NULL),
('Hilton Downtown', 103, '2019-03-31', 103, NULL),
('Hilton Downtown', 103, '2019-04-01', 332, NULL),
('Hilton Downtown', 103, '2019-04-02', 203, NULL),
('Hilton Downtown', 103, '2019-04-03', 242, NULL),
('Hilton Downtown', 103, '2019-04-04', 354, NULL),
('Hilton Downtown', 103, '2019-04-05', 237, NULL),
('Hilton Downtown', 103, '2019-04-06', 259, NULL),
('Hilton Downtown', 103, '2019-04-07', 315, NULL),
('Hilton Downtown', 103, '2019-04-08', 288, NULL),
('Hilton Downtown', 103, '2019-04-09', 310, NULL),
('Hilton Downtown', 103, '2019-04-10', 231, NULL),
('Hilton Downtown', 103, '2019-04-11', 162, NULL),
('Hilton Downtown', 103, '2019-04-12', 226, NULL),
('Hilton Downtown', 103, '2019-04-13', 198, NULL),
('Hilton Downtown', 103, '2019-04-14', 318, NULL),
('Hilton Downtown', 103, '2019-04-15', 312, NULL),
('Hilton Downtown', 103, '2019-04-16', 117, NULL),
('Hilton Downtown', 103, '2019-04-17', 129, NULL),
('Hilton Downtown', 103, '2019-04-18', 226, NULL),
('Hilton Downtown', 103, '2019-04-19', 326, NULL),
('Hilton Downtown', 103, '2019-04-20', 346, NULL),
('Hilton Downtown', 103, '2019-04-21', 106, NULL),
('Hilton Downtown', 103, '2019-04-22', 301, NULL),
('Hilton Downtown', 103, '2019-04-23', 261, NULL),
('Hilton Downtown', 103, '2019-04-24', 302, NULL),
('Hilton Downtown', 103, '2019-04-25', 380, NULL),
('Hilton Downtown', 103, '2019-04-26', 234, NULL),
('Hilton Downtown', 103, '2019-04-27', 189, NULL),
('Hilton Downtown', 103, '2019-04-28', 368, NULL),
('Hilton Downtown', 103, '2019-04-29', 237, NULL),
('Hilton Downtown', 103, '2019-04-30', 105, NULL),
('Hilton Downtown', 103, '2019-05-01', 151, NULL),
('Hilton Downtown', 103, '2019-05-02', 316, NULL),
('Hilton Downtown', 103, '2019-05-03', 305, NULL),
('Hilton Downtown', 103, '2019-05-04', 299, NULL),
('Hilton Downtown', 103, '2019-05-05', 114, NULL),
('Hilton Downtown', 103, '2019-05-06', 346, NULL),
('Hilton Downtown', 103, '2019-05-07', 232, NULL),
('Hilton Downtown', 103, '2019-05-08', 283, NULL),
('Hilton Downtown', 103, '2019-05-09', 338, NULL),
('Hilton Downtown', 103, '2019-05-10', 114, NULL),
('Hilton Downtown', 103, '2019-05-11', 302, NULL),
('Hilton Downtown', 103, '2019-05-12', 140, NULL),
('Hilton Downtown', 103, '2019-05-13', 175, NULL),
('Hilton Downtown', 103, '2019-05-14', 336, NULL),
('Hilton Downtown', 103, '2019-05-15', 326, NULL),
('Hilton Downtown', 103, '2019-05-16', 129, NULL),
('Hilton Downtown', 103, '2019-05-17', 351, NULL),
('Hilton Downtown', 103, '2019-05-18', 338, NULL),
('Hilton Downtown', 103, '2019-05-19', 311, NULL),
('Hilton Downtown', 103, '2019-05-20', 190, NULL),
('Hilton Downtown', 103, '2019-05-21', 375, NULL),
('Hilton Downtown', 103, '2019-05-22', 123, NULL),
('Hilton Downtown', 103, '2019-05-23', 347, NULL),
('Hilton Downtown', 103, '2019-05-24', 159, NULL),
('Hilton Downtown', 103, '2019-05-25', 288, NULL),
('Hilton Downtown', 103, '2019-05-26', 156, NULL),
('Hilton Downtown', 103, '2019-05-27', 369, NULL),
('Hilton Downtown', 103, '2019-05-28', 166, NULL),
('Hilton Downtown', 103, '2019-05-29', 258, NULL),
('Hilton Downtown', 103, '2019-05-30', 316, NULL),
('Hilton Downtown', 103, '2019-05-31', 396, NULL),
('Hilton Downtown', 103, '2019-06-01', 224, NULL),
('Hilton Downtown', 103, '2019-06-02', 333, NULL),
('Hilton Downtown', 103, '2019-06-03', 107, NULL),
('Hilton Downtown', 103, '2019-06-04', 187, NULL),
('Hilton Downtown', 103, '2019-06-05', 217, NULL),
('Hilton Downtown', 103, '2019-06-06', 213, NULL),
('Hilton Downtown', 103, '2019-06-07', 371, NULL),
('Hilton Downtown', 103, '2019-06-08', 317, NULL),
('Hilton Downtown', 103, '2019-06-09', 312, NULL),
('Hilton Downtown', 103, '2019-06-10', 220, NULL),
('Hilton Downtown', 103, '2019-06-11', 101, NULL),
('Hilton Downtown', 103, '2019-06-12', 379, NULL),
('Hilton Downtown', 103, '2019-06-13', 320, NULL),
('Hilton Downtown', 103, '2019-06-14', 154, NULL),
('Hilton Downtown', 103, '2019-06-15', 373, NULL),
('Hilton Downtown', 103, '2019-06-16', 380, NULL),
('Hilton Downtown', 103, '2019-06-17', 233, NULL),
('Hilton Downtown', 103, '2019-06-18', 178, NULL),
('Hilton Downtown', 103, '2019-06-19', 229, NULL),
('Hilton Downtown', 103, '2019-06-20', 129, NULL),
('Hilton Downtown', 103, '2019-06-21', 377, NULL),
('Hilton Downtown', 103, '2019-06-22', 265, NULL),
('Hilton Downtown', 103, '2019-06-23', 108, NULL),
('Hilton Downtown', 103, '2019-06-24', 107, NULL),
('Hilton Downtown', 103, '2019-06-25', 265, NULL),
('Hilton Downtown', 103, '2019-06-26', 320, NULL),
('Hilton Downtown', 103, '2019-06-27', 301, NULL),
('Hilton Downtown', 103, '2019-06-28', 256, NULL),
('Hilton Downtown', 103, '2019-06-29', 251, NULL),
('Hilton Downtown', 103, '2019-06-30', 264, NULL),
('Hilton Downtown', 103, '2019-07-01', 114, NULL),
('Hilton Downtown', 103, '2019-07-02', 123, NULL),
('Hilton Downtown', 103, '2019-07-03', 144, NULL),
('Hilton Downtown', 103, '2019-07-04', 368, NULL),
('Hilton Downtown', 103, '2019-07-05', 271, NULL),
('Hilton Downtown', 103, '2019-07-06', 282, NULL),
('Hilton Downtown', 103, '2019-07-07', 208, NULL),
('Hilton Downtown', 103, '2019-07-08', 323, NULL),
('Hilton Downtown', 103, '2019-07-09', 370, NULL),
('Hilton Downtown', 103, '2019-07-10', 340, NULL),
('Hilton Downtown', 103, '2019-07-11', 240, NULL),
('Hilton Downtown', 103, '2019-07-12', 309, NULL),
('Hilton Downtown', 103, '2019-07-13', 262, NULL),
('Hilton Downtown', 103, '2019-07-14', 189, NULL),
('Hilton Downtown', 103, '2019-07-15', 140, NULL),
('Hilton Downtown', 103, '2019-07-16', 145, NULL),
('Hilton Downtown', 103, '2019-07-17', 335, NULL),
('Hilton Downtown', 103, '2019-07-18', 124, NULL),
('Hilton Downtown', 103, '2019-07-19', 109, NULL),
('Hilton Downtown', 103, '2019-07-20', 289, NULL),
('Hilton Downtown', 103, '2019-07-21', 110, NULL),
('Hilton Downtown', 103, '2019-07-22', 254, NULL),
('Hilton Downtown', 103, '2019-07-23', 350, NULL),
('Hilton Downtown', 103, '2019-07-24', 274, NULL),
('Hilton Downtown', 103, '2019-07-25', 244, NULL),
('Hilton Downtown', 103, '2019-07-26', 116, NULL),
('Hilton Downtown', 103, '2019-07-27', 100, NULL),
('Hilton Downtown', 103, '2019-07-28', 260, NULL),
('Hilton Downtown', 103, '2019-07-29', 248, NULL),
('Hilton Downtown', 103, '2019-07-30', 316, NULL),
('Hilton Downtown', 103, '2019-07-31', 108, NULL),
('Hilton Downtown', 103, '2019-08-01', 258, NULL),
('Hilton Downtown', 103, '2019-08-02', 244, NULL),
('Hilton Downtown', 103, '2019-08-03', 197, NULL),
('Hilton Downtown', 103, '2019-08-04', 374, NULL),
('Hilton Downtown', 103, '2019-08-05', 314, NULL),
('Hilton Downtown', 103, '2019-08-06', 225, NULL),
('Hilton Downtown', 103, '2019-08-07', 338, NULL),
('Hilton Downtown', 103, '2019-08-08', 286, NULL),
('Hilton Downtown', 103, '2019-08-09', 360, NULL),
('Hilton Downtown', 103, '2019-08-10', 304, NULL),
('Hilton Downtown', 103, '2019-08-11', 184, NULL),
('Hilton Downtown', 103, '2019-08-12', 391, NULL),
('Hilton Downtown', 103, '2019-08-13', 261, NULL),
('Hilton Downtown', 103, '2019-08-14', 112, NULL),
('Hilton Downtown', 103, '2019-08-15', 341, NULL),
('Hilton Downtown', 103, '2019-08-16', 191, NULL),
('Hilton Downtown', 103, '2019-08-17', 296, NULL),
('Hilton Downtown', 103, '2019-08-18', 234, NULL),
('Hilton Downtown', 103, '2019-08-19', 367, NULL),
('Hilton Downtown', 103, '2019-08-20', 367, NULL),
('Hilton Downtown', 103, '2019-08-21', 272, NULL),
('Hilton Downtown', 103, '2019-08-22', 329, NULL),
('Hilton Downtown', 103, '2019-08-23', 276, NULL),
('Hilton Downtown', 103, '2019-08-24', 142, NULL),
('Hilton Downtown', 103, '2019-08-25', 393, NULL),
('Hilton Downtown', 103, '2019-08-26', 381, NULL),
('Hilton Downtown', 103, '2019-08-27', 155, NULL),
('Hilton Downtown', 103, '2019-08-28', 374, NULL),
('Hilton Downtown', 103, '2019-08-29', 374, NULL),
('Hilton Downtown', 103, '2019-08-30', 323, NULL),
('Hilton Downtown', 103, '2019-08-31', 167, NULL),
('Hilton Downtown', 103, '2019-09-01', 203, NULL),
('Hilton Downtown', 103, '2019-09-02', 379, NULL),
('Hilton Downtown', 103, '2019-09-03', 264, NULL),
('Hilton Downtown', 103, '2019-09-04', 182, NULL),
('Hilton Downtown', 103, '2019-09-05', 205, NULL),
('Hilton Downtown', 103, '2019-09-06', 261, NULL),
('Hilton Downtown', 103, '2019-09-07', 368, NULL),
('Hilton Downtown', 103, '2019-09-08', 109, NULL),
('Hilton Downtown', 103, '2019-09-09', 371, NULL),
('Hilton Downtown', 103, '2019-09-10', 340, NULL),
('Hilton Downtown', 103, '2019-09-11', 382, NULL),
('Hilton Downtown', 103, '2019-09-12', 206, NULL),
('Hilton Downtown', 103, '2019-09-13', 295, NULL),
('Hilton Downtown', 103, '2019-09-14', 229, NULL),
('Hilton Downtown', 103, '2019-09-15', 157, NULL),
('Hilton Downtown', 103, '2019-09-16', 159, NULL),
('Hilton Downtown', 103, '2019-09-17', 329, NULL),
('Hilton Downtown', 103, '2019-09-18', 204, NULL),
('Hilton Downtown', 103, '2019-09-19', 278, NULL),
('Hilton Downtown', 103, '2019-09-20', 176, NULL),
('Hilton Downtown', 103, '2019-09-21', 140, NULL),
('Hilton Downtown', 103, '2019-09-22', 339, NULL),
('Hilton Downtown', 103, '2019-09-23', 221, NULL),
('Hilton Downtown', 103, '2019-09-24', 325, NULL),
('Hilton Downtown', 103, '2019-09-25', 232, NULL),
('Hilton Downtown', 103, '2019-09-26', 241, NULL),
('Hilton Downtown', 103, '2019-09-27', 284, NULL),
('Hilton Downtown', 103, '2019-09-28', 399, NULL),
('Hilton Downtown', 103, '2019-09-29', 335, NULL),
('Hilton Downtown', 103, '2019-09-30', 333, NULL),
('Hilton Downtown', 103, '2019-10-01', 373, NULL),
('Hilton Downtown', 103, '2019-10-02', 372, NULL),
('Hilton Downtown', 103, '2019-10-03', 345, NULL),
('Hilton Downtown', 103, '2019-10-04', 205, NULL),
('Hilton Downtown', 103, '2019-10-05', 164, NULL),
('Hilton Downtown', 103, '2019-10-06', 369, NULL),
('Hilton Downtown', 103, '2019-10-07', 196, NULL),
('Hilton Downtown', 103, '2019-10-08', 180, NULL),
('Hilton Downtown', 103, '2019-10-09', 372, NULL),
('Hilton Downtown', 103, '2019-10-10', 216, NULL),
('Hilton Downtown', 103, '2019-10-11', 200, NULL),
('Hilton Downtown', 103, '2019-10-12', 362, NULL),
('Hilton Downtown', 103, '2019-10-13', 271, NULL),
('Hilton Downtown', 103, '2019-10-14', 189, NULL),
('Hilton Downtown', 103, '2019-10-15', 325, NULL),
('Hilton Downtown', 103, '2019-10-16', 152, NULL),
('Hilton Downtown', 103, '2019-10-17', 279, NULL),
('Hilton Downtown', 103, '2019-10-18', 334, NULL),
('Hilton Downtown', 103, '2019-10-19', 225, NULL),
('Hilton Downtown', 103, '2019-10-20', 222, NULL),
('Hilton Downtown', 103, '2019-10-21', 163, NULL),
('Hilton Downtown', 103, '2019-10-22', 179, NULL),
('Hilton Downtown', 103, '2019-10-23', 338, NULL),
('Hilton Downtown', 103, '2019-10-24', 250, NULL),
('Hilton Downtown', 103, '2019-10-25', 268, NULL),
('Hilton Downtown', 103, '2019-10-26', 251, NULL),
('Hilton Downtown', 103, '2019-10-27', 229, NULL),
('Hilton Downtown', 103, '2019-10-28', 247, NULL),
('Hilton Downtown', 103, '2019-10-29', 383, NULL),
('Hilton Downtown', 103, '2019-10-30', 220, NULL),
('Hilton Downtown', 103, '2019-10-31', 248, NULL),
('Hilton Downtown', 103, '2019-11-01', 349, NULL),
('Hilton Downtown', 103, '2019-11-02', 203, NULL),
('Hilton Downtown', 103, '2019-11-03', 352, NULL),
('Hilton Downtown', 103, '2019-11-04', 255, NULL),
('Hilton Downtown', 103, '2019-11-05', 298, NULL),
('Hilton Downtown', 103, '2019-11-06', 320, NULL),
('Hilton Downtown', 103, '2019-11-07', 322, NULL),
('Hilton Downtown', 103, '2019-11-08', 169, NULL),
('Hilton Downtown', 103, '2019-11-09', 118, NULL),
('Hilton Downtown', 103, '2019-11-10', 215, NULL),
('Hilton Downtown', 103, '2019-11-11', 303, NULL),
('Hilton Downtown', 103, '2019-11-12', 358, NULL),
('Hilton Downtown', 103, '2019-11-13', 291, NULL),
('Hilton Downtown', 103, '2019-11-14', 241, NULL),
('Hilton Downtown', 103, '2019-11-15', 378, NULL),
('Hilton Downtown', 103, '2019-11-16', 249, NULL),
('Hilton Downtown', 103, '2019-11-17', 239, NULL),
('Hilton Downtown', 103, '2019-11-18', 117, NULL),
('Hilton Downtown', 103, '2019-11-19', 243, NULL),
('Hilton Downtown', 103, '2019-11-20', 330, NULL),
('Hilton Downtown', 103, '2019-11-21', 285, NULL),
('Hilton Downtown', 103, '2019-11-22', 329, NULL),
('Hilton Downtown', 103, '2019-11-23', 253, NULL),
('Hilton Downtown', 103, '2019-11-24', 225, NULL),
('Hilton Downtown', 103, '2019-11-25', 240, NULL),
('Hilton Downtown', 103, '2019-11-26', 306, NULL),
('Hilton Downtown', 103, '2019-11-27', 164, NULL),
('Hilton Downtown', 103, '2019-11-28', 175, NULL),
('Hilton Downtown', 103, '2019-11-29', 312, NULL),
('Hilton Downtown', 103, '2019-11-30', 223, NULL),
('Hilton Downtown', 103, '2019-12-01', 381, NULL),
('Hilton Downtown', 103, '2019-12-02', 310, NULL),
('Hilton Downtown', 103, '2019-12-03', 353, NULL),
('Hilton Downtown', 103, '2019-12-04', 153, NULL),
('Hilton Downtown', 103, '2019-12-05', 308, NULL),
('Hilton Downtown', 103, '2019-12-06', 212, NULL),
('Hilton Downtown', 103, '2019-12-07', 122, NULL),
('Hilton Downtown', 103, '2019-12-08', 338, NULL),
('Hilton Downtown', 103, '2019-12-09', 107, NULL),
('Hilton Downtown', 103, '2019-12-10', 116, NULL),
('Hilton Downtown', 103, '2019-12-11', 119, NULL),
('Hilton Downtown', 103, '2019-12-12', 245, NULL),
('Hilton Downtown', 103, '2019-12-13', 211, NULL),
('Hilton Downtown', 103, '2019-12-14', 172, NULL),
('Hilton Downtown', 103, '2019-12-15', 364, NULL),
('Hilton Downtown', 103, '2019-12-16', 146, NULL),
('Hilton Downtown', 103, '2019-12-17', 345, NULL),
('Hilton Downtown', 103, '2019-12-18', 298, NULL),
('Hilton Downtown', 103, '2019-12-19', 280, NULL),
('Hilton Downtown', 103, '2019-12-20', 290, NULL),
('Hilton Downtown', 103, '2019-12-21', 168, NULL),
('Hilton Downtown', 103, '2019-12-22', 269, NULL),
('Hilton Downtown', 103, '2019-12-23', 366, NULL),
('Hilton Downtown', 103, '2019-12-24', 394, NULL),
('Hilton Downtown', 103, '2019-12-25', 209, NULL),
('Hilton Downtown', 103, '2019-12-26', 181, NULL),
('Hilton Downtown', 103, '2019-12-27', 353, NULL),
('Hilton Downtown', 103, '2019-12-28', 367, NULL),
('Hilton Downtown', 103, '2019-12-29', 306, NULL),
('Hilton Downtown', 103, '2019-12-30', 178, NULL),
('Hilton Downtown', 103, '2019-12-31', 360, NULL),
('Hilton Downtown', 103, '2020-01-01', 302, NULL),
('Hilton Downtown', 103, '2020-01-02', 125, NULL),
('Hilton Downtown', 103, '2020-01-03', 102, NULL),
('Hilton Downtown', 103, '2020-01-04', 164, NULL),
('Hilton Downtown', 103, '2020-01-05', 339, NULL),
('Hilton Downtown', 103, '2020-01-06', 100, NULL),
('Hilton Downtown', 103, '2020-01-07', 241, NULL),
('Hilton Downtown', 103, '2020-01-08', 270, NULL),
('Hilton Downtown', 103, '2020-01-09', 208, NULL),
('Hilton Downtown', 103, '2020-01-10', 181, NULL),
('Hilton Downtown', 103, '2020-01-11', 147, NULL),
('Hilton Downtown', 103, '2020-01-12', 190, NULL),
('Hilton Downtown', 103, '2020-01-13', 101, NULL),
('Hilton Downtown', 103, '2020-01-14', 112, NULL),
('Hilton Downtown', 103, '2020-01-15', 108, NULL),
('Hilton Downtown', 103, '2020-01-16', 329, NULL),
('Hilton Downtown', 103, '2020-01-17', 240, NULL),
('Hilton Downtown', 103, '2020-01-18', 326, NULL),
('Hilton Downtown', 103, '2020-01-19', 384, NULL),
('Hilton Downtown', 103, '2020-01-20', 229, NULL),
('Hilton Downtown', 103, '2020-01-21', 326, NULL),
('Hilton Downtown', 103, '2020-01-22', 115, NULL),
('Hilton Downtown', 103, '2020-01-23', 335, NULL),
('Hilton Downtown', 103, '2020-01-24', 301, NULL),
('Hilton Downtown', 103, '2020-01-25', 255, NULL),
('Hilton Downtown', 103, '2020-01-26', 251, NULL),
('Hilton Downtown', 103, '2020-01-27', 257, NULL),
('Hilton Downtown', 103, '2020-01-28', 176, NULL),
('Hilton Downtown', 103, '2020-01-29', 101, NULL),
('Hilton Downtown', 103, '2020-01-30', 348, NULL),
('Hilton Downtown', 103, '2020-01-31', 315, NULL),
('Hilton Downtown', 103, '2020-02-01', 277, NULL),
('Hilton Downtown', 103, '2020-02-02', 117, NULL),
('Hilton Downtown', 103, '2020-02-03', 152, NULL),
('Hilton Downtown', 103, '2020-02-04', 156, NULL),
('Hilton Downtown', 107, '2019-01-01', 288, NULL),
('Hilton Downtown', 107, '2019-01-02', 257, NULL),
('Hilton Downtown', 107, '2019-01-03', 314, NULL),
('Hilton Downtown', 107, '2019-01-04', 359, NULL),
('Hilton Downtown', 107, '2019-01-05', 184, NULL),
('Hilton Downtown', 107, '2019-01-06', 257, NULL),
('Hilton Downtown', 107, '2019-01-07', 201, NULL),
('Hilton Downtown', 107, '2019-01-08', 135, NULL),
('Hilton Downtown', 107, '2019-01-09', 280, NULL),
('Hilton Downtown', 107, '2019-01-10', 213, NULL),
('Hilton Downtown', 107, '2019-01-11', 315, NULL),
('Hilton Downtown', 107, '2019-01-12', 141, NULL),
('Hilton Downtown', 107, '2019-01-13', 300, NULL),
('Hilton Downtown', 107, '2019-01-14', 399, NULL),
('Hilton Downtown', 107, '2019-01-15', 132, NULL),
('Hilton Downtown', 107, '2019-01-16', 126, NULL),
('Hilton Downtown', 107, '2019-01-17', 145, NULL),
('Hilton Downtown', 107, '2019-01-18', 237, NULL),
('Hilton Downtown', 107, '2019-01-19', 211, NULL),
('Hilton Downtown', 107, '2019-01-20', 174, NULL),
('Hilton Downtown', 107, '2019-01-21', 247, NULL),
('Hilton Downtown', 107, '2019-01-22', 290, NULL),
('Hilton Downtown', 107, '2019-01-23', 175, NULL),
('Hilton Downtown', 107, '2019-01-24', 214, NULL),
('Hilton Downtown', 107, '2019-01-25', 134, NULL),
('Hilton Downtown', 107, '2019-01-26', 326, NULL),
('Hilton Downtown', 107, '2019-01-27', 244, NULL),
('Hilton Downtown', 107, '2019-01-28', 226, NULL),
('Hilton Downtown', 107, '2019-01-29', 137, NULL),
('Hilton Downtown', 107, '2019-01-30', 290, NULL),
('Hilton Downtown', 107, '2019-01-31', 353, NULL),
('Hilton Downtown', 107, '2019-02-01', 209, NULL),
('Hilton Downtown', 107, '2019-02-02', 155, NULL),
('Hilton Downtown', 107, '2019-02-03', 299, NULL),
('Hilton Downtown', 107, '2019-02-04', 181, NULL),
('Hilton Downtown', 107, '2019-02-05', 325, NULL),
('Hilton Downtown', 107, '2019-02-06', 218, NULL),
('Hilton Downtown', 107, '2019-02-07', 191, NULL),
('Hilton Downtown', 107, '2019-02-08', 128, NULL),
('Hilton Downtown', 107, '2019-02-09', 286, NULL),
('Hilton Downtown', 107, '2019-02-10', 352, NULL),
('Hilton Downtown', 107, '2019-02-11', 196, NULL),
('Hilton Downtown', 107, '2019-02-12', 287, NULL),
('Hilton Downtown', 107, '2019-02-13', 330, NULL),
('Hilton Downtown', 107, '2019-02-14', 192, NULL),
('Hilton Downtown', 107, '2019-02-15', 189, NULL),
('Hilton Downtown', 107, '2019-02-16', 123, NULL),
('Hilton Downtown', 107, '2019-02-17', 225, NULL),
('Hilton Downtown', 107, '2019-02-18', 336, NULL),
('Hilton Downtown', 107, '2019-02-19', 356, NULL),
('Hilton Downtown', 107, '2019-02-20', 274, NULL),
('Hilton Downtown', 107, '2019-02-21', 131, NULL),
('Hilton Downtown', 107, '2019-02-22', 212, NULL),
('Hilton Downtown', 107, '2019-02-23', 233, NULL),
('Hilton Downtown', 107, '2019-02-24', 158, NULL),
('Hilton Downtown', 107, '2019-02-25', 248, NULL),
('Hilton Downtown', 107, '2019-02-26', 139, NULL),
('Hilton Downtown', 107, '2019-02-27', 395, NULL),
('Hilton Downtown', 107, '2019-02-28', 333, NULL),
('Hilton Downtown', 107, '2019-03-01', 279, NULL),
('Hilton Downtown', 107, '2019-03-02', 359, NULL),
('Hilton Downtown', 107, '2019-03-03', 150, NULL),
('Hilton Downtown', 107, '2019-03-04', 184, NULL),
('Hilton Downtown', 107, '2019-03-05', 314, NULL),
('Hilton Downtown', 107, '2019-03-06', 282, NULL),
('Hilton Downtown', 107, '2019-03-07', 361, NULL),
('Hilton Downtown', 107, '2019-03-08', 157, NULL),
('Hilton Downtown', 107, '2019-03-09', 250, NULL),
('Hilton Downtown', 107, '2019-03-10', 152, NULL),
('Hilton Downtown', 107, '2019-03-11', 100, NULL),
('Hilton Downtown', 107, '2019-03-12', 389, NULL),
('Hilton Downtown', 107, '2019-03-13', 303, NULL),
('Hilton Downtown', 107, '2019-03-14', 206, NULL),
('Hilton Downtown', 107, '2019-03-15', 268, NULL),
('Hilton Downtown', 107, '2019-03-16', 369, NULL),
('Hilton Downtown', 107, '2019-03-17', 287, NULL),
('Hilton Downtown', 107, '2019-03-18', 108, NULL),
('Hilton Downtown', 107, '2019-03-19', 287, NULL),
('Hilton Downtown', 107, '2019-03-20', 360, NULL),
('Hilton Downtown', 107, '2019-03-21', 258, NULL),
('Hilton Downtown', 107, '2019-03-22', 147, NULL),
('Hilton Downtown', 107, '2019-03-23', 213, NULL),
('Hilton Downtown', 107, '2019-03-24', 387, NULL),
('Hilton Downtown', 107, '2019-03-25', 124, NULL),
('Hilton Downtown', 107, '2019-03-26', 312, NULL),
('Hilton Downtown', 107, '2019-03-27', 365, NULL),
('Hilton Downtown', 107, '2019-03-28', 145, NULL),
('Hilton Downtown', 107, '2019-03-29', 352, NULL),
('Hilton Downtown', 107, '2019-03-30', 204, NULL),
('Hilton Downtown', 107, '2019-03-31', 230, NULL),
('Hilton Downtown', 107, '2019-04-01', 151, NULL),
('Hilton Downtown', 107, '2019-04-02', 309, NULL),
('Hilton Downtown', 107, '2019-04-03', 342, NULL),
('Hilton Downtown', 107, '2019-04-04', 344, NULL),
('Hilton Downtown', 107, '2019-04-05', 365, NULL),
('Hilton Downtown', 107, '2019-04-06', 297, NULL),
('Hilton Downtown', 107, '2019-04-07', 138, NULL),
('Hilton Downtown', 107, '2019-04-08', 102, NULL),
('Hilton Downtown', 107, '2019-04-09', 173, NULL),
('Hilton Downtown', 107, '2019-04-10', 143, NULL),
('Hilton Downtown', 107, '2019-04-11', 395, NULL),
('Hilton Downtown', 107, '2019-04-12', 285, NULL),
('Hilton Downtown', 107, '2019-04-13', 242, NULL),
('Hilton Downtown', 107, '2019-04-14', 175, NULL),
('Hilton Downtown', 107, '2019-04-15', 194, NULL),
('Hilton Downtown', 107, '2019-04-16', 324, NULL),
('Hilton Downtown', 107, '2019-04-17', 323, NULL),
('Hilton Downtown', 107, '2019-04-18', 274, NULL),
('Hilton Downtown', 107, '2019-04-19', 151, NULL),
('Hilton Downtown', 107, '2019-04-20', 193, NULL),
('Hilton Downtown', 107, '2019-04-21', 356, NULL),
('Hilton Downtown', 107, '2019-04-22', 320, NULL),
('Hilton Downtown', 107, '2019-04-23', 105, NULL),
('Hilton Downtown', 107, '2019-04-24', 229, NULL),
('Hilton Downtown', 107, '2019-04-25', 161, NULL),
('Hilton Downtown', 107, '2019-04-26', 383, NULL),
('Hilton Downtown', 107, '2019-04-27', 330, NULL),
('Hilton Downtown', 107, '2019-04-28', 142, NULL),
('Hilton Downtown', 107, '2019-04-29', 231, NULL),
('Hilton Downtown', 107, '2019-04-30', 291, NULL),
('Hilton Downtown', 107, '2019-05-01', 233, NULL),
('Hilton Downtown', 107, '2019-05-02', 136, NULL),
('Hilton Downtown', 107, '2019-05-03', 364, NULL),
('Hilton Downtown', 107, '2019-05-04', 294, NULL),
('Hilton Downtown', 107, '2019-05-05', 237, NULL),
('Hilton Downtown', 107, '2019-05-06', 129, NULL),
('Hilton Downtown', 107, '2019-05-07', 203, NULL),
('Hilton Downtown', 107, '2019-05-08', 184, NULL),
('Hilton Downtown', 107, '2019-05-09', 277, NULL),
('Hilton Downtown', 107, '2019-05-10', 215, NULL),
('Hilton Downtown', 107, '2019-05-11', 361, NULL),
('Hilton Downtown', 107, '2019-05-12', 394, NULL),
('Hilton Downtown', 107, '2019-05-13', 201, NULL),
('Hilton Downtown', 107, '2019-05-14', 338, NULL),
('Hilton Downtown', 107, '2019-05-15', 373, NULL),
('Hilton Downtown', 107, '2019-05-16', 237, NULL),
('Hilton Downtown', 107, '2019-05-17', 344, NULL),
('Hilton Downtown', 107, '2019-05-18', 101, NULL),
('Hilton Downtown', 107, '2019-05-19', 373, NULL),
('Hilton Downtown', 107, '2019-05-20', 380, NULL),
('Hilton Downtown', 107, '2019-05-21', 266, NULL),
('Hilton Downtown', 107, '2019-05-22', 126, NULL),
('Hilton Downtown', 107, '2019-05-23', 288, NULL),
('Hilton Downtown', 107, '2019-05-24', 194, NULL),
('Hilton Downtown', 107, '2019-05-25', 154, NULL),
('Hilton Downtown', 107, '2019-05-26', 255, NULL),
('Hilton Downtown', 107, '2019-05-27', 296, NULL),
('Hilton Downtown', 107, '2019-05-28', 200, NULL),
('Hilton Downtown', 107, '2019-05-29', 103, NULL),
('Hilton Downtown', 107, '2019-05-30', 273, NULL),
('Hilton Downtown', 107, '2019-05-31', 335, NULL),
('Hilton Downtown', 107, '2019-06-01', 306, NULL),
('Hilton Downtown', 107, '2019-06-02', 144, NULL),
('Hilton Downtown', 107, '2019-06-03', 320, NULL),
('Hilton Downtown', 107, '2019-06-04', 119, NULL),
('Hilton Downtown', 107, '2019-06-05', 174, NULL),
('Hilton Downtown', 107, '2019-06-06', 333, NULL),
('Hilton Downtown', 107, '2019-06-07', 372, NULL),
('Hilton Downtown', 107, '2019-06-08', 355, NULL),
('Hilton Downtown', 107, '2019-06-09', 249, NULL),
('Hilton Downtown', 107, '2019-06-10', 220, NULL),
('Hilton Downtown', 107, '2019-06-11', 393, NULL),
('Hilton Downtown', 107, '2019-06-12', 226, NULL),
('Hilton Downtown', 107, '2019-06-13', 138, NULL),
('Hilton Downtown', 107, '2019-06-14', 309, NULL),
('Hilton Downtown', 107, '2019-06-15', 349, NULL),
('Hilton Downtown', 107, '2019-06-16', 131, NULL),
('Hilton Downtown', 107, '2019-06-17', 384, NULL),
('Hilton Downtown', 107, '2019-06-18', 153, NULL),
('Hilton Downtown', 107, '2019-06-19', 204, NULL),
('Hilton Downtown', 107, '2019-06-20', 269, NULL),
('Hilton Downtown', 107, '2019-06-21', 171, NULL),
('Hilton Downtown', 107, '2019-06-22', 194, NULL),
('Hilton Downtown', 107, '2019-06-23', 193, NULL),
('Hilton Downtown', 107, '2019-06-24', 350, NULL),
('Hilton Downtown', 107, '2019-06-25', 199, NULL),
('Hilton Downtown', 107, '2019-06-26', 369, NULL),
('Hilton Downtown', 107, '2019-06-27', 132, NULL),
('Hilton Downtown', 107, '2019-06-28', 191, NULL),
('Hilton Downtown', 107, '2019-06-29', 391, NULL),
('Hilton Downtown', 107, '2019-06-30', 163, NULL),
('Hilton Downtown', 107, '2019-07-01', 226, NULL),
('Hilton Downtown', 107, '2019-07-02', 297, NULL),
('Hilton Downtown', 107, '2019-07-03', 180, NULL),
('Hilton Downtown', 107, '2019-07-04', 148, NULL),
('Hilton Downtown', 107, '2019-07-05', 179, NULL),
('Hilton Downtown', 107, '2019-07-06', 210, NULL),
('Hilton Downtown', 107, '2019-07-07', 326, NULL),
('Hilton Downtown', 107, '2019-07-08', 370, NULL),
('Hilton Downtown', 107, '2019-07-09', 275, NULL),
('Hilton Downtown', 107, '2019-07-10', 357, NULL),
('Hilton Downtown', 107, '2019-07-11', 329, NULL),
('Hilton Downtown', 107, '2019-07-12', 166, NULL),
('Hilton Downtown', 107, '2019-07-13', 246, NULL),
('Hilton Downtown', 107, '2019-07-14', 103, NULL),
('Hilton Downtown', 107, '2019-07-15', 243, NULL),
('Hilton Downtown', 107, '2019-07-16', 302, NULL),
('Hilton Downtown', 107, '2019-07-17', 122, NULL),
('Hilton Downtown', 107, '2019-07-18', 163, NULL),
('Hilton Downtown', 107, '2019-07-19', 193, NULL),
('Hilton Downtown', 107, '2019-07-20', 272, NULL),
('Hilton Downtown', 107, '2019-07-21', 239, NULL),
('Hilton Downtown', 107, '2019-07-22', 250, NULL),
('Hilton Downtown', 107, '2019-07-23', 130, NULL),
('Hilton Downtown', 107, '2019-07-24', 148, NULL),
('Hilton Downtown', 107, '2019-07-25', 307, NULL),
('Hilton Downtown', 107, '2019-07-26', 288, NULL),
('Hilton Downtown', 107, '2019-07-27', 182, NULL),
('Hilton Downtown', 107, '2019-07-28', 189, NULL),
('Hilton Downtown', 107, '2019-07-29', 318, NULL),
('Hilton Downtown', 107, '2019-07-30', 153, NULL),
('Hilton Downtown', 107, '2019-07-31', 243, NULL),
('Hilton Downtown', 107, '2019-08-01', 304, NULL),
('Hilton Downtown', 107, '2019-08-02', 145, NULL),
('Hilton Downtown', 107, '2019-08-03', 150, NULL),
('Hilton Downtown', 107, '2019-08-04', 342, NULL),
('Hilton Downtown', 107, '2019-08-05', 270, NULL),
('Hilton Downtown', 107, '2019-08-06', 326, NULL),
('Hilton Downtown', 107, '2019-08-07', 303, NULL),
('Hilton Downtown', 107, '2019-08-08', 399, NULL),
('Hilton Downtown', 107, '2019-08-09', 290, NULL),
('Hilton Downtown', 107, '2019-08-10', 270, NULL),
('Hilton Downtown', 107, '2019-08-11', 357, NULL),
('Hilton Downtown', 107, '2019-08-12', 118, NULL),
('Hilton Downtown', 107, '2019-08-13', 162, NULL),
('Hilton Downtown', 107, '2019-08-14', 363, NULL),
('Hilton Downtown', 107, '2019-08-15', 363, NULL),
('Hilton Downtown', 107, '2019-08-16', 140, NULL),
('Hilton Downtown', 107, '2019-08-17', 261, NULL),
('Hilton Downtown', 107, '2019-08-18', 396, NULL),
('Hilton Downtown', 107, '2019-08-19', 340, NULL),
('Hilton Downtown', 107, '2019-08-20', 342, NULL),
('Hilton Downtown', 107, '2019-08-21', 209, NULL),
('Hilton Downtown', 107, '2019-08-22', 306, NULL),
('Hilton Downtown', 107, '2019-08-23', 377, NULL),
('Hilton Downtown', 107, '2019-08-24', 230, NULL),
('Hilton Downtown', 107, '2019-08-25', 319, NULL),
('Hilton Downtown', 107, '2019-08-26', 165, NULL),
('Hilton Downtown', 107, '2019-08-27', 322, NULL),
('Hilton Downtown', 107, '2019-08-28', 399, NULL),
('Hilton Downtown', 107, '2019-08-29', 226, NULL),
('Hilton Downtown', 107, '2019-08-30', 144, NULL),
('Hilton Downtown', 107, '2019-08-31', 312, NULL),
('Hilton Downtown', 107, '2019-09-01', 294, NULL),
('Hilton Downtown', 107, '2019-09-02', 360, NULL),
('Hilton Downtown', 107, '2019-09-03', 236, NULL),
('Hilton Downtown', 107, '2019-09-04', 339, NULL),
('Hilton Downtown', 107, '2019-09-05', 213, NULL),
('Hilton Downtown', 107, '2019-09-06', 387, NULL),
('Hilton Downtown', 107, '2019-09-07', 320, NULL),
('Hilton Downtown', 107, '2019-09-08', 113, NULL),
('Hilton Downtown', 107, '2019-09-09', 381, NULL),
('Hilton Downtown', 107, '2019-09-10', 312, NULL),
('Hilton Downtown', 107, '2019-09-11', 341, NULL),
('Hilton Downtown', 107, '2019-09-12', 138, NULL),
('Hilton Downtown', 107, '2019-09-13', 111, NULL),
('Hilton Downtown', 107, '2019-09-14', 378, NULL),
('Hilton Downtown', 107, '2019-09-15', 196, NULL),
('Hilton Downtown', 107, '2019-09-16', 108, NULL),
('Hilton Downtown', 107, '2019-09-17', 294, NULL),
('Hilton Downtown', 107, '2019-09-18', 269, NULL),
('Hilton Downtown', 107, '2019-09-19', 169, NULL),
('Hilton Downtown', 107, '2019-09-20', 155, NULL),
('Hilton Downtown', 107, '2019-09-21', 228, NULL),
('Hilton Downtown', 107, '2019-09-22', 393, NULL),
('Hilton Downtown', 107, '2019-09-23', 271, NULL),
('Hilton Downtown', 107, '2019-09-24', 296, NULL),
('Hilton Downtown', 107, '2019-09-25', 262, NULL),
('Hilton Downtown', 107, '2019-09-26', 152, NULL),
('Hilton Downtown', 107, '2019-09-27', 243, NULL),
('Hilton Downtown', 107, '2019-09-28', 159, NULL),
('Hilton Downtown', 107, '2019-09-29', 370, NULL),
('Hilton Downtown', 107, '2019-09-30', 270, NULL),
('Hilton Downtown', 107, '2019-10-01', 183, NULL),
('Hilton Downtown', 107, '2019-10-02', 357, NULL),
('Hilton Downtown', 107, '2019-10-03', 368, NULL),
('Hilton Downtown', 107, '2019-10-04', 245, NULL),
('Hilton Downtown', 107, '2019-10-05', 164, NULL),
('Hilton Downtown', 107, '2019-10-06', 280, NULL),
('Hilton Downtown', 107, '2019-10-07', 156, NULL),
('Hilton Downtown', 107, '2019-10-08', 233, NULL),
('Hilton Downtown', 107, '2019-10-09', 348, NULL),
('Hilton Downtown', 107, '2019-10-10', 163, NULL),
('Hilton Downtown', 107, '2019-10-11', 231, NULL),
('Hilton Downtown', 107, '2019-10-12', 288, NULL),
('Hilton Downtown', 107, '2019-10-13', 362, NULL),
('Hilton Downtown', 107, '2019-10-14', 135, NULL),
('Hilton Downtown', 107, '2019-10-15', 145, NULL),
('Hilton Downtown', 107, '2019-10-16', 152, NULL),
('Hilton Downtown', 107, '2019-10-17', 259, NULL),
('Hilton Downtown', 107, '2019-10-18', 314, NULL),
('Hilton Downtown', 107, '2019-10-19', 283, NULL),
('Hilton Downtown', 107, '2019-10-20', 131, NULL),
('Hilton Downtown', 107, '2019-10-21', 192, NULL),
('Hilton Downtown', 107, '2019-10-22', 209, NULL),
('Hilton Downtown', 107, '2019-10-23', 372, NULL),
('Hilton Downtown', 107, '2019-10-24', 282, NULL),
('Hilton Downtown', 107, '2019-10-25', 120, NULL),
('Hilton Downtown', 107, '2019-10-26', 104, NULL),
('Hilton Downtown', 107, '2019-10-27', 114, NULL),
('Hilton Downtown', 107, '2019-10-28', 154, NULL),
('Hilton Downtown', 107, '2019-10-29', 355, NULL),
('Hilton Downtown', 107, '2019-10-30', 130, NULL),
('Hilton Downtown', 107, '2019-10-31', 257, NULL),
('Hilton Downtown', 107, '2019-11-01', 110, NULL),
('Hilton Downtown', 107, '2019-11-02', 183, NULL),
('Hilton Downtown', 107, '2019-11-03', 213, NULL),
('Hilton Downtown', 107, '2019-11-04', 152, NULL),
('Hilton Downtown', 107, '2019-11-05', 289, NULL),
('Hilton Downtown', 107, '2019-11-06', 394, NULL),
('Hilton Downtown', 107, '2019-11-07', 126, NULL),
('Hilton Downtown', 107, '2019-11-08', 301, NULL),
('Hilton Downtown', 107, '2019-11-09', 364, NULL),
('Hilton Downtown', 107, '2019-11-10', 152, NULL),
('Hilton Downtown', 107, '2019-11-11', 377, NULL),
('Hilton Downtown', 107, '2019-11-12', 252, NULL),
('Hilton Downtown', 107, '2019-11-13', 203, NULL),
('Hilton Downtown', 107, '2019-11-14', 267, NULL),
('Hilton Downtown', 107, '2019-11-15', 378, NULL),
('Hilton Downtown', 107, '2019-11-16', 393, NULL),
('Hilton Downtown', 107, '2019-11-17', 116, NULL),
('Hilton Downtown', 107, '2019-11-18', 242, NULL),
('Hilton Downtown', 107, '2019-11-19', 293, NULL),
('Hilton Downtown', 107, '2019-11-20', 352, NULL),
('Hilton Downtown', 107, '2019-11-21', 363, NULL),
('Hilton Downtown', 107, '2019-11-22', 174, NULL),
('Hilton Downtown', 107, '2019-11-23', 295, NULL),
('Hilton Downtown', 107, '2019-11-24', 111, NULL),
('Hilton Downtown', 107, '2019-11-25', 343, NULL),
('Hilton Downtown', 107, '2019-11-26', 361, NULL),
('Hilton Downtown', 107, '2019-11-27', 216, NULL),
('Hilton Downtown', 107, '2019-11-28', 256, NULL),
('Hilton Downtown', 107, '2019-11-29', 102, NULL),
('Hilton Downtown', 107, '2019-11-30', 233, NULL),
('Hilton Downtown', 107, '2019-12-01', 352, NULL),
('Hilton Downtown', 107, '2019-12-02', 297, NULL),
('Hilton Downtown', 107, '2019-12-03', 164, NULL),
('Hilton Downtown', 107, '2019-12-04', 308, NULL),
('Hilton Downtown', 107, '2019-12-05', 316, NULL),
('Hilton Downtown', 107, '2019-12-06', 269, NULL),
('Hilton Downtown', 107, '2019-12-07', 392, NULL),
('Hilton Downtown', 107, '2019-12-08', 190, NULL),
('Hilton Downtown', 107, '2019-12-09', 387, NULL),
('Hilton Downtown', 107, '2019-12-10', 364, NULL),
('Hilton Downtown', 107, '2019-12-11', 202, NULL),
('Hilton Downtown', 107, '2019-12-12', 219, NULL),
('Hilton Downtown', 107, '2019-12-13', 365, NULL),
('Hilton Downtown', 107, '2019-12-14', 224, NULL),
('Hilton Downtown', 107, '2019-12-15', 352, NULL),
('Hilton Downtown', 107, '2019-12-16', 176, NULL),
('Hilton Downtown', 107, '2019-12-17', 145, NULL),
('Hilton Downtown', 107, '2019-12-18', 385, NULL),
('Hilton Downtown', 107, '2019-12-19', 168, NULL),
('Hilton Downtown', 107, '2019-12-20', 121, NULL),
('Hilton Downtown', 107, '2019-12-21', 327, NULL),
('Hilton Downtown', 107, '2019-12-22', 139, NULL),
('Hilton Downtown', 107, '2019-12-23', 358, NULL),
('Hilton Downtown', 107, '2019-12-24', 163, NULL),
('Hilton Downtown', 107, '2019-12-25', 194, NULL),
('Hilton Downtown', 107, '2019-12-26', 165, NULL),
('Hilton Downtown', 107, '2019-12-27', 133, NULL),
('Hilton Downtown', 107, '2019-12-28', 101, NULL),
('Hilton Downtown', 107, '2019-12-29', 287, NULL),
('Hilton Downtown', 107, '2019-12-30', 172, NULL),
('Hilton Downtown', 107, '2019-12-31', 247, NULL),
('Hilton Downtown', 107, '2020-01-01', 147, NULL),
('Hilton Downtown', 107, '2020-01-02', 217, NULL),
('Hilton Downtown', 107, '2020-01-03', 150, NULL),
('Hilton Downtown', 107, '2020-01-04', 166, NULL),
('Hilton Downtown', 107, '2020-01-05', 182, NULL),
('Hilton Downtown', 107, '2020-01-06', 389, NULL),
('Hilton Downtown', 107, '2020-01-07', 276, NULL),
('Hilton Downtown', 107, '2020-01-08', 117, NULL),
('Hilton Downtown', 107, '2020-01-09', 349, NULL),
('Hilton Downtown', 107, '2020-01-10', 106, NULL),
('Hilton Downtown', 107, '2020-01-11', 198, NULL),
('Hilton Downtown', 107, '2020-01-12', 159, NULL),
('Hilton Downtown', 107, '2020-01-13', 282, NULL),
('Hilton Downtown', 107, '2020-01-14', 206, NULL),
('Hilton Downtown', 107, '2020-01-15', 225, NULL),
('Hilton Downtown', 107, '2020-01-16', 190, NULL),
('Hilton Downtown', 107, '2020-01-17', 228, NULL),
('Hilton Downtown', 107, '2020-01-18', 107, NULL),
('Hilton Downtown', 107, '2020-01-19', 133, NULL),
('Hilton Downtown', 107, '2020-01-20', 314, NULL),
('Hilton Downtown', 107, '2020-01-21', 379, NULL),
('Hilton Downtown', 107, '2020-01-22', 244, NULL),
('Hilton Downtown', 107, '2020-01-23', 137, NULL),
('Hilton Downtown', 107, '2020-01-24', 344, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 107, '2020-01-25', 309, NULL),
('Hilton Downtown', 107, '2020-01-26', 204, NULL),
('Hilton Downtown', 107, '2020-01-27', 139, NULL),
('Hilton Downtown', 107, '2020-01-28', 209, NULL),
('Hilton Downtown', 107, '2020-01-29', 397, NULL),
('Hilton Downtown', 107, '2020-01-30', 177, NULL),
('Hilton Downtown', 107, '2020-01-31', 371, NULL),
('Hilton Downtown', 107, '2020-02-01', 336, NULL),
('Hilton Downtown', 107, '2020-02-02', 283, NULL),
('Hilton Downtown', 107, '2020-02-03', 283, NULL),
('Hilton Downtown', 107, '2020-02-04', 207, NULL),
('Hilton Downtown', 152, '2019-01-01', 155, NULL),
('Hilton Downtown', 152, '2019-01-02', 147, NULL),
('Hilton Downtown', 152, '2019-01-03', 314, NULL),
('Hilton Downtown', 152, '2019-01-04', 123, NULL),
('Hilton Downtown', 152, '2019-01-05', 157, NULL),
('Hilton Downtown', 152, '2019-01-06', 363, NULL),
('Hilton Downtown', 152, '2019-01-07', 104, NULL),
('Hilton Downtown', 152, '2019-01-08', 107, NULL),
('Hilton Downtown', 152, '2019-01-09', 184, NULL),
('Hilton Downtown', 152, '2019-01-10', 305, NULL),
('Hilton Downtown', 152, '2019-01-11', 289, NULL),
('Hilton Downtown', 152, '2019-01-12', 257, NULL),
('Hilton Downtown', 152, '2019-01-13', 243, NULL),
('Hilton Downtown', 152, '2019-01-14', 108, NULL),
('Hilton Downtown', 152, '2019-01-15', 105, NULL),
('Hilton Downtown', 152, '2019-01-16', 104, NULL),
('Hilton Downtown', 152, '2019-01-17', 124, NULL),
('Hilton Downtown', 152, '2019-01-18', 358, NULL),
('Hilton Downtown', 152, '2019-01-19', 250, NULL),
('Hilton Downtown', 152, '2019-01-20', 248, NULL),
('Hilton Downtown', 152, '2019-01-21', 344, NULL),
('Hilton Downtown', 152, '2019-01-22', 296, NULL),
('Hilton Downtown', 152, '2019-01-23', 162, NULL),
('Hilton Downtown', 152, '2019-01-24', 384, NULL),
('Hilton Downtown', 152, '2019-01-25', 338, NULL),
('Hilton Downtown', 152, '2019-01-26', 143, NULL),
('Hilton Downtown', 152, '2019-01-27', 155, NULL),
('Hilton Downtown', 152, '2019-01-28', 265, NULL),
('Hilton Downtown', 152, '2019-01-29', 272, NULL),
('Hilton Downtown', 152, '2019-01-30', 190, NULL),
('Hilton Downtown', 152, '2019-01-31', 288, NULL),
('Hilton Downtown', 152, '2019-02-01', 176, NULL),
('Hilton Downtown', 152, '2019-02-02', 256, NULL),
('Hilton Downtown', 152, '2019-02-03', 269, NULL),
('Hilton Downtown', 152, '2019-02-04', 355, NULL),
('Hilton Downtown', 152, '2019-02-05', 317, NULL),
('Hilton Downtown', 152, '2019-02-06', 347, NULL),
('Hilton Downtown', 152, '2019-02-07', 230, NULL),
('Hilton Downtown', 152, '2019-02-08', 170, NULL),
('Hilton Downtown', 152, '2019-02-09', 112, NULL),
('Hilton Downtown', 152, '2019-02-10', 123, NULL),
('Hilton Downtown', 152, '2019-02-11', 122, NULL),
('Hilton Downtown', 152, '2019-02-12', 361, NULL),
('Hilton Downtown', 152, '2019-02-13', 210, NULL),
('Hilton Downtown', 152, '2019-02-14', 184, NULL),
('Hilton Downtown', 152, '2019-02-15', 316, NULL),
('Hilton Downtown', 152, '2019-02-16', 228, NULL),
('Hilton Downtown', 152, '2019-02-17', 350, NULL),
('Hilton Downtown', 152, '2019-02-18', 312, NULL),
('Hilton Downtown', 152, '2019-02-19', 264, NULL),
('Hilton Downtown', 152, '2019-02-20', 179, NULL),
('Hilton Downtown', 152, '2019-02-21', 196, NULL),
('Hilton Downtown', 152, '2019-02-22', 248, NULL),
('Hilton Downtown', 152, '2019-02-23', 317, NULL),
('Hilton Downtown', 152, '2019-02-24', 342, NULL),
('Hilton Downtown', 152, '2019-02-25', 196, NULL),
('Hilton Downtown', 152, '2019-02-26', 177, NULL),
('Hilton Downtown', 152, '2019-02-27', 105, NULL),
('Hilton Downtown', 152, '2019-02-28', 216, NULL),
('Hilton Downtown', 152, '2019-03-01', 171, NULL),
('Hilton Downtown', 152, '2019-03-02', 231, NULL),
('Hilton Downtown', 152, '2019-03-03', 187, NULL),
('Hilton Downtown', 152, '2019-03-04', 389, NULL),
('Hilton Downtown', 152, '2019-03-05', 288, NULL),
('Hilton Downtown', 152, '2019-03-06', 242, NULL),
('Hilton Downtown', 152, '2019-03-07', 160, NULL),
('Hilton Downtown', 152, '2019-03-08', 101, NULL),
('Hilton Downtown', 152, '2019-03-09', 119, NULL),
('Hilton Downtown', 152, '2019-03-10', 167, NULL),
('Hilton Downtown', 152, '2019-03-11', 269, NULL),
('Hilton Downtown', 152, '2019-03-12', 105, NULL),
('Hilton Downtown', 152, '2019-03-13', 214, NULL),
('Hilton Downtown', 152, '2019-03-14', 115, NULL),
('Hilton Downtown', 152, '2019-03-15', 221, NULL),
('Hilton Downtown', 152, '2019-03-16', 263, NULL),
('Hilton Downtown', 152, '2019-03-17', 218, NULL),
('Hilton Downtown', 152, '2019-03-18', 206, NULL),
('Hilton Downtown', 152, '2019-03-19', 278, NULL),
('Hilton Downtown', 152, '2019-03-20', 302, NULL),
('Hilton Downtown', 152, '2019-03-21', 267, NULL),
('Hilton Downtown', 152, '2019-03-22', 237, NULL),
('Hilton Downtown', 152, '2019-03-23', 367, NULL),
('Hilton Downtown', 152, '2019-03-24', 151, NULL),
('Hilton Downtown', 152, '2019-03-25', 245, NULL),
('Hilton Downtown', 152, '2019-03-26', 178, NULL),
('Hilton Downtown', 152, '2019-03-27', 303, NULL),
('Hilton Downtown', 152, '2019-03-28', 297, NULL),
('Hilton Downtown', 152, '2019-03-29', 255, NULL),
('Hilton Downtown', 152, '2019-03-30', 262, NULL),
('Hilton Downtown', 152, '2019-03-31', 142, NULL),
('Hilton Downtown', 152, '2019-04-01', 259, NULL),
('Hilton Downtown', 152, '2019-04-02', 237, NULL),
('Hilton Downtown', 152, '2019-04-03', 286, NULL),
('Hilton Downtown', 152, '2019-04-04', 257, NULL),
('Hilton Downtown', 152, '2019-04-05', 117, NULL),
('Hilton Downtown', 152, '2019-04-06', 311, NULL),
('Hilton Downtown', 152, '2019-04-07', 248, NULL),
('Hilton Downtown', 152, '2019-04-08', 148, NULL),
('Hilton Downtown', 152, '2019-04-09', 136, NULL),
('Hilton Downtown', 152, '2019-04-10', 221, NULL),
('Hilton Downtown', 152, '2019-04-11', 189, NULL),
('Hilton Downtown', 152, '2019-04-12', 348, NULL),
('Hilton Downtown', 152, '2019-04-13', 218, NULL),
('Hilton Downtown', 152, '2019-04-14', 120, NULL),
('Hilton Downtown', 152, '2019-04-15', 233, NULL),
('Hilton Downtown', 152, '2019-04-16', 271, NULL),
('Hilton Downtown', 152, '2019-04-17', 227, NULL),
('Hilton Downtown', 152, '2019-04-18', 290, NULL),
('Hilton Downtown', 152, '2019-04-19', 278, NULL),
('Hilton Downtown', 152, '2019-04-20', 126, NULL),
('Hilton Downtown', 152, '2019-04-21', 165, NULL),
('Hilton Downtown', 152, '2019-04-22', 296, NULL),
('Hilton Downtown', 152, '2019-04-23', 244, NULL),
('Hilton Downtown', 152, '2019-04-24', 141, NULL),
('Hilton Downtown', 152, '2019-04-25', 167, NULL),
('Hilton Downtown', 152, '2019-04-26', 216, NULL),
('Hilton Downtown', 152, '2019-04-27', 384, NULL),
('Hilton Downtown', 152, '2019-04-28', 107, NULL),
('Hilton Downtown', 152, '2019-04-29', 344, NULL),
('Hilton Downtown', 152, '2019-04-30', 142, NULL),
('Hilton Downtown', 152, '2019-05-01', 313, NULL),
('Hilton Downtown', 152, '2019-05-02', 231, NULL),
('Hilton Downtown', 152, '2019-05-03', 207, NULL),
('Hilton Downtown', 152, '2019-05-04', 172, NULL),
('Hilton Downtown', 152, '2019-05-05', 140, NULL),
('Hilton Downtown', 152, '2019-05-06', 110, NULL),
('Hilton Downtown', 152, '2019-05-07', 222, NULL),
('Hilton Downtown', 152, '2019-05-08', 271, NULL),
('Hilton Downtown', 152, '2019-05-09', 274, NULL),
('Hilton Downtown', 152, '2019-05-10', 334, NULL),
('Hilton Downtown', 152, '2019-05-11', 197, NULL),
('Hilton Downtown', 152, '2019-05-12', 248, NULL),
('Hilton Downtown', 152, '2019-05-13', 380, NULL),
('Hilton Downtown', 152, '2019-05-14', 281, NULL),
('Hilton Downtown', 152, '2019-05-15', 187, NULL),
('Hilton Downtown', 152, '2019-05-16', 396, NULL),
('Hilton Downtown', 152, '2019-05-17', 265, NULL),
('Hilton Downtown', 152, '2019-05-18', 293, NULL),
('Hilton Downtown', 152, '2019-05-19', 232, NULL),
('Hilton Downtown', 152, '2019-05-20', 331, NULL),
('Hilton Downtown', 152, '2019-05-21', 105, NULL),
('Hilton Downtown', 152, '2019-05-22', 160, NULL),
('Hilton Downtown', 152, '2019-05-23', 298, NULL),
('Hilton Downtown', 152, '2019-05-24', 395, NULL),
('Hilton Downtown', 152, '2019-05-25', 106, NULL),
('Hilton Downtown', 152, '2019-05-26', 107, NULL),
('Hilton Downtown', 152, '2019-05-27', 271, NULL),
('Hilton Downtown', 152, '2019-05-28', 102, NULL),
('Hilton Downtown', 152, '2019-05-29', 241, NULL),
('Hilton Downtown', 152, '2019-05-30', 318, NULL),
('Hilton Downtown', 152, '2019-05-31', 388, NULL),
('Hilton Downtown', 152, '2019-06-01', 157, NULL),
('Hilton Downtown', 152, '2019-06-02', 223, NULL),
('Hilton Downtown', 152, '2019-06-03', 277, NULL),
('Hilton Downtown', 152, '2019-06-04', 236, NULL),
('Hilton Downtown', 152, '2019-06-05', 121, NULL),
('Hilton Downtown', 152, '2019-06-06', 329, NULL),
('Hilton Downtown', 152, '2019-06-07', 349, NULL),
('Hilton Downtown', 152, '2019-06-08', 126, NULL),
('Hilton Downtown', 152, '2019-06-09', 209, NULL),
('Hilton Downtown', 152, '2019-06-10', 339, NULL),
('Hilton Downtown', 152, '2019-06-11', 359, NULL),
('Hilton Downtown', 152, '2019-06-12', 194, NULL),
('Hilton Downtown', 152, '2019-06-13', 229, NULL),
('Hilton Downtown', 152, '2019-06-14', 384, NULL),
('Hilton Downtown', 152, '2019-06-15', 226, NULL),
('Hilton Downtown', 152, '2019-06-16', 313, NULL),
('Hilton Downtown', 152, '2019-06-17', 220, NULL),
('Hilton Downtown', 152, '2019-06-18', 134, NULL),
('Hilton Downtown', 152, '2019-06-19', 236, NULL),
('Hilton Downtown', 152, '2019-06-20', 257, NULL),
('Hilton Downtown', 152, '2019-06-21', 226, NULL),
('Hilton Downtown', 152, '2019-06-22', 376, NULL),
('Hilton Downtown', 152, '2019-06-23', 241, NULL),
('Hilton Downtown', 152, '2019-06-24', 127, NULL),
('Hilton Downtown', 152, '2019-06-25', 101, NULL),
('Hilton Downtown', 152, '2019-06-26', 187, NULL),
('Hilton Downtown', 152, '2019-06-27', 258, NULL),
('Hilton Downtown', 152, '2019-06-28', 384, NULL),
('Hilton Downtown', 152, '2019-06-29', 206, NULL),
('Hilton Downtown', 152, '2019-06-30', 223, NULL),
('Hilton Downtown', 152, '2019-07-01', 388, NULL),
('Hilton Downtown', 152, '2019-07-02', 116, NULL),
('Hilton Downtown', 152, '2019-07-03', 370, NULL),
('Hilton Downtown', 152, '2019-07-04', 135, NULL),
('Hilton Downtown', 152, '2019-07-05', 281, NULL),
('Hilton Downtown', 152, '2019-07-06', 102, NULL),
('Hilton Downtown', 152, '2019-07-07', 303, NULL),
('Hilton Downtown', 152, '2019-07-08', 185, NULL),
('Hilton Downtown', 152, '2019-07-09', 163, NULL),
('Hilton Downtown', 152, '2019-07-10', 367, NULL),
('Hilton Downtown', 152, '2019-07-11', 226, NULL),
('Hilton Downtown', 152, '2019-07-12', 100, NULL),
('Hilton Downtown', 152, '2019-07-13', 342, NULL),
('Hilton Downtown', 152, '2019-07-14', 149, NULL),
('Hilton Downtown', 152, '2019-07-15', 398, NULL),
('Hilton Downtown', 152, '2019-07-16', 377, NULL),
('Hilton Downtown', 152, '2019-07-17', 105, NULL),
('Hilton Downtown', 152, '2019-07-18', 343, NULL),
('Hilton Downtown', 152, '2019-07-19', 237, NULL),
('Hilton Downtown', 152, '2019-07-20', 394, NULL),
('Hilton Downtown', 152, '2019-07-21', 167, NULL),
('Hilton Downtown', 152, '2019-07-22', 390, NULL),
('Hilton Downtown', 152, '2019-07-23', 104, NULL),
('Hilton Downtown', 152, '2019-07-24', 121, NULL),
('Hilton Downtown', 152, '2019-07-25', 104, NULL),
('Hilton Downtown', 152, '2019-07-26', 393, NULL),
('Hilton Downtown', 152, '2019-07-27', 211, NULL),
('Hilton Downtown', 152, '2019-07-28', 368, NULL),
('Hilton Downtown', 152, '2019-07-29', 146, NULL),
('Hilton Downtown', 152, '2019-07-30', 314, NULL),
('Hilton Downtown', 152, '2019-07-31', 194, NULL),
('Hilton Downtown', 152, '2019-08-01', 348, NULL),
('Hilton Downtown', 152, '2019-08-02', 197, NULL),
('Hilton Downtown', 152, '2019-08-03', 359, NULL),
('Hilton Downtown', 152, '2019-08-04', 189, NULL),
('Hilton Downtown', 152, '2019-08-05', 307, NULL),
('Hilton Downtown', 152, '2019-08-06', 256, NULL),
('Hilton Downtown', 152, '2019-08-07', 103, NULL),
('Hilton Downtown', 152, '2019-08-08', 137, NULL),
('Hilton Downtown', 152, '2019-08-09', 268, NULL),
('Hilton Downtown', 152, '2019-08-10', 338, NULL),
('Hilton Downtown', 152, '2019-08-11', 235, NULL),
('Hilton Downtown', 152, '2019-08-12', 216, NULL),
('Hilton Downtown', 152, '2019-08-13', 227, NULL),
('Hilton Downtown', 152, '2019-08-14', 181, NULL),
('Hilton Downtown', 152, '2019-08-15', 393, NULL),
('Hilton Downtown', 152, '2019-08-16', 328, NULL),
('Hilton Downtown', 152, '2019-08-17', 319, NULL),
('Hilton Downtown', 152, '2019-08-18', 276, NULL),
('Hilton Downtown', 152, '2019-08-19', 201, NULL),
('Hilton Downtown', 152, '2019-08-20', 212, NULL),
('Hilton Downtown', 152, '2019-08-21', 133, NULL),
('Hilton Downtown', 152, '2019-08-22', 143, NULL),
('Hilton Downtown', 152, '2019-08-23', 358, NULL),
('Hilton Downtown', 152, '2019-08-24', 325, NULL),
('Hilton Downtown', 152, '2019-08-25', 316, NULL),
('Hilton Downtown', 152, '2019-08-26', 183, NULL),
('Hilton Downtown', 152, '2019-08-27', 143, NULL),
('Hilton Downtown', 152, '2019-08-28', 175, NULL),
('Hilton Downtown', 152, '2019-08-29', 212, NULL),
('Hilton Downtown', 152, '2019-08-30', 254, NULL),
('Hilton Downtown', 152, '2019-08-31', 358, NULL),
('Hilton Downtown', 152, '2019-09-01', 158, NULL),
('Hilton Downtown', 152, '2019-09-02', 266, NULL),
('Hilton Downtown', 152, '2019-09-03', 287, NULL),
('Hilton Downtown', 152, '2019-09-04', 151, NULL),
('Hilton Downtown', 152, '2019-09-05', 352, NULL),
('Hilton Downtown', 152, '2019-09-06', 152, NULL),
('Hilton Downtown', 152, '2019-09-07', 399, NULL),
('Hilton Downtown', 152, '2019-09-08', 140, NULL),
('Hilton Downtown', 152, '2019-09-09', 393, NULL),
('Hilton Downtown', 152, '2019-09-10', 139, NULL),
('Hilton Downtown', 152, '2019-09-11', 157, NULL),
('Hilton Downtown', 152, '2019-09-12', 273, NULL),
('Hilton Downtown', 152, '2019-09-13', 168, NULL),
('Hilton Downtown', 152, '2019-09-14', 201, NULL),
('Hilton Downtown', 152, '2019-09-15', 109, NULL),
('Hilton Downtown', 152, '2019-09-16', 263, NULL),
('Hilton Downtown', 152, '2019-09-17', 381, NULL),
('Hilton Downtown', 152, '2019-09-18', 332, NULL),
('Hilton Downtown', 152, '2019-09-19', 212, NULL),
('Hilton Downtown', 152, '2019-09-20', 147, NULL),
('Hilton Downtown', 152, '2019-09-21', 322, NULL),
('Hilton Downtown', 152, '2019-09-22', 247, NULL),
('Hilton Downtown', 152, '2019-09-23', 295, NULL),
('Hilton Downtown', 152, '2019-09-24', 103, NULL),
('Hilton Downtown', 152, '2019-09-25', 214, NULL),
('Hilton Downtown', 152, '2019-09-26', 241, NULL),
('Hilton Downtown', 152, '2019-09-27', 265, NULL),
('Hilton Downtown', 152, '2019-09-28', 396, NULL),
('Hilton Downtown', 152, '2019-09-29', 143, NULL),
('Hilton Downtown', 152, '2019-09-30', 253, NULL),
('Hilton Downtown', 152, '2019-10-01', 300, NULL),
('Hilton Downtown', 152, '2019-10-02', 267, NULL),
('Hilton Downtown', 152, '2019-10-03', 106, NULL),
('Hilton Downtown', 152, '2019-10-04', 213, NULL),
('Hilton Downtown', 152, '2019-10-05', 226, NULL),
('Hilton Downtown', 152, '2019-10-06', 193, NULL),
('Hilton Downtown', 152, '2019-10-07', 390, NULL),
('Hilton Downtown', 152, '2019-10-08', 224, NULL),
('Hilton Downtown', 152, '2019-10-09', 226, NULL),
('Hilton Downtown', 152, '2019-10-10', 370, NULL),
('Hilton Downtown', 152, '2019-10-11', 155, NULL),
('Hilton Downtown', 152, '2019-10-12', 252, NULL),
('Hilton Downtown', 152, '2019-10-13', 299, NULL),
('Hilton Downtown', 152, '2019-10-14', 306, NULL),
('Hilton Downtown', 152, '2019-10-15', 248, NULL),
('Hilton Downtown', 152, '2019-10-16', 203, NULL),
('Hilton Downtown', 152, '2019-10-17', 360, NULL),
('Hilton Downtown', 152, '2019-10-18', 170, NULL),
('Hilton Downtown', 152, '2019-10-19', 337, NULL),
('Hilton Downtown', 152, '2019-10-20', 191, NULL),
('Hilton Downtown', 152, '2019-10-21', 371, NULL),
('Hilton Downtown', 152, '2019-10-22', 109, NULL),
('Hilton Downtown', 152, '2019-10-23', 147, NULL),
('Hilton Downtown', 152, '2019-10-24', 259, NULL),
('Hilton Downtown', 152, '2019-10-25', 298, NULL),
('Hilton Downtown', 152, '2019-10-26', 270, NULL),
('Hilton Downtown', 152, '2019-10-27', 383, NULL),
('Hilton Downtown', 152, '2019-10-28', 228, NULL),
('Hilton Downtown', 152, '2019-10-29', 229, NULL),
('Hilton Downtown', 152, '2019-10-30', 192, NULL),
('Hilton Downtown', 152, '2019-10-31', 141, NULL),
('Hilton Downtown', 152, '2019-11-01', 302, NULL),
('Hilton Downtown', 152, '2019-11-02', 209, NULL),
('Hilton Downtown', 152, '2019-11-03', 212, NULL),
('Hilton Downtown', 152, '2019-11-04', 194, NULL),
('Hilton Downtown', 152, '2019-11-05', 151, NULL),
('Hilton Downtown', 152, '2019-11-06', 312, NULL),
('Hilton Downtown', 152, '2019-11-07', 165, NULL),
('Hilton Downtown', 152, '2019-11-08', 296, NULL),
('Hilton Downtown', 152, '2019-11-09', 164, NULL),
('Hilton Downtown', 152, '2019-11-10', 314, NULL),
('Hilton Downtown', 152, '2019-11-11', 275, NULL),
('Hilton Downtown', 152, '2019-11-12', 385, NULL),
('Hilton Downtown', 152, '2019-11-13', 346, NULL),
('Hilton Downtown', 152, '2019-11-14', 212, NULL),
('Hilton Downtown', 152, '2019-11-15', 356, NULL),
('Hilton Downtown', 152, '2019-11-16', 221, NULL),
('Hilton Downtown', 152, '2019-11-17', 364, NULL),
('Hilton Downtown', 152, '2019-11-18', 160, NULL),
('Hilton Downtown', 152, '2019-11-19', 337, NULL),
('Hilton Downtown', 152, '2019-11-20', 372, NULL),
('Hilton Downtown', 152, '2019-11-21', 263, NULL),
('Hilton Downtown', 152, '2019-11-22', 385, NULL),
('Hilton Downtown', 152, '2019-11-23', 317, NULL),
('Hilton Downtown', 152, '2019-11-24', 381, NULL),
('Hilton Downtown', 152, '2019-11-25', 297, NULL),
('Hilton Downtown', 152, '2019-11-26', 187, NULL),
('Hilton Downtown', 152, '2019-11-27', 189, NULL),
('Hilton Downtown', 152, '2019-11-28', 358, NULL),
('Hilton Downtown', 152, '2019-11-29', 373, NULL),
('Hilton Downtown', 152, '2019-11-30', 398, NULL),
('Hilton Downtown', 152, '2019-12-01', 218, NULL),
('Hilton Downtown', 152, '2019-12-02', 154, NULL),
('Hilton Downtown', 152, '2019-12-03', 263, NULL),
('Hilton Downtown', 152, '2019-12-04', 379, NULL),
('Hilton Downtown', 152, '2019-12-05', 258, NULL),
('Hilton Downtown', 152, '2019-12-06', 308, NULL),
('Hilton Downtown', 152, '2019-12-07', 295, NULL),
('Hilton Downtown', 152, '2019-12-08', 135, NULL),
('Hilton Downtown', 152, '2019-12-09', 315, NULL),
('Hilton Downtown', 152, '2019-12-10', 173, NULL),
('Hilton Downtown', 152, '2019-12-11', 252, NULL),
('Hilton Downtown', 152, '2019-12-12', 261, NULL),
('Hilton Downtown', 152, '2019-12-13', 193, NULL),
('Hilton Downtown', 152, '2019-12-14', 206, NULL),
('Hilton Downtown', 152, '2019-12-15', 271, NULL),
('Hilton Downtown', 152, '2019-12-16', 345, NULL),
('Hilton Downtown', 152, '2019-12-17', 190, NULL),
('Hilton Downtown', 152, '2019-12-18', 330, NULL),
('Hilton Downtown', 152, '2019-12-19', 200, NULL),
('Hilton Downtown', 152, '2019-12-20', 233, NULL),
('Hilton Downtown', 152, '2019-12-21', 134, NULL),
('Hilton Downtown', 152, '2019-12-22', 388, NULL),
('Hilton Downtown', 152, '2019-12-23', 295, NULL),
('Hilton Downtown', 152, '2019-12-24', 132, NULL),
('Hilton Downtown', 152, '2019-12-25', 244, NULL),
('Hilton Downtown', 152, '2019-12-26', 182, NULL),
('Hilton Downtown', 152, '2019-12-27', 106, NULL),
('Hilton Downtown', 152, '2019-12-28', 203, NULL),
('Hilton Downtown', 152, '2019-12-29', 118, NULL),
('Hilton Downtown', 152, '2019-12-30', 226, NULL),
('Hilton Downtown', 152, '2019-12-31', 358, NULL),
('Hilton Downtown', 152, '2020-01-01', 331, NULL),
('Hilton Downtown', 152, '2020-01-02', 312, NULL),
('Hilton Downtown', 152, '2020-01-03', 341, NULL),
('Hilton Downtown', 152, '2020-01-04', 242, NULL),
('Hilton Downtown', 152, '2020-01-05', 392, NULL),
('Hilton Downtown', 152, '2020-01-06', 346, NULL),
('Hilton Downtown', 152, '2020-01-07', 255, NULL),
('Hilton Downtown', 152, '2020-01-08', 276, NULL),
('Hilton Downtown', 152, '2020-01-09', 121, NULL),
('Hilton Downtown', 152, '2020-01-10', 187, NULL),
('Hilton Downtown', 152, '2020-01-11', 149, NULL),
('Hilton Downtown', 152, '2020-01-12', 124, NULL),
('Hilton Downtown', 152, '2020-01-13', 109, NULL),
('Hilton Downtown', 152, '2020-01-14', 292, NULL),
('Hilton Downtown', 152, '2020-01-15', 103, NULL),
('Hilton Downtown', 152, '2020-01-16', 163, NULL),
('Hilton Downtown', 152, '2020-01-17', 321, NULL),
('Hilton Downtown', 152, '2020-01-18', 355, NULL),
('Hilton Downtown', 152, '2020-01-19', 313, NULL),
('Hilton Downtown', 152, '2020-01-20', 183, NULL),
('Hilton Downtown', 152, '2020-01-21', 219, NULL),
('Hilton Downtown', 152, '2020-01-22', 176, NULL),
('Hilton Downtown', 152, '2020-01-23', 180, NULL),
('Hilton Downtown', 152, '2020-01-24', 118, NULL),
('Hilton Downtown', 152, '2020-01-25', 382, NULL),
('Hilton Downtown', 152, '2020-01-26', 166, NULL),
('Hilton Downtown', 152, '2020-01-27', 124, NULL),
('Hilton Downtown', 152, '2020-01-28', 118, NULL),
('Hilton Downtown', 152, '2020-01-29', 381, NULL),
('Hilton Downtown', 152, '2020-01-30', 341, NULL),
('Hilton Downtown', 152, '2020-01-31', 212, NULL),
('Hilton Downtown', 152, '2020-02-01', 148, NULL),
('Hilton Downtown', 152, '2020-02-02', 363, NULL),
('Hilton Downtown', 152, '2020-02-03', 261, NULL),
('Hilton Downtown', 152, '2020-02-04', 165, NULL),
('Hilton Downtown', 186, '2019-01-01', 112, NULL),
('Hilton Downtown', 186, '2019-01-02', 167, NULL),
('Hilton Downtown', 186, '2019-01-03', 231, NULL),
('Hilton Downtown', 186, '2019-01-04', 340, NULL),
('Hilton Downtown', 186, '2019-01-05', 134, NULL),
('Hilton Downtown', 186, '2019-01-06', 347, NULL),
('Hilton Downtown', 186, '2019-01-07', 115, NULL),
('Hilton Downtown', 186, '2019-01-08', 331, NULL),
('Hilton Downtown', 186, '2019-01-09', 283, NULL),
('Hilton Downtown', 186, '2019-01-10', 185, NULL),
('Hilton Downtown', 186, '2019-01-11', 398, NULL),
('Hilton Downtown', 186, '2019-01-12', 163, NULL),
('Hilton Downtown', 186, '2019-01-13', 216, NULL),
('Hilton Downtown', 186, '2019-01-14', 143, NULL),
('Hilton Downtown', 186, '2019-01-15', 330, NULL),
('Hilton Downtown', 186, '2019-01-16', 342, NULL),
('Hilton Downtown', 186, '2019-01-17', 387, NULL),
('Hilton Downtown', 186, '2019-01-18', 381, NULL),
('Hilton Downtown', 186, '2019-01-19', 216, NULL),
('Hilton Downtown', 186, '2019-01-20', 317, NULL),
('Hilton Downtown', 186, '2019-01-21', 281, NULL),
('Hilton Downtown', 186, '2019-01-22', 211, NULL),
('Hilton Downtown', 186, '2019-01-23', 186, NULL),
('Hilton Downtown', 186, '2019-01-24', 279, NULL),
('Hilton Downtown', 186, '2019-01-25', 288, NULL),
('Hilton Downtown', 186, '2019-01-26', 238, NULL),
('Hilton Downtown', 186, '2019-01-27', 243, NULL),
('Hilton Downtown', 186, '2019-01-28', 247, NULL),
('Hilton Downtown', 186, '2019-01-29', 249, NULL),
('Hilton Downtown', 186, '2019-01-30', 283, NULL),
('Hilton Downtown', 186, '2019-01-31', 280, NULL),
('Hilton Downtown', 186, '2019-02-01', 156, NULL),
('Hilton Downtown', 186, '2019-02-02', 117, NULL),
('Hilton Downtown', 186, '2019-02-03', 346, NULL),
('Hilton Downtown', 186, '2019-02-04', 231, NULL),
('Hilton Downtown', 186, '2019-02-05', 212, NULL),
('Hilton Downtown', 186, '2019-02-06', 382, NULL),
('Hilton Downtown', 186, '2019-02-07', 176, NULL),
('Hilton Downtown', 186, '2019-02-08', 366, NULL),
('Hilton Downtown', 186, '2019-02-09', 200, NULL),
('Hilton Downtown', 186, '2019-02-10', 360, NULL),
('Hilton Downtown', 186, '2019-02-11', 225, NULL),
('Hilton Downtown', 186, '2019-02-12', 246, NULL),
('Hilton Downtown', 186, '2019-02-13', 261, NULL),
('Hilton Downtown', 186, '2019-02-14', 243, NULL),
('Hilton Downtown', 186, '2019-02-15', 312, NULL),
('Hilton Downtown', 186, '2019-02-16', 372, NULL),
('Hilton Downtown', 186, '2019-02-17', 377, NULL),
('Hilton Downtown', 186, '2019-02-18', 151, NULL),
('Hilton Downtown', 186, '2019-02-19', 154, NULL),
('Hilton Downtown', 186, '2019-02-20', 276, NULL),
('Hilton Downtown', 186, '2019-02-21', 184, NULL),
('Hilton Downtown', 186, '2019-02-22', 206, NULL),
('Hilton Downtown', 186, '2019-02-23', 188, NULL),
('Hilton Downtown', 186, '2019-02-24', 237, NULL),
('Hilton Downtown', 186, '2019-02-25', 137, NULL),
('Hilton Downtown', 186, '2019-02-26', 370, NULL),
('Hilton Downtown', 186, '2019-02-27', 140, NULL),
('Hilton Downtown', 186, '2019-02-28', 284, NULL),
('Hilton Downtown', 186, '2019-03-01', 218, NULL),
('Hilton Downtown', 186, '2019-03-02', 280, NULL),
('Hilton Downtown', 186, '2019-03-03', 388, NULL),
('Hilton Downtown', 186, '2019-03-04', 394, NULL),
('Hilton Downtown', 186, '2019-03-05', 398, NULL),
('Hilton Downtown', 186, '2019-03-06', 266, NULL),
('Hilton Downtown', 186, '2019-03-07', 217, NULL),
('Hilton Downtown', 186, '2019-03-08', 235, NULL),
('Hilton Downtown', 186, '2019-03-09', 344, NULL),
('Hilton Downtown', 186, '2019-03-10', 280, NULL),
('Hilton Downtown', 186, '2019-03-11', 347, NULL),
('Hilton Downtown', 186, '2019-03-12', 158, NULL),
('Hilton Downtown', 186, '2019-03-13', 361, NULL),
('Hilton Downtown', 186, '2019-03-14', 156, NULL),
('Hilton Downtown', 186, '2019-03-15', 203, NULL),
('Hilton Downtown', 186, '2019-03-16', 111, NULL),
('Hilton Downtown', 186, '2019-03-17', 129, NULL),
('Hilton Downtown', 186, '2019-03-18', 309, NULL),
('Hilton Downtown', 186, '2019-03-19', 132, NULL),
('Hilton Downtown', 186, '2019-03-20', 327, NULL),
('Hilton Downtown', 186, '2019-03-21', 163, NULL),
('Hilton Downtown', 186, '2019-03-22', 344, NULL),
('Hilton Downtown', 186, '2019-03-23', 197, NULL),
('Hilton Downtown', 186, '2019-03-24', 392, NULL),
('Hilton Downtown', 186, '2019-03-25', 155, NULL),
('Hilton Downtown', 186, '2019-03-26', 157, NULL),
('Hilton Downtown', 186, '2019-03-27', 321, NULL),
('Hilton Downtown', 186, '2019-03-28', 351, NULL),
('Hilton Downtown', 186, '2019-03-29', 118, NULL),
('Hilton Downtown', 186, '2019-03-30', 299, NULL),
('Hilton Downtown', 186, '2019-03-31', 218, NULL),
('Hilton Downtown', 186, '2019-04-01', 142, NULL),
('Hilton Downtown', 186, '2019-04-02', 157, NULL),
('Hilton Downtown', 186, '2019-04-03', 304, NULL),
('Hilton Downtown', 186, '2019-04-04', 153, NULL),
('Hilton Downtown', 186, '2019-04-05', 291, NULL),
('Hilton Downtown', 186, '2019-04-06', 261, NULL),
('Hilton Downtown', 186, '2019-04-07', 124, NULL),
('Hilton Downtown', 186, '2019-04-08', 331, NULL),
('Hilton Downtown', 186, '2019-04-09', 360, NULL),
('Hilton Downtown', 186, '2019-04-10', 276, NULL),
('Hilton Downtown', 186, '2019-04-11', 259, NULL),
('Hilton Downtown', 186, '2019-04-12', 186, NULL),
('Hilton Downtown', 186, '2019-04-13', 262, NULL),
('Hilton Downtown', 186, '2019-04-14', 275, NULL),
('Hilton Downtown', 186, '2019-04-15', 186, NULL),
('Hilton Downtown', 186, '2019-04-16', 282, NULL),
('Hilton Downtown', 186, '2019-04-17', 367, NULL),
('Hilton Downtown', 186, '2019-04-18', 228, NULL),
('Hilton Downtown', 186, '2019-04-19', 240, NULL),
('Hilton Downtown', 186, '2019-04-20', 253, NULL),
('Hilton Downtown', 186, '2019-04-21', 258, NULL),
('Hilton Downtown', 186, '2019-04-22', 121, NULL),
('Hilton Downtown', 186, '2019-04-23', 207, NULL),
('Hilton Downtown', 186, '2019-04-24', 219, NULL),
('Hilton Downtown', 186, '2019-04-25', 251, NULL),
('Hilton Downtown', 186, '2019-04-26', 133, NULL),
('Hilton Downtown', 186, '2019-04-27', 231, NULL),
('Hilton Downtown', 186, '2019-04-28', 310, NULL),
('Hilton Downtown', 186, '2019-04-29', 330, NULL),
('Hilton Downtown', 186, '2019-04-30', 338, NULL),
('Hilton Downtown', 186, '2019-05-01', 169, NULL),
('Hilton Downtown', 186, '2019-05-02', 350, NULL),
('Hilton Downtown', 186, '2019-05-03', 145, NULL),
('Hilton Downtown', 186, '2019-05-04', 179, NULL),
('Hilton Downtown', 186, '2019-05-05', 189, NULL),
('Hilton Downtown', 186, '2019-05-06', 362, NULL),
('Hilton Downtown', 186, '2019-05-07', 399, NULL),
('Hilton Downtown', 186, '2019-05-08', 104, NULL),
('Hilton Downtown', 186, '2019-05-09', 136, NULL),
('Hilton Downtown', 186, '2019-05-10', 323, NULL),
('Hilton Downtown', 186, '2019-05-11', 102, NULL),
('Hilton Downtown', 186, '2019-05-12', 260, NULL),
('Hilton Downtown', 186, '2019-05-13', 297, NULL),
('Hilton Downtown', 186, '2019-05-14', 292, NULL),
('Hilton Downtown', 186, '2019-05-15', 316, NULL),
('Hilton Downtown', 186, '2019-05-16', 270, NULL),
('Hilton Downtown', 186, '2019-05-17', 194, NULL),
('Hilton Downtown', 186, '2019-05-18', 163, NULL),
('Hilton Downtown', 186, '2019-05-19', 243, NULL),
('Hilton Downtown', 186, '2019-05-20', 117, NULL),
('Hilton Downtown', 186, '2019-05-21', 227, NULL),
('Hilton Downtown', 186, '2019-05-22', 323, NULL),
('Hilton Downtown', 186, '2019-05-23', 226, NULL),
('Hilton Downtown', 186, '2019-05-24', 392, NULL),
('Hilton Downtown', 186, '2019-05-25', 267, NULL),
('Hilton Downtown', 186, '2019-05-26', 272, NULL),
('Hilton Downtown', 186, '2019-05-27', 366, NULL),
('Hilton Downtown', 186, '2019-05-28', 111, NULL),
('Hilton Downtown', 186, '2019-05-29', 198, NULL),
('Hilton Downtown', 186, '2019-05-30', 369, NULL),
('Hilton Downtown', 186, '2019-05-31', 234, NULL),
('Hilton Downtown', 186, '2019-06-01', 371, NULL),
('Hilton Downtown', 186, '2019-06-02', 283, NULL),
('Hilton Downtown', 186, '2019-06-03', 329, NULL),
('Hilton Downtown', 186, '2019-06-04', 121, NULL),
('Hilton Downtown', 186, '2019-06-05', 281, NULL),
('Hilton Downtown', 186, '2019-06-06', 245, NULL),
('Hilton Downtown', 186, '2019-06-07', 226, NULL),
('Hilton Downtown', 186, '2019-06-08', 364, NULL),
('Hilton Downtown', 186, '2019-06-09', 198, NULL),
('Hilton Downtown', 186, '2019-06-10', 338, NULL),
('Hilton Downtown', 186, '2019-06-11', 219, NULL),
('Hilton Downtown', 186, '2019-06-12', 194, NULL),
('Hilton Downtown', 186, '2019-06-13', 334, NULL),
('Hilton Downtown', 186, '2019-06-14', 293, NULL),
('Hilton Downtown', 186, '2019-06-15', 285, NULL),
('Hilton Downtown', 186, '2019-06-16', 175, NULL),
('Hilton Downtown', 186, '2019-06-17', 148, NULL),
('Hilton Downtown', 186, '2019-06-18', 111, NULL),
('Hilton Downtown', 186, '2019-06-19', 167, NULL),
('Hilton Downtown', 186, '2019-06-20', 380, NULL),
('Hilton Downtown', 186, '2019-06-21', 216, NULL),
('Hilton Downtown', 186, '2019-06-22', 297, NULL),
('Hilton Downtown', 186, '2019-06-23', 225, NULL),
('Hilton Downtown', 186, '2019-06-24', 387, NULL),
('Hilton Downtown', 186, '2019-06-25', 111, NULL),
('Hilton Downtown', 186, '2019-06-26', 325, NULL),
('Hilton Downtown', 186, '2019-06-27', 194, NULL),
('Hilton Downtown', 186, '2019-06-28', 351, NULL),
('Hilton Downtown', 186, '2019-06-29', 354, NULL),
('Hilton Downtown', 186, '2019-06-30', 225, NULL),
('Hilton Downtown', 186, '2019-07-01', 262, NULL),
('Hilton Downtown', 186, '2019-07-02', 190, NULL),
('Hilton Downtown', 186, '2019-07-03', 310, NULL),
('Hilton Downtown', 186, '2019-07-04', 131, NULL),
('Hilton Downtown', 186, '2019-07-05', 171, NULL),
('Hilton Downtown', 186, '2019-07-06', 382, NULL),
('Hilton Downtown', 186, '2019-07-07', 140, NULL),
('Hilton Downtown', 186, '2019-07-08', 314, NULL),
('Hilton Downtown', 186, '2019-07-09', 191, NULL),
('Hilton Downtown', 186, '2019-07-10', 363, NULL),
('Hilton Downtown', 186, '2019-07-11', 343, NULL),
('Hilton Downtown', 186, '2019-07-12', 204, NULL),
('Hilton Downtown', 186, '2019-07-13', 272, NULL),
('Hilton Downtown', 186, '2019-07-14', 334, NULL),
('Hilton Downtown', 186, '2019-07-15', 258, NULL),
('Hilton Downtown', 186, '2019-07-16', 277, NULL),
('Hilton Downtown', 186, '2019-07-17', 358, NULL),
('Hilton Downtown', 186, '2019-07-18', 230, NULL),
('Hilton Downtown', 186, '2019-07-19', 206, NULL),
('Hilton Downtown', 186, '2019-07-20', 153, NULL),
('Hilton Downtown', 186, '2019-07-21', 317, NULL),
('Hilton Downtown', 186, '2019-07-22', 201, NULL),
('Hilton Downtown', 186, '2019-07-23', 329, NULL),
('Hilton Downtown', 186, '2019-07-24', 359, NULL),
('Hilton Downtown', 186, '2019-07-25', 100, NULL),
('Hilton Downtown', 186, '2019-07-26', 102, NULL),
('Hilton Downtown', 186, '2019-07-27', 108, NULL),
('Hilton Downtown', 186, '2019-07-28', 270, NULL),
('Hilton Downtown', 186, '2019-07-29', 278, NULL),
('Hilton Downtown', 186, '2019-07-30', 115, NULL),
('Hilton Downtown', 186, '2019-07-31', 143, NULL),
('Hilton Downtown', 186, '2019-08-01', 128, NULL),
('Hilton Downtown', 186, '2019-08-02', 147, NULL),
('Hilton Downtown', 186, '2019-08-03', 343, NULL),
('Hilton Downtown', 186, '2019-08-04', 118, NULL),
('Hilton Downtown', 186, '2019-08-05', 327, NULL),
('Hilton Downtown', 186, '2019-08-06', 201, NULL),
('Hilton Downtown', 186, '2019-08-07', 106, NULL),
('Hilton Downtown', 186, '2019-08-08', 288, NULL),
('Hilton Downtown', 186, '2019-08-09', 373, NULL),
('Hilton Downtown', 186, '2019-08-10', 183, NULL),
('Hilton Downtown', 186, '2019-08-11', 303, NULL),
('Hilton Downtown', 186, '2019-08-12', 327, NULL),
('Hilton Downtown', 186, '2019-08-13', 250, NULL),
('Hilton Downtown', 186, '2019-08-14', 314, NULL),
('Hilton Downtown', 186, '2019-08-15', 176, NULL),
('Hilton Downtown', 186, '2019-08-16', 219, NULL),
('Hilton Downtown', 186, '2019-08-17', 109, NULL),
('Hilton Downtown', 186, '2019-08-18', 393, NULL),
('Hilton Downtown', 186, '2019-08-19', 186, NULL),
('Hilton Downtown', 186, '2019-08-20', 231, NULL),
('Hilton Downtown', 186, '2019-08-21', 239, NULL),
('Hilton Downtown', 186, '2019-08-22', 297, NULL),
('Hilton Downtown', 186, '2019-08-23', 259, NULL),
('Hilton Downtown', 186, '2019-08-24', 235, NULL),
('Hilton Downtown', 186, '2019-08-25', 224, NULL),
('Hilton Downtown', 186, '2019-08-26', 320, NULL),
('Hilton Downtown', 186, '2019-08-27', 253, NULL),
('Hilton Downtown', 186, '2019-08-28', 176, NULL),
('Hilton Downtown', 186, '2019-08-29', 279, NULL),
('Hilton Downtown', 186, '2019-08-30', 139, NULL),
('Hilton Downtown', 186, '2019-08-31', 153, NULL),
('Hilton Downtown', 186, '2019-09-01', 110, NULL),
('Hilton Downtown', 186, '2019-09-02', 150, NULL),
('Hilton Downtown', 186, '2019-09-03', 327, NULL),
('Hilton Downtown', 186, '2019-09-04', 239, NULL),
('Hilton Downtown', 186, '2019-09-05', 121, NULL),
('Hilton Downtown', 186, '2019-09-06', 102, NULL),
('Hilton Downtown', 186, '2019-09-07', 336, NULL),
('Hilton Downtown', 186, '2019-09-08', 261, NULL),
('Hilton Downtown', 186, '2019-09-09', 121, NULL),
('Hilton Downtown', 186, '2019-09-10', 259, NULL),
('Hilton Downtown', 186, '2019-09-11', 264, NULL),
('Hilton Downtown', 186, '2019-09-12', 249, NULL),
('Hilton Downtown', 186, '2019-09-13', 108, NULL),
('Hilton Downtown', 186, '2019-09-14', 372, NULL),
('Hilton Downtown', 186, '2019-09-15', 157, NULL),
('Hilton Downtown', 186, '2019-09-16', 293, NULL),
('Hilton Downtown', 186, '2019-09-17', 323, NULL),
('Hilton Downtown', 186, '2019-09-18', 154, NULL),
('Hilton Downtown', 186, '2019-09-19', 155, NULL),
('Hilton Downtown', 186, '2019-09-20', 168, NULL),
('Hilton Downtown', 186, '2019-09-21', 225, NULL),
('Hilton Downtown', 186, '2019-09-22', 257, NULL),
('Hilton Downtown', 186, '2019-09-23', 262, NULL),
('Hilton Downtown', 186, '2019-09-24', 130, NULL),
('Hilton Downtown', 186, '2019-09-25', 183, NULL),
('Hilton Downtown', 186, '2019-09-26', 347, NULL),
('Hilton Downtown', 186, '2019-09-27', 194, NULL),
('Hilton Downtown', 186, '2019-09-28', 203, NULL),
('Hilton Downtown', 186, '2019-09-29', 108, NULL),
('Hilton Downtown', 186, '2019-09-30', 355, NULL),
('Hilton Downtown', 186, '2019-10-01', 249, NULL),
('Hilton Downtown', 186, '2019-10-02', 166, NULL),
('Hilton Downtown', 186, '2019-10-03', 226, NULL),
('Hilton Downtown', 186, '2019-10-04', 230, NULL),
('Hilton Downtown', 186, '2019-10-05', 239, NULL),
('Hilton Downtown', 186, '2019-10-06', 325, NULL),
('Hilton Downtown', 186, '2019-10-07', 183, NULL),
('Hilton Downtown', 186, '2019-10-08', 324, NULL),
('Hilton Downtown', 186, '2019-10-09', 288, NULL),
('Hilton Downtown', 186, '2019-10-10', 360, NULL),
('Hilton Downtown', 186, '2019-10-11', 282, NULL),
('Hilton Downtown', 186, '2019-10-12', 297, NULL),
('Hilton Downtown', 186, '2019-10-13', 309, NULL),
('Hilton Downtown', 186, '2019-10-14', 127, NULL),
('Hilton Downtown', 186, '2019-10-15', 108, NULL),
('Hilton Downtown', 186, '2019-10-16', 160, NULL),
('Hilton Downtown', 186, '2019-10-17', 322, NULL),
('Hilton Downtown', 186, '2019-10-18', 108, NULL),
('Hilton Downtown', 186, '2019-10-19', 138, NULL),
('Hilton Downtown', 186, '2019-10-20', 160, NULL),
('Hilton Downtown', 186, '2019-10-21', 281, NULL),
('Hilton Downtown', 186, '2019-10-22', 117, NULL),
('Hilton Downtown', 186, '2019-10-23', 120, NULL),
('Hilton Downtown', 186, '2019-10-24', 349, NULL),
('Hilton Downtown', 186, '2019-10-25', 131, NULL),
('Hilton Downtown', 186, '2019-10-26', 339, NULL),
('Hilton Downtown', 186, '2019-10-27', 274, NULL),
('Hilton Downtown', 186, '2019-10-28', 277, NULL),
('Hilton Downtown', 186, '2019-10-29', 277, NULL),
('Hilton Downtown', 186, '2019-10-30', 167, NULL),
('Hilton Downtown', 186, '2019-10-31', 136, NULL),
('Hilton Downtown', 186, '2019-11-01', 182, NULL),
('Hilton Downtown', 186, '2019-11-02', 395, NULL),
('Hilton Downtown', 186, '2019-11-03', 321, NULL),
('Hilton Downtown', 186, '2019-11-04', 117, NULL),
('Hilton Downtown', 186, '2019-11-05', 390, NULL),
('Hilton Downtown', 186, '2019-11-06', 280, NULL),
('Hilton Downtown', 186, '2019-11-07', 349, NULL),
('Hilton Downtown', 186, '2019-11-08', 180, NULL),
('Hilton Downtown', 186, '2019-11-09', 230, NULL),
('Hilton Downtown', 186, '2019-11-10', 117, NULL),
('Hilton Downtown', 186, '2019-11-11', 145, NULL),
('Hilton Downtown', 186, '2019-11-12', 170, NULL),
('Hilton Downtown', 186, '2019-11-13', 120, NULL),
('Hilton Downtown', 186, '2019-11-14', 161, NULL),
('Hilton Downtown', 186, '2019-11-15', 248, NULL),
('Hilton Downtown', 186, '2019-11-16', 125, NULL),
('Hilton Downtown', 186, '2019-11-17', 170, NULL),
('Hilton Downtown', 186, '2019-11-18', 275, NULL),
('Hilton Downtown', 186, '2019-11-19', 106, NULL),
('Hilton Downtown', 186, '2019-11-20', 102, NULL),
('Hilton Downtown', 186, '2019-11-21', 127, NULL),
('Hilton Downtown', 186, '2019-11-22', 103, NULL),
('Hilton Downtown', 186, '2019-11-23', 300, NULL),
('Hilton Downtown', 186, '2019-11-24', 273, NULL),
('Hilton Downtown', 186, '2019-11-25', 356, NULL),
('Hilton Downtown', 186, '2019-11-26', 352, NULL),
('Hilton Downtown', 186, '2019-11-27', 195, NULL),
('Hilton Downtown', 186, '2019-11-28', 319, NULL),
('Hilton Downtown', 186, '2019-11-29', 262, NULL),
('Hilton Downtown', 186, '2019-11-30', 290, NULL),
('Hilton Downtown', 186, '2019-12-01', 234, NULL),
('Hilton Downtown', 186, '2019-12-02', 383, NULL),
('Hilton Downtown', 186, '2019-12-03', 122, NULL),
('Hilton Downtown', 186, '2019-12-04', 274, NULL),
('Hilton Downtown', 186, '2019-12-05', 241, NULL),
('Hilton Downtown', 186, '2019-12-06', 335, NULL),
('Hilton Downtown', 186, '2019-12-07', 197, NULL),
('Hilton Downtown', 186, '2019-12-08', 306, NULL),
('Hilton Downtown', 186, '2019-12-09', 313, NULL),
('Hilton Downtown', 186, '2019-12-10', 274, NULL),
('Hilton Downtown', 186, '2019-12-11', 255, NULL),
('Hilton Downtown', 186, '2019-12-12', 248, NULL),
('Hilton Downtown', 186, '2019-12-13', 369, NULL),
('Hilton Downtown', 186, '2019-12-14', 258, NULL),
('Hilton Downtown', 186, '2019-12-15', 197, NULL),
('Hilton Downtown', 186, '2019-12-16', 196, NULL),
('Hilton Downtown', 186, '2019-12-17', 116, NULL),
('Hilton Downtown', 186, '2019-12-18', 394, NULL),
('Hilton Downtown', 186, '2019-12-19', 397, NULL),
('Hilton Downtown', 186, '2019-12-20', 104, NULL),
('Hilton Downtown', 186, '2019-12-21', 189, NULL),
('Hilton Downtown', 186, '2019-12-22', 223, NULL),
('Hilton Downtown', 186, '2019-12-23', 299, NULL),
('Hilton Downtown', 186, '2019-12-24', 373, NULL),
('Hilton Downtown', 186, '2019-12-25', 239, NULL),
('Hilton Downtown', 186, '2019-12-26', 317, NULL),
('Hilton Downtown', 186, '2019-12-27', 332, NULL),
('Hilton Downtown', 186, '2019-12-28', 313, NULL),
('Hilton Downtown', 186, '2019-12-29', 228, NULL),
('Hilton Downtown', 186, '2019-12-30', 215, NULL),
('Hilton Downtown', 186, '2019-12-31', 349, NULL),
('Hilton Downtown', 186, '2020-01-01', 216, NULL),
('Hilton Downtown', 186, '2020-01-02', 209, NULL),
('Hilton Downtown', 186, '2020-01-03', 258, NULL),
('Hilton Downtown', 186, '2020-01-04', 312, NULL),
('Hilton Downtown', 186, '2020-01-05', 116, NULL),
('Hilton Downtown', 186, '2020-01-06', 163, NULL),
('Hilton Downtown', 186, '2020-01-07', 348, NULL),
('Hilton Downtown', 186, '2020-01-08', 331, NULL),
('Hilton Downtown', 186, '2020-01-09', 359, NULL),
('Hilton Downtown', 186, '2020-01-10', 219, NULL),
('Hilton Downtown', 186, '2020-01-11', 350, NULL),
('Hilton Downtown', 186, '2020-01-12', 343, NULL),
('Hilton Downtown', 186, '2020-01-13', 198, NULL),
('Hilton Downtown', 186, '2020-01-14', 145, NULL),
('Hilton Downtown', 186, '2020-01-15', 338, NULL),
('Hilton Downtown', 186, '2020-01-16', 144, NULL),
('Hilton Downtown', 186, '2020-01-17', 222, NULL),
('Hilton Downtown', 186, '2020-01-18', 156, NULL),
('Hilton Downtown', 186, '2020-01-19', 169, NULL),
('Hilton Downtown', 186, '2020-01-20', 172, NULL),
('Hilton Downtown', 186, '2020-01-21', 158, NULL),
('Hilton Downtown', 186, '2020-01-22', 349, NULL),
('Hilton Downtown', 186, '2020-01-23', 390, NULL),
('Hilton Downtown', 186, '2020-01-24', 356, NULL),
('Hilton Downtown', 186, '2020-01-25', 281, NULL),
('Hilton Downtown', 186, '2020-01-26', 118, NULL),
('Hilton Downtown', 186, '2020-01-27', 105, NULL),
('Hilton Downtown', 186, '2020-01-28', 162, NULL),
('Hilton Downtown', 186, '2020-01-29', 314, NULL),
('Hilton Downtown', 186, '2020-01-30', 175, NULL),
('Hilton Downtown', 186, '2020-01-31', 147, NULL),
('Hilton Downtown', 186, '2020-02-01', 234, NULL),
('Hilton Downtown', 186, '2020-02-02', 266, NULL),
('Hilton Downtown', 186, '2020-02-03', 354, NULL),
('Hilton Downtown', 186, '2020-02-04', 104, NULL),
('Hilton Downtown', 190, '2019-01-01', 294, NULL),
('Hilton Downtown', 190, '2019-01-02', 292, NULL),
('Hilton Downtown', 190, '2019-01-03', 112, NULL),
('Hilton Downtown', 190, '2019-01-04', 332, NULL),
('Hilton Downtown', 190, '2019-01-05', 100, NULL),
('Hilton Downtown', 190, '2019-01-06', 244, NULL),
('Hilton Downtown', 190, '2019-01-07', 163, NULL),
('Hilton Downtown', 190, '2019-01-08', 334, NULL),
('Hilton Downtown', 190, '2019-01-09', 161, NULL),
('Hilton Downtown', 190, '2019-01-10', 212, NULL),
('Hilton Downtown', 190, '2019-01-11', 124, NULL),
('Hilton Downtown', 190, '2019-01-12', 242, NULL),
('Hilton Downtown', 190, '2019-01-13', 250, NULL),
('Hilton Downtown', 190, '2019-01-14', 292, NULL),
('Hilton Downtown', 190, '2019-01-15', 333, NULL),
('Hilton Downtown', 190, '2019-01-16', 101, NULL),
('Hilton Downtown', 190, '2019-01-17', 262, NULL),
('Hilton Downtown', 190, '2019-01-18', 129, NULL),
('Hilton Downtown', 190, '2019-01-19', 231, NULL),
('Hilton Downtown', 190, '2019-01-20', 142, NULL),
('Hilton Downtown', 190, '2019-01-21', 275, NULL),
('Hilton Downtown', 190, '2019-01-22', 365, NULL),
('Hilton Downtown', 190, '2019-01-23', 346, NULL),
('Hilton Downtown', 190, '2019-01-24', 144, NULL),
('Hilton Downtown', 190, '2019-01-25', 327, NULL),
('Hilton Downtown', 190, '2019-01-26', 360, NULL),
('Hilton Downtown', 190, '2019-01-27', 350, NULL),
('Hilton Downtown', 190, '2019-01-28', 340, NULL),
('Hilton Downtown', 190, '2019-01-29', 329, NULL),
('Hilton Downtown', 190, '2019-01-30', 146, NULL),
('Hilton Downtown', 190, '2019-01-31', 139, NULL),
('Hilton Downtown', 190, '2019-02-01', 150, NULL),
('Hilton Downtown', 190, '2019-02-02', 318, NULL),
('Hilton Downtown', 190, '2019-02-03', 223, NULL),
('Hilton Downtown', 190, '2019-02-04', 291, NULL),
('Hilton Downtown', 190, '2019-02-05', 308, NULL),
('Hilton Downtown', 190, '2019-02-06', 169, NULL),
('Hilton Downtown', 190, '2019-02-07', 392, NULL),
('Hilton Downtown', 190, '2019-02-08', 319, NULL),
('Hilton Downtown', 190, '2019-02-09', 266, NULL),
('Hilton Downtown', 190, '2019-02-10', 132, NULL),
('Hilton Downtown', 190, '2019-02-11', 359, NULL),
('Hilton Downtown', 190, '2019-02-12', 345, NULL),
('Hilton Downtown', 190, '2019-02-13', 274, NULL),
('Hilton Downtown', 190, '2019-02-14', 264, NULL),
('Hilton Downtown', 190, '2019-02-15', 215, NULL),
('Hilton Downtown', 190, '2019-02-16', 174, NULL),
('Hilton Downtown', 190, '2019-02-17', 133, NULL),
('Hilton Downtown', 190, '2019-02-18', 322, NULL),
('Hilton Downtown', 190, '2019-02-19', 178, NULL),
('Hilton Downtown', 190, '2019-02-20', 140, NULL),
('Hilton Downtown', 190, '2019-02-21', 235, NULL),
('Hilton Downtown', 190, '2019-02-22', 183, NULL),
('Hilton Downtown', 190, '2019-02-23', 190, NULL),
('Hilton Downtown', 190, '2019-02-24', 360, NULL),
('Hilton Downtown', 190, '2019-02-25', 299, NULL),
('Hilton Downtown', 190, '2019-02-26', 318, NULL),
('Hilton Downtown', 190, '2019-02-27', 284, NULL),
('Hilton Downtown', 190, '2019-02-28', 370, NULL),
('Hilton Downtown', 190, '2019-03-01', 179, NULL),
('Hilton Downtown', 190, '2019-03-02', 308, NULL),
('Hilton Downtown', 190, '2019-03-03', 377, NULL),
('Hilton Downtown', 190, '2019-03-04', 106, NULL),
('Hilton Downtown', 190, '2019-03-05', 128, NULL),
('Hilton Downtown', 190, '2019-03-06', 206, NULL),
('Hilton Downtown', 190, '2019-03-07', 208, NULL),
('Hilton Downtown', 190, '2019-03-08', 172, NULL),
('Hilton Downtown', 190, '2019-03-09', 365, NULL),
('Hilton Downtown', 190, '2019-03-10', 198, NULL),
('Hilton Downtown', 190, '2019-03-11', 227, NULL),
('Hilton Downtown', 190, '2019-03-12', 375, NULL),
('Hilton Downtown', 190, '2019-03-13', 163, NULL),
('Hilton Downtown', 190, '2019-03-14', 338, NULL),
('Hilton Downtown', 190, '2019-03-15', 253, NULL),
('Hilton Downtown', 190, '2019-03-16', 264, NULL),
('Hilton Downtown', 190, '2019-03-17', 192, NULL),
('Hilton Downtown', 190, '2019-03-18', 229, NULL),
('Hilton Downtown', 190, '2019-03-19', 326, NULL),
('Hilton Downtown', 190, '2019-03-20', 333, NULL),
('Hilton Downtown', 190, '2019-03-21', 212, NULL),
('Hilton Downtown', 190, '2019-03-22', 311, NULL),
('Hilton Downtown', 190, '2019-03-23', 383, NULL),
('Hilton Downtown', 190, '2019-03-24', 210, NULL),
('Hilton Downtown', 190, '2019-03-25', 237, NULL),
('Hilton Downtown', 190, '2019-03-26', 153, NULL),
('Hilton Downtown', 190, '2019-03-27', 296, NULL),
('Hilton Downtown', 190, '2019-03-28', 166, NULL),
('Hilton Downtown', 190, '2019-03-29', 328, NULL),
('Hilton Downtown', 190, '2019-03-30', 311, NULL),
('Hilton Downtown', 190, '2019-03-31', 266, NULL),
('Hilton Downtown', 190, '2019-04-01', 134, NULL),
('Hilton Downtown', 190, '2019-04-02', 276, NULL),
('Hilton Downtown', 190, '2019-04-03', 261, NULL),
('Hilton Downtown', 190, '2019-04-04', 197, NULL),
('Hilton Downtown', 190, '2019-04-05', 102, NULL),
('Hilton Downtown', 190, '2019-04-06', 276, NULL),
('Hilton Downtown', 190, '2019-04-07', 378, NULL),
('Hilton Downtown', 190, '2019-04-08', 215, NULL),
('Hilton Downtown', 190, '2019-04-09', 392, NULL),
('Hilton Downtown', 190, '2019-04-10', 318, NULL),
('Hilton Downtown', 190, '2019-04-11', 328, NULL),
('Hilton Downtown', 190, '2019-04-12', 386, NULL),
('Hilton Downtown', 190, '2019-04-13', 259, NULL),
('Hilton Downtown', 190, '2019-04-14', 318, NULL),
('Hilton Downtown', 190, '2019-04-15', 129, NULL),
('Hilton Downtown', 190, '2019-04-16', 197, NULL),
('Hilton Downtown', 190, '2019-04-17', 155, NULL),
('Hilton Downtown', 190, '2019-04-18', 173, NULL),
('Hilton Downtown', 190, '2019-04-19', 264, NULL),
('Hilton Downtown', 190, '2019-04-20', 189, NULL),
('Hilton Downtown', 190, '2019-04-21', 394, NULL),
('Hilton Downtown', 190, '2019-04-22', 217, NULL),
('Hilton Downtown', 190, '2019-04-23', 200, NULL),
('Hilton Downtown', 190, '2019-04-24', 274, NULL),
('Hilton Downtown', 190, '2019-04-25', 353, NULL),
('Hilton Downtown', 190, '2019-04-26', 214, NULL),
('Hilton Downtown', 190, '2019-04-27', 201, NULL),
('Hilton Downtown', 190, '2019-04-28', 230, NULL),
('Hilton Downtown', 190, '2019-04-29', 216, NULL),
('Hilton Downtown', 190, '2019-04-30', 263, NULL),
('Hilton Downtown', 190, '2019-05-01', 105, NULL),
('Hilton Downtown', 190, '2019-05-02', 357, NULL),
('Hilton Downtown', 190, '2019-05-03', 302, NULL),
('Hilton Downtown', 190, '2019-05-04', 282, NULL),
('Hilton Downtown', 190, '2019-05-05', 128, NULL),
('Hilton Downtown', 190, '2019-05-06', 179, NULL),
('Hilton Downtown', 190, '2019-05-07', 331, NULL),
('Hilton Downtown', 190, '2019-05-08', 208, NULL),
('Hilton Downtown', 190, '2019-05-09', 362, NULL),
('Hilton Downtown', 190, '2019-05-10', 214, NULL),
('Hilton Downtown', 190, '2019-05-11', 121, NULL),
('Hilton Downtown', 190, '2019-05-12', 157, NULL),
('Hilton Downtown', 190, '2019-05-13', 247, NULL),
('Hilton Downtown', 190, '2019-05-14', 217, NULL),
('Hilton Downtown', 190, '2019-05-15', 320, NULL),
('Hilton Downtown', 190, '2019-05-16', 363, NULL),
('Hilton Downtown', 190, '2019-05-17', 378, NULL),
('Hilton Downtown', 190, '2019-05-18', 138, NULL),
('Hilton Downtown', 190, '2019-05-19', 118, NULL),
('Hilton Downtown', 190, '2019-05-20', 389, NULL),
('Hilton Downtown', 190, '2019-05-21', 120, NULL),
('Hilton Downtown', 190, '2019-05-22', 135, NULL),
('Hilton Downtown', 190, '2019-05-23', 135, NULL),
('Hilton Downtown', 190, '2019-05-24', 376, NULL),
('Hilton Downtown', 190, '2019-05-25', 320, NULL),
('Hilton Downtown', 190, '2019-05-26', 340, NULL),
('Hilton Downtown', 190, '2019-05-27', 321, NULL),
('Hilton Downtown', 190, '2019-05-28', 150, NULL),
('Hilton Downtown', 190, '2019-05-29', 166, NULL),
('Hilton Downtown', 190, '2019-05-30', 193, NULL),
('Hilton Downtown', 190, '2019-05-31', 205, NULL),
('Hilton Downtown', 190, '2019-06-01', 384, NULL),
('Hilton Downtown', 190, '2019-06-02', 345, NULL),
('Hilton Downtown', 190, '2019-06-03', 111, NULL),
('Hilton Downtown', 190, '2019-06-04', 397, NULL),
('Hilton Downtown', 190, '2019-06-05', 343, NULL),
('Hilton Downtown', 190, '2019-06-06', 137, NULL),
('Hilton Downtown', 190, '2019-06-07', 283, NULL),
('Hilton Downtown', 190, '2019-06-08', 141, NULL),
('Hilton Downtown', 190, '2019-06-09', 264, NULL),
('Hilton Downtown', 190, '2019-06-10', 274, NULL),
('Hilton Downtown', 190, '2019-06-11', 217, NULL),
('Hilton Downtown', 190, '2019-06-12', 286, NULL),
('Hilton Downtown', 190, '2019-06-13', 282, NULL),
('Hilton Downtown', 190, '2019-06-14', 213, NULL),
('Hilton Downtown', 190, '2019-06-15', 348, NULL),
('Hilton Downtown', 190, '2019-06-16', 136, NULL),
('Hilton Downtown', 190, '2019-06-17', 282, NULL),
('Hilton Downtown', 190, '2019-06-18', 354, NULL),
('Hilton Downtown', 190, '2019-06-19', 326, NULL),
('Hilton Downtown', 190, '2019-06-20', 131, NULL),
('Hilton Downtown', 190, '2019-06-21', 302, NULL),
('Hilton Downtown', 190, '2019-06-22', 260, NULL),
('Hilton Downtown', 190, '2019-06-23', 301, NULL),
('Hilton Downtown', 190, '2019-06-24', 255, NULL),
('Hilton Downtown', 190, '2019-06-25', 150, NULL),
('Hilton Downtown', 190, '2019-06-26', 368, NULL),
('Hilton Downtown', 190, '2019-06-27', 396, NULL),
('Hilton Downtown', 190, '2019-06-28', 200, NULL),
('Hilton Downtown', 190, '2019-06-29', 152, NULL),
('Hilton Downtown', 190, '2019-06-30', 359, NULL),
('Hilton Downtown', 190, '2019-07-01', 346, NULL),
('Hilton Downtown', 190, '2019-07-02', 203, NULL),
('Hilton Downtown', 190, '2019-07-03', 342, NULL),
('Hilton Downtown', 190, '2019-07-04', 149, NULL),
('Hilton Downtown', 190, '2019-07-05', 210, NULL),
('Hilton Downtown', 190, '2019-07-06', 304, NULL),
('Hilton Downtown', 190, '2019-07-07', 292, NULL),
('Hilton Downtown', 190, '2019-07-08', 314, NULL),
('Hilton Downtown', 190, '2019-07-09', 364, NULL),
('Hilton Downtown', 190, '2019-07-10', 317, NULL),
('Hilton Downtown', 190, '2019-07-11', 336, NULL),
('Hilton Downtown', 190, '2019-07-12', 320, NULL),
('Hilton Downtown', 190, '2019-07-13', 237, NULL),
('Hilton Downtown', 190, '2019-07-14', 223, NULL),
('Hilton Downtown', 190, '2019-07-15', 296, NULL),
('Hilton Downtown', 190, '2019-07-16', 155, NULL),
('Hilton Downtown', 190, '2019-07-17', 177, NULL),
('Hilton Downtown', 190, '2019-07-18', 318, NULL),
('Hilton Downtown', 190, '2019-07-19', 220, NULL),
('Hilton Downtown', 190, '2019-07-20', 383, NULL),
('Hilton Downtown', 190, '2019-07-21', 384, NULL),
('Hilton Downtown', 190, '2019-07-22', 336, NULL),
('Hilton Downtown', 190, '2019-07-23', 331, NULL),
('Hilton Downtown', 190, '2019-07-24', 135, NULL),
('Hilton Downtown', 190, '2019-07-25', 388, NULL),
('Hilton Downtown', 190, '2019-07-26', 129, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 190, '2019-07-27', 107, NULL),
('Hilton Downtown', 190, '2019-07-28', 150, NULL),
('Hilton Downtown', 190, '2019-07-29', 251, NULL),
('Hilton Downtown', 190, '2019-07-30', 132, NULL),
('Hilton Downtown', 190, '2019-07-31', 331, NULL),
('Hilton Downtown', 190, '2019-08-01', 397, NULL),
('Hilton Downtown', 190, '2019-08-02', 346, NULL),
('Hilton Downtown', 190, '2019-08-03', 240, NULL),
('Hilton Downtown', 190, '2019-08-04', 223, NULL),
('Hilton Downtown', 190, '2019-08-05', 313, NULL),
('Hilton Downtown', 190, '2019-08-06', 137, NULL),
('Hilton Downtown', 190, '2019-08-07', 120, NULL),
('Hilton Downtown', 190, '2019-08-08', 331, NULL),
('Hilton Downtown', 190, '2019-08-09', 363, NULL),
('Hilton Downtown', 190, '2019-08-10', 399, NULL),
('Hilton Downtown', 190, '2019-08-11', 113, NULL),
('Hilton Downtown', 190, '2019-08-12', 286, NULL),
('Hilton Downtown', 190, '2019-08-13', 168, NULL),
('Hilton Downtown', 190, '2019-08-14', 329, NULL),
('Hilton Downtown', 190, '2019-08-15', 200, NULL),
('Hilton Downtown', 190, '2019-08-16', 310, NULL),
('Hilton Downtown', 190, '2019-08-17', 392, NULL),
('Hilton Downtown', 190, '2019-08-18', 137, NULL),
('Hilton Downtown', 190, '2019-08-19', 228, NULL),
('Hilton Downtown', 190, '2019-08-20', 121, NULL),
('Hilton Downtown', 190, '2019-08-21', 394, NULL),
('Hilton Downtown', 190, '2019-08-22', 357, NULL),
('Hilton Downtown', 190, '2019-08-23', 123, NULL),
('Hilton Downtown', 190, '2019-08-24', 398, NULL),
('Hilton Downtown', 190, '2019-08-25', 373, NULL),
('Hilton Downtown', 190, '2019-08-26', 353, NULL),
('Hilton Downtown', 190, '2019-08-27', 136, NULL),
('Hilton Downtown', 190, '2019-08-28', 257, NULL),
('Hilton Downtown', 190, '2019-08-29', 360, NULL),
('Hilton Downtown', 190, '2019-08-30', 131, NULL),
('Hilton Downtown', 190, '2019-08-31', 191, NULL),
('Hilton Downtown', 190, '2019-09-01', 275, NULL),
('Hilton Downtown', 190, '2019-09-02', 152, NULL),
('Hilton Downtown', 190, '2019-09-03', 375, NULL),
('Hilton Downtown', 190, '2019-09-04', 344, NULL),
('Hilton Downtown', 190, '2019-09-05', 348, NULL),
('Hilton Downtown', 190, '2019-09-06', 253, NULL),
('Hilton Downtown', 190, '2019-09-07', 381, NULL),
('Hilton Downtown', 190, '2019-09-08', 185, NULL),
('Hilton Downtown', 190, '2019-09-09', 228, NULL),
('Hilton Downtown', 190, '2019-09-10', 180, NULL),
('Hilton Downtown', 190, '2019-09-11', 148, NULL),
('Hilton Downtown', 190, '2019-09-12', 330, NULL),
('Hilton Downtown', 190, '2019-09-13', 236, NULL),
('Hilton Downtown', 190, '2019-09-14', 258, NULL),
('Hilton Downtown', 190, '2019-09-15', 359, NULL),
('Hilton Downtown', 190, '2019-09-16', 277, NULL),
('Hilton Downtown', 190, '2019-09-17', 371, NULL),
('Hilton Downtown', 190, '2019-09-18', 275, NULL),
('Hilton Downtown', 190, '2019-09-19', 338, NULL),
('Hilton Downtown', 190, '2019-09-20', 303, NULL),
('Hilton Downtown', 190, '2019-09-21', 359, NULL),
('Hilton Downtown', 190, '2019-09-22', 144, NULL),
('Hilton Downtown', 190, '2019-09-23', 324, NULL),
('Hilton Downtown', 190, '2019-09-24', 242, NULL),
('Hilton Downtown', 190, '2019-09-25', 173, NULL),
('Hilton Downtown', 190, '2019-09-26', 314, NULL),
('Hilton Downtown', 190, '2019-09-27', 375, NULL),
('Hilton Downtown', 190, '2019-09-28', 330, NULL),
('Hilton Downtown', 190, '2019-09-29', 310, NULL),
('Hilton Downtown', 190, '2019-09-30', 318, NULL),
('Hilton Downtown', 190, '2019-10-01', 246, NULL),
('Hilton Downtown', 190, '2019-10-02', 230, NULL),
('Hilton Downtown', 190, '2019-10-03', 114, NULL),
('Hilton Downtown', 190, '2019-10-04', 109, NULL),
('Hilton Downtown', 190, '2019-10-05', 117, NULL),
('Hilton Downtown', 190, '2019-10-06', 347, NULL),
('Hilton Downtown', 190, '2019-10-07', 245, NULL),
('Hilton Downtown', 190, '2019-10-08', 245, NULL),
('Hilton Downtown', 190, '2019-10-09', 362, NULL),
('Hilton Downtown', 190, '2019-10-10', 290, NULL),
('Hilton Downtown', 190, '2019-10-11', 247, NULL),
('Hilton Downtown', 190, '2019-10-12', 328, NULL),
('Hilton Downtown', 190, '2019-10-13', 247, NULL),
('Hilton Downtown', 190, '2019-10-14', 218, NULL),
('Hilton Downtown', 190, '2019-10-15', 296, NULL),
('Hilton Downtown', 190, '2019-10-16', 390, NULL),
('Hilton Downtown', 190, '2019-10-17', 129, NULL),
('Hilton Downtown', 190, '2019-10-18', 229, NULL),
('Hilton Downtown', 190, '2019-10-19', 180, NULL),
('Hilton Downtown', 190, '2019-10-20', 128, NULL),
('Hilton Downtown', 190, '2019-10-21', 190, NULL),
('Hilton Downtown', 190, '2019-10-22', 160, NULL),
('Hilton Downtown', 190, '2019-10-23', 358, NULL),
('Hilton Downtown', 190, '2019-10-24', 267, NULL),
('Hilton Downtown', 190, '2019-10-25', 258, NULL),
('Hilton Downtown', 190, '2019-10-26', 186, NULL),
('Hilton Downtown', 190, '2019-10-27', 119, NULL),
('Hilton Downtown', 190, '2019-10-28', 304, NULL),
('Hilton Downtown', 190, '2019-10-29', 300, NULL),
('Hilton Downtown', 190, '2019-10-30', 161, NULL),
('Hilton Downtown', 190, '2019-10-31', 156, NULL),
('Hilton Downtown', 190, '2019-11-01', 202, NULL),
('Hilton Downtown', 190, '2019-11-02', 349, NULL),
('Hilton Downtown', 190, '2019-11-03', 268, NULL),
('Hilton Downtown', 190, '2019-11-04', 201, NULL),
('Hilton Downtown', 190, '2019-11-05', 197, NULL),
('Hilton Downtown', 190, '2019-11-06', 361, NULL),
('Hilton Downtown', 190, '2019-11-07', 248, NULL),
('Hilton Downtown', 190, '2019-11-08', 213, NULL),
('Hilton Downtown', 190, '2019-11-09', 258, NULL),
('Hilton Downtown', 190, '2019-11-10', 142, NULL),
('Hilton Downtown', 190, '2019-11-11', 101, NULL),
('Hilton Downtown', 190, '2019-11-12', 195, NULL),
('Hilton Downtown', 190, '2019-11-13', 364, NULL),
('Hilton Downtown', 190, '2019-11-14', 370, NULL),
('Hilton Downtown', 190, '2019-11-15', 372, NULL),
('Hilton Downtown', 190, '2019-11-16', 162, NULL),
('Hilton Downtown', 190, '2019-11-17', 261, NULL),
('Hilton Downtown', 190, '2019-11-18', 194, NULL),
('Hilton Downtown', 190, '2019-11-19', 322, NULL),
('Hilton Downtown', 190, '2019-11-20', 196, NULL),
('Hilton Downtown', 190, '2019-11-21', 346, NULL),
('Hilton Downtown', 190, '2019-11-22', 159, NULL),
('Hilton Downtown', 190, '2019-11-23', 147, NULL),
('Hilton Downtown', 190, '2019-11-24', 120, NULL),
('Hilton Downtown', 190, '2019-11-25', 189, NULL),
('Hilton Downtown', 190, '2019-11-26', 200, NULL),
('Hilton Downtown', 190, '2019-11-27', 309, NULL),
('Hilton Downtown', 190, '2019-11-28', 125, NULL),
('Hilton Downtown', 190, '2019-11-29', 392, NULL),
('Hilton Downtown', 190, '2019-11-30', 155, NULL),
('Hilton Downtown', 190, '2019-12-01', 117, NULL),
('Hilton Downtown', 190, '2019-12-02', 152, NULL),
('Hilton Downtown', 190, '2019-12-03', 322, NULL),
('Hilton Downtown', 190, '2019-12-04', 133, NULL),
('Hilton Downtown', 190, '2019-12-05', 332, NULL),
('Hilton Downtown', 190, '2019-12-06', 351, NULL),
('Hilton Downtown', 190, '2019-12-07', 302, NULL),
('Hilton Downtown', 190, '2019-12-08', 126, NULL),
('Hilton Downtown', 190, '2019-12-09', 221, NULL),
('Hilton Downtown', 190, '2019-12-10', 153, NULL),
('Hilton Downtown', 190, '2019-12-11', 120, NULL),
('Hilton Downtown', 190, '2019-12-12', 356, NULL),
('Hilton Downtown', 190, '2019-12-13', 267, NULL),
('Hilton Downtown', 190, '2019-12-14', 272, NULL),
('Hilton Downtown', 190, '2019-12-15', 372, NULL),
('Hilton Downtown', 190, '2019-12-16', 144, NULL),
('Hilton Downtown', 190, '2019-12-17', 210, NULL),
('Hilton Downtown', 190, '2019-12-18', 282, NULL),
('Hilton Downtown', 190, '2019-12-19', 385, NULL),
('Hilton Downtown', 190, '2019-12-20', 321, NULL),
('Hilton Downtown', 190, '2019-12-21', 141, NULL),
('Hilton Downtown', 190, '2019-12-22', 153, NULL),
('Hilton Downtown', 190, '2019-12-23', 211, NULL),
('Hilton Downtown', 190, '2019-12-24', 169, NULL),
('Hilton Downtown', 190, '2019-12-25', 363, NULL),
('Hilton Downtown', 190, '2019-12-26', 337, NULL),
('Hilton Downtown', 190, '2019-12-27', 344, NULL),
('Hilton Downtown', 190, '2019-12-28', 256, NULL),
('Hilton Downtown', 190, '2019-12-29', 389, NULL),
('Hilton Downtown', 190, '2019-12-30', 300, NULL),
('Hilton Downtown', 190, '2019-12-31', 271, NULL),
('Hilton Downtown', 190, '2020-01-01', 288, NULL),
('Hilton Downtown', 190, '2020-01-02', 308, NULL),
('Hilton Downtown', 190, '2020-01-03', 165, NULL),
('Hilton Downtown', 190, '2020-01-04', 133, NULL),
('Hilton Downtown', 190, '2020-01-05', 204, NULL),
('Hilton Downtown', 190, '2020-01-06', 276, NULL),
('Hilton Downtown', 190, '2020-01-07', 275, NULL),
('Hilton Downtown', 190, '2020-01-08', 127, NULL),
('Hilton Downtown', 190, '2020-01-09', 132, NULL),
('Hilton Downtown', 190, '2020-01-10', 131, NULL),
('Hilton Downtown', 190, '2020-01-11', 304, NULL),
('Hilton Downtown', 190, '2020-01-12', 344, NULL),
('Hilton Downtown', 190, '2020-01-13', 263, NULL),
('Hilton Downtown', 190, '2020-01-14', 349, NULL),
('Hilton Downtown', 190, '2020-01-15', 384, NULL),
('Hilton Downtown', 190, '2020-01-16', 134, NULL),
('Hilton Downtown', 190, '2020-01-17', 347, NULL),
('Hilton Downtown', 190, '2020-01-18', 216, NULL),
('Hilton Downtown', 190, '2020-01-19', 105, NULL),
('Hilton Downtown', 190, '2020-01-20', 213, NULL),
('Hilton Downtown', 190, '2020-01-21', 331, NULL),
('Hilton Downtown', 190, '2020-01-22', 216, NULL),
('Hilton Downtown', 190, '2020-01-23', 111, NULL),
('Hilton Downtown', 190, '2020-01-24', 127, NULL),
('Hilton Downtown', 190, '2020-01-25', 160, NULL),
('Hilton Downtown', 190, '2020-01-26', 291, NULL),
('Hilton Downtown', 190, '2020-01-27', 352, NULL),
('Hilton Downtown', 190, '2020-01-28', 359, NULL),
('Hilton Downtown', 190, '2020-01-29', 329, NULL),
('Hilton Downtown', 190, '2020-01-30', 354, NULL),
('Hilton Downtown', 190, '2020-01-31', 299, NULL),
('Hilton Downtown', 190, '2020-02-01', 325, NULL),
('Hilton Downtown', 190, '2020-02-02', 141, NULL),
('Hilton Downtown', 190, '2020-02-03', 290, NULL),
('Hilton Downtown', 190, '2020-02-04', 225, NULL),
('Hilton Downtown', 200, '2019-01-01', 133, NULL),
('Hilton Downtown', 200, '2019-01-02', 260, NULL),
('Hilton Downtown', 200, '2019-01-03', 366, NULL),
('Hilton Downtown', 200, '2019-01-04', 241, NULL),
('Hilton Downtown', 200, '2019-01-05', 296, NULL),
('Hilton Downtown', 200, '2019-01-06', 382, NULL),
('Hilton Downtown', 200, '2019-01-07', 374, NULL),
('Hilton Downtown', 200, '2019-01-08', 276, NULL),
('Hilton Downtown', 200, '2019-01-09', 158, NULL),
('Hilton Downtown', 200, '2019-01-10', 103, NULL),
('Hilton Downtown', 200, '2019-01-11', 229, NULL),
('Hilton Downtown', 200, '2019-01-12', 324, NULL),
('Hilton Downtown', 200, '2019-01-13', 204, NULL),
('Hilton Downtown', 200, '2019-01-14', 332, NULL),
('Hilton Downtown', 200, '2019-01-15', 276, NULL),
('Hilton Downtown', 200, '2019-01-16', 277, NULL),
('Hilton Downtown', 200, '2019-01-17', 351, NULL),
('Hilton Downtown', 200, '2019-01-18', 304, NULL),
('Hilton Downtown', 200, '2019-01-19', 109, NULL),
('Hilton Downtown', 200, '2019-01-20', 262, NULL),
('Hilton Downtown', 200, '2019-01-21', 131, NULL),
('Hilton Downtown', 200, '2019-01-22', 193, NULL),
('Hilton Downtown', 200, '2019-01-23', 171, NULL),
('Hilton Downtown', 200, '2019-01-24', 381, NULL),
('Hilton Downtown', 200, '2019-01-25', 370, NULL),
('Hilton Downtown', 200, '2019-01-26', 385, NULL),
('Hilton Downtown', 200, '2019-01-27', 322, NULL),
('Hilton Downtown', 200, '2019-01-28', 258, NULL),
('Hilton Downtown', 200, '2019-01-29', 197, NULL),
('Hilton Downtown', 200, '2019-01-30', 379, NULL),
('Hilton Downtown', 200, '2019-01-31', 353, NULL),
('Hilton Downtown', 200, '2019-02-01', 182, NULL),
('Hilton Downtown', 200, '2019-02-02', 239, NULL),
('Hilton Downtown', 200, '2019-02-03', 279, NULL),
('Hilton Downtown', 200, '2019-02-04', 364, NULL),
('Hilton Downtown', 200, '2019-02-05', 204, NULL),
('Hilton Downtown', 200, '2019-02-06', 198, NULL),
('Hilton Downtown', 200, '2019-02-07', 134, NULL),
('Hilton Downtown', 200, '2019-02-08', 399, NULL),
('Hilton Downtown', 200, '2019-02-09', 331, NULL),
('Hilton Downtown', 200, '2019-02-10', 380, NULL),
('Hilton Downtown', 200, '2019-02-11', 120, NULL),
('Hilton Downtown', 200, '2019-02-12', 290, NULL),
('Hilton Downtown', 200, '2019-02-13', 190, NULL),
('Hilton Downtown', 200, '2019-02-14', 194, NULL),
('Hilton Downtown', 200, '2019-02-15', 340, NULL),
('Hilton Downtown', 200, '2019-02-16', 256, NULL),
('Hilton Downtown', 200, '2019-02-17', 335, NULL),
('Hilton Downtown', 200, '2019-02-18', 157, NULL),
('Hilton Downtown', 200, '2019-02-19', 330, NULL),
('Hilton Downtown', 200, '2019-02-20', 375, NULL),
('Hilton Downtown', 200, '2019-02-21', 221, NULL),
('Hilton Downtown', 200, '2019-02-22', 200, NULL),
('Hilton Downtown', 200, '2019-02-23', 286, NULL),
('Hilton Downtown', 200, '2019-02-24', 390, NULL),
('Hilton Downtown', 200, '2019-02-25', 384, NULL),
('Hilton Downtown', 200, '2019-02-26', 381, NULL),
('Hilton Downtown', 200, '2019-02-27', 301, NULL),
('Hilton Downtown', 200, '2019-02-28', 297, NULL),
('Hilton Downtown', 200, '2019-03-01', 141, NULL),
('Hilton Downtown', 200, '2019-03-02', 298, NULL),
('Hilton Downtown', 200, '2019-03-03', 324, NULL),
('Hilton Downtown', 200, '2019-03-04', 145, NULL),
('Hilton Downtown', 200, '2019-03-05', 246, NULL),
('Hilton Downtown', 200, '2019-03-06', 133, NULL),
('Hilton Downtown', 200, '2019-03-07', 287, NULL),
('Hilton Downtown', 200, '2019-03-08', 357, NULL),
('Hilton Downtown', 200, '2019-03-09', 393, NULL),
('Hilton Downtown', 200, '2019-03-10', 352, NULL),
('Hilton Downtown', 200, '2019-03-11', 296, NULL),
('Hilton Downtown', 200, '2019-03-12', 102, NULL),
('Hilton Downtown', 200, '2019-03-13', 231, NULL),
('Hilton Downtown', 200, '2019-03-14', 220, NULL),
('Hilton Downtown', 200, '2019-03-15', 256, NULL),
('Hilton Downtown', 200, '2019-03-16', 287, NULL),
('Hilton Downtown', 200, '2019-03-17', 175, NULL),
('Hilton Downtown', 200, '2019-03-18', 115, NULL),
('Hilton Downtown', 200, '2019-03-19', 236, NULL),
('Hilton Downtown', 200, '2019-03-20', 282, NULL),
('Hilton Downtown', 200, '2019-03-21', 174, NULL),
('Hilton Downtown', 200, '2019-03-22', 121, NULL),
('Hilton Downtown', 200, '2019-03-23', 325, NULL),
('Hilton Downtown', 200, '2019-03-24', 374, NULL),
('Hilton Downtown', 200, '2019-03-25', 324, NULL),
('Hilton Downtown', 200, '2019-03-26', 192, NULL),
('Hilton Downtown', 200, '2019-03-27', 117, NULL),
('Hilton Downtown', 200, '2019-03-28', 278, NULL),
('Hilton Downtown', 200, '2019-03-29', 285, NULL),
('Hilton Downtown', 200, '2019-03-30', 258, NULL),
('Hilton Downtown', 200, '2019-03-31', 277, NULL),
('Hilton Downtown', 200, '2019-04-01', 144, NULL),
('Hilton Downtown', 200, '2019-04-02', 209, NULL),
('Hilton Downtown', 200, '2019-04-03', 293, NULL),
('Hilton Downtown', 200, '2019-04-04', 127, NULL),
('Hilton Downtown', 200, '2019-04-05', 140, NULL),
('Hilton Downtown', 200, '2019-04-06', 197, NULL),
('Hilton Downtown', 200, '2019-04-07', 218, NULL),
('Hilton Downtown', 200, '2019-04-08', 282, NULL),
('Hilton Downtown', 200, '2019-04-09', 180, NULL),
('Hilton Downtown', 200, '2019-04-10', 364, NULL),
('Hilton Downtown', 200, '2019-04-11', 165, NULL),
('Hilton Downtown', 200, '2019-04-12', 371, NULL),
('Hilton Downtown', 200, '2019-04-13', 110, NULL),
('Hilton Downtown', 200, '2019-04-14', 363, NULL),
('Hilton Downtown', 200, '2019-04-15', 291, NULL),
('Hilton Downtown', 200, '2019-04-16', 342, NULL),
('Hilton Downtown', 200, '2019-04-17', 172, NULL),
('Hilton Downtown', 200, '2019-04-18', 382, NULL),
('Hilton Downtown', 200, '2019-04-19', 202, NULL),
('Hilton Downtown', 200, '2019-04-20', 385, NULL),
('Hilton Downtown', 200, '2019-04-21', 195, NULL),
('Hilton Downtown', 200, '2019-04-22', 325, NULL),
('Hilton Downtown', 200, '2019-04-23', 281, NULL),
('Hilton Downtown', 200, '2019-04-24', 311, NULL),
('Hilton Downtown', 200, '2019-04-25', 313, NULL),
('Hilton Downtown', 200, '2019-04-26', 274, NULL),
('Hilton Downtown', 200, '2019-04-27', 216, NULL),
('Hilton Downtown', 200, '2019-04-28', 120, NULL),
('Hilton Downtown', 200, '2019-04-29', 291, NULL),
('Hilton Downtown', 200, '2019-04-30', 202, NULL),
('Hilton Downtown', 200, '2019-05-01', 219, NULL),
('Hilton Downtown', 200, '2019-05-02', 334, NULL),
('Hilton Downtown', 200, '2019-05-03', 378, NULL),
('Hilton Downtown', 200, '2019-05-04', 171, NULL),
('Hilton Downtown', 200, '2019-05-05', 275, NULL),
('Hilton Downtown', 200, '2019-05-06', 312, NULL),
('Hilton Downtown', 200, '2019-05-07', 360, NULL),
('Hilton Downtown', 200, '2019-05-08', 327, NULL),
('Hilton Downtown', 200, '2019-05-09', 399, NULL),
('Hilton Downtown', 200, '2019-05-10', 300, NULL),
('Hilton Downtown', 200, '2019-05-11', 201, NULL),
('Hilton Downtown', 200, '2019-05-12', 203, NULL),
('Hilton Downtown', 200, '2019-05-13', 244, NULL),
('Hilton Downtown', 200, '2019-05-14', 109, NULL),
('Hilton Downtown', 200, '2019-05-15', 252, NULL),
('Hilton Downtown', 200, '2019-05-16', 304, NULL),
('Hilton Downtown', 200, '2019-05-17', 306, NULL),
('Hilton Downtown', 200, '2019-05-18', 100, NULL),
('Hilton Downtown', 200, '2019-05-19', 361, NULL),
('Hilton Downtown', 200, '2019-05-20', 297, NULL),
('Hilton Downtown', 200, '2019-05-21', 118, NULL),
('Hilton Downtown', 200, '2019-05-22', 205, NULL),
('Hilton Downtown', 200, '2019-05-23', 199, NULL),
('Hilton Downtown', 200, '2019-05-24', 306, NULL),
('Hilton Downtown', 200, '2019-05-25', 399, NULL),
('Hilton Downtown', 200, '2019-05-26', 182, NULL),
('Hilton Downtown', 200, '2019-05-27', 107, NULL),
('Hilton Downtown', 200, '2019-05-28', 315, NULL),
('Hilton Downtown', 200, '2019-05-29', 137, NULL),
('Hilton Downtown', 200, '2019-05-30', 359, NULL),
('Hilton Downtown', 200, '2019-05-31', 224, NULL),
('Hilton Downtown', 200, '2019-06-01', 107, NULL),
('Hilton Downtown', 200, '2019-06-02', 177, NULL),
('Hilton Downtown', 200, '2019-06-03', 368, NULL),
('Hilton Downtown', 200, '2019-06-04', 322, NULL),
('Hilton Downtown', 200, '2019-06-05', 173, NULL),
('Hilton Downtown', 200, '2019-06-06', 151, NULL),
('Hilton Downtown', 200, '2019-06-07', 340, NULL),
('Hilton Downtown', 200, '2019-06-08', 115, NULL),
('Hilton Downtown', 200, '2019-06-09', 327, NULL),
('Hilton Downtown', 200, '2019-06-10', 255, NULL),
('Hilton Downtown', 200, '2019-06-11', 328, NULL),
('Hilton Downtown', 200, '2019-06-12', 151, NULL),
('Hilton Downtown', 200, '2019-06-13', 307, NULL),
('Hilton Downtown', 200, '2019-06-14', 386, NULL),
('Hilton Downtown', 200, '2019-06-15', 183, NULL),
('Hilton Downtown', 200, '2019-06-16', 355, NULL),
('Hilton Downtown', 200, '2019-06-17', 265, NULL),
('Hilton Downtown', 200, '2019-06-18', 135, NULL),
('Hilton Downtown', 200, '2019-06-19', 131, NULL),
('Hilton Downtown', 200, '2019-06-20', 315, NULL),
('Hilton Downtown', 200, '2019-06-21', 162, NULL),
('Hilton Downtown', 200, '2019-06-22', 306, NULL),
('Hilton Downtown', 200, '2019-06-23', 134, NULL),
('Hilton Downtown', 200, '2019-06-24', 313, NULL),
('Hilton Downtown', 200, '2019-06-25', 319, NULL),
('Hilton Downtown', 200, '2019-06-26', 163, NULL),
('Hilton Downtown', 200, '2019-06-27', 398, NULL),
('Hilton Downtown', 200, '2019-06-28', 149, NULL),
('Hilton Downtown', 200, '2019-06-29', 201, NULL),
('Hilton Downtown', 200, '2019-06-30', 121, NULL),
('Hilton Downtown', 200, '2019-07-01', 244, NULL),
('Hilton Downtown', 200, '2019-07-02', 344, NULL),
('Hilton Downtown', 200, '2019-07-03', 378, NULL),
('Hilton Downtown', 200, '2019-07-04', 255, NULL),
('Hilton Downtown', 200, '2019-07-05', 138, NULL),
('Hilton Downtown', 200, '2019-07-06', 273, NULL),
('Hilton Downtown', 200, '2019-07-07', 339, NULL),
('Hilton Downtown', 200, '2019-07-08', 228, NULL),
('Hilton Downtown', 200, '2019-07-09', 251, NULL),
('Hilton Downtown', 200, '2019-07-10', 393, NULL),
('Hilton Downtown', 200, '2019-07-11', 253, NULL),
('Hilton Downtown', 200, '2019-07-12', 289, NULL),
('Hilton Downtown', 200, '2019-07-13', 269, NULL),
('Hilton Downtown', 200, '2019-07-14', 313, NULL),
('Hilton Downtown', 200, '2019-07-15', 309, NULL),
('Hilton Downtown', 200, '2019-07-16', 144, NULL),
('Hilton Downtown', 200, '2019-07-17', 312, NULL),
('Hilton Downtown', 200, '2019-07-18', 201, NULL),
('Hilton Downtown', 200, '2019-07-19', 381, NULL),
('Hilton Downtown', 200, '2019-07-20', 155, NULL),
('Hilton Downtown', 200, '2019-07-21', 271, NULL),
('Hilton Downtown', 200, '2019-07-22', 378, NULL),
('Hilton Downtown', 200, '2019-07-23', 272, NULL),
('Hilton Downtown', 200, '2019-07-24', 399, NULL),
('Hilton Downtown', 200, '2019-07-25', 340, NULL),
('Hilton Downtown', 200, '2019-07-26', 242, NULL),
('Hilton Downtown', 200, '2019-07-27', 114, NULL),
('Hilton Downtown', 200, '2019-07-28', 138, NULL),
('Hilton Downtown', 200, '2019-07-29', 323, NULL),
('Hilton Downtown', 200, '2019-07-30', 214, NULL),
('Hilton Downtown', 200, '2019-07-31', 226, NULL),
('Hilton Downtown', 200, '2019-08-01', 303, NULL),
('Hilton Downtown', 200, '2019-08-02', 291, NULL),
('Hilton Downtown', 200, '2019-08-03', 373, NULL),
('Hilton Downtown', 200, '2019-08-04', 362, NULL),
('Hilton Downtown', 200, '2019-08-05', 185, NULL),
('Hilton Downtown', 200, '2019-08-06', 284, NULL),
('Hilton Downtown', 200, '2019-08-07', 184, NULL),
('Hilton Downtown', 200, '2019-08-08', 392, NULL),
('Hilton Downtown', 200, '2019-08-09', 295, NULL),
('Hilton Downtown', 200, '2019-08-10', 146, NULL),
('Hilton Downtown', 200, '2019-08-11', 153, NULL),
('Hilton Downtown', 200, '2019-08-12', 351, NULL),
('Hilton Downtown', 200, '2019-08-13', 293, NULL),
('Hilton Downtown', 200, '2019-08-14', 303, NULL),
('Hilton Downtown', 200, '2019-08-15', 373, NULL),
('Hilton Downtown', 200, '2019-08-16', 197, NULL),
('Hilton Downtown', 200, '2019-08-17', 331, NULL),
('Hilton Downtown', 200, '2019-08-18', 306, NULL),
('Hilton Downtown', 200, '2019-08-19', 183, NULL),
('Hilton Downtown', 200, '2019-08-20', 114, NULL),
('Hilton Downtown', 200, '2019-08-21', 253, NULL),
('Hilton Downtown', 200, '2019-08-22', 194, NULL),
('Hilton Downtown', 200, '2019-08-23', 336, NULL),
('Hilton Downtown', 200, '2019-08-24', 289, NULL),
('Hilton Downtown', 200, '2019-08-25', 193, NULL),
('Hilton Downtown', 200, '2019-08-26', 104, NULL),
('Hilton Downtown', 200, '2019-08-27', 120, NULL),
('Hilton Downtown', 200, '2019-08-28', 356, NULL),
('Hilton Downtown', 200, '2019-08-29', 265, NULL),
('Hilton Downtown', 200, '2019-08-30', 139, NULL),
('Hilton Downtown', 200, '2019-08-31', 396, NULL),
('Hilton Downtown', 200, '2019-09-01', 348, NULL),
('Hilton Downtown', 200, '2019-09-02', 211, NULL),
('Hilton Downtown', 200, '2019-09-03', 194, NULL),
('Hilton Downtown', 200, '2019-09-04', 303, NULL),
('Hilton Downtown', 200, '2019-09-05', 376, NULL),
('Hilton Downtown', 200, '2019-09-06', 262, NULL),
('Hilton Downtown', 200, '2019-09-07', 200, NULL),
('Hilton Downtown', 200, '2019-09-08', 345, NULL),
('Hilton Downtown', 200, '2019-09-09', 379, NULL),
('Hilton Downtown', 200, '2019-09-10', 324, NULL),
('Hilton Downtown', 200, '2019-09-11', 147, NULL),
('Hilton Downtown', 200, '2019-09-12', 200, NULL),
('Hilton Downtown', 200, '2019-09-13', 158, NULL),
('Hilton Downtown', 200, '2019-09-14', 373, NULL),
('Hilton Downtown', 200, '2019-09-15', 326, NULL),
('Hilton Downtown', 200, '2019-09-16', 107, NULL),
('Hilton Downtown', 200, '2019-09-17', 189, NULL),
('Hilton Downtown', 200, '2019-09-18', 213, NULL),
('Hilton Downtown', 200, '2019-09-19', 227, NULL),
('Hilton Downtown', 200, '2019-09-20', 309, NULL),
('Hilton Downtown', 200, '2019-09-21', 119, NULL),
('Hilton Downtown', 200, '2019-09-22', 152, NULL),
('Hilton Downtown', 200, '2019-09-23', 134, NULL),
('Hilton Downtown', 200, '2019-09-24', 119, NULL),
('Hilton Downtown', 200, '2019-09-25', 218, NULL),
('Hilton Downtown', 200, '2019-09-26', 129, NULL),
('Hilton Downtown', 200, '2019-09-27', 295, NULL),
('Hilton Downtown', 200, '2019-09-28', 342, NULL),
('Hilton Downtown', 200, '2019-09-29', 228, NULL),
('Hilton Downtown', 200, '2019-09-30', 123, NULL),
('Hilton Downtown', 200, '2019-10-01', 384, NULL),
('Hilton Downtown', 200, '2019-10-02', 253, NULL),
('Hilton Downtown', 200, '2019-10-03', 393, NULL),
('Hilton Downtown', 200, '2019-10-04', 359, NULL),
('Hilton Downtown', 200, '2019-10-05', 367, NULL),
('Hilton Downtown', 200, '2019-10-06', 362, NULL),
('Hilton Downtown', 200, '2019-10-07', 277, NULL),
('Hilton Downtown', 200, '2019-10-08', 156, NULL),
('Hilton Downtown', 200, '2019-10-09', 244, NULL),
('Hilton Downtown', 200, '2019-10-10', 272, NULL),
('Hilton Downtown', 200, '2019-10-11', 289, NULL),
('Hilton Downtown', 200, '2019-10-12', 353, NULL),
('Hilton Downtown', 200, '2019-10-13', 208, NULL),
('Hilton Downtown', 200, '2019-10-14', 308, NULL),
('Hilton Downtown', 200, '2019-10-15', 155, NULL),
('Hilton Downtown', 200, '2019-10-16', 171, NULL),
('Hilton Downtown', 200, '2019-10-17', 180, NULL),
('Hilton Downtown', 200, '2019-10-18', 123, NULL),
('Hilton Downtown', 200, '2019-10-19', 387, NULL),
('Hilton Downtown', 200, '2019-10-20', 359, NULL),
('Hilton Downtown', 200, '2019-10-21', 307, NULL),
('Hilton Downtown', 200, '2019-10-22', 350, NULL),
('Hilton Downtown', 200, '2019-10-23', 131, NULL),
('Hilton Downtown', 200, '2019-10-24', 191, NULL),
('Hilton Downtown', 200, '2019-10-25', 200, NULL),
('Hilton Downtown', 200, '2019-10-26', 114, NULL),
('Hilton Downtown', 200, '2019-10-27', 277, NULL),
('Hilton Downtown', 200, '2019-10-28', 288, NULL),
('Hilton Downtown', 200, '2019-10-29', 270, NULL),
('Hilton Downtown', 200, '2019-10-30', 203, NULL),
('Hilton Downtown', 200, '2019-10-31', 272, NULL),
('Hilton Downtown', 200, '2019-11-01', 366, NULL),
('Hilton Downtown', 200, '2019-11-02', 160, NULL),
('Hilton Downtown', 200, '2019-11-03', 277, NULL),
('Hilton Downtown', 200, '2019-11-04', 255, NULL),
('Hilton Downtown', 200, '2019-11-05', 314, NULL),
('Hilton Downtown', 200, '2019-11-06', 268, NULL),
('Hilton Downtown', 200, '2019-11-07', 394, NULL),
('Hilton Downtown', 200, '2019-11-08', 125, NULL),
('Hilton Downtown', 200, '2019-11-09', 201, NULL),
('Hilton Downtown', 200, '2019-11-10', 258, NULL),
('Hilton Downtown', 200, '2019-11-11', 270, NULL),
('Hilton Downtown', 200, '2019-11-12', 367, NULL),
('Hilton Downtown', 200, '2019-11-13', 161, NULL),
('Hilton Downtown', 200, '2019-11-14', 368, NULL),
('Hilton Downtown', 200, '2019-11-15', 115, NULL),
('Hilton Downtown', 200, '2019-11-16', 338, NULL),
('Hilton Downtown', 200, '2019-11-17', 397, NULL),
('Hilton Downtown', 200, '2019-11-18', 348, NULL),
('Hilton Downtown', 200, '2019-11-19', 291, NULL),
('Hilton Downtown', 200, '2019-11-20', 274, NULL),
('Hilton Downtown', 200, '2019-11-21', 351, NULL),
('Hilton Downtown', 200, '2019-11-22', 388, NULL),
('Hilton Downtown', 200, '2019-11-23', 339, NULL),
('Hilton Downtown', 200, '2019-11-24', 283, NULL),
('Hilton Downtown', 200, '2019-11-25', 377, NULL),
('Hilton Downtown', 200, '2019-11-26', 145, NULL),
('Hilton Downtown', 200, '2019-11-27', 262, NULL),
('Hilton Downtown', 200, '2019-11-28', 167, NULL),
('Hilton Downtown', 200, '2019-11-29', 174, NULL),
('Hilton Downtown', 200, '2019-11-30', 106, NULL),
('Hilton Downtown', 200, '2019-12-01', 383, NULL),
('Hilton Downtown', 200, '2019-12-02', 113, NULL),
('Hilton Downtown', 200, '2019-12-03', 244, NULL),
('Hilton Downtown', 200, '2019-12-04', 345, NULL),
('Hilton Downtown', 200, '2019-12-05', 238, NULL),
('Hilton Downtown', 200, '2019-12-06', 351, NULL),
('Hilton Downtown', 200, '2019-12-07', 219, NULL),
('Hilton Downtown', 200, '2019-12-08', 212, NULL),
('Hilton Downtown', 200, '2019-12-09', 367, NULL),
('Hilton Downtown', 200, '2019-12-10', 141, NULL),
('Hilton Downtown', 200, '2019-12-11', 336, NULL),
('Hilton Downtown', 200, '2019-12-12', 338, NULL),
('Hilton Downtown', 200, '2019-12-13', 130, NULL),
('Hilton Downtown', 200, '2019-12-14', 185, NULL),
('Hilton Downtown', 200, '2019-12-15', 272, NULL),
('Hilton Downtown', 200, '2019-12-16', 333, NULL),
('Hilton Downtown', 200, '2019-12-17', 304, NULL),
('Hilton Downtown', 200, '2019-12-18', 127, NULL),
('Hilton Downtown', 200, '2019-12-19', 333, NULL),
('Hilton Downtown', 200, '2019-12-20', 295, NULL),
('Hilton Downtown', 200, '2019-12-21', 341, NULL),
('Hilton Downtown', 200, '2019-12-22', 297, NULL),
('Hilton Downtown', 200, '2019-12-23', 361, NULL),
('Hilton Downtown', 200, '2019-12-24', 227, NULL),
('Hilton Downtown', 200, '2019-12-25', 398, NULL),
('Hilton Downtown', 200, '2019-12-26', 336, NULL),
('Hilton Downtown', 200, '2019-12-27', 324, NULL),
('Hilton Downtown', 200, '2019-12-28', 241, NULL),
('Hilton Downtown', 200, '2019-12-29', 263, NULL),
('Hilton Downtown', 200, '2019-12-30', 152, NULL),
('Hilton Downtown', 200, '2019-12-31', 210, NULL),
('Hilton Downtown', 200, '2020-01-01', 394, NULL),
('Hilton Downtown', 200, '2020-01-02', 213, NULL),
('Hilton Downtown', 200, '2020-01-03', 253, NULL),
('Hilton Downtown', 200, '2020-01-04', 230, NULL),
('Hilton Downtown', 200, '2020-01-05', 273, NULL),
('Hilton Downtown', 200, '2020-01-06', 191, NULL),
('Hilton Downtown', 200, '2020-01-07', 234, NULL),
('Hilton Downtown', 200, '2020-01-08', 144, NULL),
('Hilton Downtown', 200, '2020-01-09', 384, NULL),
('Hilton Downtown', 200, '2020-01-10', 201, NULL),
('Hilton Downtown', 200, '2020-01-11', 370, NULL),
('Hilton Downtown', 200, '2020-01-12', 291, NULL),
('Hilton Downtown', 200, '2020-01-13', 322, NULL),
('Hilton Downtown', 200, '2020-01-14', 310, NULL),
('Hilton Downtown', 200, '2020-01-15', 207, NULL),
('Hilton Downtown', 200, '2020-01-16', 139, NULL),
('Hilton Downtown', 200, '2020-01-17', 371, NULL),
('Hilton Downtown', 200, '2020-01-18', 211, NULL),
('Hilton Downtown', 200, '2020-01-19', 220, NULL),
('Hilton Downtown', 200, '2020-01-20', 148, NULL),
('Hilton Downtown', 200, '2020-01-21', 184, NULL),
('Hilton Downtown', 200, '2020-01-22', 237, NULL),
('Hilton Downtown', 200, '2020-01-23', 187, NULL),
('Hilton Downtown', 200, '2020-01-24', 369, NULL),
('Hilton Downtown', 200, '2020-01-25', 156, NULL),
('Hilton Downtown', 200, '2020-01-26', 105, NULL),
('Hilton Downtown', 200, '2020-01-27', 144, NULL),
('Hilton Downtown', 200, '2020-01-28', 308, NULL),
('Hilton Downtown', 200, '2020-01-29', 301, NULL),
('Hilton Downtown', 200, '2020-01-30', 245, NULL),
('Hilton Downtown', 200, '2020-01-31', 356, NULL),
('Hilton Downtown', 200, '2020-02-01', 225, NULL),
('Hilton Downtown', 200, '2020-02-02', 109, NULL),
('Hilton Downtown', 200, '2020-02-03', 288, NULL),
('Hilton Downtown', 200, '2020-02-04', 116, NULL),
('Hilton Downtown', 203, '2019-01-01', 285, NULL),
('Hilton Downtown', 203, '2019-01-02', 323, NULL),
('Hilton Downtown', 203, '2019-01-03', 197, NULL),
('Hilton Downtown', 203, '2019-01-04', 108, NULL),
('Hilton Downtown', 203, '2019-01-05', 181, NULL),
('Hilton Downtown', 203, '2019-01-06', 177, NULL),
('Hilton Downtown', 203, '2019-01-07', 379, NULL),
('Hilton Downtown', 203, '2019-01-08', 281, NULL),
('Hilton Downtown', 203, '2019-01-09', 209, NULL),
('Hilton Downtown', 203, '2019-01-10', 383, NULL),
('Hilton Downtown', 203, '2019-01-11', 371, NULL),
('Hilton Downtown', 203, '2019-01-12', 195, NULL),
('Hilton Downtown', 203, '2019-01-13', 171, NULL),
('Hilton Downtown', 203, '2019-01-14', 386, NULL),
('Hilton Downtown', 203, '2019-01-15', 280, NULL),
('Hilton Downtown', 203, '2019-01-16', 382, NULL),
('Hilton Downtown', 203, '2019-01-17', 270, NULL),
('Hilton Downtown', 203, '2019-01-18', 133, NULL),
('Hilton Downtown', 203, '2019-01-19', 350, NULL),
('Hilton Downtown', 203, '2019-01-20', 184, NULL),
('Hilton Downtown', 203, '2019-01-21', 330, NULL),
('Hilton Downtown', 203, '2019-01-22', 371, NULL),
('Hilton Downtown', 203, '2019-01-23', 320, NULL),
('Hilton Downtown', 203, '2019-01-24', 177, NULL),
('Hilton Downtown', 203, '2019-01-25', 169, NULL),
('Hilton Downtown', 203, '2019-01-26', 148, NULL),
('Hilton Downtown', 203, '2019-01-27', 159, NULL),
('Hilton Downtown', 203, '2019-01-28', 173, NULL),
('Hilton Downtown', 203, '2019-01-29', 201, NULL),
('Hilton Downtown', 203, '2019-01-30', 160, NULL),
('Hilton Downtown', 203, '2019-01-31', 350, NULL),
('Hilton Downtown', 203, '2019-02-01', 362, NULL),
('Hilton Downtown', 203, '2019-02-02', 143, NULL),
('Hilton Downtown', 203, '2019-02-03', 326, NULL),
('Hilton Downtown', 203, '2019-02-04', 246, NULL),
('Hilton Downtown', 203, '2019-02-05', 295, NULL),
('Hilton Downtown', 203, '2019-02-06', 385, NULL),
('Hilton Downtown', 203, '2019-02-07', 291, NULL),
('Hilton Downtown', 203, '2019-02-08', 338, NULL),
('Hilton Downtown', 203, '2019-02-09', 157, NULL),
('Hilton Downtown', 203, '2019-02-10', 203, NULL),
('Hilton Downtown', 203, '2019-02-11', 322, NULL),
('Hilton Downtown', 203, '2019-02-12', 313, NULL),
('Hilton Downtown', 203, '2019-02-13', 329, NULL),
('Hilton Downtown', 203, '2019-02-14', 377, NULL),
('Hilton Downtown', 203, '2019-02-15', 355, NULL),
('Hilton Downtown', 203, '2019-02-16', 359, NULL),
('Hilton Downtown', 203, '2019-02-17', 277, NULL),
('Hilton Downtown', 203, '2019-02-18', 321, NULL),
('Hilton Downtown', 203, '2019-02-19', 114, NULL),
('Hilton Downtown', 203, '2019-02-20', 155, NULL),
('Hilton Downtown', 203, '2019-02-21', 304, NULL),
('Hilton Downtown', 203, '2019-02-22', 351, NULL),
('Hilton Downtown', 203, '2019-02-23', 161, NULL),
('Hilton Downtown', 203, '2019-02-24', 171, NULL),
('Hilton Downtown', 203, '2019-02-25', 325, NULL),
('Hilton Downtown', 203, '2019-02-26', 251, NULL),
('Hilton Downtown', 203, '2019-02-27', 255, NULL),
('Hilton Downtown', 203, '2019-02-28', 277, NULL),
('Hilton Downtown', 203, '2019-03-01', 371, NULL),
('Hilton Downtown', 203, '2019-03-02', 169, NULL),
('Hilton Downtown', 203, '2019-03-03', 387, NULL),
('Hilton Downtown', 203, '2019-03-04', 310, NULL),
('Hilton Downtown', 203, '2019-03-05', 147, NULL),
('Hilton Downtown', 203, '2019-03-06', 244, NULL),
('Hilton Downtown', 203, '2019-03-07', 112, NULL),
('Hilton Downtown', 203, '2019-03-08', 267, NULL),
('Hilton Downtown', 203, '2019-03-09', 171, NULL),
('Hilton Downtown', 203, '2019-03-10', 166, NULL),
('Hilton Downtown', 203, '2019-03-11', 397, NULL),
('Hilton Downtown', 203, '2019-03-12', 187, NULL),
('Hilton Downtown', 203, '2019-03-13', 267, NULL),
('Hilton Downtown', 203, '2019-03-14', 287, NULL),
('Hilton Downtown', 203, '2019-03-15', 120, NULL),
('Hilton Downtown', 203, '2019-03-16', 245, NULL),
('Hilton Downtown', 203, '2019-03-17', 197, NULL),
('Hilton Downtown', 203, '2019-03-18', 391, NULL),
('Hilton Downtown', 203, '2019-03-19', 100, NULL),
('Hilton Downtown', 203, '2019-03-20', 313, NULL),
('Hilton Downtown', 203, '2019-03-21', 133, NULL),
('Hilton Downtown', 203, '2019-03-22', 174, NULL),
('Hilton Downtown', 203, '2019-03-23', 377, NULL),
('Hilton Downtown', 203, '2019-03-24', 242, NULL),
('Hilton Downtown', 203, '2019-03-25', 206, NULL),
('Hilton Downtown', 203, '2019-03-26', 100, NULL),
('Hilton Downtown', 203, '2019-03-27', 196, NULL),
('Hilton Downtown', 203, '2019-03-28', 190, NULL),
('Hilton Downtown', 203, '2019-03-29', 343, NULL),
('Hilton Downtown', 203, '2019-03-30', 256, NULL),
('Hilton Downtown', 203, '2019-03-31', 186, NULL),
('Hilton Downtown', 203, '2019-04-01', 221, NULL),
('Hilton Downtown', 203, '2019-04-02', 117, NULL),
('Hilton Downtown', 203, '2019-04-03', 285, NULL),
('Hilton Downtown', 203, '2019-04-04', 243, NULL),
('Hilton Downtown', 203, '2019-04-05', 295, NULL),
('Hilton Downtown', 203, '2019-04-06', 357, NULL),
('Hilton Downtown', 203, '2019-04-07', 156, NULL),
('Hilton Downtown', 203, '2019-04-08', 366, NULL),
('Hilton Downtown', 203, '2019-04-09', 227, NULL),
('Hilton Downtown', 203, '2019-04-10', 167, NULL),
('Hilton Downtown', 203, '2019-04-11', 339, NULL),
('Hilton Downtown', 203, '2019-04-12', 299, NULL),
('Hilton Downtown', 203, '2019-04-13', 274, NULL),
('Hilton Downtown', 203, '2019-04-14', 161, NULL),
('Hilton Downtown', 203, '2019-04-15', 365, NULL),
('Hilton Downtown', 203, '2019-04-16', 117, NULL),
('Hilton Downtown', 203, '2019-04-17', 297, NULL),
('Hilton Downtown', 203, '2019-04-18', 392, NULL),
('Hilton Downtown', 203, '2019-04-19', 116, NULL),
('Hilton Downtown', 203, '2019-04-20', 357, NULL),
('Hilton Downtown', 203, '2019-04-21', 297, NULL),
('Hilton Downtown', 203, '2019-04-22', 273, NULL),
('Hilton Downtown', 203, '2019-04-23', 107, NULL),
('Hilton Downtown', 203, '2019-04-24', 333, NULL),
('Hilton Downtown', 203, '2019-04-25', 109, NULL),
('Hilton Downtown', 203, '2019-04-26', 327, NULL),
('Hilton Downtown', 203, '2019-04-27', 377, NULL),
('Hilton Downtown', 203, '2019-04-28', 111, NULL),
('Hilton Downtown', 203, '2019-04-29', 106, NULL),
('Hilton Downtown', 203, '2019-04-30', 122, NULL),
('Hilton Downtown', 203, '2019-05-01', 382, NULL),
('Hilton Downtown', 203, '2019-05-02', 201, NULL),
('Hilton Downtown', 203, '2019-05-03', 283, NULL),
('Hilton Downtown', 203, '2019-05-04', 209, NULL),
('Hilton Downtown', 203, '2019-05-05', 288, NULL),
('Hilton Downtown', 203, '2019-05-06', 322, NULL),
('Hilton Downtown', 203, '2019-05-07', 105, NULL),
('Hilton Downtown', 203, '2019-05-08', 314, NULL),
('Hilton Downtown', 203, '2019-05-09', 213, NULL),
('Hilton Downtown', 203, '2019-05-10', 161, NULL),
('Hilton Downtown', 203, '2019-05-11', 239, NULL),
('Hilton Downtown', 203, '2019-05-12', 147, NULL),
('Hilton Downtown', 203, '2019-05-13', 378, NULL),
('Hilton Downtown', 203, '2019-05-14', 394, NULL),
('Hilton Downtown', 203, '2019-05-15', 199, NULL),
('Hilton Downtown', 203, '2019-05-16', 331, NULL),
('Hilton Downtown', 203, '2019-05-17', 296, NULL),
('Hilton Downtown', 203, '2019-05-18', 288, NULL),
('Hilton Downtown', 203, '2019-05-19', 153, NULL),
('Hilton Downtown', 203, '2019-05-20', 217, NULL),
('Hilton Downtown', 203, '2019-05-21', 134, NULL),
('Hilton Downtown', 203, '2019-05-22', 221, NULL),
('Hilton Downtown', 203, '2019-05-23', 191, NULL),
('Hilton Downtown', 203, '2019-05-24', 302, NULL),
('Hilton Downtown', 203, '2019-05-25', 335, NULL),
('Hilton Downtown', 203, '2019-05-26', 391, NULL),
('Hilton Downtown', 203, '2019-05-27', 370, NULL),
('Hilton Downtown', 203, '2019-05-28', 127, NULL),
('Hilton Downtown', 203, '2019-05-29', 388, NULL),
('Hilton Downtown', 203, '2019-05-30', 214, NULL),
('Hilton Downtown', 203, '2019-05-31', 108, NULL),
('Hilton Downtown', 203, '2019-06-01', 182, NULL),
('Hilton Downtown', 203, '2019-06-02', 351, NULL),
('Hilton Downtown', 203, '2019-06-03', 211, NULL),
('Hilton Downtown', 203, '2019-06-04', 322, NULL),
('Hilton Downtown', 203, '2019-06-05', 336, NULL),
('Hilton Downtown', 203, '2019-06-06', 246, NULL),
('Hilton Downtown', 203, '2019-06-07', 151, NULL),
('Hilton Downtown', 203, '2019-06-08', 353, NULL),
('Hilton Downtown', 203, '2019-06-09', 144, NULL),
('Hilton Downtown', 203, '2019-06-10', 354, NULL),
('Hilton Downtown', 203, '2019-06-11', 291, NULL),
('Hilton Downtown', 203, '2019-06-12', 394, NULL),
('Hilton Downtown', 203, '2019-06-13', 292, NULL),
('Hilton Downtown', 203, '2019-06-14', 292, NULL),
('Hilton Downtown', 203, '2019-06-15', 373, NULL),
('Hilton Downtown', 203, '2019-06-16', 366, NULL),
('Hilton Downtown', 203, '2019-06-17', 380, NULL),
('Hilton Downtown', 203, '2019-06-18', 115, NULL),
('Hilton Downtown', 203, '2019-06-19', 177, NULL),
('Hilton Downtown', 203, '2019-06-20', 181, NULL),
('Hilton Downtown', 203, '2019-06-21', 107, NULL),
('Hilton Downtown', 203, '2019-06-22', 352, NULL),
('Hilton Downtown', 203, '2019-06-23', 267, NULL),
('Hilton Downtown', 203, '2019-06-24', 100, NULL),
('Hilton Downtown', 203, '2019-06-25', 145, NULL),
('Hilton Downtown', 203, '2019-06-26', 211, NULL),
('Hilton Downtown', 203, '2019-06-27', 103, NULL),
('Hilton Downtown', 203, '2019-06-28', 346, NULL),
('Hilton Downtown', 203, '2019-06-29', 150, NULL),
('Hilton Downtown', 203, '2019-06-30', 327, NULL),
('Hilton Downtown', 203, '2019-07-01', 384, NULL),
('Hilton Downtown', 203, '2019-07-02', 114, NULL),
('Hilton Downtown', 203, '2019-07-03', 165, NULL),
('Hilton Downtown', 203, '2019-07-04', 128, NULL),
('Hilton Downtown', 203, '2019-07-05', 260, NULL),
('Hilton Downtown', 203, '2019-07-06', 354, NULL),
('Hilton Downtown', 203, '2019-07-07', 121, NULL),
('Hilton Downtown', 203, '2019-07-08', 100, NULL),
('Hilton Downtown', 203, '2019-07-09', 364, NULL),
('Hilton Downtown', 203, '2019-07-10', 317, NULL),
('Hilton Downtown', 203, '2019-07-11', 157, NULL),
('Hilton Downtown', 203, '2019-07-12', 384, NULL),
('Hilton Downtown', 203, '2019-07-13', 234, NULL),
('Hilton Downtown', 203, '2019-07-14', 197, NULL),
('Hilton Downtown', 203, '2019-07-15', 257, NULL),
('Hilton Downtown', 203, '2019-07-16', 156, NULL),
('Hilton Downtown', 203, '2019-07-17', 329, NULL),
('Hilton Downtown', 203, '2019-07-18', 252, NULL),
('Hilton Downtown', 203, '2019-07-19', 247, NULL),
('Hilton Downtown', 203, '2019-07-20', 128, NULL),
('Hilton Downtown', 203, '2019-07-21', 102, NULL),
('Hilton Downtown', 203, '2019-07-22', 182, NULL),
('Hilton Downtown', 203, '2019-07-23', 267, NULL),
('Hilton Downtown', 203, '2019-07-24', 289, NULL),
('Hilton Downtown', 203, '2019-07-25', 135, NULL),
('Hilton Downtown', 203, '2019-07-26', 124, NULL),
('Hilton Downtown', 203, '2019-07-27', 146, NULL),
('Hilton Downtown', 203, '2019-07-28', 140, NULL),
('Hilton Downtown', 203, '2019-07-29', 162, NULL),
('Hilton Downtown', 203, '2019-07-30', 277, NULL),
('Hilton Downtown', 203, '2019-07-31', 338, NULL),
('Hilton Downtown', 203, '2019-08-01', 222, NULL),
('Hilton Downtown', 203, '2019-08-02', 317, NULL),
('Hilton Downtown', 203, '2019-08-03', 144, NULL),
('Hilton Downtown', 203, '2019-08-04', 142, NULL),
('Hilton Downtown', 203, '2019-08-05', 185, NULL),
('Hilton Downtown', 203, '2019-08-06', 310, NULL),
('Hilton Downtown', 203, '2019-08-07', 160, NULL),
('Hilton Downtown', 203, '2019-08-08', 267, NULL),
('Hilton Downtown', 203, '2019-08-09', 287, NULL),
('Hilton Downtown', 203, '2019-08-10', 335, NULL),
('Hilton Downtown', 203, '2019-08-11', 328, NULL),
('Hilton Downtown', 203, '2019-08-12', 195, NULL),
('Hilton Downtown', 203, '2019-08-13', 260, NULL),
('Hilton Downtown', 203, '2019-08-14', 128, NULL),
('Hilton Downtown', 203, '2019-08-15', 265, NULL),
('Hilton Downtown', 203, '2019-08-16', 252, NULL),
('Hilton Downtown', 203, '2019-08-17', 379, NULL),
('Hilton Downtown', 203, '2019-08-18', 122, NULL),
('Hilton Downtown', 203, '2019-08-19', 129, NULL),
('Hilton Downtown', 203, '2019-08-20', 106, NULL),
('Hilton Downtown', 203, '2019-08-21', 283, NULL),
('Hilton Downtown', 203, '2019-08-22', 399, NULL),
('Hilton Downtown', 203, '2019-08-23', 311, NULL),
('Hilton Downtown', 203, '2019-08-24', 150, NULL),
('Hilton Downtown', 203, '2019-08-25', 345, NULL),
('Hilton Downtown', 203, '2019-08-26', 261, NULL),
('Hilton Downtown', 203, '2019-08-27', 392, NULL),
('Hilton Downtown', 203, '2019-08-28', 312, NULL),
('Hilton Downtown', 203, '2019-08-29', 147, NULL),
('Hilton Downtown', 203, '2019-08-30', 203, NULL),
('Hilton Downtown', 203, '2019-08-31', 109, NULL),
('Hilton Downtown', 203, '2019-09-01', 212, NULL),
('Hilton Downtown', 203, '2019-09-02', 198, NULL),
('Hilton Downtown', 203, '2019-09-03', 346, NULL),
('Hilton Downtown', 203, '2019-09-04', 383, NULL),
('Hilton Downtown', 203, '2019-09-05', 139, NULL),
('Hilton Downtown', 203, '2019-09-06', 149, NULL),
('Hilton Downtown', 203, '2019-09-07', 356, NULL),
('Hilton Downtown', 203, '2019-09-08', 167, NULL),
('Hilton Downtown', 203, '2019-09-09', 209, NULL),
('Hilton Downtown', 203, '2019-09-10', 381, NULL),
('Hilton Downtown', 203, '2019-09-11', 195, NULL),
('Hilton Downtown', 203, '2019-09-12', 211, NULL),
('Hilton Downtown', 203, '2019-09-13', 281, NULL),
('Hilton Downtown', 203, '2019-09-14', 391, NULL),
('Hilton Downtown', 203, '2019-09-15', 154, NULL),
('Hilton Downtown', 203, '2019-09-16', 205, NULL),
('Hilton Downtown', 203, '2019-09-17', 334, NULL),
('Hilton Downtown', 203, '2019-09-18', 141, NULL),
('Hilton Downtown', 203, '2019-09-19', 321, NULL),
('Hilton Downtown', 203, '2019-09-20', 237, NULL),
('Hilton Downtown', 203, '2019-09-21', 320, NULL),
('Hilton Downtown', 203, '2019-09-22', 228, NULL),
('Hilton Downtown', 203, '2019-09-23', 199, NULL),
('Hilton Downtown', 203, '2019-09-24', 370, NULL),
('Hilton Downtown', 203, '2019-09-25', 173, NULL),
('Hilton Downtown', 203, '2019-09-26', 202, NULL),
('Hilton Downtown', 203, '2019-09-27', 250, NULL),
('Hilton Downtown', 203, '2019-09-28', 319, NULL),
('Hilton Downtown', 203, '2019-09-29', 111, NULL),
('Hilton Downtown', 203, '2019-09-30', 163, NULL),
('Hilton Downtown', 203, '2019-10-01', 182, NULL),
('Hilton Downtown', 203, '2019-10-02', 176, NULL),
('Hilton Downtown', 203, '2019-10-03', 323, NULL),
('Hilton Downtown', 203, '2019-10-04', 166, NULL),
('Hilton Downtown', 203, '2019-10-05', 187, NULL),
('Hilton Downtown', 203, '2019-10-06', 367, NULL),
('Hilton Downtown', 203, '2019-10-07', 249, NULL),
('Hilton Downtown', 203, '2019-10-08', 245, NULL),
('Hilton Downtown', 203, '2019-10-09', 336, NULL),
('Hilton Downtown', 203, '2019-10-10', 392, NULL),
('Hilton Downtown', 203, '2019-10-11', 306, NULL),
('Hilton Downtown', 203, '2019-10-12', 378, NULL),
('Hilton Downtown', 203, '2019-10-13', 202, NULL),
('Hilton Downtown', 203, '2019-10-14', 186, NULL),
('Hilton Downtown', 203, '2019-10-15', 389, NULL),
('Hilton Downtown', 203, '2019-10-16', 187, NULL),
('Hilton Downtown', 203, '2019-10-17', 114, NULL),
('Hilton Downtown', 203, '2019-10-18', 126, NULL),
('Hilton Downtown', 203, '2019-10-19', 393, NULL),
('Hilton Downtown', 203, '2019-10-20', 114, NULL),
('Hilton Downtown', 203, '2019-10-21', 268, NULL),
('Hilton Downtown', 203, '2019-10-22', 269, NULL),
('Hilton Downtown', 203, '2019-10-23', 381, NULL),
('Hilton Downtown', 203, '2019-10-24', 354, NULL),
('Hilton Downtown', 203, '2019-10-25', 126, NULL),
('Hilton Downtown', 203, '2019-10-26', 213, NULL),
('Hilton Downtown', 203, '2019-10-27', 327, NULL),
('Hilton Downtown', 203, '2019-10-28', 128, NULL),
('Hilton Downtown', 203, '2019-10-29', 349, NULL),
('Hilton Downtown', 203, '2019-10-30', 135, NULL),
('Hilton Downtown', 203, '2019-10-31', 192, NULL),
('Hilton Downtown', 203, '2019-11-01', 225, NULL),
('Hilton Downtown', 203, '2019-11-02', 254, NULL),
('Hilton Downtown', 203, '2019-11-03', 181, NULL),
('Hilton Downtown', 203, '2019-11-04', 275, NULL),
('Hilton Downtown', 203, '2019-11-05', 281, NULL),
('Hilton Downtown', 203, '2019-11-06', 155, NULL),
('Hilton Downtown', 203, '2019-11-07', 225, NULL),
('Hilton Downtown', 203, '2019-11-08', 186, NULL),
('Hilton Downtown', 203, '2019-11-09', 131, NULL),
('Hilton Downtown', 203, '2019-11-10', 167, NULL),
('Hilton Downtown', 203, '2019-11-11', 346, NULL),
('Hilton Downtown', 203, '2019-11-12', 250, NULL),
('Hilton Downtown', 203, '2019-11-13', 211, NULL),
('Hilton Downtown', 203, '2019-11-14', 329, NULL),
('Hilton Downtown', 203, '2019-11-15', 261, NULL),
('Hilton Downtown', 203, '2019-11-16', 201, NULL),
('Hilton Downtown', 203, '2019-11-17', 199, NULL),
('Hilton Downtown', 203, '2019-11-18', 159, NULL),
('Hilton Downtown', 203, '2019-11-19', 389, NULL),
('Hilton Downtown', 203, '2019-11-20', 382, NULL),
('Hilton Downtown', 203, '2019-11-21', 317, NULL),
('Hilton Downtown', 203, '2019-11-22', 163, NULL),
('Hilton Downtown', 203, '2019-11-23', 254, NULL),
('Hilton Downtown', 203, '2019-11-24', 354, NULL),
('Hilton Downtown', 203, '2019-11-25', 319, NULL),
('Hilton Downtown', 203, '2019-11-26', 326, NULL),
('Hilton Downtown', 203, '2019-11-27', 282, NULL),
('Hilton Downtown', 203, '2019-11-28', 360, NULL),
('Hilton Downtown', 203, '2019-11-29', 192, NULL),
('Hilton Downtown', 203, '2019-11-30', 264, NULL),
('Hilton Downtown', 203, '2019-12-01', 265, NULL),
('Hilton Downtown', 203, '2019-12-02', 310, NULL),
('Hilton Downtown', 203, '2019-12-03', 154, NULL),
('Hilton Downtown', 203, '2019-12-04', 326, NULL),
('Hilton Downtown', 203, '2019-12-05', 394, NULL),
('Hilton Downtown', 203, '2019-12-06', 303, NULL),
('Hilton Downtown', 203, '2019-12-07', 389, NULL),
('Hilton Downtown', 203, '2019-12-08', 285, NULL),
('Hilton Downtown', 203, '2019-12-09', 173, NULL),
('Hilton Downtown', 203, '2019-12-10', 149, NULL),
('Hilton Downtown', 203, '2019-12-11', 321, NULL),
('Hilton Downtown', 203, '2019-12-12', 222, NULL),
('Hilton Downtown', 203, '2019-12-13', 349, NULL),
('Hilton Downtown', 203, '2019-12-14', 310, NULL),
('Hilton Downtown', 203, '2019-12-15', 143, NULL),
('Hilton Downtown', 203, '2019-12-16', 233, NULL),
('Hilton Downtown', 203, '2019-12-17', 190, NULL),
('Hilton Downtown', 203, '2019-12-18', 289, NULL),
('Hilton Downtown', 203, '2019-12-19', 113, NULL),
('Hilton Downtown', 203, '2019-12-20', 112, NULL),
('Hilton Downtown', 203, '2019-12-21', 280, NULL),
('Hilton Downtown', 203, '2019-12-22', 325, NULL),
('Hilton Downtown', 203, '2019-12-23', 169, NULL),
('Hilton Downtown', 203, '2019-12-24', 229, NULL),
('Hilton Downtown', 203, '2019-12-25', 204, NULL),
('Hilton Downtown', 203, '2019-12-26', 271, NULL),
('Hilton Downtown', 203, '2019-12-27', 187, NULL),
('Hilton Downtown', 203, '2019-12-28', 340, NULL),
('Hilton Downtown', 203, '2019-12-29', 345, NULL),
('Hilton Downtown', 203, '2019-12-30', 363, NULL),
('Hilton Downtown', 203, '2019-12-31', 138, NULL),
('Hilton Downtown', 203, '2020-01-01', 103, NULL),
('Hilton Downtown', 203, '2020-01-02', 344, NULL),
('Hilton Downtown', 203, '2020-01-03', 372, NULL),
('Hilton Downtown', 203, '2020-01-04', 350, NULL),
('Hilton Downtown', 203, '2020-01-05', 355, NULL),
('Hilton Downtown', 203, '2020-01-06', 328, NULL),
('Hilton Downtown', 203, '2020-01-07', 242, NULL),
('Hilton Downtown', 203, '2020-01-08', 236, NULL),
('Hilton Downtown', 203, '2020-01-09', 227, NULL),
('Hilton Downtown', 203, '2020-01-10', 213, NULL),
('Hilton Downtown', 203, '2020-01-11', 240, NULL),
('Hilton Downtown', 203, '2020-01-12', 326, NULL),
('Hilton Downtown', 203, '2020-01-13', 121, NULL),
('Hilton Downtown', 203, '2020-01-14', 102, NULL),
('Hilton Downtown', 203, '2020-01-15', 384, NULL),
('Hilton Downtown', 203, '2020-01-16', 192, NULL),
('Hilton Downtown', 203, '2020-01-17', 112, NULL),
('Hilton Downtown', 203, '2020-01-18', 310, NULL),
('Hilton Downtown', 203, '2020-01-19', 385, NULL),
('Hilton Downtown', 203, '2020-01-20', 303, NULL),
('Hilton Downtown', 203, '2020-01-21', 125, NULL),
('Hilton Downtown', 203, '2020-01-22', 134, NULL),
('Hilton Downtown', 203, '2020-01-23', 200, NULL),
('Hilton Downtown', 203, '2020-01-24', 165, NULL),
('Hilton Downtown', 203, '2020-01-25', 203, NULL),
('Hilton Downtown', 203, '2020-01-26', 149, NULL),
('Hilton Downtown', 203, '2020-01-27', 166, NULL),
('Hilton Downtown', 203, '2020-01-28', 366, NULL),
('Hilton Downtown', 203, '2020-01-29', 121, NULL),
('Hilton Downtown', 203, '2020-01-30', 363, NULL),
('Hilton Downtown', 203, '2020-01-31', 185, NULL),
('Hilton Downtown', 203, '2020-02-01', 348, NULL),
('Hilton Downtown', 203, '2020-02-02', 321, NULL),
('Hilton Downtown', 203, '2020-02-03', 171, NULL),
('Hilton Downtown', 203, '2020-02-04', 106, NULL),
('Hilton Downtown', 204, '2019-01-01', 328, NULL),
('Hilton Downtown', 204, '2019-01-02', 138, NULL),
('Hilton Downtown', 204, '2019-01-03', 387, NULL),
('Hilton Downtown', 204, '2019-01-04', 318, NULL),
('Hilton Downtown', 204, '2019-01-05', 219, NULL),
('Hilton Downtown', 204, '2019-01-06', 238, NULL),
('Hilton Downtown', 204, '2019-01-07', 372, NULL),
('Hilton Downtown', 204, '2019-01-08', 177, NULL),
('Hilton Downtown', 204, '2019-01-09', 169, NULL),
('Hilton Downtown', 204, '2019-01-10', 305, NULL),
('Hilton Downtown', 204, '2019-01-11', 171, NULL),
('Hilton Downtown', 204, '2019-01-12', 203, NULL),
('Hilton Downtown', 204, '2019-01-13', 143, NULL),
('Hilton Downtown', 204, '2019-01-14', 233, NULL),
('Hilton Downtown', 204, '2019-01-15', 174, NULL),
('Hilton Downtown', 204, '2019-01-16', 382, NULL),
('Hilton Downtown', 204, '2019-01-17', 194, NULL),
('Hilton Downtown', 204, '2019-01-18', 254, NULL),
('Hilton Downtown', 204, '2019-01-19', 124, NULL),
('Hilton Downtown', 204, '2019-01-20', 334, NULL),
('Hilton Downtown', 204, '2019-01-21', 260, NULL),
('Hilton Downtown', 204, '2019-01-22', 277, NULL),
('Hilton Downtown', 204, '2019-01-23', 385, NULL),
('Hilton Downtown', 204, '2019-01-24', 241, NULL),
('Hilton Downtown', 204, '2019-01-25', 238, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 204, '2019-01-26', 384, NULL),
('Hilton Downtown', 204, '2019-01-27', 330, NULL),
('Hilton Downtown', 204, '2019-01-28', 290, NULL),
('Hilton Downtown', 204, '2019-01-29', 312, NULL),
('Hilton Downtown', 204, '2019-01-30', 163, NULL),
('Hilton Downtown', 204, '2019-01-31', 291, NULL),
('Hilton Downtown', 204, '2019-02-01', 265, NULL),
('Hilton Downtown', 204, '2019-02-02', 195, NULL),
('Hilton Downtown', 204, '2019-02-03', 395, NULL),
('Hilton Downtown', 204, '2019-02-04', 339, NULL),
('Hilton Downtown', 204, '2019-02-05', 166, NULL),
('Hilton Downtown', 204, '2019-02-06', 331, NULL),
('Hilton Downtown', 204, '2019-02-07', 354, NULL),
('Hilton Downtown', 204, '2019-02-08', 395, NULL),
('Hilton Downtown', 204, '2019-02-09', 290, NULL),
('Hilton Downtown', 204, '2019-02-10', 376, NULL),
('Hilton Downtown', 204, '2019-02-11', 251, NULL),
('Hilton Downtown', 204, '2019-02-12', 297, NULL),
('Hilton Downtown', 204, '2019-02-13', 373, NULL),
('Hilton Downtown', 204, '2019-02-14', 304, NULL),
('Hilton Downtown', 204, '2019-02-15', 354, NULL),
('Hilton Downtown', 204, '2019-02-16', 326, NULL),
('Hilton Downtown', 204, '2019-02-17', 279, NULL),
('Hilton Downtown', 204, '2019-02-18', 134, NULL),
('Hilton Downtown', 204, '2019-02-19', 381, NULL),
('Hilton Downtown', 204, '2019-02-20', 150, NULL),
('Hilton Downtown', 204, '2019-02-21', 154, NULL),
('Hilton Downtown', 204, '2019-02-22', 157, NULL),
('Hilton Downtown', 204, '2019-02-23', 148, NULL),
('Hilton Downtown', 204, '2019-02-24', 185, NULL),
('Hilton Downtown', 204, '2019-02-25', 372, NULL),
('Hilton Downtown', 204, '2019-02-26', 314, NULL),
('Hilton Downtown', 204, '2019-02-27', 272, NULL),
('Hilton Downtown', 204, '2019-02-28', 396, NULL),
('Hilton Downtown', 204, '2019-03-01', 129, NULL),
('Hilton Downtown', 204, '2019-03-02', 152, NULL),
('Hilton Downtown', 204, '2019-03-03', 266, NULL),
('Hilton Downtown', 204, '2019-03-04', 116, NULL),
('Hilton Downtown', 204, '2019-03-05', 199, NULL),
('Hilton Downtown', 204, '2019-03-06', 125, NULL),
('Hilton Downtown', 204, '2019-03-07', 198, NULL),
('Hilton Downtown', 204, '2019-03-08', 165, NULL),
('Hilton Downtown', 204, '2019-03-09', 174, NULL),
('Hilton Downtown', 204, '2019-03-10', 276, NULL),
('Hilton Downtown', 204, '2019-03-11', 399, NULL),
('Hilton Downtown', 204, '2019-03-12', 230, NULL),
('Hilton Downtown', 204, '2019-03-13', 242, NULL),
('Hilton Downtown', 204, '2019-03-14', 376, NULL),
('Hilton Downtown', 204, '2019-03-15', 334, NULL),
('Hilton Downtown', 204, '2019-03-16', 262, NULL),
('Hilton Downtown', 204, '2019-03-17', 362, NULL),
('Hilton Downtown', 204, '2019-03-18', 310, NULL),
('Hilton Downtown', 204, '2019-03-19', 291, NULL),
('Hilton Downtown', 204, '2019-03-20', 319, NULL),
('Hilton Downtown', 204, '2019-03-21', 344, NULL),
('Hilton Downtown', 204, '2019-03-22', 106, NULL),
('Hilton Downtown', 204, '2019-03-23', 212, NULL),
('Hilton Downtown', 204, '2019-03-24', 286, NULL),
('Hilton Downtown', 204, '2019-03-25', 261, NULL),
('Hilton Downtown', 204, '2019-03-26', 128, NULL),
('Hilton Downtown', 204, '2019-03-27', 231, NULL),
('Hilton Downtown', 204, '2019-03-28', 318, NULL),
('Hilton Downtown', 204, '2019-03-29', 161, NULL),
('Hilton Downtown', 204, '2019-03-30', 107, NULL),
('Hilton Downtown', 204, '2019-03-31', 300, NULL),
('Hilton Downtown', 204, '2019-04-01', 273, NULL),
('Hilton Downtown', 204, '2019-04-02', 157, NULL),
('Hilton Downtown', 204, '2019-04-03', 148, NULL),
('Hilton Downtown', 204, '2019-04-04', 134, NULL),
('Hilton Downtown', 204, '2019-04-05', 356, NULL),
('Hilton Downtown', 204, '2019-04-06', 193, NULL),
('Hilton Downtown', 204, '2019-04-07', 326, NULL),
('Hilton Downtown', 204, '2019-04-08', 284, NULL),
('Hilton Downtown', 204, '2019-04-09', 192, NULL),
('Hilton Downtown', 204, '2019-04-10', 244, NULL),
('Hilton Downtown', 204, '2019-04-11', 203, NULL),
('Hilton Downtown', 204, '2019-04-12', 283, NULL),
('Hilton Downtown', 204, '2019-04-13', 340, NULL),
('Hilton Downtown', 204, '2019-04-14', 216, NULL),
('Hilton Downtown', 204, '2019-04-15', 255, NULL),
('Hilton Downtown', 204, '2019-04-16', 360, NULL),
('Hilton Downtown', 204, '2019-04-17', 271, NULL),
('Hilton Downtown', 204, '2019-04-18', 113, NULL),
('Hilton Downtown', 204, '2019-04-19', 176, NULL),
('Hilton Downtown', 204, '2019-04-20', 233, NULL),
('Hilton Downtown', 204, '2019-04-21', 198, NULL),
('Hilton Downtown', 204, '2019-04-22', 291, NULL),
('Hilton Downtown', 204, '2019-04-23', 191, NULL),
('Hilton Downtown', 204, '2019-04-24', 334, NULL),
('Hilton Downtown', 204, '2019-04-25', 105, NULL),
('Hilton Downtown', 204, '2019-04-26', 115, NULL),
('Hilton Downtown', 204, '2019-04-27', 238, NULL),
('Hilton Downtown', 204, '2019-04-28', 394, NULL),
('Hilton Downtown', 204, '2019-04-29', 157, NULL),
('Hilton Downtown', 204, '2019-04-30', 202, NULL),
('Hilton Downtown', 204, '2019-05-01', 253, NULL),
('Hilton Downtown', 204, '2019-05-02', 203, NULL),
('Hilton Downtown', 204, '2019-05-03', 180, NULL),
('Hilton Downtown', 204, '2019-05-04', 135, NULL),
('Hilton Downtown', 204, '2019-05-05', 217, NULL),
('Hilton Downtown', 204, '2019-05-06', 276, NULL),
('Hilton Downtown', 204, '2019-05-07', 246, NULL),
('Hilton Downtown', 204, '2019-05-08', 189, NULL),
('Hilton Downtown', 204, '2019-05-09', 367, NULL),
('Hilton Downtown', 204, '2019-05-10', 103, NULL),
('Hilton Downtown', 204, '2019-05-11', 194, NULL),
('Hilton Downtown', 204, '2019-05-12', 325, NULL),
('Hilton Downtown', 204, '2019-05-13', 162, NULL),
('Hilton Downtown', 204, '2019-05-14', 342, NULL),
('Hilton Downtown', 204, '2019-05-15', 143, NULL),
('Hilton Downtown', 204, '2019-05-16', 345, NULL),
('Hilton Downtown', 204, '2019-05-17', 163, NULL),
('Hilton Downtown', 204, '2019-05-18', 140, NULL),
('Hilton Downtown', 204, '2019-05-19', 184, NULL),
('Hilton Downtown', 204, '2019-05-20', 395, NULL),
('Hilton Downtown', 204, '2019-05-21', 213, NULL),
('Hilton Downtown', 204, '2019-05-22', 393, NULL),
('Hilton Downtown', 204, '2019-05-23', 256, NULL),
('Hilton Downtown', 204, '2019-05-24', 190, NULL),
('Hilton Downtown', 204, '2019-05-25', 379, NULL),
('Hilton Downtown', 204, '2019-05-26', 110, NULL),
('Hilton Downtown', 204, '2019-05-27', 233, NULL),
('Hilton Downtown', 204, '2019-05-28', 192, NULL),
('Hilton Downtown', 204, '2019-05-29', 229, NULL),
('Hilton Downtown', 204, '2019-05-30', 196, NULL),
('Hilton Downtown', 204, '2019-05-31', 366, NULL),
('Hilton Downtown', 204, '2019-06-01', 191, NULL),
('Hilton Downtown', 204, '2019-06-02', 224, NULL),
('Hilton Downtown', 204, '2019-06-03', 148, NULL),
('Hilton Downtown', 204, '2019-06-04', 243, NULL),
('Hilton Downtown', 204, '2019-06-05', 160, NULL),
('Hilton Downtown', 204, '2019-06-06', 376, NULL),
('Hilton Downtown', 204, '2019-06-07', 234, NULL),
('Hilton Downtown', 204, '2019-06-08', 121, NULL),
('Hilton Downtown', 204, '2019-06-09', 239, NULL),
('Hilton Downtown', 204, '2019-06-10', 304, NULL),
('Hilton Downtown', 204, '2019-06-11', 370, NULL),
('Hilton Downtown', 204, '2019-06-12', 220, NULL),
('Hilton Downtown', 204, '2019-06-13', 139, NULL),
('Hilton Downtown', 204, '2019-06-14', 205, NULL),
('Hilton Downtown', 204, '2019-06-15', 315, NULL),
('Hilton Downtown', 204, '2019-06-16', 368, NULL),
('Hilton Downtown', 204, '2019-06-17', 105, NULL),
('Hilton Downtown', 204, '2019-06-18', 369, NULL),
('Hilton Downtown', 204, '2019-06-19', 393, NULL),
('Hilton Downtown', 204, '2019-06-20', 162, NULL),
('Hilton Downtown', 204, '2019-06-21', 249, NULL),
('Hilton Downtown', 204, '2019-06-22', 143, NULL),
('Hilton Downtown', 204, '2019-06-23', 231, NULL),
('Hilton Downtown', 204, '2019-06-24', 360, NULL),
('Hilton Downtown', 204, '2019-06-25', 269, NULL),
('Hilton Downtown', 204, '2019-06-26', 167, NULL),
('Hilton Downtown', 204, '2019-06-27', 122, NULL),
('Hilton Downtown', 204, '2019-06-28', 282, NULL),
('Hilton Downtown', 204, '2019-06-29', 346, NULL),
('Hilton Downtown', 204, '2019-06-30', 271, NULL),
('Hilton Downtown', 204, '2019-07-01', 189, NULL),
('Hilton Downtown', 204, '2019-07-02', 335, NULL),
('Hilton Downtown', 204, '2019-07-03', 191, NULL),
('Hilton Downtown', 204, '2019-07-04', 377, NULL),
('Hilton Downtown', 204, '2019-07-05', 187, NULL),
('Hilton Downtown', 204, '2019-07-06', 252, NULL),
('Hilton Downtown', 204, '2019-07-07', 390, NULL),
('Hilton Downtown', 204, '2019-07-08', 318, NULL),
('Hilton Downtown', 204, '2019-07-09', 366, NULL),
('Hilton Downtown', 204, '2019-07-10', 307, NULL),
('Hilton Downtown', 204, '2019-07-11', 228, NULL),
('Hilton Downtown', 204, '2019-07-12', 355, NULL),
('Hilton Downtown', 204, '2019-07-13', 265, NULL),
('Hilton Downtown', 204, '2019-07-14', 248, NULL),
('Hilton Downtown', 204, '2019-07-15', 258, NULL),
('Hilton Downtown', 204, '2019-07-16', 248, NULL),
('Hilton Downtown', 204, '2019-07-17', 309, NULL),
('Hilton Downtown', 204, '2019-07-18', 257, NULL),
('Hilton Downtown', 204, '2019-07-19', 292, NULL),
('Hilton Downtown', 204, '2019-07-20', 376, NULL),
('Hilton Downtown', 204, '2019-07-21', 197, NULL),
('Hilton Downtown', 204, '2019-07-22', 276, NULL),
('Hilton Downtown', 204, '2019-07-23', 118, NULL),
('Hilton Downtown', 204, '2019-07-24', 148, NULL),
('Hilton Downtown', 204, '2019-07-25', 159, NULL),
('Hilton Downtown', 204, '2019-07-26', 393, NULL),
('Hilton Downtown', 204, '2019-07-27', 292, NULL),
('Hilton Downtown', 204, '2019-07-28', 185, NULL),
('Hilton Downtown', 204, '2019-07-29', 342, NULL),
('Hilton Downtown', 204, '2019-07-30', 340, NULL),
('Hilton Downtown', 204, '2019-07-31', 312, NULL),
('Hilton Downtown', 204, '2019-08-01', 102, NULL),
('Hilton Downtown', 204, '2019-08-02', 312, NULL),
('Hilton Downtown', 204, '2019-08-03', 104, NULL),
('Hilton Downtown', 204, '2019-08-04', 125, NULL),
('Hilton Downtown', 204, '2019-08-05', 271, NULL),
('Hilton Downtown', 204, '2019-08-06', 297, NULL),
('Hilton Downtown', 204, '2019-08-07', 147, NULL),
('Hilton Downtown', 204, '2019-08-08', 359, NULL),
('Hilton Downtown', 204, '2019-08-09', 149, NULL),
('Hilton Downtown', 204, '2019-08-10', 237, NULL),
('Hilton Downtown', 204, '2019-08-11', 180, NULL),
('Hilton Downtown', 204, '2019-08-12', 124, NULL),
('Hilton Downtown', 204, '2019-08-13', 320, NULL),
('Hilton Downtown', 204, '2019-08-14', 231, NULL),
('Hilton Downtown', 204, '2019-08-15', 106, NULL),
('Hilton Downtown', 204, '2019-08-16', 272, NULL),
('Hilton Downtown', 204, '2019-08-17', 205, NULL),
('Hilton Downtown', 204, '2019-08-18', 190, NULL),
('Hilton Downtown', 204, '2019-08-19', 298, NULL),
('Hilton Downtown', 204, '2019-08-20', 388, NULL),
('Hilton Downtown', 204, '2019-08-21', 260, NULL),
('Hilton Downtown', 204, '2019-08-22', 113, NULL),
('Hilton Downtown', 204, '2019-08-23', 150, NULL),
('Hilton Downtown', 204, '2019-08-24', 384, NULL),
('Hilton Downtown', 204, '2019-08-25', 148, NULL),
('Hilton Downtown', 204, '2019-08-26', 294, NULL),
('Hilton Downtown', 204, '2019-08-27', 302, NULL),
('Hilton Downtown', 204, '2019-08-28', 389, NULL),
('Hilton Downtown', 204, '2019-08-29', 139, NULL),
('Hilton Downtown', 204, '2019-08-30', 197, NULL),
('Hilton Downtown', 204, '2019-08-31', 157, NULL),
('Hilton Downtown', 204, '2019-09-01', 220, NULL),
('Hilton Downtown', 204, '2019-09-02', 260, NULL),
('Hilton Downtown', 204, '2019-09-03', 147, NULL),
('Hilton Downtown', 204, '2019-09-04', 305, NULL),
('Hilton Downtown', 204, '2019-09-05', 368, NULL),
('Hilton Downtown', 204, '2019-09-06', 160, NULL),
('Hilton Downtown', 204, '2019-09-07', 180, NULL),
('Hilton Downtown', 204, '2019-09-08', 304, NULL),
('Hilton Downtown', 204, '2019-09-09', 110, NULL),
('Hilton Downtown', 204, '2019-09-10', 232, NULL),
('Hilton Downtown', 204, '2019-09-11', 132, NULL),
('Hilton Downtown', 204, '2019-09-12', 358, NULL),
('Hilton Downtown', 204, '2019-09-13', 232, NULL),
('Hilton Downtown', 204, '2019-09-14', 139, NULL),
('Hilton Downtown', 204, '2019-09-15', 290, NULL),
('Hilton Downtown', 204, '2019-09-16', 304, NULL),
('Hilton Downtown', 204, '2019-09-17', 101, NULL),
('Hilton Downtown', 204, '2019-09-18', 268, NULL),
('Hilton Downtown', 204, '2019-09-19', 222, NULL),
('Hilton Downtown', 204, '2019-09-20', 159, NULL),
('Hilton Downtown', 204, '2019-09-21', 245, NULL),
('Hilton Downtown', 204, '2019-09-22', 283, NULL),
('Hilton Downtown', 204, '2019-09-23', 196, NULL),
('Hilton Downtown', 204, '2019-09-24', 193, NULL),
('Hilton Downtown', 204, '2019-09-25', 112, NULL),
('Hilton Downtown', 204, '2019-09-26', 223, NULL),
('Hilton Downtown', 204, '2019-09-27', 265, NULL),
('Hilton Downtown', 204, '2019-09-28', 172, NULL),
('Hilton Downtown', 204, '2019-09-29', 373, NULL),
('Hilton Downtown', 204, '2019-09-30', 344, NULL),
('Hilton Downtown', 204, '2019-10-01', 261, NULL),
('Hilton Downtown', 204, '2019-10-02', 320, NULL),
('Hilton Downtown', 204, '2019-10-03', 334, NULL),
('Hilton Downtown', 204, '2019-10-04', 253, NULL),
('Hilton Downtown', 204, '2019-10-05', 333, NULL),
('Hilton Downtown', 204, '2019-10-06', 350, NULL),
('Hilton Downtown', 204, '2019-10-07', 316, NULL),
('Hilton Downtown', 204, '2019-10-08', 357, NULL),
('Hilton Downtown', 204, '2019-10-09', 249, NULL),
('Hilton Downtown', 204, '2019-10-10', 143, NULL),
('Hilton Downtown', 204, '2019-10-11', 261, NULL),
('Hilton Downtown', 204, '2019-10-12', 135, NULL),
('Hilton Downtown', 204, '2019-10-13', 285, NULL),
('Hilton Downtown', 204, '2019-10-14', 206, NULL),
('Hilton Downtown', 204, '2019-10-15', 180, NULL),
('Hilton Downtown', 204, '2019-10-16', 321, NULL),
('Hilton Downtown', 204, '2019-10-17', 232, NULL),
('Hilton Downtown', 204, '2019-10-18', 165, NULL),
('Hilton Downtown', 204, '2019-10-19', 108, NULL),
('Hilton Downtown', 204, '2019-10-20', 291, NULL),
('Hilton Downtown', 204, '2019-10-21', 319, NULL),
('Hilton Downtown', 204, '2019-10-22', 194, NULL),
('Hilton Downtown', 204, '2019-10-23', 215, NULL),
('Hilton Downtown', 204, '2019-10-24', 195, NULL),
('Hilton Downtown', 204, '2019-10-25', 231, NULL),
('Hilton Downtown', 204, '2019-10-26', 321, NULL),
('Hilton Downtown', 204, '2019-10-27', 105, NULL),
('Hilton Downtown', 204, '2019-10-28', 277, NULL),
('Hilton Downtown', 204, '2019-10-29', 236, NULL),
('Hilton Downtown', 204, '2019-10-30', 265, NULL),
('Hilton Downtown', 204, '2019-10-31', 345, NULL),
('Hilton Downtown', 204, '2019-11-01', 226, NULL),
('Hilton Downtown', 204, '2019-11-02', 388, NULL),
('Hilton Downtown', 204, '2019-11-03', 274, NULL),
('Hilton Downtown', 204, '2019-11-04', 208, NULL),
('Hilton Downtown', 204, '2019-11-05', 364, NULL),
('Hilton Downtown', 204, '2019-11-06', 172, NULL),
('Hilton Downtown', 204, '2019-11-07', 147, NULL),
('Hilton Downtown', 204, '2019-11-08', 155, NULL),
('Hilton Downtown', 204, '2019-11-09', 252, NULL),
('Hilton Downtown', 204, '2019-11-10', 261, NULL),
('Hilton Downtown', 204, '2019-11-11', 221, NULL),
('Hilton Downtown', 204, '2019-11-12', 348, NULL),
('Hilton Downtown', 204, '2019-11-13', 173, NULL),
('Hilton Downtown', 204, '2019-11-14', 141, NULL),
('Hilton Downtown', 204, '2019-11-15', 260, NULL),
('Hilton Downtown', 204, '2019-11-16', 194, NULL),
('Hilton Downtown', 204, '2019-11-17', 305, NULL),
('Hilton Downtown', 204, '2019-11-18', 252, NULL),
('Hilton Downtown', 204, '2019-11-19', 373, NULL),
('Hilton Downtown', 204, '2019-11-20', 391, NULL),
('Hilton Downtown', 204, '2019-11-21', 131, NULL),
('Hilton Downtown', 204, '2019-11-22', 150, NULL),
('Hilton Downtown', 204, '2019-11-23', 152, NULL),
('Hilton Downtown', 204, '2019-11-24', 221, NULL),
('Hilton Downtown', 204, '2019-11-25', 364, NULL),
('Hilton Downtown', 204, '2019-11-26', 193, NULL),
('Hilton Downtown', 204, '2019-11-27', 226, NULL),
('Hilton Downtown', 204, '2019-11-28', 298, NULL),
('Hilton Downtown', 204, '2019-11-29', 342, NULL),
('Hilton Downtown', 204, '2019-11-30', 305, NULL),
('Hilton Downtown', 204, '2019-12-01', 375, NULL),
('Hilton Downtown', 204, '2019-12-02', 209, NULL),
('Hilton Downtown', 204, '2019-12-03', 241, NULL),
('Hilton Downtown', 204, '2019-12-04', 197, NULL),
('Hilton Downtown', 204, '2019-12-05', 256, NULL),
('Hilton Downtown', 204, '2019-12-06', 364, NULL),
('Hilton Downtown', 204, '2019-12-07', 291, NULL),
('Hilton Downtown', 204, '2019-12-08', 386, NULL),
('Hilton Downtown', 204, '2019-12-09', 265, NULL),
('Hilton Downtown', 204, '2019-12-10', 222, NULL),
('Hilton Downtown', 204, '2019-12-11', 196, NULL),
('Hilton Downtown', 204, '2019-12-12', 298, NULL),
('Hilton Downtown', 204, '2019-12-13', 356, NULL),
('Hilton Downtown', 204, '2019-12-14', 295, NULL),
('Hilton Downtown', 204, '2019-12-15', 101, NULL),
('Hilton Downtown', 204, '2019-12-16', 368, NULL),
('Hilton Downtown', 204, '2019-12-17', 239, NULL),
('Hilton Downtown', 204, '2019-12-18', 364, NULL),
('Hilton Downtown', 204, '2019-12-19', 364, NULL),
('Hilton Downtown', 204, '2019-12-20', 175, NULL),
('Hilton Downtown', 204, '2019-12-21', 279, NULL),
('Hilton Downtown', 204, '2019-12-22', 333, NULL),
('Hilton Downtown', 204, '2019-12-23', 264, NULL),
('Hilton Downtown', 204, '2019-12-24', 364, NULL),
('Hilton Downtown', 204, '2019-12-25', 324, NULL),
('Hilton Downtown', 204, '2019-12-26', 245, NULL),
('Hilton Downtown', 204, '2019-12-27', 164, NULL),
('Hilton Downtown', 204, '2019-12-28', 277, NULL),
('Hilton Downtown', 204, '2019-12-29', 239, NULL),
('Hilton Downtown', 204, '2019-12-30', 361, NULL),
('Hilton Downtown', 204, '2019-12-31', 262, NULL),
('Hilton Downtown', 204, '2020-01-01', 133, NULL),
('Hilton Downtown', 204, '2020-01-02', 379, NULL),
('Hilton Downtown', 204, '2020-01-03', 101, NULL),
('Hilton Downtown', 204, '2020-01-04', 360, NULL),
('Hilton Downtown', 204, '2020-01-05', 254, NULL),
('Hilton Downtown', 204, '2020-01-06', 366, NULL),
('Hilton Downtown', 204, '2020-01-07', 111, NULL),
('Hilton Downtown', 204, '2020-01-08', 350, NULL),
('Hilton Downtown', 204, '2020-01-09', 180, NULL),
('Hilton Downtown', 204, '2020-01-10', 361, NULL),
('Hilton Downtown', 204, '2020-01-11', 292, NULL),
('Hilton Downtown', 204, '2020-01-12', 356, NULL),
('Hilton Downtown', 204, '2020-01-13', 140, NULL),
('Hilton Downtown', 204, '2020-01-14', 383, NULL),
('Hilton Downtown', 204, '2020-01-15', 298, NULL),
('Hilton Downtown', 204, '2020-01-16', 142, NULL),
('Hilton Downtown', 204, '2020-01-17', 250, NULL),
('Hilton Downtown', 204, '2020-01-18', 217, NULL),
('Hilton Downtown', 204, '2020-01-19', 265, NULL),
('Hilton Downtown', 204, '2020-01-20', 372, NULL),
('Hilton Downtown', 204, '2020-01-21', 276, NULL),
('Hilton Downtown', 204, '2020-01-22', 160, NULL),
('Hilton Downtown', 204, '2020-01-23', 339, NULL),
('Hilton Downtown', 204, '2020-01-24', 216, NULL),
('Hilton Downtown', 204, '2020-01-25', 148, NULL),
('Hilton Downtown', 204, '2020-01-26', 334, NULL),
('Hilton Downtown', 204, '2020-01-27', 297, NULL),
('Hilton Downtown', 204, '2020-01-28', 203, NULL),
('Hilton Downtown', 204, '2020-01-29', 201, NULL),
('Hilton Downtown', 204, '2020-01-30', 382, NULL),
('Hilton Downtown', 204, '2020-01-31', 354, NULL),
('Hilton Downtown', 204, '2020-02-01', 367, NULL),
('Hilton Downtown', 204, '2020-02-02', 278, NULL),
('Hilton Downtown', 204, '2020-02-03', 192, NULL),
('Hilton Downtown', 204, '2020-02-04', 380, NULL),
('Hilton Downtown', 216, '2019-01-01', 384, NULL),
('Hilton Downtown', 216, '2019-01-02', 221, NULL),
('Hilton Downtown', 216, '2019-01-03', 342, NULL),
('Hilton Downtown', 216, '2019-01-04', 265, NULL),
('Hilton Downtown', 216, '2019-01-05', 154, NULL),
('Hilton Downtown', 216, '2019-01-06', 260, NULL),
('Hilton Downtown', 216, '2019-01-07', 326, NULL),
('Hilton Downtown', 216, '2019-01-08', 242, NULL),
('Hilton Downtown', 216, '2019-01-09', 121, NULL),
('Hilton Downtown', 216, '2019-01-10', 276, NULL),
('Hilton Downtown', 216, '2019-01-11', 240, NULL),
('Hilton Downtown', 216, '2019-01-12', 332, NULL),
('Hilton Downtown', 216, '2019-01-13', 104, NULL),
('Hilton Downtown', 216, '2019-01-14', 206, NULL),
('Hilton Downtown', 216, '2019-01-15', 230, NULL),
('Hilton Downtown', 216, '2019-01-16', 364, NULL),
('Hilton Downtown', 216, '2019-01-17', 364, NULL),
('Hilton Downtown', 216, '2019-01-18', 170, NULL),
('Hilton Downtown', 216, '2019-01-19', 372, NULL),
('Hilton Downtown', 216, '2019-01-20', 117, NULL),
('Hilton Downtown', 216, '2019-01-21', 209, NULL),
('Hilton Downtown', 216, '2019-01-22', 172, NULL),
('Hilton Downtown', 216, '2019-01-23', 268, NULL),
('Hilton Downtown', 216, '2019-01-24', 274, NULL),
('Hilton Downtown', 216, '2019-01-25', 285, NULL),
('Hilton Downtown', 216, '2019-01-26', 178, NULL),
('Hilton Downtown', 216, '2019-01-27', 173, NULL),
('Hilton Downtown', 216, '2019-01-28', 231, NULL),
('Hilton Downtown', 216, '2019-01-29', 259, NULL),
('Hilton Downtown', 216, '2019-01-30', 235, NULL),
('Hilton Downtown', 216, '2019-01-31', 306, NULL),
('Hilton Downtown', 216, '2019-02-01', 141, NULL),
('Hilton Downtown', 216, '2019-02-02', 150, NULL),
('Hilton Downtown', 216, '2019-02-03', 298, NULL),
('Hilton Downtown', 216, '2019-02-04', 259, NULL),
('Hilton Downtown', 216, '2019-02-05', 146, NULL),
('Hilton Downtown', 216, '2019-02-06', 100, NULL),
('Hilton Downtown', 216, '2019-02-07', 200, NULL),
('Hilton Downtown', 216, '2019-02-08', 260, NULL),
('Hilton Downtown', 216, '2019-02-09', 283, NULL),
('Hilton Downtown', 216, '2019-02-10', 273, NULL),
('Hilton Downtown', 216, '2019-02-11', 192, NULL),
('Hilton Downtown', 216, '2019-02-12', 144, NULL),
('Hilton Downtown', 216, '2019-02-13', 181, NULL),
('Hilton Downtown', 216, '2019-02-14', 288, NULL),
('Hilton Downtown', 216, '2019-02-15', 306, NULL),
('Hilton Downtown', 216, '2019-02-16', 155, NULL),
('Hilton Downtown', 216, '2019-02-17', 168, NULL),
('Hilton Downtown', 216, '2019-02-18', 205, NULL),
('Hilton Downtown', 216, '2019-02-19', 263, NULL),
('Hilton Downtown', 216, '2019-02-20', 187, NULL),
('Hilton Downtown', 216, '2019-02-21', 362, NULL),
('Hilton Downtown', 216, '2019-02-22', 230, NULL),
('Hilton Downtown', 216, '2019-02-23', 156, NULL),
('Hilton Downtown', 216, '2019-02-24', 312, NULL),
('Hilton Downtown', 216, '2019-02-25', 188, NULL),
('Hilton Downtown', 216, '2019-02-26', 117, NULL),
('Hilton Downtown', 216, '2019-02-27', 193, NULL),
('Hilton Downtown', 216, '2019-02-28', 147, NULL),
('Hilton Downtown', 216, '2019-03-01', 335, NULL),
('Hilton Downtown', 216, '2019-03-02', 152, NULL),
('Hilton Downtown', 216, '2019-03-03', 367, NULL),
('Hilton Downtown', 216, '2019-03-04', 149, NULL),
('Hilton Downtown', 216, '2019-03-05', 154, NULL),
('Hilton Downtown', 216, '2019-03-06', 392, NULL),
('Hilton Downtown', 216, '2019-03-07', 257, NULL),
('Hilton Downtown', 216, '2019-03-08', 223, NULL),
('Hilton Downtown', 216, '2019-03-09', 260, NULL),
('Hilton Downtown', 216, '2019-03-10', 181, NULL),
('Hilton Downtown', 216, '2019-03-11', 102, NULL),
('Hilton Downtown', 216, '2019-03-12', 189, NULL),
('Hilton Downtown', 216, '2019-03-13', 309, NULL),
('Hilton Downtown', 216, '2019-03-14', 321, NULL),
('Hilton Downtown', 216, '2019-03-15', 310, NULL),
('Hilton Downtown', 216, '2019-03-16', 178, NULL),
('Hilton Downtown', 216, '2019-03-17', 220, NULL),
('Hilton Downtown', 216, '2019-03-18', 278, NULL),
('Hilton Downtown', 216, '2019-03-19', 158, NULL),
('Hilton Downtown', 216, '2019-03-20', 255, NULL),
('Hilton Downtown', 216, '2019-03-21', 320, NULL),
('Hilton Downtown', 216, '2019-03-22', 207, NULL),
('Hilton Downtown', 216, '2019-03-23', 127, NULL),
('Hilton Downtown', 216, '2019-03-24', 307, NULL),
('Hilton Downtown', 216, '2019-03-25', 285, NULL),
('Hilton Downtown', 216, '2019-03-26', 237, NULL),
('Hilton Downtown', 216, '2019-03-27', 169, NULL),
('Hilton Downtown', 216, '2019-03-28', 322, NULL),
('Hilton Downtown', 216, '2019-03-29', 276, NULL),
('Hilton Downtown', 216, '2019-03-30', 267, NULL),
('Hilton Downtown', 216, '2019-03-31', 244, NULL),
('Hilton Downtown', 216, '2019-04-01', 300, NULL),
('Hilton Downtown', 216, '2019-04-02', 337, NULL),
('Hilton Downtown', 216, '2019-04-03', 382, NULL),
('Hilton Downtown', 216, '2019-04-04', 142, NULL),
('Hilton Downtown', 216, '2019-04-05', 196, NULL),
('Hilton Downtown', 216, '2019-04-06', 396, NULL),
('Hilton Downtown', 216, '2019-04-07', 165, NULL),
('Hilton Downtown', 216, '2019-04-08', 224, NULL),
('Hilton Downtown', 216, '2019-04-09', 183, NULL),
('Hilton Downtown', 216, '2019-04-10', 317, NULL),
('Hilton Downtown', 216, '2019-04-11', 197, NULL),
('Hilton Downtown', 216, '2019-04-12', 117, NULL),
('Hilton Downtown', 216, '2019-04-13', 177, NULL),
('Hilton Downtown', 216, '2019-04-14', 197, NULL),
('Hilton Downtown', 216, '2019-04-15', 379, NULL),
('Hilton Downtown', 216, '2019-04-16', 152, NULL),
('Hilton Downtown', 216, '2019-04-17', 364, NULL),
('Hilton Downtown', 216, '2019-04-18', 190, NULL),
('Hilton Downtown', 216, '2019-04-19', 131, NULL),
('Hilton Downtown', 216, '2019-04-20', 294, NULL),
('Hilton Downtown', 216, '2019-04-21', 301, NULL),
('Hilton Downtown', 216, '2019-04-22', 236, NULL),
('Hilton Downtown', 216, '2019-04-23', 237, NULL),
('Hilton Downtown', 216, '2019-04-24', 269, NULL),
('Hilton Downtown', 216, '2019-04-25', 399, NULL),
('Hilton Downtown', 216, '2019-04-26', 393, NULL),
('Hilton Downtown', 216, '2019-04-27', 260, NULL),
('Hilton Downtown', 216, '2019-04-28', 338, NULL),
('Hilton Downtown', 216, '2019-04-29', 369, NULL),
('Hilton Downtown', 216, '2019-04-30', 247, NULL),
('Hilton Downtown', 216, '2019-05-01', 318, NULL),
('Hilton Downtown', 216, '2019-05-02', 314, NULL),
('Hilton Downtown', 216, '2019-05-03', 253, NULL),
('Hilton Downtown', 216, '2019-05-04', 248, NULL),
('Hilton Downtown', 216, '2019-05-05', 122, NULL),
('Hilton Downtown', 216, '2019-05-06', 316, NULL),
('Hilton Downtown', 216, '2019-05-07', 218, NULL),
('Hilton Downtown', 216, '2019-05-08', 201, NULL),
('Hilton Downtown', 216, '2019-05-09', 197, NULL),
('Hilton Downtown', 216, '2019-05-10', 236, NULL),
('Hilton Downtown', 216, '2019-05-11', 154, NULL),
('Hilton Downtown', 216, '2019-05-12', 183, NULL),
('Hilton Downtown', 216, '2019-05-13', 173, NULL),
('Hilton Downtown', 216, '2019-05-14', 131, NULL),
('Hilton Downtown', 216, '2019-05-15', 316, NULL),
('Hilton Downtown', 216, '2019-05-16', 334, NULL),
('Hilton Downtown', 216, '2019-05-17', 126, NULL),
('Hilton Downtown', 216, '2019-05-18', 334, NULL),
('Hilton Downtown', 216, '2019-05-19', 358, NULL),
('Hilton Downtown', 216, '2019-05-20', 323, NULL),
('Hilton Downtown', 216, '2019-05-21', 265, NULL),
('Hilton Downtown', 216, '2019-05-22', 302, NULL),
('Hilton Downtown', 216, '2019-05-23', 310, NULL),
('Hilton Downtown', 216, '2019-05-24', 247, NULL),
('Hilton Downtown', 216, '2019-05-25', 192, NULL),
('Hilton Downtown', 216, '2019-05-26', 179, NULL),
('Hilton Downtown', 216, '2019-05-27', 254, NULL),
('Hilton Downtown', 216, '2019-05-28', 179, NULL),
('Hilton Downtown', 216, '2019-05-29', 183, NULL),
('Hilton Downtown', 216, '2019-05-30', 239, NULL),
('Hilton Downtown', 216, '2019-05-31', 209, NULL),
('Hilton Downtown', 216, '2019-06-01', 309, NULL),
('Hilton Downtown', 216, '2019-06-02', 267, NULL),
('Hilton Downtown', 216, '2019-06-03', 309, NULL),
('Hilton Downtown', 216, '2019-06-04', 151, NULL),
('Hilton Downtown', 216, '2019-06-05', 295, NULL),
('Hilton Downtown', 216, '2019-06-06', 142, NULL),
('Hilton Downtown', 216, '2019-06-07', 320, NULL),
('Hilton Downtown', 216, '2019-06-08', 344, NULL),
('Hilton Downtown', 216, '2019-06-09', 365, NULL),
('Hilton Downtown', 216, '2019-06-10', 358, NULL),
('Hilton Downtown', 216, '2019-06-11', 279, NULL),
('Hilton Downtown', 216, '2019-06-12', 117, NULL),
('Hilton Downtown', 216, '2019-06-13', 318, NULL),
('Hilton Downtown', 216, '2019-06-14', 346, NULL),
('Hilton Downtown', 216, '2019-06-15', 357, NULL),
('Hilton Downtown', 216, '2019-06-16', 340, NULL),
('Hilton Downtown', 216, '2019-06-17', 185, NULL),
('Hilton Downtown', 216, '2019-06-18', 203, NULL),
('Hilton Downtown', 216, '2019-06-19', 135, NULL),
('Hilton Downtown', 216, '2019-06-20', 168, NULL),
('Hilton Downtown', 216, '2019-06-21', 224, NULL),
('Hilton Downtown', 216, '2019-06-22', 161, NULL),
('Hilton Downtown', 216, '2019-06-23', 255, NULL),
('Hilton Downtown', 216, '2019-06-24', 203, NULL),
('Hilton Downtown', 216, '2019-06-25', 209, NULL),
('Hilton Downtown', 216, '2019-06-26', 102, NULL),
('Hilton Downtown', 216, '2019-06-27', 200, NULL),
('Hilton Downtown', 216, '2019-06-28', 272, NULL),
('Hilton Downtown', 216, '2019-06-29', 283, NULL),
('Hilton Downtown', 216, '2019-06-30', 275, NULL),
('Hilton Downtown', 216, '2019-07-01', 293, NULL),
('Hilton Downtown', 216, '2019-07-02', 337, NULL),
('Hilton Downtown', 216, '2019-07-03', 362, NULL),
('Hilton Downtown', 216, '2019-07-04', 199, NULL),
('Hilton Downtown', 216, '2019-07-05', 354, NULL),
('Hilton Downtown', 216, '2019-07-06', 396, NULL),
('Hilton Downtown', 216, '2019-07-07', 284, NULL),
('Hilton Downtown', 216, '2019-07-08', 288, NULL),
('Hilton Downtown', 216, '2019-07-09', 340, NULL),
('Hilton Downtown', 216, '2019-07-10', 184, NULL),
('Hilton Downtown', 216, '2019-07-11', 268, NULL),
('Hilton Downtown', 216, '2019-07-12', 221, NULL),
('Hilton Downtown', 216, '2019-07-13', 223, NULL),
('Hilton Downtown', 216, '2019-07-14', 248, NULL),
('Hilton Downtown', 216, '2019-07-15', 119, NULL),
('Hilton Downtown', 216, '2019-07-16', 373, NULL),
('Hilton Downtown', 216, '2019-07-17', 157, NULL),
('Hilton Downtown', 216, '2019-07-18', 130, NULL),
('Hilton Downtown', 216, '2019-07-19', 320, NULL),
('Hilton Downtown', 216, '2019-07-20', 198, NULL),
('Hilton Downtown', 216, '2019-07-21', 279, NULL),
('Hilton Downtown', 216, '2019-07-22', 136, NULL),
('Hilton Downtown', 216, '2019-07-23', 289, NULL),
('Hilton Downtown', 216, '2019-07-24', 374, NULL),
('Hilton Downtown', 216, '2019-07-25', 288, NULL),
('Hilton Downtown', 216, '2019-07-26', 293, NULL),
('Hilton Downtown', 216, '2019-07-27', 320, NULL),
('Hilton Downtown', 216, '2019-07-28', 109, NULL),
('Hilton Downtown', 216, '2019-07-29', 222, NULL),
('Hilton Downtown', 216, '2019-07-30', 173, NULL),
('Hilton Downtown', 216, '2019-07-31', 147, NULL),
('Hilton Downtown', 216, '2019-08-01', 343, NULL),
('Hilton Downtown', 216, '2019-08-02', 209, NULL),
('Hilton Downtown', 216, '2019-08-03', 286, NULL),
('Hilton Downtown', 216, '2019-08-04', 398, NULL),
('Hilton Downtown', 216, '2019-08-05', 100, NULL),
('Hilton Downtown', 216, '2019-08-06', 156, NULL),
('Hilton Downtown', 216, '2019-08-07', 158, NULL),
('Hilton Downtown', 216, '2019-08-08', 293, NULL),
('Hilton Downtown', 216, '2019-08-09', 387, NULL),
('Hilton Downtown', 216, '2019-08-10', 382, NULL),
('Hilton Downtown', 216, '2019-08-11', 120, NULL),
('Hilton Downtown', 216, '2019-08-12', 235, NULL),
('Hilton Downtown', 216, '2019-08-13', 122, NULL),
('Hilton Downtown', 216, '2019-08-14', 371, NULL),
('Hilton Downtown', 216, '2019-08-15', 234, NULL),
('Hilton Downtown', 216, '2019-08-16', 203, NULL),
('Hilton Downtown', 216, '2019-08-17', 385, NULL),
('Hilton Downtown', 216, '2019-08-18', 184, NULL),
('Hilton Downtown', 216, '2019-08-19', 101, NULL),
('Hilton Downtown', 216, '2019-08-20', 323, NULL),
('Hilton Downtown', 216, '2019-08-21', 348, NULL),
('Hilton Downtown', 216, '2019-08-22', 168, NULL),
('Hilton Downtown', 216, '2019-08-23', 318, NULL),
('Hilton Downtown', 216, '2019-08-24', 171, NULL),
('Hilton Downtown', 216, '2019-08-25', 205, NULL),
('Hilton Downtown', 216, '2019-08-26', 287, NULL),
('Hilton Downtown', 216, '2019-08-27', 235, NULL),
('Hilton Downtown', 216, '2019-08-28', 313, NULL),
('Hilton Downtown', 216, '2019-08-29', 153, NULL),
('Hilton Downtown', 216, '2019-08-30', 279, NULL),
('Hilton Downtown', 216, '2019-08-31', 357, NULL),
('Hilton Downtown', 216, '2019-09-01', 364, NULL),
('Hilton Downtown', 216, '2019-09-02', 307, NULL),
('Hilton Downtown', 216, '2019-09-03', 197, NULL),
('Hilton Downtown', 216, '2019-09-04', 276, NULL),
('Hilton Downtown', 216, '2019-09-05', 123, NULL),
('Hilton Downtown', 216, '2019-09-06', 252, NULL),
('Hilton Downtown', 216, '2019-09-07', 333, NULL),
('Hilton Downtown', 216, '2019-09-08', 318, NULL),
('Hilton Downtown', 216, '2019-09-09', 123, NULL),
('Hilton Downtown', 216, '2019-09-10', 219, NULL),
('Hilton Downtown', 216, '2019-09-11', 274, NULL),
('Hilton Downtown', 216, '2019-09-12', 156, NULL),
('Hilton Downtown', 216, '2019-09-13', 218, NULL),
('Hilton Downtown', 216, '2019-09-14', 321, NULL),
('Hilton Downtown', 216, '2019-09-15', 289, NULL),
('Hilton Downtown', 216, '2019-09-16', 204, NULL),
('Hilton Downtown', 216, '2019-09-17', 303, NULL),
('Hilton Downtown', 216, '2019-09-18', 215, NULL),
('Hilton Downtown', 216, '2019-09-19', 349, NULL),
('Hilton Downtown', 216, '2019-09-20', 284, NULL),
('Hilton Downtown', 216, '2019-09-21', 164, NULL),
('Hilton Downtown', 216, '2019-09-22', 332, NULL),
('Hilton Downtown', 216, '2019-09-23', 281, NULL),
('Hilton Downtown', 216, '2019-09-24', 355, NULL),
('Hilton Downtown', 216, '2019-09-25', 239, NULL),
('Hilton Downtown', 216, '2019-09-26', 109, NULL),
('Hilton Downtown', 216, '2019-09-27', 177, NULL),
('Hilton Downtown', 216, '2019-09-28', 101, NULL),
('Hilton Downtown', 216, '2019-09-29', 229, NULL),
('Hilton Downtown', 216, '2019-09-30', 234, NULL),
('Hilton Downtown', 216, '2019-10-01', 357, NULL),
('Hilton Downtown', 216, '2019-10-02', 372, NULL),
('Hilton Downtown', 216, '2019-10-03', 303, NULL),
('Hilton Downtown', 216, '2019-10-04', 368, NULL),
('Hilton Downtown', 216, '2019-10-05', 103, NULL),
('Hilton Downtown', 216, '2019-10-06', 252, NULL),
('Hilton Downtown', 216, '2019-10-07', 131, NULL),
('Hilton Downtown', 216, '2019-10-08', 351, NULL),
('Hilton Downtown', 216, '2019-10-09', 138, NULL),
('Hilton Downtown', 216, '2019-10-10', 341, NULL),
('Hilton Downtown', 216, '2019-10-11', 288, NULL),
('Hilton Downtown', 216, '2019-10-12', 340, NULL),
('Hilton Downtown', 216, '2019-10-13', 121, NULL),
('Hilton Downtown', 216, '2019-10-14', 375, NULL),
('Hilton Downtown', 216, '2019-10-15', 235, NULL),
('Hilton Downtown', 216, '2019-10-16', 346, NULL),
('Hilton Downtown', 216, '2019-10-17', 118, NULL),
('Hilton Downtown', 216, '2019-10-18', 345, NULL),
('Hilton Downtown', 216, '2019-10-19', 159, NULL),
('Hilton Downtown', 216, '2019-10-20', 113, NULL),
('Hilton Downtown', 216, '2019-10-21', 390, NULL),
('Hilton Downtown', 216, '2019-10-22', 367, NULL),
('Hilton Downtown', 216, '2019-10-23', 130, NULL),
('Hilton Downtown', 216, '2019-10-24', 117, NULL),
('Hilton Downtown', 216, '2019-10-25', 376, NULL),
('Hilton Downtown', 216, '2019-10-26', 267, NULL),
('Hilton Downtown', 216, '2019-10-27', 342, NULL),
('Hilton Downtown', 216, '2019-10-28', 301, NULL),
('Hilton Downtown', 216, '2019-10-29', 334, NULL),
('Hilton Downtown', 216, '2019-10-30', 221, NULL),
('Hilton Downtown', 216, '2019-10-31', 150, NULL),
('Hilton Downtown', 216, '2019-11-01', 354, NULL),
('Hilton Downtown', 216, '2019-11-02', 181, NULL),
('Hilton Downtown', 216, '2019-11-03', 129, NULL),
('Hilton Downtown', 216, '2019-11-04', 116, NULL),
('Hilton Downtown', 216, '2019-11-05', 275, NULL),
('Hilton Downtown', 216, '2019-11-06', 295, NULL),
('Hilton Downtown', 216, '2019-11-07', 258, NULL),
('Hilton Downtown', 216, '2019-11-08', 119, NULL),
('Hilton Downtown', 216, '2019-11-09', 168, NULL),
('Hilton Downtown', 216, '2019-11-10', 105, NULL),
('Hilton Downtown', 216, '2019-11-11', 270, NULL),
('Hilton Downtown', 216, '2019-11-12', 289, NULL),
('Hilton Downtown', 216, '2019-11-13', 134, NULL),
('Hilton Downtown', 216, '2019-11-14', 219, NULL),
('Hilton Downtown', 216, '2019-11-15', 117, NULL),
('Hilton Downtown', 216, '2019-11-16', 265, NULL),
('Hilton Downtown', 216, '2019-11-17', 229, NULL),
('Hilton Downtown', 216, '2019-11-18', 382, NULL),
('Hilton Downtown', 216, '2019-11-19', 297, NULL),
('Hilton Downtown', 216, '2019-11-20', 107, NULL),
('Hilton Downtown', 216, '2019-11-21', 206, NULL),
('Hilton Downtown', 216, '2019-11-22', 163, NULL),
('Hilton Downtown', 216, '2019-11-23', 197, NULL),
('Hilton Downtown', 216, '2019-11-24', 244, NULL),
('Hilton Downtown', 216, '2019-11-25', 166, NULL),
('Hilton Downtown', 216, '2019-11-26', 189, NULL),
('Hilton Downtown', 216, '2019-11-27', 182, NULL),
('Hilton Downtown', 216, '2019-11-28', 312, NULL),
('Hilton Downtown', 216, '2019-11-29', 133, NULL),
('Hilton Downtown', 216, '2019-11-30', 334, NULL),
('Hilton Downtown', 216, '2019-12-01', 383, NULL),
('Hilton Downtown', 216, '2019-12-02', 318, NULL),
('Hilton Downtown', 216, '2019-12-03', 341, NULL),
('Hilton Downtown', 216, '2019-12-04', 205, NULL),
('Hilton Downtown', 216, '2019-12-05', 299, NULL),
('Hilton Downtown', 216, '2019-12-06', 209, NULL),
('Hilton Downtown', 216, '2019-12-07', 187, NULL),
('Hilton Downtown', 216, '2019-12-08', 377, NULL),
('Hilton Downtown', 216, '2019-12-09', 107, NULL),
('Hilton Downtown', 216, '2019-12-10', 265, NULL),
('Hilton Downtown', 216, '2019-12-11', 218, NULL),
('Hilton Downtown', 216, '2019-12-12', 122, NULL),
('Hilton Downtown', 216, '2019-12-13', 335, NULL),
('Hilton Downtown', 216, '2019-12-14', 144, NULL),
('Hilton Downtown', 216, '2019-12-15', 274, NULL),
('Hilton Downtown', 216, '2019-12-16', 143, NULL),
('Hilton Downtown', 216, '2019-12-17', 226, NULL),
('Hilton Downtown', 216, '2019-12-18', 254, NULL),
('Hilton Downtown', 216, '2019-12-19', 181, NULL),
('Hilton Downtown', 216, '2019-12-20', 140, NULL),
('Hilton Downtown', 216, '2019-12-21', 155, NULL),
('Hilton Downtown', 216, '2019-12-22', 292, NULL),
('Hilton Downtown', 216, '2019-12-23', 115, NULL),
('Hilton Downtown', 216, '2019-12-24', 135, NULL),
('Hilton Downtown', 216, '2019-12-25', 308, NULL),
('Hilton Downtown', 216, '2019-12-26', 312, NULL),
('Hilton Downtown', 216, '2019-12-27', 158, NULL),
('Hilton Downtown', 216, '2019-12-28', 265, NULL),
('Hilton Downtown', 216, '2019-12-29', 359, NULL),
('Hilton Downtown', 216, '2019-12-30', 313, NULL),
('Hilton Downtown', 216, '2019-12-31', 193, NULL),
('Hilton Downtown', 216, '2020-01-01', 259, NULL),
('Hilton Downtown', 216, '2020-01-02', 167, NULL),
('Hilton Downtown', 216, '2020-01-03', 190, NULL),
('Hilton Downtown', 216, '2020-01-04', 350, NULL),
('Hilton Downtown', 216, '2020-01-05', 105, NULL),
('Hilton Downtown', 216, '2020-01-06', 147, NULL),
('Hilton Downtown', 216, '2020-01-07', 328, NULL),
('Hilton Downtown', 216, '2020-01-08', 343, NULL),
('Hilton Downtown', 216, '2020-01-09', 121, NULL),
('Hilton Downtown', 216, '2020-01-10', 166, NULL),
('Hilton Downtown', 216, '2020-01-11', 337, NULL),
('Hilton Downtown', 216, '2020-01-12', 104, NULL),
('Hilton Downtown', 216, '2020-01-13', 237, NULL),
('Hilton Downtown', 216, '2020-01-14', 308, NULL),
('Hilton Downtown', 216, '2020-01-15', 238, NULL),
('Hilton Downtown', 216, '2020-01-16', 338, NULL),
('Hilton Downtown', 216, '2020-01-17', 212, NULL),
('Hilton Downtown', 216, '2020-01-18', 355, NULL),
('Hilton Downtown', 216, '2020-01-19', 370, NULL),
('Hilton Downtown', 216, '2020-01-20', 251, NULL),
('Hilton Downtown', 216, '2020-01-21', 305, NULL),
('Hilton Downtown', 216, '2020-01-22', 301, NULL),
('Hilton Downtown', 216, '2020-01-23', 398, NULL),
('Hilton Downtown', 216, '2020-01-24', 188, NULL),
('Hilton Downtown', 216, '2020-01-25', 331, NULL),
('Hilton Downtown', 216, '2020-01-26', 221, NULL),
('Hilton Downtown', 216, '2020-01-27', 289, NULL),
('Hilton Downtown', 216, '2020-01-28', 119, NULL),
('Hilton Downtown', 216, '2020-01-29', 242, NULL),
('Hilton Downtown', 216, '2020-01-30', 121, NULL),
('Hilton Downtown', 216, '2020-01-31', 216, NULL),
('Hilton Downtown', 216, '2020-02-01', 391, NULL),
('Hilton Downtown', 216, '2020-02-02', 329, NULL),
('Hilton Downtown', 216, '2020-02-03', 348, NULL),
('Hilton Downtown', 216, '2020-02-04', 282, NULL),
('Hilton Downtown', 219, '2019-01-01', 238, NULL),
('Hilton Downtown', 219, '2019-01-02', 293, NULL),
('Hilton Downtown', 219, '2019-01-03', 152, NULL),
('Hilton Downtown', 219, '2019-01-04', 271, NULL),
('Hilton Downtown', 219, '2019-01-05', 311, NULL),
('Hilton Downtown', 219, '2019-01-06', 189, NULL),
('Hilton Downtown', 219, '2019-01-07', 116, NULL),
('Hilton Downtown', 219, '2019-01-08', 279, NULL),
('Hilton Downtown', 219, '2019-01-09', 299, NULL),
('Hilton Downtown', 219, '2019-01-10', 364, NULL),
('Hilton Downtown', 219, '2019-01-11', 289, NULL),
('Hilton Downtown', 219, '2019-01-12', 351, NULL),
('Hilton Downtown', 219, '2019-01-13', 291, NULL),
('Hilton Downtown', 219, '2019-01-14', 231, NULL),
('Hilton Downtown', 219, '2019-01-15', 227, NULL),
('Hilton Downtown', 219, '2019-01-16', 274, NULL),
('Hilton Downtown', 219, '2019-01-17', 238, NULL),
('Hilton Downtown', 219, '2019-01-18', 288, NULL),
('Hilton Downtown', 219, '2019-01-19', 188, NULL),
('Hilton Downtown', 219, '2019-01-20', 386, NULL),
('Hilton Downtown', 219, '2019-01-21', 166, NULL),
('Hilton Downtown', 219, '2019-01-22', 231, NULL),
('Hilton Downtown', 219, '2019-01-23', 384, NULL),
('Hilton Downtown', 219, '2019-01-24', 246, NULL),
('Hilton Downtown', 219, '2019-01-25', 308, NULL),
('Hilton Downtown', 219, '2019-01-26', 238, NULL),
('Hilton Downtown', 219, '2019-01-27', 376, NULL),
('Hilton Downtown', 219, '2019-01-28', 186, NULL),
('Hilton Downtown', 219, '2019-01-29', 261, NULL),
('Hilton Downtown', 219, '2019-01-30', 287, NULL),
('Hilton Downtown', 219, '2019-01-31', 258, NULL),
('Hilton Downtown', 219, '2019-02-01', 109, NULL),
('Hilton Downtown', 219, '2019-02-02', 365, NULL),
('Hilton Downtown', 219, '2019-02-03', 204, NULL),
('Hilton Downtown', 219, '2019-02-04', 179, NULL),
('Hilton Downtown', 219, '2019-02-05', 131, NULL),
('Hilton Downtown', 219, '2019-02-06', 308, NULL),
('Hilton Downtown', 219, '2019-02-07', 135, NULL),
('Hilton Downtown', 219, '2019-02-08', 317, NULL),
('Hilton Downtown', 219, '2019-02-09', 144, NULL),
('Hilton Downtown', 219, '2019-02-10', 139, NULL),
('Hilton Downtown', 219, '2019-02-11', 106, NULL),
('Hilton Downtown', 219, '2019-02-12', 333, NULL),
('Hilton Downtown', 219, '2019-02-13', 287, NULL),
('Hilton Downtown', 219, '2019-02-14', 128, NULL),
('Hilton Downtown', 219, '2019-02-15', 370, NULL),
('Hilton Downtown', 219, '2019-02-16', 297, NULL),
('Hilton Downtown', 219, '2019-02-17', 200, NULL),
('Hilton Downtown', 219, '2019-02-18', 225, NULL),
('Hilton Downtown', 219, '2019-02-19', 373, NULL),
('Hilton Downtown', 219, '2019-02-20', 385, NULL),
('Hilton Downtown', 219, '2019-02-21', 346, NULL),
('Hilton Downtown', 219, '2019-02-22', 278, NULL),
('Hilton Downtown', 219, '2019-02-23', 236, NULL),
('Hilton Downtown', 219, '2019-02-24', 307, NULL),
('Hilton Downtown', 219, '2019-02-25', 322, NULL),
('Hilton Downtown', 219, '2019-02-26', 145, NULL),
('Hilton Downtown', 219, '2019-02-27', 353, NULL),
('Hilton Downtown', 219, '2019-02-28', 350, NULL),
('Hilton Downtown', 219, '2019-03-01', 290, NULL),
('Hilton Downtown', 219, '2019-03-02', 206, NULL),
('Hilton Downtown', 219, '2019-03-03', 338, NULL),
('Hilton Downtown', 219, '2019-03-04', 296, NULL),
('Hilton Downtown', 219, '2019-03-05', 371, NULL),
('Hilton Downtown', 219, '2019-03-06', 285, NULL),
('Hilton Downtown', 219, '2019-03-07', 290, NULL),
('Hilton Downtown', 219, '2019-03-08', 222, NULL),
('Hilton Downtown', 219, '2019-03-09', 377, NULL),
('Hilton Downtown', 219, '2019-03-10', 279, NULL),
('Hilton Downtown', 219, '2019-03-11', 116, NULL),
('Hilton Downtown', 219, '2019-03-12', 156, NULL),
('Hilton Downtown', 219, '2019-03-13', 120, NULL),
('Hilton Downtown', 219, '2019-03-14', 376, NULL),
('Hilton Downtown', 219, '2019-03-15', 148, NULL),
('Hilton Downtown', 219, '2019-03-16', 305, NULL),
('Hilton Downtown', 219, '2019-03-17', 212, NULL),
('Hilton Downtown', 219, '2019-03-18', 359, NULL),
('Hilton Downtown', 219, '2019-03-19', 118, NULL),
('Hilton Downtown', 219, '2019-03-20', 219, NULL),
('Hilton Downtown', 219, '2019-03-21', 170, NULL),
('Hilton Downtown', 219, '2019-03-22', 320, NULL),
('Hilton Downtown', 219, '2019-03-23', 202, NULL),
('Hilton Downtown', 219, '2019-03-24', 276, NULL),
('Hilton Downtown', 219, '2019-03-25', 242, NULL),
('Hilton Downtown', 219, '2019-03-26', 103, NULL),
('Hilton Downtown', 219, '2019-03-27', 352, NULL),
('Hilton Downtown', 219, '2019-03-28', 255, NULL),
('Hilton Downtown', 219, '2019-03-29', 196, NULL),
('Hilton Downtown', 219, '2019-03-30', 316, NULL),
('Hilton Downtown', 219, '2019-03-31', 222, NULL),
('Hilton Downtown', 219, '2019-04-01', 282, NULL),
('Hilton Downtown', 219, '2019-04-02', 212, NULL),
('Hilton Downtown', 219, '2019-04-03', 166, NULL),
('Hilton Downtown', 219, '2019-04-04', 208, NULL),
('Hilton Downtown', 219, '2019-04-05', 112, NULL),
('Hilton Downtown', 219, '2019-04-06', 399, NULL),
('Hilton Downtown', 219, '2019-04-07', 344, NULL),
('Hilton Downtown', 219, '2019-04-08', 168, NULL),
('Hilton Downtown', 219, '2019-04-09', 239, NULL),
('Hilton Downtown', 219, '2019-04-10', 156, NULL),
('Hilton Downtown', 219, '2019-04-11', 278, NULL),
('Hilton Downtown', 219, '2019-04-12', 237, NULL),
('Hilton Downtown', 219, '2019-04-13', 365, NULL),
('Hilton Downtown', 219, '2019-04-14', 241, NULL),
('Hilton Downtown', 219, '2019-04-15', 131, NULL),
('Hilton Downtown', 219, '2019-04-16', 177, NULL),
('Hilton Downtown', 219, '2019-04-17', 305, NULL),
('Hilton Downtown', 219, '2019-04-18', 211, NULL),
('Hilton Downtown', 219, '2019-04-19', 330, NULL),
('Hilton Downtown', 219, '2019-04-20', 370, NULL),
('Hilton Downtown', 219, '2019-04-21', 210, NULL),
('Hilton Downtown', 219, '2019-04-22', 210, NULL),
('Hilton Downtown', 219, '2019-04-23', 211, NULL),
('Hilton Downtown', 219, '2019-04-24', 247, NULL),
('Hilton Downtown', 219, '2019-04-25', 379, NULL),
('Hilton Downtown', 219, '2019-04-26', 320, NULL),
('Hilton Downtown', 219, '2019-04-27', 188, NULL),
('Hilton Downtown', 219, '2019-04-28', 107, NULL),
('Hilton Downtown', 219, '2019-04-29', 372, NULL),
('Hilton Downtown', 219, '2019-04-30', 230, NULL),
('Hilton Downtown', 219, '2019-05-01', 131, NULL),
('Hilton Downtown', 219, '2019-05-02', 262, NULL),
('Hilton Downtown', 219, '2019-05-03', 327, NULL),
('Hilton Downtown', 219, '2019-05-04', 135, NULL),
('Hilton Downtown', 219, '2019-05-05', 159, NULL),
('Hilton Downtown', 219, '2019-05-06', 350, NULL),
('Hilton Downtown', 219, '2019-05-07', 249, NULL),
('Hilton Downtown', 219, '2019-05-08', 341, NULL),
('Hilton Downtown', 219, '2019-05-09', 384, NULL),
('Hilton Downtown', 219, '2019-05-10', 169, NULL),
('Hilton Downtown', 219, '2019-05-11', 389, NULL),
('Hilton Downtown', 219, '2019-05-12', 143, NULL),
('Hilton Downtown', 219, '2019-05-13', 282, NULL),
('Hilton Downtown', 219, '2019-05-14', 131, NULL),
('Hilton Downtown', 219, '2019-05-15', 153, NULL),
('Hilton Downtown', 219, '2019-05-16', 232, NULL),
('Hilton Downtown', 219, '2019-05-17', 343, NULL),
('Hilton Downtown', 219, '2019-05-18', 253, NULL),
('Hilton Downtown', 219, '2019-05-19', 241, NULL),
('Hilton Downtown', 219, '2019-05-20', 331, NULL),
('Hilton Downtown', 219, '2019-05-21', 287, NULL),
('Hilton Downtown', 219, '2019-05-22', 230, NULL),
('Hilton Downtown', 219, '2019-05-23', 381, NULL),
('Hilton Downtown', 219, '2019-05-24', 265, NULL),
('Hilton Downtown', 219, '2019-05-25', 322, NULL),
('Hilton Downtown', 219, '2019-05-26', 166, NULL),
('Hilton Downtown', 219, '2019-05-27', 171, NULL),
('Hilton Downtown', 219, '2019-05-28', 217, NULL),
('Hilton Downtown', 219, '2019-05-29', 127, NULL),
('Hilton Downtown', 219, '2019-05-30', 206, NULL),
('Hilton Downtown', 219, '2019-05-31', 147, NULL),
('Hilton Downtown', 219, '2019-06-01', 273, NULL),
('Hilton Downtown', 219, '2019-06-02', 264, NULL),
('Hilton Downtown', 219, '2019-06-03', 100, NULL),
('Hilton Downtown', 219, '2019-06-04', 226, NULL),
('Hilton Downtown', 219, '2019-06-05', 296, NULL),
('Hilton Downtown', 219, '2019-06-06', 385, NULL),
('Hilton Downtown', 219, '2019-06-07', 196, NULL),
('Hilton Downtown', 219, '2019-06-08', 358, NULL),
('Hilton Downtown', 219, '2019-06-09', 109, NULL),
('Hilton Downtown', 219, '2019-06-10', 178, NULL),
('Hilton Downtown', 219, '2019-06-11', 185, NULL),
('Hilton Downtown', 219, '2019-06-12', 125, NULL),
('Hilton Downtown', 219, '2019-06-13', 173, NULL),
('Hilton Downtown', 219, '2019-06-14', 116, NULL),
('Hilton Downtown', 219, '2019-06-15', 143, NULL),
('Hilton Downtown', 219, '2019-06-16', 197, NULL),
('Hilton Downtown', 219, '2019-06-17', 212, NULL),
('Hilton Downtown', 219, '2019-06-18', 108, NULL),
('Hilton Downtown', 219, '2019-06-19', 294, NULL),
('Hilton Downtown', 219, '2019-06-20', 255, NULL),
('Hilton Downtown', 219, '2019-06-21', 274, NULL),
('Hilton Downtown', 219, '2019-06-22', 276, NULL),
('Hilton Downtown', 219, '2019-06-23', 185, NULL),
('Hilton Downtown', 219, '2019-06-24', 134, NULL),
('Hilton Downtown', 219, '2019-06-25', 141, NULL),
('Hilton Downtown', 219, '2019-06-26', 211, NULL),
('Hilton Downtown', 219, '2019-06-27', 233, NULL),
('Hilton Downtown', 219, '2019-06-28', 117, NULL),
('Hilton Downtown', 219, '2019-06-29', 275, NULL),
('Hilton Downtown', 219, '2019-06-30', 164, NULL),
('Hilton Downtown', 219, '2019-07-01', 200, NULL),
('Hilton Downtown', 219, '2019-07-02', 278, NULL),
('Hilton Downtown', 219, '2019-07-03', 237, NULL),
('Hilton Downtown', 219, '2019-07-04', 367, NULL),
('Hilton Downtown', 219, '2019-07-05', 212, NULL),
('Hilton Downtown', 219, '2019-07-06', 228, NULL),
('Hilton Downtown', 219, '2019-07-07', 153, NULL),
('Hilton Downtown', 219, '2019-07-08', 387, NULL),
('Hilton Downtown', 219, '2019-07-09', 200, NULL),
('Hilton Downtown', 219, '2019-07-10', 201, NULL),
('Hilton Downtown', 219, '2019-07-11', 256, NULL),
('Hilton Downtown', 219, '2019-07-12', 244, NULL),
('Hilton Downtown', 219, '2019-07-13', 222, NULL),
('Hilton Downtown', 219, '2019-07-14', 395, NULL),
('Hilton Downtown', 219, '2019-07-15', 321, NULL),
('Hilton Downtown', 219, '2019-07-16', 120, NULL),
('Hilton Downtown', 219, '2019-07-17', 360, NULL),
('Hilton Downtown', 219, '2019-07-18', 381, NULL),
('Hilton Downtown', 219, '2019-07-19', 326, NULL),
('Hilton Downtown', 219, '2019-07-20', 362, NULL),
('Hilton Downtown', 219, '2019-07-21', 103, NULL),
('Hilton Downtown', 219, '2019-07-22', 350, NULL),
('Hilton Downtown', 219, '2019-07-23', 393, NULL),
('Hilton Downtown', 219, '2019-07-24', 126, NULL),
('Hilton Downtown', 219, '2019-07-25', 263, NULL),
('Hilton Downtown', 219, '2019-07-26', 185, NULL),
('Hilton Downtown', 219, '2019-07-27', 327, NULL),
('Hilton Downtown', 219, '2019-07-28', 189, NULL),
('Hilton Downtown', 219, '2019-07-29', 287, NULL),
('Hilton Downtown', 219, '2019-07-30', 346, NULL),
('Hilton Downtown', 219, '2019-07-31', 300, NULL),
('Hilton Downtown', 219, '2019-08-01', 112, NULL),
('Hilton Downtown', 219, '2019-08-02', 309, NULL),
('Hilton Downtown', 219, '2019-08-03', 119, NULL),
('Hilton Downtown', 219, '2019-08-04', 316, NULL),
('Hilton Downtown', 219, '2019-08-05', 189, NULL),
('Hilton Downtown', 219, '2019-08-06', 388, NULL),
('Hilton Downtown', 219, '2019-08-07', 248, NULL),
('Hilton Downtown', 219, '2019-08-08', 291, NULL),
('Hilton Downtown', 219, '2019-08-09', 188, NULL),
('Hilton Downtown', 219, '2019-08-10', 198, NULL),
('Hilton Downtown', 219, '2019-08-11', 257, NULL),
('Hilton Downtown', 219, '2019-08-12', 103, NULL),
('Hilton Downtown', 219, '2019-08-13', 151, NULL),
('Hilton Downtown', 219, '2019-08-14', 165, NULL),
('Hilton Downtown', 219, '2019-08-15', 155, NULL),
('Hilton Downtown', 219, '2019-08-16', 101, NULL),
('Hilton Downtown', 219, '2019-08-17', 313, NULL),
('Hilton Downtown', 219, '2019-08-18', 252, NULL),
('Hilton Downtown', 219, '2019-08-19', 115, NULL),
('Hilton Downtown', 219, '2019-08-20', 353, NULL),
('Hilton Downtown', 219, '2019-08-21', 262, NULL),
('Hilton Downtown', 219, '2019-08-22', 104, NULL),
('Hilton Downtown', 219, '2019-08-23', 140, NULL),
('Hilton Downtown', 219, '2019-08-24', 204, NULL),
('Hilton Downtown', 219, '2019-08-25', 180, NULL),
('Hilton Downtown', 219, '2019-08-26', 156, NULL),
('Hilton Downtown', 219, '2019-08-27', 169, NULL),
('Hilton Downtown', 219, '2019-08-28', 298, NULL),
('Hilton Downtown', 219, '2019-08-29', 248, NULL),
('Hilton Downtown', 219, '2019-08-30', 102, NULL),
('Hilton Downtown', 219, '2019-08-31', 315, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 219, '2019-09-01', 160, NULL),
('Hilton Downtown', 219, '2019-09-02', 355, NULL),
('Hilton Downtown', 219, '2019-09-03', 145, NULL),
('Hilton Downtown', 219, '2019-09-04', 365, NULL),
('Hilton Downtown', 219, '2019-09-05', 309, NULL),
('Hilton Downtown', 219, '2019-09-06', 381, NULL),
('Hilton Downtown', 219, '2019-09-07', 126, NULL),
('Hilton Downtown', 219, '2019-09-08', 276, NULL),
('Hilton Downtown', 219, '2019-09-09', 187, NULL),
('Hilton Downtown', 219, '2019-09-10', 300, NULL),
('Hilton Downtown', 219, '2019-09-11', 277, NULL),
('Hilton Downtown', 219, '2019-09-12', 208, NULL),
('Hilton Downtown', 219, '2019-09-13', 292, NULL),
('Hilton Downtown', 219, '2019-09-14', 187, NULL),
('Hilton Downtown', 219, '2019-09-15', 176, NULL),
('Hilton Downtown', 219, '2019-09-16', 309, NULL),
('Hilton Downtown', 219, '2019-09-17', 214, NULL),
('Hilton Downtown', 219, '2019-09-18', 174, NULL),
('Hilton Downtown', 219, '2019-09-19', 381, NULL),
('Hilton Downtown', 219, '2019-09-20', 245, NULL),
('Hilton Downtown', 219, '2019-09-21', 285, NULL),
('Hilton Downtown', 219, '2019-09-22', 114, NULL),
('Hilton Downtown', 219, '2019-09-23', 116, NULL),
('Hilton Downtown', 219, '2019-09-24', 198, NULL),
('Hilton Downtown', 219, '2019-09-25', 159, NULL),
('Hilton Downtown', 219, '2019-09-26', 375, NULL),
('Hilton Downtown', 219, '2019-09-27', 288, NULL),
('Hilton Downtown', 219, '2019-09-28', 188, NULL),
('Hilton Downtown', 219, '2019-09-29', 230, NULL),
('Hilton Downtown', 219, '2019-09-30', 338, NULL),
('Hilton Downtown', 219, '2019-10-01', 301, NULL),
('Hilton Downtown', 219, '2019-10-02', 201, NULL),
('Hilton Downtown', 219, '2019-10-03', 115, NULL),
('Hilton Downtown', 219, '2019-10-04', 382, NULL),
('Hilton Downtown', 219, '2019-10-05', 319, NULL),
('Hilton Downtown', 219, '2019-10-06', 108, NULL),
('Hilton Downtown', 219, '2019-10-07', 211, NULL),
('Hilton Downtown', 219, '2019-10-08', 286, NULL),
('Hilton Downtown', 219, '2019-10-09', 143, NULL),
('Hilton Downtown', 219, '2019-10-10', 276, NULL),
('Hilton Downtown', 219, '2019-10-11', 256, NULL),
('Hilton Downtown', 219, '2019-10-12', 293, NULL),
('Hilton Downtown', 219, '2019-10-13', 250, NULL),
('Hilton Downtown', 219, '2019-10-14', 257, NULL),
('Hilton Downtown', 219, '2019-10-15', 234, NULL),
('Hilton Downtown', 219, '2019-10-16', 367, NULL),
('Hilton Downtown', 219, '2019-10-17', 395, NULL),
('Hilton Downtown', 219, '2019-10-18', 229, NULL),
('Hilton Downtown', 219, '2019-10-19', 372, NULL),
('Hilton Downtown', 219, '2019-10-20', 192, NULL),
('Hilton Downtown', 219, '2019-10-21', 295, NULL),
('Hilton Downtown', 219, '2019-10-22', 251, NULL),
('Hilton Downtown', 219, '2019-10-23', 206, NULL),
('Hilton Downtown', 219, '2019-10-24', 200, NULL),
('Hilton Downtown', 219, '2019-10-25', 190, NULL),
('Hilton Downtown', 219, '2019-10-26', 272, NULL),
('Hilton Downtown', 219, '2019-10-27', 399, NULL),
('Hilton Downtown', 219, '2019-10-28', 275, NULL),
('Hilton Downtown', 219, '2019-10-29', 264, NULL),
('Hilton Downtown', 219, '2019-10-30', 212, NULL),
('Hilton Downtown', 219, '2019-10-31', 215, NULL),
('Hilton Downtown', 219, '2019-11-01', 396, NULL),
('Hilton Downtown', 219, '2019-11-02', 243, NULL),
('Hilton Downtown', 219, '2019-11-03', 324, NULL),
('Hilton Downtown', 219, '2019-11-04', 157, NULL),
('Hilton Downtown', 219, '2019-11-05', 186, NULL),
('Hilton Downtown', 219, '2019-11-06', 260, NULL),
('Hilton Downtown', 219, '2019-11-07', 148, NULL),
('Hilton Downtown', 219, '2019-11-08', 328, NULL),
('Hilton Downtown', 219, '2019-11-09', 283, NULL),
('Hilton Downtown', 219, '2019-11-10', 243, NULL),
('Hilton Downtown', 219, '2019-11-11', 286, NULL),
('Hilton Downtown', 219, '2019-11-12', 305, NULL),
('Hilton Downtown', 219, '2019-11-13', 351, NULL),
('Hilton Downtown', 219, '2019-11-14', 273, NULL),
('Hilton Downtown', 219, '2019-11-15', 307, NULL),
('Hilton Downtown', 219, '2019-11-16', 345, NULL),
('Hilton Downtown', 219, '2019-11-17', 131, NULL),
('Hilton Downtown', 219, '2019-11-18', 154, NULL),
('Hilton Downtown', 219, '2019-11-19', 267, NULL),
('Hilton Downtown', 219, '2019-11-20', 164, NULL),
('Hilton Downtown', 219, '2019-11-21', 238, NULL),
('Hilton Downtown', 219, '2019-11-22', 267, NULL),
('Hilton Downtown', 219, '2019-11-23', 132, NULL),
('Hilton Downtown', 219, '2019-11-24', 157, NULL),
('Hilton Downtown', 219, '2019-11-25', 237, NULL),
('Hilton Downtown', 219, '2019-11-26', 266, NULL),
('Hilton Downtown', 219, '2019-11-27', 134, NULL),
('Hilton Downtown', 219, '2019-11-28', 265, NULL),
('Hilton Downtown', 219, '2019-11-29', 141, NULL),
('Hilton Downtown', 219, '2019-11-30', 354, NULL),
('Hilton Downtown', 219, '2019-12-01', 390, NULL),
('Hilton Downtown', 219, '2019-12-02', 262, NULL),
('Hilton Downtown', 219, '2019-12-03', 285, NULL),
('Hilton Downtown', 219, '2019-12-04', 337, NULL),
('Hilton Downtown', 219, '2019-12-05', 329, NULL),
('Hilton Downtown', 219, '2019-12-06', 155, NULL),
('Hilton Downtown', 219, '2019-12-07', 263, NULL),
('Hilton Downtown', 219, '2019-12-08', 328, NULL),
('Hilton Downtown', 219, '2019-12-09', 240, NULL),
('Hilton Downtown', 219, '2019-12-10', 257, NULL),
('Hilton Downtown', 219, '2019-12-11', 103, NULL),
('Hilton Downtown', 219, '2019-12-12', 218, NULL),
('Hilton Downtown', 219, '2019-12-13', 205, NULL),
('Hilton Downtown', 219, '2019-12-14', 338, NULL),
('Hilton Downtown', 219, '2019-12-15', 369, NULL),
('Hilton Downtown', 219, '2019-12-16', 110, NULL),
('Hilton Downtown', 219, '2019-12-17', 312, NULL),
('Hilton Downtown', 219, '2019-12-18', 377, NULL),
('Hilton Downtown', 219, '2019-12-19', 316, NULL),
('Hilton Downtown', 219, '2019-12-20', 374, NULL),
('Hilton Downtown', 219, '2019-12-21', 140, NULL),
('Hilton Downtown', 219, '2019-12-22', 361, NULL),
('Hilton Downtown', 219, '2019-12-23', 284, NULL),
('Hilton Downtown', 219, '2019-12-24', 382, NULL),
('Hilton Downtown', 219, '2019-12-25', 168, NULL),
('Hilton Downtown', 219, '2019-12-26', 126, NULL),
('Hilton Downtown', 219, '2019-12-27', 201, NULL),
('Hilton Downtown', 219, '2019-12-28', 395, NULL),
('Hilton Downtown', 219, '2019-12-29', 380, NULL),
('Hilton Downtown', 219, '2019-12-30', 383, NULL),
('Hilton Downtown', 219, '2019-12-31', 381, NULL),
('Hilton Downtown', 219, '2020-01-01', 196, NULL),
('Hilton Downtown', 219, '2020-01-02', 195, NULL),
('Hilton Downtown', 219, '2020-01-03', 246, NULL),
('Hilton Downtown', 219, '2020-01-04', 272, NULL),
('Hilton Downtown', 219, '2020-01-05', 263, NULL),
('Hilton Downtown', 219, '2020-01-06', 138, NULL),
('Hilton Downtown', 219, '2020-01-07', 307, NULL),
('Hilton Downtown', 219, '2020-01-08', 267, NULL),
('Hilton Downtown', 219, '2020-01-09', 267, NULL),
('Hilton Downtown', 219, '2020-01-10', 246, NULL),
('Hilton Downtown', 219, '2020-01-11', 111, NULL),
('Hilton Downtown', 219, '2020-01-12', 253, NULL),
('Hilton Downtown', 219, '2020-01-13', 368, NULL),
('Hilton Downtown', 219, '2020-01-14', 291, NULL),
('Hilton Downtown', 219, '2020-01-15', 196, NULL),
('Hilton Downtown', 219, '2020-01-16', 261, NULL),
('Hilton Downtown', 219, '2020-01-17', 210, NULL),
('Hilton Downtown', 219, '2020-01-18', 127, NULL),
('Hilton Downtown', 219, '2020-01-19', 355, NULL),
('Hilton Downtown', 219, '2020-01-20', 338, NULL),
('Hilton Downtown', 219, '2020-01-21', 297, NULL),
('Hilton Downtown', 219, '2020-01-22', 323, NULL),
('Hilton Downtown', 219, '2020-01-23', 272, NULL),
('Hilton Downtown', 219, '2020-01-24', 192, NULL),
('Hilton Downtown', 219, '2020-01-25', 209, NULL),
('Hilton Downtown', 219, '2020-01-26', 306, NULL),
('Hilton Downtown', 219, '2020-01-27', 152, NULL),
('Hilton Downtown', 219, '2020-01-28', 185, NULL),
('Hilton Downtown', 219, '2020-01-29', 207, NULL),
('Hilton Downtown', 219, '2020-01-30', 260, NULL),
('Hilton Downtown', 219, '2020-01-31', 219, NULL),
('Hilton Downtown', 219, '2020-02-01', 154, NULL),
('Hilton Downtown', 219, '2020-02-02', 109, NULL),
('Hilton Downtown', 219, '2020-02-03', 165, NULL),
('Hilton Downtown', 219, '2020-02-04', 173, NULL),
('Hilton Downtown', 225, '2019-01-01', 239, NULL),
('Hilton Downtown', 225, '2019-01-02', 100, NULL),
('Hilton Downtown', 225, '2019-01-03', 232, NULL),
('Hilton Downtown', 225, '2019-01-04', 162, NULL),
('Hilton Downtown', 225, '2019-01-05', 395, NULL),
('Hilton Downtown', 225, '2019-01-06', 364, NULL),
('Hilton Downtown', 225, '2019-01-07', 100, NULL),
('Hilton Downtown', 225, '2019-01-08', 272, NULL),
('Hilton Downtown', 225, '2019-01-09', 132, NULL),
('Hilton Downtown', 225, '2019-01-10', 295, NULL),
('Hilton Downtown', 225, '2019-01-11', 324, NULL),
('Hilton Downtown', 225, '2019-01-12', 357, NULL),
('Hilton Downtown', 225, '2019-01-13', 142, NULL),
('Hilton Downtown', 225, '2019-01-14', 138, NULL),
('Hilton Downtown', 225, '2019-01-15', 347, NULL),
('Hilton Downtown', 225, '2019-01-16', 178, NULL),
('Hilton Downtown', 225, '2019-01-17', 297, NULL),
('Hilton Downtown', 225, '2019-01-18', 231, NULL),
('Hilton Downtown', 225, '2019-01-19', 326, NULL),
('Hilton Downtown', 225, '2019-01-20', 277, NULL),
('Hilton Downtown', 225, '2019-01-21', 102, NULL),
('Hilton Downtown', 225, '2019-01-22', 241, NULL),
('Hilton Downtown', 225, '2019-01-23', 116, NULL),
('Hilton Downtown', 225, '2019-01-24', 311, NULL),
('Hilton Downtown', 225, '2019-01-25', 288, NULL),
('Hilton Downtown', 225, '2019-01-26', 257, NULL),
('Hilton Downtown', 225, '2019-01-27', 361, NULL),
('Hilton Downtown', 225, '2019-01-28', 139, NULL),
('Hilton Downtown', 225, '2019-01-29', 126, NULL),
('Hilton Downtown', 225, '2019-01-30', 329, NULL),
('Hilton Downtown', 225, '2019-01-31', 271, NULL),
('Hilton Downtown', 225, '2019-02-01', 324, NULL),
('Hilton Downtown', 225, '2019-02-02', 373, NULL),
('Hilton Downtown', 225, '2019-02-03', 325, NULL),
('Hilton Downtown', 225, '2019-02-04', 317, NULL),
('Hilton Downtown', 225, '2019-02-05', 117, NULL),
('Hilton Downtown', 225, '2019-02-06', 242, NULL),
('Hilton Downtown', 225, '2019-02-07', 278, NULL),
('Hilton Downtown', 225, '2019-02-08', 107, NULL),
('Hilton Downtown', 225, '2019-02-09', 372, NULL),
('Hilton Downtown', 225, '2019-02-10', 374, NULL),
('Hilton Downtown', 225, '2019-02-11', 155, NULL),
('Hilton Downtown', 225, '2019-02-12', 231, NULL),
('Hilton Downtown', 225, '2019-02-13', 191, NULL),
('Hilton Downtown', 225, '2019-02-14', 279, NULL),
('Hilton Downtown', 225, '2019-02-15', 230, NULL),
('Hilton Downtown', 225, '2019-02-16', 321, NULL),
('Hilton Downtown', 225, '2019-02-17', 396, NULL),
('Hilton Downtown', 225, '2019-02-18', 110, NULL),
('Hilton Downtown', 225, '2019-02-19', 375, NULL),
('Hilton Downtown', 225, '2019-02-20', 364, NULL),
('Hilton Downtown', 225, '2019-02-21', 244, NULL),
('Hilton Downtown', 225, '2019-02-22', 304, NULL),
('Hilton Downtown', 225, '2019-02-23', 315, NULL),
('Hilton Downtown', 225, '2019-02-24', 199, NULL),
('Hilton Downtown', 225, '2019-02-25', 347, NULL),
('Hilton Downtown', 225, '2019-02-26', 275, NULL),
('Hilton Downtown', 225, '2019-02-27', 186, NULL),
('Hilton Downtown', 225, '2019-02-28', 306, NULL),
('Hilton Downtown', 225, '2019-03-01', 342, NULL),
('Hilton Downtown', 225, '2019-03-02', 175, NULL),
('Hilton Downtown', 225, '2019-03-03', 191, NULL),
('Hilton Downtown', 225, '2019-03-04', 334, NULL),
('Hilton Downtown', 225, '2019-03-05', 395, NULL),
('Hilton Downtown', 225, '2019-03-06', 148, NULL),
('Hilton Downtown', 225, '2019-03-07', 282, NULL),
('Hilton Downtown', 225, '2019-03-08', 342, NULL),
('Hilton Downtown', 225, '2019-03-09', 106, NULL),
('Hilton Downtown', 225, '2019-03-10', 150, NULL),
('Hilton Downtown', 225, '2019-03-11', 175, NULL),
('Hilton Downtown', 225, '2019-03-12', 112, NULL),
('Hilton Downtown', 225, '2019-03-13', 173, NULL),
('Hilton Downtown', 225, '2019-03-14', 218, NULL),
('Hilton Downtown', 225, '2019-03-15', 312, NULL),
('Hilton Downtown', 225, '2019-03-16', 289, NULL),
('Hilton Downtown', 225, '2019-03-17', 301, NULL),
('Hilton Downtown', 225, '2019-03-18', 261, NULL),
('Hilton Downtown', 225, '2019-03-19', 315, NULL),
('Hilton Downtown', 225, '2019-03-20', 231, NULL),
('Hilton Downtown', 225, '2019-03-21', 388, NULL),
('Hilton Downtown', 225, '2019-03-22', 280, NULL),
('Hilton Downtown', 225, '2019-03-23', 227, NULL),
('Hilton Downtown', 225, '2019-03-24', 362, NULL),
('Hilton Downtown', 225, '2019-03-25', 258, NULL),
('Hilton Downtown', 225, '2019-03-26', 306, NULL),
('Hilton Downtown', 225, '2019-03-27', 254, NULL),
('Hilton Downtown', 225, '2019-03-28', 209, NULL),
('Hilton Downtown', 225, '2019-03-29', 355, NULL),
('Hilton Downtown', 225, '2019-03-30', 379, NULL),
('Hilton Downtown', 225, '2019-03-31', 275, NULL),
('Hilton Downtown', 225, '2019-04-01', 111, NULL),
('Hilton Downtown', 225, '2019-04-02', 251, NULL),
('Hilton Downtown', 225, '2019-04-03', 187, NULL),
('Hilton Downtown', 225, '2019-04-04', 216, NULL),
('Hilton Downtown', 225, '2019-04-05', 171, NULL),
('Hilton Downtown', 225, '2019-04-06', 110, NULL),
('Hilton Downtown', 225, '2019-04-07', 228, NULL),
('Hilton Downtown', 225, '2019-04-08', 369, NULL),
('Hilton Downtown', 225, '2019-04-09', 247, NULL),
('Hilton Downtown', 225, '2019-04-10', 328, NULL),
('Hilton Downtown', 225, '2019-04-11', 101, NULL),
('Hilton Downtown', 225, '2019-04-12', 135, NULL),
('Hilton Downtown', 225, '2019-04-13', 297, NULL),
('Hilton Downtown', 225, '2019-04-14', 211, NULL),
('Hilton Downtown', 225, '2019-04-15', 318, NULL),
('Hilton Downtown', 225, '2019-04-16', 330, NULL),
('Hilton Downtown', 225, '2019-04-17', 337, NULL),
('Hilton Downtown', 225, '2019-04-18', 385, NULL),
('Hilton Downtown', 225, '2019-04-19', 257, NULL),
('Hilton Downtown', 225, '2019-04-20', 267, NULL),
('Hilton Downtown', 225, '2019-04-21', 349, NULL),
('Hilton Downtown', 225, '2019-04-22', 240, NULL),
('Hilton Downtown', 225, '2019-04-23', 243, NULL),
('Hilton Downtown', 225, '2019-04-24', 326, NULL),
('Hilton Downtown', 225, '2019-04-25', 297, NULL),
('Hilton Downtown', 225, '2019-04-26', 322, NULL),
('Hilton Downtown', 225, '2019-04-27', 357, NULL),
('Hilton Downtown', 225, '2019-04-28', 322, NULL),
('Hilton Downtown', 225, '2019-04-29', 356, NULL),
('Hilton Downtown', 225, '2019-04-30', 311, NULL),
('Hilton Downtown', 225, '2019-05-01', 202, NULL),
('Hilton Downtown', 225, '2019-05-02', 266, NULL),
('Hilton Downtown', 225, '2019-05-03', 174, NULL),
('Hilton Downtown', 225, '2019-05-04', 132, NULL),
('Hilton Downtown', 225, '2019-05-05', 328, NULL),
('Hilton Downtown', 225, '2019-05-06', 103, NULL),
('Hilton Downtown', 225, '2019-05-07', 194, NULL),
('Hilton Downtown', 225, '2019-05-08', 103, NULL),
('Hilton Downtown', 225, '2019-05-09', 329, NULL),
('Hilton Downtown', 225, '2019-05-10', 336, NULL),
('Hilton Downtown', 225, '2019-05-11', 183, NULL),
('Hilton Downtown', 225, '2019-05-12', 368, NULL),
('Hilton Downtown', 225, '2019-05-13', 192, NULL),
('Hilton Downtown', 225, '2019-05-14', 161, NULL),
('Hilton Downtown', 225, '2019-05-15', 315, NULL),
('Hilton Downtown', 225, '2019-05-16', 361, NULL),
('Hilton Downtown', 225, '2019-05-17', 337, NULL),
('Hilton Downtown', 225, '2019-05-18', 163, NULL),
('Hilton Downtown', 225, '2019-05-19', 332, NULL),
('Hilton Downtown', 225, '2019-05-20', 287, NULL),
('Hilton Downtown', 225, '2019-05-21', 241, NULL),
('Hilton Downtown', 225, '2019-05-22', 144, NULL),
('Hilton Downtown', 225, '2019-05-23', 276, NULL),
('Hilton Downtown', 225, '2019-05-24', 186, NULL),
('Hilton Downtown', 225, '2019-05-25', 335, NULL),
('Hilton Downtown', 225, '2019-05-26', 193, NULL),
('Hilton Downtown', 225, '2019-05-27', 296, NULL),
('Hilton Downtown', 225, '2019-05-28', 149, NULL),
('Hilton Downtown', 225, '2019-05-29', 286, NULL),
('Hilton Downtown', 225, '2019-05-30', 215, NULL),
('Hilton Downtown', 225, '2019-05-31', 310, NULL),
('Hilton Downtown', 225, '2019-06-01', 340, NULL),
('Hilton Downtown', 225, '2019-06-02', 117, NULL),
('Hilton Downtown', 225, '2019-06-03', 373, NULL),
('Hilton Downtown', 225, '2019-06-04', 277, NULL),
('Hilton Downtown', 225, '2019-06-05', 196, NULL),
('Hilton Downtown', 225, '2019-06-06', 197, NULL),
('Hilton Downtown', 225, '2019-06-07', 223, NULL),
('Hilton Downtown', 225, '2019-06-08', 361, NULL),
('Hilton Downtown', 225, '2019-06-09', 250, NULL),
('Hilton Downtown', 225, '2019-06-10', 316, NULL),
('Hilton Downtown', 225, '2019-06-11', 287, NULL),
('Hilton Downtown', 225, '2019-06-12', 174, NULL),
('Hilton Downtown', 225, '2019-06-13', 112, NULL),
('Hilton Downtown', 225, '2019-06-14', 342, NULL),
('Hilton Downtown', 225, '2019-06-15', 142, NULL),
('Hilton Downtown', 225, '2019-06-16', 167, NULL),
('Hilton Downtown', 225, '2019-06-17', 105, NULL),
('Hilton Downtown', 225, '2019-06-18', 131, NULL),
('Hilton Downtown', 225, '2019-06-19', 368, NULL),
('Hilton Downtown', 225, '2019-06-20', 373, NULL),
('Hilton Downtown', 225, '2019-06-21', 298, NULL),
('Hilton Downtown', 225, '2019-06-22', 198, NULL),
('Hilton Downtown', 225, '2019-06-23', 357, NULL),
('Hilton Downtown', 225, '2019-06-24', 264, NULL),
('Hilton Downtown', 225, '2019-06-25', 279, NULL),
('Hilton Downtown', 225, '2019-06-26', 347, NULL),
('Hilton Downtown', 225, '2019-06-27', 169, NULL),
('Hilton Downtown', 225, '2019-06-28', 270, NULL),
('Hilton Downtown', 225, '2019-06-29', 128, NULL),
('Hilton Downtown', 225, '2019-06-30', 196, NULL),
('Hilton Downtown', 225, '2019-07-01', 322, NULL),
('Hilton Downtown', 225, '2019-07-02', 280, NULL),
('Hilton Downtown', 225, '2019-07-03', 299, NULL),
('Hilton Downtown', 225, '2019-07-04', 238, NULL),
('Hilton Downtown', 225, '2019-07-05', 197, NULL),
('Hilton Downtown', 225, '2019-07-06', 151, NULL),
('Hilton Downtown', 225, '2019-07-07', 115, NULL),
('Hilton Downtown', 225, '2019-07-08', 374, NULL),
('Hilton Downtown', 225, '2019-07-09', 180, NULL),
('Hilton Downtown', 225, '2019-07-10', 353, NULL),
('Hilton Downtown', 225, '2019-07-11', 376, NULL),
('Hilton Downtown', 225, '2019-07-12', 156, NULL),
('Hilton Downtown', 225, '2019-07-13', 340, NULL),
('Hilton Downtown', 225, '2019-07-14', 234, NULL),
('Hilton Downtown', 225, '2019-07-15', 250, NULL),
('Hilton Downtown', 225, '2019-07-16', 282, NULL),
('Hilton Downtown', 225, '2019-07-17', 330, NULL),
('Hilton Downtown', 225, '2019-07-18', 213, NULL),
('Hilton Downtown', 225, '2019-07-19', 271, NULL),
('Hilton Downtown', 225, '2019-07-20', 214, NULL),
('Hilton Downtown', 225, '2019-07-21', 182, NULL),
('Hilton Downtown', 225, '2019-07-22', 342, NULL),
('Hilton Downtown', 225, '2019-07-23', 397, NULL),
('Hilton Downtown', 225, '2019-07-24', 310, NULL),
('Hilton Downtown', 225, '2019-07-25', 352, NULL),
('Hilton Downtown', 225, '2019-07-26', 249, NULL),
('Hilton Downtown', 225, '2019-07-27', 273, NULL),
('Hilton Downtown', 225, '2019-07-28', 219, NULL),
('Hilton Downtown', 225, '2019-07-29', 368, NULL),
('Hilton Downtown', 225, '2019-07-30', 210, NULL),
('Hilton Downtown', 225, '2019-07-31', 357, NULL),
('Hilton Downtown', 225, '2019-08-01', 330, NULL),
('Hilton Downtown', 225, '2019-08-02', 219, NULL),
('Hilton Downtown', 225, '2019-08-03', 240, NULL),
('Hilton Downtown', 225, '2019-08-04', 289, NULL),
('Hilton Downtown', 225, '2019-08-05', 246, NULL),
('Hilton Downtown', 225, '2019-08-06', 175, NULL),
('Hilton Downtown', 225, '2019-08-07', 368, NULL),
('Hilton Downtown', 225, '2019-08-08', 175, NULL),
('Hilton Downtown', 225, '2019-08-09', 279, NULL),
('Hilton Downtown', 225, '2019-08-10', 345, NULL),
('Hilton Downtown', 225, '2019-08-11', 227, NULL),
('Hilton Downtown', 225, '2019-08-12', 310, NULL),
('Hilton Downtown', 225, '2019-08-13', 287, NULL),
('Hilton Downtown', 225, '2019-08-14', 209, NULL),
('Hilton Downtown', 225, '2019-08-15', 273, NULL),
('Hilton Downtown', 225, '2019-08-16', 397, NULL),
('Hilton Downtown', 225, '2019-08-17', 311, NULL),
('Hilton Downtown', 225, '2019-08-18', 307, NULL),
('Hilton Downtown', 225, '2019-08-19', 171, NULL),
('Hilton Downtown', 225, '2019-08-20', 397, NULL),
('Hilton Downtown', 225, '2019-08-21', 167, NULL),
('Hilton Downtown', 225, '2019-08-22', 215, NULL),
('Hilton Downtown', 225, '2019-08-23', 244, NULL),
('Hilton Downtown', 225, '2019-08-24', 108, NULL),
('Hilton Downtown', 225, '2019-08-25', 189, NULL),
('Hilton Downtown', 225, '2019-08-26', 117, NULL),
('Hilton Downtown', 225, '2019-08-27', 342, NULL),
('Hilton Downtown', 225, '2019-08-28', 152, NULL),
('Hilton Downtown', 225, '2019-08-29', 383, NULL),
('Hilton Downtown', 225, '2019-08-30', 175, NULL),
('Hilton Downtown', 225, '2019-08-31', 103, NULL),
('Hilton Downtown', 225, '2019-09-01', 206, NULL),
('Hilton Downtown', 225, '2019-09-02', 152, NULL),
('Hilton Downtown', 225, '2019-09-03', 333, NULL),
('Hilton Downtown', 225, '2019-09-04', 298, NULL),
('Hilton Downtown', 225, '2019-09-05', 179, NULL),
('Hilton Downtown', 225, '2019-09-06', 151, NULL),
('Hilton Downtown', 225, '2019-09-07', 133, NULL),
('Hilton Downtown', 225, '2019-09-08', 330, NULL),
('Hilton Downtown', 225, '2019-09-09', 164, NULL),
('Hilton Downtown', 225, '2019-09-10', 144, NULL),
('Hilton Downtown', 225, '2019-09-11', 163, NULL),
('Hilton Downtown', 225, '2019-09-12', 169, NULL),
('Hilton Downtown', 225, '2019-09-13', 110, NULL),
('Hilton Downtown', 225, '2019-09-14', 175, NULL),
('Hilton Downtown', 225, '2019-09-15', 213, NULL),
('Hilton Downtown', 225, '2019-09-16', 234, NULL),
('Hilton Downtown', 225, '2019-09-17', 363, NULL),
('Hilton Downtown', 225, '2019-09-18', 125, NULL),
('Hilton Downtown', 225, '2019-09-19', 158, NULL),
('Hilton Downtown', 225, '2019-09-20', 272, NULL),
('Hilton Downtown', 225, '2019-09-21', 233, NULL),
('Hilton Downtown', 225, '2019-09-22', 371, NULL),
('Hilton Downtown', 225, '2019-09-23', 240, NULL),
('Hilton Downtown', 225, '2019-09-24', 126, NULL),
('Hilton Downtown', 225, '2019-09-25', 278, NULL),
('Hilton Downtown', 225, '2019-09-26', 252, NULL),
('Hilton Downtown', 225, '2019-09-27', 212, NULL),
('Hilton Downtown', 225, '2019-09-28', 239, NULL),
('Hilton Downtown', 225, '2019-09-29', 361, NULL),
('Hilton Downtown', 225, '2019-09-30', 287, NULL),
('Hilton Downtown', 225, '2019-10-01', 338, NULL),
('Hilton Downtown', 225, '2019-10-02', 388, NULL),
('Hilton Downtown', 225, '2019-10-03', 167, NULL),
('Hilton Downtown', 225, '2019-10-04', 108, NULL),
('Hilton Downtown', 225, '2019-10-05', 286, NULL),
('Hilton Downtown', 225, '2019-10-06', 286, NULL),
('Hilton Downtown', 225, '2019-10-07', 259, NULL),
('Hilton Downtown', 225, '2019-10-08', 275, NULL),
('Hilton Downtown', 225, '2019-10-09', 202, NULL),
('Hilton Downtown', 225, '2019-10-10', 256, NULL),
('Hilton Downtown', 225, '2019-10-11', 317, NULL),
('Hilton Downtown', 225, '2019-10-12', 349, NULL),
('Hilton Downtown', 225, '2019-10-13', 187, NULL),
('Hilton Downtown', 225, '2019-10-14', 362, NULL),
('Hilton Downtown', 225, '2019-10-15', 367, NULL),
('Hilton Downtown', 225, '2019-10-16', 396, NULL),
('Hilton Downtown', 225, '2019-10-17', 322, NULL),
('Hilton Downtown', 225, '2019-10-18', 314, NULL),
('Hilton Downtown', 225, '2019-10-19', 383, NULL),
('Hilton Downtown', 225, '2019-10-20', 222, NULL),
('Hilton Downtown', 225, '2019-10-21', 204, NULL),
('Hilton Downtown', 225, '2019-10-22', 354, NULL),
('Hilton Downtown', 225, '2019-10-23', 242, NULL),
('Hilton Downtown', 225, '2019-10-24', 248, NULL),
('Hilton Downtown', 225, '2019-10-25', 320, NULL),
('Hilton Downtown', 225, '2019-10-26', 160, NULL),
('Hilton Downtown', 225, '2019-10-27', 268, NULL),
('Hilton Downtown', 225, '2019-10-28', 371, NULL),
('Hilton Downtown', 225, '2019-10-29', 219, NULL),
('Hilton Downtown', 225, '2019-10-30', 294, NULL),
('Hilton Downtown', 225, '2019-10-31', 224, NULL),
('Hilton Downtown', 225, '2019-11-01', 217, NULL),
('Hilton Downtown', 225, '2019-11-02', 270, NULL),
('Hilton Downtown', 225, '2019-11-03', 232, NULL),
('Hilton Downtown', 225, '2019-11-04', 337, NULL),
('Hilton Downtown', 225, '2019-11-05', 305, NULL),
('Hilton Downtown', 225, '2019-11-06', 314, NULL),
('Hilton Downtown', 225, '2019-11-07', 169, NULL),
('Hilton Downtown', 225, '2019-11-08', 286, NULL),
('Hilton Downtown', 225, '2019-11-09', 211, NULL),
('Hilton Downtown', 225, '2019-11-10', 199, NULL),
('Hilton Downtown', 225, '2019-11-11', 220, NULL),
('Hilton Downtown', 225, '2019-11-12', 258, NULL),
('Hilton Downtown', 225, '2019-11-13', 351, NULL),
('Hilton Downtown', 225, '2019-11-14', 310, NULL),
('Hilton Downtown', 225, '2019-11-15', 183, NULL),
('Hilton Downtown', 225, '2019-11-16', 232, NULL),
('Hilton Downtown', 225, '2019-11-17', 168, NULL),
('Hilton Downtown', 225, '2019-11-18', 124, NULL),
('Hilton Downtown', 225, '2019-11-19', 346, NULL),
('Hilton Downtown', 225, '2019-11-20', 101, NULL),
('Hilton Downtown', 225, '2019-11-21', 172, NULL),
('Hilton Downtown', 225, '2019-11-22', 145, NULL),
('Hilton Downtown', 225, '2019-11-23', 269, NULL),
('Hilton Downtown', 225, '2019-11-24', 252, NULL),
('Hilton Downtown', 225, '2019-11-25', 287, NULL),
('Hilton Downtown', 225, '2019-11-26', 364, NULL),
('Hilton Downtown', 225, '2019-11-27', 323, NULL),
('Hilton Downtown', 225, '2019-11-28', 291, NULL),
('Hilton Downtown', 225, '2019-11-29', 205, NULL),
('Hilton Downtown', 225, '2019-11-30', 368, NULL),
('Hilton Downtown', 225, '2019-12-01', 102, NULL),
('Hilton Downtown', 225, '2019-12-02', 255, NULL),
('Hilton Downtown', 225, '2019-12-03', 301, NULL),
('Hilton Downtown', 225, '2019-12-04', 369, NULL),
('Hilton Downtown', 225, '2019-12-05', 345, NULL),
('Hilton Downtown', 225, '2019-12-06', 349, NULL),
('Hilton Downtown', 225, '2019-12-07', 355, NULL),
('Hilton Downtown', 225, '2019-12-08', 110, NULL),
('Hilton Downtown', 225, '2019-12-09', 181, NULL),
('Hilton Downtown', 225, '2019-12-10', 392, NULL),
('Hilton Downtown', 225, '2019-12-11', 363, NULL),
('Hilton Downtown', 225, '2019-12-12', 326, NULL),
('Hilton Downtown', 225, '2019-12-13', 221, NULL),
('Hilton Downtown', 225, '2019-12-14', 256, NULL),
('Hilton Downtown', 225, '2019-12-15', 325, NULL),
('Hilton Downtown', 225, '2019-12-16', 323, NULL),
('Hilton Downtown', 225, '2019-12-17', 181, NULL),
('Hilton Downtown', 225, '2019-12-18', 126, NULL),
('Hilton Downtown', 225, '2019-12-19', 338, NULL),
('Hilton Downtown', 225, '2019-12-20', 149, NULL),
('Hilton Downtown', 225, '2019-12-21', 136, NULL),
('Hilton Downtown', 225, '2019-12-22', 230, NULL),
('Hilton Downtown', 225, '2019-12-23', 374, NULL),
('Hilton Downtown', 225, '2019-12-24', 207, NULL),
('Hilton Downtown', 225, '2019-12-25', 119, NULL),
('Hilton Downtown', 225, '2019-12-26', 195, NULL),
('Hilton Downtown', 225, '2019-12-27', 129, NULL),
('Hilton Downtown', 225, '2019-12-28', 179, NULL),
('Hilton Downtown', 225, '2019-12-29', 124, NULL),
('Hilton Downtown', 225, '2019-12-30', 276, NULL),
('Hilton Downtown', 225, '2019-12-31', 327, NULL),
('Hilton Downtown', 225, '2020-01-01', 103, NULL),
('Hilton Downtown', 225, '2020-01-02', 377, NULL),
('Hilton Downtown', 225, '2020-01-03', 261, NULL),
('Hilton Downtown', 225, '2020-01-04', 210, NULL),
('Hilton Downtown', 225, '2020-01-05', 302, NULL),
('Hilton Downtown', 225, '2020-01-06', 149, NULL),
('Hilton Downtown', 225, '2020-01-07', 153, NULL),
('Hilton Downtown', 225, '2020-01-08', 204, NULL),
('Hilton Downtown', 225, '2020-01-09', 270, NULL),
('Hilton Downtown', 225, '2020-01-10', 336, NULL),
('Hilton Downtown', 225, '2020-01-11', 343, NULL),
('Hilton Downtown', 225, '2020-01-12', 252, NULL),
('Hilton Downtown', 225, '2020-01-13', 126, NULL),
('Hilton Downtown', 225, '2020-01-14', 132, NULL),
('Hilton Downtown', 225, '2020-01-15', 165, NULL),
('Hilton Downtown', 225, '2020-01-16', 193, NULL),
('Hilton Downtown', 225, '2020-01-17', 317, NULL),
('Hilton Downtown', 225, '2020-01-18', 367, NULL),
('Hilton Downtown', 225, '2020-01-19', 268, NULL),
('Hilton Downtown', 225, '2020-01-20', 240, NULL),
('Hilton Downtown', 225, '2020-01-21', 170, NULL),
('Hilton Downtown', 225, '2020-01-22', 312, NULL),
('Hilton Downtown', 225, '2020-01-23', 368, NULL),
('Hilton Downtown', 225, '2020-01-24', 297, NULL),
('Hilton Downtown', 225, '2020-01-25', 254, NULL),
('Hilton Downtown', 225, '2020-01-26', 164, NULL),
('Hilton Downtown', 225, '2020-01-27', 395, NULL),
('Hilton Downtown', 225, '2020-01-28', 168, NULL),
('Hilton Downtown', 225, '2020-01-29', 211, NULL),
('Hilton Downtown', 225, '2020-01-30', 238, NULL),
('Hilton Downtown', 225, '2020-01-31', 349, NULL),
('Hilton Downtown', 225, '2020-02-01', 396, NULL),
('Hilton Downtown', 225, '2020-02-02', 362, NULL),
('Hilton Downtown', 225, '2020-02-03', 281, NULL),
('Hilton Downtown', 225, '2020-02-04', 217, NULL),
('Hilton Downtown', 228, '2019-01-01', 380, NULL),
('Hilton Downtown', 228, '2019-01-02', 123, NULL),
('Hilton Downtown', 228, '2019-01-03', 307, NULL),
('Hilton Downtown', 228, '2019-01-04', 195, NULL),
('Hilton Downtown', 228, '2019-01-05', 340, NULL),
('Hilton Downtown', 228, '2019-01-06', 252, NULL),
('Hilton Downtown', 228, '2019-01-07', 352, NULL),
('Hilton Downtown', 228, '2019-01-08', 120, NULL),
('Hilton Downtown', 228, '2019-01-09', 261, NULL),
('Hilton Downtown', 228, '2019-01-10', 281, NULL),
('Hilton Downtown', 228, '2019-01-11', 352, NULL),
('Hilton Downtown', 228, '2019-01-12', 334, NULL),
('Hilton Downtown', 228, '2019-01-13', 339, NULL),
('Hilton Downtown', 228, '2019-01-14', 197, NULL),
('Hilton Downtown', 228, '2019-01-15', 353, NULL),
('Hilton Downtown', 228, '2019-01-16', 267, NULL),
('Hilton Downtown', 228, '2019-01-17', 373, NULL),
('Hilton Downtown', 228, '2019-01-18', 192, NULL),
('Hilton Downtown', 228, '2019-01-19', 365, NULL),
('Hilton Downtown', 228, '2019-01-20', 127, NULL),
('Hilton Downtown', 228, '2019-01-21', 211, NULL),
('Hilton Downtown', 228, '2019-01-22', 109, NULL),
('Hilton Downtown', 228, '2019-01-23', 230, NULL),
('Hilton Downtown', 228, '2019-01-24', 117, NULL),
('Hilton Downtown', 228, '2019-01-25', 117, NULL),
('Hilton Downtown', 228, '2019-01-26', 169, NULL),
('Hilton Downtown', 228, '2019-01-27', 276, NULL),
('Hilton Downtown', 228, '2019-01-28', 335, NULL),
('Hilton Downtown', 228, '2019-01-29', 347, NULL),
('Hilton Downtown', 228, '2019-01-30', 384, NULL),
('Hilton Downtown', 228, '2019-01-31', 182, NULL),
('Hilton Downtown', 228, '2019-02-01', 293, NULL),
('Hilton Downtown', 228, '2019-02-02', 374, NULL),
('Hilton Downtown', 228, '2019-02-03', 315, NULL),
('Hilton Downtown', 228, '2019-02-04', 350, NULL),
('Hilton Downtown', 228, '2019-02-05', 395, NULL),
('Hilton Downtown', 228, '2019-02-06', 187, NULL),
('Hilton Downtown', 228, '2019-02-07', 283, NULL),
('Hilton Downtown', 228, '2019-02-08', 382, NULL),
('Hilton Downtown', 228, '2019-02-09', 127, NULL),
('Hilton Downtown', 228, '2019-02-10', 153, NULL),
('Hilton Downtown', 228, '2019-02-11', 355, NULL),
('Hilton Downtown', 228, '2019-02-12', 357, NULL),
('Hilton Downtown', 228, '2019-02-13', 293, NULL),
('Hilton Downtown', 228, '2019-02-14', 308, NULL),
('Hilton Downtown', 228, '2019-02-15', 240, NULL),
('Hilton Downtown', 228, '2019-02-16', 314, NULL),
('Hilton Downtown', 228, '2019-02-17', 382, NULL),
('Hilton Downtown', 228, '2019-02-18', 374, NULL),
('Hilton Downtown', 228, '2019-02-19', 357, NULL),
('Hilton Downtown', 228, '2019-02-20', 266, NULL),
('Hilton Downtown', 228, '2019-02-21', 382, NULL),
('Hilton Downtown', 228, '2019-02-22', 286, NULL),
('Hilton Downtown', 228, '2019-02-23', 167, NULL),
('Hilton Downtown', 228, '2019-02-24', 274, NULL),
('Hilton Downtown', 228, '2019-02-25', 368, NULL),
('Hilton Downtown', 228, '2019-02-26', 241, NULL),
('Hilton Downtown', 228, '2019-02-27', 369, NULL),
('Hilton Downtown', 228, '2019-02-28', 384, NULL),
('Hilton Downtown', 228, '2019-03-01', 141, NULL),
('Hilton Downtown', 228, '2019-03-02', 156, NULL),
('Hilton Downtown', 228, '2019-03-03', 140, NULL),
('Hilton Downtown', 228, '2019-03-04', 385, NULL),
('Hilton Downtown', 228, '2019-03-05', 163, NULL),
('Hilton Downtown', 228, '2019-03-06', 387, NULL),
('Hilton Downtown', 228, '2019-03-07', 137, NULL),
('Hilton Downtown', 228, '2019-03-08', 342, NULL),
('Hilton Downtown', 228, '2019-03-09', 197, NULL),
('Hilton Downtown', 228, '2019-03-10', 114, NULL),
('Hilton Downtown', 228, '2019-03-11', 126, NULL),
('Hilton Downtown', 228, '2019-03-12', 292, NULL),
('Hilton Downtown', 228, '2019-03-13', 106, NULL),
('Hilton Downtown', 228, '2019-03-14', 162, NULL),
('Hilton Downtown', 228, '2019-03-15', 116, NULL),
('Hilton Downtown', 228, '2019-03-16', 131, NULL),
('Hilton Downtown', 228, '2019-03-17', 170, NULL),
('Hilton Downtown', 228, '2019-03-18', 131, NULL),
('Hilton Downtown', 228, '2019-03-19', 223, NULL),
('Hilton Downtown', 228, '2019-03-20', 398, NULL),
('Hilton Downtown', 228, '2019-03-21', 134, NULL),
('Hilton Downtown', 228, '2019-03-22', 341, NULL),
('Hilton Downtown', 228, '2019-03-23', 131, NULL),
('Hilton Downtown', 228, '2019-03-24', 280, NULL),
('Hilton Downtown', 228, '2019-03-25', 164, NULL),
('Hilton Downtown', 228, '2019-03-26', 219, NULL),
('Hilton Downtown', 228, '2019-03-27', 115, NULL),
('Hilton Downtown', 228, '2019-03-28', 180, NULL),
('Hilton Downtown', 228, '2019-03-29', 186, NULL),
('Hilton Downtown', 228, '2019-03-30', 246, NULL),
('Hilton Downtown', 228, '2019-03-31', 313, NULL),
('Hilton Downtown', 228, '2019-04-01', 209, NULL),
('Hilton Downtown', 228, '2019-04-02', 219, NULL),
('Hilton Downtown', 228, '2019-04-03', 335, NULL),
('Hilton Downtown', 228, '2019-04-04', 356, NULL),
('Hilton Downtown', 228, '2019-04-05', 119, NULL),
('Hilton Downtown', 228, '2019-04-06', 153, NULL),
('Hilton Downtown', 228, '2019-04-07', 309, NULL),
('Hilton Downtown', 228, '2019-04-08', 339, NULL),
('Hilton Downtown', 228, '2019-04-09', 117, NULL),
('Hilton Downtown', 228, '2019-04-10', 171, NULL),
('Hilton Downtown', 228, '2019-04-11', 169, NULL),
('Hilton Downtown', 228, '2019-04-12', 163, NULL),
('Hilton Downtown', 228, '2019-04-13', 291, NULL),
('Hilton Downtown', 228, '2019-04-14', 233, NULL),
('Hilton Downtown', 228, '2019-04-15', 197, NULL),
('Hilton Downtown', 228, '2019-04-16', 121, NULL),
('Hilton Downtown', 228, '2019-04-17', 369, NULL),
('Hilton Downtown', 228, '2019-04-18', 292, NULL),
('Hilton Downtown', 228, '2019-04-19', 197, NULL),
('Hilton Downtown', 228, '2019-04-20', 129, NULL),
('Hilton Downtown', 228, '2019-04-21', 113, NULL),
('Hilton Downtown', 228, '2019-04-22', 171, NULL),
('Hilton Downtown', 228, '2019-04-23', 184, NULL),
('Hilton Downtown', 228, '2019-04-24', 189, NULL),
('Hilton Downtown', 228, '2019-04-25', 251, NULL),
('Hilton Downtown', 228, '2019-04-26', 250, NULL),
('Hilton Downtown', 228, '2019-04-27', 225, NULL),
('Hilton Downtown', 228, '2019-04-28', 289, NULL),
('Hilton Downtown', 228, '2019-04-29', 265, NULL),
('Hilton Downtown', 228, '2019-04-30', 163, NULL),
('Hilton Downtown', 228, '2019-05-01', 216, NULL),
('Hilton Downtown', 228, '2019-05-02', 144, NULL),
('Hilton Downtown', 228, '2019-05-03', 390, NULL),
('Hilton Downtown', 228, '2019-05-04', 156, NULL),
('Hilton Downtown', 228, '2019-05-05', 165, NULL),
('Hilton Downtown', 228, '2019-05-06', 268, NULL),
('Hilton Downtown', 228, '2019-05-07', 124, NULL),
('Hilton Downtown', 228, '2019-05-08', 290, NULL),
('Hilton Downtown', 228, '2019-05-09', 392, NULL),
('Hilton Downtown', 228, '2019-05-10', 175, NULL),
('Hilton Downtown', 228, '2019-05-11', 247, NULL),
('Hilton Downtown', 228, '2019-05-12', 108, NULL),
('Hilton Downtown', 228, '2019-05-13', 314, NULL),
('Hilton Downtown', 228, '2019-05-14', 311, NULL),
('Hilton Downtown', 228, '2019-05-15', 117, NULL),
('Hilton Downtown', 228, '2019-05-16', 111, NULL),
('Hilton Downtown', 228, '2019-05-17', 258, NULL),
('Hilton Downtown', 228, '2019-05-18', 255, NULL),
('Hilton Downtown', 228, '2019-05-19', 235, NULL),
('Hilton Downtown', 228, '2019-05-20', 343, NULL),
('Hilton Downtown', 228, '2019-05-21', 245, NULL),
('Hilton Downtown', 228, '2019-05-22', 233, NULL),
('Hilton Downtown', 228, '2019-05-23', 138, NULL),
('Hilton Downtown', 228, '2019-05-24', 336, NULL),
('Hilton Downtown', 228, '2019-05-25', 311, NULL),
('Hilton Downtown', 228, '2019-05-26', 368, NULL),
('Hilton Downtown', 228, '2019-05-27', 266, NULL),
('Hilton Downtown', 228, '2019-05-28', 297, NULL),
('Hilton Downtown', 228, '2019-05-29', 350, NULL),
('Hilton Downtown', 228, '2019-05-30', 356, NULL),
('Hilton Downtown', 228, '2019-05-31', 109, NULL),
('Hilton Downtown', 228, '2019-06-01', 179, NULL),
('Hilton Downtown', 228, '2019-06-02', 297, NULL),
('Hilton Downtown', 228, '2019-06-03', 267, NULL),
('Hilton Downtown', 228, '2019-06-04', 308, NULL),
('Hilton Downtown', 228, '2019-06-05', 292, NULL),
('Hilton Downtown', 228, '2019-06-06', 331, NULL),
('Hilton Downtown', 228, '2019-06-07', 126, NULL),
('Hilton Downtown', 228, '2019-06-08', 328, NULL),
('Hilton Downtown', 228, '2019-06-09', 224, NULL),
('Hilton Downtown', 228, '2019-06-10', 349, NULL),
('Hilton Downtown', 228, '2019-06-11', 182, NULL),
('Hilton Downtown', 228, '2019-06-12', 394, NULL),
('Hilton Downtown', 228, '2019-06-13', 243, NULL),
('Hilton Downtown', 228, '2019-06-14', 362, NULL),
('Hilton Downtown', 228, '2019-06-15', 181, NULL),
('Hilton Downtown', 228, '2019-06-16', 146, NULL),
('Hilton Downtown', 228, '2019-06-17', 388, NULL),
('Hilton Downtown', 228, '2019-06-18', 233, NULL),
('Hilton Downtown', 228, '2019-06-19', 259, NULL),
('Hilton Downtown', 228, '2019-06-20', 398, NULL),
('Hilton Downtown', 228, '2019-06-21', 271, NULL),
('Hilton Downtown', 228, '2019-06-22', 363, NULL),
('Hilton Downtown', 228, '2019-06-23', 233, NULL),
('Hilton Downtown', 228, '2019-06-24', 216, NULL),
('Hilton Downtown', 228, '2019-06-25', 271, NULL),
('Hilton Downtown', 228, '2019-06-26', 105, NULL),
('Hilton Downtown', 228, '2019-06-27', 346, NULL),
('Hilton Downtown', 228, '2019-06-28', 300, NULL),
('Hilton Downtown', 228, '2019-06-29', 313, NULL),
('Hilton Downtown', 228, '2019-06-30', 389, NULL),
('Hilton Downtown', 228, '2019-07-01', 308, NULL),
('Hilton Downtown', 228, '2019-07-02', 168, NULL),
('Hilton Downtown', 228, '2019-07-03', 386, NULL),
('Hilton Downtown', 228, '2019-07-04', 291, NULL),
('Hilton Downtown', 228, '2019-07-05', 248, NULL),
('Hilton Downtown', 228, '2019-07-06', 271, NULL),
('Hilton Downtown', 228, '2019-07-07', 314, NULL),
('Hilton Downtown', 228, '2019-07-08', 306, NULL),
('Hilton Downtown', 228, '2019-07-09', 203, NULL),
('Hilton Downtown', 228, '2019-07-10', 163, NULL),
('Hilton Downtown', 228, '2019-07-11', 112, NULL),
('Hilton Downtown', 228, '2019-07-12', 249, NULL),
('Hilton Downtown', 228, '2019-07-13', 335, NULL),
('Hilton Downtown', 228, '2019-07-14', 185, NULL),
('Hilton Downtown', 228, '2019-07-15', 188, NULL),
('Hilton Downtown', 228, '2019-07-16', 352, NULL),
('Hilton Downtown', 228, '2019-07-17', 172, NULL),
('Hilton Downtown', 228, '2019-07-18', 125, NULL),
('Hilton Downtown', 228, '2019-07-19', 275, NULL),
('Hilton Downtown', 228, '2019-07-20', 186, NULL),
('Hilton Downtown', 228, '2019-07-21', 201, NULL),
('Hilton Downtown', 228, '2019-07-22', 261, NULL),
('Hilton Downtown', 228, '2019-07-23', 107, NULL),
('Hilton Downtown', 228, '2019-07-24', 174, NULL),
('Hilton Downtown', 228, '2019-07-25', 271, NULL),
('Hilton Downtown', 228, '2019-07-26', 292, NULL),
('Hilton Downtown', 228, '2019-07-27', 284, NULL),
('Hilton Downtown', 228, '2019-07-28', 129, NULL),
('Hilton Downtown', 228, '2019-07-29', 282, NULL),
('Hilton Downtown', 228, '2019-07-30', 212, NULL),
('Hilton Downtown', 228, '2019-07-31', 187, NULL),
('Hilton Downtown', 228, '2019-08-01', 315, NULL),
('Hilton Downtown', 228, '2019-08-02', 370, NULL),
('Hilton Downtown', 228, '2019-08-03', 140, NULL),
('Hilton Downtown', 228, '2019-08-04', 395, NULL),
('Hilton Downtown', 228, '2019-08-05', 262, NULL),
('Hilton Downtown', 228, '2019-08-06', 210, NULL),
('Hilton Downtown', 228, '2019-08-07', 397, NULL),
('Hilton Downtown', 228, '2019-08-08', 201, NULL),
('Hilton Downtown', 228, '2019-08-09', 132, NULL),
('Hilton Downtown', 228, '2019-08-10', 131, NULL),
('Hilton Downtown', 228, '2019-08-11', 263, NULL),
('Hilton Downtown', 228, '2019-08-12', 243, NULL),
('Hilton Downtown', 228, '2019-08-13', 283, NULL),
('Hilton Downtown', 228, '2019-08-14', 154, NULL),
('Hilton Downtown', 228, '2019-08-15', 201, NULL),
('Hilton Downtown', 228, '2019-08-16', 382, NULL),
('Hilton Downtown', 228, '2019-08-17', 218, NULL),
('Hilton Downtown', 228, '2019-08-18', 382, NULL),
('Hilton Downtown', 228, '2019-08-19', 112, NULL),
('Hilton Downtown', 228, '2019-08-20', 226, NULL),
('Hilton Downtown', 228, '2019-08-21', 249, NULL),
('Hilton Downtown', 228, '2019-08-22', 362, NULL),
('Hilton Downtown', 228, '2019-08-23', 104, NULL),
('Hilton Downtown', 228, '2019-08-24', 127, NULL),
('Hilton Downtown', 228, '2019-08-25', 302, NULL),
('Hilton Downtown', 228, '2019-08-26', 319, NULL),
('Hilton Downtown', 228, '2019-08-27', 202, NULL),
('Hilton Downtown', 228, '2019-08-28', 364, NULL),
('Hilton Downtown', 228, '2019-08-29', 172, NULL),
('Hilton Downtown', 228, '2019-08-30', 167, NULL),
('Hilton Downtown', 228, '2019-08-31', 373, NULL),
('Hilton Downtown', 228, '2019-09-01', 154, NULL),
('Hilton Downtown', 228, '2019-09-02', 198, NULL),
('Hilton Downtown', 228, '2019-09-03', 233, NULL),
('Hilton Downtown', 228, '2019-09-04', 295, NULL),
('Hilton Downtown', 228, '2019-09-05', 170, NULL),
('Hilton Downtown', 228, '2019-09-06', 113, NULL),
('Hilton Downtown', 228, '2019-09-07', 187, NULL),
('Hilton Downtown', 228, '2019-09-08', 121, NULL),
('Hilton Downtown', 228, '2019-09-09', 159, NULL),
('Hilton Downtown', 228, '2019-09-10', 320, NULL),
('Hilton Downtown', 228, '2019-09-11', 186, NULL),
('Hilton Downtown', 228, '2019-09-12', 125, NULL),
('Hilton Downtown', 228, '2019-09-13', 172, NULL),
('Hilton Downtown', 228, '2019-09-14', 212, NULL),
('Hilton Downtown', 228, '2019-09-15', 138, NULL),
('Hilton Downtown', 228, '2019-09-16', 144, NULL),
('Hilton Downtown', 228, '2019-09-17', 172, NULL),
('Hilton Downtown', 228, '2019-09-18', 304, NULL),
('Hilton Downtown', 228, '2019-09-19', 148, NULL),
('Hilton Downtown', 228, '2019-09-20', 225, NULL),
('Hilton Downtown', 228, '2019-09-21', 212, NULL),
('Hilton Downtown', 228, '2019-09-22', 214, NULL),
('Hilton Downtown', 228, '2019-09-23', 152, NULL),
('Hilton Downtown', 228, '2019-09-24', 234, NULL),
('Hilton Downtown', 228, '2019-09-25', 213, NULL),
('Hilton Downtown', 228, '2019-09-26', 335, NULL),
('Hilton Downtown', 228, '2019-09-27', 395, NULL),
('Hilton Downtown', 228, '2019-09-28', 232, NULL),
('Hilton Downtown', 228, '2019-09-29', 116, NULL),
('Hilton Downtown', 228, '2019-09-30', 321, NULL),
('Hilton Downtown', 228, '2019-10-01', 386, NULL),
('Hilton Downtown', 228, '2019-10-02', 340, NULL),
('Hilton Downtown', 228, '2019-10-03', 388, NULL),
('Hilton Downtown', 228, '2019-10-04', 193, NULL),
('Hilton Downtown', 228, '2019-10-05', 373, NULL),
('Hilton Downtown', 228, '2019-10-06', 106, NULL),
('Hilton Downtown', 228, '2019-10-07', 264, NULL),
('Hilton Downtown', 228, '2019-10-08', 119, NULL),
('Hilton Downtown', 228, '2019-10-09', 182, NULL),
('Hilton Downtown', 228, '2019-10-10', 352, NULL),
('Hilton Downtown', 228, '2019-10-11', 118, NULL),
('Hilton Downtown', 228, '2019-10-12', 164, NULL),
('Hilton Downtown', 228, '2019-10-13', 384, NULL),
('Hilton Downtown', 228, '2019-10-14', 337, NULL),
('Hilton Downtown', 228, '2019-10-15', 134, NULL),
('Hilton Downtown', 228, '2019-10-16', 181, NULL),
('Hilton Downtown', 228, '2019-10-17', 324, NULL),
('Hilton Downtown', 228, '2019-10-18', 182, NULL),
('Hilton Downtown', 228, '2019-10-19', 101, NULL),
('Hilton Downtown', 228, '2019-10-20', 136, NULL),
('Hilton Downtown', 228, '2019-10-21', 338, NULL),
('Hilton Downtown', 228, '2019-10-22', 319, NULL),
('Hilton Downtown', 228, '2019-10-23', 192, NULL),
('Hilton Downtown', 228, '2019-10-24', 239, NULL),
('Hilton Downtown', 228, '2019-10-25', 333, NULL),
('Hilton Downtown', 228, '2019-10-26', 186, NULL),
('Hilton Downtown', 228, '2019-10-27', 345, NULL),
('Hilton Downtown', 228, '2019-10-28', 332, NULL),
('Hilton Downtown', 228, '2019-10-29', 202, NULL),
('Hilton Downtown', 228, '2019-10-30', 138, NULL),
('Hilton Downtown', 228, '2019-10-31', 378, NULL),
('Hilton Downtown', 228, '2019-11-01', 398, NULL),
('Hilton Downtown', 228, '2019-11-02', 224, NULL),
('Hilton Downtown', 228, '2019-11-03', 390, NULL),
('Hilton Downtown', 228, '2019-11-04', 213, NULL),
('Hilton Downtown', 228, '2019-11-05', 267, NULL),
('Hilton Downtown', 228, '2019-11-06', 391, NULL),
('Hilton Downtown', 228, '2019-11-07', 303, NULL),
('Hilton Downtown', 228, '2019-11-08', 346, NULL),
('Hilton Downtown', 228, '2019-11-09', 109, NULL),
('Hilton Downtown', 228, '2019-11-10', 165, NULL),
('Hilton Downtown', 228, '2019-11-11', 144, NULL),
('Hilton Downtown', 228, '2019-11-12', 276, NULL),
('Hilton Downtown', 228, '2019-11-13', 306, NULL),
('Hilton Downtown', 228, '2019-11-14', 330, NULL),
('Hilton Downtown', 228, '2019-11-15', 193, NULL),
('Hilton Downtown', 228, '2019-11-16', 325, NULL),
('Hilton Downtown', 228, '2019-11-17', 346, NULL),
('Hilton Downtown', 228, '2019-11-18', 360, NULL),
('Hilton Downtown', 228, '2019-11-19', 229, NULL),
('Hilton Downtown', 228, '2019-11-20', 211, NULL),
('Hilton Downtown', 228, '2019-11-21', 347, NULL),
('Hilton Downtown', 228, '2019-11-22', 123, NULL),
('Hilton Downtown', 228, '2019-11-23', 247, NULL),
('Hilton Downtown', 228, '2019-11-24', 392, NULL),
('Hilton Downtown', 228, '2019-11-25', 323, NULL),
('Hilton Downtown', 228, '2019-11-26', 324, NULL),
('Hilton Downtown', 228, '2019-11-27', 216, NULL),
('Hilton Downtown', 228, '2019-11-28', 260, NULL),
('Hilton Downtown', 228, '2019-11-29', 204, NULL),
('Hilton Downtown', 228, '2019-11-30', 378, NULL),
('Hilton Downtown', 228, '2019-12-01', 138, NULL),
('Hilton Downtown', 228, '2019-12-02', 392, NULL),
('Hilton Downtown', 228, '2019-12-03', 250, NULL),
('Hilton Downtown', 228, '2019-12-04', 133, NULL),
('Hilton Downtown', 228, '2019-12-05', 341, NULL),
('Hilton Downtown', 228, '2019-12-06', 281, NULL),
('Hilton Downtown', 228, '2019-12-07', 285, NULL),
('Hilton Downtown', 228, '2019-12-08', 366, NULL),
('Hilton Downtown', 228, '2019-12-09', 385, NULL),
('Hilton Downtown', 228, '2019-12-10', 191, NULL),
('Hilton Downtown', 228, '2019-12-11', 205, NULL),
('Hilton Downtown', 228, '2019-12-12', 275, NULL),
('Hilton Downtown', 228, '2019-12-13', 390, NULL),
('Hilton Downtown', 228, '2019-12-14', 167, NULL),
('Hilton Downtown', 228, '2019-12-15', 116, NULL),
('Hilton Downtown', 228, '2019-12-16', 284, NULL),
('Hilton Downtown', 228, '2019-12-17', 172, NULL),
('Hilton Downtown', 228, '2019-12-18', 299, NULL),
('Hilton Downtown', 228, '2019-12-19', 342, NULL),
('Hilton Downtown', 228, '2019-12-20', 126, NULL),
('Hilton Downtown', 228, '2019-12-21', 158, NULL),
('Hilton Downtown', 228, '2019-12-22', 268, NULL),
('Hilton Downtown', 228, '2019-12-23', 319, NULL),
('Hilton Downtown', 228, '2019-12-24', 390, NULL),
('Hilton Downtown', 228, '2019-12-25', 291, NULL),
('Hilton Downtown', 228, '2019-12-26', 198, NULL),
('Hilton Downtown', 228, '2019-12-27', 245, NULL),
('Hilton Downtown', 228, '2019-12-28', 212, NULL),
('Hilton Downtown', 228, '2019-12-29', 281, NULL),
('Hilton Downtown', 228, '2019-12-30', 134, NULL),
('Hilton Downtown', 228, '2019-12-31', 393, NULL),
('Hilton Downtown', 228, '2020-01-01', 128, NULL),
('Hilton Downtown', 228, '2020-01-02', 300, NULL),
('Hilton Downtown', 228, '2020-01-03', 168, NULL),
('Hilton Downtown', 228, '2020-01-04', 133, NULL),
('Hilton Downtown', 228, '2020-01-05', 323, NULL),
('Hilton Downtown', 228, '2020-01-06', 230, NULL),
('Hilton Downtown', 228, '2020-01-07', 342, NULL),
('Hilton Downtown', 228, '2020-01-08', 121, NULL),
('Hilton Downtown', 228, '2020-01-09', 151, NULL),
('Hilton Downtown', 228, '2020-01-10', 240, NULL),
('Hilton Downtown', 228, '2020-01-11', 385, NULL),
('Hilton Downtown', 228, '2020-01-12', 100, NULL),
('Hilton Downtown', 228, '2020-01-13', 329, NULL),
('Hilton Downtown', 228, '2020-01-14', 288, NULL),
('Hilton Downtown', 228, '2020-01-15', 140, NULL),
('Hilton Downtown', 228, '2020-01-16', 381, NULL),
('Hilton Downtown', 228, '2020-01-17', 255, NULL),
('Hilton Downtown', 228, '2020-01-18', 155, NULL),
('Hilton Downtown', 228, '2020-01-19', 174, NULL),
('Hilton Downtown', 228, '2020-01-20', 387, NULL),
('Hilton Downtown', 228, '2020-01-21', 160, NULL),
('Hilton Downtown', 228, '2020-01-22', 192, NULL),
('Hilton Downtown', 228, '2020-01-23', 323, NULL),
('Hilton Downtown', 228, '2020-01-24', 207, NULL),
('Hilton Downtown', 228, '2020-01-25', 245, NULL),
('Hilton Downtown', 228, '2020-01-26', 106, NULL),
('Hilton Downtown', 228, '2020-01-27', 219, NULL),
('Hilton Downtown', 228, '2020-01-28', 185, NULL),
('Hilton Downtown', 228, '2020-01-29', 334, NULL),
('Hilton Downtown', 228, '2020-01-30', 309, NULL),
('Hilton Downtown', 228, '2020-01-31', 387, NULL),
('Hilton Downtown', 228, '2020-02-01', 220, NULL),
('Hilton Downtown', 228, '2020-02-02', 182, NULL),
('Hilton Downtown', 228, '2020-02-03', 211, NULL),
('Hilton Downtown', 228, '2020-02-04', 168, NULL),
('Hilton Downtown', 238, '2019-01-01', 183, NULL),
('Hilton Downtown', 238, '2019-01-02', 214, NULL),
('Hilton Downtown', 238, '2019-01-03', 137, NULL),
('Hilton Downtown', 238, '2019-01-04', 393, NULL),
('Hilton Downtown', 238, '2019-01-05', 117, NULL),
('Hilton Downtown', 238, '2019-01-06', 371, NULL),
('Hilton Downtown', 238, '2019-01-07', 161, NULL),
('Hilton Downtown', 238, '2019-01-08', 286, NULL),
('Hilton Downtown', 238, '2019-01-09', 211, NULL),
('Hilton Downtown', 238, '2019-01-10', 122, NULL),
('Hilton Downtown', 238, '2019-01-11', 392, NULL),
('Hilton Downtown', 238, '2019-01-12', 201, NULL),
('Hilton Downtown', 238, '2019-01-13', 268, NULL),
('Hilton Downtown', 238, '2019-01-14', 173, NULL),
('Hilton Downtown', 238, '2019-01-15', 325, NULL),
('Hilton Downtown', 238, '2019-01-16', 105, NULL),
('Hilton Downtown', 238, '2019-01-17', 274, NULL),
('Hilton Downtown', 238, '2019-01-18', 168, NULL),
('Hilton Downtown', 238, '2019-01-19', 149, NULL),
('Hilton Downtown', 238, '2019-01-20', 304, NULL),
('Hilton Downtown', 238, '2019-01-21', 353, NULL),
('Hilton Downtown', 238, '2019-01-22', 324, NULL),
('Hilton Downtown', 238, '2019-01-23', 103, NULL),
('Hilton Downtown', 238, '2019-01-24', 152, NULL),
('Hilton Downtown', 238, '2019-01-25', 221, NULL),
('Hilton Downtown', 238, '2019-01-26', 277, NULL),
('Hilton Downtown', 238, '2019-01-27', 198, NULL),
('Hilton Downtown', 238, '2019-01-28', 259, NULL),
('Hilton Downtown', 238, '2019-01-29', 357, NULL),
('Hilton Downtown', 238, '2019-01-30', 234, NULL),
('Hilton Downtown', 238, '2019-01-31', 299, NULL),
('Hilton Downtown', 238, '2019-02-01', 394, NULL),
('Hilton Downtown', 238, '2019-02-02', 348, NULL),
('Hilton Downtown', 238, '2019-02-03', 200, NULL),
('Hilton Downtown', 238, '2019-02-04', 397, NULL),
('Hilton Downtown', 238, '2019-02-05', 321, NULL),
('Hilton Downtown', 238, '2019-02-06', 107, NULL),
('Hilton Downtown', 238, '2019-02-07', 183, NULL),
('Hilton Downtown', 238, '2019-02-08', 291, NULL),
('Hilton Downtown', 238, '2019-02-09', 319, NULL),
('Hilton Downtown', 238, '2019-02-10', 144, NULL),
('Hilton Downtown', 238, '2019-02-11', 314, NULL),
('Hilton Downtown', 238, '2019-02-12', 392, NULL),
('Hilton Downtown', 238, '2019-02-13', 193, NULL),
('Hilton Downtown', 238, '2019-02-14', 307, NULL),
('Hilton Downtown', 238, '2019-02-15', 111, NULL),
('Hilton Downtown', 238, '2019-02-16', 207, NULL),
('Hilton Downtown', 238, '2019-02-17', 323, NULL),
('Hilton Downtown', 238, '2019-02-18', 244, NULL),
('Hilton Downtown', 238, '2019-02-19', 262, NULL),
('Hilton Downtown', 238, '2019-02-20', 137, NULL),
('Hilton Downtown', 238, '2019-02-21', 181, NULL),
('Hilton Downtown', 238, '2019-02-22', 120, NULL),
('Hilton Downtown', 238, '2019-02-23', 388, NULL),
('Hilton Downtown', 238, '2019-02-24', 373, NULL),
('Hilton Downtown', 238, '2019-02-25', 100, NULL),
('Hilton Downtown', 238, '2019-02-26', 279, NULL),
('Hilton Downtown', 238, '2019-02-27', 288, NULL),
('Hilton Downtown', 238, '2019-02-28', 301, NULL),
('Hilton Downtown', 238, '2019-03-01', 178, NULL),
('Hilton Downtown', 238, '2019-03-02', 157, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 238, '2019-03-03', 330, NULL),
('Hilton Downtown', 238, '2019-03-04', 223, NULL),
('Hilton Downtown', 238, '2019-03-05', 132, NULL),
('Hilton Downtown', 238, '2019-03-06', 189, NULL),
('Hilton Downtown', 238, '2019-03-07', 343, NULL),
('Hilton Downtown', 238, '2019-03-08', 287, NULL),
('Hilton Downtown', 238, '2019-03-09', 271, NULL),
('Hilton Downtown', 238, '2019-03-10', 319, NULL),
('Hilton Downtown', 238, '2019-03-11', 307, NULL),
('Hilton Downtown', 238, '2019-03-12', 127, NULL),
('Hilton Downtown', 238, '2019-03-13', 210, NULL),
('Hilton Downtown', 238, '2019-03-14', 359, NULL),
('Hilton Downtown', 238, '2019-03-15', 146, NULL),
('Hilton Downtown', 238, '2019-03-16', 290, NULL),
('Hilton Downtown', 238, '2019-03-17', 150, NULL),
('Hilton Downtown', 238, '2019-03-18', 372, NULL),
('Hilton Downtown', 238, '2019-03-19', 371, NULL),
('Hilton Downtown', 238, '2019-03-20', 299, NULL),
('Hilton Downtown', 238, '2019-03-21', 305, NULL),
('Hilton Downtown', 238, '2019-03-22', 165, NULL),
('Hilton Downtown', 238, '2019-03-23', 172, NULL),
('Hilton Downtown', 238, '2019-03-24', 215, NULL),
('Hilton Downtown', 238, '2019-03-25', 246, NULL),
('Hilton Downtown', 238, '2019-03-26', 377, NULL),
('Hilton Downtown', 238, '2019-03-27', 314, NULL),
('Hilton Downtown', 238, '2019-03-28', 174, NULL),
('Hilton Downtown', 238, '2019-03-29', 368, NULL),
('Hilton Downtown', 238, '2019-03-30', 296, NULL),
('Hilton Downtown', 238, '2019-03-31', 337, NULL),
('Hilton Downtown', 238, '2019-04-01', 314, NULL),
('Hilton Downtown', 238, '2019-04-02', 243, NULL),
('Hilton Downtown', 238, '2019-04-03', 114, NULL),
('Hilton Downtown', 238, '2019-04-04', 134, NULL),
('Hilton Downtown', 238, '2019-04-05', 283, NULL),
('Hilton Downtown', 238, '2019-04-06', 336, NULL),
('Hilton Downtown', 238, '2019-04-07', 162, NULL),
('Hilton Downtown', 238, '2019-04-08', 190, NULL),
('Hilton Downtown', 238, '2019-04-09', 347, NULL),
('Hilton Downtown', 238, '2019-04-10', 372, NULL),
('Hilton Downtown', 238, '2019-04-11', 143, NULL),
('Hilton Downtown', 238, '2019-04-12', 310, NULL),
('Hilton Downtown', 238, '2019-04-13', 164, NULL),
('Hilton Downtown', 238, '2019-04-14', 134, NULL),
('Hilton Downtown', 238, '2019-04-15', 232, NULL),
('Hilton Downtown', 238, '2019-04-16', 117, NULL),
('Hilton Downtown', 238, '2019-04-17', 136, NULL),
('Hilton Downtown', 238, '2019-04-18', 206, NULL),
('Hilton Downtown', 238, '2019-04-19', 111, NULL),
('Hilton Downtown', 238, '2019-04-20', 344, NULL),
('Hilton Downtown', 238, '2019-04-21', 321, NULL),
('Hilton Downtown', 238, '2019-04-22', 335, NULL),
('Hilton Downtown', 238, '2019-04-23', 391, NULL),
('Hilton Downtown', 238, '2019-04-24', 170, NULL),
('Hilton Downtown', 238, '2019-04-25', 265, NULL),
('Hilton Downtown', 238, '2019-04-26', 186, NULL),
('Hilton Downtown', 238, '2019-04-27', 252, NULL),
('Hilton Downtown', 238, '2019-04-28', 381, NULL),
('Hilton Downtown', 238, '2019-04-29', 157, NULL),
('Hilton Downtown', 238, '2019-04-30', 383, NULL),
('Hilton Downtown', 238, '2019-05-01', 375, NULL),
('Hilton Downtown', 238, '2019-05-02', 123, NULL),
('Hilton Downtown', 238, '2019-05-03', 130, NULL),
('Hilton Downtown', 238, '2019-05-04', 285, NULL),
('Hilton Downtown', 238, '2019-05-05', 340, NULL),
('Hilton Downtown', 238, '2019-05-06', 328, NULL),
('Hilton Downtown', 238, '2019-05-07', 236, NULL),
('Hilton Downtown', 238, '2019-05-08', 143, NULL),
('Hilton Downtown', 238, '2019-05-09', 277, NULL),
('Hilton Downtown', 238, '2019-05-10', 369, NULL),
('Hilton Downtown', 238, '2019-05-11', 289, NULL),
('Hilton Downtown', 238, '2019-05-12', 238, NULL),
('Hilton Downtown', 238, '2019-05-13', 293, NULL),
('Hilton Downtown', 238, '2019-05-14', 373, NULL),
('Hilton Downtown', 238, '2019-05-15', 142, NULL),
('Hilton Downtown', 238, '2019-05-16', 269, NULL),
('Hilton Downtown', 238, '2019-05-17', 177, NULL),
('Hilton Downtown', 238, '2019-05-18', 387, NULL),
('Hilton Downtown', 238, '2019-05-19', 381, NULL),
('Hilton Downtown', 238, '2019-05-20', 156, NULL),
('Hilton Downtown', 238, '2019-05-21', 101, NULL),
('Hilton Downtown', 238, '2019-05-22', 331, NULL),
('Hilton Downtown', 238, '2019-05-23', 360, NULL),
('Hilton Downtown', 238, '2019-05-24', 122, NULL),
('Hilton Downtown', 238, '2019-05-25', 150, NULL),
('Hilton Downtown', 238, '2019-05-26', 261, NULL),
('Hilton Downtown', 238, '2019-05-27', 341, NULL),
('Hilton Downtown', 238, '2019-05-28', 338, NULL),
('Hilton Downtown', 238, '2019-05-29', 194, NULL),
('Hilton Downtown', 238, '2019-05-30', 135, NULL),
('Hilton Downtown', 238, '2019-05-31', 113, NULL),
('Hilton Downtown', 238, '2019-06-01', 378, NULL),
('Hilton Downtown', 238, '2019-06-02', 134, NULL),
('Hilton Downtown', 238, '2019-06-03', 117, NULL),
('Hilton Downtown', 238, '2019-06-04', 309, NULL),
('Hilton Downtown', 238, '2019-06-05', 173, NULL),
('Hilton Downtown', 238, '2019-06-06', 364, NULL),
('Hilton Downtown', 238, '2019-06-07', 162, NULL),
('Hilton Downtown', 238, '2019-06-08', 159, NULL),
('Hilton Downtown', 238, '2019-06-09', 270, NULL),
('Hilton Downtown', 238, '2019-06-10', 397, NULL),
('Hilton Downtown', 238, '2019-06-11', 249, NULL),
('Hilton Downtown', 238, '2019-06-12', 152, NULL),
('Hilton Downtown', 238, '2019-06-13', 179, NULL),
('Hilton Downtown', 238, '2019-06-14', 384, NULL),
('Hilton Downtown', 238, '2019-06-15', 381, NULL),
('Hilton Downtown', 238, '2019-06-16', 127, NULL),
('Hilton Downtown', 238, '2019-06-17', 328, NULL),
('Hilton Downtown', 238, '2019-06-18', 372, NULL),
('Hilton Downtown', 238, '2019-06-19', 389, NULL),
('Hilton Downtown', 238, '2019-06-20', 171, NULL),
('Hilton Downtown', 238, '2019-06-21', 358, NULL),
('Hilton Downtown', 238, '2019-06-22', 223, NULL),
('Hilton Downtown', 238, '2019-06-23', 294, NULL),
('Hilton Downtown', 238, '2019-06-24', 191, NULL),
('Hilton Downtown', 238, '2019-06-25', 117, NULL),
('Hilton Downtown', 238, '2019-06-26', 282, NULL),
('Hilton Downtown', 238, '2019-06-27', 225, NULL),
('Hilton Downtown', 238, '2019-06-28', 289, NULL),
('Hilton Downtown', 238, '2019-06-29', 185, NULL),
('Hilton Downtown', 238, '2019-06-30', 358, NULL),
('Hilton Downtown', 238, '2019-07-01', 176, NULL),
('Hilton Downtown', 238, '2019-07-02', 200, NULL),
('Hilton Downtown', 238, '2019-07-03', 333, NULL),
('Hilton Downtown', 238, '2019-07-04', 339, NULL),
('Hilton Downtown', 238, '2019-07-05', 252, NULL),
('Hilton Downtown', 238, '2019-07-06', 204, NULL),
('Hilton Downtown', 238, '2019-07-07', 225, NULL),
('Hilton Downtown', 238, '2019-07-08', 310, NULL),
('Hilton Downtown', 238, '2019-07-09', 375, NULL),
('Hilton Downtown', 238, '2019-07-10', 254, NULL),
('Hilton Downtown', 238, '2019-07-11', 232, NULL),
('Hilton Downtown', 238, '2019-07-12', 379, NULL),
('Hilton Downtown', 238, '2019-07-13', 256, NULL),
('Hilton Downtown', 238, '2019-07-14', 123, NULL),
('Hilton Downtown', 238, '2019-07-15', 389, NULL),
('Hilton Downtown', 238, '2019-07-16', 214, NULL),
('Hilton Downtown', 238, '2019-07-17', 369, NULL),
('Hilton Downtown', 238, '2019-07-18', 184, NULL),
('Hilton Downtown', 238, '2019-07-19', 162, NULL),
('Hilton Downtown', 238, '2019-07-20', 187, NULL),
('Hilton Downtown', 238, '2019-07-21', 358, NULL),
('Hilton Downtown', 238, '2019-07-22', 179, NULL),
('Hilton Downtown', 238, '2019-07-23', 147, NULL),
('Hilton Downtown', 238, '2019-07-24', 138, NULL),
('Hilton Downtown', 238, '2019-07-25', 202, NULL),
('Hilton Downtown', 238, '2019-07-26', 311, NULL),
('Hilton Downtown', 238, '2019-07-27', 203, NULL),
('Hilton Downtown', 238, '2019-07-28', 187, NULL),
('Hilton Downtown', 238, '2019-07-29', 203, NULL),
('Hilton Downtown', 238, '2019-07-30', 331, NULL),
('Hilton Downtown', 238, '2019-07-31', 365, NULL),
('Hilton Downtown', 238, '2019-08-01', 186, NULL),
('Hilton Downtown', 238, '2019-08-02', 193, NULL),
('Hilton Downtown', 238, '2019-08-03', 181, NULL),
('Hilton Downtown', 238, '2019-08-04', 109, NULL),
('Hilton Downtown', 238, '2019-08-05', 173, NULL),
('Hilton Downtown', 238, '2019-08-06', 127, NULL),
('Hilton Downtown', 238, '2019-08-07', 181, NULL),
('Hilton Downtown', 238, '2019-08-08', 381, NULL),
('Hilton Downtown', 238, '2019-08-09', 325, NULL),
('Hilton Downtown', 238, '2019-08-10', 123, NULL),
('Hilton Downtown', 238, '2019-08-11', 236, NULL),
('Hilton Downtown', 238, '2019-08-12', 185, NULL),
('Hilton Downtown', 238, '2019-08-13', 156, NULL),
('Hilton Downtown', 238, '2019-08-14', 343, NULL),
('Hilton Downtown', 238, '2019-08-15', 384, NULL),
('Hilton Downtown', 238, '2019-08-16', 319, NULL),
('Hilton Downtown', 238, '2019-08-17', 354, NULL),
('Hilton Downtown', 238, '2019-08-18', 289, NULL),
('Hilton Downtown', 238, '2019-08-19', 247, NULL),
('Hilton Downtown', 238, '2019-08-20', 138, NULL),
('Hilton Downtown', 238, '2019-08-21', 345, NULL),
('Hilton Downtown', 238, '2019-08-22', 167, NULL),
('Hilton Downtown', 238, '2019-08-23', 286, NULL),
('Hilton Downtown', 238, '2019-08-24', 210, NULL),
('Hilton Downtown', 238, '2019-08-25', 244, NULL),
('Hilton Downtown', 238, '2019-08-26', 243, NULL),
('Hilton Downtown', 238, '2019-08-27', 183, NULL),
('Hilton Downtown', 238, '2019-08-28', 365, NULL),
('Hilton Downtown', 238, '2019-08-29', 212, NULL),
('Hilton Downtown', 238, '2019-08-30', 213, NULL),
('Hilton Downtown', 238, '2019-08-31', 255, NULL),
('Hilton Downtown', 238, '2019-09-01', 351, NULL),
('Hilton Downtown', 238, '2019-09-02', 134, NULL),
('Hilton Downtown', 238, '2019-09-03', 367, NULL),
('Hilton Downtown', 238, '2019-09-04', 183, NULL),
('Hilton Downtown', 238, '2019-09-05', 211, NULL),
('Hilton Downtown', 238, '2019-09-06', 313, NULL),
('Hilton Downtown', 238, '2019-09-07', 136, NULL),
('Hilton Downtown', 238, '2019-09-08', 115, NULL),
('Hilton Downtown', 238, '2019-09-09', 204, NULL),
('Hilton Downtown', 238, '2019-09-10', 169, NULL),
('Hilton Downtown', 238, '2019-09-11', 341, NULL),
('Hilton Downtown', 238, '2019-09-12', 318, NULL),
('Hilton Downtown', 238, '2019-09-13', 132, NULL),
('Hilton Downtown', 238, '2019-09-14', 136, NULL),
('Hilton Downtown', 238, '2019-09-15', 253, NULL),
('Hilton Downtown', 238, '2019-09-16', 218, NULL),
('Hilton Downtown', 238, '2019-09-17', 270, NULL),
('Hilton Downtown', 238, '2019-09-18', 144, NULL),
('Hilton Downtown', 238, '2019-09-19', 164, NULL),
('Hilton Downtown', 238, '2019-09-20', 210, NULL),
('Hilton Downtown', 238, '2019-09-21', 261, NULL),
('Hilton Downtown', 238, '2019-09-22', 160, NULL),
('Hilton Downtown', 238, '2019-09-23', 239, NULL),
('Hilton Downtown', 238, '2019-09-24', 392, NULL),
('Hilton Downtown', 238, '2019-09-25', 132, NULL),
('Hilton Downtown', 238, '2019-09-26', 220, NULL),
('Hilton Downtown', 238, '2019-09-27', 340, NULL),
('Hilton Downtown', 238, '2019-09-28', 344, NULL),
('Hilton Downtown', 238, '2019-09-29', 299, NULL),
('Hilton Downtown', 238, '2019-09-30', 347, NULL),
('Hilton Downtown', 238, '2019-10-01', 215, NULL),
('Hilton Downtown', 238, '2019-10-02', 135, NULL),
('Hilton Downtown', 238, '2019-10-03', 139, NULL),
('Hilton Downtown', 238, '2019-10-04', 242, NULL),
('Hilton Downtown', 238, '2019-10-05', 308, NULL),
('Hilton Downtown', 238, '2019-10-06', 171, NULL),
('Hilton Downtown', 238, '2019-10-07', 144, NULL),
('Hilton Downtown', 238, '2019-10-08', 272, NULL),
('Hilton Downtown', 238, '2019-10-09', 204, NULL),
('Hilton Downtown', 238, '2019-10-10', 293, NULL),
('Hilton Downtown', 238, '2019-10-11', 139, NULL),
('Hilton Downtown', 238, '2019-10-12', 274, NULL),
('Hilton Downtown', 238, '2019-10-13', 361, NULL),
('Hilton Downtown', 238, '2019-10-14', 202, NULL),
('Hilton Downtown', 238, '2019-10-15', 367, NULL),
('Hilton Downtown', 238, '2019-10-16', 217, NULL),
('Hilton Downtown', 238, '2019-10-17', 257, NULL),
('Hilton Downtown', 238, '2019-10-18', 169, NULL),
('Hilton Downtown', 238, '2019-10-19', 154, NULL),
('Hilton Downtown', 238, '2019-10-20', 215, NULL),
('Hilton Downtown', 238, '2019-10-21', 377, NULL),
('Hilton Downtown', 238, '2019-10-22', 133, NULL),
('Hilton Downtown', 238, '2019-10-23', 136, NULL),
('Hilton Downtown', 238, '2019-10-24', 354, NULL),
('Hilton Downtown', 238, '2019-10-25', 304, NULL),
('Hilton Downtown', 238, '2019-10-26', 352, NULL),
('Hilton Downtown', 238, '2019-10-27', 221, NULL),
('Hilton Downtown', 238, '2019-10-28', 147, NULL),
('Hilton Downtown', 238, '2019-10-29', 255, NULL),
('Hilton Downtown', 238, '2019-10-30', 308, NULL),
('Hilton Downtown', 238, '2019-10-31', 216, NULL),
('Hilton Downtown', 238, '2019-11-01', 339, NULL),
('Hilton Downtown', 238, '2019-11-02', 210, NULL),
('Hilton Downtown', 238, '2019-11-03', 254, NULL),
('Hilton Downtown', 238, '2019-11-04', 254, NULL),
('Hilton Downtown', 238, '2019-11-05', 320, NULL),
('Hilton Downtown', 238, '2019-11-06', 314, NULL),
('Hilton Downtown', 238, '2019-11-07', 307, NULL),
('Hilton Downtown', 238, '2019-11-08', 171, NULL),
('Hilton Downtown', 238, '2019-11-09', 110, NULL),
('Hilton Downtown', 238, '2019-11-10', 130, NULL),
('Hilton Downtown', 238, '2019-11-11', 259, NULL),
('Hilton Downtown', 238, '2019-11-12', 207, NULL),
('Hilton Downtown', 238, '2019-11-13', 377, NULL),
('Hilton Downtown', 238, '2019-11-14', 323, NULL),
('Hilton Downtown', 238, '2019-11-15', 320, NULL),
('Hilton Downtown', 238, '2019-11-16', 227, NULL),
('Hilton Downtown', 238, '2019-11-17', 227, NULL),
('Hilton Downtown', 238, '2019-11-18', 128, NULL),
('Hilton Downtown', 238, '2019-11-19', 305, NULL),
('Hilton Downtown', 238, '2019-11-20', 353, NULL),
('Hilton Downtown', 238, '2019-11-21', 221, NULL),
('Hilton Downtown', 238, '2019-11-22', 380, NULL),
('Hilton Downtown', 238, '2019-11-23', 332, NULL),
('Hilton Downtown', 238, '2019-11-24', 202, NULL),
('Hilton Downtown', 238, '2019-11-25', 355, NULL),
('Hilton Downtown', 238, '2019-11-26', 128, NULL),
('Hilton Downtown', 238, '2019-11-27', 311, NULL),
('Hilton Downtown', 238, '2019-11-28', 326, NULL),
('Hilton Downtown', 238, '2019-11-29', 306, NULL),
('Hilton Downtown', 238, '2019-11-30', 386, NULL),
('Hilton Downtown', 238, '2019-12-01', 285, NULL),
('Hilton Downtown', 238, '2019-12-02', 195, NULL),
('Hilton Downtown', 238, '2019-12-03', 249, NULL),
('Hilton Downtown', 238, '2019-12-04', 359, NULL),
('Hilton Downtown', 238, '2019-12-05', 272, NULL),
('Hilton Downtown', 238, '2019-12-06', 259, NULL),
('Hilton Downtown', 238, '2019-12-07', 259, NULL),
('Hilton Downtown', 238, '2019-12-08', 199, NULL),
('Hilton Downtown', 238, '2019-12-09', 381, NULL),
('Hilton Downtown', 238, '2019-12-10', 278, NULL),
('Hilton Downtown', 238, '2019-12-11', 135, NULL),
('Hilton Downtown', 238, '2019-12-12', 297, NULL),
('Hilton Downtown', 238, '2019-12-13', 289, NULL),
('Hilton Downtown', 238, '2019-12-14', 267, NULL),
('Hilton Downtown', 238, '2019-12-15', 107, NULL),
('Hilton Downtown', 238, '2019-12-16', 353, NULL),
('Hilton Downtown', 238, '2019-12-17', 218, NULL),
('Hilton Downtown', 238, '2019-12-18', 117, NULL),
('Hilton Downtown', 238, '2019-12-19', 295, NULL),
('Hilton Downtown', 238, '2019-12-20', 384, NULL),
('Hilton Downtown', 238, '2019-12-21', 283, NULL),
('Hilton Downtown', 238, '2019-12-22', 251, NULL),
('Hilton Downtown', 238, '2019-12-23', 373, NULL),
('Hilton Downtown', 238, '2019-12-24', 327, NULL),
('Hilton Downtown', 238, '2019-12-25', 399, NULL),
('Hilton Downtown', 238, '2019-12-26', 307, NULL),
('Hilton Downtown', 238, '2019-12-27', 139, NULL),
('Hilton Downtown', 238, '2019-12-28', 123, NULL),
('Hilton Downtown', 238, '2019-12-29', 331, NULL),
('Hilton Downtown', 238, '2019-12-30', 342, NULL),
('Hilton Downtown', 238, '2019-12-31', 283, NULL),
('Hilton Downtown', 238, '2020-01-01', 230, NULL),
('Hilton Downtown', 238, '2020-01-02', 269, NULL),
('Hilton Downtown', 238, '2020-01-03', 257, NULL),
('Hilton Downtown', 238, '2020-01-04', 236, NULL),
('Hilton Downtown', 238, '2020-01-05', 309, NULL),
('Hilton Downtown', 238, '2020-01-06', 304, NULL),
('Hilton Downtown', 238, '2020-01-07', 255, NULL),
('Hilton Downtown', 238, '2020-01-08', 192, NULL),
('Hilton Downtown', 238, '2020-01-09', 144, NULL),
('Hilton Downtown', 238, '2020-01-10', 392, NULL),
('Hilton Downtown', 238, '2020-01-11', 194, NULL),
('Hilton Downtown', 238, '2020-01-12', 245, NULL),
('Hilton Downtown', 238, '2020-01-13', 268, NULL),
('Hilton Downtown', 238, '2020-01-14', 345, NULL),
('Hilton Downtown', 238, '2020-01-15', 103, NULL),
('Hilton Downtown', 238, '2020-01-16', 325, NULL),
('Hilton Downtown', 238, '2020-01-17', 224, NULL),
('Hilton Downtown', 238, '2020-01-18', 176, NULL),
('Hilton Downtown', 238, '2020-01-19', 266, NULL),
('Hilton Downtown', 238, '2020-01-20', 216, NULL),
('Hilton Downtown', 238, '2020-01-21', 189, NULL),
('Hilton Downtown', 238, '2020-01-22', 225, NULL),
('Hilton Downtown', 238, '2020-01-23', 110, NULL),
('Hilton Downtown', 238, '2020-01-24', 345, NULL),
('Hilton Downtown', 238, '2020-01-25', 362, NULL),
('Hilton Downtown', 238, '2020-01-26', 236, NULL),
('Hilton Downtown', 238, '2020-01-27', 111, NULL),
('Hilton Downtown', 238, '2020-01-28', 321, NULL),
('Hilton Downtown', 238, '2020-01-29', 339, NULL),
('Hilton Downtown', 238, '2020-01-30', 132, NULL),
('Hilton Downtown', 238, '2020-01-31', 187, NULL),
('Hilton Downtown', 238, '2020-02-01', 110, NULL),
('Hilton Downtown', 238, '2020-02-02', 326, NULL),
('Hilton Downtown', 238, '2020-02-03', 114, NULL),
('Hilton Downtown', 238, '2020-02-04', 387, NULL),
('Hilton Downtown', 247, '2019-01-01', 278, NULL),
('Hilton Downtown', 247, '2019-01-02', 301, NULL),
('Hilton Downtown', 247, '2019-01-03', 264, NULL),
('Hilton Downtown', 247, '2019-01-04', 378, NULL),
('Hilton Downtown', 247, '2019-01-05', 367, NULL),
('Hilton Downtown', 247, '2019-01-06', 399, NULL),
('Hilton Downtown', 247, '2019-01-07', 248, NULL),
('Hilton Downtown', 247, '2019-01-08', 372, NULL),
('Hilton Downtown', 247, '2019-01-09', 172, NULL),
('Hilton Downtown', 247, '2019-01-10', 268, NULL),
('Hilton Downtown', 247, '2019-01-11', 202, NULL),
('Hilton Downtown', 247, '2019-01-12', 202, NULL),
('Hilton Downtown', 247, '2019-01-13', 225, NULL),
('Hilton Downtown', 247, '2019-01-14', 174, NULL),
('Hilton Downtown', 247, '2019-01-15', 169, NULL),
('Hilton Downtown', 247, '2019-01-16', 221, NULL),
('Hilton Downtown', 247, '2019-01-17', 151, NULL),
('Hilton Downtown', 247, '2019-01-18', 166, NULL),
('Hilton Downtown', 247, '2019-01-19', 152, NULL),
('Hilton Downtown', 247, '2019-01-20', 141, NULL),
('Hilton Downtown', 247, '2019-01-21', 132, NULL),
('Hilton Downtown', 247, '2019-01-22', 293, NULL),
('Hilton Downtown', 247, '2019-01-23', 324, NULL),
('Hilton Downtown', 247, '2019-01-24', 309, NULL),
('Hilton Downtown', 247, '2019-01-25', 353, NULL),
('Hilton Downtown', 247, '2019-01-26', 176, NULL),
('Hilton Downtown', 247, '2019-01-27', 365, NULL),
('Hilton Downtown', 247, '2019-01-28', 192, NULL),
('Hilton Downtown', 247, '2019-01-29', 344, NULL),
('Hilton Downtown', 247, '2019-01-30', 220, NULL),
('Hilton Downtown', 247, '2019-01-31', 248, NULL),
('Hilton Downtown', 247, '2019-02-01', 393, NULL),
('Hilton Downtown', 247, '2019-02-02', 220, NULL),
('Hilton Downtown', 247, '2019-02-03', 256, NULL),
('Hilton Downtown', 247, '2019-02-04', 237, NULL),
('Hilton Downtown', 247, '2019-02-05', 323, NULL),
('Hilton Downtown', 247, '2019-02-06', 176, NULL),
('Hilton Downtown', 247, '2019-02-07', 267, NULL),
('Hilton Downtown', 247, '2019-02-08', 208, NULL),
('Hilton Downtown', 247, '2019-02-09', 214, NULL),
('Hilton Downtown', 247, '2019-02-10', 162, NULL),
('Hilton Downtown', 247, '2019-02-11', 103, NULL),
('Hilton Downtown', 247, '2019-02-12', 188, NULL),
('Hilton Downtown', 247, '2019-02-13', 286, NULL),
('Hilton Downtown', 247, '2019-02-14', 209, NULL),
('Hilton Downtown', 247, '2019-02-15', 334, NULL),
('Hilton Downtown', 247, '2019-02-16', 292, NULL),
('Hilton Downtown', 247, '2019-02-17', 371, NULL),
('Hilton Downtown', 247, '2019-02-18', 295, NULL),
('Hilton Downtown', 247, '2019-02-19', 140, NULL),
('Hilton Downtown', 247, '2019-02-20', 389, NULL),
('Hilton Downtown', 247, '2019-02-21', 258, NULL),
('Hilton Downtown', 247, '2019-02-22', 240, NULL),
('Hilton Downtown', 247, '2019-02-23', 143, NULL),
('Hilton Downtown', 247, '2019-02-24', 345, NULL),
('Hilton Downtown', 247, '2019-02-25', 197, NULL),
('Hilton Downtown', 247, '2019-02-26', 273, NULL),
('Hilton Downtown', 247, '2019-02-27', 235, NULL),
('Hilton Downtown', 247, '2019-02-28', 253, NULL),
('Hilton Downtown', 247, '2019-03-01', 371, NULL),
('Hilton Downtown', 247, '2019-03-02', 217, NULL),
('Hilton Downtown', 247, '2019-03-03', 230, NULL),
('Hilton Downtown', 247, '2019-03-04', 160, NULL),
('Hilton Downtown', 247, '2019-03-05', 369, NULL),
('Hilton Downtown', 247, '2019-03-06', 288, NULL),
('Hilton Downtown', 247, '2019-03-07', 302, NULL),
('Hilton Downtown', 247, '2019-03-08', 309, NULL),
('Hilton Downtown', 247, '2019-03-09', 363, NULL),
('Hilton Downtown', 247, '2019-03-10', 256, NULL),
('Hilton Downtown', 247, '2019-03-11', 157, NULL),
('Hilton Downtown', 247, '2019-03-12', 258, NULL),
('Hilton Downtown', 247, '2019-03-13', 332, NULL),
('Hilton Downtown', 247, '2019-03-14', 306, NULL),
('Hilton Downtown', 247, '2019-03-15', 281, NULL),
('Hilton Downtown', 247, '2019-03-16', 358, NULL),
('Hilton Downtown', 247, '2019-03-17', 138, NULL),
('Hilton Downtown', 247, '2019-03-18', 169, NULL),
('Hilton Downtown', 247, '2019-03-19', 186, NULL),
('Hilton Downtown', 247, '2019-03-20', 200, NULL),
('Hilton Downtown', 247, '2019-03-21', 123, NULL),
('Hilton Downtown', 247, '2019-03-22', 302, NULL),
('Hilton Downtown', 247, '2019-03-23', 371, NULL),
('Hilton Downtown', 247, '2019-03-24', 134, NULL),
('Hilton Downtown', 247, '2019-03-25', 339, NULL),
('Hilton Downtown', 247, '2019-03-26', 230, NULL),
('Hilton Downtown', 247, '2019-03-27', 223, NULL),
('Hilton Downtown', 247, '2019-03-28', 232, NULL),
('Hilton Downtown', 247, '2019-03-29', 279, NULL),
('Hilton Downtown', 247, '2019-03-30', 341, NULL),
('Hilton Downtown', 247, '2019-03-31', 349, NULL),
('Hilton Downtown', 247, '2019-04-01', 243, NULL),
('Hilton Downtown', 247, '2019-04-02', 157, NULL),
('Hilton Downtown', 247, '2019-04-03', 367, NULL),
('Hilton Downtown', 247, '2019-04-04', 100, NULL),
('Hilton Downtown', 247, '2019-04-05', 361, NULL),
('Hilton Downtown', 247, '2019-04-06', 220, NULL),
('Hilton Downtown', 247, '2019-04-07', 384, NULL),
('Hilton Downtown', 247, '2019-04-08', 132, NULL),
('Hilton Downtown', 247, '2019-04-09', 384, NULL),
('Hilton Downtown', 247, '2019-04-10', 347, NULL),
('Hilton Downtown', 247, '2019-04-11', 109, NULL),
('Hilton Downtown', 247, '2019-04-12', 364, NULL),
('Hilton Downtown', 247, '2019-04-13', 148, NULL),
('Hilton Downtown', 247, '2019-04-14', 172, NULL),
('Hilton Downtown', 247, '2019-04-15', 170, NULL),
('Hilton Downtown', 247, '2019-04-16', 119, NULL),
('Hilton Downtown', 247, '2019-04-17', 374, NULL),
('Hilton Downtown', 247, '2019-04-18', 356, NULL),
('Hilton Downtown', 247, '2019-04-19', 167, NULL),
('Hilton Downtown', 247, '2019-04-20', 333, NULL),
('Hilton Downtown', 247, '2019-04-21', 265, NULL),
('Hilton Downtown', 247, '2019-04-22', 162, NULL),
('Hilton Downtown', 247, '2019-04-23', 104, NULL),
('Hilton Downtown', 247, '2019-04-24', 184, NULL),
('Hilton Downtown', 247, '2019-04-25', 171, NULL),
('Hilton Downtown', 247, '2019-04-26', 379, NULL),
('Hilton Downtown', 247, '2019-04-27', 187, NULL),
('Hilton Downtown', 247, '2019-04-28', 339, NULL),
('Hilton Downtown', 247, '2019-04-29', 190, NULL),
('Hilton Downtown', 247, '2019-04-30', 128, NULL),
('Hilton Downtown', 247, '2019-05-01', 229, NULL),
('Hilton Downtown', 247, '2019-05-02', 386, NULL),
('Hilton Downtown', 247, '2019-05-03', 280, NULL),
('Hilton Downtown', 247, '2019-05-04', 256, NULL),
('Hilton Downtown', 247, '2019-05-05', 207, NULL),
('Hilton Downtown', 247, '2019-05-06', 139, NULL),
('Hilton Downtown', 247, '2019-05-07', 109, NULL),
('Hilton Downtown', 247, '2019-05-08', 344, NULL),
('Hilton Downtown', 247, '2019-05-09', 107, NULL),
('Hilton Downtown', 247, '2019-05-10', 320, NULL),
('Hilton Downtown', 247, '2019-05-11', 301, NULL),
('Hilton Downtown', 247, '2019-05-12', 168, NULL),
('Hilton Downtown', 247, '2019-05-13', 124, NULL),
('Hilton Downtown', 247, '2019-05-14', 232, NULL),
('Hilton Downtown', 247, '2019-05-15', 260, NULL),
('Hilton Downtown', 247, '2019-05-16', 314, NULL),
('Hilton Downtown', 247, '2019-05-17', 314, NULL),
('Hilton Downtown', 247, '2019-05-18', 172, NULL),
('Hilton Downtown', 247, '2019-05-19', 201, NULL),
('Hilton Downtown', 247, '2019-05-20', 249, NULL),
('Hilton Downtown', 247, '2019-05-21', 272, NULL),
('Hilton Downtown', 247, '2019-05-22', 256, NULL),
('Hilton Downtown', 247, '2019-05-23', 389, NULL),
('Hilton Downtown', 247, '2019-05-24', 103, NULL),
('Hilton Downtown', 247, '2019-05-25', 318, NULL),
('Hilton Downtown', 247, '2019-05-26', 399, NULL),
('Hilton Downtown', 247, '2019-05-27', 210, NULL),
('Hilton Downtown', 247, '2019-05-28', 399, NULL),
('Hilton Downtown', 247, '2019-05-29', 119, NULL),
('Hilton Downtown', 247, '2019-05-30', 106, NULL),
('Hilton Downtown', 247, '2019-05-31', 139, NULL),
('Hilton Downtown', 247, '2019-06-01', 353, NULL),
('Hilton Downtown', 247, '2019-06-02', 278, NULL),
('Hilton Downtown', 247, '2019-06-03', 282, NULL),
('Hilton Downtown', 247, '2019-06-04', 223, NULL),
('Hilton Downtown', 247, '2019-06-05', 188, NULL),
('Hilton Downtown', 247, '2019-06-06', 128, NULL),
('Hilton Downtown', 247, '2019-06-07', 333, NULL),
('Hilton Downtown', 247, '2019-06-08', 312, NULL),
('Hilton Downtown', 247, '2019-06-09', 277, NULL),
('Hilton Downtown', 247, '2019-06-10', 240, NULL),
('Hilton Downtown', 247, '2019-06-11', 300, NULL),
('Hilton Downtown', 247, '2019-06-12', 378, NULL),
('Hilton Downtown', 247, '2019-06-13', 365, NULL),
('Hilton Downtown', 247, '2019-06-14', 136, NULL),
('Hilton Downtown', 247, '2019-06-15', 362, NULL),
('Hilton Downtown', 247, '2019-06-16', 396, NULL),
('Hilton Downtown', 247, '2019-06-17', 375, NULL),
('Hilton Downtown', 247, '2019-06-18', 161, NULL),
('Hilton Downtown', 247, '2019-06-19', 172, NULL),
('Hilton Downtown', 247, '2019-06-20', 161, NULL),
('Hilton Downtown', 247, '2019-06-21', 278, NULL),
('Hilton Downtown', 247, '2019-06-22', 223, NULL),
('Hilton Downtown', 247, '2019-06-23', 370, NULL),
('Hilton Downtown', 247, '2019-06-24', 207, NULL),
('Hilton Downtown', 247, '2019-06-25', 274, NULL),
('Hilton Downtown', 247, '2019-06-26', 398, NULL),
('Hilton Downtown', 247, '2019-06-27', 286, NULL),
('Hilton Downtown', 247, '2019-06-28', 145, NULL),
('Hilton Downtown', 247, '2019-06-29', 183, NULL),
('Hilton Downtown', 247, '2019-06-30', 224, NULL),
('Hilton Downtown', 247, '2019-07-01', 155, NULL),
('Hilton Downtown', 247, '2019-07-02', 395, NULL),
('Hilton Downtown', 247, '2019-07-03', 108, NULL),
('Hilton Downtown', 247, '2019-07-04', 124, NULL),
('Hilton Downtown', 247, '2019-07-05', 114, NULL),
('Hilton Downtown', 247, '2019-07-06', 109, NULL),
('Hilton Downtown', 247, '2019-07-07', 383, NULL),
('Hilton Downtown', 247, '2019-07-08', 233, NULL),
('Hilton Downtown', 247, '2019-07-09', 266, NULL),
('Hilton Downtown', 247, '2019-07-10', 382, NULL),
('Hilton Downtown', 247, '2019-07-11', 126, NULL),
('Hilton Downtown', 247, '2019-07-12', 146, NULL),
('Hilton Downtown', 247, '2019-07-13', 175, NULL),
('Hilton Downtown', 247, '2019-07-14', 260, NULL),
('Hilton Downtown', 247, '2019-07-15', 383, NULL),
('Hilton Downtown', 247, '2019-07-16', 215, NULL),
('Hilton Downtown', 247, '2019-07-17', 331, NULL),
('Hilton Downtown', 247, '2019-07-18', 145, NULL),
('Hilton Downtown', 247, '2019-07-19', 188, NULL),
('Hilton Downtown', 247, '2019-07-20', 277, NULL),
('Hilton Downtown', 247, '2019-07-21', 190, NULL),
('Hilton Downtown', 247, '2019-07-22', 314, NULL),
('Hilton Downtown', 247, '2019-07-23', 311, NULL),
('Hilton Downtown', 247, '2019-07-24', 368, NULL),
('Hilton Downtown', 247, '2019-07-25', 397, NULL),
('Hilton Downtown', 247, '2019-07-26', 280, NULL),
('Hilton Downtown', 247, '2019-07-27', 363, NULL),
('Hilton Downtown', 247, '2019-07-28', 151, NULL),
('Hilton Downtown', 247, '2019-07-29', 372, NULL),
('Hilton Downtown', 247, '2019-07-30', 321, NULL),
('Hilton Downtown', 247, '2019-07-31', 263, NULL),
('Hilton Downtown', 247, '2019-08-01', 185, NULL),
('Hilton Downtown', 247, '2019-08-02', 354, NULL),
('Hilton Downtown', 247, '2019-08-03', 386, NULL),
('Hilton Downtown', 247, '2019-08-04', 159, NULL),
('Hilton Downtown', 247, '2019-08-05', 281, NULL),
('Hilton Downtown', 247, '2019-08-06', 204, NULL),
('Hilton Downtown', 247, '2019-08-07', 216, NULL),
('Hilton Downtown', 247, '2019-08-08', 303, NULL),
('Hilton Downtown', 247, '2019-08-09', 227, NULL),
('Hilton Downtown', 247, '2019-08-10', 119, NULL),
('Hilton Downtown', 247, '2019-08-11', 291, NULL),
('Hilton Downtown', 247, '2019-08-12', 396, NULL),
('Hilton Downtown', 247, '2019-08-13', 132, NULL),
('Hilton Downtown', 247, '2019-08-14', 252, NULL),
('Hilton Downtown', 247, '2019-08-15', 320, NULL),
('Hilton Downtown', 247, '2019-08-16', 349, NULL),
('Hilton Downtown', 247, '2019-08-17', 119, NULL),
('Hilton Downtown', 247, '2019-08-18', 199, NULL),
('Hilton Downtown', 247, '2019-08-19', 198, NULL),
('Hilton Downtown', 247, '2019-08-20', 215, NULL),
('Hilton Downtown', 247, '2019-08-21', 280, NULL),
('Hilton Downtown', 247, '2019-08-22', 249, NULL),
('Hilton Downtown', 247, '2019-08-23', 118, NULL),
('Hilton Downtown', 247, '2019-08-24', 271, NULL),
('Hilton Downtown', 247, '2019-08-25', 215, NULL),
('Hilton Downtown', 247, '2019-08-26', 161, NULL),
('Hilton Downtown', 247, '2019-08-27', 210, NULL),
('Hilton Downtown', 247, '2019-08-28', 332, NULL),
('Hilton Downtown', 247, '2019-08-29', 145, NULL),
('Hilton Downtown', 247, '2019-08-30', 165, NULL),
('Hilton Downtown', 247, '2019-08-31', 356, NULL),
('Hilton Downtown', 247, '2019-09-01', 294, NULL),
('Hilton Downtown', 247, '2019-09-02', 276, NULL),
('Hilton Downtown', 247, '2019-09-03', 136, NULL),
('Hilton Downtown', 247, '2019-09-04', 228, NULL),
('Hilton Downtown', 247, '2019-09-05', 147, NULL),
('Hilton Downtown', 247, '2019-09-06', 225, NULL),
('Hilton Downtown', 247, '2019-09-07', 320, NULL),
('Hilton Downtown', 247, '2019-09-08', 111, NULL),
('Hilton Downtown', 247, '2019-09-09', 142, NULL),
('Hilton Downtown', 247, '2019-09-10', 383, NULL),
('Hilton Downtown', 247, '2019-09-11', 146, NULL),
('Hilton Downtown', 247, '2019-09-12', 213, NULL),
('Hilton Downtown', 247, '2019-09-13', 344, NULL),
('Hilton Downtown', 247, '2019-09-14', 244, NULL),
('Hilton Downtown', 247, '2019-09-15', 149, NULL),
('Hilton Downtown', 247, '2019-09-16', 260, NULL),
('Hilton Downtown', 247, '2019-09-17', 137, NULL),
('Hilton Downtown', 247, '2019-09-18', 308, NULL),
('Hilton Downtown', 247, '2019-09-19', 278, NULL),
('Hilton Downtown', 247, '2019-09-20', 275, NULL),
('Hilton Downtown', 247, '2019-09-21', 269, NULL),
('Hilton Downtown', 247, '2019-09-22', 358, NULL),
('Hilton Downtown', 247, '2019-09-23', 341, NULL),
('Hilton Downtown', 247, '2019-09-24', 260, NULL),
('Hilton Downtown', 247, '2019-09-25', 221, NULL),
('Hilton Downtown', 247, '2019-09-26', 293, NULL),
('Hilton Downtown', 247, '2019-09-27', 115, NULL),
('Hilton Downtown', 247, '2019-09-28', 324, NULL),
('Hilton Downtown', 247, '2019-09-29', 149, NULL),
('Hilton Downtown', 247, '2019-09-30', 372, NULL),
('Hilton Downtown', 247, '2019-10-01', 119, NULL),
('Hilton Downtown', 247, '2019-10-02', 156, NULL),
('Hilton Downtown', 247, '2019-10-03', 331, NULL),
('Hilton Downtown', 247, '2019-10-04', 232, NULL),
('Hilton Downtown', 247, '2019-10-05', 321, NULL),
('Hilton Downtown', 247, '2019-10-06', 139, NULL),
('Hilton Downtown', 247, '2019-10-07', 128, NULL),
('Hilton Downtown', 247, '2019-10-08', 300, NULL),
('Hilton Downtown', 247, '2019-10-09', 375, NULL),
('Hilton Downtown', 247, '2019-10-10', 311, NULL),
('Hilton Downtown', 247, '2019-10-11', 241, NULL),
('Hilton Downtown', 247, '2019-10-12', 179, NULL),
('Hilton Downtown', 247, '2019-10-13', 252, NULL),
('Hilton Downtown', 247, '2019-10-14', 197, NULL),
('Hilton Downtown', 247, '2019-10-15', 137, NULL),
('Hilton Downtown', 247, '2019-10-16', 143, NULL),
('Hilton Downtown', 247, '2019-10-17', 212, NULL),
('Hilton Downtown', 247, '2019-10-18', 198, NULL),
('Hilton Downtown', 247, '2019-10-19', 371, NULL),
('Hilton Downtown', 247, '2019-10-20', 268, NULL),
('Hilton Downtown', 247, '2019-10-21', 173, NULL),
('Hilton Downtown', 247, '2019-10-22', 210, NULL),
('Hilton Downtown', 247, '2019-10-23', 305, NULL),
('Hilton Downtown', 247, '2019-10-24', 354, NULL),
('Hilton Downtown', 247, '2019-10-25', 122, NULL),
('Hilton Downtown', 247, '2019-10-26', 199, NULL),
('Hilton Downtown', 247, '2019-10-27', 268, NULL),
('Hilton Downtown', 247, '2019-10-28', 239, NULL),
('Hilton Downtown', 247, '2019-10-29', 267, NULL),
('Hilton Downtown', 247, '2019-10-30', 126, NULL),
('Hilton Downtown', 247, '2019-10-31', 146, NULL),
('Hilton Downtown', 247, '2019-11-01', 103, NULL),
('Hilton Downtown', 247, '2019-11-02', 278, NULL),
('Hilton Downtown', 247, '2019-11-03', 299, NULL),
('Hilton Downtown', 247, '2019-11-04', 233, NULL),
('Hilton Downtown', 247, '2019-11-05', 398, NULL),
('Hilton Downtown', 247, '2019-11-06', 298, NULL),
('Hilton Downtown', 247, '2019-11-07', 225, NULL),
('Hilton Downtown', 247, '2019-11-08', 319, NULL),
('Hilton Downtown', 247, '2019-11-09', 126, NULL),
('Hilton Downtown', 247, '2019-11-10', 357, NULL),
('Hilton Downtown', 247, '2019-11-11', 166, NULL),
('Hilton Downtown', 247, '2019-11-12', 107, NULL),
('Hilton Downtown', 247, '2019-11-13', 267, NULL),
('Hilton Downtown', 247, '2019-11-14', 222, NULL),
('Hilton Downtown', 247, '2019-11-15', 320, NULL),
('Hilton Downtown', 247, '2019-11-16', 361, NULL),
('Hilton Downtown', 247, '2019-11-17', 297, NULL),
('Hilton Downtown', 247, '2019-11-18', 359, NULL),
('Hilton Downtown', 247, '2019-11-19', 142, NULL),
('Hilton Downtown', 247, '2019-11-20', 133, NULL),
('Hilton Downtown', 247, '2019-11-21', 262, NULL),
('Hilton Downtown', 247, '2019-11-22', 233, NULL),
('Hilton Downtown', 247, '2019-11-23', 219, NULL),
('Hilton Downtown', 247, '2019-11-24', 335, NULL),
('Hilton Downtown', 247, '2019-11-25', 106, NULL),
('Hilton Downtown', 247, '2019-11-26', 168, NULL),
('Hilton Downtown', 247, '2019-11-27', 206, NULL),
('Hilton Downtown', 247, '2019-11-28', 153, NULL),
('Hilton Downtown', 247, '2019-11-29', 217, NULL),
('Hilton Downtown', 247, '2019-11-30', 396, NULL),
('Hilton Downtown', 247, '2019-12-01', 314, NULL),
('Hilton Downtown', 247, '2019-12-02', 300, NULL),
('Hilton Downtown', 247, '2019-12-03', 396, NULL),
('Hilton Downtown', 247, '2019-12-04', 396, NULL),
('Hilton Downtown', 247, '2019-12-05', 236, NULL),
('Hilton Downtown', 247, '2019-12-06', 351, NULL),
('Hilton Downtown', 247, '2019-12-07', 344, NULL),
('Hilton Downtown', 247, '2019-12-08', 397, NULL),
('Hilton Downtown', 247, '2019-12-09', 353, NULL),
('Hilton Downtown', 247, '2019-12-10', 117, NULL),
('Hilton Downtown', 247, '2019-12-11', 261, NULL),
('Hilton Downtown', 247, '2019-12-12', 259, NULL),
('Hilton Downtown', 247, '2019-12-13', 175, NULL),
('Hilton Downtown', 247, '2019-12-14', 136, NULL),
('Hilton Downtown', 247, '2019-12-15', 389, NULL),
('Hilton Downtown', 247, '2019-12-16', 211, NULL),
('Hilton Downtown', 247, '2019-12-17', 175, NULL),
('Hilton Downtown', 247, '2019-12-18', 188, NULL),
('Hilton Downtown', 247, '2019-12-19', 351, NULL),
('Hilton Downtown', 247, '2019-12-20', 241, NULL),
('Hilton Downtown', 247, '2019-12-21', 242, NULL),
('Hilton Downtown', 247, '2019-12-22', 349, NULL),
('Hilton Downtown', 247, '2019-12-23', 211, NULL),
('Hilton Downtown', 247, '2019-12-24', 366, NULL),
('Hilton Downtown', 247, '2019-12-25', 120, NULL),
('Hilton Downtown', 247, '2019-12-26', 239, NULL),
('Hilton Downtown', 247, '2019-12-27', 161, NULL),
('Hilton Downtown', 247, '2019-12-28', 181, NULL),
('Hilton Downtown', 247, '2019-12-29', 112, NULL),
('Hilton Downtown', 247, '2019-12-30', 310, NULL),
('Hilton Downtown', 247, '2019-12-31', 137, NULL),
('Hilton Downtown', 247, '2020-01-01', 369, NULL),
('Hilton Downtown', 247, '2020-01-02', 347, NULL),
('Hilton Downtown', 247, '2020-01-03', 381, NULL),
('Hilton Downtown', 247, '2020-01-04', 381, NULL),
('Hilton Downtown', 247, '2020-01-05', 177, NULL),
('Hilton Downtown', 247, '2020-01-06', 132, NULL),
('Hilton Downtown', 247, '2020-01-07', 147, NULL),
('Hilton Downtown', 247, '2020-01-08', 200, NULL),
('Hilton Downtown', 247, '2020-01-09', 167, NULL),
('Hilton Downtown', 247, '2020-01-10', 243, NULL),
('Hilton Downtown', 247, '2020-01-11', 318, NULL),
('Hilton Downtown', 247, '2020-01-12', 227, NULL),
('Hilton Downtown', 247, '2020-01-13', 254, NULL),
('Hilton Downtown', 247, '2020-01-14', 160, NULL),
('Hilton Downtown', 247, '2020-01-15', 299, NULL),
('Hilton Downtown', 247, '2020-01-16', 386, NULL),
('Hilton Downtown', 247, '2020-01-17', 257, NULL),
('Hilton Downtown', 247, '2020-01-18', 317, NULL),
('Hilton Downtown', 247, '2020-01-19', 108, NULL),
('Hilton Downtown', 247, '2020-01-20', 117, NULL),
('Hilton Downtown', 247, '2020-01-21', 366, NULL),
('Hilton Downtown', 247, '2020-01-22', 147, NULL),
('Hilton Downtown', 247, '2020-01-23', 383, NULL),
('Hilton Downtown', 247, '2020-01-24', 107, NULL),
('Hilton Downtown', 247, '2020-01-25', 375, NULL),
('Hilton Downtown', 247, '2020-01-26', 163, NULL),
('Hilton Downtown', 247, '2020-01-27', 399, NULL),
('Hilton Downtown', 247, '2020-01-28', 353, NULL),
('Hilton Downtown', 247, '2020-01-29', 293, NULL),
('Hilton Downtown', 247, '2020-01-30', 233, NULL),
('Hilton Downtown', 247, '2020-01-31', 277, NULL),
('Hilton Downtown', 247, '2020-02-01', 394, NULL),
('Hilton Downtown', 247, '2020-02-02', 383, NULL),
('Hilton Downtown', 247, '2020-02-03', 136, NULL),
('Hilton Downtown', 247, '2020-02-04', 135, NULL),
('Hilton Downtown', 250, '2019-01-01', 140, NULL),
('Hilton Downtown', 250, '2019-01-02', 162, NULL),
('Hilton Downtown', 250, '2019-01-03', 212, NULL),
('Hilton Downtown', 250, '2019-01-04', 314, NULL),
('Hilton Downtown', 250, '2019-01-05', 184, NULL),
('Hilton Downtown', 250, '2019-01-06', 182, NULL),
('Hilton Downtown', 250, '2019-01-07', 359, NULL),
('Hilton Downtown', 250, '2019-01-08', 300, NULL),
('Hilton Downtown', 250, '2019-01-09', 128, NULL),
('Hilton Downtown', 250, '2019-01-10', 274, NULL),
('Hilton Downtown', 250, '2019-01-11', 336, NULL),
('Hilton Downtown', 250, '2019-01-12', 306, NULL),
('Hilton Downtown', 250, '2019-01-13', 221, NULL),
('Hilton Downtown', 250, '2019-01-14', 252, NULL),
('Hilton Downtown', 250, '2019-01-15', 367, NULL),
('Hilton Downtown', 250, '2019-01-16', 392, NULL),
('Hilton Downtown', 250, '2019-01-17', 135, NULL),
('Hilton Downtown', 250, '2019-01-18', 224, NULL),
('Hilton Downtown', 250, '2019-01-19', 210, NULL),
('Hilton Downtown', 250, '2019-01-20', 293, NULL),
('Hilton Downtown', 250, '2019-01-21', 100, NULL),
('Hilton Downtown', 250, '2019-01-22', 395, NULL),
('Hilton Downtown', 250, '2019-01-23', 313, NULL),
('Hilton Downtown', 250, '2019-01-24', 392, NULL),
('Hilton Downtown', 250, '2019-01-25', 103, NULL),
('Hilton Downtown', 250, '2019-01-26', 252, NULL),
('Hilton Downtown', 250, '2019-01-27', 230, NULL),
('Hilton Downtown', 250, '2019-01-28', 381, NULL),
('Hilton Downtown', 250, '2019-01-29', 251, NULL),
('Hilton Downtown', 250, '2019-01-30', 297, NULL),
('Hilton Downtown', 250, '2019-01-31', 245, NULL),
('Hilton Downtown', 250, '2019-02-01', 382, NULL),
('Hilton Downtown', 250, '2019-02-02', 258, NULL),
('Hilton Downtown', 250, '2019-02-03', 280, NULL),
('Hilton Downtown', 250, '2019-02-04', 195, NULL),
('Hilton Downtown', 250, '2019-02-05', 254, NULL),
('Hilton Downtown', 250, '2019-02-06', 159, NULL),
('Hilton Downtown', 250, '2019-02-07', 386, NULL),
('Hilton Downtown', 250, '2019-02-08', 367, NULL),
('Hilton Downtown', 250, '2019-02-09', 313, NULL),
('Hilton Downtown', 250, '2019-02-10', 277, NULL),
('Hilton Downtown', 250, '2019-02-11', 376, NULL),
('Hilton Downtown', 250, '2019-02-12', 266, NULL),
('Hilton Downtown', 250, '2019-02-13', 154, NULL),
('Hilton Downtown', 250, '2019-02-14', 326, NULL),
('Hilton Downtown', 250, '2019-02-15', 339, NULL),
('Hilton Downtown', 250, '2019-02-16', 141, NULL),
('Hilton Downtown', 250, '2019-02-17', 183, NULL),
('Hilton Downtown', 250, '2019-02-18', 345, NULL),
('Hilton Downtown', 250, '2019-02-19', 115, NULL),
('Hilton Downtown', 250, '2019-02-20', 234, NULL),
('Hilton Downtown', 250, '2019-02-21', 346, NULL),
('Hilton Downtown', 250, '2019-02-22', 139, NULL),
('Hilton Downtown', 250, '2019-02-23', 348, NULL),
('Hilton Downtown', 250, '2019-02-24', 206, NULL),
('Hilton Downtown', 250, '2019-02-25', 285, NULL),
('Hilton Downtown', 250, '2019-02-26', 128, NULL),
('Hilton Downtown', 250, '2019-02-27', 213, NULL),
('Hilton Downtown', 250, '2019-02-28', 262, NULL),
('Hilton Downtown', 250, '2019-03-01', 318, NULL),
('Hilton Downtown', 250, '2019-03-02', 212, NULL),
('Hilton Downtown', 250, '2019-03-03', 358, NULL),
('Hilton Downtown', 250, '2019-03-04', 332, NULL),
('Hilton Downtown', 250, '2019-03-05', 151, NULL),
('Hilton Downtown', 250, '2019-03-06', 173, NULL),
('Hilton Downtown', 250, '2019-03-07', 381, NULL),
('Hilton Downtown', 250, '2019-03-08', 284, NULL),
('Hilton Downtown', 250, '2019-03-09', 304, NULL),
('Hilton Downtown', 250, '2019-03-10', 222, NULL),
('Hilton Downtown', 250, '2019-03-11', 362, NULL),
('Hilton Downtown', 250, '2019-03-12', 209, NULL),
('Hilton Downtown', 250, '2019-03-13', 333, NULL),
('Hilton Downtown', 250, '2019-03-14', 354, NULL),
('Hilton Downtown', 250, '2019-03-15', 270, NULL),
('Hilton Downtown', 250, '2019-03-16', 221, NULL),
('Hilton Downtown', 250, '2019-03-17', 139, NULL),
('Hilton Downtown', 250, '2019-03-18', 228, NULL),
('Hilton Downtown', 250, '2019-03-19', 316, NULL),
('Hilton Downtown', 250, '2019-03-20', 304, NULL),
('Hilton Downtown', 250, '2019-03-21', 200, NULL),
('Hilton Downtown', 250, '2019-03-22', 316, NULL),
('Hilton Downtown', 250, '2019-03-23', 338, NULL),
('Hilton Downtown', 250, '2019-03-24', 226, NULL),
('Hilton Downtown', 250, '2019-03-25', 257, NULL),
('Hilton Downtown', 250, '2019-03-26', 220, NULL),
('Hilton Downtown', 250, '2019-03-27', 376, NULL),
('Hilton Downtown', 250, '2019-03-28', 238, NULL),
('Hilton Downtown', 250, '2019-03-29', 194, NULL),
('Hilton Downtown', 250, '2019-03-30', 117, NULL),
('Hilton Downtown', 250, '2019-03-31', 334, NULL),
('Hilton Downtown', 250, '2019-04-01', 173, NULL),
('Hilton Downtown', 250, '2019-04-02', 257, NULL),
('Hilton Downtown', 250, '2019-04-03', 193, NULL),
('Hilton Downtown', 250, '2019-04-04', 300, NULL),
('Hilton Downtown', 250, '2019-04-05', 254, NULL),
('Hilton Downtown', 250, '2019-04-06', 294, NULL),
('Hilton Downtown', 250, '2019-04-07', 133, NULL),
('Hilton Downtown', 250, '2019-04-08', 291, NULL),
('Hilton Downtown', 250, '2019-04-09', 178, NULL),
('Hilton Downtown', 250, '2019-04-10', 221, NULL),
('Hilton Downtown', 250, '2019-04-11', 317, NULL),
('Hilton Downtown', 250, '2019-04-12', 191, NULL),
('Hilton Downtown', 250, '2019-04-13', 146, NULL),
('Hilton Downtown', 250, '2019-04-14', 356, NULL),
('Hilton Downtown', 250, '2019-04-15', 354, NULL),
('Hilton Downtown', 250, '2019-04-16', 147, NULL),
('Hilton Downtown', 250, '2019-04-17', 160, NULL),
('Hilton Downtown', 250, '2019-04-18', 161, NULL),
('Hilton Downtown', 250, '2019-04-19', 101, NULL),
('Hilton Downtown', 250, '2019-04-20', 231, NULL),
('Hilton Downtown', 250, '2019-04-21', 264, NULL),
('Hilton Downtown', 250, '2019-04-22', 308, NULL),
('Hilton Downtown', 250, '2019-04-23', 149, NULL),
('Hilton Downtown', 250, '2019-04-24', 308, NULL),
('Hilton Downtown', 250, '2019-04-25', 262, NULL),
('Hilton Downtown', 250, '2019-04-26', 339, NULL),
('Hilton Downtown', 250, '2019-04-27', 380, NULL),
('Hilton Downtown', 250, '2019-04-28', 150, NULL),
('Hilton Downtown', 250, '2019-04-29', 379, NULL),
('Hilton Downtown', 250, '2019-04-30', 289, NULL),
('Hilton Downtown', 250, '2019-05-01', 220, NULL),
('Hilton Downtown', 250, '2019-05-02', 259, NULL),
('Hilton Downtown', 250, '2019-05-03', 308, NULL),
('Hilton Downtown', 250, '2019-05-04', 325, NULL),
('Hilton Downtown', 250, '2019-05-05', 215, NULL),
('Hilton Downtown', 250, '2019-05-06', 211, NULL),
('Hilton Downtown', 250, '2019-05-07', 337, NULL),
('Hilton Downtown', 250, '2019-05-08', 292, NULL),
('Hilton Downtown', 250, '2019-05-09', 207, NULL),
('Hilton Downtown', 250, '2019-05-10', 394, NULL),
('Hilton Downtown', 250, '2019-05-11', 242, NULL),
('Hilton Downtown', 250, '2019-05-12', 324, NULL),
('Hilton Downtown', 250, '2019-05-13', 243, NULL),
('Hilton Downtown', 250, '2019-05-14', 244, NULL),
('Hilton Downtown', 250, '2019-05-15', 175, NULL),
('Hilton Downtown', 250, '2019-05-16', 364, NULL),
('Hilton Downtown', 250, '2019-05-17', 340, NULL),
('Hilton Downtown', 250, '2019-05-18', 201, NULL),
('Hilton Downtown', 250, '2019-05-19', 362, NULL),
('Hilton Downtown', 250, '2019-05-20', 377, NULL),
('Hilton Downtown', 250, '2019-05-21', 355, NULL),
('Hilton Downtown', 250, '2019-05-22', 188, NULL),
('Hilton Downtown', 250, '2019-05-23', 167, NULL),
('Hilton Downtown', 250, '2019-05-24', 350, NULL),
('Hilton Downtown', 250, '2019-05-25', 138, NULL),
('Hilton Downtown', 250, '2019-05-26', 216, NULL),
('Hilton Downtown', 250, '2019-05-27', 225, NULL),
('Hilton Downtown', 250, '2019-05-28', 283, NULL),
('Hilton Downtown', 250, '2019-05-29', 215, NULL),
('Hilton Downtown', 250, '2019-05-30', 327, NULL),
('Hilton Downtown', 250, '2019-05-31', 258, NULL),
('Hilton Downtown', 250, '2019-06-01', 232, NULL),
('Hilton Downtown', 250, '2019-06-02', 288, NULL),
('Hilton Downtown', 250, '2019-06-03', 360, NULL),
('Hilton Downtown', 250, '2019-06-04', 386, NULL),
('Hilton Downtown', 250, '2019-06-05', 323, NULL),
('Hilton Downtown', 250, '2019-06-06', 348, NULL),
('Hilton Downtown', 250, '2019-06-07', 180, NULL),
('Hilton Downtown', 250, '2019-06-08', 384, NULL),
('Hilton Downtown', 250, '2019-06-09', 175, NULL),
('Hilton Downtown', 250, '2019-06-10', 210, NULL),
('Hilton Downtown', 250, '2019-06-11', 354, NULL),
('Hilton Downtown', 250, '2019-06-12', 134, NULL),
('Hilton Downtown', 250, '2019-06-13', 291, NULL),
('Hilton Downtown', 250, '2019-06-14', 329, NULL),
('Hilton Downtown', 250, '2019-06-15', 269, NULL),
('Hilton Downtown', 250, '2019-06-16', 302, NULL),
('Hilton Downtown', 250, '2019-06-17', 192, NULL),
('Hilton Downtown', 250, '2019-06-18', 190, NULL),
('Hilton Downtown', 250, '2019-06-19', 190, NULL),
('Hilton Downtown', 250, '2019-06-20', 192, NULL),
('Hilton Downtown', 250, '2019-06-21', 218, NULL),
('Hilton Downtown', 250, '2019-06-22', 349, NULL),
('Hilton Downtown', 250, '2019-06-23', 268, NULL),
('Hilton Downtown', 250, '2019-06-24', 362, NULL),
('Hilton Downtown', 250, '2019-06-25', 319, NULL),
('Hilton Downtown', 250, '2019-06-26', 142, NULL),
('Hilton Downtown', 250, '2019-06-27', 357, NULL),
('Hilton Downtown', 250, '2019-06-28', 358, NULL),
('Hilton Downtown', 250, '2019-06-29', 263, NULL),
('Hilton Downtown', 250, '2019-06-30', 247, NULL),
('Hilton Downtown', 250, '2019-07-01', 149, NULL),
('Hilton Downtown', 250, '2019-07-02', 378, NULL),
('Hilton Downtown', 250, '2019-07-03', 342, NULL),
('Hilton Downtown', 250, '2019-07-04', 104, NULL),
('Hilton Downtown', 250, '2019-07-05', 316, NULL),
('Hilton Downtown', 250, '2019-07-06', 130, NULL),
('Hilton Downtown', 250, '2019-07-07', 240, NULL),
('Hilton Downtown', 250, '2019-07-08', 135, NULL),
('Hilton Downtown', 250, '2019-07-09', 104, NULL),
('Hilton Downtown', 250, '2019-07-10', 150, NULL),
('Hilton Downtown', 250, '2019-07-11', 133, NULL),
('Hilton Downtown', 250, '2019-07-12', 393, NULL),
('Hilton Downtown', 250, '2019-07-13', 306, NULL),
('Hilton Downtown', 250, '2019-07-14', 234, NULL),
('Hilton Downtown', 250, '2019-07-15', 348, NULL),
('Hilton Downtown', 250, '2019-07-16', 335, NULL),
('Hilton Downtown', 250, '2019-07-17', 147, NULL),
('Hilton Downtown', 250, '2019-07-18', 373, NULL),
('Hilton Downtown', 250, '2019-07-19', 355, NULL),
('Hilton Downtown', 250, '2019-07-20', 124, NULL),
('Hilton Downtown', 250, '2019-07-21', 374, NULL),
('Hilton Downtown', 250, '2019-07-22', 332, NULL),
('Hilton Downtown', 250, '2019-07-23', 118, NULL),
('Hilton Downtown', 250, '2019-07-24', 128, NULL),
('Hilton Downtown', 250, '2019-07-25', 378, NULL),
('Hilton Downtown', 250, '2019-07-26', 370, NULL),
('Hilton Downtown', 250, '2019-07-27', 206, NULL),
('Hilton Downtown', 250, '2019-07-28', 392, NULL),
('Hilton Downtown', 250, '2019-07-29', 250, NULL),
('Hilton Downtown', 250, '2019-07-30', 211, NULL),
('Hilton Downtown', 250, '2019-07-31', 122, NULL),
('Hilton Downtown', 250, '2019-08-01', 267, NULL),
('Hilton Downtown', 250, '2019-08-02', 193, NULL),
('Hilton Downtown', 250, '2019-08-03', 388, NULL),
('Hilton Downtown', 250, '2019-08-04', 369, NULL),
('Hilton Downtown', 250, '2019-08-05', 184, NULL),
('Hilton Downtown', 250, '2019-08-06', 241, NULL),
('Hilton Downtown', 250, '2019-08-07', 134, NULL),
('Hilton Downtown', 250, '2019-08-08', 272, NULL),
('Hilton Downtown', 250, '2019-08-09', 361, NULL),
('Hilton Downtown', 250, '2019-08-10', 127, NULL),
('Hilton Downtown', 250, '2019-08-11', 348, NULL),
('Hilton Downtown', 250, '2019-08-12', 125, NULL),
('Hilton Downtown', 250, '2019-08-13', 392, NULL),
('Hilton Downtown', 250, '2019-08-14', 132, NULL),
('Hilton Downtown', 250, '2019-08-15', 349, NULL),
('Hilton Downtown', 250, '2019-08-16', 390, NULL),
('Hilton Downtown', 250, '2019-08-17', 333, NULL),
('Hilton Downtown', 250, '2019-08-18', 329, NULL),
('Hilton Downtown', 250, '2019-08-19', 152, NULL),
('Hilton Downtown', 250, '2019-08-20', 262, NULL),
('Hilton Downtown', 250, '2019-08-21', 264, NULL),
('Hilton Downtown', 250, '2019-08-22', 345, NULL),
('Hilton Downtown', 250, '2019-08-23', 231, NULL),
('Hilton Downtown', 250, '2019-08-24', 327, NULL),
('Hilton Downtown', 250, '2019-08-25', 243, NULL),
('Hilton Downtown', 250, '2019-08-26', 276, NULL),
('Hilton Downtown', 250, '2019-08-27', 103, NULL),
('Hilton Downtown', 250, '2019-08-28', 167, NULL),
('Hilton Downtown', 250, '2019-08-29', 290, NULL),
('Hilton Downtown', 250, '2019-08-30', 384, NULL),
('Hilton Downtown', 250, '2019-08-31', 317, NULL),
('Hilton Downtown', 250, '2019-09-01', 318, NULL),
('Hilton Downtown', 250, '2019-09-02', 280, NULL),
('Hilton Downtown', 250, '2019-09-03', 379, NULL),
('Hilton Downtown', 250, '2019-09-04', 192, NULL),
('Hilton Downtown', 250, '2019-09-05', 300, NULL),
('Hilton Downtown', 250, '2019-09-06', 387, NULL),
('Hilton Downtown', 250, '2019-09-07', 192, NULL),
('Hilton Downtown', 250, '2019-09-08', 112, NULL),
('Hilton Downtown', 250, '2019-09-09', 299, NULL),
('Hilton Downtown', 250, '2019-09-10', 110, NULL),
('Hilton Downtown', 250, '2019-09-11', 210, NULL),
('Hilton Downtown', 250, '2019-09-12', 315, NULL),
('Hilton Downtown', 250, '2019-09-13', 324, NULL),
('Hilton Downtown', 250, '2019-09-14', 115, NULL),
('Hilton Downtown', 250, '2019-09-15', 187, NULL),
('Hilton Downtown', 250, '2019-09-16', 247, NULL),
('Hilton Downtown', 250, '2019-09-17', 375, NULL),
('Hilton Downtown', 250, '2019-09-18', 110, NULL),
('Hilton Downtown', 250, '2019-09-19', 197, NULL),
('Hilton Downtown', 250, '2019-09-20', 348, NULL),
('Hilton Downtown', 250, '2019-09-21', 164, NULL),
('Hilton Downtown', 250, '2019-09-22', 310, NULL),
('Hilton Downtown', 250, '2019-09-23', 287, NULL),
('Hilton Downtown', 250, '2019-09-24', 325, NULL),
('Hilton Downtown', 250, '2019-09-25', 310, NULL),
('Hilton Downtown', 250, '2019-09-26', 108, NULL),
('Hilton Downtown', 250, '2019-09-27', 356, NULL),
('Hilton Downtown', 250, '2019-09-28', 187, NULL),
('Hilton Downtown', 250, '2019-09-29', 345, NULL),
('Hilton Downtown', 250, '2019-09-30', 117, NULL),
('Hilton Downtown', 250, '2019-10-01', 149, NULL),
('Hilton Downtown', 250, '2019-10-02', 276, NULL),
('Hilton Downtown', 250, '2019-10-03', 238, NULL),
('Hilton Downtown', 250, '2019-10-04', 335, NULL),
('Hilton Downtown', 250, '2019-10-05', 281, NULL),
('Hilton Downtown', 250, '2019-10-06', 382, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hilton Downtown', 250, '2019-10-07', 109, NULL),
('Hilton Downtown', 250, '2019-10-08', 287, NULL),
('Hilton Downtown', 250, '2019-10-09', 263, NULL),
('Hilton Downtown', 250, '2019-10-10', 278, NULL),
('Hilton Downtown', 250, '2019-10-11', 391, NULL),
('Hilton Downtown', 250, '2019-10-12', 272, NULL),
('Hilton Downtown', 250, '2019-10-13', 377, NULL),
('Hilton Downtown', 250, '2019-10-14', 278, NULL),
('Hilton Downtown', 250, '2019-10-15', 381, NULL),
('Hilton Downtown', 250, '2019-10-16', 265, NULL),
('Hilton Downtown', 250, '2019-10-17', 189, NULL),
('Hilton Downtown', 250, '2019-10-18', 386, NULL),
('Hilton Downtown', 250, '2019-10-19', 391, NULL),
('Hilton Downtown', 250, '2019-10-20', 295, NULL),
('Hilton Downtown', 250, '2019-10-21', 234, NULL),
('Hilton Downtown', 250, '2019-10-22', 252, NULL),
('Hilton Downtown', 250, '2019-10-23', 114, NULL),
('Hilton Downtown', 250, '2019-10-24', 306, NULL),
('Hilton Downtown', 250, '2019-10-25', 197, NULL),
('Hilton Downtown', 250, '2019-10-26', 140, NULL),
('Hilton Downtown', 250, '2019-10-27', 280, NULL),
('Hilton Downtown', 250, '2019-10-28', 355, NULL),
('Hilton Downtown', 250, '2019-10-29', 171, NULL),
('Hilton Downtown', 250, '2019-10-30', 207, NULL),
('Hilton Downtown', 250, '2019-10-31', 282, NULL),
('Hilton Downtown', 250, '2019-11-01', 297, NULL),
('Hilton Downtown', 250, '2019-11-02', 360, NULL),
('Hilton Downtown', 250, '2019-11-03', 334, NULL),
('Hilton Downtown', 250, '2019-11-04', 304, NULL),
('Hilton Downtown', 250, '2019-11-05', 331, NULL),
('Hilton Downtown', 250, '2019-11-06', 146, NULL),
('Hilton Downtown', 250, '2019-11-07', 104, NULL),
('Hilton Downtown', 250, '2019-11-08', 383, NULL),
('Hilton Downtown', 250, '2019-11-09', 199, NULL),
('Hilton Downtown', 250, '2019-11-10', 394, NULL),
('Hilton Downtown', 250, '2019-11-11', 252, NULL),
('Hilton Downtown', 250, '2019-11-12', 116, NULL),
('Hilton Downtown', 250, '2019-11-13', 103, NULL),
('Hilton Downtown', 250, '2019-11-14', 344, NULL),
('Hilton Downtown', 250, '2019-11-15', 240, NULL),
('Hilton Downtown', 250, '2019-11-16', 127, NULL),
('Hilton Downtown', 250, '2019-11-17', 106, NULL),
('Hilton Downtown', 250, '2019-11-18', 112, NULL),
('Hilton Downtown', 250, '2019-11-19', 292, NULL),
('Hilton Downtown', 250, '2019-11-20', 106, NULL),
('Hilton Downtown', 250, '2019-11-21', 250, NULL),
('Hilton Downtown', 250, '2019-11-22', 227, NULL),
('Hilton Downtown', 250, '2019-11-23', 299, NULL),
('Hilton Downtown', 250, '2019-11-24', 369, NULL),
('Hilton Downtown', 250, '2019-11-25', 268, NULL),
('Hilton Downtown', 250, '2019-11-26', 357, NULL),
('Hilton Downtown', 250, '2019-11-27', 300, NULL),
('Hilton Downtown', 250, '2019-11-28', 285, NULL),
('Hilton Downtown', 250, '2019-11-29', 368, NULL),
('Hilton Downtown', 250, '2019-11-30', 122, NULL),
('Hilton Downtown', 250, '2019-12-01', 313, NULL),
('Hilton Downtown', 250, '2019-12-02', 213, NULL),
('Hilton Downtown', 250, '2019-12-03', 234, NULL),
('Hilton Downtown', 250, '2019-12-04', 202, NULL),
('Hilton Downtown', 250, '2019-12-05', 266, NULL),
('Hilton Downtown', 250, '2019-12-06', 278, NULL),
('Hilton Downtown', 250, '2019-12-07', 240, NULL),
('Hilton Downtown', 250, '2019-12-08', 388, NULL),
('Hilton Downtown', 250, '2019-12-09', 220, NULL),
('Hilton Downtown', 250, '2019-12-10', 250, NULL),
('Hilton Downtown', 250, '2019-12-11', 203, NULL),
('Hilton Downtown', 250, '2019-12-12', 307, NULL),
('Hilton Downtown', 250, '2019-12-13', 210, NULL),
('Hilton Downtown', 250, '2019-12-14', 379, NULL),
('Hilton Downtown', 250, '2019-12-15', 322, NULL),
('Hilton Downtown', 250, '2019-12-16', 196, NULL),
('Hilton Downtown', 250, '2019-12-17', 121, NULL),
('Hilton Downtown', 250, '2019-12-18', 188, NULL),
('Hilton Downtown', 250, '2019-12-19', 171, NULL),
('Hilton Downtown', 250, '2019-12-20', 254, NULL),
('Hilton Downtown', 250, '2019-12-21', 262, NULL),
('Hilton Downtown', 250, '2019-12-22', 295, NULL),
('Hilton Downtown', 250, '2019-12-23', 133, NULL),
('Hilton Downtown', 250, '2019-12-24', 148, NULL),
('Hilton Downtown', 250, '2019-12-25', 206, NULL),
('Hilton Downtown', 250, '2019-12-26', 174, NULL),
('Hilton Downtown', 250, '2019-12-27', 289, NULL),
('Hilton Downtown', 250, '2019-12-28', 136, NULL),
('Hilton Downtown', 250, '2019-12-29', 370, NULL),
('Hilton Downtown', 250, '2019-12-30', 122, NULL),
('Hilton Downtown', 250, '2019-12-31', 336, NULL),
('Hilton Downtown', 250, '2020-01-01', 155, NULL),
('Hilton Downtown', 250, '2020-01-02', 227, NULL),
('Hilton Downtown', 250, '2020-01-03', 134, NULL),
('Hilton Downtown', 250, '2020-01-04', 196, NULL),
('Hilton Downtown', 250, '2020-01-05', 156, NULL),
('Hilton Downtown', 250, '2020-01-06', 249, NULL),
('Hilton Downtown', 250, '2020-01-07', 170, NULL),
('Hilton Downtown', 250, '2020-01-08', 322, NULL),
('Hilton Downtown', 250, '2020-01-09', 306, NULL),
('Hilton Downtown', 250, '2020-01-10', 240, NULL),
('Hilton Downtown', 250, '2020-01-11', 307, NULL),
('Hilton Downtown', 250, '2020-01-12', 300, NULL),
('Hilton Downtown', 250, '2020-01-13', 367, NULL),
('Hilton Downtown', 250, '2020-01-14', 265, NULL),
('Hilton Downtown', 250, '2020-01-15', 185, NULL),
('Hilton Downtown', 250, '2020-01-16', 253, NULL),
('Hilton Downtown', 250, '2020-01-17', 210, NULL),
('Hilton Downtown', 250, '2020-01-18', 355, NULL),
('Hilton Downtown', 250, '2020-01-19', 245, NULL),
('Hilton Downtown', 250, '2020-01-20', 139, NULL),
('Hilton Downtown', 250, '2020-01-21', 262, NULL),
('Hilton Downtown', 250, '2020-01-22', 264, NULL),
('Hilton Downtown', 250, '2020-01-23', 287, NULL),
('Hilton Downtown', 250, '2020-01-24', 299, NULL),
('Hilton Downtown', 250, '2020-01-25', 388, NULL),
('Hilton Downtown', 250, '2020-01-26', 309, NULL),
('Hilton Downtown', 250, '2020-01-27', 362, NULL),
('Hilton Downtown', 250, '2020-01-28', 100, NULL),
('Hilton Downtown', 250, '2020-01-29', 348, NULL),
('Hilton Downtown', 250, '2020-01-30', 370, NULL),
('Hilton Downtown', 250, '2020-01-31', 125, NULL),
('Hilton Downtown', 250, '2020-02-01', 340, NULL),
('Hilton Downtown', 250, '2020-02-02', 237, NULL),
('Hilton Downtown', 250, '2020-02-03', 239, NULL),
('Hilton Downtown', 250, '2020-02-04', 313, NULL),
('Hotel deLuxe', 5, '2019-01-01', 365, NULL),
('Hotel deLuxe', 5, '2019-01-02', 110, NULL),
('Hotel deLuxe', 5, '2019-01-03', 169, 135),
('Hotel deLuxe', 5, '2019-01-04', 333, 135),
('Hotel deLuxe', 5, '2019-01-05', 318, 135),
('Hotel deLuxe', 5, '2019-01-06', 215, NULL),
('Hotel deLuxe', 5, '2019-01-07', 352, NULL),
('Hotel deLuxe', 5, '2019-01-08', 286, NULL),
('Hotel deLuxe', 5, '2019-01-09', 325, NULL),
('Hotel deLuxe', 5, '2019-01-10', 167, NULL),
('Hotel deLuxe', 5, '2019-01-11', 375, NULL),
('Hotel deLuxe', 5, '2019-01-12', 226, 54),
('Hotel deLuxe', 5, '2019-01-13', 331, 54),
('Hotel deLuxe', 5, '2019-01-14', 339, 54),
('Hotel deLuxe', 5, '2019-01-15', 330, 54),
('Hotel deLuxe', 5, '2019-01-16', 297, 54),
('Hotel deLuxe', 5, '2019-01-17', 122, 54),
('Hotel deLuxe', 5, '2019-01-18', 224, NULL),
('Hotel deLuxe', 5, '2019-01-19', 195, NULL),
('Hotel deLuxe', 5, '2019-01-20', 344, NULL),
('Hotel deLuxe', 5, '2019-01-21', 305, NULL),
('Hotel deLuxe', 5, '2019-01-22', 394, NULL),
('Hotel deLuxe', 5, '2019-01-23', 191, NULL),
('Hotel deLuxe', 5, '2019-01-24', 330, NULL),
('Hotel deLuxe', 5, '2019-01-25', 258, NULL),
('Hotel deLuxe', 5, '2019-01-26', 330, NULL),
('Hotel deLuxe', 5, '2019-01-27', 256, NULL),
('Hotel deLuxe', 5, '2019-01-28', 332, NULL),
('Hotel deLuxe', 5, '2019-01-29', 122, NULL),
('Hotel deLuxe', 5, '2019-01-30', 127, NULL),
('Hotel deLuxe', 5, '2019-01-31', 383, NULL),
('Hotel deLuxe', 5, '2019-02-01', 330, NULL),
('Hotel deLuxe', 5, '2019-02-02', 231, NULL),
('Hotel deLuxe', 5, '2019-02-03', 234, NULL),
('Hotel deLuxe', 5, '2019-02-04', 165, NULL),
('Hotel deLuxe', 5, '2019-02-05', 200, NULL),
('Hotel deLuxe', 5, '2019-02-06', 166, NULL),
('Hotel deLuxe', 5, '2019-02-07', 129, NULL),
('Hotel deLuxe', 5, '2019-02-08', 210, NULL),
('Hotel deLuxe', 5, '2019-02-09', 223, NULL),
('Hotel deLuxe', 5, '2019-02-10', 202, NULL),
('Hotel deLuxe', 5, '2019-02-11', 270, NULL),
('Hotel deLuxe', 5, '2019-02-12', 365, NULL),
('Hotel deLuxe', 5, '2019-02-13', 113, NULL),
('Hotel deLuxe', 5, '2019-02-14', 304, NULL),
('Hotel deLuxe', 5, '2019-02-15', 293, NULL),
('Hotel deLuxe', 5, '2019-02-16', 330, NULL),
('Hotel deLuxe', 5, '2019-02-17', 305, NULL),
('Hotel deLuxe', 5, '2019-02-18', 140, NULL),
('Hotel deLuxe', 5, '2019-02-19', 357, NULL),
('Hotel deLuxe', 5, '2019-02-20', 202, NULL),
('Hotel deLuxe', 5, '2019-02-21', 259, NULL),
('Hotel deLuxe', 5, '2019-02-22', 178, NULL),
('Hotel deLuxe', 5, '2019-02-23', 314, NULL),
('Hotel deLuxe', 5, '2019-02-24', 196, NULL),
('Hotel deLuxe', 5, '2019-02-25', 135, NULL),
('Hotel deLuxe', 5, '2019-02-26', 320, NULL),
('Hotel deLuxe', 5, '2019-02-27', 259, NULL),
('Hotel deLuxe', 5, '2019-02-28', 154, NULL),
('Hotel deLuxe', 5, '2019-03-01', 380, NULL),
('Hotel deLuxe', 5, '2019-03-02', 313, NULL),
('Hotel deLuxe', 5, '2019-03-03', 102, NULL),
('Hotel deLuxe', 5, '2019-03-04', 180, NULL),
('Hotel deLuxe', 5, '2019-03-05', 146, NULL),
('Hotel deLuxe', 5, '2019-03-06', 199, NULL),
('Hotel deLuxe', 5, '2019-03-07', 300, NULL),
('Hotel deLuxe', 5, '2019-03-08', 394, 91),
('Hotel deLuxe', 5, '2019-03-09', 330, 91),
('Hotel deLuxe', 5, '2019-03-10', 242, 91),
('Hotel deLuxe', 5, '2019-03-11', 342, 91),
('Hotel deLuxe', 5, '2019-03-12', 172, 91),
('Hotel deLuxe', 5, '2019-03-13', 270, 91),
('Hotel deLuxe', 5, '2019-03-14', 155, 91),
('Hotel deLuxe', 5, '2019-03-15', 104, 91),
('Hotel deLuxe', 5, '2019-03-16', 231, NULL),
('Hotel deLuxe', 5, '2019-03-17', 184, NULL),
('Hotel deLuxe', 5, '2019-03-18', 234, NULL),
('Hotel deLuxe', 5, '2019-03-19', 325, 5),
('Hotel deLuxe', 5, '2019-03-20', 219, 5),
('Hotel deLuxe', 5, '2019-03-21', 234, 5),
('Hotel deLuxe', 5, '2019-03-22', 272, 5),
('Hotel deLuxe', 5, '2019-03-23', 177, 5),
('Hotel deLuxe', 5, '2019-03-24', 328, 5),
('Hotel deLuxe', 5, '2019-03-25', 168, 5),
('Hotel deLuxe', 5, '2019-03-26', 310, 5),
('Hotel deLuxe', 5, '2019-03-27', 209, 5),
('Hotel deLuxe', 5, '2019-03-28', 396, 5),
('Hotel deLuxe', 5, '2019-03-29', 334, 5),
('Hotel deLuxe', 5, '2019-03-30', 365, 5),
('Hotel deLuxe', 5, '2019-03-31', 224, 5),
('Hotel deLuxe', 5, '2019-04-01', 338, 5),
('Hotel deLuxe', 5, '2019-04-02', 113, 5),
('Hotel deLuxe', 5, '2019-04-03', 364, 5),
('Hotel deLuxe', 5, '2019-04-04', 198, 5),
('Hotel deLuxe', 5, '2019-04-05', 389, NULL),
('Hotel deLuxe', 5, '2019-04-06', 108, NULL),
('Hotel deLuxe', 5, '2019-04-07', 314, 76),
('Hotel deLuxe', 5, '2019-04-08', 359, 76),
('Hotel deLuxe', 5, '2019-04-09', 240, 76),
('Hotel deLuxe', 5, '2019-04-10', 266, 76),
('Hotel deLuxe', 5, '2019-04-11', 260, 76),
('Hotel deLuxe', 5, '2019-04-12', 362, 76),
('Hotel deLuxe', 5, '2019-04-13', 188, 76),
('Hotel deLuxe', 5, '2019-04-14', 265, 76),
('Hotel deLuxe', 5, '2019-04-15', 259, 76),
('Hotel deLuxe', 5, '2019-04-16', 278, 76),
('Hotel deLuxe', 5, '2019-04-17', 178, 76),
('Hotel deLuxe', 5, '2019-04-18', 238, 76),
('Hotel deLuxe', 5, '2019-04-19', 206, 76),
('Hotel deLuxe', 5, '2019-04-20', 360, 76),
('Hotel deLuxe', 5, '2019-04-21', 124, 76),
('Hotel deLuxe', 5, '2019-04-22', 352, 76),
('Hotel deLuxe', 5, '2019-04-23', 332, 76),
('Hotel deLuxe', 5, '2019-04-24', 288, 76),
('Hotel deLuxe', 5, '2019-04-25', 397, 76),
('Hotel deLuxe', 5, '2019-04-26', 158, 76),
('Hotel deLuxe', 5, '2019-04-27', 340, 76),
('Hotel deLuxe', 5, '2019-04-28', 235, 76),
('Hotel deLuxe', 5, '2019-04-29', 327, 76),
('Hotel deLuxe', 5, '2019-04-30', 364, 76),
('Hotel deLuxe', 5, '2019-05-01', 312, 76),
('Hotel deLuxe', 5, '2019-05-02', 336, 76),
('Hotel deLuxe', 5, '2019-05-03', 303, 76),
('Hotel deLuxe', 5, '2019-05-04', 156, 76),
('Hotel deLuxe', 5, '2019-05-05', 354, 76),
('Hotel deLuxe', 5, '2019-05-06', 237, NULL),
('Hotel deLuxe', 5, '2019-05-07', 358, NULL),
('Hotel deLuxe', 5, '2019-05-08', 329, NULL),
('Hotel deLuxe', 5, '2019-05-09', 312, NULL),
('Hotel deLuxe', 5, '2019-05-10', 311, NULL),
('Hotel deLuxe', 5, '2019-05-11', 207, NULL),
('Hotel deLuxe', 5, '2019-05-12', 118, NULL),
('Hotel deLuxe', 5, '2019-05-13', 143, NULL),
('Hotel deLuxe', 5, '2019-05-14', 122, NULL),
('Hotel deLuxe', 5, '2019-05-15', 293, NULL),
('Hotel deLuxe', 5, '2019-05-16', 179, NULL),
('Hotel deLuxe', 5, '2019-05-17', 356, NULL),
('Hotel deLuxe', 5, '2019-05-18', 386, NULL),
('Hotel deLuxe', 5, '2019-05-19', 208, NULL),
('Hotel deLuxe', 5, '2019-05-20', 139, 162),
('Hotel deLuxe', 5, '2019-05-21', 262, 162),
('Hotel deLuxe', 5, '2019-05-22', 373, 162),
('Hotel deLuxe', 5, '2019-05-23', 166, 162),
('Hotel deLuxe', 5, '2019-05-24', 142, 162),
('Hotel deLuxe', 5, '2019-05-25', 237, 162),
('Hotel deLuxe', 5, '2019-05-26', 382, 162),
('Hotel deLuxe', 5, '2019-05-27', 396, 162),
('Hotel deLuxe', 5, '2019-05-28', 116, 162),
('Hotel deLuxe', 5, '2019-05-29', 318, 162),
('Hotel deLuxe', 5, '2019-05-30', 319, 162),
('Hotel deLuxe', 5, '2019-05-31', 171, 162),
('Hotel deLuxe', 5, '2019-06-01', 299, 162),
('Hotel deLuxe', 5, '2019-06-02', 206, 162),
('Hotel deLuxe', 5, '2019-06-03', 257, 162),
('Hotel deLuxe', 5, '2019-06-04', 265, 162),
('Hotel deLuxe', 5, '2019-06-05', 353, 162),
('Hotel deLuxe', 5, '2019-06-06', 356, 162),
('Hotel deLuxe', 5, '2019-06-07', 102, 162),
('Hotel deLuxe', 5, '2019-06-08', 284, 27),
('Hotel deLuxe', 5, '2019-06-09', 244, 27),
('Hotel deLuxe', 5, '2019-06-10', 227, 27),
('Hotel deLuxe', 5, '2019-06-11', 172, 27),
('Hotel deLuxe', 5, '2019-06-12', 336, 27),
('Hotel deLuxe', 5, '2019-06-13', 258, 27),
('Hotel deLuxe', 5, '2019-06-14', 237, 27),
('Hotel deLuxe', 5, '2019-06-15', 158, 27),
('Hotel deLuxe', 5, '2019-06-16', 223, 27),
('Hotel deLuxe', 5, '2019-06-17', 336, 27),
('Hotel deLuxe', 5, '2019-06-18', 366, 27),
('Hotel deLuxe', 5, '2019-06-19', 337, 27),
('Hotel deLuxe', 5, '2019-06-20', 378, 27),
('Hotel deLuxe', 5, '2019-06-21', 157, 27),
('Hotel deLuxe', 5, '2019-06-22', 377, 27),
('Hotel deLuxe', 5, '2019-06-23', 133, 27),
('Hotel deLuxe', 5, '2019-06-24', 189, 27),
('Hotel deLuxe', 5, '2019-06-25', 376, 27),
('Hotel deLuxe', 5, '2019-06-26', 318, 27),
('Hotel deLuxe', 5, '2019-06-27', 227, 27),
('Hotel deLuxe', 5, '2019-06-28', 356, 27),
('Hotel deLuxe', 5, '2019-06-29', 364, NULL),
('Hotel deLuxe', 5, '2019-06-30', 162, NULL),
('Hotel deLuxe', 5, '2019-07-01', 179, NULL),
('Hotel deLuxe', 5, '2019-07-02', 306, NULL),
('Hotel deLuxe', 5, '2019-07-03', 387, NULL),
('Hotel deLuxe', 5, '2019-07-04', 346, NULL),
('Hotel deLuxe', 5, '2019-07-05', 239, NULL),
('Hotel deLuxe', 5, '2019-07-06', 225, NULL),
('Hotel deLuxe', 5, '2019-07-07', 254, NULL),
('Hotel deLuxe', 5, '2019-07-08', 177, NULL),
('Hotel deLuxe', 5, '2019-07-09', 223, NULL),
('Hotel deLuxe', 5, '2019-07-10', 105, NULL),
('Hotel deLuxe', 5, '2019-07-11', 186, NULL),
('Hotel deLuxe', 5, '2019-07-12', 230, NULL),
('Hotel deLuxe', 5, '2019-07-13', 305, NULL),
('Hotel deLuxe', 5, '2019-07-14', 289, NULL),
('Hotel deLuxe', 5, '2019-07-15', 193, NULL),
('Hotel deLuxe', 5, '2019-07-16', 330, NULL),
('Hotel deLuxe', 5, '2019-07-17', 242, NULL),
('Hotel deLuxe', 5, '2019-07-18', 131, NULL),
('Hotel deLuxe', 5, '2019-07-19', 211, NULL),
('Hotel deLuxe', 5, '2019-07-20', 290, NULL),
('Hotel deLuxe', 5, '2019-07-21', 303, NULL),
('Hotel deLuxe', 5, '2019-07-22', 318, NULL),
('Hotel deLuxe', 5, '2019-07-23', 155, NULL),
('Hotel deLuxe', 5, '2019-07-24', 338, NULL),
('Hotel deLuxe', 5, '2019-07-25', 300, NULL),
('Hotel deLuxe', 5, '2019-07-26', 308, NULL),
('Hotel deLuxe', 5, '2019-07-27', 140, NULL),
('Hotel deLuxe', 5, '2019-07-28', 209, NULL),
('Hotel deLuxe', 5, '2019-07-29', 337, 98),
('Hotel deLuxe', 5, '2019-07-30', 291, 98),
('Hotel deLuxe', 5, '2019-07-31', 323, 98),
('Hotel deLuxe', 5, '2019-08-01', 379, 98),
('Hotel deLuxe', 5, '2019-08-02', 104, 98),
('Hotel deLuxe', 5, '2019-08-03', 381, 98),
('Hotel deLuxe', 5, '2019-08-04', 368, 98),
('Hotel deLuxe', 5, '2019-08-05', 277, 98),
('Hotel deLuxe', 5, '2019-08-06', 192, 98),
('Hotel deLuxe', 5, '2019-08-07', 226, 98),
('Hotel deLuxe', 5, '2019-08-08', 352, 98),
('Hotel deLuxe', 5, '2019-08-09', 123, 98),
('Hotel deLuxe', 5, '2019-08-10', 180, 98),
('Hotel deLuxe', 5, '2019-08-11', 167, 98),
('Hotel deLuxe', 5, '2019-08-12', 239, 98),
('Hotel deLuxe', 5, '2019-08-13', 266, 98),
('Hotel deLuxe', 5, '2019-08-14', 105, 98),
('Hotel deLuxe', 5, '2019-08-15', 384, 98),
('Hotel deLuxe', 5, '2019-08-16', 204, 98),
('Hotel deLuxe', 5, '2019-08-17', 309, 98),
('Hotel deLuxe', 5, '2019-08-18', 346, 98),
('Hotel deLuxe', 5, '2019-08-19', 365, 98),
('Hotel deLuxe', 5, '2019-08-20', 263, 98),
('Hotel deLuxe', 5, '2019-08-21', 381, 98),
('Hotel deLuxe', 5, '2019-08-22', 277, 98),
('Hotel deLuxe', 5, '2019-08-23', 104, NULL),
('Hotel deLuxe', 5, '2019-08-24', 120, NULL),
('Hotel deLuxe', 5, '2019-08-25', 170, NULL),
('Hotel deLuxe', 5, '2019-08-26', 195, NULL),
('Hotel deLuxe', 5, '2019-08-27', 384, NULL),
('Hotel deLuxe', 5, '2019-08-28', 338, 94),
('Hotel deLuxe', 5, '2019-08-29', 316, 94),
('Hotel deLuxe', 5, '2019-08-30', 128, 94),
('Hotel deLuxe', 5, '2019-08-31', 119, 94),
('Hotel deLuxe', 5, '2019-09-01', 309, 94),
('Hotel deLuxe', 5, '2019-09-02', 170, 94),
('Hotel deLuxe', 5, '2019-09-03', 186, 94),
('Hotel deLuxe', 5, '2019-09-04', 178, 94),
('Hotel deLuxe', 5, '2019-09-05', 363, 94),
('Hotel deLuxe', 5, '2019-09-06', 260, 94),
('Hotel deLuxe', 5, '2019-09-07', 199, NULL),
('Hotel deLuxe', 5, '2019-09-08', 128, NULL),
('Hotel deLuxe', 5, '2019-09-09', 371, NULL),
('Hotel deLuxe', 5, '2019-09-10', 201, NULL),
('Hotel deLuxe', 5, '2019-09-11', 209, NULL),
('Hotel deLuxe', 5, '2019-09-12', 235, NULL),
('Hotel deLuxe', 5, '2019-09-13', 187, NULL),
('Hotel deLuxe', 5, '2019-09-14', 342, NULL),
('Hotel deLuxe', 5, '2019-09-15', 387, NULL),
('Hotel deLuxe', 5, '2019-09-16', 353, NULL),
('Hotel deLuxe', 5, '2019-09-17', 164, NULL),
('Hotel deLuxe', 5, '2019-09-18', 127, 123),
('Hotel deLuxe', 5, '2019-09-19', 354, 123),
('Hotel deLuxe', 5, '2019-09-20', 213, 123),
('Hotel deLuxe', 5, '2019-09-21', 213, 123),
('Hotel deLuxe', 5, '2019-09-22', 375, 123),
('Hotel deLuxe', 5, '2019-09-23', 315, 123),
('Hotel deLuxe', 5, '2019-09-24', 143, 123),
('Hotel deLuxe', 5, '2019-09-25', 188, 123),
('Hotel deLuxe', 5, '2019-09-26', 162, 123),
('Hotel deLuxe', 5, '2019-09-27', 137, 123),
('Hotel deLuxe', 5, '2019-09-28', 167, 123),
('Hotel deLuxe', 5, '2019-09-29', 279, 123),
('Hotel deLuxe', 5, '2019-09-30', 271, 123),
('Hotel deLuxe', 5, '2019-10-01', 290, 123),
('Hotel deLuxe', 5, '2019-10-02', 214, NULL),
('Hotel deLuxe', 5, '2019-10-03', 397, NULL),
('Hotel deLuxe', 5, '2019-10-04', 280, NULL),
('Hotel deLuxe', 5, '2019-10-05', 342, NULL),
('Hotel deLuxe', 5, '2019-10-06', 192, NULL),
('Hotel deLuxe', 5, '2019-10-07', 363, NULL),
('Hotel deLuxe', 5, '2019-10-08', 133, NULL),
('Hotel deLuxe', 5, '2019-10-09', 392, NULL),
('Hotel deLuxe', 5, '2019-10-10', 354, NULL),
('Hotel deLuxe', 5, '2019-10-11', 232, NULL),
('Hotel deLuxe', 5, '2019-10-12', 125, NULL),
('Hotel deLuxe', 5, '2019-10-13', 133, NULL),
('Hotel deLuxe', 5, '2019-10-14', 103, NULL),
('Hotel deLuxe', 5, '2019-10-15', 195, NULL),
('Hotel deLuxe', 5, '2019-10-16', 197, NULL),
('Hotel deLuxe', 5, '2019-10-17', 211, NULL),
('Hotel deLuxe', 5, '2019-10-18', 334, NULL),
('Hotel deLuxe', 5, '2019-10-19', 142, NULL),
('Hotel deLuxe', 5, '2019-10-20', 269, NULL),
('Hotel deLuxe', 5, '2019-10-21', 249, NULL),
('Hotel deLuxe', 5, '2019-10-22', 228, NULL),
('Hotel deLuxe', 5, '2019-10-23', 158, NULL),
('Hotel deLuxe', 5, '2019-10-24', 369, NULL),
('Hotel deLuxe', 5, '2019-10-25', 218, NULL),
('Hotel deLuxe', 5, '2019-10-26', 303, NULL),
('Hotel deLuxe', 5, '2019-10-27', 195, NULL),
('Hotel deLuxe', 5, '2019-10-28', 358, NULL),
('Hotel deLuxe', 5, '2019-10-29', 256, NULL),
('Hotel deLuxe', 5, '2019-10-30', 258, NULL),
('Hotel deLuxe', 5, '2019-10-31', 272, NULL),
('Hotel deLuxe', 5, '2019-11-01', 179, NULL),
('Hotel deLuxe', 5, '2019-11-02', 266, NULL),
('Hotel deLuxe', 5, '2019-11-03', 373, NULL),
('Hotel deLuxe', 5, '2019-11-04', 123, NULL),
('Hotel deLuxe', 5, '2019-11-05', 364, NULL),
('Hotel deLuxe', 5, '2019-11-06', 338, NULL),
('Hotel deLuxe', 5, '2019-11-07', 345, 52),
('Hotel deLuxe', 5, '2019-11-08', 257, 52),
('Hotel deLuxe', 5, '2019-11-09', 217, 52),
('Hotel deLuxe', 5, '2019-11-10', 199, 52),
('Hotel deLuxe', 5, '2019-11-11', 362, 52),
('Hotel deLuxe', 5, '2019-11-12', 157, 52),
('Hotel deLuxe', 5, '2019-11-13', 217, 52),
('Hotel deLuxe', 5, '2019-11-14', 353, 52),
('Hotel deLuxe', 5, '2019-11-15', 141, 52),
('Hotel deLuxe', 5, '2019-11-16', 352, 52),
('Hotel deLuxe', 5, '2019-11-17', 139, 52),
('Hotel deLuxe', 5, '2019-11-18', 283, 52),
('Hotel deLuxe', 5, '2019-11-19', 338, 52),
('Hotel deLuxe', 5, '2019-11-20', 331, 52),
('Hotel deLuxe', 5, '2019-11-21', 361, 52),
('Hotel deLuxe', 5, '2019-11-22', 335, 52),
('Hotel deLuxe', 5, '2019-11-23', 139, 52),
('Hotel deLuxe', 5, '2019-11-24', 141, 52),
('Hotel deLuxe', 5, '2019-11-25', 322, NULL),
('Hotel deLuxe', 5, '2019-11-26', 280, NULL),
('Hotel deLuxe', 5, '2019-11-27', 181, NULL),
('Hotel deLuxe', 5, '2019-11-28', 269, NULL),
('Hotel deLuxe', 5, '2019-11-29', 191, NULL),
('Hotel deLuxe', 5, '2019-11-30', 225, NULL),
('Hotel deLuxe', 5, '2019-12-01', 222, NULL),
('Hotel deLuxe', 5, '2019-12-02', 367, NULL),
('Hotel deLuxe', 5, '2019-12-03', 181, NULL),
('Hotel deLuxe', 5, '2019-12-04', 325, NULL),
('Hotel deLuxe', 5, '2019-12-05', 221, NULL),
('Hotel deLuxe', 5, '2019-12-06', 236, NULL),
('Hotel deLuxe', 5, '2019-12-07', 371, NULL),
('Hotel deLuxe', 5, '2019-12-08', 350, NULL),
('Hotel deLuxe', 5, '2019-12-09', 241, NULL),
('Hotel deLuxe', 5, '2019-12-10', 201, NULL),
('Hotel deLuxe', 5, '2019-12-11', 131, NULL),
('Hotel deLuxe', 5, '2019-12-12', 358, NULL),
('Hotel deLuxe', 5, '2019-12-13', 122, NULL),
('Hotel deLuxe', 5, '2019-12-14', 188, NULL),
('Hotel deLuxe', 5, '2019-12-15', 343, NULL),
('Hotel deLuxe', 5, '2019-12-16', 251, NULL),
('Hotel deLuxe', 5, '2019-12-17', 281, NULL),
('Hotel deLuxe', 5, '2019-12-18', 277, NULL),
('Hotel deLuxe', 5, '2019-12-19', 301, NULL),
('Hotel deLuxe', 5, '2019-12-20', 148, NULL),
('Hotel deLuxe', 5, '2019-12-21', 183, NULL),
('Hotel deLuxe', 5, '2019-12-22', 326, NULL),
('Hotel deLuxe', 5, '2019-12-23', 233, NULL),
('Hotel deLuxe', 5, '2019-12-24', 144, NULL),
('Hotel deLuxe', 5, '2019-12-25', 271, NULL),
('Hotel deLuxe', 5, '2019-12-26', 353, NULL),
('Hotel deLuxe', 5, '2019-12-27', 261, NULL),
('Hotel deLuxe', 5, '2019-12-28', 337, 15),
('Hotel deLuxe', 5, '2019-12-29', 215, 15),
('Hotel deLuxe', 5, '2019-12-30', 183, 15),
('Hotel deLuxe', 5, '2019-12-31', 268, 15),
('Hotel deLuxe', 5, '2020-01-01', 168, 15),
('Hotel deLuxe', 5, '2020-01-02', 294, 15),
('Hotel deLuxe', 5, '2020-01-03', 329, 15),
('Hotel deLuxe', 5, '2020-01-04', 340, 15),
('Hotel deLuxe', 5, '2020-01-05', 151, 15),
('Hotel deLuxe', 5, '2020-01-06', 147, 15),
('Hotel deLuxe', 5, '2020-01-07', 309, 15),
('Hotel deLuxe', 5, '2020-01-08', 309, 15),
('Hotel deLuxe', 5, '2020-01-09', 329, 15),
('Hotel deLuxe', 5, '2020-01-10', 369, 15),
('Hotel deLuxe', 5, '2020-01-11', 182, 15),
('Hotel deLuxe', 5, '2020-01-12', 119, 15),
('Hotel deLuxe', 5, '2020-01-13', 370, 15),
('Hotel deLuxe', 5, '2020-01-14', 148, 15),
('Hotel deLuxe', 5, '2020-01-15', 227, 15),
('Hotel deLuxe', 5, '2020-01-16', 307, 15),
('Hotel deLuxe', 5, '2020-01-17', 183, 15),
('Hotel deLuxe', 5, '2020-01-18', 127, 15),
('Hotel deLuxe', 5, '2020-01-19', 199, 15),
('Hotel deLuxe', 5, '2020-01-20', 243, NULL),
('Hotel deLuxe', 5, '2020-01-21', 113, NULL),
('Hotel deLuxe', 5, '2020-01-22', 177, NULL),
('Hotel deLuxe', 5, '2020-01-23', 184, NULL),
('Hotel deLuxe', 5, '2020-01-24', 174, NULL),
('Hotel deLuxe', 5, '2020-01-25', 118, NULL),
('Hotel deLuxe', 5, '2020-01-26', 356, NULL),
('Hotel deLuxe', 5, '2020-01-27', 214, NULL),
('Hotel deLuxe', 5, '2020-01-28', 243, NULL),
('Hotel deLuxe', 5, '2020-01-29', 161, NULL),
('Hotel deLuxe', 5, '2020-01-30', 152, NULL),
('Hotel deLuxe', 5, '2020-01-31', 295, NULL),
('Hotel deLuxe', 5, '2020-02-01', 116, NULL),
('Hotel deLuxe', 5, '2020-02-02', 237, NULL),
('Hotel deLuxe', 5, '2020-02-03', 386, NULL),
('Hotel deLuxe', 5, '2020-02-04', 159, NULL),
('Hotel deLuxe', 22, '2019-01-01', 108, NULL),
('Hotel deLuxe', 22, '2019-01-02', 265, NULL),
('Hotel deLuxe', 22, '2019-01-03', 109, NULL),
('Hotel deLuxe', 22, '2019-01-04', 326, NULL),
('Hotel deLuxe', 22, '2019-01-05', 338, NULL),
('Hotel deLuxe', 22, '2019-01-06', 129, NULL),
('Hotel deLuxe', 22, '2019-01-07', 285, NULL),
('Hotel deLuxe', 22, '2019-01-08', 132, NULL),
('Hotel deLuxe', 22, '2019-01-09', 241, NULL),
('Hotel deLuxe', 22, '2019-01-10', 215, NULL),
('Hotel deLuxe', 22, '2019-01-11', 165, NULL),
('Hotel deLuxe', 22, '2019-01-12', 112, NULL),
('Hotel deLuxe', 22, '2019-01-13', 293, NULL),
('Hotel deLuxe', 22, '2019-01-14', 239, NULL),
('Hotel deLuxe', 22, '2019-01-15', 148, NULL),
('Hotel deLuxe', 22, '2019-01-16', 209, NULL),
('Hotel deLuxe', 22, '2019-01-17', 105, NULL),
('Hotel deLuxe', 22, '2019-01-18', 349, NULL),
('Hotel deLuxe', 22, '2019-01-19', 248, NULL),
('Hotel deLuxe', 22, '2019-01-20', 142, NULL),
('Hotel deLuxe', 22, '2019-01-21', 227, NULL),
('Hotel deLuxe', 22, '2019-01-22', 387, NULL),
('Hotel deLuxe', 22, '2019-01-23', 219, NULL),
('Hotel deLuxe', 22, '2019-01-24', 378, NULL),
('Hotel deLuxe', 22, '2019-01-25', 279, NULL),
('Hotel deLuxe', 22, '2019-01-26', 196, NULL),
('Hotel deLuxe', 22, '2019-01-27', 191, NULL),
('Hotel deLuxe', 22, '2019-01-28', 119, NULL),
('Hotel deLuxe', 22, '2019-01-29', 357, NULL),
('Hotel deLuxe', 22, '2019-01-30', 244, NULL),
('Hotel deLuxe', 22, '2019-01-31', 177, NULL),
('Hotel deLuxe', 22, '2019-02-01', 104, NULL),
('Hotel deLuxe', 22, '2019-02-02', 280, NULL),
('Hotel deLuxe', 22, '2019-02-03', 229, NULL),
('Hotel deLuxe', 22, '2019-02-04', 140, NULL),
('Hotel deLuxe', 22, '2019-02-05', 138, NULL),
('Hotel deLuxe', 22, '2019-02-06', 254, NULL),
('Hotel deLuxe', 22, '2019-02-07', 289, NULL),
('Hotel deLuxe', 22, '2019-02-08', 153, NULL),
('Hotel deLuxe', 22, '2019-02-09', 376, NULL),
('Hotel deLuxe', 22, '2019-02-10', 379, NULL),
('Hotel deLuxe', 22, '2019-02-11', 122, NULL),
('Hotel deLuxe', 22, '2019-02-12', 330, NULL),
('Hotel deLuxe', 22, '2019-02-13', 301, NULL),
('Hotel deLuxe', 22, '2019-02-14', 140, NULL),
('Hotel deLuxe', 22, '2019-02-15', 347, NULL),
('Hotel deLuxe', 22, '2019-02-16', 228, NULL),
('Hotel deLuxe', 22, '2019-02-17', 277, NULL),
('Hotel deLuxe', 22, '2019-02-18', 164, NULL),
('Hotel deLuxe', 22, '2019-02-19', 137, NULL),
('Hotel deLuxe', 22, '2019-02-20', 210, NULL),
('Hotel deLuxe', 22, '2019-02-21', 155, NULL),
('Hotel deLuxe', 22, '2019-02-22', 373, NULL),
('Hotel deLuxe', 22, '2019-02-23', 127, NULL),
('Hotel deLuxe', 22, '2019-02-24', 264, NULL),
('Hotel deLuxe', 22, '2019-02-25', 321, NULL),
('Hotel deLuxe', 22, '2019-02-26', 218, NULL),
('Hotel deLuxe', 22, '2019-02-27', 255, NULL),
('Hotel deLuxe', 22, '2019-02-28', 183, NULL),
('Hotel deLuxe', 22, '2019-03-01', 245, NULL),
('Hotel deLuxe', 22, '2019-03-02', 226, NULL),
('Hotel deLuxe', 22, '2019-03-03', 235, NULL),
('Hotel deLuxe', 22, '2019-03-04', 104, NULL),
('Hotel deLuxe', 22, '2019-03-05', 180, NULL),
('Hotel deLuxe', 22, '2019-03-06', 378, NULL),
('Hotel deLuxe', 22, '2019-03-07', 257, NULL),
('Hotel deLuxe', 22, '2019-03-08', 116, NULL),
('Hotel deLuxe', 22, '2019-03-09', 339, NULL),
('Hotel deLuxe', 22, '2019-03-10', 146, NULL),
('Hotel deLuxe', 22, '2019-03-11', 225, NULL),
('Hotel deLuxe', 22, '2019-03-12', 132, NULL),
('Hotel deLuxe', 22, '2019-03-13', 249, NULL),
('Hotel deLuxe', 22, '2019-03-14', 211, NULL),
('Hotel deLuxe', 22, '2019-03-15', 212, NULL),
('Hotel deLuxe', 22, '2019-03-16', 391, NULL),
('Hotel deLuxe', 22, '2019-03-17', 103, NULL),
('Hotel deLuxe', 22, '2019-03-18', 388, NULL),
('Hotel deLuxe', 22, '2019-03-19', 278, NULL),
('Hotel deLuxe', 22, '2019-03-20', 385, NULL),
('Hotel deLuxe', 22, '2019-03-21', 168, NULL),
('Hotel deLuxe', 22, '2019-03-22', 315, 23),
('Hotel deLuxe', 22, '2019-03-23', 372, 23),
('Hotel deLuxe', 22, '2019-03-24', 262, 23),
('Hotel deLuxe', 22, '2019-03-25', 271, 23),
('Hotel deLuxe', 22, '2019-03-26', 191, 23),
('Hotel deLuxe', 22, '2019-03-27', 118, NULL),
('Hotel deLuxe', 22, '2019-03-28', 266, NULL),
('Hotel deLuxe', 22, '2019-03-29', 390, NULL),
('Hotel deLuxe', 22, '2019-03-30', 173, NULL),
('Hotel deLuxe', 22, '2019-03-31', 318, NULL),
('Hotel deLuxe', 22, '2019-04-01', 172, NULL),
('Hotel deLuxe', 22, '2019-04-02', 297, NULL),
('Hotel deLuxe', 22, '2019-04-03', 240, NULL),
('Hotel deLuxe', 22, '2019-04-04', 293, NULL),
('Hotel deLuxe', 22, '2019-04-05', 181, 121),
('Hotel deLuxe', 22, '2019-04-06', 160, 121),
('Hotel deLuxe', 22, '2019-04-07', 172, 121),
('Hotel deLuxe', 22, '2019-04-08', 225, 121),
('Hotel deLuxe', 22, '2019-04-09', 265, 121),
('Hotel deLuxe', 22, '2019-04-10', 265, NULL),
('Hotel deLuxe', 22, '2019-04-11', 248, NULL),
('Hotel deLuxe', 22, '2019-04-12', 236, NULL),
('Hotel deLuxe', 22, '2019-04-13', 103, NULL),
('Hotel deLuxe', 22, '2019-04-14', 159, NULL),
('Hotel deLuxe', 22, '2019-04-15', 134, NULL),
('Hotel deLuxe', 22, '2019-04-16', 251, NULL),
('Hotel deLuxe', 22, '2019-04-17', 312, NULL),
('Hotel deLuxe', 22, '2019-04-18', 309, NULL),
('Hotel deLuxe', 22, '2019-04-19', 327, NULL),
('Hotel deLuxe', 22, '2019-04-20', 107, NULL),
('Hotel deLuxe', 22, '2019-04-21', 330, NULL),
('Hotel deLuxe', 22, '2019-04-22', 135, NULL),
('Hotel deLuxe', 22, '2019-04-23', 215, NULL),
('Hotel deLuxe', 22, '2019-04-24', 117, NULL),
('Hotel deLuxe', 22, '2019-04-25', 199, NULL),
('Hotel deLuxe', 22, '2019-04-26', 273, NULL),
('Hotel deLuxe', 22, '2019-04-27', 158, NULL),
('Hotel deLuxe', 22, '2019-04-28', 326, NULL),
('Hotel deLuxe', 22, '2019-04-29', 399, NULL),
('Hotel deLuxe', 22, '2019-04-30', 251, NULL),
('Hotel deLuxe', 22, '2019-05-01', 201, NULL),
('Hotel deLuxe', 22, '2019-05-02', 205, NULL),
('Hotel deLuxe', 22, '2019-05-03', 192, NULL),
('Hotel deLuxe', 22, '2019-05-04', 308, NULL),
('Hotel deLuxe', 22, '2019-05-05', 126, 163),
('Hotel deLuxe', 22, '2019-05-06', 154, 163),
('Hotel deLuxe', 22, '2019-05-07', 381, 163),
('Hotel deLuxe', 22, '2019-05-08', 367, 163),
('Hotel deLuxe', 22, '2019-05-09', 240, 163),
('Hotel deLuxe', 22, '2019-05-10', 271, 163),
('Hotel deLuxe', 22, '2019-05-11', 209, 163),
('Hotel deLuxe', 22, '2019-05-12', 120, NULL),
('Hotel deLuxe', 22, '2019-05-13', 185, NULL),
('Hotel deLuxe', 22, '2019-05-14', 377, NULL),
('Hotel deLuxe', 22, '2019-05-15', 244, NULL),
('Hotel deLuxe', 22, '2019-05-16', 304, NULL),
('Hotel deLuxe', 22, '2019-05-17', 363, NULL),
('Hotel deLuxe', 22, '2019-05-18', 330, NULL),
('Hotel deLuxe', 22, '2019-05-19', 156, NULL),
('Hotel deLuxe', 22, '2019-05-20', 367, NULL),
('Hotel deLuxe', 22, '2019-05-21', 145, NULL),
('Hotel deLuxe', 22, '2019-05-22', 300, NULL),
('Hotel deLuxe', 22, '2019-05-23', 231, NULL),
('Hotel deLuxe', 22, '2019-05-24', 159, NULL),
('Hotel deLuxe', 22, '2019-05-25', 374, NULL),
('Hotel deLuxe', 22, '2019-05-26', 263, NULL),
('Hotel deLuxe', 22, '2019-05-27', 307, NULL),
('Hotel deLuxe', 22, '2019-05-28', 233, NULL),
('Hotel deLuxe', 22, '2019-05-29', 247, NULL),
('Hotel deLuxe', 22, '2019-05-30', 216, NULL),
('Hotel deLuxe', 22, '2019-05-31', 282, NULL),
('Hotel deLuxe', 22, '2019-06-01', 101, NULL),
('Hotel deLuxe', 22, '2019-06-02', 366, NULL),
('Hotel deLuxe', 22, '2019-06-03', 103, NULL),
('Hotel deLuxe', 22, '2019-06-04', 364, NULL),
('Hotel deLuxe', 22, '2019-06-05', 394, NULL),
('Hotel deLuxe', 22, '2019-06-06', 337, NULL),
('Hotel deLuxe', 22, '2019-06-07', 170, NULL),
('Hotel deLuxe', 22, '2019-06-08', 170, NULL),
('Hotel deLuxe', 22, '2019-06-09', 295, NULL),
('Hotel deLuxe', 22, '2019-06-10', 109, NULL),
('Hotel deLuxe', 22, '2019-06-11', 295, NULL),
('Hotel deLuxe', 22, '2019-06-12', 280, NULL),
('Hotel deLuxe', 22, '2019-06-13', 318, NULL),
('Hotel deLuxe', 22, '2019-06-14', 397, NULL),
('Hotel deLuxe', 22, '2019-06-15', 182, NULL),
('Hotel deLuxe', 22, '2019-06-16', 109, NULL),
('Hotel deLuxe', 22, '2019-06-17', 105, NULL),
('Hotel deLuxe', 22, '2019-06-18', 259, NULL),
('Hotel deLuxe', 22, '2019-06-19', 114, 199),
('Hotel deLuxe', 22, '2019-06-20', 315, 199),
('Hotel deLuxe', 22, '2019-06-21', 329, 199),
('Hotel deLuxe', 22, '2019-06-22', 138, 199),
('Hotel deLuxe', 22, '2019-06-23', 361, 199),
('Hotel deLuxe', 22, '2019-06-24', 361, 199),
('Hotel deLuxe', 22, '2019-06-25', 220, 199),
('Hotel deLuxe', 22, '2019-06-26', 163, 199),
('Hotel deLuxe', 22, '2019-06-27', 266, 199),
('Hotel deLuxe', 22, '2019-06-28', 305, 199),
('Hotel deLuxe', 22, '2019-06-29', 335, NULL),
('Hotel deLuxe', 22, '2019-06-30', 271, NULL),
('Hotel deLuxe', 22, '2019-07-01', 351, NULL),
('Hotel deLuxe', 22, '2019-07-02', 294, NULL),
('Hotel deLuxe', 22, '2019-07-03', 208, NULL),
('Hotel deLuxe', 22, '2019-07-04', 119, NULL),
('Hotel deLuxe', 22, '2019-07-05', 146, NULL),
('Hotel deLuxe', 22, '2019-07-06', 336, NULL),
('Hotel deLuxe', 22, '2019-07-07', 150, NULL),
('Hotel deLuxe', 22, '2019-07-08', 380, NULL),
('Hotel deLuxe', 22, '2019-07-09', 103, NULL),
('Hotel deLuxe', 22, '2019-07-10', 275, NULL),
('Hotel deLuxe', 22, '2019-07-11', 134, NULL),
('Hotel deLuxe', 22, '2019-07-12', 169, NULL),
('Hotel deLuxe', 22, '2019-07-13', 208, NULL),
('Hotel deLuxe', 22, '2019-07-14', 343, NULL),
('Hotel deLuxe', 22, '2019-07-15', 119, NULL),
('Hotel deLuxe', 22, '2019-07-16', 243, NULL),
('Hotel deLuxe', 22, '2019-07-17', 372, NULL),
('Hotel deLuxe', 22, '2019-07-18', 336, NULL),
('Hotel deLuxe', 22, '2019-07-19', 191, NULL),
('Hotel deLuxe', 22, '2019-07-20', 378, NULL),
('Hotel deLuxe', 22, '2019-07-21', 290, NULL),
('Hotel deLuxe', 22, '2019-07-22', 194, NULL),
('Hotel deLuxe', 22, '2019-07-23', 322, NULL),
('Hotel deLuxe', 22, '2019-07-24', 304, NULL),
('Hotel deLuxe', 22, '2019-07-25', 266, NULL),
('Hotel deLuxe', 22, '2019-07-26', 330, NULL),
('Hotel deLuxe', 22, '2019-07-27', 285, NULL),
('Hotel deLuxe', 22, '2019-07-28', 368, NULL),
('Hotel deLuxe', 22, '2019-07-29', 235, NULL),
('Hotel deLuxe', 22, '2019-07-30', 125, NULL),
('Hotel deLuxe', 22, '2019-07-31', 248, NULL),
('Hotel deLuxe', 22, '2019-08-01', 397, NULL),
('Hotel deLuxe', 22, '2019-08-02', 141, NULL),
('Hotel deLuxe', 22, '2019-08-03', 344, NULL),
('Hotel deLuxe', 22, '2019-08-04', 332, NULL),
('Hotel deLuxe', 22, '2019-08-05', 134, NULL),
('Hotel deLuxe', 22, '2019-08-06', 140, NULL),
('Hotel deLuxe', 22, '2019-08-07', 328, NULL),
('Hotel deLuxe', 22, '2019-08-08', 246, NULL),
('Hotel deLuxe', 22, '2019-08-09', 333, NULL),
('Hotel deLuxe', 22, '2019-08-10', 120, NULL),
('Hotel deLuxe', 22, '2019-08-11', 292, NULL),
('Hotel deLuxe', 22, '2019-08-12', 118, NULL),
('Hotel deLuxe', 22, '2019-08-13', 351, NULL),
('Hotel deLuxe', 22, '2019-08-14', 331, NULL),
('Hotel deLuxe', 22, '2019-08-15', 172, NULL),
('Hotel deLuxe', 22, '2019-08-16', 351, NULL),
('Hotel deLuxe', 22, '2019-08-17', 148, NULL),
('Hotel deLuxe', 22, '2019-08-18', 345, NULL),
('Hotel deLuxe', 22, '2019-08-19', 370, NULL),
('Hotel deLuxe', 22, '2019-08-20', 130, NULL),
('Hotel deLuxe', 22, '2019-08-21', 112, NULL),
('Hotel deLuxe', 22, '2019-08-22', 252, NULL),
('Hotel deLuxe', 22, '2019-08-23', 328, NULL),
('Hotel deLuxe', 22, '2019-08-24', 120, NULL),
('Hotel deLuxe', 22, '2019-08-25', 321, NULL),
('Hotel deLuxe', 22, '2019-08-26', 351, NULL),
('Hotel deLuxe', 22, '2019-08-27', 313, NULL),
('Hotel deLuxe', 22, '2019-08-28', 190, NULL),
('Hotel deLuxe', 22, '2019-08-29', 311, NULL),
('Hotel deLuxe', 22, '2019-08-30', 290, NULL),
('Hotel deLuxe', 22, '2019-08-31', 141, NULL),
('Hotel deLuxe', 22, '2019-09-01', 193, NULL),
('Hotel deLuxe', 22, '2019-09-02', 213, NULL),
('Hotel deLuxe', 22, '2019-09-03', 296, NULL),
('Hotel deLuxe', 22, '2019-09-04', 212, NULL),
('Hotel deLuxe', 22, '2019-09-05', 214, NULL),
('Hotel deLuxe', 22, '2019-09-06', 341, NULL),
('Hotel deLuxe', 22, '2019-09-07', 322, NULL),
('Hotel deLuxe', 22, '2019-09-08', 203, NULL),
('Hotel deLuxe', 22, '2019-09-09', 260, NULL),
('Hotel deLuxe', 22, '2019-09-10', 277, NULL),
('Hotel deLuxe', 22, '2019-09-11', 319, NULL),
('Hotel deLuxe', 22, '2019-09-12', 131, 190),
('Hotel deLuxe', 22, '2019-09-13', 165, 190),
('Hotel deLuxe', 22, '2019-09-14', 368, 190),
('Hotel deLuxe', 22, '2019-09-15', 375, 190),
('Hotel deLuxe', 22, '2019-09-16', 324, 190),
('Hotel deLuxe', 22, '2019-09-17', 197, 190),
('Hotel deLuxe', 22, '2019-09-18', 205, 190),
('Hotel deLuxe', 22, '2019-09-19', 177, 190),
('Hotel deLuxe', 22, '2019-09-20', 223, 190),
('Hotel deLuxe', 22, '2019-09-21', 174, 190),
('Hotel deLuxe', 22, '2019-09-22', 245, 190),
('Hotel deLuxe', 22, '2019-09-23', 311, 190),
('Hotel deLuxe', 22, '2019-09-24', 244, 190),
('Hotel deLuxe', 22, '2019-09-25', 208, 190),
('Hotel deLuxe', 22, '2019-09-26', 386, 190),
('Hotel deLuxe', 22, '2019-09-27', 118, 190),
('Hotel deLuxe', 22, '2019-09-28', 171, NULL),
('Hotel deLuxe', 22, '2019-09-29', 261, NULL),
('Hotel deLuxe', 22, '2019-09-30', 306, NULL),
('Hotel deLuxe', 22, '2019-10-01', 305, NULL),
('Hotel deLuxe', 22, '2019-10-02', 141, NULL),
('Hotel deLuxe', 22, '2019-10-03', 271, NULL),
('Hotel deLuxe', 22, '2019-10-04', 296, NULL),
('Hotel deLuxe', 22, '2019-10-05', 169, NULL),
('Hotel deLuxe', 22, '2019-10-06', 317, NULL),
('Hotel deLuxe', 22, '2019-10-07', 188, NULL),
('Hotel deLuxe', 22, '2019-10-08', 306, NULL),
('Hotel deLuxe', 22, '2019-10-09', 169, NULL),
('Hotel deLuxe', 22, '2019-10-10', 238, NULL),
('Hotel deLuxe', 22, '2019-10-11', 188, NULL),
('Hotel deLuxe', 22, '2019-10-12', 309, NULL),
('Hotel deLuxe', 22, '2019-10-13', 331, NULL),
('Hotel deLuxe', 22, '2019-10-14', 180, NULL),
('Hotel deLuxe', 22, '2019-10-15', 335, NULL),
('Hotel deLuxe', 22, '2019-10-16', 390, NULL),
('Hotel deLuxe', 22, '2019-10-17', 388, NULL),
('Hotel deLuxe', 22, '2019-10-18', 113, NULL),
('Hotel deLuxe', 22, '2019-10-19', 336, NULL),
('Hotel deLuxe', 22, '2019-10-20', 362, NULL),
('Hotel deLuxe', 22, '2019-10-21', 146, NULL),
('Hotel deLuxe', 22, '2019-10-22', 285, NULL),
('Hotel deLuxe', 22, '2019-10-23', 349, NULL),
('Hotel deLuxe', 22, '2019-10-24', 226, NULL),
('Hotel deLuxe', 22, '2019-10-25', 103, NULL),
('Hotel deLuxe', 22, '2019-10-26', 397, NULL),
('Hotel deLuxe', 22, '2019-10-27', 338, NULL),
('Hotel deLuxe', 22, '2019-10-28', 324, NULL),
('Hotel deLuxe', 22, '2019-10-29', 368, NULL),
('Hotel deLuxe', 22, '2019-10-30', 268, NULL),
('Hotel deLuxe', 22, '2019-10-31', 118, NULL),
('Hotel deLuxe', 22, '2019-11-01', 202, NULL),
('Hotel deLuxe', 22, '2019-11-02', 152, NULL),
('Hotel deLuxe', 22, '2019-11-03', 164, NULL),
('Hotel deLuxe', 22, '2019-11-04', 202, NULL),
('Hotel deLuxe', 22, '2019-11-05', 126, NULL),
('Hotel deLuxe', 22, '2019-11-06', 254, NULL),
('Hotel deLuxe', 22, '2019-11-07', 115, NULL),
('Hotel deLuxe', 22, '2019-11-08', 335, NULL),
('Hotel deLuxe', 22, '2019-11-09', 390, NULL),
('Hotel deLuxe', 22, '2019-11-10', 315, NULL),
('Hotel deLuxe', 22, '2019-11-11', 354, NULL),
('Hotel deLuxe', 22, '2019-11-12', 339, NULL),
('Hotel deLuxe', 22, '2019-11-13', 375, NULL),
('Hotel deLuxe', 22, '2019-11-14', 332, NULL),
('Hotel deLuxe', 22, '2019-11-15', 187, 70),
('Hotel deLuxe', 22, '2019-11-16', 380, 70),
('Hotel deLuxe', 22, '2019-11-17', 279, 70),
('Hotel deLuxe', 22, '2019-11-18', 381, NULL),
('Hotel deLuxe', 22, '2019-11-19', 112, NULL),
('Hotel deLuxe', 22, '2019-11-20', 337, NULL),
('Hotel deLuxe', 22, '2019-11-21', 359, NULL),
('Hotel deLuxe', 22, '2019-11-22', 295, NULL),
('Hotel deLuxe', 22, '2019-11-23', 296, NULL),
('Hotel deLuxe', 22, '2019-11-24', 399, NULL),
('Hotel deLuxe', 22, '2019-11-25', 106, NULL),
('Hotel deLuxe', 22, '2019-11-26', 232, NULL),
('Hotel deLuxe', 22, '2019-11-27', 206, NULL),
('Hotel deLuxe', 22, '2019-11-28', 390, NULL),
('Hotel deLuxe', 22, '2019-11-29', 352, NULL),
('Hotel deLuxe', 22, '2019-11-30', 358, NULL),
('Hotel deLuxe', 22, '2019-12-01', 374, NULL),
('Hotel deLuxe', 22, '2019-12-02', 195, NULL),
('Hotel deLuxe', 22, '2019-12-03', 104, NULL),
('Hotel deLuxe', 22, '2019-12-04', 320, NULL),
('Hotel deLuxe', 22, '2019-12-05', 208, NULL),
('Hotel deLuxe', 22, '2019-12-06', 249, NULL),
('Hotel deLuxe', 22, '2019-12-07', 133, NULL),
('Hotel deLuxe', 22, '2019-12-08', 185, NULL),
('Hotel deLuxe', 22, '2019-12-09', 148, NULL),
('Hotel deLuxe', 22, '2019-12-10', 155, NULL),
('Hotel deLuxe', 22, '2019-12-11', 249, NULL),
('Hotel deLuxe', 22, '2019-12-12', 168, NULL),
('Hotel deLuxe', 22, '2019-12-13', 184, NULL),
('Hotel deLuxe', 22, '2019-12-14', 303, NULL),
('Hotel deLuxe', 22, '2019-12-15', 348, NULL),
('Hotel deLuxe', 22, '2019-12-16', 265, NULL),
('Hotel deLuxe', 22, '2019-12-17', 343, NULL),
('Hotel deLuxe', 22, '2019-12-18', 123, NULL),
('Hotel deLuxe', 22, '2019-12-19', 293, NULL),
('Hotel deLuxe', 22, '2019-12-20', 179, NULL),
('Hotel deLuxe', 22, '2019-12-21', 331, NULL),
('Hotel deLuxe', 22, '2019-12-22', 345, NULL),
('Hotel deLuxe', 22, '2019-12-23', 369, NULL),
('Hotel deLuxe', 22, '2019-12-24', 176, NULL),
('Hotel deLuxe', 22, '2019-12-25', 335, NULL),
('Hotel deLuxe', 22, '2019-12-26', 243, NULL),
('Hotel deLuxe', 22, '2019-12-27', 339, NULL),
('Hotel deLuxe', 22, '2019-12-28', 276, NULL),
('Hotel deLuxe', 22, '2019-12-29', 163, NULL),
('Hotel deLuxe', 22, '2019-12-30', 149, NULL),
('Hotel deLuxe', 22, '2019-12-31', 234, NULL),
('Hotel deLuxe', 22, '2020-01-01', 275, NULL),
('Hotel deLuxe', 22, '2020-01-02', 391, NULL),
('Hotel deLuxe', 22, '2020-01-03', 244, NULL),
('Hotel deLuxe', 22, '2020-01-04', 110, NULL),
('Hotel deLuxe', 22, '2020-01-05', 188, NULL),
('Hotel deLuxe', 22, '2020-01-06', 190, NULL),
('Hotel deLuxe', 22, '2020-01-07', 337, NULL),
('Hotel deLuxe', 22, '2020-01-08', 182, NULL),
('Hotel deLuxe', 22, '2020-01-09', 326, 31),
('Hotel deLuxe', 22, '2020-01-10', 128, 31),
('Hotel deLuxe', 22, '2020-01-11', 188, 31),
('Hotel deLuxe', 22, '2020-01-12', 197, 31),
('Hotel deLuxe', 22, '2020-01-13', 353, 31),
('Hotel deLuxe', 22, '2020-01-14', 146, 31),
('Hotel deLuxe', 22, '2020-01-15', 180, 31),
('Hotel deLuxe', 22, '2020-01-16', 377, 31),
('Hotel deLuxe', 22, '2020-01-17', 185, 31),
('Hotel deLuxe', 22, '2020-01-18', 368, 31),
('Hotel deLuxe', 22, '2020-01-19', 162, 31),
('Hotel deLuxe', 22, '2020-01-20', 100, 31),
('Hotel deLuxe', 22, '2020-01-21', 279, 31),
('Hotel deLuxe', 22, '2020-01-22', 295, 31),
('Hotel deLuxe', 22, '2020-01-23', 263, 31),
('Hotel deLuxe', 22, '2020-01-24', 174, 31),
('Hotel deLuxe', 22, '2020-01-25', 227, 31),
('Hotel deLuxe', 22, '2020-01-26', 155, 31),
('Hotel deLuxe', 22, '2020-01-27', 184, 31),
('Hotel deLuxe', 22, '2020-01-28', 217, 31),
('Hotel deLuxe', 22, '2020-01-29', 260, 31),
('Hotel deLuxe', 22, '2020-01-30', 148, 31),
('Hotel deLuxe', 22, '2020-01-31', 398, 31),
('Hotel deLuxe', 22, '2020-02-01', 362, NULL),
('Hotel deLuxe', 22, '2020-02-02', 375, NULL),
('Hotel deLuxe', 22, '2020-02-03', 214, NULL),
('Hotel deLuxe', 22, '2020-02-04', 357, NULL),
('Hotel deLuxe', 45, '2019-01-01', 246, NULL),
('Hotel deLuxe', 45, '2019-01-02', 297, NULL),
('Hotel deLuxe', 45, '2019-01-03', 239, NULL),
('Hotel deLuxe', 45, '2019-01-04', 230, NULL),
('Hotel deLuxe', 45, '2019-01-05', 337, NULL),
('Hotel deLuxe', 45, '2019-01-06', 201, NULL),
('Hotel deLuxe', 45, '2019-01-07', 267, NULL),
('Hotel deLuxe', 45, '2019-01-08', 301, NULL),
('Hotel deLuxe', 45, '2019-01-09', 131, NULL),
('Hotel deLuxe', 45, '2019-01-10', 173, NULL),
('Hotel deLuxe', 45, '2019-01-11', 202, NULL),
('Hotel deLuxe', 45, '2019-01-12', 383, NULL),
('Hotel deLuxe', 45, '2019-01-13', 372, NULL),
('Hotel deLuxe', 45, '2019-01-14', 378, NULL),
('Hotel deLuxe', 45, '2019-01-15', 254, NULL),
('Hotel deLuxe', 45, '2019-01-16', 357, NULL),
('Hotel deLuxe', 45, '2019-01-17', 362, NULL),
('Hotel deLuxe', 45, '2019-01-18', 373, NULL),
('Hotel deLuxe', 45, '2019-01-19', 254, NULL),
('Hotel deLuxe', 45, '2019-01-20', 179, NULL),
('Hotel deLuxe', 45, '2019-01-21', 117, NULL),
('Hotel deLuxe', 45, '2019-01-22', 351, NULL),
('Hotel deLuxe', 45, '2019-01-23', 119, NULL),
('Hotel deLuxe', 45, '2019-01-24', 199, NULL),
('Hotel deLuxe', 45, '2019-01-25', 222, NULL),
('Hotel deLuxe', 45, '2019-01-26', 191, NULL),
('Hotel deLuxe', 45, '2019-01-27', 388, NULL),
('Hotel deLuxe', 45, '2019-01-28', 396, NULL),
('Hotel deLuxe', 45, '2019-01-29', 121, NULL),
('Hotel deLuxe', 45, '2019-01-30', 138, NULL),
('Hotel deLuxe', 45, '2019-01-31', 238, NULL),
('Hotel deLuxe', 45, '2019-02-01', 330, NULL),
('Hotel deLuxe', 45, '2019-02-02', 309, NULL),
('Hotel deLuxe', 45, '2019-02-03', 343, NULL),
('Hotel deLuxe', 45, '2019-02-04', 103, NULL),
('Hotel deLuxe', 45, '2019-02-05', 292, NULL),
('Hotel deLuxe', 45, '2019-02-06', 372, NULL),
('Hotel deLuxe', 45, '2019-02-07', 359, NULL),
('Hotel deLuxe', 45, '2019-02-08', 334, NULL),
('Hotel deLuxe', 45, '2019-02-09', 214, NULL),
('Hotel deLuxe', 45, '2019-02-10', 290, NULL),
('Hotel deLuxe', 45, '2019-02-11', 302, NULL),
('Hotel deLuxe', 45, '2019-02-12', 155, NULL),
('Hotel deLuxe', 45, '2019-02-13', 168, NULL),
('Hotel deLuxe', 45, '2019-02-14', 289, NULL),
('Hotel deLuxe', 45, '2019-02-15', 156, NULL),
('Hotel deLuxe', 45, '2019-02-16', 348, NULL),
('Hotel deLuxe', 45, '2019-02-17', 371, NULL),
('Hotel deLuxe', 45, '2019-02-18', 303, NULL),
('Hotel deLuxe', 45, '2019-02-19', 115, NULL),
('Hotel deLuxe', 45, '2019-02-20', 345, NULL),
('Hotel deLuxe', 45, '2019-02-21', 198, NULL),
('Hotel deLuxe', 45, '2019-02-22', 332, NULL),
('Hotel deLuxe', 45, '2019-02-23', 192, NULL),
('Hotel deLuxe', 45, '2019-02-24', 329, NULL),
('Hotel deLuxe', 45, '2019-02-25', 199, NULL),
('Hotel deLuxe', 45, '2019-02-26', 328, NULL),
('Hotel deLuxe', 45, '2019-02-27', 100, NULL),
('Hotel deLuxe', 45, '2019-02-28', 354, NULL),
('Hotel deLuxe', 45, '2019-03-01', 286, NULL),
('Hotel deLuxe', 45, '2019-03-02', 394, NULL),
('Hotel deLuxe', 45, '2019-03-03', 169, NULL),
('Hotel deLuxe', 45, '2019-03-04', 183, NULL),
('Hotel deLuxe', 45, '2019-03-05', 362, NULL),
('Hotel deLuxe', 45, '2019-03-06', 295, NULL),
('Hotel deLuxe', 45, '2019-03-07', 287, NULL),
('Hotel deLuxe', 45, '2019-03-08', 201, NULL),
('Hotel deLuxe', 45, '2019-03-09', 307, NULL),
('Hotel deLuxe', 45, '2019-03-10', 204, NULL),
('Hotel deLuxe', 45, '2019-03-11', 300, NULL),
('Hotel deLuxe', 45, '2019-03-12', 347, NULL),
('Hotel deLuxe', 45, '2019-03-13', 336, NULL),
('Hotel deLuxe', 45, '2019-03-14', 191, NULL),
('Hotel deLuxe', 45, '2019-03-15', 348, NULL),
('Hotel deLuxe', 45, '2019-03-16', 265, NULL),
('Hotel deLuxe', 45, '2019-03-17', 163, NULL),
('Hotel deLuxe', 45, '2019-03-18', 236, NULL),
('Hotel deLuxe', 45, '2019-03-19', 315, NULL),
('Hotel deLuxe', 45, '2019-03-20', 268, NULL),
('Hotel deLuxe', 45, '2019-03-21', 339, NULL),
('Hotel deLuxe', 45, '2019-03-22', 358, NULL),
('Hotel deLuxe', 45, '2019-03-23', 329, NULL),
('Hotel deLuxe', 45, '2019-03-24', 226, NULL),
('Hotel deLuxe', 45, '2019-03-25', 150, NULL),
('Hotel deLuxe', 45, '2019-03-26', 224, NULL),
('Hotel deLuxe', 45, '2019-03-27', 163, NULL),
('Hotel deLuxe', 45, '2019-03-28', 343, NULL),
('Hotel deLuxe', 45, '2019-03-29', 246, NULL),
('Hotel deLuxe', 45, '2019-03-30', 270, NULL),
('Hotel deLuxe', 45, '2019-03-31', 218, NULL),
('Hotel deLuxe', 45, '2019-04-01', 343, NULL),
('Hotel deLuxe', 45, '2019-04-02', 147, NULL),
('Hotel deLuxe', 45, '2019-04-03', 310, NULL),
('Hotel deLuxe', 45, '2019-04-04', 170, NULL),
('Hotel deLuxe', 45, '2019-04-05', 241, NULL),
('Hotel deLuxe', 45, '2019-04-06', 377, NULL),
('Hotel deLuxe', 45, '2019-04-07', 117, NULL),
('Hotel deLuxe', 45, '2019-04-08', 247, NULL),
('Hotel deLuxe', 45, '2019-04-09', 207, NULL),
('Hotel deLuxe', 45, '2019-04-10', 128, NULL),
('Hotel deLuxe', 45, '2019-04-11', 359, NULL),
('Hotel deLuxe', 45, '2019-04-12', 296, NULL),
('Hotel deLuxe', 45, '2019-04-13', 151, NULL),
('Hotel deLuxe', 45, '2019-04-14', 199, NULL),
('Hotel deLuxe', 45, '2019-04-15', 392, NULL),
('Hotel deLuxe', 45, '2019-04-16', 321, NULL),
('Hotel deLuxe', 45, '2019-04-17', 324, NULL),
('Hotel deLuxe', 45, '2019-04-18', 132, NULL),
('Hotel deLuxe', 45, '2019-04-19', 317, NULL),
('Hotel deLuxe', 45, '2019-04-20', 253, NULL),
('Hotel deLuxe', 45, '2019-04-21', 278, NULL),
('Hotel deLuxe', 45, '2019-04-22', 122, NULL),
('Hotel deLuxe', 45, '2019-04-23', 280, NULL),
('Hotel deLuxe', 45, '2019-04-24', 222, NULL),
('Hotel deLuxe', 45, '2019-04-25', 304, NULL),
('Hotel deLuxe', 45, '2019-04-26', 192, NULL),
('Hotel deLuxe', 45, '2019-04-27', 270, NULL),
('Hotel deLuxe', 45, '2019-04-28', 226, NULL),
('Hotel deLuxe', 45, '2019-04-29', 312, NULL),
('Hotel deLuxe', 45, '2019-04-30', 363, NULL),
('Hotel deLuxe', 45, '2019-05-01', 270, NULL),
('Hotel deLuxe', 45, '2019-05-02', 220, NULL),
('Hotel deLuxe', 45, '2019-05-03', 249, NULL),
('Hotel deLuxe', 45, '2019-05-04', 372, NULL),
('Hotel deLuxe', 45, '2019-05-05', 367, NULL),
('Hotel deLuxe', 45, '2019-05-06', 260, NULL),
('Hotel deLuxe', 45, '2019-05-07', 130, NULL),
('Hotel deLuxe', 45, '2019-05-08', 151, NULL),
('Hotel deLuxe', 45, '2019-05-09', 166, NULL),
('Hotel deLuxe', 45, '2019-05-10', 322, NULL),
('Hotel deLuxe', 45, '2019-05-11', 324, NULL),
('Hotel deLuxe', 45, '2019-05-12', 144, NULL),
('Hotel deLuxe', 45, '2019-05-13', 399, NULL),
('Hotel deLuxe', 45, '2019-05-14', 222, NULL),
('Hotel deLuxe', 45, '2019-05-15', 238, NULL),
('Hotel deLuxe', 45, '2019-05-16', 284, NULL),
('Hotel deLuxe', 45, '2019-05-17', 344, NULL),
('Hotel deLuxe', 45, '2019-05-18', 392, NULL),
('Hotel deLuxe', 45, '2019-05-19', 353, NULL),
('Hotel deLuxe', 45, '2019-05-20', 115, NULL),
('Hotel deLuxe', 45, '2019-05-21', 139, NULL),
('Hotel deLuxe', 45, '2019-05-22', 282, NULL),
('Hotel deLuxe', 45, '2019-05-23', 256, NULL),
('Hotel deLuxe', 45, '2019-05-24', 268, NULL),
('Hotel deLuxe', 45, '2019-05-25', 158, NULL),
('Hotel deLuxe', 45, '2019-05-26', 370, NULL),
('Hotel deLuxe', 45, '2019-05-27', 246, NULL),
('Hotel deLuxe', 45, '2019-05-28', 115, NULL),
('Hotel deLuxe', 45, '2019-05-29', 179, NULL),
('Hotel deLuxe', 45, '2019-05-30', 320, NULL),
('Hotel deLuxe', 45, '2019-05-31', 200, NULL),
('Hotel deLuxe', 45, '2019-06-01', 106, NULL),
('Hotel deLuxe', 45, '2019-06-02', 212, NULL),
('Hotel deLuxe', 45, '2019-06-03', 243, NULL),
('Hotel deLuxe', 45, '2019-06-04', 328, NULL),
('Hotel deLuxe', 45, '2019-06-05', 213, NULL),
('Hotel deLuxe', 45, '2019-06-06', 217, NULL),
('Hotel deLuxe', 45, '2019-06-07', 144, NULL),
('Hotel deLuxe', 45, '2019-06-08', 195, NULL),
('Hotel deLuxe', 45, '2019-06-09', 344, NULL),
('Hotel deLuxe', 45, '2019-06-10', 362, NULL),
('Hotel deLuxe', 45, '2019-06-11', 262, NULL),
('Hotel deLuxe', 45, '2019-06-12', 290, NULL),
('Hotel deLuxe', 45, '2019-06-13', 118, NULL),
('Hotel deLuxe', 45, '2019-06-14', 277, NULL),
('Hotel deLuxe', 45, '2019-06-15', 338, NULL),
('Hotel deLuxe', 45, '2019-06-16', 375, NULL),
('Hotel deLuxe', 45, '2019-06-17', 315, NULL),
('Hotel deLuxe', 45, '2019-06-18', 101, NULL),
('Hotel deLuxe', 45, '2019-06-19', 362, NULL),
('Hotel deLuxe', 45, '2019-06-20', 340, NULL),
('Hotel deLuxe', 45, '2019-06-21', 174, NULL),
('Hotel deLuxe', 45, '2019-06-22', 358, NULL),
('Hotel deLuxe', 45, '2019-06-23', 106, NULL),
('Hotel deLuxe', 45, '2019-06-24', 236, NULL),
('Hotel deLuxe', 45, '2019-06-25', 175, NULL),
('Hotel deLuxe', 45, '2019-06-26', 362, NULL),
('Hotel deLuxe', 45, '2019-06-27', 247, NULL),
('Hotel deLuxe', 45, '2019-06-28', 358, NULL),
('Hotel deLuxe', 45, '2019-06-29', 181, NULL),
('Hotel deLuxe', 45, '2019-06-30', 169, NULL),
('Hotel deLuxe', 45, '2019-07-01', 216, NULL),
('Hotel deLuxe', 45, '2019-07-02', 154, NULL),
('Hotel deLuxe', 45, '2019-07-03', 381, NULL),
('Hotel deLuxe', 45, '2019-07-04', 357, NULL),
('Hotel deLuxe', 45, '2019-07-05', 213, NULL),
('Hotel deLuxe', 45, '2019-07-06', 305, NULL),
('Hotel deLuxe', 45, '2019-07-07', 186, NULL),
('Hotel deLuxe', 45, '2019-07-08', 368, NULL),
('Hotel deLuxe', 45, '2019-07-09', 349, NULL),
('Hotel deLuxe', 45, '2019-07-10', 361, NULL),
('Hotel deLuxe', 45, '2019-07-11', 312, NULL),
('Hotel deLuxe', 45, '2019-07-12', 356, NULL),
('Hotel deLuxe', 45, '2019-07-13', 326, NULL),
('Hotel deLuxe', 45, '2019-07-14', 149, NULL),
('Hotel deLuxe', 45, '2019-07-15', 219, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 45, '2019-07-16', 128, NULL),
('Hotel deLuxe', 45, '2019-07-17', 134, NULL),
('Hotel deLuxe', 45, '2019-07-18', 290, NULL),
('Hotel deLuxe', 45, '2019-07-19', 224, NULL),
('Hotel deLuxe', 45, '2019-07-20', 322, NULL),
('Hotel deLuxe', 45, '2019-07-21', 144, NULL),
('Hotel deLuxe', 45, '2019-07-22', 215, NULL),
('Hotel deLuxe', 45, '2019-07-23', 145, NULL),
('Hotel deLuxe', 45, '2019-07-24', 108, NULL),
('Hotel deLuxe', 45, '2019-07-25', 332, NULL),
('Hotel deLuxe', 45, '2019-07-26', 326, NULL),
('Hotel deLuxe', 45, '2019-07-27', 306, NULL),
('Hotel deLuxe', 45, '2019-07-28', 215, NULL),
('Hotel deLuxe', 45, '2019-07-29', 363, NULL),
('Hotel deLuxe', 45, '2019-07-30', 253, NULL),
('Hotel deLuxe', 45, '2019-07-31', 173, NULL),
('Hotel deLuxe', 45, '2019-08-01', 150, NULL),
('Hotel deLuxe', 45, '2019-08-02', 295, NULL),
('Hotel deLuxe', 45, '2019-08-03', 176, NULL),
('Hotel deLuxe', 45, '2019-08-04', 160, NULL),
('Hotel deLuxe', 45, '2019-08-05', 338, NULL),
('Hotel deLuxe', 45, '2019-08-06', 321, NULL),
('Hotel deLuxe', 45, '2019-08-07', 262, NULL),
('Hotel deLuxe', 45, '2019-08-08', 375, NULL),
('Hotel deLuxe', 45, '2019-08-09', 296, NULL),
('Hotel deLuxe', 45, '2019-08-10', 260, NULL),
('Hotel deLuxe', 45, '2019-08-11', 258, NULL),
('Hotel deLuxe', 45, '2019-08-12', 375, NULL),
('Hotel deLuxe', 45, '2019-08-13', 261, NULL),
('Hotel deLuxe', 45, '2019-08-14', 341, NULL),
('Hotel deLuxe', 45, '2019-08-15', 212, NULL),
('Hotel deLuxe', 45, '2019-08-16', 142, NULL),
('Hotel deLuxe', 45, '2019-08-17', 311, NULL),
('Hotel deLuxe', 45, '2019-08-18', 289, NULL),
('Hotel deLuxe', 45, '2019-08-19', 357, NULL),
('Hotel deLuxe', 45, '2019-08-20', 362, NULL),
('Hotel deLuxe', 45, '2019-08-21', 217, NULL),
('Hotel deLuxe', 45, '2019-08-22', 328, NULL),
('Hotel deLuxe', 45, '2019-08-23', 326, NULL),
('Hotel deLuxe', 45, '2019-08-24', 140, NULL),
('Hotel deLuxe', 45, '2019-08-25', 397, NULL),
('Hotel deLuxe', 45, '2019-08-26', 167, NULL),
('Hotel deLuxe', 45, '2019-08-27', 314, NULL),
('Hotel deLuxe', 45, '2019-08-28', 137, NULL),
('Hotel deLuxe', 45, '2019-08-29', 205, NULL),
('Hotel deLuxe', 45, '2019-08-30', 363, NULL),
('Hotel deLuxe', 45, '2019-08-31', 250, NULL),
('Hotel deLuxe', 45, '2019-09-01', 235, NULL),
('Hotel deLuxe', 45, '2019-09-02', 154, NULL),
('Hotel deLuxe', 45, '2019-09-03', 220, NULL),
('Hotel deLuxe', 45, '2019-09-04', 128, NULL),
('Hotel deLuxe', 45, '2019-09-05', 181, NULL),
('Hotel deLuxe', 45, '2019-09-06', 225, NULL),
('Hotel deLuxe', 45, '2019-09-07', 314, NULL),
('Hotel deLuxe', 45, '2019-09-08', 234, NULL),
('Hotel deLuxe', 45, '2019-09-09', 386, NULL),
('Hotel deLuxe', 45, '2019-09-10', 380, NULL),
('Hotel deLuxe', 45, '2019-09-11', 268, NULL),
('Hotel deLuxe', 45, '2019-09-12', 150, NULL),
('Hotel deLuxe', 45, '2019-09-13', 164, NULL),
('Hotel deLuxe', 45, '2019-09-14', 111, NULL),
('Hotel deLuxe', 45, '2019-09-15', 315, NULL),
('Hotel deLuxe', 45, '2019-09-16', 161, NULL),
('Hotel deLuxe', 45, '2019-09-17', 394, NULL),
('Hotel deLuxe', 45, '2019-09-18', 243, NULL),
('Hotel deLuxe', 45, '2019-09-19', 322, NULL),
('Hotel deLuxe', 45, '2019-09-20', 377, NULL),
('Hotel deLuxe', 45, '2019-09-21', 129, NULL),
('Hotel deLuxe', 45, '2019-09-22', 302, NULL),
('Hotel deLuxe', 45, '2019-09-23', 213, NULL),
('Hotel deLuxe', 45, '2019-09-24', 389, NULL),
('Hotel deLuxe', 45, '2019-09-25', 379, NULL),
('Hotel deLuxe', 45, '2019-09-26', 144, NULL),
('Hotel deLuxe', 45, '2019-09-27', 380, NULL),
('Hotel deLuxe', 45, '2019-09-28', 256, NULL),
('Hotel deLuxe', 45, '2019-09-29', 370, NULL),
('Hotel deLuxe', 45, '2019-09-30', 318, NULL),
('Hotel deLuxe', 45, '2019-10-01', 254, NULL),
('Hotel deLuxe', 45, '2019-10-02', 264, NULL),
('Hotel deLuxe', 45, '2019-10-03', 367, NULL),
('Hotel deLuxe', 45, '2019-10-04', 240, NULL),
('Hotel deLuxe', 45, '2019-10-05', 318, NULL),
('Hotel deLuxe', 45, '2019-10-06', 311, NULL),
('Hotel deLuxe', 45, '2019-10-07', 351, NULL),
('Hotel deLuxe', 45, '2019-10-08', 133, NULL),
('Hotel deLuxe', 45, '2019-10-09', 169, NULL),
('Hotel deLuxe', 45, '2019-10-10', 330, NULL),
('Hotel deLuxe', 45, '2019-10-11', 145, NULL),
('Hotel deLuxe', 45, '2019-10-12', 169, NULL),
('Hotel deLuxe', 45, '2019-10-13', 257, NULL),
('Hotel deLuxe', 45, '2019-10-14', 192, NULL),
('Hotel deLuxe', 45, '2019-10-15', 389, NULL),
('Hotel deLuxe', 45, '2019-10-16', 358, NULL),
('Hotel deLuxe', 45, '2019-10-17', 306, NULL),
('Hotel deLuxe', 45, '2019-10-18', 365, NULL),
('Hotel deLuxe', 45, '2019-10-19', 257, NULL),
('Hotel deLuxe', 45, '2019-10-20', 305, NULL),
('Hotel deLuxe', 45, '2019-10-21', 182, NULL),
('Hotel deLuxe', 45, '2019-10-22', 343, NULL),
('Hotel deLuxe', 45, '2019-10-23', 271, NULL),
('Hotel deLuxe', 45, '2019-10-24', 226, NULL),
('Hotel deLuxe', 45, '2019-10-25', 360, NULL),
('Hotel deLuxe', 45, '2019-10-26', 377, NULL),
('Hotel deLuxe', 45, '2019-10-27', 105, NULL),
('Hotel deLuxe', 45, '2019-10-28', 147, NULL),
('Hotel deLuxe', 45, '2019-10-29', 370, NULL),
('Hotel deLuxe', 45, '2019-10-30', 167, NULL),
('Hotel deLuxe', 45, '2019-10-31', 271, NULL),
('Hotel deLuxe', 45, '2019-11-01', 372, NULL),
('Hotel deLuxe', 45, '2019-11-02', 162, NULL),
('Hotel deLuxe', 45, '2019-11-03', 203, NULL),
('Hotel deLuxe', 45, '2019-11-04', 240, NULL),
('Hotel deLuxe', 45, '2019-11-05', 337, NULL),
('Hotel deLuxe', 45, '2019-11-06', 157, NULL),
('Hotel deLuxe', 45, '2019-11-07', 341, NULL),
('Hotel deLuxe', 45, '2019-11-08', 206, NULL),
('Hotel deLuxe', 45, '2019-11-09', 297, NULL),
('Hotel deLuxe', 45, '2019-11-10', 276, NULL),
('Hotel deLuxe', 45, '2019-11-11', 287, NULL),
('Hotel deLuxe', 45, '2019-11-12', 223, NULL),
('Hotel deLuxe', 45, '2019-11-13', 227, NULL),
('Hotel deLuxe', 45, '2019-11-14', 204, NULL),
('Hotel deLuxe', 45, '2019-11-15', 109, NULL),
('Hotel deLuxe', 45, '2019-11-16', 143, NULL),
('Hotel deLuxe', 45, '2019-11-17', 276, NULL),
('Hotel deLuxe', 45, '2019-11-18', 354, NULL),
('Hotel deLuxe', 45, '2019-11-19', 348, NULL),
('Hotel deLuxe', 45, '2019-11-20', 294, NULL),
('Hotel deLuxe', 45, '2019-11-21', 310, NULL),
('Hotel deLuxe', 45, '2019-11-22', 370, NULL),
('Hotel deLuxe', 45, '2019-11-23', 367, NULL),
('Hotel deLuxe', 45, '2019-11-24', 272, NULL),
('Hotel deLuxe', 45, '2019-11-25', 364, NULL),
('Hotel deLuxe', 45, '2019-11-26', 217, NULL),
('Hotel deLuxe', 45, '2019-11-27', 386, NULL),
('Hotel deLuxe', 45, '2019-11-28', 142, NULL),
('Hotel deLuxe', 45, '2019-11-29', 189, NULL),
('Hotel deLuxe', 45, '2019-11-30', 116, NULL),
('Hotel deLuxe', 45, '2019-12-01', 203, NULL),
('Hotel deLuxe', 45, '2019-12-02', 377, NULL),
('Hotel deLuxe', 45, '2019-12-03', 179, NULL),
('Hotel deLuxe', 45, '2019-12-04', 226, NULL),
('Hotel deLuxe', 45, '2019-12-05', 279, NULL),
('Hotel deLuxe', 45, '2019-12-06', 136, NULL),
('Hotel deLuxe', 45, '2019-12-07', 355, NULL),
('Hotel deLuxe', 45, '2019-12-08', 377, NULL),
('Hotel deLuxe', 45, '2019-12-09', 214, NULL),
('Hotel deLuxe', 45, '2019-12-10', 373, NULL),
('Hotel deLuxe', 45, '2019-12-11', 149, NULL),
('Hotel deLuxe', 45, '2019-12-12', 269, NULL),
('Hotel deLuxe', 45, '2019-12-13', 154, NULL),
('Hotel deLuxe', 45, '2019-12-14', 251, NULL),
('Hotel deLuxe', 45, '2019-12-15', 315, NULL),
('Hotel deLuxe', 45, '2019-12-16', 174, NULL),
('Hotel deLuxe', 45, '2019-12-17', 170, NULL),
('Hotel deLuxe', 45, '2019-12-18', 285, NULL),
('Hotel deLuxe', 45, '2019-12-19', 163, NULL),
('Hotel deLuxe', 45, '2019-12-20', 349, NULL),
('Hotel deLuxe', 45, '2019-12-21', 105, NULL),
('Hotel deLuxe', 45, '2019-12-22', 348, NULL),
('Hotel deLuxe', 45, '2019-12-23', 143, NULL),
('Hotel deLuxe', 45, '2019-12-24', 348, NULL),
('Hotel deLuxe', 45, '2019-12-25', 164, NULL),
('Hotel deLuxe', 45, '2019-12-26', 357, NULL),
('Hotel deLuxe', 45, '2019-12-27', 212, NULL),
('Hotel deLuxe', 45, '2019-12-28', 270, NULL),
('Hotel deLuxe', 45, '2019-12-29', 372, NULL),
('Hotel deLuxe', 45, '2019-12-30', 396, NULL),
('Hotel deLuxe', 45, '2019-12-31', 268, NULL),
('Hotel deLuxe', 45, '2020-01-01', 170, NULL),
('Hotel deLuxe', 45, '2020-01-02', 372, NULL),
('Hotel deLuxe', 45, '2020-01-03', 134, NULL),
('Hotel deLuxe', 45, '2020-01-04', 332, NULL),
('Hotel deLuxe', 45, '2020-01-05', 388, NULL),
('Hotel deLuxe', 45, '2020-01-06', 108, NULL),
('Hotel deLuxe', 45, '2020-01-07', 360, NULL),
('Hotel deLuxe', 45, '2020-01-08', 184, NULL),
('Hotel deLuxe', 45, '2020-01-09', 244, NULL),
('Hotel deLuxe', 45, '2020-01-10', 331, NULL),
('Hotel deLuxe', 45, '2020-01-11', 296, NULL),
('Hotel deLuxe', 45, '2020-01-12', 229, NULL),
('Hotel deLuxe', 45, '2020-01-13', 256, NULL),
('Hotel deLuxe', 45, '2020-01-14', 185, NULL),
('Hotel deLuxe', 45, '2020-01-15', 121, NULL),
('Hotel deLuxe', 45, '2020-01-16', 264, NULL),
('Hotel deLuxe', 45, '2020-01-17', 275, NULL),
('Hotel deLuxe', 45, '2020-01-18', 159, NULL),
('Hotel deLuxe', 45, '2020-01-19', 115, NULL),
('Hotel deLuxe', 45, '2020-01-20', 271, NULL),
('Hotel deLuxe', 45, '2020-01-21', 356, NULL),
('Hotel deLuxe', 45, '2020-01-22', 245, NULL),
('Hotel deLuxe', 45, '2020-01-23', 360, NULL),
('Hotel deLuxe', 45, '2020-01-24', 250, NULL),
('Hotel deLuxe', 45, '2020-01-25', 379, NULL),
('Hotel deLuxe', 45, '2020-01-26', 206, NULL),
('Hotel deLuxe', 45, '2020-01-27', 179, NULL),
('Hotel deLuxe', 45, '2020-01-28', 257, NULL),
('Hotel deLuxe', 45, '2020-01-29', 119, NULL),
('Hotel deLuxe', 45, '2020-01-30', 186, NULL),
('Hotel deLuxe', 45, '2020-01-31', 106, NULL),
('Hotel deLuxe', 45, '2020-02-01', 164, NULL),
('Hotel deLuxe', 45, '2020-02-02', 165, NULL),
('Hotel deLuxe', 45, '2020-02-03', 112, NULL),
('Hotel deLuxe', 45, '2020-02-04', 308, NULL),
('Hotel deLuxe', 50, '2019-01-01', 203, NULL),
('Hotel deLuxe', 50, '2019-01-02', 287, NULL),
('Hotel deLuxe', 50, '2019-01-03', 166, NULL),
('Hotel deLuxe', 50, '2019-01-04', 375, NULL),
('Hotel deLuxe', 50, '2019-01-05', 270, NULL),
('Hotel deLuxe', 50, '2019-01-06', 219, NULL),
('Hotel deLuxe', 50, '2019-01-07', 382, NULL),
('Hotel deLuxe', 50, '2019-01-08', 109, NULL),
('Hotel deLuxe', 50, '2019-01-09', 130, NULL),
('Hotel deLuxe', 50, '2019-01-10', 119, NULL),
('Hotel deLuxe', 50, '2019-01-11', 116, NULL),
('Hotel deLuxe', 50, '2019-01-12', 279, NULL),
('Hotel deLuxe', 50, '2019-01-13', 281, NULL),
('Hotel deLuxe', 50, '2019-01-14', 174, NULL),
('Hotel deLuxe', 50, '2019-01-15', 123, NULL),
('Hotel deLuxe', 50, '2019-01-16', 158, NULL),
('Hotel deLuxe', 50, '2019-01-17', 192, NULL),
('Hotel deLuxe', 50, '2019-01-18', 117, NULL),
('Hotel deLuxe', 50, '2019-01-19', 127, NULL),
('Hotel deLuxe', 50, '2019-01-20', 369, NULL),
('Hotel deLuxe', 50, '2019-01-21', 108, NULL),
('Hotel deLuxe', 50, '2019-01-22', 198, NULL),
('Hotel deLuxe', 50, '2019-01-23', 142, NULL),
('Hotel deLuxe', 50, '2019-01-24', 363, NULL),
('Hotel deLuxe', 50, '2019-01-25', 175, NULL),
('Hotel deLuxe', 50, '2019-01-26', 267, NULL),
('Hotel deLuxe', 50, '2019-01-27', 367, NULL),
('Hotel deLuxe', 50, '2019-01-28', 326, NULL),
('Hotel deLuxe', 50, '2019-01-29', 332, NULL),
('Hotel deLuxe', 50, '2019-01-30', 160, NULL),
('Hotel deLuxe', 50, '2019-01-31', 260, NULL),
('Hotel deLuxe', 50, '2019-02-01', 342, NULL),
('Hotel deLuxe', 50, '2019-02-02', 304, NULL),
('Hotel deLuxe', 50, '2019-02-03', 331, NULL),
('Hotel deLuxe', 50, '2019-02-04', 299, NULL),
('Hotel deLuxe', 50, '2019-02-05', 346, NULL),
('Hotel deLuxe', 50, '2019-02-06', 399, NULL),
('Hotel deLuxe', 50, '2019-02-07', 229, NULL),
('Hotel deLuxe', 50, '2019-02-08', 211, NULL),
('Hotel deLuxe', 50, '2019-02-09', 141, NULL),
('Hotel deLuxe', 50, '2019-02-10', 211, NULL),
('Hotel deLuxe', 50, '2019-02-11', 144, NULL),
('Hotel deLuxe', 50, '2019-02-12', 284, NULL),
('Hotel deLuxe', 50, '2019-02-13', 137, NULL),
('Hotel deLuxe', 50, '2019-02-14', 328, NULL),
('Hotel deLuxe', 50, '2019-02-15', 242, NULL),
('Hotel deLuxe', 50, '2019-02-16', 357, NULL),
('Hotel deLuxe', 50, '2019-02-17', 325, NULL),
('Hotel deLuxe', 50, '2019-02-18', 323, NULL),
('Hotel deLuxe', 50, '2019-02-19', 366, NULL),
('Hotel deLuxe', 50, '2019-02-20', 395, NULL),
('Hotel deLuxe', 50, '2019-02-21', 127, NULL),
('Hotel deLuxe', 50, '2019-02-22', 141, NULL),
('Hotel deLuxe', 50, '2019-02-23', 179, NULL),
('Hotel deLuxe', 50, '2019-02-24', 156, NULL),
('Hotel deLuxe', 50, '2019-02-25', 235, NULL),
('Hotel deLuxe', 50, '2019-02-26', 290, NULL),
('Hotel deLuxe', 50, '2019-02-27', 233, NULL),
('Hotel deLuxe', 50, '2019-02-28', 221, NULL),
('Hotel deLuxe', 50, '2019-03-01', 296, NULL),
('Hotel deLuxe', 50, '2019-03-02', 290, NULL),
('Hotel deLuxe', 50, '2019-03-03', 342, NULL),
('Hotel deLuxe', 50, '2019-03-04', 201, NULL),
('Hotel deLuxe', 50, '2019-03-05', 270, NULL),
('Hotel deLuxe', 50, '2019-03-06', 240, NULL),
('Hotel deLuxe', 50, '2019-03-07', 263, NULL),
('Hotel deLuxe', 50, '2019-03-08', 258, NULL),
('Hotel deLuxe', 50, '2019-03-09', 115, NULL),
('Hotel deLuxe', 50, '2019-03-10', 183, NULL),
('Hotel deLuxe', 50, '2019-03-11', 125, NULL),
('Hotel deLuxe', 50, '2019-03-12', 337, NULL),
('Hotel deLuxe', 50, '2019-03-13', 232, NULL),
('Hotel deLuxe', 50, '2019-03-14', 222, NULL),
('Hotel deLuxe', 50, '2019-03-15', 105, NULL),
('Hotel deLuxe', 50, '2019-03-16', 353, NULL),
('Hotel deLuxe', 50, '2019-03-17', 107, NULL),
('Hotel deLuxe', 50, '2019-03-18', 218, NULL),
('Hotel deLuxe', 50, '2019-03-19', 341, NULL),
('Hotel deLuxe', 50, '2019-03-20', 384, NULL),
('Hotel deLuxe', 50, '2019-03-21', 191, NULL),
('Hotel deLuxe', 50, '2019-03-22', 145, NULL),
('Hotel deLuxe', 50, '2019-03-23', 131, NULL),
('Hotel deLuxe', 50, '2019-03-24', 247, NULL),
('Hotel deLuxe', 50, '2019-03-25', 137, NULL),
('Hotel deLuxe', 50, '2019-03-26', 149, NULL),
('Hotel deLuxe', 50, '2019-03-27', 362, NULL),
('Hotel deLuxe', 50, '2019-03-28', 219, NULL),
('Hotel deLuxe', 50, '2019-03-29', 259, NULL),
('Hotel deLuxe', 50, '2019-03-30', 133, NULL),
('Hotel deLuxe', 50, '2019-03-31', 339, NULL),
('Hotel deLuxe', 50, '2019-04-01', 203, NULL),
('Hotel deLuxe', 50, '2019-04-02', 342, NULL),
('Hotel deLuxe', 50, '2019-04-03', 129, NULL),
('Hotel deLuxe', 50, '2019-04-04', 172, NULL),
('Hotel deLuxe', 50, '2019-04-05', 260, NULL),
('Hotel deLuxe', 50, '2019-04-06', 106, NULL),
('Hotel deLuxe', 50, '2019-04-07', 269, NULL),
('Hotel deLuxe', 50, '2019-04-08', 162, NULL),
('Hotel deLuxe', 50, '2019-04-09', 141, NULL),
('Hotel deLuxe', 50, '2019-04-10', 345, NULL),
('Hotel deLuxe', 50, '2019-04-11', 354, NULL),
('Hotel deLuxe', 50, '2019-04-12', 371, NULL),
('Hotel deLuxe', 50, '2019-04-13', 348, NULL),
('Hotel deLuxe', 50, '2019-04-14', 119, NULL),
('Hotel deLuxe', 50, '2019-04-15', 261, NULL),
('Hotel deLuxe', 50, '2019-04-16', 153, NULL),
('Hotel deLuxe', 50, '2019-04-17', 287, NULL),
('Hotel deLuxe', 50, '2019-04-18', 232, NULL),
('Hotel deLuxe', 50, '2019-04-19', 204, NULL),
('Hotel deLuxe', 50, '2019-04-20', 246, NULL),
('Hotel deLuxe', 50, '2019-04-21', 302, NULL),
('Hotel deLuxe', 50, '2019-04-22', 106, NULL),
('Hotel deLuxe', 50, '2019-04-23', 353, NULL),
('Hotel deLuxe', 50, '2019-04-24', 358, NULL),
('Hotel deLuxe', 50, '2019-04-25', 224, NULL),
('Hotel deLuxe', 50, '2019-04-26', 342, NULL),
('Hotel deLuxe', 50, '2019-04-27', 177, NULL),
('Hotel deLuxe', 50, '2019-04-28', 350, NULL),
('Hotel deLuxe', 50, '2019-04-29', 267, NULL),
('Hotel deLuxe', 50, '2019-04-30', 365, NULL),
('Hotel deLuxe', 50, '2019-05-01', 348, NULL),
('Hotel deLuxe', 50, '2019-05-02', 382, NULL),
('Hotel deLuxe', 50, '2019-05-03', 271, NULL),
('Hotel deLuxe', 50, '2019-05-04', 237, NULL),
('Hotel deLuxe', 50, '2019-05-05', 159, NULL),
('Hotel deLuxe', 50, '2019-05-06', 136, NULL),
('Hotel deLuxe', 50, '2019-05-07', 309, NULL),
('Hotel deLuxe', 50, '2019-05-08', 156, NULL),
('Hotel deLuxe', 50, '2019-05-09', 311, NULL),
('Hotel deLuxe', 50, '2019-05-10', 101, NULL),
('Hotel deLuxe', 50, '2019-05-11', 293, NULL),
('Hotel deLuxe', 50, '2019-05-12', 262, NULL),
('Hotel deLuxe', 50, '2019-05-13', 141, NULL),
('Hotel deLuxe', 50, '2019-05-14', 181, NULL),
('Hotel deLuxe', 50, '2019-05-15', 359, NULL),
('Hotel deLuxe', 50, '2019-05-16', 107, NULL),
('Hotel deLuxe', 50, '2019-05-17', 235, NULL),
('Hotel deLuxe', 50, '2019-05-18', 270, NULL),
('Hotel deLuxe', 50, '2019-05-19', 300, NULL),
('Hotel deLuxe', 50, '2019-05-20', 277, NULL),
('Hotel deLuxe', 50, '2019-05-21', 159, NULL),
('Hotel deLuxe', 50, '2019-05-22', 110, NULL),
('Hotel deLuxe', 50, '2019-05-23', 186, NULL),
('Hotel deLuxe', 50, '2019-05-24', 165, NULL),
('Hotel deLuxe', 50, '2019-05-25', 169, NULL),
('Hotel deLuxe', 50, '2019-05-26', 361, NULL),
('Hotel deLuxe', 50, '2019-05-27', 210, NULL),
('Hotel deLuxe', 50, '2019-05-28', 380, NULL),
('Hotel deLuxe', 50, '2019-05-29', 357, NULL),
('Hotel deLuxe', 50, '2019-05-30', 252, NULL),
('Hotel deLuxe', 50, '2019-05-31', 354, NULL),
('Hotel deLuxe', 50, '2019-06-01', 131, NULL),
('Hotel deLuxe', 50, '2019-06-02', 162, NULL),
('Hotel deLuxe', 50, '2019-06-03', 210, NULL),
('Hotel deLuxe', 50, '2019-06-04', 150, NULL),
('Hotel deLuxe', 50, '2019-06-05', 385, NULL),
('Hotel deLuxe', 50, '2019-06-06', 275, NULL),
('Hotel deLuxe', 50, '2019-06-07', 110, NULL),
('Hotel deLuxe', 50, '2019-06-08', 369, NULL),
('Hotel deLuxe', 50, '2019-06-09', 137, NULL),
('Hotel deLuxe', 50, '2019-06-10', 185, NULL),
('Hotel deLuxe', 50, '2019-06-11', 325, NULL),
('Hotel deLuxe', 50, '2019-06-12', 211, NULL),
('Hotel deLuxe', 50, '2019-06-13', 136, NULL),
('Hotel deLuxe', 50, '2019-06-14', 392, NULL),
('Hotel deLuxe', 50, '2019-06-15', 143, NULL),
('Hotel deLuxe', 50, '2019-06-16', 250, NULL),
('Hotel deLuxe', 50, '2019-06-17', 261, NULL),
('Hotel deLuxe', 50, '2019-06-18', 228, NULL),
('Hotel deLuxe', 50, '2019-06-19', 167, NULL),
('Hotel deLuxe', 50, '2019-06-20', 358, NULL),
('Hotel deLuxe', 50, '2019-06-21', 385, NULL),
('Hotel deLuxe', 50, '2019-06-22', 376, NULL),
('Hotel deLuxe', 50, '2019-06-23', 249, NULL),
('Hotel deLuxe', 50, '2019-06-24', 300, NULL),
('Hotel deLuxe', 50, '2019-06-25', 113, NULL),
('Hotel deLuxe', 50, '2019-06-26', 323, NULL),
('Hotel deLuxe', 50, '2019-06-27', 338, NULL),
('Hotel deLuxe', 50, '2019-06-28', 176, NULL),
('Hotel deLuxe', 50, '2019-06-29', 102, NULL),
('Hotel deLuxe', 50, '2019-06-30', 231, NULL),
('Hotel deLuxe', 50, '2019-07-01', 230, NULL),
('Hotel deLuxe', 50, '2019-07-02', 388, NULL),
('Hotel deLuxe', 50, '2019-07-03', 279, NULL),
('Hotel deLuxe', 50, '2019-07-04', 131, NULL),
('Hotel deLuxe', 50, '2019-07-05', 229, NULL),
('Hotel deLuxe', 50, '2019-07-06', 116, NULL),
('Hotel deLuxe', 50, '2019-07-07', 384, NULL),
('Hotel deLuxe', 50, '2019-07-08', 303, NULL),
('Hotel deLuxe', 50, '2019-07-09', 135, NULL),
('Hotel deLuxe', 50, '2019-07-10', 280, NULL),
('Hotel deLuxe', 50, '2019-07-11', 160, NULL),
('Hotel deLuxe', 50, '2019-07-12', 275, NULL),
('Hotel deLuxe', 50, '2019-07-13', 308, NULL),
('Hotel deLuxe', 50, '2019-07-14', 217, NULL),
('Hotel deLuxe', 50, '2019-07-15', 339, NULL),
('Hotel deLuxe', 50, '2019-07-16', 111, NULL),
('Hotel deLuxe', 50, '2019-07-17', 354, NULL),
('Hotel deLuxe', 50, '2019-07-18', 340, NULL),
('Hotel deLuxe', 50, '2019-07-19', 145, NULL),
('Hotel deLuxe', 50, '2019-07-20', 374, NULL),
('Hotel deLuxe', 50, '2019-07-21', 352, NULL),
('Hotel deLuxe', 50, '2019-07-22', 397, NULL),
('Hotel deLuxe', 50, '2019-07-23', 260, NULL),
('Hotel deLuxe', 50, '2019-07-24', 128, NULL),
('Hotel deLuxe', 50, '2019-07-25', 161, NULL),
('Hotel deLuxe', 50, '2019-07-26', 240, NULL),
('Hotel deLuxe', 50, '2019-07-27', 275, NULL),
('Hotel deLuxe', 50, '2019-07-28', 169, NULL),
('Hotel deLuxe', 50, '2019-07-29', 111, NULL),
('Hotel deLuxe', 50, '2019-07-30', 191, NULL),
('Hotel deLuxe', 50, '2019-07-31', 319, NULL),
('Hotel deLuxe', 50, '2019-08-01', 357, NULL),
('Hotel deLuxe', 50, '2019-08-02', 353, NULL),
('Hotel deLuxe', 50, '2019-08-03', 347, NULL),
('Hotel deLuxe', 50, '2019-08-04', 304, NULL),
('Hotel deLuxe', 50, '2019-08-05', 289, NULL),
('Hotel deLuxe', 50, '2019-08-06', 189, NULL),
('Hotel deLuxe', 50, '2019-08-07', 226, NULL),
('Hotel deLuxe', 50, '2019-08-08', 136, NULL),
('Hotel deLuxe', 50, '2019-08-09', 381, NULL),
('Hotel deLuxe', 50, '2019-08-10', 239, NULL),
('Hotel deLuxe', 50, '2019-08-11', 314, NULL),
('Hotel deLuxe', 50, '2019-08-12', 222, NULL),
('Hotel deLuxe', 50, '2019-08-13', 152, NULL),
('Hotel deLuxe', 50, '2019-08-14', 310, NULL),
('Hotel deLuxe', 50, '2019-08-15', 142, NULL),
('Hotel deLuxe', 50, '2019-08-16', 158, NULL),
('Hotel deLuxe', 50, '2019-08-17', 110, NULL),
('Hotel deLuxe', 50, '2019-08-18', 310, NULL),
('Hotel deLuxe', 50, '2019-08-19', 276, NULL),
('Hotel deLuxe', 50, '2019-08-20', 119, NULL),
('Hotel deLuxe', 50, '2019-08-21', 349, NULL),
('Hotel deLuxe', 50, '2019-08-22', 184, NULL),
('Hotel deLuxe', 50, '2019-08-23', 248, NULL),
('Hotel deLuxe', 50, '2019-08-24', 241, NULL),
('Hotel deLuxe', 50, '2019-08-25', 323, NULL),
('Hotel deLuxe', 50, '2019-08-26', 285, NULL),
('Hotel deLuxe', 50, '2019-08-27', 232, NULL),
('Hotel deLuxe', 50, '2019-08-28', 318, NULL),
('Hotel deLuxe', 50, '2019-08-29', 295, NULL),
('Hotel deLuxe', 50, '2019-08-30', 247, NULL),
('Hotel deLuxe', 50, '2019-08-31', 127, NULL),
('Hotel deLuxe', 50, '2019-09-01', 199, NULL),
('Hotel deLuxe', 50, '2019-09-02', 331, NULL),
('Hotel deLuxe', 50, '2019-09-03', 114, NULL),
('Hotel deLuxe', 50, '2019-09-04', 206, NULL),
('Hotel deLuxe', 50, '2019-09-05', 163, NULL),
('Hotel deLuxe', 50, '2019-09-06', 302, NULL),
('Hotel deLuxe', 50, '2019-09-07', 202, NULL),
('Hotel deLuxe', 50, '2019-09-08', 159, NULL),
('Hotel deLuxe', 50, '2019-09-09', 149, NULL),
('Hotel deLuxe', 50, '2019-09-10', 371, NULL),
('Hotel deLuxe', 50, '2019-09-11', 283, NULL),
('Hotel deLuxe', 50, '2019-09-12', 260, NULL),
('Hotel deLuxe', 50, '2019-09-13', 227, NULL),
('Hotel deLuxe', 50, '2019-09-14', 252, NULL),
('Hotel deLuxe', 50, '2019-09-15', 352, NULL),
('Hotel deLuxe', 50, '2019-09-16', 335, NULL),
('Hotel deLuxe', 50, '2019-09-17', 380, NULL),
('Hotel deLuxe', 50, '2019-09-18', 199, NULL),
('Hotel deLuxe', 50, '2019-09-19', 383, NULL),
('Hotel deLuxe', 50, '2019-09-20', 217, NULL),
('Hotel deLuxe', 50, '2019-09-21', 324, NULL),
('Hotel deLuxe', 50, '2019-09-22', 375, NULL),
('Hotel deLuxe', 50, '2019-09-23', 331, NULL),
('Hotel deLuxe', 50, '2019-09-24', 215, NULL),
('Hotel deLuxe', 50, '2019-09-25', 272, NULL),
('Hotel deLuxe', 50, '2019-09-26', 362, NULL),
('Hotel deLuxe', 50, '2019-09-27', 246, NULL),
('Hotel deLuxe', 50, '2019-09-28', 368, NULL),
('Hotel deLuxe', 50, '2019-09-29', 368, NULL),
('Hotel deLuxe', 50, '2019-09-30', 270, NULL),
('Hotel deLuxe', 50, '2019-10-01', 255, NULL),
('Hotel deLuxe', 50, '2019-10-02', 199, NULL),
('Hotel deLuxe', 50, '2019-10-03', 322, NULL),
('Hotel deLuxe', 50, '2019-10-04', 214, NULL),
('Hotel deLuxe', 50, '2019-10-05', 384, NULL),
('Hotel deLuxe', 50, '2019-10-06', 201, NULL),
('Hotel deLuxe', 50, '2019-10-07', 192, NULL),
('Hotel deLuxe', 50, '2019-10-08', 247, NULL),
('Hotel deLuxe', 50, '2019-10-09', 238, NULL),
('Hotel deLuxe', 50, '2019-10-10', 236, NULL),
('Hotel deLuxe', 50, '2019-10-11', 359, NULL),
('Hotel deLuxe', 50, '2019-10-12', 120, NULL),
('Hotel deLuxe', 50, '2019-10-13', 195, NULL),
('Hotel deLuxe', 50, '2019-10-14', 319, NULL),
('Hotel deLuxe', 50, '2019-10-15', 240, NULL),
('Hotel deLuxe', 50, '2019-10-16', 223, NULL),
('Hotel deLuxe', 50, '2019-10-17', 269, NULL),
('Hotel deLuxe', 50, '2019-10-18', 185, NULL),
('Hotel deLuxe', 50, '2019-10-19', 178, NULL),
('Hotel deLuxe', 50, '2019-10-20', 340, NULL),
('Hotel deLuxe', 50, '2019-10-21', 375, NULL),
('Hotel deLuxe', 50, '2019-10-22', 158, NULL),
('Hotel deLuxe', 50, '2019-10-23', 208, NULL),
('Hotel deLuxe', 50, '2019-10-24', 350, NULL),
('Hotel deLuxe', 50, '2019-10-25', 193, NULL),
('Hotel deLuxe', 50, '2019-10-26', 292, NULL),
('Hotel deLuxe', 50, '2019-10-27', 310, NULL),
('Hotel deLuxe', 50, '2019-10-28', 263, NULL),
('Hotel deLuxe', 50, '2019-10-29', 348, NULL),
('Hotel deLuxe', 50, '2019-10-30', 229, NULL),
('Hotel deLuxe', 50, '2019-10-31', 303, NULL),
('Hotel deLuxe', 50, '2019-11-01', 258, NULL),
('Hotel deLuxe', 50, '2019-11-02', 256, NULL),
('Hotel deLuxe', 50, '2019-11-03', 124, NULL),
('Hotel deLuxe', 50, '2019-11-04', 197, NULL),
('Hotel deLuxe', 50, '2019-11-05', 311, NULL),
('Hotel deLuxe', 50, '2019-11-06', 222, NULL),
('Hotel deLuxe', 50, '2019-11-07', 362, NULL),
('Hotel deLuxe', 50, '2019-11-08', 224, NULL),
('Hotel deLuxe', 50, '2019-11-09', 218, NULL),
('Hotel deLuxe', 50, '2019-11-10', 336, NULL),
('Hotel deLuxe', 50, '2019-11-11', 273, NULL),
('Hotel deLuxe', 50, '2019-11-12', 297, NULL),
('Hotel deLuxe', 50, '2019-11-13', 209, NULL),
('Hotel deLuxe', 50, '2019-11-14', 224, NULL),
('Hotel deLuxe', 50, '2019-11-15', 188, NULL),
('Hotel deLuxe', 50, '2019-11-16', 377, NULL),
('Hotel deLuxe', 50, '2019-11-17', 143, NULL),
('Hotel deLuxe', 50, '2019-11-18', 231, NULL),
('Hotel deLuxe', 50, '2019-11-19', 102, NULL),
('Hotel deLuxe', 50, '2019-11-20', 360, NULL),
('Hotel deLuxe', 50, '2019-11-21', 376, NULL),
('Hotel deLuxe', 50, '2019-11-22', 267, NULL),
('Hotel deLuxe', 50, '2019-11-23', 246, NULL),
('Hotel deLuxe', 50, '2019-11-24', 363, NULL),
('Hotel deLuxe', 50, '2019-11-25', 201, NULL),
('Hotel deLuxe', 50, '2019-11-26', 292, NULL),
('Hotel deLuxe', 50, '2019-11-27', 314, NULL),
('Hotel deLuxe', 50, '2019-11-28', 339, NULL),
('Hotel deLuxe', 50, '2019-11-29', 386, NULL),
('Hotel deLuxe', 50, '2019-11-30', 304, NULL),
('Hotel deLuxe', 50, '2019-12-01', 393, NULL),
('Hotel deLuxe', 50, '2019-12-02', 298, NULL),
('Hotel deLuxe', 50, '2019-12-03', 184, NULL),
('Hotel deLuxe', 50, '2019-12-04', 371, NULL),
('Hotel deLuxe', 50, '2019-12-05', 372, NULL),
('Hotel deLuxe', 50, '2019-12-06', 135, NULL),
('Hotel deLuxe', 50, '2019-12-07', 374, NULL),
('Hotel deLuxe', 50, '2019-12-08', 332, NULL),
('Hotel deLuxe', 50, '2019-12-09', 229, NULL),
('Hotel deLuxe', 50, '2019-12-10', 102, NULL),
('Hotel deLuxe', 50, '2019-12-11', 200, NULL),
('Hotel deLuxe', 50, '2019-12-12', 142, NULL),
('Hotel deLuxe', 50, '2019-12-13', 117, NULL),
('Hotel deLuxe', 50, '2019-12-14', 248, NULL),
('Hotel deLuxe', 50, '2019-12-15', 129, NULL),
('Hotel deLuxe', 50, '2019-12-16', 273, NULL),
('Hotel deLuxe', 50, '2019-12-17', 323, NULL),
('Hotel deLuxe', 50, '2019-12-18', 357, NULL),
('Hotel deLuxe', 50, '2019-12-19', 134, NULL),
('Hotel deLuxe', 50, '2019-12-20', 210, NULL),
('Hotel deLuxe', 50, '2019-12-21', 332, NULL),
('Hotel deLuxe', 50, '2019-12-22', 308, NULL),
('Hotel deLuxe', 50, '2019-12-23', 112, NULL),
('Hotel deLuxe', 50, '2019-12-24', 212, NULL),
('Hotel deLuxe', 50, '2019-12-25', 317, NULL),
('Hotel deLuxe', 50, '2019-12-26', 357, NULL),
('Hotel deLuxe', 50, '2019-12-27', 245, NULL),
('Hotel deLuxe', 50, '2019-12-28', 123, NULL),
('Hotel deLuxe', 50, '2019-12-29', 371, NULL),
('Hotel deLuxe', 50, '2019-12-30', 233, NULL),
('Hotel deLuxe', 50, '2019-12-31', 236, NULL),
('Hotel deLuxe', 50, '2020-01-01', 227, NULL),
('Hotel deLuxe', 50, '2020-01-02', 289, NULL),
('Hotel deLuxe', 50, '2020-01-03', 140, NULL),
('Hotel deLuxe', 50, '2020-01-04', 330, NULL),
('Hotel deLuxe', 50, '2020-01-05', 377, NULL),
('Hotel deLuxe', 50, '2020-01-06', 171, NULL),
('Hotel deLuxe', 50, '2020-01-07', 388, NULL),
('Hotel deLuxe', 50, '2020-01-08', 275, NULL),
('Hotel deLuxe', 50, '2020-01-09', 142, NULL),
('Hotel deLuxe', 50, '2020-01-10', 274, NULL),
('Hotel deLuxe', 50, '2020-01-11', 215, NULL),
('Hotel deLuxe', 50, '2020-01-12', 153, NULL),
('Hotel deLuxe', 50, '2020-01-13', 119, NULL),
('Hotel deLuxe', 50, '2020-01-14', 386, NULL),
('Hotel deLuxe', 50, '2020-01-15', 263, NULL),
('Hotel deLuxe', 50, '2020-01-16', 391, NULL),
('Hotel deLuxe', 50, '2020-01-17', 122, NULL),
('Hotel deLuxe', 50, '2020-01-18', 192, NULL),
('Hotel deLuxe', 50, '2020-01-19', 287, NULL),
('Hotel deLuxe', 50, '2020-01-20', 354, NULL),
('Hotel deLuxe', 50, '2020-01-21', 242, NULL),
('Hotel deLuxe', 50, '2020-01-22', 241, NULL),
('Hotel deLuxe', 50, '2020-01-23', 313, NULL),
('Hotel deLuxe', 50, '2020-01-24', 329, NULL),
('Hotel deLuxe', 50, '2020-01-25', 215, NULL),
('Hotel deLuxe', 50, '2020-01-26', 164, NULL),
('Hotel deLuxe', 50, '2020-01-27', 241, NULL),
('Hotel deLuxe', 50, '2020-01-28', 232, NULL),
('Hotel deLuxe', 50, '2020-01-29', 314, NULL),
('Hotel deLuxe', 50, '2020-01-30', 385, NULL),
('Hotel deLuxe', 50, '2020-01-31', 136, NULL),
('Hotel deLuxe', 50, '2020-02-01', 233, NULL),
('Hotel deLuxe', 50, '2020-02-02', 202, NULL),
('Hotel deLuxe', 50, '2020-02-03', 119, NULL),
('Hotel deLuxe', 50, '2020-02-04', 372, NULL),
('Hotel deLuxe', 51, '2019-01-01', 181, NULL),
('Hotel deLuxe', 51, '2019-01-02', 146, NULL),
('Hotel deLuxe', 51, '2019-01-03', 316, NULL),
('Hotel deLuxe', 51, '2019-01-04', 183, NULL),
('Hotel deLuxe', 51, '2019-01-05', 240, NULL),
('Hotel deLuxe', 51, '2019-01-06', 392, NULL),
('Hotel deLuxe', 51, '2019-01-07', 108, NULL),
('Hotel deLuxe', 51, '2019-01-08', 144, NULL),
('Hotel deLuxe', 51, '2019-01-09', 161, NULL),
('Hotel deLuxe', 51, '2019-01-10', 276, NULL),
('Hotel deLuxe', 51, '2019-01-11', 172, NULL),
('Hotel deLuxe', 51, '2019-01-12', 147, NULL),
('Hotel deLuxe', 51, '2019-01-13', 190, NULL),
('Hotel deLuxe', 51, '2019-01-14', 237, NULL),
('Hotel deLuxe', 51, '2019-01-15', 355, NULL),
('Hotel deLuxe', 51, '2019-01-16', 217, NULL),
('Hotel deLuxe', 51, '2019-01-17', 378, NULL),
('Hotel deLuxe', 51, '2019-01-18', 266, NULL),
('Hotel deLuxe', 51, '2019-01-19', 375, NULL),
('Hotel deLuxe', 51, '2019-01-20', 308, NULL),
('Hotel deLuxe', 51, '2019-01-21', 389, NULL),
('Hotel deLuxe', 51, '2019-01-22', 134, NULL),
('Hotel deLuxe', 51, '2019-01-23', 254, NULL),
('Hotel deLuxe', 51, '2019-01-24', 217, NULL),
('Hotel deLuxe', 51, '2019-01-25', 107, NULL),
('Hotel deLuxe', 51, '2019-01-26', 361, NULL),
('Hotel deLuxe', 51, '2019-01-27', 270, NULL),
('Hotel deLuxe', 51, '2019-01-28', 341, NULL),
('Hotel deLuxe', 51, '2019-01-29', 300, NULL),
('Hotel deLuxe', 51, '2019-01-30', 287, NULL),
('Hotel deLuxe', 51, '2019-01-31', 186, NULL),
('Hotel deLuxe', 51, '2019-02-01', 317, NULL),
('Hotel deLuxe', 51, '2019-02-02', 195, NULL),
('Hotel deLuxe', 51, '2019-02-03', 224, NULL),
('Hotel deLuxe', 51, '2019-02-04', 186, NULL),
('Hotel deLuxe', 51, '2019-02-05', 156, NULL),
('Hotel deLuxe', 51, '2019-02-06', 178, NULL),
('Hotel deLuxe', 51, '2019-02-07', 267, NULL),
('Hotel deLuxe', 51, '2019-02-08', 255, NULL),
('Hotel deLuxe', 51, '2019-02-09', 262, NULL),
('Hotel deLuxe', 51, '2019-02-10', 386, NULL),
('Hotel deLuxe', 51, '2019-02-11', 315, NULL),
('Hotel deLuxe', 51, '2019-02-12', 256, NULL),
('Hotel deLuxe', 51, '2019-02-13', 382, NULL),
('Hotel deLuxe', 51, '2019-02-14', 371, NULL),
('Hotel deLuxe', 51, '2019-02-15', 342, NULL),
('Hotel deLuxe', 51, '2019-02-16', 340, NULL),
('Hotel deLuxe', 51, '2019-02-17', 111, NULL),
('Hotel deLuxe', 51, '2019-02-18', 306, NULL),
('Hotel deLuxe', 51, '2019-02-19', 183, NULL),
('Hotel deLuxe', 51, '2019-02-20', 240, NULL),
('Hotel deLuxe', 51, '2019-02-21', 240, NULL),
('Hotel deLuxe', 51, '2019-02-22', 208, NULL),
('Hotel deLuxe', 51, '2019-02-23', 220, NULL),
('Hotel deLuxe', 51, '2019-02-24', 293, NULL),
('Hotel deLuxe', 51, '2019-02-25', 176, NULL),
('Hotel deLuxe', 51, '2019-02-26', 364, NULL),
('Hotel deLuxe', 51, '2019-02-27', 168, NULL),
('Hotel deLuxe', 51, '2019-02-28', 244, NULL),
('Hotel deLuxe', 51, '2019-03-01', 224, NULL),
('Hotel deLuxe', 51, '2019-03-02', 170, NULL),
('Hotel deLuxe', 51, '2019-03-03', 203, NULL),
('Hotel deLuxe', 51, '2019-03-04', 357, NULL),
('Hotel deLuxe', 51, '2019-03-05', 166, NULL),
('Hotel deLuxe', 51, '2019-03-06', 214, NULL),
('Hotel deLuxe', 51, '2019-03-07', 354, NULL),
('Hotel deLuxe', 51, '2019-03-08', 286, NULL),
('Hotel deLuxe', 51, '2019-03-09', 157, NULL),
('Hotel deLuxe', 51, '2019-03-10', 204, NULL),
('Hotel deLuxe', 51, '2019-03-11', 223, NULL),
('Hotel deLuxe', 51, '2019-03-12', 246, NULL),
('Hotel deLuxe', 51, '2019-03-13', 353, NULL),
('Hotel deLuxe', 51, '2019-03-14', 138, NULL),
('Hotel deLuxe', 51, '2019-03-15', 283, NULL),
('Hotel deLuxe', 51, '2019-03-16', 269, NULL),
('Hotel deLuxe', 51, '2019-03-17', 247, NULL),
('Hotel deLuxe', 51, '2019-03-18', 284, NULL),
('Hotel deLuxe', 51, '2019-03-19', 362, NULL),
('Hotel deLuxe', 51, '2019-03-20', 118, NULL),
('Hotel deLuxe', 51, '2019-03-21', 137, NULL),
('Hotel deLuxe', 51, '2019-03-22', 150, NULL),
('Hotel deLuxe', 51, '2019-03-23', 167, NULL),
('Hotel deLuxe', 51, '2019-03-24', 155, NULL),
('Hotel deLuxe', 51, '2019-03-25', 135, NULL),
('Hotel deLuxe', 51, '2019-03-26', 273, NULL),
('Hotel deLuxe', 51, '2019-03-27', 323, NULL),
('Hotel deLuxe', 51, '2019-03-28', 263, NULL),
('Hotel deLuxe', 51, '2019-03-29', 161, NULL),
('Hotel deLuxe', 51, '2019-03-30', 354, NULL),
('Hotel deLuxe', 51, '2019-03-31', 338, NULL),
('Hotel deLuxe', 51, '2019-04-01', 185, NULL),
('Hotel deLuxe', 51, '2019-04-02', 271, NULL),
('Hotel deLuxe', 51, '2019-04-03', 218, NULL),
('Hotel deLuxe', 51, '2019-04-04', 250, NULL),
('Hotel deLuxe', 51, '2019-04-05', 179, NULL),
('Hotel deLuxe', 51, '2019-04-06', 199, NULL),
('Hotel deLuxe', 51, '2019-04-07', 296, NULL),
('Hotel deLuxe', 51, '2019-04-08', 268, NULL),
('Hotel deLuxe', 51, '2019-04-09', 285, NULL),
('Hotel deLuxe', 51, '2019-04-10', 342, NULL),
('Hotel deLuxe', 51, '2019-04-11', 291, NULL),
('Hotel deLuxe', 51, '2019-04-12', 268, NULL),
('Hotel deLuxe', 51, '2019-04-13', 288, NULL),
('Hotel deLuxe', 51, '2019-04-14', 200, NULL),
('Hotel deLuxe', 51, '2019-04-15', 328, NULL),
('Hotel deLuxe', 51, '2019-04-16', 300, NULL),
('Hotel deLuxe', 51, '2019-04-17', 364, NULL),
('Hotel deLuxe', 51, '2019-04-18', 363, NULL),
('Hotel deLuxe', 51, '2019-04-19', 270, NULL),
('Hotel deLuxe', 51, '2019-04-20', 373, NULL),
('Hotel deLuxe', 51, '2019-04-21', 276, NULL),
('Hotel deLuxe', 51, '2019-04-22', 364, NULL),
('Hotel deLuxe', 51, '2019-04-23', 227, NULL),
('Hotel deLuxe', 51, '2019-04-24', 126, NULL),
('Hotel deLuxe', 51, '2019-04-25', 108, NULL),
('Hotel deLuxe', 51, '2019-04-26', 134, NULL),
('Hotel deLuxe', 51, '2019-04-27', 275, NULL),
('Hotel deLuxe', 51, '2019-04-28', 373, NULL),
('Hotel deLuxe', 51, '2019-04-29', 296, NULL),
('Hotel deLuxe', 51, '2019-04-30', 334, NULL),
('Hotel deLuxe', 51, '2019-05-01', 230, NULL),
('Hotel deLuxe', 51, '2019-05-02', 253, NULL),
('Hotel deLuxe', 51, '2019-05-03', 207, NULL),
('Hotel deLuxe', 51, '2019-05-04', 268, NULL),
('Hotel deLuxe', 51, '2019-05-05', 196, NULL),
('Hotel deLuxe', 51, '2019-05-06', 104, NULL),
('Hotel deLuxe', 51, '2019-05-07', 155, NULL),
('Hotel deLuxe', 51, '2019-05-08', 225, NULL),
('Hotel deLuxe', 51, '2019-05-09', 356, NULL),
('Hotel deLuxe', 51, '2019-05-10', 336, NULL),
('Hotel deLuxe', 51, '2019-05-11', 393, NULL),
('Hotel deLuxe', 51, '2019-05-12', 179, NULL),
('Hotel deLuxe', 51, '2019-05-13', 306, NULL),
('Hotel deLuxe', 51, '2019-05-14', 137, NULL),
('Hotel deLuxe', 51, '2019-05-15', 384, NULL),
('Hotel deLuxe', 51, '2019-05-16', 184, NULL),
('Hotel deLuxe', 51, '2019-05-17', 342, NULL),
('Hotel deLuxe', 51, '2019-05-18', 374, NULL),
('Hotel deLuxe', 51, '2019-05-19', 340, NULL),
('Hotel deLuxe', 51, '2019-05-20', 340, NULL),
('Hotel deLuxe', 51, '2019-05-21', 281, NULL),
('Hotel deLuxe', 51, '2019-05-22', 204, NULL),
('Hotel deLuxe', 51, '2019-05-23', 365, NULL),
('Hotel deLuxe', 51, '2019-05-24', 221, NULL),
('Hotel deLuxe', 51, '2019-05-25', 273, NULL),
('Hotel deLuxe', 51, '2019-05-26', 294, NULL),
('Hotel deLuxe', 51, '2019-05-27', 213, NULL),
('Hotel deLuxe', 51, '2019-05-28', 253, NULL),
('Hotel deLuxe', 51, '2019-05-29', 246, NULL),
('Hotel deLuxe', 51, '2019-05-30', 203, NULL),
('Hotel deLuxe', 51, '2019-05-31', 168, NULL),
('Hotel deLuxe', 51, '2019-06-01', 236, NULL),
('Hotel deLuxe', 51, '2019-06-02', 373, NULL),
('Hotel deLuxe', 51, '2019-06-03', 218, NULL),
('Hotel deLuxe', 51, '2019-06-04', 263, NULL),
('Hotel deLuxe', 51, '2019-06-05', 285, NULL),
('Hotel deLuxe', 51, '2019-06-06', 323, NULL),
('Hotel deLuxe', 51, '2019-06-07', 319, NULL),
('Hotel deLuxe', 51, '2019-06-08', 260, NULL),
('Hotel deLuxe', 51, '2019-06-09', 151, NULL),
('Hotel deLuxe', 51, '2019-06-10', 339, NULL),
('Hotel deLuxe', 51, '2019-06-11', 138, NULL),
('Hotel deLuxe', 51, '2019-06-12', 387, NULL),
('Hotel deLuxe', 51, '2019-06-13', 224, NULL),
('Hotel deLuxe', 51, '2019-06-14', 132, NULL),
('Hotel deLuxe', 51, '2019-06-15', 202, NULL),
('Hotel deLuxe', 51, '2019-06-16', 324, NULL),
('Hotel deLuxe', 51, '2019-06-17', 260, NULL),
('Hotel deLuxe', 51, '2019-06-18', 135, NULL),
('Hotel deLuxe', 51, '2019-06-19', 250, NULL),
('Hotel deLuxe', 51, '2019-06-20', 369, NULL),
('Hotel deLuxe', 51, '2019-06-21', 103, NULL),
('Hotel deLuxe', 51, '2019-06-22', 106, NULL),
('Hotel deLuxe', 51, '2019-06-23', 226, NULL),
('Hotel deLuxe', 51, '2019-06-24', 392, NULL),
('Hotel deLuxe', 51, '2019-06-25', 241, NULL),
('Hotel deLuxe', 51, '2019-06-26', 127, NULL),
('Hotel deLuxe', 51, '2019-06-27', 249, NULL),
('Hotel deLuxe', 51, '2019-06-28', 306, NULL),
('Hotel deLuxe', 51, '2019-06-29', 165, NULL),
('Hotel deLuxe', 51, '2019-06-30', 247, NULL),
('Hotel deLuxe', 51, '2019-07-01', 103, NULL),
('Hotel deLuxe', 51, '2019-07-02', 177, NULL),
('Hotel deLuxe', 51, '2019-07-03', 153, NULL),
('Hotel deLuxe', 51, '2019-07-04', 383, NULL),
('Hotel deLuxe', 51, '2019-07-05', 105, NULL),
('Hotel deLuxe', 51, '2019-07-06', 169, NULL),
('Hotel deLuxe', 51, '2019-07-07', 361, NULL),
('Hotel deLuxe', 51, '2019-07-08', 309, NULL),
('Hotel deLuxe', 51, '2019-07-09', 129, NULL),
('Hotel deLuxe', 51, '2019-07-10', 218, NULL),
('Hotel deLuxe', 51, '2019-07-11', 362, NULL),
('Hotel deLuxe', 51, '2019-07-12', 205, NULL),
('Hotel deLuxe', 51, '2019-07-13', 160, NULL),
('Hotel deLuxe', 51, '2019-07-14', 240, NULL),
('Hotel deLuxe', 51, '2019-07-15', 336, NULL),
('Hotel deLuxe', 51, '2019-07-16', 371, NULL),
('Hotel deLuxe', 51, '2019-07-17', 369, NULL),
('Hotel deLuxe', 51, '2019-07-18', 132, NULL),
('Hotel deLuxe', 51, '2019-07-19', 256, NULL),
('Hotel deLuxe', 51, '2019-07-20', 207, NULL),
('Hotel deLuxe', 51, '2019-07-21', 326, NULL),
('Hotel deLuxe', 51, '2019-07-22', 340, NULL),
('Hotel deLuxe', 51, '2019-07-23', 164, NULL),
('Hotel deLuxe', 51, '2019-07-24', 217, NULL),
('Hotel deLuxe', 51, '2019-07-25', 311, NULL),
('Hotel deLuxe', 51, '2019-07-26', 122, NULL),
('Hotel deLuxe', 51, '2019-07-27', 356, NULL),
('Hotel deLuxe', 51, '2019-07-28', 103, NULL),
('Hotel deLuxe', 51, '2019-07-29', 268, NULL),
('Hotel deLuxe', 51, '2019-07-30', 395, NULL),
('Hotel deLuxe', 51, '2019-07-31', 376, NULL),
('Hotel deLuxe', 51, '2019-08-01', 336, NULL),
('Hotel deLuxe', 51, '2019-08-02', 180, NULL),
('Hotel deLuxe', 51, '2019-08-03', 208, NULL),
('Hotel deLuxe', 51, '2019-08-04', 338, NULL),
('Hotel deLuxe', 51, '2019-08-05', 333, NULL),
('Hotel deLuxe', 51, '2019-08-06', 181, NULL),
('Hotel deLuxe', 51, '2019-08-07', 246, NULL),
('Hotel deLuxe', 51, '2019-08-08', 354, NULL),
('Hotel deLuxe', 51, '2019-08-09', 318, NULL),
('Hotel deLuxe', 51, '2019-08-10', 318, NULL),
('Hotel deLuxe', 51, '2019-08-11', 100, NULL),
('Hotel deLuxe', 51, '2019-08-12', 185, NULL),
('Hotel deLuxe', 51, '2019-08-13', 175, NULL),
('Hotel deLuxe', 51, '2019-08-14', 127, NULL),
('Hotel deLuxe', 51, '2019-08-15', 276, NULL),
('Hotel deLuxe', 51, '2019-08-16', 263, NULL),
('Hotel deLuxe', 51, '2019-08-17', 121, NULL),
('Hotel deLuxe', 51, '2019-08-18', 283, NULL),
('Hotel deLuxe', 51, '2019-08-19', 209, NULL),
('Hotel deLuxe', 51, '2019-08-20', 310, NULL),
('Hotel deLuxe', 51, '2019-08-21', 396, NULL),
('Hotel deLuxe', 51, '2019-08-22', 137, NULL),
('Hotel deLuxe', 51, '2019-08-23', 162, NULL),
('Hotel deLuxe', 51, '2019-08-24', 387, NULL),
('Hotel deLuxe', 51, '2019-08-25', 325, NULL),
('Hotel deLuxe', 51, '2019-08-26', 223, NULL),
('Hotel deLuxe', 51, '2019-08-27', 119, NULL),
('Hotel deLuxe', 51, '2019-08-28', 176, NULL),
('Hotel deLuxe', 51, '2019-08-29', 160, NULL),
('Hotel deLuxe', 51, '2019-08-30', 348, NULL),
('Hotel deLuxe', 51, '2019-08-31', 387, NULL),
('Hotel deLuxe', 51, '2019-09-01', 188, NULL),
('Hotel deLuxe', 51, '2019-09-02', 196, NULL),
('Hotel deLuxe', 51, '2019-09-03', 112, NULL),
('Hotel deLuxe', 51, '2019-09-04', 243, NULL),
('Hotel deLuxe', 51, '2019-09-05', 173, NULL),
('Hotel deLuxe', 51, '2019-09-06', 138, NULL),
('Hotel deLuxe', 51, '2019-09-07', 270, NULL),
('Hotel deLuxe', 51, '2019-09-08', 294, NULL),
('Hotel deLuxe', 51, '2019-09-09', 388, NULL),
('Hotel deLuxe', 51, '2019-09-10', 316, NULL),
('Hotel deLuxe', 51, '2019-09-11', 213, NULL),
('Hotel deLuxe', 51, '2019-09-12', 147, NULL),
('Hotel deLuxe', 51, '2019-09-13', 244, NULL),
('Hotel deLuxe', 51, '2019-09-14', 228, NULL),
('Hotel deLuxe', 51, '2019-09-15', 116, NULL),
('Hotel deLuxe', 51, '2019-09-16', 192, NULL),
('Hotel deLuxe', 51, '2019-09-17', 316, NULL),
('Hotel deLuxe', 51, '2019-09-18', 170, NULL),
('Hotel deLuxe', 51, '2019-09-19', 248, NULL),
('Hotel deLuxe', 51, '2019-09-20', 153, NULL),
('Hotel deLuxe', 51, '2019-09-21', 236, NULL),
('Hotel deLuxe', 51, '2019-09-22', 267, NULL),
('Hotel deLuxe', 51, '2019-09-23', 319, NULL),
('Hotel deLuxe', 51, '2019-09-24', 108, NULL),
('Hotel deLuxe', 51, '2019-09-25', 122, NULL),
('Hotel deLuxe', 51, '2019-09-26', 379, NULL),
('Hotel deLuxe', 51, '2019-09-27', 291, NULL),
('Hotel deLuxe', 51, '2019-09-28', 373, NULL),
('Hotel deLuxe', 51, '2019-09-29', 327, NULL),
('Hotel deLuxe', 51, '2019-09-30', 299, NULL),
('Hotel deLuxe', 51, '2019-10-01', 113, NULL),
('Hotel deLuxe', 51, '2019-10-02', 101, NULL),
('Hotel deLuxe', 51, '2019-10-03', 111, NULL),
('Hotel deLuxe', 51, '2019-10-04', 247, NULL),
('Hotel deLuxe', 51, '2019-10-05', 268, NULL),
('Hotel deLuxe', 51, '2019-10-06', 274, NULL),
('Hotel deLuxe', 51, '2019-10-07', 106, NULL),
('Hotel deLuxe', 51, '2019-10-08', 137, NULL),
('Hotel deLuxe', 51, '2019-10-09', 284, NULL),
('Hotel deLuxe', 51, '2019-10-10', 390, NULL),
('Hotel deLuxe', 51, '2019-10-11', 360, NULL),
('Hotel deLuxe', 51, '2019-10-12', 293, NULL),
('Hotel deLuxe', 51, '2019-10-13', 102, NULL),
('Hotel deLuxe', 51, '2019-10-14', 319, NULL),
('Hotel deLuxe', 51, '2019-10-15', 232, NULL),
('Hotel deLuxe', 51, '2019-10-16', 242, NULL),
('Hotel deLuxe', 51, '2019-10-17', 328, NULL),
('Hotel deLuxe', 51, '2019-10-18', 332, NULL),
('Hotel deLuxe', 51, '2019-10-19', 318, NULL),
('Hotel deLuxe', 51, '2019-10-20', 386, NULL),
('Hotel deLuxe', 51, '2019-10-21', 327, NULL),
('Hotel deLuxe', 51, '2019-10-22', 263, NULL),
('Hotel deLuxe', 51, '2019-10-23', 129, NULL),
('Hotel deLuxe', 51, '2019-10-24', 375, NULL),
('Hotel deLuxe', 51, '2019-10-25', 383, NULL),
('Hotel deLuxe', 51, '2019-10-26', 231, NULL),
('Hotel deLuxe', 51, '2019-10-27', 238, NULL),
('Hotel deLuxe', 51, '2019-10-28', 174, NULL),
('Hotel deLuxe', 51, '2019-10-29', 230, NULL),
('Hotel deLuxe', 51, '2019-10-30', 248, NULL),
('Hotel deLuxe', 51, '2019-10-31', 304, NULL),
('Hotel deLuxe', 51, '2019-11-01', 372, NULL),
('Hotel deLuxe', 51, '2019-11-02', 394, NULL),
('Hotel deLuxe', 51, '2019-11-03', 209, NULL),
('Hotel deLuxe', 51, '2019-11-04', 165, NULL),
('Hotel deLuxe', 51, '2019-11-05', 141, NULL),
('Hotel deLuxe', 51, '2019-11-06', 239, NULL),
('Hotel deLuxe', 51, '2019-11-07', 386, NULL),
('Hotel deLuxe', 51, '2019-11-08', 105, NULL),
('Hotel deLuxe', 51, '2019-11-09', 100, NULL),
('Hotel deLuxe', 51, '2019-11-10', 154, NULL),
('Hotel deLuxe', 51, '2019-11-11', 105, NULL),
('Hotel deLuxe', 51, '2019-11-12', 119, NULL),
('Hotel deLuxe', 51, '2019-11-13', 263, NULL),
('Hotel deLuxe', 51, '2019-11-14', 108, NULL),
('Hotel deLuxe', 51, '2019-11-15', 213, NULL),
('Hotel deLuxe', 51, '2019-11-16', 155, NULL),
('Hotel deLuxe', 51, '2019-11-17', 387, NULL),
('Hotel deLuxe', 51, '2019-11-18', 291, NULL),
('Hotel deLuxe', 51, '2019-11-19', 268, NULL),
('Hotel deLuxe', 51, '2019-11-20', 218, NULL),
('Hotel deLuxe', 51, '2019-11-21', 251, NULL),
('Hotel deLuxe', 51, '2019-11-22', 126, NULL),
('Hotel deLuxe', 51, '2019-11-23', 328, NULL),
('Hotel deLuxe', 51, '2019-11-24', 300, NULL),
('Hotel deLuxe', 51, '2019-11-25', 114, NULL),
('Hotel deLuxe', 51, '2019-11-26', 109, NULL),
('Hotel deLuxe', 51, '2019-11-27', 312, NULL),
('Hotel deLuxe', 51, '2019-11-28', 273, NULL),
('Hotel deLuxe', 51, '2019-11-29', 363, NULL),
('Hotel deLuxe', 51, '2019-11-30', 176, NULL),
('Hotel deLuxe', 51, '2019-12-01', 358, NULL),
('Hotel deLuxe', 51, '2019-12-02', 261, NULL),
('Hotel deLuxe', 51, '2019-12-03', 281, NULL),
('Hotel deLuxe', 51, '2019-12-04', 179, NULL),
('Hotel deLuxe', 51, '2019-12-05', 321, NULL),
('Hotel deLuxe', 51, '2019-12-06', 168, NULL),
('Hotel deLuxe', 51, '2019-12-07', 107, NULL),
('Hotel deLuxe', 51, '2019-12-08', 130, NULL),
('Hotel deLuxe', 51, '2019-12-09', 105, NULL),
('Hotel deLuxe', 51, '2019-12-10', 188, NULL),
('Hotel deLuxe', 51, '2019-12-11', 153, NULL),
('Hotel deLuxe', 51, '2019-12-12', 104, NULL),
('Hotel deLuxe', 51, '2019-12-13', 325, NULL),
('Hotel deLuxe', 51, '2019-12-14', 389, NULL),
('Hotel deLuxe', 51, '2019-12-15', 203, NULL),
('Hotel deLuxe', 51, '2019-12-16', 145, NULL),
('Hotel deLuxe', 51, '2019-12-17', 106, NULL),
('Hotel deLuxe', 51, '2019-12-18', 228, NULL),
('Hotel deLuxe', 51, '2019-12-19', 385, NULL),
('Hotel deLuxe', 51, '2019-12-20', 202, NULL),
('Hotel deLuxe', 51, '2019-12-21', 348, NULL),
('Hotel deLuxe', 51, '2019-12-22', 395, NULL),
('Hotel deLuxe', 51, '2019-12-23', 329, NULL),
('Hotel deLuxe', 51, '2019-12-24', 215, NULL),
('Hotel deLuxe', 51, '2019-12-25', 390, NULL),
('Hotel deLuxe', 51, '2019-12-26', 315, NULL),
('Hotel deLuxe', 51, '2019-12-27', 190, NULL),
('Hotel deLuxe', 51, '2019-12-28', 304, NULL),
('Hotel deLuxe', 51, '2019-12-29', 342, NULL),
('Hotel deLuxe', 51, '2019-12-30', 177, NULL),
('Hotel deLuxe', 51, '2019-12-31', 276, NULL),
('Hotel deLuxe', 51, '2020-01-01', 225, NULL),
('Hotel deLuxe', 51, '2020-01-02', 228, NULL),
('Hotel deLuxe', 51, '2020-01-03', 195, NULL),
('Hotel deLuxe', 51, '2020-01-04', 255, NULL),
('Hotel deLuxe', 51, '2020-01-05', 321, NULL),
('Hotel deLuxe', 51, '2020-01-06', 131, NULL),
('Hotel deLuxe', 51, '2020-01-07', 161, NULL),
('Hotel deLuxe', 51, '2020-01-08', 122, NULL),
('Hotel deLuxe', 51, '2020-01-09', 178, NULL),
('Hotel deLuxe', 51, '2020-01-10', 275, NULL),
('Hotel deLuxe', 51, '2020-01-11', 387, NULL),
('Hotel deLuxe', 51, '2020-01-12', 280, NULL),
('Hotel deLuxe', 51, '2020-01-13', 329, NULL),
('Hotel deLuxe', 51, '2020-01-14', 378, NULL),
('Hotel deLuxe', 51, '2020-01-15', 255, NULL),
('Hotel deLuxe', 51, '2020-01-16', 165, NULL),
('Hotel deLuxe', 51, '2020-01-17', 285, NULL),
('Hotel deLuxe', 51, '2020-01-18', 384, NULL),
('Hotel deLuxe', 51, '2020-01-19', 393, NULL),
('Hotel deLuxe', 51, '2020-01-20', 258, NULL),
('Hotel deLuxe', 51, '2020-01-21', 345, NULL),
('Hotel deLuxe', 51, '2020-01-22', 371, NULL),
('Hotel deLuxe', 51, '2020-01-23', 383, NULL),
('Hotel deLuxe', 51, '2020-01-24', 196, NULL),
('Hotel deLuxe', 51, '2020-01-25', 137, NULL),
('Hotel deLuxe', 51, '2020-01-26', 105, NULL),
('Hotel deLuxe', 51, '2020-01-27', 271, NULL),
('Hotel deLuxe', 51, '2020-01-28', 288, NULL),
('Hotel deLuxe', 51, '2020-01-29', 215, NULL),
('Hotel deLuxe', 51, '2020-01-30', 369, NULL),
('Hotel deLuxe', 51, '2020-01-31', 265, NULL),
('Hotel deLuxe', 51, '2020-02-01', 273, NULL),
('Hotel deLuxe', 51, '2020-02-02', 114, NULL),
('Hotel deLuxe', 51, '2020-02-03', 158, NULL),
('Hotel deLuxe', 51, '2020-02-04', 233, NULL),
('Hotel deLuxe', 55, '2019-01-01', 196, NULL),
('Hotel deLuxe', 55, '2019-01-02', 368, NULL),
('Hotel deLuxe', 55, '2019-01-03', 384, NULL),
('Hotel deLuxe', 55, '2019-01-04', 291, NULL),
('Hotel deLuxe', 55, '2019-01-05', 292, NULL),
('Hotel deLuxe', 55, '2019-01-06', 305, NULL),
('Hotel deLuxe', 55, '2019-01-07', 197, NULL),
('Hotel deLuxe', 55, '2019-01-08', 292, NULL),
('Hotel deLuxe', 55, '2019-01-09', 314, NULL),
('Hotel deLuxe', 55, '2019-01-10', 325, NULL),
('Hotel deLuxe', 55, '2019-01-11', 114, NULL),
('Hotel deLuxe', 55, '2019-01-12', 100, NULL),
('Hotel deLuxe', 55, '2019-01-13', 309, NULL),
('Hotel deLuxe', 55, '2019-01-14', 262, NULL),
('Hotel deLuxe', 55, '2019-01-15', 105, NULL),
('Hotel deLuxe', 55, '2019-01-16', 213, NULL),
('Hotel deLuxe', 55, '2019-01-17', 313, NULL),
('Hotel deLuxe', 55, '2019-01-18', 280, NULL),
('Hotel deLuxe', 55, '2019-01-19', 194, NULL),
('Hotel deLuxe', 55, '2019-01-20', 334, NULL),
('Hotel deLuxe', 55, '2019-01-21', 319, NULL),
('Hotel deLuxe', 55, '2019-01-22', 280, NULL),
('Hotel deLuxe', 55, '2019-01-23', 144, NULL),
('Hotel deLuxe', 55, '2019-01-24', 198, NULL),
('Hotel deLuxe', 55, '2019-01-25', 213, NULL),
('Hotel deLuxe', 55, '2019-01-26', 306, NULL),
('Hotel deLuxe', 55, '2019-01-27', 150, NULL),
('Hotel deLuxe', 55, '2019-01-28', 328, NULL),
('Hotel deLuxe', 55, '2019-01-29', 103, NULL),
('Hotel deLuxe', 55, '2019-01-30', 256, NULL),
('Hotel deLuxe', 55, '2019-01-31', 349, NULL),
('Hotel deLuxe', 55, '2019-02-01', 160, NULL),
('Hotel deLuxe', 55, '2019-02-02', 263, NULL),
('Hotel deLuxe', 55, '2019-02-03', 328, NULL),
('Hotel deLuxe', 55, '2019-02-04', 233, NULL),
('Hotel deLuxe', 55, '2019-02-05', 241, NULL),
('Hotel deLuxe', 55, '2019-02-06', 193, NULL),
('Hotel deLuxe', 55, '2019-02-07', 250, NULL),
('Hotel deLuxe', 55, '2019-02-08', 243, NULL),
('Hotel deLuxe', 55, '2019-02-09', 188, NULL),
('Hotel deLuxe', 55, '2019-02-10', 298, NULL),
('Hotel deLuxe', 55, '2019-02-11', 145, NULL),
('Hotel deLuxe', 55, '2019-02-12', 329, NULL),
('Hotel deLuxe', 55, '2019-02-13', 197, NULL),
('Hotel deLuxe', 55, '2019-02-14', 174, NULL),
('Hotel deLuxe', 55, '2019-02-15', 286, NULL),
('Hotel deLuxe', 55, '2019-02-16', 232, NULL),
('Hotel deLuxe', 55, '2019-02-17', 381, NULL),
('Hotel deLuxe', 55, '2019-02-18', 162, NULL),
('Hotel deLuxe', 55, '2019-02-19', 320, NULL),
('Hotel deLuxe', 55, '2019-02-20', 216, NULL),
('Hotel deLuxe', 55, '2019-02-21', 122, NULL),
('Hotel deLuxe', 55, '2019-02-22', 220, NULL),
('Hotel deLuxe', 55, '2019-02-23', 164, NULL),
('Hotel deLuxe', 55, '2019-02-24', 298, NULL),
('Hotel deLuxe', 55, '2019-02-25', 376, NULL),
('Hotel deLuxe', 55, '2019-02-26', 249, NULL),
('Hotel deLuxe', 55, '2019-02-27', 342, NULL),
('Hotel deLuxe', 55, '2019-02-28', 157, NULL),
('Hotel deLuxe', 55, '2019-03-01', 130, NULL),
('Hotel deLuxe', 55, '2019-03-02', 179, NULL),
('Hotel deLuxe', 55, '2019-03-03', 189, NULL),
('Hotel deLuxe', 55, '2019-03-04', 183, NULL),
('Hotel deLuxe', 55, '2019-03-05', 218, NULL),
('Hotel deLuxe', 55, '2019-03-06', 251, NULL),
('Hotel deLuxe', 55, '2019-03-07', 282, NULL),
('Hotel deLuxe', 55, '2019-03-08', 255, NULL),
('Hotel deLuxe', 55, '2019-03-09', 342, NULL),
('Hotel deLuxe', 55, '2019-03-10', 371, NULL),
('Hotel deLuxe', 55, '2019-03-11', 344, NULL),
('Hotel deLuxe', 55, '2019-03-12', 119, NULL),
('Hotel deLuxe', 55, '2019-03-13', 370, NULL),
('Hotel deLuxe', 55, '2019-03-14', 226, NULL),
('Hotel deLuxe', 55, '2019-03-15', 101, NULL),
('Hotel deLuxe', 55, '2019-03-16', 186, NULL),
('Hotel deLuxe', 55, '2019-03-17', 216, NULL),
('Hotel deLuxe', 55, '2019-03-18', 364, NULL),
('Hotel deLuxe', 55, '2019-03-19', 387, NULL),
('Hotel deLuxe', 55, '2019-03-20', 239, NULL),
('Hotel deLuxe', 55, '2019-03-21', 314, NULL),
('Hotel deLuxe', 55, '2019-03-22', 219, NULL),
('Hotel deLuxe', 55, '2019-03-23', 342, NULL),
('Hotel deLuxe', 55, '2019-03-24', 236, NULL),
('Hotel deLuxe', 55, '2019-03-25', 165, NULL),
('Hotel deLuxe', 55, '2019-03-26', 220, NULL),
('Hotel deLuxe', 55, '2019-03-27', 129, NULL),
('Hotel deLuxe', 55, '2019-03-28', 262, NULL),
('Hotel deLuxe', 55, '2019-03-29', 225, NULL),
('Hotel deLuxe', 55, '2019-03-30', 370, NULL),
('Hotel deLuxe', 55, '2019-03-31', 277, NULL),
('Hotel deLuxe', 55, '2019-04-01', 216, NULL),
('Hotel deLuxe', 55, '2019-04-02', 230, NULL),
('Hotel deLuxe', 55, '2019-04-03', 304, NULL),
('Hotel deLuxe', 55, '2019-04-04', 337, NULL),
('Hotel deLuxe', 55, '2019-04-05', 313, NULL),
('Hotel deLuxe', 55, '2019-04-06', 277, NULL),
('Hotel deLuxe', 55, '2019-04-07', 273, NULL),
('Hotel deLuxe', 55, '2019-04-08', 153, NULL),
('Hotel deLuxe', 55, '2019-04-09', 303, NULL),
('Hotel deLuxe', 55, '2019-04-10', 278, NULL),
('Hotel deLuxe', 55, '2019-04-11', 295, NULL),
('Hotel deLuxe', 55, '2019-04-12', 127, NULL),
('Hotel deLuxe', 55, '2019-04-13', 295, NULL),
('Hotel deLuxe', 55, '2019-04-14', 243, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 55, '2019-04-15', 158, NULL),
('Hotel deLuxe', 55, '2019-04-16', 342, NULL),
('Hotel deLuxe', 55, '2019-04-17', 258, NULL),
('Hotel deLuxe', 55, '2019-04-18', 120, NULL),
('Hotel deLuxe', 55, '2019-04-19', 340, NULL),
('Hotel deLuxe', 55, '2019-04-20', 128, NULL),
('Hotel deLuxe', 55, '2019-04-21', 374, NULL),
('Hotel deLuxe', 55, '2019-04-22', 202, NULL),
('Hotel deLuxe', 55, '2019-04-23', 275, NULL),
('Hotel deLuxe', 55, '2019-04-24', 356, NULL),
('Hotel deLuxe', 55, '2019-04-25', 368, NULL),
('Hotel deLuxe', 55, '2019-04-26', 145, NULL),
('Hotel deLuxe', 55, '2019-04-27', 147, NULL),
('Hotel deLuxe', 55, '2019-04-28', 118, NULL),
('Hotel deLuxe', 55, '2019-04-29', 281, NULL),
('Hotel deLuxe', 55, '2019-04-30', 177, NULL),
('Hotel deLuxe', 55, '2019-05-01', 307, NULL),
('Hotel deLuxe', 55, '2019-05-02', 317, NULL),
('Hotel deLuxe', 55, '2019-05-03', 122, NULL),
('Hotel deLuxe', 55, '2019-05-04', 229, NULL),
('Hotel deLuxe', 55, '2019-05-05', 101, NULL),
('Hotel deLuxe', 55, '2019-05-06', 309, NULL),
('Hotel deLuxe', 55, '2019-05-07', 349, NULL),
('Hotel deLuxe', 55, '2019-05-08', 256, NULL),
('Hotel deLuxe', 55, '2019-05-09', 148, NULL),
('Hotel deLuxe', 55, '2019-05-10', 379, NULL),
('Hotel deLuxe', 55, '2019-05-11', 389, NULL),
('Hotel deLuxe', 55, '2019-05-12', 308, NULL),
('Hotel deLuxe', 55, '2019-05-13', 106, NULL),
('Hotel deLuxe', 55, '2019-05-14', 342, NULL),
('Hotel deLuxe', 55, '2019-05-15', 143, NULL),
('Hotel deLuxe', 55, '2019-05-16', 201, NULL),
('Hotel deLuxe', 55, '2019-05-17', 305, NULL),
('Hotel deLuxe', 55, '2019-05-18', 362, NULL),
('Hotel deLuxe', 55, '2019-05-19', 102, NULL),
('Hotel deLuxe', 55, '2019-05-20', 171, NULL),
('Hotel deLuxe', 55, '2019-05-21', 227, NULL),
('Hotel deLuxe', 55, '2019-05-22', 289, NULL),
('Hotel deLuxe', 55, '2019-05-23', 269, NULL),
('Hotel deLuxe', 55, '2019-05-24', 212, NULL),
('Hotel deLuxe', 55, '2019-05-25', 157, NULL),
('Hotel deLuxe', 55, '2019-05-26', 289, NULL),
('Hotel deLuxe', 55, '2019-05-27', 334, NULL),
('Hotel deLuxe', 55, '2019-05-28', 328, NULL),
('Hotel deLuxe', 55, '2019-05-29', 361, NULL),
('Hotel deLuxe', 55, '2019-05-30', 157, NULL),
('Hotel deLuxe', 55, '2019-05-31', 280, NULL),
('Hotel deLuxe', 55, '2019-06-01', 389, NULL),
('Hotel deLuxe', 55, '2019-06-02', 383, NULL),
('Hotel deLuxe', 55, '2019-06-03', 363, NULL),
('Hotel deLuxe', 55, '2019-06-04', 166, NULL),
('Hotel deLuxe', 55, '2019-06-05', 173, NULL),
('Hotel deLuxe', 55, '2019-06-06', 390, NULL),
('Hotel deLuxe', 55, '2019-06-07', 265, NULL),
('Hotel deLuxe', 55, '2019-06-08', 394, NULL),
('Hotel deLuxe', 55, '2019-06-09', 245, NULL),
('Hotel deLuxe', 55, '2019-06-10', 142, NULL),
('Hotel deLuxe', 55, '2019-06-11', 218, NULL),
('Hotel deLuxe', 55, '2019-06-12', 302, NULL),
('Hotel deLuxe', 55, '2019-06-13', 315, NULL),
('Hotel deLuxe', 55, '2019-06-14', 285, NULL),
('Hotel deLuxe', 55, '2019-06-15', 180, NULL),
('Hotel deLuxe', 55, '2019-06-16', 172, NULL),
('Hotel deLuxe', 55, '2019-06-17', 118, NULL),
('Hotel deLuxe', 55, '2019-06-18', 193, NULL),
('Hotel deLuxe', 55, '2019-06-19', 348, NULL),
('Hotel deLuxe', 55, '2019-06-20', 374, NULL),
('Hotel deLuxe', 55, '2019-06-21', 159, NULL),
('Hotel deLuxe', 55, '2019-06-22', 202, NULL),
('Hotel deLuxe', 55, '2019-06-23', 283, NULL),
('Hotel deLuxe', 55, '2019-06-24', 362, NULL),
('Hotel deLuxe', 55, '2019-06-25', 168, NULL),
('Hotel deLuxe', 55, '2019-06-26', 168, NULL),
('Hotel deLuxe', 55, '2019-06-27', 131, NULL),
('Hotel deLuxe', 55, '2019-06-28', 304, NULL),
('Hotel deLuxe', 55, '2019-06-29', 121, NULL),
('Hotel deLuxe', 55, '2019-06-30', 146, NULL),
('Hotel deLuxe', 55, '2019-07-01', 326, NULL),
('Hotel deLuxe', 55, '2019-07-02', 223, NULL),
('Hotel deLuxe', 55, '2019-07-03', 130, NULL),
('Hotel deLuxe', 55, '2019-07-04', 221, NULL),
('Hotel deLuxe', 55, '2019-07-05', 340, NULL),
('Hotel deLuxe', 55, '2019-07-06', 394, NULL),
('Hotel deLuxe', 55, '2019-07-07', 254, NULL),
('Hotel deLuxe', 55, '2019-07-08', 238, NULL),
('Hotel deLuxe', 55, '2019-07-09', 142, NULL),
('Hotel deLuxe', 55, '2019-07-10', 152, NULL),
('Hotel deLuxe', 55, '2019-07-11', 332, NULL),
('Hotel deLuxe', 55, '2019-07-12', 100, NULL),
('Hotel deLuxe', 55, '2019-07-13', 379, NULL),
('Hotel deLuxe', 55, '2019-07-14', 149, NULL),
('Hotel deLuxe', 55, '2019-07-15', 264, NULL),
('Hotel deLuxe', 55, '2019-07-16', 225, NULL),
('Hotel deLuxe', 55, '2019-07-17', 382, NULL),
('Hotel deLuxe', 55, '2019-07-18', 141, NULL),
('Hotel deLuxe', 55, '2019-07-19', 142, NULL),
('Hotel deLuxe', 55, '2019-07-20', 115, NULL),
('Hotel deLuxe', 55, '2019-07-21', 174, NULL),
('Hotel deLuxe', 55, '2019-07-22', 107, NULL),
('Hotel deLuxe', 55, '2019-07-23', 240, NULL),
('Hotel deLuxe', 55, '2019-07-24', 303, NULL),
('Hotel deLuxe', 55, '2019-07-25', 374, NULL),
('Hotel deLuxe', 55, '2019-07-26', 389, NULL),
('Hotel deLuxe', 55, '2019-07-27', 256, NULL),
('Hotel deLuxe', 55, '2019-07-28', 209, NULL),
('Hotel deLuxe', 55, '2019-07-29', 306, NULL),
('Hotel deLuxe', 55, '2019-07-30', 101, NULL),
('Hotel deLuxe', 55, '2019-07-31', 223, NULL),
('Hotel deLuxe', 55, '2019-08-01', 208, NULL),
('Hotel deLuxe', 55, '2019-08-02', 342, NULL),
('Hotel deLuxe', 55, '2019-08-03', 199, NULL),
('Hotel deLuxe', 55, '2019-08-04', 381, NULL),
('Hotel deLuxe', 55, '2019-08-05', 396, NULL),
('Hotel deLuxe', 55, '2019-08-06', 238, NULL),
('Hotel deLuxe', 55, '2019-08-07', 153, NULL),
('Hotel deLuxe', 55, '2019-08-08', 365, NULL),
('Hotel deLuxe', 55, '2019-08-09', 349, NULL),
('Hotel deLuxe', 55, '2019-08-10', 171, NULL),
('Hotel deLuxe', 55, '2019-08-11', 355, NULL),
('Hotel deLuxe', 55, '2019-08-12', 159, NULL),
('Hotel deLuxe', 55, '2019-08-13', 323, NULL),
('Hotel deLuxe', 55, '2019-08-14', 208, NULL),
('Hotel deLuxe', 55, '2019-08-15', 255, NULL),
('Hotel deLuxe', 55, '2019-08-16', 141, NULL),
('Hotel deLuxe', 55, '2019-08-17', 172, NULL),
('Hotel deLuxe', 55, '2019-08-18', 387, NULL),
('Hotel deLuxe', 55, '2019-08-19', 118, NULL),
('Hotel deLuxe', 55, '2019-08-20', 192, NULL),
('Hotel deLuxe', 55, '2019-08-21', 234, NULL),
('Hotel deLuxe', 55, '2019-08-22', 333, NULL),
('Hotel deLuxe', 55, '2019-08-23', 267, NULL),
('Hotel deLuxe', 55, '2019-08-24', 212, NULL),
('Hotel deLuxe', 55, '2019-08-25', 255, NULL),
('Hotel deLuxe', 55, '2019-08-26', 163, NULL),
('Hotel deLuxe', 55, '2019-08-27', 398, NULL),
('Hotel deLuxe', 55, '2019-08-28', 126, NULL),
('Hotel deLuxe', 55, '2019-08-29', 117, NULL),
('Hotel deLuxe', 55, '2019-08-30', 300, NULL),
('Hotel deLuxe', 55, '2019-08-31', 254, NULL),
('Hotel deLuxe', 55, '2019-09-01', 243, NULL),
('Hotel deLuxe', 55, '2019-09-02', 185, NULL),
('Hotel deLuxe', 55, '2019-09-03', 117, NULL),
('Hotel deLuxe', 55, '2019-09-04', 201, NULL),
('Hotel deLuxe', 55, '2019-09-05', 277, NULL),
('Hotel deLuxe', 55, '2019-09-06', 281, NULL),
('Hotel deLuxe', 55, '2019-09-07', 346, NULL),
('Hotel deLuxe', 55, '2019-09-08', 294, NULL),
('Hotel deLuxe', 55, '2019-09-09', 194, NULL),
('Hotel deLuxe', 55, '2019-09-10', 365, NULL),
('Hotel deLuxe', 55, '2019-09-11', 117, NULL),
('Hotel deLuxe', 55, '2019-09-12', 157, NULL),
('Hotel deLuxe', 55, '2019-09-13', 139, NULL),
('Hotel deLuxe', 55, '2019-09-14', 286, NULL),
('Hotel deLuxe', 55, '2019-09-15', 323, NULL),
('Hotel deLuxe', 55, '2019-09-16', 155, NULL),
('Hotel deLuxe', 55, '2019-09-17', 344, NULL),
('Hotel deLuxe', 55, '2019-09-18', 151, NULL),
('Hotel deLuxe', 55, '2019-09-19', 290, NULL),
('Hotel deLuxe', 55, '2019-09-20', 315, NULL),
('Hotel deLuxe', 55, '2019-09-21', 105, NULL),
('Hotel deLuxe', 55, '2019-09-22', 114, NULL),
('Hotel deLuxe', 55, '2019-09-23', 201, NULL),
('Hotel deLuxe', 55, '2019-09-24', 398, NULL),
('Hotel deLuxe', 55, '2019-09-25', 294, NULL),
('Hotel deLuxe', 55, '2019-09-26', 108, NULL),
('Hotel deLuxe', 55, '2019-09-27', 316, NULL),
('Hotel deLuxe', 55, '2019-09-28', 359, NULL),
('Hotel deLuxe', 55, '2019-09-29', 134, NULL),
('Hotel deLuxe', 55, '2019-09-30', 284, NULL),
('Hotel deLuxe', 55, '2019-10-01', 301, NULL),
('Hotel deLuxe', 55, '2019-10-02', 109, NULL),
('Hotel deLuxe', 55, '2019-10-03', 387, NULL),
('Hotel deLuxe', 55, '2019-10-04', 196, NULL),
('Hotel deLuxe', 55, '2019-10-05', 386, NULL),
('Hotel deLuxe', 55, '2019-10-06', 368, NULL),
('Hotel deLuxe', 55, '2019-10-07', 156, NULL),
('Hotel deLuxe', 55, '2019-10-08', 143, NULL),
('Hotel deLuxe', 55, '2019-10-09', 308, NULL),
('Hotel deLuxe', 55, '2019-10-10', 244, NULL),
('Hotel deLuxe', 55, '2019-10-11', 326, NULL),
('Hotel deLuxe', 55, '2019-10-12', 105, NULL),
('Hotel deLuxe', 55, '2019-10-13', 127, NULL),
('Hotel deLuxe', 55, '2019-10-14', 241, NULL),
('Hotel deLuxe', 55, '2019-10-15', 341, NULL),
('Hotel deLuxe', 55, '2019-10-16', 141, NULL),
('Hotel deLuxe', 55, '2019-10-17', 132, NULL),
('Hotel deLuxe', 55, '2019-10-18', 106, NULL),
('Hotel deLuxe', 55, '2019-10-19', 359, NULL),
('Hotel deLuxe', 55, '2019-10-20', 210, NULL),
('Hotel deLuxe', 55, '2019-10-21', 111, NULL),
('Hotel deLuxe', 55, '2019-10-22', 143, NULL),
('Hotel deLuxe', 55, '2019-10-23', 222, NULL),
('Hotel deLuxe', 55, '2019-10-24', 127, NULL),
('Hotel deLuxe', 55, '2019-10-25', 337, NULL),
('Hotel deLuxe', 55, '2019-10-26', 178, NULL),
('Hotel deLuxe', 55, '2019-10-27', 160, NULL),
('Hotel deLuxe', 55, '2019-10-28', 281, NULL),
('Hotel deLuxe', 55, '2019-10-29', 306, NULL),
('Hotel deLuxe', 55, '2019-10-30', 154, NULL),
('Hotel deLuxe', 55, '2019-10-31', 209, NULL),
('Hotel deLuxe', 55, '2019-11-01', 389, NULL),
('Hotel deLuxe', 55, '2019-11-02', 202, NULL),
('Hotel deLuxe', 55, '2019-11-03', 277, NULL),
('Hotel deLuxe', 55, '2019-11-04', 133, NULL),
('Hotel deLuxe', 55, '2019-11-05', 276, NULL),
('Hotel deLuxe', 55, '2019-11-06', 131, NULL),
('Hotel deLuxe', 55, '2019-11-07', 144, NULL),
('Hotel deLuxe', 55, '2019-11-08', 352, NULL),
('Hotel deLuxe', 55, '2019-11-09', 347, NULL),
('Hotel deLuxe', 55, '2019-11-10', 261, NULL),
('Hotel deLuxe', 55, '2019-11-11', 206, NULL),
('Hotel deLuxe', 55, '2019-11-12', 205, NULL),
('Hotel deLuxe', 55, '2019-11-13', 289, NULL),
('Hotel deLuxe', 55, '2019-11-14', 369, NULL),
('Hotel deLuxe', 55, '2019-11-15', 102, NULL),
('Hotel deLuxe', 55, '2019-11-16', 147, NULL),
('Hotel deLuxe', 55, '2019-11-17', 207, NULL),
('Hotel deLuxe', 55, '2019-11-18', 364, NULL),
('Hotel deLuxe', 55, '2019-11-19', 335, NULL),
('Hotel deLuxe', 55, '2019-11-20', 208, NULL),
('Hotel deLuxe', 55, '2019-11-21', 325, NULL),
('Hotel deLuxe', 55, '2019-11-22', 330, NULL),
('Hotel deLuxe', 55, '2019-11-23', 205, NULL),
('Hotel deLuxe', 55, '2019-11-24', 311, NULL),
('Hotel deLuxe', 55, '2019-11-25', 170, NULL),
('Hotel deLuxe', 55, '2019-11-26', 170, NULL),
('Hotel deLuxe', 55, '2019-11-27', 221, NULL),
('Hotel deLuxe', 55, '2019-11-28', 247, NULL),
('Hotel deLuxe', 55, '2019-11-29', 260, NULL),
('Hotel deLuxe', 55, '2019-11-30', 166, NULL),
('Hotel deLuxe', 55, '2019-12-01', 210, NULL),
('Hotel deLuxe', 55, '2019-12-02', 310, NULL),
('Hotel deLuxe', 55, '2019-12-03', 155, NULL),
('Hotel deLuxe', 55, '2019-12-04', 279, NULL),
('Hotel deLuxe', 55, '2019-12-05', 391, NULL),
('Hotel deLuxe', 55, '2019-12-06', 333, NULL),
('Hotel deLuxe', 55, '2019-12-07', 213, NULL),
('Hotel deLuxe', 55, '2019-12-08', 151, NULL),
('Hotel deLuxe', 55, '2019-12-09', 336, NULL),
('Hotel deLuxe', 55, '2019-12-10', 238, NULL),
('Hotel deLuxe', 55, '2019-12-11', 366, NULL),
('Hotel deLuxe', 55, '2019-12-12', 294, NULL),
('Hotel deLuxe', 55, '2019-12-13', 274, NULL),
('Hotel deLuxe', 55, '2019-12-14', 199, NULL),
('Hotel deLuxe', 55, '2019-12-15', 227, NULL),
('Hotel deLuxe', 55, '2019-12-16', 105, NULL),
('Hotel deLuxe', 55, '2019-12-17', 359, NULL),
('Hotel deLuxe', 55, '2019-12-18', 270, NULL),
('Hotel deLuxe', 55, '2019-12-19', 222, NULL),
('Hotel deLuxe', 55, '2019-12-20', 283, NULL),
('Hotel deLuxe', 55, '2019-12-21', 343, NULL),
('Hotel deLuxe', 55, '2019-12-22', 354, NULL),
('Hotel deLuxe', 55, '2019-12-23', 310, NULL),
('Hotel deLuxe', 55, '2019-12-24', 343, NULL),
('Hotel deLuxe', 55, '2019-12-25', 302, NULL),
('Hotel deLuxe', 55, '2019-12-26', 102, NULL),
('Hotel deLuxe', 55, '2019-12-27', 113, NULL),
('Hotel deLuxe', 55, '2019-12-28', 154, NULL),
('Hotel deLuxe', 55, '2019-12-29', 195, NULL),
('Hotel deLuxe', 55, '2019-12-30', 389, NULL),
('Hotel deLuxe', 55, '2019-12-31', 272, NULL),
('Hotel deLuxe', 55, '2020-01-01', 343, NULL),
('Hotel deLuxe', 55, '2020-01-02', 175, NULL),
('Hotel deLuxe', 55, '2020-01-03', 159, NULL),
('Hotel deLuxe', 55, '2020-01-04', 187, NULL),
('Hotel deLuxe', 55, '2020-01-05', 372, NULL),
('Hotel deLuxe', 55, '2020-01-06', 341, NULL),
('Hotel deLuxe', 55, '2020-01-07', 142, NULL),
('Hotel deLuxe', 55, '2020-01-08', 284, NULL),
('Hotel deLuxe', 55, '2020-01-09', 366, NULL),
('Hotel deLuxe', 55, '2020-01-10', 154, NULL),
('Hotel deLuxe', 55, '2020-01-11', 289, NULL),
('Hotel deLuxe', 55, '2020-01-12', 240, NULL),
('Hotel deLuxe', 55, '2020-01-13', 287, NULL),
('Hotel deLuxe', 55, '2020-01-14', 334, NULL),
('Hotel deLuxe', 55, '2020-01-15', 385, NULL),
('Hotel deLuxe', 55, '2020-01-16', 151, NULL),
('Hotel deLuxe', 55, '2020-01-17', 360, NULL),
('Hotel deLuxe', 55, '2020-01-18', 343, NULL),
('Hotel deLuxe', 55, '2020-01-19', 105, NULL),
('Hotel deLuxe', 55, '2020-01-20', 130, NULL),
('Hotel deLuxe', 55, '2020-01-21', 300, NULL),
('Hotel deLuxe', 55, '2020-01-22', 131, NULL),
('Hotel deLuxe', 55, '2020-01-23', 279, NULL),
('Hotel deLuxe', 55, '2020-01-24', 194, NULL),
('Hotel deLuxe', 55, '2020-01-25', 244, NULL),
('Hotel deLuxe', 55, '2020-01-26', 232, NULL),
('Hotel deLuxe', 55, '2020-01-27', 233, NULL),
('Hotel deLuxe', 55, '2020-01-28', 347, NULL),
('Hotel deLuxe', 55, '2020-01-29', 334, NULL),
('Hotel deLuxe', 55, '2020-01-30', 289, NULL),
('Hotel deLuxe', 55, '2020-01-31', 216, NULL),
('Hotel deLuxe', 55, '2020-02-01', 266, NULL),
('Hotel deLuxe', 55, '2020-02-02', 163, NULL),
('Hotel deLuxe', 55, '2020-02-03', 333, NULL),
('Hotel deLuxe', 55, '2020-02-04', 252, NULL),
('Hotel deLuxe', 64, '2019-01-01', 338, NULL),
('Hotel deLuxe', 64, '2019-01-02', 102, NULL),
('Hotel deLuxe', 64, '2019-01-03', 269, NULL),
('Hotel deLuxe', 64, '2019-01-04', 205, NULL),
('Hotel deLuxe', 64, '2019-01-05', 340, NULL),
('Hotel deLuxe', 64, '2019-01-06', 250, NULL),
('Hotel deLuxe', 64, '2019-01-07', 261, NULL),
('Hotel deLuxe', 64, '2019-01-08', 331, NULL),
('Hotel deLuxe', 64, '2019-01-09', 387, NULL),
('Hotel deLuxe', 64, '2019-01-10', 397, NULL),
('Hotel deLuxe', 64, '2019-01-11', 255, NULL),
('Hotel deLuxe', 64, '2019-01-12', 258, NULL),
('Hotel deLuxe', 64, '2019-01-13', 274, NULL),
('Hotel deLuxe', 64, '2019-01-14', 201, NULL),
('Hotel deLuxe', 64, '2019-01-15', 260, NULL),
('Hotel deLuxe', 64, '2019-01-16', 313, NULL),
('Hotel deLuxe', 64, '2019-01-17', 330, NULL),
('Hotel deLuxe', 64, '2019-01-18', 204, NULL),
('Hotel deLuxe', 64, '2019-01-19', 344, NULL),
('Hotel deLuxe', 64, '2019-01-20', 347, NULL),
('Hotel deLuxe', 64, '2019-01-21', 330, NULL),
('Hotel deLuxe', 64, '2019-01-22', 296, NULL),
('Hotel deLuxe', 64, '2019-01-23', 157, NULL),
('Hotel deLuxe', 64, '2019-01-24', 239, NULL),
('Hotel deLuxe', 64, '2019-01-25', 342, NULL),
('Hotel deLuxe', 64, '2019-01-26', 347, NULL),
('Hotel deLuxe', 64, '2019-01-27', 140, NULL),
('Hotel deLuxe', 64, '2019-01-28', 218, NULL),
('Hotel deLuxe', 64, '2019-01-29', 118, NULL),
('Hotel deLuxe', 64, '2019-01-30', 317, NULL),
('Hotel deLuxe', 64, '2019-01-31', 189, NULL),
('Hotel deLuxe', 64, '2019-02-01', 350, NULL),
('Hotel deLuxe', 64, '2019-02-02', 329, NULL),
('Hotel deLuxe', 64, '2019-02-03', 269, NULL),
('Hotel deLuxe', 64, '2019-02-04', 208, NULL),
('Hotel deLuxe', 64, '2019-02-05', 338, NULL),
('Hotel deLuxe', 64, '2019-02-06', 335, NULL),
('Hotel deLuxe', 64, '2019-02-07', 350, NULL),
('Hotel deLuxe', 64, '2019-02-08', 348, NULL),
('Hotel deLuxe', 64, '2019-02-09', 356, NULL),
('Hotel deLuxe', 64, '2019-02-10', 232, NULL),
('Hotel deLuxe', 64, '2019-02-11', 278, NULL),
('Hotel deLuxe', 64, '2019-02-12', 179, NULL),
('Hotel deLuxe', 64, '2019-02-13', 342, NULL),
('Hotel deLuxe', 64, '2019-02-14', 257, NULL),
('Hotel deLuxe', 64, '2019-02-15', 302, NULL),
('Hotel deLuxe', 64, '2019-02-16', 342, NULL),
('Hotel deLuxe', 64, '2019-02-17', 272, NULL),
('Hotel deLuxe', 64, '2019-02-18', 394, NULL),
('Hotel deLuxe', 64, '2019-02-19', 352, NULL),
('Hotel deLuxe', 64, '2019-02-20', 262, NULL),
('Hotel deLuxe', 64, '2019-02-21', 391, NULL),
('Hotel deLuxe', 64, '2019-02-22', 375, NULL),
('Hotel deLuxe', 64, '2019-02-23', 358, NULL),
('Hotel deLuxe', 64, '2019-02-24', 213, NULL),
('Hotel deLuxe', 64, '2019-02-25', 354, NULL),
('Hotel deLuxe', 64, '2019-02-26', 357, NULL),
('Hotel deLuxe', 64, '2019-02-27', 206, NULL),
('Hotel deLuxe', 64, '2019-02-28', 252, NULL),
('Hotel deLuxe', 64, '2019-03-01', 177, NULL),
('Hotel deLuxe', 64, '2019-03-02', 285, NULL),
('Hotel deLuxe', 64, '2019-03-03', 236, NULL),
('Hotel deLuxe', 64, '2019-03-04', 342, NULL),
('Hotel deLuxe', 64, '2019-03-05', 192, NULL),
('Hotel deLuxe', 64, '2019-03-06', 213, NULL),
('Hotel deLuxe', 64, '2019-03-07', 251, NULL),
('Hotel deLuxe', 64, '2019-03-08', 319, NULL),
('Hotel deLuxe', 64, '2019-03-09', 238, NULL),
('Hotel deLuxe', 64, '2019-03-10', 245, NULL),
('Hotel deLuxe', 64, '2019-03-11', 351, NULL),
('Hotel deLuxe', 64, '2019-03-12', 358, NULL),
('Hotel deLuxe', 64, '2019-03-13', 392, NULL),
('Hotel deLuxe', 64, '2019-03-14', 317, NULL),
('Hotel deLuxe', 64, '2019-03-15', 155, NULL),
('Hotel deLuxe', 64, '2019-03-16', 324, NULL),
('Hotel deLuxe', 64, '2019-03-17', 238, NULL),
('Hotel deLuxe', 64, '2019-03-18', 268, NULL),
('Hotel deLuxe', 64, '2019-03-19', 150, NULL),
('Hotel deLuxe', 64, '2019-03-20', 139, NULL),
('Hotel deLuxe', 64, '2019-03-21', 158, NULL),
('Hotel deLuxe', 64, '2019-03-22', 244, NULL),
('Hotel deLuxe', 64, '2019-03-23', 209, NULL),
('Hotel deLuxe', 64, '2019-03-24', 314, NULL),
('Hotel deLuxe', 64, '2019-03-25', 322, NULL),
('Hotel deLuxe', 64, '2019-03-26', 180, NULL),
('Hotel deLuxe', 64, '2019-03-27', 178, NULL),
('Hotel deLuxe', 64, '2019-03-28', 119, NULL),
('Hotel deLuxe', 64, '2019-03-29', 246, NULL),
('Hotel deLuxe', 64, '2019-03-30', 390, NULL),
('Hotel deLuxe', 64, '2019-03-31', 268, NULL),
('Hotel deLuxe', 64, '2019-04-01', 125, NULL),
('Hotel deLuxe', 64, '2019-04-02', 238, NULL),
('Hotel deLuxe', 64, '2019-04-03', 166, NULL),
('Hotel deLuxe', 64, '2019-04-04', 234, NULL),
('Hotel deLuxe', 64, '2019-04-05', 331, NULL),
('Hotel deLuxe', 64, '2019-04-06', 388, NULL),
('Hotel deLuxe', 64, '2019-04-07', 378, NULL),
('Hotel deLuxe', 64, '2019-04-08', 163, NULL),
('Hotel deLuxe', 64, '2019-04-09', 259, NULL),
('Hotel deLuxe', 64, '2019-04-10', 261, NULL),
('Hotel deLuxe', 64, '2019-04-11', 203, NULL),
('Hotel deLuxe', 64, '2019-04-12', 331, NULL),
('Hotel deLuxe', 64, '2019-04-13', 212, NULL),
('Hotel deLuxe', 64, '2019-04-14', 217, NULL),
('Hotel deLuxe', 64, '2019-04-15', 308, NULL),
('Hotel deLuxe', 64, '2019-04-16', 113, NULL),
('Hotel deLuxe', 64, '2019-04-17', 399, NULL),
('Hotel deLuxe', 64, '2019-04-18', 314, NULL),
('Hotel deLuxe', 64, '2019-04-19', 188, NULL),
('Hotel deLuxe', 64, '2019-04-20', 322, NULL),
('Hotel deLuxe', 64, '2019-04-21', 341, NULL),
('Hotel deLuxe', 64, '2019-04-22', 117, NULL),
('Hotel deLuxe', 64, '2019-04-23', 293, NULL),
('Hotel deLuxe', 64, '2019-04-24', 101, NULL),
('Hotel deLuxe', 64, '2019-04-25', 217, NULL),
('Hotel deLuxe', 64, '2019-04-26', 224, NULL),
('Hotel deLuxe', 64, '2019-04-27', 108, NULL),
('Hotel deLuxe', 64, '2019-04-28', 270, NULL),
('Hotel deLuxe', 64, '2019-04-29', 116, NULL),
('Hotel deLuxe', 64, '2019-04-30', 383, NULL),
('Hotel deLuxe', 64, '2019-05-01', 146, NULL),
('Hotel deLuxe', 64, '2019-05-02', 128, NULL),
('Hotel deLuxe', 64, '2019-05-03', 192, NULL),
('Hotel deLuxe', 64, '2019-05-04', 242, NULL),
('Hotel deLuxe', 64, '2019-05-05', 117, NULL),
('Hotel deLuxe', 64, '2019-05-06', 236, NULL),
('Hotel deLuxe', 64, '2019-05-07', 278, NULL),
('Hotel deLuxe', 64, '2019-05-08', 208, NULL),
('Hotel deLuxe', 64, '2019-05-09', 171, NULL),
('Hotel deLuxe', 64, '2019-05-10', 185, NULL),
('Hotel deLuxe', 64, '2019-05-11', 363, NULL),
('Hotel deLuxe', 64, '2019-05-12', 304, NULL),
('Hotel deLuxe', 64, '2019-05-13', 116, NULL),
('Hotel deLuxe', 64, '2019-05-14', 298, NULL),
('Hotel deLuxe', 64, '2019-05-15', 363, NULL),
('Hotel deLuxe', 64, '2019-05-16', 351, NULL),
('Hotel deLuxe', 64, '2019-05-17', 101, NULL),
('Hotel deLuxe', 64, '2019-05-18', 286, NULL),
('Hotel deLuxe', 64, '2019-05-19', 292, NULL),
('Hotel deLuxe', 64, '2019-05-20', 334, NULL),
('Hotel deLuxe', 64, '2019-05-21', 193, NULL),
('Hotel deLuxe', 64, '2019-05-22', 137, NULL),
('Hotel deLuxe', 64, '2019-05-23', 147, NULL),
('Hotel deLuxe', 64, '2019-05-24', 297, NULL),
('Hotel deLuxe', 64, '2019-05-25', 167, NULL),
('Hotel deLuxe', 64, '2019-05-26', 163, NULL),
('Hotel deLuxe', 64, '2019-05-27', 333, NULL),
('Hotel deLuxe', 64, '2019-05-28', 180, NULL),
('Hotel deLuxe', 64, '2019-05-29', 369, NULL),
('Hotel deLuxe', 64, '2019-05-30', 380, NULL),
('Hotel deLuxe', 64, '2019-05-31', 197, NULL),
('Hotel deLuxe', 64, '2019-06-01', 235, NULL),
('Hotel deLuxe', 64, '2019-06-02', 396, NULL),
('Hotel deLuxe', 64, '2019-06-03', 159, NULL),
('Hotel deLuxe', 64, '2019-06-04', 240, NULL),
('Hotel deLuxe', 64, '2019-06-05', 207, NULL),
('Hotel deLuxe', 64, '2019-06-06', 283, NULL),
('Hotel deLuxe', 64, '2019-06-07', 270, NULL),
('Hotel deLuxe', 64, '2019-06-08', 191, NULL),
('Hotel deLuxe', 64, '2019-06-09', 371, NULL),
('Hotel deLuxe', 64, '2019-06-10', 194, NULL),
('Hotel deLuxe', 64, '2019-06-11', 273, NULL),
('Hotel deLuxe', 64, '2019-06-12', 250, NULL),
('Hotel deLuxe', 64, '2019-06-13', 202, NULL),
('Hotel deLuxe', 64, '2019-06-14', 329, NULL),
('Hotel deLuxe', 64, '2019-06-15', 195, NULL),
('Hotel deLuxe', 64, '2019-06-16', 389, NULL),
('Hotel deLuxe', 64, '2019-06-17', 312, NULL),
('Hotel deLuxe', 64, '2019-06-18', 161, NULL),
('Hotel deLuxe', 64, '2019-06-19', 290, NULL),
('Hotel deLuxe', 64, '2019-06-20', 360, NULL),
('Hotel deLuxe', 64, '2019-06-21', 389, NULL),
('Hotel deLuxe', 64, '2019-06-22', 295, NULL),
('Hotel deLuxe', 64, '2019-06-23', 339, NULL),
('Hotel deLuxe', 64, '2019-06-24', 232, NULL),
('Hotel deLuxe', 64, '2019-06-25', 319, NULL),
('Hotel deLuxe', 64, '2019-06-26', 358, NULL),
('Hotel deLuxe', 64, '2019-06-27', 108, NULL),
('Hotel deLuxe', 64, '2019-06-28', 203, NULL),
('Hotel deLuxe', 64, '2019-06-29', 309, NULL),
('Hotel deLuxe', 64, '2019-06-30', 187, NULL),
('Hotel deLuxe', 64, '2019-07-01', 319, NULL),
('Hotel deLuxe', 64, '2019-07-02', 183, NULL),
('Hotel deLuxe', 64, '2019-07-03', 390, NULL),
('Hotel deLuxe', 64, '2019-07-04', 159, NULL),
('Hotel deLuxe', 64, '2019-07-05', 386, NULL),
('Hotel deLuxe', 64, '2019-07-06', 165, NULL),
('Hotel deLuxe', 64, '2019-07-07', 385, NULL),
('Hotel deLuxe', 64, '2019-07-08', 164, NULL),
('Hotel deLuxe', 64, '2019-07-09', 223, NULL),
('Hotel deLuxe', 64, '2019-07-10', 306, NULL),
('Hotel deLuxe', 64, '2019-07-11', 172, NULL),
('Hotel deLuxe', 64, '2019-07-12', 387, NULL),
('Hotel deLuxe', 64, '2019-07-13', 115, NULL),
('Hotel deLuxe', 64, '2019-07-14', 223, NULL),
('Hotel deLuxe', 64, '2019-07-15', 215, NULL),
('Hotel deLuxe', 64, '2019-07-16', 210, NULL),
('Hotel deLuxe', 64, '2019-07-17', 103, NULL),
('Hotel deLuxe', 64, '2019-07-18', 211, NULL),
('Hotel deLuxe', 64, '2019-07-19', 146, NULL),
('Hotel deLuxe', 64, '2019-07-20', 152, NULL),
('Hotel deLuxe', 64, '2019-07-21', 393, NULL),
('Hotel deLuxe', 64, '2019-07-22', 317, NULL),
('Hotel deLuxe', 64, '2019-07-23', 310, NULL),
('Hotel deLuxe', 64, '2019-07-24', 161, NULL),
('Hotel deLuxe', 64, '2019-07-25', 235, NULL),
('Hotel deLuxe', 64, '2019-07-26', 283, NULL),
('Hotel deLuxe', 64, '2019-07-27', 112, NULL),
('Hotel deLuxe', 64, '2019-07-28', 337, NULL),
('Hotel deLuxe', 64, '2019-07-29', 329, NULL),
('Hotel deLuxe', 64, '2019-07-30', 121, NULL),
('Hotel deLuxe', 64, '2019-07-31', 189, NULL),
('Hotel deLuxe', 64, '2019-08-01', 232, NULL),
('Hotel deLuxe', 64, '2019-08-02', 170, NULL),
('Hotel deLuxe', 64, '2019-08-03', 274, NULL),
('Hotel deLuxe', 64, '2019-08-04', 189, NULL),
('Hotel deLuxe', 64, '2019-08-05', 283, NULL),
('Hotel deLuxe', 64, '2019-08-06', 250, NULL),
('Hotel deLuxe', 64, '2019-08-07', 227, NULL),
('Hotel deLuxe', 64, '2019-08-08', 365, NULL),
('Hotel deLuxe', 64, '2019-08-09', 391, NULL),
('Hotel deLuxe', 64, '2019-08-10', 102, NULL),
('Hotel deLuxe', 64, '2019-08-11', 177, NULL),
('Hotel deLuxe', 64, '2019-08-12', 141, NULL),
('Hotel deLuxe', 64, '2019-08-13', 389, NULL),
('Hotel deLuxe', 64, '2019-08-14', 260, NULL),
('Hotel deLuxe', 64, '2019-08-15', 348, NULL),
('Hotel deLuxe', 64, '2019-08-16', 117, NULL),
('Hotel deLuxe', 64, '2019-08-17', 100, NULL),
('Hotel deLuxe', 64, '2019-08-18', 387, NULL),
('Hotel deLuxe', 64, '2019-08-19', 161, NULL),
('Hotel deLuxe', 64, '2019-08-20', 232, NULL),
('Hotel deLuxe', 64, '2019-08-21', 181, NULL),
('Hotel deLuxe', 64, '2019-08-22', 255, NULL),
('Hotel deLuxe', 64, '2019-08-23', 149, NULL),
('Hotel deLuxe', 64, '2019-08-24', 100, NULL),
('Hotel deLuxe', 64, '2019-08-25', 203, NULL),
('Hotel deLuxe', 64, '2019-08-26', 344, NULL),
('Hotel deLuxe', 64, '2019-08-27', 335, NULL),
('Hotel deLuxe', 64, '2019-08-28', 303, NULL),
('Hotel deLuxe', 64, '2019-08-29', 304, NULL),
('Hotel deLuxe', 64, '2019-08-30', 354, NULL),
('Hotel deLuxe', 64, '2019-08-31', 310, NULL),
('Hotel deLuxe', 64, '2019-09-01', 253, NULL),
('Hotel deLuxe', 64, '2019-09-02', 239, NULL),
('Hotel deLuxe', 64, '2019-09-03', 149, NULL),
('Hotel deLuxe', 64, '2019-09-04', 173, NULL),
('Hotel deLuxe', 64, '2019-09-05', 164, NULL),
('Hotel deLuxe', 64, '2019-09-06', 292, NULL),
('Hotel deLuxe', 64, '2019-09-07', 217, NULL),
('Hotel deLuxe', 64, '2019-09-08', 189, NULL),
('Hotel deLuxe', 64, '2019-09-09', 307, NULL),
('Hotel deLuxe', 64, '2019-09-10', 180, NULL),
('Hotel deLuxe', 64, '2019-09-11', 144, NULL),
('Hotel deLuxe', 64, '2019-09-12', 243, NULL),
('Hotel deLuxe', 64, '2019-09-13', 165, NULL),
('Hotel deLuxe', 64, '2019-09-14', 344, NULL),
('Hotel deLuxe', 64, '2019-09-15', 268, NULL),
('Hotel deLuxe', 64, '2019-09-16', 101, NULL),
('Hotel deLuxe', 64, '2019-09-17', 369, NULL),
('Hotel deLuxe', 64, '2019-09-18', 145, NULL),
('Hotel deLuxe', 64, '2019-09-19', 307, NULL),
('Hotel deLuxe', 64, '2019-09-20', 118, NULL),
('Hotel deLuxe', 64, '2019-09-21', 321, NULL),
('Hotel deLuxe', 64, '2019-09-22', 270, NULL),
('Hotel deLuxe', 64, '2019-09-23', 249, NULL),
('Hotel deLuxe', 64, '2019-09-24', 363, NULL),
('Hotel deLuxe', 64, '2019-09-25', 104, NULL),
('Hotel deLuxe', 64, '2019-09-26', 205, NULL),
('Hotel deLuxe', 64, '2019-09-27', 309, NULL),
('Hotel deLuxe', 64, '2019-09-28', 277, NULL),
('Hotel deLuxe', 64, '2019-09-29', 191, NULL),
('Hotel deLuxe', 64, '2019-09-30', 124, NULL),
('Hotel deLuxe', 64, '2019-10-01', 168, NULL),
('Hotel deLuxe', 64, '2019-10-02', 144, NULL),
('Hotel deLuxe', 64, '2019-10-03', 303, NULL),
('Hotel deLuxe', 64, '2019-10-04', 141, NULL),
('Hotel deLuxe', 64, '2019-10-05', 129, NULL),
('Hotel deLuxe', 64, '2019-10-06', 319, NULL),
('Hotel deLuxe', 64, '2019-10-07', 363, NULL),
('Hotel deLuxe', 64, '2019-10-08', 204, NULL),
('Hotel deLuxe', 64, '2019-10-09', 289, NULL),
('Hotel deLuxe', 64, '2019-10-10', 250, NULL),
('Hotel deLuxe', 64, '2019-10-11', 149, NULL),
('Hotel deLuxe', 64, '2019-10-12', 146, NULL),
('Hotel deLuxe', 64, '2019-10-13', 227, NULL),
('Hotel deLuxe', 64, '2019-10-14', 148, NULL),
('Hotel deLuxe', 64, '2019-10-15', 311, NULL),
('Hotel deLuxe', 64, '2019-10-16', 179, NULL),
('Hotel deLuxe', 64, '2019-10-17', 176, NULL),
('Hotel deLuxe', 64, '2019-10-18', 335, NULL),
('Hotel deLuxe', 64, '2019-10-19', 139, NULL),
('Hotel deLuxe', 64, '2019-10-20', 390, NULL),
('Hotel deLuxe', 64, '2019-10-21', 375, NULL),
('Hotel deLuxe', 64, '2019-10-22', 126, NULL),
('Hotel deLuxe', 64, '2019-10-23', 322, NULL),
('Hotel deLuxe', 64, '2019-10-24', 307, NULL),
('Hotel deLuxe', 64, '2019-10-25', 139, NULL),
('Hotel deLuxe', 64, '2019-10-26', 398, NULL),
('Hotel deLuxe', 64, '2019-10-27', 287, NULL),
('Hotel deLuxe', 64, '2019-10-28', 185, NULL),
('Hotel deLuxe', 64, '2019-10-29', 141, NULL),
('Hotel deLuxe', 64, '2019-10-30', 224, NULL),
('Hotel deLuxe', 64, '2019-10-31', 336, NULL),
('Hotel deLuxe', 64, '2019-11-01', 130, NULL),
('Hotel deLuxe', 64, '2019-11-02', 328, NULL),
('Hotel deLuxe', 64, '2019-11-03', 355, NULL),
('Hotel deLuxe', 64, '2019-11-04', 371, NULL),
('Hotel deLuxe', 64, '2019-11-05', 254, NULL),
('Hotel deLuxe', 64, '2019-11-06', 139, NULL),
('Hotel deLuxe', 64, '2019-11-07', 362, NULL),
('Hotel deLuxe', 64, '2019-11-08', 147, NULL),
('Hotel deLuxe', 64, '2019-11-09', 133, NULL),
('Hotel deLuxe', 64, '2019-11-10', 142, NULL),
('Hotel deLuxe', 64, '2019-11-11', 314, NULL),
('Hotel deLuxe', 64, '2019-11-12', 268, NULL),
('Hotel deLuxe', 64, '2019-11-13', 256, NULL),
('Hotel deLuxe', 64, '2019-11-14', 222, NULL),
('Hotel deLuxe', 64, '2019-11-15', 371, NULL),
('Hotel deLuxe', 64, '2019-11-16', 167, NULL),
('Hotel deLuxe', 64, '2019-11-17', 377, NULL),
('Hotel deLuxe', 64, '2019-11-18', 249, NULL),
('Hotel deLuxe', 64, '2019-11-19', 171, NULL),
('Hotel deLuxe', 64, '2019-11-20', 289, NULL),
('Hotel deLuxe', 64, '2019-11-21', 175, NULL),
('Hotel deLuxe', 64, '2019-11-22', 269, NULL),
('Hotel deLuxe', 64, '2019-11-23', 243, NULL),
('Hotel deLuxe', 64, '2019-11-24', 254, NULL),
('Hotel deLuxe', 64, '2019-11-25', 107, NULL),
('Hotel deLuxe', 64, '2019-11-26', 123, NULL),
('Hotel deLuxe', 64, '2019-11-27', 366, NULL),
('Hotel deLuxe', 64, '2019-11-28', 319, NULL),
('Hotel deLuxe', 64, '2019-11-29', 111, NULL),
('Hotel deLuxe', 64, '2019-11-30', 203, NULL),
('Hotel deLuxe', 64, '2019-12-01', 179, NULL),
('Hotel deLuxe', 64, '2019-12-02', 366, NULL),
('Hotel deLuxe', 64, '2019-12-03', 131, NULL),
('Hotel deLuxe', 64, '2019-12-04', 160, NULL),
('Hotel deLuxe', 64, '2019-12-05', 292, NULL),
('Hotel deLuxe', 64, '2019-12-06', 165, NULL),
('Hotel deLuxe', 64, '2019-12-07', 346, NULL),
('Hotel deLuxe', 64, '2019-12-08', 269, NULL),
('Hotel deLuxe', 64, '2019-12-09', 366, NULL),
('Hotel deLuxe', 64, '2019-12-10', 225, NULL),
('Hotel deLuxe', 64, '2019-12-11', 371, NULL),
('Hotel deLuxe', 64, '2019-12-12', 159, NULL),
('Hotel deLuxe', 64, '2019-12-13', 296, NULL),
('Hotel deLuxe', 64, '2019-12-14', 329, NULL),
('Hotel deLuxe', 64, '2019-12-15', 126, NULL),
('Hotel deLuxe', 64, '2019-12-16', 293, NULL),
('Hotel deLuxe', 64, '2019-12-17', 180, NULL),
('Hotel deLuxe', 64, '2019-12-18', 269, NULL),
('Hotel deLuxe', 64, '2019-12-19', 157, NULL),
('Hotel deLuxe', 64, '2019-12-20', 110, NULL),
('Hotel deLuxe', 64, '2019-12-21', 272, NULL),
('Hotel deLuxe', 64, '2019-12-22', 182, NULL),
('Hotel deLuxe', 64, '2019-12-23', 162, NULL),
('Hotel deLuxe', 64, '2019-12-24', 369, NULL),
('Hotel deLuxe', 64, '2019-12-25', 240, NULL),
('Hotel deLuxe', 64, '2019-12-26', 369, NULL),
('Hotel deLuxe', 64, '2019-12-27', 195, NULL),
('Hotel deLuxe', 64, '2019-12-28', 356, NULL),
('Hotel deLuxe', 64, '2019-12-29', 148, NULL),
('Hotel deLuxe', 64, '2019-12-30', 112, NULL),
('Hotel deLuxe', 64, '2019-12-31', 134, NULL),
('Hotel deLuxe', 64, '2020-01-01', 341, NULL),
('Hotel deLuxe', 64, '2020-01-02', 392, NULL),
('Hotel deLuxe', 64, '2020-01-03', 108, NULL),
('Hotel deLuxe', 64, '2020-01-04', 371, NULL),
('Hotel deLuxe', 64, '2020-01-05', 200, NULL),
('Hotel deLuxe', 64, '2020-01-06', 314, NULL),
('Hotel deLuxe', 64, '2020-01-07', 126, NULL),
('Hotel deLuxe', 64, '2020-01-08', 358, NULL),
('Hotel deLuxe', 64, '2020-01-09', 295, NULL),
('Hotel deLuxe', 64, '2020-01-10', 147, NULL),
('Hotel deLuxe', 64, '2020-01-11', 188, NULL),
('Hotel deLuxe', 64, '2020-01-12', 260, NULL),
('Hotel deLuxe', 64, '2020-01-13', 348, NULL),
('Hotel deLuxe', 64, '2020-01-14', 133, NULL),
('Hotel deLuxe', 64, '2020-01-15', 160, NULL),
('Hotel deLuxe', 64, '2020-01-16', 159, NULL),
('Hotel deLuxe', 64, '2020-01-17', 245, NULL),
('Hotel deLuxe', 64, '2020-01-18', 163, NULL),
('Hotel deLuxe', 64, '2020-01-19', 146, NULL),
('Hotel deLuxe', 64, '2020-01-20', 376, NULL),
('Hotel deLuxe', 64, '2020-01-21', 365, NULL),
('Hotel deLuxe', 64, '2020-01-22', 341, NULL),
('Hotel deLuxe', 64, '2020-01-23', 148, NULL),
('Hotel deLuxe', 64, '2020-01-24', 280, NULL),
('Hotel deLuxe', 64, '2020-01-25', 106, NULL),
('Hotel deLuxe', 64, '2020-01-26', 146, NULL),
('Hotel deLuxe', 64, '2020-01-27', 250, NULL),
('Hotel deLuxe', 64, '2020-01-28', 173, NULL),
('Hotel deLuxe', 64, '2020-01-29', 323, NULL),
('Hotel deLuxe', 64, '2020-01-30', 240, NULL),
('Hotel deLuxe', 64, '2020-01-31', 185, NULL),
('Hotel deLuxe', 64, '2020-02-01', 113, NULL),
('Hotel deLuxe', 64, '2020-02-02', 374, NULL),
('Hotel deLuxe', 64, '2020-02-03', 193, NULL),
('Hotel deLuxe', 64, '2020-02-04', 162, NULL),
('Hotel deLuxe', 65, '2019-01-01', 102, NULL),
('Hotel deLuxe', 65, '2019-01-02', 207, NULL),
('Hotel deLuxe', 65, '2019-01-03', 395, NULL),
('Hotel deLuxe', 65, '2019-01-04', 353, NULL),
('Hotel deLuxe', 65, '2019-01-05', 123, NULL),
('Hotel deLuxe', 65, '2019-01-06', 232, NULL),
('Hotel deLuxe', 65, '2019-01-07', 316, NULL),
('Hotel deLuxe', 65, '2019-01-08', 378, NULL),
('Hotel deLuxe', 65, '2019-01-09', 296, NULL),
('Hotel deLuxe', 65, '2019-01-10', 310, NULL),
('Hotel deLuxe', 65, '2019-01-11', 233, NULL),
('Hotel deLuxe', 65, '2019-01-12', 289, NULL),
('Hotel deLuxe', 65, '2019-01-13', 342, NULL),
('Hotel deLuxe', 65, '2019-01-14', 121, NULL),
('Hotel deLuxe', 65, '2019-01-15', 286, NULL),
('Hotel deLuxe', 65, '2019-01-16', 229, NULL),
('Hotel deLuxe', 65, '2019-01-17', 311, NULL),
('Hotel deLuxe', 65, '2019-01-18', 378, NULL),
('Hotel deLuxe', 65, '2019-01-19', 137, NULL),
('Hotel deLuxe', 65, '2019-01-20', 335, NULL),
('Hotel deLuxe', 65, '2019-01-21', 293, NULL),
('Hotel deLuxe', 65, '2019-01-22', 240, NULL),
('Hotel deLuxe', 65, '2019-01-23', 256, NULL),
('Hotel deLuxe', 65, '2019-01-24', 203, NULL),
('Hotel deLuxe', 65, '2019-01-25', 371, NULL),
('Hotel deLuxe', 65, '2019-01-26', 118, NULL),
('Hotel deLuxe', 65, '2019-01-27', 153, NULL),
('Hotel deLuxe', 65, '2019-01-28', 306, NULL),
('Hotel deLuxe', 65, '2019-01-29', 179, NULL),
('Hotel deLuxe', 65, '2019-01-30', 120, NULL),
('Hotel deLuxe', 65, '2019-01-31', 399, NULL),
('Hotel deLuxe', 65, '2019-02-01', 270, NULL),
('Hotel deLuxe', 65, '2019-02-02', 157, NULL),
('Hotel deLuxe', 65, '2019-02-03', 261, NULL),
('Hotel deLuxe', 65, '2019-02-04', 242, NULL),
('Hotel deLuxe', 65, '2019-02-05', 266, NULL),
('Hotel deLuxe', 65, '2019-02-06', 393, NULL),
('Hotel deLuxe', 65, '2019-02-07', 298, NULL),
('Hotel deLuxe', 65, '2019-02-08', 311, NULL),
('Hotel deLuxe', 65, '2019-02-09', 214, NULL),
('Hotel deLuxe', 65, '2019-02-10', 168, NULL),
('Hotel deLuxe', 65, '2019-02-11', 257, NULL),
('Hotel deLuxe', 65, '2019-02-12', 109, NULL),
('Hotel deLuxe', 65, '2019-02-13', 120, NULL),
('Hotel deLuxe', 65, '2019-02-14', 365, NULL),
('Hotel deLuxe', 65, '2019-02-15', 252, NULL),
('Hotel deLuxe', 65, '2019-02-16', 311, NULL),
('Hotel deLuxe', 65, '2019-02-17', 119, NULL),
('Hotel deLuxe', 65, '2019-02-18', 183, NULL),
('Hotel deLuxe', 65, '2019-02-19', 102, NULL),
('Hotel deLuxe', 65, '2019-02-20', 259, NULL),
('Hotel deLuxe', 65, '2019-02-21', 290, NULL),
('Hotel deLuxe', 65, '2019-02-22', 216, NULL),
('Hotel deLuxe', 65, '2019-02-23', 301, NULL),
('Hotel deLuxe', 65, '2019-02-24', 370, NULL),
('Hotel deLuxe', 65, '2019-02-25', 240, NULL),
('Hotel deLuxe', 65, '2019-02-26', 337, NULL),
('Hotel deLuxe', 65, '2019-02-27', 205, NULL),
('Hotel deLuxe', 65, '2019-02-28', 389, NULL),
('Hotel deLuxe', 65, '2019-03-01', 399, NULL),
('Hotel deLuxe', 65, '2019-03-02', 191, NULL),
('Hotel deLuxe', 65, '2019-03-03', 213, NULL),
('Hotel deLuxe', 65, '2019-03-04', 164, NULL),
('Hotel deLuxe', 65, '2019-03-05', 209, NULL),
('Hotel deLuxe', 65, '2019-03-06', 213, NULL),
('Hotel deLuxe', 65, '2019-03-07', 307, NULL),
('Hotel deLuxe', 65, '2019-03-08', 129, NULL),
('Hotel deLuxe', 65, '2019-03-09', 366, NULL),
('Hotel deLuxe', 65, '2019-03-10', 313, NULL),
('Hotel deLuxe', 65, '2019-03-11', 321, NULL),
('Hotel deLuxe', 65, '2019-03-12', 132, NULL),
('Hotel deLuxe', 65, '2019-03-13', 149, NULL),
('Hotel deLuxe', 65, '2019-03-14', 204, NULL),
('Hotel deLuxe', 65, '2019-03-15', 373, NULL),
('Hotel deLuxe', 65, '2019-03-16', 362, NULL),
('Hotel deLuxe', 65, '2019-03-17', 144, NULL),
('Hotel deLuxe', 65, '2019-03-18', 150, NULL),
('Hotel deLuxe', 65, '2019-03-19', 390, NULL),
('Hotel deLuxe', 65, '2019-03-20', 179, NULL),
('Hotel deLuxe', 65, '2019-03-21', 349, NULL),
('Hotel deLuxe', 65, '2019-03-22', 163, NULL),
('Hotel deLuxe', 65, '2019-03-23', 221, NULL),
('Hotel deLuxe', 65, '2019-03-24', 163, NULL),
('Hotel deLuxe', 65, '2019-03-25', 115, NULL),
('Hotel deLuxe', 65, '2019-03-26', 141, NULL),
('Hotel deLuxe', 65, '2019-03-27', 102, NULL),
('Hotel deLuxe', 65, '2019-03-28', 312, NULL),
('Hotel deLuxe', 65, '2019-03-29', 152, NULL),
('Hotel deLuxe', 65, '2019-03-30', 141, NULL),
('Hotel deLuxe', 65, '2019-03-31', 112, NULL),
('Hotel deLuxe', 65, '2019-04-01', 178, NULL),
('Hotel deLuxe', 65, '2019-04-02', 100, NULL),
('Hotel deLuxe', 65, '2019-04-03', 120, NULL),
('Hotel deLuxe', 65, '2019-04-04', 359, NULL),
('Hotel deLuxe', 65, '2019-04-05', 317, NULL),
('Hotel deLuxe', 65, '2019-04-06', 109, NULL),
('Hotel deLuxe', 65, '2019-04-07', 372, NULL),
('Hotel deLuxe', 65, '2019-04-08', 255, NULL),
('Hotel deLuxe', 65, '2019-04-09', 286, NULL),
('Hotel deLuxe', 65, '2019-04-10', 373, NULL),
('Hotel deLuxe', 65, '2019-04-11', 330, NULL),
('Hotel deLuxe', 65, '2019-04-12', 277, NULL),
('Hotel deLuxe', 65, '2019-04-13', 374, NULL),
('Hotel deLuxe', 65, '2019-04-14', 254, NULL),
('Hotel deLuxe', 65, '2019-04-15', 364, NULL),
('Hotel deLuxe', 65, '2019-04-16', 338, NULL),
('Hotel deLuxe', 65, '2019-04-17', 224, NULL),
('Hotel deLuxe', 65, '2019-04-18', 208, NULL),
('Hotel deLuxe', 65, '2019-04-19', 120, NULL),
('Hotel deLuxe', 65, '2019-04-20', 224, NULL),
('Hotel deLuxe', 65, '2019-04-21', 184, NULL),
('Hotel deLuxe', 65, '2019-04-22', 181, NULL),
('Hotel deLuxe', 65, '2019-04-23', 244, NULL),
('Hotel deLuxe', 65, '2019-04-24', 238, NULL),
('Hotel deLuxe', 65, '2019-04-25', 182, NULL),
('Hotel deLuxe', 65, '2019-04-26', 286, NULL),
('Hotel deLuxe', 65, '2019-04-27', 301, NULL),
('Hotel deLuxe', 65, '2019-04-28', 295, NULL),
('Hotel deLuxe', 65, '2019-04-29', 236, NULL),
('Hotel deLuxe', 65, '2019-04-30', 383, NULL),
('Hotel deLuxe', 65, '2019-05-01', 307, NULL),
('Hotel deLuxe', 65, '2019-05-02', 190, NULL),
('Hotel deLuxe', 65, '2019-05-03', 194, NULL),
('Hotel deLuxe', 65, '2019-05-04', 126, NULL),
('Hotel deLuxe', 65, '2019-05-05', 182, NULL),
('Hotel deLuxe', 65, '2019-05-06', 152, NULL),
('Hotel deLuxe', 65, '2019-05-07', 246, NULL),
('Hotel deLuxe', 65, '2019-05-08', 171, NULL),
('Hotel deLuxe', 65, '2019-05-09', 314, NULL),
('Hotel deLuxe', 65, '2019-05-10', 292, NULL),
('Hotel deLuxe', 65, '2019-05-11', 252, NULL),
('Hotel deLuxe', 65, '2019-05-12', 195, NULL),
('Hotel deLuxe', 65, '2019-05-13', 161, NULL),
('Hotel deLuxe', 65, '2019-05-14', 367, NULL),
('Hotel deLuxe', 65, '2019-05-15', 385, NULL),
('Hotel deLuxe', 65, '2019-05-16', 153, NULL),
('Hotel deLuxe', 65, '2019-05-17', 390, NULL),
('Hotel deLuxe', 65, '2019-05-18', 246, NULL),
('Hotel deLuxe', 65, '2019-05-19', 151, NULL),
('Hotel deLuxe', 65, '2019-05-20', 157, NULL),
('Hotel deLuxe', 65, '2019-05-21', 184, NULL),
('Hotel deLuxe', 65, '2019-05-22', 316, NULL),
('Hotel deLuxe', 65, '2019-05-23', 129, NULL),
('Hotel deLuxe', 65, '2019-05-24', 148, NULL),
('Hotel deLuxe', 65, '2019-05-25', 264, NULL),
('Hotel deLuxe', 65, '2019-05-26', 150, NULL),
('Hotel deLuxe', 65, '2019-05-27', 263, NULL),
('Hotel deLuxe', 65, '2019-05-28', 119, NULL),
('Hotel deLuxe', 65, '2019-05-29', 362, NULL),
('Hotel deLuxe', 65, '2019-05-30', 126, NULL),
('Hotel deLuxe', 65, '2019-05-31', 347, NULL),
('Hotel deLuxe', 65, '2019-06-01', 211, NULL),
('Hotel deLuxe', 65, '2019-06-02', 133, NULL),
('Hotel deLuxe', 65, '2019-06-03', 207, NULL),
('Hotel deLuxe', 65, '2019-06-04', 306, NULL),
('Hotel deLuxe', 65, '2019-06-05', 117, NULL),
('Hotel deLuxe', 65, '2019-06-06', 144, NULL),
('Hotel deLuxe', 65, '2019-06-07', 155, NULL),
('Hotel deLuxe', 65, '2019-06-08', 273, NULL),
('Hotel deLuxe', 65, '2019-06-09', 123, NULL),
('Hotel deLuxe', 65, '2019-06-10', 143, NULL),
('Hotel deLuxe', 65, '2019-06-11', 315, NULL),
('Hotel deLuxe', 65, '2019-06-12', 244, NULL),
('Hotel deLuxe', 65, '2019-06-13', 266, NULL),
('Hotel deLuxe', 65, '2019-06-14', 388, NULL),
('Hotel deLuxe', 65, '2019-06-15', 337, NULL),
('Hotel deLuxe', 65, '2019-06-16', 130, NULL),
('Hotel deLuxe', 65, '2019-06-17', 206, NULL),
('Hotel deLuxe', 65, '2019-06-18', 128, NULL),
('Hotel deLuxe', 65, '2019-06-19', 306, NULL),
('Hotel deLuxe', 65, '2019-06-20', 281, NULL),
('Hotel deLuxe', 65, '2019-06-21', 166, NULL),
('Hotel deLuxe', 65, '2019-06-22', 168, NULL),
('Hotel deLuxe', 65, '2019-06-23', 145, NULL),
('Hotel deLuxe', 65, '2019-06-24', 275, NULL),
('Hotel deLuxe', 65, '2019-06-25', 388, NULL),
('Hotel deLuxe', 65, '2019-06-26', 289, NULL),
('Hotel deLuxe', 65, '2019-06-27', 348, NULL),
('Hotel deLuxe', 65, '2019-06-28', 305, NULL),
('Hotel deLuxe', 65, '2019-06-29', 184, NULL),
('Hotel deLuxe', 65, '2019-06-30', 399, NULL),
('Hotel deLuxe', 65, '2019-07-01', 216, NULL),
('Hotel deLuxe', 65, '2019-07-02', 149, NULL),
('Hotel deLuxe', 65, '2019-07-03', 263, NULL),
('Hotel deLuxe', 65, '2019-07-04', 332, NULL),
('Hotel deLuxe', 65, '2019-07-05', 209, NULL),
('Hotel deLuxe', 65, '2019-07-06', 144, NULL),
('Hotel deLuxe', 65, '2019-07-07', 166, NULL),
('Hotel deLuxe', 65, '2019-07-08', 305, NULL),
('Hotel deLuxe', 65, '2019-07-09', 291, NULL),
('Hotel deLuxe', 65, '2019-07-10', 376, NULL),
('Hotel deLuxe', 65, '2019-07-11', 366, NULL),
('Hotel deLuxe', 65, '2019-07-12', 334, NULL),
('Hotel deLuxe', 65, '2019-07-13', 238, NULL),
('Hotel deLuxe', 65, '2019-07-14', 271, NULL),
('Hotel deLuxe', 65, '2019-07-15', 182, NULL),
('Hotel deLuxe', 65, '2019-07-16', 276, NULL),
('Hotel deLuxe', 65, '2019-07-17', 172, NULL),
('Hotel deLuxe', 65, '2019-07-18', 230, NULL),
('Hotel deLuxe', 65, '2019-07-19', 203, NULL),
('Hotel deLuxe', 65, '2019-07-20', 314, NULL),
('Hotel deLuxe', 65, '2019-07-21', 145, NULL),
('Hotel deLuxe', 65, '2019-07-22', 266, NULL),
('Hotel deLuxe', 65, '2019-07-23', 131, NULL),
('Hotel deLuxe', 65, '2019-07-24', 100, NULL),
('Hotel deLuxe', 65, '2019-07-25', 252, NULL),
('Hotel deLuxe', 65, '2019-07-26', 148, NULL),
('Hotel deLuxe', 65, '2019-07-27', 293, NULL),
('Hotel deLuxe', 65, '2019-07-28', 356, NULL),
('Hotel deLuxe', 65, '2019-07-29', 324, NULL),
('Hotel deLuxe', 65, '2019-07-30', 202, NULL),
('Hotel deLuxe', 65, '2019-07-31', 175, NULL),
('Hotel deLuxe', 65, '2019-08-01', 136, NULL),
('Hotel deLuxe', 65, '2019-08-02', 324, NULL),
('Hotel deLuxe', 65, '2019-08-03', 372, NULL),
('Hotel deLuxe', 65, '2019-08-04', 305, NULL),
('Hotel deLuxe', 65, '2019-08-05', 128, NULL),
('Hotel deLuxe', 65, '2019-08-06', 134, NULL),
('Hotel deLuxe', 65, '2019-08-07', 275, NULL),
('Hotel deLuxe', 65, '2019-08-08', 328, NULL),
('Hotel deLuxe', 65, '2019-08-09', 207, NULL),
('Hotel deLuxe', 65, '2019-08-10', 197, NULL),
('Hotel deLuxe', 65, '2019-08-11', 319, NULL),
('Hotel deLuxe', 65, '2019-08-12', 128, NULL),
('Hotel deLuxe', 65, '2019-08-13', 275, NULL),
('Hotel deLuxe', 65, '2019-08-14', 276, NULL),
('Hotel deLuxe', 65, '2019-08-15', 274, NULL),
('Hotel deLuxe', 65, '2019-08-16', 365, NULL),
('Hotel deLuxe', 65, '2019-08-17', 184, NULL),
('Hotel deLuxe', 65, '2019-08-18', 374, NULL),
('Hotel deLuxe', 65, '2019-08-19', 353, NULL),
('Hotel deLuxe', 65, '2019-08-20', 184, NULL),
('Hotel deLuxe', 65, '2019-08-21', 104, NULL),
('Hotel deLuxe', 65, '2019-08-22', 178, NULL),
('Hotel deLuxe', 65, '2019-08-23', 147, NULL),
('Hotel deLuxe', 65, '2019-08-24', 365, NULL),
('Hotel deLuxe', 65, '2019-08-25', 149, NULL),
('Hotel deLuxe', 65, '2019-08-26', 234, NULL),
('Hotel deLuxe', 65, '2019-08-27', 379, NULL),
('Hotel deLuxe', 65, '2019-08-28', 138, NULL),
('Hotel deLuxe', 65, '2019-08-29', 168, NULL),
('Hotel deLuxe', 65, '2019-08-30', 172, NULL),
('Hotel deLuxe', 65, '2019-08-31', 389, NULL),
('Hotel deLuxe', 65, '2019-09-01', 137, NULL),
('Hotel deLuxe', 65, '2019-09-02', 242, NULL),
('Hotel deLuxe', 65, '2019-09-03', 295, NULL),
('Hotel deLuxe', 65, '2019-09-04', 165, NULL),
('Hotel deLuxe', 65, '2019-09-05', 193, NULL),
('Hotel deLuxe', 65, '2019-09-06', 217, NULL),
('Hotel deLuxe', 65, '2019-09-07', 249, NULL),
('Hotel deLuxe', 65, '2019-09-08', 265, NULL),
('Hotel deLuxe', 65, '2019-09-09', 252, NULL),
('Hotel deLuxe', 65, '2019-09-10', 303, NULL),
('Hotel deLuxe', 65, '2019-09-11', 272, NULL),
('Hotel deLuxe', 65, '2019-09-12', 345, NULL),
('Hotel deLuxe', 65, '2019-09-13', 305, NULL),
('Hotel deLuxe', 65, '2019-09-14', 165, NULL),
('Hotel deLuxe', 65, '2019-09-15', 272, NULL),
('Hotel deLuxe', 65, '2019-09-16', 239, NULL),
('Hotel deLuxe', 65, '2019-09-17', 113, NULL),
('Hotel deLuxe', 65, '2019-09-18', 176, NULL),
('Hotel deLuxe', 65, '2019-09-19', 265, NULL),
('Hotel deLuxe', 65, '2019-09-20', 143, NULL),
('Hotel deLuxe', 65, '2019-09-21', 287, NULL),
('Hotel deLuxe', 65, '2019-09-22', 309, NULL),
('Hotel deLuxe', 65, '2019-09-23', 240, NULL),
('Hotel deLuxe', 65, '2019-09-24', 221, NULL),
('Hotel deLuxe', 65, '2019-09-25', 140, NULL),
('Hotel deLuxe', 65, '2019-09-26', 299, NULL),
('Hotel deLuxe', 65, '2019-09-27', 198, NULL),
('Hotel deLuxe', 65, '2019-09-28', 210, NULL),
('Hotel deLuxe', 65, '2019-09-29', 151, NULL),
('Hotel deLuxe', 65, '2019-09-30', 270, NULL),
('Hotel deLuxe', 65, '2019-10-01', 137, NULL),
('Hotel deLuxe', 65, '2019-10-02', 291, NULL),
('Hotel deLuxe', 65, '2019-10-03', 254, NULL),
('Hotel deLuxe', 65, '2019-10-04', 315, NULL),
('Hotel deLuxe', 65, '2019-10-05', 287, NULL),
('Hotel deLuxe', 65, '2019-10-06', 390, NULL),
('Hotel deLuxe', 65, '2019-10-07', 348, NULL),
('Hotel deLuxe', 65, '2019-10-08', 191, NULL),
('Hotel deLuxe', 65, '2019-10-09', 119, NULL),
('Hotel deLuxe', 65, '2019-10-10', 116, NULL),
('Hotel deLuxe', 65, '2019-10-11', 268, NULL),
('Hotel deLuxe', 65, '2019-10-12', 317, NULL),
('Hotel deLuxe', 65, '2019-10-13', 357, NULL),
('Hotel deLuxe', 65, '2019-10-14', 218, NULL),
('Hotel deLuxe', 65, '2019-10-15', 134, NULL),
('Hotel deLuxe', 65, '2019-10-16', 370, NULL),
('Hotel deLuxe', 65, '2019-10-17', 387, NULL),
('Hotel deLuxe', 65, '2019-10-18', 359, NULL),
('Hotel deLuxe', 65, '2019-10-19', 117, NULL),
('Hotel deLuxe', 65, '2019-10-20', 323, NULL),
('Hotel deLuxe', 65, '2019-10-21', 241, NULL),
('Hotel deLuxe', 65, '2019-10-22', 100, NULL),
('Hotel deLuxe', 65, '2019-10-23', 244, NULL),
('Hotel deLuxe', 65, '2019-10-24', 156, NULL),
('Hotel deLuxe', 65, '2019-10-25', 182, NULL),
('Hotel deLuxe', 65, '2019-10-26', 156, NULL),
('Hotel deLuxe', 65, '2019-10-27', 254, NULL),
('Hotel deLuxe', 65, '2019-10-28', 281, NULL),
('Hotel deLuxe', 65, '2019-10-29', 287, NULL),
('Hotel deLuxe', 65, '2019-10-30', 260, NULL),
('Hotel deLuxe', 65, '2019-10-31', 354, NULL),
('Hotel deLuxe', 65, '2019-11-01', 280, NULL),
('Hotel deLuxe', 65, '2019-11-02', 333, NULL),
('Hotel deLuxe', 65, '2019-11-03', 246, NULL),
('Hotel deLuxe', 65, '2019-11-04', 155, NULL),
('Hotel deLuxe', 65, '2019-11-05', 345, NULL),
('Hotel deLuxe', 65, '2019-11-06', 202, NULL),
('Hotel deLuxe', 65, '2019-11-07', 379, NULL),
('Hotel deLuxe', 65, '2019-11-08', 179, NULL),
('Hotel deLuxe', 65, '2019-11-09', 124, NULL),
('Hotel deLuxe', 65, '2019-11-10', 129, NULL),
('Hotel deLuxe', 65, '2019-11-11', 253, NULL),
('Hotel deLuxe', 65, '2019-11-12', 324, NULL),
('Hotel deLuxe', 65, '2019-11-13', 316, NULL),
('Hotel deLuxe', 65, '2019-11-14', 204, NULL),
('Hotel deLuxe', 65, '2019-11-15', 247, NULL),
('Hotel deLuxe', 65, '2019-11-16', 298, NULL),
('Hotel deLuxe', 65, '2019-11-17', 262, NULL),
('Hotel deLuxe', 65, '2019-11-18', 352, NULL),
('Hotel deLuxe', 65, '2019-11-19', 352, NULL),
('Hotel deLuxe', 65, '2019-11-20', 123, NULL),
('Hotel deLuxe', 65, '2019-11-21', 399, NULL),
('Hotel deLuxe', 65, '2019-11-22', 259, NULL),
('Hotel deLuxe', 65, '2019-11-23', 197, NULL),
('Hotel deLuxe', 65, '2019-11-24', 238, NULL),
('Hotel deLuxe', 65, '2019-11-25', 225, NULL),
('Hotel deLuxe', 65, '2019-11-26', 307, NULL),
('Hotel deLuxe', 65, '2019-11-27', 169, NULL),
('Hotel deLuxe', 65, '2019-11-28', 151, NULL),
('Hotel deLuxe', 65, '2019-11-29', 277, NULL),
('Hotel deLuxe', 65, '2019-11-30', 118, NULL),
('Hotel deLuxe', 65, '2019-12-01', 165, NULL),
('Hotel deLuxe', 65, '2019-12-02', 203, NULL),
('Hotel deLuxe', 65, '2019-12-03', 393, NULL),
('Hotel deLuxe', 65, '2019-12-04', 164, NULL),
('Hotel deLuxe', 65, '2019-12-05', 186, NULL),
('Hotel deLuxe', 65, '2019-12-06', 324, NULL),
('Hotel deLuxe', 65, '2019-12-07', 393, NULL),
('Hotel deLuxe', 65, '2019-12-08', 192, NULL),
('Hotel deLuxe', 65, '2019-12-09', 122, NULL),
('Hotel deLuxe', 65, '2019-12-10', 312, NULL),
('Hotel deLuxe', 65, '2019-12-11', 357, NULL),
('Hotel deLuxe', 65, '2019-12-12', 115, NULL),
('Hotel deLuxe', 65, '2019-12-13', 259, NULL),
('Hotel deLuxe', 65, '2019-12-14', 351, NULL),
('Hotel deLuxe', 65, '2019-12-15', 150, NULL),
('Hotel deLuxe', 65, '2019-12-16', 148, NULL),
('Hotel deLuxe', 65, '2019-12-17', 324, NULL),
('Hotel deLuxe', 65, '2019-12-18', 133, NULL),
('Hotel deLuxe', 65, '2019-12-19', 317, NULL),
('Hotel deLuxe', 65, '2019-12-20', 199, NULL),
('Hotel deLuxe', 65, '2019-12-21', 233, NULL),
('Hotel deLuxe', 65, '2019-12-22', 350, NULL),
('Hotel deLuxe', 65, '2019-12-23', 382, NULL),
('Hotel deLuxe', 65, '2019-12-24', 117, NULL),
('Hotel deLuxe', 65, '2019-12-25', 195, NULL),
('Hotel deLuxe', 65, '2019-12-26', 238, NULL),
('Hotel deLuxe', 65, '2019-12-27', 237, NULL),
('Hotel deLuxe', 65, '2019-12-28', 318, NULL),
('Hotel deLuxe', 65, '2019-12-29', 358, NULL),
('Hotel deLuxe', 65, '2019-12-30', 195, NULL),
('Hotel deLuxe', 65, '2019-12-31', 354, NULL),
('Hotel deLuxe', 65, '2020-01-01', 276, NULL),
('Hotel deLuxe', 65, '2020-01-02', 135, NULL),
('Hotel deLuxe', 65, '2020-01-03', 264, NULL),
('Hotel deLuxe', 65, '2020-01-04', 292, NULL),
('Hotel deLuxe', 65, '2020-01-05', 384, NULL),
('Hotel deLuxe', 65, '2020-01-06', 148, NULL),
('Hotel deLuxe', 65, '2020-01-07', 105, NULL),
('Hotel deLuxe', 65, '2020-01-08', 236, NULL),
('Hotel deLuxe', 65, '2020-01-09', 279, NULL),
('Hotel deLuxe', 65, '2020-01-10', 174, NULL),
('Hotel deLuxe', 65, '2020-01-11', 271, NULL),
('Hotel deLuxe', 65, '2020-01-12', 183, NULL),
('Hotel deLuxe', 65, '2020-01-13', 181, NULL),
('Hotel deLuxe', 65, '2020-01-14', 167, NULL),
('Hotel deLuxe', 65, '2020-01-15', 144, NULL),
('Hotel deLuxe', 65, '2020-01-16', 245, NULL),
('Hotel deLuxe', 65, '2020-01-17', 347, NULL),
('Hotel deLuxe', 65, '2020-01-18', 289, NULL),
('Hotel deLuxe', 65, '2020-01-19', 316, NULL),
('Hotel deLuxe', 65, '2020-01-20', 191, NULL),
('Hotel deLuxe', 65, '2020-01-21', 225, NULL),
('Hotel deLuxe', 65, '2020-01-22', 314, NULL),
('Hotel deLuxe', 65, '2020-01-23', 102, NULL),
('Hotel deLuxe', 65, '2020-01-24', 118, NULL),
('Hotel deLuxe', 65, '2020-01-25', 302, NULL),
('Hotel deLuxe', 65, '2020-01-26', 233, NULL),
('Hotel deLuxe', 65, '2020-01-27', 153, NULL),
('Hotel deLuxe', 65, '2020-01-28', 321, NULL),
('Hotel deLuxe', 65, '2020-01-29', 217, NULL),
('Hotel deLuxe', 65, '2020-01-30', 233, NULL),
('Hotel deLuxe', 65, '2020-01-31', 176, NULL),
('Hotel deLuxe', 65, '2020-02-01', 266, NULL),
('Hotel deLuxe', 65, '2020-02-02', 383, NULL),
('Hotel deLuxe', 65, '2020-02-03', 168, NULL),
('Hotel deLuxe', 65, '2020-02-04', 254, NULL),
('Hotel deLuxe', 73, '2019-01-01', 295, NULL),
('Hotel deLuxe', 73, '2019-01-02', 329, NULL),
('Hotel deLuxe', 73, '2019-01-03', 167, NULL),
('Hotel deLuxe', 73, '2019-01-04', 149, NULL),
('Hotel deLuxe', 73, '2019-01-05', 394, NULL),
('Hotel deLuxe', 73, '2019-01-06', 314, NULL),
('Hotel deLuxe', 73, '2019-01-07', 395, NULL),
('Hotel deLuxe', 73, '2019-01-08', 200, NULL),
('Hotel deLuxe', 73, '2019-01-09', 217, NULL),
('Hotel deLuxe', 73, '2019-01-10', 258, NULL),
('Hotel deLuxe', 73, '2019-01-11', 300, NULL),
('Hotel deLuxe', 73, '2019-01-12', 274, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 73, '2019-01-13', 190, NULL),
('Hotel deLuxe', 73, '2019-01-14', 199, NULL),
('Hotel deLuxe', 73, '2019-01-15', 252, NULL),
('Hotel deLuxe', 73, '2019-01-16', 105, NULL),
('Hotel deLuxe', 73, '2019-01-17', 165, NULL),
('Hotel deLuxe', 73, '2019-01-18', 280, NULL),
('Hotel deLuxe', 73, '2019-01-19', 156, NULL),
('Hotel deLuxe', 73, '2019-01-20', 232, NULL),
('Hotel deLuxe', 73, '2019-01-21', 374, NULL),
('Hotel deLuxe', 73, '2019-01-22', 212, NULL),
('Hotel deLuxe', 73, '2019-01-23', 107, NULL),
('Hotel deLuxe', 73, '2019-01-24', 196, NULL),
('Hotel deLuxe', 73, '2019-01-25', 129, NULL),
('Hotel deLuxe', 73, '2019-01-26', 349, NULL),
('Hotel deLuxe', 73, '2019-01-27', 245, NULL),
('Hotel deLuxe', 73, '2019-01-28', 178, NULL),
('Hotel deLuxe', 73, '2019-01-29', 141, NULL),
('Hotel deLuxe', 73, '2019-01-30', 148, NULL),
('Hotel deLuxe', 73, '2019-01-31', 128, NULL),
('Hotel deLuxe', 73, '2019-02-01', 202, NULL),
('Hotel deLuxe', 73, '2019-02-02', 300, NULL),
('Hotel deLuxe', 73, '2019-02-03', 398, NULL),
('Hotel deLuxe', 73, '2019-02-04', 186, NULL),
('Hotel deLuxe', 73, '2019-02-05', 219, NULL),
('Hotel deLuxe', 73, '2019-02-06', 264, NULL),
('Hotel deLuxe', 73, '2019-02-07', 344, NULL),
('Hotel deLuxe', 73, '2019-02-08', 114, NULL),
('Hotel deLuxe', 73, '2019-02-09', 206, NULL),
('Hotel deLuxe', 73, '2019-02-10', 343, NULL),
('Hotel deLuxe', 73, '2019-02-11', 351, NULL),
('Hotel deLuxe', 73, '2019-02-12', 207, NULL),
('Hotel deLuxe', 73, '2019-02-13', 372, NULL),
('Hotel deLuxe', 73, '2019-02-14', 353, NULL),
('Hotel deLuxe', 73, '2019-02-15', 255, NULL),
('Hotel deLuxe', 73, '2019-02-16', 133, NULL),
('Hotel deLuxe', 73, '2019-02-17', 279, NULL),
('Hotel deLuxe', 73, '2019-02-18', 236, NULL),
('Hotel deLuxe', 73, '2019-02-19', 251, NULL),
('Hotel deLuxe', 73, '2019-02-20', 113, NULL),
('Hotel deLuxe', 73, '2019-02-21', 178, NULL),
('Hotel deLuxe', 73, '2019-02-22', 154, NULL),
('Hotel deLuxe', 73, '2019-02-23', 329, NULL),
('Hotel deLuxe', 73, '2019-02-24', 211, NULL),
('Hotel deLuxe', 73, '2019-02-25', 339, NULL),
('Hotel deLuxe', 73, '2019-02-26', 216, NULL),
('Hotel deLuxe', 73, '2019-02-27', 307, NULL),
('Hotel deLuxe', 73, '2019-02-28', 192, NULL),
('Hotel deLuxe', 73, '2019-03-01', 162, NULL),
('Hotel deLuxe', 73, '2019-03-02', 300, NULL),
('Hotel deLuxe', 73, '2019-03-03', 257, NULL),
('Hotel deLuxe', 73, '2019-03-04', 294, NULL),
('Hotel deLuxe', 73, '2019-03-05', 369, NULL),
('Hotel deLuxe', 73, '2019-03-06', 328, NULL),
('Hotel deLuxe', 73, '2019-03-07', 382, NULL),
('Hotel deLuxe', 73, '2019-03-08', 190, NULL),
('Hotel deLuxe', 73, '2019-03-09', 117, NULL),
('Hotel deLuxe', 73, '2019-03-10', 130, NULL),
('Hotel deLuxe', 73, '2019-03-11', 153, NULL),
('Hotel deLuxe', 73, '2019-03-12', 386, NULL),
('Hotel deLuxe', 73, '2019-03-13', 368, NULL),
('Hotel deLuxe', 73, '2019-03-14', 273, NULL),
('Hotel deLuxe', 73, '2019-03-15', 100, NULL),
('Hotel deLuxe', 73, '2019-03-16', 138, NULL),
('Hotel deLuxe', 73, '2019-03-17', 206, NULL),
('Hotel deLuxe', 73, '2019-03-18', 146, NULL),
('Hotel deLuxe', 73, '2019-03-19', 198, NULL),
('Hotel deLuxe', 73, '2019-03-20', 380, NULL),
('Hotel deLuxe', 73, '2019-03-21', 274, NULL),
('Hotel deLuxe', 73, '2019-03-22', 285, NULL),
('Hotel deLuxe', 73, '2019-03-23', 376, NULL),
('Hotel deLuxe', 73, '2019-03-24', 373, NULL),
('Hotel deLuxe', 73, '2019-03-25', 108, NULL),
('Hotel deLuxe', 73, '2019-03-26', 364, NULL),
('Hotel deLuxe', 73, '2019-03-27', 178, NULL),
('Hotel deLuxe', 73, '2019-03-28', 203, NULL),
('Hotel deLuxe', 73, '2019-03-29', 224, NULL),
('Hotel deLuxe', 73, '2019-03-30', 335, NULL),
('Hotel deLuxe', 73, '2019-03-31', 254, NULL),
('Hotel deLuxe', 73, '2019-04-01', 116, NULL),
('Hotel deLuxe', 73, '2019-04-02', 287, NULL),
('Hotel deLuxe', 73, '2019-04-03', 300, NULL),
('Hotel deLuxe', 73, '2019-04-04', 393, NULL),
('Hotel deLuxe', 73, '2019-04-05', 192, NULL),
('Hotel deLuxe', 73, '2019-04-06', 181, NULL),
('Hotel deLuxe', 73, '2019-04-07', 327, NULL),
('Hotel deLuxe', 73, '2019-04-08', 388, NULL),
('Hotel deLuxe', 73, '2019-04-09', 254, NULL),
('Hotel deLuxe', 73, '2019-04-10', 383, NULL),
('Hotel deLuxe', 73, '2019-04-11', 340, NULL),
('Hotel deLuxe', 73, '2019-04-12', 291, NULL),
('Hotel deLuxe', 73, '2019-04-13', 235, NULL),
('Hotel deLuxe', 73, '2019-04-14', 221, NULL),
('Hotel deLuxe', 73, '2019-04-15', 196, NULL),
('Hotel deLuxe', 73, '2019-04-16', 353, NULL),
('Hotel deLuxe', 73, '2019-04-17', 120, NULL),
('Hotel deLuxe', 73, '2019-04-18', 299, NULL),
('Hotel deLuxe', 73, '2019-04-19', 235, NULL),
('Hotel deLuxe', 73, '2019-04-20', 357, NULL),
('Hotel deLuxe', 73, '2019-04-21', 399, NULL),
('Hotel deLuxe', 73, '2019-04-22', 153, NULL),
('Hotel deLuxe', 73, '2019-04-23', 240, NULL),
('Hotel deLuxe', 73, '2019-04-24', 186, NULL),
('Hotel deLuxe', 73, '2019-04-25', 160, NULL),
('Hotel deLuxe', 73, '2019-04-26', 358, NULL),
('Hotel deLuxe', 73, '2019-04-27', 180, NULL),
('Hotel deLuxe', 73, '2019-04-28', 268, NULL),
('Hotel deLuxe', 73, '2019-04-29', 136, NULL),
('Hotel deLuxe', 73, '2019-04-30', 367, NULL),
('Hotel deLuxe', 73, '2019-05-01', 399, NULL),
('Hotel deLuxe', 73, '2019-05-02', 167, NULL),
('Hotel deLuxe', 73, '2019-05-03', 295, NULL),
('Hotel deLuxe', 73, '2019-05-04', 101, NULL),
('Hotel deLuxe', 73, '2019-05-05', 160, NULL),
('Hotel deLuxe', 73, '2019-05-06', 253, NULL),
('Hotel deLuxe', 73, '2019-05-07', 296, NULL),
('Hotel deLuxe', 73, '2019-05-08', 133, NULL),
('Hotel deLuxe', 73, '2019-05-09', 358, NULL),
('Hotel deLuxe', 73, '2019-05-10', 202, NULL),
('Hotel deLuxe', 73, '2019-05-11', 368, NULL),
('Hotel deLuxe', 73, '2019-05-12', 266, NULL),
('Hotel deLuxe', 73, '2019-05-13', 359, NULL),
('Hotel deLuxe', 73, '2019-05-14', 243, NULL),
('Hotel deLuxe', 73, '2019-05-15', 139, NULL),
('Hotel deLuxe', 73, '2019-05-16', 215, NULL),
('Hotel deLuxe', 73, '2019-05-17', 346, NULL),
('Hotel deLuxe', 73, '2019-05-18', 274, NULL),
('Hotel deLuxe', 73, '2019-05-19', 381, NULL),
('Hotel deLuxe', 73, '2019-05-20', 282, NULL),
('Hotel deLuxe', 73, '2019-05-21', 244, NULL),
('Hotel deLuxe', 73, '2019-05-22', 172, NULL),
('Hotel deLuxe', 73, '2019-05-23', 107, NULL),
('Hotel deLuxe', 73, '2019-05-24', 352, NULL),
('Hotel deLuxe', 73, '2019-05-25', 120, NULL),
('Hotel deLuxe', 73, '2019-05-26', 159, NULL),
('Hotel deLuxe', 73, '2019-05-27', 218, NULL),
('Hotel deLuxe', 73, '2019-05-28', 252, NULL),
('Hotel deLuxe', 73, '2019-05-29', 303, NULL),
('Hotel deLuxe', 73, '2019-05-30', 291, NULL),
('Hotel deLuxe', 73, '2019-05-31', 143, NULL),
('Hotel deLuxe', 73, '2019-06-01', 249, NULL),
('Hotel deLuxe', 73, '2019-06-02', 276, NULL),
('Hotel deLuxe', 73, '2019-06-03', 161, NULL),
('Hotel deLuxe', 73, '2019-06-04', 108, NULL),
('Hotel deLuxe', 73, '2019-06-05', 167, NULL),
('Hotel deLuxe', 73, '2019-06-06', 374, NULL),
('Hotel deLuxe', 73, '2019-06-07', 166, NULL),
('Hotel deLuxe', 73, '2019-06-08', 392, NULL),
('Hotel deLuxe', 73, '2019-06-09', 303, NULL),
('Hotel deLuxe', 73, '2019-06-10', 335, NULL),
('Hotel deLuxe', 73, '2019-06-11', 356, NULL),
('Hotel deLuxe', 73, '2019-06-12', 369, NULL),
('Hotel deLuxe', 73, '2019-06-13', 325, NULL),
('Hotel deLuxe', 73, '2019-06-14', 255, NULL),
('Hotel deLuxe', 73, '2019-06-15', 102, NULL),
('Hotel deLuxe', 73, '2019-06-16', 281, NULL),
('Hotel deLuxe', 73, '2019-06-17', 293, NULL),
('Hotel deLuxe', 73, '2019-06-18', 356, NULL),
('Hotel deLuxe', 73, '2019-06-19', 263, NULL),
('Hotel deLuxe', 73, '2019-06-20', 226, NULL),
('Hotel deLuxe', 73, '2019-06-21', 164, NULL),
('Hotel deLuxe', 73, '2019-06-22', 154, NULL),
('Hotel deLuxe', 73, '2019-06-23', 210, NULL),
('Hotel deLuxe', 73, '2019-06-24', 282, NULL),
('Hotel deLuxe', 73, '2019-06-25', 285, NULL),
('Hotel deLuxe', 73, '2019-06-26', 269, NULL),
('Hotel deLuxe', 73, '2019-06-27', 115, NULL),
('Hotel deLuxe', 73, '2019-06-28', 213, NULL),
('Hotel deLuxe', 73, '2019-06-29', 195, NULL),
('Hotel deLuxe', 73, '2019-06-30', 133, NULL),
('Hotel deLuxe', 73, '2019-07-01', 327, NULL),
('Hotel deLuxe', 73, '2019-07-02', 395, NULL),
('Hotel deLuxe', 73, '2019-07-03', 343, NULL),
('Hotel deLuxe', 73, '2019-07-04', 182, NULL),
('Hotel deLuxe', 73, '2019-07-05', 388, NULL),
('Hotel deLuxe', 73, '2019-07-06', 125, NULL),
('Hotel deLuxe', 73, '2019-07-07', 176, NULL),
('Hotel deLuxe', 73, '2019-07-08', 333, NULL),
('Hotel deLuxe', 73, '2019-07-09', 384, NULL),
('Hotel deLuxe', 73, '2019-07-10', 259, NULL),
('Hotel deLuxe', 73, '2019-07-11', 316, NULL),
('Hotel deLuxe', 73, '2019-07-12', 112, NULL),
('Hotel deLuxe', 73, '2019-07-13', 146, NULL),
('Hotel deLuxe', 73, '2019-07-14', 286, NULL),
('Hotel deLuxe', 73, '2019-07-15', 164, NULL),
('Hotel deLuxe', 73, '2019-07-16', 351, NULL),
('Hotel deLuxe', 73, '2019-07-17', 152, NULL),
('Hotel deLuxe', 73, '2019-07-18', 118, NULL),
('Hotel deLuxe', 73, '2019-07-19', 178, NULL),
('Hotel deLuxe', 73, '2019-07-20', 117, NULL),
('Hotel deLuxe', 73, '2019-07-21', 345, NULL),
('Hotel deLuxe', 73, '2019-07-22', 277, NULL),
('Hotel deLuxe', 73, '2019-07-23', 227, NULL),
('Hotel deLuxe', 73, '2019-07-24', 215, NULL),
('Hotel deLuxe', 73, '2019-07-25', 158, NULL),
('Hotel deLuxe', 73, '2019-07-26', 389, NULL),
('Hotel deLuxe', 73, '2019-07-27', 129, NULL),
('Hotel deLuxe', 73, '2019-07-28', 371, NULL),
('Hotel deLuxe', 73, '2019-07-29', 235, NULL),
('Hotel deLuxe', 73, '2019-07-30', 247, NULL),
('Hotel deLuxe', 73, '2019-07-31', 210, NULL),
('Hotel deLuxe', 73, '2019-08-01', 185, NULL),
('Hotel deLuxe', 73, '2019-08-02', 110, NULL),
('Hotel deLuxe', 73, '2019-08-03', 338, NULL),
('Hotel deLuxe', 73, '2019-08-04', 257, NULL),
('Hotel deLuxe', 73, '2019-08-05', 292, NULL),
('Hotel deLuxe', 73, '2019-08-06', 122, NULL),
('Hotel deLuxe', 73, '2019-08-07', 295, NULL),
('Hotel deLuxe', 73, '2019-08-08', 145, NULL),
('Hotel deLuxe', 73, '2019-08-09', 365, NULL),
('Hotel deLuxe', 73, '2019-08-10', 281, NULL),
('Hotel deLuxe', 73, '2019-08-11', 366, NULL),
('Hotel deLuxe', 73, '2019-08-12', 118, NULL),
('Hotel deLuxe', 73, '2019-08-13', 109, NULL),
('Hotel deLuxe', 73, '2019-08-14', 201, NULL),
('Hotel deLuxe', 73, '2019-08-15', 227, NULL),
('Hotel deLuxe', 73, '2019-08-16', 172, NULL),
('Hotel deLuxe', 73, '2019-08-17', 222, NULL),
('Hotel deLuxe', 73, '2019-08-18', 307, NULL),
('Hotel deLuxe', 73, '2019-08-19', 284, NULL),
('Hotel deLuxe', 73, '2019-08-20', 125, NULL),
('Hotel deLuxe', 73, '2019-08-21', 176, NULL),
('Hotel deLuxe', 73, '2019-08-22', 324, NULL),
('Hotel deLuxe', 73, '2019-08-23', 185, NULL),
('Hotel deLuxe', 73, '2019-08-24', 226, NULL),
('Hotel deLuxe', 73, '2019-08-25', 336, NULL),
('Hotel deLuxe', 73, '2019-08-26', 338, NULL),
('Hotel deLuxe', 73, '2019-08-27', 192, NULL),
('Hotel deLuxe', 73, '2019-08-28', 281, NULL),
('Hotel deLuxe', 73, '2019-08-29', 129, NULL),
('Hotel deLuxe', 73, '2019-08-30', 300, NULL),
('Hotel deLuxe', 73, '2019-08-31', 316, NULL),
('Hotel deLuxe', 73, '2019-09-01', 126, NULL),
('Hotel deLuxe', 73, '2019-09-02', 391, NULL),
('Hotel deLuxe', 73, '2019-09-03', 327, NULL),
('Hotel deLuxe', 73, '2019-09-04', 206, NULL),
('Hotel deLuxe', 73, '2019-09-05', 370, NULL),
('Hotel deLuxe', 73, '2019-09-06', 109, NULL),
('Hotel deLuxe', 73, '2019-09-07', 196, NULL),
('Hotel deLuxe', 73, '2019-09-08', 357, NULL),
('Hotel deLuxe', 73, '2019-09-09', 241, NULL),
('Hotel deLuxe', 73, '2019-09-10', 279, NULL),
('Hotel deLuxe', 73, '2019-09-11', 228, NULL),
('Hotel deLuxe', 73, '2019-09-12', 296, NULL),
('Hotel deLuxe', 73, '2019-09-13', 334, NULL),
('Hotel deLuxe', 73, '2019-09-14', 292, NULL),
('Hotel deLuxe', 73, '2019-09-15', 154, NULL),
('Hotel deLuxe', 73, '2019-09-16', 193, NULL),
('Hotel deLuxe', 73, '2019-09-17', 260, NULL),
('Hotel deLuxe', 73, '2019-09-18', 342, NULL),
('Hotel deLuxe', 73, '2019-09-19', 304, NULL),
('Hotel deLuxe', 73, '2019-09-20', 262, NULL),
('Hotel deLuxe', 73, '2019-09-21', 375, NULL),
('Hotel deLuxe', 73, '2019-09-22', 332, NULL),
('Hotel deLuxe', 73, '2019-09-23', 356, NULL),
('Hotel deLuxe', 73, '2019-09-24', 218, NULL),
('Hotel deLuxe', 73, '2019-09-25', 287, NULL),
('Hotel deLuxe', 73, '2019-09-26', 183, NULL),
('Hotel deLuxe', 73, '2019-09-27', 263, NULL),
('Hotel deLuxe', 73, '2019-09-28', 118, NULL),
('Hotel deLuxe', 73, '2019-09-29', 384, NULL),
('Hotel deLuxe', 73, '2019-09-30', 276, NULL),
('Hotel deLuxe', 73, '2019-10-01', 381, NULL),
('Hotel deLuxe', 73, '2019-10-02', 325, NULL),
('Hotel deLuxe', 73, '2019-10-03', 261, NULL),
('Hotel deLuxe', 73, '2019-10-04', 153, NULL),
('Hotel deLuxe', 73, '2019-10-05', 350, NULL),
('Hotel deLuxe', 73, '2019-10-06', 292, NULL),
('Hotel deLuxe', 73, '2019-10-07', 253, NULL),
('Hotel deLuxe', 73, '2019-10-08', 242, NULL),
('Hotel deLuxe', 73, '2019-10-09', 230, NULL),
('Hotel deLuxe', 73, '2019-10-10', 334, NULL),
('Hotel deLuxe', 73, '2019-10-11', 195, NULL),
('Hotel deLuxe', 73, '2019-10-12', 148, NULL),
('Hotel deLuxe', 73, '2019-10-13', 104, NULL),
('Hotel deLuxe', 73, '2019-10-14', 247, NULL),
('Hotel deLuxe', 73, '2019-10-15', 236, NULL),
('Hotel deLuxe', 73, '2019-10-16', 317, NULL),
('Hotel deLuxe', 73, '2019-10-17', 107, NULL),
('Hotel deLuxe', 73, '2019-10-18', 387, NULL),
('Hotel deLuxe', 73, '2019-10-19', 371, NULL),
('Hotel deLuxe', 73, '2019-10-20', 345, NULL),
('Hotel deLuxe', 73, '2019-10-21', 280, NULL),
('Hotel deLuxe', 73, '2019-10-22', 322, NULL),
('Hotel deLuxe', 73, '2019-10-23', 155, NULL),
('Hotel deLuxe', 73, '2019-10-24', 358, NULL),
('Hotel deLuxe', 73, '2019-10-25', 394, NULL),
('Hotel deLuxe', 73, '2019-10-26', 389, NULL),
('Hotel deLuxe', 73, '2019-10-27', 311, NULL),
('Hotel deLuxe', 73, '2019-10-28', 149, NULL),
('Hotel deLuxe', 73, '2019-10-29', 312, NULL),
('Hotel deLuxe', 73, '2019-10-30', 227, NULL),
('Hotel deLuxe', 73, '2019-10-31', 359, NULL),
('Hotel deLuxe', 73, '2019-11-01', 314, NULL),
('Hotel deLuxe', 73, '2019-11-02', 282, NULL),
('Hotel deLuxe', 73, '2019-11-03', 365, NULL),
('Hotel deLuxe', 73, '2019-11-04', 164, NULL),
('Hotel deLuxe', 73, '2019-11-05', 265, NULL),
('Hotel deLuxe', 73, '2019-11-06', 192, NULL),
('Hotel deLuxe', 73, '2019-11-07', 110, NULL),
('Hotel deLuxe', 73, '2019-11-08', 355, NULL),
('Hotel deLuxe', 73, '2019-11-09', 125, NULL),
('Hotel deLuxe', 73, '2019-11-10', 120, NULL),
('Hotel deLuxe', 73, '2019-11-11', 222, NULL),
('Hotel deLuxe', 73, '2019-11-12', 117, NULL),
('Hotel deLuxe', 73, '2019-11-13', 110, NULL),
('Hotel deLuxe', 73, '2019-11-14', 253, NULL),
('Hotel deLuxe', 73, '2019-11-15', 325, NULL),
('Hotel deLuxe', 73, '2019-11-16', 287, NULL),
('Hotel deLuxe', 73, '2019-11-17', 379, NULL),
('Hotel deLuxe', 73, '2019-11-18', 313, NULL),
('Hotel deLuxe', 73, '2019-11-19', 247, NULL),
('Hotel deLuxe', 73, '2019-11-20', 246, NULL),
('Hotel deLuxe', 73, '2019-11-21', 169, NULL),
('Hotel deLuxe', 73, '2019-11-22', 386, NULL),
('Hotel deLuxe', 73, '2019-11-23', 157, NULL),
('Hotel deLuxe', 73, '2019-11-24', 329, NULL),
('Hotel deLuxe', 73, '2019-11-25', 103, NULL),
('Hotel deLuxe', 73, '2019-11-26', 164, NULL),
('Hotel deLuxe', 73, '2019-11-27', 249, NULL),
('Hotel deLuxe', 73, '2019-11-28', 301, NULL),
('Hotel deLuxe', 73, '2019-11-29', 349, NULL),
('Hotel deLuxe', 73, '2019-11-30', 182, NULL),
('Hotel deLuxe', 73, '2019-12-01', 188, NULL),
('Hotel deLuxe', 73, '2019-12-02', 118, NULL),
('Hotel deLuxe', 73, '2019-12-03', 271, NULL),
('Hotel deLuxe', 73, '2019-12-04', 240, NULL),
('Hotel deLuxe', 73, '2019-12-05', 255, NULL),
('Hotel deLuxe', 73, '2019-12-06', 124, NULL),
('Hotel deLuxe', 73, '2019-12-07', 224, NULL),
('Hotel deLuxe', 73, '2019-12-08', 351, NULL),
('Hotel deLuxe', 73, '2019-12-09', 313, NULL),
('Hotel deLuxe', 73, '2019-12-10', 187, NULL),
('Hotel deLuxe', 73, '2019-12-11', 274, NULL),
('Hotel deLuxe', 73, '2019-12-12', 295, NULL),
('Hotel deLuxe', 73, '2019-12-13', 308, NULL),
('Hotel deLuxe', 73, '2019-12-14', 365, NULL),
('Hotel deLuxe', 73, '2019-12-15', 274, NULL),
('Hotel deLuxe', 73, '2019-12-16', 361, NULL),
('Hotel deLuxe', 73, '2019-12-17', 380, NULL),
('Hotel deLuxe', 73, '2019-12-18', 358, NULL),
('Hotel deLuxe', 73, '2019-12-19', 114, NULL),
('Hotel deLuxe', 73, '2019-12-20', 264, NULL),
('Hotel deLuxe', 73, '2019-12-21', 249, NULL),
('Hotel deLuxe', 73, '2019-12-22', 205, NULL),
('Hotel deLuxe', 73, '2019-12-23', 122, NULL),
('Hotel deLuxe', 73, '2019-12-24', 277, NULL),
('Hotel deLuxe', 73, '2019-12-25', 155, NULL),
('Hotel deLuxe', 73, '2019-12-26', 284, NULL),
('Hotel deLuxe', 73, '2019-12-27', 200, NULL),
('Hotel deLuxe', 73, '2019-12-28', 125, NULL),
('Hotel deLuxe', 73, '2019-12-29', 348, NULL),
('Hotel deLuxe', 73, '2019-12-30', 238, NULL),
('Hotel deLuxe', 73, '2019-12-31', 370, NULL),
('Hotel deLuxe', 73, '2020-01-01', 259, NULL),
('Hotel deLuxe', 73, '2020-01-02', 300, NULL),
('Hotel deLuxe', 73, '2020-01-03', 299, NULL),
('Hotel deLuxe', 73, '2020-01-04', 249, NULL),
('Hotel deLuxe', 73, '2020-01-05', 319, NULL),
('Hotel deLuxe', 73, '2020-01-06', 298, NULL),
('Hotel deLuxe', 73, '2020-01-07', 349, NULL),
('Hotel deLuxe', 73, '2020-01-08', 308, NULL),
('Hotel deLuxe', 73, '2020-01-09', 111, NULL),
('Hotel deLuxe', 73, '2020-01-10', 330, NULL),
('Hotel deLuxe', 73, '2020-01-11', 392, NULL),
('Hotel deLuxe', 73, '2020-01-12', 333, NULL),
('Hotel deLuxe', 73, '2020-01-13', 360, NULL),
('Hotel deLuxe', 73, '2020-01-14', 335, NULL),
('Hotel deLuxe', 73, '2020-01-15', 143, NULL),
('Hotel deLuxe', 73, '2020-01-16', 348, NULL),
('Hotel deLuxe', 73, '2020-01-17', 299, NULL),
('Hotel deLuxe', 73, '2020-01-18', 255, NULL),
('Hotel deLuxe', 73, '2020-01-19', 141, NULL),
('Hotel deLuxe', 73, '2020-01-20', 328, NULL),
('Hotel deLuxe', 73, '2020-01-21', 231, NULL),
('Hotel deLuxe', 73, '2020-01-22', 149, NULL),
('Hotel deLuxe', 73, '2020-01-23', 267, NULL),
('Hotel deLuxe', 73, '2020-01-24', 251, NULL),
('Hotel deLuxe', 73, '2020-01-25', 190, NULL),
('Hotel deLuxe', 73, '2020-01-26', 330, NULL),
('Hotel deLuxe', 73, '2020-01-27', 215, NULL),
('Hotel deLuxe', 73, '2020-01-28', 389, NULL),
('Hotel deLuxe', 73, '2020-01-29', 314, NULL),
('Hotel deLuxe', 73, '2020-01-30', 347, NULL),
('Hotel deLuxe', 73, '2020-01-31', 229, NULL),
('Hotel deLuxe', 73, '2020-02-01', 294, NULL),
('Hotel deLuxe', 73, '2020-02-02', 394, NULL),
('Hotel deLuxe', 73, '2020-02-03', 162, NULL),
('Hotel deLuxe', 73, '2020-02-04', 383, NULL),
('Hotel deLuxe', 83, '2019-01-01', 172, NULL),
('Hotel deLuxe', 83, '2019-01-02', 325, NULL),
('Hotel deLuxe', 83, '2019-01-03', 151, NULL),
('Hotel deLuxe', 83, '2019-01-04', 189, NULL),
('Hotel deLuxe', 83, '2019-01-05', 305, NULL),
('Hotel deLuxe', 83, '2019-01-06', 173, NULL),
('Hotel deLuxe', 83, '2019-01-07', 328, NULL),
('Hotel deLuxe', 83, '2019-01-08', 363, NULL),
('Hotel deLuxe', 83, '2019-01-09', 399, NULL),
('Hotel deLuxe', 83, '2019-01-10', 262, NULL),
('Hotel deLuxe', 83, '2019-01-11', 100, NULL),
('Hotel deLuxe', 83, '2019-01-12', 104, NULL),
('Hotel deLuxe', 83, '2019-01-13', 123, NULL),
('Hotel deLuxe', 83, '2019-01-14', 234, NULL),
('Hotel deLuxe', 83, '2019-01-15', 301, NULL),
('Hotel deLuxe', 83, '2019-01-16', 340, NULL),
('Hotel deLuxe', 83, '2019-01-17', 393, NULL),
('Hotel deLuxe', 83, '2019-01-18', 166, NULL),
('Hotel deLuxe', 83, '2019-01-19', 268, NULL),
('Hotel deLuxe', 83, '2019-01-20', 357, NULL),
('Hotel deLuxe', 83, '2019-01-21', 293, NULL),
('Hotel deLuxe', 83, '2019-01-22', 243, NULL),
('Hotel deLuxe', 83, '2019-01-23', 268, NULL),
('Hotel deLuxe', 83, '2019-01-24', 273, NULL),
('Hotel deLuxe', 83, '2019-01-25', 333, NULL),
('Hotel deLuxe', 83, '2019-01-26', 394, NULL),
('Hotel deLuxe', 83, '2019-01-27', 365, NULL),
('Hotel deLuxe', 83, '2019-01-28', 171, NULL),
('Hotel deLuxe', 83, '2019-01-29', 369, NULL),
('Hotel deLuxe', 83, '2019-01-30', 282, NULL),
('Hotel deLuxe', 83, '2019-01-31', 242, NULL),
('Hotel deLuxe', 83, '2019-02-01', 102, NULL),
('Hotel deLuxe', 83, '2019-02-02', 330, NULL),
('Hotel deLuxe', 83, '2019-02-03', 210, NULL),
('Hotel deLuxe', 83, '2019-02-04', 104, NULL),
('Hotel deLuxe', 83, '2019-02-05', 197, NULL),
('Hotel deLuxe', 83, '2019-02-06', 339, NULL),
('Hotel deLuxe', 83, '2019-02-07', 123, NULL),
('Hotel deLuxe', 83, '2019-02-08', 138, NULL),
('Hotel deLuxe', 83, '2019-02-09', 286, NULL),
('Hotel deLuxe', 83, '2019-02-10', 212, NULL),
('Hotel deLuxe', 83, '2019-02-11', 283, NULL),
('Hotel deLuxe', 83, '2019-02-12', 308, NULL),
('Hotel deLuxe', 83, '2019-02-13', 201, NULL),
('Hotel deLuxe', 83, '2019-02-14', 272, NULL),
('Hotel deLuxe', 83, '2019-02-15', 119, NULL),
('Hotel deLuxe', 83, '2019-02-16', 230, NULL),
('Hotel deLuxe', 83, '2019-02-17', 340, NULL),
('Hotel deLuxe', 83, '2019-02-18', 228, NULL),
('Hotel deLuxe', 83, '2019-02-19', 250, NULL),
('Hotel deLuxe', 83, '2019-02-20', 286, NULL),
('Hotel deLuxe', 83, '2019-02-21', 220, NULL),
('Hotel deLuxe', 83, '2019-02-22', 323, NULL),
('Hotel deLuxe', 83, '2019-02-23', 346, NULL),
('Hotel deLuxe', 83, '2019-02-24', 146, NULL),
('Hotel deLuxe', 83, '2019-02-25', 276, NULL),
('Hotel deLuxe', 83, '2019-02-26', 269, NULL),
('Hotel deLuxe', 83, '2019-02-27', 219, NULL),
('Hotel deLuxe', 83, '2019-02-28', 291, NULL),
('Hotel deLuxe', 83, '2019-03-01', 113, NULL),
('Hotel deLuxe', 83, '2019-03-02', 229, NULL),
('Hotel deLuxe', 83, '2019-03-03', 249, NULL),
('Hotel deLuxe', 83, '2019-03-04', 280, NULL),
('Hotel deLuxe', 83, '2019-03-05', 219, NULL),
('Hotel deLuxe', 83, '2019-03-06', 298, NULL),
('Hotel deLuxe', 83, '2019-03-07', 289, NULL),
('Hotel deLuxe', 83, '2019-03-08', 161, NULL),
('Hotel deLuxe', 83, '2019-03-09', 285, NULL),
('Hotel deLuxe', 83, '2019-03-10', 212, NULL),
('Hotel deLuxe', 83, '2019-03-11', 305, NULL),
('Hotel deLuxe', 83, '2019-03-12', 234, NULL),
('Hotel deLuxe', 83, '2019-03-13', 397, NULL),
('Hotel deLuxe', 83, '2019-03-14', 353, NULL),
('Hotel deLuxe', 83, '2019-03-15', 183, NULL),
('Hotel deLuxe', 83, '2019-03-16', 105, NULL),
('Hotel deLuxe', 83, '2019-03-17', 200, NULL),
('Hotel deLuxe', 83, '2019-03-18', 182, NULL),
('Hotel deLuxe', 83, '2019-03-19', 321, NULL),
('Hotel deLuxe', 83, '2019-03-20', 364, NULL),
('Hotel deLuxe', 83, '2019-03-21', 221, NULL),
('Hotel deLuxe', 83, '2019-03-22', 235, NULL),
('Hotel deLuxe', 83, '2019-03-23', 220, NULL),
('Hotel deLuxe', 83, '2019-03-24', 378, NULL),
('Hotel deLuxe', 83, '2019-03-25', 396, NULL),
('Hotel deLuxe', 83, '2019-03-26', 396, NULL),
('Hotel deLuxe', 83, '2019-03-27', 183, NULL),
('Hotel deLuxe', 83, '2019-03-28', 279, NULL),
('Hotel deLuxe', 83, '2019-03-29', 265, NULL),
('Hotel deLuxe', 83, '2019-03-30', 251, NULL),
('Hotel deLuxe', 83, '2019-03-31', 234, NULL),
('Hotel deLuxe', 83, '2019-04-01', 244, NULL),
('Hotel deLuxe', 83, '2019-04-02', 137, NULL),
('Hotel deLuxe', 83, '2019-04-03', 139, NULL),
('Hotel deLuxe', 83, '2019-04-04', 188, NULL),
('Hotel deLuxe', 83, '2019-04-05', 208, NULL),
('Hotel deLuxe', 83, '2019-04-06', 179, NULL),
('Hotel deLuxe', 83, '2019-04-07', 119, NULL),
('Hotel deLuxe', 83, '2019-04-08', 175, NULL),
('Hotel deLuxe', 83, '2019-04-09', 313, NULL),
('Hotel deLuxe', 83, '2019-04-10', 395, NULL),
('Hotel deLuxe', 83, '2019-04-11', 310, NULL),
('Hotel deLuxe', 83, '2019-04-12', 225, NULL),
('Hotel deLuxe', 83, '2019-04-13', 255, NULL),
('Hotel deLuxe', 83, '2019-04-14', 243, NULL),
('Hotel deLuxe', 83, '2019-04-15', 390, NULL),
('Hotel deLuxe', 83, '2019-04-16', 352, NULL),
('Hotel deLuxe', 83, '2019-04-17', 130, NULL),
('Hotel deLuxe', 83, '2019-04-18', 170, NULL),
('Hotel deLuxe', 83, '2019-04-19', 119, NULL),
('Hotel deLuxe', 83, '2019-04-20', 113, NULL),
('Hotel deLuxe', 83, '2019-04-21', 144, NULL),
('Hotel deLuxe', 83, '2019-04-22', 126, NULL),
('Hotel deLuxe', 83, '2019-04-23', 367, NULL),
('Hotel deLuxe', 83, '2019-04-24', 120, NULL),
('Hotel deLuxe', 83, '2019-04-25', 153, NULL),
('Hotel deLuxe', 83, '2019-04-26', 232, NULL),
('Hotel deLuxe', 83, '2019-04-27', 200, NULL),
('Hotel deLuxe', 83, '2019-04-28', 354, NULL),
('Hotel deLuxe', 83, '2019-04-29', 170, NULL),
('Hotel deLuxe', 83, '2019-04-30', 286, NULL),
('Hotel deLuxe', 83, '2019-05-01', 376, NULL),
('Hotel deLuxe', 83, '2019-05-02', 165, NULL),
('Hotel deLuxe', 83, '2019-05-03', 192, NULL),
('Hotel deLuxe', 83, '2019-05-04', 329, NULL),
('Hotel deLuxe', 83, '2019-05-05', 154, NULL),
('Hotel deLuxe', 83, '2019-05-06', 110, NULL),
('Hotel deLuxe', 83, '2019-05-07', 343, NULL),
('Hotel deLuxe', 83, '2019-05-08', 353, NULL),
('Hotel deLuxe', 83, '2019-05-09', 147, NULL),
('Hotel deLuxe', 83, '2019-05-10', 338, NULL),
('Hotel deLuxe', 83, '2019-05-11', 387, NULL),
('Hotel deLuxe', 83, '2019-05-12', 346, NULL),
('Hotel deLuxe', 83, '2019-05-13', 311, NULL),
('Hotel deLuxe', 83, '2019-05-14', 313, NULL),
('Hotel deLuxe', 83, '2019-05-15', 338, NULL),
('Hotel deLuxe', 83, '2019-05-16', 214, NULL),
('Hotel deLuxe', 83, '2019-05-17', 164, NULL),
('Hotel deLuxe', 83, '2019-05-18', 231, NULL),
('Hotel deLuxe', 83, '2019-05-19', 153, NULL),
('Hotel deLuxe', 83, '2019-05-20', 243, NULL),
('Hotel deLuxe', 83, '2019-05-21', 265, NULL),
('Hotel deLuxe', 83, '2019-05-22', 111, NULL),
('Hotel deLuxe', 83, '2019-05-23', 345, NULL),
('Hotel deLuxe', 83, '2019-05-24', 314, NULL),
('Hotel deLuxe', 83, '2019-05-25', 310, NULL),
('Hotel deLuxe', 83, '2019-05-26', 244, NULL),
('Hotel deLuxe', 83, '2019-05-27', 202, NULL),
('Hotel deLuxe', 83, '2019-05-28', 206, NULL),
('Hotel deLuxe', 83, '2019-05-29', 328, NULL),
('Hotel deLuxe', 83, '2019-05-30', 379, NULL),
('Hotel deLuxe', 83, '2019-05-31', 174, NULL),
('Hotel deLuxe', 83, '2019-06-01', 211, NULL),
('Hotel deLuxe', 83, '2019-06-02', 281, NULL),
('Hotel deLuxe', 83, '2019-06-03', 383, NULL),
('Hotel deLuxe', 83, '2019-06-04', 124, NULL),
('Hotel deLuxe', 83, '2019-06-05', 383, NULL),
('Hotel deLuxe', 83, '2019-06-06', 138, NULL),
('Hotel deLuxe', 83, '2019-06-07', 263, NULL),
('Hotel deLuxe', 83, '2019-06-08', 141, NULL),
('Hotel deLuxe', 83, '2019-06-09', 147, NULL),
('Hotel deLuxe', 83, '2019-06-10', 244, NULL),
('Hotel deLuxe', 83, '2019-06-11', 136, NULL),
('Hotel deLuxe', 83, '2019-06-12', 115, NULL),
('Hotel deLuxe', 83, '2019-06-13', 129, NULL),
('Hotel deLuxe', 83, '2019-06-14', 313, NULL),
('Hotel deLuxe', 83, '2019-06-15', 298, NULL),
('Hotel deLuxe', 83, '2019-06-16', 317, NULL),
('Hotel deLuxe', 83, '2019-06-17', 150, NULL),
('Hotel deLuxe', 83, '2019-06-18', 395, NULL),
('Hotel deLuxe', 83, '2019-06-19', 295, NULL),
('Hotel deLuxe', 83, '2019-06-20', 186, NULL),
('Hotel deLuxe', 83, '2019-06-21', 222, NULL),
('Hotel deLuxe', 83, '2019-06-22', 170, NULL),
('Hotel deLuxe', 83, '2019-06-23', 214, NULL),
('Hotel deLuxe', 83, '2019-06-24', 182, NULL),
('Hotel deLuxe', 83, '2019-06-25', 162, NULL),
('Hotel deLuxe', 83, '2019-06-26', 380, NULL),
('Hotel deLuxe', 83, '2019-06-27', 333, NULL),
('Hotel deLuxe', 83, '2019-06-28', 351, NULL),
('Hotel deLuxe', 83, '2019-06-29', 320, NULL),
('Hotel deLuxe', 83, '2019-06-30', 270, NULL),
('Hotel deLuxe', 83, '2019-07-01', 285, NULL),
('Hotel deLuxe', 83, '2019-07-02', 230, NULL),
('Hotel deLuxe', 83, '2019-07-03', 226, NULL),
('Hotel deLuxe', 83, '2019-07-04', 115, NULL),
('Hotel deLuxe', 83, '2019-07-05', 314, NULL),
('Hotel deLuxe', 83, '2019-07-06', 395, NULL),
('Hotel deLuxe', 83, '2019-07-07', 283, NULL),
('Hotel deLuxe', 83, '2019-07-08', 353, NULL),
('Hotel deLuxe', 83, '2019-07-09', 350, NULL),
('Hotel deLuxe', 83, '2019-07-10', 369, NULL),
('Hotel deLuxe', 83, '2019-07-11', 380, NULL),
('Hotel deLuxe', 83, '2019-07-12', 356, NULL),
('Hotel deLuxe', 83, '2019-07-13', 217, NULL),
('Hotel deLuxe', 83, '2019-07-14', 219, NULL),
('Hotel deLuxe', 83, '2019-07-15', 174, NULL),
('Hotel deLuxe', 83, '2019-07-16', 227, NULL),
('Hotel deLuxe', 83, '2019-07-17', 145, NULL),
('Hotel deLuxe', 83, '2019-07-18', 103, NULL),
('Hotel deLuxe', 83, '2019-07-19', 180, NULL),
('Hotel deLuxe', 83, '2019-07-20', 143, NULL),
('Hotel deLuxe', 83, '2019-07-21', 290, NULL),
('Hotel deLuxe', 83, '2019-07-22', 188, NULL),
('Hotel deLuxe', 83, '2019-07-23', 340, NULL),
('Hotel deLuxe', 83, '2019-07-24', 377, NULL),
('Hotel deLuxe', 83, '2019-07-25', 235, NULL),
('Hotel deLuxe', 83, '2019-07-26', 205, NULL),
('Hotel deLuxe', 83, '2019-07-27', 267, NULL),
('Hotel deLuxe', 83, '2019-07-28', 387, NULL),
('Hotel deLuxe', 83, '2019-07-29', 101, NULL),
('Hotel deLuxe', 83, '2019-07-30', 230, NULL),
('Hotel deLuxe', 83, '2019-07-31', 126, NULL),
('Hotel deLuxe', 83, '2019-08-01', 117, NULL),
('Hotel deLuxe', 83, '2019-08-02', 377, NULL),
('Hotel deLuxe', 83, '2019-08-03', 176, NULL),
('Hotel deLuxe', 83, '2019-08-04', 269, NULL),
('Hotel deLuxe', 83, '2019-08-05', 378, NULL),
('Hotel deLuxe', 83, '2019-08-06', 109, NULL),
('Hotel deLuxe', 83, '2019-08-07', 250, NULL),
('Hotel deLuxe', 83, '2019-08-08', 243, NULL),
('Hotel deLuxe', 83, '2019-08-09', 202, NULL),
('Hotel deLuxe', 83, '2019-08-10', 115, NULL),
('Hotel deLuxe', 83, '2019-08-11', 171, NULL),
('Hotel deLuxe', 83, '2019-08-12', 108, NULL),
('Hotel deLuxe', 83, '2019-08-13', 221, NULL),
('Hotel deLuxe', 83, '2019-08-14', 378, NULL),
('Hotel deLuxe', 83, '2019-08-15', 212, NULL),
('Hotel deLuxe', 83, '2019-08-16', 267, NULL),
('Hotel deLuxe', 83, '2019-08-17', 157, NULL),
('Hotel deLuxe', 83, '2019-08-18', 317, NULL),
('Hotel deLuxe', 83, '2019-08-19', 262, NULL),
('Hotel deLuxe', 83, '2019-08-20', 273, NULL),
('Hotel deLuxe', 83, '2019-08-21', 171, NULL),
('Hotel deLuxe', 83, '2019-08-22', 385, NULL),
('Hotel deLuxe', 83, '2019-08-23', 386, NULL),
('Hotel deLuxe', 83, '2019-08-24', 236, NULL),
('Hotel deLuxe', 83, '2019-08-25', 234, NULL),
('Hotel deLuxe', 83, '2019-08-26', 290, NULL),
('Hotel deLuxe', 83, '2019-08-27', 323, NULL),
('Hotel deLuxe', 83, '2019-08-28', 294, NULL),
('Hotel deLuxe', 83, '2019-08-29', 340, NULL),
('Hotel deLuxe', 83, '2019-08-30', 284, NULL),
('Hotel deLuxe', 83, '2019-08-31', 311, NULL),
('Hotel deLuxe', 83, '2019-09-01', 118, NULL),
('Hotel deLuxe', 83, '2019-09-02', 232, NULL),
('Hotel deLuxe', 83, '2019-09-03', 353, NULL),
('Hotel deLuxe', 83, '2019-09-04', 133, NULL),
('Hotel deLuxe', 83, '2019-09-05', 273, NULL),
('Hotel deLuxe', 83, '2019-09-06', 395, NULL),
('Hotel deLuxe', 83, '2019-09-07', 134, NULL),
('Hotel deLuxe', 83, '2019-09-08', 293, NULL),
('Hotel deLuxe', 83, '2019-09-09', 349, NULL),
('Hotel deLuxe', 83, '2019-09-10', 383, NULL),
('Hotel deLuxe', 83, '2019-09-11', 223, NULL),
('Hotel deLuxe', 83, '2019-09-12', 345, NULL),
('Hotel deLuxe', 83, '2019-09-13', 352, NULL),
('Hotel deLuxe', 83, '2019-09-14', 265, NULL),
('Hotel deLuxe', 83, '2019-09-15', 157, NULL),
('Hotel deLuxe', 83, '2019-09-16', 150, NULL),
('Hotel deLuxe', 83, '2019-09-17', 262, NULL),
('Hotel deLuxe', 83, '2019-09-18', 183, NULL),
('Hotel deLuxe', 83, '2019-09-19', 324, NULL),
('Hotel deLuxe', 83, '2019-09-20', 181, NULL),
('Hotel deLuxe', 83, '2019-09-21', 315, NULL),
('Hotel deLuxe', 83, '2019-09-22', 336, NULL),
('Hotel deLuxe', 83, '2019-09-23', 359, NULL),
('Hotel deLuxe', 83, '2019-09-24', 327, NULL),
('Hotel deLuxe', 83, '2019-09-25', 316, NULL),
('Hotel deLuxe', 83, '2019-09-26', 217, NULL),
('Hotel deLuxe', 83, '2019-09-27', 319, NULL),
('Hotel deLuxe', 83, '2019-09-28', 162, NULL),
('Hotel deLuxe', 83, '2019-09-29', 169, NULL),
('Hotel deLuxe', 83, '2019-09-30', 171, NULL),
('Hotel deLuxe', 83, '2019-10-01', 196, NULL),
('Hotel deLuxe', 83, '2019-10-02', 354, NULL),
('Hotel deLuxe', 83, '2019-10-03', 144, NULL),
('Hotel deLuxe', 83, '2019-10-04', 320, NULL),
('Hotel deLuxe', 83, '2019-10-05', 188, NULL),
('Hotel deLuxe', 83, '2019-10-06', 192, NULL),
('Hotel deLuxe', 83, '2019-10-07', 118, NULL),
('Hotel deLuxe', 83, '2019-10-08', 240, NULL),
('Hotel deLuxe', 83, '2019-10-09', 394, NULL),
('Hotel deLuxe', 83, '2019-10-10', 321, NULL),
('Hotel deLuxe', 83, '2019-10-11', 372, NULL),
('Hotel deLuxe', 83, '2019-10-12', 290, NULL),
('Hotel deLuxe', 83, '2019-10-13', 251, NULL),
('Hotel deLuxe', 83, '2019-10-14', 182, NULL),
('Hotel deLuxe', 83, '2019-10-15', 378, NULL),
('Hotel deLuxe', 83, '2019-10-16', 375, NULL),
('Hotel deLuxe', 83, '2019-10-17', 172, NULL),
('Hotel deLuxe', 83, '2019-10-18', 161, NULL),
('Hotel deLuxe', 83, '2019-10-19', 202, NULL),
('Hotel deLuxe', 83, '2019-10-20', 355, NULL),
('Hotel deLuxe', 83, '2019-10-21', 277, NULL),
('Hotel deLuxe', 83, '2019-10-22', 310, NULL),
('Hotel deLuxe', 83, '2019-10-23', 243, NULL),
('Hotel deLuxe', 83, '2019-10-24', 324, NULL),
('Hotel deLuxe', 83, '2019-10-25', 124, NULL),
('Hotel deLuxe', 83, '2019-10-26', 176, NULL),
('Hotel deLuxe', 83, '2019-10-27', 392, NULL),
('Hotel deLuxe', 83, '2019-10-28', 105, NULL),
('Hotel deLuxe', 83, '2019-10-29', 301, NULL),
('Hotel deLuxe', 83, '2019-10-30', 256, NULL),
('Hotel deLuxe', 83, '2019-10-31', 337, NULL),
('Hotel deLuxe', 83, '2019-11-01', 327, NULL),
('Hotel deLuxe', 83, '2019-11-02', 311, NULL),
('Hotel deLuxe', 83, '2019-11-03', 389, NULL),
('Hotel deLuxe', 83, '2019-11-04', 254, NULL),
('Hotel deLuxe', 83, '2019-11-05', 188, NULL),
('Hotel deLuxe', 83, '2019-11-06', 254, NULL),
('Hotel deLuxe', 83, '2019-11-07', 214, NULL),
('Hotel deLuxe', 83, '2019-11-08', 236, NULL),
('Hotel deLuxe', 83, '2019-11-09', 150, NULL),
('Hotel deLuxe', 83, '2019-11-10', 114, NULL),
('Hotel deLuxe', 83, '2019-11-11', 255, NULL),
('Hotel deLuxe', 83, '2019-11-12', 112, NULL),
('Hotel deLuxe', 83, '2019-11-13', 103, NULL),
('Hotel deLuxe', 83, '2019-11-14', 256, NULL),
('Hotel deLuxe', 83, '2019-11-15', 185, NULL),
('Hotel deLuxe', 83, '2019-11-16', 144, NULL),
('Hotel deLuxe', 83, '2019-11-17', 110, NULL),
('Hotel deLuxe', 83, '2019-11-18', 108, NULL),
('Hotel deLuxe', 83, '2019-11-19', 377, NULL),
('Hotel deLuxe', 83, '2019-11-20', 161, NULL),
('Hotel deLuxe', 83, '2019-11-21', 151, NULL),
('Hotel deLuxe', 83, '2019-11-22', 156, NULL),
('Hotel deLuxe', 83, '2019-11-23', 394, NULL),
('Hotel deLuxe', 83, '2019-11-24', 233, NULL),
('Hotel deLuxe', 83, '2019-11-25', 344, NULL),
('Hotel deLuxe', 83, '2019-11-26', 399, NULL),
('Hotel deLuxe', 83, '2019-11-27', 339, NULL),
('Hotel deLuxe', 83, '2019-11-28', 352, NULL),
('Hotel deLuxe', 83, '2019-11-29', 218, NULL),
('Hotel deLuxe', 83, '2019-11-30', 155, NULL),
('Hotel deLuxe', 83, '2019-12-01', 347, NULL),
('Hotel deLuxe', 83, '2019-12-02', 182, NULL),
('Hotel deLuxe', 83, '2019-12-03', 378, NULL),
('Hotel deLuxe', 83, '2019-12-04', 308, NULL),
('Hotel deLuxe', 83, '2019-12-05', 317, NULL),
('Hotel deLuxe', 83, '2019-12-06', 150, NULL),
('Hotel deLuxe', 83, '2019-12-07', 143, NULL),
('Hotel deLuxe', 83, '2019-12-08', 180, NULL),
('Hotel deLuxe', 83, '2019-12-09', 198, NULL),
('Hotel deLuxe', 83, '2019-12-10', 197, NULL),
('Hotel deLuxe', 83, '2019-12-11', 199, NULL),
('Hotel deLuxe', 83, '2019-12-12', 134, NULL),
('Hotel deLuxe', 83, '2019-12-13', 364, NULL),
('Hotel deLuxe', 83, '2019-12-14', 376, NULL),
('Hotel deLuxe', 83, '2019-12-15', 218, NULL),
('Hotel deLuxe', 83, '2019-12-16', 362, NULL),
('Hotel deLuxe', 83, '2019-12-17', 229, NULL),
('Hotel deLuxe', 83, '2019-12-18', 394, NULL),
('Hotel deLuxe', 83, '2019-12-19', 121, NULL),
('Hotel deLuxe', 83, '2019-12-20', 327, NULL),
('Hotel deLuxe', 83, '2019-12-21', 145, NULL),
('Hotel deLuxe', 83, '2019-12-22', 177, NULL),
('Hotel deLuxe', 83, '2019-12-23', 267, NULL),
('Hotel deLuxe', 83, '2019-12-24', 335, NULL),
('Hotel deLuxe', 83, '2019-12-25', 390, NULL),
('Hotel deLuxe', 83, '2019-12-26', 305, NULL),
('Hotel deLuxe', 83, '2019-12-27', 190, NULL),
('Hotel deLuxe', 83, '2019-12-28', 169, NULL),
('Hotel deLuxe', 83, '2019-12-29', 263, NULL),
('Hotel deLuxe', 83, '2019-12-30', 206, NULL),
('Hotel deLuxe', 83, '2019-12-31', 388, NULL),
('Hotel deLuxe', 83, '2020-01-01', 368, NULL),
('Hotel deLuxe', 83, '2020-01-02', 394, NULL),
('Hotel deLuxe', 83, '2020-01-03', 300, NULL),
('Hotel deLuxe', 83, '2020-01-04', 268, NULL),
('Hotel deLuxe', 83, '2020-01-05', 345, NULL),
('Hotel deLuxe', 83, '2020-01-06', 348, NULL),
('Hotel deLuxe', 83, '2020-01-07', 128, NULL),
('Hotel deLuxe', 83, '2020-01-08', 131, NULL),
('Hotel deLuxe', 83, '2020-01-09', 217, NULL),
('Hotel deLuxe', 83, '2020-01-10', 126, NULL),
('Hotel deLuxe', 83, '2020-01-11', 147, NULL),
('Hotel deLuxe', 83, '2020-01-12', 118, NULL),
('Hotel deLuxe', 83, '2020-01-13', 260, NULL),
('Hotel deLuxe', 83, '2020-01-14', 173, NULL),
('Hotel deLuxe', 83, '2020-01-15', 183, NULL),
('Hotel deLuxe', 83, '2020-01-16', 307, NULL),
('Hotel deLuxe', 83, '2020-01-17', 357, NULL),
('Hotel deLuxe', 83, '2020-01-18', 310, NULL),
('Hotel deLuxe', 83, '2020-01-19', 260, NULL),
('Hotel deLuxe', 83, '2020-01-20', 368, NULL),
('Hotel deLuxe', 83, '2020-01-21', 382, NULL),
('Hotel deLuxe', 83, '2020-01-22', 301, NULL),
('Hotel deLuxe', 83, '2020-01-23', 327, NULL),
('Hotel deLuxe', 83, '2020-01-24', 202, NULL),
('Hotel deLuxe', 83, '2020-01-25', 244, NULL),
('Hotel deLuxe', 83, '2020-01-26', 250, NULL),
('Hotel deLuxe', 83, '2020-01-27', 217, NULL),
('Hotel deLuxe', 83, '2020-01-28', 282, NULL),
('Hotel deLuxe', 83, '2020-01-29', 218, NULL),
('Hotel deLuxe', 83, '2020-01-30', 334, NULL),
('Hotel deLuxe', 83, '2020-01-31', 214, NULL),
('Hotel deLuxe', 83, '2020-02-01', 272, NULL),
('Hotel deLuxe', 83, '2020-02-02', 119, NULL),
('Hotel deLuxe', 83, '2020-02-03', 204, NULL),
('Hotel deLuxe', 83, '2020-02-04', 154, NULL),
('Hotel deLuxe', 88, '2019-01-01', 175, NULL),
('Hotel deLuxe', 88, '2019-01-02', 239, NULL),
('Hotel deLuxe', 88, '2019-01-03', 155, NULL),
('Hotel deLuxe', 88, '2019-01-04', 396, NULL),
('Hotel deLuxe', 88, '2019-01-05', 240, NULL),
('Hotel deLuxe', 88, '2019-01-06', 126, NULL),
('Hotel deLuxe', 88, '2019-01-07', 354, NULL),
('Hotel deLuxe', 88, '2019-01-08', 218, NULL),
('Hotel deLuxe', 88, '2019-01-09', 343, NULL),
('Hotel deLuxe', 88, '2019-01-10', 136, NULL),
('Hotel deLuxe', 88, '2019-01-11', 101, NULL),
('Hotel deLuxe', 88, '2019-01-12', 198, NULL),
('Hotel deLuxe', 88, '2019-01-13', 247, NULL),
('Hotel deLuxe', 88, '2019-01-14', 175, NULL),
('Hotel deLuxe', 88, '2019-01-15', 348, NULL),
('Hotel deLuxe', 88, '2019-01-16', 383, NULL),
('Hotel deLuxe', 88, '2019-01-17', 173, NULL),
('Hotel deLuxe', 88, '2019-01-18', 193, NULL),
('Hotel deLuxe', 88, '2019-01-19', 175, NULL),
('Hotel deLuxe', 88, '2019-01-20', 387, NULL),
('Hotel deLuxe', 88, '2019-01-21', 244, NULL),
('Hotel deLuxe', 88, '2019-01-22', 177, NULL),
('Hotel deLuxe', 88, '2019-01-23', 321, NULL),
('Hotel deLuxe', 88, '2019-01-24', 377, NULL),
('Hotel deLuxe', 88, '2019-01-25', 279, NULL),
('Hotel deLuxe', 88, '2019-01-26', 221, NULL),
('Hotel deLuxe', 88, '2019-01-27', 390, NULL),
('Hotel deLuxe', 88, '2019-01-28', 222, NULL),
('Hotel deLuxe', 88, '2019-01-29', 124, NULL),
('Hotel deLuxe', 88, '2019-01-30', 267, NULL),
('Hotel deLuxe', 88, '2019-01-31', 128, NULL),
('Hotel deLuxe', 88, '2019-02-01', 102, NULL),
('Hotel deLuxe', 88, '2019-02-02', 349, NULL),
('Hotel deLuxe', 88, '2019-02-03', 354, NULL),
('Hotel deLuxe', 88, '2019-02-04', 162, NULL),
('Hotel deLuxe', 88, '2019-02-05', 230, NULL),
('Hotel deLuxe', 88, '2019-02-06', 205, NULL),
('Hotel deLuxe', 88, '2019-02-07', 384, NULL),
('Hotel deLuxe', 88, '2019-02-08', 246, NULL),
('Hotel deLuxe', 88, '2019-02-09', 112, NULL),
('Hotel deLuxe', 88, '2019-02-10', 232, NULL),
('Hotel deLuxe', 88, '2019-02-11', 265, NULL),
('Hotel deLuxe', 88, '2019-02-12', 219, NULL),
('Hotel deLuxe', 88, '2019-02-13', 389, NULL),
('Hotel deLuxe', 88, '2019-02-14', 200, NULL),
('Hotel deLuxe', 88, '2019-02-15', 331, NULL),
('Hotel deLuxe', 88, '2019-02-16', 351, NULL),
('Hotel deLuxe', 88, '2019-02-17', 164, NULL),
('Hotel deLuxe', 88, '2019-02-18', 334, NULL),
('Hotel deLuxe', 88, '2019-02-19', 398, NULL),
('Hotel deLuxe', 88, '2019-02-20', 394, NULL),
('Hotel deLuxe', 88, '2019-02-21', 167, NULL),
('Hotel deLuxe', 88, '2019-02-22', 154, NULL),
('Hotel deLuxe', 88, '2019-02-23', 342, NULL),
('Hotel deLuxe', 88, '2019-02-24', 300, NULL),
('Hotel deLuxe', 88, '2019-02-25', 263, NULL),
('Hotel deLuxe', 88, '2019-02-26', 299, NULL),
('Hotel deLuxe', 88, '2019-02-27', 378, NULL),
('Hotel deLuxe', 88, '2019-02-28', 181, NULL),
('Hotel deLuxe', 88, '2019-03-01', 282, NULL),
('Hotel deLuxe', 88, '2019-03-02', 144, NULL),
('Hotel deLuxe', 88, '2019-03-03', 374, NULL),
('Hotel deLuxe', 88, '2019-03-04', 118, NULL),
('Hotel deLuxe', 88, '2019-03-05', 189, NULL),
('Hotel deLuxe', 88, '2019-03-06', 110, NULL),
('Hotel deLuxe', 88, '2019-03-07', 201, NULL),
('Hotel deLuxe', 88, '2019-03-08', 139, NULL),
('Hotel deLuxe', 88, '2019-03-09', 374, NULL),
('Hotel deLuxe', 88, '2019-03-10', 270, NULL),
('Hotel deLuxe', 88, '2019-03-11', 363, NULL),
('Hotel deLuxe', 88, '2019-03-12', 216, NULL),
('Hotel deLuxe', 88, '2019-03-13', 178, NULL),
('Hotel deLuxe', 88, '2019-03-14', 248, NULL),
('Hotel deLuxe', 88, '2019-03-15', 214, NULL),
('Hotel deLuxe', 88, '2019-03-16', 310, NULL),
('Hotel deLuxe', 88, '2019-03-17', 280, NULL),
('Hotel deLuxe', 88, '2019-03-18', 371, NULL),
('Hotel deLuxe', 88, '2019-03-19', 314, NULL),
('Hotel deLuxe', 88, '2019-03-20', 280, NULL),
('Hotel deLuxe', 88, '2019-03-21', 184, NULL),
('Hotel deLuxe', 88, '2019-03-22', 220, NULL),
('Hotel deLuxe', 88, '2019-03-23', 173, NULL),
('Hotel deLuxe', 88, '2019-03-24', 373, NULL),
('Hotel deLuxe', 88, '2019-03-25', 357, NULL),
('Hotel deLuxe', 88, '2019-03-26', 192, NULL),
('Hotel deLuxe', 88, '2019-03-27', 281, NULL),
('Hotel deLuxe', 88, '2019-03-28', 388, NULL),
('Hotel deLuxe', 88, '2019-03-29', 252, NULL),
('Hotel deLuxe', 88, '2019-03-30', 151, NULL),
('Hotel deLuxe', 88, '2019-03-31', 312, NULL),
('Hotel deLuxe', 88, '2019-04-01', 175, NULL),
('Hotel deLuxe', 88, '2019-04-02', 324, NULL),
('Hotel deLuxe', 88, '2019-04-03', 299, NULL),
('Hotel deLuxe', 88, '2019-04-04', 263, NULL),
('Hotel deLuxe', 88, '2019-04-05', 365, NULL),
('Hotel deLuxe', 88, '2019-04-06', 252, NULL),
('Hotel deLuxe', 88, '2019-04-07', 115, NULL),
('Hotel deLuxe', 88, '2019-04-08', 210, NULL),
('Hotel deLuxe', 88, '2019-04-09', 102, NULL),
('Hotel deLuxe', 88, '2019-04-10', 126, NULL),
('Hotel deLuxe', 88, '2019-04-11', 130, NULL),
('Hotel deLuxe', 88, '2019-04-12', 153, NULL),
('Hotel deLuxe', 88, '2019-04-13', 170, NULL),
('Hotel deLuxe', 88, '2019-04-14', 152, NULL),
('Hotel deLuxe', 88, '2019-04-15', 363, NULL),
('Hotel deLuxe', 88, '2019-04-16', 301, NULL),
('Hotel deLuxe', 88, '2019-04-17', 192, NULL),
('Hotel deLuxe', 88, '2019-04-18', 156, NULL),
('Hotel deLuxe', 88, '2019-04-19', 391, NULL),
('Hotel deLuxe', 88, '2019-04-20', 294, NULL),
('Hotel deLuxe', 88, '2019-04-21', 321, NULL),
('Hotel deLuxe', 88, '2019-04-22', 368, NULL),
('Hotel deLuxe', 88, '2019-04-23', 115, NULL),
('Hotel deLuxe', 88, '2019-04-24', 241, NULL),
('Hotel deLuxe', 88, '2019-04-25', 187, NULL),
('Hotel deLuxe', 88, '2019-04-26', 285, NULL),
('Hotel deLuxe', 88, '2019-04-27', 358, NULL),
('Hotel deLuxe', 88, '2019-04-28', 267, NULL),
('Hotel deLuxe', 88, '2019-04-29', 344, NULL),
('Hotel deLuxe', 88, '2019-04-30', 231, NULL),
('Hotel deLuxe', 88, '2019-05-01', 283, NULL),
('Hotel deLuxe', 88, '2019-05-02', 226, NULL),
('Hotel deLuxe', 88, '2019-05-03', 274, NULL),
('Hotel deLuxe', 88, '2019-05-04', 343, NULL),
('Hotel deLuxe', 88, '2019-05-05', 193, NULL),
('Hotel deLuxe', 88, '2019-05-06', 289, NULL),
('Hotel deLuxe', 88, '2019-05-07', 129, NULL),
('Hotel deLuxe', 88, '2019-05-08', 366, NULL),
('Hotel deLuxe', 88, '2019-05-09', 163, NULL),
('Hotel deLuxe', 88, '2019-05-10', 381, NULL),
('Hotel deLuxe', 88, '2019-05-11', 130, NULL),
('Hotel deLuxe', 88, '2019-05-12', 231, NULL),
('Hotel deLuxe', 88, '2019-05-13', 381, NULL),
('Hotel deLuxe', 88, '2019-05-14', 136, NULL),
('Hotel deLuxe', 88, '2019-05-15', 276, NULL),
('Hotel deLuxe', 88, '2019-05-16', 327, NULL),
('Hotel deLuxe', 88, '2019-05-17', 279, NULL),
('Hotel deLuxe', 88, '2019-05-18', 235, NULL),
('Hotel deLuxe', 88, '2019-05-19', 123, NULL),
('Hotel deLuxe', 88, '2019-05-20', 266, NULL),
('Hotel deLuxe', 88, '2019-05-21', 197, NULL),
('Hotel deLuxe', 88, '2019-05-22', 239, NULL),
('Hotel deLuxe', 88, '2019-05-23', 108, NULL),
('Hotel deLuxe', 88, '2019-05-24', 117, NULL),
('Hotel deLuxe', 88, '2019-05-25', 189, NULL),
('Hotel deLuxe', 88, '2019-05-26', 347, NULL),
('Hotel deLuxe', 88, '2019-05-27', 256, NULL),
('Hotel deLuxe', 88, '2019-05-28', 172, NULL),
('Hotel deLuxe', 88, '2019-05-29', 334, NULL),
('Hotel deLuxe', 88, '2019-05-30', 320, NULL),
('Hotel deLuxe', 88, '2019-05-31', 343, NULL),
('Hotel deLuxe', 88, '2019-06-01', 209, NULL),
('Hotel deLuxe', 88, '2019-06-02', 176, NULL),
('Hotel deLuxe', 88, '2019-06-03', 134, NULL),
('Hotel deLuxe', 88, '2019-06-04', 194, NULL),
('Hotel deLuxe', 88, '2019-06-05', 114, NULL),
('Hotel deLuxe', 88, '2019-06-06', 366, NULL),
('Hotel deLuxe', 88, '2019-06-07', 119, NULL),
('Hotel deLuxe', 88, '2019-06-08', 330, NULL),
('Hotel deLuxe', 88, '2019-06-09', 324, NULL),
('Hotel deLuxe', 88, '2019-06-10', 118, NULL),
('Hotel deLuxe', 88, '2019-06-11', 110, NULL),
('Hotel deLuxe', 88, '2019-06-12', 270, NULL),
('Hotel deLuxe', 88, '2019-06-13', 170, NULL),
('Hotel deLuxe', 88, '2019-06-14', 398, NULL),
('Hotel deLuxe', 88, '2019-06-15', 184, NULL),
('Hotel deLuxe', 88, '2019-06-16', 341, NULL),
('Hotel deLuxe', 88, '2019-06-17', 371, NULL),
('Hotel deLuxe', 88, '2019-06-18', 208, NULL),
('Hotel deLuxe', 88, '2019-06-19', 286, NULL),
('Hotel deLuxe', 88, '2019-06-20', 152, NULL),
('Hotel deLuxe', 88, '2019-06-21', 219, NULL),
('Hotel deLuxe', 88, '2019-06-22', 285, NULL),
('Hotel deLuxe', 88, '2019-06-23', 339, NULL),
('Hotel deLuxe', 88, '2019-06-24', 267, NULL),
('Hotel deLuxe', 88, '2019-06-25', 157, NULL),
('Hotel deLuxe', 88, '2019-06-26', 391, NULL),
('Hotel deLuxe', 88, '2019-06-27', 319, NULL),
('Hotel deLuxe', 88, '2019-06-28', 119, NULL),
('Hotel deLuxe', 88, '2019-06-29', 317, NULL),
('Hotel deLuxe', 88, '2019-06-30', 251, NULL),
('Hotel deLuxe', 88, '2019-07-01', 346, NULL),
('Hotel deLuxe', 88, '2019-07-02', 165, NULL),
('Hotel deLuxe', 88, '2019-07-03', 302, NULL),
('Hotel deLuxe', 88, '2019-07-04', 229, NULL),
('Hotel deLuxe', 88, '2019-07-05', 308, NULL),
('Hotel deLuxe', 88, '2019-07-06', 298, NULL),
('Hotel deLuxe', 88, '2019-07-07', 186, NULL),
('Hotel deLuxe', 88, '2019-07-08', 364, NULL),
('Hotel deLuxe', 88, '2019-07-09', 198, NULL),
('Hotel deLuxe', 88, '2019-07-10', 368, NULL),
('Hotel deLuxe', 88, '2019-07-11', 254, NULL),
('Hotel deLuxe', 88, '2019-07-12', 144, NULL),
('Hotel deLuxe', 88, '2019-07-13', 246, NULL),
('Hotel deLuxe', 88, '2019-07-14', 137, NULL),
('Hotel deLuxe', 88, '2019-07-15', 280, NULL),
('Hotel deLuxe', 88, '2019-07-16', 282, NULL),
('Hotel deLuxe', 88, '2019-07-17', 167, NULL),
('Hotel deLuxe', 88, '2019-07-18', 359, NULL),
('Hotel deLuxe', 88, '2019-07-19', 267, NULL),
('Hotel deLuxe', 88, '2019-07-20', 266, NULL),
('Hotel deLuxe', 88, '2019-07-21', 317, NULL),
('Hotel deLuxe', 88, '2019-07-22', 311, NULL),
('Hotel deLuxe', 88, '2019-07-23', 321, NULL),
('Hotel deLuxe', 88, '2019-07-24', 241, NULL),
('Hotel deLuxe', 88, '2019-07-25', 301, NULL),
('Hotel deLuxe', 88, '2019-07-26', 356, NULL),
('Hotel deLuxe', 88, '2019-07-27', 248, NULL),
('Hotel deLuxe', 88, '2019-07-28', 122, NULL),
('Hotel deLuxe', 88, '2019-07-29', 304, NULL),
('Hotel deLuxe', 88, '2019-07-30', 309, NULL),
('Hotel deLuxe', 88, '2019-07-31', 199, NULL),
('Hotel deLuxe', 88, '2019-08-01', 230, NULL),
('Hotel deLuxe', 88, '2019-08-02', 258, NULL),
('Hotel deLuxe', 88, '2019-08-03', 365, NULL),
('Hotel deLuxe', 88, '2019-08-04', 176, NULL),
('Hotel deLuxe', 88, '2019-08-05', 312, NULL),
('Hotel deLuxe', 88, '2019-08-06', 379, NULL),
('Hotel deLuxe', 88, '2019-08-07', 266, NULL),
('Hotel deLuxe', 88, '2019-08-08', 381, NULL),
('Hotel deLuxe', 88, '2019-08-09', 115, NULL),
('Hotel deLuxe', 88, '2019-08-10', 231, NULL),
('Hotel deLuxe', 88, '2019-08-11', 260, NULL),
('Hotel deLuxe', 88, '2019-08-12', 387, NULL),
('Hotel deLuxe', 88, '2019-08-13', 377, NULL),
('Hotel deLuxe', 88, '2019-08-14', 285, NULL),
('Hotel deLuxe', 88, '2019-08-15', 279, NULL),
('Hotel deLuxe', 88, '2019-08-16', 120, NULL),
('Hotel deLuxe', 88, '2019-08-17', 319, NULL),
('Hotel deLuxe', 88, '2019-08-18', 264, NULL),
('Hotel deLuxe', 88, '2019-08-19', 358, NULL),
('Hotel deLuxe', 88, '2019-08-20', 289, NULL),
('Hotel deLuxe', 88, '2019-08-21', 227, NULL),
('Hotel deLuxe', 88, '2019-08-22', 253, NULL),
('Hotel deLuxe', 88, '2019-08-23', 374, NULL),
('Hotel deLuxe', 88, '2019-08-24', 102, NULL),
('Hotel deLuxe', 88, '2019-08-25', 362, NULL),
('Hotel deLuxe', 88, '2019-08-26', 334, NULL),
('Hotel deLuxe', 88, '2019-08-27', 340, NULL),
('Hotel deLuxe', 88, '2019-08-28', 226, NULL),
('Hotel deLuxe', 88, '2019-08-29', 315, NULL),
('Hotel deLuxe', 88, '2019-08-30', 120, NULL),
('Hotel deLuxe', 88, '2019-08-31', 210, NULL),
('Hotel deLuxe', 88, '2019-09-01', 112, NULL),
('Hotel deLuxe', 88, '2019-09-02', 187, NULL),
('Hotel deLuxe', 88, '2019-09-03', 385, NULL),
('Hotel deLuxe', 88, '2019-09-04', 250, NULL),
('Hotel deLuxe', 88, '2019-09-05', 155, NULL),
('Hotel deLuxe', 88, '2019-09-06', 350, NULL),
('Hotel deLuxe', 88, '2019-09-07', 282, NULL),
('Hotel deLuxe', 88, '2019-09-08', 292, NULL),
('Hotel deLuxe', 88, '2019-09-09', 322, NULL),
('Hotel deLuxe', 88, '2019-09-10', 379, NULL),
('Hotel deLuxe', 88, '2019-09-11', 333, NULL),
('Hotel deLuxe', 88, '2019-09-12', 139, NULL),
('Hotel deLuxe', 88, '2019-09-13', 362, NULL),
('Hotel deLuxe', 88, '2019-09-14', 352, NULL),
('Hotel deLuxe', 88, '2019-09-15', 223, NULL),
('Hotel deLuxe', 88, '2019-09-16', 373, NULL),
('Hotel deLuxe', 88, '2019-09-17', 128, NULL),
('Hotel deLuxe', 88, '2019-09-18', 390, NULL),
('Hotel deLuxe', 88, '2019-09-19', 311, NULL),
('Hotel deLuxe', 88, '2019-09-20', 319, NULL),
('Hotel deLuxe', 88, '2019-09-21', 349, NULL),
('Hotel deLuxe', 88, '2019-09-22', 285, NULL),
('Hotel deLuxe', 88, '2019-09-23', 326, NULL),
('Hotel deLuxe', 88, '2019-09-24', 282, NULL),
('Hotel deLuxe', 88, '2019-09-25', 318, NULL),
('Hotel deLuxe', 88, '2019-09-26', 136, NULL),
('Hotel deLuxe', 88, '2019-09-27', 110, NULL),
('Hotel deLuxe', 88, '2019-09-28', 356, NULL),
('Hotel deLuxe', 88, '2019-09-29', 190, NULL),
('Hotel deLuxe', 88, '2019-09-30', 227, NULL),
('Hotel deLuxe', 88, '2019-10-01', 337, NULL),
('Hotel deLuxe', 88, '2019-10-02', 394, NULL),
('Hotel deLuxe', 88, '2019-10-03', 137, NULL),
('Hotel deLuxe', 88, '2019-10-04', 144, NULL),
('Hotel deLuxe', 88, '2019-10-05', 389, NULL),
('Hotel deLuxe', 88, '2019-10-06', 284, NULL),
('Hotel deLuxe', 88, '2019-10-07', 334, NULL),
('Hotel deLuxe', 88, '2019-10-08', 375, NULL),
('Hotel deLuxe', 88, '2019-10-09', 280, NULL),
('Hotel deLuxe', 88, '2019-10-10', 202, NULL),
('Hotel deLuxe', 88, '2019-10-11', 273, NULL),
('Hotel deLuxe', 88, '2019-10-12', 307, NULL),
('Hotel deLuxe', 88, '2019-10-13', 242, NULL),
('Hotel deLuxe', 88, '2019-10-14', 367, NULL),
('Hotel deLuxe', 88, '2019-10-15', 185, NULL),
('Hotel deLuxe', 88, '2019-10-16', 224, NULL),
('Hotel deLuxe', 88, '2019-10-17', 141, NULL),
('Hotel deLuxe', 88, '2019-10-18', 146, NULL),
('Hotel deLuxe', 88, '2019-10-19', 100, NULL),
('Hotel deLuxe', 88, '2019-10-20', 339, NULL),
('Hotel deLuxe', 88, '2019-10-21', 146, NULL),
('Hotel deLuxe', 88, '2019-10-22', 185, NULL),
('Hotel deLuxe', 88, '2019-10-23', 349, NULL),
('Hotel deLuxe', 88, '2019-10-24', 146, NULL),
('Hotel deLuxe', 88, '2019-10-25', 240, NULL),
('Hotel deLuxe', 88, '2019-10-26', 212, NULL),
('Hotel deLuxe', 88, '2019-10-27', 327, NULL),
('Hotel deLuxe', 88, '2019-10-28', 279, NULL),
('Hotel deLuxe', 88, '2019-10-29', 167, NULL),
('Hotel deLuxe', 88, '2019-10-30', 200, NULL),
('Hotel deLuxe', 88, '2019-10-31', 207, NULL),
('Hotel deLuxe', 88, '2019-11-01', 296, NULL),
('Hotel deLuxe', 88, '2019-11-02', 312, NULL),
('Hotel deLuxe', 88, '2019-11-03', 151, NULL),
('Hotel deLuxe', 88, '2019-11-04', 378, NULL),
('Hotel deLuxe', 88, '2019-11-05', 345, NULL),
('Hotel deLuxe', 88, '2019-11-06', 296, NULL),
('Hotel deLuxe', 88, '2019-11-07', 341, NULL),
('Hotel deLuxe', 88, '2019-11-08', 318, NULL),
('Hotel deLuxe', 88, '2019-11-09', 279, NULL),
('Hotel deLuxe', 88, '2019-11-10', 110, NULL),
('Hotel deLuxe', 88, '2019-11-11', 207, NULL),
('Hotel deLuxe', 88, '2019-11-12', 112, NULL),
('Hotel deLuxe', 88, '2019-11-13', 386, NULL),
('Hotel deLuxe', 88, '2019-11-14', 120, NULL),
('Hotel deLuxe', 88, '2019-11-15', 148, NULL),
('Hotel deLuxe', 88, '2019-11-16', 357, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 88, '2019-11-17', 213, NULL),
('Hotel deLuxe', 88, '2019-11-18', 105, NULL),
('Hotel deLuxe', 88, '2019-11-19', 147, NULL),
('Hotel deLuxe', 88, '2019-11-20', 268, NULL),
('Hotel deLuxe', 88, '2019-11-21', 147, NULL),
('Hotel deLuxe', 88, '2019-11-22', 120, NULL),
('Hotel deLuxe', 88, '2019-11-23', 201, NULL),
('Hotel deLuxe', 88, '2019-11-24', 378, NULL),
('Hotel deLuxe', 88, '2019-11-25', 109, NULL),
('Hotel deLuxe', 88, '2019-11-26', 205, NULL),
('Hotel deLuxe', 88, '2019-11-27', 245, NULL),
('Hotel deLuxe', 88, '2019-11-28', 158, NULL),
('Hotel deLuxe', 88, '2019-11-29', 242, NULL),
('Hotel deLuxe', 88, '2019-11-30', 132, NULL),
('Hotel deLuxe', 88, '2019-12-01', 171, NULL),
('Hotel deLuxe', 88, '2019-12-02', 154, NULL),
('Hotel deLuxe', 88, '2019-12-03', 377, NULL),
('Hotel deLuxe', 88, '2019-12-04', 120, NULL),
('Hotel deLuxe', 88, '2019-12-05', 120, NULL),
('Hotel deLuxe', 88, '2019-12-06', 279, NULL),
('Hotel deLuxe', 88, '2019-12-07', 242, NULL),
('Hotel deLuxe', 88, '2019-12-08', 348, NULL),
('Hotel deLuxe', 88, '2019-12-09', 254, NULL),
('Hotel deLuxe', 88, '2019-12-10', 325, NULL),
('Hotel deLuxe', 88, '2019-12-11', 375, NULL),
('Hotel deLuxe', 88, '2019-12-12', 283, NULL),
('Hotel deLuxe', 88, '2019-12-13', 196, NULL),
('Hotel deLuxe', 88, '2019-12-14', 383, NULL),
('Hotel deLuxe', 88, '2019-12-15', 168, NULL),
('Hotel deLuxe', 88, '2019-12-16', 328, NULL),
('Hotel deLuxe', 88, '2019-12-17', 205, NULL),
('Hotel deLuxe', 88, '2019-12-18', 195, NULL),
('Hotel deLuxe', 88, '2019-12-19', 164, NULL),
('Hotel deLuxe', 88, '2019-12-20', 142, NULL),
('Hotel deLuxe', 88, '2019-12-21', 179, NULL),
('Hotel deLuxe', 88, '2019-12-22', 168, NULL),
('Hotel deLuxe', 88, '2019-12-23', 268, NULL),
('Hotel deLuxe', 88, '2019-12-24', 145, NULL),
('Hotel deLuxe', 88, '2019-12-25', 187, NULL),
('Hotel deLuxe', 88, '2019-12-26', 274, NULL),
('Hotel deLuxe', 88, '2019-12-27', 249, NULL),
('Hotel deLuxe', 88, '2019-12-28', 370, NULL),
('Hotel deLuxe', 88, '2019-12-29', 173, NULL),
('Hotel deLuxe', 88, '2019-12-30', 216, NULL),
('Hotel deLuxe', 88, '2019-12-31', 132, NULL),
('Hotel deLuxe', 88, '2020-01-01', 362, NULL),
('Hotel deLuxe', 88, '2020-01-02', 373, NULL),
('Hotel deLuxe', 88, '2020-01-03', 205, NULL),
('Hotel deLuxe', 88, '2020-01-04', 193, NULL),
('Hotel deLuxe', 88, '2020-01-05', 370, NULL),
('Hotel deLuxe', 88, '2020-01-06', 146, NULL),
('Hotel deLuxe', 88, '2020-01-07', 394, NULL),
('Hotel deLuxe', 88, '2020-01-08', 233, NULL),
('Hotel deLuxe', 88, '2020-01-09', 351, NULL),
('Hotel deLuxe', 88, '2020-01-10', 140, NULL),
('Hotel deLuxe', 88, '2020-01-11', 361, NULL),
('Hotel deLuxe', 88, '2020-01-12', 390, NULL),
('Hotel deLuxe', 88, '2020-01-13', 119, NULL),
('Hotel deLuxe', 88, '2020-01-14', 360, NULL),
('Hotel deLuxe', 88, '2020-01-15', 385, NULL),
('Hotel deLuxe', 88, '2020-01-16', 390, NULL),
('Hotel deLuxe', 88, '2020-01-17', 186, NULL),
('Hotel deLuxe', 88, '2020-01-18', 383, NULL),
('Hotel deLuxe', 88, '2020-01-19', 176, NULL),
('Hotel deLuxe', 88, '2020-01-20', 156, NULL),
('Hotel deLuxe', 88, '2020-01-21', 215, NULL),
('Hotel deLuxe', 88, '2020-01-22', 357, NULL),
('Hotel deLuxe', 88, '2020-01-23', 137, NULL),
('Hotel deLuxe', 88, '2020-01-24', 159, NULL),
('Hotel deLuxe', 88, '2020-01-25', 250, NULL),
('Hotel deLuxe', 88, '2020-01-26', 162, NULL),
('Hotel deLuxe', 88, '2020-01-27', 339, NULL),
('Hotel deLuxe', 88, '2020-01-28', 141, NULL),
('Hotel deLuxe', 88, '2020-01-29', 351, NULL),
('Hotel deLuxe', 88, '2020-01-30', 230, NULL),
('Hotel deLuxe', 88, '2020-01-31', 286, NULL),
('Hotel deLuxe', 88, '2020-02-01', 377, NULL),
('Hotel deLuxe', 88, '2020-02-02', 216, NULL),
('Hotel deLuxe', 88, '2020-02-03', 136, NULL),
('Hotel deLuxe', 88, '2020-02-04', 123, NULL),
('Hotel deLuxe', 91, '2019-01-01', 261, NULL),
('Hotel deLuxe', 91, '2019-01-02', 119, NULL),
('Hotel deLuxe', 91, '2019-01-03', 220, NULL),
('Hotel deLuxe', 91, '2019-01-04', 113, NULL),
('Hotel deLuxe', 91, '2019-01-05', 189, NULL),
('Hotel deLuxe', 91, '2019-01-06', 308, NULL),
('Hotel deLuxe', 91, '2019-01-07', 386, NULL),
('Hotel deLuxe', 91, '2019-01-08', 199, NULL),
('Hotel deLuxe', 91, '2019-01-09', 120, NULL),
('Hotel deLuxe', 91, '2019-01-10', 393, NULL),
('Hotel deLuxe', 91, '2019-01-11', 107, NULL),
('Hotel deLuxe', 91, '2019-01-12', 280, NULL),
('Hotel deLuxe', 91, '2019-01-13', 164, NULL),
('Hotel deLuxe', 91, '2019-01-14', 370, NULL),
('Hotel deLuxe', 91, '2019-01-15', 138, NULL),
('Hotel deLuxe', 91, '2019-01-16', 196, NULL),
('Hotel deLuxe', 91, '2019-01-17', 185, NULL),
('Hotel deLuxe', 91, '2019-01-18', 365, NULL),
('Hotel deLuxe', 91, '2019-01-19', 271, NULL),
('Hotel deLuxe', 91, '2019-01-20', 167, NULL),
('Hotel deLuxe', 91, '2019-01-21', 241, NULL),
('Hotel deLuxe', 91, '2019-01-22', 359, NULL),
('Hotel deLuxe', 91, '2019-01-23', 100, NULL),
('Hotel deLuxe', 91, '2019-01-24', 366, NULL),
('Hotel deLuxe', 91, '2019-01-25', 295, NULL),
('Hotel deLuxe', 91, '2019-01-26', 123, NULL),
('Hotel deLuxe', 91, '2019-01-27', 158, NULL),
('Hotel deLuxe', 91, '2019-01-28', 196, NULL),
('Hotel deLuxe', 91, '2019-01-29', 315, NULL),
('Hotel deLuxe', 91, '2019-01-30', 387, NULL),
('Hotel deLuxe', 91, '2019-01-31', 113, NULL),
('Hotel deLuxe', 91, '2019-02-01', 105, NULL),
('Hotel deLuxe', 91, '2019-02-02', 358, NULL),
('Hotel deLuxe', 91, '2019-02-03', 143, NULL),
('Hotel deLuxe', 91, '2019-02-04', 398, NULL),
('Hotel deLuxe', 91, '2019-02-05', 156, NULL),
('Hotel deLuxe', 91, '2019-02-06', 209, NULL),
('Hotel deLuxe', 91, '2019-02-07', 253, NULL),
('Hotel deLuxe', 91, '2019-02-08', 116, NULL),
('Hotel deLuxe', 91, '2019-02-09', 205, NULL),
('Hotel deLuxe', 91, '2019-02-10', 124, NULL),
('Hotel deLuxe', 91, '2019-02-11', 375, NULL),
('Hotel deLuxe', 91, '2019-02-12', 374, NULL),
('Hotel deLuxe', 91, '2019-02-13', 345, NULL),
('Hotel deLuxe', 91, '2019-02-14', 386, NULL),
('Hotel deLuxe', 91, '2019-02-15', 300, NULL),
('Hotel deLuxe', 91, '2019-02-16', 368, NULL),
('Hotel deLuxe', 91, '2019-02-17', 299, NULL),
('Hotel deLuxe', 91, '2019-02-18', 287, NULL),
('Hotel deLuxe', 91, '2019-02-19', 240, NULL),
('Hotel deLuxe', 91, '2019-02-20', 110, NULL),
('Hotel deLuxe', 91, '2019-02-21', 373, NULL),
('Hotel deLuxe', 91, '2019-02-22', 300, NULL),
('Hotel deLuxe', 91, '2019-02-23', 271, NULL),
('Hotel deLuxe', 91, '2019-02-24', 359, NULL),
('Hotel deLuxe', 91, '2019-02-25', 386, NULL),
('Hotel deLuxe', 91, '2019-02-26', 288, NULL),
('Hotel deLuxe', 91, '2019-02-27', 230, NULL),
('Hotel deLuxe', 91, '2019-02-28', 234, NULL),
('Hotel deLuxe', 91, '2019-03-01', 372, NULL),
('Hotel deLuxe', 91, '2019-03-02', 232, NULL),
('Hotel deLuxe', 91, '2019-03-03', 124, NULL),
('Hotel deLuxe', 91, '2019-03-04', 252, NULL),
('Hotel deLuxe', 91, '2019-03-05', 188, NULL),
('Hotel deLuxe', 91, '2019-03-06', 156, NULL),
('Hotel deLuxe', 91, '2019-03-07', 340, NULL),
('Hotel deLuxe', 91, '2019-03-08', 110, NULL),
('Hotel deLuxe', 91, '2019-03-09', 315, NULL),
('Hotel deLuxe', 91, '2019-03-10', 313, NULL),
('Hotel deLuxe', 91, '2019-03-11', 202, NULL),
('Hotel deLuxe', 91, '2019-03-12', 275, NULL),
('Hotel deLuxe', 91, '2019-03-13', 201, NULL),
('Hotel deLuxe', 91, '2019-03-14', 381, NULL),
('Hotel deLuxe', 91, '2019-03-15', 124, NULL),
('Hotel deLuxe', 91, '2019-03-16', 236, NULL),
('Hotel deLuxe', 91, '2019-03-17', 103, NULL),
('Hotel deLuxe', 91, '2019-03-18', 310, NULL),
('Hotel deLuxe', 91, '2019-03-19', 206, NULL),
('Hotel deLuxe', 91, '2019-03-20', 206, NULL),
('Hotel deLuxe', 91, '2019-03-21', 158, NULL),
('Hotel deLuxe', 91, '2019-03-22', 298, NULL),
('Hotel deLuxe', 91, '2019-03-23', 106, NULL),
('Hotel deLuxe', 91, '2019-03-24', 329, NULL),
('Hotel deLuxe', 91, '2019-03-25', 198, NULL),
('Hotel deLuxe', 91, '2019-03-26', 271, NULL),
('Hotel deLuxe', 91, '2019-03-27', 159, NULL),
('Hotel deLuxe', 91, '2019-03-28', 101, NULL),
('Hotel deLuxe', 91, '2019-03-29', 368, NULL),
('Hotel deLuxe', 91, '2019-03-30', 201, NULL),
('Hotel deLuxe', 91, '2019-03-31', 156, NULL),
('Hotel deLuxe', 91, '2019-04-01', 342, NULL),
('Hotel deLuxe', 91, '2019-04-02', 209, NULL),
('Hotel deLuxe', 91, '2019-04-03', 376, NULL),
('Hotel deLuxe', 91, '2019-04-04', 353, NULL),
('Hotel deLuxe', 91, '2019-04-05', 200, NULL),
('Hotel deLuxe', 91, '2019-04-06', 322, NULL),
('Hotel deLuxe', 91, '2019-04-07', 119, NULL),
('Hotel deLuxe', 91, '2019-04-08', 125, NULL),
('Hotel deLuxe', 91, '2019-04-09', 374, NULL),
('Hotel deLuxe', 91, '2019-04-10', 245, NULL),
('Hotel deLuxe', 91, '2019-04-11', 223, NULL),
('Hotel deLuxe', 91, '2019-04-12', 289, NULL),
('Hotel deLuxe', 91, '2019-04-13', 287, NULL),
('Hotel deLuxe', 91, '2019-04-14', 230, NULL),
('Hotel deLuxe', 91, '2019-04-15', 244, NULL),
('Hotel deLuxe', 91, '2019-04-16', 351, NULL),
('Hotel deLuxe', 91, '2019-04-17', 169, NULL),
('Hotel deLuxe', 91, '2019-04-18', 172, NULL),
('Hotel deLuxe', 91, '2019-04-19', 297, NULL),
('Hotel deLuxe', 91, '2019-04-20', 130, NULL),
('Hotel deLuxe', 91, '2019-04-21', 176, NULL),
('Hotel deLuxe', 91, '2019-04-22', 162, NULL),
('Hotel deLuxe', 91, '2019-04-23', 274, NULL),
('Hotel deLuxe', 91, '2019-04-24', 144, NULL),
('Hotel deLuxe', 91, '2019-04-25', 375, NULL),
('Hotel deLuxe', 91, '2019-04-26', 333, NULL),
('Hotel deLuxe', 91, '2019-04-27', 192, NULL),
('Hotel deLuxe', 91, '2019-04-28', 172, NULL),
('Hotel deLuxe', 91, '2019-04-29', 209, NULL),
('Hotel deLuxe', 91, '2019-04-30', 199, NULL),
('Hotel deLuxe', 91, '2019-05-01', 186, NULL),
('Hotel deLuxe', 91, '2019-05-02', 236, NULL),
('Hotel deLuxe', 91, '2019-05-03', 397, NULL),
('Hotel deLuxe', 91, '2019-05-04', 330, NULL),
('Hotel deLuxe', 91, '2019-05-05', 100, NULL),
('Hotel deLuxe', 91, '2019-05-06', 117, NULL),
('Hotel deLuxe', 91, '2019-05-07', 114, NULL),
('Hotel deLuxe', 91, '2019-05-08', 373, NULL),
('Hotel deLuxe', 91, '2019-05-09', 273, NULL),
('Hotel deLuxe', 91, '2019-05-10', 193, NULL),
('Hotel deLuxe', 91, '2019-05-11', 291, NULL),
('Hotel deLuxe', 91, '2019-05-12', 317, NULL),
('Hotel deLuxe', 91, '2019-05-13', 271, NULL),
('Hotel deLuxe', 91, '2019-05-14', 240, NULL),
('Hotel deLuxe', 91, '2019-05-15', 265, NULL),
('Hotel deLuxe', 91, '2019-05-16', 295, NULL),
('Hotel deLuxe', 91, '2019-05-17', 203, NULL),
('Hotel deLuxe', 91, '2019-05-18', 381, NULL),
('Hotel deLuxe', 91, '2019-05-19', 355, NULL),
('Hotel deLuxe', 91, '2019-05-20', 204, NULL),
('Hotel deLuxe', 91, '2019-05-21', 389, NULL),
('Hotel deLuxe', 91, '2019-05-22', 161, NULL),
('Hotel deLuxe', 91, '2019-05-23', 303, NULL),
('Hotel deLuxe', 91, '2019-05-24', 141, NULL),
('Hotel deLuxe', 91, '2019-05-25', 216, NULL),
('Hotel deLuxe', 91, '2019-05-26', 304, NULL),
('Hotel deLuxe', 91, '2019-05-27', 272, NULL),
('Hotel deLuxe', 91, '2019-05-28', 142, NULL),
('Hotel deLuxe', 91, '2019-05-29', 287, NULL),
('Hotel deLuxe', 91, '2019-05-30', 367, NULL),
('Hotel deLuxe', 91, '2019-05-31', 195, NULL),
('Hotel deLuxe', 91, '2019-06-01', 314, NULL),
('Hotel deLuxe', 91, '2019-06-02', 239, NULL),
('Hotel deLuxe', 91, '2019-06-03', 321, NULL),
('Hotel deLuxe', 91, '2019-06-04', 201, NULL),
('Hotel deLuxe', 91, '2019-06-05', 223, NULL),
('Hotel deLuxe', 91, '2019-06-06', 119, NULL),
('Hotel deLuxe', 91, '2019-06-07', 306, NULL),
('Hotel deLuxe', 91, '2019-06-08', 228, NULL),
('Hotel deLuxe', 91, '2019-06-09', 180, NULL),
('Hotel deLuxe', 91, '2019-06-10', 356, NULL),
('Hotel deLuxe', 91, '2019-06-11', 342, NULL),
('Hotel deLuxe', 91, '2019-06-12', 304, NULL),
('Hotel deLuxe', 91, '2019-06-13', 363, NULL),
('Hotel deLuxe', 91, '2019-06-14', 353, NULL),
('Hotel deLuxe', 91, '2019-06-15', 227, NULL),
('Hotel deLuxe', 91, '2019-06-16', 354, NULL),
('Hotel deLuxe', 91, '2019-06-17', 104, NULL),
('Hotel deLuxe', 91, '2019-06-18', 357, NULL),
('Hotel deLuxe', 91, '2019-06-19', 145, NULL),
('Hotel deLuxe', 91, '2019-06-20', 105, NULL),
('Hotel deLuxe', 91, '2019-06-21', 330, NULL),
('Hotel deLuxe', 91, '2019-06-22', 219, NULL),
('Hotel deLuxe', 91, '2019-06-23', 356, NULL),
('Hotel deLuxe', 91, '2019-06-24', 390, NULL),
('Hotel deLuxe', 91, '2019-06-25', 197, NULL),
('Hotel deLuxe', 91, '2019-06-26', 119, NULL),
('Hotel deLuxe', 91, '2019-06-27', 198, NULL),
('Hotel deLuxe', 91, '2019-06-28', 340, NULL),
('Hotel deLuxe', 91, '2019-06-29', 227, NULL),
('Hotel deLuxe', 91, '2019-06-30', 344, NULL),
('Hotel deLuxe', 91, '2019-07-01', 174, NULL),
('Hotel deLuxe', 91, '2019-07-02', 335, NULL),
('Hotel deLuxe', 91, '2019-07-03', 133, NULL),
('Hotel deLuxe', 91, '2019-07-04', 100, NULL),
('Hotel deLuxe', 91, '2019-07-05', 196, NULL),
('Hotel deLuxe', 91, '2019-07-06', 205, NULL),
('Hotel deLuxe', 91, '2019-07-07', 284, NULL),
('Hotel deLuxe', 91, '2019-07-08', 361, NULL),
('Hotel deLuxe', 91, '2019-07-09', 141, NULL),
('Hotel deLuxe', 91, '2019-07-10', 334, NULL),
('Hotel deLuxe', 91, '2019-07-11', 331, NULL),
('Hotel deLuxe', 91, '2019-07-12', 154, NULL),
('Hotel deLuxe', 91, '2019-07-13', 182, NULL),
('Hotel deLuxe', 91, '2019-07-14', 229, NULL),
('Hotel deLuxe', 91, '2019-07-15', 179, NULL),
('Hotel deLuxe', 91, '2019-07-16', 330, NULL),
('Hotel deLuxe', 91, '2019-07-17', 300, NULL),
('Hotel deLuxe', 91, '2019-07-18', 185, NULL),
('Hotel deLuxe', 91, '2019-07-19', 395, NULL),
('Hotel deLuxe', 91, '2019-07-20', 200, NULL),
('Hotel deLuxe', 91, '2019-07-21', 313, NULL),
('Hotel deLuxe', 91, '2019-07-22', 290, NULL),
('Hotel deLuxe', 91, '2019-07-23', 186, NULL),
('Hotel deLuxe', 91, '2019-07-24', 272, NULL),
('Hotel deLuxe', 91, '2019-07-25', 102, NULL),
('Hotel deLuxe', 91, '2019-07-26', 165, NULL),
('Hotel deLuxe', 91, '2019-07-27', 338, NULL),
('Hotel deLuxe', 91, '2019-07-28', 249, NULL),
('Hotel deLuxe', 91, '2019-07-29', 215, NULL),
('Hotel deLuxe', 91, '2019-07-30', 154, NULL),
('Hotel deLuxe', 91, '2019-07-31', 217, NULL),
('Hotel deLuxe', 91, '2019-08-01', 100, NULL),
('Hotel deLuxe', 91, '2019-08-02', 357, NULL),
('Hotel deLuxe', 91, '2019-08-03', 298, NULL),
('Hotel deLuxe', 91, '2019-08-04', 274, NULL),
('Hotel deLuxe', 91, '2019-08-05', 327, NULL),
('Hotel deLuxe', 91, '2019-08-06', 270, NULL),
('Hotel deLuxe', 91, '2019-08-07', 182, NULL),
('Hotel deLuxe', 91, '2019-08-08', 177, NULL),
('Hotel deLuxe', 91, '2019-08-09', 172, NULL),
('Hotel deLuxe', 91, '2019-08-10', 112, NULL),
('Hotel deLuxe', 91, '2019-08-11', 387, NULL),
('Hotel deLuxe', 91, '2019-08-12', 310, NULL),
('Hotel deLuxe', 91, '2019-08-13', 224, NULL),
('Hotel deLuxe', 91, '2019-08-14', 191, NULL),
('Hotel deLuxe', 91, '2019-08-15', 361, NULL),
('Hotel deLuxe', 91, '2019-08-16', 300, NULL),
('Hotel deLuxe', 91, '2019-08-17', 123, NULL),
('Hotel deLuxe', 91, '2019-08-18', 267, NULL),
('Hotel deLuxe', 91, '2019-08-19', 306, NULL),
('Hotel deLuxe', 91, '2019-08-20', 227, NULL),
('Hotel deLuxe', 91, '2019-08-21', 220, NULL),
('Hotel deLuxe', 91, '2019-08-22', 314, NULL),
('Hotel deLuxe', 91, '2019-08-23', 312, NULL),
('Hotel deLuxe', 91, '2019-08-24', 302, NULL),
('Hotel deLuxe', 91, '2019-08-25', 110, NULL),
('Hotel deLuxe', 91, '2019-08-26', 100, NULL),
('Hotel deLuxe', 91, '2019-08-27', 330, NULL),
('Hotel deLuxe', 91, '2019-08-28', 147, NULL),
('Hotel deLuxe', 91, '2019-08-29', 154, NULL),
('Hotel deLuxe', 91, '2019-08-30', 249, NULL),
('Hotel deLuxe', 91, '2019-08-31', 318, NULL),
('Hotel deLuxe', 91, '2019-09-01', 109, NULL),
('Hotel deLuxe', 91, '2019-09-02', 138, NULL),
('Hotel deLuxe', 91, '2019-09-03', 167, NULL),
('Hotel deLuxe', 91, '2019-09-04', 152, NULL),
('Hotel deLuxe', 91, '2019-09-05', 158, NULL),
('Hotel deLuxe', 91, '2019-09-06', 164, NULL),
('Hotel deLuxe', 91, '2019-09-07', 306, NULL),
('Hotel deLuxe', 91, '2019-09-08', 181, NULL),
('Hotel deLuxe', 91, '2019-09-09', 163, NULL),
('Hotel deLuxe', 91, '2019-09-10', 349, NULL),
('Hotel deLuxe', 91, '2019-09-11', 295, NULL),
('Hotel deLuxe', 91, '2019-09-12', 158, NULL),
('Hotel deLuxe', 91, '2019-09-13', 354, NULL),
('Hotel deLuxe', 91, '2019-09-14', 265, NULL),
('Hotel deLuxe', 91, '2019-09-15', 245, NULL),
('Hotel deLuxe', 91, '2019-09-16', 112, NULL),
('Hotel deLuxe', 91, '2019-09-17', 356, NULL),
('Hotel deLuxe', 91, '2019-09-18', 103, NULL),
('Hotel deLuxe', 91, '2019-09-19', 184, NULL),
('Hotel deLuxe', 91, '2019-09-20', 351, NULL),
('Hotel deLuxe', 91, '2019-09-21', 102, NULL),
('Hotel deLuxe', 91, '2019-09-22', 316, NULL),
('Hotel deLuxe', 91, '2019-09-23', 157, NULL),
('Hotel deLuxe', 91, '2019-09-24', 328, NULL),
('Hotel deLuxe', 91, '2019-09-25', 242, NULL),
('Hotel deLuxe', 91, '2019-09-26', 229, NULL),
('Hotel deLuxe', 91, '2019-09-27', 390, NULL),
('Hotel deLuxe', 91, '2019-09-28', 296, NULL),
('Hotel deLuxe', 91, '2019-09-29', 345, NULL),
('Hotel deLuxe', 91, '2019-09-30', 222, NULL),
('Hotel deLuxe', 91, '2019-10-01', 396, NULL),
('Hotel deLuxe', 91, '2019-10-02', 209, NULL),
('Hotel deLuxe', 91, '2019-10-03', 155, NULL),
('Hotel deLuxe', 91, '2019-10-04', 258, NULL),
('Hotel deLuxe', 91, '2019-10-05', 383, NULL),
('Hotel deLuxe', 91, '2019-10-06', 144, NULL),
('Hotel deLuxe', 91, '2019-10-07', 317, NULL),
('Hotel deLuxe', 91, '2019-10-08', 153, NULL),
('Hotel deLuxe', 91, '2019-10-09', 119, NULL),
('Hotel deLuxe', 91, '2019-10-10', 247, NULL),
('Hotel deLuxe', 91, '2019-10-11', 150, NULL),
('Hotel deLuxe', 91, '2019-10-12', 266, NULL),
('Hotel deLuxe', 91, '2019-10-13', 359, NULL),
('Hotel deLuxe', 91, '2019-10-14', 292, NULL),
('Hotel deLuxe', 91, '2019-10-15', 288, NULL),
('Hotel deLuxe', 91, '2019-10-16', 197, NULL),
('Hotel deLuxe', 91, '2019-10-17', 390, NULL),
('Hotel deLuxe', 91, '2019-10-18', 145, NULL),
('Hotel deLuxe', 91, '2019-10-19', 393, NULL),
('Hotel deLuxe', 91, '2019-10-20', 234, NULL),
('Hotel deLuxe', 91, '2019-10-21', 398, NULL),
('Hotel deLuxe', 91, '2019-10-22', 195, NULL),
('Hotel deLuxe', 91, '2019-10-23', 319, NULL),
('Hotel deLuxe', 91, '2019-10-24', 259, NULL),
('Hotel deLuxe', 91, '2019-10-25', 127, NULL),
('Hotel deLuxe', 91, '2019-10-26', 133, NULL),
('Hotel deLuxe', 91, '2019-10-27', 361, NULL),
('Hotel deLuxe', 91, '2019-10-28', 379, NULL),
('Hotel deLuxe', 91, '2019-10-29', 134, NULL),
('Hotel deLuxe', 91, '2019-10-30', 133, NULL),
('Hotel deLuxe', 91, '2019-10-31', 224, NULL),
('Hotel deLuxe', 91, '2019-11-01', 399, NULL),
('Hotel deLuxe', 91, '2019-11-02', 227, NULL),
('Hotel deLuxe', 91, '2019-11-03', 387, NULL),
('Hotel deLuxe', 91, '2019-11-04', 132, NULL),
('Hotel deLuxe', 91, '2019-11-05', 161, NULL),
('Hotel deLuxe', 91, '2019-11-06', 318, NULL),
('Hotel deLuxe', 91, '2019-11-07', 363, NULL),
('Hotel deLuxe', 91, '2019-11-08', 182, NULL),
('Hotel deLuxe', 91, '2019-11-09', 243, NULL),
('Hotel deLuxe', 91, '2019-11-10', 109, NULL),
('Hotel deLuxe', 91, '2019-11-11', 172, NULL),
('Hotel deLuxe', 91, '2019-11-12', 125, NULL),
('Hotel deLuxe', 91, '2019-11-13', 322, NULL),
('Hotel deLuxe', 91, '2019-11-14', 333, NULL),
('Hotel deLuxe', 91, '2019-11-15', 385, NULL),
('Hotel deLuxe', 91, '2019-11-16', 356, NULL),
('Hotel deLuxe', 91, '2019-11-17', 336, NULL),
('Hotel deLuxe', 91, '2019-11-18', 399, NULL),
('Hotel deLuxe', 91, '2019-11-19', 104, NULL),
('Hotel deLuxe', 91, '2019-11-20', 156, NULL),
('Hotel deLuxe', 91, '2019-11-21', 183, NULL),
('Hotel deLuxe', 91, '2019-11-22', 334, NULL),
('Hotel deLuxe', 91, '2019-11-23', 323, NULL),
('Hotel deLuxe', 91, '2019-11-24', 190, NULL),
('Hotel deLuxe', 91, '2019-11-25', 315, NULL),
('Hotel deLuxe', 91, '2019-11-26', 330, NULL),
('Hotel deLuxe', 91, '2019-11-27', 112, NULL),
('Hotel deLuxe', 91, '2019-11-28', 235, NULL),
('Hotel deLuxe', 91, '2019-11-29', 158, NULL),
('Hotel deLuxe', 91, '2019-11-30', 393, NULL),
('Hotel deLuxe', 91, '2019-12-01', 315, NULL),
('Hotel deLuxe', 91, '2019-12-02', 124, NULL),
('Hotel deLuxe', 91, '2019-12-03', 350, NULL),
('Hotel deLuxe', 91, '2019-12-04', 175, NULL),
('Hotel deLuxe', 91, '2019-12-05', 151, NULL),
('Hotel deLuxe', 91, '2019-12-06', 247, NULL),
('Hotel deLuxe', 91, '2019-12-07', 381, NULL),
('Hotel deLuxe', 91, '2019-12-08', 201, NULL),
('Hotel deLuxe', 91, '2019-12-09', 274, NULL),
('Hotel deLuxe', 91, '2019-12-10', 336, NULL),
('Hotel deLuxe', 91, '2019-12-11', 278, NULL),
('Hotel deLuxe', 91, '2019-12-12', 314, NULL),
('Hotel deLuxe', 91, '2019-12-13', 388, NULL),
('Hotel deLuxe', 91, '2019-12-14', 389, NULL),
('Hotel deLuxe', 91, '2019-12-15', 386, NULL),
('Hotel deLuxe', 91, '2019-12-16', 153, NULL),
('Hotel deLuxe', 91, '2019-12-17', 236, NULL),
('Hotel deLuxe', 91, '2019-12-18', 292, NULL),
('Hotel deLuxe', 91, '2019-12-19', 356, NULL),
('Hotel deLuxe', 91, '2019-12-20', 231, NULL),
('Hotel deLuxe', 91, '2019-12-21', 360, NULL),
('Hotel deLuxe', 91, '2019-12-22', 208, NULL),
('Hotel deLuxe', 91, '2019-12-23', 140, NULL),
('Hotel deLuxe', 91, '2019-12-24', 220, NULL),
('Hotel deLuxe', 91, '2019-12-25', 266, NULL),
('Hotel deLuxe', 91, '2019-12-26', 354, NULL),
('Hotel deLuxe', 91, '2019-12-27', 278, NULL),
('Hotel deLuxe', 91, '2019-12-28', 346, NULL),
('Hotel deLuxe', 91, '2019-12-29', 278, NULL),
('Hotel deLuxe', 91, '2019-12-30', 364, NULL),
('Hotel deLuxe', 91, '2019-12-31', 294, NULL),
('Hotel deLuxe', 91, '2020-01-01', 309, NULL),
('Hotel deLuxe', 91, '2020-01-02', 283, NULL),
('Hotel deLuxe', 91, '2020-01-03', 323, NULL),
('Hotel deLuxe', 91, '2020-01-04', 361, NULL),
('Hotel deLuxe', 91, '2020-01-05', 114, NULL),
('Hotel deLuxe', 91, '2020-01-06', 186, NULL),
('Hotel deLuxe', 91, '2020-01-07', 285, NULL),
('Hotel deLuxe', 91, '2020-01-08', 374, NULL),
('Hotel deLuxe', 91, '2020-01-09', 107, NULL),
('Hotel deLuxe', 91, '2020-01-10', 225, NULL),
('Hotel deLuxe', 91, '2020-01-11', 365, NULL),
('Hotel deLuxe', 91, '2020-01-12', 299, NULL),
('Hotel deLuxe', 91, '2020-01-13', 317, NULL),
('Hotel deLuxe', 91, '2020-01-14', 281, NULL),
('Hotel deLuxe', 91, '2020-01-15', 375, NULL),
('Hotel deLuxe', 91, '2020-01-16', 330, NULL),
('Hotel deLuxe', 91, '2020-01-17', 361, NULL),
('Hotel deLuxe', 91, '2020-01-18', 286, NULL),
('Hotel deLuxe', 91, '2020-01-19', 300, NULL),
('Hotel deLuxe', 91, '2020-01-20', 177, NULL),
('Hotel deLuxe', 91, '2020-01-21', 130, NULL),
('Hotel deLuxe', 91, '2020-01-22', 186, NULL),
('Hotel deLuxe', 91, '2020-01-23', 203, NULL),
('Hotel deLuxe', 91, '2020-01-24', 390, NULL),
('Hotel deLuxe', 91, '2020-01-25', 118, NULL),
('Hotel deLuxe', 91, '2020-01-26', 260, NULL),
('Hotel deLuxe', 91, '2020-01-27', 347, NULL),
('Hotel deLuxe', 91, '2020-01-28', 363, NULL),
('Hotel deLuxe', 91, '2020-01-29', 100, NULL),
('Hotel deLuxe', 91, '2020-01-30', 349, NULL),
('Hotel deLuxe', 91, '2020-01-31', 387, NULL),
('Hotel deLuxe', 91, '2020-02-01', 369, NULL),
('Hotel deLuxe', 91, '2020-02-02', 324, NULL),
('Hotel deLuxe', 91, '2020-02-03', 269, NULL),
('Hotel deLuxe', 91, '2020-02-04', 352, NULL),
('Hotel deLuxe', 116, '2019-01-01', 378, NULL),
('Hotel deLuxe', 116, '2019-01-02', 380, NULL),
('Hotel deLuxe', 116, '2019-01-03', 238, NULL),
('Hotel deLuxe', 116, '2019-01-04', 181, NULL),
('Hotel deLuxe', 116, '2019-01-05', 123, NULL),
('Hotel deLuxe', 116, '2019-01-06', 164, NULL),
('Hotel deLuxe', 116, '2019-01-07', 171, NULL),
('Hotel deLuxe', 116, '2019-01-08', 241, NULL),
('Hotel deLuxe', 116, '2019-01-09', 370, NULL),
('Hotel deLuxe', 116, '2019-01-10', 258, NULL),
('Hotel deLuxe', 116, '2019-01-11', 132, NULL),
('Hotel deLuxe', 116, '2019-01-12', 106, NULL),
('Hotel deLuxe', 116, '2019-01-13', 283, NULL),
('Hotel deLuxe', 116, '2019-01-14', 329, NULL),
('Hotel deLuxe', 116, '2019-01-15', 149, NULL),
('Hotel deLuxe', 116, '2019-01-16', 330, NULL),
('Hotel deLuxe', 116, '2019-01-17', 308, NULL),
('Hotel deLuxe', 116, '2019-01-18', 246, NULL),
('Hotel deLuxe', 116, '2019-01-19', 130, NULL),
('Hotel deLuxe', 116, '2019-01-20', 172, NULL),
('Hotel deLuxe', 116, '2019-01-21', 372, NULL),
('Hotel deLuxe', 116, '2019-01-22', 263, NULL),
('Hotel deLuxe', 116, '2019-01-23', 336, NULL),
('Hotel deLuxe', 116, '2019-01-24', 298, NULL),
('Hotel deLuxe', 116, '2019-01-25', 242, NULL),
('Hotel deLuxe', 116, '2019-01-26', 155, NULL),
('Hotel deLuxe', 116, '2019-01-27', 121, NULL),
('Hotel deLuxe', 116, '2019-01-28', 216, NULL),
('Hotel deLuxe', 116, '2019-01-29', 201, NULL),
('Hotel deLuxe', 116, '2019-01-30', 136, NULL),
('Hotel deLuxe', 116, '2019-01-31', 383, NULL),
('Hotel deLuxe', 116, '2019-02-01', 121, NULL),
('Hotel deLuxe', 116, '2019-02-02', 342, NULL),
('Hotel deLuxe', 116, '2019-02-03', 151, NULL),
('Hotel deLuxe', 116, '2019-02-04', 207, NULL),
('Hotel deLuxe', 116, '2019-02-05', 292, NULL),
('Hotel deLuxe', 116, '2019-02-06', 331, NULL),
('Hotel deLuxe', 116, '2019-02-07', 314, NULL),
('Hotel deLuxe', 116, '2019-02-08', 342, NULL),
('Hotel deLuxe', 116, '2019-02-09', 288, NULL),
('Hotel deLuxe', 116, '2019-02-10', 123, NULL),
('Hotel deLuxe', 116, '2019-02-11', 381, NULL),
('Hotel deLuxe', 116, '2019-02-12', 213, NULL),
('Hotel deLuxe', 116, '2019-02-13', 158, NULL),
('Hotel deLuxe', 116, '2019-02-14', 330, NULL),
('Hotel deLuxe', 116, '2019-02-15', 105, NULL),
('Hotel deLuxe', 116, '2019-02-16', 385, NULL),
('Hotel deLuxe', 116, '2019-02-17', 302, NULL),
('Hotel deLuxe', 116, '2019-02-18', 333, NULL),
('Hotel deLuxe', 116, '2019-02-19', 205, NULL),
('Hotel deLuxe', 116, '2019-02-20', 168, NULL),
('Hotel deLuxe', 116, '2019-02-21', 367, NULL),
('Hotel deLuxe', 116, '2019-02-22', 340, NULL),
('Hotel deLuxe', 116, '2019-02-23', 229, NULL),
('Hotel deLuxe', 116, '2019-02-24', 196, NULL),
('Hotel deLuxe', 116, '2019-02-25', 144, NULL),
('Hotel deLuxe', 116, '2019-02-26', 142, NULL),
('Hotel deLuxe', 116, '2019-02-27', 219, NULL),
('Hotel deLuxe', 116, '2019-02-28', 228, NULL),
('Hotel deLuxe', 116, '2019-03-01', 315, NULL),
('Hotel deLuxe', 116, '2019-03-02', 328, NULL),
('Hotel deLuxe', 116, '2019-03-03', 297, NULL),
('Hotel deLuxe', 116, '2019-03-04', 205, NULL),
('Hotel deLuxe', 116, '2019-03-05', 274, NULL),
('Hotel deLuxe', 116, '2019-03-06', 350, NULL),
('Hotel deLuxe', 116, '2019-03-07', 395, NULL),
('Hotel deLuxe', 116, '2019-03-08', 333, NULL),
('Hotel deLuxe', 116, '2019-03-09', 354, NULL),
('Hotel deLuxe', 116, '2019-03-10', 356, NULL),
('Hotel deLuxe', 116, '2019-03-11', 123, NULL),
('Hotel deLuxe', 116, '2019-03-12', 329, NULL),
('Hotel deLuxe', 116, '2019-03-13', 374, NULL),
('Hotel deLuxe', 116, '2019-03-14', 159, NULL),
('Hotel deLuxe', 116, '2019-03-15', 177, NULL),
('Hotel deLuxe', 116, '2019-03-16', 150, NULL),
('Hotel deLuxe', 116, '2019-03-17', 173, NULL),
('Hotel deLuxe', 116, '2019-03-18', 336, NULL),
('Hotel deLuxe', 116, '2019-03-19', 290, NULL),
('Hotel deLuxe', 116, '2019-03-20', 393, NULL),
('Hotel deLuxe', 116, '2019-03-21', 137, NULL),
('Hotel deLuxe', 116, '2019-03-22', 130, NULL),
('Hotel deLuxe', 116, '2019-03-23', 209, NULL),
('Hotel deLuxe', 116, '2019-03-24', 128, NULL),
('Hotel deLuxe', 116, '2019-03-25', 117, NULL),
('Hotel deLuxe', 116, '2019-03-26', 381, NULL),
('Hotel deLuxe', 116, '2019-03-27', 150, NULL),
('Hotel deLuxe', 116, '2019-03-28', 144, NULL),
('Hotel deLuxe', 116, '2019-03-29', 384, NULL),
('Hotel deLuxe', 116, '2019-03-30', 153, NULL),
('Hotel deLuxe', 116, '2019-03-31', 345, NULL),
('Hotel deLuxe', 116, '2019-04-01', 184, NULL),
('Hotel deLuxe', 116, '2019-04-02', 271, NULL),
('Hotel deLuxe', 116, '2019-04-03', 286, NULL),
('Hotel deLuxe', 116, '2019-04-04', 275, NULL),
('Hotel deLuxe', 116, '2019-04-05', 106, NULL),
('Hotel deLuxe', 116, '2019-04-06', 157, NULL),
('Hotel deLuxe', 116, '2019-04-07', 150, NULL),
('Hotel deLuxe', 116, '2019-04-08', 195, NULL),
('Hotel deLuxe', 116, '2019-04-09', 264, NULL),
('Hotel deLuxe', 116, '2019-04-10', 148, NULL),
('Hotel deLuxe', 116, '2019-04-11', 325, NULL),
('Hotel deLuxe', 116, '2019-04-12', 287, NULL),
('Hotel deLuxe', 116, '2019-04-13', 223, NULL),
('Hotel deLuxe', 116, '2019-04-14', 296, NULL),
('Hotel deLuxe', 116, '2019-04-15', 333, NULL),
('Hotel deLuxe', 116, '2019-04-16', 152, NULL),
('Hotel deLuxe', 116, '2019-04-17', 172, NULL),
('Hotel deLuxe', 116, '2019-04-18', 290, NULL),
('Hotel deLuxe', 116, '2019-04-19', 213, NULL),
('Hotel deLuxe', 116, '2019-04-20', 270, NULL),
('Hotel deLuxe', 116, '2019-04-21', 116, NULL),
('Hotel deLuxe', 116, '2019-04-22', 209, NULL),
('Hotel deLuxe', 116, '2019-04-23', 328, NULL),
('Hotel deLuxe', 116, '2019-04-24', 200, NULL),
('Hotel deLuxe', 116, '2019-04-25', 315, NULL),
('Hotel deLuxe', 116, '2019-04-26', 107, NULL),
('Hotel deLuxe', 116, '2019-04-27', 385, NULL),
('Hotel deLuxe', 116, '2019-04-28', 260, NULL),
('Hotel deLuxe', 116, '2019-04-29', 213, NULL),
('Hotel deLuxe', 116, '2019-04-30', 200, NULL),
('Hotel deLuxe', 116, '2019-05-01', 283, NULL),
('Hotel deLuxe', 116, '2019-05-02', 103, NULL),
('Hotel deLuxe', 116, '2019-05-03', 162, NULL),
('Hotel deLuxe', 116, '2019-05-04', 218, NULL),
('Hotel deLuxe', 116, '2019-05-05', 124, NULL),
('Hotel deLuxe', 116, '2019-05-06', 220, NULL),
('Hotel deLuxe', 116, '2019-05-07', 386, NULL),
('Hotel deLuxe', 116, '2019-05-08', 367, NULL),
('Hotel deLuxe', 116, '2019-05-09', 176, NULL),
('Hotel deLuxe', 116, '2019-05-10', 324, NULL),
('Hotel deLuxe', 116, '2019-05-11', 364, NULL),
('Hotel deLuxe', 116, '2019-05-12', 194, NULL),
('Hotel deLuxe', 116, '2019-05-13', 111, NULL),
('Hotel deLuxe', 116, '2019-05-14', 395, NULL),
('Hotel deLuxe', 116, '2019-05-15', 397, NULL),
('Hotel deLuxe', 116, '2019-05-16', 392, NULL),
('Hotel deLuxe', 116, '2019-05-17', 379, NULL),
('Hotel deLuxe', 116, '2019-05-18', 203, NULL),
('Hotel deLuxe', 116, '2019-05-19', 109, NULL),
('Hotel deLuxe', 116, '2019-05-20', 121, NULL),
('Hotel deLuxe', 116, '2019-05-21', 354, NULL),
('Hotel deLuxe', 116, '2019-05-22', 292, NULL),
('Hotel deLuxe', 116, '2019-05-23', 193, NULL),
('Hotel deLuxe', 116, '2019-05-24', 254, NULL),
('Hotel deLuxe', 116, '2019-05-25', 112, NULL),
('Hotel deLuxe', 116, '2019-05-26', 377, NULL),
('Hotel deLuxe', 116, '2019-05-27', 195, NULL),
('Hotel deLuxe', 116, '2019-05-28', 397, NULL),
('Hotel deLuxe', 116, '2019-05-29', 334, NULL),
('Hotel deLuxe', 116, '2019-05-30', 173, NULL),
('Hotel deLuxe', 116, '2019-05-31', 144, NULL),
('Hotel deLuxe', 116, '2019-06-01', 243, NULL),
('Hotel deLuxe', 116, '2019-06-02', 268, NULL),
('Hotel deLuxe', 116, '2019-06-03', 203, NULL),
('Hotel deLuxe', 116, '2019-06-04', 322, NULL),
('Hotel deLuxe', 116, '2019-06-05', 373, NULL),
('Hotel deLuxe', 116, '2019-06-06', 296, NULL),
('Hotel deLuxe', 116, '2019-06-07', 174, NULL),
('Hotel deLuxe', 116, '2019-06-08', 350, NULL),
('Hotel deLuxe', 116, '2019-06-09', 130, NULL),
('Hotel deLuxe', 116, '2019-06-10', 128, NULL),
('Hotel deLuxe', 116, '2019-06-11', 384, NULL),
('Hotel deLuxe', 116, '2019-06-12', 311, NULL),
('Hotel deLuxe', 116, '2019-06-13', 304, NULL),
('Hotel deLuxe', 116, '2019-06-14', 172, NULL),
('Hotel deLuxe', 116, '2019-06-15', 181, NULL),
('Hotel deLuxe', 116, '2019-06-16', 348, NULL),
('Hotel deLuxe', 116, '2019-06-17', 206, NULL),
('Hotel deLuxe', 116, '2019-06-18', 160, NULL),
('Hotel deLuxe', 116, '2019-06-19', 368, NULL),
('Hotel deLuxe', 116, '2019-06-20', 267, NULL),
('Hotel deLuxe', 116, '2019-06-21', 292, NULL),
('Hotel deLuxe', 116, '2019-06-22', 137, NULL),
('Hotel deLuxe', 116, '2019-06-23', 362, NULL),
('Hotel deLuxe', 116, '2019-06-24', 148, NULL),
('Hotel deLuxe', 116, '2019-06-25', 117, NULL),
('Hotel deLuxe', 116, '2019-06-26', 219, NULL),
('Hotel deLuxe', 116, '2019-06-27', 234, NULL),
('Hotel deLuxe', 116, '2019-06-28', 345, NULL),
('Hotel deLuxe', 116, '2019-06-29', 384, NULL),
('Hotel deLuxe', 116, '2019-06-30', 269, NULL),
('Hotel deLuxe', 116, '2019-07-01', 335, NULL),
('Hotel deLuxe', 116, '2019-07-02', 180, NULL),
('Hotel deLuxe', 116, '2019-07-03', 259, NULL),
('Hotel deLuxe', 116, '2019-07-04', 313, NULL),
('Hotel deLuxe', 116, '2019-07-05', 256, NULL),
('Hotel deLuxe', 116, '2019-07-06', 332, NULL),
('Hotel deLuxe', 116, '2019-07-07', 160, NULL),
('Hotel deLuxe', 116, '2019-07-08', 315, NULL),
('Hotel deLuxe', 116, '2019-07-09', 310, NULL),
('Hotel deLuxe', 116, '2019-07-10', 164, NULL),
('Hotel deLuxe', 116, '2019-07-11', 191, NULL),
('Hotel deLuxe', 116, '2019-07-12', 239, NULL),
('Hotel deLuxe', 116, '2019-07-13', 369, NULL),
('Hotel deLuxe', 116, '2019-07-14', 332, NULL),
('Hotel deLuxe', 116, '2019-07-15', 257, NULL),
('Hotel deLuxe', 116, '2019-07-16', 106, NULL),
('Hotel deLuxe', 116, '2019-07-17', 300, NULL),
('Hotel deLuxe', 116, '2019-07-18', 351, NULL),
('Hotel deLuxe', 116, '2019-07-19', 175, NULL),
('Hotel deLuxe', 116, '2019-07-20', 104, NULL),
('Hotel deLuxe', 116, '2019-07-21', 218, NULL),
('Hotel deLuxe', 116, '2019-07-22', 120, NULL),
('Hotel deLuxe', 116, '2019-07-23', 165, NULL),
('Hotel deLuxe', 116, '2019-07-24', 238, NULL),
('Hotel deLuxe', 116, '2019-07-25', 106, NULL),
('Hotel deLuxe', 116, '2019-07-26', 259, NULL),
('Hotel deLuxe', 116, '2019-07-27', 247, NULL),
('Hotel deLuxe', 116, '2019-07-28', 179, NULL),
('Hotel deLuxe', 116, '2019-07-29', 366, NULL),
('Hotel deLuxe', 116, '2019-07-30', 345, NULL),
('Hotel deLuxe', 116, '2019-07-31', 387, NULL),
('Hotel deLuxe', 116, '2019-08-01', 309, NULL),
('Hotel deLuxe', 116, '2019-08-02', 312, NULL),
('Hotel deLuxe', 116, '2019-08-03', 295, NULL),
('Hotel deLuxe', 116, '2019-08-04', 141, NULL),
('Hotel deLuxe', 116, '2019-08-05', 302, NULL),
('Hotel deLuxe', 116, '2019-08-06', 114, NULL),
('Hotel deLuxe', 116, '2019-08-07', 310, NULL),
('Hotel deLuxe', 116, '2019-08-08', 242, NULL),
('Hotel deLuxe', 116, '2019-08-09', 115, NULL),
('Hotel deLuxe', 116, '2019-08-10', 369, NULL),
('Hotel deLuxe', 116, '2019-08-11', 155, NULL),
('Hotel deLuxe', 116, '2019-08-12', 289, NULL),
('Hotel deLuxe', 116, '2019-08-13', 187, NULL),
('Hotel deLuxe', 116, '2019-08-14', 304, NULL),
('Hotel deLuxe', 116, '2019-08-15', 270, NULL),
('Hotel deLuxe', 116, '2019-08-16', 141, NULL),
('Hotel deLuxe', 116, '2019-08-17', 161, NULL),
('Hotel deLuxe', 116, '2019-08-18', 146, NULL),
('Hotel deLuxe', 116, '2019-08-19', 353, NULL),
('Hotel deLuxe', 116, '2019-08-20', 169, NULL),
('Hotel deLuxe', 116, '2019-08-21', 323, NULL),
('Hotel deLuxe', 116, '2019-08-22', 108, NULL),
('Hotel deLuxe', 116, '2019-08-23', 338, NULL),
('Hotel deLuxe', 116, '2019-08-24', 204, NULL),
('Hotel deLuxe', 116, '2019-08-25', 262, NULL),
('Hotel deLuxe', 116, '2019-08-26', 298, NULL),
('Hotel deLuxe', 116, '2019-08-27', 231, NULL),
('Hotel deLuxe', 116, '2019-08-28', 257, NULL),
('Hotel deLuxe', 116, '2019-08-29', 328, NULL),
('Hotel deLuxe', 116, '2019-08-30', 185, NULL),
('Hotel deLuxe', 116, '2019-08-31', 258, NULL),
('Hotel deLuxe', 116, '2019-09-01', 108, NULL),
('Hotel deLuxe', 116, '2019-09-02', 328, NULL),
('Hotel deLuxe', 116, '2019-09-03', 177, NULL),
('Hotel deLuxe', 116, '2019-09-04', 211, NULL),
('Hotel deLuxe', 116, '2019-09-05', 223, NULL),
('Hotel deLuxe', 116, '2019-09-06', 269, NULL),
('Hotel deLuxe', 116, '2019-09-07', 287, NULL),
('Hotel deLuxe', 116, '2019-09-08', 228, NULL),
('Hotel deLuxe', 116, '2019-09-09', 351, NULL),
('Hotel deLuxe', 116, '2019-09-10', 206, NULL),
('Hotel deLuxe', 116, '2019-09-11', 378, NULL),
('Hotel deLuxe', 116, '2019-09-12', 276, NULL),
('Hotel deLuxe', 116, '2019-09-13', 283, NULL),
('Hotel deLuxe', 116, '2019-09-14', 169, NULL),
('Hotel deLuxe', 116, '2019-09-15', 155, NULL),
('Hotel deLuxe', 116, '2019-09-16', 242, NULL),
('Hotel deLuxe', 116, '2019-09-17', 395, NULL),
('Hotel deLuxe', 116, '2019-09-18', 143, NULL),
('Hotel deLuxe', 116, '2019-09-19', 185, NULL),
('Hotel deLuxe', 116, '2019-09-20', 102, NULL),
('Hotel deLuxe', 116, '2019-09-21', 262, NULL),
('Hotel deLuxe', 116, '2019-09-22', 327, NULL),
('Hotel deLuxe', 116, '2019-09-23', 304, NULL),
('Hotel deLuxe', 116, '2019-09-24', 396, NULL),
('Hotel deLuxe', 116, '2019-09-25', 157, NULL),
('Hotel deLuxe', 116, '2019-09-26', 340, NULL),
('Hotel deLuxe', 116, '2019-09-27', 323, NULL),
('Hotel deLuxe', 116, '2019-09-28', 312, NULL),
('Hotel deLuxe', 116, '2019-09-29', 156, NULL),
('Hotel deLuxe', 116, '2019-09-30', 331, NULL),
('Hotel deLuxe', 116, '2019-10-01', 269, NULL),
('Hotel deLuxe', 116, '2019-10-02', 362, NULL),
('Hotel deLuxe', 116, '2019-10-03', 262, NULL),
('Hotel deLuxe', 116, '2019-10-04', 161, NULL),
('Hotel deLuxe', 116, '2019-10-05', 349, NULL),
('Hotel deLuxe', 116, '2019-10-06', 369, NULL),
('Hotel deLuxe', 116, '2019-10-07', 184, NULL),
('Hotel deLuxe', 116, '2019-10-08', 143, NULL),
('Hotel deLuxe', 116, '2019-10-09', 253, NULL),
('Hotel deLuxe', 116, '2019-10-10', 230, NULL),
('Hotel deLuxe', 116, '2019-10-11', 134, NULL),
('Hotel deLuxe', 116, '2019-10-12', 308, NULL),
('Hotel deLuxe', 116, '2019-10-13', 368, NULL),
('Hotel deLuxe', 116, '2019-10-14', 260, NULL),
('Hotel deLuxe', 116, '2019-10-15', 187, NULL),
('Hotel deLuxe', 116, '2019-10-16', 213, NULL),
('Hotel deLuxe', 116, '2019-10-17', 227, NULL),
('Hotel deLuxe', 116, '2019-10-18', 186, NULL),
('Hotel deLuxe', 116, '2019-10-19', 367, NULL),
('Hotel deLuxe', 116, '2019-10-20', 353, NULL),
('Hotel deLuxe', 116, '2019-10-21', 254, NULL),
('Hotel deLuxe', 116, '2019-10-22', 321, NULL),
('Hotel deLuxe', 116, '2019-10-23', 146, NULL),
('Hotel deLuxe', 116, '2019-10-24', 159, NULL),
('Hotel deLuxe', 116, '2019-10-25', 117, NULL),
('Hotel deLuxe', 116, '2019-10-26', 231, NULL),
('Hotel deLuxe', 116, '2019-10-27', 123, NULL),
('Hotel deLuxe', 116, '2019-10-28', 361, NULL),
('Hotel deLuxe', 116, '2019-10-29', 368, NULL),
('Hotel deLuxe', 116, '2019-10-30', 267, NULL),
('Hotel deLuxe', 116, '2019-10-31', 399, NULL),
('Hotel deLuxe', 116, '2019-11-01', 105, NULL),
('Hotel deLuxe', 116, '2019-11-02', 399, NULL),
('Hotel deLuxe', 116, '2019-11-03', 183, NULL),
('Hotel deLuxe', 116, '2019-11-04', 323, NULL),
('Hotel deLuxe', 116, '2019-11-05', 270, NULL),
('Hotel deLuxe', 116, '2019-11-06', 302, NULL),
('Hotel deLuxe', 116, '2019-11-07', 392, NULL),
('Hotel deLuxe', 116, '2019-11-08', 158, NULL),
('Hotel deLuxe', 116, '2019-11-09', 279, NULL),
('Hotel deLuxe', 116, '2019-11-10', 115, NULL),
('Hotel deLuxe', 116, '2019-11-11', 140, NULL),
('Hotel deLuxe', 116, '2019-11-12', 189, NULL),
('Hotel deLuxe', 116, '2019-11-13', 352, NULL),
('Hotel deLuxe', 116, '2019-11-14', 306, NULL),
('Hotel deLuxe', 116, '2019-11-15', 183, NULL),
('Hotel deLuxe', 116, '2019-11-16', 309, NULL),
('Hotel deLuxe', 116, '2019-11-17', 341, NULL),
('Hotel deLuxe', 116, '2019-11-18', 382, NULL),
('Hotel deLuxe', 116, '2019-11-19', 280, NULL),
('Hotel deLuxe', 116, '2019-11-20', 176, NULL),
('Hotel deLuxe', 116, '2019-11-21', 373, NULL),
('Hotel deLuxe', 116, '2019-11-22', 312, NULL),
('Hotel deLuxe', 116, '2019-11-23', 314, NULL),
('Hotel deLuxe', 116, '2019-11-24', 316, NULL),
('Hotel deLuxe', 116, '2019-11-25', 250, NULL),
('Hotel deLuxe', 116, '2019-11-26', 334, NULL),
('Hotel deLuxe', 116, '2019-11-27', 325, NULL),
('Hotel deLuxe', 116, '2019-11-28', 302, NULL),
('Hotel deLuxe', 116, '2019-11-29', 263, NULL),
('Hotel deLuxe', 116, '2019-11-30', 269, NULL),
('Hotel deLuxe', 116, '2019-12-01', 363, NULL),
('Hotel deLuxe', 116, '2019-12-02', 361, NULL),
('Hotel deLuxe', 116, '2019-12-03', 219, NULL),
('Hotel deLuxe', 116, '2019-12-04', 118, NULL),
('Hotel deLuxe', 116, '2019-12-05', 295, NULL),
('Hotel deLuxe', 116, '2019-12-06', 296, NULL),
('Hotel deLuxe', 116, '2019-12-07', 179, NULL),
('Hotel deLuxe', 116, '2019-12-08', 160, NULL),
('Hotel deLuxe', 116, '2019-12-09', 211, NULL),
('Hotel deLuxe', 116, '2019-12-10', 306, NULL),
('Hotel deLuxe', 116, '2019-12-11', 164, NULL),
('Hotel deLuxe', 116, '2019-12-12', 323, NULL),
('Hotel deLuxe', 116, '2019-12-13', 351, NULL),
('Hotel deLuxe', 116, '2019-12-14', 395, NULL),
('Hotel deLuxe', 116, '2019-12-15', 128, NULL),
('Hotel deLuxe', 116, '2019-12-16', 282, NULL),
('Hotel deLuxe', 116, '2019-12-17', 169, NULL),
('Hotel deLuxe', 116, '2019-12-18', 177, NULL),
('Hotel deLuxe', 116, '2019-12-19', 289, NULL),
('Hotel deLuxe', 116, '2019-12-20', 327, NULL),
('Hotel deLuxe', 116, '2019-12-21', 263, NULL),
('Hotel deLuxe', 116, '2019-12-22', 140, NULL),
('Hotel deLuxe', 116, '2019-12-23', 396, NULL),
('Hotel deLuxe', 116, '2019-12-24', 266, NULL),
('Hotel deLuxe', 116, '2019-12-25', 366, NULL),
('Hotel deLuxe', 116, '2019-12-26', 248, NULL),
('Hotel deLuxe', 116, '2019-12-27', 242, NULL),
('Hotel deLuxe', 116, '2019-12-28', 221, NULL),
('Hotel deLuxe', 116, '2019-12-29', 170, NULL),
('Hotel deLuxe', 116, '2019-12-30', 173, NULL),
('Hotel deLuxe', 116, '2019-12-31', 376, NULL),
('Hotel deLuxe', 116, '2020-01-01', 356, NULL),
('Hotel deLuxe', 116, '2020-01-02', 195, NULL),
('Hotel deLuxe', 116, '2020-01-03', 303, NULL),
('Hotel deLuxe', 116, '2020-01-04', 227, NULL),
('Hotel deLuxe', 116, '2020-01-05', 261, NULL),
('Hotel deLuxe', 116, '2020-01-06', 392, NULL),
('Hotel deLuxe', 116, '2020-01-07', 145, NULL),
('Hotel deLuxe', 116, '2020-01-08', 168, NULL),
('Hotel deLuxe', 116, '2020-01-09', 283, NULL),
('Hotel deLuxe', 116, '2020-01-10', 305, NULL),
('Hotel deLuxe', 116, '2020-01-11', 340, NULL),
('Hotel deLuxe', 116, '2020-01-12', 224, NULL),
('Hotel deLuxe', 116, '2020-01-13', 227, NULL),
('Hotel deLuxe', 116, '2020-01-14', 227, NULL),
('Hotel deLuxe', 116, '2020-01-15', 324, NULL),
('Hotel deLuxe', 116, '2020-01-16', 378, NULL),
('Hotel deLuxe', 116, '2020-01-17', 248, NULL),
('Hotel deLuxe', 116, '2020-01-18', 182, NULL),
('Hotel deLuxe', 116, '2020-01-19', 273, NULL),
('Hotel deLuxe', 116, '2020-01-20', 316, NULL),
('Hotel deLuxe', 116, '2020-01-21', 206, NULL),
('Hotel deLuxe', 116, '2020-01-22', 358, NULL),
('Hotel deLuxe', 116, '2020-01-23', 205, NULL),
('Hotel deLuxe', 116, '2020-01-24', 172, NULL),
('Hotel deLuxe', 116, '2020-01-25', 342, NULL),
('Hotel deLuxe', 116, '2020-01-26', 114, NULL),
('Hotel deLuxe', 116, '2020-01-27', 319, NULL),
('Hotel deLuxe', 116, '2020-01-28', 392, NULL),
('Hotel deLuxe', 116, '2020-01-29', 247, NULL),
('Hotel deLuxe', 116, '2020-01-30', 355, NULL),
('Hotel deLuxe', 116, '2020-01-31', 378, NULL),
('Hotel deLuxe', 116, '2020-02-01', 316, NULL),
('Hotel deLuxe', 116, '2020-02-02', 272, NULL),
('Hotel deLuxe', 116, '2020-02-03', 235, NULL),
('Hotel deLuxe', 116, '2020-02-04', 392, NULL),
('Hotel deLuxe', 126, '2019-01-01', 109, NULL),
('Hotel deLuxe', 126, '2019-01-02', 245, NULL),
('Hotel deLuxe', 126, '2019-01-03', 132, NULL),
('Hotel deLuxe', 126, '2019-01-04', 163, NULL),
('Hotel deLuxe', 126, '2019-01-05', 251, NULL),
('Hotel deLuxe', 126, '2019-01-06', 395, NULL),
('Hotel deLuxe', 126, '2019-01-07', 198, NULL),
('Hotel deLuxe', 126, '2019-01-08', 211, NULL),
('Hotel deLuxe', 126, '2019-01-09', 191, NULL),
('Hotel deLuxe', 126, '2019-01-10', 311, NULL),
('Hotel deLuxe', 126, '2019-01-11', 240, NULL),
('Hotel deLuxe', 126, '2019-01-12', 188, NULL),
('Hotel deLuxe', 126, '2019-01-13', 220, NULL),
('Hotel deLuxe', 126, '2019-01-14', 135, NULL),
('Hotel deLuxe', 126, '2019-01-15', 231, NULL),
('Hotel deLuxe', 126, '2019-01-16', 366, NULL),
('Hotel deLuxe', 126, '2019-01-17', 284, NULL),
('Hotel deLuxe', 126, '2019-01-18', 336, NULL),
('Hotel deLuxe', 126, '2019-01-19', 336, NULL),
('Hotel deLuxe', 126, '2019-01-20', 259, NULL),
('Hotel deLuxe', 126, '2019-01-21', 139, NULL),
('Hotel deLuxe', 126, '2019-01-22', 137, NULL),
('Hotel deLuxe', 126, '2019-01-23', 381, NULL),
('Hotel deLuxe', 126, '2019-01-24', 293, NULL),
('Hotel deLuxe', 126, '2019-01-25', 222, NULL),
('Hotel deLuxe', 126, '2019-01-26', 303, NULL),
('Hotel deLuxe', 126, '2019-01-27', 330, NULL),
('Hotel deLuxe', 126, '2019-01-28', 394, NULL),
('Hotel deLuxe', 126, '2019-01-29', 260, NULL),
('Hotel deLuxe', 126, '2019-01-30', 321, NULL),
('Hotel deLuxe', 126, '2019-01-31', 276, NULL),
('Hotel deLuxe', 126, '2019-02-01', 190, NULL),
('Hotel deLuxe', 126, '2019-02-02', 235, NULL),
('Hotel deLuxe', 126, '2019-02-03', 226, NULL),
('Hotel deLuxe', 126, '2019-02-04', 341, NULL),
('Hotel deLuxe', 126, '2019-02-05', 294, NULL),
('Hotel deLuxe', 126, '2019-02-06', 327, NULL),
('Hotel deLuxe', 126, '2019-02-07', 113, NULL),
('Hotel deLuxe', 126, '2019-02-08', 366, NULL),
('Hotel deLuxe', 126, '2019-02-09', 126, NULL),
('Hotel deLuxe', 126, '2019-02-10', 146, NULL),
('Hotel deLuxe', 126, '2019-02-11', 380, NULL),
('Hotel deLuxe', 126, '2019-02-12', 142, NULL),
('Hotel deLuxe', 126, '2019-02-13', 257, NULL),
('Hotel deLuxe', 126, '2019-02-14', 393, NULL),
('Hotel deLuxe', 126, '2019-02-15', 126, NULL),
('Hotel deLuxe', 126, '2019-02-16', 124, NULL),
('Hotel deLuxe', 126, '2019-02-17', 213, NULL),
('Hotel deLuxe', 126, '2019-02-18', 105, NULL),
('Hotel deLuxe', 126, '2019-02-19', 208, NULL),
('Hotel deLuxe', 126, '2019-02-20', 110, NULL),
('Hotel deLuxe', 126, '2019-02-21', 316, NULL),
('Hotel deLuxe', 126, '2019-02-22', 101, NULL),
('Hotel deLuxe', 126, '2019-02-23', 235, NULL),
('Hotel deLuxe', 126, '2019-02-24', 104, NULL),
('Hotel deLuxe', 126, '2019-02-25', 362, NULL),
('Hotel deLuxe', 126, '2019-02-26', 348, NULL),
('Hotel deLuxe', 126, '2019-02-27', 306, NULL),
('Hotel deLuxe', 126, '2019-02-28', 336, NULL),
('Hotel deLuxe', 126, '2019-03-01', 359, NULL),
('Hotel deLuxe', 126, '2019-03-02', 246, NULL),
('Hotel deLuxe', 126, '2019-03-03', 113, NULL),
('Hotel deLuxe', 126, '2019-03-04', 169, NULL),
('Hotel deLuxe', 126, '2019-03-05', 107, NULL),
('Hotel deLuxe', 126, '2019-03-06', 282, NULL),
('Hotel deLuxe', 126, '2019-03-07', 258, NULL),
('Hotel deLuxe', 126, '2019-03-08', 335, NULL),
('Hotel deLuxe', 126, '2019-03-09', 126, NULL),
('Hotel deLuxe', 126, '2019-03-10', 141, NULL),
('Hotel deLuxe', 126, '2019-03-11', 209, NULL),
('Hotel deLuxe', 126, '2019-03-12', 121, NULL),
('Hotel deLuxe', 126, '2019-03-13', 264, NULL),
('Hotel deLuxe', 126, '2019-03-14', 154, NULL),
('Hotel deLuxe', 126, '2019-03-15', 112, NULL),
('Hotel deLuxe', 126, '2019-03-16', 245, NULL),
('Hotel deLuxe', 126, '2019-03-17', 156, NULL),
('Hotel deLuxe', 126, '2019-03-18', 351, NULL),
('Hotel deLuxe', 126, '2019-03-19', 132, NULL),
('Hotel deLuxe', 126, '2019-03-20', 346, NULL),
('Hotel deLuxe', 126, '2019-03-21', 111, NULL),
('Hotel deLuxe', 126, '2019-03-22', 257, NULL),
('Hotel deLuxe', 126, '2019-03-23', 327, NULL),
('Hotel deLuxe', 126, '2019-03-24', 153, NULL),
('Hotel deLuxe', 126, '2019-03-25', 194, NULL),
('Hotel deLuxe', 126, '2019-03-26', 390, NULL),
('Hotel deLuxe', 126, '2019-03-27', 176, NULL),
('Hotel deLuxe', 126, '2019-03-28', 315, NULL),
('Hotel deLuxe', 126, '2019-03-29', 117, NULL),
('Hotel deLuxe', 126, '2019-03-30', 365, NULL),
('Hotel deLuxe', 126, '2019-03-31', 257, NULL),
('Hotel deLuxe', 126, '2019-04-01', 398, NULL),
('Hotel deLuxe', 126, '2019-04-02', 331, NULL),
('Hotel deLuxe', 126, '2019-04-03', 203, NULL),
('Hotel deLuxe', 126, '2019-04-04', 218, NULL),
('Hotel deLuxe', 126, '2019-04-05', 129, NULL),
('Hotel deLuxe', 126, '2019-04-06', 318, NULL),
('Hotel deLuxe', 126, '2019-04-07', 292, NULL),
('Hotel deLuxe', 126, '2019-04-08', 202, NULL),
('Hotel deLuxe', 126, '2019-04-09', 396, NULL),
('Hotel deLuxe', 126, '2019-04-10', 204, NULL),
('Hotel deLuxe', 126, '2019-04-11', 254, NULL),
('Hotel deLuxe', 126, '2019-04-12', 170, NULL),
('Hotel deLuxe', 126, '2019-04-13', 155, NULL),
('Hotel deLuxe', 126, '2019-04-14', 388, NULL),
('Hotel deLuxe', 126, '2019-04-15', 235, NULL),
('Hotel deLuxe', 126, '2019-04-16', 207, NULL),
('Hotel deLuxe', 126, '2019-04-17', 250, NULL),
('Hotel deLuxe', 126, '2019-04-18', 233, NULL),
('Hotel deLuxe', 126, '2019-04-19', 376, NULL),
('Hotel deLuxe', 126, '2019-04-20', 259, NULL),
('Hotel deLuxe', 126, '2019-04-21', 253, NULL),
('Hotel deLuxe', 126, '2019-04-22', 157, NULL),
('Hotel deLuxe', 126, '2019-04-23', 116, NULL),
('Hotel deLuxe', 126, '2019-04-24', 167, NULL),
('Hotel deLuxe', 126, '2019-04-25', 349, NULL),
('Hotel deLuxe', 126, '2019-04-26', 338, NULL),
('Hotel deLuxe', 126, '2019-04-27', 350, NULL),
('Hotel deLuxe', 126, '2019-04-28', 385, NULL),
('Hotel deLuxe', 126, '2019-04-29', 341, NULL),
('Hotel deLuxe', 126, '2019-04-30', 302, NULL),
('Hotel deLuxe', 126, '2019-05-01', 155, NULL),
('Hotel deLuxe', 126, '2019-05-02', 308, NULL),
('Hotel deLuxe', 126, '2019-05-03', 121, NULL),
('Hotel deLuxe', 126, '2019-05-04', 302, NULL),
('Hotel deLuxe', 126, '2019-05-05', 221, NULL),
('Hotel deLuxe', 126, '2019-05-06', 349, NULL),
('Hotel deLuxe', 126, '2019-05-07', 289, NULL),
('Hotel deLuxe', 126, '2019-05-08', 315, NULL),
('Hotel deLuxe', 126, '2019-05-09', 262, NULL),
('Hotel deLuxe', 126, '2019-05-10', 341, NULL),
('Hotel deLuxe', 126, '2019-05-11', 248, NULL),
('Hotel deLuxe', 126, '2019-05-12', 220, NULL),
('Hotel deLuxe', 126, '2019-05-13', 244, NULL),
('Hotel deLuxe', 126, '2019-05-14', 254, NULL),
('Hotel deLuxe', 126, '2019-05-15', 190, NULL),
('Hotel deLuxe', 126, '2019-05-16', 375, NULL),
('Hotel deLuxe', 126, '2019-05-17', 288, NULL),
('Hotel deLuxe', 126, '2019-05-18', 370, NULL),
('Hotel deLuxe', 126, '2019-05-19', 277, NULL),
('Hotel deLuxe', 126, '2019-05-20', 193, NULL),
('Hotel deLuxe', 126, '2019-05-21', 203, NULL),
('Hotel deLuxe', 126, '2019-05-22', 275, NULL),
('Hotel deLuxe', 126, '2019-05-23', 254, NULL),
('Hotel deLuxe', 126, '2019-05-24', 149, NULL),
('Hotel deLuxe', 126, '2019-05-25', 112, NULL),
('Hotel deLuxe', 126, '2019-05-26', 273, NULL),
('Hotel deLuxe', 126, '2019-05-27', 359, NULL),
('Hotel deLuxe', 126, '2019-05-28', 260, NULL),
('Hotel deLuxe', 126, '2019-05-29', 107, NULL),
('Hotel deLuxe', 126, '2019-05-30', 264, NULL),
('Hotel deLuxe', 126, '2019-05-31', 335, NULL),
('Hotel deLuxe', 126, '2019-06-01', 172, NULL),
('Hotel deLuxe', 126, '2019-06-02', 224, NULL),
('Hotel deLuxe', 126, '2019-06-03', 251, NULL),
('Hotel deLuxe', 126, '2019-06-04', 308, NULL),
('Hotel deLuxe', 126, '2019-06-05', 196, NULL),
('Hotel deLuxe', 126, '2019-06-06', 122, NULL),
('Hotel deLuxe', 126, '2019-06-07', 151, NULL),
('Hotel deLuxe', 126, '2019-06-08', 368, NULL),
('Hotel deLuxe', 126, '2019-06-09', 308, NULL),
('Hotel deLuxe', 126, '2019-06-10', 373, NULL),
('Hotel deLuxe', 126, '2019-06-11', 192, NULL),
('Hotel deLuxe', 126, '2019-06-12', 245, NULL),
('Hotel deLuxe', 126, '2019-06-13', 332, NULL),
('Hotel deLuxe', 126, '2019-06-14', 301, NULL),
('Hotel deLuxe', 126, '2019-06-15', 127, NULL),
('Hotel deLuxe', 126, '2019-06-16', 279, NULL),
('Hotel deLuxe', 126, '2019-06-17', 322, NULL),
('Hotel deLuxe', 126, '2019-06-18', 230, NULL),
('Hotel deLuxe', 126, '2019-06-19', 107, NULL),
('Hotel deLuxe', 126, '2019-06-20', 320, NULL),
('Hotel deLuxe', 126, '2019-06-21', 370, NULL),
('Hotel deLuxe', 126, '2019-06-22', 231, NULL),
('Hotel deLuxe', 126, '2019-06-23', 345, NULL),
('Hotel deLuxe', 126, '2019-06-24', 370, NULL),
('Hotel deLuxe', 126, '2019-06-25', 195, NULL),
('Hotel deLuxe', 126, '2019-06-26', 340, NULL),
('Hotel deLuxe', 126, '2019-06-27', 174, NULL),
('Hotel deLuxe', 126, '2019-06-28', 304, NULL),
('Hotel deLuxe', 126, '2019-06-29', 238, NULL),
('Hotel deLuxe', 126, '2019-06-30', 212, NULL),
('Hotel deLuxe', 126, '2019-07-01', 151, NULL),
('Hotel deLuxe', 126, '2019-07-02', 397, NULL),
('Hotel deLuxe', 126, '2019-07-03', 197, NULL),
('Hotel deLuxe', 126, '2019-07-04', 268, NULL),
('Hotel deLuxe', 126, '2019-07-05', 292, NULL),
('Hotel deLuxe', 126, '2019-07-06', 348, NULL),
('Hotel deLuxe', 126, '2019-07-07', 151, NULL),
('Hotel deLuxe', 126, '2019-07-08', 393, NULL),
('Hotel deLuxe', 126, '2019-07-09', 128, NULL),
('Hotel deLuxe', 126, '2019-07-10', 322, NULL),
('Hotel deLuxe', 126, '2019-07-11', 163, NULL),
('Hotel deLuxe', 126, '2019-07-12', 335, NULL),
('Hotel deLuxe', 126, '2019-07-13', 303, NULL),
('Hotel deLuxe', 126, '2019-07-14', 276, NULL),
('Hotel deLuxe', 126, '2019-07-15', 347, NULL),
('Hotel deLuxe', 126, '2019-07-16', 338, NULL),
('Hotel deLuxe', 126, '2019-07-17', 200, NULL),
('Hotel deLuxe', 126, '2019-07-18', 201, NULL),
('Hotel deLuxe', 126, '2019-07-19', 190, NULL),
('Hotel deLuxe', 126, '2019-07-20', 118, NULL),
('Hotel deLuxe', 126, '2019-07-21', 349, NULL),
('Hotel deLuxe', 126, '2019-07-22', 228, NULL),
('Hotel deLuxe', 126, '2019-07-23', 170, NULL),
('Hotel deLuxe', 126, '2019-07-24', 274, NULL),
('Hotel deLuxe', 126, '2019-07-25', 126, NULL),
('Hotel deLuxe', 126, '2019-07-26', 101, NULL),
('Hotel deLuxe', 126, '2019-07-27', 123, NULL),
('Hotel deLuxe', 126, '2019-07-28', 348, NULL),
('Hotel deLuxe', 126, '2019-07-29', 186, NULL),
('Hotel deLuxe', 126, '2019-07-30', 265, NULL),
('Hotel deLuxe', 126, '2019-07-31', 287, NULL),
('Hotel deLuxe', 126, '2019-08-01', 247, NULL),
('Hotel deLuxe', 126, '2019-08-02', 390, NULL),
('Hotel deLuxe', 126, '2019-08-03', 181, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 126, '2019-08-04', 385, NULL),
('Hotel deLuxe', 126, '2019-08-05', 126, NULL),
('Hotel deLuxe', 126, '2019-08-06', 261, NULL),
('Hotel deLuxe', 126, '2019-08-07', 307, NULL),
('Hotel deLuxe', 126, '2019-08-08', 280, NULL),
('Hotel deLuxe', 126, '2019-08-09', 258, NULL),
('Hotel deLuxe', 126, '2019-08-10', 208, NULL),
('Hotel deLuxe', 126, '2019-08-11', 113, NULL),
('Hotel deLuxe', 126, '2019-08-12', 117, NULL),
('Hotel deLuxe', 126, '2019-08-13', 166, NULL),
('Hotel deLuxe', 126, '2019-08-14', 245, NULL),
('Hotel deLuxe', 126, '2019-08-15', 166, NULL),
('Hotel deLuxe', 126, '2019-08-16', 303, NULL),
('Hotel deLuxe', 126, '2019-08-17', 336, NULL),
('Hotel deLuxe', 126, '2019-08-18', 128, NULL),
('Hotel deLuxe', 126, '2019-08-19', 151, NULL),
('Hotel deLuxe', 126, '2019-08-20', 362, NULL),
('Hotel deLuxe', 126, '2019-08-21', 255, NULL),
('Hotel deLuxe', 126, '2019-08-22', 399, NULL),
('Hotel deLuxe', 126, '2019-08-23', 354, NULL),
('Hotel deLuxe', 126, '2019-08-24', 314, NULL),
('Hotel deLuxe', 126, '2019-08-25', 281, NULL),
('Hotel deLuxe', 126, '2019-08-26', 192, NULL),
('Hotel deLuxe', 126, '2019-08-27', 366, NULL),
('Hotel deLuxe', 126, '2019-08-28', 146, NULL),
('Hotel deLuxe', 126, '2019-08-29', 180, NULL),
('Hotel deLuxe', 126, '2019-08-30', 377, NULL),
('Hotel deLuxe', 126, '2019-08-31', 236, NULL),
('Hotel deLuxe', 126, '2019-09-01', 113, NULL),
('Hotel deLuxe', 126, '2019-09-02', 229, NULL),
('Hotel deLuxe', 126, '2019-09-03', 288, NULL),
('Hotel deLuxe', 126, '2019-09-04', 199, NULL),
('Hotel deLuxe', 126, '2019-09-05', 243, NULL),
('Hotel deLuxe', 126, '2019-09-06', 156, NULL),
('Hotel deLuxe', 126, '2019-09-07', 119, NULL),
('Hotel deLuxe', 126, '2019-09-08', 200, NULL),
('Hotel deLuxe', 126, '2019-09-09', 266, NULL),
('Hotel deLuxe', 126, '2019-09-10', 183, NULL),
('Hotel deLuxe', 126, '2019-09-11', 305, NULL),
('Hotel deLuxe', 126, '2019-09-12', 206, NULL),
('Hotel deLuxe', 126, '2019-09-13', 253, NULL),
('Hotel deLuxe', 126, '2019-09-14', 249, NULL),
('Hotel deLuxe', 126, '2019-09-15', 241, NULL),
('Hotel deLuxe', 126, '2019-09-16', 176, NULL),
('Hotel deLuxe', 126, '2019-09-17', 209, NULL),
('Hotel deLuxe', 126, '2019-09-18', 306, NULL),
('Hotel deLuxe', 126, '2019-09-19', 277, NULL),
('Hotel deLuxe', 126, '2019-09-20', 256, NULL),
('Hotel deLuxe', 126, '2019-09-21', 306, NULL),
('Hotel deLuxe', 126, '2019-09-22', 285, NULL),
('Hotel deLuxe', 126, '2019-09-23', 351, NULL),
('Hotel deLuxe', 126, '2019-09-24', 297, NULL),
('Hotel deLuxe', 126, '2019-09-25', 261, NULL),
('Hotel deLuxe', 126, '2019-09-26', 314, NULL),
('Hotel deLuxe', 126, '2019-09-27', 343, NULL),
('Hotel deLuxe', 126, '2019-09-28', 271, NULL),
('Hotel deLuxe', 126, '2019-09-29', 245, NULL),
('Hotel deLuxe', 126, '2019-09-30', 288, NULL),
('Hotel deLuxe', 126, '2019-10-01', 356, NULL),
('Hotel deLuxe', 126, '2019-10-02', 186, NULL),
('Hotel deLuxe', 126, '2019-10-03', 147, NULL),
('Hotel deLuxe', 126, '2019-10-04', 228, NULL),
('Hotel deLuxe', 126, '2019-10-05', 195, NULL),
('Hotel deLuxe', 126, '2019-10-06', 115, NULL),
('Hotel deLuxe', 126, '2019-10-07', 168, NULL),
('Hotel deLuxe', 126, '2019-10-08', 156, NULL),
('Hotel deLuxe', 126, '2019-10-09', 212, NULL),
('Hotel deLuxe', 126, '2019-10-10', 310, NULL),
('Hotel deLuxe', 126, '2019-10-11', 118, NULL),
('Hotel deLuxe', 126, '2019-10-12', 342, NULL),
('Hotel deLuxe', 126, '2019-10-13', 363, NULL),
('Hotel deLuxe', 126, '2019-10-14', 322, NULL),
('Hotel deLuxe', 126, '2019-10-15', 270, NULL),
('Hotel deLuxe', 126, '2019-10-16', 376, NULL),
('Hotel deLuxe', 126, '2019-10-17', 167, NULL),
('Hotel deLuxe', 126, '2019-10-18', 398, NULL),
('Hotel deLuxe', 126, '2019-10-19', 256, NULL),
('Hotel deLuxe', 126, '2019-10-20', 363, NULL),
('Hotel deLuxe', 126, '2019-10-21', 278, NULL),
('Hotel deLuxe', 126, '2019-10-22', 320, NULL),
('Hotel deLuxe', 126, '2019-10-23', 276, NULL),
('Hotel deLuxe', 126, '2019-10-24', 215, NULL),
('Hotel deLuxe', 126, '2019-10-25', 105, NULL),
('Hotel deLuxe', 126, '2019-10-26', 354, NULL),
('Hotel deLuxe', 126, '2019-10-27', 334, NULL),
('Hotel deLuxe', 126, '2019-10-28', 266, NULL),
('Hotel deLuxe', 126, '2019-10-29', 138, NULL),
('Hotel deLuxe', 126, '2019-10-30', 233, NULL),
('Hotel deLuxe', 126, '2019-10-31', 326, NULL),
('Hotel deLuxe', 126, '2019-11-01', 131, NULL),
('Hotel deLuxe', 126, '2019-11-02', 316, NULL),
('Hotel deLuxe', 126, '2019-11-03', 255, NULL),
('Hotel deLuxe', 126, '2019-11-04', 220, NULL),
('Hotel deLuxe', 126, '2019-11-05', 170, NULL),
('Hotel deLuxe', 126, '2019-11-06', 158, NULL),
('Hotel deLuxe', 126, '2019-11-07', 170, NULL),
('Hotel deLuxe', 126, '2019-11-08', 143, NULL),
('Hotel deLuxe', 126, '2019-11-09', 268, NULL),
('Hotel deLuxe', 126, '2019-11-10', 150, NULL),
('Hotel deLuxe', 126, '2019-11-11', 385, NULL),
('Hotel deLuxe', 126, '2019-11-12', 170, NULL),
('Hotel deLuxe', 126, '2019-11-13', 396, NULL),
('Hotel deLuxe', 126, '2019-11-14', 133, NULL),
('Hotel deLuxe', 126, '2019-11-15', 259, NULL),
('Hotel deLuxe', 126, '2019-11-16', 376, NULL),
('Hotel deLuxe', 126, '2019-11-17', 296, NULL),
('Hotel deLuxe', 126, '2019-11-18', 313, NULL),
('Hotel deLuxe', 126, '2019-11-19', 389, NULL),
('Hotel deLuxe', 126, '2019-11-20', 314, NULL),
('Hotel deLuxe', 126, '2019-11-21', 318, NULL),
('Hotel deLuxe', 126, '2019-11-22', 155, NULL),
('Hotel deLuxe', 126, '2019-11-23', 201, NULL),
('Hotel deLuxe', 126, '2019-11-24', 311, NULL),
('Hotel deLuxe', 126, '2019-11-25', 203, NULL),
('Hotel deLuxe', 126, '2019-11-26', 281, NULL),
('Hotel deLuxe', 126, '2019-11-27', 288, NULL),
('Hotel deLuxe', 126, '2019-11-28', 103, NULL),
('Hotel deLuxe', 126, '2019-11-29', 143, NULL),
('Hotel deLuxe', 126, '2019-11-30', 366, NULL),
('Hotel deLuxe', 126, '2019-12-01', 170, NULL),
('Hotel deLuxe', 126, '2019-12-02', 134, NULL),
('Hotel deLuxe', 126, '2019-12-03', 248, NULL),
('Hotel deLuxe', 126, '2019-12-04', 265, NULL),
('Hotel deLuxe', 126, '2019-12-05', 323, NULL),
('Hotel deLuxe', 126, '2019-12-06', 340, NULL),
('Hotel deLuxe', 126, '2019-12-07', 251, NULL),
('Hotel deLuxe', 126, '2019-12-08', 100, NULL),
('Hotel deLuxe', 126, '2019-12-09', 133, NULL),
('Hotel deLuxe', 126, '2019-12-10', 122, NULL),
('Hotel deLuxe', 126, '2019-12-11', 187, NULL),
('Hotel deLuxe', 126, '2019-12-12', 272, NULL),
('Hotel deLuxe', 126, '2019-12-13', 194, NULL),
('Hotel deLuxe', 126, '2019-12-14', 109, NULL),
('Hotel deLuxe', 126, '2019-12-15', 283, NULL),
('Hotel deLuxe', 126, '2019-12-16', 250, NULL),
('Hotel deLuxe', 126, '2019-12-17', 335, NULL),
('Hotel deLuxe', 126, '2019-12-18', 211, NULL),
('Hotel deLuxe', 126, '2019-12-19', 277, NULL),
('Hotel deLuxe', 126, '2019-12-20', 242, NULL),
('Hotel deLuxe', 126, '2019-12-21', 135, NULL),
('Hotel deLuxe', 126, '2019-12-22', 273, NULL),
('Hotel deLuxe', 126, '2019-12-23', 259, NULL),
('Hotel deLuxe', 126, '2019-12-24', 269, NULL),
('Hotel deLuxe', 126, '2019-12-25', 336, NULL),
('Hotel deLuxe', 126, '2019-12-26', 381, NULL),
('Hotel deLuxe', 126, '2019-12-27', 277, NULL),
('Hotel deLuxe', 126, '2019-12-28', 267, NULL),
('Hotel deLuxe', 126, '2019-12-29', 216, NULL),
('Hotel deLuxe', 126, '2019-12-30', 272, NULL),
('Hotel deLuxe', 126, '2019-12-31', 298, NULL),
('Hotel deLuxe', 126, '2020-01-01', 157, NULL),
('Hotel deLuxe', 126, '2020-01-02', 327, NULL),
('Hotel deLuxe', 126, '2020-01-03', 147, NULL),
('Hotel deLuxe', 126, '2020-01-04', 251, NULL),
('Hotel deLuxe', 126, '2020-01-05', 265, NULL),
('Hotel deLuxe', 126, '2020-01-06', 102, NULL),
('Hotel deLuxe', 126, '2020-01-07', 369, NULL),
('Hotel deLuxe', 126, '2020-01-08', 221, NULL),
('Hotel deLuxe', 126, '2020-01-09', 392, NULL),
('Hotel deLuxe', 126, '2020-01-10', 152, NULL),
('Hotel deLuxe', 126, '2020-01-11', 207, NULL),
('Hotel deLuxe', 126, '2020-01-12', 125, NULL),
('Hotel deLuxe', 126, '2020-01-13', 387, NULL),
('Hotel deLuxe', 126, '2020-01-14', 194, NULL),
('Hotel deLuxe', 126, '2020-01-15', 394, NULL),
('Hotel deLuxe', 126, '2020-01-16', 204, NULL),
('Hotel deLuxe', 126, '2020-01-17', 359, NULL),
('Hotel deLuxe', 126, '2020-01-18', 251, NULL),
('Hotel deLuxe', 126, '2020-01-19', 364, NULL),
('Hotel deLuxe', 126, '2020-01-20', 350, NULL),
('Hotel deLuxe', 126, '2020-01-21', 240, NULL),
('Hotel deLuxe', 126, '2020-01-22', 234, NULL),
('Hotel deLuxe', 126, '2020-01-23', 317, NULL),
('Hotel deLuxe', 126, '2020-01-24', 191, NULL),
('Hotel deLuxe', 126, '2020-01-25', 354, NULL),
('Hotel deLuxe', 126, '2020-01-26', 289, NULL),
('Hotel deLuxe', 126, '2020-01-27', 153, NULL),
('Hotel deLuxe', 126, '2020-01-28', 170, NULL),
('Hotel deLuxe', 126, '2020-01-29', 236, NULL),
('Hotel deLuxe', 126, '2020-01-30', 328, NULL),
('Hotel deLuxe', 126, '2020-01-31', 331, NULL),
('Hotel deLuxe', 126, '2020-02-01', 375, NULL),
('Hotel deLuxe', 126, '2020-02-02', 287, NULL),
('Hotel deLuxe', 126, '2020-02-03', 271, NULL),
('Hotel deLuxe', 126, '2020-02-04', 206, NULL),
('Hotel deLuxe', 131, '2019-01-01', 210, NULL),
('Hotel deLuxe', 131, '2019-01-02', 282, NULL),
('Hotel deLuxe', 131, '2019-01-03', 145, NULL),
('Hotel deLuxe', 131, '2019-01-04', 173, NULL),
('Hotel deLuxe', 131, '2019-01-05', 186, NULL),
('Hotel deLuxe', 131, '2019-01-06', 184, NULL),
('Hotel deLuxe', 131, '2019-01-07', 377, NULL),
('Hotel deLuxe', 131, '2019-01-08', 230, NULL),
('Hotel deLuxe', 131, '2019-01-09', 346, NULL),
('Hotel deLuxe', 131, '2019-01-10', 380, NULL),
('Hotel deLuxe', 131, '2019-01-11', 104, NULL),
('Hotel deLuxe', 131, '2019-01-12', 226, NULL),
('Hotel deLuxe', 131, '2019-01-13', 154, NULL),
('Hotel deLuxe', 131, '2019-01-14', 187, NULL),
('Hotel deLuxe', 131, '2019-01-15', 309, NULL),
('Hotel deLuxe', 131, '2019-01-16', 137, NULL),
('Hotel deLuxe', 131, '2019-01-17', 397, NULL),
('Hotel deLuxe', 131, '2019-01-18', 244, NULL),
('Hotel deLuxe', 131, '2019-01-19', 292, NULL),
('Hotel deLuxe', 131, '2019-01-20', 381, NULL),
('Hotel deLuxe', 131, '2019-01-21', 381, NULL),
('Hotel deLuxe', 131, '2019-01-22', 398, NULL),
('Hotel deLuxe', 131, '2019-01-23', 199, NULL),
('Hotel deLuxe', 131, '2019-01-24', 172, NULL),
('Hotel deLuxe', 131, '2019-01-25', 285, NULL),
('Hotel deLuxe', 131, '2019-01-26', 354, NULL),
('Hotel deLuxe', 131, '2019-01-27', 288, NULL),
('Hotel deLuxe', 131, '2019-01-28', 319, NULL),
('Hotel deLuxe', 131, '2019-01-29', 298, NULL),
('Hotel deLuxe', 131, '2019-01-30', 195, NULL),
('Hotel deLuxe', 131, '2019-01-31', 131, NULL),
('Hotel deLuxe', 131, '2019-02-01', 188, NULL),
('Hotel deLuxe', 131, '2019-02-02', 351, NULL),
('Hotel deLuxe', 131, '2019-02-03', 278, NULL),
('Hotel deLuxe', 131, '2019-02-04', 384, NULL),
('Hotel deLuxe', 131, '2019-02-05', 193, NULL),
('Hotel deLuxe', 131, '2019-02-06', 242, NULL),
('Hotel deLuxe', 131, '2019-02-07', 120, NULL),
('Hotel deLuxe', 131, '2019-02-08', 101, NULL),
('Hotel deLuxe', 131, '2019-02-09', 265, NULL),
('Hotel deLuxe', 131, '2019-02-10', 259, NULL),
('Hotel deLuxe', 131, '2019-02-11', 359, NULL),
('Hotel deLuxe', 131, '2019-02-12', 272, NULL),
('Hotel deLuxe', 131, '2019-02-13', 110, NULL),
('Hotel deLuxe', 131, '2019-02-14', 277, NULL),
('Hotel deLuxe', 131, '2019-02-15', 217, NULL),
('Hotel deLuxe', 131, '2019-02-16', 265, NULL),
('Hotel deLuxe', 131, '2019-02-17', 361, NULL),
('Hotel deLuxe', 131, '2019-02-18', 328, NULL),
('Hotel deLuxe', 131, '2019-02-19', 325, NULL),
('Hotel deLuxe', 131, '2019-02-20', 246, NULL),
('Hotel deLuxe', 131, '2019-02-21', 379, NULL),
('Hotel deLuxe', 131, '2019-02-22', 287, NULL),
('Hotel deLuxe', 131, '2019-02-23', 388, NULL),
('Hotel deLuxe', 131, '2019-02-24', 134, NULL),
('Hotel deLuxe', 131, '2019-02-25', 379, NULL),
('Hotel deLuxe', 131, '2019-02-26', 315, NULL),
('Hotel deLuxe', 131, '2019-02-27', 174, NULL),
('Hotel deLuxe', 131, '2019-02-28', 298, NULL),
('Hotel deLuxe', 131, '2019-03-01', 150, NULL),
('Hotel deLuxe', 131, '2019-03-02', 144, NULL),
('Hotel deLuxe', 131, '2019-03-03', 173, NULL),
('Hotel deLuxe', 131, '2019-03-04', 130, NULL),
('Hotel deLuxe', 131, '2019-03-05', 213, NULL),
('Hotel deLuxe', 131, '2019-03-06', 260, NULL),
('Hotel deLuxe', 131, '2019-03-07', 306, NULL),
('Hotel deLuxe', 131, '2019-03-08', 279, NULL),
('Hotel deLuxe', 131, '2019-03-09', 370, NULL),
('Hotel deLuxe', 131, '2019-03-10', 138, NULL),
('Hotel deLuxe', 131, '2019-03-11', 278, NULL),
('Hotel deLuxe', 131, '2019-03-12', 116, NULL),
('Hotel deLuxe', 131, '2019-03-13', 100, NULL),
('Hotel deLuxe', 131, '2019-03-14', 193, NULL),
('Hotel deLuxe', 131, '2019-03-15', 231, NULL),
('Hotel deLuxe', 131, '2019-03-16', 373, NULL),
('Hotel deLuxe', 131, '2019-03-17', 162, NULL),
('Hotel deLuxe', 131, '2019-03-18', 347, NULL),
('Hotel deLuxe', 131, '2019-03-19', 291, NULL),
('Hotel deLuxe', 131, '2019-03-20', 154, NULL),
('Hotel deLuxe', 131, '2019-03-21', 345, NULL),
('Hotel deLuxe', 131, '2019-03-22', 195, NULL),
('Hotel deLuxe', 131, '2019-03-23', 310, NULL),
('Hotel deLuxe', 131, '2019-03-24', 282, NULL),
('Hotel deLuxe', 131, '2019-03-25', 219, NULL),
('Hotel deLuxe', 131, '2019-03-26', 107, NULL),
('Hotel deLuxe', 131, '2019-03-27', 328, NULL),
('Hotel deLuxe', 131, '2019-03-28', 143, NULL),
('Hotel deLuxe', 131, '2019-03-29', 233, NULL),
('Hotel deLuxe', 131, '2019-03-30', 364, NULL),
('Hotel deLuxe', 131, '2019-03-31', 150, NULL),
('Hotel deLuxe', 131, '2019-04-01', 135, NULL),
('Hotel deLuxe', 131, '2019-04-02', 144, NULL),
('Hotel deLuxe', 131, '2019-04-03', 358, NULL),
('Hotel deLuxe', 131, '2019-04-04', 166, NULL),
('Hotel deLuxe', 131, '2019-04-05', 230, NULL),
('Hotel deLuxe', 131, '2019-04-06', 119, NULL),
('Hotel deLuxe', 131, '2019-04-07', 312, NULL),
('Hotel deLuxe', 131, '2019-04-08', 327, NULL),
('Hotel deLuxe', 131, '2019-04-09', 190, NULL),
('Hotel deLuxe', 131, '2019-04-10', 178, NULL),
('Hotel deLuxe', 131, '2019-04-11', 199, NULL),
('Hotel deLuxe', 131, '2019-04-12', 190, NULL),
('Hotel deLuxe', 131, '2019-04-13', 309, NULL),
('Hotel deLuxe', 131, '2019-04-14', 356, NULL),
('Hotel deLuxe', 131, '2019-04-15', 375, NULL),
('Hotel deLuxe', 131, '2019-04-16', 181, NULL),
('Hotel deLuxe', 131, '2019-04-17', 336, NULL),
('Hotel deLuxe', 131, '2019-04-18', 197, NULL),
('Hotel deLuxe', 131, '2019-04-19', 239, NULL),
('Hotel deLuxe', 131, '2019-04-20', 388, NULL),
('Hotel deLuxe', 131, '2019-04-21', 217, NULL),
('Hotel deLuxe', 131, '2019-04-22', 359, NULL),
('Hotel deLuxe', 131, '2019-04-23', 398, NULL),
('Hotel deLuxe', 131, '2019-04-24', 137, NULL),
('Hotel deLuxe', 131, '2019-04-25', 101, NULL),
('Hotel deLuxe', 131, '2019-04-26', 368, NULL),
('Hotel deLuxe', 131, '2019-04-27', 194, NULL),
('Hotel deLuxe', 131, '2019-04-28', 145, NULL),
('Hotel deLuxe', 131, '2019-04-29', 364, NULL),
('Hotel deLuxe', 131, '2019-04-30', 214, NULL),
('Hotel deLuxe', 131, '2019-05-01', 129, NULL),
('Hotel deLuxe', 131, '2019-05-02', 231, NULL),
('Hotel deLuxe', 131, '2019-05-03', 319, NULL),
('Hotel deLuxe', 131, '2019-05-04', 158, NULL),
('Hotel deLuxe', 131, '2019-05-05', 331, NULL),
('Hotel deLuxe', 131, '2019-05-06', 386, NULL),
('Hotel deLuxe', 131, '2019-05-07', 185, NULL),
('Hotel deLuxe', 131, '2019-05-08', 375, NULL),
('Hotel deLuxe', 131, '2019-05-09', 380, NULL),
('Hotel deLuxe', 131, '2019-05-10', 335, NULL),
('Hotel deLuxe', 131, '2019-05-11', 348, NULL),
('Hotel deLuxe', 131, '2019-05-12', 116, NULL),
('Hotel deLuxe', 131, '2019-05-13', 188, NULL),
('Hotel deLuxe', 131, '2019-05-14', 286, NULL),
('Hotel deLuxe', 131, '2019-05-15', 262, NULL),
('Hotel deLuxe', 131, '2019-05-16', 298, NULL),
('Hotel deLuxe', 131, '2019-05-17', 201, NULL),
('Hotel deLuxe', 131, '2019-05-18', 241, NULL),
('Hotel deLuxe', 131, '2019-05-19', 361, NULL),
('Hotel deLuxe', 131, '2019-05-20', 205, NULL),
('Hotel deLuxe', 131, '2019-05-21', 154, NULL),
('Hotel deLuxe', 131, '2019-05-22', 399, NULL),
('Hotel deLuxe', 131, '2019-05-23', 295, NULL),
('Hotel deLuxe', 131, '2019-05-24', 182, NULL),
('Hotel deLuxe', 131, '2019-05-25', 124, NULL),
('Hotel deLuxe', 131, '2019-05-26', 136, NULL),
('Hotel deLuxe', 131, '2019-05-27', 212, NULL),
('Hotel deLuxe', 131, '2019-05-28', 309, NULL),
('Hotel deLuxe', 131, '2019-05-29', 334, NULL),
('Hotel deLuxe', 131, '2019-05-30', 100, NULL),
('Hotel deLuxe', 131, '2019-05-31', 243, NULL),
('Hotel deLuxe', 131, '2019-06-01', 334, NULL),
('Hotel deLuxe', 131, '2019-06-02', 217, NULL),
('Hotel deLuxe', 131, '2019-06-03', 246, NULL),
('Hotel deLuxe', 131, '2019-06-04', 175, NULL),
('Hotel deLuxe', 131, '2019-06-05', 363, NULL),
('Hotel deLuxe', 131, '2019-06-06', 224, NULL),
('Hotel deLuxe', 131, '2019-06-07', 135, NULL),
('Hotel deLuxe', 131, '2019-06-08', 392, NULL),
('Hotel deLuxe', 131, '2019-06-09', 152, NULL),
('Hotel deLuxe', 131, '2019-06-10', 181, NULL),
('Hotel deLuxe', 131, '2019-06-11', 309, NULL),
('Hotel deLuxe', 131, '2019-06-12', 192, NULL),
('Hotel deLuxe', 131, '2019-06-13', 347, NULL),
('Hotel deLuxe', 131, '2019-06-14', 291, NULL),
('Hotel deLuxe', 131, '2019-06-15', 293, NULL),
('Hotel deLuxe', 131, '2019-06-16', 252, NULL),
('Hotel deLuxe', 131, '2019-06-17', 290, NULL),
('Hotel deLuxe', 131, '2019-06-18', 270, NULL),
('Hotel deLuxe', 131, '2019-06-19', 230, NULL),
('Hotel deLuxe', 131, '2019-06-20', 101, NULL),
('Hotel deLuxe', 131, '2019-06-21', 274, NULL),
('Hotel deLuxe', 131, '2019-06-22', 345, NULL),
('Hotel deLuxe', 131, '2019-06-23', 237, NULL),
('Hotel deLuxe', 131, '2019-06-24', 109, NULL),
('Hotel deLuxe', 131, '2019-06-25', 222, NULL),
('Hotel deLuxe', 131, '2019-06-26', 344, NULL),
('Hotel deLuxe', 131, '2019-06-27', 370, NULL),
('Hotel deLuxe', 131, '2019-06-28', 384, NULL),
('Hotel deLuxe', 131, '2019-06-29', 238, NULL),
('Hotel deLuxe', 131, '2019-06-30', 156, NULL),
('Hotel deLuxe', 131, '2019-07-01', 252, NULL),
('Hotel deLuxe', 131, '2019-07-02', 146, NULL),
('Hotel deLuxe', 131, '2019-07-03', 109, NULL),
('Hotel deLuxe', 131, '2019-07-04', 301, NULL),
('Hotel deLuxe', 131, '2019-07-05', 293, NULL),
('Hotel deLuxe', 131, '2019-07-06', 342, NULL),
('Hotel deLuxe', 131, '2019-07-07', 174, NULL),
('Hotel deLuxe', 131, '2019-07-08', 322, NULL),
('Hotel deLuxe', 131, '2019-07-09', 211, NULL),
('Hotel deLuxe', 131, '2019-07-10', 118, NULL),
('Hotel deLuxe', 131, '2019-07-11', 145, NULL),
('Hotel deLuxe', 131, '2019-07-12', 256, NULL),
('Hotel deLuxe', 131, '2019-07-13', 305, NULL),
('Hotel deLuxe', 131, '2019-07-14', 283, NULL),
('Hotel deLuxe', 131, '2019-07-15', 263, NULL),
('Hotel deLuxe', 131, '2019-07-16', 372, NULL),
('Hotel deLuxe', 131, '2019-07-17', 299, NULL),
('Hotel deLuxe', 131, '2019-07-18', 152, NULL),
('Hotel deLuxe', 131, '2019-07-19', 326, NULL),
('Hotel deLuxe', 131, '2019-07-20', 182, NULL),
('Hotel deLuxe', 131, '2019-07-21', 393, NULL),
('Hotel deLuxe', 131, '2019-07-22', 379, NULL),
('Hotel deLuxe', 131, '2019-07-23', 255, NULL),
('Hotel deLuxe', 131, '2019-07-24', 258, NULL),
('Hotel deLuxe', 131, '2019-07-25', 210, NULL),
('Hotel deLuxe', 131, '2019-07-26', 227, NULL),
('Hotel deLuxe', 131, '2019-07-27', 375, NULL),
('Hotel deLuxe', 131, '2019-07-28', 204, NULL),
('Hotel deLuxe', 131, '2019-07-29', 332, NULL),
('Hotel deLuxe', 131, '2019-07-30', 190, NULL),
('Hotel deLuxe', 131, '2019-07-31', 175, NULL),
('Hotel deLuxe', 131, '2019-08-01', 208, NULL),
('Hotel deLuxe', 131, '2019-08-02', 314, NULL),
('Hotel deLuxe', 131, '2019-08-03', 223, NULL),
('Hotel deLuxe', 131, '2019-08-04', 201, NULL),
('Hotel deLuxe', 131, '2019-08-05', 227, NULL),
('Hotel deLuxe', 131, '2019-08-06', 262, NULL),
('Hotel deLuxe', 131, '2019-08-07', 203, NULL),
('Hotel deLuxe', 131, '2019-08-08', 272, NULL),
('Hotel deLuxe', 131, '2019-08-09', 245, NULL),
('Hotel deLuxe', 131, '2019-08-10', 132, NULL),
('Hotel deLuxe', 131, '2019-08-11', 303, NULL),
('Hotel deLuxe', 131, '2019-08-12', 217, NULL),
('Hotel deLuxe', 131, '2019-08-13', 170, NULL),
('Hotel deLuxe', 131, '2019-08-14', 213, NULL),
('Hotel deLuxe', 131, '2019-08-15', 219, NULL),
('Hotel deLuxe', 131, '2019-08-16', 392, NULL),
('Hotel deLuxe', 131, '2019-08-17', 196, NULL),
('Hotel deLuxe', 131, '2019-08-18', 105, NULL),
('Hotel deLuxe', 131, '2019-08-19', 193, NULL),
('Hotel deLuxe', 131, '2019-08-20', 307, NULL),
('Hotel deLuxe', 131, '2019-08-21', 205, NULL),
('Hotel deLuxe', 131, '2019-08-22', 374, NULL),
('Hotel deLuxe', 131, '2019-08-23', 356, NULL),
('Hotel deLuxe', 131, '2019-08-24', 258, NULL),
('Hotel deLuxe', 131, '2019-08-25', 218, NULL),
('Hotel deLuxe', 131, '2019-08-26', 266, NULL),
('Hotel deLuxe', 131, '2019-08-27', 139, NULL),
('Hotel deLuxe', 131, '2019-08-28', 161, NULL),
('Hotel deLuxe', 131, '2019-08-29', 113, NULL),
('Hotel deLuxe', 131, '2019-08-30', 331, NULL),
('Hotel deLuxe', 131, '2019-08-31', 308, NULL),
('Hotel deLuxe', 131, '2019-09-01', 142, NULL),
('Hotel deLuxe', 131, '2019-09-02', 361, NULL),
('Hotel deLuxe', 131, '2019-09-03', 209, NULL),
('Hotel deLuxe', 131, '2019-09-04', 262, NULL),
('Hotel deLuxe', 131, '2019-09-05', 147, NULL),
('Hotel deLuxe', 131, '2019-09-06', 171, NULL),
('Hotel deLuxe', 131, '2019-09-07', 232, NULL),
('Hotel deLuxe', 131, '2019-09-08', 218, NULL),
('Hotel deLuxe', 131, '2019-09-09', 176, NULL),
('Hotel deLuxe', 131, '2019-09-10', 200, NULL),
('Hotel deLuxe', 131, '2019-09-11', 293, NULL),
('Hotel deLuxe', 131, '2019-09-12', 104, NULL),
('Hotel deLuxe', 131, '2019-09-13', 317, NULL),
('Hotel deLuxe', 131, '2019-09-14', 340, NULL),
('Hotel deLuxe', 131, '2019-09-15', 341, NULL),
('Hotel deLuxe', 131, '2019-09-16', 352, NULL),
('Hotel deLuxe', 131, '2019-09-17', 362, NULL),
('Hotel deLuxe', 131, '2019-09-18', 104, NULL),
('Hotel deLuxe', 131, '2019-09-19', 127, NULL),
('Hotel deLuxe', 131, '2019-09-20', 273, NULL),
('Hotel deLuxe', 131, '2019-09-21', 344, NULL),
('Hotel deLuxe', 131, '2019-09-22', 346, NULL),
('Hotel deLuxe', 131, '2019-09-23', 143, NULL),
('Hotel deLuxe', 131, '2019-09-24', 199, NULL),
('Hotel deLuxe', 131, '2019-09-25', 132, NULL),
('Hotel deLuxe', 131, '2019-09-26', 149, NULL),
('Hotel deLuxe', 131, '2019-09-27', 349, NULL),
('Hotel deLuxe', 131, '2019-09-28', 320, NULL),
('Hotel deLuxe', 131, '2019-09-29', 357, NULL),
('Hotel deLuxe', 131, '2019-09-30', 349, NULL),
('Hotel deLuxe', 131, '2019-10-01', 277, NULL),
('Hotel deLuxe', 131, '2019-10-02', 344, NULL),
('Hotel deLuxe', 131, '2019-10-03', 150, NULL),
('Hotel deLuxe', 131, '2019-10-04', 260, NULL),
('Hotel deLuxe', 131, '2019-10-05', 130, NULL),
('Hotel deLuxe', 131, '2019-10-06', 270, NULL),
('Hotel deLuxe', 131, '2019-10-07', 187, NULL),
('Hotel deLuxe', 131, '2019-10-08', 250, NULL),
('Hotel deLuxe', 131, '2019-10-09', 198, NULL),
('Hotel deLuxe', 131, '2019-10-10', 159, NULL),
('Hotel deLuxe', 131, '2019-10-11', 389, NULL),
('Hotel deLuxe', 131, '2019-10-12', 385, NULL),
('Hotel deLuxe', 131, '2019-10-13', 311, NULL),
('Hotel deLuxe', 131, '2019-10-14', 131, NULL),
('Hotel deLuxe', 131, '2019-10-15', 390, NULL),
('Hotel deLuxe', 131, '2019-10-16', 241, NULL),
('Hotel deLuxe', 131, '2019-10-17', 354, NULL),
('Hotel deLuxe', 131, '2019-10-18', 134, NULL),
('Hotel deLuxe', 131, '2019-10-19', 379, NULL),
('Hotel deLuxe', 131, '2019-10-20', 356, NULL),
('Hotel deLuxe', 131, '2019-10-21', 228, NULL),
('Hotel deLuxe', 131, '2019-10-22', 236, NULL),
('Hotel deLuxe', 131, '2019-10-23', 242, NULL),
('Hotel deLuxe', 131, '2019-10-24', 202, NULL),
('Hotel deLuxe', 131, '2019-10-25', 374, NULL),
('Hotel deLuxe', 131, '2019-10-26', 379, NULL),
('Hotel deLuxe', 131, '2019-10-27', 299, NULL),
('Hotel deLuxe', 131, '2019-10-28', 148, NULL),
('Hotel deLuxe', 131, '2019-10-29', 386, NULL),
('Hotel deLuxe', 131, '2019-10-30', 268, NULL),
('Hotel deLuxe', 131, '2019-10-31', 332, NULL),
('Hotel deLuxe', 131, '2019-11-01', 242, NULL),
('Hotel deLuxe', 131, '2019-11-02', 283, NULL),
('Hotel deLuxe', 131, '2019-11-03', 327, NULL),
('Hotel deLuxe', 131, '2019-11-04', 331, NULL),
('Hotel deLuxe', 131, '2019-11-05', 237, NULL),
('Hotel deLuxe', 131, '2019-11-06', 385, NULL),
('Hotel deLuxe', 131, '2019-11-07', 175, NULL),
('Hotel deLuxe', 131, '2019-11-08', 140, NULL),
('Hotel deLuxe', 131, '2019-11-09', 103, NULL),
('Hotel deLuxe', 131, '2019-11-10', 305, NULL),
('Hotel deLuxe', 131, '2019-11-11', 205, NULL),
('Hotel deLuxe', 131, '2019-11-12', 185, NULL),
('Hotel deLuxe', 131, '2019-11-13', 224, NULL),
('Hotel deLuxe', 131, '2019-11-14', 245, NULL),
('Hotel deLuxe', 131, '2019-11-15', 349, NULL),
('Hotel deLuxe', 131, '2019-11-16', 253, NULL),
('Hotel deLuxe', 131, '2019-11-17', 358, NULL),
('Hotel deLuxe', 131, '2019-11-18', 319, NULL),
('Hotel deLuxe', 131, '2019-11-19', 104, NULL),
('Hotel deLuxe', 131, '2019-11-20', 344, NULL),
('Hotel deLuxe', 131, '2019-11-21', 371, NULL),
('Hotel deLuxe', 131, '2019-11-22', 342, NULL),
('Hotel deLuxe', 131, '2019-11-23', 262, NULL),
('Hotel deLuxe', 131, '2019-11-24', 209, NULL),
('Hotel deLuxe', 131, '2019-11-25', 165, NULL),
('Hotel deLuxe', 131, '2019-11-26', 302, NULL),
('Hotel deLuxe', 131, '2019-11-27', 368, NULL),
('Hotel deLuxe', 131, '2019-11-28', 109, NULL),
('Hotel deLuxe', 131, '2019-11-29', 126, NULL),
('Hotel deLuxe', 131, '2019-11-30', 325, NULL),
('Hotel deLuxe', 131, '2019-12-01', 260, NULL),
('Hotel deLuxe', 131, '2019-12-02', 387, NULL),
('Hotel deLuxe', 131, '2019-12-03', 182, NULL),
('Hotel deLuxe', 131, '2019-12-04', 271, NULL),
('Hotel deLuxe', 131, '2019-12-05', 330, NULL),
('Hotel deLuxe', 131, '2019-12-06', 114, NULL),
('Hotel deLuxe', 131, '2019-12-07', 322, NULL),
('Hotel deLuxe', 131, '2019-12-08', 219, NULL),
('Hotel deLuxe', 131, '2019-12-09', 231, NULL),
('Hotel deLuxe', 131, '2019-12-10', 193, NULL),
('Hotel deLuxe', 131, '2019-12-11', 345, NULL),
('Hotel deLuxe', 131, '2019-12-12', 293, NULL),
('Hotel deLuxe', 131, '2019-12-13', 118, NULL),
('Hotel deLuxe', 131, '2019-12-14', 161, NULL),
('Hotel deLuxe', 131, '2019-12-15', 330, NULL),
('Hotel deLuxe', 131, '2019-12-16', 307, NULL),
('Hotel deLuxe', 131, '2019-12-17', 171, NULL),
('Hotel deLuxe', 131, '2019-12-18', 125, NULL),
('Hotel deLuxe', 131, '2019-12-19', 118, NULL),
('Hotel deLuxe', 131, '2019-12-20', 132, NULL),
('Hotel deLuxe', 131, '2019-12-21', 387, NULL),
('Hotel deLuxe', 131, '2019-12-22', 249, NULL),
('Hotel deLuxe', 131, '2019-12-23', 309, NULL),
('Hotel deLuxe', 131, '2019-12-24', 147, NULL),
('Hotel deLuxe', 131, '2019-12-25', 183, NULL),
('Hotel deLuxe', 131, '2019-12-26', 161, NULL),
('Hotel deLuxe', 131, '2019-12-27', 258, NULL),
('Hotel deLuxe', 131, '2019-12-28', 274, NULL),
('Hotel deLuxe', 131, '2019-12-29', 169, NULL),
('Hotel deLuxe', 131, '2019-12-30', 142, NULL),
('Hotel deLuxe', 131, '2019-12-31', 263, NULL),
('Hotel deLuxe', 131, '2020-01-01', 216, NULL),
('Hotel deLuxe', 131, '2020-01-02', 349, NULL),
('Hotel deLuxe', 131, '2020-01-03', 325, NULL),
('Hotel deLuxe', 131, '2020-01-04', 176, NULL),
('Hotel deLuxe', 131, '2020-01-05', 140, NULL),
('Hotel deLuxe', 131, '2020-01-06', 133, NULL),
('Hotel deLuxe', 131, '2020-01-07', 112, NULL),
('Hotel deLuxe', 131, '2020-01-08', 200, NULL),
('Hotel deLuxe', 131, '2020-01-09', 115, NULL),
('Hotel deLuxe', 131, '2020-01-10', 345, NULL),
('Hotel deLuxe', 131, '2020-01-11', 215, NULL),
('Hotel deLuxe', 131, '2020-01-12', 153, NULL),
('Hotel deLuxe', 131, '2020-01-13', 252, NULL),
('Hotel deLuxe', 131, '2020-01-14', 188, NULL),
('Hotel deLuxe', 131, '2020-01-15', 300, NULL),
('Hotel deLuxe', 131, '2020-01-16', 385, NULL),
('Hotel deLuxe', 131, '2020-01-17', 349, NULL),
('Hotel deLuxe', 131, '2020-01-18', 312, NULL),
('Hotel deLuxe', 131, '2020-01-19', 301, NULL),
('Hotel deLuxe', 131, '2020-01-20', 105, NULL),
('Hotel deLuxe', 131, '2020-01-21', 183, NULL),
('Hotel deLuxe', 131, '2020-01-22', 294, NULL),
('Hotel deLuxe', 131, '2020-01-23', 271, NULL),
('Hotel deLuxe', 131, '2020-01-24', 340, NULL),
('Hotel deLuxe', 131, '2020-01-25', 347, NULL),
('Hotel deLuxe', 131, '2020-01-26', 106, NULL),
('Hotel deLuxe', 131, '2020-01-27', 310, NULL),
('Hotel deLuxe', 131, '2020-01-28', 175, NULL),
('Hotel deLuxe', 131, '2020-01-29', 340, NULL),
('Hotel deLuxe', 131, '2020-01-30', 175, NULL),
('Hotel deLuxe', 131, '2020-01-31', 119, NULL),
('Hotel deLuxe', 131, '2020-02-01', 225, NULL),
('Hotel deLuxe', 131, '2020-02-02', 222, NULL),
('Hotel deLuxe', 131, '2020-02-03', 248, NULL),
('Hotel deLuxe', 131, '2020-02-04', 355, NULL),
('Hotel deLuxe', 138, '2019-01-01', 325, NULL),
('Hotel deLuxe', 138, '2019-01-02', 279, NULL),
('Hotel deLuxe', 138, '2019-01-03', 229, NULL),
('Hotel deLuxe', 138, '2019-01-04', 276, NULL),
('Hotel deLuxe', 138, '2019-01-05', 376, NULL),
('Hotel deLuxe', 138, '2019-01-06', 237, NULL),
('Hotel deLuxe', 138, '2019-01-07', 289, NULL),
('Hotel deLuxe', 138, '2019-01-08', 117, NULL),
('Hotel deLuxe', 138, '2019-01-09', 158, NULL),
('Hotel deLuxe', 138, '2019-01-10', 270, NULL),
('Hotel deLuxe', 138, '2019-01-11', 302, NULL),
('Hotel deLuxe', 138, '2019-01-12', 164, NULL),
('Hotel deLuxe', 138, '2019-01-13', 310, NULL),
('Hotel deLuxe', 138, '2019-01-14', 129, NULL),
('Hotel deLuxe', 138, '2019-01-15', 151, NULL),
('Hotel deLuxe', 138, '2019-01-16', 391, NULL),
('Hotel deLuxe', 138, '2019-01-17', 134, NULL),
('Hotel deLuxe', 138, '2019-01-18', 113, NULL),
('Hotel deLuxe', 138, '2019-01-19', 354, NULL),
('Hotel deLuxe', 138, '2019-01-20', 130, NULL),
('Hotel deLuxe', 138, '2019-01-21', 186, NULL),
('Hotel deLuxe', 138, '2019-01-22', 279, NULL),
('Hotel deLuxe', 138, '2019-01-23', 351, NULL),
('Hotel deLuxe', 138, '2019-01-24', 183, NULL),
('Hotel deLuxe', 138, '2019-01-25', 358, NULL),
('Hotel deLuxe', 138, '2019-01-26', 159, NULL),
('Hotel deLuxe', 138, '2019-01-27', 351, NULL),
('Hotel deLuxe', 138, '2019-01-28', 317, NULL),
('Hotel deLuxe', 138, '2019-01-29', 312, NULL),
('Hotel deLuxe', 138, '2019-01-30', 214, NULL),
('Hotel deLuxe', 138, '2019-01-31', 327, NULL),
('Hotel deLuxe', 138, '2019-02-01', 271, NULL),
('Hotel deLuxe', 138, '2019-02-02', 352, NULL),
('Hotel deLuxe', 138, '2019-02-03', 315, NULL),
('Hotel deLuxe', 138, '2019-02-04', 199, NULL),
('Hotel deLuxe', 138, '2019-02-05', 286, NULL),
('Hotel deLuxe', 138, '2019-02-06', 129, NULL),
('Hotel deLuxe', 138, '2019-02-07', 164, NULL),
('Hotel deLuxe', 138, '2019-02-08', 210, NULL),
('Hotel deLuxe', 138, '2019-02-09', 250, NULL),
('Hotel deLuxe', 138, '2019-02-10', 158, NULL),
('Hotel deLuxe', 138, '2019-02-11', 253, NULL),
('Hotel deLuxe', 138, '2019-02-12', 233, NULL),
('Hotel deLuxe', 138, '2019-02-13', 278, NULL),
('Hotel deLuxe', 138, '2019-02-14', 103, NULL),
('Hotel deLuxe', 138, '2019-02-15', 305, NULL),
('Hotel deLuxe', 138, '2019-02-16', 255, NULL),
('Hotel deLuxe', 138, '2019-02-17', 168, NULL),
('Hotel deLuxe', 138, '2019-02-18', 325, NULL),
('Hotel deLuxe', 138, '2019-02-19', 300, NULL),
('Hotel deLuxe', 138, '2019-02-20', 200, NULL),
('Hotel deLuxe', 138, '2019-02-21', 249, NULL),
('Hotel deLuxe', 138, '2019-02-22', 130, NULL),
('Hotel deLuxe', 138, '2019-02-23', 237, NULL),
('Hotel deLuxe', 138, '2019-02-24', 257, NULL),
('Hotel deLuxe', 138, '2019-02-25', 108, NULL),
('Hotel deLuxe', 138, '2019-02-26', 132, NULL),
('Hotel deLuxe', 138, '2019-02-27', 153, NULL),
('Hotel deLuxe', 138, '2019-02-28', 381, NULL),
('Hotel deLuxe', 138, '2019-03-01', 172, NULL),
('Hotel deLuxe', 138, '2019-03-02', 186, NULL),
('Hotel deLuxe', 138, '2019-03-03', 130, NULL),
('Hotel deLuxe', 138, '2019-03-04', 345, NULL),
('Hotel deLuxe', 138, '2019-03-05', 344, NULL),
('Hotel deLuxe', 138, '2019-03-06', 356, NULL),
('Hotel deLuxe', 138, '2019-03-07', 356, NULL),
('Hotel deLuxe', 138, '2019-03-08', 289, NULL),
('Hotel deLuxe', 138, '2019-03-09', 171, NULL),
('Hotel deLuxe', 138, '2019-03-10', 169, NULL),
('Hotel deLuxe', 138, '2019-03-11', 361, NULL),
('Hotel deLuxe', 138, '2019-03-12', 119, NULL),
('Hotel deLuxe', 138, '2019-03-13', 208, NULL),
('Hotel deLuxe', 138, '2019-03-14', 106, NULL),
('Hotel deLuxe', 138, '2019-03-15', 119, NULL),
('Hotel deLuxe', 138, '2019-03-16', 133, NULL),
('Hotel deLuxe', 138, '2019-03-17', 242, NULL),
('Hotel deLuxe', 138, '2019-03-18', 283, NULL),
('Hotel deLuxe', 138, '2019-03-19', 357, NULL),
('Hotel deLuxe', 138, '2019-03-20', 232, NULL),
('Hotel deLuxe', 138, '2019-03-21', 392, NULL),
('Hotel deLuxe', 138, '2019-03-22', 105, NULL),
('Hotel deLuxe', 138, '2019-03-23', 170, NULL),
('Hotel deLuxe', 138, '2019-03-24', 250, NULL),
('Hotel deLuxe', 138, '2019-03-25', 112, NULL),
('Hotel deLuxe', 138, '2019-03-26', 167, NULL),
('Hotel deLuxe', 138, '2019-03-27', 112, NULL),
('Hotel deLuxe', 138, '2019-03-28', 272, NULL),
('Hotel deLuxe', 138, '2019-03-29', 115, NULL),
('Hotel deLuxe', 138, '2019-03-30', 326, NULL),
('Hotel deLuxe', 138, '2019-03-31', 181, NULL),
('Hotel deLuxe', 138, '2019-04-01', 284, NULL),
('Hotel deLuxe', 138, '2019-04-02', 226, NULL),
('Hotel deLuxe', 138, '2019-04-03', 180, NULL),
('Hotel deLuxe', 138, '2019-04-04', 377, NULL),
('Hotel deLuxe', 138, '2019-04-05', 363, NULL),
('Hotel deLuxe', 138, '2019-04-06', 143, NULL),
('Hotel deLuxe', 138, '2019-04-07', 285, NULL),
('Hotel deLuxe', 138, '2019-04-08', 330, NULL),
('Hotel deLuxe', 138, '2019-04-09', 262, NULL),
('Hotel deLuxe', 138, '2019-04-10', 177, NULL),
('Hotel deLuxe', 138, '2019-04-11', 131, NULL),
('Hotel deLuxe', 138, '2019-04-12', 338, NULL),
('Hotel deLuxe', 138, '2019-04-13', 378, NULL),
('Hotel deLuxe', 138, '2019-04-14', 214, NULL),
('Hotel deLuxe', 138, '2019-04-15', 170, NULL),
('Hotel deLuxe', 138, '2019-04-16', 181, NULL),
('Hotel deLuxe', 138, '2019-04-17', 231, NULL),
('Hotel deLuxe', 138, '2019-04-18', 188, NULL),
('Hotel deLuxe', 138, '2019-04-19', 267, NULL),
('Hotel deLuxe', 138, '2019-04-20', 163, NULL),
('Hotel deLuxe', 138, '2019-04-21', 227, NULL),
('Hotel deLuxe', 138, '2019-04-22', 326, NULL),
('Hotel deLuxe', 138, '2019-04-23', 342, NULL),
('Hotel deLuxe', 138, '2019-04-24', 382, NULL),
('Hotel deLuxe', 138, '2019-04-25', 258, NULL),
('Hotel deLuxe', 138, '2019-04-26', 126, NULL),
('Hotel deLuxe', 138, '2019-04-27', 121, NULL),
('Hotel deLuxe', 138, '2019-04-28', 370, NULL),
('Hotel deLuxe', 138, '2019-04-29', 398, NULL),
('Hotel deLuxe', 138, '2019-04-30', 363, NULL),
('Hotel deLuxe', 138, '2019-05-01', 381, NULL),
('Hotel deLuxe', 138, '2019-05-02', 131, NULL),
('Hotel deLuxe', 138, '2019-05-03', 234, NULL),
('Hotel deLuxe', 138, '2019-05-04', 381, NULL),
('Hotel deLuxe', 138, '2019-05-05', 292, NULL),
('Hotel deLuxe', 138, '2019-05-06', 184, NULL),
('Hotel deLuxe', 138, '2019-05-07', 259, NULL),
('Hotel deLuxe', 138, '2019-05-08', 229, NULL),
('Hotel deLuxe', 138, '2019-05-09', 118, NULL),
('Hotel deLuxe', 138, '2019-05-10', 251, NULL),
('Hotel deLuxe', 138, '2019-05-11', 297, NULL),
('Hotel deLuxe', 138, '2019-05-12', 121, NULL),
('Hotel deLuxe', 138, '2019-05-13', 107, NULL),
('Hotel deLuxe', 138, '2019-05-14', 268, NULL),
('Hotel deLuxe', 138, '2019-05-15', 340, NULL),
('Hotel deLuxe', 138, '2019-05-16', 269, NULL),
('Hotel deLuxe', 138, '2019-05-17', 343, NULL),
('Hotel deLuxe', 138, '2019-05-18', 298, NULL),
('Hotel deLuxe', 138, '2019-05-19', 274, NULL),
('Hotel deLuxe', 138, '2019-05-20', 345, NULL),
('Hotel deLuxe', 138, '2019-05-21', 361, NULL),
('Hotel deLuxe', 138, '2019-05-22', 170, NULL),
('Hotel deLuxe', 138, '2019-05-23', 310, NULL),
('Hotel deLuxe', 138, '2019-05-24', 365, NULL),
('Hotel deLuxe', 138, '2019-05-25', 186, NULL),
('Hotel deLuxe', 138, '2019-05-26', 359, NULL),
('Hotel deLuxe', 138, '2019-05-27', 181, NULL),
('Hotel deLuxe', 138, '2019-05-28', 365, NULL),
('Hotel deLuxe', 138, '2019-05-29', 350, NULL),
('Hotel deLuxe', 138, '2019-05-30', 212, NULL),
('Hotel deLuxe', 138, '2019-05-31', 113, NULL),
('Hotel deLuxe', 138, '2019-06-01', 154, NULL),
('Hotel deLuxe', 138, '2019-06-02', 312, NULL),
('Hotel deLuxe', 138, '2019-06-03', 379, NULL),
('Hotel deLuxe', 138, '2019-06-04', 149, NULL),
('Hotel deLuxe', 138, '2019-06-05', 227, NULL),
('Hotel deLuxe', 138, '2019-06-06', 354, NULL),
('Hotel deLuxe', 138, '2019-06-07', 123, NULL),
('Hotel deLuxe', 138, '2019-06-08', 153, NULL),
('Hotel deLuxe', 138, '2019-06-09', 334, NULL),
('Hotel deLuxe', 138, '2019-06-10', 286, NULL),
('Hotel deLuxe', 138, '2019-06-11', 272, NULL),
('Hotel deLuxe', 138, '2019-06-12', 126, NULL),
('Hotel deLuxe', 138, '2019-06-13', 342, NULL),
('Hotel deLuxe', 138, '2019-06-14', 151, NULL),
('Hotel deLuxe', 138, '2019-06-15', 386, NULL),
('Hotel deLuxe', 138, '2019-06-16', 323, NULL),
('Hotel deLuxe', 138, '2019-06-17', 385, NULL),
('Hotel deLuxe', 138, '2019-06-18', 263, NULL),
('Hotel deLuxe', 138, '2019-06-19', 129, NULL),
('Hotel deLuxe', 138, '2019-06-20', 345, NULL),
('Hotel deLuxe', 138, '2019-06-21', 163, NULL),
('Hotel deLuxe', 138, '2019-06-22', 334, NULL),
('Hotel deLuxe', 138, '2019-06-23', 350, NULL),
('Hotel deLuxe', 138, '2019-06-24', 233, NULL),
('Hotel deLuxe', 138, '2019-06-25', 126, NULL),
('Hotel deLuxe', 138, '2019-06-26', 301, NULL),
('Hotel deLuxe', 138, '2019-06-27', 328, NULL),
('Hotel deLuxe', 138, '2019-06-28', 312, NULL),
('Hotel deLuxe', 138, '2019-06-29', 377, NULL),
('Hotel deLuxe', 138, '2019-06-30', 343, NULL),
('Hotel deLuxe', 138, '2019-07-01', 108, NULL),
('Hotel deLuxe', 138, '2019-07-02', 337, NULL),
('Hotel deLuxe', 138, '2019-07-03', 152, NULL),
('Hotel deLuxe', 138, '2019-07-04', 301, NULL),
('Hotel deLuxe', 138, '2019-07-05', 190, NULL),
('Hotel deLuxe', 138, '2019-07-06', 266, NULL),
('Hotel deLuxe', 138, '2019-07-07', 316, NULL),
('Hotel deLuxe', 138, '2019-07-08', 329, NULL),
('Hotel deLuxe', 138, '2019-07-09', 271, NULL),
('Hotel deLuxe', 138, '2019-07-10', 125, NULL),
('Hotel deLuxe', 138, '2019-07-11', 133, NULL),
('Hotel deLuxe', 138, '2019-07-12', 176, NULL),
('Hotel deLuxe', 138, '2019-07-13', 219, NULL),
('Hotel deLuxe', 138, '2019-07-14', 186, NULL),
('Hotel deLuxe', 138, '2019-07-15', 175, NULL),
('Hotel deLuxe', 138, '2019-07-16', 145, NULL),
('Hotel deLuxe', 138, '2019-07-17', 197, NULL),
('Hotel deLuxe', 138, '2019-07-18', 359, NULL),
('Hotel deLuxe', 138, '2019-07-19', 361, NULL),
('Hotel deLuxe', 138, '2019-07-20', 153, NULL),
('Hotel deLuxe', 138, '2019-07-21', 216, NULL),
('Hotel deLuxe', 138, '2019-07-22', 215, NULL),
('Hotel deLuxe', 138, '2019-07-23', 366, NULL),
('Hotel deLuxe', 138, '2019-07-24', 368, NULL),
('Hotel deLuxe', 138, '2019-07-25', 273, NULL),
('Hotel deLuxe', 138, '2019-07-26', 133, NULL),
('Hotel deLuxe', 138, '2019-07-27', 205, NULL),
('Hotel deLuxe', 138, '2019-07-28', 179, NULL),
('Hotel deLuxe', 138, '2019-07-29', 103, NULL),
('Hotel deLuxe', 138, '2019-07-30', 356, NULL),
('Hotel deLuxe', 138, '2019-07-31', 214, NULL),
('Hotel deLuxe', 138, '2019-08-01', 198, NULL),
('Hotel deLuxe', 138, '2019-08-02', 300, NULL),
('Hotel deLuxe', 138, '2019-08-03', 171, NULL),
('Hotel deLuxe', 138, '2019-08-04', 353, NULL),
('Hotel deLuxe', 138, '2019-08-05', 357, NULL),
('Hotel deLuxe', 138, '2019-08-06', 127, NULL),
('Hotel deLuxe', 138, '2019-08-07', 294, NULL),
('Hotel deLuxe', 138, '2019-08-08', 122, NULL),
('Hotel deLuxe', 138, '2019-08-09', 350, NULL),
('Hotel deLuxe', 138, '2019-08-10', 237, NULL),
('Hotel deLuxe', 138, '2019-08-11', 177, NULL),
('Hotel deLuxe', 138, '2019-08-12', 333, NULL),
('Hotel deLuxe', 138, '2019-08-13', 254, NULL),
('Hotel deLuxe', 138, '2019-08-14', 231, NULL),
('Hotel deLuxe', 138, '2019-08-15', 200, NULL),
('Hotel deLuxe', 138, '2019-08-16', 353, NULL),
('Hotel deLuxe', 138, '2019-08-17', 175, NULL),
('Hotel deLuxe', 138, '2019-08-18', 339, NULL),
('Hotel deLuxe', 138, '2019-08-19', 116, NULL),
('Hotel deLuxe', 138, '2019-08-20', 348, NULL),
('Hotel deLuxe', 138, '2019-08-21', 159, NULL),
('Hotel deLuxe', 138, '2019-08-22', 271, NULL),
('Hotel deLuxe', 138, '2019-08-23', 319, NULL),
('Hotel deLuxe', 138, '2019-08-24', 248, NULL),
('Hotel deLuxe', 138, '2019-08-25', 148, NULL),
('Hotel deLuxe', 138, '2019-08-26', 355, NULL),
('Hotel deLuxe', 138, '2019-08-27', 397, NULL),
('Hotel deLuxe', 138, '2019-08-28', 268, NULL),
('Hotel deLuxe', 138, '2019-08-29', 225, NULL),
('Hotel deLuxe', 138, '2019-08-30', 123, NULL),
('Hotel deLuxe', 138, '2019-08-31', 130, NULL),
('Hotel deLuxe', 138, '2019-09-01', 272, NULL),
('Hotel deLuxe', 138, '2019-09-02', 120, NULL),
('Hotel deLuxe', 138, '2019-09-03', 381, NULL),
('Hotel deLuxe', 138, '2019-09-04', 314, NULL),
('Hotel deLuxe', 138, '2019-09-05', 205, NULL),
('Hotel deLuxe', 138, '2019-09-06', 289, NULL),
('Hotel deLuxe', 138, '2019-09-07', 105, NULL),
('Hotel deLuxe', 138, '2019-09-08', 389, NULL),
('Hotel deLuxe', 138, '2019-09-09', 283, NULL),
('Hotel deLuxe', 138, '2019-09-10', 349, NULL),
('Hotel deLuxe', 138, '2019-09-11', 149, NULL),
('Hotel deLuxe', 138, '2019-09-12', 100, NULL),
('Hotel deLuxe', 138, '2019-09-13', 125, NULL),
('Hotel deLuxe', 138, '2019-09-14', 254, NULL),
('Hotel deLuxe', 138, '2019-09-15', 282, NULL),
('Hotel deLuxe', 138, '2019-09-16', 233, NULL),
('Hotel deLuxe', 138, '2019-09-17', 183, NULL),
('Hotel deLuxe', 138, '2019-09-18', 100, NULL),
('Hotel deLuxe', 138, '2019-09-19', 306, NULL),
('Hotel deLuxe', 138, '2019-09-20', 197, NULL),
('Hotel deLuxe', 138, '2019-09-21', 102, NULL),
('Hotel deLuxe', 138, '2019-09-22', 174, NULL),
('Hotel deLuxe', 138, '2019-09-23', 163, NULL),
('Hotel deLuxe', 138, '2019-09-24', 301, NULL),
('Hotel deLuxe', 138, '2019-09-25', 379, NULL),
('Hotel deLuxe', 138, '2019-09-26', 303, NULL),
('Hotel deLuxe', 138, '2019-09-27', 314, NULL),
('Hotel deLuxe', 138, '2019-09-28', 388, NULL),
('Hotel deLuxe', 138, '2019-09-29', 351, NULL),
('Hotel deLuxe', 138, '2019-09-30', 182, NULL),
('Hotel deLuxe', 138, '2019-10-01', 218, NULL),
('Hotel deLuxe', 138, '2019-10-02', 162, NULL),
('Hotel deLuxe', 138, '2019-10-03', 210, NULL),
('Hotel deLuxe', 138, '2019-10-04', 215, NULL),
('Hotel deLuxe', 138, '2019-10-05', 264, NULL),
('Hotel deLuxe', 138, '2019-10-06', 302, NULL),
('Hotel deLuxe', 138, '2019-10-07', 334, NULL),
('Hotel deLuxe', 138, '2019-10-08', 385, NULL),
('Hotel deLuxe', 138, '2019-10-09', 256, NULL),
('Hotel deLuxe', 138, '2019-10-10', 368, NULL),
('Hotel deLuxe', 138, '2019-10-11', 294, NULL),
('Hotel deLuxe', 138, '2019-10-12', 203, NULL),
('Hotel deLuxe', 138, '2019-10-13', 369, NULL),
('Hotel deLuxe', 138, '2019-10-14', 192, NULL),
('Hotel deLuxe', 138, '2019-10-15', 140, NULL),
('Hotel deLuxe', 138, '2019-10-16', 276, NULL),
('Hotel deLuxe', 138, '2019-10-17', 268, NULL),
('Hotel deLuxe', 138, '2019-10-18', 274, NULL),
('Hotel deLuxe', 138, '2019-10-19', 127, NULL),
('Hotel deLuxe', 138, '2019-10-20', 291, NULL),
('Hotel deLuxe', 138, '2019-10-21', 207, NULL),
('Hotel deLuxe', 138, '2019-10-22', 122, NULL),
('Hotel deLuxe', 138, '2019-10-23', 283, NULL),
('Hotel deLuxe', 138, '2019-10-24', 262, NULL),
('Hotel deLuxe', 138, '2019-10-25', 255, NULL),
('Hotel deLuxe', 138, '2019-10-26', 134, NULL),
('Hotel deLuxe', 138, '2019-10-27', 395, NULL),
('Hotel deLuxe', 138, '2019-10-28', 145, NULL),
('Hotel deLuxe', 138, '2019-10-29', 217, NULL),
('Hotel deLuxe', 138, '2019-10-30', 238, NULL),
('Hotel deLuxe', 138, '2019-10-31', 283, NULL),
('Hotel deLuxe', 138, '2019-11-01', 116, NULL),
('Hotel deLuxe', 138, '2019-11-02', 369, NULL),
('Hotel deLuxe', 138, '2019-11-03', 170, NULL),
('Hotel deLuxe', 138, '2019-11-04', 298, NULL),
('Hotel deLuxe', 138, '2019-11-05', 279, NULL),
('Hotel deLuxe', 138, '2019-11-06', 152, NULL),
('Hotel deLuxe', 138, '2019-11-07', 267, NULL),
('Hotel deLuxe', 138, '2019-11-08', 173, NULL),
('Hotel deLuxe', 138, '2019-11-09', 213, NULL),
('Hotel deLuxe', 138, '2019-11-10', 375, NULL),
('Hotel deLuxe', 138, '2019-11-11', 370, NULL),
('Hotel deLuxe', 138, '2019-11-12', 315, NULL),
('Hotel deLuxe', 138, '2019-11-13', 132, NULL),
('Hotel deLuxe', 138, '2019-11-14', 129, NULL),
('Hotel deLuxe', 138, '2019-11-15', 266, NULL),
('Hotel deLuxe', 138, '2019-11-16', 336, NULL),
('Hotel deLuxe', 138, '2019-11-17', 203, NULL),
('Hotel deLuxe', 138, '2019-11-18', 255, NULL),
('Hotel deLuxe', 138, '2019-11-19', 154, NULL),
('Hotel deLuxe', 138, '2019-11-20', 378, NULL),
('Hotel deLuxe', 138, '2019-11-21', 200, NULL),
('Hotel deLuxe', 138, '2019-11-22', 244, NULL),
('Hotel deLuxe', 138, '2019-11-23', 309, NULL),
('Hotel deLuxe', 138, '2019-11-24', 310, NULL),
('Hotel deLuxe', 138, '2019-11-25', 117, NULL),
('Hotel deLuxe', 138, '2019-11-26', 268, NULL),
('Hotel deLuxe', 138, '2019-11-27', 275, NULL),
('Hotel deLuxe', 138, '2019-11-28', 138, NULL),
('Hotel deLuxe', 138, '2019-11-29', 102, NULL),
('Hotel deLuxe', 138, '2019-11-30', 126, NULL),
('Hotel deLuxe', 138, '2019-12-01', 393, NULL),
('Hotel deLuxe', 138, '2019-12-02', 232, NULL),
('Hotel deLuxe', 138, '2019-12-03', 366, NULL),
('Hotel deLuxe', 138, '2019-12-04', 162, NULL),
('Hotel deLuxe', 138, '2019-12-05', 282, NULL),
('Hotel deLuxe', 138, '2019-12-06', 348, NULL),
('Hotel deLuxe', 138, '2019-12-07', 158, NULL),
('Hotel deLuxe', 138, '2019-12-08', 396, NULL),
('Hotel deLuxe', 138, '2019-12-09', 357, NULL),
('Hotel deLuxe', 138, '2019-12-10', 198, NULL),
('Hotel deLuxe', 138, '2019-12-11', 164, NULL),
('Hotel deLuxe', 138, '2019-12-12', 250, NULL),
('Hotel deLuxe', 138, '2019-12-13', 209, NULL),
('Hotel deLuxe', 138, '2019-12-14', 380, NULL),
('Hotel deLuxe', 138, '2019-12-15', 102, NULL),
('Hotel deLuxe', 138, '2019-12-16', 386, NULL),
('Hotel deLuxe', 138, '2019-12-17', 350, NULL),
('Hotel deLuxe', 138, '2019-12-18', 190, NULL),
('Hotel deLuxe', 138, '2019-12-19', 259, NULL),
('Hotel deLuxe', 138, '2019-12-20', 136, NULL),
('Hotel deLuxe', 138, '2019-12-21', 230, NULL),
('Hotel deLuxe', 138, '2019-12-22', 324, NULL),
('Hotel deLuxe', 138, '2019-12-23', 370, NULL),
('Hotel deLuxe', 138, '2019-12-24', 131, NULL),
('Hotel deLuxe', 138, '2019-12-25', 105, NULL),
('Hotel deLuxe', 138, '2019-12-26', 163, NULL),
('Hotel deLuxe', 138, '2019-12-27', 361, NULL),
('Hotel deLuxe', 138, '2019-12-28', 169, NULL),
('Hotel deLuxe', 138, '2019-12-29', 399, NULL),
('Hotel deLuxe', 138, '2019-12-30', 392, NULL),
('Hotel deLuxe', 138, '2019-12-31', 322, NULL),
('Hotel deLuxe', 138, '2020-01-01', 210, NULL),
('Hotel deLuxe', 138, '2020-01-02', 364, NULL),
('Hotel deLuxe', 138, '2020-01-03', 186, NULL),
('Hotel deLuxe', 138, '2020-01-04', 327, NULL),
('Hotel deLuxe', 138, '2020-01-05', 108, NULL),
('Hotel deLuxe', 138, '2020-01-06', 261, NULL),
('Hotel deLuxe', 138, '2020-01-07', 255, NULL),
('Hotel deLuxe', 138, '2020-01-08', 238, NULL),
('Hotel deLuxe', 138, '2020-01-09', 196, NULL),
('Hotel deLuxe', 138, '2020-01-10', 271, NULL),
('Hotel deLuxe', 138, '2020-01-11', 354, NULL),
('Hotel deLuxe', 138, '2020-01-12', 289, NULL),
('Hotel deLuxe', 138, '2020-01-13', 299, NULL),
('Hotel deLuxe', 138, '2020-01-14', 260, NULL),
('Hotel deLuxe', 138, '2020-01-15', 216, NULL),
('Hotel deLuxe', 138, '2020-01-16', 313, NULL),
('Hotel deLuxe', 138, '2020-01-17', 267, NULL),
('Hotel deLuxe', 138, '2020-01-18', 106, NULL),
('Hotel deLuxe', 138, '2020-01-19', 316, NULL),
('Hotel deLuxe', 138, '2020-01-20', 272, NULL),
('Hotel deLuxe', 138, '2020-01-21', 397, NULL),
('Hotel deLuxe', 138, '2020-01-22', 372, NULL),
('Hotel deLuxe', 138, '2020-01-23', 305, NULL),
('Hotel deLuxe', 138, '2020-01-24', 127, NULL),
('Hotel deLuxe', 138, '2020-01-25', 271, NULL),
('Hotel deLuxe', 138, '2020-01-26', 162, NULL),
('Hotel deLuxe', 138, '2020-01-27', 391, NULL),
('Hotel deLuxe', 138, '2020-01-28', 264, NULL),
('Hotel deLuxe', 138, '2020-01-29', 291, NULL),
('Hotel deLuxe', 138, '2020-01-30', 393, NULL),
('Hotel deLuxe', 138, '2020-01-31', 101, NULL),
('Hotel deLuxe', 138, '2020-02-01', 200, NULL),
('Hotel deLuxe', 138, '2020-02-02', 147, NULL),
('Hotel deLuxe', 138, '2020-02-03', 330, NULL),
('Hotel deLuxe', 138, '2020-02-04', 156, NULL),
('Hotel deLuxe', 143, '2019-01-01', 296, NULL),
('Hotel deLuxe', 143, '2019-01-02', 147, NULL),
('Hotel deLuxe', 143, '2019-01-03', 311, NULL),
('Hotel deLuxe', 143, '2019-01-04', 161, NULL),
('Hotel deLuxe', 143, '2019-01-05', 323, NULL),
('Hotel deLuxe', 143, '2019-01-06', 232, NULL),
('Hotel deLuxe', 143, '2019-01-07', 217, NULL),
('Hotel deLuxe', 143, '2019-01-08', 398, NULL),
('Hotel deLuxe', 143, '2019-01-09', 253, NULL),
('Hotel deLuxe', 143, '2019-01-10', 109, NULL),
('Hotel deLuxe', 143, '2019-01-11', 196, NULL),
('Hotel deLuxe', 143, '2019-01-12', 344, NULL),
('Hotel deLuxe', 143, '2019-01-13', 390, NULL),
('Hotel deLuxe', 143, '2019-01-14', 287, NULL),
('Hotel deLuxe', 143, '2019-01-15', 327, NULL),
('Hotel deLuxe', 143, '2019-01-16', 242, NULL),
('Hotel deLuxe', 143, '2019-01-17', 278, NULL),
('Hotel deLuxe', 143, '2019-01-18', 332, NULL),
('Hotel deLuxe', 143, '2019-01-19', 193, NULL),
('Hotel deLuxe', 143, '2019-01-20', 305, NULL),
('Hotel deLuxe', 143, '2019-01-21', 288, NULL),
('Hotel deLuxe', 143, '2019-01-22', 103, NULL),
('Hotel deLuxe', 143, '2019-01-23', 157, NULL),
('Hotel deLuxe', 143, '2019-01-24', 297, NULL),
('Hotel deLuxe', 143, '2019-01-25', 238, NULL),
('Hotel deLuxe', 143, '2019-01-26', 233, NULL),
('Hotel deLuxe', 143, '2019-01-27', 191, NULL),
('Hotel deLuxe', 143, '2019-01-28', 226, NULL),
('Hotel deLuxe', 143, '2019-01-29', 266, NULL),
('Hotel deLuxe', 143, '2019-01-30', 383, NULL),
('Hotel deLuxe', 143, '2019-01-31', 244, NULL),
('Hotel deLuxe', 143, '2019-02-01', 389, NULL),
('Hotel deLuxe', 143, '2019-02-02', 305, NULL),
('Hotel deLuxe', 143, '2019-02-03', 340, NULL),
('Hotel deLuxe', 143, '2019-02-04', 344, NULL),
('Hotel deLuxe', 143, '2019-02-05', 149, NULL),
('Hotel deLuxe', 143, '2019-02-06', 120, NULL),
('Hotel deLuxe', 143, '2019-02-07', 360, NULL),
('Hotel deLuxe', 143, '2019-02-08', 347, NULL),
('Hotel deLuxe', 143, '2019-02-09', 355, NULL),
('Hotel deLuxe', 143, '2019-02-10', 215, NULL),
('Hotel deLuxe', 143, '2019-02-11', 390, NULL),
('Hotel deLuxe', 143, '2019-02-12', 250, NULL),
('Hotel deLuxe', 143, '2019-02-13', 362, NULL),
('Hotel deLuxe', 143, '2019-02-14', 186, NULL),
('Hotel deLuxe', 143, '2019-02-15', 176, NULL),
('Hotel deLuxe', 143, '2019-02-16', 378, NULL),
('Hotel deLuxe', 143, '2019-02-17', 255, NULL),
('Hotel deLuxe', 143, '2019-02-18', 239, NULL),
('Hotel deLuxe', 143, '2019-02-19', 125, NULL),
('Hotel deLuxe', 143, '2019-02-20', 162, NULL),
('Hotel deLuxe', 143, '2019-02-21', 307, NULL),
('Hotel deLuxe', 143, '2019-02-22', 290, NULL),
('Hotel deLuxe', 143, '2019-02-23', 219, NULL),
('Hotel deLuxe', 143, '2019-02-24', 183, NULL),
('Hotel deLuxe', 143, '2019-02-25', 203, NULL),
('Hotel deLuxe', 143, '2019-02-26', 215, NULL),
('Hotel deLuxe', 143, '2019-02-27', 145, NULL),
('Hotel deLuxe', 143, '2019-02-28', 313, NULL),
('Hotel deLuxe', 143, '2019-03-01', 312, NULL),
('Hotel deLuxe', 143, '2019-03-02', 396, NULL),
('Hotel deLuxe', 143, '2019-03-03', 329, NULL),
('Hotel deLuxe', 143, '2019-03-04', 337, NULL),
('Hotel deLuxe', 143, '2019-03-05', 382, NULL),
('Hotel deLuxe', 143, '2019-03-06', 299, NULL),
('Hotel deLuxe', 143, '2019-03-07', 163, NULL),
('Hotel deLuxe', 143, '2019-03-08', 211, NULL),
('Hotel deLuxe', 143, '2019-03-09', 245, NULL),
('Hotel deLuxe', 143, '2019-03-10', 330, NULL),
('Hotel deLuxe', 143, '2019-03-11', 274, NULL),
('Hotel deLuxe', 143, '2019-03-12', 149, NULL),
('Hotel deLuxe', 143, '2019-03-13', 339, NULL),
('Hotel deLuxe', 143, '2019-03-14', 148, NULL),
('Hotel deLuxe', 143, '2019-03-15', 103, NULL),
('Hotel deLuxe', 143, '2019-03-16', 343, NULL),
('Hotel deLuxe', 143, '2019-03-17', 326, NULL),
('Hotel deLuxe', 143, '2019-03-18', 273, NULL),
('Hotel deLuxe', 143, '2019-03-19', 214, NULL),
('Hotel deLuxe', 143, '2019-03-20', 297, NULL),
('Hotel deLuxe', 143, '2019-03-21', 226, NULL),
('Hotel deLuxe', 143, '2019-03-22', 141, NULL),
('Hotel deLuxe', 143, '2019-03-23', 121, NULL),
('Hotel deLuxe', 143, '2019-03-24', 306, NULL),
('Hotel deLuxe', 143, '2019-03-25', 104, NULL),
('Hotel deLuxe', 143, '2019-03-26', 115, NULL),
('Hotel deLuxe', 143, '2019-03-27', 376, NULL),
('Hotel deLuxe', 143, '2019-03-28', 230, NULL),
('Hotel deLuxe', 143, '2019-03-29', 376, NULL),
('Hotel deLuxe', 143, '2019-03-30', 140, NULL),
('Hotel deLuxe', 143, '2019-03-31', 356, NULL),
('Hotel deLuxe', 143, '2019-04-01', 314, NULL),
('Hotel deLuxe', 143, '2019-04-02', 297, NULL),
('Hotel deLuxe', 143, '2019-04-03', 326, NULL),
('Hotel deLuxe', 143, '2019-04-04', 386, NULL),
('Hotel deLuxe', 143, '2019-04-05', 126, NULL),
('Hotel deLuxe', 143, '2019-04-06', 260, NULL),
('Hotel deLuxe', 143, '2019-04-07', 388, NULL),
('Hotel deLuxe', 143, '2019-04-08', 267, NULL),
('Hotel deLuxe', 143, '2019-04-09', 343, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 143, '2019-04-10', 251, NULL),
('Hotel deLuxe', 143, '2019-04-11', 258, NULL),
('Hotel deLuxe', 143, '2019-04-12', 121, NULL),
('Hotel deLuxe', 143, '2019-04-13', 264, NULL),
('Hotel deLuxe', 143, '2019-04-14', 205, NULL),
('Hotel deLuxe', 143, '2019-04-15', 228, NULL),
('Hotel deLuxe', 143, '2019-04-16', 266, NULL),
('Hotel deLuxe', 143, '2019-04-17', 349, NULL),
('Hotel deLuxe', 143, '2019-04-18', 248, NULL),
('Hotel deLuxe', 143, '2019-04-19', 221, NULL),
('Hotel deLuxe', 143, '2019-04-20', 151, NULL),
('Hotel deLuxe', 143, '2019-04-21', 383, NULL),
('Hotel deLuxe', 143, '2019-04-22', 152, NULL),
('Hotel deLuxe', 143, '2019-04-23', 118, NULL),
('Hotel deLuxe', 143, '2019-04-24', 201, NULL),
('Hotel deLuxe', 143, '2019-04-25', 289, NULL),
('Hotel deLuxe', 143, '2019-04-26', 328, NULL),
('Hotel deLuxe', 143, '2019-04-27', 225, NULL),
('Hotel deLuxe', 143, '2019-04-28', 115, NULL),
('Hotel deLuxe', 143, '2019-04-29', 197, NULL),
('Hotel deLuxe', 143, '2019-04-30', 174, NULL),
('Hotel deLuxe', 143, '2019-05-01', 218, NULL),
('Hotel deLuxe', 143, '2019-05-02', 164, NULL),
('Hotel deLuxe', 143, '2019-05-03', 112, NULL),
('Hotel deLuxe', 143, '2019-05-04', 135, NULL),
('Hotel deLuxe', 143, '2019-05-05', 368, NULL),
('Hotel deLuxe', 143, '2019-05-06', 262, NULL),
('Hotel deLuxe', 143, '2019-05-07', 343, NULL),
('Hotel deLuxe', 143, '2019-05-08', 222, NULL),
('Hotel deLuxe', 143, '2019-05-09', 251, NULL),
('Hotel deLuxe', 143, '2019-05-10', 150, NULL),
('Hotel deLuxe', 143, '2019-05-11', 343, NULL),
('Hotel deLuxe', 143, '2019-05-12', 157, NULL),
('Hotel deLuxe', 143, '2019-05-13', 171, NULL),
('Hotel deLuxe', 143, '2019-05-14', 384, NULL),
('Hotel deLuxe', 143, '2019-05-15', 215, NULL),
('Hotel deLuxe', 143, '2019-05-16', 350, NULL),
('Hotel deLuxe', 143, '2019-05-17', 113, NULL),
('Hotel deLuxe', 143, '2019-05-18', 366, NULL),
('Hotel deLuxe', 143, '2019-05-19', 187, NULL),
('Hotel deLuxe', 143, '2019-05-20', 109, NULL),
('Hotel deLuxe', 143, '2019-05-21', 345, NULL),
('Hotel deLuxe', 143, '2019-05-22', 154, NULL),
('Hotel deLuxe', 143, '2019-05-23', 268, NULL),
('Hotel deLuxe', 143, '2019-05-24', 278, NULL),
('Hotel deLuxe', 143, '2019-05-25', 160, NULL),
('Hotel deLuxe', 143, '2019-05-26', 390, NULL),
('Hotel deLuxe', 143, '2019-05-27', 170, NULL),
('Hotel deLuxe', 143, '2019-05-28', 201, NULL),
('Hotel deLuxe', 143, '2019-05-29', 350, NULL),
('Hotel deLuxe', 143, '2019-05-30', 359, NULL),
('Hotel deLuxe', 143, '2019-05-31', 337, NULL),
('Hotel deLuxe', 143, '2019-06-01', 268, NULL),
('Hotel deLuxe', 143, '2019-06-02', 211, NULL),
('Hotel deLuxe', 143, '2019-06-03', 158, NULL),
('Hotel deLuxe', 143, '2019-06-04', 124, NULL),
('Hotel deLuxe', 143, '2019-06-05', 245, NULL),
('Hotel deLuxe', 143, '2019-06-06', 100, NULL),
('Hotel deLuxe', 143, '2019-06-07', 112, NULL),
('Hotel deLuxe', 143, '2019-06-08', 391, NULL),
('Hotel deLuxe', 143, '2019-06-09', 217, NULL),
('Hotel deLuxe', 143, '2019-06-10', 189, NULL),
('Hotel deLuxe', 143, '2019-06-11', 331, NULL),
('Hotel deLuxe', 143, '2019-06-12', 256, NULL),
('Hotel deLuxe', 143, '2019-06-13', 268, NULL),
('Hotel deLuxe', 143, '2019-06-14', 381, NULL),
('Hotel deLuxe', 143, '2019-06-15', 349, NULL),
('Hotel deLuxe', 143, '2019-06-16', 159, NULL),
('Hotel deLuxe', 143, '2019-06-17', 356, NULL),
('Hotel deLuxe', 143, '2019-06-18', 104, NULL),
('Hotel deLuxe', 143, '2019-06-19', 156, NULL),
('Hotel deLuxe', 143, '2019-06-20', 123, NULL),
('Hotel deLuxe', 143, '2019-06-21', 193, NULL),
('Hotel deLuxe', 143, '2019-06-22', 233, NULL),
('Hotel deLuxe', 143, '2019-06-23', 340, NULL),
('Hotel deLuxe', 143, '2019-06-24', 138, NULL),
('Hotel deLuxe', 143, '2019-06-25', 165, NULL),
('Hotel deLuxe', 143, '2019-06-26', 371, NULL),
('Hotel deLuxe', 143, '2019-06-27', 132, NULL),
('Hotel deLuxe', 143, '2019-06-28', 306, NULL),
('Hotel deLuxe', 143, '2019-06-29', 171, NULL),
('Hotel deLuxe', 143, '2019-06-30', 246, NULL),
('Hotel deLuxe', 143, '2019-07-01', 282, NULL),
('Hotel deLuxe', 143, '2019-07-02', 250, NULL),
('Hotel deLuxe', 143, '2019-07-03', 337, NULL),
('Hotel deLuxe', 143, '2019-07-04', 201, NULL),
('Hotel deLuxe', 143, '2019-07-05', 270, NULL),
('Hotel deLuxe', 143, '2019-07-06', 204, NULL),
('Hotel deLuxe', 143, '2019-07-07', 358, NULL),
('Hotel deLuxe', 143, '2019-07-08', 279, NULL),
('Hotel deLuxe', 143, '2019-07-09', 322, NULL),
('Hotel deLuxe', 143, '2019-07-10', 171, NULL),
('Hotel deLuxe', 143, '2019-07-11', 134, NULL),
('Hotel deLuxe', 143, '2019-07-12', 312, NULL),
('Hotel deLuxe', 143, '2019-07-13', 379, NULL),
('Hotel deLuxe', 143, '2019-07-14', 284, NULL),
('Hotel deLuxe', 143, '2019-07-15', 286, NULL),
('Hotel deLuxe', 143, '2019-07-16', 113, NULL),
('Hotel deLuxe', 143, '2019-07-17', 289, NULL),
('Hotel deLuxe', 143, '2019-07-18', 338, NULL),
('Hotel deLuxe', 143, '2019-07-19', 129, NULL),
('Hotel deLuxe', 143, '2019-07-20', 121, NULL),
('Hotel deLuxe', 143, '2019-07-21', 103, NULL),
('Hotel deLuxe', 143, '2019-07-22', 138, NULL),
('Hotel deLuxe', 143, '2019-07-23', 363, NULL),
('Hotel deLuxe', 143, '2019-07-24', 365, NULL),
('Hotel deLuxe', 143, '2019-07-25', 335, NULL),
('Hotel deLuxe', 143, '2019-07-26', 183, NULL),
('Hotel deLuxe', 143, '2019-07-27', 101, NULL),
('Hotel deLuxe', 143, '2019-07-28', 180, NULL),
('Hotel deLuxe', 143, '2019-07-29', 318, NULL),
('Hotel deLuxe', 143, '2019-07-30', 208, NULL),
('Hotel deLuxe', 143, '2019-07-31', 145, NULL),
('Hotel deLuxe', 143, '2019-08-01', 269, NULL),
('Hotel deLuxe', 143, '2019-08-02', 160, NULL),
('Hotel deLuxe', 143, '2019-08-03', 389, NULL),
('Hotel deLuxe', 143, '2019-08-04', 160, NULL),
('Hotel deLuxe', 143, '2019-08-05', 102, NULL),
('Hotel deLuxe', 143, '2019-08-06', 349, NULL),
('Hotel deLuxe', 143, '2019-08-07', 163, NULL),
('Hotel deLuxe', 143, '2019-08-08', 293, NULL),
('Hotel deLuxe', 143, '2019-08-09', 319, NULL),
('Hotel deLuxe', 143, '2019-08-10', 391, NULL),
('Hotel deLuxe', 143, '2019-08-11', 177, NULL),
('Hotel deLuxe', 143, '2019-08-12', 316, NULL),
('Hotel deLuxe', 143, '2019-08-13', 357, NULL),
('Hotel deLuxe', 143, '2019-08-14', 115, NULL),
('Hotel deLuxe', 143, '2019-08-15', 244, NULL),
('Hotel deLuxe', 143, '2019-08-16', 188, NULL),
('Hotel deLuxe', 143, '2019-08-17', 184, NULL),
('Hotel deLuxe', 143, '2019-08-18', 381, NULL),
('Hotel deLuxe', 143, '2019-08-19', 200, NULL),
('Hotel deLuxe', 143, '2019-08-20', 120, NULL),
('Hotel deLuxe', 143, '2019-08-21', 383, NULL),
('Hotel deLuxe', 143, '2019-08-22', 133, NULL),
('Hotel deLuxe', 143, '2019-08-23', 129, NULL),
('Hotel deLuxe', 143, '2019-08-24', 367, NULL),
('Hotel deLuxe', 143, '2019-08-25', 289, NULL),
('Hotel deLuxe', 143, '2019-08-26', 275, NULL),
('Hotel deLuxe', 143, '2019-08-27', 267, NULL),
('Hotel deLuxe', 143, '2019-08-28', 155, NULL),
('Hotel deLuxe', 143, '2019-08-29', 388, NULL),
('Hotel deLuxe', 143, '2019-08-30', 126, NULL),
('Hotel deLuxe', 143, '2019-08-31', 230, NULL),
('Hotel deLuxe', 143, '2019-09-01', 234, NULL),
('Hotel deLuxe', 143, '2019-09-02', 316, NULL),
('Hotel deLuxe', 143, '2019-09-03', 277, NULL),
('Hotel deLuxe', 143, '2019-09-04', 385, NULL),
('Hotel deLuxe', 143, '2019-09-05', 184, NULL),
('Hotel deLuxe', 143, '2019-09-06', 233, NULL),
('Hotel deLuxe', 143, '2019-09-07', 328, NULL),
('Hotel deLuxe', 143, '2019-09-08', 290, NULL),
('Hotel deLuxe', 143, '2019-09-09', 186, NULL),
('Hotel deLuxe', 143, '2019-09-10', 148, NULL),
('Hotel deLuxe', 143, '2019-09-11', 368, NULL),
('Hotel deLuxe', 143, '2019-09-12', 388, NULL),
('Hotel deLuxe', 143, '2019-09-13', 175, NULL),
('Hotel deLuxe', 143, '2019-09-14', 150, NULL),
('Hotel deLuxe', 143, '2019-09-15', 288, NULL),
('Hotel deLuxe', 143, '2019-09-16', 310, NULL),
('Hotel deLuxe', 143, '2019-09-17', 331, NULL),
('Hotel deLuxe', 143, '2019-09-18', 387, NULL),
('Hotel deLuxe', 143, '2019-09-19', 151, NULL),
('Hotel deLuxe', 143, '2019-09-20', 366, NULL),
('Hotel deLuxe', 143, '2019-09-21', 281, NULL),
('Hotel deLuxe', 143, '2019-09-22', 335, NULL),
('Hotel deLuxe', 143, '2019-09-23', 284, NULL),
('Hotel deLuxe', 143, '2019-09-24', 210, NULL),
('Hotel deLuxe', 143, '2019-09-25', 199, NULL),
('Hotel deLuxe', 143, '2019-09-26', 367, NULL),
('Hotel deLuxe', 143, '2019-09-27', 126, NULL),
('Hotel deLuxe', 143, '2019-09-28', 279, NULL),
('Hotel deLuxe', 143, '2019-09-29', 284, NULL),
('Hotel deLuxe', 143, '2019-09-30', 362, NULL),
('Hotel deLuxe', 143, '2019-10-01', 157, NULL),
('Hotel deLuxe', 143, '2019-10-02', 279, NULL),
('Hotel deLuxe', 143, '2019-10-03', 201, NULL),
('Hotel deLuxe', 143, '2019-10-04', 195, NULL),
('Hotel deLuxe', 143, '2019-10-05', 230, NULL),
('Hotel deLuxe', 143, '2019-10-06', 302, NULL),
('Hotel deLuxe', 143, '2019-10-07', 108, NULL),
('Hotel deLuxe', 143, '2019-10-08', 173, NULL),
('Hotel deLuxe', 143, '2019-10-09', 287, NULL),
('Hotel deLuxe', 143, '2019-10-10', 364, NULL),
('Hotel deLuxe', 143, '2019-10-11', 201, NULL),
('Hotel deLuxe', 143, '2019-10-12', 359, NULL),
('Hotel deLuxe', 143, '2019-10-13', 211, NULL),
('Hotel deLuxe', 143, '2019-10-14', 164, NULL),
('Hotel deLuxe', 143, '2019-10-15', 330, NULL),
('Hotel deLuxe', 143, '2019-10-16', 256, NULL),
('Hotel deLuxe', 143, '2019-10-17', 180, NULL),
('Hotel deLuxe', 143, '2019-10-18', 268, NULL),
('Hotel deLuxe', 143, '2019-10-19', 300, NULL),
('Hotel deLuxe', 143, '2019-10-20', 289, NULL),
('Hotel deLuxe', 143, '2019-10-21', 251, NULL),
('Hotel deLuxe', 143, '2019-10-22', 102, NULL),
('Hotel deLuxe', 143, '2019-10-23', 289, NULL),
('Hotel deLuxe', 143, '2019-10-24', 307, NULL),
('Hotel deLuxe', 143, '2019-10-25', 353, NULL),
('Hotel deLuxe', 143, '2019-10-26', 333, NULL),
('Hotel deLuxe', 143, '2019-10-27', 380, NULL),
('Hotel deLuxe', 143, '2019-10-28', 179, NULL),
('Hotel deLuxe', 143, '2019-10-29', 130, NULL),
('Hotel deLuxe', 143, '2019-10-30', 290, NULL),
('Hotel deLuxe', 143, '2019-10-31', 320, NULL),
('Hotel deLuxe', 143, '2019-11-01', 354, NULL),
('Hotel deLuxe', 143, '2019-11-02', 293, NULL),
('Hotel deLuxe', 143, '2019-11-03', 370, NULL),
('Hotel deLuxe', 143, '2019-11-04', 394, NULL),
('Hotel deLuxe', 143, '2019-11-05', 283, NULL),
('Hotel deLuxe', 143, '2019-11-06', 107, NULL),
('Hotel deLuxe', 143, '2019-11-07', 112, NULL),
('Hotel deLuxe', 143, '2019-11-08', 343, NULL),
('Hotel deLuxe', 143, '2019-11-09', 353, NULL),
('Hotel deLuxe', 143, '2019-11-10', 260, NULL),
('Hotel deLuxe', 143, '2019-11-11', 234, NULL),
('Hotel deLuxe', 143, '2019-11-12', 318, NULL),
('Hotel deLuxe', 143, '2019-11-13', 188, NULL),
('Hotel deLuxe', 143, '2019-11-14', 110, NULL),
('Hotel deLuxe', 143, '2019-11-15', 183, NULL),
('Hotel deLuxe', 143, '2019-11-16', 225, NULL),
('Hotel deLuxe', 143, '2019-11-17', 143, NULL),
('Hotel deLuxe', 143, '2019-11-18', 221, NULL),
('Hotel deLuxe', 143, '2019-11-19', 357, NULL),
('Hotel deLuxe', 143, '2019-11-20', 159, NULL),
('Hotel deLuxe', 143, '2019-11-21', 390, NULL),
('Hotel deLuxe', 143, '2019-11-22', 395, NULL),
('Hotel deLuxe', 143, '2019-11-23', 358, NULL),
('Hotel deLuxe', 143, '2019-11-24', 223, NULL),
('Hotel deLuxe', 143, '2019-11-25', 292, NULL),
('Hotel deLuxe', 143, '2019-11-26', 336, NULL),
('Hotel deLuxe', 143, '2019-11-27', 171, NULL),
('Hotel deLuxe', 143, '2019-11-28', 265, NULL),
('Hotel deLuxe', 143, '2019-11-29', 331, NULL),
('Hotel deLuxe', 143, '2019-11-30', 155, NULL),
('Hotel deLuxe', 143, '2019-12-01', 186, NULL),
('Hotel deLuxe', 143, '2019-12-02', 199, NULL),
('Hotel deLuxe', 143, '2019-12-03', 286, NULL),
('Hotel deLuxe', 143, '2019-12-04', 196, NULL),
('Hotel deLuxe', 143, '2019-12-05', 319, NULL),
('Hotel deLuxe', 143, '2019-12-06', 101, NULL),
('Hotel deLuxe', 143, '2019-12-07', 323, NULL),
('Hotel deLuxe', 143, '2019-12-08', 323, NULL),
('Hotel deLuxe', 143, '2019-12-09', 393, NULL),
('Hotel deLuxe', 143, '2019-12-10', 314, NULL),
('Hotel deLuxe', 143, '2019-12-11', 284, NULL),
('Hotel deLuxe', 143, '2019-12-12', 272, NULL),
('Hotel deLuxe', 143, '2019-12-13', 291, NULL),
('Hotel deLuxe', 143, '2019-12-14', 115, NULL),
('Hotel deLuxe', 143, '2019-12-15', 321, NULL),
('Hotel deLuxe', 143, '2019-12-16', 307, NULL),
('Hotel deLuxe', 143, '2019-12-17', 236, NULL),
('Hotel deLuxe', 143, '2019-12-18', 178, NULL),
('Hotel deLuxe', 143, '2019-12-19', 243, NULL),
('Hotel deLuxe', 143, '2019-12-20', 181, NULL),
('Hotel deLuxe', 143, '2019-12-21', 192, NULL),
('Hotel deLuxe', 143, '2019-12-22', 174, NULL),
('Hotel deLuxe', 143, '2019-12-23', 223, NULL),
('Hotel deLuxe', 143, '2019-12-24', 112, NULL),
('Hotel deLuxe', 143, '2019-12-25', 179, NULL),
('Hotel deLuxe', 143, '2019-12-26', 232, NULL),
('Hotel deLuxe', 143, '2019-12-27', 333, NULL),
('Hotel deLuxe', 143, '2019-12-28', 223, NULL),
('Hotel deLuxe', 143, '2019-12-29', 190, NULL),
('Hotel deLuxe', 143, '2019-12-30', 238, NULL),
('Hotel deLuxe', 143, '2019-12-31', 120, NULL),
('Hotel deLuxe', 143, '2020-01-01', 300, NULL),
('Hotel deLuxe', 143, '2020-01-02', 377, NULL),
('Hotel deLuxe', 143, '2020-01-03', 156, NULL),
('Hotel deLuxe', 143, '2020-01-04', 107, NULL),
('Hotel deLuxe', 143, '2020-01-05', 319, NULL),
('Hotel deLuxe', 143, '2020-01-06', 208, NULL),
('Hotel deLuxe', 143, '2020-01-07', 238, NULL),
('Hotel deLuxe', 143, '2020-01-08', 189, NULL),
('Hotel deLuxe', 143, '2020-01-09', 239, NULL),
('Hotel deLuxe', 143, '2020-01-10', 218, NULL),
('Hotel deLuxe', 143, '2020-01-11', 128, NULL),
('Hotel deLuxe', 143, '2020-01-12', 286, NULL),
('Hotel deLuxe', 143, '2020-01-13', 342, NULL),
('Hotel deLuxe', 143, '2020-01-14', 337, NULL),
('Hotel deLuxe', 143, '2020-01-15', 381, NULL),
('Hotel deLuxe', 143, '2020-01-16', 313, NULL),
('Hotel deLuxe', 143, '2020-01-17', 192, NULL),
('Hotel deLuxe', 143, '2020-01-18', 394, NULL),
('Hotel deLuxe', 143, '2020-01-19', 275, NULL),
('Hotel deLuxe', 143, '2020-01-20', 346, NULL),
('Hotel deLuxe', 143, '2020-01-21', 134, NULL),
('Hotel deLuxe', 143, '2020-01-22', 275, NULL),
('Hotel deLuxe', 143, '2020-01-23', 312, NULL),
('Hotel deLuxe', 143, '2020-01-24', 117, NULL),
('Hotel deLuxe', 143, '2020-01-25', 217, NULL),
('Hotel deLuxe', 143, '2020-01-26', 393, NULL),
('Hotel deLuxe', 143, '2020-01-27', 327, NULL),
('Hotel deLuxe', 143, '2020-01-28', 396, NULL),
('Hotel deLuxe', 143, '2020-01-29', 336, NULL),
('Hotel deLuxe', 143, '2020-01-30', 138, NULL),
('Hotel deLuxe', 143, '2020-01-31', 352, NULL),
('Hotel deLuxe', 143, '2020-02-01', 226, NULL),
('Hotel deLuxe', 143, '2020-02-02', 269, NULL),
('Hotel deLuxe', 143, '2020-02-03', 204, NULL),
('Hotel deLuxe', 143, '2020-02-04', 217, NULL),
('Hotel deLuxe', 145, '2019-01-01', 105, NULL),
('Hotel deLuxe', 145, '2019-01-02', 101, NULL),
('Hotel deLuxe', 145, '2019-01-03', 168, NULL),
('Hotel deLuxe', 145, '2019-01-04', 179, NULL),
('Hotel deLuxe', 145, '2019-01-05', 387, NULL),
('Hotel deLuxe', 145, '2019-01-06', 348, NULL),
('Hotel deLuxe', 145, '2019-01-07', 117, NULL),
('Hotel deLuxe', 145, '2019-01-08', 337, NULL),
('Hotel deLuxe', 145, '2019-01-09', 389, NULL),
('Hotel deLuxe', 145, '2019-01-10', 235, NULL),
('Hotel deLuxe', 145, '2019-01-11', 275, NULL),
('Hotel deLuxe', 145, '2019-01-12', 226, NULL),
('Hotel deLuxe', 145, '2019-01-13', 318, NULL),
('Hotel deLuxe', 145, '2019-01-14', 348, NULL),
('Hotel deLuxe', 145, '2019-01-15', 184, NULL),
('Hotel deLuxe', 145, '2019-01-16', 239, NULL),
('Hotel deLuxe', 145, '2019-01-17', 288, NULL),
('Hotel deLuxe', 145, '2019-01-18', 322, NULL),
('Hotel deLuxe', 145, '2019-01-19', 104, NULL),
('Hotel deLuxe', 145, '2019-01-20', 138, NULL),
('Hotel deLuxe', 145, '2019-01-21', 181, NULL),
('Hotel deLuxe', 145, '2019-01-22', 178, NULL),
('Hotel deLuxe', 145, '2019-01-23', 235, NULL),
('Hotel deLuxe', 145, '2019-01-24', 239, NULL),
('Hotel deLuxe', 145, '2019-01-25', 316, NULL),
('Hotel deLuxe', 145, '2019-01-26', 290, NULL),
('Hotel deLuxe', 145, '2019-01-27', 101, NULL),
('Hotel deLuxe', 145, '2019-01-28', 382, NULL),
('Hotel deLuxe', 145, '2019-01-29', 293, NULL),
('Hotel deLuxe', 145, '2019-01-30', 277, NULL),
('Hotel deLuxe', 145, '2019-01-31', 141, NULL),
('Hotel deLuxe', 145, '2019-02-01', 134, NULL),
('Hotel deLuxe', 145, '2019-02-02', 370, NULL),
('Hotel deLuxe', 145, '2019-02-03', 355, NULL),
('Hotel deLuxe', 145, '2019-02-04', 121, NULL),
('Hotel deLuxe', 145, '2019-02-05', 388, NULL),
('Hotel deLuxe', 145, '2019-02-06', 115, NULL),
('Hotel deLuxe', 145, '2019-02-07', 307, NULL),
('Hotel deLuxe', 145, '2019-02-08', 107, NULL),
('Hotel deLuxe', 145, '2019-02-09', 323, NULL),
('Hotel deLuxe', 145, '2019-02-10', 201, NULL),
('Hotel deLuxe', 145, '2019-02-11', 192, NULL),
('Hotel deLuxe', 145, '2019-02-12', 151, NULL),
('Hotel deLuxe', 145, '2019-02-13', 276, NULL),
('Hotel deLuxe', 145, '2019-02-14', 222, NULL),
('Hotel deLuxe', 145, '2019-02-15', 165, NULL),
('Hotel deLuxe', 145, '2019-02-16', 124, NULL),
('Hotel deLuxe', 145, '2019-02-17', 373, NULL),
('Hotel deLuxe', 145, '2019-02-18', 122, NULL),
('Hotel deLuxe', 145, '2019-02-19', 225, NULL),
('Hotel deLuxe', 145, '2019-02-20', 110, NULL),
('Hotel deLuxe', 145, '2019-02-21', 388, NULL),
('Hotel deLuxe', 145, '2019-02-22', 361, NULL),
('Hotel deLuxe', 145, '2019-02-23', 284, NULL),
('Hotel deLuxe', 145, '2019-02-24', 344, NULL),
('Hotel deLuxe', 145, '2019-02-25', 294, NULL),
('Hotel deLuxe', 145, '2019-02-26', 280, NULL),
('Hotel deLuxe', 145, '2019-02-27', 163, NULL),
('Hotel deLuxe', 145, '2019-02-28', 323, NULL),
('Hotel deLuxe', 145, '2019-03-01', 344, NULL),
('Hotel deLuxe', 145, '2019-03-02', 124, NULL),
('Hotel deLuxe', 145, '2019-03-03', 258, NULL),
('Hotel deLuxe', 145, '2019-03-04', 248, NULL),
('Hotel deLuxe', 145, '2019-03-05', 178, NULL),
('Hotel deLuxe', 145, '2019-03-06', 330, NULL),
('Hotel deLuxe', 145, '2019-03-07', 247, NULL),
('Hotel deLuxe', 145, '2019-03-08', 385, NULL),
('Hotel deLuxe', 145, '2019-03-09', 312, NULL),
('Hotel deLuxe', 145, '2019-03-10', 144, NULL),
('Hotel deLuxe', 145, '2019-03-11', 186, NULL),
('Hotel deLuxe', 145, '2019-03-12', 288, NULL),
('Hotel deLuxe', 145, '2019-03-13', 372, NULL),
('Hotel deLuxe', 145, '2019-03-14', 323, NULL),
('Hotel deLuxe', 145, '2019-03-15', 356, NULL),
('Hotel deLuxe', 145, '2019-03-16', 320, NULL),
('Hotel deLuxe', 145, '2019-03-17', 202, NULL),
('Hotel deLuxe', 145, '2019-03-18', 117, NULL),
('Hotel deLuxe', 145, '2019-03-19', 201, NULL),
('Hotel deLuxe', 145, '2019-03-20', 391, NULL),
('Hotel deLuxe', 145, '2019-03-21', 153, NULL),
('Hotel deLuxe', 145, '2019-03-22', 288, NULL),
('Hotel deLuxe', 145, '2019-03-23', 294, NULL),
('Hotel deLuxe', 145, '2019-03-24', 378, NULL),
('Hotel deLuxe', 145, '2019-03-25', 387, NULL),
('Hotel deLuxe', 145, '2019-03-26', 275, NULL),
('Hotel deLuxe', 145, '2019-03-27', 246, NULL),
('Hotel deLuxe', 145, '2019-03-28', 234, NULL),
('Hotel deLuxe', 145, '2019-03-29', 236, NULL),
('Hotel deLuxe', 145, '2019-03-30', 223, NULL),
('Hotel deLuxe', 145, '2019-03-31', 237, NULL),
('Hotel deLuxe', 145, '2019-04-01', 320, NULL),
('Hotel deLuxe', 145, '2019-04-02', 109, NULL),
('Hotel deLuxe', 145, '2019-04-03', 392, NULL),
('Hotel deLuxe', 145, '2019-04-04', 101, NULL),
('Hotel deLuxe', 145, '2019-04-05', 340, NULL),
('Hotel deLuxe', 145, '2019-04-06', 170, NULL),
('Hotel deLuxe', 145, '2019-04-07', 387, NULL),
('Hotel deLuxe', 145, '2019-04-08', 246, NULL),
('Hotel deLuxe', 145, '2019-04-09', 228, NULL),
('Hotel deLuxe', 145, '2019-04-10', 324, NULL),
('Hotel deLuxe', 145, '2019-04-11', 201, NULL),
('Hotel deLuxe', 145, '2019-04-12', 391, NULL),
('Hotel deLuxe', 145, '2019-04-13', 388, NULL),
('Hotel deLuxe', 145, '2019-04-14', 281, NULL),
('Hotel deLuxe', 145, '2019-04-15', 227, NULL),
('Hotel deLuxe', 145, '2019-04-16', 385, NULL),
('Hotel deLuxe', 145, '2019-04-17', 350, NULL),
('Hotel deLuxe', 145, '2019-04-18', 277, NULL),
('Hotel deLuxe', 145, '2019-04-19', 204, NULL),
('Hotel deLuxe', 145, '2019-04-20', 167, NULL),
('Hotel deLuxe', 145, '2019-04-21', 233, NULL),
('Hotel deLuxe', 145, '2019-04-22', 281, NULL),
('Hotel deLuxe', 145, '2019-04-23', 362, NULL),
('Hotel deLuxe', 145, '2019-04-24', 359, NULL),
('Hotel deLuxe', 145, '2019-04-25', 269, NULL),
('Hotel deLuxe', 145, '2019-04-26', 261, NULL),
('Hotel deLuxe', 145, '2019-04-27', 360, NULL),
('Hotel deLuxe', 145, '2019-04-28', 265, NULL),
('Hotel deLuxe', 145, '2019-04-29', 294, NULL),
('Hotel deLuxe', 145, '2019-04-30', 283, NULL),
('Hotel deLuxe', 145, '2019-05-01', 146, NULL),
('Hotel deLuxe', 145, '2019-05-02', 327, NULL),
('Hotel deLuxe', 145, '2019-05-03', 359, NULL),
('Hotel deLuxe', 145, '2019-05-04', 332, NULL),
('Hotel deLuxe', 145, '2019-05-05', 265, NULL),
('Hotel deLuxe', 145, '2019-05-06', 356, NULL),
('Hotel deLuxe', 145, '2019-05-07', 236, NULL),
('Hotel deLuxe', 145, '2019-05-08', 322, NULL),
('Hotel deLuxe', 145, '2019-05-09', 200, NULL),
('Hotel deLuxe', 145, '2019-05-10', 196, NULL),
('Hotel deLuxe', 145, '2019-05-11', 124, NULL),
('Hotel deLuxe', 145, '2019-05-12', 322, NULL),
('Hotel deLuxe', 145, '2019-05-13', 136, NULL),
('Hotel deLuxe', 145, '2019-05-14', 115, NULL),
('Hotel deLuxe', 145, '2019-05-15', 257, NULL),
('Hotel deLuxe', 145, '2019-05-16', 244, NULL),
('Hotel deLuxe', 145, '2019-05-17', 337, NULL),
('Hotel deLuxe', 145, '2019-05-18', 236, NULL),
('Hotel deLuxe', 145, '2019-05-19', 315, NULL),
('Hotel deLuxe', 145, '2019-05-20', 314, NULL),
('Hotel deLuxe', 145, '2019-05-21', 243, NULL),
('Hotel deLuxe', 145, '2019-05-22', 160, NULL),
('Hotel deLuxe', 145, '2019-05-23', 311, NULL),
('Hotel deLuxe', 145, '2019-05-24', 198, NULL),
('Hotel deLuxe', 145, '2019-05-25', 139, NULL),
('Hotel deLuxe', 145, '2019-05-26', 172, NULL),
('Hotel deLuxe', 145, '2019-05-27', 207, NULL),
('Hotel deLuxe', 145, '2019-05-28', 107, NULL),
('Hotel deLuxe', 145, '2019-05-29', 297, NULL),
('Hotel deLuxe', 145, '2019-05-30', 160, NULL),
('Hotel deLuxe', 145, '2019-05-31', 347, NULL),
('Hotel deLuxe', 145, '2019-06-01', 180, NULL),
('Hotel deLuxe', 145, '2019-06-02', 320, NULL),
('Hotel deLuxe', 145, '2019-06-03', 155, NULL),
('Hotel deLuxe', 145, '2019-06-04', 373, NULL),
('Hotel deLuxe', 145, '2019-06-05', 146, NULL),
('Hotel deLuxe', 145, '2019-06-06', 239, NULL),
('Hotel deLuxe', 145, '2019-06-07', 389, NULL),
('Hotel deLuxe', 145, '2019-06-08', 198, NULL),
('Hotel deLuxe', 145, '2019-06-09', 282, NULL),
('Hotel deLuxe', 145, '2019-06-10', 285, NULL),
('Hotel deLuxe', 145, '2019-06-11', 138, NULL),
('Hotel deLuxe', 145, '2019-06-12', 200, NULL),
('Hotel deLuxe', 145, '2019-06-13', 215, NULL),
('Hotel deLuxe', 145, '2019-06-14', 154, NULL),
('Hotel deLuxe', 145, '2019-06-15', 188, NULL),
('Hotel deLuxe', 145, '2019-06-16', 325, NULL),
('Hotel deLuxe', 145, '2019-06-17', 225, NULL),
('Hotel deLuxe', 145, '2019-06-18', 232, NULL),
('Hotel deLuxe', 145, '2019-06-19', 295, NULL),
('Hotel deLuxe', 145, '2019-06-20', 381, NULL),
('Hotel deLuxe', 145, '2019-06-21', 378, NULL),
('Hotel deLuxe', 145, '2019-06-22', 363, NULL),
('Hotel deLuxe', 145, '2019-06-23', 252, NULL),
('Hotel deLuxe', 145, '2019-06-24', 192, NULL),
('Hotel deLuxe', 145, '2019-06-25', 346, NULL),
('Hotel deLuxe', 145, '2019-06-26', 253, NULL),
('Hotel deLuxe', 145, '2019-06-27', 177, NULL),
('Hotel deLuxe', 145, '2019-06-28', 195, NULL),
('Hotel deLuxe', 145, '2019-06-29', 224, NULL),
('Hotel deLuxe', 145, '2019-06-30', 103, NULL),
('Hotel deLuxe', 145, '2019-07-01', 389, NULL),
('Hotel deLuxe', 145, '2019-07-02', 139, NULL),
('Hotel deLuxe', 145, '2019-07-03', 227, NULL),
('Hotel deLuxe', 145, '2019-07-04', 304, NULL),
('Hotel deLuxe', 145, '2019-07-05', 382, NULL),
('Hotel deLuxe', 145, '2019-07-06', 124, NULL),
('Hotel deLuxe', 145, '2019-07-07', 143, NULL),
('Hotel deLuxe', 145, '2019-07-08', 308, NULL),
('Hotel deLuxe', 145, '2019-07-09', 399, NULL),
('Hotel deLuxe', 145, '2019-07-10', 378, NULL),
('Hotel deLuxe', 145, '2019-07-11', 169, NULL),
('Hotel deLuxe', 145, '2019-07-12', 331, NULL),
('Hotel deLuxe', 145, '2019-07-13', 240, NULL),
('Hotel deLuxe', 145, '2019-07-14', 163, NULL),
('Hotel deLuxe', 145, '2019-07-15', 207, NULL),
('Hotel deLuxe', 145, '2019-07-16', 330, NULL),
('Hotel deLuxe', 145, '2019-07-17', 156, NULL),
('Hotel deLuxe', 145, '2019-07-18', 213, NULL),
('Hotel deLuxe', 145, '2019-07-19', 360, NULL),
('Hotel deLuxe', 145, '2019-07-20', 345, NULL),
('Hotel deLuxe', 145, '2019-07-21', 368, NULL),
('Hotel deLuxe', 145, '2019-07-22', 245, NULL),
('Hotel deLuxe', 145, '2019-07-23', 321, NULL),
('Hotel deLuxe', 145, '2019-07-24', 322, NULL),
('Hotel deLuxe', 145, '2019-07-25', 159, NULL),
('Hotel deLuxe', 145, '2019-07-26', 116, NULL),
('Hotel deLuxe', 145, '2019-07-27', 392, NULL),
('Hotel deLuxe', 145, '2019-07-28', 266, NULL),
('Hotel deLuxe', 145, '2019-07-29', 284, NULL),
('Hotel deLuxe', 145, '2019-07-30', 174, NULL),
('Hotel deLuxe', 145, '2019-07-31', 282, NULL),
('Hotel deLuxe', 145, '2019-08-01', 349, NULL),
('Hotel deLuxe', 145, '2019-08-02', 101, NULL),
('Hotel deLuxe', 145, '2019-08-03', 129, NULL),
('Hotel deLuxe', 145, '2019-08-04', 243, NULL),
('Hotel deLuxe', 145, '2019-08-05', 243, NULL),
('Hotel deLuxe', 145, '2019-08-06', 365, NULL),
('Hotel deLuxe', 145, '2019-08-07', 135, NULL),
('Hotel deLuxe', 145, '2019-08-08', 102, NULL),
('Hotel deLuxe', 145, '2019-08-09', 143, NULL),
('Hotel deLuxe', 145, '2019-08-10', 242, NULL),
('Hotel deLuxe', 145, '2019-08-11', 253, NULL),
('Hotel deLuxe', 145, '2019-08-12', 181, NULL),
('Hotel deLuxe', 145, '2019-08-13', 324, NULL),
('Hotel deLuxe', 145, '2019-08-14', 384, NULL),
('Hotel deLuxe', 145, '2019-08-15', 219, NULL),
('Hotel deLuxe', 145, '2019-08-16', 383, NULL),
('Hotel deLuxe', 145, '2019-08-17', 299, NULL),
('Hotel deLuxe', 145, '2019-08-18', 190, NULL),
('Hotel deLuxe', 145, '2019-08-19', 250, NULL),
('Hotel deLuxe', 145, '2019-08-20', 356, NULL),
('Hotel deLuxe', 145, '2019-08-21', 138, NULL),
('Hotel deLuxe', 145, '2019-08-22', 352, NULL),
('Hotel deLuxe', 145, '2019-08-23', 186, NULL),
('Hotel deLuxe', 145, '2019-08-24', 391, NULL),
('Hotel deLuxe', 145, '2019-08-25', 299, NULL),
('Hotel deLuxe', 145, '2019-08-26', 213, NULL),
('Hotel deLuxe', 145, '2019-08-27', 343, NULL),
('Hotel deLuxe', 145, '2019-08-28', 171, NULL),
('Hotel deLuxe', 145, '2019-08-29', 267, NULL),
('Hotel deLuxe', 145, '2019-08-30', 159, NULL),
('Hotel deLuxe', 145, '2019-08-31', 360, NULL),
('Hotel deLuxe', 145, '2019-09-01', 255, NULL),
('Hotel deLuxe', 145, '2019-09-02', 219, NULL),
('Hotel deLuxe', 145, '2019-09-03', 143, NULL),
('Hotel deLuxe', 145, '2019-09-04', 284, NULL),
('Hotel deLuxe', 145, '2019-09-05', 208, NULL),
('Hotel deLuxe', 145, '2019-09-06', 197, NULL),
('Hotel deLuxe', 145, '2019-09-07', 326, NULL),
('Hotel deLuxe', 145, '2019-09-08', 186, NULL),
('Hotel deLuxe', 145, '2019-09-09', 283, NULL),
('Hotel deLuxe', 145, '2019-09-10', 194, NULL),
('Hotel deLuxe', 145, '2019-09-11', 392, NULL),
('Hotel deLuxe', 145, '2019-09-12', 342, NULL),
('Hotel deLuxe', 145, '2019-09-13', 102, NULL),
('Hotel deLuxe', 145, '2019-09-14', 189, NULL),
('Hotel deLuxe', 145, '2019-09-15', 196, NULL),
('Hotel deLuxe', 145, '2019-09-16', 151, NULL),
('Hotel deLuxe', 145, '2019-09-17', 105, NULL),
('Hotel deLuxe', 145, '2019-09-18', 339, NULL),
('Hotel deLuxe', 145, '2019-09-19', 334, NULL),
('Hotel deLuxe', 145, '2019-09-20', 243, NULL),
('Hotel deLuxe', 145, '2019-09-21', 397, NULL),
('Hotel deLuxe', 145, '2019-09-22', 151, NULL),
('Hotel deLuxe', 145, '2019-09-23', 235, NULL),
('Hotel deLuxe', 145, '2019-09-24', 346, NULL),
('Hotel deLuxe', 145, '2019-09-25', 357, NULL),
('Hotel deLuxe', 145, '2019-09-26', 230, NULL),
('Hotel deLuxe', 145, '2019-09-27', 189, NULL),
('Hotel deLuxe', 145, '2019-09-28', 131, NULL),
('Hotel deLuxe', 145, '2019-09-29', 266, NULL),
('Hotel deLuxe', 145, '2019-09-30', 266, NULL),
('Hotel deLuxe', 145, '2019-10-01', 332, NULL),
('Hotel deLuxe', 145, '2019-10-02', 209, NULL),
('Hotel deLuxe', 145, '2019-10-03', 274, NULL),
('Hotel deLuxe', 145, '2019-10-04', 229, NULL),
('Hotel deLuxe', 145, '2019-10-05', 260, NULL),
('Hotel deLuxe', 145, '2019-10-06', 205, NULL),
('Hotel deLuxe', 145, '2019-10-07', 338, NULL),
('Hotel deLuxe', 145, '2019-10-08', 210, NULL),
('Hotel deLuxe', 145, '2019-10-09', 265, NULL),
('Hotel deLuxe', 145, '2019-10-10', 315, NULL),
('Hotel deLuxe', 145, '2019-10-11', 323, NULL),
('Hotel deLuxe', 145, '2019-10-12', 188, NULL),
('Hotel deLuxe', 145, '2019-10-13', 147, NULL),
('Hotel deLuxe', 145, '2019-10-14', 148, NULL),
('Hotel deLuxe', 145, '2019-10-15', 230, NULL),
('Hotel deLuxe', 145, '2019-10-16', 354, NULL),
('Hotel deLuxe', 145, '2019-10-17', 296, NULL),
('Hotel deLuxe', 145, '2019-10-18', 119, NULL),
('Hotel deLuxe', 145, '2019-10-19', 120, NULL),
('Hotel deLuxe', 145, '2019-10-20', 174, NULL),
('Hotel deLuxe', 145, '2019-10-21', 235, NULL),
('Hotel deLuxe', 145, '2019-10-22', 344, NULL),
('Hotel deLuxe', 145, '2019-10-23', 195, NULL),
('Hotel deLuxe', 145, '2019-10-24', 348, NULL),
('Hotel deLuxe', 145, '2019-10-25', 300, NULL),
('Hotel deLuxe', 145, '2019-10-26', 263, NULL),
('Hotel deLuxe', 145, '2019-10-27', 313, NULL),
('Hotel deLuxe', 145, '2019-10-28', 360, NULL),
('Hotel deLuxe', 145, '2019-10-29', 196, NULL),
('Hotel deLuxe', 145, '2019-10-30', 335, NULL),
('Hotel deLuxe', 145, '2019-10-31', 350, NULL),
('Hotel deLuxe', 145, '2019-11-01', 123, NULL),
('Hotel deLuxe', 145, '2019-11-02', 261, NULL),
('Hotel deLuxe', 145, '2019-11-03', 339, NULL),
('Hotel deLuxe', 145, '2019-11-04', 379, NULL),
('Hotel deLuxe', 145, '2019-11-05', 178, NULL),
('Hotel deLuxe', 145, '2019-11-06', 276, NULL),
('Hotel deLuxe', 145, '2019-11-07', 256, NULL),
('Hotel deLuxe', 145, '2019-11-08', 199, NULL),
('Hotel deLuxe', 145, '2019-11-09', 129, NULL),
('Hotel deLuxe', 145, '2019-11-10', 376, NULL),
('Hotel deLuxe', 145, '2019-11-11', 261, NULL),
('Hotel deLuxe', 145, '2019-11-12', 248, NULL),
('Hotel deLuxe', 145, '2019-11-13', 143, NULL),
('Hotel deLuxe', 145, '2019-11-14', 364, NULL),
('Hotel deLuxe', 145, '2019-11-15', 318, NULL),
('Hotel deLuxe', 145, '2019-11-16', 316, NULL),
('Hotel deLuxe', 145, '2019-11-17', 308, NULL),
('Hotel deLuxe', 145, '2019-11-18', 238, NULL),
('Hotel deLuxe', 145, '2019-11-19', 325, NULL),
('Hotel deLuxe', 145, '2019-11-20', 159, NULL),
('Hotel deLuxe', 145, '2019-11-21', 349, NULL),
('Hotel deLuxe', 145, '2019-11-22', 243, NULL),
('Hotel deLuxe', 145, '2019-11-23', 166, NULL),
('Hotel deLuxe', 145, '2019-11-24', 387, NULL),
('Hotel deLuxe', 145, '2019-11-25', 107, NULL),
('Hotel deLuxe', 145, '2019-11-26', 177, NULL),
('Hotel deLuxe', 145, '2019-11-27', 230, NULL),
('Hotel deLuxe', 145, '2019-11-28', 208, NULL),
('Hotel deLuxe', 145, '2019-11-29', 350, NULL),
('Hotel deLuxe', 145, '2019-11-30', 299, NULL),
('Hotel deLuxe', 145, '2019-12-01', 252, NULL),
('Hotel deLuxe', 145, '2019-12-02', 199, NULL),
('Hotel deLuxe', 145, '2019-12-03', 232, NULL),
('Hotel deLuxe', 145, '2019-12-04', 393, NULL),
('Hotel deLuxe', 145, '2019-12-05', 351, NULL),
('Hotel deLuxe', 145, '2019-12-06', 260, NULL),
('Hotel deLuxe', 145, '2019-12-07', 143, NULL),
('Hotel deLuxe', 145, '2019-12-08', 329, NULL),
('Hotel deLuxe', 145, '2019-12-09', 193, NULL),
('Hotel deLuxe', 145, '2019-12-10', 274, NULL),
('Hotel deLuxe', 145, '2019-12-11', 229, NULL),
('Hotel deLuxe', 145, '2019-12-12', 211, NULL),
('Hotel deLuxe', 145, '2019-12-13', 130, NULL),
('Hotel deLuxe', 145, '2019-12-14', 234, NULL),
('Hotel deLuxe', 145, '2019-12-15', 300, NULL),
('Hotel deLuxe', 145, '2019-12-16', 280, NULL),
('Hotel deLuxe', 145, '2019-12-17', 332, NULL),
('Hotel deLuxe', 145, '2019-12-18', 220, NULL),
('Hotel deLuxe', 145, '2019-12-19', 340, NULL),
('Hotel deLuxe', 145, '2019-12-20', 399, NULL),
('Hotel deLuxe', 145, '2019-12-21', 168, NULL),
('Hotel deLuxe', 145, '2019-12-22', 101, NULL),
('Hotel deLuxe', 145, '2019-12-23', 205, NULL),
('Hotel deLuxe', 145, '2019-12-24', 367, NULL),
('Hotel deLuxe', 145, '2019-12-25', 180, NULL),
('Hotel deLuxe', 145, '2019-12-26', 273, NULL),
('Hotel deLuxe', 145, '2019-12-27', 181, NULL),
('Hotel deLuxe', 145, '2019-12-28', 206, NULL),
('Hotel deLuxe', 145, '2019-12-29', 252, NULL),
('Hotel deLuxe', 145, '2019-12-30', 212, NULL),
('Hotel deLuxe', 145, '2019-12-31', 134, NULL),
('Hotel deLuxe', 145, '2020-01-01', 174, NULL),
('Hotel deLuxe', 145, '2020-01-02', 390, NULL),
('Hotel deLuxe', 145, '2020-01-03', 122, NULL),
('Hotel deLuxe', 145, '2020-01-04', 356, NULL),
('Hotel deLuxe', 145, '2020-01-05', 271, NULL),
('Hotel deLuxe', 145, '2020-01-06', 156, NULL),
('Hotel deLuxe', 145, '2020-01-07', 328, NULL),
('Hotel deLuxe', 145, '2020-01-08', 134, NULL),
('Hotel deLuxe', 145, '2020-01-09', 205, NULL),
('Hotel deLuxe', 145, '2020-01-10', 178, NULL),
('Hotel deLuxe', 145, '2020-01-11', 376, NULL),
('Hotel deLuxe', 145, '2020-01-12', 163, NULL),
('Hotel deLuxe', 145, '2020-01-13', 112, NULL),
('Hotel deLuxe', 145, '2020-01-14', 205, NULL),
('Hotel deLuxe', 145, '2020-01-15', 257, NULL),
('Hotel deLuxe', 145, '2020-01-16', 224, NULL),
('Hotel deLuxe', 145, '2020-01-17', 357, NULL),
('Hotel deLuxe', 145, '2020-01-18', 354, NULL),
('Hotel deLuxe', 145, '2020-01-19', 331, NULL),
('Hotel deLuxe', 145, '2020-01-20', 217, NULL),
('Hotel deLuxe', 145, '2020-01-21', 282, NULL),
('Hotel deLuxe', 145, '2020-01-22', 160, NULL),
('Hotel deLuxe', 145, '2020-01-23', 245, NULL),
('Hotel deLuxe', 145, '2020-01-24', 103, NULL),
('Hotel deLuxe', 145, '2020-01-25', 170, NULL),
('Hotel deLuxe', 145, '2020-01-26', 178, NULL),
('Hotel deLuxe', 145, '2020-01-27', 362, NULL),
('Hotel deLuxe', 145, '2020-01-28', 189, NULL),
('Hotel deLuxe', 145, '2020-01-29', 108, NULL),
('Hotel deLuxe', 145, '2020-01-30', 315, NULL),
('Hotel deLuxe', 145, '2020-01-31', 158, NULL),
('Hotel deLuxe', 145, '2020-02-01', 129, NULL),
('Hotel deLuxe', 145, '2020-02-02', 207, NULL),
('Hotel deLuxe', 145, '2020-02-03', 231, NULL),
('Hotel deLuxe', 145, '2020-02-04', 215, NULL),
('Hotel deLuxe', 153, '2019-01-01', 136, NULL),
('Hotel deLuxe', 153, '2019-01-02', 263, NULL),
('Hotel deLuxe', 153, '2019-01-03', 108, NULL),
('Hotel deLuxe', 153, '2019-01-04', 314, NULL),
('Hotel deLuxe', 153, '2019-01-05', 267, NULL),
('Hotel deLuxe', 153, '2019-01-06', 348, NULL),
('Hotel deLuxe', 153, '2019-01-07', 135, NULL),
('Hotel deLuxe', 153, '2019-01-08', 392, NULL),
('Hotel deLuxe', 153, '2019-01-09', 186, NULL),
('Hotel deLuxe', 153, '2019-01-10', 148, NULL),
('Hotel deLuxe', 153, '2019-01-11', 388, NULL),
('Hotel deLuxe', 153, '2019-01-12', 301, NULL),
('Hotel deLuxe', 153, '2019-01-13', 322, NULL),
('Hotel deLuxe', 153, '2019-01-14', 179, NULL),
('Hotel deLuxe', 153, '2019-01-15', 138, NULL),
('Hotel deLuxe', 153, '2019-01-16', 369, NULL),
('Hotel deLuxe', 153, '2019-01-17', 206, NULL),
('Hotel deLuxe', 153, '2019-01-18', 215, NULL),
('Hotel deLuxe', 153, '2019-01-19', 141, NULL),
('Hotel deLuxe', 153, '2019-01-20', 274, NULL),
('Hotel deLuxe', 153, '2019-01-21', 241, NULL),
('Hotel deLuxe', 153, '2019-01-22', 182, NULL),
('Hotel deLuxe', 153, '2019-01-23', 303, NULL),
('Hotel deLuxe', 153, '2019-01-24', 205, NULL),
('Hotel deLuxe', 153, '2019-01-25', 167, NULL),
('Hotel deLuxe', 153, '2019-01-26', 350, NULL),
('Hotel deLuxe', 153, '2019-01-27', 133, NULL),
('Hotel deLuxe', 153, '2019-01-28', 233, NULL),
('Hotel deLuxe', 153, '2019-01-29', 267, NULL),
('Hotel deLuxe', 153, '2019-01-30', 134, NULL),
('Hotel deLuxe', 153, '2019-01-31', 170, NULL),
('Hotel deLuxe', 153, '2019-02-01', 301, NULL),
('Hotel deLuxe', 153, '2019-02-02', 237, NULL),
('Hotel deLuxe', 153, '2019-02-03', 354, NULL),
('Hotel deLuxe', 153, '2019-02-04', 375, NULL),
('Hotel deLuxe', 153, '2019-02-05', 192, NULL),
('Hotel deLuxe', 153, '2019-02-06', 116, NULL),
('Hotel deLuxe', 153, '2019-02-07', 355, NULL),
('Hotel deLuxe', 153, '2019-02-08', 295, NULL),
('Hotel deLuxe', 153, '2019-02-09', 152, NULL),
('Hotel deLuxe', 153, '2019-02-10', 261, NULL),
('Hotel deLuxe', 153, '2019-02-11', 290, NULL),
('Hotel deLuxe', 153, '2019-02-12', 206, NULL),
('Hotel deLuxe', 153, '2019-02-13', 195, NULL),
('Hotel deLuxe', 153, '2019-02-14', 151, NULL),
('Hotel deLuxe', 153, '2019-02-15', 196, NULL),
('Hotel deLuxe', 153, '2019-02-16', 290, NULL),
('Hotel deLuxe', 153, '2019-02-17', 101, NULL),
('Hotel deLuxe', 153, '2019-02-18', 392, NULL),
('Hotel deLuxe', 153, '2019-02-19', 354, NULL),
('Hotel deLuxe', 153, '2019-02-20', 268, NULL),
('Hotel deLuxe', 153, '2019-02-21', 320, NULL),
('Hotel deLuxe', 153, '2019-02-22', 233, NULL),
('Hotel deLuxe', 153, '2019-02-23', 364, NULL),
('Hotel deLuxe', 153, '2019-02-24', 173, NULL),
('Hotel deLuxe', 153, '2019-02-25', 160, NULL),
('Hotel deLuxe', 153, '2019-02-26', 354, NULL),
('Hotel deLuxe', 153, '2019-02-27', 281, NULL),
('Hotel deLuxe', 153, '2019-02-28', 275, NULL),
('Hotel deLuxe', 153, '2019-03-01', 384, NULL),
('Hotel deLuxe', 153, '2019-03-02', 231, NULL),
('Hotel deLuxe', 153, '2019-03-03', 204, NULL),
('Hotel deLuxe', 153, '2019-03-04', 129, NULL),
('Hotel deLuxe', 153, '2019-03-05', 243, NULL),
('Hotel deLuxe', 153, '2019-03-06', 353, NULL),
('Hotel deLuxe', 153, '2019-03-07', 346, NULL),
('Hotel deLuxe', 153, '2019-03-08', 294, NULL),
('Hotel deLuxe', 153, '2019-03-09', 128, NULL),
('Hotel deLuxe', 153, '2019-03-10', 228, NULL),
('Hotel deLuxe', 153, '2019-03-11', 310, NULL),
('Hotel deLuxe', 153, '2019-03-12', 292, NULL),
('Hotel deLuxe', 153, '2019-03-13', 144, NULL),
('Hotel deLuxe', 153, '2019-03-14', 173, NULL),
('Hotel deLuxe', 153, '2019-03-15', 174, NULL),
('Hotel deLuxe', 153, '2019-03-16', 170, NULL),
('Hotel deLuxe', 153, '2019-03-17', 233, NULL),
('Hotel deLuxe', 153, '2019-03-18', 267, NULL),
('Hotel deLuxe', 153, '2019-03-19', 263, NULL),
('Hotel deLuxe', 153, '2019-03-20', 363, NULL),
('Hotel deLuxe', 153, '2019-03-21', 288, NULL),
('Hotel deLuxe', 153, '2019-03-22', 321, NULL),
('Hotel deLuxe', 153, '2019-03-23', 109, NULL),
('Hotel deLuxe', 153, '2019-03-24', 274, NULL),
('Hotel deLuxe', 153, '2019-03-25', 320, NULL),
('Hotel deLuxe', 153, '2019-03-26', 329, NULL),
('Hotel deLuxe', 153, '2019-03-27', 302, NULL),
('Hotel deLuxe', 153, '2019-03-28', 380, NULL),
('Hotel deLuxe', 153, '2019-03-29', 254, NULL),
('Hotel deLuxe', 153, '2019-03-30', 297, NULL),
('Hotel deLuxe', 153, '2019-03-31', 318, NULL),
('Hotel deLuxe', 153, '2019-04-01', 260, NULL),
('Hotel deLuxe', 153, '2019-04-02', 153, NULL),
('Hotel deLuxe', 153, '2019-04-03', 280, NULL),
('Hotel deLuxe', 153, '2019-04-04', 149, NULL),
('Hotel deLuxe', 153, '2019-04-05', 325, NULL),
('Hotel deLuxe', 153, '2019-04-06', 272, NULL),
('Hotel deLuxe', 153, '2019-04-07', 370, NULL),
('Hotel deLuxe', 153, '2019-04-08', 332, NULL),
('Hotel deLuxe', 153, '2019-04-09', 310, NULL),
('Hotel deLuxe', 153, '2019-04-10', 171, NULL),
('Hotel deLuxe', 153, '2019-04-11', 128, NULL),
('Hotel deLuxe', 153, '2019-04-12', 292, NULL),
('Hotel deLuxe', 153, '2019-04-13', 146, NULL),
('Hotel deLuxe', 153, '2019-04-14', 392, NULL),
('Hotel deLuxe', 153, '2019-04-15', 353, NULL),
('Hotel deLuxe', 153, '2019-04-16', 130, NULL),
('Hotel deLuxe', 153, '2019-04-17', 304, NULL),
('Hotel deLuxe', 153, '2019-04-18', 241, NULL),
('Hotel deLuxe', 153, '2019-04-19', 258, NULL),
('Hotel deLuxe', 153, '2019-04-20', 284, NULL),
('Hotel deLuxe', 153, '2019-04-21', 220, NULL),
('Hotel deLuxe', 153, '2019-04-22', 252, NULL),
('Hotel deLuxe', 153, '2019-04-23', 159, NULL),
('Hotel deLuxe', 153, '2019-04-24', 191, NULL),
('Hotel deLuxe', 153, '2019-04-25', 379, NULL),
('Hotel deLuxe', 153, '2019-04-26', 223, NULL),
('Hotel deLuxe', 153, '2019-04-27', 127, NULL),
('Hotel deLuxe', 153, '2019-04-28', 281, NULL),
('Hotel deLuxe', 153, '2019-04-29', 180, NULL),
('Hotel deLuxe', 153, '2019-04-30', 191, NULL),
('Hotel deLuxe', 153, '2019-05-01', 278, NULL),
('Hotel deLuxe', 153, '2019-05-02', 145, NULL),
('Hotel deLuxe', 153, '2019-05-03', 160, NULL),
('Hotel deLuxe', 153, '2019-05-04', 253, NULL),
('Hotel deLuxe', 153, '2019-05-05', 123, NULL),
('Hotel deLuxe', 153, '2019-05-06', 298, NULL),
('Hotel deLuxe', 153, '2019-05-07', 353, NULL),
('Hotel deLuxe', 153, '2019-05-08', 244, NULL),
('Hotel deLuxe', 153, '2019-05-09', 150, NULL),
('Hotel deLuxe', 153, '2019-05-10', 133, NULL),
('Hotel deLuxe', 153, '2019-05-11', 391, NULL),
('Hotel deLuxe', 153, '2019-05-12', 140, NULL),
('Hotel deLuxe', 153, '2019-05-13', 367, NULL),
('Hotel deLuxe', 153, '2019-05-14', 225, NULL),
('Hotel deLuxe', 153, '2019-05-15', 238, NULL),
('Hotel deLuxe', 153, '2019-05-16', 368, NULL),
('Hotel deLuxe', 153, '2019-05-17', 347, NULL),
('Hotel deLuxe', 153, '2019-05-18', 285, NULL),
('Hotel deLuxe', 153, '2019-05-19', 312, NULL),
('Hotel deLuxe', 153, '2019-05-20', 240, NULL),
('Hotel deLuxe', 153, '2019-05-21', 379, NULL),
('Hotel deLuxe', 153, '2019-05-22', 241, NULL),
('Hotel deLuxe', 153, '2019-05-23', 352, NULL),
('Hotel deLuxe', 153, '2019-05-24', 355, NULL),
('Hotel deLuxe', 153, '2019-05-25', 119, NULL),
('Hotel deLuxe', 153, '2019-05-26', 192, NULL),
('Hotel deLuxe', 153, '2019-05-27', 127, NULL),
('Hotel deLuxe', 153, '2019-05-28', 135, NULL),
('Hotel deLuxe', 153, '2019-05-29', 338, NULL),
('Hotel deLuxe', 153, '2019-05-30', 224, NULL),
('Hotel deLuxe', 153, '2019-05-31', 321, NULL),
('Hotel deLuxe', 153, '2019-06-01', 297, NULL),
('Hotel deLuxe', 153, '2019-06-02', 266, NULL),
('Hotel deLuxe', 153, '2019-06-03', 198, NULL),
('Hotel deLuxe', 153, '2019-06-04', 191, NULL),
('Hotel deLuxe', 153, '2019-06-05', 194, NULL),
('Hotel deLuxe', 153, '2019-06-06', 196, NULL),
('Hotel deLuxe', 153, '2019-06-07', 310, NULL),
('Hotel deLuxe', 153, '2019-06-08', 318, NULL),
('Hotel deLuxe', 153, '2019-06-09', 361, NULL),
('Hotel deLuxe', 153, '2019-06-10', 160, NULL),
('Hotel deLuxe', 153, '2019-06-11', 200, NULL),
('Hotel deLuxe', 153, '2019-06-12', 134, NULL),
('Hotel deLuxe', 153, '2019-06-13', 170, NULL),
('Hotel deLuxe', 153, '2019-06-14', 127, NULL),
('Hotel deLuxe', 153, '2019-06-15', 392, NULL),
('Hotel deLuxe', 153, '2019-06-16', 151, NULL),
('Hotel deLuxe', 153, '2019-06-17', 257, NULL),
('Hotel deLuxe', 153, '2019-06-18', 147, NULL),
('Hotel deLuxe', 153, '2019-06-19', 307, NULL),
('Hotel deLuxe', 153, '2019-06-20', 236, NULL),
('Hotel deLuxe', 153, '2019-06-21', 310, NULL),
('Hotel deLuxe', 153, '2019-06-22', 117, NULL),
('Hotel deLuxe', 153, '2019-06-23', 141, NULL),
('Hotel deLuxe', 153, '2019-06-24', 147, NULL),
('Hotel deLuxe', 153, '2019-06-25', 236, NULL),
('Hotel deLuxe', 153, '2019-06-26', 355, NULL),
('Hotel deLuxe', 153, '2019-06-27', 389, NULL),
('Hotel deLuxe', 153, '2019-06-28', 256, NULL),
('Hotel deLuxe', 153, '2019-06-29', 208, NULL),
('Hotel deLuxe', 153, '2019-06-30', 278, NULL),
('Hotel deLuxe', 153, '2019-07-01', 397, NULL),
('Hotel deLuxe', 153, '2019-07-02', 145, NULL),
('Hotel deLuxe', 153, '2019-07-03', 326, NULL),
('Hotel deLuxe', 153, '2019-07-04', 219, NULL),
('Hotel deLuxe', 153, '2019-07-05', 100, NULL),
('Hotel deLuxe', 153, '2019-07-06', 206, NULL),
('Hotel deLuxe', 153, '2019-07-07', 141, NULL),
('Hotel deLuxe', 153, '2019-07-08', 303, NULL),
('Hotel deLuxe', 153, '2019-07-09', 328, NULL),
('Hotel deLuxe', 153, '2019-07-10', 380, NULL),
('Hotel deLuxe', 153, '2019-07-11', 346, NULL),
('Hotel deLuxe', 153, '2019-07-12', 323, NULL),
('Hotel deLuxe', 153, '2019-07-13', 262, NULL),
('Hotel deLuxe', 153, '2019-07-14', 163, NULL),
('Hotel deLuxe', 153, '2019-07-15', 379, NULL),
('Hotel deLuxe', 153, '2019-07-16', 309, NULL),
('Hotel deLuxe', 153, '2019-07-17', 111, NULL),
('Hotel deLuxe', 153, '2019-07-18', 254, NULL),
('Hotel deLuxe', 153, '2019-07-19', 114, NULL),
('Hotel deLuxe', 153, '2019-07-20', 363, NULL),
('Hotel deLuxe', 153, '2019-07-21', 231, NULL),
('Hotel deLuxe', 153, '2019-07-22', 112, NULL),
('Hotel deLuxe', 153, '2019-07-23', 114, NULL),
('Hotel deLuxe', 153, '2019-07-24', 114, NULL),
('Hotel deLuxe', 153, '2019-07-25', 288, NULL),
('Hotel deLuxe', 153, '2019-07-26', 231, NULL),
('Hotel deLuxe', 153, '2019-07-27', 358, NULL),
('Hotel deLuxe', 153, '2019-07-28', 389, NULL),
('Hotel deLuxe', 153, '2019-07-29', 365, NULL),
('Hotel deLuxe', 153, '2019-07-30', 148, NULL),
('Hotel deLuxe', 153, '2019-07-31', 278, NULL),
('Hotel deLuxe', 153, '2019-08-01', 241, NULL),
('Hotel deLuxe', 153, '2019-08-02', 224, NULL),
('Hotel deLuxe', 153, '2019-08-03', 280, NULL),
('Hotel deLuxe', 153, '2019-08-04', 336, NULL),
('Hotel deLuxe', 153, '2019-08-05', 206, NULL),
('Hotel deLuxe', 153, '2019-08-06', 379, NULL),
('Hotel deLuxe', 153, '2019-08-07', 383, NULL),
('Hotel deLuxe', 153, '2019-08-08', 130, NULL),
('Hotel deLuxe', 153, '2019-08-09', 258, NULL),
('Hotel deLuxe', 153, '2019-08-10', 240, NULL),
('Hotel deLuxe', 153, '2019-08-11', 335, NULL),
('Hotel deLuxe', 153, '2019-08-12', 156, NULL),
('Hotel deLuxe', 153, '2019-08-13', 150, NULL),
('Hotel deLuxe', 153, '2019-08-14', 276, NULL),
('Hotel deLuxe', 153, '2019-08-15', 263, NULL),
('Hotel deLuxe', 153, '2019-08-16', 352, NULL),
('Hotel deLuxe', 153, '2019-08-17', 243, NULL),
('Hotel deLuxe', 153, '2019-08-18', 308, NULL),
('Hotel deLuxe', 153, '2019-08-19', 254, NULL),
('Hotel deLuxe', 153, '2019-08-20', 121, NULL),
('Hotel deLuxe', 153, '2019-08-21', 343, NULL),
('Hotel deLuxe', 153, '2019-08-22', 365, NULL),
('Hotel deLuxe', 153, '2019-08-23', 147, NULL),
('Hotel deLuxe', 153, '2019-08-24', 155, NULL),
('Hotel deLuxe', 153, '2019-08-25', 231, NULL),
('Hotel deLuxe', 153, '2019-08-26', 140, NULL),
('Hotel deLuxe', 153, '2019-08-27', 217, NULL),
('Hotel deLuxe', 153, '2019-08-28', 291, NULL),
('Hotel deLuxe', 153, '2019-08-29', 369, NULL),
('Hotel deLuxe', 153, '2019-08-30', 318, NULL),
('Hotel deLuxe', 153, '2019-08-31', 109, NULL),
('Hotel deLuxe', 153, '2019-09-01', 172, NULL),
('Hotel deLuxe', 153, '2019-09-02', 350, NULL),
('Hotel deLuxe', 153, '2019-09-03', 386, NULL),
('Hotel deLuxe', 153, '2019-09-04', 166, NULL),
('Hotel deLuxe', 153, '2019-09-05', 386, NULL),
('Hotel deLuxe', 153, '2019-09-06', 186, NULL),
('Hotel deLuxe', 153, '2019-09-07', 245, NULL),
('Hotel deLuxe', 153, '2019-09-08', 258, NULL),
('Hotel deLuxe', 153, '2019-09-09', 156, NULL),
('Hotel deLuxe', 153, '2019-09-10', 126, NULL),
('Hotel deLuxe', 153, '2019-09-11', 159, NULL),
('Hotel deLuxe', 153, '2019-09-12', 147, NULL),
('Hotel deLuxe', 153, '2019-09-13', 186, NULL),
('Hotel deLuxe', 153, '2019-09-14', 394, NULL),
('Hotel deLuxe', 153, '2019-09-15', 314, NULL),
('Hotel deLuxe', 153, '2019-09-16', 325, NULL),
('Hotel deLuxe', 153, '2019-09-17', 332, NULL),
('Hotel deLuxe', 153, '2019-09-18', 134, NULL),
('Hotel deLuxe', 153, '2019-09-19', 220, NULL),
('Hotel deLuxe', 153, '2019-09-20', 314, NULL),
('Hotel deLuxe', 153, '2019-09-21', 142, NULL),
('Hotel deLuxe', 153, '2019-09-22', 253, NULL),
('Hotel deLuxe', 153, '2019-09-23', 221, NULL),
('Hotel deLuxe', 153, '2019-09-24', 399, NULL),
('Hotel deLuxe', 153, '2019-09-25', 190, NULL),
('Hotel deLuxe', 153, '2019-09-26', 246, NULL),
('Hotel deLuxe', 153, '2019-09-27', 165, NULL),
('Hotel deLuxe', 153, '2019-09-28', 320, NULL),
('Hotel deLuxe', 153, '2019-09-29', 380, NULL),
('Hotel deLuxe', 153, '2019-09-30', 146, NULL),
('Hotel deLuxe', 153, '2019-10-01', 189, NULL),
('Hotel deLuxe', 153, '2019-10-02', 109, NULL),
('Hotel deLuxe', 153, '2019-10-03', 366, NULL),
('Hotel deLuxe', 153, '2019-10-04', 163, NULL),
('Hotel deLuxe', 153, '2019-10-05', 208, NULL),
('Hotel deLuxe', 153, '2019-10-06', 321, NULL),
('Hotel deLuxe', 153, '2019-10-07', 368, NULL),
('Hotel deLuxe', 153, '2019-10-08', 132, NULL),
('Hotel deLuxe', 153, '2019-10-09', 367, NULL),
('Hotel deLuxe', 153, '2019-10-10', 383, NULL),
('Hotel deLuxe', 153, '2019-10-11', 312, NULL),
('Hotel deLuxe', 153, '2019-10-12', 361, NULL),
('Hotel deLuxe', 153, '2019-10-13', 303, NULL),
('Hotel deLuxe', 153, '2019-10-14', 147, NULL),
('Hotel deLuxe', 153, '2019-10-15', 360, NULL),
('Hotel deLuxe', 153, '2019-10-16', 304, NULL),
('Hotel deLuxe', 153, '2019-10-17', 240, NULL),
('Hotel deLuxe', 153, '2019-10-18', 293, NULL),
('Hotel deLuxe', 153, '2019-10-19', 199, NULL),
('Hotel deLuxe', 153, '2019-10-20', 202, NULL),
('Hotel deLuxe', 153, '2019-10-21', 322, NULL),
('Hotel deLuxe', 153, '2019-10-22', 116, NULL),
('Hotel deLuxe', 153, '2019-10-23', 312, NULL),
('Hotel deLuxe', 153, '2019-10-24', 120, NULL),
('Hotel deLuxe', 153, '2019-10-25', 343, NULL),
('Hotel deLuxe', 153, '2019-10-26', 217, NULL),
('Hotel deLuxe', 153, '2019-10-27', 326, NULL),
('Hotel deLuxe', 153, '2019-10-28', 264, NULL),
('Hotel deLuxe', 153, '2019-10-29', 193, NULL),
('Hotel deLuxe', 153, '2019-10-30', 104, NULL),
('Hotel deLuxe', 153, '2019-10-31', 389, NULL),
('Hotel deLuxe', 153, '2019-11-01', 353, NULL),
('Hotel deLuxe', 153, '2019-11-02', 327, NULL),
('Hotel deLuxe', 153, '2019-11-03', 188, NULL),
('Hotel deLuxe', 153, '2019-11-04', 312, NULL),
('Hotel deLuxe', 153, '2019-11-05', 244, NULL),
('Hotel deLuxe', 153, '2019-11-06', 360, NULL),
('Hotel deLuxe', 153, '2019-11-07', 248, NULL),
('Hotel deLuxe', 153, '2019-11-08', 166, NULL),
('Hotel deLuxe', 153, '2019-11-09', 384, NULL),
('Hotel deLuxe', 153, '2019-11-10', 100, NULL),
('Hotel deLuxe', 153, '2019-11-11', 206, NULL),
('Hotel deLuxe', 153, '2019-11-12', 186, NULL),
('Hotel deLuxe', 153, '2019-11-13', 353, NULL),
('Hotel deLuxe', 153, '2019-11-14', 191, NULL),
('Hotel deLuxe', 153, '2019-11-15', 341, NULL),
('Hotel deLuxe', 153, '2019-11-16', 206, NULL),
('Hotel deLuxe', 153, '2019-11-17', 108, NULL),
('Hotel deLuxe', 153, '2019-11-18', 128, NULL),
('Hotel deLuxe', 153, '2019-11-19', 155, NULL),
('Hotel deLuxe', 153, '2019-11-20', 219, NULL),
('Hotel deLuxe', 153, '2019-11-21', 177, NULL),
('Hotel deLuxe', 153, '2019-11-22', 233, NULL),
('Hotel deLuxe', 153, '2019-11-23', 255, NULL),
('Hotel deLuxe', 153, '2019-11-24', 267, NULL),
('Hotel deLuxe', 153, '2019-11-25', 160, NULL),
('Hotel deLuxe', 153, '2019-11-26', 378, NULL),
('Hotel deLuxe', 153, '2019-11-27', 237, NULL),
('Hotel deLuxe', 153, '2019-11-28', 149, NULL),
('Hotel deLuxe', 153, '2019-11-29', 357, NULL),
('Hotel deLuxe', 153, '2019-11-30', 328, NULL),
('Hotel deLuxe', 153, '2019-12-01', 302, NULL),
('Hotel deLuxe', 153, '2019-12-02', 299, NULL),
('Hotel deLuxe', 153, '2019-12-03', 201, NULL),
('Hotel deLuxe', 153, '2019-12-04', 381, NULL),
('Hotel deLuxe', 153, '2019-12-05', 100, NULL),
('Hotel deLuxe', 153, '2019-12-06', 297, NULL),
('Hotel deLuxe', 153, '2019-12-07', 248, NULL),
('Hotel deLuxe', 153, '2019-12-08', 277, NULL),
('Hotel deLuxe', 153, '2019-12-09', 290, NULL),
('Hotel deLuxe', 153, '2019-12-10', 329, NULL),
('Hotel deLuxe', 153, '2019-12-11', 195, NULL),
('Hotel deLuxe', 153, '2019-12-12', 139, NULL),
('Hotel deLuxe', 153, '2019-12-13', 276, NULL),
('Hotel deLuxe', 153, '2019-12-14', 129, NULL),
('Hotel deLuxe', 153, '2019-12-15', 136, NULL),
('Hotel deLuxe', 153, '2019-12-16', 377, NULL),
('Hotel deLuxe', 153, '2019-12-17', 252, NULL),
('Hotel deLuxe', 153, '2019-12-18', 166, NULL),
('Hotel deLuxe', 153, '2019-12-19', 270, NULL),
('Hotel deLuxe', 153, '2019-12-20', 151, NULL),
('Hotel deLuxe', 153, '2019-12-21', 163, NULL),
('Hotel deLuxe', 153, '2019-12-22', 181, NULL),
('Hotel deLuxe', 153, '2019-12-23', 255, NULL),
('Hotel deLuxe', 153, '2019-12-24', 202, NULL),
('Hotel deLuxe', 153, '2019-12-25', 263, NULL),
('Hotel deLuxe', 153, '2019-12-26', 268, NULL),
('Hotel deLuxe', 153, '2019-12-27', 107, NULL),
('Hotel deLuxe', 153, '2019-12-28', 265, NULL),
('Hotel deLuxe', 153, '2019-12-29', 291, NULL),
('Hotel deLuxe', 153, '2019-12-30', 246, NULL),
('Hotel deLuxe', 153, '2019-12-31', 210, NULL),
('Hotel deLuxe', 153, '2020-01-01', 169, NULL),
('Hotel deLuxe', 153, '2020-01-02', 121, NULL),
('Hotel deLuxe', 153, '2020-01-03', 343, NULL),
('Hotel deLuxe', 153, '2020-01-04', 161, NULL),
('Hotel deLuxe', 153, '2020-01-05', 301, NULL),
('Hotel deLuxe', 153, '2020-01-06', 356, NULL),
('Hotel deLuxe', 153, '2020-01-07', 224, NULL),
('Hotel deLuxe', 153, '2020-01-08', 304, NULL),
('Hotel deLuxe', 153, '2020-01-09', 207, NULL),
('Hotel deLuxe', 153, '2020-01-10', 137, NULL),
('Hotel deLuxe', 153, '2020-01-11', 196, NULL),
('Hotel deLuxe', 153, '2020-01-12', 158, NULL),
('Hotel deLuxe', 153, '2020-01-13', 333, NULL),
('Hotel deLuxe', 153, '2020-01-14', 214, NULL),
('Hotel deLuxe', 153, '2020-01-15', 344, NULL),
('Hotel deLuxe', 153, '2020-01-16', 382, NULL),
('Hotel deLuxe', 153, '2020-01-17', 210, NULL),
('Hotel deLuxe', 153, '2020-01-18', 186, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 153, '2020-01-19', 127, NULL),
('Hotel deLuxe', 153, '2020-01-20', 246, NULL),
('Hotel deLuxe', 153, '2020-01-21', 310, NULL),
('Hotel deLuxe', 153, '2020-01-22', 174, NULL),
('Hotel deLuxe', 153, '2020-01-23', 190, NULL),
('Hotel deLuxe', 153, '2020-01-24', 367, NULL),
('Hotel deLuxe', 153, '2020-01-25', 100, NULL),
('Hotel deLuxe', 153, '2020-01-26', 214, NULL),
('Hotel deLuxe', 153, '2020-01-27', 131, NULL),
('Hotel deLuxe', 153, '2020-01-28', 258, NULL),
('Hotel deLuxe', 153, '2020-01-29', 334, NULL),
('Hotel deLuxe', 153, '2020-01-30', 160, NULL),
('Hotel deLuxe', 153, '2020-01-31', 232, NULL),
('Hotel deLuxe', 153, '2020-02-01', 168, NULL),
('Hotel deLuxe', 153, '2020-02-02', 130, NULL),
('Hotel deLuxe', 153, '2020-02-03', 142, NULL),
('Hotel deLuxe', 153, '2020-02-04', 324, NULL),
('Hotel deLuxe', 167, '2019-01-01', 266, NULL),
('Hotel deLuxe', 167, '2019-01-02', 312, NULL),
('Hotel deLuxe', 167, '2019-01-03', 237, NULL),
('Hotel deLuxe', 167, '2019-01-04', 330, NULL),
('Hotel deLuxe', 167, '2019-01-05', 373, NULL),
('Hotel deLuxe', 167, '2019-01-06', 293, NULL),
('Hotel deLuxe', 167, '2019-01-07', 223, NULL),
('Hotel deLuxe', 167, '2019-01-08', 249, NULL),
('Hotel deLuxe', 167, '2019-01-09', 267, NULL),
('Hotel deLuxe', 167, '2019-01-10', 234, NULL),
('Hotel deLuxe', 167, '2019-01-11', 117, NULL),
('Hotel deLuxe', 167, '2019-01-12', 127, NULL),
('Hotel deLuxe', 167, '2019-01-13', 255, NULL),
('Hotel deLuxe', 167, '2019-01-14', 352, NULL),
('Hotel deLuxe', 167, '2019-01-15', 341, NULL),
('Hotel deLuxe', 167, '2019-01-16', 130, NULL),
('Hotel deLuxe', 167, '2019-01-17', 367, NULL),
('Hotel deLuxe', 167, '2019-01-18', 309, NULL),
('Hotel deLuxe', 167, '2019-01-19', 294, NULL),
('Hotel deLuxe', 167, '2019-01-20', 256, NULL),
('Hotel deLuxe', 167, '2019-01-21', 264, NULL),
('Hotel deLuxe', 167, '2019-01-22', 277, NULL),
('Hotel deLuxe', 167, '2019-01-23', 111, NULL),
('Hotel deLuxe', 167, '2019-01-24', 207, NULL),
('Hotel deLuxe', 167, '2019-01-25', 389, NULL),
('Hotel deLuxe', 167, '2019-01-26', 180, NULL),
('Hotel deLuxe', 167, '2019-01-27', 265, NULL),
('Hotel deLuxe', 167, '2019-01-28', 219, NULL),
('Hotel deLuxe', 167, '2019-01-29', 358, NULL),
('Hotel deLuxe', 167, '2019-01-30', 342, NULL),
('Hotel deLuxe', 167, '2019-01-31', 331, NULL),
('Hotel deLuxe', 167, '2019-02-01', 107, NULL),
('Hotel deLuxe', 167, '2019-02-02', 275, NULL),
('Hotel deLuxe', 167, '2019-02-03', 306, NULL),
('Hotel deLuxe', 167, '2019-02-04', 214, NULL),
('Hotel deLuxe', 167, '2019-02-05', 297, NULL),
('Hotel deLuxe', 167, '2019-02-06', 135, NULL),
('Hotel deLuxe', 167, '2019-02-07', 155, NULL),
('Hotel deLuxe', 167, '2019-02-08', 153, NULL),
('Hotel deLuxe', 167, '2019-02-09', 290, NULL),
('Hotel deLuxe', 167, '2019-02-10', 303, NULL),
('Hotel deLuxe', 167, '2019-02-11', 175, NULL),
('Hotel deLuxe', 167, '2019-02-12', 176, NULL),
('Hotel deLuxe', 167, '2019-02-13', 349, NULL),
('Hotel deLuxe', 167, '2019-02-14', 291, NULL),
('Hotel deLuxe', 167, '2019-02-15', 385, NULL),
('Hotel deLuxe', 167, '2019-02-16', 377, NULL),
('Hotel deLuxe', 167, '2019-02-17', 185, NULL),
('Hotel deLuxe', 167, '2019-02-18', 295, NULL),
('Hotel deLuxe', 167, '2019-02-19', 392, NULL),
('Hotel deLuxe', 167, '2019-02-20', 307, NULL),
('Hotel deLuxe', 167, '2019-02-21', 338, NULL),
('Hotel deLuxe', 167, '2019-02-22', 285, NULL),
('Hotel deLuxe', 167, '2019-02-23', 268, NULL),
('Hotel deLuxe', 167, '2019-02-24', 331, NULL),
('Hotel deLuxe', 167, '2019-02-25', 117, NULL),
('Hotel deLuxe', 167, '2019-02-26', 232, NULL),
('Hotel deLuxe', 167, '2019-02-27', 217, NULL),
('Hotel deLuxe', 167, '2019-02-28', 305, NULL),
('Hotel deLuxe', 167, '2019-03-01', 190, NULL),
('Hotel deLuxe', 167, '2019-03-02', 385, NULL),
('Hotel deLuxe', 167, '2019-03-03', 145, NULL),
('Hotel deLuxe', 167, '2019-03-04', 101, NULL),
('Hotel deLuxe', 167, '2019-03-05', 282, NULL),
('Hotel deLuxe', 167, '2019-03-06', 375, NULL),
('Hotel deLuxe', 167, '2019-03-07', 291, NULL),
('Hotel deLuxe', 167, '2019-03-08', 216, NULL),
('Hotel deLuxe', 167, '2019-03-09', 201, NULL),
('Hotel deLuxe', 167, '2019-03-10', 312, NULL),
('Hotel deLuxe', 167, '2019-03-11', 293, NULL),
('Hotel deLuxe', 167, '2019-03-12', 196, NULL),
('Hotel deLuxe', 167, '2019-03-13', 105, NULL),
('Hotel deLuxe', 167, '2019-03-14', 397, NULL),
('Hotel deLuxe', 167, '2019-03-15', 304, NULL),
('Hotel deLuxe', 167, '2019-03-16', 391, NULL),
('Hotel deLuxe', 167, '2019-03-17', 162, NULL),
('Hotel deLuxe', 167, '2019-03-18', 286, NULL),
('Hotel deLuxe', 167, '2019-03-19', 311, NULL),
('Hotel deLuxe', 167, '2019-03-20', 244, NULL),
('Hotel deLuxe', 167, '2019-03-21', 282, NULL),
('Hotel deLuxe', 167, '2019-03-22', 339, NULL),
('Hotel deLuxe', 167, '2019-03-23', 164, NULL),
('Hotel deLuxe', 167, '2019-03-24', 137, NULL),
('Hotel deLuxe', 167, '2019-03-25', 341, NULL),
('Hotel deLuxe', 167, '2019-03-26', 121, NULL),
('Hotel deLuxe', 167, '2019-03-27', 372, NULL),
('Hotel deLuxe', 167, '2019-03-28', 199, NULL),
('Hotel deLuxe', 167, '2019-03-29', 161, NULL),
('Hotel deLuxe', 167, '2019-03-30', 113, NULL),
('Hotel deLuxe', 167, '2019-03-31', 178, NULL),
('Hotel deLuxe', 167, '2019-04-01', 238, NULL),
('Hotel deLuxe', 167, '2019-04-02', 339, NULL),
('Hotel deLuxe', 167, '2019-04-03', 126, NULL),
('Hotel deLuxe', 167, '2019-04-04', 339, NULL),
('Hotel deLuxe', 167, '2019-04-05', 202, NULL),
('Hotel deLuxe', 167, '2019-04-06', 149, NULL),
('Hotel deLuxe', 167, '2019-04-07', 289, NULL),
('Hotel deLuxe', 167, '2019-04-08', 220, NULL),
('Hotel deLuxe', 167, '2019-04-09', 168, NULL),
('Hotel deLuxe', 167, '2019-04-10', 380, NULL),
('Hotel deLuxe', 167, '2019-04-11', 237, NULL),
('Hotel deLuxe', 167, '2019-04-12', 188, NULL),
('Hotel deLuxe', 167, '2019-04-13', 367, NULL),
('Hotel deLuxe', 167, '2019-04-14', 117, NULL),
('Hotel deLuxe', 167, '2019-04-15', 386, NULL),
('Hotel deLuxe', 167, '2019-04-16', 294, NULL),
('Hotel deLuxe', 167, '2019-04-17', 369, NULL),
('Hotel deLuxe', 167, '2019-04-18', 274, NULL),
('Hotel deLuxe', 167, '2019-04-19', 277, NULL),
('Hotel deLuxe', 167, '2019-04-20', 217, NULL),
('Hotel deLuxe', 167, '2019-04-21', 300, NULL),
('Hotel deLuxe', 167, '2019-04-22', 318, NULL),
('Hotel deLuxe', 167, '2019-04-23', 207, NULL),
('Hotel deLuxe', 167, '2019-04-24', 379, NULL),
('Hotel deLuxe', 167, '2019-04-25', 390, NULL),
('Hotel deLuxe', 167, '2019-04-26', 233, NULL),
('Hotel deLuxe', 167, '2019-04-27', 356, NULL),
('Hotel deLuxe', 167, '2019-04-28', 212, NULL),
('Hotel deLuxe', 167, '2019-04-29', 217, NULL),
('Hotel deLuxe', 167, '2019-04-30', 308, NULL),
('Hotel deLuxe', 167, '2019-05-01', 253, NULL),
('Hotel deLuxe', 167, '2019-05-02', 243, NULL),
('Hotel deLuxe', 167, '2019-05-03', 221, NULL),
('Hotel deLuxe', 167, '2019-05-04', 171, NULL),
('Hotel deLuxe', 167, '2019-05-05', 321, NULL),
('Hotel deLuxe', 167, '2019-05-06', 321, NULL),
('Hotel deLuxe', 167, '2019-05-07', 357, NULL),
('Hotel deLuxe', 167, '2019-05-08', 156, NULL),
('Hotel deLuxe', 167, '2019-05-09', 348, NULL),
('Hotel deLuxe', 167, '2019-05-10', 276, NULL),
('Hotel deLuxe', 167, '2019-05-11', 284, NULL),
('Hotel deLuxe', 167, '2019-05-12', 233, NULL),
('Hotel deLuxe', 167, '2019-05-13', 127, NULL),
('Hotel deLuxe', 167, '2019-05-14', 380, NULL),
('Hotel deLuxe', 167, '2019-05-15', 320, NULL),
('Hotel deLuxe', 167, '2019-05-16', 111, NULL),
('Hotel deLuxe', 167, '2019-05-17', 325, NULL),
('Hotel deLuxe', 167, '2019-05-18', 314, NULL),
('Hotel deLuxe', 167, '2019-05-19', 216, NULL),
('Hotel deLuxe', 167, '2019-05-20', 160, NULL),
('Hotel deLuxe', 167, '2019-05-21', 168, NULL),
('Hotel deLuxe', 167, '2019-05-22', 324, NULL),
('Hotel deLuxe', 167, '2019-05-23', 128, NULL),
('Hotel deLuxe', 167, '2019-05-24', 181, NULL),
('Hotel deLuxe', 167, '2019-05-25', 375, NULL),
('Hotel deLuxe', 167, '2019-05-26', 342, NULL),
('Hotel deLuxe', 167, '2019-05-27', 213, NULL),
('Hotel deLuxe', 167, '2019-05-28', 254, NULL),
('Hotel deLuxe', 167, '2019-05-29', 101, NULL),
('Hotel deLuxe', 167, '2019-05-30', 238, NULL),
('Hotel deLuxe', 167, '2019-05-31', 167, NULL),
('Hotel deLuxe', 167, '2019-06-01', 245, NULL),
('Hotel deLuxe', 167, '2019-06-02', 269, NULL),
('Hotel deLuxe', 167, '2019-06-03', 128, NULL),
('Hotel deLuxe', 167, '2019-06-04', 337, NULL),
('Hotel deLuxe', 167, '2019-06-05', 132, NULL),
('Hotel deLuxe', 167, '2019-06-06', 161, NULL),
('Hotel deLuxe', 167, '2019-06-07', 285, NULL),
('Hotel deLuxe', 167, '2019-06-08', 295, NULL),
('Hotel deLuxe', 167, '2019-06-09', 258, NULL),
('Hotel deLuxe', 167, '2019-06-10', 146, NULL),
('Hotel deLuxe', 167, '2019-06-11', 187, NULL),
('Hotel deLuxe', 167, '2019-06-12', 271, NULL),
('Hotel deLuxe', 167, '2019-06-13', 105, NULL),
('Hotel deLuxe', 167, '2019-06-14', 375, NULL),
('Hotel deLuxe', 167, '2019-06-15', 399, NULL),
('Hotel deLuxe', 167, '2019-06-16', 278, NULL),
('Hotel deLuxe', 167, '2019-06-17', 212, NULL),
('Hotel deLuxe', 167, '2019-06-18', 240, NULL),
('Hotel deLuxe', 167, '2019-06-19', 251, NULL),
('Hotel deLuxe', 167, '2019-06-20', 236, NULL),
('Hotel deLuxe', 167, '2019-06-21', 316, NULL),
('Hotel deLuxe', 167, '2019-06-22', 295, NULL),
('Hotel deLuxe', 167, '2019-06-23', 150, NULL),
('Hotel deLuxe', 167, '2019-06-24', 361, NULL),
('Hotel deLuxe', 167, '2019-06-25', 345, NULL),
('Hotel deLuxe', 167, '2019-06-26', 315, NULL),
('Hotel deLuxe', 167, '2019-06-27', 114, NULL),
('Hotel deLuxe', 167, '2019-06-28', 299, NULL),
('Hotel deLuxe', 167, '2019-06-29', 268, NULL),
('Hotel deLuxe', 167, '2019-06-30', 383, NULL),
('Hotel deLuxe', 167, '2019-07-01', 118, NULL),
('Hotel deLuxe', 167, '2019-07-02', 208, NULL),
('Hotel deLuxe', 167, '2019-07-03', 250, NULL),
('Hotel deLuxe', 167, '2019-07-04', 382, NULL),
('Hotel deLuxe', 167, '2019-07-05', 153, NULL),
('Hotel deLuxe', 167, '2019-07-06', 261, NULL),
('Hotel deLuxe', 167, '2019-07-07', 177, NULL),
('Hotel deLuxe', 167, '2019-07-08', 191, NULL),
('Hotel deLuxe', 167, '2019-07-09', 346, NULL),
('Hotel deLuxe', 167, '2019-07-10', 368, NULL),
('Hotel deLuxe', 167, '2019-07-11', 224, NULL),
('Hotel deLuxe', 167, '2019-07-12', 220, NULL),
('Hotel deLuxe', 167, '2019-07-13', 192, NULL),
('Hotel deLuxe', 167, '2019-07-14', 225, NULL),
('Hotel deLuxe', 167, '2019-07-15', 272, NULL),
('Hotel deLuxe', 167, '2019-07-16', 158, NULL),
('Hotel deLuxe', 167, '2019-07-17', 287, NULL),
('Hotel deLuxe', 167, '2019-07-18', 228, NULL),
('Hotel deLuxe', 167, '2019-07-19', 289, NULL),
('Hotel deLuxe', 167, '2019-07-20', 380, NULL),
('Hotel deLuxe', 167, '2019-07-21', 251, NULL),
('Hotel deLuxe', 167, '2019-07-22', 325, NULL),
('Hotel deLuxe', 167, '2019-07-23', 110, NULL),
('Hotel deLuxe', 167, '2019-07-24', 107, NULL),
('Hotel deLuxe', 167, '2019-07-25', 263, NULL),
('Hotel deLuxe', 167, '2019-07-26', 108, NULL),
('Hotel deLuxe', 167, '2019-07-27', 213, NULL),
('Hotel deLuxe', 167, '2019-07-28', 150, NULL),
('Hotel deLuxe', 167, '2019-07-29', 276, NULL),
('Hotel deLuxe', 167, '2019-07-30', 118, NULL),
('Hotel deLuxe', 167, '2019-07-31', 146, NULL),
('Hotel deLuxe', 167, '2019-08-01', 359, NULL),
('Hotel deLuxe', 167, '2019-08-02', 118, NULL),
('Hotel deLuxe', 167, '2019-08-03', 313, NULL),
('Hotel deLuxe', 167, '2019-08-04', 249, NULL),
('Hotel deLuxe', 167, '2019-08-05', 204, NULL),
('Hotel deLuxe', 167, '2019-08-06', 399, NULL),
('Hotel deLuxe', 167, '2019-08-07', 213, NULL),
('Hotel deLuxe', 167, '2019-08-08', 245, NULL),
('Hotel deLuxe', 167, '2019-08-09', 162, NULL),
('Hotel deLuxe', 167, '2019-08-10', 375, NULL),
('Hotel deLuxe', 167, '2019-08-11', 218, NULL),
('Hotel deLuxe', 167, '2019-08-12', 138, NULL),
('Hotel deLuxe', 167, '2019-08-13', 277, NULL),
('Hotel deLuxe', 167, '2019-08-14', 129, NULL),
('Hotel deLuxe', 167, '2019-08-15', 260, NULL),
('Hotel deLuxe', 167, '2019-08-16', 212, NULL),
('Hotel deLuxe', 167, '2019-08-17', 218, NULL),
('Hotel deLuxe', 167, '2019-08-18', 270, NULL),
('Hotel deLuxe', 167, '2019-08-19', 120, NULL),
('Hotel deLuxe', 167, '2019-08-20', 339, NULL),
('Hotel deLuxe', 167, '2019-08-21', 299, NULL),
('Hotel deLuxe', 167, '2019-08-22', 366, NULL),
('Hotel deLuxe', 167, '2019-08-23', 374, NULL),
('Hotel deLuxe', 167, '2019-08-24', 102, NULL),
('Hotel deLuxe', 167, '2019-08-25', 156, NULL),
('Hotel deLuxe', 167, '2019-08-26', 263, NULL),
('Hotel deLuxe', 167, '2019-08-27', 256, NULL),
('Hotel deLuxe', 167, '2019-08-28', 243, NULL),
('Hotel deLuxe', 167, '2019-08-29', 346, NULL),
('Hotel deLuxe', 167, '2019-08-30', 114, NULL),
('Hotel deLuxe', 167, '2019-08-31', 266, NULL),
('Hotel deLuxe', 167, '2019-09-01', 297, NULL),
('Hotel deLuxe', 167, '2019-09-02', 393, NULL),
('Hotel deLuxe', 167, '2019-09-03', 202, NULL),
('Hotel deLuxe', 167, '2019-09-04', 176, NULL),
('Hotel deLuxe', 167, '2019-09-05', 308, NULL),
('Hotel deLuxe', 167, '2019-09-06', 239, NULL),
('Hotel deLuxe', 167, '2019-09-07', 147, NULL),
('Hotel deLuxe', 167, '2019-09-08', 333, NULL),
('Hotel deLuxe', 167, '2019-09-09', 132, NULL),
('Hotel deLuxe', 167, '2019-09-10', 250, NULL),
('Hotel deLuxe', 167, '2019-09-11', 116, NULL),
('Hotel deLuxe', 167, '2019-09-12', 209, NULL),
('Hotel deLuxe', 167, '2019-09-13', 223, NULL),
('Hotel deLuxe', 167, '2019-09-14', 105, NULL),
('Hotel deLuxe', 167, '2019-09-15', 284, NULL),
('Hotel deLuxe', 167, '2019-09-16', 174, NULL),
('Hotel deLuxe', 167, '2019-09-17', 344, NULL),
('Hotel deLuxe', 167, '2019-09-18', 153, NULL),
('Hotel deLuxe', 167, '2019-09-19', 300, NULL),
('Hotel deLuxe', 167, '2019-09-20', 142, NULL),
('Hotel deLuxe', 167, '2019-09-21', 320, NULL),
('Hotel deLuxe', 167, '2019-09-22', 111, NULL),
('Hotel deLuxe', 167, '2019-09-23', 299, NULL),
('Hotel deLuxe', 167, '2019-09-24', 261, NULL),
('Hotel deLuxe', 167, '2019-09-25', 381, NULL),
('Hotel deLuxe', 167, '2019-09-26', 144, NULL),
('Hotel deLuxe', 167, '2019-09-27', 160, NULL),
('Hotel deLuxe', 167, '2019-09-28', 206, NULL),
('Hotel deLuxe', 167, '2019-09-29', 104, NULL),
('Hotel deLuxe', 167, '2019-09-30', 131, NULL),
('Hotel deLuxe', 167, '2019-10-01', 149, NULL),
('Hotel deLuxe', 167, '2019-10-02', 116, NULL),
('Hotel deLuxe', 167, '2019-10-03', 312, NULL),
('Hotel deLuxe', 167, '2019-10-04', 327, NULL),
('Hotel deLuxe', 167, '2019-10-05', 164, NULL),
('Hotel deLuxe', 167, '2019-10-06', 290, NULL),
('Hotel deLuxe', 167, '2019-10-07', 128, NULL),
('Hotel deLuxe', 167, '2019-10-08', 229, NULL),
('Hotel deLuxe', 167, '2019-10-09', 341, NULL),
('Hotel deLuxe', 167, '2019-10-10', 271, NULL),
('Hotel deLuxe', 167, '2019-10-11', 191, NULL),
('Hotel deLuxe', 167, '2019-10-12', 244, NULL),
('Hotel deLuxe', 167, '2019-10-13', 374, NULL),
('Hotel deLuxe', 167, '2019-10-14', 190, NULL),
('Hotel deLuxe', 167, '2019-10-15', 111, NULL),
('Hotel deLuxe', 167, '2019-10-16', 357, NULL),
('Hotel deLuxe', 167, '2019-10-17', 214, NULL),
('Hotel deLuxe', 167, '2019-10-18', 106, NULL),
('Hotel deLuxe', 167, '2019-10-19', 234, NULL),
('Hotel deLuxe', 167, '2019-10-20', 388, NULL),
('Hotel deLuxe', 167, '2019-10-21', 204, NULL),
('Hotel deLuxe', 167, '2019-10-22', 346, NULL),
('Hotel deLuxe', 167, '2019-10-23', 272, NULL),
('Hotel deLuxe', 167, '2019-10-24', 358, NULL),
('Hotel deLuxe', 167, '2019-10-25', 114, NULL),
('Hotel deLuxe', 167, '2019-10-26', 195, NULL),
('Hotel deLuxe', 167, '2019-10-27', 293, NULL),
('Hotel deLuxe', 167, '2019-10-28', 140, NULL),
('Hotel deLuxe', 167, '2019-10-29', 275, NULL),
('Hotel deLuxe', 167, '2019-10-30', 317, NULL),
('Hotel deLuxe', 167, '2019-10-31', 198, NULL),
('Hotel deLuxe', 167, '2019-11-01', 395, NULL),
('Hotel deLuxe', 167, '2019-11-02', 153, NULL),
('Hotel deLuxe', 167, '2019-11-03', 122, NULL),
('Hotel deLuxe', 167, '2019-11-04', 323, NULL),
('Hotel deLuxe', 167, '2019-11-05', 285, NULL),
('Hotel deLuxe', 167, '2019-11-06', 274, NULL),
('Hotel deLuxe', 167, '2019-11-07', 370, NULL),
('Hotel deLuxe', 167, '2019-11-08', 134, NULL),
('Hotel deLuxe', 167, '2019-11-09', 235, NULL),
('Hotel deLuxe', 167, '2019-11-10', 175, NULL),
('Hotel deLuxe', 167, '2019-11-11', 146, NULL),
('Hotel deLuxe', 167, '2019-11-12', 386, NULL),
('Hotel deLuxe', 167, '2019-11-13', 339, NULL),
('Hotel deLuxe', 167, '2019-11-14', 362, NULL),
('Hotel deLuxe', 167, '2019-11-15', 353, NULL),
('Hotel deLuxe', 167, '2019-11-16', 283, NULL),
('Hotel deLuxe', 167, '2019-11-17', 117, NULL),
('Hotel deLuxe', 167, '2019-11-18', 127, NULL),
('Hotel deLuxe', 167, '2019-11-19', 299, NULL),
('Hotel deLuxe', 167, '2019-11-20', 217, NULL),
('Hotel deLuxe', 167, '2019-11-21', 337, NULL),
('Hotel deLuxe', 167, '2019-11-22', 335, NULL),
('Hotel deLuxe', 167, '2019-11-23', 377, NULL),
('Hotel deLuxe', 167, '2019-11-24', 372, NULL),
('Hotel deLuxe', 167, '2019-11-25', 381, NULL),
('Hotel deLuxe', 167, '2019-11-26', 358, NULL),
('Hotel deLuxe', 167, '2019-11-27', 395, NULL),
('Hotel deLuxe', 167, '2019-11-28', 319, NULL),
('Hotel deLuxe', 167, '2019-11-29', 336, NULL),
('Hotel deLuxe', 167, '2019-11-30', 347, NULL),
('Hotel deLuxe', 167, '2019-12-01', 353, NULL),
('Hotel deLuxe', 167, '2019-12-02', 198, NULL),
('Hotel deLuxe', 167, '2019-12-03', 210, NULL),
('Hotel deLuxe', 167, '2019-12-04', 325, NULL),
('Hotel deLuxe', 167, '2019-12-05', 246, NULL),
('Hotel deLuxe', 167, '2019-12-06', 306, NULL),
('Hotel deLuxe', 167, '2019-12-07', 108, NULL),
('Hotel deLuxe', 167, '2019-12-08', 297, NULL),
('Hotel deLuxe', 167, '2019-12-09', 168, NULL),
('Hotel deLuxe', 167, '2019-12-10', 125, NULL),
('Hotel deLuxe', 167, '2019-12-11', 188, NULL),
('Hotel deLuxe', 167, '2019-12-12', 261, NULL),
('Hotel deLuxe', 167, '2019-12-13', 292, NULL),
('Hotel deLuxe', 167, '2019-12-14', 143, NULL),
('Hotel deLuxe', 167, '2019-12-15', 281, NULL),
('Hotel deLuxe', 167, '2019-12-16', 347, NULL),
('Hotel deLuxe', 167, '2019-12-17', 164, NULL),
('Hotel deLuxe', 167, '2019-12-18', 370, NULL),
('Hotel deLuxe', 167, '2019-12-19', 232, NULL),
('Hotel deLuxe', 167, '2019-12-20', 357, NULL),
('Hotel deLuxe', 167, '2019-12-21', 215, NULL),
('Hotel deLuxe', 167, '2019-12-22', 202, NULL),
('Hotel deLuxe', 167, '2019-12-23', 262, NULL),
('Hotel deLuxe', 167, '2019-12-24', 107, NULL),
('Hotel deLuxe', 167, '2019-12-25', 376, NULL),
('Hotel deLuxe', 167, '2019-12-26', 124, NULL),
('Hotel deLuxe', 167, '2019-12-27', 191, NULL),
('Hotel deLuxe', 167, '2019-12-28', 305, NULL),
('Hotel deLuxe', 167, '2019-12-29', 299, NULL),
('Hotel deLuxe', 167, '2019-12-30', 194, NULL),
('Hotel deLuxe', 167, '2019-12-31', 251, NULL),
('Hotel deLuxe', 167, '2020-01-01', 226, NULL),
('Hotel deLuxe', 167, '2020-01-02', 234, NULL),
('Hotel deLuxe', 167, '2020-01-03', 351, NULL),
('Hotel deLuxe', 167, '2020-01-04', 236, NULL),
('Hotel deLuxe', 167, '2020-01-05', 291, NULL),
('Hotel deLuxe', 167, '2020-01-06', 312, NULL),
('Hotel deLuxe', 167, '2020-01-07', 336, NULL),
('Hotel deLuxe', 167, '2020-01-08', 119, NULL),
('Hotel deLuxe', 167, '2020-01-09', 322, NULL),
('Hotel deLuxe', 167, '2020-01-10', 350, NULL),
('Hotel deLuxe', 167, '2020-01-11', 353, NULL),
('Hotel deLuxe', 167, '2020-01-12', 201, NULL),
('Hotel deLuxe', 167, '2020-01-13', 331, NULL),
('Hotel deLuxe', 167, '2020-01-14', 354, NULL),
('Hotel deLuxe', 167, '2020-01-15', 249, NULL),
('Hotel deLuxe', 167, '2020-01-16', 240, NULL),
('Hotel deLuxe', 167, '2020-01-17', 180, NULL),
('Hotel deLuxe', 167, '2020-01-18', 371, NULL),
('Hotel deLuxe', 167, '2020-01-19', 142, NULL),
('Hotel deLuxe', 167, '2020-01-20', 178, NULL),
('Hotel deLuxe', 167, '2020-01-21', 301, NULL),
('Hotel deLuxe', 167, '2020-01-22', 294, NULL),
('Hotel deLuxe', 167, '2020-01-23', 117, NULL),
('Hotel deLuxe', 167, '2020-01-24', 225, NULL),
('Hotel deLuxe', 167, '2020-01-25', 190, NULL),
('Hotel deLuxe', 167, '2020-01-26', 135, NULL),
('Hotel deLuxe', 167, '2020-01-27', 367, NULL),
('Hotel deLuxe', 167, '2020-01-28', 321, NULL),
('Hotel deLuxe', 167, '2020-01-29', 346, NULL),
('Hotel deLuxe', 167, '2020-01-30', 356, NULL),
('Hotel deLuxe', 167, '2020-01-31', 286, NULL),
('Hotel deLuxe', 167, '2020-02-01', 352, NULL),
('Hotel deLuxe', 167, '2020-02-02', 226, NULL),
('Hotel deLuxe', 167, '2020-02-03', 220, NULL),
('Hotel deLuxe', 167, '2020-02-04', 278, NULL),
('Hotel deLuxe', 169, '2019-01-01', 225, NULL),
('Hotel deLuxe', 169, '2019-01-02', 372, NULL),
('Hotel deLuxe', 169, '2019-01-03', 161, NULL),
('Hotel deLuxe', 169, '2019-01-04', 312, NULL),
('Hotel deLuxe', 169, '2019-01-05', 365, NULL),
('Hotel deLuxe', 169, '2019-01-06', 324, NULL),
('Hotel deLuxe', 169, '2019-01-07', 310, NULL),
('Hotel deLuxe', 169, '2019-01-08', 269, NULL),
('Hotel deLuxe', 169, '2019-01-09', 375, NULL),
('Hotel deLuxe', 169, '2019-01-10', 330, NULL),
('Hotel deLuxe', 169, '2019-01-11', 219, NULL),
('Hotel deLuxe', 169, '2019-01-12', 231, NULL),
('Hotel deLuxe', 169, '2019-01-13', 211, NULL),
('Hotel deLuxe', 169, '2019-01-14', 225, NULL),
('Hotel deLuxe', 169, '2019-01-15', 289, NULL),
('Hotel deLuxe', 169, '2019-01-16', 344, NULL),
('Hotel deLuxe', 169, '2019-01-17', 216, NULL),
('Hotel deLuxe', 169, '2019-01-18', 201, NULL),
('Hotel deLuxe', 169, '2019-01-19', 349, NULL),
('Hotel deLuxe', 169, '2019-01-20', 359, NULL),
('Hotel deLuxe', 169, '2019-01-21', 199, NULL),
('Hotel deLuxe', 169, '2019-01-22', 139, NULL),
('Hotel deLuxe', 169, '2019-01-23', 146, NULL),
('Hotel deLuxe', 169, '2019-01-24', 323, NULL),
('Hotel deLuxe', 169, '2019-01-25', 142, NULL),
('Hotel deLuxe', 169, '2019-01-26', 353, NULL),
('Hotel deLuxe', 169, '2019-01-27', 224, NULL),
('Hotel deLuxe', 169, '2019-01-28', 294, NULL),
('Hotel deLuxe', 169, '2019-01-29', 291, NULL),
('Hotel deLuxe', 169, '2019-01-30', 308, NULL),
('Hotel deLuxe', 169, '2019-01-31', 142, NULL),
('Hotel deLuxe', 169, '2019-02-01', 132, NULL),
('Hotel deLuxe', 169, '2019-02-02', 266, NULL),
('Hotel deLuxe', 169, '2019-02-03', 367, NULL),
('Hotel deLuxe', 169, '2019-02-04', 145, NULL),
('Hotel deLuxe', 169, '2019-02-05', 209, NULL),
('Hotel deLuxe', 169, '2019-02-06', 229, NULL),
('Hotel deLuxe', 169, '2019-02-07', 210, NULL),
('Hotel deLuxe', 169, '2019-02-08', 381, NULL),
('Hotel deLuxe', 169, '2019-02-09', 296, NULL),
('Hotel deLuxe', 169, '2019-02-10', 330, NULL),
('Hotel deLuxe', 169, '2019-02-11', 205, NULL),
('Hotel deLuxe', 169, '2019-02-12', 162, NULL),
('Hotel deLuxe', 169, '2019-02-13', 160, NULL),
('Hotel deLuxe', 169, '2019-02-14', 304, NULL),
('Hotel deLuxe', 169, '2019-02-15', 341, NULL),
('Hotel deLuxe', 169, '2019-02-16', 318, NULL),
('Hotel deLuxe', 169, '2019-02-17', 221, NULL),
('Hotel deLuxe', 169, '2019-02-18', 200, NULL),
('Hotel deLuxe', 169, '2019-02-19', 199, NULL),
('Hotel deLuxe', 169, '2019-02-20', 334, NULL),
('Hotel deLuxe', 169, '2019-02-21', 330, NULL),
('Hotel deLuxe', 169, '2019-02-22', 327, NULL),
('Hotel deLuxe', 169, '2019-02-23', 150, NULL),
('Hotel deLuxe', 169, '2019-02-24', 138, NULL),
('Hotel deLuxe', 169, '2019-02-25', 308, NULL),
('Hotel deLuxe', 169, '2019-02-26', 297, NULL),
('Hotel deLuxe', 169, '2019-02-27', 142, NULL),
('Hotel deLuxe', 169, '2019-02-28', 302, NULL),
('Hotel deLuxe', 169, '2019-03-01', 299, NULL),
('Hotel deLuxe', 169, '2019-03-02', 232, NULL),
('Hotel deLuxe', 169, '2019-03-03', 313, NULL),
('Hotel deLuxe', 169, '2019-03-04', 321, NULL),
('Hotel deLuxe', 169, '2019-03-05', 282, NULL),
('Hotel deLuxe', 169, '2019-03-06', 117, NULL),
('Hotel deLuxe', 169, '2019-03-07', 316, NULL),
('Hotel deLuxe', 169, '2019-03-08', 398, NULL),
('Hotel deLuxe', 169, '2019-03-09', 225, NULL),
('Hotel deLuxe', 169, '2019-03-10', 174, NULL),
('Hotel deLuxe', 169, '2019-03-11', 136, NULL),
('Hotel deLuxe', 169, '2019-03-12', 305, NULL),
('Hotel deLuxe', 169, '2019-03-13', 295, NULL),
('Hotel deLuxe', 169, '2019-03-14', 167, NULL),
('Hotel deLuxe', 169, '2019-03-15', 296, NULL),
('Hotel deLuxe', 169, '2019-03-16', 146, NULL),
('Hotel deLuxe', 169, '2019-03-17', 311, NULL),
('Hotel deLuxe', 169, '2019-03-18', 227, NULL),
('Hotel deLuxe', 169, '2019-03-19', 365, NULL),
('Hotel deLuxe', 169, '2019-03-20', 329, NULL),
('Hotel deLuxe', 169, '2019-03-21', 146, NULL),
('Hotel deLuxe', 169, '2019-03-22', 334, NULL),
('Hotel deLuxe', 169, '2019-03-23', 392, NULL),
('Hotel deLuxe', 169, '2019-03-24', 363, NULL),
('Hotel deLuxe', 169, '2019-03-25', 347, NULL),
('Hotel deLuxe', 169, '2019-03-26', 117, NULL),
('Hotel deLuxe', 169, '2019-03-27', 254, NULL),
('Hotel deLuxe', 169, '2019-03-28', 355, NULL),
('Hotel deLuxe', 169, '2019-03-29', 246, NULL),
('Hotel deLuxe', 169, '2019-03-30', 175, NULL),
('Hotel deLuxe', 169, '2019-03-31', 138, NULL),
('Hotel deLuxe', 169, '2019-04-01', 310, NULL),
('Hotel deLuxe', 169, '2019-04-02', 235, NULL),
('Hotel deLuxe', 169, '2019-04-03', 289, NULL),
('Hotel deLuxe', 169, '2019-04-04', 251, NULL),
('Hotel deLuxe', 169, '2019-04-05', 238, NULL),
('Hotel deLuxe', 169, '2019-04-06', 128, NULL),
('Hotel deLuxe', 169, '2019-04-07', 236, NULL),
('Hotel deLuxe', 169, '2019-04-08', 306, NULL),
('Hotel deLuxe', 169, '2019-04-09', 112, NULL),
('Hotel deLuxe', 169, '2019-04-10', 388, NULL),
('Hotel deLuxe', 169, '2019-04-11', 104, NULL),
('Hotel deLuxe', 169, '2019-04-12', 266, NULL),
('Hotel deLuxe', 169, '2019-04-13', 398, NULL),
('Hotel deLuxe', 169, '2019-04-14', 208, NULL),
('Hotel deLuxe', 169, '2019-04-15', 172, NULL),
('Hotel deLuxe', 169, '2019-04-16', 381, NULL),
('Hotel deLuxe', 169, '2019-04-17', 235, NULL),
('Hotel deLuxe', 169, '2019-04-18', 247, NULL),
('Hotel deLuxe', 169, '2019-04-19', 213, NULL),
('Hotel deLuxe', 169, '2019-04-20', 135, NULL),
('Hotel deLuxe', 169, '2019-04-21', 139, NULL),
('Hotel deLuxe', 169, '2019-04-22', 134, NULL),
('Hotel deLuxe', 169, '2019-04-23', 160, NULL),
('Hotel deLuxe', 169, '2019-04-24', 323, NULL),
('Hotel deLuxe', 169, '2019-04-25', 113, NULL),
('Hotel deLuxe', 169, '2019-04-26', 397, NULL),
('Hotel deLuxe', 169, '2019-04-27', 399, NULL),
('Hotel deLuxe', 169, '2019-04-28', 116, NULL),
('Hotel deLuxe', 169, '2019-04-29', 146, NULL),
('Hotel deLuxe', 169, '2019-04-30', 266, NULL),
('Hotel deLuxe', 169, '2019-05-01', 332, NULL),
('Hotel deLuxe', 169, '2019-05-02', 380, NULL),
('Hotel deLuxe', 169, '2019-05-03', 227, NULL),
('Hotel deLuxe', 169, '2019-05-04', 296, NULL),
('Hotel deLuxe', 169, '2019-05-05', 237, NULL),
('Hotel deLuxe', 169, '2019-05-06', 313, NULL),
('Hotel deLuxe', 169, '2019-05-07', 328, NULL),
('Hotel deLuxe', 169, '2019-05-08', 246, NULL),
('Hotel deLuxe', 169, '2019-05-09', 290, NULL),
('Hotel deLuxe', 169, '2019-05-10', 281, NULL),
('Hotel deLuxe', 169, '2019-05-11', 145, NULL),
('Hotel deLuxe', 169, '2019-05-12', 349, NULL),
('Hotel deLuxe', 169, '2019-05-13', 336, NULL),
('Hotel deLuxe', 169, '2019-05-14', 224, NULL),
('Hotel deLuxe', 169, '2019-05-15', 187, NULL),
('Hotel deLuxe', 169, '2019-05-16', 251, NULL),
('Hotel deLuxe', 169, '2019-05-17', 184, NULL),
('Hotel deLuxe', 169, '2019-05-18', 318, NULL),
('Hotel deLuxe', 169, '2019-05-19', 345, NULL),
('Hotel deLuxe', 169, '2019-05-20', 282, NULL),
('Hotel deLuxe', 169, '2019-05-21', 202, NULL),
('Hotel deLuxe', 169, '2019-05-22', 197, NULL),
('Hotel deLuxe', 169, '2019-05-23', 384, NULL),
('Hotel deLuxe', 169, '2019-05-24', 341, NULL),
('Hotel deLuxe', 169, '2019-05-25', 220, NULL),
('Hotel deLuxe', 169, '2019-05-26', 138, NULL),
('Hotel deLuxe', 169, '2019-05-27', 284, NULL),
('Hotel deLuxe', 169, '2019-05-28', 166, NULL),
('Hotel deLuxe', 169, '2019-05-29', 289, NULL),
('Hotel deLuxe', 169, '2019-05-30', 121, NULL),
('Hotel deLuxe', 169, '2019-05-31', 373, NULL),
('Hotel deLuxe', 169, '2019-06-01', 234, NULL),
('Hotel deLuxe', 169, '2019-06-02', 150, NULL),
('Hotel deLuxe', 169, '2019-06-03', 246, NULL),
('Hotel deLuxe', 169, '2019-06-04', 115, NULL),
('Hotel deLuxe', 169, '2019-06-05', 281, NULL),
('Hotel deLuxe', 169, '2019-06-06', 118, NULL),
('Hotel deLuxe', 169, '2019-06-07', 393, NULL),
('Hotel deLuxe', 169, '2019-06-08', 121, NULL),
('Hotel deLuxe', 169, '2019-06-09', 106, NULL),
('Hotel deLuxe', 169, '2019-06-10', 150, NULL),
('Hotel deLuxe', 169, '2019-06-11', 235, NULL),
('Hotel deLuxe', 169, '2019-06-12', 252, NULL),
('Hotel deLuxe', 169, '2019-06-13', 218, NULL),
('Hotel deLuxe', 169, '2019-06-14', 192, NULL),
('Hotel deLuxe', 169, '2019-06-15', 118, NULL),
('Hotel deLuxe', 169, '2019-06-16', 240, NULL),
('Hotel deLuxe', 169, '2019-06-17', 190, NULL),
('Hotel deLuxe', 169, '2019-06-18', 359, NULL),
('Hotel deLuxe', 169, '2019-06-19', 234, NULL),
('Hotel deLuxe', 169, '2019-06-20', 374, NULL),
('Hotel deLuxe', 169, '2019-06-21', 251, NULL),
('Hotel deLuxe', 169, '2019-06-22', 127, NULL),
('Hotel deLuxe', 169, '2019-06-23', 226, NULL),
('Hotel deLuxe', 169, '2019-06-24', 362, NULL),
('Hotel deLuxe', 169, '2019-06-25', 316, NULL),
('Hotel deLuxe', 169, '2019-06-26', 111, NULL),
('Hotel deLuxe', 169, '2019-06-27', 205, NULL),
('Hotel deLuxe', 169, '2019-06-28', 324, NULL),
('Hotel deLuxe', 169, '2019-06-29', 317, NULL),
('Hotel deLuxe', 169, '2019-06-30', 379, NULL),
('Hotel deLuxe', 169, '2019-07-01', 200, NULL),
('Hotel deLuxe', 169, '2019-07-02', 204, NULL),
('Hotel deLuxe', 169, '2019-07-03', 171, NULL),
('Hotel deLuxe', 169, '2019-07-04', 255, NULL),
('Hotel deLuxe', 169, '2019-07-05', 368, NULL),
('Hotel deLuxe', 169, '2019-07-06', 287, NULL),
('Hotel deLuxe', 169, '2019-07-07', 361, NULL),
('Hotel deLuxe', 169, '2019-07-08', 247, NULL),
('Hotel deLuxe', 169, '2019-07-09', 344, NULL),
('Hotel deLuxe', 169, '2019-07-10', 297, NULL),
('Hotel deLuxe', 169, '2019-07-11', 280, NULL),
('Hotel deLuxe', 169, '2019-07-12', 332, NULL),
('Hotel deLuxe', 169, '2019-07-13', 375, NULL),
('Hotel deLuxe', 169, '2019-07-14', 237, NULL),
('Hotel deLuxe', 169, '2019-07-15', 123, NULL),
('Hotel deLuxe', 169, '2019-07-16', 363, NULL),
('Hotel deLuxe', 169, '2019-07-17', 104, NULL),
('Hotel deLuxe', 169, '2019-07-18', 281, NULL),
('Hotel deLuxe', 169, '2019-07-19', 105, NULL),
('Hotel deLuxe', 169, '2019-07-20', 113, NULL),
('Hotel deLuxe', 169, '2019-07-21', 164, NULL),
('Hotel deLuxe', 169, '2019-07-22', 290, NULL),
('Hotel deLuxe', 169, '2019-07-23', 108, NULL),
('Hotel deLuxe', 169, '2019-07-24', 392, NULL),
('Hotel deLuxe', 169, '2019-07-25', 350, NULL),
('Hotel deLuxe', 169, '2019-07-26', 348, NULL),
('Hotel deLuxe', 169, '2019-07-27', 192, NULL),
('Hotel deLuxe', 169, '2019-07-28', 382, NULL),
('Hotel deLuxe', 169, '2019-07-29', 183, NULL),
('Hotel deLuxe', 169, '2019-07-30', 348, NULL),
('Hotel deLuxe', 169, '2019-07-31', 393, NULL),
('Hotel deLuxe', 169, '2019-08-01', 374, NULL),
('Hotel deLuxe', 169, '2019-08-02', 119, NULL),
('Hotel deLuxe', 169, '2019-08-03', 325, NULL),
('Hotel deLuxe', 169, '2019-08-04', 138, NULL),
('Hotel deLuxe', 169, '2019-08-05', 302, NULL),
('Hotel deLuxe', 169, '2019-08-06', 158, NULL),
('Hotel deLuxe', 169, '2019-08-07', 115, NULL),
('Hotel deLuxe', 169, '2019-08-08', 137, NULL),
('Hotel deLuxe', 169, '2019-08-09', 238, NULL),
('Hotel deLuxe', 169, '2019-08-10', 156, NULL),
('Hotel deLuxe', 169, '2019-08-11', 286, NULL),
('Hotel deLuxe', 169, '2019-08-12', 122, NULL),
('Hotel deLuxe', 169, '2019-08-13', 239, NULL),
('Hotel deLuxe', 169, '2019-08-14', 316, NULL),
('Hotel deLuxe', 169, '2019-08-15', 111, NULL),
('Hotel deLuxe', 169, '2019-08-16', 206, NULL),
('Hotel deLuxe', 169, '2019-08-17', 263, NULL),
('Hotel deLuxe', 169, '2019-08-18', 327, NULL),
('Hotel deLuxe', 169, '2019-08-19', 337, NULL),
('Hotel deLuxe', 169, '2019-08-20', 333, NULL),
('Hotel deLuxe', 169, '2019-08-21', 366, NULL),
('Hotel deLuxe', 169, '2019-08-22', 337, NULL),
('Hotel deLuxe', 169, '2019-08-23', 131, NULL),
('Hotel deLuxe', 169, '2019-08-24', 248, NULL),
('Hotel deLuxe', 169, '2019-08-25', 289, NULL),
('Hotel deLuxe', 169, '2019-08-26', 193, NULL),
('Hotel deLuxe', 169, '2019-08-27', 228, NULL),
('Hotel deLuxe', 169, '2019-08-28', 241, NULL),
('Hotel deLuxe', 169, '2019-08-29', 221, NULL),
('Hotel deLuxe', 169, '2019-08-30', 115, NULL),
('Hotel deLuxe', 169, '2019-08-31', 304, NULL),
('Hotel deLuxe', 169, '2019-09-01', 267, NULL),
('Hotel deLuxe', 169, '2019-09-02', 215, NULL),
('Hotel deLuxe', 169, '2019-09-03', 351, NULL),
('Hotel deLuxe', 169, '2019-09-04', 284, NULL),
('Hotel deLuxe', 169, '2019-09-05', 284, NULL),
('Hotel deLuxe', 169, '2019-09-06', 239, NULL),
('Hotel deLuxe', 169, '2019-09-07', 201, NULL),
('Hotel deLuxe', 169, '2019-09-08', 192, NULL),
('Hotel deLuxe', 169, '2019-09-09', 392, NULL),
('Hotel deLuxe', 169, '2019-09-10', 172, NULL),
('Hotel deLuxe', 169, '2019-09-11', 306, NULL),
('Hotel deLuxe', 169, '2019-09-12', 205, NULL),
('Hotel deLuxe', 169, '2019-09-13', 159, NULL),
('Hotel deLuxe', 169, '2019-09-14', 144, NULL),
('Hotel deLuxe', 169, '2019-09-15', 378, NULL),
('Hotel deLuxe', 169, '2019-09-16', 393, NULL),
('Hotel deLuxe', 169, '2019-09-17', 326, NULL),
('Hotel deLuxe', 169, '2019-09-18', 263, NULL),
('Hotel deLuxe', 169, '2019-09-19', 139, NULL),
('Hotel deLuxe', 169, '2019-09-20', 269, NULL),
('Hotel deLuxe', 169, '2019-09-21', 176, NULL),
('Hotel deLuxe', 169, '2019-09-22', 297, NULL),
('Hotel deLuxe', 169, '2019-09-23', 135, NULL),
('Hotel deLuxe', 169, '2019-09-24', 308, NULL),
('Hotel deLuxe', 169, '2019-09-25', 336, NULL),
('Hotel deLuxe', 169, '2019-09-26', 181, NULL),
('Hotel deLuxe', 169, '2019-09-27', 204, NULL),
('Hotel deLuxe', 169, '2019-09-28', 271, NULL),
('Hotel deLuxe', 169, '2019-09-29', 178, NULL),
('Hotel deLuxe', 169, '2019-09-30', 117, NULL),
('Hotel deLuxe', 169, '2019-10-01', 378, NULL),
('Hotel deLuxe', 169, '2019-10-02', 156, NULL),
('Hotel deLuxe', 169, '2019-10-03', 360, NULL),
('Hotel deLuxe', 169, '2019-10-04', 146, NULL),
('Hotel deLuxe', 169, '2019-10-05', 395, NULL),
('Hotel deLuxe', 169, '2019-10-06', 385, NULL),
('Hotel deLuxe', 169, '2019-10-07', 334, NULL),
('Hotel deLuxe', 169, '2019-10-08', 352, NULL),
('Hotel deLuxe', 169, '2019-10-09', 204, NULL),
('Hotel deLuxe', 169, '2019-10-10', 109, NULL),
('Hotel deLuxe', 169, '2019-10-11', 222, NULL),
('Hotel deLuxe', 169, '2019-10-12', 335, NULL),
('Hotel deLuxe', 169, '2019-10-13', 262, NULL),
('Hotel deLuxe', 169, '2019-10-14', 112, NULL),
('Hotel deLuxe', 169, '2019-10-15', 274, NULL),
('Hotel deLuxe', 169, '2019-10-16', 173, NULL),
('Hotel deLuxe', 169, '2019-10-17', 251, NULL),
('Hotel deLuxe', 169, '2019-10-18', 151, NULL),
('Hotel deLuxe', 169, '2019-10-19', 176, NULL),
('Hotel deLuxe', 169, '2019-10-20', 334, NULL),
('Hotel deLuxe', 169, '2019-10-21', 258, NULL),
('Hotel deLuxe', 169, '2019-10-22', 383, NULL),
('Hotel deLuxe', 169, '2019-10-23', 326, NULL),
('Hotel deLuxe', 169, '2019-10-24', 129, NULL),
('Hotel deLuxe', 169, '2019-10-25', 343, NULL),
('Hotel deLuxe', 169, '2019-10-26', 226, NULL),
('Hotel deLuxe', 169, '2019-10-27', 385, NULL),
('Hotel deLuxe', 169, '2019-10-28', 108, NULL),
('Hotel deLuxe', 169, '2019-10-29', 398, NULL),
('Hotel deLuxe', 169, '2019-10-30', 271, NULL),
('Hotel deLuxe', 169, '2019-10-31', 325, NULL),
('Hotel deLuxe', 169, '2019-11-01', 218, NULL),
('Hotel deLuxe', 169, '2019-11-02', 282, NULL),
('Hotel deLuxe', 169, '2019-11-03', 247, NULL),
('Hotel deLuxe', 169, '2019-11-04', 281, NULL),
('Hotel deLuxe', 169, '2019-11-05', 293, NULL),
('Hotel deLuxe', 169, '2019-11-06', 191, NULL),
('Hotel deLuxe', 169, '2019-11-07', 108, NULL),
('Hotel deLuxe', 169, '2019-11-08', 371, NULL),
('Hotel deLuxe', 169, '2019-11-09', 223, NULL),
('Hotel deLuxe', 169, '2019-11-10', 172, NULL),
('Hotel deLuxe', 169, '2019-11-11', 315, NULL),
('Hotel deLuxe', 169, '2019-11-12', 372, NULL),
('Hotel deLuxe', 169, '2019-11-13', 233, NULL),
('Hotel deLuxe', 169, '2019-11-14', 239, NULL),
('Hotel deLuxe', 169, '2019-11-15', 343, NULL),
('Hotel deLuxe', 169, '2019-11-16', 399, NULL),
('Hotel deLuxe', 169, '2019-11-17', 164, NULL),
('Hotel deLuxe', 169, '2019-11-18', 151, NULL),
('Hotel deLuxe', 169, '2019-11-19', 331, NULL),
('Hotel deLuxe', 169, '2019-11-20', 330, NULL),
('Hotel deLuxe', 169, '2019-11-21', 154, NULL),
('Hotel deLuxe', 169, '2019-11-22', 277, NULL),
('Hotel deLuxe', 169, '2019-11-23', 122, NULL),
('Hotel deLuxe', 169, '2019-11-24', 363, NULL),
('Hotel deLuxe', 169, '2019-11-25', 123, NULL),
('Hotel deLuxe', 169, '2019-11-26', 257, NULL),
('Hotel deLuxe', 169, '2019-11-27', 267, NULL),
('Hotel deLuxe', 169, '2019-11-28', 150, NULL),
('Hotel deLuxe', 169, '2019-11-29', 208, NULL),
('Hotel deLuxe', 169, '2019-11-30', 349, NULL),
('Hotel deLuxe', 169, '2019-12-01', 161, NULL),
('Hotel deLuxe', 169, '2019-12-02', 293, NULL),
('Hotel deLuxe', 169, '2019-12-03', 348, NULL),
('Hotel deLuxe', 169, '2019-12-04', 381, NULL),
('Hotel deLuxe', 169, '2019-12-05', 230, NULL),
('Hotel deLuxe', 169, '2019-12-06', 239, NULL),
('Hotel deLuxe', 169, '2019-12-07', 299, NULL),
('Hotel deLuxe', 169, '2019-12-08', 256, NULL),
('Hotel deLuxe', 169, '2019-12-09', 170, NULL),
('Hotel deLuxe', 169, '2019-12-10', 139, NULL),
('Hotel deLuxe', 169, '2019-12-11', 253, NULL),
('Hotel deLuxe', 169, '2019-12-12', 190, NULL),
('Hotel deLuxe', 169, '2019-12-13', 230, NULL),
('Hotel deLuxe', 169, '2019-12-14', 230, NULL),
('Hotel deLuxe', 169, '2019-12-15', 296, NULL),
('Hotel deLuxe', 169, '2019-12-16', 202, NULL),
('Hotel deLuxe', 169, '2019-12-17', 267, NULL),
('Hotel deLuxe', 169, '2019-12-18', 354, NULL),
('Hotel deLuxe', 169, '2019-12-19', 252, NULL),
('Hotel deLuxe', 169, '2019-12-20', 336, NULL),
('Hotel deLuxe', 169, '2019-12-21', 185, NULL),
('Hotel deLuxe', 169, '2019-12-22', 369, NULL),
('Hotel deLuxe', 169, '2019-12-23', 144, NULL),
('Hotel deLuxe', 169, '2019-12-24', 131, NULL),
('Hotel deLuxe', 169, '2019-12-25', 393, NULL),
('Hotel deLuxe', 169, '2019-12-26', 314, NULL),
('Hotel deLuxe', 169, '2019-12-27', 235, NULL),
('Hotel deLuxe', 169, '2019-12-28', 330, NULL),
('Hotel deLuxe', 169, '2019-12-29', 221, NULL),
('Hotel deLuxe', 169, '2019-12-30', 133, NULL),
('Hotel deLuxe', 169, '2019-12-31', 224, NULL),
('Hotel deLuxe', 169, '2020-01-01', 220, NULL),
('Hotel deLuxe', 169, '2020-01-02', 107, NULL),
('Hotel deLuxe', 169, '2020-01-03', 324, NULL),
('Hotel deLuxe', 169, '2020-01-04', 296, NULL),
('Hotel deLuxe', 169, '2020-01-05', 152, NULL),
('Hotel deLuxe', 169, '2020-01-06', 393, NULL),
('Hotel deLuxe', 169, '2020-01-07', 308, NULL),
('Hotel deLuxe', 169, '2020-01-08', 184, NULL),
('Hotel deLuxe', 169, '2020-01-09', 291, NULL),
('Hotel deLuxe', 169, '2020-01-10', 340, NULL),
('Hotel deLuxe', 169, '2020-01-11', 177, NULL),
('Hotel deLuxe', 169, '2020-01-12', 134, NULL),
('Hotel deLuxe', 169, '2020-01-13', 256, NULL),
('Hotel deLuxe', 169, '2020-01-14', 130, NULL),
('Hotel deLuxe', 169, '2020-01-15', 114, NULL),
('Hotel deLuxe', 169, '2020-01-16', 255, NULL),
('Hotel deLuxe', 169, '2020-01-17', 170, NULL),
('Hotel deLuxe', 169, '2020-01-18', 299, NULL),
('Hotel deLuxe', 169, '2020-01-19', 232, NULL),
('Hotel deLuxe', 169, '2020-01-20', 353, NULL),
('Hotel deLuxe', 169, '2020-01-21', 176, NULL),
('Hotel deLuxe', 169, '2020-01-22', 246, NULL),
('Hotel deLuxe', 169, '2020-01-23', 216, NULL),
('Hotel deLuxe', 169, '2020-01-24', 224, NULL),
('Hotel deLuxe', 169, '2020-01-25', 250, NULL),
('Hotel deLuxe', 169, '2020-01-26', 236, NULL),
('Hotel deLuxe', 169, '2020-01-27', 144, NULL),
('Hotel deLuxe', 169, '2020-01-28', 134, NULL),
('Hotel deLuxe', 169, '2020-01-29', 327, NULL),
('Hotel deLuxe', 169, '2020-01-30', 298, NULL),
('Hotel deLuxe', 169, '2020-01-31', 336, NULL),
('Hotel deLuxe', 169, '2020-02-01', 259, NULL),
('Hotel deLuxe', 169, '2020-02-02', 341, NULL),
('Hotel deLuxe', 169, '2020-02-03', 275, NULL),
('Hotel deLuxe', 169, '2020-02-04', 318, NULL),
('Hotel deLuxe', 179, '2019-01-01', 225, NULL),
('Hotel deLuxe', 179, '2019-01-02', 226, NULL),
('Hotel deLuxe', 179, '2019-01-03', 297, NULL),
('Hotel deLuxe', 179, '2019-01-04', 168, NULL),
('Hotel deLuxe', 179, '2019-01-05', 305, NULL),
('Hotel deLuxe', 179, '2019-01-06', 340, NULL),
('Hotel deLuxe', 179, '2019-01-07', 180, NULL),
('Hotel deLuxe', 179, '2019-01-08', 200, NULL),
('Hotel deLuxe', 179, '2019-01-09', 374, NULL),
('Hotel deLuxe', 179, '2019-01-10', 246, NULL),
('Hotel deLuxe', 179, '2019-01-11', 344, NULL),
('Hotel deLuxe', 179, '2019-01-12', 374, NULL),
('Hotel deLuxe', 179, '2019-01-13', 189, NULL),
('Hotel deLuxe', 179, '2019-01-14', 268, NULL),
('Hotel deLuxe', 179, '2019-01-15', 323, NULL),
('Hotel deLuxe', 179, '2019-01-16', 329, NULL),
('Hotel deLuxe', 179, '2019-01-17', 182, NULL),
('Hotel deLuxe', 179, '2019-01-18', 277, NULL),
('Hotel deLuxe', 179, '2019-01-19', 162, NULL),
('Hotel deLuxe', 179, '2019-01-20', 326, NULL),
('Hotel deLuxe', 179, '2019-01-21', 101, NULL),
('Hotel deLuxe', 179, '2019-01-22', 365, NULL),
('Hotel deLuxe', 179, '2019-01-23', 296, NULL),
('Hotel deLuxe', 179, '2019-01-24', 292, NULL),
('Hotel deLuxe', 179, '2019-01-25', 344, NULL),
('Hotel deLuxe', 179, '2019-01-26', 225, NULL),
('Hotel deLuxe', 179, '2019-01-27', 228, NULL),
('Hotel deLuxe', 179, '2019-01-28', 115, NULL),
('Hotel deLuxe', 179, '2019-01-29', 279, NULL),
('Hotel deLuxe', 179, '2019-01-30', 116, NULL),
('Hotel deLuxe', 179, '2019-01-31', 221, NULL),
('Hotel deLuxe', 179, '2019-02-01', 239, NULL),
('Hotel deLuxe', 179, '2019-02-02', 103, NULL),
('Hotel deLuxe', 179, '2019-02-03', 220, NULL),
('Hotel deLuxe', 179, '2019-02-04', 281, NULL),
('Hotel deLuxe', 179, '2019-02-05', 355, NULL),
('Hotel deLuxe', 179, '2019-02-06', 338, NULL),
('Hotel deLuxe', 179, '2019-02-07', 187, NULL),
('Hotel deLuxe', 179, '2019-02-08', 146, NULL),
('Hotel deLuxe', 179, '2019-02-09', 211, NULL),
('Hotel deLuxe', 179, '2019-02-10', 344, NULL),
('Hotel deLuxe', 179, '2019-02-11', 101, NULL),
('Hotel deLuxe', 179, '2019-02-12', 183, NULL),
('Hotel deLuxe', 179, '2019-02-13', 252, NULL),
('Hotel deLuxe', 179, '2019-02-14', 245, NULL),
('Hotel deLuxe', 179, '2019-02-15', 148, NULL),
('Hotel deLuxe', 179, '2019-02-16', 356, NULL),
('Hotel deLuxe', 179, '2019-02-17', 152, NULL),
('Hotel deLuxe', 179, '2019-02-18', 315, NULL),
('Hotel deLuxe', 179, '2019-02-19', 319, NULL),
('Hotel deLuxe', 179, '2019-02-20', 349, NULL),
('Hotel deLuxe', 179, '2019-02-21', 238, NULL),
('Hotel deLuxe', 179, '2019-02-22', 380, NULL),
('Hotel deLuxe', 179, '2019-02-23', 148, NULL),
('Hotel deLuxe', 179, '2019-02-24', 199, NULL),
('Hotel deLuxe', 179, '2019-02-25', 190, NULL),
('Hotel deLuxe', 179, '2019-02-26', 390, NULL),
('Hotel deLuxe', 179, '2019-02-27', 259, NULL),
('Hotel deLuxe', 179, '2019-02-28', 193, NULL),
('Hotel deLuxe', 179, '2019-03-01', 225, NULL),
('Hotel deLuxe', 179, '2019-03-02', 206, NULL),
('Hotel deLuxe', 179, '2019-03-03', 133, NULL),
('Hotel deLuxe', 179, '2019-03-04', 302, NULL),
('Hotel deLuxe', 179, '2019-03-05', 164, NULL),
('Hotel deLuxe', 179, '2019-03-06', 260, NULL),
('Hotel deLuxe', 179, '2019-03-07', 308, NULL),
('Hotel deLuxe', 179, '2019-03-08', 341, NULL),
('Hotel deLuxe', 179, '2019-03-09', 122, NULL),
('Hotel deLuxe', 179, '2019-03-10', 133, NULL),
('Hotel deLuxe', 179, '2019-03-11', 299, NULL),
('Hotel deLuxe', 179, '2019-03-12', 237, NULL),
('Hotel deLuxe', 179, '2019-03-13', 159, NULL),
('Hotel deLuxe', 179, '2019-03-14', 143, NULL),
('Hotel deLuxe', 179, '2019-03-15', 169, NULL),
('Hotel deLuxe', 179, '2019-03-16', 359, NULL),
('Hotel deLuxe', 179, '2019-03-17', 367, NULL),
('Hotel deLuxe', 179, '2019-03-18', 178, NULL),
('Hotel deLuxe', 179, '2019-03-19', 195, NULL),
('Hotel deLuxe', 179, '2019-03-20', 216, NULL),
('Hotel deLuxe', 179, '2019-03-21', 386, NULL),
('Hotel deLuxe', 179, '2019-03-22', 255, NULL),
('Hotel deLuxe', 179, '2019-03-23', 170, NULL),
('Hotel deLuxe', 179, '2019-03-24', 103, NULL),
('Hotel deLuxe', 179, '2019-03-25', 310, NULL),
('Hotel deLuxe', 179, '2019-03-26', 124, NULL),
('Hotel deLuxe', 179, '2019-03-27', 356, NULL),
('Hotel deLuxe', 179, '2019-03-28', 180, NULL),
('Hotel deLuxe', 179, '2019-03-29', 345, NULL),
('Hotel deLuxe', 179, '2019-03-30', 137, NULL),
('Hotel deLuxe', 179, '2019-03-31', 354, NULL),
('Hotel deLuxe', 179, '2019-04-01', 138, NULL),
('Hotel deLuxe', 179, '2019-04-02', 361, NULL),
('Hotel deLuxe', 179, '2019-04-03', 369, NULL),
('Hotel deLuxe', 179, '2019-04-04', 137, NULL),
('Hotel deLuxe', 179, '2019-04-05', 183, NULL),
('Hotel deLuxe', 179, '2019-04-06', 395, NULL),
('Hotel deLuxe', 179, '2019-04-07', 212, NULL),
('Hotel deLuxe', 179, '2019-04-08', 171, NULL),
('Hotel deLuxe', 179, '2019-04-09', 254, NULL),
('Hotel deLuxe', 179, '2019-04-10', 100, NULL),
('Hotel deLuxe', 179, '2019-04-11', 307, NULL),
('Hotel deLuxe', 179, '2019-04-12', 366, NULL),
('Hotel deLuxe', 179, '2019-04-13', 190, NULL),
('Hotel deLuxe', 179, '2019-04-14', 289, NULL),
('Hotel deLuxe', 179, '2019-04-15', 202, NULL),
('Hotel deLuxe', 179, '2019-04-16', 322, NULL),
('Hotel deLuxe', 179, '2019-04-17', 269, NULL),
('Hotel deLuxe', 179, '2019-04-18', 316, NULL),
('Hotel deLuxe', 179, '2019-04-19', 135, NULL),
('Hotel deLuxe', 179, '2019-04-20', 222, NULL),
('Hotel deLuxe', 179, '2019-04-21', 295, NULL),
('Hotel deLuxe', 179, '2019-04-22', 217, NULL),
('Hotel deLuxe', 179, '2019-04-23', 378, NULL),
('Hotel deLuxe', 179, '2019-04-24', 378, NULL),
('Hotel deLuxe', 179, '2019-04-25', 197, NULL),
('Hotel deLuxe', 179, '2019-04-26', 284, NULL),
('Hotel deLuxe', 179, '2019-04-27', 227, NULL),
('Hotel deLuxe', 179, '2019-04-28', 145, NULL),
('Hotel deLuxe', 179, '2019-04-29', 281, NULL),
('Hotel deLuxe', 179, '2019-04-30', 309, NULL),
('Hotel deLuxe', 179, '2019-05-01', 202, NULL),
('Hotel deLuxe', 179, '2019-05-02', 173, NULL),
('Hotel deLuxe', 179, '2019-05-03', 374, NULL),
('Hotel deLuxe', 179, '2019-05-04', 266, NULL),
('Hotel deLuxe', 179, '2019-05-05', 123, NULL),
('Hotel deLuxe', 179, '2019-05-06', 203, NULL),
('Hotel deLuxe', 179, '2019-05-07', 168, NULL),
('Hotel deLuxe', 179, '2019-05-08', 366, NULL),
('Hotel deLuxe', 179, '2019-05-09', 309, NULL),
('Hotel deLuxe', 179, '2019-05-10', 180, NULL),
('Hotel deLuxe', 179, '2019-05-11', 376, NULL),
('Hotel deLuxe', 179, '2019-05-12', 344, NULL),
('Hotel deLuxe', 179, '2019-05-13', 301, NULL),
('Hotel deLuxe', 179, '2019-05-14', 182, NULL),
('Hotel deLuxe', 179, '2019-05-15', 176, NULL),
('Hotel deLuxe', 179, '2019-05-16', 221, NULL),
('Hotel deLuxe', 179, '2019-05-17', 147, NULL),
('Hotel deLuxe', 179, '2019-05-18', 246, NULL),
('Hotel deLuxe', 179, '2019-05-19', 378, NULL),
('Hotel deLuxe', 179, '2019-05-20', 229, NULL),
('Hotel deLuxe', 179, '2019-05-21', 105, NULL),
('Hotel deLuxe', 179, '2019-05-22', 212, NULL),
('Hotel deLuxe', 179, '2019-05-23', 237, NULL),
('Hotel deLuxe', 179, '2019-05-24', 165, NULL),
('Hotel deLuxe', 179, '2019-05-25', 177, NULL),
('Hotel deLuxe', 179, '2019-05-26', 162, NULL),
('Hotel deLuxe', 179, '2019-05-27', 380, NULL),
('Hotel deLuxe', 179, '2019-05-28', 268, NULL),
('Hotel deLuxe', 179, '2019-05-29', 143, NULL),
('Hotel deLuxe', 179, '2019-05-30', 390, NULL),
('Hotel deLuxe', 179, '2019-05-31', 363, NULL),
('Hotel deLuxe', 179, '2019-06-01', 336, NULL),
('Hotel deLuxe', 179, '2019-06-02', 143, NULL),
('Hotel deLuxe', 179, '2019-06-03', 147, NULL),
('Hotel deLuxe', 179, '2019-06-04', 363, NULL),
('Hotel deLuxe', 179, '2019-06-05', 307, NULL),
('Hotel deLuxe', 179, '2019-06-06', 308, NULL),
('Hotel deLuxe', 179, '2019-06-07', 113, NULL),
('Hotel deLuxe', 179, '2019-06-08', 220, NULL),
('Hotel deLuxe', 179, '2019-06-09', 258, NULL),
('Hotel deLuxe', 179, '2019-06-10', 213, NULL),
('Hotel deLuxe', 179, '2019-06-11', 216, NULL),
('Hotel deLuxe', 179, '2019-06-12', 350, NULL),
('Hotel deLuxe', 179, '2019-06-13', 376, NULL),
('Hotel deLuxe', 179, '2019-06-14', 336, NULL),
('Hotel deLuxe', 179, '2019-06-15', 195, NULL),
('Hotel deLuxe', 179, '2019-06-16', 266, NULL),
('Hotel deLuxe', 179, '2019-06-17', 212, NULL),
('Hotel deLuxe', 179, '2019-06-18', 377, NULL),
('Hotel deLuxe', 179, '2019-06-19', 318, NULL),
('Hotel deLuxe', 179, '2019-06-20', 163, NULL),
('Hotel deLuxe', 179, '2019-06-21', 209, NULL),
('Hotel deLuxe', 179, '2019-06-22', 250, NULL),
('Hotel deLuxe', 179, '2019-06-23', 280, NULL),
('Hotel deLuxe', 179, '2019-06-24', 328, NULL),
('Hotel deLuxe', 179, '2019-06-25', 144, NULL),
('Hotel deLuxe', 179, '2019-06-26', 112, NULL),
('Hotel deLuxe', 179, '2019-06-27', 281, NULL),
('Hotel deLuxe', 179, '2019-06-28', 326, NULL),
('Hotel deLuxe', 179, '2019-06-29', 382, NULL),
('Hotel deLuxe', 179, '2019-06-30', 346, NULL),
('Hotel deLuxe', 179, '2019-07-01', 247, NULL),
('Hotel deLuxe', 179, '2019-07-02', 299, NULL),
('Hotel deLuxe', 179, '2019-07-03', 305, NULL),
('Hotel deLuxe', 179, '2019-07-04', 330, NULL),
('Hotel deLuxe', 179, '2019-07-05', 381, NULL),
('Hotel deLuxe', 179, '2019-07-06', 251, NULL),
('Hotel deLuxe', 179, '2019-07-07', 276, NULL),
('Hotel deLuxe', 179, '2019-07-08', 262, NULL),
('Hotel deLuxe', 179, '2019-07-09', 284, NULL),
('Hotel deLuxe', 179, '2019-07-10', 285, NULL),
('Hotel deLuxe', 179, '2019-07-11', 330, NULL),
('Hotel deLuxe', 179, '2019-07-12', 303, NULL),
('Hotel deLuxe', 179, '2019-07-13', 297, NULL),
('Hotel deLuxe', 179, '2019-07-14', 109, NULL),
('Hotel deLuxe', 179, '2019-07-15', 300, NULL),
('Hotel deLuxe', 179, '2019-07-16', 340, NULL),
('Hotel deLuxe', 179, '2019-07-17', 158, NULL),
('Hotel deLuxe', 179, '2019-07-18', 319, NULL),
('Hotel deLuxe', 179, '2019-07-19', 158, NULL),
('Hotel deLuxe', 179, '2019-07-20', 227, NULL),
('Hotel deLuxe', 179, '2019-07-21', 268, NULL),
('Hotel deLuxe', 179, '2019-07-22', 377, NULL),
('Hotel deLuxe', 179, '2019-07-23', 110, NULL),
('Hotel deLuxe', 179, '2019-07-24', 341, NULL),
('Hotel deLuxe', 179, '2019-07-25', 265, NULL),
('Hotel deLuxe', 179, '2019-07-26', 115, NULL),
('Hotel deLuxe', 179, '2019-07-27', 223, NULL),
('Hotel deLuxe', 179, '2019-07-28', 162, NULL),
('Hotel deLuxe', 179, '2019-07-29', 287, NULL),
('Hotel deLuxe', 179, '2019-07-30', 385, NULL),
('Hotel deLuxe', 179, '2019-07-31', 228, NULL),
('Hotel deLuxe', 179, '2019-08-01', 390, NULL),
('Hotel deLuxe', 179, '2019-08-02', 140, NULL),
('Hotel deLuxe', 179, '2019-08-03', 286, NULL),
('Hotel deLuxe', 179, '2019-08-04', 142, NULL),
('Hotel deLuxe', 179, '2019-08-05', 197, NULL),
('Hotel deLuxe', 179, '2019-08-06', 395, NULL),
('Hotel deLuxe', 179, '2019-08-07', 139, NULL),
('Hotel deLuxe', 179, '2019-08-08', 149, NULL),
('Hotel deLuxe', 179, '2019-08-09', 303, NULL),
('Hotel deLuxe', 179, '2019-08-10', 156, NULL),
('Hotel deLuxe', 179, '2019-08-11', 374, NULL),
('Hotel deLuxe', 179, '2019-08-12', 397, NULL),
('Hotel deLuxe', 179, '2019-08-13', 262, NULL),
('Hotel deLuxe', 179, '2019-08-14', 194, NULL),
('Hotel deLuxe', 179, '2019-08-15', 277, NULL),
('Hotel deLuxe', 179, '2019-08-16', 292, NULL),
('Hotel deLuxe', 179, '2019-08-17', 261, NULL),
('Hotel deLuxe', 179, '2019-08-18', 123, NULL),
('Hotel deLuxe', 179, '2019-08-19', 325, NULL),
('Hotel deLuxe', 179, '2019-08-20', 247, NULL),
('Hotel deLuxe', 179, '2019-08-21', 234, NULL),
('Hotel deLuxe', 179, '2019-08-22', 186, NULL),
('Hotel deLuxe', 179, '2019-08-23', 334, NULL),
('Hotel deLuxe', 179, '2019-08-24', 232, NULL),
('Hotel deLuxe', 179, '2019-08-25', 278, NULL),
('Hotel deLuxe', 179, '2019-08-26', 378, NULL),
('Hotel deLuxe', 179, '2019-08-27', 274, NULL),
('Hotel deLuxe', 179, '2019-08-28', 379, NULL),
('Hotel deLuxe', 179, '2019-08-29', 271, NULL),
('Hotel deLuxe', 179, '2019-08-30', 134, NULL),
('Hotel deLuxe', 179, '2019-08-31', 322, NULL),
('Hotel deLuxe', 179, '2019-09-01', 347, NULL),
('Hotel deLuxe', 179, '2019-09-02', 396, NULL),
('Hotel deLuxe', 179, '2019-09-03', 149, NULL),
('Hotel deLuxe', 179, '2019-09-04', 193, NULL),
('Hotel deLuxe', 179, '2019-09-05', 394, NULL),
('Hotel deLuxe', 179, '2019-09-06', 378, NULL),
('Hotel deLuxe', 179, '2019-09-07', 165, NULL),
('Hotel deLuxe', 179, '2019-09-08', 161, NULL),
('Hotel deLuxe', 179, '2019-09-09', 265, NULL),
('Hotel deLuxe', 179, '2019-09-10', 308, NULL),
('Hotel deLuxe', 179, '2019-09-11', 184, NULL),
('Hotel deLuxe', 179, '2019-09-12', 298, NULL),
('Hotel deLuxe', 179, '2019-09-13', 325, NULL),
('Hotel deLuxe', 179, '2019-09-14', 307, NULL),
('Hotel deLuxe', 179, '2019-09-15', 338, NULL),
('Hotel deLuxe', 179, '2019-09-16', 146, NULL),
('Hotel deLuxe', 179, '2019-09-17', 200, NULL),
('Hotel deLuxe', 179, '2019-09-18', 158, NULL),
('Hotel deLuxe', 179, '2019-09-19', 294, NULL),
('Hotel deLuxe', 179, '2019-09-20', 220, NULL),
('Hotel deLuxe', 179, '2019-09-21', 119, NULL),
('Hotel deLuxe', 179, '2019-09-22', 153, NULL),
('Hotel deLuxe', 179, '2019-09-23', 279, NULL),
('Hotel deLuxe', 179, '2019-09-24', 356, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 179, '2019-09-25', 135, NULL),
('Hotel deLuxe', 179, '2019-09-26', 375, NULL),
('Hotel deLuxe', 179, '2019-09-27', 143, NULL),
('Hotel deLuxe', 179, '2019-09-28', 339, NULL),
('Hotel deLuxe', 179, '2019-09-29', 178, NULL),
('Hotel deLuxe', 179, '2019-09-30', 392, NULL),
('Hotel deLuxe', 179, '2019-10-01', 143, NULL),
('Hotel deLuxe', 179, '2019-10-02', 332, NULL),
('Hotel deLuxe', 179, '2019-10-03', 166, NULL),
('Hotel deLuxe', 179, '2019-10-04', 249, NULL),
('Hotel deLuxe', 179, '2019-10-05', 184, NULL),
('Hotel deLuxe', 179, '2019-10-06', 358, NULL),
('Hotel deLuxe', 179, '2019-10-07', 288, NULL),
('Hotel deLuxe', 179, '2019-10-08', 372, NULL),
('Hotel deLuxe', 179, '2019-10-09', 198, NULL),
('Hotel deLuxe', 179, '2019-10-10', 229, NULL),
('Hotel deLuxe', 179, '2019-10-11', 135, NULL),
('Hotel deLuxe', 179, '2019-10-12', 243, NULL),
('Hotel deLuxe', 179, '2019-10-13', 388, NULL),
('Hotel deLuxe', 179, '2019-10-14', 188, NULL),
('Hotel deLuxe', 179, '2019-10-15', 341, NULL),
('Hotel deLuxe', 179, '2019-10-16', 295, NULL),
('Hotel deLuxe', 179, '2019-10-17', 215, NULL),
('Hotel deLuxe', 179, '2019-10-18', 340, NULL),
('Hotel deLuxe', 179, '2019-10-19', 379, NULL),
('Hotel deLuxe', 179, '2019-10-20', 107, NULL),
('Hotel deLuxe', 179, '2019-10-21', 275, NULL),
('Hotel deLuxe', 179, '2019-10-22', 180, NULL),
('Hotel deLuxe', 179, '2019-10-23', 114, NULL),
('Hotel deLuxe', 179, '2019-10-24', 373, NULL),
('Hotel deLuxe', 179, '2019-10-25', 371, NULL),
('Hotel deLuxe', 179, '2019-10-26', 146, NULL),
('Hotel deLuxe', 179, '2019-10-27', 348, NULL),
('Hotel deLuxe', 179, '2019-10-28', 323, NULL),
('Hotel deLuxe', 179, '2019-10-29', 165, NULL),
('Hotel deLuxe', 179, '2019-10-30', 306, NULL),
('Hotel deLuxe', 179, '2019-10-31', 329, NULL),
('Hotel deLuxe', 179, '2019-11-01', 107, NULL),
('Hotel deLuxe', 179, '2019-11-02', 251, NULL),
('Hotel deLuxe', 179, '2019-11-03', 168, NULL),
('Hotel deLuxe', 179, '2019-11-04', 336, NULL),
('Hotel deLuxe', 179, '2019-11-05', 211, NULL),
('Hotel deLuxe', 179, '2019-11-06', 331, NULL),
('Hotel deLuxe', 179, '2019-11-07', 231, NULL),
('Hotel deLuxe', 179, '2019-11-08', 152, NULL),
('Hotel deLuxe', 179, '2019-11-09', 312, NULL),
('Hotel deLuxe', 179, '2019-11-10', 237, NULL),
('Hotel deLuxe', 179, '2019-11-11', 134, NULL),
('Hotel deLuxe', 179, '2019-11-12', 304, NULL),
('Hotel deLuxe', 179, '2019-11-13', 348, NULL),
('Hotel deLuxe', 179, '2019-11-14', 310, NULL),
('Hotel deLuxe', 179, '2019-11-15', 257, NULL),
('Hotel deLuxe', 179, '2019-11-16', 146, NULL),
('Hotel deLuxe', 179, '2019-11-17', 367, NULL),
('Hotel deLuxe', 179, '2019-11-18', 274, NULL),
('Hotel deLuxe', 179, '2019-11-19', 358, NULL),
('Hotel deLuxe', 179, '2019-11-20', 298, NULL),
('Hotel deLuxe', 179, '2019-11-21', 262, NULL),
('Hotel deLuxe', 179, '2019-11-22', 280, NULL),
('Hotel deLuxe', 179, '2019-11-23', 279, NULL),
('Hotel deLuxe', 179, '2019-11-24', 297, NULL),
('Hotel deLuxe', 179, '2019-11-25', 273, NULL),
('Hotel deLuxe', 179, '2019-11-26', 112, NULL),
('Hotel deLuxe', 179, '2019-11-27', 349, NULL),
('Hotel deLuxe', 179, '2019-11-28', 293, NULL),
('Hotel deLuxe', 179, '2019-11-29', 234, NULL),
('Hotel deLuxe', 179, '2019-11-30', 306, NULL),
('Hotel deLuxe', 179, '2019-12-01', 248, NULL),
('Hotel deLuxe', 179, '2019-12-02', 174, NULL),
('Hotel deLuxe', 179, '2019-12-03', 111, NULL),
('Hotel deLuxe', 179, '2019-12-04', 231, NULL),
('Hotel deLuxe', 179, '2019-12-05', 312, NULL),
('Hotel deLuxe', 179, '2019-12-06', 178, NULL),
('Hotel deLuxe', 179, '2019-12-07', 169, NULL),
('Hotel deLuxe', 179, '2019-12-08', 287, NULL),
('Hotel deLuxe', 179, '2019-12-09', 247, NULL),
('Hotel deLuxe', 179, '2019-12-10', 217, NULL),
('Hotel deLuxe', 179, '2019-12-11', 304, NULL),
('Hotel deLuxe', 179, '2019-12-12', 365, NULL),
('Hotel deLuxe', 179, '2019-12-13', 175, NULL),
('Hotel deLuxe', 179, '2019-12-14', 318, NULL),
('Hotel deLuxe', 179, '2019-12-15', 237, NULL),
('Hotel deLuxe', 179, '2019-12-16', 172, NULL),
('Hotel deLuxe', 179, '2019-12-17', 142, NULL),
('Hotel deLuxe', 179, '2019-12-18', 261, NULL),
('Hotel deLuxe', 179, '2019-12-19', 161, NULL),
('Hotel deLuxe', 179, '2019-12-20', 207, NULL),
('Hotel deLuxe', 179, '2019-12-21', 179, NULL),
('Hotel deLuxe', 179, '2019-12-22', 241, NULL),
('Hotel deLuxe', 179, '2019-12-23', 135, NULL),
('Hotel deLuxe', 179, '2019-12-24', 232, NULL),
('Hotel deLuxe', 179, '2019-12-25', 136, NULL),
('Hotel deLuxe', 179, '2019-12-26', 198, NULL),
('Hotel deLuxe', 179, '2019-12-27', 204, NULL),
('Hotel deLuxe', 179, '2019-12-28', 338, NULL),
('Hotel deLuxe', 179, '2019-12-29', 109, NULL),
('Hotel deLuxe', 179, '2019-12-30', 285, NULL),
('Hotel deLuxe', 179, '2019-12-31', 268, NULL),
('Hotel deLuxe', 179, '2020-01-01', 324, NULL),
('Hotel deLuxe', 179, '2020-01-02', 335, NULL),
('Hotel deLuxe', 179, '2020-01-03', 170, NULL),
('Hotel deLuxe', 179, '2020-01-04', 372, NULL),
('Hotel deLuxe', 179, '2020-01-05', 387, NULL),
('Hotel deLuxe', 179, '2020-01-06', 330, NULL),
('Hotel deLuxe', 179, '2020-01-07', 131, NULL),
('Hotel deLuxe', 179, '2020-01-08', 164, NULL),
('Hotel deLuxe', 179, '2020-01-09', 387, NULL),
('Hotel deLuxe', 179, '2020-01-10', 251, NULL),
('Hotel deLuxe', 179, '2020-01-11', 327, NULL),
('Hotel deLuxe', 179, '2020-01-12', 267, NULL),
('Hotel deLuxe', 179, '2020-01-13', 188, NULL),
('Hotel deLuxe', 179, '2020-01-14', 389, NULL),
('Hotel deLuxe', 179, '2020-01-15', 323, NULL),
('Hotel deLuxe', 179, '2020-01-16', 154, NULL),
('Hotel deLuxe', 179, '2020-01-17', 213, NULL),
('Hotel deLuxe', 179, '2020-01-18', 279, NULL),
('Hotel deLuxe', 179, '2020-01-19', 335, NULL),
('Hotel deLuxe', 179, '2020-01-20', 234, NULL),
('Hotel deLuxe', 179, '2020-01-21', 176, NULL),
('Hotel deLuxe', 179, '2020-01-22', 248, NULL),
('Hotel deLuxe', 179, '2020-01-23', 329, NULL),
('Hotel deLuxe', 179, '2020-01-24', 346, NULL),
('Hotel deLuxe', 179, '2020-01-25', 280, NULL),
('Hotel deLuxe', 179, '2020-01-26', 372, NULL),
('Hotel deLuxe', 179, '2020-01-27', 120, NULL),
('Hotel deLuxe', 179, '2020-01-28', 207, NULL),
('Hotel deLuxe', 179, '2020-01-29', 198, NULL),
('Hotel deLuxe', 179, '2020-01-30', 325, NULL),
('Hotel deLuxe', 179, '2020-01-31', 122, NULL),
('Hotel deLuxe', 179, '2020-02-01', 140, NULL),
('Hotel deLuxe', 179, '2020-02-02', 330, NULL),
('Hotel deLuxe', 179, '2020-02-03', 314, NULL),
('Hotel deLuxe', 179, '2020-02-04', 357, NULL),
('Hotel deLuxe', 181, '2019-01-01', 351, NULL),
('Hotel deLuxe', 181, '2019-01-02', 212, NULL),
('Hotel deLuxe', 181, '2019-01-03', 299, NULL),
('Hotel deLuxe', 181, '2019-01-04', 106, NULL),
('Hotel deLuxe', 181, '2019-01-05', 333, NULL),
('Hotel deLuxe', 181, '2019-01-06', 329, NULL),
('Hotel deLuxe', 181, '2019-01-07', 174, NULL),
('Hotel deLuxe', 181, '2019-01-08', 391, NULL),
('Hotel deLuxe', 181, '2019-01-09', 345, NULL),
('Hotel deLuxe', 181, '2019-01-10', 141, NULL),
('Hotel deLuxe', 181, '2019-01-11', 363, NULL),
('Hotel deLuxe', 181, '2019-01-12', 180, NULL),
('Hotel deLuxe', 181, '2019-01-13', 214, NULL),
('Hotel deLuxe', 181, '2019-01-14', 264, NULL),
('Hotel deLuxe', 181, '2019-01-15', 349, NULL),
('Hotel deLuxe', 181, '2019-01-16', 212, NULL),
('Hotel deLuxe', 181, '2019-01-17', 164, NULL),
('Hotel deLuxe', 181, '2019-01-18', 384, NULL),
('Hotel deLuxe', 181, '2019-01-19', 265, NULL),
('Hotel deLuxe', 181, '2019-01-20', 156, NULL),
('Hotel deLuxe', 181, '2019-01-21', 111, NULL),
('Hotel deLuxe', 181, '2019-01-22', 108, NULL),
('Hotel deLuxe', 181, '2019-01-23', 343, NULL),
('Hotel deLuxe', 181, '2019-01-24', 392, NULL),
('Hotel deLuxe', 181, '2019-01-25', 295, NULL),
('Hotel deLuxe', 181, '2019-01-26', 268, NULL),
('Hotel deLuxe', 181, '2019-01-27', 366, NULL),
('Hotel deLuxe', 181, '2019-01-28', 194, NULL),
('Hotel deLuxe', 181, '2019-01-29', 121, NULL),
('Hotel deLuxe', 181, '2019-01-30', 154, NULL),
('Hotel deLuxe', 181, '2019-01-31', 277, NULL),
('Hotel deLuxe', 181, '2019-02-01', 399, NULL),
('Hotel deLuxe', 181, '2019-02-02', 217, NULL),
('Hotel deLuxe', 181, '2019-02-03', 199, NULL),
('Hotel deLuxe', 181, '2019-02-04', 274, NULL),
('Hotel deLuxe', 181, '2019-02-05', 151, NULL),
('Hotel deLuxe', 181, '2019-02-06', 306, NULL),
('Hotel deLuxe', 181, '2019-02-07', 206, NULL),
('Hotel deLuxe', 181, '2019-02-08', 390, NULL),
('Hotel deLuxe', 181, '2019-02-09', 367, NULL),
('Hotel deLuxe', 181, '2019-02-10', 330, NULL),
('Hotel deLuxe', 181, '2019-02-11', 390, NULL),
('Hotel deLuxe', 181, '2019-02-12', 332, NULL),
('Hotel deLuxe', 181, '2019-02-13', 382, NULL),
('Hotel deLuxe', 181, '2019-02-14', 215, NULL),
('Hotel deLuxe', 181, '2019-02-15', 218, NULL),
('Hotel deLuxe', 181, '2019-02-16', 129, NULL),
('Hotel deLuxe', 181, '2019-02-17', 299, NULL),
('Hotel deLuxe', 181, '2019-02-18', 275, NULL),
('Hotel deLuxe', 181, '2019-02-19', 301, NULL),
('Hotel deLuxe', 181, '2019-02-20', 344, NULL),
('Hotel deLuxe', 181, '2019-02-21', 399, NULL),
('Hotel deLuxe', 181, '2019-02-22', 219, NULL),
('Hotel deLuxe', 181, '2019-02-23', 189, NULL),
('Hotel deLuxe', 181, '2019-02-24', 180, NULL),
('Hotel deLuxe', 181, '2019-02-25', 224, NULL),
('Hotel deLuxe', 181, '2019-02-26', 358, NULL),
('Hotel deLuxe', 181, '2019-02-27', 171, NULL),
('Hotel deLuxe', 181, '2019-02-28', 263, NULL),
('Hotel deLuxe', 181, '2019-03-01', 130, NULL),
('Hotel deLuxe', 181, '2019-03-02', 234, NULL),
('Hotel deLuxe', 181, '2019-03-03', 223, NULL),
('Hotel deLuxe', 181, '2019-03-04', 146, NULL),
('Hotel deLuxe', 181, '2019-03-05', 173, NULL),
('Hotel deLuxe', 181, '2019-03-06', 250, NULL),
('Hotel deLuxe', 181, '2019-03-07', 191, NULL),
('Hotel deLuxe', 181, '2019-03-08', 111, NULL),
('Hotel deLuxe', 181, '2019-03-09', 133, NULL),
('Hotel deLuxe', 181, '2019-03-10', 346, NULL),
('Hotel deLuxe', 181, '2019-03-11', 390, NULL),
('Hotel deLuxe', 181, '2019-03-12', 171, NULL),
('Hotel deLuxe', 181, '2019-03-13', 110, NULL),
('Hotel deLuxe', 181, '2019-03-14', 113, NULL),
('Hotel deLuxe', 181, '2019-03-15', 158, NULL),
('Hotel deLuxe', 181, '2019-03-16', 355, NULL),
('Hotel deLuxe', 181, '2019-03-17', 204, NULL),
('Hotel deLuxe', 181, '2019-03-18', 109, NULL),
('Hotel deLuxe', 181, '2019-03-19', 381, NULL),
('Hotel deLuxe', 181, '2019-03-20', 295, NULL),
('Hotel deLuxe', 181, '2019-03-21', 192, NULL),
('Hotel deLuxe', 181, '2019-03-22', 170, NULL),
('Hotel deLuxe', 181, '2019-03-23', 172, NULL),
('Hotel deLuxe', 181, '2019-03-24', 227, NULL),
('Hotel deLuxe', 181, '2019-03-25', 112, NULL),
('Hotel deLuxe', 181, '2019-03-26', 168, NULL),
('Hotel deLuxe', 181, '2019-03-27', 318, NULL),
('Hotel deLuxe', 181, '2019-03-28', 334, NULL),
('Hotel deLuxe', 181, '2019-03-29', 288, NULL),
('Hotel deLuxe', 181, '2019-03-30', 359, NULL),
('Hotel deLuxe', 181, '2019-03-31', 357, NULL),
('Hotel deLuxe', 181, '2019-04-01', 259, NULL),
('Hotel deLuxe', 181, '2019-04-02', 100, NULL),
('Hotel deLuxe', 181, '2019-04-03', 279, NULL),
('Hotel deLuxe', 181, '2019-04-04', 133, NULL),
('Hotel deLuxe', 181, '2019-04-05', 101, NULL),
('Hotel deLuxe', 181, '2019-04-06', 290, NULL),
('Hotel deLuxe', 181, '2019-04-07', 254, NULL),
('Hotel deLuxe', 181, '2019-04-08', 137, NULL),
('Hotel deLuxe', 181, '2019-04-09', 234, NULL),
('Hotel deLuxe', 181, '2019-04-10', 138, NULL),
('Hotel deLuxe', 181, '2019-04-11', 225, NULL),
('Hotel deLuxe', 181, '2019-04-12', 330, NULL),
('Hotel deLuxe', 181, '2019-04-13', 256, NULL),
('Hotel deLuxe', 181, '2019-04-14', 122, NULL),
('Hotel deLuxe', 181, '2019-04-15', 395, NULL),
('Hotel deLuxe', 181, '2019-04-16', 367, NULL),
('Hotel deLuxe', 181, '2019-04-17', 241, NULL),
('Hotel deLuxe', 181, '2019-04-18', 137, NULL),
('Hotel deLuxe', 181, '2019-04-19', 237, NULL),
('Hotel deLuxe', 181, '2019-04-20', 308, NULL),
('Hotel deLuxe', 181, '2019-04-21', 358, NULL),
('Hotel deLuxe', 181, '2019-04-22', 284, NULL),
('Hotel deLuxe', 181, '2019-04-23', 109, NULL),
('Hotel deLuxe', 181, '2019-04-24', 224, NULL),
('Hotel deLuxe', 181, '2019-04-25', 244, NULL),
('Hotel deLuxe', 181, '2019-04-26', 130, NULL),
('Hotel deLuxe', 181, '2019-04-27', 140, NULL),
('Hotel deLuxe', 181, '2019-04-28', 277, NULL),
('Hotel deLuxe', 181, '2019-04-29', 265, NULL),
('Hotel deLuxe', 181, '2019-04-30', 346, NULL),
('Hotel deLuxe', 181, '2019-05-01', 212, NULL),
('Hotel deLuxe', 181, '2019-05-02', 227, NULL),
('Hotel deLuxe', 181, '2019-05-03', 189, NULL),
('Hotel deLuxe', 181, '2019-05-04', 345, NULL),
('Hotel deLuxe', 181, '2019-05-05', 101, NULL),
('Hotel deLuxe', 181, '2019-05-06', 275, NULL),
('Hotel deLuxe', 181, '2019-05-07', 359, NULL),
('Hotel deLuxe', 181, '2019-05-08', 391, NULL),
('Hotel deLuxe', 181, '2019-05-09', 276, NULL),
('Hotel deLuxe', 181, '2019-05-10', 254, NULL),
('Hotel deLuxe', 181, '2019-05-11', 145, NULL),
('Hotel deLuxe', 181, '2019-05-12', 274, NULL),
('Hotel deLuxe', 181, '2019-05-13', 395, NULL),
('Hotel deLuxe', 181, '2019-05-14', 136, NULL),
('Hotel deLuxe', 181, '2019-05-15', 218, NULL),
('Hotel deLuxe', 181, '2019-05-16', 255, NULL),
('Hotel deLuxe', 181, '2019-05-17', 382, NULL),
('Hotel deLuxe', 181, '2019-05-18', 177, NULL),
('Hotel deLuxe', 181, '2019-05-19', 153, NULL),
('Hotel deLuxe', 181, '2019-05-20', 202, NULL),
('Hotel deLuxe', 181, '2019-05-21', 122, NULL),
('Hotel deLuxe', 181, '2019-05-22', 371, NULL),
('Hotel deLuxe', 181, '2019-05-23', 232, NULL),
('Hotel deLuxe', 181, '2019-05-24', 299, NULL),
('Hotel deLuxe', 181, '2019-05-25', 124, NULL),
('Hotel deLuxe', 181, '2019-05-26', 299, NULL),
('Hotel deLuxe', 181, '2019-05-27', 352, NULL),
('Hotel deLuxe', 181, '2019-05-28', 142, NULL),
('Hotel deLuxe', 181, '2019-05-29', 347, NULL),
('Hotel deLuxe', 181, '2019-05-30', 287, NULL),
('Hotel deLuxe', 181, '2019-05-31', 296, NULL),
('Hotel deLuxe', 181, '2019-06-01', 277, NULL),
('Hotel deLuxe', 181, '2019-06-02', 166, NULL),
('Hotel deLuxe', 181, '2019-06-03', 199, NULL),
('Hotel deLuxe', 181, '2019-06-04', 171, NULL),
('Hotel deLuxe', 181, '2019-06-05', 293, NULL),
('Hotel deLuxe', 181, '2019-06-06', 187, NULL),
('Hotel deLuxe', 181, '2019-06-07', 185, NULL),
('Hotel deLuxe', 181, '2019-06-08', 340, NULL),
('Hotel deLuxe', 181, '2019-06-09', 274, NULL),
('Hotel deLuxe', 181, '2019-06-10', 217, NULL),
('Hotel deLuxe', 181, '2019-06-11', 276, NULL),
('Hotel deLuxe', 181, '2019-06-12', 292, NULL),
('Hotel deLuxe', 181, '2019-06-13', 226, NULL),
('Hotel deLuxe', 181, '2019-06-14', 105, NULL),
('Hotel deLuxe', 181, '2019-06-15', 220, NULL),
('Hotel deLuxe', 181, '2019-06-16', 210, NULL),
('Hotel deLuxe', 181, '2019-06-17', 392, NULL),
('Hotel deLuxe', 181, '2019-06-18', 109, NULL),
('Hotel deLuxe', 181, '2019-06-19', 190, NULL),
('Hotel deLuxe', 181, '2019-06-20', 191, NULL),
('Hotel deLuxe', 181, '2019-06-21', 193, NULL),
('Hotel deLuxe', 181, '2019-06-22', 169, NULL),
('Hotel deLuxe', 181, '2019-06-23', 324, NULL),
('Hotel deLuxe', 181, '2019-06-24', 157, NULL),
('Hotel deLuxe', 181, '2019-06-25', 274, NULL),
('Hotel deLuxe', 181, '2019-06-26', 127, NULL),
('Hotel deLuxe', 181, '2019-06-27', 392, NULL),
('Hotel deLuxe', 181, '2019-06-28', 259, NULL),
('Hotel deLuxe', 181, '2019-06-29', 257, NULL),
('Hotel deLuxe', 181, '2019-06-30', 192, NULL),
('Hotel deLuxe', 181, '2019-07-01', 235, NULL),
('Hotel deLuxe', 181, '2019-07-02', 181, NULL),
('Hotel deLuxe', 181, '2019-07-03', 315, NULL),
('Hotel deLuxe', 181, '2019-07-04', 185, NULL),
('Hotel deLuxe', 181, '2019-07-05', 101, NULL),
('Hotel deLuxe', 181, '2019-07-06', 295, NULL),
('Hotel deLuxe', 181, '2019-07-07', 197, NULL),
('Hotel deLuxe', 181, '2019-07-08', 172, NULL),
('Hotel deLuxe', 181, '2019-07-09', 287, NULL),
('Hotel deLuxe', 181, '2019-07-10', 133, NULL),
('Hotel deLuxe', 181, '2019-07-11', 109, NULL),
('Hotel deLuxe', 181, '2019-07-12', 116, NULL),
('Hotel deLuxe', 181, '2019-07-13', 262, NULL),
('Hotel deLuxe', 181, '2019-07-14', 335, NULL),
('Hotel deLuxe', 181, '2019-07-15', 133, NULL),
('Hotel deLuxe', 181, '2019-07-16', 214, NULL),
('Hotel deLuxe', 181, '2019-07-17', 377, NULL),
('Hotel deLuxe', 181, '2019-07-18', 355, NULL),
('Hotel deLuxe', 181, '2019-07-19', 376, NULL),
('Hotel deLuxe', 181, '2019-07-20', 394, NULL),
('Hotel deLuxe', 181, '2019-07-21', 149, NULL),
('Hotel deLuxe', 181, '2019-07-22', 312, NULL),
('Hotel deLuxe', 181, '2019-07-23', 127, NULL),
('Hotel deLuxe', 181, '2019-07-24', 129, NULL),
('Hotel deLuxe', 181, '2019-07-25', 175, NULL),
('Hotel deLuxe', 181, '2019-07-26', 331, NULL),
('Hotel deLuxe', 181, '2019-07-27', 138, NULL),
('Hotel deLuxe', 181, '2019-07-28', 164, NULL),
('Hotel deLuxe', 181, '2019-07-29', 186, NULL),
('Hotel deLuxe', 181, '2019-07-30', 183, NULL),
('Hotel deLuxe', 181, '2019-07-31', 162, NULL),
('Hotel deLuxe', 181, '2019-08-01', 129, NULL),
('Hotel deLuxe', 181, '2019-08-02', 246, NULL),
('Hotel deLuxe', 181, '2019-08-03', 358, NULL),
('Hotel deLuxe', 181, '2019-08-04', 198, NULL),
('Hotel deLuxe', 181, '2019-08-05', 279, NULL),
('Hotel deLuxe', 181, '2019-08-06', 202, NULL),
('Hotel deLuxe', 181, '2019-08-07', 248, NULL),
('Hotel deLuxe', 181, '2019-08-08', 234, NULL),
('Hotel deLuxe', 181, '2019-08-09', 101, NULL),
('Hotel deLuxe', 181, '2019-08-10', 209, NULL),
('Hotel deLuxe', 181, '2019-08-11', 312, NULL),
('Hotel deLuxe', 181, '2019-08-12', 319, NULL),
('Hotel deLuxe', 181, '2019-08-13', 192, NULL),
('Hotel deLuxe', 181, '2019-08-14', 223, NULL),
('Hotel deLuxe', 181, '2019-08-15', 351, NULL),
('Hotel deLuxe', 181, '2019-08-16', 141, NULL),
('Hotel deLuxe', 181, '2019-08-17', 116, NULL),
('Hotel deLuxe', 181, '2019-08-18', 137, NULL),
('Hotel deLuxe', 181, '2019-08-19', 216, NULL),
('Hotel deLuxe', 181, '2019-08-20', 136, NULL),
('Hotel deLuxe', 181, '2019-08-21', 271, NULL),
('Hotel deLuxe', 181, '2019-08-22', 122, NULL),
('Hotel deLuxe', 181, '2019-08-23', 278, NULL),
('Hotel deLuxe', 181, '2019-08-24', 316, NULL),
('Hotel deLuxe', 181, '2019-08-25', 122, NULL),
('Hotel deLuxe', 181, '2019-08-26', 311, NULL),
('Hotel deLuxe', 181, '2019-08-27', 287, NULL),
('Hotel deLuxe', 181, '2019-08-28', 172, NULL),
('Hotel deLuxe', 181, '2019-08-29', 291, NULL),
('Hotel deLuxe', 181, '2019-08-30', 226, NULL),
('Hotel deLuxe', 181, '2019-08-31', 301, NULL),
('Hotel deLuxe', 181, '2019-09-01', 235, NULL),
('Hotel deLuxe', 181, '2019-09-02', 337, NULL),
('Hotel deLuxe', 181, '2019-09-03', 195, NULL),
('Hotel deLuxe', 181, '2019-09-04', 312, NULL),
('Hotel deLuxe', 181, '2019-09-05', 119, NULL),
('Hotel deLuxe', 181, '2019-09-06', 172, NULL),
('Hotel deLuxe', 181, '2019-09-07', 123, NULL),
('Hotel deLuxe', 181, '2019-09-08', 132, NULL),
('Hotel deLuxe', 181, '2019-09-09', 351, NULL),
('Hotel deLuxe', 181, '2019-09-10', 326, NULL),
('Hotel deLuxe', 181, '2019-09-11', 200, NULL),
('Hotel deLuxe', 181, '2019-09-12', 175, NULL),
('Hotel deLuxe', 181, '2019-09-13', 148, NULL),
('Hotel deLuxe', 181, '2019-09-14', 101, NULL),
('Hotel deLuxe', 181, '2019-09-15', 158, NULL),
('Hotel deLuxe', 181, '2019-09-16', 350, NULL),
('Hotel deLuxe', 181, '2019-09-17', 223, NULL),
('Hotel deLuxe', 181, '2019-09-18', 200, NULL),
('Hotel deLuxe', 181, '2019-09-19', 353, NULL),
('Hotel deLuxe', 181, '2019-09-20', 195, NULL),
('Hotel deLuxe', 181, '2019-09-21', 266, NULL),
('Hotel deLuxe', 181, '2019-09-22', 372, NULL),
('Hotel deLuxe', 181, '2019-09-23', 291, NULL),
('Hotel deLuxe', 181, '2019-09-24', 159, NULL),
('Hotel deLuxe', 181, '2019-09-25', 166, NULL),
('Hotel deLuxe', 181, '2019-09-26', 332, NULL),
('Hotel deLuxe', 181, '2019-09-27', 304, NULL),
('Hotel deLuxe', 181, '2019-09-28', 181, NULL),
('Hotel deLuxe', 181, '2019-09-29', 259, NULL),
('Hotel deLuxe', 181, '2019-09-30', 310, NULL),
('Hotel deLuxe', 181, '2019-10-01', 382, NULL),
('Hotel deLuxe', 181, '2019-10-02', 193, NULL),
('Hotel deLuxe', 181, '2019-10-03', 252, NULL),
('Hotel deLuxe', 181, '2019-10-04', 110, NULL),
('Hotel deLuxe', 181, '2019-10-05', 237, NULL),
('Hotel deLuxe', 181, '2019-10-06', 234, NULL),
('Hotel deLuxe', 181, '2019-10-07', 339, NULL),
('Hotel deLuxe', 181, '2019-10-08', 104, NULL),
('Hotel deLuxe', 181, '2019-10-09', 279, NULL),
('Hotel deLuxe', 181, '2019-10-10', 121, NULL),
('Hotel deLuxe', 181, '2019-10-11', 210, NULL),
('Hotel deLuxe', 181, '2019-10-12', 111, NULL),
('Hotel deLuxe', 181, '2019-10-13', 154, NULL),
('Hotel deLuxe', 181, '2019-10-14', 207, NULL),
('Hotel deLuxe', 181, '2019-10-15', 181, NULL),
('Hotel deLuxe', 181, '2019-10-16', 256, NULL),
('Hotel deLuxe', 181, '2019-10-17', 219, NULL),
('Hotel deLuxe', 181, '2019-10-18', 247, NULL),
('Hotel deLuxe', 181, '2019-10-19', 366, NULL),
('Hotel deLuxe', 181, '2019-10-20', 333, NULL),
('Hotel deLuxe', 181, '2019-10-21', 203, NULL),
('Hotel deLuxe', 181, '2019-10-22', 249, NULL),
('Hotel deLuxe', 181, '2019-10-23', 393, NULL),
('Hotel deLuxe', 181, '2019-10-24', 180, NULL),
('Hotel deLuxe', 181, '2019-10-25', 129, NULL),
('Hotel deLuxe', 181, '2019-10-26', 251, NULL),
('Hotel deLuxe', 181, '2019-10-27', 184, NULL),
('Hotel deLuxe', 181, '2019-10-28', 291, NULL),
('Hotel deLuxe', 181, '2019-10-29', 130, NULL),
('Hotel deLuxe', 181, '2019-10-30', 320, NULL),
('Hotel deLuxe', 181, '2019-10-31', 272, NULL),
('Hotel deLuxe', 181, '2019-11-01', 381, NULL),
('Hotel deLuxe', 181, '2019-11-02', 311, NULL),
('Hotel deLuxe', 181, '2019-11-03', 300, NULL),
('Hotel deLuxe', 181, '2019-11-04', 137, NULL),
('Hotel deLuxe', 181, '2019-11-05', 376, NULL),
('Hotel deLuxe', 181, '2019-11-06', 383, NULL),
('Hotel deLuxe', 181, '2019-11-07', 132, NULL),
('Hotel deLuxe', 181, '2019-11-08', 151, NULL),
('Hotel deLuxe', 181, '2019-11-09', 191, NULL),
('Hotel deLuxe', 181, '2019-11-10', 268, NULL),
('Hotel deLuxe', 181, '2019-11-11', 228, NULL),
('Hotel deLuxe', 181, '2019-11-12', 302, NULL),
('Hotel deLuxe', 181, '2019-11-13', 342, NULL),
('Hotel deLuxe', 181, '2019-11-14', 134, NULL),
('Hotel deLuxe', 181, '2019-11-15', 155, NULL),
('Hotel deLuxe', 181, '2019-11-16', 331, NULL),
('Hotel deLuxe', 181, '2019-11-17', 346, NULL),
('Hotel deLuxe', 181, '2019-11-18', 220, NULL),
('Hotel deLuxe', 181, '2019-11-19', 398, NULL),
('Hotel deLuxe', 181, '2019-11-20', 102, NULL),
('Hotel deLuxe', 181, '2019-11-21', 146, NULL),
('Hotel deLuxe', 181, '2019-11-22', 169, NULL),
('Hotel deLuxe', 181, '2019-11-23', 328, NULL),
('Hotel deLuxe', 181, '2019-11-24', 295, NULL),
('Hotel deLuxe', 181, '2019-11-25', 299, NULL),
('Hotel deLuxe', 181, '2019-11-26', 290, NULL),
('Hotel deLuxe', 181, '2019-11-27', 246, NULL),
('Hotel deLuxe', 181, '2019-11-28', 315, NULL),
('Hotel deLuxe', 181, '2019-11-29', 147, NULL),
('Hotel deLuxe', 181, '2019-11-30', 383, NULL),
('Hotel deLuxe', 181, '2019-12-01', 356, NULL),
('Hotel deLuxe', 181, '2019-12-02', 189, NULL),
('Hotel deLuxe', 181, '2019-12-03', 311, NULL),
('Hotel deLuxe', 181, '2019-12-04', 213, NULL),
('Hotel deLuxe', 181, '2019-12-05', 172, NULL),
('Hotel deLuxe', 181, '2019-12-06', 373, NULL),
('Hotel deLuxe', 181, '2019-12-07', 150, NULL),
('Hotel deLuxe', 181, '2019-12-08', 269, NULL),
('Hotel deLuxe', 181, '2019-12-09', 326, NULL),
('Hotel deLuxe', 181, '2019-12-10', 272, NULL),
('Hotel deLuxe', 181, '2019-12-11', 362, NULL),
('Hotel deLuxe', 181, '2019-12-12', 259, NULL),
('Hotel deLuxe', 181, '2019-12-13', 387, NULL),
('Hotel deLuxe', 181, '2019-12-14', 204, NULL),
('Hotel deLuxe', 181, '2019-12-15', 199, NULL),
('Hotel deLuxe', 181, '2019-12-16', 152, NULL),
('Hotel deLuxe', 181, '2019-12-17', 107, NULL),
('Hotel deLuxe', 181, '2019-12-18', 143, NULL),
('Hotel deLuxe', 181, '2019-12-19', 249, NULL),
('Hotel deLuxe', 181, '2019-12-20', 228, NULL),
('Hotel deLuxe', 181, '2019-12-21', 241, NULL),
('Hotel deLuxe', 181, '2019-12-22', 295, NULL),
('Hotel deLuxe', 181, '2019-12-23', 145, NULL),
('Hotel deLuxe', 181, '2019-12-24', 370, NULL),
('Hotel deLuxe', 181, '2019-12-25', 303, NULL),
('Hotel deLuxe', 181, '2019-12-26', 249, NULL),
('Hotel deLuxe', 181, '2019-12-27', 214, NULL),
('Hotel deLuxe', 181, '2019-12-28', 299, NULL),
('Hotel deLuxe', 181, '2019-12-29', 384, NULL),
('Hotel deLuxe', 181, '2019-12-30', 327, NULL),
('Hotel deLuxe', 181, '2019-12-31', 267, NULL),
('Hotel deLuxe', 181, '2020-01-01', 259, NULL),
('Hotel deLuxe', 181, '2020-01-02', 355, NULL),
('Hotel deLuxe', 181, '2020-01-03', 377, NULL),
('Hotel deLuxe', 181, '2020-01-04', 272, NULL),
('Hotel deLuxe', 181, '2020-01-05', 181, NULL),
('Hotel deLuxe', 181, '2020-01-06', 370, NULL),
('Hotel deLuxe', 181, '2020-01-07', 235, NULL),
('Hotel deLuxe', 181, '2020-01-08', 168, NULL),
('Hotel deLuxe', 181, '2020-01-09', 364, NULL),
('Hotel deLuxe', 181, '2020-01-10', 137, NULL),
('Hotel deLuxe', 181, '2020-01-11', 106, NULL),
('Hotel deLuxe', 181, '2020-01-12', 232, NULL),
('Hotel deLuxe', 181, '2020-01-13', 373, NULL),
('Hotel deLuxe', 181, '2020-01-14', 253, NULL),
('Hotel deLuxe', 181, '2020-01-15', 272, NULL),
('Hotel deLuxe', 181, '2020-01-16', 207, NULL),
('Hotel deLuxe', 181, '2020-01-17', 152, NULL),
('Hotel deLuxe', 181, '2020-01-18', 100, NULL),
('Hotel deLuxe', 181, '2020-01-19', 280, NULL),
('Hotel deLuxe', 181, '2020-01-20', 309, NULL),
('Hotel deLuxe', 181, '2020-01-21', 253, NULL),
('Hotel deLuxe', 181, '2020-01-22', 103, NULL),
('Hotel deLuxe', 181, '2020-01-23', 299, NULL),
('Hotel deLuxe', 181, '2020-01-24', 357, NULL),
('Hotel deLuxe', 181, '2020-01-25', 251, NULL),
('Hotel deLuxe', 181, '2020-01-26', 154, NULL),
('Hotel deLuxe', 181, '2020-01-27', 368, NULL),
('Hotel deLuxe', 181, '2020-01-28', 235, NULL),
('Hotel deLuxe', 181, '2020-01-29', 210, NULL),
('Hotel deLuxe', 181, '2020-01-30', 333, NULL),
('Hotel deLuxe', 181, '2020-01-31', 101, NULL),
('Hotel deLuxe', 181, '2020-02-01', 122, NULL),
('Hotel deLuxe', 181, '2020-02-02', 226, NULL),
('Hotel deLuxe', 181, '2020-02-03', 347, NULL),
('Hotel deLuxe', 181, '2020-02-04', 133, NULL),
('Hotel deLuxe', 205, '2019-01-01', 380, NULL),
('Hotel deLuxe', 205, '2019-01-02', 284, NULL),
('Hotel deLuxe', 205, '2019-01-03', 206, NULL),
('Hotel deLuxe', 205, '2019-01-04', 227, NULL),
('Hotel deLuxe', 205, '2019-01-05', 349, NULL),
('Hotel deLuxe', 205, '2019-01-06', 226, NULL),
('Hotel deLuxe', 205, '2019-01-07', 231, NULL),
('Hotel deLuxe', 205, '2019-01-08', 357, NULL),
('Hotel deLuxe', 205, '2019-01-09', 205, NULL),
('Hotel deLuxe', 205, '2019-01-10', 166, NULL),
('Hotel deLuxe', 205, '2019-01-11', 384, NULL),
('Hotel deLuxe', 205, '2019-01-12', 277, NULL),
('Hotel deLuxe', 205, '2019-01-13', 105, NULL),
('Hotel deLuxe', 205, '2019-01-14', 119, NULL),
('Hotel deLuxe', 205, '2019-01-15', 376, NULL),
('Hotel deLuxe', 205, '2019-01-16', 277, NULL),
('Hotel deLuxe', 205, '2019-01-17', 171, NULL),
('Hotel deLuxe', 205, '2019-01-18', 387, NULL),
('Hotel deLuxe', 205, '2019-01-19', 139, NULL),
('Hotel deLuxe', 205, '2019-01-20', 300, NULL),
('Hotel deLuxe', 205, '2019-01-21', 150, NULL),
('Hotel deLuxe', 205, '2019-01-22', 246, NULL),
('Hotel deLuxe', 205, '2019-01-23', 130, NULL),
('Hotel deLuxe', 205, '2019-01-24', 386, NULL),
('Hotel deLuxe', 205, '2019-01-25', 344, NULL),
('Hotel deLuxe', 205, '2019-01-26', 265, NULL),
('Hotel deLuxe', 205, '2019-01-27', 148, NULL),
('Hotel deLuxe', 205, '2019-01-28', 226, NULL),
('Hotel deLuxe', 205, '2019-01-29', 272, NULL),
('Hotel deLuxe', 205, '2019-01-30', 323, NULL),
('Hotel deLuxe', 205, '2019-01-31', 322, NULL),
('Hotel deLuxe', 205, '2019-02-01', 280, NULL),
('Hotel deLuxe', 205, '2019-02-02', 379, NULL),
('Hotel deLuxe', 205, '2019-02-03', 235, NULL),
('Hotel deLuxe', 205, '2019-02-04', 126, NULL),
('Hotel deLuxe', 205, '2019-02-05', 188, NULL),
('Hotel deLuxe', 205, '2019-02-06', 117, NULL),
('Hotel deLuxe', 205, '2019-02-07', 369, NULL),
('Hotel deLuxe', 205, '2019-02-08', 209, NULL),
('Hotel deLuxe', 205, '2019-02-09', 205, NULL),
('Hotel deLuxe', 205, '2019-02-10', 219, NULL),
('Hotel deLuxe', 205, '2019-02-11', 346, NULL),
('Hotel deLuxe', 205, '2019-02-12', 109, NULL),
('Hotel deLuxe', 205, '2019-02-13', 156, NULL),
('Hotel deLuxe', 205, '2019-02-14', 241, NULL),
('Hotel deLuxe', 205, '2019-02-15', 246, NULL),
('Hotel deLuxe', 205, '2019-02-16', 378, NULL),
('Hotel deLuxe', 205, '2019-02-17', 338, NULL),
('Hotel deLuxe', 205, '2019-02-18', 329, NULL),
('Hotel deLuxe', 205, '2019-02-19', 147, NULL),
('Hotel deLuxe', 205, '2019-02-20', 272, NULL),
('Hotel deLuxe', 205, '2019-02-21', 280, NULL),
('Hotel deLuxe', 205, '2019-02-22', 156, NULL),
('Hotel deLuxe', 205, '2019-02-23', 100, NULL),
('Hotel deLuxe', 205, '2019-02-24', 203, NULL),
('Hotel deLuxe', 205, '2019-02-25', 152, NULL),
('Hotel deLuxe', 205, '2019-02-26', 220, NULL),
('Hotel deLuxe', 205, '2019-02-27', 276, NULL),
('Hotel deLuxe', 205, '2019-02-28', 336, NULL),
('Hotel deLuxe', 205, '2019-03-01', 176, NULL),
('Hotel deLuxe', 205, '2019-03-02', 152, NULL),
('Hotel deLuxe', 205, '2019-03-03', 319, NULL),
('Hotel deLuxe', 205, '2019-03-04', 324, NULL),
('Hotel deLuxe', 205, '2019-03-05', 276, NULL),
('Hotel deLuxe', 205, '2019-03-06', 372, NULL),
('Hotel deLuxe', 205, '2019-03-07', 231, NULL),
('Hotel deLuxe', 205, '2019-03-08', 332, NULL),
('Hotel deLuxe', 205, '2019-03-09', 200, NULL),
('Hotel deLuxe', 205, '2019-03-10', 333, NULL),
('Hotel deLuxe', 205, '2019-03-11', 351, NULL),
('Hotel deLuxe', 205, '2019-03-12', 342, NULL),
('Hotel deLuxe', 205, '2019-03-13', 272, NULL),
('Hotel deLuxe', 205, '2019-03-14', 339, NULL),
('Hotel deLuxe', 205, '2019-03-15', 185, NULL),
('Hotel deLuxe', 205, '2019-03-16', 299, NULL),
('Hotel deLuxe', 205, '2019-03-17', 117, NULL),
('Hotel deLuxe', 205, '2019-03-18', 212, NULL),
('Hotel deLuxe', 205, '2019-03-19', 320, NULL),
('Hotel deLuxe', 205, '2019-03-20', 125, NULL),
('Hotel deLuxe', 205, '2019-03-21', 304, NULL),
('Hotel deLuxe', 205, '2019-03-22', 289, NULL),
('Hotel deLuxe', 205, '2019-03-23', 251, NULL),
('Hotel deLuxe', 205, '2019-03-24', 127, NULL),
('Hotel deLuxe', 205, '2019-03-25', 131, NULL),
('Hotel deLuxe', 205, '2019-03-26', 368, NULL),
('Hotel deLuxe', 205, '2019-03-27', 122, NULL),
('Hotel deLuxe', 205, '2019-03-28', 133, NULL),
('Hotel deLuxe', 205, '2019-03-29', 305, NULL),
('Hotel deLuxe', 205, '2019-03-30', 384, NULL),
('Hotel deLuxe', 205, '2019-03-31', 325, NULL),
('Hotel deLuxe', 205, '2019-04-01', 183, NULL),
('Hotel deLuxe', 205, '2019-04-02', 216, NULL),
('Hotel deLuxe', 205, '2019-04-03', 186, NULL),
('Hotel deLuxe', 205, '2019-04-04', 155, NULL),
('Hotel deLuxe', 205, '2019-04-05', 159, NULL),
('Hotel deLuxe', 205, '2019-04-06', 166, NULL),
('Hotel deLuxe', 205, '2019-04-07', 233, NULL),
('Hotel deLuxe', 205, '2019-04-08', 370, NULL),
('Hotel deLuxe', 205, '2019-04-09', 308, NULL),
('Hotel deLuxe', 205, '2019-04-10', 290, NULL),
('Hotel deLuxe', 205, '2019-04-11', 102, NULL),
('Hotel deLuxe', 205, '2019-04-12', 155, NULL),
('Hotel deLuxe', 205, '2019-04-13', 311, NULL),
('Hotel deLuxe', 205, '2019-04-14', 242, NULL),
('Hotel deLuxe', 205, '2019-04-15', 370, NULL),
('Hotel deLuxe', 205, '2019-04-16', 169, NULL),
('Hotel deLuxe', 205, '2019-04-17', 299, NULL),
('Hotel deLuxe', 205, '2019-04-18', 238, NULL),
('Hotel deLuxe', 205, '2019-04-19', 381, NULL),
('Hotel deLuxe', 205, '2019-04-20', 175, NULL),
('Hotel deLuxe', 205, '2019-04-21', 209, NULL),
('Hotel deLuxe', 205, '2019-04-22', 369, NULL),
('Hotel deLuxe', 205, '2019-04-23', 215, NULL),
('Hotel deLuxe', 205, '2019-04-24', 184, NULL),
('Hotel deLuxe', 205, '2019-04-25', 229, NULL),
('Hotel deLuxe', 205, '2019-04-26', 301, NULL),
('Hotel deLuxe', 205, '2019-04-27', 218, NULL),
('Hotel deLuxe', 205, '2019-04-28', 249, NULL),
('Hotel deLuxe', 205, '2019-04-29', 385, NULL),
('Hotel deLuxe', 205, '2019-04-30', 105, NULL),
('Hotel deLuxe', 205, '2019-05-01', 355, NULL),
('Hotel deLuxe', 205, '2019-05-02', 213, NULL),
('Hotel deLuxe', 205, '2019-05-03', 323, NULL),
('Hotel deLuxe', 205, '2019-05-04', 226, NULL),
('Hotel deLuxe', 205, '2019-05-05', 340, NULL),
('Hotel deLuxe', 205, '2019-05-06', 367, NULL),
('Hotel deLuxe', 205, '2019-05-07', 288, NULL),
('Hotel deLuxe', 205, '2019-05-08', 159, NULL),
('Hotel deLuxe', 205, '2019-05-09', 352, NULL),
('Hotel deLuxe', 205, '2019-05-10', 333, NULL),
('Hotel deLuxe', 205, '2019-05-11', 395, NULL),
('Hotel deLuxe', 205, '2019-05-12', 240, NULL),
('Hotel deLuxe', 205, '2019-05-13', 373, NULL),
('Hotel deLuxe', 205, '2019-05-14', 338, NULL),
('Hotel deLuxe', 205, '2019-05-15', 161, NULL),
('Hotel deLuxe', 205, '2019-05-16', 213, NULL),
('Hotel deLuxe', 205, '2019-05-17', 169, NULL),
('Hotel deLuxe', 205, '2019-05-18', 350, NULL),
('Hotel deLuxe', 205, '2019-05-19', 133, NULL),
('Hotel deLuxe', 205, '2019-05-20', 221, NULL),
('Hotel deLuxe', 205, '2019-05-21', 193, NULL),
('Hotel deLuxe', 205, '2019-05-22', 217, NULL),
('Hotel deLuxe', 205, '2019-05-23', 351, NULL),
('Hotel deLuxe', 205, '2019-05-24', 300, NULL),
('Hotel deLuxe', 205, '2019-05-25', 290, NULL),
('Hotel deLuxe', 205, '2019-05-26', 306, NULL),
('Hotel deLuxe', 205, '2019-05-27', 218, NULL),
('Hotel deLuxe', 205, '2019-05-28', 106, NULL),
('Hotel deLuxe', 205, '2019-05-29', 308, NULL),
('Hotel deLuxe', 205, '2019-05-30', 168, NULL),
('Hotel deLuxe', 205, '2019-05-31', 291, NULL),
('Hotel deLuxe', 205, '2019-06-01', 278, NULL),
('Hotel deLuxe', 205, '2019-06-02', 302, NULL),
('Hotel deLuxe', 205, '2019-06-03', 151, NULL),
('Hotel deLuxe', 205, '2019-06-04', 264, NULL),
('Hotel deLuxe', 205, '2019-06-05', 147, NULL),
('Hotel deLuxe', 205, '2019-06-06', 210, NULL),
('Hotel deLuxe', 205, '2019-06-07', 186, NULL),
('Hotel deLuxe', 205, '2019-06-08', 338, NULL),
('Hotel deLuxe', 205, '2019-06-09', 194, NULL),
('Hotel deLuxe', 205, '2019-06-10', 346, NULL),
('Hotel deLuxe', 205, '2019-06-11', 330, NULL),
('Hotel deLuxe', 205, '2019-06-12', 311, NULL),
('Hotel deLuxe', 205, '2019-06-13', 200, NULL),
('Hotel deLuxe', 205, '2019-06-14', 317, NULL),
('Hotel deLuxe', 205, '2019-06-15', 116, NULL),
('Hotel deLuxe', 205, '2019-06-16', 152, NULL),
('Hotel deLuxe', 205, '2019-06-17', 322, NULL),
('Hotel deLuxe', 205, '2019-06-18', 212, NULL),
('Hotel deLuxe', 205, '2019-06-19', 194, NULL),
('Hotel deLuxe', 205, '2019-06-20', 368, NULL),
('Hotel deLuxe', 205, '2019-06-21', 239, NULL),
('Hotel deLuxe', 205, '2019-06-22', 297, NULL),
('Hotel deLuxe', 205, '2019-06-23', 379, NULL),
('Hotel deLuxe', 205, '2019-06-24', 300, NULL),
('Hotel deLuxe', 205, '2019-06-25', 238, NULL),
('Hotel deLuxe', 205, '2019-06-26', 200, NULL),
('Hotel deLuxe', 205, '2019-06-27', 118, NULL),
('Hotel deLuxe', 205, '2019-06-28', 216, NULL),
('Hotel deLuxe', 205, '2019-06-29', 341, NULL),
('Hotel deLuxe', 205, '2019-06-30', 126, NULL),
('Hotel deLuxe', 205, '2019-07-01', 333, NULL),
('Hotel deLuxe', 205, '2019-07-02', 211, NULL),
('Hotel deLuxe', 205, '2019-07-03', 257, NULL),
('Hotel deLuxe', 205, '2019-07-04', 135, NULL),
('Hotel deLuxe', 205, '2019-07-05', 163, NULL),
('Hotel deLuxe', 205, '2019-07-06', 323, NULL),
('Hotel deLuxe', 205, '2019-07-07', 356, NULL),
('Hotel deLuxe', 205, '2019-07-08', 273, NULL),
('Hotel deLuxe', 205, '2019-07-09', 183, NULL),
('Hotel deLuxe', 205, '2019-07-10', 312, NULL),
('Hotel deLuxe', 205, '2019-07-11', 355, NULL),
('Hotel deLuxe', 205, '2019-07-12', 173, NULL),
('Hotel deLuxe', 205, '2019-07-13', 318, NULL),
('Hotel deLuxe', 205, '2019-07-14', 350, NULL),
('Hotel deLuxe', 205, '2019-07-15', 263, NULL),
('Hotel deLuxe', 205, '2019-07-16', 248, NULL),
('Hotel deLuxe', 205, '2019-07-17', 115, NULL),
('Hotel deLuxe', 205, '2019-07-18', 116, NULL),
('Hotel deLuxe', 205, '2019-07-19', 104, NULL),
('Hotel deLuxe', 205, '2019-07-20', 288, NULL),
('Hotel deLuxe', 205, '2019-07-21', 139, NULL),
('Hotel deLuxe', 205, '2019-07-22', 333, NULL),
('Hotel deLuxe', 205, '2019-07-23', 206, NULL),
('Hotel deLuxe', 205, '2019-07-24', 122, NULL),
('Hotel deLuxe', 205, '2019-07-25', 280, NULL),
('Hotel deLuxe', 205, '2019-07-26', 310, NULL),
('Hotel deLuxe', 205, '2019-07-27', 223, NULL),
('Hotel deLuxe', 205, '2019-07-28', 236, NULL),
('Hotel deLuxe', 205, '2019-07-29', 270, NULL),
('Hotel deLuxe', 205, '2019-07-30', 260, NULL),
('Hotel deLuxe', 205, '2019-07-31', 328, NULL),
('Hotel deLuxe', 205, '2019-08-01', 276, NULL),
('Hotel deLuxe', 205, '2019-08-02', 109, NULL),
('Hotel deLuxe', 205, '2019-08-03', 229, NULL),
('Hotel deLuxe', 205, '2019-08-04', 166, NULL),
('Hotel deLuxe', 205, '2019-08-05', 104, NULL),
('Hotel deLuxe', 205, '2019-08-06', 323, NULL),
('Hotel deLuxe', 205, '2019-08-07', 123, NULL),
('Hotel deLuxe', 205, '2019-08-08', 324, NULL),
('Hotel deLuxe', 205, '2019-08-09', 399, NULL),
('Hotel deLuxe', 205, '2019-08-10', 181, NULL),
('Hotel deLuxe', 205, '2019-08-11', 340, NULL),
('Hotel deLuxe', 205, '2019-08-12', 307, NULL),
('Hotel deLuxe', 205, '2019-08-13', 376, NULL),
('Hotel deLuxe', 205, '2019-08-14', 131, NULL),
('Hotel deLuxe', 205, '2019-08-15', 225, NULL),
('Hotel deLuxe', 205, '2019-08-16', 333, NULL),
('Hotel deLuxe', 205, '2019-08-17', 299, NULL),
('Hotel deLuxe', 205, '2019-08-18', 217, NULL),
('Hotel deLuxe', 205, '2019-08-19', 307, NULL),
('Hotel deLuxe', 205, '2019-08-20', 139, NULL),
('Hotel deLuxe', 205, '2019-08-21', 256, NULL),
('Hotel deLuxe', 205, '2019-08-22', 251, NULL),
('Hotel deLuxe', 205, '2019-08-23', 288, NULL),
('Hotel deLuxe', 205, '2019-08-24', 185, NULL),
('Hotel deLuxe', 205, '2019-08-25', 277, NULL),
('Hotel deLuxe', 205, '2019-08-26', 324, NULL),
('Hotel deLuxe', 205, '2019-08-27', 212, NULL),
('Hotel deLuxe', 205, '2019-08-28', 224, NULL),
('Hotel deLuxe', 205, '2019-08-29', 241, NULL),
('Hotel deLuxe', 205, '2019-08-30', 328, NULL),
('Hotel deLuxe', 205, '2019-08-31', 136, NULL),
('Hotel deLuxe', 205, '2019-09-01', 334, NULL),
('Hotel deLuxe', 205, '2019-09-02', 397, NULL),
('Hotel deLuxe', 205, '2019-09-03', 126, NULL),
('Hotel deLuxe', 205, '2019-09-04', 283, NULL),
('Hotel deLuxe', 205, '2019-09-05', 214, NULL),
('Hotel deLuxe', 205, '2019-09-06', 229, NULL),
('Hotel deLuxe', 205, '2019-09-07', 320, NULL),
('Hotel deLuxe', 205, '2019-09-08', 374, NULL),
('Hotel deLuxe', 205, '2019-09-09', 258, NULL),
('Hotel deLuxe', 205, '2019-09-10', 305, NULL),
('Hotel deLuxe', 205, '2019-09-11', 348, NULL),
('Hotel deLuxe', 205, '2019-09-12', 181, NULL),
('Hotel deLuxe', 205, '2019-09-13', 268, NULL),
('Hotel deLuxe', 205, '2019-09-14', 383, NULL),
('Hotel deLuxe', 205, '2019-09-15', 276, NULL),
('Hotel deLuxe', 205, '2019-09-16', 313, NULL),
('Hotel deLuxe', 205, '2019-09-17', 116, NULL),
('Hotel deLuxe', 205, '2019-09-18', 129, NULL),
('Hotel deLuxe', 205, '2019-09-19', 183, NULL),
('Hotel deLuxe', 205, '2019-09-20', 214, NULL),
('Hotel deLuxe', 205, '2019-09-21', 277, NULL),
('Hotel deLuxe', 205, '2019-09-22', 105, NULL),
('Hotel deLuxe', 205, '2019-09-23', 217, NULL),
('Hotel deLuxe', 205, '2019-09-24', 225, NULL),
('Hotel deLuxe', 205, '2019-09-25', 328, NULL),
('Hotel deLuxe', 205, '2019-09-26', 134, NULL),
('Hotel deLuxe', 205, '2019-09-27', 390, NULL),
('Hotel deLuxe', 205, '2019-09-28', 387, NULL),
('Hotel deLuxe', 205, '2019-09-29', 359, NULL),
('Hotel deLuxe', 205, '2019-09-30', 276, NULL),
('Hotel deLuxe', 205, '2019-10-01', 184, NULL),
('Hotel deLuxe', 205, '2019-10-02', 170, NULL),
('Hotel deLuxe', 205, '2019-10-03', 360, NULL),
('Hotel deLuxe', 205, '2019-10-04', 302, NULL),
('Hotel deLuxe', 205, '2019-10-05', 232, NULL),
('Hotel deLuxe', 205, '2019-10-06', 298, NULL),
('Hotel deLuxe', 205, '2019-10-07', 132, NULL),
('Hotel deLuxe', 205, '2019-10-08', 205, NULL),
('Hotel deLuxe', 205, '2019-10-09', 100, NULL),
('Hotel deLuxe', 205, '2019-10-10', 118, NULL),
('Hotel deLuxe', 205, '2019-10-11', 244, NULL),
('Hotel deLuxe', 205, '2019-10-12', 326, NULL),
('Hotel deLuxe', 205, '2019-10-13', 106, NULL),
('Hotel deLuxe', 205, '2019-10-14', 370, NULL),
('Hotel deLuxe', 205, '2019-10-15', 385, NULL),
('Hotel deLuxe', 205, '2019-10-16', 294, NULL),
('Hotel deLuxe', 205, '2019-10-17', 352, NULL),
('Hotel deLuxe', 205, '2019-10-18', 115, NULL),
('Hotel deLuxe', 205, '2019-10-19', 295, NULL),
('Hotel deLuxe', 205, '2019-10-20', 346, NULL),
('Hotel deLuxe', 205, '2019-10-21', 390, NULL),
('Hotel deLuxe', 205, '2019-10-22', 307, NULL),
('Hotel deLuxe', 205, '2019-10-23', 321, NULL),
('Hotel deLuxe', 205, '2019-10-24', 278, NULL),
('Hotel deLuxe', 205, '2019-10-25', 332, NULL),
('Hotel deLuxe', 205, '2019-10-26', 120, NULL),
('Hotel deLuxe', 205, '2019-10-27', 377, NULL),
('Hotel deLuxe', 205, '2019-10-28', 385, NULL),
('Hotel deLuxe', 205, '2019-10-29', 355, NULL),
('Hotel deLuxe', 205, '2019-10-30', 279, NULL),
('Hotel deLuxe', 205, '2019-10-31', 272, NULL),
('Hotel deLuxe', 205, '2019-11-01', 283, NULL),
('Hotel deLuxe', 205, '2019-11-02', 102, NULL),
('Hotel deLuxe', 205, '2019-11-03', 296, NULL),
('Hotel deLuxe', 205, '2019-11-04', 178, NULL),
('Hotel deLuxe', 205, '2019-11-05', 250, NULL),
('Hotel deLuxe', 205, '2019-11-06', 225, NULL),
('Hotel deLuxe', 205, '2019-11-07', 166, NULL),
('Hotel deLuxe', 205, '2019-11-08', 198, NULL),
('Hotel deLuxe', 205, '2019-11-09', 220, NULL),
('Hotel deLuxe', 205, '2019-11-10', 232, NULL),
('Hotel deLuxe', 205, '2019-11-11', 337, NULL),
('Hotel deLuxe', 205, '2019-11-12', 201, NULL),
('Hotel deLuxe', 205, '2019-11-13', 268, NULL),
('Hotel deLuxe', 205, '2019-11-14', 239, NULL),
('Hotel deLuxe', 205, '2019-11-15', 204, NULL),
('Hotel deLuxe', 205, '2019-11-16', 219, NULL),
('Hotel deLuxe', 205, '2019-11-17', 227, NULL),
('Hotel deLuxe', 205, '2019-11-18', 175, NULL),
('Hotel deLuxe', 205, '2019-11-19', 218, NULL),
('Hotel deLuxe', 205, '2019-11-20', 117, NULL),
('Hotel deLuxe', 205, '2019-11-21', 146, NULL),
('Hotel deLuxe', 205, '2019-11-22', 205, NULL),
('Hotel deLuxe', 205, '2019-11-23', 104, NULL),
('Hotel deLuxe', 205, '2019-11-24', 187, NULL),
('Hotel deLuxe', 205, '2019-11-25', 274, NULL),
('Hotel deLuxe', 205, '2019-11-26', 113, NULL),
('Hotel deLuxe', 205, '2019-11-27', 381, NULL),
('Hotel deLuxe', 205, '2019-11-28', 296, NULL),
('Hotel deLuxe', 205, '2019-11-29', 232, NULL),
('Hotel deLuxe', 205, '2019-11-30', 299, NULL),
('Hotel deLuxe', 205, '2019-12-01', 335, NULL),
('Hotel deLuxe', 205, '2019-12-02', 324, NULL),
('Hotel deLuxe', 205, '2019-12-03', 221, NULL),
('Hotel deLuxe', 205, '2019-12-04', 270, NULL),
('Hotel deLuxe', 205, '2019-12-05', 126, NULL),
('Hotel deLuxe', 205, '2019-12-06', 331, NULL),
('Hotel deLuxe', 205, '2019-12-07', 141, NULL),
('Hotel deLuxe', 205, '2019-12-08', 383, NULL),
('Hotel deLuxe', 205, '2019-12-09', 190, NULL),
('Hotel deLuxe', 205, '2019-12-10', 310, NULL),
('Hotel deLuxe', 205, '2019-12-11', 197, NULL),
('Hotel deLuxe', 205, '2019-12-12', 399, NULL),
('Hotel deLuxe', 205, '2019-12-13', 110, NULL),
('Hotel deLuxe', 205, '2019-12-14', 265, NULL),
('Hotel deLuxe', 205, '2019-12-15', 184, NULL),
('Hotel deLuxe', 205, '2019-12-16', 145, NULL),
('Hotel deLuxe', 205, '2019-12-17', 313, NULL),
('Hotel deLuxe', 205, '2019-12-18', 132, NULL),
('Hotel deLuxe', 205, '2019-12-19', 364, NULL),
('Hotel deLuxe', 205, '2019-12-20', 121, NULL),
('Hotel deLuxe', 205, '2019-12-21', 267, NULL),
('Hotel deLuxe', 205, '2019-12-22', 355, NULL),
('Hotel deLuxe', 205, '2019-12-23', 218, NULL),
('Hotel deLuxe', 205, '2019-12-24', 153, NULL),
('Hotel deLuxe', 205, '2019-12-25', 107, NULL),
('Hotel deLuxe', 205, '2019-12-26', 250, NULL),
('Hotel deLuxe', 205, '2019-12-27', 357, NULL),
('Hotel deLuxe', 205, '2019-12-28', 383, NULL),
('Hotel deLuxe', 205, '2019-12-29', 291, NULL),
('Hotel deLuxe', 205, '2019-12-30', 380, NULL),
('Hotel deLuxe', 205, '2019-12-31', 130, NULL),
('Hotel deLuxe', 205, '2020-01-01', 226, NULL),
('Hotel deLuxe', 205, '2020-01-02', 370, NULL),
('Hotel deLuxe', 205, '2020-01-03', 376, NULL),
('Hotel deLuxe', 205, '2020-01-04', 146, NULL),
('Hotel deLuxe', 205, '2020-01-05', 246, NULL),
('Hotel deLuxe', 205, '2020-01-06', 160, NULL),
('Hotel deLuxe', 205, '2020-01-07', 382, NULL),
('Hotel deLuxe', 205, '2020-01-08', 247, NULL),
('Hotel deLuxe', 205, '2020-01-09', 260, NULL),
('Hotel deLuxe', 205, '2020-01-10', 131, NULL),
('Hotel deLuxe', 205, '2020-01-11', 349, NULL),
('Hotel deLuxe', 205, '2020-01-12', 260, NULL),
('Hotel deLuxe', 205, '2020-01-13', 301, NULL),
('Hotel deLuxe', 205, '2020-01-14', 301, NULL),
('Hotel deLuxe', 205, '2020-01-15', 291, NULL),
('Hotel deLuxe', 205, '2020-01-16', 172, NULL),
('Hotel deLuxe', 205, '2020-01-17', 322, NULL),
('Hotel deLuxe', 205, '2020-01-18', 163, NULL),
('Hotel deLuxe', 205, '2020-01-19', 296, NULL),
('Hotel deLuxe', 205, '2020-01-20', 145, NULL),
('Hotel deLuxe', 205, '2020-01-21', 339, NULL),
('Hotel deLuxe', 205, '2020-01-22', 271, NULL),
('Hotel deLuxe', 205, '2020-01-23', 107, NULL),
('Hotel deLuxe', 205, '2020-01-24', 349, NULL),
('Hotel deLuxe', 205, '2020-01-25', 315, NULL),
('Hotel deLuxe', 205, '2020-01-26', 155, NULL),
('Hotel deLuxe', 205, '2020-01-27', 182, NULL),
('Hotel deLuxe', 205, '2020-01-28', 152, NULL),
('Hotel deLuxe', 205, '2020-01-29', 354, NULL),
('Hotel deLuxe', 205, '2020-01-30', 287, NULL),
('Hotel deLuxe', 205, '2020-01-31', 343, NULL),
('Hotel deLuxe', 205, '2020-02-01', 390, NULL),
('Hotel deLuxe', 205, '2020-02-02', 342, NULL),
('Hotel deLuxe', 205, '2020-02-03', 393, NULL),
('Hotel deLuxe', 205, '2020-02-04', 393, NULL),
('Hotel deLuxe', 209, '2019-01-01', 149, NULL),
('Hotel deLuxe', 209, '2019-01-02', 384, NULL),
('Hotel deLuxe', 209, '2019-01-03', 332, NULL),
('Hotel deLuxe', 209, '2019-01-04', 117, NULL),
('Hotel deLuxe', 209, '2019-01-05', 349, NULL),
('Hotel deLuxe', 209, '2019-01-06', 341, NULL),
('Hotel deLuxe', 209, '2019-01-07', 234, NULL),
('Hotel deLuxe', 209, '2019-01-08', 214, NULL),
('Hotel deLuxe', 209, '2019-01-09', 192, NULL),
('Hotel deLuxe', 209, '2019-01-10', 310, NULL),
('Hotel deLuxe', 209, '2019-01-11', 131, NULL),
('Hotel deLuxe', 209, '2019-01-12', 147, NULL),
('Hotel deLuxe', 209, '2019-01-13', 380, NULL),
('Hotel deLuxe', 209, '2019-01-14', 304, NULL),
('Hotel deLuxe', 209, '2019-01-15', 133, NULL),
('Hotel deLuxe', 209, '2019-01-16', 346, NULL),
('Hotel deLuxe', 209, '2019-01-17', 265, NULL),
('Hotel deLuxe', 209, '2019-01-18', 386, NULL),
('Hotel deLuxe', 209, '2019-01-19', 102, NULL),
('Hotel deLuxe', 209, '2019-01-20', 335, NULL),
('Hotel deLuxe', 209, '2019-01-21', 320, NULL),
('Hotel deLuxe', 209, '2019-01-22', 205, NULL),
('Hotel deLuxe', 209, '2019-01-23', 119, NULL),
('Hotel deLuxe', 209, '2019-01-24', 353, NULL),
('Hotel deLuxe', 209, '2019-01-25', 135, NULL),
('Hotel deLuxe', 209, '2019-01-26', 120, NULL),
('Hotel deLuxe', 209, '2019-01-27', 141, NULL),
('Hotel deLuxe', 209, '2019-01-28', 147, NULL),
('Hotel deLuxe', 209, '2019-01-29', 296, NULL),
('Hotel deLuxe', 209, '2019-01-30', 155, NULL),
('Hotel deLuxe', 209, '2019-01-31', 381, NULL),
('Hotel deLuxe', 209, '2019-02-01', 102, NULL),
('Hotel deLuxe', 209, '2019-02-02', 243, NULL),
('Hotel deLuxe', 209, '2019-02-03', 179, NULL),
('Hotel deLuxe', 209, '2019-02-04', 306, NULL),
('Hotel deLuxe', 209, '2019-02-05', 387, NULL),
('Hotel deLuxe', 209, '2019-02-06', 165, NULL),
('Hotel deLuxe', 209, '2019-02-07', 229, NULL),
('Hotel deLuxe', 209, '2019-02-08', 376, NULL),
('Hotel deLuxe', 209, '2019-02-09', 121, NULL),
('Hotel deLuxe', 209, '2019-02-10', 306, NULL),
('Hotel deLuxe', 209, '2019-02-11', 160, NULL),
('Hotel deLuxe', 209, '2019-02-12', 352, NULL),
('Hotel deLuxe', 209, '2019-02-13', 133, NULL),
('Hotel deLuxe', 209, '2019-02-14', 159, NULL),
('Hotel deLuxe', 209, '2019-02-15', 179, NULL),
('Hotel deLuxe', 209, '2019-02-16', 201, NULL),
('Hotel deLuxe', 209, '2019-02-17', 394, NULL),
('Hotel deLuxe', 209, '2019-02-18', 122, NULL),
('Hotel deLuxe', 209, '2019-02-19', 331, NULL),
('Hotel deLuxe', 209, '2019-02-20', 231, NULL),
('Hotel deLuxe', 209, '2019-02-21', 103, NULL),
('Hotel deLuxe', 209, '2019-02-22', 322, NULL),
('Hotel deLuxe', 209, '2019-02-23', 133, NULL),
('Hotel deLuxe', 209, '2019-02-24', 376, NULL),
('Hotel deLuxe', 209, '2019-02-25', 288, NULL),
('Hotel deLuxe', 209, '2019-02-26', 228, NULL),
('Hotel deLuxe', 209, '2019-02-27', 168, NULL),
('Hotel deLuxe', 209, '2019-02-28', 190, NULL),
('Hotel deLuxe', 209, '2019-03-01', 389, NULL),
('Hotel deLuxe', 209, '2019-03-02', 259, NULL),
('Hotel deLuxe', 209, '2019-03-03', 224, NULL),
('Hotel deLuxe', 209, '2019-03-04', 184, NULL),
('Hotel deLuxe', 209, '2019-03-05', 160, NULL),
('Hotel deLuxe', 209, '2019-03-06', 110, NULL),
('Hotel deLuxe', 209, '2019-03-07', 182, NULL),
('Hotel deLuxe', 209, '2019-03-08', 327, NULL),
('Hotel deLuxe', 209, '2019-03-09', 202, NULL),
('Hotel deLuxe', 209, '2019-03-10', 225, NULL),
('Hotel deLuxe', 209, '2019-03-11', 187, NULL),
('Hotel deLuxe', 209, '2019-03-12', 201, NULL),
('Hotel deLuxe', 209, '2019-03-13', 334, NULL),
('Hotel deLuxe', 209, '2019-03-14', 357, NULL),
('Hotel deLuxe', 209, '2019-03-15', 348, NULL),
('Hotel deLuxe', 209, '2019-03-16', 330, NULL),
('Hotel deLuxe', 209, '2019-03-17', 177, NULL),
('Hotel deLuxe', 209, '2019-03-18', 332, NULL),
('Hotel deLuxe', 209, '2019-03-19', 359, NULL),
('Hotel deLuxe', 209, '2019-03-20', 239, NULL),
('Hotel deLuxe', 209, '2019-03-21', 242, NULL),
('Hotel deLuxe', 209, '2019-03-22', 233, NULL),
('Hotel deLuxe', 209, '2019-03-23', 338, NULL),
('Hotel deLuxe', 209, '2019-03-24', 155, NULL),
('Hotel deLuxe', 209, '2019-03-25', 217, NULL),
('Hotel deLuxe', 209, '2019-03-26', 336, NULL),
('Hotel deLuxe', 209, '2019-03-27', 155, NULL),
('Hotel deLuxe', 209, '2019-03-28', 162, NULL),
('Hotel deLuxe', 209, '2019-03-29', 261, NULL),
('Hotel deLuxe', 209, '2019-03-30', 147, NULL),
('Hotel deLuxe', 209, '2019-03-31', 156, NULL),
('Hotel deLuxe', 209, '2019-04-01', 336, NULL),
('Hotel deLuxe', 209, '2019-04-02', 381, NULL),
('Hotel deLuxe', 209, '2019-04-03', 297, NULL),
('Hotel deLuxe', 209, '2019-04-04', 275, NULL),
('Hotel deLuxe', 209, '2019-04-05', 391, NULL),
('Hotel deLuxe', 209, '2019-04-06', 160, NULL),
('Hotel deLuxe', 209, '2019-04-07', 304, NULL),
('Hotel deLuxe', 209, '2019-04-08', 142, NULL),
('Hotel deLuxe', 209, '2019-04-09', 141, NULL),
('Hotel deLuxe', 209, '2019-04-10', 335, NULL),
('Hotel deLuxe', 209, '2019-04-11', 338, NULL),
('Hotel deLuxe', 209, '2019-04-12', 284, NULL),
('Hotel deLuxe', 209, '2019-04-13', 388, NULL),
('Hotel deLuxe', 209, '2019-04-14', 148, NULL),
('Hotel deLuxe', 209, '2019-04-15', 267, NULL),
('Hotel deLuxe', 209, '2019-04-16', 244, NULL),
('Hotel deLuxe', 209, '2019-04-17', 373, NULL),
('Hotel deLuxe', 209, '2019-04-18', 380, NULL),
('Hotel deLuxe', 209, '2019-04-19', 192, NULL),
('Hotel deLuxe', 209, '2019-04-20', 149, NULL),
('Hotel deLuxe', 209, '2019-04-21', 168, NULL),
('Hotel deLuxe', 209, '2019-04-22', 292, NULL),
('Hotel deLuxe', 209, '2019-04-23', 346, NULL),
('Hotel deLuxe', 209, '2019-04-24', 149, NULL),
('Hotel deLuxe', 209, '2019-04-25', 314, NULL),
('Hotel deLuxe', 209, '2019-04-26', 112, NULL),
('Hotel deLuxe', 209, '2019-04-27', 273, NULL),
('Hotel deLuxe', 209, '2019-04-28', 317, NULL),
('Hotel deLuxe', 209, '2019-04-29', 131, NULL),
('Hotel deLuxe', 209, '2019-04-30', 285, NULL),
('Hotel deLuxe', 209, '2019-05-01', 139, NULL),
('Hotel deLuxe', 209, '2019-05-02', 287, NULL),
('Hotel deLuxe', 209, '2019-05-03', 349, NULL),
('Hotel deLuxe', 209, '2019-05-04', 294, NULL),
('Hotel deLuxe', 209, '2019-05-05', 396, NULL),
('Hotel deLuxe', 209, '2019-05-06', 311, NULL),
('Hotel deLuxe', 209, '2019-05-07', 266, NULL),
('Hotel deLuxe', 209, '2019-05-08', 121, NULL),
('Hotel deLuxe', 209, '2019-05-09', 231, NULL),
('Hotel deLuxe', 209, '2019-05-10', 203, NULL),
('Hotel deLuxe', 209, '2019-05-11', 243, NULL),
('Hotel deLuxe', 209, '2019-05-12', 277, NULL),
('Hotel deLuxe', 209, '2019-05-13', 279, NULL),
('Hotel deLuxe', 209, '2019-05-14', 281, NULL),
('Hotel deLuxe', 209, '2019-05-15', 354, NULL),
('Hotel deLuxe', 209, '2019-05-16', 201, NULL),
('Hotel deLuxe', 209, '2019-05-17', 201, NULL),
('Hotel deLuxe', 209, '2019-05-18', 218, NULL),
('Hotel deLuxe', 209, '2019-05-19', 106, NULL),
('Hotel deLuxe', 209, '2019-05-20', 102, NULL),
('Hotel deLuxe', 209, '2019-05-21', 203, NULL),
('Hotel deLuxe', 209, '2019-05-22', 175, NULL),
('Hotel deLuxe', 209, '2019-05-23', 360, NULL),
('Hotel deLuxe', 209, '2019-05-24', 206, NULL),
('Hotel deLuxe', 209, '2019-05-25', 379, NULL),
('Hotel deLuxe', 209, '2019-05-26', 236, NULL),
('Hotel deLuxe', 209, '2019-05-27', 237, NULL),
('Hotel deLuxe', 209, '2019-05-28', 304, NULL),
('Hotel deLuxe', 209, '2019-05-29', 101, NULL),
('Hotel deLuxe', 209, '2019-05-30', 178, NULL),
('Hotel deLuxe', 209, '2019-05-31', 168, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 209, '2019-06-01', 161, NULL),
('Hotel deLuxe', 209, '2019-06-02', 312, NULL),
('Hotel deLuxe', 209, '2019-06-03', 362, NULL),
('Hotel deLuxe', 209, '2019-06-04', 109, NULL),
('Hotel deLuxe', 209, '2019-06-05', 355, NULL),
('Hotel deLuxe', 209, '2019-06-06', 390, NULL),
('Hotel deLuxe', 209, '2019-06-07', 278, NULL),
('Hotel deLuxe', 209, '2019-06-08', 271, NULL),
('Hotel deLuxe', 209, '2019-06-09', 349, NULL),
('Hotel deLuxe', 209, '2019-06-10', 380, NULL),
('Hotel deLuxe', 209, '2019-06-11', 122, NULL),
('Hotel deLuxe', 209, '2019-06-12', 279, NULL),
('Hotel deLuxe', 209, '2019-06-13', 226, NULL),
('Hotel deLuxe', 209, '2019-06-14', 273, NULL),
('Hotel deLuxe', 209, '2019-06-15', 120, NULL),
('Hotel deLuxe', 209, '2019-06-16', 332, NULL),
('Hotel deLuxe', 209, '2019-06-17', 337, NULL),
('Hotel deLuxe', 209, '2019-06-18', 333, NULL),
('Hotel deLuxe', 209, '2019-06-19', 302, NULL),
('Hotel deLuxe', 209, '2019-06-20', 269, NULL),
('Hotel deLuxe', 209, '2019-06-21', 217, NULL),
('Hotel deLuxe', 209, '2019-06-22', 278, NULL),
('Hotel deLuxe', 209, '2019-06-23', 223, NULL),
('Hotel deLuxe', 209, '2019-06-24', 328, NULL),
('Hotel deLuxe', 209, '2019-06-25', 267, NULL),
('Hotel deLuxe', 209, '2019-06-26', 220, NULL),
('Hotel deLuxe', 209, '2019-06-27', 214, NULL),
('Hotel deLuxe', 209, '2019-06-28', 204, NULL),
('Hotel deLuxe', 209, '2019-06-29', 236, NULL),
('Hotel deLuxe', 209, '2019-06-30', 253, NULL),
('Hotel deLuxe', 209, '2019-07-01', 263, NULL),
('Hotel deLuxe', 209, '2019-07-02', 111, NULL),
('Hotel deLuxe', 209, '2019-07-03', 244, NULL),
('Hotel deLuxe', 209, '2019-07-04', 320, NULL),
('Hotel deLuxe', 209, '2019-07-05', 113, NULL),
('Hotel deLuxe', 209, '2019-07-06', 329, NULL),
('Hotel deLuxe', 209, '2019-07-07', 190, NULL),
('Hotel deLuxe', 209, '2019-07-08', 148, NULL),
('Hotel deLuxe', 209, '2019-07-09', 257, NULL),
('Hotel deLuxe', 209, '2019-07-10', 160, NULL),
('Hotel deLuxe', 209, '2019-07-11', 148, NULL),
('Hotel deLuxe', 209, '2019-07-12', 118, NULL),
('Hotel deLuxe', 209, '2019-07-13', 104, NULL),
('Hotel deLuxe', 209, '2019-07-14', 345, NULL),
('Hotel deLuxe', 209, '2019-07-15', 219, NULL),
('Hotel deLuxe', 209, '2019-07-16', 199, NULL),
('Hotel deLuxe', 209, '2019-07-17', 244, NULL),
('Hotel deLuxe', 209, '2019-07-18', 317, NULL),
('Hotel deLuxe', 209, '2019-07-19', 196, NULL),
('Hotel deLuxe', 209, '2019-07-20', 160, NULL),
('Hotel deLuxe', 209, '2019-07-21', 150, NULL),
('Hotel deLuxe', 209, '2019-07-22', 327, NULL),
('Hotel deLuxe', 209, '2019-07-23', 249, NULL),
('Hotel deLuxe', 209, '2019-07-24', 125, NULL),
('Hotel deLuxe', 209, '2019-07-25', 175, NULL),
('Hotel deLuxe', 209, '2019-07-26', 158, NULL),
('Hotel deLuxe', 209, '2019-07-27', 301, NULL),
('Hotel deLuxe', 209, '2019-07-28', 286, NULL),
('Hotel deLuxe', 209, '2019-07-29', 391, NULL),
('Hotel deLuxe', 209, '2019-07-30', 352, NULL),
('Hotel deLuxe', 209, '2019-07-31', 155, NULL),
('Hotel deLuxe', 209, '2019-08-01', 294, NULL),
('Hotel deLuxe', 209, '2019-08-02', 306, NULL),
('Hotel deLuxe', 209, '2019-08-03', 274, NULL),
('Hotel deLuxe', 209, '2019-08-04', 134, NULL),
('Hotel deLuxe', 209, '2019-08-05', 187, NULL),
('Hotel deLuxe', 209, '2019-08-06', 310, NULL),
('Hotel deLuxe', 209, '2019-08-07', 372, NULL),
('Hotel deLuxe', 209, '2019-08-08', 218, NULL),
('Hotel deLuxe', 209, '2019-08-09', 391, NULL),
('Hotel deLuxe', 209, '2019-08-10', 175, NULL),
('Hotel deLuxe', 209, '2019-08-11', 365, NULL),
('Hotel deLuxe', 209, '2019-08-12', 175, NULL),
('Hotel deLuxe', 209, '2019-08-13', 303, NULL),
('Hotel deLuxe', 209, '2019-08-14', 189, NULL),
('Hotel deLuxe', 209, '2019-08-15', 272, NULL),
('Hotel deLuxe', 209, '2019-08-16', 239, NULL),
('Hotel deLuxe', 209, '2019-08-17', 148, NULL),
('Hotel deLuxe', 209, '2019-08-18', 275, NULL),
('Hotel deLuxe', 209, '2019-08-19', 186, NULL),
('Hotel deLuxe', 209, '2019-08-20', 188, NULL),
('Hotel deLuxe', 209, '2019-08-21', 367, NULL),
('Hotel deLuxe', 209, '2019-08-22', 191, NULL),
('Hotel deLuxe', 209, '2019-08-23', 206, NULL),
('Hotel deLuxe', 209, '2019-08-24', 177, NULL),
('Hotel deLuxe', 209, '2019-08-25', 321, NULL),
('Hotel deLuxe', 209, '2019-08-26', 284, NULL),
('Hotel deLuxe', 209, '2019-08-27', 399, NULL),
('Hotel deLuxe', 209, '2019-08-28', 203, NULL),
('Hotel deLuxe', 209, '2019-08-29', 232, NULL),
('Hotel deLuxe', 209, '2019-08-30', 261, NULL),
('Hotel deLuxe', 209, '2019-08-31', 279, NULL),
('Hotel deLuxe', 209, '2019-09-01', 265, NULL),
('Hotel deLuxe', 209, '2019-09-02', 273, NULL),
('Hotel deLuxe', 209, '2019-09-03', 246, NULL),
('Hotel deLuxe', 209, '2019-09-04', 381, NULL),
('Hotel deLuxe', 209, '2019-09-05', 315, NULL),
('Hotel deLuxe', 209, '2019-09-06', 229, NULL),
('Hotel deLuxe', 209, '2019-09-07', 233, NULL),
('Hotel deLuxe', 209, '2019-09-08', 176, NULL),
('Hotel deLuxe', 209, '2019-09-09', 137, NULL),
('Hotel deLuxe', 209, '2019-09-10', 150, NULL),
('Hotel deLuxe', 209, '2019-09-11', 140, NULL),
('Hotel deLuxe', 209, '2019-09-12', 283, NULL),
('Hotel deLuxe', 209, '2019-09-13', 193, NULL),
('Hotel deLuxe', 209, '2019-09-14', 316, NULL),
('Hotel deLuxe', 209, '2019-09-15', 206, NULL),
('Hotel deLuxe', 209, '2019-09-16', 113, NULL),
('Hotel deLuxe', 209, '2019-09-17', 111, NULL),
('Hotel deLuxe', 209, '2019-09-18', 243, NULL),
('Hotel deLuxe', 209, '2019-09-19', 357, NULL),
('Hotel deLuxe', 209, '2019-09-20', 387, NULL),
('Hotel deLuxe', 209, '2019-09-21', 184, NULL),
('Hotel deLuxe', 209, '2019-09-22', 207, NULL),
('Hotel deLuxe', 209, '2019-09-23', 114, NULL),
('Hotel deLuxe', 209, '2019-09-24', 249, NULL),
('Hotel deLuxe', 209, '2019-09-25', 144, NULL),
('Hotel deLuxe', 209, '2019-09-26', 176, NULL),
('Hotel deLuxe', 209, '2019-09-27', 337, NULL),
('Hotel deLuxe', 209, '2019-09-28', 394, NULL),
('Hotel deLuxe', 209, '2019-09-29', 320, NULL),
('Hotel deLuxe', 209, '2019-09-30', 350, NULL),
('Hotel deLuxe', 209, '2019-10-01', 272, NULL),
('Hotel deLuxe', 209, '2019-10-02', 173, NULL),
('Hotel deLuxe', 209, '2019-10-03', 345, NULL),
('Hotel deLuxe', 209, '2019-10-04', 180, NULL),
('Hotel deLuxe', 209, '2019-10-05', 350, NULL),
('Hotel deLuxe', 209, '2019-10-06', 386, NULL),
('Hotel deLuxe', 209, '2019-10-07', 143, NULL),
('Hotel deLuxe', 209, '2019-10-08', 312, NULL),
('Hotel deLuxe', 209, '2019-10-09', 164, NULL),
('Hotel deLuxe', 209, '2019-10-10', 129, NULL),
('Hotel deLuxe', 209, '2019-10-11', 192, NULL),
('Hotel deLuxe', 209, '2019-10-12', 300, NULL),
('Hotel deLuxe', 209, '2019-10-13', 269, NULL),
('Hotel deLuxe', 209, '2019-10-14', 231, NULL),
('Hotel deLuxe', 209, '2019-10-15', 382, NULL),
('Hotel deLuxe', 209, '2019-10-16', 306, NULL),
('Hotel deLuxe', 209, '2019-10-17', 103, NULL),
('Hotel deLuxe', 209, '2019-10-18', 336, NULL),
('Hotel deLuxe', 209, '2019-10-19', 277, NULL),
('Hotel deLuxe', 209, '2019-10-20', 329, NULL),
('Hotel deLuxe', 209, '2019-10-21', 340, NULL),
('Hotel deLuxe', 209, '2019-10-22', 389, NULL),
('Hotel deLuxe', 209, '2019-10-23', 330, NULL),
('Hotel deLuxe', 209, '2019-10-24', 153, NULL),
('Hotel deLuxe', 209, '2019-10-25', 275, NULL),
('Hotel deLuxe', 209, '2019-10-26', 346, NULL),
('Hotel deLuxe', 209, '2019-10-27', 335, NULL),
('Hotel deLuxe', 209, '2019-10-28', 352, NULL),
('Hotel deLuxe', 209, '2019-10-29', 389, NULL),
('Hotel deLuxe', 209, '2019-10-30', 336, NULL),
('Hotel deLuxe', 209, '2019-10-31', 147, NULL),
('Hotel deLuxe', 209, '2019-11-01', 174, NULL),
('Hotel deLuxe', 209, '2019-11-02', 377, NULL),
('Hotel deLuxe', 209, '2019-11-03', 182, NULL),
('Hotel deLuxe', 209, '2019-11-04', 379, NULL),
('Hotel deLuxe', 209, '2019-11-05', 320, NULL),
('Hotel deLuxe', 209, '2019-11-06', 174, NULL),
('Hotel deLuxe', 209, '2019-11-07', 335, NULL),
('Hotel deLuxe', 209, '2019-11-08', 137, NULL),
('Hotel deLuxe', 209, '2019-11-09', 127, NULL),
('Hotel deLuxe', 209, '2019-11-10', 257, NULL),
('Hotel deLuxe', 209, '2019-11-11', 300, NULL),
('Hotel deLuxe', 209, '2019-11-12', 299, NULL),
('Hotel deLuxe', 209, '2019-11-13', 212, NULL),
('Hotel deLuxe', 209, '2019-11-14', 394, NULL),
('Hotel deLuxe', 209, '2019-11-15', 158, NULL),
('Hotel deLuxe', 209, '2019-11-16', 304, NULL),
('Hotel deLuxe', 209, '2019-11-17', 300, NULL),
('Hotel deLuxe', 209, '2019-11-18', 118, NULL),
('Hotel deLuxe', 209, '2019-11-19', 397, NULL),
('Hotel deLuxe', 209, '2019-11-20', 180, NULL),
('Hotel deLuxe', 209, '2019-11-21', 191, NULL),
('Hotel deLuxe', 209, '2019-11-22', 119, NULL),
('Hotel deLuxe', 209, '2019-11-23', 338, NULL),
('Hotel deLuxe', 209, '2019-11-24', 251, NULL),
('Hotel deLuxe', 209, '2019-11-25', 376, NULL),
('Hotel deLuxe', 209, '2019-11-26', 197, NULL),
('Hotel deLuxe', 209, '2019-11-27', 167, NULL),
('Hotel deLuxe', 209, '2019-11-28', 135, NULL),
('Hotel deLuxe', 209, '2019-11-29', 320, NULL),
('Hotel deLuxe', 209, '2019-11-30', 244, NULL),
('Hotel deLuxe', 209, '2019-12-01', 208, NULL),
('Hotel deLuxe', 209, '2019-12-02', 355, NULL),
('Hotel deLuxe', 209, '2019-12-03', 375, NULL),
('Hotel deLuxe', 209, '2019-12-04', 315, NULL),
('Hotel deLuxe', 209, '2019-12-05', 311, NULL),
('Hotel deLuxe', 209, '2019-12-06', 137, NULL),
('Hotel deLuxe', 209, '2019-12-07', 158, NULL),
('Hotel deLuxe', 209, '2019-12-08', 109, NULL),
('Hotel deLuxe', 209, '2019-12-09', 171, NULL),
('Hotel deLuxe', 209, '2019-12-10', 332, NULL),
('Hotel deLuxe', 209, '2019-12-11', 102, NULL),
('Hotel deLuxe', 209, '2019-12-12', 219, NULL),
('Hotel deLuxe', 209, '2019-12-13', 191, NULL),
('Hotel deLuxe', 209, '2019-12-14', 313, NULL),
('Hotel deLuxe', 209, '2019-12-15', 222, NULL),
('Hotel deLuxe', 209, '2019-12-16', 170, NULL),
('Hotel deLuxe', 209, '2019-12-17', 245, NULL),
('Hotel deLuxe', 209, '2019-12-18', 133, NULL),
('Hotel deLuxe', 209, '2019-12-19', 375, NULL),
('Hotel deLuxe', 209, '2019-12-20', 121, NULL),
('Hotel deLuxe', 209, '2019-12-21', 214, NULL),
('Hotel deLuxe', 209, '2019-12-22', 189, NULL),
('Hotel deLuxe', 209, '2019-12-23', 258, NULL),
('Hotel deLuxe', 209, '2019-12-24', 156, NULL),
('Hotel deLuxe', 209, '2019-12-25', 126, NULL),
('Hotel deLuxe', 209, '2019-12-26', 104, NULL),
('Hotel deLuxe', 209, '2019-12-27', 145, NULL),
('Hotel deLuxe', 209, '2019-12-28', 316, NULL),
('Hotel deLuxe', 209, '2019-12-29', 207, NULL),
('Hotel deLuxe', 209, '2019-12-30', 218, NULL),
('Hotel deLuxe', 209, '2019-12-31', 353, NULL),
('Hotel deLuxe', 209, '2020-01-01', 253, NULL),
('Hotel deLuxe', 209, '2020-01-02', 387, NULL),
('Hotel deLuxe', 209, '2020-01-03', 351, NULL),
('Hotel deLuxe', 209, '2020-01-04', 116, NULL),
('Hotel deLuxe', 209, '2020-01-05', 286, NULL),
('Hotel deLuxe', 209, '2020-01-06', 193, NULL),
('Hotel deLuxe', 209, '2020-01-07', 205, NULL),
('Hotel deLuxe', 209, '2020-01-08', 334, NULL),
('Hotel deLuxe', 209, '2020-01-09', 110, NULL),
('Hotel deLuxe', 209, '2020-01-10', 146, NULL),
('Hotel deLuxe', 209, '2020-01-11', 125, NULL),
('Hotel deLuxe', 209, '2020-01-12', 206, NULL),
('Hotel deLuxe', 209, '2020-01-13', 288, NULL),
('Hotel deLuxe', 209, '2020-01-14', 348, NULL),
('Hotel deLuxe', 209, '2020-01-15', 239, NULL),
('Hotel deLuxe', 209, '2020-01-16', 138, NULL),
('Hotel deLuxe', 209, '2020-01-17', 156, NULL),
('Hotel deLuxe', 209, '2020-01-18', 114, NULL),
('Hotel deLuxe', 209, '2020-01-19', 237, NULL),
('Hotel deLuxe', 209, '2020-01-20', 297, NULL),
('Hotel deLuxe', 209, '2020-01-21', 238, NULL),
('Hotel deLuxe', 209, '2020-01-22', 348, NULL),
('Hotel deLuxe', 209, '2020-01-23', 139, NULL),
('Hotel deLuxe', 209, '2020-01-24', 273, NULL),
('Hotel deLuxe', 209, '2020-01-25', 121, NULL),
('Hotel deLuxe', 209, '2020-01-26', 212, NULL),
('Hotel deLuxe', 209, '2020-01-27', 307, NULL),
('Hotel deLuxe', 209, '2020-01-28', 254, NULL),
('Hotel deLuxe', 209, '2020-01-29', 144, NULL),
('Hotel deLuxe', 209, '2020-01-30', 337, NULL),
('Hotel deLuxe', 209, '2020-01-31', 110, NULL),
('Hotel deLuxe', 209, '2020-02-01', 287, NULL),
('Hotel deLuxe', 209, '2020-02-02', 333, NULL),
('Hotel deLuxe', 209, '2020-02-03', 224, NULL),
('Hotel deLuxe', 209, '2020-02-04', 268, NULL),
('Hotel deLuxe', 220, '2019-01-01', 103, NULL),
('Hotel deLuxe', 220, '2019-01-02', 368, NULL),
('Hotel deLuxe', 220, '2019-01-03', 342, NULL),
('Hotel deLuxe', 220, '2019-01-04', 103, NULL),
('Hotel deLuxe', 220, '2019-01-05', 296, NULL),
('Hotel deLuxe', 220, '2019-01-06', 331, NULL),
('Hotel deLuxe', 220, '2019-01-07', 374, NULL),
('Hotel deLuxe', 220, '2019-01-08', 199, NULL),
('Hotel deLuxe', 220, '2019-01-09', 245, NULL),
('Hotel deLuxe', 220, '2019-01-10', 351, NULL),
('Hotel deLuxe', 220, '2019-01-11', 303, NULL),
('Hotel deLuxe', 220, '2019-01-12', 103, NULL),
('Hotel deLuxe', 220, '2019-01-13', 288, NULL),
('Hotel deLuxe', 220, '2019-01-14', 162, NULL),
('Hotel deLuxe', 220, '2019-01-15', 337, NULL),
('Hotel deLuxe', 220, '2019-01-16', 200, NULL),
('Hotel deLuxe', 220, '2019-01-17', 114, NULL),
('Hotel deLuxe', 220, '2019-01-18', 371, NULL),
('Hotel deLuxe', 220, '2019-01-19', 292, NULL),
('Hotel deLuxe', 220, '2019-01-20', 375, NULL),
('Hotel deLuxe', 220, '2019-01-21', 148, NULL),
('Hotel deLuxe', 220, '2019-01-22', 187, NULL),
('Hotel deLuxe', 220, '2019-01-23', 104, NULL),
('Hotel deLuxe', 220, '2019-01-24', 206, NULL),
('Hotel deLuxe', 220, '2019-01-25', 145, NULL),
('Hotel deLuxe', 220, '2019-01-26', 304, NULL),
('Hotel deLuxe', 220, '2019-01-27', 162, NULL),
('Hotel deLuxe', 220, '2019-01-28', 259, NULL),
('Hotel deLuxe', 220, '2019-01-29', 263, NULL),
('Hotel deLuxe', 220, '2019-01-30', 304, NULL),
('Hotel deLuxe', 220, '2019-01-31', 239, NULL),
('Hotel deLuxe', 220, '2019-02-01', 170, NULL),
('Hotel deLuxe', 220, '2019-02-02', 280, NULL),
('Hotel deLuxe', 220, '2019-02-03', 390, NULL),
('Hotel deLuxe', 220, '2019-02-04', 156, NULL),
('Hotel deLuxe', 220, '2019-02-05', 371, NULL),
('Hotel deLuxe', 220, '2019-02-06', 375, NULL),
('Hotel deLuxe', 220, '2019-02-07', 235, NULL),
('Hotel deLuxe', 220, '2019-02-08', 255, NULL),
('Hotel deLuxe', 220, '2019-02-09', 191, NULL),
('Hotel deLuxe', 220, '2019-02-10', 173, NULL),
('Hotel deLuxe', 220, '2019-02-11', 263, NULL),
('Hotel deLuxe', 220, '2019-02-12', 134, NULL),
('Hotel deLuxe', 220, '2019-02-13', 398, NULL),
('Hotel deLuxe', 220, '2019-02-14', 272, NULL),
('Hotel deLuxe', 220, '2019-02-15', 356, NULL),
('Hotel deLuxe', 220, '2019-02-16', 373, NULL),
('Hotel deLuxe', 220, '2019-02-17', 255, NULL),
('Hotel deLuxe', 220, '2019-02-18', 125, NULL),
('Hotel deLuxe', 220, '2019-02-19', 215, NULL),
('Hotel deLuxe', 220, '2019-02-20', 238, NULL),
('Hotel deLuxe', 220, '2019-02-21', 178, NULL),
('Hotel deLuxe', 220, '2019-02-22', 144, NULL),
('Hotel deLuxe', 220, '2019-02-23', 266, NULL),
('Hotel deLuxe', 220, '2019-02-24', 273, NULL),
('Hotel deLuxe', 220, '2019-02-25', 283, NULL),
('Hotel deLuxe', 220, '2019-02-26', 382, NULL),
('Hotel deLuxe', 220, '2019-02-27', 212, NULL),
('Hotel deLuxe', 220, '2019-02-28', 144, NULL),
('Hotel deLuxe', 220, '2019-03-01', 116, NULL),
('Hotel deLuxe', 220, '2019-03-02', 141, NULL),
('Hotel deLuxe', 220, '2019-03-03', 367, NULL),
('Hotel deLuxe', 220, '2019-03-04', 150, NULL),
('Hotel deLuxe', 220, '2019-03-05', 172, NULL),
('Hotel deLuxe', 220, '2019-03-06', 232, NULL),
('Hotel deLuxe', 220, '2019-03-07', 118, NULL),
('Hotel deLuxe', 220, '2019-03-08', 242, NULL),
('Hotel deLuxe', 220, '2019-03-09', 310, NULL),
('Hotel deLuxe', 220, '2019-03-10', 325, NULL),
('Hotel deLuxe', 220, '2019-03-11', 381, NULL),
('Hotel deLuxe', 220, '2019-03-12', 178, NULL),
('Hotel deLuxe', 220, '2019-03-13', 152, NULL),
('Hotel deLuxe', 220, '2019-03-14', 366, NULL),
('Hotel deLuxe', 220, '2019-03-15', 188, NULL),
('Hotel deLuxe', 220, '2019-03-16', 353, NULL),
('Hotel deLuxe', 220, '2019-03-17', 134, NULL),
('Hotel deLuxe', 220, '2019-03-18', 323, NULL),
('Hotel deLuxe', 220, '2019-03-19', 135, NULL),
('Hotel deLuxe', 220, '2019-03-20', 124, NULL),
('Hotel deLuxe', 220, '2019-03-21', 199, NULL),
('Hotel deLuxe', 220, '2019-03-22', 201, NULL),
('Hotel deLuxe', 220, '2019-03-23', 240, NULL),
('Hotel deLuxe', 220, '2019-03-24', 294, NULL),
('Hotel deLuxe', 220, '2019-03-25', 295, NULL),
('Hotel deLuxe', 220, '2019-03-26', 179, NULL),
('Hotel deLuxe', 220, '2019-03-27', 311, NULL),
('Hotel deLuxe', 220, '2019-03-28', 313, NULL),
('Hotel deLuxe', 220, '2019-03-29', 290, NULL),
('Hotel deLuxe', 220, '2019-03-30', 380, NULL),
('Hotel deLuxe', 220, '2019-03-31', 303, NULL),
('Hotel deLuxe', 220, '2019-04-01', 134, NULL),
('Hotel deLuxe', 220, '2019-04-02', 256, NULL),
('Hotel deLuxe', 220, '2019-04-03', 226, NULL),
('Hotel deLuxe', 220, '2019-04-04', 210, NULL),
('Hotel deLuxe', 220, '2019-04-05', 180, NULL),
('Hotel deLuxe', 220, '2019-04-06', 205, NULL),
('Hotel deLuxe', 220, '2019-04-07', 122, NULL),
('Hotel deLuxe', 220, '2019-04-08', 102, NULL),
('Hotel deLuxe', 220, '2019-04-09', 279, NULL),
('Hotel deLuxe', 220, '2019-04-10', 107, NULL),
('Hotel deLuxe', 220, '2019-04-11', 383, NULL),
('Hotel deLuxe', 220, '2019-04-12', 255, NULL),
('Hotel deLuxe', 220, '2019-04-13', 308, NULL),
('Hotel deLuxe', 220, '2019-04-14', 213, NULL),
('Hotel deLuxe', 220, '2019-04-15', 123, NULL),
('Hotel deLuxe', 220, '2019-04-16', 315, NULL),
('Hotel deLuxe', 220, '2019-04-17', 269, NULL),
('Hotel deLuxe', 220, '2019-04-18', 187, NULL),
('Hotel deLuxe', 220, '2019-04-19', 320, NULL),
('Hotel deLuxe', 220, '2019-04-20', 121, NULL),
('Hotel deLuxe', 220, '2019-04-21', 114, NULL),
('Hotel deLuxe', 220, '2019-04-22', 253, NULL),
('Hotel deLuxe', 220, '2019-04-23', 385, NULL),
('Hotel deLuxe', 220, '2019-04-24', 394, NULL),
('Hotel deLuxe', 220, '2019-04-25', 184, NULL),
('Hotel deLuxe', 220, '2019-04-26', 161, NULL),
('Hotel deLuxe', 220, '2019-04-27', 309, NULL),
('Hotel deLuxe', 220, '2019-04-28', 136, NULL),
('Hotel deLuxe', 220, '2019-04-29', 300, NULL),
('Hotel deLuxe', 220, '2019-04-30', 112, NULL),
('Hotel deLuxe', 220, '2019-05-01', 132, NULL),
('Hotel deLuxe', 220, '2019-05-02', 397, NULL),
('Hotel deLuxe', 220, '2019-05-03', 378, NULL),
('Hotel deLuxe', 220, '2019-05-04', 395, NULL),
('Hotel deLuxe', 220, '2019-05-05', 260, NULL),
('Hotel deLuxe', 220, '2019-05-06', 353, NULL),
('Hotel deLuxe', 220, '2019-05-07', 368, NULL),
('Hotel deLuxe', 220, '2019-05-08', 327, NULL),
('Hotel deLuxe', 220, '2019-05-09', 302, NULL),
('Hotel deLuxe', 220, '2019-05-10', 217, NULL),
('Hotel deLuxe', 220, '2019-05-11', 232, NULL),
('Hotel deLuxe', 220, '2019-05-12', 264, NULL),
('Hotel deLuxe', 220, '2019-05-13', 176, NULL),
('Hotel deLuxe', 220, '2019-05-14', 292, NULL),
('Hotel deLuxe', 220, '2019-05-15', 287, NULL),
('Hotel deLuxe', 220, '2019-05-16', 265, NULL),
('Hotel deLuxe', 220, '2019-05-17', 396, NULL),
('Hotel deLuxe', 220, '2019-05-18', 240, NULL),
('Hotel deLuxe', 220, '2019-05-19', 332, NULL),
('Hotel deLuxe', 220, '2019-05-20', 346, NULL),
('Hotel deLuxe', 220, '2019-05-21', 334, NULL),
('Hotel deLuxe', 220, '2019-05-22', 125, NULL),
('Hotel deLuxe', 220, '2019-05-23', 347, NULL),
('Hotel deLuxe', 220, '2019-05-24', 328, NULL),
('Hotel deLuxe', 220, '2019-05-25', 326, NULL),
('Hotel deLuxe', 220, '2019-05-26', 162, NULL),
('Hotel deLuxe', 220, '2019-05-27', 129, NULL),
('Hotel deLuxe', 220, '2019-05-28', 202, NULL),
('Hotel deLuxe', 220, '2019-05-29', 381, NULL),
('Hotel deLuxe', 220, '2019-05-30', 287, NULL),
('Hotel deLuxe', 220, '2019-05-31', 169, NULL),
('Hotel deLuxe', 220, '2019-06-01', 169, NULL),
('Hotel deLuxe', 220, '2019-06-02', 254, NULL),
('Hotel deLuxe', 220, '2019-06-03', 354, NULL),
('Hotel deLuxe', 220, '2019-06-04', 255, NULL),
('Hotel deLuxe', 220, '2019-06-05', 332, NULL),
('Hotel deLuxe', 220, '2019-06-06', 321, NULL),
('Hotel deLuxe', 220, '2019-06-07', 132, NULL),
('Hotel deLuxe', 220, '2019-06-08', 243, NULL),
('Hotel deLuxe', 220, '2019-06-09', 164, NULL),
('Hotel deLuxe', 220, '2019-06-10', 160, NULL),
('Hotel deLuxe', 220, '2019-06-11', 121, NULL),
('Hotel deLuxe', 220, '2019-06-12', 362, NULL),
('Hotel deLuxe', 220, '2019-06-13', 129, NULL),
('Hotel deLuxe', 220, '2019-06-14', 312, NULL),
('Hotel deLuxe', 220, '2019-06-15', 152, NULL),
('Hotel deLuxe', 220, '2019-06-16', 202, NULL),
('Hotel deLuxe', 220, '2019-06-17', 319, NULL),
('Hotel deLuxe', 220, '2019-06-18', 333, NULL),
('Hotel deLuxe', 220, '2019-06-19', 226, NULL),
('Hotel deLuxe', 220, '2019-06-20', 139, NULL),
('Hotel deLuxe', 220, '2019-06-21', 267, NULL),
('Hotel deLuxe', 220, '2019-06-22', 101, NULL),
('Hotel deLuxe', 220, '2019-06-23', 179, NULL),
('Hotel deLuxe', 220, '2019-06-24', 343, NULL),
('Hotel deLuxe', 220, '2019-06-25', 224, NULL),
('Hotel deLuxe', 220, '2019-06-26', 398, NULL),
('Hotel deLuxe', 220, '2019-06-27', 318, NULL),
('Hotel deLuxe', 220, '2019-06-28', 275, NULL),
('Hotel deLuxe', 220, '2019-06-29', 354, NULL),
('Hotel deLuxe', 220, '2019-06-30', 186, NULL),
('Hotel deLuxe', 220, '2019-07-01', 217, NULL),
('Hotel deLuxe', 220, '2019-07-02', 124, NULL),
('Hotel deLuxe', 220, '2019-07-03', 349, NULL),
('Hotel deLuxe', 220, '2019-07-04', 198, NULL),
('Hotel deLuxe', 220, '2019-07-05', 277, NULL),
('Hotel deLuxe', 220, '2019-07-06', 277, NULL),
('Hotel deLuxe', 220, '2019-07-07', 385, NULL),
('Hotel deLuxe', 220, '2019-07-08', 123, NULL),
('Hotel deLuxe', 220, '2019-07-09', 335, NULL),
('Hotel deLuxe', 220, '2019-07-10', 366, NULL),
('Hotel deLuxe', 220, '2019-07-11', 176, NULL),
('Hotel deLuxe', 220, '2019-07-12', 273, NULL),
('Hotel deLuxe', 220, '2019-07-13', 368, NULL),
('Hotel deLuxe', 220, '2019-07-14', 277, NULL),
('Hotel deLuxe', 220, '2019-07-15', 204, NULL),
('Hotel deLuxe', 220, '2019-07-16', 153, NULL),
('Hotel deLuxe', 220, '2019-07-17', 175, NULL),
('Hotel deLuxe', 220, '2019-07-18', 235, NULL),
('Hotel deLuxe', 220, '2019-07-19', 268, NULL),
('Hotel deLuxe', 220, '2019-07-20', 139, NULL),
('Hotel deLuxe', 220, '2019-07-21', 233, NULL),
('Hotel deLuxe', 220, '2019-07-22', 237, NULL),
('Hotel deLuxe', 220, '2019-07-23', 226, NULL),
('Hotel deLuxe', 220, '2019-07-24', 159, NULL),
('Hotel deLuxe', 220, '2019-07-25', 235, NULL),
('Hotel deLuxe', 220, '2019-07-26', 359, NULL),
('Hotel deLuxe', 220, '2019-07-27', 137, NULL),
('Hotel deLuxe', 220, '2019-07-28', 325, NULL),
('Hotel deLuxe', 220, '2019-07-29', 148, NULL),
('Hotel deLuxe', 220, '2019-07-30', 279, NULL),
('Hotel deLuxe', 220, '2019-07-31', 292, NULL),
('Hotel deLuxe', 220, '2019-08-01', 243, NULL),
('Hotel deLuxe', 220, '2019-08-02', 204, NULL),
('Hotel deLuxe', 220, '2019-08-03', 285, NULL),
('Hotel deLuxe', 220, '2019-08-04', 371, NULL),
('Hotel deLuxe', 220, '2019-08-05', 220, NULL),
('Hotel deLuxe', 220, '2019-08-06', 182, NULL),
('Hotel deLuxe', 220, '2019-08-07', 190, NULL),
('Hotel deLuxe', 220, '2019-08-08', 317, NULL),
('Hotel deLuxe', 220, '2019-08-09', 358, NULL),
('Hotel deLuxe', 220, '2019-08-10', 235, NULL),
('Hotel deLuxe', 220, '2019-08-11', 107, NULL),
('Hotel deLuxe', 220, '2019-08-12', 156, NULL),
('Hotel deLuxe', 220, '2019-08-13', 289, NULL),
('Hotel deLuxe', 220, '2019-08-14', 153, NULL),
('Hotel deLuxe', 220, '2019-08-15', 285, NULL),
('Hotel deLuxe', 220, '2019-08-16', 399, NULL),
('Hotel deLuxe', 220, '2019-08-17', 342, NULL),
('Hotel deLuxe', 220, '2019-08-18', 322, NULL),
('Hotel deLuxe', 220, '2019-08-19', 211, NULL),
('Hotel deLuxe', 220, '2019-08-20', 126, NULL),
('Hotel deLuxe', 220, '2019-08-21', 366, NULL),
('Hotel deLuxe', 220, '2019-08-22', 101, NULL),
('Hotel deLuxe', 220, '2019-08-23', 369, NULL),
('Hotel deLuxe', 220, '2019-08-24', 231, NULL),
('Hotel deLuxe', 220, '2019-08-25', 372, NULL),
('Hotel deLuxe', 220, '2019-08-26', 349, NULL),
('Hotel deLuxe', 220, '2019-08-27', 358, NULL),
('Hotel deLuxe', 220, '2019-08-28', 243, NULL),
('Hotel deLuxe', 220, '2019-08-29', 337, NULL),
('Hotel deLuxe', 220, '2019-08-30', 221, NULL),
('Hotel deLuxe', 220, '2019-08-31', 285, NULL),
('Hotel deLuxe', 220, '2019-09-01', 224, NULL),
('Hotel deLuxe', 220, '2019-09-02', 375, NULL),
('Hotel deLuxe', 220, '2019-09-03', 151, NULL),
('Hotel deLuxe', 220, '2019-09-04', 354, NULL),
('Hotel deLuxe', 220, '2019-09-05', 231, NULL),
('Hotel deLuxe', 220, '2019-09-06', 357, NULL),
('Hotel deLuxe', 220, '2019-09-07', 103, NULL),
('Hotel deLuxe', 220, '2019-09-08', 258, NULL),
('Hotel deLuxe', 220, '2019-09-09', 113, NULL),
('Hotel deLuxe', 220, '2019-09-10', 333, NULL),
('Hotel deLuxe', 220, '2019-09-11', 157, NULL),
('Hotel deLuxe', 220, '2019-09-12', 170, NULL),
('Hotel deLuxe', 220, '2019-09-13', 364, NULL),
('Hotel deLuxe', 220, '2019-09-14', 329, NULL),
('Hotel deLuxe', 220, '2019-09-15', 101, NULL),
('Hotel deLuxe', 220, '2019-09-16', 130, NULL),
('Hotel deLuxe', 220, '2019-09-17', 105, NULL),
('Hotel deLuxe', 220, '2019-09-18', 128, NULL),
('Hotel deLuxe', 220, '2019-09-19', 238, NULL),
('Hotel deLuxe', 220, '2019-09-20', 291, NULL),
('Hotel deLuxe', 220, '2019-09-21', 291, NULL),
('Hotel deLuxe', 220, '2019-09-22', 322, NULL),
('Hotel deLuxe', 220, '2019-09-23', 120, NULL),
('Hotel deLuxe', 220, '2019-09-24', 169, NULL),
('Hotel deLuxe', 220, '2019-09-25', 234, NULL),
('Hotel deLuxe', 220, '2019-09-26', 379, NULL),
('Hotel deLuxe', 220, '2019-09-27', 116, NULL),
('Hotel deLuxe', 220, '2019-09-28', 107, NULL),
('Hotel deLuxe', 220, '2019-09-29', 121, NULL),
('Hotel deLuxe', 220, '2019-09-30', 223, NULL),
('Hotel deLuxe', 220, '2019-10-01', 107, NULL),
('Hotel deLuxe', 220, '2019-10-02', 253, NULL),
('Hotel deLuxe', 220, '2019-10-03', 247, NULL),
('Hotel deLuxe', 220, '2019-10-04', 194, NULL),
('Hotel deLuxe', 220, '2019-10-05', 356, NULL),
('Hotel deLuxe', 220, '2019-10-06', 340, NULL),
('Hotel deLuxe', 220, '2019-10-07', 217, NULL),
('Hotel deLuxe', 220, '2019-10-08', 247, NULL),
('Hotel deLuxe', 220, '2019-10-09', 119, NULL),
('Hotel deLuxe', 220, '2019-10-10', 191, NULL),
('Hotel deLuxe', 220, '2019-10-11', 128, NULL),
('Hotel deLuxe', 220, '2019-10-12', 120, NULL),
('Hotel deLuxe', 220, '2019-10-13', 326, NULL),
('Hotel deLuxe', 220, '2019-10-14', 246, NULL),
('Hotel deLuxe', 220, '2019-10-15', 355, NULL),
('Hotel deLuxe', 220, '2019-10-16', 246, NULL),
('Hotel deLuxe', 220, '2019-10-17', 261, NULL),
('Hotel deLuxe', 220, '2019-10-18', 333, NULL),
('Hotel deLuxe', 220, '2019-10-19', 102, NULL),
('Hotel deLuxe', 220, '2019-10-20', 209, NULL),
('Hotel deLuxe', 220, '2019-10-21', 132, NULL),
('Hotel deLuxe', 220, '2019-10-22', 322, NULL),
('Hotel deLuxe', 220, '2019-10-23', 286, NULL),
('Hotel deLuxe', 220, '2019-10-24', 130, NULL),
('Hotel deLuxe', 220, '2019-10-25', 276, NULL),
('Hotel deLuxe', 220, '2019-10-26', 371, NULL),
('Hotel deLuxe', 220, '2019-10-27', 143, NULL),
('Hotel deLuxe', 220, '2019-10-28', 206, NULL),
('Hotel deLuxe', 220, '2019-10-29', 177, NULL),
('Hotel deLuxe', 220, '2019-10-30', 146, NULL),
('Hotel deLuxe', 220, '2019-10-31', 118, NULL),
('Hotel deLuxe', 220, '2019-11-01', 221, NULL),
('Hotel deLuxe', 220, '2019-11-02', 278, NULL),
('Hotel deLuxe', 220, '2019-11-03', 222, NULL),
('Hotel deLuxe', 220, '2019-11-04', 364, NULL),
('Hotel deLuxe', 220, '2019-11-05', 150, NULL),
('Hotel deLuxe', 220, '2019-11-06', 395, NULL),
('Hotel deLuxe', 220, '2019-11-07', 178, NULL),
('Hotel deLuxe', 220, '2019-11-08', 292, NULL),
('Hotel deLuxe', 220, '2019-11-09', 175, NULL),
('Hotel deLuxe', 220, '2019-11-10', 189, NULL),
('Hotel deLuxe', 220, '2019-11-11', 392, NULL),
('Hotel deLuxe', 220, '2019-11-12', 193, NULL),
('Hotel deLuxe', 220, '2019-11-13', 160, NULL),
('Hotel deLuxe', 220, '2019-11-14', 252, NULL),
('Hotel deLuxe', 220, '2019-11-15', 378, NULL),
('Hotel deLuxe', 220, '2019-11-16', 163, NULL),
('Hotel deLuxe', 220, '2019-11-17', 118, NULL),
('Hotel deLuxe', 220, '2019-11-18', 265, NULL),
('Hotel deLuxe', 220, '2019-11-19', 328, NULL),
('Hotel deLuxe', 220, '2019-11-20', 150, NULL),
('Hotel deLuxe', 220, '2019-11-21', 118, NULL),
('Hotel deLuxe', 220, '2019-11-22', 179, NULL),
('Hotel deLuxe', 220, '2019-11-23', 377, NULL),
('Hotel deLuxe', 220, '2019-11-24', 294, NULL),
('Hotel deLuxe', 220, '2019-11-25', 355, NULL),
('Hotel deLuxe', 220, '2019-11-26', 248, NULL),
('Hotel deLuxe', 220, '2019-11-27', 194, NULL),
('Hotel deLuxe', 220, '2019-11-28', 286, NULL),
('Hotel deLuxe', 220, '2019-11-29', 205, NULL),
('Hotel deLuxe', 220, '2019-11-30', 226, NULL),
('Hotel deLuxe', 220, '2019-12-01', 235, NULL),
('Hotel deLuxe', 220, '2019-12-02', 101, NULL),
('Hotel deLuxe', 220, '2019-12-03', 210, NULL),
('Hotel deLuxe', 220, '2019-12-04', 364, NULL),
('Hotel deLuxe', 220, '2019-12-05', 179, NULL),
('Hotel deLuxe', 220, '2019-12-06', 190, NULL),
('Hotel deLuxe', 220, '2019-12-07', 265, NULL),
('Hotel deLuxe', 220, '2019-12-08', 197, NULL),
('Hotel deLuxe', 220, '2019-12-09', 188, NULL),
('Hotel deLuxe', 220, '2019-12-10', 332, NULL),
('Hotel deLuxe', 220, '2019-12-11', 119, NULL),
('Hotel deLuxe', 220, '2019-12-12', 397, NULL),
('Hotel deLuxe', 220, '2019-12-13', 225, NULL),
('Hotel deLuxe', 220, '2019-12-14', 369, NULL),
('Hotel deLuxe', 220, '2019-12-15', 161, NULL),
('Hotel deLuxe', 220, '2019-12-16', 315, NULL),
('Hotel deLuxe', 220, '2019-12-17', 183, NULL),
('Hotel deLuxe', 220, '2019-12-18', 167, NULL),
('Hotel deLuxe', 220, '2019-12-19', 383, NULL),
('Hotel deLuxe', 220, '2019-12-20', 144, NULL),
('Hotel deLuxe', 220, '2019-12-21', 168, NULL),
('Hotel deLuxe', 220, '2019-12-22', 383, NULL),
('Hotel deLuxe', 220, '2019-12-23', 235, NULL),
('Hotel deLuxe', 220, '2019-12-24', 224, NULL),
('Hotel deLuxe', 220, '2019-12-25', 211, NULL),
('Hotel deLuxe', 220, '2019-12-26', 270, NULL),
('Hotel deLuxe', 220, '2019-12-27', 155, NULL),
('Hotel deLuxe', 220, '2019-12-28', 334, NULL),
('Hotel deLuxe', 220, '2019-12-29', 359, NULL),
('Hotel deLuxe', 220, '2019-12-30', 153, NULL),
('Hotel deLuxe', 220, '2019-12-31', 373, NULL),
('Hotel deLuxe', 220, '2020-01-01', 189, NULL),
('Hotel deLuxe', 220, '2020-01-02', 126, NULL),
('Hotel deLuxe', 220, '2020-01-03', 226, NULL),
('Hotel deLuxe', 220, '2020-01-04', 341, NULL),
('Hotel deLuxe', 220, '2020-01-05', 293, NULL),
('Hotel deLuxe', 220, '2020-01-06', 385, NULL),
('Hotel deLuxe', 220, '2020-01-07', 381, NULL),
('Hotel deLuxe', 220, '2020-01-08', 229, NULL),
('Hotel deLuxe', 220, '2020-01-09', 268, NULL),
('Hotel deLuxe', 220, '2020-01-10', 235, NULL),
('Hotel deLuxe', 220, '2020-01-11', 382, NULL),
('Hotel deLuxe', 220, '2020-01-12', 150, NULL),
('Hotel deLuxe', 220, '2020-01-13', 138, NULL),
('Hotel deLuxe', 220, '2020-01-14', 135, NULL),
('Hotel deLuxe', 220, '2020-01-15', 223, NULL),
('Hotel deLuxe', 220, '2020-01-16', 378, NULL),
('Hotel deLuxe', 220, '2020-01-17', 314, NULL),
('Hotel deLuxe', 220, '2020-01-18', 284, NULL),
('Hotel deLuxe', 220, '2020-01-19', 201, NULL),
('Hotel deLuxe', 220, '2020-01-20', 351, NULL),
('Hotel deLuxe', 220, '2020-01-21', 370, NULL),
('Hotel deLuxe', 220, '2020-01-22', 227, NULL),
('Hotel deLuxe', 220, '2020-01-23', 276, NULL),
('Hotel deLuxe', 220, '2020-01-24', 219, NULL),
('Hotel deLuxe', 220, '2020-01-25', 164, NULL),
('Hotel deLuxe', 220, '2020-01-26', 197, NULL),
('Hotel deLuxe', 220, '2020-01-27', 288, NULL),
('Hotel deLuxe', 220, '2020-01-28', 118, NULL),
('Hotel deLuxe', 220, '2020-01-29', 158, NULL),
('Hotel deLuxe', 220, '2020-01-30', 126, NULL),
('Hotel deLuxe', 220, '2020-01-31', 321, NULL),
('Hotel deLuxe', 220, '2020-02-01', 164, NULL),
('Hotel deLuxe', 220, '2020-02-02', 238, NULL),
('Hotel deLuxe', 220, '2020-02-03', 140, NULL),
('Hotel deLuxe', 220, '2020-02-04', 362, NULL),
('Hotel deLuxe', 243, '2019-01-01', 270, NULL),
('Hotel deLuxe', 243, '2019-01-02', 288, NULL),
('Hotel deLuxe', 243, '2019-01-03', 315, NULL),
('Hotel deLuxe', 243, '2019-01-04', 363, NULL),
('Hotel deLuxe', 243, '2019-01-05', 335, NULL),
('Hotel deLuxe', 243, '2019-01-06', 231, NULL),
('Hotel deLuxe', 243, '2019-01-07', 171, NULL),
('Hotel deLuxe', 243, '2019-01-08', 251, NULL),
('Hotel deLuxe', 243, '2019-01-09', 248, NULL),
('Hotel deLuxe', 243, '2019-01-10', 124, NULL),
('Hotel deLuxe', 243, '2019-01-11', 124, NULL),
('Hotel deLuxe', 243, '2019-01-12', 274, NULL),
('Hotel deLuxe', 243, '2019-01-13', 198, NULL),
('Hotel deLuxe', 243, '2019-01-14', 100, NULL),
('Hotel deLuxe', 243, '2019-01-15', 288, NULL),
('Hotel deLuxe', 243, '2019-01-16', 165, NULL),
('Hotel deLuxe', 243, '2019-01-17', 275, NULL),
('Hotel deLuxe', 243, '2019-01-18', 294, NULL),
('Hotel deLuxe', 243, '2019-01-19', 156, NULL),
('Hotel deLuxe', 243, '2019-01-20', 172, NULL),
('Hotel deLuxe', 243, '2019-01-21', 281, NULL),
('Hotel deLuxe', 243, '2019-01-22', 220, NULL),
('Hotel deLuxe', 243, '2019-01-23', 366, NULL),
('Hotel deLuxe', 243, '2019-01-24', 172, NULL),
('Hotel deLuxe', 243, '2019-01-25', 220, NULL),
('Hotel deLuxe', 243, '2019-01-26', 162, NULL),
('Hotel deLuxe', 243, '2019-01-27', 286, NULL),
('Hotel deLuxe', 243, '2019-01-28', 154, NULL),
('Hotel deLuxe', 243, '2019-01-29', 327, NULL),
('Hotel deLuxe', 243, '2019-01-30', 357, NULL),
('Hotel deLuxe', 243, '2019-01-31', 251, NULL),
('Hotel deLuxe', 243, '2019-02-01', 144, NULL),
('Hotel deLuxe', 243, '2019-02-02', 271, NULL),
('Hotel deLuxe', 243, '2019-02-03', 115, NULL),
('Hotel deLuxe', 243, '2019-02-04', 362, NULL),
('Hotel deLuxe', 243, '2019-02-05', 294, NULL),
('Hotel deLuxe', 243, '2019-02-06', 380, NULL),
('Hotel deLuxe', 243, '2019-02-07', 392, NULL),
('Hotel deLuxe', 243, '2019-02-08', 347, NULL),
('Hotel deLuxe', 243, '2019-02-09', 193, NULL),
('Hotel deLuxe', 243, '2019-02-10', 147, NULL),
('Hotel deLuxe', 243, '2019-02-11', 134, NULL),
('Hotel deLuxe', 243, '2019-02-12', 113, NULL),
('Hotel deLuxe', 243, '2019-02-13', 291, NULL),
('Hotel deLuxe', 243, '2019-02-14', 186, NULL),
('Hotel deLuxe', 243, '2019-02-15', 242, NULL),
('Hotel deLuxe', 243, '2019-02-16', 261, NULL),
('Hotel deLuxe', 243, '2019-02-17', 294, NULL),
('Hotel deLuxe', 243, '2019-02-18', 158, NULL),
('Hotel deLuxe', 243, '2019-02-19', 283, NULL),
('Hotel deLuxe', 243, '2019-02-20', 398, NULL),
('Hotel deLuxe', 243, '2019-02-21', 179, NULL),
('Hotel deLuxe', 243, '2019-02-22', 255, NULL),
('Hotel deLuxe', 243, '2019-02-23', 233, NULL),
('Hotel deLuxe', 243, '2019-02-24', 137, NULL),
('Hotel deLuxe', 243, '2019-02-25', 154, NULL),
('Hotel deLuxe', 243, '2019-02-26', 226, NULL),
('Hotel deLuxe', 243, '2019-02-27', 156, NULL),
('Hotel deLuxe', 243, '2019-02-28', 351, NULL),
('Hotel deLuxe', 243, '2019-03-01', 216, NULL),
('Hotel deLuxe', 243, '2019-03-02', 126, NULL),
('Hotel deLuxe', 243, '2019-03-03', 161, NULL),
('Hotel deLuxe', 243, '2019-03-04', 396, NULL),
('Hotel deLuxe', 243, '2019-03-05', 280, NULL),
('Hotel deLuxe', 243, '2019-03-06', 132, NULL),
('Hotel deLuxe', 243, '2019-03-07', 244, NULL),
('Hotel deLuxe', 243, '2019-03-08', 129, NULL),
('Hotel deLuxe', 243, '2019-03-09', 243, NULL),
('Hotel deLuxe', 243, '2019-03-10', 253, NULL),
('Hotel deLuxe', 243, '2019-03-11', 346, NULL),
('Hotel deLuxe', 243, '2019-03-12', 187, NULL),
('Hotel deLuxe', 243, '2019-03-13', 260, NULL),
('Hotel deLuxe', 243, '2019-03-14', 361, NULL),
('Hotel deLuxe', 243, '2019-03-15', 397, NULL),
('Hotel deLuxe', 243, '2019-03-16', 375, NULL),
('Hotel deLuxe', 243, '2019-03-17', 338, NULL),
('Hotel deLuxe', 243, '2019-03-18', 223, NULL),
('Hotel deLuxe', 243, '2019-03-19', 398, NULL),
('Hotel deLuxe', 243, '2019-03-20', 100, NULL),
('Hotel deLuxe', 243, '2019-03-21', 169, NULL),
('Hotel deLuxe', 243, '2019-03-22', 205, NULL),
('Hotel deLuxe', 243, '2019-03-23', 385, NULL),
('Hotel deLuxe', 243, '2019-03-24', 306, NULL),
('Hotel deLuxe', 243, '2019-03-25', 124, NULL),
('Hotel deLuxe', 243, '2019-03-26', 388, NULL),
('Hotel deLuxe', 243, '2019-03-27', 389, NULL),
('Hotel deLuxe', 243, '2019-03-28', 379, NULL),
('Hotel deLuxe', 243, '2019-03-29', 269, NULL),
('Hotel deLuxe', 243, '2019-03-30', 162, NULL),
('Hotel deLuxe', 243, '2019-03-31', 350, NULL),
('Hotel deLuxe', 243, '2019-04-01', 164, NULL),
('Hotel deLuxe', 243, '2019-04-02', 340, NULL),
('Hotel deLuxe', 243, '2019-04-03', 138, NULL),
('Hotel deLuxe', 243, '2019-04-04', 128, NULL),
('Hotel deLuxe', 243, '2019-04-05', 226, NULL),
('Hotel deLuxe', 243, '2019-04-06', 145, NULL),
('Hotel deLuxe', 243, '2019-04-07', 197, NULL),
('Hotel deLuxe', 243, '2019-04-08', 282, NULL),
('Hotel deLuxe', 243, '2019-04-09', 273, NULL),
('Hotel deLuxe', 243, '2019-04-10', 328, NULL),
('Hotel deLuxe', 243, '2019-04-11', 200, NULL),
('Hotel deLuxe', 243, '2019-04-12', 324, NULL),
('Hotel deLuxe', 243, '2019-04-13', 274, NULL),
('Hotel deLuxe', 243, '2019-04-14', 220, NULL),
('Hotel deLuxe', 243, '2019-04-15', 316, NULL),
('Hotel deLuxe', 243, '2019-04-16', 142, NULL),
('Hotel deLuxe', 243, '2019-04-17', 125, NULL),
('Hotel deLuxe', 243, '2019-04-18', 297, NULL),
('Hotel deLuxe', 243, '2019-04-19', 323, NULL),
('Hotel deLuxe', 243, '2019-04-20', 360, NULL),
('Hotel deLuxe', 243, '2019-04-21', 269, NULL),
('Hotel deLuxe', 243, '2019-04-22', 291, NULL),
('Hotel deLuxe', 243, '2019-04-23', 191, NULL),
('Hotel deLuxe', 243, '2019-04-24', 225, NULL),
('Hotel deLuxe', 243, '2019-04-25', 179, NULL),
('Hotel deLuxe', 243, '2019-04-26', 367, NULL),
('Hotel deLuxe', 243, '2019-04-27', 327, NULL),
('Hotel deLuxe', 243, '2019-04-28', 233, NULL),
('Hotel deLuxe', 243, '2019-04-29', 105, NULL),
('Hotel deLuxe', 243, '2019-04-30', 207, NULL),
('Hotel deLuxe', 243, '2019-05-01', 143, NULL),
('Hotel deLuxe', 243, '2019-05-02', 124, NULL),
('Hotel deLuxe', 243, '2019-05-03', 140, NULL),
('Hotel deLuxe', 243, '2019-05-04', 392, NULL),
('Hotel deLuxe', 243, '2019-05-05', 313, NULL),
('Hotel deLuxe', 243, '2019-05-06', 133, NULL),
('Hotel deLuxe', 243, '2019-05-07', 340, NULL),
('Hotel deLuxe', 243, '2019-05-08', 276, NULL),
('Hotel deLuxe', 243, '2019-05-09', 116, NULL),
('Hotel deLuxe', 243, '2019-05-10', 375, NULL),
('Hotel deLuxe', 243, '2019-05-11', 330, NULL),
('Hotel deLuxe', 243, '2019-05-12', 390, NULL),
('Hotel deLuxe', 243, '2019-05-13', 242, NULL),
('Hotel deLuxe', 243, '2019-05-14', 219, NULL),
('Hotel deLuxe', 243, '2019-05-15', 275, NULL),
('Hotel deLuxe', 243, '2019-05-16', 322, NULL),
('Hotel deLuxe', 243, '2019-05-17', 381, NULL),
('Hotel deLuxe', 243, '2019-05-18', 145, NULL),
('Hotel deLuxe', 243, '2019-05-19', 343, NULL),
('Hotel deLuxe', 243, '2019-05-20', 126, NULL),
('Hotel deLuxe', 243, '2019-05-21', 360, NULL),
('Hotel deLuxe', 243, '2019-05-22', 300, NULL),
('Hotel deLuxe', 243, '2019-05-23', 257, NULL),
('Hotel deLuxe', 243, '2019-05-24', 323, NULL),
('Hotel deLuxe', 243, '2019-05-25', 393, NULL),
('Hotel deLuxe', 243, '2019-05-26', 303, NULL),
('Hotel deLuxe', 243, '2019-05-27', 134, NULL),
('Hotel deLuxe', 243, '2019-05-28', 298, NULL),
('Hotel deLuxe', 243, '2019-05-29', 304, NULL),
('Hotel deLuxe', 243, '2019-05-30', 201, NULL),
('Hotel deLuxe', 243, '2019-05-31', 239, NULL),
('Hotel deLuxe', 243, '2019-06-01', 263, NULL),
('Hotel deLuxe', 243, '2019-06-02', 234, NULL),
('Hotel deLuxe', 243, '2019-06-03', 286, NULL),
('Hotel deLuxe', 243, '2019-06-04', 249, NULL),
('Hotel deLuxe', 243, '2019-06-05', 199, NULL),
('Hotel deLuxe', 243, '2019-06-06', 334, NULL),
('Hotel deLuxe', 243, '2019-06-07', 326, NULL),
('Hotel deLuxe', 243, '2019-06-08', 300, NULL),
('Hotel deLuxe', 243, '2019-06-09', 273, NULL),
('Hotel deLuxe', 243, '2019-06-10', 163, NULL),
('Hotel deLuxe', 243, '2019-06-11', 138, NULL),
('Hotel deLuxe', 243, '2019-06-12', 273, NULL),
('Hotel deLuxe', 243, '2019-06-13', 169, NULL),
('Hotel deLuxe', 243, '2019-06-14', 343, NULL),
('Hotel deLuxe', 243, '2019-06-15', 301, NULL),
('Hotel deLuxe', 243, '2019-06-16', 217, NULL),
('Hotel deLuxe', 243, '2019-06-17', 182, NULL),
('Hotel deLuxe', 243, '2019-06-18', 264, NULL),
('Hotel deLuxe', 243, '2019-06-19', 128, NULL),
('Hotel deLuxe', 243, '2019-06-20', 388, NULL),
('Hotel deLuxe', 243, '2019-06-21', 286, NULL),
('Hotel deLuxe', 243, '2019-06-22', 169, NULL),
('Hotel deLuxe', 243, '2019-06-23', 126, NULL),
('Hotel deLuxe', 243, '2019-06-24', 332, NULL),
('Hotel deLuxe', 243, '2019-06-25', 217, NULL),
('Hotel deLuxe', 243, '2019-06-26', 331, NULL),
('Hotel deLuxe', 243, '2019-06-27', 246, NULL),
('Hotel deLuxe', 243, '2019-06-28', 360, NULL),
('Hotel deLuxe', 243, '2019-06-29', 366, NULL),
('Hotel deLuxe', 243, '2019-06-30', 371, NULL),
('Hotel deLuxe', 243, '2019-07-01', 195, NULL),
('Hotel deLuxe', 243, '2019-07-02', 185, NULL),
('Hotel deLuxe', 243, '2019-07-03', 311, NULL),
('Hotel deLuxe', 243, '2019-07-04', 228, NULL),
('Hotel deLuxe', 243, '2019-07-05', 345, NULL),
('Hotel deLuxe', 243, '2019-07-06', 299, NULL),
('Hotel deLuxe', 243, '2019-07-07', 354, NULL),
('Hotel deLuxe', 243, '2019-07-08', 370, NULL),
('Hotel deLuxe', 243, '2019-07-09', 203, NULL),
('Hotel deLuxe', 243, '2019-07-10', 348, NULL),
('Hotel deLuxe', 243, '2019-07-11', 338, NULL),
('Hotel deLuxe', 243, '2019-07-12', 308, NULL),
('Hotel deLuxe', 243, '2019-07-13', 227, NULL),
('Hotel deLuxe', 243, '2019-07-14', 248, NULL),
('Hotel deLuxe', 243, '2019-07-15', 266, NULL),
('Hotel deLuxe', 243, '2019-07-16', 367, NULL),
('Hotel deLuxe', 243, '2019-07-17', 343, NULL),
('Hotel deLuxe', 243, '2019-07-18', 127, NULL),
('Hotel deLuxe', 243, '2019-07-19', 351, NULL),
('Hotel deLuxe', 243, '2019-07-20', 112, NULL),
('Hotel deLuxe', 243, '2019-07-21', 316, NULL),
('Hotel deLuxe', 243, '2019-07-22', 103, NULL),
('Hotel deLuxe', 243, '2019-07-23', 286, NULL),
('Hotel deLuxe', 243, '2019-07-24', 319, NULL),
('Hotel deLuxe', 243, '2019-07-25', 251, NULL),
('Hotel deLuxe', 243, '2019-07-26', 323, NULL),
('Hotel deLuxe', 243, '2019-07-27', 282, NULL),
('Hotel deLuxe', 243, '2019-07-28', 366, NULL),
('Hotel deLuxe', 243, '2019-07-29', 365, NULL),
('Hotel deLuxe', 243, '2019-07-30', 240, NULL),
('Hotel deLuxe', 243, '2019-07-31', 293, NULL),
('Hotel deLuxe', 243, '2019-08-01', 234, NULL),
('Hotel deLuxe', 243, '2019-08-02', 303, NULL),
('Hotel deLuxe', 243, '2019-08-03', 202, NULL),
('Hotel deLuxe', 243, '2019-08-04', 157, NULL),
('Hotel deLuxe', 243, '2019-08-05', 142, NULL),
('Hotel deLuxe', 243, '2019-08-06', 180, NULL),
('Hotel deLuxe', 243, '2019-08-07', 336, NULL),
('Hotel deLuxe', 243, '2019-08-08', 235, NULL),
('Hotel deLuxe', 243, '2019-08-09', 218, NULL),
('Hotel deLuxe', 243, '2019-08-10', 249, NULL),
('Hotel deLuxe', 243, '2019-08-11', 239, NULL),
('Hotel deLuxe', 243, '2019-08-12', 158, NULL),
('Hotel deLuxe', 243, '2019-08-13', 136, NULL),
('Hotel deLuxe', 243, '2019-08-14', 398, NULL),
('Hotel deLuxe', 243, '2019-08-15', 211, NULL),
('Hotel deLuxe', 243, '2019-08-16', 276, NULL),
('Hotel deLuxe', 243, '2019-08-17', 269, NULL),
('Hotel deLuxe', 243, '2019-08-18', 387, NULL),
('Hotel deLuxe', 243, '2019-08-19', 396, NULL),
('Hotel deLuxe', 243, '2019-08-20', 263, NULL),
('Hotel deLuxe', 243, '2019-08-21', 331, NULL),
('Hotel deLuxe', 243, '2019-08-22', 133, NULL),
('Hotel deLuxe', 243, '2019-08-23', 225, NULL),
('Hotel deLuxe', 243, '2019-08-24', 226, NULL),
('Hotel deLuxe', 243, '2019-08-25', 196, NULL),
('Hotel deLuxe', 243, '2019-08-26', 194, NULL),
('Hotel deLuxe', 243, '2019-08-27', 196, NULL),
('Hotel deLuxe', 243, '2019-08-28', 207, NULL),
('Hotel deLuxe', 243, '2019-08-29', 293, NULL),
('Hotel deLuxe', 243, '2019-08-30', 224, NULL),
('Hotel deLuxe', 243, '2019-08-31', 192, NULL),
('Hotel deLuxe', 243, '2019-09-01', 224, NULL),
('Hotel deLuxe', 243, '2019-09-02', 358, NULL),
('Hotel deLuxe', 243, '2019-09-03', 219, NULL),
('Hotel deLuxe', 243, '2019-09-04', 229, NULL),
('Hotel deLuxe', 243, '2019-09-05', 111, NULL),
('Hotel deLuxe', 243, '2019-09-06', 101, NULL),
('Hotel deLuxe', 243, '2019-09-07', 316, NULL),
('Hotel deLuxe', 243, '2019-09-08', 361, NULL),
('Hotel deLuxe', 243, '2019-09-09', 353, NULL),
('Hotel deLuxe', 243, '2019-09-10', 215, NULL),
('Hotel deLuxe', 243, '2019-09-11', 264, NULL),
('Hotel deLuxe', 243, '2019-09-12', 200, NULL),
('Hotel deLuxe', 243, '2019-09-13', 240, NULL),
('Hotel deLuxe', 243, '2019-09-14', 297, NULL),
('Hotel deLuxe', 243, '2019-09-15', 389, NULL),
('Hotel deLuxe', 243, '2019-09-16', 209, NULL),
('Hotel deLuxe', 243, '2019-09-17', 395, NULL),
('Hotel deLuxe', 243, '2019-09-18', 112, NULL),
('Hotel deLuxe', 243, '2019-09-19', 317, NULL),
('Hotel deLuxe', 243, '2019-09-20', 197, NULL),
('Hotel deLuxe', 243, '2019-09-21', 202, NULL),
('Hotel deLuxe', 243, '2019-09-22', 290, NULL),
('Hotel deLuxe', 243, '2019-09-23', 156, NULL),
('Hotel deLuxe', 243, '2019-09-24', 300, NULL),
('Hotel deLuxe', 243, '2019-09-25', 338, NULL),
('Hotel deLuxe', 243, '2019-09-26', 365, NULL),
('Hotel deLuxe', 243, '2019-09-27', 370, NULL),
('Hotel deLuxe', 243, '2019-09-28', 156, NULL),
('Hotel deLuxe', 243, '2019-09-29', 147, NULL),
('Hotel deLuxe', 243, '2019-09-30', 266, NULL),
('Hotel deLuxe', 243, '2019-10-01', 222, NULL),
('Hotel deLuxe', 243, '2019-10-02', 347, NULL),
('Hotel deLuxe', 243, '2019-10-03', 101, NULL),
('Hotel deLuxe', 243, '2019-10-04', 331, NULL),
('Hotel deLuxe', 243, '2019-10-05', 330, NULL),
('Hotel deLuxe', 243, '2019-10-06', 140, NULL),
('Hotel deLuxe', 243, '2019-10-07', 259, NULL),
('Hotel deLuxe', 243, '2019-10-08', 198, NULL),
('Hotel deLuxe', 243, '2019-10-09', 303, NULL),
('Hotel deLuxe', 243, '2019-10-10', 167, NULL),
('Hotel deLuxe', 243, '2019-10-11', 263, NULL),
('Hotel deLuxe', 243, '2019-10-12', 202, NULL),
('Hotel deLuxe', 243, '2019-10-13', 126, NULL),
('Hotel deLuxe', 243, '2019-10-14', 138, NULL),
('Hotel deLuxe', 243, '2019-10-15', 230, NULL),
('Hotel deLuxe', 243, '2019-10-16', 213, NULL),
('Hotel deLuxe', 243, '2019-10-17', 294, NULL),
('Hotel deLuxe', 243, '2019-10-18', 257, NULL),
('Hotel deLuxe', 243, '2019-10-19', 178, NULL),
('Hotel deLuxe', 243, '2019-10-20', 260, NULL),
('Hotel deLuxe', 243, '2019-10-21', 140, NULL),
('Hotel deLuxe', 243, '2019-10-22', 346, NULL),
('Hotel deLuxe', 243, '2019-10-23', 339, NULL),
('Hotel deLuxe', 243, '2019-10-24', 390, NULL),
('Hotel deLuxe', 243, '2019-10-25', 158, NULL),
('Hotel deLuxe', 243, '2019-10-26', 118, NULL),
('Hotel deLuxe', 243, '2019-10-27', 213, NULL),
('Hotel deLuxe', 243, '2019-10-28', 173, NULL),
('Hotel deLuxe', 243, '2019-10-29', 219, NULL),
('Hotel deLuxe', 243, '2019-10-30', 220, NULL),
('Hotel deLuxe', 243, '2019-10-31', 349, NULL),
('Hotel deLuxe', 243, '2019-11-01', 183, NULL),
('Hotel deLuxe', 243, '2019-11-02', 161, NULL),
('Hotel deLuxe', 243, '2019-11-03', 165, NULL),
('Hotel deLuxe', 243, '2019-11-04', 280, NULL),
('Hotel deLuxe', 243, '2019-11-05', 293, NULL),
('Hotel deLuxe', 243, '2019-11-06', 156, NULL),
('Hotel deLuxe', 243, '2019-11-07', 383, NULL),
('Hotel deLuxe', 243, '2019-11-08', 349, NULL),
('Hotel deLuxe', 243, '2019-11-09', 394, NULL),
('Hotel deLuxe', 243, '2019-11-10', 375, NULL),
('Hotel deLuxe', 243, '2019-11-11', 360, NULL),
('Hotel deLuxe', 243, '2019-11-12', 266, NULL),
('Hotel deLuxe', 243, '2019-11-13', 362, NULL),
('Hotel deLuxe', 243, '2019-11-14', 280, NULL),
('Hotel deLuxe', 243, '2019-11-15', 116, NULL),
('Hotel deLuxe', 243, '2019-11-16', 104, NULL),
('Hotel deLuxe', 243, '2019-11-17', 190, NULL),
('Hotel deLuxe', 243, '2019-11-18', 273, NULL),
('Hotel deLuxe', 243, '2019-11-19', 353, NULL),
('Hotel deLuxe', 243, '2019-11-20', 108, NULL),
('Hotel deLuxe', 243, '2019-11-21', 218, NULL),
('Hotel deLuxe', 243, '2019-11-22', 138, NULL),
('Hotel deLuxe', 243, '2019-11-23', 172, NULL),
('Hotel deLuxe', 243, '2019-11-24', 316, NULL),
('Hotel deLuxe', 243, '2019-11-25', 251, NULL),
('Hotel deLuxe', 243, '2019-11-26', 247, NULL),
('Hotel deLuxe', 243, '2019-11-27', 371, NULL),
('Hotel deLuxe', 243, '2019-11-28', 328, NULL),
('Hotel deLuxe', 243, '2019-11-29', 264, NULL),
('Hotel deLuxe', 243, '2019-11-30', 298, NULL),
('Hotel deLuxe', 243, '2019-12-01', 152, NULL),
('Hotel deLuxe', 243, '2019-12-02', 241, NULL),
('Hotel deLuxe', 243, '2019-12-03', 128, NULL),
('Hotel deLuxe', 243, '2019-12-04', 175, NULL),
('Hotel deLuxe', 243, '2019-12-05', 161, NULL),
('Hotel deLuxe', 243, '2019-12-06', 143, NULL),
('Hotel deLuxe', 243, '2019-12-07', 153, NULL),
('Hotel deLuxe', 243, '2019-12-08', 256, NULL),
('Hotel deLuxe', 243, '2019-12-09', 327, NULL),
('Hotel deLuxe', 243, '2019-12-10', 262, NULL),
('Hotel deLuxe', 243, '2019-12-11', 187, NULL),
('Hotel deLuxe', 243, '2019-12-12', 328, NULL),
('Hotel deLuxe', 243, '2019-12-13', 150, NULL),
('Hotel deLuxe', 243, '2019-12-14', 208, NULL),
('Hotel deLuxe', 243, '2019-12-15', 338, NULL),
('Hotel deLuxe', 243, '2019-12-16', 366, NULL),
('Hotel deLuxe', 243, '2019-12-17', 383, NULL),
('Hotel deLuxe', 243, '2019-12-18', 337, NULL),
('Hotel deLuxe', 243, '2019-12-19', 391, NULL),
('Hotel deLuxe', 243, '2019-12-20', 258, NULL),
('Hotel deLuxe', 243, '2019-12-21', 100, NULL),
('Hotel deLuxe', 243, '2019-12-22', 345, NULL),
('Hotel deLuxe', 243, '2019-12-23', 301, NULL),
('Hotel deLuxe', 243, '2019-12-24', 249, NULL),
('Hotel deLuxe', 243, '2019-12-25', 274, NULL),
('Hotel deLuxe', 243, '2019-12-26', 338, NULL),
('Hotel deLuxe', 243, '2019-12-27', 239, NULL),
('Hotel deLuxe', 243, '2019-12-28', 322, NULL),
('Hotel deLuxe', 243, '2019-12-29', 176, NULL),
('Hotel deLuxe', 243, '2019-12-30', 309, NULL),
('Hotel deLuxe', 243, '2019-12-31', 107, NULL),
('Hotel deLuxe', 243, '2020-01-01', 385, NULL),
('Hotel deLuxe', 243, '2020-01-02', 269, NULL),
('Hotel deLuxe', 243, '2020-01-03', 278, NULL),
('Hotel deLuxe', 243, '2020-01-04', 357, NULL),
('Hotel deLuxe', 243, '2020-01-05', 206, NULL),
('Hotel deLuxe', 243, '2020-01-06', 348, NULL),
('Hotel deLuxe', 243, '2020-01-07', 290, NULL),
('Hotel deLuxe', 243, '2020-01-08', 344, NULL),
('Hotel deLuxe', 243, '2020-01-09', 311, NULL),
('Hotel deLuxe', 243, '2020-01-10', 339, NULL),
('Hotel deLuxe', 243, '2020-01-11', 232, NULL),
('Hotel deLuxe', 243, '2020-01-12', 334, NULL),
('Hotel deLuxe', 243, '2020-01-13', 327, NULL),
('Hotel deLuxe', 243, '2020-01-14', 133, NULL),
('Hotel deLuxe', 243, '2020-01-15', 297, NULL),
('Hotel deLuxe', 243, '2020-01-16', 174, NULL),
('Hotel deLuxe', 243, '2020-01-17', 104, NULL),
('Hotel deLuxe', 243, '2020-01-18', 378, NULL),
('Hotel deLuxe', 243, '2020-01-19', 191, NULL),
('Hotel deLuxe', 243, '2020-01-20', 162, NULL),
('Hotel deLuxe', 243, '2020-01-21', 139, NULL),
('Hotel deLuxe', 243, '2020-01-22', 292, NULL),
('Hotel deLuxe', 243, '2020-01-23', 263, NULL),
('Hotel deLuxe', 243, '2020-01-24', 178, NULL),
('Hotel deLuxe', 243, '2020-01-25', 355, NULL),
('Hotel deLuxe', 243, '2020-01-26', 249, NULL),
('Hotel deLuxe', 243, '2020-01-27', 122, NULL),
('Hotel deLuxe', 243, '2020-01-28', 328, NULL),
('Hotel deLuxe', 243, '2020-01-29', 256, NULL),
('Hotel deLuxe', 243, '2020-01-30', 120, NULL),
('Hotel deLuxe', 243, '2020-01-31', 274, NULL),
('Hotel deLuxe', 243, '2020-02-01', 160, NULL),
('Hotel deLuxe', 243, '2020-02-02', 390, NULL),
('Hotel deLuxe', 243, '2020-02-03', 230, NULL),
('Hotel deLuxe', 243, '2020-02-04', 305, NULL),
('Hotel deLuxe', 251, '2019-01-01', 343, NULL),
('Hotel deLuxe', 251, '2019-01-02', 236, NULL),
('Hotel deLuxe', 251, '2019-01-03', 150, NULL),
('Hotel deLuxe', 251, '2019-01-04', 210, NULL),
('Hotel deLuxe', 251, '2019-01-05', 388, NULL),
('Hotel deLuxe', 251, '2019-01-06', 364, NULL),
('Hotel deLuxe', 251, '2019-01-07', 233, NULL),
('Hotel deLuxe', 251, '2019-01-08', 262, NULL),
('Hotel deLuxe', 251, '2019-01-09', 105, NULL),
('Hotel deLuxe', 251, '2019-01-10', 370, NULL),
('Hotel deLuxe', 251, '2019-01-11', 213, NULL),
('Hotel deLuxe', 251, '2019-01-12', 363, NULL),
('Hotel deLuxe', 251, '2019-01-13', 329, NULL),
('Hotel deLuxe', 251, '2019-01-14', 215, NULL),
('Hotel deLuxe', 251, '2019-01-15', 329, NULL),
('Hotel deLuxe', 251, '2019-01-16', 124, NULL),
('Hotel deLuxe', 251, '2019-01-17', 334, NULL),
('Hotel deLuxe', 251, '2019-01-18', 260, NULL),
('Hotel deLuxe', 251, '2019-01-19', 102, NULL),
('Hotel deLuxe', 251, '2019-01-20', 233, NULL),
('Hotel deLuxe', 251, '2019-01-21', 264, NULL),
('Hotel deLuxe', 251, '2019-01-22', 141, NULL),
('Hotel deLuxe', 251, '2019-01-23', 219, NULL),
('Hotel deLuxe', 251, '2019-01-24', 143, NULL),
('Hotel deLuxe', 251, '2019-01-25', 265, NULL),
('Hotel deLuxe', 251, '2019-01-26', 100, NULL),
('Hotel deLuxe', 251, '2019-01-27', 247, NULL),
('Hotel deLuxe', 251, '2019-01-28', 194, NULL),
('Hotel deLuxe', 251, '2019-01-29', 149, NULL),
('Hotel deLuxe', 251, '2019-01-30', 175, NULL),
('Hotel deLuxe', 251, '2019-01-31', 139, NULL),
('Hotel deLuxe', 251, '2019-02-01', 111, NULL),
('Hotel deLuxe', 251, '2019-02-02', 114, NULL),
('Hotel deLuxe', 251, '2019-02-03', 203, NULL),
('Hotel deLuxe', 251, '2019-02-04', 340, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 251, '2019-02-05', 260, NULL),
('Hotel deLuxe', 251, '2019-02-06', 374, NULL),
('Hotel deLuxe', 251, '2019-02-07', 255, NULL),
('Hotel deLuxe', 251, '2019-02-08', 272, NULL),
('Hotel deLuxe', 251, '2019-02-09', 293, NULL),
('Hotel deLuxe', 251, '2019-02-10', 119, NULL),
('Hotel deLuxe', 251, '2019-02-11', 384, NULL),
('Hotel deLuxe', 251, '2019-02-12', 363, NULL),
('Hotel deLuxe', 251, '2019-02-13', 162, NULL),
('Hotel deLuxe', 251, '2019-02-14', 312, NULL),
('Hotel deLuxe', 251, '2019-02-15', 346, NULL),
('Hotel deLuxe', 251, '2019-02-16', 388, NULL),
('Hotel deLuxe', 251, '2019-02-17', 305, NULL),
('Hotel deLuxe', 251, '2019-02-18', 316, NULL),
('Hotel deLuxe', 251, '2019-02-19', 371, NULL),
('Hotel deLuxe', 251, '2019-02-20', 275, NULL),
('Hotel deLuxe', 251, '2019-02-21', 264, NULL),
('Hotel deLuxe', 251, '2019-02-22', 143, NULL),
('Hotel deLuxe', 251, '2019-02-23', 266, NULL),
('Hotel deLuxe', 251, '2019-02-24', 365, NULL),
('Hotel deLuxe', 251, '2019-02-25', 120, NULL),
('Hotel deLuxe', 251, '2019-02-26', 185, NULL),
('Hotel deLuxe', 251, '2019-02-27', 347, NULL),
('Hotel deLuxe', 251, '2019-02-28', 324, NULL),
('Hotel deLuxe', 251, '2019-03-01', 333, NULL),
('Hotel deLuxe', 251, '2019-03-02', 110, NULL),
('Hotel deLuxe', 251, '2019-03-03', 204, NULL),
('Hotel deLuxe', 251, '2019-03-04', 230, NULL),
('Hotel deLuxe', 251, '2019-03-05', 187, NULL),
('Hotel deLuxe', 251, '2019-03-06', 165, NULL),
('Hotel deLuxe', 251, '2019-03-07', 166, NULL),
('Hotel deLuxe', 251, '2019-03-08', 120, NULL),
('Hotel deLuxe', 251, '2019-03-09', 187, NULL),
('Hotel deLuxe', 251, '2019-03-10', 192, NULL),
('Hotel deLuxe', 251, '2019-03-11', 188, NULL),
('Hotel deLuxe', 251, '2019-03-12', 304, NULL),
('Hotel deLuxe', 251, '2019-03-13', 145, NULL),
('Hotel deLuxe', 251, '2019-03-14', 307, NULL),
('Hotel deLuxe', 251, '2019-03-15', 121, NULL),
('Hotel deLuxe', 251, '2019-03-16', 116, NULL),
('Hotel deLuxe', 251, '2019-03-17', 289, NULL),
('Hotel deLuxe', 251, '2019-03-18', 346, NULL),
('Hotel deLuxe', 251, '2019-03-19', 284, NULL),
('Hotel deLuxe', 251, '2019-03-20', 331, NULL),
('Hotel deLuxe', 251, '2019-03-21', 148, NULL),
('Hotel deLuxe', 251, '2019-03-22', 323, NULL),
('Hotel deLuxe', 251, '2019-03-23', 205, NULL),
('Hotel deLuxe', 251, '2019-03-24', 248, NULL),
('Hotel deLuxe', 251, '2019-03-25', 235, NULL),
('Hotel deLuxe', 251, '2019-03-26', 103, NULL),
('Hotel deLuxe', 251, '2019-03-27', 312, NULL),
('Hotel deLuxe', 251, '2019-03-28', 256, NULL),
('Hotel deLuxe', 251, '2019-03-29', 377, NULL),
('Hotel deLuxe', 251, '2019-03-30', 168, NULL),
('Hotel deLuxe', 251, '2019-03-31', 141, NULL),
('Hotel deLuxe', 251, '2019-04-01', 316, NULL),
('Hotel deLuxe', 251, '2019-04-02', 230, NULL),
('Hotel deLuxe', 251, '2019-04-03', 216, NULL),
('Hotel deLuxe', 251, '2019-04-04', 209, NULL),
('Hotel deLuxe', 251, '2019-04-05', 192, NULL),
('Hotel deLuxe', 251, '2019-04-06', 309, NULL),
('Hotel deLuxe', 251, '2019-04-07', 219, NULL),
('Hotel deLuxe', 251, '2019-04-08', 105, NULL),
('Hotel deLuxe', 251, '2019-04-09', 129, NULL),
('Hotel deLuxe', 251, '2019-04-10', 322, NULL),
('Hotel deLuxe', 251, '2019-04-11', 353, NULL),
('Hotel deLuxe', 251, '2019-04-12', 156, NULL),
('Hotel deLuxe', 251, '2019-04-13', 346, NULL),
('Hotel deLuxe', 251, '2019-04-14', 362, NULL),
('Hotel deLuxe', 251, '2019-04-15', 211, NULL),
('Hotel deLuxe', 251, '2019-04-16', 268, NULL),
('Hotel deLuxe', 251, '2019-04-17', 318, NULL),
('Hotel deLuxe', 251, '2019-04-18', 223, NULL),
('Hotel deLuxe', 251, '2019-04-19', 257, NULL),
('Hotel deLuxe', 251, '2019-04-20', 135, NULL),
('Hotel deLuxe', 251, '2019-04-21', 303, NULL),
('Hotel deLuxe', 251, '2019-04-22', 297, NULL),
('Hotel deLuxe', 251, '2019-04-23', 297, NULL),
('Hotel deLuxe', 251, '2019-04-24', 142, NULL),
('Hotel deLuxe', 251, '2019-04-25', 243, NULL),
('Hotel deLuxe', 251, '2019-04-26', 352, NULL),
('Hotel deLuxe', 251, '2019-04-27', 308, NULL),
('Hotel deLuxe', 251, '2019-04-28', 354, NULL),
('Hotel deLuxe', 251, '2019-04-29', 129, NULL),
('Hotel deLuxe', 251, '2019-04-30', 296, NULL),
('Hotel deLuxe', 251, '2019-05-01', 218, NULL),
('Hotel deLuxe', 251, '2019-05-02', 231, NULL),
('Hotel deLuxe', 251, '2019-05-03', 370, NULL),
('Hotel deLuxe', 251, '2019-05-04', 377, NULL),
('Hotel deLuxe', 251, '2019-05-05', 386, NULL),
('Hotel deLuxe', 251, '2019-05-06', 107, NULL),
('Hotel deLuxe', 251, '2019-05-07', 196, NULL),
('Hotel deLuxe', 251, '2019-05-08', 296, NULL),
('Hotel deLuxe', 251, '2019-05-09', 175, NULL),
('Hotel deLuxe', 251, '2019-05-10', 223, NULL),
('Hotel deLuxe', 251, '2019-05-11', 254, NULL),
('Hotel deLuxe', 251, '2019-05-12', 159, NULL),
('Hotel deLuxe', 251, '2019-05-13', 286, NULL),
('Hotel deLuxe', 251, '2019-05-14', 116, NULL),
('Hotel deLuxe', 251, '2019-05-15', 114, NULL),
('Hotel deLuxe', 251, '2019-05-16', 117, NULL),
('Hotel deLuxe', 251, '2019-05-17', 315, NULL),
('Hotel deLuxe', 251, '2019-05-18', 207, NULL),
('Hotel deLuxe', 251, '2019-05-19', 319, NULL),
('Hotel deLuxe', 251, '2019-05-20', 391, NULL),
('Hotel deLuxe', 251, '2019-05-21', 102, NULL),
('Hotel deLuxe', 251, '2019-05-22', 126, NULL),
('Hotel deLuxe', 251, '2019-05-23', 144, NULL),
('Hotel deLuxe', 251, '2019-05-24', 232, NULL),
('Hotel deLuxe', 251, '2019-05-25', 289, NULL),
('Hotel deLuxe', 251, '2019-05-26', 329, NULL),
('Hotel deLuxe', 251, '2019-05-27', 185, NULL),
('Hotel deLuxe', 251, '2019-05-28', 185, NULL),
('Hotel deLuxe', 251, '2019-05-29', 276, NULL),
('Hotel deLuxe', 251, '2019-05-30', 345, NULL),
('Hotel deLuxe', 251, '2019-05-31', 288, NULL),
('Hotel deLuxe', 251, '2019-06-01', 110, NULL),
('Hotel deLuxe', 251, '2019-06-02', 307, NULL),
('Hotel deLuxe', 251, '2019-06-03', 268, NULL),
('Hotel deLuxe', 251, '2019-06-04', 379, NULL),
('Hotel deLuxe', 251, '2019-06-05', 199, NULL),
('Hotel deLuxe', 251, '2019-06-06', 307, NULL),
('Hotel deLuxe', 251, '2019-06-07', 236, NULL),
('Hotel deLuxe', 251, '2019-06-08', 372, NULL),
('Hotel deLuxe', 251, '2019-06-09', 173, NULL),
('Hotel deLuxe', 251, '2019-06-10', 234, NULL),
('Hotel deLuxe', 251, '2019-06-11', 228, NULL),
('Hotel deLuxe', 251, '2019-06-12', 180, NULL),
('Hotel deLuxe', 251, '2019-06-13', 358, NULL),
('Hotel deLuxe', 251, '2019-06-14', 379, NULL),
('Hotel deLuxe', 251, '2019-06-15', 349, NULL),
('Hotel deLuxe', 251, '2019-06-16', 379, NULL),
('Hotel deLuxe', 251, '2019-06-17', 157, NULL),
('Hotel deLuxe', 251, '2019-06-18', 222, NULL),
('Hotel deLuxe', 251, '2019-06-19', 159, NULL),
('Hotel deLuxe', 251, '2019-06-20', 223, NULL),
('Hotel deLuxe', 251, '2019-06-21', 228, NULL),
('Hotel deLuxe', 251, '2019-06-22', 145, NULL),
('Hotel deLuxe', 251, '2019-06-23', 296, NULL),
('Hotel deLuxe', 251, '2019-06-24', 230, NULL),
('Hotel deLuxe', 251, '2019-06-25', 314, NULL),
('Hotel deLuxe', 251, '2019-06-26', 362, NULL),
('Hotel deLuxe', 251, '2019-06-27', 180, NULL),
('Hotel deLuxe', 251, '2019-06-28', 276, NULL),
('Hotel deLuxe', 251, '2019-06-29', 368, NULL),
('Hotel deLuxe', 251, '2019-06-30', 300, NULL),
('Hotel deLuxe', 251, '2019-07-01', 223, NULL),
('Hotel deLuxe', 251, '2019-07-02', 156, NULL),
('Hotel deLuxe', 251, '2019-07-03', 110, NULL),
('Hotel deLuxe', 251, '2019-07-04', 146, NULL),
('Hotel deLuxe', 251, '2019-07-05', 194, NULL),
('Hotel deLuxe', 251, '2019-07-06', 264, NULL),
('Hotel deLuxe', 251, '2019-07-07', 216, NULL),
('Hotel deLuxe', 251, '2019-07-08', 182, NULL),
('Hotel deLuxe', 251, '2019-07-09', 214, NULL),
('Hotel deLuxe', 251, '2019-07-10', 242, NULL),
('Hotel deLuxe', 251, '2019-07-11', 161, NULL),
('Hotel deLuxe', 251, '2019-07-12', 324, NULL),
('Hotel deLuxe', 251, '2019-07-13', 234, NULL),
('Hotel deLuxe', 251, '2019-07-14', 310, NULL),
('Hotel deLuxe', 251, '2019-07-15', 317, NULL),
('Hotel deLuxe', 251, '2019-07-16', 375, NULL),
('Hotel deLuxe', 251, '2019-07-17', 192, NULL),
('Hotel deLuxe', 251, '2019-07-18', 129, NULL),
('Hotel deLuxe', 251, '2019-07-19', 253, NULL),
('Hotel deLuxe', 251, '2019-07-20', 346, NULL),
('Hotel deLuxe', 251, '2019-07-21', 181, NULL),
('Hotel deLuxe', 251, '2019-07-22', 306, NULL),
('Hotel deLuxe', 251, '2019-07-23', 352, NULL),
('Hotel deLuxe', 251, '2019-07-24', 119, NULL),
('Hotel deLuxe', 251, '2019-07-25', 149, NULL),
('Hotel deLuxe', 251, '2019-07-26', 137, NULL),
('Hotel deLuxe', 251, '2019-07-27', 301, NULL),
('Hotel deLuxe', 251, '2019-07-28', 157, NULL),
('Hotel deLuxe', 251, '2019-07-29', 382, NULL),
('Hotel deLuxe', 251, '2019-07-30', 263, NULL),
('Hotel deLuxe', 251, '2019-07-31', 189, NULL),
('Hotel deLuxe', 251, '2019-08-01', 340, NULL),
('Hotel deLuxe', 251, '2019-08-02', 205, NULL),
('Hotel deLuxe', 251, '2019-08-03', 354, NULL),
('Hotel deLuxe', 251, '2019-08-04', 173, NULL),
('Hotel deLuxe', 251, '2019-08-05', 252, NULL),
('Hotel deLuxe', 251, '2019-08-06', 256, NULL),
('Hotel deLuxe', 251, '2019-08-07', 110, NULL),
('Hotel deLuxe', 251, '2019-08-08', 122, NULL),
('Hotel deLuxe', 251, '2019-08-09', 215, NULL),
('Hotel deLuxe', 251, '2019-08-10', 141, NULL),
('Hotel deLuxe', 251, '2019-08-11', 176, NULL),
('Hotel deLuxe', 251, '2019-08-12', 219, NULL),
('Hotel deLuxe', 251, '2019-08-13', 313, NULL),
('Hotel deLuxe', 251, '2019-08-14', 231, NULL),
('Hotel deLuxe', 251, '2019-08-15', 398, NULL),
('Hotel deLuxe', 251, '2019-08-16', 386, NULL),
('Hotel deLuxe', 251, '2019-08-17', 218, NULL),
('Hotel deLuxe', 251, '2019-08-18', 270, NULL),
('Hotel deLuxe', 251, '2019-08-19', 346, NULL),
('Hotel deLuxe', 251, '2019-08-20', 240, NULL),
('Hotel deLuxe', 251, '2019-08-21', 155, NULL),
('Hotel deLuxe', 251, '2019-08-22', 262, NULL),
('Hotel deLuxe', 251, '2019-08-23', 221, NULL),
('Hotel deLuxe', 251, '2019-08-24', 338, NULL),
('Hotel deLuxe', 251, '2019-08-25', 368, NULL),
('Hotel deLuxe', 251, '2019-08-26', 125, NULL),
('Hotel deLuxe', 251, '2019-08-27', 106, NULL),
('Hotel deLuxe', 251, '2019-08-28', 205, NULL),
('Hotel deLuxe', 251, '2019-08-29', 351, NULL),
('Hotel deLuxe', 251, '2019-08-30', 357, NULL),
('Hotel deLuxe', 251, '2019-08-31', 304, NULL),
('Hotel deLuxe', 251, '2019-09-01', 352, NULL),
('Hotel deLuxe', 251, '2019-09-02', 266, NULL),
('Hotel deLuxe', 251, '2019-09-03', 241, NULL),
('Hotel deLuxe', 251, '2019-09-04', 283, NULL),
('Hotel deLuxe', 251, '2019-09-05', 361, NULL),
('Hotel deLuxe', 251, '2019-09-06', 234, NULL),
('Hotel deLuxe', 251, '2019-09-07', 271, NULL),
('Hotel deLuxe', 251, '2019-09-08', 332, NULL),
('Hotel deLuxe', 251, '2019-09-09', 125, NULL),
('Hotel deLuxe', 251, '2019-09-10', 277, NULL),
('Hotel deLuxe', 251, '2019-09-11', 151, NULL),
('Hotel deLuxe', 251, '2019-09-12', 394, NULL),
('Hotel deLuxe', 251, '2019-09-13', 307, NULL),
('Hotel deLuxe', 251, '2019-09-14', 101, NULL),
('Hotel deLuxe', 251, '2019-09-15', 341, NULL),
('Hotel deLuxe', 251, '2019-09-16', 256, NULL),
('Hotel deLuxe', 251, '2019-09-17', 359, NULL),
('Hotel deLuxe', 251, '2019-09-18', 376, NULL),
('Hotel deLuxe', 251, '2019-09-19', 174, NULL),
('Hotel deLuxe', 251, '2019-09-20', 313, NULL),
('Hotel deLuxe', 251, '2019-09-21', 337, NULL),
('Hotel deLuxe', 251, '2019-09-22', 383, NULL),
('Hotel deLuxe', 251, '2019-09-23', 322, NULL),
('Hotel deLuxe', 251, '2019-09-24', 295, NULL),
('Hotel deLuxe', 251, '2019-09-25', 291, NULL),
('Hotel deLuxe', 251, '2019-09-26', 292, NULL),
('Hotel deLuxe', 251, '2019-09-27', 203, NULL),
('Hotel deLuxe', 251, '2019-09-28', 360, NULL),
('Hotel deLuxe', 251, '2019-09-29', 274, NULL),
('Hotel deLuxe', 251, '2019-09-30', 263, NULL),
('Hotel deLuxe', 251, '2019-10-01', 390, NULL),
('Hotel deLuxe', 251, '2019-10-02', 277, NULL),
('Hotel deLuxe', 251, '2019-10-03', 265, NULL),
('Hotel deLuxe', 251, '2019-10-04', 373, NULL),
('Hotel deLuxe', 251, '2019-10-05', 182, NULL),
('Hotel deLuxe', 251, '2019-10-06', 182, NULL),
('Hotel deLuxe', 251, '2019-10-07', 242, NULL),
('Hotel deLuxe', 251, '2019-10-08', 151, NULL),
('Hotel deLuxe', 251, '2019-10-09', 160, NULL),
('Hotel deLuxe', 251, '2019-10-10', 162, NULL),
('Hotel deLuxe', 251, '2019-10-11', 233, NULL),
('Hotel deLuxe', 251, '2019-10-12', 251, NULL),
('Hotel deLuxe', 251, '2019-10-13', 151, NULL),
('Hotel deLuxe', 251, '2019-10-14', 153, NULL),
('Hotel deLuxe', 251, '2019-10-15', 286, NULL),
('Hotel deLuxe', 251, '2019-10-16', 226, NULL),
('Hotel deLuxe', 251, '2019-10-17', 287, NULL),
('Hotel deLuxe', 251, '2019-10-18', 188, NULL),
('Hotel deLuxe', 251, '2019-10-19', 183, NULL),
('Hotel deLuxe', 251, '2019-10-20', 274, NULL),
('Hotel deLuxe', 251, '2019-10-21', 205, NULL),
('Hotel deLuxe', 251, '2019-10-22', 363, NULL),
('Hotel deLuxe', 251, '2019-10-23', 137, NULL),
('Hotel deLuxe', 251, '2019-10-24', 263, NULL),
('Hotel deLuxe', 251, '2019-10-25', 162, NULL),
('Hotel deLuxe', 251, '2019-10-26', 276, NULL),
('Hotel deLuxe', 251, '2019-10-27', 233, NULL),
('Hotel deLuxe', 251, '2019-10-28', 148, NULL),
('Hotel deLuxe', 251, '2019-10-29', 164, NULL),
('Hotel deLuxe', 251, '2019-10-30', 262, NULL),
('Hotel deLuxe', 251, '2019-10-31', 392, NULL),
('Hotel deLuxe', 251, '2019-11-01', 154, NULL),
('Hotel deLuxe', 251, '2019-11-02', 171, NULL),
('Hotel deLuxe', 251, '2019-11-03', 361, NULL),
('Hotel deLuxe', 251, '2019-11-04', 210, NULL),
('Hotel deLuxe', 251, '2019-11-05', 312, NULL),
('Hotel deLuxe', 251, '2019-11-06', 395, NULL),
('Hotel deLuxe', 251, '2019-11-07', 383, NULL),
('Hotel deLuxe', 251, '2019-11-08', 171, NULL),
('Hotel deLuxe', 251, '2019-11-09', 148, NULL),
('Hotel deLuxe', 251, '2019-11-10', 310, NULL),
('Hotel deLuxe', 251, '2019-11-11', 224, NULL),
('Hotel deLuxe', 251, '2019-11-12', 353, NULL),
('Hotel deLuxe', 251, '2019-11-13', 333, NULL),
('Hotel deLuxe', 251, '2019-11-14', 243, NULL),
('Hotel deLuxe', 251, '2019-11-15', 246, NULL),
('Hotel deLuxe', 251, '2019-11-16', 232, NULL),
('Hotel deLuxe', 251, '2019-11-17', 198, NULL),
('Hotel deLuxe', 251, '2019-11-18', 171, NULL),
('Hotel deLuxe', 251, '2019-11-19', 381, NULL),
('Hotel deLuxe', 251, '2019-11-20', 293, NULL),
('Hotel deLuxe', 251, '2019-11-21', 336, NULL),
('Hotel deLuxe', 251, '2019-11-22', 353, NULL),
('Hotel deLuxe', 251, '2019-11-23', 231, NULL),
('Hotel deLuxe', 251, '2019-11-24', 300, NULL),
('Hotel deLuxe', 251, '2019-11-25', 388, NULL),
('Hotel deLuxe', 251, '2019-11-26', 394, NULL),
('Hotel deLuxe', 251, '2019-11-27', 271, NULL),
('Hotel deLuxe', 251, '2019-11-28', 382, NULL),
('Hotel deLuxe', 251, '2019-11-29', 306, NULL),
('Hotel deLuxe', 251, '2019-11-30', 114, NULL),
('Hotel deLuxe', 251, '2019-12-01', 255, NULL),
('Hotel deLuxe', 251, '2019-12-02', 203, NULL),
('Hotel deLuxe', 251, '2019-12-03', 208, NULL),
('Hotel deLuxe', 251, '2019-12-04', 285, NULL),
('Hotel deLuxe', 251, '2019-12-05', 170, NULL),
('Hotel deLuxe', 251, '2019-12-06', 345, NULL),
('Hotel deLuxe', 251, '2019-12-07', 170, NULL),
('Hotel deLuxe', 251, '2019-12-08', 292, NULL),
('Hotel deLuxe', 251, '2019-12-09', 369, NULL),
('Hotel deLuxe', 251, '2019-12-10', 216, NULL),
('Hotel deLuxe', 251, '2019-12-11', 181, NULL),
('Hotel deLuxe', 251, '2019-12-12', 351, NULL),
('Hotel deLuxe', 251, '2019-12-13', 277, NULL),
('Hotel deLuxe', 251, '2019-12-14', 132, NULL),
('Hotel deLuxe', 251, '2019-12-15', 208, NULL),
('Hotel deLuxe', 251, '2019-12-16', 184, NULL),
('Hotel deLuxe', 251, '2019-12-17', 368, NULL),
('Hotel deLuxe', 251, '2019-12-18', 186, NULL),
('Hotel deLuxe', 251, '2019-12-19', 106, NULL),
('Hotel deLuxe', 251, '2019-12-20', 156, NULL),
('Hotel deLuxe', 251, '2019-12-21', 198, NULL),
('Hotel deLuxe', 251, '2019-12-22', 179, NULL),
('Hotel deLuxe', 251, '2019-12-23', 103, NULL),
('Hotel deLuxe', 251, '2019-12-24', 176, NULL),
('Hotel deLuxe', 251, '2019-12-25', 341, NULL),
('Hotel deLuxe', 251, '2019-12-26', 181, NULL),
('Hotel deLuxe', 251, '2019-12-27', 331, NULL),
('Hotel deLuxe', 251, '2019-12-28', 209, NULL),
('Hotel deLuxe', 251, '2019-12-29', 305, NULL),
('Hotel deLuxe', 251, '2019-12-30', 387, NULL),
('Hotel deLuxe', 251, '2019-12-31', 215, NULL),
('Hotel deLuxe', 251, '2020-01-01', 360, NULL),
('Hotel deLuxe', 251, '2020-01-02', 266, NULL),
('Hotel deLuxe', 251, '2020-01-03', 314, NULL),
('Hotel deLuxe', 251, '2020-01-04', 362, NULL),
('Hotel deLuxe', 251, '2020-01-05', 351, NULL),
('Hotel deLuxe', 251, '2020-01-06', 183, NULL),
('Hotel deLuxe', 251, '2020-01-07', 207, NULL),
('Hotel deLuxe', 251, '2020-01-08', 333, NULL),
('Hotel deLuxe', 251, '2020-01-09', 351, NULL),
('Hotel deLuxe', 251, '2020-01-10', 290, NULL),
('Hotel deLuxe', 251, '2020-01-11', 217, NULL),
('Hotel deLuxe', 251, '2020-01-12', 219, NULL),
('Hotel deLuxe', 251, '2020-01-13', 222, NULL),
('Hotel deLuxe', 251, '2020-01-14', 159, NULL),
('Hotel deLuxe', 251, '2020-01-15', 118, NULL),
('Hotel deLuxe', 251, '2020-01-16', 238, NULL),
('Hotel deLuxe', 251, '2020-01-17', 378, NULL),
('Hotel deLuxe', 251, '2020-01-18', 336, NULL),
('Hotel deLuxe', 251, '2020-01-19', 256, NULL),
('Hotel deLuxe', 251, '2020-01-20', 261, NULL),
('Hotel deLuxe', 251, '2020-01-21', 386, NULL),
('Hotel deLuxe', 251, '2020-01-22', 377, NULL),
('Hotel deLuxe', 251, '2020-01-23', 386, NULL),
('Hotel deLuxe', 251, '2020-01-24', 132, NULL),
('Hotel deLuxe', 251, '2020-01-25', 285, NULL),
('Hotel deLuxe', 251, '2020-01-26', 256, NULL),
('Hotel deLuxe', 251, '2020-01-27', 243, NULL),
('Hotel deLuxe', 251, '2020-01-28', 288, NULL),
('Hotel deLuxe', 251, '2020-01-29', 107, NULL),
('Hotel deLuxe', 251, '2020-01-30', 123, NULL),
('Hotel deLuxe', 251, '2020-01-31', 310, NULL),
('Hotel deLuxe', 251, '2020-02-01', 209, NULL),
('Hotel deLuxe', 251, '2020-02-02', 237, NULL),
('Hotel deLuxe', 251, '2020-02-03', 330, NULL),
('Hotel deLuxe', 251, '2020-02-04', 341, NULL),
('Hotel deLuxe', 258, '2019-01-01', 203, NULL),
('Hotel deLuxe', 258, '2019-01-02', 217, NULL),
('Hotel deLuxe', 258, '2019-01-03', 304, NULL),
('Hotel deLuxe', 258, '2019-01-04', 160, NULL),
('Hotel deLuxe', 258, '2019-01-05', 233, NULL),
('Hotel deLuxe', 258, '2019-01-06', 128, NULL),
('Hotel deLuxe', 258, '2019-01-07', 251, NULL),
('Hotel deLuxe', 258, '2019-01-08', 155, NULL),
('Hotel deLuxe', 258, '2019-01-09', 280, NULL),
('Hotel deLuxe', 258, '2019-01-10', 179, NULL),
('Hotel deLuxe', 258, '2019-01-11', 290, NULL),
('Hotel deLuxe', 258, '2019-01-12', 292, NULL),
('Hotel deLuxe', 258, '2019-01-13', 352, NULL),
('Hotel deLuxe', 258, '2019-01-14', 373, NULL),
('Hotel deLuxe', 258, '2019-01-15', 381, NULL),
('Hotel deLuxe', 258, '2019-01-16', 325, NULL),
('Hotel deLuxe', 258, '2019-01-17', 147, NULL),
('Hotel deLuxe', 258, '2019-01-18', 318, NULL),
('Hotel deLuxe', 258, '2019-01-19', 243, NULL),
('Hotel deLuxe', 258, '2019-01-20', 251, NULL),
('Hotel deLuxe', 258, '2019-01-21', 375, NULL),
('Hotel deLuxe', 258, '2019-01-22', 245, NULL),
('Hotel deLuxe', 258, '2019-01-23', 197, NULL),
('Hotel deLuxe', 258, '2019-01-24', 398, NULL),
('Hotel deLuxe', 258, '2019-01-25', 265, NULL),
('Hotel deLuxe', 258, '2019-01-26', 212, NULL),
('Hotel deLuxe', 258, '2019-01-27', 278, NULL),
('Hotel deLuxe', 258, '2019-01-28', 106, NULL),
('Hotel deLuxe', 258, '2019-01-29', 263, NULL),
('Hotel deLuxe', 258, '2019-01-30', 302, NULL),
('Hotel deLuxe', 258, '2019-01-31', 141, NULL),
('Hotel deLuxe', 258, '2019-02-01', 326, NULL),
('Hotel deLuxe', 258, '2019-02-02', 260, NULL),
('Hotel deLuxe', 258, '2019-02-03', 270, NULL),
('Hotel deLuxe', 258, '2019-02-04', 215, NULL),
('Hotel deLuxe', 258, '2019-02-05', 319, NULL),
('Hotel deLuxe', 258, '2019-02-06', 332, NULL),
('Hotel deLuxe', 258, '2019-02-07', 300, NULL),
('Hotel deLuxe', 258, '2019-02-08', 220, NULL),
('Hotel deLuxe', 258, '2019-02-09', 187, NULL),
('Hotel deLuxe', 258, '2019-02-10', 352, NULL),
('Hotel deLuxe', 258, '2019-02-11', 217, NULL),
('Hotel deLuxe', 258, '2019-02-12', 176, NULL),
('Hotel deLuxe', 258, '2019-02-13', 138, NULL),
('Hotel deLuxe', 258, '2019-02-14', 305, NULL),
('Hotel deLuxe', 258, '2019-02-15', 301, NULL),
('Hotel deLuxe', 258, '2019-02-16', 155, NULL),
('Hotel deLuxe', 258, '2019-02-17', 243, NULL),
('Hotel deLuxe', 258, '2019-02-18', 108, NULL),
('Hotel deLuxe', 258, '2019-02-19', 306, NULL),
('Hotel deLuxe', 258, '2019-02-20', 382, NULL),
('Hotel deLuxe', 258, '2019-02-21', 381, NULL),
('Hotel deLuxe', 258, '2019-02-22', 152, NULL),
('Hotel deLuxe', 258, '2019-02-23', 233, NULL),
('Hotel deLuxe', 258, '2019-02-24', 115, NULL),
('Hotel deLuxe', 258, '2019-02-25', 341, NULL),
('Hotel deLuxe', 258, '2019-02-26', 146, NULL),
('Hotel deLuxe', 258, '2019-02-27', 266, NULL),
('Hotel deLuxe', 258, '2019-02-28', 168, NULL),
('Hotel deLuxe', 258, '2019-03-01', 317, NULL),
('Hotel deLuxe', 258, '2019-03-02', 373, NULL),
('Hotel deLuxe', 258, '2019-03-03', 137, NULL),
('Hotel deLuxe', 258, '2019-03-04', 164, NULL),
('Hotel deLuxe', 258, '2019-03-05', 293, NULL),
('Hotel deLuxe', 258, '2019-03-06', 327, NULL),
('Hotel deLuxe', 258, '2019-03-07', 299, NULL),
('Hotel deLuxe', 258, '2019-03-08', 114, NULL),
('Hotel deLuxe', 258, '2019-03-09', 104, NULL),
('Hotel deLuxe', 258, '2019-03-10', 398, NULL),
('Hotel deLuxe', 258, '2019-03-11', 102, NULL),
('Hotel deLuxe', 258, '2019-03-12', 258, NULL),
('Hotel deLuxe', 258, '2019-03-13', 146, NULL),
('Hotel deLuxe', 258, '2019-03-14', 354, NULL),
('Hotel deLuxe', 258, '2019-03-15', 215, NULL),
('Hotel deLuxe', 258, '2019-03-16', 257, NULL),
('Hotel deLuxe', 258, '2019-03-17', 330, NULL),
('Hotel deLuxe', 258, '2019-03-18', 362, NULL),
('Hotel deLuxe', 258, '2019-03-19', 129, NULL),
('Hotel deLuxe', 258, '2019-03-20', 354, NULL),
('Hotel deLuxe', 258, '2019-03-21', 135, NULL),
('Hotel deLuxe', 258, '2019-03-22', 300, NULL),
('Hotel deLuxe', 258, '2019-03-23', 373, NULL),
('Hotel deLuxe', 258, '2019-03-24', 225, NULL),
('Hotel deLuxe', 258, '2019-03-25', 104, NULL),
('Hotel deLuxe', 258, '2019-03-26', 151, NULL),
('Hotel deLuxe', 258, '2019-03-27', 294, NULL),
('Hotel deLuxe', 258, '2019-03-28', 344, NULL),
('Hotel deLuxe', 258, '2019-03-29', 375, NULL),
('Hotel deLuxe', 258, '2019-03-30', 257, NULL),
('Hotel deLuxe', 258, '2019-03-31', 153, NULL),
('Hotel deLuxe', 258, '2019-04-01', 389, NULL),
('Hotel deLuxe', 258, '2019-04-02', 330, NULL),
('Hotel deLuxe', 258, '2019-04-03', 263, NULL),
('Hotel deLuxe', 258, '2019-04-04', 261, NULL),
('Hotel deLuxe', 258, '2019-04-05', 183, NULL),
('Hotel deLuxe', 258, '2019-04-06', 112, NULL),
('Hotel deLuxe', 258, '2019-04-07', 106, NULL),
('Hotel deLuxe', 258, '2019-04-08', 181, NULL),
('Hotel deLuxe', 258, '2019-04-09', 325, NULL),
('Hotel deLuxe', 258, '2019-04-10', 225, NULL),
('Hotel deLuxe', 258, '2019-04-11', 165, NULL),
('Hotel deLuxe', 258, '2019-04-12', 310, NULL),
('Hotel deLuxe', 258, '2019-04-13', 211, NULL),
('Hotel deLuxe', 258, '2019-04-14', 152, NULL),
('Hotel deLuxe', 258, '2019-04-15', 306, NULL),
('Hotel deLuxe', 258, '2019-04-16', 212, NULL),
('Hotel deLuxe', 258, '2019-04-17', 215, NULL),
('Hotel deLuxe', 258, '2019-04-18', 123, NULL),
('Hotel deLuxe', 258, '2019-04-19', 217, NULL),
('Hotel deLuxe', 258, '2019-04-20', 397, NULL),
('Hotel deLuxe', 258, '2019-04-21', 306, NULL),
('Hotel deLuxe', 258, '2019-04-22', 210, NULL),
('Hotel deLuxe', 258, '2019-04-23', 213, NULL),
('Hotel deLuxe', 258, '2019-04-24', 234, NULL),
('Hotel deLuxe', 258, '2019-04-25', 278, NULL),
('Hotel deLuxe', 258, '2019-04-26', 258, NULL),
('Hotel deLuxe', 258, '2019-04-27', 161, NULL),
('Hotel deLuxe', 258, '2019-04-28', 374, NULL),
('Hotel deLuxe', 258, '2019-04-29', 229, NULL),
('Hotel deLuxe', 258, '2019-04-30', 163, NULL),
('Hotel deLuxe', 258, '2019-05-01', 264, NULL),
('Hotel deLuxe', 258, '2019-05-02', 382, NULL),
('Hotel deLuxe', 258, '2019-05-03', 129, NULL),
('Hotel deLuxe', 258, '2019-05-04', 308, NULL),
('Hotel deLuxe', 258, '2019-05-05', 291, NULL),
('Hotel deLuxe', 258, '2019-05-06', 335, NULL),
('Hotel deLuxe', 258, '2019-05-07', 162, NULL),
('Hotel deLuxe', 258, '2019-05-08', 255, NULL),
('Hotel deLuxe', 258, '2019-05-09', 127, NULL),
('Hotel deLuxe', 258, '2019-05-10', 193, NULL),
('Hotel deLuxe', 258, '2019-05-11', 180, NULL),
('Hotel deLuxe', 258, '2019-05-12', 125, NULL),
('Hotel deLuxe', 258, '2019-05-13', 305, NULL),
('Hotel deLuxe', 258, '2019-05-14', 126, NULL),
('Hotel deLuxe', 258, '2019-05-15', 246, NULL),
('Hotel deLuxe', 258, '2019-05-16', 117, NULL),
('Hotel deLuxe', 258, '2019-05-17', 331, NULL),
('Hotel deLuxe', 258, '2019-05-18', 199, NULL),
('Hotel deLuxe', 258, '2019-05-19', 168, NULL),
('Hotel deLuxe', 258, '2019-05-20', 278, NULL),
('Hotel deLuxe', 258, '2019-05-21', 228, NULL),
('Hotel deLuxe', 258, '2019-05-22', 232, NULL),
('Hotel deLuxe', 258, '2019-05-23', 148, NULL),
('Hotel deLuxe', 258, '2019-05-24', 390, NULL),
('Hotel deLuxe', 258, '2019-05-25', 166, NULL),
('Hotel deLuxe', 258, '2019-05-26', 337, NULL),
('Hotel deLuxe', 258, '2019-05-27', 122, NULL),
('Hotel deLuxe', 258, '2019-05-28', 230, NULL),
('Hotel deLuxe', 258, '2019-05-29', 368, NULL),
('Hotel deLuxe', 258, '2019-05-30', 121, NULL),
('Hotel deLuxe', 258, '2019-05-31', 327, NULL),
('Hotel deLuxe', 258, '2019-06-01', 262, NULL),
('Hotel deLuxe', 258, '2019-06-02', 137, NULL),
('Hotel deLuxe', 258, '2019-06-03', 385, NULL),
('Hotel deLuxe', 258, '2019-06-04', 147, NULL),
('Hotel deLuxe', 258, '2019-06-05', 300, NULL),
('Hotel deLuxe', 258, '2019-06-06', 136, NULL),
('Hotel deLuxe', 258, '2019-06-07', 100, NULL),
('Hotel deLuxe', 258, '2019-06-08', 260, NULL),
('Hotel deLuxe', 258, '2019-06-09', 248, NULL),
('Hotel deLuxe', 258, '2019-06-10', 282, NULL),
('Hotel deLuxe', 258, '2019-06-11', 328, NULL),
('Hotel deLuxe', 258, '2019-06-12', 283, NULL),
('Hotel deLuxe', 258, '2019-06-13', 283, NULL),
('Hotel deLuxe', 258, '2019-06-14', 166, NULL),
('Hotel deLuxe', 258, '2019-06-15', 141, NULL),
('Hotel deLuxe', 258, '2019-06-16', 246, NULL),
('Hotel deLuxe', 258, '2019-06-17', 139, NULL),
('Hotel deLuxe', 258, '2019-06-18', 219, NULL),
('Hotel deLuxe', 258, '2019-06-19', 314, NULL),
('Hotel deLuxe', 258, '2019-06-20', 152, NULL),
('Hotel deLuxe', 258, '2019-06-21', 183, NULL),
('Hotel deLuxe', 258, '2019-06-22', 119, NULL),
('Hotel deLuxe', 258, '2019-06-23', 101, NULL),
('Hotel deLuxe', 258, '2019-06-24', 356, NULL),
('Hotel deLuxe', 258, '2019-06-25', 222, NULL),
('Hotel deLuxe', 258, '2019-06-26', 116, NULL),
('Hotel deLuxe', 258, '2019-06-27', 359, NULL),
('Hotel deLuxe', 258, '2019-06-28', 201, NULL),
('Hotel deLuxe', 258, '2019-06-29', 343, NULL),
('Hotel deLuxe', 258, '2019-06-30', 285, NULL),
('Hotel deLuxe', 258, '2019-07-01', 131, NULL),
('Hotel deLuxe', 258, '2019-07-02', 126, NULL),
('Hotel deLuxe', 258, '2019-07-03', 118, NULL),
('Hotel deLuxe', 258, '2019-07-04', 248, NULL),
('Hotel deLuxe', 258, '2019-07-05', 138, NULL),
('Hotel deLuxe', 258, '2019-07-06', 325, NULL),
('Hotel deLuxe', 258, '2019-07-07', 220, NULL),
('Hotel deLuxe', 258, '2019-07-08', 302, NULL),
('Hotel deLuxe', 258, '2019-07-09', 358, NULL),
('Hotel deLuxe', 258, '2019-07-10', 367, NULL),
('Hotel deLuxe', 258, '2019-07-11', 292, NULL),
('Hotel deLuxe', 258, '2019-07-12', 297, NULL),
('Hotel deLuxe', 258, '2019-07-13', 390, NULL),
('Hotel deLuxe', 258, '2019-07-14', 105, NULL),
('Hotel deLuxe', 258, '2019-07-15', 387, NULL),
('Hotel deLuxe', 258, '2019-07-16', 378, NULL),
('Hotel deLuxe', 258, '2019-07-17', 132, NULL),
('Hotel deLuxe', 258, '2019-07-18', 165, NULL),
('Hotel deLuxe', 258, '2019-07-19', 111, NULL),
('Hotel deLuxe', 258, '2019-07-20', 395, NULL),
('Hotel deLuxe', 258, '2019-07-21', 156, NULL),
('Hotel deLuxe', 258, '2019-07-22', 223, NULL),
('Hotel deLuxe', 258, '2019-07-23', 202, NULL),
('Hotel deLuxe', 258, '2019-07-24', 141, NULL),
('Hotel deLuxe', 258, '2019-07-25', 195, NULL),
('Hotel deLuxe', 258, '2019-07-26', 217, NULL),
('Hotel deLuxe', 258, '2019-07-27', 259, NULL),
('Hotel deLuxe', 258, '2019-07-28', 185, NULL),
('Hotel deLuxe', 258, '2019-07-29', 114, NULL),
('Hotel deLuxe', 258, '2019-07-30', 197, NULL),
('Hotel deLuxe', 258, '2019-07-31', 266, NULL),
('Hotel deLuxe', 258, '2019-08-01', 300, NULL),
('Hotel deLuxe', 258, '2019-08-02', 313, NULL),
('Hotel deLuxe', 258, '2019-08-03', 165, NULL),
('Hotel deLuxe', 258, '2019-08-04', 292, NULL),
('Hotel deLuxe', 258, '2019-08-05', 131, NULL),
('Hotel deLuxe', 258, '2019-08-06', 341, NULL),
('Hotel deLuxe', 258, '2019-08-07', 342, NULL),
('Hotel deLuxe', 258, '2019-08-08', 105, NULL),
('Hotel deLuxe', 258, '2019-08-09', 321, NULL),
('Hotel deLuxe', 258, '2019-08-10', 159, NULL),
('Hotel deLuxe', 258, '2019-08-11', 361, NULL),
('Hotel deLuxe', 258, '2019-08-12', 223, NULL),
('Hotel deLuxe', 258, '2019-08-13', 157, NULL),
('Hotel deLuxe', 258, '2019-08-14', 162, NULL),
('Hotel deLuxe', 258, '2019-08-15', 361, NULL),
('Hotel deLuxe', 258, '2019-08-16', 102, NULL),
('Hotel deLuxe', 258, '2019-08-17', 183, NULL),
('Hotel deLuxe', 258, '2019-08-18', 388, NULL),
('Hotel deLuxe', 258, '2019-08-19', 144, NULL),
('Hotel deLuxe', 258, '2019-08-20', 312, NULL),
('Hotel deLuxe', 258, '2019-08-21', 286, NULL),
('Hotel deLuxe', 258, '2019-08-22', 214, NULL),
('Hotel deLuxe', 258, '2019-08-23', 329, NULL),
('Hotel deLuxe', 258, '2019-08-24', 311, NULL),
('Hotel deLuxe', 258, '2019-08-25', 252, NULL),
('Hotel deLuxe', 258, '2019-08-26', 244, NULL),
('Hotel deLuxe', 258, '2019-08-27', 143, NULL),
('Hotel deLuxe', 258, '2019-08-28', 304, NULL),
('Hotel deLuxe', 258, '2019-08-29', 179, NULL),
('Hotel deLuxe', 258, '2019-08-30', 115, NULL),
('Hotel deLuxe', 258, '2019-08-31', 243, NULL),
('Hotel deLuxe', 258, '2019-09-01', 385, NULL),
('Hotel deLuxe', 258, '2019-09-02', 155, NULL),
('Hotel deLuxe', 258, '2019-09-03', 151, NULL),
('Hotel deLuxe', 258, '2019-09-04', 327, NULL),
('Hotel deLuxe', 258, '2019-09-05', 176, NULL),
('Hotel deLuxe', 258, '2019-09-06', 165, NULL),
('Hotel deLuxe', 258, '2019-09-07', 308, NULL),
('Hotel deLuxe', 258, '2019-09-08', 179, NULL),
('Hotel deLuxe', 258, '2019-09-09', 370, NULL),
('Hotel deLuxe', 258, '2019-09-10', 342, NULL),
('Hotel deLuxe', 258, '2019-09-11', 163, NULL),
('Hotel deLuxe', 258, '2019-09-12', 368, NULL),
('Hotel deLuxe', 258, '2019-09-13', 118, NULL),
('Hotel deLuxe', 258, '2019-09-14', 113, NULL),
('Hotel deLuxe', 258, '2019-09-15', 140, NULL),
('Hotel deLuxe', 258, '2019-09-16', 256, NULL),
('Hotel deLuxe', 258, '2019-09-17', 211, NULL),
('Hotel deLuxe', 258, '2019-09-18', 244, NULL),
('Hotel deLuxe', 258, '2019-09-19', 118, NULL),
('Hotel deLuxe', 258, '2019-09-20', 275, NULL),
('Hotel deLuxe', 258, '2019-09-21', 381, NULL),
('Hotel deLuxe', 258, '2019-09-22', 346, NULL),
('Hotel deLuxe', 258, '2019-09-23', 141, NULL),
('Hotel deLuxe', 258, '2019-09-24', 174, NULL),
('Hotel deLuxe', 258, '2019-09-25', 341, NULL),
('Hotel deLuxe', 258, '2019-09-26', 262, NULL),
('Hotel deLuxe', 258, '2019-09-27', 105, NULL),
('Hotel deLuxe', 258, '2019-09-28', 333, NULL),
('Hotel deLuxe', 258, '2019-09-29', 229, NULL),
('Hotel deLuxe', 258, '2019-09-30', 115, NULL),
('Hotel deLuxe', 258, '2019-10-01', 282, NULL),
('Hotel deLuxe', 258, '2019-10-02', 245, NULL),
('Hotel deLuxe', 258, '2019-10-03', 322, NULL),
('Hotel deLuxe', 258, '2019-10-04', 172, NULL),
('Hotel deLuxe', 258, '2019-10-05', 120, NULL),
('Hotel deLuxe', 258, '2019-10-06', 391, NULL),
('Hotel deLuxe', 258, '2019-10-07', 337, NULL),
('Hotel deLuxe', 258, '2019-10-08', 359, NULL),
('Hotel deLuxe', 258, '2019-10-09', 390, NULL),
('Hotel deLuxe', 258, '2019-10-10', 210, NULL),
('Hotel deLuxe', 258, '2019-10-11', 275, NULL),
('Hotel deLuxe', 258, '2019-10-12', 247, NULL),
('Hotel deLuxe', 258, '2019-10-13', 277, NULL),
('Hotel deLuxe', 258, '2019-10-14', 252, NULL),
('Hotel deLuxe', 258, '2019-10-15', 342, NULL),
('Hotel deLuxe', 258, '2019-10-16', 391, NULL),
('Hotel deLuxe', 258, '2019-10-17', 153, NULL),
('Hotel deLuxe', 258, '2019-10-18', 367, NULL),
('Hotel deLuxe', 258, '2019-10-19', 283, NULL),
('Hotel deLuxe', 258, '2019-10-20', 188, NULL),
('Hotel deLuxe', 258, '2019-10-21', 206, NULL),
('Hotel deLuxe', 258, '2019-10-22', 377, NULL),
('Hotel deLuxe', 258, '2019-10-23', 170, NULL),
('Hotel deLuxe', 258, '2019-10-24', 345, NULL),
('Hotel deLuxe', 258, '2019-10-25', 237, NULL),
('Hotel deLuxe', 258, '2019-10-26', 327, NULL),
('Hotel deLuxe', 258, '2019-10-27', 128, NULL),
('Hotel deLuxe', 258, '2019-10-28', 124, NULL),
('Hotel deLuxe', 258, '2019-10-29', 366, NULL),
('Hotel deLuxe', 258, '2019-10-30', 253, NULL),
('Hotel deLuxe', 258, '2019-10-31', 215, NULL),
('Hotel deLuxe', 258, '2019-11-01', 121, NULL),
('Hotel deLuxe', 258, '2019-11-02', 272, NULL),
('Hotel deLuxe', 258, '2019-11-03', 309, NULL),
('Hotel deLuxe', 258, '2019-11-04', 110, NULL),
('Hotel deLuxe', 258, '2019-11-05', 285, NULL),
('Hotel deLuxe', 258, '2019-11-06', 208, NULL),
('Hotel deLuxe', 258, '2019-11-07', 367, NULL),
('Hotel deLuxe', 258, '2019-11-08', 308, NULL),
('Hotel deLuxe', 258, '2019-11-09', 358, NULL),
('Hotel deLuxe', 258, '2019-11-10', 323, NULL),
('Hotel deLuxe', 258, '2019-11-11', 242, NULL),
('Hotel deLuxe', 258, '2019-11-12', 267, NULL),
('Hotel deLuxe', 258, '2019-11-13', 178, NULL),
('Hotel deLuxe', 258, '2019-11-14', 275, NULL),
('Hotel deLuxe', 258, '2019-11-15', 181, NULL),
('Hotel deLuxe', 258, '2019-11-16', 147, NULL),
('Hotel deLuxe', 258, '2019-11-17', 318, NULL),
('Hotel deLuxe', 258, '2019-11-18', 236, NULL),
('Hotel deLuxe', 258, '2019-11-19', 146, NULL),
('Hotel deLuxe', 258, '2019-11-20', 141, NULL),
('Hotel deLuxe', 258, '2019-11-21', 328, NULL),
('Hotel deLuxe', 258, '2019-11-22', 353, NULL),
('Hotel deLuxe', 258, '2019-11-23', 238, NULL),
('Hotel deLuxe', 258, '2019-11-24', 150, NULL),
('Hotel deLuxe', 258, '2019-11-25', 189, NULL),
('Hotel deLuxe', 258, '2019-11-26', 230, NULL),
('Hotel deLuxe', 258, '2019-11-27', 143, NULL),
('Hotel deLuxe', 258, '2019-11-28', 227, NULL),
('Hotel deLuxe', 258, '2019-11-29', 337, NULL),
('Hotel deLuxe', 258, '2019-11-30', 176, NULL),
('Hotel deLuxe', 258, '2019-12-01', 122, NULL),
('Hotel deLuxe', 258, '2019-12-02', 193, NULL),
('Hotel deLuxe', 258, '2019-12-03', 256, NULL),
('Hotel deLuxe', 258, '2019-12-04', 200, NULL),
('Hotel deLuxe', 258, '2019-12-05', 269, NULL),
('Hotel deLuxe', 258, '2019-12-06', 295, NULL),
('Hotel deLuxe', 258, '2019-12-07', 292, NULL),
('Hotel deLuxe', 258, '2019-12-08', 293, NULL),
('Hotel deLuxe', 258, '2019-12-09', 168, NULL),
('Hotel deLuxe', 258, '2019-12-10', 195, NULL),
('Hotel deLuxe', 258, '2019-12-11', 245, NULL),
('Hotel deLuxe', 258, '2019-12-12', 372, NULL),
('Hotel deLuxe', 258, '2019-12-13', 234, NULL),
('Hotel deLuxe', 258, '2019-12-14', 239, NULL),
('Hotel deLuxe', 258, '2019-12-15', 227, NULL),
('Hotel deLuxe', 258, '2019-12-16', 325, NULL),
('Hotel deLuxe', 258, '2019-12-17', 289, NULL),
('Hotel deLuxe', 258, '2019-12-18', 119, NULL),
('Hotel deLuxe', 258, '2019-12-19', 158, NULL),
('Hotel deLuxe', 258, '2019-12-20', 208, NULL),
('Hotel deLuxe', 258, '2019-12-21', 289, NULL),
('Hotel deLuxe', 258, '2019-12-22', 358, NULL),
('Hotel deLuxe', 258, '2019-12-23', 110, NULL),
('Hotel deLuxe', 258, '2019-12-24', 331, NULL),
('Hotel deLuxe', 258, '2019-12-25', 184, NULL),
('Hotel deLuxe', 258, '2019-12-26', 392, NULL),
('Hotel deLuxe', 258, '2019-12-27', 237, NULL),
('Hotel deLuxe', 258, '2019-12-28', 280, NULL),
('Hotel deLuxe', 258, '2019-12-29', 298, NULL),
('Hotel deLuxe', 258, '2019-12-30', 307, NULL),
('Hotel deLuxe', 258, '2019-12-31', 354, NULL),
('Hotel deLuxe', 258, '2020-01-01', 246, NULL),
('Hotel deLuxe', 258, '2020-01-02', 126, NULL),
('Hotel deLuxe', 258, '2020-01-03', 337, NULL),
('Hotel deLuxe', 258, '2020-01-04', 341, NULL),
('Hotel deLuxe', 258, '2020-01-05', 137, NULL),
('Hotel deLuxe', 258, '2020-01-06', 371, NULL),
('Hotel deLuxe', 258, '2020-01-07', 367, NULL),
('Hotel deLuxe', 258, '2020-01-08', 233, NULL),
('Hotel deLuxe', 258, '2020-01-09', 124, NULL),
('Hotel deLuxe', 258, '2020-01-10', 332, NULL),
('Hotel deLuxe', 258, '2020-01-11', 288, NULL),
('Hotel deLuxe', 258, '2020-01-12', 292, NULL),
('Hotel deLuxe', 258, '2020-01-13', 328, NULL),
('Hotel deLuxe', 258, '2020-01-14', 296, NULL),
('Hotel deLuxe', 258, '2020-01-15', 201, NULL),
('Hotel deLuxe', 258, '2020-01-16', 269, NULL),
('Hotel deLuxe', 258, '2020-01-17', 277, NULL),
('Hotel deLuxe', 258, '2020-01-18', 150, NULL),
('Hotel deLuxe', 258, '2020-01-19', 306, NULL),
('Hotel deLuxe', 258, '2020-01-20', 120, NULL),
('Hotel deLuxe', 258, '2020-01-21', 212, NULL),
('Hotel deLuxe', 258, '2020-01-22', 312, NULL),
('Hotel deLuxe', 258, '2020-01-23', 140, NULL),
('Hotel deLuxe', 258, '2020-01-24', 327, NULL),
('Hotel deLuxe', 258, '2020-01-25', 259, NULL),
('Hotel deLuxe', 258, '2020-01-26', 133, NULL),
('Hotel deLuxe', 258, '2020-01-27', 152, NULL),
('Hotel deLuxe', 258, '2020-01-28', 355, NULL),
('Hotel deLuxe', 258, '2020-01-29', 268, NULL),
('Hotel deLuxe', 258, '2020-01-30', 154, NULL),
('Hotel deLuxe', 258, '2020-01-31', 329, NULL),
('Hotel deLuxe', 258, '2020-02-01', 166, NULL),
('Hotel deLuxe', 258, '2020-02-02', 215, NULL),
('Hotel deLuxe', 258, '2020-02-03', 261, NULL),
('Hotel deLuxe', 258, '2020-02-04', 389, NULL),
('Hotel deLuxe', 274, '2019-01-01', 187, NULL),
('Hotel deLuxe', 274, '2019-01-02', 279, NULL),
('Hotel deLuxe', 274, '2019-01-03', 372, NULL),
('Hotel deLuxe', 274, '2019-01-04', 371, NULL),
('Hotel deLuxe', 274, '2019-01-05', 204, NULL),
('Hotel deLuxe', 274, '2019-01-06', 348, NULL),
('Hotel deLuxe', 274, '2019-01-07', 158, NULL),
('Hotel deLuxe', 274, '2019-01-08', 192, NULL),
('Hotel deLuxe', 274, '2019-01-09', 389, NULL),
('Hotel deLuxe', 274, '2019-01-10', 286, NULL),
('Hotel deLuxe', 274, '2019-01-11', 115, NULL),
('Hotel deLuxe', 274, '2019-01-12', 272, NULL),
('Hotel deLuxe', 274, '2019-01-13', 374, NULL),
('Hotel deLuxe', 274, '2019-01-14', 220, NULL),
('Hotel deLuxe', 274, '2019-01-15', 221, NULL),
('Hotel deLuxe', 274, '2019-01-16', 255, NULL),
('Hotel deLuxe', 274, '2019-01-17', 230, NULL),
('Hotel deLuxe', 274, '2019-01-18', 109, NULL),
('Hotel deLuxe', 274, '2019-01-19', 209, NULL),
('Hotel deLuxe', 274, '2019-01-20', 157, NULL),
('Hotel deLuxe', 274, '2019-01-21', 383, NULL),
('Hotel deLuxe', 274, '2019-01-22', 102, NULL),
('Hotel deLuxe', 274, '2019-01-23', 227, NULL),
('Hotel deLuxe', 274, '2019-01-24', 265, NULL),
('Hotel deLuxe', 274, '2019-01-25', 131, NULL),
('Hotel deLuxe', 274, '2019-01-26', 363, NULL),
('Hotel deLuxe', 274, '2019-01-27', 251, NULL),
('Hotel deLuxe', 274, '2019-01-28', 151, NULL),
('Hotel deLuxe', 274, '2019-01-29', 168, NULL),
('Hotel deLuxe', 274, '2019-01-30', 289, NULL),
('Hotel deLuxe', 274, '2019-01-31', 190, NULL),
('Hotel deLuxe', 274, '2019-02-01', 295, NULL),
('Hotel deLuxe', 274, '2019-02-02', 258, NULL),
('Hotel deLuxe', 274, '2019-02-03', 342, NULL),
('Hotel deLuxe', 274, '2019-02-04', 258, NULL),
('Hotel deLuxe', 274, '2019-02-05', 115, NULL),
('Hotel deLuxe', 274, '2019-02-06', 139, NULL),
('Hotel deLuxe', 274, '2019-02-07', 333, NULL),
('Hotel deLuxe', 274, '2019-02-08', 184, NULL),
('Hotel deLuxe', 274, '2019-02-09', 254, NULL),
('Hotel deLuxe', 274, '2019-02-10', 103, NULL),
('Hotel deLuxe', 274, '2019-02-11', 133, NULL),
('Hotel deLuxe', 274, '2019-02-12', 291, NULL),
('Hotel deLuxe', 274, '2019-02-13', 105, NULL),
('Hotel deLuxe', 274, '2019-02-14', 189, NULL),
('Hotel deLuxe', 274, '2019-02-15', 369, NULL),
('Hotel deLuxe', 274, '2019-02-16', 115, NULL),
('Hotel deLuxe', 274, '2019-02-17', 203, NULL),
('Hotel deLuxe', 274, '2019-02-18', 390, NULL),
('Hotel deLuxe', 274, '2019-02-19', 318, NULL),
('Hotel deLuxe', 274, '2019-02-20', 387, NULL),
('Hotel deLuxe', 274, '2019-02-21', 116, NULL),
('Hotel deLuxe', 274, '2019-02-22', 232, NULL),
('Hotel deLuxe', 274, '2019-02-23', 268, NULL),
('Hotel deLuxe', 274, '2019-02-24', 281, NULL),
('Hotel deLuxe', 274, '2019-02-25', 343, NULL),
('Hotel deLuxe', 274, '2019-02-26', 375, NULL),
('Hotel deLuxe', 274, '2019-02-27', 190, NULL),
('Hotel deLuxe', 274, '2019-02-28', 369, NULL),
('Hotel deLuxe', 274, '2019-03-01', 186, NULL),
('Hotel deLuxe', 274, '2019-03-02', 235, NULL),
('Hotel deLuxe', 274, '2019-03-03', 274, NULL),
('Hotel deLuxe', 274, '2019-03-04', 328, NULL),
('Hotel deLuxe', 274, '2019-03-05', 204, NULL),
('Hotel deLuxe', 274, '2019-03-06', 143, NULL),
('Hotel deLuxe', 274, '2019-03-07', 297, NULL),
('Hotel deLuxe', 274, '2019-03-08', 110, NULL),
('Hotel deLuxe', 274, '2019-03-09', 163, NULL),
('Hotel deLuxe', 274, '2019-03-10', 117, NULL),
('Hotel deLuxe', 274, '2019-03-11', 147, NULL),
('Hotel deLuxe', 274, '2019-03-12', 280, NULL),
('Hotel deLuxe', 274, '2019-03-13', 194, NULL),
('Hotel deLuxe', 274, '2019-03-14', 150, NULL),
('Hotel deLuxe', 274, '2019-03-15', 314, NULL),
('Hotel deLuxe', 274, '2019-03-16', 238, NULL),
('Hotel deLuxe', 274, '2019-03-17', 385, NULL),
('Hotel deLuxe', 274, '2019-03-18', 370, NULL),
('Hotel deLuxe', 274, '2019-03-19', 294, NULL),
('Hotel deLuxe', 274, '2019-03-20', 380, NULL),
('Hotel deLuxe', 274, '2019-03-21', 132, NULL),
('Hotel deLuxe', 274, '2019-03-22', 134, NULL),
('Hotel deLuxe', 274, '2019-03-23', 249, NULL),
('Hotel deLuxe', 274, '2019-03-24', 278, NULL),
('Hotel deLuxe', 274, '2019-03-25', 315, NULL),
('Hotel deLuxe', 274, '2019-03-26', 346, NULL),
('Hotel deLuxe', 274, '2019-03-27', 136, NULL),
('Hotel deLuxe', 274, '2019-03-28', 254, NULL),
('Hotel deLuxe', 274, '2019-03-29', 346, NULL),
('Hotel deLuxe', 274, '2019-03-30', 381, NULL),
('Hotel deLuxe', 274, '2019-03-31', 245, NULL),
('Hotel deLuxe', 274, '2019-04-01', 297, NULL),
('Hotel deLuxe', 274, '2019-04-02', 260, NULL),
('Hotel deLuxe', 274, '2019-04-03', 267, NULL),
('Hotel deLuxe', 274, '2019-04-04', 278, NULL),
('Hotel deLuxe', 274, '2019-04-05', 240, NULL),
('Hotel deLuxe', 274, '2019-04-06', 133, NULL),
('Hotel deLuxe', 274, '2019-04-07', 372, NULL),
('Hotel deLuxe', 274, '2019-04-08', 188, NULL),
('Hotel deLuxe', 274, '2019-04-09', 240, NULL),
('Hotel deLuxe', 274, '2019-04-10', 359, NULL),
('Hotel deLuxe', 274, '2019-04-11', 268, NULL),
('Hotel deLuxe', 274, '2019-04-12', 382, NULL),
('Hotel deLuxe', 274, '2019-04-13', 217, NULL),
('Hotel deLuxe', 274, '2019-04-14', 174, NULL),
('Hotel deLuxe', 274, '2019-04-15', 199, NULL),
('Hotel deLuxe', 274, '2019-04-16', 157, NULL),
('Hotel deLuxe', 274, '2019-04-17', 321, NULL),
('Hotel deLuxe', 274, '2019-04-18', 146, NULL),
('Hotel deLuxe', 274, '2019-04-19', 216, NULL),
('Hotel deLuxe', 274, '2019-04-20', 279, NULL),
('Hotel deLuxe', 274, '2019-04-21', 225, NULL),
('Hotel deLuxe', 274, '2019-04-22', 361, NULL),
('Hotel deLuxe', 274, '2019-04-23', 373, NULL),
('Hotel deLuxe', 274, '2019-04-24', 344, NULL),
('Hotel deLuxe', 274, '2019-04-25', 262, NULL),
('Hotel deLuxe', 274, '2019-04-26', 138, NULL),
('Hotel deLuxe', 274, '2019-04-27', 382, NULL),
('Hotel deLuxe', 274, '2019-04-28', 109, NULL),
('Hotel deLuxe', 274, '2019-04-29', 357, NULL),
('Hotel deLuxe', 274, '2019-04-30', 127, NULL),
('Hotel deLuxe', 274, '2019-05-01', 267, NULL),
('Hotel deLuxe', 274, '2019-05-02', 217, NULL),
('Hotel deLuxe', 274, '2019-05-03', 337, NULL),
('Hotel deLuxe', 274, '2019-05-04', 312, NULL),
('Hotel deLuxe', 274, '2019-05-05', 197, NULL),
('Hotel deLuxe', 274, '2019-05-06', 356, NULL),
('Hotel deLuxe', 274, '2019-05-07', 120, NULL),
('Hotel deLuxe', 274, '2019-05-08', 286, NULL),
('Hotel deLuxe', 274, '2019-05-09', 311, NULL),
('Hotel deLuxe', 274, '2019-05-10', 197, NULL),
('Hotel deLuxe', 274, '2019-05-11', 340, NULL),
('Hotel deLuxe', 274, '2019-05-12', 350, NULL),
('Hotel deLuxe', 274, '2019-05-13', 267, NULL),
('Hotel deLuxe', 274, '2019-05-14', 184, NULL),
('Hotel deLuxe', 274, '2019-05-15', 187, NULL),
('Hotel deLuxe', 274, '2019-05-16', 137, NULL),
('Hotel deLuxe', 274, '2019-05-17', 314, NULL),
('Hotel deLuxe', 274, '2019-05-18', 277, NULL),
('Hotel deLuxe', 274, '2019-05-19', 384, NULL),
('Hotel deLuxe', 274, '2019-05-20', 117, NULL),
('Hotel deLuxe', 274, '2019-05-21', 137, NULL),
('Hotel deLuxe', 274, '2019-05-22', 380, NULL),
('Hotel deLuxe', 274, '2019-05-23', 209, NULL),
('Hotel deLuxe', 274, '2019-05-24', 257, NULL),
('Hotel deLuxe', 274, '2019-05-25', 164, NULL),
('Hotel deLuxe', 274, '2019-05-26', 298, NULL),
('Hotel deLuxe', 274, '2019-05-27', 256, NULL),
('Hotel deLuxe', 274, '2019-05-28', 198, NULL),
('Hotel deLuxe', 274, '2019-05-29', 312, NULL),
('Hotel deLuxe', 274, '2019-05-30', 371, NULL),
('Hotel deLuxe', 274, '2019-05-31', 368, NULL),
('Hotel deLuxe', 274, '2019-06-01', 279, NULL),
('Hotel deLuxe', 274, '2019-06-02', 262, NULL),
('Hotel deLuxe', 274, '2019-06-03', 120, NULL),
('Hotel deLuxe', 274, '2019-06-04', 100, NULL),
('Hotel deLuxe', 274, '2019-06-05', 202, NULL),
('Hotel deLuxe', 274, '2019-06-06', 260, NULL),
('Hotel deLuxe', 274, '2019-06-07', 295, NULL),
('Hotel deLuxe', 274, '2019-06-08', 383, NULL),
('Hotel deLuxe', 274, '2019-06-09', 323, NULL),
('Hotel deLuxe', 274, '2019-06-10', 310, NULL),
('Hotel deLuxe', 274, '2019-06-11', 255, NULL),
('Hotel deLuxe', 274, '2019-06-12', 177, NULL),
('Hotel deLuxe', 274, '2019-06-13', 241, NULL),
('Hotel deLuxe', 274, '2019-06-14', 192, NULL),
('Hotel deLuxe', 274, '2019-06-15', 161, NULL),
('Hotel deLuxe', 274, '2019-06-16', 293, NULL),
('Hotel deLuxe', 274, '2019-06-17', 123, NULL),
('Hotel deLuxe', 274, '2019-06-18', 329, NULL),
('Hotel deLuxe', 274, '2019-06-19', 394, NULL),
('Hotel deLuxe', 274, '2019-06-20', 291, NULL),
('Hotel deLuxe', 274, '2019-06-21', 133, NULL),
('Hotel deLuxe', 274, '2019-06-22', 360, NULL),
('Hotel deLuxe', 274, '2019-06-23', 117, NULL),
('Hotel deLuxe', 274, '2019-06-24', 388, NULL),
('Hotel deLuxe', 274, '2019-06-25', 365, NULL),
('Hotel deLuxe', 274, '2019-06-26', 298, NULL),
('Hotel deLuxe', 274, '2019-06-27', 257, NULL),
('Hotel deLuxe', 274, '2019-06-28', 377, NULL),
('Hotel deLuxe', 274, '2019-06-29', 209, NULL),
('Hotel deLuxe', 274, '2019-06-30', 128, NULL),
('Hotel deLuxe', 274, '2019-07-01', 187, NULL),
('Hotel deLuxe', 274, '2019-07-02', 363, NULL),
('Hotel deLuxe', 274, '2019-07-03', 162, NULL),
('Hotel deLuxe', 274, '2019-07-04', 103, NULL),
('Hotel deLuxe', 274, '2019-07-05', 305, NULL),
('Hotel deLuxe', 274, '2019-07-06', 132, NULL),
('Hotel deLuxe', 274, '2019-07-07', 350, NULL),
('Hotel deLuxe', 274, '2019-07-08', 265, NULL),
('Hotel deLuxe', 274, '2019-07-09', 149, NULL),
('Hotel deLuxe', 274, '2019-07-10', 111, NULL),
('Hotel deLuxe', 274, '2019-07-11', 279, NULL),
('Hotel deLuxe', 274, '2019-07-12', 114, NULL),
('Hotel deLuxe', 274, '2019-07-13', 247, NULL),
('Hotel deLuxe', 274, '2019-07-14', 398, NULL),
('Hotel deLuxe', 274, '2019-07-15', 286, NULL),
('Hotel deLuxe', 274, '2019-07-16', 362, NULL),
('Hotel deLuxe', 274, '2019-07-17', 285, NULL),
('Hotel deLuxe', 274, '2019-07-18', 339, NULL),
('Hotel deLuxe', 274, '2019-07-19', 298, NULL),
('Hotel deLuxe', 274, '2019-07-20', 236, NULL),
('Hotel deLuxe', 274, '2019-07-21', 137, NULL),
('Hotel deLuxe', 274, '2019-07-22', 394, NULL),
('Hotel deLuxe', 274, '2019-07-23', 155, NULL),
('Hotel deLuxe', 274, '2019-07-24', 245, NULL),
('Hotel deLuxe', 274, '2019-07-25', 129, NULL),
('Hotel deLuxe', 274, '2019-07-26', 274, NULL),
('Hotel deLuxe', 274, '2019-07-27', 292, NULL),
('Hotel deLuxe', 274, '2019-07-28', 354, NULL),
('Hotel deLuxe', 274, '2019-07-29', 225, NULL),
('Hotel deLuxe', 274, '2019-07-30', 394, NULL),
('Hotel deLuxe', 274, '2019-07-31', 365, NULL),
('Hotel deLuxe', 274, '2019-08-01', 378, NULL),
('Hotel deLuxe', 274, '2019-08-02', 254, NULL),
('Hotel deLuxe', 274, '2019-08-03', 265, NULL),
('Hotel deLuxe', 274, '2019-08-04', 243, NULL),
('Hotel deLuxe', 274, '2019-08-05', 102, NULL),
('Hotel deLuxe', 274, '2019-08-06', 239, NULL),
('Hotel deLuxe', 274, '2019-08-07', 381, NULL),
('Hotel deLuxe', 274, '2019-08-08', 358, NULL),
('Hotel deLuxe', 274, '2019-08-09', 263, NULL),
('Hotel deLuxe', 274, '2019-08-10', 270, NULL),
('Hotel deLuxe', 274, '2019-08-11', 278, NULL),
('Hotel deLuxe', 274, '2019-08-12', 356, NULL),
('Hotel deLuxe', 274, '2019-08-13', 346, NULL),
('Hotel deLuxe', 274, '2019-08-14', 317, NULL),
('Hotel deLuxe', 274, '2019-08-15', 209, NULL),
('Hotel deLuxe', 274, '2019-08-16', 154, NULL),
('Hotel deLuxe', 274, '2019-08-17', 161, NULL),
('Hotel deLuxe', 274, '2019-08-18', 133, NULL),
('Hotel deLuxe', 274, '2019-08-19', 182, NULL),
('Hotel deLuxe', 274, '2019-08-20', 140, NULL),
('Hotel deLuxe', 274, '2019-08-21', 264, NULL),
('Hotel deLuxe', 274, '2019-08-22', 181, NULL),
('Hotel deLuxe', 274, '2019-08-23', 281, NULL),
('Hotel deLuxe', 274, '2019-08-24', 141, NULL),
('Hotel deLuxe', 274, '2019-08-25', 354, NULL),
('Hotel deLuxe', 274, '2019-08-26', 143, NULL),
('Hotel deLuxe', 274, '2019-08-27', 295, NULL),
('Hotel deLuxe', 274, '2019-08-28', 207, NULL),
('Hotel deLuxe', 274, '2019-08-29', 343, NULL),
('Hotel deLuxe', 274, '2019-08-30', 304, NULL),
('Hotel deLuxe', 274, '2019-08-31', 206, NULL),
('Hotel deLuxe', 274, '2019-09-01', 169, NULL),
('Hotel deLuxe', 274, '2019-09-02', 176, NULL),
('Hotel deLuxe', 274, '2019-09-03', 231, NULL),
('Hotel deLuxe', 274, '2019-09-04', 388, NULL),
('Hotel deLuxe', 274, '2019-09-05', 295, NULL),
('Hotel deLuxe', 274, '2019-09-06', 327, NULL),
('Hotel deLuxe', 274, '2019-09-07', 330, NULL),
('Hotel deLuxe', 274, '2019-09-08', 399, NULL),
('Hotel deLuxe', 274, '2019-09-09', 174, NULL),
('Hotel deLuxe', 274, '2019-09-10', 180, NULL),
('Hotel deLuxe', 274, '2019-09-11', 265, NULL),
('Hotel deLuxe', 274, '2019-09-12', 259, NULL),
('Hotel deLuxe', 274, '2019-09-13', 170, NULL),
('Hotel deLuxe', 274, '2019-09-14', 163, NULL),
('Hotel deLuxe', 274, '2019-09-15', 178, NULL),
('Hotel deLuxe', 274, '2019-09-16', 110, NULL),
('Hotel deLuxe', 274, '2019-09-17', 179, NULL),
('Hotel deLuxe', 274, '2019-09-18', 292, NULL),
('Hotel deLuxe', 274, '2019-09-19', 271, NULL),
('Hotel deLuxe', 274, '2019-09-20', 333, NULL),
('Hotel deLuxe', 274, '2019-09-21', 193, NULL),
('Hotel deLuxe', 274, '2019-09-22', 180, NULL),
('Hotel deLuxe', 274, '2019-09-23', 241, NULL),
('Hotel deLuxe', 274, '2019-09-24', 188, NULL),
('Hotel deLuxe', 274, '2019-09-25', 132, NULL),
('Hotel deLuxe', 274, '2019-09-26', 336, NULL),
('Hotel deLuxe', 274, '2019-09-27', 118, NULL),
('Hotel deLuxe', 274, '2019-09-28', 185, NULL),
('Hotel deLuxe', 274, '2019-09-29', 223, NULL),
('Hotel deLuxe', 274, '2019-09-30', 287, NULL),
('Hotel deLuxe', 274, '2019-10-01', 142, NULL),
('Hotel deLuxe', 274, '2019-10-02', 293, NULL),
('Hotel deLuxe', 274, '2019-10-03', 114, NULL),
('Hotel deLuxe', 274, '2019-10-04', 242, NULL),
('Hotel deLuxe', 274, '2019-10-05', 256, NULL),
('Hotel deLuxe', 274, '2019-10-06', 108, NULL),
('Hotel deLuxe', 274, '2019-10-07', 257, NULL),
('Hotel deLuxe', 274, '2019-10-08', 344, NULL),
('Hotel deLuxe', 274, '2019-10-09', 172, NULL),
('Hotel deLuxe', 274, '2019-10-10', 164, NULL),
('Hotel deLuxe', 274, '2019-10-11', 277, NULL),
('Hotel deLuxe', 274, '2019-10-12', 385, NULL),
('Hotel deLuxe', 274, '2019-10-13', 233, NULL),
('Hotel deLuxe', 274, '2019-10-14', 102, NULL),
('Hotel deLuxe', 274, '2019-10-15', 150, NULL),
('Hotel deLuxe', 274, '2019-10-16', 280, NULL),
('Hotel deLuxe', 274, '2019-10-17', 106, NULL),
('Hotel deLuxe', 274, '2019-10-18', 274, NULL),
('Hotel deLuxe', 274, '2019-10-19', 167, NULL),
('Hotel deLuxe', 274, '2019-10-20', 318, NULL),
('Hotel deLuxe', 274, '2019-10-21', 316, NULL),
('Hotel deLuxe', 274, '2019-10-22', 397, NULL),
('Hotel deLuxe', 274, '2019-10-23', 340, NULL),
('Hotel deLuxe', 274, '2019-10-24', 235, NULL),
('Hotel deLuxe', 274, '2019-10-25', 301, NULL),
('Hotel deLuxe', 274, '2019-10-26', 106, NULL),
('Hotel deLuxe', 274, '2019-10-27', 142, NULL),
('Hotel deLuxe', 274, '2019-10-28', 376, NULL),
('Hotel deLuxe', 274, '2019-10-29', 337, NULL),
('Hotel deLuxe', 274, '2019-10-30', 380, NULL),
('Hotel deLuxe', 274, '2019-10-31', 100, NULL),
('Hotel deLuxe', 274, '2019-11-01', 345, NULL),
('Hotel deLuxe', 274, '2019-11-02', 146, NULL),
('Hotel deLuxe', 274, '2019-11-03', 361, NULL),
('Hotel deLuxe', 274, '2019-11-04', 122, NULL),
('Hotel deLuxe', 274, '2019-11-05', 388, NULL),
('Hotel deLuxe', 274, '2019-11-06', 355, NULL),
('Hotel deLuxe', 274, '2019-11-07', 287, NULL),
('Hotel deLuxe', 274, '2019-11-08', 329, NULL),
('Hotel deLuxe', 274, '2019-11-09', 344, NULL),
('Hotel deLuxe', 274, '2019-11-10', 284, NULL),
('Hotel deLuxe', 274, '2019-11-11', 139, NULL),
('Hotel deLuxe', 274, '2019-11-12', 175, NULL),
('Hotel deLuxe', 274, '2019-11-13', 393, NULL),
('Hotel deLuxe', 274, '2019-11-14', 246, NULL),
('Hotel deLuxe', 274, '2019-11-15', 370, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Hotel deLuxe', 274, '2019-11-16', 239, NULL),
('Hotel deLuxe', 274, '2019-11-17', 297, NULL),
('Hotel deLuxe', 274, '2019-11-18', 268, NULL),
('Hotel deLuxe', 274, '2019-11-19', 386, NULL),
('Hotel deLuxe', 274, '2019-11-20', 325, NULL),
('Hotel deLuxe', 274, '2019-11-21', 230, NULL),
('Hotel deLuxe', 274, '2019-11-22', 305, NULL),
('Hotel deLuxe', 274, '2019-11-23', 396, NULL),
('Hotel deLuxe', 274, '2019-11-24', 353, NULL),
('Hotel deLuxe', 274, '2019-11-25', 281, NULL),
('Hotel deLuxe', 274, '2019-11-26', 165, NULL),
('Hotel deLuxe', 274, '2019-11-27', 105, NULL),
('Hotel deLuxe', 274, '2019-11-28', 189, NULL),
('Hotel deLuxe', 274, '2019-11-29', 369, NULL),
('Hotel deLuxe', 274, '2019-11-30', 136, NULL),
('Hotel deLuxe', 274, '2019-12-01', 344, NULL),
('Hotel deLuxe', 274, '2019-12-02', 254, NULL),
('Hotel deLuxe', 274, '2019-12-03', 259, NULL),
('Hotel deLuxe', 274, '2019-12-04', 345, NULL),
('Hotel deLuxe', 274, '2019-12-05', 134, NULL),
('Hotel deLuxe', 274, '2019-12-06', 340, NULL),
('Hotel deLuxe', 274, '2019-12-07', 251, NULL),
('Hotel deLuxe', 274, '2019-12-08', 190, NULL),
('Hotel deLuxe', 274, '2019-12-09', 231, NULL),
('Hotel deLuxe', 274, '2019-12-10', 226, NULL),
('Hotel deLuxe', 274, '2019-12-11', 280, NULL),
('Hotel deLuxe', 274, '2019-12-12', 106, NULL),
('Hotel deLuxe', 274, '2019-12-13', 239, NULL),
('Hotel deLuxe', 274, '2019-12-14', 398, NULL),
('Hotel deLuxe', 274, '2019-12-15', 112, NULL),
('Hotel deLuxe', 274, '2019-12-16', 371, NULL),
('Hotel deLuxe', 274, '2019-12-17', 241, NULL),
('Hotel deLuxe', 274, '2019-12-18', 238, NULL),
('Hotel deLuxe', 274, '2019-12-19', 370, NULL),
('Hotel deLuxe', 274, '2019-12-20', 173, NULL),
('Hotel deLuxe', 274, '2019-12-21', 152, NULL),
('Hotel deLuxe', 274, '2019-12-22', 254, NULL),
('Hotel deLuxe', 274, '2019-12-23', 141, NULL),
('Hotel deLuxe', 274, '2019-12-24', 129, NULL),
('Hotel deLuxe', 274, '2019-12-25', 397, NULL),
('Hotel deLuxe', 274, '2019-12-26', 119, NULL),
('Hotel deLuxe', 274, '2019-12-27', 395, NULL),
('Hotel deLuxe', 274, '2019-12-28', 372, NULL),
('Hotel deLuxe', 274, '2019-12-29', 174, NULL),
('Hotel deLuxe', 274, '2019-12-30', 276, NULL),
('Hotel deLuxe', 274, '2019-12-31', 127, NULL),
('Hotel deLuxe', 274, '2020-01-01', 351, NULL),
('Hotel deLuxe', 274, '2020-01-02', 329, NULL),
('Hotel deLuxe', 274, '2020-01-03', 343, NULL),
('Hotel deLuxe', 274, '2020-01-04', 218, NULL),
('Hotel deLuxe', 274, '2020-01-05', 135, NULL),
('Hotel deLuxe', 274, '2020-01-06', 309, NULL),
('Hotel deLuxe', 274, '2020-01-07', 214, NULL),
('Hotel deLuxe', 274, '2020-01-08', 368, NULL),
('Hotel deLuxe', 274, '2020-01-09', 367, NULL),
('Hotel deLuxe', 274, '2020-01-10', 390, NULL),
('Hotel deLuxe', 274, '2020-01-11', 390, NULL),
('Hotel deLuxe', 274, '2020-01-12', 103, NULL),
('Hotel deLuxe', 274, '2020-01-13', 274, NULL),
('Hotel deLuxe', 274, '2020-01-14', 305, NULL),
('Hotel deLuxe', 274, '2020-01-15', 249, NULL),
('Hotel deLuxe', 274, '2020-01-16', 231, NULL),
('Hotel deLuxe', 274, '2020-01-17', 153, NULL),
('Hotel deLuxe', 274, '2020-01-18', 239, NULL),
('Hotel deLuxe', 274, '2020-01-19', 365, NULL),
('Hotel deLuxe', 274, '2020-01-20', 317, NULL),
('Hotel deLuxe', 274, '2020-01-21', 101, NULL),
('Hotel deLuxe', 274, '2020-01-22', 327, NULL),
('Hotel deLuxe', 274, '2020-01-23', 345, NULL),
('Hotel deLuxe', 274, '2020-01-24', 238, NULL),
('Hotel deLuxe', 274, '2020-01-25', 341, NULL),
('Hotel deLuxe', 274, '2020-01-26', 398, NULL),
('Hotel deLuxe', 274, '2020-01-27', 231, NULL),
('Hotel deLuxe', 274, '2020-01-28', 212, NULL),
('Hotel deLuxe', 274, '2020-01-29', 321, NULL),
('Hotel deLuxe', 274, '2020-01-30', 303, NULL),
('Hotel deLuxe', 274, '2020-01-31', 313, NULL),
('Hotel deLuxe', 274, '2020-02-01', 101, NULL),
('Hotel deLuxe', 274, '2020-02-02', 267, NULL),
('Hotel deLuxe', 274, '2020-02-03', 216, NULL),
('Hotel deLuxe', 274, '2020-02-04', 225, NULL),
('Luxor', 3, '2019-01-01', 226, NULL),
('Luxor', 3, '2019-01-02', 342, NULL),
('Luxor', 3, '2019-01-03', 248, NULL),
('Luxor', 3, '2019-01-04', 376, NULL),
('Luxor', 3, '2019-01-05', 221, NULL),
('Luxor', 3, '2019-01-06', 358, NULL),
('Luxor', 3, '2019-01-07', 238, NULL),
('Luxor', 3, '2019-01-08', 392, NULL),
('Luxor', 3, '2019-01-09', 105, NULL),
('Luxor', 3, '2019-01-10', 192, 169),
('Luxor', 3, '2019-01-11', 204, 169),
('Luxor', 3, '2019-01-12', 386, 169),
('Luxor', 3, '2019-01-13', 114, 169),
('Luxor', 3, '2019-01-14', 182, 169),
('Luxor', 3, '2019-01-15', 161, NULL),
('Luxor', 3, '2019-01-16', 200, NULL),
('Luxor', 3, '2019-01-17', 312, NULL),
('Luxor', 3, '2019-01-18', 394, NULL),
('Luxor', 3, '2019-01-19', 215, NULL),
('Luxor', 3, '2019-01-20', 232, NULL),
('Luxor', 3, '2019-01-21', 391, NULL),
('Luxor', 3, '2019-01-22', 276, NULL),
('Luxor', 3, '2019-01-23', 147, NULL),
('Luxor', 3, '2019-01-24', 328, NULL),
('Luxor', 3, '2019-01-25', 361, NULL),
('Luxor', 3, '2019-01-26', 179, NULL),
('Luxor', 3, '2019-01-27', 318, NULL),
('Luxor', 3, '2019-01-28', 338, NULL),
('Luxor', 3, '2019-01-29', 251, NULL),
('Luxor', 3, '2019-01-30', 136, NULL),
('Luxor', 3, '2019-01-31', 127, NULL),
('Luxor', 3, '2019-02-01', 398, NULL),
('Luxor', 3, '2019-02-02', 108, NULL),
('Luxor', 3, '2019-02-03', 200, NULL),
('Luxor', 3, '2019-02-04', 243, NULL),
('Luxor', 3, '2019-02-05', 120, NULL),
('Luxor', 3, '2019-02-06', 198, NULL),
('Luxor', 3, '2019-02-07', 368, NULL),
('Luxor', 3, '2019-02-08', 161, NULL),
('Luxor', 3, '2019-02-09', 311, 115),
('Luxor', 3, '2019-02-10', 259, 115),
('Luxor', 3, '2019-02-11', 215, 115),
('Luxor', 3, '2019-02-12', 227, 115),
('Luxor', 3, '2019-02-13', 310, 115),
('Luxor', 3, '2019-02-14', 231, 115),
('Luxor', 3, '2019-02-15', 244, 115),
('Luxor', 3, '2019-02-16', 308, 115),
('Luxor', 3, '2019-02-17', 184, 115),
('Luxor', 3, '2019-02-18', 327, 115),
('Luxor', 3, '2019-02-19', 272, 115),
('Luxor', 3, '2019-02-20', 389, 115),
('Luxor', 3, '2019-02-21', 237, 115),
('Luxor', 3, '2019-02-22', 302, NULL),
('Luxor', 3, '2019-02-23', 240, NULL),
('Luxor', 3, '2019-02-24', 362, NULL),
('Luxor', 3, '2019-02-25', 292, NULL),
('Luxor', 3, '2019-02-26', 137, NULL),
('Luxor', 3, '2019-02-27', 353, NULL),
('Luxor', 3, '2019-02-28', 341, NULL),
('Luxor', 3, '2019-03-01', 181, NULL),
('Luxor', 3, '2019-03-02', 257, NULL),
('Luxor', 3, '2019-03-03', 258, NULL),
('Luxor', 3, '2019-03-04', 152, NULL),
('Luxor', 3, '2019-03-05', 344, NULL),
('Luxor', 3, '2019-03-06', 233, NULL),
('Luxor', 3, '2019-03-07', 188, NULL),
('Luxor', 3, '2019-03-08', 106, NULL),
('Luxor', 3, '2019-03-09', 100, NULL),
('Luxor', 3, '2019-03-10', 190, NULL),
('Luxor', 3, '2019-03-11', 330, 174),
('Luxor', 3, '2019-03-12', 223, 174),
('Luxor', 3, '2019-03-13', 131, 174),
('Luxor', 3, '2019-03-14', 186, 174),
('Luxor', 3, '2019-03-15', 222, 174),
('Luxor', 3, '2019-03-16', 320, 174),
('Luxor', 3, '2019-03-17', 237, 174),
('Luxor', 3, '2019-03-18', 365, 174),
('Luxor', 3, '2019-03-19', 383, 174),
('Luxor', 3, '2019-03-20', 136, 174),
('Luxor', 3, '2019-03-21', 154, 174),
('Luxor', 3, '2019-03-22', 268, 174),
('Luxor', 3, '2019-03-23', 327, 174),
('Luxor', 3, '2019-03-24', 318, 174),
('Luxor', 3, '2019-03-25', 262, 174),
('Luxor', 3, '2019-03-26', 278, 174),
('Luxor', 3, '2019-03-27', 299, 174),
('Luxor', 3, '2019-03-28', 137, 174),
('Luxor', 3, '2019-03-29', 206, 174),
('Luxor', 3, '2019-03-30', 134, NULL),
('Luxor', 3, '2019-03-31', 365, NULL),
('Luxor', 3, '2019-04-01', 221, NULL),
('Luxor', 3, '2019-04-02', 211, NULL),
('Luxor', 3, '2019-04-03', 148, NULL),
('Luxor', 3, '2019-04-04', 208, NULL),
('Luxor', 3, '2019-04-05', 250, NULL),
('Luxor', 3, '2019-04-06', 231, NULL),
('Luxor', 3, '2019-04-07', 241, NULL),
('Luxor', 3, '2019-04-08', 297, 12),
('Luxor', 3, '2019-04-09', 127, NULL),
('Luxor', 3, '2019-04-10', 120, NULL),
('Luxor', 3, '2019-04-11', 146, NULL),
('Luxor', 3, '2019-04-12', 280, NULL),
('Luxor', 3, '2019-04-13', 350, NULL),
('Luxor', 3, '2019-04-14', 315, NULL),
('Luxor', 3, '2019-04-15', 278, NULL),
('Luxor', 3, '2019-04-16', 349, NULL),
('Luxor', 3, '2019-04-17', 261, NULL),
('Luxor', 3, '2019-04-18', 261, NULL),
('Luxor', 3, '2019-04-19', 326, NULL),
('Luxor', 3, '2019-04-20', 107, NULL),
('Luxor', 3, '2019-04-21', 105, NULL),
('Luxor', 3, '2019-04-22', 175, NULL),
('Luxor', 3, '2019-04-23', 227, NULL),
('Luxor', 3, '2019-04-24', 319, NULL),
('Luxor', 3, '2019-04-25', 376, NULL),
('Luxor', 3, '2019-04-26', 114, NULL),
('Luxor', 3, '2019-04-27', 127, 47),
('Luxor', 3, '2019-04-28', 224, 47),
('Luxor', 3, '2019-04-29', 100, 47),
('Luxor', 3, '2019-04-30', 345, 47),
('Luxor', 3, '2019-05-01', 142, 47),
('Luxor', 3, '2019-05-02', 138, 47),
('Luxor', 3, '2019-05-03', 299, 47),
('Luxor', 3, '2019-05-04', 233, 47),
('Luxor', 3, '2019-05-05', 312, NULL),
('Luxor', 3, '2019-05-06', 376, NULL),
('Luxor', 3, '2019-05-07', 317, NULL),
('Luxor', 3, '2019-05-08', 267, NULL),
('Luxor', 3, '2019-05-09', 174, NULL),
('Luxor', 3, '2019-05-10', 307, NULL),
('Luxor', 3, '2019-05-11', 160, NULL),
('Luxor', 3, '2019-05-12', 374, 102),
('Luxor', 3, '2019-05-13', 321, 102),
('Luxor', 3, '2019-05-14', 140, 102),
('Luxor', 3, '2019-05-15', 399, 102),
('Luxor', 3, '2019-05-16', 232, 102),
('Luxor', 3, '2019-05-17', 175, 102),
('Luxor', 3, '2019-05-18', 386, 102),
('Luxor', 3, '2019-05-19', 116, 102),
('Luxor', 3, '2019-05-20', 254, 102),
('Luxor', 3, '2019-05-21', 201, 102),
('Luxor', 3, '2019-05-22', 207, 102),
('Luxor', 3, '2019-05-23', 201, 102),
('Luxor', 3, '2019-05-24', 313, 102),
('Luxor', 3, '2019-05-25', 223, 102),
('Luxor', 3, '2019-05-26', 380, 102),
('Luxor', 3, '2019-05-27', 217, 102),
('Luxor', 3, '2019-05-28', 200, 102),
('Luxor', 3, '2019-05-29', 358, 102),
('Luxor', 3, '2019-05-30', 195, 102),
('Luxor', 3, '2019-05-31', 162, 102),
('Luxor', 3, '2019-06-01', 208, 102),
('Luxor', 3, '2019-06-02', 198, 102),
('Luxor', 3, '2019-06-03', 245, 102),
('Luxor', 3, '2019-06-04', 260, 102),
('Luxor', 3, '2019-06-05', 309, 102),
('Luxor', 3, '2019-06-06', 193, NULL),
('Luxor', 3, '2019-06-07', 172, NULL),
('Luxor', 3, '2019-06-08', 137, NULL),
('Luxor', 3, '2019-06-09', 169, NULL),
('Luxor', 3, '2019-06-10', 304, NULL),
('Luxor', 3, '2019-06-11', 194, NULL),
('Luxor', 3, '2019-06-12', 233, 78),
('Luxor', 3, '2019-06-13', 256, 78),
('Luxor', 3, '2019-06-14', 363, 78),
('Luxor', 3, '2019-06-15', 283, 78),
('Luxor', 3, '2019-06-16', 328, 78),
('Luxor', 3, '2019-06-17', 100, 78),
('Luxor', 3, '2019-06-18', 290, 78),
('Luxor', 3, '2019-06-19', 326, 78),
('Luxor', 3, '2019-06-20', 300, 78),
('Luxor', 3, '2019-06-21', 317, 78),
('Luxor', 3, '2019-06-22', 145, 78),
('Luxor', 3, '2019-06-23', 183, 78),
('Luxor', 3, '2019-06-24', 173, 78),
('Luxor', 3, '2019-06-25', 161, 78),
('Luxor', 3, '2019-06-26', 139, 78),
('Luxor', 3, '2019-06-27', 109, 78),
('Luxor', 3, '2019-06-28', 281, 78),
('Luxor', 3, '2019-06-29', 220, 78),
('Luxor', 3, '2019-06-30', 283, 78),
('Luxor', 3, '2019-07-01', 144, 78),
('Luxor', 3, '2019-07-02', 136, 78),
('Luxor', 3, '2019-07-03', 356, 78),
('Luxor', 3, '2019-07-04', 271, 78),
('Luxor', 3, '2019-07-05', 114, 78),
('Luxor', 3, '2019-07-06', 185, 78),
('Luxor', 3, '2019-07-07', 392, 78),
('Luxor', 3, '2019-07-08', 318, 78),
('Luxor', 3, '2019-07-09', 172, 78),
('Luxor', 3, '2019-07-10', 254, 78),
('Luxor', 3, '2019-07-11', 118, NULL),
('Luxor', 3, '2019-07-12', 179, NULL),
('Luxor', 3, '2019-07-13', 264, NULL),
('Luxor', 3, '2019-07-14', 373, NULL),
('Luxor', 3, '2019-07-15', 169, NULL),
('Luxor', 3, '2019-07-16', 279, NULL),
('Luxor', 3, '2019-07-17', 330, NULL),
('Luxor', 3, '2019-07-18', 202, NULL),
('Luxor', 3, '2019-07-19', 157, NULL),
('Luxor', 3, '2019-07-20', 197, NULL),
('Luxor', 3, '2019-07-21', 120, NULL),
('Luxor', 3, '2019-07-22', 305, NULL),
('Luxor', 3, '2019-07-23', 369, NULL),
('Luxor', 3, '2019-07-24', 106, NULL),
('Luxor', 3, '2019-07-25', 258, NULL),
('Luxor', 3, '2019-07-26', 322, NULL),
('Luxor', 3, '2019-07-27', 282, NULL),
('Luxor', 3, '2019-07-28', 219, NULL),
('Luxor', 3, '2019-07-29', 384, NULL),
('Luxor', 3, '2019-07-30', 382, NULL),
('Luxor', 3, '2019-07-31', 327, NULL),
('Luxor', 3, '2019-08-01', 293, NULL),
('Luxor', 3, '2019-08-02', 230, NULL),
('Luxor', 3, '2019-08-03', 129, NULL),
('Luxor', 3, '2019-08-04', 238, NULL),
('Luxor', 3, '2019-08-05', 319, NULL),
('Luxor', 3, '2019-08-06', 369, NULL),
('Luxor', 3, '2019-08-07', 182, NULL),
('Luxor', 3, '2019-08-08', 178, NULL),
('Luxor', 3, '2019-08-09', 251, NULL),
('Luxor', 3, '2019-08-10', 175, NULL),
('Luxor', 3, '2019-08-11', 207, NULL),
('Luxor', 3, '2019-08-12', 115, NULL),
('Luxor', 3, '2019-08-13', 260, NULL),
('Luxor', 3, '2019-08-14', 398, NULL),
('Luxor', 3, '2019-08-15', 164, NULL),
('Luxor', 3, '2019-08-16', 365, NULL),
('Luxor', 3, '2019-08-17', 158, NULL),
('Luxor', 3, '2019-08-18', 301, NULL),
('Luxor', 3, '2019-08-19', 379, NULL),
('Luxor', 3, '2019-08-20', 265, 117),
('Luxor', 3, '2019-08-21', 361, 117),
('Luxor', 3, '2019-08-22', 164, 117),
('Luxor', 3, '2019-08-23', 320, 117),
('Luxor', 3, '2019-08-24', 271, 117),
('Luxor', 3, '2019-08-25', 317, 117),
('Luxor', 3, '2019-08-26', 185, 117),
('Luxor', 3, '2019-08-27', 348, 117),
('Luxor', 3, '2019-08-28', 323, 117),
('Luxor', 3, '2019-08-29', 176, 117),
('Luxor', 3, '2019-08-30', 175, 117),
('Luxor', 3, '2019-08-31', 200, 117),
('Luxor', 3, '2019-09-01', 193, 117),
('Luxor', 3, '2019-09-02', 319, 117),
('Luxor', 3, '2019-09-03', 304, 117),
('Luxor', 3, '2019-09-04', 261, 117),
('Luxor', 3, '2019-09-05', 248, 117),
('Luxor', 3, '2019-09-06', 137, 117),
('Luxor', 3, '2019-09-07', 323, 117),
('Luxor', 3, '2019-09-08', 159, 117),
('Luxor', 3, '2019-09-09', 260, 117),
('Luxor', 3, '2019-09-10', 372, 117),
('Luxor', 3, '2019-09-11', 133, 117),
('Luxor', 3, '2019-09-12', 393, 117),
('Luxor', 3, '2019-09-13', 397, 117),
('Luxor', 3, '2019-09-14', 378, 117),
('Luxor', 3, '2019-09-15', 369, 117),
('Luxor', 3, '2019-09-16', 281, 117),
('Luxor', 3, '2019-09-17', 163, 117),
('Luxor', 3, '2019-09-18', 328, NULL),
('Luxor', 3, '2019-09-19', 299, NULL),
('Luxor', 3, '2019-09-20', 144, NULL),
('Luxor', 3, '2019-09-21', 321, NULL),
('Luxor', 3, '2019-09-22', 364, NULL),
('Luxor', 3, '2019-09-23', 382, NULL),
('Luxor', 3, '2019-09-24', 315, NULL),
('Luxor', 3, '2019-09-25', 139, NULL),
('Luxor', 3, '2019-09-26', 194, NULL),
('Luxor', 3, '2019-09-27', 174, NULL),
('Luxor', 3, '2019-09-28', 127, NULL),
('Luxor', 3, '2019-09-29', 330, NULL),
('Luxor', 3, '2019-09-30', 388, NULL),
('Luxor', 3, '2019-10-01', 363, NULL),
('Luxor', 3, '2019-10-02', 330, NULL),
('Luxor', 3, '2019-10-03', 105, NULL),
('Luxor', 3, '2019-10-04', 294, NULL),
('Luxor', 3, '2019-10-05', 220, NULL),
('Luxor', 3, '2019-10-06', 166, NULL),
('Luxor', 3, '2019-10-07', 174, NULL),
('Luxor', 3, '2019-10-08', 243, NULL),
('Luxor', 3, '2019-10-09', 189, NULL),
('Luxor', 3, '2019-10-10', 392, NULL),
('Luxor', 3, '2019-10-11', 162, NULL),
('Luxor', 3, '2019-10-12', 184, NULL),
('Luxor', 3, '2019-10-13', 236, NULL),
('Luxor', 3, '2019-10-14', 254, 75),
('Luxor', 3, '2019-10-15', 225, 75),
('Luxor', 3, '2019-10-16', 126, 75),
('Luxor', 3, '2019-10-17', 270, 75),
('Luxor', 3, '2019-10-18', 167, 75),
('Luxor', 3, '2019-10-19', 188, 75),
('Luxor', 3, '2019-10-20', 325, 75),
('Luxor', 3, '2019-10-21', 263, 75),
('Luxor', 3, '2019-10-22', 156, 75),
('Luxor', 3, '2019-10-23', 191, 75),
('Luxor', 3, '2019-10-24', 343, 75),
('Luxor', 3, '2019-10-25', 391, 75),
('Luxor', 3, '2019-10-26', 351, 75),
('Luxor', 3, '2019-10-27', 225, 75),
('Luxor', 3, '2019-10-28', 206, 75),
('Luxor', 3, '2019-10-29', 186, 75),
('Luxor', 3, '2019-10-30', 141, 75),
('Luxor', 3, '2019-10-31', 353, 75),
('Luxor', 3, '2019-11-01', 360, 75),
('Luxor', 3, '2019-11-02', 117, 75),
('Luxor', 3, '2019-11-03', 180, 75),
('Luxor', 3, '2019-11-04', 179, 75),
('Luxor', 3, '2019-11-05', 386, 75),
('Luxor', 3, '2019-11-06', 150, 75),
('Luxor', 3, '2019-11-07', 233, 75),
('Luxor', 3, '2019-11-08', 322, 75),
('Luxor', 3, '2019-11-09', 248, 75),
('Luxor', 3, '2019-11-10', 354, NULL),
('Luxor', 3, '2019-11-11', 171, NULL),
('Luxor', 3, '2019-11-12', 278, NULL),
('Luxor', 3, '2019-11-13', 131, NULL),
('Luxor', 3, '2019-11-14', 307, NULL),
('Luxor', 3, '2019-11-15', 305, NULL),
('Luxor', 3, '2019-11-16', 354, NULL),
('Luxor', 3, '2019-11-17', 133, NULL),
('Luxor', 3, '2019-11-18', 231, NULL),
('Luxor', 3, '2019-11-19', 194, NULL),
('Luxor', 3, '2019-11-20', 202, NULL),
('Luxor', 3, '2019-11-21', 367, NULL),
('Luxor', 3, '2019-11-22', 367, NULL),
('Luxor', 3, '2019-11-23', 267, NULL),
('Luxor', 3, '2019-11-24', 313, NULL),
('Luxor', 3, '2019-11-25', 137, NULL),
('Luxor', 3, '2019-11-26', 339, NULL),
('Luxor', 3, '2019-11-27', 294, NULL),
('Luxor', 3, '2019-11-28', 163, NULL),
('Luxor', 3, '2019-11-29', 134, NULL),
('Luxor', 3, '2019-11-30', 355, NULL),
('Luxor', 3, '2019-12-01', 354, NULL),
('Luxor', 3, '2019-12-02', 294, NULL),
('Luxor', 3, '2019-12-03', 128, NULL),
('Luxor', 3, '2019-12-04', 127, NULL),
('Luxor', 3, '2019-12-05', 362, NULL),
('Luxor', 3, '2019-12-06', 117, NULL),
('Luxor', 3, '2019-12-07', 279, NULL),
('Luxor', 3, '2019-12-08', 271, NULL),
('Luxor', 3, '2019-12-09', 250, NULL),
('Luxor', 3, '2019-12-10', 146, NULL),
('Luxor', 3, '2019-12-11', 268, NULL),
('Luxor', 3, '2019-12-12', 214, NULL),
('Luxor', 3, '2019-12-13', 394, NULL),
('Luxor', 3, '2019-12-14', 272, NULL),
('Luxor', 3, '2019-12-15', 380, NULL),
('Luxor', 3, '2019-12-16', 182, NULL),
('Luxor', 3, '2019-12-17', 238, NULL),
('Luxor', 3, '2019-12-18', 133, NULL),
('Luxor', 3, '2019-12-19', 378, NULL),
('Luxor', 3, '2019-12-20', 141, NULL),
('Luxor', 3, '2019-12-21', 391, NULL),
('Luxor', 3, '2019-12-22', 396, NULL),
('Luxor', 3, '2019-12-23', 277, NULL),
('Luxor', 3, '2019-12-24', 152, NULL),
('Luxor', 3, '2019-12-25', 131, NULL),
('Luxor', 3, '2019-12-26', 218, NULL),
('Luxor', 3, '2019-12-27', 262, NULL),
('Luxor', 3, '2019-12-28', 319, NULL),
('Luxor', 3, '2019-12-29', 178, NULL),
('Luxor', 3, '2019-12-30', 359, NULL),
('Luxor', 3, '2019-12-31', 375, NULL),
('Luxor', 3, '2020-01-01', 318, NULL),
('Luxor', 3, '2020-01-02', 271, NULL),
('Luxor', 3, '2020-01-03', 304, NULL),
('Luxor', 3, '2020-01-04', 269, 17),
('Luxor', 3, '2020-01-05', 165, 17),
('Luxor', 3, '2020-01-06', 331, 17),
('Luxor', 3, '2020-01-07', 170, 17),
('Luxor', 3, '2020-01-08', 140, 17),
('Luxor', 3, '2020-01-09', 161, 17),
('Luxor', 3, '2020-01-10', 256, 17),
('Luxor', 3, '2020-01-11', 388, 17),
('Luxor', 3, '2020-01-12', 142, 17),
('Luxor', 3, '2020-01-13', 286, 17),
('Luxor', 3, '2020-01-14', 238, NULL),
('Luxor', 3, '2020-01-15', 242, NULL),
('Luxor', 3, '2020-01-16', 249, NULL),
('Luxor', 3, '2020-01-17', 133, NULL),
('Luxor', 3, '2020-01-18', 348, NULL),
('Luxor', 3, '2020-01-19', 204, NULL),
('Luxor', 3, '2020-01-20', 224, NULL),
('Luxor', 3, '2020-01-21', 372, NULL),
('Luxor', 3, '2020-01-22', 302, NULL),
('Luxor', 3, '2020-01-23', 303, NULL),
('Luxor', 3, '2020-01-24', 111, NULL),
('Luxor', 3, '2020-01-25', 229, NULL),
('Luxor', 3, '2020-01-26', 292, NULL),
('Luxor', 3, '2020-01-27', 299, NULL),
('Luxor', 3, '2020-01-28', 193, NULL),
('Luxor', 3, '2020-01-29', 100, NULL),
('Luxor', 3, '2020-01-30', 352, NULL),
('Luxor', 3, '2020-01-31', 181, NULL),
('Luxor', 3, '2020-02-01', 210, NULL),
('Luxor', 3, '2020-02-02', 290, NULL),
('Luxor', 3, '2020-02-03', 198, NULL),
('Luxor', 3, '2020-02-04', 157, NULL),
('Luxor', 23, '2019-01-01', 172, NULL),
('Luxor', 23, '2019-01-02', 176, NULL),
('Luxor', 23, '2019-01-03', 323, NULL),
('Luxor', 23, '2019-01-04', 367, NULL),
('Luxor', 23, '2019-01-05', 394, NULL),
('Luxor', 23, '2019-01-06', 345, NULL),
('Luxor', 23, '2019-01-07', 315, NULL),
('Luxor', 23, '2019-01-08', 388, NULL),
('Luxor', 23, '2019-01-09', 159, NULL),
('Luxor', 23, '2019-01-10', 304, NULL),
('Luxor', 23, '2019-01-11', 276, NULL),
('Luxor', 23, '2019-01-12', 116, NULL),
('Luxor', 23, '2019-01-13', 247, NULL),
('Luxor', 23, '2019-01-14', 151, NULL),
('Luxor', 23, '2019-01-15', 341, NULL),
('Luxor', 23, '2019-01-16', 137, NULL),
('Luxor', 23, '2019-01-17', 169, NULL),
('Luxor', 23, '2019-01-18', 341, NULL),
('Luxor', 23, '2019-01-19', 350, NULL),
('Luxor', 23, '2019-01-20', 290, NULL),
('Luxor', 23, '2019-01-21', 109, NULL),
('Luxor', 23, '2019-01-22', 374, NULL),
('Luxor', 23, '2019-01-23', 252, NULL),
('Luxor', 23, '2019-01-24', 149, NULL),
('Luxor', 23, '2019-01-25', 113, NULL),
('Luxor', 23, '2019-01-26', 305, NULL),
('Luxor', 23, '2019-01-27', 139, NULL),
('Luxor', 23, '2019-01-28', 239, NULL),
('Luxor', 23, '2019-01-29', 352, NULL),
('Luxor', 23, '2019-01-30', 313, NULL),
('Luxor', 23, '2019-01-31', 265, NULL),
('Luxor', 23, '2019-02-01', 106, NULL),
('Luxor', 23, '2019-02-02', 269, NULL),
('Luxor', 23, '2019-02-03', 174, NULL),
('Luxor', 23, '2019-02-04', 343, NULL),
('Luxor', 23, '2019-02-05', 152, NULL),
('Luxor', 23, '2019-02-06', 173, NULL),
('Luxor', 23, '2019-02-07', 142, NULL),
('Luxor', 23, '2019-02-08', 155, NULL),
('Luxor', 23, '2019-02-09', 392, NULL),
('Luxor', 23, '2019-02-10', 285, NULL),
('Luxor', 23, '2019-02-11', 277, NULL),
('Luxor', 23, '2019-02-12', 162, NULL),
('Luxor', 23, '2019-02-13', 236, NULL),
('Luxor', 23, '2019-02-14', 189, NULL),
('Luxor', 23, '2019-02-15', 311, NULL),
('Luxor', 23, '2019-02-16', 197, NULL),
('Luxor', 23, '2019-02-17', 211, NULL),
('Luxor', 23, '2019-02-18', 368, NULL),
('Luxor', 23, '2019-02-19', 308, NULL),
('Luxor', 23, '2019-02-20', 386, NULL),
('Luxor', 23, '2019-02-21', 137, NULL),
('Luxor', 23, '2019-02-22', 116, NULL),
('Luxor', 23, '2019-02-23', 295, NULL),
('Luxor', 23, '2019-02-24', 268, NULL),
('Luxor', 23, '2019-02-25', 332, NULL),
('Luxor', 23, '2019-02-26', 362, NULL),
('Luxor', 23, '2019-02-27', 197, NULL),
('Luxor', 23, '2019-02-28', 198, NULL),
('Luxor', 23, '2019-03-01', 246, NULL),
('Luxor', 23, '2019-03-02', 180, NULL),
('Luxor', 23, '2019-03-03', 369, NULL),
('Luxor', 23, '2019-03-04', 274, NULL),
('Luxor', 23, '2019-03-05', 107, NULL),
('Luxor', 23, '2019-03-06', 339, NULL),
('Luxor', 23, '2019-03-07', 251, NULL),
('Luxor', 23, '2019-03-08', 103, NULL),
('Luxor', 23, '2019-03-09', 214, NULL),
('Luxor', 23, '2019-03-10', 200, NULL),
('Luxor', 23, '2019-03-11', 209, NULL),
('Luxor', 23, '2019-03-12', 179, NULL),
('Luxor', 23, '2019-03-13', 276, NULL),
('Luxor', 23, '2019-03-14', 381, NULL),
('Luxor', 23, '2019-03-15', 371, NULL),
('Luxor', 23, '2019-03-16', 185, NULL),
('Luxor', 23, '2019-03-17', 229, NULL),
('Luxor', 23, '2019-03-18', 315, NULL),
('Luxor', 23, '2019-03-19', 335, NULL),
('Luxor', 23, '2019-03-20', 341, NULL),
('Luxor', 23, '2019-03-21', 273, NULL),
('Luxor', 23, '2019-03-22', 238, NULL),
('Luxor', 23, '2019-03-23', 189, NULL),
('Luxor', 23, '2019-03-24', 355, NULL),
('Luxor', 23, '2019-03-25', 268, NULL),
('Luxor', 23, '2019-03-26', 252, NULL),
('Luxor', 23, '2019-03-27', 386, NULL),
('Luxor', 23, '2019-03-28', 126, NULL),
('Luxor', 23, '2019-03-29', 190, NULL),
('Luxor', 23, '2019-03-30', 328, NULL),
('Luxor', 23, '2019-03-31', 391, NULL),
('Luxor', 23, '2019-04-01', 112, NULL),
('Luxor', 23, '2019-04-02', 176, NULL),
('Luxor', 23, '2019-04-03', 141, NULL),
('Luxor', 23, '2019-04-04', 107, NULL),
('Luxor', 23, '2019-04-05', 131, NULL),
('Luxor', 23, '2019-04-06', 355, NULL),
('Luxor', 23, '2019-04-07', 293, NULL),
('Luxor', 23, '2019-04-08', 221, NULL),
('Luxor', 23, '2019-04-09', 115, NULL),
('Luxor', 23, '2019-04-10', 326, NULL),
('Luxor', 23, '2019-04-11', 125, NULL),
('Luxor', 23, '2019-04-12', 154, NULL),
('Luxor', 23, '2019-04-13', 102, NULL),
('Luxor', 23, '2019-04-14', 354, NULL),
('Luxor', 23, '2019-04-15', 392, NULL),
('Luxor', 23, '2019-04-16', 273, NULL),
('Luxor', 23, '2019-04-17', 241, NULL),
('Luxor', 23, '2019-04-18', 168, NULL),
('Luxor', 23, '2019-04-19', 285, NULL),
('Luxor', 23, '2019-04-20', 196, NULL),
('Luxor', 23, '2019-04-21', 352, NULL),
('Luxor', 23, '2019-04-22', 291, NULL),
('Luxor', 23, '2019-04-23', 218, NULL),
('Luxor', 23, '2019-04-24', 162, NULL),
('Luxor', 23, '2019-04-25', 394, NULL),
('Luxor', 23, '2019-04-26', 359, NULL),
('Luxor', 23, '2019-04-27', 287, NULL),
('Luxor', 23, '2019-04-28', 392, NULL),
('Luxor', 23, '2019-04-29', 230, NULL),
('Luxor', 23, '2019-04-30', 345, NULL),
('Luxor', 23, '2019-05-01', 110, NULL),
('Luxor', 23, '2019-05-02', 243, NULL),
('Luxor', 23, '2019-05-03', 382, NULL),
('Luxor', 23, '2019-05-04', 131, NULL),
('Luxor', 23, '2019-05-05', 269, NULL),
('Luxor', 23, '2019-05-06', 112, NULL),
('Luxor', 23, '2019-05-07', 226, NULL),
('Luxor', 23, '2019-05-08', 378, NULL),
('Luxor', 23, '2019-05-09', 137, NULL),
('Luxor', 23, '2019-05-10', 246, NULL),
('Luxor', 23, '2019-05-11', 280, NULL),
('Luxor', 23, '2019-05-12', 120, NULL),
('Luxor', 23, '2019-05-13', 102, NULL),
('Luxor', 23, '2019-05-14', 350, NULL),
('Luxor', 23, '2019-05-15', 135, NULL),
('Luxor', 23, '2019-05-16', 351, NULL),
('Luxor', 23, '2019-05-17', 135, NULL),
('Luxor', 23, '2019-05-18', 102, NULL),
('Luxor', 23, '2019-05-19', 228, NULL),
('Luxor', 23, '2019-05-20', 218, NULL),
('Luxor', 23, '2019-05-21', 196, NULL),
('Luxor', 23, '2019-05-22', 392, NULL),
('Luxor', 23, '2019-05-23', 279, NULL),
('Luxor', 23, '2019-05-24', 395, NULL),
('Luxor', 23, '2019-05-25', 223, NULL),
('Luxor', 23, '2019-05-26', 306, NULL),
('Luxor', 23, '2019-05-27', 214, NULL),
('Luxor', 23, '2019-05-28', 305, NULL),
('Luxor', 23, '2019-05-29', 152, NULL),
('Luxor', 23, '2019-05-30', 360, NULL),
('Luxor', 23, '2019-05-31', 204, NULL),
('Luxor', 23, '2019-06-01', 106, NULL),
('Luxor', 23, '2019-06-02', 108, NULL),
('Luxor', 23, '2019-06-03', 165, NULL),
('Luxor', 23, '2019-06-04', 298, NULL),
('Luxor', 23, '2019-06-05', 241, NULL),
('Luxor', 23, '2019-06-06', 385, NULL),
('Luxor', 23, '2019-06-07', 179, NULL),
('Luxor', 23, '2019-06-08', 337, NULL),
('Luxor', 23, '2019-06-09', 375, NULL),
('Luxor', 23, '2019-06-10', 188, NULL),
('Luxor', 23, '2019-06-11', 103, 131),
('Luxor', 23, '2019-06-12', 236, 131),
('Luxor', 23, '2019-06-13', 157, 131),
('Luxor', 23, '2019-06-14', 240, 131),
('Luxor', 23, '2019-06-15', 232, 131),
('Luxor', 23, '2019-06-16', 361, 131),
('Luxor', 23, '2019-06-17', 330, 131),
('Luxor', 23, '2019-06-18', 363, 131),
('Luxor', 23, '2019-06-19', 349, 131),
('Luxor', 23, '2019-06-20', 229, 131),
('Luxor', 23, '2019-06-21', 187, 131),
('Luxor', 23, '2019-06-22', 144, 131),
('Luxor', 23, '2019-06-23', 164, 131),
('Luxor', 23, '2019-06-24', 202, 131),
('Luxor', 23, '2019-06-25', 209, 131),
('Luxor', 23, '2019-06-26', 303, 131),
('Luxor', 23, '2019-06-27', 276, 131),
('Luxor', 23, '2019-06-28', 175, NULL),
('Luxor', 23, '2019-06-29', 370, NULL),
('Luxor', 23, '2019-06-30', 335, NULL),
('Luxor', 23, '2019-07-01', 360, NULL),
('Luxor', 23, '2019-07-02', 391, NULL),
('Luxor', 23, '2019-07-03', 292, NULL),
('Luxor', 23, '2019-07-04', 345, NULL),
('Luxor', 23, '2019-07-05', 155, NULL),
('Luxor', 23, '2019-07-06', 132, NULL),
('Luxor', 23, '2019-07-07', 209, NULL),
('Luxor', 23, '2019-07-08', 394, NULL),
('Luxor', 23, '2019-07-09', 314, NULL),
('Luxor', 23, '2019-07-10', 237, NULL),
('Luxor', 23, '2019-07-11', 256, NULL),
('Luxor', 23, '2019-07-12', 152, NULL),
('Luxor', 23, '2019-07-13', 180, NULL),
('Luxor', 23, '2019-07-14', 271, NULL),
('Luxor', 23, '2019-07-15', 189, NULL),
('Luxor', 23, '2019-07-16', 210, NULL),
('Luxor', 23, '2019-07-17', 396, NULL),
('Luxor', 23, '2019-07-18', 192, NULL),
('Luxor', 23, '2019-07-19', 393, NULL),
('Luxor', 23, '2019-07-20', 177, NULL),
('Luxor', 23, '2019-07-21', 391, NULL),
('Luxor', 23, '2019-07-22', 243, NULL),
('Luxor', 23, '2019-07-23', 382, NULL),
('Luxor', 23, '2019-07-24', 292, NULL),
('Luxor', 23, '2019-07-25', 204, NULL),
('Luxor', 23, '2019-07-26', 386, NULL),
('Luxor', 23, '2019-07-27', 135, NULL),
('Luxor', 23, '2019-07-28', 230, NULL),
('Luxor', 23, '2019-07-29', 246, NULL),
('Luxor', 23, '2019-07-30', 330, NULL),
('Luxor', 23, '2019-07-31', 139, NULL),
('Luxor', 23, '2019-08-01', 232, NULL),
('Luxor', 23, '2019-08-02', 290, NULL),
('Luxor', 23, '2019-08-03', 351, NULL),
('Luxor', 23, '2019-08-04', 362, NULL),
('Luxor', 23, '2019-08-05', 287, 140),
('Luxor', 23, '2019-08-06', 129, 140),
('Luxor', 23, '2019-08-07', 264, 140),
('Luxor', 23, '2019-08-08', 317, 140),
('Luxor', 23, '2019-08-09', 366, 140),
('Luxor', 23, '2019-08-10', 267, 140),
('Luxor', 23, '2019-08-11', 103, 140),
('Luxor', 23, '2019-08-12', 306, 140),
('Luxor', 23, '2019-08-13', 163, 140),
('Luxor', 23, '2019-08-14', 339, 140),
('Luxor', 23, '2019-08-15', 392, 140),
('Luxor', 23, '2019-08-16', 361, 140),
('Luxor', 23, '2019-08-17', 207, 140),
('Luxor', 23, '2019-08-18', 108, 140),
('Luxor', 23, '2019-08-19', 348, 140),
('Luxor', 23, '2019-08-20', 205, 140),
('Luxor', 23, '2019-08-21', 316, 140),
('Luxor', 23, '2019-08-22', 179, 140),
('Luxor', 23, '2019-08-23', 357, 140),
('Luxor', 23, '2019-08-24', 236, NULL),
('Luxor', 23, '2019-08-25', 122, NULL),
('Luxor', 23, '2019-08-26', 396, NULL),
('Luxor', 23, '2019-08-27', 155, NULL),
('Luxor', 23, '2019-08-28', 296, NULL),
('Luxor', 23, '2019-08-29', 351, NULL),
('Luxor', 23, '2019-08-30', 165, NULL),
('Luxor', 23, '2019-08-31', 282, NULL),
('Luxor', 23, '2019-09-01', 356, NULL),
('Luxor', 23, '2019-09-02', 364, NULL),
('Luxor', 23, '2019-09-03', 126, NULL),
('Luxor', 23, '2019-09-04', 339, NULL),
('Luxor', 23, '2019-09-05', 256, NULL),
('Luxor', 23, '2019-09-06', 207, NULL),
('Luxor', 23, '2019-09-07', 228, NULL),
('Luxor', 23, '2019-09-08', 398, NULL),
('Luxor', 23, '2019-09-09', 379, NULL),
('Luxor', 23, '2019-09-10', 320, NULL),
('Luxor', 23, '2019-09-11', 373, NULL),
('Luxor', 23, '2019-09-12', 187, NULL),
('Luxor', 23, '2019-09-13', 174, NULL),
('Luxor', 23, '2019-09-14', 101, NULL),
('Luxor', 23, '2019-09-15', 312, NULL),
('Luxor', 23, '2019-09-16', 378, NULL),
('Luxor', 23, '2019-09-17', 177, NULL),
('Luxor', 23, '2019-09-18', 366, NULL),
('Luxor', 23, '2019-09-19', 281, NULL),
('Luxor', 23, '2019-09-20', 220, NULL),
('Luxor', 23, '2019-09-21', 330, NULL),
('Luxor', 23, '2019-09-22', 281, NULL),
('Luxor', 23, '2019-09-23', 189, NULL),
('Luxor', 23, '2019-09-24', 313, NULL),
('Luxor', 23, '2019-09-25', 198, NULL),
('Luxor', 23, '2019-09-26', 162, NULL),
('Luxor', 23, '2019-09-27', 118, NULL),
('Luxor', 23, '2019-09-28', 278, NULL),
('Luxor', 23, '2019-09-29', 282, NULL),
('Luxor', 23, '2019-09-30', 383, NULL),
('Luxor', 23, '2019-10-01', 390, NULL),
('Luxor', 23, '2019-10-02', 374, NULL),
('Luxor', 23, '2019-10-03', 384, NULL),
('Luxor', 23, '2019-10-04', 347, NULL),
('Luxor', 23, '2019-10-05', 232, NULL),
('Luxor', 23, '2019-10-06', 107, NULL),
('Luxor', 23, '2019-10-07', 300, NULL),
('Luxor', 23, '2019-10-08', 383, NULL),
('Luxor', 23, '2019-10-09', 331, NULL),
('Luxor', 23, '2019-10-10', 168, NULL),
('Luxor', 23, '2019-10-11', 178, NULL),
('Luxor', 23, '2019-10-12', 264, NULL),
('Luxor', 23, '2019-10-13', 379, 84),
('Luxor', 23, '2019-10-14', 266, 84),
('Luxor', 23, '2019-10-15', 275, 84),
('Luxor', 23, '2019-10-16', 291, 84),
('Luxor', 23, '2019-10-17', 334, 84),
('Luxor', 23, '2019-10-18', 214, 84),
('Luxor', 23, '2019-10-19', 336, 84),
('Luxor', 23, '2019-10-20', 275, 84),
('Luxor', 23, '2019-10-21', 268, 84),
('Luxor', 23, '2019-10-22', 387, 84),
('Luxor', 23, '2019-10-23', 136, 84),
('Luxor', 23, '2019-10-24', 308, 84),
('Luxor', 23, '2019-10-25', 354, 84),
('Luxor', 23, '2019-10-26', 137, 84),
('Luxor', 23, '2019-10-27', 301, 84),
('Luxor', 23, '2019-10-28', 105, 84),
('Luxor', 23, '2019-10-29', 121, NULL),
('Luxor', 23, '2019-10-30', 364, NULL),
('Luxor', 23, '2019-10-31', 168, NULL),
('Luxor', 23, '2019-11-01', 365, NULL),
('Luxor', 23, '2019-11-02', 349, NULL),
('Luxor', 23, '2019-11-03', 316, NULL),
('Luxor', 23, '2019-11-04', 131, NULL),
('Luxor', 23, '2019-11-05', 366, NULL),
('Luxor', 23, '2019-11-06', 188, NULL),
('Luxor', 23, '2019-11-07', 206, NULL),
('Luxor', 23, '2019-11-08', 221, 106),
('Luxor', 23, '2019-11-09', 106, NULL),
('Luxor', 23, '2019-11-10', 216, NULL),
('Luxor', 23, '2019-11-11', 335, NULL),
('Luxor', 23, '2019-11-12', 163, NULL),
('Luxor', 23, '2019-11-13', 276, NULL),
('Luxor', 23, '2019-11-14', 397, NULL),
('Luxor', 23, '2019-11-15', 315, NULL),
('Luxor', 23, '2019-11-16', 356, NULL),
('Luxor', 23, '2019-11-17', 275, NULL),
('Luxor', 23, '2019-11-18', 254, NULL),
('Luxor', 23, '2019-11-19', 313, NULL),
('Luxor', 23, '2019-11-20', 237, NULL),
('Luxor', 23, '2019-11-21', 146, NULL),
('Luxor', 23, '2019-11-22', 223, NULL),
('Luxor', 23, '2019-11-23', 349, NULL),
('Luxor', 23, '2019-11-24', 108, NULL),
('Luxor', 23, '2019-11-25', 345, NULL),
('Luxor', 23, '2019-11-26', 200, NULL),
('Luxor', 23, '2019-11-27', 154, NULL),
('Luxor', 23, '2019-11-28', 148, NULL),
('Luxor', 23, '2019-11-29', 364, NULL),
('Luxor', 23, '2019-11-30', 366, NULL),
('Luxor', 23, '2019-12-01', 340, NULL),
('Luxor', 23, '2019-12-02', 307, NULL),
('Luxor', 23, '2019-12-03', 363, NULL),
('Luxor', 23, '2019-12-04', 101, NULL),
('Luxor', 23, '2019-12-05', 110, NULL),
('Luxor', 23, '2019-12-06', 365, NULL),
('Luxor', 23, '2019-12-07', 244, NULL),
('Luxor', 23, '2019-12-08', 387, NULL),
('Luxor', 23, '2019-12-09', 160, NULL),
('Luxor', 23, '2019-12-10', 251, NULL),
('Luxor', 23, '2019-12-11', 398, NULL),
('Luxor', 23, '2019-12-12', 354, NULL),
('Luxor', 23, '2019-12-13', 255, NULL),
('Luxor', 23, '2019-12-14', 368, NULL),
('Luxor', 23, '2019-12-15', 264, NULL),
('Luxor', 23, '2019-12-16', 297, NULL),
('Luxor', 23, '2019-12-17', 370, NULL),
('Luxor', 23, '2019-12-18', 151, NULL),
('Luxor', 23, '2019-12-19', 381, NULL),
('Luxor', 23, '2019-12-20', 386, NULL),
('Luxor', 23, '2019-12-21', 202, NULL),
('Luxor', 23, '2019-12-22', 221, NULL),
('Luxor', 23, '2019-12-23', 261, NULL),
('Luxor', 23, '2019-12-24', 276, NULL),
('Luxor', 23, '2019-12-25', 267, 137),
('Luxor', 23, '2019-12-26', 332, 137),
('Luxor', 23, '2019-12-27', 327, 137),
('Luxor', 23, '2019-12-28', 381, 137),
('Luxor', 23, '2019-12-29', 266, 137),
('Luxor', 23, '2019-12-30', 270, 137),
('Luxor', 23, '2019-12-31', 193, 137),
('Luxor', 23, '2020-01-01', 138, 137),
('Luxor', 23, '2020-01-02', 265, 137),
('Luxor', 23, '2020-01-03', 392, 137),
('Luxor', 23, '2020-01-04', 290, 137),
('Luxor', 23, '2020-01-05', 321, 137),
('Luxor', 23, '2020-01-06', 329, 137),
('Luxor', 23, '2020-01-07', 108, 137),
('Luxor', 23, '2020-01-08', 397, 137),
('Luxor', 23, '2020-01-09', 208, 137),
('Luxor', 23, '2020-01-10', 310, 137),
('Luxor', 23, '2020-01-11', 369, 137),
('Luxor', 23, '2020-01-12', 302, 137),
('Luxor', 23, '2020-01-13', 208, 137),
('Luxor', 23, '2020-01-14', 176, 137),
('Luxor', 23, '2020-01-15', 362, 137),
('Luxor', 23, '2020-01-16', 151, 137),
('Luxor', 23, '2020-01-17', 108, 137),
('Luxor', 23, '2020-01-18', 323, NULL),
('Luxor', 23, '2020-01-19', 128, NULL),
('Luxor', 23, '2020-01-20', 371, NULL),
('Luxor', 23, '2020-01-21', 258, NULL),
('Luxor', 23, '2020-01-22', 127, NULL),
('Luxor', 23, '2020-01-23', 382, NULL),
('Luxor', 23, '2020-01-24', 341, NULL),
('Luxor', 23, '2020-01-25', 323, NULL),
('Luxor', 23, '2020-01-26', 164, NULL),
('Luxor', 23, '2020-01-27', 102, NULL),
('Luxor', 23, '2020-01-28', 231, NULL),
('Luxor', 23, '2020-01-29', 340, NULL),
('Luxor', 23, '2020-01-30', 153, NULL),
('Luxor', 23, '2020-01-31', 166, NULL),
('Luxor', 23, '2020-02-01', 346, NULL),
('Luxor', 23, '2020-02-02', 248, NULL),
('Luxor', 23, '2020-02-03', 243, NULL),
('Luxor', 23, '2020-02-04', 308, NULL),
('Luxor', 26, '2019-01-01', 381, NULL),
('Luxor', 26, '2019-01-02', 353, NULL),
('Luxor', 26, '2019-01-03', 174, NULL),
('Luxor', 26, '2019-01-04', 307, NULL),
('Luxor', 26, '2019-01-05', 305, NULL),
('Luxor', 26, '2019-01-06', 250, NULL),
('Luxor', 26, '2019-01-07', 161, NULL),
('Luxor', 26, '2019-01-08', 362, NULL),
('Luxor', 26, '2019-01-09', 380, NULL),
('Luxor', 26, '2019-01-10', 244, NULL),
('Luxor', 26, '2019-01-11', 369, NULL),
('Luxor', 26, '2019-01-12', 219, NULL),
('Luxor', 26, '2019-01-13', 195, NULL),
('Luxor', 26, '2019-01-14', 109, NULL),
('Luxor', 26, '2019-01-15', 222, NULL),
('Luxor', 26, '2019-01-16', 285, NULL),
('Luxor', 26, '2019-01-17', 110, NULL),
('Luxor', 26, '2019-01-18', 123, NULL),
('Luxor', 26, '2019-01-19', 106, NULL),
('Luxor', 26, '2019-01-20', 354, NULL),
('Luxor', 26, '2019-01-21', 170, NULL),
('Luxor', 26, '2019-01-22', 342, NULL),
('Luxor', 26, '2019-01-23', 121, NULL),
('Luxor', 26, '2019-01-24', 258, NULL),
('Luxor', 26, '2019-01-25', 283, NULL),
('Luxor', 26, '2019-01-26', 288, NULL),
('Luxor', 26, '2019-01-27', 241, NULL),
('Luxor', 26, '2019-01-28', 378, NULL),
('Luxor', 26, '2019-01-29', 308, NULL),
('Luxor', 26, '2019-01-30', 158, NULL),
('Luxor', 26, '2019-01-31', 246, NULL),
('Luxor', 26, '2019-02-01', 137, NULL),
('Luxor', 26, '2019-02-02', 321, NULL),
('Luxor', 26, '2019-02-03', 172, NULL),
('Luxor', 26, '2019-02-04', 288, NULL),
('Luxor', 26, '2019-02-05', 304, NULL),
('Luxor', 26, '2019-02-06', 174, NULL),
('Luxor', 26, '2019-02-07', 107, NULL),
('Luxor', 26, '2019-02-08', 189, NULL),
('Luxor', 26, '2019-02-09', 327, NULL),
('Luxor', 26, '2019-02-10', 252, NULL),
('Luxor', 26, '2019-02-11', 341, NULL),
('Luxor', 26, '2019-02-12', 331, NULL),
('Luxor', 26, '2019-02-13', 151, NULL),
('Luxor', 26, '2019-02-14', 153, NULL),
('Luxor', 26, '2019-02-15', 123, NULL),
('Luxor', 26, '2019-02-16', 261, NULL),
('Luxor', 26, '2019-02-17', 103, NULL),
('Luxor', 26, '2019-02-18', 157, NULL),
('Luxor', 26, '2019-02-19', 325, NULL),
('Luxor', 26, '2019-02-20', 360, NULL),
('Luxor', 26, '2019-02-21', 173, NULL),
('Luxor', 26, '2019-02-22', 175, NULL),
('Luxor', 26, '2019-02-23', 356, NULL),
('Luxor', 26, '2019-02-24', 154, NULL),
('Luxor', 26, '2019-02-25', 385, NULL),
('Luxor', 26, '2019-02-26', 398, NULL),
('Luxor', 26, '2019-02-27', 126, NULL),
('Luxor', 26, '2019-02-28', 166, NULL),
('Luxor', 26, '2019-03-01', 288, NULL),
('Luxor', 26, '2019-03-02', 330, NULL),
('Luxor', 26, '2019-03-03', 370, NULL),
('Luxor', 26, '2019-03-04', 217, NULL),
('Luxor', 26, '2019-03-05', 306, NULL),
('Luxor', 26, '2019-03-06', 295, NULL),
('Luxor', 26, '2019-03-07', 289, NULL),
('Luxor', 26, '2019-03-08', 397, NULL),
('Luxor', 26, '2019-03-09', 370, NULL),
('Luxor', 26, '2019-03-10', 330, NULL),
('Luxor', 26, '2019-03-11', 254, NULL),
('Luxor', 26, '2019-03-12', 125, NULL),
('Luxor', 26, '2019-03-13', 289, NULL),
('Luxor', 26, '2019-03-14', 349, NULL),
('Luxor', 26, '2019-03-15', 188, NULL),
('Luxor', 26, '2019-03-16', 165, NULL),
('Luxor', 26, '2019-03-17', 336, NULL),
('Luxor', 26, '2019-03-18', 381, NULL),
('Luxor', 26, '2019-03-19', 124, NULL),
('Luxor', 26, '2019-03-20', 297, NULL),
('Luxor', 26, '2019-03-21', 205, NULL),
('Luxor', 26, '2019-03-22', 287, NULL),
('Luxor', 26, '2019-03-23', 162, NULL),
('Luxor', 26, '2019-03-24', 124, NULL),
('Luxor', 26, '2019-03-25', 152, NULL),
('Luxor', 26, '2019-03-26', 325, NULL),
('Luxor', 26, '2019-03-27', 335, NULL),
('Luxor', 26, '2019-03-28', 116, NULL),
('Luxor', 26, '2019-03-29', 235, NULL),
('Luxor', 26, '2019-03-30', 240, NULL),
('Luxor', 26, '2019-03-31', 161, NULL),
('Luxor', 26, '2019-04-01', 100, NULL),
('Luxor', 26, '2019-04-02', 145, NULL),
('Luxor', 26, '2019-04-03', 159, NULL),
('Luxor', 26, '2019-04-04', 112, NULL),
('Luxor', 26, '2019-04-05', 106, NULL),
('Luxor', 26, '2019-04-06', 382, NULL),
('Luxor', 26, '2019-04-07', 342, NULL),
('Luxor', 26, '2019-04-08', 117, NULL),
('Luxor', 26, '2019-04-09', 395, NULL),
('Luxor', 26, '2019-04-10', 268, NULL),
('Luxor', 26, '2019-04-11', 389, NULL),
('Luxor', 26, '2019-04-12', 131, NULL),
('Luxor', 26, '2019-04-13', 258, NULL),
('Luxor', 26, '2019-04-14', 126, NULL),
('Luxor', 26, '2019-04-15', 125, NULL),
('Luxor', 26, '2019-04-16', 220, NULL),
('Luxor', 26, '2019-04-17', 323, NULL),
('Luxor', 26, '2019-04-18', 259, NULL),
('Luxor', 26, '2019-04-19', 347, NULL),
('Luxor', 26, '2019-04-20', 261, NULL),
('Luxor', 26, '2019-04-21', 144, NULL),
('Luxor', 26, '2019-04-22', 230, NULL),
('Luxor', 26, '2019-04-23', 309, NULL),
('Luxor', 26, '2019-04-24', 355, NULL),
('Luxor', 26, '2019-04-25', 142, NULL),
('Luxor', 26, '2019-04-26', 151, NULL),
('Luxor', 26, '2019-04-27', 358, NULL),
('Luxor', 26, '2019-04-28', 288, NULL),
('Luxor', 26, '2019-04-29', 149, NULL),
('Luxor', 26, '2019-04-30', 288, NULL),
('Luxor', 26, '2019-05-01', 325, NULL),
('Luxor', 26, '2019-05-02', 100, NULL),
('Luxor', 26, '2019-05-03', 315, NULL),
('Luxor', 26, '2019-05-04', 157, NULL),
('Luxor', 26, '2019-05-05', 309, NULL),
('Luxor', 26, '2019-05-06', 233, NULL),
('Luxor', 26, '2019-05-07', 380, NULL),
('Luxor', 26, '2019-05-08', 389, NULL),
('Luxor', 26, '2019-05-09', 365, NULL),
('Luxor', 26, '2019-05-10', 206, NULL),
('Luxor', 26, '2019-05-11', 220, NULL),
('Luxor', 26, '2019-05-12', 281, NULL),
('Luxor', 26, '2019-05-13', 348, NULL),
('Luxor', 26, '2019-05-14', 330, NULL),
('Luxor', 26, '2019-05-15', 277, NULL),
('Luxor', 26, '2019-05-16', 358, NULL),
('Luxor', 26, '2019-05-17', 348, NULL),
('Luxor', 26, '2019-05-18', 153, NULL),
('Luxor', 26, '2019-05-19', 394, NULL),
('Luxor', 26, '2019-05-20', 227, NULL),
('Luxor', 26, '2019-05-21', 275, NULL),
('Luxor', 26, '2019-05-22', 342, NULL),
('Luxor', 26, '2019-05-23', 393, NULL),
('Luxor', 26, '2019-05-24', 336, NULL),
('Luxor', 26, '2019-05-25', 345, NULL),
('Luxor', 26, '2019-05-26', 289, NULL),
('Luxor', 26, '2019-05-27', 322, NULL),
('Luxor', 26, '2019-05-28', 227, NULL),
('Luxor', 26, '2019-05-29', 188, NULL),
('Luxor', 26, '2019-05-30', 215, NULL),
('Luxor', 26, '2019-05-31', 134, NULL),
('Luxor', 26, '2019-06-01', 108, NULL),
('Luxor', 26, '2019-06-02', 145, NULL),
('Luxor', 26, '2019-06-03', 289, NULL),
('Luxor', 26, '2019-06-04', 313, NULL),
('Luxor', 26, '2019-06-05', 177, NULL),
('Luxor', 26, '2019-06-06', 345, NULL),
('Luxor', 26, '2019-06-07', 278, NULL),
('Luxor', 26, '2019-06-08', 276, NULL),
('Luxor', 26, '2019-06-09', 371, NULL),
('Luxor', 26, '2019-06-10', 232, NULL),
('Luxor', 26, '2019-06-11', 135, NULL),
('Luxor', 26, '2019-06-12', 382, NULL),
('Luxor', 26, '2019-06-13', 220, NULL),
('Luxor', 26, '2019-06-14', 310, NULL),
('Luxor', 26, '2019-06-15', 212, NULL),
('Luxor', 26, '2019-06-16', 123, NULL),
('Luxor', 26, '2019-06-17', 351, NULL),
('Luxor', 26, '2019-06-18', 246, NULL),
('Luxor', 26, '2019-06-19', 370, NULL),
('Luxor', 26, '2019-06-20', 145, NULL),
('Luxor', 26, '2019-06-21', 185, NULL),
('Luxor', 26, '2019-06-22', 187, NULL),
('Luxor', 26, '2019-06-23', 171, NULL),
('Luxor', 26, '2019-06-24', 393, NULL),
('Luxor', 26, '2019-06-25', 165, 133),
('Luxor', 26, '2019-06-26', 399, 133),
('Luxor', 26, '2019-06-27', 353, 133),
('Luxor', 26, '2019-06-28', 233, 133),
('Luxor', 26, '2019-06-29', 192, 133),
('Luxor', 26, '2019-06-30', 123, 133),
('Luxor', 26, '2019-07-01', 366, 133),
('Luxor', 26, '2019-07-02', 248, 133),
('Luxor', 26, '2019-07-03', 293, 133),
('Luxor', 26, '2019-07-04', 212, 133),
('Luxor', 26, '2019-07-05', 332, 133),
('Luxor', 26, '2019-07-06', 303, 133),
('Luxor', 26, '2019-07-07', 368, 133),
('Luxor', 26, '2019-07-08', 317, 133),
('Luxor', 26, '2019-07-09', 353, 133),
('Luxor', 26, '2019-07-10', 325, 133),
('Luxor', 26, '2019-07-11', 224, 133),
('Luxor', 26, '2019-07-12', 123, 133),
('Luxor', 26, '2019-07-13', 307, 133),
('Luxor', 26, '2019-07-14', 136, 133),
('Luxor', 26, '2019-07-15', 338, 133),
('Luxor', 26, '2019-07-16', 113, 133),
('Luxor', 26, '2019-07-17', 288, 133),
('Luxor', 26, '2019-07-18', 257, 133),
('Luxor', 26, '2019-07-19', 192, 133),
('Luxor', 26, '2019-07-20', 194, 133),
('Luxor', 26, '2019-07-21', 292, 133),
('Luxor', 26, '2019-07-22', 198, 133),
('Luxor', 26, '2019-07-23', 103, 133),
('Luxor', 26, '2019-07-24', 145, 133),
('Luxor', 26, '2019-07-25', 148, NULL),
('Luxor', 26, '2019-07-26', 266, NULL),
('Luxor', 26, '2019-07-27', 331, NULL),
('Luxor', 26, '2019-07-28', 395, NULL),
('Luxor', 26, '2019-07-29', 276, 192),
('Luxor', 26, '2019-07-30', 101, 192),
('Luxor', 26, '2019-07-31', 216, 192),
('Luxor', 26, '2019-08-01', 179, 192),
('Luxor', 26, '2019-08-02', 358, 192),
('Luxor', 26, '2019-08-03', 370, 192),
('Luxor', 26, '2019-08-04', 397, 192),
('Luxor', 26, '2019-08-05', 379, 192),
('Luxor', 26, '2019-08-06', 338, 192),
('Luxor', 26, '2019-08-07', 374, 192),
('Luxor', 26, '2019-08-08', 352, 192),
('Luxor', 26, '2019-08-09', 377, 192),
('Luxor', 26, '2019-08-10', 109, 192),
('Luxor', 26, '2019-08-11', 394, 192),
('Luxor', 26, '2019-08-12', 188, 192),
('Luxor', 26, '2019-08-13', 237, 192),
('Luxor', 26, '2019-08-14', 105, 192),
('Luxor', 26, '2019-08-15', 169, 192),
('Luxor', 26, '2019-08-16', 310, 192),
('Luxor', 26, '2019-08-17', 161, 192),
('Luxor', 26, '2019-08-18', 136, 192),
('Luxor', 26, '2019-08-19', 204, 192),
('Luxor', 26, '2019-08-20', 130, 192),
('Luxor', 26, '2019-08-21', 394, 192),
('Luxor', 26, '2019-08-22', 304, 192),
('Luxor', 26, '2019-08-23', 124, NULL),
('Luxor', 26, '2019-08-24', 266, NULL),
('Luxor', 26, '2019-08-25', 160, NULL),
('Luxor', 26, '2019-08-26', 127, NULL),
('Luxor', 26, '2019-08-27', 230, NULL),
('Luxor', 26, '2019-08-28', 112, NULL),
('Luxor', 26, '2019-08-29', 231, NULL),
('Luxor', 26, '2019-08-30', 199, NULL),
('Luxor', 26, '2019-08-31', 113, NULL),
('Luxor', 26, '2019-09-01', 202, NULL),
('Luxor', 26, '2019-09-02', 166, NULL),
('Luxor', 26, '2019-09-03', 220, NULL),
('Luxor', 26, '2019-09-04', 215, NULL),
('Luxor', 26, '2019-09-05', 136, NULL),
('Luxor', 26, '2019-09-06', 226, NULL),
('Luxor', 26, '2019-09-07', 372, NULL),
('Luxor', 26, '2019-09-08', 215, NULL),
('Luxor', 26, '2019-09-09', 116, NULL),
('Luxor', 26, '2019-09-10', 387, NULL),
('Luxor', 26, '2019-09-11', 168, NULL),
('Luxor', 26, '2019-09-12', 257, NULL),
('Luxor', 26, '2019-09-13', 179, NULL),
('Luxor', 26, '2019-09-14', 171, NULL),
('Luxor', 26, '2019-09-15', 355, NULL),
('Luxor', 26, '2019-09-16', 348, NULL),
('Luxor', 26, '2019-09-17', 299, NULL),
('Luxor', 26, '2019-09-18', 145, NULL),
('Luxor', 26, '2019-09-19', 111, NULL),
('Luxor', 26, '2019-09-20', 270, NULL),
('Luxor', 26, '2019-09-21', 284, NULL),
('Luxor', 26, '2019-09-22', 213, NULL),
('Luxor', 26, '2019-09-23', 298, NULL),
('Luxor', 26, '2019-09-24', 222, NULL),
('Luxor', 26, '2019-09-25', 175, NULL),
('Luxor', 26, '2019-09-26', 127, NULL),
('Luxor', 26, '2019-09-27', 269, 142),
('Luxor', 26, '2019-09-28', 311, 142),
('Luxor', 26, '2019-09-29', 320, 142),
('Luxor', 26, '2019-09-30', 352, 142),
('Luxor', 26, '2019-10-01', 162, 142),
('Luxor', 26, '2019-10-02', 178, 142),
('Luxor', 26, '2019-10-03', 306, 142),
('Luxor', 26, '2019-10-04', 150, 142),
('Luxor', 26, '2019-10-05', 399, 142),
('Luxor', 26, '2019-10-06', 240, 142),
('Luxor', 26, '2019-10-07', 279, 142),
('Luxor', 26, '2019-10-08', 189, 142),
('Luxor', 26, '2019-10-09', 386, 142),
('Luxor', 26, '2019-10-10', 163, 142),
('Luxor', 26, '2019-10-11', 306, 142),
('Luxor', 26, '2019-10-12', 371, 142),
('Luxor', 26, '2019-10-13', 189, 142),
('Luxor', 26, '2019-10-14', 165, 142),
('Luxor', 26, '2019-10-15', 299, NULL),
('Luxor', 26, '2019-10-16', 377, NULL),
('Luxor', 26, '2019-10-17', 159, NULL),
('Luxor', 26, '2019-10-18', 168, NULL),
('Luxor', 26, '2019-10-19', 120, NULL),
('Luxor', 26, '2019-10-20', 301, NULL),
('Luxor', 26, '2019-10-21', 150, NULL),
('Luxor', 26, '2019-10-22', 167, 129),
('Luxor', 26, '2019-10-23', 308, 129),
('Luxor', 26, '2019-10-24', 114, 129),
('Luxor', 26, '2019-10-25', 198, 129),
('Luxor', 26, '2019-10-26', 131, 129),
('Luxor', 26, '2019-10-27', 132, 129),
('Luxor', 26, '2019-10-28', 107, 129),
('Luxor', 26, '2019-10-29', 245, 129),
('Luxor', 26, '2019-10-30', 399, 129),
('Luxor', 26, '2019-10-31', 281, 129),
('Luxor', 26, '2019-11-01', 346, 129),
('Luxor', 26, '2019-11-02', 392, 129),
('Luxor', 26, '2019-11-03', 342, 129),
('Luxor', 26, '2019-11-04', 318, 129),
('Luxor', 26, '2019-11-05', 274, 129),
('Luxor', 26, '2019-11-06', 389, NULL),
('Luxor', 26, '2019-11-07', 231, NULL),
('Luxor', 26, '2019-11-08', 340, NULL),
('Luxor', 26, '2019-11-09', 290, NULL),
('Luxor', 26, '2019-11-10', 221, NULL),
('Luxor', 26, '2019-11-11', 164, NULL),
('Luxor', 26, '2019-11-12', 181, NULL),
('Luxor', 26, '2019-11-13', 288, NULL),
('Luxor', 26, '2019-11-14', 366, NULL),
('Luxor', 26, '2019-11-15', 263, NULL),
('Luxor', 26, '2019-11-16', 319, NULL),
('Luxor', 26, '2019-11-17', 275, NULL),
('Luxor', 26, '2019-11-18', 175, NULL),
('Luxor', 26, '2019-11-19', 283, NULL),
('Luxor', 26, '2019-11-20', 181, NULL),
('Luxor', 26, '2019-11-21', 129, NULL),
('Luxor', 26, '2019-11-22', 211, NULL),
('Luxor', 26, '2019-11-23', 244, NULL),
('Luxor', 26, '2019-11-24', 100, NULL),
('Luxor', 26, '2019-11-25', 315, NULL),
('Luxor', 26, '2019-11-26', 181, NULL),
('Luxor', 26, '2019-11-27', 392, NULL),
('Luxor', 26, '2019-11-28', 153, NULL),
('Luxor', 26, '2019-11-29', 117, NULL),
('Luxor', 26, '2019-11-30', 367, NULL),
('Luxor', 26, '2019-12-01', 239, NULL),
('Luxor', 26, '2019-12-02', 256, NULL),
('Luxor', 26, '2019-12-03', 132, NULL),
('Luxor', 26, '2019-12-04', 322, NULL),
('Luxor', 26, '2019-12-05', 263, NULL),
('Luxor', 26, '2019-12-06', 173, NULL),
('Luxor', 26, '2019-12-07', 283, NULL),
('Luxor', 26, '2019-12-08', 121, NULL),
('Luxor', 26, '2019-12-09', 250, NULL),
('Luxor', 26, '2019-12-10', 120, NULL),
('Luxor', 26, '2019-12-11', 187, NULL),
('Luxor', 26, '2019-12-12', 129, NULL),
('Luxor', 26, '2019-12-13', 295, NULL),
('Luxor', 26, '2019-12-14', 323, NULL),
('Luxor', 26, '2019-12-15', 379, NULL),
('Luxor', 26, '2019-12-16', 240, NULL),
('Luxor', 26, '2019-12-17', 136, NULL),
('Luxor', 26, '2019-12-18', 256, NULL),
('Luxor', 26, '2019-12-19', 372, NULL),
('Luxor', 26, '2019-12-20', 209, NULL),
('Luxor', 26, '2019-12-21', 335, NULL),
('Luxor', 26, '2019-12-22', 116, NULL),
('Luxor', 26, '2019-12-23', 376, 176),
('Luxor', 26, '2019-12-24', 222, 176),
('Luxor', 26, '2019-12-25', 243, 176),
('Luxor', 26, '2019-12-26', 308, 176),
('Luxor', 26, '2019-12-27', 151, 176),
('Luxor', 26, '2019-12-28', 249, 176),
('Luxor', 26, '2019-12-29', 100, 176),
('Luxor', 26, '2019-12-30', 170, 176),
('Luxor', 26, '2019-12-31', 340, 176),
('Luxor', 26, '2020-01-01', 237, 176),
('Luxor', 26, '2020-01-02', 116, 176),
('Luxor', 26, '2020-01-03', 349, 176),
('Luxor', 26, '2020-01-04', 245, 176),
('Luxor', 26, '2020-01-05', 110, 176),
('Luxor', 26, '2020-01-06', 251, 176),
('Luxor', 26, '2020-01-07', 230, 176),
('Luxor', 26, '2020-01-08', 267, 176),
('Luxor', 26, '2020-01-09', 156, 176),
('Luxor', 26, '2020-01-10', 384, 176),
('Luxor', 26, '2020-01-11', 282, 176),
('Luxor', 26, '2020-01-12', 385, 176),
('Luxor', 26, '2020-01-13', 382, 176),
('Luxor', 26, '2020-01-14', 364, 176),
('Luxor', 26, '2020-01-15', 388, 176),
('Luxor', 26, '2020-01-16', 209, 176),
('Luxor', 26, '2020-01-17', 342, 176),
('Luxor', 26, '2020-01-18', 170, 176),
('Luxor', 26, '2020-01-19', 227, 176),
('Luxor', 26, '2020-01-20', 184, NULL),
('Luxor', 26, '2020-01-21', 375, NULL),
('Luxor', 26, '2020-01-22', 231, NULL),
('Luxor', 26, '2020-01-23', 301, NULL),
('Luxor', 26, '2020-01-24', 374, NULL),
('Luxor', 26, '2020-01-25', 227, NULL),
('Luxor', 26, '2020-01-26', 144, NULL),
('Luxor', 26, '2020-01-27', 116, NULL),
('Luxor', 26, '2020-01-28', 178, NULL),
('Luxor', 26, '2020-01-29', 397, NULL),
('Luxor', 26, '2020-01-30', 209, NULL),
('Luxor', 26, '2020-01-31', 185, NULL),
('Luxor', 26, '2020-02-01', 103, NULL),
('Luxor', 26, '2020-02-02', 270, NULL),
('Luxor', 26, '2020-02-03', 223, NULL),
('Luxor', 26, '2020-02-04', 373, NULL),
('Luxor', 27, '2019-01-01', 388, NULL),
('Luxor', 27, '2019-01-02', 236, NULL),
('Luxor', 27, '2019-01-03', 101, NULL),
('Luxor', 27, '2019-01-04', 333, NULL),
('Luxor', 27, '2019-01-05', 246, NULL),
('Luxor', 27, '2019-01-06', 119, NULL),
('Luxor', 27, '2019-01-07', 360, NULL),
('Luxor', 27, '2019-01-08', 248, NULL),
('Luxor', 27, '2019-01-09', 121, NULL),
('Luxor', 27, '2019-01-10', 209, NULL),
('Luxor', 27, '2019-01-11', 317, NULL),
('Luxor', 27, '2019-01-12', 347, NULL),
('Luxor', 27, '2019-01-13', 132, NULL),
('Luxor', 27, '2019-01-14', 291, NULL),
('Luxor', 27, '2019-01-15', 289, NULL),
('Luxor', 27, '2019-01-16', 312, NULL),
('Luxor', 27, '2019-01-17', 242, NULL),
('Luxor', 27, '2019-01-18', 394, NULL),
('Luxor', 27, '2019-01-19', 282, NULL),
('Luxor', 27, '2019-01-20', 199, NULL),
('Luxor', 27, '2019-01-21', 125, NULL),
('Luxor', 27, '2019-01-22', 190, NULL),
('Luxor', 27, '2019-01-23', 349, NULL),
('Luxor', 27, '2019-01-24', 144, NULL),
('Luxor', 27, '2019-01-25', 377, NULL),
('Luxor', 27, '2019-01-26', 128, NULL),
('Luxor', 27, '2019-01-27', 390, NULL),
('Luxor', 27, '2019-01-28', 176, NULL),
('Luxor', 27, '2019-01-29', 383, NULL),
('Luxor', 27, '2019-01-30', 350, NULL),
('Luxor', 27, '2019-01-31', 334, NULL),
('Luxor', 27, '2019-02-01', 267, NULL),
('Luxor', 27, '2019-02-02', 397, NULL),
('Luxor', 27, '2019-02-03', 237, NULL),
('Luxor', 27, '2019-02-04', 311, NULL),
('Luxor', 27, '2019-02-05', 363, NULL),
('Luxor', 27, '2019-02-06', 249, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 27, '2019-02-07', 307, NULL),
('Luxor', 27, '2019-02-08', 383, NULL),
('Luxor', 27, '2019-02-09', 363, NULL),
('Luxor', 27, '2019-02-10', 304, NULL),
('Luxor', 27, '2019-02-11', 172, NULL),
('Luxor', 27, '2019-02-12', 168, NULL),
('Luxor', 27, '2019-02-13', 248, NULL),
('Luxor', 27, '2019-02-14', 398, NULL),
('Luxor', 27, '2019-02-15', 183, NULL),
('Luxor', 27, '2019-02-16', 317, NULL),
('Luxor', 27, '2019-02-17', 382, NULL),
('Luxor', 27, '2019-02-18', 181, NULL),
('Luxor', 27, '2019-02-19', 301, NULL),
('Luxor', 27, '2019-02-20', 245, NULL),
('Luxor', 27, '2019-02-21', 356, NULL),
('Luxor', 27, '2019-02-22', 126, NULL),
('Luxor', 27, '2019-02-23', 197, NULL),
('Luxor', 27, '2019-02-24', 166, NULL),
('Luxor', 27, '2019-02-25', 228, NULL),
('Luxor', 27, '2019-02-26', 207, NULL),
('Luxor', 27, '2019-02-27', 238, NULL),
('Luxor', 27, '2019-02-28', 137, NULL),
('Luxor', 27, '2019-03-01', 302, NULL),
('Luxor', 27, '2019-03-02', 112, NULL),
('Luxor', 27, '2019-03-03', 347, NULL),
('Luxor', 27, '2019-03-04', 163, NULL),
('Luxor', 27, '2019-03-05', 208, NULL),
('Luxor', 27, '2019-03-06', 360, NULL),
('Luxor', 27, '2019-03-07', 293, NULL),
('Luxor', 27, '2019-03-08', 376, NULL),
('Luxor', 27, '2019-03-09', 207, NULL),
('Luxor', 27, '2019-03-10', 350, NULL),
('Luxor', 27, '2019-03-11', 247, NULL),
('Luxor', 27, '2019-03-12', 289, NULL),
('Luxor', 27, '2019-03-13', 215, NULL),
('Luxor', 27, '2019-03-14', 202, NULL),
('Luxor', 27, '2019-03-15', 329, NULL),
('Luxor', 27, '2019-03-16', 171, NULL),
('Luxor', 27, '2019-03-17', 292, NULL),
('Luxor', 27, '2019-03-18', 260, NULL),
('Luxor', 27, '2019-03-19', 116, NULL),
('Luxor', 27, '2019-03-20', 361, NULL),
('Luxor', 27, '2019-03-21', 105, NULL),
('Luxor', 27, '2019-03-22', 324, NULL),
('Luxor', 27, '2019-03-23', 146, NULL),
('Luxor', 27, '2019-03-24', 353, NULL),
('Luxor', 27, '2019-03-25', 159, NULL),
('Luxor', 27, '2019-03-26', 170, NULL),
('Luxor', 27, '2019-03-27', 117, NULL),
('Luxor', 27, '2019-03-28', 103, NULL),
('Luxor', 27, '2019-03-29', 206, NULL),
('Luxor', 27, '2019-03-30', 114, NULL),
('Luxor', 27, '2019-03-31', 134, NULL),
('Luxor', 27, '2019-04-01', 362, NULL),
('Luxor', 27, '2019-04-02', 101, NULL),
('Luxor', 27, '2019-04-03', 273, NULL),
('Luxor', 27, '2019-04-04', 140, NULL),
('Luxor', 27, '2019-04-05', 336, NULL),
('Luxor', 27, '2019-04-06', 144, NULL),
('Luxor', 27, '2019-04-07', 130, NULL),
('Luxor', 27, '2019-04-08', 122, NULL),
('Luxor', 27, '2019-04-09', 329, NULL),
('Luxor', 27, '2019-04-10', 265, NULL),
('Luxor', 27, '2019-04-11', 270, NULL),
('Luxor', 27, '2019-04-12', 393, NULL),
('Luxor', 27, '2019-04-13', 287, NULL),
('Luxor', 27, '2019-04-14', 366, NULL),
('Luxor', 27, '2019-04-15', 252, NULL),
('Luxor', 27, '2019-04-16', 183, NULL),
('Luxor', 27, '2019-04-17', 191, NULL),
('Luxor', 27, '2019-04-18', 390, NULL),
('Luxor', 27, '2019-04-19', 182, NULL),
('Luxor', 27, '2019-04-20', 319, NULL),
('Luxor', 27, '2019-04-21', 167, NULL),
('Luxor', 27, '2019-04-22', 180, NULL),
('Luxor', 27, '2019-04-23', 192, NULL),
('Luxor', 27, '2019-04-24', 289, NULL),
('Luxor', 27, '2019-04-25', 331, NULL),
('Luxor', 27, '2019-04-26', 181, NULL),
('Luxor', 27, '2019-04-27', 227, NULL),
('Luxor', 27, '2019-04-28', 166, NULL),
('Luxor', 27, '2019-04-29', 257, NULL),
('Luxor', 27, '2019-04-30', 309, NULL),
('Luxor', 27, '2019-05-01', 295, NULL),
('Luxor', 27, '2019-05-02', 270, NULL),
('Luxor', 27, '2019-05-03', 329, NULL),
('Luxor', 27, '2019-05-04', 294, NULL),
('Luxor', 27, '2019-05-05', 341, NULL),
('Luxor', 27, '2019-05-06', 127, NULL),
('Luxor', 27, '2019-05-07', 220, NULL),
('Luxor', 27, '2019-05-08', 113, NULL),
('Luxor', 27, '2019-05-09', 115, NULL),
('Luxor', 27, '2019-05-10', 195, NULL),
('Luxor', 27, '2019-05-11', 162, NULL),
('Luxor', 27, '2019-05-12', 344, NULL),
('Luxor', 27, '2019-05-13', 136, NULL),
('Luxor', 27, '2019-05-14', 200, NULL),
('Luxor', 27, '2019-05-15', 282, NULL),
('Luxor', 27, '2019-05-16', 338, NULL),
('Luxor', 27, '2019-05-17', 338, NULL),
('Luxor', 27, '2019-05-18', 359, NULL),
('Luxor', 27, '2019-05-19', 285, NULL),
('Luxor', 27, '2019-05-20', 380, NULL),
('Luxor', 27, '2019-05-21', 388, NULL),
('Luxor', 27, '2019-05-22', 135, NULL),
('Luxor', 27, '2019-05-23', 126, NULL),
('Luxor', 27, '2019-05-24', 396, NULL),
('Luxor', 27, '2019-05-25', 359, NULL),
('Luxor', 27, '2019-05-26', 127, NULL),
('Luxor', 27, '2019-05-27', 267, NULL),
('Luxor', 27, '2019-05-28', 120, NULL),
('Luxor', 27, '2019-05-29', 385, NULL),
('Luxor', 27, '2019-05-30', 195, NULL),
('Luxor', 27, '2019-05-31', 259, NULL),
('Luxor', 27, '2019-06-01', 119, NULL),
('Luxor', 27, '2019-06-02', 301, NULL),
('Luxor', 27, '2019-06-03', 253, NULL),
('Luxor', 27, '2019-06-04', 270, NULL),
('Luxor', 27, '2019-06-05', 363, NULL),
('Luxor', 27, '2019-06-06', 171, NULL),
('Luxor', 27, '2019-06-07', 154, NULL),
('Luxor', 27, '2019-06-08', 269, NULL),
('Luxor', 27, '2019-06-09', 328, NULL),
('Luxor', 27, '2019-06-10', 194, NULL),
('Luxor', 27, '2019-06-11', 267, NULL),
('Luxor', 27, '2019-06-12', 200, NULL),
('Luxor', 27, '2019-06-13', 227, NULL),
('Luxor', 27, '2019-06-14', 132, NULL),
('Luxor', 27, '2019-06-15', 265, NULL),
('Luxor', 27, '2019-06-16', 331, NULL),
('Luxor', 27, '2019-06-17', 367, NULL),
('Luxor', 27, '2019-06-18', 343, NULL),
('Luxor', 27, '2019-06-19', 102, NULL),
('Luxor', 27, '2019-06-20', 236, NULL),
('Luxor', 27, '2019-06-21', 264, NULL),
('Luxor', 27, '2019-06-22', 103, NULL),
('Luxor', 27, '2019-06-23', 262, NULL),
('Luxor', 27, '2019-06-24', 360, NULL),
('Luxor', 27, '2019-06-25', 396, NULL),
('Luxor', 27, '2019-06-26', 387, NULL),
('Luxor', 27, '2019-06-27', 235, NULL),
('Luxor', 27, '2019-06-28', 240, NULL),
('Luxor', 27, '2019-06-29', 352, NULL),
('Luxor', 27, '2019-06-30', 112, NULL),
('Luxor', 27, '2019-07-01', 353, NULL),
('Luxor', 27, '2019-07-02', 268, NULL),
('Luxor', 27, '2019-07-03', 192, NULL),
('Luxor', 27, '2019-07-04', 227, NULL),
('Luxor', 27, '2019-07-05', 198, NULL),
('Luxor', 27, '2019-07-06', 120, NULL),
('Luxor', 27, '2019-07-07', 216, NULL),
('Luxor', 27, '2019-07-08', 303, NULL),
('Luxor', 27, '2019-07-09', 124, NULL),
('Luxor', 27, '2019-07-10', 213, NULL),
('Luxor', 27, '2019-07-11', 255, NULL),
('Luxor', 27, '2019-07-12', 361, NULL),
('Luxor', 27, '2019-07-13', 297, NULL),
('Luxor', 27, '2019-07-14', 368, NULL),
('Luxor', 27, '2019-07-15', 123, NULL),
('Luxor', 27, '2019-07-16', 133, NULL),
('Luxor', 27, '2019-07-17', 155, NULL),
('Luxor', 27, '2019-07-18', 306, NULL),
('Luxor', 27, '2019-07-19', 283, NULL),
('Luxor', 27, '2019-07-20', 340, NULL),
('Luxor', 27, '2019-07-21', 187, NULL),
('Luxor', 27, '2019-07-22', 164, NULL),
('Luxor', 27, '2019-07-23', 171, NULL),
('Luxor', 27, '2019-07-24', 347, NULL),
('Luxor', 27, '2019-07-25', 329, NULL),
('Luxor', 27, '2019-07-26', 371, NULL),
('Luxor', 27, '2019-07-27', 252, NULL),
('Luxor', 27, '2019-07-28', 285, NULL),
('Luxor', 27, '2019-07-29', 245, NULL),
('Luxor', 27, '2019-07-30', 319, NULL),
('Luxor', 27, '2019-07-31', 265, NULL),
('Luxor', 27, '2019-08-01', 102, NULL),
('Luxor', 27, '2019-08-02', 222, NULL),
('Luxor', 27, '2019-08-03', 397, NULL),
('Luxor', 27, '2019-08-04', 200, NULL),
('Luxor', 27, '2019-08-05', 334, NULL),
('Luxor', 27, '2019-08-06', 304, NULL),
('Luxor', 27, '2019-08-07', 381, NULL),
('Luxor', 27, '2019-08-08', 107, NULL),
('Luxor', 27, '2019-08-09', 390, NULL),
('Luxor', 27, '2019-08-10', 245, NULL),
('Luxor', 27, '2019-08-11', 360, NULL),
('Luxor', 27, '2019-08-12', 219, NULL),
('Luxor', 27, '2019-08-13', 293, NULL),
('Luxor', 27, '2019-08-14', 306, NULL),
('Luxor', 27, '2019-08-15', 171, NULL),
('Luxor', 27, '2019-08-16', 370, NULL),
('Luxor', 27, '2019-08-17', 384, NULL),
('Luxor', 27, '2019-08-18', 257, NULL),
('Luxor', 27, '2019-08-19', 176, NULL),
('Luxor', 27, '2019-08-20', 236, NULL),
('Luxor', 27, '2019-08-21', 326, NULL),
('Luxor', 27, '2019-08-22', 282, NULL),
('Luxor', 27, '2019-08-23', 350, NULL),
('Luxor', 27, '2019-08-24', 221, NULL),
('Luxor', 27, '2019-08-25', 337, NULL),
('Luxor', 27, '2019-08-26', 247, NULL),
('Luxor', 27, '2019-08-27', 289, NULL),
('Luxor', 27, '2019-08-28', 173, NULL),
('Luxor', 27, '2019-08-29', 299, NULL),
('Luxor', 27, '2019-08-30', 102, NULL),
('Luxor', 27, '2019-08-31', 219, NULL),
('Luxor', 27, '2019-09-01', 145, NULL),
('Luxor', 27, '2019-09-02', 239, NULL),
('Luxor', 27, '2019-09-03', 320, NULL),
('Luxor', 27, '2019-09-04', 257, NULL),
('Luxor', 27, '2019-09-05', 111, NULL),
('Luxor', 27, '2019-09-06', 107, NULL),
('Luxor', 27, '2019-09-07', 176, NULL),
('Luxor', 27, '2019-09-08', 379, NULL),
('Luxor', 27, '2019-09-09', 244, NULL),
('Luxor', 27, '2019-09-10', 274, NULL),
('Luxor', 27, '2019-09-11', 218, NULL),
('Luxor', 27, '2019-09-12', 324, NULL),
('Luxor', 27, '2019-09-13', 276, NULL),
('Luxor', 27, '2019-09-14', 154, NULL),
('Luxor', 27, '2019-09-15', 140, NULL),
('Luxor', 27, '2019-09-16', 205, NULL),
('Luxor', 27, '2019-09-17', 261, NULL),
('Luxor', 27, '2019-09-18', 127, NULL),
('Luxor', 27, '2019-09-19', 214, NULL),
('Luxor', 27, '2019-09-20', 289, NULL),
('Luxor', 27, '2019-09-21', 333, NULL),
('Luxor', 27, '2019-09-22', 123, NULL),
('Luxor', 27, '2019-09-23', 223, NULL),
('Luxor', 27, '2019-09-24', 371, NULL),
('Luxor', 27, '2019-09-25', 180, NULL),
('Luxor', 27, '2019-09-26', 352, NULL),
('Luxor', 27, '2019-09-27', 290, NULL),
('Luxor', 27, '2019-09-28', 321, NULL),
('Luxor', 27, '2019-09-29', 352, NULL),
('Luxor', 27, '2019-09-30', 211, NULL),
('Luxor', 27, '2019-10-01', 141, NULL),
('Luxor', 27, '2019-10-02', 269, NULL),
('Luxor', 27, '2019-10-03', 278, NULL),
('Luxor', 27, '2019-10-04', 212, NULL),
('Luxor', 27, '2019-10-05', 300, NULL),
('Luxor', 27, '2019-10-06', 177, NULL),
('Luxor', 27, '2019-10-07', 397, NULL),
('Luxor', 27, '2019-10-08', 294, NULL),
('Luxor', 27, '2019-10-09', 239, NULL),
('Luxor', 27, '2019-10-10', 214, 153),
('Luxor', 27, '2019-10-11', 297, 153),
('Luxor', 27, '2019-10-12', 361, 153),
('Luxor', 27, '2019-10-13', 308, 153),
('Luxor', 27, '2019-10-14', 230, 153),
('Luxor', 27, '2019-10-15', 274, 153),
('Luxor', 27, '2019-10-16', 314, 153),
('Luxor', 27, '2019-10-17', 296, 153),
('Luxor', 27, '2019-10-18', 100, 153),
('Luxor', 27, '2019-10-19', 389, 153),
('Luxor', 27, '2019-10-20', 277, 153),
('Luxor', 27, '2019-10-21', 149, 153),
('Luxor', 27, '2019-10-22', 178, 153),
('Luxor', 27, '2019-10-23', 134, 153),
('Luxor', 27, '2019-10-24', 147, 153),
('Luxor', 27, '2019-10-25', 129, 153),
('Luxor', 27, '2019-10-26', 144, 153),
('Luxor', 27, '2019-10-27', 255, 153),
('Luxor', 27, '2019-10-28', 121, 153),
('Luxor', 27, '2019-10-29', 165, NULL),
('Luxor', 27, '2019-10-30', 203, NULL),
('Luxor', 27, '2019-10-31', 201, NULL),
('Luxor', 27, '2019-11-01', 236, NULL),
('Luxor', 27, '2019-11-02', 216, NULL),
('Luxor', 27, '2019-11-03', 361, NULL),
('Luxor', 27, '2019-11-04', 199, NULL),
('Luxor', 27, '2019-11-05', 173, NULL),
('Luxor', 27, '2019-11-06', 382, NULL),
('Luxor', 27, '2019-11-07', 135, NULL),
('Luxor', 27, '2019-11-08', 339, NULL),
('Luxor', 27, '2019-11-09', 130, NULL),
('Luxor', 27, '2019-11-10', 355, NULL),
('Luxor', 27, '2019-11-11', 316, NULL),
('Luxor', 27, '2019-11-12', 316, NULL),
('Luxor', 27, '2019-11-13', 212, NULL),
('Luxor', 27, '2019-11-14', 239, NULL),
('Luxor', 27, '2019-11-15', 269, NULL),
('Luxor', 27, '2019-11-16', 126, NULL),
('Luxor', 27, '2019-11-17', 153, NULL),
('Luxor', 27, '2019-11-18', 314, NULL),
('Luxor', 27, '2019-11-19', 377, NULL),
('Luxor', 27, '2019-11-20', 392, NULL),
('Luxor', 27, '2019-11-21', 109, NULL),
('Luxor', 27, '2019-11-22', 287, NULL),
('Luxor', 27, '2019-11-23', 375, NULL),
('Luxor', 27, '2019-11-24', 378, NULL),
('Luxor', 27, '2019-11-25', 139, NULL),
('Luxor', 27, '2019-11-26', 209, NULL),
('Luxor', 27, '2019-11-27', 196, NULL),
('Luxor', 27, '2019-11-28', 219, NULL),
('Luxor', 27, '2019-11-29', 296, NULL),
('Luxor', 27, '2019-11-30', 336, NULL),
('Luxor', 27, '2019-12-01', 376, NULL),
('Luxor', 27, '2019-12-02', 257, NULL),
('Luxor', 27, '2019-12-03', 372, NULL),
('Luxor', 27, '2019-12-04', 310, NULL),
('Luxor', 27, '2019-12-05', 285, NULL),
('Luxor', 27, '2019-12-06', 269, NULL),
('Luxor', 27, '2019-12-07', 281, NULL),
('Luxor', 27, '2019-12-08', 246, NULL),
('Luxor', 27, '2019-12-09', 371, NULL),
('Luxor', 27, '2019-12-10', 346, NULL),
('Luxor', 27, '2019-12-11', 241, NULL),
('Luxor', 27, '2019-12-12', 381, NULL),
('Luxor', 27, '2019-12-13', 307, NULL),
('Luxor', 27, '2019-12-14', 111, NULL),
('Luxor', 27, '2019-12-15', 103, NULL),
('Luxor', 27, '2019-12-16', 209, NULL),
('Luxor', 27, '2019-12-17', 372, NULL),
('Luxor', 27, '2019-12-18', 128, NULL),
('Luxor', 27, '2019-12-19', 319, NULL),
('Luxor', 27, '2019-12-20', 387, NULL),
('Luxor', 27, '2019-12-21', 370, NULL),
('Luxor', 27, '2019-12-22', 118, NULL),
('Luxor', 27, '2019-12-23', 397, NULL),
('Luxor', 27, '2019-12-24', 183, NULL),
('Luxor', 27, '2019-12-25', 313, NULL),
('Luxor', 27, '2019-12-26', 142, NULL),
('Luxor', 27, '2019-12-27', 273, NULL),
('Luxor', 27, '2019-12-28', 302, NULL),
('Luxor', 27, '2019-12-29', 200, NULL),
('Luxor', 27, '2019-12-30', 242, NULL),
('Luxor', 27, '2019-12-31', 124, NULL),
('Luxor', 27, '2020-01-01', 371, NULL),
('Luxor', 27, '2020-01-02', 283, NULL),
('Luxor', 27, '2020-01-03', 167, NULL),
('Luxor', 27, '2020-01-04', 253, NULL),
('Luxor', 27, '2020-01-05', 388, NULL),
('Luxor', 27, '2020-01-06', 169, NULL),
('Luxor', 27, '2020-01-07', 128, NULL),
('Luxor', 27, '2020-01-08', 344, NULL),
('Luxor', 27, '2020-01-09', 355, NULL),
('Luxor', 27, '2020-01-10', 290, NULL),
('Luxor', 27, '2020-01-11', 202, NULL),
('Luxor', 27, '2020-01-12', 319, NULL),
('Luxor', 27, '2020-01-13', 289, NULL),
('Luxor', 27, '2020-01-14', 295, NULL),
('Luxor', 27, '2020-01-15', 155, NULL),
('Luxor', 27, '2020-01-16', 191, NULL),
('Luxor', 27, '2020-01-17', 384, NULL),
('Luxor', 27, '2020-01-18', 381, NULL),
('Luxor', 27, '2020-01-19', 354, NULL),
('Luxor', 27, '2020-01-20', 307, NULL),
('Luxor', 27, '2020-01-21', 102, NULL),
('Luxor', 27, '2020-01-22', 373, NULL),
('Luxor', 27, '2020-01-23', 260, NULL),
('Luxor', 27, '2020-01-24', 146, NULL),
('Luxor', 27, '2020-01-25', 368, NULL),
('Luxor', 27, '2020-01-26', 129, NULL),
('Luxor', 27, '2020-01-27', 172, NULL),
('Luxor', 27, '2020-01-28', 397, NULL),
('Luxor', 27, '2020-01-29', 267, NULL),
('Luxor', 27, '2020-01-30', 188, NULL),
('Luxor', 27, '2020-01-31', 330, NULL),
('Luxor', 27, '2020-02-01', 275, NULL),
('Luxor', 27, '2020-02-02', 207, NULL),
('Luxor', 27, '2020-02-03', 283, NULL),
('Luxor', 27, '2020-02-04', 242, NULL),
('Luxor', 30, '2019-01-01', 397, NULL),
('Luxor', 30, '2019-01-02', 322, NULL),
('Luxor', 30, '2019-01-03', 181, NULL),
('Luxor', 30, '2019-01-04', 346, NULL),
('Luxor', 30, '2019-01-05', 215, NULL),
('Luxor', 30, '2019-01-06', 342, NULL),
('Luxor', 30, '2019-01-07', 319, NULL),
('Luxor', 30, '2019-01-08', 352, NULL),
('Luxor', 30, '2019-01-09', 268, NULL),
('Luxor', 30, '2019-01-10', 214, NULL),
('Luxor', 30, '2019-01-11', 378, NULL),
('Luxor', 30, '2019-01-12', 382, NULL),
('Luxor', 30, '2019-01-13', 279, NULL),
('Luxor', 30, '2019-01-14', 130, NULL),
('Luxor', 30, '2019-01-15', 381, NULL),
('Luxor', 30, '2019-01-16', 308, NULL),
('Luxor', 30, '2019-01-17', 181, NULL),
('Luxor', 30, '2019-01-18', 303, NULL),
('Luxor', 30, '2019-01-19', 390, NULL),
('Luxor', 30, '2019-01-20', 136, NULL),
('Luxor', 30, '2019-01-21', 313, NULL),
('Luxor', 30, '2019-01-22', 124, NULL),
('Luxor', 30, '2019-01-23', 383, NULL),
('Luxor', 30, '2019-01-24', 148, NULL),
('Luxor', 30, '2019-01-25', 335, NULL),
('Luxor', 30, '2019-01-26', 276, NULL),
('Luxor', 30, '2019-01-27', 226, NULL),
('Luxor', 30, '2019-01-28', 244, NULL),
('Luxor', 30, '2019-01-29', 291, NULL),
('Luxor', 30, '2019-01-30', 278, NULL),
('Luxor', 30, '2019-01-31', 231, NULL),
('Luxor', 30, '2019-02-01', 224, NULL),
('Luxor', 30, '2019-02-02', 325, NULL),
('Luxor', 30, '2019-02-03', 272, NULL),
('Luxor', 30, '2019-02-04', 290, NULL),
('Luxor', 30, '2019-02-05', 203, NULL),
('Luxor', 30, '2019-02-06', 327, NULL),
('Luxor', 30, '2019-02-07', 217, NULL),
('Luxor', 30, '2019-02-08', 350, NULL),
('Luxor', 30, '2019-02-09', 131, NULL),
('Luxor', 30, '2019-02-10', 365, NULL),
('Luxor', 30, '2019-02-11', 341, NULL),
('Luxor', 30, '2019-02-12', 349, NULL),
('Luxor', 30, '2019-02-13', 389, NULL),
('Luxor', 30, '2019-02-14', 230, NULL),
('Luxor', 30, '2019-02-15', 149, NULL),
('Luxor', 30, '2019-02-16', 399, NULL),
('Luxor', 30, '2019-02-17', 304, NULL),
('Luxor', 30, '2019-02-18', 336, NULL),
('Luxor', 30, '2019-02-19', 129, NULL),
('Luxor', 30, '2019-02-20', 347, NULL),
('Luxor', 30, '2019-02-21', 262, NULL),
('Luxor', 30, '2019-02-22', 305, NULL),
('Luxor', 30, '2019-02-23', 115, NULL),
('Luxor', 30, '2019-02-24', 268, NULL),
('Luxor', 30, '2019-02-25', 185, NULL),
('Luxor', 30, '2019-02-26', 341, NULL),
('Luxor', 30, '2019-02-27', 114, NULL),
('Luxor', 30, '2019-02-28', 389, NULL),
('Luxor', 30, '2019-03-01', 247, NULL),
('Luxor', 30, '2019-03-02', 370, NULL),
('Luxor', 30, '2019-03-03', 223, NULL),
('Luxor', 30, '2019-03-04', 366, NULL),
('Luxor', 30, '2019-03-05', 322, NULL),
('Luxor', 30, '2019-03-06', 215, NULL),
('Luxor', 30, '2019-03-07', 200, NULL),
('Luxor', 30, '2019-03-08', 289, NULL),
('Luxor', 30, '2019-03-09', 128, NULL),
('Luxor', 30, '2019-03-10', 360, NULL),
('Luxor', 30, '2019-03-11', 370, NULL),
('Luxor', 30, '2019-03-12', 368, NULL),
('Luxor', 30, '2019-03-13', 110, NULL),
('Luxor', 30, '2019-03-14', 162, NULL),
('Luxor', 30, '2019-03-15', 383, NULL),
('Luxor', 30, '2019-03-16', 261, NULL),
('Luxor', 30, '2019-03-17', 351, NULL),
('Luxor', 30, '2019-03-18', 359, NULL),
('Luxor', 30, '2019-03-19', 110, NULL),
('Luxor', 30, '2019-03-20', 218, NULL),
('Luxor', 30, '2019-03-21', 113, NULL),
('Luxor', 30, '2019-03-22', 356, NULL),
('Luxor', 30, '2019-03-23', 144, NULL),
('Luxor', 30, '2019-03-24', 393, NULL),
('Luxor', 30, '2019-03-25', 239, NULL),
('Luxor', 30, '2019-03-26', 376, NULL),
('Luxor', 30, '2019-03-27', 378, NULL),
('Luxor', 30, '2019-03-28', 369, NULL),
('Luxor', 30, '2019-03-29', 225, NULL),
('Luxor', 30, '2019-03-30', 351, NULL),
('Luxor', 30, '2019-03-31', 386, NULL),
('Luxor', 30, '2019-04-01', 212, NULL),
('Luxor', 30, '2019-04-02', 267, NULL),
('Luxor', 30, '2019-04-03', 188, NULL),
('Luxor', 30, '2019-04-04', 264, NULL),
('Luxor', 30, '2019-04-05', 363, NULL),
('Luxor', 30, '2019-04-06', 376, NULL),
('Luxor', 30, '2019-04-07', 124, NULL),
('Luxor', 30, '2019-04-08', 160, NULL),
('Luxor', 30, '2019-04-09', 361, NULL),
('Luxor', 30, '2019-04-10', 121, NULL),
('Luxor', 30, '2019-04-11', 382, NULL),
('Luxor', 30, '2019-04-12', 271, NULL),
('Luxor', 30, '2019-04-13', 260, NULL),
('Luxor', 30, '2019-04-14', 154, NULL),
('Luxor', 30, '2019-04-15', 183, NULL),
('Luxor', 30, '2019-04-16', 154, NULL),
('Luxor', 30, '2019-04-17', 190, NULL),
('Luxor', 30, '2019-04-18', 172, NULL),
('Luxor', 30, '2019-04-19', 368, NULL),
('Luxor', 30, '2019-04-20', 112, NULL),
('Luxor', 30, '2019-04-21', 300, NULL),
('Luxor', 30, '2019-04-22', 108, NULL),
('Luxor', 30, '2019-04-23', 233, NULL),
('Luxor', 30, '2019-04-24', 280, NULL),
('Luxor', 30, '2019-04-25', 227, NULL),
('Luxor', 30, '2019-04-26', 351, NULL),
('Luxor', 30, '2019-04-27', 261, NULL),
('Luxor', 30, '2019-04-28', 166, NULL),
('Luxor', 30, '2019-04-29', 139, NULL),
('Luxor', 30, '2019-04-30', 281, NULL),
('Luxor', 30, '2019-05-01', 100, NULL),
('Luxor', 30, '2019-05-02', 352, NULL),
('Luxor', 30, '2019-05-03', 299, NULL),
('Luxor', 30, '2019-05-04', 298, NULL),
('Luxor', 30, '2019-05-05', 377, NULL),
('Luxor', 30, '2019-05-06', 138, NULL),
('Luxor', 30, '2019-05-07', 161, NULL),
('Luxor', 30, '2019-05-08', 198, NULL),
('Luxor', 30, '2019-05-09', 281, NULL),
('Luxor', 30, '2019-05-10', 257, NULL),
('Luxor', 30, '2019-05-11', 351, NULL),
('Luxor', 30, '2019-05-12', 178, NULL),
('Luxor', 30, '2019-05-13', 137, NULL),
('Luxor', 30, '2019-05-14', 210, NULL),
('Luxor', 30, '2019-05-15', 177, NULL),
('Luxor', 30, '2019-05-16', 219, NULL),
('Luxor', 30, '2019-05-17', 247, NULL),
('Luxor', 30, '2019-05-18', 337, NULL),
('Luxor', 30, '2019-05-19', 144, NULL),
('Luxor', 30, '2019-05-20', 223, NULL),
('Luxor', 30, '2019-05-21', 114, NULL),
('Luxor', 30, '2019-05-22', 148, NULL),
('Luxor', 30, '2019-05-23', 255, NULL),
('Luxor', 30, '2019-05-24', 272, NULL),
('Luxor', 30, '2019-05-25', 360, NULL),
('Luxor', 30, '2019-05-26', 271, NULL),
('Luxor', 30, '2019-05-27', 269, NULL),
('Luxor', 30, '2019-05-28', 118, NULL),
('Luxor', 30, '2019-05-29', 363, NULL),
('Luxor', 30, '2019-05-30', 232, NULL),
('Luxor', 30, '2019-05-31', 195, NULL),
('Luxor', 30, '2019-06-01', 175, NULL),
('Luxor', 30, '2019-06-02', 372, NULL),
('Luxor', 30, '2019-06-03', 298, NULL),
('Luxor', 30, '2019-06-04', 312, NULL),
('Luxor', 30, '2019-06-05', 286, NULL),
('Luxor', 30, '2019-06-06', 319, NULL),
('Luxor', 30, '2019-06-07', 138, NULL),
('Luxor', 30, '2019-06-08', 117, NULL),
('Luxor', 30, '2019-06-09', 127, NULL),
('Luxor', 30, '2019-06-10', 175, NULL),
('Luxor', 30, '2019-06-11', 231, NULL),
('Luxor', 30, '2019-06-12', 356, NULL),
('Luxor', 30, '2019-06-13', 374, NULL),
('Luxor', 30, '2019-06-14', 229, NULL),
('Luxor', 30, '2019-06-15', 290, NULL),
('Luxor', 30, '2019-06-16', 289, NULL),
('Luxor', 30, '2019-06-17', 382, NULL),
('Luxor', 30, '2019-06-18', 276, NULL),
('Luxor', 30, '2019-06-19', 199, NULL),
('Luxor', 30, '2019-06-20', 348, NULL),
('Luxor', 30, '2019-06-21', 366, NULL),
('Luxor', 30, '2019-06-22', 153, NULL),
('Luxor', 30, '2019-06-23', 399, NULL),
('Luxor', 30, '2019-06-24', 219, NULL),
('Luxor', 30, '2019-06-25', 188, NULL),
('Luxor', 30, '2019-06-26', 338, NULL),
('Luxor', 30, '2019-06-27', 319, NULL),
('Luxor', 30, '2019-06-28', 104, NULL),
('Luxor', 30, '2019-06-29', 183, NULL),
('Luxor', 30, '2019-06-30', 391, NULL),
('Luxor', 30, '2019-07-01', 267, NULL),
('Luxor', 30, '2019-07-02', 195, NULL),
('Luxor', 30, '2019-07-03', 281, NULL),
('Luxor', 30, '2019-07-04', 398, NULL),
('Luxor', 30, '2019-07-05', 195, NULL),
('Luxor', 30, '2019-07-06', 190, NULL),
('Luxor', 30, '2019-07-07', 177, NULL),
('Luxor', 30, '2019-07-08', 164, NULL),
('Luxor', 30, '2019-07-09', 361, NULL),
('Luxor', 30, '2019-07-10', 290, NULL),
('Luxor', 30, '2019-07-11', 203, NULL),
('Luxor', 30, '2019-07-12', 138, NULL),
('Luxor', 30, '2019-07-13', 163, NULL),
('Luxor', 30, '2019-07-14', 132, NULL),
('Luxor', 30, '2019-07-15', 101, NULL),
('Luxor', 30, '2019-07-16', 229, NULL),
('Luxor', 30, '2019-07-17', 110, NULL),
('Luxor', 30, '2019-07-18', 361, NULL),
('Luxor', 30, '2019-07-19', 140, NULL),
('Luxor', 30, '2019-07-20', 117, NULL),
('Luxor', 30, '2019-07-21', 262, NULL),
('Luxor', 30, '2019-07-22', 125, NULL),
('Luxor', 30, '2019-07-23', 144, NULL),
('Luxor', 30, '2019-07-24', 300, NULL),
('Luxor', 30, '2019-07-25', 199, NULL),
('Luxor', 30, '2019-07-26', 360, NULL),
('Luxor', 30, '2019-07-27', 164, NULL),
('Luxor', 30, '2019-07-28', 139, NULL),
('Luxor', 30, '2019-07-29', 295, NULL),
('Luxor', 30, '2019-07-30', 290, NULL),
('Luxor', 30, '2019-07-31', 275, NULL),
('Luxor', 30, '2019-08-01', 174, NULL),
('Luxor', 30, '2019-08-02', 237, NULL),
('Luxor', 30, '2019-08-03', 174, NULL),
('Luxor', 30, '2019-08-04', 310, NULL),
('Luxor', 30, '2019-08-05', 132, NULL),
('Luxor', 30, '2019-08-06', 106, NULL),
('Luxor', 30, '2019-08-07', 384, NULL),
('Luxor', 30, '2019-08-08', 282, NULL),
('Luxor', 30, '2019-08-09', 120, NULL),
('Luxor', 30, '2019-08-10', 199, NULL),
('Luxor', 30, '2019-08-11', 219, NULL),
('Luxor', 30, '2019-08-12', 134, NULL),
('Luxor', 30, '2019-08-13', 358, NULL),
('Luxor', 30, '2019-08-14', 216, NULL),
('Luxor', 30, '2019-08-15', 248, NULL),
('Luxor', 30, '2019-08-16', 220, NULL),
('Luxor', 30, '2019-08-17', 140, NULL),
('Luxor', 30, '2019-08-18', 179, NULL),
('Luxor', 30, '2019-08-19', 169, NULL),
('Luxor', 30, '2019-08-20', 393, NULL),
('Luxor', 30, '2019-08-21', 347, NULL),
('Luxor', 30, '2019-08-22', 399, NULL),
('Luxor', 30, '2019-08-23', 378, NULL),
('Luxor', 30, '2019-08-24', 209, NULL),
('Luxor', 30, '2019-08-25', 202, NULL),
('Luxor', 30, '2019-08-26', 153, NULL),
('Luxor', 30, '2019-08-27', 352, NULL),
('Luxor', 30, '2019-08-28', 128, NULL),
('Luxor', 30, '2019-08-29', 104, NULL),
('Luxor', 30, '2019-08-30', 114, NULL),
('Luxor', 30, '2019-08-31', 356, NULL),
('Luxor', 30, '2019-09-01', 316, NULL),
('Luxor', 30, '2019-09-02', 299, NULL),
('Luxor', 30, '2019-09-03', 241, NULL),
('Luxor', 30, '2019-09-04', 242, NULL),
('Luxor', 30, '2019-09-05', 349, NULL),
('Luxor', 30, '2019-09-06', 357, NULL),
('Luxor', 30, '2019-09-07', 263, NULL),
('Luxor', 30, '2019-09-08', 251, NULL),
('Luxor', 30, '2019-09-09', 171, NULL),
('Luxor', 30, '2019-09-10', 110, NULL),
('Luxor', 30, '2019-09-11', 188, NULL),
('Luxor', 30, '2019-09-12', 148, NULL),
('Luxor', 30, '2019-09-13', 141, NULL),
('Luxor', 30, '2019-09-14', 157, NULL),
('Luxor', 30, '2019-09-15', 133, NULL),
('Luxor', 30, '2019-09-16', 182, NULL),
('Luxor', 30, '2019-09-17', 312, NULL),
('Luxor', 30, '2019-09-18', 101, NULL),
('Luxor', 30, '2019-09-19', 334, NULL),
('Luxor', 30, '2019-09-20', 237, NULL),
('Luxor', 30, '2019-09-21', 114, NULL),
('Luxor', 30, '2019-09-22', 175, NULL),
('Luxor', 30, '2019-09-23', 124, NULL),
('Luxor', 30, '2019-09-24', 191, NULL),
('Luxor', 30, '2019-09-25', 278, NULL),
('Luxor', 30, '2019-09-26', 377, NULL),
('Luxor', 30, '2019-09-27', 243, NULL),
('Luxor', 30, '2019-09-28', 274, NULL),
('Luxor', 30, '2019-09-29', 103, NULL),
('Luxor', 30, '2019-09-30', 198, NULL),
('Luxor', 30, '2019-10-01', 118, NULL),
('Luxor', 30, '2019-10-02', 111, NULL),
('Luxor', 30, '2019-10-03', 373, NULL),
('Luxor', 30, '2019-10-04', 208, NULL),
('Luxor', 30, '2019-10-05', 202, NULL),
('Luxor', 30, '2019-10-06', 365, NULL),
('Luxor', 30, '2019-10-07', 149, NULL),
('Luxor', 30, '2019-10-08', 202, NULL),
('Luxor', 30, '2019-10-09', 235, NULL),
('Luxor', 30, '2019-10-10', 179, NULL),
('Luxor', 30, '2019-10-11', 168, NULL),
('Luxor', 30, '2019-10-12', 293, NULL),
('Luxor', 30, '2019-10-13', 275, NULL),
('Luxor', 30, '2019-10-14', 253, NULL),
('Luxor', 30, '2019-10-15', 370, NULL),
('Luxor', 30, '2019-10-16', 339, NULL),
('Luxor', 30, '2019-10-17', 301, NULL),
('Luxor', 30, '2019-10-18', 197, NULL),
('Luxor', 30, '2019-10-19', 288, NULL),
('Luxor', 30, '2019-10-20', 385, NULL),
('Luxor', 30, '2019-10-21', 193, NULL),
('Luxor', 30, '2019-10-22', 286, NULL),
('Luxor', 30, '2019-10-23', 243, NULL),
('Luxor', 30, '2019-10-24', 292, NULL),
('Luxor', 30, '2019-10-25', 251, NULL),
('Luxor', 30, '2019-10-26', 230, NULL),
('Luxor', 30, '2019-10-27', 180, NULL),
('Luxor', 30, '2019-10-28', 186, NULL),
('Luxor', 30, '2019-10-29', 289, NULL),
('Luxor', 30, '2019-10-30', 317, NULL),
('Luxor', 30, '2019-10-31', 364, NULL),
('Luxor', 30, '2019-11-01', 344, NULL),
('Luxor', 30, '2019-11-02', 103, NULL),
('Luxor', 30, '2019-11-03', 379, NULL),
('Luxor', 30, '2019-11-04', 240, NULL),
('Luxor', 30, '2019-11-05', 245, NULL),
('Luxor', 30, '2019-11-06', 345, NULL),
('Luxor', 30, '2019-11-07', 185, NULL),
('Luxor', 30, '2019-11-08', 275, NULL),
('Luxor', 30, '2019-11-09', 283, NULL),
('Luxor', 30, '2019-11-10', 114, NULL),
('Luxor', 30, '2019-11-11', 388, NULL),
('Luxor', 30, '2019-11-12', 337, NULL),
('Luxor', 30, '2019-11-13', 398, NULL),
('Luxor', 30, '2019-11-14', 295, NULL),
('Luxor', 30, '2019-11-15', 159, NULL),
('Luxor', 30, '2019-11-16', 175, NULL),
('Luxor', 30, '2019-11-17', 139, NULL),
('Luxor', 30, '2019-11-18', 345, NULL),
('Luxor', 30, '2019-11-19', 335, NULL),
('Luxor', 30, '2019-11-20', 116, NULL),
('Luxor', 30, '2019-11-21', 359, NULL),
('Luxor', 30, '2019-11-22', 103, NULL),
('Luxor', 30, '2019-11-23', 140, NULL),
('Luxor', 30, '2019-11-24', 290, NULL),
('Luxor', 30, '2019-11-25', 253, NULL),
('Luxor', 30, '2019-11-26', 100, NULL),
('Luxor', 30, '2019-11-27', 305, NULL),
('Luxor', 30, '2019-11-28', 239, NULL),
('Luxor', 30, '2019-11-29', 127, NULL),
('Luxor', 30, '2019-11-30', 182, NULL),
('Luxor', 30, '2019-12-01', 163, NULL),
('Luxor', 30, '2019-12-02', 118, NULL),
('Luxor', 30, '2019-12-03', 164, NULL),
('Luxor', 30, '2019-12-04', 183, NULL),
('Luxor', 30, '2019-12-05', 239, NULL),
('Luxor', 30, '2019-12-06', 130, NULL),
('Luxor', 30, '2019-12-07', 159, NULL),
('Luxor', 30, '2019-12-08', 166, NULL),
('Luxor', 30, '2019-12-09', 104, NULL),
('Luxor', 30, '2019-12-10', 372, NULL),
('Luxor', 30, '2019-12-11', 243, NULL),
('Luxor', 30, '2019-12-12', 219, NULL),
('Luxor', 30, '2019-12-13', 252, NULL),
('Luxor', 30, '2019-12-14', 386, NULL),
('Luxor', 30, '2019-12-15', 180, NULL),
('Luxor', 30, '2019-12-16', 225, NULL),
('Luxor', 30, '2019-12-17', 151, NULL),
('Luxor', 30, '2019-12-18', 371, NULL),
('Luxor', 30, '2019-12-19', 378, NULL),
('Luxor', 30, '2019-12-20', 308, NULL),
('Luxor', 30, '2019-12-21', 148, NULL),
('Luxor', 30, '2019-12-22', 141, NULL),
('Luxor', 30, '2019-12-23', 156, NULL),
('Luxor', 30, '2019-12-24', 150, NULL),
('Luxor', 30, '2019-12-25', 136, NULL),
('Luxor', 30, '2019-12-26', 290, NULL),
('Luxor', 30, '2019-12-27', 214, NULL),
('Luxor', 30, '2019-12-28', 366, NULL),
('Luxor', 30, '2019-12-29', 301, NULL),
('Luxor', 30, '2019-12-30', 302, NULL),
('Luxor', 30, '2019-12-31', 399, NULL),
('Luxor', 30, '2020-01-01', 145, NULL),
('Luxor', 30, '2020-01-02', 369, NULL),
('Luxor', 30, '2020-01-03', 290, NULL),
('Luxor', 30, '2020-01-04', 133, NULL),
('Luxor', 30, '2020-01-05', 311, NULL),
('Luxor', 30, '2020-01-06', 294, NULL),
('Luxor', 30, '2020-01-07', 148, NULL),
('Luxor', 30, '2020-01-08', 220, NULL),
('Luxor', 30, '2020-01-09', 310, NULL),
('Luxor', 30, '2020-01-10', 200, NULL),
('Luxor', 30, '2020-01-11', 364, NULL),
('Luxor', 30, '2020-01-12', 342, NULL),
('Luxor', 30, '2020-01-13', 197, NULL),
('Luxor', 30, '2020-01-14', 284, NULL),
('Luxor', 30, '2020-01-15', 109, NULL),
('Luxor', 30, '2020-01-16', 231, NULL),
('Luxor', 30, '2020-01-17', 195, NULL),
('Luxor', 30, '2020-01-18', 398, NULL),
('Luxor', 30, '2020-01-19', 387, NULL),
('Luxor', 30, '2020-01-20', 284, NULL),
('Luxor', 30, '2020-01-21', 183, NULL),
('Luxor', 30, '2020-01-22', 172, NULL),
('Luxor', 30, '2020-01-23', 296, NULL),
('Luxor', 30, '2020-01-24', 107, NULL),
('Luxor', 30, '2020-01-25', 157, NULL),
('Luxor', 30, '2020-01-26', 116, NULL),
('Luxor', 30, '2020-01-27', 112, NULL),
('Luxor', 30, '2020-01-28', 150, NULL),
('Luxor', 30, '2020-01-29', 345, NULL),
('Luxor', 30, '2020-01-30', 212, NULL),
('Luxor', 30, '2020-01-31', 394, NULL),
('Luxor', 30, '2020-02-01', 366, NULL),
('Luxor', 30, '2020-02-02', 126, NULL),
('Luxor', 30, '2020-02-03', 349, NULL),
('Luxor', 30, '2020-02-04', 290, NULL),
('Luxor', 33, '2019-01-01', 124, NULL),
('Luxor', 33, '2019-01-02', 204, NULL),
('Luxor', 33, '2019-01-03', 206, NULL),
('Luxor', 33, '2019-01-04', 331, NULL),
('Luxor', 33, '2019-01-05', 236, NULL),
('Luxor', 33, '2019-01-06', 355, NULL),
('Luxor', 33, '2019-01-07', 113, NULL),
('Luxor', 33, '2019-01-08', 318, NULL),
('Luxor', 33, '2019-01-09', 278, NULL),
('Luxor', 33, '2019-01-10', 342, NULL),
('Luxor', 33, '2019-01-11', 239, NULL),
('Luxor', 33, '2019-01-12', 167, NULL),
('Luxor', 33, '2019-01-13', 298, NULL),
('Luxor', 33, '2019-01-14', 278, NULL),
('Luxor', 33, '2019-01-15', 337, NULL),
('Luxor', 33, '2019-01-16', 203, NULL),
('Luxor', 33, '2019-01-17', 378, NULL),
('Luxor', 33, '2019-01-18', 233, NULL),
('Luxor', 33, '2019-01-19', 104, NULL),
('Luxor', 33, '2019-01-20', 283, NULL),
('Luxor', 33, '2019-01-21', 193, NULL),
('Luxor', 33, '2019-01-22', 249, NULL),
('Luxor', 33, '2019-01-23', 170, NULL),
('Luxor', 33, '2019-01-24', 206, NULL),
('Luxor', 33, '2019-01-25', 146, NULL),
('Luxor', 33, '2019-01-26', 296, NULL),
('Luxor', 33, '2019-01-27', 163, NULL),
('Luxor', 33, '2019-01-28', 295, NULL),
('Luxor', 33, '2019-01-29', 208, NULL),
('Luxor', 33, '2019-01-30', 240, NULL),
('Luxor', 33, '2019-01-31', 357, NULL),
('Luxor', 33, '2019-02-01', 218, NULL),
('Luxor', 33, '2019-02-02', 334, NULL),
('Luxor', 33, '2019-02-03', 248, NULL),
('Luxor', 33, '2019-02-04', 119, NULL),
('Luxor', 33, '2019-02-05', 125, NULL),
('Luxor', 33, '2019-02-06', 185, NULL),
('Luxor', 33, '2019-02-07', 365, NULL),
('Luxor', 33, '2019-02-08', 198, NULL),
('Luxor', 33, '2019-02-09', 369, NULL),
('Luxor', 33, '2019-02-10', 211, NULL),
('Luxor', 33, '2019-02-11', 187, NULL),
('Luxor', 33, '2019-02-12', 243, NULL),
('Luxor', 33, '2019-02-13', 200, NULL),
('Luxor', 33, '2019-02-14', 158, NULL),
('Luxor', 33, '2019-02-15', 394, NULL),
('Luxor', 33, '2019-02-16', 346, NULL),
('Luxor', 33, '2019-02-17', 274, NULL),
('Luxor', 33, '2019-02-18', 139, NULL),
('Luxor', 33, '2019-02-19', 245, NULL),
('Luxor', 33, '2019-02-20', 297, NULL),
('Luxor', 33, '2019-02-21', 140, NULL),
('Luxor', 33, '2019-02-22', 146, NULL),
('Luxor', 33, '2019-02-23', 188, NULL),
('Luxor', 33, '2019-02-24', 144, NULL),
('Luxor', 33, '2019-02-25', 142, NULL),
('Luxor', 33, '2019-02-26', 385, NULL),
('Luxor', 33, '2019-02-27', 354, NULL),
('Luxor', 33, '2019-02-28', 236, NULL),
('Luxor', 33, '2019-03-01', 231, NULL),
('Luxor', 33, '2019-03-02', 215, NULL),
('Luxor', 33, '2019-03-03', 275, NULL),
('Luxor', 33, '2019-03-04', 339, NULL),
('Luxor', 33, '2019-03-05', 285, NULL),
('Luxor', 33, '2019-03-06', 195, NULL),
('Luxor', 33, '2019-03-07', 320, NULL),
('Luxor', 33, '2019-03-08', 219, NULL),
('Luxor', 33, '2019-03-09', 219, NULL),
('Luxor', 33, '2019-03-10', 350, NULL),
('Luxor', 33, '2019-03-11', 111, NULL),
('Luxor', 33, '2019-03-12', 277, NULL),
('Luxor', 33, '2019-03-13', 105, NULL),
('Luxor', 33, '2019-03-14', 104, NULL),
('Luxor', 33, '2019-03-15', 225, NULL),
('Luxor', 33, '2019-03-16', 393, NULL),
('Luxor', 33, '2019-03-17', 182, NULL),
('Luxor', 33, '2019-03-18', 313, NULL),
('Luxor', 33, '2019-03-19', 103, NULL),
('Luxor', 33, '2019-03-20', 205, NULL),
('Luxor', 33, '2019-03-21', 152, NULL),
('Luxor', 33, '2019-03-22', 109, NULL),
('Luxor', 33, '2019-03-23', 182, NULL),
('Luxor', 33, '2019-03-24', 206, NULL),
('Luxor', 33, '2019-03-25', 319, NULL),
('Luxor', 33, '2019-03-26', 371, NULL),
('Luxor', 33, '2019-03-27', 243, NULL),
('Luxor', 33, '2019-03-28', 235, NULL),
('Luxor', 33, '2019-03-29', 109, NULL),
('Luxor', 33, '2019-03-30', 113, NULL),
('Luxor', 33, '2019-03-31', 229, NULL),
('Luxor', 33, '2019-04-01', 172, NULL),
('Luxor', 33, '2019-04-02', 336, NULL),
('Luxor', 33, '2019-04-03', 322, NULL),
('Luxor', 33, '2019-04-04', 198, NULL),
('Luxor', 33, '2019-04-05', 106, NULL),
('Luxor', 33, '2019-04-06', 149, NULL),
('Luxor', 33, '2019-04-07', 130, NULL),
('Luxor', 33, '2019-04-08', 335, NULL),
('Luxor', 33, '2019-04-09', 121, NULL),
('Luxor', 33, '2019-04-10', 309, NULL),
('Luxor', 33, '2019-04-11', 102, NULL),
('Luxor', 33, '2019-04-12', 378, NULL),
('Luxor', 33, '2019-04-13', 340, NULL),
('Luxor', 33, '2019-04-14', 172, NULL),
('Luxor', 33, '2019-04-15', 363, NULL),
('Luxor', 33, '2019-04-16', 123, NULL),
('Luxor', 33, '2019-04-17', 276, NULL),
('Luxor', 33, '2019-04-18', 194, NULL),
('Luxor', 33, '2019-04-19', 294, NULL),
('Luxor', 33, '2019-04-20', 102, NULL),
('Luxor', 33, '2019-04-21', 301, NULL),
('Luxor', 33, '2019-04-22', 202, NULL),
('Luxor', 33, '2019-04-23', 190, NULL),
('Luxor', 33, '2019-04-24', 132, NULL),
('Luxor', 33, '2019-04-25', 344, NULL),
('Luxor', 33, '2019-04-26', 213, NULL),
('Luxor', 33, '2019-04-27', 226, NULL),
('Luxor', 33, '2019-04-28', 231, NULL),
('Luxor', 33, '2019-04-29', 124, NULL),
('Luxor', 33, '2019-04-30', 380, NULL),
('Luxor', 33, '2019-05-01', 115, NULL),
('Luxor', 33, '2019-05-02', 251, NULL),
('Luxor', 33, '2019-05-03', 108, NULL),
('Luxor', 33, '2019-05-04', 209, NULL),
('Luxor', 33, '2019-05-05', 165, NULL),
('Luxor', 33, '2019-05-06', 209, NULL),
('Luxor', 33, '2019-05-07', 345, NULL),
('Luxor', 33, '2019-05-08', 250, NULL),
('Luxor', 33, '2019-05-09', 358, NULL),
('Luxor', 33, '2019-05-10', 302, NULL),
('Luxor', 33, '2019-05-11', 267, NULL),
('Luxor', 33, '2019-05-12', 358, NULL),
('Luxor', 33, '2019-05-13', 177, NULL),
('Luxor', 33, '2019-05-14', 352, NULL),
('Luxor', 33, '2019-05-15', 242, NULL),
('Luxor', 33, '2019-05-16', 279, NULL),
('Luxor', 33, '2019-05-17', 121, NULL),
('Luxor', 33, '2019-05-18', 206, NULL),
('Luxor', 33, '2019-05-19', 365, NULL),
('Luxor', 33, '2019-05-20', 176, NULL),
('Luxor', 33, '2019-05-21', 207, NULL),
('Luxor', 33, '2019-05-22', 234, NULL),
('Luxor', 33, '2019-05-23', 195, NULL),
('Luxor', 33, '2019-05-24', 373, NULL),
('Luxor', 33, '2019-05-25', 325, NULL),
('Luxor', 33, '2019-05-26', 273, NULL),
('Luxor', 33, '2019-05-27', 143, NULL),
('Luxor', 33, '2019-05-28', 130, NULL),
('Luxor', 33, '2019-05-29', 258, NULL),
('Luxor', 33, '2019-05-30', 174, NULL),
('Luxor', 33, '2019-05-31', 397, NULL),
('Luxor', 33, '2019-06-01', 116, NULL),
('Luxor', 33, '2019-06-02', 258, NULL),
('Luxor', 33, '2019-06-03', 330, NULL),
('Luxor', 33, '2019-06-04', 351, NULL),
('Luxor', 33, '2019-06-05', 241, NULL),
('Luxor', 33, '2019-06-06', 383, NULL),
('Luxor', 33, '2019-06-07', 127, NULL),
('Luxor', 33, '2019-06-08', 279, NULL),
('Luxor', 33, '2019-06-09', 155, NULL),
('Luxor', 33, '2019-06-10', 196, NULL),
('Luxor', 33, '2019-06-11', 254, NULL),
('Luxor', 33, '2019-06-12', 180, NULL),
('Luxor', 33, '2019-06-13', 193, NULL),
('Luxor', 33, '2019-06-14', 351, NULL),
('Luxor', 33, '2019-06-15', 254, NULL),
('Luxor', 33, '2019-06-16', 349, NULL),
('Luxor', 33, '2019-06-17', 109, NULL),
('Luxor', 33, '2019-06-18', 252, NULL),
('Luxor', 33, '2019-06-19', 289, NULL),
('Luxor', 33, '2019-06-20', 333, NULL),
('Luxor', 33, '2019-06-21', 336, NULL),
('Luxor', 33, '2019-06-22', 357, NULL),
('Luxor', 33, '2019-06-23', 210, NULL),
('Luxor', 33, '2019-06-24', 217, NULL),
('Luxor', 33, '2019-06-25', 253, NULL),
('Luxor', 33, '2019-06-26', 131, NULL),
('Luxor', 33, '2019-06-27', 188, NULL),
('Luxor', 33, '2019-06-28', 299, NULL),
('Luxor', 33, '2019-06-29', 361, NULL),
('Luxor', 33, '2019-06-30', 319, NULL),
('Luxor', 33, '2019-07-01', 177, NULL),
('Luxor', 33, '2019-07-02', 374, NULL),
('Luxor', 33, '2019-07-03', 127, NULL),
('Luxor', 33, '2019-07-04', 311, NULL),
('Luxor', 33, '2019-07-05', 279, NULL),
('Luxor', 33, '2019-07-06', 190, NULL),
('Luxor', 33, '2019-07-07', 138, NULL),
('Luxor', 33, '2019-07-08', 114, NULL),
('Luxor', 33, '2019-07-09', 136, NULL),
('Luxor', 33, '2019-07-10', 111, NULL),
('Luxor', 33, '2019-07-11', 150, NULL),
('Luxor', 33, '2019-07-12', 104, NULL),
('Luxor', 33, '2019-07-13', 127, NULL),
('Luxor', 33, '2019-07-14', 356, NULL),
('Luxor', 33, '2019-07-15', 339, NULL),
('Luxor', 33, '2019-07-16', 347, NULL),
('Luxor', 33, '2019-07-17', 286, NULL),
('Luxor', 33, '2019-07-18', 188, NULL),
('Luxor', 33, '2019-07-19', 350, NULL),
('Luxor', 33, '2019-07-20', 365, NULL),
('Luxor', 33, '2019-07-21', 350, NULL),
('Luxor', 33, '2019-07-22', 333, NULL),
('Luxor', 33, '2019-07-23', 108, NULL),
('Luxor', 33, '2019-07-24', 361, NULL),
('Luxor', 33, '2019-07-25', 208, NULL),
('Luxor', 33, '2019-07-26', 284, NULL),
('Luxor', 33, '2019-07-27', 266, NULL),
('Luxor', 33, '2019-07-28', 340, NULL),
('Luxor', 33, '2019-07-29', 342, NULL),
('Luxor', 33, '2019-07-30', 392, NULL),
('Luxor', 33, '2019-07-31', 179, NULL),
('Luxor', 33, '2019-08-01', 165, NULL),
('Luxor', 33, '2019-08-02', 117, NULL),
('Luxor', 33, '2019-08-03', 180, NULL),
('Luxor', 33, '2019-08-04', 249, NULL),
('Luxor', 33, '2019-08-05', 160, NULL),
('Luxor', 33, '2019-08-06', 120, NULL),
('Luxor', 33, '2019-08-07', 375, NULL),
('Luxor', 33, '2019-08-08', 386, NULL),
('Luxor', 33, '2019-08-09', 227, NULL),
('Luxor', 33, '2019-08-10', 162, NULL),
('Luxor', 33, '2019-08-11', 214, NULL),
('Luxor', 33, '2019-08-12', 211, NULL),
('Luxor', 33, '2019-08-13', 210, NULL),
('Luxor', 33, '2019-08-14', 362, NULL),
('Luxor', 33, '2019-08-15', 328, NULL),
('Luxor', 33, '2019-08-16', 189, NULL),
('Luxor', 33, '2019-08-17', 348, NULL),
('Luxor', 33, '2019-08-18', 321, NULL),
('Luxor', 33, '2019-08-19', 217, NULL),
('Luxor', 33, '2019-08-20', 254, NULL),
('Luxor', 33, '2019-08-21', 359, NULL),
('Luxor', 33, '2019-08-22', 148, NULL),
('Luxor', 33, '2019-08-23', 143, NULL),
('Luxor', 33, '2019-08-24', 284, NULL),
('Luxor', 33, '2019-08-25', 201, NULL),
('Luxor', 33, '2019-08-26', 223, NULL),
('Luxor', 33, '2019-08-27', 196, NULL),
('Luxor', 33, '2019-08-28', 324, NULL),
('Luxor', 33, '2019-08-29', 123, NULL),
('Luxor', 33, '2019-08-30', 165, NULL),
('Luxor', 33, '2019-08-31', 121, NULL),
('Luxor', 33, '2019-09-01', 148, NULL),
('Luxor', 33, '2019-09-02', 375, NULL),
('Luxor', 33, '2019-09-03', 146, NULL),
('Luxor', 33, '2019-09-04', 340, NULL),
('Luxor', 33, '2019-09-05', 111, NULL),
('Luxor', 33, '2019-09-06', 165, NULL),
('Luxor', 33, '2019-09-07', 387, NULL),
('Luxor', 33, '2019-09-08', 319, NULL),
('Luxor', 33, '2019-09-09', 323, NULL),
('Luxor', 33, '2019-09-10', 229, NULL),
('Luxor', 33, '2019-09-11', 188, NULL),
('Luxor', 33, '2019-09-12', 271, NULL),
('Luxor', 33, '2019-09-13', 380, NULL),
('Luxor', 33, '2019-09-14', 222, NULL),
('Luxor', 33, '2019-09-15', 145, NULL),
('Luxor', 33, '2019-09-16', 198, NULL),
('Luxor', 33, '2019-09-17', 375, NULL),
('Luxor', 33, '2019-09-18', 323, NULL),
('Luxor', 33, '2019-09-19', 330, NULL),
('Luxor', 33, '2019-09-20', 217, NULL),
('Luxor', 33, '2019-09-21', 372, NULL),
('Luxor', 33, '2019-09-22', 109, NULL),
('Luxor', 33, '2019-09-23', 148, NULL),
('Luxor', 33, '2019-09-24', 341, NULL),
('Luxor', 33, '2019-09-25', 148, NULL),
('Luxor', 33, '2019-09-26', 131, NULL),
('Luxor', 33, '2019-09-27', 244, NULL),
('Luxor', 33, '2019-09-28', 307, NULL),
('Luxor', 33, '2019-09-29', 259, NULL),
('Luxor', 33, '2019-09-30', 259, NULL),
('Luxor', 33, '2019-10-01', 367, NULL),
('Luxor', 33, '2019-10-02', 249, NULL),
('Luxor', 33, '2019-10-03', 332, NULL),
('Luxor', 33, '2019-10-04', 306, NULL),
('Luxor', 33, '2019-10-05', 313, NULL),
('Luxor', 33, '2019-10-06', 295, NULL),
('Luxor', 33, '2019-10-07', 352, NULL),
('Luxor', 33, '2019-10-08', 331, NULL),
('Luxor', 33, '2019-10-09', 362, NULL),
('Luxor', 33, '2019-10-10', 156, NULL),
('Luxor', 33, '2019-10-11', 149, NULL),
('Luxor', 33, '2019-10-12', 282, NULL),
('Luxor', 33, '2019-10-13', 348, NULL),
('Luxor', 33, '2019-10-14', 178, NULL),
('Luxor', 33, '2019-10-15', 331, NULL),
('Luxor', 33, '2019-10-16', 354, NULL),
('Luxor', 33, '2019-10-17', 220, NULL),
('Luxor', 33, '2019-10-18', 286, NULL),
('Luxor', 33, '2019-10-19', 171, NULL),
('Luxor', 33, '2019-10-20', 393, NULL),
('Luxor', 33, '2019-10-21', 119, NULL),
('Luxor', 33, '2019-10-22', 197, NULL),
('Luxor', 33, '2019-10-23', 114, NULL),
('Luxor', 33, '2019-10-24', 320, NULL),
('Luxor', 33, '2019-10-25', 167, NULL),
('Luxor', 33, '2019-10-26', 316, NULL),
('Luxor', 33, '2019-10-27', 337, NULL),
('Luxor', 33, '2019-10-28', 166, NULL),
('Luxor', 33, '2019-10-29', 250, NULL),
('Luxor', 33, '2019-10-30', 278, NULL),
('Luxor', 33, '2019-10-31', 218, NULL),
('Luxor', 33, '2019-11-01', 311, NULL),
('Luxor', 33, '2019-11-02', 367, NULL),
('Luxor', 33, '2019-11-03', 114, NULL),
('Luxor', 33, '2019-11-04', 203, NULL),
('Luxor', 33, '2019-11-05', 303, NULL),
('Luxor', 33, '2019-11-06', 177, NULL),
('Luxor', 33, '2019-11-07', 122, NULL),
('Luxor', 33, '2019-11-08', 259, NULL),
('Luxor', 33, '2019-11-09', 324, NULL),
('Luxor', 33, '2019-11-10', 306, NULL),
('Luxor', 33, '2019-11-11', 292, NULL),
('Luxor', 33, '2019-11-12', 340, NULL),
('Luxor', 33, '2019-11-13', 352, NULL),
('Luxor', 33, '2019-11-14', 360, NULL),
('Luxor', 33, '2019-11-15', 186, NULL),
('Luxor', 33, '2019-11-16', 398, NULL),
('Luxor', 33, '2019-11-17', 136, NULL),
('Luxor', 33, '2019-11-18', 383, NULL),
('Luxor', 33, '2019-11-19', 147, NULL),
('Luxor', 33, '2019-11-20', 207, NULL),
('Luxor', 33, '2019-11-21', 166, NULL),
('Luxor', 33, '2019-11-22', 154, NULL),
('Luxor', 33, '2019-11-23', 379, NULL),
('Luxor', 33, '2019-11-24', 216, NULL),
('Luxor', 33, '2019-11-25', 146, NULL),
('Luxor', 33, '2019-11-26', 374, NULL),
('Luxor', 33, '2019-11-27', 239, NULL),
('Luxor', 33, '2019-11-28', 137, NULL),
('Luxor', 33, '2019-11-29', 249, NULL),
('Luxor', 33, '2019-11-30', 101, NULL),
('Luxor', 33, '2019-12-01', 189, NULL),
('Luxor', 33, '2019-12-02', 318, NULL),
('Luxor', 33, '2019-12-03', 203, NULL),
('Luxor', 33, '2019-12-04', 186, NULL),
('Luxor', 33, '2019-12-05', 241, NULL),
('Luxor', 33, '2019-12-06', 343, NULL),
('Luxor', 33, '2019-12-07', 151, NULL),
('Luxor', 33, '2019-12-08', 292, NULL),
('Luxor', 33, '2019-12-09', 208, NULL),
('Luxor', 33, '2019-12-10', 123, NULL),
('Luxor', 33, '2019-12-11', 394, NULL),
('Luxor', 33, '2019-12-12', 155, NULL),
('Luxor', 33, '2019-12-13', 237, NULL),
('Luxor', 33, '2019-12-14', 299, NULL),
('Luxor', 33, '2019-12-15', 192, NULL),
('Luxor', 33, '2019-12-16', 399, NULL),
('Luxor', 33, '2019-12-17', 139, NULL),
('Luxor', 33, '2019-12-18', 173, NULL),
('Luxor', 33, '2019-12-19', 234, NULL),
('Luxor', 33, '2019-12-20', 279, NULL),
('Luxor', 33, '2019-12-21', 129, NULL),
('Luxor', 33, '2019-12-22', 252, NULL),
('Luxor', 33, '2019-12-23', 390, NULL),
('Luxor', 33, '2019-12-24', 101, NULL),
('Luxor', 33, '2019-12-25', 242, NULL),
('Luxor', 33, '2019-12-26', 323, NULL),
('Luxor', 33, '2019-12-27', 152, NULL),
('Luxor', 33, '2019-12-28', 221, NULL),
('Luxor', 33, '2019-12-29', 204, NULL),
('Luxor', 33, '2019-12-30', 383, NULL),
('Luxor', 33, '2019-12-31', 324, NULL),
('Luxor', 33, '2020-01-01', 111, NULL),
('Luxor', 33, '2020-01-02', 294, NULL),
('Luxor', 33, '2020-01-03', 249, NULL),
('Luxor', 33, '2020-01-04', 104, NULL),
('Luxor', 33, '2020-01-05', 292, NULL),
('Luxor', 33, '2020-01-06', 261, NULL),
('Luxor', 33, '2020-01-07', 258, NULL),
('Luxor', 33, '2020-01-08', 268, NULL),
('Luxor', 33, '2020-01-09', 385, NULL),
('Luxor', 33, '2020-01-10', 328, NULL),
('Luxor', 33, '2020-01-11', 214, NULL),
('Luxor', 33, '2020-01-12', 352, NULL),
('Luxor', 33, '2020-01-13', 319, NULL),
('Luxor', 33, '2020-01-14', 133, NULL),
('Luxor', 33, '2020-01-15', 282, NULL),
('Luxor', 33, '2020-01-16', 181, NULL),
('Luxor', 33, '2020-01-17', 323, NULL),
('Luxor', 33, '2020-01-18', 147, NULL),
('Luxor', 33, '2020-01-19', 175, NULL),
('Luxor', 33, '2020-01-20', 100, NULL),
('Luxor', 33, '2020-01-21', 210, NULL),
('Luxor', 33, '2020-01-22', 241, NULL),
('Luxor', 33, '2020-01-23', 303, NULL),
('Luxor', 33, '2020-01-24', 298, NULL),
('Luxor', 33, '2020-01-25', 184, NULL),
('Luxor', 33, '2020-01-26', 392, NULL),
('Luxor', 33, '2020-01-27', 246, NULL),
('Luxor', 33, '2020-01-28', 359, NULL),
('Luxor', 33, '2020-01-29', 226, NULL),
('Luxor', 33, '2020-01-30', 399, NULL),
('Luxor', 33, '2020-01-31', 282, NULL),
('Luxor', 33, '2020-02-01', 305, NULL),
('Luxor', 33, '2020-02-02', 208, NULL),
('Luxor', 33, '2020-02-03', 196, NULL),
('Luxor', 33, '2020-02-04', 325, NULL),
('Luxor', 47, '2019-01-01', 229, NULL),
('Luxor', 47, '2019-01-02', 253, NULL),
('Luxor', 47, '2019-01-03', 386, NULL),
('Luxor', 47, '2019-01-04', 216, NULL),
('Luxor', 47, '2019-01-05', 137, NULL),
('Luxor', 47, '2019-01-06', 349, NULL),
('Luxor', 47, '2019-01-07', 112, NULL),
('Luxor', 47, '2019-01-08', 136, NULL),
('Luxor', 47, '2019-01-09', 188, NULL),
('Luxor', 47, '2019-01-10', 368, NULL),
('Luxor', 47, '2019-01-11', 264, NULL),
('Luxor', 47, '2019-01-12', 191, NULL),
('Luxor', 47, '2019-01-13', 254, NULL),
('Luxor', 47, '2019-01-14', 299, NULL),
('Luxor', 47, '2019-01-15', 141, NULL),
('Luxor', 47, '2019-01-16', 290, NULL),
('Luxor', 47, '2019-01-17', 349, NULL),
('Luxor', 47, '2019-01-18', 154, NULL),
('Luxor', 47, '2019-01-19', 153, NULL),
('Luxor', 47, '2019-01-20', 309, NULL),
('Luxor', 47, '2019-01-21', 227, NULL),
('Luxor', 47, '2019-01-22', 174, NULL),
('Luxor', 47, '2019-01-23', 200, NULL),
('Luxor', 47, '2019-01-24', 187, NULL),
('Luxor', 47, '2019-01-25', 223, NULL),
('Luxor', 47, '2019-01-26', 250, NULL),
('Luxor', 47, '2019-01-27', 336, NULL),
('Luxor', 47, '2019-01-28', 341, NULL),
('Luxor', 47, '2019-01-29', 366, NULL),
('Luxor', 47, '2019-01-30', 268, NULL),
('Luxor', 47, '2019-01-31', 390, NULL),
('Luxor', 47, '2019-02-01', 320, NULL),
('Luxor', 47, '2019-02-02', 295, NULL),
('Luxor', 47, '2019-02-03', 325, NULL),
('Luxor', 47, '2019-02-04', 224, NULL),
('Luxor', 47, '2019-02-05', 218, NULL),
('Luxor', 47, '2019-02-06', 146, NULL),
('Luxor', 47, '2019-02-07', 175, NULL),
('Luxor', 47, '2019-02-08', 144, NULL),
('Luxor', 47, '2019-02-09', 151, NULL),
('Luxor', 47, '2019-02-10', 164, NULL),
('Luxor', 47, '2019-02-11', 115, NULL),
('Luxor', 47, '2019-02-12', 366, NULL),
('Luxor', 47, '2019-02-13', 332, NULL),
('Luxor', 47, '2019-02-14', 299, NULL),
('Luxor', 47, '2019-02-15', 225, NULL),
('Luxor', 47, '2019-02-16', 134, NULL),
('Luxor', 47, '2019-02-17', 357, NULL),
('Luxor', 47, '2019-02-18', 186, NULL),
('Luxor', 47, '2019-02-19', 136, NULL),
('Luxor', 47, '2019-02-20', 346, NULL),
('Luxor', 47, '2019-02-21', 116, NULL),
('Luxor', 47, '2019-02-22', 318, NULL),
('Luxor', 47, '2019-02-23', 194, NULL),
('Luxor', 47, '2019-02-24', 115, NULL),
('Luxor', 47, '2019-02-25', 355, NULL),
('Luxor', 47, '2019-02-26', 200, NULL),
('Luxor', 47, '2019-02-27', 132, NULL),
('Luxor', 47, '2019-02-28', 211, NULL),
('Luxor', 47, '2019-03-01', 315, NULL),
('Luxor', 47, '2019-03-02', 163, NULL),
('Luxor', 47, '2019-03-03', 305, NULL),
('Luxor', 47, '2019-03-04', 200, NULL),
('Luxor', 47, '2019-03-05', 363, NULL),
('Luxor', 47, '2019-03-06', 233, NULL),
('Luxor', 47, '2019-03-07', 301, NULL),
('Luxor', 47, '2019-03-08', 127, NULL),
('Luxor', 47, '2019-03-09', 312, NULL),
('Luxor', 47, '2019-03-10', 272, NULL),
('Luxor', 47, '2019-03-11', 245, NULL),
('Luxor', 47, '2019-03-12', 179, NULL),
('Luxor', 47, '2019-03-13', 393, NULL),
('Luxor', 47, '2019-03-14', 235, NULL),
('Luxor', 47, '2019-03-15', 179, NULL),
('Luxor', 47, '2019-03-16', 180, NULL),
('Luxor', 47, '2019-03-17', 356, NULL),
('Luxor', 47, '2019-03-18', 389, NULL),
('Luxor', 47, '2019-03-19', 387, NULL),
('Luxor', 47, '2019-03-20', 271, NULL),
('Luxor', 47, '2019-03-21', 318, NULL),
('Luxor', 47, '2019-03-22', 280, NULL),
('Luxor', 47, '2019-03-23', 380, NULL),
('Luxor', 47, '2019-03-24', 354, NULL),
('Luxor', 47, '2019-03-25', 179, NULL),
('Luxor', 47, '2019-03-26', 325, NULL),
('Luxor', 47, '2019-03-27', 279, NULL),
('Luxor', 47, '2019-03-28', 270, NULL),
('Luxor', 47, '2019-03-29', 369, NULL),
('Luxor', 47, '2019-03-30', 313, NULL),
('Luxor', 47, '2019-03-31', 189, NULL),
('Luxor', 47, '2019-04-01', 127, NULL),
('Luxor', 47, '2019-04-02', 178, NULL),
('Luxor', 47, '2019-04-03', 347, NULL),
('Luxor', 47, '2019-04-04', 101, NULL),
('Luxor', 47, '2019-04-05', 242, NULL),
('Luxor', 47, '2019-04-06', 116, NULL),
('Luxor', 47, '2019-04-07', 180, NULL),
('Luxor', 47, '2019-04-08', 197, NULL),
('Luxor', 47, '2019-04-09', 319, NULL),
('Luxor', 47, '2019-04-10', 184, NULL),
('Luxor', 47, '2019-04-11', 163, NULL),
('Luxor', 47, '2019-04-12', 377, NULL),
('Luxor', 47, '2019-04-13', 221, NULL),
('Luxor', 47, '2019-04-14', 299, NULL),
('Luxor', 47, '2019-04-15', 263, NULL),
('Luxor', 47, '2019-04-16', 353, NULL),
('Luxor', 47, '2019-04-17', 109, NULL),
('Luxor', 47, '2019-04-18', 351, NULL),
('Luxor', 47, '2019-04-19', 269, NULL),
('Luxor', 47, '2019-04-20', 376, NULL),
('Luxor', 47, '2019-04-21', 208, NULL),
('Luxor', 47, '2019-04-22', 285, NULL),
('Luxor', 47, '2019-04-23', 150, NULL),
('Luxor', 47, '2019-04-24', 322, NULL),
('Luxor', 47, '2019-04-25', 339, NULL),
('Luxor', 47, '2019-04-26', 212, NULL),
('Luxor', 47, '2019-04-27', 245, NULL),
('Luxor', 47, '2019-04-28', 258, NULL),
('Luxor', 47, '2019-04-29', 104, NULL),
('Luxor', 47, '2019-04-30', 355, NULL),
('Luxor', 47, '2019-05-01', 176, NULL),
('Luxor', 47, '2019-05-02', 101, NULL),
('Luxor', 47, '2019-05-03', 146, NULL),
('Luxor', 47, '2019-05-04', 353, NULL),
('Luxor', 47, '2019-05-05', 192, NULL),
('Luxor', 47, '2019-05-06', 230, NULL),
('Luxor', 47, '2019-05-07', 242, NULL),
('Luxor', 47, '2019-05-08', 258, NULL),
('Luxor', 47, '2019-05-09', 251, NULL),
('Luxor', 47, '2019-05-10', 337, NULL),
('Luxor', 47, '2019-05-11', 182, NULL),
('Luxor', 47, '2019-05-12', 258, NULL),
('Luxor', 47, '2019-05-13', 373, NULL),
('Luxor', 47, '2019-05-14', 132, NULL),
('Luxor', 47, '2019-05-15', 280, NULL),
('Luxor', 47, '2019-05-16', 339, NULL),
('Luxor', 47, '2019-05-17', 364, NULL),
('Luxor', 47, '2019-05-18', 222, NULL),
('Luxor', 47, '2019-05-19', 395, NULL),
('Luxor', 47, '2019-05-20', 110, NULL),
('Luxor', 47, '2019-05-21', 293, NULL),
('Luxor', 47, '2019-05-22', 329, NULL),
('Luxor', 47, '2019-05-23', 111, NULL),
('Luxor', 47, '2019-05-24', 348, NULL),
('Luxor', 47, '2019-05-25', 144, NULL),
('Luxor', 47, '2019-05-26', 151, NULL),
('Luxor', 47, '2019-05-27', 110, NULL),
('Luxor', 47, '2019-05-28', 197, NULL),
('Luxor', 47, '2019-05-29', 100, NULL),
('Luxor', 47, '2019-05-30', 377, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 47, '2019-05-31', 103, NULL),
('Luxor', 47, '2019-06-01', 257, NULL),
('Luxor', 47, '2019-06-02', 375, NULL),
('Luxor', 47, '2019-06-03', 356, NULL),
('Luxor', 47, '2019-06-04', 120, NULL),
('Luxor', 47, '2019-06-05', 248, NULL),
('Luxor', 47, '2019-06-06', 261, NULL),
('Luxor', 47, '2019-06-07', 122, NULL),
('Luxor', 47, '2019-06-08', 346, NULL),
('Luxor', 47, '2019-06-09', 291, NULL),
('Luxor', 47, '2019-06-10', 353, NULL),
('Luxor', 47, '2019-06-11', 178, NULL),
('Luxor', 47, '2019-06-12', 334, NULL),
('Luxor', 47, '2019-06-13', 343, NULL),
('Luxor', 47, '2019-06-14', 368, NULL),
('Luxor', 47, '2019-06-15', 300, NULL),
('Luxor', 47, '2019-06-16', 181, NULL),
('Luxor', 47, '2019-06-17', 199, NULL),
('Luxor', 47, '2019-06-18', 333, NULL),
('Luxor', 47, '2019-06-19', 151, NULL),
('Luxor', 47, '2019-06-20', 220, NULL),
('Luxor', 47, '2019-06-21', 185, NULL),
('Luxor', 47, '2019-06-22', 326, NULL),
('Luxor', 47, '2019-06-23', 351, NULL),
('Luxor', 47, '2019-06-24', 329, NULL),
('Luxor', 47, '2019-06-25', 302, NULL),
('Luxor', 47, '2019-06-26', 140, NULL),
('Luxor', 47, '2019-06-27', 184, NULL),
('Luxor', 47, '2019-06-28', 183, NULL),
('Luxor', 47, '2019-06-29', 257, NULL),
('Luxor', 47, '2019-06-30', 322, NULL),
('Luxor', 47, '2019-07-01', 285, NULL),
('Luxor', 47, '2019-07-02', 283, NULL),
('Luxor', 47, '2019-07-03', 294, NULL),
('Luxor', 47, '2019-07-04', 259, NULL),
('Luxor', 47, '2019-07-05', 113, NULL),
('Luxor', 47, '2019-07-06', 284, NULL),
('Luxor', 47, '2019-07-07', 359, NULL),
('Luxor', 47, '2019-07-08', 277, NULL),
('Luxor', 47, '2019-07-09', 395, NULL),
('Luxor', 47, '2019-07-10', 185, NULL),
('Luxor', 47, '2019-07-11', 341, NULL),
('Luxor', 47, '2019-07-12', 309, NULL),
('Luxor', 47, '2019-07-13', 345, NULL),
('Luxor', 47, '2019-07-14', 385, NULL),
('Luxor', 47, '2019-07-15', 390, NULL),
('Luxor', 47, '2019-07-16', 346, NULL),
('Luxor', 47, '2019-07-17', 399, NULL),
('Luxor', 47, '2019-07-18', 358, NULL),
('Luxor', 47, '2019-07-19', 333, NULL),
('Luxor', 47, '2019-07-20', 175, NULL),
('Luxor', 47, '2019-07-21', 265, NULL),
('Luxor', 47, '2019-07-22', 289, NULL),
('Luxor', 47, '2019-07-23', 308, NULL),
('Luxor', 47, '2019-07-24', 204, NULL),
('Luxor', 47, '2019-07-25', 347, NULL),
('Luxor', 47, '2019-07-26', 244, NULL),
('Luxor', 47, '2019-07-27', 139, NULL),
('Luxor', 47, '2019-07-28', 285, NULL),
('Luxor', 47, '2019-07-29', 125, NULL),
('Luxor', 47, '2019-07-30', 393, NULL),
('Luxor', 47, '2019-07-31', 273, NULL),
('Luxor', 47, '2019-08-01', 203, NULL),
('Luxor', 47, '2019-08-02', 377, NULL),
('Luxor', 47, '2019-08-03', 278, NULL),
('Luxor', 47, '2019-08-04', 216, NULL),
('Luxor', 47, '2019-08-05', 305, NULL),
('Luxor', 47, '2019-08-06', 184, NULL),
('Luxor', 47, '2019-08-07', 324, NULL),
('Luxor', 47, '2019-08-08', 388, NULL),
('Luxor', 47, '2019-08-09', 378, NULL),
('Luxor', 47, '2019-08-10', 113, NULL),
('Luxor', 47, '2019-08-11', 316, NULL),
('Luxor', 47, '2019-08-12', 254, NULL),
('Luxor', 47, '2019-08-13', 175, NULL),
('Luxor', 47, '2019-08-14', 165, NULL),
('Luxor', 47, '2019-08-15', 196, NULL),
('Luxor', 47, '2019-08-16', 185, NULL),
('Luxor', 47, '2019-08-17', 319, NULL),
('Luxor', 47, '2019-08-18', 371, NULL),
('Luxor', 47, '2019-08-19', 180, NULL),
('Luxor', 47, '2019-08-20', 291, NULL),
('Luxor', 47, '2019-08-21', 353, NULL),
('Luxor', 47, '2019-08-22', 343, NULL),
('Luxor', 47, '2019-08-23', 380, NULL),
('Luxor', 47, '2019-08-24', 394, NULL),
('Luxor', 47, '2019-08-25', 298, NULL),
('Luxor', 47, '2019-08-26', 260, NULL),
('Luxor', 47, '2019-08-27', 125, NULL),
('Luxor', 47, '2019-08-28', 235, NULL),
('Luxor', 47, '2019-08-29', 203, NULL),
('Luxor', 47, '2019-08-30', 384, NULL),
('Luxor', 47, '2019-08-31', 341, NULL),
('Luxor', 47, '2019-09-01', 291, NULL),
('Luxor', 47, '2019-09-02', 280, NULL),
('Luxor', 47, '2019-09-03', 208, NULL),
('Luxor', 47, '2019-09-04', 271, NULL),
('Luxor', 47, '2019-09-05', 310, NULL),
('Luxor', 47, '2019-09-06', 257, NULL),
('Luxor', 47, '2019-09-07', 147, NULL),
('Luxor', 47, '2019-09-08', 143, NULL),
('Luxor', 47, '2019-09-09', 104, NULL),
('Luxor', 47, '2019-09-10', 116, NULL),
('Luxor', 47, '2019-09-11', 276, NULL),
('Luxor', 47, '2019-09-12', 212, NULL),
('Luxor', 47, '2019-09-13', 176, NULL),
('Luxor', 47, '2019-09-14', 240, NULL),
('Luxor', 47, '2019-09-15', 228, NULL),
('Luxor', 47, '2019-09-16', 341, NULL),
('Luxor', 47, '2019-09-17', 242, NULL),
('Luxor', 47, '2019-09-18', 313, NULL),
('Luxor', 47, '2019-09-19', 249, NULL),
('Luxor', 47, '2019-09-20', 275, NULL),
('Luxor', 47, '2019-09-21', 216, NULL),
('Luxor', 47, '2019-09-22', 220, NULL),
('Luxor', 47, '2019-09-23', 270, NULL),
('Luxor', 47, '2019-09-24', 134, NULL),
('Luxor', 47, '2019-09-25', 108, NULL),
('Luxor', 47, '2019-09-26', 324, NULL),
('Luxor', 47, '2019-09-27', 393, NULL),
('Luxor', 47, '2019-09-28', 312, NULL),
('Luxor', 47, '2019-09-29', 284, NULL),
('Luxor', 47, '2019-09-30', 301, NULL),
('Luxor', 47, '2019-10-01', 181, NULL),
('Luxor', 47, '2019-10-02', 211, NULL),
('Luxor', 47, '2019-10-03', 142, NULL),
('Luxor', 47, '2019-10-04', 205, NULL),
('Luxor', 47, '2019-10-05', 259, NULL),
('Luxor', 47, '2019-10-06', 280, NULL),
('Luxor', 47, '2019-10-07', 315, NULL),
('Luxor', 47, '2019-10-08', 351, NULL),
('Luxor', 47, '2019-10-09', 105, NULL),
('Luxor', 47, '2019-10-10', 143, NULL),
('Luxor', 47, '2019-10-11', 143, NULL),
('Luxor', 47, '2019-10-12', 134, NULL),
('Luxor', 47, '2019-10-13', 219, NULL),
('Luxor', 47, '2019-10-14', 331, NULL),
('Luxor', 47, '2019-10-15', 145, NULL),
('Luxor', 47, '2019-10-16', 352, NULL),
('Luxor', 47, '2019-10-17', 396, NULL),
('Luxor', 47, '2019-10-18', 140, NULL),
('Luxor', 47, '2019-10-19', 192, NULL),
('Luxor', 47, '2019-10-20', 110, NULL),
('Luxor', 47, '2019-10-21', 218, NULL),
('Luxor', 47, '2019-10-22', 326, NULL),
('Luxor', 47, '2019-10-23', 343, NULL),
('Luxor', 47, '2019-10-24', 322, NULL),
('Luxor', 47, '2019-10-25', 284, NULL),
('Luxor', 47, '2019-10-26', 193, NULL),
('Luxor', 47, '2019-10-27', 144, NULL),
('Luxor', 47, '2019-10-28', 171, NULL),
('Luxor', 47, '2019-10-29', 285, NULL),
('Luxor', 47, '2019-10-30', 339, NULL),
('Luxor', 47, '2019-10-31', 198, NULL),
('Luxor', 47, '2019-11-01', 123, NULL),
('Luxor', 47, '2019-11-02', 227, NULL),
('Luxor', 47, '2019-11-03', 231, NULL),
('Luxor', 47, '2019-11-04', 195, NULL),
('Luxor', 47, '2019-11-05', 383, NULL),
('Luxor', 47, '2019-11-06', 353, NULL),
('Luxor', 47, '2019-11-07', 252, NULL),
('Luxor', 47, '2019-11-08', 368, NULL),
('Luxor', 47, '2019-11-09', 371, NULL),
('Luxor', 47, '2019-11-10', 186, NULL),
('Luxor', 47, '2019-11-11', 197, NULL),
('Luxor', 47, '2019-11-12', 290, NULL),
('Luxor', 47, '2019-11-13', 170, NULL),
('Luxor', 47, '2019-11-14', 217, NULL),
('Luxor', 47, '2019-11-15', 355, NULL),
('Luxor', 47, '2019-11-16', 166, NULL),
('Luxor', 47, '2019-11-17', 164, NULL),
('Luxor', 47, '2019-11-18', 181, NULL),
('Luxor', 47, '2019-11-19', 229, NULL),
('Luxor', 47, '2019-11-20', 288, NULL),
('Luxor', 47, '2019-11-21', 255, NULL),
('Luxor', 47, '2019-11-22', 361, NULL),
('Luxor', 47, '2019-11-23', 175, NULL),
('Luxor', 47, '2019-11-24', 110, NULL),
('Luxor', 47, '2019-11-25', 170, NULL),
('Luxor', 47, '2019-11-26', 272, NULL),
('Luxor', 47, '2019-11-27', 180, NULL),
('Luxor', 47, '2019-11-28', 169, NULL),
('Luxor', 47, '2019-11-29', 162, NULL),
('Luxor', 47, '2019-11-30', 159, NULL),
('Luxor', 47, '2019-12-01', 355, NULL),
('Luxor', 47, '2019-12-02', 237, NULL),
('Luxor', 47, '2019-12-03', 126, NULL),
('Luxor', 47, '2019-12-04', 283, NULL),
('Luxor', 47, '2019-12-05', 388, NULL),
('Luxor', 47, '2019-12-06', 323, NULL),
('Luxor', 47, '2019-12-07', 181, NULL),
('Luxor', 47, '2019-12-08', 263, NULL),
('Luxor', 47, '2019-12-09', 330, NULL),
('Luxor', 47, '2019-12-10', 300, NULL),
('Luxor', 47, '2019-12-11', 244, NULL),
('Luxor', 47, '2019-12-12', 317, NULL),
('Luxor', 47, '2019-12-13', 332, NULL),
('Luxor', 47, '2019-12-14', 239, NULL),
('Luxor', 47, '2019-12-15', 321, NULL),
('Luxor', 47, '2019-12-16', 319, NULL),
('Luxor', 47, '2019-12-17', 141, NULL),
('Luxor', 47, '2019-12-18', 253, NULL),
('Luxor', 47, '2019-12-19', 237, NULL),
('Luxor', 47, '2019-12-20', 372, NULL),
('Luxor', 47, '2019-12-21', 103, NULL),
('Luxor', 47, '2019-12-22', 140, NULL),
('Luxor', 47, '2019-12-23', 183, NULL),
('Luxor', 47, '2019-12-24', 255, NULL),
('Luxor', 47, '2019-12-25', 101, NULL),
('Luxor', 47, '2019-12-26', 345, NULL),
('Luxor', 47, '2019-12-27', 316, NULL),
('Luxor', 47, '2019-12-28', 210, NULL),
('Luxor', 47, '2019-12-29', 318, NULL),
('Luxor', 47, '2019-12-30', 309, NULL),
('Luxor', 47, '2019-12-31', 324, NULL),
('Luxor', 47, '2020-01-01', 323, NULL),
('Luxor', 47, '2020-01-02', 266, NULL),
('Luxor', 47, '2020-01-03', 277, NULL),
('Luxor', 47, '2020-01-04', 322, NULL),
('Luxor', 47, '2020-01-05', 126, NULL),
('Luxor', 47, '2020-01-06', 327, NULL),
('Luxor', 47, '2020-01-07', 147, NULL),
('Luxor', 47, '2020-01-08', 282, NULL),
('Luxor', 47, '2020-01-09', 297, NULL),
('Luxor', 47, '2020-01-10', 343, NULL),
('Luxor', 47, '2020-01-11', 180, NULL),
('Luxor', 47, '2020-01-12', 335, NULL),
('Luxor', 47, '2020-01-13', 303, NULL),
('Luxor', 47, '2020-01-14', 316, NULL),
('Luxor', 47, '2020-01-15', 385, NULL),
('Luxor', 47, '2020-01-16', 111, NULL),
('Luxor', 47, '2020-01-17', 330, NULL),
('Luxor', 47, '2020-01-18', 340, NULL),
('Luxor', 47, '2020-01-19', 214, NULL),
('Luxor', 47, '2020-01-20', 149, NULL),
('Luxor', 47, '2020-01-21', 103, NULL),
('Luxor', 47, '2020-01-22', 290, NULL),
('Luxor', 47, '2020-01-23', 226, NULL),
('Luxor', 47, '2020-01-24', 170, NULL),
('Luxor', 47, '2020-01-25', 348, NULL),
('Luxor', 47, '2020-01-26', 312, NULL),
('Luxor', 47, '2020-01-27', 193, NULL),
('Luxor', 47, '2020-01-28', 345, NULL),
('Luxor', 47, '2020-01-29', 293, NULL),
('Luxor', 47, '2020-01-30', 357, NULL),
('Luxor', 47, '2020-01-31', 130, NULL),
('Luxor', 47, '2020-02-01', 328, NULL),
('Luxor', 47, '2020-02-02', 265, NULL),
('Luxor', 47, '2020-02-03', 132, NULL),
('Luxor', 47, '2020-02-04', 353, NULL),
('Luxor', 59, '2019-01-01', 373, NULL),
('Luxor', 59, '2019-01-02', 256, NULL),
('Luxor', 59, '2019-01-03', 312, NULL),
('Luxor', 59, '2019-01-04', 289, NULL),
('Luxor', 59, '2019-01-05', 177, NULL),
('Luxor', 59, '2019-01-06', 281, NULL),
('Luxor', 59, '2019-01-07', 119, NULL),
('Luxor', 59, '2019-01-08', 225, NULL),
('Luxor', 59, '2019-01-09', 303, NULL),
('Luxor', 59, '2019-01-10', 116, NULL),
('Luxor', 59, '2019-01-11', 201, NULL),
('Luxor', 59, '2019-01-12', 354, NULL),
('Luxor', 59, '2019-01-13', 276, NULL),
('Luxor', 59, '2019-01-14', 264, NULL),
('Luxor', 59, '2019-01-15', 198, NULL),
('Luxor', 59, '2019-01-16', 144, NULL),
('Luxor', 59, '2019-01-17', 212, NULL),
('Luxor', 59, '2019-01-18', 273, NULL),
('Luxor', 59, '2019-01-19', 352, NULL),
('Luxor', 59, '2019-01-20', 294, NULL),
('Luxor', 59, '2019-01-21', 155, NULL),
('Luxor', 59, '2019-01-22', 324, NULL),
('Luxor', 59, '2019-01-23', 390, NULL),
('Luxor', 59, '2019-01-24', 220, NULL),
('Luxor', 59, '2019-01-25', 278, NULL),
('Luxor', 59, '2019-01-26', 266, NULL),
('Luxor', 59, '2019-01-27', 192, NULL),
('Luxor', 59, '2019-01-28', 124, NULL),
('Luxor', 59, '2019-01-29', 208, NULL),
('Luxor', 59, '2019-01-30', 221, NULL),
('Luxor', 59, '2019-01-31', 180, NULL),
('Luxor', 59, '2019-02-01', 246, NULL),
('Luxor', 59, '2019-02-02', 374, NULL),
('Luxor', 59, '2019-02-03', 179, NULL),
('Luxor', 59, '2019-02-04', 362, NULL),
('Luxor', 59, '2019-02-05', 317, NULL),
('Luxor', 59, '2019-02-06', 374, NULL),
('Luxor', 59, '2019-02-07', 281, NULL),
('Luxor', 59, '2019-02-08', 324, NULL),
('Luxor', 59, '2019-02-09', 149, NULL),
('Luxor', 59, '2019-02-10', 385, NULL),
('Luxor', 59, '2019-02-11', 215, NULL),
('Luxor', 59, '2019-02-12', 101, NULL),
('Luxor', 59, '2019-02-13', 362, NULL),
('Luxor', 59, '2019-02-14', 322, NULL),
('Luxor', 59, '2019-02-15', 142, NULL),
('Luxor', 59, '2019-02-16', 133, NULL),
('Luxor', 59, '2019-02-17', 263, NULL),
('Luxor', 59, '2019-02-18', 115, NULL),
('Luxor', 59, '2019-02-19', 145, NULL),
('Luxor', 59, '2019-02-20', 141, NULL),
('Luxor', 59, '2019-02-21', 361, NULL),
('Luxor', 59, '2019-02-22', 151, NULL),
('Luxor', 59, '2019-02-23', 305, NULL),
('Luxor', 59, '2019-02-24', 344, NULL),
('Luxor', 59, '2019-02-25', 348, NULL),
('Luxor', 59, '2019-02-26', 347, NULL),
('Luxor', 59, '2019-02-27', 395, NULL),
('Luxor', 59, '2019-02-28', 246, NULL),
('Luxor', 59, '2019-03-01', 181, NULL),
('Luxor', 59, '2019-03-02', 371, NULL),
('Luxor', 59, '2019-03-03', 301, NULL),
('Luxor', 59, '2019-03-04', 184, NULL),
('Luxor', 59, '2019-03-05', 259, NULL),
('Luxor', 59, '2019-03-06', 177, NULL),
('Luxor', 59, '2019-03-07', 147, NULL),
('Luxor', 59, '2019-03-08', 180, NULL),
('Luxor', 59, '2019-03-09', 203, NULL),
('Luxor', 59, '2019-03-10', 208, NULL),
('Luxor', 59, '2019-03-11', 191, NULL),
('Luxor', 59, '2019-03-12', 266, NULL),
('Luxor', 59, '2019-03-13', 354, NULL),
('Luxor', 59, '2019-03-14', 162, NULL),
('Luxor', 59, '2019-03-15', 121, NULL),
('Luxor', 59, '2019-03-16', 224, NULL),
('Luxor', 59, '2019-03-17', 236, NULL),
('Luxor', 59, '2019-03-18', 309, NULL),
('Luxor', 59, '2019-03-19', 323, NULL),
('Luxor', 59, '2019-03-20', 342, NULL),
('Luxor', 59, '2019-03-21', 135, NULL),
('Luxor', 59, '2019-03-22', 372, NULL),
('Luxor', 59, '2019-03-23', 352, NULL),
('Luxor', 59, '2019-03-24', 151, NULL),
('Luxor', 59, '2019-03-25', 138, NULL),
('Luxor', 59, '2019-03-26', 115, NULL),
('Luxor', 59, '2019-03-27', 269, NULL),
('Luxor', 59, '2019-03-28', 243, NULL),
('Luxor', 59, '2019-03-29', 217, NULL),
('Luxor', 59, '2019-03-30', 227, NULL),
('Luxor', 59, '2019-03-31', 157, NULL),
('Luxor', 59, '2019-04-01', 318, NULL),
('Luxor', 59, '2019-04-02', 381, NULL),
('Luxor', 59, '2019-04-03', 371, NULL),
('Luxor', 59, '2019-04-04', 113, NULL),
('Luxor', 59, '2019-04-05', 193, NULL),
('Luxor', 59, '2019-04-06', 333, NULL),
('Luxor', 59, '2019-04-07', 108, NULL),
('Luxor', 59, '2019-04-08', 177, NULL),
('Luxor', 59, '2019-04-09', 233, NULL),
('Luxor', 59, '2019-04-10', 194, NULL),
('Luxor', 59, '2019-04-11', 110, NULL),
('Luxor', 59, '2019-04-12', 350, NULL),
('Luxor', 59, '2019-04-13', 283, NULL),
('Luxor', 59, '2019-04-14', 278, NULL),
('Luxor', 59, '2019-04-15', 128, NULL),
('Luxor', 59, '2019-04-16', 396, NULL),
('Luxor', 59, '2019-04-17', 218, NULL),
('Luxor', 59, '2019-04-18', 176, NULL),
('Luxor', 59, '2019-04-19', 361, NULL),
('Luxor', 59, '2019-04-20', 274, NULL),
('Luxor', 59, '2019-04-21', 334, NULL),
('Luxor', 59, '2019-04-22', 119, NULL),
('Luxor', 59, '2019-04-23', 381, NULL),
('Luxor', 59, '2019-04-24', 215, NULL),
('Luxor', 59, '2019-04-25', 262, NULL),
('Luxor', 59, '2019-04-26', 322, NULL),
('Luxor', 59, '2019-04-27', 150, NULL),
('Luxor', 59, '2019-04-28', 197, NULL),
('Luxor', 59, '2019-04-29', 350, NULL),
('Luxor', 59, '2019-04-30', 235, NULL),
('Luxor', 59, '2019-05-01', 135, NULL),
('Luxor', 59, '2019-05-02', 250, NULL),
('Luxor', 59, '2019-05-03', 305, NULL),
('Luxor', 59, '2019-05-04', 136, NULL),
('Luxor', 59, '2019-05-05', 365, NULL),
('Luxor', 59, '2019-05-06', 124, NULL),
('Luxor', 59, '2019-05-07', 378, NULL),
('Luxor', 59, '2019-05-08', 139, NULL),
('Luxor', 59, '2019-05-09', 378, NULL),
('Luxor', 59, '2019-05-10', 379, NULL),
('Luxor', 59, '2019-05-11', 311, NULL),
('Luxor', 59, '2019-05-12', 115, NULL),
('Luxor', 59, '2019-05-13', 336, NULL),
('Luxor', 59, '2019-05-14', 102, NULL),
('Luxor', 59, '2019-05-15', 274, NULL),
('Luxor', 59, '2019-05-16', 160, NULL),
('Luxor', 59, '2019-05-17', 159, NULL),
('Luxor', 59, '2019-05-18', 390, NULL),
('Luxor', 59, '2019-05-19', 180, NULL),
('Luxor', 59, '2019-05-20', 221, NULL),
('Luxor', 59, '2019-05-21', 143, NULL),
('Luxor', 59, '2019-05-22', 241, NULL),
('Luxor', 59, '2019-05-23', 172, NULL),
('Luxor', 59, '2019-05-24', 225, NULL),
('Luxor', 59, '2019-05-25', 244, NULL),
('Luxor', 59, '2019-05-26', 138, NULL),
('Luxor', 59, '2019-05-27', 323, NULL),
('Luxor', 59, '2019-05-28', 197, NULL),
('Luxor', 59, '2019-05-29', 230, NULL),
('Luxor', 59, '2019-05-30', 362, NULL),
('Luxor', 59, '2019-05-31', 123, NULL),
('Luxor', 59, '2019-06-01', 238, NULL),
('Luxor', 59, '2019-06-02', 101, NULL),
('Luxor', 59, '2019-06-03', 391, NULL),
('Luxor', 59, '2019-06-04', 346, NULL),
('Luxor', 59, '2019-06-05', 119, NULL),
('Luxor', 59, '2019-06-06', 355, NULL),
('Luxor', 59, '2019-06-07', 130, NULL),
('Luxor', 59, '2019-06-08', 193, NULL),
('Luxor', 59, '2019-06-09', 294, NULL),
('Luxor', 59, '2019-06-10', 179, NULL),
('Luxor', 59, '2019-06-11', 327, NULL),
('Luxor', 59, '2019-06-12', 130, NULL),
('Luxor', 59, '2019-06-13', 134, NULL),
('Luxor', 59, '2019-06-14', 389, NULL),
('Luxor', 59, '2019-06-15', 337, NULL),
('Luxor', 59, '2019-06-16', 357, NULL),
('Luxor', 59, '2019-06-17', 270, NULL),
('Luxor', 59, '2019-06-18', 210, NULL),
('Luxor', 59, '2019-06-19', 389, NULL),
('Luxor', 59, '2019-06-20', 303, NULL),
('Luxor', 59, '2019-06-21', 117, NULL),
('Luxor', 59, '2019-06-22', 162, NULL),
('Luxor', 59, '2019-06-23', 129, NULL),
('Luxor', 59, '2019-06-24', 294, NULL),
('Luxor', 59, '2019-06-25', 351, NULL),
('Luxor', 59, '2019-06-26', 208, NULL),
('Luxor', 59, '2019-06-27', 258, NULL),
('Luxor', 59, '2019-06-28', 217, NULL),
('Luxor', 59, '2019-06-29', 103, NULL),
('Luxor', 59, '2019-06-30', 253, NULL),
('Luxor', 59, '2019-07-01', 194, NULL),
('Luxor', 59, '2019-07-02', 196, NULL),
('Luxor', 59, '2019-07-03', 389, NULL),
('Luxor', 59, '2019-07-04', 264, NULL),
('Luxor', 59, '2019-07-05', 229, NULL),
('Luxor', 59, '2019-07-06', 147, NULL),
('Luxor', 59, '2019-07-07', 383, NULL),
('Luxor', 59, '2019-07-08', 344, NULL),
('Luxor', 59, '2019-07-09', 270, NULL),
('Luxor', 59, '2019-07-10', 193, NULL),
('Luxor', 59, '2019-07-11', 255, NULL),
('Luxor', 59, '2019-07-12', 235, NULL),
('Luxor', 59, '2019-07-13', 347, NULL),
('Luxor', 59, '2019-07-14', 156, NULL),
('Luxor', 59, '2019-07-15', 236, NULL),
('Luxor', 59, '2019-07-16', 291, NULL),
('Luxor', 59, '2019-07-17', 139, NULL),
('Luxor', 59, '2019-07-18', 228, NULL),
('Luxor', 59, '2019-07-19', 213, NULL),
('Luxor', 59, '2019-07-20', 280, NULL),
('Luxor', 59, '2019-07-21', 176, NULL),
('Luxor', 59, '2019-07-22', 350, NULL),
('Luxor', 59, '2019-07-23', 218, NULL),
('Luxor', 59, '2019-07-24', 137, NULL),
('Luxor', 59, '2019-07-25', 108, NULL),
('Luxor', 59, '2019-07-26', 268, NULL),
('Luxor', 59, '2019-07-27', 399, NULL),
('Luxor', 59, '2019-07-28', 306, NULL),
('Luxor', 59, '2019-07-29', 100, NULL),
('Luxor', 59, '2019-07-30', 391, NULL),
('Luxor', 59, '2019-07-31', 130, NULL),
('Luxor', 59, '2019-08-01', 119, NULL),
('Luxor', 59, '2019-08-02', 232, NULL),
('Luxor', 59, '2019-08-03', 150, NULL),
('Luxor', 59, '2019-08-04', 232, NULL),
('Luxor', 59, '2019-08-05', 347, NULL),
('Luxor', 59, '2019-08-06', 158, NULL),
('Luxor', 59, '2019-08-07', 396, NULL),
('Luxor', 59, '2019-08-08', 381, NULL),
('Luxor', 59, '2019-08-09', 211, NULL),
('Luxor', 59, '2019-08-10', 279, NULL),
('Luxor', 59, '2019-08-11', 239, NULL),
('Luxor', 59, '2019-08-12', 240, NULL),
('Luxor', 59, '2019-08-13', 148, NULL),
('Luxor', 59, '2019-08-14', 237, NULL),
('Luxor', 59, '2019-08-15', 198, NULL),
('Luxor', 59, '2019-08-16', 260, NULL),
('Luxor', 59, '2019-08-17', 151, NULL),
('Luxor', 59, '2019-08-18', 194, NULL),
('Luxor', 59, '2019-08-19', 149, NULL),
('Luxor', 59, '2019-08-20', 294, NULL),
('Luxor', 59, '2019-08-21', 288, NULL),
('Luxor', 59, '2019-08-22', 271, NULL),
('Luxor', 59, '2019-08-23', 174, NULL),
('Luxor', 59, '2019-08-24', 115, NULL),
('Luxor', 59, '2019-08-25', 188, NULL),
('Luxor', 59, '2019-08-26', 231, NULL),
('Luxor', 59, '2019-08-27', 237, NULL),
('Luxor', 59, '2019-08-28', 103, NULL),
('Luxor', 59, '2019-08-29', 247, NULL),
('Luxor', 59, '2019-08-30', 123, NULL),
('Luxor', 59, '2019-08-31', 339, NULL),
('Luxor', 59, '2019-09-01', 312, NULL),
('Luxor', 59, '2019-09-02', 177, NULL),
('Luxor', 59, '2019-09-03', 201, NULL),
('Luxor', 59, '2019-09-04', 239, NULL),
('Luxor', 59, '2019-09-05', 217, NULL),
('Luxor', 59, '2019-09-06', 388, NULL),
('Luxor', 59, '2019-09-07', 374, NULL),
('Luxor', 59, '2019-09-08', 259, NULL),
('Luxor', 59, '2019-09-09', 352, NULL),
('Luxor', 59, '2019-09-10', 392, NULL),
('Luxor', 59, '2019-09-11', 115, NULL),
('Luxor', 59, '2019-09-12', 147, NULL),
('Luxor', 59, '2019-09-13', 241, NULL),
('Luxor', 59, '2019-09-14', 135, NULL),
('Luxor', 59, '2019-09-15', 304, NULL),
('Luxor', 59, '2019-09-16', 111, NULL),
('Luxor', 59, '2019-09-17', 283, NULL),
('Luxor', 59, '2019-09-18', 198, NULL),
('Luxor', 59, '2019-09-19', 153, NULL),
('Luxor', 59, '2019-09-20', 325, NULL),
('Luxor', 59, '2019-09-21', 166, NULL),
('Luxor', 59, '2019-09-22', 373, NULL),
('Luxor', 59, '2019-09-23', 209, NULL),
('Luxor', 59, '2019-09-24', 147, NULL),
('Luxor', 59, '2019-09-25', 294, NULL),
('Luxor', 59, '2019-09-26', 228, NULL),
('Luxor', 59, '2019-09-27', 235, NULL),
('Luxor', 59, '2019-09-28', 239, NULL),
('Luxor', 59, '2019-09-29', 247, NULL),
('Luxor', 59, '2019-09-30', 327, NULL),
('Luxor', 59, '2019-10-01', 307, NULL),
('Luxor', 59, '2019-10-02', 209, NULL),
('Luxor', 59, '2019-10-03', 213, NULL),
('Luxor', 59, '2019-10-04', 307, NULL),
('Luxor', 59, '2019-10-05', 256, NULL),
('Luxor', 59, '2019-10-06', 116, NULL),
('Luxor', 59, '2019-10-07', 120, NULL),
('Luxor', 59, '2019-10-08', 359, NULL),
('Luxor', 59, '2019-10-09', 238, NULL),
('Luxor', 59, '2019-10-10', 149, NULL),
('Luxor', 59, '2019-10-11', 166, NULL),
('Luxor', 59, '2019-10-12', 322, NULL),
('Luxor', 59, '2019-10-13', 252, NULL),
('Luxor', 59, '2019-10-14', 123, NULL),
('Luxor', 59, '2019-10-15', 232, NULL),
('Luxor', 59, '2019-10-16', 300, NULL),
('Luxor', 59, '2019-10-17', 322, NULL),
('Luxor', 59, '2019-10-18', 342, NULL),
('Luxor', 59, '2019-10-19', 350, NULL),
('Luxor', 59, '2019-10-20', 174, NULL),
('Luxor', 59, '2019-10-21', 333, NULL),
('Luxor', 59, '2019-10-22', 343, NULL),
('Luxor', 59, '2019-10-23', 371, NULL),
('Luxor', 59, '2019-10-24', 254, NULL),
('Luxor', 59, '2019-10-25', 221, NULL),
('Luxor', 59, '2019-10-26', 217, NULL),
('Luxor', 59, '2019-10-27', 212, NULL),
('Luxor', 59, '2019-10-28', 258, NULL),
('Luxor', 59, '2019-10-29', 276, NULL),
('Luxor', 59, '2019-10-30', 162, NULL),
('Luxor', 59, '2019-10-31', 236, NULL),
('Luxor', 59, '2019-11-01', 182, NULL),
('Luxor', 59, '2019-11-02', 235, NULL),
('Luxor', 59, '2019-11-03', 115, NULL),
('Luxor', 59, '2019-11-04', 268, NULL),
('Luxor', 59, '2019-11-05', 304, NULL),
('Luxor', 59, '2019-11-06', 232, NULL),
('Luxor', 59, '2019-11-07', 197, NULL),
('Luxor', 59, '2019-11-08', 365, NULL),
('Luxor', 59, '2019-11-09', 182, NULL),
('Luxor', 59, '2019-11-10', 214, NULL),
('Luxor', 59, '2019-11-11', 308, NULL),
('Luxor', 59, '2019-11-12', 329, NULL),
('Luxor', 59, '2019-11-13', 291, NULL),
('Luxor', 59, '2019-11-14', 204, NULL),
('Luxor', 59, '2019-11-15', 219, NULL),
('Luxor', 59, '2019-11-16', 136, NULL),
('Luxor', 59, '2019-11-17', 314, NULL),
('Luxor', 59, '2019-11-18', 258, NULL),
('Luxor', 59, '2019-11-19', 305, NULL),
('Luxor', 59, '2019-11-20', 118, NULL),
('Luxor', 59, '2019-11-21', 377, NULL),
('Luxor', 59, '2019-11-22', 343, NULL),
('Luxor', 59, '2019-11-23', 240, NULL),
('Luxor', 59, '2019-11-24', 105, NULL),
('Luxor', 59, '2019-11-25', 315, NULL),
('Luxor', 59, '2019-11-26', 139, NULL),
('Luxor', 59, '2019-11-27', 384, NULL),
('Luxor', 59, '2019-11-28', 336, NULL),
('Luxor', 59, '2019-11-29', 266, NULL),
('Luxor', 59, '2019-11-30', 392, NULL),
('Luxor', 59, '2019-12-01', 211, NULL),
('Luxor', 59, '2019-12-02', 130, NULL),
('Luxor', 59, '2019-12-03', 222, NULL),
('Luxor', 59, '2019-12-04', 156, NULL),
('Luxor', 59, '2019-12-05', 216, NULL),
('Luxor', 59, '2019-12-06', 190, NULL),
('Luxor', 59, '2019-12-07', 351, NULL),
('Luxor', 59, '2019-12-08', 341, NULL),
('Luxor', 59, '2019-12-09', 327, NULL),
('Luxor', 59, '2019-12-10', 129, NULL),
('Luxor', 59, '2019-12-11', 235, NULL),
('Luxor', 59, '2019-12-12', 119, NULL),
('Luxor', 59, '2019-12-13', 250, NULL),
('Luxor', 59, '2019-12-14', 196, NULL),
('Luxor', 59, '2019-12-15', 327, NULL),
('Luxor', 59, '2019-12-16', 300, NULL),
('Luxor', 59, '2019-12-17', 192, NULL),
('Luxor', 59, '2019-12-18', 344, NULL),
('Luxor', 59, '2019-12-19', 383, NULL),
('Luxor', 59, '2019-12-20', 324, NULL),
('Luxor', 59, '2019-12-21', 329, NULL),
('Luxor', 59, '2019-12-22', 142, NULL),
('Luxor', 59, '2019-12-23', 245, NULL),
('Luxor', 59, '2019-12-24', 274, NULL),
('Luxor', 59, '2019-12-25', 282, NULL),
('Luxor', 59, '2019-12-26', 359, NULL),
('Luxor', 59, '2019-12-27', 126, NULL),
('Luxor', 59, '2019-12-28', 285, NULL),
('Luxor', 59, '2019-12-29', 281, NULL),
('Luxor', 59, '2019-12-30', 295, NULL),
('Luxor', 59, '2019-12-31', 249, NULL),
('Luxor', 59, '2020-01-01', 281, NULL),
('Luxor', 59, '2020-01-02', 346, NULL),
('Luxor', 59, '2020-01-03', 237, NULL),
('Luxor', 59, '2020-01-04', 301, NULL),
('Luxor', 59, '2020-01-05', 257, NULL),
('Luxor', 59, '2020-01-06', 149, NULL),
('Luxor', 59, '2020-01-07', 162, NULL),
('Luxor', 59, '2020-01-08', 207, NULL),
('Luxor', 59, '2020-01-09', 230, NULL),
('Luxor', 59, '2020-01-10', 331, NULL),
('Luxor', 59, '2020-01-11', 160, NULL),
('Luxor', 59, '2020-01-12', 220, NULL),
('Luxor', 59, '2020-01-13', 162, NULL),
('Luxor', 59, '2020-01-14', 182, NULL),
('Luxor', 59, '2020-01-15', 379, NULL),
('Luxor', 59, '2020-01-16', 214, NULL),
('Luxor', 59, '2020-01-17', 284, NULL),
('Luxor', 59, '2020-01-18', 261, NULL),
('Luxor', 59, '2020-01-19', 147, NULL),
('Luxor', 59, '2020-01-20', 346, NULL),
('Luxor', 59, '2020-01-21', 385, NULL),
('Luxor', 59, '2020-01-22', 326, NULL),
('Luxor', 59, '2020-01-23', 122, NULL),
('Luxor', 59, '2020-01-24', 157, NULL),
('Luxor', 59, '2020-01-25', 190, NULL),
('Luxor', 59, '2020-01-26', 286, NULL),
('Luxor', 59, '2020-01-27', 127, NULL),
('Luxor', 59, '2020-01-28', 248, NULL),
('Luxor', 59, '2020-01-29', 389, NULL),
('Luxor', 59, '2020-01-30', 189, NULL),
('Luxor', 59, '2020-01-31', 301, NULL),
('Luxor', 59, '2020-02-01', 328, NULL),
('Luxor', 59, '2020-02-02', 298, NULL),
('Luxor', 59, '2020-02-03', 271, NULL),
('Luxor', 59, '2020-02-04', 393, NULL),
('Luxor', 60, '2019-01-01', 177, NULL),
('Luxor', 60, '2019-01-02', 120, NULL),
('Luxor', 60, '2019-01-03', 304, NULL),
('Luxor', 60, '2019-01-04', 397, NULL),
('Luxor', 60, '2019-01-05', 373, NULL),
('Luxor', 60, '2019-01-06', 257, NULL),
('Luxor', 60, '2019-01-07', 162, NULL),
('Luxor', 60, '2019-01-08', 320, NULL),
('Luxor', 60, '2019-01-09', 252, NULL),
('Luxor', 60, '2019-01-10', 275, NULL),
('Luxor', 60, '2019-01-11', 113, NULL),
('Luxor', 60, '2019-01-12', 197, NULL),
('Luxor', 60, '2019-01-13', 218, NULL),
('Luxor', 60, '2019-01-14', 320, NULL),
('Luxor', 60, '2019-01-15', 165, NULL),
('Luxor', 60, '2019-01-16', 351, NULL),
('Luxor', 60, '2019-01-17', 214, NULL),
('Luxor', 60, '2019-01-18', 204, NULL),
('Luxor', 60, '2019-01-19', 302, NULL),
('Luxor', 60, '2019-01-20', 142, NULL),
('Luxor', 60, '2019-01-21', 294, NULL),
('Luxor', 60, '2019-01-22', 398, NULL),
('Luxor', 60, '2019-01-23', 352, NULL),
('Luxor', 60, '2019-01-24', 139, NULL),
('Luxor', 60, '2019-01-25', 322, NULL),
('Luxor', 60, '2019-01-26', 181, NULL),
('Luxor', 60, '2019-01-27', 151, NULL),
('Luxor', 60, '2019-01-28', 394, NULL),
('Luxor', 60, '2019-01-29', 141, NULL),
('Luxor', 60, '2019-01-30', 202, NULL),
('Luxor', 60, '2019-01-31', 230, NULL),
('Luxor', 60, '2019-02-01', 170, NULL),
('Luxor', 60, '2019-02-02', 284, NULL),
('Luxor', 60, '2019-02-03', 123, NULL),
('Luxor', 60, '2019-02-04', 142, NULL),
('Luxor', 60, '2019-02-05', 229, NULL),
('Luxor', 60, '2019-02-06', 132, NULL),
('Luxor', 60, '2019-02-07', 180, NULL),
('Luxor', 60, '2019-02-08', 188, NULL),
('Luxor', 60, '2019-02-09', 191, NULL),
('Luxor', 60, '2019-02-10', 135, NULL),
('Luxor', 60, '2019-02-11', 328, NULL),
('Luxor', 60, '2019-02-12', 210, NULL),
('Luxor', 60, '2019-02-13', 116, NULL),
('Luxor', 60, '2019-02-14', 313, NULL),
('Luxor', 60, '2019-02-15', 236, NULL),
('Luxor', 60, '2019-02-16', 162, NULL),
('Luxor', 60, '2019-02-17', 147, NULL),
('Luxor', 60, '2019-02-18', 216, NULL),
('Luxor', 60, '2019-02-19', 217, NULL),
('Luxor', 60, '2019-02-20', 166, NULL),
('Luxor', 60, '2019-02-21', 159, NULL),
('Luxor', 60, '2019-02-22', 303, NULL),
('Luxor', 60, '2019-02-23', 244, NULL),
('Luxor', 60, '2019-02-24', 374, NULL),
('Luxor', 60, '2019-02-25', 278, NULL),
('Luxor', 60, '2019-02-26', 137, NULL),
('Luxor', 60, '2019-02-27', 281, NULL),
('Luxor', 60, '2019-02-28', 201, NULL),
('Luxor', 60, '2019-03-01', 162, NULL),
('Luxor', 60, '2019-03-02', 367, NULL),
('Luxor', 60, '2019-03-03', 189, NULL),
('Luxor', 60, '2019-03-04', 218, NULL),
('Luxor', 60, '2019-03-05', 105, NULL),
('Luxor', 60, '2019-03-06', 389, NULL),
('Luxor', 60, '2019-03-07', 333, NULL),
('Luxor', 60, '2019-03-08', 119, NULL),
('Luxor', 60, '2019-03-09', 280, NULL),
('Luxor', 60, '2019-03-10', 126, NULL),
('Luxor', 60, '2019-03-11', 123, NULL),
('Luxor', 60, '2019-03-12', 391, NULL),
('Luxor', 60, '2019-03-13', 191, NULL),
('Luxor', 60, '2019-03-14', 306, NULL),
('Luxor', 60, '2019-03-15', 267, NULL),
('Luxor', 60, '2019-03-16', 181, NULL),
('Luxor', 60, '2019-03-17', 311, NULL),
('Luxor', 60, '2019-03-18', 276, NULL),
('Luxor', 60, '2019-03-19', 356, NULL),
('Luxor', 60, '2019-03-20', 198, NULL),
('Luxor', 60, '2019-03-21', 220, NULL),
('Luxor', 60, '2019-03-22', 320, NULL),
('Luxor', 60, '2019-03-23', 221, NULL),
('Luxor', 60, '2019-03-24', 195, NULL),
('Luxor', 60, '2019-03-25', 351, NULL),
('Luxor', 60, '2019-03-26', 399, NULL),
('Luxor', 60, '2019-03-27', 108, NULL),
('Luxor', 60, '2019-03-28', 309, NULL),
('Luxor', 60, '2019-03-29', 178, NULL),
('Luxor', 60, '2019-03-30', 395, NULL),
('Luxor', 60, '2019-03-31', 118, NULL),
('Luxor', 60, '2019-04-01', 210, NULL),
('Luxor', 60, '2019-04-02', 372, NULL),
('Luxor', 60, '2019-04-03', 114, NULL),
('Luxor', 60, '2019-04-04', 160, NULL),
('Luxor', 60, '2019-04-05', 141, NULL),
('Luxor', 60, '2019-04-06', 318, NULL),
('Luxor', 60, '2019-04-07', 202, NULL),
('Luxor', 60, '2019-04-08', 195, NULL),
('Luxor', 60, '2019-04-09', 108, NULL),
('Luxor', 60, '2019-04-10', 317, NULL),
('Luxor', 60, '2019-04-11', 262, NULL),
('Luxor', 60, '2019-04-12', 220, NULL),
('Luxor', 60, '2019-04-13', 356, NULL),
('Luxor', 60, '2019-04-14', 395, NULL),
('Luxor', 60, '2019-04-15', 350, NULL),
('Luxor', 60, '2019-04-16', 220, NULL),
('Luxor', 60, '2019-04-17', 363, NULL),
('Luxor', 60, '2019-04-18', 327, NULL),
('Luxor', 60, '2019-04-19', 301, NULL),
('Luxor', 60, '2019-04-20', 144, NULL),
('Luxor', 60, '2019-04-21', 349, NULL),
('Luxor', 60, '2019-04-22', 240, NULL),
('Luxor', 60, '2019-04-23', 157, NULL),
('Luxor', 60, '2019-04-24', 308, NULL),
('Luxor', 60, '2019-04-25', 196, NULL),
('Luxor', 60, '2019-04-26', 274, NULL),
('Luxor', 60, '2019-04-27', 215, NULL),
('Luxor', 60, '2019-04-28', 111, NULL),
('Luxor', 60, '2019-04-29', 137, NULL),
('Luxor', 60, '2019-04-30', 311, NULL),
('Luxor', 60, '2019-05-01', 347, NULL),
('Luxor', 60, '2019-05-02', 249, NULL),
('Luxor', 60, '2019-05-03', 386, NULL),
('Luxor', 60, '2019-05-04', 124, NULL),
('Luxor', 60, '2019-05-05', 252, NULL),
('Luxor', 60, '2019-05-06', 130, NULL),
('Luxor', 60, '2019-05-07', 165, NULL),
('Luxor', 60, '2019-05-08', 122, NULL),
('Luxor', 60, '2019-05-09', 140, NULL),
('Luxor', 60, '2019-05-10', 185, NULL),
('Luxor', 60, '2019-05-11', 311, NULL),
('Luxor', 60, '2019-05-12', 303, NULL),
('Luxor', 60, '2019-05-13', 161, NULL),
('Luxor', 60, '2019-05-14', 313, NULL),
('Luxor', 60, '2019-05-15', 129, NULL),
('Luxor', 60, '2019-05-16', 282, NULL),
('Luxor', 60, '2019-05-17', 201, NULL),
('Luxor', 60, '2019-05-18', 284, NULL),
('Luxor', 60, '2019-05-19', 215, NULL),
('Luxor', 60, '2019-05-20', 379, NULL),
('Luxor', 60, '2019-05-21', 339, NULL),
('Luxor', 60, '2019-05-22', 118, NULL),
('Luxor', 60, '2019-05-23', 126, NULL),
('Luxor', 60, '2019-05-24', 278, NULL),
('Luxor', 60, '2019-05-25', 389, NULL),
('Luxor', 60, '2019-05-26', 139, NULL),
('Luxor', 60, '2019-05-27', 284, NULL),
('Luxor', 60, '2019-05-28', 292, NULL),
('Luxor', 60, '2019-05-29', 147, NULL),
('Luxor', 60, '2019-05-30', 280, NULL),
('Luxor', 60, '2019-05-31', 206, NULL),
('Luxor', 60, '2019-06-01', 319, NULL),
('Luxor', 60, '2019-06-02', 179, NULL),
('Luxor', 60, '2019-06-03', 189, NULL),
('Luxor', 60, '2019-06-04', 369, NULL),
('Luxor', 60, '2019-06-05', 350, NULL),
('Luxor', 60, '2019-06-06', 292, NULL),
('Luxor', 60, '2019-06-07', 183, NULL),
('Luxor', 60, '2019-06-08', 126, NULL),
('Luxor', 60, '2019-06-09', 196, NULL),
('Luxor', 60, '2019-06-10', 334, NULL),
('Luxor', 60, '2019-06-11', 101, NULL),
('Luxor', 60, '2019-06-12', 150, NULL),
('Luxor', 60, '2019-06-13', 144, NULL),
('Luxor', 60, '2019-06-14', 138, NULL),
('Luxor', 60, '2019-06-15', 388, NULL),
('Luxor', 60, '2019-06-16', 243, NULL),
('Luxor', 60, '2019-06-17', 351, NULL),
('Luxor', 60, '2019-06-18', 249, NULL),
('Luxor', 60, '2019-06-19', 193, NULL),
('Luxor', 60, '2019-06-20', 154, NULL),
('Luxor', 60, '2019-06-21', 231, NULL),
('Luxor', 60, '2019-06-22', 331, NULL),
('Luxor', 60, '2019-06-23', 390, NULL),
('Luxor', 60, '2019-06-24', 384, NULL),
('Luxor', 60, '2019-06-25', 150, NULL),
('Luxor', 60, '2019-06-26', 221, NULL),
('Luxor', 60, '2019-06-27', 338, NULL),
('Luxor', 60, '2019-06-28', 140, NULL),
('Luxor', 60, '2019-06-29', 245, NULL),
('Luxor', 60, '2019-06-30', 202, NULL),
('Luxor', 60, '2019-07-01', 314, NULL),
('Luxor', 60, '2019-07-02', 331, NULL),
('Luxor', 60, '2019-07-03', 366, NULL),
('Luxor', 60, '2019-07-04', 144, NULL),
('Luxor', 60, '2019-07-05', 106, NULL),
('Luxor', 60, '2019-07-06', 386, NULL),
('Luxor', 60, '2019-07-07', 139, NULL),
('Luxor', 60, '2019-07-08', 188, NULL),
('Luxor', 60, '2019-07-09', 364, NULL),
('Luxor', 60, '2019-07-10', 312, NULL),
('Luxor', 60, '2019-07-11', 154, NULL),
('Luxor', 60, '2019-07-12', 146, NULL),
('Luxor', 60, '2019-07-13', 298, NULL),
('Luxor', 60, '2019-07-14', 127, NULL),
('Luxor', 60, '2019-07-15', 209, NULL),
('Luxor', 60, '2019-07-16', 318, NULL),
('Luxor', 60, '2019-07-17', 297, NULL),
('Luxor', 60, '2019-07-18', 264, NULL),
('Luxor', 60, '2019-07-19', 267, NULL),
('Luxor', 60, '2019-07-20', 175, NULL),
('Luxor', 60, '2019-07-21', 283, NULL),
('Luxor', 60, '2019-07-22', 182, NULL),
('Luxor', 60, '2019-07-23', 364, NULL),
('Luxor', 60, '2019-07-24', 273, NULL),
('Luxor', 60, '2019-07-25', 300, NULL),
('Luxor', 60, '2019-07-26', 207, NULL),
('Luxor', 60, '2019-07-27', 275, NULL),
('Luxor', 60, '2019-07-28', 273, NULL),
('Luxor', 60, '2019-07-29', 327, NULL),
('Luxor', 60, '2019-07-30', 375, NULL),
('Luxor', 60, '2019-07-31', 330, NULL),
('Luxor', 60, '2019-08-01', 188, NULL),
('Luxor', 60, '2019-08-02', 231, NULL),
('Luxor', 60, '2019-08-03', 117, NULL),
('Luxor', 60, '2019-08-04', 113, NULL),
('Luxor', 60, '2019-08-05', 119, NULL),
('Luxor', 60, '2019-08-06', 137, NULL),
('Luxor', 60, '2019-08-07', 310, NULL),
('Luxor', 60, '2019-08-08', 343, NULL),
('Luxor', 60, '2019-08-09', 118, NULL),
('Luxor', 60, '2019-08-10', 356, NULL),
('Luxor', 60, '2019-08-11', 148, NULL),
('Luxor', 60, '2019-08-12', 335, NULL),
('Luxor', 60, '2019-08-13', 116, NULL),
('Luxor', 60, '2019-08-14', 290, NULL),
('Luxor', 60, '2019-08-15', 303, NULL),
('Luxor', 60, '2019-08-16', 344, NULL),
('Luxor', 60, '2019-08-17', 300, NULL),
('Luxor', 60, '2019-08-18', 355, NULL),
('Luxor', 60, '2019-08-19', 105, NULL),
('Luxor', 60, '2019-08-20', 200, NULL),
('Luxor', 60, '2019-08-21', 280, NULL),
('Luxor', 60, '2019-08-22', 226, NULL),
('Luxor', 60, '2019-08-23', 227, NULL),
('Luxor', 60, '2019-08-24', 197, NULL),
('Luxor', 60, '2019-08-25', 247, NULL),
('Luxor', 60, '2019-08-26', 273, NULL),
('Luxor', 60, '2019-08-27', 111, NULL),
('Luxor', 60, '2019-08-28', 311, NULL),
('Luxor', 60, '2019-08-29', 228, NULL),
('Luxor', 60, '2019-08-30', 265, NULL),
('Luxor', 60, '2019-08-31', 275, NULL),
('Luxor', 60, '2019-09-01', 289, NULL),
('Luxor', 60, '2019-09-02', 246, NULL),
('Luxor', 60, '2019-09-03', 282, NULL),
('Luxor', 60, '2019-09-04', 283, NULL),
('Luxor', 60, '2019-09-05', 357, NULL),
('Luxor', 60, '2019-09-06', 171, NULL),
('Luxor', 60, '2019-09-07', 129, NULL),
('Luxor', 60, '2019-09-08', 164, NULL),
('Luxor', 60, '2019-09-09', 148, NULL),
('Luxor', 60, '2019-09-10', 312, NULL),
('Luxor', 60, '2019-09-11', 247, NULL),
('Luxor', 60, '2019-09-12', 298, NULL),
('Luxor', 60, '2019-09-13', 276, NULL),
('Luxor', 60, '2019-09-14', 155, NULL),
('Luxor', 60, '2019-09-15', 137, NULL),
('Luxor', 60, '2019-09-16', 334, NULL),
('Luxor', 60, '2019-09-17', 292, NULL),
('Luxor', 60, '2019-09-18', 253, NULL),
('Luxor', 60, '2019-09-19', 221, NULL),
('Luxor', 60, '2019-09-20', 101, NULL),
('Luxor', 60, '2019-09-21', 383, NULL),
('Luxor', 60, '2019-09-22', 207, NULL),
('Luxor', 60, '2019-09-23', 132, NULL),
('Luxor', 60, '2019-09-24', 233, NULL),
('Luxor', 60, '2019-09-25', 149, NULL),
('Luxor', 60, '2019-09-26', 367, NULL),
('Luxor', 60, '2019-09-27', 197, NULL),
('Luxor', 60, '2019-09-28', 159, NULL),
('Luxor', 60, '2019-09-29', 283, NULL),
('Luxor', 60, '2019-09-30', 333, NULL),
('Luxor', 60, '2019-10-01', 292, NULL),
('Luxor', 60, '2019-10-02', 313, NULL),
('Luxor', 60, '2019-10-03', 240, NULL),
('Luxor', 60, '2019-10-04', 220, NULL),
('Luxor', 60, '2019-10-05', 105, NULL),
('Luxor', 60, '2019-10-06', 242, NULL),
('Luxor', 60, '2019-10-07', 156, NULL),
('Luxor', 60, '2019-10-08', 345, NULL),
('Luxor', 60, '2019-10-09', 175, NULL),
('Luxor', 60, '2019-10-10', 214, NULL),
('Luxor', 60, '2019-10-11', 301, NULL),
('Luxor', 60, '2019-10-12', 210, NULL),
('Luxor', 60, '2019-10-13', 201, NULL),
('Luxor', 60, '2019-10-14', 119, NULL),
('Luxor', 60, '2019-10-15', 326, NULL),
('Luxor', 60, '2019-10-16', 343, NULL),
('Luxor', 60, '2019-10-17', 323, NULL),
('Luxor', 60, '2019-10-18', 292, NULL),
('Luxor', 60, '2019-10-19', 172, NULL),
('Luxor', 60, '2019-10-20', 141, NULL),
('Luxor', 60, '2019-10-21', 313, NULL),
('Luxor', 60, '2019-10-22', 336, NULL),
('Luxor', 60, '2019-10-23', 127, NULL),
('Luxor', 60, '2019-10-24', 202, NULL),
('Luxor', 60, '2019-10-25', 153, NULL),
('Luxor', 60, '2019-10-26', 104, NULL),
('Luxor', 60, '2019-10-27', 225, NULL),
('Luxor', 60, '2019-10-28', 379, NULL),
('Luxor', 60, '2019-10-29', 123, NULL),
('Luxor', 60, '2019-10-30', 293, NULL),
('Luxor', 60, '2019-10-31', 186, NULL),
('Luxor', 60, '2019-11-01', 143, NULL),
('Luxor', 60, '2019-11-02', 395, NULL),
('Luxor', 60, '2019-11-03', 381, NULL),
('Luxor', 60, '2019-11-04', 356, NULL),
('Luxor', 60, '2019-11-05', 271, NULL),
('Luxor', 60, '2019-11-06', 301, NULL),
('Luxor', 60, '2019-11-07', 130, NULL),
('Luxor', 60, '2019-11-08', 322, NULL),
('Luxor', 60, '2019-11-09', 300, NULL),
('Luxor', 60, '2019-11-10', 111, NULL),
('Luxor', 60, '2019-11-11', 249, NULL),
('Luxor', 60, '2019-11-12', 374, NULL),
('Luxor', 60, '2019-11-13', 248, NULL),
('Luxor', 60, '2019-11-14', 269, NULL),
('Luxor', 60, '2019-11-15', 227, NULL),
('Luxor', 60, '2019-11-16', 382, NULL),
('Luxor', 60, '2019-11-17', 376, NULL),
('Luxor', 60, '2019-11-18', 345, NULL),
('Luxor', 60, '2019-11-19', 138, NULL),
('Luxor', 60, '2019-11-20', 226, NULL),
('Luxor', 60, '2019-11-21', 120, NULL),
('Luxor', 60, '2019-11-22', 233, NULL),
('Luxor', 60, '2019-11-23', 273, NULL),
('Luxor', 60, '2019-11-24', 394, NULL),
('Luxor', 60, '2019-11-25', 366, NULL),
('Luxor', 60, '2019-11-26', 377, NULL),
('Luxor', 60, '2019-11-27', 379, NULL),
('Luxor', 60, '2019-11-28', 171, NULL),
('Luxor', 60, '2019-11-29', 143, NULL),
('Luxor', 60, '2019-11-30', 183, NULL),
('Luxor', 60, '2019-12-01', 188, NULL),
('Luxor', 60, '2019-12-02', 140, NULL),
('Luxor', 60, '2019-12-03', 333, NULL),
('Luxor', 60, '2019-12-04', 130, NULL),
('Luxor', 60, '2019-12-05', 116, NULL),
('Luxor', 60, '2019-12-06', 179, NULL),
('Luxor', 60, '2019-12-07', 213, NULL),
('Luxor', 60, '2019-12-08', 216, NULL),
('Luxor', 60, '2019-12-09', 246, NULL),
('Luxor', 60, '2019-12-10', 246, NULL),
('Luxor', 60, '2019-12-11', 344, NULL),
('Luxor', 60, '2019-12-12', 144, NULL),
('Luxor', 60, '2019-12-13', 154, NULL),
('Luxor', 60, '2019-12-14', 166, NULL),
('Luxor', 60, '2019-12-15', 275, NULL),
('Luxor', 60, '2019-12-16', 142, NULL),
('Luxor', 60, '2019-12-17', 134, NULL),
('Luxor', 60, '2019-12-18', 263, NULL),
('Luxor', 60, '2019-12-19', 205, NULL),
('Luxor', 60, '2019-12-20', 104, NULL),
('Luxor', 60, '2019-12-21', 338, NULL),
('Luxor', 60, '2019-12-22', 191, NULL),
('Luxor', 60, '2019-12-23', 275, NULL),
('Luxor', 60, '2019-12-24', 205, NULL),
('Luxor', 60, '2019-12-25', 107, NULL),
('Luxor', 60, '2019-12-26', 359, NULL),
('Luxor', 60, '2019-12-27', 183, NULL),
('Luxor', 60, '2019-12-28', 395, NULL),
('Luxor', 60, '2019-12-29', 350, NULL),
('Luxor', 60, '2019-12-30', 152, NULL),
('Luxor', 60, '2019-12-31', 171, NULL),
('Luxor', 60, '2020-01-01', 335, NULL),
('Luxor', 60, '2020-01-02', 233, NULL),
('Luxor', 60, '2020-01-03', 254, NULL),
('Luxor', 60, '2020-01-04', 136, NULL),
('Luxor', 60, '2020-01-05', 206, NULL),
('Luxor', 60, '2020-01-06', 267, NULL),
('Luxor', 60, '2020-01-07', 267, NULL),
('Luxor', 60, '2020-01-08', 389, NULL),
('Luxor', 60, '2020-01-09', 160, NULL),
('Luxor', 60, '2020-01-10', 225, NULL),
('Luxor', 60, '2020-01-11', 160, NULL),
('Luxor', 60, '2020-01-12', 295, NULL),
('Luxor', 60, '2020-01-13', 399, NULL),
('Luxor', 60, '2020-01-14', 160, NULL),
('Luxor', 60, '2020-01-15', 340, NULL),
('Luxor', 60, '2020-01-16', 339, NULL),
('Luxor', 60, '2020-01-17', 329, NULL),
('Luxor', 60, '2020-01-18', 183, NULL),
('Luxor', 60, '2020-01-19', 293, NULL),
('Luxor', 60, '2020-01-20', 285, NULL),
('Luxor', 60, '2020-01-21', 318, NULL),
('Luxor', 60, '2020-01-22', 363, NULL),
('Luxor', 60, '2020-01-23', 133, NULL),
('Luxor', 60, '2020-01-24', 177, NULL),
('Luxor', 60, '2020-01-25', 107, NULL),
('Luxor', 60, '2020-01-26', 394, NULL),
('Luxor', 60, '2020-01-27', 257, NULL),
('Luxor', 60, '2020-01-28', 108, NULL),
('Luxor', 60, '2020-01-29', 366, NULL),
('Luxor', 60, '2020-01-30', 376, NULL),
('Luxor', 60, '2020-01-31', 117, NULL),
('Luxor', 60, '2020-02-01', 253, NULL),
('Luxor', 60, '2020-02-02', 299, NULL),
('Luxor', 60, '2020-02-03', 262, NULL),
('Luxor', 60, '2020-02-04', 205, NULL),
('Luxor', 62, '2019-01-01', 267, NULL),
('Luxor', 62, '2019-01-02', 333, NULL),
('Luxor', 62, '2019-01-03', 186, NULL),
('Luxor', 62, '2019-01-04', 120, NULL),
('Luxor', 62, '2019-01-05', 336, NULL),
('Luxor', 62, '2019-01-06', 342, NULL),
('Luxor', 62, '2019-01-07', 351, NULL),
('Luxor', 62, '2019-01-08', 223, NULL),
('Luxor', 62, '2019-01-09', 252, NULL),
('Luxor', 62, '2019-01-10', 329, NULL),
('Luxor', 62, '2019-01-11', 164, NULL),
('Luxor', 62, '2019-01-12', 125, NULL),
('Luxor', 62, '2019-01-13', 164, NULL),
('Luxor', 62, '2019-01-14', 111, NULL),
('Luxor', 62, '2019-01-15', 131, NULL),
('Luxor', 62, '2019-01-16', 321, NULL),
('Luxor', 62, '2019-01-17', 333, NULL),
('Luxor', 62, '2019-01-18', 101, NULL),
('Luxor', 62, '2019-01-19', 354, NULL),
('Luxor', 62, '2019-01-20', 331, NULL),
('Luxor', 62, '2019-01-21', 308, NULL),
('Luxor', 62, '2019-01-22', 319, NULL),
('Luxor', 62, '2019-01-23', 188, NULL),
('Luxor', 62, '2019-01-24', 233, NULL),
('Luxor', 62, '2019-01-25', 379, NULL),
('Luxor', 62, '2019-01-26', 307, NULL),
('Luxor', 62, '2019-01-27', 380, NULL),
('Luxor', 62, '2019-01-28', 301, NULL),
('Luxor', 62, '2019-01-29', 282, NULL),
('Luxor', 62, '2019-01-30', 247, NULL),
('Luxor', 62, '2019-01-31', 212, NULL),
('Luxor', 62, '2019-02-01', 314, NULL),
('Luxor', 62, '2019-02-02', 199, NULL),
('Luxor', 62, '2019-02-03', 277, NULL),
('Luxor', 62, '2019-02-04', 124, NULL),
('Luxor', 62, '2019-02-05', 395, NULL),
('Luxor', 62, '2019-02-06', 341, NULL),
('Luxor', 62, '2019-02-07', 258, NULL),
('Luxor', 62, '2019-02-08', 169, NULL),
('Luxor', 62, '2019-02-09', 110, NULL),
('Luxor', 62, '2019-02-10', 320, NULL),
('Luxor', 62, '2019-02-11', 297, NULL),
('Luxor', 62, '2019-02-12', 348, NULL),
('Luxor', 62, '2019-02-13', 292, NULL),
('Luxor', 62, '2019-02-14', 199, NULL),
('Luxor', 62, '2019-02-15', 355, NULL),
('Luxor', 62, '2019-02-16', 310, NULL),
('Luxor', 62, '2019-02-17', 145, NULL),
('Luxor', 62, '2019-02-18', 335, NULL),
('Luxor', 62, '2019-02-19', 250, NULL),
('Luxor', 62, '2019-02-20', 309, NULL),
('Luxor', 62, '2019-02-21', 209, NULL),
('Luxor', 62, '2019-02-22', 364, NULL),
('Luxor', 62, '2019-02-23', 204, NULL),
('Luxor', 62, '2019-02-24', 140, NULL),
('Luxor', 62, '2019-02-25', 244, NULL),
('Luxor', 62, '2019-02-26', 142, NULL),
('Luxor', 62, '2019-02-27', 122, NULL),
('Luxor', 62, '2019-02-28', 166, NULL),
('Luxor', 62, '2019-03-01', 165, NULL),
('Luxor', 62, '2019-03-02', 321, NULL),
('Luxor', 62, '2019-03-03', 243, NULL),
('Luxor', 62, '2019-03-04', 139, NULL),
('Luxor', 62, '2019-03-05', 249, NULL),
('Luxor', 62, '2019-03-06', 115, NULL),
('Luxor', 62, '2019-03-07', 224, NULL),
('Luxor', 62, '2019-03-08', 257, NULL),
('Luxor', 62, '2019-03-09', 392, NULL),
('Luxor', 62, '2019-03-10', 208, NULL),
('Luxor', 62, '2019-03-11', 242, NULL),
('Luxor', 62, '2019-03-12', 159, NULL),
('Luxor', 62, '2019-03-13', 394, NULL),
('Luxor', 62, '2019-03-14', 347, NULL),
('Luxor', 62, '2019-03-15', 273, NULL),
('Luxor', 62, '2019-03-16', 132, NULL),
('Luxor', 62, '2019-03-17', 146, NULL),
('Luxor', 62, '2019-03-18', 352, NULL),
('Luxor', 62, '2019-03-19', 110, NULL),
('Luxor', 62, '2019-03-20', 163, NULL),
('Luxor', 62, '2019-03-21', 297, NULL),
('Luxor', 62, '2019-03-22', 384, NULL),
('Luxor', 62, '2019-03-23', 251, NULL),
('Luxor', 62, '2019-03-24', 122, NULL),
('Luxor', 62, '2019-03-25', 345, NULL),
('Luxor', 62, '2019-03-26', 351, NULL),
('Luxor', 62, '2019-03-27', 231, NULL),
('Luxor', 62, '2019-03-28', 113, NULL),
('Luxor', 62, '2019-03-29', 141, NULL),
('Luxor', 62, '2019-03-30', 294, NULL),
('Luxor', 62, '2019-03-31', 321, NULL),
('Luxor', 62, '2019-04-01', 297, NULL),
('Luxor', 62, '2019-04-02', 316, NULL),
('Luxor', 62, '2019-04-03', 256, NULL),
('Luxor', 62, '2019-04-04', 360, NULL),
('Luxor', 62, '2019-04-05', 325, NULL),
('Luxor', 62, '2019-04-06', 193, NULL),
('Luxor', 62, '2019-04-07', 288, NULL),
('Luxor', 62, '2019-04-08', 346, NULL),
('Luxor', 62, '2019-04-09', 340, NULL),
('Luxor', 62, '2019-04-10', 305, NULL),
('Luxor', 62, '2019-04-11', 280, NULL),
('Luxor', 62, '2019-04-12', 252, NULL),
('Luxor', 62, '2019-04-13', 228, NULL),
('Luxor', 62, '2019-04-14', 141, NULL),
('Luxor', 62, '2019-04-15', 368, NULL),
('Luxor', 62, '2019-04-16', 115, NULL),
('Luxor', 62, '2019-04-17', 161, NULL),
('Luxor', 62, '2019-04-18', 107, NULL),
('Luxor', 62, '2019-04-19', 321, NULL),
('Luxor', 62, '2019-04-20', 396, NULL),
('Luxor', 62, '2019-04-21', 343, NULL),
('Luxor', 62, '2019-04-22', 145, NULL),
('Luxor', 62, '2019-04-23', 143, NULL),
('Luxor', 62, '2019-04-24', 197, NULL),
('Luxor', 62, '2019-04-25', 393, NULL),
('Luxor', 62, '2019-04-26', 303, NULL),
('Luxor', 62, '2019-04-27', 225, NULL),
('Luxor', 62, '2019-04-28', 163, NULL),
('Luxor', 62, '2019-04-29', 134, NULL),
('Luxor', 62, '2019-04-30', 151, NULL),
('Luxor', 62, '2019-05-01', 331, NULL),
('Luxor', 62, '2019-05-02', 395, NULL),
('Luxor', 62, '2019-05-03', 319, NULL),
('Luxor', 62, '2019-05-04', 112, NULL),
('Luxor', 62, '2019-05-05', 364, NULL),
('Luxor', 62, '2019-05-06', 177, NULL),
('Luxor', 62, '2019-05-07', 189, NULL),
('Luxor', 62, '2019-05-08', 392, NULL),
('Luxor', 62, '2019-05-09', 364, NULL),
('Luxor', 62, '2019-05-10', 287, NULL),
('Luxor', 62, '2019-05-11', 219, NULL),
('Luxor', 62, '2019-05-12', 170, NULL),
('Luxor', 62, '2019-05-13', 299, NULL),
('Luxor', 62, '2019-05-14', 261, NULL),
('Luxor', 62, '2019-05-15', 325, NULL),
('Luxor', 62, '2019-05-16', 231, NULL),
('Luxor', 62, '2019-05-17', 127, NULL),
('Luxor', 62, '2019-05-18', 152, NULL),
('Luxor', 62, '2019-05-19', 134, NULL),
('Luxor', 62, '2019-05-20', 229, NULL),
('Luxor', 62, '2019-05-21', 267, NULL),
('Luxor', 62, '2019-05-22', 370, NULL),
('Luxor', 62, '2019-05-23', 315, NULL),
('Luxor', 62, '2019-05-24', 316, NULL),
('Luxor', 62, '2019-05-25', 212, NULL),
('Luxor', 62, '2019-05-26', 182, NULL),
('Luxor', 62, '2019-05-27', 352, NULL),
('Luxor', 62, '2019-05-28', 170, NULL),
('Luxor', 62, '2019-05-29', 248, NULL),
('Luxor', 62, '2019-05-30', 214, NULL),
('Luxor', 62, '2019-05-31', 262, NULL),
('Luxor', 62, '2019-06-01', 179, NULL),
('Luxor', 62, '2019-06-02', 194, NULL),
('Luxor', 62, '2019-06-03', 271, NULL),
('Luxor', 62, '2019-06-04', 110, NULL),
('Luxor', 62, '2019-06-05', 396, NULL),
('Luxor', 62, '2019-06-06', 298, NULL),
('Luxor', 62, '2019-06-07', 127, NULL),
('Luxor', 62, '2019-06-08', 254, NULL),
('Luxor', 62, '2019-06-09', 297, NULL),
('Luxor', 62, '2019-06-10', 135, NULL),
('Luxor', 62, '2019-06-11', 326, NULL),
('Luxor', 62, '2019-06-12', 259, NULL),
('Luxor', 62, '2019-06-13', 216, NULL),
('Luxor', 62, '2019-06-14', 327, NULL),
('Luxor', 62, '2019-06-15', 230, NULL),
('Luxor', 62, '2019-06-16', 346, NULL),
('Luxor', 62, '2019-06-17', 248, NULL),
('Luxor', 62, '2019-06-18', 215, NULL),
('Luxor', 62, '2019-06-19', 298, NULL),
('Luxor', 62, '2019-06-20', 361, NULL),
('Luxor', 62, '2019-06-21', 105, NULL),
('Luxor', 62, '2019-06-22', 169, NULL),
('Luxor', 62, '2019-06-23', 264, NULL),
('Luxor', 62, '2019-06-24', 340, NULL),
('Luxor', 62, '2019-06-25', 196, NULL),
('Luxor', 62, '2019-06-26', 383, NULL),
('Luxor', 62, '2019-06-27', 216, NULL),
('Luxor', 62, '2019-06-28', 246, NULL),
('Luxor', 62, '2019-06-29', 214, NULL),
('Luxor', 62, '2019-06-30', 149, NULL),
('Luxor', 62, '2019-07-01', 288, NULL),
('Luxor', 62, '2019-07-02', 366, NULL),
('Luxor', 62, '2019-07-03', 261, NULL),
('Luxor', 62, '2019-07-04', 127, NULL),
('Luxor', 62, '2019-07-05', 345, NULL),
('Luxor', 62, '2019-07-06', 190, NULL),
('Luxor', 62, '2019-07-07', 343, NULL),
('Luxor', 62, '2019-07-08', 109, NULL),
('Luxor', 62, '2019-07-09', 312, NULL),
('Luxor', 62, '2019-07-10', 282, NULL),
('Luxor', 62, '2019-07-11', 206, NULL),
('Luxor', 62, '2019-07-12', 224, NULL),
('Luxor', 62, '2019-07-13', 351, NULL),
('Luxor', 62, '2019-07-14', 369, NULL),
('Luxor', 62, '2019-07-15', 237, NULL),
('Luxor', 62, '2019-07-16', 317, NULL),
('Luxor', 62, '2019-07-17', 369, NULL),
('Luxor', 62, '2019-07-18', 236, NULL),
('Luxor', 62, '2019-07-19', 297, NULL),
('Luxor', 62, '2019-07-20', 238, NULL),
('Luxor', 62, '2019-07-21', 188, NULL),
('Luxor', 62, '2019-07-22', 361, NULL),
('Luxor', 62, '2019-07-23', 170, NULL),
('Luxor', 62, '2019-07-24', 255, NULL),
('Luxor', 62, '2019-07-25', 176, NULL),
('Luxor', 62, '2019-07-26', 131, NULL),
('Luxor', 62, '2019-07-27', 381, NULL),
('Luxor', 62, '2019-07-28', 350, NULL),
('Luxor', 62, '2019-07-29', 333, NULL),
('Luxor', 62, '2019-07-30', 301, NULL),
('Luxor', 62, '2019-07-31', 261, NULL),
('Luxor', 62, '2019-08-01', 183, NULL),
('Luxor', 62, '2019-08-02', 358, NULL),
('Luxor', 62, '2019-08-03', 337, NULL),
('Luxor', 62, '2019-08-04', 369, NULL),
('Luxor', 62, '2019-08-05', 353, NULL),
('Luxor', 62, '2019-08-06', 115, NULL),
('Luxor', 62, '2019-08-07', 262, NULL),
('Luxor', 62, '2019-08-08', 172, NULL),
('Luxor', 62, '2019-08-09', 160, NULL),
('Luxor', 62, '2019-08-10', 244, NULL),
('Luxor', 62, '2019-08-11', 224, NULL),
('Luxor', 62, '2019-08-12', 259, NULL),
('Luxor', 62, '2019-08-13', 334, NULL),
('Luxor', 62, '2019-08-14', 339, NULL),
('Luxor', 62, '2019-08-15', 219, NULL),
('Luxor', 62, '2019-08-16', 241, NULL),
('Luxor', 62, '2019-08-17', 347, NULL),
('Luxor', 62, '2019-08-18', 193, NULL),
('Luxor', 62, '2019-08-19', 280, NULL),
('Luxor', 62, '2019-08-20', 316, NULL),
('Luxor', 62, '2019-08-21', 140, NULL),
('Luxor', 62, '2019-08-22', 217, NULL),
('Luxor', 62, '2019-08-23', 216, NULL),
('Luxor', 62, '2019-08-24', 238, NULL),
('Luxor', 62, '2019-08-25', 271, NULL),
('Luxor', 62, '2019-08-26', 275, NULL),
('Luxor', 62, '2019-08-27', 345, NULL),
('Luxor', 62, '2019-08-28', 244, NULL),
('Luxor', 62, '2019-08-29', 300, NULL),
('Luxor', 62, '2019-08-30', 256, NULL),
('Luxor', 62, '2019-08-31', 258, NULL),
('Luxor', 62, '2019-09-01', 108, NULL),
('Luxor', 62, '2019-09-02', 299, NULL),
('Luxor', 62, '2019-09-03', 108, NULL),
('Luxor', 62, '2019-09-04', 297, NULL),
('Luxor', 62, '2019-09-05', 134, NULL),
('Luxor', 62, '2019-09-06', 191, NULL),
('Luxor', 62, '2019-09-07', 324, NULL),
('Luxor', 62, '2019-09-08', 246, NULL),
('Luxor', 62, '2019-09-09', 184, NULL),
('Luxor', 62, '2019-09-10', 285, NULL),
('Luxor', 62, '2019-09-11', 192, NULL),
('Luxor', 62, '2019-09-12', 349, NULL),
('Luxor', 62, '2019-09-13', 257, NULL),
('Luxor', 62, '2019-09-14', 270, NULL),
('Luxor', 62, '2019-09-15', 274, NULL),
('Luxor', 62, '2019-09-16', 338, NULL),
('Luxor', 62, '2019-09-17', 212, NULL),
('Luxor', 62, '2019-09-18', 269, NULL),
('Luxor', 62, '2019-09-19', 244, NULL),
('Luxor', 62, '2019-09-20', 328, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 62, '2019-09-21', 117, NULL),
('Luxor', 62, '2019-09-22', 114, NULL),
('Luxor', 62, '2019-09-23', 236, NULL),
('Luxor', 62, '2019-09-24', 324, NULL),
('Luxor', 62, '2019-09-25', 362, NULL),
('Luxor', 62, '2019-09-26', 154, NULL),
('Luxor', 62, '2019-09-27', 178, NULL),
('Luxor', 62, '2019-09-28', 278, NULL),
('Luxor', 62, '2019-09-29', 275, NULL),
('Luxor', 62, '2019-09-30', 284, NULL),
('Luxor', 62, '2019-10-01', 137, NULL),
('Luxor', 62, '2019-10-02', 237, NULL),
('Luxor', 62, '2019-10-03', 161, NULL),
('Luxor', 62, '2019-10-04', 381, NULL),
('Luxor', 62, '2019-10-05', 257, NULL),
('Luxor', 62, '2019-10-06', 160, NULL),
('Luxor', 62, '2019-10-07', 319, NULL),
('Luxor', 62, '2019-10-08', 248, NULL),
('Luxor', 62, '2019-10-09', 361, NULL),
('Luxor', 62, '2019-10-10', 225, NULL),
('Luxor', 62, '2019-10-11', 306, NULL),
('Luxor', 62, '2019-10-12', 286, NULL),
('Luxor', 62, '2019-10-13', 149, NULL),
('Luxor', 62, '2019-10-14', 129, NULL),
('Luxor', 62, '2019-10-15', 233, NULL),
('Luxor', 62, '2019-10-16', 117, NULL),
('Luxor', 62, '2019-10-17', 249, NULL),
('Luxor', 62, '2019-10-18', 333, NULL),
('Luxor', 62, '2019-10-19', 310, NULL),
('Luxor', 62, '2019-10-20', 380, NULL),
('Luxor', 62, '2019-10-21', 166, NULL),
('Luxor', 62, '2019-10-22', 252, NULL),
('Luxor', 62, '2019-10-23', 323, NULL),
('Luxor', 62, '2019-10-24', 151, NULL),
('Luxor', 62, '2019-10-25', 302, NULL),
('Luxor', 62, '2019-10-26', 371, NULL),
('Luxor', 62, '2019-10-27', 391, NULL),
('Luxor', 62, '2019-10-28', 122, NULL),
('Luxor', 62, '2019-10-29', 289, NULL),
('Luxor', 62, '2019-10-30', 280, NULL),
('Luxor', 62, '2019-10-31', 121, NULL),
('Luxor', 62, '2019-11-01', 371, NULL),
('Luxor', 62, '2019-11-02', 268, NULL),
('Luxor', 62, '2019-11-03', 264, NULL),
('Luxor', 62, '2019-11-04', 274, NULL),
('Luxor', 62, '2019-11-05', 343, NULL),
('Luxor', 62, '2019-11-06', 110, NULL),
('Luxor', 62, '2019-11-07', 258, NULL),
('Luxor', 62, '2019-11-08', 113, NULL),
('Luxor', 62, '2019-11-09', 254, NULL),
('Luxor', 62, '2019-11-10', 115, NULL),
('Luxor', 62, '2019-11-11', 223, NULL),
('Luxor', 62, '2019-11-12', 185, NULL),
('Luxor', 62, '2019-11-13', 268, NULL),
('Luxor', 62, '2019-11-14', 333, NULL),
('Luxor', 62, '2019-11-15', 381, NULL),
('Luxor', 62, '2019-11-16', 205, NULL),
('Luxor', 62, '2019-11-17', 239, NULL),
('Luxor', 62, '2019-11-18', 254, NULL),
('Luxor', 62, '2019-11-19', 275, NULL),
('Luxor', 62, '2019-11-20', 376, NULL),
('Luxor', 62, '2019-11-21', 272, NULL),
('Luxor', 62, '2019-11-22', 338, NULL),
('Luxor', 62, '2019-11-23', 245, NULL),
('Luxor', 62, '2019-11-24', 357, NULL),
('Luxor', 62, '2019-11-25', 185, NULL),
('Luxor', 62, '2019-11-26', 169, NULL),
('Luxor', 62, '2019-11-27', 346, NULL),
('Luxor', 62, '2019-11-28', 350, NULL),
('Luxor', 62, '2019-11-29', 118, NULL),
('Luxor', 62, '2019-11-30', 241, NULL),
('Luxor', 62, '2019-12-01', 207, NULL),
('Luxor', 62, '2019-12-02', 212, NULL),
('Luxor', 62, '2019-12-03', 298, NULL),
('Luxor', 62, '2019-12-04', 384, NULL),
('Luxor', 62, '2019-12-05', 133, NULL),
('Luxor', 62, '2019-12-06', 227, NULL),
('Luxor', 62, '2019-12-07', 213, NULL),
('Luxor', 62, '2019-12-08', 256, NULL),
('Luxor', 62, '2019-12-09', 149, NULL),
('Luxor', 62, '2019-12-10', 142, NULL),
('Luxor', 62, '2019-12-11', 314, NULL),
('Luxor', 62, '2019-12-12', 265, NULL),
('Luxor', 62, '2019-12-13', 221, NULL),
('Luxor', 62, '2019-12-14', 143, NULL),
('Luxor', 62, '2019-12-15', 292, NULL),
('Luxor', 62, '2019-12-16', 311, NULL),
('Luxor', 62, '2019-12-17', 297, NULL),
('Luxor', 62, '2019-12-18', 183, NULL),
('Luxor', 62, '2019-12-19', 376, NULL),
('Luxor', 62, '2019-12-20', 350, NULL),
('Luxor', 62, '2019-12-21', 300, NULL),
('Luxor', 62, '2019-12-22', 130, NULL),
('Luxor', 62, '2019-12-23', 243, NULL),
('Luxor', 62, '2019-12-24', 101, NULL),
('Luxor', 62, '2019-12-25', 188, NULL),
('Luxor', 62, '2019-12-26', 319, NULL),
('Luxor', 62, '2019-12-27', 137, NULL),
('Luxor', 62, '2019-12-28', 120, NULL),
('Luxor', 62, '2019-12-29', 206, NULL),
('Luxor', 62, '2019-12-30', 373, NULL),
('Luxor', 62, '2019-12-31', 309, NULL),
('Luxor', 62, '2020-01-01', 133, NULL),
('Luxor', 62, '2020-01-02', 330, NULL),
('Luxor', 62, '2020-01-03', 162, NULL),
('Luxor', 62, '2020-01-04', 280, NULL),
('Luxor', 62, '2020-01-05', 161, NULL),
('Luxor', 62, '2020-01-06', 188, NULL),
('Luxor', 62, '2020-01-07', 149, NULL),
('Luxor', 62, '2020-01-08', 325, NULL),
('Luxor', 62, '2020-01-09', 311, NULL),
('Luxor', 62, '2020-01-10', 334, NULL),
('Luxor', 62, '2020-01-11', 221, NULL),
('Luxor', 62, '2020-01-12', 114, NULL),
('Luxor', 62, '2020-01-13', 208, NULL),
('Luxor', 62, '2020-01-14', 156, NULL),
('Luxor', 62, '2020-01-15', 162, NULL),
('Luxor', 62, '2020-01-16', 352, NULL),
('Luxor', 62, '2020-01-17', 395, NULL),
('Luxor', 62, '2020-01-18', 335, NULL),
('Luxor', 62, '2020-01-19', 326, NULL),
('Luxor', 62, '2020-01-20', 284, NULL),
('Luxor', 62, '2020-01-21', 335, NULL),
('Luxor', 62, '2020-01-22', 135, NULL),
('Luxor', 62, '2020-01-23', 199, NULL),
('Luxor', 62, '2020-01-24', 313, NULL),
('Luxor', 62, '2020-01-25', 163, NULL),
('Luxor', 62, '2020-01-26', 111, NULL),
('Luxor', 62, '2020-01-27', 204, NULL),
('Luxor', 62, '2020-01-28', 297, NULL),
('Luxor', 62, '2020-01-29', 262, NULL),
('Luxor', 62, '2020-01-30', 313, NULL),
('Luxor', 62, '2020-01-31', 182, NULL),
('Luxor', 62, '2020-02-01', 185, NULL),
('Luxor', 62, '2020-02-02', 201, NULL),
('Luxor', 62, '2020-02-03', 398, NULL),
('Luxor', 62, '2020-02-04', 347, NULL),
('Luxor', 89, '2019-01-01', 107, NULL),
('Luxor', 89, '2019-01-02', 304, NULL),
('Luxor', 89, '2019-01-03', 215, NULL),
('Luxor', 89, '2019-01-04', 210, NULL),
('Luxor', 89, '2019-01-05', 160, NULL),
('Luxor', 89, '2019-01-06', 239, NULL),
('Luxor', 89, '2019-01-07', 270, NULL),
('Luxor', 89, '2019-01-08', 355, NULL),
('Luxor', 89, '2019-01-09', 105, NULL),
('Luxor', 89, '2019-01-10', 119, NULL),
('Luxor', 89, '2019-01-11', 382, NULL),
('Luxor', 89, '2019-01-12', 233, NULL),
('Luxor', 89, '2019-01-13', 367, NULL),
('Luxor', 89, '2019-01-14', 397, NULL),
('Luxor', 89, '2019-01-15', 360, NULL),
('Luxor', 89, '2019-01-16', 156, NULL),
('Luxor', 89, '2019-01-17', 323, NULL),
('Luxor', 89, '2019-01-18', 394, NULL),
('Luxor', 89, '2019-01-19', 164, NULL),
('Luxor', 89, '2019-01-20', 230, NULL),
('Luxor', 89, '2019-01-21', 258, NULL),
('Luxor', 89, '2019-01-22', 303, NULL),
('Luxor', 89, '2019-01-23', 386, NULL),
('Luxor', 89, '2019-01-24', 351, NULL),
('Luxor', 89, '2019-01-25', 226, NULL),
('Luxor', 89, '2019-01-26', 291, NULL),
('Luxor', 89, '2019-01-27', 149, NULL),
('Luxor', 89, '2019-01-28', 224, NULL),
('Luxor', 89, '2019-01-29', 290, NULL),
('Luxor', 89, '2019-01-30', 231, NULL),
('Luxor', 89, '2019-01-31', 271, NULL),
('Luxor', 89, '2019-02-01', 360, NULL),
('Luxor', 89, '2019-02-02', 343, NULL),
('Luxor', 89, '2019-02-03', 317, NULL),
('Luxor', 89, '2019-02-04', 392, NULL),
('Luxor', 89, '2019-02-05', 290, NULL),
('Luxor', 89, '2019-02-06', 310, NULL),
('Luxor', 89, '2019-02-07', 352, NULL),
('Luxor', 89, '2019-02-08', 183, NULL),
('Luxor', 89, '2019-02-09', 178, NULL),
('Luxor', 89, '2019-02-10', 197, NULL),
('Luxor', 89, '2019-02-11', 399, NULL),
('Luxor', 89, '2019-02-12', 109, NULL),
('Luxor', 89, '2019-02-13', 112, NULL),
('Luxor', 89, '2019-02-14', 258, NULL),
('Luxor', 89, '2019-02-15', 369, NULL),
('Luxor', 89, '2019-02-16', 366, NULL),
('Luxor', 89, '2019-02-17', 184, NULL),
('Luxor', 89, '2019-02-18', 329, NULL),
('Luxor', 89, '2019-02-19', 200, NULL),
('Luxor', 89, '2019-02-20', 346, NULL),
('Luxor', 89, '2019-02-21', 170, NULL),
('Luxor', 89, '2019-02-22', 209, NULL),
('Luxor', 89, '2019-02-23', 189, NULL),
('Luxor', 89, '2019-02-24', 380, NULL),
('Luxor', 89, '2019-02-25', 288, NULL),
('Luxor', 89, '2019-02-26', 202, NULL),
('Luxor', 89, '2019-02-27', 265, NULL),
('Luxor', 89, '2019-02-28', 129, NULL),
('Luxor', 89, '2019-03-01', 241, NULL),
('Luxor', 89, '2019-03-02', 106, NULL),
('Luxor', 89, '2019-03-03', 250, NULL),
('Luxor', 89, '2019-03-04', 243, NULL),
('Luxor', 89, '2019-03-05', 232, NULL),
('Luxor', 89, '2019-03-06', 205, NULL),
('Luxor', 89, '2019-03-07', 321, NULL),
('Luxor', 89, '2019-03-08', 227, NULL),
('Luxor', 89, '2019-03-09', 121, NULL),
('Luxor', 89, '2019-03-10', 261, NULL),
('Luxor', 89, '2019-03-11', 142, NULL),
('Luxor', 89, '2019-03-12', 123, NULL),
('Luxor', 89, '2019-03-13', 395, NULL),
('Luxor', 89, '2019-03-14', 117, NULL),
('Luxor', 89, '2019-03-15', 166, NULL),
('Luxor', 89, '2019-03-16', 318, NULL),
('Luxor', 89, '2019-03-17', 300, NULL),
('Luxor', 89, '2019-03-18', 236, NULL),
('Luxor', 89, '2019-03-19', 283, NULL),
('Luxor', 89, '2019-03-20', 122, NULL),
('Luxor', 89, '2019-03-21', 124, NULL),
('Luxor', 89, '2019-03-22', 263, NULL),
('Luxor', 89, '2019-03-23', 191, NULL),
('Luxor', 89, '2019-03-24', 224, NULL),
('Luxor', 89, '2019-03-25', 271, NULL),
('Luxor', 89, '2019-03-26', 159, NULL),
('Luxor', 89, '2019-03-27', 133, NULL),
('Luxor', 89, '2019-03-28', 141, NULL),
('Luxor', 89, '2019-03-29', 369, NULL),
('Luxor', 89, '2019-03-30', 187, NULL),
('Luxor', 89, '2019-03-31', 251, NULL),
('Luxor', 89, '2019-04-01', 156, NULL),
('Luxor', 89, '2019-04-02', 366, NULL),
('Luxor', 89, '2019-04-03', 241, NULL),
('Luxor', 89, '2019-04-04', 323, NULL),
('Luxor', 89, '2019-04-05', 202, NULL),
('Luxor', 89, '2019-04-06', 212, NULL),
('Luxor', 89, '2019-04-07', 133, NULL),
('Luxor', 89, '2019-04-08', 143, NULL),
('Luxor', 89, '2019-04-09', 380, NULL),
('Luxor', 89, '2019-04-10', 173, NULL),
('Luxor', 89, '2019-04-11', 215, NULL),
('Luxor', 89, '2019-04-12', 198, NULL),
('Luxor', 89, '2019-04-13', 274, NULL),
('Luxor', 89, '2019-04-14', 321, NULL),
('Luxor', 89, '2019-04-15', 390, NULL),
('Luxor', 89, '2019-04-16', 116, NULL),
('Luxor', 89, '2019-04-17', 219, NULL),
('Luxor', 89, '2019-04-18', 356, NULL),
('Luxor', 89, '2019-04-19', 302, NULL),
('Luxor', 89, '2019-04-20', 248, NULL),
('Luxor', 89, '2019-04-21', 268, NULL),
('Luxor', 89, '2019-04-22', 205, NULL),
('Luxor', 89, '2019-04-23', 142, NULL),
('Luxor', 89, '2019-04-24', 260, NULL),
('Luxor', 89, '2019-04-25', 380, NULL),
('Luxor', 89, '2019-04-26', 296, NULL),
('Luxor', 89, '2019-04-27', 383, NULL),
('Luxor', 89, '2019-04-28', 386, NULL),
('Luxor', 89, '2019-04-29', 161, NULL),
('Luxor', 89, '2019-04-30', 324, NULL),
('Luxor', 89, '2019-05-01', 214, NULL),
('Luxor', 89, '2019-05-02', 227, NULL),
('Luxor', 89, '2019-05-03', 336, NULL),
('Luxor', 89, '2019-05-04', 389, NULL),
('Luxor', 89, '2019-05-05', 365, NULL),
('Luxor', 89, '2019-05-06', 399, NULL),
('Luxor', 89, '2019-05-07', 353, NULL),
('Luxor', 89, '2019-05-08', 295, NULL),
('Luxor', 89, '2019-05-09', 104, NULL),
('Luxor', 89, '2019-05-10', 182, NULL),
('Luxor', 89, '2019-05-11', 366, NULL),
('Luxor', 89, '2019-05-12', 140, NULL),
('Luxor', 89, '2019-05-13', 313, NULL),
('Luxor', 89, '2019-05-14', 268, NULL),
('Luxor', 89, '2019-05-15', 237, NULL),
('Luxor', 89, '2019-05-16', 208, NULL),
('Luxor', 89, '2019-05-17', 236, NULL),
('Luxor', 89, '2019-05-18', 108, NULL),
('Luxor', 89, '2019-05-19', 225, NULL),
('Luxor', 89, '2019-05-20', 212, NULL),
('Luxor', 89, '2019-05-21', 216, NULL),
('Luxor', 89, '2019-05-22', 195, NULL),
('Luxor', 89, '2019-05-23', 197, NULL),
('Luxor', 89, '2019-05-24', 346, NULL),
('Luxor', 89, '2019-05-25', 395, NULL),
('Luxor', 89, '2019-05-26', 393, NULL),
('Luxor', 89, '2019-05-27', 207, NULL),
('Luxor', 89, '2019-05-28', 173, NULL),
('Luxor', 89, '2019-05-29', 397, NULL),
('Luxor', 89, '2019-05-30', 129, NULL),
('Luxor', 89, '2019-05-31', 290, NULL),
('Luxor', 89, '2019-06-01', 141, NULL),
('Luxor', 89, '2019-06-02', 334, NULL),
('Luxor', 89, '2019-06-03', 390, NULL),
('Luxor', 89, '2019-06-04', 244, NULL),
('Luxor', 89, '2019-06-05', 227, NULL),
('Luxor', 89, '2019-06-06', 213, NULL),
('Luxor', 89, '2019-06-07', 284, NULL),
('Luxor', 89, '2019-06-08', 192, NULL),
('Luxor', 89, '2019-06-09', 200, NULL),
('Luxor', 89, '2019-06-10', 174, NULL),
('Luxor', 89, '2019-06-11', 327, NULL),
('Luxor', 89, '2019-06-12', 144, NULL),
('Luxor', 89, '2019-06-13', 248, NULL),
('Luxor', 89, '2019-06-14', 220, NULL),
('Luxor', 89, '2019-06-15', 187, NULL),
('Luxor', 89, '2019-06-16', 301, NULL),
('Luxor', 89, '2019-06-17', 388, NULL),
('Luxor', 89, '2019-06-18', 230, NULL),
('Luxor', 89, '2019-06-19', 211, NULL),
('Luxor', 89, '2019-06-20', 344, NULL),
('Luxor', 89, '2019-06-21', 334, NULL),
('Luxor', 89, '2019-06-22', 353, NULL),
('Luxor', 89, '2019-06-23', 351, NULL),
('Luxor', 89, '2019-06-24', 146, NULL),
('Luxor', 89, '2019-06-25', 130, NULL),
('Luxor', 89, '2019-06-26', 251, NULL),
('Luxor', 89, '2019-06-27', 267, NULL),
('Luxor', 89, '2019-06-28', 114, NULL),
('Luxor', 89, '2019-06-29', 234, NULL),
('Luxor', 89, '2019-06-30', 340, NULL),
('Luxor', 89, '2019-07-01', 101, NULL),
('Luxor', 89, '2019-07-02', 139, NULL),
('Luxor', 89, '2019-07-03', 108, NULL),
('Luxor', 89, '2019-07-04', 105, NULL),
('Luxor', 89, '2019-07-05', 107, NULL),
('Luxor', 89, '2019-07-06', 293, NULL),
('Luxor', 89, '2019-07-07', 302, NULL),
('Luxor', 89, '2019-07-08', 182, NULL),
('Luxor', 89, '2019-07-09', 367, NULL),
('Luxor', 89, '2019-07-10', 374, NULL),
('Luxor', 89, '2019-07-11', 167, NULL),
('Luxor', 89, '2019-07-12', 285, NULL),
('Luxor', 89, '2019-07-13', 160, NULL),
('Luxor', 89, '2019-07-14', 164, NULL),
('Luxor', 89, '2019-07-15', 157, NULL),
('Luxor', 89, '2019-07-16', 233, NULL),
('Luxor', 89, '2019-07-17', 256, NULL),
('Luxor', 89, '2019-07-18', 291, NULL),
('Luxor', 89, '2019-07-19', 286, NULL),
('Luxor', 89, '2019-07-20', 266, NULL),
('Luxor', 89, '2019-07-21', 290, NULL),
('Luxor', 89, '2019-07-22', 261, NULL),
('Luxor', 89, '2019-07-23', 257, NULL),
('Luxor', 89, '2019-07-24', 355, NULL),
('Luxor', 89, '2019-07-25', 179, NULL),
('Luxor', 89, '2019-07-26', 234, NULL),
('Luxor', 89, '2019-07-27', 378, NULL),
('Luxor', 89, '2019-07-28', 230, NULL),
('Luxor', 89, '2019-07-29', 284, NULL),
('Luxor', 89, '2019-07-30', 280, NULL),
('Luxor', 89, '2019-07-31', 213, NULL),
('Luxor', 89, '2019-08-01', 251, NULL),
('Luxor', 89, '2019-08-02', 397, NULL),
('Luxor', 89, '2019-08-03', 332, NULL),
('Luxor', 89, '2019-08-04', 208, NULL),
('Luxor', 89, '2019-08-05', 109, NULL),
('Luxor', 89, '2019-08-06', 361, NULL),
('Luxor', 89, '2019-08-07', 280, NULL),
('Luxor', 89, '2019-08-08', 330, NULL),
('Luxor', 89, '2019-08-09', 347, NULL),
('Luxor', 89, '2019-08-10', 352, NULL),
('Luxor', 89, '2019-08-11', 275, NULL),
('Luxor', 89, '2019-08-12', 189, NULL),
('Luxor', 89, '2019-08-13', 325, NULL),
('Luxor', 89, '2019-08-14', 128, NULL),
('Luxor', 89, '2019-08-15', 388, NULL),
('Luxor', 89, '2019-08-16', 373, NULL),
('Luxor', 89, '2019-08-17', 134, NULL),
('Luxor', 89, '2019-08-18', 103, NULL),
('Luxor', 89, '2019-08-19', 383, NULL),
('Luxor', 89, '2019-08-20', 282, NULL),
('Luxor', 89, '2019-08-21', 358, NULL),
('Luxor', 89, '2019-08-22', 311, NULL),
('Luxor', 89, '2019-08-23', 298, NULL),
('Luxor', 89, '2019-08-24', 199, NULL),
('Luxor', 89, '2019-08-25', 215, NULL),
('Luxor', 89, '2019-08-26', 156, NULL),
('Luxor', 89, '2019-08-27', 391, NULL),
('Luxor', 89, '2019-08-28', 191, NULL),
('Luxor', 89, '2019-08-29', 117, NULL),
('Luxor', 89, '2019-08-30', 388, NULL),
('Luxor', 89, '2019-08-31', 363, NULL),
('Luxor', 89, '2019-09-01', 173, NULL),
('Luxor', 89, '2019-09-02', 355, NULL),
('Luxor', 89, '2019-09-03', 192, NULL),
('Luxor', 89, '2019-09-04', 238, NULL),
('Luxor', 89, '2019-09-05', 398, NULL),
('Luxor', 89, '2019-09-06', 342, NULL),
('Luxor', 89, '2019-09-07', 234, NULL),
('Luxor', 89, '2019-09-08', 338, NULL),
('Luxor', 89, '2019-09-09', 377, NULL),
('Luxor', 89, '2019-09-10', 390, NULL),
('Luxor', 89, '2019-09-11', 121, NULL),
('Luxor', 89, '2019-09-12', 152, NULL),
('Luxor', 89, '2019-09-13', 357, NULL),
('Luxor', 89, '2019-09-14', 186, NULL),
('Luxor', 89, '2019-09-15', 258, NULL),
('Luxor', 89, '2019-09-16', 289, NULL),
('Luxor', 89, '2019-09-17', 383, NULL),
('Luxor', 89, '2019-09-18', 187, NULL),
('Luxor', 89, '2019-09-19', 161, NULL),
('Luxor', 89, '2019-09-20', 339, NULL),
('Luxor', 89, '2019-09-21', 237, NULL),
('Luxor', 89, '2019-09-22', 149, NULL),
('Luxor', 89, '2019-09-23', 383, NULL),
('Luxor', 89, '2019-09-24', 220, NULL),
('Luxor', 89, '2019-09-25', 364, NULL),
('Luxor', 89, '2019-09-26', 170, NULL),
('Luxor', 89, '2019-09-27', 199, NULL),
('Luxor', 89, '2019-09-28', 213, NULL),
('Luxor', 89, '2019-09-29', 127, NULL),
('Luxor', 89, '2019-09-30', 324, NULL),
('Luxor', 89, '2019-10-01', 311, NULL),
('Luxor', 89, '2019-10-02', 146, NULL),
('Luxor', 89, '2019-10-03', 288, NULL),
('Luxor', 89, '2019-10-04', 245, NULL),
('Luxor', 89, '2019-10-05', 272, NULL),
('Luxor', 89, '2019-10-06', 276, NULL),
('Luxor', 89, '2019-10-07', 127, NULL),
('Luxor', 89, '2019-10-08', 103, NULL),
('Luxor', 89, '2019-10-09', 280, NULL),
('Luxor', 89, '2019-10-10', 382, NULL),
('Luxor', 89, '2019-10-11', 231, NULL),
('Luxor', 89, '2019-10-12', 100, NULL),
('Luxor', 89, '2019-10-13', 343, NULL),
('Luxor', 89, '2019-10-14', 189, NULL),
('Luxor', 89, '2019-10-15', 388, NULL),
('Luxor', 89, '2019-10-16', 358, NULL),
('Luxor', 89, '2019-10-17', 175, NULL),
('Luxor', 89, '2019-10-18', 390, NULL),
('Luxor', 89, '2019-10-19', 337, NULL),
('Luxor', 89, '2019-10-20', 181, NULL),
('Luxor', 89, '2019-10-21', 392, NULL),
('Luxor', 89, '2019-10-22', 152, NULL),
('Luxor', 89, '2019-10-23', 236, NULL),
('Luxor', 89, '2019-10-24', 346, NULL),
('Luxor', 89, '2019-10-25', 351, NULL),
('Luxor', 89, '2019-10-26', 245, NULL),
('Luxor', 89, '2019-10-27', 278, NULL),
('Luxor', 89, '2019-10-28', 273, NULL),
('Luxor', 89, '2019-10-29', 375, NULL),
('Luxor', 89, '2019-10-30', 121, NULL),
('Luxor', 89, '2019-10-31', 248, NULL),
('Luxor', 89, '2019-11-01', 124, NULL),
('Luxor', 89, '2019-11-02', 359, NULL),
('Luxor', 89, '2019-11-03', 374, NULL),
('Luxor', 89, '2019-11-04', 205, NULL),
('Luxor', 89, '2019-11-05', 203, NULL),
('Luxor', 89, '2019-11-06', 150, NULL),
('Luxor', 89, '2019-11-07', 203, NULL),
('Luxor', 89, '2019-11-08', 101, NULL),
('Luxor', 89, '2019-11-09', 270, NULL),
('Luxor', 89, '2019-11-10', 142, NULL),
('Luxor', 89, '2019-11-11', 268, NULL),
('Luxor', 89, '2019-11-12', 302, NULL),
('Luxor', 89, '2019-11-13', 193, NULL),
('Luxor', 89, '2019-11-14', 158, NULL),
('Luxor', 89, '2019-11-15', 223, NULL),
('Luxor', 89, '2019-11-16', 376, NULL),
('Luxor', 89, '2019-11-17', 270, NULL),
('Luxor', 89, '2019-11-18', 135, NULL),
('Luxor', 89, '2019-11-19', 262, NULL),
('Luxor', 89, '2019-11-20', 202, NULL),
('Luxor', 89, '2019-11-21', 298, NULL),
('Luxor', 89, '2019-11-22', 289, NULL),
('Luxor', 89, '2019-11-23', 308, NULL),
('Luxor', 89, '2019-11-24', 201, NULL),
('Luxor', 89, '2019-11-25', 326, NULL),
('Luxor', 89, '2019-11-26', 215, NULL),
('Luxor', 89, '2019-11-27', 192, NULL),
('Luxor', 89, '2019-11-28', 237, NULL),
('Luxor', 89, '2019-11-29', 359, NULL),
('Luxor', 89, '2019-11-30', 256, NULL),
('Luxor', 89, '2019-12-01', 372, NULL),
('Luxor', 89, '2019-12-02', 242, NULL),
('Luxor', 89, '2019-12-03', 390, NULL),
('Luxor', 89, '2019-12-04', 230, NULL),
('Luxor', 89, '2019-12-05', 216, NULL),
('Luxor', 89, '2019-12-06', 197, NULL),
('Luxor', 89, '2019-12-07', 325, NULL),
('Luxor', 89, '2019-12-08', 232, NULL),
('Luxor', 89, '2019-12-09', 205, NULL),
('Luxor', 89, '2019-12-10', 174, NULL),
('Luxor', 89, '2019-12-11', 140, NULL),
('Luxor', 89, '2019-12-12', 193, NULL),
('Luxor', 89, '2019-12-13', 244, NULL),
('Luxor', 89, '2019-12-14', 116, NULL),
('Luxor', 89, '2019-12-15', 239, NULL),
('Luxor', 89, '2019-12-16', 130, NULL),
('Luxor', 89, '2019-12-17', 384, NULL),
('Luxor', 89, '2019-12-18', 326, NULL),
('Luxor', 89, '2019-12-19', 266, NULL),
('Luxor', 89, '2019-12-20', 136, NULL),
('Luxor', 89, '2019-12-21', 387, NULL),
('Luxor', 89, '2019-12-22', 278, NULL),
('Luxor', 89, '2019-12-23', 291, NULL),
('Luxor', 89, '2019-12-24', 394, NULL),
('Luxor', 89, '2019-12-25', 222, NULL),
('Luxor', 89, '2019-12-26', 120, NULL),
('Luxor', 89, '2019-12-27', 336, NULL),
('Luxor', 89, '2019-12-28', 216, NULL),
('Luxor', 89, '2019-12-29', 182, NULL),
('Luxor', 89, '2019-12-30', 109, NULL),
('Luxor', 89, '2019-12-31', 335, NULL),
('Luxor', 89, '2020-01-01', 160, NULL),
('Luxor', 89, '2020-01-02', 248, NULL),
('Luxor', 89, '2020-01-03', 248, NULL),
('Luxor', 89, '2020-01-04', 293, NULL),
('Luxor', 89, '2020-01-05', 384, NULL),
('Luxor', 89, '2020-01-06', 339, NULL),
('Luxor', 89, '2020-01-07', 147, NULL),
('Luxor', 89, '2020-01-08', 357, NULL),
('Luxor', 89, '2020-01-09', 375, NULL),
('Luxor', 89, '2020-01-10', 295, NULL),
('Luxor', 89, '2020-01-11', 226, NULL),
('Luxor', 89, '2020-01-12', 187, NULL),
('Luxor', 89, '2020-01-13', 346, NULL),
('Luxor', 89, '2020-01-14', 198, NULL),
('Luxor', 89, '2020-01-15', 290, NULL),
('Luxor', 89, '2020-01-16', 346, NULL),
('Luxor', 89, '2020-01-17', 289, NULL),
('Luxor', 89, '2020-01-18', 127, NULL),
('Luxor', 89, '2020-01-19', 349, NULL),
('Luxor', 89, '2020-01-20', 166, NULL),
('Luxor', 89, '2020-01-21', 321, NULL),
('Luxor', 89, '2020-01-22', 389, NULL),
('Luxor', 89, '2020-01-23', 196, NULL),
('Luxor', 89, '2020-01-24', 335, NULL),
('Luxor', 89, '2020-01-25', 395, NULL),
('Luxor', 89, '2020-01-26', 177, NULL),
('Luxor', 89, '2020-01-27', 150, NULL),
('Luxor', 89, '2020-01-28', 160, NULL),
('Luxor', 89, '2020-01-29', 114, NULL),
('Luxor', 89, '2020-01-30', 336, NULL),
('Luxor', 89, '2020-01-31', 160, NULL),
('Luxor', 89, '2020-02-01', 364, NULL),
('Luxor', 89, '2020-02-02', 307, NULL),
('Luxor', 89, '2020-02-03', 205, NULL),
('Luxor', 89, '2020-02-04', 122, NULL),
('Luxor', 128, '2019-01-01', 233, NULL),
('Luxor', 128, '2019-01-02', 123, NULL),
('Luxor', 128, '2019-01-03', 120, NULL),
('Luxor', 128, '2019-01-04', 288, NULL),
('Luxor', 128, '2019-01-05', 292, NULL),
('Luxor', 128, '2019-01-06', 370, NULL),
('Luxor', 128, '2019-01-07', 196, NULL),
('Luxor', 128, '2019-01-08', 105, NULL),
('Luxor', 128, '2019-01-09', 271, NULL),
('Luxor', 128, '2019-01-10', 110, NULL),
('Luxor', 128, '2019-01-11', 116, NULL),
('Luxor', 128, '2019-01-12', 390, NULL),
('Luxor', 128, '2019-01-13', 341, NULL),
('Luxor', 128, '2019-01-14', 351, NULL),
('Luxor', 128, '2019-01-15', 108, NULL),
('Luxor', 128, '2019-01-16', 314, NULL),
('Luxor', 128, '2019-01-17', 218, NULL),
('Luxor', 128, '2019-01-18', 366, NULL),
('Luxor', 128, '2019-01-19', 258, NULL),
('Luxor', 128, '2019-01-20', 358, NULL),
('Luxor', 128, '2019-01-21', 264, NULL),
('Luxor', 128, '2019-01-22', 159, NULL),
('Luxor', 128, '2019-01-23', 365, NULL),
('Luxor', 128, '2019-01-24', 356, NULL),
('Luxor', 128, '2019-01-25', 195, NULL),
('Luxor', 128, '2019-01-26', 137, NULL),
('Luxor', 128, '2019-01-27', 107, NULL),
('Luxor', 128, '2019-01-28', 114, NULL),
('Luxor', 128, '2019-01-29', 201, NULL),
('Luxor', 128, '2019-01-30', 313, NULL),
('Luxor', 128, '2019-01-31', 320, NULL),
('Luxor', 128, '2019-02-01', 156, NULL),
('Luxor', 128, '2019-02-02', 118, NULL),
('Luxor', 128, '2019-02-03', 354, NULL),
('Luxor', 128, '2019-02-04', 289, NULL),
('Luxor', 128, '2019-02-05', 166, NULL),
('Luxor', 128, '2019-02-06', 128, NULL),
('Luxor', 128, '2019-02-07', 285, NULL),
('Luxor', 128, '2019-02-08', 309, NULL),
('Luxor', 128, '2019-02-09', 161, NULL),
('Luxor', 128, '2019-02-10', 225, NULL),
('Luxor', 128, '2019-02-11', 108, NULL),
('Luxor', 128, '2019-02-12', 304, NULL),
('Luxor', 128, '2019-02-13', 184, NULL),
('Luxor', 128, '2019-02-14', 291, NULL),
('Luxor', 128, '2019-02-15', 380, NULL),
('Luxor', 128, '2019-02-16', 202, NULL),
('Luxor', 128, '2019-02-17', 386, NULL),
('Luxor', 128, '2019-02-18', 242, NULL),
('Luxor', 128, '2019-02-19', 152, NULL),
('Luxor', 128, '2019-02-20', 106, NULL),
('Luxor', 128, '2019-02-21', 126, NULL),
('Luxor', 128, '2019-02-22', 155, NULL),
('Luxor', 128, '2019-02-23', 234, NULL),
('Luxor', 128, '2019-02-24', 177, NULL),
('Luxor', 128, '2019-02-25', 309, NULL),
('Luxor', 128, '2019-02-26', 181, NULL),
('Luxor', 128, '2019-02-27', 262, NULL),
('Luxor', 128, '2019-02-28', 345, NULL),
('Luxor', 128, '2019-03-01', 311, NULL),
('Luxor', 128, '2019-03-02', 369, NULL),
('Luxor', 128, '2019-03-03', 122, NULL),
('Luxor', 128, '2019-03-04', 398, NULL),
('Luxor', 128, '2019-03-05', 313, NULL),
('Luxor', 128, '2019-03-06', 284, NULL),
('Luxor', 128, '2019-03-07', 234, NULL),
('Luxor', 128, '2019-03-08', 263, NULL),
('Luxor', 128, '2019-03-09', 228, NULL),
('Luxor', 128, '2019-03-10', 280, NULL),
('Luxor', 128, '2019-03-11', 183, NULL),
('Luxor', 128, '2019-03-12', 339, NULL),
('Luxor', 128, '2019-03-13', 394, NULL),
('Luxor', 128, '2019-03-14', 343, NULL),
('Luxor', 128, '2019-03-15', 212, NULL),
('Luxor', 128, '2019-03-16', 194, NULL),
('Luxor', 128, '2019-03-17', 363, NULL),
('Luxor', 128, '2019-03-18', 324, NULL),
('Luxor', 128, '2019-03-19', 384, NULL),
('Luxor', 128, '2019-03-20', 322, NULL),
('Luxor', 128, '2019-03-21', 230, NULL),
('Luxor', 128, '2019-03-22', 361, NULL),
('Luxor', 128, '2019-03-23', 102, NULL),
('Luxor', 128, '2019-03-24', 356, NULL),
('Luxor', 128, '2019-03-25', 219, NULL),
('Luxor', 128, '2019-03-26', 243, NULL),
('Luxor', 128, '2019-03-27', 170, NULL),
('Luxor', 128, '2019-03-28', 266, NULL),
('Luxor', 128, '2019-03-29', 125, NULL),
('Luxor', 128, '2019-03-30', 252, NULL),
('Luxor', 128, '2019-03-31', 192, NULL),
('Luxor', 128, '2019-04-01', 390, NULL),
('Luxor', 128, '2019-04-02', 183, NULL),
('Luxor', 128, '2019-04-03', 336, NULL),
('Luxor', 128, '2019-04-04', 136, NULL),
('Luxor', 128, '2019-04-05', 237, NULL),
('Luxor', 128, '2019-04-06', 379, NULL),
('Luxor', 128, '2019-04-07', 302, NULL),
('Luxor', 128, '2019-04-08', 179, NULL),
('Luxor', 128, '2019-04-09', 179, NULL),
('Luxor', 128, '2019-04-10', 151, NULL),
('Luxor', 128, '2019-04-11', 134, NULL),
('Luxor', 128, '2019-04-12', 135, NULL),
('Luxor', 128, '2019-04-13', 288, NULL),
('Luxor', 128, '2019-04-14', 182, NULL),
('Luxor', 128, '2019-04-15', 146, NULL),
('Luxor', 128, '2019-04-16', 133, NULL),
('Luxor', 128, '2019-04-17', 211, NULL),
('Luxor', 128, '2019-04-18', 160, NULL),
('Luxor', 128, '2019-04-19', 150, NULL),
('Luxor', 128, '2019-04-20', 254, NULL),
('Luxor', 128, '2019-04-21', 211, NULL),
('Luxor', 128, '2019-04-22', 189, NULL),
('Luxor', 128, '2019-04-23', 184, NULL),
('Luxor', 128, '2019-04-24', 309, NULL),
('Luxor', 128, '2019-04-25', 319, NULL),
('Luxor', 128, '2019-04-26', 169, NULL),
('Luxor', 128, '2019-04-27', 237, NULL),
('Luxor', 128, '2019-04-28', 139, NULL),
('Luxor', 128, '2019-04-29', 303, NULL),
('Luxor', 128, '2019-04-30', 167, NULL),
('Luxor', 128, '2019-05-01', 276, NULL),
('Luxor', 128, '2019-05-02', 151, NULL),
('Luxor', 128, '2019-05-03', 322, NULL),
('Luxor', 128, '2019-05-04', 310, NULL),
('Luxor', 128, '2019-05-05', 334, NULL),
('Luxor', 128, '2019-05-06', 163, NULL),
('Luxor', 128, '2019-05-07', 197, NULL),
('Luxor', 128, '2019-05-08', 200, NULL),
('Luxor', 128, '2019-05-09', 225, NULL),
('Luxor', 128, '2019-05-10', 249, NULL),
('Luxor', 128, '2019-05-11', 172, NULL),
('Luxor', 128, '2019-05-12', 391, NULL),
('Luxor', 128, '2019-05-13', 266, NULL),
('Luxor', 128, '2019-05-14', 156, NULL),
('Luxor', 128, '2019-05-15', 112, NULL),
('Luxor', 128, '2019-05-16', 249, NULL),
('Luxor', 128, '2019-05-17', 100, NULL),
('Luxor', 128, '2019-05-18', 284, NULL),
('Luxor', 128, '2019-05-19', 325, NULL),
('Luxor', 128, '2019-05-20', 270, NULL),
('Luxor', 128, '2019-05-21', 180, NULL),
('Luxor', 128, '2019-05-22', 367, NULL),
('Luxor', 128, '2019-05-23', 241, NULL),
('Luxor', 128, '2019-05-24', 383, NULL),
('Luxor', 128, '2019-05-25', 341, NULL),
('Luxor', 128, '2019-05-26', 119, NULL),
('Luxor', 128, '2019-05-27', 179, NULL),
('Luxor', 128, '2019-05-28', 258, NULL),
('Luxor', 128, '2019-05-29', 244, NULL),
('Luxor', 128, '2019-05-30', 205, NULL),
('Luxor', 128, '2019-05-31', 268, NULL),
('Luxor', 128, '2019-06-01', 369, NULL),
('Luxor', 128, '2019-06-02', 386, NULL),
('Luxor', 128, '2019-06-03', 139, NULL),
('Luxor', 128, '2019-06-04', 189, NULL),
('Luxor', 128, '2019-06-05', 148, NULL),
('Luxor', 128, '2019-06-06', 372, NULL),
('Luxor', 128, '2019-06-07', 343, NULL),
('Luxor', 128, '2019-06-08', 397, NULL),
('Luxor', 128, '2019-06-09', 310, NULL),
('Luxor', 128, '2019-06-10', 366, NULL),
('Luxor', 128, '2019-06-11', 256, NULL),
('Luxor', 128, '2019-06-12', 144, NULL),
('Luxor', 128, '2019-06-13', 195, NULL),
('Luxor', 128, '2019-06-14', 319, NULL),
('Luxor', 128, '2019-06-15', 146, NULL),
('Luxor', 128, '2019-06-16', 367, NULL),
('Luxor', 128, '2019-06-17', 198, NULL),
('Luxor', 128, '2019-06-18', 104, NULL),
('Luxor', 128, '2019-06-19', 360, NULL),
('Luxor', 128, '2019-06-20', 236, NULL),
('Luxor', 128, '2019-06-21', 352, NULL),
('Luxor', 128, '2019-06-22', 257, NULL),
('Luxor', 128, '2019-06-23', 262, NULL),
('Luxor', 128, '2019-06-24', 209, NULL),
('Luxor', 128, '2019-06-25', 263, NULL),
('Luxor', 128, '2019-06-26', 308, NULL),
('Luxor', 128, '2019-06-27', 286, NULL),
('Luxor', 128, '2019-06-28', 330, NULL),
('Luxor', 128, '2019-06-29', 132, NULL),
('Luxor', 128, '2019-06-30', 252, NULL),
('Luxor', 128, '2019-07-01', 141, NULL),
('Luxor', 128, '2019-07-02', 396, NULL),
('Luxor', 128, '2019-07-03', 256, NULL),
('Luxor', 128, '2019-07-04', 346, NULL),
('Luxor', 128, '2019-07-05', 299, NULL),
('Luxor', 128, '2019-07-06', 196, NULL),
('Luxor', 128, '2019-07-07', 380, NULL),
('Luxor', 128, '2019-07-08', 182, NULL),
('Luxor', 128, '2019-07-09', 199, NULL),
('Luxor', 128, '2019-07-10', 323, NULL),
('Luxor', 128, '2019-07-11', 120, NULL),
('Luxor', 128, '2019-07-12', 353, NULL),
('Luxor', 128, '2019-07-13', 248, NULL),
('Luxor', 128, '2019-07-14', 211, NULL),
('Luxor', 128, '2019-07-15', 276, NULL),
('Luxor', 128, '2019-07-16', 114, NULL),
('Luxor', 128, '2019-07-17', 371, NULL),
('Luxor', 128, '2019-07-18', 346, NULL),
('Luxor', 128, '2019-07-19', 140, NULL),
('Luxor', 128, '2019-07-20', 215, NULL),
('Luxor', 128, '2019-07-21', 188, NULL),
('Luxor', 128, '2019-07-22', 120, NULL),
('Luxor', 128, '2019-07-23', 373, NULL),
('Luxor', 128, '2019-07-24', 312, NULL),
('Luxor', 128, '2019-07-25', 271, NULL),
('Luxor', 128, '2019-07-26', 377, NULL),
('Luxor', 128, '2019-07-27', 348, NULL),
('Luxor', 128, '2019-07-28', 300, NULL),
('Luxor', 128, '2019-07-29', 324, NULL),
('Luxor', 128, '2019-07-30', 397, NULL),
('Luxor', 128, '2019-07-31', 184, NULL),
('Luxor', 128, '2019-08-01', 309, NULL),
('Luxor', 128, '2019-08-02', 211, NULL),
('Luxor', 128, '2019-08-03', 249, NULL),
('Luxor', 128, '2019-08-04', 135, NULL),
('Luxor', 128, '2019-08-05', 288, NULL),
('Luxor', 128, '2019-08-06', 162, NULL),
('Luxor', 128, '2019-08-07', 216, NULL),
('Luxor', 128, '2019-08-08', 136, NULL),
('Luxor', 128, '2019-08-09', 253, NULL),
('Luxor', 128, '2019-08-10', 327, NULL),
('Luxor', 128, '2019-08-11', 303, NULL),
('Luxor', 128, '2019-08-12', 369, NULL),
('Luxor', 128, '2019-08-13', 224, NULL),
('Luxor', 128, '2019-08-14', 123, NULL),
('Luxor', 128, '2019-08-15', 284, NULL),
('Luxor', 128, '2019-08-16', 142, NULL),
('Luxor', 128, '2019-08-17', 129, NULL),
('Luxor', 128, '2019-08-18', 135, NULL),
('Luxor', 128, '2019-08-19', 377, NULL),
('Luxor', 128, '2019-08-20', 360, NULL),
('Luxor', 128, '2019-08-21', 370, NULL),
('Luxor', 128, '2019-08-22', 201, NULL),
('Luxor', 128, '2019-08-23', 143, NULL),
('Luxor', 128, '2019-08-24', 183, NULL),
('Luxor', 128, '2019-08-25', 160, NULL),
('Luxor', 128, '2019-08-26', 157, NULL),
('Luxor', 128, '2019-08-27', 219, NULL),
('Luxor', 128, '2019-08-28', 121, NULL),
('Luxor', 128, '2019-08-29', 184, NULL),
('Luxor', 128, '2019-08-30', 169, NULL),
('Luxor', 128, '2019-08-31', 345, NULL),
('Luxor', 128, '2019-09-01', 143, NULL),
('Luxor', 128, '2019-09-02', 181, NULL),
('Luxor', 128, '2019-09-03', 240, NULL),
('Luxor', 128, '2019-09-04', 200, NULL),
('Luxor', 128, '2019-09-05', 291, NULL),
('Luxor', 128, '2019-09-06', 139, NULL),
('Luxor', 128, '2019-09-07', 397, NULL),
('Luxor', 128, '2019-09-08', 251, NULL),
('Luxor', 128, '2019-09-09', 333, NULL),
('Luxor', 128, '2019-09-10', 393, NULL),
('Luxor', 128, '2019-09-11', 228, NULL),
('Luxor', 128, '2019-09-12', 214, NULL),
('Luxor', 128, '2019-09-13', 316, NULL),
('Luxor', 128, '2019-09-14', 320, NULL),
('Luxor', 128, '2019-09-15', 369, NULL),
('Luxor', 128, '2019-09-16', 332, NULL),
('Luxor', 128, '2019-09-17', 278, NULL),
('Luxor', 128, '2019-09-18', 327, NULL),
('Luxor', 128, '2019-09-19', 271, NULL),
('Luxor', 128, '2019-09-20', 313, NULL),
('Luxor', 128, '2019-09-21', 135, NULL),
('Luxor', 128, '2019-09-22', 307, NULL),
('Luxor', 128, '2019-09-23', 208, NULL),
('Luxor', 128, '2019-09-24', 329, NULL),
('Luxor', 128, '2019-09-25', 333, NULL),
('Luxor', 128, '2019-09-26', 285, NULL),
('Luxor', 128, '2019-09-27', 364, NULL),
('Luxor', 128, '2019-09-28', 131, NULL),
('Luxor', 128, '2019-09-29', 308, NULL),
('Luxor', 128, '2019-09-30', 368, NULL),
('Luxor', 128, '2019-10-01', 145, NULL),
('Luxor', 128, '2019-10-02', 220, NULL),
('Luxor', 128, '2019-10-03', 255, NULL),
('Luxor', 128, '2019-10-04', 282, NULL),
('Luxor', 128, '2019-10-05', 187, NULL),
('Luxor', 128, '2019-10-06', 199, NULL),
('Luxor', 128, '2019-10-07', 181, NULL),
('Luxor', 128, '2019-10-08', 275, NULL),
('Luxor', 128, '2019-10-09', 218, NULL),
('Luxor', 128, '2019-10-10', 235, NULL),
('Luxor', 128, '2019-10-11', 134, NULL),
('Luxor', 128, '2019-10-12', 140, NULL),
('Luxor', 128, '2019-10-13', 267, NULL),
('Luxor', 128, '2019-10-14', 159, NULL),
('Luxor', 128, '2019-10-15', 244, NULL),
('Luxor', 128, '2019-10-16', 138, NULL),
('Luxor', 128, '2019-10-17', 328, NULL),
('Luxor', 128, '2019-10-18', 253, NULL),
('Luxor', 128, '2019-10-19', 353, NULL),
('Luxor', 128, '2019-10-20', 262, NULL),
('Luxor', 128, '2019-10-21', 160, NULL),
('Luxor', 128, '2019-10-22', 206, NULL),
('Luxor', 128, '2019-10-23', 112, NULL),
('Luxor', 128, '2019-10-24', 280, NULL),
('Luxor', 128, '2019-10-25', 152, NULL),
('Luxor', 128, '2019-10-26', 311, NULL),
('Luxor', 128, '2019-10-27', 121, NULL),
('Luxor', 128, '2019-10-28', 300, NULL),
('Luxor', 128, '2019-10-29', 309, NULL),
('Luxor', 128, '2019-10-30', 266, NULL),
('Luxor', 128, '2019-10-31', 179, NULL),
('Luxor', 128, '2019-11-01', 309, NULL),
('Luxor', 128, '2019-11-02', 288, NULL),
('Luxor', 128, '2019-11-03', 379, NULL),
('Luxor', 128, '2019-11-04', 103, NULL),
('Luxor', 128, '2019-11-05', 188, NULL),
('Luxor', 128, '2019-11-06', 319, NULL),
('Luxor', 128, '2019-11-07', 138, NULL),
('Luxor', 128, '2019-11-08', 365, NULL),
('Luxor', 128, '2019-11-09', 190, NULL),
('Luxor', 128, '2019-11-10', 265, NULL),
('Luxor', 128, '2019-11-11', 273, NULL),
('Luxor', 128, '2019-11-12', 255, NULL),
('Luxor', 128, '2019-11-13', 365, NULL),
('Luxor', 128, '2019-11-14', 291, NULL),
('Luxor', 128, '2019-11-15', 174, NULL),
('Luxor', 128, '2019-11-16', 266, NULL),
('Luxor', 128, '2019-11-17', 230, NULL),
('Luxor', 128, '2019-11-18', 115, NULL),
('Luxor', 128, '2019-11-19', 384, NULL),
('Luxor', 128, '2019-11-20', 385, NULL),
('Luxor', 128, '2019-11-21', 277, NULL),
('Luxor', 128, '2019-11-22', 332, NULL),
('Luxor', 128, '2019-11-23', 104, NULL),
('Luxor', 128, '2019-11-24', 134, NULL),
('Luxor', 128, '2019-11-25', 375, NULL),
('Luxor', 128, '2019-11-26', 169, NULL),
('Luxor', 128, '2019-11-27', 123, NULL),
('Luxor', 128, '2019-11-28', 336, NULL),
('Luxor', 128, '2019-11-29', 145, NULL),
('Luxor', 128, '2019-11-30', 159, NULL),
('Luxor', 128, '2019-12-01', 239, NULL),
('Luxor', 128, '2019-12-02', 172, NULL),
('Luxor', 128, '2019-12-03', 358, NULL),
('Luxor', 128, '2019-12-04', 198, NULL),
('Luxor', 128, '2019-12-05', 283, NULL),
('Luxor', 128, '2019-12-06', 205, NULL),
('Luxor', 128, '2019-12-07', 287, NULL),
('Luxor', 128, '2019-12-08', 295, NULL),
('Luxor', 128, '2019-12-09', 180, NULL),
('Luxor', 128, '2019-12-10', 343, NULL),
('Luxor', 128, '2019-12-11', 259, NULL),
('Luxor', 128, '2019-12-12', 370, NULL),
('Luxor', 128, '2019-12-13', 155, NULL),
('Luxor', 128, '2019-12-14', 352, NULL),
('Luxor', 128, '2019-12-15', 216, NULL),
('Luxor', 128, '2019-12-16', 217, NULL),
('Luxor', 128, '2019-12-17', 331, NULL),
('Luxor', 128, '2019-12-18', 383, NULL),
('Luxor', 128, '2019-12-19', 102, NULL),
('Luxor', 128, '2019-12-20', 131, NULL),
('Luxor', 128, '2019-12-21', 337, NULL),
('Luxor', 128, '2019-12-22', 301, NULL),
('Luxor', 128, '2019-12-23', 324, NULL),
('Luxor', 128, '2019-12-24', 366, NULL),
('Luxor', 128, '2019-12-25', 145, NULL),
('Luxor', 128, '2019-12-26', 141, NULL),
('Luxor', 128, '2019-12-27', 268, NULL),
('Luxor', 128, '2019-12-28', 323, NULL),
('Luxor', 128, '2019-12-29', 193, NULL),
('Luxor', 128, '2019-12-30', 226, NULL),
('Luxor', 128, '2019-12-31', 346, NULL),
('Luxor', 128, '2020-01-01', 301, NULL),
('Luxor', 128, '2020-01-02', 154, NULL),
('Luxor', 128, '2020-01-03', 355, NULL),
('Luxor', 128, '2020-01-04', 226, NULL),
('Luxor', 128, '2020-01-05', 141, NULL),
('Luxor', 128, '2020-01-06', 132, NULL),
('Luxor', 128, '2020-01-07', 188, NULL),
('Luxor', 128, '2020-01-08', 110, NULL),
('Luxor', 128, '2020-01-09', 241, NULL),
('Luxor', 128, '2020-01-10', 376, NULL),
('Luxor', 128, '2020-01-11', 368, NULL),
('Luxor', 128, '2020-01-12', 195, NULL),
('Luxor', 128, '2020-01-13', 105, NULL),
('Luxor', 128, '2020-01-14', 125, NULL),
('Luxor', 128, '2020-01-15', 267, NULL),
('Luxor', 128, '2020-01-16', 272, NULL),
('Luxor', 128, '2020-01-17', 160, NULL),
('Luxor', 128, '2020-01-18', 128, NULL),
('Luxor', 128, '2020-01-19', 367, NULL),
('Luxor', 128, '2020-01-20', 178, NULL),
('Luxor', 128, '2020-01-21', 202, NULL),
('Luxor', 128, '2020-01-22', 240, NULL),
('Luxor', 128, '2020-01-23', 285, NULL),
('Luxor', 128, '2020-01-24', 337, NULL),
('Luxor', 128, '2020-01-25', 188, NULL),
('Luxor', 128, '2020-01-26', 149, NULL),
('Luxor', 128, '2020-01-27', 338, NULL),
('Luxor', 128, '2020-01-28', 108, NULL),
('Luxor', 128, '2020-01-29', 285, NULL),
('Luxor', 128, '2020-01-30', 341, NULL),
('Luxor', 128, '2020-01-31', 153, NULL),
('Luxor', 128, '2020-02-01', 268, NULL),
('Luxor', 128, '2020-02-02', 233, NULL),
('Luxor', 128, '2020-02-03', 330, NULL),
('Luxor', 128, '2020-02-04', 368, NULL),
('Luxor', 141, '2019-01-01', 145, NULL),
('Luxor', 141, '2019-01-02', 204, NULL),
('Luxor', 141, '2019-01-03', 156, NULL),
('Luxor', 141, '2019-01-04', 110, NULL),
('Luxor', 141, '2019-01-05', 283, NULL),
('Luxor', 141, '2019-01-06', 132, NULL),
('Luxor', 141, '2019-01-07', 374, NULL),
('Luxor', 141, '2019-01-08', 263, NULL),
('Luxor', 141, '2019-01-09', 338, NULL),
('Luxor', 141, '2019-01-10', 392, NULL),
('Luxor', 141, '2019-01-11', 236, NULL),
('Luxor', 141, '2019-01-12', 253, NULL),
('Luxor', 141, '2019-01-13', 205, NULL),
('Luxor', 141, '2019-01-14', 164, NULL),
('Luxor', 141, '2019-01-15', 263, NULL),
('Luxor', 141, '2019-01-16', 103, NULL),
('Luxor', 141, '2019-01-17', 320, NULL),
('Luxor', 141, '2019-01-18', 248, NULL),
('Luxor', 141, '2019-01-19', 101, NULL),
('Luxor', 141, '2019-01-20', 101, NULL),
('Luxor', 141, '2019-01-21', 148, NULL),
('Luxor', 141, '2019-01-22', 383, NULL),
('Luxor', 141, '2019-01-23', 267, NULL),
('Luxor', 141, '2019-01-24', 329, NULL),
('Luxor', 141, '2019-01-25', 195, NULL),
('Luxor', 141, '2019-01-26', 310, NULL),
('Luxor', 141, '2019-01-27', 285, NULL),
('Luxor', 141, '2019-01-28', 102, NULL),
('Luxor', 141, '2019-01-29', 338, NULL),
('Luxor', 141, '2019-01-30', 173, NULL),
('Luxor', 141, '2019-01-31', 386, NULL),
('Luxor', 141, '2019-02-01', 204, NULL),
('Luxor', 141, '2019-02-02', 364, NULL),
('Luxor', 141, '2019-02-03', 120, NULL),
('Luxor', 141, '2019-02-04', 171, NULL),
('Luxor', 141, '2019-02-05', 160, NULL),
('Luxor', 141, '2019-02-06', 210, NULL),
('Luxor', 141, '2019-02-07', 269, NULL),
('Luxor', 141, '2019-02-08', 296, NULL),
('Luxor', 141, '2019-02-09', 171, NULL),
('Luxor', 141, '2019-02-10', 135, NULL),
('Luxor', 141, '2019-02-11', 142, NULL),
('Luxor', 141, '2019-02-12', 191, NULL),
('Luxor', 141, '2019-02-13', 185, NULL),
('Luxor', 141, '2019-02-14', 283, NULL),
('Luxor', 141, '2019-02-15', 395, NULL),
('Luxor', 141, '2019-02-16', 111, NULL),
('Luxor', 141, '2019-02-17', 378, NULL),
('Luxor', 141, '2019-02-18', 122, NULL),
('Luxor', 141, '2019-02-19', 358, NULL),
('Luxor', 141, '2019-02-20', 289, NULL),
('Luxor', 141, '2019-02-21', 317, NULL),
('Luxor', 141, '2019-02-22', 347, NULL),
('Luxor', 141, '2019-02-23', 204, NULL),
('Luxor', 141, '2019-02-24', 249, NULL),
('Luxor', 141, '2019-02-25', 281, NULL),
('Luxor', 141, '2019-02-26', 203, NULL),
('Luxor', 141, '2019-02-27', 115, NULL),
('Luxor', 141, '2019-02-28', 339, NULL),
('Luxor', 141, '2019-03-01', 131, NULL),
('Luxor', 141, '2019-03-02', 225, NULL),
('Luxor', 141, '2019-03-03', 360, NULL),
('Luxor', 141, '2019-03-04', 260, NULL),
('Luxor', 141, '2019-03-05', 168, NULL),
('Luxor', 141, '2019-03-06', 105, NULL),
('Luxor', 141, '2019-03-07', 105, NULL),
('Luxor', 141, '2019-03-08', 236, NULL),
('Luxor', 141, '2019-03-09', 376, NULL),
('Luxor', 141, '2019-03-10', 221, NULL),
('Luxor', 141, '2019-03-11', 391, NULL),
('Luxor', 141, '2019-03-12', 327, NULL),
('Luxor', 141, '2019-03-13', 387, NULL),
('Luxor', 141, '2019-03-14', 364, NULL),
('Luxor', 141, '2019-03-15', 162, NULL),
('Luxor', 141, '2019-03-16', 215, NULL),
('Luxor', 141, '2019-03-17', 214, NULL),
('Luxor', 141, '2019-03-18', 210, NULL),
('Luxor', 141, '2019-03-19', 374, NULL),
('Luxor', 141, '2019-03-20', 246, NULL),
('Luxor', 141, '2019-03-21', 379, NULL),
('Luxor', 141, '2019-03-22', 316, NULL),
('Luxor', 141, '2019-03-23', 140, NULL),
('Luxor', 141, '2019-03-24', 110, NULL),
('Luxor', 141, '2019-03-25', 185, NULL),
('Luxor', 141, '2019-03-26', 340, NULL),
('Luxor', 141, '2019-03-27', 355, NULL),
('Luxor', 141, '2019-03-28', 209, NULL),
('Luxor', 141, '2019-03-29', 319, NULL),
('Luxor', 141, '2019-03-30', 299, NULL),
('Luxor', 141, '2019-03-31', 108, NULL),
('Luxor', 141, '2019-04-01', 181, NULL),
('Luxor', 141, '2019-04-02', 319, NULL),
('Luxor', 141, '2019-04-03', 260, NULL),
('Luxor', 141, '2019-04-04', 210, NULL),
('Luxor', 141, '2019-04-05', 178, NULL),
('Luxor', 141, '2019-04-06', 262, NULL),
('Luxor', 141, '2019-04-07', 109, NULL),
('Luxor', 141, '2019-04-08', 365, NULL),
('Luxor', 141, '2019-04-09', 257, NULL),
('Luxor', 141, '2019-04-10', 139, NULL),
('Luxor', 141, '2019-04-11', 226, NULL),
('Luxor', 141, '2019-04-12', 281, NULL),
('Luxor', 141, '2019-04-13', 217, NULL),
('Luxor', 141, '2019-04-14', 148, NULL),
('Luxor', 141, '2019-04-15', 360, NULL),
('Luxor', 141, '2019-04-16', 221, NULL),
('Luxor', 141, '2019-04-17', 297, NULL),
('Luxor', 141, '2019-04-18', 232, NULL),
('Luxor', 141, '2019-04-19', 343, NULL),
('Luxor', 141, '2019-04-20', 128, NULL),
('Luxor', 141, '2019-04-21', 153, NULL),
('Luxor', 141, '2019-04-22', 232, NULL),
('Luxor', 141, '2019-04-23', 392, NULL),
('Luxor', 141, '2019-04-24', 365, NULL),
('Luxor', 141, '2019-04-25', 358, NULL),
('Luxor', 141, '2019-04-26', 159, NULL),
('Luxor', 141, '2019-04-27', 238, NULL),
('Luxor', 141, '2019-04-28', 336, NULL),
('Luxor', 141, '2019-04-29', 332, NULL),
('Luxor', 141, '2019-04-30', 364, NULL),
('Luxor', 141, '2019-05-01', 341, NULL),
('Luxor', 141, '2019-05-02', 274, NULL),
('Luxor', 141, '2019-05-03', 203, NULL),
('Luxor', 141, '2019-05-04', 282, NULL),
('Luxor', 141, '2019-05-05', 177, NULL),
('Luxor', 141, '2019-05-06', 117, NULL),
('Luxor', 141, '2019-05-07', 128, NULL),
('Luxor', 141, '2019-05-08', 316, NULL),
('Luxor', 141, '2019-05-09', 114, NULL),
('Luxor', 141, '2019-05-10', 299, NULL),
('Luxor', 141, '2019-05-11', 261, NULL),
('Luxor', 141, '2019-05-12', 238, NULL),
('Luxor', 141, '2019-05-13', 291, NULL),
('Luxor', 141, '2019-05-14', 176, NULL),
('Luxor', 141, '2019-05-15', 348, NULL),
('Luxor', 141, '2019-05-16', 220, NULL),
('Luxor', 141, '2019-05-17', 292, NULL),
('Luxor', 141, '2019-05-18', 397, NULL),
('Luxor', 141, '2019-05-19', 248, NULL),
('Luxor', 141, '2019-05-20', 316, NULL),
('Luxor', 141, '2019-05-21', 152, NULL),
('Luxor', 141, '2019-05-22', 250, NULL),
('Luxor', 141, '2019-05-23', 213, NULL),
('Luxor', 141, '2019-05-24', 177, NULL),
('Luxor', 141, '2019-05-25', 117, NULL),
('Luxor', 141, '2019-05-26', 217, NULL),
('Luxor', 141, '2019-05-27', 173, NULL),
('Luxor', 141, '2019-05-28', 372, NULL),
('Luxor', 141, '2019-05-29', 229, NULL),
('Luxor', 141, '2019-05-30', 238, NULL),
('Luxor', 141, '2019-05-31', 368, NULL),
('Luxor', 141, '2019-06-01', 121, NULL),
('Luxor', 141, '2019-06-02', 229, NULL),
('Luxor', 141, '2019-06-03', 322, NULL),
('Luxor', 141, '2019-06-04', 113, NULL),
('Luxor', 141, '2019-06-05', 258, NULL),
('Luxor', 141, '2019-06-06', 223, NULL),
('Luxor', 141, '2019-06-07', 161, NULL),
('Luxor', 141, '2019-06-08', 112, NULL),
('Luxor', 141, '2019-06-09', 250, NULL),
('Luxor', 141, '2019-06-10', 308, NULL),
('Luxor', 141, '2019-06-11', 199, NULL),
('Luxor', 141, '2019-06-12', 188, NULL),
('Luxor', 141, '2019-06-13', 131, NULL),
('Luxor', 141, '2019-06-14', 236, NULL),
('Luxor', 141, '2019-06-15', 367, NULL),
('Luxor', 141, '2019-06-16', 233, NULL),
('Luxor', 141, '2019-06-17', 323, NULL),
('Luxor', 141, '2019-06-18', 332, NULL),
('Luxor', 141, '2019-06-19', 170, NULL),
('Luxor', 141, '2019-06-20', 351, NULL),
('Luxor', 141, '2019-06-21', 361, NULL),
('Luxor', 141, '2019-06-22', 128, NULL),
('Luxor', 141, '2019-06-23', 159, NULL),
('Luxor', 141, '2019-06-24', 210, NULL),
('Luxor', 141, '2019-06-25', 227, NULL),
('Luxor', 141, '2019-06-26', 387, NULL),
('Luxor', 141, '2019-06-27', 232, NULL),
('Luxor', 141, '2019-06-28', 310, NULL),
('Luxor', 141, '2019-06-29', 158, NULL),
('Luxor', 141, '2019-06-30', 141, NULL),
('Luxor', 141, '2019-07-01', 300, NULL),
('Luxor', 141, '2019-07-02', 266, NULL),
('Luxor', 141, '2019-07-03', 257, NULL),
('Luxor', 141, '2019-07-04', 112, NULL),
('Luxor', 141, '2019-07-05', 174, NULL),
('Luxor', 141, '2019-07-06', 301, NULL),
('Luxor', 141, '2019-07-07', 296, NULL),
('Luxor', 141, '2019-07-08', 264, NULL),
('Luxor', 141, '2019-07-09', 396, NULL),
('Luxor', 141, '2019-07-10', 395, NULL),
('Luxor', 141, '2019-07-11', 296, NULL),
('Luxor', 141, '2019-07-12', 212, NULL),
('Luxor', 141, '2019-07-13', 362, NULL),
('Luxor', 141, '2019-07-14', 165, NULL),
('Luxor', 141, '2019-07-15', 209, NULL),
('Luxor', 141, '2019-07-16', 372, NULL),
('Luxor', 141, '2019-07-17', 388, NULL),
('Luxor', 141, '2019-07-18', 159, NULL),
('Luxor', 141, '2019-07-19', 341, NULL),
('Luxor', 141, '2019-07-20', 179, NULL),
('Luxor', 141, '2019-07-21', 270, NULL),
('Luxor', 141, '2019-07-22', 317, NULL),
('Luxor', 141, '2019-07-23', 398, NULL),
('Luxor', 141, '2019-07-24', 394, NULL),
('Luxor', 141, '2019-07-25', 116, NULL),
('Luxor', 141, '2019-07-26', 186, NULL),
('Luxor', 141, '2019-07-27', 208, NULL),
('Luxor', 141, '2019-07-28', 109, NULL),
('Luxor', 141, '2019-07-29', 366, NULL),
('Luxor', 141, '2019-07-30', 146, NULL),
('Luxor', 141, '2019-07-31', 183, NULL),
('Luxor', 141, '2019-08-01', 389, NULL),
('Luxor', 141, '2019-08-02', 367, NULL),
('Luxor', 141, '2019-08-03', 152, NULL),
('Luxor', 141, '2019-08-04', 249, NULL),
('Luxor', 141, '2019-08-05', 114, NULL),
('Luxor', 141, '2019-08-06', 227, NULL),
('Luxor', 141, '2019-08-07', 142, NULL),
('Luxor', 141, '2019-08-08', 188, NULL),
('Luxor', 141, '2019-08-09', 128, NULL),
('Luxor', 141, '2019-08-10', 180, NULL),
('Luxor', 141, '2019-08-11', 290, NULL),
('Luxor', 141, '2019-08-12', 278, NULL),
('Luxor', 141, '2019-08-13', 342, NULL),
('Luxor', 141, '2019-08-14', 133, NULL),
('Luxor', 141, '2019-08-15', 155, NULL),
('Luxor', 141, '2019-08-16', 393, NULL),
('Luxor', 141, '2019-08-17', 146, NULL),
('Luxor', 141, '2019-08-18', 266, NULL),
('Luxor', 141, '2019-08-19', 337, NULL),
('Luxor', 141, '2019-08-20', 257, NULL),
('Luxor', 141, '2019-08-21', 379, NULL),
('Luxor', 141, '2019-08-22', 275, NULL),
('Luxor', 141, '2019-08-23', 322, NULL),
('Luxor', 141, '2019-08-24', 216, NULL),
('Luxor', 141, '2019-08-25', 358, NULL),
('Luxor', 141, '2019-08-26', 217, NULL),
('Luxor', 141, '2019-08-27', 124, NULL),
('Luxor', 141, '2019-08-28', 233, NULL),
('Luxor', 141, '2019-08-29', 170, NULL),
('Luxor', 141, '2019-08-30', 185, NULL),
('Luxor', 141, '2019-08-31', 235, NULL),
('Luxor', 141, '2019-09-01', 396, NULL),
('Luxor', 141, '2019-09-02', 341, NULL),
('Luxor', 141, '2019-09-03', 221, NULL),
('Luxor', 141, '2019-09-04', 185, NULL),
('Luxor', 141, '2019-09-05', 161, NULL),
('Luxor', 141, '2019-09-06', 168, NULL),
('Luxor', 141, '2019-09-07', 285, NULL),
('Luxor', 141, '2019-09-08', 144, NULL),
('Luxor', 141, '2019-09-09', 135, NULL),
('Luxor', 141, '2019-09-10', 398, NULL),
('Luxor', 141, '2019-09-11', 380, NULL),
('Luxor', 141, '2019-09-12', 215, NULL),
('Luxor', 141, '2019-09-13', 111, NULL),
('Luxor', 141, '2019-09-14', 344, NULL),
('Luxor', 141, '2019-09-15', 372, NULL),
('Luxor', 141, '2019-09-16', 391, NULL),
('Luxor', 141, '2019-09-17', 144, NULL),
('Luxor', 141, '2019-09-18', 374, NULL),
('Luxor', 141, '2019-09-19', 175, NULL),
('Luxor', 141, '2019-09-20', 148, NULL),
('Luxor', 141, '2019-09-21', 166, NULL),
('Luxor', 141, '2019-09-22', 385, NULL),
('Luxor', 141, '2019-09-23', 392, NULL),
('Luxor', 141, '2019-09-24', 286, NULL),
('Luxor', 141, '2019-09-25', 173, NULL),
('Luxor', 141, '2019-09-26', 219, NULL),
('Luxor', 141, '2019-09-27', 221, NULL),
('Luxor', 141, '2019-09-28', 219, NULL),
('Luxor', 141, '2019-09-29', 160, NULL),
('Luxor', 141, '2019-09-30', 169, NULL),
('Luxor', 141, '2019-10-01', 290, NULL),
('Luxor', 141, '2019-10-02', 263, NULL),
('Luxor', 141, '2019-10-03', 312, NULL),
('Luxor', 141, '2019-10-04', 274, NULL),
('Luxor', 141, '2019-10-05', 319, NULL),
('Luxor', 141, '2019-10-06', 370, NULL),
('Luxor', 141, '2019-10-07', 123, NULL),
('Luxor', 141, '2019-10-08', 366, NULL),
('Luxor', 141, '2019-10-09', 151, NULL),
('Luxor', 141, '2019-10-10', 229, NULL),
('Luxor', 141, '2019-10-11', 181, NULL),
('Luxor', 141, '2019-10-12', 302, NULL),
('Luxor', 141, '2019-10-13', 207, NULL),
('Luxor', 141, '2019-10-14', 126, NULL),
('Luxor', 141, '2019-10-15', 253, NULL),
('Luxor', 141, '2019-10-16', 115, NULL),
('Luxor', 141, '2019-10-17', 118, NULL),
('Luxor', 141, '2019-10-18', 296, NULL),
('Luxor', 141, '2019-10-19', 356, NULL),
('Luxor', 141, '2019-10-20', 369, NULL),
('Luxor', 141, '2019-10-21', 125, NULL),
('Luxor', 141, '2019-10-22', 175, NULL),
('Luxor', 141, '2019-10-23', 350, NULL),
('Luxor', 141, '2019-10-24', 264, NULL),
('Luxor', 141, '2019-10-25', 204, NULL),
('Luxor', 141, '2019-10-26', 122, NULL),
('Luxor', 141, '2019-10-27', 270, NULL),
('Luxor', 141, '2019-10-28', 279, NULL),
('Luxor', 141, '2019-10-29', 323, NULL),
('Luxor', 141, '2019-10-30', 266, NULL),
('Luxor', 141, '2019-10-31', 349, NULL),
('Luxor', 141, '2019-11-01', 174, NULL),
('Luxor', 141, '2019-11-02', 265, NULL),
('Luxor', 141, '2019-11-03', 376, NULL),
('Luxor', 141, '2019-11-04', 399, NULL),
('Luxor', 141, '2019-11-05', 231, NULL),
('Luxor', 141, '2019-11-06', 145, NULL),
('Luxor', 141, '2019-11-07', 285, NULL),
('Luxor', 141, '2019-11-08', 225, NULL),
('Luxor', 141, '2019-11-09', 339, NULL),
('Luxor', 141, '2019-11-10', 199, NULL),
('Luxor', 141, '2019-11-11', 160, NULL),
('Luxor', 141, '2019-11-12', 272, NULL),
('Luxor', 141, '2019-11-13', 247, NULL),
('Luxor', 141, '2019-11-14', 283, NULL),
('Luxor', 141, '2019-11-15', 100, NULL),
('Luxor', 141, '2019-11-16', 102, NULL),
('Luxor', 141, '2019-11-17', 244, NULL),
('Luxor', 141, '2019-11-18', 368, NULL),
('Luxor', 141, '2019-11-19', 137, NULL),
('Luxor', 141, '2019-11-20', 316, NULL),
('Luxor', 141, '2019-11-21', 389, NULL),
('Luxor', 141, '2019-11-22', 392, NULL),
('Luxor', 141, '2019-11-23', 395, NULL),
('Luxor', 141, '2019-11-24', 270, NULL),
('Luxor', 141, '2019-11-25', 198, NULL),
('Luxor', 141, '2019-11-26', 102, NULL),
('Luxor', 141, '2019-11-27', 239, NULL),
('Luxor', 141, '2019-11-28', 267, NULL),
('Luxor', 141, '2019-11-29', 148, NULL),
('Luxor', 141, '2019-11-30', 227, NULL),
('Luxor', 141, '2019-12-01', 281, NULL),
('Luxor', 141, '2019-12-02', 334, NULL),
('Luxor', 141, '2019-12-03', 219, NULL),
('Luxor', 141, '2019-12-04', 202, NULL),
('Luxor', 141, '2019-12-05', 366, NULL),
('Luxor', 141, '2019-12-06', 335, NULL),
('Luxor', 141, '2019-12-07', 359, NULL),
('Luxor', 141, '2019-12-08', 378, NULL),
('Luxor', 141, '2019-12-09', 187, NULL),
('Luxor', 141, '2019-12-10', 196, NULL),
('Luxor', 141, '2019-12-11', 174, NULL),
('Luxor', 141, '2019-12-12', 271, NULL),
('Luxor', 141, '2019-12-13', 246, NULL),
('Luxor', 141, '2019-12-14', 114, NULL),
('Luxor', 141, '2019-12-15', 264, NULL),
('Luxor', 141, '2019-12-16', 297, NULL),
('Luxor', 141, '2019-12-17', 100, NULL),
('Luxor', 141, '2019-12-18', 237, NULL),
('Luxor', 141, '2019-12-19', 215, NULL),
('Luxor', 141, '2019-12-20', 147, NULL),
('Luxor', 141, '2019-12-21', 122, NULL),
('Luxor', 141, '2019-12-22', 272, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 141, '2019-12-23', 350, NULL),
('Luxor', 141, '2019-12-24', 247, NULL),
('Luxor', 141, '2019-12-25', 259, NULL),
('Luxor', 141, '2019-12-26', 244, NULL),
('Luxor', 141, '2019-12-27', 235, NULL),
('Luxor', 141, '2019-12-28', 265, NULL),
('Luxor', 141, '2019-12-29', 317, NULL),
('Luxor', 141, '2019-12-30', 106, NULL),
('Luxor', 141, '2019-12-31', 326, NULL),
('Luxor', 141, '2020-01-01', 324, NULL),
('Luxor', 141, '2020-01-02', 224, NULL),
('Luxor', 141, '2020-01-03', 332, NULL),
('Luxor', 141, '2020-01-04', 151, NULL),
('Luxor', 141, '2020-01-05', 353, NULL),
('Luxor', 141, '2020-01-06', 142, NULL),
('Luxor', 141, '2020-01-07', 398, NULL),
('Luxor', 141, '2020-01-08', 281, NULL),
('Luxor', 141, '2020-01-09', 282, NULL),
('Luxor', 141, '2020-01-10', 292, NULL),
('Luxor', 141, '2020-01-11', 161, NULL),
('Luxor', 141, '2020-01-12', 314, NULL),
('Luxor', 141, '2020-01-13', 289, NULL),
('Luxor', 141, '2020-01-14', 229, NULL),
('Luxor', 141, '2020-01-15', 363, NULL),
('Luxor', 141, '2020-01-16', 223, NULL),
('Luxor', 141, '2020-01-17', 131, NULL),
('Luxor', 141, '2020-01-18', 163, NULL),
('Luxor', 141, '2020-01-19', 389, NULL),
('Luxor', 141, '2020-01-20', 291, NULL),
('Luxor', 141, '2020-01-21', 247, NULL),
('Luxor', 141, '2020-01-22', 235, NULL),
('Luxor', 141, '2020-01-23', 139, NULL),
('Luxor', 141, '2020-01-24', 279, NULL),
('Luxor', 141, '2020-01-25', 257, NULL),
('Luxor', 141, '2020-01-26', 114, NULL),
('Luxor', 141, '2020-01-27', 242, NULL),
('Luxor', 141, '2020-01-28', 260, NULL),
('Luxor', 141, '2020-01-29', 381, NULL),
('Luxor', 141, '2020-01-30', 298, NULL),
('Luxor', 141, '2020-01-31', 185, NULL),
('Luxor', 141, '2020-02-01', 145, NULL),
('Luxor', 141, '2020-02-02', 143, NULL),
('Luxor', 141, '2020-02-03', 336, NULL),
('Luxor', 141, '2020-02-04', 177, NULL),
('Luxor', 150, '2019-01-01', 224, NULL),
('Luxor', 150, '2019-01-02', 249, NULL),
('Luxor', 150, '2019-01-03', 319, NULL),
('Luxor', 150, '2019-01-04', 188, NULL),
('Luxor', 150, '2019-01-05', 139, NULL),
('Luxor', 150, '2019-01-06', 353, NULL),
('Luxor', 150, '2019-01-07', 279, NULL),
('Luxor', 150, '2019-01-08', 300, NULL),
('Luxor', 150, '2019-01-09', 177, NULL),
('Luxor', 150, '2019-01-10', 331, NULL),
('Luxor', 150, '2019-01-11', 133, NULL),
('Luxor', 150, '2019-01-12', 297, NULL),
('Luxor', 150, '2019-01-13', 203, NULL),
('Luxor', 150, '2019-01-14', 268, NULL),
('Luxor', 150, '2019-01-15', 289, NULL),
('Luxor', 150, '2019-01-16', 374, NULL),
('Luxor', 150, '2019-01-17', 247, NULL),
('Luxor', 150, '2019-01-18', 345, NULL),
('Luxor', 150, '2019-01-19', 231, NULL),
('Luxor', 150, '2019-01-20', 229, NULL),
('Luxor', 150, '2019-01-21', 149, NULL),
('Luxor', 150, '2019-01-22', 141, NULL),
('Luxor', 150, '2019-01-23', 140, NULL),
('Luxor', 150, '2019-01-24', 176, NULL),
('Luxor', 150, '2019-01-25', 294, NULL),
('Luxor', 150, '2019-01-26', 141, NULL),
('Luxor', 150, '2019-01-27', 108, NULL),
('Luxor', 150, '2019-01-28', 367, NULL),
('Luxor', 150, '2019-01-29', 388, NULL),
('Luxor', 150, '2019-01-30', 127, NULL),
('Luxor', 150, '2019-01-31', 271, NULL),
('Luxor', 150, '2019-02-01', 149, NULL),
('Luxor', 150, '2019-02-02', 165, NULL),
('Luxor', 150, '2019-02-03', 338, NULL),
('Luxor', 150, '2019-02-04', 186, NULL),
('Luxor', 150, '2019-02-05', 202, NULL),
('Luxor', 150, '2019-02-06', 265, NULL),
('Luxor', 150, '2019-02-07', 393, NULL),
('Luxor', 150, '2019-02-08', 151, NULL),
('Luxor', 150, '2019-02-09', 273, NULL),
('Luxor', 150, '2019-02-10', 201, NULL),
('Luxor', 150, '2019-02-11', 285, NULL),
('Luxor', 150, '2019-02-12', 245, NULL),
('Luxor', 150, '2019-02-13', 274, NULL),
('Luxor', 150, '2019-02-14', 144, NULL),
('Luxor', 150, '2019-02-15', 133, NULL),
('Luxor', 150, '2019-02-16', 150, NULL),
('Luxor', 150, '2019-02-17', 331, NULL),
('Luxor', 150, '2019-02-18', 385, NULL),
('Luxor', 150, '2019-02-19', 336, NULL),
('Luxor', 150, '2019-02-20', 129, NULL),
('Luxor', 150, '2019-02-21', 208, NULL),
('Luxor', 150, '2019-02-22', 271, NULL),
('Luxor', 150, '2019-02-23', 218, NULL),
('Luxor', 150, '2019-02-24', 312, NULL),
('Luxor', 150, '2019-02-25', 380, NULL),
('Luxor', 150, '2019-02-26', 370, NULL),
('Luxor', 150, '2019-02-27', 289, NULL),
('Luxor', 150, '2019-02-28', 260, NULL),
('Luxor', 150, '2019-03-01', 222, NULL),
('Luxor', 150, '2019-03-02', 218, NULL),
('Luxor', 150, '2019-03-03', 132, NULL),
('Luxor', 150, '2019-03-04', 305, NULL),
('Luxor', 150, '2019-03-05', 101, NULL),
('Luxor', 150, '2019-03-06', 171, NULL),
('Luxor', 150, '2019-03-07', 326, NULL),
('Luxor', 150, '2019-03-08', 293, NULL),
('Luxor', 150, '2019-03-09', 200, NULL),
('Luxor', 150, '2019-03-10', 163, NULL),
('Luxor', 150, '2019-03-11', 105, NULL),
('Luxor', 150, '2019-03-12', 219, NULL),
('Luxor', 150, '2019-03-13', 353, NULL),
('Luxor', 150, '2019-03-14', 394, NULL),
('Luxor', 150, '2019-03-15', 376, NULL),
('Luxor', 150, '2019-03-16', 394, NULL),
('Luxor', 150, '2019-03-17', 181, NULL),
('Luxor', 150, '2019-03-18', 281, NULL),
('Luxor', 150, '2019-03-19', 319, NULL),
('Luxor', 150, '2019-03-20', 164, NULL),
('Luxor', 150, '2019-03-21', 204, NULL),
('Luxor', 150, '2019-03-22', 397, NULL),
('Luxor', 150, '2019-03-23', 294, NULL),
('Luxor', 150, '2019-03-24', 282, NULL),
('Luxor', 150, '2019-03-25', 167, NULL),
('Luxor', 150, '2019-03-26', 270, NULL),
('Luxor', 150, '2019-03-27', 263, NULL),
('Luxor', 150, '2019-03-28', 147, NULL),
('Luxor', 150, '2019-03-29', 221, NULL),
('Luxor', 150, '2019-03-30', 342, NULL),
('Luxor', 150, '2019-03-31', 165, NULL),
('Luxor', 150, '2019-04-01', 235, NULL),
('Luxor', 150, '2019-04-02', 345, NULL),
('Luxor', 150, '2019-04-03', 189, NULL),
('Luxor', 150, '2019-04-04', 241, NULL),
('Luxor', 150, '2019-04-05', 380, NULL),
('Luxor', 150, '2019-04-06', 373, NULL),
('Luxor', 150, '2019-04-07', 142, NULL),
('Luxor', 150, '2019-04-08', 289, NULL),
('Luxor', 150, '2019-04-09', 347, NULL),
('Luxor', 150, '2019-04-10', 139, NULL),
('Luxor', 150, '2019-04-11', 328, NULL),
('Luxor', 150, '2019-04-12', 301, NULL),
('Luxor', 150, '2019-04-13', 121, NULL),
('Luxor', 150, '2019-04-14', 394, NULL),
('Luxor', 150, '2019-04-15', 364, NULL),
('Luxor', 150, '2019-04-16', 303, NULL),
('Luxor', 150, '2019-04-17', 154, NULL),
('Luxor', 150, '2019-04-18', 279, NULL),
('Luxor', 150, '2019-04-19', 267, NULL),
('Luxor', 150, '2019-04-20', 379, NULL),
('Luxor', 150, '2019-04-21', 332, NULL),
('Luxor', 150, '2019-04-22', 192, NULL),
('Luxor', 150, '2019-04-23', 109, NULL),
('Luxor', 150, '2019-04-24', 200, NULL),
('Luxor', 150, '2019-04-25', 134, NULL),
('Luxor', 150, '2019-04-26', 189, NULL),
('Luxor', 150, '2019-04-27', 381, NULL),
('Luxor', 150, '2019-04-28', 266, NULL),
('Luxor', 150, '2019-04-29', 352, NULL),
('Luxor', 150, '2019-04-30', 319, NULL),
('Luxor', 150, '2019-05-01', 179, NULL),
('Luxor', 150, '2019-05-02', 220, NULL),
('Luxor', 150, '2019-05-03', 251, NULL),
('Luxor', 150, '2019-05-04', 380, NULL),
('Luxor', 150, '2019-05-05', 381, NULL),
('Luxor', 150, '2019-05-06', 298, NULL),
('Luxor', 150, '2019-05-07', 247, NULL),
('Luxor', 150, '2019-05-08', 280, NULL),
('Luxor', 150, '2019-05-09', 396, NULL),
('Luxor', 150, '2019-05-10', 349, NULL),
('Luxor', 150, '2019-05-11', 390, NULL),
('Luxor', 150, '2019-05-12', 215, NULL),
('Luxor', 150, '2019-05-13', 260, NULL),
('Luxor', 150, '2019-05-14', 315, NULL),
('Luxor', 150, '2019-05-15', 106, NULL),
('Luxor', 150, '2019-05-16', 255, NULL),
('Luxor', 150, '2019-05-17', 159, NULL),
('Luxor', 150, '2019-05-18', 133, NULL),
('Luxor', 150, '2019-05-19', 169, NULL),
('Luxor', 150, '2019-05-20', 372, NULL),
('Luxor', 150, '2019-05-21', 121, NULL),
('Luxor', 150, '2019-05-22', 348, NULL),
('Luxor', 150, '2019-05-23', 242, NULL),
('Luxor', 150, '2019-05-24', 238, NULL),
('Luxor', 150, '2019-05-25', 366, NULL),
('Luxor', 150, '2019-05-26', 327, NULL),
('Luxor', 150, '2019-05-27', 232, NULL),
('Luxor', 150, '2019-05-28', 384, NULL),
('Luxor', 150, '2019-05-29', 313, NULL),
('Luxor', 150, '2019-05-30', 174, NULL),
('Luxor', 150, '2019-05-31', 338, NULL),
('Luxor', 150, '2019-06-01', 299, NULL),
('Luxor', 150, '2019-06-02', 189, NULL),
('Luxor', 150, '2019-06-03', 194, NULL),
('Luxor', 150, '2019-06-04', 198, NULL),
('Luxor', 150, '2019-06-05', 149, NULL),
('Luxor', 150, '2019-06-06', 197, NULL),
('Luxor', 150, '2019-06-07', 278, NULL),
('Luxor', 150, '2019-06-08', 167, NULL),
('Luxor', 150, '2019-06-09', 222, NULL),
('Luxor', 150, '2019-06-10', 344, NULL),
('Luxor', 150, '2019-06-11', 130, NULL),
('Luxor', 150, '2019-06-12', 108, NULL),
('Luxor', 150, '2019-06-13', 269, NULL),
('Luxor', 150, '2019-06-14', 122, NULL),
('Luxor', 150, '2019-06-15', 399, NULL),
('Luxor', 150, '2019-06-16', 263, NULL),
('Luxor', 150, '2019-06-17', 324, NULL),
('Luxor', 150, '2019-06-18', 348, NULL),
('Luxor', 150, '2019-06-19', 269, NULL),
('Luxor', 150, '2019-06-20', 345, NULL),
('Luxor', 150, '2019-06-21', 349, NULL),
('Luxor', 150, '2019-06-22', 368, NULL),
('Luxor', 150, '2019-06-23', 210, NULL),
('Luxor', 150, '2019-06-24', 324, NULL),
('Luxor', 150, '2019-06-25', 244, NULL),
('Luxor', 150, '2019-06-26', 312, NULL),
('Luxor', 150, '2019-06-27', 200, NULL),
('Luxor', 150, '2019-06-28', 158, NULL),
('Luxor', 150, '2019-06-29', 293, NULL),
('Luxor', 150, '2019-06-30', 152, NULL),
('Luxor', 150, '2019-07-01', 380, NULL),
('Luxor', 150, '2019-07-02', 339, NULL),
('Luxor', 150, '2019-07-03', 118, NULL),
('Luxor', 150, '2019-07-04', 325, NULL),
('Luxor', 150, '2019-07-05', 174, NULL),
('Luxor', 150, '2019-07-06', 219, NULL),
('Luxor', 150, '2019-07-07', 241, NULL),
('Luxor', 150, '2019-07-08', 377, NULL),
('Luxor', 150, '2019-07-09', 384, NULL),
('Luxor', 150, '2019-07-10', 307, NULL),
('Luxor', 150, '2019-07-11', 123, NULL),
('Luxor', 150, '2019-07-12', 201, NULL),
('Luxor', 150, '2019-07-13', 367, NULL),
('Luxor', 150, '2019-07-14', 390, NULL),
('Luxor', 150, '2019-07-15', 118, NULL),
('Luxor', 150, '2019-07-16', 218, NULL),
('Luxor', 150, '2019-07-17', 130, NULL),
('Luxor', 150, '2019-07-18', 257, NULL),
('Luxor', 150, '2019-07-19', 287, NULL),
('Luxor', 150, '2019-07-20', 152, NULL),
('Luxor', 150, '2019-07-21', 385, NULL),
('Luxor', 150, '2019-07-22', 225, NULL),
('Luxor', 150, '2019-07-23', 169, NULL),
('Luxor', 150, '2019-07-24', 337, NULL),
('Luxor', 150, '2019-07-25', 269, NULL),
('Luxor', 150, '2019-07-26', 300, NULL),
('Luxor', 150, '2019-07-27', 196, NULL),
('Luxor', 150, '2019-07-28', 147, NULL),
('Luxor', 150, '2019-07-29', 161, NULL),
('Luxor', 150, '2019-07-30', 341, NULL),
('Luxor', 150, '2019-07-31', 262, NULL),
('Luxor', 150, '2019-08-01', 321, NULL),
('Luxor', 150, '2019-08-02', 201, NULL),
('Luxor', 150, '2019-08-03', 211, NULL),
('Luxor', 150, '2019-08-04', 142, NULL),
('Luxor', 150, '2019-08-05', 205, NULL),
('Luxor', 150, '2019-08-06', 251, NULL),
('Luxor', 150, '2019-08-07', 259, NULL),
('Luxor', 150, '2019-08-08', 135, NULL),
('Luxor', 150, '2019-08-09', 379, NULL),
('Luxor', 150, '2019-08-10', 118, NULL),
('Luxor', 150, '2019-08-11', 143, NULL),
('Luxor', 150, '2019-08-12', 186, NULL),
('Luxor', 150, '2019-08-13', 341, NULL),
('Luxor', 150, '2019-08-14', 196, NULL),
('Luxor', 150, '2019-08-15', 122, NULL),
('Luxor', 150, '2019-08-16', 238, NULL),
('Luxor', 150, '2019-08-17', 244, NULL),
('Luxor', 150, '2019-08-18', 224, NULL),
('Luxor', 150, '2019-08-19', 153, NULL),
('Luxor', 150, '2019-08-20', 105, NULL),
('Luxor', 150, '2019-08-21', 383, NULL),
('Luxor', 150, '2019-08-22', 371, NULL),
('Luxor', 150, '2019-08-23', 180, NULL),
('Luxor', 150, '2019-08-24', 133, NULL),
('Luxor', 150, '2019-08-25', 312, NULL),
('Luxor', 150, '2019-08-26', 213, NULL),
('Luxor', 150, '2019-08-27', 164, NULL),
('Luxor', 150, '2019-08-28', 104, NULL),
('Luxor', 150, '2019-08-29', 200, NULL),
('Luxor', 150, '2019-08-30', 316, NULL),
('Luxor', 150, '2019-08-31', 340, NULL),
('Luxor', 150, '2019-09-01', 253, NULL),
('Luxor', 150, '2019-09-02', 161, NULL),
('Luxor', 150, '2019-09-03', 289, NULL),
('Luxor', 150, '2019-09-04', 226, NULL),
('Luxor', 150, '2019-09-05', 134, NULL),
('Luxor', 150, '2019-09-06', 326, NULL),
('Luxor', 150, '2019-09-07', 133, NULL),
('Luxor', 150, '2019-09-08', 166, NULL),
('Luxor', 150, '2019-09-09', 178, NULL),
('Luxor', 150, '2019-09-10', 113, NULL),
('Luxor', 150, '2019-09-11', 213, NULL),
('Luxor', 150, '2019-09-12', 333, NULL),
('Luxor', 150, '2019-09-13', 106, NULL),
('Luxor', 150, '2019-09-14', 358, NULL),
('Luxor', 150, '2019-09-15', 355, NULL),
('Luxor', 150, '2019-09-16', 260, NULL),
('Luxor', 150, '2019-09-17', 387, NULL),
('Luxor', 150, '2019-09-18', 190, NULL),
('Luxor', 150, '2019-09-19', 259, NULL),
('Luxor', 150, '2019-09-20', 300, NULL),
('Luxor', 150, '2019-09-21', 322, NULL),
('Luxor', 150, '2019-09-22', 306, NULL),
('Luxor', 150, '2019-09-23', 336, NULL),
('Luxor', 150, '2019-09-24', 344, NULL),
('Luxor', 150, '2019-09-25', 368, NULL),
('Luxor', 150, '2019-09-26', 138, NULL),
('Luxor', 150, '2019-09-27', 215, NULL),
('Luxor', 150, '2019-09-28', 300, NULL),
('Luxor', 150, '2019-09-29', 378, NULL),
('Luxor', 150, '2019-09-30', 241, NULL),
('Luxor', 150, '2019-10-01', 318, NULL),
('Luxor', 150, '2019-10-02', 254, NULL),
('Luxor', 150, '2019-10-03', 396, NULL),
('Luxor', 150, '2019-10-04', 127, NULL),
('Luxor', 150, '2019-10-05', 337, NULL),
('Luxor', 150, '2019-10-06', 250, NULL),
('Luxor', 150, '2019-10-07', 272, NULL),
('Luxor', 150, '2019-10-08', 306, NULL),
('Luxor', 150, '2019-10-09', 300, NULL),
('Luxor', 150, '2019-10-10', 340, NULL),
('Luxor', 150, '2019-10-11', 102, NULL),
('Luxor', 150, '2019-10-12', 388, NULL),
('Luxor', 150, '2019-10-13', 136, NULL),
('Luxor', 150, '2019-10-14', 355, NULL),
('Luxor', 150, '2019-10-15', 134, NULL),
('Luxor', 150, '2019-10-16', 361, NULL),
('Luxor', 150, '2019-10-17', 107, NULL),
('Luxor', 150, '2019-10-18', 321, NULL),
('Luxor', 150, '2019-10-19', 321, NULL),
('Luxor', 150, '2019-10-20', 361, NULL),
('Luxor', 150, '2019-10-21', 348, NULL),
('Luxor', 150, '2019-10-22', 158, NULL),
('Luxor', 150, '2019-10-23', 117, NULL),
('Luxor', 150, '2019-10-24', 378, NULL),
('Luxor', 150, '2019-10-25', 167, NULL),
('Luxor', 150, '2019-10-26', 177, NULL),
('Luxor', 150, '2019-10-27', 286, NULL),
('Luxor', 150, '2019-10-28', 397, NULL),
('Luxor', 150, '2019-10-29', 286, NULL),
('Luxor', 150, '2019-10-30', 132, NULL),
('Luxor', 150, '2019-10-31', 212, NULL),
('Luxor', 150, '2019-11-01', 141, NULL),
('Luxor', 150, '2019-11-02', 363, NULL),
('Luxor', 150, '2019-11-03', 342, NULL),
('Luxor', 150, '2019-11-04', 388, NULL),
('Luxor', 150, '2019-11-05', 193, NULL),
('Luxor', 150, '2019-11-06', 269, NULL),
('Luxor', 150, '2019-11-07', 309, NULL),
('Luxor', 150, '2019-11-08', 229, NULL),
('Luxor', 150, '2019-11-09', 128, NULL),
('Luxor', 150, '2019-11-10', 101, NULL),
('Luxor', 150, '2019-11-11', 182, NULL),
('Luxor', 150, '2019-11-12', 193, NULL),
('Luxor', 150, '2019-11-13', 338, NULL),
('Luxor', 150, '2019-11-14', 141, NULL),
('Luxor', 150, '2019-11-15', 177, NULL),
('Luxor', 150, '2019-11-16', 214, NULL),
('Luxor', 150, '2019-11-17', 128, NULL),
('Luxor', 150, '2019-11-18', 196, NULL),
('Luxor', 150, '2019-11-19', 334, NULL),
('Luxor', 150, '2019-11-20', 328, NULL),
('Luxor', 150, '2019-11-21', 117, NULL),
('Luxor', 150, '2019-11-22', 267, NULL),
('Luxor', 150, '2019-11-23', 366, NULL),
('Luxor', 150, '2019-11-24', 248, NULL),
('Luxor', 150, '2019-11-25', 366, NULL),
('Luxor', 150, '2019-11-26', 201, NULL),
('Luxor', 150, '2019-11-27', 128, NULL),
('Luxor', 150, '2019-11-28', 229, NULL),
('Luxor', 150, '2019-11-29', 205, NULL),
('Luxor', 150, '2019-11-30', 257, NULL),
('Luxor', 150, '2019-12-01', 288, NULL),
('Luxor', 150, '2019-12-02', 156, NULL),
('Luxor', 150, '2019-12-03', 222, NULL),
('Luxor', 150, '2019-12-04', 314, NULL),
('Luxor', 150, '2019-12-05', 284, NULL),
('Luxor', 150, '2019-12-06', 360, NULL),
('Luxor', 150, '2019-12-07', 237, NULL),
('Luxor', 150, '2019-12-08', 306, NULL),
('Luxor', 150, '2019-12-09', 293, NULL),
('Luxor', 150, '2019-12-10', 149, NULL),
('Luxor', 150, '2019-12-11', 296, NULL),
('Luxor', 150, '2019-12-12', 147, NULL),
('Luxor', 150, '2019-12-13', 363, NULL),
('Luxor', 150, '2019-12-14', 314, NULL),
('Luxor', 150, '2019-12-15', 275, NULL),
('Luxor', 150, '2019-12-16', 133, NULL),
('Luxor', 150, '2019-12-17', 309, NULL),
('Luxor', 150, '2019-12-18', 237, NULL),
('Luxor', 150, '2019-12-19', 366, NULL),
('Luxor', 150, '2019-12-20', 243, NULL),
('Luxor', 150, '2019-12-21', 102, NULL),
('Luxor', 150, '2019-12-22', 358, NULL),
('Luxor', 150, '2019-12-23', 376, NULL),
('Luxor', 150, '2019-12-24', 337, NULL),
('Luxor', 150, '2019-12-25', 160, NULL),
('Luxor', 150, '2019-12-26', 100, NULL),
('Luxor', 150, '2019-12-27', 272, NULL),
('Luxor', 150, '2019-12-28', 259, NULL),
('Luxor', 150, '2019-12-29', 308, NULL),
('Luxor', 150, '2019-12-30', 352, NULL),
('Luxor', 150, '2019-12-31', 193, NULL),
('Luxor', 150, '2020-01-01', 320, NULL),
('Luxor', 150, '2020-01-02', 260, NULL),
('Luxor', 150, '2020-01-03', 193, NULL),
('Luxor', 150, '2020-01-04', 276, NULL),
('Luxor', 150, '2020-01-05', 341, NULL),
('Luxor', 150, '2020-01-06', 216, NULL),
('Luxor', 150, '2020-01-07', 128, NULL),
('Luxor', 150, '2020-01-08', 373, NULL),
('Luxor', 150, '2020-01-09', 288, NULL),
('Luxor', 150, '2020-01-10', 233, NULL),
('Luxor', 150, '2020-01-11', 204, NULL),
('Luxor', 150, '2020-01-12', 283, NULL),
('Luxor', 150, '2020-01-13', 131, NULL),
('Luxor', 150, '2020-01-14', 373, NULL),
('Luxor', 150, '2020-01-15', 317, NULL),
('Luxor', 150, '2020-01-16', 199, NULL),
('Luxor', 150, '2020-01-17', 378, NULL),
('Luxor', 150, '2020-01-18', 329, NULL),
('Luxor', 150, '2020-01-19', 143, NULL),
('Luxor', 150, '2020-01-20', 224, NULL),
('Luxor', 150, '2020-01-21', 230, NULL),
('Luxor', 150, '2020-01-22', 355, NULL),
('Luxor', 150, '2020-01-23', 337, NULL),
('Luxor', 150, '2020-01-24', 287, NULL),
('Luxor', 150, '2020-01-25', 319, NULL),
('Luxor', 150, '2020-01-26', 325, NULL),
('Luxor', 150, '2020-01-27', 397, NULL),
('Luxor', 150, '2020-01-28', 279, NULL),
('Luxor', 150, '2020-01-29', 352, NULL),
('Luxor', 150, '2020-01-30', 367, NULL),
('Luxor', 150, '2020-01-31', 367, NULL),
('Luxor', 150, '2020-02-01', 125, NULL),
('Luxor', 150, '2020-02-02', 219, NULL),
('Luxor', 150, '2020-02-03', 293, NULL),
('Luxor', 150, '2020-02-04', 280, NULL),
('Luxor', 177, '2019-01-01', 289, NULL),
('Luxor', 177, '2019-01-02', 237, NULL),
('Luxor', 177, '2019-01-03', 126, NULL),
('Luxor', 177, '2019-01-04', 211, NULL),
('Luxor', 177, '2019-01-05', 346, NULL),
('Luxor', 177, '2019-01-06', 370, NULL),
('Luxor', 177, '2019-01-07', 175, NULL),
('Luxor', 177, '2019-01-08', 311, NULL),
('Luxor', 177, '2019-01-09', 371, NULL),
('Luxor', 177, '2019-01-10', 379, NULL),
('Luxor', 177, '2019-01-11', 158, NULL),
('Luxor', 177, '2019-01-12', 325, NULL),
('Luxor', 177, '2019-01-13', 301, NULL),
('Luxor', 177, '2019-01-14', 150, NULL),
('Luxor', 177, '2019-01-15', 255, NULL),
('Luxor', 177, '2019-01-16', 263, NULL),
('Luxor', 177, '2019-01-17', 176, NULL),
('Luxor', 177, '2019-01-18', 280, NULL),
('Luxor', 177, '2019-01-19', 150, NULL),
('Luxor', 177, '2019-01-20', 143, NULL),
('Luxor', 177, '2019-01-21', 202, NULL),
('Luxor', 177, '2019-01-22', 357, NULL),
('Luxor', 177, '2019-01-23', 399, NULL),
('Luxor', 177, '2019-01-24', 395, NULL),
('Luxor', 177, '2019-01-25', 183, NULL),
('Luxor', 177, '2019-01-26', 274, NULL),
('Luxor', 177, '2019-01-27', 182, NULL),
('Luxor', 177, '2019-01-28', 231, NULL),
('Luxor', 177, '2019-01-29', 228, NULL),
('Luxor', 177, '2019-01-30', 317, NULL),
('Luxor', 177, '2019-01-31', 398, NULL),
('Luxor', 177, '2019-02-01', 336, NULL),
('Luxor', 177, '2019-02-02', 234, NULL),
('Luxor', 177, '2019-02-03', 332, NULL),
('Luxor', 177, '2019-02-04', 319, NULL),
('Luxor', 177, '2019-02-05', 131, NULL),
('Luxor', 177, '2019-02-06', 296, NULL),
('Luxor', 177, '2019-02-07', 155, NULL),
('Luxor', 177, '2019-02-08', 369, NULL),
('Luxor', 177, '2019-02-09', 151, NULL),
('Luxor', 177, '2019-02-10', 202, NULL),
('Luxor', 177, '2019-02-11', 300, NULL),
('Luxor', 177, '2019-02-12', 252, NULL),
('Luxor', 177, '2019-02-13', 113, NULL),
('Luxor', 177, '2019-02-14', 372, NULL),
('Luxor', 177, '2019-02-15', 281, NULL),
('Luxor', 177, '2019-02-16', 316, NULL),
('Luxor', 177, '2019-02-17', 123, NULL),
('Luxor', 177, '2019-02-18', 259, NULL),
('Luxor', 177, '2019-02-19', 207, NULL),
('Luxor', 177, '2019-02-20', 281, NULL),
('Luxor', 177, '2019-02-21', 288, NULL),
('Luxor', 177, '2019-02-22', 214, NULL),
('Luxor', 177, '2019-02-23', 380, NULL),
('Luxor', 177, '2019-02-24', 116, NULL),
('Luxor', 177, '2019-02-25', 358, NULL),
('Luxor', 177, '2019-02-26', 243, NULL),
('Luxor', 177, '2019-02-27', 399, NULL),
('Luxor', 177, '2019-02-28', 184, NULL),
('Luxor', 177, '2019-03-01', 317, NULL),
('Luxor', 177, '2019-03-02', 315, NULL),
('Luxor', 177, '2019-03-03', 383, NULL),
('Luxor', 177, '2019-03-04', 349, NULL),
('Luxor', 177, '2019-03-05', 201, NULL),
('Luxor', 177, '2019-03-06', 143, NULL),
('Luxor', 177, '2019-03-07', 317, NULL),
('Luxor', 177, '2019-03-08', 357, NULL),
('Luxor', 177, '2019-03-09', 370, NULL),
('Luxor', 177, '2019-03-10', 354, NULL),
('Luxor', 177, '2019-03-11', 155, NULL),
('Luxor', 177, '2019-03-12', 312, NULL),
('Luxor', 177, '2019-03-13', 206, NULL),
('Luxor', 177, '2019-03-14', 176, NULL),
('Luxor', 177, '2019-03-15', 394, NULL),
('Luxor', 177, '2019-03-16', 324, NULL),
('Luxor', 177, '2019-03-17', 163, NULL),
('Luxor', 177, '2019-03-18', 373, NULL),
('Luxor', 177, '2019-03-19', 371, NULL),
('Luxor', 177, '2019-03-20', 281, NULL),
('Luxor', 177, '2019-03-21', 384, NULL),
('Luxor', 177, '2019-03-22', 340, NULL),
('Luxor', 177, '2019-03-23', 351, NULL),
('Luxor', 177, '2019-03-24', 378, NULL),
('Luxor', 177, '2019-03-25', 181, NULL),
('Luxor', 177, '2019-03-26', 231, NULL),
('Luxor', 177, '2019-03-27', 150, NULL),
('Luxor', 177, '2019-03-28', 310, NULL),
('Luxor', 177, '2019-03-29', 349, NULL),
('Luxor', 177, '2019-03-30', 111, NULL),
('Luxor', 177, '2019-03-31', 101, NULL),
('Luxor', 177, '2019-04-01', 235, NULL),
('Luxor', 177, '2019-04-02', 368, NULL),
('Luxor', 177, '2019-04-03', 367, NULL),
('Luxor', 177, '2019-04-04', 177, NULL),
('Luxor', 177, '2019-04-05', 365, NULL),
('Luxor', 177, '2019-04-06', 380, NULL),
('Luxor', 177, '2019-04-07', 283, NULL),
('Luxor', 177, '2019-04-08', 251, NULL),
('Luxor', 177, '2019-04-09', 264, NULL),
('Luxor', 177, '2019-04-10', 179, NULL),
('Luxor', 177, '2019-04-11', 265, NULL),
('Luxor', 177, '2019-04-12', 262, NULL),
('Luxor', 177, '2019-04-13', 155, NULL),
('Luxor', 177, '2019-04-14', 228, NULL),
('Luxor', 177, '2019-04-15', 339, NULL),
('Luxor', 177, '2019-04-16', 154, NULL),
('Luxor', 177, '2019-04-17', 378, NULL),
('Luxor', 177, '2019-04-18', 302, NULL),
('Luxor', 177, '2019-04-19', 207, NULL),
('Luxor', 177, '2019-04-20', 208, NULL),
('Luxor', 177, '2019-04-21', 203, NULL),
('Luxor', 177, '2019-04-22', 167, NULL),
('Luxor', 177, '2019-04-23', 170, NULL),
('Luxor', 177, '2019-04-24', 107, NULL),
('Luxor', 177, '2019-04-25', 394, NULL),
('Luxor', 177, '2019-04-26', 367, NULL),
('Luxor', 177, '2019-04-27', 191, NULL),
('Luxor', 177, '2019-04-28', 224, NULL),
('Luxor', 177, '2019-04-29', 363, NULL),
('Luxor', 177, '2019-04-30', 105, NULL),
('Luxor', 177, '2019-05-01', 369, NULL),
('Luxor', 177, '2019-05-02', 177, NULL),
('Luxor', 177, '2019-05-03', 244, NULL),
('Luxor', 177, '2019-05-04', 353, NULL),
('Luxor', 177, '2019-05-05', 376, NULL),
('Luxor', 177, '2019-05-06', 141, NULL),
('Luxor', 177, '2019-05-07', 151, NULL),
('Luxor', 177, '2019-05-08', 354, NULL),
('Luxor', 177, '2019-05-09', 339, NULL),
('Luxor', 177, '2019-05-10', 148, NULL),
('Luxor', 177, '2019-05-11', 169, NULL),
('Luxor', 177, '2019-05-12', 261, NULL),
('Luxor', 177, '2019-05-13', 325, NULL),
('Luxor', 177, '2019-05-14', 345, NULL),
('Luxor', 177, '2019-05-15', 285, NULL),
('Luxor', 177, '2019-05-16', 215, NULL),
('Luxor', 177, '2019-05-17', 119, NULL),
('Luxor', 177, '2019-05-18', 275, NULL),
('Luxor', 177, '2019-05-19', 299, NULL),
('Luxor', 177, '2019-05-20', 212, NULL),
('Luxor', 177, '2019-05-21', 350, NULL),
('Luxor', 177, '2019-05-22', 290, NULL),
('Luxor', 177, '2019-05-23', 171, NULL),
('Luxor', 177, '2019-05-24', 260, NULL),
('Luxor', 177, '2019-05-25', 180, NULL),
('Luxor', 177, '2019-05-26', 283, NULL),
('Luxor', 177, '2019-05-27', 240, NULL),
('Luxor', 177, '2019-05-28', 104, NULL),
('Luxor', 177, '2019-05-29', 180, NULL),
('Luxor', 177, '2019-05-30', 357, NULL),
('Luxor', 177, '2019-05-31', 186, NULL),
('Luxor', 177, '2019-06-01', 133, NULL),
('Luxor', 177, '2019-06-02', 157, NULL),
('Luxor', 177, '2019-06-03', 207, NULL),
('Luxor', 177, '2019-06-04', 251, NULL),
('Luxor', 177, '2019-06-05', 171, NULL),
('Luxor', 177, '2019-06-06', 217, NULL),
('Luxor', 177, '2019-06-07', 208, NULL),
('Luxor', 177, '2019-06-08', 399, NULL),
('Luxor', 177, '2019-06-09', 258, NULL),
('Luxor', 177, '2019-06-10', 394, NULL),
('Luxor', 177, '2019-06-11', 254, NULL),
('Luxor', 177, '2019-06-12', 178, NULL),
('Luxor', 177, '2019-06-13', 253, NULL),
('Luxor', 177, '2019-06-14', 102, NULL),
('Luxor', 177, '2019-06-15', 196, NULL),
('Luxor', 177, '2019-06-16', 218, NULL),
('Luxor', 177, '2019-06-17', 249, NULL),
('Luxor', 177, '2019-06-18', 346, NULL),
('Luxor', 177, '2019-06-19', 137, NULL),
('Luxor', 177, '2019-06-20', 275, NULL),
('Luxor', 177, '2019-06-21', 263, NULL),
('Luxor', 177, '2019-06-22', 155, NULL),
('Luxor', 177, '2019-06-23', 175, NULL),
('Luxor', 177, '2019-06-24', 292, NULL),
('Luxor', 177, '2019-06-25', 141, NULL),
('Luxor', 177, '2019-06-26', 300, NULL),
('Luxor', 177, '2019-06-27', 206, NULL),
('Luxor', 177, '2019-06-28', 361, NULL),
('Luxor', 177, '2019-06-29', 293, NULL),
('Luxor', 177, '2019-06-30', 236, NULL),
('Luxor', 177, '2019-07-01', 299, NULL),
('Luxor', 177, '2019-07-02', 200, NULL),
('Luxor', 177, '2019-07-03', 318, NULL),
('Luxor', 177, '2019-07-04', 290, NULL),
('Luxor', 177, '2019-07-05', 247, NULL),
('Luxor', 177, '2019-07-06', 392, NULL),
('Luxor', 177, '2019-07-07', 216, NULL),
('Luxor', 177, '2019-07-08', 393, NULL),
('Luxor', 177, '2019-07-09', 331, NULL),
('Luxor', 177, '2019-07-10', 250, NULL),
('Luxor', 177, '2019-07-11', 227, NULL),
('Luxor', 177, '2019-07-12', 268, NULL),
('Luxor', 177, '2019-07-13', 349, NULL),
('Luxor', 177, '2019-07-14', 159, NULL),
('Luxor', 177, '2019-07-15', 162, NULL),
('Luxor', 177, '2019-07-16', 174, NULL),
('Luxor', 177, '2019-07-17', 284, NULL),
('Luxor', 177, '2019-07-18', 107, NULL),
('Luxor', 177, '2019-07-19', 311, NULL),
('Luxor', 177, '2019-07-20', 120, NULL),
('Luxor', 177, '2019-07-21', 119, NULL),
('Luxor', 177, '2019-07-22', 376, NULL),
('Luxor', 177, '2019-07-23', 154, NULL),
('Luxor', 177, '2019-07-24', 102, NULL),
('Luxor', 177, '2019-07-25', 295, NULL),
('Luxor', 177, '2019-07-26', 240, NULL),
('Luxor', 177, '2019-07-27', 257, NULL),
('Luxor', 177, '2019-07-28', 310, NULL),
('Luxor', 177, '2019-07-29', 209, NULL),
('Luxor', 177, '2019-07-30', 267, NULL),
('Luxor', 177, '2019-07-31', 361, NULL),
('Luxor', 177, '2019-08-01', 338, NULL),
('Luxor', 177, '2019-08-02', 104, NULL),
('Luxor', 177, '2019-08-03', 201, NULL),
('Luxor', 177, '2019-08-04', 161, NULL),
('Luxor', 177, '2019-08-05', 285, NULL),
('Luxor', 177, '2019-08-06', 172, NULL),
('Luxor', 177, '2019-08-07', 171, NULL),
('Luxor', 177, '2019-08-08', 312, NULL),
('Luxor', 177, '2019-08-09', 211, NULL),
('Luxor', 177, '2019-08-10', 254, NULL),
('Luxor', 177, '2019-08-11', 343, NULL),
('Luxor', 177, '2019-08-12', 293, NULL),
('Luxor', 177, '2019-08-13', 281, NULL),
('Luxor', 177, '2019-08-14', 179, NULL),
('Luxor', 177, '2019-08-15', 347, NULL),
('Luxor', 177, '2019-08-16', 211, NULL),
('Luxor', 177, '2019-08-17', 383, NULL),
('Luxor', 177, '2019-08-18', 224, NULL),
('Luxor', 177, '2019-08-19', 255, NULL),
('Luxor', 177, '2019-08-20', 255, NULL),
('Luxor', 177, '2019-08-21', 377, NULL),
('Luxor', 177, '2019-08-22', 330, NULL),
('Luxor', 177, '2019-08-23', 134, NULL),
('Luxor', 177, '2019-08-24', 220, NULL),
('Luxor', 177, '2019-08-25', 384, NULL),
('Luxor', 177, '2019-08-26', 316, NULL),
('Luxor', 177, '2019-08-27', 347, NULL),
('Luxor', 177, '2019-08-28', 321, NULL),
('Luxor', 177, '2019-08-29', 388, NULL),
('Luxor', 177, '2019-08-30', 326, NULL),
('Luxor', 177, '2019-08-31', 296, NULL),
('Luxor', 177, '2019-09-01', 278, NULL),
('Luxor', 177, '2019-09-02', 283, NULL),
('Luxor', 177, '2019-09-03', 380, NULL),
('Luxor', 177, '2019-09-04', 177, NULL),
('Luxor', 177, '2019-09-05', 387, NULL),
('Luxor', 177, '2019-09-06', 124, NULL),
('Luxor', 177, '2019-09-07', 309, NULL),
('Luxor', 177, '2019-09-08', 299, NULL),
('Luxor', 177, '2019-09-09', 383, NULL),
('Luxor', 177, '2019-09-10', 168, NULL),
('Luxor', 177, '2019-09-11', 128, NULL),
('Luxor', 177, '2019-09-12', 321, NULL),
('Luxor', 177, '2019-09-13', 397, NULL),
('Luxor', 177, '2019-09-14', 359, NULL),
('Luxor', 177, '2019-09-15', 260, NULL),
('Luxor', 177, '2019-09-16', 328, NULL),
('Luxor', 177, '2019-09-17', 204, NULL),
('Luxor', 177, '2019-09-18', 330, NULL),
('Luxor', 177, '2019-09-19', 374, NULL),
('Luxor', 177, '2019-09-20', 356, NULL),
('Luxor', 177, '2019-09-21', 115, NULL),
('Luxor', 177, '2019-09-22', 273, NULL),
('Luxor', 177, '2019-09-23', 104, NULL),
('Luxor', 177, '2019-09-24', 164, NULL),
('Luxor', 177, '2019-09-25', 322, NULL),
('Luxor', 177, '2019-09-26', 235, NULL),
('Luxor', 177, '2019-09-27', 313, NULL),
('Luxor', 177, '2019-09-28', 145, NULL),
('Luxor', 177, '2019-09-29', 110, NULL),
('Luxor', 177, '2019-09-30', 296, NULL),
('Luxor', 177, '2019-10-01', 321, NULL),
('Luxor', 177, '2019-10-02', 381, NULL),
('Luxor', 177, '2019-10-03', 344, NULL),
('Luxor', 177, '2019-10-04', 314, NULL),
('Luxor', 177, '2019-10-05', 328, NULL),
('Luxor', 177, '2019-10-06', 343, NULL),
('Luxor', 177, '2019-10-07', 294, NULL),
('Luxor', 177, '2019-10-08', 332, NULL),
('Luxor', 177, '2019-10-09', 350, NULL),
('Luxor', 177, '2019-10-10', 314, NULL),
('Luxor', 177, '2019-10-11', 169, NULL),
('Luxor', 177, '2019-10-12', 337, NULL),
('Luxor', 177, '2019-10-13', 257, NULL),
('Luxor', 177, '2019-10-14', 397, NULL),
('Luxor', 177, '2019-10-15', 113, NULL),
('Luxor', 177, '2019-10-16', 162, NULL),
('Luxor', 177, '2019-10-17', 378, NULL),
('Luxor', 177, '2019-10-18', 315, NULL),
('Luxor', 177, '2019-10-19', 136, NULL),
('Luxor', 177, '2019-10-20', 295, NULL),
('Luxor', 177, '2019-10-21', 365, NULL),
('Luxor', 177, '2019-10-22', 166, NULL),
('Luxor', 177, '2019-10-23', 334, NULL),
('Luxor', 177, '2019-10-24', 398, NULL),
('Luxor', 177, '2019-10-25', 124, NULL),
('Luxor', 177, '2019-10-26', 120, NULL),
('Luxor', 177, '2019-10-27', 221, NULL),
('Luxor', 177, '2019-10-28', 150, NULL),
('Luxor', 177, '2019-10-29', 360, NULL),
('Luxor', 177, '2019-10-30', 365, NULL),
('Luxor', 177, '2019-10-31', 211, NULL),
('Luxor', 177, '2019-11-01', 385, NULL),
('Luxor', 177, '2019-11-02', 318, NULL),
('Luxor', 177, '2019-11-03', 183, NULL),
('Luxor', 177, '2019-11-04', 345, NULL),
('Luxor', 177, '2019-11-05', 173, NULL),
('Luxor', 177, '2019-11-06', 210, NULL),
('Luxor', 177, '2019-11-07', 291, NULL),
('Luxor', 177, '2019-11-08', 372, NULL),
('Luxor', 177, '2019-11-09', 121, NULL),
('Luxor', 177, '2019-11-10', 107, NULL),
('Luxor', 177, '2019-11-11', 331, NULL),
('Luxor', 177, '2019-11-12', 349, NULL),
('Luxor', 177, '2019-11-13', 251, NULL),
('Luxor', 177, '2019-11-14', 359, NULL),
('Luxor', 177, '2019-11-15', 187, NULL),
('Luxor', 177, '2019-11-16', 363, NULL),
('Luxor', 177, '2019-11-17', 111, NULL),
('Luxor', 177, '2019-11-18', 378, NULL),
('Luxor', 177, '2019-11-19', 258, NULL),
('Luxor', 177, '2019-11-20', 294, NULL),
('Luxor', 177, '2019-11-21', 215, NULL),
('Luxor', 177, '2019-11-22', 360, NULL),
('Luxor', 177, '2019-11-23', 245, NULL),
('Luxor', 177, '2019-11-24', 330, NULL),
('Luxor', 177, '2019-11-25', 238, NULL),
('Luxor', 177, '2019-11-26', 298, NULL),
('Luxor', 177, '2019-11-27', 121, NULL),
('Luxor', 177, '2019-11-28', 243, NULL),
('Luxor', 177, '2019-11-29', 183, NULL),
('Luxor', 177, '2019-11-30', 205, NULL),
('Luxor', 177, '2019-12-01', 195, NULL),
('Luxor', 177, '2019-12-02', 276, NULL),
('Luxor', 177, '2019-12-03', 354, NULL),
('Luxor', 177, '2019-12-04', 265, NULL),
('Luxor', 177, '2019-12-05', 222, NULL),
('Luxor', 177, '2019-12-06', 394, NULL),
('Luxor', 177, '2019-12-07', 307, NULL),
('Luxor', 177, '2019-12-08', 298, NULL),
('Luxor', 177, '2019-12-09', 207, NULL),
('Luxor', 177, '2019-12-10', 357, NULL),
('Luxor', 177, '2019-12-11', 256, NULL),
('Luxor', 177, '2019-12-12', 123, NULL),
('Luxor', 177, '2019-12-13', 378, NULL),
('Luxor', 177, '2019-12-14', 229, NULL),
('Luxor', 177, '2019-12-15', 181, NULL),
('Luxor', 177, '2019-12-16', 274, NULL),
('Luxor', 177, '2019-12-17', 246, NULL),
('Luxor', 177, '2019-12-18', 373, NULL),
('Luxor', 177, '2019-12-19', 186, NULL),
('Luxor', 177, '2019-12-20', 374, NULL),
('Luxor', 177, '2019-12-21', 345, NULL),
('Luxor', 177, '2019-12-22', 273, NULL),
('Luxor', 177, '2019-12-23', 132, NULL),
('Luxor', 177, '2019-12-24', 246, NULL),
('Luxor', 177, '2019-12-25', 225, NULL),
('Luxor', 177, '2019-12-26', 269, NULL),
('Luxor', 177, '2019-12-27', 255, NULL),
('Luxor', 177, '2019-12-28', 398, NULL),
('Luxor', 177, '2019-12-29', 190, NULL),
('Luxor', 177, '2019-12-30', 143, NULL),
('Luxor', 177, '2019-12-31', 188, NULL),
('Luxor', 177, '2020-01-01', 227, NULL),
('Luxor', 177, '2020-01-02', 228, NULL),
('Luxor', 177, '2020-01-03', 171, NULL),
('Luxor', 177, '2020-01-04', 230, NULL),
('Luxor', 177, '2020-01-05', 247, NULL),
('Luxor', 177, '2020-01-06', 254, NULL),
('Luxor', 177, '2020-01-07', 247, NULL),
('Luxor', 177, '2020-01-08', 326, NULL),
('Luxor', 177, '2020-01-09', 192, NULL),
('Luxor', 177, '2020-01-10', 191, NULL),
('Luxor', 177, '2020-01-11', 136, NULL),
('Luxor', 177, '2020-01-12', 376, NULL),
('Luxor', 177, '2020-01-13', 290, NULL),
('Luxor', 177, '2020-01-14', 177, NULL),
('Luxor', 177, '2020-01-15', 394, NULL),
('Luxor', 177, '2020-01-16', 227, NULL),
('Luxor', 177, '2020-01-17', 199, NULL),
('Luxor', 177, '2020-01-18', 156, NULL),
('Luxor', 177, '2020-01-19', 350, NULL),
('Luxor', 177, '2020-01-20', 148, NULL),
('Luxor', 177, '2020-01-21', 309, NULL),
('Luxor', 177, '2020-01-22', 370, NULL),
('Luxor', 177, '2020-01-23', 272, NULL),
('Luxor', 177, '2020-01-24', 195, NULL),
('Luxor', 177, '2020-01-25', 124, NULL),
('Luxor', 177, '2020-01-26', 284, NULL),
('Luxor', 177, '2020-01-27', 259, NULL),
('Luxor', 177, '2020-01-28', 215, NULL),
('Luxor', 177, '2020-01-29', 216, NULL),
('Luxor', 177, '2020-01-30', 241, NULL),
('Luxor', 177, '2020-01-31', 279, NULL),
('Luxor', 177, '2020-02-01', 387, NULL),
('Luxor', 177, '2020-02-02', 267, NULL),
('Luxor', 177, '2020-02-03', 354, NULL),
('Luxor', 177, '2020-02-04', 169, NULL),
('Luxor', 194, '2019-01-01', 373, NULL),
('Luxor', 194, '2019-01-02', 335, NULL),
('Luxor', 194, '2019-01-03', 176, NULL),
('Luxor', 194, '2019-01-04', 389, NULL),
('Luxor', 194, '2019-01-05', 312, NULL),
('Luxor', 194, '2019-01-06', 388, NULL),
('Luxor', 194, '2019-01-07', 240, NULL),
('Luxor', 194, '2019-01-08', 257, NULL),
('Luxor', 194, '2019-01-09', 326, NULL),
('Luxor', 194, '2019-01-10', 204, NULL),
('Luxor', 194, '2019-01-11', 291, NULL),
('Luxor', 194, '2019-01-12', 332, NULL),
('Luxor', 194, '2019-01-13', 195, NULL),
('Luxor', 194, '2019-01-14', 144, NULL),
('Luxor', 194, '2019-01-15', 311, NULL),
('Luxor', 194, '2019-01-16', 390, NULL),
('Luxor', 194, '2019-01-17', 340, NULL),
('Luxor', 194, '2019-01-18', 267, NULL),
('Luxor', 194, '2019-01-19', 261, NULL),
('Luxor', 194, '2019-01-20', 227, NULL),
('Luxor', 194, '2019-01-21', 162, NULL),
('Luxor', 194, '2019-01-22', 361, NULL),
('Luxor', 194, '2019-01-23', 275, NULL),
('Luxor', 194, '2019-01-24', 148, NULL),
('Luxor', 194, '2019-01-25', 235, NULL),
('Luxor', 194, '2019-01-26', 248, NULL),
('Luxor', 194, '2019-01-27', 190, NULL),
('Luxor', 194, '2019-01-28', 255, NULL),
('Luxor', 194, '2019-01-29', 173, NULL),
('Luxor', 194, '2019-01-30', 206, NULL),
('Luxor', 194, '2019-01-31', 178, NULL),
('Luxor', 194, '2019-02-01', 232, NULL),
('Luxor', 194, '2019-02-02', 275, NULL),
('Luxor', 194, '2019-02-03', 246, NULL),
('Luxor', 194, '2019-02-04', 339, NULL),
('Luxor', 194, '2019-02-05', 248, NULL),
('Luxor', 194, '2019-02-06', 285, NULL),
('Luxor', 194, '2019-02-07', 399, NULL),
('Luxor', 194, '2019-02-08', 395, NULL),
('Luxor', 194, '2019-02-09', 138, NULL),
('Luxor', 194, '2019-02-10', 304, NULL),
('Luxor', 194, '2019-02-11', 248, NULL),
('Luxor', 194, '2019-02-12', 124, NULL),
('Luxor', 194, '2019-02-13', 246, NULL),
('Luxor', 194, '2019-02-14', 126, NULL),
('Luxor', 194, '2019-02-15', 306, NULL),
('Luxor', 194, '2019-02-16', 131, NULL),
('Luxor', 194, '2019-02-17', 121, NULL),
('Luxor', 194, '2019-02-18', 340, NULL),
('Luxor', 194, '2019-02-19', 228, NULL),
('Luxor', 194, '2019-02-20', 315, NULL),
('Luxor', 194, '2019-02-21', 117, NULL),
('Luxor', 194, '2019-02-22', 158, NULL),
('Luxor', 194, '2019-02-23', 247, NULL),
('Luxor', 194, '2019-02-24', 144, NULL),
('Luxor', 194, '2019-02-25', 248, NULL),
('Luxor', 194, '2019-02-26', 304, NULL),
('Luxor', 194, '2019-02-27', 131, NULL),
('Luxor', 194, '2019-02-28', 342, NULL),
('Luxor', 194, '2019-03-01', 221, NULL),
('Luxor', 194, '2019-03-02', 224, NULL),
('Luxor', 194, '2019-03-03', 220, NULL),
('Luxor', 194, '2019-03-04', 128, NULL),
('Luxor', 194, '2019-03-05', 303, NULL),
('Luxor', 194, '2019-03-06', 101, NULL),
('Luxor', 194, '2019-03-07', 205, NULL),
('Luxor', 194, '2019-03-08', 204, NULL),
('Luxor', 194, '2019-03-09', 253, NULL),
('Luxor', 194, '2019-03-10', 280, NULL),
('Luxor', 194, '2019-03-11', 358, NULL),
('Luxor', 194, '2019-03-12', 206, NULL),
('Luxor', 194, '2019-03-13', 171, NULL),
('Luxor', 194, '2019-03-14', 200, NULL),
('Luxor', 194, '2019-03-15', 142, NULL),
('Luxor', 194, '2019-03-16', 341, NULL),
('Luxor', 194, '2019-03-17', 172, NULL),
('Luxor', 194, '2019-03-18', 322, NULL),
('Luxor', 194, '2019-03-19', 200, NULL),
('Luxor', 194, '2019-03-20', 216, NULL),
('Luxor', 194, '2019-03-21', 307, NULL),
('Luxor', 194, '2019-03-22', 108, NULL),
('Luxor', 194, '2019-03-23', 174, NULL),
('Luxor', 194, '2019-03-24', 346, NULL),
('Luxor', 194, '2019-03-25', 306, NULL),
('Luxor', 194, '2019-03-26', 247, NULL),
('Luxor', 194, '2019-03-27', 160, NULL),
('Luxor', 194, '2019-03-28', 109, NULL),
('Luxor', 194, '2019-03-29', 382, NULL),
('Luxor', 194, '2019-03-30', 329, NULL),
('Luxor', 194, '2019-03-31', 210, NULL),
('Luxor', 194, '2019-04-01', 368, NULL),
('Luxor', 194, '2019-04-02', 106, NULL),
('Luxor', 194, '2019-04-03', 266, NULL),
('Luxor', 194, '2019-04-04', 364, NULL),
('Luxor', 194, '2019-04-05', 284, NULL),
('Luxor', 194, '2019-04-06', 381, NULL),
('Luxor', 194, '2019-04-07', 290, NULL),
('Luxor', 194, '2019-04-08', 287, NULL),
('Luxor', 194, '2019-04-09', 181, NULL),
('Luxor', 194, '2019-04-10', 377, NULL),
('Luxor', 194, '2019-04-11', 239, NULL),
('Luxor', 194, '2019-04-12', 307, NULL),
('Luxor', 194, '2019-04-13', 313, NULL),
('Luxor', 194, '2019-04-14', 157, NULL),
('Luxor', 194, '2019-04-15', 206, NULL),
('Luxor', 194, '2019-04-16', 363, NULL),
('Luxor', 194, '2019-04-17', 128, NULL),
('Luxor', 194, '2019-04-18', 271, NULL),
('Luxor', 194, '2019-04-19', 132, NULL),
('Luxor', 194, '2019-04-20', 106, NULL),
('Luxor', 194, '2019-04-21', 217, NULL),
('Luxor', 194, '2019-04-22', 157, NULL),
('Luxor', 194, '2019-04-23', 125, NULL),
('Luxor', 194, '2019-04-24', 135, NULL),
('Luxor', 194, '2019-04-25', 268, NULL),
('Luxor', 194, '2019-04-26', 271, NULL),
('Luxor', 194, '2019-04-27', 310, NULL),
('Luxor', 194, '2019-04-28', 221, NULL),
('Luxor', 194, '2019-04-29', 361, NULL),
('Luxor', 194, '2019-04-30', 369, NULL),
('Luxor', 194, '2019-05-01', 311, NULL),
('Luxor', 194, '2019-05-02', 124, NULL),
('Luxor', 194, '2019-05-03', 367, NULL),
('Luxor', 194, '2019-05-04', 228, NULL),
('Luxor', 194, '2019-05-05', 336, NULL),
('Luxor', 194, '2019-05-06', 312, NULL),
('Luxor', 194, '2019-05-07', 216, NULL),
('Luxor', 194, '2019-05-08', 229, NULL),
('Luxor', 194, '2019-05-09', 106, NULL),
('Luxor', 194, '2019-05-10', 195, NULL),
('Luxor', 194, '2019-05-11', 173, NULL),
('Luxor', 194, '2019-05-12', 262, NULL),
('Luxor', 194, '2019-05-13', 147, NULL),
('Luxor', 194, '2019-05-14', 379, NULL),
('Luxor', 194, '2019-05-15', 107, NULL),
('Luxor', 194, '2019-05-16', 210, NULL),
('Luxor', 194, '2019-05-17', 319, NULL),
('Luxor', 194, '2019-05-18', 278, NULL),
('Luxor', 194, '2019-05-19', 290, NULL),
('Luxor', 194, '2019-05-20', 144, NULL),
('Luxor', 194, '2019-05-21', 389, NULL),
('Luxor', 194, '2019-05-22', 307, NULL),
('Luxor', 194, '2019-05-23', 330, NULL),
('Luxor', 194, '2019-05-24', 184, NULL),
('Luxor', 194, '2019-05-25', 299, NULL),
('Luxor', 194, '2019-05-26', 338, NULL),
('Luxor', 194, '2019-05-27', 107, NULL),
('Luxor', 194, '2019-05-28', 171, NULL),
('Luxor', 194, '2019-05-29', 159, NULL),
('Luxor', 194, '2019-05-30', 262, NULL),
('Luxor', 194, '2019-05-31', 118, NULL),
('Luxor', 194, '2019-06-01', 268, NULL),
('Luxor', 194, '2019-06-02', 120, NULL),
('Luxor', 194, '2019-06-03', 353, NULL),
('Luxor', 194, '2019-06-04', 262, NULL),
('Luxor', 194, '2019-06-05', 308, NULL),
('Luxor', 194, '2019-06-06', 393, NULL),
('Luxor', 194, '2019-06-07', 108, NULL),
('Luxor', 194, '2019-06-08', 196, NULL),
('Luxor', 194, '2019-06-09', 226, NULL),
('Luxor', 194, '2019-06-10', 240, NULL),
('Luxor', 194, '2019-06-11', 178, NULL),
('Luxor', 194, '2019-06-12', 168, NULL),
('Luxor', 194, '2019-06-13', 358, NULL),
('Luxor', 194, '2019-06-14', 344, NULL),
('Luxor', 194, '2019-06-15', 281, NULL),
('Luxor', 194, '2019-06-16', 202, NULL),
('Luxor', 194, '2019-06-17', 176, NULL),
('Luxor', 194, '2019-06-18', 286, NULL),
('Luxor', 194, '2019-06-19', 376, NULL),
('Luxor', 194, '2019-06-20', 240, NULL),
('Luxor', 194, '2019-06-21', 169, NULL),
('Luxor', 194, '2019-06-22', 175, NULL),
('Luxor', 194, '2019-06-23', 144, NULL),
('Luxor', 194, '2019-06-24', 385, NULL),
('Luxor', 194, '2019-06-25', 174, NULL),
('Luxor', 194, '2019-06-26', 163, NULL),
('Luxor', 194, '2019-06-27', 332, NULL),
('Luxor', 194, '2019-06-28', 334, NULL),
('Luxor', 194, '2019-06-29', 185, NULL),
('Luxor', 194, '2019-06-30', 324, NULL),
('Luxor', 194, '2019-07-01', 256, NULL),
('Luxor', 194, '2019-07-02', 182, NULL),
('Luxor', 194, '2019-07-03', 238, NULL),
('Luxor', 194, '2019-07-04', 373, NULL),
('Luxor', 194, '2019-07-05', 315, NULL),
('Luxor', 194, '2019-07-06', 304, NULL),
('Luxor', 194, '2019-07-07', 258, NULL),
('Luxor', 194, '2019-07-08', 136, NULL),
('Luxor', 194, '2019-07-09', 105, NULL),
('Luxor', 194, '2019-07-10', 228, NULL),
('Luxor', 194, '2019-07-11', 366, NULL),
('Luxor', 194, '2019-07-12', 339, NULL),
('Luxor', 194, '2019-07-13', 244, NULL),
('Luxor', 194, '2019-07-14', 124, NULL),
('Luxor', 194, '2019-07-15', 358, NULL),
('Luxor', 194, '2019-07-16', 115, NULL),
('Luxor', 194, '2019-07-17', 332, NULL),
('Luxor', 194, '2019-07-18', 264, NULL),
('Luxor', 194, '2019-07-19', 294, NULL),
('Luxor', 194, '2019-07-20', 348, NULL),
('Luxor', 194, '2019-07-21', 238, NULL),
('Luxor', 194, '2019-07-22', 206, NULL),
('Luxor', 194, '2019-07-23', 162, NULL),
('Luxor', 194, '2019-07-24', 301, NULL),
('Luxor', 194, '2019-07-25', 272, NULL),
('Luxor', 194, '2019-07-26', 203, NULL),
('Luxor', 194, '2019-07-27', 295, NULL),
('Luxor', 194, '2019-07-28', 110, NULL),
('Luxor', 194, '2019-07-29', 159, NULL),
('Luxor', 194, '2019-07-30', 214, NULL),
('Luxor', 194, '2019-07-31', 318, NULL),
('Luxor', 194, '2019-08-01', 328, NULL),
('Luxor', 194, '2019-08-02', 117, NULL),
('Luxor', 194, '2019-08-03', 273, NULL),
('Luxor', 194, '2019-08-04', 282, NULL),
('Luxor', 194, '2019-08-05', 112, NULL),
('Luxor', 194, '2019-08-06', 309, NULL),
('Luxor', 194, '2019-08-07', 279, NULL),
('Luxor', 194, '2019-08-08', 157, NULL),
('Luxor', 194, '2019-08-09', 121, NULL),
('Luxor', 194, '2019-08-10', 214, NULL),
('Luxor', 194, '2019-08-11', 288, NULL),
('Luxor', 194, '2019-08-12', 208, NULL),
('Luxor', 194, '2019-08-13', 281, NULL),
('Luxor', 194, '2019-08-14', 208, NULL),
('Luxor', 194, '2019-08-15', 371, NULL),
('Luxor', 194, '2019-08-16', 244, NULL),
('Luxor', 194, '2019-08-17', 182, NULL),
('Luxor', 194, '2019-08-18', 348, NULL),
('Luxor', 194, '2019-08-19', 118, NULL),
('Luxor', 194, '2019-08-20', 261, NULL),
('Luxor', 194, '2019-08-21', 340, NULL),
('Luxor', 194, '2019-08-22', 138, NULL),
('Luxor', 194, '2019-08-23', 331, NULL),
('Luxor', 194, '2019-08-24', 298, NULL),
('Luxor', 194, '2019-08-25', 287, NULL),
('Luxor', 194, '2019-08-26', 239, NULL),
('Luxor', 194, '2019-08-27', 245, NULL),
('Luxor', 194, '2019-08-28', 295, NULL),
('Luxor', 194, '2019-08-29', 340, NULL),
('Luxor', 194, '2019-08-30', 283, NULL),
('Luxor', 194, '2019-08-31', 360, NULL),
('Luxor', 194, '2019-09-01', 231, NULL),
('Luxor', 194, '2019-09-02', 230, NULL),
('Luxor', 194, '2019-09-03', 334, NULL),
('Luxor', 194, '2019-09-04', 107, NULL),
('Luxor', 194, '2019-09-05', 232, NULL),
('Luxor', 194, '2019-09-06', 143, NULL),
('Luxor', 194, '2019-09-07', 149, NULL),
('Luxor', 194, '2019-09-08', 298, NULL),
('Luxor', 194, '2019-09-09', 381, NULL),
('Luxor', 194, '2019-09-10', 105, NULL),
('Luxor', 194, '2019-09-11', 200, NULL),
('Luxor', 194, '2019-09-12', 205, NULL),
('Luxor', 194, '2019-09-13', 367, NULL),
('Luxor', 194, '2019-09-14', 321, NULL),
('Luxor', 194, '2019-09-15', 134, NULL),
('Luxor', 194, '2019-09-16', 162, NULL),
('Luxor', 194, '2019-09-17', 357, NULL),
('Luxor', 194, '2019-09-18', 381, NULL),
('Luxor', 194, '2019-09-19', 391, NULL),
('Luxor', 194, '2019-09-20', 181, NULL),
('Luxor', 194, '2019-09-21', 107, NULL),
('Luxor', 194, '2019-09-22', 350, NULL),
('Luxor', 194, '2019-09-23', 312, NULL),
('Luxor', 194, '2019-09-24', 287, NULL),
('Luxor', 194, '2019-09-25', 107, NULL),
('Luxor', 194, '2019-09-26', 360, NULL),
('Luxor', 194, '2019-09-27', 220, NULL),
('Luxor', 194, '2019-09-28', 323, NULL),
('Luxor', 194, '2019-09-29', 218, NULL),
('Luxor', 194, '2019-09-30', 361, NULL),
('Luxor', 194, '2019-10-01', 252, NULL),
('Luxor', 194, '2019-10-02', 144, NULL),
('Luxor', 194, '2019-10-03', 133, NULL),
('Luxor', 194, '2019-10-04', 190, NULL),
('Luxor', 194, '2019-10-05', 228, NULL),
('Luxor', 194, '2019-10-06', 267, NULL),
('Luxor', 194, '2019-10-07', 251, NULL),
('Luxor', 194, '2019-10-08', 342, NULL),
('Luxor', 194, '2019-10-09', 149, NULL),
('Luxor', 194, '2019-10-10', 151, NULL),
('Luxor', 194, '2019-10-11', 138, NULL),
('Luxor', 194, '2019-10-12', 123, NULL),
('Luxor', 194, '2019-10-13', 178, NULL),
('Luxor', 194, '2019-10-14', 221, NULL),
('Luxor', 194, '2019-10-15', 363, NULL),
('Luxor', 194, '2019-10-16', 227, NULL),
('Luxor', 194, '2019-10-17', 273, NULL),
('Luxor', 194, '2019-10-18', 214, NULL),
('Luxor', 194, '2019-10-19', 217, NULL),
('Luxor', 194, '2019-10-20', 296, NULL),
('Luxor', 194, '2019-10-21', 380, NULL),
('Luxor', 194, '2019-10-22', 254, NULL),
('Luxor', 194, '2019-10-23', 321, NULL),
('Luxor', 194, '2019-10-24', 159, NULL),
('Luxor', 194, '2019-10-25', 320, NULL),
('Luxor', 194, '2019-10-26', 270, NULL),
('Luxor', 194, '2019-10-27', 146, NULL),
('Luxor', 194, '2019-10-28', 360, NULL),
('Luxor', 194, '2019-10-29', 246, NULL),
('Luxor', 194, '2019-10-30', 128, NULL),
('Luxor', 194, '2019-10-31', 321, NULL),
('Luxor', 194, '2019-11-01', 203, NULL),
('Luxor', 194, '2019-11-02', 103, NULL),
('Luxor', 194, '2019-11-03', 391, NULL),
('Luxor', 194, '2019-11-04', 159, NULL),
('Luxor', 194, '2019-11-05', 183, NULL),
('Luxor', 194, '2019-11-06', 144, NULL),
('Luxor', 194, '2019-11-07', 131, NULL),
('Luxor', 194, '2019-11-08', 172, NULL),
('Luxor', 194, '2019-11-09', 122, NULL),
('Luxor', 194, '2019-11-10', 135, NULL),
('Luxor', 194, '2019-11-11', 110, NULL),
('Luxor', 194, '2019-11-12', 167, NULL),
('Luxor', 194, '2019-11-13', 141, NULL),
('Luxor', 194, '2019-11-14', 372, NULL),
('Luxor', 194, '2019-11-15', 306, NULL),
('Luxor', 194, '2019-11-16', 175, NULL),
('Luxor', 194, '2019-11-17', 370, NULL),
('Luxor', 194, '2019-11-18', 302, NULL),
('Luxor', 194, '2019-11-19', 190, NULL),
('Luxor', 194, '2019-11-20', 385, NULL),
('Luxor', 194, '2019-11-21', 328, NULL),
('Luxor', 194, '2019-11-22', 297, NULL),
('Luxor', 194, '2019-11-23', 329, NULL),
('Luxor', 194, '2019-11-24', 207, NULL),
('Luxor', 194, '2019-11-25', 290, NULL),
('Luxor', 194, '2019-11-26', 191, NULL),
('Luxor', 194, '2019-11-27', 122, NULL),
('Luxor', 194, '2019-11-28', 130, NULL),
('Luxor', 194, '2019-11-29', 200, NULL),
('Luxor', 194, '2019-11-30', 155, NULL),
('Luxor', 194, '2019-12-01', 314, NULL),
('Luxor', 194, '2019-12-02', 214, NULL),
('Luxor', 194, '2019-12-03', 106, NULL),
('Luxor', 194, '2019-12-04', 284, NULL),
('Luxor', 194, '2019-12-05', 156, NULL),
('Luxor', 194, '2019-12-06', 194, NULL),
('Luxor', 194, '2019-12-07', 123, NULL),
('Luxor', 194, '2019-12-08', 173, NULL),
('Luxor', 194, '2019-12-09', 356, NULL),
('Luxor', 194, '2019-12-10', 339, NULL),
('Luxor', 194, '2019-12-11', 293, NULL),
('Luxor', 194, '2019-12-12', 373, NULL),
('Luxor', 194, '2019-12-13', 101, NULL),
('Luxor', 194, '2019-12-14', 104, NULL),
('Luxor', 194, '2019-12-15', 283, NULL),
('Luxor', 194, '2019-12-16', 274, NULL),
('Luxor', 194, '2019-12-17', 203, NULL),
('Luxor', 194, '2019-12-18', 155, NULL),
('Luxor', 194, '2019-12-19', 334, NULL),
('Luxor', 194, '2019-12-20', 142, NULL),
('Luxor', 194, '2019-12-21', 118, NULL),
('Luxor', 194, '2019-12-22', 194, NULL),
('Luxor', 194, '2019-12-23', 330, NULL),
('Luxor', 194, '2019-12-24', 121, NULL),
('Luxor', 194, '2019-12-25', 245, NULL),
('Luxor', 194, '2019-12-26', 344, NULL),
('Luxor', 194, '2019-12-27', 361, NULL),
('Luxor', 194, '2019-12-28', 216, NULL),
('Luxor', 194, '2019-12-29', 225, NULL),
('Luxor', 194, '2019-12-30', 160, NULL),
('Luxor', 194, '2019-12-31', 263, NULL),
('Luxor', 194, '2020-01-01', 378, NULL),
('Luxor', 194, '2020-01-02', 261, NULL),
('Luxor', 194, '2020-01-03', 176, NULL),
('Luxor', 194, '2020-01-04', 220, NULL),
('Luxor', 194, '2020-01-05', 112, NULL),
('Luxor', 194, '2020-01-06', 223, NULL),
('Luxor', 194, '2020-01-07', 151, NULL),
('Luxor', 194, '2020-01-08', 109, NULL),
('Luxor', 194, '2020-01-09', 298, NULL),
('Luxor', 194, '2020-01-10', 155, NULL),
('Luxor', 194, '2020-01-11', 266, NULL),
('Luxor', 194, '2020-01-12', 329, NULL),
('Luxor', 194, '2020-01-13', 355, NULL),
('Luxor', 194, '2020-01-14', 265, NULL),
('Luxor', 194, '2020-01-15', 320, NULL),
('Luxor', 194, '2020-01-16', 137, NULL),
('Luxor', 194, '2020-01-17', 359, NULL),
('Luxor', 194, '2020-01-18', 296, NULL),
('Luxor', 194, '2020-01-19', 322, NULL),
('Luxor', 194, '2020-01-20', 267, NULL),
('Luxor', 194, '2020-01-21', 154, NULL),
('Luxor', 194, '2020-01-22', 385, NULL),
('Luxor', 194, '2020-01-23', 248, NULL),
('Luxor', 194, '2020-01-24', 317, NULL),
('Luxor', 194, '2020-01-25', 165, NULL),
('Luxor', 194, '2020-01-26', 344, NULL),
('Luxor', 194, '2020-01-27', 306, NULL),
('Luxor', 194, '2020-01-28', 138, NULL),
('Luxor', 194, '2020-01-29', 225, NULL),
('Luxor', 194, '2020-01-30', 306, NULL),
('Luxor', 194, '2020-01-31', 196, NULL),
('Luxor', 194, '2020-02-01', 264, NULL),
('Luxor', 194, '2020-02-02', 278, NULL),
('Luxor', 194, '2020-02-03', 191, NULL),
('Luxor', 194, '2020-02-04', 205, NULL),
('Luxor', 214, '2019-01-01', 296, NULL),
('Luxor', 214, '2019-01-02', 267, NULL),
('Luxor', 214, '2019-01-03', 103, NULL),
('Luxor', 214, '2019-01-04', 316, NULL),
('Luxor', 214, '2019-01-05', 124, NULL),
('Luxor', 214, '2019-01-06', 134, NULL),
('Luxor', 214, '2019-01-07', 275, NULL),
('Luxor', 214, '2019-01-08', 250, NULL),
('Luxor', 214, '2019-01-09', 116, NULL),
('Luxor', 214, '2019-01-10', 381, NULL),
('Luxor', 214, '2019-01-11', 281, NULL),
('Luxor', 214, '2019-01-12', 289, NULL),
('Luxor', 214, '2019-01-13', 274, NULL),
('Luxor', 214, '2019-01-14', 172, NULL),
('Luxor', 214, '2019-01-15', 391, NULL),
('Luxor', 214, '2019-01-16', 165, NULL),
('Luxor', 214, '2019-01-17', 172, NULL),
('Luxor', 214, '2019-01-18', 395, NULL),
('Luxor', 214, '2019-01-19', 154, NULL),
('Luxor', 214, '2019-01-20', 309, NULL),
('Luxor', 214, '2019-01-21', 106, NULL),
('Luxor', 214, '2019-01-22', 336, NULL),
('Luxor', 214, '2019-01-23', 380, NULL),
('Luxor', 214, '2019-01-24', 356, NULL),
('Luxor', 214, '2019-01-25', 228, NULL),
('Luxor', 214, '2019-01-26', 317, NULL),
('Luxor', 214, '2019-01-27', 302, NULL),
('Luxor', 214, '2019-01-28', 181, NULL),
('Luxor', 214, '2019-01-29', 382, NULL),
('Luxor', 214, '2019-01-30', 277, NULL),
('Luxor', 214, '2019-01-31', 196, NULL),
('Luxor', 214, '2019-02-01', 354, NULL),
('Luxor', 214, '2019-02-02', 272, NULL),
('Luxor', 214, '2019-02-03', 132, NULL),
('Luxor', 214, '2019-02-04', 338, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 214, '2019-02-05', 148, NULL),
('Luxor', 214, '2019-02-06', 137, NULL),
('Luxor', 214, '2019-02-07', 229, NULL),
('Luxor', 214, '2019-02-08', 165, NULL),
('Luxor', 214, '2019-02-09', 136, NULL),
('Luxor', 214, '2019-02-10', 215, NULL),
('Luxor', 214, '2019-02-11', 238, NULL),
('Luxor', 214, '2019-02-12', 367, NULL),
('Luxor', 214, '2019-02-13', 193, NULL),
('Luxor', 214, '2019-02-14', 317, NULL),
('Luxor', 214, '2019-02-15', 287, NULL),
('Luxor', 214, '2019-02-16', 207, NULL),
('Luxor', 214, '2019-02-17', 138, NULL),
('Luxor', 214, '2019-02-18', 222, NULL),
('Luxor', 214, '2019-02-19', 118, NULL),
('Luxor', 214, '2019-02-20', 333, NULL),
('Luxor', 214, '2019-02-21', 224, NULL),
('Luxor', 214, '2019-02-22', 349, NULL),
('Luxor', 214, '2019-02-23', 296, NULL),
('Luxor', 214, '2019-02-24', 274, NULL),
('Luxor', 214, '2019-02-25', 366, NULL),
('Luxor', 214, '2019-02-26', 390, NULL),
('Luxor', 214, '2019-02-27', 256, NULL),
('Luxor', 214, '2019-02-28', 158, NULL),
('Luxor', 214, '2019-03-01', 355, NULL),
('Luxor', 214, '2019-03-02', 373, NULL),
('Luxor', 214, '2019-03-03', 151, NULL),
('Luxor', 214, '2019-03-04', 394, NULL),
('Luxor', 214, '2019-03-05', 212, NULL),
('Luxor', 214, '2019-03-06', 275, NULL),
('Luxor', 214, '2019-03-07', 274, NULL),
('Luxor', 214, '2019-03-08', 150, NULL),
('Luxor', 214, '2019-03-09', 352, NULL),
('Luxor', 214, '2019-03-10', 241, NULL),
('Luxor', 214, '2019-03-11', 328, NULL),
('Luxor', 214, '2019-03-12', 294, NULL),
('Luxor', 214, '2019-03-13', 138, NULL),
('Luxor', 214, '2019-03-14', 372, NULL),
('Luxor', 214, '2019-03-15', 328, NULL),
('Luxor', 214, '2019-03-16', 334, NULL),
('Luxor', 214, '2019-03-17', 272, NULL),
('Luxor', 214, '2019-03-18', 392, NULL),
('Luxor', 214, '2019-03-19', 387, NULL),
('Luxor', 214, '2019-03-20', 137, NULL),
('Luxor', 214, '2019-03-21', 285, NULL),
('Luxor', 214, '2019-03-22', 321, NULL),
('Luxor', 214, '2019-03-23', 317, NULL),
('Luxor', 214, '2019-03-24', 198, NULL),
('Luxor', 214, '2019-03-25', 285, NULL),
('Luxor', 214, '2019-03-26', 141, NULL),
('Luxor', 214, '2019-03-27', 254, NULL),
('Luxor', 214, '2019-03-28', 113, NULL),
('Luxor', 214, '2019-03-29', 163, NULL),
('Luxor', 214, '2019-03-30', 315, NULL),
('Luxor', 214, '2019-03-31', 347, NULL),
('Luxor', 214, '2019-04-01', 137, NULL),
('Luxor', 214, '2019-04-02', 225, NULL),
('Luxor', 214, '2019-04-03', 133, NULL),
('Luxor', 214, '2019-04-04', 287, NULL),
('Luxor', 214, '2019-04-05', 229, NULL),
('Luxor', 214, '2019-04-06', 364, NULL),
('Luxor', 214, '2019-04-07', 201, NULL),
('Luxor', 214, '2019-04-08', 285, NULL),
('Luxor', 214, '2019-04-09', 313, NULL),
('Luxor', 214, '2019-04-10', 350, NULL),
('Luxor', 214, '2019-04-11', 302, NULL),
('Luxor', 214, '2019-04-12', 350, NULL),
('Luxor', 214, '2019-04-13', 101, NULL),
('Luxor', 214, '2019-04-14', 301, NULL),
('Luxor', 214, '2019-04-15', 210, NULL),
('Luxor', 214, '2019-04-16', 352, NULL),
('Luxor', 214, '2019-04-17', 307, NULL),
('Luxor', 214, '2019-04-18', 351, NULL),
('Luxor', 214, '2019-04-19', 242, NULL),
('Luxor', 214, '2019-04-20', 104, NULL),
('Luxor', 214, '2019-04-21', 376, NULL),
('Luxor', 214, '2019-04-22', 188, NULL),
('Luxor', 214, '2019-04-23', 315, NULL),
('Luxor', 214, '2019-04-24', 252, NULL),
('Luxor', 214, '2019-04-25', 359, NULL),
('Luxor', 214, '2019-04-26', 153, NULL),
('Luxor', 214, '2019-04-27', 280, NULL),
('Luxor', 214, '2019-04-28', 333, NULL),
('Luxor', 214, '2019-04-29', 316, NULL),
('Luxor', 214, '2019-04-30', 228, NULL),
('Luxor', 214, '2019-05-01', 349, NULL),
('Luxor', 214, '2019-05-02', 290, NULL),
('Luxor', 214, '2019-05-03', 106, NULL),
('Luxor', 214, '2019-05-04', 281, NULL),
('Luxor', 214, '2019-05-05', 152, NULL),
('Luxor', 214, '2019-05-06', 135, NULL),
('Luxor', 214, '2019-05-07', 227, NULL),
('Luxor', 214, '2019-05-08', 284, NULL),
('Luxor', 214, '2019-05-09', 315, NULL),
('Luxor', 214, '2019-05-10', 132, NULL),
('Luxor', 214, '2019-05-11', 258, NULL),
('Luxor', 214, '2019-05-12', 129, NULL),
('Luxor', 214, '2019-05-13', 259, NULL),
('Luxor', 214, '2019-05-14', 164, NULL),
('Luxor', 214, '2019-05-15', 183, NULL),
('Luxor', 214, '2019-05-16', 307, NULL),
('Luxor', 214, '2019-05-17', 239, NULL),
('Luxor', 214, '2019-05-18', 166, NULL),
('Luxor', 214, '2019-05-19', 152, NULL),
('Luxor', 214, '2019-05-20', 285, NULL),
('Luxor', 214, '2019-05-21', 193, NULL),
('Luxor', 214, '2019-05-22', 265, NULL),
('Luxor', 214, '2019-05-23', 138, NULL),
('Luxor', 214, '2019-05-24', 341, NULL),
('Luxor', 214, '2019-05-25', 258, NULL),
('Luxor', 214, '2019-05-26', 140, NULL),
('Luxor', 214, '2019-05-27', 312, NULL),
('Luxor', 214, '2019-05-28', 144, NULL),
('Luxor', 214, '2019-05-29', 158, NULL),
('Luxor', 214, '2019-05-30', 140, NULL),
('Luxor', 214, '2019-05-31', 232, NULL),
('Luxor', 214, '2019-06-01', 240, NULL),
('Luxor', 214, '2019-06-02', 328, NULL),
('Luxor', 214, '2019-06-03', 142, NULL),
('Luxor', 214, '2019-06-04', 159, NULL),
('Luxor', 214, '2019-06-05', 327, NULL),
('Luxor', 214, '2019-06-06', 318, NULL),
('Luxor', 214, '2019-06-07', 113, NULL),
('Luxor', 214, '2019-06-08', 283, NULL),
('Luxor', 214, '2019-06-09', 257, NULL),
('Luxor', 214, '2019-06-10', 220, NULL),
('Luxor', 214, '2019-06-11', 330, NULL),
('Luxor', 214, '2019-06-12', 204, NULL),
('Luxor', 214, '2019-06-13', 331, NULL),
('Luxor', 214, '2019-06-14', 115, NULL),
('Luxor', 214, '2019-06-15', 118, NULL),
('Luxor', 214, '2019-06-16', 257, NULL),
('Luxor', 214, '2019-06-17', 333, NULL),
('Luxor', 214, '2019-06-18', 291, NULL),
('Luxor', 214, '2019-06-19', 170, NULL),
('Luxor', 214, '2019-06-20', 274, NULL),
('Luxor', 214, '2019-06-21', 257, NULL),
('Luxor', 214, '2019-06-22', 308, NULL),
('Luxor', 214, '2019-06-23', 395, NULL),
('Luxor', 214, '2019-06-24', 351, NULL),
('Luxor', 214, '2019-06-25', 347, NULL),
('Luxor', 214, '2019-06-26', 115, NULL),
('Luxor', 214, '2019-06-27', 341, NULL),
('Luxor', 214, '2019-06-28', 187, NULL),
('Luxor', 214, '2019-06-29', 247, NULL),
('Luxor', 214, '2019-06-30', 214, NULL),
('Luxor', 214, '2019-07-01', 285, NULL),
('Luxor', 214, '2019-07-02', 213, NULL),
('Luxor', 214, '2019-07-03', 138, NULL),
('Luxor', 214, '2019-07-04', 295, NULL),
('Luxor', 214, '2019-07-05', 136, NULL),
('Luxor', 214, '2019-07-06', 245, NULL),
('Luxor', 214, '2019-07-07', 242, NULL),
('Luxor', 214, '2019-07-08', 300, NULL),
('Luxor', 214, '2019-07-09', 333, NULL),
('Luxor', 214, '2019-07-10', 292, NULL),
('Luxor', 214, '2019-07-11', 148, NULL),
('Luxor', 214, '2019-07-12', 191, NULL),
('Luxor', 214, '2019-07-13', 374, NULL),
('Luxor', 214, '2019-07-14', 342, NULL),
('Luxor', 214, '2019-07-15', 304, NULL),
('Luxor', 214, '2019-07-16', 254, NULL),
('Luxor', 214, '2019-07-17', 107, NULL),
('Luxor', 214, '2019-07-18', 300, NULL),
('Luxor', 214, '2019-07-19', 138, NULL),
('Luxor', 214, '2019-07-20', 378, NULL),
('Luxor', 214, '2019-07-21', 133, NULL),
('Luxor', 214, '2019-07-22', 101, NULL),
('Luxor', 214, '2019-07-23', 249, NULL),
('Luxor', 214, '2019-07-24', 199, NULL),
('Luxor', 214, '2019-07-25', 374, NULL),
('Luxor', 214, '2019-07-26', 193, NULL),
('Luxor', 214, '2019-07-27', 307, NULL),
('Luxor', 214, '2019-07-28', 117, NULL),
('Luxor', 214, '2019-07-29', 369, NULL),
('Luxor', 214, '2019-07-30', 167, NULL),
('Luxor', 214, '2019-07-31', 110, NULL),
('Luxor', 214, '2019-08-01', 227, NULL),
('Luxor', 214, '2019-08-02', 176, NULL),
('Luxor', 214, '2019-08-03', 360, NULL),
('Luxor', 214, '2019-08-04', 229, NULL),
('Luxor', 214, '2019-08-05', 202, NULL),
('Luxor', 214, '2019-08-06', 329, NULL),
('Luxor', 214, '2019-08-07', 182, NULL),
('Luxor', 214, '2019-08-08', 346, NULL),
('Luxor', 214, '2019-08-09', 170, NULL),
('Luxor', 214, '2019-08-10', 211, NULL),
('Luxor', 214, '2019-08-11', 311, NULL),
('Luxor', 214, '2019-08-12', 361, NULL),
('Luxor', 214, '2019-08-13', 161, NULL),
('Luxor', 214, '2019-08-14', 104, NULL),
('Luxor', 214, '2019-08-15', 115, NULL),
('Luxor', 214, '2019-08-16', 187, NULL),
('Luxor', 214, '2019-08-17', 260, NULL),
('Luxor', 214, '2019-08-18', 370, NULL),
('Luxor', 214, '2019-08-19', 325, NULL),
('Luxor', 214, '2019-08-20', 142, NULL),
('Luxor', 214, '2019-08-21', 169, NULL),
('Luxor', 214, '2019-08-22', 200, NULL),
('Luxor', 214, '2019-08-23', 253, NULL),
('Luxor', 214, '2019-08-24', 130, NULL),
('Luxor', 214, '2019-08-25', 181, NULL),
('Luxor', 214, '2019-08-26', 151, NULL),
('Luxor', 214, '2019-08-27', 383, NULL),
('Luxor', 214, '2019-08-28', 113, NULL),
('Luxor', 214, '2019-08-29', 138, NULL),
('Luxor', 214, '2019-08-30', 338, NULL),
('Luxor', 214, '2019-08-31', 214, NULL),
('Luxor', 214, '2019-09-01', 220, NULL),
('Luxor', 214, '2019-09-02', 205, NULL),
('Luxor', 214, '2019-09-03', 133, NULL),
('Luxor', 214, '2019-09-04', 202, NULL),
('Luxor', 214, '2019-09-05', 199, NULL),
('Luxor', 214, '2019-09-06', 245, NULL),
('Luxor', 214, '2019-09-07', 317, NULL),
('Luxor', 214, '2019-09-08', 192, NULL),
('Luxor', 214, '2019-09-09', 356, NULL),
('Luxor', 214, '2019-09-10', 219, NULL),
('Luxor', 214, '2019-09-11', 218, NULL),
('Luxor', 214, '2019-09-12', 265, NULL),
('Luxor', 214, '2019-09-13', 247, NULL),
('Luxor', 214, '2019-09-14', 131, NULL),
('Luxor', 214, '2019-09-15', 393, NULL),
('Luxor', 214, '2019-09-16', 324, NULL),
('Luxor', 214, '2019-09-17', 175, NULL),
('Luxor', 214, '2019-09-18', 214, NULL),
('Luxor', 214, '2019-09-19', 134, NULL),
('Luxor', 214, '2019-09-20', 338, NULL),
('Luxor', 214, '2019-09-21', 393, NULL),
('Luxor', 214, '2019-09-22', 230, NULL),
('Luxor', 214, '2019-09-23', 250, NULL),
('Luxor', 214, '2019-09-24', 242, NULL),
('Luxor', 214, '2019-09-25', 369, NULL),
('Luxor', 214, '2019-09-26', 396, NULL),
('Luxor', 214, '2019-09-27', 363, NULL),
('Luxor', 214, '2019-09-28', 182, NULL),
('Luxor', 214, '2019-09-29', 358, NULL),
('Luxor', 214, '2019-09-30', 217, NULL),
('Luxor', 214, '2019-10-01', 195, NULL),
('Luxor', 214, '2019-10-02', 380, NULL),
('Luxor', 214, '2019-10-03', 132, NULL),
('Luxor', 214, '2019-10-04', 208, NULL),
('Luxor', 214, '2019-10-05', 358, NULL),
('Luxor', 214, '2019-10-06', 203, NULL),
('Luxor', 214, '2019-10-07', 277, NULL),
('Luxor', 214, '2019-10-08', 314, NULL),
('Luxor', 214, '2019-10-09', 196, NULL),
('Luxor', 214, '2019-10-10', 312, NULL),
('Luxor', 214, '2019-10-11', 385, NULL),
('Luxor', 214, '2019-10-12', 103, NULL),
('Luxor', 214, '2019-10-13', 322, NULL),
('Luxor', 214, '2019-10-14', 114, NULL),
('Luxor', 214, '2019-10-15', 175, NULL),
('Luxor', 214, '2019-10-16', 251, NULL),
('Luxor', 214, '2019-10-17', 130, NULL),
('Luxor', 214, '2019-10-18', 325, NULL),
('Luxor', 214, '2019-10-19', 280, NULL),
('Luxor', 214, '2019-10-20', 192, NULL),
('Luxor', 214, '2019-10-21', 106, NULL),
('Luxor', 214, '2019-10-22', 371, NULL),
('Luxor', 214, '2019-10-23', 204, NULL),
('Luxor', 214, '2019-10-24', 100, NULL),
('Luxor', 214, '2019-10-25', 227, NULL),
('Luxor', 214, '2019-10-26', 292, NULL),
('Luxor', 214, '2019-10-27', 269, NULL),
('Luxor', 214, '2019-10-28', 351, NULL),
('Luxor', 214, '2019-10-29', 348, NULL),
('Luxor', 214, '2019-10-30', 344, NULL),
('Luxor', 214, '2019-10-31', 274, NULL),
('Luxor', 214, '2019-11-01', 361, NULL),
('Luxor', 214, '2019-11-02', 362, NULL),
('Luxor', 214, '2019-11-03', 106, NULL),
('Luxor', 214, '2019-11-04', 262, NULL),
('Luxor', 214, '2019-11-05', 300, NULL),
('Luxor', 214, '2019-11-06', 289, NULL),
('Luxor', 214, '2019-11-07', 279, NULL),
('Luxor', 214, '2019-11-08', 246, NULL),
('Luxor', 214, '2019-11-09', 147, NULL),
('Luxor', 214, '2019-11-10', 252, NULL),
('Luxor', 214, '2019-11-11', 355, NULL),
('Luxor', 214, '2019-11-12', 291, NULL),
('Luxor', 214, '2019-11-13', 151, NULL),
('Luxor', 214, '2019-11-14', 381, NULL),
('Luxor', 214, '2019-11-15', 268, NULL),
('Luxor', 214, '2019-11-16', 284, NULL),
('Luxor', 214, '2019-11-17', 217, NULL),
('Luxor', 214, '2019-11-18', 278, NULL),
('Luxor', 214, '2019-11-19', 376, NULL),
('Luxor', 214, '2019-11-20', 344, NULL),
('Luxor', 214, '2019-11-21', 295, NULL),
('Luxor', 214, '2019-11-22', 306, NULL),
('Luxor', 214, '2019-11-23', 211, NULL),
('Luxor', 214, '2019-11-24', 247, NULL),
('Luxor', 214, '2019-11-25', 337, NULL),
('Luxor', 214, '2019-11-26', 258, NULL),
('Luxor', 214, '2019-11-27', 147, NULL),
('Luxor', 214, '2019-11-28', 120, NULL),
('Luxor', 214, '2019-11-29', 351, NULL),
('Luxor', 214, '2019-11-30', 360, NULL),
('Luxor', 214, '2019-12-01', 285, NULL),
('Luxor', 214, '2019-12-02', 143, NULL),
('Luxor', 214, '2019-12-03', 268, NULL),
('Luxor', 214, '2019-12-04', 224, NULL),
('Luxor', 214, '2019-12-05', 316, NULL),
('Luxor', 214, '2019-12-06', 285, NULL),
('Luxor', 214, '2019-12-07', 198, NULL),
('Luxor', 214, '2019-12-08', 171, NULL),
('Luxor', 214, '2019-12-09', 161, NULL),
('Luxor', 214, '2019-12-10', 225, NULL),
('Luxor', 214, '2019-12-11', 298, NULL),
('Luxor', 214, '2019-12-12', 197, NULL),
('Luxor', 214, '2019-12-13', 171, NULL),
('Luxor', 214, '2019-12-14', 333, NULL),
('Luxor', 214, '2019-12-15', 172, NULL),
('Luxor', 214, '2019-12-16', 147, NULL),
('Luxor', 214, '2019-12-17', 179, NULL),
('Luxor', 214, '2019-12-18', 155, NULL),
('Luxor', 214, '2019-12-19', 112, NULL),
('Luxor', 214, '2019-12-20', 387, NULL),
('Luxor', 214, '2019-12-21', 356, NULL),
('Luxor', 214, '2019-12-22', 348, NULL),
('Luxor', 214, '2019-12-23', 257, NULL),
('Luxor', 214, '2019-12-24', 364, NULL),
('Luxor', 214, '2019-12-25', 150, NULL),
('Luxor', 214, '2019-12-26', 213, NULL),
('Luxor', 214, '2019-12-27', 338, NULL),
('Luxor', 214, '2019-12-28', 385, NULL),
('Luxor', 214, '2019-12-29', 157, NULL),
('Luxor', 214, '2019-12-30', 269, NULL),
('Luxor', 214, '2019-12-31', 349, NULL),
('Luxor', 214, '2020-01-01', 207, NULL),
('Luxor', 214, '2020-01-02', 221, NULL),
('Luxor', 214, '2020-01-03', 267, NULL),
('Luxor', 214, '2020-01-04', 312, NULL),
('Luxor', 214, '2020-01-05', 321, NULL),
('Luxor', 214, '2020-01-06', 253, NULL),
('Luxor', 214, '2020-01-07', 215, NULL),
('Luxor', 214, '2020-01-08', 369, NULL),
('Luxor', 214, '2020-01-09', 213, NULL),
('Luxor', 214, '2020-01-10', 104, NULL),
('Luxor', 214, '2020-01-11', 226, NULL),
('Luxor', 214, '2020-01-12', 117, NULL),
('Luxor', 214, '2020-01-13', 205, NULL),
('Luxor', 214, '2020-01-14', 396, NULL),
('Luxor', 214, '2020-01-15', 317, NULL),
('Luxor', 214, '2020-01-16', 205, NULL),
('Luxor', 214, '2020-01-17', 201, NULL),
('Luxor', 214, '2020-01-18', 311, NULL),
('Luxor', 214, '2020-01-19', 158, NULL),
('Luxor', 214, '2020-01-20', 191, NULL),
('Luxor', 214, '2020-01-21', 345, NULL),
('Luxor', 214, '2020-01-22', 118, NULL),
('Luxor', 214, '2020-01-23', 323, NULL),
('Luxor', 214, '2020-01-24', 299, NULL),
('Luxor', 214, '2020-01-25', 353, NULL),
('Luxor', 214, '2020-01-26', 170, NULL),
('Luxor', 214, '2020-01-27', 352, NULL),
('Luxor', 214, '2020-01-28', 246, NULL),
('Luxor', 214, '2020-01-29', 379, NULL),
('Luxor', 214, '2020-01-30', 106, NULL),
('Luxor', 214, '2020-01-31', 345, NULL),
('Luxor', 214, '2020-02-01', 357, NULL),
('Luxor', 214, '2020-02-02', 187, NULL),
('Luxor', 214, '2020-02-03', 395, NULL),
('Luxor', 214, '2020-02-04', 118, NULL),
('Luxor', 235, '2019-01-01', 264, NULL),
('Luxor', 235, '2019-01-02', 230, NULL),
('Luxor', 235, '2019-01-03', 187, NULL),
('Luxor', 235, '2019-01-04', 310, NULL),
('Luxor', 235, '2019-01-05', 185, NULL),
('Luxor', 235, '2019-01-06', 306, NULL),
('Luxor', 235, '2019-01-07', 256, NULL),
('Luxor', 235, '2019-01-08', 381, NULL),
('Luxor', 235, '2019-01-09', 103, NULL),
('Luxor', 235, '2019-01-10', 294, NULL),
('Luxor', 235, '2019-01-11', 131, NULL),
('Luxor', 235, '2019-01-12', 349, NULL),
('Luxor', 235, '2019-01-13', 383, NULL),
('Luxor', 235, '2019-01-14', 329, NULL),
('Luxor', 235, '2019-01-15', 323, NULL),
('Luxor', 235, '2019-01-16', 154, NULL),
('Luxor', 235, '2019-01-17', 340, NULL),
('Luxor', 235, '2019-01-18', 172, NULL),
('Luxor', 235, '2019-01-19', 185, NULL),
('Luxor', 235, '2019-01-20', 164, NULL),
('Luxor', 235, '2019-01-21', 246, NULL),
('Luxor', 235, '2019-01-22', 195, NULL),
('Luxor', 235, '2019-01-23', 375, NULL),
('Luxor', 235, '2019-01-24', 337, NULL),
('Luxor', 235, '2019-01-25', 333, NULL),
('Luxor', 235, '2019-01-26', 144, NULL),
('Luxor', 235, '2019-01-27', 243, NULL),
('Luxor', 235, '2019-01-28', 341, NULL),
('Luxor', 235, '2019-01-29', 391, NULL),
('Luxor', 235, '2019-01-30', 367, NULL),
('Luxor', 235, '2019-01-31', 347, NULL),
('Luxor', 235, '2019-02-01', 376, NULL),
('Luxor', 235, '2019-02-02', 139, NULL),
('Luxor', 235, '2019-02-03', 125, NULL),
('Luxor', 235, '2019-02-04', 271, NULL),
('Luxor', 235, '2019-02-05', 197, NULL),
('Luxor', 235, '2019-02-06', 330, NULL),
('Luxor', 235, '2019-02-07', 148, NULL),
('Luxor', 235, '2019-02-08', 141, NULL),
('Luxor', 235, '2019-02-09', 166, NULL),
('Luxor', 235, '2019-02-10', 364, NULL),
('Luxor', 235, '2019-02-11', 348, NULL),
('Luxor', 235, '2019-02-12', 163, NULL),
('Luxor', 235, '2019-02-13', 126, NULL),
('Luxor', 235, '2019-02-14', 205, NULL),
('Luxor', 235, '2019-02-15', 118, NULL),
('Luxor', 235, '2019-02-16', 244, NULL),
('Luxor', 235, '2019-02-17', 228, NULL),
('Luxor', 235, '2019-02-18', 291, NULL),
('Luxor', 235, '2019-02-19', 107, NULL),
('Luxor', 235, '2019-02-20', 320, NULL),
('Luxor', 235, '2019-02-21', 369, NULL),
('Luxor', 235, '2019-02-22', 269, NULL),
('Luxor', 235, '2019-02-23', 339, NULL),
('Luxor', 235, '2019-02-24', 235, NULL),
('Luxor', 235, '2019-02-25', 389, NULL),
('Luxor', 235, '2019-02-26', 341, NULL),
('Luxor', 235, '2019-02-27', 191, NULL),
('Luxor', 235, '2019-02-28', 265, NULL),
('Luxor', 235, '2019-03-01', 112, NULL),
('Luxor', 235, '2019-03-02', 195, NULL),
('Luxor', 235, '2019-03-03', 295, NULL),
('Luxor', 235, '2019-03-04', 285, NULL),
('Luxor', 235, '2019-03-05', 351, NULL),
('Luxor', 235, '2019-03-06', 375, NULL),
('Luxor', 235, '2019-03-07', 356, NULL),
('Luxor', 235, '2019-03-08', 341, NULL),
('Luxor', 235, '2019-03-09', 304, NULL),
('Luxor', 235, '2019-03-10', 264, NULL),
('Luxor', 235, '2019-03-11', 164, NULL),
('Luxor', 235, '2019-03-12', 151, NULL),
('Luxor', 235, '2019-03-13', 378, NULL),
('Luxor', 235, '2019-03-14', 261, NULL),
('Luxor', 235, '2019-03-15', 214, NULL),
('Luxor', 235, '2019-03-16', 245, NULL),
('Luxor', 235, '2019-03-17', 143, NULL),
('Luxor', 235, '2019-03-18', 294, NULL),
('Luxor', 235, '2019-03-19', 335, NULL),
('Luxor', 235, '2019-03-20', 238, NULL),
('Luxor', 235, '2019-03-21', 105, NULL),
('Luxor', 235, '2019-03-22', 282, NULL),
('Luxor', 235, '2019-03-23', 365, NULL),
('Luxor', 235, '2019-03-24', 153, NULL),
('Luxor', 235, '2019-03-25', 109, NULL),
('Luxor', 235, '2019-03-26', 165, NULL),
('Luxor', 235, '2019-03-27', 389, NULL),
('Luxor', 235, '2019-03-28', 141, NULL),
('Luxor', 235, '2019-03-29', 171, NULL),
('Luxor', 235, '2019-03-30', 188, NULL),
('Luxor', 235, '2019-03-31', 106, NULL),
('Luxor', 235, '2019-04-01', 382, NULL),
('Luxor', 235, '2019-04-02', 109, NULL),
('Luxor', 235, '2019-04-03', 367, NULL),
('Luxor', 235, '2019-04-04', 243, NULL),
('Luxor', 235, '2019-04-05', 194, NULL),
('Luxor', 235, '2019-04-06', 279, NULL),
('Luxor', 235, '2019-04-07', 335, NULL),
('Luxor', 235, '2019-04-08', 163, NULL),
('Luxor', 235, '2019-04-09', 323, NULL),
('Luxor', 235, '2019-04-10', 218, NULL),
('Luxor', 235, '2019-04-11', 392, NULL),
('Luxor', 235, '2019-04-12', 129, NULL),
('Luxor', 235, '2019-04-13', 364, NULL),
('Luxor', 235, '2019-04-14', 336, NULL),
('Luxor', 235, '2019-04-15', 335, NULL),
('Luxor', 235, '2019-04-16', 272, NULL),
('Luxor', 235, '2019-04-17', 154, NULL),
('Luxor', 235, '2019-04-18', 243, NULL),
('Luxor', 235, '2019-04-19', 113, NULL),
('Luxor', 235, '2019-04-20', 104, NULL),
('Luxor', 235, '2019-04-21', 231, NULL),
('Luxor', 235, '2019-04-22', 366, NULL),
('Luxor', 235, '2019-04-23', 199, NULL),
('Luxor', 235, '2019-04-24', 158, NULL),
('Luxor', 235, '2019-04-25', 291, NULL),
('Luxor', 235, '2019-04-26', 155, NULL),
('Luxor', 235, '2019-04-27', 370, NULL),
('Luxor', 235, '2019-04-28', 305, NULL),
('Luxor', 235, '2019-04-29', 396, NULL),
('Luxor', 235, '2019-04-30', 234, NULL),
('Luxor', 235, '2019-05-01', 112, NULL),
('Luxor', 235, '2019-05-02', 381, NULL),
('Luxor', 235, '2019-05-03', 226, NULL),
('Luxor', 235, '2019-05-04', 320, NULL),
('Luxor', 235, '2019-05-05', 255, NULL),
('Luxor', 235, '2019-05-06', 241, NULL),
('Luxor', 235, '2019-05-07', 390, NULL),
('Luxor', 235, '2019-05-08', 335, NULL),
('Luxor', 235, '2019-05-09', 258, NULL),
('Luxor', 235, '2019-05-10', 275, NULL),
('Luxor', 235, '2019-05-11', 374, NULL),
('Luxor', 235, '2019-05-12', 356, NULL),
('Luxor', 235, '2019-05-13', 157, NULL),
('Luxor', 235, '2019-05-14', 182, NULL),
('Luxor', 235, '2019-05-15', 193, NULL),
('Luxor', 235, '2019-05-16', 203, NULL),
('Luxor', 235, '2019-05-17', 137, NULL),
('Luxor', 235, '2019-05-18', 196, NULL),
('Luxor', 235, '2019-05-19', 392, NULL),
('Luxor', 235, '2019-05-20', 291, NULL),
('Luxor', 235, '2019-05-21', 299, NULL),
('Luxor', 235, '2019-05-22', 305, NULL),
('Luxor', 235, '2019-05-23', 198, NULL),
('Luxor', 235, '2019-05-24', 154, NULL),
('Luxor', 235, '2019-05-25', 294, NULL),
('Luxor', 235, '2019-05-26', 187, NULL),
('Luxor', 235, '2019-05-27', 241, NULL),
('Luxor', 235, '2019-05-28', 108, NULL),
('Luxor', 235, '2019-05-29', 212, NULL),
('Luxor', 235, '2019-05-30', 116, NULL),
('Luxor', 235, '2019-05-31', 108, NULL),
('Luxor', 235, '2019-06-01', 299, NULL),
('Luxor', 235, '2019-06-02', 281, NULL),
('Luxor', 235, '2019-06-03', 153, NULL),
('Luxor', 235, '2019-06-04', 207, NULL),
('Luxor', 235, '2019-06-05', 313, NULL),
('Luxor', 235, '2019-06-06', 309, NULL),
('Luxor', 235, '2019-06-07', 145, NULL),
('Luxor', 235, '2019-06-08', 129, NULL),
('Luxor', 235, '2019-06-09', 205, NULL),
('Luxor', 235, '2019-06-10', 280, NULL),
('Luxor', 235, '2019-06-11', 117, NULL),
('Luxor', 235, '2019-06-12', 117, NULL),
('Luxor', 235, '2019-06-13', 181, NULL),
('Luxor', 235, '2019-06-14', 346, NULL),
('Luxor', 235, '2019-06-15', 246, NULL),
('Luxor', 235, '2019-06-16', 279, NULL),
('Luxor', 235, '2019-06-17', 138, NULL),
('Luxor', 235, '2019-06-18', 197, NULL),
('Luxor', 235, '2019-06-19', 222, NULL),
('Luxor', 235, '2019-06-20', 253, NULL),
('Luxor', 235, '2019-06-21', 380, NULL),
('Luxor', 235, '2019-06-22', 317, NULL),
('Luxor', 235, '2019-06-23', 242, NULL),
('Luxor', 235, '2019-06-24', 200, NULL),
('Luxor', 235, '2019-06-25', 215, NULL),
('Luxor', 235, '2019-06-26', 289, NULL),
('Luxor', 235, '2019-06-27', 309, NULL),
('Luxor', 235, '2019-06-28', 132, NULL),
('Luxor', 235, '2019-06-29', 282, NULL),
('Luxor', 235, '2019-06-30', 299, NULL),
('Luxor', 235, '2019-07-01', 256, NULL),
('Luxor', 235, '2019-07-02', 116, NULL),
('Luxor', 235, '2019-07-03', 174, NULL),
('Luxor', 235, '2019-07-04', 258, NULL),
('Luxor', 235, '2019-07-05', 233, NULL),
('Luxor', 235, '2019-07-06', 215, NULL),
('Luxor', 235, '2019-07-07', 338, NULL),
('Luxor', 235, '2019-07-08', 391, NULL),
('Luxor', 235, '2019-07-09', 350, NULL),
('Luxor', 235, '2019-07-10', 374, NULL),
('Luxor', 235, '2019-07-11', 142, NULL),
('Luxor', 235, '2019-07-12', 140, NULL),
('Luxor', 235, '2019-07-13', 140, NULL),
('Luxor', 235, '2019-07-14', 340, NULL),
('Luxor', 235, '2019-07-15', 345, NULL),
('Luxor', 235, '2019-07-16', 224, NULL),
('Luxor', 235, '2019-07-17', 342, NULL),
('Luxor', 235, '2019-07-18', 308, NULL),
('Luxor', 235, '2019-07-19', 308, NULL),
('Luxor', 235, '2019-07-20', 146, NULL),
('Luxor', 235, '2019-07-21', 154, NULL),
('Luxor', 235, '2019-07-22', 389, NULL),
('Luxor', 235, '2019-07-23', 357, NULL),
('Luxor', 235, '2019-07-24', 291, NULL),
('Luxor', 235, '2019-07-25', 355, NULL),
('Luxor', 235, '2019-07-26', 257, NULL),
('Luxor', 235, '2019-07-27', 249, NULL),
('Luxor', 235, '2019-07-28', 159, NULL),
('Luxor', 235, '2019-07-29', 369, NULL),
('Luxor', 235, '2019-07-30', 394, NULL),
('Luxor', 235, '2019-07-31', 394, NULL),
('Luxor', 235, '2019-08-01', 349, NULL),
('Luxor', 235, '2019-08-02', 129, NULL),
('Luxor', 235, '2019-08-03', 283, NULL),
('Luxor', 235, '2019-08-04', 197, NULL),
('Luxor', 235, '2019-08-05', 275, NULL),
('Luxor', 235, '2019-08-06', 319, NULL),
('Luxor', 235, '2019-08-07', 272, NULL),
('Luxor', 235, '2019-08-08', 261, NULL),
('Luxor', 235, '2019-08-09', 387, NULL),
('Luxor', 235, '2019-08-10', 312, NULL),
('Luxor', 235, '2019-08-11', 291, NULL),
('Luxor', 235, '2019-08-12', 184, NULL),
('Luxor', 235, '2019-08-13', 163, NULL),
('Luxor', 235, '2019-08-14', 397, NULL),
('Luxor', 235, '2019-08-15', 260, NULL),
('Luxor', 235, '2019-08-16', 105, NULL),
('Luxor', 235, '2019-08-17', 355, NULL),
('Luxor', 235, '2019-08-18', 107, NULL),
('Luxor', 235, '2019-08-19', 270, NULL),
('Luxor', 235, '2019-08-20', 125, NULL),
('Luxor', 235, '2019-08-21', 325, NULL),
('Luxor', 235, '2019-08-22', 189, NULL),
('Luxor', 235, '2019-08-23', 173, NULL),
('Luxor', 235, '2019-08-24', 258, NULL),
('Luxor', 235, '2019-08-25', 243, NULL),
('Luxor', 235, '2019-08-26', 236, NULL),
('Luxor', 235, '2019-08-27', 182, NULL),
('Luxor', 235, '2019-08-28', 179, NULL),
('Luxor', 235, '2019-08-29', 171, NULL),
('Luxor', 235, '2019-08-30', 141, NULL),
('Luxor', 235, '2019-08-31', 189, NULL),
('Luxor', 235, '2019-09-01', 306, NULL),
('Luxor', 235, '2019-09-02', 235, NULL),
('Luxor', 235, '2019-09-03', 160, NULL),
('Luxor', 235, '2019-09-04', 292, NULL),
('Luxor', 235, '2019-09-05', 200, NULL),
('Luxor', 235, '2019-09-06', 394, NULL),
('Luxor', 235, '2019-09-07', 137, NULL),
('Luxor', 235, '2019-09-08', 268, NULL),
('Luxor', 235, '2019-09-09', 238, NULL),
('Luxor', 235, '2019-09-10', 381, NULL),
('Luxor', 235, '2019-09-11', 388, NULL),
('Luxor', 235, '2019-09-12', 311, NULL),
('Luxor', 235, '2019-09-13', 333, NULL),
('Luxor', 235, '2019-09-14', 192, NULL),
('Luxor', 235, '2019-09-15', 261, NULL),
('Luxor', 235, '2019-09-16', 137, NULL),
('Luxor', 235, '2019-09-17', 306, NULL),
('Luxor', 235, '2019-09-18', 129, NULL),
('Luxor', 235, '2019-09-19', 298, NULL),
('Luxor', 235, '2019-09-20', 148, NULL),
('Luxor', 235, '2019-09-21', 344, NULL),
('Luxor', 235, '2019-09-22', 303, NULL),
('Luxor', 235, '2019-09-23', 216, NULL),
('Luxor', 235, '2019-09-24', 252, NULL),
('Luxor', 235, '2019-09-25', 225, NULL),
('Luxor', 235, '2019-09-26', 199, NULL),
('Luxor', 235, '2019-09-27', 152, NULL),
('Luxor', 235, '2019-09-28', 143, NULL),
('Luxor', 235, '2019-09-29', 136, NULL),
('Luxor', 235, '2019-09-30', 200, NULL),
('Luxor', 235, '2019-10-01', 122, NULL),
('Luxor', 235, '2019-10-02', 166, NULL),
('Luxor', 235, '2019-10-03', 163, NULL),
('Luxor', 235, '2019-10-04', 370, NULL),
('Luxor', 235, '2019-10-05', 106, NULL),
('Luxor', 235, '2019-10-06', 116, NULL),
('Luxor', 235, '2019-10-07', 231, NULL),
('Luxor', 235, '2019-10-08', 147, NULL),
('Luxor', 235, '2019-10-09', 135, NULL),
('Luxor', 235, '2019-10-10', 110, NULL),
('Luxor', 235, '2019-10-11', 211, NULL),
('Luxor', 235, '2019-10-12', 347, NULL),
('Luxor', 235, '2019-10-13', 374, NULL),
('Luxor', 235, '2019-10-14', 108, NULL),
('Luxor', 235, '2019-10-15', 289, NULL),
('Luxor', 235, '2019-10-16', 175, NULL),
('Luxor', 235, '2019-10-17', 332, NULL),
('Luxor', 235, '2019-10-18', 284, NULL),
('Luxor', 235, '2019-10-19', 349, NULL),
('Luxor', 235, '2019-10-20', 276, NULL),
('Luxor', 235, '2019-10-21', 192, NULL),
('Luxor', 235, '2019-10-22', 397, NULL),
('Luxor', 235, '2019-10-23', 257, NULL),
('Luxor', 235, '2019-10-24', 223, NULL),
('Luxor', 235, '2019-10-25', 376, NULL),
('Luxor', 235, '2019-10-26', 247, NULL),
('Luxor', 235, '2019-10-27', 209, NULL),
('Luxor', 235, '2019-10-28', 272, NULL),
('Luxor', 235, '2019-10-29', 303, NULL),
('Luxor', 235, '2019-10-30', 337, NULL),
('Luxor', 235, '2019-10-31', 306, NULL),
('Luxor', 235, '2019-11-01', 194, NULL),
('Luxor', 235, '2019-11-02', 202, NULL),
('Luxor', 235, '2019-11-03', 156, NULL),
('Luxor', 235, '2019-11-04', 133, NULL),
('Luxor', 235, '2019-11-05', 250, NULL),
('Luxor', 235, '2019-11-06', 315, NULL),
('Luxor', 235, '2019-11-07', 303, NULL),
('Luxor', 235, '2019-11-08', 316, NULL),
('Luxor', 235, '2019-11-09', 269, NULL),
('Luxor', 235, '2019-11-10', 158, NULL),
('Luxor', 235, '2019-11-11', 146, NULL),
('Luxor', 235, '2019-11-12', 252, NULL),
('Luxor', 235, '2019-11-13', 235, NULL),
('Luxor', 235, '2019-11-14', 393, NULL),
('Luxor', 235, '2019-11-15', 323, NULL),
('Luxor', 235, '2019-11-16', 199, NULL),
('Luxor', 235, '2019-11-17', 177, NULL),
('Luxor', 235, '2019-11-18', 382, NULL),
('Luxor', 235, '2019-11-19', 312, NULL),
('Luxor', 235, '2019-11-20', 163, NULL),
('Luxor', 235, '2019-11-21', 391, NULL),
('Luxor', 235, '2019-11-22', 238, NULL),
('Luxor', 235, '2019-11-23', 269, NULL),
('Luxor', 235, '2019-11-24', 212, NULL),
('Luxor', 235, '2019-11-25', 114, NULL),
('Luxor', 235, '2019-11-26', 321, NULL),
('Luxor', 235, '2019-11-27', 272, NULL),
('Luxor', 235, '2019-11-28', 113, NULL),
('Luxor', 235, '2019-11-29', 155, NULL),
('Luxor', 235, '2019-11-30', 337, NULL),
('Luxor', 235, '2019-12-01', 384, NULL),
('Luxor', 235, '2019-12-02', 274, NULL),
('Luxor', 235, '2019-12-03', 322, NULL),
('Luxor', 235, '2019-12-04', 169, NULL),
('Luxor', 235, '2019-12-05', 112, NULL),
('Luxor', 235, '2019-12-06', 144, NULL),
('Luxor', 235, '2019-12-07', 218, NULL),
('Luxor', 235, '2019-12-08', 235, NULL),
('Luxor', 235, '2019-12-09', 237, NULL),
('Luxor', 235, '2019-12-10', 306, NULL),
('Luxor', 235, '2019-12-11', 209, NULL),
('Luxor', 235, '2019-12-12', 365, NULL),
('Luxor', 235, '2019-12-13', 154, NULL),
('Luxor', 235, '2019-12-14', 355, NULL),
('Luxor', 235, '2019-12-15', 209, NULL),
('Luxor', 235, '2019-12-16', 115, NULL),
('Luxor', 235, '2019-12-17', 186, NULL),
('Luxor', 235, '2019-12-18', 213, NULL),
('Luxor', 235, '2019-12-19', 359, NULL),
('Luxor', 235, '2019-12-20', 211, NULL),
('Luxor', 235, '2019-12-21', 128, NULL),
('Luxor', 235, '2019-12-22', 161, NULL),
('Luxor', 235, '2019-12-23', 195, NULL),
('Luxor', 235, '2019-12-24', 160, NULL),
('Luxor', 235, '2019-12-25', 217, NULL),
('Luxor', 235, '2019-12-26', 235, NULL),
('Luxor', 235, '2019-12-27', 207, NULL),
('Luxor', 235, '2019-12-28', 278, NULL),
('Luxor', 235, '2019-12-29', 311, NULL),
('Luxor', 235, '2019-12-30', 167, NULL),
('Luxor', 235, '2019-12-31', 256, NULL),
('Luxor', 235, '2020-01-01', 102, NULL),
('Luxor', 235, '2020-01-02', 224, NULL),
('Luxor', 235, '2020-01-03', 108, NULL),
('Luxor', 235, '2020-01-04', 202, NULL),
('Luxor', 235, '2020-01-05', 269, NULL),
('Luxor', 235, '2020-01-06', 196, NULL),
('Luxor', 235, '2020-01-07', 220, NULL),
('Luxor', 235, '2020-01-08', 216, NULL),
('Luxor', 235, '2020-01-09', 371, NULL),
('Luxor', 235, '2020-01-10', 256, NULL),
('Luxor', 235, '2020-01-11', 232, NULL),
('Luxor', 235, '2020-01-12', 101, NULL),
('Luxor', 235, '2020-01-13', 163, NULL),
('Luxor', 235, '2020-01-14', 186, NULL),
('Luxor', 235, '2020-01-15', 227, NULL),
('Luxor', 235, '2020-01-16', 215, NULL),
('Luxor', 235, '2020-01-17', 127, NULL),
('Luxor', 235, '2020-01-18', 268, NULL),
('Luxor', 235, '2020-01-19', 327, NULL),
('Luxor', 235, '2020-01-20', 354, NULL),
('Luxor', 235, '2020-01-21', 265, NULL),
('Luxor', 235, '2020-01-22', 232, NULL),
('Luxor', 235, '2020-01-23', 173, NULL),
('Luxor', 235, '2020-01-24', 144, NULL),
('Luxor', 235, '2020-01-25', 270, NULL),
('Luxor', 235, '2020-01-26', 319, NULL),
('Luxor', 235, '2020-01-27', 142, NULL),
('Luxor', 235, '2020-01-28', 117, NULL),
('Luxor', 235, '2020-01-29', 218, NULL),
('Luxor', 235, '2020-01-30', 111, NULL),
('Luxor', 235, '2020-01-31', 135, NULL),
('Luxor', 235, '2020-02-01', 295, NULL),
('Luxor', 235, '2020-02-02', 303, NULL),
('Luxor', 235, '2020-02-03', 103, NULL),
('Luxor', 235, '2020-02-04', 178, NULL),
('Luxor', 237, '2019-01-01', 331, NULL),
('Luxor', 237, '2019-01-02', 251, NULL),
('Luxor', 237, '2019-01-03', 224, NULL),
('Luxor', 237, '2019-01-04', 204, NULL),
('Luxor', 237, '2019-01-05', 154, NULL),
('Luxor', 237, '2019-01-06', 129, NULL),
('Luxor', 237, '2019-01-07', 353, NULL),
('Luxor', 237, '2019-01-08', 155, NULL),
('Luxor', 237, '2019-01-09', 368, NULL),
('Luxor', 237, '2019-01-10', 230, NULL),
('Luxor', 237, '2019-01-11', 313, NULL),
('Luxor', 237, '2019-01-12', 176, NULL),
('Luxor', 237, '2019-01-13', 397, NULL),
('Luxor', 237, '2019-01-14', 127, NULL),
('Luxor', 237, '2019-01-15', 340, NULL),
('Luxor', 237, '2019-01-16', 174, NULL),
('Luxor', 237, '2019-01-17', 186, NULL),
('Luxor', 237, '2019-01-18', 178, NULL),
('Luxor', 237, '2019-01-19', 367, NULL),
('Luxor', 237, '2019-01-20', 394, NULL),
('Luxor', 237, '2019-01-21', 211, NULL),
('Luxor', 237, '2019-01-22', 168, NULL),
('Luxor', 237, '2019-01-23', 337, NULL),
('Luxor', 237, '2019-01-24', 215, NULL),
('Luxor', 237, '2019-01-25', 284, NULL),
('Luxor', 237, '2019-01-26', 268, NULL),
('Luxor', 237, '2019-01-27', 208, NULL),
('Luxor', 237, '2019-01-28', 164, NULL),
('Luxor', 237, '2019-01-29', 109, NULL),
('Luxor', 237, '2019-01-30', 307, NULL),
('Luxor', 237, '2019-01-31', 149, NULL),
('Luxor', 237, '2019-02-01', 117, NULL),
('Luxor', 237, '2019-02-02', 376, NULL),
('Luxor', 237, '2019-02-03', 129, NULL),
('Luxor', 237, '2019-02-04', 243, NULL),
('Luxor', 237, '2019-02-05', 141, NULL),
('Luxor', 237, '2019-02-06', 242, NULL),
('Luxor', 237, '2019-02-07', 253, NULL),
('Luxor', 237, '2019-02-08', 109, NULL),
('Luxor', 237, '2019-02-09', 323, NULL),
('Luxor', 237, '2019-02-10', 177, NULL),
('Luxor', 237, '2019-02-11', 328, NULL),
('Luxor', 237, '2019-02-12', 212, NULL),
('Luxor', 237, '2019-02-13', 252, NULL),
('Luxor', 237, '2019-02-14', 275, NULL),
('Luxor', 237, '2019-02-15', 229, NULL),
('Luxor', 237, '2019-02-16', 200, NULL),
('Luxor', 237, '2019-02-17', 324, NULL),
('Luxor', 237, '2019-02-18', 390, NULL),
('Luxor', 237, '2019-02-19', 382, NULL),
('Luxor', 237, '2019-02-20', 204, NULL),
('Luxor', 237, '2019-02-21', 171, NULL),
('Luxor', 237, '2019-02-22', 201, NULL),
('Luxor', 237, '2019-02-23', 108, NULL),
('Luxor', 237, '2019-02-24', 256, NULL),
('Luxor', 237, '2019-02-25', 147, NULL),
('Luxor', 237, '2019-02-26', 135, NULL),
('Luxor', 237, '2019-02-27', 384, NULL),
('Luxor', 237, '2019-02-28', 151, NULL),
('Luxor', 237, '2019-03-01', 297, NULL),
('Luxor', 237, '2019-03-02', 355, NULL),
('Luxor', 237, '2019-03-03', 321, NULL),
('Luxor', 237, '2019-03-04', 144, NULL),
('Luxor', 237, '2019-03-05', 120, NULL),
('Luxor', 237, '2019-03-06', 349, NULL),
('Luxor', 237, '2019-03-07', 260, NULL),
('Luxor', 237, '2019-03-08', 255, NULL),
('Luxor', 237, '2019-03-09', 365, NULL),
('Luxor', 237, '2019-03-10', 196, NULL),
('Luxor', 237, '2019-03-11', 337, NULL),
('Luxor', 237, '2019-03-12', 373, NULL),
('Luxor', 237, '2019-03-13', 177, NULL),
('Luxor', 237, '2019-03-14', 388, NULL),
('Luxor', 237, '2019-03-15', 287, NULL),
('Luxor', 237, '2019-03-16', 124, NULL),
('Luxor', 237, '2019-03-17', 102, NULL),
('Luxor', 237, '2019-03-18', 193, NULL),
('Luxor', 237, '2019-03-19', 114, NULL),
('Luxor', 237, '2019-03-20', 377, NULL),
('Luxor', 237, '2019-03-21', 172, NULL),
('Luxor', 237, '2019-03-22', 347, NULL),
('Luxor', 237, '2019-03-23', 173, NULL),
('Luxor', 237, '2019-03-24', 369, NULL),
('Luxor', 237, '2019-03-25', 189, NULL),
('Luxor', 237, '2019-03-26', 301, NULL),
('Luxor', 237, '2019-03-27', 185, NULL),
('Luxor', 237, '2019-03-28', 264, NULL),
('Luxor', 237, '2019-03-29', 267, NULL),
('Luxor', 237, '2019-03-30', 194, NULL),
('Luxor', 237, '2019-03-31', 289, NULL),
('Luxor', 237, '2019-04-01', 199, NULL),
('Luxor', 237, '2019-04-02', 368, NULL),
('Luxor', 237, '2019-04-03', 138, NULL),
('Luxor', 237, '2019-04-04', 256, NULL),
('Luxor', 237, '2019-04-05', 182, NULL),
('Luxor', 237, '2019-04-06', 202, NULL),
('Luxor', 237, '2019-04-07', 375, NULL),
('Luxor', 237, '2019-04-08', 160, NULL),
('Luxor', 237, '2019-04-09', 277, NULL),
('Luxor', 237, '2019-04-10', 240, NULL),
('Luxor', 237, '2019-04-11', 357, NULL),
('Luxor', 237, '2019-04-12', 397, NULL),
('Luxor', 237, '2019-04-13', 219, NULL),
('Luxor', 237, '2019-04-14', 375, NULL),
('Luxor', 237, '2019-04-15', 343, NULL),
('Luxor', 237, '2019-04-16', 203, NULL),
('Luxor', 237, '2019-04-17', 348, NULL),
('Luxor', 237, '2019-04-18', 362, NULL),
('Luxor', 237, '2019-04-19', 340, NULL),
('Luxor', 237, '2019-04-20', 110, NULL),
('Luxor', 237, '2019-04-21', 229, NULL),
('Luxor', 237, '2019-04-22', 267, NULL),
('Luxor', 237, '2019-04-23', 250, NULL),
('Luxor', 237, '2019-04-24', 235, NULL),
('Luxor', 237, '2019-04-25', 281, NULL),
('Luxor', 237, '2019-04-26', 214, NULL),
('Luxor', 237, '2019-04-27', 310, NULL),
('Luxor', 237, '2019-04-28', 124, NULL),
('Luxor', 237, '2019-04-29', 334, NULL),
('Luxor', 237, '2019-04-30', 385, NULL),
('Luxor', 237, '2019-05-01', 312, NULL),
('Luxor', 237, '2019-05-02', 334, NULL),
('Luxor', 237, '2019-05-03', 116, NULL),
('Luxor', 237, '2019-05-04', 360, NULL),
('Luxor', 237, '2019-05-05', 117, NULL),
('Luxor', 237, '2019-05-06', 102, NULL),
('Luxor', 237, '2019-05-07', 266, NULL),
('Luxor', 237, '2019-05-08', 124, NULL),
('Luxor', 237, '2019-05-09', 246, NULL),
('Luxor', 237, '2019-05-10', 281, NULL),
('Luxor', 237, '2019-05-11', 398, NULL),
('Luxor', 237, '2019-05-12', 396, NULL),
('Luxor', 237, '2019-05-13', 208, NULL),
('Luxor', 237, '2019-05-14', 320, NULL),
('Luxor', 237, '2019-05-15', 317, NULL),
('Luxor', 237, '2019-05-16', 294, NULL),
('Luxor', 237, '2019-05-17', 169, NULL),
('Luxor', 237, '2019-05-18', 382, NULL),
('Luxor', 237, '2019-05-19', 205, NULL),
('Luxor', 237, '2019-05-20', 203, NULL),
('Luxor', 237, '2019-05-21', 219, NULL),
('Luxor', 237, '2019-05-22', 329, NULL),
('Luxor', 237, '2019-05-23', 179, NULL),
('Luxor', 237, '2019-05-24', 249, NULL),
('Luxor', 237, '2019-05-25', 297, NULL),
('Luxor', 237, '2019-05-26', 116, NULL),
('Luxor', 237, '2019-05-27', 169, NULL),
('Luxor', 237, '2019-05-28', 307, NULL),
('Luxor', 237, '2019-05-29', 187, NULL),
('Luxor', 237, '2019-05-30', 360, NULL),
('Luxor', 237, '2019-05-31', 342, NULL),
('Luxor', 237, '2019-06-01', 374, NULL),
('Luxor', 237, '2019-06-02', 322, NULL),
('Luxor', 237, '2019-06-03', 239, NULL),
('Luxor', 237, '2019-06-04', 160, NULL),
('Luxor', 237, '2019-06-05', 185, NULL),
('Luxor', 237, '2019-06-06', 192, NULL),
('Luxor', 237, '2019-06-07', 284, NULL),
('Luxor', 237, '2019-06-08', 293, NULL),
('Luxor', 237, '2019-06-09', 157, NULL),
('Luxor', 237, '2019-06-10', 338, NULL),
('Luxor', 237, '2019-06-11', 396, NULL),
('Luxor', 237, '2019-06-12', 176, NULL),
('Luxor', 237, '2019-06-13', 114, NULL),
('Luxor', 237, '2019-06-14', 382, NULL),
('Luxor', 237, '2019-06-15', 178, NULL),
('Luxor', 237, '2019-06-16', 226, NULL),
('Luxor', 237, '2019-06-17', 191, NULL),
('Luxor', 237, '2019-06-18', 314, NULL),
('Luxor', 237, '2019-06-19', 200, NULL),
('Luxor', 237, '2019-06-20', 343, NULL),
('Luxor', 237, '2019-06-21', 127, NULL),
('Luxor', 237, '2019-06-22', 262, NULL),
('Luxor', 237, '2019-06-23', 226, NULL),
('Luxor', 237, '2019-06-24', 149, NULL),
('Luxor', 237, '2019-06-25', 235, NULL),
('Luxor', 237, '2019-06-26', 399, NULL),
('Luxor', 237, '2019-06-27', 124, NULL),
('Luxor', 237, '2019-06-28', 302, NULL),
('Luxor', 237, '2019-06-29', 268, NULL),
('Luxor', 237, '2019-06-30', 154, NULL),
('Luxor', 237, '2019-07-01', 326, NULL),
('Luxor', 237, '2019-07-02', 145, NULL),
('Luxor', 237, '2019-07-03', 357, NULL),
('Luxor', 237, '2019-07-04', 307, NULL),
('Luxor', 237, '2019-07-05', 360, NULL),
('Luxor', 237, '2019-07-06', 237, NULL),
('Luxor', 237, '2019-07-07', 264, NULL),
('Luxor', 237, '2019-07-08', 356, NULL),
('Luxor', 237, '2019-07-09', 350, NULL),
('Luxor', 237, '2019-07-10', 297, NULL),
('Luxor', 237, '2019-07-11', 170, NULL),
('Luxor', 237, '2019-07-12', 328, NULL),
('Luxor', 237, '2019-07-13', 376, NULL),
('Luxor', 237, '2019-07-14', 276, NULL),
('Luxor', 237, '2019-07-15', 114, NULL),
('Luxor', 237, '2019-07-16', 261, NULL),
('Luxor', 237, '2019-07-17', 388, NULL),
('Luxor', 237, '2019-07-18', 240, NULL),
('Luxor', 237, '2019-07-19', 127, NULL),
('Luxor', 237, '2019-07-20', 398, NULL),
('Luxor', 237, '2019-07-21', 269, NULL),
('Luxor', 237, '2019-07-22', 342, NULL),
('Luxor', 237, '2019-07-23', 342, NULL),
('Luxor', 237, '2019-07-24', 158, NULL),
('Luxor', 237, '2019-07-25', 255, NULL),
('Luxor', 237, '2019-07-26', 307, NULL),
('Luxor', 237, '2019-07-27', 223, NULL),
('Luxor', 237, '2019-07-28', 342, NULL),
('Luxor', 237, '2019-07-29', 337, NULL),
('Luxor', 237, '2019-07-30', 169, NULL),
('Luxor', 237, '2019-07-31', 340, NULL),
('Luxor', 237, '2019-08-01', 366, NULL),
('Luxor', 237, '2019-08-02', 316, NULL),
('Luxor', 237, '2019-08-03', 236, NULL),
('Luxor', 237, '2019-08-04', 198, NULL),
('Luxor', 237, '2019-08-05', 371, NULL),
('Luxor', 237, '2019-08-06', 210, NULL),
('Luxor', 237, '2019-08-07', 116, NULL),
('Luxor', 237, '2019-08-08', 166, NULL),
('Luxor', 237, '2019-08-09', 129, NULL),
('Luxor', 237, '2019-08-10', 226, NULL),
('Luxor', 237, '2019-08-11', 123, NULL),
('Luxor', 237, '2019-08-12', 338, NULL),
('Luxor', 237, '2019-08-13', 232, NULL),
('Luxor', 237, '2019-08-14', 372, NULL),
('Luxor', 237, '2019-08-15', 259, NULL),
('Luxor', 237, '2019-08-16', 161, NULL),
('Luxor', 237, '2019-08-17', 294, NULL),
('Luxor', 237, '2019-08-18', 226, NULL),
('Luxor', 237, '2019-08-19', 278, NULL),
('Luxor', 237, '2019-08-20', 102, NULL),
('Luxor', 237, '2019-08-21', 117, NULL),
('Luxor', 237, '2019-08-22', 242, NULL),
('Luxor', 237, '2019-08-23', 308, NULL),
('Luxor', 237, '2019-08-24', 201, NULL),
('Luxor', 237, '2019-08-25', 275, NULL),
('Luxor', 237, '2019-08-26', 329, NULL),
('Luxor', 237, '2019-08-27', 261, NULL),
('Luxor', 237, '2019-08-28', 156, NULL),
('Luxor', 237, '2019-08-29', 343, NULL),
('Luxor', 237, '2019-08-30', 191, NULL),
('Luxor', 237, '2019-08-31', 205, NULL),
('Luxor', 237, '2019-09-01', 174, NULL),
('Luxor', 237, '2019-09-02', 162, NULL),
('Luxor', 237, '2019-09-03', 302, NULL),
('Luxor', 237, '2019-09-04', 153, NULL),
('Luxor', 237, '2019-09-05', 303, NULL),
('Luxor', 237, '2019-09-06', 235, NULL),
('Luxor', 237, '2019-09-07', 236, NULL),
('Luxor', 237, '2019-09-08', 363, NULL),
('Luxor', 237, '2019-09-09', 324, NULL),
('Luxor', 237, '2019-09-10', 250, NULL),
('Luxor', 237, '2019-09-11', 289, NULL),
('Luxor', 237, '2019-09-12', 361, NULL),
('Luxor', 237, '2019-09-13', 224, NULL),
('Luxor', 237, '2019-09-14', 168, NULL),
('Luxor', 237, '2019-09-15', 328, NULL),
('Luxor', 237, '2019-09-16', 212, NULL),
('Luxor', 237, '2019-09-17', 304, NULL),
('Luxor', 237, '2019-09-18', 202, NULL),
('Luxor', 237, '2019-09-19', 386, NULL),
('Luxor', 237, '2019-09-20', 227, NULL),
('Luxor', 237, '2019-09-21', 141, NULL),
('Luxor', 237, '2019-09-22', 124, NULL),
('Luxor', 237, '2019-09-23', 228, NULL),
('Luxor', 237, '2019-09-24', 135, NULL),
('Luxor', 237, '2019-09-25', 219, NULL),
('Luxor', 237, '2019-09-26', 309, NULL),
('Luxor', 237, '2019-09-27', 175, NULL),
('Luxor', 237, '2019-09-28', 369, NULL),
('Luxor', 237, '2019-09-29', 107, NULL),
('Luxor', 237, '2019-09-30', 253, NULL),
('Luxor', 237, '2019-10-01', 226, NULL),
('Luxor', 237, '2019-10-02', 191, NULL),
('Luxor', 237, '2019-10-03', 318, NULL),
('Luxor', 237, '2019-10-04', 227, NULL),
('Luxor', 237, '2019-10-05', 258, NULL),
('Luxor', 237, '2019-10-06', 172, NULL),
('Luxor', 237, '2019-10-07', 225, NULL),
('Luxor', 237, '2019-10-08', 291, NULL),
('Luxor', 237, '2019-10-09', 288, NULL),
('Luxor', 237, '2019-10-10', 112, NULL),
('Luxor', 237, '2019-10-11', 100, NULL),
('Luxor', 237, '2019-10-12', 127, NULL),
('Luxor', 237, '2019-10-13', 206, NULL),
('Luxor', 237, '2019-10-14', 397, NULL),
('Luxor', 237, '2019-10-15', 219, NULL),
('Luxor', 237, '2019-10-16', 321, NULL),
('Luxor', 237, '2019-10-17', 269, NULL),
('Luxor', 237, '2019-10-18', 344, NULL),
('Luxor', 237, '2019-10-19', 204, NULL),
('Luxor', 237, '2019-10-20', 104, NULL),
('Luxor', 237, '2019-10-21', 239, NULL),
('Luxor', 237, '2019-10-22', 171, NULL),
('Luxor', 237, '2019-10-23', 272, NULL),
('Luxor', 237, '2019-10-24', 115, NULL),
('Luxor', 237, '2019-10-25', 200, NULL),
('Luxor', 237, '2019-10-26', 261, NULL),
('Luxor', 237, '2019-10-27', 138, NULL),
('Luxor', 237, '2019-10-28', 211, NULL),
('Luxor', 237, '2019-10-29', 370, NULL),
('Luxor', 237, '2019-10-30', 253, NULL),
('Luxor', 237, '2019-10-31', 309, NULL),
('Luxor', 237, '2019-11-01', 389, NULL),
('Luxor', 237, '2019-11-02', 125, NULL),
('Luxor', 237, '2019-11-03', 362, NULL),
('Luxor', 237, '2019-11-04', 380, NULL),
('Luxor', 237, '2019-11-05', 253, NULL),
('Luxor', 237, '2019-11-06', 309, NULL),
('Luxor', 237, '2019-11-07', 278, NULL),
('Luxor', 237, '2019-11-08', 140, NULL),
('Luxor', 237, '2019-11-09', 205, NULL),
('Luxor', 237, '2019-11-10', 232, NULL),
('Luxor', 237, '2019-11-11', 167, NULL),
('Luxor', 237, '2019-11-12', 290, NULL),
('Luxor', 237, '2019-11-13', 320, NULL),
('Luxor', 237, '2019-11-14', 121, NULL),
('Luxor', 237, '2019-11-15', 110, NULL),
('Luxor', 237, '2019-11-16', 342, NULL),
('Luxor', 237, '2019-11-17', 134, NULL),
('Luxor', 237, '2019-11-18', 376, NULL),
('Luxor', 237, '2019-11-19', 332, NULL),
('Luxor', 237, '2019-11-20', 287, NULL),
('Luxor', 237, '2019-11-21', 370, NULL),
('Luxor', 237, '2019-11-22', 175, NULL),
('Luxor', 237, '2019-11-23', 313, NULL),
('Luxor', 237, '2019-11-24', 219, NULL),
('Luxor', 237, '2019-11-25', 361, NULL),
('Luxor', 237, '2019-11-26', 128, NULL),
('Luxor', 237, '2019-11-27', 218, NULL),
('Luxor', 237, '2019-11-28', 104, NULL),
('Luxor', 237, '2019-11-29', 223, NULL),
('Luxor', 237, '2019-11-30', 203, NULL),
('Luxor', 237, '2019-12-01', 364, NULL),
('Luxor', 237, '2019-12-02', 243, NULL),
('Luxor', 237, '2019-12-03', 105, NULL),
('Luxor', 237, '2019-12-04', 372, NULL),
('Luxor', 237, '2019-12-05', 111, NULL),
('Luxor', 237, '2019-12-06', 368, NULL),
('Luxor', 237, '2019-12-07', 398, NULL),
('Luxor', 237, '2019-12-08', 262, NULL),
('Luxor', 237, '2019-12-09', 300, NULL),
('Luxor', 237, '2019-12-10', 159, NULL),
('Luxor', 237, '2019-12-11', 355, NULL),
('Luxor', 237, '2019-12-12', 235, NULL),
('Luxor', 237, '2019-12-13', 159, NULL),
('Luxor', 237, '2019-12-14', 377, NULL),
('Luxor', 237, '2019-12-15', 133, NULL),
('Luxor', 237, '2019-12-16', 334, NULL),
('Luxor', 237, '2019-12-17', 294, NULL),
('Luxor', 237, '2019-12-18', 200, NULL),
('Luxor', 237, '2019-12-19', 159, NULL),
('Luxor', 237, '2019-12-20', 396, NULL),
('Luxor', 237, '2019-12-21', 373, NULL),
('Luxor', 237, '2019-12-22', 261, NULL),
('Luxor', 237, '2019-12-23', 104, NULL),
('Luxor', 237, '2019-12-24', 207, NULL),
('Luxor', 237, '2019-12-25', 236, NULL),
('Luxor', 237, '2019-12-26', 136, NULL),
('Luxor', 237, '2019-12-27', 222, NULL),
('Luxor', 237, '2019-12-28', 137, NULL),
('Luxor', 237, '2019-12-29', 385, NULL),
('Luxor', 237, '2019-12-30', 227, NULL),
('Luxor', 237, '2019-12-31', 132, NULL),
('Luxor', 237, '2020-01-01', 392, NULL),
('Luxor', 237, '2020-01-02', 357, NULL),
('Luxor', 237, '2020-01-03', 239, NULL),
('Luxor', 237, '2020-01-04', 272, NULL),
('Luxor', 237, '2020-01-05', 283, NULL),
('Luxor', 237, '2020-01-06', 123, NULL),
('Luxor', 237, '2020-01-07', 357, NULL),
('Luxor', 237, '2020-01-08', 177, NULL),
('Luxor', 237, '2020-01-09', 215, NULL),
('Luxor', 237, '2020-01-10', 267, NULL),
('Luxor', 237, '2020-01-11', 383, NULL),
('Luxor', 237, '2020-01-12', 355, NULL),
('Luxor', 237, '2020-01-13', 101, NULL),
('Luxor', 237, '2020-01-14', 242, NULL),
('Luxor', 237, '2020-01-15', 383, NULL),
('Luxor', 237, '2020-01-16', 359, NULL),
('Luxor', 237, '2020-01-17', 234, NULL),
('Luxor', 237, '2020-01-18', 309, NULL),
('Luxor', 237, '2020-01-19', 163, NULL),
('Luxor', 237, '2020-01-20', 196, NULL),
('Luxor', 237, '2020-01-21', 190, NULL),
('Luxor', 237, '2020-01-22', 110, NULL),
('Luxor', 237, '2020-01-23', 397, NULL),
('Luxor', 237, '2020-01-24', 324, NULL),
('Luxor', 237, '2020-01-25', 191, NULL),
('Luxor', 237, '2020-01-26', 385, NULL),
('Luxor', 237, '2020-01-27', 157, NULL),
('Luxor', 237, '2020-01-28', 348, NULL),
('Luxor', 237, '2020-01-29', 156, NULL),
('Luxor', 237, '2020-01-30', 139, NULL),
('Luxor', 237, '2020-01-31', 141, NULL),
('Luxor', 237, '2020-02-01', 303, NULL),
('Luxor', 237, '2020-02-02', 254, NULL),
('Luxor', 237, '2020-02-03', 131, NULL),
('Luxor', 237, '2020-02-04', 136, NULL),
('Luxor', 241, '2019-01-01', 163, NULL),
('Luxor', 241, '2019-01-02', 165, NULL),
('Luxor', 241, '2019-01-03', 162, NULL),
('Luxor', 241, '2019-01-04', 289, NULL),
('Luxor', 241, '2019-01-05', 114, NULL),
('Luxor', 241, '2019-01-06', 226, NULL),
('Luxor', 241, '2019-01-07', 299, NULL),
('Luxor', 241, '2019-01-08', 134, NULL),
('Luxor', 241, '2019-01-09', 231, NULL),
('Luxor', 241, '2019-01-10', 166, NULL),
('Luxor', 241, '2019-01-11', 174, NULL),
('Luxor', 241, '2019-01-12', 334, NULL),
('Luxor', 241, '2019-01-13', 133, NULL),
('Luxor', 241, '2019-01-14', 150, NULL),
('Luxor', 241, '2019-01-15', 334, NULL),
('Luxor', 241, '2019-01-16', 309, NULL),
('Luxor', 241, '2019-01-17', 110, NULL),
('Luxor', 241, '2019-01-18', 275, NULL),
('Luxor', 241, '2019-01-19', 279, NULL),
('Luxor', 241, '2019-01-20', 180, NULL),
('Luxor', 241, '2019-01-21', 216, NULL),
('Luxor', 241, '2019-01-22', 156, NULL),
('Luxor', 241, '2019-01-23', 160, NULL),
('Luxor', 241, '2019-01-24', 266, NULL),
('Luxor', 241, '2019-01-25', 320, NULL),
('Luxor', 241, '2019-01-26', 209, NULL),
('Luxor', 241, '2019-01-27', 210, NULL),
('Luxor', 241, '2019-01-28', 297, NULL),
('Luxor', 241, '2019-01-29', 173, NULL),
('Luxor', 241, '2019-01-30', 334, NULL),
('Luxor', 241, '2019-01-31', 203, NULL),
('Luxor', 241, '2019-02-01', 257, NULL),
('Luxor', 241, '2019-02-02', 165, NULL),
('Luxor', 241, '2019-02-03', 172, NULL),
('Luxor', 241, '2019-02-04', 303, NULL),
('Luxor', 241, '2019-02-05', 315, NULL),
('Luxor', 241, '2019-02-06', 118, NULL),
('Luxor', 241, '2019-02-07', 121, NULL),
('Luxor', 241, '2019-02-08', 325, NULL),
('Luxor', 241, '2019-02-09', 118, NULL),
('Luxor', 241, '2019-02-10', 292, NULL),
('Luxor', 241, '2019-02-11', 195, NULL),
('Luxor', 241, '2019-02-12', 173, NULL),
('Luxor', 241, '2019-02-13', 182, NULL),
('Luxor', 241, '2019-02-14', 361, NULL),
('Luxor', 241, '2019-02-15', 393, NULL),
('Luxor', 241, '2019-02-16', 166, NULL),
('Luxor', 241, '2019-02-17', 237, NULL),
('Luxor', 241, '2019-02-18', 377, NULL),
('Luxor', 241, '2019-02-19', 290, NULL),
('Luxor', 241, '2019-02-20', 259, NULL),
('Luxor', 241, '2019-02-21', 251, NULL),
('Luxor', 241, '2019-02-22', 398, NULL),
('Luxor', 241, '2019-02-23', 322, NULL),
('Luxor', 241, '2019-02-24', 177, NULL),
('Luxor', 241, '2019-02-25', 367, NULL),
('Luxor', 241, '2019-02-26', 151, NULL),
('Luxor', 241, '2019-02-27', 348, NULL),
('Luxor', 241, '2019-02-28', 159, NULL),
('Luxor', 241, '2019-03-01', 149, NULL),
('Luxor', 241, '2019-03-02', 192, NULL),
('Luxor', 241, '2019-03-03', 322, NULL),
('Luxor', 241, '2019-03-04', 366, NULL),
('Luxor', 241, '2019-03-05', 346, NULL),
('Luxor', 241, '2019-03-06', 219, NULL),
('Luxor', 241, '2019-03-07', 131, NULL),
('Luxor', 241, '2019-03-08', 153, NULL),
('Luxor', 241, '2019-03-09', 214, NULL),
('Luxor', 241, '2019-03-10', 389, NULL),
('Luxor', 241, '2019-03-11', 194, NULL),
('Luxor', 241, '2019-03-12', 113, NULL),
('Luxor', 241, '2019-03-13', 249, NULL),
('Luxor', 241, '2019-03-14', 160, NULL),
('Luxor', 241, '2019-03-15', 395, NULL),
('Luxor', 241, '2019-03-16', 386, NULL),
('Luxor', 241, '2019-03-17', 280, NULL),
('Luxor', 241, '2019-03-18', 287, NULL),
('Luxor', 241, '2019-03-19', 367, NULL),
('Luxor', 241, '2019-03-20', 172, NULL),
('Luxor', 241, '2019-03-21', 144, NULL),
('Luxor', 241, '2019-03-22', 189, NULL),
('Luxor', 241, '2019-03-23', 270, NULL),
('Luxor', 241, '2019-03-24', 388, NULL),
('Luxor', 241, '2019-03-25', 221, NULL),
('Luxor', 241, '2019-03-26', 312, NULL),
('Luxor', 241, '2019-03-27', 260, NULL),
('Luxor', 241, '2019-03-28', 198, NULL),
('Luxor', 241, '2019-03-29', 123, NULL),
('Luxor', 241, '2019-03-30', 309, NULL),
('Luxor', 241, '2019-03-31', 127, NULL),
('Luxor', 241, '2019-04-01', 350, NULL),
('Luxor', 241, '2019-04-02', 216, NULL),
('Luxor', 241, '2019-04-03', 386, NULL),
('Luxor', 241, '2019-04-04', 152, NULL),
('Luxor', 241, '2019-04-05', 227, NULL),
('Luxor', 241, '2019-04-06', 376, NULL),
('Luxor', 241, '2019-04-07', 168, NULL),
('Luxor', 241, '2019-04-08', 213, NULL),
('Luxor', 241, '2019-04-09', 316, NULL),
('Luxor', 241, '2019-04-10', 148, NULL),
('Luxor', 241, '2019-04-11', 207, NULL),
('Luxor', 241, '2019-04-12', 297, NULL),
('Luxor', 241, '2019-04-13', 203, NULL),
('Luxor', 241, '2019-04-14', 170, NULL),
('Luxor', 241, '2019-04-15', 314, NULL),
('Luxor', 241, '2019-04-16', 398, NULL),
('Luxor', 241, '2019-04-17', 276, NULL),
('Luxor', 241, '2019-04-18', 382, NULL),
('Luxor', 241, '2019-04-19', 363, NULL),
('Luxor', 241, '2019-04-20', 138, NULL),
('Luxor', 241, '2019-04-21', 351, NULL),
('Luxor', 241, '2019-04-22', 138, NULL),
('Luxor', 241, '2019-04-23', 255, NULL),
('Luxor', 241, '2019-04-24', 300, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 241, '2019-04-25', 132, NULL),
('Luxor', 241, '2019-04-26', 205, NULL),
('Luxor', 241, '2019-04-27', 339, NULL),
('Luxor', 241, '2019-04-28', 207, NULL),
('Luxor', 241, '2019-04-29', 382, NULL),
('Luxor', 241, '2019-04-30', 226, NULL),
('Luxor', 241, '2019-05-01', 225, NULL),
('Luxor', 241, '2019-05-02', 128, NULL),
('Luxor', 241, '2019-05-03', 103, NULL),
('Luxor', 241, '2019-05-04', 137, NULL),
('Luxor', 241, '2019-05-05', 320, NULL),
('Luxor', 241, '2019-05-06', 286, NULL),
('Luxor', 241, '2019-05-07', 362, NULL),
('Luxor', 241, '2019-05-08', 115, NULL),
('Luxor', 241, '2019-05-09', 354, NULL),
('Luxor', 241, '2019-05-10', 181, NULL),
('Luxor', 241, '2019-05-11', 166, NULL),
('Luxor', 241, '2019-05-12', 210, NULL),
('Luxor', 241, '2019-05-13', 168, NULL),
('Luxor', 241, '2019-05-14', 352, NULL),
('Luxor', 241, '2019-05-15', 307, NULL),
('Luxor', 241, '2019-05-16', 165, NULL),
('Luxor', 241, '2019-05-17', 336, NULL),
('Luxor', 241, '2019-05-18', 324, NULL),
('Luxor', 241, '2019-05-19', 348, NULL),
('Luxor', 241, '2019-05-20', 344, NULL),
('Luxor', 241, '2019-05-21', 395, NULL),
('Luxor', 241, '2019-05-22', 333, NULL),
('Luxor', 241, '2019-05-23', 203, NULL),
('Luxor', 241, '2019-05-24', 380, NULL),
('Luxor', 241, '2019-05-25', 201, NULL),
('Luxor', 241, '2019-05-26', 220, NULL),
('Luxor', 241, '2019-05-27', 322, NULL),
('Luxor', 241, '2019-05-28', 211, NULL),
('Luxor', 241, '2019-05-29', 198, NULL),
('Luxor', 241, '2019-05-30', 152, NULL),
('Luxor', 241, '2019-05-31', 388, NULL),
('Luxor', 241, '2019-06-01', 273, NULL),
('Luxor', 241, '2019-06-02', 367, NULL),
('Luxor', 241, '2019-06-03', 336, NULL),
('Luxor', 241, '2019-06-04', 381, NULL),
('Luxor', 241, '2019-06-05', 186, NULL),
('Luxor', 241, '2019-06-06', 235, NULL),
('Luxor', 241, '2019-06-07', 287, NULL),
('Luxor', 241, '2019-06-08', 382, NULL),
('Luxor', 241, '2019-06-09', 369, NULL),
('Luxor', 241, '2019-06-10', 154, NULL),
('Luxor', 241, '2019-06-11', 329, NULL),
('Luxor', 241, '2019-06-12', 127, NULL),
('Luxor', 241, '2019-06-13', 226, NULL),
('Luxor', 241, '2019-06-14', 176, NULL),
('Luxor', 241, '2019-06-15', 354, NULL),
('Luxor', 241, '2019-06-16', 192, NULL),
('Luxor', 241, '2019-06-17', 143, NULL),
('Luxor', 241, '2019-06-18', 280, NULL),
('Luxor', 241, '2019-06-19', 233, NULL),
('Luxor', 241, '2019-06-20', 256, NULL),
('Luxor', 241, '2019-06-21', 294, NULL),
('Luxor', 241, '2019-06-22', 258, NULL),
('Luxor', 241, '2019-06-23', 306, NULL),
('Luxor', 241, '2019-06-24', 344, NULL),
('Luxor', 241, '2019-06-25', 128, NULL),
('Luxor', 241, '2019-06-26', 127, NULL),
('Luxor', 241, '2019-06-27', 194, NULL),
('Luxor', 241, '2019-06-28', 114, NULL),
('Luxor', 241, '2019-06-29', 394, NULL),
('Luxor', 241, '2019-06-30', 375, NULL),
('Luxor', 241, '2019-07-01', 162, NULL),
('Luxor', 241, '2019-07-02', 276, NULL),
('Luxor', 241, '2019-07-03', 262, NULL),
('Luxor', 241, '2019-07-04', 359, NULL),
('Luxor', 241, '2019-07-05', 100, NULL),
('Luxor', 241, '2019-07-06', 143, NULL),
('Luxor', 241, '2019-07-07', 206, NULL),
('Luxor', 241, '2019-07-08', 207, NULL),
('Luxor', 241, '2019-07-09', 301, NULL),
('Luxor', 241, '2019-07-10', 263, NULL),
('Luxor', 241, '2019-07-11', 321, NULL),
('Luxor', 241, '2019-07-12', 219, NULL),
('Luxor', 241, '2019-07-13', 160, NULL),
('Luxor', 241, '2019-07-14', 259, NULL),
('Luxor', 241, '2019-07-15', 335, NULL),
('Luxor', 241, '2019-07-16', 232, NULL),
('Luxor', 241, '2019-07-17', 213, NULL),
('Luxor', 241, '2019-07-18', 178, NULL),
('Luxor', 241, '2019-07-19', 213, NULL),
('Luxor', 241, '2019-07-20', 250, NULL),
('Luxor', 241, '2019-07-21', 185, NULL),
('Luxor', 241, '2019-07-22', 145, NULL),
('Luxor', 241, '2019-07-23', 239, NULL),
('Luxor', 241, '2019-07-24', 119, NULL),
('Luxor', 241, '2019-07-25', 109, NULL),
('Luxor', 241, '2019-07-26', 362, NULL),
('Luxor', 241, '2019-07-27', 272, NULL),
('Luxor', 241, '2019-07-28', 234, NULL),
('Luxor', 241, '2019-07-29', 180, NULL),
('Luxor', 241, '2019-07-30', 165, NULL),
('Luxor', 241, '2019-07-31', 121, NULL),
('Luxor', 241, '2019-08-01', 385, NULL),
('Luxor', 241, '2019-08-02', 195, NULL),
('Luxor', 241, '2019-08-03', 232, NULL),
('Luxor', 241, '2019-08-04', 300, NULL),
('Luxor', 241, '2019-08-05', 329, NULL),
('Luxor', 241, '2019-08-06', 294, NULL),
('Luxor', 241, '2019-08-07', 265, NULL),
('Luxor', 241, '2019-08-08', 247, NULL),
('Luxor', 241, '2019-08-09', 281, NULL),
('Luxor', 241, '2019-08-10', 394, NULL),
('Luxor', 241, '2019-08-11', 242, NULL),
('Luxor', 241, '2019-08-12', 136, NULL),
('Luxor', 241, '2019-08-13', 272, NULL),
('Luxor', 241, '2019-08-14', 271, NULL),
('Luxor', 241, '2019-08-15', 112, NULL),
('Luxor', 241, '2019-08-16', 393, NULL),
('Luxor', 241, '2019-08-17', 308, NULL),
('Luxor', 241, '2019-08-18', 110, NULL),
('Luxor', 241, '2019-08-19', 178, NULL),
('Luxor', 241, '2019-08-20', 332, NULL),
('Luxor', 241, '2019-08-21', 112, NULL),
('Luxor', 241, '2019-08-22', 245, NULL),
('Luxor', 241, '2019-08-23', 321, NULL),
('Luxor', 241, '2019-08-24', 130, NULL),
('Luxor', 241, '2019-08-25', 248, NULL),
('Luxor', 241, '2019-08-26', 236, NULL),
('Luxor', 241, '2019-08-27', 361, NULL),
('Luxor', 241, '2019-08-28', 142, NULL),
('Luxor', 241, '2019-08-29', 199, NULL),
('Luxor', 241, '2019-08-30', 131, NULL),
('Luxor', 241, '2019-08-31', 358, NULL),
('Luxor', 241, '2019-09-01', 150, NULL),
('Luxor', 241, '2019-09-02', 302, NULL),
('Luxor', 241, '2019-09-03', 331, NULL),
('Luxor', 241, '2019-09-04', 391, NULL),
('Luxor', 241, '2019-09-05', 217, NULL),
('Luxor', 241, '2019-09-06', 193, NULL),
('Luxor', 241, '2019-09-07', 368, NULL),
('Luxor', 241, '2019-09-08', 312, NULL),
('Luxor', 241, '2019-09-09', 205, NULL),
('Luxor', 241, '2019-09-10', 304, NULL),
('Luxor', 241, '2019-09-11', 181, NULL),
('Luxor', 241, '2019-09-12', 170, NULL),
('Luxor', 241, '2019-09-13', 324, NULL),
('Luxor', 241, '2019-09-14', 164, NULL),
('Luxor', 241, '2019-09-15', 157, NULL),
('Luxor', 241, '2019-09-16', 249, NULL),
('Luxor', 241, '2019-09-17', 201, NULL),
('Luxor', 241, '2019-09-18', 224, NULL),
('Luxor', 241, '2019-09-19', 339, NULL),
('Luxor', 241, '2019-09-20', 290, NULL),
('Luxor', 241, '2019-09-21', 176, NULL),
('Luxor', 241, '2019-09-22', 214, NULL),
('Luxor', 241, '2019-09-23', 393, NULL),
('Luxor', 241, '2019-09-24', 118, NULL),
('Luxor', 241, '2019-09-25', 319, NULL),
('Luxor', 241, '2019-09-26', 250, NULL),
('Luxor', 241, '2019-09-27', 319, NULL),
('Luxor', 241, '2019-09-28', 115, NULL),
('Luxor', 241, '2019-09-29', 326, NULL),
('Luxor', 241, '2019-09-30', 263, NULL),
('Luxor', 241, '2019-10-01', 363, NULL),
('Luxor', 241, '2019-10-02', 358, NULL),
('Luxor', 241, '2019-10-03', 103, NULL),
('Luxor', 241, '2019-10-04', 224, NULL),
('Luxor', 241, '2019-10-05', 274, NULL),
('Luxor', 241, '2019-10-06', 110, NULL),
('Luxor', 241, '2019-10-07', 333, NULL),
('Luxor', 241, '2019-10-08', 317, NULL),
('Luxor', 241, '2019-10-09', 334, NULL),
('Luxor', 241, '2019-10-10', 131, NULL),
('Luxor', 241, '2019-10-11', 366, NULL),
('Luxor', 241, '2019-10-12', 393, NULL),
('Luxor', 241, '2019-10-13', 110, NULL),
('Luxor', 241, '2019-10-14', 363, NULL),
('Luxor', 241, '2019-10-15', 128, NULL),
('Luxor', 241, '2019-10-16', 382, NULL),
('Luxor', 241, '2019-10-17', 249, NULL),
('Luxor', 241, '2019-10-18', 169, NULL),
('Luxor', 241, '2019-10-19', 174, NULL),
('Luxor', 241, '2019-10-20', 191, NULL),
('Luxor', 241, '2019-10-21', 223, NULL),
('Luxor', 241, '2019-10-22', 165, NULL),
('Luxor', 241, '2019-10-23', 188, NULL),
('Luxor', 241, '2019-10-24', 107, NULL),
('Luxor', 241, '2019-10-25', 372, NULL),
('Luxor', 241, '2019-10-26', 164, NULL),
('Luxor', 241, '2019-10-27', 262, NULL),
('Luxor', 241, '2019-10-28', 137, NULL),
('Luxor', 241, '2019-10-29', 243, NULL),
('Luxor', 241, '2019-10-30', 157, NULL),
('Luxor', 241, '2019-10-31', 228, NULL),
('Luxor', 241, '2019-11-01', 362, NULL),
('Luxor', 241, '2019-11-02', 220, NULL),
('Luxor', 241, '2019-11-03', 343, NULL),
('Luxor', 241, '2019-11-04', 202, NULL),
('Luxor', 241, '2019-11-05', 112, NULL),
('Luxor', 241, '2019-11-06', 201, NULL),
('Luxor', 241, '2019-11-07', 381, NULL),
('Luxor', 241, '2019-11-08', 253, NULL),
('Luxor', 241, '2019-11-09', 117, NULL),
('Luxor', 241, '2019-11-10', 285, NULL),
('Luxor', 241, '2019-11-11', 298, NULL),
('Luxor', 241, '2019-11-12', 294, NULL),
('Luxor', 241, '2019-11-13', 199, NULL),
('Luxor', 241, '2019-11-14', 225, NULL),
('Luxor', 241, '2019-11-15', 383, NULL),
('Luxor', 241, '2019-11-16', 112, NULL),
('Luxor', 241, '2019-11-17', 341, NULL),
('Luxor', 241, '2019-11-18', 335, NULL),
('Luxor', 241, '2019-11-19', 326, NULL),
('Luxor', 241, '2019-11-20', 243, NULL),
('Luxor', 241, '2019-11-21', 278, NULL),
('Luxor', 241, '2019-11-22', 362, NULL),
('Luxor', 241, '2019-11-23', 356, NULL),
('Luxor', 241, '2019-11-24', 359, NULL),
('Luxor', 241, '2019-11-25', 163, NULL),
('Luxor', 241, '2019-11-26', 181, NULL),
('Luxor', 241, '2019-11-27', 173, NULL),
('Luxor', 241, '2019-11-28', 383, NULL),
('Luxor', 241, '2019-11-29', 251, NULL),
('Luxor', 241, '2019-11-30', 205, NULL),
('Luxor', 241, '2019-12-01', 268, NULL),
('Luxor', 241, '2019-12-02', 292, NULL),
('Luxor', 241, '2019-12-03', 361, NULL),
('Luxor', 241, '2019-12-04', 356, NULL),
('Luxor', 241, '2019-12-05', 120, NULL),
('Luxor', 241, '2019-12-06', 105, NULL),
('Luxor', 241, '2019-12-07', 335, NULL),
('Luxor', 241, '2019-12-08', 205, NULL),
('Luxor', 241, '2019-12-09', 393, NULL),
('Luxor', 241, '2019-12-10', 376, NULL),
('Luxor', 241, '2019-12-11', 145, NULL),
('Luxor', 241, '2019-12-12', 280, NULL),
('Luxor', 241, '2019-12-13', 230, NULL),
('Luxor', 241, '2019-12-14', 120, NULL),
('Luxor', 241, '2019-12-15', 235, NULL),
('Luxor', 241, '2019-12-16', 327, NULL),
('Luxor', 241, '2019-12-17', 211, NULL),
('Luxor', 241, '2019-12-18', 259, NULL),
('Luxor', 241, '2019-12-19', 218, NULL),
('Luxor', 241, '2019-12-20', 345, NULL),
('Luxor', 241, '2019-12-21', 179, NULL),
('Luxor', 241, '2019-12-22', 122, NULL),
('Luxor', 241, '2019-12-23', 136, NULL),
('Luxor', 241, '2019-12-24', 154, NULL),
('Luxor', 241, '2019-12-25', 127, NULL),
('Luxor', 241, '2019-12-26', 175, NULL),
('Luxor', 241, '2019-12-27', 389, NULL),
('Luxor', 241, '2019-12-28', 351, NULL),
('Luxor', 241, '2019-12-29', 290, NULL),
('Luxor', 241, '2019-12-30', 237, NULL),
('Luxor', 241, '2019-12-31', 395, NULL),
('Luxor', 241, '2020-01-01', 352, NULL),
('Luxor', 241, '2020-01-02', 113, NULL),
('Luxor', 241, '2020-01-03', 173, NULL),
('Luxor', 241, '2020-01-04', 354, NULL),
('Luxor', 241, '2020-01-05', 210, NULL),
('Luxor', 241, '2020-01-06', 226, NULL),
('Luxor', 241, '2020-01-07', 126, NULL),
('Luxor', 241, '2020-01-08', 136, NULL),
('Luxor', 241, '2020-01-09', 166, NULL),
('Luxor', 241, '2020-01-10', 167, NULL),
('Luxor', 241, '2020-01-11', 220, NULL),
('Luxor', 241, '2020-01-12', 170, NULL),
('Luxor', 241, '2020-01-13', 213, NULL),
('Luxor', 241, '2020-01-14', 252, NULL),
('Luxor', 241, '2020-01-15', 235, NULL),
('Luxor', 241, '2020-01-16', 153, NULL),
('Luxor', 241, '2020-01-17', 388, NULL),
('Luxor', 241, '2020-01-18', 340, NULL),
('Luxor', 241, '2020-01-19', 332, NULL),
('Luxor', 241, '2020-01-20', 122, NULL),
('Luxor', 241, '2020-01-21', 355, NULL),
('Luxor', 241, '2020-01-22', 353, NULL),
('Luxor', 241, '2020-01-23', 166, NULL),
('Luxor', 241, '2020-01-24', 188, NULL),
('Luxor', 241, '2020-01-25', 346, NULL),
('Luxor', 241, '2020-01-26', 270, NULL),
('Luxor', 241, '2020-01-27', 257, NULL),
('Luxor', 241, '2020-01-28', 387, NULL),
('Luxor', 241, '2020-01-29', 324, NULL),
('Luxor', 241, '2020-01-30', 264, NULL),
('Luxor', 241, '2020-01-31', 200, NULL),
('Luxor', 241, '2020-02-01', 233, NULL),
('Luxor', 241, '2020-02-02', 263, NULL),
('Luxor', 241, '2020-02-03', 245, NULL),
('Luxor', 241, '2020-02-04', 347, NULL),
('Luxor', 257, '2019-01-01', 321, NULL),
('Luxor', 257, '2019-01-02', 274, NULL),
('Luxor', 257, '2019-01-03', 336, NULL),
('Luxor', 257, '2019-01-04', 133, NULL),
('Luxor', 257, '2019-01-05', 308, NULL),
('Luxor', 257, '2019-01-06', 346, NULL),
('Luxor', 257, '2019-01-07', 336, NULL),
('Luxor', 257, '2019-01-08', 106, NULL),
('Luxor', 257, '2019-01-09', 250, NULL),
('Luxor', 257, '2019-01-10', 340, NULL),
('Luxor', 257, '2019-01-11', 130, NULL),
('Luxor', 257, '2019-01-12', 145, NULL),
('Luxor', 257, '2019-01-13', 277, NULL),
('Luxor', 257, '2019-01-14', 268, NULL),
('Luxor', 257, '2019-01-15', 251, NULL),
('Luxor', 257, '2019-01-16', 325, NULL),
('Luxor', 257, '2019-01-17', 192, NULL),
('Luxor', 257, '2019-01-18', 142, NULL),
('Luxor', 257, '2019-01-19', 195, NULL),
('Luxor', 257, '2019-01-20', 216, NULL),
('Luxor', 257, '2019-01-21', 347, NULL),
('Luxor', 257, '2019-01-22', 176, NULL),
('Luxor', 257, '2019-01-23', 289, NULL),
('Luxor', 257, '2019-01-24', 283, NULL),
('Luxor', 257, '2019-01-25', 347, NULL),
('Luxor', 257, '2019-01-26', 140, NULL),
('Luxor', 257, '2019-01-27', 328, NULL),
('Luxor', 257, '2019-01-28', 293, NULL),
('Luxor', 257, '2019-01-29', 137, NULL),
('Luxor', 257, '2019-01-30', 348, NULL),
('Luxor', 257, '2019-01-31', 167, NULL),
('Luxor', 257, '2019-02-01', 237, NULL),
('Luxor', 257, '2019-02-02', 197, NULL),
('Luxor', 257, '2019-02-03', 371, NULL),
('Luxor', 257, '2019-02-04', 384, NULL),
('Luxor', 257, '2019-02-05', 152, NULL),
('Luxor', 257, '2019-02-06', 367, NULL),
('Luxor', 257, '2019-02-07', 347, NULL),
('Luxor', 257, '2019-02-08', 296, NULL),
('Luxor', 257, '2019-02-09', 120, NULL),
('Luxor', 257, '2019-02-10', 231, NULL),
('Luxor', 257, '2019-02-11', 193, NULL),
('Luxor', 257, '2019-02-12', 131, NULL),
('Luxor', 257, '2019-02-13', 356, NULL),
('Luxor', 257, '2019-02-14', 278, NULL),
('Luxor', 257, '2019-02-15', 278, NULL),
('Luxor', 257, '2019-02-16', 130, NULL),
('Luxor', 257, '2019-02-17', 113, NULL),
('Luxor', 257, '2019-02-18', 316, NULL),
('Luxor', 257, '2019-02-19', 203, NULL),
('Luxor', 257, '2019-02-20', 285, NULL),
('Luxor', 257, '2019-02-21', 341, NULL),
('Luxor', 257, '2019-02-22', 388, NULL),
('Luxor', 257, '2019-02-23', 287, NULL),
('Luxor', 257, '2019-02-24', 315, NULL),
('Luxor', 257, '2019-02-25', 395, NULL),
('Luxor', 257, '2019-02-26', 253, NULL),
('Luxor', 257, '2019-02-27', 188, NULL),
('Luxor', 257, '2019-02-28', 244, NULL),
('Luxor', 257, '2019-03-01', 356, NULL),
('Luxor', 257, '2019-03-02', 396, NULL),
('Luxor', 257, '2019-03-03', 246, NULL),
('Luxor', 257, '2019-03-04', 397, NULL),
('Luxor', 257, '2019-03-05', 372, NULL),
('Luxor', 257, '2019-03-06', 252, NULL),
('Luxor', 257, '2019-03-07', 375, NULL),
('Luxor', 257, '2019-03-08', 199, NULL),
('Luxor', 257, '2019-03-09', 176, NULL),
('Luxor', 257, '2019-03-10', 360, NULL),
('Luxor', 257, '2019-03-11', 157, NULL),
('Luxor', 257, '2019-03-12', 246, NULL),
('Luxor', 257, '2019-03-13', 317, NULL),
('Luxor', 257, '2019-03-14', 133, NULL),
('Luxor', 257, '2019-03-15', 112, NULL),
('Luxor', 257, '2019-03-16', 258, NULL),
('Luxor', 257, '2019-03-17', 397, NULL),
('Luxor', 257, '2019-03-18', 154, NULL),
('Luxor', 257, '2019-03-19', 193, NULL),
('Luxor', 257, '2019-03-20', 229, NULL),
('Luxor', 257, '2019-03-21', 104, NULL),
('Luxor', 257, '2019-03-22', 105, NULL),
('Luxor', 257, '2019-03-23', 131, NULL),
('Luxor', 257, '2019-03-24', 134, NULL),
('Luxor', 257, '2019-03-25', 138, NULL),
('Luxor', 257, '2019-03-26', 258, NULL),
('Luxor', 257, '2019-03-27', 342, NULL),
('Luxor', 257, '2019-03-28', 399, NULL),
('Luxor', 257, '2019-03-29', 313, NULL),
('Luxor', 257, '2019-03-30', 262, NULL),
('Luxor', 257, '2019-03-31', 269, NULL),
('Luxor', 257, '2019-04-01', 154, NULL),
('Luxor', 257, '2019-04-02', 177, NULL),
('Luxor', 257, '2019-04-03', 220, NULL),
('Luxor', 257, '2019-04-04', 190, NULL),
('Luxor', 257, '2019-04-05', 189, NULL),
('Luxor', 257, '2019-04-06', 272, NULL),
('Luxor', 257, '2019-04-07', 215, NULL),
('Luxor', 257, '2019-04-08', 184, NULL),
('Luxor', 257, '2019-04-09', 351, NULL),
('Luxor', 257, '2019-04-10', 218, NULL),
('Luxor', 257, '2019-04-11', 167, NULL),
('Luxor', 257, '2019-04-12', 195, NULL),
('Luxor', 257, '2019-04-13', 261, NULL),
('Luxor', 257, '2019-04-14', 224, NULL),
('Luxor', 257, '2019-04-15', 139, NULL),
('Luxor', 257, '2019-04-16', 384, NULL),
('Luxor', 257, '2019-04-17', 240, NULL),
('Luxor', 257, '2019-04-18', 124, NULL),
('Luxor', 257, '2019-04-19', 393, NULL),
('Luxor', 257, '2019-04-20', 259, NULL),
('Luxor', 257, '2019-04-21', 368, NULL),
('Luxor', 257, '2019-04-22', 391, NULL),
('Luxor', 257, '2019-04-23', 123, NULL),
('Luxor', 257, '2019-04-24', 397, NULL),
('Luxor', 257, '2019-04-25', 317, NULL),
('Luxor', 257, '2019-04-26', 286, NULL),
('Luxor', 257, '2019-04-27', 368, NULL),
('Luxor', 257, '2019-04-28', 265, NULL),
('Luxor', 257, '2019-04-29', 210, NULL),
('Luxor', 257, '2019-04-30', 173, NULL),
('Luxor', 257, '2019-05-01', 391, NULL),
('Luxor', 257, '2019-05-02', 137, NULL),
('Luxor', 257, '2019-05-03', 365, NULL),
('Luxor', 257, '2019-05-04', 109, NULL),
('Luxor', 257, '2019-05-05', 250, NULL),
('Luxor', 257, '2019-05-06', 124, NULL),
('Luxor', 257, '2019-05-07', 312, NULL),
('Luxor', 257, '2019-05-08', 104, NULL),
('Luxor', 257, '2019-05-09', 333, NULL),
('Luxor', 257, '2019-05-10', 259, NULL),
('Luxor', 257, '2019-05-11', 135, NULL),
('Luxor', 257, '2019-05-12', 363, NULL),
('Luxor', 257, '2019-05-13', 116, NULL),
('Luxor', 257, '2019-05-14', 100, NULL),
('Luxor', 257, '2019-05-15', 183, NULL),
('Luxor', 257, '2019-05-16', 140, NULL),
('Luxor', 257, '2019-05-17', 173, NULL),
('Luxor', 257, '2019-05-18', 372, NULL),
('Luxor', 257, '2019-05-19', 126, NULL),
('Luxor', 257, '2019-05-20', 109, NULL),
('Luxor', 257, '2019-05-21', 321, NULL),
('Luxor', 257, '2019-05-22', 279, NULL),
('Luxor', 257, '2019-05-23', 377, NULL),
('Luxor', 257, '2019-05-24', 157, NULL),
('Luxor', 257, '2019-05-25', 316, NULL),
('Luxor', 257, '2019-05-26', 350, NULL),
('Luxor', 257, '2019-05-27', 103, NULL),
('Luxor', 257, '2019-05-28', 335, NULL),
('Luxor', 257, '2019-05-29', 329, NULL),
('Luxor', 257, '2019-05-30', 182, NULL),
('Luxor', 257, '2019-05-31', 212, NULL),
('Luxor', 257, '2019-06-01', 144, NULL),
('Luxor', 257, '2019-06-02', 171, NULL),
('Luxor', 257, '2019-06-03', 266, NULL),
('Luxor', 257, '2019-06-04', 123, NULL),
('Luxor', 257, '2019-06-05', 274, NULL),
('Luxor', 257, '2019-06-06', 200, NULL),
('Luxor', 257, '2019-06-07', 181, NULL),
('Luxor', 257, '2019-06-08', 330, NULL),
('Luxor', 257, '2019-06-09', 375, NULL),
('Luxor', 257, '2019-06-10', 254, NULL),
('Luxor', 257, '2019-06-11', 358, NULL),
('Luxor', 257, '2019-06-12', 308, NULL),
('Luxor', 257, '2019-06-13', 390, NULL),
('Luxor', 257, '2019-06-14', 232, NULL),
('Luxor', 257, '2019-06-15', 235, NULL),
('Luxor', 257, '2019-06-16', 184, NULL),
('Luxor', 257, '2019-06-17', 343, NULL),
('Luxor', 257, '2019-06-18', 359, NULL),
('Luxor', 257, '2019-06-19', 168, NULL),
('Luxor', 257, '2019-06-20', 152, NULL),
('Luxor', 257, '2019-06-21', 393, NULL),
('Luxor', 257, '2019-06-22', 107, NULL),
('Luxor', 257, '2019-06-23', 151, NULL),
('Luxor', 257, '2019-06-24', 273, NULL),
('Luxor', 257, '2019-06-25', 136, NULL),
('Luxor', 257, '2019-06-26', 239, NULL),
('Luxor', 257, '2019-06-27', 200, NULL),
('Luxor', 257, '2019-06-28', 165, NULL),
('Luxor', 257, '2019-06-29', 168, NULL),
('Luxor', 257, '2019-06-30', 110, NULL),
('Luxor', 257, '2019-07-01', 333, NULL),
('Luxor', 257, '2019-07-02', 246, NULL),
('Luxor', 257, '2019-07-03', 141, NULL),
('Luxor', 257, '2019-07-04', 175, NULL),
('Luxor', 257, '2019-07-05', 219, NULL),
('Luxor', 257, '2019-07-06', 203, NULL),
('Luxor', 257, '2019-07-07', 138, NULL),
('Luxor', 257, '2019-07-08', 166, NULL),
('Luxor', 257, '2019-07-09', 355, NULL),
('Luxor', 257, '2019-07-10', 323, NULL),
('Luxor', 257, '2019-07-11', 396, NULL),
('Luxor', 257, '2019-07-12', 312, NULL),
('Luxor', 257, '2019-07-13', 175, NULL),
('Luxor', 257, '2019-07-14', 366, NULL),
('Luxor', 257, '2019-07-15', 334, NULL),
('Luxor', 257, '2019-07-16', 276, NULL),
('Luxor', 257, '2019-07-17', 104, NULL),
('Luxor', 257, '2019-07-18', 368, NULL),
('Luxor', 257, '2019-07-19', 284, NULL),
('Luxor', 257, '2019-07-20', 258, NULL),
('Luxor', 257, '2019-07-21', 319, NULL),
('Luxor', 257, '2019-07-22', 197, NULL),
('Luxor', 257, '2019-07-23', 367, NULL),
('Luxor', 257, '2019-07-24', 321, NULL),
('Luxor', 257, '2019-07-25', 279, NULL),
('Luxor', 257, '2019-07-26', 193, NULL),
('Luxor', 257, '2019-07-27', 289, NULL),
('Luxor', 257, '2019-07-28', 345, NULL),
('Luxor', 257, '2019-07-29', 391, NULL),
('Luxor', 257, '2019-07-30', 217, NULL),
('Luxor', 257, '2019-07-31', 384, NULL),
('Luxor', 257, '2019-08-01', 127, NULL),
('Luxor', 257, '2019-08-02', 228, NULL),
('Luxor', 257, '2019-08-03', 351, NULL),
('Luxor', 257, '2019-08-04', 206, NULL),
('Luxor', 257, '2019-08-05', 133, NULL),
('Luxor', 257, '2019-08-06', 137, NULL),
('Luxor', 257, '2019-08-07', 277, NULL),
('Luxor', 257, '2019-08-08', 337, NULL),
('Luxor', 257, '2019-08-09', 319, NULL),
('Luxor', 257, '2019-08-10', 295, NULL),
('Luxor', 257, '2019-08-11', 143, NULL),
('Luxor', 257, '2019-08-12', 168, NULL),
('Luxor', 257, '2019-08-13', 265, NULL),
('Luxor', 257, '2019-08-14', 138, NULL),
('Luxor', 257, '2019-08-15', 283, NULL),
('Luxor', 257, '2019-08-16', 183, NULL),
('Luxor', 257, '2019-08-17', 259, NULL),
('Luxor', 257, '2019-08-18', 373, NULL),
('Luxor', 257, '2019-08-19', 259, NULL),
('Luxor', 257, '2019-08-20', 357, NULL),
('Luxor', 257, '2019-08-21', 109, NULL),
('Luxor', 257, '2019-08-22', 399, NULL),
('Luxor', 257, '2019-08-23', 281, NULL),
('Luxor', 257, '2019-08-24', 249, NULL),
('Luxor', 257, '2019-08-25', 314, NULL),
('Luxor', 257, '2019-08-26', 396, NULL),
('Luxor', 257, '2019-08-27', 321, NULL),
('Luxor', 257, '2019-08-28', 144, NULL),
('Luxor', 257, '2019-08-29', 170, NULL),
('Luxor', 257, '2019-08-30', 284, NULL),
('Luxor', 257, '2019-08-31', 174, NULL),
('Luxor', 257, '2019-09-01', 131, NULL),
('Luxor', 257, '2019-09-02', 326, NULL),
('Luxor', 257, '2019-09-03', 352, NULL),
('Luxor', 257, '2019-09-04', 196, NULL),
('Luxor', 257, '2019-09-05', 376, NULL),
('Luxor', 257, '2019-09-06', 162, NULL),
('Luxor', 257, '2019-09-07', 135, NULL),
('Luxor', 257, '2019-09-08', 370, NULL),
('Luxor', 257, '2019-09-09', 255, NULL),
('Luxor', 257, '2019-09-10', 374, NULL),
('Luxor', 257, '2019-09-11', 240, NULL),
('Luxor', 257, '2019-09-12', 267, NULL),
('Luxor', 257, '2019-09-13', 246, NULL),
('Luxor', 257, '2019-09-14', 218, NULL),
('Luxor', 257, '2019-09-15', 303, NULL),
('Luxor', 257, '2019-09-16', 212, NULL),
('Luxor', 257, '2019-09-17', 295, NULL),
('Luxor', 257, '2019-09-18', 113, NULL),
('Luxor', 257, '2019-09-19', 139, NULL),
('Luxor', 257, '2019-09-20', 372, NULL),
('Luxor', 257, '2019-09-21', 354, NULL),
('Luxor', 257, '2019-09-22', 295, NULL),
('Luxor', 257, '2019-09-23', 283, NULL),
('Luxor', 257, '2019-09-24', 387, NULL),
('Luxor', 257, '2019-09-25', 240, NULL),
('Luxor', 257, '2019-09-26', 222, NULL),
('Luxor', 257, '2019-09-27', 371, NULL),
('Luxor', 257, '2019-09-28', 268, NULL),
('Luxor', 257, '2019-09-29', 311, NULL),
('Luxor', 257, '2019-09-30', 156, NULL),
('Luxor', 257, '2019-10-01', 137, NULL),
('Luxor', 257, '2019-10-02', 215, NULL),
('Luxor', 257, '2019-10-03', 362, NULL),
('Luxor', 257, '2019-10-04', 339, NULL),
('Luxor', 257, '2019-10-05', 193, NULL),
('Luxor', 257, '2019-10-06', 237, NULL),
('Luxor', 257, '2019-10-07', 288, NULL),
('Luxor', 257, '2019-10-08', 309, NULL),
('Luxor', 257, '2019-10-09', 108, NULL),
('Luxor', 257, '2019-10-10', 219, NULL),
('Luxor', 257, '2019-10-11', 233, NULL),
('Luxor', 257, '2019-10-12', 284, NULL),
('Luxor', 257, '2019-10-13', 132, NULL),
('Luxor', 257, '2019-10-14', 222, NULL),
('Luxor', 257, '2019-10-15', 186, NULL),
('Luxor', 257, '2019-10-16', 245, NULL),
('Luxor', 257, '2019-10-17', 338, NULL),
('Luxor', 257, '2019-10-18', 313, NULL),
('Luxor', 257, '2019-10-19', 157, NULL),
('Luxor', 257, '2019-10-20', 245, NULL),
('Luxor', 257, '2019-10-21', 298, NULL),
('Luxor', 257, '2019-10-22', 213, NULL),
('Luxor', 257, '2019-10-23', 327, NULL),
('Luxor', 257, '2019-10-24', 389, NULL),
('Luxor', 257, '2019-10-25', 259, NULL),
('Luxor', 257, '2019-10-26', 237, NULL),
('Luxor', 257, '2019-10-27', 199, NULL),
('Luxor', 257, '2019-10-28', 253, NULL),
('Luxor', 257, '2019-10-29', 306, NULL),
('Luxor', 257, '2019-10-30', 226, NULL),
('Luxor', 257, '2019-10-31', 111, NULL),
('Luxor', 257, '2019-11-01', 244, NULL),
('Luxor', 257, '2019-11-02', 324, NULL),
('Luxor', 257, '2019-11-03', 229, NULL),
('Luxor', 257, '2019-11-04', 372, NULL),
('Luxor', 257, '2019-11-05', 302, NULL),
('Luxor', 257, '2019-11-06', 278, NULL),
('Luxor', 257, '2019-11-07', 374, NULL),
('Luxor', 257, '2019-11-08', 146, NULL),
('Luxor', 257, '2019-11-09', 173, NULL),
('Luxor', 257, '2019-11-10', 333, NULL),
('Luxor', 257, '2019-11-11', 289, NULL),
('Luxor', 257, '2019-11-12', 199, NULL),
('Luxor', 257, '2019-11-13', 232, NULL),
('Luxor', 257, '2019-11-14', 363, NULL),
('Luxor', 257, '2019-11-15', 286, NULL),
('Luxor', 257, '2019-11-16', 334, NULL),
('Luxor', 257, '2019-11-17', 303, NULL),
('Luxor', 257, '2019-11-18', 148, NULL),
('Luxor', 257, '2019-11-19', 234, NULL),
('Luxor', 257, '2019-11-20', 256, NULL),
('Luxor', 257, '2019-11-21', 181, NULL),
('Luxor', 257, '2019-11-22', 283, NULL),
('Luxor', 257, '2019-11-23', 141, NULL),
('Luxor', 257, '2019-11-24', 139, NULL),
('Luxor', 257, '2019-11-25', 232, NULL),
('Luxor', 257, '2019-11-26', 118, NULL),
('Luxor', 257, '2019-11-27', 112, NULL),
('Luxor', 257, '2019-11-28', 303, NULL),
('Luxor', 257, '2019-11-29', 184, NULL),
('Luxor', 257, '2019-11-30', 317, NULL),
('Luxor', 257, '2019-12-01', 148, NULL),
('Luxor', 257, '2019-12-02', 331, NULL),
('Luxor', 257, '2019-12-03', 189, NULL),
('Luxor', 257, '2019-12-04', 262, NULL),
('Luxor', 257, '2019-12-05', 166, NULL),
('Luxor', 257, '2019-12-06', 225, NULL),
('Luxor', 257, '2019-12-07', 383, NULL),
('Luxor', 257, '2019-12-08', 142, NULL),
('Luxor', 257, '2019-12-09', 362, NULL),
('Luxor', 257, '2019-12-10', 104, NULL),
('Luxor', 257, '2019-12-11', 164, NULL),
('Luxor', 257, '2019-12-12', 294, NULL),
('Luxor', 257, '2019-12-13', 276, NULL),
('Luxor', 257, '2019-12-14', 268, NULL),
('Luxor', 257, '2019-12-15', 380, NULL),
('Luxor', 257, '2019-12-16', 232, NULL),
('Luxor', 257, '2019-12-17', 374, NULL),
('Luxor', 257, '2019-12-18', 299, NULL),
('Luxor', 257, '2019-12-19', 212, NULL),
('Luxor', 257, '2019-12-20', 139, NULL),
('Luxor', 257, '2019-12-21', 276, NULL),
('Luxor', 257, '2019-12-22', 328, NULL),
('Luxor', 257, '2019-12-23', 269, NULL),
('Luxor', 257, '2019-12-24', 353, NULL),
('Luxor', 257, '2019-12-25', 129, NULL),
('Luxor', 257, '2019-12-26', 367, NULL),
('Luxor', 257, '2019-12-27', 279, NULL),
('Luxor', 257, '2019-12-28', 345, NULL),
('Luxor', 257, '2019-12-29', 195, NULL),
('Luxor', 257, '2019-12-30', 105, NULL),
('Luxor', 257, '2019-12-31', 280, NULL),
('Luxor', 257, '2020-01-01', 184, NULL),
('Luxor', 257, '2020-01-02', 293, NULL),
('Luxor', 257, '2020-01-03', 348, NULL),
('Luxor', 257, '2020-01-04', 253, NULL),
('Luxor', 257, '2020-01-05', 398, NULL),
('Luxor', 257, '2020-01-06', 363, NULL),
('Luxor', 257, '2020-01-07', 361, NULL),
('Luxor', 257, '2020-01-08', 348, NULL),
('Luxor', 257, '2020-01-09', 386, NULL),
('Luxor', 257, '2020-01-10', 236, NULL),
('Luxor', 257, '2020-01-11', 152, NULL),
('Luxor', 257, '2020-01-12', 288, NULL),
('Luxor', 257, '2020-01-13', 366, NULL),
('Luxor', 257, '2020-01-14', 134, NULL),
('Luxor', 257, '2020-01-15', 227, NULL),
('Luxor', 257, '2020-01-16', 186, NULL),
('Luxor', 257, '2020-01-17', 239, NULL),
('Luxor', 257, '2020-01-18', 372, NULL),
('Luxor', 257, '2020-01-19', 174, NULL),
('Luxor', 257, '2020-01-20', 221, NULL),
('Luxor', 257, '2020-01-21', 205, NULL),
('Luxor', 257, '2020-01-22', 135, NULL),
('Luxor', 257, '2020-01-23', 139, NULL),
('Luxor', 257, '2020-01-24', 169, NULL),
('Luxor', 257, '2020-01-25', 156, NULL),
('Luxor', 257, '2020-01-26', 393, NULL),
('Luxor', 257, '2020-01-27', 116, NULL),
('Luxor', 257, '2020-01-28', 192, NULL),
('Luxor', 257, '2020-01-29', 152, NULL),
('Luxor', 257, '2020-01-30', 203, NULL),
('Luxor', 257, '2020-01-31', 178, NULL),
('Luxor', 257, '2020-02-01', 157, NULL),
('Luxor', 257, '2020-02-02', 153, NULL),
('Luxor', 257, '2020-02-03', 132, NULL),
('Luxor', 257, '2020-02-04', 326, NULL),
('Luxor', 259, '2019-01-01', 119, NULL),
('Luxor', 259, '2019-01-02', 173, NULL),
('Luxor', 259, '2019-01-03', 197, NULL),
('Luxor', 259, '2019-01-04', 298, NULL),
('Luxor', 259, '2019-01-05', 198, NULL),
('Luxor', 259, '2019-01-06', 350, NULL),
('Luxor', 259, '2019-01-07', 383, NULL),
('Luxor', 259, '2019-01-08', 328, NULL),
('Luxor', 259, '2019-01-09', 159, NULL),
('Luxor', 259, '2019-01-10', 205, NULL),
('Luxor', 259, '2019-01-11', 329, NULL),
('Luxor', 259, '2019-01-12', 223, NULL),
('Luxor', 259, '2019-01-13', 286, NULL),
('Luxor', 259, '2019-01-14', 189, NULL),
('Luxor', 259, '2019-01-15', 152, NULL),
('Luxor', 259, '2019-01-16', 299, NULL),
('Luxor', 259, '2019-01-17', 233, NULL),
('Luxor', 259, '2019-01-18', 383, NULL),
('Luxor', 259, '2019-01-19', 337, NULL),
('Luxor', 259, '2019-01-20', 140, NULL),
('Luxor', 259, '2019-01-21', 390, NULL),
('Luxor', 259, '2019-01-22', 313, NULL),
('Luxor', 259, '2019-01-23', 265, NULL),
('Luxor', 259, '2019-01-24', 221, NULL),
('Luxor', 259, '2019-01-25', 378, NULL),
('Luxor', 259, '2019-01-26', 275, NULL),
('Luxor', 259, '2019-01-27', 308, NULL),
('Luxor', 259, '2019-01-28', 173, NULL),
('Luxor', 259, '2019-01-29', 367, NULL),
('Luxor', 259, '2019-01-30', 340, NULL),
('Luxor', 259, '2019-01-31', 126, NULL),
('Luxor', 259, '2019-02-01', 313, NULL),
('Luxor', 259, '2019-02-02', 392, NULL),
('Luxor', 259, '2019-02-03', 339, NULL),
('Luxor', 259, '2019-02-04', 315, NULL),
('Luxor', 259, '2019-02-05', 314, NULL),
('Luxor', 259, '2019-02-06', 182, NULL),
('Luxor', 259, '2019-02-07', 375, NULL),
('Luxor', 259, '2019-02-08', 107, NULL),
('Luxor', 259, '2019-02-09', 149, NULL),
('Luxor', 259, '2019-02-10', 180, NULL),
('Luxor', 259, '2019-02-11', 279, NULL),
('Luxor', 259, '2019-02-12', 334, NULL),
('Luxor', 259, '2019-02-13', 233, NULL),
('Luxor', 259, '2019-02-14', 211, NULL),
('Luxor', 259, '2019-02-15', 113, NULL),
('Luxor', 259, '2019-02-16', 353, NULL),
('Luxor', 259, '2019-02-17', 356, NULL),
('Luxor', 259, '2019-02-18', 349, NULL),
('Luxor', 259, '2019-02-19', 346, NULL),
('Luxor', 259, '2019-02-20', 246, NULL),
('Luxor', 259, '2019-02-21', 252, NULL),
('Luxor', 259, '2019-02-22', 344, NULL),
('Luxor', 259, '2019-02-23', 371, NULL),
('Luxor', 259, '2019-02-24', 346, NULL),
('Luxor', 259, '2019-02-25', 175, NULL),
('Luxor', 259, '2019-02-26', 112, NULL),
('Luxor', 259, '2019-02-27', 396, NULL),
('Luxor', 259, '2019-02-28', 344, NULL),
('Luxor', 259, '2019-03-01', 333, NULL),
('Luxor', 259, '2019-03-02', 104, NULL),
('Luxor', 259, '2019-03-03', 166, NULL),
('Luxor', 259, '2019-03-04', 188, NULL),
('Luxor', 259, '2019-03-05', 124, NULL),
('Luxor', 259, '2019-03-06', 201, NULL),
('Luxor', 259, '2019-03-07', 181, NULL),
('Luxor', 259, '2019-03-08', 138, NULL),
('Luxor', 259, '2019-03-09', 137, NULL),
('Luxor', 259, '2019-03-10', 230, NULL),
('Luxor', 259, '2019-03-11', 107, NULL),
('Luxor', 259, '2019-03-12', 193, NULL),
('Luxor', 259, '2019-03-13', 138, NULL),
('Luxor', 259, '2019-03-14', 388, NULL),
('Luxor', 259, '2019-03-15', 177, NULL),
('Luxor', 259, '2019-03-16', 335, NULL),
('Luxor', 259, '2019-03-17', 143, NULL),
('Luxor', 259, '2019-03-18', 110, NULL),
('Luxor', 259, '2019-03-19', 366, NULL),
('Luxor', 259, '2019-03-20', 231, NULL),
('Luxor', 259, '2019-03-21', 288, NULL),
('Luxor', 259, '2019-03-22', 159, NULL),
('Luxor', 259, '2019-03-23', 346, NULL),
('Luxor', 259, '2019-03-24', 305, NULL),
('Luxor', 259, '2019-03-25', 225, NULL),
('Luxor', 259, '2019-03-26', 252, NULL),
('Luxor', 259, '2019-03-27', 231, NULL),
('Luxor', 259, '2019-03-28', 103, NULL),
('Luxor', 259, '2019-03-29', 199, NULL),
('Luxor', 259, '2019-03-30', 284, NULL),
('Luxor', 259, '2019-03-31', 266, NULL),
('Luxor', 259, '2019-04-01', 220, NULL),
('Luxor', 259, '2019-04-02', 136, NULL),
('Luxor', 259, '2019-04-03', 141, NULL),
('Luxor', 259, '2019-04-04', 395, NULL),
('Luxor', 259, '2019-04-05', 167, NULL),
('Luxor', 259, '2019-04-06', 134, NULL),
('Luxor', 259, '2019-04-07', 174, NULL),
('Luxor', 259, '2019-04-08', 183, NULL),
('Luxor', 259, '2019-04-09', 105, NULL),
('Luxor', 259, '2019-04-10', 248, NULL),
('Luxor', 259, '2019-04-11', 112, NULL),
('Luxor', 259, '2019-04-12', 285, NULL),
('Luxor', 259, '2019-04-13', 293, NULL),
('Luxor', 259, '2019-04-14', 209, NULL),
('Luxor', 259, '2019-04-15', 255, NULL),
('Luxor', 259, '2019-04-16', 327, NULL),
('Luxor', 259, '2019-04-17', 271, NULL),
('Luxor', 259, '2019-04-18', 273, NULL),
('Luxor', 259, '2019-04-19', 175, NULL),
('Luxor', 259, '2019-04-20', 180, NULL),
('Luxor', 259, '2019-04-21', 388, NULL),
('Luxor', 259, '2019-04-22', 241, NULL),
('Luxor', 259, '2019-04-23', 353, NULL),
('Luxor', 259, '2019-04-24', 386, NULL),
('Luxor', 259, '2019-04-25', 189, NULL),
('Luxor', 259, '2019-04-26', 115, NULL),
('Luxor', 259, '2019-04-27', 125, NULL),
('Luxor', 259, '2019-04-28', 303, NULL),
('Luxor', 259, '2019-04-29', 105, NULL),
('Luxor', 259, '2019-04-30', 387, NULL),
('Luxor', 259, '2019-05-01', 280, NULL),
('Luxor', 259, '2019-05-02', 202, NULL),
('Luxor', 259, '2019-05-03', 216, NULL),
('Luxor', 259, '2019-05-04', 332, NULL),
('Luxor', 259, '2019-05-05', 192, NULL),
('Luxor', 259, '2019-05-06', 261, NULL),
('Luxor', 259, '2019-05-07', 373, NULL),
('Luxor', 259, '2019-05-08', 373, NULL),
('Luxor', 259, '2019-05-09', 203, NULL),
('Luxor', 259, '2019-05-10', 356, NULL),
('Luxor', 259, '2019-05-11', 379, NULL),
('Luxor', 259, '2019-05-12', 187, NULL),
('Luxor', 259, '2019-05-13', 277, NULL),
('Luxor', 259, '2019-05-14', 247, NULL),
('Luxor', 259, '2019-05-15', 194, NULL),
('Luxor', 259, '2019-05-16', 108, NULL),
('Luxor', 259, '2019-05-17', 359, NULL),
('Luxor', 259, '2019-05-18', 189, NULL),
('Luxor', 259, '2019-05-19', 386, NULL),
('Luxor', 259, '2019-05-20', 313, NULL),
('Luxor', 259, '2019-05-21', 320, NULL),
('Luxor', 259, '2019-05-22', 295, NULL),
('Luxor', 259, '2019-05-23', 275, NULL),
('Luxor', 259, '2019-05-24', 144, NULL),
('Luxor', 259, '2019-05-25', 276, NULL),
('Luxor', 259, '2019-05-26', 394, NULL),
('Luxor', 259, '2019-05-27', 350, NULL),
('Luxor', 259, '2019-05-28', 344, NULL),
('Luxor', 259, '2019-05-29', 351, NULL),
('Luxor', 259, '2019-05-30', 352, NULL),
('Luxor', 259, '2019-05-31', 399, NULL),
('Luxor', 259, '2019-06-01', 100, NULL),
('Luxor', 259, '2019-06-02', 253, NULL),
('Luxor', 259, '2019-06-03', 220, NULL),
('Luxor', 259, '2019-06-04', 274, NULL),
('Luxor', 259, '2019-06-05', 115, NULL),
('Luxor', 259, '2019-06-06', 194, NULL),
('Luxor', 259, '2019-06-07', 246, NULL),
('Luxor', 259, '2019-06-08', 106, NULL),
('Luxor', 259, '2019-06-09', 370, NULL),
('Luxor', 259, '2019-06-10', 108, NULL),
('Luxor', 259, '2019-06-11', 104, NULL),
('Luxor', 259, '2019-06-12', 158, NULL),
('Luxor', 259, '2019-06-13', 270, NULL),
('Luxor', 259, '2019-06-14', 232, NULL),
('Luxor', 259, '2019-06-15', 315, NULL),
('Luxor', 259, '2019-06-16', 244, NULL),
('Luxor', 259, '2019-06-17', 286, NULL),
('Luxor', 259, '2019-06-18', 256, NULL),
('Luxor', 259, '2019-06-19', 341, NULL),
('Luxor', 259, '2019-06-20', 192, NULL),
('Luxor', 259, '2019-06-21', 381, NULL),
('Luxor', 259, '2019-06-22', 261, NULL),
('Luxor', 259, '2019-06-23', 338, NULL),
('Luxor', 259, '2019-06-24', 232, NULL),
('Luxor', 259, '2019-06-25', 196, NULL),
('Luxor', 259, '2019-06-26', 113, NULL),
('Luxor', 259, '2019-06-27', 316, NULL),
('Luxor', 259, '2019-06-28', 381, NULL),
('Luxor', 259, '2019-06-29', 158, NULL),
('Luxor', 259, '2019-06-30', 225, NULL),
('Luxor', 259, '2019-07-01', 181, NULL),
('Luxor', 259, '2019-07-02', 304, NULL),
('Luxor', 259, '2019-07-03', 118, NULL),
('Luxor', 259, '2019-07-04', 297, NULL),
('Luxor', 259, '2019-07-05', 399, NULL),
('Luxor', 259, '2019-07-06', 187, NULL),
('Luxor', 259, '2019-07-07', 271, NULL),
('Luxor', 259, '2019-07-08', 112, NULL),
('Luxor', 259, '2019-07-09', 173, NULL),
('Luxor', 259, '2019-07-10', 128, NULL),
('Luxor', 259, '2019-07-11', 319, NULL),
('Luxor', 259, '2019-07-12', 203, NULL),
('Luxor', 259, '2019-07-13', 292, NULL),
('Luxor', 259, '2019-07-14', 356, NULL),
('Luxor', 259, '2019-07-15', 265, NULL),
('Luxor', 259, '2019-07-16', 288, NULL),
('Luxor', 259, '2019-07-17', 381, NULL),
('Luxor', 259, '2019-07-18', 309, NULL),
('Luxor', 259, '2019-07-19', 382, NULL),
('Luxor', 259, '2019-07-20', 140, NULL),
('Luxor', 259, '2019-07-21', 341, NULL),
('Luxor', 259, '2019-07-22', 153, NULL),
('Luxor', 259, '2019-07-23', 122, NULL),
('Luxor', 259, '2019-07-24', 251, NULL),
('Luxor', 259, '2019-07-25', 368, NULL),
('Luxor', 259, '2019-07-26', 377, NULL),
('Luxor', 259, '2019-07-27', 231, NULL),
('Luxor', 259, '2019-07-28', 322, NULL),
('Luxor', 259, '2019-07-29', 112, NULL),
('Luxor', 259, '2019-07-30', 192, NULL),
('Luxor', 259, '2019-07-31', 258, NULL),
('Luxor', 259, '2019-08-01', 279, NULL),
('Luxor', 259, '2019-08-02', 157, NULL),
('Luxor', 259, '2019-08-03', 359, NULL),
('Luxor', 259, '2019-08-04', 332, NULL),
('Luxor', 259, '2019-08-05', 178, NULL),
('Luxor', 259, '2019-08-06', 307, NULL),
('Luxor', 259, '2019-08-07', 190, NULL),
('Luxor', 259, '2019-08-08', 244, NULL),
('Luxor', 259, '2019-08-09', 352, NULL),
('Luxor', 259, '2019-08-10', 191, NULL),
('Luxor', 259, '2019-08-11', 188, NULL),
('Luxor', 259, '2019-08-12', 331, NULL),
('Luxor', 259, '2019-08-13', 108, NULL),
('Luxor', 259, '2019-08-14', 379, NULL),
('Luxor', 259, '2019-08-15', 381, NULL),
('Luxor', 259, '2019-08-16', 234, NULL),
('Luxor', 259, '2019-08-17', 271, NULL),
('Luxor', 259, '2019-08-18', 232, NULL),
('Luxor', 259, '2019-08-19', 362, NULL),
('Luxor', 259, '2019-08-20', 391, NULL),
('Luxor', 259, '2019-08-21', 109, NULL),
('Luxor', 259, '2019-08-22', 263, NULL),
('Luxor', 259, '2019-08-23', 340, NULL),
('Luxor', 259, '2019-08-24', 153, NULL),
('Luxor', 259, '2019-08-25', 126, NULL),
('Luxor', 259, '2019-08-26', 270, NULL),
('Luxor', 259, '2019-08-27', 124, NULL),
('Luxor', 259, '2019-08-28', 195, NULL),
('Luxor', 259, '2019-08-29', 151, NULL),
('Luxor', 259, '2019-08-30', 325, NULL),
('Luxor', 259, '2019-08-31', 298, NULL),
('Luxor', 259, '2019-09-01', 105, NULL),
('Luxor', 259, '2019-09-02', 325, NULL),
('Luxor', 259, '2019-09-03', 364, NULL),
('Luxor', 259, '2019-09-04', 306, NULL),
('Luxor', 259, '2019-09-05', 230, NULL),
('Luxor', 259, '2019-09-06', 131, NULL),
('Luxor', 259, '2019-09-07', 372, NULL),
('Luxor', 259, '2019-09-08', 213, NULL),
('Luxor', 259, '2019-09-09', 259, NULL),
('Luxor', 259, '2019-09-10', 258, NULL),
('Luxor', 259, '2019-09-11', 256, NULL),
('Luxor', 259, '2019-09-12', 126, NULL),
('Luxor', 259, '2019-09-13', 161, NULL),
('Luxor', 259, '2019-09-14', 197, NULL),
('Luxor', 259, '2019-09-15', 346, NULL),
('Luxor', 259, '2019-09-16', 212, NULL),
('Luxor', 259, '2019-09-17', 171, NULL),
('Luxor', 259, '2019-09-18', 396, NULL),
('Luxor', 259, '2019-09-19', 175, NULL),
('Luxor', 259, '2019-09-20', 288, NULL),
('Luxor', 259, '2019-09-21', 243, NULL),
('Luxor', 259, '2019-09-22', 137, NULL),
('Luxor', 259, '2019-09-23', 137, NULL),
('Luxor', 259, '2019-09-24', 279, NULL),
('Luxor', 259, '2019-09-25', 144, NULL),
('Luxor', 259, '2019-09-26', 259, NULL),
('Luxor', 259, '2019-09-27', 200, NULL),
('Luxor', 259, '2019-09-28', 298, NULL),
('Luxor', 259, '2019-09-29', 179, NULL),
('Luxor', 259, '2019-09-30', 190, NULL),
('Luxor', 259, '2019-10-01', 396, NULL),
('Luxor', 259, '2019-10-02', 204, NULL),
('Luxor', 259, '2019-10-03', 201, NULL),
('Luxor', 259, '2019-10-04', 325, NULL),
('Luxor', 259, '2019-10-05', 345, NULL),
('Luxor', 259, '2019-10-06', 153, NULL),
('Luxor', 259, '2019-10-07', 344, NULL),
('Luxor', 259, '2019-10-08', 197, NULL),
('Luxor', 259, '2019-10-09', 339, NULL),
('Luxor', 259, '2019-10-10', 304, NULL),
('Luxor', 259, '2019-10-11', 267, NULL),
('Luxor', 259, '2019-10-12', 140, NULL),
('Luxor', 259, '2019-10-13', 228, NULL),
('Luxor', 259, '2019-10-14', 225, NULL),
('Luxor', 259, '2019-10-15', 144, NULL),
('Luxor', 259, '2019-10-16', 281, NULL),
('Luxor', 259, '2019-10-17', 246, NULL),
('Luxor', 259, '2019-10-18', 357, NULL),
('Luxor', 259, '2019-10-19', 166, NULL),
('Luxor', 259, '2019-10-20', 251, NULL),
('Luxor', 259, '2019-10-21', 123, NULL),
('Luxor', 259, '2019-10-22', 169, NULL),
('Luxor', 259, '2019-10-23', 372, NULL),
('Luxor', 259, '2019-10-24', 326, NULL),
('Luxor', 259, '2019-10-25', 381, NULL),
('Luxor', 259, '2019-10-26', 294, NULL),
('Luxor', 259, '2019-10-27', 107, NULL),
('Luxor', 259, '2019-10-28', 156, NULL),
('Luxor', 259, '2019-10-29', 102, NULL),
('Luxor', 259, '2019-10-30', 258, NULL),
('Luxor', 259, '2019-10-31', 374, NULL),
('Luxor', 259, '2019-11-01', 336, NULL),
('Luxor', 259, '2019-11-02', 259, NULL),
('Luxor', 259, '2019-11-03', 319, NULL),
('Luxor', 259, '2019-11-04', 252, NULL),
('Luxor', 259, '2019-11-05', 176, NULL),
('Luxor', 259, '2019-11-06', 386, NULL),
('Luxor', 259, '2019-11-07', 326, NULL),
('Luxor', 259, '2019-11-08', 171, NULL),
('Luxor', 259, '2019-11-09', 113, NULL),
('Luxor', 259, '2019-11-10', 110, NULL),
('Luxor', 259, '2019-11-11', 149, NULL),
('Luxor', 259, '2019-11-12', 313, NULL),
('Luxor', 259, '2019-11-13', 164, NULL),
('Luxor', 259, '2019-11-14', 139, NULL),
('Luxor', 259, '2019-11-15', 182, NULL),
('Luxor', 259, '2019-11-16', 337, NULL),
('Luxor', 259, '2019-11-17', 392, NULL),
('Luxor', 259, '2019-11-18', 235, NULL),
('Luxor', 259, '2019-11-19', 391, NULL),
('Luxor', 259, '2019-11-20', 153, NULL),
('Luxor', 259, '2019-11-21', 273, NULL),
('Luxor', 259, '2019-11-22', 230, NULL),
('Luxor', 259, '2019-11-23', 139, NULL),
('Luxor', 259, '2019-11-24', 120, NULL),
('Luxor', 259, '2019-11-25', 273, NULL),
('Luxor', 259, '2019-11-26', 250, NULL),
('Luxor', 259, '2019-11-27', 241, NULL),
('Luxor', 259, '2019-11-28', 265, NULL),
('Luxor', 259, '2019-11-29', 369, NULL),
('Luxor', 259, '2019-11-30', 272, NULL),
('Luxor', 259, '2019-12-01', 140, NULL),
('Luxor', 259, '2019-12-02', 381, NULL),
('Luxor', 259, '2019-12-03', 364, NULL),
('Luxor', 259, '2019-12-04', 143, NULL),
('Luxor', 259, '2019-12-05', 372, NULL),
('Luxor', 259, '2019-12-06', 109, NULL),
('Luxor', 259, '2019-12-07', 210, NULL),
('Luxor', 259, '2019-12-08', 293, NULL),
('Luxor', 259, '2019-12-09', 234, NULL),
('Luxor', 259, '2019-12-10', 193, NULL),
('Luxor', 259, '2019-12-11', 285, NULL),
('Luxor', 259, '2019-12-12', 234, NULL),
('Luxor', 259, '2019-12-13', 292, NULL),
('Luxor', 259, '2019-12-14', 281, NULL),
('Luxor', 259, '2019-12-15', 193, NULL),
('Luxor', 259, '2019-12-16', 381, NULL),
('Luxor', 259, '2019-12-17', 236, NULL),
('Luxor', 259, '2019-12-18', 317, NULL),
('Luxor', 259, '2019-12-19', 307, NULL),
('Luxor', 259, '2019-12-20', 159, NULL),
('Luxor', 259, '2019-12-21', 142, NULL),
('Luxor', 259, '2019-12-22', 275, NULL),
('Luxor', 259, '2019-12-23', 237, NULL),
('Luxor', 259, '2019-12-24', 301, NULL),
('Luxor', 259, '2019-12-25', 162, NULL),
('Luxor', 259, '2019-12-26', 310, NULL),
('Luxor', 259, '2019-12-27', 131, NULL),
('Luxor', 259, '2019-12-28', 274, NULL),
('Luxor', 259, '2019-12-29', 308, NULL),
('Luxor', 259, '2019-12-30', 314, NULL),
('Luxor', 259, '2019-12-31', 115, NULL),
('Luxor', 259, '2020-01-01', 363, NULL),
('Luxor', 259, '2020-01-02', 130, NULL),
('Luxor', 259, '2020-01-03', 221, NULL),
('Luxor', 259, '2020-01-04', 107, NULL),
('Luxor', 259, '2020-01-05', 363, NULL),
('Luxor', 259, '2020-01-06', 138, NULL),
('Luxor', 259, '2020-01-07', 125, NULL),
('Luxor', 259, '2020-01-08', 333, NULL),
('Luxor', 259, '2020-01-09', 130, NULL),
('Luxor', 259, '2020-01-10', 280, NULL),
('Luxor', 259, '2020-01-11', 301, NULL),
('Luxor', 259, '2020-01-12', 230, NULL),
('Luxor', 259, '2020-01-13', 190, NULL),
('Luxor', 259, '2020-01-14', 116, NULL),
('Luxor', 259, '2020-01-15', 332, NULL),
('Luxor', 259, '2020-01-16', 371, NULL),
('Luxor', 259, '2020-01-17', 230, NULL),
('Luxor', 259, '2020-01-18', 140, NULL),
('Luxor', 259, '2020-01-19', 372, NULL),
('Luxor', 259, '2020-01-20', 340, NULL),
('Luxor', 259, '2020-01-21', 162, NULL),
('Luxor', 259, '2020-01-22', 116, NULL),
('Luxor', 259, '2020-01-23', 396, NULL),
('Luxor', 259, '2020-01-24', 181, NULL),
('Luxor', 259, '2020-01-25', 244, NULL),
('Luxor', 259, '2020-01-26', 156, NULL),
('Luxor', 259, '2020-01-27', 309, NULL),
('Luxor', 259, '2020-01-28', 301, NULL),
('Luxor', 259, '2020-01-29', 291, NULL),
('Luxor', 259, '2020-01-30', 123, NULL),
('Luxor', 259, '2020-01-31', 189, NULL),
('Luxor', 259, '2020-02-01', 284, NULL),
('Luxor', 259, '2020-02-02', 175, NULL),
('Luxor', 259, '2020-02-03', 127, NULL),
('Luxor', 259, '2020-02-04', 188, NULL),
('Luxor', 264, '2019-01-01', 132, NULL),
('Luxor', 264, '2019-01-02', 245, NULL),
('Luxor', 264, '2019-01-03', 178, NULL),
('Luxor', 264, '2019-01-04', 391, NULL),
('Luxor', 264, '2019-01-05', 267, NULL),
('Luxor', 264, '2019-01-06', 312, NULL),
('Luxor', 264, '2019-01-07', 210, NULL),
('Luxor', 264, '2019-01-08', 320, NULL),
('Luxor', 264, '2019-01-09', 244, NULL),
('Luxor', 264, '2019-01-10', 203, NULL),
('Luxor', 264, '2019-01-11', 255, NULL),
('Luxor', 264, '2019-01-12', 280, NULL),
('Luxor', 264, '2019-01-13', 200, NULL),
('Luxor', 264, '2019-01-14', 345, NULL),
('Luxor', 264, '2019-01-15', 209, NULL),
('Luxor', 264, '2019-01-16', 120, NULL),
('Luxor', 264, '2019-01-17', 186, NULL),
('Luxor', 264, '2019-01-18', 188, NULL),
('Luxor', 264, '2019-01-19', 102, NULL),
('Luxor', 264, '2019-01-20', 252, NULL),
('Luxor', 264, '2019-01-21', 207, NULL),
('Luxor', 264, '2019-01-22', 335, NULL),
('Luxor', 264, '2019-01-23', 361, NULL),
('Luxor', 264, '2019-01-24', 154, NULL),
('Luxor', 264, '2019-01-25', 151, NULL),
('Luxor', 264, '2019-01-26', 254, NULL),
('Luxor', 264, '2019-01-27', 159, NULL),
('Luxor', 264, '2019-01-28', 188, NULL),
('Luxor', 264, '2019-01-29', 126, NULL),
('Luxor', 264, '2019-01-30', 256, NULL),
('Luxor', 264, '2019-01-31', 330, NULL),
('Luxor', 264, '2019-02-01', 153, NULL),
('Luxor', 264, '2019-02-02', 367, NULL),
('Luxor', 264, '2019-02-03', 183, NULL),
('Luxor', 264, '2019-02-04', 322, NULL),
('Luxor', 264, '2019-02-05', 116, NULL),
('Luxor', 264, '2019-02-06', 310, NULL),
('Luxor', 264, '2019-02-07', 131, NULL),
('Luxor', 264, '2019-02-08', 149, NULL),
('Luxor', 264, '2019-02-09', 284, NULL),
('Luxor', 264, '2019-02-10', 105, NULL),
('Luxor', 264, '2019-02-11', 116, NULL),
('Luxor', 264, '2019-02-12', 277, NULL),
('Luxor', 264, '2019-02-13', 299, NULL),
('Luxor', 264, '2019-02-14', 118, NULL),
('Luxor', 264, '2019-02-15', 232, NULL),
('Luxor', 264, '2019-02-16', 376, NULL),
('Luxor', 264, '2019-02-17', 141, NULL),
('Luxor', 264, '2019-02-18', 100, NULL),
('Luxor', 264, '2019-02-19', 123, NULL),
('Luxor', 264, '2019-02-20', 275, NULL),
('Luxor', 264, '2019-02-21', 138, NULL),
('Luxor', 264, '2019-02-22', 160, NULL),
('Luxor', 264, '2019-02-23', 295, NULL),
('Luxor', 264, '2019-02-24', 387, NULL),
('Luxor', 264, '2019-02-25', 188, NULL),
('Luxor', 264, '2019-02-26', 302, NULL),
('Luxor', 264, '2019-02-27', 117, NULL),
('Luxor', 264, '2019-02-28', 288, NULL),
('Luxor', 264, '2019-03-01', 197, NULL),
('Luxor', 264, '2019-03-02', 131, NULL),
('Luxor', 264, '2019-03-03', 291, NULL),
('Luxor', 264, '2019-03-04', 248, NULL),
('Luxor', 264, '2019-03-05', 302, NULL),
('Luxor', 264, '2019-03-06', 149, NULL),
('Luxor', 264, '2019-03-07', 284, NULL),
('Luxor', 264, '2019-03-08', 291, NULL),
('Luxor', 264, '2019-03-09', 356, NULL),
('Luxor', 264, '2019-03-10', 273, NULL),
('Luxor', 264, '2019-03-11', 262, NULL),
('Luxor', 264, '2019-03-12', 126, NULL),
('Luxor', 264, '2019-03-13', 241, NULL),
('Luxor', 264, '2019-03-14', 242, NULL),
('Luxor', 264, '2019-03-15', 150, NULL),
('Luxor', 264, '2019-03-16', 198, NULL),
('Luxor', 264, '2019-03-17', 326, NULL),
('Luxor', 264, '2019-03-18', 290, NULL),
('Luxor', 264, '2019-03-19', 252, NULL),
('Luxor', 264, '2019-03-20', 370, NULL),
('Luxor', 264, '2019-03-21', 130, NULL),
('Luxor', 264, '2019-03-22', 380, NULL),
('Luxor', 264, '2019-03-23', 338, NULL),
('Luxor', 264, '2019-03-24', 124, NULL),
('Luxor', 264, '2019-03-25', 315, NULL),
('Luxor', 264, '2019-03-26', 390, NULL),
('Luxor', 264, '2019-03-27', 330, NULL),
('Luxor', 264, '2019-03-28', 116, NULL),
('Luxor', 264, '2019-03-29', 255, NULL),
('Luxor', 264, '2019-03-30', 235, NULL),
('Luxor', 264, '2019-03-31', 121, NULL),
('Luxor', 264, '2019-04-01', 237, NULL),
('Luxor', 264, '2019-04-02', 348, NULL),
('Luxor', 264, '2019-04-03', 247, NULL),
('Luxor', 264, '2019-04-04', 107, NULL),
('Luxor', 264, '2019-04-05', 166, NULL),
('Luxor', 264, '2019-04-06', 354, NULL),
('Luxor', 264, '2019-04-07', 124, NULL),
('Luxor', 264, '2019-04-08', 262, NULL),
('Luxor', 264, '2019-04-09', 272, NULL),
('Luxor', 264, '2019-04-10', 188, NULL),
('Luxor', 264, '2019-04-11', 258, NULL),
('Luxor', 264, '2019-04-12', 139, NULL),
('Luxor', 264, '2019-04-13', 284, NULL),
('Luxor', 264, '2019-04-14', 274, NULL),
('Luxor', 264, '2019-04-15', 157, NULL),
('Luxor', 264, '2019-04-16', 385, NULL),
('Luxor', 264, '2019-04-17', 237, NULL),
('Luxor', 264, '2019-04-18', 296, NULL),
('Luxor', 264, '2019-04-19', 200, NULL),
('Luxor', 264, '2019-04-20', 326, NULL),
('Luxor', 264, '2019-04-21', 137, NULL),
('Luxor', 264, '2019-04-22', 233, NULL),
('Luxor', 264, '2019-04-23', 396, NULL),
('Luxor', 264, '2019-04-24', 340, NULL),
('Luxor', 264, '2019-04-25', 197, NULL),
('Luxor', 264, '2019-04-26', 217, NULL),
('Luxor', 264, '2019-04-27', 319, NULL),
('Luxor', 264, '2019-04-28', 322, NULL),
('Luxor', 264, '2019-04-29', 397, NULL),
('Luxor', 264, '2019-04-30', 117, NULL),
('Luxor', 264, '2019-05-01', 128, NULL),
('Luxor', 264, '2019-05-02', 201, NULL),
('Luxor', 264, '2019-05-03', 185, NULL),
('Luxor', 264, '2019-05-04', 335, NULL),
('Luxor', 264, '2019-05-05', 111, NULL),
('Luxor', 264, '2019-05-06', 235, NULL),
('Luxor', 264, '2019-05-07', 232, NULL),
('Luxor', 264, '2019-05-08', 255, NULL),
('Luxor', 264, '2019-05-09', 218, NULL),
('Luxor', 264, '2019-05-10', 301, NULL),
('Luxor', 264, '2019-05-11', 189, NULL),
('Luxor', 264, '2019-05-12', 344, NULL),
('Luxor', 264, '2019-05-13', 336, NULL),
('Luxor', 264, '2019-05-14', 236, NULL),
('Luxor', 264, '2019-05-15', 321, NULL),
('Luxor', 264, '2019-05-16', 319, NULL),
('Luxor', 264, '2019-05-17', 276, NULL),
('Luxor', 264, '2019-05-18', 332, NULL),
('Luxor', 264, '2019-05-19', 251, NULL),
('Luxor', 264, '2019-05-20', 238, NULL),
('Luxor', 264, '2019-05-21', 237, NULL),
('Luxor', 264, '2019-05-22', 237, NULL),
('Luxor', 264, '2019-05-23', 146, NULL),
('Luxor', 264, '2019-05-24', 152, NULL),
('Luxor', 264, '2019-05-25', 332, NULL),
('Luxor', 264, '2019-05-26', 218, NULL),
('Luxor', 264, '2019-05-27', 142, NULL),
('Luxor', 264, '2019-05-28', 312, NULL),
('Luxor', 264, '2019-05-29', 368, NULL),
('Luxor', 264, '2019-05-30', 216, NULL),
('Luxor', 264, '2019-05-31', 359, NULL),
('Luxor', 264, '2019-06-01', 270, NULL),
('Luxor', 264, '2019-06-02', 351, NULL),
('Luxor', 264, '2019-06-03', 205, NULL),
('Luxor', 264, '2019-06-04', 303, NULL),
('Luxor', 264, '2019-06-05', 252, NULL),
('Luxor', 264, '2019-06-06', 270, NULL),
('Luxor', 264, '2019-06-07', 289, NULL),
('Luxor', 264, '2019-06-08', 341, NULL),
('Luxor', 264, '2019-06-09', 325, NULL),
('Luxor', 264, '2019-06-10', 277, NULL),
('Luxor', 264, '2019-06-11', 246, NULL),
('Luxor', 264, '2019-06-12', 369, NULL),
('Luxor', 264, '2019-06-13', 382, NULL),
('Luxor', 264, '2019-06-14', 366, NULL),
('Luxor', 264, '2019-06-15', 172, NULL),
('Luxor', 264, '2019-06-16', 266, NULL),
('Luxor', 264, '2019-06-17', 303, NULL),
('Luxor', 264, '2019-06-18', 101, NULL),
('Luxor', 264, '2019-06-19', 201, NULL),
('Luxor', 264, '2019-06-20', 106, NULL),
('Luxor', 264, '2019-06-21', 328, NULL),
('Luxor', 264, '2019-06-22', 282, NULL),
('Luxor', 264, '2019-06-23', 237, NULL),
('Luxor', 264, '2019-06-24', 243, NULL),
('Luxor', 264, '2019-06-25', 175, NULL),
('Luxor', 264, '2019-06-26', 352, NULL),
('Luxor', 264, '2019-06-27', 279, NULL),
('Luxor', 264, '2019-06-28', 110, NULL),
('Luxor', 264, '2019-06-29', 188, NULL),
('Luxor', 264, '2019-06-30', 398, NULL),
('Luxor', 264, '2019-07-01', 104, NULL),
('Luxor', 264, '2019-07-02', 382, NULL),
('Luxor', 264, '2019-07-03', 368, NULL),
('Luxor', 264, '2019-07-04', 261, NULL),
('Luxor', 264, '2019-07-05', 336, NULL),
('Luxor', 264, '2019-07-06', 228, NULL),
('Luxor', 264, '2019-07-07', 242, NULL),
('Luxor', 264, '2019-07-08', 263, NULL),
('Luxor', 264, '2019-07-09', 302, NULL),
('Luxor', 264, '2019-07-10', 173, NULL),
('Luxor', 264, '2019-07-11', 305, NULL),
('Luxor', 264, '2019-07-12', 279, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 264, '2019-07-13', 239, NULL),
('Luxor', 264, '2019-07-14', 282, NULL),
('Luxor', 264, '2019-07-15', 223, NULL),
('Luxor', 264, '2019-07-16', 211, NULL),
('Luxor', 264, '2019-07-17', 293, NULL),
('Luxor', 264, '2019-07-18', 342, NULL),
('Luxor', 264, '2019-07-19', 359, NULL),
('Luxor', 264, '2019-07-20', 129, NULL),
('Luxor', 264, '2019-07-21', 348, NULL),
('Luxor', 264, '2019-07-22', 375, NULL),
('Luxor', 264, '2019-07-23', 307, NULL),
('Luxor', 264, '2019-07-24', 190, NULL),
('Luxor', 264, '2019-07-25', 307, NULL),
('Luxor', 264, '2019-07-26', 309, NULL),
('Luxor', 264, '2019-07-27', 187, NULL),
('Luxor', 264, '2019-07-28', 177, NULL),
('Luxor', 264, '2019-07-29', 190, NULL),
('Luxor', 264, '2019-07-30', 207, NULL),
('Luxor', 264, '2019-07-31', 337, NULL),
('Luxor', 264, '2019-08-01', 315, NULL),
('Luxor', 264, '2019-08-02', 299, NULL),
('Luxor', 264, '2019-08-03', 342, NULL),
('Luxor', 264, '2019-08-04', 342, NULL),
('Luxor', 264, '2019-08-05', 393, NULL),
('Luxor', 264, '2019-08-06', 121, NULL),
('Luxor', 264, '2019-08-07', 321, NULL),
('Luxor', 264, '2019-08-08', 110, NULL),
('Luxor', 264, '2019-08-09', 105, NULL),
('Luxor', 264, '2019-08-10', 271, NULL),
('Luxor', 264, '2019-08-11', 110, NULL),
('Luxor', 264, '2019-08-12', 154, NULL),
('Luxor', 264, '2019-08-13', 245, NULL),
('Luxor', 264, '2019-08-14', 182, NULL),
('Luxor', 264, '2019-08-15', 355, NULL),
('Luxor', 264, '2019-08-16', 221, NULL),
('Luxor', 264, '2019-08-17', 179, NULL),
('Luxor', 264, '2019-08-18', 244, NULL),
('Luxor', 264, '2019-08-19', 331, NULL),
('Luxor', 264, '2019-08-20', 182, NULL),
('Luxor', 264, '2019-08-21', 117, NULL),
('Luxor', 264, '2019-08-22', 316, NULL),
('Luxor', 264, '2019-08-23', 161, NULL),
('Luxor', 264, '2019-08-24', 221, NULL),
('Luxor', 264, '2019-08-25', 189, NULL),
('Luxor', 264, '2019-08-26', 363, NULL),
('Luxor', 264, '2019-08-27', 155, NULL),
('Luxor', 264, '2019-08-28', 144, NULL),
('Luxor', 264, '2019-08-29', 145, NULL),
('Luxor', 264, '2019-08-30', 376, NULL),
('Luxor', 264, '2019-08-31', 266, NULL),
('Luxor', 264, '2019-09-01', 330, NULL),
('Luxor', 264, '2019-09-02', 247, NULL),
('Luxor', 264, '2019-09-03', 368, NULL),
('Luxor', 264, '2019-09-04', 243, NULL),
('Luxor', 264, '2019-09-05', 222, NULL),
('Luxor', 264, '2019-09-06', 369, NULL),
('Luxor', 264, '2019-09-07', 156, NULL),
('Luxor', 264, '2019-09-08', 159, NULL),
('Luxor', 264, '2019-09-09', 129, NULL),
('Luxor', 264, '2019-09-10', 368, NULL),
('Luxor', 264, '2019-09-11', 159, NULL),
('Luxor', 264, '2019-09-12', 328, NULL),
('Luxor', 264, '2019-09-13', 266, NULL),
('Luxor', 264, '2019-09-14', 233, NULL),
('Luxor', 264, '2019-09-15', 118, NULL),
('Luxor', 264, '2019-09-16', 326, NULL),
('Luxor', 264, '2019-09-17', 170, NULL),
('Luxor', 264, '2019-09-18', 341, NULL),
('Luxor', 264, '2019-09-19', 360, NULL),
('Luxor', 264, '2019-09-20', 226, NULL),
('Luxor', 264, '2019-09-21', 354, NULL),
('Luxor', 264, '2019-09-22', 298, NULL),
('Luxor', 264, '2019-09-23', 336, NULL),
('Luxor', 264, '2019-09-24', 137, NULL),
('Luxor', 264, '2019-09-25', 200, NULL),
('Luxor', 264, '2019-09-26', 232, NULL),
('Luxor', 264, '2019-09-27', 385, NULL),
('Luxor', 264, '2019-09-28', 285, NULL),
('Luxor', 264, '2019-09-29', 163, NULL),
('Luxor', 264, '2019-09-30', 385, NULL),
('Luxor', 264, '2019-10-01', 271, NULL),
('Luxor', 264, '2019-10-02', 274, NULL),
('Luxor', 264, '2019-10-03', 121, NULL),
('Luxor', 264, '2019-10-04', 208, NULL),
('Luxor', 264, '2019-10-05', 145, NULL),
('Luxor', 264, '2019-10-06', 255, NULL),
('Luxor', 264, '2019-10-07', 156, NULL),
('Luxor', 264, '2019-10-08', 258, NULL),
('Luxor', 264, '2019-10-09', 369, NULL),
('Luxor', 264, '2019-10-10', 161, NULL),
('Luxor', 264, '2019-10-11', 235, NULL),
('Luxor', 264, '2019-10-12', 351, NULL),
('Luxor', 264, '2019-10-13', 346, NULL),
('Luxor', 264, '2019-10-14', 357, NULL),
('Luxor', 264, '2019-10-15', 363, NULL),
('Luxor', 264, '2019-10-16', 270, NULL),
('Luxor', 264, '2019-10-17', 114, NULL),
('Luxor', 264, '2019-10-18', 149, NULL),
('Luxor', 264, '2019-10-19', 257, NULL),
('Luxor', 264, '2019-10-20', 123, NULL),
('Luxor', 264, '2019-10-21', 218, NULL),
('Luxor', 264, '2019-10-22', 106, NULL),
('Luxor', 264, '2019-10-23', 178, NULL),
('Luxor', 264, '2019-10-24', 363, NULL),
('Luxor', 264, '2019-10-25', 129, NULL),
('Luxor', 264, '2019-10-26', 360, NULL),
('Luxor', 264, '2019-10-27', 140, NULL),
('Luxor', 264, '2019-10-28', 222, NULL),
('Luxor', 264, '2019-10-29', 391, NULL),
('Luxor', 264, '2019-10-30', 213, NULL),
('Luxor', 264, '2019-10-31', 236, NULL),
('Luxor', 264, '2019-11-01', 246, NULL),
('Luxor', 264, '2019-11-02', 226, NULL),
('Luxor', 264, '2019-11-03', 206, NULL),
('Luxor', 264, '2019-11-04', 347, NULL),
('Luxor', 264, '2019-11-05', 174, NULL),
('Luxor', 264, '2019-11-06', 398, NULL),
('Luxor', 264, '2019-11-07', 110, NULL),
('Luxor', 264, '2019-11-08', 317, NULL),
('Luxor', 264, '2019-11-09', 248, NULL),
('Luxor', 264, '2019-11-10', 349, NULL),
('Luxor', 264, '2019-11-11', 382, NULL),
('Luxor', 264, '2019-11-12', 268, NULL),
('Luxor', 264, '2019-11-13', 324, NULL),
('Luxor', 264, '2019-11-14', 110, NULL),
('Luxor', 264, '2019-11-15', 252, NULL),
('Luxor', 264, '2019-11-16', 283, NULL),
('Luxor', 264, '2019-11-17', 352, NULL),
('Luxor', 264, '2019-11-18', 331, NULL),
('Luxor', 264, '2019-11-19', 253, NULL),
('Luxor', 264, '2019-11-20', 198, NULL),
('Luxor', 264, '2019-11-21', 120, NULL),
('Luxor', 264, '2019-11-22', 202, NULL),
('Luxor', 264, '2019-11-23', 174, NULL),
('Luxor', 264, '2019-11-24', 383, NULL),
('Luxor', 264, '2019-11-25', 270, NULL),
('Luxor', 264, '2019-11-26', 197, NULL),
('Luxor', 264, '2019-11-27', 171, NULL),
('Luxor', 264, '2019-11-28', 316, NULL),
('Luxor', 264, '2019-11-29', 293, NULL),
('Luxor', 264, '2019-11-30', 309, NULL),
('Luxor', 264, '2019-12-01', 153, NULL),
('Luxor', 264, '2019-12-02', 211, NULL),
('Luxor', 264, '2019-12-03', 251, NULL),
('Luxor', 264, '2019-12-04', 131, NULL),
('Luxor', 264, '2019-12-05', 363, NULL),
('Luxor', 264, '2019-12-06', 372, NULL),
('Luxor', 264, '2019-12-07', 100, NULL),
('Luxor', 264, '2019-12-08', 341, NULL),
('Luxor', 264, '2019-12-09', 285, NULL),
('Luxor', 264, '2019-12-10', 251, NULL),
('Luxor', 264, '2019-12-11', 232, NULL),
('Luxor', 264, '2019-12-12', 185, NULL),
('Luxor', 264, '2019-12-13', 231, NULL),
('Luxor', 264, '2019-12-14', 203, NULL),
('Luxor', 264, '2019-12-15', 328, NULL),
('Luxor', 264, '2019-12-16', 208, NULL),
('Luxor', 264, '2019-12-17', 260, NULL),
('Luxor', 264, '2019-12-18', 289, NULL),
('Luxor', 264, '2019-12-19', 200, NULL),
('Luxor', 264, '2019-12-20', 278, NULL),
('Luxor', 264, '2019-12-21', 386, NULL),
('Luxor', 264, '2019-12-22', 290, NULL),
('Luxor', 264, '2019-12-23', 277, NULL),
('Luxor', 264, '2019-12-24', 346, NULL),
('Luxor', 264, '2019-12-25', 327, NULL),
('Luxor', 264, '2019-12-26', 352, NULL),
('Luxor', 264, '2019-12-27', 318, NULL),
('Luxor', 264, '2019-12-28', 232, NULL),
('Luxor', 264, '2019-12-29', 253, NULL),
('Luxor', 264, '2019-12-30', 255, NULL),
('Luxor', 264, '2019-12-31', 234, NULL),
('Luxor', 264, '2020-01-01', 267, NULL),
('Luxor', 264, '2020-01-02', 268, NULL),
('Luxor', 264, '2020-01-03', 260, NULL),
('Luxor', 264, '2020-01-04', 277, NULL),
('Luxor', 264, '2020-01-05', 219, NULL),
('Luxor', 264, '2020-01-06', 399, NULL),
('Luxor', 264, '2020-01-07', 343, NULL),
('Luxor', 264, '2020-01-08', 220, NULL),
('Luxor', 264, '2020-01-09', 294, NULL),
('Luxor', 264, '2020-01-10', 291, NULL),
('Luxor', 264, '2020-01-11', 347, NULL),
('Luxor', 264, '2020-01-12', 188, NULL),
('Luxor', 264, '2020-01-13', 352, NULL),
('Luxor', 264, '2020-01-14', 378, NULL),
('Luxor', 264, '2020-01-15', 277, NULL),
('Luxor', 264, '2020-01-16', 300, NULL),
('Luxor', 264, '2020-01-17', 336, NULL),
('Luxor', 264, '2020-01-18', 385, NULL),
('Luxor', 264, '2020-01-19', 338, NULL),
('Luxor', 264, '2020-01-20', 338, NULL),
('Luxor', 264, '2020-01-21', 395, NULL),
('Luxor', 264, '2020-01-22', 374, NULL),
('Luxor', 264, '2020-01-23', 264, NULL),
('Luxor', 264, '2020-01-24', 298, NULL),
('Luxor', 264, '2020-01-25', 351, NULL),
('Luxor', 264, '2020-01-26', 102, NULL),
('Luxor', 264, '2020-01-27', 196, NULL),
('Luxor', 264, '2020-01-28', 231, NULL),
('Luxor', 264, '2020-01-29', 298, NULL),
('Luxor', 264, '2020-01-30', 205, NULL),
('Luxor', 264, '2020-01-31', 313, NULL),
('Luxor', 264, '2020-02-01', 249, NULL),
('Luxor', 264, '2020-02-02', 317, NULL),
('Luxor', 264, '2020-02-03', 137, NULL),
('Luxor', 264, '2020-02-04', 166, NULL),
('Luxor', 271, '2019-01-01', 203, NULL),
('Luxor', 271, '2019-01-02', 308, NULL),
('Luxor', 271, '2019-01-03', 198, NULL),
('Luxor', 271, '2019-01-04', 363, NULL),
('Luxor', 271, '2019-01-05', 341, NULL),
('Luxor', 271, '2019-01-06', 113, NULL),
('Luxor', 271, '2019-01-07', 398, NULL),
('Luxor', 271, '2019-01-08', 219, NULL),
('Luxor', 271, '2019-01-09', 343, NULL),
('Luxor', 271, '2019-01-10', 304, NULL),
('Luxor', 271, '2019-01-11', 190, NULL),
('Luxor', 271, '2019-01-12', 333, NULL),
('Luxor', 271, '2019-01-13', 342, NULL),
('Luxor', 271, '2019-01-14', 156, NULL),
('Luxor', 271, '2019-01-15', 188, NULL),
('Luxor', 271, '2019-01-16', 203, NULL),
('Luxor', 271, '2019-01-17', 133, NULL),
('Luxor', 271, '2019-01-18', 295, NULL),
('Luxor', 271, '2019-01-19', 300, NULL),
('Luxor', 271, '2019-01-20', 143, NULL),
('Luxor', 271, '2019-01-21', 366, NULL),
('Luxor', 271, '2019-01-22', 340, NULL),
('Luxor', 271, '2019-01-23', 308, NULL),
('Luxor', 271, '2019-01-24', 309, NULL),
('Luxor', 271, '2019-01-25', 118, NULL),
('Luxor', 271, '2019-01-26', 348, NULL),
('Luxor', 271, '2019-01-27', 371, NULL),
('Luxor', 271, '2019-01-28', 323, NULL),
('Luxor', 271, '2019-01-29', 327, NULL),
('Luxor', 271, '2019-01-30', 161, NULL),
('Luxor', 271, '2019-01-31', 274, NULL),
('Luxor', 271, '2019-02-01', 330, NULL),
('Luxor', 271, '2019-02-02', 261, NULL),
('Luxor', 271, '2019-02-03', 100, NULL),
('Luxor', 271, '2019-02-04', 264, NULL),
('Luxor', 271, '2019-02-05', 139, NULL),
('Luxor', 271, '2019-02-06', 305, NULL),
('Luxor', 271, '2019-02-07', 334, NULL),
('Luxor', 271, '2019-02-08', 324, NULL),
('Luxor', 271, '2019-02-09', 276, NULL),
('Luxor', 271, '2019-02-10', 185, NULL),
('Luxor', 271, '2019-02-11', 245, NULL),
('Luxor', 271, '2019-02-12', 284, NULL),
('Luxor', 271, '2019-02-13', 396, NULL),
('Luxor', 271, '2019-02-14', 161, NULL),
('Luxor', 271, '2019-02-15', 121, NULL),
('Luxor', 271, '2019-02-16', 120, NULL),
('Luxor', 271, '2019-02-17', 137, NULL),
('Luxor', 271, '2019-02-18', 251, NULL),
('Luxor', 271, '2019-02-19', 376, NULL),
('Luxor', 271, '2019-02-20', 241, NULL),
('Luxor', 271, '2019-02-21', 135, NULL),
('Luxor', 271, '2019-02-22', 266, NULL),
('Luxor', 271, '2019-02-23', 262, NULL),
('Luxor', 271, '2019-02-24', 196, NULL),
('Luxor', 271, '2019-02-25', 318, NULL),
('Luxor', 271, '2019-02-26', 172, NULL),
('Luxor', 271, '2019-02-27', 198, NULL),
('Luxor', 271, '2019-02-28', 307, NULL),
('Luxor', 271, '2019-03-01', 188, NULL),
('Luxor', 271, '2019-03-02', 245, NULL),
('Luxor', 271, '2019-03-03', 259, NULL),
('Luxor', 271, '2019-03-04', 277, NULL),
('Luxor', 271, '2019-03-05', 140, NULL),
('Luxor', 271, '2019-03-06', 343, NULL),
('Luxor', 271, '2019-03-07', 175, NULL),
('Luxor', 271, '2019-03-08', 342, NULL),
('Luxor', 271, '2019-03-09', 372, NULL),
('Luxor', 271, '2019-03-10', 275, NULL),
('Luxor', 271, '2019-03-11', 289, NULL),
('Luxor', 271, '2019-03-12', 252, NULL),
('Luxor', 271, '2019-03-13', 388, NULL),
('Luxor', 271, '2019-03-14', 244, NULL),
('Luxor', 271, '2019-03-15', 119, NULL),
('Luxor', 271, '2019-03-16', 186, NULL),
('Luxor', 271, '2019-03-17', 201, NULL),
('Luxor', 271, '2019-03-18', 121, NULL),
('Luxor', 271, '2019-03-19', 360, NULL),
('Luxor', 271, '2019-03-20', 155, NULL),
('Luxor', 271, '2019-03-21', 287, NULL),
('Luxor', 271, '2019-03-22', 124, NULL),
('Luxor', 271, '2019-03-23', 252, NULL),
('Luxor', 271, '2019-03-24', 206, NULL),
('Luxor', 271, '2019-03-25', 199, NULL),
('Luxor', 271, '2019-03-26', 192, NULL),
('Luxor', 271, '2019-03-27', 260, NULL),
('Luxor', 271, '2019-03-28', 172, NULL),
('Luxor', 271, '2019-03-29', 277, NULL),
('Luxor', 271, '2019-03-30', 225, NULL),
('Luxor', 271, '2019-03-31', 307, NULL),
('Luxor', 271, '2019-04-01', 127, NULL),
('Luxor', 271, '2019-04-02', 335, NULL),
('Luxor', 271, '2019-04-03', 113, NULL),
('Luxor', 271, '2019-04-04', 149, NULL),
('Luxor', 271, '2019-04-05', 229, NULL),
('Luxor', 271, '2019-04-06', 369, NULL),
('Luxor', 271, '2019-04-07', 301, NULL),
('Luxor', 271, '2019-04-08', 362, NULL),
('Luxor', 271, '2019-04-09', 346, NULL),
('Luxor', 271, '2019-04-10', 395, NULL),
('Luxor', 271, '2019-04-11', 258, NULL),
('Luxor', 271, '2019-04-12', 343, NULL),
('Luxor', 271, '2019-04-13', 143, NULL),
('Luxor', 271, '2019-04-14', 345, NULL),
('Luxor', 271, '2019-04-15', 219, NULL),
('Luxor', 271, '2019-04-16', 242, NULL),
('Luxor', 271, '2019-04-17', 272, NULL),
('Luxor', 271, '2019-04-18', 263, NULL),
('Luxor', 271, '2019-04-19', 375, NULL),
('Luxor', 271, '2019-04-20', 391, NULL),
('Luxor', 271, '2019-04-21', 320, NULL),
('Luxor', 271, '2019-04-22', 343, NULL),
('Luxor', 271, '2019-04-23', 219, NULL),
('Luxor', 271, '2019-04-24', 142, NULL),
('Luxor', 271, '2019-04-25', 316, NULL),
('Luxor', 271, '2019-04-26', 339, NULL),
('Luxor', 271, '2019-04-27', 220, NULL),
('Luxor', 271, '2019-04-28', 300, NULL),
('Luxor', 271, '2019-04-29', 367, NULL),
('Luxor', 271, '2019-04-30', 224, NULL),
('Luxor', 271, '2019-05-01', 302, NULL),
('Luxor', 271, '2019-05-02', 300, NULL),
('Luxor', 271, '2019-05-03', 177, NULL),
('Luxor', 271, '2019-05-04', 277, NULL),
('Luxor', 271, '2019-05-05', 177, NULL),
('Luxor', 271, '2019-05-06', 293, NULL),
('Luxor', 271, '2019-05-07', 240, NULL),
('Luxor', 271, '2019-05-08', 358, NULL),
('Luxor', 271, '2019-05-09', 380, NULL),
('Luxor', 271, '2019-05-10', 340, NULL),
('Luxor', 271, '2019-05-11', 310, NULL),
('Luxor', 271, '2019-05-12', 162, NULL),
('Luxor', 271, '2019-05-13', 152, NULL),
('Luxor', 271, '2019-05-14', 338, NULL),
('Luxor', 271, '2019-05-15', 326, NULL),
('Luxor', 271, '2019-05-16', 270, NULL),
('Luxor', 271, '2019-05-17', 204, NULL),
('Luxor', 271, '2019-05-18', 392, NULL),
('Luxor', 271, '2019-05-19', 298, NULL),
('Luxor', 271, '2019-05-20', 154, NULL),
('Luxor', 271, '2019-05-21', 124, NULL),
('Luxor', 271, '2019-05-22', 203, NULL),
('Luxor', 271, '2019-05-23', 104, NULL),
('Luxor', 271, '2019-05-24', 225, NULL),
('Luxor', 271, '2019-05-25', 133, NULL),
('Luxor', 271, '2019-05-26', 110, NULL),
('Luxor', 271, '2019-05-27', 161, NULL),
('Luxor', 271, '2019-05-28', 132, NULL),
('Luxor', 271, '2019-05-29', 388, NULL),
('Luxor', 271, '2019-05-30', 225, NULL),
('Luxor', 271, '2019-05-31', 200, NULL),
('Luxor', 271, '2019-06-01', 348, NULL),
('Luxor', 271, '2019-06-02', 298, NULL),
('Luxor', 271, '2019-06-03', 266, NULL),
('Luxor', 271, '2019-06-04', 292, NULL),
('Luxor', 271, '2019-06-05', 214, NULL),
('Luxor', 271, '2019-06-06', 371, NULL),
('Luxor', 271, '2019-06-07', 305, NULL),
('Luxor', 271, '2019-06-08', 385, NULL),
('Luxor', 271, '2019-06-09', 116, NULL),
('Luxor', 271, '2019-06-10', 364, NULL),
('Luxor', 271, '2019-06-11', 220, NULL),
('Luxor', 271, '2019-06-12', 372, NULL),
('Luxor', 271, '2019-06-13', 399, NULL),
('Luxor', 271, '2019-06-14', 134, NULL),
('Luxor', 271, '2019-06-15', 112, NULL),
('Luxor', 271, '2019-06-16', 201, NULL),
('Luxor', 271, '2019-06-17', 255, NULL),
('Luxor', 271, '2019-06-18', 237, NULL),
('Luxor', 271, '2019-06-19', 183, NULL),
('Luxor', 271, '2019-06-20', 153, NULL),
('Luxor', 271, '2019-06-21', 395, NULL),
('Luxor', 271, '2019-06-22', 229, NULL),
('Luxor', 271, '2019-06-23', 370, NULL),
('Luxor', 271, '2019-06-24', 122, NULL),
('Luxor', 271, '2019-06-25', 184, NULL),
('Luxor', 271, '2019-06-26', 119, NULL),
('Luxor', 271, '2019-06-27', 349, NULL),
('Luxor', 271, '2019-06-28', 209, NULL),
('Luxor', 271, '2019-06-29', 367, NULL),
('Luxor', 271, '2019-06-30', 314, NULL),
('Luxor', 271, '2019-07-01', 178, NULL),
('Luxor', 271, '2019-07-02', 300, NULL),
('Luxor', 271, '2019-07-03', 186, NULL),
('Luxor', 271, '2019-07-04', 315, NULL),
('Luxor', 271, '2019-07-05', 385, NULL),
('Luxor', 271, '2019-07-06', 176, NULL),
('Luxor', 271, '2019-07-07', 299, NULL),
('Luxor', 271, '2019-07-08', 279, NULL),
('Luxor', 271, '2019-07-09', 290, NULL),
('Luxor', 271, '2019-07-10', 381, NULL),
('Luxor', 271, '2019-07-11', 169, NULL),
('Luxor', 271, '2019-07-12', 386, NULL),
('Luxor', 271, '2019-07-13', 217, NULL),
('Luxor', 271, '2019-07-14', 243, NULL),
('Luxor', 271, '2019-07-15', 221, NULL),
('Luxor', 271, '2019-07-16', 392, NULL),
('Luxor', 271, '2019-07-17', 222, NULL),
('Luxor', 271, '2019-07-18', 382, NULL),
('Luxor', 271, '2019-07-19', 248, NULL),
('Luxor', 271, '2019-07-20', 123, NULL),
('Luxor', 271, '2019-07-21', 315, NULL),
('Luxor', 271, '2019-07-22', 116, NULL),
('Luxor', 271, '2019-07-23', 169, NULL),
('Luxor', 271, '2019-07-24', 396, NULL),
('Luxor', 271, '2019-07-25', 329, NULL),
('Luxor', 271, '2019-07-26', 315, NULL),
('Luxor', 271, '2019-07-27', 142, NULL),
('Luxor', 271, '2019-07-28', 117, NULL),
('Luxor', 271, '2019-07-29', 213, NULL),
('Luxor', 271, '2019-07-30', 361, NULL),
('Luxor', 271, '2019-07-31', 212, NULL),
('Luxor', 271, '2019-08-01', 340, NULL),
('Luxor', 271, '2019-08-02', 327, NULL),
('Luxor', 271, '2019-08-03', 232, NULL),
('Luxor', 271, '2019-08-04', 316, NULL),
('Luxor', 271, '2019-08-05', 133, NULL),
('Luxor', 271, '2019-08-06', 187, NULL),
('Luxor', 271, '2019-08-07', 334, NULL),
('Luxor', 271, '2019-08-08', 318, NULL),
('Luxor', 271, '2019-08-09', 269, NULL),
('Luxor', 271, '2019-08-10', 381, NULL),
('Luxor', 271, '2019-08-11', 189, NULL),
('Luxor', 271, '2019-08-12', 276, NULL),
('Luxor', 271, '2019-08-13', 204, NULL),
('Luxor', 271, '2019-08-14', 272, NULL),
('Luxor', 271, '2019-08-15', 232, NULL),
('Luxor', 271, '2019-08-16', 304, NULL),
('Luxor', 271, '2019-08-17', 282, NULL),
('Luxor', 271, '2019-08-18', 126, NULL),
('Luxor', 271, '2019-08-19', 172, NULL),
('Luxor', 271, '2019-08-20', 236, NULL),
('Luxor', 271, '2019-08-21', 161, NULL),
('Luxor', 271, '2019-08-22', 392, NULL),
('Luxor', 271, '2019-08-23', 286, NULL),
('Luxor', 271, '2019-08-24', 245, NULL),
('Luxor', 271, '2019-08-25', 168, NULL),
('Luxor', 271, '2019-08-26', 306, NULL),
('Luxor', 271, '2019-08-27', 306, NULL),
('Luxor', 271, '2019-08-28', 337, NULL),
('Luxor', 271, '2019-08-29', 173, NULL),
('Luxor', 271, '2019-08-30', 207, NULL),
('Luxor', 271, '2019-08-31', 338, NULL),
('Luxor', 271, '2019-09-01', 337, NULL),
('Luxor', 271, '2019-09-02', 159, NULL),
('Luxor', 271, '2019-09-03', 346, NULL),
('Luxor', 271, '2019-09-04', 198, NULL),
('Luxor', 271, '2019-09-05', 322, NULL),
('Luxor', 271, '2019-09-06', 153, NULL),
('Luxor', 271, '2019-09-07', 162, NULL),
('Luxor', 271, '2019-09-08', 357, NULL),
('Luxor', 271, '2019-09-09', 370, NULL),
('Luxor', 271, '2019-09-10', 366, NULL),
('Luxor', 271, '2019-09-11', 230, NULL),
('Luxor', 271, '2019-09-12', 265, NULL),
('Luxor', 271, '2019-09-13', 146, NULL),
('Luxor', 271, '2019-09-14', 173, NULL),
('Luxor', 271, '2019-09-15', 352, NULL),
('Luxor', 271, '2019-09-16', 293, NULL),
('Luxor', 271, '2019-09-17', 241, NULL),
('Luxor', 271, '2019-09-18', 116, NULL),
('Luxor', 271, '2019-09-19', 275, NULL),
('Luxor', 271, '2019-09-20', 166, NULL),
('Luxor', 271, '2019-09-21', 343, NULL),
('Luxor', 271, '2019-09-22', 378, NULL),
('Luxor', 271, '2019-09-23', 270, NULL),
('Luxor', 271, '2019-09-24', 348, NULL),
('Luxor', 271, '2019-09-25', 170, NULL),
('Luxor', 271, '2019-09-26', 284, NULL),
('Luxor', 271, '2019-09-27', 328, NULL),
('Luxor', 271, '2019-09-28', 130, NULL),
('Luxor', 271, '2019-09-29', 175, NULL),
('Luxor', 271, '2019-09-30', 355, NULL),
('Luxor', 271, '2019-10-01', 368, NULL),
('Luxor', 271, '2019-10-02', 357, NULL),
('Luxor', 271, '2019-10-03', 200, NULL),
('Luxor', 271, '2019-10-04', 264, NULL),
('Luxor', 271, '2019-10-05', 190, NULL),
('Luxor', 271, '2019-10-06', 116, NULL),
('Luxor', 271, '2019-10-07', 249, NULL),
('Luxor', 271, '2019-10-08', 301, NULL),
('Luxor', 271, '2019-10-09', 131, NULL),
('Luxor', 271, '2019-10-10', 395, NULL),
('Luxor', 271, '2019-10-11', 274, NULL),
('Luxor', 271, '2019-10-12', 337, NULL),
('Luxor', 271, '2019-10-13', 348, NULL),
('Luxor', 271, '2019-10-14', 113, NULL),
('Luxor', 271, '2019-10-15', 386, NULL),
('Luxor', 271, '2019-10-16', 108, NULL),
('Luxor', 271, '2019-10-17', 332, NULL),
('Luxor', 271, '2019-10-18', 175, NULL),
('Luxor', 271, '2019-10-19', 390, NULL),
('Luxor', 271, '2019-10-20', 359, NULL),
('Luxor', 271, '2019-10-21', 325, NULL),
('Luxor', 271, '2019-10-22', 225, NULL),
('Luxor', 271, '2019-10-23', 277, NULL),
('Luxor', 271, '2019-10-24', 136, NULL),
('Luxor', 271, '2019-10-25', 303, NULL),
('Luxor', 271, '2019-10-26', 217, NULL),
('Luxor', 271, '2019-10-27', 280, NULL),
('Luxor', 271, '2019-10-28', 240, NULL),
('Luxor', 271, '2019-10-29', 351, NULL),
('Luxor', 271, '2019-10-30', 192, NULL),
('Luxor', 271, '2019-10-31', 257, NULL),
('Luxor', 271, '2019-11-01', 124, NULL),
('Luxor', 271, '2019-11-02', 254, NULL),
('Luxor', 271, '2019-11-03', 274, NULL),
('Luxor', 271, '2019-11-04', 277, NULL),
('Luxor', 271, '2019-11-05', 244, NULL),
('Luxor', 271, '2019-11-06', 130, NULL),
('Luxor', 271, '2019-11-07', 371, NULL),
('Luxor', 271, '2019-11-08', 371, NULL),
('Luxor', 271, '2019-11-09', 202, NULL),
('Luxor', 271, '2019-11-10', 119, NULL),
('Luxor', 271, '2019-11-11', 163, NULL),
('Luxor', 271, '2019-11-12', 304, NULL),
('Luxor', 271, '2019-11-13', 130, NULL),
('Luxor', 271, '2019-11-14', 332, NULL),
('Luxor', 271, '2019-11-15', 315, NULL),
('Luxor', 271, '2019-11-16', 305, NULL),
('Luxor', 271, '2019-11-17', 183, NULL),
('Luxor', 271, '2019-11-18', 250, NULL),
('Luxor', 271, '2019-11-19', 292, NULL),
('Luxor', 271, '2019-11-20', 130, NULL),
('Luxor', 271, '2019-11-21', 282, NULL),
('Luxor', 271, '2019-11-22', 221, NULL),
('Luxor', 271, '2019-11-23', 353, NULL),
('Luxor', 271, '2019-11-24', 257, NULL),
('Luxor', 271, '2019-11-25', 131, NULL),
('Luxor', 271, '2019-11-26', 136, NULL),
('Luxor', 271, '2019-11-27', 331, NULL),
('Luxor', 271, '2019-11-28', 387, NULL),
('Luxor', 271, '2019-11-29', 260, NULL),
('Luxor', 271, '2019-11-30', 328, NULL),
('Luxor', 271, '2019-12-01', 245, NULL),
('Luxor', 271, '2019-12-02', 111, NULL),
('Luxor', 271, '2019-12-03', 365, NULL),
('Luxor', 271, '2019-12-04', 124, NULL),
('Luxor', 271, '2019-12-05', 297, NULL),
('Luxor', 271, '2019-12-06', 231, NULL),
('Luxor', 271, '2019-12-07', 372, NULL),
('Luxor', 271, '2019-12-08', 125, NULL),
('Luxor', 271, '2019-12-09', 323, NULL),
('Luxor', 271, '2019-12-10', 278, NULL),
('Luxor', 271, '2019-12-11', 204, NULL),
('Luxor', 271, '2019-12-12', 125, NULL),
('Luxor', 271, '2019-12-13', 177, NULL),
('Luxor', 271, '2019-12-14', 372, NULL),
('Luxor', 271, '2019-12-15', 359, NULL),
('Luxor', 271, '2019-12-16', 396, NULL),
('Luxor', 271, '2019-12-17', 191, NULL),
('Luxor', 271, '2019-12-18', 392, NULL),
('Luxor', 271, '2019-12-19', 277, NULL),
('Luxor', 271, '2019-12-20', 214, NULL),
('Luxor', 271, '2019-12-21', 203, NULL),
('Luxor', 271, '2019-12-22', 224, NULL),
('Luxor', 271, '2019-12-23', 274, NULL),
('Luxor', 271, '2019-12-24', 128, NULL),
('Luxor', 271, '2019-12-25', 148, NULL),
('Luxor', 271, '2019-12-26', 130, NULL),
('Luxor', 271, '2019-12-27', 197, NULL),
('Luxor', 271, '2019-12-28', 241, NULL),
('Luxor', 271, '2019-12-29', 244, NULL),
('Luxor', 271, '2019-12-30', 235, NULL),
('Luxor', 271, '2019-12-31', 125, NULL),
('Luxor', 271, '2020-01-01', 144, NULL),
('Luxor', 271, '2020-01-02', 251, NULL),
('Luxor', 271, '2020-01-03', 240, NULL),
('Luxor', 271, '2020-01-04', 362, NULL),
('Luxor', 271, '2020-01-05', 209, NULL),
('Luxor', 271, '2020-01-06', 281, NULL),
('Luxor', 271, '2020-01-07', 339, NULL),
('Luxor', 271, '2020-01-08', 305, NULL),
('Luxor', 271, '2020-01-09', 381, NULL),
('Luxor', 271, '2020-01-10', 216, NULL),
('Luxor', 271, '2020-01-11', 132, NULL),
('Luxor', 271, '2020-01-12', 150, NULL),
('Luxor', 271, '2020-01-13', 191, NULL),
('Luxor', 271, '2020-01-14', 244, NULL),
('Luxor', 271, '2020-01-15', 291, NULL),
('Luxor', 271, '2020-01-16', 288, NULL),
('Luxor', 271, '2020-01-17', 289, NULL),
('Luxor', 271, '2020-01-18', 207, NULL),
('Luxor', 271, '2020-01-19', 175, NULL),
('Luxor', 271, '2020-01-20', 272, NULL),
('Luxor', 271, '2020-01-21', 189, NULL),
('Luxor', 271, '2020-01-22', 225, NULL),
('Luxor', 271, '2020-01-23', 334, NULL),
('Luxor', 271, '2020-01-24', 249, NULL),
('Luxor', 271, '2020-01-25', 326, NULL),
('Luxor', 271, '2020-01-26', 244, NULL),
('Luxor', 271, '2020-01-27', 253, NULL),
('Luxor', 271, '2020-01-28', 151, NULL),
('Luxor', 271, '2020-01-29', 219, NULL),
('Luxor', 271, '2020-01-30', 259, NULL),
('Luxor', 271, '2020-01-31', 298, NULL),
('Luxor', 271, '2020-02-01', 296, NULL),
('Luxor', 271, '2020-02-02', 361, NULL),
('Luxor', 271, '2020-02-03', 208, NULL),
('Luxor', 271, '2020-02-04', 163, NULL),
('Luxor', 272, '2019-01-01', 219, NULL),
('Luxor', 272, '2019-01-02', 102, NULL),
('Luxor', 272, '2019-01-03', 356, NULL),
('Luxor', 272, '2019-01-04', 242, NULL),
('Luxor', 272, '2019-01-05', 206, NULL),
('Luxor', 272, '2019-01-06', 129, NULL),
('Luxor', 272, '2019-01-07', 363, NULL),
('Luxor', 272, '2019-01-08', 335, NULL),
('Luxor', 272, '2019-01-09', 285, NULL),
('Luxor', 272, '2019-01-10', 208, NULL),
('Luxor', 272, '2019-01-11', 385, NULL),
('Luxor', 272, '2019-01-12', 122, NULL),
('Luxor', 272, '2019-01-13', 111, NULL),
('Luxor', 272, '2019-01-14', 245, NULL),
('Luxor', 272, '2019-01-15', 212, NULL),
('Luxor', 272, '2019-01-16', 258, NULL),
('Luxor', 272, '2019-01-17', 305, NULL),
('Luxor', 272, '2019-01-18', 212, NULL),
('Luxor', 272, '2019-01-19', 196, NULL),
('Luxor', 272, '2019-01-20', 159, NULL),
('Luxor', 272, '2019-01-21', 212, NULL),
('Luxor', 272, '2019-01-22', 293, NULL),
('Luxor', 272, '2019-01-23', 360, NULL),
('Luxor', 272, '2019-01-24', 383, NULL),
('Luxor', 272, '2019-01-25', 338, NULL),
('Luxor', 272, '2019-01-26', 276, NULL),
('Luxor', 272, '2019-01-27', 380, NULL),
('Luxor', 272, '2019-01-28', 349, NULL),
('Luxor', 272, '2019-01-29', 261, NULL),
('Luxor', 272, '2019-01-30', 238, NULL),
('Luxor', 272, '2019-01-31', 280, NULL),
('Luxor', 272, '2019-02-01', 188, NULL),
('Luxor', 272, '2019-02-02', 103, NULL),
('Luxor', 272, '2019-02-03', 150, NULL),
('Luxor', 272, '2019-02-04', 257, NULL),
('Luxor', 272, '2019-02-05', 247, NULL),
('Luxor', 272, '2019-02-06', 195, NULL),
('Luxor', 272, '2019-02-07', 276, NULL),
('Luxor', 272, '2019-02-08', 172, NULL),
('Luxor', 272, '2019-02-09', 126, NULL),
('Luxor', 272, '2019-02-10', 212, NULL),
('Luxor', 272, '2019-02-11', 175, NULL),
('Luxor', 272, '2019-02-12', 188, NULL),
('Luxor', 272, '2019-02-13', 385, NULL),
('Luxor', 272, '2019-02-14', 349, NULL),
('Luxor', 272, '2019-02-15', 108, NULL),
('Luxor', 272, '2019-02-16', 275, NULL),
('Luxor', 272, '2019-02-17', 161, NULL),
('Luxor', 272, '2019-02-18', 257, NULL),
('Luxor', 272, '2019-02-19', 213, NULL),
('Luxor', 272, '2019-02-20', 277, NULL),
('Luxor', 272, '2019-02-21', 162, NULL),
('Luxor', 272, '2019-02-22', 151, NULL),
('Luxor', 272, '2019-02-23', 324, NULL),
('Luxor', 272, '2019-02-24', 318, NULL),
('Luxor', 272, '2019-02-25', 326, NULL),
('Luxor', 272, '2019-02-26', 157, NULL),
('Luxor', 272, '2019-02-27', 239, NULL),
('Luxor', 272, '2019-02-28', 274, NULL),
('Luxor', 272, '2019-03-01', 248, NULL),
('Luxor', 272, '2019-03-02', 133, NULL),
('Luxor', 272, '2019-03-03', 323, NULL),
('Luxor', 272, '2019-03-04', 241, NULL),
('Luxor', 272, '2019-03-05', 292, NULL),
('Luxor', 272, '2019-03-06', 267, NULL),
('Luxor', 272, '2019-03-07', 224, NULL),
('Luxor', 272, '2019-03-08', 139, NULL),
('Luxor', 272, '2019-03-09', 390, NULL),
('Luxor', 272, '2019-03-10', 155, NULL),
('Luxor', 272, '2019-03-11', 259, NULL),
('Luxor', 272, '2019-03-12', 184, NULL),
('Luxor', 272, '2019-03-13', 220, NULL),
('Luxor', 272, '2019-03-14', 398, NULL),
('Luxor', 272, '2019-03-15', 345, NULL),
('Luxor', 272, '2019-03-16', 239, NULL),
('Luxor', 272, '2019-03-17', 228, NULL),
('Luxor', 272, '2019-03-18', 235, NULL),
('Luxor', 272, '2019-03-19', 344, NULL),
('Luxor', 272, '2019-03-20', 167, NULL),
('Luxor', 272, '2019-03-21', 346, NULL),
('Luxor', 272, '2019-03-22', 281, NULL),
('Luxor', 272, '2019-03-23', 145, NULL),
('Luxor', 272, '2019-03-24', 259, NULL),
('Luxor', 272, '2019-03-25', 251, NULL),
('Luxor', 272, '2019-03-26', 290, NULL),
('Luxor', 272, '2019-03-27', 207, NULL),
('Luxor', 272, '2019-03-28', 113, NULL),
('Luxor', 272, '2019-03-29', 221, NULL),
('Luxor', 272, '2019-03-30', 318, NULL),
('Luxor', 272, '2019-03-31', 175, NULL),
('Luxor', 272, '2019-04-01', 123, NULL),
('Luxor', 272, '2019-04-02', 230, NULL),
('Luxor', 272, '2019-04-03', 325, NULL),
('Luxor', 272, '2019-04-04', 325, NULL),
('Luxor', 272, '2019-04-05', 247, NULL),
('Luxor', 272, '2019-04-06', 384, NULL),
('Luxor', 272, '2019-04-07', 130, NULL),
('Luxor', 272, '2019-04-08', 325, NULL),
('Luxor', 272, '2019-04-09', 213, NULL),
('Luxor', 272, '2019-04-10', 112, NULL),
('Luxor', 272, '2019-04-11', 117, NULL),
('Luxor', 272, '2019-04-12', 297, NULL),
('Luxor', 272, '2019-04-13', 363, NULL),
('Luxor', 272, '2019-04-14', 203, NULL),
('Luxor', 272, '2019-04-15', 227, NULL),
('Luxor', 272, '2019-04-16', 257, NULL),
('Luxor', 272, '2019-04-17', 250, NULL),
('Luxor', 272, '2019-04-18', 324, NULL),
('Luxor', 272, '2019-04-19', 274, NULL),
('Luxor', 272, '2019-04-20', 278, NULL),
('Luxor', 272, '2019-04-21', 188, NULL),
('Luxor', 272, '2019-04-22', 316, NULL),
('Luxor', 272, '2019-04-23', 111, NULL),
('Luxor', 272, '2019-04-24', 188, NULL),
('Luxor', 272, '2019-04-25', 292, NULL),
('Luxor', 272, '2019-04-26', 346, NULL),
('Luxor', 272, '2019-04-27', 342, NULL),
('Luxor', 272, '2019-04-28', 136, NULL),
('Luxor', 272, '2019-04-29', 246, NULL),
('Luxor', 272, '2019-04-30', 370, NULL),
('Luxor', 272, '2019-05-01', 124, NULL),
('Luxor', 272, '2019-05-02', 195, NULL),
('Luxor', 272, '2019-05-03', 234, NULL),
('Luxor', 272, '2019-05-04', 282, NULL),
('Luxor', 272, '2019-05-05', 152, NULL),
('Luxor', 272, '2019-05-06', 361, NULL),
('Luxor', 272, '2019-05-07', 103, NULL),
('Luxor', 272, '2019-05-08', 323, NULL),
('Luxor', 272, '2019-05-09', 246, NULL),
('Luxor', 272, '2019-05-10', 397, NULL),
('Luxor', 272, '2019-05-11', 282, NULL),
('Luxor', 272, '2019-05-12', 278, NULL),
('Luxor', 272, '2019-05-13', 250, NULL),
('Luxor', 272, '2019-05-14', 283, NULL),
('Luxor', 272, '2019-05-15', 269, NULL),
('Luxor', 272, '2019-05-16', 296, NULL),
('Luxor', 272, '2019-05-17', 392, NULL),
('Luxor', 272, '2019-05-18', 264, NULL),
('Luxor', 272, '2019-05-19', 336, NULL),
('Luxor', 272, '2019-05-20', 256, NULL),
('Luxor', 272, '2019-05-21', 111, NULL),
('Luxor', 272, '2019-05-22', 205, NULL),
('Luxor', 272, '2019-05-23', 282, NULL),
('Luxor', 272, '2019-05-24', 272, NULL),
('Luxor', 272, '2019-05-25', 169, NULL),
('Luxor', 272, '2019-05-26', 395, NULL),
('Luxor', 272, '2019-05-27', 278, NULL),
('Luxor', 272, '2019-05-28', 222, NULL),
('Luxor', 272, '2019-05-29', 136, NULL),
('Luxor', 272, '2019-05-30', 378, NULL),
('Luxor', 272, '2019-05-31', 123, NULL),
('Luxor', 272, '2019-06-01', 234, NULL),
('Luxor', 272, '2019-06-02', 339, NULL),
('Luxor', 272, '2019-06-03', 313, NULL),
('Luxor', 272, '2019-06-04', 151, NULL),
('Luxor', 272, '2019-06-05', 215, NULL),
('Luxor', 272, '2019-06-06', 342, NULL),
('Luxor', 272, '2019-06-07', 261, NULL),
('Luxor', 272, '2019-06-08', 202, NULL),
('Luxor', 272, '2019-06-09', 105, NULL),
('Luxor', 272, '2019-06-10', 290, NULL),
('Luxor', 272, '2019-06-11', 259, NULL),
('Luxor', 272, '2019-06-12', 354, NULL),
('Luxor', 272, '2019-06-13', 152, NULL),
('Luxor', 272, '2019-06-14', 374, NULL),
('Luxor', 272, '2019-06-15', 246, NULL),
('Luxor', 272, '2019-06-16', 108, NULL),
('Luxor', 272, '2019-06-17', 267, NULL),
('Luxor', 272, '2019-06-18', 184, NULL),
('Luxor', 272, '2019-06-19', 211, NULL),
('Luxor', 272, '2019-06-20', 349, NULL),
('Luxor', 272, '2019-06-21', 295, NULL),
('Luxor', 272, '2019-06-22', 199, NULL),
('Luxor', 272, '2019-06-23', 140, NULL),
('Luxor', 272, '2019-06-24', 378, NULL),
('Luxor', 272, '2019-06-25', 298, NULL),
('Luxor', 272, '2019-06-26', 341, NULL),
('Luxor', 272, '2019-06-27', 208, NULL),
('Luxor', 272, '2019-06-28', 317, NULL),
('Luxor', 272, '2019-06-29', 269, NULL),
('Luxor', 272, '2019-06-30', 275, NULL),
('Luxor', 272, '2019-07-01', 180, NULL),
('Luxor', 272, '2019-07-02', 251, NULL),
('Luxor', 272, '2019-07-03', 328, NULL),
('Luxor', 272, '2019-07-04', 391, NULL),
('Luxor', 272, '2019-07-05', 218, NULL),
('Luxor', 272, '2019-07-06', 100, NULL),
('Luxor', 272, '2019-07-07', 368, NULL),
('Luxor', 272, '2019-07-08', 207, NULL),
('Luxor', 272, '2019-07-09', 143, NULL),
('Luxor', 272, '2019-07-10', 385, NULL),
('Luxor', 272, '2019-07-11', 132, NULL),
('Luxor', 272, '2019-07-12', 393, NULL),
('Luxor', 272, '2019-07-13', 268, NULL),
('Luxor', 272, '2019-07-14', 269, NULL),
('Luxor', 272, '2019-07-15', 337, NULL),
('Luxor', 272, '2019-07-16', 325, NULL),
('Luxor', 272, '2019-07-17', 133, NULL),
('Luxor', 272, '2019-07-18', 183, NULL),
('Luxor', 272, '2019-07-19', 363, NULL),
('Luxor', 272, '2019-07-20', 129, NULL),
('Luxor', 272, '2019-07-21', 134, NULL),
('Luxor', 272, '2019-07-22', 256, NULL),
('Luxor', 272, '2019-07-23', 126, NULL),
('Luxor', 272, '2019-07-24', 112, NULL),
('Luxor', 272, '2019-07-25', 325, NULL),
('Luxor', 272, '2019-07-26', 248, NULL),
('Luxor', 272, '2019-07-27', 352, NULL),
('Luxor', 272, '2019-07-28', 258, NULL),
('Luxor', 272, '2019-07-29', 395, NULL),
('Luxor', 272, '2019-07-30', 184, NULL),
('Luxor', 272, '2019-07-31', 250, NULL),
('Luxor', 272, '2019-08-01', 355, NULL),
('Luxor', 272, '2019-08-02', 338, NULL),
('Luxor', 272, '2019-08-03', 338, NULL),
('Luxor', 272, '2019-08-04', 153, NULL),
('Luxor', 272, '2019-08-05', 284, NULL),
('Luxor', 272, '2019-08-06', 173, NULL),
('Luxor', 272, '2019-08-07', 307, NULL),
('Luxor', 272, '2019-08-08', 260, NULL),
('Luxor', 272, '2019-08-09', 333, NULL),
('Luxor', 272, '2019-08-10', 395, NULL),
('Luxor', 272, '2019-08-11', 214, NULL),
('Luxor', 272, '2019-08-12', 219, NULL),
('Luxor', 272, '2019-08-13', 185, NULL),
('Luxor', 272, '2019-08-14', 116, NULL),
('Luxor', 272, '2019-08-15', 297, NULL),
('Luxor', 272, '2019-08-16', 158, NULL),
('Luxor', 272, '2019-08-17', 175, NULL),
('Luxor', 272, '2019-08-18', 395, NULL),
('Luxor', 272, '2019-08-19', 365, NULL),
('Luxor', 272, '2019-08-20', 237, NULL),
('Luxor', 272, '2019-08-21', 353, NULL),
('Luxor', 272, '2019-08-22', 312, NULL),
('Luxor', 272, '2019-08-23', 245, NULL),
('Luxor', 272, '2019-08-24', 162, NULL),
('Luxor', 272, '2019-08-25', 175, NULL),
('Luxor', 272, '2019-08-26', 341, NULL),
('Luxor', 272, '2019-08-27', 365, NULL),
('Luxor', 272, '2019-08-28', 252, NULL),
('Luxor', 272, '2019-08-29', 329, NULL),
('Luxor', 272, '2019-08-30', 106, NULL),
('Luxor', 272, '2019-08-31', 193, NULL),
('Luxor', 272, '2019-09-01', 297, NULL),
('Luxor', 272, '2019-09-02', 257, NULL),
('Luxor', 272, '2019-09-03', 229, NULL),
('Luxor', 272, '2019-09-04', 161, NULL),
('Luxor', 272, '2019-09-05', 242, NULL),
('Luxor', 272, '2019-09-06', 160, NULL),
('Luxor', 272, '2019-09-07', 245, NULL),
('Luxor', 272, '2019-09-08', 308, NULL),
('Luxor', 272, '2019-09-09', 164, NULL),
('Luxor', 272, '2019-09-10', 329, NULL),
('Luxor', 272, '2019-09-11', 271, NULL),
('Luxor', 272, '2019-09-12', 242, NULL),
('Luxor', 272, '2019-09-13', 133, NULL),
('Luxor', 272, '2019-09-14', 365, NULL),
('Luxor', 272, '2019-09-15', 108, NULL),
('Luxor', 272, '2019-09-16', 389, NULL),
('Luxor', 272, '2019-09-17', 292, NULL),
('Luxor', 272, '2019-09-18', 359, NULL),
('Luxor', 272, '2019-09-19', 196, NULL),
('Luxor', 272, '2019-09-20', 351, NULL),
('Luxor', 272, '2019-09-21', 252, NULL),
('Luxor', 272, '2019-09-22', 300, NULL),
('Luxor', 272, '2019-09-23', 242, NULL),
('Luxor', 272, '2019-09-24', 329, NULL),
('Luxor', 272, '2019-09-25', 150, NULL),
('Luxor', 272, '2019-09-26', 324, NULL),
('Luxor', 272, '2019-09-27', 383, NULL),
('Luxor', 272, '2019-09-28', 298, NULL),
('Luxor', 272, '2019-09-29', 289, NULL),
('Luxor', 272, '2019-09-30', 219, NULL),
('Luxor', 272, '2019-10-01', 326, NULL),
('Luxor', 272, '2019-10-02', 266, NULL),
('Luxor', 272, '2019-10-03', 237, NULL),
('Luxor', 272, '2019-10-04', 299, NULL),
('Luxor', 272, '2019-10-05', 115, NULL),
('Luxor', 272, '2019-10-06', 318, NULL),
('Luxor', 272, '2019-10-07', 375, NULL),
('Luxor', 272, '2019-10-08', 332, NULL),
('Luxor', 272, '2019-10-09', 346, NULL),
('Luxor', 272, '2019-10-10', 191, NULL),
('Luxor', 272, '2019-10-11', 266, NULL),
('Luxor', 272, '2019-10-12', 230, NULL),
('Luxor', 272, '2019-10-13', 302, NULL),
('Luxor', 272, '2019-10-14', 291, NULL),
('Luxor', 272, '2019-10-15', 138, NULL),
('Luxor', 272, '2019-10-16', 228, NULL),
('Luxor', 272, '2019-10-17', 321, NULL),
('Luxor', 272, '2019-10-18', 326, NULL),
('Luxor', 272, '2019-10-19', 180, NULL),
('Luxor', 272, '2019-10-20', 130, NULL),
('Luxor', 272, '2019-10-21', 269, NULL),
('Luxor', 272, '2019-10-22', 108, NULL),
('Luxor', 272, '2019-10-23', 148, NULL),
('Luxor', 272, '2019-10-24', 392, NULL),
('Luxor', 272, '2019-10-25', 126, NULL),
('Luxor', 272, '2019-10-26', 205, NULL),
('Luxor', 272, '2019-10-27', 279, NULL),
('Luxor', 272, '2019-10-28', 137, NULL),
('Luxor', 272, '2019-10-29', 180, NULL),
('Luxor', 272, '2019-10-30', 221, NULL),
('Luxor', 272, '2019-10-31', 180, NULL),
('Luxor', 272, '2019-11-01', 382, NULL),
('Luxor', 272, '2019-11-02', 192, NULL),
('Luxor', 272, '2019-11-03', 353, NULL),
('Luxor', 272, '2019-11-04', 245, NULL),
('Luxor', 272, '2019-11-05', 299, NULL),
('Luxor', 272, '2019-11-06', 260, NULL),
('Luxor', 272, '2019-11-07', 227, NULL),
('Luxor', 272, '2019-11-08', 207, NULL),
('Luxor', 272, '2019-11-09', 164, NULL),
('Luxor', 272, '2019-11-10', 346, NULL),
('Luxor', 272, '2019-11-11', 168, NULL),
('Luxor', 272, '2019-11-12', 317, NULL),
('Luxor', 272, '2019-11-13', 178, NULL),
('Luxor', 272, '2019-11-14', 328, NULL),
('Luxor', 272, '2019-11-15', 120, NULL),
('Luxor', 272, '2019-11-16', 276, NULL),
('Luxor', 272, '2019-11-17', 361, NULL),
('Luxor', 272, '2019-11-18', 158, NULL),
('Luxor', 272, '2019-11-19', 303, NULL),
('Luxor', 272, '2019-11-20', 259, NULL),
('Luxor', 272, '2019-11-21', 351, NULL),
('Luxor', 272, '2019-11-22', 399, NULL),
('Luxor', 272, '2019-11-23', 242, NULL),
('Luxor', 272, '2019-11-24', 337, NULL),
('Luxor', 272, '2019-11-25', 347, NULL),
('Luxor', 272, '2019-11-26', 287, NULL),
('Luxor', 272, '2019-11-27', 145, NULL),
('Luxor', 272, '2019-11-28', 287, NULL),
('Luxor', 272, '2019-11-29', 323, NULL),
('Luxor', 272, '2019-11-30', 314, NULL),
('Luxor', 272, '2019-12-01', 368, NULL),
('Luxor', 272, '2019-12-02', 125, NULL),
('Luxor', 272, '2019-12-03', 372, NULL),
('Luxor', 272, '2019-12-04', 130, NULL),
('Luxor', 272, '2019-12-05', 298, NULL),
('Luxor', 272, '2019-12-06', 242, NULL),
('Luxor', 272, '2019-12-07', 261, NULL),
('Luxor', 272, '2019-12-08', 105, NULL),
('Luxor', 272, '2019-12-09', 359, NULL),
('Luxor', 272, '2019-12-10', 236, NULL),
('Luxor', 272, '2019-12-11', 226, NULL),
('Luxor', 272, '2019-12-12', 270, NULL),
('Luxor', 272, '2019-12-13', 396, NULL),
('Luxor', 272, '2019-12-14', 251, NULL),
('Luxor', 272, '2019-12-15', 113, NULL),
('Luxor', 272, '2019-12-16', 359, NULL),
('Luxor', 272, '2019-12-17', 377, NULL),
('Luxor', 272, '2019-12-18', 396, NULL),
('Luxor', 272, '2019-12-19', 389, NULL),
('Luxor', 272, '2019-12-20', 137, NULL),
('Luxor', 272, '2019-12-21', 360, NULL),
('Luxor', 272, '2019-12-22', 152, NULL),
('Luxor', 272, '2019-12-23', 141, NULL),
('Luxor', 272, '2019-12-24', 101, NULL),
('Luxor', 272, '2019-12-25', 261, NULL),
('Luxor', 272, '2019-12-26', 395, NULL),
('Luxor', 272, '2019-12-27', 230, NULL),
('Luxor', 272, '2019-12-28', 107, NULL),
('Luxor', 272, '2019-12-29', 360, NULL),
('Luxor', 272, '2019-12-30', 310, NULL),
('Luxor', 272, '2019-12-31', 123, NULL),
('Luxor', 272, '2020-01-01', 121, NULL),
('Luxor', 272, '2020-01-02', 350, NULL),
('Luxor', 272, '2020-01-03', 320, NULL),
('Luxor', 272, '2020-01-04', 279, NULL),
('Luxor', 272, '2020-01-05', 289, NULL),
('Luxor', 272, '2020-01-06', 112, NULL),
('Luxor', 272, '2020-01-07', 268, NULL),
('Luxor', 272, '2020-01-08', 162, NULL),
('Luxor', 272, '2020-01-09', 323, NULL),
('Luxor', 272, '2020-01-10', 108, NULL),
('Luxor', 272, '2020-01-11', 119, NULL),
('Luxor', 272, '2020-01-12', 387, NULL),
('Luxor', 272, '2020-01-13', 101, NULL),
('Luxor', 272, '2020-01-14', 284, NULL),
('Luxor', 272, '2020-01-15', 223, NULL),
('Luxor', 272, '2020-01-16', 139, NULL),
('Luxor', 272, '2020-01-17', 337, NULL),
('Luxor', 272, '2020-01-18', 379, NULL),
('Luxor', 272, '2020-01-19', 361, NULL),
('Luxor', 272, '2020-01-20', 244, NULL),
('Luxor', 272, '2020-01-21', 261, NULL),
('Luxor', 272, '2020-01-22', 204, NULL),
('Luxor', 272, '2020-01-23', 179, NULL),
('Luxor', 272, '2020-01-24', 250, NULL),
('Luxor', 272, '2020-01-25', 176, NULL),
('Luxor', 272, '2020-01-26', 212, NULL),
('Luxor', 272, '2020-01-27', 280, NULL),
('Luxor', 272, '2020-01-28', 260, NULL),
('Luxor', 272, '2020-01-29', 102, NULL),
('Luxor', 272, '2020-01-30', 280, NULL),
('Luxor', 272, '2020-01-31', 151, NULL),
('Luxor', 272, '2020-02-01', 331, NULL),
('Luxor', 272, '2020-02-02', 154, NULL),
('Luxor', 272, '2020-02-03', 227, NULL),
('Luxor', 272, '2020-02-04', 220, NULL),
('Luxor', 275, '2019-01-01', 388, NULL),
('Luxor', 275, '2019-01-02', 388, NULL),
('Luxor', 275, '2019-01-03', 189, NULL),
('Luxor', 275, '2019-01-04', 323, NULL),
('Luxor', 275, '2019-01-05', 208, NULL),
('Luxor', 275, '2019-01-06', 206, NULL),
('Luxor', 275, '2019-01-07', 222, NULL),
('Luxor', 275, '2019-01-08', 319, NULL),
('Luxor', 275, '2019-01-09', 294, NULL),
('Luxor', 275, '2019-01-10', 329, NULL),
('Luxor', 275, '2019-01-11', 355, NULL),
('Luxor', 275, '2019-01-12', 115, NULL),
('Luxor', 275, '2019-01-13', 329, NULL),
('Luxor', 275, '2019-01-14', 358, NULL),
('Luxor', 275, '2019-01-15', 398, NULL),
('Luxor', 275, '2019-01-16', 279, NULL),
('Luxor', 275, '2019-01-17', 129, NULL),
('Luxor', 275, '2019-01-18', 373, NULL),
('Luxor', 275, '2019-01-19', 277, NULL),
('Luxor', 275, '2019-01-20', 265, NULL),
('Luxor', 275, '2019-01-21', 160, NULL),
('Luxor', 275, '2019-01-22', 346, NULL),
('Luxor', 275, '2019-01-23', 175, NULL),
('Luxor', 275, '2019-01-24', 288, NULL),
('Luxor', 275, '2019-01-25', 336, NULL),
('Luxor', 275, '2019-01-26', 239, NULL),
('Luxor', 275, '2019-01-27', 386, NULL),
('Luxor', 275, '2019-01-28', 376, NULL),
('Luxor', 275, '2019-01-29', 222, NULL),
('Luxor', 275, '2019-01-30', 308, NULL),
('Luxor', 275, '2019-01-31', 179, NULL),
('Luxor', 275, '2019-02-01', 154, NULL),
('Luxor', 275, '2019-02-02', 232, NULL),
('Luxor', 275, '2019-02-03', 353, NULL),
('Luxor', 275, '2019-02-04', 394, NULL),
('Luxor', 275, '2019-02-05', 116, NULL),
('Luxor', 275, '2019-02-06', 259, NULL),
('Luxor', 275, '2019-02-07', 277, NULL),
('Luxor', 275, '2019-02-08', 387, NULL),
('Luxor', 275, '2019-02-09', 304, NULL),
('Luxor', 275, '2019-02-10', 104, NULL),
('Luxor', 275, '2019-02-11', 341, NULL),
('Luxor', 275, '2019-02-12', 289, NULL),
('Luxor', 275, '2019-02-13', 337, NULL),
('Luxor', 275, '2019-02-14', 263, NULL),
('Luxor', 275, '2019-02-15', 380, NULL),
('Luxor', 275, '2019-02-16', 316, NULL),
('Luxor', 275, '2019-02-17', 296, NULL),
('Luxor', 275, '2019-02-18', 131, NULL),
('Luxor', 275, '2019-02-19', 136, NULL),
('Luxor', 275, '2019-02-20', 264, NULL),
('Luxor', 275, '2019-02-21', 307, NULL),
('Luxor', 275, '2019-02-22', 160, NULL),
('Luxor', 275, '2019-02-23', 134, NULL),
('Luxor', 275, '2019-02-24', 301, NULL),
('Luxor', 275, '2019-02-25', 274, NULL),
('Luxor', 275, '2019-02-26', 169, NULL),
('Luxor', 275, '2019-02-27', 203, NULL),
('Luxor', 275, '2019-02-28', 348, NULL),
('Luxor', 275, '2019-03-01', 279, NULL),
('Luxor', 275, '2019-03-02', 130, NULL),
('Luxor', 275, '2019-03-03', 139, NULL),
('Luxor', 275, '2019-03-04', 276, NULL),
('Luxor', 275, '2019-03-05', 343, NULL),
('Luxor', 275, '2019-03-06', 208, NULL),
('Luxor', 275, '2019-03-07', 195, NULL),
('Luxor', 275, '2019-03-08', 168, NULL),
('Luxor', 275, '2019-03-09', 137, NULL),
('Luxor', 275, '2019-03-10', 151, NULL),
('Luxor', 275, '2019-03-11', 329, NULL),
('Luxor', 275, '2019-03-12', 362, NULL),
('Luxor', 275, '2019-03-13', 136, NULL),
('Luxor', 275, '2019-03-14', 256, NULL),
('Luxor', 275, '2019-03-15', 367, NULL),
('Luxor', 275, '2019-03-16', 237, NULL),
('Luxor', 275, '2019-03-17', 136, NULL),
('Luxor', 275, '2019-03-18', 114, NULL),
('Luxor', 275, '2019-03-19', 240, NULL),
('Luxor', 275, '2019-03-20', 270, NULL),
('Luxor', 275, '2019-03-21', 167, NULL),
('Luxor', 275, '2019-03-22', 332, NULL),
('Luxor', 275, '2019-03-23', 170, NULL),
('Luxor', 275, '2019-03-24', 278, NULL),
('Luxor', 275, '2019-03-25', 258, NULL),
('Luxor', 275, '2019-03-26', 176, NULL),
('Luxor', 275, '2019-03-27', 158, NULL),
('Luxor', 275, '2019-03-28', 250, NULL),
('Luxor', 275, '2019-03-29', 175, NULL),
('Luxor', 275, '2019-03-30', 218, NULL),
('Luxor', 275, '2019-03-31', 153, NULL),
('Luxor', 275, '2019-04-01', 135, NULL),
('Luxor', 275, '2019-04-02', 348, NULL),
('Luxor', 275, '2019-04-03', 286, NULL),
('Luxor', 275, '2019-04-04', 177, NULL),
('Luxor', 275, '2019-04-05', 150, NULL),
('Luxor', 275, '2019-04-06', 111, NULL),
('Luxor', 275, '2019-04-07', 250, NULL),
('Luxor', 275, '2019-04-08', 139, NULL),
('Luxor', 275, '2019-04-09', 230, NULL),
('Luxor', 275, '2019-04-10', 176, NULL),
('Luxor', 275, '2019-04-11', 309, NULL),
('Luxor', 275, '2019-04-12', 355, NULL),
('Luxor', 275, '2019-04-13', 385, NULL),
('Luxor', 275, '2019-04-14', 180, NULL),
('Luxor', 275, '2019-04-15', 379, NULL),
('Luxor', 275, '2019-04-16', 159, NULL),
('Luxor', 275, '2019-04-17', 334, NULL),
('Luxor', 275, '2019-04-18', 134, NULL),
('Luxor', 275, '2019-04-19', 146, NULL),
('Luxor', 275, '2019-04-20', 116, NULL),
('Luxor', 275, '2019-04-21', 184, NULL),
('Luxor', 275, '2019-04-22', 153, NULL),
('Luxor', 275, '2019-04-23', 395, NULL),
('Luxor', 275, '2019-04-24', 116, NULL),
('Luxor', 275, '2019-04-25', 112, NULL),
('Luxor', 275, '2019-04-26', 315, NULL),
('Luxor', 275, '2019-04-27', 354, NULL),
('Luxor', 275, '2019-04-28', 280, NULL),
('Luxor', 275, '2019-04-29', 329, NULL),
('Luxor', 275, '2019-04-30', 178, NULL),
('Luxor', 275, '2019-05-01', 216, NULL),
('Luxor', 275, '2019-05-02', 277, NULL),
('Luxor', 275, '2019-05-03', 236, NULL),
('Luxor', 275, '2019-05-04', 181, NULL),
('Luxor', 275, '2019-05-05', 132, NULL),
('Luxor', 275, '2019-05-06', 226, NULL),
('Luxor', 275, '2019-05-07', 296, NULL),
('Luxor', 275, '2019-05-08', 142, NULL),
('Luxor', 275, '2019-05-09', 291, NULL),
('Luxor', 275, '2019-05-10', 267, NULL),
('Luxor', 275, '2019-05-11', 382, NULL),
('Luxor', 275, '2019-05-12', 203, NULL),
('Luxor', 275, '2019-05-13', 394, NULL),
('Luxor', 275, '2019-05-14', 301, NULL),
('Luxor', 275, '2019-05-15', 264, NULL),
('Luxor', 275, '2019-05-16', 268, NULL),
('Luxor', 275, '2019-05-17', 349, NULL),
('Luxor', 275, '2019-05-18', 346, NULL),
('Luxor', 275, '2019-05-19', 390, NULL),
('Luxor', 275, '2019-05-20', 117, NULL),
('Luxor', 275, '2019-05-21', 384, NULL),
('Luxor', 275, '2019-05-22', 317, NULL),
('Luxor', 275, '2019-05-23', 399, NULL),
('Luxor', 275, '2019-05-24', 283, NULL),
('Luxor', 275, '2019-05-25', 345, NULL),
('Luxor', 275, '2019-05-26', 347, NULL),
('Luxor', 275, '2019-05-27', 209, NULL),
('Luxor', 275, '2019-05-28', 315, NULL),
('Luxor', 275, '2019-05-29', 317, NULL),
('Luxor', 275, '2019-05-30', 217, NULL),
('Luxor', 275, '2019-05-31', 216, NULL),
('Luxor', 275, '2019-06-01', 325, NULL),
('Luxor', 275, '2019-06-02', 102, NULL),
('Luxor', 275, '2019-06-03', 367, NULL),
('Luxor', 275, '2019-06-04', 382, NULL),
('Luxor', 275, '2019-06-05', 334, NULL),
('Luxor', 275, '2019-06-06', 200, NULL),
('Luxor', 275, '2019-06-07', 291, NULL),
('Luxor', 275, '2019-06-08', 357, NULL),
('Luxor', 275, '2019-06-09', 378, NULL),
('Luxor', 275, '2019-06-10', 259, NULL),
('Luxor', 275, '2019-06-11', 238, NULL),
('Luxor', 275, '2019-06-12', 255, NULL),
('Luxor', 275, '2019-06-13', 360, NULL),
('Luxor', 275, '2019-06-14', 166, NULL),
('Luxor', 275, '2019-06-15', 194, NULL),
('Luxor', 275, '2019-06-16', 135, NULL),
('Luxor', 275, '2019-06-17', 169, NULL),
('Luxor', 275, '2019-06-18', 111, NULL),
('Luxor', 275, '2019-06-19', 108, NULL),
('Luxor', 275, '2019-06-20', 288, NULL),
('Luxor', 275, '2019-06-21', 188, NULL),
('Luxor', 275, '2019-06-22', 209, NULL),
('Luxor', 275, '2019-06-23', 390, NULL),
('Luxor', 275, '2019-06-24', 226, NULL),
('Luxor', 275, '2019-06-25', 238, NULL),
('Luxor', 275, '2019-06-26', 346, NULL),
('Luxor', 275, '2019-06-27', 194, NULL),
('Luxor', 275, '2019-06-28', 256, NULL),
('Luxor', 275, '2019-06-29', 146, NULL),
('Luxor', 275, '2019-06-30', 336, NULL),
('Luxor', 275, '2019-07-01', 267, NULL),
('Luxor', 275, '2019-07-02', 258, NULL),
('Luxor', 275, '2019-07-03', 381, NULL),
('Luxor', 275, '2019-07-04', 310, NULL),
('Luxor', 275, '2019-07-05', 134, NULL),
('Luxor', 275, '2019-07-06', 169, NULL),
('Luxor', 275, '2019-07-07', 243, NULL),
('Luxor', 275, '2019-07-08', 396, NULL),
('Luxor', 275, '2019-07-09', 348, NULL),
('Luxor', 275, '2019-07-10', 381, NULL),
('Luxor', 275, '2019-07-11', 352, NULL),
('Luxor', 275, '2019-07-12', 109, NULL),
('Luxor', 275, '2019-07-13', 290, NULL),
('Luxor', 275, '2019-07-14', 215, NULL),
('Luxor', 275, '2019-07-15', 323, NULL),
('Luxor', 275, '2019-07-16', 353, NULL),
('Luxor', 275, '2019-07-17', 198, NULL),
('Luxor', 275, '2019-07-18', 271, NULL),
('Luxor', 275, '2019-07-19', 373, NULL),
('Luxor', 275, '2019-07-20', 175, NULL),
('Luxor', 275, '2019-07-21', 226, NULL),
('Luxor', 275, '2019-07-22', 232, NULL),
('Luxor', 275, '2019-07-23', 323, NULL),
('Luxor', 275, '2019-07-24', 171, NULL),
('Luxor', 275, '2019-07-25', 237, NULL),
('Luxor', 275, '2019-07-26', 194, NULL),
('Luxor', 275, '2019-07-27', 333, NULL),
('Luxor', 275, '2019-07-28', 237, NULL),
('Luxor', 275, '2019-07-29', 337, NULL),
('Luxor', 275, '2019-07-30', 339, NULL),
('Luxor', 275, '2019-07-31', 216, NULL),
('Luxor', 275, '2019-08-01', 355, NULL),
('Luxor', 275, '2019-08-02', 308, NULL),
('Luxor', 275, '2019-08-03', 294, NULL),
('Luxor', 275, '2019-08-04', 319, NULL),
('Luxor', 275, '2019-08-05', 323, NULL),
('Luxor', 275, '2019-08-06', 205, NULL),
('Luxor', 275, '2019-08-07', 135, NULL),
('Luxor', 275, '2019-08-08', 246, NULL),
('Luxor', 275, '2019-08-09', 155, NULL),
('Luxor', 275, '2019-08-10', 131, NULL),
('Luxor', 275, '2019-08-11', 102, NULL),
('Luxor', 275, '2019-08-12', 168, NULL),
('Luxor', 275, '2019-08-13', 213, NULL),
('Luxor', 275, '2019-08-14', 263, NULL),
('Luxor', 275, '2019-08-15', 387, NULL),
('Luxor', 275, '2019-08-16', 379, NULL),
('Luxor', 275, '2019-08-17', 227, NULL),
('Luxor', 275, '2019-08-18', 301, NULL),
('Luxor', 275, '2019-08-19', 309, NULL),
('Luxor', 275, '2019-08-20', 376, NULL),
('Luxor', 275, '2019-08-21', 283, NULL),
('Luxor', 275, '2019-08-22', 284, NULL),
('Luxor', 275, '2019-08-23', 270, NULL),
('Luxor', 275, '2019-08-24', 277, NULL),
('Luxor', 275, '2019-08-25', 270, NULL),
('Luxor', 275, '2019-08-26', 390, NULL),
('Luxor', 275, '2019-08-27', 208, NULL),
('Luxor', 275, '2019-08-28', 150, NULL),
('Luxor', 275, '2019-08-29', 130, NULL),
('Luxor', 275, '2019-08-30', 108, NULL),
('Luxor', 275, '2019-08-31', 151, NULL),
('Luxor', 275, '2019-09-01', 372, NULL),
('Luxor', 275, '2019-09-02', 108, NULL),
('Luxor', 275, '2019-09-03', 304, NULL),
('Luxor', 275, '2019-09-04', 112, NULL),
('Luxor', 275, '2019-09-05', 146, NULL),
('Luxor', 275, '2019-09-06', 241, NULL),
('Luxor', 275, '2019-09-07', 340, NULL),
('Luxor', 275, '2019-09-08', 370, NULL),
('Luxor', 275, '2019-09-09', 209, NULL),
('Luxor', 275, '2019-09-10', 145, NULL),
('Luxor', 275, '2019-09-11', 267, NULL),
('Luxor', 275, '2019-09-12', 316, NULL),
('Luxor', 275, '2019-09-13', 129, NULL),
('Luxor', 275, '2019-09-14', 309, NULL),
('Luxor', 275, '2019-09-15', 285, NULL),
('Luxor', 275, '2019-09-16', 366, NULL),
('Luxor', 275, '2019-09-17', 338, NULL),
('Luxor', 275, '2019-09-18', 148, NULL),
('Luxor', 275, '2019-09-19', 357, NULL),
('Luxor', 275, '2019-09-20', 257, NULL),
('Luxor', 275, '2019-09-21', 131, NULL),
('Luxor', 275, '2019-09-22', 264, NULL),
('Luxor', 275, '2019-09-23', 299, NULL),
('Luxor', 275, '2019-09-24', 202, NULL),
('Luxor', 275, '2019-09-25', 139, NULL),
('Luxor', 275, '2019-09-26', 369, NULL),
('Luxor', 275, '2019-09-27', 231, NULL),
('Luxor', 275, '2019-09-28', 102, NULL),
('Luxor', 275, '2019-09-29', 221, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 275, '2019-09-30', 233, NULL),
('Luxor', 275, '2019-10-01', 128, NULL),
('Luxor', 275, '2019-10-02', 157, NULL),
('Luxor', 275, '2019-10-03', 188, NULL),
('Luxor', 275, '2019-10-04', 303, NULL),
('Luxor', 275, '2019-10-05', 208, NULL),
('Luxor', 275, '2019-10-06', 240, NULL),
('Luxor', 275, '2019-10-07', 131, NULL),
('Luxor', 275, '2019-10-08', 355, NULL),
('Luxor', 275, '2019-10-09', 339, NULL),
('Luxor', 275, '2019-10-10', 273, NULL),
('Luxor', 275, '2019-10-11', 108, NULL),
('Luxor', 275, '2019-10-12', 338, NULL),
('Luxor', 275, '2019-10-13', 366, NULL),
('Luxor', 275, '2019-10-14', 119, NULL),
('Luxor', 275, '2019-10-15', 334, NULL),
('Luxor', 275, '2019-10-16', 119, NULL),
('Luxor', 275, '2019-10-17', 208, NULL),
('Luxor', 275, '2019-10-18', 105, NULL),
('Luxor', 275, '2019-10-19', 229, NULL),
('Luxor', 275, '2019-10-20', 373, NULL),
('Luxor', 275, '2019-10-21', 271, NULL),
('Luxor', 275, '2019-10-22', 365, NULL),
('Luxor', 275, '2019-10-23', 112, NULL),
('Luxor', 275, '2019-10-24', 254, NULL),
('Luxor', 275, '2019-10-25', 224, NULL),
('Luxor', 275, '2019-10-26', 277, NULL),
('Luxor', 275, '2019-10-27', 156, NULL),
('Luxor', 275, '2019-10-28', 164, NULL),
('Luxor', 275, '2019-10-29', 349, NULL),
('Luxor', 275, '2019-10-30', 130, NULL),
('Luxor', 275, '2019-10-31', 328, NULL),
('Luxor', 275, '2019-11-01', 240, NULL),
('Luxor', 275, '2019-11-02', 397, NULL),
('Luxor', 275, '2019-11-03', 243, NULL),
('Luxor', 275, '2019-11-04', 295, NULL),
('Luxor', 275, '2019-11-05', 361, NULL),
('Luxor', 275, '2019-11-06', 207, NULL),
('Luxor', 275, '2019-11-07', 220, NULL),
('Luxor', 275, '2019-11-08', 123, NULL),
('Luxor', 275, '2019-11-09', 116, NULL),
('Luxor', 275, '2019-11-10', 373, NULL),
('Luxor', 275, '2019-11-11', 254, NULL),
('Luxor', 275, '2019-11-12', 273, NULL),
('Luxor', 275, '2019-11-13', 100, NULL),
('Luxor', 275, '2019-11-14', 248, NULL),
('Luxor', 275, '2019-11-15', 156, NULL),
('Luxor', 275, '2019-11-16', 365, NULL),
('Luxor', 275, '2019-11-17', 258, NULL),
('Luxor', 275, '2019-11-18', 242, NULL),
('Luxor', 275, '2019-11-19', 241, NULL),
('Luxor', 275, '2019-11-20', 202, NULL),
('Luxor', 275, '2019-11-21', 211, NULL),
('Luxor', 275, '2019-11-22', 332, NULL),
('Luxor', 275, '2019-11-23', 353, NULL),
('Luxor', 275, '2019-11-24', 212, NULL),
('Luxor', 275, '2019-11-25', 340, NULL),
('Luxor', 275, '2019-11-26', 329, NULL),
('Luxor', 275, '2019-11-27', 232, NULL),
('Luxor', 275, '2019-11-28', 175, NULL),
('Luxor', 275, '2019-11-29', 132, NULL),
('Luxor', 275, '2019-11-30', 188, NULL),
('Luxor', 275, '2019-12-01', 105, NULL),
('Luxor', 275, '2019-12-02', 192, NULL),
('Luxor', 275, '2019-12-03', 365, NULL),
('Luxor', 275, '2019-12-04', 180, NULL),
('Luxor', 275, '2019-12-05', 200, NULL),
('Luxor', 275, '2019-12-06', 116, NULL),
('Luxor', 275, '2019-12-07', 389, NULL),
('Luxor', 275, '2019-12-08', 350, NULL),
('Luxor', 275, '2019-12-09', 128, NULL),
('Luxor', 275, '2019-12-10', 247, NULL),
('Luxor', 275, '2019-12-11', 119, NULL),
('Luxor', 275, '2019-12-12', 276, NULL),
('Luxor', 275, '2019-12-13', 149, NULL),
('Luxor', 275, '2019-12-14', 340, NULL),
('Luxor', 275, '2019-12-15', 290, NULL),
('Luxor', 275, '2019-12-16', 208, NULL),
('Luxor', 275, '2019-12-17', 312, NULL),
('Luxor', 275, '2019-12-18', 103, NULL),
('Luxor', 275, '2019-12-19', 113, NULL),
('Luxor', 275, '2019-12-20', 242, NULL),
('Luxor', 275, '2019-12-21', 188, NULL),
('Luxor', 275, '2019-12-22', 290, NULL),
('Luxor', 275, '2019-12-23', 385, NULL),
('Luxor', 275, '2019-12-24', 322, NULL),
('Luxor', 275, '2019-12-25', 162, NULL),
('Luxor', 275, '2019-12-26', 286, NULL),
('Luxor', 275, '2019-12-27', 162, NULL),
('Luxor', 275, '2019-12-28', 313, NULL),
('Luxor', 275, '2019-12-29', 369, NULL),
('Luxor', 275, '2019-12-30', 146, NULL),
('Luxor', 275, '2019-12-31', 142, NULL),
('Luxor', 275, '2020-01-01', 374, NULL),
('Luxor', 275, '2020-01-02', 299, NULL),
('Luxor', 275, '2020-01-03', 181, NULL),
('Luxor', 275, '2020-01-04', 210, NULL),
('Luxor', 275, '2020-01-05', 118, NULL),
('Luxor', 275, '2020-01-06', 215, NULL),
('Luxor', 275, '2020-01-07', 223, NULL),
('Luxor', 275, '2020-01-08', 397, NULL),
('Luxor', 275, '2020-01-09', 373, NULL),
('Luxor', 275, '2020-01-10', 390, NULL),
('Luxor', 275, '2020-01-11', 102, NULL),
('Luxor', 275, '2020-01-12', 185, NULL),
('Luxor', 275, '2020-01-13', 130, NULL),
('Luxor', 275, '2020-01-14', 288, NULL),
('Luxor', 275, '2020-01-15', 144, NULL),
('Luxor', 275, '2020-01-16', 333, NULL),
('Luxor', 275, '2020-01-17', 121, NULL),
('Luxor', 275, '2020-01-18', 275, NULL),
('Luxor', 275, '2020-01-19', 281, NULL),
('Luxor', 275, '2020-01-20', 307, NULL),
('Luxor', 275, '2020-01-21', 337, NULL),
('Luxor', 275, '2020-01-22', 244, NULL),
('Luxor', 275, '2020-01-23', 391, NULL),
('Luxor', 275, '2020-01-24', 105, NULL),
('Luxor', 275, '2020-01-25', 101, NULL),
('Luxor', 275, '2020-01-26', 229, NULL),
('Luxor', 275, '2020-01-27', 241, NULL),
('Luxor', 275, '2020-01-28', 151, NULL),
('Luxor', 275, '2020-01-29', 354, NULL),
('Luxor', 275, '2020-01-30', 222, NULL),
('Luxor', 275, '2020-01-31', 360, NULL),
('Luxor', 275, '2020-02-01', 366, NULL),
('Luxor', 275, '2020-02-02', 189, NULL),
('Luxor', 275, '2020-02-03', 113, NULL),
('Luxor', 275, '2020-02-04', 213, NULL),
('Luxor', 283, '2019-01-01', 281, NULL),
('Luxor', 283, '2019-01-02', 335, NULL),
('Luxor', 283, '2019-01-03', 377, NULL),
('Luxor', 283, '2019-01-04', 188, NULL),
('Luxor', 283, '2019-01-05', 322, NULL),
('Luxor', 283, '2019-01-06', 245, NULL),
('Luxor', 283, '2019-01-07', 223, NULL),
('Luxor', 283, '2019-01-08', 191, NULL),
('Luxor', 283, '2019-01-09', 218, NULL),
('Luxor', 283, '2019-01-10', 323, NULL),
('Luxor', 283, '2019-01-11', 221, NULL),
('Luxor', 283, '2019-01-12', 107, NULL),
('Luxor', 283, '2019-01-13', 312, NULL),
('Luxor', 283, '2019-01-14', 358, NULL),
('Luxor', 283, '2019-01-15', 352, NULL),
('Luxor', 283, '2019-01-16', 221, NULL),
('Luxor', 283, '2019-01-17', 230, NULL),
('Luxor', 283, '2019-01-18', 230, NULL),
('Luxor', 283, '2019-01-19', 399, NULL),
('Luxor', 283, '2019-01-20', 151, NULL),
('Luxor', 283, '2019-01-21', 366, NULL),
('Luxor', 283, '2019-01-22', 152, NULL),
('Luxor', 283, '2019-01-23', 297, NULL),
('Luxor', 283, '2019-01-24', 194, NULL),
('Luxor', 283, '2019-01-25', 266, NULL),
('Luxor', 283, '2019-01-26', 264, NULL),
('Luxor', 283, '2019-01-27', 391, NULL),
('Luxor', 283, '2019-01-28', 135, NULL),
('Luxor', 283, '2019-01-29', 230, NULL),
('Luxor', 283, '2019-01-30', 126, NULL),
('Luxor', 283, '2019-01-31', 254, NULL),
('Luxor', 283, '2019-02-01', 103, NULL),
('Luxor', 283, '2019-02-02', 154, NULL),
('Luxor', 283, '2019-02-03', 313, NULL),
('Luxor', 283, '2019-02-04', 200, NULL),
('Luxor', 283, '2019-02-05', 343, NULL),
('Luxor', 283, '2019-02-06', 312, NULL),
('Luxor', 283, '2019-02-07', 158, NULL),
('Luxor', 283, '2019-02-08', 122, NULL),
('Luxor', 283, '2019-02-09', 140, NULL),
('Luxor', 283, '2019-02-10', 386, NULL),
('Luxor', 283, '2019-02-11', 180, NULL),
('Luxor', 283, '2019-02-12', 182, NULL),
('Luxor', 283, '2019-02-13', 130, NULL),
('Luxor', 283, '2019-02-14', 170, NULL),
('Luxor', 283, '2019-02-15', 274, NULL),
('Luxor', 283, '2019-02-16', 355, NULL),
('Luxor', 283, '2019-02-17', 299, NULL),
('Luxor', 283, '2019-02-18', 384, NULL),
('Luxor', 283, '2019-02-19', 240, NULL),
('Luxor', 283, '2019-02-20', 389, NULL),
('Luxor', 283, '2019-02-21', 347, NULL),
('Luxor', 283, '2019-02-22', 244, NULL),
('Luxor', 283, '2019-02-23', 199, NULL),
('Luxor', 283, '2019-02-24', 155, NULL),
('Luxor', 283, '2019-02-25', 296, NULL),
('Luxor', 283, '2019-02-26', 272, NULL),
('Luxor', 283, '2019-02-27', 196, NULL),
('Luxor', 283, '2019-02-28', 218, NULL),
('Luxor', 283, '2019-03-01', 250, NULL),
('Luxor', 283, '2019-03-02', 152, NULL),
('Luxor', 283, '2019-03-03', 228, NULL),
('Luxor', 283, '2019-03-04', 259, NULL),
('Luxor', 283, '2019-03-05', 138, NULL),
('Luxor', 283, '2019-03-06', 141, NULL),
('Luxor', 283, '2019-03-07', 204, NULL),
('Luxor', 283, '2019-03-08', 326, NULL),
('Luxor', 283, '2019-03-09', 315, NULL),
('Luxor', 283, '2019-03-10', 190, NULL),
('Luxor', 283, '2019-03-11', 169, NULL),
('Luxor', 283, '2019-03-12', 261, NULL),
('Luxor', 283, '2019-03-13', 220, NULL),
('Luxor', 283, '2019-03-14', 288, NULL),
('Luxor', 283, '2019-03-15', 102, NULL),
('Luxor', 283, '2019-03-16', 368, NULL),
('Luxor', 283, '2019-03-17', 197, NULL),
('Luxor', 283, '2019-03-18', 363, NULL),
('Luxor', 283, '2019-03-19', 371, NULL),
('Luxor', 283, '2019-03-20', 148, NULL),
('Luxor', 283, '2019-03-21', 299, NULL),
('Luxor', 283, '2019-03-22', 117, NULL),
('Luxor', 283, '2019-03-23', 315, NULL),
('Luxor', 283, '2019-03-24', 213, NULL),
('Luxor', 283, '2019-03-25', 139, NULL),
('Luxor', 283, '2019-03-26', 209, NULL),
('Luxor', 283, '2019-03-27', 369, NULL),
('Luxor', 283, '2019-03-28', 211, NULL),
('Luxor', 283, '2019-03-29', 115, NULL),
('Luxor', 283, '2019-03-30', 335, NULL),
('Luxor', 283, '2019-03-31', 141, NULL),
('Luxor', 283, '2019-04-01', 208, NULL),
('Luxor', 283, '2019-04-02', 348, NULL),
('Luxor', 283, '2019-04-03', 354, NULL),
('Luxor', 283, '2019-04-04', 112, NULL),
('Luxor', 283, '2019-04-05', 209, NULL),
('Luxor', 283, '2019-04-06', 206, NULL),
('Luxor', 283, '2019-04-07', 161, NULL),
('Luxor', 283, '2019-04-08', 221, NULL),
('Luxor', 283, '2019-04-09', 110, NULL),
('Luxor', 283, '2019-04-10', 144, NULL),
('Luxor', 283, '2019-04-11', 194, NULL),
('Luxor', 283, '2019-04-12', 184, NULL),
('Luxor', 283, '2019-04-13', 139, NULL),
('Luxor', 283, '2019-04-14', 190, NULL),
('Luxor', 283, '2019-04-15', 213, NULL),
('Luxor', 283, '2019-04-16', 224, NULL),
('Luxor', 283, '2019-04-17', 222, NULL),
('Luxor', 283, '2019-04-18', 197, NULL),
('Luxor', 283, '2019-04-19', 108, NULL),
('Luxor', 283, '2019-04-20', 247, NULL),
('Luxor', 283, '2019-04-21', 255, NULL),
('Luxor', 283, '2019-04-22', 315, NULL),
('Luxor', 283, '2019-04-23', 346, NULL),
('Luxor', 283, '2019-04-24', 217, NULL),
('Luxor', 283, '2019-04-25', 184, NULL),
('Luxor', 283, '2019-04-26', 138, NULL),
('Luxor', 283, '2019-04-27', 341, NULL),
('Luxor', 283, '2019-04-28', 293, NULL),
('Luxor', 283, '2019-04-29', 208, NULL),
('Luxor', 283, '2019-04-30', 279, NULL),
('Luxor', 283, '2019-05-01', 307, NULL),
('Luxor', 283, '2019-05-02', 399, NULL),
('Luxor', 283, '2019-05-03', 380, NULL),
('Luxor', 283, '2019-05-04', 260, NULL),
('Luxor', 283, '2019-05-05', 105, NULL),
('Luxor', 283, '2019-05-06', 248, NULL),
('Luxor', 283, '2019-05-07', 174, NULL),
('Luxor', 283, '2019-05-08', 241, NULL),
('Luxor', 283, '2019-05-09', 316, NULL),
('Luxor', 283, '2019-05-10', 343, NULL),
('Luxor', 283, '2019-05-11', 366, NULL),
('Luxor', 283, '2019-05-12', 381, NULL),
('Luxor', 283, '2019-05-13', 220, NULL),
('Luxor', 283, '2019-05-14', 259, NULL),
('Luxor', 283, '2019-05-15', 113, NULL),
('Luxor', 283, '2019-05-16', 354, NULL),
('Luxor', 283, '2019-05-17', 169, NULL),
('Luxor', 283, '2019-05-18', 236, NULL),
('Luxor', 283, '2019-05-19', 239, NULL),
('Luxor', 283, '2019-05-20', 319, NULL),
('Luxor', 283, '2019-05-21', 287, NULL),
('Luxor', 283, '2019-05-22', 270, NULL),
('Luxor', 283, '2019-05-23', 151, NULL),
('Luxor', 283, '2019-05-24', 200, NULL),
('Luxor', 283, '2019-05-25', 221, NULL),
('Luxor', 283, '2019-05-26', 149, NULL),
('Luxor', 283, '2019-05-27', 109, NULL),
('Luxor', 283, '2019-05-28', 211, NULL),
('Luxor', 283, '2019-05-29', 178, NULL),
('Luxor', 283, '2019-05-30', 148, NULL),
('Luxor', 283, '2019-05-31', 312, NULL),
('Luxor', 283, '2019-06-01', 225, NULL),
('Luxor', 283, '2019-06-02', 294, NULL),
('Luxor', 283, '2019-06-03', 196, NULL),
('Luxor', 283, '2019-06-04', 156, NULL),
('Luxor', 283, '2019-06-05', 325, NULL),
('Luxor', 283, '2019-06-06', 174, NULL),
('Luxor', 283, '2019-06-07', 272, NULL),
('Luxor', 283, '2019-06-08', 178, NULL),
('Luxor', 283, '2019-06-09', 275, NULL),
('Luxor', 283, '2019-06-10', 323, NULL),
('Luxor', 283, '2019-06-11', 315, NULL),
('Luxor', 283, '2019-06-12', 112, NULL),
('Luxor', 283, '2019-06-13', 347, NULL),
('Luxor', 283, '2019-06-14', 211, NULL),
('Luxor', 283, '2019-06-15', 133, NULL),
('Luxor', 283, '2019-06-16', 255, NULL),
('Luxor', 283, '2019-06-17', 247, NULL),
('Luxor', 283, '2019-06-18', 204, NULL),
('Luxor', 283, '2019-06-19', 106, NULL),
('Luxor', 283, '2019-06-20', 290, NULL),
('Luxor', 283, '2019-06-21', 254, NULL),
('Luxor', 283, '2019-06-22', 350, NULL),
('Luxor', 283, '2019-06-23', 231, NULL),
('Luxor', 283, '2019-06-24', 197, NULL),
('Luxor', 283, '2019-06-25', 194, NULL),
('Luxor', 283, '2019-06-26', 310, NULL),
('Luxor', 283, '2019-06-27', 246, NULL),
('Luxor', 283, '2019-06-28', 230, NULL),
('Luxor', 283, '2019-06-29', 123, NULL),
('Luxor', 283, '2019-06-30', 156, NULL),
('Luxor', 283, '2019-07-01', 394, NULL),
('Luxor', 283, '2019-07-02', 135, NULL),
('Luxor', 283, '2019-07-03', 223, NULL),
('Luxor', 283, '2019-07-04', 281, NULL),
('Luxor', 283, '2019-07-05', 215, NULL),
('Luxor', 283, '2019-07-06', 148, NULL),
('Luxor', 283, '2019-07-07', 314, NULL),
('Luxor', 283, '2019-07-08', 362, NULL),
('Luxor', 283, '2019-07-09', 311, NULL),
('Luxor', 283, '2019-07-10', 352, NULL),
('Luxor', 283, '2019-07-11', 363, NULL),
('Luxor', 283, '2019-07-12', 167, NULL),
('Luxor', 283, '2019-07-13', 246, NULL),
('Luxor', 283, '2019-07-14', 170, NULL),
('Luxor', 283, '2019-07-15', 206, NULL),
('Luxor', 283, '2019-07-16', 388, NULL),
('Luxor', 283, '2019-07-17', 192, NULL),
('Luxor', 283, '2019-07-18', 105, NULL),
('Luxor', 283, '2019-07-19', 374, NULL),
('Luxor', 283, '2019-07-20', 391, NULL),
('Luxor', 283, '2019-07-21', 326, NULL),
('Luxor', 283, '2019-07-22', 292, NULL),
('Luxor', 283, '2019-07-23', 238, NULL),
('Luxor', 283, '2019-07-24', 119, NULL),
('Luxor', 283, '2019-07-25', 111, NULL),
('Luxor', 283, '2019-07-26', 126, NULL),
('Luxor', 283, '2019-07-27', 210, NULL),
('Luxor', 283, '2019-07-28', 313, NULL),
('Luxor', 283, '2019-07-29', 399, NULL),
('Luxor', 283, '2019-07-30', 143, NULL),
('Luxor', 283, '2019-07-31', 231, NULL),
('Luxor', 283, '2019-08-01', 313, NULL),
('Luxor', 283, '2019-08-02', 129, NULL),
('Luxor', 283, '2019-08-03', 358, NULL),
('Luxor', 283, '2019-08-04', 137, NULL),
('Luxor', 283, '2019-08-05', 362, NULL),
('Luxor', 283, '2019-08-06', 106, NULL),
('Luxor', 283, '2019-08-07', 255, NULL),
('Luxor', 283, '2019-08-08', 351, NULL),
('Luxor', 283, '2019-08-09', 276, NULL),
('Luxor', 283, '2019-08-10', 271, NULL),
('Luxor', 283, '2019-08-11', 371, NULL),
('Luxor', 283, '2019-08-12', 385, NULL),
('Luxor', 283, '2019-08-13', 112, NULL),
('Luxor', 283, '2019-08-14', 270, NULL),
('Luxor', 283, '2019-08-15', 346, NULL),
('Luxor', 283, '2019-08-16', 120, NULL),
('Luxor', 283, '2019-08-17', 211, NULL),
('Luxor', 283, '2019-08-18', 217, NULL),
('Luxor', 283, '2019-08-19', 350, NULL),
('Luxor', 283, '2019-08-20', 168, NULL),
('Luxor', 283, '2019-08-21', 257, NULL),
('Luxor', 283, '2019-08-22', 386, NULL),
('Luxor', 283, '2019-08-23', 216, NULL),
('Luxor', 283, '2019-08-24', 197, NULL),
('Luxor', 283, '2019-08-25', 127, NULL),
('Luxor', 283, '2019-08-26', 225, NULL),
('Luxor', 283, '2019-08-27', 143, NULL),
('Luxor', 283, '2019-08-28', 194, NULL),
('Luxor', 283, '2019-08-29', 160, NULL),
('Luxor', 283, '2019-08-30', 125, NULL),
('Luxor', 283, '2019-08-31', 377, NULL),
('Luxor', 283, '2019-09-01', 271, NULL),
('Luxor', 283, '2019-09-02', 269, NULL),
('Luxor', 283, '2019-09-03', 137, NULL),
('Luxor', 283, '2019-09-04', 277, NULL),
('Luxor', 283, '2019-09-05', 204, NULL),
('Luxor', 283, '2019-09-06', 323, NULL),
('Luxor', 283, '2019-09-07', 266, NULL),
('Luxor', 283, '2019-09-08', 226, NULL),
('Luxor', 283, '2019-09-09', 153, NULL),
('Luxor', 283, '2019-09-10', 239, NULL),
('Luxor', 283, '2019-09-11', 123, NULL),
('Luxor', 283, '2019-09-12', 152, NULL),
('Luxor', 283, '2019-09-13', 144, NULL),
('Luxor', 283, '2019-09-14', 348, NULL),
('Luxor', 283, '2019-09-15', 399, NULL),
('Luxor', 283, '2019-09-16', 262, NULL),
('Luxor', 283, '2019-09-17', 114, NULL),
('Luxor', 283, '2019-09-18', 161, NULL),
('Luxor', 283, '2019-09-19', 195, NULL),
('Luxor', 283, '2019-09-20', 134, NULL),
('Luxor', 283, '2019-09-21', 100, NULL),
('Luxor', 283, '2019-09-22', 323, NULL),
('Luxor', 283, '2019-09-23', 373, NULL),
('Luxor', 283, '2019-09-24', 224, NULL),
('Luxor', 283, '2019-09-25', 145, NULL),
('Luxor', 283, '2019-09-26', 174, NULL),
('Luxor', 283, '2019-09-27', 207, NULL),
('Luxor', 283, '2019-09-28', 113, NULL),
('Luxor', 283, '2019-09-29', 137, NULL),
('Luxor', 283, '2019-09-30', 110, NULL),
('Luxor', 283, '2019-10-01', 161, NULL),
('Luxor', 283, '2019-10-02', 188, NULL),
('Luxor', 283, '2019-10-03', 127, NULL),
('Luxor', 283, '2019-10-04', 220, NULL),
('Luxor', 283, '2019-10-05', 296, NULL),
('Luxor', 283, '2019-10-06', 148, NULL),
('Luxor', 283, '2019-10-07', 330, NULL),
('Luxor', 283, '2019-10-08', 381, NULL),
('Luxor', 283, '2019-10-09', 256, NULL),
('Luxor', 283, '2019-10-10', 392, NULL),
('Luxor', 283, '2019-10-11', 241, NULL),
('Luxor', 283, '2019-10-12', 304, NULL),
('Luxor', 283, '2019-10-13', 226, NULL),
('Luxor', 283, '2019-10-14', 221, NULL),
('Luxor', 283, '2019-10-15', 257, NULL),
('Luxor', 283, '2019-10-16', 112, NULL),
('Luxor', 283, '2019-10-17', 280, NULL),
('Luxor', 283, '2019-10-18', 350, NULL),
('Luxor', 283, '2019-10-19', 204, NULL),
('Luxor', 283, '2019-10-20', 174, NULL),
('Luxor', 283, '2019-10-21', 147, NULL),
('Luxor', 283, '2019-10-22', 200, NULL),
('Luxor', 283, '2019-10-23', 315, NULL),
('Luxor', 283, '2019-10-24', 294, NULL),
('Luxor', 283, '2019-10-25', 340, NULL),
('Luxor', 283, '2019-10-26', 369, NULL),
('Luxor', 283, '2019-10-27', 143, NULL),
('Luxor', 283, '2019-10-28', 310, NULL),
('Luxor', 283, '2019-10-29', 203, NULL),
('Luxor', 283, '2019-10-30', 189, NULL),
('Luxor', 283, '2019-10-31', 101, NULL),
('Luxor', 283, '2019-11-01', 253, NULL),
('Luxor', 283, '2019-11-02', 111, NULL),
('Luxor', 283, '2019-11-03', 356, NULL),
('Luxor', 283, '2019-11-04', 340, NULL),
('Luxor', 283, '2019-11-05', 210, NULL),
('Luxor', 283, '2019-11-06', 158, NULL),
('Luxor', 283, '2019-11-07', 320, NULL),
('Luxor', 283, '2019-11-08', 195, NULL),
('Luxor', 283, '2019-11-09', 287, NULL),
('Luxor', 283, '2019-11-10', 127, NULL),
('Luxor', 283, '2019-11-11', 363, NULL),
('Luxor', 283, '2019-11-12', 315, NULL),
('Luxor', 283, '2019-11-13', 169, NULL),
('Luxor', 283, '2019-11-14', 155, NULL),
('Luxor', 283, '2019-11-15', 322, NULL),
('Luxor', 283, '2019-11-16', 297, NULL),
('Luxor', 283, '2019-11-17', 105, NULL),
('Luxor', 283, '2019-11-18', 334, NULL),
('Luxor', 283, '2019-11-19', 194, NULL),
('Luxor', 283, '2019-11-20', 135, NULL),
('Luxor', 283, '2019-11-21', 201, NULL),
('Luxor', 283, '2019-11-22', 366, NULL),
('Luxor', 283, '2019-11-23', 338, NULL),
('Luxor', 283, '2019-11-24', 252, NULL),
('Luxor', 283, '2019-11-25', 262, NULL),
('Luxor', 283, '2019-11-26', 385, NULL),
('Luxor', 283, '2019-11-27', 325, NULL),
('Luxor', 283, '2019-11-28', 214, NULL),
('Luxor', 283, '2019-11-29', 192, NULL),
('Luxor', 283, '2019-11-30', 199, NULL),
('Luxor', 283, '2019-12-01', 223, NULL),
('Luxor', 283, '2019-12-02', 184, NULL),
('Luxor', 283, '2019-12-03', 312, NULL),
('Luxor', 283, '2019-12-04', 107, NULL),
('Luxor', 283, '2019-12-05', 308, NULL),
('Luxor', 283, '2019-12-06', 357, NULL),
('Luxor', 283, '2019-12-07', 161, NULL),
('Luxor', 283, '2019-12-08', 136, NULL),
('Luxor', 283, '2019-12-09', 363, NULL),
('Luxor', 283, '2019-12-10', 126, NULL),
('Luxor', 283, '2019-12-11', 119, NULL),
('Luxor', 283, '2019-12-12', 168, NULL),
('Luxor', 283, '2019-12-13', 359, NULL),
('Luxor', 283, '2019-12-14', 246, NULL),
('Luxor', 283, '2019-12-15', 108, NULL),
('Luxor', 283, '2019-12-16', 164, NULL),
('Luxor', 283, '2019-12-17', 328, NULL),
('Luxor', 283, '2019-12-18', 129, NULL),
('Luxor', 283, '2019-12-19', 201, NULL),
('Luxor', 283, '2019-12-20', 399, NULL),
('Luxor', 283, '2019-12-21', 361, NULL),
('Luxor', 283, '2019-12-22', 296, NULL),
('Luxor', 283, '2019-12-23', 202, NULL),
('Luxor', 283, '2019-12-24', 306, NULL),
('Luxor', 283, '2019-12-25', 226, NULL),
('Luxor', 283, '2019-12-26', 145, NULL),
('Luxor', 283, '2019-12-27', 320, NULL),
('Luxor', 283, '2019-12-28', 246, NULL),
('Luxor', 283, '2019-12-29', 364, NULL),
('Luxor', 283, '2019-12-30', 299, NULL),
('Luxor', 283, '2019-12-31', 241, NULL),
('Luxor', 283, '2020-01-01', 208, NULL),
('Luxor', 283, '2020-01-02', 346, NULL),
('Luxor', 283, '2020-01-03', 147, NULL),
('Luxor', 283, '2020-01-04', 115, NULL),
('Luxor', 283, '2020-01-05', 223, NULL),
('Luxor', 283, '2020-01-06', 338, NULL),
('Luxor', 283, '2020-01-07', 212, NULL),
('Luxor', 283, '2020-01-08', 201, NULL),
('Luxor', 283, '2020-01-09', 198, NULL),
('Luxor', 283, '2020-01-10', 330, NULL),
('Luxor', 283, '2020-01-11', 354, NULL),
('Luxor', 283, '2020-01-12', 262, NULL),
('Luxor', 283, '2020-01-13', 250, NULL),
('Luxor', 283, '2020-01-14', 189, NULL),
('Luxor', 283, '2020-01-15', 251, NULL),
('Luxor', 283, '2020-01-16', 248, NULL),
('Luxor', 283, '2020-01-17', 392, NULL),
('Luxor', 283, '2020-01-18', 139, NULL),
('Luxor', 283, '2020-01-19', 223, NULL),
('Luxor', 283, '2020-01-20', 103, NULL),
('Luxor', 283, '2020-01-21', 206, NULL),
('Luxor', 283, '2020-01-22', 211, NULL),
('Luxor', 283, '2020-01-23', 118, NULL),
('Luxor', 283, '2020-01-24', 275, NULL),
('Luxor', 283, '2020-01-25', 179, NULL),
('Luxor', 283, '2020-01-26', 111, NULL),
('Luxor', 283, '2020-01-27', 264, NULL),
('Luxor', 283, '2020-01-28', 173, NULL),
('Luxor', 283, '2020-01-29', 165, NULL),
('Luxor', 283, '2020-01-30', 173, NULL),
('Luxor', 283, '2020-01-31', 351, NULL),
('Luxor', 283, '2020-02-01', 141, NULL),
('Luxor', 283, '2020-02-02', 382, NULL),
('Luxor', 283, '2020-02-03', 383, NULL),
('Luxor', 283, '2020-02-04', 303, NULL),
('Luxor', 284, '2019-01-01', 145, NULL),
('Luxor', 284, '2019-01-02', 111, NULL),
('Luxor', 284, '2019-01-03', 319, NULL),
('Luxor', 284, '2019-01-04', 174, NULL),
('Luxor', 284, '2019-01-05', 285, NULL),
('Luxor', 284, '2019-01-06', 208, NULL),
('Luxor', 284, '2019-01-07', 346, NULL),
('Luxor', 284, '2019-01-08', 197, NULL),
('Luxor', 284, '2019-01-09', 109, NULL),
('Luxor', 284, '2019-01-10', 229, NULL),
('Luxor', 284, '2019-01-11', 240, NULL),
('Luxor', 284, '2019-01-12', 391, NULL),
('Luxor', 284, '2019-01-13', 174, NULL),
('Luxor', 284, '2019-01-14', 314, NULL),
('Luxor', 284, '2019-01-15', 170, NULL),
('Luxor', 284, '2019-01-16', 171, NULL),
('Luxor', 284, '2019-01-17', 365, NULL),
('Luxor', 284, '2019-01-18', 234, NULL),
('Luxor', 284, '2019-01-19', 165, NULL),
('Luxor', 284, '2019-01-20', 160, NULL),
('Luxor', 284, '2019-01-21', 349, NULL),
('Luxor', 284, '2019-01-22', 222, NULL),
('Luxor', 284, '2019-01-23', 258, NULL),
('Luxor', 284, '2019-01-24', 303, NULL),
('Luxor', 284, '2019-01-25', 224, NULL),
('Luxor', 284, '2019-01-26', 206, NULL),
('Luxor', 284, '2019-01-27', 398, NULL),
('Luxor', 284, '2019-01-28', 348, NULL),
('Luxor', 284, '2019-01-29', 383, NULL),
('Luxor', 284, '2019-01-30', 205, NULL),
('Luxor', 284, '2019-01-31', 335, NULL),
('Luxor', 284, '2019-02-01', 256, NULL),
('Luxor', 284, '2019-02-02', 271, NULL),
('Luxor', 284, '2019-02-03', 107, NULL),
('Luxor', 284, '2019-02-04', 317, NULL),
('Luxor', 284, '2019-02-05', 367, NULL),
('Luxor', 284, '2019-02-06', 381, NULL),
('Luxor', 284, '2019-02-07', 161, NULL),
('Luxor', 284, '2019-02-08', 250, NULL),
('Luxor', 284, '2019-02-09', 291, NULL),
('Luxor', 284, '2019-02-10', 317, NULL),
('Luxor', 284, '2019-02-11', 379, NULL),
('Luxor', 284, '2019-02-12', 244, NULL),
('Luxor', 284, '2019-02-13', 139, NULL),
('Luxor', 284, '2019-02-14', 259, NULL),
('Luxor', 284, '2019-02-15', 131, NULL),
('Luxor', 284, '2019-02-16', 127, NULL),
('Luxor', 284, '2019-02-17', 206, NULL),
('Luxor', 284, '2019-02-18', 227, NULL),
('Luxor', 284, '2019-02-19', 395, NULL),
('Luxor', 284, '2019-02-20', 155, NULL),
('Luxor', 284, '2019-02-21', 116, NULL),
('Luxor', 284, '2019-02-22', 342, NULL),
('Luxor', 284, '2019-02-23', 195, NULL),
('Luxor', 284, '2019-02-24', 372, NULL),
('Luxor', 284, '2019-02-25', 256, NULL),
('Luxor', 284, '2019-02-26', 157, NULL),
('Luxor', 284, '2019-02-27', 272, NULL),
('Luxor', 284, '2019-02-28', 247, NULL),
('Luxor', 284, '2019-03-01', 312, NULL),
('Luxor', 284, '2019-03-02', 269, NULL),
('Luxor', 284, '2019-03-03', 321, NULL),
('Luxor', 284, '2019-03-04', 366, NULL),
('Luxor', 284, '2019-03-05', 161, NULL),
('Luxor', 284, '2019-03-06', 280, NULL),
('Luxor', 284, '2019-03-07', 335, NULL),
('Luxor', 284, '2019-03-08', 123, NULL),
('Luxor', 284, '2019-03-09', 162, NULL),
('Luxor', 284, '2019-03-10', 398, NULL),
('Luxor', 284, '2019-03-11', 356, NULL),
('Luxor', 284, '2019-03-12', 119, NULL),
('Luxor', 284, '2019-03-13', 294, NULL),
('Luxor', 284, '2019-03-14', 270, NULL),
('Luxor', 284, '2019-03-15', 208, NULL),
('Luxor', 284, '2019-03-16', 130, NULL),
('Luxor', 284, '2019-03-17', 178, NULL),
('Luxor', 284, '2019-03-18', 176, NULL),
('Luxor', 284, '2019-03-19', 133, NULL),
('Luxor', 284, '2019-03-20', 134, NULL),
('Luxor', 284, '2019-03-21', 293, NULL),
('Luxor', 284, '2019-03-22', 390, NULL),
('Luxor', 284, '2019-03-23', 367, NULL),
('Luxor', 284, '2019-03-24', 130, NULL),
('Luxor', 284, '2019-03-25', 122, NULL),
('Luxor', 284, '2019-03-26', 118, NULL),
('Luxor', 284, '2019-03-27', 372, NULL),
('Luxor', 284, '2019-03-28', 207, NULL),
('Luxor', 284, '2019-03-29', 247, NULL),
('Luxor', 284, '2019-03-30', 321, NULL),
('Luxor', 284, '2019-03-31', 147, NULL),
('Luxor', 284, '2019-04-01', 235, NULL),
('Luxor', 284, '2019-04-02', 298, NULL),
('Luxor', 284, '2019-04-03', 213, NULL),
('Luxor', 284, '2019-04-04', 230, NULL),
('Luxor', 284, '2019-04-05', 197, NULL),
('Luxor', 284, '2019-04-06', 297, NULL),
('Luxor', 284, '2019-04-07', 254, NULL),
('Luxor', 284, '2019-04-08', 288, NULL),
('Luxor', 284, '2019-04-09', 362, NULL),
('Luxor', 284, '2019-04-10', 392, NULL),
('Luxor', 284, '2019-04-11', 246, NULL),
('Luxor', 284, '2019-04-12', 357, NULL),
('Luxor', 284, '2019-04-13', 338, NULL),
('Luxor', 284, '2019-04-14', 311, NULL),
('Luxor', 284, '2019-04-15', 128, NULL),
('Luxor', 284, '2019-04-16', 242, NULL),
('Luxor', 284, '2019-04-17', 309, NULL),
('Luxor', 284, '2019-04-18', 183, NULL),
('Luxor', 284, '2019-04-19', 305, NULL),
('Luxor', 284, '2019-04-20', 189, NULL),
('Luxor', 284, '2019-04-21', 323, NULL),
('Luxor', 284, '2019-04-22', 117, NULL),
('Luxor', 284, '2019-04-23', 144, NULL),
('Luxor', 284, '2019-04-24', 338, NULL),
('Luxor', 284, '2019-04-25', 184, NULL),
('Luxor', 284, '2019-04-26', 243, NULL),
('Luxor', 284, '2019-04-27', 245, NULL),
('Luxor', 284, '2019-04-28', 226, NULL),
('Luxor', 284, '2019-04-29', 253, NULL),
('Luxor', 284, '2019-04-30', 162, NULL),
('Luxor', 284, '2019-05-01', 186, NULL),
('Luxor', 284, '2019-05-02', 165, NULL),
('Luxor', 284, '2019-05-03', 193, NULL),
('Luxor', 284, '2019-05-04', 356, NULL),
('Luxor', 284, '2019-05-05', 327, NULL),
('Luxor', 284, '2019-05-06', 162, NULL),
('Luxor', 284, '2019-05-07', 182, NULL),
('Luxor', 284, '2019-05-08', 380, NULL),
('Luxor', 284, '2019-05-09', 307, NULL),
('Luxor', 284, '2019-05-10', 213, NULL),
('Luxor', 284, '2019-05-11', 281, NULL),
('Luxor', 284, '2019-05-12', 297, NULL),
('Luxor', 284, '2019-05-13', 118, NULL),
('Luxor', 284, '2019-05-14', 290, NULL),
('Luxor', 284, '2019-05-15', 275, NULL),
('Luxor', 284, '2019-05-16', 267, NULL),
('Luxor', 284, '2019-05-17', 298, NULL),
('Luxor', 284, '2019-05-18', 342, NULL),
('Luxor', 284, '2019-05-19', 227, NULL),
('Luxor', 284, '2019-05-20', 243, NULL),
('Luxor', 284, '2019-05-21', 184, NULL),
('Luxor', 284, '2019-05-22', 301, NULL),
('Luxor', 284, '2019-05-23', 359, NULL),
('Luxor', 284, '2019-05-24', 352, NULL),
('Luxor', 284, '2019-05-25', 269, NULL),
('Luxor', 284, '2019-05-26', 204, NULL),
('Luxor', 284, '2019-05-27', 120, NULL),
('Luxor', 284, '2019-05-28', 311, NULL),
('Luxor', 284, '2019-05-29', 138, NULL),
('Luxor', 284, '2019-05-30', 292, NULL),
('Luxor', 284, '2019-05-31', 213, NULL),
('Luxor', 284, '2019-06-01', 351, NULL),
('Luxor', 284, '2019-06-02', 165, NULL),
('Luxor', 284, '2019-06-03', 379, NULL),
('Luxor', 284, '2019-06-04', 133, NULL),
('Luxor', 284, '2019-06-05', 224, NULL),
('Luxor', 284, '2019-06-06', 172, NULL),
('Luxor', 284, '2019-06-07', 387, NULL),
('Luxor', 284, '2019-06-08', 320, NULL),
('Luxor', 284, '2019-06-09', 141, NULL),
('Luxor', 284, '2019-06-10', 141, NULL),
('Luxor', 284, '2019-06-11', 159, NULL),
('Luxor', 284, '2019-06-12', 295, NULL),
('Luxor', 284, '2019-06-13', 257, NULL),
('Luxor', 284, '2019-06-14', 157, NULL),
('Luxor', 284, '2019-06-15', 281, NULL),
('Luxor', 284, '2019-06-16', 168, NULL),
('Luxor', 284, '2019-06-17', 328, NULL),
('Luxor', 284, '2019-06-18', 284, NULL),
('Luxor', 284, '2019-06-19', 106, NULL),
('Luxor', 284, '2019-06-20', 187, NULL),
('Luxor', 284, '2019-06-21', 308, NULL),
('Luxor', 284, '2019-06-22', 121, NULL),
('Luxor', 284, '2019-06-23', 187, NULL),
('Luxor', 284, '2019-06-24', 206, NULL),
('Luxor', 284, '2019-06-25', 159, NULL),
('Luxor', 284, '2019-06-26', 113, NULL),
('Luxor', 284, '2019-06-27', 248, NULL),
('Luxor', 284, '2019-06-28', 285, NULL),
('Luxor', 284, '2019-06-29', 377, NULL),
('Luxor', 284, '2019-06-30', 272, NULL),
('Luxor', 284, '2019-07-01', 168, NULL),
('Luxor', 284, '2019-07-02', 102, NULL),
('Luxor', 284, '2019-07-03', 173, NULL),
('Luxor', 284, '2019-07-04', 372, NULL),
('Luxor', 284, '2019-07-05', 277, NULL),
('Luxor', 284, '2019-07-06', 132, NULL),
('Luxor', 284, '2019-07-07', 140, NULL),
('Luxor', 284, '2019-07-08', 220, NULL),
('Luxor', 284, '2019-07-09', 111, NULL),
('Luxor', 284, '2019-07-10', 218, NULL),
('Luxor', 284, '2019-07-11', 361, NULL),
('Luxor', 284, '2019-07-12', 108, NULL),
('Luxor', 284, '2019-07-13', 262, NULL),
('Luxor', 284, '2019-07-14', 105, NULL),
('Luxor', 284, '2019-07-15', 258, NULL),
('Luxor', 284, '2019-07-16', 181, NULL),
('Luxor', 284, '2019-07-17', 266, NULL),
('Luxor', 284, '2019-07-18', 213, NULL),
('Luxor', 284, '2019-07-19', 354, NULL),
('Luxor', 284, '2019-07-20', 130, NULL),
('Luxor', 284, '2019-07-21', 253, NULL),
('Luxor', 284, '2019-07-22', 364, NULL),
('Luxor', 284, '2019-07-23', 122, NULL),
('Luxor', 284, '2019-07-24', 285, NULL),
('Luxor', 284, '2019-07-25', 345, NULL),
('Luxor', 284, '2019-07-26', 249, NULL),
('Luxor', 284, '2019-07-27', 252, NULL),
('Luxor', 284, '2019-07-28', 154, NULL),
('Luxor', 284, '2019-07-29', 284, NULL),
('Luxor', 284, '2019-07-30', 199, NULL),
('Luxor', 284, '2019-07-31', 106, NULL),
('Luxor', 284, '2019-08-01', 398, NULL),
('Luxor', 284, '2019-08-02', 221, NULL),
('Luxor', 284, '2019-08-03', 207, NULL),
('Luxor', 284, '2019-08-04', 228, NULL),
('Luxor', 284, '2019-08-05', 143, NULL),
('Luxor', 284, '2019-08-06', 116, NULL),
('Luxor', 284, '2019-08-07', 171, NULL),
('Luxor', 284, '2019-08-08', 316, NULL),
('Luxor', 284, '2019-08-09', 218, NULL),
('Luxor', 284, '2019-08-10', 261, NULL),
('Luxor', 284, '2019-08-11', 250, NULL),
('Luxor', 284, '2019-08-12', 120, NULL),
('Luxor', 284, '2019-08-13', 118, NULL),
('Luxor', 284, '2019-08-14', 160, NULL),
('Luxor', 284, '2019-08-15', 170, NULL),
('Luxor', 284, '2019-08-16', 266, NULL),
('Luxor', 284, '2019-08-17', 274, NULL),
('Luxor', 284, '2019-08-18', 384, NULL),
('Luxor', 284, '2019-08-19', 124, NULL),
('Luxor', 284, '2019-08-20', 216, NULL),
('Luxor', 284, '2019-08-21', 335, NULL),
('Luxor', 284, '2019-08-22', 378, NULL),
('Luxor', 284, '2019-08-23', 169, NULL),
('Luxor', 284, '2019-08-24', 356, NULL),
('Luxor', 284, '2019-08-25', 324, NULL),
('Luxor', 284, '2019-08-26', 154, NULL),
('Luxor', 284, '2019-08-27', 293, NULL),
('Luxor', 284, '2019-08-28', 121, NULL),
('Luxor', 284, '2019-08-29', 314, NULL),
('Luxor', 284, '2019-08-30', 202, NULL),
('Luxor', 284, '2019-08-31', 133, NULL),
('Luxor', 284, '2019-09-01', 141, NULL),
('Luxor', 284, '2019-09-02', 319, NULL),
('Luxor', 284, '2019-09-03', 272, NULL),
('Luxor', 284, '2019-09-04', 348, NULL),
('Luxor', 284, '2019-09-05', 181, NULL),
('Luxor', 284, '2019-09-06', 196, NULL),
('Luxor', 284, '2019-09-07', 211, NULL),
('Luxor', 284, '2019-09-08', 219, NULL),
('Luxor', 284, '2019-09-09', 338, NULL),
('Luxor', 284, '2019-09-10', 361, NULL),
('Luxor', 284, '2019-09-11', 314, NULL),
('Luxor', 284, '2019-09-12', 314, NULL),
('Luxor', 284, '2019-09-13', 236, NULL),
('Luxor', 284, '2019-09-14', 116, NULL),
('Luxor', 284, '2019-09-15', 142, NULL),
('Luxor', 284, '2019-09-16', 113, NULL),
('Luxor', 284, '2019-09-17', 356, NULL),
('Luxor', 284, '2019-09-18', 262, NULL),
('Luxor', 284, '2019-09-19', 106, NULL),
('Luxor', 284, '2019-09-20', 101, NULL),
('Luxor', 284, '2019-09-21', 309, NULL),
('Luxor', 284, '2019-09-22', 121, NULL),
('Luxor', 284, '2019-09-23', 265, NULL),
('Luxor', 284, '2019-09-24', 115, NULL),
('Luxor', 284, '2019-09-25', 207, NULL),
('Luxor', 284, '2019-09-26', 261, NULL),
('Luxor', 284, '2019-09-27', 242, NULL),
('Luxor', 284, '2019-09-28', 162, NULL),
('Luxor', 284, '2019-09-29', 224, NULL),
('Luxor', 284, '2019-09-30', 348, NULL),
('Luxor', 284, '2019-10-01', 323, NULL),
('Luxor', 284, '2019-10-02', 368, NULL),
('Luxor', 284, '2019-10-03', 272, NULL),
('Luxor', 284, '2019-10-04', 388, NULL),
('Luxor', 284, '2019-10-05', 157, NULL),
('Luxor', 284, '2019-10-06', 220, NULL),
('Luxor', 284, '2019-10-07', 257, NULL),
('Luxor', 284, '2019-10-08', 141, NULL),
('Luxor', 284, '2019-10-09', 163, NULL),
('Luxor', 284, '2019-10-10', 142, NULL),
('Luxor', 284, '2019-10-11', 183, NULL),
('Luxor', 284, '2019-10-12', 106, NULL),
('Luxor', 284, '2019-10-13', 231, NULL),
('Luxor', 284, '2019-10-14', 348, NULL),
('Luxor', 284, '2019-10-15', 183, NULL),
('Luxor', 284, '2019-10-16', 105, NULL),
('Luxor', 284, '2019-10-17', 374, NULL),
('Luxor', 284, '2019-10-18', 135, NULL),
('Luxor', 284, '2019-10-19', 235, NULL),
('Luxor', 284, '2019-10-20', 254, NULL),
('Luxor', 284, '2019-10-21', 122, NULL),
('Luxor', 284, '2019-10-22', 108, NULL),
('Luxor', 284, '2019-10-23', 238, NULL),
('Luxor', 284, '2019-10-24', 306, NULL),
('Luxor', 284, '2019-10-25', 331, NULL),
('Luxor', 284, '2019-10-26', 317, NULL),
('Luxor', 284, '2019-10-27', 148, NULL),
('Luxor', 284, '2019-10-28', 360, NULL),
('Luxor', 284, '2019-10-29', 171, NULL),
('Luxor', 284, '2019-10-30', 154, NULL),
('Luxor', 284, '2019-10-31', 321, NULL),
('Luxor', 284, '2019-11-01', 148, NULL),
('Luxor', 284, '2019-11-02', 165, NULL),
('Luxor', 284, '2019-11-03', 350, NULL),
('Luxor', 284, '2019-11-04', 115, NULL),
('Luxor', 284, '2019-11-05', 168, NULL),
('Luxor', 284, '2019-11-06', 370, NULL),
('Luxor', 284, '2019-11-07', 239, NULL),
('Luxor', 284, '2019-11-08', 207, NULL),
('Luxor', 284, '2019-11-09', 389, NULL),
('Luxor', 284, '2019-11-10', 320, NULL),
('Luxor', 284, '2019-11-11', 356, NULL),
('Luxor', 284, '2019-11-12', 358, NULL),
('Luxor', 284, '2019-11-13', 144, NULL),
('Luxor', 284, '2019-11-14', 231, NULL),
('Luxor', 284, '2019-11-15', 139, NULL),
('Luxor', 284, '2019-11-16', 293, NULL),
('Luxor', 284, '2019-11-17', 254, NULL),
('Luxor', 284, '2019-11-18', 245, NULL),
('Luxor', 284, '2019-11-19', 149, NULL),
('Luxor', 284, '2019-11-20', 268, NULL),
('Luxor', 284, '2019-11-21', 272, NULL),
('Luxor', 284, '2019-11-22', 132, NULL),
('Luxor', 284, '2019-11-23', 234, NULL),
('Luxor', 284, '2019-11-24', 222, NULL),
('Luxor', 284, '2019-11-25', 188, NULL),
('Luxor', 284, '2019-11-26', 237, NULL),
('Luxor', 284, '2019-11-27', 230, NULL),
('Luxor', 284, '2019-11-28', 146, NULL),
('Luxor', 284, '2019-11-29', 164, NULL),
('Luxor', 284, '2019-11-30', 331, NULL),
('Luxor', 284, '2019-12-01', 102, NULL),
('Luxor', 284, '2019-12-02', 246, NULL),
('Luxor', 284, '2019-12-03', 365, NULL),
('Luxor', 284, '2019-12-04', 198, NULL),
('Luxor', 284, '2019-12-05', 238, NULL),
('Luxor', 284, '2019-12-06', 135, NULL),
('Luxor', 284, '2019-12-07', 140, NULL),
('Luxor', 284, '2019-12-08', 132, NULL),
('Luxor', 284, '2019-12-09', 133, NULL),
('Luxor', 284, '2019-12-10', 390, NULL),
('Luxor', 284, '2019-12-11', 138, NULL),
('Luxor', 284, '2019-12-12', 216, NULL),
('Luxor', 284, '2019-12-13', 346, NULL),
('Luxor', 284, '2019-12-14', 111, NULL),
('Luxor', 284, '2019-12-15', 172, NULL),
('Luxor', 284, '2019-12-16', 397, NULL),
('Luxor', 284, '2019-12-17', 304, NULL),
('Luxor', 284, '2019-12-18', 238, NULL),
('Luxor', 284, '2019-12-19', 263, NULL),
('Luxor', 284, '2019-12-20', 270, NULL),
('Luxor', 284, '2019-12-21', 243, NULL),
('Luxor', 284, '2019-12-22', 207, NULL),
('Luxor', 284, '2019-12-23', 357, NULL),
('Luxor', 284, '2019-12-24', 167, NULL),
('Luxor', 284, '2019-12-25', 244, NULL),
('Luxor', 284, '2019-12-26', 368, NULL),
('Luxor', 284, '2019-12-27', 116, NULL),
('Luxor', 284, '2019-12-28', 189, NULL),
('Luxor', 284, '2019-12-29', 314, NULL),
('Luxor', 284, '2019-12-30', 356, NULL),
('Luxor', 284, '2019-12-31', 378, NULL),
('Luxor', 284, '2020-01-01', 117, NULL),
('Luxor', 284, '2020-01-02', 133, NULL),
('Luxor', 284, '2020-01-03', 390, NULL),
('Luxor', 284, '2020-01-04', 143, NULL),
('Luxor', 284, '2020-01-05', 361, NULL),
('Luxor', 284, '2020-01-06', 348, NULL),
('Luxor', 284, '2020-01-07', 292, NULL),
('Luxor', 284, '2020-01-08', 313, NULL),
('Luxor', 284, '2020-01-09', 368, NULL),
('Luxor', 284, '2020-01-10', 379, NULL),
('Luxor', 284, '2020-01-11', 165, NULL),
('Luxor', 284, '2020-01-12', 358, NULL),
('Luxor', 284, '2020-01-13', 161, NULL),
('Luxor', 284, '2020-01-14', 281, NULL),
('Luxor', 284, '2020-01-15', 125, NULL),
('Luxor', 284, '2020-01-16', 142, NULL),
('Luxor', 284, '2020-01-17', 297, NULL),
('Luxor', 284, '2020-01-18', 372, NULL),
('Luxor', 284, '2020-01-19', 174, NULL),
('Luxor', 284, '2020-01-20', 396, NULL),
('Luxor', 284, '2020-01-21', 216, NULL),
('Luxor', 284, '2020-01-22', 222, NULL),
('Luxor', 284, '2020-01-23', 220, NULL),
('Luxor', 284, '2020-01-24', 361, NULL),
('Luxor', 284, '2020-01-25', 191, NULL),
('Luxor', 284, '2020-01-26', 366, NULL),
('Luxor', 284, '2020-01-27', 199, NULL),
('Luxor', 284, '2020-01-28', 315, NULL),
('Luxor', 284, '2020-01-29', 261, NULL),
('Luxor', 284, '2020-01-30', 398, NULL),
('Luxor', 284, '2020-01-31', 274, NULL),
('Luxor', 284, '2020-02-01', 106, NULL),
('Luxor', 284, '2020-02-02', 345, NULL),
('Luxor', 284, '2020-02-03', 279, NULL),
('Luxor', 284, '2020-02-04', 177, NULL),
('Luxor', 286, '2019-01-01', 380, NULL),
('Luxor', 286, '2019-01-02', 352, NULL),
('Luxor', 286, '2019-01-03', 364, NULL),
('Luxor', 286, '2019-01-04', 203, NULL),
('Luxor', 286, '2019-01-05', 362, NULL),
('Luxor', 286, '2019-01-06', 203, NULL),
('Luxor', 286, '2019-01-07', 362, NULL),
('Luxor', 286, '2019-01-08', 315, NULL),
('Luxor', 286, '2019-01-09', 392, NULL),
('Luxor', 286, '2019-01-10', 375, NULL),
('Luxor', 286, '2019-01-11', 137, NULL),
('Luxor', 286, '2019-01-12', 336, NULL),
('Luxor', 286, '2019-01-13', 136, NULL),
('Luxor', 286, '2019-01-14', 398, NULL),
('Luxor', 286, '2019-01-15', 294, NULL),
('Luxor', 286, '2019-01-16', 390, NULL),
('Luxor', 286, '2019-01-17', 136, NULL),
('Luxor', 286, '2019-01-18', 379, NULL),
('Luxor', 286, '2019-01-19', 128, NULL),
('Luxor', 286, '2019-01-20', 245, NULL),
('Luxor', 286, '2019-01-21', 248, NULL),
('Luxor', 286, '2019-01-22', 254, NULL),
('Luxor', 286, '2019-01-23', 302, NULL),
('Luxor', 286, '2019-01-24', 237, NULL),
('Luxor', 286, '2019-01-25', 223, NULL),
('Luxor', 286, '2019-01-26', 139, NULL),
('Luxor', 286, '2019-01-27', 118, NULL),
('Luxor', 286, '2019-01-28', 335, NULL),
('Luxor', 286, '2019-01-29', 225, NULL),
('Luxor', 286, '2019-01-30', 250, NULL),
('Luxor', 286, '2019-01-31', 215, NULL),
('Luxor', 286, '2019-02-01', 272, NULL),
('Luxor', 286, '2019-02-02', 197, NULL),
('Luxor', 286, '2019-02-03', 399, NULL),
('Luxor', 286, '2019-02-04', 286, NULL),
('Luxor', 286, '2019-02-05', 106, NULL),
('Luxor', 286, '2019-02-06', 271, NULL),
('Luxor', 286, '2019-02-07', 230, NULL),
('Luxor', 286, '2019-02-08', 183, NULL),
('Luxor', 286, '2019-02-09', 336, NULL),
('Luxor', 286, '2019-02-10', 328, NULL),
('Luxor', 286, '2019-02-11', 357, NULL),
('Luxor', 286, '2019-02-12', 274, NULL),
('Luxor', 286, '2019-02-13', 207, NULL),
('Luxor', 286, '2019-02-14', 388, NULL),
('Luxor', 286, '2019-02-15', 335, NULL),
('Luxor', 286, '2019-02-16', 369, NULL),
('Luxor', 286, '2019-02-17', 333, NULL),
('Luxor', 286, '2019-02-18', 183, NULL),
('Luxor', 286, '2019-02-19', 255, NULL),
('Luxor', 286, '2019-02-20', 108, NULL),
('Luxor', 286, '2019-02-21', 340, NULL),
('Luxor', 286, '2019-02-22', 279, NULL),
('Luxor', 286, '2019-02-23', 276, NULL),
('Luxor', 286, '2019-02-24', 394, NULL),
('Luxor', 286, '2019-02-25', 291, NULL),
('Luxor', 286, '2019-02-26', 167, NULL),
('Luxor', 286, '2019-02-27', 372, NULL),
('Luxor', 286, '2019-02-28', 180, NULL),
('Luxor', 286, '2019-03-01', 111, NULL),
('Luxor', 286, '2019-03-02', 189, NULL),
('Luxor', 286, '2019-03-03', 220, NULL),
('Luxor', 286, '2019-03-04', 354, NULL),
('Luxor', 286, '2019-03-05', 290, NULL),
('Luxor', 286, '2019-03-06', 276, NULL),
('Luxor', 286, '2019-03-07', 364, NULL),
('Luxor', 286, '2019-03-08', 141, NULL),
('Luxor', 286, '2019-03-09', 369, NULL),
('Luxor', 286, '2019-03-10', 120, NULL),
('Luxor', 286, '2019-03-11', 277, NULL),
('Luxor', 286, '2019-03-12', 311, NULL),
('Luxor', 286, '2019-03-13', 110, NULL),
('Luxor', 286, '2019-03-14', 389, NULL),
('Luxor', 286, '2019-03-15', 334, NULL),
('Luxor', 286, '2019-03-16', 348, NULL),
('Luxor', 286, '2019-03-17', 199, NULL),
('Luxor', 286, '2019-03-18', 290, NULL),
('Luxor', 286, '2019-03-19', 355, NULL),
('Luxor', 286, '2019-03-20', 123, NULL),
('Luxor', 286, '2019-03-21', 169, NULL),
('Luxor', 286, '2019-03-22', 301, NULL),
('Luxor', 286, '2019-03-23', 190, NULL),
('Luxor', 286, '2019-03-24', 213, NULL),
('Luxor', 286, '2019-03-25', 391, NULL),
('Luxor', 286, '2019-03-26', 164, NULL),
('Luxor', 286, '2019-03-27', 351, NULL),
('Luxor', 286, '2019-03-28', 301, NULL),
('Luxor', 286, '2019-03-29', 190, NULL),
('Luxor', 286, '2019-03-30', 199, NULL),
('Luxor', 286, '2019-03-31', 211, NULL),
('Luxor', 286, '2019-04-01', 153, NULL),
('Luxor', 286, '2019-04-02', 347, NULL),
('Luxor', 286, '2019-04-03', 205, NULL),
('Luxor', 286, '2019-04-04', 113, NULL),
('Luxor', 286, '2019-04-05', 257, NULL),
('Luxor', 286, '2019-04-06', 167, NULL),
('Luxor', 286, '2019-04-07', 390, NULL),
('Luxor', 286, '2019-04-08', 377, NULL),
('Luxor', 286, '2019-04-09', 178, NULL),
('Luxor', 286, '2019-04-10', 228, NULL),
('Luxor', 286, '2019-04-11', 246, NULL),
('Luxor', 286, '2019-04-12', 234, NULL),
('Luxor', 286, '2019-04-13', 275, NULL),
('Luxor', 286, '2019-04-14', 287, NULL),
('Luxor', 286, '2019-04-15', 200, NULL),
('Luxor', 286, '2019-04-16', 139, NULL),
('Luxor', 286, '2019-04-17', 179, NULL),
('Luxor', 286, '2019-04-18', 223, NULL),
('Luxor', 286, '2019-04-19', 200, NULL),
('Luxor', 286, '2019-04-20', 102, NULL),
('Luxor', 286, '2019-04-21', 150, NULL),
('Luxor', 286, '2019-04-22', 139, NULL),
('Luxor', 286, '2019-04-23', 183, NULL),
('Luxor', 286, '2019-04-24', 341, NULL),
('Luxor', 286, '2019-04-25', 271, NULL),
('Luxor', 286, '2019-04-26', 101, NULL),
('Luxor', 286, '2019-04-27', 104, NULL),
('Luxor', 286, '2019-04-28', 150, NULL),
('Luxor', 286, '2019-04-29', 241, NULL),
('Luxor', 286, '2019-04-30', 176, NULL),
('Luxor', 286, '2019-05-01', 212, NULL),
('Luxor', 286, '2019-05-02', 128, NULL),
('Luxor', 286, '2019-05-03', 324, NULL),
('Luxor', 286, '2019-05-04', 300, NULL),
('Luxor', 286, '2019-05-05', 324, NULL),
('Luxor', 286, '2019-05-06', 266, NULL),
('Luxor', 286, '2019-05-07', 287, NULL),
('Luxor', 286, '2019-05-08', 176, NULL),
('Luxor', 286, '2019-05-09', 190, NULL),
('Luxor', 286, '2019-05-10', 236, NULL),
('Luxor', 286, '2019-05-11', 210, NULL),
('Luxor', 286, '2019-05-12', 242, NULL),
('Luxor', 286, '2019-05-13', 130, NULL),
('Luxor', 286, '2019-05-14', 276, NULL),
('Luxor', 286, '2019-05-15', 337, NULL),
('Luxor', 286, '2019-05-16', 172, NULL),
('Luxor', 286, '2019-05-17', 284, NULL),
('Luxor', 286, '2019-05-18', 305, NULL),
('Luxor', 286, '2019-05-19', 317, NULL),
('Luxor', 286, '2019-05-20', 161, NULL),
('Luxor', 286, '2019-05-21', 258, NULL),
('Luxor', 286, '2019-05-22', 294, NULL),
('Luxor', 286, '2019-05-23', 340, NULL),
('Luxor', 286, '2019-05-24', 162, NULL),
('Luxor', 286, '2019-05-25', 283, NULL),
('Luxor', 286, '2019-05-26', 175, NULL),
('Luxor', 286, '2019-05-27', 172, NULL),
('Luxor', 286, '2019-05-28', 221, NULL),
('Luxor', 286, '2019-05-29', 356, NULL),
('Luxor', 286, '2019-05-30', 317, NULL),
('Luxor', 286, '2019-05-31', 330, NULL),
('Luxor', 286, '2019-06-01', 381, NULL),
('Luxor', 286, '2019-06-02', 143, NULL),
('Luxor', 286, '2019-06-03', 309, NULL),
('Luxor', 286, '2019-06-04', 398, NULL),
('Luxor', 286, '2019-06-05', 343, NULL),
('Luxor', 286, '2019-06-06', 237, NULL),
('Luxor', 286, '2019-06-07', 121, NULL),
('Luxor', 286, '2019-06-08', 366, NULL),
('Luxor', 286, '2019-06-09', 382, NULL),
('Luxor', 286, '2019-06-10', 234, NULL),
('Luxor', 286, '2019-06-11', 353, NULL),
('Luxor', 286, '2019-06-12', 139, NULL),
('Luxor', 286, '2019-06-13', 143, NULL),
('Luxor', 286, '2019-06-14', 353, NULL),
('Luxor', 286, '2019-06-15', 309, NULL),
('Luxor', 286, '2019-06-16', 276, NULL),
('Luxor', 286, '2019-06-17', 197, NULL),
('Luxor', 286, '2019-06-18', 111, NULL),
('Luxor', 286, '2019-06-19', 112, NULL),
('Luxor', 286, '2019-06-20', 266, NULL),
('Luxor', 286, '2019-06-21', 380, NULL),
('Luxor', 286, '2019-06-22', 358, NULL),
('Luxor', 286, '2019-06-23', 141, NULL),
('Luxor', 286, '2019-06-24', 341, NULL),
('Luxor', 286, '2019-06-25', 115, NULL),
('Luxor', 286, '2019-06-26', 135, NULL),
('Luxor', 286, '2019-06-27', 104, NULL),
('Luxor', 286, '2019-06-28', 332, NULL),
('Luxor', 286, '2019-06-29', 216, NULL),
('Luxor', 286, '2019-06-30', 194, NULL),
('Luxor', 286, '2019-07-01', 160, NULL),
('Luxor', 286, '2019-07-02', 307, NULL),
('Luxor', 286, '2019-07-03', 396, NULL),
('Luxor', 286, '2019-07-04', 321, NULL),
('Luxor', 286, '2019-07-05', 337, NULL),
('Luxor', 286, '2019-07-06', 115, NULL),
('Luxor', 286, '2019-07-07', 257, NULL),
('Luxor', 286, '2019-07-08', 217, NULL),
('Luxor', 286, '2019-07-09', 124, NULL),
('Luxor', 286, '2019-07-10', 236, NULL),
('Luxor', 286, '2019-07-11', 317, NULL),
('Luxor', 286, '2019-07-12', 240, NULL),
('Luxor', 286, '2019-07-13', 172, NULL),
('Luxor', 286, '2019-07-14', 215, NULL),
('Luxor', 286, '2019-07-15', 274, NULL),
('Luxor', 286, '2019-07-16', 244, NULL),
('Luxor', 286, '2019-07-17', 355, NULL),
('Luxor', 286, '2019-07-18', 352, NULL),
('Luxor', 286, '2019-07-19', 250, NULL),
('Luxor', 286, '2019-07-20', 278, NULL),
('Luxor', 286, '2019-07-21', 186, NULL),
('Luxor', 286, '2019-07-22', 245, NULL),
('Luxor', 286, '2019-07-23', 395, NULL),
('Luxor', 286, '2019-07-24', 367, NULL),
('Luxor', 286, '2019-07-25', 391, NULL),
('Luxor', 286, '2019-07-26', 167, NULL),
('Luxor', 286, '2019-07-27', 230, NULL),
('Luxor', 286, '2019-07-28', 330, NULL),
('Luxor', 286, '2019-07-29', 125, NULL),
('Luxor', 286, '2019-07-30', 166, NULL),
('Luxor', 286, '2019-07-31', 337, NULL),
('Luxor', 286, '2019-08-01', 350, NULL),
('Luxor', 286, '2019-08-02', 320, NULL),
('Luxor', 286, '2019-08-03', 162, NULL),
('Luxor', 286, '2019-08-04', 327, NULL),
('Luxor', 286, '2019-08-05', 129, NULL),
('Luxor', 286, '2019-08-06', 163, NULL),
('Luxor', 286, '2019-08-07', 290, NULL),
('Luxor', 286, '2019-08-08', 128, NULL),
('Luxor', 286, '2019-08-09', 163, NULL),
('Luxor', 286, '2019-08-10', 392, NULL),
('Luxor', 286, '2019-08-11', 339, NULL),
('Luxor', 286, '2019-08-12', 246, NULL),
('Luxor', 286, '2019-08-13', 158, NULL),
('Luxor', 286, '2019-08-14', 190, NULL),
('Luxor', 286, '2019-08-15', 312, NULL),
('Luxor', 286, '2019-08-16', 268, NULL),
('Luxor', 286, '2019-08-17', 337, NULL),
('Luxor', 286, '2019-08-18', 270, NULL),
('Luxor', 286, '2019-08-19', 372, NULL),
('Luxor', 286, '2019-08-20', 174, NULL),
('Luxor', 286, '2019-08-21', 207, NULL),
('Luxor', 286, '2019-08-22', 334, NULL),
('Luxor', 286, '2019-08-23', 396, NULL),
('Luxor', 286, '2019-08-24', 188, NULL),
('Luxor', 286, '2019-08-25', 239, NULL),
('Luxor', 286, '2019-08-26', 299, NULL),
('Luxor', 286, '2019-08-27', 338, NULL),
('Luxor', 286, '2019-08-28', 222, NULL),
('Luxor', 286, '2019-08-29', 388, NULL),
('Luxor', 286, '2019-08-30', 236, NULL),
('Luxor', 286, '2019-08-31', 336, NULL),
('Luxor', 286, '2019-09-01', 392, NULL),
('Luxor', 286, '2019-09-02', 392, NULL),
('Luxor', 286, '2019-09-03', 250, NULL),
('Luxor', 286, '2019-09-04', 211, NULL),
('Luxor', 286, '2019-09-05', 195, NULL),
('Luxor', 286, '2019-09-06', 210, NULL),
('Luxor', 286, '2019-09-07', 158, NULL),
('Luxor', 286, '2019-09-08', 318, NULL),
('Luxor', 286, '2019-09-09', 231, NULL),
('Luxor', 286, '2019-09-10', 387, NULL),
('Luxor', 286, '2019-09-11', 202, NULL),
('Luxor', 286, '2019-09-12', 114, NULL),
('Luxor', 286, '2019-09-13', 348, NULL),
('Luxor', 286, '2019-09-14', 336, NULL),
('Luxor', 286, '2019-09-15', 316, NULL),
('Luxor', 286, '2019-09-16', 280, NULL),
('Luxor', 286, '2019-09-17', 138, NULL),
('Luxor', 286, '2019-09-18', 127, NULL),
('Luxor', 286, '2019-09-19', 144, NULL),
('Luxor', 286, '2019-09-20', 304, NULL),
('Luxor', 286, '2019-09-21', 243, NULL),
('Luxor', 286, '2019-09-22', 137, NULL),
('Luxor', 286, '2019-09-23', 106, NULL),
('Luxor', 286, '2019-09-24', 103, NULL),
('Luxor', 286, '2019-09-25', 204, NULL),
('Luxor', 286, '2019-09-26', 387, NULL),
('Luxor', 286, '2019-09-27', 188, NULL),
('Luxor', 286, '2019-09-28', 372, NULL),
('Luxor', 286, '2019-09-29', 309, NULL),
('Luxor', 286, '2019-09-30', 111, NULL),
('Luxor', 286, '2019-10-01', 131, NULL),
('Luxor', 286, '2019-10-02', 279, NULL),
('Luxor', 286, '2019-10-03', 282, NULL),
('Luxor', 286, '2019-10-04', 283, NULL),
('Luxor', 286, '2019-10-05', 396, NULL),
('Luxor', 286, '2019-10-06', 258, NULL),
('Luxor', 286, '2019-10-07', 197, NULL),
('Luxor', 286, '2019-10-08', 362, NULL),
('Luxor', 286, '2019-10-09', 250, NULL),
('Luxor', 286, '2019-10-10', 334, NULL),
('Luxor', 286, '2019-10-11', 391, NULL),
('Luxor', 286, '2019-10-12', 117, NULL),
('Luxor', 286, '2019-10-13', 378, NULL),
('Luxor', 286, '2019-10-14', 378, NULL),
('Luxor', 286, '2019-10-15', 343, NULL),
('Luxor', 286, '2019-10-16', 386, NULL),
('Luxor', 286, '2019-10-17', 333, NULL),
('Luxor', 286, '2019-10-18', 123, NULL),
('Luxor', 286, '2019-10-19', 164, NULL),
('Luxor', 286, '2019-10-20', 345, NULL),
('Luxor', 286, '2019-10-21', 371, NULL),
('Luxor', 286, '2019-10-22', 140, NULL),
('Luxor', 286, '2019-10-23', 148, NULL),
('Luxor', 286, '2019-10-24', 252, NULL),
('Luxor', 286, '2019-10-25', 233, NULL),
('Luxor', 286, '2019-10-26', 376, NULL),
('Luxor', 286, '2019-10-27', 210, NULL),
('Luxor', 286, '2019-10-28', 168, NULL),
('Luxor', 286, '2019-10-29', 147, NULL),
('Luxor', 286, '2019-10-30', 103, NULL),
('Luxor', 286, '2019-10-31', 305, NULL),
('Luxor', 286, '2019-11-01', 178, NULL),
('Luxor', 286, '2019-11-02', 391, NULL),
('Luxor', 286, '2019-11-03', 284, NULL),
('Luxor', 286, '2019-11-04', 354, NULL),
('Luxor', 286, '2019-11-05', 112, NULL),
('Luxor', 286, '2019-11-06', 375, NULL),
('Luxor', 286, '2019-11-07', 136, NULL),
('Luxor', 286, '2019-11-08', 351, NULL),
('Luxor', 286, '2019-11-09', 386, NULL),
('Luxor', 286, '2019-11-10', 216, NULL),
('Luxor', 286, '2019-11-11', 291, NULL),
('Luxor', 286, '2019-11-12', 143, NULL),
('Luxor', 286, '2019-11-13', 112, NULL),
('Luxor', 286, '2019-11-14', 290, NULL),
('Luxor', 286, '2019-11-15', 232, NULL),
('Luxor', 286, '2019-11-16', 174, NULL),
('Luxor', 286, '2019-11-17', 254, NULL),
('Luxor', 286, '2019-11-18', 123, NULL),
('Luxor', 286, '2019-11-19', 365, NULL),
('Luxor', 286, '2019-11-20', 238, NULL),
('Luxor', 286, '2019-11-21', 358, NULL),
('Luxor', 286, '2019-11-22', 364, NULL),
('Luxor', 286, '2019-11-23', 355, NULL),
('Luxor', 286, '2019-11-24', 255, NULL),
('Luxor', 286, '2019-11-25', 355, NULL),
('Luxor', 286, '2019-11-26', 232, NULL),
('Luxor', 286, '2019-11-27', 374, NULL),
('Luxor', 286, '2019-11-28', 288, NULL),
('Luxor', 286, '2019-11-29', 147, NULL),
('Luxor', 286, '2019-11-30', 360, NULL),
('Luxor', 286, '2019-12-01', 338, NULL),
('Luxor', 286, '2019-12-02', 276, NULL),
('Luxor', 286, '2019-12-03', 188, NULL),
('Luxor', 286, '2019-12-04', 269, NULL),
('Luxor', 286, '2019-12-05', 168, NULL),
('Luxor', 286, '2019-12-06', 105, NULL),
('Luxor', 286, '2019-12-07', 116, NULL),
('Luxor', 286, '2019-12-08', 151, NULL),
('Luxor', 286, '2019-12-09', 375, NULL),
('Luxor', 286, '2019-12-10', 273, NULL),
('Luxor', 286, '2019-12-11', 235, NULL),
('Luxor', 286, '2019-12-12', 176, NULL),
('Luxor', 286, '2019-12-13', 256, NULL),
('Luxor', 286, '2019-12-14', 319, NULL),
('Luxor', 286, '2019-12-15', 138, NULL),
('Luxor', 286, '2019-12-16', 191, NULL),
('Luxor', 286, '2019-12-17', 139, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Luxor', 286, '2019-12-18', 100, NULL),
('Luxor', 286, '2019-12-19', 314, NULL),
('Luxor', 286, '2019-12-20', 354, NULL),
('Luxor', 286, '2019-12-21', 332, NULL),
('Luxor', 286, '2019-12-22', 348, NULL),
('Luxor', 286, '2019-12-23', 176, NULL),
('Luxor', 286, '2019-12-24', 115, NULL),
('Luxor', 286, '2019-12-25', 143, NULL),
('Luxor', 286, '2019-12-26', 105, NULL),
('Luxor', 286, '2019-12-27', 119, NULL),
('Luxor', 286, '2019-12-28', 110, NULL),
('Luxor', 286, '2019-12-29', 377, NULL),
('Luxor', 286, '2019-12-30', 186, NULL),
('Luxor', 286, '2019-12-31', 167, NULL),
('Luxor', 286, '2020-01-01', 160, NULL),
('Luxor', 286, '2020-01-02', 128, NULL),
('Luxor', 286, '2020-01-03', 209, NULL),
('Luxor', 286, '2020-01-04', 270, NULL),
('Luxor', 286, '2020-01-05', 138, NULL),
('Luxor', 286, '2020-01-06', 327, NULL),
('Luxor', 286, '2020-01-07', 124, NULL),
('Luxor', 286, '2020-01-08', 261, NULL),
('Luxor', 286, '2020-01-09', 249, NULL),
('Luxor', 286, '2020-01-10', 205, NULL),
('Luxor', 286, '2020-01-11', 264, NULL),
('Luxor', 286, '2020-01-12', 304, NULL),
('Luxor', 286, '2020-01-13', 252, NULL),
('Luxor', 286, '2020-01-14', 138, NULL),
('Luxor', 286, '2020-01-15', 373, NULL),
('Luxor', 286, '2020-01-16', 167, NULL),
('Luxor', 286, '2020-01-17', 209, NULL),
('Luxor', 286, '2020-01-18', 142, NULL),
('Luxor', 286, '2020-01-19', 101, NULL),
('Luxor', 286, '2020-01-20', 369, NULL),
('Luxor', 286, '2020-01-21', 362, NULL),
('Luxor', 286, '2020-01-22', 376, NULL),
('Luxor', 286, '2020-01-23', 347, NULL),
('Luxor', 286, '2020-01-24', 280, NULL),
('Luxor', 286, '2020-01-25', 321, NULL),
('Luxor', 286, '2020-01-26', 201, NULL),
('Luxor', 286, '2020-01-27', 101, NULL),
('Luxor', 286, '2020-01-28', 356, NULL),
('Luxor', 286, '2020-01-29', 111, NULL),
('Luxor', 286, '2020-01-30', 170, NULL),
('Luxor', 286, '2020-01-31', 216, NULL),
('Luxor', 286, '2020-02-01', 309, NULL),
('Luxor', 286, '2020-02-02', 178, NULL),
('Luxor', 286, '2020-02-03', 143, NULL),
('Luxor', 286, '2020-02-04', 178, NULL),
('Luxor', 289, '2019-01-01', 168, NULL),
('Luxor', 289, '2019-01-02', 125, NULL),
('Luxor', 289, '2019-01-03', 165, NULL),
('Luxor', 289, '2019-01-04', 395, NULL),
('Luxor', 289, '2019-01-05', 255, NULL),
('Luxor', 289, '2019-01-06', 290, NULL),
('Luxor', 289, '2019-01-07', 373, NULL),
('Luxor', 289, '2019-01-08', 282, NULL),
('Luxor', 289, '2019-01-09', 332, NULL),
('Luxor', 289, '2019-01-10', 190, NULL),
('Luxor', 289, '2019-01-11', 168, NULL),
('Luxor', 289, '2019-01-12', 105, NULL),
('Luxor', 289, '2019-01-13', 359, NULL),
('Luxor', 289, '2019-01-14', 349, NULL),
('Luxor', 289, '2019-01-15', 258, NULL),
('Luxor', 289, '2019-01-16', 139, NULL),
('Luxor', 289, '2019-01-17', 386, NULL),
('Luxor', 289, '2019-01-18', 192, NULL),
('Luxor', 289, '2019-01-19', 344, NULL),
('Luxor', 289, '2019-01-20', 349, NULL),
('Luxor', 289, '2019-01-21', 394, NULL),
('Luxor', 289, '2019-01-22', 205, NULL),
('Luxor', 289, '2019-01-23', 337, NULL),
('Luxor', 289, '2019-01-24', 175, NULL),
('Luxor', 289, '2019-01-25', 342, NULL),
('Luxor', 289, '2019-01-26', 277, NULL),
('Luxor', 289, '2019-01-27', 196, NULL),
('Luxor', 289, '2019-01-28', 231, NULL),
('Luxor', 289, '2019-01-29', 177, NULL),
('Luxor', 289, '2019-01-30', 236, NULL),
('Luxor', 289, '2019-01-31', 268, NULL),
('Luxor', 289, '2019-02-01', 194, NULL),
('Luxor', 289, '2019-02-02', 370, NULL),
('Luxor', 289, '2019-02-03', 372, NULL),
('Luxor', 289, '2019-02-04', 378, NULL),
('Luxor', 289, '2019-02-05', 231, NULL),
('Luxor', 289, '2019-02-06', 110, NULL),
('Luxor', 289, '2019-02-07', 269, NULL),
('Luxor', 289, '2019-02-08', 365, NULL),
('Luxor', 289, '2019-02-09', 105, NULL),
('Luxor', 289, '2019-02-10', 291, NULL),
('Luxor', 289, '2019-02-11', 246, NULL),
('Luxor', 289, '2019-02-12', 240, NULL),
('Luxor', 289, '2019-02-13', 219, NULL),
('Luxor', 289, '2019-02-14', 162, NULL),
('Luxor', 289, '2019-02-15', 280, NULL),
('Luxor', 289, '2019-02-16', 165, NULL),
('Luxor', 289, '2019-02-17', 349, NULL),
('Luxor', 289, '2019-02-18', 136, NULL),
('Luxor', 289, '2019-02-19', 292, NULL),
('Luxor', 289, '2019-02-20', 276, NULL),
('Luxor', 289, '2019-02-21', 352, NULL),
('Luxor', 289, '2019-02-22', 267, NULL),
('Luxor', 289, '2019-02-23', 398, NULL),
('Luxor', 289, '2019-02-24', 156, NULL),
('Luxor', 289, '2019-02-25', 291, NULL),
('Luxor', 289, '2019-02-26', 266, NULL),
('Luxor', 289, '2019-02-27', 347, NULL),
('Luxor', 289, '2019-02-28', 360, NULL),
('Luxor', 289, '2019-03-01', 118, NULL),
('Luxor', 289, '2019-03-02', 341, NULL),
('Luxor', 289, '2019-03-03', 340, NULL),
('Luxor', 289, '2019-03-04', 272, NULL),
('Luxor', 289, '2019-03-05', 269, NULL),
('Luxor', 289, '2019-03-06', 141, NULL),
('Luxor', 289, '2019-03-07', 115, NULL),
('Luxor', 289, '2019-03-08', 235, NULL),
('Luxor', 289, '2019-03-09', 359, NULL),
('Luxor', 289, '2019-03-10', 206, NULL),
('Luxor', 289, '2019-03-11', 217, NULL),
('Luxor', 289, '2019-03-12', 200, NULL),
('Luxor', 289, '2019-03-13', 168, NULL),
('Luxor', 289, '2019-03-14', 133, NULL),
('Luxor', 289, '2019-03-15', 347, NULL),
('Luxor', 289, '2019-03-16', 348, NULL),
('Luxor', 289, '2019-03-17', 360, NULL),
('Luxor', 289, '2019-03-18', 222, NULL),
('Luxor', 289, '2019-03-19', 377, NULL),
('Luxor', 289, '2019-03-20', 117, NULL),
('Luxor', 289, '2019-03-21', 165, NULL),
('Luxor', 289, '2019-03-22', 234, NULL),
('Luxor', 289, '2019-03-23', 348, NULL),
('Luxor', 289, '2019-03-24', 274, NULL),
('Luxor', 289, '2019-03-25', 290, NULL),
('Luxor', 289, '2019-03-26', 368, NULL),
('Luxor', 289, '2019-03-27', 243, NULL),
('Luxor', 289, '2019-03-28', 186, NULL),
('Luxor', 289, '2019-03-29', 110, NULL),
('Luxor', 289, '2019-03-30', 235, NULL),
('Luxor', 289, '2019-03-31', 214, NULL),
('Luxor', 289, '2019-04-01', 259, NULL),
('Luxor', 289, '2019-04-02', 139, NULL),
('Luxor', 289, '2019-04-03', 287, NULL),
('Luxor', 289, '2019-04-04', 377, NULL),
('Luxor', 289, '2019-04-05', 297, NULL),
('Luxor', 289, '2019-04-06', 146, NULL),
('Luxor', 289, '2019-04-07', 187, NULL),
('Luxor', 289, '2019-04-08', 322, NULL),
('Luxor', 289, '2019-04-09', 307, NULL),
('Luxor', 289, '2019-04-10', 165, NULL),
('Luxor', 289, '2019-04-11', 396, NULL),
('Luxor', 289, '2019-04-12', 300, NULL),
('Luxor', 289, '2019-04-13', 260, NULL),
('Luxor', 289, '2019-04-14', 102, NULL),
('Luxor', 289, '2019-04-15', 218, NULL),
('Luxor', 289, '2019-04-16', 170, NULL),
('Luxor', 289, '2019-04-17', 170, NULL),
('Luxor', 289, '2019-04-18', 170, NULL),
('Luxor', 289, '2019-04-19', 287, NULL),
('Luxor', 289, '2019-04-20', 143, NULL),
('Luxor', 289, '2019-04-21', 282, NULL),
('Luxor', 289, '2019-04-22', 245, NULL),
('Luxor', 289, '2019-04-23', 383, NULL),
('Luxor', 289, '2019-04-24', 289, NULL),
('Luxor', 289, '2019-04-25', 102, NULL),
('Luxor', 289, '2019-04-26', 277, NULL),
('Luxor', 289, '2019-04-27', 282, NULL),
('Luxor', 289, '2019-04-28', 273, NULL),
('Luxor', 289, '2019-04-29', 345, NULL),
('Luxor', 289, '2019-04-30', 292, NULL),
('Luxor', 289, '2019-05-01', 100, NULL),
('Luxor', 289, '2019-05-02', 347, NULL),
('Luxor', 289, '2019-05-03', 343, NULL),
('Luxor', 289, '2019-05-04', 335, NULL),
('Luxor', 289, '2019-05-05', 236, NULL),
('Luxor', 289, '2019-05-06', 143, NULL),
('Luxor', 289, '2019-05-07', 189, NULL),
('Luxor', 289, '2019-05-08', 241, NULL),
('Luxor', 289, '2019-05-09', 229, NULL),
('Luxor', 289, '2019-05-10', 144, NULL),
('Luxor', 289, '2019-05-11', 105, NULL),
('Luxor', 289, '2019-05-12', 219, NULL),
('Luxor', 289, '2019-05-13', 197, NULL),
('Luxor', 289, '2019-05-14', 110, NULL),
('Luxor', 289, '2019-05-15', 161, NULL),
('Luxor', 289, '2019-05-16', 262, NULL),
('Luxor', 289, '2019-05-17', 127, NULL),
('Luxor', 289, '2019-05-18', 101, NULL),
('Luxor', 289, '2019-05-19', 203, NULL),
('Luxor', 289, '2019-05-20', 276, NULL),
('Luxor', 289, '2019-05-21', 338, NULL),
('Luxor', 289, '2019-05-22', 169, NULL),
('Luxor', 289, '2019-05-23', 223, NULL),
('Luxor', 289, '2019-05-24', 255, NULL),
('Luxor', 289, '2019-05-25', 207, NULL),
('Luxor', 289, '2019-05-26', 161, NULL),
('Luxor', 289, '2019-05-27', 100, NULL),
('Luxor', 289, '2019-05-28', 371, NULL),
('Luxor', 289, '2019-05-29', 368, NULL),
('Luxor', 289, '2019-05-30', 311, NULL),
('Luxor', 289, '2019-05-31', 312, NULL),
('Luxor', 289, '2019-06-01', 151, NULL),
('Luxor', 289, '2019-06-02', 122, NULL),
('Luxor', 289, '2019-06-03', 309, NULL),
('Luxor', 289, '2019-06-04', 291, NULL),
('Luxor', 289, '2019-06-05', 346, NULL),
('Luxor', 289, '2019-06-06', 272, NULL),
('Luxor', 289, '2019-06-07', 243, NULL),
('Luxor', 289, '2019-06-08', 171, NULL),
('Luxor', 289, '2019-06-09', 186, NULL),
('Luxor', 289, '2019-06-10', 347, NULL),
('Luxor', 289, '2019-06-11', 288, NULL),
('Luxor', 289, '2019-06-12', 312, NULL),
('Luxor', 289, '2019-06-13', 144, NULL),
('Luxor', 289, '2019-06-14', 296, NULL),
('Luxor', 289, '2019-06-15', 304, NULL),
('Luxor', 289, '2019-06-16', 177, NULL),
('Luxor', 289, '2019-06-17', 203, NULL),
('Luxor', 289, '2019-06-18', 205, NULL),
('Luxor', 289, '2019-06-19', 145, NULL),
('Luxor', 289, '2019-06-20', 371, NULL),
('Luxor', 289, '2019-06-21', 277, NULL),
('Luxor', 289, '2019-06-22', 127, NULL),
('Luxor', 289, '2019-06-23', 343, NULL),
('Luxor', 289, '2019-06-24', 386, NULL),
('Luxor', 289, '2019-06-25', 296, NULL),
('Luxor', 289, '2019-06-26', 238, NULL),
('Luxor', 289, '2019-06-27', 278, NULL),
('Luxor', 289, '2019-06-28', 107, NULL),
('Luxor', 289, '2019-06-29', 152, NULL),
('Luxor', 289, '2019-06-30', 352, NULL),
('Luxor', 289, '2019-07-01', 195, NULL),
('Luxor', 289, '2019-07-02', 229, NULL),
('Luxor', 289, '2019-07-03', 160, NULL),
('Luxor', 289, '2019-07-04', 386, NULL),
('Luxor', 289, '2019-07-05', 158, NULL),
('Luxor', 289, '2019-07-06', 383, NULL),
('Luxor', 289, '2019-07-07', 168, NULL),
('Luxor', 289, '2019-07-08', 326, NULL),
('Luxor', 289, '2019-07-09', 188, NULL),
('Luxor', 289, '2019-07-10', 124, NULL),
('Luxor', 289, '2019-07-11', 100, NULL),
('Luxor', 289, '2019-07-12', 175, NULL),
('Luxor', 289, '2019-07-13', 273, NULL),
('Luxor', 289, '2019-07-14', 362, NULL),
('Luxor', 289, '2019-07-15', 196, NULL),
('Luxor', 289, '2019-07-16', 278, NULL),
('Luxor', 289, '2019-07-17', 276, NULL),
('Luxor', 289, '2019-07-18', 121, NULL),
('Luxor', 289, '2019-07-19', 386, NULL),
('Luxor', 289, '2019-07-20', 299, NULL),
('Luxor', 289, '2019-07-21', 373, NULL),
('Luxor', 289, '2019-07-22', 333, NULL),
('Luxor', 289, '2019-07-23', 310, NULL),
('Luxor', 289, '2019-07-24', 280, NULL),
('Luxor', 289, '2019-07-25', 220, NULL),
('Luxor', 289, '2019-07-26', 290, NULL),
('Luxor', 289, '2019-07-27', 294, NULL),
('Luxor', 289, '2019-07-28', 188, NULL),
('Luxor', 289, '2019-07-29', 272, NULL),
('Luxor', 289, '2019-07-30', 134, NULL),
('Luxor', 289, '2019-07-31', 370, NULL),
('Luxor', 289, '2019-08-01', 159, NULL),
('Luxor', 289, '2019-08-02', 235, NULL),
('Luxor', 289, '2019-08-03', 390, NULL),
('Luxor', 289, '2019-08-04', 254, NULL),
('Luxor', 289, '2019-08-05', 118, NULL),
('Luxor', 289, '2019-08-06', 367, NULL),
('Luxor', 289, '2019-08-07', 235, NULL),
('Luxor', 289, '2019-08-08', 192, NULL),
('Luxor', 289, '2019-08-09', 360, NULL),
('Luxor', 289, '2019-08-10', 180, NULL),
('Luxor', 289, '2019-08-11', 242, NULL),
('Luxor', 289, '2019-08-12', 170, NULL),
('Luxor', 289, '2019-08-13', 335, NULL),
('Luxor', 289, '2019-08-14', 373, NULL),
('Luxor', 289, '2019-08-15', 349, NULL),
('Luxor', 289, '2019-08-16', 142, NULL),
('Luxor', 289, '2019-08-17', 166, NULL),
('Luxor', 289, '2019-08-18', 399, NULL),
('Luxor', 289, '2019-08-19', 189, NULL),
('Luxor', 289, '2019-08-20', 123, NULL),
('Luxor', 289, '2019-08-21', 230, NULL),
('Luxor', 289, '2019-08-22', 136, NULL),
('Luxor', 289, '2019-08-23', 174, NULL),
('Luxor', 289, '2019-08-24', 372, NULL),
('Luxor', 289, '2019-08-25', 125, NULL),
('Luxor', 289, '2019-08-26', 332, NULL),
('Luxor', 289, '2019-08-27', 110, NULL),
('Luxor', 289, '2019-08-28', 346, NULL),
('Luxor', 289, '2019-08-29', 300, NULL),
('Luxor', 289, '2019-08-30', 173, NULL),
('Luxor', 289, '2019-08-31', 280, NULL),
('Luxor', 289, '2019-09-01', 237, NULL),
('Luxor', 289, '2019-09-02', 304, NULL),
('Luxor', 289, '2019-09-03', 334, NULL),
('Luxor', 289, '2019-09-04', 211, NULL),
('Luxor', 289, '2019-09-05', 330, NULL),
('Luxor', 289, '2019-09-06', 363, NULL),
('Luxor', 289, '2019-09-07', 356, NULL),
('Luxor', 289, '2019-09-08', 233, NULL),
('Luxor', 289, '2019-09-09', 341, NULL),
('Luxor', 289, '2019-09-10', 155, NULL),
('Luxor', 289, '2019-09-11', 266, NULL),
('Luxor', 289, '2019-09-12', 128, NULL),
('Luxor', 289, '2019-09-13', 331, NULL),
('Luxor', 289, '2019-09-14', 334, NULL),
('Luxor', 289, '2019-09-15', 151, NULL),
('Luxor', 289, '2019-09-16', 361, NULL),
('Luxor', 289, '2019-09-17', 121, NULL),
('Luxor', 289, '2019-09-18', 349, NULL),
('Luxor', 289, '2019-09-19', 304, NULL),
('Luxor', 289, '2019-09-20', 215, NULL),
('Luxor', 289, '2019-09-21', 190, NULL),
('Luxor', 289, '2019-09-22', 224, NULL),
('Luxor', 289, '2019-09-23', 238, NULL),
('Luxor', 289, '2019-09-24', 372, NULL),
('Luxor', 289, '2019-09-25', 298, NULL),
('Luxor', 289, '2019-09-26', 150, NULL),
('Luxor', 289, '2019-09-27', 116, NULL),
('Luxor', 289, '2019-09-28', 375, NULL),
('Luxor', 289, '2019-09-29', 173, NULL),
('Luxor', 289, '2019-09-30', 314, NULL),
('Luxor', 289, '2019-10-01', 189, NULL),
('Luxor', 289, '2019-10-02', 191, NULL),
('Luxor', 289, '2019-10-03', 191, NULL),
('Luxor', 289, '2019-10-04', 152, NULL),
('Luxor', 289, '2019-10-05', 210, NULL),
('Luxor', 289, '2019-10-06', 231, NULL),
('Luxor', 289, '2019-10-07', 112, NULL),
('Luxor', 289, '2019-10-08', 387, NULL),
('Luxor', 289, '2019-10-09', 361, NULL),
('Luxor', 289, '2019-10-10', 243, NULL),
('Luxor', 289, '2019-10-11', 108, NULL),
('Luxor', 289, '2019-10-12', 167, NULL),
('Luxor', 289, '2019-10-13', 196, NULL),
('Luxor', 289, '2019-10-14', 149, NULL),
('Luxor', 289, '2019-10-15', 167, NULL),
('Luxor', 289, '2019-10-16', 317, NULL),
('Luxor', 289, '2019-10-17', 144, NULL),
('Luxor', 289, '2019-10-18', 114, NULL),
('Luxor', 289, '2019-10-19', 316, NULL),
('Luxor', 289, '2019-10-20', 266, NULL),
('Luxor', 289, '2019-10-21', 191, NULL),
('Luxor', 289, '2019-10-22', 275, NULL),
('Luxor', 289, '2019-10-23', 225, NULL),
('Luxor', 289, '2019-10-24', 242, NULL),
('Luxor', 289, '2019-10-25', 373, NULL),
('Luxor', 289, '2019-10-26', 229, NULL),
('Luxor', 289, '2019-10-27', 209, NULL),
('Luxor', 289, '2019-10-28', 261, NULL),
('Luxor', 289, '2019-10-29', 122, NULL),
('Luxor', 289, '2019-10-30', 255, NULL),
('Luxor', 289, '2019-10-31', 160, NULL),
('Luxor', 289, '2019-11-01', 349, NULL),
('Luxor', 289, '2019-11-02', 159, NULL),
('Luxor', 289, '2019-11-03', 269, NULL),
('Luxor', 289, '2019-11-04', 129, NULL),
('Luxor', 289, '2019-11-05', 255, NULL),
('Luxor', 289, '2019-11-06', 365, NULL),
('Luxor', 289, '2019-11-07', 166, NULL),
('Luxor', 289, '2019-11-08', 133, NULL),
('Luxor', 289, '2019-11-09', 360, NULL),
('Luxor', 289, '2019-11-10', 320, NULL),
('Luxor', 289, '2019-11-11', 286, NULL),
('Luxor', 289, '2019-11-12', 140, NULL),
('Luxor', 289, '2019-11-13', 329, NULL),
('Luxor', 289, '2019-11-14', 360, NULL),
('Luxor', 289, '2019-11-15', 343, NULL),
('Luxor', 289, '2019-11-16', 189, NULL),
('Luxor', 289, '2019-11-17', 109, NULL),
('Luxor', 289, '2019-11-18', 381, NULL),
('Luxor', 289, '2019-11-19', 378, NULL),
('Luxor', 289, '2019-11-20', 286, NULL),
('Luxor', 289, '2019-11-21', 274, NULL),
('Luxor', 289, '2019-11-22', 122, NULL),
('Luxor', 289, '2019-11-23', 373, NULL),
('Luxor', 289, '2019-11-24', 210, NULL),
('Luxor', 289, '2019-11-25', 213, NULL),
('Luxor', 289, '2019-11-26', 347, NULL),
('Luxor', 289, '2019-11-27', 180, NULL),
('Luxor', 289, '2019-11-28', 302, NULL),
('Luxor', 289, '2019-11-29', 142, NULL),
('Luxor', 289, '2019-11-30', 107, NULL),
('Luxor', 289, '2019-12-01', 386, NULL),
('Luxor', 289, '2019-12-02', 244, NULL),
('Luxor', 289, '2019-12-03', 345, NULL),
('Luxor', 289, '2019-12-04', 352, NULL),
('Luxor', 289, '2019-12-05', 326, NULL),
('Luxor', 289, '2019-12-06', 322, NULL),
('Luxor', 289, '2019-12-07', 363, NULL),
('Luxor', 289, '2019-12-08', 258, NULL),
('Luxor', 289, '2019-12-09', 177, NULL),
('Luxor', 289, '2019-12-10', 396, NULL),
('Luxor', 289, '2019-12-11', 360, NULL),
('Luxor', 289, '2019-12-12', 134, NULL),
('Luxor', 289, '2019-12-13', 142, NULL),
('Luxor', 289, '2019-12-14', 261, NULL),
('Luxor', 289, '2019-12-15', 372, NULL),
('Luxor', 289, '2019-12-16', 267, NULL),
('Luxor', 289, '2019-12-17', 281, NULL),
('Luxor', 289, '2019-12-18', 289, NULL),
('Luxor', 289, '2019-12-19', 380, NULL),
('Luxor', 289, '2019-12-20', 261, NULL),
('Luxor', 289, '2019-12-21', 231, NULL),
('Luxor', 289, '2019-12-22', 121, NULL),
('Luxor', 289, '2019-12-23', 312, NULL),
('Luxor', 289, '2019-12-24', 276, NULL),
('Luxor', 289, '2019-12-25', 184, NULL),
('Luxor', 289, '2019-12-26', 220, NULL),
('Luxor', 289, '2019-12-27', 148, NULL),
('Luxor', 289, '2019-12-28', 185, NULL),
('Luxor', 289, '2019-12-29', 246, NULL),
('Luxor', 289, '2019-12-30', 361, NULL),
('Luxor', 289, '2019-12-31', 201, NULL),
('Luxor', 289, '2020-01-01', 352, NULL),
('Luxor', 289, '2020-01-02', 142, NULL),
('Luxor', 289, '2020-01-03', 378, NULL),
('Luxor', 289, '2020-01-04', 224, NULL),
('Luxor', 289, '2020-01-05', 108, NULL),
('Luxor', 289, '2020-01-06', 189, NULL),
('Luxor', 289, '2020-01-07', 246, NULL),
('Luxor', 289, '2020-01-08', 269, NULL),
('Luxor', 289, '2020-01-09', 341, NULL),
('Luxor', 289, '2020-01-10', 389, NULL),
('Luxor', 289, '2020-01-11', 124, NULL),
('Luxor', 289, '2020-01-12', 348, NULL),
('Luxor', 289, '2020-01-13', 381, NULL),
('Luxor', 289, '2020-01-14', 350, NULL),
('Luxor', 289, '2020-01-15', 188, NULL),
('Luxor', 289, '2020-01-16', 310, NULL),
('Luxor', 289, '2020-01-17', 354, NULL),
('Luxor', 289, '2020-01-18', 397, NULL),
('Luxor', 289, '2020-01-19', 181, NULL),
('Luxor', 289, '2020-01-20', 258, NULL),
('Luxor', 289, '2020-01-21', 163, NULL),
('Luxor', 289, '2020-01-22', 215, NULL),
('Luxor', 289, '2020-01-23', 376, NULL),
('Luxor', 289, '2020-01-24', 219, NULL),
('Luxor', 289, '2020-01-25', 330, NULL),
('Luxor', 289, '2020-01-26', 105, NULL),
('Luxor', 289, '2020-01-27', 110, NULL),
('Luxor', 289, '2020-01-28', 135, NULL),
('Luxor', 289, '2020-01-29', 273, NULL),
('Luxor', 289, '2020-01-30', 159, NULL),
('Luxor', 289, '2020-01-31', 160, NULL),
('Luxor', 289, '2020-02-01', 229, NULL),
('Luxor', 289, '2020-02-02', 358, NULL),
('Luxor', 289, '2020-02-03', 381, NULL),
('Luxor', 289, '2020-02-04', 260, NULL),
('Residence Inn', 1, '2019-01-01', 198, 141),
('Residence Inn', 1, '2019-01-02', 370, 141),
('Residence Inn', 1, '2019-01-03', 231, 141),
('Residence Inn', 1, '2019-01-04', 368, 141),
('Residence Inn', 1, '2019-01-05', 389, 141),
('Residence Inn', 1, '2019-01-06', 145, 141),
('Residence Inn', 1, '2019-01-07', 381, 141),
('Residence Inn', 1, '2019-01-08', 365, 141),
('Residence Inn', 1, '2019-01-09', 386, 141),
('Residence Inn', 1, '2019-01-10', 324, 141),
('Residence Inn', 1, '2019-01-11', 327, NULL),
('Residence Inn', 1, '2019-01-12', 318, NULL),
('Residence Inn', 1, '2019-01-13', 384, NULL),
('Residence Inn', 1, '2019-01-14', 151, NULL),
('Residence Inn', 1, '2019-01-15', 312, NULL),
('Residence Inn', 1, '2019-01-16', 326, NULL),
('Residence Inn', 1, '2019-01-17', 221, NULL),
('Residence Inn', 1, '2019-01-18', 323, NULL),
('Residence Inn', 1, '2019-01-19', 338, NULL),
('Residence Inn', 1, '2019-01-20', 309, NULL),
('Residence Inn', 1, '2019-01-21', 227, NULL),
('Residence Inn', 1, '2019-01-22', 162, NULL),
('Residence Inn', 1, '2019-01-23', 377, NULL),
('Residence Inn', 1, '2019-01-24', 365, NULL),
('Residence Inn', 1, '2019-01-25', 344, NULL),
('Residence Inn', 1, '2019-01-26', 270, NULL),
('Residence Inn', 1, '2019-01-27', 228, NULL),
('Residence Inn', 1, '2019-01-28', 352, NULL),
('Residence Inn', 1, '2019-01-29', 109, NULL),
('Residence Inn', 1, '2019-01-30', 331, NULL),
('Residence Inn', 1, '2019-01-31', 298, NULL),
('Residence Inn', 1, '2019-02-01', 351, NULL),
('Residence Inn', 1, '2019-02-02', 262, NULL),
('Residence Inn', 1, '2019-02-03', 264, NULL),
('Residence Inn', 1, '2019-02-04', 335, NULL),
('Residence Inn', 1, '2019-02-05', 135, NULL),
('Residence Inn', 1, '2019-02-06', 240, NULL),
('Residence Inn', 1, '2019-02-07', 257, NULL),
('Residence Inn', 1, '2019-02-08', 279, NULL),
('Residence Inn', 1, '2019-02-09', 318, NULL),
('Residence Inn', 1, '2019-02-10', 370, 99),
('Residence Inn', 1, '2019-02-11', 360, 99),
('Residence Inn', 1, '2019-02-12', 277, 99),
('Residence Inn', 1, '2019-02-13', 375, 99),
('Residence Inn', 1, '2019-02-14', 147, NULL),
('Residence Inn', 1, '2019-02-15', 297, NULL),
('Residence Inn', 1, '2019-02-16', 219, NULL),
('Residence Inn', 1, '2019-02-17', 345, NULL),
('Residence Inn', 1, '2019-02-18', 330, NULL),
('Residence Inn', 1, '2019-02-19', 295, NULL),
('Residence Inn', 1, '2019-02-20', 355, NULL),
('Residence Inn', 1, '2019-02-21', 340, NULL),
('Residence Inn', 1, '2019-02-22', 101, NULL),
('Residence Inn', 1, '2019-02-23', 162, NULL),
('Residence Inn', 1, '2019-02-24', 399, NULL),
('Residence Inn', 1, '2019-02-25', 182, NULL),
('Residence Inn', 1, '2019-02-26', 127, NULL),
('Residence Inn', 1, '2019-02-27', 217, NULL),
('Residence Inn', 1, '2019-02-28', 260, NULL),
('Residence Inn', 1, '2019-03-01', 160, NULL),
('Residence Inn', 1, '2019-03-02', 137, NULL),
('Residence Inn', 1, '2019-03-03', 338, NULL),
('Residence Inn', 1, '2019-03-04', 197, NULL),
('Residence Inn', 1, '2019-03-05', 377, NULL),
('Residence Inn', 1, '2019-03-06', 377, NULL),
('Residence Inn', 1, '2019-03-07', 284, NULL),
('Residence Inn', 1, '2019-03-08', 351, NULL),
('Residence Inn', 1, '2019-03-09', 286, NULL),
('Residence Inn', 1, '2019-03-10', 273, NULL),
('Residence Inn', 1, '2019-03-11', 153, NULL),
('Residence Inn', 1, '2019-03-12', 267, NULL),
('Residence Inn', 1, '2019-03-13', 110, NULL),
('Residence Inn', 1, '2019-03-14', 301, NULL),
('Residence Inn', 1, '2019-03-15', 334, NULL),
('Residence Inn', 1, '2019-03-16', 298, NULL),
('Residence Inn', 1, '2019-03-17', 204, NULL),
('Residence Inn', 1, '2019-03-18', 139, NULL),
('Residence Inn', 1, '2019-03-19', 120, NULL),
('Residence Inn', 1, '2019-03-20', 113, NULL),
('Residence Inn', 1, '2019-03-21', 219, NULL),
('Residence Inn', 1, '2019-03-22', 169, NULL),
('Residence Inn', 1, '2019-03-23', 172, NULL),
('Residence Inn', 1, '2019-03-24', 331, NULL),
('Residence Inn', 1, '2019-03-25', 179, NULL),
('Residence Inn', 1, '2019-03-26', 347, NULL),
('Residence Inn', 1, '2019-03-27', 361, NULL),
('Residence Inn', 1, '2019-03-28', 227, NULL),
('Residence Inn', 1, '2019-03-29', 180, NULL),
('Residence Inn', 1, '2019-03-30', 178, NULL),
('Residence Inn', 1, '2019-03-31', 339, NULL),
('Residence Inn', 1, '2019-04-01', 138, NULL),
('Residence Inn', 1, '2019-04-02', 155, 3),
('Residence Inn', 1, '2019-04-03', 118, 3),
('Residence Inn', 1, '2019-04-04', 245, 3),
('Residence Inn', 1, '2019-04-05', 312, 3),
('Residence Inn', 1, '2019-04-06', 130, NULL),
('Residence Inn', 1, '2019-04-07', 265, NULL),
('Residence Inn', 1, '2019-04-08', 381, NULL),
('Residence Inn', 1, '2019-04-09', 300, NULL),
('Residence Inn', 1, '2019-04-10', 344, NULL),
('Residence Inn', 1, '2019-04-11', 239, NULL),
('Residence Inn', 1, '2019-04-12', 396, 36),
('Residence Inn', 1, '2019-04-13', 376, 36),
('Residence Inn', 1, '2019-04-14', 149, 36),
('Residence Inn', 1, '2019-04-15', 392, 36),
('Residence Inn', 1, '2019-04-16', 335, 36),
('Residence Inn', 1, '2019-04-17', 210, 36),
('Residence Inn', 1, '2019-04-18', 379, 36),
('Residence Inn', 1, '2019-04-19', 136, NULL),
('Residence Inn', 1, '2019-04-20', 310, NULL),
('Residence Inn', 1, '2019-04-21', 261, NULL),
('Residence Inn', 1, '2019-04-22', 109, NULL),
('Residence Inn', 1, '2019-04-23', 368, NULL),
('Residence Inn', 1, '2019-04-24', 324, NULL),
('Residence Inn', 1, '2019-04-25', 197, NULL),
('Residence Inn', 1, '2019-04-26', 385, 119),
('Residence Inn', 1, '2019-04-27', 102, 119),
('Residence Inn', 1, '2019-04-28', 215, 119),
('Residence Inn', 1, '2019-04-29', 304, 119),
('Residence Inn', 1, '2019-04-30', 234, 119),
('Residence Inn', 1, '2019-05-01', 367, 119),
('Residence Inn', 1, '2019-05-02', 349, 119),
('Residence Inn', 1, '2019-05-03', 345, 119),
('Residence Inn', 1, '2019-05-04', 373, 119),
('Residence Inn', 1, '2019-05-05', 109, 119),
('Residence Inn', 1, '2019-05-06', 119, 119),
('Residence Inn', 1, '2019-05-07', 287, 119),
('Residence Inn', 1, '2019-05-08', 278, 119),
('Residence Inn', 1, '2019-05-09', 177, 119),
('Residence Inn', 1, '2019-05-10', 212, 119),
('Residence Inn', 1, '2019-05-11', 396, 119),
('Residence Inn', 1, '2019-05-12', 270, 119),
('Residence Inn', 1, '2019-05-13', 197, 119),
('Residence Inn', 1, '2019-05-14', 222, 119),
('Residence Inn', 1, '2019-05-15', 296, 119),
('Residence Inn', 1, '2019-05-16', 393, 119),
('Residence Inn', 1, '2019-05-17', 283, 119),
('Residence Inn', 1, '2019-05-18', 387, 119),
('Residence Inn', 1, '2019-05-19', 268, 119),
('Residence Inn', 1, '2019-05-20', 198, 119),
('Residence Inn', 1, '2019-05-21', 217, NULL),
('Residence Inn', 1, '2019-05-22', 162, NULL),
('Residence Inn', 1, '2019-05-23', 295, NULL),
('Residence Inn', 1, '2019-05-24', 388, NULL),
('Residence Inn', 1, '2019-05-25', 386, NULL),
('Residence Inn', 1, '2019-05-26', 183, NULL),
('Residence Inn', 1, '2019-05-27', 187, NULL),
('Residence Inn', 1, '2019-05-28', 195, NULL),
('Residence Inn', 1, '2019-05-29', 371, NULL),
('Residence Inn', 1, '2019-05-30', 201, NULL),
('Residence Inn', 1, '2019-05-31', 170, NULL),
('Residence Inn', 1, '2019-06-01', 113, NULL),
('Residence Inn', 1, '2019-06-02', 379, NULL),
('Residence Inn', 1, '2019-06-03', 220, NULL),
('Residence Inn', 1, '2019-06-04', 163, NULL),
('Residence Inn', 1, '2019-06-05', 303, NULL),
('Residence Inn', 1, '2019-06-06', 247, NULL),
('Residence Inn', 1, '2019-06-07', 155, NULL),
('Residence Inn', 1, '2019-06-08', 258, NULL),
('Residence Inn', 1, '2019-06-09', 284, NULL),
('Residence Inn', 1, '2019-06-10', 336, NULL),
('Residence Inn', 1, '2019-06-11', 281, NULL),
('Residence Inn', 1, '2019-06-12', 144, NULL),
('Residence Inn', 1, '2019-06-13', 191, NULL),
('Residence Inn', 1, '2019-06-14', 318, NULL),
('Residence Inn', 1, '2019-06-15', 190, NULL),
('Residence Inn', 1, '2019-06-16', 257, NULL),
('Residence Inn', 1, '2019-06-17', 326, NULL),
('Residence Inn', 1, '2019-06-18', 290, NULL),
('Residence Inn', 1, '2019-06-19', 288, NULL),
('Residence Inn', 1, '2019-06-20', 356, NULL),
('Residence Inn', 1, '2019-06-21', 142, NULL),
('Residence Inn', 1, '2019-06-22', 363, NULL),
('Residence Inn', 1, '2019-06-23', 296, NULL),
('Residence Inn', 1, '2019-06-24', 206, NULL),
('Residence Inn', 1, '2019-06-25', 135, NULL),
('Residence Inn', 1, '2019-06-26', 384, NULL),
('Residence Inn', 1, '2019-06-27', 375, NULL),
('Residence Inn', 1, '2019-06-28', 339, NULL),
('Residence Inn', 1, '2019-06-29', 312, NULL),
('Residence Inn', 1, '2019-06-30', 180, NULL),
('Residence Inn', 1, '2019-07-01', 398, NULL),
('Residence Inn', 1, '2019-07-02', 123, NULL),
('Residence Inn', 1, '2019-07-03', 114, NULL),
('Residence Inn', 1, '2019-07-04', 269, NULL),
('Residence Inn', 1, '2019-07-05', 277, NULL),
('Residence Inn', 1, '2019-07-06', 267, NULL),
('Residence Inn', 1, '2019-07-07', 270, NULL),
('Residence Inn', 1, '2019-07-08', 281, NULL),
('Residence Inn', 1, '2019-07-09', 167, NULL),
('Residence Inn', 1, '2019-07-10', 115, 28),
('Residence Inn', 1, '2019-07-11', 353, 28),
('Residence Inn', 1, '2019-07-12', 358, 28),
('Residence Inn', 1, '2019-07-13', 149, 28),
('Residence Inn', 1, '2019-07-14', 167, 28),
('Residence Inn', 1, '2019-07-15', 357, 28),
('Residence Inn', 1, '2019-07-16', 256, 28),
('Residence Inn', 1, '2019-07-17', 214, NULL),
('Residence Inn', 1, '2019-07-18', 351, NULL),
('Residence Inn', 1, '2019-07-19', 181, NULL),
('Residence Inn', 1, '2019-07-20', 263, NULL),
('Residence Inn', 1, '2019-07-21', 306, NULL),
('Residence Inn', 1, '2019-07-22', 233, NULL),
('Residence Inn', 1, '2019-07-23', 267, NULL),
('Residence Inn', 1, '2019-07-24', 202, NULL),
('Residence Inn', 1, '2019-07-25', 127, NULL),
('Residence Inn', 1, '2019-07-26', 247, 184),
('Residence Inn', 1, '2019-07-27', 380, 184),
('Residence Inn', 1, '2019-07-28', 153, 184),
('Residence Inn', 1, '2019-07-29', 286, 184),
('Residence Inn', 1, '2019-07-30', 374, 184),
('Residence Inn', 1, '2019-07-31', 139, 184),
('Residence Inn', 1, '2019-08-01', 246, 184),
('Residence Inn', 1, '2019-08-02', 118, 184),
('Residence Inn', 1, '2019-08-03', 165, 184),
('Residence Inn', 1, '2019-08-04', 189, 184),
('Residence Inn', 1, '2019-08-05', 104, 184),
('Residence Inn', 1, '2019-08-06', 345, 184),
('Residence Inn', 1, '2019-08-07', 208, 184),
('Residence Inn', 1, '2019-08-08', 177, 184),
('Residence Inn', 1, '2019-08-09', 313, 184),
('Residence Inn', 1, '2019-08-10', 222, 184),
('Residence Inn', 1, '2019-08-11', 397, 184),
('Residence Inn', 1, '2019-08-12', 311, 184),
('Residence Inn', 1, '2019-08-13', 203, NULL),
('Residence Inn', 1, '2019-08-14', 293, NULL),
('Residence Inn', 1, '2019-08-15', 109, NULL),
('Residence Inn', 1, '2019-08-16', 109, NULL),
('Residence Inn', 1, '2019-08-17', 317, NULL),
('Residence Inn', 1, '2019-08-18', 184, NULL),
('Residence Inn', 1, '2019-08-19', 329, NULL),
('Residence Inn', 1, '2019-08-20', 294, 16),
('Residence Inn', 1, '2019-08-21', 129, 16),
('Residence Inn', 1, '2019-08-22', 177, 16),
('Residence Inn', 1, '2019-08-23', 182, 16),
('Residence Inn', 1, '2019-08-24', 297, 16),
('Residence Inn', 1, '2019-08-25', 107, 16),
('Residence Inn', 1, '2019-08-26', 363, 16),
('Residence Inn', 1, '2019-08-27', 337, 16),
('Residence Inn', 1, '2019-08-28', 368, 16),
('Residence Inn', 1, '2019-08-29', 237, 16),
('Residence Inn', 1, '2019-08-30', 357, 16),
('Residence Inn', 1, '2019-08-31', 294, 16),
('Residence Inn', 1, '2019-09-01', 211, 16),
('Residence Inn', 1, '2019-09-02', 244, 16),
('Residence Inn', 1, '2019-09-03', 221, 16),
('Residence Inn', 1, '2019-09-04', 322, 16),
('Residence Inn', 1, '2019-09-05', 369, NULL),
('Residence Inn', 1, '2019-09-06', 185, NULL),
('Residence Inn', 1, '2019-09-07', 308, NULL),
('Residence Inn', 1, '2019-09-08', 113, NULL),
('Residence Inn', 1, '2019-09-09', 312, NULL),
('Residence Inn', 1, '2019-09-10', 113, NULL),
('Residence Inn', 1, '2019-09-11', 327, NULL),
('Residence Inn', 1, '2019-09-12', 197, NULL),
('Residence Inn', 1, '2019-09-13', 214, NULL),
('Residence Inn', 1, '2019-09-14', 262, NULL),
('Residence Inn', 1, '2019-09-15', 308, NULL),
('Residence Inn', 1, '2019-09-16', 266, NULL),
('Residence Inn', 1, '2019-09-17', 395, NULL),
('Residence Inn', 1, '2019-09-18', 363, NULL),
('Residence Inn', 1, '2019-09-19', 389, NULL),
('Residence Inn', 1, '2019-09-20', 365, NULL),
('Residence Inn', 1, '2019-09-21', 119, NULL),
('Residence Inn', 1, '2019-09-22', 309, NULL),
('Residence Inn', 1, '2019-09-23', 172, NULL),
('Residence Inn', 1, '2019-09-24', 249, NULL),
('Residence Inn', 1, '2019-09-25', 181, NULL),
('Residence Inn', 1, '2019-09-26', 388, NULL),
('Residence Inn', 1, '2019-09-27', 217, NULL),
('Residence Inn', 1, '2019-09-28', 359, NULL),
('Residence Inn', 1, '2019-09-29', 141, NULL),
('Residence Inn', 1, '2019-09-30', 236, NULL),
('Residence Inn', 1, '2019-10-01', 152, NULL),
('Residence Inn', 1, '2019-10-02', 316, NULL),
('Residence Inn', 1, '2019-10-03', 313, NULL),
('Residence Inn', 1, '2019-10-04', 111, NULL),
('Residence Inn', 1, '2019-10-05', 362, NULL),
('Residence Inn', 1, '2019-10-06', 281, NULL),
('Residence Inn', 1, '2019-10-07', 172, NULL),
('Residence Inn', 1, '2019-10-08', 151, NULL),
('Residence Inn', 1, '2019-10-09', 357, NULL),
('Residence Inn', 1, '2019-10-10', 115, NULL),
('Residence Inn', 1, '2019-10-11', 166, NULL),
('Residence Inn', 1, '2019-10-12', 385, NULL),
('Residence Inn', 1, '2019-10-13', 348, NULL),
('Residence Inn', 1, '2019-10-14', 109, NULL),
('Residence Inn', 1, '2019-10-15', 306, NULL),
('Residence Inn', 1, '2019-10-16', 328, NULL),
('Residence Inn', 1, '2019-10-17', 218, NULL),
('Residence Inn', 1, '2019-10-18', 100, NULL),
('Residence Inn', 1, '2019-10-19', 388, NULL),
('Residence Inn', 1, '2019-10-20', 194, NULL),
('Residence Inn', 1, '2019-10-21', 340, NULL),
('Residence Inn', 1, '2019-10-22', 257, NULL),
('Residence Inn', 1, '2019-10-23', 282, NULL),
('Residence Inn', 1, '2019-10-24', 355, NULL),
('Residence Inn', 1, '2019-10-25', 167, NULL),
('Residence Inn', 1, '2019-10-26', 217, NULL),
('Residence Inn', 1, '2019-10-27', 315, NULL),
('Residence Inn', 1, '2019-10-28', 103, NULL),
('Residence Inn', 1, '2019-10-29', 370, NULL),
('Residence Inn', 1, '2019-10-30', 266, NULL),
('Residence Inn', 1, '2019-10-31', 386, NULL),
('Residence Inn', 1, '2019-11-01', 211, NULL),
('Residence Inn', 1, '2019-11-02', 126, NULL),
('Residence Inn', 1, '2019-11-03', 394, NULL),
('Residence Inn', 1, '2019-11-04', 381, NULL),
('Residence Inn', 1, '2019-11-05', 239, NULL),
('Residence Inn', 1, '2019-11-06', 300, NULL),
('Residence Inn', 1, '2019-11-07', 320, NULL),
('Residence Inn', 1, '2019-11-08', 113, NULL),
('Residence Inn', 1, '2019-11-09', 245, NULL),
('Residence Inn', 1, '2019-11-10', 255, NULL),
('Residence Inn', 1, '2019-11-11', 157, NULL),
('Residence Inn', 1, '2019-11-12', 174, NULL),
('Residence Inn', 1, '2019-11-13', 308, NULL),
('Residence Inn', 1, '2019-11-14', 229, NULL),
('Residence Inn', 1, '2019-11-15', 318, NULL),
('Residence Inn', 1, '2019-11-16', 325, NULL),
('Residence Inn', 1, '2019-11-17', 285, NULL),
('Residence Inn', 1, '2019-11-18', 237, NULL),
('Residence Inn', 1, '2019-11-19', 393, NULL),
('Residence Inn', 1, '2019-11-20', 318, NULL),
('Residence Inn', 1, '2019-11-21', 195, NULL),
('Residence Inn', 1, '2019-11-22', 321, NULL),
('Residence Inn', 1, '2019-11-23', 100, NULL),
('Residence Inn', 1, '2019-11-24', 187, NULL),
('Residence Inn', 1, '2019-11-25', 199, NULL),
('Residence Inn', 1, '2019-11-26', 341, NULL),
('Residence Inn', 1, '2019-11-27', 279, NULL),
('Residence Inn', 1, '2019-11-28', 246, NULL),
('Residence Inn', 1, '2019-11-29', 171, NULL),
('Residence Inn', 1, '2019-11-30', 254, NULL),
('Residence Inn', 1, '2019-12-01', 218, NULL),
('Residence Inn', 1, '2019-12-02', 294, NULL),
('Residence Inn', 1, '2019-12-03', 162, NULL),
('Residence Inn', 1, '2019-12-04', 253, NULL),
('Residence Inn', 1, '2019-12-05', 126, NULL),
('Residence Inn', 1, '2019-12-06', 296, NULL),
('Residence Inn', 1, '2019-12-07', 167, NULL),
('Residence Inn', 1, '2019-12-08', 137, NULL),
('Residence Inn', 1, '2019-12-09', 260, NULL),
('Residence Inn', 1, '2019-12-10', 160, NULL),
('Residence Inn', 1, '2019-12-11', 394, NULL),
('Residence Inn', 1, '2019-12-12', 340, NULL),
('Residence Inn', 1, '2019-12-13', 142, NULL),
('Residence Inn', 1, '2019-12-14', 249, NULL),
('Residence Inn', 1, '2019-12-15', 149, NULL),
('Residence Inn', 1, '2019-12-16', 363, NULL),
('Residence Inn', 1, '2019-12-17', 289, NULL),
('Residence Inn', 1, '2019-12-18', 145, NULL),
('Residence Inn', 1, '2019-12-19', 258, NULL),
('Residence Inn', 1, '2019-12-20', 145, NULL),
('Residence Inn', 1, '2019-12-21', 361, NULL),
('Residence Inn', 1, '2019-12-22', 360, NULL),
('Residence Inn', 1, '2019-12-23', 330, NULL),
('Residence Inn', 1, '2019-12-24', 335, NULL),
('Residence Inn', 1, '2019-12-25', 393, NULL),
('Residence Inn', 1, '2019-12-26', 388, NULL),
('Residence Inn', 1, '2019-12-27', 282, NULL),
('Residence Inn', 1, '2019-12-28', 192, NULL),
('Residence Inn', 1, '2019-12-29', 301, NULL),
('Residence Inn', 1, '2019-12-30', 249, NULL),
('Residence Inn', 1, '2019-12-31', 108, NULL),
('Residence Inn', 1, '2020-01-01', 281, NULL),
('Residence Inn', 1, '2020-01-02', 226, NULL),
('Residence Inn', 1, '2020-01-03', 263, NULL),
('Residence Inn', 1, '2020-01-04', 211, NULL),
('Residence Inn', 1, '2020-01-05', 325, NULL),
('Residence Inn', 1, '2020-01-06', 167, NULL),
('Residence Inn', 1, '2020-01-07', 158, NULL),
('Residence Inn', 1, '2020-01-08', 162, NULL),
('Residence Inn', 1, '2020-01-09', 258, NULL),
('Residence Inn', 1, '2020-01-10', 332, NULL),
('Residence Inn', 1, '2020-01-11', 330, NULL),
('Residence Inn', 1, '2020-01-12', 128, NULL),
('Residence Inn', 1, '2020-01-13', 147, NULL),
('Residence Inn', 1, '2020-01-14', 336, NULL),
('Residence Inn', 1, '2020-01-15', 321, NULL),
('Residence Inn', 1, '2020-01-16', 350, NULL),
('Residence Inn', 1, '2020-01-17', 143, NULL),
('Residence Inn', 1, '2020-01-18', 256, NULL),
('Residence Inn', 1, '2020-01-19', 204, NULL),
('Residence Inn', 1, '2020-01-20', 383, NULL),
('Residence Inn', 1, '2020-01-21', 231, NULL),
('Residence Inn', 1, '2020-01-22', 147, NULL),
('Residence Inn', 1, '2020-01-23', 140, NULL),
('Residence Inn', 1, '2020-01-24', 156, NULL),
('Residence Inn', 1, '2020-01-25', 288, NULL),
('Residence Inn', 1, '2020-01-26', 121, NULL),
('Residence Inn', 1, '2020-01-27', 146, NULL),
('Residence Inn', 1, '2020-01-28', 110, NULL),
('Residence Inn', 1, '2020-01-29', 333, NULL),
('Residence Inn', 1, '2020-01-30', 183, NULL),
('Residence Inn', 1, '2020-01-31', 350, NULL),
('Residence Inn', 1, '2020-02-01', 115, NULL),
('Residence Inn', 1, '2020-02-02', 254, NULL),
('Residence Inn', 1, '2020-02-03', 176, NULL),
('Residence Inn', 1, '2020-02-04', 364, NULL),
('Residence Inn', 31, '2019-01-01', 387, NULL),
('Residence Inn', 31, '2019-01-02', 177, NULL),
('Residence Inn', 31, '2019-01-03', 262, NULL),
('Residence Inn', 31, '2019-01-04', 253, NULL),
('Residence Inn', 31, '2019-01-05', 180, NULL),
('Residence Inn', 31, '2019-01-06', 355, NULL),
('Residence Inn', 31, '2019-01-07', 383, NULL),
('Residence Inn', 31, '2019-01-08', 280, NULL),
('Residence Inn', 31, '2019-01-09', 232, NULL),
('Residence Inn', 31, '2019-01-10', 350, NULL),
('Residence Inn', 31, '2019-01-11', 134, NULL),
('Residence Inn', 31, '2019-01-12', 276, NULL),
('Residence Inn', 31, '2019-01-13', 147, NULL),
('Residence Inn', 31, '2019-01-14', 207, NULL),
('Residence Inn', 31, '2019-01-15', 385, NULL),
('Residence Inn', 31, '2019-01-16', 211, NULL),
('Residence Inn', 31, '2019-01-17', 147, NULL),
('Residence Inn', 31, '2019-01-18', 339, NULL),
('Residence Inn', 31, '2019-01-19', 259, NULL),
('Residence Inn', 31, '2019-01-20', 397, NULL),
('Residence Inn', 31, '2019-01-21', 154, NULL),
('Residence Inn', 31, '2019-01-22', 397, NULL),
('Residence Inn', 31, '2019-01-23', 175, NULL),
('Residence Inn', 31, '2019-01-24', 299, NULL),
('Residence Inn', 31, '2019-01-25', 294, NULL),
('Residence Inn', 31, '2019-01-26', 116, NULL),
('Residence Inn', 31, '2019-01-27', 150, NULL),
('Residence Inn', 31, '2019-01-28', 365, NULL),
('Residence Inn', 31, '2019-01-29', 217, NULL),
('Residence Inn', 31, '2019-01-30', 245, NULL),
('Residence Inn', 31, '2019-01-31', 287, NULL),
('Residence Inn', 31, '2019-02-01', 176, NULL),
('Residence Inn', 31, '2019-02-02', 399, NULL),
('Residence Inn', 31, '2019-02-03', 103, NULL),
('Residence Inn', 31, '2019-02-04', 142, NULL),
('Residence Inn', 31, '2019-02-05', 185, NULL),
('Residence Inn', 31, '2019-02-06', 172, NULL),
('Residence Inn', 31, '2019-02-07', 375, NULL),
('Residence Inn', 31, '2019-02-08', 199, NULL),
('Residence Inn', 31, '2019-02-09', 275, NULL),
('Residence Inn', 31, '2019-02-10', 278, NULL),
('Residence Inn', 31, '2019-02-11', 364, NULL),
('Residence Inn', 31, '2019-02-12', 265, NULL),
('Residence Inn', 31, '2019-02-13', 217, NULL),
('Residence Inn', 31, '2019-02-14', 151, NULL),
('Residence Inn', 31, '2019-02-15', 246, NULL),
('Residence Inn', 31, '2019-02-16', 200, NULL),
('Residence Inn', 31, '2019-02-17', 279, NULL),
('Residence Inn', 31, '2019-02-18', 245, NULL),
('Residence Inn', 31, '2019-02-19', 201, NULL),
('Residence Inn', 31, '2019-02-20', 247, NULL),
('Residence Inn', 31, '2019-02-21', 245, NULL),
('Residence Inn', 31, '2019-02-22', 204, NULL),
('Residence Inn', 31, '2019-02-23', 118, NULL),
('Residence Inn', 31, '2019-02-24', 229, NULL),
('Residence Inn', 31, '2019-02-25', 235, NULL),
('Residence Inn', 31, '2019-02-26', 339, NULL),
('Residence Inn', 31, '2019-02-27', 247, NULL),
('Residence Inn', 31, '2019-02-28', 121, NULL),
('Residence Inn', 31, '2019-03-01', 347, NULL),
('Residence Inn', 31, '2019-03-02', 165, NULL),
('Residence Inn', 31, '2019-03-03', 273, NULL),
('Residence Inn', 31, '2019-03-04', 369, NULL),
('Residence Inn', 31, '2019-03-05', 379, NULL),
('Residence Inn', 31, '2019-03-06', 165, NULL),
('Residence Inn', 31, '2019-03-07', 377, 173),
('Residence Inn', 31, '2019-03-08', 350, 173),
('Residence Inn', 31, '2019-03-09', 255, 173),
('Residence Inn', 31, '2019-03-10', 347, 173),
('Residence Inn', 31, '2019-03-11', 315, 173),
('Residence Inn', 31, '2019-03-12', 334, 173),
('Residence Inn', 31, '2019-03-13', 247, 173),
('Residence Inn', 31, '2019-03-14', 107, 173),
('Residence Inn', 31, '2019-03-15', 231, 173),
('Residence Inn', 31, '2019-03-16', 348, 173),
('Residence Inn', 31, '2019-03-17', 143, 173),
('Residence Inn', 31, '2019-03-18', 232, 173),
('Residence Inn', 31, '2019-03-19', 271, 173),
('Residence Inn', 31, '2019-03-20', 115, 173),
('Residence Inn', 31, '2019-03-21', 199, 173),
('Residence Inn', 31, '2019-03-22', 343, 173),
('Residence Inn', 31, '2019-03-23', 318, 173),
('Residence Inn', 31, '2019-03-24', 134, 173),
('Residence Inn', 31, '2019-03-25', 224, 173),
('Residence Inn', 31, '2019-03-26', 233, 173),
('Residence Inn', 31, '2019-03-27', 375, 173),
('Residence Inn', 31, '2019-03-28', 178, 173),
('Residence Inn', 31, '2019-03-29', 171, 173),
('Residence Inn', 31, '2019-03-30', 387, 173),
('Residence Inn', 31, '2019-03-31', 353, 173),
('Residence Inn', 31, '2019-04-01', 112, 173),
('Residence Inn', 31, '2019-04-02', 257, 173),
('Residence Inn', 31, '2019-04-03', 228, NULL),
('Residence Inn', 31, '2019-04-04', 295, NULL),
('Residence Inn', 31, '2019-04-05', 271, NULL),
('Residence Inn', 31, '2019-04-06', 113, NULL),
('Residence Inn', 31, '2019-04-07', 363, NULL),
('Residence Inn', 31, '2019-04-08', 237, NULL),
('Residence Inn', 31, '2019-04-09', 180, NULL),
('Residence Inn', 31, '2019-04-10', 222, NULL),
('Residence Inn', 31, '2019-04-11', 209, NULL),
('Residence Inn', 31, '2019-04-12', 382, NULL),
('Residence Inn', 31, '2019-04-13', 101, NULL),
('Residence Inn', 31, '2019-04-14', 340, NULL),
('Residence Inn', 31, '2019-04-15', 305, NULL),
('Residence Inn', 31, '2019-04-16', 165, 113),
('Residence Inn', 31, '2019-04-17', 143, 113),
('Residence Inn', 31, '2019-04-18', 385, 113),
('Residence Inn', 31, '2019-04-19', 319, 113),
('Residence Inn', 31, '2019-04-20', 123, 113),
('Residence Inn', 31, '2019-04-21', 361, 113),
('Residence Inn', 31, '2019-04-22', 309, 113),
('Residence Inn', 31, '2019-04-23', 289, 113),
('Residence Inn', 31, '2019-04-24', 352, NULL),
('Residence Inn', 31, '2019-04-25', 279, NULL),
('Residence Inn', 31, '2019-04-26', 392, NULL),
('Residence Inn', 31, '2019-04-27', 162, NULL),
('Residence Inn', 31, '2019-04-28', 157, NULL),
('Residence Inn', 31, '2019-04-29', 387, NULL),
('Residence Inn', 31, '2019-04-30', 194, NULL),
('Residence Inn', 31, '2019-05-01', 236, NULL),
('Residence Inn', 31, '2019-05-02', 305, NULL),
('Residence Inn', 31, '2019-05-03', 293, NULL),
('Residence Inn', 31, '2019-05-04', 162, NULL),
('Residence Inn', 31, '2019-05-05', 340, NULL),
('Residence Inn', 31, '2019-05-06', 366, NULL),
('Residence Inn', 31, '2019-05-07', 168, NULL),
('Residence Inn', 31, '2019-05-08', 267, NULL),
('Residence Inn', 31, '2019-05-09', 395, NULL),
('Residence Inn', 31, '2019-05-10', 229, NULL),
('Residence Inn', 31, '2019-05-11', 366, NULL),
('Residence Inn', 31, '2019-05-12', 294, NULL),
('Residence Inn', 31, '2019-05-13', 293, NULL),
('Residence Inn', 31, '2019-05-14', 379, NULL),
('Residence Inn', 31, '2019-05-15', 295, NULL),
('Residence Inn', 31, '2019-05-16', 179, NULL),
('Residence Inn', 31, '2019-05-17', 335, NULL),
('Residence Inn', 31, '2019-05-18', 334, NULL),
('Residence Inn', 31, '2019-05-19', 331, NULL),
('Residence Inn', 31, '2019-05-20', 362, NULL),
('Residence Inn', 31, '2019-05-21', 272, NULL),
('Residence Inn', 31, '2019-05-22', 205, NULL),
('Residence Inn', 31, '2019-05-23', 107, NULL),
('Residence Inn', 31, '2019-05-24', 175, NULL),
('Residence Inn', 31, '2019-05-25', 310, NULL),
('Residence Inn', 31, '2019-05-26', 332, NULL),
('Residence Inn', 31, '2019-05-27', 235, NULL),
('Residence Inn', 31, '2019-05-28', 362, NULL),
('Residence Inn', 31, '2019-05-29', 352, NULL),
('Residence Inn', 31, '2019-05-30', 274, NULL),
('Residence Inn', 31, '2019-05-31', 115, NULL),
('Residence Inn', 31, '2019-06-01', 310, NULL),
('Residence Inn', 31, '2019-06-02', 231, NULL),
('Residence Inn', 31, '2019-06-03', 372, NULL),
('Residence Inn', 31, '2019-06-04', 144, NULL),
('Residence Inn', 31, '2019-06-05', 376, NULL),
('Residence Inn', 31, '2019-06-06', 320, NULL),
('Residence Inn', 31, '2019-06-07', 243, NULL),
('Residence Inn', 31, '2019-06-08', 377, NULL),
('Residence Inn', 31, '2019-06-09', 161, NULL),
('Residence Inn', 31, '2019-06-10', 238, NULL),
('Residence Inn', 31, '2019-06-11', 142, NULL),
('Residence Inn', 31, '2019-06-12', 284, NULL),
('Residence Inn', 31, '2019-06-13', 122, NULL),
('Residence Inn', 31, '2019-06-14', 304, NULL),
('Residence Inn', 31, '2019-06-15', 240, NULL),
('Residence Inn', 31, '2019-06-16', 355, NULL),
('Residence Inn', 31, '2019-06-17', 322, NULL),
('Residence Inn', 31, '2019-06-18', 138, NULL),
('Residence Inn', 31, '2019-06-19', 308, NULL),
('Residence Inn', 31, '2019-06-20', 270, NULL),
('Residence Inn', 31, '2019-06-21', 383, NULL),
('Residence Inn', 31, '2019-06-22', 132, 189),
('Residence Inn', 31, '2019-06-23', 349, 189),
('Residence Inn', 31, '2019-06-24', 374, 189),
('Residence Inn', 31, '2019-06-25', 287, 189),
('Residence Inn', 31, '2019-06-26', 208, 189),
('Residence Inn', 31, '2019-06-27', 345, 189),
('Residence Inn', 31, '2019-06-28', 375, 189),
('Residence Inn', 31, '2019-06-29', 104, 189),
('Residence Inn', 31, '2019-06-30', 343, 189),
('Residence Inn', 31, '2019-07-01', 106, 189),
('Residence Inn', 31, '2019-07-02', 129, 189),
('Residence Inn', 31, '2019-07-03', 288, 189),
('Residence Inn', 31, '2019-07-04', 388, 189),
('Residence Inn', 31, '2019-07-05', 210, 189),
('Residence Inn', 31, '2019-07-06', 390, 189),
('Residence Inn', 31, '2019-07-07', 146, 189),
('Residence Inn', 31, '2019-07-08', 324, 189),
('Residence Inn', 31, '2019-07-09', 173, 189),
('Residence Inn', 31, '2019-07-10', 101, 189),
('Residence Inn', 31, '2019-07-11', 162, NULL),
('Residence Inn', 31, '2019-07-12', 266, NULL),
('Residence Inn', 31, '2019-07-13', 128, NULL),
('Residence Inn', 31, '2019-07-14', 247, NULL),
('Residence Inn', 31, '2019-07-15', 199, NULL),
('Residence Inn', 31, '2019-07-16', 346, 73),
('Residence Inn', 31, '2019-07-17', 146, 73),
('Residence Inn', 31, '2019-07-18', 393, 73),
('Residence Inn', 31, '2019-07-19', 246, 73),
('Residence Inn', 31, '2019-07-20', 319, 73),
('Residence Inn', 31, '2019-07-21', 310, 73),
('Residence Inn', 31, '2019-07-22', 363, 73),
('Residence Inn', 31, '2019-07-23', 306, 73),
('Residence Inn', 31, '2019-07-24', 369, 73),
('Residence Inn', 31, '2019-07-25', 178, 73),
('Residence Inn', 31, '2019-07-26', 266, 73),
('Residence Inn', 31, '2019-07-27', 320, 73),
('Residence Inn', 31, '2019-07-28', 399, 73),
('Residence Inn', 31, '2019-07-29', 215, 73),
('Residence Inn', 31, '2019-07-30', 167, NULL),
('Residence Inn', 31, '2019-07-31', 384, NULL),
('Residence Inn', 31, '2019-08-01', 352, NULL),
('Residence Inn', 31, '2019-08-02', 383, NULL),
('Residence Inn', 31, '2019-08-03', 156, NULL),
('Residence Inn', 31, '2019-08-04', 382, NULL),
('Residence Inn', 31, '2019-08-05', 367, NULL),
('Residence Inn', 31, '2019-08-06', 227, NULL),
('Residence Inn', 31, '2019-08-07', 234, NULL),
('Residence Inn', 31, '2019-08-08', 209, NULL),
('Residence Inn', 31, '2019-08-09', 383, NULL),
('Residence Inn', 31, '2019-08-10', 173, NULL),
('Residence Inn', 31, '2019-08-11', 257, NULL),
('Residence Inn', 31, '2019-08-12', 348, NULL),
('Residence Inn', 31, '2019-08-13', 208, NULL),
('Residence Inn', 31, '2019-08-14', 249, NULL),
('Residence Inn', 31, '2019-08-15', 298, NULL),
('Residence Inn', 31, '2019-08-16', 317, NULL),
('Residence Inn', 31, '2019-08-17', 390, NULL),
('Residence Inn', 31, '2019-08-18', 226, NULL),
('Residence Inn', 31, '2019-08-19', 378, NULL),
('Residence Inn', 31, '2019-08-20', 399, NULL),
('Residence Inn', 31, '2019-08-21', 155, NULL),
('Residence Inn', 31, '2019-08-22', 379, NULL),
('Residence Inn', 31, '2019-08-23', 287, NULL),
('Residence Inn', 31, '2019-08-24', 272, NULL),
('Residence Inn', 31, '2019-08-25', 360, NULL),
('Residence Inn', 31, '2019-08-26', 119, NULL),
('Residence Inn', 31, '2019-08-27', 353, NULL),
('Residence Inn', 31, '2019-08-28', 100, NULL),
('Residence Inn', 31, '2019-08-29', 183, NULL),
('Residence Inn', 31, '2019-08-30', 267, NULL),
('Residence Inn', 31, '2019-08-31', 231, NULL),
('Residence Inn', 31, '2019-09-01', 244, NULL),
('Residence Inn', 31, '2019-09-02', 208, NULL),
('Residence Inn', 31, '2019-09-03', 304, NULL),
('Residence Inn', 31, '2019-09-04', 276, NULL),
('Residence Inn', 31, '2019-09-05', 152, NULL),
('Residence Inn', 31, '2019-09-06', 335, NULL),
('Residence Inn', 31, '2019-09-07', 373, NULL),
('Residence Inn', 31, '2019-09-08', 364, NULL),
('Residence Inn', 31, '2019-09-09', 137, NULL),
('Residence Inn', 31, '2019-09-10', 302, NULL),
('Residence Inn', 31, '2019-09-11', 136, NULL),
('Residence Inn', 31, '2019-09-12', 203, NULL),
('Residence Inn', 31, '2019-09-13', 275, NULL),
('Residence Inn', 31, '2019-09-14', 206, NULL),
('Residence Inn', 31, '2019-09-15', 387, NULL),
('Residence Inn', 31, '2019-09-16', 148, NULL),
('Residence Inn', 31, '2019-09-17', 312, NULL),
('Residence Inn', 31, '2019-09-18', 371, NULL),
('Residence Inn', 31, '2019-09-19', 331, NULL),
('Residence Inn', 31, '2019-09-20', 180, NULL),
('Residence Inn', 31, '2019-09-21', 228, NULL),
('Residence Inn', 31, '2019-09-22', 171, NULL),
('Residence Inn', 31, '2019-09-23', 345, NULL),
('Residence Inn', 31, '2019-09-24', 329, NULL),
('Residence Inn', 31, '2019-09-25', 208, NULL),
('Residence Inn', 31, '2019-09-26', 194, NULL),
('Residence Inn', 31, '2019-09-27', 338, NULL),
('Residence Inn', 31, '2019-09-28', 268, NULL),
('Residence Inn', 31, '2019-09-29', 384, NULL),
('Residence Inn', 31, '2019-09-30', 139, NULL),
('Residence Inn', 31, '2019-10-01', 393, NULL),
('Residence Inn', 31, '2019-10-02', 310, NULL),
('Residence Inn', 31, '2019-10-03', 290, NULL),
('Residence Inn', 31, '2019-10-04', 299, NULL),
('Residence Inn', 31, '2019-10-05', 182, NULL),
('Residence Inn', 31, '2019-10-06', 313, NULL),
('Residence Inn', 31, '2019-10-07', 122, NULL),
('Residence Inn', 31, '2019-10-08', 393, NULL),
('Residence Inn', 31, '2019-10-09', 299, NULL),
('Residence Inn', 31, '2019-10-10', 347, NULL),
('Residence Inn', 31, '2019-10-11', 106, NULL),
('Residence Inn', 31, '2019-10-12', 124, NULL),
('Residence Inn', 31, '2019-10-13', 152, NULL),
('Residence Inn', 31, '2019-10-14', 298, NULL),
('Residence Inn', 31, '2019-10-15', 330, NULL),
('Residence Inn', 31, '2019-10-16', 288, NULL),
('Residence Inn', 31, '2019-10-17', 262, NULL),
('Residence Inn', 31, '2019-10-18', 359, NULL),
('Residence Inn', 31, '2019-10-19', 292, NULL),
('Residence Inn', 31, '2019-10-20', 374, NULL),
('Residence Inn', 31, '2019-10-21', 127, NULL),
('Residence Inn', 31, '2019-10-22', 361, NULL),
('Residence Inn', 31, '2019-10-23', 334, NULL),
('Residence Inn', 31, '2019-10-24', 348, NULL),
('Residence Inn', 31, '2019-10-25', 216, NULL),
('Residence Inn', 31, '2019-10-26', 300, NULL),
('Residence Inn', 31, '2019-10-27', 249, NULL),
('Residence Inn', 31, '2019-10-28', 232, NULL),
('Residence Inn', 31, '2019-10-29', 183, NULL),
('Residence Inn', 31, '2019-10-30', 165, NULL),
('Residence Inn', 31, '2019-10-31', 153, NULL),
('Residence Inn', 31, '2019-11-01', 207, NULL),
('Residence Inn', 31, '2019-11-02', 351, NULL),
('Residence Inn', 31, '2019-11-03', 165, NULL),
('Residence Inn', 31, '2019-11-04', 220, NULL),
('Residence Inn', 31, '2019-11-05', 333, NULL),
('Residence Inn', 31, '2019-11-06', 307, NULL),
('Residence Inn', 31, '2019-11-07', 102, NULL),
('Residence Inn', 31, '2019-11-08', 366, NULL),
('Residence Inn', 31, '2019-11-09', 345, NULL),
('Residence Inn', 31, '2019-11-10', 214, NULL),
('Residence Inn', 31, '2019-11-11', 128, NULL),
('Residence Inn', 31, '2019-11-12', 349, NULL),
('Residence Inn', 31, '2019-11-13', 156, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 31, '2019-11-14', 264, NULL),
('Residence Inn', 31, '2019-11-15', 164, NULL),
('Residence Inn', 31, '2019-11-16', 357, NULL),
('Residence Inn', 31, '2019-11-17', 398, NULL),
('Residence Inn', 31, '2019-11-18', 240, NULL),
('Residence Inn', 31, '2019-11-19', 135, NULL),
('Residence Inn', 31, '2019-11-20', 330, NULL),
('Residence Inn', 31, '2019-11-21', 357, NULL),
('Residence Inn', 31, '2019-11-22', 237, NULL),
('Residence Inn', 31, '2019-11-23', 184, NULL),
('Residence Inn', 31, '2019-11-24', 205, NULL),
('Residence Inn', 31, '2019-11-25', 258, NULL),
('Residence Inn', 31, '2019-11-26', 265, NULL),
('Residence Inn', 31, '2019-11-27', 158, NULL),
('Residence Inn', 31, '2019-11-28', 227, NULL),
('Residence Inn', 31, '2019-11-29', 329, NULL),
('Residence Inn', 31, '2019-11-30', 249, NULL),
('Residence Inn', 31, '2019-12-01', 130, NULL),
('Residence Inn', 31, '2019-12-02', 338, NULL),
('Residence Inn', 31, '2019-12-03', 277, NULL),
('Residence Inn', 31, '2019-12-04', 109, NULL),
('Residence Inn', 31, '2019-12-05', 152, NULL),
('Residence Inn', 31, '2019-12-06', 112, NULL),
('Residence Inn', 31, '2019-12-07', 246, NULL),
('Residence Inn', 31, '2019-12-08', 112, NULL),
('Residence Inn', 31, '2019-12-09', 370, NULL),
('Residence Inn', 31, '2019-12-10', 114, NULL),
('Residence Inn', 31, '2019-12-11', 194, NULL),
('Residence Inn', 31, '2019-12-12', 297, NULL),
('Residence Inn', 31, '2019-12-13', 183, NULL),
('Residence Inn', 31, '2019-12-14', 362, NULL),
('Residence Inn', 31, '2019-12-15', 129, NULL),
('Residence Inn', 31, '2019-12-16', 315, NULL),
('Residence Inn', 31, '2019-12-17', 205, NULL),
('Residence Inn', 31, '2019-12-18', 356, NULL),
('Residence Inn', 31, '2019-12-19', 351, NULL),
('Residence Inn', 31, '2019-12-20', 141, NULL),
('Residence Inn', 31, '2019-12-21', 112, NULL),
('Residence Inn', 31, '2019-12-22', 138, NULL),
('Residence Inn', 31, '2019-12-23', 317, NULL),
('Residence Inn', 31, '2019-12-24', 146, NULL),
('Residence Inn', 31, '2019-12-25', 113, NULL),
('Residence Inn', 31, '2019-12-26', 280, NULL),
('Residence Inn', 31, '2019-12-27', 268, NULL),
('Residence Inn', 31, '2019-12-28', 307, NULL),
('Residence Inn', 31, '2019-12-29', 365, NULL),
('Residence Inn', 31, '2019-12-30', 362, NULL),
('Residence Inn', 31, '2019-12-31', 134, NULL),
('Residence Inn', 31, '2020-01-01', 249, NULL),
('Residence Inn', 31, '2020-01-02', 303, NULL),
('Residence Inn', 31, '2020-01-03', 382, NULL),
('Residence Inn', 31, '2020-01-04', 281, NULL),
('Residence Inn', 31, '2020-01-05', 303, NULL),
('Residence Inn', 31, '2020-01-06', 166, NULL),
('Residence Inn', 31, '2020-01-07', 253, NULL),
('Residence Inn', 31, '2020-01-08', 202, NULL),
('Residence Inn', 31, '2020-01-09', 169, NULL),
('Residence Inn', 31, '2020-01-10', 392, NULL),
('Residence Inn', 31, '2020-01-11', 279, NULL),
('Residence Inn', 31, '2020-01-12', 397, NULL),
('Residence Inn', 31, '2020-01-13', 393, NULL),
('Residence Inn', 31, '2020-01-14', 228, NULL),
('Residence Inn', 31, '2020-01-15', 344, NULL),
('Residence Inn', 31, '2020-01-16', 121, NULL),
('Residence Inn', 31, '2020-01-17', 155, NULL),
('Residence Inn', 31, '2020-01-18', 291, NULL),
('Residence Inn', 31, '2020-01-19', 378, NULL),
('Residence Inn', 31, '2020-01-20', 141, NULL),
('Residence Inn', 31, '2020-01-21', 267, NULL),
('Residence Inn', 31, '2020-01-22', 291, NULL),
('Residence Inn', 31, '2020-01-23', 371, NULL),
('Residence Inn', 31, '2020-01-24', 323, NULL),
('Residence Inn', 31, '2020-01-25', 352, NULL),
('Residence Inn', 31, '2020-01-26', 193, NULL),
('Residence Inn', 31, '2020-01-27', 303, NULL),
('Residence Inn', 31, '2020-01-28', 342, NULL),
('Residence Inn', 31, '2020-01-29', 145, NULL),
('Residence Inn', 31, '2020-01-30', 340, NULL),
('Residence Inn', 31, '2020-01-31', 273, NULL),
('Residence Inn', 31, '2020-02-01', 389, NULL),
('Residence Inn', 31, '2020-02-02', 397, NULL),
('Residence Inn', 31, '2020-02-03', 239, NULL),
('Residence Inn', 31, '2020-02-04', 343, NULL),
('Residence Inn', 39, '2019-01-01', 343, NULL),
('Residence Inn', 39, '2019-01-02', 277, NULL),
('Residence Inn', 39, '2019-01-03', 219, NULL),
('Residence Inn', 39, '2019-01-04', 363, NULL),
('Residence Inn', 39, '2019-01-05', 235, NULL),
('Residence Inn', 39, '2019-01-06', 339, NULL),
('Residence Inn', 39, '2019-01-07', 376, NULL),
('Residence Inn', 39, '2019-01-08', 207, NULL),
('Residence Inn', 39, '2019-01-09', 203, NULL),
('Residence Inn', 39, '2019-01-10', 380, NULL),
('Residence Inn', 39, '2019-01-11', 186, NULL),
('Residence Inn', 39, '2019-01-12', 327, NULL),
('Residence Inn', 39, '2019-01-13', 383, NULL),
('Residence Inn', 39, '2019-01-14', 182, NULL),
('Residence Inn', 39, '2019-01-15', 289, NULL),
('Residence Inn', 39, '2019-01-16', 281, NULL),
('Residence Inn', 39, '2019-01-17', 272, NULL),
('Residence Inn', 39, '2019-01-18', 328, NULL),
('Residence Inn', 39, '2019-01-19', 180, NULL),
('Residence Inn', 39, '2019-01-20', 358, NULL),
('Residence Inn', 39, '2019-01-21', 288, NULL),
('Residence Inn', 39, '2019-01-22', 199, NULL),
('Residence Inn', 39, '2019-01-23', 243, NULL),
('Residence Inn', 39, '2019-01-24', 301, NULL),
('Residence Inn', 39, '2019-01-25', 339, NULL),
('Residence Inn', 39, '2019-01-26', 274, NULL),
('Residence Inn', 39, '2019-01-27', 269, NULL),
('Residence Inn', 39, '2019-01-28', 371, NULL),
('Residence Inn', 39, '2019-01-29', 358, NULL),
('Residence Inn', 39, '2019-01-30', 134, NULL),
('Residence Inn', 39, '2019-01-31', 140, NULL),
('Residence Inn', 39, '2019-02-01', 326, NULL),
('Residence Inn', 39, '2019-02-02', 211, NULL),
('Residence Inn', 39, '2019-02-03', 226, NULL),
('Residence Inn', 39, '2019-02-04', 202, NULL),
('Residence Inn', 39, '2019-02-05', 119, NULL),
('Residence Inn', 39, '2019-02-06', 338, NULL),
('Residence Inn', 39, '2019-02-07', 106, NULL),
('Residence Inn', 39, '2019-02-08', 360, NULL),
('Residence Inn', 39, '2019-02-09', 323, NULL),
('Residence Inn', 39, '2019-02-10', 180, NULL),
('Residence Inn', 39, '2019-02-11', 341, NULL),
('Residence Inn', 39, '2019-02-12', 394, NULL),
('Residence Inn', 39, '2019-02-13', 160, NULL),
('Residence Inn', 39, '2019-02-14', 213, NULL),
('Residence Inn', 39, '2019-02-15', 240, NULL),
('Residence Inn', 39, '2019-02-16', 242, NULL),
('Residence Inn', 39, '2019-02-17', 258, NULL),
('Residence Inn', 39, '2019-02-18', 136, NULL),
('Residence Inn', 39, '2019-02-19', 317, NULL),
('Residence Inn', 39, '2019-02-20', 372, NULL),
('Residence Inn', 39, '2019-02-21', 106, NULL),
('Residence Inn', 39, '2019-02-22', 317, NULL),
('Residence Inn', 39, '2019-02-23', 302, NULL),
('Residence Inn', 39, '2019-02-24', 146, NULL),
('Residence Inn', 39, '2019-02-25', 231, NULL),
('Residence Inn', 39, '2019-02-26', 316, NULL),
('Residence Inn', 39, '2019-02-27', 183, NULL),
('Residence Inn', 39, '2019-02-28', 324, NULL),
('Residence Inn', 39, '2019-03-01', 254, NULL),
('Residence Inn', 39, '2019-03-02', 312, NULL),
('Residence Inn', 39, '2019-03-03', 250, NULL),
('Residence Inn', 39, '2019-03-04', 256, NULL),
('Residence Inn', 39, '2019-03-05', 364, NULL),
('Residence Inn', 39, '2019-03-06', 194, NULL),
('Residence Inn', 39, '2019-03-07', 333, NULL),
('Residence Inn', 39, '2019-03-08', 300, NULL),
('Residence Inn', 39, '2019-03-09', 316, NULL),
('Residence Inn', 39, '2019-03-10', 217, NULL),
('Residence Inn', 39, '2019-03-11', 119, NULL),
('Residence Inn', 39, '2019-03-12', 171, NULL),
('Residence Inn', 39, '2019-03-13', 205, NULL),
('Residence Inn', 39, '2019-03-14', 131, NULL),
('Residence Inn', 39, '2019-03-15', 354, NULL),
('Residence Inn', 39, '2019-03-16', 143, NULL),
('Residence Inn', 39, '2019-03-17', 302, NULL),
('Residence Inn', 39, '2019-03-18', 341, NULL),
('Residence Inn', 39, '2019-03-19', 295, NULL),
('Residence Inn', 39, '2019-03-20', 139, NULL),
('Residence Inn', 39, '2019-03-21', 240, NULL),
('Residence Inn', 39, '2019-03-22', 207, NULL),
('Residence Inn', 39, '2019-03-23', 373, NULL),
('Residence Inn', 39, '2019-03-24', 177, NULL),
('Residence Inn', 39, '2019-03-25', 186, NULL),
('Residence Inn', 39, '2019-03-26', 325, NULL),
('Residence Inn', 39, '2019-03-27', 394, NULL),
('Residence Inn', 39, '2019-03-28', 110, NULL),
('Residence Inn', 39, '2019-03-29', 214, NULL),
('Residence Inn', 39, '2019-03-30', 101, NULL),
('Residence Inn', 39, '2019-03-31', 349, NULL),
('Residence Inn', 39, '2019-04-01', 345, NULL),
('Residence Inn', 39, '2019-04-02', 123, NULL),
('Residence Inn', 39, '2019-04-03', 390, NULL),
('Residence Inn', 39, '2019-04-04', 341, NULL),
('Residence Inn', 39, '2019-04-05', 320, NULL),
('Residence Inn', 39, '2019-04-06', 376, NULL),
('Residence Inn', 39, '2019-04-07', 323, NULL),
('Residence Inn', 39, '2019-04-08', 242, NULL),
('Residence Inn', 39, '2019-04-09', 199, NULL),
('Residence Inn', 39, '2019-04-10', 281, NULL),
('Residence Inn', 39, '2019-04-11', 227, NULL),
('Residence Inn', 39, '2019-04-12', 324, NULL),
('Residence Inn', 39, '2019-04-13', 176, NULL),
('Residence Inn', 39, '2019-04-14', 254, NULL),
('Residence Inn', 39, '2019-04-15', 249, NULL),
('Residence Inn', 39, '2019-04-16', 321, NULL),
('Residence Inn', 39, '2019-04-17', 286, NULL),
('Residence Inn', 39, '2019-04-18', 389, NULL),
('Residence Inn', 39, '2019-04-19', 187, NULL),
('Residence Inn', 39, '2019-04-20', 183, NULL),
('Residence Inn', 39, '2019-04-21', 320, NULL),
('Residence Inn', 39, '2019-04-22', 218, NULL),
('Residence Inn', 39, '2019-04-23', 242, NULL),
('Residence Inn', 39, '2019-04-24', 388, NULL),
('Residence Inn', 39, '2019-04-25', 104, NULL),
('Residence Inn', 39, '2019-04-26', 105, NULL),
('Residence Inn', 39, '2019-04-27', 104, NULL),
('Residence Inn', 39, '2019-04-28', 342, NULL),
('Residence Inn', 39, '2019-04-29', 323, NULL),
('Residence Inn', 39, '2019-04-30', 167, NULL),
('Residence Inn', 39, '2019-05-01', 279, NULL),
('Residence Inn', 39, '2019-05-02', 379, NULL),
('Residence Inn', 39, '2019-05-03', 333, NULL),
('Residence Inn', 39, '2019-05-04', 191, NULL),
('Residence Inn', 39, '2019-05-05', 371, NULL),
('Residence Inn', 39, '2019-05-06', 173, NULL),
('Residence Inn', 39, '2019-05-07', 180, NULL),
('Residence Inn', 39, '2019-05-08', 103, NULL),
('Residence Inn', 39, '2019-05-09', 147, NULL),
('Residence Inn', 39, '2019-05-10', 111, NULL),
('Residence Inn', 39, '2019-05-11', 243, NULL),
('Residence Inn', 39, '2019-05-12', 262, NULL),
('Residence Inn', 39, '2019-05-13', 175, NULL),
('Residence Inn', 39, '2019-05-14', 230, NULL),
('Residence Inn', 39, '2019-05-15', 188, NULL),
('Residence Inn', 39, '2019-05-16', 216, NULL),
('Residence Inn', 39, '2019-05-17', 127, NULL),
('Residence Inn', 39, '2019-05-18', 110, NULL),
('Residence Inn', 39, '2019-05-19', 149, NULL),
('Residence Inn', 39, '2019-05-20', 217, NULL),
('Residence Inn', 39, '2019-05-21', 311, NULL),
('Residence Inn', 39, '2019-05-22', 140, NULL),
('Residence Inn', 39, '2019-05-23', 152, NULL),
('Residence Inn', 39, '2019-05-24', 213, NULL),
('Residence Inn', 39, '2019-05-25', 293, NULL),
('Residence Inn', 39, '2019-05-26', 111, NULL),
('Residence Inn', 39, '2019-05-27', 214, NULL),
('Residence Inn', 39, '2019-05-28', 224, NULL),
('Residence Inn', 39, '2019-05-29', 249, NULL),
('Residence Inn', 39, '2019-05-30', 365, NULL),
('Residence Inn', 39, '2019-05-31', 264, NULL),
('Residence Inn', 39, '2019-06-01', 214, NULL),
('Residence Inn', 39, '2019-06-02', 217, NULL),
('Residence Inn', 39, '2019-06-03', 202, NULL),
('Residence Inn', 39, '2019-06-04', 129, NULL),
('Residence Inn', 39, '2019-06-05', 273, NULL),
('Residence Inn', 39, '2019-06-06', 160, NULL),
('Residence Inn', 39, '2019-06-07', 352, NULL),
('Residence Inn', 39, '2019-06-08', 110, NULL),
('Residence Inn', 39, '2019-06-09', 157, NULL),
('Residence Inn', 39, '2019-06-10', 383, NULL),
('Residence Inn', 39, '2019-06-11', 365, NULL),
('Residence Inn', 39, '2019-06-12', 288, NULL),
('Residence Inn', 39, '2019-06-13', 239, NULL),
('Residence Inn', 39, '2019-06-14', 165, NULL),
('Residence Inn', 39, '2019-06-15', 232, NULL),
('Residence Inn', 39, '2019-06-16', 303, NULL),
('Residence Inn', 39, '2019-06-17', 232, NULL),
('Residence Inn', 39, '2019-06-18', 318, NULL),
('Residence Inn', 39, '2019-06-19', 273, NULL),
('Residence Inn', 39, '2019-06-20', 180, NULL),
('Residence Inn', 39, '2019-06-21', 188, NULL),
('Residence Inn', 39, '2019-06-22', 370, NULL),
('Residence Inn', 39, '2019-06-23', 156, NULL),
('Residence Inn', 39, '2019-06-24', 254, NULL),
('Residence Inn', 39, '2019-06-25', 332, NULL),
('Residence Inn', 39, '2019-06-26', 387, NULL),
('Residence Inn', 39, '2019-06-27', 197, NULL),
('Residence Inn', 39, '2019-06-28', 158, NULL),
('Residence Inn', 39, '2019-06-29', 385, NULL),
('Residence Inn', 39, '2019-06-30', 175, NULL),
('Residence Inn', 39, '2019-07-01', 135, NULL),
('Residence Inn', 39, '2019-07-02', 176, NULL),
('Residence Inn', 39, '2019-07-03', 102, NULL),
('Residence Inn', 39, '2019-07-04', 132, NULL),
('Residence Inn', 39, '2019-07-05', 123, NULL),
('Residence Inn', 39, '2019-07-06', 148, NULL),
('Residence Inn', 39, '2019-07-07', 119, NULL),
('Residence Inn', 39, '2019-07-08', 380, NULL),
('Residence Inn', 39, '2019-07-09', 262, NULL),
('Residence Inn', 39, '2019-07-10', 361, NULL),
('Residence Inn', 39, '2019-07-11', 253, NULL),
('Residence Inn', 39, '2019-07-12', 155, NULL),
('Residence Inn', 39, '2019-07-13', 392, NULL),
('Residence Inn', 39, '2019-07-14', 337, NULL),
('Residence Inn', 39, '2019-07-15', 123, NULL),
('Residence Inn', 39, '2019-07-16', 265, NULL),
('Residence Inn', 39, '2019-07-17', 287, NULL),
('Residence Inn', 39, '2019-07-18', 212, NULL),
('Residence Inn', 39, '2019-07-19', 288, 186),
('Residence Inn', 39, '2019-07-20', 105, 186),
('Residence Inn', 39, '2019-07-21', 236, 186),
('Residence Inn', 39, '2019-07-22', 120, 186),
('Residence Inn', 39, '2019-07-23', 328, 186),
('Residence Inn', 39, '2019-07-24', 240, 186),
('Residence Inn', 39, '2019-07-25', 109, 186),
('Residence Inn', 39, '2019-07-26', 191, 186),
('Residence Inn', 39, '2019-07-27', 361, 186),
('Residence Inn', 39, '2019-07-28', 238, 186),
('Residence Inn', 39, '2019-07-29', 118, 186),
('Residence Inn', 39, '2019-07-30', 213, 186),
('Residence Inn', 39, '2019-07-31', 205, 186),
('Residence Inn', 39, '2019-08-01', 324, 186),
('Residence Inn', 39, '2019-08-02', 262, NULL),
('Residence Inn', 39, '2019-08-03', 184, NULL),
('Residence Inn', 39, '2019-08-04', 344, NULL),
('Residence Inn', 39, '2019-08-05', 224, NULL),
('Residence Inn', 39, '2019-08-06', 299, NULL),
('Residence Inn', 39, '2019-08-07', 146, NULL),
('Residence Inn', 39, '2019-08-08', 116, NULL),
('Residence Inn', 39, '2019-08-09', 277, NULL),
('Residence Inn', 39, '2019-08-10', 398, NULL),
('Residence Inn', 39, '2019-08-11', 297, NULL),
('Residence Inn', 39, '2019-08-12', 108, NULL),
('Residence Inn', 39, '2019-08-13', 334, NULL),
('Residence Inn', 39, '2019-08-14', 266, NULL),
('Residence Inn', 39, '2019-08-15', 166, NULL),
('Residence Inn', 39, '2019-08-16', 260, NULL),
('Residence Inn', 39, '2019-08-17', 299, NULL),
('Residence Inn', 39, '2019-08-18', 178, NULL),
('Residence Inn', 39, '2019-08-19', 203, NULL),
('Residence Inn', 39, '2019-08-20', 117, NULL),
('Residence Inn', 39, '2019-08-21', 289, NULL),
('Residence Inn', 39, '2019-08-22', 363, NULL),
('Residence Inn', 39, '2019-08-23', 192, NULL),
('Residence Inn', 39, '2019-08-24', 366, NULL),
('Residence Inn', 39, '2019-08-25', 179, NULL),
('Residence Inn', 39, '2019-08-26', 308, NULL),
('Residence Inn', 39, '2019-08-27', 358, NULL),
('Residence Inn', 39, '2019-08-28', 197, NULL),
('Residence Inn', 39, '2019-08-29', 106, NULL),
('Residence Inn', 39, '2019-08-30', 164, NULL),
('Residence Inn', 39, '2019-08-31', 173, NULL),
('Residence Inn', 39, '2019-09-01', 186, NULL),
('Residence Inn', 39, '2019-09-02', 210, NULL),
('Residence Inn', 39, '2019-09-03', 155, NULL),
('Residence Inn', 39, '2019-09-04', 317, NULL),
('Residence Inn', 39, '2019-09-05', 157, NULL),
('Residence Inn', 39, '2019-09-06', 123, NULL),
('Residence Inn', 39, '2019-09-07', 240, NULL),
('Residence Inn', 39, '2019-09-08', 182, NULL),
('Residence Inn', 39, '2019-09-09', 251, NULL),
('Residence Inn', 39, '2019-09-10', 172, NULL),
('Residence Inn', 39, '2019-09-11', 198, NULL),
('Residence Inn', 39, '2019-09-12', 326, NULL),
('Residence Inn', 39, '2019-09-13', 334, NULL),
('Residence Inn', 39, '2019-09-14', 146, NULL),
('Residence Inn', 39, '2019-09-15', 313, NULL),
('Residence Inn', 39, '2019-09-16', 144, NULL),
('Residence Inn', 39, '2019-09-17', 277, NULL),
('Residence Inn', 39, '2019-09-18', 367, NULL),
('Residence Inn', 39, '2019-09-19', 392, NULL),
('Residence Inn', 39, '2019-09-20', 305, NULL),
('Residence Inn', 39, '2019-09-21', 382, NULL),
('Residence Inn', 39, '2019-09-22', 131, NULL),
('Residence Inn', 39, '2019-09-23', 209, NULL),
('Residence Inn', 39, '2019-09-24', 198, NULL),
('Residence Inn', 39, '2019-09-25', 398, NULL),
('Residence Inn', 39, '2019-09-26', 304, NULL),
('Residence Inn', 39, '2019-09-27', 340, NULL),
('Residence Inn', 39, '2019-09-28', 165, NULL),
('Residence Inn', 39, '2019-09-29', 198, NULL),
('Residence Inn', 39, '2019-09-30', 187, NULL),
('Residence Inn', 39, '2019-10-01', 208, NULL),
('Residence Inn', 39, '2019-10-02', 203, NULL),
('Residence Inn', 39, '2019-10-03', 112, NULL),
('Residence Inn', 39, '2019-10-04', 162, NULL),
('Residence Inn', 39, '2019-10-05', 325, NULL),
('Residence Inn', 39, '2019-10-06', 321, NULL),
('Residence Inn', 39, '2019-10-07', 297, NULL),
('Residence Inn', 39, '2019-10-08', 215, NULL),
('Residence Inn', 39, '2019-10-09', 328, NULL),
('Residence Inn', 39, '2019-10-10', 391, NULL),
('Residence Inn', 39, '2019-10-11', 233, NULL),
('Residence Inn', 39, '2019-10-12', 265, NULL),
('Residence Inn', 39, '2019-10-13', 217, NULL),
('Residence Inn', 39, '2019-10-14', 164, NULL),
('Residence Inn', 39, '2019-10-15', 333, NULL),
('Residence Inn', 39, '2019-10-16', 357, NULL),
('Residence Inn', 39, '2019-10-17', 254, NULL),
('Residence Inn', 39, '2019-10-18', 197, NULL),
('Residence Inn', 39, '2019-10-19', 195, NULL),
('Residence Inn', 39, '2019-10-20', 286, NULL),
('Residence Inn', 39, '2019-10-21', 116, NULL),
('Residence Inn', 39, '2019-10-22', 332, NULL),
('Residence Inn', 39, '2019-10-23', 125, NULL),
('Residence Inn', 39, '2019-10-24', 277, NULL),
('Residence Inn', 39, '2019-10-25', 180, NULL),
('Residence Inn', 39, '2019-10-26', 151, NULL),
('Residence Inn', 39, '2019-10-27', 201, NULL),
('Residence Inn', 39, '2019-10-28', 151, NULL),
('Residence Inn', 39, '2019-10-29', 308, NULL),
('Residence Inn', 39, '2019-10-30', 228, NULL),
('Residence Inn', 39, '2019-10-31', 104, NULL),
('Residence Inn', 39, '2019-11-01', 303, NULL),
('Residence Inn', 39, '2019-11-02', 376, NULL),
('Residence Inn', 39, '2019-11-03', 144, NULL),
('Residence Inn', 39, '2019-11-04', 159, NULL),
('Residence Inn', 39, '2019-11-05', 245, NULL),
('Residence Inn', 39, '2019-11-06', 234, NULL),
('Residence Inn', 39, '2019-11-07', 353, NULL),
('Residence Inn', 39, '2019-11-08', 193, NULL),
('Residence Inn', 39, '2019-11-09', 291, NULL),
('Residence Inn', 39, '2019-11-10', 207, NULL),
('Residence Inn', 39, '2019-11-11', 370, NULL),
('Residence Inn', 39, '2019-11-12', 226, NULL),
('Residence Inn', 39, '2019-11-13', 356, NULL),
('Residence Inn', 39, '2019-11-14', 233, NULL),
('Residence Inn', 39, '2019-11-15', 365, NULL),
('Residence Inn', 39, '2019-11-16', 113, NULL),
('Residence Inn', 39, '2019-11-17', 134, NULL),
('Residence Inn', 39, '2019-11-18', 392, NULL),
('Residence Inn', 39, '2019-11-19', 293, NULL),
('Residence Inn', 39, '2019-11-20', 296, NULL),
('Residence Inn', 39, '2019-11-21', 199, NULL),
('Residence Inn', 39, '2019-11-22', 125, NULL),
('Residence Inn', 39, '2019-11-23', 218, NULL),
('Residence Inn', 39, '2019-11-24', 363, NULL),
('Residence Inn', 39, '2019-11-25', 292, NULL),
('Residence Inn', 39, '2019-11-26', 202, NULL),
('Residence Inn', 39, '2019-11-27', 150, NULL),
('Residence Inn', 39, '2019-11-28', 297, NULL),
('Residence Inn', 39, '2019-11-29', 130, NULL),
('Residence Inn', 39, '2019-11-30', 383, NULL),
('Residence Inn', 39, '2019-12-01', 198, NULL),
('Residence Inn', 39, '2019-12-02', 109, NULL),
('Residence Inn', 39, '2019-12-03', 199, NULL),
('Residence Inn', 39, '2019-12-04', 286, NULL),
('Residence Inn', 39, '2019-12-05', 285, NULL),
('Residence Inn', 39, '2019-12-06', 175, NULL),
('Residence Inn', 39, '2019-12-07', 330, NULL),
('Residence Inn', 39, '2019-12-08', 351, NULL),
('Residence Inn', 39, '2019-12-09', 369, NULL),
('Residence Inn', 39, '2019-12-10', 290, NULL),
('Residence Inn', 39, '2019-12-11', 285, NULL),
('Residence Inn', 39, '2019-12-12', 368, NULL),
('Residence Inn', 39, '2019-12-13', 391, NULL),
('Residence Inn', 39, '2019-12-14', 363, NULL),
('Residence Inn', 39, '2019-12-15', 399, NULL),
('Residence Inn', 39, '2019-12-16', 386, NULL),
('Residence Inn', 39, '2019-12-17', 357, NULL),
('Residence Inn', 39, '2019-12-18', 349, NULL),
('Residence Inn', 39, '2019-12-19', 284, NULL),
('Residence Inn', 39, '2019-12-20', 170, NULL),
('Residence Inn', 39, '2019-12-21', 278, NULL),
('Residence Inn', 39, '2019-12-22', 112, NULL),
('Residence Inn', 39, '2019-12-23', 195, NULL),
('Residence Inn', 39, '2019-12-24', 226, NULL),
('Residence Inn', 39, '2019-12-25', 185, NULL),
('Residence Inn', 39, '2019-12-26', 138, NULL),
('Residence Inn', 39, '2019-12-27', 393, NULL),
('Residence Inn', 39, '2019-12-28', 258, NULL),
('Residence Inn', 39, '2019-12-29', 221, NULL),
('Residence Inn', 39, '2019-12-30', 365, NULL),
('Residence Inn', 39, '2019-12-31', 248, NULL),
('Residence Inn', 39, '2020-01-01', 303, NULL),
('Residence Inn', 39, '2020-01-02', 139, NULL),
('Residence Inn', 39, '2020-01-03', 120, NULL),
('Residence Inn', 39, '2020-01-04', 374, NULL),
('Residence Inn', 39, '2020-01-05', 140, NULL),
('Residence Inn', 39, '2020-01-06', 232, NULL),
('Residence Inn', 39, '2020-01-07', 390, NULL),
('Residence Inn', 39, '2020-01-08', 126, NULL),
('Residence Inn', 39, '2020-01-09', 269, NULL),
('Residence Inn', 39, '2020-01-10', 265, NULL),
('Residence Inn', 39, '2020-01-11', 303, NULL),
('Residence Inn', 39, '2020-01-12', 300, NULL),
('Residence Inn', 39, '2020-01-13', 223, NULL),
('Residence Inn', 39, '2020-01-14', 333, NULL),
('Residence Inn', 39, '2020-01-15', 357, NULL),
('Residence Inn', 39, '2020-01-16', 355, NULL),
('Residence Inn', 39, '2020-01-17', 247, NULL),
('Residence Inn', 39, '2020-01-18', 288, NULL),
('Residence Inn', 39, '2020-01-19', 276, NULL),
('Residence Inn', 39, '2020-01-20', 359, NULL),
('Residence Inn', 39, '2020-01-21', 242, NULL),
('Residence Inn', 39, '2020-01-22', 313, NULL),
('Residence Inn', 39, '2020-01-23', 137, NULL),
('Residence Inn', 39, '2020-01-24', 147, NULL),
('Residence Inn', 39, '2020-01-25', 194, NULL),
('Residence Inn', 39, '2020-01-26', 200, NULL),
('Residence Inn', 39, '2020-01-27', 376, NULL),
('Residence Inn', 39, '2020-01-28', 381, NULL),
('Residence Inn', 39, '2020-01-29', 226, NULL),
('Residence Inn', 39, '2020-01-30', 151, NULL),
('Residence Inn', 39, '2020-01-31', 217, NULL),
('Residence Inn', 39, '2020-02-01', 301, NULL),
('Residence Inn', 39, '2020-02-02', 226, NULL),
('Residence Inn', 39, '2020-02-03', 265, NULL),
('Residence Inn', 39, '2020-02-04', 221, NULL),
('Residence Inn', 67, '2019-01-01', 155, NULL),
('Residence Inn', 67, '2019-01-02', 151, NULL),
('Residence Inn', 67, '2019-01-03', 206, NULL),
('Residence Inn', 67, '2019-01-04', 355, NULL),
('Residence Inn', 67, '2019-01-05', 235, NULL),
('Residence Inn', 67, '2019-01-06', 232, NULL),
('Residence Inn', 67, '2019-01-07', 330, NULL),
('Residence Inn', 67, '2019-01-08', 393, NULL),
('Residence Inn', 67, '2019-01-09', 218, NULL),
('Residence Inn', 67, '2019-01-10', 148, NULL),
('Residence Inn', 67, '2019-01-11', 132, NULL),
('Residence Inn', 67, '2019-01-12', 106, NULL),
('Residence Inn', 67, '2019-01-13', 172, NULL),
('Residence Inn', 67, '2019-01-14', 188, NULL),
('Residence Inn', 67, '2019-01-15', 192, NULL),
('Residence Inn', 67, '2019-01-16', 369, NULL),
('Residence Inn', 67, '2019-01-17', 219, NULL),
('Residence Inn', 67, '2019-01-18', 224, NULL),
('Residence Inn', 67, '2019-01-19', 324, NULL),
('Residence Inn', 67, '2019-01-20', 201, NULL),
('Residence Inn', 67, '2019-01-21', 281, NULL),
('Residence Inn', 67, '2019-01-22', 303, NULL),
('Residence Inn', 67, '2019-01-23', 292, NULL),
('Residence Inn', 67, '2019-01-24', 209, NULL),
('Residence Inn', 67, '2019-01-25', 111, NULL),
('Residence Inn', 67, '2019-01-26', 320, NULL),
('Residence Inn', 67, '2019-01-27', 193, NULL),
('Residence Inn', 67, '2019-01-28', 358, NULL),
('Residence Inn', 67, '2019-01-29', 138, NULL),
('Residence Inn', 67, '2019-01-30', 136, NULL),
('Residence Inn', 67, '2019-01-31', 341, NULL),
('Residence Inn', 67, '2019-02-01', 105, NULL),
('Residence Inn', 67, '2019-02-02', 359, NULL),
('Residence Inn', 67, '2019-02-03', 121, NULL),
('Residence Inn', 67, '2019-02-04', 187, NULL),
('Residence Inn', 67, '2019-02-05', 241, NULL),
('Residence Inn', 67, '2019-02-06', 176, NULL),
('Residence Inn', 67, '2019-02-07', 207, NULL),
('Residence Inn', 67, '2019-02-08', 201, NULL),
('Residence Inn', 67, '2019-02-09', 392, NULL),
('Residence Inn', 67, '2019-02-10', 266, NULL),
('Residence Inn', 67, '2019-02-11', 212, NULL),
('Residence Inn', 67, '2019-02-12', 176, NULL),
('Residence Inn', 67, '2019-02-13', 350, NULL),
('Residence Inn', 67, '2019-02-14', 212, NULL),
('Residence Inn', 67, '2019-02-15', 363, NULL),
('Residence Inn', 67, '2019-02-16', 211, NULL),
('Residence Inn', 67, '2019-02-17', 357, NULL),
('Residence Inn', 67, '2019-02-18', 143, NULL),
('Residence Inn', 67, '2019-02-19', 286, NULL),
('Residence Inn', 67, '2019-02-20', 121, NULL),
('Residence Inn', 67, '2019-02-21', 295, NULL),
('Residence Inn', 67, '2019-02-22', 272, NULL),
('Residence Inn', 67, '2019-02-23', 159, NULL),
('Residence Inn', 67, '2019-02-24', 243, NULL),
('Residence Inn', 67, '2019-02-25', 351, NULL),
('Residence Inn', 67, '2019-02-26', 164, NULL),
('Residence Inn', 67, '2019-02-27', 376, NULL),
('Residence Inn', 67, '2019-02-28', 260, NULL),
('Residence Inn', 67, '2019-03-01', 131, NULL),
('Residence Inn', 67, '2019-03-02', 367, NULL),
('Residence Inn', 67, '2019-03-03', 332, NULL),
('Residence Inn', 67, '2019-03-04', 375, NULL),
('Residence Inn', 67, '2019-03-05', 281, NULL),
('Residence Inn', 67, '2019-03-06', 375, NULL),
('Residence Inn', 67, '2019-03-07', 136, NULL),
('Residence Inn', 67, '2019-03-08', 351, NULL),
('Residence Inn', 67, '2019-03-09', 115, NULL),
('Residence Inn', 67, '2019-03-10', 242, NULL),
('Residence Inn', 67, '2019-03-11', 147, NULL),
('Residence Inn', 67, '2019-03-12', 353, NULL),
('Residence Inn', 67, '2019-03-13', 187, NULL),
('Residence Inn', 67, '2019-03-14', 234, NULL),
('Residence Inn', 67, '2019-03-15', 374, NULL),
('Residence Inn', 67, '2019-03-16', 173, NULL),
('Residence Inn', 67, '2019-03-17', 382, NULL),
('Residence Inn', 67, '2019-03-18', 312, NULL),
('Residence Inn', 67, '2019-03-19', 261, NULL),
('Residence Inn', 67, '2019-03-20', 248, NULL),
('Residence Inn', 67, '2019-03-21', 204, NULL),
('Residence Inn', 67, '2019-03-22', 205, NULL),
('Residence Inn', 67, '2019-03-23', 210, NULL),
('Residence Inn', 67, '2019-03-24', 384, NULL),
('Residence Inn', 67, '2019-03-25', 157, NULL),
('Residence Inn', 67, '2019-03-26', 226, NULL),
('Residence Inn', 67, '2019-03-27', 146, NULL),
('Residence Inn', 67, '2019-03-28', 214, NULL),
('Residence Inn', 67, '2019-03-29', 157, NULL),
('Residence Inn', 67, '2019-03-30', 145, NULL),
('Residence Inn', 67, '2019-03-31', 287, NULL),
('Residence Inn', 67, '2019-04-01', 391, NULL),
('Residence Inn', 67, '2019-04-02', 342, NULL),
('Residence Inn', 67, '2019-04-03', 266, NULL),
('Residence Inn', 67, '2019-04-04', 120, NULL),
('Residence Inn', 67, '2019-04-05', 388, NULL),
('Residence Inn', 67, '2019-04-06', 241, NULL),
('Residence Inn', 67, '2019-04-07', 127, NULL),
('Residence Inn', 67, '2019-04-08', 102, NULL),
('Residence Inn', 67, '2019-04-09', 357, NULL),
('Residence Inn', 67, '2019-04-10', 341, NULL),
('Residence Inn', 67, '2019-04-11', 110, NULL),
('Residence Inn', 67, '2019-04-12', 375, NULL),
('Residence Inn', 67, '2019-04-13', 177, NULL),
('Residence Inn', 67, '2019-04-14', 149, NULL),
('Residence Inn', 67, '2019-04-15', 233, NULL),
('Residence Inn', 67, '2019-04-16', 109, NULL),
('Residence Inn', 67, '2019-04-17', 299, NULL),
('Residence Inn', 67, '2019-04-18', 389, NULL),
('Residence Inn', 67, '2019-04-19', 177, NULL),
('Residence Inn', 67, '2019-04-20', 150, NULL),
('Residence Inn', 67, '2019-04-21', 118, NULL),
('Residence Inn', 67, '2019-04-22', 363, NULL),
('Residence Inn', 67, '2019-04-23', 243, NULL),
('Residence Inn', 67, '2019-04-24', 186, NULL),
('Residence Inn', 67, '2019-04-25', 183, NULL),
('Residence Inn', 67, '2019-04-26', 151, NULL),
('Residence Inn', 67, '2019-04-27', 235, NULL),
('Residence Inn', 67, '2019-04-28', 237, NULL),
('Residence Inn', 67, '2019-04-29', 356, NULL),
('Residence Inn', 67, '2019-04-30', 157, NULL),
('Residence Inn', 67, '2019-05-01', 285, NULL),
('Residence Inn', 67, '2019-05-02', 280, NULL),
('Residence Inn', 67, '2019-05-03', 385, NULL),
('Residence Inn', 67, '2019-05-04', 370, NULL),
('Residence Inn', 67, '2019-05-05', 138, NULL),
('Residence Inn', 67, '2019-05-06', 269, NULL),
('Residence Inn', 67, '2019-05-07', 297, NULL),
('Residence Inn', 67, '2019-05-08', 214, NULL),
('Residence Inn', 67, '2019-05-09', 348, NULL),
('Residence Inn', 67, '2019-05-10', 367, NULL),
('Residence Inn', 67, '2019-05-11', 318, NULL),
('Residence Inn', 67, '2019-05-12', 328, NULL),
('Residence Inn', 67, '2019-05-13', 197, NULL),
('Residence Inn', 67, '2019-05-14', 215, NULL),
('Residence Inn', 67, '2019-05-15', 254, NULL),
('Residence Inn', 67, '2019-05-16', 146, NULL),
('Residence Inn', 67, '2019-05-17', 129, NULL),
('Residence Inn', 67, '2019-05-18', 350, NULL),
('Residence Inn', 67, '2019-05-19', 254, NULL),
('Residence Inn', 67, '2019-05-20', 201, NULL),
('Residence Inn', 67, '2019-05-21', 337, NULL),
('Residence Inn', 67, '2019-05-22', 287, NULL),
('Residence Inn', 67, '2019-05-23', 341, NULL),
('Residence Inn', 67, '2019-05-24', 140, NULL),
('Residence Inn', 67, '2019-05-25', 136, NULL),
('Residence Inn', 67, '2019-05-26', 361, NULL),
('Residence Inn', 67, '2019-05-27', 266, NULL),
('Residence Inn', 67, '2019-05-28', 234, NULL),
('Residence Inn', 67, '2019-05-29', 388, NULL),
('Residence Inn', 67, '2019-05-30', 306, NULL),
('Residence Inn', 67, '2019-05-31', 275, NULL),
('Residence Inn', 67, '2019-06-01', 342, NULL),
('Residence Inn', 67, '2019-06-02', 292, NULL),
('Residence Inn', 67, '2019-06-03', 395, NULL),
('Residence Inn', 67, '2019-06-04', 115, NULL),
('Residence Inn', 67, '2019-06-05', 135, NULL),
('Residence Inn', 67, '2019-06-06', 341, NULL),
('Residence Inn', 67, '2019-06-07', 331, NULL),
('Residence Inn', 67, '2019-06-08', 219, NULL),
('Residence Inn', 67, '2019-06-09', 200, NULL),
('Residence Inn', 67, '2019-06-10', 200, NULL),
('Residence Inn', 67, '2019-06-11', 101, NULL),
('Residence Inn', 67, '2019-06-12', 187, NULL),
('Residence Inn', 67, '2019-06-13', 131, NULL),
('Residence Inn', 67, '2019-06-14', 113, NULL),
('Residence Inn', 67, '2019-06-15', 340, NULL),
('Residence Inn', 67, '2019-06-16', 350, NULL),
('Residence Inn', 67, '2019-06-17', 392, NULL),
('Residence Inn', 67, '2019-06-18', 178, NULL),
('Residence Inn', 67, '2019-06-19', 342, NULL),
('Residence Inn', 67, '2019-06-20', 292, NULL),
('Residence Inn', 67, '2019-06-21', 293, NULL),
('Residence Inn', 67, '2019-06-22', 157, NULL),
('Residence Inn', 67, '2019-06-23', 236, NULL),
('Residence Inn', 67, '2019-06-24', 348, NULL),
('Residence Inn', 67, '2019-06-25', 399, NULL),
('Residence Inn', 67, '2019-06-26', 312, NULL),
('Residence Inn', 67, '2019-06-27', 154, NULL),
('Residence Inn', 67, '2019-06-28', 165, NULL),
('Residence Inn', 67, '2019-06-29', 311, NULL),
('Residence Inn', 67, '2019-06-30', 349, NULL),
('Residence Inn', 67, '2019-07-01', 258, NULL),
('Residence Inn', 67, '2019-07-02', 394, NULL),
('Residence Inn', 67, '2019-07-03', 143, NULL),
('Residence Inn', 67, '2019-07-04', 297, NULL),
('Residence Inn', 67, '2019-07-05', 183, NULL),
('Residence Inn', 67, '2019-07-06', 371, NULL),
('Residence Inn', 67, '2019-07-07', 360, NULL),
('Residence Inn', 67, '2019-07-08', 228, NULL),
('Residence Inn', 67, '2019-07-09', 394, NULL),
('Residence Inn', 67, '2019-07-10', 202, NULL),
('Residence Inn', 67, '2019-07-11', 378, NULL),
('Residence Inn', 67, '2019-07-12', 178, NULL),
('Residence Inn', 67, '2019-07-13', 275, NULL),
('Residence Inn', 67, '2019-07-14', 241, NULL),
('Residence Inn', 67, '2019-07-15', 221, NULL),
('Residence Inn', 67, '2019-07-16', 187, NULL),
('Residence Inn', 67, '2019-07-17', 299, NULL),
('Residence Inn', 67, '2019-07-18', 379, NULL),
('Residence Inn', 67, '2019-07-19', 305, NULL),
('Residence Inn', 67, '2019-07-20', 370, NULL),
('Residence Inn', 67, '2019-07-21', 149, NULL),
('Residence Inn', 67, '2019-07-22', 310, NULL),
('Residence Inn', 67, '2019-07-23', 321, NULL),
('Residence Inn', 67, '2019-07-24', 292, NULL),
('Residence Inn', 67, '2019-07-25', 212, NULL),
('Residence Inn', 67, '2019-07-26', 359, NULL),
('Residence Inn', 67, '2019-07-27', 144, NULL),
('Residence Inn', 67, '2019-07-28', 194, NULL),
('Residence Inn', 67, '2019-07-29', 145, NULL),
('Residence Inn', 67, '2019-07-30', 163, NULL),
('Residence Inn', 67, '2019-07-31', 372, NULL),
('Residence Inn', 67, '2019-08-01', 162, NULL),
('Residence Inn', 67, '2019-08-02', 360, NULL),
('Residence Inn', 67, '2019-08-03', 351, NULL),
('Residence Inn', 67, '2019-08-04', 173, NULL),
('Residence Inn', 67, '2019-08-05', 219, NULL),
('Residence Inn', 67, '2019-08-06', 115, NULL),
('Residence Inn', 67, '2019-08-07', 228, NULL),
('Residence Inn', 67, '2019-08-08', 152, NULL),
('Residence Inn', 67, '2019-08-09', 135, NULL),
('Residence Inn', 67, '2019-08-10', 171, NULL),
('Residence Inn', 67, '2019-08-11', 314, NULL),
('Residence Inn', 67, '2019-08-12', 297, NULL),
('Residence Inn', 67, '2019-08-13', 344, NULL),
('Residence Inn', 67, '2019-08-14', 185, NULL),
('Residence Inn', 67, '2019-08-15', 137, NULL),
('Residence Inn', 67, '2019-08-16', 249, NULL),
('Residence Inn', 67, '2019-08-17', 223, NULL),
('Residence Inn', 67, '2019-08-18', 111, NULL),
('Residence Inn', 67, '2019-08-19', 380, NULL),
('Residence Inn', 67, '2019-08-20', 187, NULL),
('Residence Inn', 67, '2019-08-21', 282, NULL),
('Residence Inn', 67, '2019-08-22', 278, NULL),
('Residence Inn', 67, '2019-08-23', 298, NULL),
('Residence Inn', 67, '2019-08-24', 316, NULL),
('Residence Inn', 67, '2019-08-25', 315, NULL),
('Residence Inn', 67, '2019-08-26', 183, NULL),
('Residence Inn', 67, '2019-08-27', 331, NULL),
('Residence Inn', 67, '2019-08-28', 284, NULL),
('Residence Inn', 67, '2019-08-29', 182, NULL),
('Residence Inn', 67, '2019-08-30', 221, NULL),
('Residence Inn', 67, '2019-08-31', 370, NULL),
('Residence Inn', 67, '2019-09-01', 397, NULL),
('Residence Inn', 67, '2019-09-02', 324, NULL),
('Residence Inn', 67, '2019-09-03', 365, NULL),
('Residence Inn', 67, '2019-09-04', 357, NULL),
('Residence Inn', 67, '2019-09-05', 227, NULL),
('Residence Inn', 67, '2019-09-06', 111, NULL),
('Residence Inn', 67, '2019-09-07', 280, NULL),
('Residence Inn', 67, '2019-09-08', 320, NULL),
('Residence Inn', 67, '2019-09-09', 145, NULL),
('Residence Inn', 67, '2019-09-10', 154, NULL),
('Residence Inn', 67, '2019-09-11', 186, NULL),
('Residence Inn', 67, '2019-09-12', 322, NULL),
('Residence Inn', 67, '2019-09-13', 144, NULL),
('Residence Inn', 67, '2019-09-14', 311, NULL),
('Residence Inn', 67, '2019-09-15', 302, NULL),
('Residence Inn', 67, '2019-09-16', 175, NULL),
('Residence Inn', 67, '2019-09-17', 347, NULL),
('Residence Inn', 67, '2019-09-18', 321, NULL),
('Residence Inn', 67, '2019-09-19', 265, NULL),
('Residence Inn', 67, '2019-09-20', 286, NULL),
('Residence Inn', 67, '2019-09-21', 229, NULL),
('Residence Inn', 67, '2019-09-22', 340, NULL),
('Residence Inn', 67, '2019-09-23', 211, NULL),
('Residence Inn', 67, '2019-09-24', 205, NULL),
('Residence Inn', 67, '2019-09-25', 365, NULL),
('Residence Inn', 67, '2019-09-26', 237, NULL),
('Residence Inn', 67, '2019-09-27', 286, NULL),
('Residence Inn', 67, '2019-09-28', 222, NULL),
('Residence Inn', 67, '2019-09-29', 340, NULL),
('Residence Inn', 67, '2019-09-30', 117, NULL),
('Residence Inn', 67, '2019-10-01', 365, NULL),
('Residence Inn', 67, '2019-10-02', 285, NULL),
('Residence Inn', 67, '2019-10-03', 190, NULL),
('Residence Inn', 67, '2019-10-04', 113, NULL),
('Residence Inn', 67, '2019-10-05', 377, NULL),
('Residence Inn', 67, '2019-10-06', 268, NULL),
('Residence Inn', 67, '2019-10-07', 119, NULL),
('Residence Inn', 67, '2019-10-08', 395, NULL),
('Residence Inn', 67, '2019-10-09', 341, NULL),
('Residence Inn', 67, '2019-10-10', 215, NULL),
('Residence Inn', 67, '2019-10-11', 147, NULL),
('Residence Inn', 67, '2019-10-12', 255, NULL),
('Residence Inn', 67, '2019-10-13', 228, NULL),
('Residence Inn', 67, '2019-10-14', 128, NULL),
('Residence Inn', 67, '2019-10-15', 276, NULL),
('Residence Inn', 67, '2019-10-16', 220, NULL),
('Residence Inn', 67, '2019-10-17', 383, NULL),
('Residence Inn', 67, '2019-10-18', 106, NULL),
('Residence Inn', 67, '2019-10-19', 302, NULL),
('Residence Inn', 67, '2019-10-20', 210, NULL),
('Residence Inn', 67, '2019-10-21', 100, NULL),
('Residence Inn', 67, '2019-10-22', 181, NULL),
('Residence Inn', 67, '2019-10-23', 125, NULL),
('Residence Inn', 67, '2019-10-24', 241, NULL),
('Residence Inn', 67, '2019-10-25', 154, NULL),
('Residence Inn', 67, '2019-10-26', 353, NULL),
('Residence Inn', 67, '2019-10-27', 156, NULL),
('Residence Inn', 67, '2019-10-28', 261, NULL),
('Residence Inn', 67, '2019-10-29', 291, NULL),
('Residence Inn', 67, '2019-10-30', 245, NULL),
('Residence Inn', 67, '2019-10-31', 262, NULL),
('Residence Inn', 67, '2019-11-01', 197, NULL),
('Residence Inn', 67, '2019-11-02', 130, NULL),
('Residence Inn', 67, '2019-11-03', 126, NULL),
('Residence Inn', 67, '2019-11-04', 333, NULL),
('Residence Inn', 67, '2019-11-05', 128, NULL),
('Residence Inn', 67, '2019-11-06', 150, NULL),
('Residence Inn', 67, '2019-11-07', 159, NULL),
('Residence Inn', 67, '2019-11-08', 367, NULL),
('Residence Inn', 67, '2019-11-09', 318, NULL),
('Residence Inn', 67, '2019-11-10', 291, NULL),
('Residence Inn', 67, '2019-11-11', 168, NULL),
('Residence Inn', 67, '2019-11-12', 283, NULL),
('Residence Inn', 67, '2019-11-13', 313, NULL),
('Residence Inn', 67, '2019-11-14', 275, NULL),
('Residence Inn', 67, '2019-11-15', 332, NULL),
('Residence Inn', 67, '2019-11-16', 293, NULL),
('Residence Inn', 67, '2019-11-17', 277, NULL),
('Residence Inn', 67, '2019-11-18', 242, NULL),
('Residence Inn', 67, '2019-11-19', 362, NULL),
('Residence Inn', 67, '2019-11-20', 390, NULL),
('Residence Inn', 67, '2019-11-21', 123, NULL),
('Residence Inn', 67, '2019-11-22', 115, NULL),
('Residence Inn', 67, '2019-11-23', 138, NULL),
('Residence Inn', 67, '2019-11-24', 200, NULL),
('Residence Inn', 67, '2019-11-25', 288, NULL),
('Residence Inn', 67, '2019-11-26', 116, NULL),
('Residence Inn', 67, '2019-11-27', 178, NULL),
('Residence Inn', 67, '2019-11-28', 104, NULL),
('Residence Inn', 67, '2019-11-29', 166, NULL),
('Residence Inn', 67, '2019-11-30', 171, NULL),
('Residence Inn', 67, '2019-12-01', 201, NULL),
('Residence Inn', 67, '2019-12-02', 330, NULL),
('Residence Inn', 67, '2019-12-03', 362, NULL),
('Residence Inn', 67, '2019-12-04', 103, NULL),
('Residence Inn', 67, '2019-12-05', 267, NULL),
('Residence Inn', 67, '2019-12-06', 139, NULL),
('Residence Inn', 67, '2019-12-07', 213, NULL),
('Residence Inn', 67, '2019-12-08', 119, NULL),
('Residence Inn', 67, '2019-12-09', 335, NULL),
('Residence Inn', 67, '2019-12-10', 108, NULL),
('Residence Inn', 67, '2019-12-11', 145, NULL),
('Residence Inn', 67, '2019-12-12', 249, NULL),
('Residence Inn', 67, '2019-12-13', 107, NULL),
('Residence Inn', 67, '2019-12-14', 330, NULL),
('Residence Inn', 67, '2019-12-15', 306, NULL),
('Residence Inn', 67, '2019-12-16', 286, NULL),
('Residence Inn', 67, '2019-12-17', 170, NULL),
('Residence Inn', 67, '2019-12-18', 277, NULL),
('Residence Inn', 67, '2019-12-19', 264, NULL),
('Residence Inn', 67, '2019-12-20', 326, NULL),
('Residence Inn', 67, '2019-12-21', 355, NULL),
('Residence Inn', 67, '2019-12-22', 343, NULL),
('Residence Inn', 67, '2019-12-23', 225, NULL),
('Residence Inn', 67, '2019-12-24', 294, NULL),
('Residence Inn', 67, '2019-12-25', 186, NULL),
('Residence Inn', 67, '2019-12-26', 348, NULL),
('Residence Inn', 67, '2019-12-27', 164, NULL),
('Residence Inn', 67, '2019-12-28', 272, NULL),
('Residence Inn', 67, '2019-12-29', 212, NULL),
('Residence Inn', 67, '2019-12-30', 337, NULL),
('Residence Inn', 67, '2019-12-31', 137, NULL),
('Residence Inn', 67, '2020-01-01', 370, NULL),
('Residence Inn', 67, '2020-01-02', 284, NULL),
('Residence Inn', 67, '2020-01-03', 254, NULL),
('Residence Inn', 67, '2020-01-04', 328, NULL),
('Residence Inn', 67, '2020-01-05', 289, NULL),
('Residence Inn', 67, '2020-01-06', 263, NULL),
('Residence Inn', 67, '2020-01-07', 192, NULL),
('Residence Inn', 67, '2020-01-08', 224, NULL),
('Residence Inn', 67, '2020-01-09', 140, NULL),
('Residence Inn', 67, '2020-01-10', 350, NULL),
('Residence Inn', 67, '2020-01-11', 281, NULL),
('Residence Inn', 67, '2020-01-12', 212, NULL),
('Residence Inn', 67, '2020-01-13', 138, NULL),
('Residence Inn', 67, '2020-01-14', 284, NULL),
('Residence Inn', 67, '2020-01-15', 355, NULL),
('Residence Inn', 67, '2020-01-16', 112, NULL),
('Residence Inn', 67, '2020-01-17', 369, NULL),
('Residence Inn', 67, '2020-01-18', 168, NULL),
('Residence Inn', 67, '2020-01-19', 150, NULL),
('Residence Inn', 67, '2020-01-20', 370, NULL),
('Residence Inn', 67, '2020-01-21', 310, NULL),
('Residence Inn', 67, '2020-01-22', 293, NULL),
('Residence Inn', 67, '2020-01-23', 372, NULL),
('Residence Inn', 67, '2020-01-24', 269, NULL),
('Residence Inn', 67, '2020-01-25', 115, NULL),
('Residence Inn', 67, '2020-01-26', 323, NULL),
('Residence Inn', 67, '2020-01-27', 272, NULL),
('Residence Inn', 67, '2020-01-28', 181, NULL),
('Residence Inn', 67, '2020-01-29', 296, NULL),
('Residence Inn', 67, '2020-01-30', 236, NULL),
('Residence Inn', 67, '2020-01-31', 164, NULL),
('Residence Inn', 67, '2020-02-01', 237, NULL),
('Residence Inn', 67, '2020-02-02', 137, NULL),
('Residence Inn', 67, '2020-02-03', 209, NULL),
('Residence Inn', 67, '2020-02-04', 278, NULL),
('Residence Inn', 75, '2019-01-01', 246, NULL),
('Residence Inn', 75, '2019-01-02', 126, NULL),
('Residence Inn', 75, '2019-01-03', 276, NULL),
('Residence Inn', 75, '2019-01-04', 288, NULL),
('Residence Inn', 75, '2019-01-05', 371, NULL),
('Residence Inn', 75, '2019-01-06', 343, NULL),
('Residence Inn', 75, '2019-01-07', 121, NULL),
('Residence Inn', 75, '2019-01-08', 346, NULL),
('Residence Inn', 75, '2019-01-09', 385, NULL),
('Residence Inn', 75, '2019-01-10', 104, NULL),
('Residence Inn', 75, '2019-01-11', 300, NULL),
('Residence Inn', 75, '2019-01-12', 351, NULL),
('Residence Inn', 75, '2019-01-13', 213, NULL),
('Residence Inn', 75, '2019-01-14', 298, NULL),
('Residence Inn', 75, '2019-01-15', 295, NULL),
('Residence Inn', 75, '2019-01-16', 303, NULL),
('Residence Inn', 75, '2019-01-17', 180, NULL),
('Residence Inn', 75, '2019-01-18', 334, NULL),
('Residence Inn', 75, '2019-01-19', 379, NULL),
('Residence Inn', 75, '2019-01-20', 132, NULL),
('Residence Inn', 75, '2019-01-21', 139, NULL),
('Residence Inn', 75, '2019-01-22', 222, NULL),
('Residence Inn', 75, '2019-01-23', 330, NULL),
('Residence Inn', 75, '2019-01-24', 344, NULL),
('Residence Inn', 75, '2019-01-25', 338, NULL),
('Residence Inn', 75, '2019-01-26', 377, NULL),
('Residence Inn', 75, '2019-01-27', 362, NULL),
('Residence Inn', 75, '2019-01-28', 280, NULL),
('Residence Inn', 75, '2019-01-29', 117, NULL),
('Residence Inn', 75, '2019-01-30', 176, NULL),
('Residence Inn', 75, '2019-01-31', 283, NULL),
('Residence Inn', 75, '2019-02-01', 344, NULL),
('Residence Inn', 75, '2019-02-02', 160, NULL),
('Residence Inn', 75, '2019-02-03', 126, NULL),
('Residence Inn', 75, '2019-02-04', 230, NULL),
('Residence Inn', 75, '2019-02-05', 147, NULL),
('Residence Inn', 75, '2019-02-06', 367, NULL),
('Residence Inn', 75, '2019-02-07', 316, NULL),
('Residence Inn', 75, '2019-02-08', 127, NULL),
('Residence Inn', 75, '2019-02-09', 289, NULL),
('Residence Inn', 75, '2019-02-10', 392, NULL),
('Residence Inn', 75, '2019-02-11', 238, NULL),
('Residence Inn', 75, '2019-02-12', 198, NULL),
('Residence Inn', 75, '2019-02-13', 271, NULL),
('Residence Inn', 75, '2019-02-14', 322, NULL),
('Residence Inn', 75, '2019-02-15', 394, NULL),
('Residence Inn', 75, '2019-02-16', 231, NULL),
('Residence Inn', 75, '2019-02-17', 312, NULL),
('Residence Inn', 75, '2019-02-18', 210, NULL),
('Residence Inn', 75, '2019-02-19', 377, NULL),
('Residence Inn', 75, '2019-02-20', 289, NULL),
('Residence Inn', 75, '2019-02-21', 159, NULL),
('Residence Inn', 75, '2019-02-22', 311, NULL),
('Residence Inn', 75, '2019-02-23', 387, NULL),
('Residence Inn', 75, '2019-02-24', 380, NULL),
('Residence Inn', 75, '2019-02-25', 362, NULL),
('Residence Inn', 75, '2019-02-26', 373, NULL),
('Residence Inn', 75, '2019-02-27', 329, NULL),
('Residence Inn', 75, '2019-02-28', 227, NULL),
('Residence Inn', 75, '2019-03-01', 392, NULL),
('Residence Inn', 75, '2019-03-02', 198, NULL),
('Residence Inn', 75, '2019-03-03', 209, NULL),
('Residence Inn', 75, '2019-03-04', 107, NULL),
('Residence Inn', 75, '2019-03-05', 217, NULL),
('Residence Inn', 75, '2019-03-06', 292, NULL),
('Residence Inn', 75, '2019-03-07', 180, NULL),
('Residence Inn', 75, '2019-03-08', 154, NULL),
('Residence Inn', 75, '2019-03-09', 130, NULL),
('Residence Inn', 75, '2019-03-10', 160, NULL),
('Residence Inn', 75, '2019-03-11', 281, NULL),
('Residence Inn', 75, '2019-03-12', 252, NULL),
('Residence Inn', 75, '2019-03-13', 217, NULL),
('Residence Inn', 75, '2019-03-14', 380, NULL),
('Residence Inn', 75, '2019-03-15', 111, NULL),
('Residence Inn', 75, '2019-03-16', 337, NULL),
('Residence Inn', 75, '2019-03-17', 306, NULL),
('Residence Inn', 75, '2019-03-18', 139, NULL),
('Residence Inn', 75, '2019-03-19', 321, NULL),
('Residence Inn', 75, '2019-03-20', 122, NULL),
('Residence Inn', 75, '2019-03-21', 201, NULL),
('Residence Inn', 75, '2019-03-22', 308, NULL),
('Residence Inn', 75, '2019-03-23', 135, NULL),
('Residence Inn', 75, '2019-03-24', 388, NULL),
('Residence Inn', 75, '2019-03-25', 129, NULL),
('Residence Inn', 75, '2019-03-26', 356, NULL),
('Residence Inn', 75, '2019-03-27', 346, NULL),
('Residence Inn', 75, '2019-03-28', 340, NULL),
('Residence Inn', 75, '2019-03-29', 347, NULL),
('Residence Inn', 75, '2019-03-30', 320, NULL),
('Residence Inn', 75, '2019-03-31', 288, NULL),
('Residence Inn', 75, '2019-04-01', 221, NULL),
('Residence Inn', 75, '2019-04-02', 342, NULL),
('Residence Inn', 75, '2019-04-03', 362, NULL),
('Residence Inn', 75, '2019-04-04', 376, NULL),
('Residence Inn', 75, '2019-04-05', 278, NULL),
('Residence Inn', 75, '2019-04-06', 276, NULL),
('Residence Inn', 75, '2019-04-07', 165, NULL),
('Residence Inn', 75, '2019-04-08', 282, NULL),
('Residence Inn', 75, '2019-04-09', 188, NULL),
('Residence Inn', 75, '2019-04-10', 159, NULL),
('Residence Inn', 75, '2019-04-11', 370, NULL),
('Residence Inn', 75, '2019-04-12', 201, NULL),
('Residence Inn', 75, '2019-04-13', 256, NULL),
('Residence Inn', 75, '2019-04-14', 186, NULL),
('Residence Inn', 75, '2019-04-15', 317, NULL),
('Residence Inn', 75, '2019-04-16', 384, NULL),
('Residence Inn', 75, '2019-04-17', 239, NULL),
('Residence Inn', 75, '2019-04-18', 381, NULL),
('Residence Inn', 75, '2019-04-19', 225, NULL),
('Residence Inn', 75, '2019-04-20', 399, NULL),
('Residence Inn', 75, '2019-04-21', 132, NULL),
('Residence Inn', 75, '2019-04-22', 161, NULL),
('Residence Inn', 75, '2019-04-23', 388, NULL),
('Residence Inn', 75, '2019-04-24', 267, NULL),
('Residence Inn', 75, '2019-04-25', 203, NULL),
('Residence Inn', 75, '2019-04-26', 342, NULL),
('Residence Inn', 75, '2019-04-27', 164, NULL),
('Residence Inn', 75, '2019-04-28', 361, NULL),
('Residence Inn', 75, '2019-04-29', 109, NULL),
('Residence Inn', 75, '2019-04-30', 181, NULL),
('Residence Inn', 75, '2019-05-01', 192, NULL),
('Residence Inn', 75, '2019-05-02', 165, NULL),
('Residence Inn', 75, '2019-05-03', 228, NULL),
('Residence Inn', 75, '2019-05-04', 278, NULL),
('Residence Inn', 75, '2019-05-05', 374, NULL),
('Residence Inn', 75, '2019-05-06', 128, NULL),
('Residence Inn', 75, '2019-05-07', 243, NULL),
('Residence Inn', 75, '2019-05-08', 362, NULL),
('Residence Inn', 75, '2019-05-09', 302, NULL),
('Residence Inn', 75, '2019-05-10', 204, NULL),
('Residence Inn', 75, '2019-05-11', 163, NULL),
('Residence Inn', 75, '2019-05-12', 154, NULL),
('Residence Inn', 75, '2019-05-13', 362, NULL),
('Residence Inn', 75, '2019-05-14', 285, NULL),
('Residence Inn', 75, '2019-05-15', 307, NULL),
('Residence Inn', 75, '2019-05-16', 280, NULL),
('Residence Inn', 75, '2019-05-17', 166, NULL),
('Residence Inn', 75, '2019-05-18', 117, NULL),
('Residence Inn', 75, '2019-05-19', 123, NULL),
('Residence Inn', 75, '2019-05-20', 253, NULL),
('Residence Inn', 75, '2019-05-21', 353, NULL),
('Residence Inn', 75, '2019-05-22', 312, NULL),
('Residence Inn', 75, '2019-05-23', 247, NULL),
('Residence Inn', 75, '2019-05-24', 262, NULL),
('Residence Inn', 75, '2019-05-25', 300, NULL),
('Residence Inn', 75, '2019-05-26', 174, NULL),
('Residence Inn', 75, '2019-05-27', 287, NULL),
('Residence Inn', 75, '2019-05-28', 101, NULL),
('Residence Inn', 75, '2019-05-29', 194, NULL),
('Residence Inn', 75, '2019-05-30', 336, NULL),
('Residence Inn', 75, '2019-05-31', 184, NULL),
('Residence Inn', 75, '2019-06-01', 367, NULL),
('Residence Inn', 75, '2019-06-02', 112, NULL),
('Residence Inn', 75, '2019-06-03', 368, NULL),
('Residence Inn', 75, '2019-06-04', 386, NULL),
('Residence Inn', 75, '2019-06-05', 356, NULL),
('Residence Inn', 75, '2019-06-06', 224, NULL),
('Residence Inn', 75, '2019-06-07', 201, NULL),
('Residence Inn', 75, '2019-06-08', 368, NULL),
('Residence Inn', 75, '2019-06-09', 131, NULL),
('Residence Inn', 75, '2019-06-10', 352, NULL),
('Residence Inn', 75, '2019-06-11', 212, NULL),
('Residence Inn', 75, '2019-06-12', 274, NULL),
('Residence Inn', 75, '2019-06-13', 137, NULL),
('Residence Inn', 75, '2019-06-14', 273, NULL),
('Residence Inn', 75, '2019-06-15', 306, NULL),
('Residence Inn', 75, '2019-06-16', 141, NULL),
('Residence Inn', 75, '2019-06-17', 267, NULL),
('Residence Inn', 75, '2019-06-18', 138, NULL),
('Residence Inn', 75, '2019-06-19', 193, NULL),
('Residence Inn', 75, '2019-06-20', 219, NULL),
('Residence Inn', 75, '2019-06-21', 199, NULL),
('Residence Inn', 75, '2019-06-22', 176, NULL),
('Residence Inn', 75, '2019-06-23', 311, NULL),
('Residence Inn', 75, '2019-06-24', 280, NULL),
('Residence Inn', 75, '2019-06-25', 300, NULL),
('Residence Inn', 75, '2019-06-26', 301, NULL),
('Residence Inn', 75, '2019-06-27', 377, NULL),
('Residence Inn', 75, '2019-06-28', 254, NULL),
('Residence Inn', 75, '2019-06-29', 304, NULL),
('Residence Inn', 75, '2019-06-30', 217, NULL),
('Residence Inn', 75, '2019-07-01', 184, NULL),
('Residence Inn', 75, '2019-07-02', 145, NULL),
('Residence Inn', 75, '2019-07-03', 312, NULL),
('Residence Inn', 75, '2019-07-04', 388, NULL),
('Residence Inn', 75, '2019-07-05', 148, NULL),
('Residence Inn', 75, '2019-07-06', 112, NULL),
('Residence Inn', 75, '2019-07-07', 143, NULL),
('Residence Inn', 75, '2019-07-08', 202, NULL),
('Residence Inn', 75, '2019-07-09', 184, NULL),
('Residence Inn', 75, '2019-07-10', 130, NULL),
('Residence Inn', 75, '2019-07-11', 134, NULL),
('Residence Inn', 75, '2019-07-12', 325, NULL),
('Residence Inn', 75, '2019-07-13', 103, NULL),
('Residence Inn', 75, '2019-07-14', 397, NULL),
('Residence Inn', 75, '2019-07-15', 334, NULL),
('Residence Inn', 75, '2019-07-16', 340, NULL),
('Residence Inn', 75, '2019-07-17', 234, NULL),
('Residence Inn', 75, '2019-07-18', 262, NULL),
('Residence Inn', 75, '2019-07-19', 258, NULL),
('Residence Inn', 75, '2019-07-20', 237, NULL),
('Residence Inn', 75, '2019-07-21', 237, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 75, '2019-07-22', 189, NULL),
('Residence Inn', 75, '2019-07-23', 224, NULL),
('Residence Inn', 75, '2019-07-24', 343, NULL),
('Residence Inn', 75, '2019-07-25', 335, NULL),
('Residence Inn', 75, '2019-07-26', 221, NULL),
('Residence Inn', 75, '2019-07-27', 136, NULL),
('Residence Inn', 75, '2019-07-28', 155, NULL),
('Residence Inn', 75, '2019-07-29', 270, NULL),
('Residence Inn', 75, '2019-07-30', 378, NULL),
('Residence Inn', 75, '2019-07-31', 247, NULL),
('Residence Inn', 75, '2019-08-01', 341, NULL),
('Residence Inn', 75, '2019-08-02', 317, NULL),
('Residence Inn', 75, '2019-08-03', 205, NULL),
('Residence Inn', 75, '2019-08-04', 337, NULL),
('Residence Inn', 75, '2019-08-05', 323, NULL),
('Residence Inn', 75, '2019-08-06', 179, NULL),
('Residence Inn', 75, '2019-08-07', 301, NULL),
('Residence Inn', 75, '2019-08-08', 314, NULL),
('Residence Inn', 75, '2019-08-09', 347, NULL),
('Residence Inn', 75, '2019-08-10', 163, NULL),
('Residence Inn', 75, '2019-08-11', 280, NULL),
('Residence Inn', 75, '2019-08-12', 162, NULL),
('Residence Inn', 75, '2019-08-13', 318, NULL),
('Residence Inn', 75, '2019-08-14', 326, NULL),
('Residence Inn', 75, '2019-08-15', 387, NULL),
('Residence Inn', 75, '2019-08-16', 367, NULL),
('Residence Inn', 75, '2019-08-17', 120, NULL),
('Residence Inn', 75, '2019-08-18', 222, NULL),
('Residence Inn', 75, '2019-08-19', 294, NULL),
('Residence Inn', 75, '2019-08-20', 183, NULL),
('Residence Inn', 75, '2019-08-21', 142, NULL),
('Residence Inn', 75, '2019-08-22', 204, NULL),
('Residence Inn', 75, '2019-08-23', 213, NULL),
('Residence Inn', 75, '2019-08-24', 381, NULL),
('Residence Inn', 75, '2019-08-25', 338, NULL),
('Residence Inn', 75, '2019-08-26', 192, NULL),
('Residence Inn', 75, '2019-08-27', 181, NULL),
('Residence Inn', 75, '2019-08-28', 129, NULL),
('Residence Inn', 75, '2019-08-29', 193, NULL),
('Residence Inn', 75, '2019-08-30', 213, NULL),
('Residence Inn', 75, '2019-08-31', 335, NULL),
('Residence Inn', 75, '2019-09-01', 131, NULL),
('Residence Inn', 75, '2019-09-02', 291, NULL),
('Residence Inn', 75, '2019-09-03', 360, NULL),
('Residence Inn', 75, '2019-09-04', 135, NULL),
('Residence Inn', 75, '2019-09-05', 265, NULL),
('Residence Inn', 75, '2019-09-06', 385, NULL),
('Residence Inn', 75, '2019-09-07', 282, NULL),
('Residence Inn', 75, '2019-09-08', 352, NULL),
('Residence Inn', 75, '2019-09-09', 170, NULL),
('Residence Inn', 75, '2019-09-10', 155, NULL),
('Residence Inn', 75, '2019-09-11', 233, NULL),
('Residence Inn', 75, '2019-09-12', 231, NULL),
('Residence Inn', 75, '2019-09-13', 220, NULL),
('Residence Inn', 75, '2019-09-14', 120, NULL),
('Residence Inn', 75, '2019-09-15', 174, NULL),
('Residence Inn', 75, '2019-09-16', 344, NULL),
('Residence Inn', 75, '2019-09-17', 205, NULL),
('Residence Inn', 75, '2019-09-18', 103, NULL),
('Residence Inn', 75, '2019-09-19', 352, NULL),
('Residence Inn', 75, '2019-09-20', 117, NULL),
('Residence Inn', 75, '2019-09-21', 199, NULL),
('Residence Inn', 75, '2019-09-22', 308, NULL),
('Residence Inn', 75, '2019-09-23', 328, NULL),
('Residence Inn', 75, '2019-09-24', 332, NULL),
('Residence Inn', 75, '2019-09-25', 233, NULL),
('Residence Inn', 75, '2019-09-26', 177, NULL),
('Residence Inn', 75, '2019-09-27', 308, NULL),
('Residence Inn', 75, '2019-09-28', 215, NULL),
('Residence Inn', 75, '2019-09-29', 105, NULL),
('Residence Inn', 75, '2019-09-30', 227, NULL),
('Residence Inn', 75, '2019-10-01', 198, NULL),
('Residence Inn', 75, '2019-10-02', 116, NULL),
('Residence Inn', 75, '2019-10-03', 216, NULL),
('Residence Inn', 75, '2019-10-04', 278, NULL),
('Residence Inn', 75, '2019-10-05', 212, NULL),
('Residence Inn', 75, '2019-10-06', 278, NULL),
('Residence Inn', 75, '2019-10-07', 204, NULL),
('Residence Inn', 75, '2019-10-08', 330, NULL),
('Residence Inn', 75, '2019-10-09', 322, NULL),
('Residence Inn', 75, '2019-10-10', 102, NULL),
('Residence Inn', 75, '2019-10-11', 235, NULL),
('Residence Inn', 75, '2019-10-12', 380, NULL),
('Residence Inn', 75, '2019-10-13', 391, NULL),
('Residence Inn', 75, '2019-10-14', 349, NULL),
('Residence Inn', 75, '2019-10-15', 283, NULL),
('Residence Inn', 75, '2019-10-16', 232, NULL),
('Residence Inn', 75, '2019-10-17', 156, NULL),
('Residence Inn', 75, '2019-10-18', 141, NULL),
('Residence Inn', 75, '2019-10-19', 224, NULL),
('Residence Inn', 75, '2019-10-20', 390, NULL),
('Residence Inn', 75, '2019-10-21', 351, NULL),
('Residence Inn', 75, '2019-10-22', 107, NULL),
('Residence Inn', 75, '2019-10-23', 148, NULL),
('Residence Inn', 75, '2019-10-24', 276, NULL),
('Residence Inn', 75, '2019-10-25', 129, NULL),
('Residence Inn', 75, '2019-10-26', 315, NULL),
('Residence Inn', 75, '2019-10-27', 379, NULL),
('Residence Inn', 75, '2019-10-28', 150, NULL),
('Residence Inn', 75, '2019-10-29', 132, NULL),
('Residence Inn', 75, '2019-10-30', 140, NULL),
('Residence Inn', 75, '2019-10-31', 301, NULL),
('Residence Inn', 75, '2019-11-01', 274, NULL),
('Residence Inn', 75, '2019-11-02', 323, NULL),
('Residence Inn', 75, '2019-11-03', 395, NULL),
('Residence Inn', 75, '2019-11-04', 191, NULL),
('Residence Inn', 75, '2019-11-05', 107, NULL),
('Residence Inn', 75, '2019-11-06', 251, NULL),
('Residence Inn', 75, '2019-11-07', 237, NULL),
('Residence Inn', 75, '2019-11-08', 256, NULL),
('Residence Inn', 75, '2019-11-09', 319, NULL),
('Residence Inn', 75, '2019-11-10', 135, NULL),
('Residence Inn', 75, '2019-11-11', 230, NULL),
('Residence Inn', 75, '2019-11-12', 337, NULL),
('Residence Inn', 75, '2019-11-13', 398, NULL),
('Residence Inn', 75, '2019-11-14', 278, NULL),
('Residence Inn', 75, '2019-11-15', 167, NULL),
('Residence Inn', 75, '2019-11-16', 126, NULL),
('Residence Inn', 75, '2019-11-17', 283, NULL),
('Residence Inn', 75, '2019-11-18', 232, NULL),
('Residence Inn', 75, '2019-11-19', 234, NULL),
('Residence Inn', 75, '2019-11-20', 363, NULL),
('Residence Inn', 75, '2019-11-21', 220, NULL),
('Residence Inn', 75, '2019-11-22', 399, NULL),
('Residence Inn', 75, '2019-11-23', 236, NULL),
('Residence Inn', 75, '2019-11-24', 114, NULL),
('Residence Inn', 75, '2019-11-25', 165, NULL),
('Residence Inn', 75, '2019-11-26', 172, NULL),
('Residence Inn', 75, '2019-11-27', 341, NULL),
('Residence Inn', 75, '2019-11-28', 132, NULL),
('Residence Inn', 75, '2019-11-29', 340, NULL),
('Residence Inn', 75, '2019-11-30', 205, NULL),
('Residence Inn', 75, '2019-12-01', 311, NULL),
('Residence Inn', 75, '2019-12-02', 325, NULL),
('Residence Inn', 75, '2019-12-03', 216, NULL),
('Residence Inn', 75, '2019-12-04', 160, NULL),
('Residence Inn', 75, '2019-12-05', 382, NULL),
('Residence Inn', 75, '2019-12-06', 371, NULL),
('Residence Inn', 75, '2019-12-07', 273, NULL),
('Residence Inn', 75, '2019-12-08', 343, NULL),
('Residence Inn', 75, '2019-12-09', 170, NULL),
('Residence Inn', 75, '2019-12-10', 171, NULL),
('Residence Inn', 75, '2019-12-11', 370, NULL),
('Residence Inn', 75, '2019-12-12', 342, NULL),
('Residence Inn', 75, '2019-12-13', 162, NULL),
('Residence Inn', 75, '2019-12-14', 162, NULL),
('Residence Inn', 75, '2019-12-15', 236, NULL),
('Residence Inn', 75, '2019-12-16', 171, NULL),
('Residence Inn', 75, '2019-12-17', 281, NULL),
('Residence Inn', 75, '2019-12-18', 237, NULL),
('Residence Inn', 75, '2019-12-19', 370, NULL),
('Residence Inn', 75, '2019-12-20', 124, NULL),
('Residence Inn', 75, '2019-12-21', 241, NULL),
('Residence Inn', 75, '2019-12-22', 383, NULL),
('Residence Inn', 75, '2019-12-23', 139, NULL),
('Residence Inn', 75, '2019-12-24', 390, NULL),
('Residence Inn', 75, '2019-12-25', 278, NULL),
('Residence Inn', 75, '2019-12-26', 328, NULL),
('Residence Inn', 75, '2019-12-27', 142, NULL),
('Residence Inn', 75, '2019-12-28', 187, NULL),
('Residence Inn', 75, '2019-12-29', 297, NULL),
('Residence Inn', 75, '2019-12-30', 193, NULL),
('Residence Inn', 75, '2019-12-31', 144, NULL),
('Residence Inn', 75, '2020-01-01', 239, NULL),
('Residence Inn', 75, '2020-01-02', 307, NULL),
('Residence Inn', 75, '2020-01-03', 212, NULL),
('Residence Inn', 75, '2020-01-04', 119, NULL),
('Residence Inn', 75, '2020-01-05', 328, NULL),
('Residence Inn', 75, '2020-01-06', 219, NULL),
('Residence Inn', 75, '2020-01-07', 292, NULL),
('Residence Inn', 75, '2020-01-08', 341, NULL),
('Residence Inn', 75, '2020-01-09', 394, NULL),
('Residence Inn', 75, '2020-01-10', 256, NULL),
('Residence Inn', 75, '2020-01-11', 395, NULL),
('Residence Inn', 75, '2020-01-12', 358, NULL),
('Residence Inn', 75, '2020-01-13', 220, NULL),
('Residence Inn', 75, '2020-01-14', 319, NULL),
('Residence Inn', 75, '2020-01-15', 304, NULL),
('Residence Inn', 75, '2020-01-16', 296, NULL),
('Residence Inn', 75, '2020-01-17', 104, NULL),
('Residence Inn', 75, '2020-01-18', 175, NULL),
('Residence Inn', 75, '2020-01-19', 120, NULL),
('Residence Inn', 75, '2020-01-20', 376, NULL),
('Residence Inn', 75, '2020-01-21', 125, NULL),
('Residence Inn', 75, '2020-01-22', 127, NULL),
('Residence Inn', 75, '2020-01-23', 149, NULL),
('Residence Inn', 75, '2020-01-24', 202, NULL),
('Residence Inn', 75, '2020-01-25', 193, NULL),
('Residence Inn', 75, '2020-01-26', 317, NULL),
('Residence Inn', 75, '2020-01-27', 131, NULL),
('Residence Inn', 75, '2020-01-28', 262, NULL),
('Residence Inn', 75, '2020-01-29', 103, NULL),
('Residence Inn', 75, '2020-01-30', 328, NULL),
('Residence Inn', 75, '2020-01-31', 371, NULL),
('Residence Inn', 75, '2020-02-01', 182, NULL),
('Residence Inn', 75, '2020-02-02', 207, NULL),
('Residence Inn', 75, '2020-02-03', 151, NULL),
('Residence Inn', 75, '2020-02-04', 326, NULL),
('Residence Inn', 96, '2019-01-01', 367, NULL),
('Residence Inn', 96, '2019-01-02', 378, NULL),
('Residence Inn', 96, '2019-01-03', 361, NULL),
('Residence Inn', 96, '2019-01-04', 273, NULL),
('Residence Inn', 96, '2019-01-05', 151, NULL),
('Residence Inn', 96, '2019-01-06', 320, NULL),
('Residence Inn', 96, '2019-01-07', 115, NULL),
('Residence Inn', 96, '2019-01-08', 152, NULL),
('Residence Inn', 96, '2019-01-09', 269, NULL),
('Residence Inn', 96, '2019-01-10', 274, NULL),
('Residence Inn', 96, '2019-01-11', 107, NULL),
('Residence Inn', 96, '2019-01-12', 138, NULL),
('Residence Inn', 96, '2019-01-13', 147, NULL),
('Residence Inn', 96, '2019-01-14', 227, NULL),
('Residence Inn', 96, '2019-01-15', 197, NULL),
('Residence Inn', 96, '2019-01-16', 310, NULL),
('Residence Inn', 96, '2019-01-17', 142, NULL),
('Residence Inn', 96, '2019-01-18', 301, NULL),
('Residence Inn', 96, '2019-01-19', 223, NULL),
('Residence Inn', 96, '2019-01-20', 258, NULL),
('Residence Inn', 96, '2019-01-21', 354, NULL),
('Residence Inn', 96, '2019-01-22', 399, NULL),
('Residence Inn', 96, '2019-01-23', 377, NULL),
('Residence Inn', 96, '2019-01-24', 394, NULL),
('Residence Inn', 96, '2019-01-25', 360, NULL),
('Residence Inn', 96, '2019-01-26', 228, NULL),
('Residence Inn', 96, '2019-01-27', 228, NULL),
('Residence Inn', 96, '2019-01-28', 227, NULL),
('Residence Inn', 96, '2019-01-29', 371, NULL),
('Residence Inn', 96, '2019-01-30', 375, NULL),
('Residence Inn', 96, '2019-01-31', 292, NULL),
('Residence Inn', 96, '2019-02-01', 107, NULL),
('Residence Inn', 96, '2019-02-02', 225, NULL),
('Residence Inn', 96, '2019-02-03', 166, NULL),
('Residence Inn', 96, '2019-02-04', 191, NULL),
('Residence Inn', 96, '2019-02-05', 215, NULL),
('Residence Inn', 96, '2019-02-06', 308, NULL),
('Residence Inn', 96, '2019-02-07', 261, NULL),
('Residence Inn', 96, '2019-02-08', 231, NULL),
('Residence Inn', 96, '2019-02-09', 171, NULL),
('Residence Inn', 96, '2019-02-10', 163, NULL),
('Residence Inn', 96, '2019-02-11', 153, NULL),
('Residence Inn', 96, '2019-02-12', 365, NULL),
('Residence Inn', 96, '2019-02-13', 203, NULL),
('Residence Inn', 96, '2019-02-14', 275, NULL),
('Residence Inn', 96, '2019-02-15', 182, NULL),
('Residence Inn', 96, '2019-02-16', 120, NULL),
('Residence Inn', 96, '2019-02-17', 387, NULL),
('Residence Inn', 96, '2019-02-18', 222, NULL),
('Residence Inn', 96, '2019-02-19', 327, NULL),
('Residence Inn', 96, '2019-02-20', 381, NULL),
('Residence Inn', 96, '2019-02-21', 110, NULL),
('Residence Inn', 96, '2019-02-22', 338, NULL),
('Residence Inn', 96, '2019-02-23', 157, NULL),
('Residence Inn', 96, '2019-02-24', 171, NULL),
('Residence Inn', 96, '2019-02-25', 357, NULL),
('Residence Inn', 96, '2019-02-26', 372, NULL),
('Residence Inn', 96, '2019-02-27', 121, NULL),
('Residence Inn', 96, '2019-02-28', 258, NULL),
('Residence Inn', 96, '2019-03-01', 267, NULL),
('Residence Inn', 96, '2019-03-02', 389, NULL),
('Residence Inn', 96, '2019-03-03', 251, NULL),
('Residence Inn', 96, '2019-03-04', 209, NULL),
('Residence Inn', 96, '2019-03-05', 140, NULL),
('Residence Inn', 96, '2019-03-06', 234, NULL),
('Residence Inn', 96, '2019-03-07', 394, NULL),
('Residence Inn', 96, '2019-03-08', 219, NULL),
('Residence Inn', 96, '2019-03-09', 203, NULL),
('Residence Inn', 96, '2019-03-10', 273, NULL),
('Residence Inn', 96, '2019-03-11', 265, NULL),
('Residence Inn', 96, '2019-03-12', 102, NULL),
('Residence Inn', 96, '2019-03-13', 127, NULL),
('Residence Inn', 96, '2019-03-14', 196, NULL),
('Residence Inn', 96, '2019-03-15', 235, NULL),
('Residence Inn', 96, '2019-03-16', 168, NULL),
('Residence Inn', 96, '2019-03-17', 281, NULL),
('Residence Inn', 96, '2019-03-18', 256, NULL),
('Residence Inn', 96, '2019-03-19', 121, NULL),
('Residence Inn', 96, '2019-03-20', 370, NULL),
('Residence Inn', 96, '2019-03-21', 291, NULL),
('Residence Inn', 96, '2019-03-22', 223, NULL),
('Residence Inn', 96, '2019-03-23', 243, NULL),
('Residence Inn', 96, '2019-03-24', 391, NULL),
('Residence Inn', 96, '2019-03-25', 372, NULL),
('Residence Inn', 96, '2019-03-26', 101, NULL),
('Residence Inn', 96, '2019-03-27', 294, NULL),
('Residence Inn', 96, '2019-03-28', 362, NULL),
('Residence Inn', 96, '2019-03-29', 262, NULL),
('Residence Inn', 96, '2019-03-30', 169, NULL),
('Residence Inn', 96, '2019-03-31', 180, NULL),
('Residence Inn', 96, '2019-04-01', 132, NULL),
('Residence Inn', 96, '2019-04-02', 286, NULL),
('Residence Inn', 96, '2019-04-03', 311, NULL),
('Residence Inn', 96, '2019-04-04', 220, NULL),
('Residence Inn', 96, '2019-04-05', 127, NULL),
('Residence Inn', 96, '2019-04-06', 256, NULL),
('Residence Inn', 96, '2019-04-07', 343, NULL),
('Residence Inn', 96, '2019-04-08', 104, NULL),
('Residence Inn', 96, '2019-04-09', 368, NULL),
('Residence Inn', 96, '2019-04-10', 276, NULL),
('Residence Inn', 96, '2019-04-11', 220, NULL),
('Residence Inn', 96, '2019-04-12', 381, NULL),
('Residence Inn', 96, '2019-04-13', 353, NULL),
('Residence Inn', 96, '2019-04-14', 382, NULL),
('Residence Inn', 96, '2019-04-15', 187, NULL),
('Residence Inn', 96, '2019-04-16', 292, NULL),
('Residence Inn', 96, '2019-04-17', 198, NULL),
('Residence Inn', 96, '2019-04-18', 338, NULL),
('Residence Inn', 96, '2019-04-19', 196, NULL),
('Residence Inn', 96, '2019-04-20', 246, NULL),
('Residence Inn', 96, '2019-04-21', 204, NULL),
('Residence Inn', 96, '2019-04-22', 217, NULL),
('Residence Inn', 96, '2019-04-23', 213, NULL),
('Residence Inn', 96, '2019-04-24', 379, NULL),
('Residence Inn', 96, '2019-04-25', 368, NULL),
('Residence Inn', 96, '2019-04-26', 255, NULL),
('Residence Inn', 96, '2019-04-27', 315, NULL),
('Residence Inn', 96, '2019-04-28', 395, NULL),
('Residence Inn', 96, '2019-04-29', 277, NULL),
('Residence Inn', 96, '2019-04-30', 335, NULL),
('Residence Inn', 96, '2019-05-01', 303, NULL),
('Residence Inn', 96, '2019-05-02', 183, NULL),
('Residence Inn', 96, '2019-05-03', 187, NULL),
('Residence Inn', 96, '2019-05-04', 181, NULL),
('Residence Inn', 96, '2019-05-05', 160, NULL),
('Residence Inn', 96, '2019-05-06', 332, NULL),
('Residence Inn', 96, '2019-05-07', 227, NULL),
('Residence Inn', 96, '2019-05-08', 169, NULL),
('Residence Inn', 96, '2019-05-09', 364, NULL),
('Residence Inn', 96, '2019-05-10', 117, NULL),
('Residence Inn', 96, '2019-05-11', 360, NULL),
('Residence Inn', 96, '2019-05-12', 287, NULL),
('Residence Inn', 96, '2019-05-13', 218, NULL),
('Residence Inn', 96, '2019-05-14', 382, NULL),
('Residence Inn', 96, '2019-05-15', 375, NULL),
('Residence Inn', 96, '2019-05-16', 265, NULL),
('Residence Inn', 96, '2019-05-17', 343, NULL),
('Residence Inn', 96, '2019-05-18', 339, NULL),
('Residence Inn', 96, '2019-05-19', 352, NULL),
('Residence Inn', 96, '2019-05-20', 263, NULL),
('Residence Inn', 96, '2019-05-21', 356, NULL),
('Residence Inn', 96, '2019-05-22', 302, NULL),
('Residence Inn', 96, '2019-05-23', 111, NULL),
('Residence Inn', 96, '2019-05-24', 190, NULL),
('Residence Inn', 96, '2019-05-25', 393, NULL),
('Residence Inn', 96, '2019-05-26', 284, NULL),
('Residence Inn', 96, '2019-05-27', 238, NULL),
('Residence Inn', 96, '2019-05-28', 303, NULL),
('Residence Inn', 96, '2019-05-29', 306, NULL),
('Residence Inn', 96, '2019-05-30', 360, NULL),
('Residence Inn', 96, '2019-05-31', 297, NULL),
('Residence Inn', 96, '2019-06-01', 110, NULL),
('Residence Inn', 96, '2019-06-02', 185, NULL),
('Residence Inn', 96, '2019-06-03', 254, NULL),
('Residence Inn', 96, '2019-06-04', 286, NULL),
('Residence Inn', 96, '2019-06-05', 375, NULL),
('Residence Inn', 96, '2019-06-06', 300, NULL),
('Residence Inn', 96, '2019-06-07', 210, NULL),
('Residence Inn', 96, '2019-06-08', 184, NULL),
('Residence Inn', 96, '2019-06-09', 257, NULL),
('Residence Inn', 96, '2019-06-10', 161, NULL),
('Residence Inn', 96, '2019-06-11', 357, NULL),
('Residence Inn', 96, '2019-06-12', 107, NULL),
('Residence Inn', 96, '2019-06-13', 194, NULL),
('Residence Inn', 96, '2019-06-14', 326, NULL),
('Residence Inn', 96, '2019-06-15', 108, NULL),
('Residence Inn', 96, '2019-06-16', 158, NULL),
('Residence Inn', 96, '2019-06-17', 358, NULL),
('Residence Inn', 96, '2019-06-18', 355, NULL),
('Residence Inn', 96, '2019-06-19', 141, NULL),
('Residence Inn', 96, '2019-06-20', 118, NULL),
('Residence Inn', 96, '2019-06-21', 316, NULL),
('Residence Inn', 96, '2019-06-22', 307, NULL),
('Residence Inn', 96, '2019-06-23', 149, NULL),
('Residence Inn', 96, '2019-06-24', 255, NULL),
('Residence Inn', 96, '2019-06-25', 203, NULL),
('Residence Inn', 96, '2019-06-26', 169, NULL),
('Residence Inn', 96, '2019-06-27', 124, NULL),
('Residence Inn', 96, '2019-06-28', 375, NULL),
('Residence Inn', 96, '2019-06-29', 184, NULL),
('Residence Inn', 96, '2019-06-30', 242, NULL),
('Residence Inn', 96, '2019-07-01', 347, NULL),
('Residence Inn', 96, '2019-07-02', 340, NULL),
('Residence Inn', 96, '2019-07-03', 132, NULL),
('Residence Inn', 96, '2019-07-04', 349, NULL),
('Residence Inn', 96, '2019-07-05', 390, NULL),
('Residence Inn', 96, '2019-07-06', 248, NULL),
('Residence Inn', 96, '2019-07-07', 134, NULL),
('Residence Inn', 96, '2019-07-08', 227, NULL),
('Residence Inn', 96, '2019-07-09', 237, NULL),
('Residence Inn', 96, '2019-07-10', 242, NULL),
('Residence Inn', 96, '2019-07-11', 336, NULL),
('Residence Inn', 96, '2019-07-12', 392, NULL),
('Residence Inn', 96, '2019-07-13', 189, NULL),
('Residence Inn', 96, '2019-07-14', 263, NULL),
('Residence Inn', 96, '2019-07-15', 308, NULL),
('Residence Inn', 96, '2019-07-16', 141, NULL),
('Residence Inn', 96, '2019-07-17', 172, NULL),
('Residence Inn', 96, '2019-07-18', 373, NULL),
('Residence Inn', 96, '2019-07-19', 278, NULL),
('Residence Inn', 96, '2019-07-20', 272, NULL),
('Residence Inn', 96, '2019-07-21', 337, NULL),
('Residence Inn', 96, '2019-07-22', 215, NULL),
('Residence Inn', 96, '2019-07-23', 358, NULL),
('Residence Inn', 96, '2019-07-24', 140, NULL),
('Residence Inn', 96, '2019-07-25', 336, NULL),
('Residence Inn', 96, '2019-07-26', 228, NULL),
('Residence Inn', 96, '2019-07-27', 150, NULL),
('Residence Inn', 96, '2019-07-28', 395, NULL),
('Residence Inn', 96, '2019-07-29', 217, NULL),
('Residence Inn', 96, '2019-07-30', 103, NULL),
('Residence Inn', 96, '2019-07-31', 318, NULL),
('Residence Inn', 96, '2019-08-01', 218, NULL),
('Residence Inn', 96, '2019-08-02', 106, NULL),
('Residence Inn', 96, '2019-08-03', 174, NULL),
('Residence Inn', 96, '2019-08-04', 163, NULL),
('Residence Inn', 96, '2019-08-05', 260, NULL),
('Residence Inn', 96, '2019-08-06', 150, NULL),
('Residence Inn', 96, '2019-08-07', 125, NULL),
('Residence Inn', 96, '2019-08-08', 113, NULL),
('Residence Inn', 96, '2019-08-09', 331, NULL),
('Residence Inn', 96, '2019-08-10', 203, NULL),
('Residence Inn', 96, '2019-08-11', 359, NULL),
('Residence Inn', 96, '2019-08-12', 118, NULL),
('Residence Inn', 96, '2019-08-13', 159, NULL),
('Residence Inn', 96, '2019-08-14', 375, NULL),
('Residence Inn', 96, '2019-08-15', 223, NULL),
('Residence Inn', 96, '2019-08-16', 388, NULL),
('Residence Inn', 96, '2019-08-17', 133, NULL),
('Residence Inn', 96, '2019-08-18', 378, NULL),
('Residence Inn', 96, '2019-08-19', 232, NULL),
('Residence Inn', 96, '2019-08-20', 258, NULL),
('Residence Inn', 96, '2019-08-21', 365, NULL),
('Residence Inn', 96, '2019-08-22', 386, NULL),
('Residence Inn', 96, '2019-08-23', 373, NULL),
('Residence Inn', 96, '2019-08-24', 257, NULL),
('Residence Inn', 96, '2019-08-25', 345, NULL),
('Residence Inn', 96, '2019-08-26', 310, NULL),
('Residence Inn', 96, '2019-08-27', 113, NULL),
('Residence Inn', 96, '2019-08-28', 296, NULL),
('Residence Inn', 96, '2019-08-29', 321, NULL),
('Residence Inn', 96, '2019-08-30', 300, NULL),
('Residence Inn', 96, '2019-08-31', 163, NULL),
('Residence Inn', 96, '2019-09-01', 263, NULL),
('Residence Inn', 96, '2019-09-02', 385, NULL),
('Residence Inn', 96, '2019-09-03', 304, NULL),
('Residence Inn', 96, '2019-09-04', 105, NULL),
('Residence Inn', 96, '2019-09-05', 243, NULL),
('Residence Inn', 96, '2019-09-06', 292, NULL),
('Residence Inn', 96, '2019-09-07', 171, NULL),
('Residence Inn', 96, '2019-09-08', 102, NULL),
('Residence Inn', 96, '2019-09-09', 318, NULL),
('Residence Inn', 96, '2019-09-10', 214, NULL),
('Residence Inn', 96, '2019-09-11', 210, NULL),
('Residence Inn', 96, '2019-09-12', 391, NULL),
('Residence Inn', 96, '2019-09-13', 270, NULL),
('Residence Inn', 96, '2019-09-14', 168, NULL),
('Residence Inn', 96, '2019-09-15', 163, NULL),
('Residence Inn', 96, '2019-09-16', 193, NULL),
('Residence Inn', 96, '2019-09-17', 186, NULL),
('Residence Inn', 96, '2019-09-18', 354, NULL),
('Residence Inn', 96, '2019-09-19', 264, NULL),
('Residence Inn', 96, '2019-09-20', 225, NULL),
('Residence Inn', 96, '2019-09-21', 208, NULL),
('Residence Inn', 96, '2019-09-22', 123, NULL),
('Residence Inn', 96, '2019-09-23', 307, NULL),
('Residence Inn', 96, '2019-09-24', 346, NULL),
('Residence Inn', 96, '2019-09-25', 270, NULL),
('Residence Inn', 96, '2019-09-26', 371, NULL),
('Residence Inn', 96, '2019-09-27', 286, NULL),
('Residence Inn', 96, '2019-09-28', 310, NULL),
('Residence Inn', 96, '2019-09-29', 304, NULL),
('Residence Inn', 96, '2019-09-30', 384, NULL),
('Residence Inn', 96, '2019-10-01', 395, NULL),
('Residence Inn', 96, '2019-10-02', 224, NULL),
('Residence Inn', 96, '2019-10-03', 108, NULL),
('Residence Inn', 96, '2019-10-04', 354, NULL),
('Residence Inn', 96, '2019-10-05', 127, NULL),
('Residence Inn', 96, '2019-10-06', 184, NULL),
('Residence Inn', 96, '2019-10-07', 262, NULL),
('Residence Inn', 96, '2019-10-08', 365, NULL),
('Residence Inn', 96, '2019-10-09', 187, NULL),
('Residence Inn', 96, '2019-10-10', 364, NULL),
('Residence Inn', 96, '2019-10-11', 336, NULL),
('Residence Inn', 96, '2019-10-12', 136, NULL),
('Residence Inn', 96, '2019-10-13', 272, NULL),
('Residence Inn', 96, '2019-10-14', 361, NULL),
('Residence Inn', 96, '2019-10-15', 186, NULL),
('Residence Inn', 96, '2019-10-16', 100, NULL),
('Residence Inn', 96, '2019-10-17', 131, NULL),
('Residence Inn', 96, '2019-10-18', 288, NULL),
('Residence Inn', 96, '2019-10-19', 115, NULL),
('Residence Inn', 96, '2019-10-20', 324, NULL),
('Residence Inn', 96, '2019-10-21', 155, NULL),
('Residence Inn', 96, '2019-10-22', 192, NULL),
('Residence Inn', 96, '2019-10-23', 266, NULL),
('Residence Inn', 96, '2019-10-24', 255, NULL),
('Residence Inn', 96, '2019-10-25', 383, NULL),
('Residence Inn', 96, '2019-10-26', 117, NULL),
('Residence Inn', 96, '2019-10-27', 129, NULL),
('Residence Inn', 96, '2019-10-28', 170, NULL),
('Residence Inn', 96, '2019-10-29', 285, NULL),
('Residence Inn', 96, '2019-10-30', 168, NULL),
('Residence Inn', 96, '2019-10-31', 318, NULL),
('Residence Inn', 96, '2019-11-01', 382, NULL),
('Residence Inn', 96, '2019-11-02', 224, NULL),
('Residence Inn', 96, '2019-11-03', 301, NULL),
('Residence Inn', 96, '2019-11-04', 154, NULL),
('Residence Inn', 96, '2019-11-05', 349, NULL),
('Residence Inn', 96, '2019-11-06', 102, NULL),
('Residence Inn', 96, '2019-11-07', 307, NULL),
('Residence Inn', 96, '2019-11-08', 378, NULL),
('Residence Inn', 96, '2019-11-09', 244, NULL),
('Residence Inn', 96, '2019-11-10', 301, NULL),
('Residence Inn', 96, '2019-11-11', 245, NULL),
('Residence Inn', 96, '2019-11-12', 136, NULL),
('Residence Inn', 96, '2019-11-13', 352, NULL),
('Residence Inn', 96, '2019-11-14', 166, NULL),
('Residence Inn', 96, '2019-11-15', 339, NULL),
('Residence Inn', 96, '2019-11-16', 250, NULL),
('Residence Inn', 96, '2019-11-17', 185, NULL),
('Residence Inn', 96, '2019-11-18', 335, NULL),
('Residence Inn', 96, '2019-11-19', 281, NULL),
('Residence Inn', 96, '2019-11-20', 244, NULL),
('Residence Inn', 96, '2019-11-21', 331, NULL),
('Residence Inn', 96, '2019-11-22', 353, NULL),
('Residence Inn', 96, '2019-11-23', 368, NULL),
('Residence Inn', 96, '2019-11-24', 170, NULL),
('Residence Inn', 96, '2019-11-25', 161, NULL),
('Residence Inn', 96, '2019-11-26', 116, NULL),
('Residence Inn', 96, '2019-11-27', 170, NULL),
('Residence Inn', 96, '2019-11-28', 245, NULL),
('Residence Inn', 96, '2019-11-29', 202, NULL),
('Residence Inn', 96, '2019-11-30', 114, NULL),
('Residence Inn', 96, '2019-12-01', 251, NULL),
('Residence Inn', 96, '2019-12-02', 234, NULL),
('Residence Inn', 96, '2019-12-03', 195, NULL),
('Residence Inn', 96, '2019-12-04', 390, NULL),
('Residence Inn', 96, '2019-12-05', 108, NULL),
('Residence Inn', 96, '2019-12-06', 139, NULL),
('Residence Inn', 96, '2019-12-07', 328, NULL),
('Residence Inn', 96, '2019-12-08', 356, NULL),
('Residence Inn', 96, '2019-12-09', 346, NULL),
('Residence Inn', 96, '2019-12-10', 133, NULL),
('Residence Inn', 96, '2019-12-11', 114, NULL),
('Residence Inn', 96, '2019-12-12', 262, NULL),
('Residence Inn', 96, '2019-12-13', 390, NULL),
('Residence Inn', 96, '2019-12-14', 319, NULL),
('Residence Inn', 96, '2019-12-15', 162, NULL),
('Residence Inn', 96, '2019-12-16', 198, NULL),
('Residence Inn', 96, '2019-12-17', 196, NULL),
('Residence Inn', 96, '2019-12-18', 253, NULL),
('Residence Inn', 96, '2019-12-19', 358, NULL),
('Residence Inn', 96, '2019-12-20', 140, NULL),
('Residence Inn', 96, '2019-12-21', 339, NULL),
('Residence Inn', 96, '2019-12-22', 185, NULL),
('Residence Inn', 96, '2019-12-23', 223, NULL),
('Residence Inn', 96, '2019-12-24', 370, NULL),
('Residence Inn', 96, '2019-12-25', 130, NULL),
('Residence Inn', 96, '2019-12-26', 197, NULL),
('Residence Inn', 96, '2019-12-27', 116, NULL),
('Residence Inn', 96, '2019-12-28', 319, NULL),
('Residence Inn', 96, '2019-12-29', 151, NULL),
('Residence Inn', 96, '2019-12-30', 155, NULL),
('Residence Inn', 96, '2019-12-31', 209, NULL),
('Residence Inn', 96, '2020-01-01', 287, NULL),
('Residence Inn', 96, '2020-01-02', 282, NULL),
('Residence Inn', 96, '2020-01-03', 199, NULL),
('Residence Inn', 96, '2020-01-04', 112, NULL),
('Residence Inn', 96, '2020-01-05', 373, NULL),
('Residence Inn', 96, '2020-01-06', 204, NULL),
('Residence Inn', 96, '2020-01-07', 183, NULL),
('Residence Inn', 96, '2020-01-08', 334, NULL),
('Residence Inn', 96, '2020-01-09', 249, NULL),
('Residence Inn', 96, '2020-01-10', 128, NULL),
('Residence Inn', 96, '2020-01-11', 132, NULL),
('Residence Inn', 96, '2020-01-12', 155, NULL),
('Residence Inn', 96, '2020-01-13', 288, NULL),
('Residence Inn', 96, '2020-01-14', 346, NULL),
('Residence Inn', 96, '2020-01-15', 354, NULL),
('Residence Inn', 96, '2020-01-16', 145, NULL),
('Residence Inn', 96, '2020-01-17', 214, NULL),
('Residence Inn', 96, '2020-01-18', 272, NULL),
('Residence Inn', 96, '2020-01-19', 351, NULL),
('Residence Inn', 96, '2020-01-20', 368, NULL),
('Residence Inn', 96, '2020-01-21', 194, NULL),
('Residence Inn', 96, '2020-01-22', 258, NULL),
('Residence Inn', 96, '2020-01-23', 132, NULL),
('Residence Inn', 96, '2020-01-24', 102, NULL),
('Residence Inn', 96, '2020-01-25', 221, NULL),
('Residence Inn', 96, '2020-01-26', 215, NULL),
('Residence Inn', 96, '2020-01-27', 341, NULL),
('Residence Inn', 96, '2020-01-28', 365, NULL),
('Residence Inn', 96, '2020-01-29', 129, NULL),
('Residence Inn', 96, '2020-01-30', 232, NULL),
('Residence Inn', 96, '2020-01-31', 364, NULL),
('Residence Inn', 96, '2020-02-01', 399, NULL),
('Residence Inn', 96, '2020-02-02', 226, NULL),
('Residence Inn', 96, '2020-02-03', 328, NULL),
('Residence Inn', 96, '2020-02-04', 399, NULL),
('Residence Inn', 118, '2019-01-01', 395, NULL),
('Residence Inn', 118, '2019-01-02', 210, NULL),
('Residence Inn', 118, '2019-01-03', 277, NULL),
('Residence Inn', 118, '2019-01-04', 105, NULL),
('Residence Inn', 118, '2019-01-05', 143, NULL),
('Residence Inn', 118, '2019-01-06', 170, NULL),
('Residence Inn', 118, '2019-01-07', 115, NULL),
('Residence Inn', 118, '2019-01-08', 223, NULL),
('Residence Inn', 118, '2019-01-09', 391, NULL),
('Residence Inn', 118, '2019-01-10', 360, NULL),
('Residence Inn', 118, '2019-01-11', 135, NULL),
('Residence Inn', 118, '2019-01-12', 138, NULL),
('Residence Inn', 118, '2019-01-13', 300, NULL),
('Residence Inn', 118, '2019-01-14', 138, NULL),
('Residence Inn', 118, '2019-01-15', 301, NULL),
('Residence Inn', 118, '2019-01-16', 240, NULL),
('Residence Inn', 118, '2019-01-17', 373, NULL),
('Residence Inn', 118, '2019-01-18', 104, NULL),
('Residence Inn', 118, '2019-01-19', 178, NULL),
('Residence Inn', 118, '2019-01-20', 195, NULL),
('Residence Inn', 118, '2019-01-21', 354, NULL),
('Residence Inn', 118, '2019-01-22', 329, NULL),
('Residence Inn', 118, '2019-01-23', 195, NULL),
('Residence Inn', 118, '2019-01-24', 237, NULL),
('Residence Inn', 118, '2019-01-25', 385, NULL),
('Residence Inn', 118, '2019-01-26', 210, NULL),
('Residence Inn', 118, '2019-01-27', 254, NULL),
('Residence Inn', 118, '2019-01-28', 193, NULL),
('Residence Inn', 118, '2019-01-29', 205, NULL),
('Residence Inn', 118, '2019-01-30', 347, NULL),
('Residence Inn', 118, '2019-01-31', 214, NULL),
('Residence Inn', 118, '2019-02-01', 302, NULL),
('Residence Inn', 118, '2019-02-02', 244, NULL),
('Residence Inn', 118, '2019-02-03', 355, NULL),
('Residence Inn', 118, '2019-02-04', 162, NULL),
('Residence Inn', 118, '2019-02-05', 232, NULL),
('Residence Inn', 118, '2019-02-06', 339, NULL),
('Residence Inn', 118, '2019-02-07', 256, NULL),
('Residence Inn', 118, '2019-02-08', 376, NULL),
('Residence Inn', 118, '2019-02-09', 187, NULL),
('Residence Inn', 118, '2019-02-10', 140, NULL),
('Residence Inn', 118, '2019-02-11', 251, NULL),
('Residence Inn', 118, '2019-02-12', 229, NULL),
('Residence Inn', 118, '2019-02-13', 104, NULL),
('Residence Inn', 118, '2019-02-14', 311, NULL),
('Residence Inn', 118, '2019-02-15', 228, NULL),
('Residence Inn', 118, '2019-02-16', 110, NULL),
('Residence Inn', 118, '2019-02-17', 302, NULL),
('Residence Inn', 118, '2019-02-18', 378, NULL),
('Residence Inn', 118, '2019-02-19', 103, NULL),
('Residence Inn', 118, '2019-02-20', 338, NULL),
('Residence Inn', 118, '2019-02-21', 272, NULL),
('Residence Inn', 118, '2019-02-22', 357, NULL),
('Residence Inn', 118, '2019-02-23', 128, NULL),
('Residence Inn', 118, '2019-02-24', 215, NULL),
('Residence Inn', 118, '2019-02-25', 298, NULL),
('Residence Inn', 118, '2019-02-26', 342, NULL),
('Residence Inn', 118, '2019-02-27', 115, NULL),
('Residence Inn', 118, '2019-02-28', 207, NULL),
('Residence Inn', 118, '2019-03-01', 362, NULL),
('Residence Inn', 118, '2019-03-02', 352, NULL),
('Residence Inn', 118, '2019-03-03', 229, NULL),
('Residence Inn', 118, '2019-03-04', 324, NULL),
('Residence Inn', 118, '2019-03-05', 252, NULL),
('Residence Inn', 118, '2019-03-06', 198, NULL),
('Residence Inn', 118, '2019-03-07', 130, NULL),
('Residence Inn', 118, '2019-03-08', 232, NULL),
('Residence Inn', 118, '2019-03-09', 227, NULL),
('Residence Inn', 118, '2019-03-10', 187, NULL),
('Residence Inn', 118, '2019-03-11', 383, NULL),
('Residence Inn', 118, '2019-03-12', 255, NULL),
('Residence Inn', 118, '2019-03-13', 182, NULL),
('Residence Inn', 118, '2019-03-14', 340, NULL),
('Residence Inn', 118, '2019-03-15', 141, NULL),
('Residence Inn', 118, '2019-03-16', 328, NULL),
('Residence Inn', 118, '2019-03-17', 390, NULL),
('Residence Inn', 118, '2019-03-18', 164, NULL),
('Residence Inn', 118, '2019-03-19', 142, NULL),
('Residence Inn', 118, '2019-03-20', 184, NULL),
('Residence Inn', 118, '2019-03-21', 156, NULL),
('Residence Inn', 118, '2019-03-22', 394, NULL),
('Residence Inn', 118, '2019-03-23', 110, NULL),
('Residence Inn', 118, '2019-03-24', 392, NULL),
('Residence Inn', 118, '2019-03-25', 175, NULL),
('Residence Inn', 118, '2019-03-26', 236, NULL),
('Residence Inn', 118, '2019-03-27', 334, NULL),
('Residence Inn', 118, '2019-03-28', 387, NULL),
('Residence Inn', 118, '2019-03-29', 169, NULL),
('Residence Inn', 118, '2019-03-30', 382, NULL),
('Residence Inn', 118, '2019-03-31', 238, NULL),
('Residence Inn', 118, '2019-04-01', 198, NULL),
('Residence Inn', 118, '2019-04-02', 303, NULL),
('Residence Inn', 118, '2019-04-03', 368, NULL),
('Residence Inn', 118, '2019-04-04', 175, NULL),
('Residence Inn', 118, '2019-04-05', 301, NULL),
('Residence Inn', 118, '2019-04-06', 356, NULL),
('Residence Inn', 118, '2019-04-07', 222, NULL),
('Residence Inn', 118, '2019-04-08', 176, NULL),
('Residence Inn', 118, '2019-04-09', 276, NULL),
('Residence Inn', 118, '2019-04-10', 200, NULL),
('Residence Inn', 118, '2019-04-11', 189, NULL),
('Residence Inn', 118, '2019-04-12', 303, NULL),
('Residence Inn', 118, '2019-04-13', 298, NULL),
('Residence Inn', 118, '2019-04-14', 351, NULL),
('Residence Inn', 118, '2019-04-15', 186, NULL),
('Residence Inn', 118, '2019-04-16', 208, NULL),
('Residence Inn', 118, '2019-04-17', 172, NULL),
('Residence Inn', 118, '2019-04-18', 148, NULL),
('Residence Inn', 118, '2019-04-19', 206, NULL),
('Residence Inn', 118, '2019-04-20', 232, NULL),
('Residence Inn', 118, '2019-04-21', 224, NULL),
('Residence Inn', 118, '2019-04-22', 204, NULL),
('Residence Inn', 118, '2019-04-23', 103, NULL),
('Residence Inn', 118, '2019-04-24', 391, NULL),
('Residence Inn', 118, '2019-04-25', 233, NULL),
('Residence Inn', 118, '2019-04-26', 148, NULL),
('Residence Inn', 118, '2019-04-27', 383, NULL),
('Residence Inn', 118, '2019-04-28', 192, NULL),
('Residence Inn', 118, '2019-04-29', 361, NULL),
('Residence Inn', 118, '2019-04-30', 132, NULL),
('Residence Inn', 118, '2019-05-01', 240, NULL),
('Residence Inn', 118, '2019-05-02', 321, NULL),
('Residence Inn', 118, '2019-05-03', 150, NULL),
('Residence Inn', 118, '2019-05-04', 272, NULL),
('Residence Inn', 118, '2019-05-05', 176, NULL),
('Residence Inn', 118, '2019-05-06', 275, NULL),
('Residence Inn', 118, '2019-05-07', 306, NULL),
('Residence Inn', 118, '2019-05-08', 257, NULL),
('Residence Inn', 118, '2019-05-09', 214, NULL),
('Residence Inn', 118, '2019-05-10', 173, NULL),
('Residence Inn', 118, '2019-05-11', 311, NULL),
('Residence Inn', 118, '2019-05-12', 274, NULL),
('Residence Inn', 118, '2019-05-13', 205, NULL),
('Residence Inn', 118, '2019-05-14', 354, NULL),
('Residence Inn', 118, '2019-05-15', 255, NULL),
('Residence Inn', 118, '2019-05-16', 383, NULL),
('Residence Inn', 118, '2019-05-17', 217, NULL),
('Residence Inn', 118, '2019-05-18', 344, NULL),
('Residence Inn', 118, '2019-05-19', 395, NULL),
('Residence Inn', 118, '2019-05-20', 158, NULL),
('Residence Inn', 118, '2019-05-21', 319, NULL),
('Residence Inn', 118, '2019-05-22', 175, NULL),
('Residence Inn', 118, '2019-05-23', 317, NULL),
('Residence Inn', 118, '2019-05-24', 366, NULL),
('Residence Inn', 118, '2019-05-25', 367, NULL),
('Residence Inn', 118, '2019-05-26', 201, NULL),
('Residence Inn', 118, '2019-05-27', 228, NULL),
('Residence Inn', 118, '2019-05-28', 211, NULL),
('Residence Inn', 118, '2019-05-29', 247, NULL),
('Residence Inn', 118, '2019-05-30', 395, NULL),
('Residence Inn', 118, '2019-05-31', 234, NULL),
('Residence Inn', 118, '2019-06-01', 249, NULL),
('Residence Inn', 118, '2019-06-02', 187, NULL),
('Residence Inn', 118, '2019-06-03', 368, NULL),
('Residence Inn', 118, '2019-06-04', 174, NULL),
('Residence Inn', 118, '2019-06-05', 110, NULL),
('Residence Inn', 118, '2019-06-06', 128, NULL),
('Residence Inn', 118, '2019-06-07', 347, NULL),
('Residence Inn', 118, '2019-06-08', 316, NULL),
('Residence Inn', 118, '2019-06-09', 190, NULL),
('Residence Inn', 118, '2019-06-10', 249, NULL),
('Residence Inn', 118, '2019-06-11', 149, NULL),
('Residence Inn', 118, '2019-06-12', 217, NULL),
('Residence Inn', 118, '2019-06-13', 160, NULL),
('Residence Inn', 118, '2019-06-14', 113, NULL),
('Residence Inn', 118, '2019-06-15', 124, NULL),
('Residence Inn', 118, '2019-06-16', 267, NULL),
('Residence Inn', 118, '2019-06-17', 292, NULL),
('Residence Inn', 118, '2019-06-18', 363, NULL),
('Residence Inn', 118, '2019-06-19', 323, NULL),
('Residence Inn', 118, '2019-06-20', 136, NULL),
('Residence Inn', 118, '2019-06-21', 284, NULL),
('Residence Inn', 118, '2019-06-22', 307, NULL),
('Residence Inn', 118, '2019-06-23', 312, NULL),
('Residence Inn', 118, '2019-06-24', 334, NULL),
('Residence Inn', 118, '2019-06-25', 315, NULL),
('Residence Inn', 118, '2019-06-26', 140, NULL),
('Residence Inn', 118, '2019-06-27', 288, NULL),
('Residence Inn', 118, '2019-06-28', 111, NULL),
('Residence Inn', 118, '2019-06-29', 212, NULL),
('Residence Inn', 118, '2019-06-30', 158, NULL),
('Residence Inn', 118, '2019-07-01', 182, NULL),
('Residence Inn', 118, '2019-07-02', 269, NULL),
('Residence Inn', 118, '2019-07-03', 223, NULL),
('Residence Inn', 118, '2019-07-04', 182, NULL),
('Residence Inn', 118, '2019-07-05', 206, NULL),
('Residence Inn', 118, '2019-07-06', 202, NULL),
('Residence Inn', 118, '2019-07-07', 144, NULL),
('Residence Inn', 118, '2019-07-08', 128, NULL),
('Residence Inn', 118, '2019-07-09', 233, NULL),
('Residence Inn', 118, '2019-07-10', 120, NULL),
('Residence Inn', 118, '2019-07-11', 278, NULL),
('Residence Inn', 118, '2019-07-12', 287, NULL),
('Residence Inn', 118, '2019-07-13', 238, NULL),
('Residence Inn', 118, '2019-07-14', 325, NULL),
('Residence Inn', 118, '2019-07-15', 138, NULL),
('Residence Inn', 118, '2019-07-16', 184, NULL),
('Residence Inn', 118, '2019-07-17', 361, NULL),
('Residence Inn', 118, '2019-07-18', 381, NULL),
('Residence Inn', 118, '2019-07-19', 218, NULL),
('Residence Inn', 118, '2019-07-20', 253, NULL),
('Residence Inn', 118, '2019-07-21', 276, NULL),
('Residence Inn', 118, '2019-07-22', 109, NULL),
('Residence Inn', 118, '2019-07-23', 120, NULL),
('Residence Inn', 118, '2019-07-24', 168, NULL),
('Residence Inn', 118, '2019-07-25', 279, NULL),
('Residence Inn', 118, '2019-07-26', 377, NULL),
('Residence Inn', 118, '2019-07-27', 243, NULL),
('Residence Inn', 118, '2019-07-28', 212, NULL),
('Residence Inn', 118, '2019-07-29', 175, NULL),
('Residence Inn', 118, '2019-07-30', 180, NULL),
('Residence Inn', 118, '2019-07-31', 149, NULL),
('Residence Inn', 118, '2019-08-01', 268, NULL),
('Residence Inn', 118, '2019-08-02', 377, NULL),
('Residence Inn', 118, '2019-08-03', 153, NULL),
('Residence Inn', 118, '2019-08-04', 305, NULL),
('Residence Inn', 118, '2019-08-05', 230, NULL),
('Residence Inn', 118, '2019-08-06', 114, NULL),
('Residence Inn', 118, '2019-08-07', 223, NULL),
('Residence Inn', 118, '2019-08-08', 124, NULL),
('Residence Inn', 118, '2019-08-09', 212, NULL),
('Residence Inn', 118, '2019-08-10', 127, NULL),
('Residence Inn', 118, '2019-08-11', 256, NULL),
('Residence Inn', 118, '2019-08-12', 303, NULL),
('Residence Inn', 118, '2019-08-13', 343, NULL),
('Residence Inn', 118, '2019-08-14', 197, NULL),
('Residence Inn', 118, '2019-08-15', 157, NULL),
('Residence Inn', 118, '2019-08-16', 138, NULL),
('Residence Inn', 118, '2019-08-17', 205, NULL),
('Residence Inn', 118, '2019-08-18', 223, NULL),
('Residence Inn', 118, '2019-08-19', 175, NULL),
('Residence Inn', 118, '2019-08-20', 338, NULL),
('Residence Inn', 118, '2019-08-21', 399, NULL),
('Residence Inn', 118, '2019-08-22', 316, NULL),
('Residence Inn', 118, '2019-08-23', 227, NULL),
('Residence Inn', 118, '2019-08-24', 344, NULL),
('Residence Inn', 118, '2019-08-25', 311, NULL),
('Residence Inn', 118, '2019-08-26', 277, NULL),
('Residence Inn', 118, '2019-08-27', 223, NULL),
('Residence Inn', 118, '2019-08-28', 391, NULL),
('Residence Inn', 118, '2019-08-29', 324, NULL),
('Residence Inn', 118, '2019-08-30', 164, NULL),
('Residence Inn', 118, '2019-08-31', 311, NULL),
('Residence Inn', 118, '2019-09-01', 222, NULL),
('Residence Inn', 118, '2019-09-02', 350, NULL),
('Residence Inn', 118, '2019-09-03', 342, NULL),
('Residence Inn', 118, '2019-09-04', 321, NULL),
('Residence Inn', 118, '2019-09-05', 324, NULL),
('Residence Inn', 118, '2019-09-06', 208, NULL),
('Residence Inn', 118, '2019-09-07', 209, NULL),
('Residence Inn', 118, '2019-09-08', 254, NULL),
('Residence Inn', 118, '2019-09-09', 382, NULL),
('Residence Inn', 118, '2019-09-10', 203, NULL),
('Residence Inn', 118, '2019-09-11', 252, NULL),
('Residence Inn', 118, '2019-09-12', 263, NULL),
('Residence Inn', 118, '2019-09-13', 287, NULL),
('Residence Inn', 118, '2019-09-14', 380, NULL),
('Residence Inn', 118, '2019-09-15', 196, NULL),
('Residence Inn', 118, '2019-09-16', 136, NULL),
('Residence Inn', 118, '2019-09-17', 213, NULL),
('Residence Inn', 118, '2019-09-18', 160, NULL),
('Residence Inn', 118, '2019-09-19', 166, NULL),
('Residence Inn', 118, '2019-09-20', 378, NULL),
('Residence Inn', 118, '2019-09-21', 343, NULL),
('Residence Inn', 118, '2019-09-22', 190, NULL),
('Residence Inn', 118, '2019-09-23', 150, NULL),
('Residence Inn', 118, '2019-09-24', 336, NULL),
('Residence Inn', 118, '2019-09-25', 253, NULL),
('Residence Inn', 118, '2019-09-26', 327, NULL),
('Residence Inn', 118, '2019-09-27', 105, NULL),
('Residence Inn', 118, '2019-09-28', 205, NULL),
('Residence Inn', 118, '2019-09-29', 207, NULL),
('Residence Inn', 118, '2019-09-30', 237, NULL),
('Residence Inn', 118, '2019-10-01', 384, NULL),
('Residence Inn', 118, '2019-10-02', 375, NULL),
('Residence Inn', 118, '2019-10-03', 396, NULL),
('Residence Inn', 118, '2019-10-04', 237, NULL),
('Residence Inn', 118, '2019-10-05', 202, NULL),
('Residence Inn', 118, '2019-10-06', 286, NULL),
('Residence Inn', 118, '2019-10-07', 298, NULL),
('Residence Inn', 118, '2019-10-08', 134, NULL),
('Residence Inn', 118, '2019-10-09', 169, NULL),
('Residence Inn', 118, '2019-10-10', 216, NULL),
('Residence Inn', 118, '2019-10-11', 274, NULL),
('Residence Inn', 118, '2019-10-12', 340, NULL),
('Residence Inn', 118, '2019-10-13', 387, NULL),
('Residence Inn', 118, '2019-10-14', 360, NULL),
('Residence Inn', 118, '2019-10-15', 282, NULL),
('Residence Inn', 118, '2019-10-16', 304, NULL),
('Residence Inn', 118, '2019-10-17', 387, NULL),
('Residence Inn', 118, '2019-10-18', 318, NULL),
('Residence Inn', 118, '2019-10-19', 105, NULL),
('Residence Inn', 118, '2019-10-20', 347, NULL),
('Residence Inn', 118, '2019-10-21', 223, NULL),
('Residence Inn', 118, '2019-10-22', 241, NULL),
('Residence Inn', 118, '2019-10-23', 188, NULL),
('Residence Inn', 118, '2019-10-24', 347, NULL),
('Residence Inn', 118, '2019-10-25', 228, NULL),
('Residence Inn', 118, '2019-10-26', 139, NULL),
('Residence Inn', 118, '2019-10-27', 308, NULL),
('Residence Inn', 118, '2019-10-28', 299, NULL),
('Residence Inn', 118, '2019-10-29', 330, NULL),
('Residence Inn', 118, '2019-10-30', 318, NULL),
('Residence Inn', 118, '2019-10-31', 287, NULL),
('Residence Inn', 118, '2019-11-01', 388, NULL),
('Residence Inn', 118, '2019-11-02', 350, NULL),
('Residence Inn', 118, '2019-11-03', 219, NULL),
('Residence Inn', 118, '2019-11-04', 398, NULL),
('Residence Inn', 118, '2019-11-05', 125, NULL),
('Residence Inn', 118, '2019-11-06', 260, NULL),
('Residence Inn', 118, '2019-11-07', 124, NULL),
('Residence Inn', 118, '2019-11-08', 123, NULL),
('Residence Inn', 118, '2019-11-09', 160, NULL),
('Residence Inn', 118, '2019-11-10', 103, NULL),
('Residence Inn', 118, '2019-11-11', 136, NULL),
('Residence Inn', 118, '2019-11-12', 168, NULL),
('Residence Inn', 118, '2019-11-13', 167, NULL),
('Residence Inn', 118, '2019-11-14', 194, NULL),
('Residence Inn', 118, '2019-11-15', 195, NULL),
('Residence Inn', 118, '2019-11-16', 174, NULL),
('Residence Inn', 118, '2019-11-17', 276, NULL),
('Residence Inn', 118, '2019-11-18', 279, NULL),
('Residence Inn', 118, '2019-11-19', 303, NULL),
('Residence Inn', 118, '2019-11-20', 332, NULL),
('Residence Inn', 118, '2019-11-21', 294, NULL),
('Residence Inn', 118, '2019-11-22', 165, NULL),
('Residence Inn', 118, '2019-11-23', 133, NULL),
('Residence Inn', 118, '2019-11-24', 108, NULL),
('Residence Inn', 118, '2019-11-25', 212, NULL),
('Residence Inn', 118, '2019-11-26', 263, NULL),
('Residence Inn', 118, '2019-11-27', 327, NULL),
('Residence Inn', 118, '2019-11-28', 129, NULL),
('Residence Inn', 118, '2019-11-29', 189, NULL),
('Residence Inn', 118, '2019-11-30', 155, NULL),
('Residence Inn', 118, '2019-12-01', 225, NULL),
('Residence Inn', 118, '2019-12-02', 398, NULL),
('Residence Inn', 118, '2019-12-03', 225, NULL),
('Residence Inn', 118, '2019-12-04', 171, NULL),
('Residence Inn', 118, '2019-12-05', 196, NULL),
('Residence Inn', 118, '2019-12-06', 380, NULL),
('Residence Inn', 118, '2019-12-07', 121, NULL),
('Residence Inn', 118, '2019-12-08', 353, NULL),
('Residence Inn', 118, '2019-12-09', 221, NULL),
('Residence Inn', 118, '2019-12-10', 350, NULL),
('Residence Inn', 118, '2019-12-11', 263, NULL),
('Residence Inn', 118, '2019-12-12', 187, NULL),
('Residence Inn', 118, '2019-12-13', 164, NULL),
('Residence Inn', 118, '2019-12-14', 111, NULL),
('Residence Inn', 118, '2019-12-15', 303, NULL),
('Residence Inn', 118, '2019-12-16', 378, NULL),
('Residence Inn', 118, '2019-12-17', 339, NULL),
('Residence Inn', 118, '2019-12-18', 157, NULL),
('Residence Inn', 118, '2019-12-19', 279, NULL),
('Residence Inn', 118, '2019-12-20', 228, NULL),
('Residence Inn', 118, '2019-12-21', 274, NULL),
('Residence Inn', 118, '2019-12-22', 277, NULL),
('Residence Inn', 118, '2019-12-23', 295, NULL),
('Residence Inn', 118, '2019-12-24', 282, NULL),
('Residence Inn', 118, '2019-12-25', 318, NULL),
('Residence Inn', 118, '2019-12-26', 201, NULL),
('Residence Inn', 118, '2019-12-27', 357, NULL),
('Residence Inn', 118, '2019-12-28', 334, NULL),
('Residence Inn', 118, '2019-12-29', 363, NULL),
('Residence Inn', 118, '2019-12-30', 395, NULL),
('Residence Inn', 118, '2019-12-31', 215, NULL),
('Residence Inn', 118, '2020-01-01', 316, NULL),
('Residence Inn', 118, '2020-01-02', 391, NULL),
('Residence Inn', 118, '2020-01-03', 260, NULL),
('Residence Inn', 118, '2020-01-04', 103, NULL),
('Residence Inn', 118, '2020-01-05', 183, NULL),
('Residence Inn', 118, '2020-01-06', 266, NULL),
('Residence Inn', 118, '2020-01-07', 241, NULL),
('Residence Inn', 118, '2020-01-08', 247, NULL),
('Residence Inn', 118, '2020-01-09', 264, NULL),
('Residence Inn', 118, '2020-01-10', 376, NULL),
('Residence Inn', 118, '2020-01-11', 276, NULL),
('Residence Inn', 118, '2020-01-12', 201, NULL),
('Residence Inn', 118, '2020-01-13', 382, NULL),
('Residence Inn', 118, '2020-01-14', 371, NULL),
('Residence Inn', 118, '2020-01-15', 158, NULL),
('Residence Inn', 118, '2020-01-16', 338, NULL),
('Residence Inn', 118, '2020-01-17', 359, NULL),
('Residence Inn', 118, '2020-01-18', 137, NULL),
('Residence Inn', 118, '2020-01-19', 397, NULL),
('Residence Inn', 118, '2020-01-20', 315, NULL),
('Residence Inn', 118, '2020-01-21', 195, NULL),
('Residence Inn', 118, '2020-01-22', 209, NULL),
('Residence Inn', 118, '2020-01-23', 111, NULL),
('Residence Inn', 118, '2020-01-24', 107, NULL),
('Residence Inn', 118, '2020-01-25', 127, NULL),
('Residence Inn', 118, '2020-01-26', 324, NULL),
('Residence Inn', 118, '2020-01-27', 310, NULL),
('Residence Inn', 118, '2020-01-28', 342, NULL),
('Residence Inn', 118, '2020-01-29', 234, NULL),
('Residence Inn', 118, '2020-01-30', 375, NULL),
('Residence Inn', 118, '2020-01-31', 306, NULL),
('Residence Inn', 118, '2020-02-01', 149, NULL),
('Residence Inn', 118, '2020-02-02', 108, NULL),
('Residence Inn', 118, '2020-02-03', 188, NULL),
('Residence Inn', 118, '2020-02-04', 315, NULL),
('Residence Inn', 120, '2019-01-01', 175, NULL),
('Residence Inn', 120, '2019-01-02', 120, NULL),
('Residence Inn', 120, '2019-01-03', 204, NULL),
('Residence Inn', 120, '2019-01-04', 204, NULL),
('Residence Inn', 120, '2019-01-05', 160, NULL),
('Residence Inn', 120, '2019-01-06', 392, NULL),
('Residence Inn', 120, '2019-01-07', 131, NULL),
('Residence Inn', 120, '2019-01-08', 259, NULL),
('Residence Inn', 120, '2019-01-09', 148, NULL),
('Residence Inn', 120, '2019-01-10', 276, NULL),
('Residence Inn', 120, '2019-01-11', 256, NULL),
('Residence Inn', 120, '2019-01-12', 177, NULL),
('Residence Inn', 120, '2019-01-13', 358, NULL),
('Residence Inn', 120, '2019-01-14', 212, NULL),
('Residence Inn', 120, '2019-01-15', 213, NULL),
('Residence Inn', 120, '2019-01-16', 170, NULL),
('Residence Inn', 120, '2019-01-17', 138, NULL),
('Residence Inn', 120, '2019-01-18', 119, NULL),
('Residence Inn', 120, '2019-01-19', 123, NULL),
('Residence Inn', 120, '2019-01-20', 102, NULL),
('Residence Inn', 120, '2019-01-21', 308, NULL),
('Residence Inn', 120, '2019-01-22', 349, NULL),
('Residence Inn', 120, '2019-01-23', 346, NULL),
('Residence Inn', 120, '2019-01-24', 202, NULL),
('Residence Inn', 120, '2019-01-25', 146, NULL),
('Residence Inn', 120, '2019-01-26', 267, NULL),
('Residence Inn', 120, '2019-01-27', 189, NULL),
('Residence Inn', 120, '2019-01-28', 184, NULL),
('Residence Inn', 120, '2019-01-29', 113, NULL),
('Residence Inn', 120, '2019-01-30', 211, NULL),
('Residence Inn', 120, '2019-01-31', 392, NULL),
('Residence Inn', 120, '2019-02-01', 190, NULL),
('Residence Inn', 120, '2019-02-02', 144, NULL),
('Residence Inn', 120, '2019-02-03', 278, NULL),
('Residence Inn', 120, '2019-02-04', 140, NULL),
('Residence Inn', 120, '2019-02-05', 117, NULL),
('Residence Inn', 120, '2019-02-06', 370, NULL),
('Residence Inn', 120, '2019-02-07', 396, NULL),
('Residence Inn', 120, '2019-02-08', 185, NULL),
('Residence Inn', 120, '2019-02-09', 323, NULL),
('Residence Inn', 120, '2019-02-10', 109, NULL),
('Residence Inn', 120, '2019-02-11', 397, NULL),
('Residence Inn', 120, '2019-02-12', 250, NULL),
('Residence Inn', 120, '2019-02-13', 113, NULL),
('Residence Inn', 120, '2019-02-14', 330, NULL),
('Residence Inn', 120, '2019-02-15', 194, NULL),
('Residence Inn', 120, '2019-02-16', 391, NULL),
('Residence Inn', 120, '2019-02-17', 250, NULL),
('Residence Inn', 120, '2019-02-18', 224, NULL),
('Residence Inn', 120, '2019-02-19', 337, NULL),
('Residence Inn', 120, '2019-02-20', 150, NULL),
('Residence Inn', 120, '2019-02-21', 333, NULL),
('Residence Inn', 120, '2019-02-22', 371, NULL),
('Residence Inn', 120, '2019-02-23', 367, NULL),
('Residence Inn', 120, '2019-02-24', 161, NULL),
('Residence Inn', 120, '2019-02-25', 322, NULL),
('Residence Inn', 120, '2019-02-26', 194, NULL),
('Residence Inn', 120, '2019-02-27', 114, NULL),
('Residence Inn', 120, '2019-02-28', 161, NULL),
('Residence Inn', 120, '2019-03-01', 307, NULL),
('Residence Inn', 120, '2019-03-02', 193, NULL),
('Residence Inn', 120, '2019-03-03', 291, NULL),
('Residence Inn', 120, '2019-03-04', 296, NULL),
('Residence Inn', 120, '2019-03-05', 141, NULL),
('Residence Inn', 120, '2019-03-06', 188, NULL),
('Residence Inn', 120, '2019-03-07', 270, NULL),
('Residence Inn', 120, '2019-03-08', 104, NULL),
('Residence Inn', 120, '2019-03-09', 128, NULL),
('Residence Inn', 120, '2019-03-10', 317, NULL),
('Residence Inn', 120, '2019-03-11', 118, NULL),
('Residence Inn', 120, '2019-03-12', 269, NULL),
('Residence Inn', 120, '2019-03-13', 129, NULL),
('Residence Inn', 120, '2019-03-14', 113, NULL),
('Residence Inn', 120, '2019-03-15', 200, NULL),
('Residence Inn', 120, '2019-03-16', 137, NULL),
('Residence Inn', 120, '2019-03-17', 106, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 120, '2019-03-18', 255, NULL),
('Residence Inn', 120, '2019-03-19', 251, NULL),
('Residence Inn', 120, '2019-03-20', 309, NULL),
('Residence Inn', 120, '2019-03-21', 104, NULL),
('Residence Inn', 120, '2019-03-22', 300, NULL),
('Residence Inn', 120, '2019-03-23', 322, NULL),
('Residence Inn', 120, '2019-03-24', 388, NULL),
('Residence Inn', 120, '2019-03-25', 257, NULL),
('Residence Inn', 120, '2019-03-26', 180, NULL),
('Residence Inn', 120, '2019-03-27', 388, NULL),
('Residence Inn', 120, '2019-03-28', 153, NULL),
('Residence Inn', 120, '2019-03-29', 261, NULL),
('Residence Inn', 120, '2019-03-30', 106, NULL),
('Residence Inn', 120, '2019-03-31', 247, NULL),
('Residence Inn', 120, '2019-04-01', 193, NULL),
('Residence Inn', 120, '2019-04-02', 257, NULL),
('Residence Inn', 120, '2019-04-03', 208, NULL),
('Residence Inn', 120, '2019-04-04', 116, NULL),
('Residence Inn', 120, '2019-04-05', 127, NULL),
('Residence Inn', 120, '2019-04-06', 310, NULL),
('Residence Inn', 120, '2019-04-07', 282, NULL),
('Residence Inn', 120, '2019-04-08', 169, NULL),
('Residence Inn', 120, '2019-04-09', 180, NULL),
('Residence Inn', 120, '2019-04-10', 373, NULL),
('Residence Inn', 120, '2019-04-11', 185, NULL),
('Residence Inn', 120, '2019-04-12', 271, NULL),
('Residence Inn', 120, '2019-04-13', 329, NULL),
('Residence Inn', 120, '2019-04-14', 212, NULL),
('Residence Inn', 120, '2019-04-15', 267, NULL),
('Residence Inn', 120, '2019-04-16', 366, NULL),
('Residence Inn', 120, '2019-04-17', 166, NULL),
('Residence Inn', 120, '2019-04-18', 228, NULL),
('Residence Inn', 120, '2019-04-19', 342, NULL),
('Residence Inn', 120, '2019-04-20', 324, NULL),
('Residence Inn', 120, '2019-04-21', 109, NULL),
('Residence Inn', 120, '2019-04-22', 269, NULL),
('Residence Inn', 120, '2019-04-23', 377, NULL),
('Residence Inn', 120, '2019-04-24', 120, NULL),
('Residence Inn', 120, '2019-04-25', 259, NULL),
('Residence Inn', 120, '2019-04-26', 179, NULL),
('Residence Inn', 120, '2019-04-27', 270, NULL),
('Residence Inn', 120, '2019-04-28', 275, NULL),
('Residence Inn', 120, '2019-04-29', 274, NULL),
('Residence Inn', 120, '2019-04-30', 154, NULL),
('Residence Inn', 120, '2019-05-01', 193, NULL),
('Residence Inn', 120, '2019-05-02', 356, NULL),
('Residence Inn', 120, '2019-05-03', 388, NULL),
('Residence Inn', 120, '2019-05-04', 117, NULL),
('Residence Inn', 120, '2019-05-05', 302, NULL),
('Residence Inn', 120, '2019-05-06', 279, NULL),
('Residence Inn', 120, '2019-05-07', 148, NULL),
('Residence Inn', 120, '2019-05-08', 379, NULL),
('Residence Inn', 120, '2019-05-09', 179, NULL),
('Residence Inn', 120, '2019-05-10', 113, NULL),
('Residence Inn', 120, '2019-05-11', 376, NULL),
('Residence Inn', 120, '2019-05-12', 110, NULL),
('Residence Inn', 120, '2019-05-13', 273, NULL),
('Residence Inn', 120, '2019-05-14', 226, NULL),
('Residence Inn', 120, '2019-05-15', 348, NULL),
('Residence Inn', 120, '2019-05-16', 123, NULL),
('Residence Inn', 120, '2019-05-17', 259, NULL),
('Residence Inn', 120, '2019-05-18', 301, NULL),
('Residence Inn', 120, '2019-05-19', 217, NULL),
('Residence Inn', 120, '2019-05-20', 199, NULL),
('Residence Inn', 120, '2019-05-21', 130, NULL),
('Residence Inn', 120, '2019-05-22', 168, NULL),
('Residence Inn', 120, '2019-05-23', 252, NULL),
('Residence Inn', 120, '2019-05-24', 260, NULL),
('Residence Inn', 120, '2019-05-25', 255, NULL),
('Residence Inn', 120, '2019-05-26', 352, NULL),
('Residence Inn', 120, '2019-05-27', 329, NULL),
('Residence Inn', 120, '2019-05-28', 348, NULL),
('Residence Inn', 120, '2019-05-29', 218, NULL),
('Residence Inn', 120, '2019-05-30', 196, NULL),
('Residence Inn', 120, '2019-05-31', 178, NULL),
('Residence Inn', 120, '2019-06-01', 217, NULL),
('Residence Inn', 120, '2019-06-02', 281, NULL),
('Residence Inn', 120, '2019-06-03', 377, NULL),
('Residence Inn', 120, '2019-06-04', 214, NULL),
('Residence Inn', 120, '2019-06-05', 224, NULL),
('Residence Inn', 120, '2019-06-06', 241, NULL),
('Residence Inn', 120, '2019-06-07', 109, NULL),
('Residence Inn', 120, '2019-06-08', 329, NULL),
('Residence Inn', 120, '2019-06-09', 380, NULL),
('Residence Inn', 120, '2019-06-10', 363, NULL),
('Residence Inn', 120, '2019-06-11', 174, NULL),
('Residence Inn', 120, '2019-06-12', 361, NULL),
('Residence Inn', 120, '2019-06-13', 116, NULL),
('Residence Inn', 120, '2019-06-14', 387, NULL),
('Residence Inn', 120, '2019-06-15', 197, NULL),
('Residence Inn', 120, '2019-06-16', 160, NULL),
('Residence Inn', 120, '2019-06-17', 285, NULL),
('Residence Inn', 120, '2019-06-18', 350, NULL),
('Residence Inn', 120, '2019-06-19', 196, NULL),
('Residence Inn', 120, '2019-06-20', 226, NULL),
('Residence Inn', 120, '2019-06-21', 372, NULL),
('Residence Inn', 120, '2019-06-22', 216, NULL),
('Residence Inn', 120, '2019-06-23', 114, NULL),
('Residence Inn', 120, '2019-06-24', 209, NULL),
('Residence Inn', 120, '2019-06-25', 267, NULL),
('Residence Inn', 120, '2019-06-26', 395, NULL),
('Residence Inn', 120, '2019-06-27', 369, NULL),
('Residence Inn', 120, '2019-06-28', 234, NULL),
('Residence Inn', 120, '2019-06-29', 107, NULL),
('Residence Inn', 120, '2019-06-30', 264, NULL),
('Residence Inn', 120, '2019-07-01', 370, NULL),
('Residence Inn', 120, '2019-07-02', 222, NULL),
('Residence Inn', 120, '2019-07-03', 319, NULL),
('Residence Inn', 120, '2019-07-04', 365, NULL),
('Residence Inn', 120, '2019-07-05', 363, NULL),
('Residence Inn', 120, '2019-07-06', 166, NULL),
('Residence Inn', 120, '2019-07-07', 217, NULL),
('Residence Inn', 120, '2019-07-08', 158, NULL),
('Residence Inn', 120, '2019-07-09', 357, NULL),
('Residence Inn', 120, '2019-07-10', 377, NULL),
('Residence Inn', 120, '2019-07-11', 283, NULL),
('Residence Inn', 120, '2019-07-12', 158, NULL),
('Residence Inn', 120, '2019-07-13', 221, NULL),
('Residence Inn', 120, '2019-07-14', 136, NULL),
('Residence Inn', 120, '2019-07-15', 269, NULL),
('Residence Inn', 120, '2019-07-16', 399, NULL),
('Residence Inn', 120, '2019-07-17', 287, NULL),
('Residence Inn', 120, '2019-07-18', 385, NULL),
('Residence Inn', 120, '2019-07-19', 154, NULL),
('Residence Inn', 120, '2019-07-20', 347, NULL),
('Residence Inn', 120, '2019-07-21', 270, NULL),
('Residence Inn', 120, '2019-07-22', 399, NULL),
('Residence Inn', 120, '2019-07-23', 323, NULL),
('Residence Inn', 120, '2019-07-24', 323, NULL),
('Residence Inn', 120, '2019-07-25', 284, NULL),
('Residence Inn', 120, '2019-07-26', 203, NULL),
('Residence Inn', 120, '2019-07-27', 367, NULL),
('Residence Inn', 120, '2019-07-28', 374, NULL),
('Residence Inn', 120, '2019-07-29', 126, NULL),
('Residence Inn', 120, '2019-07-30', 191, NULL),
('Residence Inn', 120, '2019-07-31', 293, NULL),
('Residence Inn', 120, '2019-08-01', 288, NULL),
('Residence Inn', 120, '2019-08-02', 269, NULL),
('Residence Inn', 120, '2019-08-03', 143, NULL),
('Residence Inn', 120, '2019-08-04', 339, NULL),
('Residence Inn', 120, '2019-08-05', 271, NULL),
('Residence Inn', 120, '2019-08-06', 319, NULL),
('Residence Inn', 120, '2019-08-07', 337, NULL),
('Residence Inn', 120, '2019-08-08', 180, NULL),
('Residence Inn', 120, '2019-08-09', 267, NULL),
('Residence Inn', 120, '2019-08-10', 224, NULL),
('Residence Inn', 120, '2019-08-11', 104, NULL),
('Residence Inn', 120, '2019-08-12', 165, NULL),
('Residence Inn', 120, '2019-08-13', 238, NULL),
('Residence Inn', 120, '2019-08-14', 363, NULL),
('Residence Inn', 120, '2019-08-15', 316, NULL),
('Residence Inn', 120, '2019-08-16', 328, NULL),
('Residence Inn', 120, '2019-08-17', 227, NULL),
('Residence Inn', 120, '2019-08-18', 181, NULL),
('Residence Inn', 120, '2019-08-19', 382, NULL),
('Residence Inn', 120, '2019-08-20', 219, NULL),
('Residence Inn', 120, '2019-08-21', 200, NULL),
('Residence Inn', 120, '2019-08-22', 325, NULL),
('Residence Inn', 120, '2019-08-23', 216, NULL),
('Residence Inn', 120, '2019-08-24', 251, NULL),
('Residence Inn', 120, '2019-08-25', 123, NULL),
('Residence Inn', 120, '2019-08-26', 353, NULL),
('Residence Inn', 120, '2019-08-27', 375, NULL),
('Residence Inn', 120, '2019-08-28', 367, NULL),
('Residence Inn', 120, '2019-08-29', 257, NULL),
('Residence Inn', 120, '2019-08-30', 122, NULL),
('Residence Inn', 120, '2019-08-31', 368, NULL),
('Residence Inn', 120, '2019-09-01', 221, NULL),
('Residence Inn', 120, '2019-09-02', 196, NULL),
('Residence Inn', 120, '2019-09-03', 100, NULL),
('Residence Inn', 120, '2019-09-04', 290, NULL),
('Residence Inn', 120, '2019-09-05', 188, NULL),
('Residence Inn', 120, '2019-09-06', 363, NULL),
('Residence Inn', 120, '2019-09-07', 130, NULL),
('Residence Inn', 120, '2019-09-08', 266, NULL),
('Residence Inn', 120, '2019-09-09', 253, NULL),
('Residence Inn', 120, '2019-09-10', 276, NULL),
('Residence Inn', 120, '2019-09-11', 228, NULL),
('Residence Inn', 120, '2019-09-12', 341, NULL),
('Residence Inn', 120, '2019-09-13', 228, NULL),
('Residence Inn', 120, '2019-09-14', 397, NULL),
('Residence Inn', 120, '2019-09-15', 389, NULL),
('Residence Inn', 120, '2019-09-16', 300, NULL),
('Residence Inn', 120, '2019-09-17', 109, NULL),
('Residence Inn', 120, '2019-09-18', 239, NULL),
('Residence Inn', 120, '2019-09-19', 236, NULL),
('Residence Inn', 120, '2019-09-20', 212, NULL),
('Residence Inn', 120, '2019-09-21', 393, NULL),
('Residence Inn', 120, '2019-09-22', 181, NULL),
('Residence Inn', 120, '2019-09-23', 333, NULL),
('Residence Inn', 120, '2019-09-24', 239, NULL),
('Residence Inn', 120, '2019-09-25', 355, NULL),
('Residence Inn', 120, '2019-09-26', 124, NULL),
('Residence Inn', 120, '2019-09-27', 166, NULL),
('Residence Inn', 120, '2019-09-28', 294, NULL),
('Residence Inn', 120, '2019-09-29', 324, NULL),
('Residence Inn', 120, '2019-09-30', 236, NULL),
('Residence Inn', 120, '2019-10-01', 333, NULL),
('Residence Inn', 120, '2019-10-02', 202, NULL),
('Residence Inn', 120, '2019-10-03', 354, NULL),
('Residence Inn', 120, '2019-10-04', 322, NULL),
('Residence Inn', 120, '2019-10-05', 227, NULL),
('Residence Inn', 120, '2019-10-06', 181, NULL),
('Residence Inn', 120, '2019-10-07', 307, NULL),
('Residence Inn', 120, '2019-10-08', 379, NULL),
('Residence Inn', 120, '2019-10-09', 187, NULL),
('Residence Inn', 120, '2019-10-10', 190, NULL),
('Residence Inn', 120, '2019-10-11', 263, NULL),
('Residence Inn', 120, '2019-10-12', 295, NULL),
('Residence Inn', 120, '2019-10-13', 117, NULL),
('Residence Inn', 120, '2019-10-14', 317, NULL),
('Residence Inn', 120, '2019-10-15', 153, NULL),
('Residence Inn', 120, '2019-10-16', 221, NULL),
('Residence Inn', 120, '2019-10-17', 245, NULL),
('Residence Inn', 120, '2019-10-18', 326, NULL),
('Residence Inn', 120, '2019-10-19', 378, NULL),
('Residence Inn', 120, '2019-10-20', 367, NULL),
('Residence Inn', 120, '2019-10-21', 253, NULL),
('Residence Inn', 120, '2019-10-22', 227, NULL),
('Residence Inn', 120, '2019-10-23', 342, NULL),
('Residence Inn', 120, '2019-10-24', 272, NULL),
('Residence Inn', 120, '2019-10-25', 191, NULL),
('Residence Inn', 120, '2019-10-26', 245, NULL),
('Residence Inn', 120, '2019-10-27', 151, NULL),
('Residence Inn', 120, '2019-10-28', 287, NULL),
('Residence Inn', 120, '2019-10-29', 395, NULL),
('Residence Inn', 120, '2019-10-30', 386, NULL),
('Residence Inn', 120, '2019-10-31', 381, NULL),
('Residence Inn', 120, '2019-11-01', 393, NULL),
('Residence Inn', 120, '2019-11-02', 380, NULL),
('Residence Inn', 120, '2019-11-03', 394, NULL),
('Residence Inn', 120, '2019-11-04', 227, NULL),
('Residence Inn', 120, '2019-11-05', 377, NULL),
('Residence Inn', 120, '2019-11-06', 294, NULL),
('Residence Inn', 120, '2019-11-07', 198, NULL),
('Residence Inn', 120, '2019-11-08', 284, NULL),
('Residence Inn', 120, '2019-11-09', 269, NULL),
('Residence Inn', 120, '2019-11-10', 112, NULL),
('Residence Inn', 120, '2019-11-11', 147, NULL),
('Residence Inn', 120, '2019-11-12', 334, NULL),
('Residence Inn', 120, '2019-11-13', 277, NULL),
('Residence Inn', 120, '2019-11-14', 375, NULL),
('Residence Inn', 120, '2019-11-15', 160, NULL),
('Residence Inn', 120, '2019-11-16', 319, NULL),
('Residence Inn', 120, '2019-11-17', 125, NULL),
('Residence Inn', 120, '2019-11-18', 293, NULL),
('Residence Inn', 120, '2019-11-19', 275, NULL),
('Residence Inn', 120, '2019-11-20', 230, NULL),
('Residence Inn', 120, '2019-11-21', 380, NULL),
('Residence Inn', 120, '2019-11-22', 268, NULL),
('Residence Inn', 120, '2019-11-23', 360, NULL),
('Residence Inn', 120, '2019-11-24', 230, NULL),
('Residence Inn', 120, '2019-11-25', 176, NULL),
('Residence Inn', 120, '2019-11-26', 267, NULL),
('Residence Inn', 120, '2019-11-27', 125, NULL),
('Residence Inn', 120, '2019-11-28', 112, NULL),
('Residence Inn', 120, '2019-11-29', 240, NULL),
('Residence Inn', 120, '2019-11-30', 334, NULL),
('Residence Inn', 120, '2019-12-01', 274, NULL),
('Residence Inn', 120, '2019-12-02', 287, NULL),
('Residence Inn', 120, '2019-12-03', 143, NULL),
('Residence Inn', 120, '2019-12-04', 187, NULL),
('Residence Inn', 120, '2019-12-05', 255, NULL),
('Residence Inn', 120, '2019-12-06', 185, NULL),
('Residence Inn', 120, '2019-12-07', 123, NULL),
('Residence Inn', 120, '2019-12-08', 295, NULL),
('Residence Inn', 120, '2019-12-09', 265, NULL),
('Residence Inn', 120, '2019-12-10', 353, NULL),
('Residence Inn', 120, '2019-12-11', 272, NULL),
('Residence Inn', 120, '2019-12-12', 347, NULL),
('Residence Inn', 120, '2019-12-13', 152, NULL),
('Residence Inn', 120, '2019-12-14', 397, NULL),
('Residence Inn', 120, '2019-12-15', 329, NULL),
('Residence Inn', 120, '2019-12-16', 298, NULL),
('Residence Inn', 120, '2019-12-17', 104, NULL),
('Residence Inn', 120, '2019-12-18', 228, NULL),
('Residence Inn', 120, '2019-12-19', 222, NULL),
('Residence Inn', 120, '2019-12-20', 323, NULL),
('Residence Inn', 120, '2019-12-21', 253, NULL),
('Residence Inn', 120, '2019-12-22', 130, NULL),
('Residence Inn', 120, '2019-12-23', 109, NULL),
('Residence Inn', 120, '2019-12-24', 198, NULL),
('Residence Inn', 120, '2019-12-25', 200, NULL),
('Residence Inn', 120, '2019-12-26', 316, NULL),
('Residence Inn', 120, '2019-12-27', 138, NULL),
('Residence Inn', 120, '2019-12-28', 315, NULL),
('Residence Inn', 120, '2019-12-29', 361, NULL),
('Residence Inn', 120, '2019-12-30', 211, NULL),
('Residence Inn', 120, '2019-12-31', 347, NULL),
('Residence Inn', 120, '2020-01-01', 320, NULL),
('Residence Inn', 120, '2020-01-02', 107, NULL),
('Residence Inn', 120, '2020-01-03', 305, NULL),
('Residence Inn', 120, '2020-01-04', 379, NULL),
('Residence Inn', 120, '2020-01-05', 296, NULL),
('Residence Inn', 120, '2020-01-06', 319, NULL),
('Residence Inn', 120, '2020-01-07', 256, NULL),
('Residence Inn', 120, '2020-01-08', 134, NULL),
('Residence Inn', 120, '2020-01-09', 174, NULL),
('Residence Inn', 120, '2020-01-10', 193, NULL),
('Residence Inn', 120, '2020-01-11', 284, NULL),
('Residence Inn', 120, '2020-01-12', 142, NULL),
('Residence Inn', 120, '2020-01-13', 345, NULL),
('Residence Inn', 120, '2020-01-14', 117, NULL),
('Residence Inn', 120, '2020-01-15', 228, NULL),
('Residence Inn', 120, '2020-01-16', 257, NULL),
('Residence Inn', 120, '2020-01-17', 154, NULL),
('Residence Inn', 120, '2020-01-18', 367, NULL),
('Residence Inn', 120, '2020-01-19', 230, NULL),
('Residence Inn', 120, '2020-01-20', 371, NULL),
('Residence Inn', 120, '2020-01-21', 295, NULL),
('Residence Inn', 120, '2020-01-22', 172, NULL),
('Residence Inn', 120, '2020-01-23', 361, NULL),
('Residence Inn', 120, '2020-01-24', 131, NULL),
('Residence Inn', 120, '2020-01-25', 171, NULL),
('Residence Inn', 120, '2020-01-26', 276, NULL),
('Residence Inn', 120, '2020-01-27', 131, NULL),
('Residence Inn', 120, '2020-01-28', 216, NULL),
('Residence Inn', 120, '2020-01-29', 384, NULL),
('Residence Inn', 120, '2020-01-30', 182, NULL),
('Residence Inn', 120, '2020-01-31', 337, NULL),
('Residence Inn', 120, '2020-02-01', 348, NULL),
('Residence Inn', 120, '2020-02-02', 364, NULL),
('Residence Inn', 120, '2020-02-03', 157, NULL),
('Residence Inn', 120, '2020-02-04', 279, NULL),
('Residence Inn', 132, '2019-01-01', 192, NULL),
('Residence Inn', 132, '2019-01-02', 167, NULL),
('Residence Inn', 132, '2019-01-03', 390, NULL),
('Residence Inn', 132, '2019-01-04', 308, NULL),
('Residence Inn', 132, '2019-01-05', 273, NULL),
('Residence Inn', 132, '2019-01-06', 152, NULL),
('Residence Inn', 132, '2019-01-07', 211, NULL),
('Residence Inn', 132, '2019-01-08', 227, NULL),
('Residence Inn', 132, '2019-01-09', 368, NULL),
('Residence Inn', 132, '2019-01-10', 204, NULL),
('Residence Inn', 132, '2019-01-11', 175, NULL),
('Residence Inn', 132, '2019-01-12', 369, NULL),
('Residence Inn', 132, '2019-01-13', 191, NULL),
('Residence Inn', 132, '2019-01-14', 246, NULL),
('Residence Inn', 132, '2019-01-15', 362, NULL),
('Residence Inn', 132, '2019-01-16', 332, NULL),
('Residence Inn', 132, '2019-01-17', 371, NULL),
('Residence Inn', 132, '2019-01-18', 180, NULL),
('Residence Inn', 132, '2019-01-19', 283, NULL),
('Residence Inn', 132, '2019-01-20', 125, NULL),
('Residence Inn', 132, '2019-01-21', 380, NULL),
('Residence Inn', 132, '2019-01-22', 360, NULL),
('Residence Inn', 132, '2019-01-23', 143, NULL),
('Residence Inn', 132, '2019-01-24', 201, NULL),
('Residence Inn', 132, '2019-01-25', 378, NULL),
('Residence Inn', 132, '2019-01-26', 306, NULL),
('Residence Inn', 132, '2019-01-27', 382, NULL),
('Residence Inn', 132, '2019-01-28', 242, NULL),
('Residence Inn', 132, '2019-01-29', 150, NULL),
('Residence Inn', 132, '2019-01-30', 215, NULL),
('Residence Inn', 132, '2019-01-31', 321, NULL),
('Residence Inn', 132, '2019-02-01', 247, NULL),
('Residence Inn', 132, '2019-02-02', 191, NULL),
('Residence Inn', 132, '2019-02-03', 227, NULL),
('Residence Inn', 132, '2019-02-04', 113, NULL),
('Residence Inn', 132, '2019-02-05', 391, NULL),
('Residence Inn', 132, '2019-02-06', 135, NULL),
('Residence Inn', 132, '2019-02-07', 214, NULL),
('Residence Inn', 132, '2019-02-08', 299, NULL),
('Residence Inn', 132, '2019-02-09', 356, NULL),
('Residence Inn', 132, '2019-02-10', 326, NULL),
('Residence Inn', 132, '2019-02-11', 234, NULL),
('Residence Inn', 132, '2019-02-12', 165, NULL),
('Residence Inn', 132, '2019-02-13', 153, NULL),
('Residence Inn', 132, '2019-02-14', 318, NULL),
('Residence Inn', 132, '2019-02-15', 188, NULL),
('Residence Inn', 132, '2019-02-16', 323, NULL),
('Residence Inn', 132, '2019-02-17', 244, NULL),
('Residence Inn', 132, '2019-02-18', 186, NULL),
('Residence Inn', 132, '2019-02-19', 377, NULL),
('Residence Inn', 132, '2019-02-20', 233, NULL),
('Residence Inn', 132, '2019-02-21', 147, NULL),
('Residence Inn', 132, '2019-02-22', 387, NULL),
('Residence Inn', 132, '2019-02-23', 152, NULL),
('Residence Inn', 132, '2019-02-24', 361, NULL),
('Residence Inn', 132, '2019-02-25', 318, NULL),
('Residence Inn', 132, '2019-02-26', 146, NULL),
('Residence Inn', 132, '2019-02-27', 127, NULL),
('Residence Inn', 132, '2019-02-28', 385, NULL),
('Residence Inn', 132, '2019-03-01', 349, NULL),
('Residence Inn', 132, '2019-03-02', 110, NULL),
('Residence Inn', 132, '2019-03-03', 370, NULL),
('Residence Inn', 132, '2019-03-04', 108, NULL),
('Residence Inn', 132, '2019-03-05', 147, NULL),
('Residence Inn', 132, '2019-03-06', 245, NULL),
('Residence Inn', 132, '2019-03-07', 260, NULL),
('Residence Inn', 132, '2019-03-08', 323, NULL),
('Residence Inn', 132, '2019-03-09', 158, NULL),
('Residence Inn', 132, '2019-03-10', 323, NULL),
('Residence Inn', 132, '2019-03-11', 244, NULL),
('Residence Inn', 132, '2019-03-12', 183, NULL),
('Residence Inn', 132, '2019-03-13', 301, NULL),
('Residence Inn', 132, '2019-03-14', 344, NULL),
('Residence Inn', 132, '2019-03-15', 176, NULL),
('Residence Inn', 132, '2019-03-16', 202, NULL),
('Residence Inn', 132, '2019-03-17', 160, NULL),
('Residence Inn', 132, '2019-03-18', 383, NULL),
('Residence Inn', 132, '2019-03-19', 126, NULL),
('Residence Inn', 132, '2019-03-20', 296, NULL),
('Residence Inn', 132, '2019-03-21', 254, NULL),
('Residence Inn', 132, '2019-03-22', 220, NULL),
('Residence Inn', 132, '2019-03-23', 281, NULL),
('Residence Inn', 132, '2019-03-24', 361, NULL),
('Residence Inn', 132, '2019-03-25', 363, NULL),
('Residence Inn', 132, '2019-03-26', 391, NULL),
('Residence Inn', 132, '2019-03-27', 240, NULL),
('Residence Inn', 132, '2019-03-28', 102, NULL),
('Residence Inn', 132, '2019-03-29', 396, NULL),
('Residence Inn', 132, '2019-03-30', 182, NULL),
('Residence Inn', 132, '2019-03-31', 124, NULL),
('Residence Inn', 132, '2019-04-01', 273, NULL),
('Residence Inn', 132, '2019-04-02', 278, NULL),
('Residence Inn', 132, '2019-04-03', 139, NULL),
('Residence Inn', 132, '2019-04-04', 253, NULL),
('Residence Inn', 132, '2019-04-05', 231, NULL),
('Residence Inn', 132, '2019-04-06', 383, NULL),
('Residence Inn', 132, '2019-04-07', 343, NULL),
('Residence Inn', 132, '2019-04-08', 218, NULL),
('Residence Inn', 132, '2019-04-09', 269, NULL),
('Residence Inn', 132, '2019-04-10', 267, NULL),
('Residence Inn', 132, '2019-04-11', 261, NULL),
('Residence Inn', 132, '2019-04-12', 349, NULL),
('Residence Inn', 132, '2019-04-13', 354, NULL),
('Residence Inn', 132, '2019-04-14', 205, NULL),
('Residence Inn', 132, '2019-04-15', 380, NULL),
('Residence Inn', 132, '2019-04-16', 206, NULL),
('Residence Inn', 132, '2019-04-17', 216, NULL),
('Residence Inn', 132, '2019-04-18', 294, NULL),
('Residence Inn', 132, '2019-04-19', 392, NULL),
('Residence Inn', 132, '2019-04-20', 225, NULL),
('Residence Inn', 132, '2019-04-21', 374, NULL),
('Residence Inn', 132, '2019-04-22', 334, NULL),
('Residence Inn', 132, '2019-04-23', 276, NULL),
('Residence Inn', 132, '2019-04-24', 227, NULL),
('Residence Inn', 132, '2019-04-25', 197, NULL),
('Residence Inn', 132, '2019-04-26', 351, NULL),
('Residence Inn', 132, '2019-04-27', 102, NULL),
('Residence Inn', 132, '2019-04-28', 101, NULL),
('Residence Inn', 132, '2019-04-29', 186, NULL),
('Residence Inn', 132, '2019-04-30', 278, NULL),
('Residence Inn', 132, '2019-05-01', 144, NULL),
('Residence Inn', 132, '2019-05-02', 119, NULL),
('Residence Inn', 132, '2019-05-03', 193, NULL),
('Residence Inn', 132, '2019-05-04', 269, NULL),
('Residence Inn', 132, '2019-05-05', 281, NULL),
('Residence Inn', 132, '2019-05-06', 171, NULL),
('Residence Inn', 132, '2019-05-07', 322, NULL),
('Residence Inn', 132, '2019-05-08', 126, NULL),
('Residence Inn', 132, '2019-05-09', 154, NULL),
('Residence Inn', 132, '2019-05-10', 250, NULL),
('Residence Inn', 132, '2019-05-11', 248, NULL),
('Residence Inn', 132, '2019-05-12', 229, NULL),
('Residence Inn', 132, '2019-05-13', 349, NULL),
('Residence Inn', 132, '2019-05-14', 268, NULL),
('Residence Inn', 132, '2019-05-15', 279, NULL),
('Residence Inn', 132, '2019-05-16', 267, NULL),
('Residence Inn', 132, '2019-05-17', 241, NULL),
('Residence Inn', 132, '2019-05-18', 374, NULL),
('Residence Inn', 132, '2019-05-19', 100, NULL),
('Residence Inn', 132, '2019-05-20', 121, NULL),
('Residence Inn', 132, '2019-05-21', 191, NULL),
('Residence Inn', 132, '2019-05-22', 217, NULL),
('Residence Inn', 132, '2019-05-23', 211, NULL),
('Residence Inn', 132, '2019-05-24', 100, NULL),
('Residence Inn', 132, '2019-05-25', 374, NULL),
('Residence Inn', 132, '2019-05-26', 160, NULL),
('Residence Inn', 132, '2019-05-27', 260, NULL),
('Residence Inn', 132, '2019-05-28', 105, NULL),
('Residence Inn', 132, '2019-05-29', 248, NULL),
('Residence Inn', 132, '2019-05-30', 296, NULL),
('Residence Inn', 132, '2019-05-31', 389, NULL),
('Residence Inn', 132, '2019-06-01', 238, NULL),
('Residence Inn', 132, '2019-06-02', 144, NULL),
('Residence Inn', 132, '2019-06-03', 383, NULL),
('Residence Inn', 132, '2019-06-04', 146, NULL),
('Residence Inn', 132, '2019-06-05', 390, NULL),
('Residence Inn', 132, '2019-06-06', 119, NULL),
('Residence Inn', 132, '2019-06-07', 301, NULL),
('Residence Inn', 132, '2019-06-08', 295, NULL),
('Residence Inn', 132, '2019-06-09', 330, NULL),
('Residence Inn', 132, '2019-06-10', 370, NULL),
('Residence Inn', 132, '2019-06-11', 323, NULL),
('Residence Inn', 132, '2019-06-12', 155, NULL),
('Residence Inn', 132, '2019-06-13', 300, NULL),
('Residence Inn', 132, '2019-06-14', 297, NULL),
('Residence Inn', 132, '2019-06-15', 212, NULL),
('Residence Inn', 132, '2019-06-16', 198, NULL),
('Residence Inn', 132, '2019-06-17', 150, NULL),
('Residence Inn', 132, '2019-06-18', 262, NULL),
('Residence Inn', 132, '2019-06-19', 210, NULL),
('Residence Inn', 132, '2019-06-20', 323, NULL),
('Residence Inn', 132, '2019-06-21', 308, NULL),
('Residence Inn', 132, '2019-06-22', 358, NULL),
('Residence Inn', 132, '2019-06-23', 136, NULL),
('Residence Inn', 132, '2019-06-24', 240, NULL),
('Residence Inn', 132, '2019-06-25', 289, NULL),
('Residence Inn', 132, '2019-06-26', 257, NULL),
('Residence Inn', 132, '2019-06-27', 280, NULL),
('Residence Inn', 132, '2019-06-28', 135, NULL),
('Residence Inn', 132, '2019-06-29', 101, NULL),
('Residence Inn', 132, '2019-06-30', 149, NULL),
('Residence Inn', 132, '2019-07-01', 305, NULL),
('Residence Inn', 132, '2019-07-02', 206, NULL),
('Residence Inn', 132, '2019-07-03', 227, NULL),
('Residence Inn', 132, '2019-07-04', 278, NULL),
('Residence Inn', 132, '2019-07-05', 196, NULL),
('Residence Inn', 132, '2019-07-06', 128, NULL),
('Residence Inn', 132, '2019-07-07', 252, NULL),
('Residence Inn', 132, '2019-07-08', 307, NULL),
('Residence Inn', 132, '2019-07-09', 385, NULL),
('Residence Inn', 132, '2019-07-10', 223, NULL),
('Residence Inn', 132, '2019-07-11', 180, NULL),
('Residence Inn', 132, '2019-07-12', 131, NULL),
('Residence Inn', 132, '2019-07-13', 294, NULL),
('Residence Inn', 132, '2019-07-14', 207, NULL),
('Residence Inn', 132, '2019-07-15', 228, NULL),
('Residence Inn', 132, '2019-07-16', 145, NULL),
('Residence Inn', 132, '2019-07-17', 253, NULL),
('Residence Inn', 132, '2019-07-18', 381, NULL),
('Residence Inn', 132, '2019-07-19', 317, NULL),
('Residence Inn', 132, '2019-07-20', 279, NULL),
('Residence Inn', 132, '2019-07-21', 120, NULL),
('Residence Inn', 132, '2019-07-22', 371, NULL),
('Residence Inn', 132, '2019-07-23', 257, NULL),
('Residence Inn', 132, '2019-07-24', 111, NULL),
('Residence Inn', 132, '2019-07-25', 187, NULL),
('Residence Inn', 132, '2019-07-26', 384, NULL),
('Residence Inn', 132, '2019-07-27', 105, NULL),
('Residence Inn', 132, '2019-07-28', 235, NULL),
('Residence Inn', 132, '2019-07-29', 304, NULL),
('Residence Inn', 132, '2019-07-30', 317, NULL),
('Residence Inn', 132, '2019-07-31', 317, NULL),
('Residence Inn', 132, '2019-08-01', 237, NULL),
('Residence Inn', 132, '2019-08-02', 113, NULL),
('Residence Inn', 132, '2019-08-03', 159, NULL),
('Residence Inn', 132, '2019-08-04', 379, NULL),
('Residence Inn', 132, '2019-08-05', 267, NULL),
('Residence Inn', 132, '2019-08-06', 256, NULL),
('Residence Inn', 132, '2019-08-07', 319, NULL),
('Residence Inn', 132, '2019-08-08', 129, NULL),
('Residence Inn', 132, '2019-08-09', 299, NULL),
('Residence Inn', 132, '2019-08-10', 342, NULL),
('Residence Inn', 132, '2019-08-11', 252, NULL),
('Residence Inn', 132, '2019-08-12', 113, NULL),
('Residence Inn', 132, '2019-08-13', 362, NULL),
('Residence Inn', 132, '2019-08-14', 221, NULL),
('Residence Inn', 132, '2019-08-15', 110, NULL),
('Residence Inn', 132, '2019-08-16', 228, NULL),
('Residence Inn', 132, '2019-08-17', 121, NULL),
('Residence Inn', 132, '2019-08-18', 137, NULL),
('Residence Inn', 132, '2019-08-19', 386, NULL),
('Residence Inn', 132, '2019-08-20', 281, NULL),
('Residence Inn', 132, '2019-08-21', 305, NULL),
('Residence Inn', 132, '2019-08-22', 276, NULL),
('Residence Inn', 132, '2019-08-23', 298, NULL),
('Residence Inn', 132, '2019-08-24', 123, NULL),
('Residence Inn', 132, '2019-08-25', 183, NULL),
('Residence Inn', 132, '2019-08-26', 235, NULL),
('Residence Inn', 132, '2019-08-27', 209, NULL),
('Residence Inn', 132, '2019-08-28', 263, NULL),
('Residence Inn', 132, '2019-08-29', 216, NULL),
('Residence Inn', 132, '2019-08-30', 316, NULL),
('Residence Inn', 132, '2019-08-31', 209, NULL),
('Residence Inn', 132, '2019-09-01', 339, NULL),
('Residence Inn', 132, '2019-09-02', 131, NULL),
('Residence Inn', 132, '2019-09-03', 274, NULL),
('Residence Inn', 132, '2019-09-04', 386, NULL),
('Residence Inn', 132, '2019-09-05', 171, NULL),
('Residence Inn', 132, '2019-09-06', 191, NULL),
('Residence Inn', 132, '2019-09-07', 227, NULL),
('Residence Inn', 132, '2019-09-08', 168, NULL),
('Residence Inn', 132, '2019-09-09', 321, NULL),
('Residence Inn', 132, '2019-09-10', 370, NULL),
('Residence Inn', 132, '2019-09-11', 285, NULL),
('Residence Inn', 132, '2019-09-12', 216, NULL),
('Residence Inn', 132, '2019-09-13', 180, NULL),
('Residence Inn', 132, '2019-09-14', 147, NULL),
('Residence Inn', 132, '2019-09-15', 360, NULL),
('Residence Inn', 132, '2019-09-16', 392, NULL),
('Residence Inn', 132, '2019-09-17', 108, NULL),
('Residence Inn', 132, '2019-09-18', 315, NULL),
('Residence Inn', 132, '2019-09-19', 281, NULL),
('Residence Inn', 132, '2019-09-20', 127, NULL),
('Residence Inn', 132, '2019-09-21', 236, NULL),
('Residence Inn', 132, '2019-09-22', 235, NULL),
('Residence Inn', 132, '2019-09-23', 214, NULL),
('Residence Inn', 132, '2019-09-24', 390, NULL),
('Residence Inn', 132, '2019-09-25', 318, NULL),
('Residence Inn', 132, '2019-09-26', 137, NULL),
('Residence Inn', 132, '2019-09-27', 115, NULL),
('Residence Inn', 132, '2019-09-28', 158, NULL),
('Residence Inn', 132, '2019-09-29', 300, NULL),
('Residence Inn', 132, '2019-09-30', 369, NULL),
('Residence Inn', 132, '2019-10-01', 116, NULL),
('Residence Inn', 132, '2019-10-02', 386, NULL),
('Residence Inn', 132, '2019-10-03', 184, NULL),
('Residence Inn', 132, '2019-10-04', 200, NULL),
('Residence Inn', 132, '2019-10-05', 132, NULL),
('Residence Inn', 132, '2019-10-06', 245, NULL),
('Residence Inn', 132, '2019-10-07', 239, NULL),
('Residence Inn', 132, '2019-10-08', 191, NULL),
('Residence Inn', 132, '2019-10-09', 328, NULL),
('Residence Inn', 132, '2019-10-10', 201, NULL),
('Residence Inn', 132, '2019-10-11', 393, NULL),
('Residence Inn', 132, '2019-10-12', 352, NULL),
('Residence Inn', 132, '2019-10-13', 228, NULL),
('Residence Inn', 132, '2019-10-14', 106, NULL),
('Residence Inn', 132, '2019-10-15', 120, NULL),
('Residence Inn', 132, '2019-10-16', 393, NULL),
('Residence Inn', 132, '2019-10-17', 261, NULL),
('Residence Inn', 132, '2019-10-18', 276, NULL),
('Residence Inn', 132, '2019-10-19', 276, NULL),
('Residence Inn', 132, '2019-10-20', 391, NULL),
('Residence Inn', 132, '2019-10-21', 193, NULL),
('Residence Inn', 132, '2019-10-22', 316, NULL),
('Residence Inn', 132, '2019-10-23', 146, NULL),
('Residence Inn', 132, '2019-10-24', 221, NULL),
('Residence Inn', 132, '2019-10-25', 173, NULL),
('Residence Inn', 132, '2019-10-26', 108, NULL),
('Residence Inn', 132, '2019-10-27', 334, NULL),
('Residence Inn', 132, '2019-10-28', 139, NULL),
('Residence Inn', 132, '2019-10-29', 285, NULL),
('Residence Inn', 132, '2019-10-30', 278, NULL),
('Residence Inn', 132, '2019-10-31', 346, NULL),
('Residence Inn', 132, '2019-11-01', 101, NULL),
('Residence Inn', 132, '2019-11-02', 149, NULL),
('Residence Inn', 132, '2019-11-03', 311, NULL),
('Residence Inn', 132, '2019-11-04', 143, NULL),
('Residence Inn', 132, '2019-11-05', 211, NULL),
('Residence Inn', 132, '2019-11-06', 288, NULL),
('Residence Inn', 132, '2019-11-07', 222, NULL),
('Residence Inn', 132, '2019-11-08', 348, NULL),
('Residence Inn', 132, '2019-11-09', 164, NULL),
('Residence Inn', 132, '2019-11-10', 153, NULL),
('Residence Inn', 132, '2019-11-11', 228, NULL),
('Residence Inn', 132, '2019-11-12', 168, NULL),
('Residence Inn', 132, '2019-11-13', 187, NULL),
('Residence Inn', 132, '2019-11-14', 293, NULL),
('Residence Inn', 132, '2019-11-15', 115, NULL),
('Residence Inn', 132, '2019-11-16', 373, NULL),
('Residence Inn', 132, '2019-11-17', 298, NULL),
('Residence Inn', 132, '2019-11-18', 226, NULL),
('Residence Inn', 132, '2019-11-19', 364, NULL),
('Residence Inn', 132, '2019-11-20', 354, NULL),
('Residence Inn', 132, '2019-11-21', 318, NULL),
('Residence Inn', 132, '2019-11-22', 144, NULL),
('Residence Inn', 132, '2019-11-23', 104, NULL),
('Residence Inn', 132, '2019-11-24', 128, NULL),
('Residence Inn', 132, '2019-11-25', 146, NULL),
('Residence Inn', 132, '2019-11-26', 148, NULL),
('Residence Inn', 132, '2019-11-27', 147, NULL),
('Residence Inn', 132, '2019-11-28', 374, NULL),
('Residence Inn', 132, '2019-11-29', 233, NULL),
('Residence Inn', 132, '2019-11-30', 203, NULL),
('Residence Inn', 132, '2019-12-01', 292, NULL),
('Residence Inn', 132, '2019-12-02', 143, NULL),
('Residence Inn', 132, '2019-12-03', 241, NULL),
('Residence Inn', 132, '2019-12-04', 321, NULL),
('Residence Inn', 132, '2019-12-05', 287, NULL),
('Residence Inn', 132, '2019-12-06', 283, NULL),
('Residence Inn', 132, '2019-12-07', 150, NULL),
('Residence Inn', 132, '2019-12-08', 320, NULL),
('Residence Inn', 132, '2019-12-09', 262, NULL),
('Residence Inn', 132, '2019-12-10', 316, NULL),
('Residence Inn', 132, '2019-12-11', 171, NULL),
('Residence Inn', 132, '2019-12-12', 173, NULL),
('Residence Inn', 132, '2019-12-13', 169, NULL),
('Residence Inn', 132, '2019-12-14', 352, NULL),
('Residence Inn', 132, '2019-12-15', 338, NULL),
('Residence Inn', 132, '2019-12-16', 254, NULL),
('Residence Inn', 132, '2019-12-17', 306, NULL),
('Residence Inn', 132, '2019-12-18', 266, NULL),
('Residence Inn', 132, '2019-12-19', 174, NULL),
('Residence Inn', 132, '2019-12-20', 229, NULL),
('Residence Inn', 132, '2019-12-21', 343, NULL),
('Residence Inn', 132, '2019-12-22', 319, NULL),
('Residence Inn', 132, '2019-12-23', 158, NULL),
('Residence Inn', 132, '2019-12-24', 347, NULL),
('Residence Inn', 132, '2019-12-25', 246, NULL),
('Residence Inn', 132, '2019-12-26', 277, NULL),
('Residence Inn', 132, '2019-12-27', 118, NULL),
('Residence Inn', 132, '2019-12-28', 175, NULL),
('Residence Inn', 132, '2019-12-29', 319, NULL),
('Residence Inn', 132, '2019-12-30', 372, NULL),
('Residence Inn', 132, '2019-12-31', 391, NULL),
('Residence Inn', 132, '2020-01-01', 254, NULL),
('Residence Inn', 132, '2020-01-02', 162, NULL),
('Residence Inn', 132, '2020-01-03', 342, NULL),
('Residence Inn', 132, '2020-01-04', 286, NULL),
('Residence Inn', 132, '2020-01-05', 229, NULL),
('Residence Inn', 132, '2020-01-06', 399, NULL),
('Residence Inn', 132, '2020-01-07', 156, NULL),
('Residence Inn', 132, '2020-01-08', 128, NULL),
('Residence Inn', 132, '2020-01-09', 276, NULL),
('Residence Inn', 132, '2020-01-10', 340, NULL),
('Residence Inn', 132, '2020-01-11', 194, NULL),
('Residence Inn', 132, '2020-01-12', 305, NULL),
('Residence Inn', 132, '2020-01-13', 178, NULL),
('Residence Inn', 132, '2020-01-14', 275, NULL),
('Residence Inn', 132, '2020-01-15', 268, NULL),
('Residence Inn', 132, '2020-01-16', 170, NULL),
('Residence Inn', 132, '2020-01-17', 191, NULL),
('Residence Inn', 132, '2020-01-18', 127, NULL),
('Residence Inn', 132, '2020-01-19', 161, NULL),
('Residence Inn', 132, '2020-01-20', 210, NULL),
('Residence Inn', 132, '2020-01-21', 189, NULL),
('Residence Inn', 132, '2020-01-22', 132, NULL),
('Residence Inn', 132, '2020-01-23', 170, NULL),
('Residence Inn', 132, '2020-01-24', 232, NULL),
('Residence Inn', 132, '2020-01-25', 375, NULL),
('Residence Inn', 132, '2020-01-26', 309, NULL),
('Residence Inn', 132, '2020-01-27', 224, NULL),
('Residence Inn', 132, '2020-01-28', 254, NULL),
('Residence Inn', 132, '2020-01-29', 219, NULL),
('Residence Inn', 132, '2020-01-30', 285, NULL),
('Residence Inn', 132, '2020-01-31', 369, NULL),
('Residence Inn', 132, '2020-02-01', 295, NULL),
('Residence Inn', 132, '2020-02-02', 196, NULL),
('Residence Inn', 132, '2020-02-03', 121, NULL),
('Residence Inn', 132, '2020-02-04', 351, NULL),
('Residence Inn', 137, '2019-01-01', 334, NULL),
('Residence Inn', 137, '2019-01-02', 378, NULL),
('Residence Inn', 137, '2019-01-03', 338, NULL),
('Residence Inn', 137, '2019-01-04', 227, NULL),
('Residence Inn', 137, '2019-01-05', 187, NULL),
('Residence Inn', 137, '2019-01-06', 381, NULL),
('Residence Inn', 137, '2019-01-07', 263, NULL),
('Residence Inn', 137, '2019-01-08', 257, NULL),
('Residence Inn', 137, '2019-01-09', 397, NULL),
('Residence Inn', 137, '2019-01-10', 391, NULL),
('Residence Inn', 137, '2019-01-11', 305, NULL),
('Residence Inn', 137, '2019-01-12', 314, NULL),
('Residence Inn', 137, '2019-01-13', 381, NULL),
('Residence Inn', 137, '2019-01-14', 196, NULL),
('Residence Inn', 137, '2019-01-15', 172, NULL),
('Residence Inn', 137, '2019-01-16', 149, NULL),
('Residence Inn', 137, '2019-01-17', 140, NULL),
('Residence Inn', 137, '2019-01-18', 147, NULL),
('Residence Inn', 137, '2019-01-19', 344, NULL),
('Residence Inn', 137, '2019-01-20', 221, NULL),
('Residence Inn', 137, '2019-01-21', 276, NULL),
('Residence Inn', 137, '2019-01-22', 352, NULL),
('Residence Inn', 137, '2019-01-23', 180, NULL),
('Residence Inn', 137, '2019-01-24', 299, NULL),
('Residence Inn', 137, '2019-01-25', 149, NULL),
('Residence Inn', 137, '2019-01-26', 329, NULL),
('Residence Inn', 137, '2019-01-27', 344, NULL),
('Residence Inn', 137, '2019-01-28', 260, NULL),
('Residence Inn', 137, '2019-01-29', 310, NULL),
('Residence Inn', 137, '2019-01-30', 343, NULL),
('Residence Inn', 137, '2019-01-31', 328, NULL),
('Residence Inn', 137, '2019-02-01', 262, NULL),
('Residence Inn', 137, '2019-02-02', 123, NULL),
('Residence Inn', 137, '2019-02-03', 198, NULL),
('Residence Inn', 137, '2019-02-04', 344, NULL),
('Residence Inn', 137, '2019-02-05', 304, NULL),
('Residence Inn', 137, '2019-02-06', 365, NULL),
('Residence Inn', 137, '2019-02-07', 380, NULL),
('Residence Inn', 137, '2019-02-08', 239, NULL),
('Residence Inn', 137, '2019-02-09', 112, NULL),
('Residence Inn', 137, '2019-02-10', 302, NULL),
('Residence Inn', 137, '2019-02-11', 179, NULL),
('Residence Inn', 137, '2019-02-12', 276, NULL),
('Residence Inn', 137, '2019-02-13', 325, NULL),
('Residence Inn', 137, '2019-02-14', 202, NULL),
('Residence Inn', 137, '2019-02-15', 260, NULL),
('Residence Inn', 137, '2019-02-16', 344, NULL),
('Residence Inn', 137, '2019-02-17', 371, NULL),
('Residence Inn', 137, '2019-02-18', 162, NULL),
('Residence Inn', 137, '2019-02-19', 175, NULL),
('Residence Inn', 137, '2019-02-20', 318, NULL),
('Residence Inn', 137, '2019-02-21', 239, NULL),
('Residence Inn', 137, '2019-02-22', 122, NULL),
('Residence Inn', 137, '2019-02-23', 160, NULL),
('Residence Inn', 137, '2019-02-24', 323, NULL),
('Residence Inn', 137, '2019-02-25', 221, NULL),
('Residence Inn', 137, '2019-02-26', 346, NULL),
('Residence Inn', 137, '2019-02-27', 191, NULL),
('Residence Inn', 137, '2019-02-28', 142, NULL),
('Residence Inn', 137, '2019-03-01', 124, NULL),
('Residence Inn', 137, '2019-03-02', 171, NULL),
('Residence Inn', 137, '2019-03-03', 278, NULL),
('Residence Inn', 137, '2019-03-04', 152, NULL),
('Residence Inn', 137, '2019-03-05', 212, NULL),
('Residence Inn', 137, '2019-03-06', 261, NULL),
('Residence Inn', 137, '2019-03-07', 390, NULL),
('Residence Inn', 137, '2019-03-08', 306, NULL),
('Residence Inn', 137, '2019-03-09', 305, NULL),
('Residence Inn', 137, '2019-03-10', 265, NULL),
('Residence Inn', 137, '2019-03-11', 163, NULL),
('Residence Inn', 137, '2019-03-12', 305, NULL),
('Residence Inn', 137, '2019-03-13', 120, NULL),
('Residence Inn', 137, '2019-03-14', 382, NULL),
('Residence Inn', 137, '2019-03-15', 183, NULL),
('Residence Inn', 137, '2019-03-16', 199, NULL),
('Residence Inn', 137, '2019-03-17', 385, NULL),
('Residence Inn', 137, '2019-03-18', 148, NULL),
('Residence Inn', 137, '2019-03-19', 379, NULL),
('Residence Inn', 137, '2019-03-20', 152, NULL),
('Residence Inn', 137, '2019-03-21', 258, NULL),
('Residence Inn', 137, '2019-03-22', 101, NULL),
('Residence Inn', 137, '2019-03-23', 338, NULL),
('Residence Inn', 137, '2019-03-24', 244, NULL),
('Residence Inn', 137, '2019-03-25', 344, NULL),
('Residence Inn', 137, '2019-03-26', 114, NULL),
('Residence Inn', 137, '2019-03-27', 233, NULL),
('Residence Inn', 137, '2019-03-28', 252, NULL),
('Residence Inn', 137, '2019-03-29', 201, NULL),
('Residence Inn', 137, '2019-03-30', 192, NULL),
('Residence Inn', 137, '2019-03-31', 377, NULL),
('Residence Inn', 137, '2019-04-01', 385, NULL),
('Residence Inn', 137, '2019-04-02', 219, NULL),
('Residence Inn', 137, '2019-04-03', 269, NULL),
('Residence Inn', 137, '2019-04-04', 217, NULL),
('Residence Inn', 137, '2019-04-05', 375, NULL),
('Residence Inn', 137, '2019-04-06', 286, NULL),
('Residence Inn', 137, '2019-04-07', 172, NULL),
('Residence Inn', 137, '2019-04-08', 182, NULL),
('Residence Inn', 137, '2019-04-09', 107, NULL),
('Residence Inn', 137, '2019-04-10', 117, NULL),
('Residence Inn', 137, '2019-04-11', 351, NULL),
('Residence Inn', 137, '2019-04-12', 231, NULL),
('Residence Inn', 137, '2019-04-13', 381, NULL),
('Residence Inn', 137, '2019-04-14', 293, NULL),
('Residence Inn', 137, '2019-04-15', 396, NULL),
('Residence Inn', 137, '2019-04-16', 132, NULL),
('Residence Inn', 137, '2019-04-17', 183, NULL),
('Residence Inn', 137, '2019-04-18', 385, NULL),
('Residence Inn', 137, '2019-04-19', 233, NULL),
('Residence Inn', 137, '2019-04-20', 355, NULL),
('Residence Inn', 137, '2019-04-21', 242, NULL),
('Residence Inn', 137, '2019-04-22', 161, NULL),
('Residence Inn', 137, '2019-04-23', 149, NULL),
('Residence Inn', 137, '2019-04-24', 374, NULL),
('Residence Inn', 137, '2019-04-25', 107, NULL),
('Residence Inn', 137, '2019-04-26', 218, NULL),
('Residence Inn', 137, '2019-04-27', 202, NULL),
('Residence Inn', 137, '2019-04-28', 180, NULL),
('Residence Inn', 137, '2019-04-29', 309, NULL),
('Residence Inn', 137, '2019-04-30', 228, NULL),
('Residence Inn', 137, '2019-05-01', 342, NULL),
('Residence Inn', 137, '2019-05-02', 328, NULL),
('Residence Inn', 137, '2019-05-03', 301, NULL),
('Residence Inn', 137, '2019-05-04', 296, NULL),
('Residence Inn', 137, '2019-05-05', 100, NULL),
('Residence Inn', 137, '2019-05-06', 220, NULL),
('Residence Inn', 137, '2019-05-07', 168, NULL),
('Residence Inn', 137, '2019-05-08', 293, NULL),
('Residence Inn', 137, '2019-05-09', 132, NULL),
('Residence Inn', 137, '2019-05-10', 212, NULL),
('Residence Inn', 137, '2019-05-11', 313, NULL),
('Residence Inn', 137, '2019-05-12', 114, NULL),
('Residence Inn', 137, '2019-05-13', 228, NULL),
('Residence Inn', 137, '2019-05-14', 263, NULL),
('Residence Inn', 137, '2019-05-15', 248, NULL),
('Residence Inn', 137, '2019-05-16', 264, NULL),
('Residence Inn', 137, '2019-05-17', 330, NULL),
('Residence Inn', 137, '2019-05-18', 270, NULL),
('Residence Inn', 137, '2019-05-19', 352, NULL),
('Residence Inn', 137, '2019-05-20', 210, NULL),
('Residence Inn', 137, '2019-05-21', 169, NULL),
('Residence Inn', 137, '2019-05-22', 181, NULL),
('Residence Inn', 137, '2019-05-23', 199, NULL),
('Residence Inn', 137, '2019-05-24', 222, NULL),
('Residence Inn', 137, '2019-05-25', 107, NULL),
('Residence Inn', 137, '2019-05-26', 241, NULL),
('Residence Inn', 137, '2019-05-27', 214, NULL),
('Residence Inn', 137, '2019-05-28', 282, NULL),
('Residence Inn', 137, '2019-05-29', 190, NULL),
('Residence Inn', 137, '2019-05-30', 192, NULL),
('Residence Inn', 137, '2019-05-31', 110, NULL),
('Residence Inn', 137, '2019-06-01', 139, NULL),
('Residence Inn', 137, '2019-06-02', 377, NULL),
('Residence Inn', 137, '2019-06-03', 385, NULL),
('Residence Inn', 137, '2019-06-04', 289, NULL),
('Residence Inn', 137, '2019-06-05', 278, NULL),
('Residence Inn', 137, '2019-06-06', 374, NULL),
('Residence Inn', 137, '2019-06-07', 181, NULL),
('Residence Inn', 137, '2019-06-08', 391, NULL),
('Residence Inn', 137, '2019-06-09', 110, NULL),
('Residence Inn', 137, '2019-06-10', 361, NULL),
('Residence Inn', 137, '2019-06-11', 396, NULL),
('Residence Inn', 137, '2019-06-12', 193, NULL),
('Residence Inn', 137, '2019-06-13', 152, NULL),
('Residence Inn', 137, '2019-06-14', 225, NULL),
('Residence Inn', 137, '2019-06-15', 369, NULL),
('Residence Inn', 137, '2019-06-16', 113, NULL),
('Residence Inn', 137, '2019-06-17', 395, NULL),
('Residence Inn', 137, '2019-06-18', 158, NULL),
('Residence Inn', 137, '2019-06-19', 361, NULL),
('Residence Inn', 137, '2019-06-20', 238, NULL),
('Residence Inn', 137, '2019-06-21', 324, NULL),
('Residence Inn', 137, '2019-06-22', 144, NULL),
('Residence Inn', 137, '2019-06-23', 237, NULL),
('Residence Inn', 137, '2019-06-24', 175, NULL),
('Residence Inn', 137, '2019-06-25', 243, NULL),
('Residence Inn', 137, '2019-06-26', 300, NULL),
('Residence Inn', 137, '2019-06-27', 197, NULL),
('Residence Inn', 137, '2019-06-28', 173, NULL),
('Residence Inn', 137, '2019-06-29', 385, NULL),
('Residence Inn', 137, '2019-06-30', 152, NULL),
('Residence Inn', 137, '2019-07-01', 315, NULL),
('Residence Inn', 137, '2019-07-02', 264, NULL),
('Residence Inn', 137, '2019-07-03', 378, NULL),
('Residence Inn', 137, '2019-07-04', 196, NULL),
('Residence Inn', 137, '2019-07-05', 392, NULL),
('Residence Inn', 137, '2019-07-06', 340, NULL),
('Residence Inn', 137, '2019-07-07', 210, NULL),
('Residence Inn', 137, '2019-07-08', 362, NULL),
('Residence Inn', 137, '2019-07-09', 155, NULL),
('Residence Inn', 137, '2019-07-10', 186, NULL),
('Residence Inn', 137, '2019-07-11', 253, NULL),
('Residence Inn', 137, '2019-07-12', 380, NULL),
('Residence Inn', 137, '2019-07-13', 105, NULL),
('Residence Inn', 137, '2019-07-14', 227, NULL),
('Residence Inn', 137, '2019-07-15', 237, NULL),
('Residence Inn', 137, '2019-07-16', 326, NULL),
('Residence Inn', 137, '2019-07-17', 304, NULL),
('Residence Inn', 137, '2019-07-18', 354, NULL),
('Residence Inn', 137, '2019-07-19', 124, NULL),
('Residence Inn', 137, '2019-07-20', 252, NULL),
('Residence Inn', 137, '2019-07-21', 292, NULL),
('Residence Inn', 137, '2019-07-22', 256, NULL),
('Residence Inn', 137, '2019-07-23', 218, NULL),
('Residence Inn', 137, '2019-07-24', 388, NULL),
('Residence Inn', 137, '2019-07-25', 280, NULL),
('Residence Inn', 137, '2019-07-26', 313, NULL),
('Residence Inn', 137, '2019-07-27', 226, NULL),
('Residence Inn', 137, '2019-07-28', 255, NULL),
('Residence Inn', 137, '2019-07-29', 143, NULL),
('Residence Inn', 137, '2019-07-30', 312, NULL),
('Residence Inn', 137, '2019-07-31', 306, NULL),
('Residence Inn', 137, '2019-08-01', 221, NULL),
('Residence Inn', 137, '2019-08-02', 258, NULL),
('Residence Inn', 137, '2019-08-03', 266, NULL),
('Residence Inn', 137, '2019-08-04', 179, NULL),
('Residence Inn', 137, '2019-08-05', 122, NULL),
('Residence Inn', 137, '2019-08-06', 221, NULL),
('Residence Inn', 137, '2019-08-07', 182, NULL),
('Residence Inn', 137, '2019-08-08', 305, NULL),
('Residence Inn', 137, '2019-08-09', 297, NULL),
('Residence Inn', 137, '2019-08-10', 336, NULL),
('Residence Inn', 137, '2019-08-11', 248, NULL),
('Residence Inn', 137, '2019-08-12', 274, NULL),
('Residence Inn', 137, '2019-08-13', 396, NULL),
('Residence Inn', 137, '2019-08-14', 219, NULL),
('Residence Inn', 137, '2019-08-15', 101, NULL),
('Residence Inn', 137, '2019-08-16', 356, NULL),
('Residence Inn', 137, '2019-08-17', 123, NULL),
('Residence Inn', 137, '2019-08-18', 342, NULL),
('Residence Inn', 137, '2019-08-19', 384, NULL),
('Residence Inn', 137, '2019-08-20', 346, NULL),
('Residence Inn', 137, '2019-08-21', 223, NULL),
('Residence Inn', 137, '2019-08-22', 307, NULL),
('Residence Inn', 137, '2019-08-23', 146, NULL),
('Residence Inn', 137, '2019-08-24', 362, NULL),
('Residence Inn', 137, '2019-08-25', 144, NULL),
('Residence Inn', 137, '2019-08-26', 317, NULL),
('Residence Inn', 137, '2019-08-27', 117, NULL),
('Residence Inn', 137, '2019-08-28', 114, NULL),
('Residence Inn', 137, '2019-08-29', 209, NULL),
('Residence Inn', 137, '2019-08-30', 217, NULL),
('Residence Inn', 137, '2019-08-31', 138, NULL),
('Residence Inn', 137, '2019-09-01', 331, NULL),
('Residence Inn', 137, '2019-09-02', 267, NULL),
('Residence Inn', 137, '2019-09-03', 371, NULL),
('Residence Inn', 137, '2019-09-04', 359, NULL),
('Residence Inn', 137, '2019-09-05', 192, NULL),
('Residence Inn', 137, '2019-09-06', 367, NULL),
('Residence Inn', 137, '2019-09-07', 345, NULL),
('Residence Inn', 137, '2019-09-08', 243, NULL),
('Residence Inn', 137, '2019-09-09', 146, NULL),
('Residence Inn', 137, '2019-09-10', 322, NULL),
('Residence Inn', 137, '2019-09-11', 340, NULL),
('Residence Inn', 137, '2019-09-12', 257, NULL),
('Residence Inn', 137, '2019-09-13', 115, NULL),
('Residence Inn', 137, '2019-09-14', 342, NULL),
('Residence Inn', 137, '2019-09-15', 231, NULL),
('Residence Inn', 137, '2019-09-16', 363, NULL),
('Residence Inn', 137, '2019-09-17', 114, NULL),
('Residence Inn', 137, '2019-09-18', 158, NULL),
('Residence Inn', 137, '2019-09-19', 301, NULL),
('Residence Inn', 137, '2019-09-20', 198, NULL),
('Residence Inn', 137, '2019-09-21', 201, NULL),
('Residence Inn', 137, '2019-09-22', 233, NULL),
('Residence Inn', 137, '2019-09-23', 272, NULL),
('Residence Inn', 137, '2019-09-24', 234, NULL),
('Residence Inn', 137, '2019-09-25', 123, NULL),
('Residence Inn', 137, '2019-09-26', 216, NULL),
('Residence Inn', 137, '2019-09-27', 278, NULL),
('Residence Inn', 137, '2019-09-28', 105, NULL),
('Residence Inn', 137, '2019-09-29', 126, NULL),
('Residence Inn', 137, '2019-09-30', 137, NULL),
('Residence Inn', 137, '2019-10-01', 381, NULL),
('Residence Inn', 137, '2019-10-02', 326, NULL),
('Residence Inn', 137, '2019-10-03', 358, NULL),
('Residence Inn', 137, '2019-10-04', 233, NULL),
('Residence Inn', 137, '2019-10-05', 179, NULL),
('Residence Inn', 137, '2019-10-06', 285, NULL),
('Residence Inn', 137, '2019-10-07', 175, NULL),
('Residence Inn', 137, '2019-10-08', 318, NULL),
('Residence Inn', 137, '2019-10-09', 377, NULL),
('Residence Inn', 137, '2019-10-10', 335, NULL),
('Residence Inn', 137, '2019-10-11', 178, NULL),
('Residence Inn', 137, '2019-10-12', 176, NULL),
('Residence Inn', 137, '2019-10-13', 386, NULL),
('Residence Inn', 137, '2019-10-14', 379, NULL),
('Residence Inn', 137, '2019-10-15', 342, NULL),
('Residence Inn', 137, '2019-10-16', 304, NULL),
('Residence Inn', 137, '2019-10-17', 171, NULL),
('Residence Inn', 137, '2019-10-18', 305, NULL),
('Residence Inn', 137, '2019-10-19', 146, NULL),
('Residence Inn', 137, '2019-10-20', 157, NULL),
('Residence Inn', 137, '2019-10-21', 110, NULL),
('Residence Inn', 137, '2019-10-22', 197, NULL),
('Residence Inn', 137, '2019-10-23', 203, NULL),
('Residence Inn', 137, '2019-10-24', 188, NULL),
('Residence Inn', 137, '2019-10-25', 194, NULL),
('Residence Inn', 137, '2019-10-26', 307, NULL),
('Residence Inn', 137, '2019-10-27', 215, NULL),
('Residence Inn', 137, '2019-10-28', 331, NULL),
('Residence Inn', 137, '2019-10-29', 143, NULL),
('Residence Inn', 137, '2019-10-30', 131, NULL),
('Residence Inn', 137, '2019-10-31', 188, NULL),
('Residence Inn', 137, '2019-11-01', 129, NULL),
('Residence Inn', 137, '2019-11-02', 107, NULL),
('Residence Inn', 137, '2019-11-03', 276, NULL),
('Residence Inn', 137, '2019-11-04', 234, NULL),
('Residence Inn', 137, '2019-11-05', 125, NULL),
('Residence Inn', 137, '2019-11-06', 162, NULL),
('Residence Inn', 137, '2019-11-07', 116, NULL),
('Residence Inn', 137, '2019-11-08', 191, NULL),
('Residence Inn', 137, '2019-11-09', 216, NULL),
('Residence Inn', 137, '2019-11-10', 329, NULL),
('Residence Inn', 137, '2019-11-11', 299, NULL),
('Residence Inn', 137, '2019-11-12', 335, NULL),
('Residence Inn', 137, '2019-11-13', 305, NULL),
('Residence Inn', 137, '2019-11-14', 242, NULL),
('Residence Inn', 137, '2019-11-15', 293, NULL),
('Residence Inn', 137, '2019-11-16', 211, NULL),
('Residence Inn', 137, '2019-11-17', 116, NULL),
('Residence Inn', 137, '2019-11-18', 151, NULL),
('Residence Inn', 137, '2019-11-19', 298, NULL),
('Residence Inn', 137, '2019-11-20', 379, NULL),
('Residence Inn', 137, '2019-11-21', 349, NULL),
('Residence Inn', 137, '2019-11-22', 118, NULL),
('Residence Inn', 137, '2019-11-23', 237, NULL),
('Residence Inn', 137, '2019-11-24', 148, NULL),
('Residence Inn', 137, '2019-11-25', 103, NULL),
('Residence Inn', 137, '2019-11-26', 140, NULL),
('Residence Inn', 137, '2019-11-27', 260, NULL),
('Residence Inn', 137, '2019-11-28', 236, NULL),
('Residence Inn', 137, '2019-11-29', 347, NULL),
('Residence Inn', 137, '2019-11-30', 217, NULL),
('Residence Inn', 137, '2019-12-01', 239, NULL),
('Residence Inn', 137, '2019-12-02', 355, NULL),
('Residence Inn', 137, '2019-12-03', 375, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 137, '2019-12-04', 344, NULL),
('Residence Inn', 137, '2019-12-05', 273, NULL),
('Residence Inn', 137, '2019-12-06', 163, NULL),
('Residence Inn', 137, '2019-12-07', 285, NULL),
('Residence Inn', 137, '2019-12-08', 312, NULL),
('Residence Inn', 137, '2019-12-09', 118, NULL),
('Residence Inn', 137, '2019-12-10', 123, NULL),
('Residence Inn', 137, '2019-12-11', 242, NULL),
('Residence Inn', 137, '2019-12-12', 328, NULL),
('Residence Inn', 137, '2019-12-13', 288, NULL),
('Residence Inn', 137, '2019-12-14', 170, NULL),
('Residence Inn', 137, '2019-12-15', 304, NULL),
('Residence Inn', 137, '2019-12-16', 276, NULL),
('Residence Inn', 137, '2019-12-17', 217, NULL),
('Residence Inn', 137, '2019-12-18', 248, NULL),
('Residence Inn', 137, '2019-12-19', 104, NULL),
('Residence Inn', 137, '2019-12-20', 379, NULL),
('Residence Inn', 137, '2019-12-21', 256, NULL),
('Residence Inn', 137, '2019-12-22', 205, NULL),
('Residence Inn', 137, '2019-12-23', 364, NULL),
('Residence Inn', 137, '2019-12-24', 140, NULL),
('Residence Inn', 137, '2019-12-25', 231, NULL),
('Residence Inn', 137, '2019-12-26', 336, NULL),
('Residence Inn', 137, '2019-12-27', 379, NULL),
('Residence Inn', 137, '2019-12-28', 127, NULL),
('Residence Inn', 137, '2019-12-29', 110, NULL),
('Residence Inn', 137, '2019-12-30', 227, NULL),
('Residence Inn', 137, '2019-12-31', 214, NULL),
('Residence Inn', 137, '2020-01-01', 211, NULL),
('Residence Inn', 137, '2020-01-02', 392, NULL),
('Residence Inn', 137, '2020-01-03', 399, NULL),
('Residence Inn', 137, '2020-01-04', 196, NULL),
('Residence Inn', 137, '2020-01-05', 160, NULL),
('Residence Inn', 137, '2020-01-06', 335, NULL),
('Residence Inn', 137, '2020-01-07', 212, NULL),
('Residence Inn', 137, '2020-01-08', 140, NULL),
('Residence Inn', 137, '2020-01-09', 161, NULL),
('Residence Inn', 137, '2020-01-10', 122, NULL),
('Residence Inn', 137, '2020-01-11', 316, NULL),
('Residence Inn', 137, '2020-01-12', 100, NULL),
('Residence Inn', 137, '2020-01-13', 357, NULL),
('Residence Inn', 137, '2020-01-14', 322, NULL),
('Residence Inn', 137, '2020-01-15', 257, NULL),
('Residence Inn', 137, '2020-01-16', 277, NULL),
('Residence Inn', 137, '2020-01-17', 397, NULL),
('Residence Inn', 137, '2020-01-18', 335, NULL),
('Residence Inn', 137, '2020-01-19', 314, NULL),
('Residence Inn', 137, '2020-01-20', 139, NULL),
('Residence Inn', 137, '2020-01-21', 261, NULL),
('Residence Inn', 137, '2020-01-22', 345, NULL),
('Residence Inn', 137, '2020-01-23', 268, NULL),
('Residence Inn', 137, '2020-01-24', 368, NULL),
('Residence Inn', 137, '2020-01-25', 361, NULL),
('Residence Inn', 137, '2020-01-26', 315, NULL),
('Residence Inn', 137, '2020-01-27', 328, NULL),
('Residence Inn', 137, '2020-01-28', 223, NULL),
('Residence Inn', 137, '2020-01-29', 142, NULL),
('Residence Inn', 137, '2020-01-30', 181, NULL),
('Residence Inn', 137, '2020-01-31', 133, NULL),
('Residence Inn', 137, '2020-02-01', 330, NULL),
('Residence Inn', 137, '2020-02-02', 387, NULL),
('Residence Inn', 137, '2020-02-03', 333, NULL),
('Residence Inn', 137, '2020-02-04', 220, NULL),
('Residence Inn', 156, '2019-01-01', 396, NULL),
('Residence Inn', 156, '2019-01-02', 387, NULL),
('Residence Inn', 156, '2019-01-03', 121, NULL),
('Residence Inn', 156, '2019-01-04', 111, NULL),
('Residence Inn', 156, '2019-01-05', 316, NULL),
('Residence Inn', 156, '2019-01-06', 151, NULL),
('Residence Inn', 156, '2019-01-07', 280, NULL),
('Residence Inn', 156, '2019-01-08', 207, NULL),
('Residence Inn', 156, '2019-01-09', 182, NULL),
('Residence Inn', 156, '2019-01-10', 343, NULL),
('Residence Inn', 156, '2019-01-11', 302, NULL),
('Residence Inn', 156, '2019-01-12', 366, NULL),
('Residence Inn', 156, '2019-01-13', 334, NULL),
('Residence Inn', 156, '2019-01-14', 140, NULL),
('Residence Inn', 156, '2019-01-15', 277, NULL),
('Residence Inn', 156, '2019-01-16', 249, NULL),
('Residence Inn', 156, '2019-01-17', 389, NULL),
('Residence Inn', 156, '2019-01-18', 392, NULL),
('Residence Inn', 156, '2019-01-19', 172, NULL),
('Residence Inn', 156, '2019-01-20', 328, NULL),
('Residence Inn', 156, '2019-01-21', 141, NULL),
('Residence Inn', 156, '2019-01-22', 279, NULL),
('Residence Inn', 156, '2019-01-23', 371, NULL),
('Residence Inn', 156, '2019-01-24', 193, NULL),
('Residence Inn', 156, '2019-01-25', 112, NULL),
('Residence Inn', 156, '2019-01-26', 326, NULL),
('Residence Inn', 156, '2019-01-27', 173, NULL),
('Residence Inn', 156, '2019-01-28', 172, NULL),
('Residence Inn', 156, '2019-01-29', 103, NULL),
('Residence Inn', 156, '2019-01-30', 370, NULL),
('Residence Inn', 156, '2019-01-31', 278, NULL),
('Residence Inn', 156, '2019-02-01', 172, NULL),
('Residence Inn', 156, '2019-02-02', 243, NULL),
('Residence Inn', 156, '2019-02-03', 211, NULL),
('Residence Inn', 156, '2019-02-04', 383, NULL),
('Residence Inn', 156, '2019-02-05', 246, NULL),
('Residence Inn', 156, '2019-02-06', 122, NULL),
('Residence Inn', 156, '2019-02-07', 262, NULL),
('Residence Inn', 156, '2019-02-08', 199, NULL),
('Residence Inn', 156, '2019-02-09', 290, NULL),
('Residence Inn', 156, '2019-02-10', 134, NULL),
('Residence Inn', 156, '2019-02-11', 393, NULL),
('Residence Inn', 156, '2019-02-12', 185, NULL),
('Residence Inn', 156, '2019-02-13', 165, NULL),
('Residence Inn', 156, '2019-02-14', 254, NULL),
('Residence Inn', 156, '2019-02-15', 334, NULL),
('Residence Inn', 156, '2019-02-16', 352, NULL),
('Residence Inn', 156, '2019-02-17', 122, NULL),
('Residence Inn', 156, '2019-02-18', 149, NULL),
('Residence Inn', 156, '2019-02-19', 242, NULL),
('Residence Inn', 156, '2019-02-20', 190, NULL),
('Residence Inn', 156, '2019-02-21', 354, NULL),
('Residence Inn', 156, '2019-02-22', 249, NULL),
('Residence Inn', 156, '2019-02-23', 244, NULL),
('Residence Inn', 156, '2019-02-24', 134, NULL),
('Residence Inn', 156, '2019-02-25', 354, NULL),
('Residence Inn', 156, '2019-02-26', 294, NULL),
('Residence Inn', 156, '2019-02-27', 174, NULL),
('Residence Inn', 156, '2019-02-28', 355, NULL),
('Residence Inn', 156, '2019-03-01', 374, NULL),
('Residence Inn', 156, '2019-03-02', 126, NULL),
('Residence Inn', 156, '2019-03-03', 180, NULL),
('Residence Inn', 156, '2019-03-04', 337, NULL),
('Residence Inn', 156, '2019-03-05', 220, NULL),
('Residence Inn', 156, '2019-03-06', 171, NULL),
('Residence Inn', 156, '2019-03-07', 170, NULL),
('Residence Inn', 156, '2019-03-08', 162, NULL),
('Residence Inn', 156, '2019-03-09', 352, NULL),
('Residence Inn', 156, '2019-03-10', 258, NULL),
('Residence Inn', 156, '2019-03-11', 287, NULL),
('Residence Inn', 156, '2019-03-12', 277, NULL),
('Residence Inn', 156, '2019-03-13', 196, NULL),
('Residence Inn', 156, '2019-03-14', 180, NULL),
('Residence Inn', 156, '2019-03-15', 286, NULL),
('Residence Inn', 156, '2019-03-16', 290, NULL),
('Residence Inn', 156, '2019-03-17', 144, NULL),
('Residence Inn', 156, '2019-03-18', 392, NULL),
('Residence Inn', 156, '2019-03-19', 219, NULL),
('Residence Inn', 156, '2019-03-20', 373, NULL),
('Residence Inn', 156, '2019-03-21', 130, NULL),
('Residence Inn', 156, '2019-03-22', 345, NULL),
('Residence Inn', 156, '2019-03-23', 147, NULL),
('Residence Inn', 156, '2019-03-24', 339, NULL),
('Residence Inn', 156, '2019-03-25', 230, NULL),
('Residence Inn', 156, '2019-03-26', 200, NULL),
('Residence Inn', 156, '2019-03-27', 348, NULL),
('Residence Inn', 156, '2019-03-28', 254, NULL),
('Residence Inn', 156, '2019-03-29', 314, NULL),
('Residence Inn', 156, '2019-03-30', 315, NULL),
('Residence Inn', 156, '2019-03-31', 215, NULL),
('Residence Inn', 156, '2019-04-01', 106, NULL),
('Residence Inn', 156, '2019-04-02', 163, NULL),
('Residence Inn', 156, '2019-04-03', 229, NULL),
('Residence Inn', 156, '2019-04-04', 228, NULL),
('Residence Inn', 156, '2019-04-05', 184, NULL),
('Residence Inn', 156, '2019-04-06', 183, NULL),
('Residence Inn', 156, '2019-04-07', 330, NULL),
('Residence Inn', 156, '2019-04-08', 158, NULL),
('Residence Inn', 156, '2019-04-09', 227, NULL),
('Residence Inn', 156, '2019-04-10', 283, NULL),
('Residence Inn', 156, '2019-04-11', 270, NULL),
('Residence Inn', 156, '2019-04-12', 309, NULL),
('Residence Inn', 156, '2019-04-13', 145, NULL),
('Residence Inn', 156, '2019-04-14', 147, NULL),
('Residence Inn', 156, '2019-04-15', 144, NULL),
('Residence Inn', 156, '2019-04-16', 242, NULL),
('Residence Inn', 156, '2019-04-17', 168, NULL),
('Residence Inn', 156, '2019-04-18', 347, NULL),
('Residence Inn', 156, '2019-04-19', 191, NULL),
('Residence Inn', 156, '2019-04-20', 398, NULL),
('Residence Inn', 156, '2019-04-21', 291, NULL),
('Residence Inn', 156, '2019-04-22', 305, NULL),
('Residence Inn', 156, '2019-04-23', 117, NULL),
('Residence Inn', 156, '2019-04-24', 191, NULL),
('Residence Inn', 156, '2019-04-25', 146, NULL),
('Residence Inn', 156, '2019-04-26', 237, NULL),
('Residence Inn', 156, '2019-04-27', 304, NULL),
('Residence Inn', 156, '2019-04-28', 198, NULL),
('Residence Inn', 156, '2019-04-29', 287, NULL),
('Residence Inn', 156, '2019-04-30', 205, NULL),
('Residence Inn', 156, '2019-05-01', 280, NULL),
('Residence Inn', 156, '2019-05-02', 282, NULL),
('Residence Inn', 156, '2019-05-03', 226, NULL),
('Residence Inn', 156, '2019-05-04', 275, NULL),
('Residence Inn', 156, '2019-05-05', 159, NULL),
('Residence Inn', 156, '2019-05-06', 186, NULL),
('Residence Inn', 156, '2019-05-07', 374, NULL),
('Residence Inn', 156, '2019-05-08', 388, NULL),
('Residence Inn', 156, '2019-05-09', 399, NULL),
('Residence Inn', 156, '2019-05-10', 208, NULL),
('Residence Inn', 156, '2019-05-11', 122, NULL),
('Residence Inn', 156, '2019-05-12', 386, NULL),
('Residence Inn', 156, '2019-05-13', 293, NULL),
('Residence Inn', 156, '2019-05-14', 112, NULL),
('Residence Inn', 156, '2019-05-15', 305, NULL),
('Residence Inn', 156, '2019-05-16', 119, NULL),
('Residence Inn', 156, '2019-05-17', 226, NULL),
('Residence Inn', 156, '2019-05-18', 127, NULL),
('Residence Inn', 156, '2019-05-19', 158, NULL),
('Residence Inn', 156, '2019-05-20', 287, NULL),
('Residence Inn', 156, '2019-05-21', 169, NULL),
('Residence Inn', 156, '2019-05-22', 155, NULL),
('Residence Inn', 156, '2019-05-23', 263, NULL),
('Residence Inn', 156, '2019-05-24', 111, NULL),
('Residence Inn', 156, '2019-05-25', 212, NULL),
('Residence Inn', 156, '2019-05-26', 329, NULL),
('Residence Inn', 156, '2019-05-27', 191, NULL),
('Residence Inn', 156, '2019-05-28', 397, NULL),
('Residence Inn', 156, '2019-05-29', 104, NULL),
('Residence Inn', 156, '2019-05-30', 272, NULL),
('Residence Inn', 156, '2019-05-31', 183, NULL),
('Residence Inn', 156, '2019-06-01', 181, NULL),
('Residence Inn', 156, '2019-06-02', 155, NULL),
('Residence Inn', 156, '2019-06-03', 375, NULL),
('Residence Inn', 156, '2019-06-04', 308, NULL),
('Residence Inn', 156, '2019-06-05', 122, NULL),
('Residence Inn', 156, '2019-06-06', 214, NULL),
('Residence Inn', 156, '2019-06-07', 200, NULL),
('Residence Inn', 156, '2019-06-08', 370, NULL),
('Residence Inn', 156, '2019-06-09', 363, NULL),
('Residence Inn', 156, '2019-06-10', 294, NULL),
('Residence Inn', 156, '2019-06-11', 308, NULL),
('Residence Inn', 156, '2019-06-12', 100, NULL),
('Residence Inn', 156, '2019-06-13', 360, NULL),
('Residence Inn', 156, '2019-06-14', 134, NULL),
('Residence Inn', 156, '2019-06-15', 210, NULL),
('Residence Inn', 156, '2019-06-16', 171, NULL),
('Residence Inn', 156, '2019-06-17', 224, NULL),
('Residence Inn', 156, '2019-06-18', 208, NULL),
('Residence Inn', 156, '2019-06-19', 178, NULL),
('Residence Inn', 156, '2019-06-20', 120, NULL),
('Residence Inn', 156, '2019-06-21', 299, NULL),
('Residence Inn', 156, '2019-06-22', 146, NULL),
('Residence Inn', 156, '2019-06-23', 379, NULL),
('Residence Inn', 156, '2019-06-24', 356, NULL),
('Residence Inn', 156, '2019-06-25', 252, NULL),
('Residence Inn', 156, '2019-06-26', 329, NULL),
('Residence Inn', 156, '2019-06-27', 342, NULL),
('Residence Inn', 156, '2019-06-28', 363, NULL),
('Residence Inn', 156, '2019-06-29', 322, NULL),
('Residence Inn', 156, '2019-06-30', 215, NULL),
('Residence Inn', 156, '2019-07-01', 261, NULL),
('Residence Inn', 156, '2019-07-02', 303, NULL),
('Residence Inn', 156, '2019-07-03', 212, NULL),
('Residence Inn', 156, '2019-07-04', 346, NULL),
('Residence Inn', 156, '2019-07-05', 372, NULL),
('Residence Inn', 156, '2019-07-06', 315, NULL),
('Residence Inn', 156, '2019-07-07', 195, NULL),
('Residence Inn', 156, '2019-07-08', 190, NULL),
('Residence Inn', 156, '2019-07-09', 119, NULL),
('Residence Inn', 156, '2019-07-10', 160, NULL),
('Residence Inn', 156, '2019-07-11', 324, NULL),
('Residence Inn', 156, '2019-07-12', 207, NULL),
('Residence Inn', 156, '2019-07-13', 144, NULL),
('Residence Inn', 156, '2019-07-14', 115, NULL),
('Residence Inn', 156, '2019-07-15', 100, NULL),
('Residence Inn', 156, '2019-07-16', 195, NULL),
('Residence Inn', 156, '2019-07-17', 360, NULL),
('Residence Inn', 156, '2019-07-18', 225, NULL),
('Residence Inn', 156, '2019-07-19', 168, NULL),
('Residence Inn', 156, '2019-07-20', 326, NULL),
('Residence Inn', 156, '2019-07-21', 101, NULL),
('Residence Inn', 156, '2019-07-22', 369, NULL),
('Residence Inn', 156, '2019-07-23', 218, NULL),
('Residence Inn', 156, '2019-07-24', 305, NULL),
('Residence Inn', 156, '2019-07-25', 143, NULL),
('Residence Inn', 156, '2019-07-26', 312, NULL),
('Residence Inn', 156, '2019-07-27', 113, NULL),
('Residence Inn', 156, '2019-07-28', 171, NULL),
('Residence Inn', 156, '2019-07-29', 303, NULL),
('Residence Inn', 156, '2019-07-30', 210, NULL),
('Residence Inn', 156, '2019-07-31', 178, NULL),
('Residence Inn', 156, '2019-08-01', 292, NULL),
('Residence Inn', 156, '2019-08-02', 254, NULL),
('Residence Inn', 156, '2019-08-03', 153, NULL),
('Residence Inn', 156, '2019-08-04', 256, NULL),
('Residence Inn', 156, '2019-08-05', 310, NULL),
('Residence Inn', 156, '2019-08-06', 239, NULL),
('Residence Inn', 156, '2019-08-07', 155, NULL),
('Residence Inn', 156, '2019-08-08', 141, NULL),
('Residence Inn', 156, '2019-08-09', 185, NULL),
('Residence Inn', 156, '2019-08-10', 254, NULL),
('Residence Inn', 156, '2019-08-11', 386, NULL),
('Residence Inn', 156, '2019-08-12', 329, NULL),
('Residence Inn', 156, '2019-08-13', 197, NULL),
('Residence Inn', 156, '2019-08-14', 333, NULL),
('Residence Inn', 156, '2019-08-15', 378, NULL),
('Residence Inn', 156, '2019-08-16', 394, NULL),
('Residence Inn', 156, '2019-08-17', 153, NULL),
('Residence Inn', 156, '2019-08-18', 301, NULL),
('Residence Inn', 156, '2019-08-19', 361, NULL),
('Residence Inn', 156, '2019-08-20', 191, NULL),
('Residence Inn', 156, '2019-08-21', 100, NULL),
('Residence Inn', 156, '2019-08-22', 309, NULL),
('Residence Inn', 156, '2019-08-23', 333, NULL),
('Residence Inn', 156, '2019-08-24', 142, NULL),
('Residence Inn', 156, '2019-08-25', 374, NULL),
('Residence Inn', 156, '2019-08-26', 182, NULL),
('Residence Inn', 156, '2019-08-27', 161, NULL),
('Residence Inn', 156, '2019-08-28', 283, NULL),
('Residence Inn', 156, '2019-08-29', 297, NULL),
('Residence Inn', 156, '2019-08-30', 335, NULL),
('Residence Inn', 156, '2019-08-31', 266, NULL),
('Residence Inn', 156, '2019-09-01', 241, NULL),
('Residence Inn', 156, '2019-09-02', 243, NULL),
('Residence Inn', 156, '2019-09-03', 335, NULL),
('Residence Inn', 156, '2019-09-04', 241, NULL),
('Residence Inn', 156, '2019-09-05', 349, NULL),
('Residence Inn', 156, '2019-09-06', 262, NULL),
('Residence Inn', 156, '2019-09-07', 344, NULL),
('Residence Inn', 156, '2019-09-08', 309, NULL),
('Residence Inn', 156, '2019-09-09', 269, NULL),
('Residence Inn', 156, '2019-09-10', 101, NULL),
('Residence Inn', 156, '2019-09-11', 149, NULL),
('Residence Inn', 156, '2019-09-12', 236, NULL),
('Residence Inn', 156, '2019-09-13', 235, NULL),
('Residence Inn', 156, '2019-09-14', 269, NULL),
('Residence Inn', 156, '2019-09-15', 275, NULL),
('Residence Inn', 156, '2019-09-16', 237, NULL),
('Residence Inn', 156, '2019-09-17', 145, NULL),
('Residence Inn', 156, '2019-09-18', 348, NULL),
('Residence Inn', 156, '2019-09-19', 263, NULL),
('Residence Inn', 156, '2019-09-20', 213, NULL),
('Residence Inn', 156, '2019-09-21', 199, NULL),
('Residence Inn', 156, '2019-09-22', 362, NULL),
('Residence Inn', 156, '2019-09-23', 320, NULL),
('Residence Inn', 156, '2019-09-24', 200, NULL),
('Residence Inn', 156, '2019-09-25', 163, NULL),
('Residence Inn', 156, '2019-09-26', 268, NULL),
('Residence Inn', 156, '2019-09-27', 345, NULL),
('Residence Inn', 156, '2019-09-28', 255, NULL),
('Residence Inn', 156, '2019-09-29', 232, NULL),
('Residence Inn', 156, '2019-09-30', 380, NULL),
('Residence Inn', 156, '2019-10-01', 259, NULL),
('Residence Inn', 156, '2019-10-02', 373, NULL),
('Residence Inn', 156, '2019-10-03', 237, NULL),
('Residence Inn', 156, '2019-10-04', 167, NULL),
('Residence Inn', 156, '2019-10-05', 100, NULL),
('Residence Inn', 156, '2019-10-06', 291, NULL),
('Residence Inn', 156, '2019-10-07', 358, NULL),
('Residence Inn', 156, '2019-10-08', 318, NULL),
('Residence Inn', 156, '2019-10-09', 205, NULL),
('Residence Inn', 156, '2019-10-10', 372, NULL),
('Residence Inn', 156, '2019-10-11', 212, NULL),
('Residence Inn', 156, '2019-10-12', 324, NULL),
('Residence Inn', 156, '2019-10-13', 250, NULL),
('Residence Inn', 156, '2019-10-14', 277, NULL),
('Residence Inn', 156, '2019-10-15', 351, NULL),
('Residence Inn', 156, '2019-10-16', 241, NULL),
('Residence Inn', 156, '2019-10-17', 275, NULL),
('Residence Inn', 156, '2019-10-18', 295, NULL),
('Residence Inn', 156, '2019-10-19', 103, NULL),
('Residence Inn', 156, '2019-10-20', 110, NULL),
('Residence Inn', 156, '2019-10-21', 169, NULL),
('Residence Inn', 156, '2019-10-22', 238, NULL),
('Residence Inn', 156, '2019-10-23', 180, NULL),
('Residence Inn', 156, '2019-10-24', 176, NULL),
('Residence Inn', 156, '2019-10-25', 351, NULL),
('Residence Inn', 156, '2019-10-26', 212, NULL),
('Residence Inn', 156, '2019-10-27', 274, NULL),
('Residence Inn', 156, '2019-10-28', 242, NULL),
('Residence Inn', 156, '2019-10-29', 359, NULL),
('Residence Inn', 156, '2019-10-30', 322, NULL),
('Residence Inn', 156, '2019-10-31', 104, NULL),
('Residence Inn', 156, '2019-11-01', 239, NULL),
('Residence Inn', 156, '2019-11-02', 287, NULL),
('Residence Inn', 156, '2019-11-03', 345, NULL),
('Residence Inn', 156, '2019-11-04', 342, NULL),
('Residence Inn', 156, '2019-11-05', 191, NULL),
('Residence Inn', 156, '2019-11-06', 144, NULL),
('Residence Inn', 156, '2019-11-07', 114, NULL),
('Residence Inn', 156, '2019-11-08', 112, NULL),
('Residence Inn', 156, '2019-11-09', 187, NULL),
('Residence Inn', 156, '2019-11-10', 187, NULL),
('Residence Inn', 156, '2019-11-11', 110, NULL),
('Residence Inn', 156, '2019-11-12', 174, NULL),
('Residence Inn', 156, '2019-11-13', 264, NULL),
('Residence Inn', 156, '2019-11-14', 230, NULL),
('Residence Inn', 156, '2019-11-15', 122, NULL),
('Residence Inn', 156, '2019-11-16', 136, NULL),
('Residence Inn', 156, '2019-11-17', 185, NULL),
('Residence Inn', 156, '2019-11-18', 279, NULL),
('Residence Inn', 156, '2019-11-19', 296, NULL),
('Residence Inn', 156, '2019-11-20', 136, NULL),
('Residence Inn', 156, '2019-11-21', 391, NULL),
('Residence Inn', 156, '2019-11-22', 357, NULL),
('Residence Inn', 156, '2019-11-23', 176, NULL),
('Residence Inn', 156, '2019-11-24', 256, NULL),
('Residence Inn', 156, '2019-11-25', 278, NULL),
('Residence Inn', 156, '2019-11-26', 156, NULL),
('Residence Inn', 156, '2019-11-27', 161, NULL),
('Residence Inn', 156, '2019-11-28', 257, NULL),
('Residence Inn', 156, '2019-11-29', 334, NULL),
('Residence Inn', 156, '2019-11-30', 375, NULL),
('Residence Inn', 156, '2019-12-01', 221, NULL),
('Residence Inn', 156, '2019-12-02', 344, NULL),
('Residence Inn', 156, '2019-12-03', 154, NULL),
('Residence Inn', 156, '2019-12-04', 358, NULL),
('Residence Inn', 156, '2019-12-05', 105, NULL),
('Residence Inn', 156, '2019-12-06', 167, NULL),
('Residence Inn', 156, '2019-12-07', 273, NULL),
('Residence Inn', 156, '2019-12-08', 204, NULL),
('Residence Inn', 156, '2019-12-09', 305, NULL),
('Residence Inn', 156, '2019-12-10', 164, NULL),
('Residence Inn', 156, '2019-12-11', 297, NULL),
('Residence Inn', 156, '2019-12-12', 119, NULL),
('Residence Inn', 156, '2019-12-13', 233, NULL),
('Residence Inn', 156, '2019-12-14', 297, NULL),
('Residence Inn', 156, '2019-12-15', 106, NULL),
('Residence Inn', 156, '2019-12-16', 220, NULL),
('Residence Inn', 156, '2019-12-17', 369, NULL),
('Residence Inn', 156, '2019-12-18', 341, NULL),
('Residence Inn', 156, '2019-12-19', 197, NULL),
('Residence Inn', 156, '2019-12-20', 209, NULL),
('Residence Inn', 156, '2019-12-21', 153, NULL),
('Residence Inn', 156, '2019-12-22', 268, NULL),
('Residence Inn', 156, '2019-12-23', 347, NULL),
('Residence Inn', 156, '2019-12-24', 160, NULL),
('Residence Inn', 156, '2019-12-25', 317, NULL),
('Residence Inn', 156, '2019-12-26', 152, NULL),
('Residence Inn', 156, '2019-12-27', 239, NULL),
('Residence Inn', 156, '2019-12-28', 313, NULL),
('Residence Inn', 156, '2019-12-29', 395, NULL),
('Residence Inn', 156, '2019-12-30', 220, NULL),
('Residence Inn', 156, '2019-12-31', 396, NULL),
('Residence Inn', 156, '2020-01-01', 193, NULL),
('Residence Inn', 156, '2020-01-02', 175, NULL),
('Residence Inn', 156, '2020-01-03', 266, NULL),
('Residence Inn', 156, '2020-01-04', 319, NULL),
('Residence Inn', 156, '2020-01-05', 311, NULL),
('Residence Inn', 156, '2020-01-06', 381, NULL),
('Residence Inn', 156, '2020-01-07', 195, NULL),
('Residence Inn', 156, '2020-01-08', 218, NULL),
('Residence Inn', 156, '2020-01-09', 176, NULL),
('Residence Inn', 156, '2020-01-10', 389, NULL),
('Residence Inn', 156, '2020-01-11', 298, NULL),
('Residence Inn', 156, '2020-01-12', 387, NULL),
('Residence Inn', 156, '2020-01-13', 250, NULL),
('Residence Inn', 156, '2020-01-14', 385, NULL),
('Residence Inn', 156, '2020-01-15', 382, NULL),
('Residence Inn', 156, '2020-01-16', 179, NULL),
('Residence Inn', 156, '2020-01-17', 109, NULL),
('Residence Inn', 156, '2020-01-18', 294, NULL),
('Residence Inn', 156, '2020-01-19', 386, NULL),
('Residence Inn', 156, '2020-01-20', 265, NULL),
('Residence Inn', 156, '2020-01-21', 341, NULL),
('Residence Inn', 156, '2020-01-22', 330, NULL),
('Residence Inn', 156, '2020-01-23', 133, NULL),
('Residence Inn', 156, '2020-01-24', 144, NULL),
('Residence Inn', 156, '2020-01-25', 282, NULL),
('Residence Inn', 156, '2020-01-26', 252, NULL),
('Residence Inn', 156, '2020-01-27', 270, NULL),
('Residence Inn', 156, '2020-01-28', 252, NULL),
('Residence Inn', 156, '2020-01-29', 255, NULL),
('Residence Inn', 156, '2020-01-30', 248, NULL),
('Residence Inn', 156, '2020-01-31', 360, NULL),
('Residence Inn', 156, '2020-02-01', 365, NULL),
('Residence Inn', 156, '2020-02-02', 347, NULL),
('Residence Inn', 156, '2020-02-03', 302, NULL),
('Residence Inn', 156, '2020-02-04', 248, NULL),
('Residence Inn', 160, '2019-01-01', 279, NULL),
('Residence Inn', 160, '2019-01-02', 105, NULL),
('Residence Inn', 160, '2019-01-03', 390, NULL),
('Residence Inn', 160, '2019-01-04', 375, NULL),
('Residence Inn', 160, '2019-01-05', 318, NULL),
('Residence Inn', 160, '2019-01-06', 113, NULL),
('Residence Inn', 160, '2019-01-07', 214, NULL),
('Residence Inn', 160, '2019-01-08', 163, NULL),
('Residence Inn', 160, '2019-01-09', 219, NULL),
('Residence Inn', 160, '2019-01-10', 143, NULL),
('Residence Inn', 160, '2019-01-11', 197, NULL),
('Residence Inn', 160, '2019-01-12', 190, NULL),
('Residence Inn', 160, '2019-01-13', 127, NULL),
('Residence Inn', 160, '2019-01-14', 315, NULL),
('Residence Inn', 160, '2019-01-15', 167, NULL),
('Residence Inn', 160, '2019-01-16', 399, NULL),
('Residence Inn', 160, '2019-01-17', 227, NULL),
('Residence Inn', 160, '2019-01-18', 223, NULL),
('Residence Inn', 160, '2019-01-19', 328, NULL),
('Residence Inn', 160, '2019-01-20', 277, NULL),
('Residence Inn', 160, '2019-01-21', 375, NULL),
('Residence Inn', 160, '2019-01-22', 241, NULL),
('Residence Inn', 160, '2019-01-23', 317, NULL),
('Residence Inn', 160, '2019-01-24', 267, NULL),
('Residence Inn', 160, '2019-01-25', 312, NULL),
('Residence Inn', 160, '2019-01-26', 244, NULL),
('Residence Inn', 160, '2019-01-27', 336, NULL),
('Residence Inn', 160, '2019-01-28', 282, NULL),
('Residence Inn', 160, '2019-01-29', 384, NULL),
('Residence Inn', 160, '2019-01-30', 119, NULL),
('Residence Inn', 160, '2019-01-31', 306, NULL),
('Residence Inn', 160, '2019-02-01', 272, NULL),
('Residence Inn', 160, '2019-02-02', 147, NULL),
('Residence Inn', 160, '2019-02-03', 363, NULL),
('Residence Inn', 160, '2019-02-04', 185, NULL),
('Residence Inn', 160, '2019-02-05', 218, NULL),
('Residence Inn', 160, '2019-02-06', 317, NULL),
('Residence Inn', 160, '2019-02-07', 369, NULL),
('Residence Inn', 160, '2019-02-08', 177, NULL),
('Residence Inn', 160, '2019-02-09', 116, NULL),
('Residence Inn', 160, '2019-02-10', 265, NULL),
('Residence Inn', 160, '2019-02-11', 131, NULL),
('Residence Inn', 160, '2019-02-12', 297, NULL),
('Residence Inn', 160, '2019-02-13', 354, NULL),
('Residence Inn', 160, '2019-02-14', 266, NULL),
('Residence Inn', 160, '2019-02-15', 193, NULL),
('Residence Inn', 160, '2019-02-16', 328, NULL),
('Residence Inn', 160, '2019-02-17', 299, NULL),
('Residence Inn', 160, '2019-02-18', 162, NULL),
('Residence Inn', 160, '2019-02-19', 286, NULL),
('Residence Inn', 160, '2019-02-20', 197, NULL),
('Residence Inn', 160, '2019-02-21', 353, NULL),
('Residence Inn', 160, '2019-02-22', 179, NULL),
('Residence Inn', 160, '2019-02-23', 343, NULL),
('Residence Inn', 160, '2019-02-24', 200, NULL),
('Residence Inn', 160, '2019-02-25', 106, NULL),
('Residence Inn', 160, '2019-02-26', 333, NULL),
('Residence Inn', 160, '2019-02-27', 198, NULL),
('Residence Inn', 160, '2019-02-28', 349, NULL),
('Residence Inn', 160, '2019-03-01', 198, NULL),
('Residence Inn', 160, '2019-03-02', 318, NULL),
('Residence Inn', 160, '2019-03-03', 267, NULL),
('Residence Inn', 160, '2019-03-04', 230, NULL),
('Residence Inn', 160, '2019-03-05', 365, NULL),
('Residence Inn', 160, '2019-03-06', 271, NULL),
('Residence Inn', 160, '2019-03-07', 180, NULL),
('Residence Inn', 160, '2019-03-08', 391, NULL),
('Residence Inn', 160, '2019-03-09', 147, NULL),
('Residence Inn', 160, '2019-03-10', 397, NULL),
('Residence Inn', 160, '2019-03-11', 246, NULL),
('Residence Inn', 160, '2019-03-12', 373, NULL),
('Residence Inn', 160, '2019-03-13', 220, NULL),
('Residence Inn', 160, '2019-03-14', 253, NULL),
('Residence Inn', 160, '2019-03-15', 181, NULL),
('Residence Inn', 160, '2019-03-16', 154, NULL),
('Residence Inn', 160, '2019-03-17', 367, NULL),
('Residence Inn', 160, '2019-03-18', 218, NULL),
('Residence Inn', 160, '2019-03-19', 156, NULL),
('Residence Inn', 160, '2019-03-20', 108, NULL),
('Residence Inn', 160, '2019-03-21', 375, NULL),
('Residence Inn', 160, '2019-03-22', 121, NULL),
('Residence Inn', 160, '2019-03-23', 221, NULL),
('Residence Inn', 160, '2019-03-24', 261, NULL),
('Residence Inn', 160, '2019-03-25', 318, NULL),
('Residence Inn', 160, '2019-03-26', 257, NULL),
('Residence Inn', 160, '2019-03-27', 343, NULL),
('Residence Inn', 160, '2019-03-28', 117, NULL),
('Residence Inn', 160, '2019-03-29', 269, NULL),
('Residence Inn', 160, '2019-03-30', 300, NULL),
('Residence Inn', 160, '2019-03-31', 143, NULL),
('Residence Inn', 160, '2019-04-01', 176, NULL),
('Residence Inn', 160, '2019-04-02', 356, NULL),
('Residence Inn', 160, '2019-04-03', 240, NULL),
('Residence Inn', 160, '2019-04-04', 391, NULL),
('Residence Inn', 160, '2019-04-05', 293, NULL),
('Residence Inn', 160, '2019-04-06', 258, NULL),
('Residence Inn', 160, '2019-04-07', 135, NULL),
('Residence Inn', 160, '2019-04-08', 142, NULL),
('Residence Inn', 160, '2019-04-09', 114, NULL),
('Residence Inn', 160, '2019-04-10', 366, NULL),
('Residence Inn', 160, '2019-04-11', 198, NULL),
('Residence Inn', 160, '2019-04-12', 151, NULL),
('Residence Inn', 160, '2019-04-13', 383, NULL),
('Residence Inn', 160, '2019-04-14', 357, NULL),
('Residence Inn', 160, '2019-04-15', 330, NULL),
('Residence Inn', 160, '2019-04-16', 114, NULL),
('Residence Inn', 160, '2019-04-17', 191, NULL),
('Residence Inn', 160, '2019-04-18', 177, NULL),
('Residence Inn', 160, '2019-04-19', 156, NULL),
('Residence Inn', 160, '2019-04-20', 227, NULL),
('Residence Inn', 160, '2019-04-21', 328, NULL),
('Residence Inn', 160, '2019-04-22', 344, NULL),
('Residence Inn', 160, '2019-04-23', 339, NULL),
('Residence Inn', 160, '2019-04-24', 334, NULL),
('Residence Inn', 160, '2019-04-25', 311, NULL),
('Residence Inn', 160, '2019-04-26', 130, NULL),
('Residence Inn', 160, '2019-04-27', 215, NULL),
('Residence Inn', 160, '2019-04-28', 349, NULL),
('Residence Inn', 160, '2019-04-29', 111, NULL),
('Residence Inn', 160, '2019-04-30', 244, NULL),
('Residence Inn', 160, '2019-05-01', 271, NULL),
('Residence Inn', 160, '2019-05-02', 327, NULL),
('Residence Inn', 160, '2019-05-03', 127, NULL),
('Residence Inn', 160, '2019-05-04', 384, NULL),
('Residence Inn', 160, '2019-05-05', 394, NULL),
('Residence Inn', 160, '2019-05-06', 169, NULL),
('Residence Inn', 160, '2019-05-07', 367, NULL),
('Residence Inn', 160, '2019-05-08', 362, NULL),
('Residence Inn', 160, '2019-05-09', 301, NULL),
('Residence Inn', 160, '2019-05-10', 306, NULL),
('Residence Inn', 160, '2019-05-11', 169, NULL),
('Residence Inn', 160, '2019-05-12', 285, NULL),
('Residence Inn', 160, '2019-05-13', 381, NULL),
('Residence Inn', 160, '2019-05-14', 272, NULL),
('Residence Inn', 160, '2019-05-15', 381, NULL),
('Residence Inn', 160, '2019-05-16', 306, NULL),
('Residence Inn', 160, '2019-05-17', 340, NULL),
('Residence Inn', 160, '2019-05-18', 325, NULL),
('Residence Inn', 160, '2019-05-19', 237, NULL),
('Residence Inn', 160, '2019-05-20', 106, NULL),
('Residence Inn', 160, '2019-05-21', 240, NULL),
('Residence Inn', 160, '2019-05-22', 133, NULL),
('Residence Inn', 160, '2019-05-23', 316, NULL),
('Residence Inn', 160, '2019-05-24', 389, NULL),
('Residence Inn', 160, '2019-05-25', 341, NULL),
('Residence Inn', 160, '2019-05-26', 221, NULL),
('Residence Inn', 160, '2019-05-27', 212, NULL),
('Residence Inn', 160, '2019-05-28', 139, NULL),
('Residence Inn', 160, '2019-05-29', 152, NULL),
('Residence Inn', 160, '2019-05-30', 386, NULL),
('Residence Inn', 160, '2019-05-31', 188, NULL),
('Residence Inn', 160, '2019-06-01', 388, NULL),
('Residence Inn', 160, '2019-06-02', 142, NULL),
('Residence Inn', 160, '2019-06-03', 320, NULL),
('Residence Inn', 160, '2019-06-04', 273, NULL),
('Residence Inn', 160, '2019-06-05', 274, NULL),
('Residence Inn', 160, '2019-06-06', 147, NULL),
('Residence Inn', 160, '2019-06-07', 359, NULL),
('Residence Inn', 160, '2019-06-08', 276, NULL),
('Residence Inn', 160, '2019-06-09', 183, NULL),
('Residence Inn', 160, '2019-06-10', 288, NULL),
('Residence Inn', 160, '2019-06-11', 256, NULL),
('Residence Inn', 160, '2019-06-12', 121, NULL),
('Residence Inn', 160, '2019-06-13', 347, NULL),
('Residence Inn', 160, '2019-06-14', 197, NULL),
('Residence Inn', 160, '2019-06-15', 145, NULL),
('Residence Inn', 160, '2019-06-16', 117, NULL),
('Residence Inn', 160, '2019-06-17', 135, NULL),
('Residence Inn', 160, '2019-06-18', 163, NULL),
('Residence Inn', 160, '2019-06-19', 305, NULL),
('Residence Inn', 160, '2019-06-20', 387, NULL),
('Residence Inn', 160, '2019-06-21', 124, NULL),
('Residence Inn', 160, '2019-06-22', 200, NULL),
('Residence Inn', 160, '2019-06-23', 182, NULL),
('Residence Inn', 160, '2019-06-24', 257, NULL),
('Residence Inn', 160, '2019-06-25', 131, NULL),
('Residence Inn', 160, '2019-06-26', 345, NULL),
('Residence Inn', 160, '2019-06-27', 122, NULL),
('Residence Inn', 160, '2019-06-28', 296, NULL),
('Residence Inn', 160, '2019-06-29', 354, NULL),
('Residence Inn', 160, '2019-06-30', 218, NULL),
('Residence Inn', 160, '2019-07-01', 260, NULL),
('Residence Inn', 160, '2019-07-02', 323, NULL),
('Residence Inn', 160, '2019-07-03', 124, NULL),
('Residence Inn', 160, '2019-07-04', 143, NULL),
('Residence Inn', 160, '2019-07-05', 284, NULL),
('Residence Inn', 160, '2019-07-06', 157, NULL),
('Residence Inn', 160, '2019-07-07', 245, NULL),
('Residence Inn', 160, '2019-07-08', 364, NULL),
('Residence Inn', 160, '2019-07-09', 330, NULL),
('Residence Inn', 160, '2019-07-10', 144, NULL),
('Residence Inn', 160, '2019-07-11', 163, NULL),
('Residence Inn', 160, '2019-07-12', 397, NULL),
('Residence Inn', 160, '2019-07-13', 307, NULL),
('Residence Inn', 160, '2019-07-14', 392, NULL),
('Residence Inn', 160, '2019-07-15', 291, NULL),
('Residence Inn', 160, '2019-07-16', 198, NULL),
('Residence Inn', 160, '2019-07-17', 190, NULL),
('Residence Inn', 160, '2019-07-18', 263, NULL),
('Residence Inn', 160, '2019-07-19', 368, NULL),
('Residence Inn', 160, '2019-07-20', 175, NULL),
('Residence Inn', 160, '2019-07-21', 131, NULL),
('Residence Inn', 160, '2019-07-22', 378, NULL),
('Residence Inn', 160, '2019-07-23', 336, NULL),
('Residence Inn', 160, '2019-07-24', 265, NULL),
('Residence Inn', 160, '2019-07-25', 373, NULL),
('Residence Inn', 160, '2019-07-26', 222, NULL),
('Residence Inn', 160, '2019-07-27', 387, NULL),
('Residence Inn', 160, '2019-07-28', 287, NULL),
('Residence Inn', 160, '2019-07-29', 385, NULL),
('Residence Inn', 160, '2019-07-30', 314, NULL),
('Residence Inn', 160, '2019-07-31', 175, NULL),
('Residence Inn', 160, '2019-08-01', 101, NULL),
('Residence Inn', 160, '2019-08-02', 394, NULL),
('Residence Inn', 160, '2019-08-03', 167, NULL),
('Residence Inn', 160, '2019-08-04', 347, NULL),
('Residence Inn', 160, '2019-08-05', 186, NULL),
('Residence Inn', 160, '2019-08-06', 131, NULL),
('Residence Inn', 160, '2019-08-07', 131, NULL),
('Residence Inn', 160, '2019-08-08', 289, NULL),
('Residence Inn', 160, '2019-08-09', 238, NULL),
('Residence Inn', 160, '2019-08-10', 162, NULL),
('Residence Inn', 160, '2019-08-11', 184, NULL),
('Residence Inn', 160, '2019-08-12', 124, NULL),
('Residence Inn', 160, '2019-08-13', 294, NULL),
('Residence Inn', 160, '2019-08-14', 307, NULL),
('Residence Inn', 160, '2019-08-15', 285, NULL),
('Residence Inn', 160, '2019-08-16', 203, NULL),
('Residence Inn', 160, '2019-08-17', 298, NULL),
('Residence Inn', 160, '2019-08-18', 381, NULL),
('Residence Inn', 160, '2019-08-19', 252, NULL),
('Residence Inn', 160, '2019-08-20', 115, NULL),
('Residence Inn', 160, '2019-08-21', 334, NULL),
('Residence Inn', 160, '2019-08-22', 222, NULL),
('Residence Inn', 160, '2019-08-23', 229, NULL),
('Residence Inn', 160, '2019-08-24', 126, NULL),
('Residence Inn', 160, '2019-08-25', 138, NULL),
('Residence Inn', 160, '2019-08-26', 160, NULL),
('Residence Inn', 160, '2019-08-27', 356, NULL),
('Residence Inn', 160, '2019-08-28', 373, NULL),
('Residence Inn', 160, '2019-08-29', 157, NULL),
('Residence Inn', 160, '2019-08-30', 326, NULL),
('Residence Inn', 160, '2019-08-31', 215, NULL),
('Residence Inn', 160, '2019-09-01', 112, NULL),
('Residence Inn', 160, '2019-09-02', 312, NULL),
('Residence Inn', 160, '2019-09-03', 159, NULL),
('Residence Inn', 160, '2019-09-04', 329, NULL),
('Residence Inn', 160, '2019-09-05', 166, NULL),
('Residence Inn', 160, '2019-09-06', 111, NULL),
('Residence Inn', 160, '2019-09-07', 287, NULL),
('Residence Inn', 160, '2019-09-08', 117, NULL),
('Residence Inn', 160, '2019-09-09', 209, NULL),
('Residence Inn', 160, '2019-09-10', 339, NULL),
('Residence Inn', 160, '2019-09-11', 224, NULL),
('Residence Inn', 160, '2019-09-12', 312, NULL),
('Residence Inn', 160, '2019-09-13', 130, NULL),
('Residence Inn', 160, '2019-09-14', 222, NULL),
('Residence Inn', 160, '2019-09-15', 285, NULL),
('Residence Inn', 160, '2019-09-16', 298, NULL),
('Residence Inn', 160, '2019-09-17', 282, NULL),
('Residence Inn', 160, '2019-09-18', 267, NULL),
('Residence Inn', 160, '2019-09-19', 312, NULL),
('Residence Inn', 160, '2019-09-20', 368, NULL),
('Residence Inn', 160, '2019-09-21', 290, NULL),
('Residence Inn', 160, '2019-09-22', 111, NULL),
('Residence Inn', 160, '2019-09-23', 383, NULL),
('Residence Inn', 160, '2019-09-24', 197, NULL),
('Residence Inn', 160, '2019-09-25', 346, NULL),
('Residence Inn', 160, '2019-09-26', 294, NULL),
('Residence Inn', 160, '2019-09-27', 194, NULL),
('Residence Inn', 160, '2019-09-28', 260, NULL),
('Residence Inn', 160, '2019-09-29', 384, NULL),
('Residence Inn', 160, '2019-09-30', 188, NULL),
('Residence Inn', 160, '2019-10-01', 352, NULL),
('Residence Inn', 160, '2019-10-02', 186, NULL),
('Residence Inn', 160, '2019-10-03', 311, NULL),
('Residence Inn', 160, '2019-10-04', 338, NULL),
('Residence Inn', 160, '2019-10-05', 162, NULL),
('Residence Inn', 160, '2019-10-06', 200, NULL),
('Residence Inn', 160, '2019-10-07', 265, NULL),
('Residence Inn', 160, '2019-10-08', 237, NULL),
('Residence Inn', 160, '2019-10-09', 391, NULL),
('Residence Inn', 160, '2019-10-10', 158, NULL),
('Residence Inn', 160, '2019-10-11', 127, NULL),
('Residence Inn', 160, '2019-10-12', 394, NULL),
('Residence Inn', 160, '2019-10-13', 291, NULL),
('Residence Inn', 160, '2019-10-14', 149, NULL),
('Residence Inn', 160, '2019-10-15', 329, NULL),
('Residence Inn', 160, '2019-10-16', 192, NULL),
('Residence Inn', 160, '2019-10-17', 159, NULL),
('Residence Inn', 160, '2019-10-18', 159, NULL),
('Residence Inn', 160, '2019-10-19', 279, NULL),
('Residence Inn', 160, '2019-10-20', 280, NULL),
('Residence Inn', 160, '2019-10-21', 116, NULL),
('Residence Inn', 160, '2019-10-22', 198, NULL),
('Residence Inn', 160, '2019-10-23', 191, NULL),
('Residence Inn', 160, '2019-10-24', 219, NULL),
('Residence Inn', 160, '2019-10-25', 171, NULL),
('Residence Inn', 160, '2019-10-26', 339, NULL),
('Residence Inn', 160, '2019-10-27', 324, NULL),
('Residence Inn', 160, '2019-10-28', 118, NULL),
('Residence Inn', 160, '2019-10-29', 367, NULL),
('Residence Inn', 160, '2019-10-30', 220, NULL),
('Residence Inn', 160, '2019-10-31', 153, NULL),
('Residence Inn', 160, '2019-11-01', 112, NULL),
('Residence Inn', 160, '2019-11-02', 115, NULL),
('Residence Inn', 160, '2019-11-03', 197, NULL),
('Residence Inn', 160, '2019-11-04', 308, NULL),
('Residence Inn', 160, '2019-11-05', 180, NULL),
('Residence Inn', 160, '2019-11-06', 135, NULL),
('Residence Inn', 160, '2019-11-07', 121, NULL),
('Residence Inn', 160, '2019-11-08', 186, NULL),
('Residence Inn', 160, '2019-11-09', 190, NULL),
('Residence Inn', 160, '2019-11-10', 148, NULL),
('Residence Inn', 160, '2019-11-11', 156, NULL),
('Residence Inn', 160, '2019-11-12', 366, NULL),
('Residence Inn', 160, '2019-11-13', 307, NULL),
('Residence Inn', 160, '2019-11-14', 325, NULL),
('Residence Inn', 160, '2019-11-15', 230, NULL),
('Residence Inn', 160, '2019-11-16', 249, NULL),
('Residence Inn', 160, '2019-11-17', 177, NULL),
('Residence Inn', 160, '2019-11-18', 243, NULL),
('Residence Inn', 160, '2019-11-19', 188, NULL),
('Residence Inn', 160, '2019-11-20', 341, NULL),
('Residence Inn', 160, '2019-11-21', 208, NULL),
('Residence Inn', 160, '2019-11-22', 133, NULL),
('Residence Inn', 160, '2019-11-23', 371, NULL),
('Residence Inn', 160, '2019-11-24', 138, NULL),
('Residence Inn', 160, '2019-11-25', 382, NULL),
('Residence Inn', 160, '2019-11-26', 262, NULL),
('Residence Inn', 160, '2019-11-27', 223, NULL),
('Residence Inn', 160, '2019-11-28', 179, NULL),
('Residence Inn', 160, '2019-11-29', 231, NULL),
('Residence Inn', 160, '2019-11-30', 224, NULL),
('Residence Inn', 160, '2019-12-01', 287, NULL),
('Residence Inn', 160, '2019-12-02', 256, NULL),
('Residence Inn', 160, '2019-12-03', 143, NULL),
('Residence Inn', 160, '2019-12-04', 360, NULL),
('Residence Inn', 160, '2019-12-05', 205, NULL),
('Residence Inn', 160, '2019-12-06', 245, NULL),
('Residence Inn', 160, '2019-12-07', 111, NULL),
('Residence Inn', 160, '2019-12-08', 283, NULL),
('Residence Inn', 160, '2019-12-09', 169, NULL),
('Residence Inn', 160, '2019-12-10', 353, NULL),
('Residence Inn', 160, '2019-12-11', 360, NULL),
('Residence Inn', 160, '2019-12-12', 112, NULL),
('Residence Inn', 160, '2019-12-13', 202, NULL),
('Residence Inn', 160, '2019-12-14', 273, NULL),
('Residence Inn', 160, '2019-12-15', 120, NULL),
('Residence Inn', 160, '2019-12-16', 173, NULL),
('Residence Inn', 160, '2019-12-17', 195, NULL),
('Residence Inn', 160, '2019-12-18', 261, NULL),
('Residence Inn', 160, '2019-12-19', 276, NULL),
('Residence Inn', 160, '2019-12-20', 109, NULL),
('Residence Inn', 160, '2019-12-21', 196, NULL),
('Residence Inn', 160, '2019-12-22', 326, NULL),
('Residence Inn', 160, '2019-12-23', 242, NULL),
('Residence Inn', 160, '2019-12-24', 281, NULL),
('Residence Inn', 160, '2019-12-25', 193, NULL),
('Residence Inn', 160, '2019-12-26', 250, NULL),
('Residence Inn', 160, '2019-12-27', 259, NULL),
('Residence Inn', 160, '2019-12-28', 182, NULL),
('Residence Inn', 160, '2019-12-29', 344, NULL),
('Residence Inn', 160, '2019-12-30', 318, NULL),
('Residence Inn', 160, '2019-12-31', 340, NULL),
('Residence Inn', 160, '2020-01-01', 232, NULL),
('Residence Inn', 160, '2020-01-02', 199, NULL),
('Residence Inn', 160, '2020-01-03', 336, NULL),
('Residence Inn', 160, '2020-01-04', 310, NULL),
('Residence Inn', 160, '2020-01-05', 378, NULL),
('Residence Inn', 160, '2020-01-06', 201, NULL),
('Residence Inn', 160, '2020-01-07', 240, NULL),
('Residence Inn', 160, '2020-01-08', 268, NULL),
('Residence Inn', 160, '2020-01-09', 297, NULL),
('Residence Inn', 160, '2020-01-10', 279, NULL),
('Residence Inn', 160, '2020-01-11', 145, NULL),
('Residence Inn', 160, '2020-01-12', 336, NULL),
('Residence Inn', 160, '2020-01-13', 382, NULL),
('Residence Inn', 160, '2020-01-14', 259, NULL),
('Residence Inn', 160, '2020-01-15', 138, NULL),
('Residence Inn', 160, '2020-01-16', 264, NULL),
('Residence Inn', 160, '2020-01-17', 156, NULL),
('Residence Inn', 160, '2020-01-18', 365, NULL),
('Residence Inn', 160, '2020-01-19', 291, NULL),
('Residence Inn', 160, '2020-01-20', 208, NULL),
('Residence Inn', 160, '2020-01-21', 219, NULL),
('Residence Inn', 160, '2020-01-22', 214, NULL),
('Residence Inn', 160, '2020-01-23', 359, NULL),
('Residence Inn', 160, '2020-01-24', 119, NULL),
('Residence Inn', 160, '2020-01-25', 229, NULL),
('Residence Inn', 160, '2020-01-26', 213, NULL),
('Residence Inn', 160, '2020-01-27', 264, NULL),
('Residence Inn', 160, '2020-01-28', 191, NULL),
('Residence Inn', 160, '2020-01-29', 151, NULL),
('Residence Inn', 160, '2020-01-30', 299, NULL),
('Residence Inn', 160, '2020-01-31', 103, NULL),
('Residence Inn', 160, '2020-02-01', 138, NULL),
('Residence Inn', 160, '2020-02-02', 176, NULL),
('Residence Inn', 160, '2020-02-03', 115, NULL),
('Residence Inn', 160, '2020-02-04', 178, NULL),
('Residence Inn', 162, '2019-01-01', 107, NULL),
('Residence Inn', 162, '2019-01-02', 161, NULL),
('Residence Inn', 162, '2019-01-03', 287, NULL),
('Residence Inn', 162, '2019-01-04', 241, NULL),
('Residence Inn', 162, '2019-01-05', 242, NULL),
('Residence Inn', 162, '2019-01-06', 314, NULL),
('Residence Inn', 162, '2019-01-07', 130, NULL),
('Residence Inn', 162, '2019-01-08', 396, NULL),
('Residence Inn', 162, '2019-01-09', 148, NULL),
('Residence Inn', 162, '2019-01-10', 184, NULL),
('Residence Inn', 162, '2019-01-11', 280, NULL),
('Residence Inn', 162, '2019-01-12', 349, NULL),
('Residence Inn', 162, '2019-01-13', 135, NULL),
('Residence Inn', 162, '2019-01-14', 153, NULL),
('Residence Inn', 162, '2019-01-15', 204, NULL),
('Residence Inn', 162, '2019-01-16', 248, NULL),
('Residence Inn', 162, '2019-01-17', 169, NULL),
('Residence Inn', 162, '2019-01-18', 138, NULL),
('Residence Inn', 162, '2019-01-19', 127, NULL),
('Residence Inn', 162, '2019-01-20', 303, NULL),
('Residence Inn', 162, '2019-01-21', 153, NULL),
('Residence Inn', 162, '2019-01-22', 270, NULL),
('Residence Inn', 162, '2019-01-23', 369, NULL),
('Residence Inn', 162, '2019-01-24', 357, NULL),
('Residence Inn', 162, '2019-01-25', 228, NULL),
('Residence Inn', 162, '2019-01-26', 141, NULL),
('Residence Inn', 162, '2019-01-27', 161, NULL),
('Residence Inn', 162, '2019-01-28', 195, NULL),
('Residence Inn', 162, '2019-01-29', 313, NULL),
('Residence Inn', 162, '2019-01-30', 288, NULL),
('Residence Inn', 162, '2019-01-31', 298, NULL),
('Residence Inn', 162, '2019-02-01', 147, NULL),
('Residence Inn', 162, '2019-02-02', 206, NULL),
('Residence Inn', 162, '2019-02-03', 183, NULL),
('Residence Inn', 162, '2019-02-04', 274, NULL),
('Residence Inn', 162, '2019-02-05', 254, NULL),
('Residence Inn', 162, '2019-02-06', 216, NULL),
('Residence Inn', 162, '2019-02-07', 360, NULL),
('Residence Inn', 162, '2019-02-08', 192, NULL),
('Residence Inn', 162, '2019-02-09', 209, NULL),
('Residence Inn', 162, '2019-02-10', 224, NULL),
('Residence Inn', 162, '2019-02-11', 273, NULL),
('Residence Inn', 162, '2019-02-12', 233, NULL),
('Residence Inn', 162, '2019-02-13', 273, NULL),
('Residence Inn', 162, '2019-02-14', 168, NULL),
('Residence Inn', 162, '2019-02-15', 162, NULL),
('Residence Inn', 162, '2019-02-16', 186, NULL),
('Residence Inn', 162, '2019-02-17', 130, NULL),
('Residence Inn', 162, '2019-02-18', 264, NULL),
('Residence Inn', 162, '2019-02-19', 306, NULL),
('Residence Inn', 162, '2019-02-20', 315, NULL),
('Residence Inn', 162, '2019-02-21', 304, NULL),
('Residence Inn', 162, '2019-02-22', 349, NULL),
('Residence Inn', 162, '2019-02-23', 281, NULL),
('Residence Inn', 162, '2019-02-24', 199, NULL),
('Residence Inn', 162, '2019-02-25', 269, NULL),
('Residence Inn', 162, '2019-02-26', 382, NULL),
('Residence Inn', 162, '2019-02-27', 370, NULL),
('Residence Inn', 162, '2019-02-28', 282, NULL),
('Residence Inn', 162, '2019-03-01', 369, NULL),
('Residence Inn', 162, '2019-03-02', 211, NULL),
('Residence Inn', 162, '2019-03-03', 395, NULL),
('Residence Inn', 162, '2019-03-04', 340, NULL),
('Residence Inn', 162, '2019-03-05', 165, NULL),
('Residence Inn', 162, '2019-03-06', 144, NULL),
('Residence Inn', 162, '2019-03-07', 291, NULL),
('Residence Inn', 162, '2019-03-08', 171, NULL),
('Residence Inn', 162, '2019-03-09', 179, NULL),
('Residence Inn', 162, '2019-03-10', 208, NULL),
('Residence Inn', 162, '2019-03-11', 271, NULL),
('Residence Inn', 162, '2019-03-12', 332, NULL),
('Residence Inn', 162, '2019-03-13', 114, NULL),
('Residence Inn', 162, '2019-03-14', 325, NULL),
('Residence Inn', 162, '2019-03-15', 248, NULL),
('Residence Inn', 162, '2019-03-16', 102, NULL),
('Residence Inn', 162, '2019-03-17', 104, NULL),
('Residence Inn', 162, '2019-03-18', 112, NULL),
('Residence Inn', 162, '2019-03-19', 326, NULL),
('Residence Inn', 162, '2019-03-20', 223, NULL),
('Residence Inn', 162, '2019-03-21', 184, NULL),
('Residence Inn', 162, '2019-03-22', 372, NULL),
('Residence Inn', 162, '2019-03-23', 264, NULL),
('Residence Inn', 162, '2019-03-24', 190, NULL),
('Residence Inn', 162, '2019-03-25', 202, NULL),
('Residence Inn', 162, '2019-03-26', 284, NULL),
('Residence Inn', 162, '2019-03-27', 269, NULL),
('Residence Inn', 162, '2019-03-28', 320, NULL),
('Residence Inn', 162, '2019-03-29', 305, NULL),
('Residence Inn', 162, '2019-03-30', 157, NULL),
('Residence Inn', 162, '2019-03-31', 271, NULL),
('Residence Inn', 162, '2019-04-01', 163, NULL),
('Residence Inn', 162, '2019-04-02', 294, NULL),
('Residence Inn', 162, '2019-04-03', 114, NULL),
('Residence Inn', 162, '2019-04-04', 269, NULL),
('Residence Inn', 162, '2019-04-05', 215, NULL),
('Residence Inn', 162, '2019-04-06', 340, NULL),
('Residence Inn', 162, '2019-04-07', 184, NULL),
('Residence Inn', 162, '2019-04-08', 138, NULL),
('Residence Inn', 162, '2019-04-09', 392, NULL),
('Residence Inn', 162, '2019-04-10', 282, NULL),
('Residence Inn', 162, '2019-04-11', 381, NULL),
('Residence Inn', 162, '2019-04-12', 330, NULL),
('Residence Inn', 162, '2019-04-13', 180, NULL),
('Residence Inn', 162, '2019-04-14', 347, NULL),
('Residence Inn', 162, '2019-04-15', 219, NULL),
('Residence Inn', 162, '2019-04-16', 346, NULL),
('Residence Inn', 162, '2019-04-17', 349, NULL),
('Residence Inn', 162, '2019-04-18', 347, NULL),
('Residence Inn', 162, '2019-04-19', 110, NULL),
('Residence Inn', 162, '2019-04-20', 140, NULL),
('Residence Inn', 162, '2019-04-21', 368, NULL),
('Residence Inn', 162, '2019-04-22', 105, NULL),
('Residence Inn', 162, '2019-04-23', 346, NULL),
('Residence Inn', 162, '2019-04-24', 398, NULL),
('Residence Inn', 162, '2019-04-25', 118, NULL),
('Residence Inn', 162, '2019-04-26', 140, NULL),
('Residence Inn', 162, '2019-04-27', 363, NULL),
('Residence Inn', 162, '2019-04-28', 152, NULL),
('Residence Inn', 162, '2019-04-29', 191, NULL),
('Residence Inn', 162, '2019-04-30', 205, NULL),
('Residence Inn', 162, '2019-05-01', 119, NULL),
('Residence Inn', 162, '2019-05-02', 388, NULL),
('Residence Inn', 162, '2019-05-03', 156, NULL),
('Residence Inn', 162, '2019-05-04', 396, NULL),
('Residence Inn', 162, '2019-05-05', 193, NULL),
('Residence Inn', 162, '2019-05-06', 191, NULL),
('Residence Inn', 162, '2019-05-07', 311, NULL),
('Residence Inn', 162, '2019-05-08', 246, NULL),
('Residence Inn', 162, '2019-05-09', 210, NULL),
('Residence Inn', 162, '2019-05-10', 206, NULL),
('Residence Inn', 162, '2019-05-11', 381, NULL),
('Residence Inn', 162, '2019-05-12', 170, NULL),
('Residence Inn', 162, '2019-05-13', 325, NULL),
('Residence Inn', 162, '2019-05-14', 325, NULL),
('Residence Inn', 162, '2019-05-15', 289, NULL),
('Residence Inn', 162, '2019-05-16', 172, NULL),
('Residence Inn', 162, '2019-05-17', 325, NULL),
('Residence Inn', 162, '2019-05-18', 244, NULL),
('Residence Inn', 162, '2019-05-19', 310, NULL),
('Residence Inn', 162, '2019-05-20', 169, NULL),
('Residence Inn', 162, '2019-05-21', 295, NULL),
('Residence Inn', 162, '2019-05-22', 100, NULL),
('Residence Inn', 162, '2019-05-23', 394, NULL),
('Residence Inn', 162, '2019-05-24', 313, NULL),
('Residence Inn', 162, '2019-05-25', 370, NULL),
('Residence Inn', 162, '2019-05-26', 317, NULL),
('Residence Inn', 162, '2019-05-27', 389, NULL),
('Residence Inn', 162, '2019-05-28', 306, NULL),
('Residence Inn', 162, '2019-05-29', 347, NULL),
('Residence Inn', 162, '2019-05-30', 113, NULL),
('Residence Inn', 162, '2019-05-31', 290, NULL),
('Residence Inn', 162, '2019-06-01', 399, NULL),
('Residence Inn', 162, '2019-06-02', 148, NULL),
('Residence Inn', 162, '2019-06-03', 376, NULL),
('Residence Inn', 162, '2019-06-04', 343, NULL),
('Residence Inn', 162, '2019-06-05', 307, NULL),
('Residence Inn', 162, '2019-06-06', 293, NULL),
('Residence Inn', 162, '2019-06-07', 194, NULL),
('Residence Inn', 162, '2019-06-08', 170, NULL),
('Residence Inn', 162, '2019-06-09', 327, NULL),
('Residence Inn', 162, '2019-06-10', 160, NULL),
('Residence Inn', 162, '2019-06-11', 256, NULL),
('Residence Inn', 162, '2019-06-12', 205, NULL),
('Residence Inn', 162, '2019-06-13', 255, NULL),
('Residence Inn', 162, '2019-06-14', 181, NULL),
('Residence Inn', 162, '2019-06-15', 293, NULL),
('Residence Inn', 162, '2019-06-16', 272, NULL),
('Residence Inn', 162, '2019-06-17', 206, NULL),
('Residence Inn', 162, '2019-06-18', 393, NULL),
('Residence Inn', 162, '2019-06-19', 293, NULL),
('Residence Inn', 162, '2019-06-20', 274, NULL),
('Residence Inn', 162, '2019-06-21', 223, NULL),
('Residence Inn', 162, '2019-06-22', 163, NULL),
('Residence Inn', 162, '2019-06-23', 274, NULL),
('Residence Inn', 162, '2019-06-24', 115, NULL),
('Residence Inn', 162, '2019-06-25', 101, NULL),
('Residence Inn', 162, '2019-06-26', 338, NULL),
('Residence Inn', 162, '2019-06-27', 382, NULL),
('Residence Inn', 162, '2019-06-28', 290, NULL),
('Residence Inn', 162, '2019-06-29', 107, NULL),
('Residence Inn', 162, '2019-06-30', 346, NULL),
('Residence Inn', 162, '2019-07-01', 118, NULL),
('Residence Inn', 162, '2019-07-02', 305, NULL),
('Residence Inn', 162, '2019-07-03', 185, NULL),
('Residence Inn', 162, '2019-07-04', 176, NULL),
('Residence Inn', 162, '2019-07-05', 206, NULL),
('Residence Inn', 162, '2019-07-06', 340, NULL),
('Residence Inn', 162, '2019-07-07', 239, NULL),
('Residence Inn', 162, '2019-07-08', 251, NULL),
('Residence Inn', 162, '2019-07-09', 294, NULL),
('Residence Inn', 162, '2019-07-10', 139, NULL),
('Residence Inn', 162, '2019-07-11', 345, NULL),
('Residence Inn', 162, '2019-07-12', 365, NULL),
('Residence Inn', 162, '2019-07-13', 101, NULL),
('Residence Inn', 162, '2019-07-14', 318, NULL),
('Residence Inn', 162, '2019-07-15', 155, NULL),
('Residence Inn', 162, '2019-07-16', 305, NULL),
('Residence Inn', 162, '2019-07-17', 369, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 162, '2019-07-18', 242, NULL),
('Residence Inn', 162, '2019-07-19', 339, NULL),
('Residence Inn', 162, '2019-07-20', 397, NULL),
('Residence Inn', 162, '2019-07-21', 251, NULL),
('Residence Inn', 162, '2019-07-22', 381, NULL),
('Residence Inn', 162, '2019-07-23', 328, NULL),
('Residence Inn', 162, '2019-07-24', 307, NULL),
('Residence Inn', 162, '2019-07-25', 138, NULL),
('Residence Inn', 162, '2019-07-26', 374, NULL),
('Residence Inn', 162, '2019-07-27', 296, NULL),
('Residence Inn', 162, '2019-07-28', 226, NULL),
('Residence Inn', 162, '2019-07-29', 318, NULL),
('Residence Inn', 162, '2019-07-30', 241, NULL),
('Residence Inn', 162, '2019-07-31', 241, NULL),
('Residence Inn', 162, '2019-08-01', 127, NULL),
('Residence Inn', 162, '2019-08-02', 211, NULL),
('Residence Inn', 162, '2019-08-03', 276, NULL),
('Residence Inn', 162, '2019-08-04', 267, NULL),
('Residence Inn', 162, '2019-08-05', 199, NULL),
('Residence Inn', 162, '2019-08-06', 139, NULL),
('Residence Inn', 162, '2019-08-07', 388, NULL),
('Residence Inn', 162, '2019-08-08', 321, NULL),
('Residence Inn', 162, '2019-08-09', 236, NULL),
('Residence Inn', 162, '2019-08-10', 248, NULL),
('Residence Inn', 162, '2019-08-11', 264, NULL),
('Residence Inn', 162, '2019-08-12', 133, NULL),
('Residence Inn', 162, '2019-08-13', 182, NULL),
('Residence Inn', 162, '2019-08-14', 138, NULL),
('Residence Inn', 162, '2019-08-15', 191, NULL),
('Residence Inn', 162, '2019-08-16', 334, NULL),
('Residence Inn', 162, '2019-08-17', 330, NULL),
('Residence Inn', 162, '2019-08-18', 299, NULL),
('Residence Inn', 162, '2019-08-19', 380, NULL),
('Residence Inn', 162, '2019-08-20', 202, NULL),
('Residence Inn', 162, '2019-08-21', 371, NULL),
('Residence Inn', 162, '2019-08-22', 385, NULL),
('Residence Inn', 162, '2019-08-23', 346, NULL),
('Residence Inn', 162, '2019-08-24', 104, NULL),
('Residence Inn', 162, '2019-08-25', 369, NULL),
('Residence Inn', 162, '2019-08-26', 154, NULL),
('Residence Inn', 162, '2019-08-27', 295, NULL),
('Residence Inn', 162, '2019-08-28', 317, NULL),
('Residence Inn', 162, '2019-08-29', 395, NULL),
('Residence Inn', 162, '2019-08-30', 227, NULL),
('Residence Inn', 162, '2019-08-31', 176, NULL),
('Residence Inn', 162, '2019-09-01', 335, NULL),
('Residence Inn', 162, '2019-09-02', 135, NULL),
('Residence Inn', 162, '2019-09-03', 293, NULL),
('Residence Inn', 162, '2019-09-04', 219, NULL),
('Residence Inn', 162, '2019-09-05', 284, NULL),
('Residence Inn', 162, '2019-09-06', 270, NULL),
('Residence Inn', 162, '2019-09-07', 301, NULL),
('Residence Inn', 162, '2019-09-08', 161, NULL),
('Residence Inn', 162, '2019-09-09', 136, NULL),
('Residence Inn', 162, '2019-09-10', 392, NULL),
('Residence Inn', 162, '2019-09-11', 274, NULL),
('Residence Inn', 162, '2019-09-12', 153, NULL),
('Residence Inn', 162, '2019-09-13', 145, NULL),
('Residence Inn', 162, '2019-09-14', 201, NULL),
('Residence Inn', 162, '2019-09-15', 199, NULL),
('Residence Inn', 162, '2019-09-16', 379, NULL),
('Residence Inn', 162, '2019-09-17', 278, NULL),
('Residence Inn', 162, '2019-09-18', 189, NULL),
('Residence Inn', 162, '2019-09-19', 372, NULL),
('Residence Inn', 162, '2019-09-20', 202, NULL),
('Residence Inn', 162, '2019-09-21', 155, NULL),
('Residence Inn', 162, '2019-09-22', 270, NULL),
('Residence Inn', 162, '2019-09-23', 255, NULL),
('Residence Inn', 162, '2019-09-24', 285, NULL),
('Residence Inn', 162, '2019-09-25', 241, NULL),
('Residence Inn', 162, '2019-09-26', 267, NULL),
('Residence Inn', 162, '2019-09-27', 132, NULL),
('Residence Inn', 162, '2019-09-28', 135, NULL),
('Residence Inn', 162, '2019-09-29', 225, NULL),
('Residence Inn', 162, '2019-09-30', 300, NULL),
('Residence Inn', 162, '2019-10-01', 284, NULL),
('Residence Inn', 162, '2019-10-02', 312, NULL),
('Residence Inn', 162, '2019-10-03', 146, NULL),
('Residence Inn', 162, '2019-10-04', 188, NULL),
('Residence Inn', 162, '2019-10-05', 110, NULL),
('Residence Inn', 162, '2019-10-06', 326, NULL),
('Residence Inn', 162, '2019-10-07', 150, NULL),
('Residence Inn', 162, '2019-10-08', 133, NULL),
('Residence Inn', 162, '2019-10-09', 342, NULL),
('Residence Inn', 162, '2019-10-10', 172, NULL),
('Residence Inn', 162, '2019-10-11', 198, NULL),
('Residence Inn', 162, '2019-10-12', 297, NULL),
('Residence Inn', 162, '2019-10-13', 306, NULL),
('Residence Inn', 162, '2019-10-14', 116, NULL),
('Residence Inn', 162, '2019-10-15', 192, NULL),
('Residence Inn', 162, '2019-10-16', 140, NULL),
('Residence Inn', 162, '2019-10-17', 173, NULL),
('Residence Inn', 162, '2019-10-18', 114, NULL),
('Residence Inn', 162, '2019-10-19', 385, NULL),
('Residence Inn', 162, '2019-10-20', 371, NULL),
('Residence Inn', 162, '2019-10-21', 275, NULL),
('Residence Inn', 162, '2019-10-22', 179, NULL),
('Residence Inn', 162, '2019-10-23', 315, NULL),
('Residence Inn', 162, '2019-10-24', 167, NULL),
('Residence Inn', 162, '2019-10-25', 305, NULL),
('Residence Inn', 162, '2019-10-26', 361, NULL),
('Residence Inn', 162, '2019-10-27', 102, NULL),
('Residence Inn', 162, '2019-10-28', 363, NULL),
('Residence Inn', 162, '2019-10-29', 359, NULL),
('Residence Inn', 162, '2019-10-30', 331, NULL),
('Residence Inn', 162, '2019-10-31', 355, NULL),
('Residence Inn', 162, '2019-11-01', 343, NULL),
('Residence Inn', 162, '2019-11-02', 213, NULL),
('Residence Inn', 162, '2019-11-03', 150, NULL),
('Residence Inn', 162, '2019-11-04', 117, NULL),
('Residence Inn', 162, '2019-11-05', 228, NULL),
('Residence Inn', 162, '2019-11-06', 144, NULL),
('Residence Inn', 162, '2019-11-07', 164, NULL),
('Residence Inn', 162, '2019-11-08', 195, NULL),
('Residence Inn', 162, '2019-11-09', 287, NULL),
('Residence Inn', 162, '2019-11-10', 379, NULL),
('Residence Inn', 162, '2019-11-11', 348, NULL),
('Residence Inn', 162, '2019-11-12', 309, NULL),
('Residence Inn', 162, '2019-11-13', 341, NULL),
('Residence Inn', 162, '2019-11-14', 234, NULL),
('Residence Inn', 162, '2019-11-15', 386, NULL),
('Residence Inn', 162, '2019-11-16', 137, NULL),
('Residence Inn', 162, '2019-11-17', 229, NULL),
('Residence Inn', 162, '2019-11-18', 278, NULL),
('Residence Inn', 162, '2019-11-19', 252, NULL),
('Residence Inn', 162, '2019-11-20', 297, NULL),
('Residence Inn', 162, '2019-11-21', 369, NULL),
('Residence Inn', 162, '2019-11-22', 392, NULL),
('Residence Inn', 162, '2019-11-23', 326, NULL),
('Residence Inn', 162, '2019-11-24', 123, NULL),
('Residence Inn', 162, '2019-11-25', 376, NULL),
('Residence Inn', 162, '2019-11-26', 140, NULL),
('Residence Inn', 162, '2019-11-27', 232, NULL),
('Residence Inn', 162, '2019-11-28', 323, NULL),
('Residence Inn', 162, '2019-11-29', 354, NULL),
('Residence Inn', 162, '2019-11-30', 197, NULL),
('Residence Inn', 162, '2019-12-01', 374, NULL),
('Residence Inn', 162, '2019-12-02', 148, NULL),
('Residence Inn', 162, '2019-12-03', 153, NULL),
('Residence Inn', 162, '2019-12-04', 325, NULL),
('Residence Inn', 162, '2019-12-05', 313, NULL),
('Residence Inn', 162, '2019-12-06', 326, NULL),
('Residence Inn', 162, '2019-12-07', 236, NULL),
('Residence Inn', 162, '2019-12-08', 104, NULL),
('Residence Inn', 162, '2019-12-09', 133, NULL),
('Residence Inn', 162, '2019-12-10', 274, NULL),
('Residence Inn', 162, '2019-12-11', 210, NULL),
('Residence Inn', 162, '2019-12-12', 102, NULL),
('Residence Inn', 162, '2019-12-13', 213, NULL),
('Residence Inn', 162, '2019-12-14', 376, NULL),
('Residence Inn', 162, '2019-12-15', 182, NULL),
('Residence Inn', 162, '2019-12-16', 105, NULL),
('Residence Inn', 162, '2019-12-17', 369, NULL),
('Residence Inn', 162, '2019-12-18', 184, NULL),
('Residence Inn', 162, '2019-12-19', 391, NULL),
('Residence Inn', 162, '2019-12-20', 116, NULL),
('Residence Inn', 162, '2019-12-21', 122, NULL),
('Residence Inn', 162, '2019-12-22', 126, NULL),
('Residence Inn', 162, '2019-12-23', 372, NULL),
('Residence Inn', 162, '2019-12-24', 226, NULL),
('Residence Inn', 162, '2019-12-25', 214, NULL),
('Residence Inn', 162, '2019-12-26', 396, NULL),
('Residence Inn', 162, '2019-12-27', 177, NULL),
('Residence Inn', 162, '2019-12-28', 172, NULL),
('Residence Inn', 162, '2019-12-29', 135, NULL),
('Residence Inn', 162, '2019-12-30', 229, NULL),
('Residence Inn', 162, '2019-12-31', 114, NULL),
('Residence Inn', 162, '2020-01-01', 181, NULL),
('Residence Inn', 162, '2020-01-02', 368, NULL),
('Residence Inn', 162, '2020-01-03', 181, NULL),
('Residence Inn', 162, '2020-01-04', 193, NULL),
('Residence Inn', 162, '2020-01-05', 255, NULL),
('Residence Inn', 162, '2020-01-06', 361, NULL),
('Residence Inn', 162, '2020-01-07', 216, NULL),
('Residence Inn', 162, '2020-01-08', 287, NULL),
('Residence Inn', 162, '2020-01-09', 259, NULL),
('Residence Inn', 162, '2020-01-10', 131, NULL),
('Residence Inn', 162, '2020-01-11', 331, NULL),
('Residence Inn', 162, '2020-01-12', 119, NULL),
('Residence Inn', 162, '2020-01-13', 160, NULL),
('Residence Inn', 162, '2020-01-14', 340, NULL),
('Residence Inn', 162, '2020-01-15', 345, NULL),
('Residence Inn', 162, '2020-01-16', 382, NULL),
('Residence Inn', 162, '2020-01-17', 355, NULL),
('Residence Inn', 162, '2020-01-18', 242, NULL),
('Residence Inn', 162, '2020-01-19', 198, NULL),
('Residence Inn', 162, '2020-01-20', 146, NULL),
('Residence Inn', 162, '2020-01-21', 274, NULL),
('Residence Inn', 162, '2020-01-22', 281, NULL),
('Residence Inn', 162, '2020-01-23', 397, NULL),
('Residence Inn', 162, '2020-01-24', 361, NULL),
('Residence Inn', 162, '2020-01-25', 196, NULL),
('Residence Inn', 162, '2020-01-26', 209, NULL),
('Residence Inn', 162, '2020-01-27', 111, NULL),
('Residence Inn', 162, '2020-01-28', 399, NULL),
('Residence Inn', 162, '2020-01-29', 190, NULL),
('Residence Inn', 162, '2020-01-30', 352, NULL),
('Residence Inn', 162, '2020-01-31', 233, NULL),
('Residence Inn', 162, '2020-02-01', 394, NULL),
('Residence Inn', 162, '2020-02-02', 339, NULL),
('Residence Inn', 162, '2020-02-03', 166, NULL),
('Residence Inn', 162, '2020-02-04', 349, NULL),
('Residence Inn', 173, '2019-01-01', 197, NULL),
('Residence Inn', 173, '2019-01-02', 392, NULL),
('Residence Inn', 173, '2019-01-03', 167, NULL),
('Residence Inn', 173, '2019-01-04', 281, NULL),
('Residence Inn', 173, '2019-01-05', 156, NULL),
('Residence Inn', 173, '2019-01-06', 230, NULL),
('Residence Inn', 173, '2019-01-07', 209, NULL),
('Residence Inn', 173, '2019-01-08', 192, NULL),
('Residence Inn', 173, '2019-01-09', 286, NULL),
('Residence Inn', 173, '2019-01-10', 395, NULL),
('Residence Inn', 173, '2019-01-11', 108, NULL),
('Residence Inn', 173, '2019-01-12', 176, NULL),
('Residence Inn', 173, '2019-01-13', 192, NULL),
('Residence Inn', 173, '2019-01-14', 322, NULL),
('Residence Inn', 173, '2019-01-15', 121, NULL),
('Residence Inn', 173, '2019-01-16', 243, NULL),
('Residence Inn', 173, '2019-01-17', 362, NULL),
('Residence Inn', 173, '2019-01-18', 221, NULL),
('Residence Inn', 173, '2019-01-19', 148, NULL),
('Residence Inn', 173, '2019-01-20', 284, NULL),
('Residence Inn', 173, '2019-01-21', 141, NULL),
('Residence Inn', 173, '2019-01-22', 224, NULL),
('Residence Inn', 173, '2019-01-23', 198, NULL),
('Residence Inn', 173, '2019-01-24', 283, NULL),
('Residence Inn', 173, '2019-01-25', 102, NULL),
('Residence Inn', 173, '2019-01-26', 174, NULL),
('Residence Inn', 173, '2019-01-27', 296, NULL),
('Residence Inn', 173, '2019-01-28', 328, NULL),
('Residence Inn', 173, '2019-01-29', 314, NULL),
('Residence Inn', 173, '2019-01-30', 382, NULL),
('Residence Inn', 173, '2019-01-31', 172, NULL),
('Residence Inn', 173, '2019-02-01', 116, NULL),
('Residence Inn', 173, '2019-02-02', 191, NULL),
('Residence Inn', 173, '2019-02-03', 327, NULL),
('Residence Inn', 173, '2019-02-04', 115, NULL),
('Residence Inn', 173, '2019-02-05', 215, NULL),
('Residence Inn', 173, '2019-02-06', 330, NULL),
('Residence Inn', 173, '2019-02-07', 295, NULL),
('Residence Inn', 173, '2019-02-08', 327, NULL),
('Residence Inn', 173, '2019-02-09', 298, NULL),
('Residence Inn', 173, '2019-02-10', 223, NULL),
('Residence Inn', 173, '2019-02-11', 274, NULL),
('Residence Inn', 173, '2019-02-12', 172, NULL),
('Residence Inn', 173, '2019-02-13', 206, NULL),
('Residence Inn', 173, '2019-02-14', 244, NULL),
('Residence Inn', 173, '2019-02-15', 131, NULL),
('Residence Inn', 173, '2019-02-16', 147, NULL),
('Residence Inn', 173, '2019-02-17', 251, NULL),
('Residence Inn', 173, '2019-02-18', 133, NULL),
('Residence Inn', 173, '2019-02-19', 272, NULL),
('Residence Inn', 173, '2019-02-20', 285, NULL),
('Residence Inn', 173, '2019-02-21', 362, NULL),
('Residence Inn', 173, '2019-02-22', 208, NULL),
('Residence Inn', 173, '2019-02-23', 278, NULL),
('Residence Inn', 173, '2019-02-24', 297, NULL),
('Residence Inn', 173, '2019-02-25', 328, NULL),
('Residence Inn', 173, '2019-02-26', 214, NULL),
('Residence Inn', 173, '2019-02-27', 254, NULL),
('Residence Inn', 173, '2019-02-28', 261, NULL),
('Residence Inn', 173, '2019-03-01', 250, NULL),
('Residence Inn', 173, '2019-03-02', 303, NULL),
('Residence Inn', 173, '2019-03-03', 177, NULL),
('Residence Inn', 173, '2019-03-04', 310, NULL),
('Residence Inn', 173, '2019-03-05', 230, NULL),
('Residence Inn', 173, '2019-03-06', 106, NULL),
('Residence Inn', 173, '2019-03-07', 218, NULL),
('Residence Inn', 173, '2019-03-08', 181, NULL),
('Residence Inn', 173, '2019-03-09', 356, NULL),
('Residence Inn', 173, '2019-03-10', 349, NULL),
('Residence Inn', 173, '2019-03-11', 216, NULL),
('Residence Inn', 173, '2019-03-12', 142, NULL),
('Residence Inn', 173, '2019-03-13', 110, NULL),
('Residence Inn', 173, '2019-03-14', 168, NULL),
('Residence Inn', 173, '2019-03-15', 299, NULL),
('Residence Inn', 173, '2019-03-16', 247, NULL),
('Residence Inn', 173, '2019-03-17', 217, NULL),
('Residence Inn', 173, '2019-03-18', 109, NULL),
('Residence Inn', 173, '2019-03-19', 161, NULL),
('Residence Inn', 173, '2019-03-20', 390, NULL),
('Residence Inn', 173, '2019-03-21', 297, NULL),
('Residence Inn', 173, '2019-03-22', 196, NULL),
('Residence Inn', 173, '2019-03-23', 260, NULL),
('Residence Inn', 173, '2019-03-24', 366, NULL),
('Residence Inn', 173, '2019-03-25', 256, NULL),
('Residence Inn', 173, '2019-03-26', 251, NULL),
('Residence Inn', 173, '2019-03-27', 216, NULL),
('Residence Inn', 173, '2019-03-28', 251, NULL),
('Residence Inn', 173, '2019-03-29', 317, NULL),
('Residence Inn', 173, '2019-03-30', 384, NULL),
('Residence Inn', 173, '2019-03-31', 229, NULL),
('Residence Inn', 173, '2019-04-01', 186, NULL),
('Residence Inn', 173, '2019-04-02', 303, NULL),
('Residence Inn', 173, '2019-04-03', 348, NULL),
('Residence Inn', 173, '2019-04-04', 374, NULL),
('Residence Inn', 173, '2019-04-05', 397, NULL),
('Residence Inn', 173, '2019-04-06', 229, NULL),
('Residence Inn', 173, '2019-04-07', 117, NULL),
('Residence Inn', 173, '2019-04-08', 163, NULL),
('Residence Inn', 173, '2019-04-09', 316, NULL),
('Residence Inn', 173, '2019-04-10', 211, NULL),
('Residence Inn', 173, '2019-04-11', 310, NULL),
('Residence Inn', 173, '2019-04-12', 195, NULL),
('Residence Inn', 173, '2019-04-13', 251, NULL),
('Residence Inn', 173, '2019-04-14', 262, NULL),
('Residence Inn', 173, '2019-04-15', 304, NULL),
('Residence Inn', 173, '2019-04-16', 390, NULL),
('Residence Inn', 173, '2019-04-17', 175, NULL),
('Residence Inn', 173, '2019-04-18', 205, NULL),
('Residence Inn', 173, '2019-04-19', 280, NULL),
('Residence Inn', 173, '2019-04-20', 218, NULL),
('Residence Inn', 173, '2019-04-21', 155, NULL),
('Residence Inn', 173, '2019-04-22', 291, NULL),
('Residence Inn', 173, '2019-04-23', 311, NULL),
('Residence Inn', 173, '2019-04-24', 288, NULL),
('Residence Inn', 173, '2019-04-25', 156, NULL),
('Residence Inn', 173, '2019-04-26', 213, NULL),
('Residence Inn', 173, '2019-04-27', 170, NULL),
('Residence Inn', 173, '2019-04-28', 213, NULL),
('Residence Inn', 173, '2019-04-29', 225, NULL),
('Residence Inn', 173, '2019-04-30', 194, NULL),
('Residence Inn', 173, '2019-05-01', 281, NULL),
('Residence Inn', 173, '2019-05-02', 261, NULL),
('Residence Inn', 173, '2019-05-03', 301, NULL),
('Residence Inn', 173, '2019-05-04', 127, NULL),
('Residence Inn', 173, '2019-05-05', 282, NULL),
('Residence Inn', 173, '2019-05-06', 346, NULL),
('Residence Inn', 173, '2019-05-07', 357, NULL),
('Residence Inn', 173, '2019-05-08', 346, NULL),
('Residence Inn', 173, '2019-05-09', 345, NULL),
('Residence Inn', 173, '2019-05-10', 314, NULL),
('Residence Inn', 173, '2019-05-11', 399, NULL),
('Residence Inn', 173, '2019-05-12', 194, NULL),
('Residence Inn', 173, '2019-05-13', 384, NULL),
('Residence Inn', 173, '2019-05-14', 110, NULL),
('Residence Inn', 173, '2019-05-15', 204, NULL),
('Residence Inn', 173, '2019-05-16', 141, NULL),
('Residence Inn', 173, '2019-05-17', 204, NULL),
('Residence Inn', 173, '2019-05-18', 145, NULL),
('Residence Inn', 173, '2019-05-19', 138, NULL),
('Residence Inn', 173, '2019-05-20', 127, NULL),
('Residence Inn', 173, '2019-05-21', 356, NULL),
('Residence Inn', 173, '2019-05-22', 301, NULL),
('Residence Inn', 173, '2019-05-23', 320, NULL),
('Residence Inn', 173, '2019-05-24', 298, NULL),
('Residence Inn', 173, '2019-05-25', 128, NULL),
('Residence Inn', 173, '2019-05-26', 222, NULL),
('Residence Inn', 173, '2019-05-27', 308, NULL),
('Residence Inn', 173, '2019-05-28', 112, NULL),
('Residence Inn', 173, '2019-05-29', 282, NULL),
('Residence Inn', 173, '2019-05-30', 206, NULL),
('Residence Inn', 173, '2019-05-31', 186, NULL),
('Residence Inn', 173, '2019-06-01', 130, NULL),
('Residence Inn', 173, '2019-06-02', 215, NULL),
('Residence Inn', 173, '2019-06-03', 222, NULL),
('Residence Inn', 173, '2019-06-04', 194, NULL),
('Residence Inn', 173, '2019-06-05', 312, NULL),
('Residence Inn', 173, '2019-06-06', 326, NULL),
('Residence Inn', 173, '2019-06-07', 392, NULL),
('Residence Inn', 173, '2019-06-08', 225, NULL),
('Residence Inn', 173, '2019-06-09', 389, NULL),
('Residence Inn', 173, '2019-06-10', 136, NULL),
('Residence Inn', 173, '2019-06-11', 110, NULL),
('Residence Inn', 173, '2019-06-12', 265, NULL),
('Residence Inn', 173, '2019-06-13', 133, NULL),
('Residence Inn', 173, '2019-06-14', 216, NULL),
('Residence Inn', 173, '2019-06-15', 333, NULL),
('Residence Inn', 173, '2019-06-16', 308, NULL),
('Residence Inn', 173, '2019-06-17', 225, NULL),
('Residence Inn', 173, '2019-06-18', 178, NULL),
('Residence Inn', 173, '2019-06-19', 151, NULL),
('Residence Inn', 173, '2019-06-20', 113, NULL),
('Residence Inn', 173, '2019-06-21', 343, NULL),
('Residence Inn', 173, '2019-06-22', 114, NULL),
('Residence Inn', 173, '2019-06-23', 126, NULL),
('Residence Inn', 173, '2019-06-24', 305, NULL),
('Residence Inn', 173, '2019-06-25', 311, NULL),
('Residence Inn', 173, '2019-06-26', 258, NULL),
('Residence Inn', 173, '2019-06-27', 244, NULL),
('Residence Inn', 173, '2019-06-28', 164, NULL),
('Residence Inn', 173, '2019-06-29', 272, NULL),
('Residence Inn', 173, '2019-06-30', 377, NULL),
('Residence Inn', 173, '2019-07-01', 311, NULL),
('Residence Inn', 173, '2019-07-02', 158, NULL),
('Residence Inn', 173, '2019-07-03', 152, NULL),
('Residence Inn', 173, '2019-07-04', 354, NULL),
('Residence Inn', 173, '2019-07-05', 379, NULL),
('Residence Inn', 173, '2019-07-06', 230, NULL),
('Residence Inn', 173, '2019-07-07', 362, NULL),
('Residence Inn', 173, '2019-07-08', 363, NULL),
('Residence Inn', 173, '2019-07-09', 379, NULL),
('Residence Inn', 173, '2019-07-10', 166, NULL),
('Residence Inn', 173, '2019-07-11', 234, NULL),
('Residence Inn', 173, '2019-07-12', 234, NULL),
('Residence Inn', 173, '2019-07-13', 388, NULL),
('Residence Inn', 173, '2019-07-14', 313, NULL),
('Residence Inn', 173, '2019-07-15', 102, NULL),
('Residence Inn', 173, '2019-07-16', 230, NULL),
('Residence Inn', 173, '2019-07-17', 277, NULL),
('Residence Inn', 173, '2019-07-18', 322, NULL),
('Residence Inn', 173, '2019-07-19', 191, NULL),
('Residence Inn', 173, '2019-07-20', 160, NULL),
('Residence Inn', 173, '2019-07-21', 163, NULL),
('Residence Inn', 173, '2019-07-22', 374, NULL),
('Residence Inn', 173, '2019-07-23', 230, NULL),
('Residence Inn', 173, '2019-07-24', 342, NULL),
('Residence Inn', 173, '2019-07-25', 372, NULL),
('Residence Inn', 173, '2019-07-26', 204, NULL),
('Residence Inn', 173, '2019-07-27', 222, NULL),
('Residence Inn', 173, '2019-07-28', 167, NULL),
('Residence Inn', 173, '2019-07-29', 337, NULL),
('Residence Inn', 173, '2019-07-30', 165, NULL),
('Residence Inn', 173, '2019-07-31', 280, NULL),
('Residence Inn', 173, '2019-08-01', 233, NULL),
('Residence Inn', 173, '2019-08-02', 374, NULL),
('Residence Inn', 173, '2019-08-03', 181, NULL),
('Residence Inn', 173, '2019-08-04', 192, NULL),
('Residence Inn', 173, '2019-08-05', 337, NULL),
('Residence Inn', 173, '2019-08-06', 201, NULL),
('Residence Inn', 173, '2019-08-07', 247, NULL),
('Residence Inn', 173, '2019-08-08', 342, NULL),
('Residence Inn', 173, '2019-08-09', 364, NULL),
('Residence Inn', 173, '2019-08-10', 358, NULL),
('Residence Inn', 173, '2019-08-11', 370, NULL),
('Residence Inn', 173, '2019-08-12', 194, NULL),
('Residence Inn', 173, '2019-08-13', 228, NULL),
('Residence Inn', 173, '2019-08-14', 270, NULL),
('Residence Inn', 173, '2019-08-15', 300, NULL),
('Residence Inn', 173, '2019-08-16', 362, NULL),
('Residence Inn', 173, '2019-08-17', 357, NULL),
('Residence Inn', 173, '2019-08-18', 256, NULL),
('Residence Inn', 173, '2019-08-19', 144, NULL),
('Residence Inn', 173, '2019-08-20', 267, NULL),
('Residence Inn', 173, '2019-08-21', 151, NULL),
('Residence Inn', 173, '2019-08-22', 260, NULL),
('Residence Inn', 173, '2019-08-23', 343, NULL),
('Residence Inn', 173, '2019-08-24', 342, NULL),
('Residence Inn', 173, '2019-08-25', 131, NULL),
('Residence Inn', 173, '2019-08-26', 189, NULL),
('Residence Inn', 173, '2019-08-27', 308, NULL),
('Residence Inn', 173, '2019-08-28', 368, NULL),
('Residence Inn', 173, '2019-08-29', 207, NULL),
('Residence Inn', 173, '2019-08-30', 355, NULL),
('Residence Inn', 173, '2019-08-31', 138, NULL),
('Residence Inn', 173, '2019-09-01', 343, NULL),
('Residence Inn', 173, '2019-09-02', 237, NULL),
('Residence Inn', 173, '2019-09-03', 286, NULL),
('Residence Inn', 173, '2019-09-04', 312, NULL),
('Residence Inn', 173, '2019-09-05', 225, NULL),
('Residence Inn', 173, '2019-09-06', 318, NULL),
('Residence Inn', 173, '2019-09-07', 246, NULL),
('Residence Inn', 173, '2019-09-08', 352, NULL),
('Residence Inn', 173, '2019-09-09', 254, NULL),
('Residence Inn', 173, '2019-09-10', 245, NULL),
('Residence Inn', 173, '2019-09-11', 296, NULL),
('Residence Inn', 173, '2019-09-12', 329, NULL),
('Residence Inn', 173, '2019-09-13', 234, NULL),
('Residence Inn', 173, '2019-09-14', 242, NULL),
('Residence Inn', 173, '2019-09-15', 342, NULL),
('Residence Inn', 173, '2019-09-16', 302, NULL),
('Residence Inn', 173, '2019-09-17', 142, NULL),
('Residence Inn', 173, '2019-09-18', 345, NULL),
('Residence Inn', 173, '2019-09-19', 225, NULL),
('Residence Inn', 173, '2019-09-20', 109, NULL),
('Residence Inn', 173, '2019-09-21', 103, NULL),
('Residence Inn', 173, '2019-09-22', 315, NULL),
('Residence Inn', 173, '2019-09-23', 328, NULL),
('Residence Inn', 173, '2019-09-24', 135, NULL),
('Residence Inn', 173, '2019-09-25', 367, NULL),
('Residence Inn', 173, '2019-09-26', 351, NULL),
('Residence Inn', 173, '2019-09-27', 280, NULL),
('Residence Inn', 173, '2019-09-28', 397, NULL),
('Residence Inn', 173, '2019-09-29', 172, NULL),
('Residence Inn', 173, '2019-09-30', 239, NULL),
('Residence Inn', 173, '2019-10-01', 265, NULL),
('Residence Inn', 173, '2019-10-02', 301, NULL),
('Residence Inn', 173, '2019-10-03', 296, NULL),
('Residence Inn', 173, '2019-10-04', 127, NULL),
('Residence Inn', 173, '2019-10-05', 265, NULL),
('Residence Inn', 173, '2019-10-06', 332, NULL),
('Residence Inn', 173, '2019-10-07', 159, NULL),
('Residence Inn', 173, '2019-10-08', 152, NULL),
('Residence Inn', 173, '2019-10-09', 136, NULL),
('Residence Inn', 173, '2019-10-10', 288, NULL),
('Residence Inn', 173, '2019-10-11', 209, NULL),
('Residence Inn', 173, '2019-10-12', 203, NULL),
('Residence Inn', 173, '2019-10-13', 255, NULL),
('Residence Inn', 173, '2019-10-14', 333, NULL),
('Residence Inn', 173, '2019-10-15', 175, NULL),
('Residence Inn', 173, '2019-10-16', 324, NULL),
('Residence Inn', 173, '2019-10-17', 287, NULL),
('Residence Inn', 173, '2019-10-18', 291, NULL),
('Residence Inn', 173, '2019-10-19', 388, NULL),
('Residence Inn', 173, '2019-10-20', 314, NULL),
('Residence Inn', 173, '2019-10-21', 326, NULL),
('Residence Inn', 173, '2019-10-22', 202, NULL),
('Residence Inn', 173, '2019-10-23', 302, NULL),
('Residence Inn', 173, '2019-10-24', 379, NULL),
('Residence Inn', 173, '2019-10-25', 313, NULL),
('Residence Inn', 173, '2019-10-26', 386, NULL),
('Residence Inn', 173, '2019-10-27', 336, NULL),
('Residence Inn', 173, '2019-10-28', 160, NULL),
('Residence Inn', 173, '2019-10-29', 295, NULL),
('Residence Inn', 173, '2019-10-30', 296, NULL),
('Residence Inn', 173, '2019-10-31', 317, NULL),
('Residence Inn', 173, '2019-11-01', 380, NULL),
('Residence Inn', 173, '2019-11-02', 321, NULL),
('Residence Inn', 173, '2019-11-03', 362, NULL),
('Residence Inn', 173, '2019-11-04', 158, NULL),
('Residence Inn', 173, '2019-11-05', 201, NULL),
('Residence Inn', 173, '2019-11-06', 217, NULL),
('Residence Inn', 173, '2019-11-07', 357, NULL),
('Residence Inn', 173, '2019-11-08', 318, NULL),
('Residence Inn', 173, '2019-11-09', 166, NULL),
('Residence Inn', 173, '2019-11-10', 153, NULL),
('Residence Inn', 173, '2019-11-11', 273, NULL),
('Residence Inn', 173, '2019-11-12', 346, NULL),
('Residence Inn', 173, '2019-11-13', 387, NULL),
('Residence Inn', 173, '2019-11-14', 395, NULL),
('Residence Inn', 173, '2019-11-15', 241, NULL),
('Residence Inn', 173, '2019-11-16', 139, NULL),
('Residence Inn', 173, '2019-11-17', 218, NULL),
('Residence Inn', 173, '2019-11-18', 259, NULL),
('Residence Inn', 173, '2019-11-19', 295, NULL),
('Residence Inn', 173, '2019-11-20', 362, NULL),
('Residence Inn', 173, '2019-11-21', 220, NULL),
('Residence Inn', 173, '2019-11-22', 263, NULL),
('Residence Inn', 173, '2019-11-23', 117, NULL),
('Residence Inn', 173, '2019-11-24', 100, NULL),
('Residence Inn', 173, '2019-11-25', 336, NULL),
('Residence Inn', 173, '2019-11-26', 115, NULL),
('Residence Inn', 173, '2019-11-27', 394, NULL),
('Residence Inn', 173, '2019-11-28', 377, NULL),
('Residence Inn', 173, '2019-11-29', 377, NULL),
('Residence Inn', 173, '2019-11-30', 214, NULL),
('Residence Inn', 173, '2019-12-01', 310, NULL),
('Residence Inn', 173, '2019-12-02', 174, NULL),
('Residence Inn', 173, '2019-12-03', 238, NULL),
('Residence Inn', 173, '2019-12-04', 144, NULL),
('Residence Inn', 173, '2019-12-05', 247, NULL),
('Residence Inn', 173, '2019-12-06', 196, NULL),
('Residence Inn', 173, '2019-12-07', 147, NULL),
('Residence Inn', 173, '2019-12-08', 171, NULL),
('Residence Inn', 173, '2019-12-09', 357, NULL),
('Residence Inn', 173, '2019-12-10', 211, NULL),
('Residence Inn', 173, '2019-12-11', 170, NULL),
('Residence Inn', 173, '2019-12-12', 375, NULL),
('Residence Inn', 173, '2019-12-13', 358, NULL),
('Residence Inn', 173, '2019-12-14', 360, NULL),
('Residence Inn', 173, '2019-12-15', 150, NULL),
('Residence Inn', 173, '2019-12-16', 205, NULL),
('Residence Inn', 173, '2019-12-17', 258, NULL),
('Residence Inn', 173, '2019-12-18', 337, NULL),
('Residence Inn', 173, '2019-12-19', 125, NULL),
('Residence Inn', 173, '2019-12-20', 153, NULL),
('Residence Inn', 173, '2019-12-21', 222, NULL),
('Residence Inn', 173, '2019-12-22', 155, NULL),
('Residence Inn', 173, '2019-12-23', 135, NULL),
('Residence Inn', 173, '2019-12-24', 186, NULL),
('Residence Inn', 173, '2019-12-25', 392, NULL),
('Residence Inn', 173, '2019-12-26', 230, NULL),
('Residence Inn', 173, '2019-12-27', 308, NULL),
('Residence Inn', 173, '2019-12-28', 215, NULL),
('Residence Inn', 173, '2019-12-29', 143, NULL),
('Residence Inn', 173, '2019-12-30', 393, NULL),
('Residence Inn', 173, '2019-12-31', 350, NULL),
('Residence Inn', 173, '2020-01-01', 109, NULL),
('Residence Inn', 173, '2020-01-02', 246, NULL),
('Residence Inn', 173, '2020-01-03', 399, NULL),
('Residence Inn', 173, '2020-01-04', 234, NULL),
('Residence Inn', 173, '2020-01-05', 343, NULL),
('Residence Inn', 173, '2020-01-06', 203, NULL),
('Residence Inn', 173, '2020-01-07', 262, NULL),
('Residence Inn', 173, '2020-01-08', 230, NULL),
('Residence Inn', 173, '2020-01-09', 305, NULL),
('Residence Inn', 173, '2020-01-10', 316, NULL),
('Residence Inn', 173, '2020-01-11', 219, NULL),
('Residence Inn', 173, '2020-01-12', 389, NULL),
('Residence Inn', 173, '2020-01-13', 156, NULL),
('Residence Inn', 173, '2020-01-14', 226, NULL),
('Residence Inn', 173, '2020-01-15', 310, NULL),
('Residence Inn', 173, '2020-01-16', 121, NULL),
('Residence Inn', 173, '2020-01-17', 306, NULL),
('Residence Inn', 173, '2020-01-18', 315, NULL),
('Residence Inn', 173, '2020-01-19', 315, NULL),
('Residence Inn', 173, '2020-01-20', 306, NULL),
('Residence Inn', 173, '2020-01-21', 311, NULL),
('Residence Inn', 173, '2020-01-22', 365, NULL),
('Residence Inn', 173, '2020-01-23', 208, NULL),
('Residence Inn', 173, '2020-01-24', 149, NULL),
('Residence Inn', 173, '2020-01-25', 196, NULL),
('Residence Inn', 173, '2020-01-26', 305, NULL),
('Residence Inn', 173, '2020-01-27', 263, NULL),
('Residence Inn', 173, '2020-01-28', 123, NULL),
('Residence Inn', 173, '2020-01-29', 396, NULL),
('Residence Inn', 173, '2020-01-30', 163, NULL),
('Residence Inn', 173, '2020-01-31', 156, NULL),
('Residence Inn', 173, '2020-02-01', 256, NULL),
('Residence Inn', 173, '2020-02-02', 167, NULL),
('Residence Inn', 173, '2020-02-03', 388, NULL),
('Residence Inn', 173, '2020-02-04', 209, NULL),
('Residence Inn', 212, '2019-01-01', 263, NULL),
('Residence Inn', 212, '2019-01-02', 178, NULL),
('Residence Inn', 212, '2019-01-03', 176, NULL),
('Residence Inn', 212, '2019-01-04', 282, NULL),
('Residence Inn', 212, '2019-01-05', 255, NULL),
('Residence Inn', 212, '2019-01-06', 108, NULL),
('Residence Inn', 212, '2019-01-07', 255, NULL),
('Residence Inn', 212, '2019-01-08', 273, NULL),
('Residence Inn', 212, '2019-01-09', 285, NULL),
('Residence Inn', 212, '2019-01-10', 120, NULL),
('Residence Inn', 212, '2019-01-11', 201, NULL),
('Residence Inn', 212, '2019-01-12', 332, NULL),
('Residence Inn', 212, '2019-01-13', 156, NULL),
('Residence Inn', 212, '2019-01-14', 150, NULL),
('Residence Inn', 212, '2019-01-15', 191, NULL),
('Residence Inn', 212, '2019-01-16', 372, NULL),
('Residence Inn', 212, '2019-01-17', 304, NULL),
('Residence Inn', 212, '2019-01-18', 293, NULL),
('Residence Inn', 212, '2019-01-19', 262, NULL),
('Residence Inn', 212, '2019-01-20', 112, NULL),
('Residence Inn', 212, '2019-01-21', 147, NULL),
('Residence Inn', 212, '2019-01-22', 214, NULL),
('Residence Inn', 212, '2019-01-23', 380, NULL),
('Residence Inn', 212, '2019-01-24', 248, NULL),
('Residence Inn', 212, '2019-01-25', 326, NULL),
('Residence Inn', 212, '2019-01-26', 349, NULL),
('Residence Inn', 212, '2019-01-27', 299, NULL),
('Residence Inn', 212, '2019-01-28', 356, NULL),
('Residence Inn', 212, '2019-01-29', 230, NULL),
('Residence Inn', 212, '2019-01-30', 348, NULL),
('Residence Inn', 212, '2019-01-31', 167, NULL),
('Residence Inn', 212, '2019-02-01', 343, NULL),
('Residence Inn', 212, '2019-02-02', 238, NULL),
('Residence Inn', 212, '2019-02-03', 383, NULL),
('Residence Inn', 212, '2019-02-04', 255, NULL),
('Residence Inn', 212, '2019-02-05', 215, NULL),
('Residence Inn', 212, '2019-02-06', 301, NULL),
('Residence Inn', 212, '2019-02-07', 295, NULL),
('Residence Inn', 212, '2019-02-08', 359, NULL),
('Residence Inn', 212, '2019-02-09', 162, NULL),
('Residence Inn', 212, '2019-02-10', 345, NULL),
('Residence Inn', 212, '2019-02-11', 153, NULL),
('Residence Inn', 212, '2019-02-12', 362, NULL),
('Residence Inn', 212, '2019-02-13', 111, NULL),
('Residence Inn', 212, '2019-02-14', 316, NULL),
('Residence Inn', 212, '2019-02-15', 369, NULL),
('Residence Inn', 212, '2019-02-16', 378, NULL),
('Residence Inn', 212, '2019-02-17', 168, NULL),
('Residence Inn', 212, '2019-02-18', 373, NULL),
('Residence Inn', 212, '2019-02-19', 343, NULL),
('Residence Inn', 212, '2019-02-20', 379, NULL),
('Residence Inn', 212, '2019-02-21', 197, NULL),
('Residence Inn', 212, '2019-02-22', 193, NULL),
('Residence Inn', 212, '2019-02-23', 147, NULL),
('Residence Inn', 212, '2019-02-24', 188, NULL),
('Residence Inn', 212, '2019-02-25', 133, NULL),
('Residence Inn', 212, '2019-02-26', 124, NULL),
('Residence Inn', 212, '2019-02-27', 361, NULL),
('Residence Inn', 212, '2019-02-28', 361, NULL),
('Residence Inn', 212, '2019-03-01', 344, NULL),
('Residence Inn', 212, '2019-03-02', 181, NULL),
('Residence Inn', 212, '2019-03-03', 197, NULL),
('Residence Inn', 212, '2019-03-04', 130, NULL),
('Residence Inn', 212, '2019-03-05', 258, NULL),
('Residence Inn', 212, '2019-03-06', 299, NULL),
('Residence Inn', 212, '2019-03-07', 114, NULL),
('Residence Inn', 212, '2019-03-08', 292, NULL),
('Residence Inn', 212, '2019-03-09', 241, NULL),
('Residence Inn', 212, '2019-03-10', 124, NULL),
('Residence Inn', 212, '2019-03-11', 168, NULL),
('Residence Inn', 212, '2019-03-12', 216, NULL),
('Residence Inn', 212, '2019-03-13', 110, NULL),
('Residence Inn', 212, '2019-03-14', 364, NULL),
('Residence Inn', 212, '2019-03-15', 351, NULL),
('Residence Inn', 212, '2019-03-16', 228, NULL),
('Residence Inn', 212, '2019-03-17', 375, NULL),
('Residence Inn', 212, '2019-03-18', 110, NULL),
('Residence Inn', 212, '2019-03-19', 326, NULL),
('Residence Inn', 212, '2019-03-20', 281, NULL),
('Residence Inn', 212, '2019-03-21', 233, NULL),
('Residence Inn', 212, '2019-03-22', 364, NULL),
('Residence Inn', 212, '2019-03-23', 109, NULL),
('Residence Inn', 212, '2019-03-24', 260, NULL),
('Residence Inn', 212, '2019-03-25', 276, NULL),
('Residence Inn', 212, '2019-03-26', 303, NULL),
('Residence Inn', 212, '2019-03-27', 176, NULL),
('Residence Inn', 212, '2019-03-28', 195, NULL),
('Residence Inn', 212, '2019-03-29', 271, NULL),
('Residence Inn', 212, '2019-03-30', 150, NULL),
('Residence Inn', 212, '2019-03-31', 230, NULL),
('Residence Inn', 212, '2019-04-01', 343, NULL),
('Residence Inn', 212, '2019-04-02', 233, NULL),
('Residence Inn', 212, '2019-04-03', 100, NULL),
('Residence Inn', 212, '2019-04-04', 363, NULL),
('Residence Inn', 212, '2019-04-05', 339, NULL),
('Residence Inn', 212, '2019-04-06', 323, NULL),
('Residence Inn', 212, '2019-04-07', 235, NULL),
('Residence Inn', 212, '2019-04-08', 300, NULL),
('Residence Inn', 212, '2019-04-09', 306, NULL),
('Residence Inn', 212, '2019-04-10', 112, NULL),
('Residence Inn', 212, '2019-04-11', 306, NULL),
('Residence Inn', 212, '2019-04-12', 189, NULL),
('Residence Inn', 212, '2019-04-13', 318, NULL),
('Residence Inn', 212, '2019-04-14', 170, NULL),
('Residence Inn', 212, '2019-04-15', 165, NULL),
('Residence Inn', 212, '2019-04-16', 210, NULL),
('Residence Inn', 212, '2019-04-17', 328, NULL),
('Residence Inn', 212, '2019-04-18', 183, NULL),
('Residence Inn', 212, '2019-04-19', 371, NULL),
('Residence Inn', 212, '2019-04-20', 273, NULL),
('Residence Inn', 212, '2019-04-21', 173, NULL),
('Residence Inn', 212, '2019-04-22', 143, NULL),
('Residence Inn', 212, '2019-04-23', 120, NULL),
('Residence Inn', 212, '2019-04-24', 145, NULL),
('Residence Inn', 212, '2019-04-25', 327, NULL),
('Residence Inn', 212, '2019-04-26', 244, NULL),
('Residence Inn', 212, '2019-04-27', 261, NULL),
('Residence Inn', 212, '2019-04-28', 211, NULL),
('Residence Inn', 212, '2019-04-29', 152, NULL),
('Residence Inn', 212, '2019-04-30', 253, NULL),
('Residence Inn', 212, '2019-05-01', 350, NULL),
('Residence Inn', 212, '2019-05-02', 340, NULL),
('Residence Inn', 212, '2019-05-03', 337, NULL),
('Residence Inn', 212, '2019-05-04', 251, NULL),
('Residence Inn', 212, '2019-05-05', 133, NULL),
('Residence Inn', 212, '2019-05-06', 159, NULL),
('Residence Inn', 212, '2019-05-07', 150, NULL),
('Residence Inn', 212, '2019-05-08', 293, NULL),
('Residence Inn', 212, '2019-05-09', 395, NULL),
('Residence Inn', 212, '2019-05-10', 251, NULL),
('Residence Inn', 212, '2019-05-11', 154, NULL),
('Residence Inn', 212, '2019-05-12', 363, NULL),
('Residence Inn', 212, '2019-05-13', 245, NULL),
('Residence Inn', 212, '2019-05-14', 375, NULL),
('Residence Inn', 212, '2019-05-15', 352, NULL),
('Residence Inn', 212, '2019-05-16', 391, NULL),
('Residence Inn', 212, '2019-05-17', 246, NULL),
('Residence Inn', 212, '2019-05-18', 195, NULL),
('Residence Inn', 212, '2019-05-19', 261, NULL),
('Residence Inn', 212, '2019-05-20', 331, NULL),
('Residence Inn', 212, '2019-05-21', 194, NULL),
('Residence Inn', 212, '2019-05-22', 208, NULL),
('Residence Inn', 212, '2019-05-23', 319, NULL),
('Residence Inn', 212, '2019-05-24', 151, NULL),
('Residence Inn', 212, '2019-05-25', 330, NULL),
('Residence Inn', 212, '2019-05-26', 361, NULL),
('Residence Inn', 212, '2019-05-27', 274, NULL),
('Residence Inn', 212, '2019-05-28', 142, NULL),
('Residence Inn', 212, '2019-05-29', 269, NULL),
('Residence Inn', 212, '2019-05-30', 294, NULL),
('Residence Inn', 212, '2019-05-31', 259, NULL),
('Residence Inn', 212, '2019-06-01', 254, NULL),
('Residence Inn', 212, '2019-06-02', 229, NULL),
('Residence Inn', 212, '2019-06-03', 180, NULL),
('Residence Inn', 212, '2019-06-04', 143, NULL),
('Residence Inn', 212, '2019-06-05', 239, NULL),
('Residence Inn', 212, '2019-06-06', 351, NULL),
('Residence Inn', 212, '2019-06-07', 382, NULL),
('Residence Inn', 212, '2019-06-08', 216, NULL),
('Residence Inn', 212, '2019-06-09', 261, NULL),
('Residence Inn', 212, '2019-06-10', 102, NULL),
('Residence Inn', 212, '2019-06-11', 284, NULL),
('Residence Inn', 212, '2019-06-12', 310, NULL),
('Residence Inn', 212, '2019-06-13', 100, NULL),
('Residence Inn', 212, '2019-06-14', 136, NULL),
('Residence Inn', 212, '2019-06-15', 387, NULL),
('Residence Inn', 212, '2019-06-16', 326, NULL),
('Residence Inn', 212, '2019-06-17', 109, NULL),
('Residence Inn', 212, '2019-06-18', 210, NULL),
('Residence Inn', 212, '2019-06-19', 378, NULL),
('Residence Inn', 212, '2019-06-20', 240, NULL),
('Residence Inn', 212, '2019-06-21', 348, NULL),
('Residence Inn', 212, '2019-06-22', 280, NULL),
('Residence Inn', 212, '2019-06-23', 307, NULL),
('Residence Inn', 212, '2019-06-24', 183, NULL),
('Residence Inn', 212, '2019-06-25', 253, NULL),
('Residence Inn', 212, '2019-06-26', 174, NULL),
('Residence Inn', 212, '2019-06-27', 276, NULL),
('Residence Inn', 212, '2019-06-28', 151, NULL),
('Residence Inn', 212, '2019-06-29', 342, NULL),
('Residence Inn', 212, '2019-06-30', 146, NULL),
('Residence Inn', 212, '2019-07-01', 202, NULL),
('Residence Inn', 212, '2019-07-02', 374, NULL),
('Residence Inn', 212, '2019-07-03', 107, NULL),
('Residence Inn', 212, '2019-07-04', 243, NULL),
('Residence Inn', 212, '2019-07-05', 277, NULL),
('Residence Inn', 212, '2019-07-06', 329, NULL),
('Residence Inn', 212, '2019-07-07', 395, NULL),
('Residence Inn', 212, '2019-07-08', 362, NULL),
('Residence Inn', 212, '2019-07-09', 314, NULL),
('Residence Inn', 212, '2019-07-10', 313, NULL),
('Residence Inn', 212, '2019-07-11', 335, NULL),
('Residence Inn', 212, '2019-07-12', 276, NULL),
('Residence Inn', 212, '2019-07-13', 335, NULL),
('Residence Inn', 212, '2019-07-14', 211, NULL),
('Residence Inn', 212, '2019-07-15', 244, NULL),
('Residence Inn', 212, '2019-07-16', 136, NULL),
('Residence Inn', 212, '2019-07-17', 180, NULL),
('Residence Inn', 212, '2019-07-18', 185, NULL),
('Residence Inn', 212, '2019-07-19', 138, NULL),
('Residence Inn', 212, '2019-07-20', 109, NULL),
('Residence Inn', 212, '2019-07-21', 264, NULL),
('Residence Inn', 212, '2019-07-22', 327, NULL),
('Residence Inn', 212, '2019-07-23', 367, NULL),
('Residence Inn', 212, '2019-07-24', 388, NULL),
('Residence Inn', 212, '2019-07-25', 144, NULL),
('Residence Inn', 212, '2019-07-26', 399, NULL),
('Residence Inn', 212, '2019-07-27', 120, NULL),
('Residence Inn', 212, '2019-07-28', 359, NULL),
('Residence Inn', 212, '2019-07-29', 332, NULL),
('Residence Inn', 212, '2019-07-30', 303, NULL),
('Residence Inn', 212, '2019-07-31', 279, NULL),
('Residence Inn', 212, '2019-08-01', 386, NULL),
('Residence Inn', 212, '2019-08-02', 236, NULL),
('Residence Inn', 212, '2019-08-03', 277, NULL),
('Residence Inn', 212, '2019-08-04', 360, NULL),
('Residence Inn', 212, '2019-08-05', 389, NULL),
('Residence Inn', 212, '2019-08-06', 190, NULL),
('Residence Inn', 212, '2019-08-07', 271, NULL),
('Residence Inn', 212, '2019-08-08', 344, NULL),
('Residence Inn', 212, '2019-08-09', 112, NULL),
('Residence Inn', 212, '2019-08-10', 343, NULL),
('Residence Inn', 212, '2019-08-11', 357, NULL),
('Residence Inn', 212, '2019-08-12', 173, NULL),
('Residence Inn', 212, '2019-08-13', 192, NULL),
('Residence Inn', 212, '2019-08-14', 237, NULL),
('Residence Inn', 212, '2019-08-15', 226, NULL),
('Residence Inn', 212, '2019-08-16', 107, NULL),
('Residence Inn', 212, '2019-08-17', 396, NULL),
('Residence Inn', 212, '2019-08-18', 280, NULL),
('Residence Inn', 212, '2019-08-19', 381, NULL),
('Residence Inn', 212, '2019-08-20', 331, NULL),
('Residence Inn', 212, '2019-08-21', 144, NULL),
('Residence Inn', 212, '2019-08-22', 346, NULL),
('Residence Inn', 212, '2019-08-23', 276, NULL),
('Residence Inn', 212, '2019-08-24', 398, NULL),
('Residence Inn', 212, '2019-08-25', 348, NULL),
('Residence Inn', 212, '2019-08-26', 386, NULL),
('Residence Inn', 212, '2019-08-27', 256, NULL),
('Residence Inn', 212, '2019-08-28', 189, NULL),
('Residence Inn', 212, '2019-08-29', 347, NULL),
('Residence Inn', 212, '2019-08-30', 394, NULL),
('Residence Inn', 212, '2019-08-31', 360, NULL),
('Residence Inn', 212, '2019-09-01', 308, NULL),
('Residence Inn', 212, '2019-09-02', 381, NULL),
('Residence Inn', 212, '2019-09-03', 152, NULL),
('Residence Inn', 212, '2019-09-04', 201, NULL),
('Residence Inn', 212, '2019-09-05', 170, NULL),
('Residence Inn', 212, '2019-09-06', 378, NULL),
('Residence Inn', 212, '2019-09-07', 226, NULL),
('Residence Inn', 212, '2019-09-08', 278, NULL),
('Residence Inn', 212, '2019-09-09', 160, NULL),
('Residence Inn', 212, '2019-09-10', 248, NULL),
('Residence Inn', 212, '2019-09-11', 261, NULL),
('Residence Inn', 212, '2019-09-12', 188, NULL),
('Residence Inn', 212, '2019-09-13', 339, NULL),
('Residence Inn', 212, '2019-09-14', 208, NULL),
('Residence Inn', 212, '2019-09-15', 111, NULL),
('Residence Inn', 212, '2019-09-16', 271, NULL),
('Residence Inn', 212, '2019-09-17', 377, NULL),
('Residence Inn', 212, '2019-09-18', 157, NULL),
('Residence Inn', 212, '2019-09-19', 210, NULL),
('Residence Inn', 212, '2019-09-20', 138, NULL),
('Residence Inn', 212, '2019-09-21', 253, NULL),
('Residence Inn', 212, '2019-09-22', 366, NULL),
('Residence Inn', 212, '2019-09-23', 173, NULL),
('Residence Inn', 212, '2019-09-24', 320, NULL),
('Residence Inn', 212, '2019-09-25', 114, NULL),
('Residence Inn', 212, '2019-09-26', 255, NULL),
('Residence Inn', 212, '2019-09-27', 306, NULL),
('Residence Inn', 212, '2019-09-28', 281, NULL),
('Residence Inn', 212, '2019-09-29', 387, NULL),
('Residence Inn', 212, '2019-09-30', 194, NULL),
('Residence Inn', 212, '2019-10-01', 374, NULL),
('Residence Inn', 212, '2019-10-02', 172, NULL),
('Residence Inn', 212, '2019-10-03', 342, NULL),
('Residence Inn', 212, '2019-10-04', 273, NULL),
('Residence Inn', 212, '2019-10-05', 297, NULL),
('Residence Inn', 212, '2019-10-06', 282, NULL),
('Residence Inn', 212, '2019-10-07', 245, NULL),
('Residence Inn', 212, '2019-10-08', 260, NULL),
('Residence Inn', 212, '2019-10-09', 156, NULL),
('Residence Inn', 212, '2019-10-10', 222, NULL),
('Residence Inn', 212, '2019-10-11', 353, NULL),
('Residence Inn', 212, '2019-10-12', 326, NULL),
('Residence Inn', 212, '2019-10-13', 261, NULL),
('Residence Inn', 212, '2019-10-14', 318, NULL),
('Residence Inn', 212, '2019-10-15', 199, NULL),
('Residence Inn', 212, '2019-10-16', 199, NULL),
('Residence Inn', 212, '2019-10-17', 215, NULL),
('Residence Inn', 212, '2019-10-18', 112, NULL),
('Residence Inn', 212, '2019-10-19', 387, NULL),
('Residence Inn', 212, '2019-10-20', 361, NULL),
('Residence Inn', 212, '2019-10-21', 104, NULL),
('Residence Inn', 212, '2019-10-22', 372, NULL),
('Residence Inn', 212, '2019-10-23', 165, NULL),
('Residence Inn', 212, '2019-10-24', 394, NULL),
('Residence Inn', 212, '2019-10-25', 248, NULL),
('Residence Inn', 212, '2019-10-26', 150, NULL),
('Residence Inn', 212, '2019-10-27', 375, NULL),
('Residence Inn', 212, '2019-10-28', 214, NULL),
('Residence Inn', 212, '2019-10-29', 299, NULL),
('Residence Inn', 212, '2019-10-30', 389, NULL),
('Residence Inn', 212, '2019-10-31', 121, NULL),
('Residence Inn', 212, '2019-11-01', 169, NULL),
('Residence Inn', 212, '2019-11-02', 265, NULL),
('Residence Inn', 212, '2019-11-03', 361, NULL),
('Residence Inn', 212, '2019-11-04', 342, NULL),
('Residence Inn', 212, '2019-11-05', 222, NULL),
('Residence Inn', 212, '2019-11-06', 253, NULL),
('Residence Inn', 212, '2019-11-07', 293, NULL),
('Residence Inn', 212, '2019-11-08', 306, NULL),
('Residence Inn', 212, '2019-11-09', 171, NULL),
('Residence Inn', 212, '2019-11-10', 126, NULL),
('Residence Inn', 212, '2019-11-11', 221, NULL),
('Residence Inn', 212, '2019-11-12', 104, NULL),
('Residence Inn', 212, '2019-11-13', 210, NULL),
('Residence Inn', 212, '2019-11-14', 275, NULL),
('Residence Inn', 212, '2019-11-15', 247, NULL),
('Residence Inn', 212, '2019-11-16', 183, NULL),
('Residence Inn', 212, '2019-11-17', 301, NULL),
('Residence Inn', 212, '2019-11-18', 365, NULL),
('Residence Inn', 212, '2019-11-19', 321, NULL),
('Residence Inn', 212, '2019-11-20', 220, NULL),
('Residence Inn', 212, '2019-11-21', 194, NULL),
('Residence Inn', 212, '2019-11-22', 337, NULL),
('Residence Inn', 212, '2019-11-23', 108, NULL),
('Residence Inn', 212, '2019-11-24', 334, NULL),
('Residence Inn', 212, '2019-11-25', 150, NULL),
('Residence Inn', 212, '2019-11-26', 357, NULL),
('Residence Inn', 212, '2019-11-27', 273, NULL),
('Residence Inn', 212, '2019-11-28', 218, NULL),
('Residence Inn', 212, '2019-11-29', 125, NULL),
('Residence Inn', 212, '2019-11-30', 377, NULL),
('Residence Inn', 212, '2019-12-01', 327, NULL),
('Residence Inn', 212, '2019-12-02', 328, NULL),
('Residence Inn', 212, '2019-12-03', 329, NULL),
('Residence Inn', 212, '2019-12-04', 248, NULL),
('Residence Inn', 212, '2019-12-05', 199, NULL),
('Residence Inn', 212, '2019-12-06', 202, NULL),
('Residence Inn', 212, '2019-12-07', 226, NULL),
('Residence Inn', 212, '2019-12-08', 144, NULL),
('Residence Inn', 212, '2019-12-09', 385, NULL),
('Residence Inn', 212, '2019-12-10', 135, NULL),
('Residence Inn', 212, '2019-12-11', 119, NULL),
('Residence Inn', 212, '2019-12-12', 270, NULL),
('Residence Inn', 212, '2019-12-13', 150, NULL),
('Residence Inn', 212, '2019-12-14', 275, NULL),
('Residence Inn', 212, '2019-12-15', 104, NULL),
('Residence Inn', 212, '2019-12-16', 312, NULL),
('Residence Inn', 212, '2019-12-17', 385, NULL),
('Residence Inn', 212, '2019-12-18', 135, NULL),
('Residence Inn', 212, '2019-12-19', 251, NULL),
('Residence Inn', 212, '2019-12-20', 320, NULL),
('Residence Inn', 212, '2019-12-21', 345, NULL),
('Residence Inn', 212, '2019-12-22', 297, NULL),
('Residence Inn', 212, '2019-12-23', 360, NULL),
('Residence Inn', 212, '2019-12-24', 155, NULL),
('Residence Inn', 212, '2019-12-25', 316, NULL),
('Residence Inn', 212, '2019-12-26', 163, NULL),
('Residence Inn', 212, '2019-12-27', 312, NULL),
('Residence Inn', 212, '2019-12-28', 159, NULL),
('Residence Inn', 212, '2019-12-29', 212, NULL),
('Residence Inn', 212, '2019-12-30', 278, NULL),
('Residence Inn', 212, '2019-12-31', 107, NULL),
('Residence Inn', 212, '2020-01-01', 202, NULL),
('Residence Inn', 212, '2020-01-02', 324, NULL),
('Residence Inn', 212, '2020-01-03', 152, NULL),
('Residence Inn', 212, '2020-01-04', 191, NULL),
('Residence Inn', 212, '2020-01-05', 252, NULL),
('Residence Inn', 212, '2020-01-06', 134, NULL),
('Residence Inn', 212, '2020-01-07', 259, NULL),
('Residence Inn', 212, '2020-01-08', 190, NULL),
('Residence Inn', 212, '2020-01-09', 347, NULL),
('Residence Inn', 212, '2020-01-10', 190, NULL),
('Residence Inn', 212, '2020-01-11', 304, NULL),
('Residence Inn', 212, '2020-01-12', 287, NULL),
('Residence Inn', 212, '2020-01-13', 199, NULL),
('Residence Inn', 212, '2020-01-14', 308, NULL),
('Residence Inn', 212, '2020-01-15', 118, NULL),
('Residence Inn', 212, '2020-01-16', 259, NULL),
('Residence Inn', 212, '2020-01-17', 364, NULL),
('Residence Inn', 212, '2020-01-18', 152, NULL),
('Residence Inn', 212, '2020-01-19', 283, NULL),
('Residence Inn', 212, '2020-01-20', 394, NULL),
('Residence Inn', 212, '2020-01-21', 336, NULL),
('Residence Inn', 212, '2020-01-22', 281, NULL),
('Residence Inn', 212, '2020-01-23', 351, NULL),
('Residence Inn', 212, '2020-01-24', 164, NULL),
('Residence Inn', 212, '2020-01-25', 294, NULL),
('Residence Inn', 212, '2020-01-26', 201, NULL),
('Residence Inn', 212, '2020-01-27', 285, NULL),
('Residence Inn', 212, '2020-01-28', 219, NULL),
('Residence Inn', 212, '2020-01-29', 113, NULL),
('Residence Inn', 212, '2020-01-30', 261, NULL),
('Residence Inn', 212, '2020-01-31', 284, NULL),
('Residence Inn', 212, '2020-02-01', 298, NULL),
('Residence Inn', 212, '2020-02-02', 321, NULL),
('Residence Inn', 212, '2020-02-03', 141, NULL),
('Residence Inn', 212, '2020-02-04', 199, NULL),
('Residence Inn', 239, '2019-01-01', 328, NULL),
('Residence Inn', 239, '2019-01-02', 215, NULL),
('Residence Inn', 239, '2019-01-03', 278, NULL),
('Residence Inn', 239, '2019-01-04', 167, NULL),
('Residence Inn', 239, '2019-01-05', 108, NULL),
('Residence Inn', 239, '2019-01-06', 352, NULL),
('Residence Inn', 239, '2019-01-07', 250, NULL),
('Residence Inn', 239, '2019-01-08', 387, NULL),
('Residence Inn', 239, '2019-01-09', 169, NULL),
('Residence Inn', 239, '2019-01-10', 218, NULL),
('Residence Inn', 239, '2019-01-11', 280, NULL),
('Residence Inn', 239, '2019-01-12', 134, NULL),
('Residence Inn', 239, '2019-01-13', 104, NULL),
('Residence Inn', 239, '2019-01-14', 286, NULL),
('Residence Inn', 239, '2019-01-15', 195, NULL),
('Residence Inn', 239, '2019-01-16', 134, NULL),
('Residence Inn', 239, '2019-01-17', 335, NULL),
('Residence Inn', 239, '2019-01-18', 102, NULL),
('Residence Inn', 239, '2019-01-19', 167, NULL),
('Residence Inn', 239, '2019-01-20', 207, NULL),
('Residence Inn', 239, '2019-01-21', 212, NULL),
('Residence Inn', 239, '2019-01-22', 298, NULL),
('Residence Inn', 239, '2019-01-23', 309, NULL),
('Residence Inn', 239, '2019-01-24', 288, NULL),
('Residence Inn', 239, '2019-01-25', 327, NULL),
('Residence Inn', 239, '2019-01-26', 223, NULL),
('Residence Inn', 239, '2019-01-27', 206, NULL),
('Residence Inn', 239, '2019-01-28', 399, NULL),
('Residence Inn', 239, '2019-01-29', 109, NULL),
('Residence Inn', 239, '2019-01-30', 192, NULL),
('Residence Inn', 239, '2019-01-31', 219, NULL),
('Residence Inn', 239, '2019-02-01', 368, NULL),
('Residence Inn', 239, '2019-02-02', 216, NULL),
('Residence Inn', 239, '2019-02-03', 237, NULL),
('Residence Inn', 239, '2019-02-04', 228, NULL),
('Residence Inn', 239, '2019-02-05', 330, NULL),
('Residence Inn', 239, '2019-02-06', 118, NULL),
('Residence Inn', 239, '2019-02-07', 192, NULL),
('Residence Inn', 239, '2019-02-08', 114, NULL),
('Residence Inn', 239, '2019-02-09', 116, NULL),
('Residence Inn', 239, '2019-02-10', 358, NULL),
('Residence Inn', 239, '2019-02-11', 143, NULL),
('Residence Inn', 239, '2019-02-12', 293, NULL),
('Residence Inn', 239, '2019-02-13', 139, NULL),
('Residence Inn', 239, '2019-02-14', 147, NULL),
('Residence Inn', 239, '2019-02-15', 155, NULL),
('Residence Inn', 239, '2019-02-16', 150, NULL),
('Residence Inn', 239, '2019-02-17', 285, NULL),
('Residence Inn', 239, '2019-02-18', 165, NULL),
('Residence Inn', 239, '2019-02-19', 199, NULL),
('Residence Inn', 239, '2019-02-20', 341, NULL),
('Residence Inn', 239, '2019-02-21', 100, NULL),
('Residence Inn', 239, '2019-02-22', 244, NULL),
('Residence Inn', 239, '2019-02-23', 101, NULL),
('Residence Inn', 239, '2019-02-24', 251, NULL),
('Residence Inn', 239, '2019-02-25', 181, NULL),
('Residence Inn', 239, '2019-02-26', 178, NULL),
('Residence Inn', 239, '2019-02-27', 345, NULL),
('Residence Inn', 239, '2019-02-28', 322, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 239, '2019-03-01', 270, NULL),
('Residence Inn', 239, '2019-03-02', 197, NULL),
('Residence Inn', 239, '2019-03-03', 356, NULL),
('Residence Inn', 239, '2019-03-04', 220, NULL),
('Residence Inn', 239, '2019-03-05', 198, NULL),
('Residence Inn', 239, '2019-03-06', 177, NULL),
('Residence Inn', 239, '2019-03-07', 116, NULL),
('Residence Inn', 239, '2019-03-08', 219, NULL),
('Residence Inn', 239, '2019-03-09', 341, NULL),
('Residence Inn', 239, '2019-03-10', 374, NULL),
('Residence Inn', 239, '2019-03-11', 391, NULL),
('Residence Inn', 239, '2019-03-12', 256, NULL),
('Residence Inn', 239, '2019-03-13', 119, NULL),
('Residence Inn', 239, '2019-03-14', 316, NULL),
('Residence Inn', 239, '2019-03-15', 159, NULL),
('Residence Inn', 239, '2019-03-16', 298, NULL),
('Residence Inn', 239, '2019-03-17', 223, NULL),
('Residence Inn', 239, '2019-03-18', 123, NULL),
('Residence Inn', 239, '2019-03-19', 151, NULL),
('Residence Inn', 239, '2019-03-20', 137, NULL),
('Residence Inn', 239, '2019-03-21', 177, NULL),
('Residence Inn', 239, '2019-03-22', 233, NULL),
('Residence Inn', 239, '2019-03-23', 266, NULL),
('Residence Inn', 239, '2019-03-24', 102, NULL),
('Residence Inn', 239, '2019-03-25', 211, NULL),
('Residence Inn', 239, '2019-03-26', 361, NULL),
('Residence Inn', 239, '2019-03-27', 130, NULL),
('Residence Inn', 239, '2019-03-28', 123, NULL),
('Residence Inn', 239, '2019-03-29', 302, NULL),
('Residence Inn', 239, '2019-03-30', 100, NULL),
('Residence Inn', 239, '2019-03-31', 363, NULL),
('Residence Inn', 239, '2019-04-01', 155, NULL),
('Residence Inn', 239, '2019-04-02', 158, NULL),
('Residence Inn', 239, '2019-04-03', 256, NULL),
('Residence Inn', 239, '2019-04-04', 295, NULL),
('Residence Inn', 239, '2019-04-05', 107, NULL),
('Residence Inn', 239, '2019-04-06', 228, NULL),
('Residence Inn', 239, '2019-04-07', 123, NULL),
('Residence Inn', 239, '2019-04-08', 315, NULL),
('Residence Inn', 239, '2019-04-09', 182, NULL),
('Residence Inn', 239, '2019-04-10', 126, NULL),
('Residence Inn', 239, '2019-04-11', 204, NULL),
('Residence Inn', 239, '2019-04-12', 259, NULL),
('Residence Inn', 239, '2019-04-13', 135, NULL),
('Residence Inn', 239, '2019-04-14', 265, NULL),
('Residence Inn', 239, '2019-04-15', 112, NULL),
('Residence Inn', 239, '2019-04-16', 380, NULL),
('Residence Inn', 239, '2019-04-17', 117, NULL),
('Residence Inn', 239, '2019-04-18', 199, NULL),
('Residence Inn', 239, '2019-04-19', 316, NULL),
('Residence Inn', 239, '2019-04-20', 312, NULL),
('Residence Inn', 239, '2019-04-21', 301, NULL),
('Residence Inn', 239, '2019-04-22', 342, NULL),
('Residence Inn', 239, '2019-04-23', 166, NULL),
('Residence Inn', 239, '2019-04-24', 363, NULL),
('Residence Inn', 239, '2019-04-25', 167, NULL),
('Residence Inn', 239, '2019-04-26', 180, NULL),
('Residence Inn', 239, '2019-04-27', 397, NULL),
('Residence Inn', 239, '2019-04-28', 314, NULL),
('Residence Inn', 239, '2019-04-29', 286, NULL),
('Residence Inn', 239, '2019-04-30', 285, NULL),
('Residence Inn', 239, '2019-05-01', 208, NULL),
('Residence Inn', 239, '2019-05-02', 220, NULL),
('Residence Inn', 239, '2019-05-03', 382, NULL),
('Residence Inn', 239, '2019-05-04', 172, NULL),
('Residence Inn', 239, '2019-05-05', 321, NULL),
('Residence Inn', 239, '2019-05-06', 256, NULL),
('Residence Inn', 239, '2019-05-07', 180, NULL),
('Residence Inn', 239, '2019-05-08', 326, NULL),
('Residence Inn', 239, '2019-05-09', 240, NULL),
('Residence Inn', 239, '2019-05-10', 215, NULL),
('Residence Inn', 239, '2019-05-11', 372, NULL),
('Residence Inn', 239, '2019-05-12', 230, NULL),
('Residence Inn', 239, '2019-05-13', 272, NULL),
('Residence Inn', 239, '2019-05-14', 246, NULL),
('Residence Inn', 239, '2019-05-15', 148, NULL),
('Residence Inn', 239, '2019-05-16', 233, NULL),
('Residence Inn', 239, '2019-05-17', 219, NULL),
('Residence Inn', 239, '2019-05-18', 140, NULL),
('Residence Inn', 239, '2019-05-19', 193, NULL),
('Residence Inn', 239, '2019-05-20', 272, NULL),
('Residence Inn', 239, '2019-05-21', 102, NULL),
('Residence Inn', 239, '2019-05-22', 334, NULL),
('Residence Inn', 239, '2019-05-23', 234, NULL),
('Residence Inn', 239, '2019-05-24', 360, NULL),
('Residence Inn', 239, '2019-05-25', 266, NULL),
('Residence Inn', 239, '2019-05-26', 140, NULL),
('Residence Inn', 239, '2019-05-27', 348, NULL),
('Residence Inn', 239, '2019-05-28', 275, NULL),
('Residence Inn', 239, '2019-05-29', 397, NULL),
('Residence Inn', 239, '2019-05-30', 150, NULL),
('Residence Inn', 239, '2019-05-31', 339, NULL),
('Residence Inn', 239, '2019-06-01', 183, NULL),
('Residence Inn', 239, '2019-06-02', 101, NULL),
('Residence Inn', 239, '2019-06-03', 137, NULL),
('Residence Inn', 239, '2019-06-04', 335, NULL),
('Residence Inn', 239, '2019-06-05', 162, NULL),
('Residence Inn', 239, '2019-06-06', 378, NULL),
('Residence Inn', 239, '2019-06-07', 333, NULL),
('Residence Inn', 239, '2019-06-08', 306, NULL),
('Residence Inn', 239, '2019-06-09', 340, NULL),
('Residence Inn', 239, '2019-06-10', 302, NULL),
('Residence Inn', 239, '2019-06-11', 390, NULL),
('Residence Inn', 239, '2019-06-12', 355, NULL),
('Residence Inn', 239, '2019-06-13', 301, NULL),
('Residence Inn', 239, '2019-06-14', 233, NULL),
('Residence Inn', 239, '2019-06-15', 235, NULL),
('Residence Inn', 239, '2019-06-16', 307, NULL),
('Residence Inn', 239, '2019-06-17', 367, NULL),
('Residence Inn', 239, '2019-06-18', 115, NULL),
('Residence Inn', 239, '2019-06-19', 135, NULL),
('Residence Inn', 239, '2019-06-20', 162, NULL),
('Residence Inn', 239, '2019-06-21', 309, NULL),
('Residence Inn', 239, '2019-06-22', 361, NULL),
('Residence Inn', 239, '2019-06-23', 159, NULL),
('Residence Inn', 239, '2019-06-24', 198, NULL),
('Residence Inn', 239, '2019-06-25', 233, NULL),
('Residence Inn', 239, '2019-06-26', 298, NULL),
('Residence Inn', 239, '2019-06-27', 249, NULL),
('Residence Inn', 239, '2019-06-28', 162, NULL),
('Residence Inn', 239, '2019-06-29', 191, NULL),
('Residence Inn', 239, '2019-06-30', 399, NULL),
('Residence Inn', 239, '2019-07-01', 276, NULL),
('Residence Inn', 239, '2019-07-02', 395, NULL),
('Residence Inn', 239, '2019-07-03', 281, NULL),
('Residence Inn', 239, '2019-07-04', 354, NULL),
('Residence Inn', 239, '2019-07-05', 147, NULL),
('Residence Inn', 239, '2019-07-06', 257, NULL),
('Residence Inn', 239, '2019-07-07', 187, NULL),
('Residence Inn', 239, '2019-07-08', 322, NULL),
('Residence Inn', 239, '2019-07-09', 335, NULL),
('Residence Inn', 239, '2019-07-10', 368, NULL),
('Residence Inn', 239, '2019-07-11', 274, NULL),
('Residence Inn', 239, '2019-07-12', 276, NULL),
('Residence Inn', 239, '2019-07-13', 112, NULL),
('Residence Inn', 239, '2019-07-14', 317, NULL),
('Residence Inn', 239, '2019-07-15', 217, NULL),
('Residence Inn', 239, '2019-07-16', 193, NULL),
('Residence Inn', 239, '2019-07-17', 269, NULL),
('Residence Inn', 239, '2019-07-18', 160, NULL),
('Residence Inn', 239, '2019-07-19', 316, NULL),
('Residence Inn', 239, '2019-07-20', 265, NULL),
('Residence Inn', 239, '2019-07-21', 129, NULL),
('Residence Inn', 239, '2019-07-22', 112, NULL),
('Residence Inn', 239, '2019-07-23', 145, NULL),
('Residence Inn', 239, '2019-07-24', 216, NULL),
('Residence Inn', 239, '2019-07-25', 105, NULL),
('Residence Inn', 239, '2019-07-26', 382, NULL),
('Residence Inn', 239, '2019-07-27', 133, NULL),
('Residence Inn', 239, '2019-07-28', 293, NULL),
('Residence Inn', 239, '2019-07-29', 248, NULL),
('Residence Inn', 239, '2019-07-30', 318, NULL),
('Residence Inn', 239, '2019-07-31', 155, NULL),
('Residence Inn', 239, '2019-08-01', 230, NULL),
('Residence Inn', 239, '2019-08-02', 259, NULL),
('Residence Inn', 239, '2019-08-03', 144, NULL),
('Residence Inn', 239, '2019-08-04', 225, NULL),
('Residence Inn', 239, '2019-08-05', 233, NULL),
('Residence Inn', 239, '2019-08-06', 248, NULL),
('Residence Inn', 239, '2019-08-07', 214, NULL),
('Residence Inn', 239, '2019-08-08', 297, NULL),
('Residence Inn', 239, '2019-08-09', 268, NULL),
('Residence Inn', 239, '2019-08-10', 245, NULL),
('Residence Inn', 239, '2019-08-11', 275, NULL),
('Residence Inn', 239, '2019-08-12', 180, NULL),
('Residence Inn', 239, '2019-08-13', 180, NULL),
('Residence Inn', 239, '2019-08-14', 274, NULL),
('Residence Inn', 239, '2019-08-15', 134, NULL),
('Residence Inn', 239, '2019-08-16', 251, NULL),
('Residence Inn', 239, '2019-08-17', 208, NULL),
('Residence Inn', 239, '2019-08-18', 236, NULL),
('Residence Inn', 239, '2019-08-19', 172, NULL),
('Residence Inn', 239, '2019-08-20', 154, NULL),
('Residence Inn', 239, '2019-08-21', 169, NULL),
('Residence Inn', 239, '2019-08-22', 251, NULL),
('Residence Inn', 239, '2019-08-23', 254, NULL),
('Residence Inn', 239, '2019-08-24', 263, NULL),
('Residence Inn', 239, '2019-08-25', 347, NULL),
('Residence Inn', 239, '2019-08-26', 362, NULL),
('Residence Inn', 239, '2019-08-27', 255, NULL),
('Residence Inn', 239, '2019-08-28', 341, NULL),
('Residence Inn', 239, '2019-08-29', 117, NULL),
('Residence Inn', 239, '2019-08-30', 208, NULL),
('Residence Inn', 239, '2019-08-31', 386, NULL),
('Residence Inn', 239, '2019-09-01', 114, NULL),
('Residence Inn', 239, '2019-09-02', 195, NULL),
('Residence Inn', 239, '2019-09-03', 105, NULL),
('Residence Inn', 239, '2019-09-04', 269, NULL),
('Residence Inn', 239, '2019-09-05', 378, NULL),
('Residence Inn', 239, '2019-09-06', 238, NULL),
('Residence Inn', 239, '2019-09-07', 295, NULL),
('Residence Inn', 239, '2019-09-08', 235, NULL),
('Residence Inn', 239, '2019-09-09', 242, NULL),
('Residence Inn', 239, '2019-09-10', 108, NULL),
('Residence Inn', 239, '2019-09-11', 318, NULL),
('Residence Inn', 239, '2019-09-12', 153, NULL),
('Residence Inn', 239, '2019-09-13', 291, NULL),
('Residence Inn', 239, '2019-09-14', 215, NULL),
('Residence Inn', 239, '2019-09-15', 333, NULL),
('Residence Inn', 239, '2019-09-16', 351, NULL),
('Residence Inn', 239, '2019-09-17', 160, NULL),
('Residence Inn', 239, '2019-09-18', 253, NULL),
('Residence Inn', 239, '2019-09-19', 274, NULL),
('Residence Inn', 239, '2019-09-20', 263, NULL),
('Residence Inn', 239, '2019-09-21', 254, NULL),
('Residence Inn', 239, '2019-09-22', 188, NULL),
('Residence Inn', 239, '2019-09-23', 382, NULL),
('Residence Inn', 239, '2019-09-24', 195, NULL),
('Residence Inn', 239, '2019-09-25', 270, NULL),
('Residence Inn', 239, '2019-09-26', 122, NULL),
('Residence Inn', 239, '2019-09-27', 292, NULL),
('Residence Inn', 239, '2019-09-28', 113, NULL),
('Residence Inn', 239, '2019-09-29', 120, NULL),
('Residence Inn', 239, '2019-09-30', 152, NULL),
('Residence Inn', 239, '2019-10-01', 376, NULL),
('Residence Inn', 239, '2019-10-02', 155, NULL),
('Residence Inn', 239, '2019-10-03', 123, NULL),
('Residence Inn', 239, '2019-10-04', 283, NULL),
('Residence Inn', 239, '2019-10-05', 288, NULL),
('Residence Inn', 239, '2019-10-06', 315, NULL),
('Residence Inn', 239, '2019-10-07', 346, NULL),
('Residence Inn', 239, '2019-10-08', 148, NULL),
('Residence Inn', 239, '2019-10-09', 274, NULL),
('Residence Inn', 239, '2019-10-10', 148, NULL),
('Residence Inn', 239, '2019-10-11', 138, NULL),
('Residence Inn', 239, '2019-10-12', 321, NULL),
('Residence Inn', 239, '2019-10-13', 138, NULL),
('Residence Inn', 239, '2019-10-14', 192, NULL),
('Residence Inn', 239, '2019-10-15', 371, NULL),
('Residence Inn', 239, '2019-10-16', 224, NULL),
('Residence Inn', 239, '2019-10-17', 118, NULL),
('Residence Inn', 239, '2019-10-18', 191, NULL),
('Residence Inn', 239, '2019-10-19', 369, NULL),
('Residence Inn', 239, '2019-10-20', 160, NULL),
('Residence Inn', 239, '2019-10-21', 346, NULL),
('Residence Inn', 239, '2019-10-22', 255, NULL),
('Residence Inn', 239, '2019-10-23', 120, NULL),
('Residence Inn', 239, '2019-10-24', 135, NULL),
('Residence Inn', 239, '2019-10-25', 203, NULL),
('Residence Inn', 239, '2019-10-26', 393, NULL),
('Residence Inn', 239, '2019-10-27', 168, NULL),
('Residence Inn', 239, '2019-10-28', 190, NULL),
('Residence Inn', 239, '2019-10-29', 209, NULL),
('Residence Inn', 239, '2019-10-30', 356, NULL),
('Residence Inn', 239, '2019-10-31', 156, NULL),
('Residence Inn', 239, '2019-11-01', 207, NULL),
('Residence Inn', 239, '2019-11-02', 265, NULL),
('Residence Inn', 239, '2019-11-03', 318, NULL),
('Residence Inn', 239, '2019-11-04', 238, NULL),
('Residence Inn', 239, '2019-11-05', 109, NULL),
('Residence Inn', 239, '2019-11-06', 216, NULL),
('Residence Inn', 239, '2019-11-07', 297, NULL),
('Residence Inn', 239, '2019-11-08', 177, NULL),
('Residence Inn', 239, '2019-11-09', 257, NULL),
('Residence Inn', 239, '2019-11-10', 371, NULL),
('Residence Inn', 239, '2019-11-11', 189, NULL),
('Residence Inn', 239, '2019-11-12', 280, NULL),
('Residence Inn', 239, '2019-11-13', 392, NULL),
('Residence Inn', 239, '2019-11-14', 391, NULL),
('Residence Inn', 239, '2019-11-15', 114, NULL),
('Residence Inn', 239, '2019-11-16', 399, NULL),
('Residence Inn', 239, '2019-11-17', 153, NULL),
('Residence Inn', 239, '2019-11-18', 346, NULL),
('Residence Inn', 239, '2019-11-19', 321, NULL),
('Residence Inn', 239, '2019-11-20', 217, NULL),
('Residence Inn', 239, '2019-11-21', 211, NULL),
('Residence Inn', 239, '2019-11-22', 200, NULL),
('Residence Inn', 239, '2019-11-23', 387, NULL),
('Residence Inn', 239, '2019-11-24', 368, NULL),
('Residence Inn', 239, '2019-11-25', 242, NULL),
('Residence Inn', 239, '2019-11-26', 141, NULL),
('Residence Inn', 239, '2019-11-27', 385, NULL),
('Residence Inn', 239, '2019-11-28', 159, NULL),
('Residence Inn', 239, '2019-11-29', 293, NULL),
('Residence Inn', 239, '2019-11-30', 243, NULL),
('Residence Inn', 239, '2019-12-01', 307, NULL),
('Residence Inn', 239, '2019-12-02', 117, NULL),
('Residence Inn', 239, '2019-12-03', 235, NULL),
('Residence Inn', 239, '2019-12-04', 108, NULL),
('Residence Inn', 239, '2019-12-05', 155, NULL),
('Residence Inn', 239, '2019-12-06', 323, NULL),
('Residence Inn', 239, '2019-12-07', 291, NULL),
('Residence Inn', 239, '2019-12-08', 108, NULL),
('Residence Inn', 239, '2019-12-09', 156, NULL),
('Residence Inn', 239, '2019-12-10', 243, NULL),
('Residence Inn', 239, '2019-12-11', 285, NULL),
('Residence Inn', 239, '2019-12-12', 126, NULL),
('Residence Inn', 239, '2019-12-13', 180, NULL),
('Residence Inn', 239, '2019-12-14', 193, NULL),
('Residence Inn', 239, '2019-12-15', 270, NULL),
('Residence Inn', 239, '2019-12-16', 247, NULL),
('Residence Inn', 239, '2019-12-17', 150, NULL),
('Residence Inn', 239, '2019-12-18', 164, NULL),
('Residence Inn', 239, '2019-12-19', 182, NULL),
('Residence Inn', 239, '2019-12-20', 142, NULL),
('Residence Inn', 239, '2019-12-21', 361, NULL),
('Residence Inn', 239, '2019-12-22', 319, NULL),
('Residence Inn', 239, '2019-12-23', 395, NULL),
('Residence Inn', 239, '2019-12-24', 116, NULL),
('Residence Inn', 239, '2019-12-25', 307, NULL),
('Residence Inn', 239, '2019-12-26', 324, NULL),
('Residence Inn', 239, '2019-12-27', 238, NULL),
('Residence Inn', 239, '2019-12-28', 351, NULL),
('Residence Inn', 239, '2019-12-29', 232, NULL),
('Residence Inn', 239, '2019-12-30', 114, NULL),
('Residence Inn', 239, '2019-12-31', 288, NULL),
('Residence Inn', 239, '2020-01-01', 282, NULL),
('Residence Inn', 239, '2020-01-02', 182, NULL),
('Residence Inn', 239, '2020-01-03', 362, NULL),
('Residence Inn', 239, '2020-01-04', 155, NULL),
('Residence Inn', 239, '2020-01-05', 132, NULL),
('Residence Inn', 239, '2020-01-06', 262, NULL),
('Residence Inn', 239, '2020-01-07', 109, NULL),
('Residence Inn', 239, '2020-01-08', 159, NULL),
('Residence Inn', 239, '2020-01-09', 122, NULL),
('Residence Inn', 239, '2020-01-10', 202, NULL),
('Residence Inn', 239, '2020-01-11', 162, NULL),
('Residence Inn', 239, '2020-01-12', 167, NULL),
('Residence Inn', 239, '2020-01-13', 128, NULL),
('Residence Inn', 239, '2020-01-14', 164, NULL),
('Residence Inn', 239, '2020-01-15', 161, NULL),
('Residence Inn', 239, '2020-01-16', 231, NULL),
('Residence Inn', 239, '2020-01-17', 206, NULL),
('Residence Inn', 239, '2020-01-18', 316, NULL),
('Residence Inn', 239, '2020-01-19', 372, NULL),
('Residence Inn', 239, '2020-01-20', 350, NULL),
('Residence Inn', 239, '2020-01-21', 347, NULL),
('Residence Inn', 239, '2020-01-22', 209, NULL),
('Residence Inn', 239, '2020-01-23', 131, NULL),
('Residence Inn', 239, '2020-01-24', 272, NULL),
('Residence Inn', 239, '2020-01-25', 179, NULL),
('Residence Inn', 239, '2020-01-26', 292, NULL),
('Residence Inn', 239, '2020-01-27', 235, NULL),
('Residence Inn', 239, '2020-01-28', 328, NULL),
('Residence Inn', 239, '2020-01-29', 175, NULL),
('Residence Inn', 239, '2020-01-30', 116, NULL),
('Residence Inn', 239, '2020-01-31', 252, NULL),
('Residence Inn', 239, '2020-02-01', 321, NULL),
('Residence Inn', 239, '2020-02-02', 102, NULL),
('Residence Inn', 239, '2020-02-03', 342, NULL),
('Residence Inn', 239, '2020-02-04', 267, NULL),
('Residence Inn', 240, '2019-01-01', 149, NULL),
('Residence Inn', 240, '2019-01-02', 140, NULL),
('Residence Inn', 240, '2019-01-03', 161, NULL),
('Residence Inn', 240, '2019-01-04', 190, NULL),
('Residence Inn', 240, '2019-01-05', 276, NULL),
('Residence Inn', 240, '2019-01-06', 138, NULL),
('Residence Inn', 240, '2019-01-07', 384, NULL),
('Residence Inn', 240, '2019-01-08', 119, NULL),
('Residence Inn', 240, '2019-01-09', 191, NULL),
('Residence Inn', 240, '2019-01-10', 328, NULL),
('Residence Inn', 240, '2019-01-11', 397, NULL),
('Residence Inn', 240, '2019-01-12', 173, NULL),
('Residence Inn', 240, '2019-01-13', 254, NULL),
('Residence Inn', 240, '2019-01-14', 279, NULL),
('Residence Inn', 240, '2019-01-15', 300, NULL),
('Residence Inn', 240, '2019-01-16', 352, NULL),
('Residence Inn', 240, '2019-01-17', 362, NULL),
('Residence Inn', 240, '2019-01-18', 131, NULL),
('Residence Inn', 240, '2019-01-19', 249, NULL),
('Residence Inn', 240, '2019-01-20', 300, NULL),
('Residence Inn', 240, '2019-01-21', 221, NULL),
('Residence Inn', 240, '2019-01-22', 147, NULL),
('Residence Inn', 240, '2019-01-23', 307, NULL),
('Residence Inn', 240, '2019-01-24', 300, NULL),
('Residence Inn', 240, '2019-01-25', 256, NULL),
('Residence Inn', 240, '2019-01-26', 269, NULL),
('Residence Inn', 240, '2019-01-27', 334, NULL),
('Residence Inn', 240, '2019-01-28', 225, NULL),
('Residence Inn', 240, '2019-01-29', 356, NULL),
('Residence Inn', 240, '2019-01-30', 119, NULL),
('Residence Inn', 240, '2019-01-31', 193, NULL),
('Residence Inn', 240, '2019-02-01', 109, NULL),
('Residence Inn', 240, '2019-02-02', 266, NULL),
('Residence Inn', 240, '2019-02-03', 236, NULL),
('Residence Inn', 240, '2019-02-04', 278, NULL),
('Residence Inn', 240, '2019-02-05', 304, NULL),
('Residence Inn', 240, '2019-02-06', 187, NULL),
('Residence Inn', 240, '2019-02-07', 274, NULL),
('Residence Inn', 240, '2019-02-08', 294, NULL),
('Residence Inn', 240, '2019-02-09', 298, NULL),
('Residence Inn', 240, '2019-02-10', 354, NULL),
('Residence Inn', 240, '2019-02-11', 155, NULL),
('Residence Inn', 240, '2019-02-12', 281, NULL),
('Residence Inn', 240, '2019-02-13', 262, NULL),
('Residence Inn', 240, '2019-02-14', 290, NULL),
('Residence Inn', 240, '2019-02-15', 168, NULL),
('Residence Inn', 240, '2019-02-16', 115, NULL),
('Residence Inn', 240, '2019-02-17', 223, NULL),
('Residence Inn', 240, '2019-02-18', 209, NULL),
('Residence Inn', 240, '2019-02-19', 168, NULL),
('Residence Inn', 240, '2019-02-20', 170, NULL),
('Residence Inn', 240, '2019-02-21', 110, NULL),
('Residence Inn', 240, '2019-02-22', 239, NULL),
('Residence Inn', 240, '2019-02-23', 263, NULL),
('Residence Inn', 240, '2019-02-24', 290, NULL),
('Residence Inn', 240, '2019-02-25', 108, NULL),
('Residence Inn', 240, '2019-02-26', 117, NULL),
('Residence Inn', 240, '2019-02-27', 241, NULL),
('Residence Inn', 240, '2019-02-28', 128, NULL),
('Residence Inn', 240, '2019-03-01', 218, NULL),
('Residence Inn', 240, '2019-03-02', 342, NULL),
('Residence Inn', 240, '2019-03-03', 188, NULL),
('Residence Inn', 240, '2019-03-04', 309, NULL),
('Residence Inn', 240, '2019-03-05', 117, NULL),
('Residence Inn', 240, '2019-03-06', 191, NULL),
('Residence Inn', 240, '2019-03-07', 142, NULL),
('Residence Inn', 240, '2019-03-08', 117, NULL),
('Residence Inn', 240, '2019-03-09', 279, NULL),
('Residence Inn', 240, '2019-03-10', 196, NULL),
('Residence Inn', 240, '2019-03-11', 154, NULL),
('Residence Inn', 240, '2019-03-12', 229, NULL),
('Residence Inn', 240, '2019-03-13', 164, NULL),
('Residence Inn', 240, '2019-03-14', 388, NULL),
('Residence Inn', 240, '2019-03-15', 244, NULL),
('Residence Inn', 240, '2019-03-16', 110, NULL),
('Residence Inn', 240, '2019-03-17', 193, NULL),
('Residence Inn', 240, '2019-03-18', 186, NULL),
('Residence Inn', 240, '2019-03-19', 274, NULL),
('Residence Inn', 240, '2019-03-20', 342, NULL),
('Residence Inn', 240, '2019-03-21', 384, NULL),
('Residence Inn', 240, '2019-03-22', 272, NULL),
('Residence Inn', 240, '2019-03-23', 304, NULL),
('Residence Inn', 240, '2019-03-24', 233, NULL),
('Residence Inn', 240, '2019-03-25', 127, NULL),
('Residence Inn', 240, '2019-03-26', 198, NULL),
('Residence Inn', 240, '2019-03-27', 325, NULL),
('Residence Inn', 240, '2019-03-28', 231, NULL),
('Residence Inn', 240, '2019-03-29', 300, NULL),
('Residence Inn', 240, '2019-03-30', 251, NULL),
('Residence Inn', 240, '2019-03-31', 125, NULL),
('Residence Inn', 240, '2019-04-01', 250, NULL),
('Residence Inn', 240, '2019-04-02', 290, NULL),
('Residence Inn', 240, '2019-04-03', 281, NULL),
('Residence Inn', 240, '2019-04-04', 286, NULL),
('Residence Inn', 240, '2019-04-05', 317, NULL),
('Residence Inn', 240, '2019-04-06', 371, NULL),
('Residence Inn', 240, '2019-04-07', 110, NULL),
('Residence Inn', 240, '2019-04-08', 275, NULL),
('Residence Inn', 240, '2019-04-09', 192, NULL),
('Residence Inn', 240, '2019-04-10', 196, NULL),
('Residence Inn', 240, '2019-04-11', 303, NULL),
('Residence Inn', 240, '2019-04-12', 330, NULL),
('Residence Inn', 240, '2019-04-13', 220, NULL),
('Residence Inn', 240, '2019-04-14', 114, NULL),
('Residence Inn', 240, '2019-04-15', 268, NULL),
('Residence Inn', 240, '2019-04-16', 271, NULL),
('Residence Inn', 240, '2019-04-17', 101, NULL),
('Residence Inn', 240, '2019-04-18', 347, NULL),
('Residence Inn', 240, '2019-04-19', 367, NULL),
('Residence Inn', 240, '2019-04-20', 339, NULL),
('Residence Inn', 240, '2019-04-21', 284, NULL),
('Residence Inn', 240, '2019-04-22', 283, NULL),
('Residence Inn', 240, '2019-04-23', 373, NULL),
('Residence Inn', 240, '2019-04-24', 382, NULL),
('Residence Inn', 240, '2019-04-25', 353, NULL),
('Residence Inn', 240, '2019-04-26', 370, NULL),
('Residence Inn', 240, '2019-04-27', 200, NULL),
('Residence Inn', 240, '2019-04-28', 239, NULL),
('Residence Inn', 240, '2019-04-29', 274, NULL),
('Residence Inn', 240, '2019-04-30', 267, NULL),
('Residence Inn', 240, '2019-05-01', 189, NULL),
('Residence Inn', 240, '2019-05-02', 277, NULL),
('Residence Inn', 240, '2019-05-03', 199, NULL),
('Residence Inn', 240, '2019-05-04', 307, NULL),
('Residence Inn', 240, '2019-05-05', 203, NULL),
('Residence Inn', 240, '2019-05-06', 103, NULL),
('Residence Inn', 240, '2019-05-07', 350, NULL),
('Residence Inn', 240, '2019-05-08', 351, NULL),
('Residence Inn', 240, '2019-05-09', 215, NULL),
('Residence Inn', 240, '2019-05-10', 221, NULL),
('Residence Inn', 240, '2019-05-11', 397, NULL),
('Residence Inn', 240, '2019-05-12', 265, NULL),
('Residence Inn', 240, '2019-05-13', 225, NULL),
('Residence Inn', 240, '2019-05-14', 304, NULL),
('Residence Inn', 240, '2019-05-15', 186, NULL),
('Residence Inn', 240, '2019-05-16', 191, NULL),
('Residence Inn', 240, '2019-05-17', 257, NULL),
('Residence Inn', 240, '2019-05-18', 315, NULL),
('Residence Inn', 240, '2019-05-19', 382, NULL),
('Residence Inn', 240, '2019-05-20', 269, NULL),
('Residence Inn', 240, '2019-05-21', 127, NULL),
('Residence Inn', 240, '2019-05-22', 348, NULL),
('Residence Inn', 240, '2019-05-23', 114, NULL),
('Residence Inn', 240, '2019-05-24', 351, NULL),
('Residence Inn', 240, '2019-05-25', 242, NULL),
('Residence Inn', 240, '2019-05-26', 115, NULL),
('Residence Inn', 240, '2019-05-27', 218, NULL),
('Residence Inn', 240, '2019-05-28', 248, NULL),
('Residence Inn', 240, '2019-05-29', 180, NULL),
('Residence Inn', 240, '2019-05-30', 371, NULL),
('Residence Inn', 240, '2019-05-31', 220, NULL),
('Residence Inn', 240, '2019-06-01', 350, NULL),
('Residence Inn', 240, '2019-06-02', 319, NULL),
('Residence Inn', 240, '2019-06-03', 344, NULL),
('Residence Inn', 240, '2019-06-04', 247, NULL),
('Residence Inn', 240, '2019-06-05', 293, NULL),
('Residence Inn', 240, '2019-06-06', 137, NULL),
('Residence Inn', 240, '2019-06-07', 118, NULL),
('Residence Inn', 240, '2019-06-08', 182, NULL),
('Residence Inn', 240, '2019-06-09', 219, NULL),
('Residence Inn', 240, '2019-06-10', 206, NULL),
('Residence Inn', 240, '2019-06-11', 398, NULL),
('Residence Inn', 240, '2019-06-12', 147, NULL),
('Residence Inn', 240, '2019-06-13', 205, NULL),
('Residence Inn', 240, '2019-06-14', 358, NULL),
('Residence Inn', 240, '2019-06-15', 214, NULL),
('Residence Inn', 240, '2019-06-16', 157, NULL),
('Residence Inn', 240, '2019-06-17', 212, NULL),
('Residence Inn', 240, '2019-06-18', 148, NULL),
('Residence Inn', 240, '2019-06-19', 340, NULL),
('Residence Inn', 240, '2019-06-20', 292, NULL),
('Residence Inn', 240, '2019-06-21', 103, NULL),
('Residence Inn', 240, '2019-06-22', 263, NULL),
('Residence Inn', 240, '2019-06-23', 376, NULL),
('Residence Inn', 240, '2019-06-24', 342, NULL),
('Residence Inn', 240, '2019-06-25', 307, NULL),
('Residence Inn', 240, '2019-06-26', 268, NULL),
('Residence Inn', 240, '2019-06-27', 319, NULL),
('Residence Inn', 240, '2019-06-28', 257, NULL),
('Residence Inn', 240, '2019-06-29', 133, NULL),
('Residence Inn', 240, '2019-06-30', 260, NULL),
('Residence Inn', 240, '2019-07-01', 377, NULL),
('Residence Inn', 240, '2019-07-02', 157, NULL),
('Residence Inn', 240, '2019-07-03', 385, NULL),
('Residence Inn', 240, '2019-07-04', 339, NULL),
('Residence Inn', 240, '2019-07-05', 103, NULL),
('Residence Inn', 240, '2019-07-06', 198, NULL),
('Residence Inn', 240, '2019-07-07', 252, NULL),
('Residence Inn', 240, '2019-07-08', 124, NULL),
('Residence Inn', 240, '2019-07-09', 335, NULL),
('Residence Inn', 240, '2019-07-10', 203, NULL),
('Residence Inn', 240, '2019-07-11', 267, NULL),
('Residence Inn', 240, '2019-07-12', 155, NULL),
('Residence Inn', 240, '2019-07-13', 355, NULL),
('Residence Inn', 240, '2019-07-14', 252, NULL),
('Residence Inn', 240, '2019-07-15', 254, NULL),
('Residence Inn', 240, '2019-07-16', 156, NULL),
('Residence Inn', 240, '2019-07-17', 106, NULL),
('Residence Inn', 240, '2019-07-18', 144, NULL),
('Residence Inn', 240, '2019-07-19', 167, NULL),
('Residence Inn', 240, '2019-07-20', 299, NULL),
('Residence Inn', 240, '2019-07-21', 353, NULL),
('Residence Inn', 240, '2019-07-22', 379, NULL),
('Residence Inn', 240, '2019-07-23', 126, NULL),
('Residence Inn', 240, '2019-07-24', 118, NULL),
('Residence Inn', 240, '2019-07-25', 296, NULL),
('Residence Inn', 240, '2019-07-26', 316, NULL),
('Residence Inn', 240, '2019-07-27', 209, NULL),
('Residence Inn', 240, '2019-07-28', 288, NULL),
('Residence Inn', 240, '2019-07-29', 144, NULL),
('Residence Inn', 240, '2019-07-30', 282, NULL),
('Residence Inn', 240, '2019-07-31', 138, NULL),
('Residence Inn', 240, '2019-08-01', 191, NULL),
('Residence Inn', 240, '2019-08-02', 189, NULL),
('Residence Inn', 240, '2019-08-03', 390, NULL),
('Residence Inn', 240, '2019-08-04', 245, NULL),
('Residence Inn', 240, '2019-08-05', 198, NULL),
('Residence Inn', 240, '2019-08-06', 270, NULL),
('Residence Inn', 240, '2019-08-07', 158, NULL),
('Residence Inn', 240, '2019-08-08', 352, NULL),
('Residence Inn', 240, '2019-08-09', 304, NULL),
('Residence Inn', 240, '2019-08-10', 394, NULL),
('Residence Inn', 240, '2019-08-11', 207, NULL),
('Residence Inn', 240, '2019-08-12', 285, NULL),
('Residence Inn', 240, '2019-08-13', 222, NULL),
('Residence Inn', 240, '2019-08-14', 258, NULL),
('Residence Inn', 240, '2019-08-15', 190, NULL),
('Residence Inn', 240, '2019-08-16', 233, NULL),
('Residence Inn', 240, '2019-08-17', 352, NULL),
('Residence Inn', 240, '2019-08-18', 237, NULL),
('Residence Inn', 240, '2019-08-19', 220, NULL),
('Residence Inn', 240, '2019-08-20', 277, NULL),
('Residence Inn', 240, '2019-08-21', 313, NULL),
('Residence Inn', 240, '2019-08-22', 117, NULL),
('Residence Inn', 240, '2019-08-23', 343, NULL),
('Residence Inn', 240, '2019-08-24', 323, NULL),
('Residence Inn', 240, '2019-08-25', 293, NULL),
('Residence Inn', 240, '2019-08-26', 252, NULL),
('Residence Inn', 240, '2019-08-27', 110, NULL),
('Residence Inn', 240, '2019-08-28', 140, NULL),
('Residence Inn', 240, '2019-08-29', 342, NULL),
('Residence Inn', 240, '2019-08-30', 356, NULL),
('Residence Inn', 240, '2019-08-31', 152, NULL),
('Residence Inn', 240, '2019-09-01', 145, NULL),
('Residence Inn', 240, '2019-09-02', 331, NULL),
('Residence Inn', 240, '2019-09-03', 266, NULL),
('Residence Inn', 240, '2019-09-04', 345, NULL),
('Residence Inn', 240, '2019-09-05', 380, NULL),
('Residence Inn', 240, '2019-09-06', 256, NULL),
('Residence Inn', 240, '2019-09-07', 397, NULL),
('Residence Inn', 240, '2019-09-08', 241, NULL),
('Residence Inn', 240, '2019-09-09', 330, NULL),
('Residence Inn', 240, '2019-09-10', 295, NULL),
('Residence Inn', 240, '2019-09-11', 109, NULL),
('Residence Inn', 240, '2019-09-12', 399, NULL),
('Residence Inn', 240, '2019-09-13', 340, NULL),
('Residence Inn', 240, '2019-09-14', 350, NULL),
('Residence Inn', 240, '2019-09-15', 329, NULL),
('Residence Inn', 240, '2019-09-16', 243, NULL),
('Residence Inn', 240, '2019-09-17', 170, NULL),
('Residence Inn', 240, '2019-09-18', 392, NULL),
('Residence Inn', 240, '2019-09-19', 342, NULL),
('Residence Inn', 240, '2019-09-20', 200, NULL),
('Residence Inn', 240, '2019-09-21', 114, NULL),
('Residence Inn', 240, '2019-09-22', 342, NULL),
('Residence Inn', 240, '2019-09-23', 390, NULL),
('Residence Inn', 240, '2019-09-24', 217, NULL),
('Residence Inn', 240, '2019-09-25', 310, NULL),
('Residence Inn', 240, '2019-09-26', 345, NULL),
('Residence Inn', 240, '2019-09-27', 139, NULL),
('Residence Inn', 240, '2019-09-28', 222, NULL),
('Residence Inn', 240, '2019-09-29', 240, NULL),
('Residence Inn', 240, '2019-09-30', 378, NULL),
('Residence Inn', 240, '2019-10-01', 359, NULL),
('Residence Inn', 240, '2019-10-02', 159, NULL),
('Residence Inn', 240, '2019-10-03', 390, NULL),
('Residence Inn', 240, '2019-10-04', 195, NULL),
('Residence Inn', 240, '2019-10-05', 151, NULL),
('Residence Inn', 240, '2019-10-06', 329, NULL),
('Residence Inn', 240, '2019-10-07', 299, NULL),
('Residence Inn', 240, '2019-10-08', 160, NULL),
('Residence Inn', 240, '2019-10-09', 201, NULL),
('Residence Inn', 240, '2019-10-10', 276, NULL),
('Residence Inn', 240, '2019-10-11', 130, NULL),
('Residence Inn', 240, '2019-10-12', 229, NULL),
('Residence Inn', 240, '2019-10-13', 109, NULL),
('Residence Inn', 240, '2019-10-14', 204, NULL),
('Residence Inn', 240, '2019-10-15', 256, NULL),
('Residence Inn', 240, '2019-10-16', 126, NULL),
('Residence Inn', 240, '2019-10-17', 144, NULL),
('Residence Inn', 240, '2019-10-18', 217, NULL),
('Residence Inn', 240, '2019-10-19', 287, NULL),
('Residence Inn', 240, '2019-10-20', 218, NULL),
('Residence Inn', 240, '2019-10-21', 116, NULL),
('Residence Inn', 240, '2019-10-22', 358, NULL),
('Residence Inn', 240, '2019-10-23', 306, NULL),
('Residence Inn', 240, '2019-10-24', 292, NULL),
('Residence Inn', 240, '2019-10-25', 172, NULL),
('Residence Inn', 240, '2019-10-26', 215, NULL),
('Residence Inn', 240, '2019-10-27', 217, NULL),
('Residence Inn', 240, '2019-10-28', 209, NULL),
('Residence Inn', 240, '2019-10-29', 351, NULL),
('Residence Inn', 240, '2019-10-30', 213, NULL),
('Residence Inn', 240, '2019-10-31', 315, NULL),
('Residence Inn', 240, '2019-11-01', 129, NULL),
('Residence Inn', 240, '2019-11-02', 128, NULL),
('Residence Inn', 240, '2019-11-03', 106, NULL),
('Residence Inn', 240, '2019-11-04', 361, NULL),
('Residence Inn', 240, '2019-11-05', 378, NULL),
('Residence Inn', 240, '2019-11-06', 218, NULL),
('Residence Inn', 240, '2019-11-07', 206, NULL),
('Residence Inn', 240, '2019-11-08', 167, NULL),
('Residence Inn', 240, '2019-11-09', 373, NULL),
('Residence Inn', 240, '2019-11-10', 178, NULL),
('Residence Inn', 240, '2019-11-11', 182, NULL),
('Residence Inn', 240, '2019-11-12', 392, NULL),
('Residence Inn', 240, '2019-11-13', 328, NULL),
('Residence Inn', 240, '2019-11-14', 130, NULL),
('Residence Inn', 240, '2019-11-15', 328, NULL),
('Residence Inn', 240, '2019-11-16', 148, NULL),
('Residence Inn', 240, '2019-11-17', 364, NULL),
('Residence Inn', 240, '2019-11-18', 235, NULL),
('Residence Inn', 240, '2019-11-19', 242, NULL),
('Residence Inn', 240, '2019-11-20', 324, NULL),
('Residence Inn', 240, '2019-11-21', 375, NULL),
('Residence Inn', 240, '2019-11-22', 188, NULL),
('Residence Inn', 240, '2019-11-23', 315, NULL),
('Residence Inn', 240, '2019-11-24', 140, NULL),
('Residence Inn', 240, '2019-11-25', 361, NULL),
('Residence Inn', 240, '2019-11-26', 132, NULL),
('Residence Inn', 240, '2019-11-27', 107, NULL),
('Residence Inn', 240, '2019-11-28', 340, NULL),
('Residence Inn', 240, '2019-11-29', 391, NULL),
('Residence Inn', 240, '2019-11-30', 286, NULL),
('Residence Inn', 240, '2019-12-01', 156, NULL),
('Residence Inn', 240, '2019-12-02', 100, NULL),
('Residence Inn', 240, '2019-12-03', 387, NULL),
('Residence Inn', 240, '2019-12-04', 298, NULL),
('Residence Inn', 240, '2019-12-05', 377, NULL),
('Residence Inn', 240, '2019-12-06', 311, NULL),
('Residence Inn', 240, '2019-12-07', 378, NULL),
('Residence Inn', 240, '2019-12-08', 307, NULL),
('Residence Inn', 240, '2019-12-09', 123, NULL),
('Residence Inn', 240, '2019-12-10', 111, NULL),
('Residence Inn', 240, '2019-12-11', 371, NULL),
('Residence Inn', 240, '2019-12-12', 318, NULL),
('Residence Inn', 240, '2019-12-13', 348, NULL),
('Residence Inn', 240, '2019-12-14', 339, NULL),
('Residence Inn', 240, '2019-12-15', 338, NULL),
('Residence Inn', 240, '2019-12-16', 197, NULL),
('Residence Inn', 240, '2019-12-17', 396, NULL),
('Residence Inn', 240, '2019-12-18', 314, NULL),
('Residence Inn', 240, '2019-12-19', 359, NULL),
('Residence Inn', 240, '2019-12-20', 250, NULL),
('Residence Inn', 240, '2019-12-21', 371, NULL),
('Residence Inn', 240, '2019-12-22', 303, NULL),
('Residence Inn', 240, '2019-12-23', 196, NULL),
('Residence Inn', 240, '2019-12-24', 316, NULL),
('Residence Inn', 240, '2019-12-25', 188, NULL),
('Residence Inn', 240, '2019-12-26', 134, NULL),
('Residence Inn', 240, '2019-12-27', 151, NULL),
('Residence Inn', 240, '2019-12-28', 279, NULL),
('Residence Inn', 240, '2019-12-29', 125, NULL),
('Residence Inn', 240, '2019-12-30', 235, NULL),
('Residence Inn', 240, '2019-12-31', 120, NULL),
('Residence Inn', 240, '2020-01-01', 107, NULL),
('Residence Inn', 240, '2020-01-02', 141, NULL),
('Residence Inn', 240, '2020-01-03', 356, NULL),
('Residence Inn', 240, '2020-01-04', 101, NULL),
('Residence Inn', 240, '2020-01-05', 103, NULL),
('Residence Inn', 240, '2020-01-06', 208, NULL),
('Residence Inn', 240, '2020-01-07', 271, NULL),
('Residence Inn', 240, '2020-01-08', 127, NULL),
('Residence Inn', 240, '2020-01-09', 370, NULL),
('Residence Inn', 240, '2020-01-10', 341, NULL),
('Residence Inn', 240, '2020-01-11', 100, NULL),
('Residence Inn', 240, '2020-01-12', 176, NULL),
('Residence Inn', 240, '2020-01-13', 242, NULL),
('Residence Inn', 240, '2020-01-14', 397, NULL),
('Residence Inn', 240, '2020-01-15', 350, NULL),
('Residence Inn', 240, '2020-01-16', 279, NULL),
('Residence Inn', 240, '2020-01-17', 136, NULL),
('Residence Inn', 240, '2020-01-18', 125, NULL),
('Residence Inn', 240, '2020-01-19', 309, NULL),
('Residence Inn', 240, '2020-01-20', 171, NULL),
('Residence Inn', 240, '2020-01-21', 328, NULL),
('Residence Inn', 240, '2020-01-22', 105, NULL),
('Residence Inn', 240, '2020-01-23', 102, NULL),
('Residence Inn', 240, '2020-01-24', 170, NULL),
('Residence Inn', 240, '2020-01-25', 217, NULL),
('Residence Inn', 240, '2020-01-26', 155, NULL),
('Residence Inn', 240, '2020-01-27', 221, NULL),
('Residence Inn', 240, '2020-01-28', 282, NULL),
('Residence Inn', 240, '2020-01-29', 138, NULL),
('Residence Inn', 240, '2020-01-30', 295, NULL),
('Residence Inn', 240, '2020-01-31', 309, NULL),
('Residence Inn', 240, '2020-02-01', 315, NULL),
('Residence Inn', 240, '2020-02-02', 348, NULL),
('Residence Inn', 240, '2020-02-03', 286, NULL),
('Residence Inn', 240, '2020-02-04', 339, NULL),
('Residence Inn', 242, '2019-01-01', 261, NULL),
('Residence Inn', 242, '2019-01-02', 256, NULL),
('Residence Inn', 242, '2019-01-03', 174, NULL),
('Residence Inn', 242, '2019-01-04', 350, NULL),
('Residence Inn', 242, '2019-01-05', 355, NULL),
('Residence Inn', 242, '2019-01-06', 131, NULL),
('Residence Inn', 242, '2019-01-07', 173, NULL),
('Residence Inn', 242, '2019-01-08', 232, NULL),
('Residence Inn', 242, '2019-01-09', 346, NULL),
('Residence Inn', 242, '2019-01-10', 288, NULL),
('Residence Inn', 242, '2019-01-11', 149, NULL),
('Residence Inn', 242, '2019-01-12', 364, NULL),
('Residence Inn', 242, '2019-01-13', 259, NULL),
('Residence Inn', 242, '2019-01-14', 139, NULL),
('Residence Inn', 242, '2019-01-15', 216, NULL),
('Residence Inn', 242, '2019-01-16', 358, NULL),
('Residence Inn', 242, '2019-01-17', 105, NULL),
('Residence Inn', 242, '2019-01-18', 249, NULL),
('Residence Inn', 242, '2019-01-19', 342, NULL),
('Residence Inn', 242, '2019-01-20', 181, NULL),
('Residence Inn', 242, '2019-01-21', 367, NULL),
('Residence Inn', 242, '2019-01-22', 343, NULL),
('Residence Inn', 242, '2019-01-23', 206, NULL),
('Residence Inn', 242, '2019-01-24', 234, NULL),
('Residence Inn', 242, '2019-01-25', 202, NULL),
('Residence Inn', 242, '2019-01-26', 277, NULL),
('Residence Inn', 242, '2019-01-27', 352, NULL),
('Residence Inn', 242, '2019-01-28', 127, NULL),
('Residence Inn', 242, '2019-01-29', 154, NULL),
('Residence Inn', 242, '2019-01-30', 219, NULL),
('Residence Inn', 242, '2019-01-31', 210, NULL),
('Residence Inn', 242, '2019-02-01', 242, NULL),
('Residence Inn', 242, '2019-02-02', 283, NULL),
('Residence Inn', 242, '2019-02-03', 371, NULL),
('Residence Inn', 242, '2019-02-04', 308, NULL),
('Residence Inn', 242, '2019-02-05', 133, NULL),
('Residence Inn', 242, '2019-02-06', 181, NULL),
('Residence Inn', 242, '2019-02-07', 395, NULL),
('Residence Inn', 242, '2019-02-08', 128, NULL),
('Residence Inn', 242, '2019-02-09', 139, NULL),
('Residence Inn', 242, '2019-02-10', 297, NULL),
('Residence Inn', 242, '2019-02-11', 248, NULL),
('Residence Inn', 242, '2019-02-12', 124, NULL),
('Residence Inn', 242, '2019-02-13', 191, NULL),
('Residence Inn', 242, '2019-02-14', 309, NULL),
('Residence Inn', 242, '2019-02-15', 276, NULL),
('Residence Inn', 242, '2019-02-16', 325, NULL),
('Residence Inn', 242, '2019-02-17', 162, NULL),
('Residence Inn', 242, '2019-02-18', 148, NULL),
('Residence Inn', 242, '2019-02-19', 142, NULL),
('Residence Inn', 242, '2019-02-20', 328, NULL),
('Residence Inn', 242, '2019-02-21', 152, NULL),
('Residence Inn', 242, '2019-02-22', 366, NULL),
('Residence Inn', 242, '2019-02-23', 315, NULL),
('Residence Inn', 242, '2019-02-24', 298, NULL),
('Residence Inn', 242, '2019-02-25', 197, NULL),
('Residence Inn', 242, '2019-02-26', 253, NULL),
('Residence Inn', 242, '2019-02-27', 370, NULL),
('Residence Inn', 242, '2019-02-28', 174, NULL),
('Residence Inn', 242, '2019-03-01', 183, NULL),
('Residence Inn', 242, '2019-03-02', 118, NULL),
('Residence Inn', 242, '2019-03-03', 372, NULL),
('Residence Inn', 242, '2019-03-04', 187, NULL),
('Residence Inn', 242, '2019-03-05', 193, NULL),
('Residence Inn', 242, '2019-03-06', 321, NULL),
('Residence Inn', 242, '2019-03-07', 260, NULL),
('Residence Inn', 242, '2019-03-08', 132, NULL),
('Residence Inn', 242, '2019-03-09', 272, NULL),
('Residence Inn', 242, '2019-03-10', 361, NULL),
('Residence Inn', 242, '2019-03-11', 398, NULL),
('Residence Inn', 242, '2019-03-12', 279, NULL),
('Residence Inn', 242, '2019-03-13', 364, NULL),
('Residence Inn', 242, '2019-03-14', 294, NULL),
('Residence Inn', 242, '2019-03-15', 342, NULL),
('Residence Inn', 242, '2019-03-16', 156, NULL),
('Residence Inn', 242, '2019-03-17', 196, NULL),
('Residence Inn', 242, '2019-03-18', 161, NULL),
('Residence Inn', 242, '2019-03-19', 219, NULL),
('Residence Inn', 242, '2019-03-20', 300, NULL),
('Residence Inn', 242, '2019-03-21', 392, NULL),
('Residence Inn', 242, '2019-03-22', 263, NULL),
('Residence Inn', 242, '2019-03-23', 322, NULL),
('Residence Inn', 242, '2019-03-24', 159, NULL),
('Residence Inn', 242, '2019-03-25', 203, NULL),
('Residence Inn', 242, '2019-03-26', 106, NULL),
('Residence Inn', 242, '2019-03-27', 236, NULL),
('Residence Inn', 242, '2019-03-28', 387, NULL),
('Residence Inn', 242, '2019-03-29', 195, NULL),
('Residence Inn', 242, '2019-03-30', 253, NULL),
('Residence Inn', 242, '2019-03-31', 339, NULL),
('Residence Inn', 242, '2019-04-01', 384, NULL),
('Residence Inn', 242, '2019-04-02', 277, NULL),
('Residence Inn', 242, '2019-04-03', 238, NULL),
('Residence Inn', 242, '2019-04-04', 145, NULL),
('Residence Inn', 242, '2019-04-05', 264, NULL),
('Residence Inn', 242, '2019-04-06', 174, NULL),
('Residence Inn', 242, '2019-04-07', 382, NULL),
('Residence Inn', 242, '2019-04-08', 329, NULL),
('Residence Inn', 242, '2019-04-09', 314, NULL),
('Residence Inn', 242, '2019-04-10', 203, NULL),
('Residence Inn', 242, '2019-04-11', 200, NULL),
('Residence Inn', 242, '2019-04-12', 172, NULL),
('Residence Inn', 242, '2019-04-13', 298, NULL),
('Residence Inn', 242, '2019-04-14', 274, NULL),
('Residence Inn', 242, '2019-04-15', 304, NULL),
('Residence Inn', 242, '2019-04-16', 114, NULL),
('Residence Inn', 242, '2019-04-17', 352, NULL),
('Residence Inn', 242, '2019-04-18', 140, NULL),
('Residence Inn', 242, '2019-04-19', 187, NULL),
('Residence Inn', 242, '2019-04-20', 360, NULL),
('Residence Inn', 242, '2019-04-21', 120, NULL),
('Residence Inn', 242, '2019-04-22', 289, NULL),
('Residence Inn', 242, '2019-04-23', 364, NULL),
('Residence Inn', 242, '2019-04-24', 119, NULL),
('Residence Inn', 242, '2019-04-25', 265, NULL),
('Residence Inn', 242, '2019-04-26', 311, NULL),
('Residence Inn', 242, '2019-04-27', 310, NULL),
('Residence Inn', 242, '2019-04-28', 151, NULL),
('Residence Inn', 242, '2019-04-29', 112, NULL),
('Residence Inn', 242, '2019-04-30', 378, NULL),
('Residence Inn', 242, '2019-05-01', 221, NULL),
('Residence Inn', 242, '2019-05-02', 328, NULL),
('Residence Inn', 242, '2019-05-03', 351, NULL),
('Residence Inn', 242, '2019-05-04', 319, NULL),
('Residence Inn', 242, '2019-05-05', 256, NULL),
('Residence Inn', 242, '2019-05-06', 247, NULL),
('Residence Inn', 242, '2019-05-07', 212, NULL),
('Residence Inn', 242, '2019-05-08', 378, NULL),
('Residence Inn', 242, '2019-05-09', 255, NULL),
('Residence Inn', 242, '2019-05-10', 362, NULL),
('Residence Inn', 242, '2019-05-11', 171, NULL),
('Residence Inn', 242, '2019-05-12', 234, NULL),
('Residence Inn', 242, '2019-05-13', 210, NULL),
('Residence Inn', 242, '2019-05-14', 384, NULL),
('Residence Inn', 242, '2019-05-15', 388, NULL),
('Residence Inn', 242, '2019-05-16', 156, NULL),
('Residence Inn', 242, '2019-05-17', 230, NULL),
('Residence Inn', 242, '2019-05-18', 155, NULL),
('Residence Inn', 242, '2019-05-19', 333, NULL),
('Residence Inn', 242, '2019-05-20', 127, NULL),
('Residence Inn', 242, '2019-05-21', 232, NULL),
('Residence Inn', 242, '2019-05-22', 341, NULL),
('Residence Inn', 242, '2019-05-23', 370, NULL),
('Residence Inn', 242, '2019-05-24', 272, NULL),
('Residence Inn', 242, '2019-05-25', 310, NULL),
('Residence Inn', 242, '2019-05-26', 357, NULL),
('Residence Inn', 242, '2019-05-27', 247, NULL),
('Residence Inn', 242, '2019-05-28', 318, NULL),
('Residence Inn', 242, '2019-05-29', 208, NULL),
('Residence Inn', 242, '2019-05-30', 104, NULL),
('Residence Inn', 242, '2019-05-31', 284, NULL),
('Residence Inn', 242, '2019-06-01', 204, NULL),
('Residence Inn', 242, '2019-06-02', 293, NULL),
('Residence Inn', 242, '2019-06-03', 310, NULL),
('Residence Inn', 242, '2019-06-04', 129, NULL),
('Residence Inn', 242, '2019-06-05', 279, NULL),
('Residence Inn', 242, '2019-06-06', 352, NULL),
('Residence Inn', 242, '2019-06-07', 395, NULL),
('Residence Inn', 242, '2019-06-08', 192, NULL),
('Residence Inn', 242, '2019-06-09', 274, NULL),
('Residence Inn', 242, '2019-06-10', 322, NULL),
('Residence Inn', 242, '2019-06-11', 119, NULL),
('Residence Inn', 242, '2019-06-12', 169, NULL),
('Residence Inn', 242, '2019-06-13', 324, NULL),
('Residence Inn', 242, '2019-06-14', 393, NULL),
('Residence Inn', 242, '2019-06-15', 266, NULL),
('Residence Inn', 242, '2019-06-16', 365, NULL),
('Residence Inn', 242, '2019-06-17', 157, NULL),
('Residence Inn', 242, '2019-06-18', 295, NULL),
('Residence Inn', 242, '2019-06-19', 299, NULL),
('Residence Inn', 242, '2019-06-20', 272, NULL),
('Residence Inn', 242, '2019-06-21', 388, NULL),
('Residence Inn', 242, '2019-06-22', 135, NULL),
('Residence Inn', 242, '2019-06-23', 100, NULL),
('Residence Inn', 242, '2019-06-24', 115, NULL),
('Residence Inn', 242, '2019-06-25', 138, NULL),
('Residence Inn', 242, '2019-06-26', 347, NULL),
('Residence Inn', 242, '2019-06-27', 147, NULL),
('Residence Inn', 242, '2019-06-28', 102, NULL),
('Residence Inn', 242, '2019-06-29', 289, NULL),
('Residence Inn', 242, '2019-06-30', 302, NULL),
('Residence Inn', 242, '2019-07-01', 355, NULL),
('Residence Inn', 242, '2019-07-02', 100, NULL),
('Residence Inn', 242, '2019-07-03', 381, NULL),
('Residence Inn', 242, '2019-07-04', 233, NULL),
('Residence Inn', 242, '2019-07-05', 278, NULL),
('Residence Inn', 242, '2019-07-06', 120, NULL),
('Residence Inn', 242, '2019-07-07', 300, NULL),
('Residence Inn', 242, '2019-07-08', 153, NULL),
('Residence Inn', 242, '2019-07-09', 267, NULL),
('Residence Inn', 242, '2019-07-10', 109, NULL),
('Residence Inn', 242, '2019-07-11', 114, NULL),
('Residence Inn', 242, '2019-07-12', 148, NULL),
('Residence Inn', 242, '2019-07-13', 141, NULL),
('Residence Inn', 242, '2019-07-14', 210, NULL),
('Residence Inn', 242, '2019-07-15', 218, NULL),
('Residence Inn', 242, '2019-07-16', 101, NULL),
('Residence Inn', 242, '2019-07-17', 222, NULL),
('Residence Inn', 242, '2019-07-18', 142, NULL),
('Residence Inn', 242, '2019-07-19', 387, NULL),
('Residence Inn', 242, '2019-07-20', 299, NULL),
('Residence Inn', 242, '2019-07-21', 380, NULL),
('Residence Inn', 242, '2019-07-22', 261, NULL),
('Residence Inn', 242, '2019-07-23', 396, NULL),
('Residence Inn', 242, '2019-07-24', 141, NULL),
('Residence Inn', 242, '2019-07-25', 163, NULL),
('Residence Inn', 242, '2019-07-26', 333, NULL),
('Residence Inn', 242, '2019-07-27', 246, NULL),
('Residence Inn', 242, '2019-07-28', 163, NULL),
('Residence Inn', 242, '2019-07-29', 176, NULL),
('Residence Inn', 242, '2019-07-30', 355, NULL),
('Residence Inn', 242, '2019-07-31', 126, NULL),
('Residence Inn', 242, '2019-08-01', 167, NULL),
('Residence Inn', 242, '2019-08-02', 366, NULL),
('Residence Inn', 242, '2019-08-03', 218, NULL),
('Residence Inn', 242, '2019-08-04', 153, NULL),
('Residence Inn', 242, '2019-08-05', 193, NULL),
('Residence Inn', 242, '2019-08-06', 206, NULL),
('Residence Inn', 242, '2019-08-07', 348, NULL),
('Residence Inn', 242, '2019-08-08', 168, NULL),
('Residence Inn', 242, '2019-08-09', 315, NULL),
('Residence Inn', 242, '2019-08-10', 238, NULL),
('Residence Inn', 242, '2019-08-11', 109, NULL),
('Residence Inn', 242, '2019-08-12', 184, NULL),
('Residence Inn', 242, '2019-08-13', 172, NULL),
('Residence Inn', 242, '2019-08-14', 371, NULL),
('Residence Inn', 242, '2019-08-15', 151, NULL),
('Residence Inn', 242, '2019-08-16', 315, NULL),
('Residence Inn', 242, '2019-08-17', 136, NULL),
('Residence Inn', 242, '2019-08-18', 379, NULL),
('Residence Inn', 242, '2019-08-19', 184, NULL),
('Residence Inn', 242, '2019-08-20', 224, NULL),
('Residence Inn', 242, '2019-08-21', 358, NULL),
('Residence Inn', 242, '2019-08-22', 331, NULL),
('Residence Inn', 242, '2019-08-23', 254, NULL),
('Residence Inn', 242, '2019-08-24', 127, NULL),
('Residence Inn', 242, '2019-08-25', 323, NULL),
('Residence Inn', 242, '2019-08-26', 374, NULL),
('Residence Inn', 242, '2019-08-27', 285, NULL),
('Residence Inn', 242, '2019-08-28', 178, NULL),
('Residence Inn', 242, '2019-08-29', 361, NULL),
('Residence Inn', 242, '2019-08-30', 158, NULL),
('Residence Inn', 242, '2019-08-31', 101, NULL),
('Residence Inn', 242, '2019-09-01', 282, NULL),
('Residence Inn', 242, '2019-09-02', 371, NULL),
('Residence Inn', 242, '2019-09-03', 317, NULL),
('Residence Inn', 242, '2019-09-04', 215, NULL),
('Residence Inn', 242, '2019-09-05', 366, NULL),
('Residence Inn', 242, '2019-09-06', 168, NULL),
('Residence Inn', 242, '2019-09-07', 102, NULL),
('Residence Inn', 242, '2019-09-08', 101, NULL),
('Residence Inn', 242, '2019-09-09', 224, NULL),
('Residence Inn', 242, '2019-09-10', 153, NULL),
('Residence Inn', 242, '2019-09-11', 389, NULL),
('Residence Inn', 242, '2019-09-12', 239, NULL),
('Residence Inn', 242, '2019-09-13', 126, NULL),
('Residence Inn', 242, '2019-09-14', 104, NULL),
('Residence Inn', 242, '2019-09-15', 249, NULL),
('Residence Inn', 242, '2019-09-16', 364, NULL),
('Residence Inn', 242, '2019-09-17', 271, NULL),
('Residence Inn', 242, '2019-09-18', 203, NULL),
('Residence Inn', 242, '2019-09-19', 186, NULL),
('Residence Inn', 242, '2019-09-20', 115, NULL),
('Residence Inn', 242, '2019-09-21', 307, NULL),
('Residence Inn', 242, '2019-09-22', 146, NULL),
('Residence Inn', 242, '2019-09-23', 106, NULL),
('Residence Inn', 242, '2019-09-24', 101, NULL),
('Residence Inn', 242, '2019-09-25', 338, NULL),
('Residence Inn', 242, '2019-09-26', 360, NULL),
('Residence Inn', 242, '2019-09-27', 320, NULL),
('Residence Inn', 242, '2019-09-28', 371, NULL),
('Residence Inn', 242, '2019-09-29', 139, NULL),
('Residence Inn', 242, '2019-09-30', 135, NULL),
('Residence Inn', 242, '2019-10-01', 265, NULL),
('Residence Inn', 242, '2019-10-02', 231, NULL),
('Residence Inn', 242, '2019-10-03', 280, NULL),
('Residence Inn', 242, '2019-10-04', 328, NULL),
('Residence Inn', 242, '2019-10-05', 391, NULL),
('Residence Inn', 242, '2019-10-06', 300, NULL),
('Residence Inn', 242, '2019-10-07', 355, NULL),
('Residence Inn', 242, '2019-10-08', 255, NULL),
('Residence Inn', 242, '2019-10-09', 382, NULL),
('Residence Inn', 242, '2019-10-10', 236, NULL),
('Residence Inn', 242, '2019-10-11', 139, NULL),
('Residence Inn', 242, '2019-10-12', 380, NULL),
('Residence Inn', 242, '2019-10-13', 332, NULL),
('Residence Inn', 242, '2019-10-14', 346, NULL),
('Residence Inn', 242, '2019-10-15', 371, NULL),
('Residence Inn', 242, '2019-10-16', 156, NULL),
('Residence Inn', 242, '2019-10-17', 267, NULL),
('Residence Inn', 242, '2019-10-18', 114, NULL),
('Residence Inn', 242, '2019-10-19', 228, NULL),
('Residence Inn', 242, '2019-10-20', 210, NULL),
('Residence Inn', 242, '2019-10-21', 342, NULL),
('Residence Inn', 242, '2019-10-22', 328, NULL),
('Residence Inn', 242, '2019-10-23', 169, NULL),
('Residence Inn', 242, '2019-10-24', 355, NULL),
('Residence Inn', 242, '2019-10-25', 149, NULL),
('Residence Inn', 242, '2019-10-26', 396, NULL),
('Residence Inn', 242, '2019-10-27', 180, NULL),
('Residence Inn', 242, '2019-10-28', 374, NULL),
('Residence Inn', 242, '2019-10-29', 126, NULL),
('Residence Inn', 242, '2019-10-30', 197, NULL),
('Residence Inn', 242, '2019-10-31', 106, NULL),
('Residence Inn', 242, '2019-11-01', 223, NULL),
('Residence Inn', 242, '2019-11-02', 347, NULL),
('Residence Inn', 242, '2019-11-03', 378, NULL),
('Residence Inn', 242, '2019-11-04', 394, NULL),
('Residence Inn', 242, '2019-11-05', 264, NULL),
('Residence Inn', 242, '2019-11-06', 345, NULL),
('Residence Inn', 242, '2019-11-07', 339, NULL),
('Residence Inn', 242, '2019-11-08', 203, NULL),
('Residence Inn', 242, '2019-11-09', 393, NULL),
('Residence Inn', 242, '2019-11-10', 276, NULL),
('Residence Inn', 242, '2019-11-11', 242, NULL),
('Residence Inn', 242, '2019-11-12', 121, NULL),
('Residence Inn', 242, '2019-11-13', 364, NULL),
('Residence Inn', 242, '2019-11-14', 276, NULL),
('Residence Inn', 242, '2019-11-15', 298, NULL),
('Residence Inn', 242, '2019-11-16', 341, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 242, '2019-11-17', 358, NULL),
('Residence Inn', 242, '2019-11-18', 339, NULL),
('Residence Inn', 242, '2019-11-19', 148, NULL),
('Residence Inn', 242, '2019-11-20', 268, NULL),
('Residence Inn', 242, '2019-11-21', 240, NULL),
('Residence Inn', 242, '2019-11-22', 241, NULL),
('Residence Inn', 242, '2019-11-23', 313, NULL),
('Residence Inn', 242, '2019-11-24', 397, NULL),
('Residence Inn', 242, '2019-11-25', 378, NULL),
('Residence Inn', 242, '2019-11-26', 141, NULL),
('Residence Inn', 242, '2019-11-27', 181, NULL),
('Residence Inn', 242, '2019-11-28', 223, NULL),
('Residence Inn', 242, '2019-11-29', 378, NULL),
('Residence Inn', 242, '2019-11-30', 301, NULL),
('Residence Inn', 242, '2019-12-01', 358, NULL),
('Residence Inn', 242, '2019-12-02', 350, NULL),
('Residence Inn', 242, '2019-12-03', 228, NULL),
('Residence Inn', 242, '2019-12-04', 165, NULL),
('Residence Inn', 242, '2019-12-05', 122, NULL),
('Residence Inn', 242, '2019-12-06', 184, NULL),
('Residence Inn', 242, '2019-12-07', 318, NULL),
('Residence Inn', 242, '2019-12-08', 211, NULL),
('Residence Inn', 242, '2019-12-09', 351, NULL),
('Residence Inn', 242, '2019-12-10', 325, NULL),
('Residence Inn', 242, '2019-12-11', 300, NULL),
('Residence Inn', 242, '2019-12-12', 216, NULL),
('Residence Inn', 242, '2019-12-13', 200, NULL),
('Residence Inn', 242, '2019-12-14', 120, NULL),
('Residence Inn', 242, '2019-12-15', 182, NULL),
('Residence Inn', 242, '2019-12-16', 147, NULL),
('Residence Inn', 242, '2019-12-17', 230, NULL),
('Residence Inn', 242, '2019-12-18', 380, NULL),
('Residence Inn', 242, '2019-12-19', 249, NULL),
('Residence Inn', 242, '2019-12-20', 126, NULL),
('Residence Inn', 242, '2019-12-21', 370, NULL),
('Residence Inn', 242, '2019-12-22', 162, NULL),
('Residence Inn', 242, '2019-12-23', 294, NULL),
('Residence Inn', 242, '2019-12-24', 231, NULL),
('Residence Inn', 242, '2019-12-25', 217, NULL),
('Residence Inn', 242, '2019-12-26', 199, NULL),
('Residence Inn', 242, '2019-12-27', 242, NULL),
('Residence Inn', 242, '2019-12-28', 242, NULL),
('Residence Inn', 242, '2019-12-29', 130, NULL),
('Residence Inn', 242, '2019-12-30', 132, NULL),
('Residence Inn', 242, '2019-12-31', 233, NULL),
('Residence Inn', 242, '2020-01-01', 189, NULL),
('Residence Inn', 242, '2020-01-02', 360, NULL),
('Residence Inn', 242, '2020-01-03', 292, NULL),
('Residence Inn', 242, '2020-01-04', 241, NULL),
('Residence Inn', 242, '2020-01-05', 319, NULL),
('Residence Inn', 242, '2020-01-06', 154, NULL),
('Residence Inn', 242, '2020-01-07', 329, NULL),
('Residence Inn', 242, '2020-01-08', 357, NULL),
('Residence Inn', 242, '2020-01-09', 184, NULL),
('Residence Inn', 242, '2020-01-10', 397, NULL),
('Residence Inn', 242, '2020-01-11', 212, NULL),
('Residence Inn', 242, '2020-01-12', 280, NULL),
('Residence Inn', 242, '2020-01-13', 128, NULL),
('Residence Inn', 242, '2020-01-14', 195, NULL),
('Residence Inn', 242, '2020-01-15', 267, NULL),
('Residence Inn', 242, '2020-01-16', 304, NULL),
('Residence Inn', 242, '2020-01-17', 264, NULL),
('Residence Inn', 242, '2020-01-18', 178, NULL),
('Residence Inn', 242, '2020-01-19', 332, NULL),
('Residence Inn', 242, '2020-01-20', 306, NULL),
('Residence Inn', 242, '2020-01-21', 198, NULL),
('Residence Inn', 242, '2020-01-22', 399, NULL),
('Residence Inn', 242, '2020-01-23', 320, NULL),
('Residence Inn', 242, '2020-01-24', 232, NULL),
('Residence Inn', 242, '2020-01-25', 145, NULL),
('Residence Inn', 242, '2020-01-26', 100, NULL),
('Residence Inn', 242, '2020-01-27', 302, NULL),
('Residence Inn', 242, '2020-01-28', 325, NULL),
('Residence Inn', 242, '2020-01-29', 365, NULL),
('Residence Inn', 242, '2020-01-30', 130, NULL),
('Residence Inn', 242, '2020-01-31', 389, NULL),
('Residence Inn', 242, '2020-02-01', 210, NULL),
('Residence Inn', 242, '2020-02-02', 137, NULL),
('Residence Inn', 242, '2020-02-03', 306, NULL),
('Residence Inn', 242, '2020-02-04', 194, NULL),
('Residence Inn', 249, '2019-01-01', 158, NULL),
('Residence Inn', 249, '2019-01-02', 159, NULL),
('Residence Inn', 249, '2019-01-03', 285, NULL),
('Residence Inn', 249, '2019-01-04', 180, NULL),
('Residence Inn', 249, '2019-01-05', 247, NULL),
('Residence Inn', 249, '2019-01-06', 144, NULL),
('Residence Inn', 249, '2019-01-07', 211, NULL),
('Residence Inn', 249, '2019-01-08', 106, NULL),
('Residence Inn', 249, '2019-01-09', 157, NULL),
('Residence Inn', 249, '2019-01-10', 357, NULL),
('Residence Inn', 249, '2019-01-11', 351, NULL),
('Residence Inn', 249, '2019-01-12', 304, NULL),
('Residence Inn', 249, '2019-01-13', 132, NULL),
('Residence Inn', 249, '2019-01-14', 358, NULL),
('Residence Inn', 249, '2019-01-15', 380, NULL),
('Residence Inn', 249, '2019-01-16', 334, NULL),
('Residence Inn', 249, '2019-01-17', 242, NULL),
('Residence Inn', 249, '2019-01-18', 153, NULL),
('Residence Inn', 249, '2019-01-19', 266, NULL),
('Residence Inn', 249, '2019-01-20', 203, NULL),
('Residence Inn', 249, '2019-01-21', 175, NULL),
('Residence Inn', 249, '2019-01-22', 275, NULL),
('Residence Inn', 249, '2019-01-23', 311, NULL),
('Residence Inn', 249, '2019-01-24', 171, NULL),
('Residence Inn', 249, '2019-01-25', 140, NULL),
('Residence Inn', 249, '2019-01-26', 180, NULL),
('Residence Inn', 249, '2019-01-27', 360, NULL),
('Residence Inn', 249, '2019-01-28', 163, NULL),
('Residence Inn', 249, '2019-01-29', 200, NULL),
('Residence Inn', 249, '2019-01-30', 339, NULL),
('Residence Inn', 249, '2019-01-31', 371, NULL),
('Residence Inn', 249, '2019-02-01', 184, NULL),
('Residence Inn', 249, '2019-02-02', 217, NULL),
('Residence Inn', 249, '2019-02-03', 147, NULL),
('Residence Inn', 249, '2019-02-04', 303, NULL),
('Residence Inn', 249, '2019-02-05', 252, NULL),
('Residence Inn', 249, '2019-02-06', 244, NULL),
('Residence Inn', 249, '2019-02-07', 152, NULL),
('Residence Inn', 249, '2019-02-08', 260, NULL),
('Residence Inn', 249, '2019-02-09', 303, NULL),
('Residence Inn', 249, '2019-02-10', 323, NULL),
('Residence Inn', 249, '2019-02-11', 376, NULL),
('Residence Inn', 249, '2019-02-12', 280, NULL),
('Residence Inn', 249, '2019-02-13', 371, NULL),
('Residence Inn', 249, '2019-02-14', 275, NULL),
('Residence Inn', 249, '2019-02-15', 177, NULL),
('Residence Inn', 249, '2019-02-16', 282, NULL),
('Residence Inn', 249, '2019-02-17', 341, NULL),
('Residence Inn', 249, '2019-02-18', 315, NULL),
('Residence Inn', 249, '2019-02-19', 108, NULL),
('Residence Inn', 249, '2019-02-20', 129, NULL),
('Residence Inn', 249, '2019-02-21', 328, NULL),
('Residence Inn', 249, '2019-02-22', 110, NULL),
('Residence Inn', 249, '2019-02-23', 384, NULL),
('Residence Inn', 249, '2019-02-24', 220, NULL),
('Residence Inn', 249, '2019-02-25', 262, NULL),
('Residence Inn', 249, '2019-02-26', 216, NULL),
('Residence Inn', 249, '2019-02-27', 130, NULL),
('Residence Inn', 249, '2019-02-28', 389, NULL),
('Residence Inn', 249, '2019-03-01', 159, NULL),
('Residence Inn', 249, '2019-03-02', 366, NULL),
('Residence Inn', 249, '2019-03-03', 297, NULL),
('Residence Inn', 249, '2019-03-04', 209, NULL),
('Residence Inn', 249, '2019-03-05', 212, NULL),
('Residence Inn', 249, '2019-03-06', 335, NULL),
('Residence Inn', 249, '2019-03-07', 175, NULL),
('Residence Inn', 249, '2019-03-08', 206, NULL),
('Residence Inn', 249, '2019-03-09', 124, NULL),
('Residence Inn', 249, '2019-03-10', 219, NULL),
('Residence Inn', 249, '2019-03-11', 225, NULL),
('Residence Inn', 249, '2019-03-12', 309, NULL),
('Residence Inn', 249, '2019-03-13', 331, NULL),
('Residence Inn', 249, '2019-03-14', 207, NULL),
('Residence Inn', 249, '2019-03-15', 279, NULL),
('Residence Inn', 249, '2019-03-16', 350, NULL),
('Residence Inn', 249, '2019-03-17', 300, NULL),
('Residence Inn', 249, '2019-03-18', 146, NULL),
('Residence Inn', 249, '2019-03-19', 174, NULL),
('Residence Inn', 249, '2019-03-20', 373, NULL),
('Residence Inn', 249, '2019-03-21', 109, NULL),
('Residence Inn', 249, '2019-03-22', 399, NULL),
('Residence Inn', 249, '2019-03-23', 299, NULL),
('Residence Inn', 249, '2019-03-24', 296, NULL),
('Residence Inn', 249, '2019-03-25', 234, NULL),
('Residence Inn', 249, '2019-03-26', 136, NULL),
('Residence Inn', 249, '2019-03-27', 103, NULL),
('Residence Inn', 249, '2019-03-28', 241, NULL),
('Residence Inn', 249, '2019-03-29', 276, NULL),
('Residence Inn', 249, '2019-03-30', 114, NULL),
('Residence Inn', 249, '2019-03-31', 318, NULL),
('Residence Inn', 249, '2019-04-01', 169, NULL),
('Residence Inn', 249, '2019-04-02', 114, NULL),
('Residence Inn', 249, '2019-04-03', 248, NULL),
('Residence Inn', 249, '2019-04-04', 366, NULL),
('Residence Inn', 249, '2019-04-05', 271, NULL),
('Residence Inn', 249, '2019-04-06', 256, NULL),
('Residence Inn', 249, '2019-04-07', 281, NULL),
('Residence Inn', 249, '2019-04-08', 123, NULL),
('Residence Inn', 249, '2019-04-09', 294, NULL),
('Residence Inn', 249, '2019-04-10', 328, NULL),
('Residence Inn', 249, '2019-04-11', 294, NULL),
('Residence Inn', 249, '2019-04-12', 373, NULL),
('Residence Inn', 249, '2019-04-13', 129, NULL),
('Residence Inn', 249, '2019-04-14', 331, NULL),
('Residence Inn', 249, '2019-04-15', 318, NULL),
('Residence Inn', 249, '2019-04-16', 260, NULL),
('Residence Inn', 249, '2019-04-17', 161, NULL),
('Residence Inn', 249, '2019-04-18', 160, NULL),
('Residence Inn', 249, '2019-04-19', 333, NULL),
('Residence Inn', 249, '2019-04-20', 384, NULL),
('Residence Inn', 249, '2019-04-21', 248, NULL),
('Residence Inn', 249, '2019-04-22', 194, NULL),
('Residence Inn', 249, '2019-04-23', 304, NULL),
('Residence Inn', 249, '2019-04-24', 250, NULL),
('Residence Inn', 249, '2019-04-25', 167, NULL),
('Residence Inn', 249, '2019-04-26', 344, NULL),
('Residence Inn', 249, '2019-04-27', 250, NULL),
('Residence Inn', 249, '2019-04-28', 242, NULL),
('Residence Inn', 249, '2019-04-29', 237, NULL),
('Residence Inn', 249, '2019-04-30', 391, NULL),
('Residence Inn', 249, '2019-05-01', 138, NULL),
('Residence Inn', 249, '2019-05-02', 110, NULL),
('Residence Inn', 249, '2019-05-03', 157, NULL),
('Residence Inn', 249, '2019-05-04', 277, NULL),
('Residence Inn', 249, '2019-05-05', 268, NULL),
('Residence Inn', 249, '2019-05-06', 229, NULL),
('Residence Inn', 249, '2019-05-07', 210, NULL),
('Residence Inn', 249, '2019-05-08', 137, NULL),
('Residence Inn', 249, '2019-05-09', 233, NULL),
('Residence Inn', 249, '2019-05-10', 148, NULL),
('Residence Inn', 249, '2019-05-11', 164, NULL),
('Residence Inn', 249, '2019-05-12', 275, NULL),
('Residence Inn', 249, '2019-05-13', 277, NULL),
('Residence Inn', 249, '2019-05-14', 309, NULL),
('Residence Inn', 249, '2019-05-15', 382, NULL),
('Residence Inn', 249, '2019-05-16', 108, NULL),
('Residence Inn', 249, '2019-05-17', 279, NULL),
('Residence Inn', 249, '2019-05-18', 329, NULL),
('Residence Inn', 249, '2019-05-19', 120, NULL),
('Residence Inn', 249, '2019-05-20', 330, NULL),
('Residence Inn', 249, '2019-05-21', 379, NULL),
('Residence Inn', 249, '2019-05-22', 258, NULL),
('Residence Inn', 249, '2019-05-23', 208, NULL),
('Residence Inn', 249, '2019-05-24', 211, NULL),
('Residence Inn', 249, '2019-05-25', 127, NULL),
('Residence Inn', 249, '2019-05-26', 142, NULL),
('Residence Inn', 249, '2019-05-27', 182, NULL),
('Residence Inn', 249, '2019-05-28', 144, NULL),
('Residence Inn', 249, '2019-05-29', 399, NULL),
('Residence Inn', 249, '2019-05-30', 207, NULL),
('Residence Inn', 249, '2019-05-31', 359, NULL),
('Residence Inn', 249, '2019-06-01', 171, NULL),
('Residence Inn', 249, '2019-06-02', 110, NULL),
('Residence Inn', 249, '2019-06-03', 119, NULL),
('Residence Inn', 249, '2019-06-04', 103, NULL),
('Residence Inn', 249, '2019-06-05', 115, NULL),
('Residence Inn', 249, '2019-06-06', 350, NULL),
('Residence Inn', 249, '2019-06-07', 318, NULL),
('Residence Inn', 249, '2019-06-08', 314, NULL),
('Residence Inn', 249, '2019-06-09', 314, NULL),
('Residence Inn', 249, '2019-06-10', 293, NULL),
('Residence Inn', 249, '2019-06-11', 205, NULL),
('Residence Inn', 249, '2019-06-12', 305, NULL),
('Residence Inn', 249, '2019-06-13', 307, NULL),
('Residence Inn', 249, '2019-06-14', 190, NULL),
('Residence Inn', 249, '2019-06-15', 290, NULL),
('Residence Inn', 249, '2019-06-16', 352, NULL),
('Residence Inn', 249, '2019-06-17', 348, NULL),
('Residence Inn', 249, '2019-06-18', 331, NULL),
('Residence Inn', 249, '2019-06-19', 374, NULL),
('Residence Inn', 249, '2019-06-20', 385, NULL),
('Residence Inn', 249, '2019-06-21', 333, NULL),
('Residence Inn', 249, '2019-06-22', 387, NULL),
('Residence Inn', 249, '2019-06-23', 174, NULL),
('Residence Inn', 249, '2019-06-24', 352, NULL),
('Residence Inn', 249, '2019-06-25', 267, NULL),
('Residence Inn', 249, '2019-06-26', 229, NULL),
('Residence Inn', 249, '2019-06-27', 278, NULL),
('Residence Inn', 249, '2019-06-28', 238, NULL),
('Residence Inn', 249, '2019-06-29', 349, NULL),
('Residence Inn', 249, '2019-06-30', 331, NULL),
('Residence Inn', 249, '2019-07-01', 243, NULL),
('Residence Inn', 249, '2019-07-02', 230, NULL),
('Residence Inn', 249, '2019-07-03', 350, NULL),
('Residence Inn', 249, '2019-07-04', 350, NULL),
('Residence Inn', 249, '2019-07-05', 380, NULL),
('Residence Inn', 249, '2019-07-06', 207, NULL),
('Residence Inn', 249, '2019-07-07', 344, NULL),
('Residence Inn', 249, '2019-07-08', 294, NULL),
('Residence Inn', 249, '2019-07-09', 234, NULL),
('Residence Inn', 249, '2019-07-10', 138, NULL),
('Residence Inn', 249, '2019-07-11', 268, NULL),
('Residence Inn', 249, '2019-07-12', 175, NULL),
('Residence Inn', 249, '2019-07-13', 140, NULL),
('Residence Inn', 249, '2019-07-14', 195, NULL),
('Residence Inn', 249, '2019-07-15', 228, NULL),
('Residence Inn', 249, '2019-07-16', 239, NULL),
('Residence Inn', 249, '2019-07-17', 395, NULL),
('Residence Inn', 249, '2019-07-18', 179, NULL),
('Residence Inn', 249, '2019-07-19', 134, NULL),
('Residence Inn', 249, '2019-07-20', 198, NULL),
('Residence Inn', 249, '2019-07-21', 141, NULL),
('Residence Inn', 249, '2019-07-22', 369, NULL),
('Residence Inn', 249, '2019-07-23', 300, NULL),
('Residence Inn', 249, '2019-07-24', 251, NULL),
('Residence Inn', 249, '2019-07-25', 127, NULL),
('Residence Inn', 249, '2019-07-26', 319, NULL),
('Residence Inn', 249, '2019-07-27', 204, NULL),
('Residence Inn', 249, '2019-07-28', 153, NULL),
('Residence Inn', 249, '2019-07-29', 347, NULL),
('Residence Inn', 249, '2019-07-30', 232, NULL),
('Residence Inn', 249, '2019-07-31', 118, NULL),
('Residence Inn', 249, '2019-08-01', 162, NULL),
('Residence Inn', 249, '2019-08-02', 264, NULL),
('Residence Inn', 249, '2019-08-03', 121, NULL),
('Residence Inn', 249, '2019-08-04', 228, NULL),
('Residence Inn', 249, '2019-08-05', 270, NULL),
('Residence Inn', 249, '2019-08-06', 120, NULL),
('Residence Inn', 249, '2019-08-07', 265, NULL),
('Residence Inn', 249, '2019-08-08', 285, NULL),
('Residence Inn', 249, '2019-08-09', 267, NULL),
('Residence Inn', 249, '2019-08-10', 206, NULL),
('Residence Inn', 249, '2019-08-11', 123, NULL),
('Residence Inn', 249, '2019-08-12', 266, NULL),
('Residence Inn', 249, '2019-08-13', 393, NULL),
('Residence Inn', 249, '2019-08-14', 380, NULL),
('Residence Inn', 249, '2019-08-15', 385, NULL),
('Residence Inn', 249, '2019-08-16', 176, NULL),
('Residence Inn', 249, '2019-08-17', 125, NULL),
('Residence Inn', 249, '2019-08-18', 185, NULL),
('Residence Inn', 249, '2019-08-19', 159, NULL),
('Residence Inn', 249, '2019-08-20', 188, NULL),
('Residence Inn', 249, '2019-08-21', 152, NULL),
('Residence Inn', 249, '2019-08-22', 307, NULL),
('Residence Inn', 249, '2019-08-23', 139, NULL),
('Residence Inn', 249, '2019-08-24', 166, NULL),
('Residence Inn', 249, '2019-08-25', 339, NULL),
('Residence Inn', 249, '2019-08-26', 115, NULL),
('Residence Inn', 249, '2019-08-27', 396, NULL),
('Residence Inn', 249, '2019-08-28', 370, NULL),
('Residence Inn', 249, '2019-08-29', 378, NULL),
('Residence Inn', 249, '2019-08-30', 223, NULL),
('Residence Inn', 249, '2019-08-31', 249, NULL),
('Residence Inn', 249, '2019-09-01', 277, NULL),
('Residence Inn', 249, '2019-09-02', 164, NULL),
('Residence Inn', 249, '2019-09-03', 389, NULL),
('Residence Inn', 249, '2019-09-04', 244, NULL),
('Residence Inn', 249, '2019-09-05', 291, NULL),
('Residence Inn', 249, '2019-09-06', 270, NULL),
('Residence Inn', 249, '2019-09-07', 118, NULL),
('Residence Inn', 249, '2019-09-08', 283, NULL),
('Residence Inn', 249, '2019-09-09', 333, NULL),
('Residence Inn', 249, '2019-09-10', 381, NULL),
('Residence Inn', 249, '2019-09-11', 318, NULL),
('Residence Inn', 249, '2019-09-12', 197, NULL),
('Residence Inn', 249, '2019-09-13', 110, NULL),
('Residence Inn', 249, '2019-09-14', 272, NULL),
('Residence Inn', 249, '2019-09-15', 158, NULL),
('Residence Inn', 249, '2019-09-16', 390, NULL),
('Residence Inn', 249, '2019-09-17', 143, NULL),
('Residence Inn', 249, '2019-09-18', 338, NULL),
('Residence Inn', 249, '2019-09-19', 108, NULL),
('Residence Inn', 249, '2019-09-20', 173, NULL),
('Residence Inn', 249, '2019-09-21', 196, NULL),
('Residence Inn', 249, '2019-09-22', 205, NULL),
('Residence Inn', 249, '2019-09-23', 162, NULL),
('Residence Inn', 249, '2019-09-24', 355, NULL),
('Residence Inn', 249, '2019-09-25', 362, NULL),
('Residence Inn', 249, '2019-09-26', 365, NULL),
('Residence Inn', 249, '2019-09-27', 182, NULL),
('Residence Inn', 249, '2019-09-28', 189, NULL),
('Residence Inn', 249, '2019-09-29', 175, NULL),
('Residence Inn', 249, '2019-09-30', 343, NULL),
('Residence Inn', 249, '2019-10-01', 148, NULL),
('Residence Inn', 249, '2019-10-02', 278, NULL),
('Residence Inn', 249, '2019-10-03', 132, NULL),
('Residence Inn', 249, '2019-10-04', 355, NULL),
('Residence Inn', 249, '2019-10-05', 202, NULL),
('Residence Inn', 249, '2019-10-06', 114, NULL),
('Residence Inn', 249, '2019-10-07', 180, NULL),
('Residence Inn', 249, '2019-10-08', 395, NULL),
('Residence Inn', 249, '2019-10-09', 310, NULL),
('Residence Inn', 249, '2019-10-10', 250, NULL),
('Residence Inn', 249, '2019-10-11', 204, NULL),
('Residence Inn', 249, '2019-10-12', 214, NULL),
('Residence Inn', 249, '2019-10-13', 334, NULL),
('Residence Inn', 249, '2019-10-14', 120, NULL),
('Residence Inn', 249, '2019-10-15', 385, NULL),
('Residence Inn', 249, '2019-10-16', 301, NULL),
('Residence Inn', 249, '2019-10-17', 203, NULL),
('Residence Inn', 249, '2019-10-18', 118, NULL),
('Residence Inn', 249, '2019-10-19', 181, NULL),
('Residence Inn', 249, '2019-10-20', 298, NULL),
('Residence Inn', 249, '2019-10-21', 362, NULL),
('Residence Inn', 249, '2019-10-22', 167, NULL),
('Residence Inn', 249, '2019-10-23', 129, NULL),
('Residence Inn', 249, '2019-10-24', 200, NULL),
('Residence Inn', 249, '2019-10-25', 131, NULL),
('Residence Inn', 249, '2019-10-26', 336, NULL),
('Residence Inn', 249, '2019-10-27', 150, NULL),
('Residence Inn', 249, '2019-10-28', 242, NULL),
('Residence Inn', 249, '2019-10-29', 378, NULL),
('Residence Inn', 249, '2019-10-30', 246, NULL),
('Residence Inn', 249, '2019-10-31', 389, NULL),
('Residence Inn', 249, '2019-11-01', 327, NULL),
('Residence Inn', 249, '2019-11-02', 352, NULL),
('Residence Inn', 249, '2019-11-03', 270, NULL),
('Residence Inn', 249, '2019-11-04', 188, NULL),
('Residence Inn', 249, '2019-11-05', 387, NULL),
('Residence Inn', 249, '2019-11-06', 371, NULL),
('Residence Inn', 249, '2019-11-07', 376, NULL),
('Residence Inn', 249, '2019-11-08', 117, NULL),
('Residence Inn', 249, '2019-11-09', 146, NULL),
('Residence Inn', 249, '2019-11-10', 149, NULL),
('Residence Inn', 249, '2019-11-11', 265, NULL),
('Residence Inn', 249, '2019-11-12', 227, NULL),
('Residence Inn', 249, '2019-11-13', 138, NULL),
('Residence Inn', 249, '2019-11-14', 291, NULL),
('Residence Inn', 249, '2019-11-15', 108, NULL),
('Residence Inn', 249, '2019-11-16', 265, NULL),
('Residence Inn', 249, '2019-11-17', 301, NULL),
('Residence Inn', 249, '2019-11-18', 289, NULL),
('Residence Inn', 249, '2019-11-19', 215, NULL),
('Residence Inn', 249, '2019-11-20', 272, NULL),
('Residence Inn', 249, '2019-11-21', 278, NULL),
('Residence Inn', 249, '2019-11-22', 241, NULL),
('Residence Inn', 249, '2019-11-23', 221, NULL),
('Residence Inn', 249, '2019-11-24', 265, NULL),
('Residence Inn', 249, '2019-11-25', 111, NULL),
('Residence Inn', 249, '2019-11-26', 206, NULL),
('Residence Inn', 249, '2019-11-27', 184, NULL),
('Residence Inn', 249, '2019-11-28', 298, NULL),
('Residence Inn', 249, '2019-11-29', 318, NULL),
('Residence Inn', 249, '2019-11-30', 246, NULL),
('Residence Inn', 249, '2019-12-01', 321, NULL),
('Residence Inn', 249, '2019-12-02', 151, NULL),
('Residence Inn', 249, '2019-12-03', 183, NULL),
('Residence Inn', 249, '2019-12-04', 133, NULL),
('Residence Inn', 249, '2019-12-05', 278, NULL),
('Residence Inn', 249, '2019-12-06', 187, NULL),
('Residence Inn', 249, '2019-12-07', 354, NULL),
('Residence Inn', 249, '2019-12-08', 334, NULL),
('Residence Inn', 249, '2019-12-09', 386, NULL),
('Residence Inn', 249, '2019-12-10', 293, NULL),
('Residence Inn', 249, '2019-12-11', 289, NULL),
('Residence Inn', 249, '2019-12-12', 323, NULL),
('Residence Inn', 249, '2019-12-13', 155, NULL),
('Residence Inn', 249, '2019-12-14', 383, NULL),
('Residence Inn', 249, '2019-12-15', 397, NULL),
('Residence Inn', 249, '2019-12-16', 342, NULL),
('Residence Inn', 249, '2019-12-17', 163, NULL),
('Residence Inn', 249, '2019-12-18', 256, NULL),
('Residence Inn', 249, '2019-12-19', 366, NULL),
('Residence Inn', 249, '2019-12-20', 379, NULL),
('Residence Inn', 249, '2019-12-21', 337, NULL),
('Residence Inn', 249, '2019-12-22', 398, NULL),
('Residence Inn', 249, '2019-12-23', 183, NULL),
('Residence Inn', 249, '2019-12-24', 109, NULL),
('Residence Inn', 249, '2019-12-25', 124, NULL),
('Residence Inn', 249, '2019-12-26', 193, NULL),
('Residence Inn', 249, '2019-12-27', 356, NULL),
('Residence Inn', 249, '2019-12-28', 273, NULL),
('Residence Inn', 249, '2019-12-29', 175, NULL),
('Residence Inn', 249, '2019-12-30', 157, NULL),
('Residence Inn', 249, '2019-12-31', 108, NULL),
('Residence Inn', 249, '2020-01-01', 224, NULL),
('Residence Inn', 249, '2020-01-02', 378, NULL),
('Residence Inn', 249, '2020-01-03', 296, NULL),
('Residence Inn', 249, '2020-01-04', 201, NULL),
('Residence Inn', 249, '2020-01-05', 287, NULL),
('Residence Inn', 249, '2020-01-06', 347, NULL),
('Residence Inn', 249, '2020-01-07', 131, NULL),
('Residence Inn', 249, '2020-01-08', 105, NULL),
('Residence Inn', 249, '2020-01-09', 309, NULL),
('Residence Inn', 249, '2020-01-10', 264, NULL),
('Residence Inn', 249, '2020-01-11', 362, NULL),
('Residence Inn', 249, '2020-01-12', 171, NULL),
('Residence Inn', 249, '2020-01-13', 114, NULL),
('Residence Inn', 249, '2020-01-14', 283, NULL),
('Residence Inn', 249, '2020-01-15', 188, NULL),
('Residence Inn', 249, '2020-01-16', 282, NULL),
('Residence Inn', 249, '2020-01-17', 214, NULL),
('Residence Inn', 249, '2020-01-18', 115, NULL),
('Residence Inn', 249, '2020-01-19', 331, NULL),
('Residence Inn', 249, '2020-01-20', 318, NULL),
('Residence Inn', 249, '2020-01-21', 207, NULL),
('Residence Inn', 249, '2020-01-22', 381, NULL),
('Residence Inn', 249, '2020-01-23', 292, NULL),
('Residence Inn', 249, '2020-01-24', 250, NULL),
('Residence Inn', 249, '2020-01-25', 276, NULL),
('Residence Inn', 249, '2020-01-26', 237, NULL),
('Residence Inn', 249, '2020-01-27', 147, NULL),
('Residence Inn', 249, '2020-01-28', 379, NULL),
('Residence Inn', 249, '2020-01-29', 112, NULL),
('Residence Inn', 249, '2020-01-30', 264, NULL),
('Residence Inn', 249, '2020-01-31', 319, NULL),
('Residence Inn', 249, '2020-02-01', 307, NULL),
('Residence Inn', 249, '2020-02-02', 138, NULL),
('Residence Inn', 249, '2020-02-03', 272, NULL),
('Residence Inn', 249, '2020-02-04', 154, NULL),
('Residence Inn', 261, '2019-01-01', 207, NULL),
('Residence Inn', 261, '2019-01-02', 227, NULL),
('Residence Inn', 261, '2019-01-03', 204, NULL),
('Residence Inn', 261, '2019-01-04', 352, NULL),
('Residence Inn', 261, '2019-01-05', 373, NULL),
('Residence Inn', 261, '2019-01-06', 226, NULL),
('Residence Inn', 261, '2019-01-07', 139, NULL),
('Residence Inn', 261, '2019-01-08', 334, NULL),
('Residence Inn', 261, '2019-01-09', 249, NULL),
('Residence Inn', 261, '2019-01-10', 219, NULL),
('Residence Inn', 261, '2019-01-11', 309, NULL),
('Residence Inn', 261, '2019-01-12', 327, NULL),
('Residence Inn', 261, '2019-01-13', 386, NULL),
('Residence Inn', 261, '2019-01-14', 375, NULL),
('Residence Inn', 261, '2019-01-15', 254, NULL),
('Residence Inn', 261, '2019-01-16', 199, NULL),
('Residence Inn', 261, '2019-01-17', 194, NULL),
('Residence Inn', 261, '2019-01-18', 220, NULL),
('Residence Inn', 261, '2019-01-19', 202, NULL),
('Residence Inn', 261, '2019-01-20', 372, NULL),
('Residence Inn', 261, '2019-01-21', 272, NULL),
('Residence Inn', 261, '2019-01-22', 247, NULL),
('Residence Inn', 261, '2019-01-23', 236, NULL),
('Residence Inn', 261, '2019-01-24', 352, NULL),
('Residence Inn', 261, '2019-01-25', 294, NULL),
('Residence Inn', 261, '2019-01-26', 266, NULL),
('Residence Inn', 261, '2019-01-27', 346, NULL),
('Residence Inn', 261, '2019-01-28', 333, NULL),
('Residence Inn', 261, '2019-01-29', 140, NULL),
('Residence Inn', 261, '2019-01-30', 337, NULL),
('Residence Inn', 261, '2019-01-31', 224, NULL),
('Residence Inn', 261, '2019-02-01', 396, NULL),
('Residence Inn', 261, '2019-02-02', 136, NULL),
('Residence Inn', 261, '2019-02-03', 122, NULL),
('Residence Inn', 261, '2019-02-04', 194, NULL),
('Residence Inn', 261, '2019-02-05', 162, NULL),
('Residence Inn', 261, '2019-02-06', 276, NULL),
('Residence Inn', 261, '2019-02-07', 375, NULL),
('Residence Inn', 261, '2019-02-08', 217, NULL),
('Residence Inn', 261, '2019-02-09', 100, NULL),
('Residence Inn', 261, '2019-02-10', 323, NULL),
('Residence Inn', 261, '2019-02-11', 135, NULL),
('Residence Inn', 261, '2019-02-12', 330, NULL),
('Residence Inn', 261, '2019-02-13', 281, NULL),
('Residence Inn', 261, '2019-02-14', 350, NULL),
('Residence Inn', 261, '2019-02-15', 259, NULL),
('Residence Inn', 261, '2019-02-16', 334, NULL),
('Residence Inn', 261, '2019-02-17', 218, NULL),
('Residence Inn', 261, '2019-02-18', 130, NULL),
('Residence Inn', 261, '2019-02-19', 315, NULL),
('Residence Inn', 261, '2019-02-20', 164, NULL),
('Residence Inn', 261, '2019-02-21', 183, NULL),
('Residence Inn', 261, '2019-02-22', 255, NULL),
('Residence Inn', 261, '2019-02-23', 275, NULL),
('Residence Inn', 261, '2019-02-24', 108, NULL),
('Residence Inn', 261, '2019-02-25', 321, NULL),
('Residence Inn', 261, '2019-02-26', 219, NULL),
('Residence Inn', 261, '2019-02-27', 341, NULL),
('Residence Inn', 261, '2019-02-28', 120, NULL),
('Residence Inn', 261, '2019-03-01', 149, NULL),
('Residence Inn', 261, '2019-03-02', 178, NULL),
('Residence Inn', 261, '2019-03-03', 270, NULL),
('Residence Inn', 261, '2019-03-04', 385, NULL),
('Residence Inn', 261, '2019-03-05', 384, NULL),
('Residence Inn', 261, '2019-03-06', 311, NULL),
('Residence Inn', 261, '2019-03-07', 296, NULL),
('Residence Inn', 261, '2019-03-08', 235, NULL),
('Residence Inn', 261, '2019-03-09', 305, NULL),
('Residence Inn', 261, '2019-03-10', 209, NULL),
('Residence Inn', 261, '2019-03-11', 135, NULL),
('Residence Inn', 261, '2019-03-12', 308, NULL),
('Residence Inn', 261, '2019-03-13', 160, NULL),
('Residence Inn', 261, '2019-03-14', 354, NULL),
('Residence Inn', 261, '2019-03-15', 267, NULL),
('Residence Inn', 261, '2019-03-16', 284, NULL),
('Residence Inn', 261, '2019-03-17', 214, NULL),
('Residence Inn', 261, '2019-03-18', 148, NULL),
('Residence Inn', 261, '2019-03-19', 114, NULL),
('Residence Inn', 261, '2019-03-20', 265, NULL),
('Residence Inn', 261, '2019-03-21', 166, NULL),
('Residence Inn', 261, '2019-03-22', 205, NULL),
('Residence Inn', 261, '2019-03-23', 129, NULL),
('Residence Inn', 261, '2019-03-24', 305, NULL),
('Residence Inn', 261, '2019-03-25', 161, NULL),
('Residence Inn', 261, '2019-03-26', 264, NULL),
('Residence Inn', 261, '2019-03-27', 307, NULL),
('Residence Inn', 261, '2019-03-28', 245, NULL),
('Residence Inn', 261, '2019-03-29', 394, NULL),
('Residence Inn', 261, '2019-03-30', 309, NULL),
('Residence Inn', 261, '2019-03-31', 175, NULL),
('Residence Inn', 261, '2019-04-01', 196, NULL),
('Residence Inn', 261, '2019-04-02', 242, NULL),
('Residence Inn', 261, '2019-04-03', 127, NULL),
('Residence Inn', 261, '2019-04-04', 399, NULL),
('Residence Inn', 261, '2019-04-05', 163, NULL),
('Residence Inn', 261, '2019-04-06', 359, NULL),
('Residence Inn', 261, '2019-04-07', 161, NULL),
('Residence Inn', 261, '2019-04-08', 128, NULL),
('Residence Inn', 261, '2019-04-09', 130, NULL),
('Residence Inn', 261, '2019-04-10', 331, NULL),
('Residence Inn', 261, '2019-04-11', 170, NULL),
('Residence Inn', 261, '2019-04-12', 347, NULL),
('Residence Inn', 261, '2019-04-13', 253, NULL),
('Residence Inn', 261, '2019-04-14', 135, NULL),
('Residence Inn', 261, '2019-04-15', 277, NULL),
('Residence Inn', 261, '2019-04-16', 256, NULL),
('Residence Inn', 261, '2019-04-17', 246, NULL),
('Residence Inn', 261, '2019-04-18', 280, NULL),
('Residence Inn', 261, '2019-04-19', 105, NULL),
('Residence Inn', 261, '2019-04-20', 142, NULL),
('Residence Inn', 261, '2019-04-21', 180, NULL),
('Residence Inn', 261, '2019-04-22', 305, NULL),
('Residence Inn', 261, '2019-04-23', 328, NULL),
('Residence Inn', 261, '2019-04-24', 193, NULL),
('Residence Inn', 261, '2019-04-25', 240, NULL),
('Residence Inn', 261, '2019-04-26', 389, NULL),
('Residence Inn', 261, '2019-04-27', 221, NULL),
('Residence Inn', 261, '2019-04-28', 355, NULL),
('Residence Inn', 261, '2019-04-29', 151, NULL),
('Residence Inn', 261, '2019-04-30', 120, NULL),
('Residence Inn', 261, '2019-05-01', 228, NULL),
('Residence Inn', 261, '2019-05-02', 366, NULL),
('Residence Inn', 261, '2019-05-03', 233, NULL),
('Residence Inn', 261, '2019-05-04', 329, NULL),
('Residence Inn', 261, '2019-05-05', 176, NULL),
('Residence Inn', 261, '2019-05-06', 303, NULL),
('Residence Inn', 261, '2019-05-07', 315, NULL),
('Residence Inn', 261, '2019-05-08', 352, NULL),
('Residence Inn', 261, '2019-05-09', 301, NULL),
('Residence Inn', 261, '2019-05-10', 155, NULL),
('Residence Inn', 261, '2019-05-11', 208, NULL),
('Residence Inn', 261, '2019-05-12', 274, NULL),
('Residence Inn', 261, '2019-05-13', 353, NULL),
('Residence Inn', 261, '2019-05-14', 292, NULL),
('Residence Inn', 261, '2019-05-15', 347, NULL),
('Residence Inn', 261, '2019-05-16', 272, NULL),
('Residence Inn', 261, '2019-05-17', 304, NULL),
('Residence Inn', 261, '2019-05-18', 184, NULL),
('Residence Inn', 261, '2019-05-19', 399, NULL),
('Residence Inn', 261, '2019-05-20', 270, NULL),
('Residence Inn', 261, '2019-05-21', 200, NULL),
('Residence Inn', 261, '2019-05-22', 167, NULL),
('Residence Inn', 261, '2019-05-23', 129, NULL),
('Residence Inn', 261, '2019-05-24', 138, NULL),
('Residence Inn', 261, '2019-05-25', 204, NULL),
('Residence Inn', 261, '2019-05-26', 140, NULL),
('Residence Inn', 261, '2019-05-27', 368, NULL),
('Residence Inn', 261, '2019-05-28', 267, NULL),
('Residence Inn', 261, '2019-05-29', 375, NULL),
('Residence Inn', 261, '2019-05-30', 324, NULL),
('Residence Inn', 261, '2019-05-31', 242, NULL),
('Residence Inn', 261, '2019-06-01', 141, NULL),
('Residence Inn', 261, '2019-06-02', 169, NULL),
('Residence Inn', 261, '2019-06-03', 163, NULL),
('Residence Inn', 261, '2019-06-04', 329, NULL),
('Residence Inn', 261, '2019-06-05', 240, NULL),
('Residence Inn', 261, '2019-06-06', 296, NULL),
('Residence Inn', 261, '2019-06-07', 307, NULL),
('Residence Inn', 261, '2019-06-08', 293, NULL),
('Residence Inn', 261, '2019-06-09', 350, NULL),
('Residence Inn', 261, '2019-06-10', 399, NULL),
('Residence Inn', 261, '2019-06-11', 265, NULL),
('Residence Inn', 261, '2019-06-12', 319, NULL),
('Residence Inn', 261, '2019-06-13', 161, NULL),
('Residence Inn', 261, '2019-06-14', 271, NULL),
('Residence Inn', 261, '2019-06-15', 252, NULL),
('Residence Inn', 261, '2019-06-16', 269, NULL),
('Residence Inn', 261, '2019-06-17', 273, NULL),
('Residence Inn', 261, '2019-06-18', 370, NULL),
('Residence Inn', 261, '2019-06-19', 275, NULL),
('Residence Inn', 261, '2019-06-20', 108, NULL),
('Residence Inn', 261, '2019-06-21', 101, NULL),
('Residence Inn', 261, '2019-06-22', 231, NULL),
('Residence Inn', 261, '2019-06-23', 171, NULL),
('Residence Inn', 261, '2019-06-24', 116, NULL),
('Residence Inn', 261, '2019-06-25', 223, NULL),
('Residence Inn', 261, '2019-06-26', 308, NULL),
('Residence Inn', 261, '2019-06-27', 249, NULL),
('Residence Inn', 261, '2019-06-28', 184, NULL),
('Residence Inn', 261, '2019-06-29', 176, NULL),
('Residence Inn', 261, '2019-06-30', 348, NULL),
('Residence Inn', 261, '2019-07-01', 354, NULL),
('Residence Inn', 261, '2019-07-02', 151, NULL),
('Residence Inn', 261, '2019-07-03', 207, NULL),
('Residence Inn', 261, '2019-07-04', 352, NULL),
('Residence Inn', 261, '2019-07-05', 365, NULL),
('Residence Inn', 261, '2019-07-06', 276, NULL),
('Residence Inn', 261, '2019-07-07', 119, NULL),
('Residence Inn', 261, '2019-07-08', 313, NULL),
('Residence Inn', 261, '2019-07-09', 266, NULL),
('Residence Inn', 261, '2019-07-10', 262, NULL),
('Residence Inn', 261, '2019-07-11', 298, NULL),
('Residence Inn', 261, '2019-07-12', 330, NULL),
('Residence Inn', 261, '2019-07-13', 179, NULL),
('Residence Inn', 261, '2019-07-14', 245, NULL),
('Residence Inn', 261, '2019-07-15', 388, NULL),
('Residence Inn', 261, '2019-07-16', 194, NULL),
('Residence Inn', 261, '2019-07-17', 307, NULL),
('Residence Inn', 261, '2019-07-18', 367, NULL),
('Residence Inn', 261, '2019-07-19', 312, NULL),
('Residence Inn', 261, '2019-07-20', 294, NULL),
('Residence Inn', 261, '2019-07-21', 364, NULL),
('Residence Inn', 261, '2019-07-22', 362, NULL),
('Residence Inn', 261, '2019-07-23', 215, NULL),
('Residence Inn', 261, '2019-07-24', 134, NULL),
('Residence Inn', 261, '2019-07-25', 349, NULL),
('Residence Inn', 261, '2019-07-26', 196, NULL),
('Residence Inn', 261, '2019-07-27', 183, NULL),
('Residence Inn', 261, '2019-07-28', 175, NULL),
('Residence Inn', 261, '2019-07-29', 210, NULL),
('Residence Inn', 261, '2019-07-30', 297, NULL),
('Residence Inn', 261, '2019-07-31', 110, NULL),
('Residence Inn', 261, '2019-08-01', 209, NULL),
('Residence Inn', 261, '2019-08-02', 124, NULL),
('Residence Inn', 261, '2019-08-03', 149, NULL),
('Residence Inn', 261, '2019-08-04', 282, NULL),
('Residence Inn', 261, '2019-08-05', 371, NULL),
('Residence Inn', 261, '2019-08-06', 181, NULL),
('Residence Inn', 261, '2019-08-07', 183, NULL),
('Residence Inn', 261, '2019-08-08', 224, NULL),
('Residence Inn', 261, '2019-08-09', 291, NULL),
('Residence Inn', 261, '2019-08-10', 216, NULL),
('Residence Inn', 261, '2019-08-11', 189, NULL),
('Residence Inn', 261, '2019-08-12', 378, NULL),
('Residence Inn', 261, '2019-08-13', 149, NULL),
('Residence Inn', 261, '2019-08-14', 389, NULL),
('Residence Inn', 261, '2019-08-15', 174, NULL),
('Residence Inn', 261, '2019-08-16', 135, NULL),
('Residence Inn', 261, '2019-08-17', 119, NULL),
('Residence Inn', 261, '2019-08-18', 287, NULL),
('Residence Inn', 261, '2019-08-19', 144, NULL),
('Residence Inn', 261, '2019-08-20', 168, NULL),
('Residence Inn', 261, '2019-08-21', 187, NULL),
('Residence Inn', 261, '2019-08-22', 141, NULL),
('Residence Inn', 261, '2019-08-23', 134, NULL),
('Residence Inn', 261, '2019-08-24', 349, NULL),
('Residence Inn', 261, '2019-08-25', 325, NULL),
('Residence Inn', 261, '2019-08-26', 253, NULL),
('Residence Inn', 261, '2019-08-27', 124, NULL),
('Residence Inn', 261, '2019-08-28', 316, NULL),
('Residence Inn', 261, '2019-08-29', 109, NULL),
('Residence Inn', 261, '2019-08-30', 242, NULL),
('Residence Inn', 261, '2019-08-31', 243, NULL),
('Residence Inn', 261, '2019-09-01', 137, NULL),
('Residence Inn', 261, '2019-09-02', 207, NULL),
('Residence Inn', 261, '2019-09-03', 293, NULL),
('Residence Inn', 261, '2019-09-04', 174, NULL),
('Residence Inn', 261, '2019-09-05', 256, NULL),
('Residence Inn', 261, '2019-09-06', 146, NULL),
('Residence Inn', 261, '2019-09-07', 187, NULL),
('Residence Inn', 261, '2019-09-08', 110, NULL),
('Residence Inn', 261, '2019-09-09', 290, NULL),
('Residence Inn', 261, '2019-09-10', 144, NULL),
('Residence Inn', 261, '2019-09-11', 323, NULL),
('Residence Inn', 261, '2019-09-12', 170, NULL),
('Residence Inn', 261, '2019-09-13', 374, NULL),
('Residence Inn', 261, '2019-09-14', 347, NULL),
('Residence Inn', 261, '2019-09-15', 245, NULL),
('Residence Inn', 261, '2019-09-16', 157, NULL),
('Residence Inn', 261, '2019-09-17', 104, NULL),
('Residence Inn', 261, '2019-09-18', 381, NULL),
('Residence Inn', 261, '2019-09-19', 180, NULL),
('Residence Inn', 261, '2019-09-20', 121, NULL),
('Residence Inn', 261, '2019-09-21', 258, NULL),
('Residence Inn', 261, '2019-09-22', 185, NULL),
('Residence Inn', 261, '2019-09-23', 390, NULL),
('Residence Inn', 261, '2019-09-24', 170, NULL),
('Residence Inn', 261, '2019-09-25', 397, NULL),
('Residence Inn', 261, '2019-09-26', 346, NULL),
('Residence Inn', 261, '2019-09-27', 152, NULL),
('Residence Inn', 261, '2019-09-28', 332, NULL),
('Residence Inn', 261, '2019-09-29', 358, NULL),
('Residence Inn', 261, '2019-09-30', 312, NULL),
('Residence Inn', 261, '2019-10-01', 149, NULL),
('Residence Inn', 261, '2019-10-02', 299, NULL),
('Residence Inn', 261, '2019-10-03', 322, NULL),
('Residence Inn', 261, '2019-10-04', 391, NULL),
('Residence Inn', 261, '2019-10-05', 339, NULL),
('Residence Inn', 261, '2019-10-06', 171, NULL),
('Residence Inn', 261, '2019-10-07', 335, NULL),
('Residence Inn', 261, '2019-10-08', 210, NULL),
('Residence Inn', 261, '2019-10-09', 305, NULL),
('Residence Inn', 261, '2019-10-10', 145, NULL),
('Residence Inn', 261, '2019-10-11', 205, NULL),
('Residence Inn', 261, '2019-10-12', 130, NULL),
('Residence Inn', 261, '2019-10-13', 272, NULL),
('Residence Inn', 261, '2019-10-14', 362, NULL),
('Residence Inn', 261, '2019-10-15', 113, NULL),
('Residence Inn', 261, '2019-10-16', 340, NULL),
('Residence Inn', 261, '2019-10-17', 114, NULL),
('Residence Inn', 261, '2019-10-18', 148, NULL),
('Residence Inn', 261, '2019-10-19', 119, NULL),
('Residence Inn', 261, '2019-10-20', 159, NULL),
('Residence Inn', 261, '2019-10-21', 387, NULL),
('Residence Inn', 261, '2019-10-22', 351, NULL),
('Residence Inn', 261, '2019-10-23', 337, NULL),
('Residence Inn', 261, '2019-10-24', 134, NULL),
('Residence Inn', 261, '2019-10-25', 109, NULL),
('Residence Inn', 261, '2019-10-26', 393, NULL),
('Residence Inn', 261, '2019-10-27', 111, NULL),
('Residence Inn', 261, '2019-10-28', 291, NULL),
('Residence Inn', 261, '2019-10-29', 215, NULL),
('Residence Inn', 261, '2019-10-30', 240, NULL),
('Residence Inn', 261, '2019-10-31', 325, NULL),
('Residence Inn', 261, '2019-11-01', 268, NULL),
('Residence Inn', 261, '2019-11-02', 318, NULL),
('Residence Inn', 261, '2019-11-03', 119, NULL),
('Residence Inn', 261, '2019-11-04', 259, NULL),
('Residence Inn', 261, '2019-11-05', 143, NULL),
('Residence Inn', 261, '2019-11-06', 121, NULL),
('Residence Inn', 261, '2019-11-07', 166, NULL),
('Residence Inn', 261, '2019-11-08', 176, NULL),
('Residence Inn', 261, '2019-11-09', 353, NULL),
('Residence Inn', 261, '2019-11-10', 117, NULL),
('Residence Inn', 261, '2019-11-11', 198, NULL),
('Residence Inn', 261, '2019-11-12', 373, NULL),
('Residence Inn', 261, '2019-11-13', 398, NULL),
('Residence Inn', 261, '2019-11-14', 229, NULL),
('Residence Inn', 261, '2019-11-15', 147, NULL),
('Residence Inn', 261, '2019-11-16', 199, NULL),
('Residence Inn', 261, '2019-11-17', 330, NULL),
('Residence Inn', 261, '2019-11-18', 331, NULL),
('Residence Inn', 261, '2019-11-19', 230, NULL),
('Residence Inn', 261, '2019-11-20', 153, NULL),
('Residence Inn', 261, '2019-11-21', 269, NULL),
('Residence Inn', 261, '2019-11-22', 382, NULL),
('Residence Inn', 261, '2019-11-23', 366, NULL),
('Residence Inn', 261, '2019-11-24', 334, NULL),
('Residence Inn', 261, '2019-11-25', 219, NULL),
('Residence Inn', 261, '2019-11-26', 208, NULL),
('Residence Inn', 261, '2019-11-27', 276, NULL),
('Residence Inn', 261, '2019-11-28', 120, NULL),
('Residence Inn', 261, '2019-11-29', 355, NULL),
('Residence Inn', 261, '2019-11-30', 230, NULL),
('Residence Inn', 261, '2019-12-01', 132, NULL),
('Residence Inn', 261, '2019-12-02', 205, NULL),
('Residence Inn', 261, '2019-12-03', 132, NULL),
('Residence Inn', 261, '2019-12-04', 371, NULL),
('Residence Inn', 261, '2019-12-05', 324, NULL),
('Residence Inn', 261, '2019-12-06', 284, NULL),
('Residence Inn', 261, '2019-12-07', 119, NULL),
('Residence Inn', 261, '2019-12-08', 338, NULL),
('Residence Inn', 261, '2019-12-09', 178, NULL),
('Residence Inn', 261, '2019-12-10', 389, NULL),
('Residence Inn', 261, '2019-12-11', 144, NULL),
('Residence Inn', 261, '2019-12-12', 270, NULL),
('Residence Inn', 261, '2019-12-13', 379, NULL),
('Residence Inn', 261, '2019-12-14', 256, NULL),
('Residence Inn', 261, '2019-12-15', 138, NULL),
('Residence Inn', 261, '2019-12-16', 272, NULL),
('Residence Inn', 261, '2019-12-17', 326, NULL),
('Residence Inn', 261, '2019-12-18', 344, NULL),
('Residence Inn', 261, '2019-12-19', 386, NULL),
('Residence Inn', 261, '2019-12-20', 219, NULL),
('Residence Inn', 261, '2019-12-21', 176, NULL),
('Residence Inn', 261, '2019-12-22', 207, NULL),
('Residence Inn', 261, '2019-12-23', 232, NULL),
('Residence Inn', 261, '2019-12-24', 352, NULL),
('Residence Inn', 261, '2019-12-25', 170, NULL),
('Residence Inn', 261, '2019-12-26', 267, NULL),
('Residence Inn', 261, '2019-12-27', 357, NULL),
('Residence Inn', 261, '2019-12-28', 238, NULL),
('Residence Inn', 261, '2019-12-29', 384, NULL),
('Residence Inn', 261, '2019-12-30', 287, NULL),
('Residence Inn', 261, '2019-12-31', 341, NULL),
('Residence Inn', 261, '2020-01-01', 152, NULL),
('Residence Inn', 261, '2020-01-02', 109, NULL),
('Residence Inn', 261, '2020-01-03', 201, NULL),
('Residence Inn', 261, '2020-01-04', 182, NULL),
('Residence Inn', 261, '2020-01-05', 377, NULL),
('Residence Inn', 261, '2020-01-06', 274, NULL),
('Residence Inn', 261, '2020-01-07', 170, NULL),
('Residence Inn', 261, '2020-01-08', 256, NULL),
('Residence Inn', 261, '2020-01-09', 294, NULL),
('Residence Inn', 261, '2020-01-10', 328, NULL),
('Residence Inn', 261, '2020-01-11', 176, NULL),
('Residence Inn', 261, '2020-01-12', 216, NULL),
('Residence Inn', 261, '2020-01-13', 389, NULL),
('Residence Inn', 261, '2020-01-14', 132, NULL),
('Residence Inn', 261, '2020-01-15', 337, NULL),
('Residence Inn', 261, '2020-01-16', 398, NULL),
('Residence Inn', 261, '2020-01-17', 177, NULL),
('Residence Inn', 261, '2020-01-18', 243, NULL),
('Residence Inn', 261, '2020-01-19', 259, NULL),
('Residence Inn', 261, '2020-01-20', 271, NULL),
('Residence Inn', 261, '2020-01-21', 344, NULL),
('Residence Inn', 261, '2020-01-22', 306, NULL),
('Residence Inn', 261, '2020-01-23', 100, NULL),
('Residence Inn', 261, '2020-01-24', 157, NULL),
('Residence Inn', 261, '2020-01-25', 245, NULL),
('Residence Inn', 261, '2020-01-26', 186, NULL),
('Residence Inn', 261, '2020-01-27', 330, NULL),
('Residence Inn', 261, '2020-01-28', 222, NULL),
('Residence Inn', 261, '2020-01-29', 263, NULL),
('Residence Inn', 261, '2020-01-30', 233, NULL),
('Residence Inn', 261, '2020-01-31', 329, NULL),
('Residence Inn', 261, '2020-02-01', 206, NULL),
('Residence Inn', 261, '2020-02-02', 181, NULL),
('Residence Inn', 261, '2020-02-03', 342, NULL),
('Residence Inn', 261, '2020-02-04', 387, NULL),
('Residence Inn', 269, '2019-01-01', 161, NULL),
('Residence Inn', 269, '2019-01-02', 261, NULL),
('Residence Inn', 269, '2019-01-03', 365, NULL),
('Residence Inn', 269, '2019-01-04', 219, NULL),
('Residence Inn', 269, '2019-01-05', 123, NULL),
('Residence Inn', 269, '2019-01-06', 298, NULL),
('Residence Inn', 269, '2019-01-07', 260, NULL),
('Residence Inn', 269, '2019-01-08', 353, NULL),
('Residence Inn', 269, '2019-01-09', 373, NULL),
('Residence Inn', 269, '2019-01-10', 226, NULL),
('Residence Inn', 269, '2019-01-11', 391, NULL),
('Residence Inn', 269, '2019-01-12', 322, NULL),
('Residence Inn', 269, '2019-01-13', 232, NULL),
('Residence Inn', 269, '2019-01-14', 101, NULL),
('Residence Inn', 269, '2019-01-15', 332, NULL),
('Residence Inn', 269, '2019-01-16', 194, NULL),
('Residence Inn', 269, '2019-01-17', 146, NULL),
('Residence Inn', 269, '2019-01-18', 242, NULL),
('Residence Inn', 269, '2019-01-19', 114, NULL),
('Residence Inn', 269, '2019-01-20', 254, NULL),
('Residence Inn', 269, '2019-01-21', 136, NULL),
('Residence Inn', 269, '2019-01-22', 309, NULL),
('Residence Inn', 269, '2019-01-23', 147, NULL),
('Residence Inn', 269, '2019-01-24', 247, NULL),
('Residence Inn', 269, '2019-01-25', 353, NULL),
('Residence Inn', 269, '2019-01-26', 393, NULL),
('Residence Inn', 269, '2019-01-27', 248, NULL),
('Residence Inn', 269, '2019-01-28', 176, NULL),
('Residence Inn', 269, '2019-01-29', 300, NULL),
('Residence Inn', 269, '2019-01-30', 270, NULL),
('Residence Inn', 269, '2019-01-31', 209, NULL),
('Residence Inn', 269, '2019-02-01', 129, NULL),
('Residence Inn', 269, '2019-02-02', 231, NULL),
('Residence Inn', 269, '2019-02-03', 369, NULL),
('Residence Inn', 269, '2019-02-04', 259, NULL),
('Residence Inn', 269, '2019-02-05', 256, NULL),
('Residence Inn', 269, '2019-02-06', 252, NULL),
('Residence Inn', 269, '2019-02-07', 121, NULL),
('Residence Inn', 269, '2019-02-08', 206, NULL),
('Residence Inn', 269, '2019-02-09', 392, NULL),
('Residence Inn', 269, '2019-02-10', 246, NULL),
('Residence Inn', 269, '2019-02-11', 347, NULL),
('Residence Inn', 269, '2019-02-12', 108, NULL),
('Residence Inn', 269, '2019-02-13', 191, NULL),
('Residence Inn', 269, '2019-02-14', 226, NULL),
('Residence Inn', 269, '2019-02-15', 361, NULL),
('Residence Inn', 269, '2019-02-16', 124, NULL),
('Residence Inn', 269, '2019-02-17', 268, NULL),
('Residence Inn', 269, '2019-02-18', 206, NULL),
('Residence Inn', 269, '2019-02-19', 250, NULL),
('Residence Inn', 269, '2019-02-20', 330, NULL),
('Residence Inn', 269, '2019-02-21', 135, NULL),
('Residence Inn', 269, '2019-02-22', 245, NULL),
('Residence Inn', 269, '2019-02-23', 126, NULL),
('Residence Inn', 269, '2019-02-24', 382, NULL),
('Residence Inn', 269, '2019-02-25', 119, NULL),
('Residence Inn', 269, '2019-02-26', 349, NULL),
('Residence Inn', 269, '2019-02-27', 314, NULL),
('Residence Inn', 269, '2019-02-28', 236, NULL),
('Residence Inn', 269, '2019-03-01', 166, NULL),
('Residence Inn', 269, '2019-03-02', 292, NULL),
('Residence Inn', 269, '2019-03-03', 360, NULL),
('Residence Inn', 269, '2019-03-04', 298, NULL),
('Residence Inn', 269, '2019-03-05', 282, NULL),
('Residence Inn', 269, '2019-03-06', 152, NULL),
('Residence Inn', 269, '2019-03-07', 255, NULL),
('Residence Inn', 269, '2019-03-08', 160, NULL),
('Residence Inn', 269, '2019-03-09', 155, NULL),
('Residence Inn', 269, '2019-03-10', 291, NULL),
('Residence Inn', 269, '2019-03-11', 200, NULL),
('Residence Inn', 269, '2019-03-12', 213, NULL),
('Residence Inn', 269, '2019-03-13', 311, NULL),
('Residence Inn', 269, '2019-03-14', 147, NULL),
('Residence Inn', 269, '2019-03-15', 101, NULL),
('Residence Inn', 269, '2019-03-16', 270, NULL),
('Residence Inn', 269, '2019-03-17', 368, NULL),
('Residence Inn', 269, '2019-03-18', 201, NULL),
('Residence Inn', 269, '2019-03-19', 246, NULL),
('Residence Inn', 269, '2019-03-20', 109, NULL),
('Residence Inn', 269, '2019-03-21', 106, NULL),
('Residence Inn', 269, '2019-03-22', 328, NULL),
('Residence Inn', 269, '2019-03-23', 248, NULL),
('Residence Inn', 269, '2019-03-24', 237, NULL),
('Residence Inn', 269, '2019-03-25', 304, NULL),
('Residence Inn', 269, '2019-03-26', 214, NULL),
('Residence Inn', 269, '2019-03-27', 229, NULL),
('Residence Inn', 269, '2019-03-28', 104, NULL),
('Residence Inn', 269, '2019-03-29', 145, NULL),
('Residence Inn', 269, '2019-03-30', 206, NULL),
('Residence Inn', 269, '2019-03-31', 123, NULL),
('Residence Inn', 269, '2019-04-01', 372, NULL),
('Residence Inn', 269, '2019-04-02', 167, NULL),
('Residence Inn', 269, '2019-04-03', 390, NULL),
('Residence Inn', 269, '2019-04-04', 194, NULL),
('Residence Inn', 269, '2019-04-05', 202, NULL),
('Residence Inn', 269, '2019-04-06', 327, NULL),
('Residence Inn', 269, '2019-04-07', 159, NULL),
('Residence Inn', 269, '2019-04-08', 173, NULL),
('Residence Inn', 269, '2019-04-09', 269, NULL),
('Residence Inn', 269, '2019-04-10', 271, NULL),
('Residence Inn', 269, '2019-04-11', 167, NULL),
('Residence Inn', 269, '2019-04-12', 215, NULL),
('Residence Inn', 269, '2019-04-13', 180, NULL),
('Residence Inn', 269, '2019-04-14', 181, NULL),
('Residence Inn', 269, '2019-04-15', 333, NULL),
('Residence Inn', 269, '2019-04-16', 103, NULL),
('Residence Inn', 269, '2019-04-17', 350, NULL),
('Residence Inn', 269, '2019-04-18', 222, NULL),
('Residence Inn', 269, '2019-04-19', 328, NULL),
('Residence Inn', 269, '2019-04-20', 359, NULL),
('Residence Inn', 269, '2019-04-21', 356, NULL),
('Residence Inn', 269, '2019-04-22', 243, NULL),
('Residence Inn', 269, '2019-04-23', 330, NULL),
('Residence Inn', 269, '2019-04-24', 117, NULL),
('Residence Inn', 269, '2019-04-25', 298, NULL),
('Residence Inn', 269, '2019-04-26', 211, NULL),
('Residence Inn', 269, '2019-04-27', 257, NULL),
('Residence Inn', 269, '2019-04-28', 348, NULL),
('Residence Inn', 269, '2019-04-29', 242, NULL),
('Residence Inn', 269, '2019-04-30', 228, NULL),
('Residence Inn', 269, '2019-05-01', 325, NULL),
('Residence Inn', 269, '2019-05-02', 202, NULL),
('Residence Inn', 269, '2019-05-03', 293, NULL),
('Residence Inn', 269, '2019-05-04', 115, NULL),
('Residence Inn', 269, '2019-05-05', 274, NULL),
('Residence Inn', 269, '2019-05-06', 127, NULL),
('Residence Inn', 269, '2019-05-07', 245, NULL),
('Residence Inn', 269, '2019-05-08', 350, NULL),
('Residence Inn', 269, '2019-05-09', 104, NULL),
('Residence Inn', 269, '2019-05-10', 230, NULL),
('Residence Inn', 269, '2019-05-11', 147, NULL),
('Residence Inn', 269, '2019-05-12', 146, NULL),
('Residence Inn', 269, '2019-05-13', 234, NULL),
('Residence Inn', 269, '2019-05-14', 136, NULL),
('Residence Inn', 269, '2019-05-15', 188, NULL),
('Residence Inn', 269, '2019-05-16', 336, NULL),
('Residence Inn', 269, '2019-05-17', 284, NULL),
('Residence Inn', 269, '2019-05-18', 131, NULL),
('Residence Inn', 269, '2019-05-19', 337, NULL),
('Residence Inn', 269, '2019-05-20', 261, NULL),
('Residence Inn', 269, '2019-05-21', 364, NULL),
('Residence Inn', 269, '2019-05-22', 262, NULL),
('Residence Inn', 269, '2019-05-23', 224, NULL),
('Residence Inn', 269, '2019-05-24', 257, NULL),
('Residence Inn', 269, '2019-05-25', 240, NULL),
('Residence Inn', 269, '2019-05-26', 173, NULL),
('Residence Inn', 269, '2019-05-27', 295, NULL),
('Residence Inn', 269, '2019-05-28', 202, NULL),
('Residence Inn', 269, '2019-05-29', 276, NULL),
('Residence Inn', 269, '2019-05-30', 299, NULL),
('Residence Inn', 269, '2019-05-31', 333, NULL),
('Residence Inn', 269, '2019-06-01', 393, NULL),
('Residence Inn', 269, '2019-06-02', 116, NULL),
('Residence Inn', 269, '2019-06-03', 361, NULL),
('Residence Inn', 269, '2019-06-04', 338, NULL),
('Residence Inn', 269, '2019-06-05', 153, NULL),
('Residence Inn', 269, '2019-06-06', 329, NULL),
('Residence Inn', 269, '2019-06-07', 181, NULL),
('Residence Inn', 269, '2019-06-08', 126, NULL),
('Residence Inn', 269, '2019-06-09', 106, NULL),
('Residence Inn', 269, '2019-06-10', 116, NULL),
('Residence Inn', 269, '2019-06-11', 312, NULL),
('Residence Inn', 269, '2019-06-12', 281, NULL),
('Residence Inn', 269, '2019-06-13', 384, NULL),
('Residence Inn', 269, '2019-06-14', 384, NULL),
('Residence Inn', 269, '2019-06-15', 290, NULL),
('Residence Inn', 269, '2019-06-16', 186, NULL),
('Residence Inn', 269, '2019-06-17', 218, NULL),
('Residence Inn', 269, '2019-06-18', 160, NULL),
('Residence Inn', 269, '2019-06-19', 153, NULL),
('Residence Inn', 269, '2019-06-20', 188, NULL),
('Residence Inn', 269, '2019-06-21', 308, NULL),
('Residence Inn', 269, '2019-06-22', 193, NULL),
('Residence Inn', 269, '2019-06-23', 231, NULL),
('Residence Inn', 269, '2019-06-24', 321, NULL),
('Residence Inn', 269, '2019-06-25', 215, NULL),
('Residence Inn', 269, '2019-06-26', 151, NULL),
('Residence Inn', 269, '2019-06-27', 312, NULL),
('Residence Inn', 269, '2019-06-28', 108, NULL),
('Residence Inn', 269, '2019-06-29', 334, NULL),
('Residence Inn', 269, '2019-06-30', 350, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 269, '2019-07-01', 340, NULL),
('Residence Inn', 269, '2019-07-02', 265, NULL),
('Residence Inn', 269, '2019-07-03', 186, NULL),
('Residence Inn', 269, '2019-07-04', 311, NULL),
('Residence Inn', 269, '2019-07-05', 287, NULL),
('Residence Inn', 269, '2019-07-06', 361, NULL),
('Residence Inn', 269, '2019-07-07', 364, NULL),
('Residence Inn', 269, '2019-07-08', 281, NULL),
('Residence Inn', 269, '2019-07-09', 230, NULL),
('Residence Inn', 269, '2019-07-10', 198, NULL),
('Residence Inn', 269, '2019-07-11', 288, NULL),
('Residence Inn', 269, '2019-07-12', 125, NULL),
('Residence Inn', 269, '2019-07-13', 374, NULL),
('Residence Inn', 269, '2019-07-14', 242, NULL),
('Residence Inn', 269, '2019-07-15', 257, NULL),
('Residence Inn', 269, '2019-07-16', 150, NULL),
('Residence Inn', 269, '2019-07-17', 251, NULL),
('Residence Inn', 269, '2019-07-18', 299, NULL),
('Residence Inn', 269, '2019-07-19', 157, NULL),
('Residence Inn', 269, '2019-07-20', 178, NULL),
('Residence Inn', 269, '2019-07-21', 399, NULL),
('Residence Inn', 269, '2019-07-22', 301, NULL),
('Residence Inn', 269, '2019-07-23', 375, NULL),
('Residence Inn', 269, '2019-07-24', 119, NULL),
('Residence Inn', 269, '2019-07-25', 365, NULL),
('Residence Inn', 269, '2019-07-26', 223, NULL),
('Residence Inn', 269, '2019-07-27', 201, NULL),
('Residence Inn', 269, '2019-07-28', 318, NULL),
('Residence Inn', 269, '2019-07-29', 209, NULL),
('Residence Inn', 269, '2019-07-30', 386, NULL),
('Residence Inn', 269, '2019-07-31', 396, NULL),
('Residence Inn', 269, '2019-08-01', 160, NULL),
('Residence Inn', 269, '2019-08-02', 326, NULL),
('Residence Inn', 269, '2019-08-03', 284, NULL),
('Residence Inn', 269, '2019-08-04', 326, NULL),
('Residence Inn', 269, '2019-08-05', 348, NULL),
('Residence Inn', 269, '2019-08-06', 148, NULL),
('Residence Inn', 269, '2019-08-07', 321, NULL),
('Residence Inn', 269, '2019-08-08', 164, NULL),
('Residence Inn', 269, '2019-08-09', 253, NULL),
('Residence Inn', 269, '2019-08-10', 365, NULL),
('Residence Inn', 269, '2019-08-11', 179, NULL),
('Residence Inn', 269, '2019-08-12', 393, NULL),
('Residence Inn', 269, '2019-08-13', 369, NULL),
('Residence Inn', 269, '2019-08-14', 106, NULL),
('Residence Inn', 269, '2019-08-15', 215, NULL),
('Residence Inn', 269, '2019-08-16', 346, NULL),
('Residence Inn', 269, '2019-08-17', 118, NULL),
('Residence Inn', 269, '2019-08-18', 181, NULL),
('Residence Inn', 269, '2019-08-19', 145, NULL),
('Residence Inn', 269, '2019-08-20', 177, NULL),
('Residence Inn', 269, '2019-08-21', 379, NULL),
('Residence Inn', 269, '2019-08-22', 284, NULL),
('Residence Inn', 269, '2019-08-23', 154, NULL),
('Residence Inn', 269, '2019-08-24', 247, NULL),
('Residence Inn', 269, '2019-08-25', 209, NULL),
('Residence Inn', 269, '2019-08-26', 220, NULL),
('Residence Inn', 269, '2019-08-27', 234, NULL),
('Residence Inn', 269, '2019-08-28', 370, NULL),
('Residence Inn', 269, '2019-08-29', 210, NULL),
('Residence Inn', 269, '2019-08-30', 142, NULL),
('Residence Inn', 269, '2019-08-31', 368, NULL),
('Residence Inn', 269, '2019-09-01', 358, NULL),
('Residence Inn', 269, '2019-09-02', 145, NULL),
('Residence Inn', 269, '2019-09-03', 198, NULL),
('Residence Inn', 269, '2019-09-04', 341, NULL),
('Residence Inn', 269, '2019-09-05', 310, NULL),
('Residence Inn', 269, '2019-09-06', 123, NULL),
('Residence Inn', 269, '2019-09-07', 178, NULL),
('Residence Inn', 269, '2019-09-08', 205, NULL),
('Residence Inn', 269, '2019-09-09', 354, NULL),
('Residence Inn', 269, '2019-09-10', 380, NULL),
('Residence Inn', 269, '2019-09-11', 261, NULL),
('Residence Inn', 269, '2019-09-12', 157, NULL),
('Residence Inn', 269, '2019-09-13', 238, NULL),
('Residence Inn', 269, '2019-09-14', 220, NULL),
('Residence Inn', 269, '2019-09-15', 352, NULL),
('Residence Inn', 269, '2019-09-16', 117, NULL),
('Residence Inn', 269, '2019-09-17', 290, NULL),
('Residence Inn', 269, '2019-09-18', 191, NULL),
('Residence Inn', 269, '2019-09-19', 176, NULL),
('Residence Inn', 269, '2019-09-20', 285, NULL),
('Residence Inn', 269, '2019-09-21', 304, NULL),
('Residence Inn', 269, '2019-09-22', 214, NULL),
('Residence Inn', 269, '2019-09-23', 166, NULL),
('Residence Inn', 269, '2019-09-24', 287, NULL),
('Residence Inn', 269, '2019-09-25', 198, NULL),
('Residence Inn', 269, '2019-09-26', 234, NULL),
('Residence Inn', 269, '2019-09-27', 115, NULL),
('Residence Inn', 269, '2019-09-28', 395, NULL),
('Residence Inn', 269, '2019-09-29', 264, NULL),
('Residence Inn', 269, '2019-09-30', 128, NULL),
('Residence Inn', 269, '2019-10-01', 198, NULL),
('Residence Inn', 269, '2019-10-02', 259, NULL),
('Residence Inn', 269, '2019-10-03', 213, NULL),
('Residence Inn', 269, '2019-10-04', 189, NULL),
('Residence Inn', 269, '2019-10-05', 389, NULL),
('Residence Inn', 269, '2019-10-06', 114, NULL),
('Residence Inn', 269, '2019-10-07', 134, NULL),
('Residence Inn', 269, '2019-10-08', 368, NULL),
('Residence Inn', 269, '2019-10-09', 193, NULL),
('Residence Inn', 269, '2019-10-10', 177, NULL),
('Residence Inn', 269, '2019-10-11', 314, NULL),
('Residence Inn', 269, '2019-10-12', 208, NULL),
('Residence Inn', 269, '2019-10-13', 260, NULL),
('Residence Inn', 269, '2019-10-14', 149, NULL),
('Residence Inn', 269, '2019-10-15', 209, NULL),
('Residence Inn', 269, '2019-10-16', 396, NULL),
('Residence Inn', 269, '2019-10-17', 161, NULL),
('Residence Inn', 269, '2019-10-18', 286, NULL),
('Residence Inn', 269, '2019-10-19', 252, NULL),
('Residence Inn', 269, '2019-10-20', 104, NULL),
('Residence Inn', 269, '2019-10-21', 150, NULL),
('Residence Inn', 269, '2019-10-22', 254, NULL),
('Residence Inn', 269, '2019-10-23', 300, NULL),
('Residence Inn', 269, '2019-10-24', 271, NULL),
('Residence Inn', 269, '2019-10-25', 353, NULL),
('Residence Inn', 269, '2019-10-26', 256, NULL),
('Residence Inn', 269, '2019-10-27', 304, NULL),
('Residence Inn', 269, '2019-10-28', 330, NULL),
('Residence Inn', 269, '2019-10-29', 139, NULL),
('Residence Inn', 269, '2019-10-30', 364, NULL),
('Residence Inn', 269, '2019-10-31', 360, NULL),
('Residence Inn', 269, '2019-11-01', 261, NULL),
('Residence Inn', 269, '2019-11-02', 135, NULL),
('Residence Inn', 269, '2019-11-03', 287, NULL),
('Residence Inn', 269, '2019-11-04', 332, NULL),
('Residence Inn', 269, '2019-11-05', 354, NULL),
('Residence Inn', 269, '2019-11-06', 294, NULL),
('Residence Inn', 269, '2019-11-07', 201, NULL),
('Residence Inn', 269, '2019-11-08', 127, NULL),
('Residence Inn', 269, '2019-11-09', 327, NULL),
('Residence Inn', 269, '2019-11-10', 337, NULL),
('Residence Inn', 269, '2019-11-11', 397, NULL),
('Residence Inn', 269, '2019-11-12', 184, NULL),
('Residence Inn', 269, '2019-11-13', 275, NULL),
('Residence Inn', 269, '2019-11-14', 172, NULL),
('Residence Inn', 269, '2019-11-15', 313, NULL),
('Residence Inn', 269, '2019-11-16', 103, NULL),
('Residence Inn', 269, '2019-11-17', 349, NULL),
('Residence Inn', 269, '2019-11-18', 388, NULL),
('Residence Inn', 269, '2019-11-19', 107, NULL),
('Residence Inn', 269, '2019-11-20', 151, NULL),
('Residence Inn', 269, '2019-11-21', 112, NULL),
('Residence Inn', 269, '2019-11-22', 188, NULL),
('Residence Inn', 269, '2019-11-23', 168, NULL),
('Residence Inn', 269, '2019-11-24', 174, NULL),
('Residence Inn', 269, '2019-11-25', 364, NULL),
('Residence Inn', 269, '2019-11-26', 325, NULL),
('Residence Inn', 269, '2019-11-27', 129, NULL),
('Residence Inn', 269, '2019-11-28', 206, NULL),
('Residence Inn', 269, '2019-11-29', 121, NULL),
('Residence Inn', 269, '2019-11-30', 313, NULL),
('Residence Inn', 269, '2019-12-01', 196, NULL),
('Residence Inn', 269, '2019-12-02', 174, NULL),
('Residence Inn', 269, '2019-12-03', 309, NULL),
('Residence Inn', 269, '2019-12-04', 156, NULL),
('Residence Inn', 269, '2019-12-05', 388, NULL),
('Residence Inn', 269, '2019-12-06', 159, NULL),
('Residence Inn', 269, '2019-12-07', 331, NULL),
('Residence Inn', 269, '2019-12-08', 288, NULL),
('Residence Inn', 269, '2019-12-09', 233, NULL),
('Residence Inn', 269, '2019-12-10', 366, NULL),
('Residence Inn', 269, '2019-12-11', 354, NULL),
('Residence Inn', 269, '2019-12-12', 280, NULL),
('Residence Inn', 269, '2019-12-13', 128, NULL),
('Residence Inn', 269, '2019-12-14', 331, NULL),
('Residence Inn', 269, '2019-12-15', 301, NULL),
('Residence Inn', 269, '2019-12-16', 235, NULL),
('Residence Inn', 269, '2019-12-17', 139, NULL),
('Residence Inn', 269, '2019-12-18', 250, NULL),
('Residence Inn', 269, '2019-12-19', 133, NULL),
('Residence Inn', 269, '2019-12-20', 157, NULL),
('Residence Inn', 269, '2019-12-21', 371, NULL),
('Residence Inn', 269, '2019-12-22', 340, NULL),
('Residence Inn', 269, '2019-12-23', 214, NULL),
('Residence Inn', 269, '2019-12-24', 135, NULL),
('Residence Inn', 269, '2019-12-25', 378, NULL),
('Residence Inn', 269, '2019-12-26', 356, NULL),
('Residence Inn', 269, '2019-12-27', 317, NULL),
('Residence Inn', 269, '2019-12-28', 275, NULL),
('Residence Inn', 269, '2019-12-29', 396, NULL),
('Residence Inn', 269, '2019-12-30', 268, NULL),
('Residence Inn', 269, '2019-12-31', 383, NULL),
('Residence Inn', 269, '2020-01-01', 291, NULL),
('Residence Inn', 269, '2020-01-02', 210, NULL),
('Residence Inn', 269, '2020-01-03', 320, NULL),
('Residence Inn', 269, '2020-01-04', 211, NULL),
('Residence Inn', 269, '2020-01-05', 324, NULL),
('Residence Inn', 269, '2020-01-06', 231, NULL),
('Residence Inn', 269, '2020-01-07', 358, NULL),
('Residence Inn', 269, '2020-01-08', 266, NULL),
('Residence Inn', 269, '2020-01-09', 143, NULL),
('Residence Inn', 269, '2020-01-10', 148, NULL),
('Residence Inn', 269, '2020-01-11', 293, NULL),
('Residence Inn', 269, '2020-01-12', 167, NULL),
('Residence Inn', 269, '2020-01-13', 300, NULL),
('Residence Inn', 269, '2020-01-14', 310, NULL),
('Residence Inn', 269, '2020-01-15', 122, NULL),
('Residence Inn', 269, '2020-01-16', 144, NULL),
('Residence Inn', 269, '2020-01-17', 144, NULL),
('Residence Inn', 269, '2020-01-18', 168, NULL),
('Residence Inn', 269, '2020-01-19', 202, NULL),
('Residence Inn', 269, '2020-01-20', 301, NULL),
('Residence Inn', 269, '2020-01-21', 397, NULL),
('Residence Inn', 269, '2020-01-22', 288, NULL),
('Residence Inn', 269, '2020-01-23', 127, NULL),
('Residence Inn', 269, '2020-01-24', 237, NULL),
('Residence Inn', 269, '2020-01-25', 297, NULL),
('Residence Inn', 269, '2020-01-26', 120, NULL),
('Residence Inn', 269, '2020-01-27', 209, NULL),
('Residence Inn', 269, '2020-01-28', 175, NULL),
('Residence Inn', 269, '2020-01-29', 283, NULL),
('Residence Inn', 269, '2020-01-30', 272, NULL),
('Residence Inn', 269, '2020-01-31', 287, NULL),
('Residence Inn', 269, '2020-02-01', 308, NULL),
('Residence Inn', 269, '2020-02-02', 392, NULL),
('Residence Inn', 269, '2020-02-03', 197, NULL),
('Residence Inn', 269, '2020-02-04', 175, NULL),
('Residence Inn', 278, '2019-01-01', 387, NULL),
('Residence Inn', 278, '2019-01-02', 224, NULL),
('Residence Inn', 278, '2019-01-03', 214, NULL),
('Residence Inn', 278, '2019-01-04', 240, NULL),
('Residence Inn', 278, '2019-01-05', 298, NULL),
('Residence Inn', 278, '2019-01-06', 112, NULL),
('Residence Inn', 278, '2019-01-07', 184, NULL),
('Residence Inn', 278, '2019-01-08', 362, NULL),
('Residence Inn', 278, '2019-01-09', 120, NULL),
('Residence Inn', 278, '2019-01-10', 374, NULL),
('Residence Inn', 278, '2019-01-11', 332, NULL),
('Residence Inn', 278, '2019-01-12', 230, NULL),
('Residence Inn', 278, '2019-01-13', 204, NULL),
('Residence Inn', 278, '2019-01-14', 178, NULL),
('Residence Inn', 278, '2019-01-15', 195, NULL),
('Residence Inn', 278, '2019-01-16', 270, NULL),
('Residence Inn', 278, '2019-01-17', 346, NULL),
('Residence Inn', 278, '2019-01-18', 152, NULL),
('Residence Inn', 278, '2019-01-19', 166, NULL),
('Residence Inn', 278, '2019-01-20', 354, NULL),
('Residence Inn', 278, '2019-01-21', 363, NULL),
('Residence Inn', 278, '2019-01-22', 106, NULL),
('Residence Inn', 278, '2019-01-23', 227, NULL),
('Residence Inn', 278, '2019-01-24', 382, NULL),
('Residence Inn', 278, '2019-01-25', 184, NULL),
('Residence Inn', 278, '2019-01-26', 169, NULL),
('Residence Inn', 278, '2019-01-27', 103, NULL),
('Residence Inn', 278, '2019-01-28', 382, NULL),
('Residence Inn', 278, '2019-01-29', 381, NULL),
('Residence Inn', 278, '2019-01-30', 241, NULL),
('Residence Inn', 278, '2019-01-31', 271, NULL),
('Residence Inn', 278, '2019-02-01', 258, NULL),
('Residence Inn', 278, '2019-02-02', 348, NULL),
('Residence Inn', 278, '2019-02-03', 181, NULL),
('Residence Inn', 278, '2019-02-04', 316, NULL),
('Residence Inn', 278, '2019-02-05', 393, NULL),
('Residence Inn', 278, '2019-02-06', 329, NULL),
('Residence Inn', 278, '2019-02-07', 279, NULL),
('Residence Inn', 278, '2019-02-08', 279, NULL),
('Residence Inn', 278, '2019-02-09', 360, NULL),
('Residence Inn', 278, '2019-02-10', 164, NULL),
('Residence Inn', 278, '2019-02-11', 331, NULL),
('Residence Inn', 278, '2019-02-12', 353, NULL),
('Residence Inn', 278, '2019-02-13', 316, NULL),
('Residence Inn', 278, '2019-02-14', 280, NULL),
('Residence Inn', 278, '2019-02-15', 332, NULL),
('Residence Inn', 278, '2019-02-16', 120, NULL),
('Residence Inn', 278, '2019-02-17', 285, NULL),
('Residence Inn', 278, '2019-02-18', 240, NULL),
('Residence Inn', 278, '2019-02-19', 205, NULL),
('Residence Inn', 278, '2019-02-20', 162, NULL),
('Residence Inn', 278, '2019-02-21', 324, NULL),
('Residence Inn', 278, '2019-02-22', 360, NULL),
('Residence Inn', 278, '2019-02-23', 303, NULL),
('Residence Inn', 278, '2019-02-24', 283, NULL),
('Residence Inn', 278, '2019-02-25', 131, NULL),
('Residence Inn', 278, '2019-02-26', 389, NULL),
('Residence Inn', 278, '2019-02-27', 146, NULL),
('Residence Inn', 278, '2019-02-28', 118, NULL),
('Residence Inn', 278, '2019-03-01', 285, NULL),
('Residence Inn', 278, '2019-03-02', 227, NULL),
('Residence Inn', 278, '2019-03-03', 290, NULL),
('Residence Inn', 278, '2019-03-04', 235, NULL),
('Residence Inn', 278, '2019-03-05', 157, NULL),
('Residence Inn', 278, '2019-03-06', 325, NULL),
('Residence Inn', 278, '2019-03-07', 289, NULL),
('Residence Inn', 278, '2019-03-08', 295, NULL),
('Residence Inn', 278, '2019-03-09', 361, NULL),
('Residence Inn', 278, '2019-03-10', 127, NULL),
('Residence Inn', 278, '2019-03-11', 194, NULL),
('Residence Inn', 278, '2019-03-12', 340, NULL),
('Residence Inn', 278, '2019-03-13', 374, NULL),
('Residence Inn', 278, '2019-03-14', 175, NULL),
('Residence Inn', 278, '2019-03-15', 203, NULL),
('Residence Inn', 278, '2019-03-16', 398, NULL),
('Residence Inn', 278, '2019-03-17', 201, NULL),
('Residence Inn', 278, '2019-03-18', 163, NULL),
('Residence Inn', 278, '2019-03-19', 190, NULL),
('Residence Inn', 278, '2019-03-20', 248, NULL),
('Residence Inn', 278, '2019-03-21', 232, NULL),
('Residence Inn', 278, '2019-03-22', 328, NULL),
('Residence Inn', 278, '2019-03-23', 154, NULL),
('Residence Inn', 278, '2019-03-24', 169, NULL),
('Residence Inn', 278, '2019-03-25', 339, NULL),
('Residence Inn', 278, '2019-03-26', 177, NULL),
('Residence Inn', 278, '2019-03-27', 125, NULL),
('Residence Inn', 278, '2019-03-28', 284, NULL),
('Residence Inn', 278, '2019-03-29', 342, NULL),
('Residence Inn', 278, '2019-03-30', 305, NULL),
('Residence Inn', 278, '2019-03-31', 289, NULL),
('Residence Inn', 278, '2019-04-01', 273, NULL),
('Residence Inn', 278, '2019-04-02', 308, NULL),
('Residence Inn', 278, '2019-04-03', 270, NULL),
('Residence Inn', 278, '2019-04-04', 274, NULL),
('Residence Inn', 278, '2019-04-05', 124, NULL),
('Residence Inn', 278, '2019-04-06', 158, NULL),
('Residence Inn', 278, '2019-04-07', 216, NULL),
('Residence Inn', 278, '2019-04-08', 378, NULL),
('Residence Inn', 278, '2019-04-09', 253, NULL),
('Residence Inn', 278, '2019-04-10', 261, NULL),
('Residence Inn', 278, '2019-04-11', 227, NULL),
('Residence Inn', 278, '2019-04-12', 238, NULL),
('Residence Inn', 278, '2019-04-13', 339, NULL),
('Residence Inn', 278, '2019-04-14', 101, NULL),
('Residence Inn', 278, '2019-04-15', 135, NULL),
('Residence Inn', 278, '2019-04-16', 248, NULL),
('Residence Inn', 278, '2019-04-17', 310, NULL),
('Residence Inn', 278, '2019-04-18', 170, NULL),
('Residence Inn', 278, '2019-04-19', 324, NULL),
('Residence Inn', 278, '2019-04-20', 368, NULL),
('Residence Inn', 278, '2019-04-21', 243, NULL),
('Residence Inn', 278, '2019-04-22', 199, NULL),
('Residence Inn', 278, '2019-04-23', 264, NULL),
('Residence Inn', 278, '2019-04-24', 204, NULL),
('Residence Inn', 278, '2019-04-25', 372, NULL),
('Residence Inn', 278, '2019-04-26', 392, NULL),
('Residence Inn', 278, '2019-04-27', 224, NULL),
('Residence Inn', 278, '2019-04-28', 279, NULL),
('Residence Inn', 278, '2019-04-29', 360, NULL),
('Residence Inn', 278, '2019-04-30', 382, NULL),
('Residence Inn', 278, '2019-05-01', 245, NULL),
('Residence Inn', 278, '2019-05-02', 110, NULL),
('Residence Inn', 278, '2019-05-03', 368, NULL),
('Residence Inn', 278, '2019-05-04', 386, NULL),
('Residence Inn', 278, '2019-05-05', 145, NULL),
('Residence Inn', 278, '2019-05-06', 228, NULL),
('Residence Inn', 278, '2019-05-07', 179, NULL),
('Residence Inn', 278, '2019-05-08', 293, NULL),
('Residence Inn', 278, '2019-05-09', 117, NULL),
('Residence Inn', 278, '2019-05-10', 287, NULL),
('Residence Inn', 278, '2019-05-11', 313, NULL),
('Residence Inn', 278, '2019-05-12', 107, NULL),
('Residence Inn', 278, '2019-05-13', 314, NULL),
('Residence Inn', 278, '2019-05-14', 302, NULL),
('Residence Inn', 278, '2019-05-15', 101, NULL),
('Residence Inn', 278, '2019-05-16', 167, NULL),
('Residence Inn', 278, '2019-05-17', 108, NULL),
('Residence Inn', 278, '2019-05-18', 305, NULL),
('Residence Inn', 278, '2019-05-19', 386, NULL),
('Residence Inn', 278, '2019-05-20', 395, NULL),
('Residence Inn', 278, '2019-05-21', 221, NULL),
('Residence Inn', 278, '2019-05-22', 110, NULL),
('Residence Inn', 278, '2019-05-23', 331, NULL),
('Residence Inn', 278, '2019-05-24', 172, NULL),
('Residence Inn', 278, '2019-05-25', 190, NULL),
('Residence Inn', 278, '2019-05-26', 345, NULL),
('Residence Inn', 278, '2019-05-27', 273, NULL),
('Residence Inn', 278, '2019-05-28', 110, NULL),
('Residence Inn', 278, '2019-05-29', 157, NULL),
('Residence Inn', 278, '2019-05-30', 123, NULL),
('Residence Inn', 278, '2019-05-31', 242, NULL),
('Residence Inn', 278, '2019-06-01', 245, NULL),
('Residence Inn', 278, '2019-06-02', 276, NULL),
('Residence Inn', 278, '2019-06-03', 315, NULL),
('Residence Inn', 278, '2019-06-04', 301, NULL),
('Residence Inn', 278, '2019-06-05', 249, NULL),
('Residence Inn', 278, '2019-06-06', 358, NULL),
('Residence Inn', 278, '2019-06-07', 186, NULL),
('Residence Inn', 278, '2019-06-08', 249, NULL),
('Residence Inn', 278, '2019-06-09', 282, NULL),
('Residence Inn', 278, '2019-06-10', 186, NULL),
('Residence Inn', 278, '2019-06-11', 366, NULL),
('Residence Inn', 278, '2019-06-12', 348, NULL),
('Residence Inn', 278, '2019-06-13', 138, NULL),
('Residence Inn', 278, '2019-06-14', 111, NULL),
('Residence Inn', 278, '2019-06-15', 296, NULL),
('Residence Inn', 278, '2019-06-16', 325, NULL),
('Residence Inn', 278, '2019-06-17', 173, NULL),
('Residence Inn', 278, '2019-06-18', 187, NULL),
('Residence Inn', 278, '2019-06-19', 140, NULL),
('Residence Inn', 278, '2019-06-20', 214, NULL),
('Residence Inn', 278, '2019-06-21', 237, NULL),
('Residence Inn', 278, '2019-06-22', 175, NULL),
('Residence Inn', 278, '2019-06-23', 244, NULL),
('Residence Inn', 278, '2019-06-24', 261, NULL),
('Residence Inn', 278, '2019-06-25', 304, NULL),
('Residence Inn', 278, '2019-06-26', 332, NULL),
('Residence Inn', 278, '2019-06-27', 112, NULL),
('Residence Inn', 278, '2019-06-28', 186, NULL),
('Residence Inn', 278, '2019-06-29', 143, NULL),
('Residence Inn', 278, '2019-06-30', 305, NULL),
('Residence Inn', 278, '2019-07-01', 237, NULL),
('Residence Inn', 278, '2019-07-02', 172, NULL),
('Residence Inn', 278, '2019-07-03', 208, NULL),
('Residence Inn', 278, '2019-07-04', 100, NULL),
('Residence Inn', 278, '2019-07-05', 240, NULL),
('Residence Inn', 278, '2019-07-06', 274, NULL),
('Residence Inn', 278, '2019-07-07', 165, NULL),
('Residence Inn', 278, '2019-07-08', 370, NULL),
('Residence Inn', 278, '2019-07-09', 253, NULL),
('Residence Inn', 278, '2019-07-10', 103, NULL),
('Residence Inn', 278, '2019-07-11', 145, NULL),
('Residence Inn', 278, '2019-07-12', 134, NULL),
('Residence Inn', 278, '2019-07-13', 333, NULL),
('Residence Inn', 278, '2019-07-14', 373, NULL),
('Residence Inn', 278, '2019-07-15', 320, NULL),
('Residence Inn', 278, '2019-07-16', 370, NULL),
('Residence Inn', 278, '2019-07-17', 235, NULL),
('Residence Inn', 278, '2019-07-18', 296, NULL),
('Residence Inn', 278, '2019-07-19', 350, NULL),
('Residence Inn', 278, '2019-07-20', 208, NULL),
('Residence Inn', 278, '2019-07-21', 202, NULL),
('Residence Inn', 278, '2019-07-22', 323, NULL),
('Residence Inn', 278, '2019-07-23', 232, NULL),
('Residence Inn', 278, '2019-07-24', 391, NULL),
('Residence Inn', 278, '2019-07-25', 376, NULL),
('Residence Inn', 278, '2019-07-26', 126, NULL),
('Residence Inn', 278, '2019-07-27', 358, NULL),
('Residence Inn', 278, '2019-07-28', 365, NULL),
('Residence Inn', 278, '2019-07-29', 317, NULL),
('Residence Inn', 278, '2019-07-30', 342, NULL),
('Residence Inn', 278, '2019-07-31', 351, NULL),
('Residence Inn', 278, '2019-08-01', 373, NULL),
('Residence Inn', 278, '2019-08-02', 259, NULL),
('Residence Inn', 278, '2019-08-03', 272, NULL),
('Residence Inn', 278, '2019-08-04', 385, NULL),
('Residence Inn', 278, '2019-08-05', 225, NULL),
('Residence Inn', 278, '2019-08-06', 395, NULL),
('Residence Inn', 278, '2019-08-07', 357, NULL),
('Residence Inn', 278, '2019-08-08', 349, NULL),
('Residence Inn', 278, '2019-08-09', 292, NULL),
('Residence Inn', 278, '2019-08-10', 178, NULL),
('Residence Inn', 278, '2019-08-11', 226, NULL),
('Residence Inn', 278, '2019-08-12', 133, NULL),
('Residence Inn', 278, '2019-08-13', 397, NULL),
('Residence Inn', 278, '2019-08-14', 163, NULL),
('Residence Inn', 278, '2019-08-15', 153, NULL),
('Residence Inn', 278, '2019-08-16', 326, NULL),
('Residence Inn', 278, '2019-08-17', 133, NULL),
('Residence Inn', 278, '2019-08-18', 245, NULL),
('Residence Inn', 278, '2019-08-19', 194, NULL),
('Residence Inn', 278, '2019-08-20', 281, NULL),
('Residence Inn', 278, '2019-08-21', 333, NULL),
('Residence Inn', 278, '2019-08-22', 300, NULL),
('Residence Inn', 278, '2019-08-23', 269, NULL),
('Residence Inn', 278, '2019-08-24', 389, NULL),
('Residence Inn', 278, '2019-08-25', 272, NULL),
('Residence Inn', 278, '2019-08-26', 242, NULL),
('Residence Inn', 278, '2019-08-27', 398, NULL),
('Residence Inn', 278, '2019-08-28', 201, NULL),
('Residence Inn', 278, '2019-08-29', 323, NULL),
('Residence Inn', 278, '2019-08-30', 183, NULL),
('Residence Inn', 278, '2019-08-31', 111, NULL),
('Residence Inn', 278, '2019-09-01', 379, NULL),
('Residence Inn', 278, '2019-09-02', 305, NULL),
('Residence Inn', 278, '2019-09-03', 311, NULL),
('Residence Inn', 278, '2019-09-04', 180, NULL),
('Residence Inn', 278, '2019-09-05', 380, NULL),
('Residence Inn', 278, '2019-09-06', 378, NULL),
('Residence Inn', 278, '2019-09-07', 232, NULL),
('Residence Inn', 278, '2019-09-08', 294, NULL),
('Residence Inn', 278, '2019-09-09', 198, NULL),
('Residence Inn', 278, '2019-09-10', 167, NULL),
('Residence Inn', 278, '2019-09-11', 239, NULL),
('Residence Inn', 278, '2019-09-12', 176, NULL),
('Residence Inn', 278, '2019-09-13', 271, NULL),
('Residence Inn', 278, '2019-09-14', 259, NULL),
('Residence Inn', 278, '2019-09-15', 323, NULL),
('Residence Inn', 278, '2019-09-16', 313, NULL),
('Residence Inn', 278, '2019-09-17', 138, NULL),
('Residence Inn', 278, '2019-09-18', 314, NULL),
('Residence Inn', 278, '2019-09-19', 241, NULL),
('Residence Inn', 278, '2019-09-20', 364, NULL),
('Residence Inn', 278, '2019-09-21', 346, NULL),
('Residence Inn', 278, '2019-09-22', 115, NULL),
('Residence Inn', 278, '2019-09-23', 158, NULL),
('Residence Inn', 278, '2019-09-24', 226, NULL),
('Residence Inn', 278, '2019-09-25', 302, NULL),
('Residence Inn', 278, '2019-09-26', 333, NULL),
('Residence Inn', 278, '2019-09-27', 320, NULL),
('Residence Inn', 278, '2019-09-28', 280, NULL),
('Residence Inn', 278, '2019-09-29', 150, NULL),
('Residence Inn', 278, '2019-09-30', 208, NULL),
('Residence Inn', 278, '2019-10-01', 144, NULL),
('Residence Inn', 278, '2019-10-02', 299, NULL),
('Residence Inn', 278, '2019-10-03', 299, NULL),
('Residence Inn', 278, '2019-10-04', 275, NULL),
('Residence Inn', 278, '2019-10-05', 229, NULL),
('Residence Inn', 278, '2019-10-06', 258, NULL),
('Residence Inn', 278, '2019-10-07', 167, NULL),
('Residence Inn', 278, '2019-10-08', 208, NULL),
('Residence Inn', 278, '2019-10-09', 252, NULL),
('Residence Inn', 278, '2019-10-10', 349, NULL),
('Residence Inn', 278, '2019-10-11', 254, NULL),
('Residence Inn', 278, '2019-10-12', 251, NULL),
('Residence Inn', 278, '2019-10-13', 386, NULL),
('Residence Inn', 278, '2019-10-14', 160, NULL),
('Residence Inn', 278, '2019-10-15', 306, NULL),
('Residence Inn', 278, '2019-10-16', 260, NULL),
('Residence Inn', 278, '2019-10-17', 364, NULL),
('Residence Inn', 278, '2019-10-18', 287, NULL),
('Residence Inn', 278, '2019-10-19', 206, NULL),
('Residence Inn', 278, '2019-10-20', 243, NULL),
('Residence Inn', 278, '2019-10-21', 388, NULL),
('Residence Inn', 278, '2019-10-22', 117, NULL),
('Residence Inn', 278, '2019-10-23', 388, NULL),
('Residence Inn', 278, '2019-10-24', 252, NULL),
('Residence Inn', 278, '2019-10-25', 139, NULL),
('Residence Inn', 278, '2019-10-26', 304, NULL),
('Residence Inn', 278, '2019-10-27', 188, NULL),
('Residence Inn', 278, '2019-10-28', 379, NULL),
('Residence Inn', 278, '2019-10-29', 251, NULL),
('Residence Inn', 278, '2019-10-30', 399, NULL),
('Residence Inn', 278, '2019-10-31', 124, NULL),
('Residence Inn', 278, '2019-11-01', 101, NULL),
('Residence Inn', 278, '2019-11-02', 222, NULL),
('Residence Inn', 278, '2019-11-03', 377, NULL),
('Residence Inn', 278, '2019-11-04', 184, NULL),
('Residence Inn', 278, '2019-11-05', 340, NULL),
('Residence Inn', 278, '2019-11-06', 106, NULL),
('Residence Inn', 278, '2019-11-07', 108, NULL),
('Residence Inn', 278, '2019-11-08', 309, NULL),
('Residence Inn', 278, '2019-11-09', 176, NULL),
('Residence Inn', 278, '2019-11-10', 334, NULL),
('Residence Inn', 278, '2019-11-11', 391, NULL),
('Residence Inn', 278, '2019-11-12', 303, NULL),
('Residence Inn', 278, '2019-11-13', 381, NULL),
('Residence Inn', 278, '2019-11-14', 374, NULL),
('Residence Inn', 278, '2019-11-15', 121, NULL),
('Residence Inn', 278, '2019-11-16', 117, NULL),
('Residence Inn', 278, '2019-11-17', 353, NULL),
('Residence Inn', 278, '2019-11-18', 245, NULL),
('Residence Inn', 278, '2019-11-19', 345, NULL),
('Residence Inn', 278, '2019-11-20', 195, NULL),
('Residence Inn', 278, '2019-11-21', 253, NULL),
('Residence Inn', 278, '2019-11-22', 294, NULL),
('Residence Inn', 278, '2019-11-23', 244, NULL),
('Residence Inn', 278, '2019-11-24', 369, NULL),
('Residence Inn', 278, '2019-11-25', 164, NULL),
('Residence Inn', 278, '2019-11-26', 298, NULL),
('Residence Inn', 278, '2019-11-27', 318, NULL),
('Residence Inn', 278, '2019-11-28', 271, NULL),
('Residence Inn', 278, '2019-11-29', 339, NULL),
('Residence Inn', 278, '2019-11-30', 174, NULL),
('Residence Inn', 278, '2019-12-01', 185, NULL),
('Residence Inn', 278, '2019-12-02', 154, NULL),
('Residence Inn', 278, '2019-12-03', 151, NULL),
('Residence Inn', 278, '2019-12-04', 169, NULL),
('Residence Inn', 278, '2019-12-05', 268, NULL),
('Residence Inn', 278, '2019-12-06', 143, NULL),
('Residence Inn', 278, '2019-12-07', 301, NULL),
('Residence Inn', 278, '2019-12-08', 329, NULL),
('Residence Inn', 278, '2019-12-09', 232, NULL),
('Residence Inn', 278, '2019-12-10', 264, NULL),
('Residence Inn', 278, '2019-12-11', 339, NULL),
('Residence Inn', 278, '2019-12-12', 190, NULL),
('Residence Inn', 278, '2019-12-13', 305, NULL),
('Residence Inn', 278, '2019-12-14', 187, NULL),
('Residence Inn', 278, '2019-12-15', 392, NULL),
('Residence Inn', 278, '2019-12-16', 256, NULL),
('Residence Inn', 278, '2019-12-17', 221, NULL),
('Residence Inn', 278, '2019-12-18', 121, NULL),
('Residence Inn', 278, '2019-12-19', 308, NULL),
('Residence Inn', 278, '2019-12-20', 327, NULL),
('Residence Inn', 278, '2019-12-21', 328, NULL),
('Residence Inn', 278, '2019-12-22', 382, NULL),
('Residence Inn', 278, '2019-12-23', 274, NULL),
('Residence Inn', 278, '2019-12-24', 118, NULL),
('Residence Inn', 278, '2019-12-25', 380, NULL),
('Residence Inn', 278, '2019-12-26', 281, NULL),
('Residence Inn', 278, '2019-12-27', 112, NULL),
('Residence Inn', 278, '2019-12-28', 259, NULL),
('Residence Inn', 278, '2019-12-29', 129, NULL),
('Residence Inn', 278, '2019-12-30', 377, NULL),
('Residence Inn', 278, '2019-12-31', 191, NULL),
('Residence Inn', 278, '2020-01-01', 299, NULL),
('Residence Inn', 278, '2020-01-02', 325, NULL),
('Residence Inn', 278, '2020-01-03', 299, NULL),
('Residence Inn', 278, '2020-01-04', 106, NULL),
('Residence Inn', 278, '2020-01-05', 391, NULL),
('Residence Inn', 278, '2020-01-06', 231, NULL),
('Residence Inn', 278, '2020-01-07', 281, NULL),
('Residence Inn', 278, '2020-01-08', 163, NULL),
('Residence Inn', 278, '2020-01-09', 333, NULL),
('Residence Inn', 278, '2020-01-10', 259, NULL),
('Residence Inn', 278, '2020-01-11', 237, NULL),
('Residence Inn', 278, '2020-01-12', 388, NULL),
('Residence Inn', 278, '2020-01-13', 235, NULL),
('Residence Inn', 278, '2020-01-14', 155, NULL),
('Residence Inn', 278, '2020-01-15', 399, NULL),
('Residence Inn', 278, '2020-01-16', 327, NULL),
('Residence Inn', 278, '2020-01-17', 387, NULL),
('Residence Inn', 278, '2020-01-18', 311, NULL),
('Residence Inn', 278, '2020-01-19', 135, NULL),
('Residence Inn', 278, '2020-01-20', 294, NULL),
('Residence Inn', 278, '2020-01-21', 253, NULL),
('Residence Inn', 278, '2020-01-22', 125, NULL),
('Residence Inn', 278, '2020-01-23', 233, NULL),
('Residence Inn', 278, '2020-01-24', 311, NULL),
('Residence Inn', 278, '2020-01-25', 353, NULL),
('Residence Inn', 278, '2020-01-26', 242, NULL),
('Residence Inn', 278, '2020-01-27', 256, NULL),
('Residence Inn', 278, '2020-01-28', 107, NULL),
('Residence Inn', 278, '2020-01-29', 223, NULL),
('Residence Inn', 278, '2020-01-30', 263, NULL),
('Residence Inn', 278, '2020-01-31', 350, NULL),
('Residence Inn', 278, '2020-02-01', 221, NULL),
('Residence Inn', 278, '2020-02-02', 115, NULL),
('Residence Inn', 278, '2020-02-03', 158, NULL),
('Residence Inn', 278, '2020-02-04', 212, NULL),
('Residence Inn', 285, '2019-01-01', 153, NULL),
('Residence Inn', 285, '2019-01-02', 236, NULL),
('Residence Inn', 285, '2019-01-03', 175, NULL),
('Residence Inn', 285, '2019-01-04', 143, NULL),
('Residence Inn', 285, '2019-01-05', 121, NULL),
('Residence Inn', 285, '2019-01-06', 167, NULL),
('Residence Inn', 285, '2019-01-07', 342, NULL),
('Residence Inn', 285, '2019-01-08', 352, NULL),
('Residence Inn', 285, '2019-01-09', 282, NULL),
('Residence Inn', 285, '2019-01-10', 192, NULL),
('Residence Inn', 285, '2019-01-11', 384, NULL),
('Residence Inn', 285, '2019-01-12', 385, NULL),
('Residence Inn', 285, '2019-01-13', 222, NULL),
('Residence Inn', 285, '2019-01-14', 191, NULL),
('Residence Inn', 285, '2019-01-15', 183, NULL),
('Residence Inn', 285, '2019-01-16', 371, NULL),
('Residence Inn', 285, '2019-01-17', 294, NULL),
('Residence Inn', 285, '2019-01-18', 231, NULL),
('Residence Inn', 285, '2019-01-19', 386, NULL),
('Residence Inn', 285, '2019-01-20', 307, NULL),
('Residence Inn', 285, '2019-01-21', 108, NULL),
('Residence Inn', 285, '2019-01-22', 103, NULL),
('Residence Inn', 285, '2019-01-23', 296, NULL),
('Residence Inn', 285, '2019-01-24', 169, NULL),
('Residence Inn', 285, '2019-01-25', 361, NULL),
('Residence Inn', 285, '2019-01-26', 163, NULL),
('Residence Inn', 285, '2019-01-27', 270, NULL),
('Residence Inn', 285, '2019-01-28', 384, NULL),
('Residence Inn', 285, '2019-01-29', 305, NULL),
('Residence Inn', 285, '2019-01-30', 292, NULL),
('Residence Inn', 285, '2019-01-31', 331, NULL),
('Residence Inn', 285, '2019-02-01', 204, NULL),
('Residence Inn', 285, '2019-02-02', 345, NULL),
('Residence Inn', 285, '2019-02-03', 299, NULL),
('Residence Inn', 285, '2019-02-04', 102, NULL),
('Residence Inn', 285, '2019-02-05', 196, NULL),
('Residence Inn', 285, '2019-02-06', 192, NULL),
('Residence Inn', 285, '2019-02-07', 334, NULL),
('Residence Inn', 285, '2019-02-08', 379, NULL),
('Residence Inn', 285, '2019-02-09', 223, NULL),
('Residence Inn', 285, '2019-02-10', 281, NULL),
('Residence Inn', 285, '2019-02-11', 214, NULL),
('Residence Inn', 285, '2019-02-12', 139, NULL),
('Residence Inn', 285, '2019-02-13', 305, NULL),
('Residence Inn', 285, '2019-02-14', 320, NULL),
('Residence Inn', 285, '2019-02-15', 174, NULL),
('Residence Inn', 285, '2019-02-16', 126, NULL),
('Residence Inn', 285, '2019-02-17', 221, NULL),
('Residence Inn', 285, '2019-02-18', 182, NULL),
('Residence Inn', 285, '2019-02-19', 178, NULL),
('Residence Inn', 285, '2019-02-20', 319, NULL),
('Residence Inn', 285, '2019-02-21', 217, NULL),
('Residence Inn', 285, '2019-02-22', 364, NULL),
('Residence Inn', 285, '2019-02-23', 141, NULL),
('Residence Inn', 285, '2019-02-24', 169, NULL),
('Residence Inn', 285, '2019-02-25', 199, NULL),
('Residence Inn', 285, '2019-02-26', 197, NULL),
('Residence Inn', 285, '2019-02-27', 291, NULL),
('Residence Inn', 285, '2019-02-28', 385, NULL),
('Residence Inn', 285, '2019-03-01', 229, NULL),
('Residence Inn', 285, '2019-03-02', 158, NULL),
('Residence Inn', 285, '2019-03-03', 269, NULL),
('Residence Inn', 285, '2019-03-04', 182, NULL),
('Residence Inn', 285, '2019-03-05', 143, NULL),
('Residence Inn', 285, '2019-03-06', 173, NULL),
('Residence Inn', 285, '2019-03-07', 279, NULL),
('Residence Inn', 285, '2019-03-08', 293, NULL),
('Residence Inn', 285, '2019-03-09', 338, NULL),
('Residence Inn', 285, '2019-03-10', 263, NULL),
('Residence Inn', 285, '2019-03-11', 271, NULL),
('Residence Inn', 285, '2019-03-12', 363, NULL),
('Residence Inn', 285, '2019-03-13', 238, NULL),
('Residence Inn', 285, '2019-03-14', 335, NULL),
('Residence Inn', 285, '2019-03-15', 311, NULL),
('Residence Inn', 285, '2019-03-16', 183, NULL),
('Residence Inn', 285, '2019-03-17', 101, NULL),
('Residence Inn', 285, '2019-03-18', 111, NULL),
('Residence Inn', 285, '2019-03-19', 111, NULL),
('Residence Inn', 285, '2019-03-20', 215, NULL),
('Residence Inn', 285, '2019-03-21', 142, NULL),
('Residence Inn', 285, '2019-03-22', 258, NULL),
('Residence Inn', 285, '2019-03-23', 227, NULL),
('Residence Inn', 285, '2019-03-24', 337, NULL),
('Residence Inn', 285, '2019-03-25', 384, NULL),
('Residence Inn', 285, '2019-03-26', 144, NULL),
('Residence Inn', 285, '2019-03-27', 138, NULL),
('Residence Inn', 285, '2019-03-28', 108, NULL),
('Residence Inn', 285, '2019-03-29', 274, NULL),
('Residence Inn', 285, '2019-03-30', 205, NULL),
('Residence Inn', 285, '2019-03-31', 378, NULL),
('Residence Inn', 285, '2019-04-01', 149, NULL),
('Residence Inn', 285, '2019-04-02', 342, NULL),
('Residence Inn', 285, '2019-04-03', 381, NULL),
('Residence Inn', 285, '2019-04-04', 391, NULL),
('Residence Inn', 285, '2019-04-05', 212, NULL),
('Residence Inn', 285, '2019-04-06', 309, NULL),
('Residence Inn', 285, '2019-04-07', 200, NULL),
('Residence Inn', 285, '2019-04-08', 375, NULL),
('Residence Inn', 285, '2019-04-09', 359, NULL),
('Residence Inn', 285, '2019-04-10', 393, NULL),
('Residence Inn', 285, '2019-04-11', 233, NULL),
('Residence Inn', 285, '2019-04-12', 143, NULL),
('Residence Inn', 285, '2019-04-13', 155, NULL),
('Residence Inn', 285, '2019-04-14', 164, NULL),
('Residence Inn', 285, '2019-04-15', 175, NULL),
('Residence Inn', 285, '2019-04-16', 231, NULL),
('Residence Inn', 285, '2019-04-17', 101, NULL),
('Residence Inn', 285, '2019-04-18', 385, NULL),
('Residence Inn', 285, '2019-04-19', 238, NULL),
('Residence Inn', 285, '2019-04-20', 362, NULL),
('Residence Inn', 285, '2019-04-21', 347, NULL),
('Residence Inn', 285, '2019-04-22', 166, NULL),
('Residence Inn', 285, '2019-04-23', 233, NULL),
('Residence Inn', 285, '2019-04-24', 269, NULL),
('Residence Inn', 285, '2019-04-25', 268, NULL),
('Residence Inn', 285, '2019-04-26', 324, NULL),
('Residence Inn', 285, '2019-04-27', 246, NULL),
('Residence Inn', 285, '2019-04-28', 248, NULL),
('Residence Inn', 285, '2019-04-29', 375, NULL),
('Residence Inn', 285, '2019-04-30', 226, NULL),
('Residence Inn', 285, '2019-05-01', 148, NULL),
('Residence Inn', 285, '2019-05-02', 145, NULL),
('Residence Inn', 285, '2019-05-03', 263, NULL),
('Residence Inn', 285, '2019-05-04', 286, NULL),
('Residence Inn', 285, '2019-05-05', 101, NULL),
('Residence Inn', 285, '2019-05-06', 359, NULL),
('Residence Inn', 285, '2019-05-07', 361, NULL),
('Residence Inn', 285, '2019-05-08', 317, NULL),
('Residence Inn', 285, '2019-05-09', 175, NULL),
('Residence Inn', 285, '2019-05-10', 344, NULL),
('Residence Inn', 285, '2019-05-11', 124, NULL),
('Residence Inn', 285, '2019-05-12', 296, NULL),
('Residence Inn', 285, '2019-05-13', 169, NULL),
('Residence Inn', 285, '2019-05-14', 102, NULL),
('Residence Inn', 285, '2019-05-15', 143, NULL),
('Residence Inn', 285, '2019-05-16', 325, NULL),
('Residence Inn', 285, '2019-05-17', 188, NULL),
('Residence Inn', 285, '2019-05-18', 134, NULL),
('Residence Inn', 285, '2019-05-19', 221, NULL),
('Residence Inn', 285, '2019-05-20', 192, NULL),
('Residence Inn', 285, '2019-05-21', 214, NULL),
('Residence Inn', 285, '2019-05-22', 265, NULL),
('Residence Inn', 285, '2019-05-23', 286, NULL),
('Residence Inn', 285, '2019-05-24', 290, NULL),
('Residence Inn', 285, '2019-05-25', 129, NULL),
('Residence Inn', 285, '2019-05-26', 207, NULL),
('Residence Inn', 285, '2019-05-27', 381, NULL),
('Residence Inn', 285, '2019-05-28', 147, NULL),
('Residence Inn', 285, '2019-05-29', 157, NULL),
('Residence Inn', 285, '2019-05-30', 220, NULL),
('Residence Inn', 285, '2019-05-31', 110, NULL),
('Residence Inn', 285, '2019-06-01', 243, NULL),
('Residence Inn', 285, '2019-06-02', 329, NULL),
('Residence Inn', 285, '2019-06-03', 394, NULL),
('Residence Inn', 285, '2019-06-04', 393, NULL),
('Residence Inn', 285, '2019-06-05', 385, NULL),
('Residence Inn', 285, '2019-06-06', 101, NULL),
('Residence Inn', 285, '2019-06-07', 289, NULL),
('Residence Inn', 285, '2019-06-08', 168, NULL),
('Residence Inn', 285, '2019-06-09', 393, NULL),
('Residence Inn', 285, '2019-06-10', 180, NULL),
('Residence Inn', 285, '2019-06-11', 194, NULL),
('Residence Inn', 285, '2019-06-12', 196, NULL),
('Residence Inn', 285, '2019-06-13', 338, NULL),
('Residence Inn', 285, '2019-06-14', 201, NULL),
('Residence Inn', 285, '2019-06-15', 209, NULL),
('Residence Inn', 285, '2019-06-16', 367, NULL),
('Residence Inn', 285, '2019-06-17', 113, NULL),
('Residence Inn', 285, '2019-06-18', 358, NULL),
('Residence Inn', 285, '2019-06-19', 141, NULL),
('Residence Inn', 285, '2019-06-20', 108, NULL),
('Residence Inn', 285, '2019-06-21', 159, NULL),
('Residence Inn', 285, '2019-06-22', 194, NULL),
('Residence Inn', 285, '2019-06-23', 128, NULL),
('Residence Inn', 285, '2019-06-24', 240, NULL),
('Residence Inn', 285, '2019-06-25', 178, NULL),
('Residence Inn', 285, '2019-06-26', 209, NULL),
('Residence Inn', 285, '2019-06-27', 127, NULL),
('Residence Inn', 285, '2019-06-28', 207, NULL),
('Residence Inn', 285, '2019-06-29', 214, NULL),
('Residence Inn', 285, '2019-06-30', 377, NULL),
('Residence Inn', 285, '2019-07-01', 366, NULL),
('Residence Inn', 285, '2019-07-02', 267, NULL),
('Residence Inn', 285, '2019-07-03', 385, NULL),
('Residence Inn', 285, '2019-07-04', 366, NULL),
('Residence Inn', 285, '2019-07-05', 240, NULL),
('Residence Inn', 285, '2019-07-06', 191, NULL),
('Residence Inn', 285, '2019-07-07', 233, NULL),
('Residence Inn', 285, '2019-07-08', 305, NULL),
('Residence Inn', 285, '2019-07-09', 176, NULL),
('Residence Inn', 285, '2019-07-10', 122, NULL),
('Residence Inn', 285, '2019-07-11', 362, NULL),
('Residence Inn', 285, '2019-07-12', 199, NULL),
('Residence Inn', 285, '2019-07-13', 146, NULL),
('Residence Inn', 285, '2019-07-14', 142, NULL),
('Residence Inn', 285, '2019-07-15', 132, NULL),
('Residence Inn', 285, '2019-07-16', 399, NULL),
('Residence Inn', 285, '2019-07-17', 324, NULL),
('Residence Inn', 285, '2019-07-18', 184, NULL),
('Residence Inn', 285, '2019-07-19', 278, NULL),
('Residence Inn', 285, '2019-07-20', 105, NULL),
('Residence Inn', 285, '2019-07-21', 314, NULL),
('Residence Inn', 285, '2019-07-22', 309, NULL),
('Residence Inn', 285, '2019-07-23', 236, NULL),
('Residence Inn', 285, '2019-07-24', 299, NULL),
('Residence Inn', 285, '2019-07-25', 387, NULL),
('Residence Inn', 285, '2019-07-26', 163, NULL),
('Residence Inn', 285, '2019-07-27', 189, NULL),
('Residence Inn', 285, '2019-07-28', 170, NULL),
('Residence Inn', 285, '2019-07-29', 256, NULL),
('Residence Inn', 285, '2019-07-30', 152, NULL),
('Residence Inn', 285, '2019-07-31', 167, NULL),
('Residence Inn', 285, '2019-08-01', 386, NULL),
('Residence Inn', 285, '2019-08-02', 216, NULL),
('Residence Inn', 285, '2019-08-03', 110, NULL),
('Residence Inn', 285, '2019-08-04', 247, NULL),
('Residence Inn', 285, '2019-08-05', 284, NULL),
('Residence Inn', 285, '2019-08-06', 233, NULL),
('Residence Inn', 285, '2019-08-07', 123, NULL),
('Residence Inn', 285, '2019-08-08', 252, NULL),
('Residence Inn', 285, '2019-08-09', 300, NULL),
('Residence Inn', 285, '2019-08-10', 294, NULL),
('Residence Inn', 285, '2019-08-11', 194, NULL),
('Residence Inn', 285, '2019-08-12', 285, NULL),
('Residence Inn', 285, '2019-08-13', 177, NULL),
('Residence Inn', 285, '2019-08-14', 396, NULL),
('Residence Inn', 285, '2019-08-15', 319, NULL),
('Residence Inn', 285, '2019-08-16', 194, NULL),
('Residence Inn', 285, '2019-08-17', 213, NULL),
('Residence Inn', 285, '2019-08-18', 282, NULL),
('Residence Inn', 285, '2019-08-19', 133, NULL),
('Residence Inn', 285, '2019-08-20', 174, NULL),
('Residence Inn', 285, '2019-08-21', 128, NULL),
('Residence Inn', 285, '2019-08-22', 248, NULL),
('Residence Inn', 285, '2019-08-23', 184, NULL),
('Residence Inn', 285, '2019-08-24', 205, NULL),
('Residence Inn', 285, '2019-08-25', 332, NULL),
('Residence Inn', 285, '2019-08-26', 152, NULL),
('Residence Inn', 285, '2019-08-27', 289, NULL),
('Residence Inn', 285, '2019-08-28', 398, NULL),
('Residence Inn', 285, '2019-08-29', 287, NULL),
('Residence Inn', 285, '2019-08-30', 391, NULL),
('Residence Inn', 285, '2019-08-31', 250, NULL),
('Residence Inn', 285, '2019-09-01', 121, NULL),
('Residence Inn', 285, '2019-09-02', 389, NULL),
('Residence Inn', 285, '2019-09-03', 264, NULL),
('Residence Inn', 285, '2019-09-04', 378, NULL),
('Residence Inn', 285, '2019-09-05', 271, NULL),
('Residence Inn', 285, '2019-09-06', 222, NULL),
('Residence Inn', 285, '2019-09-07', 224, NULL),
('Residence Inn', 285, '2019-09-08', 155, NULL),
('Residence Inn', 285, '2019-09-09', 130, NULL),
('Residence Inn', 285, '2019-09-10', 197, NULL),
('Residence Inn', 285, '2019-09-11', 311, NULL),
('Residence Inn', 285, '2019-09-12', 308, NULL),
('Residence Inn', 285, '2019-09-13', 240, NULL),
('Residence Inn', 285, '2019-09-14', 234, NULL),
('Residence Inn', 285, '2019-09-15', 158, NULL),
('Residence Inn', 285, '2019-09-16', 217, NULL),
('Residence Inn', 285, '2019-09-17', 321, NULL),
('Residence Inn', 285, '2019-09-18', 295, NULL),
('Residence Inn', 285, '2019-09-19', 279, NULL),
('Residence Inn', 285, '2019-09-20', 267, NULL),
('Residence Inn', 285, '2019-09-21', 120, NULL),
('Residence Inn', 285, '2019-09-22', 131, NULL),
('Residence Inn', 285, '2019-09-23', 196, NULL),
('Residence Inn', 285, '2019-09-24', 168, NULL),
('Residence Inn', 285, '2019-09-25', 214, NULL),
('Residence Inn', 285, '2019-09-26', 263, NULL),
('Residence Inn', 285, '2019-09-27', 253, NULL),
('Residence Inn', 285, '2019-09-28', 113, NULL),
('Residence Inn', 285, '2019-09-29', 157, NULL),
('Residence Inn', 285, '2019-09-30', 254, NULL),
('Residence Inn', 285, '2019-10-01', 328, NULL),
('Residence Inn', 285, '2019-10-02', 321, NULL),
('Residence Inn', 285, '2019-10-03', 157, NULL),
('Residence Inn', 285, '2019-10-04', 106, NULL),
('Residence Inn', 285, '2019-10-05', 180, NULL),
('Residence Inn', 285, '2019-10-06', 250, NULL),
('Residence Inn', 285, '2019-10-07', 334, NULL),
('Residence Inn', 285, '2019-10-08', 139, NULL),
('Residence Inn', 285, '2019-10-09', 283, NULL),
('Residence Inn', 285, '2019-10-10', 213, NULL),
('Residence Inn', 285, '2019-10-11', 229, NULL),
('Residence Inn', 285, '2019-10-12', 234, NULL),
('Residence Inn', 285, '2019-10-13', 150, NULL),
('Residence Inn', 285, '2019-10-14', 256, NULL),
('Residence Inn', 285, '2019-10-15', 203, NULL),
('Residence Inn', 285, '2019-10-16', 314, NULL),
('Residence Inn', 285, '2019-10-17', 339, NULL),
('Residence Inn', 285, '2019-10-18', 178, NULL),
('Residence Inn', 285, '2019-10-19', 172, NULL),
('Residence Inn', 285, '2019-10-20', 205, NULL),
('Residence Inn', 285, '2019-10-21', 191, NULL),
('Residence Inn', 285, '2019-10-22', 326, NULL),
('Residence Inn', 285, '2019-10-23', 340, NULL),
('Residence Inn', 285, '2019-10-24', 349, NULL),
('Residence Inn', 285, '2019-10-25', 137, NULL),
('Residence Inn', 285, '2019-10-26', 349, NULL),
('Residence Inn', 285, '2019-10-27', 229, NULL),
('Residence Inn', 285, '2019-10-28', 202, NULL),
('Residence Inn', 285, '2019-10-29', 139, NULL),
('Residence Inn', 285, '2019-10-30', 203, NULL),
('Residence Inn', 285, '2019-10-31', 342, NULL),
('Residence Inn', 285, '2019-11-01', 222, NULL),
('Residence Inn', 285, '2019-11-02', 304, NULL),
('Residence Inn', 285, '2019-11-03', 325, NULL),
('Residence Inn', 285, '2019-11-04', 123, NULL),
('Residence Inn', 285, '2019-11-05', 239, NULL),
('Residence Inn', 285, '2019-11-06', 151, NULL),
('Residence Inn', 285, '2019-11-07', 138, NULL),
('Residence Inn', 285, '2019-11-08', 166, NULL),
('Residence Inn', 285, '2019-11-09', 101, NULL),
('Residence Inn', 285, '2019-11-10', 261, NULL),
('Residence Inn', 285, '2019-11-11', 363, NULL),
('Residence Inn', 285, '2019-11-12', 261, NULL),
('Residence Inn', 285, '2019-11-13', 383, NULL),
('Residence Inn', 285, '2019-11-14', 355, NULL),
('Residence Inn', 285, '2019-11-15', 168, NULL),
('Residence Inn', 285, '2019-11-16', 178, NULL),
('Residence Inn', 285, '2019-11-17', 321, NULL),
('Residence Inn', 285, '2019-11-18', 262, NULL),
('Residence Inn', 285, '2019-11-19', 105, NULL),
('Residence Inn', 285, '2019-11-20', 124, NULL),
('Residence Inn', 285, '2019-11-21', 230, NULL),
('Residence Inn', 285, '2019-11-22', 205, NULL),
('Residence Inn', 285, '2019-11-23', 317, NULL),
('Residence Inn', 285, '2019-11-24', 326, NULL),
('Residence Inn', 285, '2019-11-25', 229, NULL),
('Residence Inn', 285, '2019-11-26', 118, NULL),
('Residence Inn', 285, '2019-11-27', 205, NULL),
('Residence Inn', 285, '2019-11-28', 337, NULL),
('Residence Inn', 285, '2019-11-29', 335, NULL),
('Residence Inn', 285, '2019-11-30', 134, NULL),
('Residence Inn', 285, '2019-12-01', 239, NULL),
('Residence Inn', 285, '2019-12-02', 150, NULL),
('Residence Inn', 285, '2019-12-03', 328, NULL),
('Residence Inn', 285, '2019-12-04', 274, NULL),
('Residence Inn', 285, '2019-12-05', 376, NULL),
('Residence Inn', 285, '2019-12-06', 141, NULL),
('Residence Inn', 285, '2019-12-07', 112, NULL),
('Residence Inn', 285, '2019-12-08', 381, NULL),
('Residence Inn', 285, '2019-12-09', 362, NULL),
('Residence Inn', 285, '2019-12-10', 121, NULL),
('Residence Inn', 285, '2019-12-11', 232, NULL),
('Residence Inn', 285, '2019-12-12', 312, NULL),
('Residence Inn', 285, '2019-12-13', 143, NULL),
('Residence Inn', 285, '2019-12-14', 143, NULL),
('Residence Inn', 285, '2019-12-15', 356, NULL),
('Residence Inn', 285, '2019-12-16', 179, NULL),
('Residence Inn', 285, '2019-12-17', 288, NULL),
('Residence Inn', 285, '2019-12-18', 352, NULL),
('Residence Inn', 285, '2019-12-19', 140, NULL),
('Residence Inn', 285, '2019-12-20', 166, NULL),
('Residence Inn', 285, '2019-12-21', 126, NULL),
('Residence Inn', 285, '2019-12-22', 189, NULL),
('Residence Inn', 285, '2019-12-23', 326, NULL),
('Residence Inn', 285, '2019-12-24', 384, NULL),
('Residence Inn', 285, '2019-12-25', 365, NULL),
('Residence Inn', 285, '2019-12-26', 238, NULL),
('Residence Inn', 285, '2019-12-27', 113, NULL),
('Residence Inn', 285, '2019-12-28', 370, NULL),
('Residence Inn', 285, '2019-12-29', 259, NULL),
('Residence Inn', 285, '2019-12-30', 382, NULL),
('Residence Inn', 285, '2019-12-31', 305, NULL),
('Residence Inn', 285, '2020-01-01', 221, NULL),
('Residence Inn', 285, '2020-01-02', 294, NULL),
('Residence Inn', 285, '2020-01-03', 133, NULL),
('Residence Inn', 285, '2020-01-04', 399, NULL),
('Residence Inn', 285, '2020-01-05', 285, NULL),
('Residence Inn', 285, '2020-01-06', 364, NULL),
('Residence Inn', 285, '2020-01-07', 230, NULL),
('Residence Inn', 285, '2020-01-08', 217, NULL),
('Residence Inn', 285, '2020-01-09', 236, NULL),
('Residence Inn', 285, '2020-01-10', 149, NULL),
('Residence Inn', 285, '2020-01-11', 208, NULL),
('Residence Inn', 285, '2020-01-12', 140, NULL),
('Residence Inn', 285, '2020-01-13', 176, NULL),
('Residence Inn', 285, '2020-01-14', 344, NULL),
('Residence Inn', 285, '2020-01-15', 328, NULL),
('Residence Inn', 285, '2020-01-16', 203, NULL),
('Residence Inn', 285, '2020-01-17', 207, NULL),
('Residence Inn', 285, '2020-01-18', 351, NULL),
('Residence Inn', 285, '2020-01-19', 269, NULL),
('Residence Inn', 285, '2020-01-20', 167, NULL),
('Residence Inn', 285, '2020-01-21', 275, NULL),
('Residence Inn', 285, '2020-01-22', 260, NULL),
('Residence Inn', 285, '2020-01-23', 387, NULL),
('Residence Inn', 285, '2020-01-24', 147, NULL),
('Residence Inn', 285, '2020-01-25', 172, NULL),
('Residence Inn', 285, '2020-01-26', 151, NULL),
('Residence Inn', 285, '2020-01-27', 255, NULL),
('Residence Inn', 285, '2020-01-28', 212, NULL),
('Residence Inn', 285, '2020-01-29', 169, NULL),
('Residence Inn', 285, '2020-01-30', 398, NULL),
('Residence Inn', 285, '2020-01-31', 189, NULL),
('Residence Inn', 285, '2020-02-01', 383, NULL),
('Residence Inn', 285, '2020-02-02', 201, NULL),
('Residence Inn', 285, '2020-02-03', 101, NULL),
('Residence Inn', 285, '2020-02-04', 138, NULL),
('Residence Inn', 297, '2019-01-01', 104, NULL),
('Residence Inn', 297, '2019-01-02', 108, NULL),
('Residence Inn', 297, '2019-01-03', 135, NULL),
('Residence Inn', 297, '2019-01-04', 198, NULL),
('Residence Inn', 297, '2019-01-05', 212, NULL),
('Residence Inn', 297, '2019-01-06', 100, NULL),
('Residence Inn', 297, '2019-01-07', 159, NULL),
('Residence Inn', 297, '2019-01-08', 274, NULL),
('Residence Inn', 297, '2019-01-09', 348, NULL),
('Residence Inn', 297, '2019-01-10', 341, NULL),
('Residence Inn', 297, '2019-01-11', 227, NULL),
('Residence Inn', 297, '2019-01-12', 236, NULL),
('Residence Inn', 297, '2019-01-13', 102, NULL),
('Residence Inn', 297, '2019-01-14', 318, NULL),
('Residence Inn', 297, '2019-01-15', 228, NULL),
('Residence Inn', 297, '2019-01-16', 347, NULL),
('Residence Inn', 297, '2019-01-17', 333, NULL),
('Residence Inn', 297, '2019-01-18', 299, NULL),
('Residence Inn', 297, '2019-01-19', 135, NULL),
('Residence Inn', 297, '2019-01-20', 373, NULL),
('Residence Inn', 297, '2019-01-21', 252, NULL),
('Residence Inn', 297, '2019-01-22', 397, NULL),
('Residence Inn', 297, '2019-01-23', 399, NULL),
('Residence Inn', 297, '2019-01-24', 200, NULL),
('Residence Inn', 297, '2019-01-25', 252, NULL),
('Residence Inn', 297, '2019-01-26', 209, NULL),
('Residence Inn', 297, '2019-01-27', 344, NULL),
('Residence Inn', 297, '2019-01-28', 372, NULL),
('Residence Inn', 297, '2019-01-29', 284, NULL),
('Residence Inn', 297, '2019-01-30', 341, NULL),
('Residence Inn', 297, '2019-01-31', 144, NULL),
('Residence Inn', 297, '2019-02-01', 145, NULL),
('Residence Inn', 297, '2019-02-02', 282, NULL),
('Residence Inn', 297, '2019-02-03', 250, NULL),
('Residence Inn', 297, '2019-02-04', 364, NULL),
('Residence Inn', 297, '2019-02-05', 304, NULL),
('Residence Inn', 297, '2019-02-06', 173, NULL),
('Residence Inn', 297, '2019-02-07', 135, NULL),
('Residence Inn', 297, '2019-02-08', 359, NULL),
('Residence Inn', 297, '2019-02-09', 235, NULL),
('Residence Inn', 297, '2019-02-10', 214, NULL),
('Residence Inn', 297, '2019-02-11', 276, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Residence Inn', 297, '2019-02-12', 136, NULL),
('Residence Inn', 297, '2019-02-13', 180, NULL),
('Residence Inn', 297, '2019-02-14', 363, NULL),
('Residence Inn', 297, '2019-02-15', 377, NULL),
('Residence Inn', 297, '2019-02-16', 173, NULL),
('Residence Inn', 297, '2019-02-17', 151, NULL),
('Residence Inn', 297, '2019-02-18', 392, NULL),
('Residence Inn', 297, '2019-02-19', 175, NULL),
('Residence Inn', 297, '2019-02-20', 108, NULL),
('Residence Inn', 297, '2019-02-21', 311, NULL),
('Residence Inn', 297, '2019-02-22', 343, NULL),
('Residence Inn', 297, '2019-02-23', 293, NULL),
('Residence Inn', 297, '2019-02-24', 200, NULL),
('Residence Inn', 297, '2019-02-25', 201, NULL),
('Residence Inn', 297, '2019-02-26', 318, NULL),
('Residence Inn', 297, '2019-02-27', 318, NULL),
('Residence Inn', 297, '2019-02-28', 272, NULL),
('Residence Inn', 297, '2019-03-01', 190, NULL),
('Residence Inn', 297, '2019-03-02', 311, NULL),
('Residence Inn', 297, '2019-03-03', 377, NULL),
('Residence Inn', 297, '2019-03-04', 106, NULL),
('Residence Inn', 297, '2019-03-05', 145, NULL),
('Residence Inn', 297, '2019-03-06', 389, NULL),
('Residence Inn', 297, '2019-03-07', 130, NULL),
('Residence Inn', 297, '2019-03-08', 181, NULL),
('Residence Inn', 297, '2019-03-09', 207, NULL),
('Residence Inn', 297, '2019-03-10', 233, NULL),
('Residence Inn', 297, '2019-03-11', 373, NULL),
('Residence Inn', 297, '2019-03-12', 397, NULL),
('Residence Inn', 297, '2019-03-13', 266, NULL),
('Residence Inn', 297, '2019-03-14', 150, NULL),
('Residence Inn', 297, '2019-03-15', 248, NULL),
('Residence Inn', 297, '2019-03-16', 218, NULL),
('Residence Inn', 297, '2019-03-17', 102, NULL),
('Residence Inn', 297, '2019-03-18', 267, NULL),
('Residence Inn', 297, '2019-03-19', 188, NULL),
('Residence Inn', 297, '2019-03-20', 230, NULL),
('Residence Inn', 297, '2019-03-21', 213, NULL),
('Residence Inn', 297, '2019-03-22', 203, NULL),
('Residence Inn', 297, '2019-03-23', 273, NULL),
('Residence Inn', 297, '2019-03-24', 177, NULL),
('Residence Inn', 297, '2019-03-25', 203, NULL),
('Residence Inn', 297, '2019-03-26', 390, NULL),
('Residence Inn', 297, '2019-03-27', 216, NULL),
('Residence Inn', 297, '2019-03-28', 190, NULL),
('Residence Inn', 297, '2019-03-29', 244, NULL),
('Residence Inn', 297, '2019-03-30', 310, NULL),
('Residence Inn', 297, '2019-03-31', 322, NULL),
('Residence Inn', 297, '2019-04-01', 128, NULL),
('Residence Inn', 297, '2019-04-02', 385, NULL),
('Residence Inn', 297, '2019-04-03', 394, NULL),
('Residence Inn', 297, '2019-04-04', 132, NULL),
('Residence Inn', 297, '2019-04-05', 289, NULL),
('Residence Inn', 297, '2019-04-06', 374, NULL),
('Residence Inn', 297, '2019-04-07', 255, NULL),
('Residence Inn', 297, '2019-04-08', 340, NULL),
('Residence Inn', 297, '2019-04-09', 339, NULL),
('Residence Inn', 297, '2019-04-10', 182, NULL),
('Residence Inn', 297, '2019-04-11', 383, NULL),
('Residence Inn', 297, '2019-04-12', 202, NULL),
('Residence Inn', 297, '2019-04-13', 258, NULL),
('Residence Inn', 297, '2019-04-14', 114, NULL),
('Residence Inn', 297, '2019-04-15', 372, NULL),
('Residence Inn', 297, '2019-04-16', 313, NULL),
('Residence Inn', 297, '2019-04-17', 377, NULL),
('Residence Inn', 297, '2019-04-18', 117, NULL),
('Residence Inn', 297, '2019-04-19', 116, NULL),
('Residence Inn', 297, '2019-04-20', 308, NULL),
('Residence Inn', 297, '2019-04-21', 304, NULL),
('Residence Inn', 297, '2019-04-22', 137, NULL),
('Residence Inn', 297, '2019-04-23', 274, NULL),
('Residence Inn', 297, '2019-04-24', 336, NULL),
('Residence Inn', 297, '2019-04-25', 123, NULL),
('Residence Inn', 297, '2019-04-26', 345, NULL),
('Residence Inn', 297, '2019-04-27', 160, NULL),
('Residence Inn', 297, '2019-04-28', 305, NULL),
('Residence Inn', 297, '2019-04-29', 393, NULL),
('Residence Inn', 297, '2019-04-30', 183, NULL),
('Residence Inn', 297, '2019-05-01', 204, NULL),
('Residence Inn', 297, '2019-05-02', 296, NULL),
('Residence Inn', 297, '2019-05-03', 111, NULL),
('Residence Inn', 297, '2019-05-04', 174, NULL),
('Residence Inn', 297, '2019-05-05', 272, NULL),
('Residence Inn', 297, '2019-05-06', 110, NULL),
('Residence Inn', 297, '2019-05-07', 268, NULL),
('Residence Inn', 297, '2019-05-08', 307, NULL),
('Residence Inn', 297, '2019-05-09', 125, NULL),
('Residence Inn', 297, '2019-05-10', 159, NULL),
('Residence Inn', 297, '2019-05-11', 182, NULL),
('Residence Inn', 297, '2019-05-12', 162, NULL),
('Residence Inn', 297, '2019-05-13', 103, NULL),
('Residence Inn', 297, '2019-05-14', 105, NULL),
('Residence Inn', 297, '2019-05-15', 310, NULL),
('Residence Inn', 297, '2019-05-16', 126, NULL),
('Residence Inn', 297, '2019-05-17', 215, NULL),
('Residence Inn', 297, '2019-05-18', 253, NULL),
('Residence Inn', 297, '2019-05-19', 148, NULL),
('Residence Inn', 297, '2019-05-20', 274, NULL),
('Residence Inn', 297, '2019-05-21', 307, NULL),
('Residence Inn', 297, '2019-05-22', 294, NULL),
('Residence Inn', 297, '2019-05-23', 337, NULL),
('Residence Inn', 297, '2019-05-24', 233, NULL),
('Residence Inn', 297, '2019-05-25', 276, NULL),
('Residence Inn', 297, '2019-05-26', 200, NULL),
('Residence Inn', 297, '2019-05-27', 387, NULL),
('Residence Inn', 297, '2019-05-28', 303, NULL),
('Residence Inn', 297, '2019-05-29', 214, NULL),
('Residence Inn', 297, '2019-05-30', 329, NULL),
('Residence Inn', 297, '2019-05-31', 327, NULL),
('Residence Inn', 297, '2019-06-01', 383, NULL),
('Residence Inn', 297, '2019-06-02', 119, NULL),
('Residence Inn', 297, '2019-06-03', 324, NULL),
('Residence Inn', 297, '2019-06-04', 364, NULL),
('Residence Inn', 297, '2019-06-05', 178, NULL),
('Residence Inn', 297, '2019-06-06', 234, NULL),
('Residence Inn', 297, '2019-06-07', 184, NULL),
('Residence Inn', 297, '2019-06-08', 294, NULL),
('Residence Inn', 297, '2019-06-09', 120, NULL),
('Residence Inn', 297, '2019-06-10', 244, NULL),
('Residence Inn', 297, '2019-06-11', 371, NULL),
('Residence Inn', 297, '2019-06-12', 138, NULL),
('Residence Inn', 297, '2019-06-13', 276, NULL),
('Residence Inn', 297, '2019-06-14', 272, NULL),
('Residence Inn', 297, '2019-06-15', 359, NULL),
('Residence Inn', 297, '2019-06-16', 161, NULL),
('Residence Inn', 297, '2019-06-17', 244, NULL),
('Residence Inn', 297, '2019-06-18', 227, NULL),
('Residence Inn', 297, '2019-06-19', 184, NULL),
('Residence Inn', 297, '2019-06-20', 397, NULL),
('Residence Inn', 297, '2019-06-21', 287, NULL),
('Residence Inn', 297, '2019-06-22', 347, NULL),
('Residence Inn', 297, '2019-06-23', 106, NULL),
('Residence Inn', 297, '2019-06-24', 320, NULL),
('Residence Inn', 297, '2019-06-25', 177, NULL),
('Residence Inn', 297, '2019-06-26', 247, NULL),
('Residence Inn', 297, '2019-06-27', 198, NULL),
('Residence Inn', 297, '2019-06-28', 379, NULL),
('Residence Inn', 297, '2019-06-29', 241, NULL),
('Residence Inn', 297, '2019-06-30', 269, NULL),
('Residence Inn', 297, '2019-07-01', 118, NULL),
('Residence Inn', 297, '2019-07-02', 120, NULL),
('Residence Inn', 297, '2019-07-03', 303, NULL),
('Residence Inn', 297, '2019-07-04', 230, NULL),
('Residence Inn', 297, '2019-07-05', 382, NULL),
('Residence Inn', 297, '2019-07-06', 331, NULL),
('Residence Inn', 297, '2019-07-07', 270, NULL),
('Residence Inn', 297, '2019-07-08', 315, NULL),
('Residence Inn', 297, '2019-07-09', 321, NULL),
('Residence Inn', 297, '2019-07-10', 200, NULL),
('Residence Inn', 297, '2019-07-11', 375, NULL),
('Residence Inn', 297, '2019-07-12', 190, NULL),
('Residence Inn', 297, '2019-07-13', 230, NULL),
('Residence Inn', 297, '2019-07-14', 389, NULL),
('Residence Inn', 297, '2019-07-15', 200, NULL),
('Residence Inn', 297, '2019-07-16', 186, NULL),
('Residence Inn', 297, '2019-07-17', 213, NULL),
('Residence Inn', 297, '2019-07-18', 230, NULL),
('Residence Inn', 297, '2019-07-19', 242, NULL),
('Residence Inn', 297, '2019-07-20', 103, NULL),
('Residence Inn', 297, '2019-07-21', 264, NULL),
('Residence Inn', 297, '2019-07-22', 179, NULL),
('Residence Inn', 297, '2019-07-23', 383, NULL),
('Residence Inn', 297, '2019-07-24', 223, NULL),
('Residence Inn', 297, '2019-07-25', 108, NULL),
('Residence Inn', 297, '2019-07-26', 336, NULL),
('Residence Inn', 297, '2019-07-27', 371, NULL),
('Residence Inn', 297, '2019-07-28', 255, NULL),
('Residence Inn', 297, '2019-07-29', 232, NULL),
('Residence Inn', 297, '2019-07-30', 234, NULL),
('Residence Inn', 297, '2019-07-31', 284, NULL),
('Residence Inn', 297, '2019-08-01', 113, NULL),
('Residence Inn', 297, '2019-08-02', 206, NULL),
('Residence Inn', 297, '2019-08-03', 234, NULL),
('Residence Inn', 297, '2019-08-04', 281, NULL),
('Residence Inn', 297, '2019-08-05', 346, NULL),
('Residence Inn', 297, '2019-08-06', 179, NULL),
('Residence Inn', 297, '2019-08-07', 344, NULL),
('Residence Inn', 297, '2019-08-08', 114, NULL),
('Residence Inn', 297, '2019-08-09', 226, NULL),
('Residence Inn', 297, '2019-08-10', 236, NULL),
('Residence Inn', 297, '2019-08-11', 194, NULL),
('Residence Inn', 297, '2019-08-12', 328, NULL),
('Residence Inn', 297, '2019-08-13', 197, NULL),
('Residence Inn', 297, '2019-08-14', 191, NULL),
('Residence Inn', 297, '2019-08-15', 137, NULL),
('Residence Inn', 297, '2019-08-16', 192, NULL),
('Residence Inn', 297, '2019-08-17', 268, NULL),
('Residence Inn', 297, '2019-08-18', 274, NULL),
('Residence Inn', 297, '2019-08-19', 283, NULL),
('Residence Inn', 297, '2019-08-20', 227, NULL),
('Residence Inn', 297, '2019-08-21', 142, NULL),
('Residence Inn', 297, '2019-08-22', 238, NULL),
('Residence Inn', 297, '2019-08-23', 314, NULL),
('Residence Inn', 297, '2019-08-24', 358, NULL),
('Residence Inn', 297, '2019-08-25', 145, NULL),
('Residence Inn', 297, '2019-08-26', 233, NULL),
('Residence Inn', 297, '2019-08-27', 152, NULL),
('Residence Inn', 297, '2019-08-28', 385, NULL),
('Residence Inn', 297, '2019-08-29', 367, NULL),
('Residence Inn', 297, '2019-08-30', 105, NULL),
('Residence Inn', 297, '2019-08-31', 220, NULL),
('Residence Inn', 297, '2019-09-01', 270, NULL),
('Residence Inn', 297, '2019-09-02', 330, NULL),
('Residence Inn', 297, '2019-09-03', 286, NULL),
('Residence Inn', 297, '2019-09-04', 352, NULL),
('Residence Inn', 297, '2019-09-05', 115, NULL),
('Residence Inn', 297, '2019-09-06', 175, NULL),
('Residence Inn', 297, '2019-09-07', 327, NULL),
('Residence Inn', 297, '2019-09-08', 394, NULL),
('Residence Inn', 297, '2019-09-09', 257, NULL),
('Residence Inn', 297, '2019-09-10', 385, NULL),
('Residence Inn', 297, '2019-09-11', 138, NULL),
('Residence Inn', 297, '2019-09-12', 316, NULL),
('Residence Inn', 297, '2019-09-13', 289, NULL),
('Residence Inn', 297, '2019-09-14', 295, NULL),
('Residence Inn', 297, '2019-09-15', 324, NULL),
('Residence Inn', 297, '2019-09-16', 344, NULL),
('Residence Inn', 297, '2019-09-17', 191, NULL),
('Residence Inn', 297, '2019-09-18', 137, NULL),
('Residence Inn', 297, '2019-09-19', 273, NULL),
('Residence Inn', 297, '2019-09-20', 143, NULL),
('Residence Inn', 297, '2019-09-21', 360, NULL),
('Residence Inn', 297, '2019-09-22', 212, NULL),
('Residence Inn', 297, '2019-09-23', 104, NULL),
('Residence Inn', 297, '2019-09-24', 362, NULL),
('Residence Inn', 297, '2019-09-25', 363, NULL),
('Residence Inn', 297, '2019-09-26', 219, NULL),
('Residence Inn', 297, '2019-09-27', 206, NULL),
('Residence Inn', 297, '2019-09-28', 228, NULL),
('Residence Inn', 297, '2019-09-29', 238, NULL),
('Residence Inn', 297, '2019-09-30', 249, NULL),
('Residence Inn', 297, '2019-10-01', 210, NULL),
('Residence Inn', 297, '2019-10-02', 305, NULL),
('Residence Inn', 297, '2019-10-03', 390, NULL),
('Residence Inn', 297, '2019-10-04', 209, NULL),
('Residence Inn', 297, '2019-10-05', 111, NULL),
('Residence Inn', 297, '2019-10-06', 374, NULL),
('Residence Inn', 297, '2019-10-07', 168, NULL),
('Residence Inn', 297, '2019-10-08', 271, NULL),
('Residence Inn', 297, '2019-10-09', 257, NULL),
('Residence Inn', 297, '2019-10-10', 218, NULL),
('Residence Inn', 297, '2019-10-11', 285, NULL),
('Residence Inn', 297, '2019-10-12', 314, NULL),
('Residence Inn', 297, '2019-10-13', 393, NULL),
('Residence Inn', 297, '2019-10-14', 398, NULL),
('Residence Inn', 297, '2019-10-15', 297, NULL),
('Residence Inn', 297, '2019-10-16', 392, NULL),
('Residence Inn', 297, '2019-10-17', 202, NULL),
('Residence Inn', 297, '2019-10-18', 229, NULL),
('Residence Inn', 297, '2019-10-19', 141, NULL),
('Residence Inn', 297, '2019-10-20', 195, NULL),
('Residence Inn', 297, '2019-10-21', 292, NULL),
('Residence Inn', 297, '2019-10-22', 276, NULL),
('Residence Inn', 297, '2019-10-23', 137, NULL),
('Residence Inn', 297, '2019-10-24', 291, NULL),
('Residence Inn', 297, '2019-10-25', 167, NULL),
('Residence Inn', 297, '2019-10-26', 137, NULL),
('Residence Inn', 297, '2019-10-27', 183, NULL),
('Residence Inn', 297, '2019-10-28', 376, NULL),
('Residence Inn', 297, '2019-10-29', 143, NULL),
('Residence Inn', 297, '2019-10-30', 321, NULL),
('Residence Inn', 297, '2019-10-31', 337, NULL),
('Residence Inn', 297, '2019-11-01', 108, NULL),
('Residence Inn', 297, '2019-11-02', 157, NULL),
('Residence Inn', 297, '2019-11-03', 393, NULL),
('Residence Inn', 297, '2019-11-04', 262, NULL),
('Residence Inn', 297, '2019-11-05', 376, NULL),
('Residence Inn', 297, '2019-11-06', 334, NULL),
('Residence Inn', 297, '2019-11-07', 268, NULL),
('Residence Inn', 297, '2019-11-08', 102, NULL),
('Residence Inn', 297, '2019-11-09', 178, NULL),
('Residence Inn', 297, '2019-11-10', 205, NULL),
('Residence Inn', 297, '2019-11-11', 242, NULL),
('Residence Inn', 297, '2019-11-12', 298, NULL),
('Residence Inn', 297, '2019-11-13', 371, NULL),
('Residence Inn', 297, '2019-11-14', 251, NULL),
('Residence Inn', 297, '2019-11-15', 378, NULL),
('Residence Inn', 297, '2019-11-16', 137, NULL),
('Residence Inn', 297, '2019-11-17', 147, NULL),
('Residence Inn', 297, '2019-11-18', 178, NULL),
('Residence Inn', 297, '2019-11-19', 292, NULL),
('Residence Inn', 297, '2019-11-20', 234, NULL),
('Residence Inn', 297, '2019-11-21', 293, NULL),
('Residence Inn', 297, '2019-11-22', 346, NULL),
('Residence Inn', 297, '2019-11-23', 151, NULL),
('Residence Inn', 297, '2019-11-24', 122, NULL),
('Residence Inn', 297, '2019-11-25', 251, NULL),
('Residence Inn', 297, '2019-11-26', 194, NULL),
('Residence Inn', 297, '2019-11-27', 271, NULL),
('Residence Inn', 297, '2019-11-28', 171, NULL),
('Residence Inn', 297, '2019-11-29', 259, NULL),
('Residence Inn', 297, '2019-11-30', 346, NULL),
('Residence Inn', 297, '2019-12-01', 240, NULL),
('Residence Inn', 297, '2019-12-02', 186, NULL),
('Residence Inn', 297, '2019-12-03', 186, NULL),
('Residence Inn', 297, '2019-12-04', 166, NULL),
('Residence Inn', 297, '2019-12-05', 377, NULL),
('Residence Inn', 297, '2019-12-06', 176, NULL),
('Residence Inn', 297, '2019-12-07', 159, NULL),
('Residence Inn', 297, '2019-12-08', 216, NULL),
('Residence Inn', 297, '2019-12-09', 114, NULL),
('Residence Inn', 297, '2019-12-10', 315, NULL),
('Residence Inn', 297, '2019-12-11', 344, NULL),
('Residence Inn', 297, '2019-12-12', 292, NULL),
('Residence Inn', 297, '2019-12-13', 300, NULL),
('Residence Inn', 297, '2019-12-14', 355, NULL),
('Residence Inn', 297, '2019-12-15', 207, NULL),
('Residence Inn', 297, '2019-12-16', 326, NULL),
('Residence Inn', 297, '2019-12-17', 375, NULL),
('Residence Inn', 297, '2019-12-18', 100, NULL),
('Residence Inn', 297, '2019-12-19', 275, NULL),
('Residence Inn', 297, '2019-12-20', 347, NULL),
('Residence Inn', 297, '2019-12-21', 145, NULL),
('Residence Inn', 297, '2019-12-22', 301, NULL),
('Residence Inn', 297, '2019-12-23', 111, NULL),
('Residence Inn', 297, '2019-12-24', 269, NULL),
('Residence Inn', 297, '2019-12-25', 288, NULL),
('Residence Inn', 297, '2019-12-26', 249, NULL),
('Residence Inn', 297, '2019-12-27', 126, NULL),
('Residence Inn', 297, '2019-12-28', 375, NULL),
('Residence Inn', 297, '2019-12-29', 205, NULL),
('Residence Inn', 297, '2019-12-30', 381, NULL),
('Residence Inn', 297, '2019-12-31', 254, NULL),
('Residence Inn', 297, '2020-01-01', 109, NULL),
('Residence Inn', 297, '2020-01-02', 398, NULL),
('Residence Inn', 297, '2020-01-03', 271, NULL),
('Residence Inn', 297, '2020-01-04', 379, NULL),
('Residence Inn', 297, '2020-01-05', 150, NULL),
('Residence Inn', 297, '2020-01-06', 125, NULL),
('Residence Inn', 297, '2020-01-07', 207, NULL),
('Residence Inn', 297, '2020-01-08', 198, NULL),
('Residence Inn', 297, '2020-01-09', 381, NULL),
('Residence Inn', 297, '2020-01-10', 168, NULL),
('Residence Inn', 297, '2020-01-11', 227, NULL),
('Residence Inn', 297, '2020-01-12', 337, NULL),
('Residence Inn', 297, '2020-01-13', 375, NULL),
('Residence Inn', 297, '2020-01-14', 256, NULL),
('Residence Inn', 297, '2020-01-15', 346, NULL),
('Residence Inn', 297, '2020-01-16', 233, NULL),
('Residence Inn', 297, '2020-01-17', 371, NULL),
('Residence Inn', 297, '2020-01-18', 122, NULL),
('Residence Inn', 297, '2020-01-19', 239, NULL),
('Residence Inn', 297, '2020-01-20', 153, NULL),
('Residence Inn', 297, '2020-01-21', 217, NULL),
('Residence Inn', 297, '2020-01-22', 225, NULL),
('Residence Inn', 297, '2020-01-23', 235, NULL),
('Residence Inn', 297, '2020-01-24', 302, NULL),
('Residence Inn', 297, '2020-01-25', 301, NULL),
('Residence Inn', 297, '2020-01-26', 228, NULL),
('Residence Inn', 297, '2020-01-27', 105, NULL),
('Residence Inn', 297, '2020-01-28', 339, NULL),
('Residence Inn', 297, '2020-01-29', 374, NULL),
('Residence Inn', 297, '2020-01-30', 204, NULL),
('Residence Inn', 297, '2020-01-31', 394, NULL),
('Residence Inn', 297, '2020-02-01', 254, NULL),
('Residence Inn', 297, '2020-02-02', 259, NULL),
('Residence Inn', 297, '2020-02-03', 228, NULL),
('Residence Inn', 297, '2020-02-04', 254, NULL),
('Sheraton Centre', 7, '2019-01-01', 261, NULL),
('Sheraton Centre', 7, '2019-01-02', 331, NULL),
('Sheraton Centre', 7, '2019-01-03', 350, NULL),
('Sheraton Centre', 7, '2019-01-04', 159, NULL),
('Sheraton Centre', 7, '2019-01-05', 295, NULL),
('Sheraton Centre', 7, '2019-01-06', 197, NULL),
('Sheraton Centre', 7, '2019-01-07', 268, NULL),
('Sheraton Centre', 7, '2019-01-08', 213, NULL),
('Sheraton Centre', 7, '2019-01-09', 197, 165),
('Sheraton Centre', 7, '2019-01-10', 126, 165),
('Sheraton Centre', 7, '2019-01-11', 184, 165),
('Sheraton Centre', 7, '2019-01-12', 225, 165),
('Sheraton Centre', 7, '2019-01-13', 342, 165),
('Sheraton Centre', 7, '2019-01-14', 319, 165),
('Sheraton Centre', 7, '2019-01-15', 192, NULL),
('Sheraton Centre', 7, '2019-01-16', 221, NULL),
('Sheraton Centre', 7, '2019-01-17', 381, NULL),
('Sheraton Centre', 7, '2019-01-18', 104, NULL),
('Sheraton Centre', 7, '2019-01-19', 316, NULL),
('Sheraton Centre', 7, '2019-01-20', 246, NULL),
('Sheraton Centre', 7, '2019-01-21', 238, NULL),
('Sheraton Centre', 7, '2019-01-22', 375, NULL),
('Sheraton Centre', 7, '2019-01-23', 106, NULL),
('Sheraton Centre', 7, '2019-01-24', 393, NULL),
('Sheraton Centre', 7, '2019-01-25', 380, NULL),
('Sheraton Centre', 7, '2019-01-26', 158, NULL),
('Sheraton Centre', 7, '2019-01-27', 210, NULL),
('Sheraton Centre', 7, '2019-01-28', 312, NULL),
('Sheraton Centre', 7, '2019-01-29', 104, NULL),
('Sheraton Centre', 7, '2019-01-30', 126, NULL),
('Sheraton Centre', 7, '2019-01-31', 224, NULL),
('Sheraton Centre', 7, '2019-02-01', 314, NULL),
('Sheraton Centre', 7, '2019-02-02', 277, NULL),
('Sheraton Centre', 7, '2019-02-03', 254, NULL),
('Sheraton Centre', 7, '2019-02-04', 213, NULL),
('Sheraton Centre', 7, '2019-02-05', 233, NULL),
('Sheraton Centre', 7, '2019-02-06', 191, NULL),
('Sheraton Centre', 7, '2019-02-07', 171, NULL),
('Sheraton Centre', 7, '2019-02-08', 255, NULL),
('Sheraton Centre', 7, '2019-02-09', 105, NULL),
('Sheraton Centre', 7, '2019-02-10', 127, NULL),
('Sheraton Centre', 7, '2019-02-11', 340, NULL),
('Sheraton Centre', 7, '2019-02-12', 163, NULL),
('Sheraton Centre', 7, '2019-02-13', 186, NULL),
('Sheraton Centre', 7, '2019-02-14', 155, NULL),
('Sheraton Centre', 7, '2019-02-15', 364, NULL),
('Sheraton Centre', 7, '2019-02-16', 387, NULL),
('Sheraton Centre', 7, '2019-02-17', 291, NULL),
('Sheraton Centre', 7, '2019-02-18', 114, NULL),
('Sheraton Centre', 7, '2019-02-19', 241, NULL),
('Sheraton Centre', 7, '2019-02-20', 384, NULL),
('Sheraton Centre', 7, '2019-02-21', 208, NULL),
('Sheraton Centre', 7, '2019-02-22', 222, NULL),
('Sheraton Centre', 7, '2019-02-23', 343, NULL),
('Sheraton Centre', 7, '2019-02-24', 390, NULL),
('Sheraton Centre', 7, '2019-02-25', 308, NULL),
('Sheraton Centre', 7, '2019-02-26', 301, NULL),
('Sheraton Centre', 7, '2019-02-27', 317, NULL),
('Sheraton Centre', 7, '2019-02-28', 106, NULL),
('Sheraton Centre', 7, '2019-03-01', 161, NULL),
('Sheraton Centre', 7, '2019-03-02', 380, NULL),
('Sheraton Centre', 7, '2019-03-03', 377, NULL),
('Sheraton Centre', 7, '2019-03-04', 183, 180),
('Sheraton Centre', 7, '2019-03-05', 195, 180),
('Sheraton Centre', 7, '2019-03-06', 124, 180),
('Sheraton Centre', 7, '2019-03-07', 313, 180),
('Sheraton Centre', 7, '2019-03-08', 229, 180),
('Sheraton Centre', 7, '2019-03-09', 224, 180),
('Sheraton Centre', 7, '2019-03-10', 278, 180),
('Sheraton Centre', 7, '2019-03-11', 355, 180),
('Sheraton Centre', 7, '2019-03-12', 195, 180),
('Sheraton Centre', 7, '2019-03-13', 219, 180),
('Sheraton Centre', 7, '2019-03-14', 246, 180),
('Sheraton Centre', 7, '2019-03-15', 209, 180),
('Sheraton Centre', 7, '2019-03-16', 143, 180),
('Sheraton Centre', 7, '2019-03-17', 106, 180),
('Sheraton Centre', 7, '2019-03-18', 305, 180),
('Sheraton Centre', 7, '2019-03-19', 207, 180),
('Sheraton Centre', 7, '2019-03-20', 107, 180),
('Sheraton Centre', 7, '2019-03-21', 241, 180),
('Sheraton Centre', 7, '2019-03-22', 142, 180),
('Sheraton Centre', 7, '2019-03-23', 285, 180),
('Sheraton Centre', 7, '2019-03-24', 373, 180),
('Sheraton Centre', 7, '2019-03-25', 364, 180),
('Sheraton Centre', 7, '2019-03-26', 220, 180),
('Sheraton Centre', 7, '2019-03-27', 264, 180),
('Sheraton Centre', 7, '2019-03-28', 227, NULL),
('Sheraton Centre', 7, '2019-03-29', 300, NULL),
('Sheraton Centre', 7, '2019-03-30', 236, NULL),
('Sheraton Centre', 7, '2019-03-31', 377, NULL),
('Sheraton Centre', 7, '2019-04-01', 391, NULL),
('Sheraton Centre', 7, '2019-04-02', 200, 96),
('Sheraton Centre', 7, '2019-04-03', 127, 96),
('Sheraton Centre', 7, '2019-04-04', 289, 96),
('Sheraton Centre', 7, '2019-04-05', 110, 96),
('Sheraton Centre', 7, '2019-04-06', 243, 96),
('Sheraton Centre', 7, '2019-04-07', 273, 96),
('Sheraton Centre', 7, '2019-04-08', 176, 96),
('Sheraton Centre', 7, '2019-04-09', 215, 96),
('Sheraton Centre', 7, '2019-04-10', 232, 96),
('Sheraton Centre', 7, '2019-04-11', 220, 96),
('Sheraton Centre', 7, '2019-04-12', 182, 96),
('Sheraton Centre', 7, '2019-04-13', 126, 96),
('Sheraton Centre', 7, '2019-04-14', 281, 96),
('Sheraton Centre', 7, '2019-04-15', 333, 96),
('Sheraton Centre', 7, '2019-04-16', 170, NULL),
('Sheraton Centre', 7, '2019-04-17', 281, NULL),
('Sheraton Centre', 7, '2019-04-18', 228, NULL),
('Sheraton Centre', 7, '2019-04-19', 367, NULL),
('Sheraton Centre', 7, '2019-04-20', 353, NULL),
('Sheraton Centre', 7, '2019-04-21', 381, NULL),
('Sheraton Centre', 7, '2019-04-22', 384, NULL),
('Sheraton Centre', 7, '2019-04-23', 272, NULL),
('Sheraton Centre', 7, '2019-04-24', 175, NULL),
('Sheraton Centre', 7, '2019-04-25', 310, NULL),
('Sheraton Centre', 7, '2019-04-26', 355, NULL),
('Sheraton Centre', 7, '2019-04-27', 263, NULL),
('Sheraton Centre', 7, '2019-04-28', 382, NULL),
('Sheraton Centre', 7, '2019-04-29', 141, NULL),
('Sheraton Centre', 7, '2019-04-30', 139, NULL),
('Sheraton Centre', 7, '2019-05-01', 178, NULL),
('Sheraton Centre', 7, '2019-05-02', 346, NULL),
('Sheraton Centre', 7, '2019-05-03', 265, NULL),
('Sheraton Centre', 7, '2019-05-04', 212, NULL),
('Sheraton Centre', 7, '2019-05-05', 356, NULL),
('Sheraton Centre', 7, '2019-05-06', 273, NULL),
('Sheraton Centre', 7, '2019-05-07', 159, NULL),
('Sheraton Centre', 7, '2019-05-08', 183, NULL),
('Sheraton Centre', 7, '2019-05-09', 302, NULL),
('Sheraton Centre', 7, '2019-05-10', 265, NULL),
('Sheraton Centre', 7, '2019-05-11', 139, NULL),
('Sheraton Centre', 7, '2019-05-12', 121, NULL),
('Sheraton Centre', 7, '2019-05-13', 208, NULL),
('Sheraton Centre', 7, '2019-05-14', 121, NULL),
('Sheraton Centre', 7, '2019-05-15', 124, NULL),
('Sheraton Centre', 7, '2019-05-16', 156, NULL),
('Sheraton Centre', 7, '2019-05-17', 114, NULL),
('Sheraton Centre', 7, '2019-05-18', 164, NULL),
('Sheraton Centre', 7, '2019-05-19', 276, NULL),
('Sheraton Centre', 7, '2019-05-20', 398, NULL),
('Sheraton Centre', 7, '2019-05-21', 195, NULL),
('Sheraton Centre', 7, '2019-05-22', 276, NULL),
('Sheraton Centre', 7, '2019-05-23', 128, NULL),
('Sheraton Centre', 7, '2019-05-24', 195, NULL),
('Sheraton Centre', 7, '2019-05-25', 293, NULL),
('Sheraton Centre', 7, '2019-05-26', 280, NULL),
('Sheraton Centre', 7, '2019-05-27', 393, NULL),
('Sheraton Centre', 7, '2019-05-28', 374, NULL),
('Sheraton Centre', 7, '2019-05-29', 200, NULL),
('Sheraton Centre', 7, '2019-05-30', 287, NULL),
('Sheraton Centre', 7, '2019-05-31', 303, NULL),
('Sheraton Centre', 7, '2019-06-01', 184, NULL),
('Sheraton Centre', 7, '2019-06-02', 106, NULL),
('Sheraton Centre', 7, '2019-06-03', 341, NULL),
('Sheraton Centre', 7, '2019-06-04', 239, NULL),
('Sheraton Centre', 7, '2019-06-05', 234, NULL),
('Sheraton Centre', 7, '2019-06-06', 167, NULL),
('Sheraton Centre', 7, '2019-06-07', 256, NULL),
('Sheraton Centre', 7, '2019-06-08', 265, NULL),
('Sheraton Centre', 7, '2019-06-09', 219, NULL),
('Sheraton Centre', 7, '2019-06-10', 279, NULL),
('Sheraton Centre', 7, '2019-06-11', 275, NULL),
('Sheraton Centre', 7, '2019-06-12', 303, NULL),
('Sheraton Centre', 7, '2019-06-13', 267, NULL),
('Sheraton Centre', 7, '2019-06-14', 356, NULL),
('Sheraton Centre', 7, '2019-06-15', 169, NULL),
('Sheraton Centre', 7, '2019-06-16', 205, NULL),
('Sheraton Centre', 7, '2019-06-17', 181, NULL),
('Sheraton Centre', 7, '2019-06-18', 261, NULL),
('Sheraton Centre', 7, '2019-06-19', 100, NULL),
('Sheraton Centre', 7, '2019-06-20', 364, NULL),
('Sheraton Centre', 7, '2019-06-21', 257, NULL),
('Sheraton Centre', 7, '2019-06-22', 155, NULL),
('Sheraton Centre', 7, '2019-06-23', 349, NULL),
('Sheraton Centre', 7, '2019-06-24', 177, NULL),
('Sheraton Centre', 7, '2019-06-25', 254, NULL),
('Sheraton Centre', 7, '2019-06-26', 209, NULL),
('Sheraton Centre', 7, '2019-06-27', 210, NULL),
('Sheraton Centre', 7, '2019-06-28', 274, NULL),
('Sheraton Centre', 7, '2019-06-29', 165, NULL),
('Sheraton Centre', 7, '2019-06-30', 114, NULL),
('Sheraton Centre', 7, '2019-07-01', 294, NULL),
('Sheraton Centre', 7, '2019-07-02', 300, NULL),
('Sheraton Centre', 7, '2019-07-03', 257, NULL),
('Sheraton Centre', 7, '2019-07-04', 252, 10),
('Sheraton Centre', 7, '2019-07-05', 187, 10),
('Sheraton Centre', 7, '2019-07-06', 382, 10),
('Sheraton Centre', 7, '2019-07-07', 251, 10),
('Sheraton Centre', 7, '2019-07-08', 260, 10),
('Sheraton Centre', 7, '2019-07-09', 377, 10),
('Sheraton Centre', 7, '2019-07-10', 234, 10),
('Sheraton Centre', 7, '2019-07-11', 390, 10),
('Sheraton Centre', 7, '2019-07-12', 256, 10),
('Sheraton Centre', 7, '2019-07-13', 311, 10),
('Sheraton Centre', 7, '2019-07-14', 220, 10),
('Sheraton Centre', 7, '2019-07-15', 202, 10),
('Sheraton Centre', 7, '2019-07-16', 236, 10),
('Sheraton Centre', 7, '2019-07-17', 294, 10),
('Sheraton Centre', 7, '2019-07-18', 201, 10),
('Sheraton Centre', 7, '2019-07-19', 276, 10),
('Sheraton Centre', 7, '2019-07-20', 100, 10),
('Sheraton Centre', 7, '2019-07-21', 280, 10),
('Sheraton Centre', 7, '2019-07-22', 167, 10),
('Sheraton Centre', 7, '2019-07-23', 207, 10),
('Sheraton Centre', 7, '2019-07-24', 118, 10),
('Sheraton Centre', 7, '2019-07-25', 180, 10),
('Sheraton Centre', 7, '2019-07-26', 193, 10),
('Sheraton Centre', 7, '2019-07-27', 289, 10),
('Sheraton Centre', 7, '2019-07-28', 365, 10),
('Sheraton Centre', 7, '2019-07-29', 291, 10),
('Sheraton Centre', 7, '2019-07-30', 314, 10),
('Sheraton Centre', 7, '2019-07-31', 219, NULL),
('Sheraton Centre', 7, '2019-08-01', 208, NULL),
('Sheraton Centre', 7, '2019-08-02', 281, NULL),
('Sheraton Centre', 7, '2019-08-03', 139, NULL),
('Sheraton Centre', 7, '2019-08-04', 264, NULL),
('Sheraton Centre', 7, '2019-08-05', 178, NULL),
('Sheraton Centre', 7, '2019-08-06', 398, NULL),
('Sheraton Centre', 7, '2019-08-07', 351, NULL),
('Sheraton Centre', 7, '2019-08-08', 314, NULL),
('Sheraton Centre', 7, '2019-08-09', 129, NULL),
('Sheraton Centre', 7, '2019-08-10', 199, NULL),
('Sheraton Centre', 7, '2019-08-11', 290, NULL),
('Sheraton Centre', 7, '2019-08-12', 385, NULL),
('Sheraton Centre', 7, '2019-08-13', 354, NULL),
('Sheraton Centre', 7, '2019-08-14', 269, NULL),
('Sheraton Centre', 7, '2019-08-15', 229, NULL),
('Sheraton Centre', 7, '2019-08-16', 276, NULL),
('Sheraton Centre', 7, '2019-08-17', 299, NULL),
('Sheraton Centre', 7, '2019-08-18', 125, NULL),
('Sheraton Centre', 7, '2019-08-19', 318, NULL),
('Sheraton Centre', 7, '2019-08-20', 213, NULL),
('Sheraton Centre', 7, '2019-08-21', 228, NULL),
('Sheraton Centre', 7, '2019-08-22', 348, NULL),
('Sheraton Centre', 7, '2019-08-23', 317, NULL),
('Sheraton Centre', 7, '2019-08-24', 175, NULL),
('Sheraton Centre', 7, '2019-08-25', 227, NULL),
('Sheraton Centre', 7, '2019-08-26', 311, NULL),
('Sheraton Centre', 7, '2019-08-27', 392, NULL),
('Sheraton Centre', 7, '2019-08-28', 331, NULL),
('Sheraton Centre', 7, '2019-08-29', 274, 152),
('Sheraton Centre', 7, '2019-08-30', 154, 152),
('Sheraton Centre', 7, '2019-08-31', 249, 152),
('Sheraton Centre', 7, '2019-09-01', 287, 152),
('Sheraton Centre', 7, '2019-09-02', 382, 152),
('Sheraton Centre', 7, '2019-09-03', 238, 152),
('Sheraton Centre', 7, '2019-09-04', 225, NULL),
('Sheraton Centre', 7, '2019-09-05', 262, NULL),
('Sheraton Centre', 7, '2019-09-06', 109, NULL),
('Sheraton Centre', 7, '2019-09-07', 262, NULL),
('Sheraton Centre', 7, '2019-09-08', 206, NULL),
('Sheraton Centre', 7, '2019-09-09', 195, NULL),
('Sheraton Centre', 7, '2019-09-10', 334, NULL),
('Sheraton Centre', 7, '2019-09-11', 259, NULL),
('Sheraton Centre', 7, '2019-09-12', 253, NULL),
('Sheraton Centre', 7, '2019-09-13', 326, NULL),
('Sheraton Centre', 7, '2019-09-14', 375, NULL),
('Sheraton Centre', 7, '2019-09-15', 147, NULL),
('Sheraton Centre', 7, '2019-09-16', 370, NULL),
('Sheraton Centre', 7, '2019-09-17', 194, NULL),
('Sheraton Centre', 7, '2019-09-18', 299, NULL),
('Sheraton Centre', 7, '2019-09-19', 127, NULL),
('Sheraton Centre', 7, '2019-09-20', 114, NULL),
('Sheraton Centre', 7, '2019-09-21', 139, 58),
('Sheraton Centre', 7, '2019-09-22', 267, 58),
('Sheraton Centre', 7, '2019-09-23', 132, 58),
('Sheraton Centre', 7, '2019-09-24', 308, 58),
('Sheraton Centre', 7, '2019-09-25', 176, 58),
('Sheraton Centre', 7, '2019-09-26', 204, 58),
('Sheraton Centre', 7, '2019-09-27', 172, 58),
('Sheraton Centre', 7, '2019-09-28', 399, 58),
('Sheraton Centre', 7, '2019-09-29', 316, 58),
('Sheraton Centre', 7, '2019-09-30', 383, 58),
('Sheraton Centre', 7, '2019-10-01', 264, 58),
('Sheraton Centre', 7, '2019-10-02', 165, 58),
('Sheraton Centre', 7, '2019-10-03', 178, NULL),
('Sheraton Centre', 7, '2019-10-04', 324, NULL),
('Sheraton Centre', 7, '2019-10-05', 216, NULL),
('Sheraton Centre', 7, '2019-10-06', 120, NULL),
('Sheraton Centre', 7, '2019-10-07', 339, NULL),
('Sheraton Centre', 7, '2019-10-08', 237, NULL),
('Sheraton Centre', 7, '2019-10-09', 339, NULL),
('Sheraton Centre', 7, '2019-10-10', 352, NULL),
('Sheraton Centre', 7, '2019-10-11', 337, NULL),
('Sheraton Centre', 7, '2019-10-12', 170, NULL),
('Sheraton Centre', 7, '2019-10-13', 215, NULL),
('Sheraton Centre', 7, '2019-10-14', 223, NULL),
('Sheraton Centre', 7, '2019-10-15', 176, NULL),
('Sheraton Centre', 7, '2019-10-16', 317, NULL),
('Sheraton Centre', 7, '2019-10-17', 193, NULL),
('Sheraton Centre', 7, '2019-10-18', 211, NULL),
('Sheraton Centre', 7, '2019-10-19', 393, NULL),
('Sheraton Centre', 7, '2019-10-20', 261, NULL),
('Sheraton Centre', 7, '2019-10-21', 186, NULL),
('Sheraton Centre', 7, '2019-10-22', 304, NULL),
('Sheraton Centre', 7, '2019-10-23', 164, NULL),
('Sheraton Centre', 7, '2019-10-24', 305, NULL),
('Sheraton Centre', 7, '2019-10-25', 323, NULL),
('Sheraton Centre', 7, '2019-10-26', 136, NULL),
('Sheraton Centre', 7, '2019-10-27', 126, NULL),
('Sheraton Centre', 7, '2019-10-28', 274, NULL),
('Sheraton Centre', 7, '2019-10-29', 198, NULL),
('Sheraton Centre', 7, '2019-10-30', 295, NULL),
('Sheraton Centre', 7, '2019-10-31', 258, NULL),
('Sheraton Centre', 7, '2019-11-01', 372, NULL),
('Sheraton Centre', 7, '2019-11-02', 374, NULL),
('Sheraton Centre', 7, '2019-11-03', 293, NULL),
('Sheraton Centre', 7, '2019-11-04', 243, NULL),
('Sheraton Centre', 7, '2019-11-05', 162, NULL),
('Sheraton Centre', 7, '2019-11-06', 220, NULL),
('Sheraton Centre', 7, '2019-11-07', 223, NULL),
('Sheraton Centre', 7, '2019-11-08', 214, NULL),
('Sheraton Centre', 7, '2019-11-09', 186, NULL),
('Sheraton Centre', 7, '2019-11-10', 139, NULL),
('Sheraton Centre', 7, '2019-11-11', 322, NULL),
('Sheraton Centre', 7, '2019-11-12', 305, NULL),
('Sheraton Centre', 7, '2019-11-13', 307, NULL),
('Sheraton Centre', 7, '2019-11-14', 392, NULL),
('Sheraton Centre', 7, '2019-11-15', 387, NULL),
('Sheraton Centre', 7, '2019-11-16', 352, NULL),
('Sheraton Centre', 7, '2019-11-17', 271, NULL),
('Sheraton Centre', 7, '2019-11-18', 302, NULL),
('Sheraton Centre', 7, '2019-11-19', 143, NULL),
('Sheraton Centre', 7, '2019-11-20', 398, NULL),
('Sheraton Centre', 7, '2019-11-21', 375, 11),
('Sheraton Centre', 7, '2019-11-22', 114, 11),
('Sheraton Centre', 7, '2019-11-23', 306, 11),
('Sheraton Centre', 7, '2019-11-24', 133, 11),
('Sheraton Centre', 7, '2019-11-25', 168, 11),
('Sheraton Centre', 7, '2019-11-26', 217, 11),
('Sheraton Centre', 7, '2019-11-27', 338, 11),
('Sheraton Centre', 7, '2019-11-28', 347, 11),
('Sheraton Centre', 7, '2019-11-29', 188, 11),
('Sheraton Centre', 7, '2019-11-30', 329, 11),
('Sheraton Centre', 7, '2019-12-01', 382, 11),
('Sheraton Centre', 7, '2019-12-02', 381, 11),
('Sheraton Centre', 7, '2019-12-03', 148, NULL),
('Sheraton Centre', 7, '2019-12-04', 206, NULL),
('Sheraton Centre', 7, '2019-12-05', 356, NULL),
('Sheraton Centre', 7, '2019-12-06', 356, 44),
('Sheraton Centre', 7, '2019-12-07', 358, 44),
('Sheraton Centre', 7, '2019-12-08', 140, 44),
('Sheraton Centre', 7, '2019-12-09', 283, 44),
('Sheraton Centre', 7, '2019-12-10', 213, 44),
('Sheraton Centre', 7, '2019-12-11', 327, 44),
('Sheraton Centre', 7, '2019-12-12', 121, 44),
('Sheraton Centre', 7, '2019-12-13', 369, 44),
('Sheraton Centre', 7, '2019-12-14', 347, 44),
('Sheraton Centre', 7, '2019-12-15', 166, 44),
('Sheraton Centre', 7, '2019-12-16', 393, 44),
('Sheraton Centre', 7, '2019-12-17', 313, 44),
('Sheraton Centre', 7, '2019-12-18', 243, 44),
('Sheraton Centre', 7, '2019-12-19', 257, 44),
('Sheraton Centre', 7, '2019-12-20', 240, 44),
('Sheraton Centre', 7, '2019-12-21', 249, 44),
('Sheraton Centre', 7, '2019-12-22', 239, 44),
('Sheraton Centre', 7, '2019-12-23', 376, 44),
('Sheraton Centre', 7, '2019-12-24', 394, 44),
('Sheraton Centre', 7, '2019-12-25', 243, 44),
('Sheraton Centre', 7, '2019-12-26', 129, 44),
('Sheraton Centre', 7, '2019-12-27', 193, 44),
('Sheraton Centre', 7, '2019-12-28', 366, NULL),
('Sheraton Centre', 7, '2019-12-29', 151, NULL),
('Sheraton Centre', 7, '2019-12-30', 358, NULL),
('Sheraton Centre', 7, '2019-12-31', 254, NULL),
('Sheraton Centre', 7, '2020-01-01', 384, NULL),
('Sheraton Centre', 7, '2020-01-02', 109, NULL),
('Sheraton Centre', 7, '2020-01-03', 255, NULL),
('Sheraton Centre', 7, '2020-01-04', 299, NULL),
('Sheraton Centre', 7, '2020-01-05', 396, 40),
('Sheraton Centre', 7, '2020-01-06', 336, 40),
('Sheraton Centre', 7, '2020-01-07', 248, 40),
('Sheraton Centre', 7, '2020-01-08', 237, 40),
('Sheraton Centre', 7, '2020-01-09', 197, NULL),
('Sheraton Centre', 7, '2020-01-10', 293, NULL),
('Sheraton Centre', 7, '2020-01-11', 114, NULL),
('Sheraton Centre', 7, '2020-01-12', 264, NULL),
('Sheraton Centre', 7, '2020-01-13', 349, NULL),
('Sheraton Centre', 7, '2020-01-14', 149, NULL),
('Sheraton Centre', 7, '2020-01-15', 347, NULL),
('Sheraton Centre', 7, '2020-01-16', 158, NULL),
('Sheraton Centre', 7, '2020-01-17', 237, NULL),
('Sheraton Centre', 7, '2020-01-18', 360, NULL),
('Sheraton Centre', 7, '2020-01-19', 288, NULL),
('Sheraton Centre', 7, '2020-01-20', 164, NULL),
('Sheraton Centre', 7, '2020-01-21', 160, NULL),
('Sheraton Centre', 7, '2020-01-22', 244, NULL),
('Sheraton Centre', 7, '2020-01-23', 214, NULL),
('Sheraton Centre', 7, '2020-01-24', 367, NULL),
('Sheraton Centre', 7, '2020-01-25', 289, NULL),
('Sheraton Centre', 7, '2020-01-26', 289, NULL),
('Sheraton Centre', 7, '2020-01-27', 259, NULL),
('Sheraton Centre', 7, '2020-01-28', 360, NULL),
('Sheraton Centre', 7, '2020-01-29', 363, NULL),
('Sheraton Centre', 7, '2020-01-30', 324, NULL),
('Sheraton Centre', 7, '2020-01-31', 105, NULL),
('Sheraton Centre', 7, '2020-02-01', 321, NULL),
('Sheraton Centre', 7, '2020-02-02', 294, NULL),
('Sheraton Centre', 7, '2020-02-03', 141, NULL),
('Sheraton Centre', 7, '2020-02-04', 158, NULL),
('Sheraton Centre', 13, '2019-01-01', 292, NULL),
('Sheraton Centre', 13, '2019-01-02', 335, NULL),
('Sheraton Centre', 13, '2019-01-03', 345, NULL),
('Sheraton Centre', 13, '2019-01-04', 103, NULL),
('Sheraton Centre', 13, '2019-01-05', 141, NULL),
('Sheraton Centre', 13, '2019-01-06', 289, NULL),
('Sheraton Centre', 13, '2019-01-07', 163, NULL),
('Sheraton Centre', 13, '2019-01-08', 147, NULL),
('Sheraton Centre', 13, '2019-01-09', 139, NULL),
('Sheraton Centre', 13, '2019-01-10', 107, NULL),
('Sheraton Centre', 13, '2019-01-11', 140, NULL),
('Sheraton Centre', 13, '2019-01-12', 316, NULL),
('Sheraton Centre', 13, '2019-01-13', 106, NULL),
('Sheraton Centre', 13, '2019-01-14', 243, NULL),
('Sheraton Centre', 13, '2019-01-15', 175, NULL),
('Sheraton Centre', 13, '2019-01-16', 265, NULL),
('Sheraton Centre', 13, '2019-01-17', 208, NULL),
('Sheraton Centre', 13, '2019-01-18', 124, NULL),
('Sheraton Centre', 13, '2019-01-19', 177, NULL),
('Sheraton Centre', 13, '2019-01-20', 313, NULL),
('Sheraton Centre', 13, '2019-01-21', 335, NULL),
('Sheraton Centre', 13, '2019-01-22', 286, NULL),
('Sheraton Centre', 13, '2019-01-23', 135, NULL),
('Sheraton Centre', 13, '2019-01-24', 366, NULL),
('Sheraton Centre', 13, '2019-01-25', 143, NULL),
('Sheraton Centre', 13, '2019-01-26', 363, NULL),
('Sheraton Centre', 13, '2019-01-27', 217, NULL),
('Sheraton Centre', 13, '2019-01-28', 341, NULL),
('Sheraton Centre', 13, '2019-01-29', 170, NULL),
('Sheraton Centre', 13, '2019-01-30', 109, NULL),
('Sheraton Centre', 13, '2019-01-31', 292, NULL),
('Sheraton Centre', 13, '2019-02-01', 134, NULL),
('Sheraton Centre', 13, '2019-02-02', 138, NULL),
('Sheraton Centre', 13, '2019-02-03', 121, NULL),
('Sheraton Centre', 13, '2019-02-04', 175, NULL),
('Sheraton Centre', 13, '2019-02-05', 153, NULL),
('Sheraton Centre', 13, '2019-02-06', 337, NULL),
('Sheraton Centre', 13, '2019-02-07', 351, NULL),
('Sheraton Centre', 13, '2019-02-08', 102, NULL),
('Sheraton Centre', 13, '2019-02-09', 324, NULL),
('Sheraton Centre', 13, '2019-02-10', 194, NULL),
('Sheraton Centre', 13, '2019-02-11', 174, 194),
('Sheraton Centre', 13, '2019-02-12', 306, 194),
('Sheraton Centre', 13, '2019-02-13', 288, 194),
('Sheraton Centre', 13, '2019-02-14', 184, 194),
('Sheraton Centre', 13, '2019-02-15', 290, 194),
('Sheraton Centre', 13, '2019-02-16', 115, 194),
('Sheraton Centre', 13, '2019-02-17', 304, 194),
('Sheraton Centre', 13, '2019-02-18', 192, 194),
('Sheraton Centre', 13, '2019-02-19', 281, 194),
('Sheraton Centre', 13, '2019-02-20', 297, 194),
('Sheraton Centre', 13, '2019-02-21', 304, 194),
('Sheraton Centre', 13, '2019-02-22', 280, 194),
('Sheraton Centre', 13, '2019-02-23', 136, 194),
('Sheraton Centre', 13, '2019-02-24', 354, 194),
('Sheraton Centre', 13, '2019-02-25', 240, 194),
('Sheraton Centre', 13, '2019-02-26', 152, 194),
('Sheraton Centre', 13, '2019-02-27', 233, 194),
('Sheraton Centre', 13, '2019-02-28', 213, 194),
('Sheraton Centre', 13, '2019-03-01', 137, 194),
('Sheraton Centre', 13, '2019-03-02', 266, 194),
('Sheraton Centre', 13, '2019-03-03', 355, 194),
('Sheraton Centre', 13, '2019-03-04', 196, 194),
('Sheraton Centre', 13, '2019-03-05', 142, 194),
('Sheraton Centre', 13, '2019-03-06', 257, 194),
('Sheraton Centre', 13, '2019-03-07', 174, 194),
('Sheraton Centre', 13, '2019-03-08', 199, 194),
('Sheraton Centre', 13, '2019-03-09', 399, 194),
('Sheraton Centre', 13, '2019-03-10', 290, 194),
('Sheraton Centre', 13, '2019-03-11', 253, 194),
('Sheraton Centre', 13, '2019-03-12', 284, NULL),
('Sheraton Centre', 13, '2019-03-13', 197, NULL),
('Sheraton Centre', 13, '2019-03-14', 379, NULL),
('Sheraton Centre', 13, '2019-03-15', 201, NULL),
('Sheraton Centre', 13, '2019-03-16', 261, NULL),
('Sheraton Centre', 13, '2019-03-17', 126, NULL),
('Sheraton Centre', 13, '2019-03-18', 321, NULL),
('Sheraton Centre', 13, '2019-03-19', 371, NULL),
('Sheraton Centre', 13, '2019-03-20', 346, NULL),
('Sheraton Centre', 13, '2019-03-21', 168, NULL),
('Sheraton Centre', 13, '2019-03-22', 300, NULL),
('Sheraton Centre', 13, '2019-03-23', 208, NULL),
('Sheraton Centre', 13, '2019-03-24', 336, NULL),
('Sheraton Centre', 13, '2019-03-25', 209, NULL),
('Sheraton Centre', 13, '2019-03-26', 128, NULL),
('Sheraton Centre', 13, '2019-03-27', 273, NULL),
('Sheraton Centre', 13, '2019-03-28', 163, NULL),
('Sheraton Centre', 13, '2019-03-29', 368, NULL),
('Sheraton Centre', 13, '2019-03-30', 152, NULL),
('Sheraton Centre', 13, '2019-03-31', 220, NULL),
('Sheraton Centre', 13, '2019-04-01', 272, NULL),
('Sheraton Centre', 13, '2019-04-02', 344, NULL),
('Sheraton Centre', 13, '2019-04-03', 254, NULL),
('Sheraton Centre', 13, '2019-04-04', 347, NULL),
('Sheraton Centre', 13, '2019-04-05', 183, NULL),
('Sheraton Centre', 13, '2019-04-06', 291, NULL),
('Sheraton Centre', 13, '2019-04-07', 200, NULL),
('Sheraton Centre', 13, '2019-04-08', 360, NULL),
('Sheraton Centre', 13, '2019-04-09', 260, NULL),
('Sheraton Centre', 13, '2019-04-10', 216, NULL),
('Sheraton Centre', 13, '2019-04-11', 150, NULL),
('Sheraton Centre', 13, '2019-04-12', 204, NULL),
('Sheraton Centre', 13, '2019-04-13', 357, 111),
('Sheraton Centre', 13, '2019-04-14', 363, 111),
('Sheraton Centre', 13, '2019-04-15', 150, 111),
('Sheraton Centre', 13, '2019-04-16', 114, 111),
('Sheraton Centre', 13, '2019-04-17', 176, 111),
('Sheraton Centre', 13, '2019-04-18', 389, 111),
('Sheraton Centre', 13, '2019-04-19', 188, 111),
('Sheraton Centre', 13, '2019-04-20', 144, 111),
('Sheraton Centre', 13, '2019-04-21', 294, 111),
('Sheraton Centre', 13, '2019-04-22', 212, 111),
('Sheraton Centre', 13, '2019-04-23', 136, 111),
('Sheraton Centre', 13, '2019-04-24', 364, 111),
('Sheraton Centre', 13, '2019-04-25', 183, 111),
('Sheraton Centre', 13, '2019-04-26', 341, 111),
('Sheraton Centre', 13, '2019-04-27', 133, 111),
('Sheraton Centre', 13, '2019-04-28', 297, 111),
('Sheraton Centre', 13, '2019-04-29', 329, 111),
('Sheraton Centre', 13, '2019-04-30', 345, 111),
('Sheraton Centre', 13, '2019-05-01', 180, 111),
('Sheraton Centre', 13, '2019-05-02', 143, 111),
('Sheraton Centre', 13, '2019-05-03', 293, 111),
('Sheraton Centre', 13, '2019-05-04', 137, 111),
('Sheraton Centre', 13, '2019-05-05', 266, 111),
('Sheraton Centre', 13, '2019-05-06', 338, 111),
('Sheraton Centre', 13, '2019-05-07', 193, 111),
('Sheraton Centre', 13, '2019-05-08', 195, 111),
('Sheraton Centre', 13, '2019-05-09', 134, 111),
('Sheraton Centre', 13, '2019-05-10', 148, 111),
('Sheraton Centre', 13, '2019-05-11', 348, 111),
('Sheraton Centre', 13, '2019-05-12', 321, 111),
('Sheraton Centre', 13, '2019-05-13', 332, NULL),
('Sheraton Centre', 13, '2019-05-14', 190, NULL),
('Sheraton Centre', 13, '2019-05-15', 188, NULL),
('Sheraton Centre', 13, '2019-05-16', 301, NULL),
('Sheraton Centre', 13, '2019-05-17', 126, NULL),
('Sheraton Centre', 13, '2019-05-18', 261, NULL),
('Sheraton Centre', 13, '2019-05-19', 236, NULL),
('Sheraton Centre', 13, '2019-05-20', 165, NULL),
('Sheraton Centre', 13, '2019-05-21', 252, NULL),
('Sheraton Centre', 13, '2019-05-22', 399, NULL),
('Sheraton Centre', 13, '2019-05-23', 130, NULL),
('Sheraton Centre', 13, '2019-05-24', 177, NULL),
('Sheraton Centre', 13, '2019-05-25', 238, NULL),
('Sheraton Centre', 13, '2019-05-26', 399, NULL),
('Sheraton Centre', 13, '2019-05-27', 105, NULL),
('Sheraton Centre', 13, '2019-05-28', 262, NULL),
('Sheraton Centre', 13, '2019-05-29', 257, NULL),
('Sheraton Centre', 13, '2019-05-30', 350, NULL),
('Sheraton Centre', 13, '2019-05-31', 136, NULL),
('Sheraton Centre', 13, '2019-06-01', 274, NULL),
('Sheraton Centre', 13, '2019-06-02', 377, NULL),
('Sheraton Centre', 13, '2019-06-03', 331, NULL),
('Sheraton Centre', 13, '2019-06-04', 306, NULL),
('Sheraton Centre', 13, '2019-06-05', 240, NULL),
('Sheraton Centre', 13, '2019-06-06', 332, NULL),
('Sheraton Centre', 13, '2019-06-07', 328, NULL),
('Sheraton Centre', 13, '2019-06-08', 343, 108),
('Sheraton Centre', 13, '2019-06-09', 338, 108),
('Sheraton Centre', 13, '2019-06-10', 266, 108),
('Sheraton Centre', 13, '2019-06-11', 162, 108),
('Sheraton Centre', 13, '2019-06-12', 101, 108),
('Sheraton Centre', 13, '2019-06-13', 108, 108),
('Sheraton Centre', 13, '2019-06-14', 267, 108),
('Sheraton Centre', 13, '2019-06-15', 267, 108),
('Sheraton Centre', 13, '2019-06-16', 141, 108),
('Sheraton Centre', 13, '2019-06-17', 374, 108),
('Sheraton Centre', 13, '2019-06-18', 227, 108),
('Sheraton Centre', 13, '2019-06-19', 148, 108),
('Sheraton Centre', 13, '2019-06-20', 226, 108),
('Sheraton Centre', 13, '2019-06-21', 327, 108),
('Sheraton Centre', 13, '2019-06-22', 231, 108),
('Sheraton Centre', 13, '2019-06-23', 126, 108),
('Sheraton Centre', 13, '2019-06-24', 128, 108),
('Sheraton Centre', 13, '2019-06-25', 338, 108),
('Sheraton Centre', 13, '2019-06-26', 204, 108),
('Sheraton Centre', 13, '2019-06-27', 358, 108),
('Sheraton Centre', 13, '2019-06-28', 133, 108),
('Sheraton Centre', 13, '2019-06-29', 300, 108),
('Sheraton Centre', 13, '2019-06-30', 263, 108),
('Sheraton Centre', 13, '2019-07-01', 116, 108),
('Sheraton Centre', 13, '2019-07-02', 140, 108),
('Sheraton Centre', 13, '2019-07-03', 278, 108),
('Sheraton Centre', 13, '2019-07-04', 172, 108),
('Sheraton Centre', 13, '2019-07-05', 292, NULL),
('Sheraton Centre', 13, '2019-07-06', 218, NULL),
('Sheraton Centre', 13, '2019-07-07', 344, NULL),
('Sheraton Centre', 13, '2019-07-08', 255, NULL),
('Sheraton Centre', 13, '2019-07-09', 224, NULL),
('Sheraton Centre', 13, '2019-07-10', 172, NULL),
('Sheraton Centre', 13, '2019-07-11', 127, NULL),
('Sheraton Centre', 13, '2019-07-12', 310, NULL),
('Sheraton Centre', 13, '2019-07-13', 166, NULL),
('Sheraton Centre', 13, '2019-07-14', 136, NULL),
('Sheraton Centre', 13, '2019-07-15', 311, NULL),
('Sheraton Centre', 13, '2019-07-16', 220, NULL),
('Sheraton Centre', 13, '2019-07-17', 131, NULL),
('Sheraton Centre', 13, '2019-07-18', 216, NULL),
('Sheraton Centre', 13, '2019-07-19', 255, NULL),
('Sheraton Centre', 13, '2019-07-20', 390, NULL),
('Sheraton Centre', 13, '2019-07-21', 206, NULL),
('Sheraton Centre', 13, '2019-07-22', 201, NULL),
('Sheraton Centre', 13, '2019-07-23', 386, NULL),
('Sheraton Centre', 13, '2019-07-24', 120, NULL),
('Sheraton Centre', 13, '2019-07-25', 178, NULL),
('Sheraton Centre', 13, '2019-07-26', 159, NULL),
('Sheraton Centre', 13, '2019-07-27', 231, NULL),
('Sheraton Centre', 13, '2019-07-28', 361, NULL),
('Sheraton Centre', 13, '2019-07-29', 359, NULL),
('Sheraton Centre', 13, '2019-07-30', 170, NULL),
('Sheraton Centre', 13, '2019-07-31', 143, NULL),
('Sheraton Centre', 13, '2019-08-01', 300, NULL),
('Sheraton Centre', 13, '2019-08-02', 388, NULL),
('Sheraton Centre', 13, '2019-08-03', 197, NULL),
('Sheraton Centre', 13, '2019-08-04', 377, NULL),
('Sheraton Centre', 13, '2019-08-05', 351, NULL),
('Sheraton Centre', 13, '2019-08-06', 154, NULL),
('Sheraton Centre', 13, '2019-08-07', 324, NULL),
('Sheraton Centre', 13, '2019-08-08', 228, NULL),
('Sheraton Centre', 13, '2019-08-09', 167, NULL),
('Sheraton Centre', 13, '2019-08-10', 190, NULL),
('Sheraton Centre', 13, '2019-08-11', 165, NULL),
('Sheraton Centre', 13, '2019-08-12', 239, NULL),
('Sheraton Centre', 13, '2019-08-13', 178, NULL),
('Sheraton Centre', 13, '2019-08-14', 371, NULL),
('Sheraton Centre', 13, '2019-08-15', 334, NULL),
('Sheraton Centre', 13, '2019-08-16', 108, NULL),
('Sheraton Centre', 13, '2019-08-17', 292, NULL),
('Sheraton Centre', 13, '2019-08-18', 302, NULL),
('Sheraton Centre', 13, '2019-08-19', 341, NULL),
('Sheraton Centre', 13, '2019-08-20', 285, NULL),
('Sheraton Centre', 13, '2019-08-21', 312, NULL),
('Sheraton Centre', 13, '2019-08-22', 328, NULL),
('Sheraton Centre', 13, '2019-08-23', 244, NULL),
('Sheraton Centre', 13, '2019-08-24', 303, NULL),
('Sheraton Centre', 13, '2019-08-25', 304, NULL),
('Sheraton Centre', 13, '2019-08-26', 155, NULL),
('Sheraton Centre', 13, '2019-08-27', 205, NULL),
('Sheraton Centre', 13, '2019-08-28', 102, NULL),
('Sheraton Centre', 13, '2019-08-29', 168, NULL),
('Sheraton Centre', 13, '2019-08-30', 354, NULL),
('Sheraton Centre', 13, '2019-08-31', 184, NULL),
('Sheraton Centre', 13, '2019-09-01', 223, NULL),
('Sheraton Centre', 13, '2019-09-02', 223, NULL),
('Sheraton Centre', 13, '2019-09-03', 233, NULL),
('Sheraton Centre', 13, '2019-09-04', 272, NULL),
('Sheraton Centre', 13, '2019-09-05', 267, NULL),
('Sheraton Centre', 13, '2019-09-06', 223, NULL),
('Sheraton Centre', 13, '2019-09-07', 228, NULL),
('Sheraton Centre', 13, '2019-09-08', 348, NULL),
('Sheraton Centre', 13, '2019-09-09', 106, NULL),
('Sheraton Centre', 13, '2019-09-10', 113, NULL),
('Sheraton Centre', 13, '2019-09-11', 180, NULL),
('Sheraton Centre', 13, '2019-09-12', 221, NULL),
('Sheraton Centre', 13, '2019-09-13', 362, NULL),
('Sheraton Centre', 13, '2019-09-14', 288, NULL),
('Sheraton Centre', 13, '2019-09-15', 264, NULL),
('Sheraton Centre', 13, '2019-09-16', 119, NULL),
('Sheraton Centre', 13, '2019-09-17', 298, NULL),
('Sheraton Centre', 13, '2019-09-18', 383, NULL),
('Sheraton Centre', 13, '2019-09-19', 317, NULL),
('Sheraton Centre', 13, '2019-09-20', 343, NULL),
('Sheraton Centre', 13, '2019-09-21', 118, NULL),
('Sheraton Centre', 13, '2019-09-22', 300, NULL),
('Sheraton Centre', 13, '2019-09-23', 251, NULL),
('Sheraton Centre', 13, '2019-09-24', 355, NULL),
('Sheraton Centre', 13, '2019-09-25', 291, NULL),
('Sheraton Centre', 13, '2019-09-26', 264, 95),
('Sheraton Centre', 13, '2019-09-27', 142, 95),
('Sheraton Centre', 13, '2019-09-28', 314, 95),
('Sheraton Centre', 13, '2019-09-29', 167, 95),
('Sheraton Centre', 13, '2019-09-30', 169, 95),
('Sheraton Centre', 13, '2019-10-01', 292, 95),
('Sheraton Centre', 13, '2019-10-02', 111, 95),
('Sheraton Centre', 13, '2019-10-03', 221, NULL),
('Sheraton Centre', 13, '2019-10-04', 295, NULL),
('Sheraton Centre', 13, '2019-10-05', 350, NULL),
('Sheraton Centre', 13, '2019-10-06', 279, NULL),
('Sheraton Centre', 13, '2019-10-07', 193, NULL),
('Sheraton Centre', 13, '2019-10-08', 272, NULL),
('Sheraton Centre', 13, '2019-10-09', 223, NULL),
('Sheraton Centre', 13, '2019-10-10', 106, NULL),
('Sheraton Centre', 13, '2019-10-11', 131, NULL),
('Sheraton Centre', 13, '2019-10-12', 107, NULL),
('Sheraton Centre', 13, '2019-10-13', 397, NULL),
('Sheraton Centre', 13, '2019-10-14', 121, NULL),
('Sheraton Centre', 13, '2019-10-15', 191, NULL),
('Sheraton Centre', 13, '2019-10-16', 308, NULL),
('Sheraton Centre', 13, '2019-10-17', 262, NULL),
('Sheraton Centre', 13, '2019-10-18', 270, NULL),
('Sheraton Centre', 13, '2019-10-19', 241, NULL),
('Sheraton Centre', 13, '2019-10-20', 322, NULL),
('Sheraton Centre', 13, '2019-10-21', 254, NULL),
('Sheraton Centre', 13, '2019-10-22', 291, NULL),
('Sheraton Centre', 13, '2019-10-23', 309, NULL),
('Sheraton Centre', 13, '2019-10-24', 256, NULL),
('Sheraton Centre', 13, '2019-10-25', 118, NULL),
('Sheraton Centre', 13, '2019-10-26', 171, NULL),
('Sheraton Centre', 13, '2019-10-27', 285, NULL),
('Sheraton Centre', 13, '2019-10-28', 140, NULL),
('Sheraton Centre', 13, '2019-10-29', 160, NULL),
('Sheraton Centre', 13, '2019-10-30', 114, NULL),
('Sheraton Centre', 13, '2019-10-31', 181, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 13, '2019-11-01', 238, NULL),
('Sheraton Centre', 13, '2019-11-02', 398, NULL),
('Sheraton Centre', 13, '2019-11-03', 184, NULL),
('Sheraton Centre', 13, '2019-11-04', 331, NULL),
('Sheraton Centre', 13, '2019-11-05', 183, NULL),
('Sheraton Centre', 13, '2019-11-06', 298, NULL),
('Sheraton Centre', 13, '2019-11-07', 214, NULL),
('Sheraton Centre', 13, '2019-11-08', 365, NULL),
('Sheraton Centre', 13, '2019-11-09', 296, NULL),
('Sheraton Centre', 13, '2019-11-10', 283, NULL),
('Sheraton Centre', 13, '2019-11-11', 185, NULL),
('Sheraton Centre', 13, '2019-11-12', 234, NULL),
('Sheraton Centre', 13, '2019-11-13', 322, NULL),
('Sheraton Centre', 13, '2019-11-14', 206, NULL),
('Sheraton Centre', 13, '2019-11-15', 103, NULL),
('Sheraton Centre', 13, '2019-11-16', 349, NULL),
('Sheraton Centre', 13, '2019-11-17', 213, NULL),
('Sheraton Centre', 13, '2019-11-18', 276, NULL),
('Sheraton Centre', 13, '2019-11-19', 341, NULL),
('Sheraton Centre', 13, '2019-11-20', 288, NULL),
('Sheraton Centre', 13, '2019-11-21', 297, NULL),
('Sheraton Centre', 13, '2019-11-22', 334, NULL),
('Sheraton Centre', 13, '2019-11-23', 379, NULL),
('Sheraton Centre', 13, '2019-11-24', 199, NULL),
('Sheraton Centre', 13, '2019-11-25', 288, NULL),
('Sheraton Centre', 13, '2019-11-26', 104, NULL),
('Sheraton Centre', 13, '2019-11-27', 181, NULL),
('Sheraton Centre', 13, '2019-11-28', 221, NULL),
('Sheraton Centre', 13, '2019-11-29', 363, NULL),
('Sheraton Centre', 13, '2019-11-30', 208, NULL),
('Sheraton Centre', 13, '2019-12-01', 192, NULL),
('Sheraton Centre', 13, '2019-12-02', 347, NULL),
('Sheraton Centre', 13, '2019-12-03', 383, NULL),
('Sheraton Centre', 13, '2019-12-04', 134, NULL),
('Sheraton Centre', 13, '2019-12-05', 248, NULL),
('Sheraton Centre', 13, '2019-12-06', 251, NULL),
('Sheraton Centre', 13, '2019-12-07', 314, NULL),
('Sheraton Centre', 13, '2019-12-08', 252, NULL),
('Sheraton Centre', 13, '2019-12-09', 376, NULL),
('Sheraton Centre', 13, '2019-12-10', 321, NULL),
('Sheraton Centre', 13, '2019-12-11', 200, NULL),
('Sheraton Centre', 13, '2019-12-12', 231, NULL),
('Sheraton Centre', 13, '2019-12-13', 248, 150),
('Sheraton Centre', 13, '2019-12-14', 270, 150),
('Sheraton Centre', 13, '2019-12-15', 111, NULL),
('Sheraton Centre', 13, '2019-12-16', 286, NULL),
('Sheraton Centre', 13, '2019-12-17', 341, NULL),
('Sheraton Centre', 13, '2019-12-18', 216, NULL),
('Sheraton Centre', 13, '2019-12-19', 359, NULL),
('Sheraton Centre', 13, '2019-12-20', 360, NULL),
('Sheraton Centre', 13, '2019-12-21', 110, NULL),
('Sheraton Centre', 13, '2019-12-22', 193, NULL),
('Sheraton Centre', 13, '2019-12-23', 247, NULL),
('Sheraton Centre', 13, '2019-12-24', 161, NULL),
('Sheraton Centre', 13, '2019-12-25', 251, NULL),
('Sheraton Centre', 13, '2019-12-26', 398, NULL),
('Sheraton Centre', 13, '2019-12-27', 189, NULL),
('Sheraton Centre', 13, '2019-12-28', 306, NULL),
('Sheraton Centre', 13, '2019-12-29', 340, 45),
('Sheraton Centre', 13, '2019-12-30', 247, 45),
('Sheraton Centre', 13, '2019-12-31', 108, 45),
('Sheraton Centre', 13, '2020-01-01', 294, 45),
('Sheraton Centre', 13, '2020-01-02', 151, 45),
('Sheraton Centre', 13, '2020-01-03', 363, 45),
('Sheraton Centre', 13, '2020-01-04', 259, 45),
('Sheraton Centre', 13, '2020-01-05', 231, 45),
('Sheraton Centre', 13, '2020-01-06', 303, 45),
('Sheraton Centre', 13, '2020-01-07', 216, 45),
('Sheraton Centre', 13, '2020-01-08', 192, 45),
('Sheraton Centre', 13, '2020-01-09', 343, 45),
('Sheraton Centre', 13, '2020-01-10', 261, 45),
('Sheraton Centre', 13, '2020-01-11', 389, 45),
('Sheraton Centre', 13, '2020-01-12', 209, 45),
('Sheraton Centre', 13, '2020-01-13', 218, 45),
('Sheraton Centre', 13, '2020-01-14', 179, 45),
('Sheraton Centre', 13, '2020-01-15', 297, 45),
('Sheraton Centre', 13, '2020-01-16', 291, 45),
('Sheraton Centre', 13, '2020-01-17', 271, 45),
('Sheraton Centre', 13, '2020-01-18', 134, 45),
('Sheraton Centre', 13, '2020-01-19', 323, 45),
('Sheraton Centre', 13, '2020-01-20', 263, 45),
('Sheraton Centre', 13, '2020-01-21', 351, 45),
('Sheraton Centre', 13, '2020-01-22', 148, 45),
('Sheraton Centre', 13, '2020-01-23', 266, 45),
('Sheraton Centre', 13, '2020-01-24', 233, NULL),
('Sheraton Centre', 13, '2020-01-25', 144, NULL),
('Sheraton Centre', 13, '2020-01-26', 362, NULL),
('Sheraton Centre', 13, '2020-01-27', 283, NULL),
('Sheraton Centre', 13, '2020-01-28', 381, NULL),
('Sheraton Centre', 13, '2020-01-29', 297, NULL),
('Sheraton Centre', 13, '2020-01-30', 309, NULL),
('Sheraton Centre', 13, '2020-01-31', 141, NULL),
('Sheraton Centre', 13, '2020-02-01', 143, NULL),
('Sheraton Centre', 13, '2020-02-02', 294, NULL),
('Sheraton Centre', 13, '2020-02-03', 219, NULL),
('Sheraton Centre', 13, '2020-02-04', 229, NULL),
('Sheraton Centre', 25, '2019-01-01', 278, NULL),
('Sheraton Centre', 25, '2019-01-02', 281, NULL),
('Sheraton Centre', 25, '2019-01-03', 275, NULL),
('Sheraton Centre', 25, '2019-01-04', 237, NULL),
('Sheraton Centre', 25, '2019-01-05', 320, NULL),
('Sheraton Centre', 25, '2019-01-06', 151, NULL),
('Sheraton Centre', 25, '2019-01-07', 210, NULL),
('Sheraton Centre', 25, '2019-01-08', 294, NULL),
('Sheraton Centre', 25, '2019-01-09', 308, NULL),
('Sheraton Centre', 25, '2019-01-10', 361, NULL),
('Sheraton Centre', 25, '2019-01-11', 347, NULL),
('Sheraton Centre', 25, '2019-01-12', 205, NULL),
('Sheraton Centre', 25, '2019-01-13', 304, NULL),
('Sheraton Centre', 25, '2019-01-14', 155, NULL),
('Sheraton Centre', 25, '2019-01-15', 203, NULL),
('Sheraton Centre', 25, '2019-01-16', 263, NULL),
('Sheraton Centre', 25, '2019-01-17', 399, NULL),
('Sheraton Centre', 25, '2019-01-18', 207, NULL),
('Sheraton Centre', 25, '2019-01-19', 137, NULL),
('Sheraton Centre', 25, '2019-01-20', 126, NULL),
('Sheraton Centre', 25, '2019-01-21', 262, NULL),
('Sheraton Centre', 25, '2019-01-22', 207, NULL),
('Sheraton Centre', 25, '2019-01-23', 257, NULL),
('Sheraton Centre', 25, '2019-01-24', 250, NULL),
('Sheraton Centre', 25, '2019-01-25', 376, NULL),
('Sheraton Centre', 25, '2019-01-26', 343, NULL),
('Sheraton Centre', 25, '2019-01-27', 356, NULL),
('Sheraton Centre', 25, '2019-01-28', 371, NULL),
('Sheraton Centre', 25, '2019-01-29', 136, NULL),
('Sheraton Centre', 25, '2019-01-30', 369, NULL),
('Sheraton Centre', 25, '2019-01-31', 385, NULL),
('Sheraton Centre', 25, '2019-02-01', 227, NULL),
('Sheraton Centre', 25, '2019-02-02', 359, NULL),
('Sheraton Centre', 25, '2019-02-03', 343, NULL),
('Sheraton Centre', 25, '2019-02-04', 136, NULL),
('Sheraton Centre', 25, '2019-02-05', 268, NULL),
('Sheraton Centre', 25, '2019-02-06', 110, NULL),
('Sheraton Centre', 25, '2019-02-07', 242, NULL),
('Sheraton Centre', 25, '2019-02-08', 243, NULL),
('Sheraton Centre', 25, '2019-02-09', 305, NULL),
('Sheraton Centre', 25, '2019-02-10', 191, NULL),
('Sheraton Centre', 25, '2019-02-11', 349, NULL),
('Sheraton Centre', 25, '2019-02-12', 345, NULL),
('Sheraton Centre', 25, '2019-02-13', 184, NULL),
('Sheraton Centre', 25, '2019-02-14', 359, NULL),
('Sheraton Centre', 25, '2019-02-15', 260, NULL),
('Sheraton Centre', 25, '2019-02-16', 214, NULL),
('Sheraton Centre', 25, '2019-02-17', 249, NULL),
('Sheraton Centre', 25, '2019-02-18', 222, NULL),
('Sheraton Centre', 25, '2019-02-19', 282, NULL),
('Sheraton Centre', 25, '2019-02-20', 231, NULL),
('Sheraton Centre', 25, '2019-02-21', 200, NULL),
('Sheraton Centre', 25, '2019-02-22', 336, NULL),
('Sheraton Centre', 25, '2019-02-23', 153, NULL),
('Sheraton Centre', 25, '2019-02-24', 198, NULL),
('Sheraton Centre', 25, '2019-02-25', 175, NULL),
('Sheraton Centre', 25, '2019-02-26', 356, NULL),
('Sheraton Centre', 25, '2019-02-27', 113, NULL),
('Sheraton Centre', 25, '2019-02-28', 346, NULL),
('Sheraton Centre', 25, '2019-03-01', 102, NULL),
('Sheraton Centre', 25, '2019-03-02', 394, NULL),
('Sheraton Centre', 25, '2019-03-03', 246, NULL),
('Sheraton Centre', 25, '2019-03-04', 335, NULL),
('Sheraton Centre', 25, '2019-03-05', 324, NULL),
('Sheraton Centre', 25, '2019-03-06', 212, NULL),
('Sheraton Centre', 25, '2019-03-07', 133, NULL),
('Sheraton Centre', 25, '2019-03-08', 211, NULL),
('Sheraton Centre', 25, '2019-03-09', 322, NULL),
('Sheraton Centre', 25, '2019-03-10', 217, NULL),
('Sheraton Centre', 25, '2019-03-11', 104, NULL),
('Sheraton Centre', 25, '2019-03-12', 135, NULL),
('Sheraton Centre', 25, '2019-03-13', 230, NULL),
('Sheraton Centre', 25, '2019-03-14', 157, NULL),
('Sheraton Centre', 25, '2019-03-15', 279, NULL),
('Sheraton Centre', 25, '2019-03-16', 177, NULL),
('Sheraton Centre', 25, '2019-03-17', 213, NULL),
('Sheraton Centre', 25, '2019-03-18', 294, NULL),
('Sheraton Centre', 25, '2019-03-19', 233, NULL),
('Sheraton Centre', 25, '2019-03-20', 110, NULL),
('Sheraton Centre', 25, '2019-03-21', 317, NULL),
('Sheraton Centre', 25, '2019-03-22', 378, NULL),
('Sheraton Centre', 25, '2019-03-23', 384, NULL),
('Sheraton Centre', 25, '2019-03-24', 161, NULL),
('Sheraton Centre', 25, '2019-03-25', 156, NULL),
('Sheraton Centre', 25, '2019-03-26', 181, NULL),
('Sheraton Centre', 25, '2019-03-27', 174, NULL),
('Sheraton Centre', 25, '2019-03-28', 336, NULL),
('Sheraton Centre', 25, '2019-03-29', 241, NULL),
('Sheraton Centre', 25, '2019-03-30', 252, NULL),
('Sheraton Centre', 25, '2019-03-31', 168, NULL),
('Sheraton Centre', 25, '2019-04-01', 389, NULL),
('Sheraton Centre', 25, '2019-04-02', 122, NULL),
('Sheraton Centre', 25, '2019-04-03', 191, NULL),
('Sheraton Centre', 25, '2019-04-04', 170, NULL),
('Sheraton Centre', 25, '2019-04-05', 185, NULL),
('Sheraton Centre', 25, '2019-04-06', 329, NULL),
('Sheraton Centre', 25, '2019-04-07', 385, 124),
('Sheraton Centre', 25, '2019-04-08', 273, 124),
('Sheraton Centre', 25, '2019-04-09', 256, 124),
('Sheraton Centre', 25, '2019-04-10', 284, 124),
('Sheraton Centre', 25, '2019-04-11', 289, 124),
('Sheraton Centre', 25, '2019-04-12', 377, 124),
('Sheraton Centre', 25, '2019-04-13', 107, 124),
('Sheraton Centre', 25, '2019-04-14', 271, 124),
('Sheraton Centre', 25, '2019-04-15', 250, 124),
('Sheraton Centre', 25, '2019-04-16', 258, NULL),
('Sheraton Centre', 25, '2019-04-17', 238, NULL),
('Sheraton Centre', 25, '2019-04-18', 263, NULL),
('Sheraton Centre', 25, '2019-04-19', 341, NULL),
('Sheraton Centre', 25, '2019-04-20', 160, NULL),
('Sheraton Centre', 25, '2019-04-21', 228, NULL),
('Sheraton Centre', 25, '2019-04-22', 109, NULL),
('Sheraton Centre', 25, '2019-04-23', 368, NULL),
('Sheraton Centre', 25, '2019-04-24', 299, NULL),
('Sheraton Centre', 25, '2019-04-25', 183, NULL),
('Sheraton Centre', 25, '2019-04-26', 241, NULL),
('Sheraton Centre', 25, '2019-04-27', 378, NULL),
('Sheraton Centre', 25, '2019-04-28', 237, NULL),
('Sheraton Centre', 25, '2019-04-29', 220, NULL),
('Sheraton Centre', 25, '2019-04-30', 310, NULL),
('Sheraton Centre', 25, '2019-05-01', 264, NULL),
('Sheraton Centre', 25, '2019-05-02', 175, NULL),
('Sheraton Centre', 25, '2019-05-03', 271, NULL),
('Sheraton Centre', 25, '2019-05-04', 249, NULL),
('Sheraton Centre', 25, '2019-05-05', 160, NULL),
('Sheraton Centre', 25, '2019-05-06', 172, NULL),
('Sheraton Centre', 25, '2019-05-07', 386, NULL),
('Sheraton Centre', 25, '2019-05-08', 326, NULL),
('Sheraton Centre', 25, '2019-05-09', 266, NULL),
('Sheraton Centre', 25, '2019-05-10', 146, NULL),
('Sheraton Centre', 25, '2019-05-11', 323, NULL),
('Sheraton Centre', 25, '2019-05-12', 243, NULL),
('Sheraton Centre', 25, '2019-05-13', 338, NULL),
('Sheraton Centre', 25, '2019-05-14', 187, NULL),
('Sheraton Centre', 25, '2019-05-15', 168, NULL),
('Sheraton Centre', 25, '2019-05-16', 338, NULL),
('Sheraton Centre', 25, '2019-05-17', 187, NULL),
('Sheraton Centre', 25, '2019-05-18', 113, NULL),
('Sheraton Centre', 25, '2019-05-19', 254, NULL),
('Sheraton Centre', 25, '2019-05-20', 135, NULL),
('Sheraton Centre', 25, '2019-05-21', 277, NULL),
('Sheraton Centre', 25, '2019-05-22', 168, NULL),
('Sheraton Centre', 25, '2019-05-23', 165, NULL),
('Sheraton Centre', 25, '2019-05-24', 199, NULL),
('Sheraton Centre', 25, '2019-05-25', 210, NULL),
('Sheraton Centre', 25, '2019-05-26', 155, NULL),
('Sheraton Centre', 25, '2019-05-27', 147, NULL),
('Sheraton Centre', 25, '2019-05-28', 387, NULL),
('Sheraton Centre', 25, '2019-05-29', 289, NULL),
('Sheraton Centre', 25, '2019-05-30', 190, NULL),
('Sheraton Centre', 25, '2019-05-31', 269, NULL),
('Sheraton Centre', 25, '2019-06-01', 117, NULL),
('Sheraton Centre', 25, '2019-06-02', 265, NULL),
('Sheraton Centre', 25, '2019-06-03', 235, NULL),
('Sheraton Centre', 25, '2019-06-04', 113, NULL),
('Sheraton Centre', 25, '2019-06-05', 396, NULL),
('Sheraton Centre', 25, '2019-06-06', 160, NULL),
('Sheraton Centre', 25, '2019-06-07', 172, NULL),
('Sheraton Centre', 25, '2019-06-08', 220, NULL),
('Sheraton Centre', 25, '2019-06-09', 333, NULL),
('Sheraton Centre', 25, '2019-06-10', 392, NULL),
('Sheraton Centre', 25, '2019-06-11', 184, NULL),
('Sheraton Centre', 25, '2019-06-12', 395, NULL),
('Sheraton Centre', 25, '2019-06-13', 239, NULL),
('Sheraton Centre', 25, '2019-06-14', 168, NULL),
('Sheraton Centre', 25, '2019-06-15', 131, NULL),
('Sheraton Centre', 25, '2019-06-16', 293, NULL),
('Sheraton Centre', 25, '2019-06-17', 328, NULL),
('Sheraton Centre', 25, '2019-06-18', 251, NULL),
('Sheraton Centre', 25, '2019-06-19', 339, NULL),
('Sheraton Centre', 25, '2019-06-20', 241, NULL),
('Sheraton Centre', 25, '2019-06-21', 162, NULL),
('Sheraton Centre', 25, '2019-06-22', 292, NULL),
('Sheraton Centre', 25, '2019-06-23', 382, NULL),
('Sheraton Centre', 25, '2019-06-24', 310, NULL),
('Sheraton Centre', 25, '2019-06-25', 227, NULL),
('Sheraton Centre', 25, '2019-06-26', 295, NULL),
('Sheraton Centre', 25, '2019-06-27', 158, NULL),
('Sheraton Centre', 25, '2019-06-28', 344, 112),
('Sheraton Centre', 25, '2019-06-29', 307, 112),
('Sheraton Centre', 25, '2019-06-30', 275, 112),
('Sheraton Centre', 25, '2019-07-01', 199, 112),
('Sheraton Centre', 25, '2019-07-02', 298, 112),
('Sheraton Centre', 25, '2019-07-03', 218, 112),
('Sheraton Centre', 25, '2019-07-04', 304, 112),
('Sheraton Centre', 25, '2019-07-05', 200, 112),
('Sheraton Centre', 25, '2019-07-06', 144, 112),
('Sheraton Centre', 25, '2019-07-07', 268, 112),
('Sheraton Centre', 25, '2019-07-08', 396, 112),
('Sheraton Centre', 25, '2019-07-09', 190, 112),
('Sheraton Centre', 25, '2019-07-10', 359, 112),
('Sheraton Centre', 25, '2019-07-11', 266, 112),
('Sheraton Centre', 25, '2019-07-12', 382, 112),
('Sheraton Centre', 25, '2019-07-13', 100, 112),
('Sheraton Centre', 25, '2019-07-14', 218, NULL),
('Sheraton Centre', 25, '2019-07-15', 252, NULL),
('Sheraton Centre', 25, '2019-07-16', 293, NULL),
('Sheraton Centre', 25, '2019-07-17', 276, NULL),
('Sheraton Centre', 25, '2019-07-18', 375, NULL),
('Sheraton Centre', 25, '2019-07-19', 349, NULL),
('Sheraton Centre', 25, '2019-07-20', 354, NULL),
('Sheraton Centre', 25, '2019-07-21', 392, NULL),
('Sheraton Centre', 25, '2019-07-22', 102, NULL),
('Sheraton Centre', 25, '2019-07-23', 311, NULL),
('Sheraton Centre', 25, '2019-07-24', 150, NULL),
('Sheraton Centre', 25, '2019-07-25', 247, NULL),
('Sheraton Centre', 25, '2019-07-26', 114, NULL),
('Sheraton Centre', 25, '2019-07-27', 188, NULL),
('Sheraton Centre', 25, '2019-07-28', 310, NULL),
('Sheraton Centre', 25, '2019-07-29', 222, NULL),
('Sheraton Centre', 25, '2019-07-30', 106, NULL),
('Sheraton Centre', 25, '2019-07-31', 259, NULL),
('Sheraton Centre', 25, '2019-08-01', 177, NULL),
('Sheraton Centre', 25, '2019-08-02', 399, NULL),
('Sheraton Centre', 25, '2019-08-03', 165, NULL),
('Sheraton Centre', 25, '2019-08-04', 392, NULL),
('Sheraton Centre', 25, '2019-08-05', 221, NULL),
('Sheraton Centre', 25, '2019-08-06', 377, NULL),
('Sheraton Centre', 25, '2019-08-07', 166, NULL),
('Sheraton Centre', 25, '2019-08-08', 101, NULL),
('Sheraton Centre', 25, '2019-08-09', 348, NULL),
('Sheraton Centre', 25, '2019-08-10', 250, NULL),
('Sheraton Centre', 25, '2019-08-11', 156, NULL),
('Sheraton Centre', 25, '2019-08-12', 242, NULL),
('Sheraton Centre', 25, '2019-08-13', 329, NULL),
('Sheraton Centre', 25, '2019-08-14', 347, NULL),
('Sheraton Centre', 25, '2019-08-15', 285, NULL),
('Sheraton Centre', 25, '2019-08-16', 210, NULL),
('Sheraton Centre', 25, '2019-08-17', 162, NULL),
('Sheraton Centre', 25, '2019-08-18', 138, NULL),
('Sheraton Centre', 25, '2019-08-19', 352, NULL),
('Sheraton Centre', 25, '2019-08-20', 387, NULL),
('Sheraton Centre', 25, '2019-08-21', 177, NULL),
('Sheraton Centre', 25, '2019-08-22', 194, NULL),
('Sheraton Centre', 25, '2019-08-23', 168, NULL),
('Sheraton Centre', 25, '2019-08-24', 289, NULL),
('Sheraton Centre', 25, '2019-08-25', 137, NULL),
('Sheraton Centre', 25, '2019-08-26', 342, NULL),
('Sheraton Centre', 25, '2019-08-27', 351, NULL),
('Sheraton Centre', 25, '2019-08-28', 319, NULL),
('Sheraton Centre', 25, '2019-08-29', 219, NULL),
('Sheraton Centre', 25, '2019-08-30', 308, NULL),
('Sheraton Centre', 25, '2019-08-31', 375, NULL),
('Sheraton Centre', 25, '2019-09-01', 158, NULL),
('Sheraton Centre', 25, '2019-09-02', 167, NULL),
('Sheraton Centre', 25, '2019-09-03', 353, NULL),
('Sheraton Centre', 25, '2019-09-04', 284, NULL),
('Sheraton Centre', 25, '2019-09-05', 148, NULL),
('Sheraton Centre', 25, '2019-09-06', 386, NULL),
('Sheraton Centre', 25, '2019-09-07', 255, NULL),
('Sheraton Centre', 25, '2019-09-08', 124, NULL),
('Sheraton Centre', 25, '2019-09-09', 143, NULL),
('Sheraton Centre', 25, '2019-09-10', 366, NULL),
('Sheraton Centre', 25, '2019-09-11', 326, NULL),
('Sheraton Centre', 25, '2019-09-12', 243, NULL),
('Sheraton Centre', 25, '2019-09-13', 132, NULL),
('Sheraton Centre', 25, '2019-09-14', 215, NULL),
('Sheraton Centre', 25, '2019-09-15', 179, NULL),
('Sheraton Centre', 25, '2019-09-16', 285, NULL),
('Sheraton Centre', 25, '2019-09-17', 206, 170),
('Sheraton Centre', 25, '2019-09-18', 321, 170),
('Sheraton Centre', 25, '2019-09-19', 202, 170),
('Sheraton Centre', 25, '2019-09-20', 370, 170),
('Sheraton Centre', 25, '2019-09-21', 374, 170),
('Sheraton Centre', 25, '2019-09-22', 300, 170),
('Sheraton Centre', 25, '2019-09-23', 160, 170),
('Sheraton Centre', 25, '2019-09-24', 151, 170),
('Sheraton Centre', 25, '2019-09-25', 226, 170),
('Sheraton Centre', 25, '2019-09-26', 310, 170),
('Sheraton Centre', 25, '2019-09-27', 396, 170),
('Sheraton Centre', 25, '2019-09-28', 272, 170),
('Sheraton Centre', 25, '2019-09-29', 390, 170),
('Sheraton Centre', 25, '2019-09-30', 197, NULL),
('Sheraton Centre', 25, '2019-10-01', 268, NULL),
('Sheraton Centre', 25, '2019-10-02', 258, NULL),
('Sheraton Centre', 25, '2019-10-03', 171, NULL),
('Sheraton Centre', 25, '2019-10-04', 102, NULL),
('Sheraton Centre', 25, '2019-10-05', 100, NULL),
('Sheraton Centre', 25, '2019-10-06', 336, NULL),
('Sheraton Centre', 25, '2019-10-07', 148, NULL),
('Sheraton Centre', 25, '2019-10-08', 249, NULL),
('Sheraton Centre', 25, '2019-10-09', 297, NULL),
('Sheraton Centre', 25, '2019-10-10', 275, NULL),
('Sheraton Centre', 25, '2019-10-11', 145, NULL),
('Sheraton Centre', 25, '2019-10-12', 225, NULL),
('Sheraton Centre', 25, '2019-10-13', 341, NULL),
('Sheraton Centre', 25, '2019-10-14', 138, NULL),
('Sheraton Centre', 25, '2019-10-15', 328, NULL),
('Sheraton Centre', 25, '2019-10-16', 188, NULL),
('Sheraton Centre', 25, '2019-10-17', 328, NULL),
('Sheraton Centre', 25, '2019-10-18', 318, NULL),
('Sheraton Centre', 25, '2019-10-19', 228, NULL),
('Sheraton Centre', 25, '2019-10-20', 126, NULL),
('Sheraton Centre', 25, '2019-10-21', 312, NULL),
('Sheraton Centre', 25, '2019-10-22', 143, NULL),
('Sheraton Centre', 25, '2019-10-23', 355, NULL),
('Sheraton Centre', 25, '2019-10-24', 265, NULL),
('Sheraton Centre', 25, '2019-10-25', 119, NULL),
('Sheraton Centre', 25, '2019-10-26', 347, NULL),
('Sheraton Centre', 25, '2019-10-27', 344, NULL),
('Sheraton Centre', 25, '2019-10-28', 382, NULL),
('Sheraton Centre', 25, '2019-10-29', 106, NULL),
('Sheraton Centre', 25, '2019-10-30', 186, NULL),
('Sheraton Centre', 25, '2019-10-31', 333, NULL),
('Sheraton Centre', 25, '2019-11-01', 276, NULL),
('Sheraton Centre', 25, '2019-11-02', 170, NULL),
('Sheraton Centre', 25, '2019-11-03', 244, NULL),
('Sheraton Centre', 25, '2019-11-04', 226, NULL),
('Sheraton Centre', 25, '2019-11-05', 328, NULL),
('Sheraton Centre', 25, '2019-11-06', 128, NULL),
('Sheraton Centre', 25, '2019-11-07', 302, NULL),
('Sheraton Centre', 25, '2019-11-08', 184, NULL),
('Sheraton Centre', 25, '2019-11-09', 224, NULL),
('Sheraton Centre', 25, '2019-11-10', 299, NULL),
('Sheraton Centre', 25, '2019-11-11', 161, NULL),
('Sheraton Centre', 25, '2019-11-12', 155, NULL),
('Sheraton Centre', 25, '2019-11-13', 288, NULL),
('Sheraton Centre', 25, '2019-11-14', 357, NULL),
('Sheraton Centre', 25, '2019-11-15', 153, NULL),
('Sheraton Centre', 25, '2019-11-16', 289, NULL),
('Sheraton Centre', 25, '2019-11-17', 153, NULL),
('Sheraton Centre', 25, '2019-11-18', 376, NULL),
('Sheraton Centre', 25, '2019-11-19', 276, NULL),
('Sheraton Centre', 25, '2019-11-20', 150, NULL),
('Sheraton Centre', 25, '2019-11-21', 261, NULL),
('Sheraton Centre', 25, '2019-11-22', 326, NULL),
('Sheraton Centre', 25, '2019-11-23', 275, NULL),
('Sheraton Centre', 25, '2019-11-24', 197, NULL),
('Sheraton Centre', 25, '2019-11-25', 237, NULL),
('Sheraton Centre', 25, '2019-11-26', 370, NULL),
('Sheraton Centre', 25, '2019-11-27', 388, NULL),
('Sheraton Centre', 25, '2019-11-28', 266, NULL),
('Sheraton Centre', 25, '2019-11-29', 251, NULL),
('Sheraton Centre', 25, '2019-11-30', 254, NULL),
('Sheraton Centre', 25, '2019-12-01', 314, NULL),
('Sheraton Centre', 25, '2019-12-02', 191, NULL),
('Sheraton Centre', 25, '2019-12-03', 169, NULL),
('Sheraton Centre', 25, '2019-12-04', 250, NULL),
('Sheraton Centre', 25, '2019-12-05', 376, NULL),
('Sheraton Centre', 25, '2019-12-06', 390, NULL),
('Sheraton Centre', 25, '2019-12-07', 396, NULL),
('Sheraton Centre', 25, '2019-12-08', 140, NULL),
('Sheraton Centre', 25, '2019-12-09', 332, NULL),
('Sheraton Centre', 25, '2019-12-10', 268, NULL),
('Sheraton Centre', 25, '2019-12-11', 220, NULL),
('Sheraton Centre', 25, '2019-12-12', 392, NULL),
('Sheraton Centre', 25, '2019-12-13', 331, NULL),
('Sheraton Centre', 25, '2019-12-14', 209, NULL),
('Sheraton Centre', 25, '2019-12-15', 256, NULL),
('Sheraton Centre', 25, '2019-12-16', 153, NULL),
('Sheraton Centre', 25, '2019-12-17', 367, NULL),
('Sheraton Centre', 25, '2019-12-18', 253, NULL),
('Sheraton Centre', 25, '2019-12-19', 326, NULL),
('Sheraton Centre', 25, '2019-12-20', 379, 175),
('Sheraton Centre', 25, '2019-12-21', 303, 175),
('Sheraton Centre', 25, '2019-12-22', 147, 175),
('Sheraton Centre', 25, '2019-12-23', 306, 175),
('Sheraton Centre', 25, '2019-12-24', 124, 175),
('Sheraton Centre', 25, '2019-12-25', 129, 175),
('Sheraton Centre', 25, '2019-12-26', 306, 175),
('Sheraton Centre', 25, '2019-12-27', 265, 175),
('Sheraton Centre', 25, '2019-12-28', 333, 175),
('Sheraton Centre', 25, '2019-12-29', 249, 175),
('Sheraton Centre', 25, '2019-12-30', 360, 175),
('Sheraton Centre', 25, '2019-12-31', 279, 175),
('Sheraton Centre', 25, '2020-01-01', 216, NULL),
('Sheraton Centre', 25, '2020-01-02', 328, NULL),
('Sheraton Centre', 25, '2020-01-03', 350, NULL),
('Sheraton Centre', 25, '2020-01-04', 296, NULL),
('Sheraton Centre', 25, '2020-01-05', 168, NULL),
('Sheraton Centre', 25, '2020-01-06', 107, NULL),
('Sheraton Centre', 25, '2020-01-07', 240, NULL),
('Sheraton Centre', 25, '2020-01-08', 150, NULL),
('Sheraton Centre', 25, '2020-01-09', 126, NULL),
('Sheraton Centre', 25, '2020-01-10', 328, NULL),
('Sheraton Centre', 25, '2020-01-11', 302, NULL),
('Sheraton Centre', 25, '2020-01-12', 155, NULL),
('Sheraton Centre', 25, '2020-01-13', 247, NULL),
('Sheraton Centre', 25, '2020-01-14', 346, NULL),
('Sheraton Centre', 25, '2020-01-15', 346, NULL),
('Sheraton Centre', 25, '2020-01-16', 280, NULL),
('Sheraton Centre', 25, '2020-01-17', 244, NULL),
('Sheraton Centre', 25, '2020-01-18', 390, NULL),
('Sheraton Centre', 25, '2020-01-19', 353, NULL),
('Sheraton Centre', 25, '2020-01-20', 124, NULL),
('Sheraton Centre', 25, '2020-01-21', 275, NULL),
('Sheraton Centre', 25, '2020-01-22', 209, NULL),
('Sheraton Centre', 25, '2020-01-23', 290, NULL),
('Sheraton Centre', 25, '2020-01-24', 263, NULL),
('Sheraton Centre', 25, '2020-01-25', 354, NULL),
('Sheraton Centre', 25, '2020-01-26', 241, NULL),
('Sheraton Centre', 25, '2020-01-27', 237, NULL),
('Sheraton Centre', 25, '2020-01-28', 128, NULL),
('Sheraton Centre', 25, '2020-01-29', 294, NULL),
('Sheraton Centre', 25, '2020-01-30', 172, NULL),
('Sheraton Centre', 25, '2020-01-31', 293, NULL),
('Sheraton Centre', 25, '2020-02-01', 251, NULL),
('Sheraton Centre', 25, '2020-02-02', 186, NULL),
('Sheraton Centre', 25, '2020-02-03', 274, NULL),
('Sheraton Centre', 25, '2020-02-04', 269, NULL),
('Sheraton Centre', 34, '2019-01-01', 114, NULL),
('Sheraton Centre', 34, '2019-01-02', 300, NULL),
('Sheraton Centre', 34, '2019-01-03', 240, NULL),
('Sheraton Centre', 34, '2019-01-04', 178, NULL),
('Sheraton Centre', 34, '2019-01-05', 176, NULL),
('Sheraton Centre', 34, '2019-01-06', 390, NULL),
('Sheraton Centre', 34, '2019-01-07', 164, NULL),
('Sheraton Centre', 34, '2019-01-08', 332, NULL),
('Sheraton Centre', 34, '2019-01-09', 120, NULL),
('Sheraton Centre', 34, '2019-01-10', 181, NULL),
('Sheraton Centre', 34, '2019-01-11', 317, NULL),
('Sheraton Centre', 34, '2019-01-12', 278, NULL),
('Sheraton Centre', 34, '2019-01-13', 201, NULL),
('Sheraton Centre', 34, '2019-01-14', 250, NULL),
('Sheraton Centre', 34, '2019-01-15', 388, NULL),
('Sheraton Centre', 34, '2019-01-16', 121, NULL),
('Sheraton Centre', 34, '2019-01-17', 368, NULL),
('Sheraton Centre', 34, '2019-01-18', 265, NULL),
('Sheraton Centre', 34, '2019-01-19', 354, NULL),
('Sheraton Centre', 34, '2019-01-20', 192, NULL),
('Sheraton Centre', 34, '2019-01-21', 204, NULL),
('Sheraton Centre', 34, '2019-01-22', 378, NULL),
('Sheraton Centre', 34, '2019-01-23', 180, NULL),
('Sheraton Centre', 34, '2019-01-24', 355, NULL),
('Sheraton Centre', 34, '2019-01-25', 149, NULL),
('Sheraton Centre', 34, '2019-01-26', 226, NULL),
('Sheraton Centre', 34, '2019-01-27', 128, NULL),
('Sheraton Centre', 34, '2019-01-28', 130, NULL),
('Sheraton Centre', 34, '2019-01-29', 373, NULL),
('Sheraton Centre', 34, '2019-01-30', 216, NULL),
('Sheraton Centre', 34, '2019-01-31', 352, NULL),
('Sheraton Centre', 34, '2019-02-01', 337, NULL),
('Sheraton Centre', 34, '2019-02-02', 384, NULL),
('Sheraton Centre', 34, '2019-02-03', 352, NULL),
('Sheraton Centre', 34, '2019-02-04', 355, NULL),
('Sheraton Centre', 34, '2019-02-05', 180, NULL),
('Sheraton Centre', 34, '2019-02-06', 340, NULL),
('Sheraton Centre', 34, '2019-02-07', 357, NULL),
('Sheraton Centre', 34, '2019-02-08', 209, NULL),
('Sheraton Centre', 34, '2019-02-09', 153, NULL),
('Sheraton Centre', 34, '2019-02-10', 272, NULL),
('Sheraton Centre', 34, '2019-02-11', 223, NULL),
('Sheraton Centre', 34, '2019-02-12', 107, NULL),
('Sheraton Centre', 34, '2019-02-13', 254, NULL),
('Sheraton Centre', 34, '2019-02-14', 242, NULL),
('Sheraton Centre', 34, '2019-02-15', 327, NULL),
('Sheraton Centre', 34, '2019-02-16', 327, NULL),
('Sheraton Centre', 34, '2019-02-17', 232, NULL),
('Sheraton Centre', 34, '2019-02-18', 133, NULL),
('Sheraton Centre', 34, '2019-02-19', 168, NULL),
('Sheraton Centre', 34, '2019-02-20', 168, NULL),
('Sheraton Centre', 34, '2019-02-21', 285, NULL),
('Sheraton Centre', 34, '2019-02-22', 142, NULL),
('Sheraton Centre', 34, '2019-02-23', 259, NULL),
('Sheraton Centre', 34, '2019-02-24', 130, NULL),
('Sheraton Centre', 34, '2019-02-25', 354, NULL),
('Sheraton Centre', 34, '2019-02-26', 325, NULL),
('Sheraton Centre', 34, '2019-02-27', 366, NULL),
('Sheraton Centre', 34, '2019-02-28', 392, NULL),
('Sheraton Centre', 34, '2019-03-01', 300, NULL),
('Sheraton Centre', 34, '2019-03-02', 171, NULL),
('Sheraton Centre', 34, '2019-03-03', 363, NULL),
('Sheraton Centre', 34, '2019-03-04', 385, NULL),
('Sheraton Centre', 34, '2019-03-05', 193, NULL),
('Sheraton Centre', 34, '2019-03-06', 189, NULL),
('Sheraton Centre', 34, '2019-03-07', 342, NULL),
('Sheraton Centre', 34, '2019-03-08', 358, NULL),
('Sheraton Centre', 34, '2019-03-09', 312, NULL),
('Sheraton Centre', 34, '2019-03-10', 117, NULL),
('Sheraton Centre', 34, '2019-03-11', 260, NULL),
('Sheraton Centre', 34, '2019-03-12', 323, NULL),
('Sheraton Centre', 34, '2019-03-13', 159, NULL),
('Sheraton Centre', 34, '2019-03-14', 149, NULL),
('Sheraton Centre', 34, '2019-03-15', 393, NULL),
('Sheraton Centre', 34, '2019-03-16', 303, NULL),
('Sheraton Centre', 34, '2019-03-17', 285, NULL),
('Sheraton Centre', 34, '2019-03-18', 106, NULL),
('Sheraton Centre', 34, '2019-03-19', 252, NULL),
('Sheraton Centre', 34, '2019-03-20', 310, NULL),
('Sheraton Centre', 34, '2019-03-21', 381, NULL),
('Sheraton Centre', 34, '2019-03-22', 289, NULL),
('Sheraton Centre', 34, '2019-03-23', 297, NULL),
('Sheraton Centre', 34, '2019-03-24', 297, NULL),
('Sheraton Centre', 34, '2019-03-25', 353, NULL),
('Sheraton Centre', 34, '2019-03-26', 122, NULL),
('Sheraton Centre', 34, '2019-03-27', 252, NULL),
('Sheraton Centre', 34, '2019-03-28', 190, NULL),
('Sheraton Centre', 34, '2019-03-29', 301, NULL),
('Sheraton Centre', 34, '2019-03-30', 102, NULL),
('Sheraton Centre', 34, '2019-03-31', 381, NULL),
('Sheraton Centre', 34, '2019-04-01', 130, NULL),
('Sheraton Centre', 34, '2019-04-02', 379, NULL),
('Sheraton Centre', 34, '2019-04-03', 391, NULL),
('Sheraton Centre', 34, '2019-04-04', 309, 134),
('Sheraton Centre', 34, '2019-04-05', 279, 134),
('Sheraton Centre', 34, '2019-04-06', 372, 134),
('Sheraton Centre', 34, '2019-04-07', 323, 134),
('Sheraton Centre', 34, '2019-04-08', 184, 134),
('Sheraton Centre', 34, '2019-04-09', 101, 134),
('Sheraton Centre', 34, '2019-04-10', 374, 134),
('Sheraton Centre', 34, '2019-04-11', 296, 134),
('Sheraton Centre', 34, '2019-04-12', 271, 134),
('Sheraton Centre', 34, '2019-04-13', 263, 134),
('Sheraton Centre', 34, '2019-04-14', 167, 134),
('Sheraton Centre', 34, '2019-04-15', 103, 134),
('Sheraton Centre', 34, '2019-04-16', 250, 134),
('Sheraton Centre', 34, '2019-04-17', 262, 134),
('Sheraton Centre', 34, '2019-04-18', 349, 134),
('Sheraton Centre', 34, '2019-04-19', 141, 134),
('Sheraton Centre', 34, '2019-04-20', 267, 134),
('Sheraton Centre', 34, '2019-04-21', 158, 134),
('Sheraton Centre', 34, '2019-04-22', 110, 134),
('Sheraton Centre', 34, '2019-04-23', 129, 134),
('Sheraton Centre', 34, '2019-04-24', 301, 134),
('Sheraton Centre', 34, '2019-04-25', 269, 134),
('Sheraton Centre', 34, '2019-04-26', 382, 134),
('Sheraton Centre', 34, '2019-04-27', 191, 134),
('Sheraton Centre', 34, '2019-04-28', 197, 134),
('Sheraton Centre', 34, '2019-04-29', 312, 134),
('Sheraton Centre', 34, '2019-04-30', 113, 134),
('Sheraton Centre', 34, '2019-05-01', 383, 134),
('Sheraton Centre', 34, '2019-05-02', 349, NULL),
('Sheraton Centre', 34, '2019-05-03', 376, NULL),
('Sheraton Centre', 34, '2019-05-04', 137, NULL),
('Sheraton Centre', 34, '2019-05-05', 204, NULL),
('Sheraton Centre', 34, '2019-05-06', 347, NULL),
('Sheraton Centre', 34, '2019-05-07', 353, NULL),
('Sheraton Centre', 34, '2019-05-08', 344, NULL),
('Sheraton Centre', 34, '2019-05-09', 227, NULL),
('Sheraton Centre', 34, '2019-05-10', 187, NULL),
('Sheraton Centre', 34, '2019-05-11', 171, NULL),
('Sheraton Centre', 34, '2019-05-12', 152, NULL),
('Sheraton Centre', 34, '2019-05-13', 294, NULL),
('Sheraton Centre', 34, '2019-05-14', 267, NULL),
('Sheraton Centre', 34, '2019-05-15', 176, NULL),
('Sheraton Centre', 34, '2019-05-16', 386, NULL),
('Sheraton Centre', 34, '2019-05-17', 158, NULL),
('Sheraton Centre', 34, '2019-05-18', 284, NULL),
('Sheraton Centre', 34, '2019-05-19', 161, NULL),
('Sheraton Centre', 34, '2019-05-20', 377, NULL),
('Sheraton Centre', 34, '2019-05-21', 228, NULL),
('Sheraton Centre', 34, '2019-05-22', 143, NULL),
('Sheraton Centre', 34, '2019-05-23', 338, NULL),
('Sheraton Centre', 34, '2019-05-24', 367, NULL),
('Sheraton Centre', 34, '2019-05-25', 235, NULL),
('Sheraton Centre', 34, '2019-05-26', 379, NULL),
('Sheraton Centre', 34, '2019-05-27', 319, NULL),
('Sheraton Centre', 34, '2019-05-28', 153, NULL),
('Sheraton Centre', 34, '2019-05-29', 271, NULL),
('Sheraton Centre', 34, '2019-05-30', 101, NULL),
('Sheraton Centre', 34, '2019-05-31', 239, NULL),
('Sheraton Centre', 34, '2019-06-01', 262, NULL),
('Sheraton Centre', 34, '2019-06-02', 393, NULL),
('Sheraton Centre', 34, '2019-06-03', 383, NULL),
('Sheraton Centre', 34, '2019-06-04', 147, NULL),
('Sheraton Centre', 34, '2019-06-05', 263, NULL),
('Sheraton Centre', 34, '2019-06-06', 306, NULL),
('Sheraton Centre', 34, '2019-06-07', 376, NULL),
('Sheraton Centre', 34, '2019-06-08', 273, NULL),
('Sheraton Centre', 34, '2019-06-09', 251, NULL),
('Sheraton Centre', 34, '2019-06-10', 161, NULL),
('Sheraton Centre', 34, '2019-06-11', 336, NULL),
('Sheraton Centre', 34, '2019-06-12', 373, NULL),
('Sheraton Centre', 34, '2019-06-13', 171, NULL),
('Sheraton Centre', 34, '2019-06-14', 241, NULL),
('Sheraton Centre', 34, '2019-06-15', 353, NULL),
('Sheraton Centre', 34, '2019-06-16', 340, NULL),
('Sheraton Centre', 34, '2019-06-17', 119, NULL),
('Sheraton Centre', 34, '2019-06-18', 175, NULL),
('Sheraton Centre', 34, '2019-06-19', 250, NULL),
('Sheraton Centre', 34, '2019-06-20', 129, NULL),
('Sheraton Centre', 34, '2019-06-21', 329, NULL),
('Sheraton Centre', 34, '2019-06-22', 367, NULL),
('Sheraton Centre', 34, '2019-06-23', 235, NULL),
('Sheraton Centre', 34, '2019-06-24', 167, NULL),
('Sheraton Centre', 34, '2019-06-25', 324, NULL),
('Sheraton Centre', 34, '2019-06-26', 161, NULL),
('Sheraton Centre', 34, '2019-06-27', 219, NULL),
('Sheraton Centre', 34, '2019-06-28', 323, NULL),
('Sheraton Centre', 34, '2019-06-29', 234, NULL),
('Sheraton Centre', 34, '2019-06-30', 186, NULL),
('Sheraton Centre', 34, '2019-07-01', 249, NULL),
('Sheraton Centre', 34, '2019-07-02', 373, NULL),
('Sheraton Centre', 34, '2019-07-03', 157, NULL),
('Sheraton Centre', 34, '2019-07-04', 303, NULL),
('Sheraton Centre', 34, '2019-07-05', 325, NULL),
('Sheraton Centre', 34, '2019-07-06', 268, NULL),
('Sheraton Centre', 34, '2019-07-07', 211, NULL),
('Sheraton Centre', 34, '2019-07-08', 217, NULL),
('Sheraton Centre', 34, '2019-07-09', 178, NULL),
('Sheraton Centre', 34, '2019-07-10', 277, NULL),
('Sheraton Centre', 34, '2019-07-11', 250, NULL),
('Sheraton Centre', 34, '2019-07-12', 280, NULL),
('Sheraton Centre', 34, '2019-07-13', 199, NULL),
('Sheraton Centre', 34, '2019-07-14', 283, NULL),
('Sheraton Centre', 34, '2019-07-15', 226, NULL),
('Sheraton Centre', 34, '2019-07-16', 104, NULL),
('Sheraton Centre', 34, '2019-07-17', 286, NULL),
('Sheraton Centre', 34, '2019-07-18', 226, NULL),
('Sheraton Centre', 34, '2019-07-19', 280, NULL),
('Sheraton Centre', 34, '2019-07-20', 197, NULL),
('Sheraton Centre', 34, '2019-07-21', 341, NULL),
('Sheraton Centre', 34, '2019-07-22', 109, NULL),
('Sheraton Centre', 34, '2019-07-23', 296, NULL),
('Sheraton Centre', 34, '2019-07-24', 288, NULL),
('Sheraton Centre', 34, '2019-07-25', 302, NULL),
('Sheraton Centre', 34, '2019-07-26', 293, NULL),
('Sheraton Centre', 34, '2019-07-27', 147, NULL),
('Sheraton Centre', 34, '2019-07-28', 366, NULL),
('Sheraton Centre', 34, '2019-07-29', 234, NULL),
('Sheraton Centre', 34, '2019-07-30', 223, NULL),
('Sheraton Centre', 34, '2019-07-31', 167, NULL),
('Sheraton Centre', 34, '2019-08-01', 186, NULL),
('Sheraton Centre', 34, '2019-08-02', 129, NULL),
('Sheraton Centre', 34, '2019-08-03', 137, NULL),
('Sheraton Centre', 34, '2019-08-04', 131, NULL),
('Sheraton Centre', 34, '2019-08-05', 254, NULL),
('Sheraton Centre', 34, '2019-08-06', 124, NULL),
('Sheraton Centre', 34, '2019-08-07', 360, NULL),
('Sheraton Centre', 34, '2019-08-08', 320, NULL),
('Sheraton Centre', 34, '2019-08-09', 240, NULL),
('Sheraton Centre', 34, '2019-08-10', 282, NULL),
('Sheraton Centre', 34, '2019-08-11', 184, NULL),
('Sheraton Centre', 34, '2019-08-12', 396, NULL),
('Sheraton Centre', 34, '2019-08-13', 111, NULL),
('Sheraton Centre', 34, '2019-08-14', 225, NULL),
('Sheraton Centre', 34, '2019-08-15', 321, NULL),
('Sheraton Centre', 34, '2019-08-16', 329, NULL),
('Sheraton Centre', 34, '2019-08-17', 137, NULL),
('Sheraton Centre', 34, '2019-08-18', 282, NULL),
('Sheraton Centre', 34, '2019-08-19', 336, NULL),
('Sheraton Centre', 34, '2019-08-20', 382, NULL),
('Sheraton Centre', 34, '2019-08-21', 151, NULL),
('Sheraton Centre', 34, '2019-08-22', 190, NULL),
('Sheraton Centre', 34, '2019-08-23', 311, NULL),
('Sheraton Centre', 34, '2019-08-24', 137, NULL),
('Sheraton Centre', 34, '2019-08-25', 273, NULL),
('Sheraton Centre', 34, '2019-08-26', 245, NULL),
('Sheraton Centre', 34, '2019-08-27', 140, NULL),
('Sheraton Centre', 34, '2019-08-28', 290, NULL),
('Sheraton Centre', 34, '2019-08-29', 190, NULL),
('Sheraton Centre', 34, '2019-08-30', 378, NULL),
('Sheraton Centre', 34, '2019-08-31', 325, NULL),
('Sheraton Centre', 34, '2019-09-01', 320, NULL),
('Sheraton Centre', 34, '2019-09-02', 368, NULL),
('Sheraton Centre', 34, '2019-09-03', 366, NULL),
('Sheraton Centre', 34, '2019-09-04', 206, NULL),
('Sheraton Centre', 34, '2019-09-05', 141, NULL),
('Sheraton Centre', 34, '2019-09-06', 262, NULL),
('Sheraton Centre', 34, '2019-09-07', 193, NULL),
('Sheraton Centre', 34, '2019-09-08', 376, NULL),
('Sheraton Centre', 34, '2019-09-09', 301, NULL),
('Sheraton Centre', 34, '2019-09-10', 190, NULL),
('Sheraton Centre', 34, '2019-09-11', 389, NULL),
('Sheraton Centre', 34, '2019-09-12', 156, NULL),
('Sheraton Centre', 34, '2019-09-13', 374, NULL),
('Sheraton Centre', 34, '2019-09-14', 115, NULL),
('Sheraton Centre', 34, '2019-09-15', 301, NULL),
('Sheraton Centre', 34, '2019-09-16', 369, NULL),
('Sheraton Centre', 34, '2019-09-17', 336, NULL),
('Sheraton Centre', 34, '2019-09-18', 356, NULL),
('Sheraton Centre', 34, '2019-09-19', 262, NULL),
('Sheraton Centre', 34, '2019-09-20', 125, NULL),
('Sheraton Centre', 34, '2019-09-21', 214, NULL),
('Sheraton Centre', 34, '2019-09-22', 200, NULL),
('Sheraton Centre', 34, '2019-09-23', 247, NULL),
('Sheraton Centre', 34, '2019-09-24', 190, NULL),
('Sheraton Centre', 34, '2019-09-25', 159, NULL),
('Sheraton Centre', 34, '2019-09-26', 358, NULL),
('Sheraton Centre', 34, '2019-09-27', 254, NULL),
('Sheraton Centre', 34, '2019-09-28', 319, NULL),
('Sheraton Centre', 34, '2019-09-29', 147, NULL),
('Sheraton Centre', 34, '2019-09-30', 377, NULL),
('Sheraton Centre', 34, '2019-10-01', 364, NULL),
('Sheraton Centre', 34, '2019-10-02', 258, NULL),
('Sheraton Centre', 34, '2019-10-03', 393, NULL),
('Sheraton Centre', 34, '2019-10-04', 126, NULL),
('Sheraton Centre', 34, '2019-10-05', 251, NULL),
('Sheraton Centre', 34, '2019-10-06', 145, NULL),
('Sheraton Centre', 34, '2019-10-07', 359, NULL),
('Sheraton Centre', 34, '2019-10-08', 331, NULL),
('Sheraton Centre', 34, '2019-10-09', 120, NULL),
('Sheraton Centre', 34, '2019-10-10', 357, NULL),
('Sheraton Centre', 34, '2019-10-11', 231, NULL),
('Sheraton Centre', 34, '2019-10-12', 106, NULL),
('Sheraton Centre', 34, '2019-10-13', 112, NULL),
('Sheraton Centre', 34, '2019-10-14', 225, NULL),
('Sheraton Centre', 34, '2019-10-15', 367, NULL),
('Sheraton Centre', 34, '2019-10-16', 220, NULL),
('Sheraton Centre', 34, '2019-10-17', 156, NULL),
('Sheraton Centre', 34, '2019-10-18', 379, NULL),
('Sheraton Centre', 34, '2019-10-19', 318, NULL),
('Sheraton Centre', 34, '2019-10-20', 166, NULL),
('Sheraton Centre', 34, '2019-10-21', 100, NULL),
('Sheraton Centre', 34, '2019-10-22', 343, NULL),
('Sheraton Centre', 34, '2019-10-23', 147, NULL),
('Sheraton Centre', 34, '2019-10-24', 157, NULL),
('Sheraton Centre', 34, '2019-10-25', 144, NULL),
('Sheraton Centre', 34, '2019-10-26', 221, NULL),
('Sheraton Centre', 34, '2019-10-27', 165, NULL),
('Sheraton Centre', 34, '2019-10-28', 189, NULL),
('Sheraton Centre', 34, '2019-10-29', 252, NULL),
('Sheraton Centre', 34, '2019-10-30', 189, NULL),
('Sheraton Centre', 34, '2019-10-31', 120, NULL),
('Sheraton Centre', 34, '2019-11-01', 266, NULL),
('Sheraton Centre', 34, '2019-11-02', 157, NULL),
('Sheraton Centre', 34, '2019-11-03', 267, NULL),
('Sheraton Centre', 34, '2019-11-04', 339, NULL),
('Sheraton Centre', 34, '2019-11-05', 392, NULL),
('Sheraton Centre', 34, '2019-11-06', 250, NULL),
('Sheraton Centre', 34, '2019-11-07', 167, NULL),
('Sheraton Centre', 34, '2019-11-08', 324, NULL),
('Sheraton Centre', 34, '2019-11-09', 133, NULL),
('Sheraton Centre', 34, '2019-11-10', 246, NULL),
('Sheraton Centre', 34, '2019-11-11', 147, NULL),
('Sheraton Centre', 34, '2019-11-12', 273, NULL),
('Sheraton Centre', 34, '2019-11-13', 377, NULL),
('Sheraton Centre', 34, '2019-11-14', 165, NULL),
('Sheraton Centre', 34, '2019-11-15', 356, NULL),
('Sheraton Centre', 34, '2019-11-16', 298, NULL),
('Sheraton Centre', 34, '2019-11-17', 327, NULL),
('Sheraton Centre', 34, '2019-11-18', 351, NULL),
('Sheraton Centre', 34, '2019-11-19', 260, NULL),
('Sheraton Centre', 34, '2019-11-20', 383, NULL),
('Sheraton Centre', 34, '2019-11-21', 314, NULL),
('Sheraton Centre', 34, '2019-11-22', 230, NULL),
('Sheraton Centre', 34, '2019-11-23', 139, NULL),
('Sheraton Centre', 34, '2019-11-24', 288, NULL),
('Sheraton Centre', 34, '2019-11-25', 221, NULL),
('Sheraton Centre', 34, '2019-11-26', 240, NULL),
('Sheraton Centre', 34, '2019-11-27', 100, NULL),
('Sheraton Centre', 34, '2019-11-28', 268, NULL),
('Sheraton Centre', 34, '2019-11-29', 370, NULL),
('Sheraton Centre', 34, '2019-11-30', 245, NULL),
('Sheraton Centre', 34, '2019-12-01', 293, NULL),
('Sheraton Centre', 34, '2019-12-02', 117, NULL),
('Sheraton Centre', 34, '2019-12-03', 198, NULL),
('Sheraton Centre', 34, '2019-12-04', 152, NULL),
('Sheraton Centre', 34, '2019-12-05', 135, NULL),
('Sheraton Centre', 34, '2019-12-06', 198, NULL),
('Sheraton Centre', 34, '2019-12-07', 340, NULL),
('Sheraton Centre', 34, '2019-12-08', 145, NULL),
('Sheraton Centre', 34, '2019-12-09', 129, NULL),
('Sheraton Centre', 34, '2019-12-10', 275, NULL),
('Sheraton Centre', 34, '2019-12-11', 101, NULL),
('Sheraton Centre', 34, '2019-12-12', 269, NULL),
('Sheraton Centre', 34, '2019-12-13', 211, NULL),
('Sheraton Centre', 34, '2019-12-14', 136, NULL),
('Sheraton Centre', 34, '2019-12-15', 250, NULL),
('Sheraton Centre', 34, '2019-12-16', 106, NULL),
('Sheraton Centre', 34, '2019-12-17', 113, NULL),
('Sheraton Centre', 34, '2019-12-18', 219, NULL),
('Sheraton Centre', 34, '2019-12-19', 154, NULL),
('Sheraton Centre', 34, '2019-12-20', 117, NULL),
('Sheraton Centre', 34, '2019-12-21', 186, NULL),
('Sheraton Centre', 34, '2019-12-22', 357, NULL),
('Sheraton Centre', 34, '2019-12-23', 393, NULL),
('Sheraton Centre', 34, '2019-12-24', 336, NULL),
('Sheraton Centre', 34, '2019-12-25', 393, NULL),
('Sheraton Centre', 34, '2019-12-26', 235, NULL),
('Sheraton Centre', 34, '2019-12-27', 361, NULL),
('Sheraton Centre', 34, '2019-12-28', 347, NULL),
('Sheraton Centre', 34, '2019-12-29', 123, NULL),
('Sheraton Centre', 34, '2019-12-30', 362, NULL),
('Sheraton Centre', 34, '2019-12-31', 371, NULL),
('Sheraton Centre', 34, '2020-01-01', 398, NULL),
('Sheraton Centre', 34, '2020-01-02', 189, NULL),
('Sheraton Centre', 34, '2020-01-03', 261, NULL),
('Sheraton Centre', 34, '2020-01-04', 305, NULL),
('Sheraton Centre', 34, '2020-01-05', 347, NULL),
('Sheraton Centre', 34, '2020-01-06', 127, NULL),
('Sheraton Centre', 34, '2020-01-07', 151, NULL),
('Sheraton Centre', 34, '2020-01-08', 376, NULL),
('Sheraton Centre', 34, '2020-01-09', 100, NULL),
('Sheraton Centre', 34, '2020-01-10', 157, NULL),
('Sheraton Centre', 34, '2020-01-11', 244, NULL),
('Sheraton Centre', 34, '2020-01-12', 348, NULL),
('Sheraton Centre', 34, '2020-01-13', 178, NULL),
('Sheraton Centre', 34, '2020-01-14', 193, NULL),
('Sheraton Centre', 34, '2020-01-15', 138, NULL),
('Sheraton Centre', 34, '2020-01-16', 130, NULL),
('Sheraton Centre', 34, '2020-01-17', 310, NULL),
('Sheraton Centre', 34, '2020-01-18', 251, NULL),
('Sheraton Centre', 34, '2020-01-19', 398, NULL),
('Sheraton Centre', 34, '2020-01-20', 332, NULL),
('Sheraton Centre', 34, '2020-01-21', 223, NULL),
('Sheraton Centre', 34, '2020-01-22', 200, NULL),
('Sheraton Centre', 34, '2020-01-23', 253, NULL),
('Sheraton Centre', 34, '2020-01-24', 219, NULL),
('Sheraton Centre', 34, '2020-01-25', 340, NULL),
('Sheraton Centre', 34, '2020-01-26', 319, NULL),
('Sheraton Centre', 34, '2020-01-27', 239, NULL),
('Sheraton Centre', 34, '2020-01-28', 298, NULL),
('Sheraton Centre', 34, '2020-01-29', 180, NULL),
('Sheraton Centre', 34, '2020-01-30', 133, NULL),
('Sheraton Centre', 34, '2020-01-31', 340, NULL),
('Sheraton Centre', 34, '2020-02-01', 129, NULL),
('Sheraton Centre', 34, '2020-02-02', 251, NULL),
('Sheraton Centre', 34, '2020-02-03', 314, NULL),
('Sheraton Centre', 34, '2020-02-04', 260, NULL),
('Sheraton Centre', 41, '2019-01-01', 238, NULL),
('Sheraton Centre', 41, '2019-01-02', 257, NULL),
('Sheraton Centre', 41, '2019-01-03', 277, NULL),
('Sheraton Centre', 41, '2019-01-04', 381, NULL),
('Sheraton Centre', 41, '2019-01-05', 124, NULL),
('Sheraton Centre', 41, '2019-01-06', 198, NULL),
('Sheraton Centre', 41, '2019-01-07', 391, NULL),
('Sheraton Centre', 41, '2019-01-08', 376, NULL),
('Sheraton Centre', 41, '2019-01-09', 179, NULL),
('Sheraton Centre', 41, '2019-01-10', 326, NULL),
('Sheraton Centre', 41, '2019-01-11', 143, NULL),
('Sheraton Centre', 41, '2019-01-12', 374, NULL),
('Sheraton Centre', 41, '2019-01-13', 293, NULL),
('Sheraton Centre', 41, '2019-01-14', 383, NULL),
('Sheraton Centre', 41, '2019-01-15', 332, NULL),
('Sheraton Centre', 41, '2019-01-16', 315, NULL),
('Sheraton Centre', 41, '2019-01-17', 247, NULL),
('Sheraton Centre', 41, '2019-01-18', 304, NULL),
('Sheraton Centre', 41, '2019-01-19', 359, NULL),
('Sheraton Centre', 41, '2019-01-20', 180, NULL),
('Sheraton Centre', 41, '2019-01-21', 137, NULL),
('Sheraton Centre', 41, '2019-01-22', 267, NULL),
('Sheraton Centre', 41, '2019-01-23', 330, NULL),
('Sheraton Centre', 41, '2019-01-24', 325, NULL),
('Sheraton Centre', 41, '2019-01-25', 120, NULL),
('Sheraton Centre', 41, '2019-01-26', 303, NULL),
('Sheraton Centre', 41, '2019-01-27', 373, NULL),
('Sheraton Centre', 41, '2019-01-28', 341, NULL),
('Sheraton Centre', 41, '2019-01-29', 158, NULL),
('Sheraton Centre', 41, '2019-01-30', 177, NULL),
('Sheraton Centre', 41, '2019-01-31', 204, NULL),
('Sheraton Centre', 41, '2019-02-01', 303, NULL),
('Sheraton Centre', 41, '2019-02-02', 143, NULL),
('Sheraton Centre', 41, '2019-02-03', 332, NULL),
('Sheraton Centre', 41, '2019-02-04', 366, NULL),
('Sheraton Centre', 41, '2019-02-05', 296, NULL),
('Sheraton Centre', 41, '2019-02-06', 369, NULL),
('Sheraton Centre', 41, '2019-02-07', 358, NULL),
('Sheraton Centre', 41, '2019-02-08', 218, NULL),
('Sheraton Centre', 41, '2019-02-09', 350, NULL),
('Sheraton Centre', 41, '2019-02-10', 389, NULL),
('Sheraton Centre', 41, '2019-02-11', 268, NULL),
('Sheraton Centre', 41, '2019-02-12', 300, NULL),
('Sheraton Centre', 41, '2019-02-13', 322, NULL),
('Sheraton Centre', 41, '2019-02-14', 333, NULL),
('Sheraton Centre', 41, '2019-02-15', 157, NULL),
('Sheraton Centre', 41, '2019-02-16', 291, NULL),
('Sheraton Centre', 41, '2019-02-17', 315, NULL),
('Sheraton Centre', 41, '2019-02-18', 199, NULL),
('Sheraton Centre', 41, '2019-02-19', 196, NULL),
('Sheraton Centre', 41, '2019-02-20', 347, NULL),
('Sheraton Centre', 41, '2019-02-21', 129, NULL),
('Sheraton Centre', 41, '2019-02-22', 201, NULL),
('Sheraton Centre', 41, '2019-02-23', 134, NULL),
('Sheraton Centre', 41, '2019-02-24', 255, NULL),
('Sheraton Centre', 41, '2019-02-25', 248, NULL),
('Sheraton Centre', 41, '2019-02-26', 160, NULL),
('Sheraton Centre', 41, '2019-02-27', 194, NULL),
('Sheraton Centre', 41, '2019-02-28', 222, NULL),
('Sheraton Centre', 41, '2019-03-01', 192, NULL),
('Sheraton Centre', 41, '2019-03-02', 173, NULL),
('Sheraton Centre', 41, '2019-03-03', 377, NULL),
('Sheraton Centre', 41, '2019-03-04', 220, NULL),
('Sheraton Centre', 41, '2019-03-05', 194, NULL),
('Sheraton Centre', 41, '2019-03-06', 208, NULL),
('Sheraton Centre', 41, '2019-03-07', 312, NULL),
('Sheraton Centre', 41, '2019-03-08', 158, NULL),
('Sheraton Centre', 41, '2019-03-09', 198, NULL),
('Sheraton Centre', 41, '2019-03-10', 135, NULL),
('Sheraton Centre', 41, '2019-03-11', 289, NULL),
('Sheraton Centre', 41, '2019-03-12', 213, NULL),
('Sheraton Centre', 41, '2019-03-13', 307, NULL),
('Sheraton Centre', 41, '2019-03-14', 174, NULL),
('Sheraton Centre', 41, '2019-03-15', 126, NULL),
('Sheraton Centre', 41, '2019-03-16', 283, NULL),
('Sheraton Centre', 41, '2019-03-17', 389, NULL),
('Sheraton Centre', 41, '2019-03-18', 146, NULL),
('Sheraton Centre', 41, '2019-03-19', 164, NULL),
('Sheraton Centre', 41, '2019-03-20', 220, NULL),
('Sheraton Centre', 41, '2019-03-21', 256, NULL),
('Sheraton Centre', 41, '2019-03-22', 212, NULL),
('Sheraton Centre', 41, '2019-03-23', 232, NULL),
('Sheraton Centre', 41, '2019-03-24', 301, NULL),
('Sheraton Centre', 41, '2019-03-25', 298, NULL),
('Sheraton Centre', 41, '2019-03-26', 266, NULL),
('Sheraton Centre', 41, '2019-03-27', 337, NULL),
('Sheraton Centre', 41, '2019-03-28', 145, NULL),
('Sheraton Centre', 41, '2019-03-29', 384, NULL),
('Sheraton Centre', 41, '2019-03-30', 258, NULL),
('Sheraton Centre', 41, '2019-03-31', 103, NULL),
('Sheraton Centre', 41, '2019-04-01', 282, NULL),
('Sheraton Centre', 41, '2019-04-02', 231, NULL),
('Sheraton Centre', 41, '2019-04-03', 385, NULL),
('Sheraton Centre', 41, '2019-04-04', 336, NULL),
('Sheraton Centre', 41, '2019-04-05', 140, NULL),
('Sheraton Centre', 41, '2019-04-06', 172, NULL),
('Sheraton Centre', 41, '2019-04-07', 360, NULL),
('Sheraton Centre', 41, '2019-04-08', 301, NULL),
('Sheraton Centre', 41, '2019-04-09', 237, NULL),
('Sheraton Centre', 41, '2019-04-10', 317, NULL),
('Sheraton Centre', 41, '2019-04-11', 212, NULL),
('Sheraton Centre', 41, '2019-04-12', 126, NULL),
('Sheraton Centre', 41, '2019-04-13', 297, NULL),
('Sheraton Centre', 41, '2019-04-14', 222, NULL),
('Sheraton Centre', 41, '2019-04-15', 264, NULL),
('Sheraton Centre', 41, '2019-04-16', 376, NULL),
('Sheraton Centre', 41, '2019-04-17', 198, NULL),
('Sheraton Centre', 41, '2019-04-18', 256, NULL),
('Sheraton Centre', 41, '2019-04-19', 181, NULL),
('Sheraton Centre', 41, '2019-04-20', 158, NULL),
('Sheraton Centre', 41, '2019-04-21', 304, NULL),
('Sheraton Centre', 41, '2019-04-22', 122, NULL),
('Sheraton Centre', 41, '2019-04-23', 342, NULL),
('Sheraton Centre', 41, '2019-04-24', 210, NULL),
('Sheraton Centre', 41, '2019-04-25', 395, NULL),
('Sheraton Centre', 41, '2019-04-26', 186, NULL),
('Sheraton Centre', 41, '2019-04-27', 323, NULL),
('Sheraton Centre', 41, '2019-04-28', 173, NULL),
('Sheraton Centre', 41, '2019-04-29', 203, NULL),
('Sheraton Centre', 41, '2019-04-30', 138, NULL),
('Sheraton Centre', 41, '2019-05-01', 121, NULL),
('Sheraton Centre', 41, '2019-05-02', 219, NULL),
('Sheraton Centre', 41, '2019-05-03', 366, NULL),
('Sheraton Centre', 41, '2019-05-04', 139, NULL),
('Sheraton Centre', 41, '2019-05-05', 140, NULL),
('Sheraton Centre', 41, '2019-05-06', 220, NULL),
('Sheraton Centre', 41, '2019-05-07', 205, NULL),
('Sheraton Centre', 41, '2019-05-08', 345, NULL),
('Sheraton Centre', 41, '2019-05-09', 240, NULL),
('Sheraton Centre', 41, '2019-05-10', 397, NULL),
('Sheraton Centre', 41, '2019-05-11', 385, NULL),
('Sheraton Centre', 41, '2019-05-12', 230, NULL),
('Sheraton Centre', 41, '2019-05-13', 357, NULL),
('Sheraton Centre', 41, '2019-05-14', 374, NULL),
('Sheraton Centre', 41, '2019-05-15', 275, NULL),
('Sheraton Centre', 41, '2019-05-16', 217, NULL),
('Sheraton Centre', 41, '2019-05-17', 128, NULL),
('Sheraton Centre', 41, '2019-05-18', 380, NULL),
('Sheraton Centre', 41, '2019-05-19', 244, NULL),
('Sheraton Centre', 41, '2019-05-20', 182, NULL),
('Sheraton Centre', 41, '2019-05-21', 210, NULL),
('Sheraton Centre', 41, '2019-05-22', 112, NULL),
('Sheraton Centre', 41, '2019-05-23', 193, NULL),
('Sheraton Centre', 41, '2019-05-24', 236, NULL),
('Sheraton Centre', 41, '2019-05-25', 149, NULL),
('Sheraton Centre', 41, '2019-05-26', 130, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 41, '2019-05-27', 154, NULL),
('Sheraton Centre', 41, '2019-05-28', 102, NULL),
('Sheraton Centre', 41, '2019-05-29', 389, NULL),
('Sheraton Centre', 41, '2019-05-30', 135, NULL),
('Sheraton Centre', 41, '2019-05-31', 288, NULL),
('Sheraton Centre', 41, '2019-06-01', 260, NULL),
('Sheraton Centre', 41, '2019-06-02', 173, NULL),
('Sheraton Centre', 41, '2019-06-03', 209, NULL),
('Sheraton Centre', 41, '2019-06-04', 295, NULL),
('Sheraton Centre', 41, '2019-06-05', 325, NULL),
('Sheraton Centre', 41, '2019-06-06', 349, NULL),
('Sheraton Centre', 41, '2019-06-07', 366, NULL),
('Sheraton Centre', 41, '2019-06-08', 307, NULL),
('Sheraton Centre', 41, '2019-06-09', 155, NULL),
('Sheraton Centre', 41, '2019-06-10', 131, NULL),
('Sheraton Centre', 41, '2019-06-11', 128, NULL),
('Sheraton Centre', 41, '2019-06-12', 282, NULL),
('Sheraton Centre', 41, '2019-06-13', 337, NULL),
('Sheraton Centre', 41, '2019-06-14', 299, NULL),
('Sheraton Centre', 41, '2019-06-15', 371, NULL),
('Sheraton Centre', 41, '2019-06-16', 121, NULL),
('Sheraton Centre', 41, '2019-06-17', 109, NULL),
('Sheraton Centre', 41, '2019-06-18', 324, NULL),
('Sheraton Centre', 41, '2019-06-19', 137, NULL),
('Sheraton Centre', 41, '2019-06-20', 120, NULL),
('Sheraton Centre', 41, '2019-06-21', 162, NULL),
('Sheraton Centre', 41, '2019-06-22', 262, NULL),
('Sheraton Centre', 41, '2019-06-23', 228, NULL),
('Sheraton Centre', 41, '2019-06-24', 103, NULL),
('Sheraton Centre', 41, '2019-06-25', 238, NULL),
('Sheraton Centre', 41, '2019-06-26', 122, NULL),
('Sheraton Centre', 41, '2019-06-27', 222, NULL),
('Sheraton Centre', 41, '2019-06-28', 183, NULL),
('Sheraton Centre', 41, '2019-06-29', 149, NULL),
('Sheraton Centre', 41, '2019-06-30', 304, NULL),
('Sheraton Centre', 41, '2019-07-01', 246, NULL),
('Sheraton Centre', 41, '2019-07-02', 272, NULL),
('Sheraton Centre', 41, '2019-07-03', 332, NULL),
('Sheraton Centre', 41, '2019-07-04', 203, NULL),
('Sheraton Centre', 41, '2019-07-05', 326, NULL),
('Sheraton Centre', 41, '2019-07-06', 209, NULL),
('Sheraton Centre', 41, '2019-07-07', 149, NULL),
('Sheraton Centre', 41, '2019-07-08', 398, NULL),
('Sheraton Centre', 41, '2019-07-09', 218, NULL),
('Sheraton Centre', 41, '2019-07-10', 212, NULL),
('Sheraton Centre', 41, '2019-07-11', 352, NULL),
('Sheraton Centre', 41, '2019-07-12', 157, NULL),
('Sheraton Centre', 41, '2019-07-13', 299, NULL),
('Sheraton Centre', 41, '2019-07-14', 363, NULL),
('Sheraton Centre', 41, '2019-07-15', 275, NULL),
('Sheraton Centre', 41, '2019-07-16', 143, NULL),
('Sheraton Centre', 41, '2019-07-17', 202, NULL),
('Sheraton Centre', 41, '2019-07-18', 209, NULL),
('Sheraton Centre', 41, '2019-07-19', 252, NULL),
('Sheraton Centre', 41, '2019-07-20', 126, NULL),
('Sheraton Centre', 41, '2019-07-21', 131, NULL),
('Sheraton Centre', 41, '2019-07-22', 139, NULL),
('Sheraton Centre', 41, '2019-07-23', 146, NULL),
('Sheraton Centre', 41, '2019-07-24', 290, NULL),
('Sheraton Centre', 41, '2019-07-25', 369, NULL),
('Sheraton Centre', 41, '2019-07-26', 126, NULL),
('Sheraton Centre', 41, '2019-07-27', 373, NULL),
('Sheraton Centre', 41, '2019-07-28', 203, NULL),
('Sheraton Centre', 41, '2019-07-29', 103, NULL),
('Sheraton Centre', 41, '2019-07-30', 395, NULL),
('Sheraton Centre', 41, '2019-07-31', 259, NULL),
('Sheraton Centre', 41, '2019-08-01', 301, NULL),
('Sheraton Centre', 41, '2019-08-02', 250, NULL),
('Sheraton Centre', 41, '2019-08-03', 389, NULL),
('Sheraton Centre', 41, '2019-08-04', 278, NULL),
('Sheraton Centre', 41, '2019-08-05', 206, NULL),
('Sheraton Centre', 41, '2019-08-06', 289, NULL),
('Sheraton Centre', 41, '2019-08-07', 301, NULL),
('Sheraton Centre', 41, '2019-08-08', 297, NULL),
('Sheraton Centre', 41, '2019-08-09', 359, NULL),
('Sheraton Centre', 41, '2019-08-10', 258, NULL),
('Sheraton Centre', 41, '2019-08-11', 355, NULL),
('Sheraton Centre', 41, '2019-08-12', 251, NULL),
('Sheraton Centre', 41, '2019-08-13', 368, NULL),
('Sheraton Centre', 41, '2019-08-14', 285, NULL),
('Sheraton Centre', 41, '2019-08-15', 352, NULL),
('Sheraton Centre', 41, '2019-08-16', 313, NULL),
('Sheraton Centre', 41, '2019-08-17', 100, NULL),
('Sheraton Centre', 41, '2019-08-18', 296, NULL),
('Sheraton Centre', 41, '2019-08-19', 223, NULL),
('Sheraton Centre', 41, '2019-08-20', 347, NULL),
('Sheraton Centre', 41, '2019-08-21', 122, NULL),
('Sheraton Centre', 41, '2019-08-22', 265, NULL),
('Sheraton Centre', 41, '2019-08-23', 349, NULL),
('Sheraton Centre', 41, '2019-08-24', 317, NULL),
('Sheraton Centre', 41, '2019-08-25', 255, NULL),
('Sheraton Centre', 41, '2019-08-26', 100, NULL),
('Sheraton Centre', 41, '2019-08-27', 147, NULL),
('Sheraton Centre', 41, '2019-08-28', 393, NULL),
('Sheraton Centre', 41, '2019-08-29', 196, NULL),
('Sheraton Centre', 41, '2019-08-30', 267, NULL),
('Sheraton Centre', 41, '2019-08-31', 100, NULL),
('Sheraton Centre', 41, '2019-09-01', 129, NULL),
('Sheraton Centre', 41, '2019-09-02', 339, NULL),
('Sheraton Centre', 41, '2019-09-03', 370, NULL),
('Sheraton Centre', 41, '2019-09-04', 379, NULL),
('Sheraton Centre', 41, '2019-09-05', 161, NULL),
('Sheraton Centre', 41, '2019-09-06', 352, NULL),
('Sheraton Centre', 41, '2019-09-07', 101, NULL),
('Sheraton Centre', 41, '2019-09-08', 209, NULL),
('Sheraton Centre', 41, '2019-09-09', 373, NULL),
('Sheraton Centre', 41, '2019-09-10', 355, NULL),
('Sheraton Centre', 41, '2019-09-11', 270, NULL),
('Sheraton Centre', 41, '2019-09-12', 250, NULL),
('Sheraton Centre', 41, '2019-09-13', 175, NULL),
('Sheraton Centre', 41, '2019-09-14', 127, NULL),
('Sheraton Centre', 41, '2019-09-15', 271, NULL),
('Sheraton Centre', 41, '2019-09-16', 289, NULL),
('Sheraton Centre', 41, '2019-09-17', 365, NULL),
('Sheraton Centre', 41, '2019-09-18', 116, NULL),
('Sheraton Centre', 41, '2019-09-19', 305, NULL),
('Sheraton Centre', 41, '2019-09-20', 312, NULL),
('Sheraton Centre', 41, '2019-09-21', 148, NULL),
('Sheraton Centre', 41, '2019-09-22', 299, NULL),
('Sheraton Centre', 41, '2019-09-23', 353, NULL),
('Sheraton Centre', 41, '2019-09-24', 396, NULL),
('Sheraton Centre', 41, '2019-09-25', 317, NULL),
('Sheraton Centre', 41, '2019-09-26', 160, NULL),
('Sheraton Centre', 41, '2019-09-27', 280, NULL),
('Sheraton Centre', 41, '2019-09-28', 379, NULL),
('Sheraton Centre', 41, '2019-09-29', 367, NULL),
('Sheraton Centre', 41, '2019-09-30', 296, NULL),
('Sheraton Centre', 41, '2019-10-01', 315, NULL),
('Sheraton Centre', 41, '2019-10-02', 117, NULL),
('Sheraton Centre', 41, '2019-10-03', 152, NULL),
('Sheraton Centre', 41, '2019-10-04', 225, NULL),
('Sheraton Centre', 41, '2019-10-05', 255, NULL),
('Sheraton Centre', 41, '2019-10-06', 215, NULL),
('Sheraton Centre', 41, '2019-10-07', 354, NULL),
('Sheraton Centre', 41, '2019-10-08', 207, NULL),
('Sheraton Centre', 41, '2019-10-09', 207, NULL),
('Sheraton Centre', 41, '2019-10-10', 261, NULL),
('Sheraton Centre', 41, '2019-10-11', 320, NULL),
('Sheraton Centre', 41, '2019-10-12', 354, NULL),
('Sheraton Centre', 41, '2019-10-13', 338, NULL),
('Sheraton Centre', 41, '2019-10-14', 312, NULL),
('Sheraton Centre', 41, '2019-10-15', 153, NULL),
('Sheraton Centre', 41, '2019-10-16', 137, NULL),
('Sheraton Centre', 41, '2019-10-17', 298, NULL),
('Sheraton Centre', 41, '2019-10-18', 241, NULL),
('Sheraton Centre', 41, '2019-10-19', 206, NULL),
('Sheraton Centre', 41, '2019-10-20', 349, NULL),
('Sheraton Centre', 41, '2019-10-21', 364, NULL),
('Sheraton Centre', 41, '2019-10-22', 286, NULL),
('Sheraton Centre', 41, '2019-10-23', 171, NULL),
('Sheraton Centre', 41, '2019-10-24', 193, NULL),
('Sheraton Centre', 41, '2019-10-25', 262, NULL),
('Sheraton Centre', 41, '2019-10-26', 264, NULL),
('Sheraton Centre', 41, '2019-10-27', 294, NULL),
('Sheraton Centre', 41, '2019-10-28', 300, NULL),
('Sheraton Centre', 41, '2019-10-29', 243, NULL),
('Sheraton Centre', 41, '2019-10-30', 288, NULL),
('Sheraton Centre', 41, '2019-10-31', 103, NULL),
('Sheraton Centre', 41, '2019-11-01', 100, NULL),
('Sheraton Centre', 41, '2019-11-02', 173, NULL),
('Sheraton Centre', 41, '2019-11-03', 206, NULL),
('Sheraton Centre', 41, '2019-11-04', 316, NULL),
('Sheraton Centre', 41, '2019-11-05', 278, NULL),
('Sheraton Centre', 41, '2019-11-06', 164, NULL),
('Sheraton Centre', 41, '2019-11-07', 130, NULL),
('Sheraton Centre', 41, '2019-11-08', 367, NULL),
('Sheraton Centre', 41, '2019-11-09', 193, NULL),
('Sheraton Centre', 41, '2019-11-10', 233, NULL),
('Sheraton Centre', 41, '2019-11-11', 156, NULL),
('Sheraton Centre', 41, '2019-11-12', 201, NULL),
('Sheraton Centre', 41, '2019-11-13', 319, NULL),
('Sheraton Centre', 41, '2019-11-14', 254, NULL),
('Sheraton Centre', 41, '2019-11-15', 323, NULL),
('Sheraton Centre', 41, '2019-11-16', 223, NULL),
('Sheraton Centre', 41, '2019-11-17', 175, NULL),
('Sheraton Centre', 41, '2019-11-18', 229, NULL),
('Sheraton Centre', 41, '2019-11-19', 369, NULL),
('Sheraton Centre', 41, '2019-11-20', 166, NULL),
('Sheraton Centre', 41, '2019-11-21', 388, NULL),
('Sheraton Centre', 41, '2019-11-22', 372, NULL),
('Sheraton Centre', 41, '2019-11-23', 372, NULL),
('Sheraton Centre', 41, '2019-11-24', 150, NULL),
('Sheraton Centre', 41, '2019-11-25', 294, NULL),
('Sheraton Centre', 41, '2019-11-26', 289, NULL),
('Sheraton Centre', 41, '2019-11-27', 135, NULL),
('Sheraton Centre', 41, '2019-11-28', 142, NULL),
('Sheraton Centre', 41, '2019-11-29', 394, NULL),
('Sheraton Centre', 41, '2019-11-30', 362, NULL),
('Sheraton Centre', 41, '2019-12-01', 125, NULL),
('Sheraton Centre', 41, '2019-12-02', 210, NULL),
('Sheraton Centre', 41, '2019-12-03', 385, NULL),
('Sheraton Centre', 41, '2019-12-04', 208, NULL),
('Sheraton Centre', 41, '2019-12-05', 349, NULL),
('Sheraton Centre', 41, '2019-12-06', 319, NULL),
('Sheraton Centre', 41, '2019-12-07', 110, NULL),
('Sheraton Centre', 41, '2019-12-08', 207, NULL),
('Sheraton Centre', 41, '2019-12-09', 153, NULL),
('Sheraton Centre', 41, '2019-12-10', 173, NULL),
('Sheraton Centre', 41, '2019-12-11', 346, NULL),
('Sheraton Centre', 41, '2019-12-12', 369, NULL),
('Sheraton Centre', 41, '2019-12-13', 265, NULL),
('Sheraton Centre', 41, '2019-12-14', 252, NULL),
('Sheraton Centre', 41, '2019-12-15', 381, NULL),
('Sheraton Centre', 41, '2019-12-16', 272, NULL),
('Sheraton Centre', 41, '2019-12-17', 262, NULL),
('Sheraton Centre', 41, '2019-12-18', 233, NULL),
('Sheraton Centre', 41, '2019-12-19', 291, NULL),
('Sheraton Centre', 41, '2019-12-20', 246, NULL),
('Sheraton Centre', 41, '2019-12-21', 223, NULL),
('Sheraton Centre', 41, '2019-12-22', 345, NULL),
('Sheraton Centre', 41, '2019-12-23', 346, NULL),
('Sheraton Centre', 41, '2019-12-24', 309, NULL),
('Sheraton Centre', 41, '2019-12-25', 276, NULL),
('Sheraton Centre', 41, '2019-12-26', 160, NULL),
('Sheraton Centre', 41, '2019-12-27', 308, NULL),
('Sheraton Centre', 41, '2019-12-28', 338, NULL),
('Sheraton Centre', 41, '2019-12-29', 371, NULL),
('Sheraton Centre', 41, '2019-12-30', 330, NULL),
('Sheraton Centre', 41, '2019-12-31', 320, NULL),
('Sheraton Centre', 41, '2020-01-01', 344, NULL),
('Sheraton Centre', 41, '2020-01-02', 160, NULL),
('Sheraton Centre', 41, '2020-01-03', 155, NULL),
('Sheraton Centre', 41, '2020-01-04', 235, NULL),
('Sheraton Centre', 41, '2020-01-05', 233, NULL),
('Sheraton Centre', 41, '2020-01-06', 215, NULL),
('Sheraton Centre', 41, '2020-01-07', 236, NULL),
('Sheraton Centre', 41, '2020-01-08', 127, NULL),
('Sheraton Centre', 41, '2020-01-09', 322, NULL),
('Sheraton Centre', 41, '2020-01-10', 300, NULL),
('Sheraton Centre', 41, '2020-01-11', 214, NULL),
('Sheraton Centre', 41, '2020-01-12', 276, NULL),
('Sheraton Centre', 41, '2020-01-13', 350, NULL),
('Sheraton Centre', 41, '2020-01-14', 129, NULL),
('Sheraton Centre', 41, '2020-01-15', 151, NULL),
('Sheraton Centre', 41, '2020-01-16', 310, NULL),
('Sheraton Centre', 41, '2020-01-17', 118, NULL),
('Sheraton Centre', 41, '2020-01-18', 283, NULL),
('Sheraton Centre', 41, '2020-01-19', 229, NULL),
('Sheraton Centre', 41, '2020-01-20', 287, NULL),
('Sheraton Centre', 41, '2020-01-21', 191, NULL),
('Sheraton Centre', 41, '2020-01-22', 272, NULL),
('Sheraton Centre', 41, '2020-01-23', 293, NULL),
('Sheraton Centre', 41, '2020-01-24', 204, NULL),
('Sheraton Centre', 41, '2020-01-25', 235, NULL),
('Sheraton Centre', 41, '2020-01-26', 174, NULL),
('Sheraton Centre', 41, '2020-01-27', 383, NULL),
('Sheraton Centre', 41, '2020-01-28', 107, NULL),
('Sheraton Centre', 41, '2020-01-29', 219, NULL),
('Sheraton Centre', 41, '2020-01-30', 353, NULL),
('Sheraton Centre', 41, '2020-01-31', 125, NULL),
('Sheraton Centre', 41, '2020-02-01', 393, NULL),
('Sheraton Centre', 41, '2020-02-02', 297, NULL),
('Sheraton Centre', 41, '2020-02-03', 350, NULL),
('Sheraton Centre', 41, '2020-02-04', 394, NULL),
('Sheraton Centre', 42, '2019-01-01', 148, NULL),
('Sheraton Centre', 42, '2019-01-02', 285, NULL),
('Sheraton Centre', 42, '2019-01-03', 266, NULL),
('Sheraton Centre', 42, '2019-01-04', 369, NULL),
('Sheraton Centre', 42, '2019-01-05', 289, NULL),
('Sheraton Centre', 42, '2019-01-06', 321, NULL),
('Sheraton Centre', 42, '2019-01-07', 164, NULL),
('Sheraton Centre', 42, '2019-01-08', 186, NULL),
('Sheraton Centre', 42, '2019-01-09', 135, NULL),
('Sheraton Centre', 42, '2019-01-10', 386, NULL),
('Sheraton Centre', 42, '2019-01-11', 265, NULL),
('Sheraton Centre', 42, '2019-01-12', 340, NULL),
('Sheraton Centre', 42, '2019-01-13', 165, NULL),
('Sheraton Centre', 42, '2019-01-14', 168, NULL),
('Sheraton Centre', 42, '2019-01-15', 397, NULL),
('Sheraton Centre', 42, '2019-01-16', 214, NULL),
('Sheraton Centre', 42, '2019-01-17', 329, NULL),
('Sheraton Centre', 42, '2019-01-18', 327, NULL),
('Sheraton Centre', 42, '2019-01-19', 334, NULL),
('Sheraton Centre', 42, '2019-01-20', 227, NULL),
('Sheraton Centre', 42, '2019-01-21', 271, NULL),
('Sheraton Centre', 42, '2019-01-22', 101, NULL),
('Sheraton Centre', 42, '2019-01-23', 110, NULL),
('Sheraton Centre', 42, '2019-01-24', 158, NULL),
('Sheraton Centre', 42, '2019-01-25', 352, NULL),
('Sheraton Centre', 42, '2019-01-26', 135, NULL),
('Sheraton Centre', 42, '2019-01-27', 183, NULL),
('Sheraton Centre', 42, '2019-01-28', 314, NULL),
('Sheraton Centre', 42, '2019-01-29', 169, NULL),
('Sheraton Centre', 42, '2019-01-30', 134, NULL),
('Sheraton Centre', 42, '2019-01-31', 166, NULL),
('Sheraton Centre', 42, '2019-02-01', 104, NULL),
('Sheraton Centre', 42, '2019-02-02', 363, NULL),
('Sheraton Centre', 42, '2019-02-03', 204, NULL),
('Sheraton Centre', 42, '2019-02-04', 368, NULL),
('Sheraton Centre', 42, '2019-02-05', 240, NULL),
('Sheraton Centre', 42, '2019-02-06', 128, NULL),
('Sheraton Centre', 42, '2019-02-07', 322, NULL),
('Sheraton Centre', 42, '2019-02-08', 362, NULL),
('Sheraton Centre', 42, '2019-02-09', 290, NULL),
('Sheraton Centre', 42, '2019-02-10', 129, NULL),
('Sheraton Centre', 42, '2019-02-11', 272, NULL),
('Sheraton Centre', 42, '2019-02-12', 180, NULL),
('Sheraton Centre', 42, '2019-02-13', 145, NULL),
('Sheraton Centre', 42, '2019-02-14', 238, NULL),
('Sheraton Centre', 42, '2019-02-15', 304, NULL),
('Sheraton Centre', 42, '2019-02-16', 377, NULL),
('Sheraton Centre', 42, '2019-02-17', 177, NULL),
('Sheraton Centre', 42, '2019-02-18', 198, NULL),
('Sheraton Centre', 42, '2019-02-19', 374, NULL),
('Sheraton Centre', 42, '2019-02-20', 230, NULL),
('Sheraton Centre', 42, '2019-02-21', 289, NULL),
('Sheraton Centre', 42, '2019-02-22', 179, NULL),
('Sheraton Centre', 42, '2019-02-23', 394, NULL),
('Sheraton Centre', 42, '2019-02-24', 188, NULL),
('Sheraton Centre', 42, '2019-02-25', 376, NULL),
('Sheraton Centre', 42, '2019-02-26', 322, NULL),
('Sheraton Centre', 42, '2019-02-27', 371, NULL),
('Sheraton Centre', 42, '2019-02-28', 134, NULL),
('Sheraton Centre', 42, '2019-03-01', 264, NULL),
('Sheraton Centre', 42, '2019-03-02', 253, NULL),
('Sheraton Centre', 42, '2019-03-03', 398, NULL),
('Sheraton Centre', 42, '2019-03-04', 146, NULL),
('Sheraton Centre', 42, '2019-03-05', 292, NULL),
('Sheraton Centre', 42, '2019-03-06', 376, NULL),
('Sheraton Centre', 42, '2019-03-07', 133, NULL),
('Sheraton Centre', 42, '2019-03-08', 216, NULL),
('Sheraton Centre', 42, '2019-03-09', 253, NULL),
('Sheraton Centre', 42, '2019-03-10', 222, NULL),
('Sheraton Centre', 42, '2019-03-11', 267, NULL),
('Sheraton Centre', 42, '2019-03-12', 295, NULL),
('Sheraton Centre', 42, '2019-03-13', 357, NULL),
('Sheraton Centre', 42, '2019-03-14', 324, NULL),
('Sheraton Centre', 42, '2019-03-15', 255, NULL),
('Sheraton Centre', 42, '2019-03-16', 106, NULL),
('Sheraton Centre', 42, '2019-03-17', 390, NULL),
('Sheraton Centre', 42, '2019-03-18', 316, NULL),
('Sheraton Centre', 42, '2019-03-19', 262, NULL),
('Sheraton Centre', 42, '2019-03-20', 372, NULL),
('Sheraton Centre', 42, '2019-03-21', 336, NULL),
('Sheraton Centre', 42, '2019-03-22', 395, NULL),
('Sheraton Centre', 42, '2019-03-23', 171, NULL),
('Sheraton Centre', 42, '2019-03-24', 217, NULL),
('Sheraton Centre', 42, '2019-03-25', 333, NULL),
('Sheraton Centre', 42, '2019-03-26', 266, NULL),
('Sheraton Centre', 42, '2019-03-27', 229, NULL),
('Sheraton Centre', 42, '2019-03-28', 355, NULL),
('Sheraton Centre', 42, '2019-03-29', 318, NULL),
('Sheraton Centre', 42, '2019-03-30', 283, NULL),
('Sheraton Centre', 42, '2019-03-31', 172, NULL),
('Sheraton Centre', 42, '2019-04-01', 321, NULL),
('Sheraton Centre', 42, '2019-04-02', 217, NULL),
('Sheraton Centre', 42, '2019-04-03', 353, NULL),
('Sheraton Centre', 42, '2019-04-04', 355, NULL),
('Sheraton Centre', 42, '2019-04-05', 361, NULL),
('Sheraton Centre', 42, '2019-04-06', 245, NULL),
('Sheraton Centre', 42, '2019-04-07', 131, NULL),
('Sheraton Centre', 42, '2019-04-08', 253, NULL),
('Sheraton Centre', 42, '2019-04-09', 182, NULL),
('Sheraton Centre', 42, '2019-04-10', 362, NULL),
('Sheraton Centre', 42, '2019-04-11', 375, NULL),
('Sheraton Centre', 42, '2019-04-12', 315, NULL),
('Sheraton Centre', 42, '2019-04-13', 298, NULL),
('Sheraton Centre', 42, '2019-04-14', 211, NULL),
('Sheraton Centre', 42, '2019-04-15', 310, NULL),
('Sheraton Centre', 42, '2019-04-16', 133, NULL),
('Sheraton Centre', 42, '2019-04-17', 101, NULL),
('Sheraton Centre', 42, '2019-04-18', 132, NULL),
('Sheraton Centre', 42, '2019-04-19', 384, NULL),
('Sheraton Centre', 42, '2019-04-20', 189, NULL),
('Sheraton Centre', 42, '2019-04-21', 350, NULL),
('Sheraton Centre', 42, '2019-04-22', 180, NULL),
('Sheraton Centre', 42, '2019-04-23', 325, NULL),
('Sheraton Centre', 42, '2019-04-24', 347, NULL),
('Sheraton Centre', 42, '2019-04-25', 169, NULL),
('Sheraton Centre', 42, '2019-04-26', 287, NULL),
('Sheraton Centre', 42, '2019-04-27', 341, NULL),
('Sheraton Centre', 42, '2019-04-28', 173, NULL),
('Sheraton Centre', 42, '2019-04-29', 281, NULL),
('Sheraton Centre', 42, '2019-04-30', 249, NULL),
('Sheraton Centre', 42, '2019-05-01', 259, NULL),
('Sheraton Centre', 42, '2019-05-02', 249, NULL),
('Sheraton Centre', 42, '2019-05-03', 304, NULL),
('Sheraton Centre', 42, '2019-05-04', 182, NULL),
('Sheraton Centre', 42, '2019-05-05', 290, NULL),
('Sheraton Centre', 42, '2019-05-06', 260, NULL),
('Sheraton Centre', 42, '2019-05-07', 169, NULL),
('Sheraton Centre', 42, '2019-05-08', 291, NULL),
('Sheraton Centre', 42, '2019-05-09', 117, NULL),
('Sheraton Centre', 42, '2019-05-10', 125, NULL),
('Sheraton Centre', 42, '2019-05-11', 116, NULL),
('Sheraton Centre', 42, '2019-05-12', 297, NULL),
('Sheraton Centre', 42, '2019-05-13', 203, NULL),
('Sheraton Centre', 42, '2019-05-14', 370, NULL),
('Sheraton Centre', 42, '2019-05-15', 151, NULL),
('Sheraton Centre', 42, '2019-05-16', 128, NULL),
('Sheraton Centre', 42, '2019-05-17', 370, NULL),
('Sheraton Centre', 42, '2019-05-18', 350, NULL),
('Sheraton Centre', 42, '2019-05-19', 338, NULL),
('Sheraton Centre', 42, '2019-05-20', 280, NULL),
('Sheraton Centre', 42, '2019-05-21', 266, NULL),
('Sheraton Centre', 42, '2019-05-22', 329, NULL),
('Sheraton Centre', 42, '2019-05-23', 153, NULL),
('Sheraton Centre', 42, '2019-05-24', 281, NULL),
('Sheraton Centre', 42, '2019-05-25', 240, NULL),
('Sheraton Centre', 42, '2019-05-26', 316, NULL),
('Sheraton Centre', 42, '2019-05-27', 312, NULL),
('Sheraton Centre', 42, '2019-05-28', 254, NULL),
('Sheraton Centre', 42, '2019-05-29', 132, NULL),
('Sheraton Centre', 42, '2019-05-30', 273, NULL),
('Sheraton Centre', 42, '2019-05-31', 322, NULL),
('Sheraton Centre', 42, '2019-06-01', 117, NULL),
('Sheraton Centre', 42, '2019-06-02', 188, NULL),
('Sheraton Centre', 42, '2019-06-03', 395, NULL),
('Sheraton Centre', 42, '2019-06-04', 335, NULL),
('Sheraton Centre', 42, '2019-06-05', 139, NULL),
('Sheraton Centre', 42, '2019-06-06', 129, NULL),
('Sheraton Centre', 42, '2019-06-07', 300, NULL),
('Sheraton Centre', 42, '2019-06-08', 317, NULL),
('Sheraton Centre', 42, '2019-06-09', 224, NULL),
('Sheraton Centre', 42, '2019-06-10', 373, NULL),
('Sheraton Centre', 42, '2019-06-11', 131, NULL),
('Sheraton Centre', 42, '2019-06-12', 192, NULL),
('Sheraton Centre', 42, '2019-06-13', 175, NULL),
('Sheraton Centre', 42, '2019-06-14', 372, NULL),
('Sheraton Centre', 42, '2019-06-15', 398, NULL),
('Sheraton Centre', 42, '2019-06-16', 386, NULL),
('Sheraton Centre', 42, '2019-06-17', 392, NULL),
('Sheraton Centre', 42, '2019-06-18', 393, NULL),
('Sheraton Centre', 42, '2019-06-19', 132, NULL),
('Sheraton Centre', 42, '2019-06-20', 114, NULL),
('Sheraton Centre', 42, '2019-06-21', 322, NULL),
('Sheraton Centre', 42, '2019-06-22', 108, NULL),
('Sheraton Centre', 42, '2019-06-23', 337, NULL),
('Sheraton Centre', 42, '2019-06-24', 218, NULL),
('Sheraton Centre', 42, '2019-06-25', 118, NULL),
('Sheraton Centre', 42, '2019-06-26', 327, NULL),
('Sheraton Centre', 42, '2019-06-27', 353, NULL),
('Sheraton Centre', 42, '2019-06-28', 145, NULL),
('Sheraton Centre', 42, '2019-06-29', 244, NULL),
('Sheraton Centre', 42, '2019-06-30', 265, NULL),
('Sheraton Centre', 42, '2019-07-01', 383, NULL),
('Sheraton Centre', 42, '2019-07-02', 141, NULL),
('Sheraton Centre', 42, '2019-07-03', 189, NULL),
('Sheraton Centre', 42, '2019-07-04', 307, NULL),
('Sheraton Centre', 42, '2019-07-05', 255, NULL),
('Sheraton Centre', 42, '2019-07-06', 140, NULL),
('Sheraton Centre', 42, '2019-07-07', 313, NULL),
('Sheraton Centre', 42, '2019-07-08', 337, NULL),
('Sheraton Centre', 42, '2019-07-09', 159, NULL),
('Sheraton Centre', 42, '2019-07-10', 127, NULL),
('Sheraton Centre', 42, '2019-07-11', 312, NULL),
('Sheraton Centre', 42, '2019-07-12', 145, NULL),
('Sheraton Centre', 42, '2019-07-13', 197, NULL),
('Sheraton Centre', 42, '2019-07-14', 263, NULL),
('Sheraton Centre', 42, '2019-07-15', 299, NULL),
('Sheraton Centre', 42, '2019-07-16', 304, NULL),
('Sheraton Centre', 42, '2019-07-17', 351, NULL),
('Sheraton Centre', 42, '2019-07-18', 268, NULL),
('Sheraton Centre', 42, '2019-07-19', 321, NULL),
('Sheraton Centre', 42, '2019-07-20', 237, NULL),
('Sheraton Centre', 42, '2019-07-21', 133, NULL),
('Sheraton Centre', 42, '2019-07-22', 267, NULL),
('Sheraton Centre', 42, '2019-07-23', 344, NULL),
('Sheraton Centre', 42, '2019-07-24', 186, NULL),
('Sheraton Centre', 42, '2019-07-25', 241, NULL),
('Sheraton Centre', 42, '2019-07-26', 250, NULL),
('Sheraton Centre', 42, '2019-07-27', 123, NULL),
('Sheraton Centre', 42, '2019-07-28', 117, NULL),
('Sheraton Centre', 42, '2019-07-29', 313, NULL),
('Sheraton Centre', 42, '2019-07-30', 306, NULL),
('Sheraton Centre', 42, '2019-07-31', 393, NULL),
('Sheraton Centre', 42, '2019-08-01', 245, NULL),
('Sheraton Centre', 42, '2019-08-02', 165, NULL),
('Sheraton Centre', 42, '2019-08-03', 236, NULL),
('Sheraton Centre', 42, '2019-08-04', 299, NULL),
('Sheraton Centre', 42, '2019-08-05', 170, NULL),
('Sheraton Centre', 42, '2019-08-06', 372, NULL),
('Sheraton Centre', 42, '2019-08-07', 325, NULL),
('Sheraton Centre', 42, '2019-08-08', 125, NULL),
('Sheraton Centre', 42, '2019-08-09', 372, NULL),
('Sheraton Centre', 42, '2019-08-10', 348, NULL),
('Sheraton Centre', 42, '2019-08-11', 221, NULL),
('Sheraton Centre', 42, '2019-08-12', 269, NULL),
('Sheraton Centre', 42, '2019-08-13', 209, NULL),
('Sheraton Centre', 42, '2019-08-14', 351, NULL),
('Sheraton Centre', 42, '2019-08-15', 399, NULL),
('Sheraton Centre', 42, '2019-08-16', 180, NULL),
('Sheraton Centre', 42, '2019-08-17', 289, NULL),
('Sheraton Centre', 42, '2019-08-18', 237, NULL),
('Sheraton Centre', 42, '2019-08-19', 311, NULL),
('Sheraton Centre', 42, '2019-08-20', 191, NULL),
('Sheraton Centre', 42, '2019-08-21', 357, NULL),
('Sheraton Centre', 42, '2019-08-22', 355, NULL),
('Sheraton Centre', 42, '2019-08-23', 116, NULL),
('Sheraton Centre', 42, '2019-08-24', 177, NULL),
('Sheraton Centre', 42, '2019-08-25', 358, NULL),
('Sheraton Centre', 42, '2019-08-26', 265, NULL),
('Sheraton Centre', 42, '2019-08-27', 216, NULL),
('Sheraton Centre', 42, '2019-08-28', 393, NULL),
('Sheraton Centre', 42, '2019-08-29', 312, NULL),
('Sheraton Centre', 42, '2019-08-30', 103, NULL),
('Sheraton Centre', 42, '2019-08-31', 323, NULL),
('Sheraton Centre', 42, '2019-09-01', 182, NULL),
('Sheraton Centre', 42, '2019-09-02', 192, NULL),
('Sheraton Centre', 42, '2019-09-03', 354, NULL),
('Sheraton Centre', 42, '2019-09-04', 275, NULL),
('Sheraton Centre', 42, '2019-09-05', 282, NULL),
('Sheraton Centre', 42, '2019-09-06', 277, NULL),
('Sheraton Centre', 42, '2019-09-07', 125, NULL),
('Sheraton Centre', 42, '2019-09-08', 117, NULL),
('Sheraton Centre', 42, '2019-09-09', 262, NULL),
('Sheraton Centre', 42, '2019-09-10', 203, NULL),
('Sheraton Centre', 42, '2019-09-11', 380, NULL),
('Sheraton Centre', 42, '2019-09-12', 381, NULL),
('Sheraton Centre', 42, '2019-09-13', 254, NULL),
('Sheraton Centre', 42, '2019-09-14', 191, NULL),
('Sheraton Centre', 42, '2019-09-15', 350, NULL),
('Sheraton Centre', 42, '2019-09-16', 239, NULL),
('Sheraton Centre', 42, '2019-09-17', 115, NULL),
('Sheraton Centre', 42, '2019-09-18', 312, NULL),
('Sheraton Centre', 42, '2019-09-19', 339, NULL),
('Sheraton Centre', 42, '2019-09-20', 189, NULL),
('Sheraton Centre', 42, '2019-09-21', 299, NULL),
('Sheraton Centre', 42, '2019-09-22', 195, NULL),
('Sheraton Centre', 42, '2019-09-23', 326, NULL),
('Sheraton Centre', 42, '2019-09-24', 112, NULL),
('Sheraton Centre', 42, '2019-09-25', 108, NULL),
('Sheraton Centre', 42, '2019-09-26', 226, NULL),
('Sheraton Centre', 42, '2019-09-27', 241, NULL),
('Sheraton Centre', 42, '2019-09-28', 241, NULL),
('Sheraton Centre', 42, '2019-09-29', 394, NULL),
('Sheraton Centre', 42, '2019-09-30', 250, NULL),
('Sheraton Centre', 42, '2019-10-01', 386, NULL),
('Sheraton Centre', 42, '2019-10-02', 313, NULL),
('Sheraton Centre', 42, '2019-10-03', 380, NULL),
('Sheraton Centre', 42, '2019-10-04', 349, NULL),
('Sheraton Centre', 42, '2019-10-05', 123, NULL),
('Sheraton Centre', 42, '2019-10-06', 241, NULL),
('Sheraton Centre', 42, '2019-10-07', 291, NULL),
('Sheraton Centre', 42, '2019-10-08', 243, NULL),
('Sheraton Centre', 42, '2019-10-09', 274, NULL),
('Sheraton Centre', 42, '2019-10-10', 132, NULL),
('Sheraton Centre', 42, '2019-10-11', 209, NULL),
('Sheraton Centre', 42, '2019-10-12', 152, NULL),
('Sheraton Centre', 42, '2019-10-13', 354, NULL),
('Sheraton Centre', 42, '2019-10-14', 185, NULL),
('Sheraton Centre', 42, '2019-10-15', 162, NULL),
('Sheraton Centre', 42, '2019-10-16', 223, NULL),
('Sheraton Centre', 42, '2019-10-17', 321, NULL),
('Sheraton Centre', 42, '2019-10-18', 269, NULL),
('Sheraton Centre', 42, '2019-10-19', 275, NULL),
('Sheraton Centre', 42, '2019-10-20', 251, NULL),
('Sheraton Centre', 42, '2019-10-21', 220, NULL),
('Sheraton Centre', 42, '2019-10-22', 304, NULL),
('Sheraton Centre', 42, '2019-10-23', 314, NULL),
('Sheraton Centre', 42, '2019-10-24', 391, NULL),
('Sheraton Centre', 42, '2019-10-25', 177, NULL),
('Sheraton Centre', 42, '2019-10-26', 256, NULL),
('Sheraton Centre', 42, '2019-10-27', 274, NULL),
('Sheraton Centre', 42, '2019-10-28', 234, NULL),
('Sheraton Centre', 42, '2019-10-29', 359, NULL),
('Sheraton Centre', 42, '2019-10-30', 171, NULL),
('Sheraton Centre', 42, '2019-10-31', 354, NULL),
('Sheraton Centre', 42, '2019-11-01', 205, NULL),
('Sheraton Centre', 42, '2019-11-02', 293, NULL),
('Sheraton Centre', 42, '2019-11-03', 127, NULL),
('Sheraton Centre', 42, '2019-11-04', 162, NULL),
('Sheraton Centre', 42, '2019-11-05', 112, NULL),
('Sheraton Centre', 42, '2019-11-06', 270, NULL),
('Sheraton Centre', 42, '2019-11-07', 351, NULL),
('Sheraton Centre', 42, '2019-11-08', 165, NULL),
('Sheraton Centre', 42, '2019-11-09', 165, NULL),
('Sheraton Centre', 42, '2019-11-10', 326, NULL),
('Sheraton Centre', 42, '2019-11-11', 237, NULL),
('Sheraton Centre', 42, '2019-11-12', 388, NULL),
('Sheraton Centre', 42, '2019-11-13', 365, NULL),
('Sheraton Centre', 42, '2019-11-14', 376, NULL),
('Sheraton Centre', 42, '2019-11-15', 147, NULL),
('Sheraton Centre', 42, '2019-11-16', 122, NULL),
('Sheraton Centre', 42, '2019-11-17', 396, NULL),
('Sheraton Centre', 42, '2019-11-18', 293, NULL),
('Sheraton Centre', 42, '2019-11-19', 367, NULL),
('Sheraton Centre', 42, '2019-11-20', 180, NULL),
('Sheraton Centre', 42, '2019-11-21', 297, NULL),
('Sheraton Centre', 42, '2019-11-22', 169, NULL),
('Sheraton Centre', 42, '2019-11-23', 141, NULL),
('Sheraton Centre', 42, '2019-11-24', 385, NULL),
('Sheraton Centre', 42, '2019-11-25', 108, NULL),
('Sheraton Centre', 42, '2019-11-26', 326, NULL),
('Sheraton Centre', 42, '2019-11-27', 276, NULL),
('Sheraton Centre', 42, '2019-11-28', 108, NULL),
('Sheraton Centre', 42, '2019-11-29', 162, NULL),
('Sheraton Centre', 42, '2019-11-30', 379, NULL),
('Sheraton Centre', 42, '2019-12-01', 244, NULL),
('Sheraton Centre', 42, '2019-12-02', 303, NULL),
('Sheraton Centre', 42, '2019-12-03', 331, NULL),
('Sheraton Centre', 42, '2019-12-04', 184, NULL),
('Sheraton Centre', 42, '2019-12-05', 340, NULL),
('Sheraton Centre', 42, '2019-12-06', 303, NULL),
('Sheraton Centre', 42, '2019-12-07', 332, NULL),
('Sheraton Centre', 42, '2019-12-08', 198, NULL),
('Sheraton Centre', 42, '2019-12-09', 275, NULL),
('Sheraton Centre', 42, '2019-12-10', 239, NULL),
('Sheraton Centre', 42, '2019-12-11', 125, NULL),
('Sheraton Centre', 42, '2019-12-12', 336, NULL),
('Sheraton Centre', 42, '2019-12-13', 291, NULL),
('Sheraton Centre', 42, '2019-12-14', 152, NULL),
('Sheraton Centre', 42, '2019-12-15', 154, NULL),
('Sheraton Centre', 42, '2019-12-16', 343, NULL),
('Sheraton Centre', 42, '2019-12-17', 273, NULL),
('Sheraton Centre', 42, '2019-12-18', 110, NULL),
('Sheraton Centre', 42, '2019-12-19', 293, NULL),
('Sheraton Centre', 42, '2019-12-20', 183, NULL),
('Sheraton Centre', 42, '2019-12-21', 155, NULL),
('Sheraton Centre', 42, '2019-12-22', 252, NULL),
('Sheraton Centre', 42, '2019-12-23', 150, NULL),
('Sheraton Centre', 42, '2019-12-24', 137, NULL),
('Sheraton Centre', 42, '2019-12-25', 103, NULL),
('Sheraton Centre', 42, '2019-12-26', 292, NULL),
('Sheraton Centre', 42, '2019-12-27', 359, NULL),
('Sheraton Centre', 42, '2019-12-28', 249, NULL),
('Sheraton Centre', 42, '2019-12-29', 186, NULL),
('Sheraton Centre', 42, '2019-12-30', 165, NULL),
('Sheraton Centre', 42, '2019-12-31', 386, NULL),
('Sheraton Centre', 42, '2020-01-01', 124, NULL),
('Sheraton Centre', 42, '2020-01-02', 134, NULL),
('Sheraton Centre', 42, '2020-01-03', 193, NULL),
('Sheraton Centre', 42, '2020-01-04', 163, NULL),
('Sheraton Centre', 42, '2020-01-05', 323, NULL),
('Sheraton Centre', 42, '2020-01-06', 295, NULL),
('Sheraton Centre', 42, '2020-01-07', 327, NULL),
('Sheraton Centre', 42, '2020-01-08', 311, NULL),
('Sheraton Centre', 42, '2020-01-09', 311, NULL),
('Sheraton Centre', 42, '2020-01-10', 331, NULL),
('Sheraton Centre', 42, '2020-01-11', 238, NULL),
('Sheraton Centre', 42, '2020-01-12', 238, NULL),
('Sheraton Centre', 42, '2020-01-13', 218, NULL),
('Sheraton Centre', 42, '2020-01-14', 265, NULL),
('Sheraton Centre', 42, '2020-01-15', 242, NULL),
('Sheraton Centre', 42, '2020-01-16', 158, NULL),
('Sheraton Centre', 42, '2020-01-17', 162, NULL),
('Sheraton Centre', 42, '2020-01-18', 261, NULL),
('Sheraton Centre', 42, '2020-01-19', 151, NULL),
('Sheraton Centre', 42, '2020-01-20', 339, NULL),
('Sheraton Centre', 42, '2020-01-21', 188, NULL),
('Sheraton Centre', 42, '2020-01-22', 363, NULL),
('Sheraton Centre', 42, '2020-01-23', 307, NULL),
('Sheraton Centre', 42, '2020-01-24', 263, NULL),
('Sheraton Centre', 42, '2020-01-25', 357, NULL),
('Sheraton Centre', 42, '2020-01-26', 114, NULL),
('Sheraton Centre', 42, '2020-01-27', 197, NULL),
('Sheraton Centre', 42, '2020-01-28', 139, NULL),
('Sheraton Centre', 42, '2020-01-29', 155, NULL),
('Sheraton Centre', 42, '2020-01-30', 363, NULL),
('Sheraton Centre', 42, '2020-01-31', 103, NULL),
('Sheraton Centre', 42, '2020-02-01', 279, NULL),
('Sheraton Centre', 42, '2020-02-02', 334, NULL),
('Sheraton Centre', 42, '2020-02-03', 106, NULL),
('Sheraton Centre', 42, '2020-02-04', 190, NULL),
('Sheraton Centre', 46, '2019-01-01', 225, NULL),
('Sheraton Centre', 46, '2019-01-02', 257, NULL),
('Sheraton Centre', 46, '2019-01-03', 100, NULL),
('Sheraton Centre', 46, '2019-01-04', 305, NULL),
('Sheraton Centre', 46, '2019-01-05', 374, NULL),
('Sheraton Centre', 46, '2019-01-06', 311, NULL),
('Sheraton Centre', 46, '2019-01-07', 149, NULL),
('Sheraton Centre', 46, '2019-01-08', 303, NULL),
('Sheraton Centre', 46, '2019-01-09', 340, NULL),
('Sheraton Centre', 46, '2019-01-10', 252, NULL),
('Sheraton Centre', 46, '2019-01-11', 197, NULL),
('Sheraton Centre', 46, '2019-01-12', 175, NULL),
('Sheraton Centre', 46, '2019-01-13', 146, NULL),
('Sheraton Centre', 46, '2019-01-14', 192, NULL),
('Sheraton Centre', 46, '2019-01-15', 291, NULL),
('Sheraton Centre', 46, '2019-01-16', 326, NULL),
('Sheraton Centre', 46, '2019-01-17', 204, NULL),
('Sheraton Centre', 46, '2019-01-18', 323, NULL),
('Sheraton Centre', 46, '2019-01-19', 195, NULL),
('Sheraton Centre', 46, '2019-01-20', 193, NULL),
('Sheraton Centre', 46, '2019-01-21', 245, NULL),
('Sheraton Centre', 46, '2019-01-22', 204, NULL),
('Sheraton Centre', 46, '2019-01-23', 360, NULL),
('Sheraton Centre', 46, '2019-01-24', 319, NULL),
('Sheraton Centre', 46, '2019-01-25', 103, NULL),
('Sheraton Centre', 46, '2019-01-26', 266, NULL),
('Sheraton Centre', 46, '2019-01-27', 298, NULL),
('Sheraton Centre', 46, '2019-01-28', 147, NULL),
('Sheraton Centre', 46, '2019-01-29', 272, NULL),
('Sheraton Centre', 46, '2019-01-30', 341, NULL),
('Sheraton Centre', 46, '2019-01-31', 120, NULL),
('Sheraton Centre', 46, '2019-02-01', 114, NULL),
('Sheraton Centre', 46, '2019-02-02', 388, NULL),
('Sheraton Centre', 46, '2019-02-03', 224, NULL),
('Sheraton Centre', 46, '2019-02-04', 343, NULL),
('Sheraton Centre', 46, '2019-02-05', 212, NULL),
('Sheraton Centre', 46, '2019-02-06', 334, NULL),
('Sheraton Centre', 46, '2019-02-07', 134, NULL),
('Sheraton Centre', 46, '2019-02-08', 158, NULL),
('Sheraton Centre', 46, '2019-02-09', 300, NULL),
('Sheraton Centre', 46, '2019-02-10', 277, NULL),
('Sheraton Centre', 46, '2019-02-11', 157, NULL),
('Sheraton Centre', 46, '2019-02-12', 202, NULL),
('Sheraton Centre', 46, '2019-02-13', 262, NULL),
('Sheraton Centre', 46, '2019-02-14', 394, NULL),
('Sheraton Centre', 46, '2019-02-15', 349, NULL),
('Sheraton Centre', 46, '2019-02-16', 311, NULL),
('Sheraton Centre', 46, '2019-02-17', 143, NULL),
('Sheraton Centre', 46, '2019-02-18', 292, NULL),
('Sheraton Centre', 46, '2019-02-19', 283, NULL),
('Sheraton Centre', 46, '2019-02-20', 310, NULL),
('Sheraton Centre', 46, '2019-02-21', 357, NULL),
('Sheraton Centre', 46, '2019-02-22', 191, NULL),
('Sheraton Centre', 46, '2019-02-23', 267, NULL),
('Sheraton Centre', 46, '2019-02-24', 372, NULL),
('Sheraton Centre', 46, '2019-02-25', 136, NULL),
('Sheraton Centre', 46, '2019-02-26', 131, NULL),
('Sheraton Centre', 46, '2019-02-27', 275, NULL),
('Sheraton Centre', 46, '2019-02-28', 205, NULL),
('Sheraton Centre', 46, '2019-03-01', 344, NULL),
('Sheraton Centre', 46, '2019-03-02', 346, NULL),
('Sheraton Centre', 46, '2019-03-03', 159, NULL),
('Sheraton Centre', 46, '2019-03-04', 271, NULL),
('Sheraton Centre', 46, '2019-03-05', 177, NULL),
('Sheraton Centre', 46, '2019-03-06', 254, NULL),
('Sheraton Centre', 46, '2019-03-07', 231, NULL),
('Sheraton Centre', 46, '2019-03-08', 208, NULL),
('Sheraton Centre', 46, '2019-03-09', 272, NULL),
('Sheraton Centre', 46, '2019-03-10', 306, NULL),
('Sheraton Centre', 46, '2019-03-11', 367, NULL),
('Sheraton Centre', 46, '2019-03-12', 138, NULL),
('Sheraton Centre', 46, '2019-03-13', 167, NULL),
('Sheraton Centre', 46, '2019-03-14', 399, NULL),
('Sheraton Centre', 46, '2019-03-15', 195, NULL),
('Sheraton Centre', 46, '2019-03-16', 183, NULL),
('Sheraton Centre', 46, '2019-03-17', 385, NULL),
('Sheraton Centre', 46, '2019-03-18', 141, NULL),
('Sheraton Centre', 46, '2019-03-19', 120, NULL),
('Sheraton Centre', 46, '2019-03-20', 198, NULL),
('Sheraton Centre', 46, '2019-03-21', 211, NULL),
('Sheraton Centre', 46, '2019-03-22', 338, NULL),
('Sheraton Centre', 46, '2019-03-23', 360, NULL),
('Sheraton Centre', 46, '2019-03-24', 381, NULL),
('Sheraton Centre', 46, '2019-03-25', 368, NULL),
('Sheraton Centre', 46, '2019-03-26', 133, NULL),
('Sheraton Centre', 46, '2019-03-27', 334, NULL),
('Sheraton Centre', 46, '2019-03-28', 339, NULL),
('Sheraton Centre', 46, '2019-03-29', 338, NULL),
('Sheraton Centre', 46, '2019-03-30', 241, NULL),
('Sheraton Centre', 46, '2019-03-31', 149, NULL),
('Sheraton Centre', 46, '2019-04-01', 358, NULL),
('Sheraton Centre', 46, '2019-04-02', 291, NULL),
('Sheraton Centre', 46, '2019-04-03', 209, NULL),
('Sheraton Centre', 46, '2019-04-04', 365, NULL),
('Sheraton Centre', 46, '2019-04-05', 386, NULL),
('Sheraton Centre', 46, '2019-04-06', 311, NULL),
('Sheraton Centre', 46, '2019-04-07', 379, NULL),
('Sheraton Centre', 46, '2019-04-08', 261, NULL),
('Sheraton Centre', 46, '2019-04-09', 101, NULL),
('Sheraton Centre', 46, '2019-04-10', 160, NULL),
('Sheraton Centre', 46, '2019-04-11', 241, NULL),
('Sheraton Centre', 46, '2019-04-12', 201, NULL),
('Sheraton Centre', 46, '2019-04-13', 196, NULL),
('Sheraton Centre', 46, '2019-04-14', 288, NULL),
('Sheraton Centre', 46, '2019-04-15', 360, NULL),
('Sheraton Centre', 46, '2019-04-16', 334, NULL),
('Sheraton Centre', 46, '2019-04-17', 115, NULL),
('Sheraton Centre', 46, '2019-04-18', 394, NULL),
('Sheraton Centre', 46, '2019-04-19', 376, NULL),
('Sheraton Centre', 46, '2019-04-20', 371, NULL),
('Sheraton Centre', 46, '2019-04-21', 138, NULL),
('Sheraton Centre', 46, '2019-04-22', 134, NULL),
('Sheraton Centre', 46, '2019-04-23', 199, NULL),
('Sheraton Centre', 46, '2019-04-24', 104, NULL),
('Sheraton Centre', 46, '2019-04-25', 161, NULL),
('Sheraton Centre', 46, '2019-04-26', 178, NULL),
('Sheraton Centre', 46, '2019-04-27', 338, NULL),
('Sheraton Centre', 46, '2019-04-28', 247, NULL),
('Sheraton Centre', 46, '2019-04-29', 394, NULL),
('Sheraton Centre', 46, '2019-04-30', 132, NULL),
('Sheraton Centre', 46, '2019-05-01', 231, NULL),
('Sheraton Centre', 46, '2019-05-02', 188, NULL),
('Sheraton Centre', 46, '2019-05-03', 320, NULL),
('Sheraton Centre', 46, '2019-05-04', 396, NULL),
('Sheraton Centre', 46, '2019-05-05', 329, NULL),
('Sheraton Centre', 46, '2019-05-06', 240, NULL),
('Sheraton Centre', 46, '2019-05-07', 128, NULL),
('Sheraton Centre', 46, '2019-05-08', 322, NULL),
('Sheraton Centre', 46, '2019-05-09', 366, NULL),
('Sheraton Centre', 46, '2019-05-10', 234, NULL),
('Sheraton Centre', 46, '2019-05-11', 223, NULL),
('Sheraton Centre', 46, '2019-05-12', 395, NULL),
('Sheraton Centre', 46, '2019-05-13', 146, NULL),
('Sheraton Centre', 46, '2019-05-14', 328, NULL),
('Sheraton Centre', 46, '2019-05-15', 129, NULL),
('Sheraton Centre', 46, '2019-05-16', 188, NULL),
('Sheraton Centre', 46, '2019-05-17', 163, NULL),
('Sheraton Centre', 46, '2019-05-18', 211, NULL),
('Sheraton Centre', 46, '2019-05-19', 256, NULL),
('Sheraton Centre', 46, '2019-05-20', 152, NULL),
('Sheraton Centre', 46, '2019-05-21', 303, NULL),
('Sheraton Centre', 46, '2019-05-22', 312, NULL),
('Sheraton Centre', 46, '2019-05-23', 387, NULL),
('Sheraton Centre', 46, '2019-05-24', 297, NULL),
('Sheraton Centre', 46, '2019-05-25', 353, NULL),
('Sheraton Centre', 46, '2019-05-26', 188, NULL),
('Sheraton Centre', 46, '2019-05-27', 101, NULL),
('Sheraton Centre', 46, '2019-05-28', 261, NULL),
('Sheraton Centre', 46, '2019-05-29', 296, NULL),
('Sheraton Centre', 46, '2019-05-30', 261, NULL),
('Sheraton Centre', 46, '2019-05-31', 346, NULL),
('Sheraton Centre', 46, '2019-06-01', 304, NULL),
('Sheraton Centre', 46, '2019-06-02', 320, NULL),
('Sheraton Centre', 46, '2019-06-03', 349, NULL),
('Sheraton Centre', 46, '2019-06-04', 389, NULL),
('Sheraton Centre', 46, '2019-06-05', 221, NULL),
('Sheraton Centre', 46, '2019-06-06', 398, NULL),
('Sheraton Centre', 46, '2019-06-07', 305, NULL),
('Sheraton Centre', 46, '2019-06-08', 262, NULL),
('Sheraton Centre', 46, '2019-06-09', 257, NULL),
('Sheraton Centre', 46, '2019-06-10', 173, NULL),
('Sheraton Centre', 46, '2019-06-11', 174, NULL),
('Sheraton Centre', 46, '2019-06-12', 315, NULL),
('Sheraton Centre', 46, '2019-06-13', 365, NULL),
('Sheraton Centre', 46, '2019-06-14', 265, NULL),
('Sheraton Centre', 46, '2019-06-15', 176, NULL),
('Sheraton Centre', 46, '2019-06-16', 267, NULL),
('Sheraton Centre', 46, '2019-06-17', 332, NULL),
('Sheraton Centre', 46, '2019-06-18', 293, NULL),
('Sheraton Centre', 46, '2019-06-19', 152, NULL),
('Sheraton Centre', 46, '2019-06-20', 112, NULL),
('Sheraton Centre', 46, '2019-06-21', 125, NULL),
('Sheraton Centre', 46, '2019-06-22', 253, NULL),
('Sheraton Centre', 46, '2019-06-23', 302, NULL),
('Sheraton Centre', 46, '2019-06-24', 379, NULL),
('Sheraton Centre', 46, '2019-06-25', 376, NULL),
('Sheraton Centre', 46, '2019-06-26', 268, NULL),
('Sheraton Centre', 46, '2019-06-27', 100, NULL),
('Sheraton Centre', 46, '2019-06-28', 378, NULL),
('Sheraton Centre', 46, '2019-06-29', 373, NULL),
('Sheraton Centre', 46, '2019-06-30', 313, NULL),
('Sheraton Centre', 46, '2019-07-01', 180, NULL),
('Sheraton Centre', 46, '2019-07-02', 390, NULL),
('Sheraton Centre', 46, '2019-07-03', 148, NULL),
('Sheraton Centre', 46, '2019-07-04', 225, NULL),
('Sheraton Centre', 46, '2019-07-05', 199, NULL),
('Sheraton Centre', 46, '2019-07-06', 275, NULL),
('Sheraton Centre', 46, '2019-07-07', 117, NULL),
('Sheraton Centre', 46, '2019-07-08', 391, NULL),
('Sheraton Centre', 46, '2019-07-09', 342, NULL),
('Sheraton Centre', 46, '2019-07-10', 199, NULL),
('Sheraton Centre', 46, '2019-07-11', 101, NULL),
('Sheraton Centre', 46, '2019-07-12', 153, NULL),
('Sheraton Centre', 46, '2019-07-13', 288, NULL),
('Sheraton Centre', 46, '2019-07-14', 130, NULL),
('Sheraton Centre', 46, '2019-07-15', 269, NULL),
('Sheraton Centre', 46, '2019-07-16', 390, NULL),
('Sheraton Centre', 46, '2019-07-17', 151, NULL),
('Sheraton Centre', 46, '2019-07-18', 313, NULL),
('Sheraton Centre', 46, '2019-07-19', 151, NULL),
('Sheraton Centre', 46, '2019-07-20', 109, NULL),
('Sheraton Centre', 46, '2019-07-21', 170, NULL),
('Sheraton Centre', 46, '2019-07-22', 218, NULL),
('Sheraton Centre', 46, '2019-07-23', 283, NULL),
('Sheraton Centre', 46, '2019-07-24', 259, NULL),
('Sheraton Centre', 46, '2019-07-25', 300, NULL),
('Sheraton Centre', 46, '2019-07-26', 173, NULL),
('Sheraton Centre', 46, '2019-07-27', 296, NULL),
('Sheraton Centre', 46, '2019-07-28', 178, NULL),
('Sheraton Centre', 46, '2019-07-29', 260, NULL),
('Sheraton Centre', 46, '2019-07-30', 246, NULL),
('Sheraton Centre', 46, '2019-07-31', 187, NULL),
('Sheraton Centre', 46, '2019-08-01', 223, NULL),
('Sheraton Centre', 46, '2019-08-02', 274, NULL),
('Sheraton Centre', 46, '2019-08-03', 212, NULL),
('Sheraton Centre', 46, '2019-08-04', 260, NULL),
('Sheraton Centre', 46, '2019-08-05', 133, NULL),
('Sheraton Centre', 46, '2019-08-06', 295, NULL),
('Sheraton Centre', 46, '2019-08-07', 322, NULL),
('Sheraton Centre', 46, '2019-08-08', 234, NULL),
('Sheraton Centre', 46, '2019-08-09', 385, NULL),
('Sheraton Centre', 46, '2019-08-10', 264, NULL),
('Sheraton Centre', 46, '2019-08-11', 241, NULL),
('Sheraton Centre', 46, '2019-08-12', 191, NULL),
('Sheraton Centre', 46, '2019-08-13', 139, NULL),
('Sheraton Centre', 46, '2019-08-14', 199, NULL),
('Sheraton Centre', 46, '2019-08-15', 236, NULL),
('Sheraton Centre', 46, '2019-08-16', 160, NULL),
('Sheraton Centre', 46, '2019-08-17', 145, NULL),
('Sheraton Centre', 46, '2019-08-18', 195, NULL),
('Sheraton Centre', 46, '2019-08-19', 185, NULL),
('Sheraton Centre', 46, '2019-08-20', 116, NULL),
('Sheraton Centre', 46, '2019-08-21', 122, NULL),
('Sheraton Centre', 46, '2019-08-22', 282, NULL),
('Sheraton Centre', 46, '2019-08-23', 330, NULL),
('Sheraton Centre', 46, '2019-08-24', 134, NULL),
('Sheraton Centre', 46, '2019-08-25', 326, NULL),
('Sheraton Centre', 46, '2019-08-26', 326, NULL),
('Sheraton Centre', 46, '2019-08-27', 240, NULL),
('Sheraton Centre', 46, '2019-08-28', 390, NULL),
('Sheraton Centre', 46, '2019-08-29', 269, NULL),
('Sheraton Centre', 46, '2019-08-30', 213, NULL),
('Sheraton Centre', 46, '2019-08-31', 317, NULL),
('Sheraton Centre', 46, '2019-09-01', 125, NULL),
('Sheraton Centre', 46, '2019-09-02', 143, NULL),
('Sheraton Centre', 46, '2019-09-03', 259, NULL),
('Sheraton Centre', 46, '2019-09-04', 138, NULL),
('Sheraton Centre', 46, '2019-09-05', 229, NULL),
('Sheraton Centre', 46, '2019-09-06', 228, NULL),
('Sheraton Centre', 46, '2019-09-07', 225, NULL),
('Sheraton Centre', 46, '2019-09-08', 160, NULL),
('Sheraton Centre', 46, '2019-09-09', 395, NULL),
('Sheraton Centre', 46, '2019-09-10', 151, NULL),
('Sheraton Centre', 46, '2019-09-11', 391, NULL),
('Sheraton Centre', 46, '2019-09-12', 156, NULL),
('Sheraton Centre', 46, '2019-09-13', 347, NULL),
('Sheraton Centre', 46, '2019-09-14', 175, NULL),
('Sheraton Centre', 46, '2019-09-15', 240, NULL),
('Sheraton Centre', 46, '2019-09-16', 228, NULL),
('Sheraton Centre', 46, '2019-09-17', 280, NULL),
('Sheraton Centre', 46, '2019-09-18', 215, NULL),
('Sheraton Centre', 46, '2019-09-19', 382, NULL),
('Sheraton Centre', 46, '2019-09-20', 208, NULL),
('Sheraton Centre', 46, '2019-09-21', 353, NULL),
('Sheraton Centre', 46, '2019-09-22', 280, NULL),
('Sheraton Centre', 46, '2019-09-23', 170, NULL),
('Sheraton Centre', 46, '2019-09-24', 174, NULL),
('Sheraton Centre', 46, '2019-09-25', 391, NULL),
('Sheraton Centre', 46, '2019-09-26', 250, NULL),
('Sheraton Centre', 46, '2019-09-27', 264, NULL),
('Sheraton Centre', 46, '2019-09-28', 267, NULL),
('Sheraton Centre', 46, '2019-09-29', 169, NULL),
('Sheraton Centre', 46, '2019-09-30', 263, NULL),
('Sheraton Centre', 46, '2019-10-01', 284, NULL),
('Sheraton Centre', 46, '2019-10-02', 214, NULL),
('Sheraton Centre', 46, '2019-10-03', 144, NULL),
('Sheraton Centre', 46, '2019-10-04', 369, NULL),
('Sheraton Centre', 46, '2019-10-05', 351, NULL),
('Sheraton Centre', 46, '2019-10-06', 161, NULL),
('Sheraton Centre', 46, '2019-10-07', 295, NULL),
('Sheraton Centre', 46, '2019-10-08', 196, NULL),
('Sheraton Centre', 46, '2019-10-09', 353, NULL),
('Sheraton Centre', 46, '2019-10-10', 381, NULL),
('Sheraton Centre', 46, '2019-10-11', 283, NULL),
('Sheraton Centre', 46, '2019-10-12', 198, NULL),
('Sheraton Centre', 46, '2019-10-13', 356, NULL),
('Sheraton Centre', 46, '2019-10-14', 192, NULL),
('Sheraton Centre', 46, '2019-10-15', 253, NULL),
('Sheraton Centre', 46, '2019-10-16', 307, NULL),
('Sheraton Centre', 46, '2019-10-17', 313, NULL),
('Sheraton Centre', 46, '2019-10-18', 224, NULL),
('Sheraton Centre', 46, '2019-10-19', 357, NULL),
('Sheraton Centre', 46, '2019-10-20', 109, NULL),
('Sheraton Centre', 46, '2019-10-21', 207, NULL),
('Sheraton Centre', 46, '2019-10-22', 260, NULL),
('Sheraton Centre', 46, '2019-10-23', 356, NULL),
('Sheraton Centre', 46, '2019-10-24', 378, NULL),
('Sheraton Centre', 46, '2019-10-25', 300, NULL),
('Sheraton Centre', 46, '2019-10-26', 392, NULL),
('Sheraton Centre', 46, '2019-10-27', 389, NULL),
('Sheraton Centre', 46, '2019-10-28', 168, NULL),
('Sheraton Centre', 46, '2019-10-29', 365, NULL),
('Sheraton Centre', 46, '2019-10-30', 193, NULL),
('Sheraton Centre', 46, '2019-10-31', 164, NULL),
('Sheraton Centre', 46, '2019-11-01', 324, NULL),
('Sheraton Centre', 46, '2019-11-02', 250, NULL),
('Sheraton Centre', 46, '2019-11-03', 217, NULL),
('Sheraton Centre', 46, '2019-11-04', 363, NULL),
('Sheraton Centre', 46, '2019-11-05', 228, NULL),
('Sheraton Centre', 46, '2019-11-06', 161, NULL),
('Sheraton Centre', 46, '2019-11-07', 365, NULL),
('Sheraton Centre', 46, '2019-11-08', 226, NULL),
('Sheraton Centre', 46, '2019-11-09', 148, NULL),
('Sheraton Centre', 46, '2019-11-10', 233, NULL),
('Sheraton Centre', 46, '2019-11-11', 319, NULL),
('Sheraton Centre', 46, '2019-11-12', 335, NULL),
('Sheraton Centre', 46, '2019-11-13', 167, NULL),
('Sheraton Centre', 46, '2019-11-14', 119, NULL),
('Sheraton Centre', 46, '2019-11-15', 268, NULL),
('Sheraton Centre', 46, '2019-11-16', 141, NULL),
('Sheraton Centre', 46, '2019-11-17', 155, NULL),
('Sheraton Centre', 46, '2019-11-18', 377, NULL),
('Sheraton Centre', 46, '2019-11-19', 328, NULL),
('Sheraton Centre', 46, '2019-11-20', 305, NULL),
('Sheraton Centre', 46, '2019-11-21', 223, NULL),
('Sheraton Centre', 46, '2019-11-22', 233, NULL),
('Sheraton Centre', 46, '2019-11-23', 389, NULL),
('Sheraton Centre', 46, '2019-11-24', 177, NULL),
('Sheraton Centre', 46, '2019-11-25', 157, NULL),
('Sheraton Centre', 46, '2019-11-26', 363, NULL),
('Sheraton Centre', 46, '2019-11-27', 275, NULL),
('Sheraton Centre', 46, '2019-11-28', 314, NULL),
('Sheraton Centre', 46, '2019-11-29', 130, NULL),
('Sheraton Centre', 46, '2019-11-30', 107, NULL),
('Sheraton Centre', 46, '2019-12-01', 149, NULL),
('Sheraton Centre', 46, '2019-12-02', 184, NULL),
('Sheraton Centre', 46, '2019-12-03', 399, NULL),
('Sheraton Centre', 46, '2019-12-04', 197, NULL),
('Sheraton Centre', 46, '2019-12-05', 254, NULL),
('Sheraton Centre', 46, '2019-12-06', 159, NULL),
('Sheraton Centre', 46, '2019-12-07', 331, NULL),
('Sheraton Centre', 46, '2019-12-08', 272, NULL),
('Sheraton Centre', 46, '2019-12-09', 219, NULL),
('Sheraton Centre', 46, '2019-12-10', 277, NULL),
('Sheraton Centre', 46, '2019-12-11', 390, NULL),
('Sheraton Centre', 46, '2019-12-12', 176, NULL),
('Sheraton Centre', 46, '2019-12-13', 261, NULL),
('Sheraton Centre', 46, '2019-12-14', 208, NULL),
('Sheraton Centre', 46, '2019-12-15', 128, NULL),
('Sheraton Centre', 46, '2019-12-16', 199, NULL),
('Sheraton Centre', 46, '2019-12-17', 181, NULL),
('Sheraton Centre', 46, '2019-12-18', 352, NULL),
('Sheraton Centre', 46, '2019-12-19', 193, NULL),
('Sheraton Centre', 46, '2019-12-20', 374, NULL),
('Sheraton Centre', 46, '2019-12-21', 307, NULL),
('Sheraton Centre', 46, '2019-12-22', 128, NULL),
('Sheraton Centre', 46, '2019-12-23', 215, NULL),
('Sheraton Centre', 46, '2019-12-24', 260, NULL),
('Sheraton Centre', 46, '2019-12-25', 188, NULL),
('Sheraton Centre', 46, '2019-12-26', 283, NULL),
('Sheraton Centre', 46, '2019-12-27', 171, NULL),
('Sheraton Centre', 46, '2019-12-28', 131, NULL),
('Sheraton Centre', 46, '2019-12-29', 319, NULL),
('Sheraton Centre', 46, '2019-12-30', 337, NULL),
('Sheraton Centre', 46, '2019-12-31', 271, NULL),
('Sheraton Centre', 46, '2020-01-01', 391, NULL),
('Sheraton Centre', 46, '2020-01-02', 392, NULL),
('Sheraton Centre', 46, '2020-01-03', 100, NULL),
('Sheraton Centre', 46, '2020-01-04', 312, NULL),
('Sheraton Centre', 46, '2020-01-05', 215, NULL),
('Sheraton Centre', 46, '2020-01-06', 131, NULL),
('Sheraton Centre', 46, '2020-01-07', 229, NULL),
('Sheraton Centre', 46, '2020-01-08', 172, NULL),
('Sheraton Centre', 46, '2020-01-09', 192, NULL),
('Sheraton Centre', 46, '2020-01-10', 354, NULL),
('Sheraton Centre', 46, '2020-01-11', 149, NULL),
('Sheraton Centre', 46, '2020-01-12', 261, NULL),
('Sheraton Centre', 46, '2020-01-13', 242, NULL),
('Sheraton Centre', 46, '2020-01-14', 238, NULL),
('Sheraton Centre', 46, '2020-01-15', 357, NULL),
('Sheraton Centre', 46, '2020-01-16', 363, NULL),
('Sheraton Centre', 46, '2020-01-17', 353, NULL),
('Sheraton Centre', 46, '2020-01-18', 358, NULL),
('Sheraton Centre', 46, '2020-01-19', 268, NULL),
('Sheraton Centre', 46, '2020-01-20', 134, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 46, '2020-01-21', 264, NULL),
('Sheraton Centre', 46, '2020-01-22', 298, NULL),
('Sheraton Centre', 46, '2020-01-23', 258, NULL),
('Sheraton Centre', 46, '2020-01-24', 303, NULL),
('Sheraton Centre', 46, '2020-01-25', 382, NULL),
('Sheraton Centre', 46, '2020-01-26', 247, NULL),
('Sheraton Centre', 46, '2020-01-27', 336, NULL),
('Sheraton Centre', 46, '2020-01-28', 275, NULL),
('Sheraton Centre', 46, '2020-01-29', 319, NULL),
('Sheraton Centre', 46, '2020-01-30', 359, NULL),
('Sheraton Centre', 46, '2020-01-31', 343, NULL),
('Sheraton Centre', 46, '2020-02-01', 117, NULL),
('Sheraton Centre', 46, '2020-02-02', 378, NULL),
('Sheraton Centre', 46, '2020-02-03', 281, NULL),
('Sheraton Centre', 46, '2020-02-04', 268, NULL),
('Sheraton Centre', 58, '2019-01-01', 283, NULL),
('Sheraton Centre', 58, '2019-01-02', 328, NULL),
('Sheraton Centre', 58, '2019-01-03', 202, NULL),
('Sheraton Centre', 58, '2019-01-04', 316, NULL),
('Sheraton Centre', 58, '2019-01-05', 305, NULL),
('Sheraton Centre', 58, '2019-01-06', 194, NULL),
('Sheraton Centre', 58, '2019-01-07', 150, NULL),
('Sheraton Centre', 58, '2019-01-08', 259, NULL),
('Sheraton Centre', 58, '2019-01-09', 293, NULL),
('Sheraton Centre', 58, '2019-01-10', 303, NULL),
('Sheraton Centre', 58, '2019-01-11', 392, NULL),
('Sheraton Centre', 58, '2019-01-12', 358, NULL),
('Sheraton Centre', 58, '2019-01-13', 137, NULL),
('Sheraton Centre', 58, '2019-01-14', 356, NULL),
('Sheraton Centre', 58, '2019-01-15', 164, NULL),
('Sheraton Centre', 58, '2019-01-16', 289, NULL),
('Sheraton Centre', 58, '2019-01-17', 236, NULL),
('Sheraton Centre', 58, '2019-01-18', 235, NULL),
('Sheraton Centre', 58, '2019-01-19', 171, NULL),
('Sheraton Centre', 58, '2019-01-20', 185, NULL),
('Sheraton Centre', 58, '2019-01-21', 313, NULL),
('Sheraton Centre', 58, '2019-01-22', 318, NULL),
('Sheraton Centre', 58, '2019-01-23', 173, NULL),
('Sheraton Centre', 58, '2019-01-24', 119, NULL),
('Sheraton Centre', 58, '2019-01-25', 257, NULL),
('Sheraton Centre', 58, '2019-01-26', 225, NULL),
('Sheraton Centre', 58, '2019-01-27', 239, NULL),
('Sheraton Centre', 58, '2019-01-28', 294, NULL),
('Sheraton Centre', 58, '2019-01-29', 152, NULL),
('Sheraton Centre', 58, '2019-01-30', 304, NULL),
('Sheraton Centre', 58, '2019-01-31', 301, NULL),
('Sheraton Centre', 58, '2019-02-01', 156, NULL),
('Sheraton Centre', 58, '2019-02-02', 150, NULL),
('Sheraton Centre', 58, '2019-02-03', 111, NULL),
('Sheraton Centre', 58, '2019-02-04', 209, NULL),
('Sheraton Centre', 58, '2019-02-05', 242, NULL),
('Sheraton Centre', 58, '2019-02-06', 286, NULL),
('Sheraton Centre', 58, '2019-02-07', 205, NULL),
('Sheraton Centre', 58, '2019-02-08', 206, NULL),
('Sheraton Centre', 58, '2019-02-09', 233, NULL),
('Sheraton Centre', 58, '2019-02-10', 301, NULL),
('Sheraton Centre', 58, '2019-02-11', 167, NULL),
('Sheraton Centre', 58, '2019-02-12', 368, NULL),
('Sheraton Centre', 58, '2019-02-13', 174, NULL),
('Sheraton Centre', 58, '2019-02-14', 254, NULL),
('Sheraton Centre', 58, '2019-02-15', 135, NULL),
('Sheraton Centre', 58, '2019-02-16', 325, NULL),
('Sheraton Centre', 58, '2019-02-17', 382, NULL),
('Sheraton Centre', 58, '2019-02-18', 166, NULL),
('Sheraton Centre', 58, '2019-02-19', 192, NULL),
('Sheraton Centre', 58, '2019-02-20', 161, NULL),
('Sheraton Centre', 58, '2019-02-21', 218, NULL),
('Sheraton Centre', 58, '2019-02-22', 320, NULL),
('Sheraton Centre', 58, '2019-02-23', 356, NULL),
('Sheraton Centre', 58, '2019-02-24', 298, NULL),
('Sheraton Centre', 58, '2019-02-25', 353, NULL),
('Sheraton Centre', 58, '2019-02-26', 190, NULL),
('Sheraton Centre', 58, '2019-02-27', 161, NULL),
('Sheraton Centre', 58, '2019-02-28', 223, NULL),
('Sheraton Centre', 58, '2019-03-01', 228, NULL),
('Sheraton Centre', 58, '2019-03-02', 271, NULL),
('Sheraton Centre', 58, '2019-03-03', 101, NULL),
('Sheraton Centre', 58, '2019-03-04', 219, NULL),
('Sheraton Centre', 58, '2019-03-05', 211, NULL),
('Sheraton Centre', 58, '2019-03-06', 343, NULL),
('Sheraton Centre', 58, '2019-03-07', 356, NULL),
('Sheraton Centre', 58, '2019-03-08', 293, NULL),
('Sheraton Centre', 58, '2019-03-09', 202, NULL),
('Sheraton Centre', 58, '2019-03-10', 165, NULL),
('Sheraton Centre', 58, '2019-03-11', 337, NULL),
('Sheraton Centre', 58, '2019-03-12', 305, NULL),
('Sheraton Centre', 58, '2019-03-13', 261, NULL),
('Sheraton Centre', 58, '2019-03-14', 323, NULL),
('Sheraton Centre', 58, '2019-03-15', 110, NULL),
('Sheraton Centre', 58, '2019-03-16', 196, NULL),
('Sheraton Centre', 58, '2019-03-17', 355, NULL),
('Sheraton Centre', 58, '2019-03-18', 256, NULL),
('Sheraton Centre', 58, '2019-03-19', 315, NULL),
('Sheraton Centre', 58, '2019-03-20', 378, NULL),
('Sheraton Centre', 58, '2019-03-21', 249, NULL),
('Sheraton Centre', 58, '2019-03-22', 107, NULL),
('Sheraton Centre', 58, '2019-03-23', 287, NULL),
('Sheraton Centre', 58, '2019-03-24', 256, NULL),
('Sheraton Centre', 58, '2019-03-25', 144, NULL),
('Sheraton Centre', 58, '2019-03-26', 367, NULL),
('Sheraton Centre', 58, '2019-03-27', 285, NULL),
('Sheraton Centre', 58, '2019-03-28', 232, NULL),
('Sheraton Centre', 58, '2019-03-29', 335, NULL),
('Sheraton Centre', 58, '2019-03-30', 258, NULL),
('Sheraton Centre', 58, '2019-03-31', 131, NULL),
('Sheraton Centre', 58, '2019-04-01', 127, NULL),
('Sheraton Centre', 58, '2019-04-02', 108, NULL),
('Sheraton Centre', 58, '2019-04-03', 187, NULL),
('Sheraton Centre', 58, '2019-04-04', 363, NULL),
('Sheraton Centre', 58, '2019-04-05', 146, NULL),
('Sheraton Centre', 58, '2019-04-06', 120, NULL),
('Sheraton Centre', 58, '2019-04-07', 199, NULL),
('Sheraton Centre', 58, '2019-04-08', 150, NULL),
('Sheraton Centre', 58, '2019-04-09', 158, NULL),
('Sheraton Centre', 58, '2019-04-10', 214, NULL),
('Sheraton Centre', 58, '2019-04-11', 277, NULL),
('Sheraton Centre', 58, '2019-04-12', 258, NULL),
('Sheraton Centre', 58, '2019-04-13', 287, NULL),
('Sheraton Centre', 58, '2019-04-14', 108, NULL),
('Sheraton Centre', 58, '2019-04-15', 171, NULL),
('Sheraton Centre', 58, '2019-04-16', 274, NULL),
('Sheraton Centre', 58, '2019-04-17', 171, NULL),
('Sheraton Centre', 58, '2019-04-18', 276, NULL),
('Sheraton Centre', 58, '2019-04-19', 329, NULL),
('Sheraton Centre', 58, '2019-04-20', 288, NULL),
('Sheraton Centre', 58, '2019-04-21', 142, NULL),
('Sheraton Centre', 58, '2019-04-22', 330, NULL),
('Sheraton Centre', 58, '2019-04-23', 222, NULL),
('Sheraton Centre', 58, '2019-04-24', 279, NULL),
('Sheraton Centre', 58, '2019-04-25', 197, NULL),
('Sheraton Centre', 58, '2019-04-26', 227, NULL),
('Sheraton Centre', 58, '2019-04-27', 267, NULL),
('Sheraton Centre', 58, '2019-04-28', 316, NULL),
('Sheraton Centre', 58, '2019-04-29', 129, NULL),
('Sheraton Centre', 58, '2019-04-30', 113, NULL),
('Sheraton Centre', 58, '2019-05-01', 279, NULL),
('Sheraton Centre', 58, '2019-05-02', 395, NULL),
('Sheraton Centre', 58, '2019-05-03', 292, NULL),
('Sheraton Centre', 58, '2019-05-04', 133, NULL),
('Sheraton Centre', 58, '2019-05-05', 376, NULL),
('Sheraton Centre', 58, '2019-05-06', 318, NULL),
('Sheraton Centre', 58, '2019-05-07', 333, NULL),
('Sheraton Centre', 58, '2019-05-08', 336, NULL),
('Sheraton Centre', 58, '2019-05-09', 181, NULL),
('Sheraton Centre', 58, '2019-05-10', 397, NULL),
('Sheraton Centre', 58, '2019-05-11', 369, NULL),
('Sheraton Centre', 58, '2019-05-12', 383, NULL),
('Sheraton Centre', 58, '2019-05-13', 322, NULL),
('Sheraton Centre', 58, '2019-05-14', 130, NULL),
('Sheraton Centre', 58, '2019-05-15', 393, NULL),
('Sheraton Centre', 58, '2019-05-16', 156, NULL),
('Sheraton Centre', 58, '2019-05-17', 208, NULL),
('Sheraton Centre', 58, '2019-05-18', 204, NULL),
('Sheraton Centre', 58, '2019-05-19', 170, NULL),
('Sheraton Centre', 58, '2019-05-20', 123, NULL),
('Sheraton Centre', 58, '2019-05-21', 315, NULL),
('Sheraton Centre', 58, '2019-05-22', 173, NULL),
('Sheraton Centre', 58, '2019-05-23', 174, NULL),
('Sheraton Centre', 58, '2019-05-24', 243, NULL),
('Sheraton Centre', 58, '2019-05-25', 347, NULL),
('Sheraton Centre', 58, '2019-05-26', 192, NULL),
('Sheraton Centre', 58, '2019-05-27', 370, NULL),
('Sheraton Centre', 58, '2019-05-28', 147, NULL),
('Sheraton Centre', 58, '2019-05-29', 382, NULL),
('Sheraton Centre', 58, '2019-05-30', 387, NULL),
('Sheraton Centre', 58, '2019-05-31', 367, NULL),
('Sheraton Centre', 58, '2019-06-01', 169, NULL),
('Sheraton Centre', 58, '2019-06-02', 336, NULL),
('Sheraton Centre', 58, '2019-06-03', 161, NULL),
('Sheraton Centre', 58, '2019-06-04', 242, NULL),
('Sheraton Centre', 58, '2019-06-05', 289, NULL),
('Sheraton Centre', 58, '2019-06-06', 304, NULL),
('Sheraton Centre', 58, '2019-06-07', 225, NULL),
('Sheraton Centre', 58, '2019-06-08', 260, NULL),
('Sheraton Centre', 58, '2019-06-09', 214, NULL),
('Sheraton Centre', 58, '2019-06-10', 247, NULL),
('Sheraton Centre', 58, '2019-06-11', 378, NULL),
('Sheraton Centre', 58, '2019-06-12', 299, NULL),
('Sheraton Centre', 58, '2019-06-13', 298, NULL),
('Sheraton Centre', 58, '2019-06-14', 108, NULL),
('Sheraton Centre', 58, '2019-06-15', 187, NULL),
('Sheraton Centre', 58, '2019-06-16', 376, NULL),
('Sheraton Centre', 58, '2019-06-17', 383, NULL),
('Sheraton Centre', 58, '2019-06-18', 187, NULL),
('Sheraton Centre', 58, '2019-06-19', 263, NULL),
('Sheraton Centre', 58, '2019-06-20', 118, NULL),
('Sheraton Centre', 58, '2019-06-21', 159, NULL),
('Sheraton Centre', 58, '2019-06-22', 241, NULL),
('Sheraton Centre', 58, '2019-06-23', 398, NULL),
('Sheraton Centre', 58, '2019-06-24', 241, NULL),
('Sheraton Centre', 58, '2019-06-25', 227, NULL),
('Sheraton Centre', 58, '2019-06-26', 261, NULL),
('Sheraton Centre', 58, '2019-06-27', 240, NULL),
('Sheraton Centre', 58, '2019-06-28', 153, NULL),
('Sheraton Centre', 58, '2019-06-29', 133, NULL),
('Sheraton Centre', 58, '2019-06-30', 370, NULL),
('Sheraton Centre', 58, '2019-07-01', 249, NULL),
('Sheraton Centre', 58, '2019-07-02', 227, NULL),
('Sheraton Centre', 58, '2019-07-03', 375, NULL),
('Sheraton Centre', 58, '2019-07-04', 107, NULL),
('Sheraton Centre', 58, '2019-07-05', 129, NULL),
('Sheraton Centre', 58, '2019-07-06', 254, NULL),
('Sheraton Centre', 58, '2019-07-07', 148, NULL),
('Sheraton Centre', 58, '2019-07-08', 244, NULL),
('Sheraton Centre', 58, '2019-07-09', 234, NULL),
('Sheraton Centre', 58, '2019-07-10', 213, NULL),
('Sheraton Centre', 58, '2019-07-11', 371, NULL),
('Sheraton Centre', 58, '2019-07-12', 229, NULL),
('Sheraton Centre', 58, '2019-07-13', 150, NULL),
('Sheraton Centre', 58, '2019-07-14', 361, NULL),
('Sheraton Centre', 58, '2019-07-15', 349, NULL),
('Sheraton Centre', 58, '2019-07-16', 337, NULL),
('Sheraton Centre', 58, '2019-07-17', 200, NULL),
('Sheraton Centre', 58, '2019-07-18', 360, NULL),
('Sheraton Centre', 58, '2019-07-19', 290, NULL),
('Sheraton Centre', 58, '2019-07-20', 335, NULL),
('Sheraton Centre', 58, '2019-07-21', 353, NULL),
('Sheraton Centre', 58, '2019-07-22', 189, NULL),
('Sheraton Centre', 58, '2019-07-23', 284, NULL),
('Sheraton Centre', 58, '2019-07-24', 340, NULL),
('Sheraton Centre', 58, '2019-07-25', 376, NULL),
('Sheraton Centre', 58, '2019-07-26', 315, NULL),
('Sheraton Centre', 58, '2019-07-27', 114, NULL),
('Sheraton Centre', 58, '2019-07-28', 140, NULL),
('Sheraton Centre', 58, '2019-07-29', 258, NULL),
('Sheraton Centre', 58, '2019-07-30', 212, NULL),
('Sheraton Centre', 58, '2019-07-31', 259, NULL),
('Sheraton Centre', 58, '2019-08-01', 281, NULL),
('Sheraton Centre', 58, '2019-08-02', 175, NULL),
('Sheraton Centre', 58, '2019-08-03', 255, NULL),
('Sheraton Centre', 58, '2019-08-04', 306, NULL),
('Sheraton Centre', 58, '2019-08-05', 355, NULL),
('Sheraton Centre', 58, '2019-08-06', 260, NULL),
('Sheraton Centre', 58, '2019-08-07', 235, NULL),
('Sheraton Centre', 58, '2019-08-08', 397, NULL),
('Sheraton Centre', 58, '2019-08-09', 110, NULL),
('Sheraton Centre', 58, '2019-08-10', 178, NULL),
('Sheraton Centre', 58, '2019-08-11', 145, NULL),
('Sheraton Centre', 58, '2019-08-12', 350, NULL),
('Sheraton Centre', 58, '2019-08-13', 271, NULL),
('Sheraton Centre', 58, '2019-08-14', 145, NULL),
('Sheraton Centre', 58, '2019-08-15', 186, NULL),
('Sheraton Centre', 58, '2019-08-16', 162, NULL),
('Sheraton Centre', 58, '2019-08-17', 358, NULL),
('Sheraton Centre', 58, '2019-08-18', 167, NULL),
('Sheraton Centre', 58, '2019-08-19', 191, NULL),
('Sheraton Centre', 58, '2019-08-20', 205, NULL),
('Sheraton Centre', 58, '2019-08-21', 339, NULL),
('Sheraton Centre', 58, '2019-08-22', 245, NULL),
('Sheraton Centre', 58, '2019-08-23', 305, NULL),
('Sheraton Centre', 58, '2019-08-24', 338, NULL),
('Sheraton Centre', 58, '2019-08-25', 157, NULL),
('Sheraton Centre', 58, '2019-08-26', 136, NULL),
('Sheraton Centre', 58, '2019-08-27', 150, NULL),
('Sheraton Centre', 58, '2019-08-28', 368, NULL),
('Sheraton Centre', 58, '2019-08-29', 310, NULL),
('Sheraton Centre', 58, '2019-08-30', 355, NULL),
('Sheraton Centre', 58, '2019-08-31', 216, NULL),
('Sheraton Centre', 58, '2019-09-01', 278, NULL),
('Sheraton Centre', 58, '2019-09-02', 338, NULL),
('Sheraton Centre', 58, '2019-09-03', 135, NULL),
('Sheraton Centre', 58, '2019-09-04', 366, NULL),
('Sheraton Centre', 58, '2019-09-05', 201, NULL),
('Sheraton Centre', 58, '2019-09-06', 209, NULL),
('Sheraton Centre', 58, '2019-09-07', 350, NULL),
('Sheraton Centre', 58, '2019-09-08', 347, NULL),
('Sheraton Centre', 58, '2019-09-09', 186, NULL),
('Sheraton Centre', 58, '2019-09-10', 347, NULL),
('Sheraton Centre', 58, '2019-09-11', 117, NULL),
('Sheraton Centre', 58, '2019-09-12', 138, NULL),
('Sheraton Centre', 58, '2019-09-13', 272, NULL),
('Sheraton Centre', 58, '2019-09-14', 201, NULL),
('Sheraton Centre', 58, '2019-09-15', 350, NULL),
('Sheraton Centre', 58, '2019-09-16', 325, NULL),
('Sheraton Centre', 58, '2019-09-17', 357, NULL),
('Sheraton Centre', 58, '2019-09-18', 340, NULL),
('Sheraton Centre', 58, '2019-09-19', 191, NULL),
('Sheraton Centre', 58, '2019-09-20', 374, NULL),
('Sheraton Centre', 58, '2019-09-21', 168, NULL),
('Sheraton Centre', 58, '2019-09-22', 114, NULL),
('Sheraton Centre', 58, '2019-09-23', 372, NULL),
('Sheraton Centre', 58, '2019-09-24', 131, NULL),
('Sheraton Centre', 58, '2019-09-25', 329, NULL),
('Sheraton Centre', 58, '2019-09-26', 175, NULL),
('Sheraton Centre', 58, '2019-09-27', 198, NULL),
('Sheraton Centre', 58, '2019-09-28', 211, NULL),
('Sheraton Centre', 58, '2019-09-29', 164, NULL),
('Sheraton Centre', 58, '2019-09-30', 165, NULL),
('Sheraton Centre', 58, '2019-10-01', 164, NULL),
('Sheraton Centre', 58, '2019-10-02', 333, NULL),
('Sheraton Centre', 58, '2019-10-03', 381, NULL),
('Sheraton Centre', 58, '2019-10-04', 100, NULL),
('Sheraton Centre', 58, '2019-10-05', 386, NULL),
('Sheraton Centre', 58, '2019-10-06', 282, NULL),
('Sheraton Centre', 58, '2019-10-07', 200, NULL),
('Sheraton Centre', 58, '2019-10-08', 152, NULL),
('Sheraton Centre', 58, '2019-10-09', 242, NULL),
('Sheraton Centre', 58, '2019-10-10', 207, NULL),
('Sheraton Centre', 58, '2019-10-11', 391, NULL),
('Sheraton Centre', 58, '2019-10-12', 133, NULL),
('Sheraton Centre', 58, '2019-10-13', 320, NULL),
('Sheraton Centre', 58, '2019-10-14', 303, NULL),
('Sheraton Centre', 58, '2019-10-15', 379, NULL),
('Sheraton Centre', 58, '2019-10-16', 164, NULL),
('Sheraton Centre', 58, '2019-10-17', 203, NULL),
('Sheraton Centre', 58, '2019-10-18', 212, NULL),
('Sheraton Centre', 58, '2019-10-19', 261, NULL),
('Sheraton Centre', 58, '2019-10-20', 289, NULL),
('Sheraton Centre', 58, '2019-10-21', 276, NULL),
('Sheraton Centre', 58, '2019-10-22', 288, NULL),
('Sheraton Centre', 58, '2019-10-23', 140, NULL),
('Sheraton Centre', 58, '2019-10-24', 315, NULL),
('Sheraton Centre', 58, '2019-10-25', 270, NULL),
('Sheraton Centre', 58, '2019-10-26', 193, NULL),
('Sheraton Centre', 58, '2019-10-27', 125, NULL),
('Sheraton Centre', 58, '2019-10-28', 341, NULL),
('Sheraton Centre', 58, '2019-10-29', 349, NULL),
('Sheraton Centre', 58, '2019-10-30', 354, NULL),
('Sheraton Centre', 58, '2019-10-31', 259, NULL),
('Sheraton Centre', 58, '2019-11-01', 305, NULL),
('Sheraton Centre', 58, '2019-11-02', 271, NULL),
('Sheraton Centre', 58, '2019-11-03', 305, NULL),
('Sheraton Centre', 58, '2019-11-04', 329, NULL),
('Sheraton Centre', 58, '2019-11-05', 105, NULL),
('Sheraton Centre', 58, '2019-11-06', 194, NULL),
('Sheraton Centre', 58, '2019-11-07', 373, NULL),
('Sheraton Centre', 58, '2019-11-08', 236, NULL),
('Sheraton Centre', 58, '2019-11-09', 147, NULL),
('Sheraton Centre', 58, '2019-11-10', 387, NULL),
('Sheraton Centre', 58, '2019-11-11', 183, NULL),
('Sheraton Centre', 58, '2019-11-12', 111, NULL),
('Sheraton Centre', 58, '2019-11-13', 243, NULL),
('Sheraton Centre', 58, '2019-11-14', 267, NULL),
('Sheraton Centre', 58, '2019-11-15', 197, NULL),
('Sheraton Centre', 58, '2019-11-16', 242, NULL),
('Sheraton Centre', 58, '2019-11-17', 386, NULL),
('Sheraton Centre', 58, '2019-11-18', 306, NULL),
('Sheraton Centre', 58, '2019-11-19', 139, NULL),
('Sheraton Centre', 58, '2019-11-20', 285, NULL),
('Sheraton Centre', 58, '2019-11-21', 125, NULL),
('Sheraton Centre', 58, '2019-11-22', 256, NULL),
('Sheraton Centre', 58, '2019-11-23', 225, NULL),
('Sheraton Centre', 58, '2019-11-24', 228, NULL),
('Sheraton Centre', 58, '2019-11-25', 363, NULL),
('Sheraton Centre', 58, '2019-11-26', 136, NULL),
('Sheraton Centre', 58, '2019-11-27', 149, NULL),
('Sheraton Centre', 58, '2019-11-28', 245, NULL),
('Sheraton Centre', 58, '2019-11-29', 364, NULL),
('Sheraton Centre', 58, '2019-11-30', 200, NULL),
('Sheraton Centre', 58, '2019-12-01', 212, NULL),
('Sheraton Centre', 58, '2019-12-02', 210, NULL),
('Sheraton Centre', 58, '2019-12-03', 302, NULL),
('Sheraton Centre', 58, '2019-12-04', 335, NULL),
('Sheraton Centre', 58, '2019-12-05', 150, NULL),
('Sheraton Centre', 58, '2019-12-06', 384, NULL),
('Sheraton Centre', 58, '2019-12-07', 261, NULL),
('Sheraton Centre', 58, '2019-12-08', 364, NULL),
('Sheraton Centre', 58, '2019-12-09', 171, NULL),
('Sheraton Centre', 58, '2019-12-10', 268, NULL),
('Sheraton Centre', 58, '2019-12-11', 274, NULL),
('Sheraton Centre', 58, '2019-12-12', 374, NULL),
('Sheraton Centre', 58, '2019-12-13', 331, NULL),
('Sheraton Centre', 58, '2019-12-14', 181, NULL),
('Sheraton Centre', 58, '2019-12-15', 379, NULL),
('Sheraton Centre', 58, '2019-12-16', 165, NULL),
('Sheraton Centre', 58, '2019-12-17', 287, NULL),
('Sheraton Centre', 58, '2019-12-18', 130, NULL),
('Sheraton Centre', 58, '2019-12-19', 287, NULL),
('Sheraton Centre', 58, '2019-12-20', 324, NULL),
('Sheraton Centre', 58, '2019-12-21', 369, NULL),
('Sheraton Centre', 58, '2019-12-22', 385, NULL),
('Sheraton Centre', 58, '2019-12-23', 226, NULL),
('Sheraton Centre', 58, '2019-12-24', 189, NULL),
('Sheraton Centre', 58, '2019-12-25', 231, NULL),
('Sheraton Centre', 58, '2019-12-26', 138, NULL),
('Sheraton Centre', 58, '2019-12-27', 278, NULL),
('Sheraton Centre', 58, '2019-12-28', 107, NULL),
('Sheraton Centre', 58, '2019-12-29', 337, NULL),
('Sheraton Centre', 58, '2019-12-30', 188, NULL),
('Sheraton Centre', 58, '2019-12-31', 399, NULL),
('Sheraton Centre', 58, '2020-01-01', 282, NULL),
('Sheraton Centre', 58, '2020-01-02', 257, NULL),
('Sheraton Centre', 58, '2020-01-03', 122, NULL),
('Sheraton Centre', 58, '2020-01-04', 370, NULL),
('Sheraton Centre', 58, '2020-01-05', 306, NULL),
('Sheraton Centre', 58, '2020-01-06', 272, NULL),
('Sheraton Centre', 58, '2020-01-07', 366, NULL),
('Sheraton Centre', 58, '2020-01-08', 128, NULL),
('Sheraton Centre', 58, '2020-01-09', 224, NULL),
('Sheraton Centre', 58, '2020-01-10', 377, NULL),
('Sheraton Centre', 58, '2020-01-11', 230, NULL),
('Sheraton Centre', 58, '2020-01-12', 193, NULL),
('Sheraton Centre', 58, '2020-01-13', 155, NULL),
('Sheraton Centre', 58, '2020-01-14', 297, NULL),
('Sheraton Centre', 58, '2020-01-15', 360, NULL),
('Sheraton Centre', 58, '2020-01-16', 340, NULL),
('Sheraton Centre', 58, '2020-01-17', 281, NULL),
('Sheraton Centre', 58, '2020-01-18', 307, NULL),
('Sheraton Centre', 58, '2020-01-19', 189, NULL),
('Sheraton Centre', 58, '2020-01-20', 156, NULL),
('Sheraton Centre', 58, '2020-01-21', 357, NULL),
('Sheraton Centre', 58, '2020-01-22', 301, NULL),
('Sheraton Centre', 58, '2020-01-23', 267, NULL),
('Sheraton Centre', 58, '2020-01-24', 325, NULL),
('Sheraton Centre', 58, '2020-01-25', 139, NULL),
('Sheraton Centre', 58, '2020-01-26', 193, NULL),
('Sheraton Centre', 58, '2020-01-27', 391, NULL),
('Sheraton Centre', 58, '2020-01-28', 258, NULL),
('Sheraton Centre', 58, '2020-01-29', 132, NULL),
('Sheraton Centre', 58, '2020-01-30', 304, NULL),
('Sheraton Centre', 58, '2020-01-31', 106, NULL),
('Sheraton Centre', 58, '2020-02-01', 249, NULL),
('Sheraton Centre', 58, '2020-02-02', 189, NULL),
('Sheraton Centre', 58, '2020-02-03', 389, NULL),
('Sheraton Centre', 58, '2020-02-04', 373, NULL),
('Sheraton Centre', 70, '2019-01-01', 338, NULL),
('Sheraton Centre', 70, '2019-01-02', 169, NULL),
('Sheraton Centre', 70, '2019-01-03', 309, NULL),
('Sheraton Centre', 70, '2019-01-04', 266, NULL),
('Sheraton Centre', 70, '2019-01-05', 302, NULL),
('Sheraton Centre', 70, '2019-01-06', 237, NULL),
('Sheraton Centre', 70, '2019-01-07', 205, NULL),
('Sheraton Centre', 70, '2019-01-08', 284, NULL),
('Sheraton Centre', 70, '2019-01-09', 347, NULL),
('Sheraton Centre', 70, '2019-01-10', 360, NULL),
('Sheraton Centre', 70, '2019-01-11', 368, NULL),
('Sheraton Centre', 70, '2019-01-12', 264, NULL),
('Sheraton Centre', 70, '2019-01-13', 146, NULL),
('Sheraton Centre', 70, '2019-01-14', 206, NULL),
('Sheraton Centre', 70, '2019-01-15', 147, NULL),
('Sheraton Centre', 70, '2019-01-16', 367, NULL),
('Sheraton Centre', 70, '2019-01-17', 169, NULL),
('Sheraton Centre', 70, '2019-01-18', 106, NULL),
('Sheraton Centre', 70, '2019-01-19', 172, NULL),
('Sheraton Centre', 70, '2019-01-20', 245, NULL),
('Sheraton Centre', 70, '2019-01-21', 128, NULL),
('Sheraton Centre', 70, '2019-01-22', 278, NULL),
('Sheraton Centre', 70, '2019-01-23', 283, NULL),
('Sheraton Centre', 70, '2019-01-24', 140, NULL),
('Sheraton Centre', 70, '2019-01-25', 278, NULL),
('Sheraton Centre', 70, '2019-01-26', 228, NULL),
('Sheraton Centre', 70, '2019-01-27', 203, NULL),
('Sheraton Centre', 70, '2019-01-28', 331, NULL),
('Sheraton Centre', 70, '2019-01-29', 147, NULL),
('Sheraton Centre', 70, '2019-01-30', 396, NULL),
('Sheraton Centre', 70, '2019-01-31', 145, NULL),
('Sheraton Centre', 70, '2019-02-01', 340, NULL),
('Sheraton Centre', 70, '2019-02-02', 385, NULL),
('Sheraton Centre', 70, '2019-02-03', 383, NULL),
('Sheraton Centre', 70, '2019-02-04', 219, NULL),
('Sheraton Centre', 70, '2019-02-05', 173, NULL),
('Sheraton Centre', 70, '2019-02-06', 328, NULL),
('Sheraton Centre', 70, '2019-02-07', 225, NULL),
('Sheraton Centre', 70, '2019-02-08', 156, NULL),
('Sheraton Centre', 70, '2019-02-09', 167, NULL),
('Sheraton Centre', 70, '2019-02-10', 273, NULL),
('Sheraton Centre', 70, '2019-02-11', 268, NULL),
('Sheraton Centre', 70, '2019-02-12', 235, NULL),
('Sheraton Centre', 70, '2019-02-13', 287, NULL),
('Sheraton Centre', 70, '2019-02-14', 288, NULL),
('Sheraton Centre', 70, '2019-02-15', 126, NULL),
('Sheraton Centre', 70, '2019-02-16', 293, NULL),
('Sheraton Centre', 70, '2019-02-17', 183, NULL),
('Sheraton Centre', 70, '2019-02-18', 156, NULL),
('Sheraton Centre', 70, '2019-02-19', 314, NULL),
('Sheraton Centre', 70, '2019-02-20', 376, NULL),
('Sheraton Centre', 70, '2019-02-21', 220, NULL),
('Sheraton Centre', 70, '2019-02-22', 326, NULL),
('Sheraton Centre', 70, '2019-02-23', 279, NULL),
('Sheraton Centre', 70, '2019-02-24', 276, NULL),
('Sheraton Centre', 70, '2019-02-25', 359, NULL),
('Sheraton Centre', 70, '2019-02-26', 158, NULL),
('Sheraton Centre', 70, '2019-02-27', 181, NULL),
('Sheraton Centre', 70, '2019-02-28', 102, NULL),
('Sheraton Centre', 70, '2019-03-01', 310, NULL),
('Sheraton Centre', 70, '2019-03-02', 217, NULL),
('Sheraton Centre', 70, '2019-03-03', 230, NULL),
('Sheraton Centre', 70, '2019-03-04', 183, NULL),
('Sheraton Centre', 70, '2019-03-05', 125, NULL),
('Sheraton Centre', 70, '2019-03-06', 255, NULL),
('Sheraton Centre', 70, '2019-03-07', 389, NULL),
('Sheraton Centre', 70, '2019-03-08', 143, NULL),
('Sheraton Centre', 70, '2019-03-09', 392, NULL),
('Sheraton Centre', 70, '2019-03-10', 106, NULL),
('Sheraton Centre', 70, '2019-03-11', 182, NULL),
('Sheraton Centre', 70, '2019-03-12', 109, NULL),
('Sheraton Centre', 70, '2019-03-13', 108, NULL),
('Sheraton Centre', 70, '2019-03-14', 319, NULL),
('Sheraton Centre', 70, '2019-03-15', 167, NULL),
('Sheraton Centre', 70, '2019-03-16', 334, NULL),
('Sheraton Centre', 70, '2019-03-17', 219, NULL),
('Sheraton Centre', 70, '2019-03-18', 161, NULL),
('Sheraton Centre', 70, '2019-03-19', 215, NULL),
('Sheraton Centre', 70, '2019-03-20', 295, NULL),
('Sheraton Centre', 70, '2019-03-21', 211, NULL),
('Sheraton Centre', 70, '2019-03-22', 319, NULL),
('Sheraton Centre', 70, '2019-03-23', 254, NULL),
('Sheraton Centre', 70, '2019-03-24', 335, NULL),
('Sheraton Centre', 70, '2019-03-25', 116, NULL),
('Sheraton Centre', 70, '2019-03-26', 137, NULL),
('Sheraton Centre', 70, '2019-03-27', 323, NULL),
('Sheraton Centre', 70, '2019-03-28', 343, NULL),
('Sheraton Centre', 70, '2019-03-29', 263, NULL),
('Sheraton Centre', 70, '2019-03-30', 167, NULL),
('Sheraton Centre', 70, '2019-03-31', 110, NULL),
('Sheraton Centre', 70, '2019-04-01', 364, NULL),
('Sheraton Centre', 70, '2019-04-02', 164, NULL),
('Sheraton Centre', 70, '2019-04-03', 208, NULL),
('Sheraton Centre', 70, '2019-04-04', 319, NULL),
('Sheraton Centre', 70, '2019-04-05', 374, NULL),
('Sheraton Centre', 70, '2019-04-06', 167, NULL),
('Sheraton Centre', 70, '2019-04-07', 359, NULL),
('Sheraton Centre', 70, '2019-04-08', 168, NULL),
('Sheraton Centre', 70, '2019-04-09', 387, NULL),
('Sheraton Centre', 70, '2019-04-10', 190, NULL),
('Sheraton Centre', 70, '2019-04-11', 264, NULL),
('Sheraton Centre', 70, '2019-04-12', 290, NULL),
('Sheraton Centre', 70, '2019-04-13', 147, NULL),
('Sheraton Centre', 70, '2019-04-14', 175, NULL),
('Sheraton Centre', 70, '2019-04-15', 275, NULL),
('Sheraton Centre', 70, '2019-04-16', 266, NULL),
('Sheraton Centre', 70, '2019-04-17', 110, NULL),
('Sheraton Centre', 70, '2019-04-18', 395, NULL),
('Sheraton Centre', 70, '2019-04-19', 119, NULL),
('Sheraton Centre', 70, '2019-04-20', 227, NULL),
('Sheraton Centre', 70, '2019-04-21', 194, NULL),
('Sheraton Centre', 70, '2019-04-22', 251, NULL),
('Sheraton Centre', 70, '2019-04-23', 112, NULL),
('Sheraton Centre', 70, '2019-04-24', 383, NULL),
('Sheraton Centre', 70, '2019-04-25', 105, NULL),
('Sheraton Centre', 70, '2019-04-26', 200, NULL),
('Sheraton Centre', 70, '2019-04-27', 222, NULL),
('Sheraton Centre', 70, '2019-04-28', 140, NULL),
('Sheraton Centre', 70, '2019-04-29', 264, NULL),
('Sheraton Centre', 70, '2019-04-30', 370, NULL),
('Sheraton Centre', 70, '2019-05-01', 301, NULL),
('Sheraton Centre', 70, '2019-05-02', 109, NULL),
('Sheraton Centre', 70, '2019-05-03', 399, NULL),
('Sheraton Centre', 70, '2019-05-04', 280, NULL),
('Sheraton Centre', 70, '2019-05-05', 192, NULL),
('Sheraton Centre', 70, '2019-05-06', 173, NULL),
('Sheraton Centre', 70, '2019-05-07', 282, NULL),
('Sheraton Centre', 70, '2019-05-08', 317, NULL),
('Sheraton Centre', 70, '2019-05-09', 305, NULL),
('Sheraton Centre', 70, '2019-05-10', 283, NULL),
('Sheraton Centre', 70, '2019-05-11', 175, NULL),
('Sheraton Centre', 70, '2019-05-12', 329, NULL),
('Sheraton Centre', 70, '2019-05-13', 172, NULL),
('Sheraton Centre', 70, '2019-05-14', 167, NULL),
('Sheraton Centre', 70, '2019-05-15', 279, NULL),
('Sheraton Centre', 70, '2019-05-16', 117, NULL),
('Sheraton Centre', 70, '2019-05-17', 150, NULL),
('Sheraton Centre', 70, '2019-05-18', 289, NULL),
('Sheraton Centre', 70, '2019-05-19', 281, NULL),
('Sheraton Centre', 70, '2019-05-20', 358, NULL),
('Sheraton Centre', 70, '2019-05-21', 269, NULL),
('Sheraton Centre', 70, '2019-05-22', 131, NULL),
('Sheraton Centre', 70, '2019-05-23', 212, NULL),
('Sheraton Centre', 70, '2019-05-24', 225, NULL),
('Sheraton Centre', 70, '2019-05-25', 277, NULL),
('Sheraton Centre', 70, '2019-05-26', 297, NULL),
('Sheraton Centre', 70, '2019-05-27', 248, NULL),
('Sheraton Centre', 70, '2019-05-28', 150, NULL),
('Sheraton Centre', 70, '2019-05-29', 322, NULL),
('Sheraton Centre', 70, '2019-05-30', 153, NULL),
('Sheraton Centre', 70, '2019-05-31', 398, NULL),
('Sheraton Centre', 70, '2019-06-01', 134, NULL),
('Sheraton Centre', 70, '2019-06-02', 320, NULL),
('Sheraton Centre', 70, '2019-06-03', 257, NULL),
('Sheraton Centre', 70, '2019-06-04', 245, NULL),
('Sheraton Centre', 70, '2019-06-05', 382, NULL),
('Sheraton Centre', 70, '2019-06-06', 224, NULL),
('Sheraton Centre', 70, '2019-06-07', 111, NULL),
('Sheraton Centre', 70, '2019-06-08', 117, NULL),
('Sheraton Centre', 70, '2019-06-09', 197, NULL),
('Sheraton Centre', 70, '2019-06-10', 315, NULL),
('Sheraton Centre', 70, '2019-06-11', 366, NULL),
('Sheraton Centre', 70, '2019-06-12', 152, NULL),
('Sheraton Centre', 70, '2019-06-13', 295, NULL),
('Sheraton Centre', 70, '2019-06-14', 247, NULL),
('Sheraton Centre', 70, '2019-06-15', 306, NULL),
('Sheraton Centre', 70, '2019-06-16', 381, NULL),
('Sheraton Centre', 70, '2019-06-17', 222, NULL),
('Sheraton Centre', 70, '2019-06-18', 259, NULL),
('Sheraton Centre', 70, '2019-06-19', 160, NULL),
('Sheraton Centre', 70, '2019-06-20', 156, NULL),
('Sheraton Centre', 70, '2019-06-21', 319, NULL),
('Sheraton Centre', 70, '2019-06-22', 346, NULL),
('Sheraton Centre', 70, '2019-06-23', 384, NULL),
('Sheraton Centre', 70, '2019-06-24', 268, NULL),
('Sheraton Centre', 70, '2019-06-25', 209, NULL),
('Sheraton Centre', 70, '2019-06-26', 101, NULL),
('Sheraton Centre', 70, '2019-06-27', 203, NULL),
('Sheraton Centre', 70, '2019-06-28', 133, NULL),
('Sheraton Centre', 70, '2019-06-29', 345, NULL),
('Sheraton Centre', 70, '2019-06-30', 212, NULL),
('Sheraton Centre', 70, '2019-07-01', 307, NULL),
('Sheraton Centre', 70, '2019-07-02', 164, NULL),
('Sheraton Centre', 70, '2019-07-03', 133, NULL),
('Sheraton Centre', 70, '2019-07-04', 359, NULL),
('Sheraton Centre', 70, '2019-07-05', 249, NULL),
('Sheraton Centre', 70, '2019-07-06', 345, NULL),
('Sheraton Centre', 70, '2019-07-07', 289, NULL),
('Sheraton Centre', 70, '2019-07-08', 248, NULL),
('Sheraton Centre', 70, '2019-07-09', 345, NULL),
('Sheraton Centre', 70, '2019-07-10', 371, NULL),
('Sheraton Centre', 70, '2019-07-11', 254, NULL),
('Sheraton Centre', 70, '2019-07-12', 290, NULL),
('Sheraton Centre', 70, '2019-07-13', 388, NULL),
('Sheraton Centre', 70, '2019-07-14', 114, NULL),
('Sheraton Centre', 70, '2019-07-15', 238, NULL),
('Sheraton Centre', 70, '2019-07-16', 119, NULL),
('Sheraton Centre', 70, '2019-07-17', 151, NULL),
('Sheraton Centre', 70, '2019-07-18', 160, NULL),
('Sheraton Centre', 70, '2019-07-19', 300, NULL),
('Sheraton Centre', 70, '2019-07-20', 350, NULL),
('Sheraton Centre', 70, '2019-07-21', 257, NULL),
('Sheraton Centre', 70, '2019-07-22', 194, NULL),
('Sheraton Centre', 70, '2019-07-23', 173, NULL),
('Sheraton Centre', 70, '2019-07-24', 224, NULL),
('Sheraton Centre', 70, '2019-07-25', 282, NULL),
('Sheraton Centre', 70, '2019-07-26', 355, NULL),
('Sheraton Centre', 70, '2019-07-27', 182, NULL),
('Sheraton Centre', 70, '2019-07-28', 367, NULL),
('Sheraton Centre', 70, '2019-07-29', 112, NULL),
('Sheraton Centre', 70, '2019-07-30', 221, NULL),
('Sheraton Centre', 70, '2019-07-31', 333, NULL),
('Sheraton Centre', 70, '2019-08-01', 336, NULL),
('Sheraton Centre', 70, '2019-08-02', 255, NULL),
('Sheraton Centre', 70, '2019-08-03', 238, NULL),
('Sheraton Centre', 70, '2019-08-04', 350, NULL),
('Sheraton Centre', 70, '2019-08-05', 376, NULL),
('Sheraton Centre', 70, '2019-08-06', 315, NULL),
('Sheraton Centre', 70, '2019-08-07', 112, NULL),
('Sheraton Centre', 70, '2019-08-08', 283, NULL),
('Sheraton Centre', 70, '2019-08-09', 195, NULL),
('Sheraton Centre', 70, '2019-08-10', 300, NULL),
('Sheraton Centre', 70, '2019-08-11', 201, NULL),
('Sheraton Centre', 70, '2019-08-12', 179, NULL),
('Sheraton Centre', 70, '2019-08-13', 236, NULL),
('Sheraton Centre', 70, '2019-08-14', 326, NULL),
('Sheraton Centre', 70, '2019-08-15', 124, NULL),
('Sheraton Centre', 70, '2019-08-16', 230, NULL),
('Sheraton Centre', 70, '2019-08-17', 357, NULL),
('Sheraton Centre', 70, '2019-08-18', 149, NULL),
('Sheraton Centre', 70, '2019-08-19', 303, NULL),
('Sheraton Centre', 70, '2019-08-20', 278, NULL),
('Sheraton Centre', 70, '2019-08-21', 331, NULL),
('Sheraton Centre', 70, '2019-08-22', 279, NULL),
('Sheraton Centre', 70, '2019-08-23', 136, NULL),
('Sheraton Centre', 70, '2019-08-24', 287, NULL),
('Sheraton Centre', 70, '2019-08-25', 308, NULL),
('Sheraton Centre', 70, '2019-08-26', 201, NULL),
('Sheraton Centre', 70, '2019-08-27', 233, NULL),
('Sheraton Centre', 70, '2019-08-28', 272, NULL),
('Sheraton Centre', 70, '2019-08-29', 343, NULL),
('Sheraton Centre', 70, '2019-08-30', 140, NULL),
('Sheraton Centre', 70, '2019-08-31', 330, NULL),
('Sheraton Centre', 70, '2019-09-01', 314, NULL),
('Sheraton Centre', 70, '2019-09-02', 261, NULL),
('Sheraton Centre', 70, '2019-09-03', 398, NULL),
('Sheraton Centre', 70, '2019-09-04', 119, NULL),
('Sheraton Centre', 70, '2019-09-05', 215, NULL),
('Sheraton Centre', 70, '2019-09-06', 260, NULL),
('Sheraton Centre', 70, '2019-09-07', 373, NULL),
('Sheraton Centre', 70, '2019-09-08', 257, NULL),
('Sheraton Centre', 70, '2019-09-09', 247, NULL),
('Sheraton Centre', 70, '2019-09-10', 284, NULL),
('Sheraton Centre', 70, '2019-09-11', 213, NULL),
('Sheraton Centre', 70, '2019-09-12', 123, NULL),
('Sheraton Centre', 70, '2019-09-13', 220, NULL),
('Sheraton Centre', 70, '2019-09-14', 382, NULL),
('Sheraton Centre', 70, '2019-09-15', 329, NULL),
('Sheraton Centre', 70, '2019-09-16', 240, NULL),
('Sheraton Centre', 70, '2019-09-17', 244, NULL),
('Sheraton Centre', 70, '2019-09-18', 353, NULL),
('Sheraton Centre', 70, '2019-09-19', 309, NULL),
('Sheraton Centre', 70, '2019-09-20', 246, NULL),
('Sheraton Centre', 70, '2019-09-21', 281, NULL),
('Sheraton Centre', 70, '2019-09-22', 231, NULL),
('Sheraton Centre', 70, '2019-09-23', 351, NULL),
('Sheraton Centre', 70, '2019-09-24', 336, NULL),
('Sheraton Centre', 70, '2019-09-25', 375, NULL),
('Sheraton Centre', 70, '2019-09-26', 325, NULL),
('Sheraton Centre', 70, '2019-09-27', 100, NULL),
('Sheraton Centre', 70, '2019-09-28', 154, NULL),
('Sheraton Centre', 70, '2019-09-29', 213, NULL),
('Sheraton Centre', 70, '2019-09-30', 235, NULL),
('Sheraton Centre', 70, '2019-10-01', 170, NULL),
('Sheraton Centre', 70, '2019-10-02', 321, NULL),
('Sheraton Centre', 70, '2019-10-03', 176, NULL),
('Sheraton Centre', 70, '2019-10-04', 195, NULL),
('Sheraton Centre', 70, '2019-10-05', 178, NULL),
('Sheraton Centre', 70, '2019-10-06', 229, NULL),
('Sheraton Centre', 70, '2019-10-07', 318, NULL),
('Sheraton Centre', 70, '2019-10-08', 373, NULL),
('Sheraton Centre', 70, '2019-10-09', 352, NULL),
('Sheraton Centre', 70, '2019-10-10', 394, NULL),
('Sheraton Centre', 70, '2019-10-11', 107, NULL),
('Sheraton Centre', 70, '2019-10-12', 275, NULL),
('Sheraton Centre', 70, '2019-10-13', 131, NULL),
('Sheraton Centre', 70, '2019-10-14', 242, NULL),
('Sheraton Centre', 70, '2019-10-15', 137, NULL),
('Sheraton Centre', 70, '2019-10-16', 103, NULL),
('Sheraton Centre', 70, '2019-10-17', 278, NULL),
('Sheraton Centre', 70, '2019-10-18', 288, NULL),
('Sheraton Centre', 70, '2019-10-19', 135, NULL),
('Sheraton Centre', 70, '2019-10-20', 122, NULL),
('Sheraton Centre', 70, '2019-10-21', 362, NULL),
('Sheraton Centre', 70, '2019-10-22', 260, NULL),
('Sheraton Centre', 70, '2019-10-23', 131, NULL),
('Sheraton Centre', 70, '2019-10-24', 345, NULL),
('Sheraton Centre', 70, '2019-10-25', 349, NULL),
('Sheraton Centre', 70, '2019-10-26', 286, NULL),
('Sheraton Centre', 70, '2019-10-27', 259, NULL),
('Sheraton Centre', 70, '2019-10-28', 199, NULL),
('Sheraton Centre', 70, '2019-10-29', 250, NULL),
('Sheraton Centre', 70, '2019-10-30', 189, NULL),
('Sheraton Centre', 70, '2019-10-31', 102, NULL),
('Sheraton Centre', 70, '2019-11-01', 155, NULL),
('Sheraton Centre', 70, '2019-11-02', 207, NULL),
('Sheraton Centre', 70, '2019-11-03', 175, NULL),
('Sheraton Centre', 70, '2019-11-04', 156, NULL),
('Sheraton Centre', 70, '2019-11-05', 343, NULL),
('Sheraton Centre', 70, '2019-11-06', 388, NULL),
('Sheraton Centre', 70, '2019-11-07', 370, NULL),
('Sheraton Centre', 70, '2019-11-08', 102, NULL),
('Sheraton Centre', 70, '2019-11-09', 191, NULL),
('Sheraton Centre', 70, '2019-11-10', 238, NULL),
('Sheraton Centre', 70, '2019-11-11', 161, NULL),
('Sheraton Centre', 70, '2019-11-12', 353, NULL),
('Sheraton Centre', 70, '2019-11-13', 314, NULL),
('Sheraton Centre', 70, '2019-11-14', 277, NULL),
('Sheraton Centre', 70, '2019-11-15', 381, NULL),
('Sheraton Centre', 70, '2019-11-16', 386, NULL),
('Sheraton Centre', 70, '2019-11-17', 167, NULL),
('Sheraton Centre', 70, '2019-11-18', 299, NULL),
('Sheraton Centre', 70, '2019-11-19', 213, NULL),
('Sheraton Centre', 70, '2019-11-20', 111, NULL),
('Sheraton Centre', 70, '2019-11-21', 156, NULL),
('Sheraton Centre', 70, '2019-11-22', 183, NULL),
('Sheraton Centre', 70, '2019-11-23', 159, NULL),
('Sheraton Centre', 70, '2019-11-24', 211, NULL),
('Sheraton Centre', 70, '2019-11-25', 345, NULL),
('Sheraton Centre', 70, '2019-11-26', 393, NULL),
('Sheraton Centre', 70, '2019-11-27', 118, NULL),
('Sheraton Centre', 70, '2019-11-28', 186, NULL),
('Sheraton Centre', 70, '2019-11-29', 132, NULL),
('Sheraton Centre', 70, '2019-11-30', 280, NULL),
('Sheraton Centre', 70, '2019-12-01', 214, NULL),
('Sheraton Centre', 70, '2019-12-02', 398, NULL),
('Sheraton Centre', 70, '2019-12-03', 214, NULL),
('Sheraton Centre', 70, '2019-12-04', 383, NULL),
('Sheraton Centre', 70, '2019-12-05', 187, NULL),
('Sheraton Centre', 70, '2019-12-06', 145, NULL),
('Sheraton Centre', 70, '2019-12-07', 209, NULL),
('Sheraton Centre', 70, '2019-12-08', 304, NULL),
('Sheraton Centre', 70, '2019-12-09', 397, NULL),
('Sheraton Centre', 70, '2019-12-10', 109, NULL),
('Sheraton Centre', 70, '2019-12-11', 100, NULL),
('Sheraton Centre', 70, '2019-12-12', 341, NULL),
('Sheraton Centre', 70, '2019-12-13', 172, NULL),
('Sheraton Centre', 70, '2019-12-14', 182, NULL),
('Sheraton Centre', 70, '2019-12-15', 210, NULL),
('Sheraton Centre', 70, '2019-12-16', 131, NULL),
('Sheraton Centre', 70, '2019-12-17', 191, NULL),
('Sheraton Centre', 70, '2019-12-18', 395, NULL),
('Sheraton Centre', 70, '2019-12-19', 155, NULL),
('Sheraton Centre', 70, '2019-12-20', 396, NULL),
('Sheraton Centre', 70, '2019-12-21', 225, NULL),
('Sheraton Centre', 70, '2019-12-22', 239, NULL),
('Sheraton Centre', 70, '2019-12-23', 386, NULL),
('Sheraton Centre', 70, '2019-12-24', 367, NULL),
('Sheraton Centre', 70, '2019-12-25', 193, NULL),
('Sheraton Centre', 70, '2019-12-26', 340, NULL),
('Sheraton Centre', 70, '2019-12-27', 178, NULL),
('Sheraton Centre', 70, '2019-12-28', 346, NULL),
('Sheraton Centre', 70, '2019-12-29', 326, NULL),
('Sheraton Centre', 70, '2019-12-30', 132, NULL),
('Sheraton Centre', 70, '2019-12-31', 183, NULL),
('Sheraton Centre', 70, '2020-01-01', 140, NULL),
('Sheraton Centre', 70, '2020-01-02', 312, NULL),
('Sheraton Centre', 70, '2020-01-03', 212, NULL),
('Sheraton Centre', 70, '2020-01-04', 212, NULL),
('Sheraton Centre', 70, '2020-01-05', 189, NULL),
('Sheraton Centre', 70, '2020-01-06', 265, NULL),
('Sheraton Centre', 70, '2020-01-07', 140, NULL),
('Sheraton Centre', 70, '2020-01-08', 323, NULL),
('Sheraton Centre', 70, '2020-01-09', 147, NULL),
('Sheraton Centre', 70, '2020-01-10', 125, NULL),
('Sheraton Centre', 70, '2020-01-11', 303, NULL),
('Sheraton Centre', 70, '2020-01-12', 380, NULL),
('Sheraton Centre', 70, '2020-01-13', 247, NULL),
('Sheraton Centre', 70, '2020-01-14', 371, NULL),
('Sheraton Centre', 70, '2020-01-15', 330, NULL),
('Sheraton Centre', 70, '2020-01-16', 212, NULL),
('Sheraton Centre', 70, '2020-01-17', 248, NULL),
('Sheraton Centre', 70, '2020-01-18', 363, NULL),
('Sheraton Centre', 70, '2020-01-19', 341, NULL),
('Sheraton Centre', 70, '2020-01-20', 275, NULL),
('Sheraton Centre', 70, '2020-01-21', 296, NULL),
('Sheraton Centre', 70, '2020-01-22', 212, NULL),
('Sheraton Centre', 70, '2020-01-23', 164, NULL),
('Sheraton Centre', 70, '2020-01-24', 320, NULL),
('Sheraton Centre', 70, '2020-01-25', 349, NULL),
('Sheraton Centre', 70, '2020-01-26', 125, NULL),
('Sheraton Centre', 70, '2020-01-27', 245, NULL),
('Sheraton Centre', 70, '2020-01-28', 366, NULL),
('Sheraton Centre', 70, '2020-01-29', 203, NULL),
('Sheraton Centre', 70, '2020-01-30', 345, NULL),
('Sheraton Centre', 70, '2020-01-31', 300, NULL),
('Sheraton Centre', 70, '2020-02-01', 195, NULL),
('Sheraton Centre', 70, '2020-02-02', 311, NULL),
('Sheraton Centre', 70, '2020-02-03', 101, NULL),
('Sheraton Centre', 70, '2020-02-04', 360, NULL),
('Sheraton Centre', 92, '2019-01-01', 144, NULL),
('Sheraton Centre', 92, '2019-01-02', 361, NULL),
('Sheraton Centre', 92, '2019-01-03', 240, NULL),
('Sheraton Centre', 92, '2019-01-04', 283, NULL),
('Sheraton Centre', 92, '2019-01-05', 196, NULL),
('Sheraton Centre', 92, '2019-01-06', 203, NULL),
('Sheraton Centre', 92, '2019-01-07', 174, NULL),
('Sheraton Centre', 92, '2019-01-08', 246, NULL),
('Sheraton Centre', 92, '2019-01-09', 154, NULL),
('Sheraton Centre', 92, '2019-01-10', 191, NULL),
('Sheraton Centre', 92, '2019-01-11', 263, NULL),
('Sheraton Centre', 92, '2019-01-12', 146, NULL),
('Sheraton Centre', 92, '2019-01-13', 219, NULL),
('Sheraton Centre', 92, '2019-01-14', 159, NULL),
('Sheraton Centre', 92, '2019-01-15', 142, NULL),
('Sheraton Centre', 92, '2019-01-16', 270, NULL),
('Sheraton Centre', 92, '2019-01-17', 338, NULL),
('Sheraton Centre', 92, '2019-01-18', 325, NULL),
('Sheraton Centre', 92, '2019-01-19', 246, NULL),
('Sheraton Centre', 92, '2019-01-20', 272, NULL),
('Sheraton Centre', 92, '2019-01-21', 205, NULL),
('Sheraton Centre', 92, '2019-01-22', 338, NULL),
('Sheraton Centre', 92, '2019-01-23', 199, NULL),
('Sheraton Centre', 92, '2019-01-24', 243, NULL),
('Sheraton Centre', 92, '2019-01-25', 221, NULL),
('Sheraton Centre', 92, '2019-01-26', 366, NULL),
('Sheraton Centre', 92, '2019-01-27', 197, NULL),
('Sheraton Centre', 92, '2019-01-28', 371, NULL),
('Sheraton Centre', 92, '2019-01-29', 180, NULL),
('Sheraton Centre', 92, '2019-01-30', 367, NULL),
('Sheraton Centre', 92, '2019-01-31', 322, NULL),
('Sheraton Centre', 92, '2019-02-01', 234, NULL),
('Sheraton Centre', 92, '2019-02-02', 178, NULL),
('Sheraton Centre', 92, '2019-02-03', 280, NULL),
('Sheraton Centre', 92, '2019-02-04', 369, NULL),
('Sheraton Centre', 92, '2019-02-05', 340, NULL),
('Sheraton Centre', 92, '2019-02-06', 382, NULL),
('Sheraton Centre', 92, '2019-02-07', 108, NULL),
('Sheraton Centre', 92, '2019-02-08', 360, NULL),
('Sheraton Centre', 92, '2019-02-09', 333, NULL),
('Sheraton Centre', 92, '2019-02-10', 362, NULL),
('Sheraton Centre', 92, '2019-02-11', 136, NULL),
('Sheraton Centre', 92, '2019-02-12', 272, NULL),
('Sheraton Centre', 92, '2019-02-13', 212, NULL),
('Sheraton Centre', 92, '2019-02-14', 282, NULL),
('Sheraton Centre', 92, '2019-02-15', 127, NULL),
('Sheraton Centre', 92, '2019-02-16', 389, NULL),
('Sheraton Centre', 92, '2019-02-17', 270, NULL),
('Sheraton Centre', 92, '2019-02-18', 180, NULL),
('Sheraton Centre', 92, '2019-02-19', 293, NULL),
('Sheraton Centre', 92, '2019-02-20', 397, NULL),
('Sheraton Centre', 92, '2019-02-21', 345, NULL),
('Sheraton Centre', 92, '2019-02-22', 273, NULL),
('Sheraton Centre', 92, '2019-02-23', 228, NULL),
('Sheraton Centre', 92, '2019-02-24', 387, NULL),
('Sheraton Centre', 92, '2019-02-25', 336, NULL),
('Sheraton Centre', 92, '2019-02-26', 120, NULL),
('Sheraton Centre', 92, '2019-02-27', 321, NULL),
('Sheraton Centre', 92, '2019-02-28', 341, NULL),
('Sheraton Centre', 92, '2019-03-01', 165, NULL),
('Sheraton Centre', 92, '2019-03-02', 173, NULL),
('Sheraton Centre', 92, '2019-03-03', 145, NULL),
('Sheraton Centre', 92, '2019-03-04', 158, NULL),
('Sheraton Centre', 92, '2019-03-05', 191, NULL),
('Sheraton Centre', 92, '2019-03-06', 146, NULL),
('Sheraton Centre', 92, '2019-03-07', 177, NULL),
('Sheraton Centre', 92, '2019-03-08', 333, NULL),
('Sheraton Centre', 92, '2019-03-09', 357, NULL),
('Sheraton Centre', 92, '2019-03-10', 238, NULL),
('Sheraton Centre', 92, '2019-03-11', 399, NULL),
('Sheraton Centre', 92, '2019-03-12', 134, NULL),
('Sheraton Centre', 92, '2019-03-13', 255, NULL),
('Sheraton Centre', 92, '2019-03-14', 226, NULL),
('Sheraton Centre', 92, '2019-03-15', 104, NULL),
('Sheraton Centre', 92, '2019-03-16', 381, NULL),
('Sheraton Centre', 92, '2019-03-17', 230, NULL),
('Sheraton Centre', 92, '2019-03-18', 235, NULL),
('Sheraton Centre', 92, '2019-03-19', 330, NULL),
('Sheraton Centre', 92, '2019-03-20', 241, NULL),
('Sheraton Centre', 92, '2019-03-21', 210, NULL),
('Sheraton Centre', 92, '2019-03-22', 275, NULL),
('Sheraton Centre', 92, '2019-03-23', 312, NULL),
('Sheraton Centre', 92, '2019-03-24', 208, NULL),
('Sheraton Centre', 92, '2019-03-25', 349, NULL),
('Sheraton Centre', 92, '2019-03-26', 384, NULL),
('Sheraton Centre', 92, '2019-03-27', 360, NULL),
('Sheraton Centre', 92, '2019-03-28', 318, NULL),
('Sheraton Centre', 92, '2019-03-29', 212, NULL),
('Sheraton Centre', 92, '2019-03-30', 261, NULL),
('Sheraton Centre', 92, '2019-03-31', 357, NULL),
('Sheraton Centre', 92, '2019-04-01', 137, NULL),
('Sheraton Centre', 92, '2019-04-02', 398, NULL),
('Sheraton Centre', 92, '2019-04-03', 379, NULL),
('Sheraton Centre', 92, '2019-04-04', 105, NULL),
('Sheraton Centre', 92, '2019-04-05', 133, NULL),
('Sheraton Centre', 92, '2019-04-06', 378, NULL),
('Sheraton Centre', 92, '2019-04-07', 197, NULL),
('Sheraton Centre', 92, '2019-04-08', 289, NULL),
('Sheraton Centre', 92, '2019-04-09', 164, NULL),
('Sheraton Centre', 92, '2019-04-10', 210, NULL),
('Sheraton Centre', 92, '2019-04-11', 388, NULL),
('Sheraton Centre', 92, '2019-04-12', 274, NULL),
('Sheraton Centre', 92, '2019-04-13', 376, NULL),
('Sheraton Centre', 92, '2019-04-14', 154, NULL),
('Sheraton Centre', 92, '2019-04-15', 163, NULL),
('Sheraton Centre', 92, '2019-04-16', 108, NULL),
('Sheraton Centre', 92, '2019-04-17', 236, NULL),
('Sheraton Centre', 92, '2019-04-18', 151, NULL),
('Sheraton Centre', 92, '2019-04-19', 108, NULL),
('Sheraton Centre', 92, '2019-04-20', 174, NULL),
('Sheraton Centre', 92, '2019-04-21', 147, NULL),
('Sheraton Centre', 92, '2019-04-22', 165, NULL),
('Sheraton Centre', 92, '2019-04-23', 395, NULL),
('Sheraton Centre', 92, '2019-04-24', 381, NULL),
('Sheraton Centre', 92, '2019-04-25', 135, NULL),
('Sheraton Centre', 92, '2019-04-26', 223, NULL),
('Sheraton Centre', 92, '2019-04-27', 208, NULL),
('Sheraton Centre', 92, '2019-04-28', 252, NULL),
('Sheraton Centre', 92, '2019-04-29', 231, NULL),
('Sheraton Centre', 92, '2019-04-30', 211, NULL),
('Sheraton Centre', 92, '2019-05-01', 270, NULL),
('Sheraton Centre', 92, '2019-05-02', 160, NULL),
('Sheraton Centre', 92, '2019-05-03', 119, NULL),
('Sheraton Centre', 92, '2019-05-04', 299, NULL),
('Sheraton Centre', 92, '2019-05-05', 334, NULL),
('Sheraton Centre', 92, '2019-05-06', 112, NULL),
('Sheraton Centre', 92, '2019-05-07', 312, NULL),
('Sheraton Centre', 92, '2019-05-08', 176, NULL),
('Sheraton Centre', 92, '2019-05-09', 282, NULL),
('Sheraton Centre', 92, '2019-05-10', 124, NULL),
('Sheraton Centre', 92, '2019-05-11', 267, NULL),
('Sheraton Centre', 92, '2019-05-12', 100, NULL),
('Sheraton Centre', 92, '2019-05-13', 395, NULL),
('Sheraton Centre', 92, '2019-05-14', 346, NULL),
('Sheraton Centre', 92, '2019-05-15', 117, NULL),
('Sheraton Centre', 92, '2019-05-16', 320, NULL),
('Sheraton Centre', 92, '2019-05-17', 327, NULL),
('Sheraton Centre', 92, '2019-05-18', 133, NULL),
('Sheraton Centre', 92, '2019-05-19', 197, NULL),
('Sheraton Centre', 92, '2019-05-20', 123, NULL),
('Sheraton Centre', 92, '2019-05-21', 299, NULL),
('Sheraton Centre', 92, '2019-05-22', 334, NULL),
('Sheraton Centre', 92, '2019-05-23', 137, NULL),
('Sheraton Centre', 92, '2019-05-24', 295, NULL),
('Sheraton Centre', 92, '2019-05-25', 242, NULL),
('Sheraton Centre', 92, '2019-05-26', 211, NULL),
('Sheraton Centre', 92, '2019-05-27', 328, NULL),
('Sheraton Centre', 92, '2019-05-28', 209, NULL),
('Sheraton Centre', 92, '2019-05-29', 366, NULL),
('Sheraton Centre', 92, '2019-05-30', 105, NULL),
('Sheraton Centre', 92, '2019-05-31', 188, NULL),
('Sheraton Centre', 92, '2019-06-01', 364, NULL),
('Sheraton Centre', 92, '2019-06-02', 195, NULL),
('Sheraton Centre', 92, '2019-06-03', 104, NULL),
('Sheraton Centre', 92, '2019-06-04', 399, NULL),
('Sheraton Centre', 92, '2019-06-05', 344, NULL),
('Sheraton Centre', 92, '2019-06-06', 110, NULL),
('Sheraton Centre', 92, '2019-06-07', 380, NULL),
('Sheraton Centre', 92, '2019-06-08', 303, NULL),
('Sheraton Centre', 92, '2019-06-09', 245, NULL),
('Sheraton Centre', 92, '2019-06-10', 137, NULL),
('Sheraton Centre', 92, '2019-06-11', 296, NULL),
('Sheraton Centre', 92, '2019-06-12', 363, NULL),
('Sheraton Centre', 92, '2019-06-13', 181, NULL),
('Sheraton Centre', 92, '2019-06-14', 212, NULL),
('Sheraton Centre', 92, '2019-06-15', 271, NULL),
('Sheraton Centre', 92, '2019-06-16', 379, NULL),
('Sheraton Centre', 92, '2019-06-17', 159, NULL),
('Sheraton Centre', 92, '2019-06-18', 331, NULL),
('Sheraton Centre', 92, '2019-06-19', 211, NULL),
('Sheraton Centre', 92, '2019-06-20', 326, NULL),
('Sheraton Centre', 92, '2019-06-21', 122, NULL),
('Sheraton Centre', 92, '2019-06-22', 309, NULL),
('Sheraton Centre', 92, '2019-06-23', 329, NULL),
('Sheraton Centre', 92, '2019-06-24', 218, NULL),
('Sheraton Centre', 92, '2019-06-25', 262, NULL),
('Sheraton Centre', 92, '2019-06-26', 224, NULL),
('Sheraton Centre', 92, '2019-06-27', 194, NULL),
('Sheraton Centre', 92, '2019-06-28', 108, NULL),
('Sheraton Centre', 92, '2019-06-29', 329, NULL),
('Sheraton Centre', 92, '2019-06-30', 152, NULL),
('Sheraton Centre', 92, '2019-07-01', 386, NULL),
('Sheraton Centre', 92, '2019-07-02', 339, NULL),
('Sheraton Centre', 92, '2019-07-03', 340, NULL),
('Sheraton Centre', 92, '2019-07-04', 177, NULL),
('Sheraton Centre', 92, '2019-07-05', 158, NULL),
('Sheraton Centre', 92, '2019-07-06', 265, NULL),
('Sheraton Centre', 92, '2019-07-07', 302, NULL),
('Sheraton Centre', 92, '2019-07-08', 110, NULL),
('Sheraton Centre', 92, '2019-07-09', 324, NULL),
('Sheraton Centre', 92, '2019-07-10', 217, NULL),
('Sheraton Centre', 92, '2019-07-11', 357, NULL),
('Sheraton Centre', 92, '2019-07-12', 361, NULL),
('Sheraton Centre', 92, '2019-07-13', 188, NULL),
('Sheraton Centre', 92, '2019-07-14', 287, NULL),
('Sheraton Centre', 92, '2019-07-15', 343, NULL),
('Sheraton Centre', 92, '2019-07-16', 382, NULL),
('Sheraton Centre', 92, '2019-07-17', 355, NULL),
('Sheraton Centre', 92, '2019-07-18', 223, NULL),
('Sheraton Centre', 92, '2019-07-19', 231, NULL),
('Sheraton Centre', 92, '2019-07-20', 344, NULL),
('Sheraton Centre', 92, '2019-07-21', 126, NULL),
('Sheraton Centre', 92, '2019-07-22', 301, NULL),
('Sheraton Centre', 92, '2019-07-23', 210, NULL),
('Sheraton Centre', 92, '2019-07-24', 300, NULL),
('Sheraton Centre', 92, '2019-07-25', 181, NULL),
('Sheraton Centre', 92, '2019-07-26', 133, NULL),
('Sheraton Centre', 92, '2019-07-27', 168, NULL),
('Sheraton Centre', 92, '2019-07-28', 114, NULL),
('Sheraton Centre', 92, '2019-07-29', 287, NULL),
('Sheraton Centre', 92, '2019-07-30', 371, NULL),
('Sheraton Centre', 92, '2019-07-31', 187, NULL),
('Sheraton Centre', 92, '2019-08-01', 140, NULL),
('Sheraton Centre', 92, '2019-08-02', 349, NULL),
('Sheraton Centre', 92, '2019-08-03', 324, NULL),
('Sheraton Centre', 92, '2019-08-04', 131, NULL),
('Sheraton Centre', 92, '2019-08-05', 115, NULL),
('Sheraton Centre', 92, '2019-08-06', 397, NULL),
('Sheraton Centre', 92, '2019-08-07', 356, NULL),
('Sheraton Centre', 92, '2019-08-08', 122, NULL),
('Sheraton Centre', 92, '2019-08-09', 247, NULL),
('Sheraton Centre', 92, '2019-08-10', 264, NULL),
('Sheraton Centre', 92, '2019-08-11', 170, NULL),
('Sheraton Centre', 92, '2019-08-12', 344, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 92, '2019-08-13', 269, NULL),
('Sheraton Centre', 92, '2019-08-14', 195, NULL),
('Sheraton Centre', 92, '2019-08-15', 261, NULL),
('Sheraton Centre', 92, '2019-08-16', 266, NULL),
('Sheraton Centre', 92, '2019-08-17', 312, NULL),
('Sheraton Centre', 92, '2019-08-18', 147, NULL),
('Sheraton Centre', 92, '2019-08-19', 241, NULL),
('Sheraton Centre', 92, '2019-08-20', 378, NULL),
('Sheraton Centre', 92, '2019-08-21', 238, NULL),
('Sheraton Centre', 92, '2019-08-22', 263, NULL),
('Sheraton Centre', 92, '2019-08-23', 265, NULL),
('Sheraton Centre', 92, '2019-08-24', 325, NULL),
('Sheraton Centre', 92, '2019-08-25', 370, NULL),
('Sheraton Centre', 92, '2019-08-26', 197, NULL),
('Sheraton Centre', 92, '2019-08-27', 315, NULL),
('Sheraton Centre', 92, '2019-08-28', 157, NULL),
('Sheraton Centre', 92, '2019-08-29', 387, NULL),
('Sheraton Centre', 92, '2019-08-30', 132, NULL),
('Sheraton Centre', 92, '2019-08-31', 304, NULL),
('Sheraton Centre', 92, '2019-09-01', 340, NULL),
('Sheraton Centre', 92, '2019-09-02', 193, NULL),
('Sheraton Centre', 92, '2019-09-03', 287, NULL),
('Sheraton Centre', 92, '2019-09-04', 294, NULL),
('Sheraton Centre', 92, '2019-09-05', 373, NULL),
('Sheraton Centre', 92, '2019-09-06', 276, NULL),
('Sheraton Centre', 92, '2019-09-07', 118, NULL),
('Sheraton Centre', 92, '2019-09-08', 146, NULL),
('Sheraton Centre', 92, '2019-09-09', 279, NULL),
('Sheraton Centre', 92, '2019-09-10', 277, NULL),
('Sheraton Centre', 92, '2019-09-11', 313, NULL),
('Sheraton Centre', 92, '2019-09-12', 100, NULL),
('Sheraton Centre', 92, '2019-09-13', 182, NULL),
('Sheraton Centre', 92, '2019-09-14', 306, NULL),
('Sheraton Centre', 92, '2019-09-15', 198, NULL),
('Sheraton Centre', 92, '2019-09-16', 128, NULL),
('Sheraton Centre', 92, '2019-09-17', 351, NULL),
('Sheraton Centre', 92, '2019-09-18', 346, NULL),
('Sheraton Centre', 92, '2019-09-19', 273, NULL),
('Sheraton Centre', 92, '2019-09-20', 309, NULL),
('Sheraton Centre', 92, '2019-09-21', 203, NULL),
('Sheraton Centre', 92, '2019-09-22', 115, NULL),
('Sheraton Centre', 92, '2019-09-23', 241, NULL),
('Sheraton Centre', 92, '2019-09-24', 288, NULL),
('Sheraton Centre', 92, '2019-09-25', 189, NULL),
('Sheraton Centre', 92, '2019-09-26', 101, NULL),
('Sheraton Centre', 92, '2019-09-27', 106, NULL),
('Sheraton Centre', 92, '2019-09-28', 339, NULL),
('Sheraton Centre', 92, '2019-09-29', 173, NULL),
('Sheraton Centre', 92, '2019-09-30', 280, NULL),
('Sheraton Centre', 92, '2019-10-01', 255, NULL),
('Sheraton Centre', 92, '2019-10-02', 209, NULL),
('Sheraton Centre', 92, '2019-10-03', 234, NULL),
('Sheraton Centre', 92, '2019-10-04', 272, NULL),
('Sheraton Centre', 92, '2019-10-05', 230, NULL),
('Sheraton Centre', 92, '2019-10-06', 197, NULL),
('Sheraton Centre', 92, '2019-10-07', 290, NULL),
('Sheraton Centre', 92, '2019-10-08', 108, NULL),
('Sheraton Centre', 92, '2019-10-09', 332, NULL),
('Sheraton Centre', 92, '2019-10-10', 351, NULL),
('Sheraton Centre', 92, '2019-10-11', 160, NULL),
('Sheraton Centre', 92, '2019-10-12', 275, NULL),
('Sheraton Centre', 92, '2019-10-13', 197, NULL),
('Sheraton Centre', 92, '2019-10-14', 201, NULL),
('Sheraton Centre', 92, '2019-10-15', 349, NULL),
('Sheraton Centre', 92, '2019-10-16', 220, NULL),
('Sheraton Centre', 92, '2019-10-17', 379, NULL),
('Sheraton Centre', 92, '2019-10-18', 105, NULL),
('Sheraton Centre', 92, '2019-10-19', 393, NULL),
('Sheraton Centre', 92, '2019-10-20', 242, NULL),
('Sheraton Centre', 92, '2019-10-21', 280, NULL),
('Sheraton Centre', 92, '2019-10-22', 337, NULL),
('Sheraton Centre', 92, '2019-10-23', 136, NULL),
('Sheraton Centre', 92, '2019-10-24', 379, NULL),
('Sheraton Centre', 92, '2019-10-25', 238, NULL),
('Sheraton Centre', 92, '2019-10-26', 155, NULL),
('Sheraton Centre', 92, '2019-10-27', 221, NULL),
('Sheraton Centre', 92, '2019-10-28', 174, NULL),
('Sheraton Centre', 92, '2019-10-29', 102, NULL),
('Sheraton Centre', 92, '2019-10-30', 383, NULL),
('Sheraton Centre', 92, '2019-10-31', 234, NULL),
('Sheraton Centre', 92, '2019-11-01', 360, NULL),
('Sheraton Centre', 92, '2019-11-02', 120, NULL),
('Sheraton Centre', 92, '2019-11-03', 159, NULL),
('Sheraton Centre', 92, '2019-11-04', 292, NULL),
('Sheraton Centre', 92, '2019-11-05', 398, NULL),
('Sheraton Centre', 92, '2019-11-06', 360, NULL),
('Sheraton Centre', 92, '2019-11-07', 330, NULL),
('Sheraton Centre', 92, '2019-11-08', 303, NULL),
('Sheraton Centre', 92, '2019-11-09', 113, NULL),
('Sheraton Centre', 92, '2019-11-10', 231, NULL),
('Sheraton Centre', 92, '2019-11-11', 155, NULL),
('Sheraton Centre', 92, '2019-11-12', 130, NULL),
('Sheraton Centre', 92, '2019-11-13', 139, NULL),
('Sheraton Centre', 92, '2019-11-14', 186, NULL),
('Sheraton Centre', 92, '2019-11-15', 313, NULL),
('Sheraton Centre', 92, '2019-11-16', 206, NULL),
('Sheraton Centre', 92, '2019-11-17', 176, NULL),
('Sheraton Centre', 92, '2019-11-18', 178, NULL),
('Sheraton Centre', 92, '2019-11-19', 250, NULL),
('Sheraton Centre', 92, '2019-11-20', 200, NULL),
('Sheraton Centre', 92, '2019-11-21', 304, NULL),
('Sheraton Centre', 92, '2019-11-22', 347, NULL),
('Sheraton Centre', 92, '2019-11-23', 320, NULL),
('Sheraton Centre', 92, '2019-11-24', 270, NULL),
('Sheraton Centre', 92, '2019-11-25', 238, NULL),
('Sheraton Centre', 92, '2019-11-26', 257, NULL),
('Sheraton Centre', 92, '2019-11-27', 343, NULL),
('Sheraton Centre', 92, '2019-11-28', 393, NULL),
('Sheraton Centre', 92, '2019-11-29', 366, NULL),
('Sheraton Centre', 92, '2019-11-30', 102, NULL),
('Sheraton Centre', 92, '2019-12-01', 332, NULL),
('Sheraton Centre', 92, '2019-12-02', 364, NULL),
('Sheraton Centre', 92, '2019-12-03', 365, NULL),
('Sheraton Centre', 92, '2019-12-04', 213, NULL),
('Sheraton Centre', 92, '2019-12-05', 386, NULL),
('Sheraton Centre', 92, '2019-12-06', 372, NULL),
('Sheraton Centre', 92, '2019-12-07', 165, NULL),
('Sheraton Centre', 92, '2019-12-08', 331, NULL),
('Sheraton Centre', 92, '2019-12-09', 172, NULL),
('Sheraton Centre', 92, '2019-12-10', 244, NULL),
('Sheraton Centre', 92, '2019-12-11', 178, NULL),
('Sheraton Centre', 92, '2019-12-12', 183, NULL),
('Sheraton Centre', 92, '2019-12-13', 370, NULL),
('Sheraton Centre', 92, '2019-12-14', 267, NULL),
('Sheraton Centre', 92, '2019-12-15', 117, NULL),
('Sheraton Centre', 92, '2019-12-16', 362, NULL),
('Sheraton Centre', 92, '2019-12-17', 295, NULL),
('Sheraton Centre', 92, '2019-12-18', 286, NULL),
('Sheraton Centre', 92, '2019-12-19', 114, NULL),
('Sheraton Centre', 92, '2019-12-20', 311, NULL),
('Sheraton Centre', 92, '2019-12-21', 218, NULL),
('Sheraton Centre', 92, '2019-12-22', 240, NULL),
('Sheraton Centre', 92, '2019-12-23', 252, NULL),
('Sheraton Centre', 92, '2019-12-24', 268, NULL),
('Sheraton Centre', 92, '2019-12-25', 171, NULL),
('Sheraton Centre', 92, '2019-12-26', 288, NULL),
('Sheraton Centre', 92, '2019-12-27', 256, NULL),
('Sheraton Centre', 92, '2019-12-28', 106, NULL),
('Sheraton Centre', 92, '2019-12-29', 220, NULL),
('Sheraton Centre', 92, '2019-12-30', 297, NULL),
('Sheraton Centre', 92, '2019-12-31', 219, NULL),
('Sheraton Centre', 92, '2020-01-01', 352, NULL),
('Sheraton Centre', 92, '2020-01-02', 388, NULL),
('Sheraton Centre', 92, '2020-01-03', 292, NULL),
('Sheraton Centre', 92, '2020-01-04', 154, NULL),
('Sheraton Centre', 92, '2020-01-05', 225, NULL),
('Sheraton Centre', 92, '2020-01-06', 110, NULL),
('Sheraton Centre', 92, '2020-01-07', 105, NULL),
('Sheraton Centre', 92, '2020-01-08', 233, NULL),
('Sheraton Centre', 92, '2020-01-09', 264, NULL),
('Sheraton Centre', 92, '2020-01-10', 293, NULL),
('Sheraton Centre', 92, '2020-01-11', 129, NULL),
('Sheraton Centre', 92, '2020-01-12', 321, NULL),
('Sheraton Centre', 92, '2020-01-13', 374, NULL),
('Sheraton Centre', 92, '2020-01-14', 265, NULL),
('Sheraton Centre', 92, '2020-01-15', 171, NULL),
('Sheraton Centre', 92, '2020-01-16', 239, NULL),
('Sheraton Centre', 92, '2020-01-17', 298, NULL),
('Sheraton Centre', 92, '2020-01-18', 192, NULL),
('Sheraton Centre', 92, '2020-01-19', 137, NULL),
('Sheraton Centre', 92, '2020-01-20', 211, NULL),
('Sheraton Centre', 92, '2020-01-21', 309, NULL),
('Sheraton Centre', 92, '2020-01-22', 356, NULL),
('Sheraton Centre', 92, '2020-01-23', 219, NULL),
('Sheraton Centre', 92, '2020-01-24', 224, NULL),
('Sheraton Centre', 92, '2020-01-25', 329, NULL),
('Sheraton Centre', 92, '2020-01-26', 248, NULL),
('Sheraton Centre', 92, '2020-01-27', 255, NULL),
('Sheraton Centre', 92, '2020-01-28', 358, NULL),
('Sheraton Centre', 92, '2020-01-29', 221, NULL),
('Sheraton Centre', 92, '2020-01-30', 111, NULL),
('Sheraton Centre', 92, '2020-01-31', 183, NULL),
('Sheraton Centre', 92, '2020-02-01', 128, NULL),
('Sheraton Centre', 92, '2020-02-02', 287, NULL),
('Sheraton Centre', 92, '2020-02-03', 141, NULL),
('Sheraton Centre', 92, '2020-02-04', 280, NULL),
('Sheraton Centre', 93, '2019-01-01', 205, NULL),
('Sheraton Centre', 93, '2019-01-02', 301, NULL),
('Sheraton Centre', 93, '2019-01-03', 174, NULL),
('Sheraton Centre', 93, '2019-01-04', 218, NULL),
('Sheraton Centre', 93, '2019-01-05', 273, NULL),
('Sheraton Centre', 93, '2019-01-06', 204, NULL),
('Sheraton Centre', 93, '2019-01-07', 157, NULL),
('Sheraton Centre', 93, '2019-01-08', 276, NULL),
('Sheraton Centre', 93, '2019-01-09', 232, NULL),
('Sheraton Centre', 93, '2019-01-10', 374, NULL),
('Sheraton Centre', 93, '2019-01-11', 111, NULL),
('Sheraton Centre', 93, '2019-01-12', 139, NULL),
('Sheraton Centre', 93, '2019-01-13', 258, NULL),
('Sheraton Centre', 93, '2019-01-14', 380, NULL),
('Sheraton Centre', 93, '2019-01-15', 171, NULL),
('Sheraton Centre', 93, '2019-01-16', 147, NULL),
('Sheraton Centre', 93, '2019-01-17', 184, NULL),
('Sheraton Centre', 93, '2019-01-18', 306, NULL),
('Sheraton Centre', 93, '2019-01-19', 317, NULL),
('Sheraton Centre', 93, '2019-01-20', 227, NULL),
('Sheraton Centre', 93, '2019-01-21', 241, NULL),
('Sheraton Centre', 93, '2019-01-22', 157, NULL),
('Sheraton Centre', 93, '2019-01-23', 345, NULL),
('Sheraton Centre', 93, '2019-01-24', 396, NULL),
('Sheraton Centre', 93, '2019-01-25', 168, NULL),
('Sheraton Centre', 93, '2019-01-26', 146, NULL),
('Sheraton Centre', 93, '2019-01-27', 278, NULL),
('Sheraton Centre', 93, '2019-01-28', 164, NULL),
('Sheraton Centre', 93, '2019-01-29', 357, NULL),
('Sheraton Centre', 93, '2019-01-30', 250, NULL),
('Sheraton Centre', 93, '2019-01-31', 174, NULL),
('Sheraton Centre', 93, '2019-02-01', 349, NULL),
('Sheraton Centre', 93, '2019-02-02', 236, NULL),
('Sheraton Centre', 93, '2019-02-03', 153, NULL),
('Sheraton Centre', 93, '2019-02-04', 189, NULL),
('Sheraton Centre', 93, '2019-02-05', 181, NULL),
('Sheraton Centre', 93, '2019-02-06', 229, NULL),
('Sheraton Centre', 93, '2019-02-07', 366, NULL),
('Sheraton Centre', 93, '2019-02-08', 334, NULL),
('Sheraton Centre', 93, '2019-02-09', 165, NULL),
('Sheraton Centre', 93, '2019-02-10', 293, NULL),
('Sheraton Centre', 93, '2019-02-11', 380, NULL),
('Sheraton Centre', 93, '2019-02-12', 253, NULL),
('Sheraton Centre', 93, '2019-02-13', 398, NULL),
('Sheraton Centre', 93, '2019-02-14', 143, NULL),
('Sheraton Centre', 93, '2019-02-15', 157, NULL),
('Sheraton Centre', 93, '2019-02-16', 365, NULL),
('Sheraton Centre', 93, '2019-02-17', 100, NULL),
('Sheraton Centre', 93, '2019-02-18', 334, NULL),
('Sheraton Centre', 93, '2019-02-19', 123, NULL),
('Sheraton Centre', 93, '2019-02-20', 157, NULL),
('Sheraton Centre', 93, '2019-02-21', 368, NULL),
('Sheraton Centre', 93, '2019-02-22', 287, NULL),
('Sheraton Centre', 93, '2019-02-23', 202, NULL),
('Sheraton Centre', 93, '2019-02-24', 106, NULL),
('Sheraton Centre', 93, '2019-02-25', 203, NULL),
('Sheraton Centre', 93, '2019-02-26', 328, NULL),
('Sheraton Centre', 93, '2019-02-27', 364, NULL),
('Sheraton Centre', 93, '2019-02-28', 398, NULL),
('Sheraton Centre', 93, '2019-03-01', 396, NULL),
('Sheraton Centre', 93, '2019-03-02', 116, NULL),
('Sheraton Centre', 93, '2019-03-03', 236, NULL),
('Sheraton Centre', 93, '2019-03-04', 142, NULL),
('Sheraton Centre', 93, '2019-03-05', 180, NULL),
('Sheraton Centre', 93, '2019-03-06', 165, NULL),
('Sheraton Centre', 93, '2019-03-07', 220, NULL),
('Sheraton Centre', 93, '2019-03-08', 237, NULL),
('Sheraton Centre', 93, '2019-03-09', 207, NULL),
('Sheraton Centre', 93, '2019-03-10', 171, NULL),
('Sheraton Centre', 93, '2019-03-11', 152, NULL),
('Sheraton Centre', 93, '2019-03-12', 240, NULL),
('Sheraton Centre', 93, '2019-03-13', 251, NULL),
('Sheraton Centre', 93, '2019-03-14', 372, NULL),
('Sheraton Centre', 93, '2019-03-15', 221, NULL),
('Sheraton Centre', 93, '2019-03-16', 204, NULL),
('Sheraton Centre', 93, '2019-03-17', 393, NULL),
('Sheraton Centre', 93, '2019-03-18', 293, NULL),
('Sheraton Centre', 93, '2019-03-19', 304, NULL),
('Sheraton Centre', 93, '2019-03-20', 219, NULL),
('Sheraton Centre', 93, '2019-03-21', 317, NULL),
('Sheraton Centre', 93, '2019-03-22', 321, NULL),
('Sheraton Centre', 93, '2019-03-23', 399, NULL),
('Sheraton Centre', 93, '2019-03-24', 238, NULL),
('Sheraton Centre', 93, '2019-03-25', 395, NULL),
('Sheraton Centre', 93, '2019-03-26', 209, NULL),
('Sheraton Centre', 93, '2019-03-27', 132, NULL),
('Sheraton Centre', 93, '2019-03-28', 164, NULL),
('Sheraton Centre', 93, '2019-03-29', 170, NULL),
('Sheraton Centre', 93, '2019-03-30', 103, NULL),
('Sheraton Centre', 93, '2019-03-31', 155, NULL),
('Sheraton Centre', 93, '2019-04-01', 394, NULL),
('Sheraton Centre', 93, '2019-04-02', 198, NULL),
('Sheraton Centre', 93, '2019-04-03', 271, NULL),
('Sheraton Centre', 93, '2019-04-04', 371, NULL),
('Sheraton Centre', 93, '2019-04-05', 345, NULL),
('Sheraton Centre', 93, '2019-04-06', 387, NULL),
('Sheraton Centre', 93, '2019-04-07', 111, NULL),
('Sheraton Centre', 93, '2019-04-08', 242, NULL),
('Sheraton Centre', 93, '2019-04-09', 156, NULL),
('Sheraton Centre', 93, '2019-04-10', 380, NULL),
('Sheraton Centre', 93, '2019-04-11', 148, NULL),
('Sheraton Centre', 93, '2019-04-12', 103, NULL),
('Sheraton Centre', 93, '2019-04-13', 140, NULL),
('Sheraton Centre', 93, '2019-04-14', 146, NULL),
('Sheraton Centre', 93, '2019-04-15', 191, NULL),
('Sheraton Centre', 93, '2019-04-16', 245, NULL),
('Sheraton Centre', 93, '2019-04-17', 154, NULL),
('Sheraton Centre', 93, '2019-04-18', 370, NULL),
('Sheraton Centre', 93, '2019-04-19', 384, NULL),
('Sheraton Centre', 93, '2019-04-20', 388, NULL),
('Sheraton Centre', 93, '2019-04-21', 352, NULL),
('Sheraton Centre', 93, '2019-04-22', 273, NULL),
('Sheraton Centre', 93, '2019-04-23', 340, NULL),
('Sheraton Centre', 93, '2019-04-24', 357, NULL),
('Sheraton Centre', 93, '2019-04-25', 261, NULL),
('Sheraton Centre', 93, '2019-04-26', 114, NULL),
('Sheraton Centre', 93, '2019-04-27', 277, NULL),
('Sheraton Centre', 93, '2019-04-28', 142, NULL),
('Sheraton Centre', 93, '2019-04-29', 266, NULL),
('Sheraton Centre', 93, '2019-04-30', 148, NULL),
('Sheraton Centre', 93, '2019-05-01', 349, NULL),
('Sheraton Centre', 93, '2019-05-02', 374, NULL),
('Sheraton Centre', 93, '2019-05-03', 201, NULL),
('Sheraton Centre', 93, '2019-05-04', 257, NULL),
('Sheraton Centre', 93, '2019-05-05', 394, NULL),
('Sheraton Centre', 93, '2019-05-06', 239, NULL),
('Sheraton Centre', 93, '2019-05-07', 316, NULL),
('Sheraton Centre', 93, '2019-05-08', 130, NULL),
('Sheraton Centre', 93, '2019-05-09', 395, NULL),
('Sheraton Centre', 93, '2019-05-10', 273, NULL),
('Sheraton Centre', 93, '2019-05-11', 113, NULL),
('Sheraton Centre', 93, '2019-05-12', 312, NULL),
('Sheraton Centre', 93, '2019-05-13', 160, NULL),
('Sheraton Centre', 93, '2019-05-14', 231, NULL),
('Sheraton Centre', 93, '2019-05-15', 249, NULL),
('Sheraton Centre', 93, '2019-05-16', 247, NULL),
('Sheraton Centre', 93, '2019-05-17', 186, NULL),
('Sheraton Centre', 93, '2019-05-18', 300, NULL),
('Sheraton Centre', 93, '2019-05-19', 343, NULL),
('Sheraton Centre', 93, '2019-05-20', 341, NULL),
('Sheraton Centre', 93, '2019-05-21', 288, NULL),
('Sheraton Centre', 93, '2019-05-22', 280, NULL),
('Sheraton Centre', 93, '2019-05-23', 249, NULL),
('Sheraton Centre', 93, '2019-05-24', 102, NULL),
('Sheraton Centre', 93, '2019-05-25', 279, NULL),
('Sheraton Centre', 93, '2019-05-26', 362, NULL),
('Sheraton Centre', 93, '2019-05-27', 199, NULL),
('Sheraton Centre', 93, '2019-05-28', 196, NULL),
('Sheraton Centre', 93, '2019-05-29', 166, NULL),
('Sheraton Centre', 93, '2019-05-30', 265, NULL),
('Sheraton Centre', 93, '2019-05-31', 249, NULL),
('Sheraton Centre', 93, '2019-06-01', 116, NULL),
('Sheraton Centre', 93, '2019-06-02', 214, NULL),
('Sheraton Centre', 93, '2019-06-03', 250, NULL),
('Sheraton Centre', 93, '2019-06-04', 261, NULL),
('Sheraton Centre', 93, '2019-06-05', 172, NULL),
('Sheraton Centre', 93, '2019-06-06', 379, NULL),
('Sheraton Centre', 93, '2019-06-07', 269, NULL),
('Sheraton Centre', 93, '2019-06-08', 166, NULL),
('Sheraton Centre', 93, '2019-06-09', 232, NULL),
('Sheraton Centre', 93, '2019-06-10', 238, NULL),
('Sheraton Centre', 93, '2019-06-11', 285, NULL),
('Sheraton Centre', 93, '2019-06-12', 358, NULL),
('Sheraton Centre', 93, '2019-06-13', 221, NULL),
('Sheraton Centre', 93, '2019-06-14', 218, NULL),
('Sheraton Centre', 93, '2019-06-15', 336, NULL),
('Sheraton Centre', 93, '2019-06-16', 352, NULL),
('Sheraton Centre', 93, '2019-06-17', 332, NULL),
('Sheraton Centre', 93, '2019-06-18', 182, NULL),
('Sheraton Centre', 93, '2019-06-19', 175, NULL),
('Sheraton Centre', 93, '2019-06-20', 161, NULL),
('Sheraton Centre', 93, '2019-06-21', 150, NULL),
('Sheraton Centre', 93, '2019-06-22', 108, NULL),
('Sheraton Centre', 93, '2019-06-23', 393, NULL),
('Sheraton Centre', 93, '2019-06-24', 189, NULL),
('Sheraton Centre', 93, '2019-06-25', 284, NULL),
('Sheraton Centre', 93, '2019-06-26', 116, NULL),
('Sheraton Centre', 93, '2019-06-27', 263, NULL),
('Sheraton Centre', 93, '2019-06-28', 340, NULL),
('Sheraton Centre', 93, '2019-06-29', 209, NULL),
('Sheraton Centre', 93, '2019-06-30', 322, NULL),
('Sheraton Centre', 93, '2019-07-01', 312, NULL),
('Sheraton Centre', 93, '2019-07-02', 206, NULL),
('Sheraton Centre', 93, '2019-07-03', 302, NULL),
('Sheraton Centre', 93, '2019-07-04', 307, NULL),
('Sheraton Centre', 93, '2019-07-05', 243, NULL),
('Sheraton Centre', 93, '2019-07-06', 189, NULL),
('Sheraton Centre', 93, '2019-07-07', 241, NULL),
('Sheraton Centre', 93, '2019-07-08', 307, NULL),
('Sheraton Centre', 93, '2019-07-09', 182, NULL),
('Sheraton Centre', 93, '2019-07-10', 173, NULL),
('Sheraton Centre', 93, '2019-07-11', 324, NULL),
('Sheraton Centre', 93, '2019-07-12', 235, NULL),
('Sheraton Centre', 93, '2019-07-13', 276, NULL),
('Sheraton Centre', 93, '2019-07-14', 396, NULL),
('Sheraton Centre', 93, '2019-07-15', 304, NULL),
('Sheraton Centre', 93, '2019-07-16', 255, NULL),
('Sheraton Centre', 93, '2019-07-17', 324, NULL),
('Sheraton Centre', 93, '2019-07-18', 236, NULL),
('Sheraton Centre', 93, '2019-07-19', 154, NULL),
('Sheraton Centre', 93, '2019-07-20', 269, NULL),
('Sheraton Centre', 93, '2019-07-21', 361, NULL),
('Sheraton Centre', 93, '2019-07-22', 223, NULL),
('Sheraton Centre', 93, '2019-07-23', 133, NULL),
('Sheraton Centre', 93, '2019-07-24', 129, NULL),
('Sheraton Centre', 93, '2019-07-25', 262, NULL),
('Sheraton Centre', 93, '2019-07-26', 398, NULL),
('Sheraton Centre', 93, '2019-07-27', 195, NULL),
('Sheraton Centre', 93, '2019-07-28', 271, NULL),
('Sheraton Centre', 93, '2019-07-29', 100, NULL),
('Sheraton Centre', 93, '2019-07-30', 193, NULL),
('Sheraton Centre', 93, '2019-07-31', 138, NULL),
('Sheraton Centre', 93, '2019-08-01', 190, NULL),
('Sheraton Centre', 93, '2019-08-02', 281, NULL),
('Sheraton Centre', 93, '2019-08-03', 206, NULL),
('Sheraton Centre', 93, '2019-08-04', 106, NULL),
('Sheraton Centre', 93, '2019-08-05', 250, NULL),
('Sheraton Centre', 93, '2019-08-06', 340, NULL),
('Sheraton Centre', 93, '2019-08-07', 144, NULL),
('Sheraton Centre', 93, '2019-08-08', 265, NULL),
('Sheraton Centre', 93, '2019-08-09', 249, NULL),
('Sheraton Centre', 93, '2019-08-10', 323, NULL),
('Sheraton Centre', 93, '2019-08-11', 149, NULL),
('Sheraton Centre', 93, '2019-08-12', 185, NULL),
('Sheraton Centre', 93, '2019-08-13', 236, NULL),
('Sheraton Centre', 93, '2019-08-14', 200, NULL),
('Sheraton Centre', 93, '2019-08-15', 233, NULL),
('Sheraton Centre', 93, '2019-08-16', 240, NULL),
('Sheraton Centre', 93, '2019-08-17', 390, NULL),
('Sheraton Centre', 93, '2019-08-18', 185, NULL),
('Sheraton Centre', 93, '2019-08-19', 197, NULL),
('Sheraton Centre', 93, '2019-08-20', 354, NULL),
('Sheraton Centre', 93, '2019-08-21', 396, NULL),
('Sheraton Centre', 93, '2019-08-22', 376, NULL),
('Sheraton Centre', 93, '2019-08-23', 218, NULL),
('Sheraton Centre', 93, '2019-08-24', 362, NULL),
('Sheraton Centre', 93, '2019-08-25', 226, NULL),
('Sheraton Centre', 93, '2019-08-26', 283, NULL),
('Sheraton Centre', 93, '2019-08-27', 177, NULL),
('Sheraton Centre', 93, '2019-08-28', 171, NULL),
('Sheraton Centre', 93, '2019-08-29', 206, NULL),
('Sheraton Centre', 93, '2019-08-30', 142, NULL),
('Sheraton Centre', 93, '2019-08-31', 129, NULL),
('Sheraton Centre', 93, '2019-09-01', 358, NULL),
('Sheraton Centre', 93, '2019-09-02', 383, NULL),
('Sheraton Centre', 93, '2019-09-03', 139, NULL),
('Sheraton Centre', 93, '2019-09-04', 117, NULL),
('Sheraton Centre', 93, '2019-09-05', 223, NULL),
('Sheraton Centre', 93, '2019-09-06', 198, NULL),
('Sheraton Centre', 93, '2019-09-07', 271, NULL),
('Sheraton Centre', 93, '2019-09-08', 158, NULL),
('Sheraton Centre', 93, '2019-09-09', 252, NULL),
('Sheraton Centre', 93, '2019-09-10', 134, NULL),
('Sheraton Centre', 93, '2019-09-11', 228, NULL),
('Sheraton Centre', 93, '2019-09-12', 333, NULL),
('Sheraton Centre', 93, '2019-09-13', 153, NULL),
('Sheraton Centre', 93, '2019-09-14', 285, NULL),
('Sheraton Centre', 93, '2019-09-15', 205, NULL),
('Sheraton Centre', 93, '2019-09-16', 119, NULL),
('Sheraton Centre', 93, '2019-09-17', 322, NULL),
('Sheraton Centre', 93, '2019-09-18', 271, NULL),
('Sheraton Centre', 93, '2019-09-19', 338, NULL),
('Sheraton Centre', 93, '2019-09-20', 106, NULL),
('Sheraton Centre', 93, '2019-09-21', 373, NULL),
('Sheraton Centre', 93, '2019-09-22', 380, NULL),
('Sheraton Centre', 93, '2019-09-23', 353, NULL),
('Sheraton Centre', 93, '2019-09-24', 332, NULL),
('Sheraton Centre', 93, '2019-09-25', 320, NULL),
('Sheraton Centre', 93, '2019-09-26', 331, NULL),
('Sheraton Centre', 93, '2019-09-27', 131, NULL),
('Sheraton Centre', 93, '2019-09-28', 231, NULL),
('Sheraton Centre', 93, '2019-09-29', 128, NULL),
('Sheraton Centre', 93, '2019-09-30', 297, NULL),
('Sheraton Centre', 93, '2019-10-01', 369, NULL),
('Sheraton Centre', 93, '2019-10-02', 280, NULL),
('Sheraton Centre', 93, '2019-10-03', 245, NULL),
('Sheraton Centre', 93, '2019-10-04', 378, NULL),
('Sheraton Centre', 93, '2019-10-05', 220, NULL),
('Sheraton Centre', 93, '2019-10-06', 199, NULL),
('Sheraton Centre', 93, '2019-10-07', 398, NULL),
('Sheraton Centre', 93, '2019-10-08', 222, NULL),
('Sheraton Centre', 93, '2019-10-09', 207, NULL),
('Sheraton Centre', 93, '2019-10-10', 172, NULL),
('Sheraton Centre', 93, '2019-10-11', 379, NULL),
('Sheraton Centre', 93, '2019-10-12', 149, NULL),
('Sheraton Centre', 93, '2019-10-13', 191, NULL),
('Sheraton Centre', 93, '2019-10-14', 180, NULL),
('Sheraton Centre', 93, '2019-10-15', 333, NULL),
('Sheraton Centre', 93, '2019-10-16', 392, NULL),
('Sheraton Centre', 93, '2019-10-17', 360, NULL),
('Sheraton Centre', 93, '2019-10-18', 162, NULL),
('Sheraton Centre', 93, '2019-10-19', 262, NULL),
('Sheraton Centre', 93, '2019-10-20', 144, NULL),
('Sheraton Centre', 93, '2019-10-21', 215, NULL),
('Sheraton Centre', 93, '2019-10-22', 204, NULL),
('Sheraton Centre', 93, '2019-10-23', 187, NULL),
('Sheraton Centre', 93, '2019-10-24', 161, NULL),
('Sheraton Centre', 93, '2019-10-25', 343, NULL),
('Sheraton Centre', 93, '2019-10-26', 116, NULL),
('Sheraton Centre', 93, '2019-10-27', 229, NULL),
('Sheraton Centre', 93, '2019-10-28', 174, NULL),
('Sheraton Centre', 93, '2019-10-29', 262, NULL),
('Sheraton Centre', 93, '2019-10-30', 349, NULL),
('Sheraton Centre', 93, '2019-10-31', 163, NULL),
('Sheraton Centre', 93, '2019-11-01', 337, NULL),
('Sheraton Centre', 93, '2019-11-02', 181, NULL),
('Sheraton Centre', 93, '2019-11-03', 173, NULL),
('Sheraton Centre', 93, '2019-11-04', 295, NULL),
('Sheraton Centre', 93, '2019-11-05', 261, NULL),
('Sheraton Centre', 93, '2019-11-06', 234, NULL),
('Sheraton Centre', 93, '2019-11-07', 141, NULL),
('Sheraton Centre', 93, '2019-11-08', 208, NULL),
('Sheraton Centre', 93, '2019-11-09', 192, NULL),
('Sheraton Centre', 93, '2019-11-10', 338, NULL),
('Sheraton Centre', 93, '2019-11-11', 192, NULL),
('Sheraton Centre', 93, '2019-11-12', 391, NULL),
('Sheraton Centre', 93, '2019-11-13', 256, NULL),
('Sheraton Centre', 93, '2019-11-14', 301, NULL),
('Sheraton Centre', 93, '2019-11-15', 326, NULL),
('Sheraton Centre', 93, '2019-11-16', 373, NULL),
('Sheraton Centre', 93, '2019-11-17', 281, NULL),
('Sheraton Centre', 93, '2019-11-18', 193, NULL),
('Sheraton Centre', 93, '2019-11-19', 210, NULL),
('Sheraton Centre', 93, '2019-11-20', 267, NULL),
('Sheraton Centre', 93, '2019-11-21', 353, NULL),
('Sheraton Centre', 93, '2019-11-22', 188, NULL),
('Sheraton Centre', 93, '2019-11-23', 125, NULL),
('Sheraton Centre', 93, '2019-11-24', 320, NULL),
('Sheraton Centre', 93, '2019-11-25', 353, NULL),
('Sheraton Centre', 93, '2019-11-26', 308, NULL),
('Sheraton Centre', 93, '2019-11-27', 363, NULL),
('Sheraton Centre', 93, '2019-11-28', 108, NULL),
('Sheraton Centre', 93, '2019-11-29', 137, NULL),
('Sheraton Centre', 93, '2019-11-30', 168, NULL),
('Sheraton Centre', 93, '2019-12-01', 322, NULL),
('Sheraton Centre', 93, '2019-12-02', 223, NULL),
('Sheraton Centre', 93, '2019-12-03', 183, NULL),
('Sheraton Centre', 93, '2019-12-04', 114, NULL),
('Sheraton Centre', 93, '2019-12-05', 369, NULL),
('Sheraton Centre', 93, '2019-12-06', 128, NULL),
('Sheraton Centre', 93, '2019-12-07', 397, NULL),
('Sheraton Centre', 93, '2019-12-08', 342, NULL),
('Sheraton Centre', 93, '2019-12-09', 169, NULL),
('Sheraton Centre', 93, '2019-12-10', 193, NULL),
('Sheraton Centre', 93, '2019-12-11', 192, NULL),
('Sheraton Centre', 93, '2019-12-12', 395, NULL),
('Sheraton Centre', 93, '2019-12-13', 335, NULL),
('Sheraton Centre', 93, '2019-12-14', 390, NULL),
('Sheraton Centre', 93, '2019-12-15', 152, NULL),
('Sheraton Centre', 93, '2019-12-16', 114, NULL),
('Sheraton Centre', 93, '2019-12-17', 203, NULL),
('Sheraton Centre', 93, '2019-12-18', 145, NULL),
('Sheraton Centre', 93, '2019-12-19', 306, NULL),
('Sheraton Centre', 93, '2019-12-20', 266, NULL),
('Sheraton Centre', 93, '2019-12-21', 314, NULL),
('Sheraton Centre', 93, '2019-12-22', 385, NULL),
('Sheraton Centre', 93, '2019-12-23', 304, NULL),
('Sheraton Centre', 93, '2019-12-24', 138, NULL),
('Sheraton Centre', 93, '2019-12-25', 177, NULL),
('Sheraton Centre', 93, '2019-12-26', 320, NULL),
('Sheraton Centre', 93, '2019-12-27', 348, NULL),
('Sheraton Centre', 93, '2019-12-28', 295, NULL),
('Sheraton Centre', 93, '2019-12-29', 324, NULL),
('Sheraton Centre', 93, '2019-12-30', 386, NULL),
('Sheraton Centre', 93, '2019-12-31', 147, NULL),
('Sheraton Centre', 93, '2020-01-01', 343, NULL),
('Sheraton Centre', 93, '2020-01-02', 303, NULL),
('Sheraton Centre', 93, '2020-01-03', 126, NULL),
('Sheraton Centre', 93, '2020-01-04', 333, NULL),
('Sheraton Centre', 93, '2020-01-05', 161, NULL),
('Sheraton Centre', 93, '2020-01-06', 256, NULL),
('Sheraton Centre', 93, '2020-01-07', 303, NULL),
('Sheraton Centre', 93, '2020-01-08', 394, NULL),
('Sheraton Centre', 93, '2020-01-09', 180, NULL),
('Sheraton Centre', 93, '2020-01-10', 392, NULL),
('Sheraton Centre', 93, '2020-01-11', 234, NULL),
('Sheraton Centre', 93, '2020-01-12', 365, NULL),
('Sheraton Centre', 93, '2020-01-13', 129, NULL),
('Sheraton Centre', 93, '2020-01-14', 112, NULL),
('Sheraton Centre', 93, '2020-01-15', 364, NULL),
('Sheraton Centre', 93, '2020-01-16', 159, NULL),
('Sheraton Centre', 93, '2020-01-17', 345, NULL),
('Sheraton Centre', 93, '2020-01-18', 375, NULL),
('Sheraton Centre', 93, '2020-01-19', 166, NULL),
('Sheraton Centre', 93, '2020-01-20', 130, NULL),
('Sheraton Centre', 93, '2020-01-21', 255, NULL),
('Sheraton Centre', 93, '2020-01-22', 146, NULL),
('Sheraton Centre', 93, '2020-01-23', 203, NULL),
('Sheraton Centre', 93, '2020-01-24', 362, NULL),
('Sheraton Centre', 93, '2020-01-25', 199, NULL),
('Sheraton Centre', 93, '2020-01-26', 164, NULL),
('Sheraton Centre', 93, '2020-01-27', 142, NULL),
('Sheraton Centre', 93, '2020-01-28', 289, NULL),
('Sheraton Centre', 93, '2020-01-29', 395, NULL),
('Sheraton Centre', 93, '2020-01-30', 324, NULL),
('Sheraton Centre', 93, '2020-01-31', 216, NULL),
('Sheraton Centre', 93, '2020-02-01', 254, NULL),
('Sheraton Centre', 93, '2020-02-02', 102, NULL),
('Sheraton Centre', 93, '2020-02-03', 300, NULL),
('Sheraton Centre', 93, '2020-02-04', 221, NULL),
('Sheraton Centre', 163, '2019-01-01', 194, NULL),
('Sheraton Centre', 163, '2019-01-02', 320, NULL),
('Sheraton Centre', 163, '2019-01-03', 350, NULL),
('Sheraton Centre', 163, '2019-01-04', 140, NULL),
('Sheraton Centre', 163, '2019-01-05', 377, NULL),
('Sheraton Centre', 163, '2019-01-06', 311, NULL),
('Sheraton Centre', 163, '2019-01-07', 162, NULL),
('Sheraton Centre', 163, '2019-01-08', 242, NULL),
('Sheraton Centre', 163, '2019-01-09', 299, NULL),
('Sheraton Centre', 163, '2019-01-10', 300, NULL),
('Sheraton Centre', 163, '2019-01-11', 270, NULL),
('Sheraton Centre', 163, '2019-01-12', 159, NULL),
('Sheraton Centre', 163, '2019-01-13', 233, NULL),
('Sheraton Centre', 163, '2019-01-14', 123, NULL),
('Sheraton Centre', 163, '2019-01-15', 330, NULL),
('Sheraton Centre', 163, '2019-01-16', 127, NULL),
('Sheraton Centre', 163, '2019-01-17', 104, NULL),
('Sheraton Centre', 163, '2019-01-18', 157, NULL),
('Sheraton Centre', 163, '2019-01-19', 145, NULL),
('Sheraton Centre', 163, '2019-01-20', 218, NULL),
('Sheraton Centre', 163, '2019-01-21', 189, NULL),
('Sheraton Centre', 163, '2019-01-22', 271, NULL),
('Sheraton Centre', 163, '2019-01-23', 130, NULL),
('Sheraton Centre', 163, '2019-01-24', 250, NULL),
('Sheraton Centre', 163, '2019-01-25', 380, NULL),
('Sheraton Centre', 163, '2019-01-26', 134, NULL),
('Sheraton Centre', 163, '2019-01-27', 100, NULL),
('Sheraton Centre', 163, '2019-01-28', 207, NULL),
('Sheraton Centre', 163, '2019-01-29', 248, NULL),
('Sheraton Centre', 163, '2019-01-30', 349, NULL),
('Sheraton Centre', 163, '2019-01-31', 106, NULL),
('Sheraton Centre', 163, '2019-02-01', 345, NULL),
('Sheraton Centre', 163, '2019-02-02', 245, NULL),
('Sheraton Centre', 163, '2019-02-03', 123, NULL),
('Sheraton Centre', 163, '2019-02-04', 339, NULL),
('Sheraton Centre', 163, '2019-02-05', 386, NULL),
('Sheraton Centre', 163, '2019-02-06', 197, NULL),
('Sheraton Centre', 163, '2019-02-07', 208, NULL),
('Sheraton Centre', 163, '2019-02-08', 192, NULL),
('Sheraton Centre', 163, '2019-02-09', 329, NULL),
('Sheraton Centre', 163, '2019-02-10', 278, NULL),
('Sheraton Centre', 163, '2019-02-11', 189, NULL),
('Sheraton Centre', 163, '2019-02-12', 353, NULL),
('Sheraton Centre', 163, '2019-02-13', 357, NULL),
('Sheraton Centre', 163, '2019-02-14', 371, NULL),
('Sheraton Centre', 163, '2019-02-15', 305, NULL),
('Sheraton Centre', 163, '2019-02-16', 261, NULL),
('Sheraton Centre', 163, '2019-02-17', 191, NULL),
('Sheraton Centre', 163, '2019-02-18', 131, NULL),
('Sheraton Centre', 163, '2019-02-19', 237, NULL),
('Sheraton Centre', 163, '2019-02-20', 397, NULL),
('Sheraton Centre', 163, '2019-02-21', 104, NULL),
('Sheraton Centre', 163, '2019-02-22', 217, NULL),
('Sheraton Centre', 163, '2019-02-23', 227, NULL),
('Sheraton Centre', 163, '2019-02-24', 168, NULL),
('Sheraton Centre', 163, '2019-02-25', 210, NULL),
('Sheraton Centre', 163, '2019-02-26', 278, NULL),
('Sheraton Centre', 163, '2019-02-27', 158, NULL),
('Sheraton Centre', 163, '2019-02-28', 270, NULL),
('Sheraton Centre', 163, '2019-03-01', 186, NULL),
('Sheraton Centre', 163, '2019-03-02', 259, NULL),
('Sheraton Centre', 163, '2019-03-03', 348, NULL),
('Sheraton Centre', 163, '2019-03-04', 136, NULL),
('Sheraton Centre', 163, '2019-03-05', 226, NULL),
('Sheraton Centre', 163, '2019-03-06', 287, NULL),
('Sheraton Centre', 163, '2019-03-07', 167, NULL),
('Sheraton Centre', 163, '2019-03-08', 389, NULL),
('Sheraton Centre', 163, '2019-03-09', 166, NULL),
('Sheraton Centre', 163, '2019-03-10', 343, NULL),
('Sheraton Centre', 163, '2019-03-11', 362, NULL),
('Sheraton Centre', 163, '2019-03-12', 101, NULL),
('Sheraton Centre', 163, '2019-03-13', 391, NULL),
('Sheraton Centre', 163, '2019-03-14', 182, NULL),
('Sheraton Centre', 163, '2019-03-15', 391, NULL),
('Sheraton Centre', 163, '2019-03-16', 377, NULL),
('Sheraton Centre', 163, '2019-03-17', 276, NULL),
('Sheraton Centre', 163, '2019-03-18', 362, NULL),
('Sheraton Centre', 163, '2019-03-19', 133, NULL),
('Sheraton Centre', 163, '2019-03-20', 273, NULL),
('Sheraton Centre', 163, '2019-03-21', 255, NULL),
('Sheraton Centre', 163, '2019-03-22', 379, NULL),
('Sheraton Centre', 163, '2019-03-23', 357, NULL),
('Sheraton Centre', 163, '2019-03-24', 165, NULL),
('Sheraton Centre', 163, '2019-03-25', 230, NULL),
('Sheraton Centre', 163, '2019-03-26', 395, NULL),
('Sheraton Centre', 163, '2019-03-27', 381, NULL),
('Sheraton Centre', 163, '2019-03-28', 368, NULL),
('Sheraton Centre', 163, '2019-03-29', 115, NULL),
('Sheraton Centre', 163, '2019-03-30', 232, NULL),
('Sheraton Centre', 163, '2019-03-31', 206, NULL),
('Sheraton Centre', 163, '2019-04-01', 258, NULL),
('Sheraton Centre', 163, '2019-04-02', 298, NULL),
('Sheraton Centre', 163, '2019-04-03', 120, NULL),
('Sheraton Centre', 163, '2019-04-04', 242, NULL),
('Sheraton Centre', 163, '2019-04-05', 326, NULL),
('Sheraton Centre', 163, '2019-04-06', 101, NULL),
('Sheraton Centre', 163, '2019-04-07', 162, NULL),
('Sheraton Centre', 163, '2019-04-08', 244, NULL),
('Sheraton Centre', 163, '2019-04-09', 192, NULL),
('Sheraton Centre', 163, '2019-04-10', 271, NULL),
('Sheraton Centre', 163, '2019-04-11', 377, NULL),
('Sheraton Centre', 163, '2019-04-12', 190, NULL),
('Sheraton Centre', 163, '2019-04-13', 371, NULL),
('Sheraton Centre', 163, '2019-04-14', 166, NULL),
('Sheraton Centre', 163, '2019-04-15', 367, NULL),
('Sheraton Centre', 163, '2019-04-16', 199, NULL),
('Sheraton Centre', 163, '2019-04-17', 259, NULL),
('Sheraton Centre', 163, '2019-04-18', 395, NULL),
('Sheraton Centre', 163, '2019-04-19', 296, NULL),
('Sheraton Centre', 163, '2019-04-20', 120, NULL),
('Sheraton Centre', 163, '2019-04-21', 320, NULL),
('Sheraton Centre', 163, '2019-04-22', 169, NULL),
('Sheraton Centre', 163, '2019-04-23', 117, NULL),
('Sheraton Centre', 163, '2019-04-24', 242, NULL),
('Sheraton Centre', 163, '2019-04-25', 198, NULL),
('Sheraton Centre', 163, '2019-04-26', 100, NULL),
('Sheraton Centre', 163, '2019-04-27', 360, NULL),
('Sheraton Centre', 163, '2019-04-28', 153, NULL),
('Sheraton Centre', 163, '2019-04-29', 235, NULL),
('Sheraton Centre', 163, '2019-04-30', 306, NULL),
('Sheraton Centre', 163, '2019-05-01', 235, NULL),
('Sheraton Centre', 163, '2019-05-02', 390, NULL),
('Sheraton Centre', 163, '2019-05-03', 246, NULL),
('Sheraton Centre', 163, '2019-05-04', 288, NULL),
('Sheraton Centre', 163, '2019-05-05', 267, NULL),
('Sheraton Centre', 163, '2019-05-06', 161, NULL),
('Sheraton Centre', 163, '2019-05-07', 242, NULL),
('Sheraton Centre', 163, '2019-05-08', 321, NULL),
('Sheraton Centre', 163, '2019-05-09', 129, NULL),
('Sheraton Centre', 163, '2019-05-10', 291, NULL),
('Sheraton Centre', 163, '2019-05-11', 262, NULL),
('Sheraton Centre', 163, '2019-05-12', 261, NULL),
('Sheraton Centre', 163, '2019-05-13', 113, NULL),
('Sheraton Centre', 163, '2019-05-14', 315, NULL),
('Sheraton Centre', 163, '2019-05-15', 195, NULL),
('Sheraton Centre', 163, '2019-05-16', 178, NULL),
('Sheraton Centre', 163, '2019-05-17', 150, NULL),
('Sheraton Centre', 163, '2019-05-18', 100, NULL),
('Sheraton Centre', 163, '2019-05-19', 122, NULL),
('Sheraton Centre', 163, '2019-05-20', 337, NULL),
('Sheraton Centre', 163, '2019-05-21', 142, NULL),
('Sheraton Centre', 163, '2019-05-22', 296, NULL),
('Sheraton Centre', 163, '2019-05-23', 134, NULL),
('Sheraton Centre', 163, '2019-05-24', 125, NULL),
('Sheraton Centre', 163, '2019-05-25', 272, NULL),
('Sheraton Centre', 163, '2019-05-26', 180, NULL),
('Sheraton Centre', 163, '2019-05-27', 211, NULL),
('Sheraton Centre', 163, '2019-05-28', 255, NULL),
('Sheraton Centre', 163, '2019-05-29', 229, NULL),
('Sheraton Centre', 163, '2019-05-30', 310, NULL),
('Sheraton Centre', 163, '2019-05-31', 279, NULL),
('Sheraton Centre', 163, '2019-06-01', 291, NULL),
('Sheraton Centre', 163, '2019-06-02', 387, NULL),
('Sheraton Centre', 163, '2019-06-03', 238, NULL),
('Sheraton Centre', 163, '2019-06-04', 307, NULL),
('Sheraton Centre', 163, '2019-06-05', 330, NULL),
('Sheraton Centre', 163, '2019-06-06', 267, NULL),
('Sheraton Centre', 163, '2019-06-07', 105, NULL),
('Sheraton Centre', 163, '2019-06-08', 121, NULL),
('Sheraton Centre', 163, '2019-06-09', 327, NULL),
('Sheraton Centre', 163, '2019-06-10', 379, NULL),
('Sheraton Centre', 163, '2019-06-11', 138, NULL),
('Sheraton Centre', 163, '2019-06-12', 303, NULL),
('Sheraton Centre', 163, '2019-06-13', 161, NULL),
('Sheraton Centre', 163, '2019-06-14', 356, NULL),
('Sheraton Centre', 163, '2019-06-15', 170, NULL),
('Sheraton Centre', 163, '2019-06-16', 225, NULL),
('Sheraton Centre', 163, '2019-06-17', 183, NULL),
('Sheraton Centre', 163, '2019-06-18', 116, NULL),
('Sheraton Centre', 163, '2019-06-19', 142, NULL),
('Sheraton Centre', 163, '2019-06-20', 327, NULL),
('Sheraton Centre', 163, '2019-06-21', 287, NULL),
('Sheraton Centre', 163, '2019-06-22', 115, NULL),
('Sheraton Centre', 163, '2019-06-23', 277, NULL),
('Sheraton Centre', 163, '2019-06-24', 188, NULL),
('Sheraton Centre', 163, '2019-06-25', 236, NULL),
('Sheraton Centre', 163, '2019-06-26', 107, NULL),
('Sheraton Centre', 163, '2019-06-27', 332, NULL),
('Sheraton Centre', 163, '2019-06-28', 376, NULL),
('Sheraton Centre', 163, '2019-06-29', 259, NULL),
('Sheraton Centre', 163, '2019-06-30', 156, NULL),
('Sheraton Centre', 163, '2019-07-01', 303, NULL),
('Sheraton Centre', 163, '2019-07-02', 211, NULL),
('Sheraton Centre', 163, '2019-07-03', 391, NULL),
('Sheraton Centre', 163, '2019-07-04', 303, NULL),
('Sheraton Centre', 163, '2019-07-05', 344, NULL),
('Sheraton Centre', 163, '2019-07-06', 352, NULL),
('Sheraton Centre', 163, '2019-07-07', 202, NULL),
('Sheraton Centre', 163, '2019-07-08', 206, NULL),
('Sheraton Centre', 163, '2019-07-09', 142, NULL),
('Sheraton Centre', 163, '2019-07-10', 115, NULL),
('Sheraton Centre', 163, '2019-07-11', 149, NULL),
('Sheraton Centre', 163, '2019-07-12', 295, NULL),
('Sheraton Centre', 163, '2019-07-13', 118, NULL),
('Sheraton Centre', 163, '2019-07-14', 118, NULL),
('Sheraton Centre', 163, '2019-07-15', 389, NULL),
('Sheraton Centre', 163, '2019-07-16', 331, NULL),
('Sheraton Centre', 163, '2019-07-17', 153, NULL),
('Sheraton Centre', 163, '2019-07-18', 109, NULL),
('Sheraton Centre', 163, '2019-07-19', 280, NULL),
('Sheraton Centre', 163, '2019-07-20', 215, NULL),
('Sheraton Centre', 163, '2019-07-21', 124, NULL),
('Sheraton Centre', 163, '2019-07-22', 112, NULL),
('Sheraton Centre', 163, '2019-07-23', 234, NULL),
('Sheraton Centre', 163, '2019-07-24', 247, NULL),
('Sheraton Centre', 163, '2019-07-25', 365, NULL),
('Sheraton Centre', 163, '2019-07-26', 291, NULL),
('Sheraton Centre', 163, '2019-07-27', 373, NULL),
('Sheraton Centre', 163, '2019-07-28', 314, NULL),
('Sheraton Centre', 163, '2019-07-29', 140, NULL),
('Sheraton Centre', 163, '2019-07-30', 351, NULL),
('Sheraton Centre', 163, '2019-07-31', 331, NULL),
('Sheraton Centre', 163, '2019-08-01', 132, NULL),
('Sheraton Centre', 163, '2019-08-02', 257, NULL),
('Sheraton Centre', 163, '2019-08-03', 261, NULL),
('Sheraton Centre', 163, '2019-08-04', 338, NULL),
('Sheraton Centre', 163, '2019-08-05', 205, NULL),
('Sheraton Centre', 163, '2019-08-06', 107, NULL),
('Sheraton Centre', 163, '2019-08-07', 152, NULL),
('Sheraton Centre', 163, '2019-08-08', 260, NULL),
('Sheraton Centre', 163, '2019-08-09', 105, NULL),
('Sheraton Centre', 163, '2019-08-10', 121, NULL),
('Sheraton Centre', 163, '2019-08-11', 134, NULL),
('Sheraton Centre', 163, '2019-08-12', 392, NULL),
('Sheraton Centre', 163, '2019-08-13', 273, NULL),
('Sheraton Centre', 163, '2019-08-14', 313, NULL),
('Sheraton Centre', 163, '2019-08-15', 283, NULL),
('Sheraton Centre', 163, '2019-08-16', 303, NULL),
('Sheraton Centre', 163, '2019-08-17', 312, NULL),
('Sheraton Centre', 163, '2019-08-18', 388, NULL),
('Sheraton Centre', 163, '2019-08-19', 162, NULL),
('Sheraton Centre', 163, '2019-08-20', 237, NULL),
('Sheraton Centre', 163, '2019-08-21', 268, NULL),
('Sheraton Centre', 163, '2019-08-22', 393, NULL),
('Sheraton Centre', 163, '2019-08-23', 195, NULL),
('Sheraton Centre', 163, '2019-08-24', 136, NULL),
('Sheraton Centre', 163, '2019-08-25', 222, NULL),
('Sheraton Centre', 163, '2019-08-26', 124, NULL),
('Sheraton Centre', 163, '2019-08-27', 141, NULL),
('Sheraton Centre', 163, '2019-08-28', 283, NULL),
('Sheraton Centre', 163, '2019-08-29', 369, NULL),
('Sheraton Centre', 163, '2019-08-30', 212, NULL),
('Sheraton Centre', 163, '2019-08-31', 234, NULL),
('Sheraton Centre', 163, '2019-09-01', 371, NULL),
('Sheraton Centre', 163, '2019-09-02', 335, NULL),
('Sheraton Centre', 163, '2019-09-03', 337, NULL),
('Sheraton Centre', 163, '2019-09-04', 201, NULL),
('Sheraton Centre', 163, '2019-09-05', 194, NULL),
('Sheraton Centre', 163, '2019-09-06', 363, NULL),
('Sheraton Centre', 163, '2019-09-07', 303, NULL),
('Sheraton Centre', 163, '2019-09-08', 253, NULL),
('Sheraton Centre', 163, '2019-09-09', 323, NULL),
('Sheraton Centre', 163, '2019-09-10', 341, NULL),
('Sheraton Centre', 163, '2019-09-11', 100, NULL),
('Sheraton Centre', 163, '2019-09-12', 365, NULL),
('Sheraton Centre', 163, '2019-09-13', 119, NULL),
('Sheraton Centre', 163, '2019-09-14', 109, NULL),
('Sheraton Centre', 163, '2019-09-15', 328, NULL),
('Sheraton Centre', 163, '2019-09-16', 113, NULL),
('Sheraton Centre', 163, '2019-09-17', 158, NULL),
('Sheraton Centre', 163, '2019-09-18', 217, NULL),
('Sheraton Centre', 163, '2019-09-19', 174, NULL),
('Sheraton Centre', 163, '2019-09-20', 105, NULL),
('Sheraton Centre', 163, '2019-09-21', 257, NULL),
('Sheraton Centre', 163, '2019-09-22', 259, NULL),
('Sheraton Centre', 163, '2019-09-23', 341, NULL),
('Sheraton Centre', 163, '2019-09-24', 397, NULL),
('Sheraton Centre', 163, '2019-09-25', 332, NULL),
('Sheraton Centre', 163, '2019-09-26', 352, NULL),
('Sheraton Centre', 163, '2019-09-27', 238, NULL),
('Sheraton Centre', 163, '2019-09-28', 342, NULL),
('Sheraton Centre', 163, '2019-09-29', 321, NULL),
('Sheraton Centre', 163, '2019-09-30', 243, NULL),
('Sheraton Centre', 163, '2019-10-01', 379, NULL),
('Sheraton Centre', 163, '2019-10-02', 373, NULL),
('Sheraton Centre', 163, '2019-10-03', 122, NULL),
('Sheraton Centre', 163, '2019-10-04', 375, NULL),
('Sheraton Centre', 163, '2019-10-05', 309, NULL),
('Sheraton Centre', 163, '2019-10-06', 303, NULL),
('Sheraton Centre', 163, '2019-10-07', 119, NULL),
('Sheraton Centre', 163, '2019-10-08', 385, NULL),
('Sheraton Centre', 163, '2019-10-09', 237, NULL),
('Sheraton Centre', 163, '2019-10-10', 309, NULL),
('Sheraton Centre', 163, '2019-10-11', 115, NULL),
('Sheraton Centre', 163, '2019-10-12', 120, NULL),
('Sheraton Centre', 163, '2019-10-13', 265, NULL),
('Sheraton Centre', 163, '2019-10-14', 195, NULL),
('Sheraton Centre', 163, '2019-10-15', 217, NULL),
('Sheraton Centre', 163, '2019-10-16', 300, NULL),
('Sheraton Centre', 163, '2019-10-17', 267, NULL),
('Sheraton Centre', 163, '2019-10-18', 397, NULL),
('Sheraton Centre', 163, '2019-10-19', 329, NULL),
('Sheraton Centre', 163, '2019-10-20', 193, NULL),
('Sheraton Centre', 163, '2019-10-21', 137, NULL),
('Sheraton Centre', 163, '2019-10-22', 212, NULL),
('Sheraton Centre', 163, '2019-10-23', 129, NULL),
('Sheraton Centre', 163, '2019-10-24', 167, NULL),
('Sheraton Centre', 163, '2019-10-25', 303, NULL),
('Sheraton Centre', 163, '2019-10-26', 314, NULL),
('Sheraton Centre', 163, '2019-10-27', 383, NULL),
('Sheraton Centre', 163, '2019-10-28', 246, NULL),
('Sheraton Centre', 163, '2019-10-29', 306, NULL),
('Sheraton Centre', 163, '2019-10-30', 195, NULL),
('Sheraton Centre', 163, '2019-10-31', 316, NULL),
('Sheraton Centre', 163, '2019-11-01', 206, NULL),
('Sheraton Centre', 163, '2019-11-02', 145, NULL),
('Sheraton Centre', 163, '2019-11-03', 288, NULL),
('Sheraton Centre', 163, '2019-11-04', 199, NULL),
('Sheraton Centre', 163, '2019-11-05', 311, NULL),
('Sheraton Centre', 163, '2019-11-06', 290, NULL),
('Sheraton Centre', 163, '2019-11-07', 217, NULL),
('Sheraton Centre', 163, '2019-11-08', 331, NULL),
('Sheraton Centre', 163, '2019-11-09', 221, NULL),
('Sheraton Centre', 163, '2019-11-10', 299, NULL),
('Sheraton Centre', 163, '2019-11-11', 397, NULL),
('Sheraton Centre', 163, '2019-11-12', 268, NULL),
('Sheraton Centre', 163, '2019-11-13', 164, NULL),
('Sheraton Centre', 163, '2019-11-14', 247, NULL),
('Sheraton Centre', 163, '2019-11-15', 291, NULL),
('Sheraton Centre', 163, '2019-11-16', 246, NULL),
('Sheraton Centre', 163, '2019-11-17', 175, NULL),
('Sheraton Centre', 163, '2019-11-18', 331, NULL),
('Sheraton Centre', 163, '2019-11-19', 199, NULL),
('Sheraton Centre', 163, '2019-11-20', 335, NULL),
('Sheraton Centre', 163, '2019-11-21', 155, NULL),
('Sheraton Centre', 163, '2019-11-22', 398, NULL),
('Sheraton Centre', 163, '2019-11-23', 164, NULL),
('Sheraton Centre', 163, '2019-11-24', 387, NULL),
('Sheraton Centre', 163, '2019-11-25', 353, NULL),
('Sheraton Centre', 163, '2019-11-26', 367, NULL),
('Sheraton Centre', 163, '2019-11-27', 388, NULL),
('Sheraton Centre', 163, '2019-11-28', 161, NULL),
('Sheraton Centre', 163, '2019-11-29', 387, NULL),
('Sheraton Centre', 163, '2019-11-30', 133, NULL),
('Sheraton Centre', 163, '2019-12-01', 212, NULL),
('Sheraton Centre', 163, '2019-12-02', 226, NULL),
('Sheraton Centre', 163, '2019-12-03', 322, NULL),
('Sheraton Centre', 163, '2019-12-04', 134, NULL),
('Sheraton Centre', 163, '2019-12-05', 287, NULL),
('Sheraton Centre', 163, '2019-12-06', 325, NULL),
('Sheraton Centre', 163, '2019-12-07', 192, NULL),
('Sheraton Centre', 163, '2019-12-08', 317, NULL),
('Sheraton Centre', 163, '2019-12-09', 228, NULL),
('Sheraton Centre', 163, '2019-12-10', 131, NULL),
('Sheraton Centre', 163, '2019-12-11', 327, NULL),
('Sheraton Centre', 163, '2019-12-12', 125, NULL),
('Sheraton Centre', 163, '2019-12-13', 164, NULL),
('Sheraton Centre', 163, '2019-12-14', 151, NULL),
('Sheraton Centre', 163, '2019-12-15', 311, NULL),
('Sheraton Centre', 163, '2019-12-16', 288, NULL),
('Sheraton Centre', 163, '2019-12-17', 330, NULL),
('Sheraton Centre', 163, '2019-12-18', 369, NULL),
('Sheraton Centre', 163, '2019-12-19', 189, NULL),
('Sheraton Centre', 163, '2019-12-20', 298, NULL),
('Sheraton Centre', 163, '2019-12-21', 219, NULL),
('Sheraton Centre', 163, '2019-12-22', 205, NULL),
('Sheraton Centre', 163, '2019-12-23', 361, NULL),
('Sheraton Centre', 163, '2019-12-24', 385, NULL),
('Sheraton Centre', 163, '2019-12-25', 273, NULL),
('Sheraton Centre', 163, '2019-12-26', 339, NULL),
('Sheraton Centre', 163, '2019-12-27', 270, NULL),
('Sheraton Centre', 163, '2019-12-28', 158, NULL),
('Sheraton Centre', 163, '2019-12-29', 260, NULL),
('Sheraton Centre', 163, '2019-12-30', 342, NULL),
('Sheraton Centre', 163, '2019-12-31', 279, NULL),
('Sheraton Centre', 163, '2020-01-01', 260, NULL),
('Sheraton Centre', 163, '2020-01-02', 250, NULL),
('Sheraton Centre', 163, '2020-01-03', 254, NULL),
('Sheraton Centre', 163, '2020-01-04', 205, NULL),
('Sheraton Centre', 163, '2020-01-05', 328, NULL),
('Sheraton Centre', 163, '2020-01-06', 248, NULL),
('Sheraton Centre', 163, '2020-01-07', 202, NULL),
('Sheraton Centre', 163, '2020-01-08', 274, NULL),
('Sheraton Centre', 163, '2020-01-09', 308, NULL),
('Sheraton Centre', 163, '2020-01-10', 379, NULL),
('Sheraton Centre', 163, '2020-01-11', 383, NULL),
('Sheraton Centre', 163, '2020-01-12', 165, NULL),
('Sheraton Centre', 163, '2020-01-13', 324, NULL),
('Sheraton Centre', 163, '2020-01-14', 267, NULL),
('Sheraton Centre', 163, '2020-01-15', 307, NULL),
('Sheraton Centre', 163, '2020-01-16', 281, NULL),
('Sheraton Centre', 163, '2020-01-17', 133, NULL),
('Sheraton Centre', 163, '2020-01-18', 297, NULL),
('Sheraton Centre', 163, '2020-01-19', 316, NULL),
('Sheraton Centre', 163, '2020-01-20', 215, NULL),
('Sheraton Centre', 163, '2020-01-21', 252, NULL),
('Sheraton Centre', 163, '2020-01-22', 164, NULL),
('Sheraton Centre', 163, '2020-01-23', 258, NULL),
('Sheraton Centre', 163, '2020-01-24', 139, NULL),
('Sheraton Centre', 163, '2020-01-25', 209, NULL),
('Sheraton Centre', 163, '2020-01-26', 275, NULL),
('Sheraton Centre', 163, '2020-01-27', 144, NULL),
('Sheraton Centre', 163, '2020-01-28', 275, NULL),
('Sheraton Centre', 163, '2020-01-29', 315, NULL),
('Sheraton Centre', 163, '2020-01-30', 286, NULL),
('Sheraton Centre', 163, '2020-01-31', 133, NULL),
('Sheraton Centre', 163, '2020-02-01', 187, NULL),
('Sheraton Centre', 163, '2020-02-02', 152, NULL),
('Sheraton Centre', 163, '2020-02-03', 378, NULL),
('Sheraton Centre', 163, '2020-02-04', 165, NULL),
('Sheraton Centre', 166, '2019-01-01', 256, NULL),
('Sheraton Centre', 166, '2019-01-02', 297, NULL),
('Sheraton Centre', 166, '2019-01-03', 230, NULL),
('Sheraton Centre', 166, '2019-01-04', 249, NULL),
('Sheraton Centre', 166, '2019-01-05', 366, NULL),
('Sheraton Centre', 166, '2019-01-06', 244, NULL),
('Sheraton Centre', 166, '2019-01-07', 240, NULL),
('Sheraton Centre', 166, '2019-01-08', 282, NULL),
('Sheraton Centre', 166, '2019-01-09', 101, NULL),
('Sheraton Centre', 166, '2019-01-10', 277, NULL),
('Sheraton Centre', 166, '2019-01-11', 315, NULL),
('Sheraton Centre', 166, '2019-01-12', 280, NULL),
('Sheraton Centre', 166, '2019-01-13', 293, NULL),
('Sheraton Centre', 166, '2019-01-14', 276, NULL),
('Sheraton Centre', 166, '2019-01-15', 139, NULL),
('Sheraton Centre', 166, '2019-01-16', 396, NULL),
('Sheraton Centre', 166, '2019-01-17', 169, NULL),
('Sheraton Centre', 166, '2019-01-18', 367, NULL),
('Sheraton Centre', 166, '2019-01-19', 275, NULL),
('Sheraton Centre', 166, '2019-01-20', 311, NULL),
('Sheraton Centre', 166, '2019-01-21', 125, NULL),
('Sheraton Centre', 166, '2019-01-22', 184, NULL),
('Sheraton Centre', 166, '2019-01-23', 115, NULL),
('Sheraton Centre', 166, '2019-01-24', 262, NULL),
('Sheraton Centre', 166, '2019-01-25', 397, NULL),
('Sheraton Centre', 166, '2019-01-26', 130, NULL),
('Sheraton Centre', 166, '2019-01-27', 164, NULL),
('Sheraton Centre', 166, '2019-01-28', 145, NULL),
('Sheraton Centre', 166, '2019-01-29', 370, NULL),
('Sheraton Centre', 166, '2019-01-30', 295, NULL),
('Sheraton Centre', 166, '2019-01-31', 210, NULL),
('Sheraton Centre', 166, '2019-02-01', 278, NULL),
('Sheraton Centre', 166, '2019-02-02', 116, NULL),
('Sheraton Centre', 166, '2019-02-03', 360, NULL),
('Sheraton Centre', 166, '2019-02-04', 126, NULL),
('Sheraton Centre', 166, '2019-02-05', 388, NULL),
('Sheraton Centre', 166, '2019-02-06', 197, NULL),
('Sheraton Centre', 166, '2019-02-07', 141, NULL),
('Sheraton Centre', 166, '2019-02-08', 158, NULL),
('Sheraton Centre', 166, '2019-02-09', 149, NULL),
('Sheraton Centre', 166, '2019-02-10', 110, NULL),
('Sheraton Centre', 166, '2019-02-11', 308, NULL),
('Sheraton Centre', 166, '2019-02-12', 305, NULL),
('Sheraton Centre', 166, '2019-02-13', 192, NULL),
('Sheraton Centre', 166, '2019-02-14', 125, NULL),
('Sheraton Centre', 166, '2019-02-15', 354, NULL),
('Sheraton Centre', 166, '2019-02-16', 112, NULL),
('Sheraton Centre', 166, '2019-02-17', 257, NULL),
('Sheraton Centre', 166, '2019-02-18', 153, NULL),
('Sheraton Centre', 166, '2019-02-19', 115, NULL),
('Sheraton Centre', 166, '2019-02-20', 211, NULL),
('Sheraton Centre', 166, '2019-02-21', 217, NULL),
('Sheraton Centre', 166, '2019-02-22', 125, NULL),
('Sheraton Centre', 166, '2019-02-23', 128, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 166, '2019-02-24', 124, NULL),
('Sheraton Centre', 166, '2019-02-25', 339, NULL),
('Sheraton Centre', 166, '2019-02-26', 308, NULL),
('Sheraton Centre', 166, '2019-02-27', 196, NULL),
('Sheraton Centre', 166, '2019-02-28', 356, NULL),
('Sheraton Centre', 166, '2019-03-01', 243, NULL),
('Sheraton Centre', 166, '2019-03-02', 250, NULL),
('Sheraton Centre', 166, '2019-03-03', 331, NULL),
('Sheraton Centre', 166, '2019-03-04', 155, NULL),
('Sheraton Centre', 166, '2019-03-05', 194, NULL),
('Sheraton Centre', 166, '2019-03-06', 240, NULL),
('Sheraton Centre', 166, '2019-03-07', 377, NULL),
('Sheraton Centre', 166, '2019-03-08', 232, NULL),
('Sheraton Centre', 166, '2019-03-09', 107, NULL),
('Sheraton Centre', 166, '2019-03-10', 200, NULL),
('Sheraton Centre', 166, '2019-03-11', 356, NULL),
('Sheraton Centre', 166, '2019-03-12', 284, NULL),
('Sheraton Centre', 166, '2019-03-13', 204, NULL),
('Sheraton Centre', 166, '2019-03-14', 298, NULL),
('Sheraton Centre', 166, '2019-03-15', 296, NULL),
('Sheraton Centre', 166, '2019-03-16', 274, NULL),
('Sheraton Centre', 166, '2019-03-17', 100, NULL),
('Sheraton Centre', 166, '2019-03-18', 232, NULL),
('Sheraton Centre', 166, '2019-03-19', 254, NULL),
('Sheraton Centre', 166, '2019-03-20', 311, NULL),
('Sheraton Centre', 166, '2019-03-21', 225, NULL),
('Sheraton Centre', 166, '2019-03-22', 231, NULL),
('Sheraton Centre', 166, '2019-03-23', 190, NULL),
('Sheraton Centre', 166, '2019-03-24', 312, NULL),
('Sheraton Centre', 166, '2019-03-25', 166, NULL),
('Sheraton Centre', 166, '2019-03-26', 348, NULL),
('Sheraton Centre', 166, '2019-03-27', 210, NULL),
('Sheraton Centre', 166, '2019-03-28', 345, NULL),
('Sheraton Centre', 166, '2019-03-29', 264, NULL),
('Sheraton Centre', 166, '2019-03-30', 154, NULL),
('Sheraton Centre', 166, '2019-03-31', 164, NULL),
('Sheraton Centre', 166, '2019-04-01', 312, NULL),
('Sheraton Centre', 166, '2019-04-02', 194, NULL),
('Sheraton Centre', 166, '2019-04-03', 286, NULL),
('Sheraton Centre', 166, '2019-04-04', 295, NULL),
('Sheraton Centre', 166, '2019-04-05', 196, NULL),
('Sheraton Centre', 166, '2019-04-06', 145, NULL),
('Sheraton Centre', 166, '2019-04-07', 380, NULL),
('Sheraton Centre', 166, '2019-04-08', 396, NULL),
('Sheraton Centre', 166, '2019-04-09', 391, NULL),
('Sheraton Centre', 166, '2019-04-10', 114, NULL),
('Sheraton Centre', 166, '2019-04-11', 142, NULL),
('Sheraton Centre', 166, '2019-04-12', 244, NULL),
('Sheraton Centre', 166, '2019-04-13', 138, NULL),
('Sheraton Centre', 166, '2019-04-14', 294, NULL),
('Sheraton Centre', 166, '2019-04-15', 261, NULL),
('Sheraton Centre', 166, '2019-04-16', 160, NULL),
('Sheraton Centre', 166, '2019-04-17', 135, NULL),
('Sheraton Centre', 166, '2019-04-18', 166, NULL),
('Sheraton Centre', 166, '2019-04-19', 228, NULL),
('Sheraton Centre', 166, '2019-04-20', 237, NULL),
('Sheraton Centre', 166, '2019-04-21', 142, NULL),
('Sheraton Centre', 166, '2019-04-22', 226, NULL),
('Sheraton Centre', 166, '2019-04-23', 364, NULL),
('Sheraton Centre', 166, '2019-04-24', 339, NULL),
('Sheraton Centre', 166, '2019-04-25', 108, NULL),
('Sheraton Centre', 166, '2019-04-26', 360, NULL),
('Sheraton Centre', 166, '2019-04-27', 268, NULL),
('Sheraton Centre', 166, '2019-04-28', 242, NULL),
('Sheraton Centre', 166, '2019-04-29', 279, NULL),
('Sheraton Centre', 166, '2019-04-30', 388, NULL),
('Sheraton Centre', 166, '2019-05-01', 329, NULL),
('Sheraton Centre', 166, '2019-05-02', 128, NULL),
('Sheraton Centre', 166, '2019-05-03', 227, NULL),
('Sheraton Centre', 166, '2019-05-04', 270, NULL),
('Sheraton Centre', 166, '2019-05-05', 353, NULL),
('Sheraton Centre', 166, '2019-05-06', 288, NULL),
('Sheraton Centre', 166, '2019-05-07', 162, NULL),
('Sheraton Centre', 166, '2019-05-08', 216, NULL),
('Sheraton Centre', 166, '2019-05-09', 260, NULL),
('Sheraton Centre', 166, '2019-05-10', 236, NULL),
('Sheraton Centre', 166, '2019-05-11', 272, NULL),
('Sheraton Centre', 166, '2019-05-12', 269, NULL),
('Sheraton Centre', 166, '2019-05-13', 286, NULL),
('Sheraton Centre', 166, '2019-05-14', 183, NULL),
('Sheraton Centre', 166, '2019-05-15', 127, NULL),
('Sheraton Centre', 166, '2019-05-16', 347, NULL),
('Sheraton Centre', 166, '2019-05-17', 390, NULL),
('Sheraton Centre', 166, '2019-05-18', 100, NULL),
('Sheraton Centre', 166, '2019-05-19', 384, NULL),
('Sheraton Centre', 166, '2019-05-20', 261, NULL),
('Sheraton Centre', 166, '2019-05-21', 349, NULL),
('Sheraton Centre', 166, '2019-05-22', 243, NULL),
('Sheraton Centre', 166, '2019-05-23', 125, NULL),
('Sheraton Centre', 166, '2019-05-24', 220, NULL),
('Sheraton Centre', 166, '2019-05-25', 123, NULL),
('Sheraton Centre', 166, '2019-05-26', 313, NULL),
('Sheraton Centre', 166, '2019-05-27', 357, NULL),
('Sheraton Centre', 166, '2019-05-28', 289, NULL),
('Sheraton Centre', 166, '2019-05-29', 249, NULL),
('Sheraton Centre', 166, '2019-05-30', 358, NULL),
('Sheraton Centre', 166, '2019-05-31', 250, NULL),
('Sheraton Centre', 166, '2019-06-01', 106, NULL),
('Sheraton Centre', 166, '2019-06-02', 291, NULL),
('Sheraton Centre', 166, '2019-06-03', 340, NULL),
('Sheraton Centre', 166, '2019-06-04', 355, NULL),
('Sheraton Centre', 166, '2019-06-05', 135, NULL),
('Sheraton Centre', 166, '2019-06-06', 396, NULL),
('Sheraton Centre', 166, '2019-06-07', 220, NULL),
('Sheraton Centre', 166, '2019-06-08', 306, NULL),
('Sheraton Centre', 166, '2019-06-09', 241, NULL),
('Sheraton Centre', 166, '2019-06-10', 182, NULL),
('Sheraton Centre', 166, '2019-06-11', 334, NULL),
('Sheraton Centre', 166, '2019-06-12', 340, NULL),
('Sheraton Centre', 166, '2019-06-13', 345, NULL),
('Sheraton Centre', 166, '2019-06-14', 126, NULL),
('Sheraton Centre', 166, '2019-06-15', 342, NULL),
('Sheraton Centre', 166, '2019-06-16', 268, NULL),
('Sheraton Centre', 166, '2019-06-17', 120, NULL),
('Sheraton Centre', 166, '2019-06-18', 234, NULL),
('Sheraton Centre', 166, '2019-06-19', 388, NULL),
('Sheraton Centre', 166, '2019-06-20', 152, NULL),
('Sheraton Centre', 166, '2019-06-21', 286, NULL),
('Sheraton Centre', 166, '2019-06-22', 149, NULL),
('Sheraton Centre', 166, '2019-06-23', 109, NULL),
('Sheraton Centre', 166, '2019-06-24', 277, NULL),
('Sheraton Centre', 166, '2019-06-25', 226, NULL),
('Sheraton Centre', 166, '2019-06-26', 390, NULL),
('Sheraton Centre', 166, '2019-06-27', 173, NULL),
('Sheraton Centre', 166, '2019-06-28', 162, NULL),
('Sheraton Centre', 166, '2019-06-29', 268, NULL),
('Sheraton Centre', 166, '2019-06-30', 315, NULL),
('Sheraton Centre', 166, '2019-07-01', 180, NULL),
('Sheraton Centre', 166, '2019-07-02', 339, NULL),
('Sheraton Centre', 166, '2019-07-03', 348, NULL),
('Sheraton Centre', 166, '2019-07-04', 195, NULL),
('Sheraton Centre', 166, '2019-07-05', 288, NULL),
('Sheraton Centre', 166, '2019-07-06', 192, NULL),
('Sheraton Centre', 166, '2019-07-07', 187, NULL),
('Sheraton Centre', 166, '2019-07-08', 310, NULL),
('Sheraton Centre', 166, '2019-07-09', 362, NULL),
('Sheraton Centre', 166, '2019-07-10', 254, NULL),
('Sheraton Centre', 166, '2019-07-11', 274, NULL),
('Sheraton Centre', 166, '2019-07-12', 371, NULL),
('Sheraton Centre', 166, '2019-07-13', 261, NULL),
('Sheraton Centre', 166, '2019-07-14', 201, NULL),
('Sheraton Centre', 166, '2019-07-15', 334, NULL),
('Sheraton Centre', 166, '2019-07-16', 189, NULL),
('Sheraton Centre', 166, '2019-07-17', 293, NULL),
('Sheraton Centre', 166, '2019-07-18', 338, NULL),
('Sheraton Centre', 166, '2019-07-19', 236, NULL),
('Sheraton Centre', 166, '2019-07-20', 167, NULL),
('Sheraton Centre', 166, '2019-07-21', 340, NULL),
('Sheraton Centre', 166, '2019-07-22', 391, NULL),
('Sheraton Centre', 166, '2019-07-23', 371, NULL),
('Sheraton Centre', 166, '2019-07-24', 147, NULL),
('Sheraton Centre', 166, '2019-07-25', 342, NULL),
('Sheraton Centre', 166, '2019-07-26', 162, NULL),
('Sheraton Centre', 166, '2019-07-27', 278, NULL),
('Sheraton Centre', 166, '2019-07-28', 357, NULL),
('Sheraton Centre', 166, '2019-07-29', 298, NULL),
('Sheraton Centre', 166, '2019-07-30', 178, NULL),
('Sheraton Centre', 166, '2019-07-31', 241, NULL),
('Sheraton Centre', 166, '2019-08-01', 289, NULL),
('Sheraton Centre', 166, '2019-08-02', 344, NULL),
('Sheraton Centre', 166, '2019-08-03', 286, NULL),
('Sheraton Centre', 166, '2019-08-04', 373, NULL),
('Sheraton Centre', 166, '2019-08-05', 173, NULL),
('Sheraton Centre', 166, '2019-08-06', 318, NULL),
('Sheraton Centre', 166, '2019-08-07', 228, NULL),
('Sheraton Centre', 166, '2019-08-08', 104, NULL),
('Sheraton Centre', 166, '2019-08-09', 278, NULL),
('Sheraton Centre', 166, '2019-08-10', 135, NULL),
('Sheraton Centre', 166, '2019-08-11', 123, NULL),
('Sheraton Centre', 166, '2019-08-12', 105, NULL),
('Sheraton Centre', 166, '2019-08-13', 257, NULL),
('Sheraton Centre', 166, '2019-08-14', 266, NULL),
('Sheraton Centre', 166, '2019-08-15', 317, NULL),
('Sheraton Centre', 166, '2019-08-16', 394, NULL),
('Sheraton Centre', 166, '2019-08-17', 290, NULL),
('Sheraton Centre', 166, '2019-08-18', 384, NULL),
('Sheraton Centre', 166, '2019-08-19', 122, NULL),
('Sheraton Centre', 166, '2019-08-20', 325, NULL),
('Sheraton Centre', 166, '2019-08-21', 354, NULL),
('Sheraton Centre', 166, '2019-08-22', 137, NULL),
('Sheraton Centre', 166, '2019-08-23', 220, NULL),
('Sheraton Centre', 166, '2019-08-24', 395, NULL),
('Sheraton Centre', 166, '2019-08-25', 330, NULL),
('Sheraton Centre', 166, '2019-08-26', 271, NULL),
('Sheraton Centre', 166, '2019-08-27', 376, NULL),
('Sheraton Centre', 166, '2019-08-28', 202, NULL),
('Sheraton Centre', 166, '2019-08-29', 227, NULL),
('Sheraton Centre', 166, '2019-08-30', 238, NULL),
('Sheraton Centre', 166, '2019-08-31', 385, NULL),
('Sheraton Centre', 166, '2019-09-01', 381, NULL),
('Sheraton Centre', 166, '2019-09-02', 126, NULL),
('Sheraton Centre', 166, '2019-09-03', 266, NULL),
('Sheraton Centre', 166, '2019-09-04', 254, NULL),
('Sheraton Centre', 166, '2019-09-05', 201, NULL),
('Sheraton Centre', 166, '2019-09-06', 222, NULL),
('Sheraton Centre', 166, '2019-09-07', 302, NULL),
('Sheraton Centre', 166, '2019-09-08', 393, NULL),
('Sheraton Centre', 166, '2019-09-09', 162, NULL),
('Sheraton Centre', 166, '2019-09-10', 301, NULL),
('Sheraton Centre', 166, '2019-09-11', 316, NULL),
('Sheraton Centre', 166, '2019-09-12', 128, NULL),
('Sheraton Centre', 166, '2019-09-13', 335, NULL),
('Sheraton Centre', 166, '2019-09-14', 190, NULL),
('Sheraton Centre', 166, '2019-09-15', 325, NULL),
('Sheraton Centre', 166, '2019-09-16', 106, NULL),
('Sheraton Centre', 166, '2019-09-17', 325, NULL),
('Sheraton Centre', 166, '2019-09-18', 174, NULL),
('Sheraton Centre', 166, '2019-09-19', 353, NULL),
('Sheraton Centre', 166, '2019-09-20', 108, NULL),
('Sheraton Centre', 166, '2019-09-21', 366, NULL),
('Sheraton Centre', 166, '2019-09-22', 352, NULL),
('Sheraton Centre', 166, '2019-09-23', 245, NULL),
('Sheraton Centre', 166, '2019-09-24', 289, NULL),
('Sheraton Centre', 166, '2019-09-25', 302, NULL),
('Sheraton Centre', 166, '2019-09-26', 368, NULL),
('Sheraton Centre', 166, '2019-09-27', 396, NULL),
('Sheraton Centre', 166, '2019-09-28', 314, NULL),
('Sheraton Centre', 166, '2019-09-29', 223, NULL),
('Sheraton Centre', 166, '2019-09-30', 227, NULL),
('Sheraton Centre', 166, '2019-10-01', 388, NULL),
('Sheraton Centre', 166, '2019-10-02', 326, NULL),
('Sheraton Centre', 166, '2019-10-03', 377, NULL),
('Sheraton Centre', 166, '2019-10-04', 339, NULL),
('Sheraton Centre', 166, '2019-10-05', 184, NULL),
('Sheraton Centre', 166, '2019-10-06', 219, NULL),
('Sheraton Centre', 166, '2019-10-07', 202, NULL),
('Sheraton Centre', 166, '2019-10-08', 259, NULL),
('Sheraton Centre', 166, '2019-10-09', 166, NULL),
('Sheraton Centre', 166, '2019-10-10', 327, NULL),
('Sheraton Centre', 166, '2019-10-11', 240, NULL),
('Sheraton Centre', 166, '2019-10-12', 354, NULL),
('Sheraton Centre', 166, '2019-10-13', 353, NULL),
('Sheraton Centre', 166, '2019-10-14', 338, NULL),
('Sheraton Centre', 166, '2019-10-15', 289, NULL),
('Sheraton Centre', 166, '2019-10-16', 224, NULL),
('Sheraton Centre', 166, '2019-10-17', 153, NULL),
('Sheraton Centre', 166, '2019-10-18', 199, NULL),
('Sheraton Centre', 166, '2019-10-19', 162, NULL),
('Sheraton Centre', 166, '2019-10-20', 136, NULL),
('Sheraton Centre', 166, '2019-10-21', 238, NULL),
('Sheraton Centre', 166, '2019-10-22', 347, NULL),
('Sheraton Centre', 166, '2019-10-23', 284, NULL),
('Sheraton Centre', 166, '2019-10-24', 255, NULL),
('Sheraton Centre', 166, '2019-10-25', 385, NULL),
('Sheraton Centre', 166, '2019-10-26', 223, NULL),
('Sheraton Centre', 166, '2019-10-27', 229, NULL),
('Sheraton Centre', 166, '2019-10-28', 310, NULL),
('Sheraton Centre', 166, '2019-10-29', 343, NULL),
('Sheraton Centre', 166, '2019-10-30', 131, NULL),
('Sheraton Centre', 166, '2019-10-31', 389, NULL),
('Sheraton Centre', 166, '2019-11-01', 218, NULL),
('Sheraton Centre', 166, '2019-11-02', 382, NULL),
('Sheraton Centre', 166, '2019-11-03', 220, NULL),
('Sheraton Centre', 166, '2019-11-04', 308, NULL),
('Sheraton Centre', 166, '2019-11-05', 375, NULL),
('Sheraton Centre', 166, '2019-11-06', 351, NULL),
('Sheraton Centre', 166, '2019-11-07', 263, NULL),
('Sheraton Centre', 166, '2019-11-08', 330, NULL),
('Sheraton Centre', 166, '2019-11-09', 129, NULL),
('Sheraton Centre', 166, '2019-11-10', 382, NULL),
('Sheraton Centre', 166, '2019-11-11', 107, NULL),
('Sheraton Centre', 166, '2019-11-12', 368, NULL),
('Sheraton Centre', 166, '2019-11-13', 250, NULL),
('Sheraton Centre', 166, '2019-11-14', 233, NULL),
('Sheraton Centre', 166, '2019-11-15', 379, NULL),
('Sheraton Centre', 166, '2019-11-16', 313, NULL),
('Sheraton Centre', 166, '2019-11-17', 236, NULL),
('Sheraton Centre', 166, '2019-11-18', 377, NULL),
('Sheraton Centre', 166, '2019-11-19', 268, NULL),
('Sheraton Centre', 166, '2019-11-20', 176, NULL),
('Sheraton Centre', 166, '2019-11-21', 215, NULL),
('Sheraton Centre', 166, '2019-11-22', 126, NULL),
('Sheraton Centre', 166, '2019-11-23', 348, NULL),
('Sheraton Centre', 166, '2019-11-24', 279, NULL),
('Sheraton Centre', 166, '2019-11-25', 306, NULL),
('Sheraton Centre', 166, '2019-11-26', 211, NULL),
('Sheraton Centre', 166, '2019-11-27', 149, NULL),
('Sheraton Centre', 166, '2019-11-28', 382, NULL),
('Sheraton Centre', 166, '2019-11-29', 224, NULL),
('Sheraton Centre', 166, '2019-11-30', 364, NULL),
('Sheraton Centre', 166, '2019-12-01', 297, NULL),
('Sheraton Centre', 166, '2019-12-02', 363, NULL),
('Sheraton Centre', 166, '2019-12-03', 359, NULL),
('Sheraton Centre', 166, '2019-12-04', 229, NULL),
('Sheraton Centre', 166, '2019-12-05', 229, NULL),
('Sheraton Centre', 166, '2019-12-06', 242, NULL),
('Sheraton Centre', 166, '2019-12-07', 269, NULL),
('Sheraton Centre', 166, '2019-12-08', 158, NULL),
('Sheraton Centre', 166, '2019-12-09', 237, NULL),
('Sheraton Centre', 166, '2019-12-10', 280, NULL),
('Sheraton Centre', 166, '2019-12-11', 357, NULL),
('Sheraton Centre', 166, '2019-12-12', 240, NULL),
('Sheraton Centre', 166, '2019-12-13', 317, NULL),
('Sheraton Centre', 166, '2019-12-14', 383, NULL),
('Sheraton Centre', 166, '2019-12-15', 398, NULL),
('Sheraton Centre', 166, '2019-12-16', 396, NULL),
('Sheraton Centre', 166, '2019-12-17', 343, NULL),
('Sheraton Centre', 166, '2019-12-18', 110, NULL),
('Sheraton Centre', 166, '2019-12-19', 227, NULL),
('Sheraton Centre', 166, '2019-12-20', 294, NULL),
('Sheraton Centre', 166, '2019-12-21', 353, NULL),
('Sheraton Centre', 166, '2019-12-22', 373, NULL),
('Sheraton Centre', 166, '2019-12-23', 197, NULL),
('Sheraton Centre', 166, '2019-12-24', 214, NULL),
('Sheraton Centre', 166, '2019-12-25', 135, NULL),
('Sheraton Centre', 166, '2019-12-26', 332, NULL),
('Sheraton Centre', 166, '2019-12-27', 208, NULL),
('Sheraton Centre', 166, '2019-12-28', 103, NULL),
('Sheraton Centre', 166, '2019-12-29', 229, NULL),
('Sheraton Centre', 166, '2019-12-30', 153, NULL),
('Sheraton Centre', 166, '2019-12-31', 255, NULL),
('Sheraton Centre', 166, '2020-01-01', 170, NULL),
('Sheraton Centre', 166, '2020-01-02', 245, NULL),
('Sheraton Centre', 166, '2020-01-03', 195, NULL),
('Sheraton Centre', 166, '2020-01-04', 226, NULL),
('Sheraton Centre', 166, '2020-01-05', 160, NULL),
('Sheraton Centre', 166, '2020-01-06', 376, NULL),
('Sheraton Centre', 166, '2020-01-07', 300, NULL),
('Sheraton Centre', 166, '2020-01-08', 387, NULL),
('Sheraton Centre', 166, '2020-01-09', 300, NULL),
('Sheraton Centre', 166, '2020-01-10', 321, NULL),
('Sheraton Centre', 166, '2020-01-11', 214, NULL),
('Sheraton Centre', 166, '2020-01-12', 231, NULL),
('Sheraton Centre', 166, '2020-01-13', 231, NULL),
('Sheraton Centre', 166, '2020-01-14', 300, NULL),
('Sheraton Centre', 166, '2020-01-15', 346, NULL),
('Sheraton Centre', 166, '2020-01-16', 226, NULL),
('Sheraton Centre', 166, '2020-01-17', 128, NULL),
('Sheraton Centre', 166, '2020-01-18', 261, NULL),
('Sheraton Centre', 166, '2020-01-19', 383, NULL),
('Sheraton Centre', 166, '2020-01-20', 289, NULL),
('Sheraton Centre', 166, '2020-01-21', 393, NULL),
('Sheraton Centre', 166, '2020-01-22', 282, NULL),
('Sheraton Centre', 166, '2020-01-23', 283, NULL),
('Sheraton Centre', 166, '2020-01-24', 111, NULL),
('Sheraton Centre', 166, '2020-01-25', 347, NULL),
('Sheraton Centre', 166, '2020-01-26', 185, NULL),
('Sheraton Centre', 166, '2020-01-27', 193, NULL),
('Sheraton Centre', 166, '2020-01-28', 107, NULL),
('Sheraton Centre', 166, '2020-01-29', 287, NULL),
('Sheraton Centre', 166, '2020-01-30', 357, NULL),
('Sheraton Centre', 166, '2020-01-31', 215, NULL),
('Sheraton Centre', 166, '2020-02-01', 373, NULL),
('Sheraton Centre', 166, '2020-02-02', 354, NULL),
('Sheraton Centre', 166, '2020-02-03', 290, NULL),
('Sheraton Centre', 166, '2020-02-04', 364, NULL),
('Sheraton Centre', 171, '2019-01-01', 298, NULL),
('Sheraton Centre', 171, '2019-01-02', 128, NULL),
('Sheraton Centre', 171, '2019-01-03', 301, NULL),
('Sheraton Centre', 171, '2019-01-04', 126, NULL),
('Sheraton Centre', 171, '2019-01-05', 301, NULL),
('Sheraton Centre', 171, '2019-01-06', 190, NULL),
('Sheraton Centre', 171, '2019-01-07', 316, NULL),
('Sheraton Centre', 171, '2019-01-08', 287, NULL),
('Sheraton Centre', 171, '2019-01-09', 106, NULL),
('Sheraton Centre', 171, '2019-01-10', 388, NULL),
('Sheraton Centre', 171, '2019-01-11', 365, NULL),
('Sheraton Centre', 171, '2019-01-12', 220, NULL),
('Sheraton Centre', 171, '2019-01-13', 368, NULL),
('Sheraton Centre', 171, '2019-01-14', 310, NULL),
('Sheraton Centre', 171, '2019-01-15', 202, NULL),
('Sheraton Centre', 171, '2019-01-16', 299, NULL),
('Sheraton Centre', 171, '2019-01-17', 133, NULL),
('Sheraton Centre', 171, '2019-01-18', 366, NULL),
('Sheraton Centre', 171, '2019-01-19', 242, NULL),
('Sheraton Centre', 171, '2019-01-20', 202, NULL),
('Sheraton Centre', 171, '2019-01-21', 256, NULL),
('Sheraton Centre', 171, '2019-01-22', 308, NULL),
('Sheraton Centre', 171, '2019-01-23', 384, NULL),
('Sheraton Centre', 171, '2019-01-24', 161, NULL),
('Sheraton Centre', 171, '2019-01-25', 145, NULL),
('Sheraton Centre', 171, '2019-01-26', 150, NULL),
('Sheraton Centre', 171, '2019-01-27', 120, NULL),
('Sheraton Centre', 171, '2019-01-28', 303, NULL),
('Sheraton Centre', 171, '2019-01-29', 106, NULL),
('Sheraton Centre', 171, '2019-01-30', 327, NULL),
('Sheraton Centre', 171, '2019-01-31', 330, NULL),
('Sheraton Centre', 171, '2019-02-01', 257, NULL),
('Sheraton Centre', 171, '2019-02-02', 348, NULL),
('Sheraton Centre', 171, '2019-02-03', 130, NULL),
('Sheraton Centre', 171, '2019-02-04', 113, NULL),
('Sheraton Centre', 171, '2019-02-05', 380, NULL),
('Sheraton Centre', 171, '2019-02-06', 298, NULL),
('Sheraton Centre', 171, '2019-02-07', 283, NULL),
('Sheraton Centre', 171, '2019-02-08', 113, NULL),
('Sheraton Centre', 171, '2019-02-09', 260, NULL),
('Sheraton Centre', 171, '2019-02-10', 219, NULL),
('Sheraton Centre', 171, '2019-02-11', 273, NULL),
('Sheraton Centre', 171, '2019-02-12', 366, NULL),
('Sheraton Centre', 171, '2019-02-13', 388, NULL),
('Sheraton Centre', 171, '2019-02-14', 312, NULL),
('Sheraton Centre', 171, '2019-02-15', 158, NULL),
('Sheraton Centre', 171, '2019-02-16', 275, NULL),
('Sheraton Centre', 171, '2019-02-17', 314, NULL),
('Sheraton Centre', 171, '2019-02-18', 273, NULL),
('Sheraton Centre', 171, '2019-02-19', 368, NULL),
('Sheraton Centre', 171, '2019-02-20', 367, NULL),
('Sheraton Centre', 171, '2019-02-21', 373, NULL),
('Sheraton Centre', 171, '2019-02-22', 176, NULL),
('Sheraton Centre', 171, '2019-02-23', 161, NULL),
('Sheraton Centre', 171, '2019-02-24', 318, NULL),
('Sheraton Centre', 171, '2019-02-25', 368, NULL),
('Sheraton Centre', 171, '2019-02-26', 308, NULL),
('Sheraton Centre', 171, '2019-02-27', 109, NULL),
('Sheraton Centre', 171, '2019-02-28', 270, NULL),
('Sheraton Centre', 171, '2019-03-01', 258, NULL),
('Sheraton Centre', 171, '2019-03-02', 373, NULL),
('Sheraton Centre', 171, '2019-03-03', 210, NULL),
('Sheraton Centre', 171, '2019-03-04', 268, NULL),
('Sheraton Centre', 171, '2019-03-05', 190, NULL),
('Sheraton Centre', 171, '2019-03-06', 239, NULL),
('Sheraton Centre', 171, '2019-03-07', 384, NULL),
('Sheraton Centre', 171, '2019-03-08', 196, NULL),
('Sheraton Centre', 171, '2019-03-09', 240, NULL),
('Sheraton Centre', 171, '2019-03-10', 174, NULL),
('Sheraton Centre', 171, '2019-03-11', 295, NULL),
('Sheraton Centre', 171, '2019-03-12', 117, NULL),
('Sheraton Centre', 171, '2019-03-13', 345, NULL),
('Sheraton Centre', 171, '2019-03-14', 241, NULL),
('Sheraton Centre', 171, '2019-03-15', 206, NULL),
('Sheraton Centre', 171, '2019-03-16', 140, NULL),
('Sheraton Centre', 171, '2019-03-17', 176, NULL),
('Sheraton Centre', 171, '2019-03-18', 272, NULL),
('Sheraton Centre', 171, '2019-03-19', 173, NULL),
('Sheraton Centre', 171, '2019-03-20', 334, NULL),
('Sheraton Centre', 171, '2019-03-21', 260, NULL),
('Sheraton Centre', 171, '2019-03-22', 219, NULL),
('Sheraton Centre', 171, '2019-03-23', 377, NULL),
('Sheraton Centre', 171, '2019-03-24', 366, NULL),
('Sheraton Centre', 171, '2019-03-25', 341, NULL),
('Sheraton Centre', 171, '2019-03-26', 155, NULL),
('Sheraton Centre', 171, '2019-03-27', 105, NULL),
('Sheraton Centre', 171, '2019-03-28', 222, NULL),
('Sheraton Centre', 171, '2019-03-29', 277, NULL),
('Sheraton Centre', 171, '2019-03-30', 273, NULL),
('Sheraton Centre', 171, '2019-03-31', 103, NULL),
('Sheraton Centre', 171, '2019-04-01', 383, NULL),
('Sheraton Centre', 171, '2019-04-02', 278, NULL),
('Sheraton Centre', 171, '2019-04-03', 371, NULL),
('Sheraton Centre', 171, '2019-04-04', 349, NULL),
('Sheraton Centre', 171, '2019-04-05', 202, NULL),
('Sheraton Centre', 171, '2019-04-06', 321, NULL),
('Sheraton Centre', 171, '2019-04-07', 114, NULL),
('Sheraton Centre', 171, '2019-04-08', 245, NULL),
('Sheraton Centre', 171, '2019-04-09', 381, NULL),
('Sheraton Centre', 171, '2019-04-10', 258, NULL),
('Sheraton Centre', 171, '2019-04-11', 381, NULL),
('Sheraton Centre', 171, '2019-04-12', 252, NULL),
('Sheraton Centre', 171, '2019-04-13', 375, NULL),
('Sheraton Centre', 171, '2019-04-14', 274, NULL),
('Sheraton Centre', 171, '2019-04-15', 107, NULL),
('Sheraton Centre', 171, '2019-04-16', 105, NULL),
('Sheraton Centre', 171, '2019-04-17', 100, NULL),
('Sheraton Centre', 171, '2019-04-18', 147, NULL),
('Sheraton Centre', 171, '2019-04-19', 153, NULL),
('Sheraton Centre', 171, '2019-04-20', 123, NULL),
('Sheraton Centre', 171, '2019-04-21', 254, NULL),
('Sheraton Centre', 171, '2019-04-22', 226, NULL),
('Sheraton Centre', 171, '2019-04-23', 170, NULL),
('Sheraton Centre', 171, '2019-04-24', 270, NULL),
('Sheraton Centre', 171, '2019-04-25', 147, NULL),
('Sheraton Centre', 171, '2019-04-26', 198, NULL),
('Sheraton Centre', 171, '2019-04-27', 161, NULL),
('Sheraton Centre', 171, '2019-04-28', 350, NULL),
('Sheraton Centre', 171, '2019-04-29', 290, NULL),
('Sheraton Centre', 171, '2019-04-30', 320, NULL),
('Sheraton Centre', 171, '2019-05-01', 242, NULL),
('Sheraton Centre', 171, '2019-05-02', 269, NULL),
('Sheraton Centre', 171, '2019-05-03', 297, NULL),
('Sheraton Centre', 171, '2019-05-04', 388, NULL),
('Sheraton Centre', 171, '2019-05-05', 264, NULL),
('Sheraton Centre', 171, '2019-05-06', 260, NULL),
('Sheraton Centre', 171, '2019-05-07', 285, NULL),
('Sheraton Centre', 171, '2019-05-08', 318, NULL),
('Sheraton Centre', 171, '2019-05-09', 216, NULL),
('Sheraton Centre', 171, '2019-05-10', 210, NULL),
('Sheraton Centre', 171, '2019-05-11', 176, NULL),
('Sheraton Centre', 171, '2019-05-12', 161, NULL),
('Sheraton Centre', 171, '2019-05-13', 390, NULL),
('Sheraton Centre', 171, '2019-05-14', 170, NULL),
('Sheraton Centre', 171, '2019-05-15', 251, NULL),
('Sheraton Centre', 171, '2019-05-16', 204, NULL),
('Sheraton Centre', 171, '2019-05-17', 201, NULL),
('Sheraton Centre', 171, '2019-05-18', 101, NULL),
('Sheraton Centre', 171, '2019-05-19', 252, NULL),
('Sheraton Centre', 171, '2019-05-20', 195, NULL),
('Sheraton Centre', 171, '2019-05-21', 318, NULL),
('Sheraton Centre', 171, '2019-05-22', 226, NULL),
('Sheraton Centre', 171, '2019-05-23', 124, NULL),
('Sheraton Centre', 171, '2019-05-24', 324, NULL),
('Sheraton Centre', 171, '2019-05-25', 299, NULL),
('Sheraton Centre', 171, '2019-05-26', 326, NULL),
('Sheraton Centre', 171, '2019-05-27', 155, NULL),
('Sheraton Centre', 171, '2019-05-28', 277, NULL),
('Sheraton Centre', 171, '2019-05-29', 160, NULL),
('Sheraton Centre', 171, '2019-05-30', 158, NULL),
('Sheraton Centre', 171, '2019-05-31', 313, NULL),
('Sheraton Centre', 171, '2019-06-01', 157, NULL),
('Sheraton Centre', 171, '2019-06-02', 194, NULL),
('Sheraton Centre', 171, '2019-06-03', 288, NULL),
('Sheraton Centre', 171, '2019-06-04', 153, NULL),
('Sheraton Centre', 171, '2019-06-05', 183, NULL),
('Sheraton Centre', 171, '2019-06-06', 181, NULL),
('Sheraton Centre', 171, '2019-06-07', 385, NULL),
('Sheraton Centre', 171, '2019-06-08', 170, NULL),
('Sheraton Centre', 171, '2019-06-09', 125, NULL),
('Sheraton Centre', 171, '2019-06-10', 274, NULL),
('Sheraton Centre', 171, '2019-06-11', 257, NULL),
('Sheraton Centre', 171, '2019-06-12', 390, NULL),
('Sheraton Centre', 171, '2019-06-13', 240, NULL),
('Sheraton Centre', 171, '2019-06-14', 361, NULL),
('Sheraton Centre', 171, '2019-06-15', 199, NULL),
('Sheraton Centre', 171, '2019-06-16', 264, NULL),
('Sheraton Centre', 171, '2019-06-17', 250, NULL),
('Sheraton Centre', 171, '2019-06-18', 124, NULL),
('Sheraton Centre', 171, '2019-06-19', 212, NULL),
('Sheraton Centre', 171, '2019-06-20', 282, NULL),
('Sheraton Centre', 171, '2019-06-21', 170, NULL),
('Sheraton Centre', 171, '2019-06-22', 302, NULL),
('Sheraton Centre', 171, '2019-06-23', 213, NULL),
('Sheraton Centre', 171, '2019-06-24', 119, NULL),
('Sheraton Centre', 171, '2019-06-25', 325, NULL),
('Sheraton Centre', 171, '2019-06-26', 327, NULL),
('Sheraton Centre', 171, '2019-06-27', 370, NULL),
('Sheraton Centre', 171, '2019-06-28', 183, NULL),
('Sheraton Centre', 171, '2019-06-29', 163, NULL),
('Sheraton Centre', 171, '2019-06-30', 106, NULL),
('Sheraton Centre', 171, '2019-07-01', 192, NULL),
('Sheraton Centre', 171, '2019-07-02', 361, NULL),
('Sheraton Centre', 171, '2019-07-03', 169, NULL),
('Sheraton Centre', 171, '2019-07-04', 269, NULL),
('Sheraton Centre', 171, '2019-07-05', 310, NULL),
('Sheraton Centre', 171, '2019-07-06', 106, NULL),
('Sheraton Centre', 171, '2019-07-07', 232, NULL),
('Sheraton Centre', 171, '2019-07-08', 231, NULL),
('Sheraton Centre', 171, '2019-07-09', 387, NULL),
('Sheraton Centre', 171, '2019-07-10', 225, NULL),
('Sheraton Centre', 171, '2019-07-11', 225, NULL),
('Sheraton Centre', 171, '2019-07-12', 270, NULL),
('Sheraton Centre', 171, '2019-07-13', 254, NULL),
('Sheraton Centre', 171, '2019-07-14', 253, NULL),
('Sheraton Centre', 171, '2019-07-15', 104, NULL),
('Sheraton Centre', 171, '2019-07-16', 152, NULL),
('Sheraton Centre', 171, '2019-07-17', 306, NULL),
('Sheraton Centre', 171, '2019-07-18', 363, NULL),
('Sheraton Centre', 171, '2019-07-19', 240, NULL),
('Sheraton Centre', 171, '2019-07-20', 391, NULL),
('Sheraton Centre', 171, '2019-07-21', 327, NULL),
('Sheraton Centre', 171, '2019-07-22', 321, NULL),
('Sheraton Centre', 171, '2019-07-23', 155, NULL),
('Sheraton Centre', 171, '2019-07-24', 196, NULL),
('Sheraton Centre', 171, '2019-07-25', 215, NULL),
('Sheraton Centre', 171, '2019-07-26', 139, NULL),
('Sheraton Centre', 171, '2019-07-27', 171, NULL),
('Sheraton Centre', 171, '2019-07-28', 143, NULL),
('Sheraton Centre', 171, '2019-07-29', 373, NULL),
('Sheraton Centre', 171, '2019-07-30', 336, NULL),
('Sheraton Centre', 171, '2019-07-31', 113, NULL),
('Sheraton Centre', 171, '2019-08-01', 350, NULL),
('Sheraton Centre', 171, '2019-08-02', 249, NULL),
('Sheraton Centre', 171, '2019-08-03', 248, NULL),
('Sheraton Centre', 171, '2019-08-04', 152, NULL),
('Sheraton Centre', 171, '2019-08-05', 152, NULL),
('Sheraton Centre', 171, '2019-08-06', 267, NULL),
('Sheraton Centre', 171, '2019-08-07', 286, NULL),
('Sheraton Centre', 171, '2019-08-08', 240, NULL),
('Sheraton Centre', 171, '2019-08-09', 377, NULL),
('Sheraton Centre', 171, '2019-08-10', 216, NULL),
('Sheraton Centre', 171, '2019-08-11', 115, NULL),
('Sheraton Centre', 171, '2019-08-12', 149, NULL),
('Sheraton Centre', 171, '2019-08-13', 370, NULL),
('Sheraton Centre', 171, '2019-08-14', 290, NULL),
('Sheraton Centre', 171, '2019-08-15', 337, NULL),
('Sheraton Centre', 171, '2019-08-16', 361, NULL),
('Sheraton Centre', 171, '2019-08-17', 117, NULL),
('Sheraton Centre', 171, '2019-08-18', 356, NULL),
('Sheraton Centre', 171, '2019-08-19', 321, NULL),
('Sheraton Centre', 171, '2019-08-20', 213, NULL),
('Sheraton Centre', 171, '2019-08-21', 263, NULL),
('Sheraton Centre', 171, '2019-08-22', 308, NULL),
('Sheraton Centre', 171, '2019-08-23', 117, NULL),
('Sheraton Centre', 171, '2019-08-24', 267, NULL),
('Sheraton Centre', 171, '2019-08-25', 285, NULL),
('Sheraton Centre', 171, '2019-08-26', 286, NULL),
('Sheraton Centre', 171, '2019-08-27', 154, NULL),
('Sheraton Centre', 171, '2019-08-28', 364, NULL),
('Sheraton Centre', 171, '2019-08-29', 230, NULL),
('Sheraton Centre', 171, '2019-08-30', 153, NULL),
('Sheraton Centre', 171, '2019-08-31', 221, NULL),
('Sheraton Centre', 171, '2019-09-01', 391, NULL),
('Sheraton Centre', 171, '2019-09-02', 128, NULL),
('Sheraton Centre', 171, '2019-09-03', 222, NULL),
('Sheraton Centre', 171, '2019-09-04', 269, NULL),
('Sheraton Centre', 171, '2019-09-05', 324, NULL),
('Sheraton Centre', 171, '2019-09-06', 221, NULL),
('Sheraton Centre', 171, '2019-09-07', 200, NULL),
('Sheraton Centre', 171, '2019-09-08', 204, NULL),
('Sheraton Centre', 171, '2019-09-09', 341, NULL),
('Sheraton Centre', 171, '2019-09-10', 384, NULL),
('Sheraton Centre', 171, '2019-09-11', 282, NULL),
('Sheraton Centre', 171, '2019-09-12', 346, NULL),
('Sheraton Centre', 171, '2019-09-13', 320, NULL),
('Sheraton Centre', 171, '2019-09-14', 225, NULL),
('Sheraton Centre', 171, '2019-09-15', 241, NULL),
('Sheraton Centre', 171, '2019-09-16', 392, NULL),
('Sheraton Centre', 171, '2019-09-17', 153, NULL),
('Sheraton Centre', 171, '2019-09-18', 121, NULL),
('Sheraton Centre', 171, '2019-09-19', 247, NULL),
('Sheraton Centre', 171, '2019-09-20', 126, NULL),
('Sheraton Centre', 171, '2019-09-21', 359, NULL),
('Sheraton Centre', 171, '2019-09-22', 287, NULL),
('Sheraton Centre', 171, '2019-09-23', 105, NULL),
('Sheraton Centre', 171, '2019-09-24', 154, NULL),
('Sheraton Centre', 171, '2019-09-25', 113, NULL),
('Sheraton Centre', 171, '2019-09-26', 382, NULL),
('Sheraton Centre', 171, '2019-09-27', 269, NULL),
('Sheraton Centre', 171, '2019-09-28', 146, NULL),
('Sheraton Centre', 171, '2019-09-29', 350, NULL),
('Sheraton Centre', 171, '2019-09-30', 305, NULL),
('Sheraton Centre', 171, '2019-10-01', 105, NULL),
('Sheraton Centre', 171, '2019-10-02', 112, NULL),
('Sheraton Centre', 171, '2019-10-03', 219, NULL),
('Sheraton Centre', 171, '2019-10-04', 172, NULL),
('Sheraton Centre', 171, '2019-10-05', 195, NULL),
('Sheraton Centre', 171, '2019-10-06', 388, NULL),
('Sheraton Centre', 171, '2019-10-07', 255, NULL),
('Sheraton Centre', 171, '2019-10-08', 341, NULL),
('Sheraton Centre', 171, '2019-10-09', 319, NULL),
('Sheraton Centre', 171, '2019-10-10', 309, NULL),
('Sheraton Centre', 171, '2019-10-11', 155, NULL),
('Sheraton Centre', 171, '2019-10-12', 109, NULL),
('Sheraton Centre', 171, '2019-10-13', 272, NULL),
('Sheraton Centre', 171, '2019-10-14', 104, NULL),
('Sheraton Centre', 171, '2019-10-15', 395, NULL),
('Sheraton Centre', 171, '2019-10-16', 120, NULL),
('Sheraton Centre', 171, '2019-10-17', 166, NULL),
('Sheraton Centre', 171, '2019-10-18', 305, NULL),
('Sheraton Centre', 171, '2019-10-19', 322, NULL),
('Sheraton Centre', 171, '2019-10-20', 299, NULL),
('Sheraton Centre', 171, '2019-10-21', 381, NULL),
('Sheraton Centre', 171, '2019-10-22', 398, NULL),
('Sheraton Centre', 171, '2019-10-23', 334, NULL),
('Sheraton Centre', 171, '2019-10-24', 372, NULL),
('Sheraton Centre', 171, '2019-10-25', 317, NULL),
('Sheraton Centre', 171, '2019-10-26', 372, NULL),
('Sheraton Centre', 171, '2019-10-27', 195, NULL),
('Sheraton Centre', 171, '2019-10-28', 113, NULL),
('Sheraton Centre', 171, '2019-10-29', 100, NULL),
('Sheraton Centre', 171, '2019-10-30', 270, NULL),
('Sheraton Centre', 171, '2019-10-31', 300, NULL),
('Sheraton Centre', 171, '2019-11-01', 372, NULL),
('Sheraton Centre', 171, '2019-11-02', 174, NULL),
('Sheraton Centre', 171, '2019-11-03', 139, NULL),
('Sheraton Centre', 171, '2019-11-04', 246, NULL),
('Sheraton Centre', 171, '2019-11-05', 242, NULL),
('Sheraton Centre', 171, '2019-11-06', 182, NULL),
('Sheraton Centre', 171, '2019-11-07', 264, NULL),
('Sheraton Centre', 171, '2019-11-08', 261, NULL),
('Sheraton Centre', 171, '2019-11-09', 183, NULL),
('Sheraton Centre', 171, '2019-11-10', 312, NULL),
('Sheraton Centre', 171, '2019-11-11', 146, NULL),
('Sheraton Centre', 171, '2019-11-12', 333, NULL),
('Sheraton Centre', 171, '2019-11-13', 360, NULL),
('Sheraton Centre', 171, '2019-11-14', 325, NULL),
('Sheraton Centre', 171, '2019-11-15', 320, NULL),
('Sheraton Centre', 171, '2019-11-16', 126, NULL),
('Sheraton Centre', 171, '2019-11-17', 254, NULL),
('Sheraton Centre', 171, '2019-11-18', 194, NULL),
('Sheraton Centre', 171, '2019-11-19', 342, NULL),
('Sheraton Centre', 171, '2019-11-20', 376, NULL),
('Sheraton Centre', 171, '2019-11-21', 212, NULL),
('Sheraton Centre', 171, '2019-11-22', 237, NULL),
('Sheraton Centre', 171, '2019-11-23', 246, NULL),
('Sheraton Centre', 171, '2019-11-24', 133, NULL),
('Sheraton Centre', 171, '2019-11-25', 374, NULL),
('Sheraton Centre', 171, '2019-11-26', 155, NULL),
('Sheraton Centre', 171, '2019-11-27', 383, NULL),
('Sheraton Centre', 171, '2019-11-28', 129, NULL),
('Sheraton Centre', 171, '2019-11-29', 160, NULL),
('Sheraton Centre', 171, '2019-11-30', 119, NULL),
('Sheraton Centre', 171, '2019-12-01', 147, NULL),
('Sheraton Centre', 171, '2019-12-02', 135, NULL),
('Sheraton Centre', 171, '2019-12-03', 132, NULL),
('Sheraton Centre', 171, '2019-12-04', 341, NULL),
('Sheraton Centre', 171, '2019-12-05', 184, NULL),
('Sheraton Centre', 171, '2019-12-06', 133, NULL),
('Sheraton Centre', 171, '2019-12-07', 369, NULL),
('Sheraton Centre', 171, '2019-12-08', 342, NULL),
('Sheraton Centre', 171, '2019-12-09', 399, NULL),
('Sheraton Centre', 171, '2019-12-10', 306, NULL),
('Sheraton Centre', 171, '2019-12-11', 105, NULL),
('Sheraton Centre', 171, '2019-12-12', 126, NULL),
('Sheraton Centre', 171, '2019-12-13', 395, NULL),
('Sheraton Centre', 171, '2019-12-14', 164, NULL),
('Sheraton Centre', 171, '2019-12-15', 360, NULL),
('Sheraton Centre', 171, '2019-12-16', 118, NULL),
('Sheraton Centre', 171, '2019-12-17', 324, NULL),
('Sheraton Centre', 171, '2019-12-18', 242, NULL),
('Sheraton Centre', 171, '2019-12-19', 171, NULL),
('Sheraton Centre', 171, '2019-12-20', 176, NULL),
('Sheraton Centre', 171, '2019-12-21', 107, NULL),
('Sheraton Centre', 171, '2019-12-22', 248, NULL),
('Sheraton Centre', 171, '2019-12-23', 101, NULL),
('Sheraton Centre', 171, '2019-12-24', 115, NULL),
('Sheraton Centre', 171, '2019-12-25', 357, NULL),
('Sheraton Centre', 171, '2019-12-26', 246, NULL),
('Sheraton Centre', 171, '2019-12-27', 129, NULL),
('Sheraton Centre', 171, '2019-12-28', 242, NULL),
('Sheraton Centre', 171, '2019-12-29', 265, NULL),
('Sheraton Centre', 171, '2019-12-30', 237, NULL),
('Sheraton Centre', 171, '2019-12-31', 336, NULL),
('Sheraton Centre', 171, '2020-01-01', 272, NULL),
('Sheraton Centre', 171, '2020-01-02', 374, NULL),
('Sheraton Centre', 171, '2020-01-03', 110, NULL),
('Sheraton Centre', 171, '2020-01-04', 116, NULL),
('Sheraton Centre', 171, '2020-01-05', 317, NULL),
('Sheraton Centre', 171, '2020-01-06', 134, NULL),
('Sheraton Centre', 171, '2020-01-07', 197, NULL),
('Sheraton Centre', 171, '2020-01-08', 114, NULL),
('Sheraton Centre', 171, '2020-01-09', 177, NULL),
('Sheraton Centre', 171, '2020-01-10', 368, NULL),
('Sheraton Centre', 171, '2020-01-11', 123, NULL),
('Sheraton Centre', 171, '2020-01-12', 258, NULL),
('Sheraton Centre', 171, '2020-01-13', 383, NULL),
('Sheraton Centre', 171, '2020-01-14', 300, NULL),
('Sheraton Centre', 171, '2020-01-15', 109, NULL),
('Sheraton Centre', 171, '2020-01-16', 189, NULL),
('Sheraton Centre', 171, '2020-01-17', 141, NULL),
('Sheraton Centre', 171, '2020-01-18', 314, NULL),
('Sheraton Centre', 171, '2020-01-19', 267, NULL),
('Sheraton Centre', 171, '2020-01-20', 399, NULL),
('Sheraton Centre', 171, '2020-01-21', 212, NULL),
('Sheraton Centre', 171, '2020-01-22', 219, NULL),
('Sheraton Centre', 171, '2020-01-23', 241, NULL),
('Sheraton Centre', 171, '2020-01-24', 335, NULL),
('Sheraton Centre', 171, '2020-01-25', 111, NULL),
('Sheraton Centre', 171, '2020-01-26', 302, NULL),
('Sheraton Centre', 171, '2020-01-27', 136, NULL),
('Sheraton Centre', 171, '2020-01-28', 210, NULL),
('Sheraton Centre', 171, '2020-01-29', 393, NULL),
('Sheraton Centre', 171, '2020-01-30', 228, NULL),
('Sheraton Centre', 171, '2020-01-31', 278, NULL),
('Sheraton Centre', 171, '2020-02-01', 305, NULL),
('Sheraton Centre', 171, '2020-02-02', 312, NULL),
('Sheraton Centre', 171, '2020-02-03', 218, NULL),
('Sheraton Centre', 171, '2020-02-04', 325, NULL),
('Sheraton Centre', 172, '2019-01-01', 321, NULL),
('Sheraton Centre', 172, '2019-01-02', 247, NULL),
('Sheraton Centre', 172, '2019-01-03', 117, NULL),
('Sheraton Centre', 172, '2019-01-04', 382, NULL),
('Sheraton Centre', 172, '2019-01-05', 307, NULL),
('Sheraton Centre', 172, '2019-01-06', 115, NULL),
('Sheraton Centre', 172, '2019-01-07', 161, NULL),
('Sheraton Centre', 172, '2019-01-08', 189, NULL),
('Sheraton Centre', 172, '2019-01-09', 128, NULL),
('Sheraton Centre', 172, '2019-01-10', 107, NULL),
('Sheraton Centre', 172, '2019-01-11', 179, NULL),
('Sheraton Centre', 172, '2019-01-12', 162, NULL),
('Sheraton Centre', 172, '2019-01-13', 259, NULL),
('Sheraton Centre', 172, '2019-01-14', 324, NULL),
('Sheraton Centre', 172, '2019-01-15', 197, NULL),
('Sheraton Centre', 172, '2019-01-16', 206, NULL),
('Sheraton Centre', 172, '2019-01-17', 360, NULL),
('Sheraton Centre', 172, '2019-01-18', 329, NULL),
('Sheraton Centre', 172, '2019-01-19', 284, NULL),
('Sheraton Centre', 172, '2019-01-20', 277, NULL),
('Sheraton Centre', 172, '2019-01-21', 205, NULL),
('Sheraton Centre', 172, '2019-01-22', 289, NULL),
('Sheraton Centre', 172, '2019-01-23', 277, NULL),
('Sheraton Centre', 172, '2019-01-24', 218, NULL),
('Sheraton Centre', 172, '2019-01-25', 335, NULL),
('Sheraton Centre', 172, '2019-01-26', 260, NULL),
('Sheraton Centre', 172, '2019-01-27', 310, NULL),
('Sheraton Centre', 172, '2019-01-28', 381, NULL),
('Sheraton Centre', 172, '2019-01-29', 219, NULL),
('Sheraton Centre', 172, '2019-01-30', 353, NULL),
('Sheraton Centre', 172, '2019-01-31', 323, NULL),
('Sheraton Centre', 172, '2019-02-01', 351, NULL),
('Sheraton Centre', 172, '2019-02-02', 394, NULL),
('Sheraton Centre', 172, '2019-02-03', 373, NULL),
('Sheraton Centre', 172, '2019-02-04', 387, NULL),
('Sheraton Centre', 172, '2019-02-05', 338, NULL),
('Sheraton Centre', 172, '2019-02-06', 196, NULL),
('Sheraton Centre', 172, '2019-02-07', 290, NULL),
('Sheraton Centre', 172, '2019-02-08', 293, NULL),
('Sheraton Centre', 172, '2019-02-09', 154, NULL),
('Sheraton Centre', 172, '2019-02-10', 365, NULL),
('Sheraton Centre', 172, '2019-02-11', 342, NULL),
('Sheraton Centre', 172, '2019-02-12', 215, NULL),
('Sheraton Centre', 172, '2019-02-13', 366, NULL),
('Sheraton Centre', 172, '2019-02-14', 185, NULL),
('Sheraton Centre', 172, '2019-02-15', 226, NULL),
('Sheraton Centre', 172, '2019-02-16', 341, NULL),
('Sheraton Centre', 172, '2019-02-17', 396, NULL),
('Sheraton Centre', 172, '2019-02-18', 206, NULL),
('Sheraton Centre', 172, '2019-02-19', 193, NULL),
('Sheraton Centre', 172, '2019-02-20', 201, NULL),
('Sheraton Centre', 172, '2019-02-21', 213, NULL),
('Sheraton Centre', 172, '2019-02-22', 102, NULL),
('Sheraton Centre', 172, '2019-02-23', 320, NULL),
('Sheraton Centre', 172, '2019-02-24', 216, NULL),
('Sheraton Centre', 172, '2019-02-25', 123, NULL),
('Sheraton Centre', 172, '2019-02-26', 214, NULL),
('Sheraton Centre', 172, '2019-02-27', 157, NULL),
('Sheraton Centre', 172, '2019-02-28', 181, NULL),
('Sheraton Centre', 172, '2019-03-01', 161, NULL),
('Sheraton Centre', 172, '2019-03-02', 116, NULL),
('Sheraton Centre', 172, '2019-03-03', 259, NULL),
('Sheraton Centre', 172, '2019-03-04', 177, NULL),
('Sheraton Centre', 172, '2019-03-05', 268, NULL),
('Sheraton Centre', 172, '2019-03-06', 378, NULL),
('Sheraton Centre', 172, '2019-03-07', 391, NULL),
('Sheraton Centre', 172, '2019-03-08', 185, NULL),
('Sheraton Centre', 172, '2019-03-09', 180, NULL),
('Sheraton Centre', 172, '2019-03-10', 168, NULL),
('Sheraton Centre', 172, '2019-03-11', 306, NULL),
('Sheraton Centre', 172, '2019-03-12', 234, NULL),
('Sheraton Centre', 172, '2019-03-13', 113, NULL),
('Sheraton Centre', 172, '2019-03-14', 214, NULL),
('Sheraton Centre', 172, '2019-03-15', 341, NULL),
('Sheraton Centre', 172, '2019-03-16', 377, NULL),
('Sheraton Centre', 172, '2019-03-17', 178, NULL),
('Sheraton Centre', 172, '2019-03-18', 264, NULL),
('Sheraton Centre', 172, '2019-03-19', 300, NULL),
('Sheraton Centre', 172, '2019-03-20', 339, NULL),
('Sheraton Centre', 172, '2019-03-21', 227, NULL),
('Sheraton Centre', 172, '2019-03-22', 304, NULL),
('Sheraton Centre', 172, '2019-03-23', 317, NULL),
('Sheraton Centre', 172, '2019-03-24', 193, NULL),
('Sheraton Centre', 172, '2019-03-25', 206, NULL),
('Sheraton Centre', 172, '2019-03-26', 234, NULL),
('Sheraton Centre', 172, '2019-03-27', 398, NULL),
('Sheraton Centre', 172, '2019-03-28', 277, NULL),
('Sheraton Centre', 172, '2019-03-29', 192, NULL),
('Sheraton Centre', 172, '2019-03-30', 206, NULL),
('Sheraton Centre', 172, '2019-03-31', 222, NULL),
('Sheraton Centre', 172, '2019-04-01', 282, NULL),
('Sheraton Centre', 172, '2019-04-02', 110, NULL),
('Sheraton Centre', 172, '2019-04-03', 297, NULL),
('Sheraton Centre', 172, '2019-04-04', 160, NULL),
('Sheraton Centre', 172, '2019-04-05', 322, NULL),
('Sheraton Centre', 172, '2019-04-06', 173, NULL),
('Sheraton Centre', 172, '2019-04-07', 231, NULL),
('Sheraton Centre', 172, '2019-04-08', 241, NULL),
('Sheraton Centre', 172, '2019-04-09', 332, NULL),
('Sheraton Centre', 172, '2019-04-10', 248, NULL),
('Sheraton Centre', 172, '2019-04-11', 176, NULL),
('Sheraton Centre', 172, '2019-04-12', 126, NULL),
('Sheraton Centre', 172, '2019-04-13', 161, NULL),
('Sheraton Centre', 172, '2019-04-14', 386, NULL),
('Sheraton Centre', 172, '2019-04-15', 250, NULL),
('Sheraton Centre', 172, '2019-04-16', 246, NULL),
('Sheraton Centre', 172, '2019-04-17', 293, NULL),
('Sheraton Centre', 172, '2019-04-18', 137, NULL),
('Sheraton Centre', 172, '2019-04-19', 281, NULL),
('Sheraton Centre', 172, '2019-04-20', 105, NULL),
('Sheraton Centre', 172, '2019-04-21', 143, NULL),
('Sheraton Centre', 172, '2019-04-22', 349, NULL),
('Sheraton Centre', 172, '2019-04-23', 257, NULL),
('Sheraton Centre', 172, '2019-04-24', 232, NULL),
('Sheraton Centre', 172, '2019-04-25', 313, NULL),
('Sheraton Centre', 172, '2019-04-26', 113, NULL),
('Sheraton Centre', 172, '2019-04-27', 201, NULL),
('Sheraton Centre', 172, '2019-04-28', 327, NULL),
('Sheraton Centre', 172, '2019-04-29', 212, NULL),
('Sheraton Centre', 172, '2019-04-30', 337, NULL),
('Sheraton Centre', 172, '2019-05-01', 121, NULL),
('Sheraton Centre', 172, '2019-05-02', 265, NULL),
('Sheraton Centre', 172, '2019-05-03', 107, NULL),
('Sheraton Centre', 172, '2019-05-04', 127, NULL),
('Sheraton Centre', 172, '2019-05-05', 164, NULL),
('Sheraton Centre', 172, '2019-05-06', 333, NULL),
('Sheraton Centre', 172, '2019-05-07', 240, NULL),
('Sheraton Centre', 172, '2019-05-08', 241, NULL),
('Sheraton Centre', 172, '2019-05-09', 201, NULL),
('Sheraton Centre', 172, '2019-05-10', 240, NULL),
('Sheraton Centre', 172, '2019-05-11', 263, NULL),
('Sheraton Centre', 172, '2019-05-12', 199, NULL),
('Sheraton Centre', 172, '2019-05-13', 394, NULL),
('Sheraton Centre', 172, '2019-05-14', 202, NULL),
('Sheraton Centre', 172, '2019-05-15', 173, NULL),
('Sheraton Centre', 172, '2019-05-16', 179, NULL),
('Sheraton Centre', 172, '2019-05-17', 336, NULL),
('Sheraton Centre', 172, '2019-05-18', 107, NULL),
('Sheraton Centre', 172, '2019-05-19', 308, NULL),
('Sheraton Centre', 172, '2019-05-20', 391, NULL),
('Sheraton Centre', 172, '2019-05-21', 142, NULL),
('Sheraton Centre', 172, '2019-05-22', 300, NULL),
('Sheraton Centre', 172, '2019-05-23', 144, NULL),
('Sheraton Centre', 172, '2019-05-24', 262, NULL),
('Sheraton Centre', 172, '2019-05-25', 129, NULL),
('Sheraton Centre', 172, '2019-05-26', 294, NULL),
('Sheraton Centre', 172, '2019-05-27', 202, NULL),
('Sheraton Centre', 172, '2019-05-28', 119, NULL),
('Sheraton Centre', 172, '2019-05-29', 254, NULL),
('Sheraton Centre', 172, '2019-05-30', 217, NULL),
('Sheraton Centre', 172, '2019-05-31', 115, NULL),
('Sheraton Centre', 172, '2019-06-01', 369, NULL),
('Sheraton Centre', 172, '2019-06-02', 298, NULL),
('Sheraton Centre', 172, '2019-06-03', 319, NULL),
('Sheraton Centre', 172, '2019-06-04', 202, NULL),
('Sheraton Centre', 172, '2019-06-05', 112, NULL),
('Sheraton Centre', 172, '2019-06-06', 215, NULL),
('Sheraton Centre', 172, '2019-06-07', 265, NULL),
('Sheraton Centre', 172, '2019-06-08', 131, NULL),
('Sheraton Centre', 172, '2019-06-09', 103, NULL),
('Sheraton Centre', 172, '2019-06-10', 125, NULL),
('Sheraton Centre', 172, '2019-06-11', 185, NULL),
('Sheraton Centre', 172, '2019-06-12', 234, NULL),
('Sheraton Centre', 172, '2019-06-13', 366, NULL),
('Sheraton Centre', 172, '2019-06-14', 129, NULL),
('Sheraton Centre', 172, '2019-06-15', 170, NULL),
('Sheraton Centre', 172, '2019-06-16', 116, NULL),
('Sheraton Centre', 172, '2019-06-17', 191, NULL),
('Sheraton Centre', 172, '2019-06-18', 120, NULL),
('Sheraton Centre', 172, '2019-06-19', 397, NULL),
('Sheraton Centre', 172, '2019-06-20', 254, NULL),
('Sheraton Centre', 172, '2019-06-21', 190, NULL),
('Sheraton Centre', 172, '2019-06-22', 363, NULL),
('Sheraton Centre', 172, '2019-06-23', 341, NULL),
('Sheraton Centre', 172, '2019-06-24', 266, NULL),
('Sheraton Centre', 172, '2019-06-25', 248, NULL),
('Sheraton Centre', 172, '2019-06-26', 367, NULL),
('Sheraton Centre', 172, '2019-06-27', 329, NULL),
('Sheraton Centre', 172, '2019-06-28', 329, NULL),
('Sheraton Centre', 172, '2019-06-29', 214, NULL),
('Sheraton Centre', 172, '2019-06-30', 384, NULL),
('Sheraton Centre', 172, '2019-07-01', 318, NULL),
('Sheraton Centre', 172, '2019-07-02', 388, NULL),
('Sheraton Centre', 172, '2019-07-03', 302, NULL),
('Sheraton Centre', 172, '2019-07-04', 359, NULL),
('Sheraton Centre', 172, '2019-07-05', 285, NULL),
('Sheraton Centre', 172, '2019-07-06', 153, NULL),
('Sheraton Centre', 172, '2019-07-07', 196, NULL),
('Sheraton Centre', 172, '2019-07-08', 124, NULL),
('Sheraton Centre', 172, '2019-07-09', 150, NULL),
('Sheraton Centre', 172, '2019-07-10', 266, NULL),
('Sheraton Centre', 172, '2019-07-11', 201, NULL),
('Sheraton Centre', 172, '2019-07-12', 135, NULL),
('Sheraton Centre', 172, '2019-07-13', 388, NULL),
('Sheraton Centre', 172, '2019-07-14', 262, NULL),
('Sheraton Centre', 172, '2019-07-15', 317, NULL),
('Sheraton Centre', 172, '2019-07-16', 393, NULL),
('Sheraton Centre', 172, '2019-07-17', 252, NULL),
('Sheraton Centre', 172, '2019-07-18', 100, NULL),
('Sheraton Centre', 172, '2019-07-19', 395, NULL),
('Sheraton Centre', 172, '2019-07-20', 155, NULL),
('Sheraton Centre', 172, '2019-07-21', 215, NULL),
('Sheraton Centre', 172, '2019-07-22', 332, NULL),
('Sheraton Centre', 172, '2019-07-23', 163, NULL),
('Sheraton Centre', 172, '2019-07-24', 137, NULL),
('Sheraton Centre', 172, '2019-07-25', 248, NULL),
('Sheraton Centre', 172, '2019-07-26', 107, NULL),
('Sheraton Centre', 172, '2019-07-27', 223, NULL),
('Sheraton Centre', 172, '2019-07-28', 146, NULL),
('Sheraton Centre', 172, '2019-07-29', 270, NULL),
('Sheraton Centre', 172, '2019-07-30', 148, NULL),
('Sheraton Centre', 172, '2019-07-31', 342, NULL),
('Sheraton Centre', 172, '2019-08-01', 185, NULL),
('Sheraton Centre', 172, '2019-08-02', 115, NULL),
('Sheraton Centre', 172, '2019-08-03', 282, NULL),
('Sheraton Centre', 172, '2019-08-04', 140, NULL),
('Sheraton Centre', 172, '2019-08-05', 140, NULL),
('Sheraton Centre', 172, '2019-08-06', 284, NULL),
('Sheraton Centre', 172, '2019-08-07', 348, NULL),
('Sheraton Centre', 172, '2019-08-08', 191, NULL),
('Sheraton Centre', 172, '2019-08-09', 350, NULL),
('Sheraton Centre', 172, '2019-08-10', 273, NULL),
('Sheraton Centre', 172, '2019-08-11', 105, NULL),
('Sheraton Centre', 172, '2019-08-12', 330, NULL),
('Sheraton Centre', 172, '2019-08-13', 376, NULL),
('Sheraton Centre', 172, '2019-08-14', 254, NULL),
('Sheraton Centre', 172, '2019-08-15', 334, NULL),
('Sheraton Centre', 172, '2019-08-16', 226, NULL),
('Sheraton Centre', 172, '2019-08-17', 216, NULL),
('Sheraton Centre', 172, '2019-08-18', 229, NULL),
('Sheraton Centre', 172, '2019-08-19', 241, NULL),
('Sheraton Centre', 172, '2019-08-20', 289, NULL),
('Sheraton Centre', 172, '2019-08-21', 155, NULL),
('Sheraton Centre', 172, '2019-08-22', 129, NULL),
('Sheraton Centre', 172, '2019-08-23', 125, NULL),
('Sheraton Centre', 172, '2019-08-24', 349, NULL),
('Sheraton Centre', 172, '2019-08-25', 337, NULL),
('Sheraton Centre', 172, '2019-08-26', 217, NULL),
('Sheraton Centre', 172, '2019-08-27', 143, NULL),
('Sheraton Centre', 172, '2019-08-28', 211, NULL),
('Sheraton Centre', 172, '2019-08-29', 367, NULL),
('Sheraton Centre', 172, '2019-08-30', 250, NULL),
('Sheraton Centre', 172, '2019-08-31', 150, NULL),
('Sheraton Centre', 172, '2019-09-01', 113, NULL),
('Sheraton Centre', 172, '2019-09-02', 161, NULL),
('Sheraton Centre', 172, '2019-09-03', 212, NULL),
('Sheraton Centre', 172, '2019-09-04', 185, NULL),
('Sheraton Centre', 172, '2019-09-05', 318, NULL),
('Sheraton Centre', 172, '2019-09-06', 338, NULL),
('Sheraton Centre', 172, '2019-09-07', 295, NULL),
('Sheraton Centre', 172, '2019-09-08', 342, NULL),
('Sheraton Centre', 172, '2019-09-09', 220, NULL),
('Sheraton Centre', 172, '2019-09-10', 315, NULL),
('Sheraton Centre', 172, '2019-09-11', 363, NULL),
('Sheraton Centre', 172, '2019-09-12', 346, NULL),
('Sheraton Centre', 172, '2019-09-13', 194, NULL),
('Sheraton Centre', 172, '2019-09-14', 155, NULL),
('Sheraton Centre', 172, '2019-09-15', 133, NULL),
('Sheraton Centre', 172, '2019-09-16', 343, NULL),
('Sheraton Centre', 172, '2019-09-17', 291, NULL),
('Sheraton Centre', 172, '2019-09-18', 282, NULL),
('Sheraton Centre', 172, '2019-09-19', 373, NULL),
('Sheraton Centre', 172, '2019-09-20', 204, NULL),
('Sheraton Centre', 172, '2019-09-21', 297, NULL),
('Sheraton Centre', 172, '2019-09-22', 278, NULL),
('Sheraton Centre', 172, '2019-09-23', 288, NULL),
('Sheraton Centre', 172, '2019-09-24', 104, NULL),
('Sheraton Centre', 172, '2019-09-25', 160, NULL),
('Sheraton Centre', 172, '2019-09-26', 109, NULL),
('Sheraton Centre', 172, '2019-09-27', 354, NULL),
('Sheraton Centre', 172, '2019-09-28', 288, NULL),
('Sheraton Centre', 172, '2019-09-29', 381, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 172, '2019-09-30', 145, NULL),
('Sheraton Centre', 172, '2019-10-01', 159, NULL),
('Sheraton Centre', 172, '2019-10-02', 382, NULL),
('Sheraton Centre', 172, '2019-10-03', 164, NULL),
('Sheraton Centre', 172, '2019-10-04', 341, NULL),
('Sheraton Centre', 172, '2019-10-05', 322, NULL),
('Sheraton Centre', 172, '2019-10-06', 283, NULL),
('Sheraton Centre', 172, '2019-10-07', 270, NULL),
('Sheraton Centre', 172, '2019-10-08', 228, NULL),
('Sheraton Centre', 172, '2019-10-09', 398, NULL),
('Sheraton Centre', 172, '2019-10-10', 167, NULL),
('Sheraton Centre', 172, '2019-10-11', 254, NULL),
('Sheraton Centre', 172, '2019-10-12', 286, NULL),
('Sheraton Centre', 172, '2019-10-13', 201, NULL),
('Sheraton Centre', 172, '2019-10-14', 308, NULL),
('Sheraton Centre', 172, '2019-10-15', 109, NULL),
('Sheraton Centre', 172, '2019-10-16', 130, NULL),
('Sheraton Centre', 172, '2019-10-17', 270, NULL),
('Sheraton Centre', 172, '2019-10-18', 226, NULL),
('Sheraton Centre', 172, '2019-10-19', 123, NULL),
('Sheraton Centre', 172, '2019-10-20', 389, NULL),
('Sheraton Centre', 172, '2019-10-21', 191, NULL),
('Sheraton Centre', 172, '2019-10-22', 251, NULL),
('Sheraton Centre', 172, '2019-10-23', 119, NULL),
('Sheraton Centre', 172, '2019-10-24', 398, NULL),
('Sheraton Centre', 172, '2019-10-25', 331, NULL),
('Sheraton Centre', 172, '2019-10-26', 195, NULL),
('Sheraton Centre', 172, '2019-10-27', 191, NULL),
('Sheraton Centre', 172, '2019-10-28', 137, NULL),
('Sheraton Centre', 172, '2019-10-29', 268, NULL),
('Sheraton Centre', 172, '2019-10-30', 257, NULL),
('Sheraton Centre', 172, '2019-10-31', 233, NULL),
('Sheraton Centre', 172, '2019-11-01', 207, NULL),
('Sheraton Centre', 172, '2019-11-02', 225, NULL),
('Sheraton Centre', 172, '2019-11-03', 235, NULL),
('Sheraton Centre', 172, '2019-11-04', 208, NULL),
('Sheraton Centre', 172, '2019-11-05', 285, NULL),
('Sheraton Centre', 172, '2019-11-06', 361, NULL),
('Sheraton Centre', 172, '2019-11-07', 130, NULL),
('Sheraton Centre', 172, '2019-11-08', 213, NULL),
('Sheraton Centre', 172, '2019-11-09', 129, NULL),
('Sheraton Centre', 172, '2019-11-10', 313, NULL),
('Sheraton Centre', 172, '2019-11-11', 310, NULL),
('Sheraton Centre', 172, '2019-11-12', 165, NULL),
('Sheraton Centre', 172, '2019-11-13', 348, NULL),
('Sheraton Centre', 172, '2019-11-14', 224, NULL),
('Sheraton Centre', 172, '2019-11-15', 365, NULL),
('Sheraton Centre', 172, '2019-11-16', 190, NULL),
('Sheraton Centre', 172, '2019-11-17', 161, NULL),
('Sheraton Centre', 172, '2019-11-18', 338, NULL),
('Sheraton Centre', 172, '2019-11-19', 208, NULL),
('Sheraton Centre', 172, '2019-11-20', 352, NULL),
('Sheraton Centre', 172, '2019-11-21', 315, NULL),
('Sheraton Centre', 172, '2019-11-22', 109, NULL),
('Sheraton Centre', 172, '2019-11-23', 385, NULL),
('Sheraton Centre', 172, '2019-11-24', 330, NULL),
('Sheraton Centre', 172, '2019-11-25', 249, NULL),
('Sheraton Centre', 172, '2019-11-26', 341, NULL),
('Sheraton Centre', 172, '2019-11-27', 167, NULL),
('Sheraton Centre', 172, '2019-11-28', 299, NULL),
('Sheraton Centre', 172, '2019-11-29', 329, NULL),
('Sheraton Centre', 172, '2019-11-30', 304, NULL),
('Sheraton Centre', 172, '2019-12-01', 347, NULL),
('Sheraton Centre', 172, '2019-12-02', 386, NULL),
('Sheraton Centre', 172, '2019-12-03', 382, NULL),
('Sheraton Centre', 172, '2019-12-04', 318, NULL),
('Sheraton Centre', 172, '2019-12-05', 135, NULL),
('Sheraton Centre', 172, '2019-12-06', 139, NULL),
('Sheraton Centre', 172, '2019-12-07', 339, NULL),
('Sheraton Centre', 172, '2019-12-08', 237, NULL),
('Sheraton Centre', 172, '2019-12-09', 284, NULL),
('Sheraton Centre', 172, '2019-12-10', 289, NULL),
('Sheraton Centre', 172, '2019-12-11', 255, NULL),
('Sheraton Centre', 172, '2019-12-12', 112, NULL),
('Sheraton Centre', 172, '2019-12-13', 322, NULL),
('Sheraton Centre', 172, '2019-12-14', 173, NULL),
('Sheraton Centre', 172, '2019-12-15', 204, NULL),
('Sheraton Centre', 172, '2019-12-16', 202, NULL),
('Sheraton Centre', 172, '2019-12-17', 192, NULL),
('Sheraton Centre', 172, '2019-12-18', 181, NULL),
('Sheraton Centre', 172, '2019-12-19', 371, NULL),
('Sheraton Centre', 172, '2019-12-20', 196, NULL),
('Sheraton Centre', 172, '2019-12-21', 276, NULL),
('Sheraton Centre', 172, '2019-12-22', 320, NULL),
('Sheraton Centre', 172, '2019-12-23', 115, NULL),
('Sheraton Centre', 172, '2019-12-24', 135, NULL),
('Sheraton Centre', 172, '2019-12-25', 378, NULL),
('Sheraton Centre', 172, '2019-12-26', 133, NULL),
('Sheraton Centre', 172, '2019-12-27', 224, NULL),
('Sheraton Centre', 172, '2019-12-28', 203, NULL),
('Sheraton Centre', 172, '2019-12-29', 239, NULL),
('Sheraton Centre', 172, '2019-12-30', 329, NULL),
('Sheraton Centre', 172, '2019-12-31', 217, NULL),
('Sheraton Centre', 172, '2020-01-01', 148, NULL),
('Sheraton Centre', 172, '2020-01-02', 138, NULL),
('Sheraton Centre', 172, '2020-01-03', 166, NULL),
('Sheraton Centre', 172, '2020-01-04', 102, NULL),
('Sheraton Centre', 172, '2020-01-05', 106, NULL),
('Sheraton Centre', 172, '2020-01-06', 343, NULL),
('Sheraton Centre', 172, '2020-01-07', 283, NULL),
('Sheraton Centre', 172, '2020-01-08', 208, NULL),
('Sheraton Centre', 172, '2020-01-09', 185, NULL),
('Sheraton Centre', 172, '2020-01-10', 178, NULL),
('Sheraton Centre', 172, '2020-01-11', 174, NULL),
('Sheraton Centre', 172, '2020-01-12', 197, NULL),
('Sheraton Centre', 172, '2020-01-13', 225, NULL),
('Sheraton Centre', 172, '2020-01-14', 200, NULL),
('Sheraton Centre', 172, '2020-01-15', 305, NULL),
('Sheraton Centre', 172, '2020-01-16', 168, NULL),
('Sheraton Centre', 172, '2020-01-17', 223, NULL),
('Sheraton Centre', 172, '2020-01-18', 389, NULL),
('Sheraton Centre', 172, '2020-01-19', 386, NULL),
('Sheraton Centre', 172, '2020-01-20', 127, NULL),
('Sheraton Centre', 172, '2020-01-21', 381, NULL),
('Sheraton Centre', 172, '2020-01-22', 148, NULL),
('Sheraton Centre', 172, '2020-01-23', 257, NULL),
('Sheraton Centre', 172, '2020-01-24', 343, NULL),
('Sheraton Centre', 172, '2020-01-25', 311, NULL),
('Sheraton Centre', 172, '2020-01-26', 255, NULL),
('Sheraton Centre', 172, '2020-01-27', 302, NULL),
('Sheraton Centre', 172, '2020-01-28', 330, NULL),
('Sheraton Centre', 172, '2020-01-29', 102, NULL),
('Sheraton Centre', 172, '2020-01-30', 271, NULL),
('Sheraton Centre', 172, '2020-01-31', 343, NULL),
('Sheraton Centre', 172, '2020-02-01', 306, NULL),
('Sheraton Centre', 172, '2020-02-02', 102, NULL),
('Sheraton Centre', 172, '2020-02-03', 121, NULL),
('Sheraton Centre', 172, '2020-02-04', 133, NULL),
('Sheraton Centre', 182, '2019-01-01', 314, NULL),
('Sheraton Centre', 182, '2019-01-02', 152, NULL),
('Sheraton Centre', 182, '2019-01-03', 179, NULL),
('Sheraton Centre', 182, '2019-01-04', 231, NULL),
('Sheraton Centre', 182, '2019-01-05', 231, NULL),
('Sheraton Centre', 182, '2019-01-06', 207, NULL),
('Sheraton Centre', 182, '2019-01-07', 356, NULL),
('Sheraton Centre', 182, '2019-01-08', 282, NULL),
('Sheraton Centre', 182, '2019-01-09', 221, NULL),
('Sheraton Centre', 182, '2019-01-10', 171, NULL),
('Sheraton Centre', 182, '2019-01-11', 304, NULL),
('Sheraton Centre', 182, '2019-01-12', 350, NULL),
('Sheraton Centre', 182, '2019-01-13', 390, NULL),
('Sheraton Centre', 182, '2019-01-14', 288, NULL),
('Sheraton Centre', 182, '2019-01-15', 277, NULL),
('Sheraton Centre', 182, '2019-01-16', 333, NULL),
('Sheraton Centre', 182, '2019-01-17', 100, NULL),
('Sheraton Centre', 182, '2019-01-18', 148, NULL),
('Sheraton Centre', 182, '2019-01-19', 294, NULL),
('Sheraton Centre', 182, '2019-01-20', 380, NULL),
('Sheraton Centre', 182, '2019-01-21', 157, NULL),
('Sheraton Centre', 182, '2019-01-22', 119, NULL),
('Sheraton Centre', 182, '2019-01-23', 135, NULL),
('Sheraton Centre', 182, '2019-01-24', 208, NULL),
('Sheraton Centre', 182, '2019-01-25', 241, NULL),
('Sheraton Centre', 182, '2019-01-26', 153, NULL),
('Sheraton Centre', 182, '2019-01-27', 189, NULL),
('Sheraton Centre', 182, '2019-01-28', 297, NULL),
('Sheraton Centre', 182, '2019-01-29', 379, NULL),
('Sheraton Centre', 182, '2019-01-30', 383, NULL),
('Sheraton Centre', 182, '2019-01-31', 225, NULL),
('Sheraton Centre', 182, '2019-02-01', 282, NULL),
('Sheraton Centre', 182, '2019-02-02', 223, NULL),
('Sheraton Centre', 182, '2019-02-03', 172, NULL),
('Sheraton Centre', 182, '2019-02-04', 296, NULL),
('Sheraton Centre', 182, '2019-02-05', 153, NULL),
('Sheraton Centre', 182, '2019-02-06', 288, NULL),
('Sheraton Centre', 182, '2019-02-07', 203, NULL),
('Sheraton Centre', 182, '2019-02-08', 128, NULL),
('Sheraton Centre', 182, '2019-02-09', 190, NULL),
('Sheraton Centre', 182, '2019-02-10', 169, NULL),
('Sheraton Centre', 182, '2019-02-11', 192, NULL),
('Sheraton Centre', 182, '2019-02-12', 177, NULL),
('Sheraton Centre', 182, '2019-02-13', 267, NULL),
('Sheraton Centre', 182, '2019-02-14', 190, NULL),
('Sheraton Centre', 182, '2019-02-15', 258, NULL),
('Sheraton Centre', 182, '2019-02-16', 178, NULL),
('Sheraton Centre', 182, '2019-02-17', 339, NULL),
('Sheraton Centre', 182, '2019-02-18', 112, NULL),
('Sheraton Centre', 182, '2019-02-19', 361, NULL),
('Sheraton Centre', 182, '2019-02-20', 103, NULL),
('Sheraton Centre', 182, '2019-02-21', 148, NULL),
('Sheraton Centre', 182, '2019-02-22', 183, NULL),
('Sheraton Centre', 182, '2019-02-23', 119, NULL),
('Sheraton Centre', 182, '2019-02-24', 327, NULL),
('Sheraton Centre', 182, '2019-02-25', 309, NULL),
('Sheraton Centre', 182, '2019-02-26', 349, NULL),
('Sheraton Centre', 182, '2019-02-27', 357, NULL),
('Sheraton Centre', 182, '2019-02-28', 296, NULL),
('Sheraton Centre', 182, '2019-03-01', 231, NULL),
('Sheraton Centre', 182, '2019-03-02', 262, NULL),
('Sheraton Centre', 182, '2019-03-03', 263, NULL),
('Sheraton Centre', 182, '2019-03-04', 278, NULL),
('Sheraton Centre', 182, '2019-03-05', 369, NULL),
('Sheraton Centre', 182, '2019-03-06', 171, NULL),
('Sheraton Centre', 182, '2019-03-07', 104, NULL),
('Sheraton Centre', 182, '2019-03-08', 236, NULL),
('Sheraton Centre', 182, '2019-03-09', 380, NULL),
('Sheraton Centre', 182, '2019-03-10', 218, NULL),
('Sheraton Centre', 182, '2019-03-11', 245, NULL),
('Sheraton Centre', 182, '2019-03-12', 119, NULL),
('Sheraton Centre', 182, '2019-03-13', 331, NULL),
('Sheraton Centre', 182, '2019-03-14', 246, NULL),
('Sheraton Centre', 182, '2019-03-15', 389, NULL),
('Sheraton Centre', 182, '2019-03-16', 166, NULL),
('Sheraton Centre', 182, '2019-03-17', 261, NULL),
('Sheraton Centre', 182, '2019-03-18', 107, NULL),
('Sheraton Centre', 182, '2019-03-19', 285, NULL),
('Sheraton Centre', 182, '2019-03-20', 292, NULL),
('Sheraton Centre', 182, '2019-03-21', 256, NULL),
('Sheraton Centre', 182, '2019-03-22', 162, NULL),
('Sheraton Centre', 182, '2019-03-23', 356, NULL),
('Sheraton Centre', 182, '2019-03-24', 367, NULL),
('Sheraton Centre', 182, '2019-03-25', 208, NULL),
('Sheraton Centre', 182, '2019-03-26', 302, NULL),
('Sheraton Centre', 182, '2019-03-27', 373, NULL),
('Sheraton Centre', 182, '2019-03-28', 320, NULL),
('Sheraton Centre', 182, '2019-03-29', 330, NULL),
('Sheraton Centre', 182, '2019-03-30', 110, NULL),
('Sheraton Centre', 182, '2019-03-31', 101, NULL),
('Sheraton Centre', 182, '2019-04-01', 160, NULL),
('Sheraton Centre', 182, '2019-04-02', 217, NULL),
('Sheraton Centre', 182, '2019-04-03', 275, NULL),
('Sheraton Centre', 182, '2019-04-04', 254, NULL),
('Sheraton Centre', 182, '2019-04-05', 304, NULL),
('Sheraton Centre', 182, '2019-04-06', 100, NULL),
('Sheraton Centre', 182, '2019-04-07', 113, NULL),
('Sheraton Centre', 182, '2019-04-08', 368, NULL),
('Sheraton Centre', 182, '2019-04-09', 117, NULL),
('Sheraton Centre', 182, '2019-04-10', 367, NULL),
('Sheraton Centre', 182, '2019-04-11', 241, NULL),
('Sheraton Centre', 182, '2019-04-12', 376, NULL),
('Sheraton Centre', 182, '2019-04-13', 181, NULL),
('Sheraton Centre', 182, '2019-04-14', 109, NULL),
('Sheraton Centre', 182, '2019-04-15', 230, NULL),
('Sheraton Centre', 182, '2019-04-16', 217, NULL),
('Sheraton Centre', 182, '2019-04-17', 167, NULL),
('Sheraton Centre', 182, '2019-04-18', 146, NULL),
('Sheraton Centre', 182, '2019-04-19', 248, NULL),
('Sheraton Centre', 182, '2019-04-20', 358, NULL),
('Sheraton Centre', 182, '2019-04-21', 153, NULL),
('Sheraton Centre', 182, '2019-04-22', 370, NULL),
('Sheraton Centre', 182, '2019-04-23', 375, NULL),
('Sheraton Centre', 182, '2019-04-24', 253, NULL),
('Sheraton Centre', 182, '2019-04-25', 122, NULL),
('Sheraton Centre', 182, '2019-04-26', 170, NULL),
('Sheraton Centre', 182, '2019-04-27', 124, NULL),
('Sheraton Centre', 182, '2019-04-28', 183, NULL),
('Sheraton Centre', 182, '2019-04-29', 392, NULL),
('Sheraton Centre', 182, '2019-04-30', 328, NULL),
('Sheraton Centre', 182, '2019-05-01', 382, NULL),
('Sheraton Centre', 182, '2019-05-02', 117, NULL),
('Sheraton Centre', 182, '2019-05-03', 142, NULL),
('Sheraton Centre', 182, '2019-05-04', 274, NULL),
('Sheraton Centre', 182, '2019-05-05', 226, NULL),
('Sheraton Centre', 182, '2019-05-06', 188, NULL),
('Sheraton Centre', 182, '2019-05-07', 247, NULL),
('Sheraton Centre', 182, '2019-05-08', 152, NULL),
('Sheraton Centre', 182, '2019-05-09', 255, NULL),
('Sheraton Centre', 182, '2019-05-10', 171, NULL),
('Sheraton Centre', 182, '2019-05-11', 389, NULL),
('Sheraton Centre', 182, '2019-05-12', 113, NULL),
('Sheraton Centre', 182, '2019-05-13', 100, NULL),
('Sheraton Centre', 182, '2019-05-14', 100, NULL),
('Sheraton Centre', 182, '2019-05-15', 312, NULL),
('Sheraton Centre', 182, '2019-05-16', 184, NULL),
('Sheraton Centre', 182, '2019-05-17', 380, NULL),
('Sheraton Centre', 182, '2019-05-18', 131, NULL),
('Sheraton Centre', 182, '2019-05-19', 385, NULL),
('Sheraton Centre', 182, '2019-05-20', 373, NULL),
('Sheraton Centre', 182, '2019-05-21', 258, NULL),
('Sheraton Centre', 182, '2019-05-22', 123, NULL),
('Sheraton Centre', 182, '2019-05-23', 249, NULL),
('Sheraton Centre', 182, '2019-05-24', 236, NULL),
('Sheraton Centre', 182, '2019-05-25', 245, NULL),
('Sheraton Centre', 182, '2019-05-26', 389, NULL),
('Sheraton Centre', 182, '2019-05-27', 144, NULL),
('Sheraton Centre', 182, '2019-05-28', 267, NULL),
('Sheraton Centre', 182, '2019-05-29', 388, NULL),
('Sheraton Centre', 182, '2019-05-30', 210, NULL),
('Sheraton Centre', 182, '2019-05-31', 137, NULL),
('Sheraton Centre', 182, '2019-06-01', 374, NULL),
('Sheraton Centre', 182, '2019-06-02', 208, NULL),
('Sheraton Centre', 182, '2019-06-03', 333, NULL),
('Sheraton Centre', 182, '2019-06-04', 149, NULL),
('Sheraton Centre', 182, '2019-06-05', 211, NULL),
('Sheraton Centre', 182, '2019-06-06', 135, NULL),
('Sheraton Centre', 182, '2019-06-07', 371, NULL),
('Sheraton Centre', 182, '2019-06-08', 346, NULL),
('Sheraton Centre', 182, '2019-06-09', 341, NULL),
('Sheraton Centre', 182, '2019-06-10', 302, NULL),
('Sheraton Centre', 182, '2019-06-11', 353, NULL),
('Sheraton Centre', 182, '2019-06-12', 199, NULL),
('Sheraton Centre', 182, '2019-06-13', 112, NULL),
('Sheraton Centre', 182, '2019-06-14', 362, NULL),
('Sheraton Centre', 182, '2019-06-15', 153, NULL),
('Sheraton Centre', 182, '2019-06-16', 289, NULL),
('Sheraton Centre', 182, '2019-06-17', 106, NULL),
('Sheraton Centre', 182, '2019-06-18', 126, NULL),
('Sheraton Centre', 182, '2019-06-19', 350, NULL),
('Sheraton Centre', 182, '2019-06-20', 322, NULL),
('Sheraton Centre', 182, '2019-06-21', 340, NULL),
('Sheraton Centre', 182, '2019-06-22', 211, NULL),
('Sheraton Centre', 182, '2019-06-23', 364, NULL),
('Sheraton Centre', 182, '2019-06-24', 273, NULL),
('Sheraton Centre', 182, '2019-06-25', 164, NULL),
('Sheraton Centre', 182, '2019-06-26', 153, NULL),
('Sheraton Centre', 182, '2019-06-27', 135, NULL),
('Sheraton Centre', 182, '2019-06-28', 396, NULL),
('Sheraton Centre', 182, '2019-06-29', 180, NULL),
('Sheraton Centre', 182, '2019-06-30', 304, NULL),
('Sheraton Centre', 182, '2019-07-01', 315, NULL),
('Sheraton Centre', 182, '2019-07-02', 159, NULL),
('Sheraton Centre', 182, '2019-07-03', 304, NULL),
('Sheraton Centre', 182, '2019-07-04', 289, NULL),
('Sheraton Centre', 182, '2019-07-05', 398, NULL),
('Sheraton Centre', 182, '2019-07-06', 346, NULL),
('Sheraton Centre', 182, '2019-07-07', 184, NULL),
('Sheraton Centre', 182, '2019-07-08', 131, NULL),
('Sheraton Centre', 182, '2019-07-09', 389, NULL),
('Sheraton Centre', 182, '2019-07-10', 253, NULL),
('Sheraton Centre', 182, '2019-07-11', 233, NULL),
('Sheraton Centre', 182, '2019-07-12', 367, NULL),
('Sheraton Centre', 182, '2019-07-13', 176, NULL),
('Sheraton Centre', 182, '2019-07-14', 152, NULL),
('Sheraton Centre', 182, '2019-07-15', 274, NULL),
('Sheraton Centre', 182, '2019-07-16', 211, NULL),
('Sheraton Centre', 182, '2019-07-17', 243, NULL),
('Sheraton Centre', 182, '2019-07-18', 214, NULL),
('Sheraton Centre', 182, '2019-07-19', 253, NULL),
('Sheraton Centre', 182, '2019-07-20', 104, NULL),
('Sheraton Centre', 182, '2019-07-21', 296, NULL),
('Sheraton Centre', 182, '2019-07-22', 297, NULL),
('Sheraton Centre', 182, '2019-07-23', 249, NULL),
('Sheraton Centre', 182, '2019-07-24', 300, NULL),
('Sheraton Centre', 182, '2019-07-25', 197, NULL),
('Sheraton Centre', 182, '2019-07-26', 321, NULL),
('Sheraton Centre', 182, '2019-07-27', 203, NULL),
('Sheraton Centre', 182, '2019-07-28', 202, NULL),
('Sheraton Centre', 182, '2019-07-29', 133, NULL),
('Sheraton Centre', 182, '2019-07-30', 234, NULL),
('Sheraton Centre', 182, '2019-07-31', 371, NULL),
('Sheraton Centre', 182, '2019-08-01', 375, NULL),
('Sheraton Centre', 182, '2019-08-02', 327, NULL),
('Sheraton Centre', 182, '2019-08-03', 269, NULL),
('Sheraton Centre', 182, '2019-08-04', 143, NULL),
('Sheraton Centre', 182, '2019-08-05', 147, NULL),
('Sheraton Centre', 182, '2019-08-06', 219, NULL),
('Sheraton Centre', 182, '2019-08-07', 180, NULL),
('Sheraton Centre', 182, '2019-08-08', 132, NULL),
('Sheraton Centre', 182, '2019-08-09', 219, NULL),
('Sheraton Centre', 182, '2019-08-10', 318, NULL),
('Sheraton Centre', 182, '2019-08-11', 379, NULL),
('Sheraton Centre', 182, '2019-08-12', 202, NULL),
('Sheraton Centre', 182, '2019-08-13', 372, NULL),
('Sheraton Centre', 182, '2019-08-14', 301, NULL),
('Sheraton Centre', 182, '2019-08-15', 258, NULL),
('Sheraton Centre', 182, '2019-08-16', 247, NULL),
('Sheraton Centre', 182, '2019-08-17', 329, NULL),
('Sheraton Centre', 182, '2019-08-18', 279, NULL),
('Sheraton Centre', 182, '2019-08-19', 140, NULL),
('Sheraton Centre', 182, '2019-08-20', 107, NULL),
('Sheraton Centre', 182, '2019-08-21', 188, NULL),
('Sheraton Centre', 182, '2019-08-22', 220, NULL),
('Sheraton Centre', 182, '2019-08-23', 173, NULL),
('Sheraton Centre', 182, '2019-08-24', 245, NULL),
('Sheraton Centre', 182, '2019-08-25', 129, NULL),
('Sheraton Centre', 182, '2019-08-26', 126, NULL),
('Sheraton Centre', 182, '2019-08-27', 156, NULL),
('Sheraton Centre', 182, '2019-08-28', 166, NULL),
('Sheraton Centre', 182, '2019-08-29', 148, NULL),
('Sheraton Centre', 182, '2019-08-30', 392, NULL),
('Sheraton Centre', 182, '2019-08-31', 287, NULL),
('Sheraton Centre', 182, '2019-09-01', 191, NULL),
('Sheraton Centre', 182, '2019-09-02', 320, NULL),
('Sheraton Centre', 182, '2019-09-03', 294, NULL),
('Sheraton Centre', 182, '2019-09-04', 316, NULL),
('Sheraton Centre', 182, '2019-09-05', 220, NULL),
('Sheraton Centre', 182, '2019-09-06', 329, NULL),
('Sheraton Centre', 182, '2019-09-07', 176, NULL),
('Sheraton Centre', 182, '2019-09-08', 398, NULL),
('Sheraton Centre', 182, '2019-09-09', 279, NULL),
('Sheraton Centre', 182, '2019-09-10', 326, NULL),
('Sheraton Centre', 182, '2019-09-11', 270, NULL),
('Sheraton Centre', 182, '2019-09-12', 293, NULL),
('Sheraton Centre', 182, '2019-09-13', 211, NULL),
('Sheraton Centre', 182, '2019-09-14', 299, NULL),
('Sheraton Centre', 182, '2019-09-15', 143, NULL),
('Sheraton Centre', 182, '2019-09-16', 140, NULL),
('Sheraton Centre', 182, '2019-09-17', 295, NULL),
('Sheraton Centre', 182, '2019-09-18', 348, NULL),
('Sheraton Centre', 182, '2019-09-19', 127, NULL),
('Sheraton Centre', 182, '2019-09-20', 245, NULL),
('Sheraton Centre', 182, '2019-09-21', 311, NULL),
('Sheraton Centre', 182, '2019-09-22', 128, NULL),
('Sheraton Centre', 182, '2019-09-23', 128, NULL),
('Sheraton Centre', 182, '2019-09-24', 259, NULL),
('Sheraton Centre', 182, '2019-09-25', 363, NULL),
('Sheraton Centre', 182, '2019-09-26', 198, NULL),
('Sheraton Centre', 182, '2019-09-27', 267, NULL),
('Sheraton Centre', 182, '2019-09-28', 305, NULL),
('Sheraton Centre', 182, '2019-09-29', 157, NULL),
('Sheraton Centre', 182, '2019-09-30', 310, NULL),
('Sheraton Centre', 182, '2019-10-01', 382, NULL),
('Sheraton Centre', 182, '2019-10-02', 276, NULL),
('Sheraton Centre', 182, '2019-10-03', 364, NULL),
('Sheraton Centre', 182, '2019-10-04', 192, NULL),
('Sheraton Centre', 182, '2019-10-05', 326, NULL),
('Sheraton Centre', 182, '2019-10-06', 151, NULL),
('Sheraton Centre', 182, '2019-10-07', 184, NULL),
('Sheraton Centre', 182, '2019-10-08', 318, NULL),
('Sheraton Centre', 182, '2019-10-09', 335, NULL),
('Sheraton Centre', 182, '2019-10-10', 107, NULL),
('Sheraton Centre', 182, '2019-10-11', 106, NULL),
('Sheraton Centre', 182, '2019-10-12', 103, NULL),
('Sheraton Centre', 182, '2019-10-13', 387, NULL),
('Sheraton Centre', 182, '2019-10-14', 228, NULL),
('Sheraton Centre', 182, '2019-10-15', 158, NULL),
('Sheraton Centre', 182, '2019-10-16', 189, NULL),
('Sheraton Centre', 182, '2019-10-17', 154, NULL),
('Sheraton Centre', 182, '2019-10-18', 119, NULL),
('Sheraton Centre', 182, '2019-10-19', 149, NULL),
('Sheraton Centre', 182, '2019-10-20', 350, NULL),
('Sheraton Centre', 182, '2019-10-21', 311, NULL),
('Sheraton Centre', 182, '2019-10-22', 260, NULL),
('Sheraton Centre', 182, '2019-10-23', 393, NULL),
('Sheraton Centre', 182, '2019-10-24', 173, NULL),
('Sheraton Centre', 182, '2019-10-25', 306, NULL),
('Sheraton Centre', 182, '2019-10-26', 358, NULL),
('Sheraton Centre', 182, '2019-10-27', 267, NULL),
('Sheraton Centre', 182, '2019-10-28', 245, NULL),
('Sheraton Centre', 182, '2019-10-29', 341, NULL),
('Sheraton Centre', 182, '2019-10-30', 375, NULL),
('Sheraton Centre', 182, '2019-10-31', 166, NULL),
('Sheraton Centre', 182, '2019-11-01', 120, NULL),
('Sheraton Centre', 182, '2019-11-02', 204, NULL),
('Sheraton Centre', 182, '2019-11-03', 359, NULL),
('Sheraton Centre', 182, '2019-11-04', 199, NULL),
('Sheraton Centre', 182, '2019-11-05', 299, NULL),
('Sheraton Centre', 182, '2019-11-06', 257, NULL),
('Sheraton Centre', 182, '2019-11-07', 359, NULL),
('Sheraton Centre', 182, '2019-11-08', 183, NULL),
('Sheraton Centre', 182, '2019-11-09', 294, NULL),
('Sheraton Centre', 182, '2019-11-10', 233, NULL),
('Sheraton Centre', 182, '2019-11-11', 111, NULL),
('Sheraton Centre', 182, '2019-11-12', 324, NULL),
('Sheraton Centre', 182, '2019-11-13', 263, NULL),
('Sheraton Centre', 182, '2019-11-14', 346, NULL),
('Sheraton Centre', 182, '2019-11-15', 167, NULL),
('Sheraton Centre', 182, '2019-11-16', 176, NULL),
('Sheraton Centre', 182, '2019-11-17', 246, NULL),
('Sheraton Centre', 182, '2019-11-18', 110, NULL),
('Sheraton Centre', 182, '2019-11-19', 216, NULL),
('Sheraton Centre', 182, '2019-11-20', 234, NULL),
('Sheraton Centre', 182, '2019-11-21', 241, NULL),
('Sheraton Centre', 182, '2019-11-22', 334, NULL),
('Sheraton Centre', 182, '2019-11-23', 190, NULL),
('Sheraton Centre', 182, '2019-11-24', 252, NULL),
('Sheraton Centre', 182, '2019-11-25', 325, NULL),
('Sheraton Centre', 182, '2019-11-26', 242, NULL),
('Sheraton Centre', 182, '2019-11-27', 189, NULL),
('Sheraton Centre', 182, '2019-11-28', 107, NULL),
('Sheraton Centre', 182, '2019-11-29', 164, NULL),
('Sheraton Centre', 182, '2019-11-30', 163, NULL),
('Sheraton Centre', 182, '2019-12-01', 292, NULL),
('Sheraton Centre', 182, '2019-12-02', 226, NULL),
('Sheraton Centre', 182, '2019-12-03', 214, NULL),
('Sheraton Centre', 182, '2019-12-04', 169, NULL),
('Sheraton Centre', 182, '2019-12-05', 322, NULL),
('Sheraton Centre', 182, '2019-12-06', 198, NULL),
('Sheraton Centre', 182, '2019-12-07', 190, NULL),
('Sheraton Centre', 182, '2019-12-08', 361, NULL),
('Sheraton Centre', 182, '2019-12-09', 126, NULL),
('Sheraton Centre', 182, '2019-12-10', 130, NULL),
('Sheraton Centre', 182, '2019-12-11', 259, NULL),
('Sheraton Centre', 182, '2019-12-12', 382, NULL),
('Sheraton Centre', 182, '2019-12-13', 325, NULL),
('Sheraton Centre', 182, '2019-12-14', 273, NULL),
('Sheraton Centre', 182, '2019-12-15', 141, NULL),
('Sheraton Centre', 182, '2019-12-16', 256, NULL),
('Sheraton Centre', 182, '2019-12-17', 188, NULL),
('Sheraton Centre', 182, '2019-12-18', 380, NULL),
('Sheraton Centre', 182, '2019-12-19', 344, NULL),
('Sheraton Centre', 182, '2019-12-20', 355, NULL),
('Sheraton Centre', 182, '2019-12-21', 360, NULL),
('Sheraton Centre', 182, '2019-12-22', 158, NULL),
('Sheraton Centre', 182, '2019-12-23', 174, NULL),
('Sheraton Centre', 182, '2019-12-24', 231, NULL),
('Sheraton Centre', 182, '2019-12-25', 121, NULL),
('Sheraton Centre', 182, '2019-12-26', 126, NULL),
('Sheraton Centre', 182, '2019-12-27', 330, NULL),
('Sheraton Centre', 182, '2019-12-28', 189, NULL),
('Sheraton Centre', 182, '2019-12-29', 299, NULL),
('Sheraton Centre', 182, '2019-12-30', 232, NULL),
('Sheraton Centre', 182, '2019-12-31', 276, NULL),
('Sheraton Centre', 182, '2020-01-01', 126, NULL),
('Sheraton Centre', 182, '2020-01-02', 365, NULL),
('Sheraton Centre', 182, '2020-01-03', 101, NULL),
('Sheraton Centre', 182, '2020-01-04', 363, NULL),
('Sheraton Centre', 182, '2020-01-05', 377, NULL),
('Sheraton Centre', 182, '2020-01-06', 312, NULL),
('Sheraton Centre', 182, '2020-01-07', 128, NULL),
('Sheraton Centre', 182, '2020-01-08', 302, NULL),
('Sheraton Centre', 182, '2020-01-09', 296, NULL),
('Sheraton Centre', 182, '2020-01-10', 285, NULL),
('Sheraton Centre', 182, '2020-01-11', 102, NULL),
('Sheraton Centre', 182, '2020-01-12', 111, NULL),
('Sheraton Centre', 182, '2020-01-13', 176, NULL),
('Sheraton Centre', 182, '2020-01-14', 301, NULL),
('Sheraton Centre', 182, '2020-01-15', 202, NULL),
('Sheraton Centre', 182, '2020-01-16', 174, NULL),
('Sheraton Centre', 182, '2020-01-17', 290, NULL),
('Sheraton Centre', 182, '2020-01-18', 301, NULL),
('Sheraton Centre', 182, '2020-01-19', 130, NULL),
('Sheraton Centre', 182, '2020-01-20', 240, NULL),
('Sheraton Centre', 182, '2020-01-21', 268, NULL),
('Sheraton Centre', 182, '2020-01-22', 286, NULL),
('Sheraton Centre', 182, '2020-01-23', 161, NULL),
('Sheraton Centre', 182, '2020-01-24', 312, NULL),
('Sheraton Centre', 182, '2020-01-25', 226, NULL),
('Sheraton Centre', 182, '2020-01-26', 267, NULL),
('Sheraton Centre', 182, '2020-01-27', 100, NULL),
('Sheraton Centre', 182, '2020-01-28', 321, NULL),
('Sheraton Centre', 182, '2020-01-29', 133, NULL),
('Sheraton Centre', 182, '2020-01-30', 270, NULL),
('Sheraton Centre', 182, '2020-01-31', 184, NULL),
('Sheraton Centre', 182, '2020-02-01', 214, NULL),
('Sheraton Centre', 182, '2020-02-02', 373, NULL),
('Sheraton Centre', 182, '2020-02-03', 149, NULL),
('Sheraton Centre', 182, '2020-02-04', 190, NULL),
('Sheraton Centre', 184, '2019-01-01', 207, NULL),
('Sheraton Centre', 184, '2019-01-02', 219, NULL),
('Sheraton Centre', 184, '2019-01-03', 146, NULL),
('Sheraton Centre', 184, '2019-01-04', 210, NULL),
('Sheraton Centre', 184, '2019-01-05', 137, NULL),
('Sheraton Centre', 184, '2019-01-06', 289, NULL),
('Sheraton Centre', 184, '2019-01-07', 297, NULL),
('Sheraton Centre', 184, '2019-01-08', 146, NULL),
('Sheraton Centre', 184, '2019-01-09', 322, NULL),
('Sheraton Centre', 184, '2019-01-10', 136, NULL),
('Sheraton Centre', 184, '2019-01-11', 281, NULL),
('Sheraton Centre', 184, '2019-01-12', 265, NULL),
('Sheraton Centre', 184, '2019-01-13', 177, NULL),
('Sheraton Centre', 184, '2019-01-14', 369, NULL),
('Sheraton Centre', 184, '2019-01-15', 397, NULL),
('Sheraton Centre', 184, '2019-01-16', 349, NULL),
('Sheraton Centre', 184, '2019-01-17', 223, NULL),
('Sheraton Centre', 184, '2019-01-18', 255, NULL),
('Sheraton Centre', 184, '2019-01-19', 218, NULL),
('Sheraton Centre', 184, '2019-01-20', 367, NULL),
('Sheraton Centre', 184, '2019-01-21', 372, NULL),
('Sheraton Centre', 184, '2019-01-22', 230, NULL),
('Sheraton Centre', 184, '2019-01-23', 343, NULL),
('Sheraton Centre', 184, '2019-01-24', 288, NULL),
('Sheraton Centre', 184, '2019-01-25', 398, NULL),
('Sheraton Centre', 184, '2019-01-26', 182, NULL),
('Sheraton Centre', 184, '2019-01-27', 215, NULL),
('Sheraton Centre', 184, '2019-01-28', 243, NULL),
('Sheraton Centre', 184, '2019-01-29', 236, NULL),
('Sheraton Centre', 184, '2019-01-30', 156, NULL),
('Sheraton Centre', 184, '2019-01-31', 358, NULL),
('Sheraton Centre', 184, '2019-02-01', 260, NULL),
('Sheraton Centre', 184, '2019-02-02', 134, NULL),
('Sheraton Centre', 184, '2019-02-03', 243, NULL),
('Sheraton Centre', 184, '2019-02-04', 221, NULL),
('Sheraton Centre', 184, '2019-02-05', 248, NULL),
('Sheraton Centre', 184, '2019-02-06', 154, NULL),
('Sheraton Centre', 184, '2019-02-07', 345, NULL),
('Sheraton Centre', 184, '2019-02-08', 260, NULL),
('Sheraton Centre', 184, '2019-02-09', 390, NULL),
('Sheraton Centre', 184, '2019-02-10', 252, NULL),
('Sheraton Centre', 184, '2019-02-11', 135, NULL),
('Sheraton Centre', 184, '2019-02-12', 142, NULL),
('Sheraton Centre', 184, '2019-02-13', 135, NULL),
('Sheraton Centre', 184, '2019-02-14', 295, NULL),
('Sheraton Centre', 184, '2019-02-15', 213, NULL),
('Sheraton Centre', 184, '2019-02-16', 371, NULL),
('Sheraton Centre', 184, '2019-02-17', 108, NULL),
('Sheraton Centre', 184, '2019-02-18', 143, NULL),
('Sheraton Centre', 184, '2019-02-19', 227, NULL),
('Sheraton Centre', 184, '2019-02-20', 115, NULL),
('Sheraton Centre', 184, '2019-02-21', 302, NULL),
('Sheraton Centre', 184, '2019-02-22', 212, NULL),
('Sheraton Centre', 184, '2019-02-23', 135, NULL),
('Sheraton Centre', 184, '2019-02-24', 288, NULL),
('Sheraton Centre', 184, '2019-02-25', 178, NULL),
('Sheraton Centre', 184, '2019-02-26', 104, NULL),
('Sheraton Centre', 184, '2019-02-27', 317, NULL),
('Sheraton Centre', 184, '2019-02-28', 237, NULL),
('Sheraton Centre', 184, '2019-03-01', 273, NULL),
('Sheraton Centre', 184, '2019-03-02', 261, NULL),
('Sheraton Centre', 184, '2019-03-03', 142, NULL),
('Sheraton Centre', 184, '2019-03-04', 163, NULL),
('Sheraton Centre', 184, '2019-03-05', 344, NULL),
('Sheraton Centre', 184, '2019-03-06', 222, NULL),
('Sheraton Centre', 184, '2019-03-07', 145, NULL),
('Sheraton Centre', 184, '2019-03-08', 224, NULL),
('Sheraton Centre', 184, '2019-03-09', 362, NULL),
('Sheraton Centre', 184, '2019-03-10', 189, NULL),
('Sheraton Centre', 184, '2019-03-11', 209, NULL),
('Sheraton Centre', 184, '2019-03-12', 396, NULL),
('Sheraton Centre', 184, '2019-03-13', 316, NULL),
('Sheraton Centre', 184, '2019-03-14', 190, NULL),
('Sheraton Centre', 184, '2019-03-15', 220, NULL),
('Sheraton Centre', 184, '2019-03-16', 201, NULL),
('Sheraton Centre', 184, '2019-03-17', 375, NULL),
('Sheraton Centre', 184, '2019-03-18', 241, NULL),
('Sheraton Centre', 184, '2019-03-19', 123, NULL),
('Sheraton Centre', 184, '2019-03-20', 342, NULL),
('Sheraton Centre', 184, '2019-03-21', 199, NULL),
('Sheraton Centre', 184, '2019-03-22', 101, NULL),
('Sheraton Centre', 184, '2019-03-23', 130, NULL),
('Sheraton Centre', 184, '2019-03-24', 258, NULL),
('Sheraton Centre', 184, '2019-03-25', 325, NULL),
('Sheraton Centre', 184, '2019-03-26', 111, NULL),
('Sheraton Centre', 184, '2019-03-27', 271, NULL),
('Sheraton Centre', 184, '2019-03-28', 368, NULL),
('Sheraton Centre', 184, '2019-03-29', 376, NULL),
('Sheraton Centre', 184, '2019-03-30', 134, NULL),
('Sheraton Centre', 184, '2019-03-31', 341, NULL),
('Sheraton Centre', 184, '2019-04-01', 155, NULL),
('Sheraton Centre', 184, '2019-04-02', 352, NULL),
('Sheraton Centre', 184, '2019-04-03', 381, NULL),
('Sheraton Centre', 184, '2019-04-04', 391, NULL),
('Sheraton Centre', 184, '2019-04-05', 154, NULL),
('Sheraton Centre', 184, '2019-04-06', 183, NULL),
('Sheraton Centre', 184, '2019-04-07', 371, NULL),
('Sheraton Centre', 184, '2019-04-08', 119, NULL),
('Sheraton Centre', 184, '2019-04-09', 392, NULL),
('Sheraton Centre', 184, '2019-04-10', 393, NULL),
('Sheraton Centre', 184, '2019-04-11', 277, NULL),
('Sheraton Centre', 184, '2019-04-12', 201, NULL),
('Sheraton Centre', 184, '2019-04-13', 324, NULL),
('Sheraton Centre', 184, '2019-04-14', 187, NULL),
('Sheraton Centre', 184, '2019-04-15', 300, NULL),
('Sheraton Centre', 184, '2019-04-16', 246, NULL),
('Sheraton Centre', 184, '2019-04-17', 155, NULL),
('Sheraton Centre', 184, '2019-04-18', 217, NULL),
('Sheraton Centre', 184, '2019-04-19', 295, NULL),
('Sheraton Centre', 184, '2019-04-20', 177, NULL),
('Sheraton Centre', 184, '2019-04-21', 237, NULL),
('Sheraton Centre', 184, '2019-04-22', 102, NULL),
('Sheraton Centre', 184, '2019-04-23', 107, NULL),
('Sheraton Centre', 184, '2019-04-24', 167, NULL),
('Sheraton Centre', 184, '2019-04-25', 174, NULL),
('Sheraton Centre', 184, '2019-04-26', 113, NULL),
('Sheraton Centre', 184, '2019-04-27', 217, NULL),
('Sheraton Centre', 184, '2019-04-28', 133, NULL),
('Sheraton Centre', 184, '2019-04-29', 324, NULL),
('Sheraton Centre', 184, '2019-04-30', 226, NULL),
('Sheraton Centre', 184, '2019-05-01', 246, NULL),
('Sheraton Centre', 184, '2019-05-02', 290, NULL),
('Sheraton Centre', 184, '2019-05-03', 289, NULL),
('Sheraton Centre', 184, '2019-05-04', 288, NULL),
('Sheraton Centre', 184, '2019-05-05', 238, NULL),
('Sheraton Centre', 184, '2019-05-06', 143, NULL),
('Sheraton Centre', 184, '2019-05-07', 116, NULL),
('Sheraton Centre', 184, '2019-05-08', 240, NULL),
('Sheraton Centre', 184, '2019-05-09', 274, NULL),
('Sheraton Centre', 184, '2019-05-10', 335, NULL),
('Sheraton Centre', 184, '2019-05-11', 157, NULL),
('Sheraton Centre', 184, '2019-05-12', 168, NULL),
('Sheraton Centre', 184, '2019-05-13', 119, NULL),
('Sheraton Centre', 184, '2019-05-14', 396, NULL),
('Sheraton Centre', 184, '2019-05-15', 343, NULL),
('Sheraton Centre', 184, '2019-05-16', 284, NULL),
('Sheraton Centre', 184, '2019-05-17', 189, NULL),
('Sheraton Centre', 184, '2019-05-18', 235, NULL),
('Sheraton Centre', 184, '2019-05-19', 301, NULL),
('Sheraton Centre', 184, '2019-05-20', 292, NULL),
('Sheraton Centre', 184, '2019-05-21', 165, NULL),
('Sheraton Centre', 184, '2019-05-22', 218, NULL),
('Sheraton Centre', 184, '2019-05-23', 115, NULL),
('Sheraton Centre', 184, '2019-05-24', 296, NULL),
('Sheraton Centre', 184, '2019-05-25', 142, NULL),
('Sheraton Centre', 184, '2019-05-26', 363, NULL),
('Sheraton Centre', 184, '2019-05-27', 318, NULL),
('Sheraton Centre', 184, '2019-05-28', 277, NULL),
('Sheraton Centre', 184, '2019-05-29', 181, NULL),
('Sheraton Centre', 184, '2019-05-30', 301, NULL),
('Sheraton Centre', 184, '2019-05-31', 242, NULL),
('Sheraton Centre', 184, '2019-06-01', 364, NULL),
('Sheraton Centre', 184, '2019-06-02', 348, NULL),
('Sheraton Centre', 184, '2019-06-03', 307, NULL),
('Sheraton Centre', 184, '2019-06-04', 339, NULL),
('Sheraton Centre', 184, '2019-06-05', 320, NULL),
('Sheraton Centre', 184, '2019-06-06', 228, NULL),
('Sheraton Centre', 184, '2019-06-07', 358, NULL),
('Sheraton Centre', 184, '2019-06-08', 339, NULL),
('Sheraton Centre', 184, '2019-06-09', 397, NULL),
('Sheraton Centre', 184, '2019-06-10', 138, NULL),
('Sheraton Centre', 184, '2019-06-11', 210, NULL),
('Sheraton Centre', 184, '2019-06-12', 194, NULL),
('Sheraton Centre', 184, '2019-06-13', 264, NULL),
('Sheraton Centre', 184, '2019-06-14', 124, NULL),
('Sheraton Centre', 184, '2019-06-15', 156, NULL),
('Sheraton Centre', 184, '2019-06-16', 100, NULL),
('Sheraton Centre', 184, '2019-06-17', 158, NULL),
('Sheraton Centre', 184, '2019-06-18', 171, NULL),
('Sheraton Centre', 184, '2019-06-19', 160, NULL),
('Sheraton Centre', 184, '2019-06-20', 151, NULL),
('Sheraton Centre', 184, '2019-06-21', 130, NULL),
('Sheraton Centre', 184, '2019-06-22', 165, NULL),
('Sheraton Centre', 184, '2019-06-23', 396, NULL),
('Sheraton Centre', 184, '2019-06-24', 166, NULL),
('Sheraton Centre', 184, '2019-06-25', 278, NULL),
('Sheraton Centre', 184, '2019-06-26', 167, NULL),
('Sheraton Centre', 184, '2019-06-27', 188, NULL),
('Sheraton Centre', 184, '2019-06-28', 293, NULL),
('Sheraton Centre', 184, '2019-06-29', 160, NULL),
('Sheraton Centre', 184, '2019-06-30', 268, NULL),
('Sheraton Centre', 184, '2019-07-01', 222, NULL),
('Sheraton Centre', 184, '2019-07-02', 133, NULL),
('Sheraton Centre', 184, '2019-07-03', 215, NULL),
('Sheraton Centre', 184, '2019-07-04', 269, NULL),
('Sheraton Centre', 184, '2019-07-05', 136, NULL),
('Sheraton Centre', 184, '2019-07-06', 275, NULL),
('Sheraton Centre', 184, '2019-07-07', 235, NULL),
('Sheraton Centre', 184, '2019-07-08', 182, NULL),
('Sheraton Centre', 184, '2019-07-09', 193, NULL),
('Sheraton Centre', 184, '2019-07-10', 368, NULL),
('Sheraton Centre', 184, '2019-07-11', 163, NULL),
('Sheraton Centre', 184, '2019-07-12', 130, NULL),
('Sheraton Centre', 184, '2019-07-13', 219, NULL),
('Sheraton Centre', 184, '2019-07-14', 176, NULL),
('Sheraton Centre', 184, '2019-07-15', 319, NULL),
('Sheraton Centre', 184, '2019-07-16', 378, NULL),
('Sheraton Centre', 184, '2019-07-17', 360, NULL),
('Sheraton Centre', 184, '2019-07-18', 370, NULL),
('Sheraton Centre', 184, '2019-07-19', 283, NULL),
('Sheraton Centre', 184, '2019-07-20', 255, NULL),
('Sheraton Centre', 184, '2019-07-21', 136, NULL),
('Sheraton Centre', 184, '2019-07-22', 388, NULL),
('Sheraton Centre', 184, '2019-07-23', 356, NULL),
('Sheraton Centre', 184, '2019-07-24', 387, NULL),
('Sheraton Centre', 184, '2019-07-25', 140, NULL),
('Sheraton Centre', 184, '2019-07-26', 286, NULL),
('Sheraton Centre', 184, '2019-07-27', 248, NULL),
('Sheraton Centre', 184, '2019-07-28', 173, NULL),
('Sheraton Centre', 184, '2019-07-29', 354, NULL),
('Sheraton Centre', 184, '2019-07-30', 324, NULL),
('Sheraton Centre', 184, '2019-07-31', 128, NULL),
('Sheraton Centre', 184, '2019-08-01', 320, NULL),
('Sheraton Centre', 184, '2019-08-02', 291, NULL),
('Sheraton Centre', 184, '2019-08-03', 397, NULL),
('Sheraton Centre', 184, '2019-08-04', 198, NULL),
('Sheraton Centre', 184, '2019-08-05', 213, NULL),
('Sheraton Centre', 184, '2019-08-06', 145, NULL),
('Sheraton Centre', 184, '2019-08-07', 356, NULL),
('Sheraton Centre', 184, '2019-08-08', 289, NULL),
('Sheraton Centre', 184, '2019-08-09', 248, NULL),
('Sheraton Centre', 184, '2019-08-10', 370, NULL),
('Sheraton Centre', 184, '2019-08-11', 283, NULL),
('Sheraton Centre', 184, '2019-08-12', 224, NULL),
('Sheraton Centre', 184, '2019-08-13', 333, NULL),
('Sheraton Centre', 184, '2019-08-14', 343, NULL),
('Sheraton Centre', 184, '2019-08-15', 191, NULL),
('Sheraton Centre', 184, '2019-08-16', 156, NULL),
('Sheraton Centre', 184, '2019-08-17', 299, NULL),
('Sheraton Centre', 184, '2019-08-18', 306, NULL),
('Sheraton Centre', 184, '2019-08-19', 181, NULL),
('Sheraton Centre', 184, '2019-08-20', 169, NULL),
('Sheraton Centre', 184, '2019-08-21', 374, NULL),
('Sheraton Centre', 184, '2019-08-22', 315, NULL),
('Sheraton Centre', 184, '2019-08-23', 390, NULL),
('Sheraton Centre', 184, '2019-08-24', 378, NULL),
('Sheraton Centre', 184, '2019-08-25', 137, NULL),
('Sheraton Centre', 184, '2019-08-26', 180, NULL),
('Sheraton Centre', 184, '2019-08-27', 248, NULL),
('Sheraton Centre', 184, '2019-08-28', 396, NULL),
('Sheraton Centre', 184, '2019-08-29', 140, NULL),
('Sheraton Centre', 184, '2019-08-30', 213, NULL),
('Sheraton Centre', 184, '2019-08-31', 288, NULL),
('Sheraton Centre', 184, '2019-09-01', 218, NULL),
('Sheraton Centre', 184, '2019-09-02', 118, NULL),
('Sheraton Centre', 184, '2019-09-03', 136, NULL),
('Sheraton Centre', 184, '2019-09-04', 325, NULL),
('Sheraton Centre', 184, '2019-09-05', 346, NULL),
('Sheraton Centre', 184, '2019-09-06', 230, NULL),
('Sheraton Centre', 184, '2019-09-07', 195, NULL),
('Sheraton Centre', 184, '2019-09-08', 265, NULL),
('Sheraton Centre', 184, '2019-09-09', 333, NULL),
('Sheraton Centre', 184, '2019-09-10', 284, NULL),
('Sheraton Centre', 184, '2019-09-11', 159, NULL),
('Sheraton Centre', 184, '2019-09-12', 325, NULL),
('Sheraton Centre', 184, '2019-09-13', 373, NULL),
('Sheraton Centre', 184, '2019-09-14', 329, NULL),
('Sheraton Centre', 184, '2019-09-15', 215, NULL),
('Sheraton Centre', 184, '2019-09-16', 171, NULL),
('Sheraton Centre', 184, '2019-09-17', 203, NULL),
('Sheraton Centre', 184, '2019-09-18', 194, NULL),
('Sheraton Centre', 184, '2019-09-19', 314, NULL),
('Sheraton Centre', 184, '2019-09-20', 212, NULL),
('Sheraton Centre', 184, '2019-09-21', 261, NULL),
('Sheraton Centre', 184, '2019-09-22', 308, NULL),
('Sheraton Centre', 184, '2019-09-23', 277, NULL),
('Sheraton Centre', 184, '2019-09-24', 281, NULL),
('Sheraton Centre', 184, '2019-09-25', 336, NULL),
('Sheraton Centre', 184, '2019-09-26', 262, NULL),
('Sheraton Centre', 184, '2019-09-27', 171, NULL),
('Sheraton Centre', 184, '2019-09-28', 259, NULL),
('Sheraton Centre', 184, '2019-09-29', 141, NULL),
('Sheraton Centre', 184, '2019-09-30', 117, NULL),
('Sheraton Centre', 184, '2019-10-01', 133, NULL),
('Sheraton Centre', 184, '2019-10-02', 134, NULL),
('Sheraton Centre', 184, '2019-10-03', 327, NULL),
('Sheraton Centre', 184, '2019-10-04', 137, NULL),
('Sheraton Centre', 184, '2019-10-05', 267, NULL),
('Sheraton Centre', 184, '2019-10-06', 105, NULL),
('Sheraton Centre', 184, '2019-10-07', 309, NULL),
('Sheraton Centre', 184, '2019-10-08', 205, NULL),
('Sheraton Centre', 184, '2019-10-09', 378, NULL),
('Sheraton Centre', 184, '2019-10-10', 234, NULL),
('Sheraton Centre', 184, '2019-10-11', 268, NULL),
('Sheraton Centre', 184, '2019-10-12', 157, NULL),
('Sheraton Centre', 184, '2019-10-13', 335, NULL),
('Sheraton Centre', 184, '2019-10-14', 114, NULL),
('Sheraton Centre', 184, '2019-10-15', 366, NULL),
('Sheraton Centre', 184, '2019-10-16', 157, NULL),
('Sheraton Centre', 184, '2019-10-17', 160, NULL),
('Sheraton Centre', 184, '2019-10-18', 115, NULL),
('Sheraton Centre', 184, '2019-10-19', 279, NULL),
('Sheraton Centre', 184, '2019-10-20', 184, NULL),
('Sheraton Centre', 184, '2019-10-21', 285, NULL),
('Sheraton Centre', 184, '2019-10-22', 150, NULL),
('Sheraton Centre', 184, '2019-10-23', 310, NULL),
('Sheraton Centre', 184, '2019-10-24', 172, NULL),
('Sheraton Centre', 184, '2019-10-25', 135, NULL),
('Sheraton Centre', 184, '2019-10-26', 205, NULL),
('Sheraton Centre', 184, '2019-10-27', 364, NULL),
('Sheraton Centre', 184, '2019-10-28', 113, NULL),
('Sheraton Centre', 184, '2019-10-29', 204, NULL),
('Sheraton Centre', 184, '2019-10-30', 103, NULL),
('Sheraton Centre', 184, '2019-10-31', 331, NULL),
('Sheraton Centre', 184, '2019-11-01', 180, NULL),
('Sheraton Centre', 184, '2019-11-02', 247, NULL),
('Sheraton Centre', 184, '2019-11-03', 392, NULL),
('Sheraton Centre', 184, '2019-11-04', 274, NULL),
('Sheraton Centre', 184, '2019-11-05', 242, NULL),
('Sheraton Centre', 184, '2019-11-06', 101, NULL),
('Sheraton Centre', 184, '2019-11-07', 107, NULL),
('Sheraton Centre', 184, '2019-11-08', 178, NULL),
('Sheraton Centre', 184, '2019-11-09', 387, NULL),
('Sheraton Centre', 184, '2019-11-10', 124, NULL),
('Sheraton Centre', 184, '2019-11-11', 128, NULL),
('Sheraton Centre', 184, '2019-11-12', 125, NULL),
('Sheraton Centre', 184, '2019-11-13', 173, NULL),
('Sheraton Centre', 184, '2019-11-14', 359, NULL),
('Sheraton Centre', 184, '2019-11-15', 238, NULL),
('Sheraton Centre', 184, '2019-11-16', 207, NULL),
('Sheraton Centre', 184, '2019-11-17', 348, NULL),
('Sheraton Centre', 184, '2019-11-18', 337, NULL),
('Sheraton Centre', 184, '2019-11-19', 354, NULL),
('Sheraton Centre', 184, '2019-11-20', 312, NULL),
('Sheraton Centre', 184, '2019-11-21', 157, NULL),
('Sheraton Centre', 184, '2019-11-22', 342, NULL),
('Sheraton Centre', 184, '2019-11-23', 296, NULL),
('Sheraton Centre', 184, '2019-11-24', 168, NULL),
('Sheraton Centre', 184, '2019-11-25', 177, NULL),
('Sheraton Centre', 184, '2019-11-26', 389, NULL),
('Sheraton Centre', 184, '2019-11-27', 342, NULL),
('Sheraton Centre', 184, '2019-11-28', 139, NULL),
('Sheraton Centre', 184, '2019-11-29', 333, NULL),
('Sheraton Centre', 184, '2019-11-30', 106, NULL),
('Sheraton Centre', 184, '2019-12-01', 322, NULL),
('Sheraton Centre', 184, '2019-12-02', 173, NULL),
('Sheraton Centre', 184, '2019-12-03', 124, NULL),
('Sheraton Centre', 184, '2019-12-04', 392, NULL),
('Sheraton Centre', 184, '2019-12-05', 204, NULL),
('Sheraton Centre', 184, '2019-12-06', 173, NULL),
('Sheraton Centre', 184, '2019-12-07', 131, NULL),
('Sheraton Centre', 184, '2019-12-08', 391, NULL),
('Sheraton Centre', 184, '2019-12-09', 278, NULL),
('Sheraton Centre', 184, '2019-12-10', 281, NULL),
('Sheraton Centre', 184, '2019-12-11', 132, NULL),
('Sheraton Centre', 184, '2019-12-12', 273, NULL),
('Sheraton Centre', 184, '2019-12-13', 260, NULL),
('Sheraton Centre', 184, '2019-12-14', 146, NULL),
('Sheraton Centre', 184, '2019-12-15', 293, NULL),
('Sheraton Centre', 184, '2019-12-16', 273, NULL),
('Sheraton Centre', 184, '2019-12-17', 266, NULL),
('Sheraton Centre', 184, '2019-12-18', 356, NULL),
('Sheraton Centre', 184, '2019-12-19', 208, NULL),
('Sheraton Centre', 184, '2019-12-20', 189, NULL),
('Sheraton Centre', 184, '2019-12-21', 272, NULL),
('Sheraton Centre', 184, '2019-12-22', 331, NULL),
('Sheraton Centre', 184, '2019-12-23', 126, NULL),
('Sheraton Centre', 184, '2019-12-24', 347, NULL),
('Sheraton Centre', 184, '2019-12-25', 273, NULL),
('Sheraton Centre', 184, '2019-12-26', 132, NULL),
('Sheraton Centre', 184, '2019-12-27', 282, NULL),
('Sheraton Centre', 184, '2019-12-28', 235, NULL),
('Sheraton Centre', 184, '2019-12-29', 381, NULL),
('Sheraton Centre', 184, '2019-12-30', 375, NULL),
('Sheraton Centre', 184, '2019-12-31', 332, NULL),
('Sheraton Centre', 184, '2020-01-01', 385, NULL),
('Sheraton Centre', 184, '2020-01-02', 115, NULL),
('Sheraton Centre', 184, '2020-01-03', 208, NULL),
('Sheraton Centre', 184, '2020-01-04', 209, NULL),
('Sheraton Centre', 184, '2020-01-05', 270, NULL),
('Sheraton Centre', 184, '2020-01-06', 132, NULL),
('Sheraton Centre', 184, '2020-01-07', 288, NULL),
('Sheraton Centre', 184, '2020-01-08', 183, NULL),
('Sheraton Centre', 184, '2020-01-09', 225, NULL),
('Sheraton Centre', 184, '2020-01-10', 194, NULL),
('Sheraton Centre', 184, '2020-01-11', 189, NULL),
('Sheraton Centre', 184, '2020-01-12', 167, NULL),
('Sheraton Centre', 184, '2020-01-13', 103, NULL),
('Sheraton Centre', 184, '2020-01-14', 207, NULL),
('Sheraton Centre', 184, '2020-01-15', 292, NULL),
('Sheraton Centre', 184, '2020-01-16', 265, NULL),
('Sheraton Centre', 184, '2020-01-17', 384, NULL),
('Sheraton Centre', 184, '2020-01-18', 238, NULL),
('Sheraton Centre', 184, '2020-01-19', 293, NULL),
('Sheraton Centre', 184, '2020-01-20', 121, NULL),
('Sheraton Centre', 184, '2020-01-21', 100, NULL),
('Sheraton Centre', 184, '2020-01-22', 283, NULL),
('Sheraton Centre', 184, '2020-01-23', 237, NULL),
('Sheraton Centre', 184, '2020-01-24', 132, NULL),
('Sheraton Centre', 184, '2020-01-25', 395, NULL),
('Sheraton Centre', 184, '2020-01-26', 173, NULL),
('Sheraton Centre', 184, '2020-01-27', 396, NULL),
('Sheraton Centre', 184, '2020-01-28', 217, NULL),
('Sheraton Centre', 184, '2020-01-29', 259, NULL),
('Sheraton Centre', 184, '2020-01-30', 140, NULL),
('Sheraton Centre', 184, '2020-01-31', 390, NULL),
('Sheraton Centre', 184, '2020-02-01', 353, NULL),
('Sheraton Centre', 184, '2020-02-02', 259, NULL),
('Sheraton Centre', 184, '2020-02-03', 283, NULL),
('Sheraton Centre', 184, '2020-02-04', 152, NULL),
('Sheraton Centre', 189, '2019-01-01', 292, NULL),
('Sheraton Centre', 189, '2019-01-02', 242, NULL),
('Sheraton Centre', 189, '2019-01-03', 394, NULL),
('Sheraton Centre', 189, '2019-01-04', 259, NULL),
('Sheraton Centre', 189, '2019-01-05', 192, NULL),
('Sheraton Centre', 189, '2019-01-06', 126, NULL),
('Sheraton Centre', 189, '2019-01-07', 316, NULL),
('Sheraton Centre', 189, '2019-01-08', 382, NULL),
('Sheraton Centre', 189, '2019-01-09', 250, NULL),
('Sheraton Centre', 189, '2019-01-10', 367, NULL),
('Sheraton Centre', 189, '2019-01-11', 393, NULL),
('Sheraton Centre', 189, '2019-01-12', 174, NULL),
('Sheraton Centre', 189, '2019-01-13', 212, NULL),
('Sheraton Centre', 189, '2019-01-14', 284, NULL),
('Sheraton Centre', 189, '2019-01-15', 153, NULL),
('Sheraton Centre', 189, '2019-01-16', 347, NULL),
('Sheraton Centre', 189, '2019-01-17', 114, NULL),
('Sheraton Centre', 189, '2019-01-18', 128, NULL),
('Sheraton Centre', 189, '2019-01-19', 109, NULL),
('Sheraton Centre', 189, '2019-01-20', 296, NULL),
('Sheraton Centre', 189, '2019-01-21', 390, NULL),
('Sheraton Centre', 189, '2019-01-22', 393, NULL),
('Sheraton Centre', 189, '2019-01-23', 311, NULL),
('Sheraton Centre', 189, '2019-01-24', 115, NULL),
('Sheraton Centre', 189, '2019-01-25', 267, NULL),
('Sheraton Centre', 189, '2019-01-26', 353, NULL),
('Sheraton Centre', 189, '2019-01-27', 111, NULL),
('Sheraton Centre', 189, '2019-01-28', 224, NULL),
('Sheraton Centre', 189, '2019-01-29', 244, NULL),
('Sheraton Centre', 189, '2019-01-30', 133, NULL),
('Sheraton Centre', 189, '2019-01-31', 112, NULL),
('Sheraton Centre', 189, '2019-02-01', 353, NULL),
('Sheraton Centre', 189, '2019-02-02', 204, NULL),
('Sheraton Centre', 189, '2019-02-03', 298, NULL),
('Sheraton Centre', 189, '2019-02-04', 118, NULL),
('Sheraton Centre', 189, '2019-02-05', 382, NULL),
('Sheraton Centre', 189, '2019-02-06', 106, NULL),
('Sheraton Centre', 189, '2019-02-07', 116, NULL),
('Sheraton Centre', 189, '2019-02-08', 217, NULL),
('Sheraton Centre', 189, '2019-02-09', 378, NULL),
('Sheraton Centre', 189, '2019-02-10', 351, NULL),
('Sheraton Centre', 189, '2019-02-11', 300, NULL),
('Sheraton Centre', 189, '2019-02-12', 381, NULL),
('Sheraton Centre', 189, '2019-02-13', 377, NULL),
('Sheraton Centre', 189, '2019-02-14', 207, NULL),
('Sheraton Centre', 189, '2019-02-15', 192, NULL),
('Sheraton Centre', 189, '2019-02-16', 318, NULL),
('Sheraton Centre', 189, '2019-02-17', 322, NULL),
('Sheraton Centre', 189, '2019-02-18', 280, NULL),
('Sheraton Centre', 189, '2019-02-19', 252, NULL),
('Sheraton Centre', 189, '2019-02-20', 165, NULL),
('Sheraton Centre', 189, '2019-02-21', 365, NULL),
('Sheraton Centre', 189, '2019-02-22', 109, NULL),
('Sheraton Centre', 189, '2019-02-23', 220, NULL),
('Sheraton Centre', 189, '2019-02-24', 361, NULL),
('Sheraton Centre', 189, '2019-02-25', 162, NULL),
('Sheraton Centre', 189, '2019-02-26', 273, NULL),
('Sheraton Centre', 189, '2019-02-27', 112, NULL),
('Sheraton Centre', 189, '2019-02-28', 199, NULL),
('Sheraton Centre', 189, '2019-03-01', 274, NULL),
('Sheraton Centre', 189, '2019-03-02', 121, NULL),
('Sheraton Centre', 189, '2019-03-03', 120, NULL),
('Sheraton Centre', 189, '2019-03-04', 180, NULL),
('Sheraton Centre', 189, '2019-03-05', 215, NULL),
('Sheraton Centre', 189, '2019-03-06', 198, NULL),
('Sheraton Centre', 189, '2019-03-07', 315, NULL),
('Sheraton Centre', 189, '2019-03-08', 314, NULL),
('Sheraton Centre', 189, '2019-03-09', 269, NULL),
('Sheraton Centre', 189, '2019-03-10', 189, NULL),
('Sheraton Centre', 189, '2019-03-11', 212, NULL),
('Sheraton Centre', 189, '2019-03-12', 321, NULL),
('Sheraton Centre', 189, '2019-03-13', 187, NULL),
('Sheraton Centre', 189, '2019-03-14', 114, NULL),
('Sheraton Centre', 189, '2019-03-15', 135, NULL),
('Sheraton Centre', 189, '2019-03-16', 108, NULL),
('Sheraton Centre', 189, '2019-03-17', 391, NULL),
('Sheraton Centre', 189, '2019-03-18', 186, NULL),
('Sheraton Centre', 189, '2019-03-19', 263, NULL),
('Sheraton Centre', 189, '2019-03-20', 138, NULL),
('Sheraton Centre', 189, '2019-03-21', 127, NULL),
('Sheraton Centre', 189, '2019-03-22', 218, NULL),
('Sheraton Centre', 189, '2019-03-23', 380, NULL),
('Sheraton Centre', 189, '2019-03-24', 389, NULL),
('Sheraton Centre', 189, '2019-03-25', 298, NULL),
('Sheraton Centre', 189, '2019-03-26', 151, NULL),
('Sheraton Centre', 189, '2019-03-27', 137, NULL),
('Sheraton Centre', 189, '2019-03-28', 181, NULL),
('Sheraton Centre', 189, '2019-03-29', 189, NULL),
('Sheraton Centre', 189, '2019-03-30', 238, NULL),
('Sheraton Centre', 189, '2019-03-31', 103, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 189, '2019-04-01', 194, NULL),
('Sheraton Centre', 189, '2019-04-02', 113, NULL),
('Sheraton Centre', 189, '2019-04-03', 384, NULL),
('Sheraton Centre', 189, '2019-04-04', 195, NULL),
('Sheraton Centre', 189, '2019-04-05', 359, NULL),
('Sheraton Centre', 189, '2019-04-06', 216, NULL),
('Sheraton Centre', 189, '2019-04-07', 219, NULL),
('Sheraton Centre', 189, '2019-04-08', 293, NULL),
('Sheraton Centre', 189, '2019-04-09', 306, NULL),
('Sheraton Centre', 189, '2019-04-10', 165, NULL),
('Sheraton Centre', 189, '2019-04-11', 263, NULL),
('Sheraton Centre', 189, '2019-04-12', 378, NULL),
('Sheraton Centre', 189, '2019-04-13', 379, NULL),
('Sheraton Centre', 189, '2019-04-14', 211, NULL),
('Sheraton Centre', 189, '2019-04-15', 111, NULL),
('Sheraton Centre', 189, '2019-04-16', 178, NULL),
('Sheraton Centre', 189, '2019-04-17', 175, NULL),
('Sheraton Centre', 189, '2019-04-18', 247, NULL),
('Sheraton Centre', 189, '2019-04-19', 332, NULL),
('Sheraton Centre', 189, '2019-04-20', 308, NULL),
('Sheraton Centre', 189, '2019-04-21', 327, NULL),
('Sheraton Centre', 189, '2019-04-22', 203, NULL),
('Sheraton Centre', 189, '2019-04-23', 211, NULL),
('Sheraton Centre', 189, '2019-04-24', 280, NULL),
('Sheraton Centre', 189, '2019-04-25', 101, NULL),
('Sheraton Centre', 189, '2019-04-26', 254, NULL),
('Sheraton Centre', 189, '2019-04-27', 312, NULL),
('Sheraton Centre', 189, '2019-04-28', 320, NULL),
('Sheraton Centre', 189, '2019-04-29', 345, NULL),
('Sheraton Centre', 189, '2019-04-30', 350, NULL),
('Sheraton Centre', 189, '2019-05-01', 285, NULL),
('Sheraton Centre', 189, '2019-05-02', 101, NULL),
('Sheraton Centre', 189, '2019-05-03', 319, NULL),
('Sheraton Centre', 189, '2019-05-04', 221, NULL),
('Sheraton Centre', 189, '2019-05-05', 115, NULL),
('Sheraton Centre', 189, '2019-05-06', 349, NULL),
('Sheraton Centre', 189, '2019-05-07', 339, NULL),
('Sheraton Centre', 189, '2019-05-08', 341, NULL),
('Sheraton Centre', 189, '2019-05-09', 204, NULL),
('Sheraton Centre', 189, '2019-05-10', 163, NULL),
('Sheraton Centre', 189, '2019-05-11', 119, NULL),
('Sheraton Centre', 189, '2019-05-12', 103, NULL),
('Sheraton Centre', 189, '2019-05-13', 194, NULL),
('Sheraton Centre', 189, '2019-05-14', 378, NULL),
('Sheraton Centre', 189, '2019-05-15', 379, NULL),
('Sheraton Centre', 189, '2019-05-16', 167, NULL),
('Sheraton Centre', 189, '2019-05-17', 309, NULL),
('Sheraton Centre', 189, '2019-05-18', 383, NULL),
('Sheraton Centre', 189, '2019-05-19', 252, NULL),
('Sheraton Centre', 189, '2019-05-20', 242, NULL),
('Sheraton Centre', 189, '2019-05-21', 251, NULL),
('Sheraton Centre', 189, '2019-05-22', 319, NULL),
('Sheraton Centre', 189, '2019-05-23', 326, NULL),
('Sheraton Centre', 189, '2019-05-24', 373, NULL),
('Sheraton Centre', 189, '2019-05-25', 173, NULL),
('Sheraton Centre', 189, '2019-05-26', 249, NULL),
('Sheraton Centre', 189, '2019-05-27', 158, NULL),
('Sheraton Centre', 189, '2019-05-28', 185, NULL),
('Sheraton Centre', 189, '2019-05-29', 243, NULL),
('Sheraton Centre', 189, '2019-05-30', 177, NULL),
('Sheraton Centre', 189, '2019-05-31', 397, NULL),
('Sheraton Centre', 189, '2019-06-01', 296, NULL),
('Sheraton Centre', 189, '2019-06-02', 115, NULL),
('Sheraton Centre', 189, '2019-06-03', 138, NULL),
('Sheraton Centre', 189, '2019-06-04', 251, NULL),
('Sheraton Centre', 189, '2019-06-05', 267, NULL),
('Sheraton Centre', 189, '2019-06-06', 336, NULL),
('Sheraton Centre', 189, '2019-06-07', 280, NULL),
('Sheraton Centre', 189, '2019-06-08', 257, NULL),
('Sheraton Centre', 189, '2019-06-09', 263, NULL),
('Sheraton Centre', 189, '2019-06-10', 283, NULL),
('Sheraton Centre', 189, '2019-06-11', 190, NULL),
('Sheraton Centre', 189, '2019-06-12', 271, NULL),
('Sheraton Centre', 189, '2019-06-13', 282, NULL),
('Sheraton Centre', 189, '2019-06-14', 334, NULL),
('Sheraton Centre', 189, '2019-06-15', 222, NULL),
('Sheraton Centre', 189, '2019-06-16', 131, NULL),
('Sheraton Centre', 189, '2019-06-17', 372, NULL),
('Sheraton Centre', 189, '2019-06-18', 377, NULL),
('Sheraton Centre', 189, '2019-06-19', 251, NULL),
('Sheraton Centre', 189, '2019-06-20', 288, NULL),
('Sheraton Centre', 189, '2019-06-21', 133, NULL),
('Sheraton Centre', 189, '2019-06-22', 391, NULL),
('Sheraton Centre', 189, '2019-06-23', 190, NULL),
('Sheraton Centre', 189, '2019-06-24', 210, NULL),
('Sheraton Centre', 189, '2019-06-25', 196, NULL),
('Sheraton Centre', 189, '2019-06-26', 275, NULL),
('Sheraton Centre', 189, '2019-06-27', 139, NULL),
('Sheraton Centre', 189, '2019-06-28', 179, NULL),
('Sheraton Centre', 189, '2019-06-29', 158, NULL),
('Sheraton Centre', 189, '2019-06-30', 331, NULL),
('Sheraton Centre', 189, '2019-07-01', 365, NULL),
('Sheraton Centre', 189, '2019-07-02', 387, NULL),
('Sheraton Centre', 189, '2019-07-03', 364, NULL),
('Sheraton Centre', 189, '2019-07-04', 379, NULL),
('Sheraton Centre', 189, '2019-07-05', 284, NULL),
('Sheraton Centre', 189, '2019-07-06', 235, NULL),
('Sheraton Centre', 189, '2019-07-07', 223, NULL),
('Sheraton Centre', 189, '2019-07-08', 115, NULL),
('Sheraton Centre', 189, '2019-07-09', 300, NULL),
('Sheraton Centre', 189, '2019-07-10', 382, NULL),
('Sheraton Centre', 189, '2019-07-11', 315, NULL),
('Sheraton Centre', 189, '2019-07-12', 349, NULL),
('Sheraton Centre', 189, '2019-07-13', 166, NULL),
('Sheraton Centre', 189, '2019-07-14', 323, NULL),
('Sheraton Centre', 189, '2019-07-15', 375, NULL),
('Sheraton Centre', 189, '2019-07-16', 254, NULL),
('Sheraton Centre', 189, '2019-07-17', 371, NULL),
('Sheraton Centre', 189, '2019-07-18', 207, NULL),
('Sheraton Centre', 189, '2019-07-19', 254, NULL),
('Sheraton Centre', 189, '2019-07-20', 264, NULL),
('Sheraton Centre', 189, '2019-07-21', 292, NULL),
('Sheraton Centre', 189, '2019-07-22', 353, NULL),
('Sheraton Centre', 189, '2019-07-23', 335, NULL),
('Sheraton Centre', 189, '2019-07-24', 336, NULL),
('Sheraton Centre', 189, '2019-07-25', 311, NULL),
('Sheraton Centre', 189, '2019-07-26', 364, NULL),
('Sheraton Centre', 189, '2019-07-27', 228, NULL),
('Sheraton Centre', 189, '2019-07-28', 160, NULL),
('Sheraton Centre', 189, '2019-07-29', 372, NULL),
('Sheraton Centre', 189, '2019-07-30', 220, NULL),
('Sheraton Centre', 189, '2019-07-31', 330, NULL),
('Sheraton Centre', 189, '2019-08-01', 376, NULL),
('Sheraton Centre', 189, '2019-08-02', 375, NULL),
('Sheraton Centre', 189, '2019-08-03', 179, NULL),
('Sheraton Centre', 189, '2019-08-04', 159, NULL),
('Sheraton Centre', 189, '2019-08-05', 224, NULL),
('Sheraton Centre', 189, '2019-08-06', 268, NULL),
('Sheraton Centre', 189, '2019-08-07', 243, NULL),
('Sheraton Centre', 189, '2019-08-08', 351, NULL),
('Sheraton Centre', 189, '2019-08-09', 181, NULL),
('Sheraton Centre', 189, '2019-08-10', 198, NULL),
('Sheraton Centre', 189, '2019-08-11', 179, NULL),
('Sheraton Centre', 189, '2019-08-12', 113, NULL),
('Sheraton Centre', 189, '2019-08-13', 149, NULL),
('Sheraton Centre', 189, '2019-08-14', 110, NULL),
('Sheraton Centre', 189, '2019-08-15', 382, NULL),
('Sheraton Centre', 189, '2019-08-16', 242, NULL),
('Sheraton Centre', 189, '2019-08-17', 107, NULL),
('Sheraton Centre', 189, '2019-08-18', 295, NULL),
('Sheraton Centre', 189, '2019-08-19', 385, NULL),
('Sheraton Centre', 189, '2019-08-20', 125, NULL),
('Sheraton Centre', 189, '2019-08-21', 308, NULL),
('Sheraton Centre', 189, '2019-08-22', 213, NULL),
('Sheraton Centre', 189, '2019-08-23', 134, NULL),
('Sheraton Centre', 189, '2019-08-24', 156, NULL),
('Sheraton Centre', 189, '2019-08-25', 197, NULL),
('Sheraton Centre', 189, '2019-08-26', 121, NULL),
('Sheraton Centre', 189, '2019-08-27', 376, NULL),
('Sheraton Centre', 189, '2019-08-28', 182, NULL),
('Sheraton Centre', 189, '2019-08-29', 154, NULL),
('Sheraton Centre', 189, '2019-08-30', 386, NULL),
('Sheraton Centre', 189, '2019-08-31', 178, NULL),
('Sheraton Centre', 189, '2019-09-01', 118, NULL),
('Sheraton Centre', 189, '2019-09-02', 129, NULL),
('Sheraton Centre', 189, '2019-09-03', 296, NULL),
('Sheraton Centre', 189, '2019-09-04', 280, NULL),
('Sheraton Centre', 189, '2019-09-05', 372, NULL),
('Sheraton Centre', 189, '2019-09-06', 363, NULL),
('Sheraton Centre', 189, '2019-09-07', 346, NULL),
('Sheraton Centre', 189, '2019-09-08', 331, NULL),
('Sheraton Centre', 189, '2019-09-09', 127, NULL),
('Sheraton Centre', 189, '2019-09-10', 342, NULL),
('Sheraton Centre', 189, '2019-09-11', 185, NULL),
('Sheraton Centre', 189, '2019-09-12', 349, NULL),
('Sheraton Centre', 189, '2019-09-13', 234, NULL),
('Sheraton Centre', 189, '2019-09-14', 352, NULL),
('Sheraton Centre', 189, '2019-09-15', 246, NULL),
('Sheraton Centre', 189, '2019-09-16', 337, NULL),
('Sheraton Centre', 189, '2019-09-17', 331, NULL),
('Sheraton Centre', 189, '2019-09-18', 127, NULL),
('Sheraton Centre', 189, '2019-09-19', 191, NULL),
('Sheraton Centre', 189, '2019-09-20', 225, NULL),
('Sheraton Centre', 189, '2019-09-21', 274, NULL),
('Sheraton Centre', 189, '2019-09-22', 157, NULL),
('Sheraton Centre', 189, '2019-09-23', 301, NULL),
('Sheraton Centre', 189, '2019-09-24', 232, NULL),
('Sheraton Centre', 189, '2019-09-25', 189, NULL),
('Sheraton Centre', 189, '2019-09-26', 318, NULL),
('Sheraton Centre', 189, '2019-09-27', 255, NULL),
('Sheraton Centre', 189, '2019-09-28', 281, NULL),
('Sheraton Centre', 189, '2019-09-29', 136, NULL),
('Sheraton Centre', 189, '2019-09-30', 154, NULL),
('Sheraton Centre', 189, '2019-10-01', 318, NULL),
('Sheraton Centre', 189, '2019-10-02', 344, NULL),
('Sheraton Centre', 189, '2019-10-03', 142, NULL),
('Sheraton Centre', 189, '2019-10-04', 308, NULL),
('Sheraton Centre', 189, '2019-10-05', 254, NULL),
('Sheraton Centre', 189, '2019-10-06', 275, NULL),
('Sheraton Centre', 189, '2019-10-07', 297, NULL),
('Sheraton Centre', 189, '2019-10-08', 274, NULL),
('Sheraton Centre', 189, '2019-10-09', 189, NULL),
('Sheraton Centre', 189, '2019-10-10', 151, NULL),
('Sheraton Centre', 189, '2019-10-11', 323, NULL),
('Sheraton Centre', 189, '2019-10-12', 376, NULL),
('Sheraton Centre', 189, '2019-10-13', 114, NULL),
('Sheraton Centre', 189, '2019-10-14', 390, NULL),
('Sheraton Centre', 189, '2019-10-15', 356, NULL),
('Sheraton Centre', 189, '2019-10-16', 119, NULL),
('Sheraton Centre', 189, '2019-10-17', 238, NULL),
('Sheraton Centre', 189, '2019-10-18', 121, NULL),
('Sheraton Centre', 189, '2019-10-19', 246, NULL),
('Sheraton Centre', 189, '2019-10-20', 368, NULL),
('Sheraton Centre', 189, '2019-10-21', 390, NULL),
('Sheraton Centre', 189, '2019-10-22', 170, NULL),
('Sheraton Centre', 189, '2019-10-23', 270, NULL),
('Sheraton Centre', 189, '2019-10-24', 243, NULL),
('Sheraton Centre', 189, '2019-10-25', 259, NULL),
('Sheraton Centre', 189, '2019-10-26', 152, NULL),
('Sheraton Centre', 189, '2019-10-27', 320, NULL),
('Sheraton Centre', 189, '2019-10-28', 330, NULL),
('Sheraton Centre', 189, '2019-10-29', 196, NULL),
('Sheraton Centre', 189, '2019-10-30', 192, NULL),
('Sheraton Centre', 189, '2019-10-31', 157, NULL),
('Sheraton Centre', 189, '2019-11-01', 138, NULL),
('Sheraton Centre', 189, '2019-11-02', 225, NULL),
('Sheraton Centre', 189, '2019-11-03', 181, NULL),
('Sheraton Centre', 189, '2019-11-04', 371, NULL),
('Sheraton Centre', 189, '2019-11-05', 213, NULL),
('Sheraton Centre', 189, '2019-11-06', 238, NULL),
('Sheraton Centre', 189, '2019-11-07', 258, NULL),
('Sheraton Centre', 189, '2019-11-08', 241, NULL),
('Sheraton Centre', 189, '2019-11-09', 352, NULL),
('Sheraton Centre', 189, '2019-11-10', 123, NULL),
('Sheraton Centre', 189, '2019-11-11', 208, NULL),
('Sheraton Centre', 189, '2019-11-12', 155, NULL),
('Sheraton Centre', 189, '2019-11-13', 275, NULL),
('Sheraton Centre', 189, '2019-11-14', 356, NULL),
('Sheraton Centre', 189, '2019-11-15', 292, NULL),
('Sheraton Centre', 189, '2019-11-16', 108, NULL),
('Sheraton Centre', 189, '2019-11-17', 302, NULL),
('Sheraton Centre', 189, '2019-11-18', 355, NULL),
('Sheraton Centre', 189, '2019-11-19', 122, NULL),
('Sheraton Centre', 189, '2019-11-20', 158, NULL),
('Sheraton Centre', 189, '2019-11-21', 265, NULL),
('Sheraton Centre', 189, '2019-11-22', 310, NULL),
('Sheraton Centre', 189, '2019-11-23', 210, NULL),
('Sheraton Centre', 189, '2019-11-24', 286, NULL),
('Sheraton Centre', 189, '2019-11-25', 113, NULL),
('Sheraton Centre', 189, '2019-11-26', 217, NULL),
('Sheraton Centre', 189, '2019-11-27', 145, NULL),
('Sheraton Centre', 189, '2019-11-28', 274, NULL),
('Sheraton Centre', 189, '2019-11-29', 174, NULL),
('Sheraton Centre', 189, '2019-11-30', 241, NULL),
('Sheraton Centre', 189, '2019-12-01', 334, NULL),
('Sheraton Centre', 189, '2019-12-02', 386, NULL),
('Sheraton Centre', 189, '2019-12-03', 181, NULL),
('Sheraton Centre', 189, '2019-12-04', 154, NULL),
('Sheraton Centre', 189, '2019-12-05', 256, NULL),
('Sheraton Centre', 189, '2019-12-06', 170, NULL),
('Sheraton Centre', 189, '2019-12-07', 285, NULL),
('Sheraton Centre', 189, '2019-12-08', 174, NULL),
('Sheraton Centre', 189, '2019-12-09', 313, NULL),
('Sheraton Centre', 189, '2019-12-10', 316, NULL),
('Sheraton Centre', 189, '2019-12-11', 384, NULL),
('Sheraton Centre', 189, '2019-12-12', 121, NULL),
('Sheraton Centre', 189, '2019-12-13', 227, NULL),
('Sheraton Centre', 189, '2019-12-14', 112, NULL),
('Sheraton Centre', 189, '2019-12-15', 345, NULL),
('Sheraton Centre', 189, '2019-12-16', 200, NULL),
('Sheraton Centre', 189, '2019-12-17', 367, NULL),
('Sheraton Centre', 189, '2019-12-18', 241, NULL),
('Sheraton Centre', 189, '2019-12-19', 210, NULL),
('Sheraton Centre', 189, '2019-12-20', 378, NULL),
('Sheraton Centre', 189, '2019-12-21', 179, NULL),
('Sheraton Centre', 189, '2019-12-22', 180, NULL),
('Sheraton Centre', 189, '2019-12-23', 306, NULL),
('Sheraton Centre', 189, '2019-12-24', 346, NULL),
('Sheraton Centre', 189, '2019-12-25', 301, NULL),
('Sheraton Centre', 189, '2019-12-26', 185, NULL),
('Sheraton Centre', 189, '2019-12-27', 318, NULL),
('Sheraton Centre', 189, '2019-12-28', 210, NULL),
('Sheraton Centre', 189, '2019-12-29', 309, NULL),
('Sheraton Centre', 189, '2019-12-30', 179, NULL),
('Sheraton Centre', 189, '2019-12-31', 131, NULL),
('Sheraton Centre', 189, '2020-01-01', 248, NULL),
('Sheraton Centre', 189, '2020-01-02', 279, NULL),
('Sheraton Centre', 189, '2020-01-03', 335, NULL),
('Sheraton Centre', 189, '2020-01-04', 158, NULL),
('Sheraton Centre', 189, '2020-01-05', 120, NULL),
('Sheraton Centre', 189, '2020-01-06', 223, NULL),
('Sheraton Centre', 189, '2020-01-07', 356, NULL),
('Sheraton Centre', 189, '2020-01-08', 212, NULL),
('Sheraton Centre', 189, '2020-01-09', 136, NULL),
('Sheraton Centre', 189, '2020-01-10', 313, NULL),
('Sheraton Centre', 189, '2020-01-11', 237, NULL),
('Sheraton Centre', 189, '2020-01-12', 101, NULL),
('Sheraton Centre', 189, '2020-01-13', 190, NULL),
('Sheraton Centre', 189, '2020-01-14', 330, NULL),
('Sheraton Centre', 189, '2020-01-15', 158, NULL),
('Sheraton Centre', 189, '2020-01-16', 102, NULL),
('Sheraton Centre', 189, '2020-01-17', 352, NULL),
('Sheraton Centre', 189, '2020-01-18', 190, NULL),
('Sheraton Centre', 189, '2020-01-19', 376, NULL),
('Sheraton Centre', 189, '2020-01-20', 384, NULL),
('Sheraton Centre', 189, '2020-01-21', 195, NULL),
('Sheraton Centre', 189, '2020-01-22', 161, NULL),
('Sheraton Centre', 189, '2020-01-23', 300, NULL),
('Sheraton Centre', 189, '2020-01-24', 225, NULL),
('Sheraton Centre', 189, '2020-01-25', 299, NULL),
('Sheraton Centre', 189, '2020-01-26', 265, NULL),
('Sheraton Centre', 189, '2020-01-27', 379, NULL),
('Sheraton Centre', 189, '2020-01-28', 322, NULL),
('Sheraton Centre', 189, '2020-01-29', 195, NULL),
('Sheraton Centre', 189, '2020-01-30', 390, NULL),
('Sheraton Centre', 189, '2020-01-31', 101, NULL),
('Sheraton Centre', 189, '2020-02-01', 126, NULL),
('Sheraton Centre', 189, '2020-02-02', 378, NULL),
('Sheraton Centre', 189, '2020-02-03', 267, NULL),
('Sheraton Centre', 189, '2020-02-04', 389, NULL),
('Sheraton Centre', 210, '2019-01-01', 140, NULL),
('Sheraton Centre', 210, '2019-01-02', 151, NULL),
('Sheraton Centre', 210, '2019-01-03', 234, NULL),
('Sheraton Centre', 210, '2019-01-04', 265, NULL),
('Sheraton Centre', 210, '2019-01-05', 147, NULL),
('Sheraton Centre', 210, '2019-01-06', 261, NULL),
('Sheraton Centre', 210, '2019-01-07', 293, NULL),
('Sheraton Centre', 210, '2019-01-08', 174, NULL),
('Sheraton Centre', 210, '2019-01-09', 183, NULL),
('Sheraton Centre', 210, '2019-01-10', 128, NULL),
('Sheraton Centre', 210, '2019-01-11', 121, NULL),
('Sheraton Centre', 210, '2019-01-12', 276, NULL),
('Sheraton Centre', 210, '2019-01-13', 132, NULL),
('Sheraton Centre', 210, '2019-01-14', 212, NULL),
('Sheraton Centre', 210, '2019-01-15', 377, NULL),
('Sheraton Centre', 210, '2019-01-16', 287, NULL),
('Sheraton Centre', 210, '2019-01-17', 101, NULL),
('Sheraton Centre', 210, '2019-01-18', 377, NULL),
('Sheraton Centre', 210, '2019-01-19', 390, NULL),
('Sheraton Centre', 210, '2019-01-20', 281, NULL),
('Sheraton Centre', 210, '2019-01-21', 132, NULL),
('Sheraton Centre', 210, '2019-01-22', 274, NULL),
('Sheraton Centre', 210, '2019-01-23', 128, NULL),
('Sheraton Centre', 210, '2019-01-24', 210, NULL),
('Sheraton Centre', 210, '2019-01-25', 345, NULL),
('Sheraton Centre', 210, '2019-01-26', 219, NULL),
('Sheraton Centre', 210, '2019-01-27', 108, NULL),
('Sheraton Centre', 210, '2019-01-28', 292, NULL),
('Sheraton Centre', 210, '2019-01-29', 115, NULL),
('Sheraton Centre', 210, '2019-01-30', 395, NULL),
('Sheraton Centre', 210, '2019-01-31', 289, NULL),
('Sheraton Centre', 210, '2019-02-01', 285, NULL),
('Sheraton Centre', 210, '2019-02-02', 217, NULL),
('Sheraton Centre', 210, '2019-02-03', 362, NULL),
('Sheraton Centre', 210, '2019-02-04', 127, NULL),
('Sheraton Centre', 210, '2019-02-05', 169, NULL),
('Sheraton Centre', 210, '2019-02-06', 270, NULL),
('Sheraton Centre', 210, '2019-02-07', 347, NULL),
('Sheraton Centre', 210, '2019-02-08', 206, NULL),
('Sheraton Centre', 210, '2019-02-09', 320, NULL),
('Sheraton Centre', 210, '2019-02-10', 301, NULL),
('Sheraton Centre', 210, '2019-02-11', 395, NULL),
('Sheraton Centre', 210, '2019-02-12', 178, NULL),
('Sheraton Centre', 210, '2019-02-13', 178, NULL),
('Sheraton Centre', 210, '2019-02-14', 349, NULL),
('Sheraton Centre', 210, '2019-02-15', 223, NULL),
('Sheraton Centre', 210, '2019-02-16', 379, NULL),
('Sheraton Centre', 210, '2019-02-17', 287, NULL),
('Sheraton Centre', 210, '2019-02-18', 270, NULL),
('Sheraton Centre', 210, '2019-02-19', 181, NULL),
('Sheraton Centre', 210, '2019-02-20', 379, NULL),
('Sheraton Centre', 210, '2019-02-21', 220, NULL),
('Sheraton Centre', 210, '2019-02-22', 112, NULL),
('Sheraton Centre', 210, '2019-02-23', 295, NULL),
('Sheraton Centre', 210, '2019-02-24', 239, NULL),
('Sheraton Centre', 210, '2019-02-25', 179, NULL),
('Sheraton Centre', 210, '2019-02-26', 351, NULL),
('Sheraton Centre', 210, '2019-02-27', 112, NULL),
('Sheraton Centre', 210, '2019-02-28', 185, NULL),
('Sheraton Centre', 210, '2019-03-01', 149, NULL),
('Sheraton Centre', 210, '2019-03-02', 323, NULL),
('Sheraton Centre', 210, '2019-03-03', 375, NULL),
('Sheraton Centre', 210, '2019-03-04', 312, NULL),
('Sheraton Centre', 210, '2019-03-05', 240, NULL),
('Sheraton Centre', 210, '2019-03-06', 225, NULL),
('Sheraton Centre', 210, '2019-03-07', 142, NULL),
('Sheraton Centre', 210, '2019-03-08', 197, NULL),
('Sheraton Centre', 210, '2019-03-09', 160, NULL),
('Sheraton Centre', 210, '2019-03-10', 281, NULL),
('Sheraton Centre', 210, '2019-03-11', 330, NULL),
('Sheraton Centre', 210, '2019-03-12', 320, NULL),
('Sheraton Centre', 210, '2019-03-13', 186, NULL),
('Sheraton Centre', 210, '2019-03-14', 197, NULL),
('Sheraton Centre', 210, '2019-03-15', 216, NULL),
('Sheraton Centre', 210, '2019-03-16', 137, NULL),
('Sheraton Centre', 210, '2019-03-17', 129, NULL),
('Sheraton Centre', 210, '2019-03-18', 106, NULL),
('Sheraton Centre', 210, '2019-03-19', 245, NULL),
('Sheraton Centre', 210, '2019-03-20', 163, NULL),
('Sheraton Centre', 210, '2019-03-21', 237, NULL),
('Sheraton Centre', 210, '2019-03-22', 388, NULL),
('Sheraton Centre', 210, '2019-03-23', 213, NULL),
('Sheraton Centre', 210, '2019-03-24', 173, NULL),
('Sheraton Centre', 210, '2019-03-25', 117, NULL),
('Sheraton Centre', 210, '2019-03-26', 319, NULL),
('Sheraton Centre', 210, '2019-03-27', 374, NULL),
('Sheraton Centre', 210, '2019-03-28', 302, NULL),
('Sheraton Centre', 210, '2019-03-29', 316, NULL),
('Sheraton Centre', 210, '2019-03-30', 391, NULL),
('Sheraton Centre', 210, '2019-03-31', 290, NULL),
('Sheraton Centre', 210, '2019-04-01', 106, NULL),
('Sheraton Centre', 210, '2019-04-02', 307, NULL),
('Sheraton Centre', 210, '2019-04-03', 375, NULL),
('Sheraton Centre', 210, '2019-04-04', 303, NULL),
('Sheraton Centre', 210, '2019-04-05', 333, NULL),
('Sheraton Centre', 210, '2019-04-06', 133, NULL),
('Sheraton Centre', 210, '2019-04-07', 183, NULL),
('Sheraton Centre', 210, '2019-04-08', 107, NULL),
('Sheraton Centre', 210, '2019-04-09', 257, NULL),
('Sheraton Centre', 210, '2019-04-10', 144, NULL),
('Sheraton Centre', 210, '2019-04-11', 384, NULL),
('Sheraton Centre', 210, '2019-04-12', 287, NULL),
('Sheraton Centre', 210, '2019-04-13', 221, NULL),
('Sheraton Centre', 210, '2019-04-14', 392, NULL),
('Sheraton Centre', 210, '2019-04-15', 156, NULL),
('Sheraton Centre', 210, '2019-04-16', 352, NULL),
('Sheraton Centre', 210, '2019-04-17', 313, NULL),
('Sheraton Centre', 210, '2019-04-18', 187, NULL),
('Sheraton Centre', 210, '2019-04-19', 374, NULL),
('Sheraton Centre', 210, '2019-04-20', 311, NULL),
('Sheraton Centre', 210, '2019-04-21', 222, NULL),
('Sheraton Centre', 210, '2019-04-22', 307, NULL),
('Sheraton Centre', 210, '2019-04-23', 332, NULL),
('Sheraton Centre', 210, '2019-04-24', 196, NULL),
('Sheraton Centre', 210, '2019-04-25', 187, NULL),
('Sheraton Centre', 210, '2019-04-26', 231, NULL),
('Sheraton Centre', 210, '2019-04-27', 208, NULL),
('Sheraton Centre', 210, '2019-04-28', 199, NULL),
('Sheraton Centre', 210, '2019-04-29', 355, NULL),
('Sheraton Centre', 210, '2019-04-30', 369, NULL),
('Sheraton Centre', 210, '2019-05-01', 286, NULL),
('Sheraton Centre', 210, '2019-05-02', 134, NULL),
('Sheraton Centre', 210, '2019-05-03', 328, NULL),
('Sheraton Centre', 210, '2019-05-04', 140, NULL),
('Sheraton Centre', 210, '2019-05-05', 359, NULL),
('Sheraton Centre', 210, '2019-05-06', 316, NULL),
('Sheraton Centre', 210, '2019-05-07', 346, NULL),
('Sheraton Centre', 210, '2019-05-08', 289, NULL),
('Sheraton Centre', 210, '2019-05-09', 398, NULL),
('Sheraton Centre', 210, '2019-05-10', 311, NULL),
('Sheraton Centre', 210, '2019-05-11', 323, NULL),
('Sheraton Centre', 210, '2019-05-12', 210, NULL),
('Sheraton Centre', 210, '2019-05-13', 214, NULL),
('Sheraton Centre', 210, '2019-05-14', 302, NULL),
('Sheraton Centre', 210, '2019-05-15', 164, NULL),
('Sheraton Centre', 210, '2019-05-16', 183, NULL),
('Sheraton Centre', 210, '2019-05-17', 276, NULL),
('Sheraton Centre', 210, '2019-05-18', 209, NULL),
('Sheraton Centre', 210, '2019-05-19', 258, NULL),
('Sheraton Centre', 210, '2019-05-20', 235, NULL),
('Sheraton Centre', 210, '2019-05-21', 359, NULL),
('Sheraton Centre', 210, '2019-05-22', 244, NULL),
('Sheraton Centre', 210, '2019-05-23', 288, NULL),
('Sheraton Centre', 210, '2019-05-24', 278, NULL),
('Sheraton Centre', 210, '2019-05-25', 341, NULL),
('Sheraton Centre', 210, '2019-05-26', 356, NULL),
('Sheraton Centre', 210, '2019-05-27', 338, NULL),
('Sheraton Centre', 210, '2019-05-28', 294, NULL),
('Sheraton Centre', 210, '2019-05-29', 269, NULL),
('Sheraton Centre', 210, '2019-05-30', 183, NULL),
('Sheraton Centre', 210, '2019-05-31', 261, NULL),
('Sheraton Centre', 210, '2019-06-01', 292, NULL),
('Sheraton Centre', 210, '2019-06-02', 331, NULL),
('Sheraton Centre', 210, '2019-06-03', 268, NULL),
('Sheraton Centre', 210, '2019-06-04', 137, NULL),
('Sheraton Centre', 210, '2019-06-05', 275, NULL),
('Sheraton Centre', 210, '2019-06-06', 295, NULL),
('Sheraton Centre', 210, '2019-06-07', 226, NULL),
('Sheraton Centre', 210, '2019-06-08', 168, NULL),
('Sheraton Centre', 210, '2019-06-09', 325, NULL),
('Sheraton Centre', 210, '2019-06-10', 302, NULL),
('Sheraton Centre', 210, '2019-06-11', 222, NULL),
('Sheraton Centre', 210, '2019-06-12', 376, NULL),
('Sheraton Centre', 210, '2019-06-13', 220, NULL),
('Sheraton Centre', 210, '2019-06-14', 298, NULL),
('Sheraton Centre', 210, '2019-06-15', 242, NULL),
('Sheraton Centre', 210, '2019-06-16', 257, NULL),
('Sheraton Centre', 210, '2019-06-17', 386, NULL),
('Sheraton Centre', 210, '2019-06-18', 374, NULL),
('Sheraton Centre', 210, '2019-06-19', 373, NULL),
('Sheraton Centre', 210, '2019-06-20', 287, NULL),
('Sheraton Centre', 210, '2019-06-21', 174, NULL),
('Sheraton Centre', 210, '2019-06-22', 163, NULL),
('Sheraton Centre', 210, '2019-06-23', 263, NULL),
('Sheraton Centre', 210, '2019-06-24', 156, NULL),
('Sheraton Centre', 210, '2019-06-25', 349, NULL),
('Sheraton Centre', 210, '2019-06-26', 175, NULL),
('Sheraton Centre', 210, '2019-06-27', 328, NULL),
('Sheraton Centre', 210, '2019-06-28', 215, NULL),
('Sheraton Centre', 210, '2019-06-29', 213, NULL),
('Sheraton Centre', 210, '2019-06-30', 148, NULL),
('Sheraton Centre', 210, '2019-07-01', 160, NULL),
('Sheraton Centre', 210, '2019-07-02', 235, NULL),
('Sheraton Centre', 210, '2019-07-03', 176, NULL),
('Sheraton Centre', 210, '2019-07-04', 386, NULL),
('Sheraton Centre', 210, '2019-07-05', 312, NULL),
('Sheraton Centre', 210, '2019-07-06', 250, NULL),
('Sheraton Centre', 210, '2019-07-07', 312, NULL),
('Sheraton Centre', 210, '2019-07-08', 233, NULL),
('Sheraton Centre', 210, '2019-07-09', 221, NULL),
('Sheraton Centre', 210, '2019-07-10', 105, NULL),
('Sheraton Centre', 210, '2019-07-11', 388, NULL),
('Sheraton Centre', 210, '2019-07-12', 355, NULL),
('Sheraton Centre', 210, '2019-07-13', 373, NULL),
('Sheraton Centre', 210, '2019-07-14', 388, NULL),
('Sheraton Centre', 210, '2019-07-15', 219, NULL),
('Sheraton Centre', 210, '2019-07-16', 338, NULL),
('Sheraton Centre', 210, '2019-07-17', 374, NULL),
('Sheraton Centre', 210, '2019-07-18', 126, NULL),
('Sheraton Centre', 210, '2019-07-19', 321, NULL),
('Sheraton Centre', 210, '2019-07-20', 155, NULL),
('Sheraton Centre', 210, '2019-07-21', 354, NULL),
('Sheraton Centre', 210, '2019-07-22', 200, NULL),
('Sheraton Centre', 210, '2019-07-23', 206, NULL),
('Sheraton Centre', 210, '2019-07-24', 119, NULL),
('Sheraton Centre', 210, '2019-07-25', 136, NULL),
('Sheraton Centre', 210, '2019-07-26', 263, NULL),
('Sheraton Centre', 210, '2019-07-27', 297, NULL),
('Sheraton Centre', 210, '2019-07-28', 179, NULL),
('Sheraton Centre', 210, '2019-07-29', 100, NULL),
('Sheraton Centre', 210, '2019-07-30', 329, NULL),
('Sheraton Centre', 210, '2019-07-31', 267, NULL),
('Sheraton Centre', 210, '2019-08-01', 220, NULL),
('Sheraton Centre', 210, '2019-08-02', 303, NULL),
('Sheraton Centre', 210, '2019-08-03', 203, NULL),
('Sheraton Centre', 210, '2019-08-04', 103, NULL),
('Sheraton Centre', 210, '2019-08-05', 383, NULL),
('Sheraton Centre', 210, '2019-08-06', 203, NULL),
('Sheraton Centre', 210, '2019-08-07', 345, NULL),
('Sheraton Centre', 210, '2019-08-08', 189, NULL),
('Sheraton Centre', 210, '2019-08-09', 363, NULL),
('Sheraton Centre', 210, '2019-08-10', 382, NULL),
('Sheraton Centre', 210, '2019-08-11', 248, NULL),
('Sheraton Centre', 210, '2019-08-12', 395, NULL),
('Sheraton Centre', 210, '2019-08-13', 248, NULL),
('Sheraton Centre', 210, '2019-08-14', 325, NULL),
('Sheraton Centre', 210, '2019-08-15', 336, NULL),
('Sheraton Centre', 210, '2019-08-16', 342, NULL),
('Sheraton Centre', 210, '2019-08-17', 138, NULL),
('Sheraton Centre', 210, '2019-08-18', 158, NULL),
('Sheraton Centre', 210, '2019-08-19', 382, NULL),
('Sheraton Centre', 210, '2019-08-20', 317, NULL),
('Sheraton Centre', 210, '2019-08-21', 319, NULL),
('Sheraton Centre', 210, '2019-08-22', 322, NULL),
('Sheraton Centre', 210, '2019-08-23', 301, NULL),
('Sheraton Centre', 210, '2019-08-24', 148, NULL),
('Sheraton Centre', 210, '2019-08-25', 173, NULL),
('Sheraton Centre', 210, '2019-08-26', 269, NULL),
('Sheraton Centre', 210, '2019-08-27', 133, NULL),
('Sheraton Centre', 210, '2019-08-28', 221, NULL),
('Sheraton Centre', 210, '2019-08-29', 250, NULL),
('Sheraton Centre', 210, '2019-08-30', 293, NULL),
('Sheraton Centre', 210, '2019-08-31', 226, NULL),
('Sheraton Centre', 210, '2019-09-01', 138, NULL),
('Sheraton Centre', 210, '2019-09-02', 194, NULL),
('Sheraton Centre', 210, '2019-09-03', 372, NULL),
('Sheraton Centre', 210, '2019-09-04', 322, NULL),
('Sheraton Centre', 210, '2019-09-05', 122, NULL),
('Sheraton Centre', 210, '2019-09-06', 127, NULL),
('Sheraton Centre', 210, '2019-09-07', 146, NULL),
('Sheraton Centre', 210, '2019-09-08', 159, NULL),
('Sheraton Centre', 210, '2019-09-09', 139, NULL),
('Sheraton Centre', 210, '2019-09-10', 159, NULL),
('Sheraton Centre', 210, '2019-09-11', 351, NULL),
('Sheraton Centre', 210, '2019-09-12', 371, NULL),
('Sheraton Centre', 210, '2019-09-13', 249, NULL),
('Sheraton Centre', 210, '2019-09-14', 371, NULL),
('Sheraton Centre', 210, '2019-09-15', 187, NULL),
('Sheraton Centre', 210, '2019-09-16', 171, NULL),
('Sheraton Centre', 210, '2019-09-17', 346, NULL),
('Sheraton Centre', 210, '2019-09-18', 253, NULL),
('Sheraton Centre', 210, '2019-09-19', 212, NULL),
('Sheraton Centre', 210, '2019-09-20', 389, NULL),
('Sheraton Centre', 210, '2019-09-21', 188, NULL),
('Sheraton Centre', 210, '2019-09-22', 361, NULL),
('Sheraton Centre', 210, '2019-09-23', 273, NULL),
('Sheraton Centre', 210, '2019-09-24', 215, NULL),
('Sheraton Centre', 210, '2019-09-25', 139, NULL),
('Sheraton Centre', 210, '2019-09-26', 104, NULL),
('Sheraton Centre', 210, '2019-09-27', 363, NULL),
('Sheraton Centre', 210, '2019-09-28', 227, NULL),
('Sheraton Centre', 210, '2019-09-29', 157, NULL),
('Sheraton Centre', 210, '2019-09-30', 318, NULL),
('Sheraton Centre', 210, '2019-10-01', 193, NULL),
('Sheraton Centre', 210, '2019-10-02', 318, NULL),
('Sheraton Centre', 210, '2019-10-03', 233, NULL),
('Sheraton Centre', 210, '2019-10-04', 129, NULL),
('Sheraton Centre', 210, '2019-10-05', 371, NULL),
('Sheraton Centre', 210, '2019-10-06', 359, NULL),
('Sheraton Centre', 210, '2019-10-07', 156, NULL),
('Sheraton Centre', 210, '2019-10-08', 355, NULL),
('Sheraton Centre', 210, '2019-10-09', 310, NULL),
('Sheraton Centre', 210, '2019-10-10', 255, NULL),
('Sheraton Centre', 210, '2019-10-11', 111, NULL),
('Sheraton Centre', 210, '2019-10-12', 111, NULL),
('Sheraton Centre', 210, '2019-10-13', 367, NULL),
('Sheraton Centre', 210, '2019-10-14', 306, NULL),
('Sheraton Centre', 210, '2019-10-15', 284, NULL),
('Sheraton Centre', 210, '2019-10-16', 323, NULL),
('Sheraton Centre', 210, '2019-10-17', 313, NULL),
('Sheraton Centre', 210, '2019-10-18', 159, NULL),
('Sheraton Centre', 210, '2019-10-19', 296, NULL),
('Sheraton Centre', 210, '2019-10-20', 291, NULL),
('Sheraton Centre', 210, '2019-10-21', 395, NULL),
('Sheraton Centre', 210, '2019-10-22', 301, NULL),
('Sheraton Centre', 210, '2019-10-23', 320, NULL),
('Sheraton Centre', 210, '2019-10-24', 297, NULL),
('Sheraton Centre', 210, '2019-10-25', 190, NULL),
('Sheraton Centre', 210, '2019-10-26', 345, NULL),
('Sheraton Centre', 210, '2019-10-27', 107, NULL),
('Sheraton Centre', 210, '2019-10-28', 315, NULL),
('Sheraton Centre', 210, '2019-10-29', 269, NULL),
('Sheraton Centre', 210, '2019-10-30', 250, NULL),
('Sheraton Centre', 210, '2019-10-31', 293, NULL),
('Sheraton Centre', 210, '2019-11-01', 351, NULL),
('Sheraton Centre', 210, '2019-11-02', 281, NULL),
('Sheraton Centre', 210, '2019-11-03', 232, NULL),
('Sheraton Centre', 210, '2019-11-04', 337, NULL),
('Sheraton Centre', 210, '2019-11-05', 241, NULL),
('Sheraton Centre', 210, '2019-11-06', 186, NULL),
('Sheraton Centre', 210, '2019-11-07', 271, NULL),
('Sheraton Centre', 210, '2019-11-08', 273, NULL),
('Sheraton Centre', 210, '2019-11-09', 198, NULL),
('Sheraton Centre', 210, '2019-11-10', 144, NULL),
('Sheraton Centre', 210, '2019-11-11', 254, NULL),
('Sheraton Centre', 210, '2019-11-12', 300, NULL),
('Sheraton Centre', 210, '2019-11-13', 156, NULL),
('Sheraton Centre', 210, '2019-11-14', 303, NULL),
('Sheraton Centre', 210, '2019-11-15', 346, NULL),
('Sheraton Centre', 210, '2019-11-16', 122, NULL),
('Sheraton Centre', 210, '2019-11-17', 364, NULL),
('Sheraton Centre', 210, '2019-11-18', 362, NULL),
('Sheraton Centre', 210, '2019-11-19', 350, NULL),
('Sheraton Centre', 210, '2019-11-20', 354, NULL),
('Sheraton Centre', 210, '2019-11-21', 156, NULL),
('Sheraton Centre', 210, '2019-11-22', 125, NULL),
('Sheraton Centre', 210, '2019-11-23', 362, NULL),
('Sheraton Centre', 210, '2019-11-24', 226, NULL),
('Sheraton Centre', 210, '2019-11-25', 235, NULL),
('Sheraton Centre', 210, '2019-11-26', 119, NULL),
('Sheraton Centre', 210, '2019-11-27', 199, NULL),
('Sheraton Centre', 210, '2019-11-28', 254, NULL),
('Sheraton Centre', 210, '2019-11-29', 371, NULL),
('Sheraton Centre', 210, '2019-11-30', 188, NULL),
('Sheraton Centre', 210, '2019-12-01', 306, NULL),
('Sheraton Centre', 210, '2019-12-02', 113, NULL),
('Sheraton Centre', 210, '2019-12-03', 134, NULL),
('Sheraton Centre', 210, '2019-12-04', 392, NULL),
('Sheraton Centre', 210, '2019-12-05', 267, NULL),
('Sheraton Centre', 210, '2019-12-06', 234, NULL),
('Sheraton Centre', 210, '2019-12-07', 333, NULL),
('Sheraton Centre', 210, '2019-12-08', 199, NULL),
('Sheraton Centre', 210, '2019-12-09', 332, NULL),
('Sheraton Centre', 210, '2019-12-10', 338, NULL),
('Sheraton Centre', 210, '2019-12-11', 223, NULL),
('Sheraton Centre', 210, '2019-12-12', 285, NULL),
('Sheraton Centre', 210, '2019-12-13', 254, NULL),
('Sheraton Centre', 210, '2019-12-14', 323, NULL),
('Sheraton Centre', 210, '2019-12-15', 144, NULL),
('Sheraton Centre', 210, '2019-12-16', 380, NULL),
('Sheraton Centre', 210, '2019-12-17', 336, NULL),
('Sheraton Centre', 210, '2019-12-18', 338, NULL),
('Sheraton Centre', 210, '2019-12-19', 325, NULL),
('Sheraton Centre', 210, '2019-12-20', 325, NULL),
('Sheraton Centre', 210, '2019-12-21', 281, NULL),
('Sheraton Centre', 210, '2019-12-22', 109, NULL),
('Sheraton Centre', 210, '2019-12-23', 153, NULL),
('Sheraton Centre', 210, '2019-12-24', 289, NULL),
('Sheraton Centre', 210, '2019-12-25', 286, NULL),
('Sheraton Centre', 210, '2019-12-26', 129, NULL),
('Sheraton Centre', 210, '2019-12-27', 345, NULL),
('Sheraton Centre', 210, '2019-12-28', 247, NULL),
('Sheraton Centre', 210, '2019-12-29', 301, NULL),
('Sheraton Centre', 210, '2019-12-30', 269, NULL),
('Sheraton Centre', 210, '2019-12-31', 161, NULL),
('Sheraton Centre', 210, '2020-01-01', 285, NULL),
('Sheraton Centre', 210, '2020-01-02', 350, NULL),
('Sheraton Centre', 210, '2020-01-03', 353, NULL),
('Sheraton Centre', 210, '2020-01-04', 364, NULL),
('Sheraton Centre', 210, '2020-01-05', 287, NULL),
('Sheraton Centre', 210, '2020-01-06', 321, NULL),
('Sheraton Centre', 210, '2020-01-07', 218, NULL),
('Sheraton Centre', 210, '2020-01-08', 111, NULL),
('Sheraton Centre', 210, '2020-01-09', 208, NULL),
('Sheraton Centre', 210, '2020-01-10', 285, NULL),
('Sheraton Centre', 210, '2020-01-11', 221, NULL),
('Sheraton Centre', 210, '2020-01-12', 205, NULL),
('Sheraton Centre', 210, '2020-01-13', 239, NULL),
('Sheraton Centre', 210, '2020-01-14', 331, NULL),
('Sheraton Centre', 210, '2020-01-15', 112, NULL),
('Sheraton Centre', 210, '2020-01-16', 218, NULL),
('Sheraton Centre', 210, '2020-01-17', 206, NULL),
('Sheraton Centre', 210, '2020-01-18', 134, NULL),
('Sheraton Centre', 210, '2020-01-19', 301, NULL),
('Sheraton Centre', 210, '2020-01-20', 257, NULL),
('Sheraton Centre', 210, '2020-01-21', 274, NULL),
('Sheraton Centre', 210, '2020-01-22', 154, NULL),
('Sheraton Centre', 210, '2020-01-23', 389, NULL),
('Sheraton Centre', 210, '2020-01-24', 328, NULL),
('Sheraton Centre', 210, '2020-01-25', 208, NULL),
('Sheraton Centre', 210, '2020-01-26', 104, NULL),
('Sheraton Centre', 210, '2020-01-27', 308, NULL),
('Sheraton Centre', 210, '2020-01-28', 258, NULL),
('Sheraton Centre', 210, '2020-01-29', 100, NULL),
('Sheraton Centre', 210, '2020-01-30', 229, NULL),
('Sheraton Centre', 210, '2020-01-31', 134, NULL),
('Sheraton Centre', 210, '2020-02-01', 368, NULL),
('Sheraton Centre', 210, '2020-02-02', 111, NULL),
('Sheraton Centre', 210, '2020-02-03', 389, NULL),
('Sheraton Centre', 210, '2020-02-04', 189, NULL),
('Sheraton Centre', 213, '2019-01-01', 324, NULL),
('Sheraton Centre', 213, '2019-01-02', 231, NULL),
('Sheraton Centre', 213, '2019-01-03', 185, NULL),
('Sheraton Centre', 213, '2019-01-04', 148, NULL),
('Sheraton Centre', 213, '2019-01-05', 363, NULL),
('Sheraton Centre', 213, '2019-01-06', 230, NULL),
('Sheraton Centre', 213, '2019-01-07', 116, NULL),
('Sheraton Centre', 213, '2019-01-08', 223, NULL),
('Sheraton Centre', 213, '2019-01-09', 366, NULL),
('Sheraton Centre', 213, '2019-01-10', 337, NULL),
('Sheraton Centre', 213, '2019-01-11', 230, NULL),
('Sheraton Centre', 213, '2019-01-12', 161, NULL),
('Sheraton Centre', 213, '2019-01-13', 224, NULL),
('Sheraton Centre', 213, '2019-01-14', 110, NULL),
('Sheraton Centre', 213, '2019-01-15', 123, NULL),
('Sheraton Centre', 213, '2019-01-16', 294, NULL),
('Sheraton Centre', 213, '2019-01-17', 366, NULL),
('Sheraton Centre', 213, '2019-01-18', 201, NULL),
('Sheraton Centre', 213, '2019-01-19', 324, NULL),
('Sheraton Centre', 213, '2019-01-20', 119, NULL),
('Sheraton Centre', 213, '2019-01-21', 293, NULL),
('Sheraton Centre', 213, '2019-01-22', 394, NULL),
('Sheraton Centre', 213, '2019-01-23', 207, NULL),
('Sheraton Centre', 213, '2019-01-24', 307, NULL),
('Sheraton Centre', 213, '2019-01-25', 222, NULL),
('Sheraton Centre', 213, '2019-01-26', 235, NULL),
('Sheraton Centre', 213, '2019-01-27', 108, NULL),
('Sheraton Centre', 213, '2019-01-28', 390, NULL),
('Sheraton Centre', 213, '2019-01-29', 343, NULL),
('Sheraton Centre', 213, '2019-01-30', 277, NULL),
('Sheraton Centre', 213, '2019-01-31', 111, NULL),
('Sheraton Centre', 213, '2019-02-01', 266, NULL),
('Sheraton Centre', 213, '2019-02-02', 375, NULL),
('Sheraton Centre', 213, '2019-02-03', 215, NULL),
('Sheraton Centre', 213, '2019-02-04', 181, NULL),
('Sheraton Centre', 213, '2019-02-05', 196, NULL),
('Sheraton Centre', 213, '2019-02-06', 330, NULL),
('Sheraton Centre', 213, '2019-02-07', 388, NULL),
('Sheraton Centre', 213, '2019-02-08', 279, NULL),
('Sheraton Centre', 213, '2019-02-09', 367, NULL),
('Sheraton Centre', 213, '2019-02-10', 352, NULL),
('Sheraton Centre', 213, '2019-02-11', 377, NULL),
('Sheraton Centre', 213, '2019-02-12', 246, NULL),
('Sheraton Centre', 213, '2019-02-13', 262, NULL),
('Sheraton Centre', 213, '2019-02-14', 127, NULL),
('Sheraton Centre', 213, '2019-02-15', 137, NULL),
('Sheraton Centre', 213, '2019-02-16', 240, NULL),
('Sheraton Centre', 213, '2019-02-17', 368, NULL),
('Sheraton Centre', 213, '2019-02-18', 110, NULL),
('Sheraton Centre', 213, '2019-02-19', 349, NULL),
('Sheraton Centre', 213, '2019-02-20', 102, NULL),
('Sheraton Centre', 213, '2019-02-21', 207, NULL),
('Sheraton Centre', 213, '2019-02-22', 131, NULL),
('Sheraton Centre', 213, '2019-02-23', 116, NULL),
('Sheraton Centre', 213, '2019-02-24', 313, NULL),
('Sheraton Centre', 213, '2019-02-25', 310, NULL),
('Sheraton Centre', 213, '2019-02-26', 240, NULL),
('Sheraton Centre', 213, '2019-02-27', 125, NULL),
('Sheraton Centre', 213, '2019-02-28', 226, NULL),
('Sheraton Centre', 213, '2019-03-01', 125, NULL),
('Sheraton Centre', 213, '2019-03-02', 251, NULL),
('Sheraton Centre', 213, '2019-03-03', 214, NULL),
('Sheraton Centre', 213, '2019-03-04', 318, NULL),
('Sheraton Centre', 213, '2019-03-05', 157, NULL),
('Sheraton Centre', 213, '2019-03-06', 133, NULL),
('Sheraton Centre', 213, '2019-03-07', 262, NULL),
('Sheraton Centre', 213, '2019-03-08', 243, NULL),
('Sheraton Centre', 213, '2019-03-09', 194, NULL),
('Sheraton Centre', 213, '2019-03-10', 139, NULL),
('Sheraton Centre', 213, '2019-03-11', 316, NULL),
('Sheraton Centre', 213, '2019-03-12', 235, NULL),
('Sheraton Centre', 213, '2019-03-13', 273, NULL),
('Sheraton Centre', 213, '2019-03-14', 247, NULL),
('Sheraton Centre', 213, '2019-03-15', 276, NULL),
('Sheraton Centre', 213, '2019-03-16', 260, NULL),
('Sheraton Centre', 213, '2019-03-17', 273, NULL),
('Sheraton Centre', 213, '2019-03-18', 171, NULL),
('Sheraton Centre', 213, '2019-03-19', 337, NULL),
('Sheraton Centre', 213, '2019-03-20', 302, NULL),
('Sheraton Centre', 213, '2019-03-21', 106, NULL),
('Sheraton Centre', 213, '2019-03-22', 285, NULL),
('Sheraton Centre', 213, '2019-03-23', 125, NULL),
('Sheraton Centre', 213, '2019-03-24', 196, NULL),
('Sheraton Centre', 213, '2019-03-25', 189, NULL),
('Sheraton Centre', 213, '2019-03-26', 143, NULL),
('Sheraton Centre', 213, '2019-03-27', 160, NULL),
('Sheraton Centre', 213, '2019-03-28', 269, NULL),
('Sheraton Centre', 213, '2019-03-29', 315, NULL),
('Sheraton Centre', 213, '2019-03-30', 241, NULL),
('Sheraton Centre', 213, '2019-03-31', 145, NULL),
('Sheraton Centre', 213, '2019-04-01', 150, NULL),
('Sheraton Centre', 213, '2019-04-02', 196, NULL),
('Sheraton Centre', 213, '2019-04-03', 326, NULL),
('Sheraton Centre', 213, '2019-04-04', 230, NULL),
('Sheraton Centre', 213, '2019-04-05', 188, NULL),
('Sheraton Centre', 213, '2019-04-06', 216, NULL),
('Sheraton Centre', 213, '2019-04-07', 158, NULL),
('Sheraton Centre', 213, '2019-04-08', 158, NULL),
('Sheraton Centre', 213, '2019-04-09', 267, NULL),
('Sheraton Centre', 213, '2019-04-10', 126, NULL),
('Sheraton Centre', 213, '2019-04-11', 133, NULL),
('Sheraton Centre', 213, '2019-04-12', 201, NULL),
('Sheraton Centre', 213, '2019-04-13', 169, NULL),
('Sheraton Centre', 213, '2019-04-14', 328, NULL),
('Sheraton Centre', 213, '2019-04-15', 346, NULL),
('Sheraton Centre', 213, '2019-04-16', 229, NULL),
('Sheraton Centre', 213, '2019-04-17', 338, NULL),
('Sheraton Centre', 213, '2019-04-18', 393, NULL),
('Sheraton Centre', 213, '2019-04-19', 178, NULL),
('Sheraton Centre', 213, '2019-04-20', 233, NULL),
('Sheraton Centre', 213, '2019-04-21', 332, NULL),
('Sheraton Centre', 213, '2019-04-22', 229, NULL),
('Sheraton Centre', 213, '2019-04-23', 330, NULL),
('Sheraton Centre', 213, '2019-04-24', 340, NULL),
('Sheraton Centre', 213, '2019-04-25', 232, NULL),
('Sheraton Centre', 213, '2019-04-26', 294, NULL),
('Sheraton Centre', 213, '2019-04-27', 308, NULL),
('Sheraton Centre', 213, '2019-04-28', 236, NULL),
('Sheraton Centre', 213, '2019-04-29', 340, NULL),
('Sheraton Centre', 213, '2019-04-30', 399, NULL),
('Sheraton Centre', 213, '2019-05-01', 176, NULL),
('Sheraton Centre', 213, '2019-05-02', 269, NULL),
('Sheraton Centre', 213, '2019-05-03', 284, NULL),
('Sheraton Centre', 213, '2019-05-04', 236, NULL),
('Sheraton Centre', 213, '2019-05-05', 151, NULL),
('Sheraton Centre', 213, '2019-05-06', 134, NULL),
('Sheraton Centre', 213, '2019-05-07', 313, NULL),
('Sheraton Centre', 213, '2019-05-08', 319, NULL),
('Sheraton Centre', 213, '2019-05-09', 381, NULL),
('Sheraton Centre', 213, '2019-05-10', 368, NULL),
('Sheraton Centre', 213, '2019-05-11', 261, NULL),
('Sheraton Centre', 213, '2019-05-12', 342, NULL),
('Sheraton Centre', 213, '2019-05-13', 390, NULL),
('Sheraton Centre', 213, '2019-05-14', 278, NULL),
('Sheraton Centre', 213, '2019-05-15', 187, NULL),
('Sheraton Centre', 213, '2019-05-16', 317, NULL),
('Sheraton Centre', 213, '2019-05-17', 352, NULL),
('Sheraton Centre', 213, '2019-05-18', 398, NULL),
('Sheraton Centre', 213, '2019-05-19', 133, NULL),
('Sheraton Centre', 213, '2019-05-20', 351, NULL),
('Sheraton Centre', 213, '2019-05-21', 343, NULL),
('Sheraton Centre', 213, '2019-05-22', 161, NULL),
('Sheraton Centre', 213, '2019-05-23', 363, NULL),
('Sheraton Centre', 213, '2019-05-24', 172, NULL),
('Sheraton Centre', 213, '2019-05-25', 187, NULL),
('Sheraton Centre', 213, '2019-05-26', 334, NULL),
('Sheraton Centre', 213, '2019-05-27', 215, NULL),
('Sheraton Centre', 213, '2019-05-28', 217, NULL),
('Sheraton Centre', 213, '2019-05-29', 217, NULL),
('Sheraton Centre', 213, '2019-05-30', 283, NULL),
('Sheraton Centre', 213, '2019-05-31', 313, NULL),
('Sheraton Centre', 213, '2019-06-01', 169, NULL),
('Sheraton Centre', 213, '2019-06-02', 311, NULL),
('Sheraton Centre', 213, '2019-06-03', 227, NULL),
('Sheraton Centre', 213, '2019-06-04', 135, NULL),
('Sheraton Centre', 213, '2019-06-05', 176, NULL),
('Sheraton Centre', 213, '2019-06-06', 371, NULL),
('Sheraton Centre', 213, '2019-06-07', 192, NULL),
('Sheraton Centre', 213, '2019-06-08', 271, NULL),
('Sheraton Centre', 213, '2019-06-09', 136, NULL),
('Sheraton Centre', 213, '2019-06-10', 261, NULL),
('Sheraton Centre', 213, '2019-06-11', 140, NULL),
('Sheraton Centre', 213, '2019-06-12', 367, NULL),
('Sheraton Centre', 213, '2019-06-13', 154, NULL),
('Sheraton Centre', 213, '2019-06-14', 387, NULL),
('Sheraton Centre', 213, '2019-06-15', 144, NULL),
('Sheraton Centre', 213, '2019-06-16', 194, NULL),
('Sheraton Centre', 213, '2019-06-17', 116, NULL),
('Sheraton Centre', 213, '2019-06-18', 340, NULL),
('Sheraton Centre', 213, '2019-06-19', 115, NULL),
('Sheraton Centre', 213, '2019-06-20', 174, NULL),
('Sheraton Centre', 213, '2019-06-21', 371, NULL),
('Sheraton Centre', 213, '2019-06-22', 143, NULL),
('Sheraton Centre', 213, '2019-06-23', 345, NULL),
('Sheraton Centre', 213, '2019-06-24', 349, NULL),
('Sheraton Centre', 213, '2019-06-25', 157, NULL),
('Sheraton Centre', 213, '2019-06-26', 251, NULL),
('Sheraton Centre', 213, '2019-06-27', 226, NULL),
('Sheraton Centre', 213, '2019-06-28', 139, NULL),
('Sheraton Centre', 213, '2019-06-29', 192, NULL),
('Sheraton Centre', 213, '2019-06-30', 250, NULL),
('Sheraton Centre', 213, '2019-07-01', 204, NULL),
('Sheraton Centre', 213, '2019-07-02', 214, NULL),
('Sheraton Centre', 213, '2019-07-03', 286, NULL),
('Sheraton Centre', 213, '2019-07-04', 395, NULL),
('Sheraton Centre', 213, '2019-07-05', 308, NULL),
('Sheraton Centre', 213, '2019-07-06', 147, NULL),
('Sheraton Centre', 213, '2019-07-07', 190, NULL),
('Sheraton Centre', 213, '2019-07-08', 119, NULL),
('Sheraton Centre', 213, '2019-07-09', 105, NULL),
('Sheraton Centre', 213, '2019-07-10', 180, NULL),
('Sheraton Centre', 213, '2019-07-11', 295, NULL),
('Sheraton Centre', 213, '2019-07-12', 331, NULL),
('Sheraton Centre', 213, '2019-07-13', 367, NULL),
('Sheraton Centre', 213, '2019-07-14', 271, NULL),
('Sheraton Centre', 213, '2019-07-15', 169, NULL),
('Sheraton Centre', 213, '2019-07-16', 229, NULL),
('Sheraton Centre', 213, '2019-07-17', 357, NULL),
('Sheraton Centre', 213, '2019-07-18', 212, NULL),
('Sheraton Centre', 213, '2019-07-19', 143, NULL),
('Sheraton Centre', 213, '2019-07-20', 183, NULL),
('Sheraton Centre', 213, '2019-07-21', 195, NULL),
('Sheraton Centre', 213, '2019-07-22', 140, NULL),
('Sheraton Centre', 213, '2019-07-23', 227, NULL),
('Sheraton Centre', 213, '2019-07-24', 390, NULL),
('Sheraton Centre', 213, '2019-07-25', 247, NULL),
('Sheraton Centre', 213, '2019-07-26', 124, NULL),
('Sheraton Centre', 213, '2019-07-27', 104, NULL),
('Sheraton Centre', 213, '2019-07-28', 317, NULL),
('Sheraton Centre', 213, '2019-07-29', 182, NULL),
('Sheraton Centre', 213, '2019-07-30', 284, NULL),
('Sheraton Centre', 213, '2019-07-31', 243, NULL),
('Sheraton Centre', 213, '2019-08-01', 173, NULL),
('Sheraton Centre', 213, '2019-08-02', 289, NULL),
('Sheraton Centre', 213, '2019-08-03', 381, NULL),
('Sheraton Centre', 213, '2019-08-04', 238, NULL),
('Sheraton Centre', 213, '2019-08-05', 244, NULL),
('Sheraton Centre', 213, '2019-08-06', 114, NULL),
('Sheraton Centre', 213, '2019-08-07', 298, NULL),
('Sheraton Centre', 213, '2019-08-08', 390, NULL),
('Sheraton Centre', 213, '2019-08-09', 273, NULL),
('Sheraton Centre', 213, '2019-08-10', 316, NULL),
('Sheraton Centre', 213, '2019-08-11', 300, NULL),
('Sheraton Centre', 213, '2019-08-12', 337, NULL),
('Sheraton Centre', 213, '2019-08-13', 393, NULL),
('Sheraton Centre', 213, '2019-08-14', 295, NULL),
('Sheraton Centre', 213, '2019-08-15', 136, NULL),
('Sheraton Centre', 213, '2019-08-16', 286, NULL),
('Sheraton Centre', 213, '2019-08-17', 269, NULL),
('Sheraton Centre', 213, '2019-08-18', 104, NULL),
('Sheraton Centre', 213, '2019-08-19', 355, NULL),
('Sheraton Centre', 213, '2019-08-20', 210, NULL),
('Sheraton Centre', 213, '2019-08-21', 270, NULL),
('Sheraton Centre', 213, '2019-08-22', 271, NULL),
('Sheraton Centre', 213, '2019-08-23', 104, NULL),
('Sheraton Centre', 213, '2019-08-24', 170, NULL),
('Sheraton Centre', 213, '2019-08-25', 177, NULL),
('Sheraton Centre', 213, '2019-08-26', 280, NULL),
('Sheraton Centre', 213, '2019-08-27', 341, NULL),
('Sheraton Centre', 213, '2019-08-28', 162, NULL),
('Sheraton Centre', 213, '2019-08-29', 388, NULL),
('Sheraton Centre', 213, '2019-08-30', 208, NULL),
('Sheraton Centre', 213, '2019-08-31', 197, NULL),
('Sheraton Centre', 213, '2019-09-01', 234, NULL),
('Sheraton Centre', 213, '2019-09-02', 181, NULL),
('Sheraton Centre', 213, '2019-09-03', 272, NULL),
('Sheraton Centre', 213, '2019-09-04', 374, NULL),
('Sheraton Centre', 213, '2019-09-05', 294, NULL),
('Sheraton Centre', 213, '2019-09-06', 346, NULL),
('Sheraton Centre', 213, '2019-09-07', 194, NULL),
('Sheraton Centre', 213, '2019-09-08', 305, NULL),
('Sheraton Centre', 213, '2019-09-09', 213, NULL),
('Sheraton Centre', 213, '2019-09-10', 270, NULL),
('Sheraton Centre', 213, '2019-09-11', 198, NULL),
('Sheraton Centre', 213, '2019-09-12', 107, NULL),
('Sheraton Centre', 213, '2019-09-13', 145, NULL),
('Sheraton Centre', 213, '2019-09-14', 398, NULL),
('Sheraton Centre', 213, '2019-09-15', 399, NULL),
('Sheraton Centre', 213, '2019-09-16', 347, NULL),
('Sheraton Centre', 213, '2019-09-17', 338, NULL),
('Sheraton Centre', 213, '2019-09-18', 183, NULL),
('Sheraton Centre', 213, '2019-09-19', 389, NULL),
('Sheraton Centre', 213, '2019-09-20', 269, NULL),
('Sheraton Centre', 213, '2019-09-21', 320, NULL),
('Sheraton Centre', 213, '2019-09-22', 333, NULL),
('Sheraton Centre', 213, '2019-09-23', 362, NULL),
('Sheraton Centre', 213, '2019-09-24', 281, NULL),
('Sheraton Centre', 213, '2019-09-25', 328, NULL),
('Sheraton Centre', 213, '2019-09-26', 365, NULL),
('Sheraton Centre', 213, '2019-09-27', 348, NULL),
('Sheraton Centre', 213, '2019-09-28', 193, NULL),
('Sheraton Centre', 213, '2019-09-29', 276, NULL),
('Sheraton Centre', 213, '2019-09-30', 132, NULL),
('Sheraton Centre', 213, '2019-10-01', 212, NULL),
('Sheraton Centre', 213, '2019-10-02', 157, NULL),
('Sheraton Centre', 213, '2019-10-03', 337, NULL),
('Sheraton Centre', 213, '2019-10-04', 223, NULL),
('Sheraton Centre', 213, '2019-10-05', 393, NULL),
('Sheraton Centre', 213, '2019-10-06', 271, NULL),
('Sheraton Centre', 213, '2019-10-07', 390, NULL),
('Sheraton Centre', 213, '2019-10-08', 253, NULL),
('Sheraton Centre', 213, '2019-10-09', 282, NULL),
('Sheraton Centre', 213, '2019-10-10', 119, NULL),
('Sheraton Centre', 213, '2019-10-11', 386, NULL),
('Sheraton Centre', 213, '2019-10-12', 225, NULL),
('Sheraton Centre', 213, '2019-10-13', 192, NULL),
('Sheraton Centre', 213, '2019-10-14', 263, NULL),
('Sheraton Centre', 213, '2019-10-15', 252, NULL),
('Sheraton Centre', 213, '2019-10-16', 258, NULL),
('Sheraton Centre', 213, '2019-10-17', 148, NULL),
('Sheraton Centre', 213, '2019-10-18', 333, NULL),
('Sheraton Centre', 213, '2019-10-19', 341, NULL),
('Sheraton Centre', 213, '2019-10-20', 252, NULL),
('Sheraton Centre', 213, '2019-10-21', 105, NULL),
('Sheraton Centre', 213, '2019-10-22', 293, NULL),
('Sheraton Centre', 213, '2019-10-23', 390, NULL),
('Sheraton Centre', 213, '2019-10-24', 357, NULL),
('Sheraton Centre', 213, '2019-10-25', 374, NULL),
('Sheraton Centre', 213, '2019-10-26', 271, NULL),
('Sheraton Centre', 213, '2019-10-27', 376, NULL),
('Sheraton Centre', 213, '2019-10-28', 182, NULL),
('Sheraton Centre', 213, '2019-10-29', 356, NULL),
('Sheraton Centre', 213, '2019-10-30', 277, NULL),
('Sheraton Centre', 213, '2019-10-31', 293, NULL),
('Sheraton Centre', 213, '2019-11-01', 342, NULL),
('Sheraton Centre', 213, '2019-11-02', 330, NULL),
('Sheraton Centre', 213, '2019-11-03', 215, NULL),
('Sheraton Centre', 213, '2019-11-04', 169, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 213, '2019-11-05', 164, NULL),
('Sheraton Centre', 213, '2019-11-06', 117, NULL),
('Sheraton Centre', 213, '2019-11-07', 181, NULL),
('Sheraton Centre', 213, '2019-11-08', 243, NULL),
('Sheraton Centre', 213, '2019-11-09', 134, NULL),
('Sheraton Centre', 213, '2019-11-10', 250, NULL),
('Sheraton Centre', 213, '2019-11-11', 246, NULL),
('Sheraton Centre', 213, '2019-11-12', 336, NULL),
('Sheraton Centre', 213, '2019-11-13', 154, NULL),
('Sheraton Centre', 213, '2019-11-14', 348, NULL),
('Sheraton Centre', 213, '2019-11-15', 153, NULL),
('Sheraton Centre', 213, '2019-11-16', 184, NULL),
('Sheraton Centre', 213, '2019-11-17', 217, NULL),
('Sheraton Centre', 213, '2019-11-18', 349, NULL),
('Sheraton Centre', 213, '2019-11-19', 384, NULL),
('Sheraton Centre', 213, '2019-11-20', 297, NULL),
('Sheraton Centre', 213, '2019-11-21', 183, NULL),
('Sheraton Centre', 213, '2019-11-22', 194, NULL),
('Sheraton Centre', 213, '2019-11-23', 181, NULL),
('Sheraton Centre', 213, '2019-11-24', 170, NULL),
('Sheraton Centre', 213, '2019-11-25', 136, NULL),
('Sheraton Centre', 213, '2019-11-26', 144, NULL),
('Sheraton Centre', 213, '2019-11-27', 162, NULL),
('Sheraton Centre', 213, '2019-11-28', 350, NULL),
('Sheraton Centre', 213, '2019-11-29', 333, NULL),
('Sheraton Centre', 213, '2019-11-30', 117, NULL),
('Sheraton Centre', 213, '2019-12-01', 126, NULL),
('Sheraton Centre', 213, '2019-12-02', 209, NULL),
('Sheraton Centre', 213, '2019-12-03', 326, NULL),
('Sheraton Centre', 213, '2019-12-04', 201, NULL),
('Sheraton Centre', 213, '2019-12-05', 170, NULL),
('Sheraton Centre', 213, '2019-12-06', 259, NULL),
('Sheraton Centre', 213, '2019-12-07', 112, NULL),
('Sheraton Centre', 213, '2019-12-08', 371, NULL),
('Sheraton Centre', 213, '2019-12-09', 321, NULL),
('Sheraton Centre', 213, '2019-12-10', 342, NULL),
('Sheraton Centre', 213, '2019-12-11', 165, NULL),
('Sheraton Centre', 213, '2019-12-12', 363, NULL),
('Sheraton Centre', 213, '2019-12-13', 189, NULL),
('Sheraton Centre', 213, '2019-12-14', 277, NULL),
('Sheraton Centre', 213, '2019-12-15', 185, NULL),
('Sheraton Centre', 213, '2019-12-16', 299, NULL),
('Sheraton Centre', 213, '2019-12-17', 181, NULL),
('Sheraton Centre', 213, '2019-12-18', 268, NULL),
('Sheraton Centre', 213, '2019-12-19', 296, NULL),
('Sheraton Centre', 213, '2019-12-20', 392, NULL),
('Sheraton Centre', 213, '2019-12-21', 169, NULL),
('Sheraton Centre', 213, '2019-12-22', 204, NULL),
('Sheraton Centre', 213, '2019-12-23', 350, NULL),
('Sheraton Centre', 213, '2019-12-24', 307, NULL),
('Sheraton Centre', 213, '2019-12-25', 128, NULL),
('Sheraton Centre', 213, '2019-12-26', 288, NULL),
('Sheraton Centre', 213, '2019-12-27', 372, NULL),
('Sheraton Centre', 213, '2019-12-28', 202, NULL),
('Sheraton Centre', 213, '2019-12-29', 177, NULL),
('Sheraton Centre', 213, '2019-12-30', 109, NULL),
('Sheraton Centre', 213, '2019-12-31', 310, NULL),
('Sheraton Centre', 213, '2020-01-01', 282, NULL),
('Sheraton Centre', 213, '2020-01-02', 212, NULL),
('Sheraton Centre', 213, '2020-01-03', 362, NULL),
('Sheraton Centre', 213, '2020-01-04', 346, NULL),
('Sheraton Centre', 213, '2020-01-05', 379, NULL),
('Sheraton Centre', 213, '2020-01-06', 235, NULL),
('Sheraton Centre', 213, '2020-01-07', 223, NULL),
('Sheraton Centre', 213, '2020-01-08', 119, NULL),
('Sheraton Centre', 213, '2020-01-09', 230, NULL),
('Sheraton Centre', 213, '2020-01-10', 387, NULL),
('Sheraton Centre', 213, '2020-01-11', 293, NULL),
('Sheraton Centre', 213, '2020-01-12', 321, NULL),
('Sheraton Centre', 213, '2020-01-13', 227, NULL),
('Sheraton Centre', 213, '2020-01-14', 264, NULL),
('Sheraton Centre', 213, '2020-01-15', 285, NULL),
('Sheraton Centre', 213, '2020-01-16', 383, NULL),
('Sheraton Centre', 213, '2020-01-17', 176, NULL),
('Sheraton Centre', 213, '2020-01-18', 302, NULL),
('Sheraton Centre', 213, '2020-01-19', 276, NULL),
('Sheraton Centre', 213, '2020-01-20', 335, NULL),
('Sheraton Centre', 213, '2020-01-21', 386, NULL),
('Sheraton Centre', 213, '2020-01-22', 190, NULL),
('Sheraton Centre', 213, '2020-01-23', 348, NULL),
('Sheraton Centre', 213, '2020-01-24', 266, NULL),
('Sheraton Centre', 213, '2020-01-25', 347, NULL),
('Sheraton Centre', 213, '2020-01-26', 227, NULL),
('Sheraton Centre', 213, '2020-01-27', 303, NULL),
('Sheraton Centre', 213, '2020-01-28', 225, NULL),
('Sheraton Centre', 213, '2020-01-29', 116, NULL),
('Sheraton Centre', 213, '2020-01-30', 174, NULL),
('Sheraton Centre', 213, '2020-01-31', 266, NULL),
('Sheraton Centre', 213, '2020-02-01', 164, NULL),
('Sheraton Centre', 213, '2020-02-02', 223, NULL),
('Sheraton Centre', 213, '2020-02-03', 144, NULL),
('Sheraton Centre', 213, '2020-02-04', 281, NULL),
('Sheraton Centre', 217, '2019-01-01', 199, NULL),
('Sheraton Centre', 217, '2019-01-02', 301, NULL),
('Sheraton Centre', 217, '2019-01-03', 125, NULL),
('Sheraton Centre', 217, '2019-01-04', 146, NULL),
('Sheraton Centre', 217, '2019-01-05', 371, NULL),
('Sheraton Centre', 217, '2019-01-06', 269, NULL),
('Sheraton Centre', 217, '2019-01-07', 201, NULL),
('Sheraton Centre', 217, '2019-01-08', 193, NULL),
('Sheraton Centre', 217, '2019-01-09', 282, NULL),
('Sheraton Centre', 217, '2019-01-10', 304, NULL),
('Sheraton Centre', 217, '2019-01-11', 386, NULL),
('Sheraton Centre', 217, '2019-01-12', 175, NULL),
('Sheraton Centre', 217, '2019-01-13', 325, NULL),
('Sheraton Centre', 217, '2019-01-14', 113, NULL),
('Sheraton Centre', 217, '2019-01-15', 286, NULL),
('Sheraton Centre', 217, '2019-01-16', 211, NULL),
('Sheraton Centre', 217, '2019-01-17', 224, NULL),
('Sheraton Centre', 217, '2019-01-18', 374, NULL),
('Sheraton Centre', 217, '2019-01-19', 350, NULL),
('Sheraton Centre', 217, '2019-01-20', 250, NULL),
('Sheraton Centre', 217, '2019-01-21', 367, NULL),
('Sheraton Centre', 217, '2019-01-22', 148, NULL),
('Sheraton Centre', 217, '2019-01-23', 252, NULL),
('Sheraton Centre', 217, '2019-01-24', 207, NULL),
('Sheraton Centre', 217, '2019-01-25', 275, NULL),
('Sheraton Centre', 217, '2019-01-26', 119, NULL),
('Sheraton Centre', 217, '2019-01-27', 117, NULL),
('Sheraton Centre', 217, '2019-01-28', 374, NULL),
('Sheraton Centre', 217, '2019-01-29', 370, NULL),
('Sheraton Centre', 217, '2019-01-30', 100, NULL),
('Sheraton Centre', 217, '2019-01-31', 186, NULL),
('Sheraton Centre', 217, '2019-02-01', 376, NULL),
('Sheraton Centre', 217, '2019-02-02', 224, NULL),
('Sheraton Centre', 217, '2019-02-03', 189, NULL),
('Sheraton Centre', 217, '2019-02-04', 124, NULL),
('Sheraton Centre', 217, '2019-02-05', 375, NULL),
('Sheraton Centre', 217, '2019-02-06', 142, NULL),
('Sheraton Centre', 217, '2019-02-07', 199, NULL),
('Sheraton Centre', 217, '2019-02-08', 378, NULL),
('Sheraton Centre', 217, '2019-02-09', 175, NULL),
('Sheraton Centre', 217, '2019-02-10', 159, NULL),
('Sheraton Centre', 217, '2019-02-11', 300, NULL),
('Sheraton Centre', 217, '2019-02-12', 297, NULL),
('Sheraton Centre', 217, '2019-02-13', 377, NULL),
('Sheraton Centre', 217, '2019-02-14', 388, NULL),
('Sheraton Centre', 217, '2019-02-15', 216, NULL),
('Sheraton Centre', 217, '2019-02-16', 266, NULL),
('Sheraton Centre', 217, '2019-02-17', 281, NULL),
('Sheraton Centre', 217, '2019-02-18', 243, NULL),
('Sheraton Centre', 217, '2019-02-19', 204, NULL),
('Sheraton Centre', 217, '2019-02-20', 175, NULL),
('Sheraton Centre', 217, '2019-02-21', 275, NULL),
('Sheraton Centre', 217, '2019-02-22', 221, NULL),
('Sheraton Centre', 217, '2019-02-23', 197, NULL),
('Sheraton Centre', 217, '2019-02-24', 150, NULL),
('Sheraton Centre', 217, '2019-02-25', 311, NULL),
('Sheraton Centre', 217, '2019-02-26', 346, NULL),
('Sheraton Centre', 217, '2019-02-27', 190, NULL),
('Sheraton Centre', 217, '2019-02-28', 177, NULL),
('Sheraton Centre', 217, '2019-03-01', 379, NULL),
('Sheraton Centre', 217, '2019-03-02', 188, NULL),
('Sheraton Centre', 217, '2019-03-03', 148, NULL),
('Sheraton Centre', 217, '2019-03-04', 256, NULL),
('Sheraton Centre', 217, '2019-03-05', 265, NULL),
('Sheraton Centre', 217, '2019-03-06', 188, NULL),
('Sheraton Centre', 217, '2019-03-07', 188, NULL),
('Sheraton Centre', 217, '2019-03-08', 224, NULL),
('Sheraton Centre', 217, '2019-03-09', 391, NULL),
('Sheraton Centre', 217, '2019-03-10', 352, NULL),
('Sheraton Centre', 217, '2019-03-11', 190, NULL),
('Sheraton Centre', 217, '2019-03-12', 115, NULL),
('Sheraton Centre', 217, '2019-03-13', 107, NULL),
('Sheraton Centre', 217, '2019-03-14', 242, NULL),
('Sheraton Centre', 217, '2019-03-15', 334, NULL),
('Sheraton Centre', 217, '2019-03-16', 191, NULL),
('Sheraton Centre', 217, '2019-03-17', 277, NULL),
('Sheraton Centre', 217, '2019-03-18', 140, NULL),
('Sheraton Centre', 217, '2019-03-19', 251, NULL),
('Sheraton Centre', 217, '2019-03-20', 319, NULL),
('Sheraton Centre', 217, '2019-03-21', 320, NULL),
('Sheraton Centre', 217, '2019-03-22', 162, NULL),
('Sheraton Centre', 217, '2019-03-23', 184, NULL),
('Sheraton Centre', 217, '2019-03-24', 362, NULL),
('Sheraton Centre', 217, '2019-03-25', 197, NULL),
('Sheraton Centre', 217, '2019-03-26', 261, NULL),
('Sheraton Centre', 217, '2019-03-27', 179, NULL),
('Sheraton Centre', 217, '2019-03-28', 339, NULL),
('Sheraton Centre', 217, '2019-03-29', 228, NULL),
('Sheraton Centre', 217, '2019-03-30', 232, NULL),
('Sheraton Centre', 217, '2019-03-31', 354, NULL),
('Sheraton Centre', 217, '2019-04-01', 331, NULL),
('Sheraton Centre', 217, '2019-04-02', 261, NULL),
('Sheraton Centre', 217, '2019-04-03', 103, NULL),
('Sheraton Centre', 217, '2019-04-04', 141, NULL),
('Sheraton Centre', 217, '2019-04-05', 143, NULL),
('Sheraton Centre', 217, '2019-04-06', 284, NULL),
('Sheraton Centre', 217, '2019-04-07', 141, NULL),
('Sheraton Centre', 217, '2019-04-08', 367, NULL),
('Sheraton Centre', 217, '2019-04-09', 166, NULL),
('Sheraton Centre', 217, '2019-04-10', 100, NULL),
('Sheraton Centre', 217, '2019-04-11', 312, NULL),
('Sheraton Centre', 217, '2019-04-12', 345, NULL),
('Sheraton Centre', 217, '2019-04-13', 383, NULL),
('Sheraton Centre', 217, '2019-04-14', 364, NULL),
('Sheraton Centre', 217, '2019-04-15', 265, NULL),
('Sheraton Centre', 217, '2019-04-16', 291, NULL),
('Sheraton Centre', 217, '2019-04-17', 352, NULL),
('Sheraton Centre', 217, '2019-04-18', 103, NULL),
('Sheraton Centre', 217, '2019-04-19', 265, NULL),
('Sheraton Centre', 217, '2019-04-20', 132, NULL),
('Sheraton Centre', 217, '2019-04-21', 293, NULL),
('Sheraton Centre', 217, '2019-04-22', 125, NULL),
('Sheraton Centre', 217, '2019-04-23', 255, NULL),
('Sheraton Centre', 217, '2019-04-24', 115, NULL),
('Sheraton Centre', 217, '2019-04-25', 200, NULL),
('Sheraton Centre', 217, '2019-04-26', 379, NULL),
('Sheraton Centre', 217, '2019-04-27', 215, NULL),
('Sheraton Centre', 217, '2019-04-28', 185, NULL),
('Sheraton Centre', 217, '2019-04-29', 233, NULL),
('Sheraton Centre', 217, '2019-04-30', 185, NULL),
('Sheraton Centre', 217, '2019-05-01', 221, NULL),
('Sheraton Centre', 217, '2019-05-02', 242, NULL),
('Sheraton Centre', 217, '2019-05-03', 336, NULL),
('Sheraton Centre', 217, '2019-05-04', 364, NULL),
('Sheraton Centre', 217, '2019-05-05', 180, NULL),
('Sheraton Centre', 217, '2019-05-06', 223, NULL),
('Sheraton Centre', 217, '2019-05-07', 129, NULL),
('Sheraton Centre', 217, '2019-05-08', 331, NULL),
('Sheraton Centre', 217, '2019-05-09', 310, NULL),
('Sheraton Centre', 217, '2019-05-10', 205, NULL),
('Sheraton Centre', 217, '2019-05-11', 235, NULL),
('Sheraton Centre', 217, '2019-05-12', 382, NULL),
('Sheraton Centre', 217, '2019-05-13', 309, NULL),
('Sheraton Centre', 217, '2019-05-14', 386, NULL),
('Sheraton Centre', 217, '2019-05-15', 344, NULL),
('Sheraton Centre', 217, '2019-05-16', 333, NULL),
('Sheraton Centre', 217, '2019-05-17', 236, NULL),
('Sheraton Centre', 217, '2019-05-18', 363, NULL),
('Sheraton Centre', 217, '2019-05-19', 391, NULL),
('Sheraton Centre', 217, '2019-05-20', 348, NULL),
('Sheraton Centre', 217, '2019-05-21', 239, NULL),
('Sheraton Centre', 217, '2019-05-22', 275, NULL),
('Sheraton Centre', 217, '2019-05-23', 250, NULL),
('Sheraton Centre', 217, '2019-05-24', 227, NULL),
('Sheraton Centre', 217, '2019-05-25', 113, NULL),
('Sheraton Centre', 217, '2019-05-26', 204, NULL),
('Sheraton Centre', 217, '2019-05-27', 262, NULL),
('Sheraton Centre', 217, '2019-05-28', 103, NULL),
('Sheraton Centre', 217, '2019-05-29', 179, NULL),
('Sheraton Centre', 217, '2019-05-30', 169, NULL),
('Sheraton Centre', 217, '2019-05-31', 383, NULL),
('Sheraton Centre', 217, '2019-06-01', 173, NULL),
('Sheraton Centre', 217, '2019-06-02', 165, NULL),
('Sheraton Centre', 217, '2019-06-03', 232, NULL),
('Sheraton Centre', 217, '2019-06-04', 161, NULL),
('Sheraton Centre', 217, '2019-06-05', 254, NULL),
('Sheraton Centre', 217, '2019-06-06', 269, NULL),
('Sheraton Centre', 217, '2019-06-07', 181, NULL),
('Sheraton Centre', 217, '2019-06-08', 149, NULL),
('Sheraton Centre', 217, '2019-06-09', 207, NULL),
('Sheraton Centre', 217, '2019-06-10', 298, NULL),
('Sheraton Centre', 217, '2019-06-11', 233, NULL),
('Sheraton Centre', 217, '2019-06-12', 309, NULL),
('Sheraton Centre', 217, '2019-06-13', 310, NULL),
('Sheraton Centre', 217, '2019-06-14', 343, NULL),
('Sheraton Centre', 217, '2019-06-15', 194, NULL),
('Sheraton Centre', 217, '2019-06-16', 397, NULL),
('Sheraton Centre', 217, '2019-06-17', 220, NULL),
('Sheraton Centre', 217, '2019-06-18', 177, NULL),
('Sheraton Centre', 217, '2019-06-19', 254, NULL),
('Sheraton Centre', 217, '2019-06-20', 206, NULL),
('Sheraton Centre', 217, '2019-06-21', 336, NULL),
('Sheraton Centre', 217, '2019-06-22', 127, NULL),
('Sheraton Centre', 217, '2019-06-23', 235, NULL),
('Sheraton Centre', 217, '2019-06-24', 276, NULL),
('Sheraton Centre', 217, '2019-06-25', 238, NULL),
('Sheraton Centre', 217, '2019-06-26', 330, NULL),
('Sheraton Centre', 217, '2019-06-27', 345, NULL),
('Sheraton Centre', 217, '2019-06-28', 248, NULL),
('Sheraton Centre', 217, '2019-06-29', 221, NULL),
('Sheraton Centre', 217, '2019-06-30', 107, NULL),
('Sheraton Centre', 217, '2019-07-01', 141, NULL),
('Sheraton Centre', 217, '2019-07-02', 267, NULL),
('Sheraton Centre', 217, '2019-07-03', 203, NULL),
('Sheraton Centre', 217, '2019-07-04', 116, NULL),
('Sheraton Centre', 217, '2019-07-05', 206, NULL),
('Sheraton Centre', 217, '2019-07-06', 184, NULL),
('Sheraton Centre', 217, '2019-07-07', 216, NULL),
('Sheraton Centre', 217, '2019-07-08', 398, NULL),
('Sheraton Centre', 217, '2019-07-09', 362, NULL),
('Sheraton Centre', 217, '2019-07-10', 187, NULL),
('Sheraton Centre', 217, '2019-07-11', 212, NULL),
('Sheraton Centre', 217, '2019-07-12', 189, NULL),
('Sheraton Centre', 217, '2019-07-13', 318, NULL),
('Sheraton Centre', 217, '2019-07-14', 391, NULL),
('Sheraton Centre', 217, '2019-07-15', 391, NULL),
('Sheraton Centre', 217, '2019-07-16', 332, NULL),
('Sheraton Centre', 217, '2019-07-17', 266, NULL),
('Sheraton Centre', 217, '2019-07-18', 279, NULL),
('Sheraton Centre', 217, '2019-07-19', 255, NULL),
('Sheraton Centre', 217, '2019-07-20', 349, NULL),
('Sheraton Centre', 217, '2019-07-21', 110, NULL),
('Sheraton Centre', 217, '2019-07-22', 300, NULL),
('Sheraton Centre', 217, '2019-07-23', 116, NULL),
('Sheraton Centre', 217, '2019-07-24', 291, NULL),
('Sheraton Centre', 217, '2019-07-25', 129, NULL),
('Sheraton Centre', 217, '2019-07-26', 331, NULL),
('Sheraton Centre', 217, '2019-07-27', 128, NULL),
('Sheraton Centre', 217, '2019-07-28', 350, NULL),
('Sheraton Centre', 217, '2019-07-29', 213, NULL),
('Sheraton Centre', 217, '2019-07-30', 333, NULL),
('Sheraton Centre', 217, '2019-07-31', 317, NULL),
('Sheraton Centre', 217, '2019-08-01', 105, NULL),
('Sheraton Centre', 217, '2019-08-02', 137, NULL),
('Sheraton Centre', 217, '2019-08-03', 294, NULL),
('Sheraton Centre', 217, '2019-08-04', 180, NULL),
('Sheraton Centre', 217, '2019-08-05', 270, NULL),
('Sheraton Centre', 217, '2019-08-06', 160, NULL),
('Sheraton Centre', 217, '2019-08-07', 356, NULL),
('Sheraton Centre', 217, '2019-08-08', 383, NULL),
('Sheraton Centre', 217, '2019-08-09', 178, NULL),
('Sheraton Centre', 217, '2019-08-10', 332, NULL),
('Sheraton Centre', 217, '2019-08-11', 358, NULL),
('Sheraton Centre', 217, '2019-08-12', 398, NULL),
('Sheraton Centre', 217, '2019-08-13', 222, NULL),
('Sheraton Centre', 217, '2019-08-14', 398, NULL),
('Sheraton Centre', 217, '2019-08-15', 170, NULL),
('Sheraton Centre', 217, '2019-08-16', 301, NULL),
('Sheraton Centre', 217, '2019-08-17', 232, NULL),
('Sheraton Centre', 217, '2019-08-18', 246, NULL),
('Sheraton Centre', 217, '2019-08-19', 230, NULL),
('Sheraton Centre', 217, '2019-08-20', 299, NULL),
('Sheraton Centre', 217, '2019-08-21', 294, NULL),
('Sheraton Centre', 217, '2019-08-22', 288, NULL),
('Sheraton Centre', 217, '2019-08-23', 115, NULL),
('Sheraton Centre', 217, '2019-08-24', 307, NULL),
('Sheraton Centre', 217, '2019-08-25', 266, NULL),
('Sheraton Centre', 217, '2019-08-26', 192, NULL),
('Sheraton Centre', 217, '2019-08-27', 304, NULL),
('Sheraton Centre', 217, '2019-08-28', 346, NULL),
('Sheraton Centre', 217, '2019-08-29', 193, NULL),
('Sheraton Centre', 217, '2019-08-30', 363, NULL),
('Sheraton Centre', 217, '2019-08-31', 207, NULL),
('Sheraton Centre', 217, '2019-09-01', 359, NULL),
('Sheraton Centre', 217, '2019-09-02', 226, NULL),
('Sheraton Centre', 217, '2019-09-03', 146, NULL),
('Sheraton Centre', 217, '2019-09-04', 204, NULL),
('Sheraton Centre', 217, '2019-09-05', 103, NULL),
('Sheraton Centre', 217, '2019-09-06', 350, NULL),
('Sheraton Centre', 217, '2019-09-07', 132, NULL),
('Sheraton Centre', 217, '2019-09-08', 347, NULL),
('Sheraton Centre', 217, '2019-09-09', 249, NULL),
('Sheraton Centre', 217, '2019-09-10', 173, NULL),
('Sheraton Centre', 217, '2019-09-11', 138, NULL),
('Sheraton Centre', 217, '2019-09-12', 224, NULL),
('Sheraton Centre', 217, '2019-09-13', 177, NULL),
('Sheraton Centre', 217, '2019-09-14', 181, NULL),
('Sheraton Centre', 217, '2019-09-15', 133, NULL),
('Sheraton Centre', 217, '2019-09-16', 220, NULL),
('Sheraton Centre', 217, '2019-09-17', 250, NULL),
('Sheraton Centre', 217, '2019-09-18', 356, NULL),
('Sheraton Centre', 217, '2019-09-19', 311, NULL),
('Sheraton Centre', 217, '2019-09-20', 382, NULL),
('Sheraton Centre', 217, '2019-09-21', 336, NULL),
('Sheraton Centre', 217, '2019-09-22', 183, NULL),
('Sheraton Centre', 217, '2019-09-23', 292, NULL),
('Sheraton Centre', 217, '2019-09-24', 362, NULL),
('Sheraton Centre', 217, '2019-09-25', 222, NULL),
('Sheraton Centre', 217, '2019-09-26', 216, NULL),
('Sheraton Centre', 217, '2019-09-27', 254, NULL),
('Sheraton Centre', 217, '2019-09-28', 183, NULL),
('Sheraton Centre', 217, '2019-09-29', 211, NULL),
('Sheraton Centre', 217, '2019-09-30', 203, NULL),
('Sheraton Centre', 217, '2019-10-01', 380, NULL),
('Sheraton Centre', 217, '2019-10-02', 334, NULL),
('Sheraton Centre', 217, '2019-10-03', 289, NULL),
('Sheraton Centre', 217, '2019-10-04', 330, NULL),
('Sheraton Centre', 217, '2019-10-05', 152, NULL),
('Sheraton Centre', 217, '2019-10-06', 177, NULL),
('Sheraton Centre', 217, '2019-10-07', 183, NULL),
('Sheraton Centre', 217, '2019-10-08', 399, NULL),
('Sheraton Centre', 217, '2019-10-09', 380, NULL),
('Sheraton Centre', 217, '2019-10-10', 332, NULL),
('Sheraton Centre', 217, '2019-10-11', 297, NULL),
('Sheraton Centre', 217, '2019-10-12', 393, NULL),
('Sheraton Centre', 217, '2019-10-13', 359, NULL),
('Sheraton Centre', 217, '2019-10-14', 294, NULL),
('Sheraton Centre', 217, '2019-10-15', 309, NULL),
('Sheraton Centre', 217, '2019-10-16', 221, NULL),
('Sheraton Centre', 217, '2019-10-17', 302, NULL),
('Sheraton Centre', 217, '2019-10-18', 188, NULL),
('Sheraton Centre', 217, '2019-10-19', 118, NULL),
('Sheraton Centre', 217, '2019-10-20', 287, NULL),
('Sheraton Centre', 217, '2019-10-21', 143, NULL),
('Sheraton Centre', 217, '2019-10-22', 165, NULL),
('Sheraton Centre', 217, '2019-10-23', 290, NULL),
('Sheraton Centre', 217, '2019-10-24', 197, NULL),
('Sheraton Centre', 217, '2019-10-25', 301, NULL),
('Sheraton Centre', 217, '2019-10-26', 218, NULL),
('Sheraton Centre', 217, '2019-10-27', 261, NULL),
('Sheraton Centre', 217, '2019-10-28', 166, NULL),
('Sheraton Centre', 217, '2019-10-29', 272, NULL),
('Sheraton Centre', 217, '2019-10-30', 233, NULL),
('Sheraton Centre', 217, '2019-10-31', 190, NULL),
('Sheraton Centre', 217, '2019-11-01', 256, NULL),
('Sheraton Centre', 217, '2019-11-02', 111, NULL),
('Sheraton Centre', 217, '2019-11-03', 280, NULL),
('Sheraton Centre', 217, '2019-11-04', 335, NULL),
('Sheraton Centre', 217, '2019-11-05', 299, NULL),
('Sheraton Centre', 217, '2019-11-06', 228, NULL),
('Sheraton Centre', 217, '2019-11-07', 292, NULL),
('Sheraton Centre', 217, '2019-11-08', 293, NULL),
('Sheraton Centre', 217, '2019-11-09', 279, NULL),
('Sheraton Centre', 217, '2019-11-10', 120, NULL),
('Sheraton Centre', 217, '2019-11-11', 370, NULL),
('Sheraton Centre', 217, '2019-11-12', 379, NULL),
('Sheraton Centre', 217, '2019-11-13', 206, NULL),
('Sheraton Centre', 217, '2019-11-14', 133, NULL),
('Sheraton Centre', 217, '2019-11-15', 228, NULL),
('Sheraton Centre', 217, '2019-11-16', 157, NULL),
('Sheraton Centre', 217, '2019-11-17', 192, NULL),
('Sheraton Centre', 217, '2019-11-18', 256, NULL),
('Sheraton Centre', 217, '2019-11-19', 169, NULL),
('Sheraton Centre', 217, '2019-11-20', 325, NULL),
('Sheraton Centre', 217, '2019-11-21', 348, NULL),
('Sheraton Centre', 217, '2019-11-22', 195, NULL),
('Sheraton Centre', 217, '2019-11-23', 319, NULL),
('Sheraton Centre', 217, '2019-11-24', 376, NULL),
('Sheraton Centre', 217, '2019-11-25', 173, NULL),
('Sheraton Centre', 217, '2019-11-26', 265, NULL),
('Sheraton Centre', 217, '2019-11-27', 114, NULL),
('Sheraton Centre', 217, '2019-11-28', 289, NULL),
('Sheraton Centre', 217, '2019-11-29', 153, NULL),
('Sheraton Centre', 217, '2019-11-30', 223, NULL),
('Sheraton Centre', 217, '2019-12-01', 214, NULL),
('Sheraton Centre', 217, '2019-12-02', 304, NULL),
('Sheraton Centre', 217, '2019-12-03', 230, NULL),
('Sheraton Centre', 217, '2019-12-04', 329, NULL),
('Sheraton Centre', 217, '2019-12-05', 248, NULL),
('Sheraton Centre', 217, '2019-12-06', 192, NULL),
('Sheraton Centre', 217, '2019-12-07', 359, NULL),
('Sheraton Centre', 217, '2019-12-08', 259, NULL),
('Sheraton Centre', 217, '2019-12-09', 208, NULL),
('Sheraton Centre', 217, '2019-12-10', 298, NULL),
('Sheraton Centre', 217, '2019-12-11', 355, NULL),
('Sheraton Centre', 217, '2019-12-12', 259, NULL),
('Sheraton Centre', 217, '2019-12-13', 383, NULL),
('Sheraton Centre', 217, '2019-12-14', 318, NULL),
('Sheraton Centre', 217, '2019-12-15', 395, NULL),
('Sheraton Centre', 217, '2019-12-16', 257, NULL),
('Sheraton Centre', 217, '2019-12-17', 395, NULL),
('Sheraton Centre', 217, '2019-12-18', 227, NULL),
('Sheraton Centre', 217, '2019-12-19', 106, NULL),
('Sheraton Centre', 217, '2019-12-20', 285, NULL),
('Sheraton Centre', 217, '2019-12-21', 204, NULL),
('Sheraton Centre', 217, '2019-12-22', 296, NULL),
('Sheraton Centre', 217, '2019-12-23', 288, NULL),
('Sheraton Centre', 217, '2019-12-24', 267, NULL),
('Sheraton Centre', 217, '2019-12-25', 284, NULL),
('Sheraton Centre', 217, '2019-12-26', 355, NULL),
('Sheraton Centre', 217, '2019-12-27', 126, NULL),
('Sheraton Centre', 217, '2019-12-28', 173, NULL),
('Sheraton Centre', 217, '2019-12-29', 184, NULL),
('Sheraton Centre', 217, '2019-12-30', 238, NULL),
('Sheraton Centre', 217, '2019-12-31', 369, NULL),
('Sheraton Centre', 217, '2020-01-01', 157, NULL),
('Sheraton Centre', 217, '2020-01-02', 212, NULL),
('Sheraton Centre', 217, '2020-01-03', 349, NULL),
('Sheraton Centre', 217, '2020-01-04', 237, NULL),
('Sheraton Centre', 217, '2020-01-05', 335, NULL),
('Sheraton Centre', 217, '2020-01-06', 116, NULL),
('Sheraton Centre', 217, '2020-01-07', 362, NULL),
('Sheraton Centre', 217, '2020-01-08', 163, NULL),
('Sheraton Centre', 217, '2020-01-09', 127, NULL),
('Sheraton Centre', 217, '2020-01-10', 380, NULL),
('Sheraton Centre', 217, '2020-01-11', 103, NULL),
('Sheraton Centre', 217, '2020-01-12', 292, NULL),
('Sheraton Centre', 217, '2020-01-13', 317, NULL),
('Sheraton Centre', 217, '2020-01-14', 227, NULL),
('Sheraton Centre', 217, '2020-01-15', 392, NULL),
('Sheraton Centre', 217, '2020-01-16', 264, NULL),
('Sheraton Centre', 217, '2020-01-17', 161, NULL),
('Sheraton Centre', 217, '2020-01-18', 106, NULL),
('Sheraton Centre', 217, '2020-01-19', 377, NULL),
('Sheraton Centre', 217, '2020-01-20', 203, NULL),
('Sheraton Centre', 217, '2020-01-21', 107, NULL),
('Sheraton Centre', 217, '2020-01-22', 389, NULL),
('Sheraton Centre', 217, '2020-01-23', 172, NULL),
('Sheraton Centre', 217, '2020-01-24', 245, NULL),
('Sheraton Centre', 217, '2020-01-25', 110, NULL),
('Sheraton Centre', 217, '2020-01-26', 122, NULL),
('Sheraton Centre', 217, '2020-01-27', 193, NULL),
('Sheraton Centre', 217, '2020-01-28', 251, NULL),
('Sheraton Centre', 217, '2020-01-29', 180, NULL),
('Sheraton Centre', 217, '2020-01-30', 387, NULL),
('Sheraton Centre', 217, '2020-01-31', 229, NULL),
('Sheraton Centre', 217, '2020-02-01', 218, NULL),
('Sheraton Centre', 217, '2020-02-02', 381, NULL),
('Sheraton Centre', 217, '2020-02-03', 353, NULL),
('Sheraton Centre', 217, '2020-02-04', 137, NULL),
('Sheraton Centre', 224, '2019-01-01', 226, NULL),
('Sheraton Centre', 224, '2019-01-02', 113, NULL),
('Sheraton Centre', 224, '2019-01-03', 271, NULL),
('Sheraton Centre', 224, '2019-01-04', 186, NULL),
('Sheraton Centre', 224, '2019-01-05', 368, NULL),
('Sheraton Centre', 224, '2019-01-06', 252, NULL),
('Sheraton Centre', 224, '2019-01-07', 256, NULL),
('Sheraton Centre', 224, '2019-01-08', 197, NULL),
('Sheraton Centre', 224, '2019-01-09', 214, NULL),
('Sheraton Centre', 224, '2019-01-10', 110, NULL),
('Sheraton Centre', 224, '2019-01-11', 240, NULL),
('Sheraton Centre', 224, '2019-01-12', 294, NULL),
('Sheraton Centre', 224, '2019-01-13', 254, NULL),
('Sheraton Centre', 224, '2019-01-14', 136, NULL),
('Sheraton Centre', 224, '2019-01-15', 361, NULL),
('Sheraton Centre', 224, '2019-01-16', 371, NULL),
('Sheraton Centre', 224, '2019-01-17', 224, NULL),
('Sheraton Centre', 224, '2019-01-18', 268, NULL),
('Sheraton Centre', 224, '2019-01-19', 379, NULL),
('Sheraton Centre', 224, '2019-01-20', 195, NULL),
('Sheraton Centre', 224, '2019-01-21', 257, NULL),
('Sheraton Centre', 224, '2019-01-22', 357, NULL),
('Sheraton Centre', 224, '2019-01-23', 240, NULL),
('Sheraton Centre', 224, '2019-01-24', 313, NULL),
('Sheraton Centre', 224, '2019-01-25', 309, NULL),
('Sheraton Centre', 224, '2019-01-26', 392, NULL),
('Sheraton Centre', 224, '2019-01-27', 160, NULL),
('Sheraton Centre', 224, '2019-01-28', 300, NULL),
('Sheraton Centre', 224, '2019-01-29', 122, NULL),
('Sheraton Centre', 224, '2019-01-30', 172, NULL),
('Sheraton Centre', 224, '2019-01-31', 196, NULL),
('Sheraton Centre', 224, '2019-02-01', 381, NULL),
('Sheraton Centre', 224, '2019-02-02', 196, NULL),
('Sheraton Centre', 224, '2019-02-03', 203, NULL),
('Sheraton Centre', 224, '2019-02-04', 279, NULL),
('Sheraton Centre', 224, '2019-02-05', 289, NULL),
('Sheraton Centre', 224, '2019-02-06', 219, NULL),
('Sheraton Centre', 224, '2019-02-07', 330, NULL),
('Sheraton Centre', 224, '2019-02-08', 353, NULL),
('Sheraton Centre', 224, '2019-02-09', 273, NULL),
('Sheraton Centre', 224, '2019-02-10', 238, NULL),
('Sheraton Centre', 224, '2019-02-11', 267, NULL),
('Sheraton Centre', 224, '2019-02-12', 347, NULL),
('Sheraton Centre', 224, '2019-02-13', 100, NULL),
('Sheraton Centre', 224, '2019-02-14', 257, NULL),
('Sheraton Centre', 224, '2019-02-15', 270, NULL),
('Sheraton Centre', 224, '2019-02-16', 212, NULL),
('Sheraton Centre', 224, '2019-02-17', 201, NULL),
('Sheraton Centre', 224, '2019-02-18', 185, NULL),
('Sheraton Centre', 224, '2019-02-19', 174, NULL),
('Sheraton Centre', 224, '2019-02-20', 168, NULL),
('Sheraton Centre', 224, '2019-02-21', 353, NULL),
('Sheraton Centre', 224, '2019-02-22', 313, NULL),
('Sheraton Centre', 224, '2019-02-23', 235, NULL),
('Sheraton Centre', 224, '2019-02-24', 311, NULL),
('Sheraton Centre', 224, '2019-02-25', 227, NULL),
('Sheraton Centre', 224, '2019-02-26', 309, NULL),
('Sheraton Centre', 224, '2019-02-27', 175, NULL),
('Sheraton Centre', 224, '2019-02-28', 106, NULL),
('Sheraton Centre', 224, '2019-03-01', 219, NULL),
('Sheraton Centre', 224, '2019-03-02', 388, NULL),
('Sheraton Centre', 224, '2019-03-03', 295, NULL),
('Sheraton Centre', 224, '2019-03-04', 227, NULL),
('Sheraton Centre', 224, '2019-03-05', 154, NULL),
('Sheraton Centre', 224, '2019-03-06', 143, NULL),
('Sheraton Centre', 224, '2019-03-07', 352, NULL),
('Sheraton Centre', 224, '2019-03-08', 294, NULL),
('Sheraton Centre', 224, '2019-03-09', 372, NULL),
('Sheraton Centre', 224, '2019-03-10', 341, NULL),
('Sheraton Centre', 224, '2019-03-11', 204, NULL),
('Sheraton Centre', 224, '2019-03-12', 373, NULL),
('Sheraton Centre', 224, '2019-03-13', 215, NULL),
('Sheraton Centre', 224, '2019-03-14', 371, NULL),
('Sheraton Centre', 224, '2019-03-15', 141, NULL),
('Sheraton Centre', 224, '2019-03-16', 373, NULL),
('Sheraton Centre', 224, '2019-03-17', 167, NULL),
('Sheraton Centre', 224, '2019-03-18', 389, NULL),
('Sheraton Centre', 224, '2019-03-19', 142, NULL),
('Sheraton Centre', 224, '2019-03-20', 293, NULL),
('Sheraton Centre', 224, '2019-03-21', 282, NULL),
('Sheraton Centre', 224, '2019-03-22', 156, NULL),
('Sheraton Centre', 224, '2019-03-23', 149, NULL),
('Sheraton Centre', 224, '2019-03-24', 222, NULL),
('Sheraton Centre', 224, '2019-03-25', 318, NULL),
('Sheraton Centre', 224, '2019-03-26', 174, NULL),
('Sheraton Centre', 224, '2019-03-27', 314, NULL),
('Sheraton Centre', 224, '2019-03-28', 190, NULL),
('Sheraton Centre', 224, '2019-03-29', 394, NULL),
('Sheraton Centre', 224, '2019-03-30', 340, NULL),
('Sheraton Centre', 224, '2019-03-31', 335, NULL),
('Sheraton Centre', 224, '2019-04-01', 208, NULL),
('Sheraton Centre', 224, '2019-04-02', 316, NULL),
('Sheraton Centre', 224, '2019-04-03', 337, NULL),
('Sheraton Centre', 224, '2019-04-04', 217, NULL),
('Sheraton Centre', 224, '2019-04-05', 353, NULL),
('Sheraton Centre', 224, '2019-04-06', 369, NULL),
('Sheraton Centre', 224, '2019-04-07', 130, NULL),
('Sheraton Centre', 224, '2019-04-08', 363, NULL),
('Sheraton Centre', 224, '2019-04-09', 228, NULL),
('Sheraton Centre', 224, '2019-04-10', 321, NULL),
('Sheraton Centre', 224, '2019-04-11', 161, NULL),
('Sheraton Centre', 224, '2019-04-12', 125, NULL),
('Sheraton Centre', 224, '2019-04-13', 107, NULL),
('Sheraton Centre', 224, '2019-04-14', 137, NULL),
('Sheraton Centre', 224, '2019-04-15', 185, NULL),
('Sheraton Centre', 224, '2019-04-16', 365, NULL),
('Sheraton Centre', 224, '2019-04-17', 345, NULL),
('Sheraton Centre', 224, '2019-04-18', 138, NULL),
('Sheraton Centre', 224, '2019-04-19', 393, NULL),
('Sheraton Centre', 224, '2019-04-20', 159, NULL),
('Sheraton Centre', 224, '2019-04-21', 370, NULL),
('Sheraton Centre', 224, '2019-04-22', 139, NULL),
('Sheraton Centre', 224, '2019-04-23', 186, NULL),
('Sheraton Centre', 224, '2019-04-24', 353, NULL),
('Sheraton Centre', 224, '2019-04-25', 204, NULL),
('Sheraton Centre', 224, '2019-04-26', 313, NULL),
('Sheraton Centre', 224, '2019-04-27', 351, NULL),
('Sheraton Centre', 224, '2019-04-28', 117, NULL),
('Sheraton Centre', 224, '2019-04-29', 347, NULL),
('Sheraton Centre', 224, '2019-04-30', 231, NULL),
('Sheraton Centre', 224, '2019-05-01', 180, NULL),
('Sheraton Centre', 224, '2019-05-02', 305, NULL),
('Sheraton Centre', 224, '2019-05-03', 127, NULL),
('Sheraton Centre', 224, '2019-05-04', 110, NULL),
('Sheraton Centre', 224, '2019-05-05', 346, NULL),
('Sheraton Centre', 224, '2019-05-06', 313, NULL),
('Sheraton Centre', 224, '2019-05-07', 206, NULL),
('Sheraton Centre', 224, '2019-05-08', 298, NULL),
('Sheraton Centre', 224, '2019-05-09', 306, NULL),
('Sheraton Centre', 224, '2019-05-10', 123, NULL),
('Sheraton Centre', 224, '2019-05-11', 293, NULL),
('Sheraton Centre', 224, '2019-05-12', 185, NULL),
('Sheraton Centre', 224, '2019-05-13', 276, NULL),
('Sheraton Centre', 224, '2019-05-14', 393, NULL),
('Sheraton Centre', 224, '2019-05-15', 159, NULL),
('Sheraton Centre', 224, '2019-05-16', 318, NULL),
('Sheraton Centre', 224, '2019-05-17', 323, NULL),
('Sheraton Centre', 224, '2019-05-18', 222, NULL),
('Sheraton Centre', 224, '2019-05-19', 259, NULL),
('Sheraton Centre', 224, '2019-05-20', 286, NULL),
('Sheraton Centre', 224, '2019-05-21', 366, NULL),
('Sheraton Centre', 224, '2019-05-22', 192, NULL),
('Sheraton Centre', 224, '2019-05-23', 362, NULL),
('Sheraton Centre', 224, '2019-05-24', 217, NULL),
('Sheraton Centre', 224, '2019-05-25', 206, NULL),
('Sheraton Centre', 224, '2019-05-26', 218, NULL),
('Sheraton Centre', 224, '2019-05-27', 266, NULL),
('Sheraton Centre', 224, '2019-05-28', 364, NULL),
('Sheraton Centre', 224, '2019-05-29', 144, NULL),
('Sheraton Centre', 224, '2019-05-30', 193, NULL),
('Sheraton Centre', 224, '2019-05-31', 278, NULL),
('Sheraton Centre', 224, '2019-06-01', 255, NULL),
('Sheraton Centre', 224, '2019-06-02', 389, NULL),
('Sheraton Centre', 224, '2019-06-03', 381, NULL),
('Sheraton Centre', 224, '2019-06-04', 302, NULL),
('Sheraton Centre', 224, '2019-06-05', 344, NULL),
('Sheraton Centre', 224, '2019-06-06', 133, NULL),
('Sheraton Centre', 224, '2019-06-07', 230, NULL),
('Sheraton Centre', 224, '2019-06-08', 134, NULL),
('Sheraton Centre', 224, '2019-06-09', 227, NULL),
('Sheraton Centre', 224, '2019-06-10', 309, NULL),
('Sheraton Centre', 224, '2019-06-11', 349, NULL),
('Sheraton Centre', 224, '2019-06-12', 345, NULL),
('Sheraton Centre', 224, '2019-06-13', 388, NULL),
('Sheraton Centre', 224, '2019-06-14', 154, NULL),
('Sheraton Centre', 224, '2019-06-15', 139, NULL),
('Sheraton Centre', 224, '2019-06-16', 105, NULL),
('Sheraton Centre', 224, '2019-06-17', 353, NULL),
('Sheraton Centre', 224, '2019-06-18', 365, NULL),
('Sheraton Centre', 224, '2019-06-19', 229, NULL),
('Sheraton Centre', 224, '2019-06-20', 111, NULL),
('Sheraton Centre', 224, '2019-06-21', 165, NULL),
('Sheraton Centre', 224, '2019-06-22', 106, NULL),
('Sheraton Centre', 224, '2019-06-23', 342, NULL),
('Sheraton Centre', 224, '2019-06-24', 234, NULL),
('Sheraton Centre', 224, '2019-06-25', 318, NULL),
('Sheraton Centre', 224, '2019-06-26', 198, NULL),
('Sheraton Centre', 224, '2019-06-27', 347, NULL),
('Sheraton Centre', 224, '2019-06-28', 127, NULL),
('Sheraton Centre', 224, '2019-06-29', 127, NULL),
('Sheraton Centre', 224, '2019-06-30', 284, NULL),
('Sheraton Centre', 224, '2019-07-01', 292, NULL),
('Sheraton Centre', 224, '2019-07-02', 293, NULL),
('Sheraton Centre', 224, '2019-07-03', 356, NULL),
('Sheraton Centre', 224, '2019-07-04', 197, NULL),
('Sheraton Centre', 224, '2019-07-05', 305, NULL),
('Sheraton Centre', 224, '2019-07-06', 378, NULL),
('Sheraton Centre', 224, '2019-07-07', 111, NULL),
('Sheraton Centre', 224, '2019-07-08', 332, NULL),
('Sheraton Centre', 224, '2019-07-09', 197, NULL),
('Sheraton Centre', 224, '2019-07-10', 294, NULL),
('Sheraton Centre', 224, '2019-07-11', 373, NULL),
('Sheraton Centre', 224, '2019-07-12', 153, NULL),
('Sheraton Centre', 224, '2019-07-13', 387, NULL),
('Sheraton Centre', 224, '2019-07-14', 145, NULL),
('Sheraton Centre', 224, '2019-07-15', 146, NULL),
('Sheraton Centre', 224, '2019-07-16', 272, NULL),
('Sheraton Centre', 224, '2019-07-17', 160, NULL),
('Sheraton Centre', 224, '2019-07-18', 361, NULL),
('Sheraton Centre', 224, '2019-07-19', 145, NULL),
('Sheraton Centre', 224, '2019-07-20', 198, NULL),
('Sheraton Centre', 224, '2019-07-21', 169, NULL),
('Sheraton Centre', 224, '2019-07-22', 383, NULL),
('Sheraton Centre', 224, '2019-07-23', 399, NULL),
('Sheraton Centre', 224, '2019-07-24', 188, NULL),
('Sheraton Centre', 224, '2019-07-25', 104, NULL),
('Sheraton Centre', 224, '2019-07-26', 282, NULL),
('Sheraton Centre', 224, '2019-07-27', 228, NULL),
('Sheraton Centre', 224, '2019-07-28', 396, NULL),
('Sheraton Centre', 224, '2019-07-29', 121, NULL),
('Sheraton Centre', 224, '2019-07-30', 115, NULL),
('Sheraton Centre', 224, '2019-07-31', 154, NULL),
('Sheraton Centre', 224, '2019-08-01', 208, NULL),
('Sheraton Centre', 224, '2019-08-02', 319, NULL),
('Sheraton Centre', 224, '2019-08-03', 229, NULL),
('Sheraton Centre', 224, '2019-08-04', 387, NULL),
('Sheraton Centre', 224, '2019-08-05', 220, NULL),
('Sheraton Centre', 224, '2019-08-06', 358, NULL),
('Sheraton Centre', 224, '2019-08-07', 186, NULL),
('Sheraton Centre', 224, '2019-08-08', 346, NULL),
('Sheraton Centre', 224, '2019-08-09', 270, NULL),
('Sheraton Centre', 224, '2019-08-10', 315, NULL),
('Sheraton Centre', 224, '2019-08-11', 189, NULL),
('Sheraton Centre', 224, '2019-08-12', 279, NULL),
('Sheraton Centre', 224, '2019-08-13', 130, NULL),
('Sheraton Centre', 224, '2019-08-14', 107, NULL),
('Sheraton Centre', 224, '2019-08-15', 345, NULL),
('Sheraton Centre', 224, '2019-08-16', 249, NULL),
('Sheraton Centre', 224, '2019-08-17', 252, NULL),
('Sheraton Centre', 224, '2019-08-18', 218, NULL),
('Sheraton Centre', 224, '2019-08-19', 287, NULL),
('Sheraton Centre', 224, '2019-08-20', 165, NULL),
('Sheraton Centre', 224, '2019-08-21', 261, NULL),
('Sheraton Centre', 224, '2019-08-22', 228, NULL),
('Sheraton Centre', 224, '2019-08-23', 164, NULL),
('Sheraton Centre', 224, '2019-08-24', 326, NULL),
('Sheraton Centre', 224, '2019-08-25', 101, NULL),
('Sheraton Centre', 224, '2019-08-26', 322, NULL),
('Sheraton Centre', 224, '2019-08-27', 399, NULL),
('Sheraton Centre', 224, '2019-08-28', 246, NULL),
('Sheraton Centre', 224, '2019-08-29', 300, NULL),
('Sheraton Centre', 224, '2019-08-30', 189, NULL),
('Sheraton Centre', 224, '2019-08-31', 344, NULL),
('Sheraton Centre', 224, '2019-09-01', 393, NULL),
('Sheraton Centre', 224, '2019-09-02', 185, NULL),
('Sheraton Centre', 224, '2019-09-03', 115, NULL),
('Sheraton Centre', 224, '2019-09-04', 398, NULL),
('Sheraton Centre', 224, '2019-09-05', 133, NULL),
('Sheraton Centre', 224, '2019-09-06', 311, NULL),
('Sheraton Centre', 224, '2019-09-07', 277, NULL),
('Sheraton Centre', 224, '2019-09-08', 120, NULL),
('Sheraton Centre', 224, '2019-09-09', 205, NULL),
('Sheraton Centre', 224, '2019-09-10', 258, NULL),
('Sheraton Centre', 224, '2019-09-11', 299, NULL),
('Sheraton Centre', 224, '2019-09-12', 100, NULL),
('Sheraton Centre', 224, '2019-09-13', 352, NULL),
('Sheraton Centre', 224, '2019-09-14', 208, NULL),
('Sheraton Centre', 224, '2019-09-15', 267, NULL),
('Sheraton Centre', 224, '2019-09-16', 259, NULL),
('Sheraton Centre', 224, '2019-09-17', 140, NULL),
('Sheraton Centre', 224, '2019-09-18', 234, NULL),
('Sheraton Centre', 224, '2019-09-19', 286, NULL),
('Sheraton Centre', 224, '2019-09-20', 101, NULL),
('Sheraton Centre', 224, '2019-09-21', 320, NULL),
('Sheraton Centre', 224, '2019-09-22', 115, NULL),
('Sheraton Centre', 224, '2019-09-23', 276, NULL),
('Sheraton Centre', 224, '2019-09-24', 266, NULL),
('Sheraton Centre', 224, '2019-09-25', 327, NULL),
('Sheraton Centre', 224, '2019-09-26', 186, NULL),
('Sheraton Centre', 224, '2019-09-27', 128, NULL),
('Sheraton Centre', 224, '2019-09-28', 239, NULL),
('Sheraton Centre', 224, '2019-09-29', 128, NULL),
('Sheraton Centre', 224, '2019-09-30', 223, NULL),
('Sheraton Centre', 224, '2019-10-01', 264, NULL),
('Sheraton Centre', 224, '2019-10-02', 199, NULL),
('Sheraton Centre', 224, '2019-10-03', 334, NULL),
('Sheraton Centre', 224, '2019-10-04', 280, NULL),
('Sheraton Centre', 224, '2019-10-05', 381, NULL),
('Sheraton Centre', 224, '2019-10-06', 273, NULL),
('Sheraton Centre', 224, '2019-10-07', 244, NULL),
('Sheraton Centre', 224, '2019-10-08', 238, NULL),
('Sheraton Centre', 224, '2019-10-09', 356, NULL),
('Sheraton Centre', 224, '2019-10-10', 302, NULL),
('Sheraton Centre', 224, '2019-10-11', 227, NULL),
('Sheraton Centre', 224, '2019-10-12', 291, NULL),
('Sheraton Centre', 224, '2019-10-13', 219, NULL),
('Sheraton Centre', 224, '2019-10-14', 285, NULL),
('Sheraton Centre', 224, '2019-10-15', 387, NULL),
('Sheraton Centre', 224, '2019-10-16', 231, NULL),
('Sheraton Centre', 224, '2019-10-17', 368, NULL),
('Sheraton Centre', 224, '2019-10-18', 141, NULL),
('Sheraton Centre', 224, '2019-10-19', 367, NULL),
('Sheraton Centre', 224, '2019-10-20', 277, NULL),
('Sheraton Centre', 224, '2019-10-21', 300, NULL),
('Sheraton Centre', 224, '2019-10-22', 144, NULL),
('Sheraton Centre', 224, '2019-10-23', 183, NULL),
('Sheraton Centre', 224, '2019-10-24', 111, NULL),
('Sheraton Centre', 224, '2019-10-25', 284, NULL),
('Sheraton Centre', 224, '2019-10-26', 179, NULL),
('Sheraton Centre', 224, '2019-10-27', 377, NULL),
('Sheraton Centre', 224, '2019-10-28', 187, NULL),
('Sheraton Centre', 224, '2019-10-29', 196, NULL),
('Sheraton Centre', 224, '2019-10-30', 236, NULL),
('Sheraton Centre', 224, '2019-10-31', 268, NULL),
('Sheraton Centre', 224, '2019-11-01', 157, NULL),
('Sheraton Centre', 224, '2019-11-02', 363, NULL),
('Sheraton Centre', 224, '2019-11-03', 357, NULL),
('Sheraton Centre', 224, '2019-11-04', 171, NULL),
('Sheraton Centre', 224, '2019-11-05', 301, NULL),
('Sheraton Centre', 224, '2019-11-06', 388, NULL),
('Sheraton Centre', 224, '2019-11-07', 218, NULL),
('Sheraton Centre', 224, '2019-11-08', 340, NULL),
('Sheraton Centre', 224, '2019-11-09', 292, NULL),
('Sheraton Centre', 224, '2019-11-10', 351, NULL),
('Sheraton Centre', 224, '2019-11-11', 114, NULL),
('Sheraton Centre', 224, '2019-11-12', 189, NULL),
('Sheraton Centre', 224, '2019-11-13', 165, NULL),
('Sheraton Centre', 224, '2019-11-14', 120, NULL),
('Sheraton Centre', 224, '2019-11-15', 281, NULL),
('Sheraton Centre', 224, '2019-11-16', 133, NULL),
('Sheraton Centre', 224, '2019-11-17', 212, NULL),
('Sheraton Centre', 224, '2019-11-18', 135, NULL),
('Sheraton Centre', 224, '2019-11-19', 193, NULL),
('Sheraton Centre', 224, '2019-11-20', 335, NULL),
('Sheraton Centre', 224, '2019-11-21', 191, NULL),
('Sheraton Centre', 224, '2019-11-22', 293, NULL),
('Sheraton Centre', 224, '2019-11-23', 354, NULL),
('Sheraton Centre', 224, '2019-11-24', 371, NULL),
('Sheraton Centre', 224, '2019-11-25', 359, NULL),
('Sheraton Centre', 224, '2019-11-26', 193, NULL),
('Sheraton Centre', 224, '2019-11-27', 283, NULL),
('Sheraton Centre', 224, '2019-11-28', 294, NULL),
('Sheraton Centre', 224, '2019-11-29', 268, NULL),
('Sheraton Centre', 224, '2019-11-30', 362, NULL),
('Sheraton Centre', 224, '2019-12-01', 291, NULL),
('Sheraton Centre', 224, '2019-12-02', 194, NULL),
('Sheraton Centre', 224, '2019-12-03', 370, NULL),
('Sheraton Centre', 224, '2019-12-04', 342, NULL),
('Sheraton Centre', 224, '2019-12-05', 332, NULL),
('Sheraton Centre', 224, '2019-12-06', 386, NULL),
('Sheraton Centre', 224, '2019-12-07', 162, NULL),
('Sheraton Centre', 224, '2019-12-08', 381, NULL),
('Sheraton Centre', 224, '2019-12-09', 280, NULL),
('Sheraton Centre', 224, '2019-12-10', 363, NULL),
('Sheraton Centre', 224, '2019-12-11', 279, NULL),
('Sheraton Centre', 224, '2019-12-12', 107, NULL),
('Sheraton Centre', 224, '2019-12-13', 349, NULL),
('Sheraton Centre', 224, '2019-12-14', 358, NULL),
('Sheraton Centre', 224, '2019-12-15', 119, NULL),
('Sheraton Centre', 224, '2019-12-16', 288, NULL),
('Sheraton Centre', 224, '2019-12-17', 135, NULL),
('Sheraton Centre', 224, '2019-12-18', 233, NULL),
('Sheraton Centre', 224, '2019-12-19', 144, NULL),
('Sheraton Centre', 224, '2019-12-20', 150, NULL),
('Sheraton Centre', 224, '2019-12-21', 111, NULL),
('Sheraton Centre', 224, '2019-12-22', 166, NULL),
('Sheraton Centre', 224, '2019-12-23', 293, NULL),
('Sheraton Centre', 224, '2019-12-24', 318, NULL),
('Sheraton Centre', 224, '2019-12-25', 336, NULL),
('Sheraton Centre', 224, '2019-12-26', 210, NULL),
('Sheraton Centre', 224, '2019-12-27', 315, NULL),
('Sheraton Centre', 224, '2019-12-28', 157, NULL),
('Sheraton Centre', 224, '2019-12-29', 289, NULL),
('Sheraton Centre', 224, '2019-12-30', 165, NULL),
('Sheraton Centre', 224, '2019-12-31', 217, NULL),
('Sheraton Centre', 224, '2020-01-01', 137, NULL),
('Sheraton Centre', 224, '2020-01-02', 324, NULL),
('Sheraton Centre', 224, '2020-01-03', 261, NULL),
('Sheraton Centre', 224, '2020-01-04', 348, NULL),
('Sheraton Centre', 224, '2020-01-05', 136, NULL),
('Sheraton Centre', 224, '2020-01-06', 372, NULL),
('Sheraton Centre', 224, '2020-01-07', 140, NULL),
('Sheraton Centre', 224, '2020-01-08', 358, NULL),
('Sheraton Centre', 224, '2020-01-09', 146, NULL),
('Sheraton Centre', 224, '2020-01-10', 340, NULL),
('Sheraton Centre', 224, '2020-01-11', 137, NULL),
('Sheraton Centre', 224, '2020-01-12', 398, NULL),
('Sheraton Centre', 224, '2020-01-13', 204, NULL),
('Sheraton Centre', 224, '2020-01-14', 244, NULL),
('Sheraton Centre', 224, '2020-01-15', 105, NULL),
('Sheraton Centre', 224, '2020-01-16', 369, NULL),
('Sheraton Centre', 224, '2020-01-17', 178, NULL),
('Sheraton Centre', 224, '2020-01-18', 128, NULL),
('Sheraton Centre', 224, '2020-01-19', 359, NULL),
('Sheraton Centre', 224, '2020-01-20', 210, NULL),
('Sheraton Centre', 224, '2020-01-21', 180, NULL),
('Sheraton Centre', 224, '2020-01-22', 374, NULL),
('Sheraton Centre', 224, '2020-01-23', 316, NULL),
('Sheraton Centre', 224, '2020-01-24', 330, NULL),
('Sheraton Centre', 224, '2020-01-25', 310, NULL),
('Sheraton Centre', 224, '2020-01-26', 130, NULL),
('Sheraton Centre', 224, '2020-01-27', 257, NULL),
('Sheraton Centre', 224, '2020-01-28', 179, NULL),
('Sheraton Centre', 224, '2020-01-29', 152, NULL),
('Sheraton Centre', 224, '2020-01-30', 111, NULL),
('Sheraton Centre', 224, '2020-01-31', 248, NULL),
('Sheraton Centre', 224, '2020-02-01', 197, NULL),
('Sheraton Centre', 224, '2020-02-02', 239, NULL),
('Sheraton Centre', 224, '2020-02-03', 333, NULL),
('Sheraton Centre', 224, '2020-02-04', 342, NULL),
('Sheraton Centre', 227, '2019-01-01', 133, NULL),
('Sheraton Centre', 227, '2019-01-02', 165, NULL),
('Sheraton Centre', 227, '2019-01-03', 282, NULL),
('Sheraton Centre', 227, '2019-01-04', 395, NULL),
('Sheraton Centre', 227, '2019-01-05', 329, NULL),
('Sheraton Centre', 227, '2019-01-06', 355, NULL),
('Sheraton Centre', 227, '2019-01-07', 279, NULL),
('Sheraton Centre', 227, '2019-01-08', 307, NULL),
('Sheraton Centre', 227, '2019-01-09', 123, NULL),
('Sheraton Centre', 227, '2019-01-10', 137, NULL),
('Sheraton Centre', 227, '2019-01-11', 244, NULL),
('Sheraton Centre', 227, '2019-01-12', 245, NULL),
('Sheraton Centre', 227, '2019-01-13', 195, NULL),
('Sheraton Centre', 227, '2019-01-14', 240, NULL),
('Sheraton Centre', 227, '2019-01-15', 248, NULL),
('Sheraton Centre', 227, '2019-01-16', 223, NULL),
('Sheraton Centre', 227, '2019-01-17', 350, NULL),
('Sheraton Centre', 227, '2019-01-18', 118, NULL),
('Sheraton Centre', 227, '2019-01-19', 144, NULL),
('Sheraton Centre', 227, '2019-01-20', 123, NULL),
('Sheraton Centre', 227, '2019-01-21', 385, NULL),
('Sheraton Centre', 227, '2019-01-22', 340, NULL),
('Sheraton Centre', 227, '2019-01-23', 343, NULL),
('Sheraton Centre', 227, '2019-01-24', 247, NULL),
('Sheraton Centre', 227, '2019-01-25', 320, NULL),
('Sheraton Centre', 227, '2019-01-26', 302, NULL),
('Sheraton Centre', 227, '2019-01-27', 349, NULL),
('Sheraton Centre', 227, '2019-01-28', 279, NULL),
('Sheraton Centre', 227, '2019-01-29', 298, NULL),
('Sheraton Centre', 227, '2019-01-30', 158, NULL),
('Sheraton Centre', 227, '2019-01-31', 326, NULL),
('Sheraton Centre', 227, '2019-02-01', 377, NULL),
('Sheraton Centre', 227, '2019-02-02', 209, NULL),
('Sheraton Centre', 227, '2019-02-03', 349, NULL),
('Sheraton Centre', 227, '2019-02-04', 323, NULL),
('Sheraton Centre', 227, '2019-02-05', 221, NULL),
('Sheraton Centre', 227, '2019-02-06', 271, NULL),
('Sheraton Centre', 227, '2019-02-07', 354, NULL),
('Sheraton Centre', 227, '2019-02-08', 231, NULL),
('Sheraton Centre', 227, '2019-02-09', 144, NULL),
('Sheraton Centre', 227, '2019-02-10', 312, NULL),
('Sheraton Centre', 227, '2019-02-11', 337, NULL),
('Sheraton Centre', 227, '2019-02-12', 144, NULL),
('Sheraton Centre', 227, '2019-02-13', 170, NULL),
('Sheraton Centre', 227, '2019-02-14', 322, NULL),
('Sheraton Centre', 227, '2019-02-15', 304, NULL),
('Sheraton Centre', 227, '2019-02-16', 159, NULL),
('Sheraton Centre', 227, '2019-02-17', 364, NULL),
('Sheraton Centre', 227, '2019-02-18', 398, NULL),
('Sheraton Centre', 227, '2019-02-19', 158, NULL),
('Sheraton Centre', 227, '2019-02-20', 214, NULL),
('Sheraton Centre', 227, '2019-02-21', 243, NULL),
('Sheraton Centre', 227, '2019-02-22', 204, NULL),
('Sheraton Centre', 227, '2019-02-23', 186, NULL),
('Sheraton Centre', 227, '2019-02-24', 105, NULL),
('Sheraton Centre', 227, '2019-02-25', 102, NULL),
('Sheraton Centre', 227, '2019-02-26', 109, NULL),
('Sheraton Centre', 227, '2019-02-27', 204, NULL),
('Sheraton Centre', 227, '2019-02-28', 202, NULL),
('Sheraton Centre', 227, '2019-03-01', 158, NULL),
('Sheraton Centre', 227, '2019-03-02', 374, NULL),
('Sheraton Centre', 227, '2019-03-03', 334, NULL),
('Sheraton Centre', 227, '2019-03-04', 269, NULL),
('Sheraton Centre', 227, '2019-03-05', 176, NULL),
('Sheraton Centre', 227, '2019-03-06', 350, NULL),
('Sheraton Centre', 227, '2019-03-07', 198, NULL),
('Sheraton Centre', 227, '2019-03-08', 396, NULL),
('Sheraton Centre', 227, '2019-03-09', 286, NULL),
('Sheraton Centre', 227, '2019-03-10', 252, NULL),
('Sheraton Centre', 227, '2019-03-11', 352, NULL),
('Sheraton Centre', 227, '2019-03-12', 221, NULL),
('Sheraton Centre', 227, '2019-03-13', 357, NULL),
('Sheraton Centre', 227, '2019-03-14', 131, NULL),
('Sheraton Centre', 227, '2019-03-15', 202, NULL),
('Sheraton Centre', 227, '2019-03-16', 296, NULL),
('Sheraton Centre', 227, '2019-03-17', 207, NULL),
('Sheraton Centre', 227, '2019-03-18', 222, NULL),
('Sheraton Centre', 227, '2019-03-19', 160, NULL),
('Sheraton Centre', 227, '2019-03-20', 107, NULL),
('Sheraton Centre', 227, '2019-03-21', 352, NULL),
('Sheraton Centre', 227, '2019-03-22', 194, NULL),
('Sheraton Centre', 227, '2019-03-23', 391, NULL),
('Sheraton Centre', 227, '2019-03-24', 225, NULL),
('Sheraton Centre', 227, '2019-03-25', 301, NULL),
('Sheraton Centre', 227, '2019-03-26', 287, NULL),
('Sheraton Centre', 227, '2019-03-27', 334, NULL),
('Sheraton Centre', 227, '2019-03-28', 130, NULL),
('Sheraton Centre', 227, '2019-03-29', 287, NULL),
('Sheraton Centre', 227, '2019-03-30', 301, NULL),
('Sheraton Centre', 227, '2019-03-31', 214, NULL),
('Sheraton Centre', 227, '2019-04-01', 245, NULL),
('Sheraton Centre', 227, '2019-04-02', 397, NULL),
('Sheraton Centre', 227, '2019-04-03', 378, NULL),
('Sheraton Centre', 227, '2019-04-04', 261, NULL),
('Sheraton Centre', 227, '2019-04-05', 335, NULL),
('Sheraton Centre', 227, '2019-04-06', 297, NULL),
('Sheraton Centre', 227, '2019-04-07', 127, NULL),
('Sheraton Centre', 227, '2019-04-08', 314, NULL),
('Sheraton Centre', 227, '2019-04-09', 243, NULL),
('Sheraton Centre', 227, '2019-04-10', 304, NULL),
('Sheraton Centre', 227, '2019-04-11', 368, NULL),
('Sheraton Centre', 227, '2019-04-12', 388, NULL),
('Sheraton Centre', 227, '2019-04-13', 188, NULL),
('Sheraton Centre', 227, '2019-04-14', 394, NULL),
('Sheraton Centre', 227, '2019-04-15', 329, NULL),
('Sheraton Centre', 227, '2019-04-16', 253, NULL),
('Sheraton Centre', 227, '2019-04-17', 270, NULL),
('Sheraton Centre', 227, '2019-04-18', 281, NULL),
('Sheraton Centre', 227, '2019-04-19', 172, NULL),
('Sheraton Centre', 227, '2019-04-20', 303, NULL),
('Sheraton Centre', 227, '2019-04-21', 273, NULL),
('Sheraton Centre', 227, '2019-04-22', 219, NULL),
('Sheraton Centre', 227, '2019-04-23', 366, NULL),
('Sheraton Centre', 227, '2019-04-24', 120, NULL),
('Sheraton Centre', 227, '2019-04-25', 322, NULL),
('Sheraton Centre', 227, '2019-04-26', 329, NULL),
('Sheraton Centre', 227, '2019-04-27', 113, NULL),
('Sheraton Centre', 227, '2019-04-28', 230, NULL),
('Sheraton Centre', 227, '2019-04-29', 336, NULL),
('Sheraton Centre', 227, '2019-04-30', 200, NULL),
('Sheraton Centre', 227, '2019-05-01', 138, NULL),
('Sheraton Centre', 227, '2019-05-02', 398, NULL),
('Sheraton Centre', 227, '2019-05-03', 129, NULL),
('Sheraton Centre', 227, '2019-05-04', 258, NULL),
('Sheraton Centre', 227, '2019-05-05', 192, NULL),
('Sheraton Centre', 227, '2019-05-06', 195, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 227, '2019-05-07', 242, NULL),
('Sheraton Centre', 227, '2019-05-08', 397, NULL),
('Sheraton Centre', 227, '2019-05-09', 201, NULL),
('Sheraton Centre', 227, '2019-05-10', 199, NULL),
('Sheraton Centre', 227, '2019-05-11', 360, NULL),
('Sheraton Centre', 227, '2019-05-12', 279, NULL),
('Sheraton Centre', 227, '2019-05-13', 353, NULL),
('Sheraton Centre', 227, '2019-05-14', 110, NULL),
('Sheraton Centre', 227, '2019-05-15', 263, NULL),
('Sheraton Centre', 227, '2019-05-16', 188, NULL),
('Sheraton Centre', 227, '2019-05-17', 206, NULL),
('Sheraton Centre', 227, '2019-05-18', 221, NULL),
('Sheraton Centre', 227, '2019-05-19', 321, NULL),
('Sheraton Centre', 227, '2019-05-20', 290, NULL),
('Sheraton Centre', 227, '2019-05-21', 114, NULL),
('Sheraton Centre', 227, '2019-05-22', 337, NULL),
('Sheraton Centre', 227, '2019-05-23', 359, NULL),
('Sheraton Centre', 227, '2019-05-24', 307, NULL),
('Sheraton Centre', 227, '2019-05-25', 289, NULL),
('Sheraton Centre', 227, '2019-05-26', 379, NULL),
('Sheraton Centre', 227, '2019-05-27', 143, NULL),
('Sheraton Centre', 227, '2019-05-28', 211, NULL),
('Sheraton Centre', 227, '2019-05-29', 382, NULL),
('Sheraton Centre', 227, '2019-05-30', 361, NULL),
('Sheraton Centre', 227, '2019-05-31', 142, NULL),
('Sheraton Centre', 227, '2019-06-01', 360, NULL),
('Sheraton Centre', 227, '2019-06-02', 152, NULL),
('Sheraton Centre', 227, '2019-06-03', 206, NULL),
('Sheraton Centre', 227, '2019-06-04', 327, NULL),
('Sheraton Centre', 227, '2019-06-05', 259, NULL),
('Sheraton Centre', 227, '2019-06-06', 357, NULL),
('Sheraton Centre', 227, '2019-06-07', 207, NULL),
('Sheraton Centre', 227, '2019-06-08', 123, NULL),
('Sheraton Centre', 227, '2019-06-09', 112, NULL),
('Sheraton Centre', 227, '2019-06-10', 253, NULL),
('Sheraton Centre', 227, '2019-06-11', 343, NULL),
('Sheraton Centre', 227, '2019-06-12', 396, NULL),
('Sheraton Centre', 227, '2019-06-13', 312, NULL),
('Sheraton Centre', 227, '2019-06-14', 243, NULL),
('Sheraton Centre', 227, '2019-06-15', 315, NULL),
('Sheraton Centre', 227, '2019-06-16', 135, NULL),
('Sheraton Centre', 227, '2019-06-17', 106, NULL),
('Sheraton Centre', 227, '2019-06-18', 294, NULL),
('Sheraton Centre', 227, '2019-06-19', 280, NULL),
('Sheraton Centre', 227, '2019-06-20', 136, NULL),
('Sheraton Centre', 227, '2019-06-21', 317, NULL),
('Sheraton Centre', 227, '2019-06-22', 348, NULL),
('Sheraton Centre', 227, '2019-06-23', 305, NULL),
('Sheraton Centre', 227, '2019-06-24', 245, NULL),
('Sheraton Centre', 227, '2019-06-25', 176, NULL),
('Sheraton Centre', 227, '2019-06-26', 201, NULL),
('Sheraton Centre', 227, '2019-06-27', 300, NULL),
('Sheraton Centre', 227, '2019-06-28', 391, NULL),
('Sheraton Centre', 227, '2019-06-29', 174, NULL),
('Sheraton Centre', 227, '2019-06-30', 399, NULL),
('Sheraton Centre', 227, '2019-07-01', 341, NULL),
('Sheraton Centre', 227, '2019-07-02', 266, NULL),
('Sheraton Centre', 227, '2019-07-03', 175, NULL),
('Sheraton Centre', 227, '2019-07-04', 237, NULL),
('Sheraton Centre', 227, '2019-07-05', 210, NULL),
('Sheraton Centre', 227, '2019-07-06', 342, NULL),
('Sheraton Centre', 227, '2019-07-07', 106, NULL),
('Sheraton Centre', 227, '2019-07-08', 366, NULL),
('Sheraton Centre', 227, '2019-07-09', 101, NULL),
('Sheraton Centre', 227, '2019-07-10', 210, NULL),
('Sheraton Centre', 227, '2019-07-11', 230, NULL),
('Sheraton Centre', 227, '2019-07-12', 397, NULL),
('Sheraton Centre', 227, '2019-07-13', 283, NULL),
('Sheraton Centre', 227, '2019-07-14', 351, NULL),
('Sheraton Centre', 227, '2019-07-15', 357, NULL),
('Sheraton Centre', 227, '2019-07-16', 266, NULL),
('Sheraton Centre', 227, '2019-07-17', 201, NULL),
('Sheraton Centre', 227, '2019-07-18', 269, NULL),
('Sheraton Centre', 227, '2019-07-19', 162, NULL),
('Sheraton Centre', 227, '2019-07-20', 143, NULL),
('Sheraton Centre', 227, '2019-07-21', 112, NULL),
('Sheraton Centre', 227, '2019-07-22', 315, NULL),
('Sheraton Centre', 227, '2019-07-23', 347, NULL),
('Sheraton Centre', 227, '2019-07-24', 268, NULL),
('Sheraton Centre', 227, '2019-07-25', 335, NULL),
('Sheraton Centre', 227, '2019-07-26', 319, NULL),
('Sheraton Centre', 227, '2019-07-27', 355, NULL),
('Sheraton Centre', 227, '2019-07-28', 233, NULL),
('Sheraton Centre', 227, '2019-07-29', 163, NULL),
('Sheraton Centre', 227, '2019-07-30', 375, NULL),
('Sheraton Centre', 227, '2019-07-31', 322, NULL),
('Sheraton Centre', 227, '2019-08-01', 325, NULL),
('Sheraton Centre', 227, '2019-08-02', 185, NULL),
('Sheraton Centre', 227, '2019-08-03', 164, NULL),
('Sheraton Centre', 227, '2019-08-04', 397, NULL),
('Sheraton Centre', 227, '2019-08-05', 192, NULL),
('Sheraton Centre', 227, '2019-08-06', 312, NULL),
('Sheraton Centre', 227, '2019-08-07', 364, NULL),
('Sheraton Centre', 227, '2019-08-08', 183, NULL),
('Sheraton Centre', 227, '2019-08-09', 115, NULL),
('Sheraton Centre', 227, '2019-08-10', 178, NULL),
('Sheraton Centre', 227, '2019-08-11', 371, NULL),
('Sheraton Centre', 227, '2019-08-12', 101, NULL),
('Sheraton Centre', 227, '2019-08-13', 184, NULL),
('Sheraton Centre', 227, '2019-08-14', 143, NULL),
('Sheraton Centre', 227, '2019-08-15', 213, NULL),
('Sheraton Centre', 227, '2019-08-16', 242, NULL),
('Sheraton Centre', 227, '2019-08-17', 164, NULL),
('Sheraton Centre', 227, '2019-08-18', 252, NULL),
('Sheraton Centre', 227, '2019-08-19', 347, NULL),
('Sheraton Centre', 227, '2019-08-20', 129, NULL),
('Sheraton Centre', 227, '2019-08-21', 322, NULL),
('Sheraton Centre', 227, '2019-08-22', 178, NULL),
('Sheraton Centre', 227, '2019-08-23', 374, NULL),
('Sheraton Centre', 227, '2019-08-24', 312, NULL),
('Sheraton Centre', 227, '2019-08-25', 207, NULL),
('Sheraton Centre', 227, '2019-08-26', 335, NULL),
('Sheraton Centre', 227, '2019-08-27', 383, NULL),
('Sheraton Centre', 227, '2019-08-28', 392, NULL),
('Sheraton Centre', 227, '2019-08-29', 221, NULL),
('Sheraton Centre', 227, '2019-08-30', 359, NULL),
('Sheraton Centre', 227, '2019-08-31', 100, NULL),
('Sheraton Centre', 227, '2019-09-01', 187, NULL),
('Sheraton Centre', 227, '2019-09-02', 148, NULL),
('Sheraton Centre', 227, '2019-09-03', 339, NULL),
('Sheraton Centre', 227, '2019-09-04', 380, NULL),
('Sheraton Centre', 227, '2019-09-05', 258, NULL),
('Sheraton Centre', 227, '2019-09-06', 106, NULL),
('Sheraton Centre', 227, '2019-09-07', 289, NULL),
('Sheraton Centre', 227, '2019-09-08', 360, NULL),
('Sheraton Centre', 227, '2019-09-09', 182, NULL),
('Sheraton Centre', 227, '2019-09-10', 368, NULL),
('Sheraton Centre', 227, '2019-09-11', 378, NULL),
('Sheraton Centre', 227, '2019-09-12', 327, NULL),
('Sheraton Centre', 227, '2019-09-13', 228, NULL),
('Sheraton Centre', 227, '2019-09-14', 100, NULL),
('Sheraton Centre', 227, '2019-09-15', 238, NULL),
('Sheraton Centre', 227, '2019-09-16', 237, NULL),
('Sheraton Centre', 227, '2019-09-17', 148, NULL),
('Sheraton Centre', 227, '2019-09-18', 301, NULL),
('Sheraton Centre', 227, '2019-09-19', 397, NULL),
('Sheraton Centre', 227, '2019-09-20', 161, NULL),
('Sheraton Centre', 227, '2019-09-21', 190, NULL),
('Sheraton Centre', 227, '2019-09-22', 230, NULL),
('Sheraton Centre', 227, '2019-09-23', 105, NULL),
('Sheraton Centre', 227, '2019-09-24', 143, NULL),
('Sheraton Centre', 227, '2019-09-25', 269, NULL),
('Sheraton Centre', 227, '2019-09-26', 180, NULL),
('Sheraton Centre', 227, '2019-09-27', 375, NULL),
('Sheraton Centre', 227, '2019-09-28', 246, NULL),
('Sheraton Centre', 227, '2019-09-29', 208, NULL),
('Sheraton Centre', 227, '2019-09-30', 105, NULL),
('Sheraton Centre', 227, '2019-10-01', 382, NULL),
('Sheraton Centre', 227, '2019-10-02', 193, NULL),
('Sheraton Centre', 227, '2019-10-03', 102, NULL),
('Sheraton Centre', 227, '2019-10-04', 310, NULL),
('Sheraton Centre', 227, '2019-10-05', 150, NULL),
('Sheraton Centre', 227, '2019-10-06', 133, NULL),
('Sheraton Centre', 227, '2019-10-07', 272, NULL),
('Sheraton Centre', 227, '2019-10-08', 192, NULL),
('Sheraton Centre', 227, '2019-10-09', 242, NULL),
('Sheraton Centre', 227, '2019-10-10', 114, NULL),
('Sheraton Centre', 227, '2019-10-11', 145, NULL),
('Sheraton Centre', 227, '2019-10-12', 179, NULL),
('Sheraton Centre', 227, '2019-10-13', 220, NULL),
('Sheraton Centre', 227, '2019-10-14', 143, NULL),
('Sheraton Centre', 227, '2019-10-15', 310, NULL),
('Sheraton Centre', 227, '2019-10-16', 394, NULL),
('Sheraton Centre', 227, '2019-10-17', 234, NULL),
('Sheraton Centre', 227, '2019-10-18', 344, NULL),
('Sheraton Centre', 227, '2019-10-19', 182, NULL),
('Sheraton Centre', 227, '2019-10-20', 127, NULL),
('Sheraton Centre', 227, '2019-10-21', 373, NULL),
('Sheraton Centre', 227, '2019-10-22', 127, NULL),
('Sheraton Centre', 227, '2019-10-23', 245, NULL),
('Sheraton Centre', 227, '2019-10-24', 167, NULL),
('Sheraton Centre', 227, '2019-10-25', 117, NULL),
('Sheraton Centre', 227, '2019-10-26', 143, NULL),
('Sheraton Centre', 227, '2019-10-27', 101, NULL),
('Sheraton Centre', 227, '2019-10-28', 337, NULL),
('Sheraton Centre', 227, '2019-10-29', 363, NULL),
('Sheraton Centre', 227, '2019-10-30', 380, NULL),
('Sheraton Centre', 227, '2019-10-31', 371, NULL),
('Sheraton Centre', 227, '2019-11-01', 217, NULL),
('Sheraton Centre', 227, '2019-11-02', 182, NULL),
('Sheraton Centre', 227, '2019-11-03', 243, NULL),
('Sheraton Centre', 227, '2019-11-04', 349, NULL),
('Sheraton Centre', 227, '2019-11-05', 211, NULL),
('Sheraton Centre', 227, '2019-11-06', 257, NULL),
('Sheraton Centre', 227, '2019-11-07', 114, NULL),
('Sheraton Centre', 227, '2019-11-08', 121, NULL),
('Sheraton Centre', 227, '2019-11-09', 224, NULL),
('Sheraton Centre', 227, '2019-11-10', 395, NULL),
('Sheraton Centre', 227, '2019-11-11', 260, NULL),
('Sheraton Centre', 227, '2019-11-12', 308, NULL),
('Sheraton Centre', 227, '2019-11-13', 110, NULL),
('Sheraton Centre', 227, '2019-11-14', 103, NULL),
('Sheraton Centre', 227, '2019-11-15', 323, NULL),
('Sheraton Centre', 227, '2019-11-16', 392, NULL),
('Sheraton Centre', 227, '2019-11-17', 382, NULL),
('Sheraton Centre', 227, '2019-11-18', 109, NULL),
('Sheraton Centre', 227, '2019-11-19', 358, NULL),
('Sheraton Centre', 227, '2019-11-20', 300, NULL),
('Sheraton Centre', 227, '2019-11-21', 111, NULL),
('Sheraton Centre', 227, '2019-11-22', 182, NULL),
('Sheraton Centre', 227, '2019-11-23', 112, NULL),
('Sheraton Centre', 227, '2019-11-24', 328, NULL),
('Sheraton Centre', 227, '2019-11-25', 278, NULL),
('Sheraton Centre', 227, '2019-11-26', 372, NULL),
('Sheraton Centre', 227, '2019-11-27', 373, NULL),
('Sheraton Centre', 227, '2019-11-28', 203, NULL),
('Sheraton Centre', 227, '2019-11-29', 182, NULL),
('Sheraton Centre', 227, '2019-11-30', 143, NULL),
('Sheraton Centre', 227, '2019-12-01', 113, NULL),
('Sheraton Centre', 227, '2019-12-02', 258, NULL),
('Sheraton Centre', 227, '2019-12-03', 163, NULL),
('Sheraton Centre', 227, '2019-12-04', 323, NULL),
('Sheraton Centre', 227, '2019-12-05', 218, NULL),
('Sheraton Centre', 227, '2019-12-06', 355, NULL),
('Sheraton Centre', 227, '2019-12-07', 233, NULL),
('Sheraton Centre', 227, '2019-12-08', 129, NULL),
('Sheraton Centre', 227, '2019-12-09', 377, NULL),
('Sheraton Centre', 227, '2019-12-10', 223, NULL),
('Sheraton Centre', 227, '2019-12-11', 234, NULL),
('Sheraton Centre', 227, '2019-12-12', 258, NULL),
('Sheraton Centre', 227, '2019-12-13', 195, NULL),
('Sheraton Centre', 227, '2019-12-14', 136, NULL),
('Sheraton Centre', 227, '2019-12-15', 212, NULL),
('Sheraton Centre', 227, '2019-12-16', 268, NULL),
('Sheraton Centre', 227, '2019-12-17', 288, NULL),
('Sheraton Centre', 227, '2019-12-18', 383, NULL),
('Sheraton Centre', 227, '2019-12-19', 300, NULL),
('Sheraton Centre', 227, '2019-12-20', 394, NULL),
('Sheraton Centre', 227, '2019-12-21', 146, NULL),
('Sheraton Centre', 227, '2019-12-22', 142, NULL),
('Sheraton Centre', 227, '2019-12-23', 203, NULL),
('Sheraton Centre', 227, '2019-12-24', 386, NULL),
('Sheraton Centre', 227, '2019-12-25', 129, NULL),
('Sheraton Centre', 227, '2019-12-26', 185, NULL),
('Sheraton Centre', 227, '2019-12-27', 199, NULL),
('Sheraton Centre', 227, '2019-12-28', 169, NULL),
('Sheraton Centre', 227, '2019-12-29', 196, NULL),
('Sheraton Centre', 227, '2019-12-30', 312, NULL),
('Sheraton Centre', 227, '2019-12-31', 178, NULL),
('Sheraton Centre', 227, '2020-01-01', 114, NULL),
('Sheraton Centre', 227, '2020-01-02', 283, NULL),
('Sheraton Centre', 227, '2020-01-03', 158, NULL),
('Sheraton Centre', 227, '2020-01-04', 332, NULL),
('Sheraton Centre', 227, '2020-01-05', 174, NULL),
('Sheraton Centre', 227, '2020-01-06', 212, NULL),
('Sheraton Centre', 227, '2020-01-07', 113, NULL),
('Sheraton Centre', 227, '2020-01-08', 303, NULL),
('Sheraton Centre', 227, '2020-01-09', 247, NULL),
('Sheraton Centre', 227, '2020-01-10', 160, NULL),
('Sheraton Centre', 227, '2020-01-11', 278, NULL),
('Sheraton Centre', 227, '2020-01-12', 113, NULL),
('Sheraton Centre', 227, '2020-01-13', 270, NULL),
('Sheraton Centre', 227, '2020-01-14', 139, NULL),
('Sheraton Centre', 227, '2020-01-15', 149, NULL),
('Sheraton Centre', 227, '2020-01-16', 353, NULL),
('Sheraton Centre', 227, '2020-01-17', 306, NULL),
('Sheraton Centre', 227, '2020-01-18', 221, NULL),
('Sheraton Centre', 227, '2020-01-19', 266, NULL),
('Sheraton Centre', 227, '2020-01-20', 343, NULL),
('Sheraton Centre', 227, '2020-01-21', 180, NULL),
('Sheraton Centre', 227, '2020-01-22', 304, NULL),
('Sheraton Centre', 227, '2020-01-23', 363, NULL),
('Sheraton Centre', 227, '2020-01-24', 213, NULL),
('Sheraton Centre', 227, '2020-01-25', 218, NULL),
('Sheraton Centre', 227, '2020-01-26', 184, NULL),
('Sheraton Centre', 227, '2020-01-27', 306, NULL),
('Sheraton Centre', 227, '2020-01-28', 345, NULL),
('Sheraton Centre', 227, '2020-01-29', 120, NULL),
('Sheraton Centre', 227, '2020-01-30', 194, NULL),
('Sheraton Centre', 227, '2020-01-31', 152, NULL),
('Sheraton Centre', 227, '2020-02-01', 231, NULL),
('Sheraton Centre', 227, '2020-02-02', 253, NULL),
('Sheraton Centre', 227, '2020-02-03', 207, NULL),
('Sheraton Centre', 227, '2020-02-04', 301, NULL),
('Sheraton Centre', 231, '2019-01-01', 186, NULL),
('Sheraton Centre', 231, '2019-01-02', 383, NULL),
('Sheraton Centre', 231, '2019-01-03', 195, NULL),
('Sheraton Centre', 231, '2019-01-04', 114, NULL),
('Sheraton Centre', 231, '2019-01-05', 139, NULL),
('Sheraton Centre', 231, '2019-01-06', 318, NULL),
('Sheraton Centre', 231, '2019-01-07', 229, NULL),
('Sheraton Centre', 231, '2019-01-08', 243, NULL),
('Sheraton Centre', 231, '2019-01-09', 173, NULL),
('Sheraton Centre', 231, '2019-01-10', 258, NULL),
('Sheraton Centre', 231, '2019-01-11', 399, NULL),
('Sheraton Centre', 231, '2019-01-12', 245, NULL),
('Sheraton Centre', 231, '2019-01-13', 114, NULL),
('Sheraton Centre', 231, '2019-01-14', 392, NULL),
('Sheraton Centre', 231, '2019-01-15', 357, NULL),
('Sheraton Centre', 231, '2019-01-16', 205, NULL),
('Sheraton Centre', 231, '2019-01-17', 379, NULL),
('Sheraton Centre', 231, '2019-01-18', 285, NULL),
('Sheraton Centre', 231, '2019-01-19', 383, NULL),
('Sheraton Centre', 231, '2019-01-20', 233, NULL),
('Sheraton Centre', 231, '2019-01-21', 154, NULL),
('Sheraton Centre', 231, '2019-01-22', 233, NULL),
('Sheraton Centre', 231, '2019-01-23', 294, NULL),
('Sheraton Centre', 231, '2019-01-24', 193, NULL),
('Sheraton Centre', 231, '2019-01-25', 274, NULL),
('Sheraton Centre', 231, '2019-01-26', 236, NULL),
('Sheraton Centre', 231, '2019-01-27', 265, NULL),
('Sheraton Centre', 231, '2019-01-28', 397, NULL),
('Sheraton Centre', 231, '2019-01-29', 128, NULL),
('Sheraton Centre', 231, '2019-01-30', 176, NULL),
('Sheraton Centre', 231, '2019-01-31', 340, NULL),
('Sheraton Centre', 231, '2019-02-01', 344, NULL),
('Sheraton Centre', 231, '2019-02-02', 358, NULL),
('Sheraton Centre', 231, '2019-02-03', 133, NULL),
('Sheraton Centre', 231, '2019-02-04', 378, NULL),
('Sheraton Centre', 231, '2019-02-05', 139, NULL),
('Sheraton Centre', 231, '2019-02-06', 300, NULL),
('Sheraton Centre', 231, '2019-02-07', 382, NULL),
('Sheraton Centre', 231, '2019-02-08', 296, NULL),
('Sheraton Centre', 231, '2019-02-09', 399, NULL),
('Sheraton Centre', 231, '2019-02-10', 150, NULL),
('Sheraton Centre', 231, '2019-02-11', 186, NULL),
('Sheraton Centre', 231, '2019-02-12', 180, NULL),
('Sheraton Centre', 231, '2019-02-13', 149, NULL),
('Sheraton Centre', 231, '2019-02-14', 142, NULL),
('Sheraton Centre', 231, '2019-02-15', 310, NULL),
('Sheraton Centre', 231, '2019-02-16', 360, NULL),
('Sheraton Centre', 231, '2019-02-17', 216, NULL),
('Sheraton Centre', 231, '2019-02-18', 132, NULL),
('Sheraton Centre', 231, '2019-02-19', 170, NULL),
('Sheraton Centre', 231, '2019-02-20', 169, NULL),
('Sheraton Centre', 231, '2019-02-21', 355, NULL),
('Sheraton Centre', 231, '2019-02-22', 278, NULL),
('Sheraton Centre', 231, '2019-02-23', 123, NULL),
('Sheraton Centre', 231, '2019-02-24', 392, NULL),
('Sheraton Centre', 231, '2019-02-25', 329, NULL),
('Sheraton Centre', 231, '2019-02-26', 118, NULL),
('Sheraton Centre', 231, '2019-02-27', 394, NULL),
('Sheraton Centre', 231, '2019-02-28', 292, NULL),
('Sheraton Centre', 231, '2019-03-01', 334, NULL),
('Sheraton Centre', 231, '2019-03-02', 306, NULL),
('Sheraton Centre', 231, '2019-03-03', 387, NULL),
('Sheraton Centre', 231, '2019-03-04', 264, NULL),
('Sheraton Centre', 231, '2019-03-05', 319, NULL),
('Sheraton Centre', 231, '2019-03-06', 321, NULL),
('Sheraton Centre', 231, '2019-03-07', 133, NULL),
('Sheraton Centre', 231, '2019-03-08', 101, NULL),
('Sheraton Centre', 231, '2019-03-09', 217, NULL),
('Sheraton Centre', 231, '2019-03-10', 135, NULL),
('Sheraton Centre', 231, '2019-03-11', 145, NULL),
('Sheraton Centre', 231, '2019-03-12', 187, NULL),
('Sheraton Centre', 231, '2019-03-13', 139, NULL),
('Sheraton Centre', 231, '2019-03-14', 341, NULL),
('Sheraton Centre', 231, '2019-03-15', 187, NULL),
('Sheraton Centre', 231, '2019-03-16', 258, NULL),
('Sheraton Centre', 231, '2019-03-17', 132, NULL),
('Sheraton Centre', 231, '2019-03-18', 147, NULL),
('Sheraton Centre', 231, '2019-03-19', 273, NULL),
('Sheraton Centre', 231, '2019-03-20', 158, NULL),
('Sheraton Centre', 231, '2019-03-21', 215, NULL),
('Sheraton Centre', 231, '2019-03-22', 101, NULL),
('Sheraton Centre', 231, '2019-03-23', 208, NULL),
('Sheraton Centre', 231, '2019-03-24', 358, NULL),
('Sheraton Centre', 231, '2019-03-25', 149, NULL),
('Sheraton Centre', 231, '2019-03-26', 215, NULL),
('Sheraton Centre', 231, '2019-03-27', 330, NULL),
('Sheraton Centre', 231, '2019-03-28', 282, NULL),
('Sheraton Centre', 231, '2019-03-29', 153, NULL),
('Sheraton Centre', 231, '2019-03-30', 387, NULL),
('Sheraton Centre', 231, '2019-03-31', 263, NULL),
('Sheraton Centre', 231, '2019-04-01', 200, NULL),
('Sheraton Centre', 231, '2019-04-02', 339, NULL),
('Sheraton Centre', 231, '2019-04-03', 181, NULL),
('Sheraton Centre', 231, '2019-04-04', 253, NULL),
('Sheraton Centre', 231, '2019-04-05', 218, NULL),
('Sheraton Centre', 231, '2019-04-06', 276, NULL),
('Sheraton Centre', 231, '2019-04-07', 148, NULL),
('Sheraton Centre', 231, '2019-04-08', 381, NULL),
('Sheraton Centre', 231, '2019-04-09', 133, NULL),
('Sheraton Centre', 231, '2019-04-10', 158, NULL),
('Sheraton Centre', 231, '2019-04-11', 359, NULL),
('Sheraton Centre', 231, '2019-04-12', 265, NULL),
('Sheraton Centre', 231, '2019-04-13', 218, NULL),
('Sheraton Centre', 231, '2019-04-14', 260, NULL),
('Sheraton Centre', 231, '2019-04-15', 393, NULL),
('Sheraton Centre', 231, '2019-04-16', 369, NULL),
('Sheraton Centre', 231, '2019-04-17', 216, NULL),
('Sheraton Centre', 231, '2019-04-18', 291, NULL),
('Sheraton Centre', 231, '2019-04-19', 180, NULL),
('Sheraton Centre', 231, '2019-04-20', 337, NULL),
('Sheraton Centre', 231, '2019-04-21', 156, NULL),
('Sheraton Centre', 231, '2019-04-22', 278, NULL),
('Sheraton Centre', 231, '2019-04-23', 270, NULL),
('Sheraton Centre', 231, '2019-04-24', 343, NULL),
('Sheraton Centre', 231, '2019-04-25', 297, NULL),
('Sheraton Centre', 231, '2019-04-26', 305, NULL),
('Sheraton Centre', 231, '2019-04-27', 312, NULL),
('Sheraton Centre', 231, '2019-04-28', 399, NULL),
('Sheraton Centre', 231, '2019-04-29', 239, NULL),
('Sheraton Centre', 231, '2019-04-30', 206, NULL),
('Sheraton Centre', 231, '2019-05-01', 348, NULL),
('Sheraton Centre', 231, '2019-05-02', 375, NULL),
('Sheraton Centre', 231, '2019-05-03', 166, NULL),
('Sheraton Centre', 231, '2019-05-04', 263, NULL),
('Sheraton Centre', 231, '2019-05-05', 120, NULL),
('Sheraton Centre', 231, '2019-05-06', 240, NULL),
('Sheraton Centre', 231, '2019-05-07', 193, NULL),
('Sheraton Centre', 231, '2019-05-08', 393, NULL),
('Sheraton Centre', 231, '2019-05-09', 288, NULL),
('Sheraton Centre', 231, '2019-05-10', 227, NULL),
('Sheraton Centre', 231, '2019-05-11', 222, NULL),
('Sheraton Centre', 231, '2019-05-12', 140, NULL),
('Sheraton Centre', 231, '2019-05-13', 236, NULL),
('Sheraton Centre', 231, '2019-05-14', 173, NULL),
('Sheraton Centre', 231, '2019-05-15', 140, NULL),
('Sheraton Centre', 231, '2019-05-16', 190, NULL),
('Sheraton Centre', 231, '2019-05-17', 262, NULL),
('Sheraton Centre', 231, '2019-05-18', 338, NULL),
('Sheraton Centre', 231, '2019-05-19', 130, NULL),
('Sheraton Centre', 231, '2019-05-20', 192, NULL),
('Sheraton Centre', 231, '2019-05-21', 273, NULL),
('Sheraton Centre', 231, '2019-05-22', 109, NULL),
('Sheraton Centre', 231, '2019-05-23', 309, NULL),
('Sheraton Centre', 231, '2019-05-24', 185, NULL),
('Sheraton Centre', 231, '2019-05-25', 127, NULL),
('Sheraton Centre', 231, '2019-05-26', 239, NULL),
('Sheraton Centre', 231, '2019-05-27', 119, NULL),
('Sheraton Centre', 231, '2019-05-28', 165, NULL),
('Sheraton Centre', 231, '2019-05-29', 180, NULL),
('Sheraton Centre', 231, '2019-05-30', 227, NULL),
('Sheraton Centre', 231, '2019-05-31', 376, NULL),
('Sheraton Centre', 231, '2019-06-01', 332, NULL),
('Sheraton Centre', 231, '2019-06-02', 392, NULL),
('Sheraton Centre', 231, '2019-06-03', 391, NULL),
('Sheraton Centre', 231, '2019-06-04', 329, NULL),
('Sheraton Centre', 231, '2019-06-05', 161, NULL),
('Sheraton Centre', 231, '2019-06-06', 386, NULL),
('Sheraton Centre', 231, '2019-06-07', 247, NULL),
('Sheraton Centre', 231, '2019-06-08', 112, NULL),
('Sheraton Centre', 231, '2019-06-09', 382, NULL),
('Sheraton Centre', 231, '2019-06-10', 236, NULL),
('Sheraton Centre', 231, '2019-06-11', 270, NULL),
('Sheraton Centre', 231, '2019-06-12', 247, NULL),
('Sheraton Centre', 231, '2019-06-13', 297, NULL),
('Sheraton Centre', 231, '2019-06-14', 354, NULL),
('Sheraton Centre', 231, '2019-06-15', 159, NULL),
('Sheraton Centre', 231, '2019-06-16', 262, NULL),
('Sheraton Centre', 231, '2019-06-17', 271, NULL),
('Sheraton Centre', 231, '2019-06-18', 277, NULL),
('Sheraton Centre', 231, '2019-06-19', 314, NULL),
('Sheraton Centre', 231, '2019-06-20', 249, NULL),
('Sheraton Centre', 231, '2019-06-21', 393, NULL),
('Sheraton Centre', 231, '2019-06-22', 122, NULL),
('Sheraton Centre', 231, '2019-06-23', 398, NULL),
('Sheraton Centre', 231, '2019-06-24', 121, NULL),
('Sheraton Centre', 231, '2019-06-25', 129, NULL),
('Sheraton Centre', 231, '2019-06-26', 312, NULL),
('Sheraton Centre', 231, '2019-06-27', 362, NULL),
('Sheraton Centre', 231, '2019-06-28', 276, NULL),
('Sheraton Centre', 231, '2019-06-29', 391, NULL),
('Sheraton Centre', 231, '2019-06-30', 145, NULL),
('Sheraton Centre', 231, '2019-07-01', 127, NULL),
('Sheraton Centre', 231, '2019-07-02', 351, NULL),
('Sheraton Centre', 231, '2019-07-03', 304, NULL),
('Sheraton Centre', 231, '2019-07-04', 195, NULL),
('Sheraton Centre', 231, '2019-07-05', 334, NULL),
('Sheraton Centre', 231, '2019-07-06', 174, NULL),
('Sheraton Centre', 231, '2019-07-07', 399, NULL),
('Sheraton Centre', 231, '2019-07-08', 133, NULL),
('Sheraton Centre', 231, '2019-07-09', 112, NULL),
('Sheraton Centre', 231, '2019-07-10', 368, NULL),
('Sheraton Centre', 231, '2019-07-11', 234, NULL),
('Sheraton Centre', 231, '2019-07-12', 227, NULL),
('Sheraton Centre', 231, '2019-07-13', 154, NULL),
('Sheraton Centre', 231, '2019-07-14', 320, NULL),
('Sheraton Centre', 231, '2019-07-15', 347, NULL),
('Sheraton Centre', 231, '2019-07-16', 115, NULL),
('Sheraton Centre', 231, '2019-07-17', 128, NULL),
('Sheraton Centre', 231, '2019-07-18', 160, NULL),
('Sheraton Centre', 231, '2019-07-19', 275, NULL),
('Sheraton Centre', 231, '2019-07-20', 321, NULL),
('Sheraton Centre', 231, '2019-07-21', 256, NULL),
('Sheraton Centre', 231, '2019-07-22', 325, NULL),
('Sheraton Centre', 231, '2019-07-23', 140, NULL),
('Sheraton Centre', 231, '2019-07-24', 375, NULL),
('Sheraton Centre', 231, '2019-07-25', 360, NULL),
('Sheraton Centre', 231, '2019-07-26', 348, NULL),
('Sheraton Centre', 231, '2019-07-27', 394, NULL),
('Sheraton Centre', 231, '2019-07-28', 177, NULL),
('Sheraton Centre', 231, '2019-07-29', 352, NULL),
('Sheraton Centre', 231, '2019-07-30', 233, NULL),
('Sheraton Centre', 231, '2019-07-31', 147, NULL),
('Sheraton Centre', 231, '2019-08-01', 300, NULL),
('Sheraton Centre', 231, '2019-08-02', 166, NULL),
('Sheraton Centre', 231, '2019-08-03', 333, NULL),
('Sheraton Centre', 231, '2019-08-04', 123, NULL),
('Sheraton Centre', 231, '2019-08-05', 199, NULL),
('Sheraton Centre', 231, '2019-08-06', 386, NULL),
('Sheraton Centre', 231, '2019-08-07', 263, NULL),
('Sheraton Centre', 231, '2019-08-08', 377, NULL),
('Sheraton Centre', 231, '2019-08-09', 265, NULL),
('Sheraton Centre', 231, '2019-08-10', 146, NULL),
('Sheraton Centre', 231, '2019-08-11', 289, NULL),
('Sheraton Centre', 231, '2019-08-12', 169, NULL),
('Sheraton Centre', 231, '2019-08-13', 130, NULL),
('Sheraton Centre', 231, '2019-08-14', 292, NULL),
('Sheraton Centre', 231, '2019-08-15', 233, NULL),
('Sheraton Centre', 231, '2019-08-16', 364, NULL),
('Sheraton Centre', 231, '2019-08-17', 268, NULL),
('Sheraton Centre', 231, '2019-08-18', 207, NULL),
('Sheraton Centre', 231, '2019-08-19', 171, NULL),
('Sheraton Centre', 231, '2019-08-20', 350, NULL),
('Sheraton Centre', 231, '2019-08-21', 129, NULL),
('Sheraton Centre', 231, '2019-08-22', 105, NULL),
('Sheraton Centre', 231, '2019-08-23', 380, NULL),
('Sheraton Centre', 231, '2019-08-24', 179, NULL),
('Sheraton Centre', 231, '2019-08-25', 333, NULL),
('Sheraton Centre', 231, '2019-08-26', 308, NULL),
('Sheraton Centre', 231, '2019-08-27', 318, NULL),
('Sheraton Centre', 231, '2019-08-28', 220, NULL),
('Sheraton Centre', 231, '2019-08-29', 108, NULL),
('Sheraton Centre', 231, '2019-08-30', 225, NULL),
('Sheraton Centre', 231, '2019-08-31', 268, NULL),
('Sheraton Centre', 231, '2019-09-01', 256, NULL),
('Sheraton Centre', 231, '2019-09-02', 387, NULL),
('Sheraton Centre', 231, '2019-09-03', 349, NULL),
('Sheraton Centre', 231, '2019-09-04', 304, NULL),
('Sheraton Centre', 231, '2019-09-05', 192, NULL),
('Sheraton Centre', 231, '2019-09-06', 396, NULL),
('Sheraton Centre', 231, '2019-09-07', 214, NULL),
('Sheraton Centre', 231, '2019-09-08', 141, NULL),
('Sheraton Centre', 231, '2019-09-09', 192, NULL),
('Sheraton Centre', 231, '2019-09-10', 368, NULL),
('Sheraton Centre', 231, '2019-09-11', 295, NULL),
('Sheraton Centre', 231, '2019-09-12', 337, NULL),
('Sheraton Centre', 231, '2019-09-13', 285, NULL),
('Sheraton Centre', 231, '2019-09-14', 376, NULL),
('Sheraton Centre', 231, '2019-09-15', 289, NULL),
('Sheraton Centre', 231, '2019-09-16', 307, NULL),
('Sheraton Centre', 231, '2019-09-17', 219, NULL),
('Sheraton Centre', 231, '2019-09-18', 103, NULL),
('Sheraton Centre', 231, '2019-09-19', 128, NULL),
('Sheraton Centre', 231, '2019-09-20', 102, NULL),
('Sheraton Centre', 231, '2019-09-21', 194, NULL),
('Sheraton Centre', 231, '2019-09-22', 102, NULL),
('Sheraton Centre', 231, '2019-09-23', 195, NULL),
('Sheraton Centre', 231, '2019-09-24', 120, NULL),
('Sheraton Centre', 231, '2019-09-25', 266, NULL),
('Sheraton Centre', 231, '2019-09-26', 244, NULL),
('Sheraton Centre', 231, '2019-09-27', 193, NULL),
('Sheraton Centre', 231, '2019-09-28', 114, NULL),
('Sheraton Centre', 231, '2019-09-29', 257, NULL),
('Sheraton Centre', 231, '2019-09-30', 356, NULL),
('Sheraton Centre', 231, '2019-10-01', 120, NULL),
('Sheraton Centre', 231, '2019-10-02', 269, NULL),
('Sheraton Centre', 231, '2019-10-03', 307, NULL),
('Sheraton Centre', 231, '2019-10-04', 313, NULL),
('Sheraton Centre', 231, '2019-10-05', 106, NULL),
('Sheraton Centre', 231, '2019-10-06', 348, NULL),
('Sheraton Centre', 231, '2019-10-07', 227, NULL),
('Sheraton Centre', 231, '2019-10-08', 146, NULL),
('Sheraton Centre', 231, '2019-10-09', 339, NULL),
('Sheraton Centre', 231, '2019-10-10', 166, NULL),
('Sheraton Centre', 231, '2019-10-11', 244, NULL),
('Sheraton Centre', 231, '2019-10-12', 219, NULL),
('Sheraton Centre', 231, '2019-10-13', 341, NULL),
('Sheraton Centre', 231, '2019-10-14', 359, NULL),
('Sheraton Centre', 231, '2019-10-15', 291, NULL),
('Sheraton Centre', 231, '2019-10-16', 279, NULL),
('Sheraton Centre', 231, '2019-10-17', 267, NULL),
('Sheraton Centre', 231, '2019-10-18', 296, NULL),
('Sheraton Centre', 231, '2019-10-19', 310, NULL),
('Sheraton Centre', 231, '2019-10-20', 303, NULL),
('Sheraton Centre', 231, '2019-10-21', 264, NULL),
('Sheraton Centre', 231, '2019-10-22', 102, NULL),
('Sheraton Centre', 231, '2019-10-23', 277, NULL),
('Sheraton Centre', 231, '2019-10-24', 103, NULL),
('Sheraton Centre', 231, '2019-10-25', 232, NULL),
('Sheraton Centre', 231, '2019-10-26', 377, NULL),
('Sheraton Centre', 231, '2019-10-27', 174, NULL),
('Sheraton Centre', 231, '2019-10-28', 123, NULL),
('Sheraton Centre', 231, '2019-10-29', 226, NULL),
('Sheraton Centre', 231, '2019-10-30', 195, NULL),
('Sheraton Centre', 231, '2019-10-31', 352, NULL),
('Sheraton Centre', 231, '2019-11-01', 214, NULL),
('Sheraton Centre', 231, '2019-11-02', 322, NULL),
('Sheraton Centre', 231, '2019-11-03', 345, NULL),
('Sheraton Centre', 231, '2019-11-04', 234, NULL),
('Sheraton Centre', 231, '2019-11-05', 351, NULL),
('Sheraton Centre', 231, '2019-11-06', 321, NULL),
('Sheraton Centre', 231, '2019-11-07', 119, NULL),
('Sheraton Centre', 231, '2019-11-08', 384, NULL),
('Sheraton Centre', 231, '2019-11-09', 143, NULL),
('Sheraton Centre', 231, '2019-11-10', 221, NULL),
('Sheraton Centre', 231, '2019-11-11', 258, NULL),
('Sheraton Centre', 231, '2019-11-12', 273, NULL),
('Sheraton Centre', 231, '2019-11-13', 254, NULL),
('Sheraton Centre', 231, '2019-11-14', 353, NULL),
('Sheraton Centre', 231, '2019-11-15', 372, NULL),
('Sheraton Centre', 231, '2019-11-16', 263, NULL),
('Sheraton Centre', 231, '2019-11-17', 276, NULL),
('Sheraton Centre', 231, '2019-11-18', 341, NULL),
('Sheraton Centre', 231, '2019-11-19', 215, NULL),
('Sheraton Centre', 231, '2019-11-20', 395, NULL),
('Sheraton Centre', 231, '2019-11-21', 184, NULL),
('Sheraton Centre', 231, '2019-11-22', 230, NULL),
('Sheraton Centre', 231, '2019-11-23', 300, NULL),
('Sheraton Centre', 231, '2019-11-24', 127, NULL),
('Sheraton Centre', 231, '2019-11-25', 214, NULL),
('Sheraton Centre', 231, '2019-11-26', 281, NULL),
('Sheraton Centre', 231, '2019-11-27', 317, NULL),
('Sheraton Centre', 231, '2019-11-28', 335, NULL),
('Sheraton Centre', 231, '2019-11-29', 307, NULL),
('Sheraton Centre', 231, '2019-11-30', 128, NULL),
('Sheraton Centre', 231, '2019-12-01', 193, NULL),
('Sheraton Centre', 231, '2019-12-02', 311, NULL),
('Sheraton Centre', 231, '2019-12-03', 204, NULL),
('Sheraton Centre', 231, '2019-12-04', 191, NULL),
('Sheraton Centre', 231, '2019-12-05', 292, NULL),
('Sheraton Centre', 231, '2019-12-06', 219, NULL),
('Sheraton Centre', 231, '2019-12-07', 281, NULL),
('Sheraton Centre', 231, '2019-12-08', 301, NULL),
('Sheraton Centre', 231, '2019-12-09', 343, NULL),
('Sheraton Centre', 231, '2019-12-10', 224, NULL),
('Sheraton Centre', 231, '2019-12-11', 230, NULL),
('Sheraton Centre', 231, '2019-12-12', 268, NULL),
('Sheraton Centre', 231, '2019-12-13', 129, NULL),
('Sheraton Centre', 231, '2019-12-14', 110, NULL),
('Sheraton Centre', 231, '2019-12-15', 302, NULL),
('Sheraton Centre', 231, '2019-12-16', 377, NULL),
('Sheraton Centre', 231, '2019-12-17', 335, NULL),
('Sheraton Centre', 231, '2019-12-18', 216, NULL),
('Sheraton Centre', 231, '2019-12-19', 368, NULL),
('Sheraton Centre', 231, '2019-12-20', 222, NULL),
('Sheraton Centre', 231, '2019-12-21', 298, NULL),
('Sheraton Centre', 231, '2019-12-22', 115, NULL),
('Sheraton Centre', 231, '2019-12-23', 334, NULL),
('Sheraton Centre', 231, '2019-12-24', 277, NULL),
('Sheraton Centre', 231, '2019-12-25', 138, NULL),
('Sheraton Centre', 231, '2019-12-26', 198, NULL),
('Sheraton Centre', 231, '2019-12-27', 247, NULL),
('Sheraton Centre', 231, '2019-12-28', 274, NULL),
('Sheraton Centre', 231, '2019-12-29', 311, NULL),
('Sheraton Centre', 231, '2019-12-30', 365, NULL),
('Sheraton Centre', 231, '2019-12-31', 138, NULL),
('Sheraton Centre', 231, '2020-01-01', 361, NULL),
('Sheraton Centre', 231, '2020-01-02', 344, NULL),
('Sheraton Centre', 231, '2020-01-03', 208, NULL),
('Sheraton Centre', 231, '2020-01-04', 213, NULL),
('Sheraton Centre', 231, '2020-01-05', 365, NULL),
('Sheraton Centre', 231, '2020-01-06', 147, NULL),
('Sheraton Centre', 231, '2020-01-07', 348, NULL),
('Sheraton Centre', 231, '2020-01-08', 342, NULL),
('Sheraton Centre', 231, '2020-01-09', 101, NULL),
('Sheraton Centre', 231, '2020-01-10', 280, NULL),
('Sheraton Centre', 231, '2020-01-11', 278, NULL),
('Sheraton Centre', 231, '2020-01-12', 171, NULL),
('Sheraton Centre', 231, '2020-01-13', 341, NULL),
('Sheraton Centre', 231, '2020-01-14', 163, NULL),
('Sheraton Centre', 231, '2020-01-15', 330, NULL),
('Sheraton Centre', 231, '2020-01-16', 259, NULL),
('Sheraton Centre', 231, '2020-01-17', 297, NULL),
('Sheraton Centre', 231, '2020-01-18', 323, NULL),
('Sheraton Centre', 231, '2020-01-19', 153, NULL),
('Sheraton Centre', 231, '2020-01-20', 386, NULL),
('Sheraton Centre', 231, '2020-01-21', 261, NULL),
('Sheraton Centre', 231, '2020-01-22', 300, NULL),
('Sheraton Centre', 231, '2020-01-23', 169, NULL),
('Sheraton Centre', 231, '2020-01-24', 276, NULL),
('Sheraton Centre', 231, '2020-01-25', 363, NULL),
('Sheraton Centre', 231, '2020-01-26', 129, NULL),
('Sheraton Centre', 231, '2020-01-27', 358, NULL),
('Sheraton Centre', 231, '2020-01-28', 186, NULL),
('Sheraton Centre', 231, '2020-01-29', 346, NULL),
('Sheraton Centre', 231, '2020-01-30', 238, NULL),
('Sheraton Centre', 231, '2020-01-31', 219, NULL),
('Sheraton Centre', 231, '2020-02-01', 163, NULL),
('Sheraton Centre', 231, '2020-02-02', 149, NULL),
('Sheraton Centre', 231, '2020-02-03', 239, NULL),
('Sheraton Centre', 231, '2020-02-04', 380, NULL),
('Sheraton Centre', 236, '2019-01-01', 133, NULL),
('Sheraton Centre', 236, '2019-01-02', 124, NULL),
('Sheraton Centre', 236, '2019-01-03', 332, NULL),
('Sheraton Centre', 236, '2019-01-04', 188, NULL),
('Sheraton Centre', 236, '2019-01-05', 210, NULL),
('Sheraton Centre', 236, '2019-01-06', 126, NULL),
('Sheraton Centre', 236, '2019-01-07', 208, NULL),
('Sheraton Centre', 236, '2019-01-08', 196, NULL),
('Sheraton Centre', 236, '2019-01-09', 399, NULL),
('Sheraton Centre', 236, '2019-01-10', 176, NULL),
('Sheraton Centre', 236, '2019-01-11', 263, NULL),
('Sheraton Centre', 236, '2019-01-12', 389, NULL),
('Sheraton Centre', 236, '2019-01-13', 184, NULL),
('Sheraton Centre', 236, '2019-01-14', 239, NULL),
('Sheraton Centre', 236, '2019-01-15', 340, NULL),
('Sheraton Centre', 236, '2019-01-16', 253, NULL),
('Sheraton Centre', 236, '2019-01-17', 144, NULL),
('Sheraton Centre', 236, '2019-01-18', 374, NULL),
('Sheraton Centre', 236, '2019-01-19', 186, NULL),
('Sheraton Centre', 236, '2019-01-20', 396, NULL),
('Sheraton Centre', 236, '2019-01-21', 115, NULL),
('Sheraton Centre', 236, '2019-01-22', 345, NULL),
('Sheraton Centre', 236, '2019-01-23', 342, NULL),
('Sheraton Centre', 236, '2019-01-24', 126, NULL),
('Sheraton Centre', 236, '2019-01-25', 312, NULL),
('Sheraton Centre', 236, '2019-01-26', 175, NULL),
('Sheraton Centre', 236, '2019-01-27', 178, NULL),
('Sheraton Centre', 236, '2019-01-28', 147, NULL),
('Sheraton Centre', 236, '2019-01-29', 245, NULL),
('Sheraton Centre', 236, '2019-01-30', 305, NULL),
('Sheraton Centre', 236, '2019-01-31', 325, NULL),
('Sheraton Centre', 236, '2019-02-01', 191, NULL),
('Sheraton Centre', 236, '2019-02-02', 161, NULL),
('Sheraton Centre', 236, '2019-02-03', 122, NULL),
('Sheraton Centre', 236, '2019-02-04', 220, NULL),
('Sheraton Centre', 236, '2019-02-05', 231, NULL),
('Sheraton Centre', 236, '2019-02-06', 284, NULL),
('Sheraton Centre', 236, '2019-02-07', 146, NULL),
('Sheraton Centre', 236, '2019-02-08', 389, NULL),
('Sheraton Centre', 236, '2019-02-09', 264, NULL),
('Sheraton Centre', 236, '2019-02-10', 311, NULL),
('Sheraton Centre', 236, '2019-02-11', 118, NULL),
('Sheraton Centre', 236, '2019-02-12', 370, NULL),
('Sheraton Centre', 236, '2019-02-13', 138, NULL),
('Sheraton Centre', 236, '2019-02-14', 243, NULL),
('Sheraton Centre', 236, '2019-02-15', 240, NULL),
('Sheraton Centre', 236, '2019-02-16', 326, NULL),
('Sheraton Centre', 236, '2019-02-17', 187, NULL),
('Sheraton Centre', 236, '2019-02-18', 268, NULL),
('Sheraton Centre', 236, '2019-02-19', 276, NULL),
('Sheraton Centre', 236, '2019-02-20', 102, NULL),
('Sheraton Centre', 236, '2019-02-21', 346, NULL),
('Sheraton Centre', 236, '2019-02-22', 382, NULL),
('Sheraton Centre', 236, '2019-02-23', 259, NULL),
('Sheraton Centre', 236, '2019-02-24', 344, NULL),
('Sheraton Centre', 236, '2019-02-25', 342, NULL),
('Sheraton Centre', 236, '2019-02-26', 162, NULL),
('Sheraton Centre', 236, '2019-02-27', 361, NULL),
('Sheraton Centre', 236, '2019-02-28', 152, NULL),
('Sheraton Centre', 236, '2019-03-01', 197, NULL),
('Sheraton Centre', 236, '2019-03-02', 308, NULL),
('Sheraton Centre', 236, '2019-03-03', 231, NULL),
('Sheraton Centre', 236, '2019-03-04', 113, NULL),
('Sheraton Centre', 236, '2019-03-05', 368, NULL),
('Sheraton Centre', 236, '2019-03-06', 158, NULL),
('Sheraton Centre', 236, '2019-03-07', 273, NULL),
('Sheraton Centre', 236, '2019-03-08', 117, NULL),
('Sheraton Centre', 236, '2019-03-09', 128, NULL),
('Sheraton Centre', 236, '2019-03-10', 122, NULL),
('Sheraton Centre', 236, '2019-03-11', 173, NULL),
('Sheraton Centre', 236, '2019-03-12', 173, NULL),
('Sheraton Centre', 236, '2019-03-13', 123, NULL),
('Sheraton Centre', 236, '2019-03-14', 312, NULL),
('Sheraton Centre', 236, '2019-03-15', 229, NULL),
('Sheraton Centre', 236, '2019-03-16', 305, NULL),
('Sheraton Centre', 236, '2019-03-17', 241, NULL),
('Sheraton Centre', 236, '2019-03-18', 266, NULL),
('Sheraton Centre', 236, '2019-03-19', 187, NULL),
('Sheraton Centre', 236, '2019-03-20', 367, NULL),
('Sheraton Centre', 236, '2019-03-21', 217, NULL),
('Sheraton Centre', 236, '2019-03-22', 125, NULL),
('Sheraton Centre', 236, '2019-03-23', 367, NULL),
('Sheraton Centre', 236, '2019-03-24', 118, NULL),
('Sheraton Centre', 236, '2019-03-25', 342, NULL),
('Sheraton Centre', 236, '2019-03-26', 114, NULL),
('Sheraton Centre', 236, '2019-03-27', 246, NULL),
('Sheraton Centre', 236, '2019-03-28', 322, NULL),
('Sheraton Centre', 236, '2019-03-29', 103, NULL),
('Sheraton Centre', 236, '2019-03-30', 334, NULL),
('Sheraton Centre', 236, '2019-03-31', 277, NULL),
('Sheraton Centre', 236, '2019-04-01', 169, NULL),
('Sheraton Centre', 236, '2019-04-02', 104, NULL),
('Sheraton Centre', 236, '2019-04-03', 269, NULL),
('Sheraton Centre', 236, '2019-04-04', 384, NULL),
('Sheraton Centre', 236, '2019-04-05', 283, NULL),
('Sheraton Centre', 236, '2019-04-06', 388, NULL),
('Sheraton Centre', 236, '2019-04-07', 261, NULL),
('Sheraton Centre', 236, '2019-04-08', 264, NULL),
('Sheraton Centre', 236, '2019-04-09', 135, NULL),
('Sheraton Centre', 236, '2019-04-10', 380, NULL),
('Sheraton Centre', 236, '2019-04-11', 292, NULL),
('Sheraton Centre', 236, '2019-04-12', 362, NULL),
('Sheraton Centre', 236, '2019-04-13', 128, NULL),
('Sheraton Centre', 236, '2019-04-14', 319, NULL),
('Sheraton Centre', 236, '2019-04-15', 280, NULL),
('Sheraton Centre', 236, '2019-04-16', 389, NULL),
('Sheraton Centre', 236, '2019-04-17', 170, NULL),
('Sheraton Centre', 236, '2019-04-18', 214, NULL),
('Sheraton Centre', 236, '2019-04-19', 285, NULL),
('Sheraton Centre', 236, '2019-04-20', 376, NULL),
('Sheraton Centre', 236, '2019-04-21', 160, NULL),
('Sheraton Centre', 236, '2019-04-22', 336, NULL),
('Sheraton Centre', 236, '2019-04-23', 153, NULL),
('Sheraton Centre', 236, '2019-04-24', 355, NULL),
('Sheraton Centre', 236, '2019-04-25', 122, NULL),
('Sheraton Centre', 236, '2019-04-26', 140, NULL),
('Sheraton Centre', 236, '2019-04-27', 219, NULL),
('Sheraton Centre', 236, '2019-04-28', 304, NULL),
('Sheraton Centre', 236, '2019-04-29', 388, NULL),
('Sheraton Centre', 236, '2019-04-30', 330, NULL),
('Sheraton Centre', 236, '2019-05-01', 326, NULL),
('Sheraton Centre', 236, '2019-05-02', 284, NULL),
('Sheraton Centre', 236, '2019-05-03', 343, NULL),
('Sheraton Centre', 236, '2019-05-04', 140, NULL),
('Sheraton Centre', 236, '2019-05-05', 228, NULL),
('Sheraton Centre', 236, '2019-05-06', 212, NULL),
('Sheraton Centre', 236, '2019-05-07', 139, NULL),
('Sheraton Centre', 236, '2019-05-08', 373, NULL),
('Sheraton Centre', 236, '2019-05-09', 136, NULL),
('Sheraton Centre', 236, '2019-05-10', 137, NULL),
('Sheraton Centre', 236, '2019-05-11', 229, NULL),
('Sheraton Centre', 236, '2019-05-12', 363, NULL),
('Sheraton Centre', 236, '2019-05-13', 323, NULL),
('Sheraton Centre', 236, '2019-05-14', 133, NULL),
('Sheraton Centre', 236, '2019-05-15', 110, NULL),
('Sheraton Centre', 236, '2019-05-16', 285, NULL),
('Sheraton Centre', 236, '2019-05-17', 293, NULL),
('Sheraton Centre', 236, '2019-05-18', 327, NULL),
('Sheraton Centre', 236, '2019-05-19', 185, NULL),
('Sheraton Centre', 236, '2019-05-20', 289, NULL),
('Sheraton Centre', 236, '2019-05-21', 322, NULL),
('Sheraton Centre', 236, '2019-05-22', 335, NULL),
('Sheraton Centre', 236, '2019-05-23', 369, NULL),
('Sheraton Centre', 236, '2019-05-24', 205, NULL),
('Sheraton Centre', 236, '2019-05-25', 270, NULL),
('Sheraton Centre', 236, '2019-05-26', 260, NULL),
('Sheraton Centre', 236, '2019-05-27', 365, NULL),
('Sheraton Centre', 236, '2019-05-28', 390, NULL),
('Sheraton Centre', 236, '2019-05-29', 255, NULL),
('Sheraton Centre', 236, '2019-05-30', 251, NULL),
('Sheraton Centre', 236, '2019-05-31', 153, NULL),
('Sheraton Centre', 236, '2019-06-01', 184, NULL),
('Sheraton Centre', 236, '2019-06-02', 205, NULL),
('Sheraton Centre', 236, '2019-06-03', 336, NULL),
('Sheraton Centre', 236, '2019-06-04', 267, NULL),
('Sheraton Centre', 236, '2019-06-05', 231, NULL),
('Sheraton Centre', 236, '2019-06-06', 160, NULL),
('Sheraton Centre', 236, '2019-06-07', 214, NULL),
('Sheraton Centre', 236, '2019-06-08', 393, NULL),
('Sheraton Centre', 236, '2019-06-09', 275, NULL),
('Sheraton Centre', 236, '2019-06-10', 322, NULL),
('Sheraton Centre', 236, '2019-06-11', 222, NULL),
('Sheraton Centre', 236, '2019-06-12', 249, NULL),
('Sheraton Centre', 236, '2019-06-13', 151, NULL),
('Sheraton Centre', 236, '2019-06-14', 338, NULL),
('Sheraton Centre', 236, '2019-06-15', 349, NULL),
('Sheraton Centre', 236, '2019-06-16', 203, NULL),
('Sheraton Centre', 236, '2019-06-17', 338, NULL),
('Sheraton Centre', 236, '2019-06-18', 101, NULL),
('Sheraton Centre', 236, '2019-06-19', 333, NULL),
('Sheraton Centre', 236, '2019-06-20', 137, NULL),
('Sheraton Centre', 236, '2019-06-21', 312, NULL),
('Sheraton Centre', 236, '2019-06-22', 365, NULL),
('Sheraton Centre', 236, '2019-06-23', 376, NULL),
('Sheraton Centre', 236, '2019-06-24', 369, NULL),
('Sheraton Centre', 236, '2019-06-25', 317, NULL),
('Sheraton Centre', 236, '2019-06-26', 258, NULL),
('Sheraton Centre', 236, '2019-06-27', 210, NULL),
('Sheraton Centre', 236, '2019-06-28', 104, NULL),
('Sheraton Centre', 236, '2019-06-29', 130, NULL),
('Sheraton Centre', 236, '2019-06-30', 327, NULL),
('Sheraton Centre', 236, '2019-07-01', 113, NULL),
('Sheraton Centre', 236, '2019-07-02', 256, NULL),
('Sheraton Centre', 236, '2019-07-03', 297, NULL),
('Sheraton Centre', 236, '2019-07-04', 166, NULL),
('Sheraton Centre', 236, '2019-07-05', 340, NULL),
('Sheraton Centre', 236, '2019-07-06', 344, NULL),
('Sheraton Centre', 236, '2019-07-07', 377, NULL),
('Sheraton Centre', 236, '2019-07-08', 370, NULL),
('Sheraton Centre', 236, '2019-07-09', 159, NULL),
('Sheraton Centre', 236, '2019-07-10', 213, NULL),
('Sheraton Centre', 236, '2019-07-11', 378, NULL),
('Sheraton Centre', 236, '2019-07-12', 143, NULL),
('Sheraton Centre', 236, '2019-07-13', 122, NULL),
('Sheraton Centre', 236, '2019-07-14', 148, NULL),
('Sheraton Centre', 236, '2019-07-15', 265, NULL),
('Sheraton Centre', 236, '2019-07-16', 278, NULL),
('Sheraton Centre', 236, '2019-07-17', 234, NULL),
('Sheraton Centre', 236, '2019-07-18', 196, NULL),
('Sheraton Centre', 236, '2019-07-19', 188, NULL),
('Sheraton Centre', 236, '2019-07-20', 175, NULL),
('Sheraton Centre', 236, '2019-07-21', 246, NULL),
('Sheraton Centre', 236, '2019-07-22', 280, NULL),
('Sheraton Centre', 236, '2019-07-23', 160, NULL),
('Sheraton Centre', 236, '2019-07-24', 371, NULL),
('Sheraton Centre', 236, '2019-07-25', 399, NULL),
('Sheraton Centre', 236, '2019-07-26', 384, NULL),
('Sheraton Centre', 236, '2019-07-27', 206, NULL),
('Sheraton Centre', 236, '2019-07-28', 388, NULL),
('Sheraton Centre', 236, '2019-07-29', 275, NULL),
('Sheraton Centre', 236, '2019-07-30', 238, NULL),
('Sheraton Centre', 236, '2019-07-31', 271, NULL),
('Sheraton Centre', 236, '2019-08-01', 125, NULL),
('Sheraton Centre', 236, '2019-08-02', 176, NULL),
('Sheraton Centre', 236, '2019-08-03', 175, NULL),
('Sheraton Centre', 236, '2019-08-04', 225, NULL),
('Sheraton Centre', 236, '2019-08-05', 320, NULL),
('Sheraton Centre', 236, '2019-08-06', 296, NULL),
('Sheraton Centre', 236, '2019-08-07', 124, NULL),
('Sheraton Centre', 236, '2019-08-08', 335, NULL),
('Sheraton Centre', 236, '2019-08-09', 282, NULL),
('Sheraton Centre', 236, '2019-08-10', 397, NULL),
('Sheraton Centre', 236, '2019-08-11', 235, NULL),
('Sheraton Centre', 236, '2019-08-12', 143, NULL),
('Sheraton Centre', 236, '2019-08-13', 297, NULL),
('Sheraton Centre', 236, '2019-08-14', 330, NULL),
('Sheraton Centre', 236, '2019-08-15', 125, NULL),
('Sheraton Centre', 236, '2019-08-16', 394, NULL),
('Sheraton Centre', 236, '2019-08-17', 145, NULL),
('Sheraton Centre', 236, '2019-08-18', 181, NULL),
('Sheraton Centre', 236, '2019-08-19', 314, NULL),
('Sheraton Centre', 236, '2019-08-20', 364, NULL),
('Sheraton Centre', 236, '2019-08-21', 180, NULL),
('Sheraton Centre', 236, '2019-08-22', 190, NULL),
('Sheraton Centre', 236, '2019-08-23', 378, NULL),
('Sheraton Centre', 236, '2019-08-24', 159, NULL),
('Sheraton Centre', 236, '2019-08-25', 344, NULL),
('Sheraton Centre', 236, '2019-08-26', 135, NULL),
('Sheraton Centre', 236, '2019-08-27', 343, NULL),
('Sheraton Centre', 236, '2019-08-28', 127, NULL),
('Sheraton Centre', 236, '2019-08-29', 376, NULL),
('Sheraton Centre', 236, '2019-08-30', 251, NULL),
('Sheraton Centre', 236, '2019-08-31', 339, NULL),
('Sheraton Centre', 236, '2019-09-01', 322, NULL),
('Sheraton Centre', 236, '2019-09-02', 190, NULL),
('Sheraton Centre', 236, '2019-09-03', 330, NULL),
('Sheraton Centre', 236, '2019-09-04', 282, NULL),
('Sheraton Centre', 236, '2019-09-05', 384, NULL),
('Sheraton Centre', 236, '2019-09-06', 364, NULL),
('Sheraton Centre', 236, '2019-09-07', 103, NULL),
('Sheraton Centre', 236, '2019-09-08', 125, NULL),
('Sheraton Centre', 236, '2019-09-09', 316, NULL),
('Sheraton Centre', 236, '2019-09-10', 335, NULL),
('Sheraton Centre', 236, '2019-09-11', 244, NULL),
('Sheraton Centre', 236, '2019-09-12', 306, NULL),
('Sheraton Centre', 236, '2019-09-13', 343, NULL),
('Sheraton Centre', 236, '2019-09-14', 281, NULL),
('Sheraton Centre', 236, '2019-09-15', 333, NULL),
('Sheraton Centre', 236, '2019-09-16', 123, NULL),
('Sheraton Centre', 236, '2019-09-17', 255, NULL),
('Sheraton Centre', 236, '2019-09-18', 112, NULL),
('Sheraton Centre', 236, '2019-09-19', 249, NULL),
('Sheraton Centre', 236, '2019-09-20', 226, NULL),
('Sheraton Centre', 236, '2019-09-21', 297, NULL),
('Sheraton Centre', 236, '2019-09-22', 323, NULL),
('Sheraton Centre', 236, '2019-09-23', 263, NULL),
('Sheraton Centre', 236, '2019-09-24', 369, NULL),
('Sheraton Centre', 236, '2019-09-25', 121, NULL),
('Sheraton Centre', 236, '2019-09-26', 280, NULL),
('Sheraton Centre', 236, '2019-09-27', 342, NULL),
('Sheraton Centre', 236, '2019-09-28', 330, NULL),
('Sheraton Centre', 236, '2019-09-29', 261, NULL),
('Sheraton Centre', 236, '2019-09-30', 168, NULL),
('Sheraton Centre', 236, '2019-10-01', 252, NULL),
('Sheraton Centre', 236, '2019-10-02', 364, NULL),
('Sheraton Centre', 236, '2019-10-03', 232, NULL),
('Sheraton Centre', 236, '2019-10-04', 235, NULL),
('Sheraton Centre', 236, '2019-10-05', 284, NULL),
('Sheraton Centre', 236, '2019-10-06', 341, NULL),
('Sheraton Centre', 236, '2019-10-07', 222, NULL),
('Sheraton Centre', 236, '2019-10-08', 357, NULL),
('Sheraton Centre', 236, '2019-10-09', 272, NULL),
('Sheraton Centre', 236, '2019-10-10', 389, NULL),
('Sheraton Centre', 236, '2019-10-11', 387, NULL),
('Sheraton Centre', 236, '2019-10-12', 161, NULL),
('Sheraton Centre', 236, '2019-10-13', 347, NULL),
('Sheraton Centre', 236, '2019-10-14', 367, NULL),
('Sheraton Centre', 236, '2019-10-15', 125, NULL),
('Sheraton Centre', 236, '2019-10-16', 113, NULL),
('Sheraton Centre', 236, '2019-10-17', 232, NULL),
('Sheraton Centre', 236, '2019-10-18', 350, NULL),
('Sheraton Centre', 236, '2019-10-19', 305, NULL),
('Sheraton Centre', 236, '2019-10-20', 135, NULL),
('Sheraton Centre', 236, '2019-10-21', 104, NULL),
('Sheraton Centre', 236, '2019-10-22', 329, NULL),
('Sheraton Centre', 236, '2019-10-23', 251, NULL),
('Sheraton Centre', 236, '2019-10-24', 213, NULL),
('Sheraton Centre', 236, '2019-10-25', 110, NULL),
('Sheraton Centre', 236, '2019-10-26', 157, NULL),
('Sheraton Centre', 236, '2019-10-27', 168, NULL),
('Sheraton Centre', 236, '2019-10-28', 103, NULL),
('Sheraton Centre', 236, '2019-10-29', 242, NULL),
('Sheraton Centre', 236, '2019-10-30', 335, NULL),
('Sheraton Centre', 236, '2019-10-31', 248, NULL),
('Sheraton Centre', 236, '2019-11-01', 321, NULL),
('Sheraton Centre', 236, '2019-11-02', 364, NULL),
('Sheraton Centre', 236, '2019-11-03', 297, NULL),
('Sheraton Centre', 236, '2019-11-04', 322, NULL),
('Sheraton Centre', 236, '2019-11-05', 124, NULL),
('Sheraton Centre', 236, '2019-11-06', 134, NULL),
('Sheraton Centre', 236, '2019-11-07', 150, NULL),
('Sheraton Centre', 236, '2019-11-08', 260, NULL),
('Sheraton Centre', 236, '2019-11-09', 243, NULL),
('Sheraton Centre', 236, '2019-11-10', 123, NULL),
('Sheraton Centre', 236, '2019-11-11', 111, NULL),
('Sheraton Centre', 236, '2019-11-12', 342, NULL),
('Sheraton Centre', 236, '2019-11-13', 242, NULL),
('Sheraton Centre', 236, '2019-11-14', 160, NULL),
('Sheraton Centre', 236, '2019-11-15', 192, NULL),
('Sheraton Centre', 236, '2019-11-16', 338, NULL),
('Sheraton Centre', 236, '2019-11-17', 132, NULL),
('Sheraton Centre', 236, '2019-11-18', 379, NULL),
('Sheraton Centre', 236, '2019-11-19', 198, NULL),
('Sheraton Centre', 236, '2019-11-20', 377, NULL),
('Sheraton Centre', 236, '2019-11-21', 186, NULL),
('Sheraton Centre', 236, '2019-11-22', 207, NULL),
('Sheraton Centre', 236, '2019-11-23', 165, NULL),
('Sheraton Centre', 236, '2019-11-24', 150, NULL),
('Sheraton Centre', 236, '2019-11-25', 133, NULL),
('Sheraton Centre', 236, '2019-11-26', 188, NULL),
('Sheraton Centre', 236, '2019-11-27', 367, NULL),
('Sheraton Centre', 236, '2019-11-28', 367, NULL),
('Sheraton Centre', 236, '2019-11-29', 290, NULL),
('Sheraton Centre', 236, '2019-11-30', 111, NULL),
('Sheraton Centre', 236, '2019-12-01', 225, NULL),
('Sheraton Centre', 236, '2019-12-02', 380, NULL),
('Sheraton Centre', 236, '2019-12-03', 134, NULL),
('Sheraton Centre', 236, '2019-12-04', 184, NULL),
('Sheraton Centre', 236, '2019-12-05', 105, NULL),
('Sheraton Centre', 236, '2019-12-06', 227, NULL),
('Sheraton Centre', 236, '2019-12-07', 303, NULL),
('Sheraton Centre', 236, '2019-12-08', 120, NULL),
('Sheraton Centre', 236, '2019-12-09', 187, NULL),
('Sheraton Centre', 236, '2019-12-10', 352, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 236, '2019-12-11', 351, NULL),
('Sheraton Centre', 236, '2019-12-12', 170, NULL),
('Sheraton Centre', 236, '2019-12-13', 259, NULL),
('Sheraton Centre', 236, '2019-12-14', 339, NULL),
('Sheraton Centre', 236, '2019-12-15', 177, NULL),
('Sheraton Centre', 236, '2019-12-16', 384, NULL),
('Sheraton Centre', 236, '2019-12-17', 113, NULL),
('Sheraton Centre', 236, '2019-12-18', 130, NULL),
('Sheraton Centre', 236, '2019-12-19', 240, NULL),
('Sheraton Centre', 236, '2019-12-20', 127, NULL),
('Sheraton Centre', 236, '2019-12-21', 350, NULL),
('Sheraton Centre', 236, '2019-12-22', 347, NULL),
('Sheraton Centre', 236, '2019-12-23', 361, NULL),
('Sheraton Centre', 236, '2019-12-24', 129, NULL),
('Sheraton Centre', 236, '2019-12-25', 202, NULL),
('Sheraton Centre', 236, '2019-12-26', 334, NULL),
('Sheraton Centre', 236, '2019-12-27', 241, NULL),
('Sheraton Centre', 236, '2019-12-28', 162, NULL),
('Sheraton Centre', 236, '2019-12-29', 266, NULL),
('Sheraton Centre', 236, '2019-12-30', 189, NULL),
('Sheraton Centre', 236, '2019-12-31', 357, NULL),
('Sheraton Centre', 236, '2020-01-01', 165, NULL),
('Sheraton Centre', 236, '2020-01-02', 171, NULL),
('Sheraton Centre', 236, '2020-01-03', 165, NULL),
('Sheraton Centre', 236, '2020-01-04', 273, NULL),
('Sheraton Centre', 236, '2020-01-05', 304, NULL),
('Sheraton Centre', 236, '2020-01-06', 300, NULL),
('Sheraton Centre', 236, '2020-01-07', 399, NULL),
('Sheraton Centre', 236, '2020-01-08', 100, NULL),
('Sheraton Centre', 236, '2020-01-09', 263, NULL),
('Sheraton Centre', 236, '2020-01-10', 220, NULL),
('Sheraton Centre', 236, '2020-01-11', 157, NULL),
('Sheraton Centre', 236, '2020-01-12', 119, NULL),
('Sheraton Centre', 236, '2020-01-13', 192, NULL),
('Sheraton Centre', 236, '2020-01-14', 299, NULL),
('Sheraton Centre', 236, '2020-01-15', 203, NULL),
('Sheraton Centre', 236, '2020-01-16', 136, NULL),
('Sheraton Centre', 236, '2020-01-17', 167, NULL),
('Sheraton Centre', 236, '2020-01-18', 253, NULL),
('Sheraton Centre', 236, '2020-01-19', 167, NULL),
('Sheraton Centre', 236, '2020-01-20', 200, NULL),
('Sheraton Centre', 236, '2020-01-21', 365, NULL),
('Sheraton Centre', 236, '2020-01-22', 188, NULL),
('Sheraton Centre', 236, '2020-01-23', 258, NULL),
('Sheraton Centre', 236, '2020-01-24', 340, NULL),
('Sheraton Centre', 236, '2020-01-25', 161, NULL),
('Sheraton Centre', 236, '2020-01-26', 296, NULL),
('Sheraton Centre', 236, '2020-01-27', 175, NULL),
('Sheraton Centre', 236, '2020-01-28', 397, NULL),
('Sheraton Centre', 236, '2020-01-29', 370, NULL),
('Sheraton Centre', 236, '2020-01-30', 207, NULL),
('Sheraton Centre', 236, '2020-01-31', 240, NULL),
('Sheraton Centre', 236, '2020-02-01', 326, NULL),
('Sheraton Centre', 236, '2020-02-02', 185, NULL),
('Sheraton Centre', 236, '2020-02-03', 171, NULL),
('Sheraton Centre', 236, '2020-02-04', 296, NULL),
('Sheraton Centre', 246, '2019-01-01', 308, NULL),
('Sheraton Centre', 246, '2019-01-02', 269, NULL),
('Sheraton Centre', 246, '2019-01-03', 374, NULL),
('Sheraton Centre', 246, '2019-01-04', 196, NULL),
('Sheraton Centre', 246, '2019-01-05', 232, NULL),
('Sheraton Centre', 246, '2019-01-06', 178, NULL),
('Sheraton Centre', 246, '2019-01-07', 253, NULL),
('Sheraton Centre', 246, '2019-01-08', 150, NULL),
('Sheraton Centre', 246, '2019-01-09', 174, NULL),
('Sheraton Centre', 246, '2019-01-10', 308, NULL),
('Sheraton Centre', 246, '2019-01-11', 318, NULL),
('Sheraton Centre', 246, '2019-01-12', 212, NULL),
('Sheraton Centre', 246, '2019-01-13', 179, NULL),
('Sheraton Centre', 246, '2019-01-14', 223, NULL),
('Sheraton Centre', 246, '2019-01-15', 232, NULL),
('Sheraton Centre', 246, '2019-01-16', 253, NULL),
('Sheraton Centre', 246, '2019-01-17', 384, NULL),
('Sheraton Centre', 246, '2019-01-18', 314, NULL),
('Sheraton Centre', 246, '2019-01-19', 279, NULL),
('Sheraton Centre', 246, '2019-01-20', 280, NULL),
('Sheraton Centre', 246, '2019-01-21', 314, NULL),
('Sheraton Centre', 246, '2019-01-22', 325, NULL),
('Sheraton Centre', 246, '2019-01-23', 131, NULL),
('Sheraton Centre', 246, '2019-01-24', 250, NULL),
('Sheraton Centre', 246, '2019-01-25', 337, NULL),
('Sheraton Centre', 246, '2019-01-26', 368, NULL),
('Sheraton Centre', 246, '2019-01-27', 296, NULL),
('Sheraton Centre', 246, '2019-01-28', 345, NULL),
('Sheraton Centre', 246, '2019-01-29', 142, NULL),
('Sheraton Centre', 246, '2019-01-30', 296, NULL),
('Sheraton Centre', 246, '2019-01-31', 204, NULL),
('Sheraton Centre', 246, '2019-02-01', 124, NULL),
('Sheraton Centre', 246, '2019-02-02', 232, NULL),
('Sheraton Centre', 246, '2019-02-03', 111, NULL),
('Sheraton Centre', 246, '2019-02-04', 168, NULL),
('Sheraton Centre', 246, '2019-02-05', 339, NULL),
('Sheraton Centre', 246, '2019-02-06', 123, NULL),
('Sheraton Centre', 246, '2019-02-07', 385, NULL),
('Sheraton Centre', 246, '2019-02-08', 356, NULL),
('Sheraton Centre', 246, '2019-02-09', 322, NULL),
('Sheraton Centre', 246, '2019-02-10', 109, NULL),
('Sheraton Centre', 246, '2019-02-11', 234, NULL),
('Sheraton Centre', 246, '2019-02-12', 310, NULL),
('Sheraton Centre', 246, '2019-02-13', 142, NULL),
('Sheraton Centre', 246, '2019-02-14', 389, NULL),
('Sheraton Centre', 246, '2019-02-15', 169, NULL),
('Sheraton Centre', 246, '2019-02-16', 148, NULL),
('Sheraton Centre', 246, '2019-02-17', 190, NULL),
('Sheraton Centre', 246, '2019-02-18', 244, NULL),
('Sheraton Centre', 246, '2019-02-19', 170, NULL),
('Sheraton Centre', 246, '2019-02-20', 205, NULL),
('Sheraton Centre', 246, '2019-02-21', 265, NULL),
('Sheraton Centre', 246, '2019-02-22', 374, NULL),
('Sheraton Centre', 246, '2019-02-23', 228, NULL),
('Sheraton Centre', 246, '2019-02-24', 148, NULL),
('Sheraton Centre', 246, '2019-02-25', 321, NULL),
('Sheraton Centre', 246, '2019-02-26', 359, NULL),
('Sheraton Centre', 246, '2019-02-27', 224, NULL),
('Sheraton Centre', 246, '2019-02-28', 387, NULL),
('Sheraton Centre', 246, '2019-03-01', 183, NULL),
('Sheraton Centre', 246, '2019-03-02', 223, NULL),
('Sheraton Centre', 246, '2019-03-03', 196, NULL),
('Sheraton Centre', 246, '2019-03-04', 275, NULL),
('Sheraton Centre', 246, '2019-03-05', 185, NULL),
('Sheraton Centre', 246, '2019-03-06', 326, NULL),
('Sheraton Centre', 246, '2019-03-07', 268, NULL),
('Sheraton Centre', 246, '2019-03-08', 182, NULL),
('Sheraton Centre', 246, '2019-03-09', 187, NULL),
('Sheraton Centre', 246, '2019-03-10', 103, NULL),
('Sheraton Centre', 246, '2019-03-11', 328, NULL),
('Sheraton Centre', 246, '2019-03-12', 202, NULL),
('Sheraton Centre', 246, '2019-03-13', 399, NULL),
('Sheraton Centre', 246, '2019-03-14', 137, NULL),
('Sheraton Centre', 246, '2019-03-15', 184, NULL),
('Sheraton Centre', 246, '2019-03-16', 349, NULL),
('Sheraton Centre', 246, '2019-03-17', 108, NULL),
('Sheraton Centre', 246, '2019-03-18', 191, NULL),
('Sheraton Centre', 246, '2019-03-19', 317, NULL),
('Sheraton Centre', 246, '2019-03-20', 361, NULL),
('Sheraton Centre', 246, '2019-03-21', 342, NULL),
('Sheraton Centre', 246, '2019-03-22', 223, NULL),
('Sheraton Centre', 246, '2019-03-23', 212, NULL),
('Sheraton Centre', 246, '2019-03-24', 314, NULL),
('Sheraton Centre', 246, '2019-03-25', 263, NULL),
('Sheraton Centre', 246, '2019-03-26', 124, NULL),
('Sheraton Centre', 246, '2019-03-27', 140, NULL),
('Sheraton Centre', 246, '2019-03-28', 364, NULL),
('Sheraton Centre', 246, '2019-03-29', 259, NULL),
('Sheraton Centre', 246, '2019-03-30', 106, NULL),
('Sheraton Centre', 246, '2019-03-31', 196, NULL),
('Sheraton Centre', 246, '2019-04-01', 144, NULL),
('Sheraton Centre', 246, '2019-04-02', 302, NULL),
('Sheraton Centre', 246, '2019-04-03', 102, NULL),
('Sheraton Centre', 246, '2019-04-04', 161, NULL),
('Sheraton Centre', 246, '2019-04-05', 363, NULL),
('Sheraton Centre', 246, '2019-04-06', 114, NULL),
('Sheraton Centre', 246, '2019-04-07', 158, NULL),
('Sheraton Centre', 246, '2019-04-08', 379, NULL),
('Sheraton Centre', 246, '2019-04-09', 176, NULL),
('Sheraton Centre', 246, '2019-04-10', 127, NULL),
('Sheraton Centre', 246, '2019-04-11', 285, NULL),
('Sheraton Centre', 246, '2019-04-12', 315, NULL),
('Sheraton Centre', 246, '2019-04-13', 184, NULL),
('Sheraton Centre', 246, '2019-04-14', 114, NULL),
('Sheraton Centre', 246, '2019-04-15', 119, NULL),
('Sheraton Centre', 246, '2019-04-16', 139, NULL),
('Sheraton Centre', 246, '2019-04-17', 103, NULL),
('Sheraton Centre', 246, '2019-04-18', 396, NULL),
('Sheraton Centre', 246, '2019-04-19', 187, NULL),
('Sheraton Centre', 246, '2019-04-20', 171, NULL),
('Sheraton Centre', 246, '2019-04-21', 232, NULL),
('Sheraton Centre', 246, '2019-04-22', 144, NULL),
('Sheraton Centre', 246, '2019-04-23', 154, NULL),
('Sheraton Centre', 246, '2019-04-24', 346, NULL),
('Sheraton Centre', 246, '2019-04-25', 216, NULL),
('Sheraton Centre', 246, '2019-04-26', 287, NULL),
('Sheraton Centre', 246, '2019-04-27', 363, NULL),
('Sheraton Centre', 246, '2019-04-28', 224, NULL),
('Sheraton Centre', 246, '2019-04-29', 222, NULL),
('Sheraton Centre', 246, '2019-04-30', 335, NULL),
('Sheraton Centre', 246, '2019-05-01', 186, NULL),
('Sheraton Centre', 246, '2019-05-02', 194, NULL),
('Sheraton Centre', 246, '2019-05-03', 216, NULL),
('Sheraton Centre', 246, '2019-05-04', 112, NULL),
('Sheraton Centre', 246, '2019-05-05', 377, NULL),
('Sheraton Centre', 246, '2019-05-06', 241, NULL),
('Sheraton Centre', 246, '2019-05-07', 317, NULL),
('Sheraton Centre', 246, '2019-05-08', 285, NULL),
('Sheraton Centre', 246, '2019-05-09', 317, NULL),
('Sheraton Centre', 246, '2019-05-10', 208, NULL),
('Sheraton Centre', 246, '2019-05-11', 378, NULL),
('Sheraton Centre', 246, '2019-05-12', 394, NULL),
('Sheraton Centre', 246, '2019-05-13', 207, NULL),
('Sheraton Centre', 246, '2019-05-14', 346, NULL),
('Sheraton Centre', 246, '2019-05-15', 331, NULL),
('Sheraton Centre', 246, '2019-05-16', 156, NULL),
('Sheraton Centre', 246, '2019-05-17', 278, NULL),
('Sheraton Centre', 246, '2019-05-18', 222, NULL),
('Sheraton Centre', 246, '2019-05-19', 136, NULL),
('Sheraton Centre', 246, '2019-05-20', 168, NULL),
('Sheraton Centre', 246, '2019-05-21', 390, NULL),
('Sheraton Centre', 246, '2019-05-22', 349, NULL),
('Sheraton Centre', 246, '2019-05-23', 221, NULL),
('Sheraton Centre', 246, '2019-05-24', 370, NULL),
('Sheraton Centre', 246, '2019-05-25', 269, NULL),
('Sheraton Centre', 246, '2019-05-26', 184, NULL),
('Sheraton Centre', 246, '2019-05-27', 169, NULL),
('Sheraton Centre', 246, '2019-05-28', 158, NULL),
('Sheraton Centre', 246, '2019-05-29', 335, NULL),
('Sheraton Centre', 246, '2019-05-30', 176, NULL),
('Sheraton Centre', 246, '2019-05-31', 137, NULL),
('Sheraton Centre', 246, '2019-06-01', 123, NULL),
('Sheraton Centre', 246, '2019-06-02', 352, NULL),
('Sheraton Centre', 246, '2019-06-03', 106, NULL),
('Sheraton Centre', 246, '2019-06-04', 247, NULL),
('Sheraton Centre', 246, '2019-06-05', 273, NULL),
('Sheraton Centre', 246, '2019-06-06', 144, NULL),
('Sheraton Centre', 246, '2019-06-07', 229, NULL),
('Sheraton Centre', 246, '2019-06-08', 327, NULL),
('Sheraton Centre', 246, '2019-06-09', 129, NULL),
('Sheraton Centre', 246, '2019-06-10', 202, NULL),
('Sheraton Centre', 246, '2019-06-11', 199, NULL),
('Sheraton Centre', 246, '2019-06-12', 102, NULL),
('Sheraton Centre', 246, '2019-06-13', 361, NULL),
('Sheraton Centre', 246, '2019-06-14', 232, NULL),
('Sheraton Centre', 246, '2019-06-15', 267, NULL),
('Sheraton Centre', 246, '2019-06-16', 130, NULL),
('Sheraton Centre', 246, '2019-06-17', 177, NULL),
('Sheraton Centre', 246, '2019-06-18', 177, NULL),
('Sheraton Centre', 246, '2019-06-19', 321, NULL),
('Sheraton Centre', 246, '2019-06-20', 138, NULL),
('Sheraton Centre', 246, '2019-06-21', 282, NULL),
('Sheraton Centre', 246, '2019-06-22', 163, NULL),
('Sheraton Centre', 246, '2019-06-23', 288, NULL),
('Sheraton Centre', 246, '2019-06-24', 185, NULL),
('Sheraton Centre', 246, '2019-06-25', 200, NULL),
('Sheraton Centre', 246, '2019-06-26', 253, NULL),
('Sheraton Centre', 246, '2019-06-27', 163, NULL),
('Sheraton Centre', 246, '2019-06-28', 195, NULL),
('Sheraton Centre', 246, '2019-06-29', 281, NULL),
('Sheraton Centre', 246, '2019-06-30', 202, NULL),
('Sheraton Centre', 246, '2019-07-01', 384, NULL),
('Sheraton Centre', 246, '2019-07-02', 127, NULL),
('Sheraton Centre', 246, '2019-07-03', 173, NULL),
('Sheraton Centre', 246, '2019-07-04', 144, NULL),
('Sheraton Centre', 246, '2019-07-05', 301, NULL),
('Sheraton Centre', 246, '2019-07-06', 198, NULL),
('Sheraton Centre', 246, '2019-07-07', 290, NULL),
('Sheraton Centre', 246, '2019-07-08', 150, NULL),
('Sheraton Centre', 246, '2019-07-09', 360, NULL),
('Sheraton Centre', 246, '2019-07-10', 158, NULL),
('Sheraton Centre', 246, '2019-07-11', 187, NULL),
('Sheraton Centre', 246, '2019-07-12', 236, NULL),
('Sheraton Centre', 246, '2019-07-13', 348, NULL),
('Sheraton Centre', 246, '2019-07-14', 279, NULL),
('Sheraton Centre', 246, '2019-07-15', 186, NULL),
('Sheraton Centre', 246, '2019-07-16', 344, NULL),
('Sheraton Centre', 246, '2019-07-17', 387, NULL),
('Sheraton Centre', 246, '2019-07-18', 102, NULL),
('Sheraton Centre', 246, '2019-07-19', 318, NULL),
('Sheraton Centre', 246, '2019-07-20', 115, NULL),
('Sheraton Centre', 246, '2019-07-21', 360, NULL),
('Sheraton Centre', 246, '2019-07-22', 327, NULL),
('Sheraton Centre', 246, '2019-07-23', 278, NULL),
('Sheraton Centre', 246, '2019-07-24', 332, NULL),
('Sheraton Centre', 246, '2019-07-25', 213, NULL),
('Sheraton Centre', 246, '2019-07-26', 176, NULL),
('Sheraton Centre', 246, '2019-07-27', 349, NULL),
('Sheraton Centre', 246, '2019-07-28', 109, NULL),
('Sheraton Centre', 246, '2019-07-29', 216, NULL),
('Sheraton Centre', 246, '2019-07-30', 392, NULL),
('Sheraton Centre', 246, '2019-07-31', 213, NULL),
('Sheraton Centre', 246, '2019-08-01', 228, NULL),
('Sheraton Centre', 246, '2019-08-02', 284, NULL),
('Sheraton Centre', 246, '2019-08-03', 373, NULL),
('Sheraton Centre', 246, '2019-08-04', 355, NULL),
('Sheraton Centre', 246, '2019-08-05', 303, NULL),
('Sheraton Centre', 246, '2019-08-06', 221, NULL),
('Sheraton Centre', 246, '2019-08-07', 329, NULL),
('Sheraton Centre', 246, '2019-08-08', 147, NULL),
('Sheraton Centre', 246, '2019-08-09', 217, NULL),
('Sheraton Centre', 246, '2019-08-10', 248, NULL),
('Sheraton Centre', 246, '2019-08-11', 206, NULL),
('Sheraton Centre', 246, '2019-08-12', 110, NULL),
('Sheraton Centre', 246, '2019-08-13', 399, NULL),
('Sheraton Centre', 246, '2019-08-14', 378, NULL),
('Sheraton Centre', 246, '2019-08-15', 126, NULL),
('Sheraton Centre', 246, '2019-08-16', 180, NULL),
('Sheraton Centre', 246, '2019-08-17', 123, NULL),
('Sheraton Centre', 246, '2019-08-18', 185, NULL),
('Sheraton Centre', 246, '2019-08-19', 357, NULL),
('Sheraton Centre', 246, '2019-08-20', 371, NULL),
('Sheraton Centre', 246, '2019-08-21', 114, NULL),
('Sheraton Centre', 246, '2019-08-22', 237, NULL),
('Sheraton Centre', 246, '2019-08-23', 351, NULL),
('Sheraton Centre', 246, '2019-08-24', 160, NULL),
('Sheraton Centre', 246, '2019-08-25', 322, NULL),
('Sheraton Centre', 246, '2019-08-26', 252, NULL),
('Sheraton Centre', 246, '2019-08-27', 363, NULL),
('Sheraton Centre', 246, '2019-08-28', 177, NULL),
('Sheraton Centre', 246, '2019-08-29', 258, NULL),
('Sheraton Centre', 246, '2019-08-30', 180, NULL),
('Sheraton Centre', 246, '2019-08-31', 193, NULL),
('Sheraton Centre', 246, '2019-09-01', 140, NULL),
('Sheraton Centre', 246, '2019-09-02', 292, NULL),
('Sheraton Centre', 246, '2019-09-03', 202, NULL),
('Sheraton Centre', 246, '2019-09-04', 397, NULL),
('Sheraton Centre', 246, '2019-09-05', 345, NULL),
('Sheraton Centre', 246, '2019-09-06', 231, NULL),
('Sheraton Centre', 246, '2019-09-07', 374, NULL),
('Sheraton Centre', 246, '2019-09-08', 104, NULL),
('Sheraton Centre', 246, '2019-09-09', 302, NULL),
('Sheraton Centre', 246, '2019-09-10', 174, NULL),
('Sheraton Centre', 246, '2019-09-11', 232, NULL),
('Sheraton Centre', 246, '2019-09-12', 117, NULL),
('Sheraton Centre', 246, '2019-09-13', 159, NULL),
('Sheraton Centre', 246, '2019-09-14', 176, NULL),
('Sheraton Centre', 246, '2019-09-15', 399, NULL),
('Sheraton Centre', 246, '2019-09-16', 198, NULL),
('Sheraton Centre', 246, '2019-09-17', 218, NULL),
('Sheraton Centre', 246, '2019-09-18', 152, NULL),
('Sheraton Centre', 246, '2019-09-19', 161, NULL),
('Sheraton Centre', 246, '2019-09-20', 127, NULL),
('Sheraton Centre', 246, '2019-09-21', 206, NULL),
('Sheraton Centre', 246, '2019-09-22', 308, NULL),
('Sheraton Centre', 246, '2019-09-23', 330, NULL),
('Sheraton Centre', 246, '2019-09-24', 188, NULL),
('Sheraton Centre', 246, '2019-09-25', 309, NULL),
('Sheraton Centre', 246, '2019-09-26', 271, NULL),
('Sheraton Centre', 246, '2019-09-27', 132, NULL),
('Sheraton Centre', 246, '2019-09-28', 311, NULL),
('Sheraton Centre', 246, '2019-09-29', 135, NULL),
('Sheraton Centre', 246, '2019-09-30', 271, NULL),
('Sheraton Centre', 246, '2019-10-01', 199, NULL),
('Sheraton Centre', 246, '2019-10-02', 316, NULL),
('Sheraton Centre', 246, '2019-10-03', 139, NULL),
('Sheraton Centre', 246, '2019-10-04', 134, NULL),
('Sheraton Centre', 246, '2019-10-05', 100, NULL),
('Sheraton Centre', 246, '2019-10-06', 264, NULL),
('Sheraton Centre', 246, '2019-10-07', 327, NULL),
('Sheraton Centre', 246, '2019-10-08', 346, NULL),
('Sheraton Centre', 246, '2019-10-09', 244, NULL),
('Sheraton Centre', 246, '2019-10-10', 148, NULL),
('Sheraton Centre', 246, '2019-10-11', 201, NULL),
('Sheraton Centre', 246, '2019-10-12', 348, NULL),
('Sheraton Centre', 246, '2019-10-13', 313, NULL),
('Sheraton Centre', 246, '2019-10-14', 359, NULL),
('Sheraton Centre', 246, '2019-10-15', 253, NULL),
('Sheraton Centre', 246, '2019-10-16', 226, NULL),
('Sheraton Centre', 246, '2019-10-17', 260, NULL),
('Sheraton Centre', 246, '2019-10-18', 164, NULL),
('Sheraton Centre', 246, '2019-10-19', 197, NULL),
('Sheraton Centre', 246, '2019-10-20', 268, NULL),
('Sheraton Centre', 246, '2019-10-21', 225, NULL),
('Sheraton Centre', 246, '2019-10-22', 341, NULL),
('Sheraton Centre', 246, '2019-10-23', 322, NULL),
('Sheraton Centre', 246, '2019-10-24', 356, NULL),
('Sheraton Centre', 246, '2019-10-25', 356, NULL),
('Sheraton Centre', 246, '2019-10-26', 153, NULL),
('Sheraton Centre', 246, '2019-10-27', 218, NULL),
('Sheraton Centre', 246, '2019-10-28', 349, NULL),
('Sheraton Centre', 246, '2019-10-29', 132, NULL),
('Sheraton Centre', 246, '2019-10-30', 388, NULL),
('Sheraton Centre', 246, '2019-10-31', 384, NULL),
('Sheraton Centre', 246, '2019-11-01', 262, NULL),
('Sheraton Centre', 246, '2019-11-02', 155, NULL),
('Sheraton Centre', 246, '2019-11-03', 348, NULL),
('Sheraton Centre', 246, '2019-11-04', 207, NULL),
('Sheraton Centre', 246, '2019-11-05', 365, NULL),
('Sheraton Centre', 246, '2019-11-06', 206, NULL),
('Sheraton Centre', 246, '2019-11-07', 295, NULL),
('Sheraton Centre', 246, '2019-11-08', 347, NULL),
('Sheraton Centre', 246, '2019-11-09', 387, NULL),
('Sheraton Centre', 246, '2019-11-10', 150, NULL),
('Sheraton Centre', 246, '2019-11-11', 283, NULL),
('Sheraton Centre', 246, '2019-11-12', 192, NULL),
('Sheraton Centre', 246, '2019-11-13', 347, NULL),
('Sheraton Centre', 246, '2019-11-14', 238, NULL),
('Sheraton Centre', 246, '2019-11-15', 343, NULL),
('Sheraton Centre', 246, '2019-11-16', 200, NULL),
('Sheraton Centre', 246, '2019-11-17', 335, NULL),
('Sheraton Centre', 246, '2019-11-18', 172, NULL),
('Sheraton Centre', 246, '2019-11-19', 248, NULL),
('Sheraton Centre', 246, '2019-11-20', 298, NULL),
('Sheraton Centre', 246, '2019-11-21', 277, NULL),
('Sheraton Centre', 246, '2019-11-22', 244, NULL),
('Sheraton Centre', 246, '2019-11-23', 124, NULL),
('Sheraton Centre', 246, '2019-11-24', 270, NULL),
('Sheraton Centre', 246, '2019-11-25', 227, NULL),
('Sheraton Centre', 246, '2019-11-26', 298, NULL),
('Sheraton Centre', 246, '2019-11-27', 186, NULL),
('Sheraton Centre', 246, '2019-11-28', 131, NULL),
('Sheraton Centre', 246, '2019-11-29', 130, NULL),
('Sheraton Centre', 246, '2019-11-30', 371, NULL),
('Sheraton Centre', 246, '2019-12-01', 149, NULL),
('Sheraton Centre', 246, '2019-12-02', 267, NULL),
('Sheraton Centre', 246, '2019-12-03', 255, NULL),
('Sheraton Centre', 246, '2019-12-04', 248, NULL),
('Sheraton Centre', 246, '2019-12-05', 151, NULL),
('Sheraton Centre', 246, '2019-12-06', 382, NULL),
('Sheraton Centre', 246, '2019-12-07', 275, NULL),
('Sheraton Centre', 246, '2019-12-08', 196, NULL),
('Sheraton Centre', 246, '2019-12-09', 104, NULL),
('Sheraton Centre', 246, '2019-12-10', 391, NULL),
('Sheraton Centre', 246, '2019-12-11', 366, NULL),
('Sheraton Centre', 246, '2019-12-12', 244, NULL),
('Sheraton Centre', 246, '2019-12-13', 212, NULL),
('Sheraton Centre', 246, '2019-12-14', 367, NULL),
('Sheraton Centre', 246, '2019-12-15', 177, NULL),
('Sheraton Centre', 246, '2019-12-16', 388, NULL),
('Sheraton Centre', 246, '2019-12-17', 359, NULL),
('Sheraton Centre', 246, '2019-12-18', 204, NULL),
('Sheraton Centre', 246, '2019-12-19', 296, NULL),
('Sheraton Centre', 246, '2019-12-20', 171, NULL),
('Sheraton Centre', 246, '2019-12-21', 156, NULL),
('Sheraton Centre', 246, '2019-12-22', 390, NULL),
('Sheraton Centre', 246, '2019-12-23', 104, NULL),
('Sheraton Centre', 246, '2019-12-24', 314, NULL),
('Sheraton Centre', 246, '2019-12-25', 198, NULL),
('Sheraton Centre', 246, '2019-12-26', 379, NULL),
('Sheraton Centre', 246, '2019-12-27', 364, NULL),
('Sheraton Centre', 246, '2019-12-28', 189, NULL),
('Sheraton Centre', 246, '2019-12-29', 300, NULL),
('Sheraton Centre', 246, '2019-12-30', 349, NULL),
('Sheraton Centre', 246, '2019-12-31', 371, NULL),
('Sheraton Centre', 246, '2020-01-01', 241, NULL),
('Sheraton Centre', 246, '2020-01-02', 326, NULL),
('Sheraton Centre', 246, '2020-01-03', 104, NULL),
('Sheraton Centre', 246, '2020-01-04', 325, NULL),
('Sheraton Centre', 246, '2020-01-05', 326, NULL),
('Sheraton Centre', 246, '2020-01-06', 359, NULL),
('Sheraton Centre', 246, '2020-01-07', 255, NULL),
('Sheraton Centre', 246, '2020-01-08', 274, NULL),
('Sheraton Centre', 246, '2020-01-09', 314, NULL),
('Sheraton Centre', 246, '2020-01-10', 160, NULL),
('Sheraton Centre', 246, '2020-01-11', 153, NULL),
('Sheraton Centre', 246, '2020-01-12', 280, NULL),
('Sheraton Centre', 246, '2020-01-13', 141, NULL),
('Sheraton Centre', 246, '2020-01-14', 307, NULL),
('Sheraton Centre', 246, '2020-01-15', 225, NULL),
('Sheraton Centre', 246, '2020-01-16', 106, NULL),
('Sheraton Centre', 246, '2020-01-17', 147, NULL),
('Sheraton Centre', 246, '2020-01-18', 197, NULL),
('Sheraton Centre', 246, '2020-01-19', 277, NULL),
('Sheraton Centre', 246, '2020-01-20', 341, NULL),
('Sheraton Centre', 246, '2020-01-21', 343, NULL),
('Sheraton Centre', 246, '2020-01-22', 241, NULL),
('Sheraton Centre', 246, '2020-01-23', 384, NULL),
('Sheraton Centre', 246, '2020-01-24', 175, NULL),
('Sheraton Centre', 246, '2020-01-25', 218, NULL),
('Sheraton Centre', 246, '2020-01-26', 392, NULL),
('Sheraton Centre', 246, '2020-01-27', 300, NULL),
('Sheraton Centre', 246, '2020-01-28', 127, NULL),
('Sheraton Centre', 246, '2020-01-29', 110, NULL),
('Sheraton Centre', 246, '2020-01-30', 223, NULL),
('Sheraton Centre', 246, '2020-01-31', 140, NULL),
('Sheraton Centre', 246, '2020-02-01', 139, NULL),
('Sheraton Centre', 246, '2020-02-02', 377, NULL),
('Sheraton Centre', 246, '2020-02-03', 338, NULL),
('Sheraton Centre', 246, '2020-02-04', 239, NULL),
('Sheraton Centre', 255, '2019-01-01', 140, NULL),
('Sheraton Centre', 255, '2019-01-02', 274, NULL),
('Sheraton Centre', 255, '2019-01-03', 174, NULL),
('Sheraton Centre', 255, '2019-01-04', 316, NULL),
('Sheraton Centre', 255, '2019-01-05', 130, NULL),
('Sheraton Centre', 255, '2019-01-06', 113, NULL),
('Sheraton Centre', 255, '2019-01-07', 243, NULL),
('Sheraton Centre', 255, '2019-01-08', 363, NULL),
('Sheraton Centre', 255, '2019-01-09', 174, NULL),
('Sheraton Centre', 255, '2019-01-10', 315, NULL),
('Sheraton Centre', 255, '2019-01-11', 102, NULL),
('Sheraton Centre', 255, '2019-01-12', 393, NULL),
('Sheraton Centre', 255, '2019-01-13', 242, NULL),
('Sheraton Centre', 255, '2019-01-14', 297, NULL),
('Sheraton Centre', 255, '2019-01-15', 342, NULL),
('Sheraton Centre', 255, '2019-01-16', 106, NULL),
('Sheraton Centre', 255, '2019-01-17', 188, NULL),
('Sheraton Centre', 255, '2019-01-18', 348, NULL),
('Sheraton Centre', 255, '2019-01-19', 138, NULL),
('Sheraton Centre', 255, '2019-01-20', 113, NULL),
('Sheraton Centre', 255, '2019-01-21', 224, NULL),
('Sheraton Centre', 255, '2019-01-22', 191, NULL),
('Sheraton Centre', 255, '2019-01-23', 127, NULL),
('Sheraton Centre', 255, '2019-01-24', 172, NULL),
('Sheraton Centre', 255, '2019-01-25', 352, NULL),
('Sheraton Centre', 255, '2019-01-26', 313, NULL),
('Sheraton Centre', 255, '2019-01-27', 247, NULL),
('Sheraton Centre', 255, '2019-01-28', 283, NULL),
('Sheraton Centre', 255, '2019-01-29', 176, NULL),
('Sheraton Centre', 255, '2019-01-30', 168, NULL),
('Sheraton Centre', 255, '2019-01-31', 247, NULL),
('Sheraton Centre', 255, '2019-02-01', 246, NULL),
('Sheraton Centre', 255, '2019-02-02', 277, NULL),
('Sheraton Centre', 255, '2019-02-03', 390, NULL),
('Sheraton Centre', 255, '2019-02-04', 381, NULL),
('Sheraton Centre', 255, '2019-02-05', 304, NULL),
('Sheraton Centre', 255, '2019-02-06', 263, NULL),
('Sheraton Centre', 255, '2019-02-07', 189, NULL),
('Sheraton Centre', 255, '2019-02-08', 215, NULL),
('Sheraton Centre', 255, '2019-02-09', 120, NULL),
('Sheraton Centre', 255, '2019-02-10', 111, NULL),
('Sheraton Centre', 255, '2019-02-11', 114, NULL),
('Sheraton Centre', 255, '2019-02-12', 339, NULL),
('Sheraton Centre', 255, '2019-02-13', 194, NULL),
('Sheraton Centre', 255, '2019-02-14', 217, NULL),
('Sheraton Centre', 255, '2019-02-15', 325, NULL),
('Sheraton Centre', 255, '2019-02-16', 262, NULL),
('Sheraton Centre', 255, '2019-02-17', 287, NULL),
('Sheraton Centre', 255, '2019-02-18', 316, NULL),
('Sheraton Centre', 255, '2019-02-19', 220, NULL),
('Sheraton Centre', 255, '2019-02-20', 319, NULL),
('Sheraton Centre', 255, '2019-02-21', 190, NULL),
('Sheraton Centre', 255, '2019-02-22', 324, NULL),
('Sheraton Centre', 255, '2019-02-23', 264, NULL),
('Sheraton Centre', 255, '2019-02-24', 206, NULL),
('Sheraton Centre', 255, '2019-02-25', 179, NULL),
('Sheraton Centre', 255, '2019-02-26', 308, NULL),
('Sheraton Centre', 255, '2019-02-27', 238, NULL),
('Sheraton Centre', 255, '2019-02-28', 177, NULL),
('Sheraton Centre', 255, '2019-03-01', 223, NULL),
('Sheraton Centre', 255, '2019-03-02', 394, NULL),
('Sheraton Centre', 255, '2019-03-03', 187, NULL),
('Sheraton Centre', 255, '2019-03-04', 336, NULL),
('Sheraton Centre', 255, '2019-03-05', 320, NULL),
('Sheraton Centre', 255, '2019-03-06', 155, NULL),
('Sheraton Centre', 255, '2019-03-07', 120, NULL),
('Sheraton Centre', 255, '2019-03-08', 162, NULL),
('Sheraton Centre', 255, '2019-03-09', 151, NULL),
('Sheraton Centre', 255, '2019-03-10', 349, NULL),
('Sheraton Centre', 255, '2019-03-11', 120, NULL),
('Sheraton Centre', 255, '2019-03-12', 393, NULL),
('Sheraton Centre', 255, '2019-03-13', 327, NULL),
('Sheraton Centre', 255, '2019-03-14', 250, NULL),
('Sheraton Centre', 255, '2019-03-15', 135, NULL),
('Sheraton Centre', 255, '2019-03-16', 131, NULL),
('Sheraton Centre', 255, '2019-03-17', 317, NULL),
('Sheraton Centre', 255, '2019-03-18', 357, NULL),
('Sheraton Centre', 255, '2019-03-19', 325, NULL),
('Sheraton Centre', 255, '2019-03-20', 307, NULL),
('Sheraton Centre', 255, '2019-03-21', 357, NULL),
('Sheraton Centre', 255, '2019-03-22', 341, NULL),
('Sheraton Centre', 255, '2019-03-23', 160, NULL),
('Sheraton Centre', 255, '2019-03-24', 216, NULL),
('Sheraton Centre', 255, '2019-03-25', 192, NULL),
('Sheraton Centre', 255, '2019-03-26', 180, NULL),
('Sheraton Centre', 255, '2019-03-27', 165, NULL),
('Sheraton Centre', 255, '2019-03-28', 154, NULL),
('Sheraton Centre', 255, '2019-03-29', 287, NULL),
('Sheraton Centre', 255, '2019-03-30', 332, NULL),
('Sheraton Centre', 255, '2019-03-31', 347, NULL),
('Sheraton Centre', 255, '2019-04-01', 115, NULL),
('Sheraton Centre', 255, '2019-04-02', 199, NULL),
('Sheraton Centre', 255, '2019-04-03', 205, NULL),
('Sheraton Centre', 255, '2019-04-04', 154, NULL),
('Sheraton Centre', 255, '2019-04-05', 265, NULL),
('Sheraton Centre', 255, '2019-04-06', 207, NULL),
('Sheraton Centre', 255, '2019-04-07', 209, NULL),
('Sheraton Centre', 255, '2019-04-08', 105, NULL),
('Sheraton Centre', 255, '2019-04-09', 378, NULL),
('Sheraton Centre', 255, '2019-04-10', 297, NULL),
('Sheraton Centre', 255, '2019-04-11', 147, NULL),
('Sheraton Centre', 255, '2019-04-12', 388, NULL),
('Sheraton Centre', 255, '2019-04-13', 139, NULL),
('Sheraton Centre', 255, '2019-04-14', 112, NULL),
('Sheraton Centre', 255, '2019-04-15', 256, NULL),
('Sheraton Centre', 255, '2019-04-16', 329, NULL),
('Sheraton Centre', 255, '2019-04-17', 203, NULL),
('Sheraton Centre', 255, '2019-04-18', 341, NULL),
('Sheraton Centre', 255, '2019-04-19', 281, NULL),
('Sheraton Centre', 255, '2019-04-20', 225, NULL),
('Sheraton Centre', 255, '2019-04-21', 281, NULL),
('Sheraton Centre', 255, '2019-04-22', 215, NULL),
('Sheraton Centre', 255, '2019-04-23', 214, NULL),
('Sheraton Centre', 255, '2019-04-24', 264, NULL),
('Sheraton Centre', 255, '2019-04-25', 316, NULL),
('Sheraton Centre', 255, '2019-04-26', 314, NULL),
('Sheraton Centre', 255, '2019-04-27', 155, NULL),
('Sheraton Centre', 255, '2019-04-28', 109, NULL),
('Sheraton Centre', 255, '2019-04-29', 149, NULL),
('Sheraton Centre', 255, '2019-04-30', 286, NULL),
('Sheraton Centre', 255, '2019-05-01', 152, NULL),
('Sheraton Centre', 255, '2019-05-02', 319, NULL),
('Sheraton Centre', 255, '2019-05-03', 253, NULL),
('Sheraton Centre', 255, '2019-05-04', 338, NULL),
('Sheraton Centre', 255, '2019-05-05', 204, NULL),
('Sheraton Centre', 255, '2019-05-06', 169, NULL),
('Sheraton Centre', 255, '2019-05-07', 167, NULL),
('Sheraton Centre', 255, '2019-05-08', 209, NULL),
('Sheraton Centre', 255, '2019-05-09', 178, NULL),
('Sheraton Centre', 255, '2019-05-10', 227, NULL),
('Sheraton Centre', 255, '2019-05-11', 206, NULL),
('Sheraton Centre', 255, '2019-05-12', 184, NULL),
('Sheraton Centre', 255, '2019-05-13', 268, NULL),
('Sheraton Centre', 255, '2019-05-14', 334, NULL),
('Sheraton Centre', 255, '2019-05-15', 326, NULL),
('Sheraton Centre', 255, '2019-05-16', 126, NULL),
('Sheraton Centre', 255, '2019-05-17', 114, NULL),
('Sheraton Centre', 255, '2019-05-18', 330, NULL),
('Sheraton Centre', 255, '2019-05-19', 327, NULL),
('Sheraton Centre', 255, '2019-05-20', 177, NULL),
('Sheraton Centre', 255, '2019-05-21', 287, NULL),
('Sheraton Centre', 255, '2019-05-22', 340, NULL),
('Sheraton Centre', 255, '2019-05-23', 196, NULL),
('Sheraton Centre', 255, '2019-05-24', 234, NULL),
('Sheraton Centre', 255, '2019-05-25', 136, NULL),
('Sheraton Centre', 255, '2019-05-26', 339, NULL),
('Sheraton Centre', 255, '2019-05-27', 250, NULL),
('Sheraton Centre', 255, '2019-05-28', 120, NULL),
('Sheraton Centre', 255, '2019-05-29', 212, NULL),
('Sheraton Centre', 255, '2019-05-30', 325, NULL),
('Sheraton Centre', 255, '2019-05-31', 129, NULL),
('Sheraton Centre', 255, '2019-06-01', 264, NULL),
('Sheraton Centre', 255, '2019-06-02', 143, NULL),
('Sheraton Centre', 255, '2019-06-03', 324, NULL),
('Sheraton Centre', 255, '2019-06-04', 334, NULL),
('Sheraton Centre', 255, '2019-06-05', 273, NULL),
('Sheraton Centre', 255, '2019-06-06', 138, NULL),
('Sheraton Centre', 255, '2019-06-07', 103, NULL),
('Sheraton Centre', 255, '2019-06-08', 360, NULL),
('Sheraton Centre', 255, '2019-06-09', 321, NULL),
('Sheraton Centre', 255, '2019-06-10', 247, NULL),
('Sheraton Centre', 255, '2019-06-11', 228, NULL),
('Sheraton Centre', 255, '2019-06-12', 266, NULL),
('Sheraton Centre', 255, '2019-06-13', 353, NULL),
('Sheraton Centre', 255, '2019-06-14', 347, NULL),
('Sheraton Centre', 255, '2019-06-15', 189, NULL),
('Sheraton Centre', 255, '2019-06-16', 243, NULL),
('Sheraton Centre', 255, '2019-06-17', 370, NULL),
('Sheraton Centre', 255, '2019-06-18', 182, NULL),
('Sheraton Centre', 255, '2019-06-19', 208, NULL),
('Sheraton Centre', 255, '2019-06-20', 182, NULL),
('Sheraton Centre', 255, '2019-06-21', 373, NULL),
('Sheraton Centre', 255, '2019-06-22', 218, NULL),
('Sheraton Centre', 255, '2019-06-23', 210, NULL),
('Sheraton Centre', 255, '2019-06-24', 317, NULL),
('Sheraton Centre', 255, '2019-06-25', 248, NULL),
('Sheraton Centre', 255, '2019-06-26', 390, NULL),
('Sheraton Centre', 255, '2019-06-27', 388, NULL),
('Sheraton Centre', 255, '2019-06-28', 261, NULL),
('Sheraton Centre', 255, '2019-06-29', 312, NULL),
('Sheraton Centre', 255, '2019-06-30', 230, NULL),
('Sheraton Centre', 255, '2019-07-01', 280, NULL),
('Sheraton Centre', 255, '2019-07-02', 367, NULL),
('Sheraton Centre', 255, '2019-07-03', 173, NULL),
('Sheraton Centre', 255, '2019-07-04', 124, NULL),
('Sheraton Centre', 255, '2019-07-05', 384, NULL),
('Sheraton Centre', 255, '2019-07-06', 160, NULL),
('Sheraton Centre', 255, '2019-07-07', 219, NULL),
('Sheraton Centre', 255, '2019-07-08', 140, NULL),
('Sheraton Centre', 255, '2019-07-09', 321, NULL),
('Sheraton Centre', 255, '2019-07-10', 355, NULL),
('Sheraton Centre', 255, '2019-07-11', 304, NULL),
('Sheraton Centre', 255, '2019-07-12', 352, NULL),
('Sheraton Centre', 255, '2019-07-13', 376, NULL),
('Sheraton Centre', 255, '2019-07-14', 252, NULL),
('Sheraton Centre', 255, '2019-07-15', 335, NULL),
('Sheraton Centre', 255, '2019-07-16', 187, NULL),
('Sheraton Centre', 255, '2019-07-17', 236, NULL),
('Sheraton Centre', 255, '2019-07-18', 120, NULL),
('Sheraton Centre', 255, '2019-07-19', 326, NULL),
('Sheraton Centre', 255, '2019-07-20', 249, NULL),
('Sheraton Centre', 255, '2019-07-21', 364, NULL),
('Sheraton Centre', 255, '2019-07-22', 397, NULL),
('Sheraton Centre', 255, '2019-07-23', 211, NULL),
('Sheraton Centre', 255, '2019-07-24', 146, NULL),
('Sheraton Centre', 255, '2019-07-25', 368, NULL),
('Sheraton Centre', 255, '2019-07-26', 231, NULL),
('Sheraton Centre', 255, '2019-07-27', 127, NULL),
('Sheraton Centre', 255, '2019-07-28', 181, NULL),
('Sheraton Centre', 255, '2019-07-29', 157, NULL),
('Sheraton Centre', 255, '2019-07-30', 247, NULL),
('Sheraton Centre', 255, '2019-07-31', 151, NULL),
('Sheraton Centre', 255, '2019-08-01', 366, NULL),
('Sheraton Centre', 255, '2019-08-02', 192, NULL),
('Sheraton Centre', 255, '2019-08-03', 344, NULL),
('Sheraton Centre', 255, '2019-08-04', 102, NULL),
('Sheraton Centre', 255, '2019-08-05', 154, NULL),
('Sheraton Centre', 255, '2019-08-06', 118, NULL),
('Sheraton Centre', 255, '2019-08-07', 276, NULL),
('Sheraton Centre', 255, '2019-08-08', 232, NULL),
('Sheraton Centre', 255, '2019-08-09', 137, NULL),
('Sheraton Centre', 255, '2019-08-10', 247, NULL),
('Sheraton Centre', 255, '2019-08-11', 228, NULL),
('Sheraton Centre', 255, '2019-08-12', 321, NULL),
('Sheraton Centre', 255, '2019-08-13', 104, NULL),
('Sheraton Centre', 255, '2019-08-14', 199, NULL),
('Sheraton Centre', 255, '2019-08-15', 155, NULL),
('Sheraton Centre', 255, '2019-08-16', 219, NULL),
('Sheraton Centre', 255, '2019-08-17', 382, NULL),
('Sheraton Centre', 255, '2019-08-18', 283, NULL),
('Sheraton Centre', 255, '2019-08-19', 146, NULL),
('Sheraton Centre', 255, '2019-08-20', 365, NULL),
('Sheraton Centre', 255, '2019-08-21', 230, NULL),
('Sheraton Centre', 255, '2019-08-22', 215, NULL),
('Sheraton Centre', 255, '2019-08-23', 220, NULL),
('Sheraton Centre', 255, '2019-08-24', 223, NULL),
('Sheraton Centre', 255, '2019-08-25', 179, NULL),
('Sheraton Centre', 255, '2019-08-26', 154, NULL),
('Sheraton Centre', 255, '2019-08-27', 384, NULL),
('Sheraton Centre', 255, '2019-08-28', 103, NULL),
('Sheraton Centre', 255, '2019-08-29', 362, NULL),
('Sheraton Centre', 255, '2019-08-30', 347, NULL),
('Sheraton Centre', 255, '2019-08-31', 149, NULL),
('Sheraton Centre', 255, '2019-09-01', 234, NULL),
('Sheraton Centre', 255, '2019-09-02', 189, NULL),
('Sheraton Centre', 255, '2019-09-03', 221, NULL),
('Sheraton Centre', 255, '2019-09-04', 138, NULL),
('Sheraton Centre', 255, '2019-09-05', 175, NULL),
('Sheraton Centre', 255, '2019-09-06', 265, NULL),
('Sheraton Centre', 255, '2019-09-07', 263, NULL),
('Sheraton Centre', 255, '2019-09-08', 344, NULL),
('Sheraton Centre', 255, '2019-09-09', 165, NULL),
('Sheraton Centre', 255, '2019-09-10', 364, NULL),
('Sheraton Centre', 255, '2019-09-11', 329, NULL),
('Sheraton Centre', 255, '2019-09-12', 168, NULL),
('Sheraton Centre', 255, '2019-09-13', 267, NULL),
('Sheraton Centre', 255, '2019-09-14', 240, NULL),
('Sheraton Centre', 255, '2019-09-15', 296, NULL),
('Sheraton Centre', 255, '2019-09-16', 219, NULL),
('Sheraton Centre', 255, '2019-09-17', 225, NULL),
('Sheraton Centre', 255, '2019-09-18', 326, NULL),
('Sheraton Centre', 255, '2019-09-19', 259, NULL),
('Sheraton Centre', 255, '2019-09-20', 157, NULL),
('Sheraton Centre', 255, '2019-09-21', 339, NULL),
('Sheraton Centre', 255, '2019-09-22', 172, NULL),
('Sheraton Centre', 255, '2019-09-23', 159, NULL),
('Sheraton Centre', 255, '2019-09-24', 332, NULL),
('Sheraton Centre', 255, '2019-09-25', 180, NULL),
('Sheraton Centre', 255, '2019-09-26', 113, NULL),
('Sheraton Centre', 255, '2019-09-27', 134, NULL),
('Sheraton Centre', 255, '2019-09-28', 164, NULL),
('Sheraton Centre', 255, '2019-09-29', 393, NULL),
('Sheraton Centre', 255, '2019-09-30', 152, NULL),
('Sheraton Centre', 255, '2019-10-01', 142, NULL),
('Sheraton Centre', 255, '2019-10-02', 388, NULL),
('Sheraton Centre', 255, '2019-10-03', 199, NULL),
('Sheraton Centre', 255, '2019-10-04', 166, NULL),
('Sheraton Centre', 255, '2019-10-05', 147, NULL),
('Sheraton Centre', 255, '2019-10-06', 194, NULL),
('Sheraton Centre', 255, '2019-10-07', 270, NULL),
('Sheraton Centre', 255, '2019-10-08', 259, NULL),
('Sheraton Centre', 255, '2019-10-09', 305, NULL),
('Sheraton Centre', 255, '2019-10-10', 373, NULL),
('Sheraton Centre', 255, '2019-10-11', 346, NULL),
('Sheraton Centre', 255, '2019-10-12', 259, NULL),
('Sheraton Centre', 255, '2019-10-13', 126, NULL),
('Sheraton Centre', 255, '2019-10-14', 293, NULL),
('Sheraton Centre', 255, '2019-10-15', 191, NULL),
('Sheraton Centre', 255, '2019-10-16', 393, NULL),
('Sheraton Centre', 255, '2019-10-17', 204, NULL),
('Sheraton Centre', 255, '2019-10-18', 267, NULL),
('Sheraton Centre', 255, '2019-10-19', 268, NULL),
('Sheraton Centre', 255, '2019-10-20', 235, NULL),
('Sheraton Centre', 255, '2019-10-21', 116, NULL),
('Sheraton Centre', 255, '2019-10-22', 317, NULL),
('Sheraton Centre', 255, '2019-10-23', 160, NULL),
('Sheraton Centre', 255, '2019-10-24', 141, NULL),
('Sheraton Centre', 255, '2019-10-25', 150, NULL),
('Sheraton Centre', 255, '2019-10-26', 197, NULL),
('Sheraton Centre', 255, '2019-10-27', 187, NULL),
('Sheraton Centre', 255, '2019-10-28', 134, NULL),
('Sheraton Centre', 255, '2019-10-29', 134, NULL),
('Sheraton Centre', 255, '2019-10-30', 237, NULL),
('Sheraton Centre', 255, '2019-10-31', 178, NULL),
('Sheraton Centre', 255, '2019-11-01', 246, NULL),
('Sheraton Centre', 255, '2019-11-02', 182, NULL),
('Sheraton Centre', 255, '2019-11-03', 153, NULL),
('Sheraton Centre', 255, '2019-11-04', 273, NULL),
('Sheraton Centre', 255, '2019-11-05', 155, NULL),
('Sheraton Centre', 255, '2019-11-06', 232, NULL),
('Sheraton Centre', 255, '2019-11-07', 326, NULL),
('Sheraton Centre', 255, '2019-11-08', 257, NULL),
('Sheraton Centre', 255, '2019-11-09', 207, NULL),
('Sheraton Centre', 255, '2019-11-10', 282, NULL),
('Sheraton Centre', 255, '2019-11-11', 380, NULL),
('Sheraton Centre', 255, '2019-11-12', 135, NULL),
('Sheraton Centre', 255, '2019-11-13', 311, NULL),
('Sheraton Centre', 255, '2019-11-14', 314, NULL),
('Sheraton Centre', 255, '2019-11-15', 140, NULL),
('Sheraton Centre', 255, '2019-11-16', 190, NULL),
('Sheraton Centre', 255, '2019-11-17', 279, NULL),
('Sheraton Centre', 255, '2019-11-18', 225, NULL),
('Sheraton Centre', 255, '2019-11-19', 246, NULL),
('Sheraton Centre', 255, '2019-11-20', 261, NULL),
('Sheraton Centre', 255, '2019-11-21', 130, NULL),
('Sheraton Centre', 255, '2019-11-22', 201, NULL),
('Sheraton Centre', 255, '2019-11-23', 324, NULL),
('Sheraton Centre', 255, '2019-11-24', 203, NULL),
('Sheraton Centre', 255, '2019-11-25', 334, NULL),
('Sheraton Centre', 255, '2019-11-26', 226, NULL),
('Sheraton Centre', 255, '2019-11-27', 326, NULL),
('Sheraton Centre', 255, '2019-11-28', 353, NULL),
('Sheraton Centre', 255, '2019-11-29', 281, NULL),
('Sheraton Centre', 255, '2019-11-30', 222, NULL),
('Sheraton Centre', 255, '2019-12-01', 270, NULL),
('Sheraton Centre', 255, '2019-12-02', 396, NULL),
('Sheraton Centre', 255, '2019-12-03', 176, NULL),
('Sheraton Centre', 255, '2019-12-04', 289, NULL),
('Sheraton Centre', 255, '2019-12-05', 340, NULL),
('Sheraton Centre', 255, '2019-12-06', 227, NULL),
('Sheraton Centre', 255, '2019-12-07', 367, NULL),
('Sheraton Centre', 255, '2019-12-08', 221, NULL),
('Sheraton Centre', 255, '2019-12-09', 162, NULL),
('Sheraton Centre', 255, '2019-12-10', 198, NULL),
('Sheraton Centre', 255, '2019-12-11', 378, NULL),
('Sheraton Centre', 255, '2019-12-12', 313, NULL),
('Sheraton Centre', 255, '2019-12-13', 181, NULL),
('Sheraton Centre', 255, '2019-12-14', 119, NULL),
('Sheraton Centre', 255, '2019-12-15', 255, NULL),
('Sheraton Centre', 255, '2019-12-16', 389, NULL),
('Sheraton Centre', 255, '2019-12-17', 157, NULL),
('Sheraton Centre', 255, '2019-12-18', 231, NULL),
('Sheraton Centre', 255, '2019-12-19', 364, NULL),
('Sheraton Centre', 255, '2019-12-20', 375, NULL),
('Sheraton Centre', 255, '2019-12-21', 232, NULL),
('Sheraton Centre', 255, '2019-12-22', 212, NULL),
('Sheraton Centre', 255, '2019-12-23', 236, NULL),
('Sheraton Centre', 255, '2019-12-24', 181, NULL),
('Sheraton Centre', 255, '2019-12-25', 282, NULL),
('Sheraton Centre', 255, '2019-12-26', 191, NULL),
('Sheraton Centre', 255, '2019-12-27', 398, NULL),
('Sheraton Centre', 255, '2019-12-28', 360, NULL),
('Sheraton Centre', 255, '2019-12-29', 304, NULL),
('Sheraton Centre', 255, '2019-12-30', 181, NULL),
('Sheraton Centre', 255, '2019-12-31', 386, NULL),
('Sheraton Centre', 255, '2020-01-01', 312, NULL),
('Sheraton Centre', 255, '2020-01-02', 116, NULL),
('Sheraton Centre', 255, '2020-01-03', 225, NULL),
('Sheraton Centre', 255, '2020-01-04', 106, NULL),
('Sheraton Centre', 255, '2020-01-05', 318, NULL),
('Sheraton Centre', 255, '2020-01-06', 196, NULL),
('Sheraton Centre', 255, '2020-01-07', 275, NULL),
('Sheraton Centre', 255, '2020-01-08', 371, NULL),
('Sheraton Centre', 255, '2020-01-09', 380, NULL),
('Sheraton Centre', 255, '2020-01-10', 343, NULL),
('Sheraton Centre', 255, '2020-01-11', 192, NULL),
('Sheraton Centre', 255, '2020-01-12', 345, NULL),
('Sheraton Centre', 255, '2020-01-13', 326, NULL),
('Sheraton Centre', 255, '2020-01-14', 239, NULL),
('Sheraton Centre', 255, '2020-01-15', 115, NULL),
('Sheraton Centre', 255, '2020-01-16', 320, NULL),
('Sheraton Centre', 255, '2020-01-17', 133, NULL),
('Sheraton Centre', 255, '2020-01-18', 127, NULL),
('Sheraton Centre', 255, '2020-01-19', 185, NULL),
('Sheraton Centre', 255, '2020-01-20', 107, NULL),
('Sheraton Centre', 255, '2020-01-21', 218, NULL),
('Sheraton Centre', 255, '2020-01-22', 241, NULL),
('Sheraton Centre', 255, '2020-01-23', 145, NULL),
('Sheraton Centre', 255, '2020-01-24', 354, NULL),
('Sheraton Centre', 255, '2020-01-25', 208, NULL),
('Sheraton Centre', 255, '2020-01-26', 373, NULL),
('Sheraton Centre', 255, '2020-01-27', 276, NULL),
('Sheraton Centre', 255, '2020-01-28', 246, NULL),
('Sheraton Centre', 255, '2020-01-29', 244, NULL),
('Sheraton Centre', 255, '2020-01-30', 395, NULL),
('Sheraton Centre', 255, '2020-01-31', 184, NULL),
('Sheraton Centre', 255, '2020-02-01', 220, NULL),
('Sheraton Centre', 255, '2020-02-02', 331, NULL),
('Sheraton Centre', 255, '2020-02-03', 179, NULL),
('Sheraton Centre', 255, '2020-02-04', 210, NULL),
('Sheraton Centre', 262, '2019-01-01', 277, NULL),
('Sheraton Centre', 262, '2019-01-02', 162, NULL),
('Sheraton Centre', 262, '2019-01-03', 249, NULL),
('Sheraton Centre', 262, '2019-01-04', 294, NULL),
('Sheraton Centre', 262, '2019-01-05', 157, NULL),
('Sheraton Centre', 262, '2019-01-06', 231, NULL),
('Sheraton Centre', 262, '2019-01-07', 357, NULL),
('Sheraton Centre', 262, '2019-01-08', 364, NULL),
('Sheraton Centre', 262, '2019-01-09', 250, NULL),
('Sheraton Centre', 262, '2019-01-10', 248, NULL),
('Sheraton Centre', 262, '2019-01-11', 359, NULL),
('Sheraton Centre', 262, '2019-01-12', 330, NULL),
('Sheraton Centre', 262, '2019-01-13', 273, NULL),
('Sheraton Centre', 262, '2019-01-14', 118, NULL),
('Sheraton Centre', 262, '2019-01-15', 311, NULL),
('Sheraton Centre', 262, '2019-01-16', 270, NULL),
('Sheraton Centre', 262, '2019-01-17', 290, NULL),
('Sheraton Centre', 262, '2019-01-18', 399, NULL),
('Sheraton Centre', 262, '2019-01-19', 356, NULL),
('Sheraton Centre', 262, '2019-01-20', 227, NULL),
('Sheraton Centre', 262, '2019-01-21', 378, NULL),
('Sheraton Centre', 262, '2019-01-22', 180, NULL),
('Sheraton Centre', 262, '2019-01-23', 144, NULL),
('Sheraton Centre', 262, '2019-01-24', 311, NULL),
('Sheraton Centre', 262, '2019-01-25', 346, NULL),
('Sheraton Centre', 262, '2019-01-26', 361, NULL),
('Sheraton Centre', 262, '2019-01-27', 248, NULL),
('Sheraton Centre', 262, '2019-01-28', 283, NULL),
('Sheraton Centre', 262, '2019-01-29', 353, NULL),
('Sheraton Centre', 262, '2019-01-30', 153, NULL),
('Sheraton Centre', 262, '2019-01-31', 224, NULL),
('Sheraton Centre', 262, '2019-02-01', 157, NULL),
('Sheraton Centre', 262, '2019-02-02', 290, NULL),
('Sheraton Centre', 262, '2019-02-03', 316, NULL),
('Sheraton Centre', 262, '2019-02-04', 102, NULL),
('Sheraton Centre', 262, '2019-02-05', 101, NULL),
('Sheraton Centre', 262, '2019-02-06', 244, NULL),
('Sheraton Centre', 262, '2019-02-07', 291, NULL),
('Sheraton Centre', 262, '2019-02-08', 209, NULL),
('Sheraton Centre', 262, '2019-02-09', 135, NULL),
('Sheraton Centre', 262, '2019-02-10', 127, NULL),
('Sheraton Centre', 262, '2019-02-11', 368, NULL),
('Sheraton Centre', 262, '2019-02-12', 366, NULL),
('Sheraton Centre', 262, '2019-02-13', 148, NULL),
('Sheraton Centre', 262, '2019-02-14', 119, NULL),
('Sheraton Centre', 262, '2019-02-15', 119, NULL),
('Sheraton Centre', 262, '2019-02-16', 167, NULL),
('Sheraton Centre', 262, '2019-02-17', 166, NULL),
('Sheraton Centre', 262, '2019-02-18', 151, NULL),
('Sheraton Centre', 262, '2019-02-19', 194, NULL),
('Sheraton Centre', 262, '2019-02-20', 279, NULL),
('Sheraton Centre', 262, '2019-02-21', 352, NULL),
('Sheraton Centre', 262, '2019-02-22', 399, NULL),
('Sheraton Centre', 262, '2019-02-23', 235, NULL),
('Sheraton Centre', 262, '2019-02-24', 188, NULL),
('Sheraton Centre', 262, '2019-02-25', 134, NULL),
('Sheraton Centre', 262, '2019-02-26', 362, NULL),
('Sheraton Centre', 262, '2019-02-27', 120, NULL),
('Sheraton Centre', 262, '2019-02-28', 226, NULL),
('Sheraton Centre', 262, '2019-03-01', 166, NULL),
('Sheraton Centre', 262, '2019-03-02', 300, NULL),
('Sheraton Centre', 262, '2019-03-03', 246, NULL),
('Sheraton Centre', 262, '2019-03-04', 157, NULL),
('Sheraton Centre', 262, '2019-03-05', 344, NULL),
('Sheraton Centre', 262, '2019-03-06', 300, NULL),
('Sheraton Centre', 262, '2019-03-07', 297, NULL),
('Sheraton Centre', 262, '2019-03-08', 161, NULL),
('Sheraton Centre', 262, '2019-03-09', 395, NULL),
('Sheraton Centre', 262, '2019-03-10', 139, NULL),
('Sheraton Centre', 262, '2019-03-11', 119, NULL),
('Sheraton Centre', 262, '2019-03-12', 359, NULL),
('Sheraton Centre', 262, '2019-03-13', 341, NULL),
('Sheraton Centre', 262, '2019-03-14', 138, NULL),
('Sheraton Centre', 262, '2019-03-15', 324, NULL),
('Sheraton Centre', 262, '2019-03-16', 108, NULL),
('Sheraton Centre', 262, '2019-03-17', 261, NULL),
('Sheraton Centre', 262, '2019-03-18', 214, NULL),
('Sheraton Centre', 262, '2019-03-19', 275, NULL),
('Sheraton Centre', 262, '2019-03-20', 353, NULL),
('Sheraton Centre', 262, '2019-03-21', 362, NULL),
('Sheraton Centre', 262, '2019-03-22', 336, NULL),
('Sheraton Centre', 262, '2019-03-23', 365, NULL),
('Sheraton Centre', 262, '2019-03-24', 337, NULL),
('Sheraton Centre', 262, '2019-03-25', 369, NULL),
('Sheraton Centre', 262, '2019-03-26', 127, NULL),
('Sheraton Centre', 262, '2019-03-27', 305, NULL),
('Sheraton Centre', 262, '2019-03-28', 179, NULL),
('Sheraton Centre', 262, '2019-03-29', 256, NULL),
('Sheraton Centre', 262, '2019-03-30', 341, NULL),
('Sheraton Centre', 262, '2019-03-31', 150, NULL),
('Sheraton Centre', 262, '2019-04-01', 341, NULL),
('Sheraton Centre', 262, '2019-04-02', 288, NULL),
('Sheraton Centre', 262, '2019-04-03', 321, NULL),
('Sheraton Centre', 262, '2019-04-04', 187, NULL),
('Sheraton Centre', 262, '2019-04-05', 135, NULL),
('Sheraton Centre', 262, '2019-04-06', 294, NULL),
('Sheraton Centre', 262, '2019-04-07', 173, NULL),
('Sheraton Centre', 262, '2019-04-08', 185, NULL),
('Sheraton Centre', 262, '2019-04-09', 360, NULL),
('Sheraton Centre', 262, '2019-04-10', 101, NULL),
('Sheraton Centre', 262, '2019-04-11', 380, NULL),
('Sheraton Centre', 262, '2019-04-12', 297, NULL),
('Sheraton Centre', 262, '2019-04-13', 344, NULL),
('Sheraton Centre', 262, '2019-04-14', 122, NULL),
('Sheraton Centre', 262, '2019-04-15', 225, NULL),
('Sheraton Centre', 262, '2019-04-16', 227, NULL),
('Sheraton Centre', 262, '2019-04-17', 310, NULL),
('Sheraton Centre', 262, '2019-04-18', 117, NULL),
('Sheraton Centre', 262, '2019-04-19', 145, NULL),
('Sheraton Centre', 262, '2019-04-20', 214, NULL),
('Sheraton Centre', 262, '2019-04-21', 308, NULL),
('Sheraton Centre', 262, '2019-04-22', 243, NULL),
('Sheraton Centre', 262, '2019-04-23', 207, NULL),
('Sheraton Centre', 262, '2019-04-24', 185, NULL),
('Sheraton Centre', 262, '2019-04-25', 234, NULL),
('Sheraton Centre', 262, '2019-04-26', 308, NULL),
('Sheraton Centre', 262, '2019-04-27', 188, NULL),
('Sheraton Centre', 262, '2019-04-28', 374, NULL),
('Sheraton Centre', 262, '2019-04-29', 280, NULL),
('Sheraton Centre', 262, '2019-04-30', 326, NULL),
('Sheraton Centre', 262, '2019-05-01', 102, NULL),
('Sheraton Centre', 262, '2019-05-02', 312, NULL),
('Sheraton Centre', 262, '2019-05-03', 219, NULL),
('Sheraton Centre', 262, '2019-05-04', 357, NULL),
('Sheraton Centre', 262, '2019-05-05', 389, NULL),
('Sheraton Centre', 262, '2019-05-06', 322, NULL),
('Sheraton Centre', 262, '2019-05-07', 388, NULL),
('Sheraton Centre', 262, '2019-05-08', 390, NULL),
('Sheraton Centre', 262, '2019-05-09', 140, NULL),
('Sheraton Centre', 262, '2019-05-10', 110, NULL),
('Sheraton Centre', 262, '2019-05-11', 398, NULL),
('Sheraton Centre', 262, '2019-05-12', 238, NULL),
('Sheraton Centre', 262, '2019-05-13', 317, NULL),
('Sheraton Centre', 262, '2019-05-14', 230, NULL),
('Sheraton Centre', 262, '2019-05-15', 235, NULL),
('Sheraton Centre', 262, '2019-05-16', 363, NULL),
('Sheraton Centre', 262, '2019-05-17', 234, NULL),
('Sheraton Centre', 262, '2019-05-18', 284, NULL),
('Sheraton Centre', 262, '2019-05-19', 227, NULL),
('Sheraton Centre', 262, '2019-05-20', 280, NULL),
('Sheraton Centre', 262, '2019-05-21', 164, NULL),
('Sheraton Centre', 262, '2019-05-22', 255, NULL),
('Sheraton Centre', 262, '2019-05-23', 219, NULL),
('Sheraton Centre', 262, '2019-05-24', 260, NULL),
('Sheraton Centre', 262, '2019-05-25', 372, NULL),
('Sheraton Centre', 262, '2019-05-26', 143, NULL),
('Sheraton Centre', 262, '2019-05-27', 344, NULL),
('Sheraton Centre', 262, '2019-05-28', 328, NULL),
('Sheraton Centre', 262, '2019-05-29', 253, NULL),
('Sheraton Centre', 262, '2019-05-30', 397, NULL),
('Sheraton Centre', 262, '2019-05-31', 133, NULL),
('Sheraton Centre', 262, '2019-06-01', 250, NULL),
('Sheraton Centre', 262, '2019-06-02', 161, NULL),
('Sheraton Centre', 262, '2019-06-03', 301, NULL),
('Sheraton Centre', 262, '2019-06-04', 231, NULL),
('Sheraton Centre', 262, '2019-06-05', 147, NULL),
('Sheraton Centre', 262, '2019-06-06', 159, NULL),
('Sheraton Centre', 262, '2019-06-07', 329, NULL),
('Sheraton Centre', 262, '2019-06-08', 117, NULL),
('Sheraton Centre', 262, '2019-06-09', 218, NULL),
('Sheraton Centre', 262, '2019-06-10', 229, NULL),
('Sheraton Centre', 262, '2019-06-11', 147, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 262, '2019-06-12', 323, NULL),
('Sheraton Centre', 262, '2019-06-13', 285, NULL),
('Sheraton Centre', 262, '2019-06-14', 337, NULL),
('Sheraton Centre', 262, '2019-06-15', 343, NULL),
('Sheraton Centre', 262, '2019-06-16', 126, NULL),
('Sheraton Centre', 262, '2019-06-17', 322, NULL),
('Sheraton Centre', 262, '2019-06-18', 277, NULL),
('Sheraton Centre', 262, '2019-06-19', 279, NULL),
('Sheraton Centre', 262, '2019-06-20', 394, NULL),
('Sheraton Centre', 262, '2019-06-21', 323, NULL),
('Sheraton Centre', 262, '2019-06-22', 204, NULL),
('Sheraton Centre', 262, '2019-06-23', 386, NULL),
('Sheraton Centre', 262, '2019-06-24', 331, NULL),
('Sheraton Centre', 262, '2019-06-25', 241, NULL),
('Sheraton Centre', 262, '2019-06-26', 193, NULL),
('Sheraton Centre', 262, '2019-06-27', 149, NULL),
('Sheraton Centre', 262, '2019-06-28', 322, NULL),
('Sheraton Centre', 262, '2019-06-29', 320, NULL),
('Sheraton Centre', 262, '2019-06-30', 144, NULL),
('Sheraton Centre', 262, '2019-07-01', 149, NULL),
('Sheraton Centre', 262, '2019-07-02', 157, NULL),
('Sheraton Centre', 262, '2019-07-03', 248, NULL),
('Sheraton Centre', 262, '2019-07-04', 389, NULL),
('Sheraton Centre', 262, '2019-07-05', 316, NULL),
('Sheraton Centre', 262, '2019-07-06', 106, NULL),
('Sheraton Centre', 262, '2019-07-07', 126, NULL),
('Sheraton Centre', 262, '2019-07-08', 153, NULL),
('Sheraton Centre', 262, '2019-07-09', 129, NULL),
('Sheraton Centre', 262, '2019-07-10', 298, NULL),
('Sheraton Centre', 262, '2019-07-11', 260, NULL),
('Sheraton Centre', 262, '2019-07-12', 352, NULL),
('Sheraton Centre', 262, '2019-07-13', 137, NULL),
('Sheraton Centre', 262, '2019-07-14', 325, NULL),
('Sheraton Centre', 262, '2019-07-15', 116, NULL),
('Sheraton Centre', 262, '2019-07-16', 104, NULL),
('Sheraton Centre', 262, '2019-07-17', 219, NULL),
('Sheraton Centre', 262, '2019-07-18', 195, NULL),
('Sheraton Centre', 262, '2019-07-19', 276, NULL),
('Sheraton Centre', 262, '2019-07-20', 201, NULL),
('Sheraton Centre', 262, '2019-07-21', 339, NULL),
('Sheraton Centre', 262, '2019-07-22', 301, NULL),
('Sheraton Centre', 262, '2019-07-23', 123, NULL),
('Sheraton Centre', 262, '2019-07-24', 233, NULL),
('Sheraton Centre', 262, '2019-07-25', 202, NULL),
('Sheraton Centre', 262, '2019-07-26', 226, NULL),
('Sheraton Centre', 262, '2019-07-27', 386, NULL),
('Sheraton Centre', 262, '2019-07-28', 179, NULL),
('Sheraton Centre', 262, '2019-07-29', 336, NULL),
('Sheraton Centre', 262, '2019-07-30', 259, NULL),
('Sheraton Centre', 262, '2019-07-31', 318, NULL),
('Sheraton Centre', 262, '2019-08-01', 144, NULL),
('Sheraton Centre', 262, '2019-08-02', 309, NULL),
('Sheraton Centre', 262, '2019-08-03', 201, NULL),
('Sheraton Centre', 262, '2019-08-04', 246, NULL),
('Sheraton Centre', 262, '2019-08-05', 363, NULL),
('Sheraton Centre', 262, '2019-08-06', 129, NULL),
('Sheraton Centre', 262, '2019-08-07', 291, NULL),
('Sheraton Centre', 262, '2019-08-08', 316, NULL),
('Sheraton Centre', 262, '2019-08-09', 233, NULL),
('Sheraton Centre', 262, '2019-08-10', 393, NULL),
('Sheraton Centre', 262, '2019-08-11', 119, NULL),
('Sheraton Centre', 262, '2019-08-12', 276, NULL),
('Sheraton Centre', 262, '2019-08-13', 123, NULL),
('Sheraton Centre', 262, '2019-08-14', 360, NULL),
('Sheraton Centre', 262, '2019-08-15', 300, NULL),
('Sheraton Centre', 262, '2019-08-16', 154, NULL),
('Sheraton Centre', 262, '2019-08-17', 239, NULL),
('Sheraton Centre', 262, '2019-08-18', 159, NULL),
('Sheraton Centre', 262, '2019-08-19', 157, NULL),
('Sheraton Centre', 262, '2019-08-20', 309, NULL),
('Sheraton Centre', 262, '2019-08-21', 108, NULL),
('Sheraton Centre', 262, '2019-08-22', 263, NULL),
('Sheraton Centre', 262, '2019-08-23', 248, NULL),
('Sheraton Centre', 262, '2019-08-24', 234, NULL),
('Sheraton Centre', 262, '2019-08-25', 129, NULL),
('Sheraton Centre', 262, '2019-08-26', 216, NULL),
('Sheraton Centre', 262, '2019-08-27', 131, NULL),
('Sheraton Centre', 262, '2019-08-28', 184, NULL),
('Sheraton Centre', 262, '2019-08-29', 337, NULL),
('Sheraton Centre', 262, '2019-08-30', 196, NULL),
('Sheraton Centre', 262, '2019-08-31', 368, NULL),
('Sheraton Centre', 262, '2019-09-01', 351, NULL),
('Sheraton Centre', 262, '2019-09-02', 269, NULL),
('Sheraton Centre', 262, '2019-09-03', 100, NULL),
('Sheraton Centre', 262, '2019-09-04', 302, NULL),
('Sheraton Centre', 262, '2019-09-05', 338, NULL),
('Sheraton Centre', 262, '2019-09-06', 233, NULL),
('Sheraton Centre', 262, '2019-09-07', 394, NULL),
('Sheraton Centre', 262, '2019-09-08', 109, NULL),
('Sheraton Centre', 262, '2019-09-09', 119, NULL),
('Sheraton Centre', 262, '2019-09-10', 297, NULL),
('Sheraton Centre', 262, '2019-09-11', 250, NULL),
('Sheraton Centre', 262, '2019-09-12', 389, NULL),
('Sheraton Centre', 262, '2019-09-13', 160, NULL),
('Sheraton Centre', 262, '2019-09-14', 272, NULL),
('Sheraton Centre', 262, '2019-09-15', 183, NULL),
('Sheraton Centre', 262, '2019-09-16', 102, NULL),
('Sheraton Centre', 262, '2019-09-17', 372, NULL),
('Sheraton Centre', 262, '2019-09-18', 175, NULL),
('Sheraton Centre', 262, '2019-09-19', 111, NULL),
('Sheraton Centre', 262, '2019-09-20', 304, NULL),
('Sheraton Centre', 262, '2019-09-21', 375, NULL),
('Sheraton Centre', 262, '2019-09-22', 136, NULL),
('Sheraton Centre', 262, '2019-09-23', 309, NULL),
('Sheraton Centre', 262, '2019-09-24', 399, NULL),
('Sheraton Centre', 262, '2019-09-25', 177, NULL),
('Sheraton Centre', 262, '2019-09-26', 252, NULL),
('Sheraton Centre', 262, '2019-09-27', 176, NULL),
('Sheraton Centre', 262, '2019-09-28', 389, NULL),
('Sheraton Centre', 262, '2019-09-29', 261, NULL),
('Sheraton Centre', 262, '2019-09-30', 147, NULL),
('Sheraton Centre', 262, '2019-10-01', 312, NULL),
('Sheraton Centre', 262, '2019-10-02', 291, NULL),
('Sheraton Centre', 262, '2019-10-03', 177, NULL),
('Sheraton Centre', 262, '2019-10-04', 328, NULL),
('Sheraton Centre', 262, '2019-10-05', 337, NULL),
('Sheraton Centre', 262, '2019-10-06', 381, NULL),
('Sheraton Centre', 262, '2019-10-07', 269, NULL),
('Sheraton Centre', 262, '2019-10-08', 156, NULL),
('Sheraton Centre', 262, '2019-10-09', 391, NULL),
('Sheraton Centre', 262, '2019-10-10', 121, NULL),
('Sheraton Centre', 262, '2019-10-11', 129, NULL),
('Sheraton Centre', 262, '2019-10-12', 150, NULL),
('Sheraton Centre', 262, '2019-10-13', 190, NULL),
('Sheraton Centre', 262, '2019-10-14', 291, NULL),
('Sheraton Centre', 262, '2019-10-15', 398, NULL),
('Sheraton Centre', 262, '2019-10-16', 288, NULL),
('Sheraton Centre', 262, '2019-10-17', 140, NULL),
('Sheraton Centre', 262, '2019-10-18', 143, NULL),
('Sheraton Centre', 262, '2019-10-19', 348, NULL),
('Sheraton Centre', 262, '2019-10-20', 270, NULL),
('Sheraton Centre', 262, '2019-10-21', 103, NULL),
('Sheraton Centre', 262, '2019-10-22', 164, NULL),
('Sheraton Centre', 262, '2019-10-23', 335, NULL),
('Sheraton Centre', 262, '2019-10-24', 137, NULL),
('Sheraton Centre', 262, '2019-10-25', 183, NULL),
('Sheraton Centre', 262, '2019-10-26', 127, NULL),
('Sheraton Centre', 262, '2019-10-27', 180, NULL),
('Sheraton Centre', 262, '2019-10-28', 124, NULL),
('Sheraton Centre', 262, '2019-10-29', 176, NULL),
('Sheraton Centre', 262, '2019-10-30', 222, NULL),
('Sheraton Centre', 262, '2019-10-31', 236, NULL),
('Sheraton Centre', 262, '2019-11-01', 346, NULL),
('Sheraton Centre', 262, '2019-11-02', 347, NULL),
('Sheraton Centre', 262, '2019-11-03', 221, NULL),
('Sheraton Centre', 262, '2019-11-04', 341, NULL),
('Sheraton Centre', 262, '2019-11-05', 180, NULL),
('Sheraton Centre', 262, '2019-11-06', 140, NULL),
('Sheraton Centre', 262, '2019-11-07', 344, NULL),
('Sheraton Centre', 262, '2019-11-08', 145, NULL),
('Sheraton Centre', 262, '2019-11-09', 374, NULL),
('Sheraton Centre', 262, '2019-11-10', 261, NULL),
('Sheraton Centre', 262, '2019-11-11', 352, NULL),
('Sheraton Centre', 262, '2019-11-12', 299, NULL),
('Sheraton Centre', 262, '2019-11-13', 112, NULL),
('Sheraton Centre', 262, '2019-11-14', 153, NULL),
('Sheraton Centre', 262, '2019-11-15', 173, NULL),
('Sheraton Centre', 262, '2019-11-16', 249, NULL),
('Sheraton Centre', 262, '2019-11-17', 290, NULL),
('Sheraton Centre', 262, '2019-11-18', 207, NULL),
('Sheraton Centre', 262, '2019-11-19', 388, NULL),
('Sheraton Centre', 262, '2019-11-20', 312, NULL),
('Sheraton Centre', 262, '2019-11-21', 320, NULL),
('Sheraton Centre', 262, '2019-11-22', 172, NULL),
('Sheraton Centre', 262, '2019-11-23', 249, NULL),
('Sheraton Centre', 262, '2019-11-24', 103, NULL),
('Sheraton Centre', 262, '2019-11-25', 292, NULL),
('Sheraton Centre', 262, '2019-11-26', 136, NULL),
('Sheraton Centre', 262, '2019-11-27', 374, NULL),
('Sheraton Centre', 262, '2019-11-28', 373, NULL),
('Sheraton Centre', 262, '2019-11-29', 314, NULL),
('Sheraton Centre', 262, '2019-11-30', 197, NULL),
('Sheraton Centre', 262, '2019-12-01', 203, NULL),
('Sheraton Centre', 262, '2019-12-02', 180, NULL),
('Sheraton Centre', 262, '2019-12-03', 316, NULL),
('Sheraton Centre', 262, '2019-12-04', 303, NULL),
('Sheraton Centre', 262, '2019-12-05', 250, NULL),
('Sheraton Centre', 262, '2019-12-06', 192, NULL),
('Sheraton Centre', 262, '2019-12-07', 309, NULL),
('Sheraton Centre', 262, '2019-12-08', 118, NULL),
('Sheraton Centre', 262, '2019-12-09', 397, NULL),
('Sheraton Centre', 262, '2019-12-10', 318, NULL),
('Sheraton Centre', 262, '2019-12-11', 391, NULL),
('Sheraton Centre', 262, '2019-12-12', 133, NULL),
('Sheraton Centre', 262, '2019-12-13', 171, NULL),
('Sheraton Centre', 262, '2019-12-14', 294, NULL),
('Sheraton Centre', 262, '2019-12-15', 346, NULL),
('Sheraton Centre', 262, '2019-12-16', 382, NULL),
('Sheraton Centre', 262, '2019-12-17', 207, NULL),
('Sheraton Centre', 262, '2019-12-18', 142, NULL),
('Sheraton Centre', 262, '2019-12-19', 229, NULL),
('Sheraton Centre', 262, '2019-12-20', 363, NULL),
('Sheraton Centre', 262, '2019-12-21', 291, NULL),
('Sheraton Centre', 262, '2019-12-22', 390, NULL),
('Sheraton Centre', 262, '2019-12-23', 170, NULL),
('Sheraton Centre', 262, '2019-12-24', 167, NULL),
('Sheraton Centre', 262, '2019-12-25', 119, NULL),
('Sheraton Centre', 262, '2019-12-26', 319, NULL),
('Sheraton Centre', 262, '2019-12-27', 199, NULL),
('Sheraton Centre', 262, '2019-12-28', 233, NULL),
('Sheraton Centre', 262, '2019-12-29', 218, NULL),
('Sheraton Centre', 262, '2019-12-30', 358, NULL),
('Sheraton Centre', 262, '2019-12-31', 116, NULL),
('Sheraton Centre', 262, '2020-01-01', 135, NULL),
('Sheraton Centre', 262, '2020-01-02', 104, NULL),
('Sheraton Centre', 262, '2020-01-03', 115, NULL),
('Sheraton Centre', 262, '2020-01-04', 354, NULL),
('Sheraton Centre', 262, '2020-01-05', 211, NULL),
('Sheraton Centre', 262, '2020-01-06', 103, NULL),
('Sheraton Centre', 262, '2020-01-07', 212, NULL),
('Sheraton Centre', 262, '2020-01-08', 334, NULL),
('Sheraton Centre', 262, '2020-01-09', 261, NULL),
('Sheraton Centre', 262, '2020-01-10', 235, NULL),
('Sheraton Centre', 262, '2020-01-11', 100, NULL),
('Sheraton Centre', 262, '2020-01-12', 184, NULL),
('Sheraton Centre', 262, '2020-01-13', 211, NULL),
('Sheraton Centre', 262, '2020-01-14', 172, NULL),
('Sheraton Centre', 262, '2020-01-15', 104, NULL),
('Sheraton Centre', 262, '2020-01-16', 284, NULL),
('Sheraton Centre', 262, '2020-01-17', 126, NULL),
('Sheraton Centre', 262, '2020-01-18', 243, NULL),
('Sheraton Centre', 262, '2020-01-19', 294, NULL),
('Sheraton Centre', 262, '2020-01-20', 313, NULL),
('Sheraton Centre', 262, '2020-01-21', 263, NULL),
('Sheraton Centre', 262, '2020-01-22', 382, NULL),
('Sheraton Centre', 262, '2020-01-23', 372, NULL),
('Sheraton Centre', 262, '2020-01-24', 245, NULL),
('Sheraton Centre', 262, '2020-01-25', 284, NULL),
('Sheraton Centre', 262, '2020-01-26', 291, NULL),
('Sheraton Centre', 262, '2020-01-27', 380, NULL),
('Sheraton Centre', 262, '2020-01-28', 148, NULL),
('Sheraton Centre', 262, '2020-01-29', 189, NULL),
('Sheraton Centre', 262, '2020-01-30', 305, NULL),
('Sheraton Centre', 262, '2020-01-31', 100, NULL),
('Sheraton Centre', 262, '2020-02-01', 282, NULL),
('Sheraton Centre', 262, '2020-02-02', 124, NULL),
('Sheraton Centre', 262, '2020-02-03', 383, NULL),
('Sheraton Centre', 262, '2020-02-04', 232, NULL),
('Sheraton Centre', 282, '2019-01-01', 265, NULL),
('Sheraton Centre', 282, '2019-01-02', 191, NULL),
('Sheraton Centre', 282, '2019-01-03', 325, NULL),
('Sheraton Centre', 282, '2019-01-04', 122, NULL),
('Sheraton Centre', 282, '2019-01-05', 296, NULL),
('Sheraton Centre', 282, '2019-01-06', 116, NULL),
('Sheraton Centre', 282, '2019-01-07', 355, NULL),
('Sheraton Centre', 282, '2019-01-08', 332, NULL),
('Sheraton Centre', 282, '2019-01-09', 327, NULL),
('Sheraton Centre', 282, '2019-01-10', 197, NULL),
('Sheraton Centre', 282, '2019-01-11', 187, NULL),
('Sheraton Centre', 282, '2019-01-12', 372, NULL),
('Sheraton Centre', 282, '2019-01-13', 242, NULL),
('Sheraton Centre', 282, '2019-01-14', 197, NULL),
('Sheraton Centre', 282, '2019-01-15', 131, NULL),
('Sheraton Centre', 282, '2019-01-16', 334, NULL),
('Sheraton Centre', 282, '2019-01-17', 185, NULL),
('Sheraton Centre', 282, '2019-01-18', 251, NULL),
('Sheraton Centre', 282, '2019-01-19', 364, NULL),
('Sheraton Centre', 282, '2019-01-20', 397, NULL),
('Sheraton Centre', 282, '2019-01-21', 218, NULL),
('Sheraton Centre', 282, '2019-01-22', 227, NULL),
('Sheraton Centre', 282, '2019-01-23', 240, NULL),
('Sheraton Centre', 282, '2019-01-24', 340, NULL),
('Sheraton Centre', 282, '2019-01-25', 276, NULL),
('Sheraton Centre', 282, '2019-01-26', 169, NULL),
('Sheraton Centre', 282, '2019-01-27', 101, NULL),
('Sheraton Centre', 282, '2019-01-28', 164, NULL),
('Sheraton Centre', 282, '2019-01-29', 239, NULL),
('Sheraton Centre', 282, '2019-01-30', 160, NULL),
('Sheraton Centre', 282, '2019-01-31', 277, NULL),
('Sheraton Centre', 282, '2019-02-01', 249, NULL),
('Sheraton Centre', 282, '2019-02-02', 218, NULL),
('Sheraton Centre', 282, '2019-02-03', 313, NULL),
('Sheraton Centre', 282, '2019-02-04', 167, NULL),
('Sheraton Centre', 282, '2019-02-05', 393, NULL),
('Sheraton Centre', 282, '2019-02-06', 335, NULL),
('Sheraton Centre', 282, '2019-02-07', 187, NULL),
('Sheraton Centre', 282, '2019-02-08', 299, NULL),
('Sheraton Centre', 282, '2019-02-09', 214, NULL),
('Sheraton Centre', 282, '2019-02-10', 202, NULL),
('Sheraton Centre', 282, '2019-02-11', 201, NULL),
('Sheraton Centre', 282, '2019-02-12', 114, NULL),
('Sheraton Centre', 282, '2019-02-13', 356, NULL),
('Sheraton Centre', 282, '2019-02-14', 144, NULL),
('Sheraton Centre', 282, '2019-02-15', 119, NULL),
('Sheraton Centre', 282, '2019-02-16', 248, NULL),
('Sheraton Centre', 282, '2019-02-17', 172, NULL),
('Sheraton Centre', 282, '2019-02-18', 306, NULL),
('Sheraton Centre', 282, '2019-02-19', 209, NULL),
('Sheraton Centre', 282, '2019-02-20', 341, NULL),
('Sheraton Centre', 282, '2019-02-21', 193, NULL),
('Sheraton Centre', 282, '2019-02-22', 323, NULL),
('Sheraton Centre', 282, '2019-02-23', 282, NULL),
('Sheraton Centre', 282, '2019-02-24', 220, NULL),
('Sheraton Centre', 282, '2019-02-25', 333, NULL),
('Sheraton Centre', 282, '2019-02-26', 187, NULL),
('Sheraton Centre', 282, '2019-02-27', 383, NULL),
('Sheraton Centre', 282, '2019-02-28', 198, NULL),
('Sheraton Centre', 282, '2019-03-01', 364, NULL),
('Sheraton Centre', 282, '2019-03-02', 218, NULL),
('Sheraton Centre', 282, '2019-03-03', 270, NULL),
('Sheraton Centre', 282, '2019-03-04', 277, NULL),
('Sheraton Centre', 282, '2019-03-05', 362, NULL),
('Sheraton Centre', 282, '2019-03-06', 336, NULL),
('Sheraton Centre', 282, '2019-03-07', 124, NULL),
('Sheraton Centre', 282, '2019-03-08', 222, NULL),
('Sheraton Centre', 282, '2019-03-09', 223, NULL),
('Sheraton Centre', 282, '2019-03-10', 148, NULL),
('Sheraton Centre', 282, '2019-03-11', 136, NULL),
('Sheraton Centre', 282, '2019-03-12', 218, NULL),
('Sheraton Centre', 282, '2019-03-13', 321, NULL),
('Sheraton Centre', 282, '2019-03-14', 142, NULL),
('Sheraton Centre', 282, '2019-03-15', 216, NULL),
('Sheraton Centre', 282, '2019-03-16', 347, NULL),
('Sheraton Centre', 282, '2019-03-17', 255, NULL),
('Sheraton Centre', 282, '2019-03-18', 200, NULL),
('Sheraton Centre', 282, '2019-03-19', 300, NULL),
('Sheraton Centre', 282, '2019-03-20', 144, NULL),
('Sheraton Centre', 282, '2019-03-21', 340, NULL),
('Sheraton Centre', 282, '2019-03-22', 257, NULL),
('Sheraton Centre', 282, '2019-03-23', 345, NULL),
('Sheraton Centre', 282, '2019-03-24', 341, NULL),
('Sheraton Centre', 282, '2019-03-25', 272, NULL),
('Sheraton Centre', 282, '2019-03-26', 298, NULL),
('Sheraton Centre', 282, '2019-03-27', 329, NULL),
('Sheraton Centre', 282, '2019-03-28', 333, NULL),
('Sheraton Centre', 282, '2019-03-29', 323, NULL),
('Sheraton Centre', 282, '2019-03-30', 311, NULL),
('Sheraton Centre', 282, '2019-03-31', 207, NULL),
('Sheraton Centre', 282, '2019-04-01', 363, NULL),
('Sheraton Centre', 282, '2019-04-02', 145, NULL),
('Sheraton Centre', 282, '2019-04-03', 289, NULL),
('Sheraton Centre', 282, '2019-04-04', 375, NULL),
('Sheraton Centre', 282, '2019-04-05', 383, NULL),
('Sheraton Centre', 282, '2019-04-06', 149, NULL),
('Sheraton Centre', 282, '2019-04-07', 136, NULL),
('Sheraton Centre', 282, '2019-04-08', 211, NULL),
('Sheraton Centre', 282, '2019-04-09', 266, NULL),
('Sheraton Centre', 282, '2019-04-10', 115, NULL),
('Sheraton Centre', 282, '2019-04-11', 162, NULL),
('Sheraton Centre', 282, '2019-04-12', 220, NULL),
('Sheraton Centre', 282, '2019-04-13', 303, NULL),
('Sheraton Centre', 282, '2019-04-14', 173, NULL),
('Sheraton Centre', 282, '2019-04-15', 255, NULL),
('Sheraton Centre', 282, '2019-04-16', 347, NULL),
('Sheraton Centre', 282, '2019-04-17', 240, NULL),
('Sheraton Centre', 282, '2019-04-18', 362, NULL),
('Sheraton Centre', 282, '2019-04-19', 380, NULL),
('Sheraton Centre', 282, '2019-04-20', 293, NULL),
('Sheraton Centre', 282, '2019-04-21', 300, NULL),
('Sheraton Centre', 282, '2019-04-22', 172, NULL),
('Sheraton Centre', 282, '2019-04-23', 295, NULL),
('Sheraton Centre', 282, '2019-04-24', 335, NULL),
('Sheraton Centre', 282, '2019-04-25', 121, NULL),
('Sheraton Centre', 282, '2019-04-26', 200, NULL),
('Sheraton Centre', 282, '2019-04-27', 376, NULL),
('Sheraton Centre', 282, '2019-04-28', 245, NULL),
('Sheraton Centre', 282, '2019-04-29', 254, NULL),
('Sheraton Centre', 282, '2019-04-30', 370, NULL),
('Sheraton Centre', 282, '2019-05-01', 255, NULL),
('Sheraton Centre', 282, '2019-05-02', 205, NULL),
('Sheraton Centre', 282, '2019-05-03', 233, NULL),
('Sheraton Centre', 282, '2019-05-04', 370, NULL),
('Sheraton Centre', 282, '2019-05-05', 331, NULL),
('Sheraton Centre', 282, '2019-05-06', 105, NULL),
('Sheraton Centre', 282, '2019-05-07', 137, NULL),
('Sheraton Centre', 282, '2019-05-08', 323, NULL),
('Sheraton Centre', 282, '2019-05-09', 368, NULL),
('Sheraton Centre', 282, '2019-05-10', 372, NULL),
('Sheraton Centre', 282, '2019-05-11', 369, NULL),
('Sheraton Centre', 282, '2019-05-12', 240, NULL),
('Sheraton Centre', 282, '2019-05-13', 383, NULL),
('Sheraton Centre', 282, '2019-05-14', 348, NULL),
('Sheraton Centre', 282, '2019-05-15', 399, NULL),
('Sheraton Centre', 282, '2019-05-16', 135, NULL),
('Sheraton Centre', 282, '2019-05-17', 128, NULL),
('Sheraton Centre', 282, '2019-05-18', 332, NULL),
('Sheraton Centre', 282, '2019-05-19', 356, NULL),
('Sheraton Centre', 282, '2019-05-20', 168, NULL),
('Sheraton Centre', 282, '2019-05-21', 158, NULL),
('Sheraton Centre', 282, '2019-05-22', 153, NULL),
('Sheraton Centre', 282, '2019-05-23', 107, NULL),
('Sheraton Centre', 282, '2019-05-24', 201, NULL),
('Sheraton Centre', 282, '2019-05-25', 153, NULL),
('Sheraton Centre', 282, '2019-05-26', 198, NULL),
('Sheraton Centre', 282, '2019-05-27', 273, NULL),
('Sheraton Centre', 282, '2019-05-28', 279, NULL),
('Sheraton Centre', 282, '2019-05-29', 230, NULL),
('Sheraton Centre', 282, '2019-05-30', 313, NULL),
('Sheraton Centre', 282, '2019-05-31', 177, NULL),
('Sheraton Centre', 282, '2019-06-01', 357, NULL),
('Sheraton Centre', 282, '2019-06-02', 275, NULL),
('Sheraton Centre', 282, '2019-06-03', 134, NULL),
('Sheraton Centre', 282, '2019-06-04', 353, NULL),
('Sheraton Centre', 282, '2019-06-05', 118, NULL),
('Sheraton Centre', 282, '2019-06-06', 283, NULL),
('Sheraton Centre', 282, '2019-06-07', 337, NULL),
('Sheraton Centre', 282, '2019-06-08', 306, NULL),
('Sheraton Centre', 282, '2019-06-09', 326, NULL),
('Sheraton Centre', 282, '2019-06-10', 303, NULL),
('Sheraton Centre', 282, '2019-06-11', 249, NULL),
('Sheraton Centre', 282, '2019-06-12', 116, NULL),
('Sheraton Centre', 282, '2019-06-13', 264, NULL),
('Sheraton Centre', 282, '2019-06-14', 244, NULL),
('Sheraton Centre', 282, '2019-06-15', 151, NULL),
('Sheraton Centre', 282, '2019-06-16', 100, NULL),
('Sheraton Centre', 282, '2019-06-17', 100, NULL),
('Sheraton Centre', 282, '2019-06-18', 143, NULL),
('Sheraton Centre', 282, '2019-06-19', 370, NULL),
('Sheraton Centre', 282, '2019-06-20', 125, NULL),
('Sheraton Centre', 282, '2019-06-21', 395, NULL),
('Sheraton Centre', 282, '2019-06-22', 264, NULL),
('Sheraton Centre', 282, '2019-06-23', 304, NULL),
('Sheraton Centre', 282, '2019-06-24', 306, NULL),
('Sheraton Centre', 282, '2019-06-25', 361, NULL),
('Sheraton Centre', 282, '2019-06-26', 295, NULL),
('Sheraton Centre', 282, '2019-06-27', 384, NULL),
('Sheraton Centre', 282, '2019-06-28', 127, NULL),
('Sheraton Centre', 282, '2019-06-29', 266, NULL),
('Sheraton Centre', 282, '2019-06-30', 229, NULL),
('Sheraton Centre', 282, '2019-07-01', 107, NULL),
('Sheraton Centre', 282, '2019-07-02', 184, NULL),
('Sheraton Centre', 282, '2019-07-03', 321, NULL),
('Sheraton Centre', 282, '2019-07-04', 270, NULL),
('Sheraton Centre', 282, '2019-07-05', 331, NULL),
('Sheraton Centre', 282, '2019-07-06', 249, NULL),
('Sheraton Centre', 282, '2019-07-07', 175, NULL),
('Sheraton Centre', 282, '2019-07-08', 244, NULL),
('Sheraton Centre', 282, '2019-07-09', 180, NULL),
('Sheraton Centre', 282, '2019-07-10', 327, NULL),
('Sheraton Centre', 282, '2019-07-11', 286, NULL),
('Sheraton Centre', 282, '2019-07-12', 305, NULL),
('Sheraton Centre', 282, '2019-07-13', 359, NULL),
('Sheraton Centre', 282, '2019-07-14', 167, NULL),
('Sheraton Centre', 282, '2019-07-15', 378, NULL),
('Sheraton Centre', 282, '2019-07-16', 157, NULL),
('Sheraton Centre', 282, '2019-07-17', 288, NULL),
('Sheraton Centre', 282, '2019-07-18', 217, NULL),
('Sheraton Centre', 282, '2019-07-19', 301, NULL),
('Sheraton Centre', 282, '2019-07-20', 158, NULL),
('Sheraton Centre', 282, '2019-07-21', 203, NULL),
('Sheraton Centre', 282, '2019-07-22', 216, NULL),
('Sheraton Centre', 282, '2019-07-23', 183, NULL),
('Sheraton Centre', 282, '2019-07-24', 329, NULL),
('Sheraton Centre', 282, '2019-07-25', 107, NULL),
('Sheraton Centre', 282, '2019-07-26', 337, NULL),
('Sheraton Centre', 282, '2019-07-27', 253, NULL),
('Sheraton Centre', 282, '2019-07-28', 250, NULL),
('Sheraton Centre', 282, '2019-07-29', 212, NULL),
('Sheraton Centre', 282, '2019-07-30', 156, NULL),
('Sheraton Centre', 282, '2019-07-31', 138, NULL),
('Sheraton Centre', 282, '2019-08-01', 123, NULL),
('Sheraton Centre', 282, '2019-08-02', 270, NULL),
('Sheraton Centre', 282, '2019-08-03', 175, NULL),
('Sheraton Centre', 282, '2019-08-04', 222, NULL),
('Sheraton Centre', 282, '2019-08-05', 353, NULL),
('Sheraton Centre', 282, '2019-08-06', 190, NULL),
('Sheraton Centre', 282, '2019-08-07', 228, NULL),
('Sheraton Centre', 282, '2019-08-08', 184, NULL),
('Sheraton Centre', 282, '2019-08-09', 358, NULL),
('Sheraton Centre', 282, '2019-08-10', 225, NULL),
('Sheraton Centre', 282, '2019-08-11', 115, NULL),
('Sheraton Centre', 282, '2019-08-12', 316, NULL),
('Sheraton Centre', 282, '2019-08-13', 205, NULL),
('Sheraton Centre', 282, '2019-08-14', 204, NULL),
('Sheraton Centre', 282, '2019-08-15', 334, NULL),
('Sheraton Centre', 282, '2019-08-16', 312, NULL),
('Sheraton Centre', 282, '2019-08-17', 249, NULL),
('Sheraton Centre', 282, '2019-08-18', 147, NULL),
('Sheraton Centre', 282, '2019-08-19', 249, NULL),
('Sheraton Centre', 282, '2019-08-20', 353, NULL),
('Sheraton Centre', 282, '2019-08-21', 353, NULL),
('Sheraton Centre', 282, '2019-08-22', 273, NULL),
('Sheraton Centre', 282, '2019-08-23', 180, NULL),
('Sheraton Centre', 282, '2019-08-24', 102, NULL),
('Sheraton Centre', 282, '2019-08-25', 309, NULL),
('Sheraton Centre', 282, '2019-08-26', 218, NULL),
('Sheraton Centre', 282, '2019-08-27', 305, NULL),
('Sheraton Centre', 282, '2019-08-28', 210, NULL),
('Sheraton Centre', 282, '2019-08-29', 201, NULL),
('Sheraton Centre', 282, '2019-08-30', 140, NULL),
('Sheraton Centre', 282, '2019-08-31', 390, NULL),
('Sheraton Centre', 282, '2019-09-01', 355, NULL),
('Sheraton Centre', 282, '2019-09-02', 379, NULL),
('Sheraton Centre', 282, '2019-09-03', 338, NULL),
('Sheraton Centre', 282, '2019-09-04', 395, NULL),
('Sheraton Centre', 282, '2019-09-05', 166, NULL),
('Sheraton Centre', 282, '2019-09-06', 269, NULL),
('Sheraton Centre', 282, '2019-09-07', 181, NULL),
('Sheraton Centre', 282, '2019-09-08', 312, NULL),
('Sheraton Centre', 282, '2019-09-09', 302, NULL),
('Sheraton Centre', 282, '2019-09-10', 295, NULL),
('Sheraton Centre', 282, '2019-09-11', 162, NULL),
('Sheraton Centre', 282, '2019-09-12', 140, NULL),
('Sheraton Centre', 282, '2019-09-13', 200, NULL),
('Sheraton Centre', 282, '2019-09-14', 242, NULL),
('Sheraton Centre', 282, '2019-09-15', 229, NULL),
('Sheraton Centre', 282, '2019-09-16', 356, NULL),
('Sheraton Centre', 282, '2019-09-17', 186, NULL),
('Sheraton Centre', 282, '2019-09-18', 398, NULL),
('Sheraton Centre', 282, '2019-09-19', 280, NULL),
('Sheraton Centre', 282, '2019-09-20', 351, NULL),
('Sheraton Centre', 282, '2019-09-21', 161, NULL),
('Sheraton Centre', 282, '2019-09-22', 364, NULL),
('Sheraton Centre', 282, '2019-09-23', 365, NULL),
('Sheraton Centre', 282, '2019-09-24', 298, NULL),
('Sheraton Centre', 282, '2019-09-25', 244, NULL),
('Sheraton Centre', 282, '2019-09-26', 221, NULL),
('Sheraton Centre', 282, '2019-09-27', 377, NULL),
('Sheraton Centre', 282, '2019-09-28', 155, NULL),
('Sheraton Centre', 282, '2019-09-29', 326, NULL),
('Sheraton Centre', 282, '2019-09-30', 180, NULL),
('Sheraton Centre', 282, '2019-10-01', 136, NULL),
('Sheraton Centre', 282, '2019-10-02', 193, NULL),
('Sheraton Centre', 282, '2019-10-03', 189, NULL),
('Sheraton Centre', 282, '2019-10-04', 142, NULL),
('Sheraton Centre', 282, '2019-10-05', 246, NULL),
('Sheraton Centre', 282, '2019-10-06', 323, NULL),
('Sheraton Centre', 282, '2019-10-07', 136, NULL),
('Sheraton Centre', 282, '2019-10-08', 205, NULL),
('Sheraton Centre', 282, '2019-10-09', 341, NULL),
('Sheraton Centre', 282, '2019-10-10', 287, NULL),
('Sheraton Centre', 282, '2019-10-11', 106, NULL),
('Sheraton Centre', 282, '2019-10-12', 172, NULL),
('Sheraton Centre', 282, '2019-10-13', 172, NULL),
('Sheraton Centre', 282, '2019-10-14', 173, NULL),
('Sheraton Centre', 282, '2019-10-15', 114, NULL),
('Sheraton Centre', 282, '2019-10-16', 161, NULL),
('Sheraton Centre', 282, '2019-10-17', 291, NULL),
('Sheraton Centre', 282, '2019-10-18', 116, NULL),
('Sheraton Centre', 282, '2019-10-19', 239, NULL),
('Sheraton Centre', 282, '2019-10-20', 248, NULL),
('Sheraton Centre', 282, '2019-10-21', 369, NULL),
('Sheraton Centre', 282, '2019-10-22', 370, NULL),
('Sheraton Centre', 282, '2019-10-23', 195, NULL),
('Sheraton Centre', 282, '2019-10-24', 165, NULL),
('Sheraton Centre', 282, '2019-10-25', 366, NULL),
('Sheraton Centre', 282, '2019-10-26', 243, NULL),
('Sheraton Centre', 282, '2019-10-27', 239, NULL),
('Sheraton Centre', 282, '2019-10-28', 121, NULL),
('Sheraton Centre', 282, '2019-10-29', 379, NULL),
('Sheraton Centre', 282, '2019-10-30', 298, NULL),
('Sheraton Centre', 282, '2019-10-31', 246, NULL),
('Sheraton Centre', 282, '2019-11-01', 291, NULL),
('Sheraton Centre', 282, '2019-11-02', 190, NULL),
('Sheraton Centre', 282, '2019-11-03', 247, NULL),
('Sheraton Centre', 282, '2019-11-04', 188, NULL),
('Sheraton Centre', 282, '2019-11-05', 336, NULL),
('Sheraton Centre', 282, '2019-11-06', 207, NULL),
('Sheraton Centre', 282, '2019-11-07', 344, NULL),
('Sheraton Centre', 282, '2019-11-08', 155, NULL),
('Sheraton Centre', 282, '2019-11-09', 249, NULL),
('Sheraton Centre', 282, '2019-11-10', 358, NULL),
('Sheraton Centre', 282, '2019-11-11', 219, NULL),
('Sheraton Centre', 282, '2019-11-12', 389, NULL),
('Sheraton Centre', 282, '2019-11-13', 128, NULL),
('Sheraton Centre', 282, '2019-11-14', 325, NULL),
('Sheraton Centre', 282, '2019-11-15', 346, NULL),
('Sheraton Centre', 282, '2019-11-16', 277, NULL),
('Sheraton Centre', 282, '2019-11-17', 214, NULL),
('Sheraton Centre', 282, '2019-11-18', 260, NULL),
('Sheraton Centre', 282, '2019-11-19', 199, NULL),
('Sheraton Centre', 282, '2019-11-20', 376, NULL),
('Sheraton Centre', 282, '2019-11-21', 208, NULL),
('Sheraton Centre', 282, '2019-11-22', 156, NULL),
('Sheraton Centre', 282, '2019-11-23', 176, NULL),
('Sheraton Centre', 282, '2019-11-24', 105, NULL),
('Sheraton Centre', 282, '2019-11-25', 356, NULL),
('Sheraton Centre', 282, '2019-11-26', 202, NULL),
('Sheraton Centre', 282, '2019-11-27', 194, NULL),
('Sheraton Centre', 282, '2019-11-28', 108, NULL),
('Sheraton Centre', 282, '2019-11-29', 329, NULL),
('Sheraton Centre', 282, '2019-11-30', 222, NULL),
('Sheraton Centre', 282, '2019-12-01', 105, NULL),
('Sheraton Centre', 282, '2019-12-02', 211, NULL),
('Sheraton Centre', 282, '2019-12-03', 351, NULL),
('Sheraton Centre', 282, '2019-12-04', 247, NULL),
('Sheraton Centre', 282, '2019-12-05', 128, NULL),
('Sheraton Centre', 282, '2019-12-06', 179, NULL),
('Sheraton Centre', 282, '2019-12-07', 344, NULL),
('Sheraton Centre', 282, '2019-12-08', 127, NULL),
('Sheraton Centre', 282, '2019-12-09', 202, NULL),
('Sheraton Centre', 282, '2019-12-10', 296, NULL),
('Sheraton Centre', 282, '2019-12-11', 123, NULL),
('Sheraton Centre', 282, '2019-12-12', 225, NULL),
('Sheraton Centre', 282, '2019-12-13', 213, NULL),
('Sheraton Centre', 282, '2019-12-14', 115, NULL),
('Sheraton Centre', 282, '2019-12-15', 263, NULL),
('Sheraton Centre', 282, '2019-12-16', 345, NULL),
('Sheraton Centre', 282, '2019-12-17', 167, NULL),
('Sheraton Centre', 282, '2019-12-18', 218, NULL),
('Sheraton Centre', 282, '2019-12-19', 254, NULL),
('Sheraton Centre', 282, '2019-12-20', 292, NULL),
('Sheraton Centre', 282, '2019-12-21', 361, NULL),
('Sheraton Centre', 282, '2019-12-22', 316, NULL),
('Sheraton Centre', 282, '2019-12-23', 340, NULL),
('Sheraton Centre', 282, '2019-12-24', 190, NULL),
('Sheraton Centre', 282, '2019-12-25', 248, NULL),
('Sheraton Centre', 282, '2019-12-26', 322, NULL),
('Sheraton Centre', 282, '2019-12-27', 299, NULL),
('Sheraton Centre', 282, '2019-12-28', 285, NULL),
('Sheraton Centre', 282, '2019-12-29', 381, NULL),
('Sheraton Centre', 282, '2019-12-30', 245, NULL),
('Sheraton Centre', 282, '2019-12-31', 222, NULL),
('Sheraton Centre', 282, '2020-01-01', 242, NULL),
('Sheraton Centre', 282, '2020-01-02', 370, NULL),
('Sheraton Centre', 282, '2020-01-03', 398, NULL),
('Sheraton Centre', 282, '2020-01-04', 153, NULL),
('Sheraton Centre', 282, '2020-01-05', 301, NULL),
('Sheraton Centre', 282, '2020-01-06', 129, NULL),
('Sheraton Centre', 282, '2020-01-07', 135, NULL),
('Sheraton Centre', 282, '2020-01-08', 157, NULL),
('Sheraton Centre', 282, '2020-01-09', 363, NULL),
('Sheraton Centre', 282, '2020-01-10', 347, NULL),
('Sheraton Centre', 282, '2020-01-11', 128, NULL),
('Sheraton Centre', 282, '2020-01-12', 387, NULL),
('Sheraton Centre', 282, '2020-01-13', 276, NULL),
('Sheraton Centre', 282, '2020-01-14', 346, NULL),
('Sheraton Centre', 282, '2020-01-15', 374, NULL),
('Sheraton Centre', 282, '2020-01-16', 361, NULL),
('Sheraton Centre', 282, '2020-01-17', 129, NULL),
('Sheraton Centre', 282, '2020-01-18', 137, NULL),
('Sheraton Centre', 282, '2020-01-19', 217, NULL),
('Sheraton Centre', 282, '2020-01-20', 245, NULL),
('Sheraton Centre', 282, '2020-01-21', 263, NULL),
('Sheraton Centre', 282, '2020-01-22', 187, NULL),
('Sheraton Centre', 282, '2020-01-23', 127, NULL),
('Sheraton Centre', 282, '2020-01-24', 365, NULL),
('Sheraton Centre', 282, '2020-01-25', 397, NULL),
('Sheraton Centre', 282, '2020-01-26', 237, NULL),
('Sheraton Centre', 282, '2020-01-27', 371, NULL),
('Sheraton Centre', 282, '2020-01-28', 204, NULL),
('Sheraton Centre', 282, '2020-01-29', 112, NULL),
('Sheraton Centre', 282, '2020-01-30', 241, NULL),
('Sheraton Centre', 282, '2020-01-31', 146, NULL),
('Sheraton Centre', 282, '2020-02-01', 350, NULL),
('Sheraton Centre', 282, '2020-02-02', 127, NULL),
('Sheraton Centre', 282, '2020-02-03', 376, NULL),
('Sheraton Centre', 282, '2020-02-04', 133, NULL),
('Sheraton Centre', 293, '2019-01-01', 393, NULL),
('Sheraton Centre', 293, '2019-01-02', 370, NULL),
('Sheraton Centre', 293, '2019-01-03', 176, NULL),
('Sheraton Centre', 293, '2019-01-04', 229, NULL),
('Sheraton Centre', 293, '2019-01-05', 307, NULL),
('Sheraton Centre', 293, '2019-01-06', 389, NULL),
('Sheraton Centre', 293, '2019-01-07', 304, NULL),
('Sheraton Centre', 293, '2019-01-08', 169, NULL),
('Sheraton Centre', 293, '2019-01-09', 184, NULL),
('Sheraton Centre', 293, '2019-01-10', 140, NULL),
('Sheraton Centre', 293, '2019-01-11', 361, NULL),
('Sheraton Centre', 293, '2019-01-12', 171, NULL),
('Sheraton Centre', 293, '2019-01-13', 290, NULL),
('Sheraton Centre', 293, '2019-01-14', 232, NULL),
('Sheraton Centre', 293, '2019-01-15', 222, NULL),
('Sheraton Centre', 293, '2019-01-16', 159, NULL),
('Sheraton Centre', 293, '2019-01-17', 258, NULL),
('Sheraton Centre', 293, '2019-01-18', 260, NULL),
('Sheraton Centre', 293, '2019-01-19', 355, NULL),
('Sheraton Centre', 293, '2019-01-20', 305, NULL),
('Sheraton Centre', 293, '2019-01-21', 157, NULL),
('Sheraton Centre', 293, '2019-01-22', 194, NULL),
('Sheraton Centre', 293, '2019-01-23', 369, NULL),
('Sheraton Centre', 293, '2019-01-24', 367, NULL),
('Sheraton Centre', 293, '2019-01-25', 244, NULL),
('Sheraton Centre', 293, '2019-01-26', 262, NULL),
('Sheraton Centre', 293, '2019-01-27', 261, NULL),
('Sheraton Centre', 293, '2019-01-28', 174, NULL),
('Sheraton Centre', 293, '2019-01-29', 337, NULL),
('Sheraton Centre', 293, '2019-01-30', 244, NULL),
('Sheraton Centre', 293, '2019-01-31', 314, NULL),
('Sheraton Centre', 293, '2019-02-01', 373, NULL),
('Sheraton Centre', 293, '2019-02-02', 121, NULL),
('Sheraton Centre', 293, '2019-02-03', 217, NULL),
('Sheraton Centre', 293, '2019-02-04', 128, NULL),
('Sheraton Centre', 293, '2019-02-05', 364, NULL),
('Sheraton Centre', 293, '2019-02-06', 241, NULL),
('Sheraton Centre', 293, '2019-02-07', 264, NULL),
('Sheraton Centre', 293, '2019-02-08', 168, NULL),
('Sheraton Centre', 293, '2019-02-09', 268, NULL),
('Sheraton Centre', 293, '2019-02-10', 231, NULL),
('Sheraton Centre', 293, '2019-02-11', 102, NULL),
('Sheraton Centre', 293, '2019-02-12', 274, NULL),
('Sheraton Centre', 293, '2019-02-13', 335, NULL),
('Sheraton Centre', 293, '2019-02-14', 265, NULL),
('Sheraton Centre', 293, '2019-02-15', 140, NULL),
('Sheraton Centre', 293, '2019-02-16', 340, NULL),
('Sheraton Centre', 293, '2019-02-17', 261, NULL),
('Sheraton Centre', 293, '2019-02-18', 378, NULL),
('Sheraton Centre', 293, '2019-02-19', 364, NULL),
('Sheraton Centre', 293, '2019-02-20', 167, NULL),
('Sheraton Centre', 293, '2019-02-21', 111, NULL),
('Sheraton Centre', 293, '2019-02-22', 319, NULL),
('Sheraton Centre', 293, '2019-02-23', 308, NULL),
('Sheraton Centre', 293, '2019-02-24', 139, NULL),
('Sheraton Centre', 293, '2019-02-25', 264, NULL),
('Sheraton Centre', 293, '2019-02-26', 349, NULL),
('Sheraton Centre', 293, '2019-02-27', 257, NULL),
('Sheraton Centre', 293, '2019-02-28', 212, NULL),
('Sheraton Centre', 293, '2019-03-01', 322, NULL),
('Sheraton Centre', 293, '2019-03-02', 390, NULL),
('Sheraton Centre', 293, '2019-03-03', 213, NULL),
('Sheraton Centre', 293, '2019-03-04', 214, NULL),
('Sheraton Centre', 293, '2019-03-05', 377, NULL),
('Sheraton Centre', 293, '2019-03-06', 380, NULL),
('Sheraton Centre', 293, '2019-03-07', 232, NULL),
('Sheraton Centre', 293, '2019-03-08', 226, NULL),
('Sheraton Centre', 293, '2019-03-09', 129, NULL),
('Sheraton Centre', 293, '2019-03-10', 224, NULL),
('Sheraton Centre', 293, '2019-03-11', 224, NULL),
('Sheraton Centre', 293, '2019-03-12', 212, NULL),
('Sheraton Centre', 293, '2019-03-13', 183, NULL),
('Sheraton Centre', 293, '2019-03-14', 194, NULL),
('Sheraton Centre', 293, '2019-03-15', 307, NULL),
('Sheraton Centre', 293, '2019-03-16', 114, NULL),
('Sheraton Centre', 293, '2019-03-17', 391, NULL),
('Sheraton Centre', 293, '2019-03-18', 258, NULL),
('Sheraton Centre', 293, '2019-03-19', 276, NULL),
('Sheraton Centre', 293, '2019-03-20', 161, NULL),
('Sheraton Centre', 293, '2019-03-21', 216, NULL),
('Sheraton Centre', 293, '2019-03-22', 176, NULL),
('Sheraton Centre', 293, '2019-03-23', 229, NULL),
('Sheraton Centre', 293, '2019-03-24', 295, NULL),
('Sheraton Centre', 293, '2019-03-25', 153, NULL),
('Sheraton Centre', 293, '2019-03-26', 106, NULL),
('Sheraton Centre', 293, '2019-03-27', 330, NULL),
('Sheraton Centre', 293, '2019-03-28', 127, NULL),
('Sheraton Centre', 293, '2019-03-29', 144, NULL),
('Sheraton Centre', 293, '2019-03-30', 131, NULL),
('Sheraton Centre', 293, '2019-03-31', 187, NULL),
('Sheraton Centre', 293, '2019-04-01', 390, NULL),
('Sheraton Centre', 293, '2019-04-02', 363, NULL),
('Sheraton Centre', 293, '2019-04-03', 381, NULL),
('Sheraton Centre', 293, '2019-04-04', 312, NULL),
('Sheraton Centre', 293, '2019-04-05', 211, NULL),
('Sheraton Centre', 293, '2019-04-06', 363, NULL),
('Sheraton Centre', 293, '2019-04-07', 363, NULL),
('Sheraton Centre', 293, '2019-04-08', 101, NULL),
('Sheraton Centre', 293, '2019-04-09', 151, NULL),
('Sheraton Centre', 293, '2019-04-10', 173, NULL),
('Sheraton Centre', 293, '2019-04-11', 171, NULL),
('Sheraton Centre', 293, '2019-04-12', 109, NULL),
('Sheraton Centre', 293, '2019-04-13', 381, NULL),
('Sheraton Centre', 293, '2019-04-14', 398, NULL),
('Sheraton Centre', 293, '2019-04-15', 201, NULL),
('Sheraton Centre', 293, '2019-04-16', 357, NULL),
('Sheraton Centre', 293, '2019-04-17', 172, NULL),
('Sheraton Centre', 293, '2019-04-18', 159, NULL),
('Sheraton Centre', 293, '2019-04-19', 166, NULL),
('Sheraton Centre', 293, '2019-04-20', 127, NULL),
('Sheraton Centre', 293, '2019-04-21', 174, NULL),
('Sheraton Centre', 293, '2019-04-22', 330, NULL),
('Sheraton Centre', 293, '2019-04-23', 152, NULL),
('Sheraton Centre', 293, '2019-04-24', 118, NULL),
('Sheraton Centre', 293, '2019-04-25', 106, NULL),
('Sheraton Centre', 293, '2019-04-26', 275, NULL),
('Sheraton Centre', 293, '2019-04-27', 316, NULL),
('Sheraton Centre', 293, '2019-04-28', 301, NULL),
('Sheraton Centre', 293, '2019-04-29', 331, NULL),
('Sheraton Centre', 293, '2019-04-30', 174, NULL),
('Sheraton Centre', 293, '2019-05-01', 270, NULL),
('Sheraton Centre', 293, '2019-05-02', 287, NULL),
('Sheraton Centre', 293, '2019-05-03', 111, NULL),
('Sheraton Centre', 293, '2019-05-04', 379, NULL),
('Sheraton Centre', 293, '2019-05-05', 392, NULL),
('Sheraton Centre', 293, '2019-05-06', 360, NULL),
('Sheraton Centre', 293, '2019-05-07', 321, NULL),
('Sheraton Centre', 293, '2019-05-08', 346, NULL),
('Sheraton Centre', 293, '2019-05-09', 120, NULL),
('Sheraton Centre', 293, '2019-05-10', 229, NULL),
('Sheraton Centre', 293, '2019-05-11', 254, NULL),
('Sheraton Centre', 293, '2019-05-12', 384, NULL),
('Sheraton Centre', 293, '2019-05-13', 266, NULL),
('Sheraton Centre', 293, '2019-05-14', 353, NULL),
('Sheraton Centre', 293, '2019-05-15', 291, NULL),
('Sheraton Centre', 293, '2019-05-16', 387, NULL),
('Sheraton Centre', 293, '2019-05-17', 141, NULL),
('Sheraton Centre', 293, '2019-05-18', 107, NULL),
('Sheraton Centre', 293, '2019-05-19', 397, NULL),
('Sheraton Centre', 293, '2019-05-20', 201, NULL),
('Sheraton Centre', 293, '2019-05-21', 202, NULL),
('Sheraton Centre', 293, '2019-05-22', 200, NULL),
('Sheraton Centre', 293, '2019-05-23', 377, NULL),
('Sheraton Centre', 293, '2019-05-24', 124, NULL),
('Sheraton Centre', 293, '2019-05-25', 152, NULL),
('Sheraton Centre', 293, '2019-05-26', 161, NULL),
('Sheraton Centre', 293, '2019-05-27', 230, NULL),
('Sheraton Centre', 293, '2019-05-28', 313, NULL),
('Sheraton Centre', 293, '2019-05-29', 294, NULL),
('Sheraton Centre', 293, '2019-05-30', 272, NULL),
('Sheraton Centre', 293, '2019-05-31', 389, NULL),
('Sheraton Centre', 293, '2019-06-01', 338, NULL),
('Sheraton Centre', 293, '2019-06-02', 195, NULL),
('Sheraton Centre', 293, '2019-06-03', 267, NULL),
('Sheraton Centre', 293, '2019-06-04', 373, NULL),
('Sheraton Centre', 293, '2019-06-05', 346, NULL),
('Sheraton Centre', 293, '2019-06-06', 237, NULL),
('Sheraton Centre', 293, '2019-06-07', 297, NULL),
('Sheraton Centre', 293, '2019-06-08', 179, NULL),
('Sheraton Centre', 293, '2019-06-09', 275, NULL),
('Sheraton Centre', 293, '2019-06-10', 129, NULL),
('Sheraton Centre', 293, '2019-06-11', 105, NULL),
('Sheraton Centre', 293, '2019-06-12', 114, NULL),
('Sheraton Centre', 293, '2019-06-13', 364, NULL),
('Sheraton Centre', 293, '2019-06-14', 110, NULL),
('Sheraton Centre', 293, '2019-06-15', 224, NULL),
('Sheraton Centre', 293, '2019-06-16', 323, NULL),
('Sheraton Centre', 293, '2019-06-17', 335, NULL),
('Sheraton Centre', 293, '2019-06-18', 383, NULL),
('Sheraton Centre', 293, '2019-06-19', 315, NULL),
('Sheraton Centre', 293, '2019-06-20', 242, NULL),
('Sheraton Centre', 293, '2019-06-21', 305, NULL),
('Sheraton Centre', 293, '2019-06-22', 309, NULL),
('Sheraton Centre', 293, '2019-06-23', 259, NULL),
('Sheraton Centre', 293, '2019-06-24', 135, NULL),
('Sheraton Centre', 293, '2019-06-25', 381, NULL),
('Sheraton Centre', 293, '2019-06-26', 195, NULL),
('Sheraton Centre', 293, '2019-06-27', 174, NULL),
('Sheraton Centre', 293, '2019-06-28', 169, NULL),
('Sheraton Centre', 293, '2019-06-29', 268, NULL),
('Sheraton Centre', 293, '2019-06-30', 316, NULL),
('Sheraton Centre', 293, '2019-07-01', 288, NULL),
('Sheraton Centre', 293, '2019-07-02', 350, NULL),
('Sheraton Centre', 293, '2019-07-03', 163, NULL),
('Sheraton Centre', 293, '2019-07-04', 387, NULL),
('Sheraton Centre', 293, '2019-07-05', 306, NULL),
('Sheraton Centre', 293, '2019-07-06', 227, NULL),
('Sheraton Centre', 293, '2019-07-07', 395, NULL),
('Sheraton Centre', 293, '2019-07-08', 361, NULL),
('Sheraton Centre', 293, '2019-07-09', 115, NULL),
('Sheraton Centre', 293, '2019-07-10', 341, NULL),
('Sheraton Centre', 293, '2019-07-11', 251, NULL),
('Sheraton Centre', 293, '2019-07-12', 370, NULL),
('Sheraton Centre', 293, '2019-07-13', 381, NULL),
('Sheraton Centre', 293, '2019-07-14', 360, NULL),
('Sheraton Centre', 293, '2019-07-15', 242, NULL),
('Sheraton Centre', 293, '2019-07-16', 376, NULL),
('Sheraton Centre', 293, '2019-07-17', 382, NULL),
('Sheraton Centre', 293, '2019-07-18', 100, NULL),
('Sheraton Centre', 293, '2019-07-19', 278, NULL),
('Sheraton Centre', 293, '2019-07-20', 390, NULL),
('Sheraton Centre', 293, '2019-07-21', 200, NULL),
('Sheraton Centre', 293, '2019-07-22', 379, NULL),
('Sheraton Centre', 293, '2019-07-23', 148, NULL),
('Sheraton Centre', 293, '2019-07-24', 247, NULL),
('Sheraton Centre', 293, '2019-07-25', 131, NULL),
('Sheraton Centre', 293, '2019-07-26', 309, NULL),
('Sheraton Centre', 293, '2019-07-27', 306, NULL),
('Sheraton Centre', 293, '2019-07-28', 316, NULL),
('Sheraton Centre', 293, '2019-07-29', 252, NULL),
('Sheraton Centre', 293, '2019-07-30', 201, NULL),
('Sheraton Centre', 293, '2019-07-31', 238, NULL),
('Sheraton Centre', 293, '2019-08-01', 383, NULL),
('Sheraton Centre', 293, '2019-08-02', 322, NULL),
('Sheraton Centre', 293, '2019-08-03', 170, NULL),
('Sheraton Centre', 293, '2019-08-04', 275, NULL),
('Sheraton Centre', 293, '2019-08-05', 279, NULL),
('Sheraton Centre', 293, '2019-08-06', 164, NULL),
('Sheraton Centre', 293, '2019-08-07', 167, NULL),
('Sheraton Centre', 293, '2019-08-08', 172, NULL),
('Sheraton Centre', 293, '2019-08-09', 391, NULL),
('Sheraton Centre', 293, '2019-08-10', 146, NULL),
('Sheraton Centre', 293, '2019-08-11', 115, NULL),
('Sheraton Centre', 293, '2019-08-12', 354, NULL),
('Sheraton Centre', 293, '2019-08-13', 255, NULL),
('Sheraton Centre', 293, '2019-08-14', 139, NULL),
('Sheraton Centre', 293, '2019-08-15', 372, NULL),
('Sheraton Centre', 293, '2019-08-16', 399, NULL),
('Sheraton Centre', 293, '2019-08-17', 131, NULL),
('Sheraton Centre', 293, '2019-08-18', 159, NULL),
('Sheraton Centre', 293, '2019-08-19', 375, NULL),
('Sheraton Centre', 293, '2019-08-20', 139, NULL),
('Sheraton Centre', 293, '2019-08-21', 139, NULL),
('Sheraton Centre', 293, '2019-08-22', 174, NULL),
('Sheraton Centre', 293, '2019-08-23', 355, NULL),
('Sheraton Centre', 293, '2019-08-24', 308, NULL),
('Sheraton Centre', 293, '2019-08-25', 159, NULL),
('Sheraton Centre', 293, '2019-08-26', 344, NULL),
('Sheraton Centre', 293, '2019-08-27', 130, NULL),
('Sheraton Centre', 293, '2019-08-28', 100, NULL),
('Sheraton Centre', 293, '2019-08-29', 193, NULL),
('Sheraton Centre', 293, '2019-08-30', 310, NULL),
('Sheraton Centre', 293, '2019-08-31', 150, NULL),
('Sheraton Centre', 293, '2019-09-01', 320, NULL),
('Sheraton Centre', 293, '2019-09-02', 391, NULL),
('Sheraton Centre', 293, '2019-09-03', 388, NULL),
('Sheraton Centre', 293, '2019-09-04', 370, NULL),
('Sheraton Centre', 293, '2019-09-05', 319, NULL),
('Sheraton Centre', 293, '2019-09-06', 245, NULL),
('Sheraton Centre', 293, '2019-09-07', 221, NULL),
('Sheraton Centre', 293, '2019-09-08', 234, NULL),
('Sheraton Centre', 293, '2019-09-09', 151, NULL),
('Sheraton Centre', 293, '2019-09-10', 186, NULL),
('Sheraton Centre', 293, '2019-09-11', 261, NULL),
('Sheraton Centre', 293, '2019-09-12', 336, NULL),
('Sheraton Centre', 293, '2019-09-13', 121, NULL),
('Sheraton Centre', 293, '2019-09-14', 293, NULL),
('Sheraton Centre', 293, '2019-09-15', 196, NULL),
('Sheraton Centre', 293, '2019-09-16', 172, NULL),
('Sheraton Centre', 293, '2019-09-17', 315, NULL),
('Sheraton Centre', 293, '2019-09-18', 165, NULL),
('Sheraton Centre', 293, '2019-09-19', 366, NULL),
('Sheraton Centre', 293, '2019-09-20', 144, NULL),
('Sheraton Centre', 293, '2019-09-21', 181, NULL),
('Sheraton Centre', 293, '2019-09-22', 111, NULL),
('Sheraton Centre', 293, '2019-09-23', 201, NULL),
('Sheraton Centre', 293, '2019-09-24', 193, NULL),
('Sheraton Centre', 293, '2019-09-25', 290, NULL),
('Sheraton Centre', 293, '2019-09-26', 250, NULL),
('Sheraton Centre', 293, '2019-09-27', 358, NULL),
('Sheraton Centre', 293, '2019-09-28', 105, NULL),
('Sheraton Centre', 293, '2019-09-29', 145, NULL),
('Sheraton Centre', 293, '2019-09-30', 358, NULL),
('Sheraton Centre', 293, '2019-10-01', 245, NULL),
('Sheraton Centre', 293, '2019-10-02', 291, NULL),
('Sheraton Centre', 293, '2019-10-03', 317, NULL),
('Sheraton Centre', 293, '2019-10-04', 228, NULL),
('Sheraton Centre', 293, '2019-10-05', 120, NULL),
('Sheraton Centre', 293, '2019-10-06', 374, NULL),
('Sheraton Centre', 293, '2019-10-07', 372, NULL),
('Sheraton Centre', 293, '2019-10-08', 158, NULL),
('Sheraton Centre', 293, '2019-10-09', 135, NULL),
('Sheraton Centre', 293, '2019-10-10', 373, NULL),
('Sheraton Centre', 293, '2019-10-11', 345, NULL),
('Sheraton Centre', 293, '2019-10-12', 312, NULL),
('Sheraton Centre', 293, '2019-10-13', 193, NULL),
('Sheraton Centre', 293, '2019-10-14', 196, NULL),
('Sheraton Centre', 293, '2019-10-15', 177, NULL),
('Sheraton Centre', 293, '2019-10-16', 141, NULL),
('Sheraton Centre', 293, '2019-10-17', 332, NULL),
('Sheraton Centre', 293, '2019-10-18', 351, NULL),
('Sheraton Centre', 293, '2019-10-19', 349, NULL),
('Sheraton Centre', 293, '2019-10-20', 331, NULL),
('Sheraton Centre', 293, '2019-10-21', 237, NULL),
('Sheraton Centre', 293, '2019-10-22', 359, NULL),
('Sheraton Centre', 293, '2019-10-23', 169, NULL),
('Sheraton Centre', 293, '2019-10-24', 315, NULL),
('Sheraton Centre', 293, '2019-10-25', 280, NULL),
('Sheraton Centre', 293, '2019-10-26', 135, NULL),
('Sheraton Centre', 293, '2019-10-27', 258, NULL),
('Sheraton Centre', 293, '2019-10-28', 130, NULL),
('Sheraton Centre', 293, '2019-10-29', 366, NULL),
('Sheraton Centre', 293, '2019-10-30', 125, NULL),
('Sheraton Centre', 293, '2019-10-31', 122, NULL),
('Sheraton Centre', 293, '2019-11-01', 318, NULL),
('Sheraton Centre', 293, '2019-11-02', 111, NULL),
('Sheraton Centre', 293, '2019-11-03', 170, NULL),
('Sheraton Centre', 293, '2019-11-04', 119, NULL),
('Sheraton Centre', 293, '2019-11-05', 138, NULL),
('Sheraton Centre', 293, '2019-11-06', 214, NULL),
('Sheraton Centre', 293, '2019-11-07', 287, NULL),
('Sheraton Centre', 293, '2019-11-08', 241, NULL),
('Sheraton Centre', 293, '2019-11-09', 326, NULL),
('Sheraton Centre', 293, '2019-11-10', 309, NULL),
('Sheraton Centre', 293, '2019-11-11', 241, NULL),
('Sheraton Centre', 293, '2019-11-12', 348, NULL),
('Sheraton Centre', 293, '2019-11-13', 207, NULL),
('Sheraton Centre', 293, '2019-11-14', 165, NULL),
('Sheraton Centre', 293, '2019-11-15', 210, NULL),
('Sheraton Centre', 293, '2019-11-16', 236, NULL),
('Sheraton Centre', 293, '2019-11-17', 398, NULL),
('Sheraton Centre', 293, '2019-11-18', 282, NULL),
('Sheraton Centre', 293, '2019-11-19', 335, NULL),
('Sheraton Centre', 293, '2019-11-20', 244, NULL),
('Sheraton Centre', 293, '2019-11-21', 281, NULL),
('Sheraton Centre', 293, '2019-11-22', 165, NULL),
('Sheraton Centre', 293, '2019-11-23', 332, NULL),
('Sheraton Centre', 293, '2019-11-24', 119, NULL),
('Sheraton Centre', 293, '2019-11-25', 206, NULL),
('Sheraton Centre', 293, '2019-11-26', 203, NULL),
('Sheraton Centre', 293, '2019-11-27', 349, NULL),
('Sheraton Centre', 293, '2019-11-28', 221, NULL),
('Sheraton Centre', 293, '2019-11-29', 303, NULL),
('Sheraton Centre', 293, '2019-11-30', 119, NULL),
('Sheraton Centre', 293, '2019-12-01', 115, NULL),
('Sheraton Centre', 293, '2019-12-02', 114, NULL),
('Sheraton Centre', 293, '2019-12-03', 108, NULL),
('Sheraton Centre', 293, '2019-12-04', 227, NULL),
('Sheraton Centre', 293, '2019-12-05', 390, NULL),
('Sheraton Centre', 293, '2019-12-06', 220, NULL),
('Sheraton Centre', 293, '2019-12-07', 393, NULL),
('Sheraton Centre', 293, '2019-12-08', 180, NULL),
('Sheraton Centre', 293, '2019-12-09', 318, NULL),
('Sheraton Centre', 293, '2019-12-10', 126, NULL),
('Sheraton Centre', 293, '2019-12-11', 242, NULL),
('Sheraton Centre', 293, '2019-12-12', 327, NULL),
('Sheraton Centre', 293, '2019-12-13', 153, NULL),
('Sheraton Centre', 293, '2019-12-14', 194, NULL),
('Sheraton Centre', 293, '2019-12-15', 179, NULL),
('Sheraton Centre', 293, '2019-12-16', 177, NULL),
('Sheraton Centre', 293, '2019-12-17', 115, NULL),
('Sheraton Centre', 293, '2019-12-18', 266, NULL),
('Sheraton Centre', 293, '2019-12-19', 186, NULL),
('Sheraton Centre', 293, '2019-12-20', 268, NULL),
('Sheraton Centre', 293, '2019-12-21', 231, NULL),
('Sheraton Centre', 293, '2019-12-22', 309, NULL),
('Sheraton Centre', 293, '2019-12-23', 193, NULL),
('Sheraton Centre', 293, '2019-12-24', 349, NULL),
('Sheraton Centre', 293, '2019-12-25', 182, NULL),
('Sheraton Centre', 293, '2019-12-26', 254, NULL),
('Sheraton Centre', 293, '2019-12-27', 200, NULL),
('Sheraton Centre', 293, '2019-12-28', 327, NULL),
('Sheraton Centre', 293, '2019-12-29', 249, NULL),
('Sheraton Centre', 293, '2019-12-30', 355, NULL),
('Sheraton Centre', 293, '2019-12-31', 365, NULL),
('Sheraton Centre', 293, '2020-01-01', 104, NULL),
('Sheraton Centre', 293, '2020-01-02', 242, NULL),
('Sheraton Centre', 293, '2020-01-03', 346, NULL),
('Sheraton Centre', 293, '2020-01-04', 204, NULL),
('Sheraton Centre', 293, '2020-01-05', 174, NULL),
('Sheraton Centre', 293, '2020-01-06', 234, NULL),
('Sheraton Centre', 293, '2020-01-07', 239, NULL),
('Sheraton Centre', 293, '2020-01-08', 285, NULL),
('Sheraton Centre', 293, '2020-01-09', 332, NULL),
('Sheraton Centre', 293, '2020-01-10', 328, NULL),
('Sheraton Centre', 293, '2020-01-11', 239, NULL),
('Sheraton Centre', 293, '2020-01-12', 384, NULL),
('Sheraton Centre', 293, '2020-01-13', 346, NULL),
('Sheraton Centre', 293, '2020-01-14', 212, NULL),
('Sheraton Centre', 293, '2020-01-15', 260, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('Sheraton Centre', 293, '2020-01-16', 251, NULL),
('Sheraton Centre', 293, '2020-01-17', 168, NULL),
('Sheraton Centre', 293, '2020-01-18', 154, NULL),
('Sheraton Centre', 293, '2020-01-19', 103, NULL),
('Sheraton Centre', 293, '2020-01-20', 185, NULL),
('Sheraton Centre', 293, '2020-01-21', 125, NULL),
('Sheraton Centre', 293, '2020-01-22', 291, NULL),
('Sheraton Centre', 293, '2020-01-23', 320, NULL),
('Sheraton Centre', 293, '2020-01-24', 388, NULL),
('Sheraton Centre', 293, '2020-01-25', 133, NULL),
('Sheraton Centre', 293, '2020-01-26', 209, NULL),
('Sheraton Centre', 293, '2020-01-27', 319, NULL),
('Sheraton Centre', 293, '2020-01-28', 175, NULL),
('Sheraton Centre', 293, '2020-01-29', 194, NULL),
('Sheraton Centre', 293, '2020-01-30', 192, NULL),
('Sheraton Centre', 293, '2020-01-31', 333, NULL),
('Sheraton Centre', 293, '2020-02-01', 206, NULL),
('Sheraton Centre', 293, '2020-02-02', 166, NULL),
('Sheraton Centre', 293, '2020-02-03', 332, NULL),
('Sheraton Centre', 293, '2020-02-04', 167, NULL),
('The Paradise Inn', 6, '2019-01-01', 172, NULL),
('The Paradise Inn', 6, '2019-01-02', 275, NULL),
('The Paradise Inn', 6, '2019-01-03', 105, NULL),
('The Paradise Inn', 6, '2019-01-04', 381, NULL),
('The Paradise Inn', 6, '2019-01-05', 249, NULL),
('The Paradise Inn', 6, '2019-01-06', 298, NULL),
('The Paradise Inn', 6, '2019-01-07', 355, NULL),
('The Paradise Inn', 6, '2019-01-08', 350, NULL),
('The Paradise Inn', 6, '2019-01-09', 140, NULL),
('The Paradise Inn', 6, '2019-01-10', 311, NULL),
('The Paradise Inn', 6, '2019-01-11', 242, NULL),
('The Paradise Inn', 6, '2019-01-12', 238, NULL),
('The Paradise Inn', 6, '2019-01-13', 323, NULL),
('The Paradise Inn', 6, '2019-01-14', 171, NULL),
('The Paradise Inn', 6, '2019-01-15', 319, NULL),
('The Paradise Inn', 6, '2019-01-16', 294, NULL),
('The Paradise Inn', 6, '2019-01-17', 333, NULL),
('The Paradise Inn', 6, '2019-01-18', 146, NULL),
('The Paradise Inn', 6, '2019-01-19', 281, NULL),
('The Paradise Inn', 6, '2019-01-20', 235, NULL),
('The Paradise Inn', 6, '2019-01-21', 333, NULL),
('The Paradise Inn', 6, '2019-01-22', 191, NULL),
('The Paradise Inn', 6, '2019-01-23', 127, NULL),
('The Paradise Inn', 6, '2019-01-24', 116, NULL),
('The Paradise Inn', 6, '2019-01-25', 293, NULL),
('The Paradise Inn', 6, '2019-01-26', 105, NULL),
('The Paradise Inn', 6, '2019-01-27', 300, NULL),
('The Paradise Inn', 6, '2019-01-28', 276, NULL),
('The Paradise Inn', 6, '2019-01-29', 268, NULL),
('The Paradise Inn', 6, '2019-01-30', 338, NULL),
('The Paradise Inn', 6, '2019-01-31', 338, NULL),
('The Paradise Inn', 6, '2019-02-01', 118, NULL),
('The Paradise Inn', 6, '2019-02-02', 150, NULL),
('The Paradise Inn', 6, '2019-02-03', 344, NULL),
('The Paradise Inn', 6, '2019-02-04', 339, NULL),
('The Paradise Inn', 6, '2019-02-05', 243, 19),
('The Paradise Inn', 6, '2019-02-06', 399, 19),
('The Paradise Inn', 6, '2019-02-07', 360, 19),
('The Paradise Inn', 6, '2019-02-08', 144, 19),
('The Paradise Inn', 6, '2019-02-09', 296, 19),
('The Paradise Inn', 6, '2019-02-10', 148, 19),
('The Paradise Inn', 6, '2019-02-11', 108, 19),
('The Paradise Inn', 6, '2019-02-12', 329, 19),
('The Paradise Inn', 6, '2019-02-13', 210, 19),
('The Paradise Inn', 6, '2019-02-14', 192, 19),
('The Paradise Inn', 6, '2019-02-15', 244, 19),
('The Paradise Inn', 6, '2019-02-16', 258, 19),
('The Paradise Inn', 6, '2019-02-17', 391, 19),
('The Paradise Inn', 6, '2019-02-18', 272, 19),
('The Paradise Inn', 6, '2019-02-19', 194, 19),
('The Paradise Inn', 6, '2019-02-20', 312, 19),
('The Paradise Inn', 6, '2019-02-21', 175, 19),
('The Paradise Inn', 6, '2019-02-22', 226, 19),
('The Paradise Inn', 6, '2019-02-23', 292, 19),
('The Paradise Inn', 6, '2019-02-24', 236, 19),
('The Paradise Inn', 6, '2019-02-25', 219, 19),
('The Paradise Inn', 6, '2019-02-26', 185, 19),
('The Paradise Inn', 6, '2019-02-27', 334, 19),
('The Paradise Inn', 6, '2019-02-28', 368, 19),
('The Paradise Inn', 6, '2019-03-01', 118, NULL),
('The Paradise Inn', 6, '2019-03-02', 298, NULL),
('The Paradise Inn', 6, '2019-03-03', 153, NULL),
('The Paradise Inn', 6, '2019-03-04', 141, NULL),
('The Paradise Inn', 6, '2019-03-05', 101, NULL),
('The Paradise Inn', 6, '2019-03-06', 193, NULL),
('The Paradise Inn', 6, '2019-03-07', 387, NULL),
('The Paradise Inn', 6, '2019-03-08', 367, NULL),
('The Paradise Inn', 6, '2019-03-09', 179, NULL),
('The Paradise Inn', 6, '2019-03-10', 275, NULL),
('The Paradise Inn', 6, '2019-03-11', 310, NULL),
('The Paradise Inn', 6, '2019-03-12', 307, 26),
('The Paradise Inn', 6, '2019-03-13', 155, 26),
('The Paradise Inn', 6, '2019-03-14', 147, 26),
('The Paradise Inn', 6, '2019-03-15', 189, 26),
('The Paradise Inn', 6, '2019-03-16', 330, 26),
('The Paradise Inn', 6, '2019-03-17', 193, 26),
('The Paradise Inn', 6, '2019-03-18', 291, 26),
('The Paradise Inn', 6, '2019-03-19', 381, 26),
('The Paradise Inn', 6, '2019-03-20', 274, 26),
('The Paradise Inn', 6, '2019-03-21', 257, 26),
('The Paradise Inn', 6, '2019-03-22', 311, 26),
('The Paradise Inn', 6, '2019-03-23', 311, 26),
('The Paradise Inn', 6, '2019-03-24', 351, 26),
('The Paradise Inn', 6, '2019-03-25', 150, 26),
('The Paradise Inn', 6, '2019-03-26', 140, 26),
('The Paradise Inn', 6, '2019-03-27', 266, 26),
('The Paradise Inn', 6, '2019-03-28', 137, 26),
('The Paradise Inn', 6, '2019-03-29', 252, 26),
('The Paradise Inn', 6, '2019-03-30', 221, 26),
('The Paradise Inn', 6, '2019-03-31', 215, NULL),
('The Paradise Inn', 6, '2019-04-01', 165, NULL),
('The Paradise Inn', 6, '2019-04-02', 377, NULL),
('The Paradise Inn', 6, '2019-04-03', 341, NULL),
('The Paradise Inn', 6, '2019-04-04', 338, NULL),
('The Paradise Inn', 6, '2019-04-05', 104, NULL),
('The Paradise Inn', 6, '2019-04-06', 370, NULL),
('The Paradise Inn', 6, '2019-04-07', 109, NULL),
('The Paradise Inn', 6, '2019-04-08', 371, NULL),
('The Paradise Inn', 6, '2019-04-09', 159, NULL),
('The Paradise Inn', 6, '2019-04-10', 122, NULL),
('The Paradise Inn', 6, '2019-04-11', 267, NULL),
('The Paradise Inn', 6, '2019-04-12', 388, NULL),
('The Paradise Inn', 6, '2019-04-13', 299, NULL),
('The Paradise Inn', 6, '2019-04-14', 171, NULL),
('The Paradise Inn', 6, '2019-04-15', 139, NULL),
('The Paradise Inn', 6, '2019-04-16', 345, NULL),
('The Paradise Inn', 6, '2019-04-17', 339, NULL),
('The Paradise Inn', 6, '2019-04-18', 212, NULL),
('The Paradise Inn', 6, '2019-04-19', 191, NULL),
('The Paradise Inn', 6, '2019-04-20', 254, 13),
('The Paradise Inn', 6, '2019-04-21', 172, 13),
('The Paradise Inn', 6, '2019-04-22', 134, 13),
('The Paradise Inn', 6, '2019-04-23', 377, 13),
('The Paradise Inn', 6, '2019-04-24', 387, 13),
('The Paradise Inn', 6, '2019-04-25', 365, 13),
('The Paradise Inn', 6, '2019-04-26', 378, 13),
('The Paradise Inn', 6, '2019-04-27', 355, 13),
('The Paradise Inn', 6, '2019-04-28', 371, 13),
('The Paradise Inn', 6, '2019-04-29', 191, 13),
('The Paradise Inn', 6, '2019-04-30', 260, 13),
('The Paradise Inn', 6, '2019-05-01', 185, 13),
('The Paradise Inn', 6, '2019-05-02', 123, 13),
('The Paradise Inn', 6, '2019-05-03', 354, 13),
('The Paradise Inn', 6, '2019-05-04', 385, 13),
('The Paradise Inn', 6, '2019-05-05', 265, 13),
('The Paradise Inn', 6, '2019-05-06', 183, 13),
('The Paradise Inn', 6, '2019-05-07', 195, 13),
('The Paradise Inn', 6, '2019-05-08', 360, 13),
('The Paradise Inn', 6, '2019-05-09', 295, 13),
('The Paradise Inn', 6, '2019-05-10', 229, NULL),
('The Paradise Inn', 6, '2019-05-11', 362, NULL),
('The Paradise Inn', 6, '2019-05-12', 199, NULL),
('The Paradise Inn', 6, '2019-05-13', 381, NULL),
('The Paradise Inn', 6, '2019-05-14', 319, NULL),
('The Paradise Inn', 6, '2019-05-15', 158, NULL),
('The Paradise Inn', 6, '2019-05-16', 233, NULL),
('The Paradise Inn', 6, '2019-05-17', 219, NULL),
('The Paradise Inn', 6, '2019-05-18', 338, NULL),
('The Paradise Inn', 6, '2019-05-19', 219, NULL),
('The Paradise Inn', 6, '2019-05-20', 102, NULL),
('The Paradise Inn', 6, '2019-05-21', 135, NULL),
('The Paradise Inn', 6, '2019-05-22', 143, NULL),
('The Paradise Inn', 6, '2019-05-23', 265, NULL),
('The Paradise Inn', 6, '2019-05-24', 217, NULL),
('The Paradise Inn', 6, '2019-05-25', 199, NULL),
('The Paradise Inn', 6, '2019-05-26', 112, NULL),
('The Paradise Inn', 6, '2019-05-27', 231, NULL),
('The Paradise Inn', 6, '2019-05-28', 326, NULL),
('The Paradise Inn', 6, '2019-05-29', 377, NULL),
('The Paradise Inn', 6, '2019-05-30', 322, NULL),
('The Paradise Inn', 6, '2019-05-31', 113, NULL),
('The Paradise Inn', 6, '2019-06-01', 219, 41),
('The Paradise Inn', 6, '2019-06-02', 350, 41),
('The Paradise Inn', 6, '2019-06-03', 232, 41),
('The Paradise Inn', 6, '2019-06-04', 105, 41),
('The Paradise Inn', 6, '2019-06-05', 377, 41),
('The Paradise Inn', 6, '2019-06-06', 237, 41),
('The Paradise Inn', 6, '2019-06-07', 374, 41),
('The Paradise Inn', 6, '2019-06-08', 178, 41),
('The Paradise Inn', 6, '2019-06-09', 301, 41),
('The Paradise Inn', 6, '2019-06-10', 235, 41),
('The Paradise Inn', 6, '2019-06-11', 277, 41),
('The Paradise Inn', 6, '2019-06-12', 120, 41),
('The Paradise Inn', 6, '2019-06-13', 332, 41),
('The Paradise Inn', 6, '2019-06-14', 317, 41),
('The Paradise Inn', 6, '2019-06-15', 270, 41),
('The Paradise Inn', 6, '2019-06-16', 317, 41),
('The Paradise Inn', 6, '2019-06-17', 373, 41),
('The Paradise Inn', 6, '2019-06-18', 185, 41),
('The Paradise Inn', 6, '2019-06-19', 365, NULL),
('The Paradise Inn', 6, '2019-06-20', 136, NULL),
('The Paradise Inn', 6, '2019-06-21', 241, NULL),
('The Paradise Inn', 6, '2019-06-22', 355, NULL),
('The Paradise Inn', 6, '2019-06-23', 286, NULL),
('The Paradise Inn', 6, '2019-06-24', 259, NULL),
('The Paradise Inn', 6, '2019-06-25', 123, NULL),
('The Paradise Inn', 6, '2019-06-26', 291, 139),
('The Paradise Inn', 6, '2019-06-27', 219, 139),
('The Paradise Inn', 6, '2019-06-28', 367, 139),
('The Paradise Inn', 6, '2019-06-29', 145, 139),
('The Paradise Inn', 6, '2019-06-30', 194, 139),
('The Paradise Inn', 6, '2019-07-01', 117, 139),
('The Paradise Inn', 6, '2019-07-02', 200, 139),
('The Paradise Inn', 6, '2019-07-03', 352, 139),
('The Paradise Inn', 6, '2019-07-04', 124, 139),
('The Paradise Inn', 6, '2019-07-05', 136, 139),
('The Paradise Inn', 6, '2019-07-06', 290, 139),
('The Paradise Inn', 6, '2019-07-07', 150, 139),
('The Paradise Inn', 6, '2019-07-08', 373, 139),
('The Paradise Inn', 6, '2019-07-09', 233, 139),
('The Paradise Inn', 6, '2019-07-10', 327, 139),
('The Paradise Inn', 6, '2019-07-11', 297, 139),
('The Paradise Inn', 6, '2019-07-12', 237, 139),
('The Paradise Inn', 6, '2019-07-13', 132, NULL),
('The Paradise Inn', 6, '2019-07-14', 301, NULL),
('The Paradise Inn', 6, '2019-07-15', 278, NULL),
('The Paradise Inn', 6, '2019-07-16', 107, NULL),
('The Paradise Inn', 6, '2019-07-17', 345, NULL),
('The Paradise Inn', 6, '2019-07-18', 348, NULL),
('The Paradise Inn', 6, '2019-07-19', 389, NULL),
('The Paradise Inn', 6, '2019-07-20', 173, NULL),
('The Paradise Inn', 6, '2019-07-21', 292, NULL),
('The Paradise Inn', 6, '2019-07-22', 245, NULL),
('The Paradise Inn', 6, '2019-07-23', 388, NULL),
('The Paradise Inn', 6, '2019-07-24', 148, NULL),
('The Paradise Inn', 6, '2019-07-25', 232, NULL),
('The Paradise Inn', 6, '2019-07-26', 134, NULL),
('The Paradise Inn', 6, '2019-07-27', 373, NULL),
('The Paradise Inn', 6, '2019-07-28', 128, NULL),
('The Paradise Inn', 6, '2019-07-29', 224, NULL),
('The Paradise Inn', 6, '2019-07-30', 137, NULL),
('The Paradise Inn', 6, '2019-07-31', 376, NULL),
('The Paradise Inn', 6, '2019-08-01', 248, NULL),
('The Paradise Inn', 6, '2019-08-02', 103, NULL),
('The Paradise Inn', 6, '2019-08-03', 225, NULL),
('The Paradise Inn', 6, '2019-08-04', 311, NULL),
('The Paradise Inn', 6, '2019-08-05', 233, NULL),
('The Paradise Inn', 6, '2019-08-06', 150, NULL),
('The Paradise Inn', 6, '2019-08-07', 353, NULL),
('The Paradise Inn', 6, '2019-08-08', 211, NULL),
('The Paradise Inn', 6, '2019-08-09', 182, NULL),
('The Paradise Inn', 6, '2019-08-10', 257, NULL),
('The Paradise Inn', 6, '2019-08-11', 134, NULL),
('The Paradise Inn', 6, '2019-08-12', 123, NULL),
('The Paradise Inn', 6, '2019-08-13', 261, NULL),
('The Paradise Inn', 6, '2019-08-14', 286, NULL),
('The Paradise Inn', 6, '2019-08-15', 158, NULL),
('The Paradise Inn', 6, '2019-08-16', 360, NULL),
('The Paradise Inn', 6, '2019-08-17', 106, 122),
('The Paradise Inn', 6, '2019-08-18', 253, 122),
('The Paradise Inn', 6, '2019-08-19', 126, 122),
('The Paradise Inn', 6, '2019-08-20', 137, 122),
('The Paradise Inn', 6, '2019-08-21', 136, 122),
('The Paradise Inn', 6, '2019-08-22', 251, 122),
('The Paradise Inn', 6, '2019-08-23', 239, 122),
('The Paradise Inn', 6, '2019-08-24', 234, 122),
('The Paradise Inn', 6, '2019-08-25', 367, 122),
('The Paradise Inn', 6, '2019-08-26', 365, 122),
('The Paradise Inn', 6, '2019-08-27', 237, 122),
('The Paradise Inn', 6, '2019-08-28', 369, 122),
('The Paradise Inn', 6, '2019-08-29', 264, 122),
('The Paradise Inn', 6, '2019-08-30', 133, 122),
('The Paradise Inn', 6, '2019-08-31', 378, 122),
('The Paradise Inn', 6, '2019-09-01', 138, 122),
('The Paradise Inn', 6, '2019-09-02', 115, 122),
('The Paradise Inn', 6, '2019-09-03', 227, 122),
('The Paradise Inn', 6, '2019-09-04', 264, 122),
('The Paradise Inn', 6, '2019-09-05', 394, 122),
('The Paradise Inn', 6, '2019-09-06', 322, 122),
('The Paradise Inn', 6, '2019-09-07', 165, NULL),
('The Paradise Inn', 6, '2019-09-08', 133, 43),
('The Paradise Inn', 6, '2019-09-09', 351, 43),
('The Paradise Inn', 6, '2019-09-10', 244, 43),
('The Paradise Inn', 6, '2019-09-11', 118, 43),
('The Paradise Inn', 6, '2019-09-12', 261, 43),
('The Paradise Inn', 6, '2019-09-13', 206, 43),
('The Paradise Inn', 6, '2019-09-14', 341, 43),
('The Paradise Inn', 6, '2019-09-15', 193, NULL),
('The Paradise Inn', 6, '2019-09-16', 294, NULL),
('The Paradise Inn', 6, '2019-09-17', 316, NULL),
('The Paradise Inn', 6, '2019-09-18', 133, NULL),
('The Paradise Inn', 6, '2019-09-19', 293, NULL),
('The Paradise Inn', 6, '2019-09-20', 165, NULL),
('The Paradise Inn', 6, '2019-09-21', 322, NULL),
('The Paradise Inn', 6, '2019-09-22', 266, NULL),
('The Paradise Inn', 6, '2019-09-23', 109, NULL),
('The Paradise Inn', 6, '2019-09-24', 270, NULL),
('The Paradise Inn', 6, '2019-09-25', 320, NULL),
('The Paradise Inn', 6, '2019-09-26', 188, NULL),
('The Paradise Inn', 6, '2019-09-27', 258, NULL),
('The Paradise Inn', 6, '2019-09-28', 263, NULL),
('The Paradise Inn', 6, '2019-09-29', 250, NULL),
('The Paradise Inn', 6, '2019-09-30', 251, NULL),
('The Paradise Inn', 6, '2019-10-01', 115, NULL),
('The Paradise Inn', 6, '2019-10-02', 179, NULL),
('The Paradise Inn', 6, '2019-10-03', 316, NULL),
('The Paradise Inn', 6, '2019-10-04', 314, NULL),
('The Paradise Inn', 6, '2019-10-05', 363, NULL),
('The Paradise Inn', 6, '2019-10-06', 201, NULL),
('The Paradise Inn', 6, '2019-10-07', 152, NULL),
('The Paradise Inn', 6, '2019-10-08', 374, NULL),
('The Paradise Inn', 6, '2019-10-09', 149, NULL),
('The Paradise Inn', 6, '2019-10-10', 305, NULL),
('The Paradise Inn', 6, '2019-10-11', 107, NULL),
('The Paradise Inn', 6, '2019-10-12', 345, NULL),
('The Paradise Inn', 6, '2019-10-13', 348, NULL),
('The Paradise Inn', 6, '2019-10-14', 361, NULL),
('The Paradise Inn', 6, '2019-10-15', 146, NULL),
('The Paradise Inn', 6, '2019-10-16', 122, NULL),
('The Paradise Inn', 6, '2019-10-17', 390, NULL),
('The Paradise Inn', 6, '2019-10-18', 109, NULL),
('The Paradise Inn', 6, '2019-10-19', 331, NULL),
('The Paradise Inn', 6, '2019-10-20', 210, NULL),
('The Paradise Inn', 6, '2019-10-21', 280, NULL),
('The Paradise Inn', 6, '2019-10-22', 286, NULL),
('The Paradise Inn', 6, '2019-10-23', 161, NULL),
('The Paradise Inn', 6, '2019-10-24', 378, NULL),
('The Paradise Inn', 6, '2019-10-25', 202, NULL),
('The Paradise Inn', 6, '2019-10-26', 147, NULL),
('The Paradise Inn', 6, '2019-10-27', 171, NULL),
('The Paradise Inn', 6, '2019-10-28', 190, NULL),
('The Paradise Inn', 6, '2019-10-29', 294, NULL),
('The Paradise Inn', 6, '2019-10-30', 230, NULL),
('The Paradise Inn', 6, '2019-10-31', 372, NULL),
('The Paradise Inn', 6, '2019-11-01', 317, NULL),
('The Paradise Inn', 6, '2019-11-02', 182, NULL),
('The Paradise Inn', 6, '2019-11-03', 311, NULL),
('The Paradise Inn', 6, '2019-11-04', 229, NULL),
('The Paradise Inn', 6, '2019-11-05', 186, NULL),
('The Paradise Inn', 6, '2019-11-06', 351, NULL),
('The Paradise Inn', 6, '2019-11-07', 306, 125),
('The Paradise Inn', 6, '2019-11-08', 338, 125),
('The Paradise Inn', 6, '2019-11-09', 183, 125),
('The Paradise Inn', 6, '2019-11-10', 369, 125),
('The Paradise Inn', 6, '2019-11-11', 149, 125),
('The Paradise Inn', 6, '2019-11-12', 173, 125),
('The Paradise Inn', 6, '2019-11-13', 251, 125),
('The Paradise Inn', 6, '2019-11-14', 353, 125),
('The Paradise Inn', 6, '2019-11-15', 211, NULL),
('The Paradise Inn', 6, '2019-11-16', 251, NULL),
('The Paradise Inn', 6, '2019-11-17', 351, NULL),
('The Paradise Inn', 6, '2019-11-18', 228, NULL),
('The Paradise Inn', 6, '2019-11-19', 376, NULL),
('The Paradise Inn', 6, '2019-11-20', 292, NULL),
('The Paradise Inn', 6, '2019-11-21', 384, NULL),
('The Paradise Inn', 6, '2019-11-22', 259, NULL),
('The Paradise Inn', 6, '2019-11-23', 134, NULL),
('The Paradise Inn', 6, '2019-11-24', 178, NULL),
('The Paradise Inn', 6, '2019-11-25', 164, NULL),
('The Paradise Inn', 6, '2019-11-26', 308, NULL),
('The Paradise Inn', 6, '2019-11-27', 164, NULL),
('The Paradise Inn', 6, '2019-11-28', 380, NULL),
('The Paradise Inn', 6, '2019-11-29', 126, NULL),
('The Paradise Inn', 6, '2019-11-30', 128, NULL),
('The Paradise Inn', 6, '2019-12-01', 162, NULL),
('The Paradise Inn', 6, '2019-12-02', 141, NULL),
('The Paradise Inn', 6, '2019-12-03', 287, NULL),
('The Paradise Inn', 6, '2019-12-04', 293, NULL),
('The Paradise Inn', 6, '2019-12-05', 266, NULL),
('The Paradise Inn', 6, '2019-12-06', 164, NULL),
('The Paradise Inn', 6, '2019-12-07', 234, 178),
('The Paradise Inn', 6, '2019-12-08', 121, 178),
('The Paradise Inn', 6, '2019-12-09', 283, 178),
('The Paradise Inn', 6, '2019-12-10', 245, 178),
('The Paradise Inn', 6, '2019-12-11', 143, 178),
('The Paradise Inn', 6, '2019-12-12', 261, 178),
('The Paradise Inn', 6, '2019-12-13', 326, 178),
('The Paradise Inn', 6, '2019-12-14', 224, 178),
('The Paradise Inn', 6, '2019-12-15', 305, 178),
('The Paradise Inn', 6, '2019-12-16', 353, 178),
('The Paradise Inn', 6, '2019-12-17', 272, 178),
('The Paradise Inn', 6, '2019-12-18', 275, 178),
('The Paradise Inn', 6, '2019-12-19', 366, 178),
('The Paradise Inn', 6, '2019-12-20', 366, 178),
('The Paradise Inn', 6, '2019-12-21', 274, 178),
('The Paradise Inn', 6, '2019-12-22', 196, 178),
('The Paradise Inn', 6, '2019-12-23', 144, 178),
('The Paradise Inn', 6, '2019-12-24', 178, 178),
('The Paradise Inn', 6, '2019-12-25', 367, 178),
('The Paradise Inn', 6, '2019-12-26', 206, 178),
('The Paradise Inn', 6, '2019-12-27', 304, 178),
('The Paradise Inn', 6, '2019-12-28', 381, 178),
('The Paradise Inn', 6, '2019-12-29', 305, 178),
('The Paradise Inn', 6, '2019-12-30', 338, NULL),
('The Paradise Inn', 6, '2019-12-31', 158, NULL),
('The Paradise Inn', 6, '2020-01-01', 294, NULL),
('The Paradise Inn', 6, '2020-01-02', 297, NULL),
('The Paradise Inn', 6, '2020-01-03', 139, NULL),
('The Paradise Inn', 6, '2020-01-04', 163, NULL),
('The Paradise Inn', 6, '2020-01-05', 166, NULL),
('The Paradise Inn', 6, '2020-01-06', 383, NULL),
('The Paradise Inn', 6, '2020-01-07', 391, NULL),
('The Paradise Inn', 6, '2020-01-08', 252, NULL),
('The Paradise Inn', 6, '2020-01-09', 174, NULL),
('The Paradise Inn', 6, '2020-01-10', 201, NULL),
('The Paradise Inn', 6, '2020-01-11', 111, 68),
('The Paradise Inn', 6, '2020-01-12', 357, 68),
('The Paradise Inn', 6, '2020-01-13', 204, 68),
('The Paradise Inn', 6, '2020-01-14', 225, 68),
('The Paradise Inn', 6, '2020-01-15', 377, 68),
('The Paradise Inn', 6, '2020-01-16', 374, 68),
('The Paradise Inn', 6, '2020-01-17', 356, 68),
('The Paradise Inn', 6, '2020-01-18', 260, 68),
('The Paradise Inn', 6, '2020-01-19', 365, 68),
('The Paradise Inn', 6, '2020-01-20', 392, NULL),
('The Paradise Inn', 6, '2020-01-21', 339, NULL),
('The Paradise Inn', 6, '2020-01-22', 195, NULL),
('The Paradise Inn', 6, '2020-01-23', 219, NULL),
('The Paradise Inn', 6, '2020-01-24', 148, NULL),
('The Paradise Inn', 6, '2020-01-25', 274, NULL),
('The Paradise Inn', 6, '2020-01-26', 238, NULL),
('The Paradise Inn', 6, '2020-01-27', 380, NULL),
('The Paradise Inn', 6, '2020-01-28', 164, NULL),
('The Paradise Inn', 6, '2020-01-29', 237, NULL),
('The Paradise Inn', 6, '2020-01-30', 137, NULL),
('The Paradise Inn', 6, '2020-01-31', 225, NULL),
('The Paradise Inn', 6, '2020-02-01', 181, NULL),
('The Paradise Inn', 6, '2020-02-02', 346, NULL),
('The Paradise Inn', 6, '2020-02-03', 133, NULL),
('The Paradise Inn', 6, '2020-02-04', 336, NULL),
('The Paradise Inn', 11, '2019-01-01', 181, NULL),
('The Paradise Inn', 11, '2019-01-02', 168, NULL),
('The Paradise Inn', 11, '2019-01-03', 197, NULL),
('The Paradise Inn', 11, '2019-01-04', 215, NULL),
('The Paradise Inn', 11, '2019-01-05', 223, NULL),
('The Paradise Inn', 11, '2019-01-06', 222, NULL),
('The Paradise Inn', 11, '2019-01-07', 164, NULL),
('The Paradise Inn', 11, '2019-01-08', 244, NULL),
('The Paradise Inn', 11, '2019-01-09', 349, NULL),
('The Paradise Inn', 11, '2019-01-10', 133, NULL),
('The Paradise Inn', 11, '2019-01-11', 329, NULL),
('The Paradise Inn', 11, '2019-01-12', 280, NULL),
('The Paradise Inn', 11, '2019-01-13', 349, NULL),
('The Paradise Inn', 11, '2019-01-14', 360, NULL),
('The Paradise Inn', 11, '2019-01-15', 228, NULL),
('The Paradise Inn', 11, '2019-01-16', 294, NULL),
('The Paradise Inn', 11, '2019-01-17', 192, NULL),
('The Paradise Inn', 11, '2019-01-18', 151, NULL),
('The Paradise Inn', 11, '2019-01-19', 240, NULL),
('The Paradise Inn', 11, '2019-01-20', 159, NULL),
('The Paradise Inn', 11, '2019-01-21', 194, NULL),
('The Paradise Inn', 11, '2019-01-22', 276, NULL),
('The Paradise Inn', 11, '2019-01-23', 326, NULL),
('The Paradise Inn', 11, '2019-01-24', 278, NULL),
('The Paradise Inn', 11, '2019-01-25', 334, NULL),
('The Paradise Inn', 11, '2019-01-26', 239, NULL),
('The Paradise Inn', 11, '2019-01-27', 321, NULL),
('The Paradise Inn', 11, '2019-01-28', 159, NULL),
('The Paradise Inn', 11, '2019-01-29', 228, NULL),
('The Paradise Inn', 11, '2019-01-30', 261, NULL),
('The Paradise Inn', 11, '2019-01-31', 351, NULL),
('The Paradise Inn', 11, '2019-02-01', 274, NULL),
('The Paradise Inn', 11, '2019-02-02', 289, NULL),
('The Paradise Inn', 11, '2019-02-03', 372, NULL),
('The Paradise Inn', 11, '2019-02-04', 314, NULL),
('The Paradise Inn', 11, '2019-02-05', 322, NULL),
('The Paradise Inn', 11, '2019-02-06', 276, NULL),
('The Paradise Inn', 11, '2019-02-07', 309, NULL),
('The Paradise Inn', 11, '2019-02-08', 116, NULL),
('The Paradise Inn', 11, '2019-02-09', 279, NULL),
('The Paradise Inn', 11, '2019-02-10', 247, NULL),
('The Paradise Inn', 11, '2019-02-11', 134, NULL),
('The Paradise Inn', 11, '2019-02-12', 124, NULL),
('The Paradise Inn', 11, '2019-02-13', 247, NULL),
('The Paradise Inn', 11, '2019-02-14', 365, NULL),
('The Paradise Inn', 11, '2019-02-15', 101, NULL),
('The Paradise Inn', 11, '2019-02-16', 171, NULL),
('The Paradise Inn', 11, '2019-02-17', 171, NULL),
('The Paradise Inn', 11, '2019-02-18', 127, NULL),
('The Paradise Inn', 11, '2019-02-19', 377, NULL),
('The Paradise Inn', 11, '2019-02-20', 360, NULL),
('The Paradise Inn', 11, '2019-02-21', 142, NULL),
('The Paradise Inn', 11, '2019-02-22', 373, NULL),
('The Paradise Inn', 11, '2019-02-23', 139, NULL),
('The Paradise Inn', 11, '2019-02-24', 362, NULL),
('The Paradise Inn', 11, '2019-02-25', 206, NULL),
('The Paradise Inn', 11, '2019-02-26', 378, NULL),
('The Paradise Inn', 11, '2019-02-27', 202, NULL),
('The Paradise Inn', 11, '2019-02-28', 205, NULL),
('The Paradise Inn', 11, '2019-03-01', 126, NULL),
('The Paradise Inn', 11, '2019-03-02', 222, NULL),
('The Paradise Inn', 11, '2019-03-03', 329, NULL),
('The Paradise Inn', 11, '2019-03-04', 262, NULL),
('The Paradise Inn', 11, '2019-03-05', 176, NULL),
('The Paradise Inn', 11, '2019-03-06', 325, NULL),
('The Paradise Inn', 11, '2019-03-07', 238, NULL),
('The Paradise Inn', 11, '2019-03-08', 155, NULL),
('The Paradise Inn', 11, '2019-03-09', 108, NULL),
('The Paradise Inn', 11, '2019-03-10', 305, NULL),
('The Paradise Inn', 11, '2019-03-11', 178, NULL),
('The Paradise Inn', 11, '2019-03-12', 200, NULL),
('The Paradise Inn', 11, '2019-03-13', 126, NULL),
('The Paradise Inn', 11, '2019-03-14', 352, NULL),
('The Paradise Inn', 11, '2019-03-15', 222, NULL),
('The Paradise Inn', 11, '2019-03-16', 307, NULL),
('The Paradise Inn', 11, '2019-03-17', 294, NULL),
('The Paradise Inn', 11, '2019-03-18', 282, NULL),
('The Paradise Inn', 11, '2019-03-19', 378, NULL),
('The Paradise Inn', 11, '2019-03-20', 187, NULL),
('The Paradise Inn', 11, '2019-03-21', 240, NULL),
('The Paradise Inn', 11, '2019-03-22', 327, NULL),
('The Paradise Inn', 11, '2019-03-23', 167, NULL),
('The Paradise Inn', 11, '2019-03-24', 172, NULL),
('The Paradise Inn', 11, '2019-03-25', 191, NULL),
('The Paradise Inn', 11, '2019-03-26', 282, NULL),
('The Paradise Inn', 11, '2019-03-27', 241, NULL),
('The Paradise Inn', 11, '2019-03-28', 206, NULL),
('The Paradise Inn', 11, '2019-03-29', 129, NULL),
('The Paradise Inn', 11, '2019-03-30', 316, NULL),
('The Paradise Inn', 11, '2019-03-31', 114, NULL),
('The Paradise Inn', 11, '2019-04-01', 152, NULL),
('The Paradise Inn', 11, '2019-04-02', 100, NULL),
('The Paradise Inn', 11, '2019-04-03', 160, NULL),
('The Paradise Inn', 11, '2019-04-04', 354, NULL),
('The Paradise Inn', 11, '2019-04-05', 387, NULL),
('The Paradise Inn', 11, '2019-04-06', 360, NULL),
('The Paradise Inn', 11, '2019-04-07', 255, NULL),
('The Paradise Inn', 11, '2019-04-08', 253, NULL),
('The Paradise Inn', 11, '2019-04-09', 243, NULL),
('The Paradise Inn', 11, '2019-04-10', 291, NULL),
('The Paradise Inn', 11, '2019-04-11', 126, NULL),
('The Paradise Inn', 11, '2019-04-12', 313, NULL),
('The Paradise Inn', 11, '2019-04-13', 251, NULL),
('The Paradise Inn', 11, '2019-04-14', 162, NULL),
('The Paradise Inn', 11, '2019-04-15', 295, NULL),
('The Paradise Inn', 11, '2019-04-16', 253, NULL),
('The Paradise Inn', 11, '2019-04-17', 180, NULL),
('The Paradise Inn', 11, '2019-04-18', 180, NULL),
('The Paradise Inn', 11, '2019-04-19', 359, NULL),
('The Paradise Inn', 11, '2019-04-20', 192, NULL),
('The Paradise Inn', 11, '2019-04-21', 236, NULL),
('The Paradise Inn', 11, '2019-04-22', 181, NULL),
('The Paradise Inn', 11, '2019-04-23', 131, NULL),
('The Paradise Inn', 11, '2019-04-24', 282, NULL),
('The Paradise Inn', 11, '2019-04-25', 209, NULL),
('The Paradise Inn', 11, '2019-04-26', 365, 138),
('The Paradise Inn', 11, '2019-04-27', 125, 138),
('The Paradise Inn', 11, '2019-04-28', 253, 138),
('The Paradise Inn', 11, '2019-04-29', 163, 138),
('The Paradise Inn', 11, '2019-04-30', 380, 138),
('The Paradise Inn', 11, '2019-05-01', 315, 138),
('The Paradise Inn', 11, '2019-05-02', 253, 138),
('The Paradise Inn', 11, '2019-05-03', 140, NULL),
('The Paradise Inn', 11, '2019-05-04', 391, NULL),
('The Paradise Inn', 11, '2019-05-05', 352, NULL),
('The Paradise Inn', 11, '2019-05-06', 336, NULL),
('The Paradise Inn', 11, '2019-05-07', 212, NULL),
('The Paradise Inn', 11, '2019-05-08', 362, NULL),
('The Paradise Inn', 11, '2019-05-09', 117, NULL),
('The Paradise Inn', 11, '2019-05-10', 358, NULL),
('The Paradise Inn', 11, '2019-05-11', 348, NULL),
('The Paradise Inn', 11, '2019-05-12', 347, NULL),
('The Paradise Inn', 11, '2019-05-13', 107, NULL),
('The Paradise Inn', 11, '2019-05-14', 137, NULL),
('The Paradise Inn', 11, '2019-05-15', 117, NULL),
('The Paradise Inn', 11, '2019-05-16', 202, NULL),
('The Paradise Inn', 11, '2019-05-17', 274, NULL),
('The Paradise Inn', 11, '2019-05-18', 372, NULL),
('The Paradise Inn', 11, '2019-05-19', 104, NULL),
('The Paradise Inn', 11, '2019-05-20', 108, NULL),
('The Paradise Inn', 11, '2019-05-21', 268, NULL),
('The Paradise Inn', 11, '2019-05-22', 313, NULL),
('The Paradise Inn', 11, '2019-05-23', 396, NULL),
('The Paradise Inn', 11, '2019-05-24', 314, NULL),
('The Paradise Inn', 11, '2019-05-25', 139, NULL),
('The Paradise Inn', 11, '2019-05-26', 277, NULL),
('The Paradise Inn', 11, '2019-05-27', 367, NULL),
('The Paradise Inn', 11, '2019-05-28', 291, NULL),
('The Paradise Inn', 11, '2019-05-29', 307, NULL),
('The Paradise Inn', 11, '2019-05-30', 395, 179),
('The Paradise Inn', 11, '2019-05-31', 201, 179),
('The Paradise Inn', 11, '2019-06-01', 281, 179),
('The Paradise Inn', 11, '2019-06-02', 167, 179),
('The Paradise Inn', 11, '2019-06-03', 261, 179),
('The Paradise Inn', 11, '2019-06-04', 209, 179),
('The Paradise Inn', 11, '2019-06-05', 147, 179),
('The Paradise Inn', 11, '2019-06-06', 375, 179),
('The Paradise Inn', 11, '2019-06-07', 280, NULL),
('The Paradise Inn', 11, '2019-06-08', 253, NULL),
('The Paradise Inn', 11, '2019-06-09', 281, NULL),
('The Paradise Inn', 11, '2019-06-10', 390, NULL),
('The Paradise Inn', 11, '2019-06-11', 372, NULL),
('The Paradise Inn', 11, '2019-06-12', 159, NULL),
('The Paradise Inn', 11, '2019-06-13', 167, NULL),
('The Paradise Inn', 11, '2019-06-14', 256, NULL),
('The Paradise Inn', 11, '2019-06-15', 279, NULL),
('The Paradise Inn', 11, '2019-06-16', 216, NULL),
('The Paradise Inn', 11, '2019-06-17', 161, NULL),
('The Paradise Inn', 11, '2019-06-18', 278, NULL),
('The Paradise Inn', 11, '2019-06-19', 182, 172),
('The Paradise Inn', 11, '2019-06-20', 156, 172),
('The Paradise Inn', 11, '2019-06-21', 191, 172),
('The Paradise Inn', 11, '2019-06-22', 148, 172),
('The Paradise Inn', 11, '2019-06-23', 251, 172),
('The Paradise Inn', 11, '2019-06-24', 190, 172),
('The Paradise Inn', 11, '2019-06-25', 273, 172),
('The Paradise Inn', 11, '2019-06-26', 170, 172),
('The Paradise Inn', 11, '2019-06-27', 174, 172),
('The Paradise Inn', 11, '2019-06-28', 326, 172),
('The Paradise Inn', 11, '2019-06-29', 119, 172),
('The Paradise Inn', 11, '2019-06-30', 222, 172),
('The Paradise Inn', 11, '2019-07-01', 225, 172),
('The Paradise Inn', 11, '2019-07-02', 148, 172),
('The Paradise Inn', 11, '2019-07-03', 272, 172),
('The Paradise Inn', 11, '2019-07-04', 259, 172),
('The Paradise Inn', 11, '2019-07-05', 263, 172),
('The Paradise Inn', 11, '2019-07-06', 371, 172),
('The Paradise Inn', 11, '2019-07-07', 367, 172),
('The Paradise Inn', 11, '2019-07-08', 385, NULL),
('The Paradise Inn', 11, '2019-07-09', 123, NULL),
('The Paradise Inn', 11, '2019-07-10', 211, NULL),
('The Paradise Inn', 11, '2019-07-11', 335, NULL),
('The Paradise Inn', 11, '2019-07-12', 272, NULL),
('The Paradise Inn', 11, '2019-07-13', 314, NULL),
('The Paradise Inn', 11, '2019-07-14', 323, NULL),
('The Paradise Inn', 11, '2019-07-15', 262, NULL),
('The Paradise Inn', 11, '2019-07-16', 210, NULL),
('The Paradise Inn', 11, '2019-07-17', 181, NULL),
('The Paradise Inn', 11, '2019-07-18', 142, NULL),
('The Paradise Inn', 11, '2019-07-19', 111, NULL),
('The Paradise Inn', 11, '2019-07-20', 198, NULL),
('The Paradise Inn', 11, '2019-07-21', 158, NULL),
('The Paradise Inn', 11, '2019-07-22', 289, NULL),
('The Paradise Inn', 11, '2019-07-23', 200, NULL),
('The Paradise Inn', 11, '2019-07-24', 200, NULL),
('The Paradise Inn', 11, '2019-07-25', 370, NULL),
('The Paradise Inn', 11, '2019-07-26', 244, NULL),
('The Paradise Inn', 11, '2019-07-27', 248, NULL),
('The Paradise Inn', 11, '2019-07-28', 193, NULL),
('The Paradise Inn', 11, '2019-07-29', 263, NULL),
('The Paradise Inn', 11, '2019-07-30', 284, NULL),
('The Paradise Inn', 11, '2019-07-31', 166, NULL),
('The Paradise Inn', 11, '2019-08-01', 292, NULL),
('The Paradise Inn', 11, '2019-08-02', 347, NULL),
('The Paradise Inn', 11, '2019-08-03', 214, NULL),
('The Paradise Inn', 11, '2019-08-04', 328, NULL),
('The Paradise Inn', 11, '2019-08-05', 229, NULL),
('The Paradise Inn', 11, '2019-08-06', 159, NULL),
('The Paradise Inn', 11, '2019-08-07', 264, NULL),
('The Paradise Inn', 11, '2019-08-08', 141, NULL),
('The Paradise Inn', 11, '2019-08-09', 237, NULL),
('The Paradise Inn', 11, '2019-08-10', 146, NULL),
('The Paradise Inn', 11, '2019-08-11', 224, NULL),
('The Paradise Inn', 11, '2019-08-12', 351, NULL),
('The Paradise Inn', 11, '2019-08-13', 141, NULL),
('The Paradise Inn', 11, '2019-08-14', 315, NULL),
('The Paradise Inn', 11, '2019-08-15', 174, NULL),
('The Paradise Inn', 11, '2019-08-16', 205, NULL),
('The Paradise Inn', 11, '2019-08-17', 339, NULL),
('The Paradise Inn', 11, '2019-08-18', 389, NULL),
('The Paradise Inn', 11, '2019-08-19', 309, NULL),
('The Paradise Inn', 11, '2019-08-20', 166, NULL),
('The Paradise Inn', 11, '2019-08-21', 164, NULL),
('The Paradise Inn', 11, '2019-08-22', 334, NULL),
('The Paradise Inn', 11, '2019-08-23', 328, NULL),
('The Paradise Inn', 11, '2019-08-24', 148, NULL),
('The Paradise Inn', 11, '2019-08-25', 359, NULL),
('The Paradise Inn', 11, '2019-08-26', 393, NULL),
('The Paradise Inn', 11, '2019-08-27', 394, NULL),
('The Paradise Inn', 11, '2019-08-28', 247, NULL),
('The Paradise Inn', 11, '2019-08-29', 340, NULL),
('The Paradise Inn', 11, '2019-08-30', 236, NULL),
('The Paradise Inn', 11, '2019-08-31', 141, NULL),
('The Paradise Inn', 11, '2019-09-01', 231, NULL),
('The Paradise Inn', 11, '2019-09-02', 203, NULL),
('The Paradise Inn', 11, '2019-09-03', 171, NULL),
('The Paradise Inn', 11, '2019-09-04', 113, NULL),
('The Paradise Inn', 11, '2019-09-05', 317, NULL),
('The Paradise Inn', 11, '2019-09-06', 174, NULL),
('The Paradise Inn', 11, '2019-09-07', 362, NULL),
('The Paradise Inn', 11, '2019-09-08', 165, NULL),
('The Paradise Inn', 11, '2019-09-09', 303, NULL),
('The Paradise Inn', 11, '2019-09-10', 264, NULL),
('The Paradise Inn', 11, '2019-09-11', 308, NULL),
('The Paradise Inn', 11, '2019-09-12', 195, NULL),
('The Paradise Inn', 11, '2019-09-13', 267, NULL),
('The Paradise Inn', 11, '2019-09-14', 124, NULL),
('The Paradise Inn', 11, '2019-09-15', 276, NULL),
('The Paradise Inn', 11, '2019-09-16', 254, NULL),
('The Paradise Inn', 11, '2019-09-17', 236, NULL),
('The Paradise Inn', 11, '2019-09-18', 370, NULL),
('The Paradise Inn', 11, '2019-09-19', 265, NULL),
('The Paradise Inn', 11, '2019-09-20', 296, NULL),
('The Paradise Inn', 11, '2019-09-21', 366, NULL),
('The Paradise Inn', 11, '2019-09-22', 296, NULL),
('The Paradise Inn', 11, '2019-09-23', 144, NULL),
('The Paradise Inn', 11, '2019-09-24', 372, NULL),
('The Paradise Inn', 11, '2019-09-25', 329, NULL),
('The Paradise Inn', 11, '2019-09-26', 391, NULL),
('The Paradise Inn', 11, '2019-09-27', 119, NULL),
('The Paradise Inn', 11, '2019-09-28', 301, NULL),
('The Paradise Inn', 11, '2019-09-29', 117, NULL),
('The Paradise Inn', 11, '2019-09-30', 382, NULL),
('The Paradise Inn', 11, '2019-10-01', 340, NULL),
('The Paradise Inn', 11, '2019-10-02', 220, NULL),
('The Paradise Inn', 11, '2019-10-03', 229, NULL),
('The Paradise Inn', 11, '2019-10-04', 187, NULL),
('The Paradise Inn', 11, '2019-10-05', 156, NULL),
('The Paradise Inn', 11, '2019-10-06', 381, NULL),
('The Paradise Inn', 11, '2019-10-07', 146, NULL),
('The Paradise Inn', 11, '2019-10-08', 397, NULL),
('The Paradise Inn', 11, '2019-10-09', 242, NULL),
('The Paradise Inn', 11, '2019-10-10', 304, NULL),
('The Paradise Inn', 11, '2019-10-11', 299, NULL),
('The Paradise Inn', 11, '2019-10-12', 389, NULL),
('The Paradise Inn', 11, '2019-10-13', 160, NULL),
('The Paradise Inn', 11, '2019-10-14', 216, NULL),
('The Paradise Inn', 11, '2019-10-15', 397, NULL),
('The Paradise Inn', 11, '2019-10-16', 388, NULL),
('The Paradise Inn', 11, '2019-10-17', 254, NULL),
('The Paradise Inn', 11, '2019-10-18', 290, NULL),
('The Paradise Inn', 11, '2019-10-19', 207, NULL),
('The Paradise Inn', 11, '2019-10-20', 256, NULL),
('The Paradise Inn', 11, '2019-10-21', 287, NULL),
('The Paradise Inn', 11, '2019-10-22', 253, NULL),
('The Paradise Inn', 11, '2019-10-23', 198, NULL),
('The Paradise Inn', 11, '2019-10-24', 247, NULL),
('The Paradise Inn', 11, '2019-10-25', 370, NULL),
('The Paradise Inn', 11, '2019-10-26', 229, NULL),
('The Paradise Inn', 11, '2019-10-27', 284, NULL),
('The Paradise Inn', 11, '2019-10-28', 160, NULL),
('The Paradise Inn', 11, '2019-10-29', 271, NULL),
('The Paradise Inn', 11, '2019-10-30', 378, NULL),
('The Paradise Inn', 11, '2019-10-31', 196, NULL),
('The Paradise Inn', 11, '2019-11-01', 232, NULL),
('The Paradise Inn', 11, '2019-11-02', 179, NULL),
('The Paradise Inn', 11, '2019-11-03', 347, NULL),
('The Paradise Inn', 11, '2019-11-04', 390, NULL),
('The Paradise Inn', 11, '2019-11-05', 116, NULL),
('The Paradise Inn', 11, '2019-11-06', 115, NULL),
('The Paradise Inn', 11, '2019-11-07', 268, NULL),
('The Paradise Inn', 11, '2019-11-08', 270, NULL),
('The Paradise Inn', 11, '2019-11-09', 135, NULL),
('The Paradise Inn', 11, '2019-11-10', 222, NULL),
('The Paradise Inn', 11, '2019-11-11', 221, NULL),
('The Paradise Inn', 11, '2019-11-12', 323, NULL),
('The Paradise Inn', 11, '2019-11-13', 234, NULL),
('The Paradise Inn', 11, '2019-11-14', 268, NULL),
('The Paradise Inn', 11, '2019-11-15', 326, NULL),
('The Paradise Inn', 11, '2019-11-16', 145, NULL),
('The Paradise Inn', 11, '2019-11-17', 161, NULL),
('The Paradise Inn', 11, '2019-11-18', 194, NULL),
('The Paradise Inn', 11, '2019-11-19', 175, NULL),
('The Paradise Inn', 11, '2019-11-20', 330, NULL),
('The Paradise Inn', 11, '2019-11-21', 376, NULL),
('The Paradise Inn', 11, '2019-11-22', 398, NULL),
('The Paradise Inn', 11, '2019-11-23', 174, NULL),
('The Paradise Inn', 11, '2019-11-24', 136, NULL),
('The Paradise Inn', 11, '2019-11-25', 101, NULL),
('The Paradise Inn', 11, '2019-11-26', 234, NULL),
('The Paradise Inn', 11, '2019-11-27', 274, NULL),
('The Paradise Inn', 11, '2019-11-28', 239, NULL),
('The Paradise Inn', 11, '2019-11-29', 225, NULL),
('The Paradise Inn', 11, '2019-11-30', 185, NULL),
('The Paradise Inn', 11, '2019-12-01', 367, NULL),
('The Paradise Inn', 11, '2019-12-02', 262, NULL),
('The Paradise Inn', 11, '2019-12-03', 111, NULL),
('The Paradise Inn', 11, '2019-12-04', 383, NULL),
('The Paradise Inn', 11, '2019-12-05', 361, NULL),
('The Paradise Inn', 11, '2019-12-06', 360, NULL),
('The Paradise Inn', 11, '2019-12-07', 190, NULL),
('The Paradise Inn', 11, '2019-12-08', 265, NULL),
('The Paradise Inn', 11, '2019-12-09', 361, NULL),
('The Paradise Inn', 11, '2019-12-10', 145, NULL),
('The Paradise Inn', 11, '2019-12-11', 189, NULL),
('The Paradise Inn', 11, '2019-12-12', 225, NULL),
('The Paradise Inn', 11, '2019-12-13', 170, NULL),
('The Paradise Inn', 11, '2019-12-14', 139, NULL),
('The Paradise Inn', 11, '2019-12-15', 290, NULL),
('The Paradise Inn', 11, '2019-12-16', 233, NULL),
('The Paradise Inn', 11, '2019-12-17', 316, NULL),
('The Paradise Inn', 11, '2019-12-18', 177, NULL),
('The Paradise Inn', 11, '2019-12-19', 275, NULL),
('The Paradise Inn', 11, '2019-12-20', 326, NULL),
('The Paradise Inn', 11, '2019-12-21', 277, NULL),
('The Paradise Inn', 11, '2019-12-22', 253, NULL),
('The Paradise Inn', 11, '2019-12-23', 343, NULL),
('The Paradise Inn', 11, '2019-12-24', 343, NULL),
('The Paradise Inn', 11, '2019-12-25', 291, NULL),
('The Paradise Inn', 11, '2019-12-26', 169, NULL),
('The Paradise Inn', 11, '2019-12-27', 222, NULL),
('The Paradise Inn', 11, '2019-12-28', 226, NULL),
('The Paradise Inn', 11, '2019-12-29', 376, NULL),
('The Paradise Inn', 11, '2019-12-30', 225, NULL),
('The Paradise Inn', 11, '2019-12-31', 196, NULL),
('The Paradise Inn', 11, '2020-01-01', 158, NULL),
('The Paradise Inn', 11, '2020-01-02', 360, NULL),
('The Paradise Inn', 11, '2020-01-03', 154, NULL),
('The Paradise Inn', 11, '2020-01-04', 103, NULL),
('The Paradise Inn', 11, '2020-01-05', 210, NULL),
('The Paradise Inn', 11, '2020-01-06', 215, NULL),
('The Paradise Inn', 11, '2020-01-07', 239, NULL),
('The Paradise Inn', 11, '2020-01-08', 305, NULL),
('The Paradise Inn', 11, '2020-01-09', 372, NULL),
('The Paradise Inn', 11, '2020-01-10', 222, NULL),
('The Paradise Inn', 11, '2020-01-11', 338, NULL),
('The Paradise Inn', 11, '2020-01-12', 235, NULL),
('The Paradise Inn', 11, '2020-01-13', 182, NULL),
('The Paradise Inn', 11, '2020-01-14', 388, NULL),
('The Paradise Inn', 11, '2020-01-15', 108, NULL),
('The Paradise Inn', 11, '2020-01-16', 116, NULL),
('The Paradise Inn', 11, '2020-01-17', 275, NULL),
('The Paradise Inn', 11, '2020-01-18', 137, NULL),
('The Paradise Inn', 11, '2020-01-19', 216, NULL),
('The Paradise Inn', 11, '2020-01-20', 103, NULL),
('The Paradise Inn', 11, '2020-01-21', 317, NULL),
('The Paradise Inn', 11, '2020-01-22', 303, NULL),
('The Paradise Inn', 11, '2020-01-23', 335, NULL),
('The Paradise Inn', 11, '2020-01-24', 377, NULL),
('The Paradise Inn', 11, '2020-01-25', 274, NULL),
('The Paradise Inn', 11, '2020-01-26', 161, NULL),
('The Paradise Inn', 11, '2020-01-27', 244, NULL),
('The Paradise Inn', 11, '2020-01-28', 197, NULL),
('The Paradise Inn', 11, '2020-01-29', 201, NULL),
('The Paradise Inn', 11, '2020-01-30', 307, NULL),
('The Paradise Inn', 11, '2020-01-31', 328, NULL),
('The Paradise Inn', 11, '2020-02-01', 188, NULL),
('The Paradise Inn', 11, '2020-02-02', 235, NULL),
('The Paradise Inn', 11, '2020-02-03', 168, NULL),
('The Paradise Inn', 11, '2020-02-04', 178, NULL),
('The Paradise Inn', 15, '2019-01-01', 290, NULL),
('The Paradise Inn', 15, '2019-01-02', 216, NULL),
('The Paradise Inn', 15, '2019-01-03', 273, NULL),
('The Paradise Inn', 15, '2019-01-04', 135, NULL),
('The Paradise Inn', 15, '2019-01-05', 267, NULL),
('The Paradise Inn', 15, '2019-01-06', 119, NULL),
('The Paradise Inn', 15, '2019-01-07', 254, NULL),
('The Paradise Inn', 15, '2019-01-08', 370, NULL),
('The Paradise Inn', 15, '2019-01-09', 324, NULL),
('The Paradise Inn', 15, '2019-01-10', 235, NULL),
('The Paradise Inn', 15, '2019-01-11', 219, NULL),
('The Paradise Inn', 15, '2019-01-12', 284, NULL),
('The Paradise Inn', 15, '2019-01-13', 375, NULL),
('The Paradise Inn', 15, '2019-01-14', 288, NULL),
('The Paradise Inn', 15, '2019-01-15', 382, NULL),
('The Paradise Inn', 15, '2019-01-16', 189, NULL),
('The Paradise Inn', 15, '2019-01-17', 161, NULL),
('The Paradise Inn', 15, '2019-01-18', 218, NULL),
('The Paradise Inn', 15, '2019-01-19', 257, NULL),
('The Paradise Inn', 15, '2019-01-20', 293, NULL),
('The Paradise Inn', 15, '2019-01-21', 173, NULL),
('The Paradise Inn', 15, '2019-01-22', 104, NULL),
('The Paradise Inn', 15, '2019-01-23', 249, NULL),
('The Paradise Inn', 15, '2019-01-24', 344, NULL),
('The Paradise Inn', 15, '2019-01-25', 392, NULL),
('The Paradise Inn', 15, '2019-01-26', 181, NULL),
('The Paradise Inn', 15, '2019-01-27', 303, NULL),
('The Paradise Inn', 15, '2019-01-28', 168, NULL),
('The Paradise Inn', 15, '2019-01-29', 239, NULL),
('The Paradise Inn', 15, '2019-01-30', 190, NULL),
('The Paradise Inn', 15, '2019-01-31', 339, NULL),
('The Paradise Inn', 15, '2019-02-01', 314, NULL),
('The Paradise Inn', 15, '2019-02-02', 295, NULL),
('The Paradise Inn', 15, '2019-02-03', 126, NULL),
('The Paradise Inn', 15, '2019-02-04', 154, NULL),
('The Paradise Inn', 15, '2019-02-05', 180, NULL),
('The Paradise Inn', 15, '2019-02-06', 382, NULL),
('The Paradise Inn', 15, '2019-02-07', 364, NULL),
('The Paradise Inn', 15, '2019-02-08', 350, NULL),
('The Paradise Inn', 15, '2019-02-09', 106, NULL),
('The Paradise Inn', 15, '2019-02-10', 393, NULL),
('The Paradise Inn', 15, '2019-02-11', 245, NULL),
('The Paradise Inn', 15, '2019-02-12', 132, NULL),
('The Paradise Inn', 15, '2019-02-13', 203, NULL),
('The Paradise Inn', 15, '2019-02-14', 250, NULL),
('The Paradise Inn', 15, '2019-02-15', 272, NULL),
('The Paradise Inn', 15, '2019-02-16', 281, NULL),
('The Paradise Inn', 15, '2019-02-17', 183, NULL),
('The Paradise Inn', 15, '2019-02-18', 319, NULL),
('The Paradise Inn', 15, '2019-02-19', 304, NULL),
('The Paradise Inn', 15, '2019-02-20', 165, NULL),
('The Paradise Inn', 15, '2019-02-21', 384, NULL),
('The Paradise Inn', 15, '2019-02-22', 186, NULL),
('The Paradise Inn', 15, '2019-02-23', 320, NULL),
('The Paradise Inn', 15, '2019-02-24', 103, NULL),
('The Paradise Inn', 15, '2019-02-25', 271, NULL),
('The Paradise Inn', 15, '2019-02-26', 336, NULL),
('The Paradise Inn', 15, '2019-02-27', 209, NULL),
('The Paradise Inn', 15, '2019-02-28', 119, NULL),
('The Paradise Inn', 15, '2019-03-01', 178, NULL),
('The Paradise Inn', 15, '2019-03-02', 115, NULL),
('The Paradise Inn', 15, '2019-03-03', 188, NULL),
('The Paradise Inn', 15, '2019-03-04', 190, NULL),
('The Paradise Inn', 15, '2019-03-05', 175, NULL),
('The Paradise Inn', 15, '2019-03-06', 345, NULL),
('The Paradise Inn', 15, '2019-03-07', 229, NULL),
('The Paradise Inn', 15, '2019-03-08', 177, NULL),
('The Paradise Inn', 15, '2019-03-09', 202, NULL),
('The Paradise Inn', 15, '2019-03-10', 299, NULL),
('The Paradise Inn', 15, '2019-03-11', 160, NULL),
('The Paradise Inn', 15, '2019-03-12', 281, NULL),
('The Paradise Inn', 15, '2019-03-13', 364, NULL),
('The Paradise Inn', 15, '2019-03-14', 321, NULL),
('The Paradise Inn', 15, '2019-03-15', 146, NULL),
('The Paradise Inn', 15, '2019-03-16', 146, NULL),
('The Paradise Inn', 15, '2019-03-17', 188, NULL),
('The Paradise Inn', 15, '2019-03-18', 137, NULL),
('The Paradise Inn', 15, '2019-03-19', 349, NULL),
('The Paradise Inn', 15, '2019-03-20', 315, NULL),
('The Paradise Inn', 15, '2019-03-21', 327, NULL),
('The Paradise Inn', 15, '2019-03-22', 301, NULL),
('The Paradise Inn', 15, '2019-03-23', 104, NULL),
('The Paradise Inn', 15, '2019-03-24', 306, NULL),
('The Paradise Inn', 15, '2019-03-25', 105, NULL),
('The Paradise Inn', 15, '2019-03-26', 291, NULL),
('The Paradise Inn', 15, '2019-03-27', 304, NULL),
('The Paradise Inn', 15, '2019-03-28', 217, NULL),
('The Paradise Inn', 15, '2019-03-29', 392, NULL),
('The Paradise Inn', 15, '2019-03-30', 214, NULL),
('The Paradise Inn', 15, '2019-03-31', 126, NULL),
('The Paradise Inn', 15, '2019-04-01', 169, NULL),
('The Paradise Inn', 15, '2019-04-02', 167, NULL),
('The Paradise Inn', 15, '2019-04-03', 280, NULL),
('The Paradise Inn', 15, '2019-04-04', 356, NULL),
('The Paradise Inn', 15, '2019-04-05', 326, NULL),
('The Paradise Inn', 15, '2019-04-06', 293, NULL),
('The Paradise Inn', 15, '2019-04-07', 249, NULL),
('The Paradise Inn', 15, '2019-04-08', 352, NULL),
('The Paradise Inn', 15, '2019-04-09', 339, NULL),
('The Paradise Inn', 15, '2019-04-10', 390, NULL),
('The Paradise Inn', 15, '2019-04-11', 326, NULL),
('The Paradise Inn', 15, '2019-04-12', 301, NULL),
('The Paradise Inn', 15, '2019-04-13', 258, NULL),
('The Paradise Inn', 15, '2019-04-14', 197, NULL),
('The Paradise Inn', 15, '2019-04-15', 360, NULL),
('The Paradise Inn', 15, '2019-04-16', 131, NULL),
('The Paradise Inn', 15, '2019-04-17', 385, NULL),
('The Paradise Inn', 15, '2019-04-18', 166, NULL),
('The Paradise Inn', 15, '2019-04-19', 222, NULL),
('The Paradise Inn', 15, '2019-04-20', 397, NULL),
('The Paradise Inn', 15, '2019-04-21', 268, NULL),
('The Paradise Inn', 15, '2019-04-22', 103, NULL),
('The Paradise Inn', 15, '2019-04-23', 323, NULL),
('The Paradise Inn', 15, '2019-04-24', 151, NULL),
('The Paradise Inn', 15, '2019-04-25', 148, NULL),
('The Paradise Inn', 15, '2019-04-26', 289, NULL),
('The Paradise Inn', 15, '2019-04-27', 359, NULL),
('The Paradise Inn', 15, '2019-04-28', 351, NULL),
('The Paradise Inn', 15, '2019-04-29', 142, NULL),
('The Paradise Inn', 15, '2019-04-30', 120, NULL),
('The Paradise Inn', 15, '2019-05-01', 322, NULL),
('The Paradise Inn', 15, '2019-05-02', 198, NULL),
('The Paradise Inn', 15, '2019-05-03', 139, NULL),
('The Paradise Inn', 15, '2019-05-04', 399, NULL),
('The Paradise Inn', 15, '2019-05-05', 265, NULL),
('The Paradise Inn', 15, '2019-05-06', 131, NULL),
('The Paradise Inn', 15, '2019-05-07', 378, NULL),
('The Paradise Inn', 15, '2019-05-08', 330, NULL),
('The Paradise Inn', 15, '2019-05-09', 199, NULL),
('The Paradise Inn', 15, '2019-05-10', 106, 182),
('The Paradise Inn', 15, '2019-05-11', 257, 182),
('The Paradise Inn', 15, '2019-05-12', 135, 182),
('The Paradise Inn', 15, '2019-05-13', 191, 182),
('The Paradise Inn', 15, '2019-05-14', 230, 182),
('The Paradise Inn', 15, '2019-05-15', 314, 182),
('The Paradise Inn', 15, '2019-05-16', 212, 182),
('The Paradise Inn', 15, '2019-05-17', 312, 182),
('The Paradise Inn', 15, '2019-05-18', 147, 182),
('The Paradise Inn', 15, '2019-05-19', 363, 182),
('The Paradise Inn', 15, '2019-05-20', 135, 182),
('The Paradise Inn', 15, '2019-05-21', 236, 182),
('The Paradise Inn', 15, '2019-05-22', 140, 182),
('The Paradise Inn', 15, '2019-05-23', 183, 182),
('The Paradise Inn', 15, '2019-05-24', 221, 182),
('The Paradise Inn', 15, '2019-05-25', 298, 182),
('The Paradise Inn', 15, '2019-05-26', 351, 182),
('The Paradise Inn', 15, '2019-05-27', 143, 182),
('The Paradise Inn', 15, '2019-05-28', 379, 182),
('The Paradise Inn', 15, '2019-05-29', 301, 182),
('The Paradise Inn', 15, '2019-05-30', 308, 182),
('The Paradise Inn', 15, '2019-05-31', 265, 182),
('The Paradise Inn', 15, '2019-06-01', 349, 182),
('The Paradise Inn', 15, '2019-06-02', 284, 182),
('The Paradise Inn', 15, '2019-06-03', 208, 182),
('The Paradise Inn', 15, '2019-06-04', 330, 182),
('The Paradise Inn', 15, '2019-06-05', 104, 182),
('The Paradise Inn', 15, '2019-06-06', 164, 182),
('The Paradise Inn', 15, '2019-06-07', 179, NULL),
('The Paradise Inn', 15, '2019-06-08', 334, NULL),
('The Paradise Inn', 15, '2019-06-09', 399, NULL),
('The Paradise Inn', 15, '2019-06-10', 245, NULL),
('The Paradise Inn', 15, '2019-06-11', 328, NULL),
('The Paradise Inn', 15, '2019-06-12', 338, NULL),
('The Paradise Inn', 15, '2019-06-13', 340, NULL),
('The Paradise Inn', 15, '2019-06-14', 231, NULL),
('The Paradise Inn', 15, '2019-06-15', 185, NULL),
('The Paradise Inn', 15, '2019-06-16', 328, NULL),
('The Paradise Inn', 15, '2019-06-17', 189, NULL),
('The Paradise Inn', 15, '2019-06-18', 137, NULL),
('The Paradise Inn', 15, '2019-06-19', 314, NULL),
('The Paradise Inn', 15, '2019-06-20', 273, NULL),
('The Paradise Inn', 15, '2019-06-21', 134, NULL),
('The Paradise Inn', 15, '2019-06-22', 177, NULL),
('The Paradise Inn', 15, '2019-06-23', 298, NULL),
('The Paradise Inn', 15, '2019-06-24', 373, NULL),
('The Paradise Inn', 15, '2019-06-25', 296, NULL),
('The Paradise Inn', 15, '2019-06-26', 178, NULL),
('The Paradise Inn', 15, '2019-06-27', 113, NULL),
('The Paradise Inn', 15, '2019-06-28', 130, NULL),
('The Paradise Inn', 15, '2019-06-29', 360, NULL),
('The Paradise Inn', 15, '2019-06-30', 127, NULL),
('The Paradise Inn', 15, '2019-07-01', 374, NULL),
('The Paradise Inn', 15, '2019-07-02', 340, NULL),
('The Paradise Inn', 15, '2019-07-03', 203, NULL),
('The Paradise Inn', 15, '2019-07-04', 222, NULL),
('The Paradise Inn', 15, '2019-07-05', 207, NULL),
('The Paradise Inn', 15, '2019-07-06', 283, NULL),
('The Paradise Inn', 15, '2019-07-07', 386, NULL),
('The Paradise Inn', 15, '2019-07-08', 105, NULL),
('The Paradise Inn', 15, '2019-07-09', 114, NULL),
('The Paradise Inn', 15, '2019-07-10', 272, NULL),
('The Paradise Inn', 15, '2019-07-11', 381, NULL),
('The Paradise Inn', 15, '2019-07-12', 252, NULL),
('The Paradise Inn', 15, '2019-07-13', 177, NULL),
('The Paradise Inn', 15, '2019-07-14', 315, NULL),
('The Paradise Inn', 15, '2019-07-15', 377, NULL),
('The Paradise Inn', 15, '2019-07-16', 328, NULL),
('The Paradise Inn', 15, '2019-07-17', 370, NULL),
('The Paradise Inn', 15, '2019-07-18', 167, NULL),
('The Paradise Inn', 15, '2019-07-19', 188, NULL),
('The Paradise Inn', 15, '2019-07-20', 371, NULL),
('The Paradise Inn', 15, '2019-07-21', 117, NULL),
('The Paradise Inn', 15, '2019-07-22', 309, NULL),
('The Paradise Inn', 15, '2019-07-23', 335, NULL),
('The Paradise Inn', 15, '2019-07-24', 155, NULL),
('The Paradise Inn', 15, '2019-07-25', 153, NULL),
('The Paradise Inn', 15, '2019-07-26', 119, NULL),
('The Paradise Inn', 15, '2019-07-27', 319, NULL),
('The Paradise Inn', 15, '2019-07-28', 181, NULL),
('The Paradise Inn', 15, '2019-07-29', 245, NULL),
('The Paradise Inn', 15, '2019-07-30', 310, NULL),
('The Paradise Inn', 15, '2019-07-31', 203, NULL),
('The Paradise Inn', 15, '2019-08-01', 317, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 15, '2019-08-02', 128, NULL),
('The Paradise Inn', 15, '2019-08-03', 299, NULL),
('The Paradise Inn', 15, '2019-08-04', 307, NULL),
('The Paradise Inn', 15, '2019-08-05', 348, NULL),
('The Paradise Inn', 15, '2019-08-06', 244, NULL),
('The Paradise Inn', 15, '2019-08-07', 163, NULL),
('The Paradise Inn', 15, '2019-08-08', 270, NULL),
('The Paradise Inn', 15, '2019-08-09', 239, NULL),
('The Paradise Inn', 15, '2019-08-10', 158, NULL),
('The Paradise Inn', 15, '2019-08-11', 319, NULL),
('The Paradise Inn', 15, '2019-08-12', 387, NULL),
('The Paradise Inn', 15, '2019-08-13', 120, NULL),
('The Paradise Inn', 15, '2019-08-14', 315, NULL),
('The Paradise Inn', 15, '2019-08-15', 295, NULL),
('The Paradise Inn', 15, '2019-08-16', 146, NULL),
('The Paradise Inn', 15, '2019-08-17', 377, NULL),
('The Paradise Inn', 15, '2019-08-18', 186, NULL),
('The Paradise Inn', 15, '2019-08-19', 165, NULL),
('The Paradise Inn', 15, '2019-08-20', 320, NULL),
('The Paradise Inn', 15, '2019-08-21', 312, NULL),
('The Paradise Inn', 15, '2019-08-22', 217, NULL),
('The Paradise Inn', 15, '2019-08-23', 223, NULL),
('The Paradise Inn', 15, '2019-08-24', 237, NULL),
('The Paradise Inn', 15, '2019-08-25', 296, NULL),
('The Paradise Inn', 15, '2019-08-26', 172, NULL),
('The Paradise Inn', 15, '2019-08-27', 261, NULL),
('The Paradise Inn', 15, '2019-08-28', 327, NULL),
('The Paradise Inn', 15, '2019-08-29', 211, NULL),
('The Paradise Inn', 15, '2019-08-30', 383, NULL),
('The Paradise Inn', 15, '2019-08-31', 370, NULL),
('The Paradise Inn', 15, '2019-09-01', 340, NULL),
('The Paradise Inn', 15, '2019-09-02', 270, NULL),
('The Paradise Inn', 15, '2019-09-03', 376, NULL),
('The Paradise Inn', 15, '2019-09-04', 271, NULL),
('The Paradise Inn', 15, '2019-09-05', 301, NULL),
('The Paradise Inn', 15, '2019-09-06', 104, NULL),
('The Paradise Inn', 15, '2019-09-07', 317, NULL),
('The Paradise Inn', 15, '2019-09-08', 325, NULL),
('The Paradise Inn', 15, '2019-09-09', 363, NULL),
('The Paradise Inn', 15, '2019-09-10', 186, NULL),
('The Paradise Inn', 15, '2019-09-11', 187, NULL),
('The Paradise Inn', 15, '2019-09-12', 392, NULL),
('The Paradise Inn', 15, '2019-09-13', 318, NULL),
('The Paradise Inn', 15, '2019-09-14', 397, NULL),
('The Paradise Inn', 15, '2019-09-15', 102, NULL),
('The Paradise Inn', 15, '2019-09-16', 287, NULL),
('The Paradise Inn', 15, '2019-09-17', 132, NULL),
('The Paradise Inn', 15, '2019-09-18', 150, NULL),
('The Paradise Inn', 15, '2019-09-19', 347, NULL),
('The Paradise Inn', 15, '2019-09-20', 285, NULL),
('The Paradise Inn', 15, '2019-09-21', 164, NULL),
('The Paradise Inn', 15, '2019-09-22', 284, NULL),
('The Paradise Inn', 15, '2019-09-23', 291, NULL),
('The Paradise Inn', 15, '2019-09-24', 351, NULL),
('The Paradise Inn', 15, '2019-09-25', 284, NULL),
('The Paradise Inn', 15, '2019-09-26', 392, NULL),
('The Paradise Inn', 15, '2019-09-27', 321, NULL),
('The Paradise Inn', 15, '2019-09-28', 314, NULL),
('The Paradise Inn', 15, '2019-09-29', 332, NULL),
('The Paradise Inn', 15, '2019-09-30', 157, NULL),
('The Paradise Inn', 15, '2019-10-01', 358, NULL),
('The Paradise Inn', 15, '2019-10-02', 164, NULL),
('The Paradise Inn', 15, '2019-10-03', 100, NULL),
('The Paradise Inn', 15, '2019-10-04', 193, NULL),
('The Paradise Inn', 15, '2019-10-05', 190, NULL),
('The Paradise Inn', 15, '2019-10-06', 304, NULL),
('The Paradise Inn', 15, '2019-10-07', 173, NULL),
('The Paradise Inn', 15, '2019-10-08', 165, NULL),
('The Paradise Inn', 15, '2019-10-09', 365, NULL),
('The Paradise Inn', 15, '2019-10-10', 207, NULL),
('The Paradise Inn', 15, '2019-10-11', 175, NULL),
('The Paradise Inn', 15, '2019-10-12', 210, NULL),
('The Paradise Inn', 15, '2019-10-13', 259, NULL),
('The Paradise Inn', 15, '2019-10-14', 199, NULL),
('The Paradise Inn', 15, '2019-10-15', 248, NULL),
('The Paradise Inn', 15, '2019-10-16', 276, NULL),
('The Paradise Inn', 15, '2019-10-17', 299, NULL),
('The Paradise Inn', 15, '2019-10-18', 123, NULL),
('The Paradise Inn', 15, '2019-10-19', 242, NULL),
('The Paradise Inn', 15, '2019-10-20', 252, NULL),
('The Paradise Inn', 15, '2019-10-21', 195, NULL),
('The Paradise Inn', 15, '2019-10-22', 309, NULL),
('The Paradise Inn', 15, '2019-10-23', 108, NULL),
('The Paradise Inn', 15, '2019-10-24', 302, NULL),
('The Paradise Inn', 15, '2019-10-25', 244, NULL),
('The Paradise Inn', 15, '2019-10-26', 304, NULL),
('The Paradise Inn', 15, '2019-10-27', 207, NULL),
('The Paradise Inn', 15, '2019-10-28', 130, NULL),
('The Paradise Inn', 15, '2019-10-29', 375, NULL),
('The Paradise Inn', 15, '2019-10-30', 198, NULL),
('The Paradise Inn', 15, '2019-10-31', 365, NULL),
('The Paradise Inn', 15, '2019-11-01', 109, NULL),
('The Paradise Inn', 15, '2019-11-02', 251, NULL),
('The Paradise Inn', 15, '2019-11-03', 101, NULL),
('The Paradise Inn', 15, '2019-11-04', 264, NULL),
('The Paradise Inn', 15, '2019-11-05', 220, NULL),
('The Paradise Inn', 15, '2019-11-06', 319, NULL),
('The Paradise Inn', 15, '2019-11-07', 322, NULL),
('The Paradise Inn', 15, '2019-11-08', 237, NULL),
('The Paradise Inn', 15, '2019-11-09', 327, NULL),
('The Paradise Inn', 15, '2019-11-10', 203, NULL),
('The Paradise Inn', 15, '2019-11-11', 260, NULL),
('The Paradise Inn', 15, '2019-11-12', 397, NULL),
('The Paradise Inn', 15, '2019-11-13', 317, NULL),
('The Paradise Inn', 15, '2019-11-14', 182, NULL),
('The Paradise Inn', 15, '2019-11-15', 300, NULL),
('The Paradise Inn', 15, '2019-11-16', 176, NULL),
('The Paradise Inn', 15, '2019-11-17', 252, NULL),
('The Paradise Inn', 15, '2019-11-18', 187, NULL),
('The Paradise Inn', 15, '2019-11-19', 249, NULL),
('The Paradise Inn', 15, '2019-11-20', 373, NULL),
('The Paradise Inn', 15, '2019-11-21', 328, NULL),
('The Paradise Inn', 15, '2019-11-22', 215, NULL),
('The Paradise Inn', 15, '2019-11-23', 366, NULL),
('The Paradise Inn', 15, '2019-11-24', 345, NULL),
('The Paradise Inn', 15, '2019-11-25', 212, NULL),
('The Paradise Inn', 15, '2019-11-26', 145, NULL),
('The Paradise Inn', 15, '2019-11-27', 179, NULL),
('The Paradise Inn', 15, '2019-11-28', 254, NULL),
('The Paradise Inn', 15, '2019-11-29', 345, NULL),
('The Paradise Inn', 15, '2019-11-30', 140, NULL),
('The Paradise Inn', 15, '2019-12-01', 348, NULL),
('The Paradise Inn', 15, '2019-12-02', 188, NULL),
('The Paradise Inn', 15, '2019-12-03', 196, NULL),
('The Paradise Inn', 15, '2019-12-04', 340, NULL),
('The Paradise Inn', 15, '2019-12-05', 310, NULL),
('The Paradise Inn', 15, '2019-12-06', 307, NULL),
('The Paradise Inn', 15, '2019-12-07', 149, NULL),
('The Paradise Inn', 15, '2019-12-08', 264, NULL),
('The Paradise Inn', 15, '2019-12-09', 257, NULL),
('The Paradise Inn', 15, '2019-12-10', 191, NULL),
('The Paradise Inn', 15, '2019-12-11', 117, NULL),
('The Paradise Inn', 15, '2019-12-12', 243, NULL),
('The Paradise Inn', 15, '2019-12-13', 374, NULL),
('The Paradise Inn', 15, '2019-12-14', 223, NULL),
('The Paradise Inn', 15, '2019-12-15', 134, NULL),
('The Paradise Inn', 15, '2019-12-16', 307, NULL),
('The Paradise Inn', 15, '2019-12-17', 366, NULL),
('The Paradise Inn', 15, '2019-12-18', 263, NULL),
('The Paradise Inn', 15, '2019-12-19', 175, NULL),
('The Paradise Inn', 15, '2019-12-20', 133, NULL),
('The Paradise Inn', 15, '2019-12-21', 162, NULL),
('The Paradise Inn', 15, '2019-12-22', 279, NULL),
('The Paradise Inn', 15, '2019-12-23', 281, NULL),
('The Paradise Inn', 15, '2019-12-24', 182, NULL),
('The Paradise Inn', 15, '2019-12-25', 255, NULL),
('The Paradise Inn', 15, '2019-12-26', 128, NULL),
('The Paradise Inn', 15, '2019-12-27', 398, NULL),
('The Paradise Inn', 15, '2019-12-28', 185, NULL),
('The Paradise Inn', 15, '2019-12-29', 266, NULL),
('The Paradise Inn', 15, '2019-12-30', 314, NULL),
('The Paradise Inn', 15, '2019-12-31', 105, NULL),
('The Paradise Inn', 15, '2020-01-01', 110, NULL),
('The Paradise Inn', 15, '2020-01-02', 212, NULL),
('The Paradise Inn', 15, '2020-01-03', 255, NULL),
('The Paradise Inn', 15, '2020-01-04', 225, NULL),
('The Paradise Inn', 15, '2020-01-05', 154, NULL),
('The Paradise Inn', 15, '2020-01-06', 127, NULL),
('The Paradise Inn', 15, '2020-01-07', 223, NULL),
('The Paradise Inn', 15, '2020-01-08', 370, NULL),
('The Paradise Inn', 15, '2020-01-09', 338, NULL),
('The Paradise Inn', 15, '2020-01-10', 108, NULL),
('The Paradise Inn', 15, '2020-01-11', 357, NULL),
('The Paradise Inn', 15, '2020-01-12', 306, NULL),
('The Paradise Inn', 15, '2020-01-13', 200, NULL),
('The Paradise Inn', 15, '2020-01-14', 265, NULL),
('The Paradise Inn', 15, '2020-01-15', 207, NULL),
('The Paradise Inn', 15, '2020-01-16', 260, NULL),
('The Paradise Inn', 15, '2020-01-17', 208, NULL),
('The Paradise Inn', 15, '2020-01-18', 105, NULL),
('The Paradise Inn', 15, '2020-01-19', 185, NULL),
('The Paradise Inn', 15, '2020-01-20', 140, NULL),
('The Paradise Inn', 15, '2020-01-21', 172, NULL),
('The Paradise Inn', 15, '2020-01-22', 230, NULL),
('The Paradise Inn', 15, '2020-01-23', 319, NULL),
('The Paradise Inn', 15, '2020-01-24', 142, NULL),
('The Paradise Inn', 15, '2020-01-25', 148, NULL),
('The Paradise Inn', 15, '2020-01-26', 293, NULL),
('The Paradise Inn', 15, '2020-01-27', 279, NULL),
('The Paradise Inn', 15, '2020-01-28', 392, NULL),
('The Paradise Inn', 15, '2020-01-29', 195, NULL),
('The Paradise Inn', 15, '2020-01-30', 128, NULL),
('The Paradise Inn', 15, '2020-01-31', 266, NULL),
('The Paradise Inn', 15, '2020-02-01', 295, NULL),
('The Paradise Inn', 15, '2020-02-02', 338, NULL),
('The Paradise Inn', 15, '2020-02-03', 343, NULL),
('The Paradise Inn', 15, '2020-02-04', 385, NULL),
('The Paradise Inn', 21, '2019-01-01', 207, NULL),
('The Paradise Inn', 21, '2019-01-02', 177, NULL),
('The Paradise Inn', 21, '2019-01-03', 372, NULL),
('The Paradise Inn', 21, '2019-01-04', 230, NULL),
('The Paradise Inn', 21, '2019-01-05', 269, NULL),
('The Paradise Inn', 21, '2019-01-06', 127, NULL),
('The Paradise Inn', 21, '2019-01-07', 381, NULL),
('The Paradise Inn', 21, '2019-01-08', 118, NULL),
('The Paradise Inn', 21, '2019-01-09', 175, NULL),
('The Paradise Inn', 21, '2019-01-10', 377, NULL),
('The Paradise Inn', 21, '2019-01-11', 309, NULL),
('The Paradise Inn', 21, '2019-01-12', 182, NULL),
('The Paradise Inn', 21, '2019-01-13', 128, NULL),
('The Paradise Inn', 21, '2019-01-14', 261, NULL),
('The Paradise Inn', 21, '2019-01-15', 229, NULL),
('The Paradise Inn', 21, '2019-01-16', 261, NULL),
('The Paradise Inn', 21, '2019-01-17', 130, NULL),
('The Paradise Inn', 21, '2019-01-18', 238, NULL),
('The Paradise Inn', 21, '2019-01-19', 164, NULL),
('The Paradise Inn', 21, '2019-01-20', 285, NULL),
('The Paradise Inn', 21, '2019-01-21', 184, NULL),
('The Paradise Inn', 21, '2019-01-22', 194, NULL),
('The Paradise Inn', 21, '2019-01-23', 170, NULL),
('The Paradise Inn', 21, '2019-01-24', 186, NULL),
('The Paradise Inn', 21, '2019-01-25', 257, NULL),
('The Paradise Inn', 21, '2019-01-26', 387, NULL),
('The Paradise Inn', 21, '2019-01-27', 151, NULL),
('The Paradise Inn', 21, '2019-01-28', 261, NULL),
('The Paradise Inn', 21, '2019-01-29', 108, NULL),
('The Paradise Inn', 21, '2019-01-30', 369, NULL),
('The Paradise Inn', 21, '2019-01-31', 244, NULL),
('The Paradise Inn', 21, '2019-02-01', 351, NULL),
('The Paradise Inn', 21, '2019-02-02', 209, NULL),
('The Paradise Inn', 21, '2019-02-03', 315, NULL),
('The Paradise Inn', 21, '2019-02-04', 326, NULL),
('The Paradise Inn', 21, '2019-02-05', 136, NULL),
('The Paradise Inn', 21, '2019-02-06', 383, NULL),
('The Paradise Inn', 21, '2019-02-07', 194, NULL),
('The Paradise Inn', 21, '2019-02-08', 101, NULL),
('The Paradise Inn', 21, '2019-02-09', 195, NULL),
('The Paradise Inn', 21, '2019-02-10', 226, NULL),
('The Paradise Inn', 21, '2019-02-11', 124, NULL),
('The Paradise Inn', 21, '2019-02-12', 188, NULL),
('The Paradise Inn', 21, '2019-02-13', 175, NULL),
('The Paradise Inn', 21, '2019-02-14', 357, NULL),
('The Paradise Inn', 21, '2019-02-15', 357, NULL),
('The Paradise Inn', 21, '2019-02-16', 194, NULL),
('The Paradise Inn', 21, '2019-02-17', 303, NULL),
('The Paradise Inn', 21, '2019-02-18', 215, NULL),
('The Paradise Inn', 21, '2019-02-19', 288, NULL),
('The Paradise Inn', 21, '2019-02-20', 245, NULL),
('The Paradise Inn', 21, '2019-02-21', 197, NULL),
('The Paradise Inn', 21, '2019-02-22', 314, NULL),
('The Paradise Inn', 21, '2019-02-23', 181, NULL),
('The Paradise Inn', 21, '2019-02-24', 228, NULL),
('The Paradise Inn', 21, '2019-02-25', 340, NULL),
('The Paradise Inn', 21, '2019-02-26', 148, NULL),
('The Paradise Inn', 21, '2019-02-27', 339, NULL),
('The Paradise Inn', 21, '2019-02-28', 181, NULL),
('The Paradise Inn', 21, '2019-03-01', 109, NULL),
('The Paradise Inn', 21, '2019-03-02', 108, NULL),
('The Paradise Inn', 21, '2019-03-03', 152, NULL),
('The Paradise Inn', 21, '2019-03-04', 362, NULL),
('The Paradise Inn', 21, '2019-03-05', 248, NULL),
('The Paradise Inn', 21, '2019-03-06', 353, NULL),
('The Paradise Inn', 21, '2019-03-07', 333, NULL),
('The Paradise Inn', 21, '2019-03-08', 319, NULL),
('The Paradise Inn', 21, '2019-03-09', 288, NULL),
('The Paradise Inn', 21, '2019-03-10', 181, NULL),
('The Paradise Inn', 21, '2019-03-11', 169, NULL),
('The Paradise Inn', 21, '2019-03-12', 105, NULL),
('The Paradise Inn', 21, '2019-03-13', 142, NULL),
('The Paradise Inn', 21, '2019-03-14', 150, NULL),
('The Paradise Inn', 21, '2019-03-15', 262, NULL),
('The Paradise Inn', 21, '2019-03-16', 308, NULL),
('The Paradise Inn', 21, '2019-03-17', 259, NULL),
('The Paradise Inn', 21, '2019-03-18', 338, NULL),
('The Paradise Inn', 21, '2019-03-19', 208, NULL),
('The Paradise Inn', 21, '2019-03-20', 315, NULL),
('The Paradise Inn', 21, '2019-03-21', 215, NULL),
('The Paradise Inn', 21, '2019-03-22', 127, NULL),
('The Paradise Inn', 21, '2019-03-23', 219, NULL),
('The Paradise Inn', 21, '2019-03-24', 314, NULL),
('The Paradise Inn', 21, '2019-03-25', 154, NULL),
('The Paradise Inn', 21, '2019-03-26', 207, NULL),
('The Paradise Inn', 21, '2019-03-27', 100, NULL),
('The Paradise Inn', 21, '2019-03-28', 370, NULL),
('The Paradise Inn', 21, '2019-03-29', 270, NULL),
('The Paradise Inn', 21, '2019-03-30', 324, NULL),
('The Paradise Inn', 21, '2019-03-31', 186, NULL),
('The Paradise Inn', 21, '2019-04-01', 286, NULL),
('The Paradise Inn', 21, '2019-04-02', 136, NULL),
('The Paradise Inn', 21, '2019-04-03', 221, NULL),
('The Paradise Inn', 21, '2019-04-04', 318, NULL),
('The Paradise Inn', 21, '2019-04-05', 370, NULL),
('The Paradise Inn', 21, '2019-04-06', 284, NULL),
('The Paradise Inn', 21, '2019-04-07', 381, NULL),
('The Paradise Inn', 21, '2019-04-08', 302, NULL),
('The Paradise Inn', 21, '2019-04-09', 265, NULL),
('The Paradise Inn', 21, '2019-04-10', 378, NULL),
('The Paradise Inn', 21, '2019-04-11', 254, NULL),
('The Paradise Inn', 21, '2019-04-12', 165, NULL),
('The Paradise Inn', 21, '2019-04-13', 139, NULL),
('The Paradise Inn', 21, '2019-04-14', 101, NULL),
('The Paradise Inn', 21, '2019-04-15', 212, NULL),
('The Paradise Inn', 21, '2019-04-16', 395, NULL),
('The Paradise Inn', 21, '2019-04-17', 384, NULL),
('The Paradise Inn', 21, '2019-04-18', 189, NULL),
('The Paradise Inn', 21, '2019-04-19', 231, NULL),
('The Paradise Inn', 21, '2019-04-20', 109, NULL),
('The Paradise Inn', 21, '2019-04-21', 231, NULL),
('The Paradise Inn', 21, '2019-04-22', 174, NULL),
('The Paradise Inn', 21, '2019-04-23', 221, NULL),
('The Paradise Inn', 21, '2019-04-24', 107, NULL),
('The Paradise Inn', 21, '2019-04-25', 316, NULL),
('The Paradise Inn', 21, '2019-04-26', 254, NULL),
('The Paradise Inn', 21, '2019-04-27', 122, NULL),
('The Paradise Inn', 21, '2019-04-28', 298, NULL),
('The Paradise Inn', 21, '2019-04-29', 122, NULL),
('The Paradise Inn', 21, '2019-04-30', 260, NULL),
('The Paradise Inn', 21, '2019-05-01', 267, NULL),
('The Paradise Inn', 21, '2019-05-02', 130, NULL),
('The Paradise Inn', 21, '2019-05-03', 176, NULL),
('The Paradise Inn', 21, '2019-05-04', 122, NULL),
('The Paradise Inn', 21, '2019-05-05', 167, NULL),
('The Paradise Inn', 21, '2019-05-06', 150, NULL),
('The Paradise Inn', 21, '2019-05-07', 252, NULL),
('The Paradise Inn', 21, '2019-05-08', 166, NULL),
('The Paradise Inn', 21, '2019-05-09', 246, NULL),
('The Paradise Inn', 21, '2019-05-10', 257, NULL),
('The Paradise Inn', 21, '2019-05-11', 138, NULL),
('The Paradise Inn', 21, '2019-05-12', 138, NULL),
('The Paradise Inn', 21, '2019-05-13', 237, NULL),
('The Paradise Inn', 21, '2019-05-14', 339, NULL),
('The Paradise Inn', 21, '2019-05-15', 217, NULL),
('The Paradise Inn', 21, '2019-05-16', 354, NULL),
('The Paradise Inn', 21, '2019-05-17', 339, NULL),
('The Paradise Inn', 21, '2019-05-18', 118, NULL),
('The Paradise Inn', 21, '2019-05-19', 205, NULL),
('The Paradise Inn', 21, '2019-05-20', 251, NULL),
('The Paradise Inn', 21, '2019-05-21', 279, NULL),
('The Paradise Inn', 21, '2019-05-22', 260, NULL),
('The Paradise Inn', 21, '2019-05-23', 230, NULL),
('The Paradise Inn', 21, '2019-05-24', 361, NULL),
('The Paradise Inn', 21, '2019-05-25', 376, NULL),
('The Paradise Inn', 21, '2019-05-26', 225, NULL),
('The Paradise Inn', 21, '2019-05-27', 115, NULL),
('The Paradise Inn', 21, '2019-05-28', 323, NULL),
('The Paradise Inn', 21, '2019-05-29', 188, NULL),
('The Paradise Inn', 21, '2019-05-30', 257, NULL),
('The Paradise Inn', 21, '2019-05-31', 321, NULL),
('The Paradise Inn', 21, '2019-06-01', 202, NULL),
('The Paradise Inn', 21, '2019-06-02', 220, NULL),
('The Paradise Inn', 21, '2019-06-03', 161, NULL),
('The Paradise Inn', 21, '2019-06-04', 324, NULL),
('The Paradise Inn', 21, '2019-06-05', 279, NULL),
('The Paradise Inn', 21, '2019-06-06', 196, NULL),
('The Paradise Inn', 21, '2019-06-07', 255, NULL),
('The Paradise Inn', 21, '2019-06-08', 209, NULL),
('The Paradise Inn', 21, '2019-06-09', 155, NULL),
('The Paradise Inn', 21, '2019-06-10', 255, NULL),
('The Paradise Inn', 21, '2019-06-11', 127, NULL),
('The Paradise Inn', 21, '2019-06-12', 210, NULL),
('The Paradise Inn', 21, '2019-06-13', 199, NULL),
('The Paradise Inn', 21, '2019-06-14', 288, NULL),
('The Paradise Inn', 21, '2019-06-15', 290, NULL),
('The Paradise Inn', 21, '2019-06-16', 294, NULL),
('The Paradise Inn', 21, '2019-06-17', 362, NULL),
('The Paradise Inn', 21, '2019-06-18', 350, NULL),
('The Paradise Inn', 21, '2019-06-19', 323, NULL),
('The Paradise Inn', 21, '2019-06-20', 197, NULL),
('The Paradise Inn', 21, '2019-06-21', 298, NULL),
('The Paradise Inn', 21, '2019-06-22', 342, NULL),
('The Paradise Inn', 21, '2019-06-23', 336, NULL),
('The Paradise Inn', 21, '2019-06-24', 297, NULL),
('The Paradise Inn', 21, '2019-06-25', 263, NULL),
('The Paradise Inn', 21, '2019-06-26', 280, NULL),
('The Paradise Inn', 21, '2019-06-27', 242, NULL),
('The Paradise Inn', 21, '2019-06-28', 173, NULL),
('The Paradise Inn', 21, '2019-06-29', 146, NULL),
('The Paradise Inn', 21, '2019-06-30', 169, NULL),
('The Paradise Inn', 21, '2019-07-01', 194, NULL),
('The Paradise Inn', 21, '2019-07-02', 255, NULL),
('The Paradise Inn', 21, '2019-07-03', 399, NULL),
('The Paradise Inn', 21, '2019-07-04', 235, NULL),
('The Paradise Inn', 21, '2019-07-05', 146, NULL),
('The Paradise Inn', 21, '2019-07-06', 202, NULL),
('The Paradise Inn', 21, '2019-07-07', 129, NULL),
('The Paradise Inn', 21, '2019-07-08', 171, NULL),
('The Paradise Inn', 21, '2019-07-09', 104, NULL),
('The Paradise Inn', 21, '2019-07-10', 331, NULL),
('The Paradise Inn', 21, '2019-07-11', 203, NULL),
('The Paradise Inn', 21, '2019-07-12', 342, NULL),
('The Paradise Inn', 21, '2019-07-13', 142, NULL),
('The Paradise Inn', 21, '2019-07-14', 205, NULL),
('The Paradise Inn', 21, '2019-07-15', 398, NULL),
('The Paradise Inn', 21, '2019-07-16', 311, NULL),
('The Paradise Inn', 21, '2019-07-17', 309, NULL),
('The Paradise Inn', 21, '2019-07-18', 307, NULL),
('The Paradise Inn', 21, '2019-07-19', 209, NULL),
('The Paradise Inn', 21, '2019-07-20', 262, NULL),
('The Paradise Inn', 21, '2019-07-21', 311, NULL),
('The Paradise Inn', 21, '2019-07-22', 281, NULL),
('The Paradise Inn', 21, '2019-07-23', 374, NULL),
('The Paradise Inn', 21, '2019-07-24', 375, NULL),
('The Paradise Inn', 21, '2019-07-25', 157, NULL),
('The Paradise Inn', 21, '2019-07-26', 362, NULL),
('The Paradise Inn', 21, '2019-07-27', 151, NULL),
('The Paradise Inn', 21, '2019-07-28', 227, NULL),
('The Paradise Inn', 21, '2019-07-29', 336, NULL),
('The Paradise Inn', 21, '2019-07-30', 297, NULL),
('The Paradise Inn', 21, '2019-07-31', 116, NULL),
('The Paradise Inn', 21, '2019-08-01', 311, NULL),
('The Paradise Inn', 21, '2019-08-02', 398, NULL),
('The Paradise Inn', 21, '2019-08-03', 152, NULL),
('The Paradise Inn', 21, '2019-08-04', 153, NULL),
('The Paradise Inn', 21, '2019-08-05', 351, NULL),
('The Paradise Inn', 21, '2019-08-06', 343, NULL),
('The Paradise Inn', 21, '2019-08-07', 221, NULL),
('The Paradise Inn', 21, '2019-08-08', 226, NULL),
('The Paradise Inn', 21, '2019-08-09', 387, NULL),
('The Paradise Inn', 21, '2019-08-10', 254, NULL),
('The Paradise Inn', 21, '2019-08-11', 223, NULL),
('The Paradise Inn', 21, '2019-08-12', 181, NULL),
('The Paradise Inn', 21, '2019-08-13', 381, NULL),
('The Paradise Inn', 21, '2019-08-14', 231, NULL),
('The Paradise Inn', 21, '2019-08-15', 255, NULL),
('The Paradise Inn', 21, '2019-08-16', 314, NULL),
('The Paradise Inn', 21, '2019-08-17', 167, NULL),
('The Paradise Inn', 21, '2019-08-18', 264, NULL),
('The Paradise Inn', 21, '2019-08-19', 100, NULL),
('The Paradise Inn', 21, '2019-08-20', 103, NULL),
('The Paradise Inn', 21, '2019-08-21', 371, NULL),
('The Paradise Inn', 21, '2019-08-22', 282, NULL),
('The Paradise Inn', 21, '2019-08-23', 334, NULL),
('The Paradise Inn', 21, '2019-08-24', 342, NULL),
('The Paradise Inn', 21, '2019-08-25', 304, NULL),
('The Paradise Inn', 21, '2019-08-26', 182, NULL),
('The Paradise Inn', 21, '2019-08-27', 325, NULL),
('The Paradise Inn', 21, '2019-08-28', 194, NULL),
('The Paradise Inn', 21, '2019-08-29', 234, NULL),
('The Paradise Inn', 21, '2019-08-30', 204, NULL),
('The Paradise Inn', 21, '2019-08-31', 127, NULL),
('The Paradise Inn', 21, '2019-09-01', 306, NULL),
('The Paradise Inn', 21, '2019-09-02', 343, NULL),
('The Paradise Inn', 21, '2019-09-03', 369, NULL),
('The Paradise Inn', 21, '2019-09-04', 319, NULL),
('The Paradise Inn', 21, '2019-09-05', 154, NULL),
('The Paradise Inn', 21, '2019-09-06', 201, NULL),
('The Paradise Inn', 21, '2019-09-07', 398, NULL),
('The Paradise Inn', 21, '2019-09-08', 130, NULL),
('The Paradise Inn', 21, '2019-09-09', 207, NULL),
('The Paradise Inn', 21, '2019-09-10', 339, NULL),
('The Paradise Inn', 21, '2019-09-11', 211, NULL),
('The Paradise Inn', 21, '2019-09-12', 376, NULL),
('The Paradise Inn', 21, '2019-09-13', 389, NULL),
('The Paradise Inn', 21, '2019-09-14', 316, NULL),
('The Paradise Inn', 21, '2019-09-15', 181, NULL),
('The Paradise Inn', 21, '2019-09-16', 273, NULL),
('The Paradise Inn', 21, '2019-09-17', 153, NULL),
('The Paradise Inn', 21, '2019-09-18', 140, NULL),
('The Paradise Inn', 21, '2019-09-19', 239, NULL),
('The Paradise Inn', 21, '2019-09-20', 139, NULL),
('The Paradise Inn', 21, '2019-09-21', 223, NULL),
('The Paradise Inn', 21, '2019-09-22', 132, NULL),
('The Paradise Inn', 21, '2019-09-23', 327, NULL),
('The Paradise Inn', 21, '2019-09-24', 238, NULL),
('The Paradise Inn', 21, '2019-09-25', 336, NULL),
('The Paradise Inn', 21, '2019-09-26', 387, NULL),
('The Paradise Inn', 21, '2019-09-27', 247, NULL),
('The Paradise Inn', 21, '2019-09-28', 268, NULL),
('The Paradise Inn', 21, '2019-09-29', 313, NULL),
('The Paradise Inn', 21, '2019-09-30', 140, NULL),
('The Paradise Inn', 21, '2019-10-01', 370, NULL),
('The Paradise Inn', 21, '2019-10-02', 363, NULL),
('The Paradise Inn', 21, '2019-10-03', 310, NULL),
('The Paradise Inn', 21, '2019-10-04', 304, NULL),
('The Paradise Inn', 21, '2019-10-05', 382, NULL),
('The Paradise Inn', 21, '2019-10-06', 277, NULL),
('The Paradise Inn', 21, '2019-10-07', 329, NULL),
('The Paradise Inn', 21, '2019-10-08', 134, NULL),
('The Paradise Inn', 21, '2019-10-09', 398, NULL),
('The Paradise Inn', 21, '2019-10-10', 323, NULL),
('The Paradise Inn', 21, '2019-10-11', 177, NULL),
('The Paradise Inn', 21, '2019-10-12', 383, NULL),
('The Paradise Inn', 21, '2019-10-13', 116, NULL),
('The Paradise Inn', 21, '2019-10-14', 248, NULL),
('The Paradise Inn', 21, '2019-10-15', 251, NULL),
('The Paradise Inn', 21, '2019-10-16', 116, NULL),
('The Paradise Inn', 21, '2019-10-17', 334, NULL),
('The Paradise Inn', 21, '2019-10-18', 246, NULL),
('The Paradise Inn', 21, '2019-10-19', 189, NULL),
('The Paradise Inn', 21, '2019-10-20', 391, NULL),
('The Paradise Inn', 21, '2019-10-21', 315, NULL),
('The Paradise Inn', 21, '2019-10-22', 384, NULL),
('The Paradise Inn', 21, '2019-10-23', 146, NULL),
('The Paradise Inn', 21, '2019-10-24', 367, NULL),
('The Paradise Inn', 21, '2019-10-25', 310, NULL),
('The Paradise Inn', 21, '2019-10-26', 134, NULL),
('The Paradise Inn', 21, '2019-10-27', 384, NULL),
('The Paradise Inn', 21, '2019-10-28', 372, NULL),
('The Paradise Inn', 21, '2019-10-29', 360, NULL),
('The Paradise Inn', 21, '2019-10-30', 358, NULL),
('The Paradise Inn', 21, '2019-10-31', 235, NULL),
('The Paradise Inn', 21, '2019-11-01', 349, NULL),
('The Paradise Inn', 21, '2019-11-02', 317, NULL),
('The Paradise Inn', 21, '2019-11-03', 263, NULL),
('The Paradise Inn', 21, '2019-11-04', 349, NULL),
('The Paradise Inn', 21, '2019-11-05', 355, NULL),
('The Paradise Inn', 21, '2019-11-06', 252, NULL),
('The Paradise Inn', 21, '2019-11-07', 108, NULL),
('The Paradise Inn', 21, '2019-11-08', 273, NULL),
('The Paradise Inn', 21, '2019-11-09', 230, NULL),
('The Paradise Inn', 21, '2019-11-10', 247, NULL),
('The Paradise Inn', 21, '2019-11-11', 237, NULL),
('The Paradise Inn', 21, '2019-11-12', 318, NULL),
('The Paradise Inn', 21, '2019-11-13', 183, NULL),
('The Paradise Inn', 21, '2019-11-14', 308, NULL),
('The Paradise Inn', 21, '2019-11-15', 120, NULL),
('The Paradise Inn', 21, '2019-11-16', 344, NULL),
('The Paradise Inn', 21, '2019-11-17', 380, NULL),
('The Paradise Inn', 21, '2019-11-18', 252, NULL),
('The Paradise Inn', 21, '2019-11-19', 321, NULL),
('The Paradise Inn', 21, '2019-11-20', 178, NULL),
('The Paradise Inn', 21, '2019-11-21', 111, NULL),
('The Paradise Inn', 21, '2019-11-22', 380, NULL),
('The Paradise Inn', 21, '2019-11-23', 312, NULL),
('The Paradise Inn', 21, '2019-11-24', 317, NULL),
('The Paradise Inn', 21, '2019-11-25', 357, NULL),
('The Paradise Inn', 21, '2019-11-26', 222, NULL),
('The Paradise Inn', 21, '2019-11-27', 274, NULL),
('The Paradise Inn', 21, '2019-11-28', 153, NULL),
('The Paradise Inn', 21, '2019-11-29', 349, NULL),
('The Paradise Inn', 21, '2019-11-30', 348, NULL),
('The Paradise Inn', 21, '2019-12-01', 241, NULL),
('The Paradise Inn', 21, '2019-12-02', 352, NULL),
('The Paradise Inn', 21, '2019-12-03', 248, NULL),
('The Paradise Inn', 21, '2019-12-04', 149, NULL),
('The Paradise Inn', 21, '2019-12-05', 364, NULL),
('The Paradise Inn', 21, '2019-12-06', 356, NULL),
('The Paradise Inn', 21, '2019-12-07', 377, NULL),
('The Paradise Inn', 21, '2019-12-08', 126, NULL),
('The Paradise Inn', 21, '2019-12-09', 104, NULL),
('The Paradise Inn', 21, '2019-12-10', 119, NULL),
('The Paradise Inn', 21, '2019-12-11', 218, NULL),
('The Paradise Inn', 21, '2019-12-12', 141, NULL),
('The Paradise Inn', 21, '2019-12-13', 360, NULL),
('The Paradise Inn', 21, '2019-12-14', 298, NULL),
('The Paradise Inn', 21, '2019-12-15', 303, NULL),
('The Paradise Inn', 21, '2019-12-16', 137, NULL),
('The Paradise Inn', 21, '2019-12-17', 180, NULL),
('The Paradise Inn', 21, '2019-12-18', 383, NULL),
('The Paradise Inn', 21, '2019-12-19', 252, NULL),
('The Paradise Inn', 21, '2019-12-20', 188, NULL),
('The Paradise Inn', 21, '2019-12-21', 181, NULL),
('The Paradise Inn', 21, '2019-12-22', 237, NULL),
('The Paradise Inn', 21, '2019-12-23', 279, NULL),
('The Paradise Inn', 21, '2019-12-24', 381, NULL),
('The Paradise Inn', 21, '2019-12-25', 302, NULL),
('The Paradise Inn', 21, '2019-12-26', 333, NULL),
('The Paradise Inn', 21, '2019-12-27', 323, NULL),
('The Paradise Inn', 21, '2019-12-28', 150, NULL),
('The Paradise Inn', 21, '2019-12-29', 101, NULL),
('The Paradise Inn', 21, '2019-12-30', 193, NULL),
('The Paradise Inn', 21, '2019-12-31', 137, NULL),
('The Paradise Inn', 21, '2020-01-01', 276, NULL),
('The Paradise Inn', 21, '2020-01-02', 177, NULL),
('The Paradise Inn', 21, '2020-01-03', 113, NULL),
('The Paradise Inn', 21, '2020-01-04', 117, NULL),
('The Paradise Inn', 21, '2020-01-05', 338, NULL),
('The Paradise Inn', 21, '2020-01-06', 190, NULL),
('The Paradise Inn', 21, '2020-01-07', 298, NULL),
('The Paradise Inn', 21, '2020-01-08', 235, NULL),
('The Paradise Inn', 21, '2020-01-09', 176, NULL),
('The Paradise Inn', 21, '2020-01-10', 374, NULL),
('The Paradise Inn', 21, '2020-01-11', 374, NULL),
('The Paradise Inn', 21, '2020-01-12', 123, NULL),
('The Paradise Inn', 21, '2020-01-13', 354, NULL),
('The Paradise Inn', 21, '2020-01-14', 360, NULL),
('The Paradise Inn', 21, '2020-01-15', 312, NULL),
('The Paradise Inn', 21, '2020-01-16', 252, NULL),
('The Paradise Inn', 21, '2020-01-17', 116, NULL),
('The Paradise Inn', 21, '2020-01-18', 316, NULL),
('The Paradise Inn', 21, '2020-01-19', 179, NULL),
('The Paradise Inn', 21, '2020-01-20', 292, NULL),
('The Paradise Inn', 21, '2020-01-21', 108, NULL),
('The Paradise Inn', 21, '2020-01-22', 143, NULL),
('The Paradise Inn', 21, '2020-01-23', 191, NULL),
('The Paradise Inn', 21, '2020-01-24', 379, NULL),
('The Paradise Inn', 21, '2020-01-25', 116, NULL),
('The Paradise Inn', 21, '2020-01-26', 284, NULL),
('The Paradise Inn', 21, '2020-01-27', 266, NULL),
('The Paradise Inn', 21, '2020-01-28', 368, NULL),
('The Paradise Inn', 21, '2020-01-29', 274, NULL),
('The Paradise Inn', 21, '2020-01-30', 217, NULL),
('The Paradise Inn', 21, '2020-01-31', 244, NULL),
('The Paradise Inn', 21, '2020-02-01', 212, NULL),
('The Paradise Inn', 21, '2020-02-02', 284, NULL),
('The Paradise Inn', 21, '2020-02-03', 209, NULL),
('The Paradise Inn', 21, '2020-02-04', 393, NULL),
('The Paradise Inn', 32, '2019-01-01', 367, NULL),
('The Paradise Inn', 32, '2019-01-02', 137, NULL),
('The Paradise Inn', 32, '2019-01-03', 345, NULL),
('The Paradise Inn', 32, '2019-01-04', 347, NULL),
('The Paradise Inn', 32, '2019-01-05', 145, NULL),
('The Paradise Inn', 32, '2019-01-06', 180, NULL),
('The Paradise Inn', 32, '2019-01-07', 142, NULL),
('The Paradise Inn', 32, '2019-01-08', 280, NULL),
('The Paradise Inn', 32, '2019-01-09', 102, NULL),
('The Paradise Inn', 32, '2019-01-10', 179, NULL),
('The Paradise Inn', 32, '2019-01-11', 188, NULL),
('The Paradise Inn', 32, '2019-01-12', 256, NULL),
('The Paradise Inn', 32, '2019-01-13', 314, NULL),
('The Paradise Inn', 32, '2019-01-14', 339, NULL),
('The Paradise Inn', 32, '2019-01-15', 198, NULL),
('The Paradise Inn', 32, '2019-01-16', 341, NULL),
('The Paradise Inn', 32, '2019-01-17', 366, NULL),
('The Paradise Inn', 32, '2019-01-18', 138, NULL),
('The Paradise Inn', 32, '2019-01-19', 253, NULL),
('The Paradise Inn', 32, '2019-01-20', 150, NULL),
('The Paradise Inn', 32, '2019-01-21', 302, NULL),
('The Paradise Inn', 32, '2019-01-22', 259, NULL),
('The Paradise Inn', 32, '2019-01-23', 303, NULL),
('The Paradise Inn', 32, '2019-01-24', 398, NULL),
('The Paradise Inn', 32, '2019-01-25', 312, NULL),
('The Paradise Inn', 32, '2019-01-26', 395, NULL),
('The Paradise Inn', 32, '2019-01-27', 349, NULL),
('The Paradise Inn', 32, '2019-01-28', 104, NULL),
('The Paradise Inn', 32, '2019-01-29', 327, NULL),
('The Paradise Inn', 32, '2019-01-30', 273, NULL),
('The Paradise Inn', 32, '2019-01-31', 105, NULL),
('The Paradise Inn', 32, '2019-02-01', 114, NULL),
('The Paradise Inn', 32, '2019-02-02', 362, NULL),
('The Paradise Inn', 32, '2019-02-03', 199, NULL),
('The Paradise Inn', 32, '2019-02-04', 171, NULL),
('The Paradise Inn', 32, '2019-02-05', 341, NULL),
('The Paradise Inn', 32, '2019-02-06', 370, NULL),
('The Paradise Inn', 32, '2019-02-07', 379, NULL),
('The Paradise Inn', 32, '2019-02-08', 255, NULL),
('The Paradise Inn', 32, '2019-02-09', 258, NULL),
('The Paradise Inn', 32, '2019-02-10', 150, NULL),
('The Paradise Inn', 32, '2019-02-11', 388, NULL),
('The Paradise Inn', 32, '2019-02-12', 147, NULL),
('The Paradise Inn', 32, '2019-02-13', 165, NULL),
('The Paradise Inn', 32, '2019-02-14', 334, NULL),
('The Paradise Inn', 32, '2019-02-15', 271, NULL),
('The Paradise Inn', 32, '2019-02-16', 326, NULL),
('The Paradise Inn', 32, '2019-02-17', 268, NULL),
('The Paradise Inn', 32, '2019-02-18', 319, NULL),
('The Paradise Inn', 32, '2019-02-19', 130, NULL),
('The Paradise Inn', 32, '2019-02-20', 329, NULL),
('The Paradise Inn', 32, '2019-02-21', 332, NULL),
('The Paradise Inn', 32, '2019-02-22', 310, NULL),
('The Paradise Inn', 32, '2019-02-23', 149, NULL),
('The Paradise Inn', 32, '2019-02-24', 134, NULL),
('The Paradise Inn', 32, '2019-02-25', 186, NULL),
('The Paradise Inn', 32, '2019-02-26', 229, NULL),
('The Paradise Inn', 32, '2019-02-27', 367, NULL),
('The Paradise Inn', 32, '2019-02-28', 149, NULL),
('The Paradise Inn', 32, '2019-03-01', 214, NULL),
('The Paradise Inn', 32, '2019-03-02', 397, NULL),
('The Paradise Inn', 32, '2019-03-03', 398, NULL),
('The Paradise Inn', 32, '2019-03-04', 242, NULL),
('The Paradise Inn', 32, '2019-03-05', 318, NULL),
('The Paradise Inn', 32, '2019-03-06', 331, NULL),
('The Paradise Inn', 32, '2019-03-07', 277, NULL),
('The Paradise Inn', 32, '2019-03-08', 365, NULL),
('The Paradise Inn', 32, '2019-03-09', 136, NULL),
('The Paradise Inn', 32, '2019-03-10', 209, NULL),
('The Paradise Inn', 32, '2019-03-11', 266, NULL),
('The Paradise Inn', 32, '2019-03-12', 182, NULL),
('The Paradise Inn', 32, '2019-03-13', 117, NULL),
('The Paradise Inn', 32, '2019-03-14', 285, NULL),
('The Paradise Inn', 32, '2019-03-15', 174, NULL),
('The Paradise Inn', 32, '2019-03-16', 105, NULL),
('The Paradise Inn', 32, '2019-03-17', 332, NULL),
('The Paradise Inn', 32, '2019-03-18', 280, NULL),
('The Paradise Inn', 32, '2019-03-19', 195, NULL),
('The Paradise Inn', 32, '2019-03-20', 229, NULL),
('The Paradise Inn', 32, '2019-03-21', 296, NULL),
('The Paradise Inn', 32, '2019-03-22', 230, NULL),
('The Paradise Inn', 32, '2019-03-23', 384, NULL),
('The Paradise Inn', 32, '2019-03-24', 251, NULL),
('The Paradise Inn', 32, '2019-03-25', 354, NULL),
('The Paradise Inn', 32, '2019-03-26', 365, NULL),
('The Paradise Inn', 32, '2019-03-27', 390, NULL),
('The Paradise Inn', 32, '2019-03-28', 199, NULL),
('The Paradise Inn', 32, '2019-03-29', 377, NULL),
('The Paradise Inn', 32, '2019-03-30', 278, NULL),
('The Paradise Inn', 32, '2019-03-31', 154, NULL),
('The Paradise Inn', 32, '2019-04-01', 226, NULL),
('The Paradise Inn', 32, '2019-04-02', 378, NULL),
('The Paradise Inn', 32, '2019-04-03', 166, NULL),
('The Paradise Inn', 32, '2019-04-04', 124, NULL),
('The Paradise Inn', 32, '2019-04-05', 170, NULL),
('The Paradise Inn', 32, '2019-04-06', 141, NULL),
('The Paradise Inn', 32, '2019-04-07', 156, NULL),
('The Paradise Inn', 32, '2019-04-08', 357, NULL),
('The Paradise Inn', 32, '2019-04-09', 209, NULL),
('The Paradise Inn', 32, '2019-04-10', 319, NULL),
('The Paradise Inn', 32, '2019-04-11', 191, NULL),
('The Paradise Inn', 32, '2019-04-12', 125, NULL),
('The Paradise Inn', 32, '2019-04-13', 120, NULL),
('The Paradise Inn', 32, '2019-04-14', 112, NULL),
('The Paradise Inn', 32, '2019-04-15', 182, NULL),
('The Paradise Inn', 32, '2019-04-16', 285, NULL),
('The Paradise Inn', 32, '2019-04-17', 364, NULL),
('The Paradise Inn', 32, '2019-04-18', 350, NULL),
('The Paradise Inn', 32, '2019-04-19', 392, NULL),
('The Paradise Inn', 32, '2019-04-20', 154, NULL),
('The Paradise Inn', 32, '2019-04-21', 251, NULL),
('The Paradise Inn', 32, '2019-04-22', 163, NULL),
('The Paradise Inn', 32, '2019-04-23', 340, NULL),
('The Paradise Inn', 32, '2019-04-24', 281, NULL),
('The Paradise Inn', 32, '2019-04-25', 137, NULL),
('The Paradise Inn', 32, '2019-04-26', 302, NULL),
('The Paradise Inn', 32, '2019-04-27', 335, NULL),
('The Paradise Inn', 32, '2019-04-28', 339, NULL),
('The Paradise Inn', 32, '2019-04-29', 383, NULL),
('The Paradise Inn', 32, '2019-04-30', 242, NULL),
('The Paradise Inn', 32, '2019-05-01', 267, NULL),
('The Paradise Inn', 32, '2019-05-02', 258, NULL),
('The Paradise Inn', 32, '2019-05-03', 363, NULL),
('The Paradise Inn', 32, '2019-05-04', 216, NULL),
('The Paradise Inn', 32, '2019-05-05', 243, NULL),
('The Paradise Inn', 32, '2019-05-06', 254, NULL),
('The Paradise Inn', 32, '2019-05-07', 329, NULL),
('The Paradise Inn', 32, '2019-05-08', 341, NULL),
('The Paradise Inn', 32, '2019-05-09', 234, NULL),
('The Paradise Inn', 32, '2019-05-10', 267, NULL),
('The Paradise Inn', 32, '2019-05-11', 122, NULL),
('The Paradise Inn', 32, '2019-05-12', 182, NULL),
('The Paradise Inn', 32, '2019-05-13', 212, NULL),
('The Paradise Inn', 32, '2019-05-14', 303, NULL),
('The Paradise Inn', 32, '2019-05-15', 343, NULL),
('The Paradise Inn', 32, '2019-05-16', 134, NULL),
('The Paradise Inn', 32, '2019-05-17', 359, NULL),
('The Paradise Inn', 32, '2019-05-18', 348, NULL),
('The Paradise Inn', 32, '2019-05-19', 135, NULL),
('The Paradise Inn', 32, '2019-05-20', 152, NULL),
('The Paradise Inn', 32, '2019-05-21', 286, NULL),
('The Paradise Inn', 32, '2019-05-22', 181, NULL),
('The Paradise Inn', 32, '2019-05-23', 200, NULL),
('The Paradise Inn', 32, '2019-05-24', 144, NULL),
('The Paradise Inn', 32, '2019-05-25', 287, NULL),
('The Paradise Inn', 32, '2019-05-26', 272, NULL),
('The Paradise Inn', 32, '2019-05-27', 344, NULL),
('The Paradise Inn', 32, '2019-05-28', 376, NULL),
('The Paradise Inn', 32, '2019-05-29', 234, NULL),
('The Paradise Inn', 32, '2019-05-30', 259, NULL),
('The Paradise Inn', 32, '2019-05-31', 110, NULL),
('The Paradise Inn', 32, '2019-06-01', 162, NULL),
('The Paradise Inn', 32, '2019-06-02', 147, NULL),
('The Paradise Inn', 32, '2019-06-03', 378, NULL),
('The Paradise Inn', 32, '2019-06-04', 228, NULL),
('The Paradise Inn', 32, '2019-06-05', 384, NULL),
('The Paradise Inn', 32, '2019-06-06', 390, NULL),
('The Paradise Inn', 32, '2019-06-07', 340, NULL),
('The Paradise Inn', 32, '2019-06-08', 244, NULL),
('The Paradise Inn', 32, '2019-06-09', 378, NULL),
('The Paradise Inn', 32, '2019-06-10', 140, NULL),
('The Paradise Inn', 32, '2019-06-11', 151, NULL),
('The Paradise Inn', 32, '2019-06-12', 239, NULL),
('The Paradise Inn', 32, '2019-06-13', 177, NULL),
('The Paradise Inn', 32, '2019-06-14', 348, NULL),
('The Paradise Inn', 32, '2019-06-15', 195, NULL),
('The Paradise Inn', 32, '2019-06-16', 386, NULL),
('The Paradise Inn', 32, '2019-06-17', 243, NULL),
('The Paradise Inn', 32, '2019-06-18', 338, NULL),
('The Paradise Inn', 32, '2019-06-19', 276, NULL),
('The Paradise Inn', 32, '2019-06-20', 366, NULL),
('The Paradise Inn', 32, '2019-06-21', 386, NULL),
('The Paradise Inn', 32, '2019-06-22', 177, NULL),
('The Paradise Inn', 32, '2019-06-23', 388, NULL),
('The Paradise Inn', 32, '2019-06-24', 267, NULL),
('The Paradise Inn', 32, '2019-06-25', 326, NULL),
('The Paradise Inn', 32, '2019-06-26', 165, NULL),
('The Paradise Inn', 32, '2019-06-27', 171, NULL),
('The Paradise Inn', 32, '2019-06-28', 375, NULL),
('The Paradise Inn', 32, '2019-06-29', 148, NULL),
('The Paradise Inn', 32, '2019-06-30', 367, NULL),
('The Paradise Inn', 32, '2019-07-01', 350, NULL),
('The Paradise Inn', 32, '2019-07-02', 158, NULL),
('The Paradise Inn', 32, '2019-07-03', 385, NULL),
('The Paradise Inn', 32, '2019-07-04', 111, NULL),
('The Paradise Inn', 32, '2019-07-05', 312, NULL),
('The Paradise Inn', 32, '2019-07-06', 363, NULL),
('The Paradise Inn', 32, '2019-07-07', 289, NULL),
('The Paradise Inn', 32, '2019-07-08', 139, NULL),
('The Paradise Inn', 32, '2019-07-09', 377, NULL),
('The Paradise Inn', 32, '2019-07-10', 139, NULL),
('The Paradise Inn', 32, '2019-07-11', 374, NULL),
('The Paradise Inn', 32, '2019-07-12', 257, NULL),
('The Paradise Inn', 32, '2019-07-13', 380, NULL),
('The Paradise Inn', 32, '2019-07-14', 280, NULL),
('The Paradise Inn', 32, '2019-07-15', 160, NULL),
('The Paradise Inn', 32, '2019-07-16', 172, NULL),
('The Paradise Inn', 32, '2019-07-17', 333, NULL),
('The Paradise Inn', 32, '2019-07-18', 336, NULL),
('The Paradise Inn', 32, '2019-07-19', 382, NULL),
('The Paradise Inn', 32, '2019-07-20', 397, NULL),
('The Paradise Inn', 32, '2019-07-21', 206, NULL),
('The Paradise Inn', 32, '2019-07-22', 377, NULL),
('The Paradise Inn', 32, '2019-07-23', 167, NULL),
('The Paradise Inn', 32, '2019-07-24', 111, NULL),
('The Paradise Inn', 32, '2019-07-25', 227, NULL),
('The Paradise Inn', 32, '2019-07-26', 152, NULL),
('The Paradise Inn', 32, '2019-07-27', 301, NULL),
('The Paradise Inn', 32, '2019-07-28', 191, NULL),
('The Paradise Inn', 32, '2019-07-29', 246, NULL),
('The Paradise Inn', 32, '2019-07-30', 156, NULL),
('The Paradise Inn', 32, '2019-07-31', 173, NULL),
('The Paradise Inn', 32, '2019-08-01', 201, NULL),
('The Paradise Inn', 32, '2019-08-02', 309, NULL),
('The Paradise Inn', 32, '2019-08-03', 363, NULL),
('The Paradise Inn', 32, '2019-08-04', 342, NULL),
('The Paradise Inn', 32, '2019-08-05', 313, NULL),
('The Paradise Inn', 32, '2019-08-06', 285, NULL),
('The Paradise Inn', 32, '2019-08-07', 218, NULL),
('The Paradise Inn', 32, '2019-08-08', 223, NULL),
('The Paradise Inn', 32, '2019-08-09', 215, NULL),
('The Paradise Inn', 32, '2019-08-10', 397, NULL),
('The Paradise Inn', 32, '2019-08-11', 359, NULL),
('The Paradise Inn', 32, '2019-08-12', 247, NULL),
('The Paradise Inn', 32, '2019-08-13', 244, NULL),
('The Paradise Inn', 32, '2019-08-14', 109, NULL),
('The Paradise Inn', 32, '2019-08-15', 290, NULL),
('The Paradise Inn', 32, '2019-08-16', 132, NULL),
('The Paradise Inn', 32, '2019-08-17', 205, NULL),
('The Paradise Inn', 32, '2019-08-18', 362, NULL),
('The Paradise Inn', 32, '2019-08-19', 205, NULL),
('The Paradise Inn', 32, '2019-08-20', 355, NULL),
('The Paradise Inn', 32, '2019-08-21', 218, NULL),
('The Paradise Inn', 32, '2019-08-22', 362, NULL),
('The Paradise Inn', 32, '2019-08-23', 302, NULL),
('The Paradise Inn', 32, '2019-08-24', 299, NULL),
('The Paradise Inn', 32, '2019-08-25', 231, NULL),
('The Paradise Inn', 32, '2019-08-26', 296, NULL),
('The Paradise Inn', 32, '2019-08-27', 141, NULL),
('The Paradise Inn', 32, '2019-08-28', 190, NULL),
('The Paradise Inn', 32, '2019-08-29', 135, NULL),
('The Paradise Inn', 32, '2019-08-30', 375, NULL),
('The Paradise Inn', 32, '2019-08-31', 326, NULL),
('The Paradise Inn', 32, '2019-09-01', 114, NULL),
('The Paradise Inn', 32, '2019-09-02', 206, NULL),
('The Paradise Inn', 32, '2019-09-03', 314, NULL),
('The Paradise Inn', 32, '2019-09-04', 381, NULL),
('The Paradise Inn', 32, '2019-09-05', 369, NULL),
('The Paradise Inn', 32, '2019-09-06', 291, NULL),
('The Paradise Inn', 32, '2019-09-07', 341, NULL),
('The Paradise Inn', 32, '2019-09-08', 176, NULL),
('The Paradise Inn', 32, '2019-09-09', 145, NULL),
('The Paradise Inn', 32, '2019-09-10', 136, NULL),
('The Paradise Inn', 32, '2019-09-11', 395, NULL),
('The Paradise Inn', 32, '2019-09-12', 307, NULL),
('The Paradise Inn', 32, '2019-09-13', 291, NULL),
('The Paradise Inn', 32, '2019-09-14', 288, NULL),
('The Paradise Inn', 32, '2019-09-15', 200, NULL),
('The Paradise Inn', 32, '2019-09-16', 105, NULL),
('The Paradise Inn', 32, '2019-09-17', 268, NULL),
('The Paradise Inn', 32, '2019-09-18', 152, NULL),
('The Paradise Inn', 32, '2019-09-19', 355, NULL),
('The Paradise Inn', 32, '2019-09-20', 340, NULL),
('The Paradise Inn', 32, '2019-09-21', 222, NULL),
('The Paradise Inn', 32, '2019-09-22', 310, NULL),
('The Paradise Inn', 32, '2019-09-23', 359, NULL),
('The Paradise Inn', 32, '2019-09-24', 339, NULL),
('The Paradise Inn', 32, '2019-09-25', 128, NULL),
('The Paradise Inn', 32, '2019-09-26', 358, NULL),
('The Paradise Inn', 32, '2019-09-27', 174, NULL),
('The Paradise Inn', 32, '2019-09-28', 298, NULL),
('The Paradise Inn', 32, '2019-09-29', 168, NULL),
('The Paradise Inn', 32, '2019-09-30', 130, NULL),
('The Paradise Inn', 32, '2019-10-01', 375, NULL),
('The Paradise Inn', 32, '2019-10-02', 322, NULL),
('The Paradise Inn', 32, '2019-10-03', 254, NULL),
('The Paradise Inn', 32, '2019-10-04', 240, NULL),
('The Paradise Inn', 32, '2019-10-05', 341, NULL),
('The Paradise Inn', 32, '2019-10-06', 373, NULL),
('The Paradise Inn', 32, '2019-10-07', 124, NULL),
('The Paradise Inn', 32, '2019-10-08', 377, NULL),
('The Paradise Inn', 32, '2019-10-09', 196, NULL),
('The Paradise Inn', 32, '2019-10-10', 295, NULL),
('The Paradise Inn', 32, '2019-10-11', 261, NULL),
('The Paradise Inn', 32, '2019-10-12', 285, NULL),
('The Paradise Inn', 32, '2019-10-13', 302, NULL),
('The Paradise Inn', 32, '2019-10-14', 241, NULL),
('The Paradise Inn', 32, '2019-10-15', 112, NULL),
('The Paradise Inn', 32, '2019-10-16', 253, NULL),
('The Paradise Inn', 32, '2019-10-17', 372, NULL),
('The Paradise Inn', 32, '2019-10-18', 161, NULL),
('The Paradise Inn', 32, '2019-10-19', 122, NULL),
('The Paradise Inn', 32, '2019-10-20', 200, NULL),
('The Paradise Inn', 32, '2019-10-21', 291, NULL),
('The Paradise Inn', 32, '2019-10-22', 294, NULL),
('The Paradise Inn', 32, '2019-10-23', 308, NULL),
('The Paradise Inn', 32, '2019-10-24', 231, NULL),
('The Paradise Inn', 32, '2019-10-25', 119, NULL),
('The Paradise Inn', 32, '2019-10-26', 257, NULL),
('The Paradise Inn', 32, '2019-10-27', 298, NULL),
('The Paradise Inn', 32, '2019-10-28', 170, NULL),
('The Paradise Inn', 32, '2019-10-29', 279, NULL),
('The Paradise Inn', 32, '2019-10-30', 195, NULL),
('The Paradise Inn', 32, '2019-10-31', 282, NULL),
('The Paradise Inn', 32, '2019-11-01', 118, NULL),
('The Paradise Inn', 32, '2019-11-02', 132, NULL),
('The Paradise Inn', 32, '2019-11-03', 313, NULL),
('The Paradise Inn', 32, '2019-11-04', 254, NULL),
('The Paradise Inn', 32, '2019-11-05', 113, NULL),
('The Paradise Inn', 32, '2019-11-06', 205, NULL),
('The Paradise Inn', 32, '2019-11-07', 374, NULL),
('The Paradise Inn', 32, '2019-11-08', 255, NULL),
('The Paradise Inn', 32, '2019-11-09', 370, NULL),
('The Paradise Inn', 32, '2019-11-10', 229, NULL),
('The Paradise Inn', 32, '2019-11-11', 304, NULL),
('The Paradise Inn', 32, '2019-11-12', 296, NULL),
('The Paradise Inn', 32, '2019-11-13', 165, NULL),
('The Paradise Inn', 32, '2019-11-14', 293, NULL),
('The Paradise Inn', 32, '2019-11-15', 202, NULL),
('The Paradise Inn', 32, '2019-11-16', 192, NULL),
('The Paradise Inn', 32, '2019-11-17', 142, NULL),
('The Paradise Inn', 32, '2019-11-18', 301, NULL),
('The Paradise Inn', 32, '2019-11-19', 159, NULL),
('The Paradise Inn', 32, '2019-11-20', 268, NULL),
('The Paradise Inn', 32, '2019-11-21', 373, NULL),
('The Paradise Inn', 32, '2019-11-22', 257, NULL),
('The Paradise Inn', 32, '2019-11-23', 359, NULL),
('The Paradise Inn', 32, '2019-11-24', 152, NULL),
('The Paradise Inn', 32, '2019-11-25', 151, NULL),
('The Paradise Inn', 32, '2019-11-26', 279, NULL),
('The Paradise Inn', 32, '2019-11-27', 130, NULL),
('The Paradise Inn', 32, '2019-11-28', 202, NULL),
('The Paradise Inn', 32, '2019-11-29', 314, NULL),
('The Paradise Inn', 32, '2019-11-30', 318, NULL),
('The Paradise Inn', 32, '2019-12-01', 360, NULL),
('The Paradise Inn', 32, '2019-12-02', 199, NULL),
('The Paradise Inn', 32, '2019-12-03', 253, NULL),
('The Paradise Inn', 32, '2019-12-04', 228, NULL),
('The Paradise Inn', 32, '2019-12-05', 194, NULL),
('The Paradise Inn', 32, '2019-12-06', 162, NULL),
('The Paradise Inn', 32, '2019-12-07', 137, NULL),
('The Paradise Inn', 32, '2019-12-08', 338, NULL),
('The Paradise Inn', 32, '2019-12-09', 251, NULL),
('The Paradise Inn', 32, '2019-12-10', 225, NULL),
('The Paradise Inn', 32, '2019-12-11', 338, NULL),
('The Paradise Inn', 32, '2019-12-12', 175, NULL),
('The Paradise Inn', 32, '2019-12-13', 277, NULL),
('The Paradise Inn', 32, '2019-12-14', 121, NULL),
('The Paradise Inn', 32, '2019-12-15', 110, NULL),
('The Paradise Inn', 32, '2019-12-16', 264, NULL),
('The Paradise Inn', 32, '2019-12-17', 305, NULL),
('The Paradise Inn', 32, '2019-12-18', 127, NULL),
('The Paradise Inn', 32, '2019-12-19', 333, NULL),
('The Paradise Inn', 32, '2019-12-20', 143, NULL),
('The Paradise Inn', 32, '2019-12-21', 320, NULL),
('The Paradise Inn', 32, '2019-12-22', 247, NULL),
('The Paradise Inn', 32, '2019-12-23', 153, NULL),
('The Paradise Inn', 32, '2019-12-24', 359, NULL),
('The Paradise Inn', 32, '2019-12-25', 344, NULL),
('The Paradise Inn', 32, '2019-12-26', 280, NULL),
('The Paradise Inn', 32, '2019-12-27', 324, NULL),
('The Paradise Inn', 32, '2019-12-28', 395, NULL),
('The Paradise Inn', 32, '2019-12-29', 209, NULL),
('The Paradise Inn', 32, '2019-12-30', 223, NULL),
('The Paradise Inn', 32, '2019-12-31', 272, NULL),
('The Paradise Inn', 32, '2020-01-01', 353, NULL),
('The Paradise Inn', 32, '2020-01-02', 152, NULL),
('The Paradise Inn', 32, '2020-01-03', 299, NULL),
('The Paradise Inn', 32, '2020-01-04', 109, NULL),
('The Paradise Inn', 32, '2020-01-05', 230, NULL),
('The Paradise Inn', 32, '2020-01-06', 171, NULL),
('The Paradise Inn', 32, '2020-01-07', 123, NULL),
('The Paradise Inn', 32, '2020-01-08', 265, NULL),
('The Paradise Inn', 32, '2020-01-09', 365, NULL),
('The Paradise Inn', 32, '2020-01-10', 247, NULL),
('The Paradise Inn', 32, '2020-01-11', 397, NULL),
('The Paradise Inn', 32, '2020-01-12', 200, NULL),
('The Paradise Inn', 32, '2020-01-13', 169, NULL),
('The Paradise Inn', 32, '2020-01-14', 307, NULL),
('The Paradise Inn', 32, '2020-01-15', 238, NULL),
('The Paradise Inn', 32, '2020-01-16', 380, NULL),
('The Paradise Inn', 32, '2020-01-17', 154, NULL),
('The Paradise Inn', 32, '2020-01-18', 265, NULL),
('The Paradise Inn', 32, '2020-01-19', 239, NULL),
('The Paradise Inn', 32, '2020-01-20', 339, NULL),
('The Paradise Inn', 32, '2020-01-21', 223, NULL),
('The Paradise Inn', 32, '2020-01-22', 225, NULL),
('The Paradise Inn', 32, '2020-01-23', 198, NULL),
('The Paradise Inn', 32, '2020-01-24', 167, NULL),
('The Paradise Inn', 32, '2020-01-25', 337, NULL),
('The Paradise Inn', 32, '2020-01-26', 141, NULL),
('The Paradise Inn', 32, '2020-01-27', 391, NULL),
('The Paradise Inn', 32, '2020-01-28', 267, NULL),
('The Paradise Inn', 32, '2020-01-29', 385, NULL),
('The Paradise Inn', 32, '2020-01-30', 304, NULL),
('The Paradise Inn', 32, '2020-01-31', 326, NULL),
('The Paradise Inn', 32, '2020-02-01', 377, NULL),
('The Paradise Inn', 32, '2020-02-02', 306, NULL),
('The Paradise Inn', 32, '2020-02-03', 219, NULL),
('The Paradise Inn', 32, '2020-02-04', 107, NULL),
('The Paradise Inn', 35, '2019-01-01', 213, NULL),
('The Paradise Inn', 35, '2019-01-02', 355, NULL),
('The Paradise Inn', 35, '2019-01-03', 206, NULL),
('The Paradise Inn', 35, '2019-01-04', 343, NULL),
('The Paradise Inn', 35, '2019-01-05', 119, NULL),
('The Paradise Inn', 35, '2019-01-06', 119, NULL),
('The Paradise Inn', 35, '2019-01-07', 370, NULL),
('The Paradise Inn', 35, '2019-01-08', 349, NULL),
('The Paradise Inn', 35, '2019-01-09', 186, NULL),
('The Paradise Inn', 35, '2019-01-10', 267, NULL),
('The Paradise Inn', 35, '2019-01-11', 215, NULL),
('The Paradise Inn', 35, '2019-01-12', 336, NULL),
('The Paradise Inn', 35, '2019-01-13', 188, NULL),
('The Paradise Inn', 35, '2019-01-14', 215, NULL),
('The Paradise Inn', 35, '2019-01-15', 205, NULL),
('The Paradise Inn', 35, '2019-01-16', 224, NULL),
('The Paradise Inn', 35, '2019-01-17', 143, NULL),
('The Paradise Inn', 35, '2019-01-18', 174, NULL),
('The Paradise Inn', 35, '2019-01-19', 373, NULL),
('The Paradise Inn', 35, '2019-01-20', 392, NULL),
('The Paradise Inn', 35, '2019-01-21', 258, NULL),
('The Paradise Inn', 35, '2019-01-22', 315, NULL),
('The Paradise Inn', 35, '2019-01-23', 306, NULL),
('The Paradise Inn', 35, '2019-01-24', 133, NULL),
('The Paradise Inn', 35, '2019-01-25', 387, NULL),
('The Paradise Inn', 35, '2019-01-26', 113, NULL),
('The Paradise Inn', 35, '2019-01-27', 290, NULL),
('The Paradise Inn', 35, '2019-01-28', 238, NULL),
('The Paradise Inn', 35, '2019-01-29', 309, NULL),
('The Paradise Inn', 35, '2019-01-30', 158, NULL),
('The Paradise Inn', 35, '2019-01-31', 293, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 35, '2019-02-01', 316, NULL),
('The Paradise Inn', 35, '2019-02-02', 183, NULL),
('The Paradise Inn', 35, '2019-02-03', 251, NULL),
('The Paradise Inn', 35, '2019-02-04', 377, NULL),
('The Paradise Inn', 35, '2019-02-05', 297, NULL),
('The Paradise Inn', 35, '2019-02-06', 302, NULL),
('The Paradise Inn', 35, '2019-02-07', 313, NULL),
('The Paradise Inn', 35, '2019-02-08', 275, NULL),
('The Paradise Inn', 35, '2019-02-09', 306, NULL),
('The Paradise Inn', 35, '2019-02-10', 271, NULL),
('The Paradise Inn', 35, '2019-02-11', 266, NULL),
('The Paradise Inn', 35, '2019-02-12', 369, NULL),
('The Paradise Inn', 35, '2019-02-13', 200, NULL),
('The Paradise Inn', 35, '2019-02-14', 200, NULL),
('The Paradise Inn', 35, '2019-02-15', 183, NULL),
('The Paradise Inn', 35, '2019-02-16', 349, NULL),
('The Paradise Inn', 35, '2019-02-17', 329, NULL),
('The Paradise Inn', 35, '2019-02-18', 252, NULL),
('The Paradise Inn', 35, '2019-02-19', 288, NULL),
('The Paradise Inn', 35, '2019-02-20', 211, NULL),
('The Paradise Inn', 35, '2019-02-21', 369, NULL),
('The Paradise Inn', 35, '2019-02-22', 212, NULL),
('The Paradise Inn', 35, '2019-02-23', 399, NULL),
('The Paradise Inn', 35, '2019-02-24', 184, NULL),
('The Paradise Inn', 35, '2019-02-25', 112, NULL),
('The Paradise Inn', 35, '2019-02-26', 305, NULL),
('The Paradise Inn', 35, '2019-02-27', 117, NULL),
('The Paradise Inn', 35, '2019-02-28', 101, NULL),
('The Paradise Inn', 35, '2019-03-01', 342, NULL),
('The Paradise Inn', 35, '2019-03-02', 361, NULL),
('The Paradise Inn', 35, '2019-03-03', 233, NULL),
('The Paradise Inn', 35, '2019-03-04', 324, NULL),
('The Paradise Inn', 35, '2019-03-05', 144, NULL),
('The Paradise Inn', 35, '2019-03-06', 193, NULL),
('The Paradise Inn', 35, '2019-03-07', 286, NULL),
('The Paradise Inn', 35, '2019-03-08', 170, NULL),
('The Paradise Inn', 35, '2019-03-09', 314, NULL),
('The Paradise Inn', 35, '2019-03-10', 104, NULL),
('The Paradise Inn', 35, '2019-03-11', 124, NULL),
('The Paradise Inn', 35, '2019-03-12', 196, NULL),
('The Paradise Inn', 35, '2019-03-13', 363, NULL),
('The Paradise Inn', 35, '2019-03-14', 277, NULL),
('The Paradise Inn', 35, '2019-03-15', 285, NULL),
('The Paradise Inn', 35, '2019-03-16', 100, NULL),
('The Paradise Inn', 35, '2019-03-17', 183, NULL),
('The Paradise Inn', 35, '2019-03-18', 287, NULL),
('The Paradise Inn', 35, '2019-03-19', 251, NULL),
('The Paradise Inn', 35, '2019-03-20', 103, NULL),
('The Paradise Inn', 35, '2019-03-21', 135, NULL),
('The Paradise Inn', 35, '2019-03-22', 370, NULL),
('The Paradise Inn', 35, '2019-03-23', 264, NULL),
('The Paradise Inn', 35, '2019-03-24', 215, NULL),
('The Paradise Inn', 35, '2019-03-25', 310, NULL),
('The Paradise Inn', 35, '2019-03-26', 202, NULL),
('The Paradise Inn', 35, '2019-03-27', 349, NULL),
('The Paradise Inn', 35, '2019-03-28', 387, NULL),
('The Paradise Inn', 35, '2019-03-29', 373, NULL),
('The Paradise Inn', 35, '2019-03-30', 318, NULL),
('The Paradise Inn', 35, '2019-03-31', 114, NULL),
('The Paradise Inn', 35, '2019-04-01', 173, NULL),
('The Paradise Inn', 35, '2019-04-02', 185, NULL),
('The Paradise Inn', 35, '2019-04-03', 367, NULL),
('The Paradise Inn', 35, '2019-04-04', 165, NULL),
('The Paradise Inn', 35, '2019-04-05', 244, NULL),
('The Paradise Inn', 35, '2019-04-06', 352, NULL),
('The Paradise Inn', 35, '2019-04-07', 140, NULL),
('The Paradise Inn', 35, '2019-04-08', 176, NULL),
('The Paradise Inn', 35, '2019-04-09', 150, NULL),
('The Paradise Inn', 35, '2019-04-10', 361, NULL),
('The Paradise Inn', 35, '2019-04-11', 395, NULL),
('The Paradise Inn', 35, '2019-04-12', 330, NULL),
('The Paradise Inn', 35, '2019-04-13', 386, NULL),
('The Paradise Inn', 35, '2019-04-14', 161, NULL),
('The Paradise Inn', 35, '2019-04-15', 176, NULL),
('The Paradise Inn', 35, '2019-04-16', 141, NULL),
('The Paradise Inn', 35, '2019-04-17', 268, NULL),
('The Paradise Inn', 35, '2019-04-18', 183, NULL),
('The Paradise Inn', 35, '2019-04-19', 267, NULL),
('The Paradise Inn', 35, '2019-04-20', 343, NULL),
('The Paradise Inn', 35, '2019-04-21', 162, NULL),
('The Paradise Inn', 35, '2019-04-22', 190, NULL),
('The Paradise Inn', 35, '2019-04-23', 334, NULL),
('The Paradise Inn', 35, '2019-04-24', 387, NULL),
('The Paradise Inn', 35, '2019-04-25', 234, NULL),
('The Paradise Inn', 35, '2019-04-26', 350, NULL),
('The Paradise Inn', 35, '2019-04-27', 310, NULL),
('The Paradise Inn', 35, '2019-04-28', 100, NULL),
('The Paradise Inn', 35, '2019-04-29', 253, NULL),
('The Paradise Inn', 35, '2019-04-30', 332, NULL),
('The Paradise Inn', 35, '2019-05-01', 134, NULL),
('The Paradise Inn', 35, '2019-05-02', 200, NULL),
('The Paradise Inn', 35, '2019-05-03', 288, NULL),
('The Paradise Inn', 35, '2019-05-04', 312, NULL),
('The Paradise Inn', 35, '2019-05-05', 316, NULL),
('The Paradise Inn', 35, '2019-05-06', 124, NULL),
('The Paradise Inn', 35, '2019-05-07', 187, NULL),
('The Paradise Inn', 35, '2019-05-08', 207, NULL),
('The Paradise Inn', 35, '2019-05-09', 330, NULL),
('The Paradise Inn', 35, '2019-05-10', 162, NULL),
('The Paradise Inn', 35, '2019-05-11', 395, NULL),
('The Paradise Inn', 35, '2019-05-12', 399, NULL),
('The Paradise Inn', 35, '2019-05-13', 250, NULL),
('The Paradise Inn', 35, '2019-05-14', 101, NULL),
('The Paradise Inn', 35, '2019-05-15', 364, NULL),
('The Paradise Inn', 35, '2019-05-16', 110, NULL),
('The Paradise Inn', 35, '2019-05-17', 378, NULL),
('The Paradise Inn', 35, '2019-05-18', 387, NULL),
('The Paradise Inn', 35, '2019-05-19', 262, NULL),
('The Paradise Inn', 35, '2019-05-20', 208, NULL),
('The Paradise Inn', 35, '2019-05-21', 195, NULL),
('The Paradise Inn', 35, '2019-05-22', 327, NULL),
('The Paradise Inn', 35, '2019-05-23', 212, NULL),
('The Paradise Inn', 35, '2019-05-24', 136, NULL),
('The Paradise Inn', 35, '2019-05-25', 208, NULL),
('The Paradise Inn', 35, '2019-05-26', 286, NULL),
('The Paradise Inn', 35, '2019-05-27', 378, NULL),
('The Paradise Inn', 35, '2019-05-28', 213, NULL),
('The Paradise Inn', 35, '2019-05-29', 209, NULL),
('The Paradise Inn', 35, '2019-05-30', 128, NULL),
('The Paradise Inn', 35, '2019-05-31', 387, NULL),
('The Paradise Inn', 35, '2019-06-01', 107, NULL),
('The Paradise Inn', 35, '2019-06-02', 275, NULL),
('The Paradise Inn', 35, '2019-06-03', 108, NULL),
('The Paradise Inn', 35, '2019-06-04', 368, NULL),
('The Paradise Inn', 35, '2019-06-05', 382, NULL),
('The Paradise Inn', 35, '2019-06-06', 363, NULL),
('The Paradise Inn', 35, '2019-06-07', 237, NULL),
('The Paradise Inn', 35, '2019-06-08', 192, NULL),
('The Paradise Inn', 35, '2019-06-09', 124, NULL),
('The Paradise Inn', 35, '2019-06-10', 137, NULL),
('The Paradise Inn', 35, '2019-06-11', 273, NULL),
('The Paradise Inn', 35, '2019-06-12', 166, NULL),
('The Paradise Inn', 35, '2019-06-13', 186, NULL),
('The Paradise Inn', 35, '2019-06-14', 177, NULL),
('The Paradise Inn', 35, '2019-06-15', 306, NULL),
('The Paradise Inn', 35, '2019-06-16', 349, NULL),
('The Paradise Inn', 35, '2019-06-17', 330, NULL),
('The Paradise Inn', 35, '2019-06-18', 242, NULL),
('The Paradise Inn', 35, '2019-06-19', 310, NULL),
('The Paradise Inn', 35, '2019-06-20', 241, NULL),
('The Paradise Inn', 35, '2019-06-21', 336, NULL),
('The Paradise Inn', 35, '2019-06-22', 361, NULL),
('The Paradise Inn', 35, '2019-06-23', 233, NULL),
('The Paradise Inn', 35, '2019-06-24', 343, NULL),
('The Paradise Inn', 35, '2019-06-25', 142, NULL),
('The Paradise Inn', 35, '2019-06-26', 187, NULL),
('The Paradise Inn', 35, '2019-06-27', 332, NULL),
('The Paradise Inn', 35, '2019-06-28', 357, NULL),
('The Paradise Inn', 35, '2019-06-29', 205, NULL),
('The Paradise Inn', 35, '2019-06-30', 328, NULL),
('The Paradise Inn', 35, '2019-07-01', 167, NULL),
('The Paradise Inn', 35, '2019-07-02', 225, NULL),
('The Paradise Inn', 35, '2019-07-03', 332, NULL),
('The Paradise Inn', 35, '2019-07-04', 349, NULL),
('The Paradise Inn', 35, '2019-07-05', 122, NULL),
('The Paradise Inn', 35, '2019-07-06', 210, NULL),
('The Paradise Inn', 35, '2019-07-07', 357, NULL),
('The Paradise Inn', 35, '2019-07-08', 385, NULL),
('The Paradise Inn', 35, '2019-07-09', 274, NULL),
('The Paradise Inn', 35, '2019-07-10', 202, NULL),
('The Paradise Inn', 35, '2019-07-11', 259, NULL),
('The Paradise Inn', 35, '2019-07-12', 157, NULL),
('The Paradise Inn', 35, '2019-07-13', 174, NULL),
('The Paradise Inn', 35, '2019-07-14', 386, NULL),
('The Paradise Inn', 35, '2019-07-15', 109, NULL),
('The Paradise Inn', 35, '2019-07-16', 125, NULL),
('The Paradise Inn', 35, '2019-07-17', 341, NULL),
('The Paradise Inn', 35, '2019-07-18', 360, NULL),
('The Paradise Inn', 35, '2019-07-19', 281, NULL),
('The Paradise Inn', 35, '2019-07-20', 201, NULL),
('The Paradise Inn', 35, '2019-07-21', 297, NULL),
('The Paradise Inn', 35, '2019-07-22', 343, NULL),
('The Paradise Inn', 35, '2019-07-23', 211, NULL),
('The Paradise Inn', 35, '2019-07-24', 232, NULL),
('The Paradise Inn', 35, '2019-07-25', 265, NULL),
('The Paradise Inn', 35, '2019-07-26', 178, NULL),
('The Paradise Inn', 35, '2019-07-27', 351, NULL),
('The Paradise Inn', 35, '2019-07-28', 177, NULL),
('The Paradise Inn', 35, '2019-07-29', 124, NULL),
('The Paradise Inn', 35, '2019-07-30', 389, NULL),
('The Paradise Inn', 35, '2019-07-31', 115, NULL),
('The Paradise Inn', 35, '2019-08-01', 274, NULL),
('The Paradise Inn', 35, '2019-08-02', 250, NULL),
('The Paradise Inn', 35, '2019-08-03', 360, NULL),
('The Paradise Inn', 35, '2019-08-04', 252, NULL),
('The Paradise Inn', 35, '2019-08-05', 114, NULL),
('The Paradise Inn', 35, '2019-08-06', 298, NULL),
('The Paradise Inn', 35, '2019-08-07', 329, NULL),
('The Paradise Inn', 35, '2019-08-08', 338, NULL),
('The Paradise Inn', 35, '2019-08-09', 116, NULL),
('The Paradise Inn', 35, '2019-08-10', 223, NULL),
('The Paradise Inn', 35, '2019-08-11', 125, NULL),
('The Paradise Inn', 35, '2019-08-12', 293, NULL),
('The Paradise Inn', 35, '2019-08-13', 279, NULL),
('The Paradise Inn', 35, '2019-08-14', 355, NULL),
('The Paradise Inn', 35, '2019-08-15', 285, NULL),
('The Paradise Inn', 35, '2019-08-16', 219, NULL),
('The Paradise Inn', 35, '2019-08-17', 127, NULL),
('The Paradise Inn', 35, '2019-08-18', 318, NULL),
('The Paradise Inn', 35, '2019-08-19', 326, NULL),
('The Paradise Inn', 35, '2019-08-20', 165, NULL),
('The Paradise Inn', 35, '2019-08-21', 177, NULL),
('The Paradise Inn', 35, '2019-08-22', 264, NULL),
('The Paradise Inn', 35, '2019-08-23', 106, NULL),
('The Paradise Inn', 35, '2019-08-24', 372, NULL),
('The Paradise Inn', 35, '2019-08-25', 143, NULL),
('The Paradise Inn', 35, '2019-08-26', 231, NULL),
('The Paradise Inn', 35, '2019-08-27', 231, NULL),
('The Paradise Inn', 35, '2019-08-28', 270, NULL),
('The Paradise Inn', 35, '2019-08-29', 177, NULL),
('The Paradise Inn', 35, '2019-08-30', 262, NULL),
('The Paradise Inn', 35, '2019-08-31', 250, NULL),
('The Paradise Inn', 35, '2019-09-01', 151, NULL),
('The Paradise Inn', 35, '2019-09-02', 199, NULL),
('The Paradise Inn', 35, '2019-09-03', 366, NULL),
('The Paradise Inn', 35, '2019-09-04', 249, NULL),
('The Paradise Inn', 35, '2019-09-05', 385, NULL),
('The Paradise Inn', 35, '2019-09-06', 154, NULL),
('The Paradise Inn', 35, '2019-09-07', 110, NULL),
('The Paradise Inn', 35, '2019-09-08', 392, NULL),
('The Paradise Inn', 35, '2019-09-09', 306, NULL),
('The Paradise Inn', 35, '2019-09-10', 166, NULL),
('The Paradise Inn', 35, '2019-09-11', 343, NULL),
('The Paradise Inn', 35, '2019-09-12', 306, NULL),
('The Paradise Inn', 35, '2019-09-13', 187, NULL),
('The Paradise Inn', 35, '2019-09-14', 391, NULL),
('The Paradise Inn', 35, '2019-09-15', 360, NULL),
('The Paradise Inn', 35, '2019-09-16', 209, NULL),
('The Paradise Inn', 35, '2019-09-17', 182, NULL),
('The Paradise Inn', 35, '2019-09-18', 239, NULL),
('The Paradise Inn', 35, '2019-09-19', 359, NULL),
('The Paradise Inn', 35, '2019-09-20', 282, NULL),
('The Paradise Inn', 35, '2019-09-21', 343, NULL),
('The Paradise Inn', 35, '2019-09-22', 152, NULL),
('The Paradise Inn', 35, '2019-09-23', 115, NULL),
('The Paradise Inn', 35, '2019-09-24', 283, NULL),
('The Paradise Inn', 35, '2019-09-25', 131, NULL),
('The Paradise Inn', 35, '2019-09-26', 232, NULL),
('The Paradise Inn', 35, '2019-09-27', 329, NULL),
('The Paradise Inn', 35, '2019-09-28', 287, NULL),
('The Paradise Inn', 35, '2019-09-29', 100, NULL),
('The Paradise Inn', 35, '2019-09-30', 130, NULL),
('The Paradise Inn', 35, '2019-10-01', 367, NULL),
('The Paradise Inn', 35, '2019-10-02', 120, NULL),
('The Paradise Inn', 35, '2019-10-03', 240, NULL),
('The Paradise Inn', 35, '2019-10-04', 192, NULL),
('The Paradise Inn', 35, '2019-10-05', 161, NULL),
('The Paradise Inn', 35, '2019-10-06', 333, NULL),
('The Paradise Inn', 35, '2019-10-07', 135, NULL),
('The Paradise Inn', 35, '2019-10-08', 181, NULL),
('The Paradise Inn', 35, '2019-10-09', 288, NULL),
('The Paradise Inn', 35, '2019-10-10', 106, NULL),
('The Paradise Inn', 35, '2019-10-11', 377, NULL),
('The Paradise Inn', 35, '2019-10-12', 177, NULL),
('The Paradise Inn', 35, '2019-10-13', 164, NULL),
('The Paradise Inn', 35, '2019-10-14', 363, NULL),
('The Paradise Inn', 35, '2019-10-15', 306, NULL),
('The Paradise Inn', 35, '2019-10-16', 216, NULL),
('The Paradise Inn', 35, '2019-10-17', 159, NULL),
('The Paradise Inn', 35, '2019-10-18', 267, NULL),
('The Paradise Inn', 35, '2019-10-19', 242, NULL),
('The Paradise Inn', 35, '2019-10-20', 327, NULL),
('The Paradise Inn', 35, '2019-10-21', 110, NULL),
('The Paradise Inn', 35, '2019-10-22', 218, NULL),
('The Paradise Inn', 35, '2019-10-23', 103, NULL),
('The Paradise Inn', 35, '2019-10-24', 255, NULL),
('The Paradise Inn', 35, '2019-10-25', 168, NULL),
('The Paradise Inn', 35, '2019-10-26', 186, NULL),
('The Paradise Inn', 35, '2019-10-27', 238, NULL),
('The Paradise Inn', 35, '2019-10-28', 235, NULL),
('The Paradise Inn', 35, '2019-10-29', 212, NULL),
('The Paradise Inn', 35, '2019-10-30', 104, NULL),
('The Paradise Inn', 35, '2019-10-31', 307, NULL),
('The Paradise Inn', 35, '2019-11-01', 343, NULL),
('The Paradise Inn', 35, '2019-11-02', 209, NULL),
('The Paradise Inn', 35, '2019-11-03', 377, NULL),
('The Paradise Inn', 35, '2019-11-04', 125, NULL),
('The Paradise Inn', 35, '2019-11-05', 300, NULL),
('The Paradise Inn', 35, '2019-11-06', 166, NULL),
('The Paradise Inn', 35, '2019-11-07', 248, NULL),
('The Paradise Inn', 35, '2019-11-08', 357, NULL),
('The Paradise Inn', 35, '2019-11-09', 162, NULL),
('The Paradise Inn', 35, '2019-11-10', 305, NULL),
('The Paradise Inn', 35, '2019-11-11', 109, NULL),
('The Paradise Inn', 35, '2019-11-12', 128, NULL),
('The Paradise Inn', 35, '2019-11-13', 175, NULL),
('The Paradise Inn', 35, '2019-11-14', 143, NULL),
('The Paradise Inn', 35, '2019-11-15', 249, NULL),
('The Paradise Inn', 35, '2019-11-16', 128, NULL),
('The Paradise Inn', 35, '2019-11-17', 373, NULL),
('The Paradise Inn', 35, '2019-11-18', 349, NULL),
('The Paradise Inn', 35, '2019-11-19', 331, NULL),
('The Paradise Inn', 35, '2019-11-20', 109, NULL),
('The Paradise Inn', 35, '2019-11-21', 231, NULL),
('The Paradise Inn', 35, '2019-11-22', 344, NULL),
('The Paradise Inn', 35, '2019-11-23', 163, NULL),
('The Paradise Inn', 35, '2019-11-24', 311, NULL),
('The Paradise Inn', 35, '2019-11-25', 186, NULL),
('The Paradise Inn', 35, '2019-11-26', 328, NULL),
('The Paradise Inn', 35, '2019-11-27', 331, NULL),
('The Paradise Inn', 35, '2019-11-28', 154, NULL),
('The Paradise Inn', 35, '2019-11-29', 122, NULL),
('The Paradise Inn', 35, '2019-11-30', 148, NULL),
('The Paradise Inn', 35, '2019-12-01', 378, NULL),
('The Paradise Inn', 35, '2019-12-02', 139, NULL),
('The Paradise Inn', 35, '2019-12-03', 122, NULL),
('The Paradise Inn', 35, '2019-12-04', 293, NULL),
('The Paradise Inn', 35, '2019-12-05', 376, NULL),
('The Paradise Inn', 35, '2019-12-06', 239, NULL),
('The Paradise Inn', 35, '2019-12-07', 356, NULL),
('The Paradise Inn', 35, '2019-12-08', 313, NULL),
('The Paradise Inn', 35, '2019-12-09', 241, NULL),
('The Paradise Inn', 35, '2019-12-10', 367, NULL),
('The Paradise Inn', 35, '2019-12-11', 338, NULL),
('The Paradise Inn', 35, '2019-12-12', 352, NULL),
('The Paradise Inn', 35, '2019-12-13', 208, NULL),
('The Paradise Inn', 35, '2019-12-14', 212, NULL),
('The Paradise Inn', 35, '2019-12-15', 144, NULL),
('The Paradise Inn', 35, '2019-12-16', 208, NULL),
('The Paradise Inn', 35, '2019-12-17', 285, NULL),
('The Paradise Inn', 35, '2019-12-18', 288, NULL),
('The Paradise Inn', 35, '2019-12-19', 211, NULL),
('The Paradise Inn', 35, '2019-12-20', 350, NULL),
('The Paradise Inn', 35, '2019-12-21', 356, NULL),
('The Paradise Inn', 35, '2019-12-22', 124, NULL),
('The Paradise Inn', 35, '2019-12-23', 126, NULL),
('The Paradise Inn', 35, '2019-12-24', 252, NULL),
('The Paradise Inn', 35, '2019-12-25', 115, NULL),
('The Paradise Inn', 35, '2019-12-26', 301, NULL),
('The Paradise Inn', 35, '2019-12-27', 249, NULL),
('The Paradise Inn', 35, '2019-12-28', 223, NULL),
('The Paradise Inn', 35, '2019-12-29', 344, NULL),
('The Paradise Inn', 35, '2019-12-30', 137, NULL),
('The Paradise Inn', 35, '2019-12-31', 249, NULL),
('The Paradise Inn', 35, '2020-01-01', 234, NULL),
('The Paradise Inn', 35, '2020-01-02', 130, NULL),
('The Paradise Inn', 35, '2020-01-03', 157, NULL),
('The Paradise Inn', 35, '2020-01-04', 397, NULL),
('The Paradise Inn', 35, '2020-01-05', 334, NULL),
('The Paradise Inn', 35, '2020-01-06', 186, NULL),
('The Paradise Inn', 35, '2020-01-07', 220, NULL),
('The Paradise Inn', 35, '2020-01-08', 220, NULL),
('The Paradise Inn', 35, '2020-01-09', 299, NULL),
('The Paradise Inn', 35, '2020-01-10', 315, NULL),
('The Paradise Inn', 35, '2020-01-11', 162, NULL),
('The Paradise Inn', 35, '2020-01-12', 230, NULL),
('The Paradise Inn', 35, '2020-01-13', 283, NULL),
('The Paradise Inn', 35, '2020-01-14', 356, NULL),
('The Paradise Inn', 35, '2020-01-15', 154, NULL),
('The Paradise Inn', 35, '2020-01-16', 144, NULL),
('The Paradise Inn', 35, '2020-01-17', 325, NULL),
('The Paradise Inn', 35, '2020-01-18', 277, NULL),
('The Paradise Inn', 35, '2020-01-19', 259, NULL),
('The Paradise Inn', 35, '2020-01-20', 118, NULL),
('The Paradise Inn', 35, '2020-01-21', 392, NULL),
('The Paradise Inn', 35, '2020-01-22', 295, NULL),
('The Paradise Inn', 35, '2020-01-23', 319, NULL),
('The Paradise Inn', 35, '2020-01-24', 201, NULL),
('The Paradise Inn', 35, '2020-01-25', 339, NULL),
('The Paradise Inn', 35, '2020-01-26', 351, NULL),
('The Paradise Inn', 35, '2020-01-27', 159, NULL),
('The Paradise Inn', 35, '2020-01-28', 130, NULL),
('The Paradise Inn', 35, '2020-01-29', 101, NULL),
('The Paradise Inn', 35, '2020-01-30', 170, NULL),
('The Paradise Inn', 35, '2020-01-31', 195, NULL),
('The Paradise Inn', 35, '2020-02-01', 250, NULL),
('The Paradise Inn', 35, '2020-02-02', 279, NULL),
('The Paradise Inn', 35, '2020-02-03', 369, NULL),
('The Paradise Inn', 35, '2020-02-04', 158, NULL),
('The Paradise Inn', 36, '2019-01-01', 166, NULL),
('The Paradise Inn', 36, '2019-01-02', 363, NULL),
('The Paradise Inn', 36, '2019-01-03', 198, NULL),
('The Paradise Inn', 36, '2019-01-04', 278, NULL),
('The Paradise Inn', 36, '2019-01-05', 360, NULL),
('The Paradise Inn', 36, '2019-01-06', 256, NULL),
('The Paradise Inn', 36, '2019-01-07', 122, NULL),
('The Paradise Inn', 36, '2019-01-08', 203, NULL),
('The Paradise Inn', 36, '2019-01-09', 226, NULL),
('The Paradise Inn', 36, '2019-01-10', 396, NULL),
('The Paradise Inn', 36, '2019-01-11', 113, NULL),
('The Paradise Inn', 36, '2019-01-12', 214, NULL),
('The Paradise Inn', 36, '2019-01-13', 200, NULL),
('The Paradise Inn', 36, '2019-01-14', 258, NULL),
('The Paradise Inn', 36, '2019-01-15', 329, NULL),
('The Paradise Inn', 36, '2019-01-16', 294, NULL),
('The Paradise Inn', 36, '2019-01-17', 115, NULL),
('The Paradise Inn', 36, '2019-01-18', 355, NULL),
('The Paradise Inn', 36, '2019-01-19', 104, NULL),
('The Paradise Inn', 36, '2019-01-20', 213, NULL),
('The Paradise Inn', 36, '2019-01-21', 282, NULL),
('The Paradise Inn', 36, '2019-01-22', 395, NULL),
('The Paradise Inn', 36, '2019-01-23', 221, NULL),
('The Paradise Inn', 36, '2019-01-24', 272, NULL),
('The Paradise Inn', 36, '2019-01-25', 302, NULL),
('The Paradise Inn', 36, '2019-01-26', 181, NULL),
('The Paradise Inn', 36, '2019-01-27', 307, NULL),
('The Paradise Inn', 36, '2019-01-28', 179, NULL),
('The Paradise Inn', 36, '2019-01-29', 165, NULL),
('The Paradise Inn', 36, '2019-01-30', 175, NULL),
('The Paradise Inn', 36, '2019-01-31', 151, NULL),
('The Paradise Inn', 36, '2019-02-01', 238, NULL),
('The Paradise Inn', 36, '2019-02-02', 328, NULL),
('The Paradise Inn', 36, '2019-02-03', 257, NULL),
('The Paradise Inn', 36, '2019-02-04', 371, NULL),
('The Paradise Inn', 36, '2019-02-05', 364, NULL),
('The Paradise Inn', 36, '2019-02-06', 299, NULL),
('The Paradise Inn', 36, '2019-02-07', 328, NULL),
('The Paradise Inn', 36, '2019-02-08', 208, NULL),
('The Paradise Inn', 36, '2019-02-09', 355, NULL),
('The Paradise Inn', 36, '2019-02-10', 208, NULL),
('The Paradise Inn', 36, '2019-02-11', 366, NULL),
('The Paradise Inn', 36, '2019-02-12', 105, NULL),
('The Paradise Inn', 36, '2019-02-13', 105, NULL),
('The Paradise Inn', 36, '2019-02-14', 199, NULL),
('The Paradise Inn', 36, '2019-02-15', 304, NULL),
('The Paradise Inn', 36, '2019-02-16', 366, NULL),
('The Paradise Inn', 36, '2019-02-17', 143, NULL),
('The Paradise Inn', 36, '2019-02-18', 202, NULL),
('The Paradise Inn', 36, '2019-02-19', 348, NULL),
('The Paradise Inn', 36, '2019-02-20', 271, NULL),
('The Paradise Inn', 36, '2019-02-21', 152, NULL),
('The Paradise Inn', 36, '2019-02-22', 327, NULL),
('The Paradise Inn', 36, '2019-02-23', 249, NULL),
('The Paradise Inn', 36, '2019-02-24', 119, NULL),
('The Paradise Inn', 36, '2019-02-25', 202, NULL),
('The Paradise Inn', 36, '2019-02-26', 138, NULL),
('The Paradise Inn', 36, '2019-02-27', 288, NULL),
('The Paradise Inn', 36, '2019-02-28', 259, NULL),
('The Paradise Inn', 36, '2019-03-01', 370, NULL),
('The Paradise Inn', 36, '2019-03-02', 217, NULL),
('The Paradise Inn', 36, '2019-03-03', 171, NULL),
('The Paradise Inn', 36, '2019-03-04', 196, NULL),
('The Paradise Inn', 36, '2019-03-05', 267, NULL),
('The Paradise Inn', 36, '2019-03-06', 176, NULL),
('The Paradise Inn', 36, '2019-03-07', 200, NULL),
('The Paradise Inn', 36, '2019-03-08', 253, NULL),
('The Paradise Inn', 36, '2019-03-09', 162, NULL),
('The Paradise Inn', 36, '2019-03-10', 391, NULL),
('The Paradise Inn', 36, '2019-03-11', 323, NULL),
('The Paradise Inn', 36, '2019-03-12', 336, NULL),
('The Paradise Inn', 36, '2019-03-13', 162, NULL),
('The Paradise Inn', 36, '2019-03-14', 132, NULL),
('The Paradise Inn', 36, '2019-03-15', 202, NULL),
('The Paradise Inn', 36, '2019-03-16', 386, NULL),
('The Paradise Inn', 36, '2019-03-17', 118, NULL),
('The Paradise Inn', 36, '2019-03-18', 195, NULL),
('The Paradise Inn', 36, '2019-03-19', 272, NULL),
('The Paradise Inn', 36, '2019-03-20', 325, NULL),
('The Paradise Inn', 36, '2019-03-21', 289, NULL),
('The Paradise Inn', 36, '2019-03-22', 159, NULL),
('The Paradise Inn', 36, '2019-03-23', 368, NULL),
('The Paradise Inn', 36, '2019-03-24', 223, NULL),
('The Paradise Inn', 36, '2019-03-25', 387, NULL),
('The Paradise Inn', 36, '2019-03-26', 118, NULL),
('The Paradise Inn', 36, '2019-03-27', 173, NULL),
('The Paradise Inn', 36, '2019-03-28', 338, NULL),
('The Paradise Inn', 36, '2019-03-29', 336, NULL),
('The Paradise Inn', 36, '2019-03-30', 356, NULL),
('The Paradise Inn', 36, '2019-03-31', 307, NULL),
('The Paradise Inn', 36, '2019-04-01', 387, NULL),
('The Paradise Inn', 36, '2019-04-02', 289, NULL),
('The Paradise Inn', 36, '2019-04-03', 336, NULL),
('The Paradise Inn', 36, '2019-04-04', 355, NULL),
('The Paradise Inn', 36, '2019-04-05', 307, NULL),
('The Paradise Inn', 36, '2019-04-06', 338, NULL),
('The Paradise Inn', 36, '2019-04-07', 132, NULL),
('The Paradise Inn', 36, '2019-04-08', 309, NULL),
('The Paradise Inn', 36, '2019-04-09', 323, NULL),
('The Paradise Inn', 36, '2019-04-10', 148, NULL),
('The Paradise Inn', 36, '2019-04-11', 103, NULL),
('The Paradise Inn', 36, '2019-04-12', 274, NULL),
('The Paradise Inn', 36, '2019-04-13', 269, NULL),
('The Paradise Inn', 36, '2019-04-14', 368, NULL),
('The Paradise Inn', 36, '2019-04-15', 235, NULL),
('The Paradise Inn', 36, '2019-04-16', 347, NULL),
('The Paradise Inn', 36, '2019-04-17', 151, NULL),
('The Paradise Inn', 36, '2019-04-18', 363, NULL),
('The Paradise Inn', 36, '2019-04-19', 361, NULL),
('The Paradise Inn', 36, '2019-04-20', 255, NULL),
('The Paradise Inn', 36, '2019-04-21', 257, NULL),
('The Paradise Inn', 36, '2019-04-22', 362, NULL),
('The Paradise Inn', 36, '2019-04-23', 251, NULL),
('The Paradise Inn', 36, '2019-04-24', 392, NULL),
('The Paradise Inn', 36, '2019-04-25', 363, NULL),
('The Paradise Inn', 36, '2019-04-26', 142, NULL),
('The Paradise Inn', 36, '2019-04-27', 144, NULL),
('The Paradise Inn', 36, '2019-04-28', 284, NULL),
('The Paradise Inn', 36, '2019-04-29', 313, NULL),
('The Paradise Inn', 36, '2019-04-30', 231, NULL),
('The Paradise Inn', 36, '2019-05-01', 372, NULL),
('The Paradise Inn', 36, '2019-05-02', 125, NULL),
('The Paradise Inn', 36, '2019-05-03', 253, NULL),
('The Paradise Inn', 36, '2019-05-04', 213, NULL),
('The Paradise Inn', 36, '2019-05-05', 149, NULL),
('The Paradise Inn', 36, '2019-05-06', 355, NULL),
('The Paradise Inn', 36, '2019-05-07', 151, NULL),
('The Paradise Inn', 36, '2019-05-08', 211, NULL),
('The Paradise Inn', 36, '2019-05-09', 249, NULL),
('The Paradise Inn', 36, '2019-05-10', 212, NULL),
('The Paradise Inn', 36, '2019-05-11', 309, NULL),
('The Paradise Inn', 36, '2019-05-12', 147, NULL),
('The Paradise Inn', 36, '2019-05-13', 212, NULL),
('The Paradise Inn', 36, '2019-05-14', 397, NULL),
('The Paradise Inn', 36, '2019-05-15', 393, NULL),
('The Paradise Inn', 36, '2019-05-16', 347, NULL),
('The Paradise Inn', 36, '2019-05-17', 116, NULL),
('The Paradise Inn', 36, '2019-05-18', 193, NULL),
('The Paradise Inn', 36, '2019-05-19', 206, NULL),
('The Paradise Inn', 36, '2019-05-20', 185, NULL),
('The Paradise Inn', 36, '2019-05-21', 314, NULL),
('The Paradise Inn', 36, '2019-05-22', 389, NULL),
('The Paradise Inn', 36, '2019-05-23', 359, NULL),
('The Paradise Inn', 36, '2019-05-24', 151, NULL),
('The Paradise Inn', 36, '2019-05-25', 380, NULL),
('The Paradise Inn', 36, '2019-05-26', 212, NULL),
('The Paradise Inn', 36, '2019-05-27', 158, NULL),
('The Paradise Inn', 36, '2019-05-28', 139, NULL),
('The Paradise Inn', 36, '2019-05-29', 244, NULL),
('The Paradise Inn', 36, '2019-05-30', 363, NULL),
('The Paradise Inn', 36, '2019-05-31', 306, NULL),
('The Paradise Inn', 36, '2019-06-01', 249, NULL),
('The Paradise Inn', 36, '2019-06-02', 234, NULL),
('The Paradise Inn', 36, '2019-06-03', 208, NULL),
('The Paradise Inn', 36, '2019-06-04', 160, NULL),
('The Paradise Inn', 36, '2019-06-05', 359, NULL),
('The Paradise Inn', 36, '2019-06-06', 242, NULL),
('The Paradise Inn', 36, '2019-06-07', 362, NULL),
('The Paradise Inn', 36, '2019-06-08', 130, NULL),
('The Paradise Inn', 36, '2019-06-09', 289, NULL),
('The Paradise Inn', 36, '2019-06-10', 163, NULL),
('The Paradise Inn', 36, '2019-06-11', 214, NULL),
('The Paradise Inn', 36, '2019-06-12', 311, NULL),
('The Paradise Inn', 36, '2019-06-13', 303, NULL),
('The Paradise Inn', 36, '2019-06-14', 341, NULL),
('The Paradise Inn', 36, '2019-06-15', 245, NULL),
('The Paradise Inn', 36, '2019-06-16', 185, NULL),
('The Paradise Inn', 36, '2019-06-17', 221, NULL),
('The Paradise Inn', 36, '2019-06-18', 397, NULL),
('The Paradise Inn', 36, '2019-06-19', 325, NULL),
('The Paradise Inn', 36, '2019-06-20', 307, NULL),
('The Paradise Inn', 36, '2019-06-21', 125, NULL),
('The Paradise Inn', 36, '2019-06-22', 276, NULL),
('The Paradise Inn', 36, '2019-06-23', 200, NULL),
('The Paradise Inn', 36, '2019-06-24', 213, NULL),
('The Paradise Inn', 36, '2019-06-25', 232, NULL),
('The Paradise Inn', 36, '2019-06-26', 341, NULL),
('The Paradise Inn', 36, '2019-06-27', 148, NULL),
('The Paradise Inn', 36, '2019-06-28', 259, NULL),
('The Paradise Inn', 36, '2019-06-29', 179, NULL),
('The Paradise Inn', 36, '2019-06-30', 141, NULL),
('The Paradise Inn', 36, '2019-07-01', 286, NULL),
('The Paradise Inn', 36, '2019-07-02', 252, NULL),
('The Paradise Inn', 36, '2019-07-03', 103, NULL),
('The Paradise Inn', 36, '2019-07-04', 115, NULL),
('The Paradise Inn', 36, '2019-07-05', 175, NULL),
('The Paradise Inn', 36, '2019-07-06', 161, NULL),
('The Paradise Inn', 36, '2019-07-07', 220, NULL),
('The Paradise Inn', 36, '2019-07-08', 207, NULL),
('The Paradise Inn', 36, '2019-07-09', 142, NULL),
('The Paradise Inn', 36, '2019-07-10', 195, NULL),
('The Paradise Inn', 36, '2019-07-11', 376, NULL),
('The Paradise Inn', 36, '2019-07-12', 216, NULL),
('The Paradise Inn', 36, '2019-07-13', 232, NULL),
('The Paradise Inn', 36, '2019-07-14', 392, NULL),
('The Paradise Inn', 36, '2019-07-15', 263, NULL),
('The Paradise Inn', 36, '2019-07-16', 312, NULL),
('The Paradise Inn', 36, '2019-07-17', 307, NULL),
('The Paradise Inn', 36, '2019-07-18', 394, NULL),
('The Paradise Inn', 36, '2019-07-19', 159, NULL),
('The Paradise Inn', 36, '2019-07-20', 314, NULL),
('The Paradise Inn', 36, '2019-07-21', 166, NULL),
('The Paradise Inn', 36, '2019-07-22', 184, NULL),
('The Paradise Inn', 36, '2019-07-23', 156, NULL),
('The Paradise Inn', 36, '2019-07-24', 127, NULL),
('The Paradise Inn', 36, '2019-07-25', 245, NULL),
('The Paradise Inn', 36, '2019-07-26', 332, NULL),
('The Paradise Inn', 36, '2019-07-27', 152, NULL),
('The Paradise Inn', 36, '2019-07-28', 214, NULL),
('The Paradise Inn', 36, '2019-07-29', 380, NULL),
('The Paradise Inn', 36, '2019-07-30', 179, NULL),
('The Paradise Inn', 36, '2019-07-31', 260, NULL),
('The Paradise Inn', 36, '2019-08-01', 367, NULL),
('The Paradise Inn', 36, '2019-08-02', 225, NULL),
('The Paradise Inn', 36, '2019-08-03', 310, NULL),
('The Paradise Inn', 36, '2019-08-04', 137, NULL),
('The Paradise Inn', 36, '2019-08-05', 128, NULL),
('The Paradise Inn', 36, '2019-08-06', 233, NULL),
('The Paradise Inn', 36, '2019-08-07', 291, NULL),
('The Paradise Inn', 36, '2019-08-08', 319, NULL),
('The Paradise Inn', 36, '2019-08-09', 136, NULL),
('The Paradise Inn', 36, '2019-08-10', 124, NULL),
('The Paradise Inn', 36, '2019-08-11', 349, NULL),
('The Paradise Inn', 36, '2019-08-12', 326, NULL),
('The Paradise Inn', 36, '2019-08-13', 264, NULL),
('The Paradise Inn', 36, '2019-08-14', 146, NULL),
('The Paradise Inn', 36, '2019-08-15', 156, NULL),
('The Paradise Inn', 36, '2019-08-16', 298, NULL),
('The Paradise Inn', 36, '2019-08-17', 218, NULL),
('The Paradise Inn', 36, '2019-08-18', 104, NULL),
('The Paradise Inn', 36, '2019-08-19', 316, NULL),
('The Paradise Inn', 36, '2019-08-20', 261, NULL),
('The Paradise Inn', 36, '2019-08-21', 133, NULL),
('The Paradise Inn', 36, '2019-08-22', 134, NULL),
('The Paradise Inn', 36, '2019-08-23', 127, NULL),
('The Paradise Inn', 36, '2019-08-24', 261, NULL),
('The Paradise Inn', 36, '2019-08-25', 224, NULL),
('The Paradise Inn', 36, '2019-08-26', 170, NULL),
('The Paradise Inn', 36, '2019-08-27', 334, NULL),
('The Paradise Inn', 36, '2019-08-28', 381, NULL),
('The Paradise Inn', 36, '2019-08-29', 381, NULL),
('The Paradise Inn', 36, '2019-08-30', 384, NULL),
('The Paradise Inn', 36, '2019-08-31', 174, NULL),
('The Paradise Inn', 36, '2019-09-01', 312, NULL),
('The Paradise Inn', 36, '2019-09-02', 281, NULL),
('The Paradise Inn', 36, '2019-09-03', 187, NULL),
('The Paradise Inn', 36, '2019-09-04', 302, NULL),
('The Paradise Inn', 36, '2019-09-05', 117, NULL),
('The Paradise Inn', 36, '2019-09-06', 399, NULL),
('The Paradise Inn', 36, '2019-09-07', 326, NULL),
('The Paradise Inn', 36, '2019-09-08', 131, NULL),
('The Paradise Inn', 36, '2019-09-09', 394, NULL),
('The Paradise Inn', 36, '2019-09-10', 320, NULL),
('The Paradise Inn', 36, '2019-09-11', 130, NULL),
('The Paradise Inn', 36, '2019-09-12', 208, NULL),
('The Paradise Inn', 36, '2019-09-13', 263, NULL),
('The Paradise Inn', 36, '2019-09-14', 394, NULL),
('The Paradise Inn', 36, '2019-09-15', 198, NULL),
('The Paradise Inn', 36, '2019-09-16', 327, NULL),
('The Paradise Inn', 36, '2019-09-17', 308, NULL),
('The Paradise Inn', 36, '2019-09-18', 339, NULL),
('The Paradise Inn', 36, '2019-09-19', 330, NULL),
('The Paradise Inn', 36, '2019-09-20', 291, NULL),
('The Paradise Inn', 36, '2019-09-21', 347, NULL),
('The Paradise Inn', 36, '2019-09-22', 330, NULL),
('The Paradise Inn', 36, '2019-09-23', 300, NULL),
('The Paradise Inn', 36, '2019-09-24', 299, NULL),
('The Paradise Inn', 36, '2019-09-25', 174, NULL),
('The Paradise Inn', 36, '2019-09-26', 284, NULL),
('The Paradise Inn', 36, '2019-09-27', 124, NULL),
('The Paradise Inn', 36, '2019-09-28', 142, NULL),
('The Paradise Inn', 36, '2019-09-29', 198, NULL),
('The Paradise Inn', 36, '2019-09-30', 161, NULL),
('The Paradise Inn', 36, '2019-10-01', 312, NULL),
('The Paradise Inn', 36, '2019-10-02', 135, NULL),
('The Paradise Inn', 36, '2019-10-03', 338, NULL),
('The Paradise Inn', 36, '2019-10-04', 139, NULL),
('The Paradise Inn', 36, '2019-10-05', 281, NULL),
('The Paradise Inn', 36, '2019-10-06', 149, NULL),
('The Paradise Inn', 36, '2019-10-07', 202, NULL),
('The Paradise Inn', 36, '2019-10-08', 275, NULL),
('The Paradise Inn', 36, '2019-10-09', 152, NULL),
('The Paradise Inn', 36, '2019-10-10', 144, NULL),
('The Paradise Inn', 36, '2019-10-11', 101, NULL),
('The Paradise Inn', 36, '2019-10-12', 230, NULL),
('The Paradise Inn', 36, '2019-10-13', 115, NULL),
('The Paradise Inn', 36, '2019-10-14', 390, NULL),
('The Paradise Inn', 36, '2019-10-15', 195, NULL),
('The Paradise Inn', 36, '2019-10-16', 223, NULL),
('The Paradise Inn', 36, '2019-10-17', 179, NULL),
('The Paradise Inn', 36, '2019-10-18', 153, NULL),
('The Paradise Inn', 36, '2019-10-19', 147, NULL),
('The Paradise Inn', 36, '2019-10-20', 337, NULL),
('The Paradise Inn', 36, '2019-10-21', 179, NULL),
('The Paradise Inn', 36, '2019-10-22', 110, NULL),
('The Paradise Inn', 36, '2019-10-23', 392, NULL),
('The Paradise Inn', 36, '2019-10-24', 184, NULL),
('The Paradise Inn', 36, '2019-10-25', 381, NULL),
('The Paradise Inn', 36, '2019-10-26', 358, NULL),
('The Paradise Inn', 36, '2019-10-27', 198, NULL),
('The Paradise Inn', 36, '2019-10-28', 265, NULL),
('The Paradise Inn', 36, '2019-10-29', 125, NULL),
('The Paradise Inn', 36, '2019-10-30', 136, NULL),
('The Paradise Inn', 36, '2019-10-31', 288, NULL),
('The Paradise Inn', 36, '2019-11-01', 362, NULL),
('The Paradise Inn', 36, '2019-11-02', 250, NULL),
('The Paradise Inn', 36, '2019-11-03', 245, NULL),
('The Paradise Inn', 36, '2019-11-04', 363, NULL),
('The Paradise Inn', 36, '2019-11-05', 164, NULL),
('The Paradise Inn', 36, '2019-11-06', 118, NULL),
('The Paradise Inn', 36, '2019-11-07', 318, NULL),
('The Paradise Inn', 36, '2019-11-08', 320, NULL),
('The Paradise Inn', 36, '2019-11-09', 199, NULL),
('The Paradise Inn', 36, '2019-11-10', 137, NULL),
('The Paradise Inn', 36, '2019-11-11', 133, NULL),
('The Paradise Inn', 36, '2019-11-12', 252, NULL),
('The Paradise Inn', 36, '2019-11-13', 281, NULL),
('The Paradise Inn', 36, '2019-11-14', 334, NULL),
('The Paradise Inn', 36, '2019-11-15', 240, NULL),
('The Paradise Inn', 36, '2019-11-16', 267, NULL),
('The Paradise Inn', 36, '2019-11-17', 138, NULL),
('The Paradise Inn', 36, '2019-11-18', 141, NULL),
('The Paradise Inn', 36, '2019-11-19', 179, NULL),
('The Paradise Inn', 36, '2019-11-20', 243, NULL),
('The Paradise Inn', 36, '2019-11-21', 239, NULL),
('The Paradise Inn', 36, '2019-11-22', 248, NULL),
('The Paradise Inn', 36, '2019-11-23', 237, NULL),
('The Paradise Inn', 36, '2019-11-24', 397, NULL),
('The Paradise Inn', 36, '2019-11-25', 377, NULL),
('The Paradise Inn', 36, '2019-11-26', 103, NULL),
('The Paradise Inn', 36, '2019-11-27', 266, NULL),
('The Paradise Inn', 36, '2019-11-28', 364, NULL),
('The Paradise Inn', 36, '2019-11-29', 170, NULL),
('The Paradise Inn', 36, '2019-11-30', 284, NULL),
('The Paradise Inn', 36, '2019-12-01', 109, NULL),
('The Paradise Inn', 36, '2019-12-02', 299, NULL),
('The Paradise Inn', 36, '2019-12-03', 351, NULL),
('The Paradise Inn', 36, '2019-12-04', 383, NULL),
('The Paradise Inn', 36, '2019-12-05', 299, NULL),
('The Paradise Inn', 36, '2019-12-06', 312, NULL),
('The Paradise Inn', 36, '2019-12-07', 370, NULL),
('The Paradise Inn', 36, '2019-12-08', 150, NULL),
('The Paradise Inn', 36, '2019-12-09', 354, NULL),
('The Paradise Inn', 36, '2019-12-10', 160, NULL),
('The Paradise Inn', 36, '2019-12-11', 277, NULL),
('The Paradise Inn', 36, '2019-12-12', 236, NULL),
('The Paradise Inn', 36, '2019-12-13', 107, NULL),
('The Paradise Inn', 36, '2019-12-14', 299, NULL),
('The Paradise Inn', 36, '2019-12-15', 289, NULL),
('The Paradise Inn', 36, '2019-12-16', 148, NULL),
('The Paradise Inn', 36, '2019-12-17', 112, NULL),
('The Paradise Inn', 36, '2019-12-18', 356, NULL),
('The Paradise Inn', 36, '2019-12-19', 258, NULL),
('The Paradise Inn', 36, '2019-12-20', 323, NULL),
('The Paradise Inn', 36, '2019-12-21', 123, NULL),
('The Paradise Inn', 36, '2019-12-22', 380, NULL),
('The Paradise Inn', 36, '2019-12-23', 374, NULL),
('The Paradise Inn', 36, '2019-12-24', 384, NULL),
('The Paradise Inn', 36, '2019-12-25', 344, NULL),
('The Paradise Inn', 36, '2019-12-26', 264, NULL),
('The Paradise Inn', 36, '2019-12-27', 174, NULL),
('The Paradise Inn', 36, '2019-12-28', 134, NULL),
('The Paradise Inn', 36, '2019-12-29', 392, NULL),
('The Paradise Inn', 36, '2019-12-30', 219, NULL),
('The Paradise Inn', 36, '2019-12-31', 330, NULL),
('The Paradise Inn', 36, '2020-01-01', 312, NULL),
('The Paradise Inn', 36, '2020-01-02', 396, NULL),
('The Paradise Inn', 36, '2020-01-03', 388, NULL),
('The Paradise Inn', 36, '2020-01-04', 359, NULL),
('The Paradise Inn', 36, '2020-01-05', 282, NULL),
('The Paradise Inn', 36, '2020-01-06', 317, NULL),
('The Paradise Inn', 36, '2020-01-07', 334, NULL),
('The Paradise Inn', 36, '2020-01-08', 206, NULL),
('The Paradise Inn', 36, '2020-01-09', 301, NULL),
('The Paradise Inn', 36, '2020-01-10', 134, NULL),
('The Paradise Inn', 36, '2020-01-11', 123, NULL),
('The Paradise Inn', 36, '2020-01-12', 152, NULL),
('The Paradise Inn', 36, '2020-01-13', 209, NULL),
('The Paradise Inn', 36, '2020-01-14', 158, NULL),
('The Paradise Inn', 36, '2020-01-15', 256, NULL),
('The Paradise Inn', 36, '2020-01-16', 380, NULL),
('The Paradise Inn', 36, '2020-01-17', 162, NULL),
('The Paradise Inn', 36, '2020-01-18', 189, NULL),
('The Paradise Inn', 36, '2020-01-19', 177, NULL),
('The Paradise Inn', 36, '2020-01-20', 377, NULL),
('The Paradise Inn', 36, '2020-01-21', 291, NULL),
('The Paradise Inn', 36, '2020-01-22', 101, NULL),
('The Paradise Inn', 36, '2020-01-23', 300, NULL),
('The Paradise Inn', 36, '2020-01-24', 102, NULL),
('The Paradise Inn', 36, '2020-01-25', 286, NULL),
('The Paradise Inn', 36, '2020-01-26', 334, NULL),
('The Paradise Inn', 36, '2020-01-27', 123, NULL),
('The Paradise Inn', 36, '2020-01-28', 350, NULL),
('The Paradise Inn', 36, '2020-01-29', 153, NULL),
('The Paradise Inn', 36, '2020-01-30', 135, NULL),
('The Paradise Inn', 36, '2020-01-31', 201, NULL),
('The Paradise Inn', 36, '2020-02-01', 318, NULL),
('The Paradise Inn', 36, '2020-02-02', 380, NULL),
('The Paradise Inn', 36, '2020-02-03', 190, NULL),
('The Paradise Inn', 36, '2020-02-04', 369, NULL),
('The Paradise Inn', 52, '2019-01-01', 390, NULL),
('The Paradise Inn', 52, '2019-01-02', 351, NULL),
('The Paradise Inn', 52, '2019-01-03', 271, NULL),
('The Paradise Inn', 52, '2019-01-04', 258, NULL),
('The Paradise Inn', 52, '2019-01-05', 143, NULL),
('The Paradise Inn', 52, '2019-01-06', 223, NULL),
('The Paradise Inn', 52, '2019-01-07', 299, NULL),
('The Paradise Inn', 52, '2019-01-08', 168, NULL),
('The Paradise Inn', 52, '2019-01-09', 172, NULL),
('The Paradise Inn', 52, '2019-01-10', 181, NULL),
('The Paradise Inn', 52, '2019-01-11', 117, NULL),
('The Paradise Inn', 52, '2019-01-12', 260, NULL),
('The Paradise Inn', 52, '2019-01-13', 336, NULL),
('The Paradise Inn', 52, '2019-01-14', 246, NULL),
('The Paradise Inn', 52, '2019-01-15', 331, NULL),
('The Paradise Inn', 52, '2019-01-16', 101, NULL),
('The Paradise Inn', 52, '2019-01-17', 347, NULL),
('The Paradise Inn', 52, '2019-01-18', 257, NULL),
('The Paradise Inn', 52, '2019-01-19', 204, NULL),
('The Paradise Inn', 52, '2019-01-20', 388, NULL),
('The Paradise Inn', 52, '2019-01-21', 239, NULL),
('The Paradise Inn', 52, '2019-01-22', 333, NULL),
('The Paradise Inn', 52, '2019-01-23', 389, NULL),
('The Paradise Inn', 52, '2019-01-24', 263, NULL),
('The Paradise Inn', 52, '2019-01-25', 248, NULL),
('The Paradise Inn', 52, '2019-01-26', 165, NULL),
('The Paradise Inn', 52, '2019-01-27', 263, NULL),
('The Paradise Inn', 52, '2019-01-28', 382, NULL),
('The Paradise Inn', 52, '2019-01-29', 100, NULL),
('The Paradise Inn', 52, '2019-01-30', 299, NULL),
('The Paradise Inn', 52, '2019-01-31', 377, NULL),
('The Paradise Inn', 52, '2019-02-01', 145, NULL),
('The Paradise Inn', 52, '2019-02-02', 393, NULL),
('The Paradise Inn', 52, '2019-02-03', 134, NULL),
('The Paradise Inn', 52, '2019-02-04', 327, NULL),
('The Paradise Inn', 52, '2019-02-05', 228, NULL),
('The Paradise Inn', 52, '2019-02-06', 191, NULL),
('The Paradise Inn', 52, '2019-02-07', 302, NULL),
('The Paradise Inn', 52, '2019-02-08', 116, NULL),
('The Paradise Inn', 52, '2019-02-09', 160, NULL),
('The Paradise Inn', 52, '2019-02-10', 125, NULL),
('The Paradise Inn', 52, '2019-02-11', 334, NULL),
('The Paradise Inn', 52, '2019-02-12', 220, NULL),
('The Paradise Inn', 52, '2019-02-13', 127, NULL),
('The Paradise Inn', 52, '2019-02-14', 294, NULL),
('The Paradise Inn', 52, '2019-02-15', 272, NULL),
('The Paradise Inn', 52, '2019-02-16', 386, NULL),
('The Paradise Inn', 52, '2019-02-17', 230, NULL),
('The Paradise Inn', 52, '2019-02-18', 156, NULL),
('The Paradise Inn', 52, '2019-02-19', 178, NULL),
('The Paradise Inn', 52, '2019-02-20', 321, NULL),
('The Paradise Inn', 52, '2019-02-21', 153, NULL),
('The Paradise Inn', 52, '2019-02-22', 302, NULL),
('The Paradise Inn', 52, '2019-02-23', 250, NULL),
('The Paradise Inn', 52, '2019-02-24', 245, NULL),
('The Paradise Inn', 52, '2019-02-25', 273, NULL),
('The Paradise Inn', 52, '2019-02-26', 275, NULL),
('The Paradise Inn', 52, '2019-02-27', 387, NULL),
('The Paradise Inn', 52, '2019-02-28', 294, NULL),
('The Paradise Inn', 52, '2019-03-01', 124, NULL),
('The Paradise Inn', 52, '2019-03-02', 199, NULL),
('The Paradise Inn', 52, '2019-03-03', 358, NULL),
('The Paradise Inn', 52, '2019-03-04', 209, NULL),
('The Paradise Inn', 52, '2019-03-05', 205, NULL),
('The Paradise Inn', 52, '2019-03-06', 200, NULL),
('The Paradise Inn', 52, '2019-03-07', 344, NULL),
('The Paradise Inn', 52, '2019-03-08', 357, NULL),
('The Paradise Inn', 52, '2019-03-09', 370, NULL),
('The Paradise Inn', 52, '2019-03-10', 346, NULL),
('The Paradise Inn', 52, '2019-03-11', 243, NULL),
('The Paradise Inn', 52, '2019-03-12', 390, NULL),
('The Paradise Inn', 52, '2019-03-13', 223, NULL),
('The Paradise Inn', 52, '2019-03-14', 328, NULL),
('The Paradise Inn', 52, '2019-03-15', 356, NULL),
('The Paradise Inn', 52, '2019-03-16', 332, NULL),
('The Paradise Inn', 52, '2019-03-17', 244, NULL),
('The Paradise Inn', 52, '2019-03-18', 314, NULL),
('The Paradise Inn', 52, '2019-03-19', 207, NULL),
('The Paradise Inn', 52, '2019-03-20', 318, NULL),
('The Paradise Inn', 52, '2019-03-21', 341, NULL),
('The Paradise Inn', 52, '2019-03-22', 186, NULL),
('The Paradise Inn', 52, '2019-03-23', 348, NULL),
('The Paradise Inn', 52, '2019-03-24', 372, NULL),
('The Paradise Inn', 52, '2019-03-25', 306, NULL),
('The Paradise Inn', 52, '2019-03-26', 185, NULL),
('The Paradise Inn', 52, '2019-03-27', 322, NULL),
('The Paradise Inn', 52, '2019-03-28', 129, NULL),
('The Paradise Inn', 52, '2019-03-29', 161, NULL),
('The Paradise Inn', 52, '2019-03-30', 126, NULL),
('The Paradise Inn', 52, '2019-03-31', 193, NULL),
('The Paradise Inn', 52, '2019-04-01', 118, NULL),
('The Paradise Inn', 52, '2019-04-02', 190, NULL),
('The Paradise Inn', 52, '2019-04-03', 180, NULL),
('The Paradise Inn', 52, '2019-04-04', 281, NULL),
('The Paradise Inn', 52, '2019-04-05', 103, NULL),
('The Paradise Inn', 52, '2019-04-06', 235, NULL),
('The Paradise Inn', 52, '2019-04-07', 140, NULL),
('The Paradise Inn', 52, '2019-04-08', 321, NULL),
('The Paradise Inn', 52, '2019-04-09', 167, NULL),
('The Paradise Inn', 52, '2019-04-10', 160, NULL),
('The Paradise Inn', 52, '2019-04-11', 132, NULL),
('The Paradise Inn', 52, '2019-04-12', 282, NULL),
('The Paradise Inn', 52, '2019-04-13', 390, NULL),
('The Paradise Inn', 52, '2019-04-14', 357, NULL),
('The Paradise Inn', 52, '2019-04-15', 246, NULL),
('The Paradise Inn', 52, '2019-04-16', 316, NULL),
('The Paradise Inn', 52, '2019-04-17', 150, NULL),
('The Paradise Inn', 52, '2019-04-18', 269, NULL),
('The Paradise Inn', 52, '2019-04-19', 302, NULL),
('The Paradise Inn', 52, '2019-04-20', 147, NULL),
('The Paradise Inn', 52, '2019-04-21', 398, NULL),
('The Paradise Inn', 52, '2019-04-22', 242, NULL),
('The Paradise Inn', 52, '2019-04-23', 156, NULL),
('The Paradise Inn', 52, '2019-04-24', 399, NULL),
('The Paradise Inn', 52, '2019-04-25', 114, NULL),
('The Paradise Inn', 52, '2019-04-26', 161, NULL),
('The Paradise Inn', 52, '2019-04-27', 292, NULL),
('The Paradise Inn', 52, '2019-04-28', 120, NULL),
('The Paradise Inn', 52, '2019-04-29', 107, NULL),
('The Paradise Inn', 52, '2019-04-30', 360, NULL),
('The Paradise Inn', 52, '2019-05-01', 159, NULL),
('The Paradise Inn', 52, '2019-05-02', 228, NULL),
('The Paradise Inn', 52, '2019-05-03', 298, NULL),
('The Paradise Inn', 52, '2019-05-04', 329, NULL),
('The Paradise Inn', 52, '2019-05-05', 298, NULL),
('The Paradise Inn', 52, '2019-05-06', 105, NULL),
('The Paradise Inn', 52, '2019-05-07', 395, NULL),
('The Paradise Inn', 52, '2019-05-08', 336, NULL),
('The Paradise Inn', 52, '2019-05-09', 154, NULL),
('The Paradise Inn', 52, '2019-05-10', 172, NULL),
('The Paradise Inn', 52, '2019-05-11', 262, NULL),
('The Paradise Inn', 52, '2019-05-12', 338, NULL),
('The Paradise Inn', 52, '2019-05-13', 214, NULL),
('The Paradise Inn', 52, '2019-05-14', 380, NULL),
('The Paradise Inn', 52, '2019-05-15', 174, NULL),
('The Paradise Inn', 52, '2019-05-16', 108, NULL),
('The Paradise Inn', 52, '2019-05-17', 244, NULL),
('The Paradise Inn', 52, '2019-05-18', 302, NULL),
('The Paradise Inn', 52, '2019-05-19', 143, NULL),
('The Paradise Inn', 52, '2019-05-20', 199, NULL),
('The Paradise Inn', 52, '2019-05-21', 289, NULL),
('The Paradise Inn', 52, '2019-05-22', 268, NULL),
('The Paradise Inn', 52, '2019-05-23', 162, NULL),
('The Paradise Inn', 52, '2019-05-24', 248, NULL),
('The Paradise Inn', 52, '2019-05-25', 275, NULL),
('The Paradise Inn', 52, '2019-05-26', 104, NULL),
('The Paradise Inn', 52, '2019-05-27', 158, NULL),
('The Paradise Inn', 52, '2019-05-28', 255, NULL),
('The Paradise Inn', 52, '2019-05-29', 191, NULL),
('The Paradise Inn', 52, '2019-05-30', 129, NULL),
('The Paradise Inn', 52, '2019-05-31', 271, NULL),
('The Paradise Inn', 52, '2019-06-01', 223, NULL),
('The Paradise Inn', 52, '2019-06-02', 248, NULL),
('The Paradise Inn', 52, '2019-06-03', 317, NULL),
('The Paradise Inn', 52, '2019-06-04', 194, NULL),
('The Paradise Inn', 52, '2019-06-05', 250, NULL),
('The Paradise Inn', 52, '2019-06-06', 324, NULL),
('The Paradise Inn', 52, '2019-06-07', 102, NULL),
('The Paradise Inn', 52, '2019-06-08', 276, NULL),
('The Paradise Inn', 52, '2019-06-09', 373, NULL),
('The Paradise Inn', 52, '2019-06-10', 306, NULL),
('The Paradise Inn', 52, '2019-06-11', 150, NULL),
('The Paradise Inn', 52, '2019-06-12', 360, NULL),
('The Paradise Inn', 52, '2019-06-13', 254, NULL),
('The Paradise Inn', 52, '2019-06-14', 172, NULL),
('The Paradise Inn', 52, '2019-06-15', 209, NULL),
('The Paradise Inn', 52, '2019-06-16', 380, NULL),
('The Paradise Inn', 52, '2019-06-17', 317, NULL),
('The Paradise Inn', 52, '2019-06-18', 261, NULL),
('The Paradise Inn', 52, '2019-06-19', 294, NULL),
('The Paradise Inn', 52, '2019-06-20', 113, NULL),
('The Paradise Inn', 52, '2019-06-21', 115, NULL),
('The Paradise Inn', 52, '2019-06-22', 196, NULL),
('The Paradise Inn', 52, '2019-06-23', 200, NULL),
('The Paradise Inn', 52, '2019-06-24', 237, NULL),
('The Paradise Inn', 52, '2019-06-25', 335, NULL),
('The Paradise Inn', 52, '2019-06-26', 145, NULL),
('The Paradise Inn', 52, '2019-06-27', 242, NULL),
('The Paradise Inn', 52, '2019-06-28', 125, NULL),
('The Paradise Inn', 52, '2019-06-29', 180, NULL),
('The Paradise Inn', 52, '2019-06-30', 219, NULL),
('The Paradise Inn', 52, '2019-07-01', 230, NULL),
('The Paradise Inn', 52, '2019-07-02', 186, NULL),
('The Paradise Inn', 52, '2019-07-03', 321, NULL),
('The Paradise Inn', 52, '2019-07-04', 326, NULL),
('The Paradise Inn', 52, '2019-07-05', 109, NULL),
('The Paradise Inn', 52, '2019-07-06', 375, NULL),
('The Paradise Inn', 52, '2019-07-07', 231, NULL),
('The Paradise Inn', 52, '2019-07-08', 380, NULL),
('The Paradise Inn', 52, '2019-07-09', 385, NULL),
('The Paradise Inn', 52, '2019-07-10', 268, NULL),
('The Paradise Inn', 52, '2019-07-11', 101, NULL),
('The Paradise Inn', 52, '2019-07-12', 210, NULL),
('The Paradise Inn', 52, '2019-07-13', 237, NULL),
('The Paradise Inn', 52, '2019-07-14', 102, NULL),
('The Paradise Inn', 52, '2019-07-15', 289, NULL),
('The Paradise Inn', 52, '2019-07-16', 184, NULL),
('The Paradise Inn', 52, '2019-07-17', 111, NULL),
('The Paradise Inn', 52, '2019-07-18', 188, NULL),
('The Paradise Inn', 52, '2019-07-19', 155, NULL),
('The Paradise Inn', 52, '2019-07-20', 269, NULL),
('The Paradise Inn', 52, '2019-07-21', 141, NULL),
('The Paradise Inn', 52, '2019-07-22', 390, NULL),
('The Paradise Inn', 52, '2019-07-23', 349, NULL),
('The Paradise Inn', 52, '2019-07-24', 139, NULL),
('The Paradise Inn', 52, '2019-07-25', 329, NULL),
('The Paradise Inn', 52, '2019-07-26', 127, NULL),
('The Paradise Inn', 52, '2019-07-27', 209, NULL),
('The Paradise Inn', 52, '2019-07-28', 136, NULL),
('The Paradise Inn', 52, '2019-07-29', 229, NULL),
('The Paradise Inn', 52, '2019-07-30', 227, NULL),
('The Paradise Inn', 52, '2019-07-31', 253, NULL),
('The Paradise Inn', 52, '2019-08-01', 314, NULL),
('The Paradise Inn', 52, '2019-08-02', 276, NULL),
('The Paradise Inn', 52, '2019-08-03', 371, NULL),
('The Paradise Inn', 52, '2019-08-04', 126, NULL),
('The Paradise Inn', 52, '2019-08-05', 202, NULL),
('The Paradise Inn', 52, '2019-08-06', 173, NULL),
('The Paradise Inn', 52, '2019-08-07', 368, NULL),
('The Paradise Inn', 52, '2019-08-08', 182, NULL),
('The Paradise Inn', 52, '2019-08-09', 232, NULL),
('The Paradise Inn', 52, '2019-08-10', 151, NULL),
('The Paradise Inn', 52, '2019-08-11', 370, NULL),
('The Paradise Inn', 52, '2019-08-12', 348, NULL),
('The Paradise Inn', 52, '2019-08-13', 381, NULL),
('The Paradise Inn', 52, '2019-08-14', 164, NULL),
('The Paradise Inn', 52, '2019-08-15', 127, NULL),
('The Paradise Inn', 52, '2019-08-16', 134, NULL),
('The Paradise Inn', 52, '2019-08-17', 311, NULL),
('The Paradise Inn', 52, '2019-08-18', 369, NULL),
('The Paradise Inn', 52, '2019-08-19', 203, NULL),
('The Paradise Inn', 52, '2019-08-20', 111, NULL),
('The Paradise Inn', 52, '2019-08-21', 335, NULL),
('The Paradise Inn', 52, '2019-08-22', 380, NULL),
('The Paradise Inn', 52, '2019-08-23', 217, NULL),
('The Paradise Inn', 52, '2019-08-24', 390, NULL),
('The Paradise Inn', 52, '2019-08-25', 290, NULL),
('The Paradise Inn', 52, '2019-08-26', 357, NULL),
('The Paradise Inn', 52, '2019-08-27', 277, NULL),
('The Paradise Inn', 52, '2019-08-28', 393, NULL),
('The Paradise Inn', 52, '2019-08-29', 372, NULL),
('The Paradise Inn', 52, '2019-08-30', 133, NULL),
('The Paradise Inn', 52, '2019-08-31', 318, NULL),
('The Paradise Inn', 52, '2019-09-01', 110, NULL),
('The Paradise Inn', 52, '2019-09-02', 105, NULL),
('The Paradise Inn', 52, '2019-09-03', 339, NULL),
('The Paradise Inn', 52, '2019-09-04', 362, NULL),
('The Paradise Inn', 52, '2019-09-05', 228, NULL),
('The Paradise Inn', 52, '2019-09-06', 232, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 52, '2019-09-07', 302, NULL),
('The Paradise Inn', 52, '2019-09-08', 280, NULL),
('The Paradise Inn', 52, '2019-09-09', 353, NULL),
('The Paradise Inn', 52, '2019-09-10', 105, NULL),
('The Paradise Inn', 52, '2019-09-11', 123, NULL),
('The Paradise Inn', 52, '2019-09-12', 322, NULL),
('The Paradise Inn', 52, '2019-09-13', 355, NULL),
('The Paradise Inn', 52, '2019-09-14', 396, NULL),
('The Paradise Inn', 52, '2019-09-15', 113, NULL),
('The Paradise Inn', 52, '2019-09-16', 309, NULL),
('The Paradise Inn', 52, '2019-09-17', 295, NULL),
('The Paradise Inn', 52, '2019-09-18', 278, NULL),
('The Paradise Inn', 52, '2019-09-19', 175, NULL),
('The Paradise Inn', 52, '2019-09-20', 211, NULL),
('The Paradise Inn', 52, '2019-09-21', 309, NULL),
('The Paradise Inn', 52, '2019-09-22', 195, NULL),
('The Paradise Inn', 52, '2019-09-23', 154, NULL),
('The Paradise Inn', 52, '2019-09-24', 244, NULL),
('The Paradise Inn', 52, '2019-09-25', 377, NULL),
('The Paradise Inn', 52, '2019-09-26', 325, NULL),
('The Paradise Inn', 52, '2019-09-27', 132, NULL),
('The Paradise Inn', 52, '2019-09-28', 349, NULL),
('The Paradise Inn', 52, '2019-09-29', 289, NULL),
('The Paradise Inn', 52, '2019-09-30', 314, NULL),
('The Paradise Inn', 52, '2019-10-01', 357, NULL),
('The Paradise Inn', 52, '2019-10-02', 216, NULL),
('The Paradise Inn', 52, '2019-10-03', 271, NULL),
('The Paradise Inn', 52, '2019-10-04', 318, NULL),
('The Paradise Inn', 52, '2019-10-05', 225, NULL),
('The Paradise Inn', 52, '2019-10-06', 246, NULL),
('The Paradise Inn', 52, '2019-10-07', 205, NULL),
('The Paradise Inn', 52, '2019-10-08', 135, NULL),
('The Paradise Inn', 52, '2019-10-09', 396, NULL),
('The Paradise Inn', 52, '2019-10-10', 303, NULL),
('The Paradise Inn', 52, '2019-10-11', 175, NULL),
('The Paradise Inn', 52, '2019-10-12', 219, NULL),
('The Paradise Inn', 52, '2019-10-13', 283, NULL),
('The Paradise Inn', 52, '2019-10-14', 164, NULL),
('The Paradise Inn', 52, '2019-10-15', 259, NULL),
('The Paradise Inn', 52, '2019-10-16', 367, NULL),
('The Paradise Inn', 52, '2019-10-17', 318, NULL),
('The Paradise Inn', 52, '2019-10-18', 163, NULL),
('The Paradise Inn', 52, '2019-10-19', 207, NULL),
('The Paradise Inn', 52, '2019-10-20', 304, NULL),
('The Paradise Inn', 52, '2019-10-21', 164, NULL),
('The Paradise Inn', 52, '2019-10-22', 394, NULL),
('The Paradise Inn', 52, '2019-10-23', 351, NULL),
('The Paradise Inn', 52, '2019-10-24', 353, NULL),
('The Paradise Inn', 52, '2019-10-25', 102, NULL),
('The Paradise Inn', 52, '2019-10-26', 235, NULL),
('The Paradise Inn', 52, '2019-10-27', 174, NULL),
('The Paradise Inn', 52, '2019-10-28', 222, NULL),
('The Paradise Inn', 52, '2019-10-29', 191, NULL),
('The Paradise Inn', 52, '2019-10-30', 266, NULL),
('The Paradise Inn', 52, '2019-10-31', 120, NULL),
('The Paradise Inn', 52, '2019-11-01', 380, NULL),
('The Paradise Inn', 52, '2019-11-02', 223, NULL),
('The Paradise Inn', 52, '2019-11-03', 296, NULL),
('The Paradise Inn', 52, '2019-11-04', 139, NULL),
('The Paradise Inn', 52, '2019-11-05', 120, NULL),
('The Paradise Inn', 52, '2019-11-06', 293, NULL),
('The Paradise Inn', 52, '2019-11-07', 147, NULL),
('The Paradise Inn', 52, '2019-11-08', 128, NULL),
('The Paradise Inn', 52, '2019-11-09', 110, NULL),
('The Paradise Inn', 52, '2019-11-10', 271, NULL),
('The Paradise Inn', 52, '2019-11-11', 238, NULL),
('The Paradise Inn', 52, '2019-11-12', 176, NULL),
('The Paradise Inn', 52, '2019-11-13', 180, NULL),
('The Paradise Inn', 52, '2019-11-14', 244, NULL),
('The Paradise Inn', 52, '2019-11-15', 354, NULL),
('The Paradise Inn', 52, '2019-11-16', 250, NULL),
('The Paradise Inn', 52, '2019-11-17', 370, NULL),
('The Paradise Inn', 52, '2019-11-18', 158, NULL),
('The Paradise Inn', 52, '2019-11-19', 101, NULL),
('The Paradise Inn', 52, '2019-11-20', 186, NULL),
('The Paradise Inn', 52, '2019-11-21', 100, NULL),
('The Paradise Inn', 52, '2019-11-22', 111, NULL),
('The Paradise Inn', 52, '2019-11-23', 296, NULL),
('The Paradise Inn', 52, '2019-11-24', 355, NULL),
('The Paradise Inn', 52, '2019-11-25', 327, NULL),
('The Paradise Inn', 52, '2019-11-26', 331, NULL),
('The Paradise Inn', 52, '2019-11-27', 237, NULL),
('The Paradise Inn', 52, '2019-11-28', 360, NULL),
('The Paradise Inn', 52, '2019-11-29', 383, NULL),
('The Paradise Inn', 52, '2019-11-30', 280, NULL),
('The Paradise Inn', 52, '2019-12-01', 211, NULL),
('The Paradise Inn', 52, '2019-12-02', 379, NULL),
('The Paradise Inn', 52, '2019-12-03', 388, NULL),
('The Paradise Inn', 52, '2019-12-04', 336, NULL),
('The Paradise Inn', 52, '2019-12-05', 267, NULL),
('The Paradise Inn', 52, '2019-12-06', 143, NULL),
('The Paradise Inn', 52, '2019-12-07', 381, NULL),
('The Paradise Inn', 52, '2019-12-08', 314, NULL),
('The Paradise Inn', 52, '2019-12-09', 346, NULL),
('The Paradise Inn', 52, '2019-12-10', 199, NULL),
('The Paradise Inn', 52, '2019-12-11', 273, NULL),
('The Paradise Inn', 52, '2019-12-12', 324, NULL),
('The Paradise Inn', 52, '2019-12-13', 113, NULL),
('The Paradise Inn', 52, '2019-12-14', 158, NULL),
('The Paradise Inn', 52, '2019-12-15', 315, NULL),
('The Paradise Inn', 52, '2019-12-16', 319, NULL),
('The Paradise Inn', 52, '2019-12-17', 203, NULL),
('The Paradise Inn', 52, '2019-12-18', 220, NULL),
('The Paradise Inn', 52, '2019-12-19', 255, NULL),
('The Paradise Inn', 52, '2019-12-20', 163, NULL),
('The Paradise Inn', 52, '2019-12-21', 347, NULL),
('The Paradise Inn', 52, '2019-12-22', 227, NULL),
('The Paradise Inn', 52, '2019-12-23', 193, NULL),
('The Paradise Inn', 52, '2019-12-24', 166, NULL),
('The Paradise Inn', 52, '2019-12-25', 375, NULL),
('The Paradise Inn', 52, '2019-12-26', 320, NULL),
('The Paradise Inn', 52, '2019-12-27', 325, NULL),
('The Paradise Inn', 52, '2019-12-28', 199, NULL),
('The Paradise Inn', 52, '2019-12-29', 227, NULL),
('The Paradise Inn', 52, '2019-12-30', 282, NULL),
('The Paradise Inn', 52, '2019-12-31', 203, NULL),
('The Paradise Inn', 52, '2020-01-01', 158, NULL),
('The Paradise Inn', 52, '2020-01-02', 288, NULL),
('The Paradise Inn', 52, '2020-01-03', 170, NULL),
('The Paradise Inn', 52, '2020-01-04', 203, NULL),
('The Paradise Inn', 52, '2020-01-05', 307, NULL),
('The Paradise Inn', 52, '2020-01-06', 325, NULL),
('The Paradise Inn', 52, '2020-01-07', 307, NULL),
('The Paradise Inn', 52, '2020-01-08', 269, NULL),
('The Paradise Inn', 52, '2020-01-09', 209, NULL),
('The Paradise Inn', 52, '2020-01-10', 223, NULL),
('The Paradise Inn', 52, '2020-01-11', 329, NULL),
('The Paradise Inn', 52, '2020-01-12', 269, NULL),
('The Paradise Inn', 52, '2020-01-13', 398, NULL),
('The Paradise Inn', 52, '2020-01-14', 223, NULL),
('The Paradise Inn', 52, '2020-01-15', 119, NULL),
('The Paradise Inn', 52, '2020-01-16', 168, NULL),
('The Paradise Inn', 52, '2020-01-17', 334, NULL),
('The Paradise Inn', 52, '2020-01-18', 316, NULL),
('The Paradise Inn', 52, '2020-01-19', 309, NULL),
('The Paradise Inn', 52, '2020-01-20', 232, NULL),
('The Paradise Inn', 52, '2020-01-21', 180, NULL),
('The Paradise Inn', 52, '2020-01-22', 121, NULL),
('The Paradise Inn', 52, '2020-01-23', 144, NULL),
('The Paradise Inn', 52, '2020-01-24', 109, NULL),
('The Paradise Inn', 52, '2020-01-25', 311, NULL),
('The Paradise Inn', 52, '2020-01-26', 216, NULL),
('The Paradise Inn', 52, '2020-01-27', 338, NULL),
('The Paradise Inn', 52, '2020-01-28', 362, NULL),
('The Paradise Inn', 52, '2020-01-29', 361, NULL),
('The Paradise Inn', 52, '2020-01-30', 369, NULL),
('The Paradise Inn', 52, '2020-01-31', 318, NULL),
('The Paradise Inn', 52, '2020-02-01', 140, NULL),
('The Paradise Inn', 52, '2020-02-02', 360, NULL),
('The Paradise Inn', 52, '2020-02-03', 341, NULL),
('The Paradise Inn', 52, '2020-02-04', 371, NULL),
('The Paradise Inn', 74, '2019-01-01', 154, NULL),
('The Paradise Inn', 74, '2019-01-02', 268, NULL),
('The Paradise Inn', 74, '2019-01-03', 364, NULL),
('The Paradise Inn', 74, '2019-01-04', 356, NULL),
('The Paradise Inn', 74, '2019-01-05', 134, NULL),
('The Paradise Inn', 74, '2019-01-06', 249, NULL),
('The Paradise Inn', 74, '2019-01-07', 133, NULL),
('The Paradise Inn', 74, '2019-01-08', 133, NULL),
('The Paradise Inn', 74, '2019-01-09', 384, NULL),
('The Paradise Inn', 74, '2019-01-10', 218, NULL),
('The Paradise Inn', 74, '2019-01-11', 148, NULL),
('The Paradise Inn', 74, '2019-01-12', 259, NULL),
('The Paradise Inn', 74, '2019-01-13', 381, NULL),
('The Paradise Inn', 74, '2019-01-14', 357, NULL),
('The Paradise Inn', 74, '2019-01-15', 269, NULL),
('The Paradise Inn', 74, '2019-01-16', 122, NULL),
('The Paradise Inn', 74, '2019-01-17', 392, NULL),
('The Paradise Inn', 74, '2019-01-18', 118, NULL),
('The Paradise Inn', 74, '2019-01-19', 309, NULL),
('The Paradise Inn', 74, '2019-01-20', 302, NULL),
('The Paradise Inn', 74, '2019-01-21', 247, NULL),
('The Paradise Inn', 74, '2019-01-22', 378, NULL),
('The Paradise Inn', 74, '2019-01-23', 281, NULL),
('The Paradise Inn', 74, '2019-01-24', 397, NULL),
('The Paradise Inn', 74, '2019-01-25', 233, NULL),
('The Paradise Inn', 74, '2019-01-26', 183, NULL),
('The Paradise Inn', 74, '2019-01-27', 296, NULL),
('The Paradise Inn', 74, '2019-01-28', 374, NULL),
('The Paradise Inn', 74, '2019-01-29', 205, NULL),
('The Paradise Inn', 74, '2019-01-30', 269, NULL),
('The Paradise Inn', 74, '2019-01-31', 132, NULL),
('The Paradise Inn', 74, '2019-02-01', 211, NULL),
('The Paradise Inn', 74, '2019-02-02', 281, NULL),
('The Paradise Inn', 74, '2019-02-03', 398, NULL),
('The Paradise Inn', 74, '2019-02-04', 122, NULL),
('The Paradise Inn', 74, '2019-02-05', 248, NULL),
('The Paradise Inn', 74, '2019-02-06', 257, NULL),
('The Paradise Inn', 74, '2019-02-07', 126, NULL),
('The Paradise Inn', 74, '2019-02-08', 156, NULL),
('The Paradise Inn', 74, '2019-02-09', 232, NULL),
('The Paradise Inn', 74, '2019-02-10', 202, NULL),
('The Paradise Inn', 74, '2019-02-11', 174, NULL),
('The Paradise Inn', 74, '2019-02-12', 386, NULL),
('The Paradise Inn', 74, '2019-02-13', 219, NULL),
('The Paradise Inn', 74, '2019-02-14', 172, NULL),
('The Paradise Inn', 74, '2019-02-15', 349, NULL),
('The Paradise Inn', 74, '2019-02-16', 130, NULL),
('The Paradise Inn', 74, '2019-02-17', 319, NULL),
('The Paradise Inn', 74, '2019-02-18', 376, NULL),
('The Paradise Inn', 74, '2019-02-19', 345, NULL),
('The Paradise Inn', 74, '2019-02-20', 390, NULL),
('The Paradise Inn', 74, '2019-02-21', 207, NULL),
('The Paradise Inn', 74, '2019-02-22', 127, NULL),
('The Paradise Inn', 74, '2019-02-23', 102, NULL),
('The Paradise Inn', 74, '2019-02-24', 167, NULL),
('The Paradise Inn', 74, '2019-02-25', 361, NULL),
('The Paradise Inn', 74, '2019-02-26', 262, NULL),
('The Paradise Inn', 74, '2019-02-27', 373, NULL),
('The Paradise Inn', 74, '2019-02-28', 292, NULL),
('The Paradise Inn', 74, '2019-03-01', 312, NULL),
('The Paradise Inn', 74, '2019-03-02', 248, NULL),
('The Paradise Inn', 74, '2019-03-03', 277, NULL),
('The Paradise Inn', 74, '2019-03-04', 356, NULL),
('The Paradise Inn', 74, '2019-03-05', 125, NULL),
('The Paradise Inn', 74, '2019-03-06', 372, NULL),
('The Paradise Inn', 74, '2019-03-07', 118, NULL),
('The Paradise Inn', 74, '2019-03-08', 327, NULL),
('The Paradise Inn', 74, '2019-03-09', 365, NULL),
('The Paradise Inn', 74, '2019-03-10', 157, NULL),
('The Paradise Inn', 74, '2019-03-11', 145, NULL),
('The Paradise Inn', 74, '2019-03-12', 241, NULL),
('The Paradise Inn', 74, '2019-03-13', 229, NULL),
('The Paradise Inn', 74, '2019-03-14', 246, NULL),
('The Paradise Inn', 74, '2019-03-15', 175, NULL),
('The Paradise Inn', 74, '2019-03-16', 100, NULL),
('The Paradise Inn', 74, '2019-03-17', 164, NULL),
('The Paradise Inn', 74, '2019-03-18', 285, NULL),
('The Paradise Inn', 74, '2019-03-19', 121, NULL),
('The Paradise Inn', 74, '2019-03-20', 216, NULL),
('The Paradise Inn', 74, '2019-03-21', 138, NULL),
('The Paradise Inn', 74, '2019-03-22', 356, NULL),
('The Paradise Inn', 74, '2019-03-23', 238, NULL),
('The Paradise Inn', 74, '2019-03-24', 191, NULL),
('The Paradise Inn', 74, '2019-03-25', 269, NULL),
('The Paradise Inn', 74, '2019-03-26', 172, NULL),
('The Paradise Inn', 74, '2019-03-27', 392, NULL),
('The Paradise Inn', 74, '2019-03-28', 133, NULL),
('The Paradise Inn', 74, '2019-03-29', 298, NULL),
('The Paradise Inn', 74, '2019-03-30', 365, NULL),
('The Paradise Inn', 74, '2019-03-31', 244, NULL),
('The Paradise Inn', 74, '2019-04-01', 227, NULL),
('The Paradise Inn', 74, '2019-04-02', 283, NULL),
('The Paradise Inn', 74, '2019-04-03', 394, NULL),
('The Paradise Inn', 74, '2019-04-04', 239, NULL),
('The Paradise Inn', 74, '2019-04-05', 397, NULL),
('The Paradise Inn', 74, '2019-04-06', 362, NULL),
('The Paradise Inn', 74, '2019-04-07', 205, NULL),
('The Paradise Inn', 74, '2019-04-08', 275, NULL),
('The Paradise Inn', 74, '2019-04-09', 367, NULL),
('The Paradise Inn', 74, '2019-04-10', 257, NULL),
('The Paradise Inn', 74, '2019-04-11', 249, NULL),
('The Paradise Inn', 74, '2019-04-12', 190, NULL),
('The Paradise Inn', 74, '2019-04-13', 141, NULL),
('The Paradise Inn', 74, '2019-04-14', 281, NULL),
('The Paradise Inn', 74, '2019-04-15', 124, NULL),
('The Paradise Inn', 74, '2019-04-16', 138, NULL),
('The Paradise Inn', 74, '2019-04-17', 198, NULL),
('The Paradise Inn', 74, '2019-04-18', 157, NULL),
('The Paradise Inn', 74, '2019-04-19', 329, NULL),
('The Paradise Inn', 74, '2019-04-20', 169, NULL),
('The Paradise Inn', 74, '2019-04-21', 223, NULL),
('The Paradise Inn', 74, '2019-04-22', 322, NULL),
('The Paradise Inn', 74, '2019-04-23', 226, NULL),
('The Paradise Inn', 74, '2019-04-24', 119, NULL),
('The Paradise Inn', 74, '2019-04-25', 278, NULL),
('The Paradise Inn', 74, '2019-04-26', 278, NULL),
('The Paradise Inn', 74, '2019-04-27', 327, NULL),
('The Paradise Inn', 74, '2019-04-28', 250, NULL),
('The Paradise Inn', 74, '2019-04-29', 396, NULL),
('The Paradise Inn', 74, '2019-04-30', 109, NULL),
('The Paradise Inn', 74, '2019-05-01', 179, NULL),
('The Paradise Inn', 74, '2019-05-02', 365, NULL),
('The Paradise Inn', 74, '2019-05-03', 334, NULL),
('The Paradise Inn', 74, '2019-05-04', 309, NULL),
('The Paradise Inn', 74, '2019-05-05', 342, NULL),
('The Paradise Inn', 74, '2019-05-06', 263, NULL),
('The Paradise Inn', 74, '2019-05-07', 223, NULL),
('The Paradise Inn', 74, '2019-05-08', 347, NULL),
('The Paradise Inn', 74, '2019-05-09', 225, NULL),
('The Paradise Inn', 74, '2019-05-10', 125, NULL),
('The Paradise Inn', 74, '2019-05-11', 281, NULL),
('The Paradise Inn', 74, '2019-05-12', 252, NULL),
('The Paradise Inn', 74, '2019-05-13', 332, NULL),
('The Paradise Inn', 74, '2019-05-14', 312, NULL),
('The Paradise Inn', 74, '2019-05-15', 190, NULL),
('The Paradise Inn', 74, '2019-05-16', 297, NULL),
('The Paradise Inn', 74, '2019-05-17', 175, NULL),
('The Paradise Inn', 74, '2019-05-18', 233, NULL),
('The Paradise Inn', 74, '2019-05-19', 299, NULL),
('The Paradise Inn', 74, '2019-05-20', 341, NULL),
('The Paradise Inn', 74, '2019-05-21', 103, NULL),
('The Paradise Inn', 74, '2019-05-22', 371, NULL),
('The Paradise Inn', 74, '2019-05-23', 232, NULL),
('The Paradise Inn', 74, '2019-05-24', 387, NULL),
('The Paradise Inn', 74, '2019-05-25', 136, NULL),
('The Paradise Inn', 74, '2019-05-26', 385, NULL),
('The Paradise Inn', 74, '2019-05-27', 215, NULL),
('The Paradise Inn', 74, '2019-05-28', 157, NULL),
('The Paradise Inn', 74, '2019-05-29', 123, NULL),
('The Paradise Inn', 74, '2019-05-30', 359, NULL),
('The Paradise Inn', 74, '2019-05-31', 338, NULL),
('The Paradise Inn', 74, '2019-06-01', 268, NULL),
('The Paradise Inn', 74, '2019-06-02', 139, NULL),
('The Paradise Inn', 74, '2019-06-03', 262, NULL),
('The Paradise Inn', 74, '2019-06-04', 389, NULL),
('The Paradise Inn', 74, '2019-06-05', 372, NULL),
('The Paradise Inn', 74, '2019-06-06', 194, NULL),
('The Paradise Inn', 74, '2019-06-07', 224, NULL),
('The Paradise Inn', 74, '2019-06-08', 288, NULL),
('The Paradise Inn', 74, '2019-06-09', 299, NULL),
('The Paradise Inn', 74, '2019-06-10', 342, NULL),
('The Paradise Inn', 74, '2019-06-11', 309, NULL),
('The Paradise Inn', 74, '2019-06-12', 167, NULL),
('The Paradise Inn', 74, '2019-06-13', 264, NULL),
('The Paradise Inn', 74, '2019-06-14', 339, NULL),
('The Paradise Inn', 74, '2019-06-15', 209, NULL),
('The Paradise Inn', 74, '2019-06-16', 346, NULL),
('The Paradise Inn', 74, '2019-06-17', 223, NULL),
('The Paradise Inn', 74, '2019-06-18', 311, NULL),
('The Paradise Inn', 74, '2019-06-19', 394, NULL),
('The Paradise Inn', 74, '2019-06-20', 144, NULL),
('The Paradise Inn', 74, '2019-06-21', 103, NULL),
('The Paradise Inn', 74, '2019-06-22', 353, NULL),
('The Paradise Inn', 74, '2019-06-23', 304, NULL),
('The Paradise Inn', 74, '2019-06-24', 149, NULL),
('The Paradise Inn', 74, '2019-06-25', 278, NULL),
('The Paradise Inn', 74, '2019-06-26', 201, NULL),
('The Paradise Inn', 74, '2019-06-27', 369, NULL),
('The Paradise Inn', 74, '2019-06-28', 351, NULL),
('The Paradise Inn', 74, '2019-06-29', 265, NULL),
('The Paradise Inn', 74, '2019-06-30', 272, NULL),
('The Paradise Inn', 74, '2019-07-01', 190, NULL),
('The Paradise Inn', 74, '2019-07-02', 373, NULL),
('The Paradise Inn', 74, '2019-07-03', 295, NULL),
('The Paradise Inn', 74, '2019-07-04', 287, NULL),
('The Paradise Inn', 74, '2019-07-05', 220, NULL),
('The Paradise Inn', 74, '2019-07-06', 394, NULL),
('The Paradise Inn', 74, '2019-07-07', 392, NULL),
('The Paradise Inn', 74, '2019-07-08', 282, NULL),
('The Paradise Inn', 74, '2019-07-09', 199, NULL),
('The Paradise Inn', 74, '2019-07-10', 356, NULL),
('The Paradise Inn', 74, '2019-07-11', 178, NULL),
('The Paradise Inn', 74, '2019-07-12', 300, NULL),
('The Paradise Inn', 74, '2019-07-13', 390, NULL),
('The Paradise Inn', 74, '2019-07-14', 133, NULL),
('The Paradise Inn', 74, '2019-07-15', 255, NULL),
('The Paradise Inn', 74, '2019-07-16', 184, NULL),
('The Paradise Inn', 74, '2019-07-17', 134, NULL),
('The Paradise Inn', 74, '2019-07-18', 260, NULL),
('The Paradise Inn', 74, '2019-07-19', 198, NULL),
('The Paradise Inn', 74, '2019-07-20', 303, NULL),
('The Paradise Inn', 74, '2019-07-21', 107, NULL),
('The Paradise Inn', 74, '2019-07-22', 101, NULL),
('The Paradise Inn', 74, '2019-07-23', 279, NULL),
('The Paradise Inn', 74, '2019-07-24', 216, NULL),
('The Paradise Inn', 74, '2019-07-25', 210, NULL),
('The Paradise Inn', 74, '2019-07-26', 140, NULL),
('The Paradise Inn', 74, '2019-07-27', 189, NULL),
('The Paradise Inn', 74, '2019-07-28', 241, NULL),
('The Paradise Inn', 74, '2019-07-29', 205, NULL),
('The Paradise Inn', 74, '2019-07-30', 198, NULL),
('The Paradise Inn', 74, '2019-07-31', 386, NULL),
('The Paradise Inn', 74, '2019-08-01', 367, NULL),
('The Paradise Inn', 74, '2019-08-02', 306, NULL),
('The Paradise Inn', 74, '2019-08-03', 227, NULL),
('The Paradise Inn', 74, '2019-08-04', 122, NULL),
('The Paradise Inn', 74, '2019-08-05', 225, NULL),
('The Paradise Inn', 74, '2019-08-06', 365, NULL),
('The Paradise Inn', 74, '2019-08-07', 268, NULL),
('The Paradise Inn', 74, '2019-08-08', 154, NULL),
('The Paradise Inn', 74, '2019-08-09', 353, NULL),
('The Paradise Inn', 74, '2019-08-10', 286, NULL),
('The Paradise Inn', 74, '2019-08-11', 106, NULL),
('The Paradise Inn', 74, '2019-08-12', 365, NULL),
('The Paradise Inn', 74, '2019-08-13', 116, NULL),
('The Paradise Inn', 74, '2019-08-14', 286, NULL),
('The Paradise Inn', 74, '2019-08-15', 365, NULL),
('The Paradise Inn', 74, '2019-08-16', 276, NULL),
('The Paradise Inn', 74, '2019-08-17', 201, NULL),
('The Paradise Inn', 74, '2019-08-18', 230, NULL),
('The Paradise Inn', 74, '2019-08-19', 267, NULL),
('The Paradise Inn', 74, '2019-08-20', 271, NULL),
('The Paradise Inn', 74, '2019-08-21', 273, NULL),
('The Paradise Inn', 74, '2019-08-22', 199, NULL),
('The Paradise Inn', 74, '2019-08-23', 305, NULL),
('The Paradise Inn', 74, '2019-08-24', 166, NULL),
('The Paradise Inn', 74, '2019-08-25', 377, NULL),
('The Paradise Inn', 74, '2019-08-26', 275, NULL),
('The Paradise Inn', 74, '2019-08-27', 283, NULL),
('The Paradise Inn', 74, '2019-08-28', 125, NULL),
('The Paradise Inn', 74, '2019-08-29', 318, NULL),
('The Paradise Inn', 74, '2019-08-30', 317, NULL),
('The Paradise Inn', 74, '2019-08-31', 369, NULL),
('The Paradise Inn', 74, '2019-09-01', 113, NULL),
('The Paradise Inn', 74, '2019-09-02', 184, NULL),
('The Paradise Inn', 74, '2019-09-03', 136, NULL),
('The Paradise Inn', 74, '2019-09-04', 205, NULL),
('The Paradise Inn', 74, '2019-09-05', 393, NULL),
('The Paradise Inn', 74, '2019-09-06', 164, NULL),
('The Paradise Inn', 74, '2019-09-07', 132, NULL),
('The Paradise Inn', 74, '2019-09-08', 306, NULL),
('The Paradise Inn', 74, '2019-09-09', 182, NULL),
('The Paradise Inn', 74, '2019-09-10', 364, NULL),
('The Paradise Inn', 74, '2019-09-11', 125, NULL),
('The Paradise Inn', 74, '2019-09-12', 286, NULL),
('The Paradise Inn', 74, '2019-09-13', 287, NULL),
('The Paradise Inn', 74, '2019-09-14', 398, NULL),
('The Paradise Inn', 74, '2019-09-15', 172, NULL),
('The Paradise Inn', 74, '2019-09-16', 167, NULL),
('The Paradise Inn', 74, '2019-09-17', 148, NULL),
('The Paradise Inn', 74, '2019-09-18', 276, NULL),
('The Paradise Inn', 74, '2019-09-19', 384, NULL),
('The Paradise Inn', 74, '2019-09-20', 381, NULL),
('The Paradise Inn', 74, '2019-09-21', 105, NULL),
('The Paradise Inn', 74, '2019-09-22', 187, NULL),
('The Paradise Inn', 74, '2019-09-23', 370, NULL),
('The Paradise Inn', 74, '2019-09-24', 225, NULL),
('The Paradise Inn', 74, '2019-09-25', 365, NULL),
('The Paradise Inn', 74, '2019-09-26', 376, NULL),
('The Paradise Inn', 74, '2019-09-27', 190, NULL),
('The Paradise Inn', 74, '2019-09-28', 322, NULL),
('The Paradise Inn', 74, '2019-09-29', 152, NULL),
('The Paradise Inn', 74, '2019-09-30', 387, NULL),
('The Paradise Inn', 74, '2019-10-01', 151, NULL),
('The Paradise Inn', 74, '2019-10-02', 274, NULL),
('The Paradise Inn', 74, '2019-10-03', 242, NULL),
('The Paradise Inn', 74, '2019-10-04', 176, NULL),
('The Paradise Inn', 74, '2019-10-05', 181, NULL),
('The Paradise Inn', 74, '2019-10-06', 382, NULL),
('The Paradise Inn', 74, '2019-10-07', 321, NULL),
('The Paradise Inn', 74, '2019-10-08', 347, NULL),
('The Paradise Inn', 74, '2019-10-09', 225, NULL),
('The Paradise Inn', 74, '2019-10-10', 386, NULL),
('The Paradise Inn', 74, '2019-10-11', 174, NULL),
('The Paradise Inn', 74, '2019-10-12', 308, NULL),
('The Paradise Inn', 74, '2019-10-13', 369, NULL),
('The Paradise Inn', 74, '2019-10-14', 149, NULL),
('The Paradise Inn', 74, '2019-10-15', 311, NULL),
('The Paradise Inn', 74, '2019-10-16', 168, NULL),
('The Paradise Inn', 74, '2019-10-17', 354, NULL),
('The Paradise Inn', 74, '2019-10-18', 258, NULL),
('The Paradise Inn', 74, '2019-10-19', 195, NULL),
('The Paradise Inn', 74, '2019-10-20', 108, NULL),
('The Paradise Inn', 74, '2019-10-21', 185, NULL),
('The Paradise Inn', 74, '2019-10-22', 342, NULL),
('The Paradise Inn', 74, '2019-10-23', 180, NULL),
('The Paradise Inn', 74, '2019-10-24', 215, NULL),
('The Paradise Inn', 74, '2019-10-25', 167, NULL),
('The Paradise Inn', 74, '2019-10-26', 300, NULL),
('The Paradise Inn', 74, '2019-10-27', 179, NULL),
('The Paradise Inn', 74, '2019-10-28', 217, NULL),
('The Paradise Inn', 74, '2019-10-29', 180, NULL),
('The Paradise Inn', 74, '2019-10-30', 223, NULL),
('The Paradise Inn', 74, '2019-10-31', 234, NULL),
('The Paradise Inn', 74, '2019-11-01', 117, NULL),
('The Paradise Inn', 74, '2019-11-02', 264, NULL),
('The Paradise Inn', 74, '2019-11-03', 345, NULL),
('The Paradise Inn', 74, '2019-11-04', 107, NULL),
('The Paradise Inn', 74, '2019-11-05', 308, NULL),
('The Paradise Inn', 74, '2019-11-06', 111, NULL),
('The Paradise Inn', 74, '2019-11-07', 281, NULL),
('The Paradise Inn', 74, '2019-11-08', 183, NULL),
('The Paradise Inn', 74, '2019-11-09', 153, NULL),
('The Paradise Inn', 74, '2019-11-10', 244, NULL),
('The Paradise Inn', 74, '2019-11-11', 391, NULL),
('The Paradise Inn', 74, '2019-11-12', 324, NULL),
('The Paradise Inn', 74, '2019-11-13', 259, NULL),
('The Paradise Inn', 74, '2019-11-14', 119, NULL),
('The Paradise Inn', 74, '2019-11-15', 349, NULL),
('The Paradise Inn', 74, '2019-11-16', 352, NULL),
('The Paradise Inn', 74, '2019-11-17', 137, NULL),
('The Paradise Inn', 74, '2019-11-18', 269, NULL),
('The Paradise Inn', 74, '2019-11-19', 170, NULL),
('The Paradise Inn', 74, '2019-11-20', 102, NULL),
('The Paradise Inn', 74, '2019-11-21', 284, NULL),
('The Paradise Inn', 74, '2019-11-22', 312, NULL),
('The Paradise Inn', 74, '2019-11-23', 368, NULL),
('The Paradise Inn', 74, '2019-11-24', 184, NULL),
('The Paradise Inn', 74, '2019-11-25', 106, NULL),
('The Paradise Inn', 74, '2019-11-26', 346, NULL),
('The Paradise Inn', 74, '2019-11-27', 287, NULL),
('The Paradise Inn', 74, '2019-11-28', 306, NULL),
('The Paradise Inn', 74, '2019-11-29', 105, NULL),
('The Paradise Inn', 74, '2019-11-30', 145, NULL),
('The Paradise Inn', 74, '2019-12-01', 330, NULL),
('The Paradise Inn', 74, '2019-12-02', 298, NULL),
('The Paradise Inn', 74, '2019-12-03', 190, NULL),
('The Paradise Inn', 74, '2019-12-04', 131, NULL),
('The Paradise Inn', 74, '2019-12-05', 341, NULL),
('The Paradise Inn', 74, '2019-12-06', 281, NULL),
('The Paradise Inn', 74, '2019-12-07', 397, NULL),
('The Paradise Inn', 74, '2019-12-08', 118, NULL),
('The Paradise Inn', 74, '2019-12-09', 270, NULL),
('The Paradise Inn', 74, '2019-12-10', 115, NULL),
('The Paradise Inn', 74, '2019-12-11', 131, NULL),
('The Paradise Inn', 74, '2019-12-12', 211, NULL),
('The Paradise Inn', 74, '2019-12-13', 146, NULL),
('The Paradise Inn', 74, '2019-12-14', 395, NULL),
('The Paradise Inn', 74, '2019-12-15', 309, NULL),
('The Paradise Inn', 74, '2019-12-16', 152, NULL),
('The Paradise Inn', 74, '2019-12-17', 279, NULL),
('The Paradise Inn', 74, '2019-12-18', 230, NULL),
('The Paradise Inn', 74, '2019-12-19', 104, NULL),
('The Paradise Inn', 74, '2019-12-20', 348, NULL),
('The Paradise Inn', 74, '2019-12-21', 365, NULL),
('The Paradise Inn', 74, '2019-12-22', 197, NULL),
('The Paradise Inn', 74, '2019-12-23', 341, NULL),
('The Paradise Inn', 74, '2019-12-24', 176, NULL),
('The Paradise Inn', 74, '2019-12-25', 146, NULL),
('The Paradise Inn', 74, '2019-12-26', 109, NULL),
('The Paradise Inn', 74, '2019-12-27', 103, NULL),
('The Paradise Inn', 74, '2019-12-28', 192, NULL),
('The Paradise Inn', 74, '2019-12-29', 160, NULL),
('The Paradise Inn', 74, '2019-12-30', 354, NULL),
('The Paradise Inn', 74, '2019-12-31', 226, NULL),
('The Paradise Inn', 74, '2020-01-01', 354, NULL),
('The Paradise Inn', 74, '2020-01-02', 152, NULL),
('The Paradise Inn', 74, '2020-01-03', 187, NULL),
('The Paradise Inn', 74, '2020-01-04', 141, NULL),
('The Paradise Inn', 74, '2020-01-05', 292, NULL),
('The Paradise Inn', 74, '2020-01-06', 278, NULL),
('The Paradise Inn', 74, '2020-01-07', 134, NULL),
('The Paradise Inn', 74, '2020-01-08', 329, NULL),
('The Paradise Inn', 74, '2020-01-09', 343, NULL),
('The Paradise Inn', 74, '2020-01-10', 314, NULL),
('The Paradise Inn', 74, '2020-01-11', 276, NULL),
('The Paradise Inn', 74, '2020-01-12', 191, NULL),
('The Paradise Inn', 74, '2020-01-13', 362, NULL),
('The Paradise Inn', 74, '2020-01-14', 241, NULL),
('The Paradise Inn', 74, '2020-01-15', 330, NULL),
('The Paradise Inn', 74, '2020-01-16', 201, NULL),
('The Paradise Inn', 74, '2020-01-17', 187, NULL),
('The Paradise Inn', 74, '2020-01-18', 315, NULL),
('The Paradise Inn', 74, '2020-01-19', 317, NULL),
('The Paradise Inn', 74, '2020-01-20', 227, NULL),
('The Paradise Inn', 74, '2020-01-21', 226, NULL),
('The Paradise Inn', 74, '2020-01-22', 203, NULL),
('The Paradise Inn', 74, '2020-01-23', 319, NULL),
('The Paradise Inn', 74, '2020-01-24', 140, NULL),
('The Paradise Inn', 74, '2020-01-25', 300, NULL),
('The Paradise Inn', 74, '2020-01-26', 277, NULL),
('The Paradise Inn', 74, '2020-01-27', 320, NULL),
('The Paradise Inn', 74, '2020-01-28', 360, NULL),
('The Paradise Inn', 74, '2020-01-29', 345, NULL),
('The Paradise Inn', 74, '2020-01-30', 138, NULL),
('The Paradise Inn', 74, '2020-01-31', 286, NULL),
('The Paradise Inn', 74, '2020-02-01', 249, NULL),
('The Paradise Inn', 74, '2020-02-02', 264, NULL),
('The Paradise Inn', 74, '2020-02-03', 135, NULL),
('The Paradise Inn', 74, '2020-02-04', 349, NULL),
('The Paradise Inn', 90, '2019-01-01', 100, NULL),
('The Paradise Inn', 90, '2019-01-02', 184, NULL),
('The Paradise Inn', 90, '2019-01-03', 306, NULL),
('The Paradise Inn', 90, '2019-01-04', 307, NULL),
('The Paradise Inn', 90, '2019-01-05', 142, NULL),
('The Paradise Inn', 90, '2019-01-06', 174, NULL),
('The Paradise Inn', 90, '2019-01-07', 265, NULL),
('The Paradise Inn', 90, '2019-01-08', 362, NULL),
('The Paradise Inn', 90, '2019-01-09', 102, NULL),
('The Paradise Inn', 90, '2019-01-10', 147, NULL),
('The Paradise Inn', 90, '2019-01-11', 291, NULL),
('The Paradise Inn', 90, '2019-01-12', 118, NULL),
('The Paradise Inn', 90, '2019-01-13', 197, NULL),
('The Paradise Inn', 90, '2019-01-14', 345, NULL),
('The Paradise Inn', 90, '2019-01-15', 253, NULL),
('The Paradise Inn', 90, '2019-01-16', 210, NULL),
('The Paradise Inn', 90, '2019-01-17', 219, NULL),
('The Paradise Inn', 90, '2019-01-18', 322, NULL),
('The Paradise Inn', 90, '2019-01-19', 235, NULL),
('The Paradise Inn', 90, '2019-01-20', 247, NULL),
('The Paradise Inn', 90, '2019-01-21', 120, NULL),
('The Paradise Inn', 90, '2019-01-22', 191, NULL),
('The Paradise Inn', 90, '2019-01-23', 138, NULL),
('The Paradise Inn', 90, '2019-01-24', 198, NULL),
('The Paradise Inn', 90, '2019-01-25', 323, NULL),
('The Paradise Inn', 90, '2019-01-26', 319, NULL),
('The Paradise Inn', 90, '2019-01-27', 293, NULL),
('The Paradise Inn', 90, '2019-01-28', 323, NULL),
('The Paradise Inn', 90, '2019-01-29', 326, NULL),
('The Paradise Inn', 90, '2019-01-30', 352, NULL),
('The Paradise Inn', 90, '2019-01-31', 328, NULL),
('The Paradise Inn', 90, '2019-02-01', 219, NULL),
('The Paradise Inn', 90, '2019-02-02', 127, NULL),
('The Paradise Inn', 90, '2019-02-03', 290, NULL),
('The Paradise Inn', 90, '2019-02-04', 131, NULL),
('The Paradise Inn', 90, '2019-02-05', 156, NULL),
('The Paradise Inn', 90, '2019-02-06', 315, NULL),
('The Paradise Inn', 90, '2019-02-07', 227, NULL),
('The Paradise Inn', 90, '2019-02-08', 334, NULL),
('The Paradise Inn', 90, '2019-02-09', 284, NULL),
('The Paradise Inn', 90, '2019-02-10', 234, NULL),
('The Paradise Inn', 90, '2019-02-11', 367, NULL),
('The Paradise Inn', 90, '2019-02-12', 271, NULL),
('The Paradise Inn', 90, '2019-02-13', 314, NULL),
('The Paradise Inn', 90, '2019-02-14', 181, NULL),
('The Paradise Inn', 90, '2019-02-15', 229, NULL),
('The Paradise Inn', 90, '2019-02-16', 293, NULL),
('The Paradise Inn', 90, '2019-02-17', 206, NULL),
('The Paradise Inn', 90, '2019-02-18', 109, NULL),
('The Paradise Inn', 90, '2019-02-19', 191, NULL),
('The Paradise Inn', 90, '2019-02-20', 291, NULL),
('The Paradise Inn', 90, '2019-02-21', 180, NULL),
('The Paradise Inn', 90, '2019-02-22', 229, NULL),
('The Paradise Inn', 90, '2019-02-23', 263, NULL),
('The Paradise Inn', 90, '2019-02-24', 302, NULL),
('The Paradise Inn', 90, '2019-02-25', 284, NULL),
('The Paradise Inn', 90, '2019-02-26', 387, NULL),
('The Paradise Inn', 90, '2019-02-27', 303, NULL),
('The Paradise Inn', 90, '2019-02-28', 180, NULL),
('The Paradise Inn', 90, '2019-03-01', 186, NULL),
('The Paradise Inn', 90, '2019-03-02', 241, NULL),
('The Paradise Inn', 90, '2019-03-03', 213, NULL),
('The Paradise Inn', 90, '2019-03-04', 153, NULL),
('The Paradise Inn', 90, '2019-03-05', 209, NULL),
('The Paradise Inn', 90, '2019-03-06', 259, NULL),
('The Paradise Inn', 90, '2019-03-07', 359, NULL),
('The Paradise Inn', 90, '2019-03-08', 163, NULL),
('The Paradise Inn', 90, '2019-03-09', 317, NULL),
('The Paradise Inn', 90, '2019-03-10', 248, NULL),
('The Paradise Inn', 90, '2019-03-11', 199, NULL),
('The Paradise Inn', 90, '2019-03-12', 238, NULL),
('The Paradise Inn', 90, '2019-03-13', 374, NULL),
('The Paradise Inn', 90, '2019-03-14', 144, NULL),
('The Paradise Inn', 90, '2019-03-15', 308, NULL),
('The Paradise Inn', 90, '2019-03-16', 304, NULL),
('The Paradise Inn', 90, '2019-03-17', 290, NULL),
('The Paradise Inn', 90, '2019-03-18', 386, NULL),
('The Paradise Inn', 90, '2019-03-19', 184, NULL),
('The Paradise Inn', 90, '2019-03-20', 326, NULL),
('The Paradise Inn', 90, '2019-03-21', 168, NULL),
('The Paradise Inn', 90, '2019-03-22', 221, NULL),
('The Paradise Inn', 90, '2019-03-23', 344, NULL),
('The Paradise Inn', 90, '2019-03-24', 340, NULL),
('The Paradise Inn', 90, '2019-03-25', 330, NULL),
('The Paradise Inn', 90, '2019-03-26', 203, NULL),
('The Paradise Inn', 90, '2019-03-27', 292, NULL),
('The Paradise Inn', 90, '2019-03-28', 178, NULL),
('The Paradise Inn', 90, '2019-03-29', 306, NULL),
('The Paradise Inn', 90, '2019-03-30', 148, NULL),
('The Paradise Inn', 90, '2019-03-31', 244, NULL),
('The Paradise Inn', 90, '2019-04-01', 382, NULL),
('The Paradise Inn', 90, '2019-04-02', 148, NULL),
('The Paradise Inn', 90, '2019-04-03', 129, NULL),
('The Paradise Inn', 90, '2019-04-04', 251, NULL),
('The Paradise Inn', 90, '2019-04-05', 376, NULL),
('The Paradise Inn', 90, '2019-04-06', 105, NULL),
('The Paradise Inn', 90, '2019-04-07', 207, NULL),
('The Paradise Inn', 90, '2019-04-08', 314, NULL),
('The Paradise Inn', 90, '2019-04-09', 332, NULL),
('The Paradise Inn', 90, '2019-04-10', 104, NULL),
('The Paradise Inn', 90, '2019-04-11', 152, NULL),
('The Paradise Inn', 90, '2019-04-12', 301, NULL),
('The Paradise Inn', 90, '2019-04-13', 335, NULL),
('The Paradise Inn', 90, '2019-04-14', 234, NULL),
('The Paradise Inn', 90, '2019-04-15', 386, NULL),
('The Paradise Inn', 90, '2019-04-16', 244, NULL),
('The Paradise Inn', 90, '2019-04-17', 141, NULL),
('The Paradise Inn', 90, '2019-04-18', 177, NULL),
('The Paradise Inn', 90, '2019-04-19', 339, NULL),
('The Paradise Inn', 90, '2019-04-20', 307, NULL),
('The Paradise Inn', 90, '2019-04-21', 119, NULL),
('The Paradise Inn', 90, '2019-04-22', 185, NULL),
('The Paradise Inn', 90, '2019-04-23', 262, NULL),
('The Paradise Inn', 90, '2019-04-24', 199, NULL),
('The Paradise Inn', 90, '2019-04-25', 352, NULL),
('The Paradise Inn', 90, '2019-04-26', 209, NULL),
('The Paradise Inn', 90, '2019-04-27', 359, NULL),
('The Paradise Inn', 90, '2019-04-28', 188, NULL),
('The Paradise Inn', 90, '2019-04-29', 359, NULL),
('The Paradise Inn', 90, '2019-04-30', 265, NULL),
('The Paradise Inn', 90, '2019-05-01', 316, NULL),
('The Paradise Inn', 90, '2019-05-02', 140, NULL),
('The Paradise Inn', 90, '2019-05-03', 376, NULL),
('The Paradise Inn', 90, '2019-05-04', 156, NULL),
('The Paradise Inn', 90, '2019-05-05', 118, NULL),
('The Paradise Inn', 90, '2019-05-06', 297, NULL),
('The Paradise Inn', 90, '2019-05-07', 127, NULL),
('The Paradise Inn', 90, '2019-05-08', 327, NULL),
('The Paradise Inn', 90, '2019-05-09', 266, NULL),
('The Paradise Inn', 90, '2019-05-10', 309, NULL),
('The Paradise Inn', 90, '2019-05-11', 222, NULL),
('The Paradise Inn', 90, '2019-05-12', 147, NULL),
('The Paradise Inn', 90, '2019-05-13', 320, NULL),
('The Paradise Inn', 90, '2019-05-14', 322, NULL),
('The Paradise Inn', 90, '2019-05-15', 330, NULL),
('The Paradise Inn', 90, '2019-05-16', 164, NULL),
('The Paradise Inn', 90, '2019-05-17', 344, NULL),
('The Paradise Inn', 90, '2019-05-18', 159, NULL),
('The Paradise Inn', 90, '2019-05-19', 366, NULL),
('The Paradise Inn', 90, '2019-05-20', 110, NULL),
('The Paradise Inn', 90, '2019-05-21', 149, NULL),
('The Paradise Inn', 90, '2019-05-22', 352, NULL),
('The Paradise Inn', 90, '2019-05-23', 272, NULL),
('The Paradise Inn', 90, '2019-05-24', 191, NULL),
('The Paradise Inn', 90, '2019-05-25', 353, NULL),
('The Paradise Inn', 90, '2019-05-26', 311, NULL),
('The Paradise Inn', 90, '2019-05-27', 201, NULL),
('The Paradise Inn', 90, '2019-05-28', 223, NULL),
('The Paradise Inn', 90, '2019-05-29', 244, NULL),
('The Paradise Inn', 90, '2019-05-30', 107, NULL),
('The Paradise Inn', 90, '2019-05-31', 178, NULL),
('The Paradise Inn', 90, '2019-06-01', 271, NULL),
('The Paradise Inn', 90, '2019-06-02', 148, NULL),
('The Paradise Inn', 90, '2019-06-03', 257, NULL),
('The Paradise Inn', 90, '2019-06-04', 366, NULL),
('The Paradise Inn', 90, '2019-06-05', 110, NULL),
('The Paradise Inn', 90, '2019-06-06', 197, NULL),
('The Paradise Inn', 90, '2019-06-07', 112, NULL),
('The Paradise Inn', 90, '2019-06-08', 214, NULL),
('The Paradise Inn', 90, '2019-06-09', 277, NULL),
('The Paradise Inn', 90, '2019-06-10', 392, NULL),
('The Paradise Inn', 90, '2019-06-11', 395, NULL),
('The Paradise Inn', 90, '2019-06-12', 253, NULL),
('The Paradise Inn', 90, '2019-06-13', 160, NULL),
('The Paradise Inn', 90, '2019-06-14', 180, NULL),
('The Paradise Inn', 90, '2019-06-15', 317, NULL),
('The Paradise Inn', 90, '2019-06-16', 189, NULL),
('The Paradise Inn', 90, '2019-06-17', 363, NULL),
('The Paradise Inn', 90, '2019-06-18', 376, NULL),
('The Paradise Inn', 90, '2019-06-19', 388, NULL),
('The Paradise Inn', 90, '2019-06-20', 280, NULL),
('The Paradise Inn', 90, '2019-06-21', 370, NULL),
('The Paradise Inn', 90, '2019-06-22', 178, NULL),
('The Paradise Inn', 90, '2019-06-23', 218, NULL),
('The Paradise Inn', 90, '2019-06-24', 233, NULL),
('The Paradise Inn', 90, '2019-06-25', 285, NULL),
('The Paradise Inn', 90, '2019-06-26', 173, NULL),
('The Paradise Inn', 90, '2019-06-27', 118, NULL),
('The Paradise Inn', 90, '2019-06-28', 378, NULL),
('The Paradise Inn', 90, '2019-06-29', 384, NULL),
('The Paradise Inn', 90, '2019-06-30', 305, NULL),
('The Paradise Inn', 90, '2019-07-01', 164, NULL),
('The Paradise Inn', 90, '2019-07-02', 309, NULL),
('The Paradise Inn', 90, '2019-07-03', 113, NULL),
('The Paradise Inn', 90, '2019-07-04', 358, NULL),
('The Paradise Inn', 90, '2019-07-05', 375, NULL),
('The Paradise Inn', 90, '2019-07-06', 146, NULL),
('The Paradise Inn', 90, '2019-07-07', 270, NULL),
('The Paradise Inn', 90, '2019-07-08', 169, NULL),
('The Paradise Inn', 90, '2019-07-09', 343, NULL),
('The Paradise Inn', 90, '2019-07-10', 277, NULL),
('The Paradise Inn', 90, '2019-07-11', 189, NULL),
('The Paradise Inn', 90, '2019-07-12', 174, NULL),
('The Paradise Inn', 90, '2019-07-13', 240, NULL),
('The Paradise Inn', 90, '2019-07-14', 259, NULL),
('The Paradise Inn', 90, '2019-07-15', 312, NULL),
('The Paradise Inn', 90, '2019-07-16', 269, NULL),
('The Paradise Inn', 90, '2019-07-17', 238, NULL),
('The Paradise Inn', 90, '2019-07-18', 336, NULL),
('The Paradise Inn', 90, '2019-07-19', 126, NULL),
('The Paradise Inn', 90, '2019-07-20', 308, NULL),
('The Paradise Inn', 90, '2019-07-21', 312, NULL),
('The Paradise Inn', 90, '2019-07-22', 136, NULL),
('The Paradise Inn', 90, '2019-07-23', 245, NULL),
('The Paradise Inn', 90, '2019-07-24', 264, NULL),
('The Paradise Inn', 90, '2019-07-25', 266, NULL),
('The Paradise Inn', 90, '2019-07-26', 218, NULL),
('The Paradise Inn', 90, '2019-07-27', 217, NULL),
('The Paradise Inn', 90, '2019-07-28', 396, NULL),
('The Paradise Inn', 90, '2019-07-29', 241, NULL),
('The Paradise Inn', 90, '2019-07-30', 210, NULL),
('The Paradise Inn', 90, '2019-07-31', 170, NULL),
('The Paradise Inn', 90, '2019-08-01', 197, NULL),
('The Paradise Inn', 90, '2019-08-02', 301, NULL),
('The Paradise Inn', 90, '2019-08-03', 221, NULL),
('The Paradise Inn', 90, '2019-08-04', 132, NULL),
('The Paradise Inn', 90, '2019-08-05', 119, NULL),
('The Paradise Inn', 90, '2019-08-06', 306, NULL),
('The Paradise Inn', 90, '2019-08-07', 136, NULL),
('The Paradise Inn', 90, '2019-08-08', 123, NULL),
('The Paradise Inn', 90, '2019-08-09', 370, NULL),
('The Paradise Inn', 90, '2019-08-10', 277, NULL),
('The Paradise Inn', 90, '2019-08-11', 218, NULL),
('The Paradise Inn', 90, '2019-08-12', 379, NULL),
('The Paradise Inn', 90, '2019-08-13', 236, NULL),
('The Paradise Inn', 90, '2019-08-14', 238, NULL),
('The Paradise Inn', 90, '2019-08-15', 146, NULL),
('The Paradise Inn', 90, '2019-08-16', 280, NULL),
('The Paradise Inn', 90, '2019-08-17', 273, NULL),
('The Paradise Inn', 90, '2019-08-18', 247, NULL),
('The Paradise Inn', 90, '2019-08-19', 327, NULL),
('The Paradise Inn', 90, '2019-08-20', 325, NULL),
('The Paradise Inn', 90, '2019-08-21', 264, NULL),
('The Paradise Inn', 90, '2019-08-22', 355, NULL),
('The Paradise Inn', 90, '2019-08-23', 176, NULL),
('The Paradise Inn', 90, '2019-08-24', 160, NULL),
('The Paradise Inn', 90, '2019-08-25', 319, NULL),
('The Paradise Inn', 90, '2019-08-26', 204, NULL),
('The Paradise Inn', 90, '2019-08-27', 185, NULL),
('The Paradise Inn', 90, '2019-08-28', 244, NULL),
('The Paradise Inn', 90, '2019-08-29', 373, NULL),
('The Paradise Inn', 90, '2019-08-30', 187, NULL),
('The Paradise Inn', 90, '2019-08-31', 192, NULL),
('The Paradise Inn', 90, '2019-09-01', 134, NULL),
('The Paradise Inn', 90, '2019-09-02', 204, NULL),
('The Paradise Inn', 90, '2019-09-03', 161, NULL),
('The Paradise Inn', 90, '2019-09-04', 138, NULL),
('The Paradise Inn', 90, '2019-09-05', 282, NULL),
('The Paradise Inn', 90, '2019-09-06', 322, NULL),
('The Paradise Inn', 90, '2019-09-07', 257, NULL),
('The Paradise Inn', 90, '2019-09-08', 291, NULL),
('The Paradise Inn', 90, '2019-09-09', 353, NULL),
('The Paradise Inn', 90, '2019-09-10', 204, NULL),
('The Paradise Inn', 90, '2019-09-11', 154, NULL),
('The Paradise Inn', 90, '2019-09-12', 367, NULL),
('The Paradise Inn', 90, '2019-09-13', 271, NULL),
('The Paradise Inn', 90, '2019-09-14', 104, NULL),
('The Paradise Inn', 90, '2019-09-15', 121, NULL),
('The Paradise Inn', 90, '2019-09-16', 108, NULL),
('The Paradise Inn', 90, '2019-09-17', 359, NULL),
('The Paradise Inn', 90, '2019-09-18', 147, NULL),
('The Paradise Inn', 90, '2019-09-19', 396, NULL),
('The Paradise Inn', 90, '2019-09-20', 273, NULL),
('The Paradise Inn', 90, '2019-09-21', 398, NULL),
('The Paradise Inn', 90, '2019-09-22', 249, NULL),
('The Paradise Inn', 90, '2019-09-23', 388, NULL),
('The Paradise Inn', 90, '2019-09-24', 293, NULL),
('The Paradise Inn', 90, '2019-09-25', 291, NULL),
('The Paradise Inn', 90, '2019-09-26', 203, NULL),
('The Paradise Inn', 90, '2019-09-27', 155, NULL),
('The Paradise Inn', 90, '2019-09-28', 161, NULL),
('The Paradise Inn', 90, '2019-09-29', 394, NULL),
('The Paradise Inn', 90, '2019-09-30', 294, NULL),
('The Paradise Inn', 90, '2019-10-01', 184, NULL),
('The Paradise Inn', 90, '2019-10-02', 325, NULL),
('The Paradise Inn', 90, '2019-10-03', 297, NULL),
('The Paradise Inn', 90, '2019-10-04', 126, NULL),
('The Paradise Inn', 90, '2019-10-05', 129, NULL),
('The Paradise Inn', 90, '2019-10-06', 176, NULL),
('The Paradise Inn', 90, '2019-10-07', 291, NULL),
('The Paradise Inn', 90, '2019-10-08', 331, NULL),
('The Paradise Inn', 90, '2019-10-09', 138, NULL),
('The Paradise Inn', 90, '2019-10-10', 318, NULL),
('The Paradise Inn', 90, '2019-10-11', 243, NULL),
('The Paradise Inn', 90, '2019-10-12', 182, NULL),
('The Paradise Inn', 90, '2019-10-13', 297, NULL),
('The Paradise Inn', 90, '2019-10-14', 154, NULL),
('The Paradise Inn', 90, '2019-10-15', 378, NULL),
('The Paradise Inn', 90, '2019-10-16', 239, NULL),
('The Paradise Inn', 90, '2019-10-17', 116, NULL),
('The Paradise Inn', 90, '2019-10-18', 102, NULL),
('The Paradise Inn', 90, '2019-10-19', 254, NULL),
('The Paradise Inn', 90, '2019-10-20', 129, NULL),
('The Paradise Inn', 90, '2019-10-21', 333, NULL),
('The Paradise Inn', 90, '2019-10-22', 127, NULL),
('The Paradise Inn', 90, '2019-10-23', 347, NULL),
('The Paradise Inn', 90, '2019-10-24', 217, NULL),
('The Paradise Inn', 90, '2019-10-25', 128, NULL),
('The Paradise Inn', 90, '2019-10-26', 395, NULL),
('The Paradise Inn', 90, '2019-10-27', 271, NULL),
('The Paradise Inn', 90, '2019-10-28', 316, NULL),
('The Paradise Inn', 90, '2019-10-29', 225, NULL),
('The Paradise Inn', 90, '2019-10-30', 216, NULL),
('The Paradise Inn', 90, '2019-10-31', 113, NULL),
('The Paradise Inn', 90, '2019-11-01', 244, NULL),
('The Paradise Inn', 90, '2019-11-02', 252, NULL),
('The Paradise Inn', 90, '2019-11-03', 137, NULL),
('The Paradise Inn', 90, '2019-11-04', 317, NULL),
('The Paradise Inn', 90, '2019-11-05', 180, NULL),
('The Paradise Inn', 90, '2019-11-06', 176, NULL),
('The Paradise Inn', 90, '2019-11-07', 265, NULL),
('The Paradise Inn', 90, '2019-11-08', 131, NULL),
('The Paradise Inn', 90, '2019-11-09', 334, NULL),
('The Paradise Inn', 90, '2019-11-10', 309, NULL),
('The Paradise Inn', 90, '2019-11-11', 244, NULL),
('The Paradise Inn', 90, '2019-11-12', 392, NULL),
('The Paradise Inn', 90, '2019-11-13', 357, NULL),
('The Paradise Inn', 90, '2019-11-14', 364, NULL),
('The Paradise Inn', 90, '2019-11-15', 284, NULL),
('The Paradise Inn', 90, '2019-11-16', 308, NULL),
('The Paradise Inn', 90, '2019-11-17', 378, NULL),
('The Paradise Inn', 90, '2019-11-18', 171, NULL),
('The Paradise Inn', 90, '2019-11-19', 147, NULL),
('The Paradise Inn', 90, '2019-11-20', 152, NULL),
('The Paradise Inn', 90, '2019-11-21', 121, NULL),
('The Paradise Inn', 90, '2019-11-22', 229, NULL),
('The Paradise Inn', 90, '2019-11-23', 253, NULL),
('The Paradise Inn', 90, '2019-11-24', 355, NULL),
('The Paradise Inn', 90, '2019-11-25', 349, NULL),
('The Paradise Inn', 90, '2019-11-26', 338, NULL),
('The Paradise Inn', 90, '2019-11-27', 326, NULL),
('The Paradise Inn', 90, '2019-11-28', 351, NULL),
('The Paradise Inn', 90, '2019-11-29', 179, NULL),
('The Paradise Inn', 90, '2019-11-30', 388, NULL),
('The Paradise Inn', 90, '2019-12-01', 318, NULL),
('The Paradise Inn', 90, '2019-12-02', 253, NULL),
('The Paradise Inn', 90, '2019-12-03', 287, NULL),
('The Paradise Inn', 90, '2019-12-04', 147, NULL),
('The Paradise Inn', 90, '2019-12-05', 203, NULL),
('The Paradise Inn', 90, '2019-12-06', 276, NULL),
('The Paradise Inn', 90, '2019-12-07', 142, NULL),
('The Paradise Inn', 90, '2019-12-08', 151, NULL),
('The Paradise Inn', 90, '2019-12-09', 210, NULL),
('The Paradise Inn', 90, '2019-12-10', 178, NULL),
('The Paradise Inn', 90, '2019-12-11', 338, NULL),
('The Paradise Inn', 90, '2019-12-12', 285, NULL),
('The Paradise Inn', 90, '2019-12-13', 291, NULL),
('The Paradise Inn', 90, '2019-12-14', 202, NULL),
('The Paradise Inn', 90, '2019-12-15', 200, NULL),
('The Paradise Inn', 90, '2019-12-16', 304, NULL),
('The Paradise Inn', 90, '2019-12-17', 386, NULL),
('The Paradise Inn', 90, '2019-12-18', 392, NULL),
('The Paradise Inn', 90, '2019-12-19', 253, NULL),
('The Paradise Inn', 90, '2019-12-20', 252, NULL),
('The Paradise Inn', 90, '2019-12-21', 385, NULL),
('The Paradise Inn', 90, '2019-12-22', 203, NULL),
('The Paradise Inn', 90, '2019-12-23', 129, NULL),
('The Paradise Inn', 90, '2019-12-24', 283, NULL),
('The Paradise Inn', 90, '2019-12-25', 102, NULL),
('The Paradise Inn', 90, '2019-12-26', 383, NULL),
('The Paradise Inn', 90, '2019-12-27', 340, NULL),
('The Paradise Inn', 90, '2019-12-28', 267, NULL),
('The Paradise Inn', 90, '2019-12-29', 320, NULL),
('The Paradise Inn', 90, '2019-12-30', 226, NULL),
('The Paradise Inn', 90, '2019-12-31', 122, NULL),
('The Paradise Inn', 90, '2020-01-01', 299, NULL),
('The Paradise Inn', 90, '2020-01-02', 397, NULL),
('The Paradise Inn', 90, '2020-01-03', 324, NULL),
('The Paradise Inn', 90, '2020-01-04', 293, NULL),
('The Paradise Inn', 90, '2020-01-05', 137, NULL),
('The Paradise Inn', 90, '2020-01-06', 314, NULL),
('The Paradise Inn', 90, '2020-01-07', 251, NULL),
('The Paradise Inn', 90, '2020-01-08', 140, NULL),
('The Paradise Inn', 90, '2020-01-09', 387, NULL),
('The Paradise Inn', 90, '2020-01-10', 201, NULL),
('The Paradise Inn', 90, '2020-01-11', 292, NULL),
('The Paradise Inn', 90, '2020-01-12', 348, NULL),
('The Paradise Inn', 90, '2020-01-13', 217, NULL),
('The Paradise Inn', 90, '2020-01-14', 137, NULL),
('The Paradise Inn', 90, '2020-01-15', 292, NULL),
('The Paradise Inn', 90, '2020-01-16', 102, NULL),
('The Paradise Inn', 90, '2020-01-17', 134, NULL),
('The Paradise Inn', 90, '2020-01-18', 225, NULL),
('The Paradise Inn', 90, '2020-01-19', 256, NULL),
('The Paradise Inn', 90, '2020-01-20', 342, NULL),
('The Paradise Inn', 90, '2020-01-21', 191, NULL),
('The Paradise Inn', 90, '2020-01-22', 252, NULL),
('The Paradise Inn', 90, '2020-01-23', 166, NULL),
('The Paradise Inn', 90, '2020-01-24', 273, NULL),
('The Paradise Inn', 90, '2020-01-25', 166, NULL),
('The Paradise Inn', 90, '2020-01-26', 341, NULL),
('The Paradise Inn', 90, '2020-01-27', 189, NULL),
('The Paradise Inn', 90, '2020-01-28', 314, NULL),
('The Paradise Inn', 90, '2020-01-29', 244, NULL),
('The Paradise Inn', 90, '2020-01-30', 384, NULL),
('The Paradise Inn', 90, '2020-01-31', 378, NULL),
('The Paradise Inn', 90, '2020-02-01', 124, NULL),
('The Paradise Inn', 90, '2020-02-02', 139, NULL),
('The Paradise Inn', 90, '2020-02-03', 154, NULL),
('The Paradise Inn', 90, '2020-02-04', 233, NULL),
('The Paradise Inn', 112, '2019-01-01', 237, NULL),
('The Paradise Inn', 112, '2019-01-02', 320, NULL),
('The Paradise Inn', 112, '2019-01-03', 337, NULL),
('The Paradise Inn', 112, '2019-01-04', 370, NULL),
('The Paradise Inn', 112, '2019-01-05', 210, NULL),
('The Paradise Inn', 112, '2019-01-06', 324, NULL),
('The Paradise Inn', 112, '2019-01-07', 230, NULL),
('The Paradise Inn', 112, '2019-01-08', 109, NULL),
('The Paradise Inn', 112, '2019-01-09', 159, NULL),
('The Paradise Inn', 112, '2019-01-10', 280, NULL),
('The Paradise Inn', 112, '2019-01-11', 310, NULL),
('The Paradise Inn', 112, '2019-01-12', 310, NULL),
('The Paradise Inn', 112, '2019-01-13', 341, NULL),
('The Paradise Inn', 112, '2019-01-14', 258, NULL),
('The Paradise Inn', 112, '2019-01-15', 360, NULL),
('The Paradise Inn', 112, '2019-01-16', 283, NULL),
('The Paradise Inn', 112, '2019-01-17', 121, NULL),
('The Paradise Inn', 112, '2019-01-18', 257, NULL),
('The Paradise Inn', 112, '2019-01-19', 145, NULL),
('The Paradise Inn', 112, '2019-01-20', 231, NULL),
('The Paradise Inn', 112, '2019-01-21', 357, NULL),
('The Paradise Inn', 112, '2019-01-22', 325, NULL),
('The Paradise Inn', 112, '2019-01-23', 348, NULL),
('The Paradise Inn', 112, '2019-01-24', 298, NULL),
('The Paradise Inn', 112, '2019-01-25', 215, NULL),
('The Paradise Inn', 112, '2019-01-26', 349, NULL),
('The Paradise Inn', 112, '2019-01-27', 175, NULL),
('The Paradise Inn', 112, '2019-01-28', 394, NULL),
('The Paradise Inn', 112, '2019-01-29', 315, NULL),
('The Paradise Inn', 112, '2019-01-30', 252, NULL),
('The Paradise Inn', 112, '2019-01-31', 244, NULL),
('The Paradise Inn', 112, '2019-02-01', 364, NULL),
('The Paradise Inn', 112, '2019-02-02', 291, NULL),
('The Paradise Inn', 112, '2019-02-03', 157, NULL),
('The Paradise Inn', 112, '2019-02-04', 188, NULL),
('The Paradise Inn', 112, '2019-02-05', 237, NULL),
('The Paradise Inn', 112, '2019-02-06', 103, NULL),
('The Paradise Inn', 112, '2019-02-07', 355, NULL),
('The Paradise Inn', 112, '2019-02-08', 203, NULL),
('The Paradise Inn', 112, '2019-02-09', 322, NULL),
('The Paradise Inn', 112, '2019-02-10', 167, NULL),
('The Paradise Inn', 112, '2019-02-11', 313, NULL),
('The Paradise Inn', 112, '2019-02-12', 397, NULL),
('The Paradise Inn', 112, '2019-02-13', 214, NULL),
('The Paradise Inn', 112, '2019-02-14', 289, NULL),
('The Paradise Inn', 112, '2019-02-15', 298, NULL),
('The Paradise Inn', 112, '2019-02-16', 377, NULL),
('The Paradise Inn', 112, '2019-02-17', 275, NULL),
('The Paradise Inn', 112, '2019-02-18', 218, NULL),
('The Paradise Inn', 112, '2019-02-19', 120, NULL),
('The Paradise Inn', 112, '2019-02-20', 185, NULL),
('The Paradise Inn', 112, '2019-02-21', 178, NULL),
('The Paradise Inn', 112, '2019-02-22', 366, NULL),
('The Paradise Inn', 112, '2019-02-23', 307, NULL),
('The Paradise Inn', 112, '2019-02-24', 311, NULL),
('The Paradise Inn', 112, '2019-02-25', 241, NULL),
('The Paradise Inn', 112, '2019-02-26', 149, NULL),
('The Paradise Inn', 112, '2019-02-27', 296, NULL),
('The Paradise Inn', 112, '2019-02-28', 225, NULL),
('The Paradise Inn', 112, '2019-03-01', 195, NULL),
('The Paradise Inn', 112, '2019-03-02', 364, NULL),
('The Paradise Inn', 112, '2019-03-03', 131, NULL),
('The Paradise Inn', 112, '2019-03-04', 199, NULL),
('The Paradise Inn', 112, '2019-03-05', 273, NULL),
('The Paradise Inn', 112, '2019-03-06', 382, NULL),
('The Paradise Inn', 112, '2019-03-07', 140, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 112, '2019-03-08', 337, NULL),
('The Paradise Inn', 112, '2019-03-09', 387, NULL),
('The Paradise Inn', 112, '2019-03-10', 369, NULL),
('The Paradise Inn', 112, '2019-03-11', 159, NULL),
('The Paradise Inn', 112, '2019-03-12', 369, NULL),
('The Paradise Inn', 112, '2019-03-13', 187, NULL),
('The Paradise Inn', 112, '2019-03-14', 182, NULL),
('The Paradise Inn', 112, '2019-03-15', 316, NULL),
('The Paradise Inn', 112, '2019-03-16', 221, NULL),
('The Paradise Inn', 112, '2019-03-17', 259, NULL),
('The Paradise Inn', 112, '2019-03-18', 374, NULL),
('The Paradise Inn', 112, '2019-03-19', 156, NULL),
('The Paradise Inn', 112, '2019-03-20', 282, NULL),
('The Paradise Inn', 112, '2019-03-21', 327, NULL),
('The Paradise Inn', 112, '2019-03-22', 238, NULL),
('The Paradise Inn', 112, '2019-03-23', 308, NULL),
('The Paradise Inn', 112, '2019-03-24', 128, NULL),
('The Paradise Inn', 112, '2019-03-25', 142, NULL),
('The Paradise Inn', 112, '2019-03-26', 399, NULL),
('The Paradise Inn', 112, '2019-03-27', 183, NULL),
('The Paradise Inn', 112, '2019-03-28', 392, NULL),
('The Paradise Inn', 112, '2019-03-29', 235, NULL),
('The Paradise Inn', 112, '2019-03-30', 146, NULL),
('The Paradise Inn', 112, '2019-03-31', 388, NULL),
('The Paradise Inn', 112, '2019-04-01', 228, NULL),
('The Paradise Inn', 112, '2019-04-02', 391, NULL),
('The Paradise Inn', 112, '2019-04-03', 266, NULL),
('The Paradise Inn', 112, '2019-04-04', 139, NULL),
('The Paradise Inn', 112, '2019-04-05', 290, NULL),
('The Paradise Inn', 112, '2019-04-06', 238, NULL),
('The Paradise Inn', 112, '2019-04-07', 318, NULL),
('The Paradise Inn', 112, '2019-04-08', 347, NULL),
('The Paradise Inn', 112, '2019-04-09', 162, NULL),
('The Paradise Inn', 112, '2019-04-10', 252, NULL),
('The Paradise Inn', 112, '2019-04-11', 210, NULL),
('The Paradise Inn', 112, '2019-04-12', 237, NULL),
('The Paradise Inn', 112, '2019-04-13', 253, NULL),
('The Paradise Inn', 112, '2019-04-14', 227, NULL),
('The Paradise Inn', 112, '2019-04-15', 255, NULL),
('The Paradise Inn', 112, '2019-04-16', 103, NULL),
('The Paradise Inn', 112, '2019-04-17', 309, NULL),
('The Paradise Inn', 112, '2019-04-18', 317, NULL),
('The Paradise Inn', 112, '2019-04-19', 311, NULL),
('The Paradise Inn', 112, '2019-04-20', 327, NULL),
('The Paradise Inn', 112, '2019-04-21', 129, NULL),
('The Paradise Inn', 112, '2019-04-22', 161, NULL),
('The Paradise Inn', 112, '2019-04-23', 231, NULL),
('The Paradise Inn', 112, '2019-04-24', 240, NULL),
('The Paradise Inn', 112, '2019-04-25', 225, NULL),
('The Paradise Inn', 112, '2019-04-26', 113, NULL),
('The Paradise Inn', 112, '2019-04-27', 114, NULL),
('The Paradise Inn', 112, '2019-04-28', 392, NULL),
('The Paradise Inn', 112, '2019-04-29', 207, NULL),
('The Paradise Inn', 112, '2019-04-30', 300, NULL),
('The Paradise Inn', 112, '2019-05-01', 344, NULL),
('The Paradise Inn', 112, '2019-05-02', 104, NULL),
('The Paradise Inn', 112, '2019-05-03', 180, NULL),
('The Paradise Inn', 112, '2019-05-04', 352, NULL),
('The Paradise Inn', 112, '2019-05-05', 363, NULL),
('The Paradise Inn', 112, '2019-05-06', 297, NULL),
('The Paradise Inn', 112, '2019-05-07', 169, NULL),
('The Paradise Inn', 112, '2019-05-08', 196, NULL),
('The Paradise Inn', 112, '2019-05-09', 252, NULL),
('The Paradise Inn', 112, '2019-05-10', 173, NULL),
('The Paradise Inn', 112, '2019-05-11', 168, NULL),
('The Paradise Inn', 112, '2019-05-12', 177, NULL),
('The Paradise Inn', 112, '2019-05-13', 205, NULL),
('The Paradise Inn', 112, '2019-05-14', 271, NULL),
('The Paradise Inn', 112, '2019-05-15', 379, NULL),
('The Paradise Inn', 112, '2019-05-16', 127, NULL),
('The Paradise Inn', 112, '2019-05-17', 193, NULL),
('The Paradise Inn', 112, '2019-05-18', 298, NULL),
('The Paradise Inn', 112, '2019-05-19', 233, NULL),
('The Paradise Inn', 112, '2019-05-20', 326, NULL),
('The Paradise Inn', 112, '2019-05-21', 338, NULL),
('The Paradise Inn', 112, '2019-05-22', 249, NULL),
('The Paradise Inn', 112, '2019-05-23', 268, NULL),
('The Paradise Inn', 112, '2019-05-24', 295, NULL),
('The Paradise Inn', 112, '2019-05-25', 361, NULL),
('The Paradise Inn', 112, '2019-05-26', 302, NULL),
('The Paradise Inn', 112, '2019-05-27', 260, NULL),
('The Paradise Inn', 112, '2019-05-28', 244, NULL),
('The Paradise Inn', 112, '2019-05-29', 153, NULL),
('The Paradise Inn', 112, '2019-05-30', 258, NULL),
('The Paradise Inn', 112, '2019-05-31', 375, NULL),
('The Paradise Inn', 112, '2019-06-01', 151, NULL),
('The Paradise Inn', 112, '2019-06-02', 227, NULL),
('The Paradise Inn', 112, '2019-06-03', 102, NULL),
('The Paradise Inn', 112, '2019-06-04', 264, NULL),
('The Paradise Inn', 112, '2019-06-05', 237, NULL),
('The Paradise Inn', 112, '2019-06-06', 306, NULL),
('The Paradise Inn', 112, '2019-06-07', 391, NULL),
('The Paradise Inn', 112, '2019-06-08', 104, NULL),
('The Paradise Inn', 112, '2019-06-09', 388, NULL),
('The Paradise Inn', 112, '2019-06-10', 236, NULL),
('The Paradise Inn', 112, '2019-06-11', 351, NULL),
('The Paradise Inn', 112, '2019-06-12', 366, NULL),
('The Paradise Inn', 112, '2019-06-13', 206, NULL),
('The Paradise Inn', 112, '2019-06-14', 385, NULL),
('The Paradise Inn', 112, '2019-06-15', 262, NULL),
('The Paradise Inn', 112, '2019-06-16', 109, NULL),
('The Paradise Inn', 112, '2019-06-17', 145, NULL),
('The Paradise Inn', 112, '2019-06-18', 245, NULL),
('The Paradise Inn', 112, '2019-06-19', 360, NULL),
('The Paradise Inn', 112, '2019-06-20', 268, NULL),
('The Paradise Inn', 112, '2019-06-21', 242, NULL),
('The Paradise Inn', 112, '2019-06-22', 329, NULL),
('The Paradise Inn', 112, '2019-06-23', 378, NULL),
('The Paradise Inn', 112, '2019-06-24', 318, NULL),
('The Paradise Inn', 112, '2019-06-25', 194, NULL),
('The Paradise Inn', 112, '2019-06-26', 159, NULL),
('The Paradise Inn', 112, '2019-06-27', 283, NULL),
('The Paradise Inn', 112, '2019-06-28', 138, NULL),
('The Paradise Inn', 112, '2019-06-29', 127, NULL),
('The Paradise Inn', 112, '2019-06-30', 310, NULL),
('The Paradise Inn', 112, '2019-07-01', 147, NULL),
('The Paradise Inn', 112, '2019-07-02', 326, NULL),
('The Paradise Inn', 112, '2019-07-03', 179, NULL),
('The Paradise Inn', 112, '2019-07-04', 230, NULL),
('The Paradise Inn', 112, '2019-07-05', 215, NULL),
('The Paradise Inn', 112, '2019-07-06', 349, NULL),
('The Paradise Inn', 112, '2019-07-07', 372, NULL),
('The Paradise Inn', 112, '2019-07-08', 200, NULL),
('The Paradise Inn', 112, '2019-07-09', 116, NULL),
('The Paradise Inn', 112, '2019-07-10', 216, NULL),
('The Paradise Inn', 112, '2019-07-11', 311, NULL),
('The Paradise Inn', 112, '2019-07-12', 169, NULL),
('The Paradise Inn', 112, '2019-07-13', 228, NULL),
('The Paradise Inn', 112, '2019-07-14', 195, NULL),
('The Paradise Inn', 112, '2019-07-15', 393, NULL),
('The Paradise Inn', 112, '2019-07-16', 394, NULL),
('The Paradise Inn', 112, '2019-07-17', 389, NULL),
('The Paradise Inn', 112, '2019-07-18', 202, NULL),
('The Paradise Inn', 112, '2019-07-19', 236, NULL),
('The Paradise Inn', 112, '2019-07-20', 231, NULL),
('The Paradise Inn', 112, '2019-07-21', 238, NULL),
('The Paradise Inn', 112, '2019-07-22', 276, NULL),
('The Paradise Inn', 112, '2019-07-23', 288, NULL),
('The Paradise Inn', 112, '2019-07-24', 273, NULL),
('The Paradise Inn', 112, '2019-07-25', 300, NULL),
('The Paradise Inn', 112, '2019-07-26', 271, NULL),
('The Paradise Inn', 112, '2019-07-27', 119, NULL),
('The Paradise Inn', 112, '2019-07-28', 256, NULL),
('The Paradise Inn', 112, '2019-07-29', 188, NULL),
('The Paradise Inn', 112, '2019-07-30', 359, NULL),
('The Paradise Inn', 112, '2019-07-31', 194, NULL),
('The Paradise Inn', 112, '2019-08-01', 383, NULL),
('The Paradise Inn', 112, '2019-08-02', 190, NULL),
('The Paradise Inn', 112, '2019-08-03', 323, NULL),
('The Paradise Inn', 112, '2019-08-04', 194, NULL),
('The Paradise Inn', 112, '2019-08-05', 119, NULL),
('The Paradise Inn', 112, '2019-08-06', 338, NULL),
('The Paradise Inn', 112, '2019-08-07', 377, NULL),
('The Paradise Inn', 112, '2019-08-08', 355, NULL),
('The Paradise Inn', 112, '2019-08-09', 389, NULL),
('The Paradise Inn', 112, '2019-08-10', 126, NULL),
('The Paradise Inn', 112, '2019-08-11', 374, NULL),
('The Paradise Inn', 112, '2019-08-12', 104, NULL),
('The Paradise Inn', 112, '2019-08-13', 134, NULL),
('The Paradise Inn', 112, '2019-08-14', 232, NULL),
('The Paradise Inn', 112, '2019-08-15', 137, NULL),
('The Paradise Inn', 112, '2019-08-16', 171, NULL),
('The Paradise Inn', 112, '2019-08-17', 361, NULL),
('The Paradise Inn', 112, '2019-08-18', 145, NULL),
('The Paradise Inn', 112, '2019-08-19', 134, NULL),
('The Paradise Inn', 112, '2019-08-20', 110, NULL),
('The Paradise Inn', 112, '2019-08-21', 102, NULL),
('The Paradise Inn', 112, '2019-08-22', 180, NULL),
('The Paradise Inn', 112, '2019-08-23', 164, NULL),
('The Paradise Inn', 112, '2019-08-24', 204, NULL),
('The Paradise Inn', 112, '2019-08-25', 362, NULL),
('The Paradise Inn', 112, '2019-08-26', 398, NULL),
('The Paradise Inn', 112, '2019-08-27', 277, NULL),
('The Paradise Inn', 112, '2019-08-28', 148, NULL),
('The Paradise Inn', 112, '2019-08-29', 211, NULL),
('The Paradise Inn', 112, '2019-08-30', 182, NULL),
('The Paradise Inn', 112, '2019-08-31', 355, NULL),
('The Paradise Inn', 112, '2019-09-01', 234, NULL),
('The Paradise Inn', 112, '2019-09-02', 369, NULL),
('The Paradise Inn', 112, '2019-09-03', 299, NULL),
('The Paradise Inn', 112, '2019-09-04', 277, NULL),
('The Paradise Inn', 112, '2019-09-05', 129, NULL),
('The Paradise Inn', 112, '2019-09-06', 122, NULL),
('The Paradise Inn', 112, '2019-09-07', 188, NULL),
('The Paradise Inn', 112, '2019-09-08', 140, NULL),
('The Paradise Inn', 112, '2019-09-09', 220, NULL),
('The Paradise Inn', 112, '2019-09-10', 130, NULL),
('The Paradise Inn', 112, '2019-09-11', 298, NULL),
('The Paradise Inn', 112, '2019-09-12', 274, NULL),
('The Paradise Inn', 112, '2019-09-13', 396, NULL),
('The Paradise Inn', 112, '2019-09-14', 127, NULL),
('The Paradise Inn', 112, '2019-09-15', 288, NULL),
('The Paradise Inn', 112, '2019-09-16', 240, NULL),
('The Paradise Inn', 112, '2019-09-17', 351, NULL),
('The Paradise Inn', 112, '2019-09-18', 108, NULL),
('The Paradise Inn', 112, '2019-09-19', 128, NULL),
('The Paradise Inn', 112, '2019-09-20', 122, NULL),
('The Paradise Inn', 112, '2019-09-21', 374, NULL),
('The Paradise Inn', 112, '2019-09-22', 283, NULL),
('The Paradise Inn', 112, '2019-09-23', 133, NULL),
('The Paradise Inn', 112, '2019-09-24', 390, NULL),
('The Paradise Inn', 112, '2019-09-25', 264, NULL),
('The Paradise Inn', 112, '2019-09-26', 387, NULL),
('The Paradise Inn', 112, '2019-09-27', 103, NULL),
('The Paradise Inn', 112, '2019-09-28', 340, NULL),
('The Paradise Inn', 112, '2019-09-29', 213, NULL),
('The Paradise Inn', 112, '2019-09-30', 212, NULL),
('The Paradise Inn', 112, '2019-10-01', 369, NULL),
('The Paradise Inn', 112, '2019-10-02', 102, NULL),
('The Paradise Inn', 112, '2019-10-03', 361, NULL),
('The Paradise Inn', 112, '2019-10-04', 302, NULL),
('The Paradise Inn', 112, '2019-10-05', 305, NULL),
('The Paradise Inn', 112, '2019-10-06', 231, NULL),
('The Paradise Inn', 112, '2019-10-07', 394, NULL),
('The Paradise Inn', 112, '2019-10-08', 217, NULL),
('The Paradise Inn', 112, '2019-10-09', 214, NULL),
('The Paradise Inn', 112, '2019-10-10', 335, NULL),
('The Paradise Inn', 112, '2019-10-11', 295, NULL),
('The Paradise Inn', 112, '2019-10-12', 185, NULL),
('The Paradise Inn', 112, '2019-10-13', 279, NULL),
('The Paradise Inn', 112, '2019-10-14', 222, NULL),
('The Paradise Inn', 112, '2019-10-15', 257, NULL),
('The Paradise Inn', 112, '2019-10-16', 291, NULL),
('The Paradise Inn', 112, '2019-10-17', 320, NULL),
('The Paradise Inn', 112, '2019-10-18', 237, NULL),
('The Paradise Inn', 112, '2019-10-19', 287, NULL),
('The Paradise Inn', 112, '2019-10-20', 221, NULL),
('The Paradise Inn', 112, '2019-10-21', 108, NULL),
('The Paradise Inn', 112, '2019-10-22', 110, NULL),
('The Paradise Inn', 112, '2019-10-23', 197, NULL),
('The Paradise Inn', 112, '2019-10-24', 340, NULL),
('The Paradise Inn', 112, '2019-10-25', 343, NULL),
('The Paradise Inn', 112, '2019-10-26', 378, NULL),
('The Paradise Inn', 112, '2019-10-27', 118, NULL),
('The Paradise Inn', 112, '2019-10-28', 230, NULL),
('The Paradise Inn', 112, '2019-10-29', 189, NULL),
('The Paradise Inn', 112, '2019-10-30', 315, NULL),
('The Paradise Inn', 112, '2019-10-31', 365, NULL),
('The Paradise Inn', 112, '2019-11-01', 169, NULL),
('The Paradise Inn', 112, '2019-11-02', 371, NULL),
('The Paradise Inn', 112, '2019-11-03', 152, NULL),
('The Paradise Inn', 112, '2019-11-04', 268, NULL),
('The Paradise Inn', 112, '2019-11-05', 178, NULL),
('The Paradise Inn', 112, '2019-11-06', 147, NULL),
('The Paradise Inn', 112, '2019-11-07', 384, NULL),
('The Paradise Inn', 112, '2019-11-08', 304, NULL),
('The Paradise Inn', 112, '2019-11-09', 213, NULL),
('The Paradise Inn', 112, '2019-11-10', 112, NULL),
('The Paradise Inn', 112, '2019-11-11', 246, NULL),
('The Paradise Inn', 112, '2019-11-12', 290, NULL),
('The Paradise Inn', 112, '2019-11-13', 307, NULL),
('The Paradise Inn', 112, '2019-11-14', 161, NULL),
('The Paradise Inn', 112, '2019-11-15', 275, NULL),
('The Paradise Inn', 112, '2019-11-16', 384, NULL),
('The Paradise Inn', 112, '2019-11-17', 178, NULL),
('The Paradise Inn', 112, '2019-11-18', 249, NULL),
('The Paradise Inn', 112, '2019-11-19', 124, NULL),
('The Paradise Inn', 112, '2019-11-20', 356, NULL),
('The Paradise Inn', 112, '2019-11-21', 255, NULL),
('The Paradise Inn', 112, '2019-11-22', 106, NULL),
('The Paradise Inn', 112, '2019-11-23', 363, NULL),
('The Paradise Inn', 112, '2019-11-24', 225, NULL),
('The Paradise Inn', 112, '2019-11-25', 127, NULL),
('The Paradise Inn', 112, '2019-11-26', 251, NULL),
('The Paradise Inn', 112, '2019-11-27', 370, NULL),
('The Paradise Inn', 112, '2019-11-28', 138, NULL),
('The Paradise Inn', 112, '2019-11-29', 180, NULL),
('The Paradise Inn', 112, '2019-11-30', 206, NULL),
('The Paradise Inn', 112, '2019-12-01', 199, NULL),
('The Paradise Inn', 112, '2019-12-02', 271, NULL),
('The Paradise Inn', 112, '2019-12-03', 165, NULL),
('The Paradise Inn', 112, '2019-12-04', 244, NULL),
('The Paradise Inn', 112, '2019-12-05', 191, NULL),
('The Paradise Inn', 112, '2019-12-06', 139, NULL),
('The Paradise Inn', 112, '2019-12-07', 319, NULL),
('The Paradise Inn', 112, '2019-12-08', 299, NULL),
('The Paradise Inn', 112, '2019-12-09', 142, NULL),
('The Paradise Inn', 112, '2019-12-10', 145, NULL),
('The Paradise Inn', 112, '2019-12-11', 296, NULL),
('The Paradise Inn', 112, '2019-12-12', 394, NULL),
('The Paradise Inn', 112, '2019-12-13', 317, NULL),
('The Paradise Inn', 112, '2019-12-14', 326, NULL),
('The Paradise Inn', 112, '2019-12-15', 273, NULL),
('The Paradise Inn', 112, '2019-12-16', 364, NULL),
('The Paradise Inn', 112, '2019-12-17', 394, NULL),
('The Paradise Inn', 112, '2019-12-18', 271, NULL),
('The Paradise Inn', 112, '2019-12-19', 254, NULL),
('The Paradise Inn', 112, '2019-12-20', 117, NULL),
('The Paradise Inn', 112, '2019-12-21', 132, NULL),
('The Paradise Inn', 112, '2019-12-22', 324, NULL),
('The Paradise Inn', 112, '2019-12-23', 123, NULL),
('The Paradise Inn', 112, '2019-12-24', 186, NULL),
('The Paradise Inn', 112, '2019-12-25', 275, NULL),
('The Paradise Inn', 112, '2019-12-26', 291, NULL),
('The Paradise Inn', 112, '2019-12-27', 392, NULL),
('The Paradise Inn', 112, '2019-12-28', 356, NULL),
('The Paradise Inn', 112, '2019-12-29', 120, NULL),
('The Paradise Inn', 112, '2019-12-30', 266, NULL),
('The Paradise Inn', 112, '2019-12-31', 131, NULL),
('The Paradise Inn', 112, '2020-01-01', 331, NULL),
('The Paradise Inn', 112, '2020-01-02', 230, NULL),
('The Paradise Inn', 112, '2020-01-03', 359, NULL),
('The Paradise Inn', 112, '2020-01-04', 343, NULL),
('The Paradise Inn', 112, '2020-01-05', 312, NULL),
('The Paradise Inn', 112, '2020-01-06', 336, NULL),
('The Paradise Inn', 112, '2020-01-07', 155, NULL),
('The Paradise Inn', 112, '2020-01-08', 214, NULL),
('The Paradise Inn', 112, '2020-01-09', 209, NULL),
('The Paradise Inn', 112, '2020-01-10', 265, NULL),
('The Paradise Inn', 112, '2020-01-11', 233, NULL),
('The Paradise Inn', 112, '2020-01-12', 169, NULL),
('The Paradise Inn', 112, '2020-01-13', 198, NULL),
('The Paradise Inn', 112, '2020-01-14', 163, NULL),
('The Paradise Inn', 112, '2020-01-15', 370, NULL),
('The Paradise Inn', 112, '2020-01-16', 109, NULL),
('The Paradise Inn', 112, '2020-01-17', 308, NULL),
('The Paradise Inn', 112, '2020-01-18', 383, NULL),
('The Paradise Inn', 112, '2020-01-19', 231, NULL),
('The Paradise Inn', 112, '2020-01-20', 327, NULL),
('The Paradise Inn', 112, '2020-01-21', 177, NULL),
('The Paradise Inn', 112, '2020-01-22', 253, NULL),
('The Paradise Inn', 112, '2020-01-23', 372, NULL),
('The Paradise Inn', 112, '2020-01-24', 244, NULL),
('The Paradise Inn', 112, '2020-01-25', 133, NULL),
('The Paradise Inn', 112, '2020-01-26', 171, NULL),
('The Paradise Inn', 112, '2020-01-27', 183, NULL),
('The Paradise Inn', 112, '2020-01-28', 392, NULL),
('The Paradise Inn', 112, '2020-01-29', 387, NULL),
('The Paradise Inn', 112, '2020-01-30', 208, NULL),
('The Paradise Inn', 112, '2020-01-31', 334, NULL),
('The Paradise Inn', 112, '2020-02-01', 374, NULL),
('The Paradise Inn', 112, '2020-02-02', 101, NULL),
('The Paradise Inn', 112, '2020-02-03', 265, NULL),
('The Paradise Inn', 112, '2020-02-04', 320, NULL),
('The Paradise Inn', 113, '2019-01-01', 188, NULL),
('The Paradise Inn', 113, '2019-01-02', 347, NULL),
('The Paradise Inn', 113, '2019-01-03', 370, NULL),
('The Paradise Inn', 113, '2019-01-04', 228, NULL),
('The Paradise Inn', 113, '2019-01-05', 223, NULL),
('The Paradise Inn', 113, '2019-01-06', 101, NULL),
('The Paradise Inn', 113, '2019-01-07', 254, NULL),
('The Paradise Inn', 113, '2019-01-08', 262, NULL),
('The Paradise Inn', 113, '2019-01-09', 390, NULL),
('The Paradise Inn', 113, '2019-01-10', 260, NULL),
('The Paradise Inn', 113, '2019-01-11', 278, NULL),
('The Paradise Inn', 113, '2019-01-12', 197, NULL),
('The Paradise Inn', 113, '2019-01-13', 114, NULL),
('The Paradise Inn', 113, '2019-01-14', 153, NULL),
('The Paradise Inn', 113, '2019-01-15', 339, NULL),
('The Paradise Inn', 113, '2019-01-16', 384, NULL),
('The Paradise Inn', 113, '2019-01-17', 148, NULL),
('The Paradise Inn', 113, '2019-01-18', 217, NULL),
('The Paradise Inn', 113, '2019-01-19', 221, NULL),
('The Paradise Inn', 113, '2019-01-20', 312, NULL),
('The Paradise Inn', 113, '2019-01-21', 129, NULL),
('The Paradise Inn', 113, '2019-01-22', 350, NULL),
('The Paradise Inn', 113, '2019-01-23', 327, NULL),
('The Paradise Inn', 113, '2019-01-24', 196, NULL),
('The Paradise Inn', 113, '2019-01-25', 307, NULL),
('The Paradise Inn', 113, '2019-01-26', 390, NULL),
('The Paradise Inn', 113, '2019-01-27', 196, NULL),
('The Paradise Inn', 113, '2019-01-28', 301, NULL),
('The Paradise Inn', 113, '2019-01-29', 197, NULL),
('The Paradise Inn', 113, '2019-01-30', 104, NULL),
('The Paradise Inn', 113, '2019-01-31', 138, NULL),
('The Paradise Inn', 113, '2019-02-01', 163, NULL),
('The Paradise Inn', 113, '2019-02-02', 374, NULL),
('The Paradise Inn', 113, '2019-02-03', 117, NULL),
('The Paradise Inn', 113, '2019-02-04', 148, NULL),
('The Paradise Inn', 113, '2019-02-05', 316, NULL),
('The Paradise Inn', 113, '2019-02-06', 371, NULL),
('The Paradise Inn', 113, '2019-02-07', 395, NULL),
('The Paradise Inn', 113, '2019-02-08', 212, NULL),
('The Paradise Inn', 113, '2019-02-09', 358, NULL),
('The Paradise Inn', 113, '2019-02-10', 334, NULL),
('The Paradise Inn', 113, '2019-02-11', 365, NULL),
('The Paradise Inn', 113, '2019-02-12', 171, NULL),
('The Paradise Inn', 113, '2019-02-13', 329, NULL),
('The Paradise Inn', 113, '2019-02-14', 202, NULL),
('The Paradise Inn', 113, '2019-02-15', 104, NULL),
('The Paradise Inn', 113, '2019-02-16', 308, NULL),
('The Paradise Inn', 113, '2019-02-17', 358, NULL),
('The Paradise Inn', 113, '2019-02-18', 364, NULL),
('The Paradise Inn', 113, '2019-02-19', 227, NULL),
('The Paradise Inn', 113, '2019-02-20', 250, NULL),
('The Paradise Inn', 113, '2019-02-21', 250, NULL),
('The Paradise Inn', 113, '2019-02-22', 145, NULL),
('The Paradise Inn', 113, '2019-02-23', 346, NULL),
('The Paradise Inn', 113, '2019-02-24', 248, NULL),
('The Paradise Inn', 113, '2019-02-25', 251, NULL),
('The Paradise Inn', 113, '2019-02-26', 383, NULL),
('The Paradise Inn', 113, '2019-02-27', 174, NULL),
('The Paradise Inn', 113, '2019-02-28', 187, NULL),
('The Paradise Inn', 113, '2019-03-01', 316, NULL),
('The Paradise Inn', 113, '2019-03-02', 396, NULL),
('The Paradise Inn', 113, '2019-03-03', 220, NULL),
('The Paradise Inn', 113, '2019-03-04', 137, NULL),
('The Paradise Inn', 113, '2019-03-05', 337, NULL),
('The Paradise Inn', 113, '2019-03-06', 135, NULL),
('The Paradise Inn', 113, '2019-03-07', 125, NULL),
('The Paradise Inn', 113, '2019-03-08', 196, NULL),
('The Paradise Inn', 113, '2019-03-09', 288, NULL),
('The Paradise Inn', 113, '2019-03-10', 103, NULL),
('The Paradise Inn', 113, '2019-03-11', 399, NULL),
('The Paradise Inn', 113, '2019-03-12', 129, NULL),
('The Paradise Inn', 113, '2019-03-13', 312, NULL),
('The Paradise Inn', 113, '2019-03-14', 378, NULL),
('The Paradise Inn', 113, '2019-03-15', 256, NULL),
('The Paradise Inn', 113, '2019-03-16', 396, NULL),
('The Paradise Inn', 113, '2019-03-17', 324, NULL),
('The Paradise Inn', 113, '2019-03-18', 313, NULL),
('The Paradise Inn', 113, '2019-03-19', 127, NULL),
('The Paradise Inn', 113, '2019-03-20', 334, NULL),
('The Paradise Inn', 113, '2019-03-21', 132, NULL),
('The Paradise Inn', 113, '2019-03-22', 129, NULL),
('The Paradise Inn', 113, '2019-03-23', 108, NULL),
('The Paradise Inn', 113, '2019-03-24', 118, NULL),
('The Paradise Inn', 113, '2019-03-25', 220, NULL),
('The Paradise Inn', 113, '2019-03-26', 389, NULL),
('The Paradise Inn', 113, '2019-03-27', 243, NULL),
('The Paradise Inn', 113, '2019-03-28', 128, NULL),
('The Paradise Inn', 113, '2019-03-29', 161, NULL),
('The Paradise Inn', 113, '2019-03-30', 186, NULL),
('The Paradise Inn', 113, '2019-03-31', 209, NULL),
('The Paradise Inn', 113, '2019-04-01', 197, NULL),
('The Paradise Inn', 113, '2019-04-02', 213, NULL),
('The Paradise Inn', 113, '2019-04-03', 242, NULL),
('The Paradise Inn', 113, '2019-04-04', 145, NULL),
('The Paradise Inn', 113, '2019-04-05', 221, NULL),
('The Paradise Inn', 113, '2019-04-06', 177, NULL),
('The Paradise Inn', 113, '2019-04-07', 271, NULL),
('The Paradise Inn', 113, '2019-04-08', 394, NULL),
('The Paradise Inn', 113, '2019-04-09', 315, NULL),
('The Paradise Inn', 113, '2019-04-10', 245, NULL),
('The Paradise Inn', 113, '2019-04-11', 198, NULL),
('The Paradise Inn', 113, '2019-04-12', 184, NULL),
('The Paradise Inn', 113, '2019-04-13', 163, NULL),
('The Paradise Inn', 113, '2019-04-14', 334, NULL),
('The Paradise Inn', 113, '2019-04-15', 321, NULL),
('The Paradise Inn', 113, '2019-04-16', 287, NULL),
('The Paradise Inn', 113, '2019-04-17', 126, NULL),
('The Paradise Inn', 113, '2019-04-18', 353, NULL),
('The Paradise Inn', 113, '2019-04-19', 135, NULL),
('The Paradise Inn', 113, '2019-04-20', 313, NULL),
('The Paradise Inn', 113, '2019-04-21', 189, NULL),
('The Paradise Inn', 113, '2019-04-22', 152, NULL),
('The Paradise Inn', 113, '2019-04-23', 273, NULL),
('The Paradise Inn', 113, '2019-04-24', 201, NULL),
('The Paradise Inn', 113, '2019-04-25', 268, NULL),
('The Paradise Inn', 113, '2019-04-26', 138, NULL),
('The Paradise Inn', 113, '2019-04-27', 294, NULL),
('The Paradise Inn', 113, '2019-04-28', 398, NULL),
('The Paradise Inn', 113, '2019-04-29', 160, NULL),
('The Paradise Inn', 113, '2019-04-30', 305, NULL),
('The Paradise Inn', 113, '2019-05-01', 375, NULL),
('The Paradise Inn', 113, '2019-05-02', 303, NULL),
('The Paradise Inn', 113, '2019-05-03', 271, NULL),
('The Paradise Inn', 113, '2019-05-04', 296, NULL),
('The Paradise Inn', 113, '2019-05-05', 162, NULL),
('The Paradise Inn', 113, '2019-05-06', 195, NULL),
('The Paradise Inn', 113, '2019-05-07', 365, NULL),
('The Paradise Inn', 113, '2019-05-08', 199, NULL),
('The Paradise Inn', 113, '2019-05-09', 363, NULL),
('The Paradise Inn', 113, '2019-05-10', 138, NULL),
('The Paradise Inn', 113, '2019-05-11', 373, NULL),
('The Paradise Inn', 113, '2019-05-12', 347, NULL),
('The Paradise Inn', 113, '2019-05-13', 265, NULL),
('The Paradise Inn', 113, '2019-05-14', 292, NULL),
('The Paradise Inn', 113, '2019-05-15', 204, NULL),
('The Paradise Inn', 113, '2019-05-16', 343, NULL),
('The Paradise Inn', 113, '2019-05-17', 134, NULL),
('The Paradise Inn', 113, '2019-05-18', 314, NULL),
('The Paradise Inn', 113, '2019-05-19', 267, NULL),
('The Paradise Inn', 113, '2019-05-20', 299, NULL),
('The Paradise Inn', 113, '2019-05-21', 242, NULL),
('The Paradise Inn', 113, '2019-05-22', 390, NULL),
('The Paradise Inn', 113, '2019-05-23', 125, NULL),
('The Paradise Inn', 113, '2019-05-24', 203, NULL),
('The Paradise Inn', 113, '2019-05-25', 345, NULL),
('The Paradise Inn', 113, '2019-05-26', 178, NULL),
('The Paradise Inn', 113, '2019-05-27', 298, NULL),
('The Paradise Inn', 113, '2019-05-28', 151, NULL),
('The Paradise Inn', 113, '2019-05-29', 231, NULL),
('The Paradise Inn', 113, '2019-05-30', 271, NULL),
('The Paradise Inn', 113, '2019-05-31', 340, NULL),
('The Paradise Inn', 113, '2019-06-01', 143, NULL),
('The Paradise Inn', 113, '2019-06-02', 289, NULL),
('The Paradise Inn', 113, '2019-06-03', 239, NULL),
('The Paradise Inn', 113, '2019-06-04', 122, NULL),
('The Paradise Inn', 113, '2019-06-05', 154, NULL),
('The Paradise Inn', 113, '2019-06-06', 240, NULL),
('The Paradise Inn', 113, '2019-06-07', 319, NULL),
('The Paradise Inn', 113, '2019-06-08', 381, NULL),
('The Paradise Inn', 113, '2019-06-09', 108, NULL),
('The Paradise Inn', 113, '2019-06-10', 203, NULL),
('The Paradise Inn', 113, '2019-06-11', 169, NULL),
('The Paradise Inn', 113, '2019-06-12', 373, NULL),
('The Paradise Inn', 113, '2019-06-13', 149, NULL),
('The Paradise Inn', 113, '2019-06-14', 383, NULL),
('The Paradise Inn', 113, '2019-06-15', 257, NULL),
('The Paradise Inn', 113, '2019-06-16', 180, NULL),
('The Paradise Inn', 113, '2019-06-17', 137, NULL),
('The Paradise Inn', 113, '2019-06-18', 300, NULL),
('The Paradise Inn', 113, '2019-06-19', 236, NULL),
('The Paradise Inn', 113, '2019-06-20', 102, NULL),
('The Paradise Inn', 113, '2019-06-21', 299, NULL),
('The Paradise Inn', 113, '2019-06-22', 112, NULL),
('The Paradise Inn', 113, '2019-06-23', 237, NULL),
('The Paradise Inn', 113, '2019-06-24', 193, NULL),
('The Paradise Inn', 113, '2019-06-25', 313, NULL),
('The Paradise Inn', 113, '2019-06-26', 180, NULL),
('The Paradise Inn', 113, '2019-06-27', 360, NULL),
('The Paradise Inn', 113, '2019-06-28', 358, NULL),
('The Paradise Inn', 113, '2019-06-29', 284, NULL),
('The Paradise Inn', 113, '2019-06-30', 235, NULL),
('The Paradise Inn', 113, '2019-07-01', 146, NULL),
('The Paradise Inn', 113, '2019-07-02', 302, NULL),
('The Paradise Inn', 113, '2019-07-03', 158, NULL),
('The Paradise Inn', 113, '2019-07-04', 277, NULL),
('The Paradise Inn', 113, '2019-07-05', 151, NULL),
('The Paradise Inn', 113, '2019-07-06', 305, NULL),
('The Paradise Inn', 113, '2019-07-07', 350, NULL),
('The Paradise Inn', 113, '2019-07-08', 392, NULL),
('The Paradise Inn', 113, '2019-07-09', 353, NULL),
('The Paradise Inn', 113, '2019-07-10', 152, NULL),
('The Paradise Inn', 113, '2019-07-11', 287, NULL),
('The Paradise Inn', 113, '2019-07-12', 223, NULL),
('The Paradise Inn', 113, '2019-07-13', 323, NULL),
('The Paradise Inn', 113, '2019-07-14', 102, NULL),
('The Paradise Inn', 113, '2019-07-15', 328, NULL),
('The Paradise Inn', 113, '2019-07-16', 161, NULL),
('The Paradise Inn', 113, '2019-07-17', 232, NULL),
('The Paradise Inn', 113, '2019-07-18', 199, NULL),
('The Paradise Inn', 113, '2019-07-19', 104, NULL),
('The Paradise Inn', 113, '2019-07-20', 132, NULL),
('The Paradise Inn', 113, '2019-07-21', 157, NULL),
('The Paradise Inn', 113, '2019-07-22', 274, NULL),
('The Paradise Inn', 113, '2019-07-23', 309, NULL),
('The Paradise Inn', 113, '2019-07-24', 174, NULL),
('The Paradise Inn', 113, '2019-07-25', 301, NULL),
('The Paradise Inn', 113, '2019-07-26', 302, NULL),
('The Paradise Inn', 113, '2019-07-27', 146, NULL),
('The Paradise Inn', 113, '2019-07-28', 296, NULL),
('The Paradise Inn', 113, '2019-07-29', 118, NULL),
('The Paradise Inn', 113, '2019-07-30', 162, NULL),
('The Paradise Inn', 113, '2019-07-31', 359, NULL),
('The Paradise Inn', 113, '2019-08-01', 326, NULL),
('The Paradise Inn', 113, '2019-08-02', 246, NULL),
('The Paradise Inn', 113, '2019-08-03', 255, NULL),
('The Paradise Inn', 113, '2019-08-04', 175, NULL),
('The Paradise Inn', 113, '2019-08-05', 140, NULL),
('The Paradise Inn', 113, '2019-08-06', 372, NULL),
('The Paradise Inn', 113, '2019-08-07', 178, NULL),
('The Paradise Inn', 113, '2019-08-08', 106, NULL),
('The Paradise Inn', 113, '2019-08-09', 137, NULL),
('The Paradise Inn', 113, '2019-08-10', 300, NULL),
('The Paradise Inn', 113, '2019-08-11', 217, NULL),
('The Paradise Inn', 113, '2019-08-12', 180, NULL),
('The Paradise Inn', 113, '2019-08-13', 163, NULL),
('The Paradise Inn', 113, '2019-08-14', 346, NULL),
('The Paradise Inn', 113, '2019-08-15', 147, NULL),
('The Paradise Inn', 113, '2019-08-16', 215, NULL),
('The Paradise Inn', 113, '2019-08-17', 287, NULL),
('The Paradise Inn', 113, '2019-08-18', 185, NULL),
('The Paradise Inn', 113, '2019-08-19', 191, NULL),
('The Paradise Inn', 113, '2019-08-20', 376, NULL),
('The Paradise Inn', 113, '2019-08-21', 216, NULL),
('The Paradise Inn', 113, '2019-08-22', 334, NULL),
('The Paradise Inn', 113, '2019-08-23', 192, NULL),
('The Paradise Inn', 113, '2019-08-24', 139, NULL),
('The Paradise Inn', 113, '2019-08-25', 153, NULL),
('The Paradise Inn', 113, '2019-08-26', 376, NULL),
('The Paradise Inn', 113, '2019-08-27', 132, NULL),
('The Paradise Inn', 113, '2019-08-28', 210, NULL),
('The Paradise Inn', 113, '2019-08-29', 138, NULL),
('The Paradise Inn', 113, '2019-08-30', 250, NULL),
('The Paradise Inn', 113, '2019-08-31', 199, NULL),
('The Paradise Inn', 113, '2019-09-01', 366, NULL),
('The Paradise Inn', 113, '2019-09-02', 233, NULL),
('The Paradise Inn', 113, '2019-09-03', 314, NULL),
('The Paradise Inn', 113, '2019-09-04', 272, NULL),
('The Paradise Inn', 113, '2019-09-05', 302, NULL),
('The Paradise Inn', 113, '2019-09-06', 142, NULL),
('The Paradise Inn', 113, '2019-09-07', 368, NULL),
('The Paradise Inn', 113, '2019-09-08', 325, NULL),
('The Paradise Inn', 113, '2019-09-09', 240, NULL),
('The Paradise Inn', 113, '2019-09-10', 239, NULL),
('The Paradise Inn', 113, '2019-09-11', 326, NULL),
('The Paradise Inn', 113, '2019-09-12', 173, NULL),
('The Paradise Inn', 113, '2019-09-13', 164, NULL),
('The Paradise Inn', 113, '2019-09-14', 221, NULL),
('The Paradise Inn', 113, '2019-09-15', 377, NULL),
('The Paradise Inn', 113, '2019-09-16', 174, NULL),
('The Paradise Inn', 113, '2019-09-17', 279, NULL),
('The Paradise Inn', 113, '2019-09-18', 299, NULL),
('The Paradise Inn', 113, '2019-09-19', 251, NULL),
('The Paradise Inn', 113, '2019-09-20', 292, NULL),
('The Paradise Inn', 113, '2019-09-21', 279, NULL),
('The Paradise Inn', 113, '2019-09-22', 271, NULL),
('The Paradise Inn', 113, '2019-09-23', 299, NULL),
('The Paradise Inn', 113, '2019-09-24', 370, NULL),
('The Paradise Inn', 113, '2019-09-25', 345, NULL),
('The Paradise Inn', 113, '2019-09-26', 328, NULL),
('The Paradise Inn', 113, '2019-09-27', 251, NULL),
('The Paradise Inn', 113, '2019-09-28', 216, NULL),
('The Paradise Inn', 113, '2019-09-29', 385, NULL),
('The Paradise Inn', 113, '2019-09-30', 377, NULL),
('The Paradise Inn', 113, '2019-10-01', 293, NULL),
('The Paradise Inn', 113, '2019-10-02', 335, NULL),
('The Paradise Inn', 113, '2019-10-03', 215, NULL),
('The Paradise Inn', 113, '2019-10-04', 132, NULL),
('The Paradise Inn', 113, '2019-10-05', 136, NULL),
('The Paradise Inn', 113, '2019-10-06', 228, NULL),
('The Paradise Inn', 113, '2019-10-07', 394, NULL),
('The Paradise Inn', 113, '2019-10-08', 290, NULL),
('The Paradise Inn', 113, '2019-10-09', 256, NULL),
('The Paradise Inn', 113, '2019-10-10', 319, NULL),
('The Paradise Inn', 113, '2019-10-11', 347, NULL),
('The Paradise Inn', 113, '2019-10-12', 280, NULL),
('The Paradise Inn', 113, '2019-10-13', 105, NULL),
('The Paradise Inn', 113, '2019-10-14', 249, NULL),
('The Paradise Inn', 113, '2019-10-15', 352, NULL),
('The Paradise Inn', 113, '2019-10-16', 337, NULL),
('The Paradise Inn', 113, '2019-10-17', 253, NULL),
('The Paradise Inn', 113, '2019-10-18', 180, NULL),
('The Paradise Inn', 113, '2019-10-19', 274, NULL),
('The Paradise Inn', 113, '2019-10-20', 317, NULL),
('The Paradise Inn', 113, '2019-10-21', 345, NULL),
('The Paradise Inn', 113, '2019-10-22', 369, NULL),
('The Paradise Inn', 113, '2019-10-23', 144, NULL),
('The Paradise Inn', 113, '2019-10-24', 351, NULL),
('The Paradise Inn', 113, '2019-10-25', 329, NULL),
('The Paradise Inn', 113, '2019-10-26', 303, NULL),
('The Paradise Inn', 113, '2019-10-27', 279, NULL),
('The Paradise Inn', 113, '2019-10-28', 104, NULL),
('The Paradise Inn', 113, '2019-10-29', 169, NULL),
('The Paradise Inn', 113, '2019-10-30', 225, NULL),
('The Paradise Inn', 113, '2019-10-31', 184, NULL),
('The Paradise Inn', 113, '2019-11-01', 316, NULL),
('The Paradise Inn', 113, '2019-11-02', 397, NULL),
('The Paradise Inn', 113, '2019-11-03', 247, NULL),
('The Paradise Inn', 113, '2019-11-04', 286, NULL),
('The Paradise Inn', 113, '2019-11-05', 250, NULL),
('The Paradise Inn', 113, '2019-11-06', 107, NULL),
('The Paradise Inn', 113, '2019-11-07', 125, NULL),
('The Paradise Inn', 113, '2019-11-08', 130, NULL),
('The Paradise Inn', 113, '2019-11-09', 261, NULL),
('The Paradise Inn', 113, '2019-11-10', 135, NULL),
('The Paradise Inn', 113, '2019-11-11', 398, NULL),
('The Paradise Inn', 113, '2019-11-12', 174, NULL),
('The Paradise Inn', 113, '2019-11-13', 365, NULL),
('The Paradise Inn', 113, '2019-11-14', 213, NULL),
('The Paradise Inn', 113, '2019-11-15', 121, NULL),
('The Paradise Inn', 113, '2019-11-16', 298, NULL),
('The Paradise Inn', 113, '2019-11-17', 257, NULL),
('The Paradise Inn', 113, '2019-11-18', 331, NULL),
('The Paradise Inn', 113, '2019-11-19', 380, NULL),
('The Paradise Inn', 113, '2019-11-20', 323, NULL),
('The Paradise Inn', 113, '2019-11-21', 211, NULL),
('The Paradise Inn', 113, '2019-11-22', 347, NULL),
('The Paradise Inn', 113, '2019-11-23', 354, NULL),
('The Paradise Inn', 113, '2019-11-24', 261, NULL),
('The Paradise Inn', 113, '2019-11-25', 389, NULL),
('The Paradise Inn', 113, '2019-11-26', 141, NULL),
('The Paradise Inn', 113, '2019-11-27', 170, NULL),
('The Paradise Inn', 113, '2019-11-28', 138, NULL),
('The Paradise Inn', 113, '2019-11-29', 262, NULL),
('The Paradise Inn', 113, '2019-11-30', 364, NULL),
('The Paradise Inn', 113, '2019-12-01', 242, NULL),
('The Paradise Inn', 113, '2019-12-02', 196, NULL),
('The Paradise Inn', 113, '2019-12-03', 163, NULL),
('The Paradise Inn', 113, '2019-12-04', 377, NULL),
('The Paradise Inn', 113, '2019-12-05', 247, NULL),
('The Paradise Inn', 113, '2019-12-06', 365, NULL),
('The Paradise Inn', 113, '2019-12-07', 169, NULL),
('The Paradise Inn', 113, '2019-12-08', 343, NULL),
('The Paradise Inn', 113, '2019-12-09', 281, NULL),
('The Paradise Inn', 113, '2019-12-10', 392, NULL),
('The Paradise Inn', 113, '2019-12-11', 368, NULL),
('The Paradise Inn', 113, '2019-12-12', 113, NULL),
('The Paradise Inn', 113, '2019-12-13', 312, NULL),
('The Paradise Inn', 113, '2019-12-14', 325, NULL),
('The Paradise Inn', 113, '2019-12-15', 368, NULL),
('The Paradise Inn', 113, '2019-12-16', 209, NULL),
('The Paradise Inn', 113, '2019-12-17', 112, NULL),
('The Paradise Inn', 113, '2019-12-18', 378, NULL),
('The Paradise Inn', 113, '2019-12-19', 113, NULL),
('The Paradise Inn', 113, '2019-12-20', 329, NULL),
('The Paradise Inn', 113, '2019-12-21', 305, NULL),
('The Paradise Inn', 113, '2019-12-22', 311, NULL),
('The Paradise Inn', 113, '2019-12-23', 129, NULL),
('The Paradise Inn', 113, '2019-12-24', 283, NULL),
('The Paradise Inn', 113, '2019-12-25', 367, NULL),
('The Paradise Inn', 113, '2019-12-26', 204, NULL),
('The Paradise Inn', 113, '2019-12-27', 239, NULL),
('The Paradise Inn', 113, '2019-12-28', 282, NULL),
('The Paradise Inn', 113, '2019-12-29', 142, NULL),
('The Paradise Inn', 113, '2019-12-30', 254, NULL),
('The Paradise Inn', 113, '2019-12-31', 190, NULL),
('The Paradise Inn', 113, '2020-01-01', 359, NULL),
('The Paradise Inn', 113, '2020-01-02', 160, NULL),
('The Paradise Inn', 113, '2020-01-03', 125, NULL),
('The Paradise Inn', 113, '2020-01-04', 139, NULL),
('The Paradise Inn', 113, '2020-01-05', 149, NULL),
('The Paradise Inn', 113, '2020-01-06', 340, NULL),
('The Paradise Inn', 113, '2020-01-07', 219, NULL),
('The Paradise Inn', 113, '2020-01-08', 248, NULL),
('The Paradise Inn', 113, '2020-01-09', 383, NULL),
('The Paradise Inn', 113, '2020-01-10', 324, NULL),
('The Paradise Inn', 113, '2020-01-11', 190, NULL),
('The Paradise Inn', 113, '2020-01-12', 300, NULL),
('The Paradise Inn', 113, '2020-01-13', 241, NULL),
('The Paradise Inn', 113, '2020-01-14', 306, NULL),
('The Paradise Inn', 113, '2020-01-15', 276, NULL),
('The Paradise Inn', 113, '2020-01-16', 136, NULL),
('The Paradise Inn', 113, '2020-01-17', 138, NULL),
('The Paradise Inn', 113, '2020-01-18', 239, NULL),
('The Paradise Inn', 113, '2020-01-19', 288, NULL),
('The Paradise Inn', 113, '2020-01-20', 212, NULL),
('The Paradise Inn', 113, '2020-01-21', 215, NULL),
('The Paradise Inn', 113, '2020-01-22', 107, NULL),
('The Paradise Inn', 113, '2020-01-23', 364, NULL),
('The Paradise Inn', 113, '2020-01-24', 300, NULL),
('The Paradise Inn', 113, '2020-01-25', 364, NULL),
('The Paradise Inn', 113, '2020-01-26', 336, NULL),
('The Paradise Inn', 113, '2020-01-27', 249, NULL),
('The Paradise Inn', 113, '2020-01-28', 316, NULL),
('The Paradise Inn', 113, '2020-01-29', 200, NULL),
('The Paradise Inn', 113, '2020-01-30', 389, NULL),
('The Paradise Inn', 113, '2020-01-31', 137, NULL),
('The Paradise Inn', 113, '2020-02-01', 198, NULL),
('The Paradise Inn', 113, '2020-02-02', 292, NULL),
('The Paradise Inn', 113, '2020-02-03', 165, NULL),
('The Paradise Inn', 113, '2020-02-04', 199, NULL),
('The Paradise Inn', 121, '2019-01-01', 128, NULL),
('The Paradise Inn', 121, '2019-01-02', 376, NULL),
('The Paradise Inn', 121, '2019-01-03', 140, NULL),
('The Paradise Inn', 121, '2019-01-04', 230, NULL),
('The Paradise Inn', 121, '2019-01-05', 385, NULL),
('The Paradise Inn', 121, '2019-01-06', 331, NULL),
('The Paradise Inn', 121, '2019-01-07', 182, NULL),
('The Paradise Inn', 121, '2019-01-08', 285, NULL),
('The Paradise Inn', 121, '2019-01-09', 174, NULL),
('The Paradise Inn', 121, '2019-01-10', 363, NULL),
('The Paradise Inn', 121, '2019-01-11', 360, NULL),
('The Paradise Inn', 121, '2019-01-12', 257, NULL),
('The Paradise Inn', 121, '2019-01-13', 348, NULL),
('The Paradise Inn', 121, '2019-01-14', 191, NULL),
('The Paradise Inn', 121, '2019-01-15', 216, NULL),
('The Paradise Inn', 121, '2019-01-16', 372, NULL),
('The Paradise Inn', 121, '2019-01-17', 275, NULL),
('The Paradise Inn', 121, '2019-01-18', 217, NULL),
('The Paradise Inn', 121, '2019-01-19', 270, NULL),
('The Paradise Inn', 121, '2019-01-20', 169, NULL),
('The Paradise Inn', 121, '2019-01-21', 373, NULL),
('The Paradise Inn', 121, '2019-01-22', 377, NULL),
('The Paradise Inn', 121, '2019-01-23', 191, NULL),
('The Paradise Inn', 121, '2019-01-24', 288, NULL),
('The Paradise Inn', 121, '2019-01-25', 191, NULL),
('The Paradise Inn', 121, '2019-01-26', 200, NULL),
('The Paradise Inn', 121, '2019-01-27', 355, NULL),
('The Paradise Inn', 121, '2019-01-28', 223, NULL),
('The Paradise Inn', 121, '2019-01-29', 241, NULL),
('The Paradise Inn', 121, '2019-01-30', 266, NULL),
('The Paradise Inn', 121, '2019-01-31', 160, NULL),
('The Paradise Inn', 121, '2019-02-01', 223, NULL),
('The Paradise Inn', 121, '2019-02-02', 300, NULL),
('The Paradise Inn', 121, '2019-02-03', 312, NULL),
('The Paradise Inn', 121, '2019-02-04', 377, NULL),
('The Paradise Inn', 121, '2019-02-05', 170, NULL),
('The Paradise Inn', 121, '2019-02-06', 247, NULL),
('The Paradise Inn', 121, '2019-02-07', 211, NULL),
('The Paradise Inn', 121, '2019-02-08', 351, NULL),
('The Paradise Inn', 121, '2019-02-09', 124, NULL),
('The Paradise Inn', 121, '2019-02-10', 170, NULL),
('The Paradise Inn', 121, '2019-02-11', 188, NULL),
('The Paradise Inn', 121, '2019-02-12', 164, NULL),
('The Paradise Inn', 121, '2019-02-13', 303, NULL),
('The Paradise Inn', 121, '2019-02-14', 343, NULL),
('The Paradise Inn', 121, '2019-02-15', 126, NULL),
('The Paradise Inn', 121, '2019-02-16', 306, NULL),
('The Paradise Inn', 121, '2019-02-17', 264, NULL),
('The Paradise Inn', 121, '2019-02-18', 168, NULL),
('The Paradise Inn', 121, '2019-02-19', 378, NULL),
('The Paradise Inn', 121, '2019-02-20', 298, NULL),
('The Paradise Inn', 121, '2019-02-21', 315, NULL),
('The Paradise Inn', 121, '2019-02-22', 126, NULL),
('The Paradise Inn', 121, '2019-02-23', 109, NULL),
('The Paradise Inn', 121, '2019-02-24', 206, NULL),
('The Paradise Inn', 121, '2019-02-25', 133, NULL),
('The Paradise Inn', 121, '2019-02-26', 170, NULL),
('The Paradise Inn', 121, '2019-02-27', 182, NULL),
('The Paradise Inn', 121, '2019-02-28', 157, NULL),
('The Paradise Inn', 121, '2019-03-01', 297, NULL),
('The Paradise Inn', 121, '2019-03-02', 187, NULL),
('The Paradise Inn', 121, '2019-03-03', 306, NULL),
('The Paradise Inn', 121, '2019-03-04', 288, NULL),
('The Paradise Inn', 121, '2019-03-05', 165, NULL),
('The Paradise Inn', 121, '2019-03-06', 327, NULL),
('The Paradise Inn', 121, '2019-03-07', 104, NULL),
('The Paradise Inn', 121, '2019-03-08', 170, NULL),
('The Paradise Inn', 121, '2019-03-09', 178, NULL),
('The Paradise Inn', 121, '2019-03-10', 209, NULL),
('The Paradise Inn', 121, '2019-03-11', 218, NULL),
('The Paradise Inn', 121, '2019-03-12', 338, NULL),
('The Paradise Inn', 121, '2019-03-13', 299, NULL),
('The Paradise Inn', 121, '2019-03-14', 345, NULL),
('The Paradise Inn', 121, '2019-03-15', 230, NULL),
('The Paradise Inn', 121, '2019-03-16', 315, NULL),
('The Paradise Inn', 121, '2019-03-17', 143, NULL),
('The Paradise Inn', 121, '2019-03-18', 344, NULL),
('The Paradise Inn', 121, '2019-03-19', 370, NULL),
('The Paradise Inn', 121, '2019-03-20', 122, NULL),
('The Paradise Inn', 121, '2019-03-21', 181, NULL),
('The Paradise Inn', 121, '2019-03-22', 131, NULL),
('The Paradise Inn', 121, '2019-03-23', 118, NULL),
('The Paradise Inn', 121, '2019-03-24', 108, NULL),
('The Paradise Inn', 121, '2019-03-25', 277, NULL),
('The Paradise Inn', 121, '2019-03-26', 349, NULL),
('The Paradise Inn', 121, '2019-03-27', 264, NULL),
('The Paradise Inn', 121, '2019-03-28', 263, NULL),
('The Paradise Inn', 121, '2019-03-29', 300, NULL),
('The Paradise Inn', 121, '2019-03-30', 392, NULL),
('The Paradise Inn', 121, '2019-03-31', 383, NULL),
('The Paradise Inn', 121, '2019-04-01', 200, NULL),
('The Paradise Inn', 121, '2019-04-02', 390, NULL),
('The Paradise Inn', 121, '2019-04-03', 312, NULL),
('The Paradise Inn', 121, '2019-04-04', 208, NULL),
('The Paradise Inn', 121, '2019-04-05', 137, NULL),
('The Paradise Inn', 121, '2019-04-06', 371, NULL),
('The Paradise Inn', 121, '2019-04-07', 300, NULL),
('The Paradise Inn', 121, '2019-04-08', 228, NULL),
('The Paradise Inn', 121, '2019-04-09', 388, NULL),
('The Paradise Inn', 121, '2019-04-10', 370, NULL),
('The Paradise Inn', 121, '2019-04-11', 260, NULL),
('The Paradise Inn', 121, '2019-04-12', 110, NULL),
('The Paradise Inn', 121, '2019-04-13', 253, NULL),
('The Paradise Inn', 121, '2019-04-14', 292, NULL),
('The Paradise Inn', 121, '2019-04-15', 138, NULL),
('The Paradise Inn', 121, '2019-04-16', 126, NULL),
('The Paradise Inn', 121, '2019-04-17', 202, NULL),
('The Paradise Inn', 121, '2019-04-18', 113, NULL),
('The Paradise Inn', 121, '2019-04-19', 244, NULL),
('The Paradise Inn', 121, '2019-04-20', 185, NULL),
('The Paradise Inn', 121, '2019-04-21', 156, NULL),
('The Paradise Inn', 121, '2019-04-22', 175, NULL),
('The Paradise Inn', 121, '2019-04-23', 270, NULL),
('The Paradise Inn', 121, '2019-04-24', 189, NULL),
('The Paradise Inn', 121, '2019-04-25', 266, NULL),
('The Paradise Inn', 121, '2019-04-26', 251, NULL),
('The Paradise Inn', 121, '2019-04-27', 130, NULL),
('The Paradise Inn', 121, '2019-04-28', 111, NULL),
('The Paradise Inn', 121, '2019-04-29', 380, NULL),
('The Paradise Inn', 121, '2019-04-30', 224, NULL),
('The Paradise Inn', 121, '2019-05-01', 143, NULL),
('The Paradise Inn', 121, '2019-05-02', 203, NULL),
('The Paradise Inn', 121, '2019-05-03', 114, NULL),
('The Paradise Inn', 121, '2019-05-04', 322, NULL),
('The Paradise Inn', 121, '2019-05-05', 222, NULL),
('The Paradise Inn', 121, '2019-05-06', 285, NULL),
('The Paradise Inn', 121, '2019-05-07', 318, NULL),
('The Paradise Inn', 121, '2019-05-08', 306, NULL),
('The Paradise Inn', 121, '2019-05-09', 360, NULL),
('The Paradise Inn', 121, '2019-05-10', 373, NULL),
('The Paradise Inn', 121, '2019-05-11', 360, NULL),
('The Paradise Inn', 121, '2019-05-12', 202, NULL),
('The Paradise Inn', 121, '2019-05-13', 312, NULL),
('The Paradise Inn', 121, '2019-05-14', 248, NULL),
('The Paradise Inn', 121, '2019-05-15', 386, NULL),
('The Paradise Inn', 121, '2019-05-16', 334, NULL),
('The Paradise Inn', 121, '2019-05-17', 292, NULL),
('The Paradise Inn', 121, '2019-05-18', 275, NULL),
('The Paradise Inn', 121, '2019-05-19', 236, NULL),
('The Paradise Inn', 121, '2019-05-20', 118, NULL),
('The Paradise Inn', 121, '2019-05-21', 395, NULL),
('The Paradise Inn', 121, '2019-05-22', 202, NULL),
('The Paradise Inn', 121, '2019-05-23', 321, NULL),
('The Paradise Inn', 121, '2019-05-24', 328, NULL),
('The Paradise Inn', 121, '2019-05-25', 243, NULL),
('The Paradise Inn', 121, '2019-05-26', 184, NULL),
('The Paradise Inn', 121, '2019-05-27', 311, NULL),
('The Paradise Inn', 121, '2019-05-28', 224, NULL),
('The Paradise Inn', 121, '2019-05-29', 297, NULL),
('The Paradise Inn', 121, '2019-05-30', 183, NULL),
('The Paradise Inn', 121, '2019-05-31', 176, NULL),
('The Paradise Inn', 121, '2019-06-01', 162, NULL),
('The Paradise Inn', 121, '2019-06-02', 365, NULL),
('The Paradise Inn', 121, '2019-06-03', 191, NULL),
('The Paradise Inn', 121, '2019-06-04', 317, NULL),
('The Paradise Inn', 121, '2019-06-05', 258, NULL),
('The Paradise Inn', 121, '2019-06-06', 180, NULL),
('The Paradise Inn', 121, '2019-06-07', 322, NULL),
('The Paradise Inn', 121, '2019-06-08', 291, NULL),
('The Paradise Inn', 121, '2019-06-09', 177, NULL),
('The Paradise Inn', 121, '2019-06-10', 208, NULL),
('The Paradise Inn', 121, '2019-06-11', 291, NULL),
('The Paradise Inn', 121, '2019-06-12', 364, NULL),
('The Paradise Inn', 121, '2019-06-13', 329, NULL),
('The Paradise Inn', 121, '2019-06-14', 360, NULL),
('The Paradise Inn', 121, '2019-06-15', 100, NULL),
('The Paradise Inn', 121, '2019-06-16', 172, NULL),
('The Paradise Inn', 121, '2019-06-17', 150, NULL),
('The Paradise Inn', 121, '2019-06-18', 366, NULL),
('The Paradise Inn', 121, '2019-06-19', 299, NULL),
('The Paradise Inn', 121, '2019-06-20', 205, NULL),
('The Paradise Inn', 121, '2019-06-21', 369, NULL),
('The Paradise Inn', 121, '2019-06-22', 375, NULL),
('The Paradise Inn', 121, '2019-06-23', 251, NULL),
('The Paradise Inn', 121, '2019-06-24', 211, NULL),
('The Paradise Inn', 121, '2019-06-25', 283, NULL),
('The Paradise Inn', 121, '2019-06-26', 321, NULL),
('The Paradise Inn', 121, '2019-06-27', 255, NULL),
('The Paradise Inn', 121, '2019-06-28', 377, NULL),
('The Paradise Inn', 121, '2019-06-29', 340, NULL),
('The Paradise Inn', 121, '2019-06-30', 144, NULL),
('The Paradise Inn', 121, '2019-07-01', 190, NULL),
('The Paradise Inn', 121, '2019-07-02', 134, NULL),
('The Paradise Inn', 121, '2019-07-03', 153, NULL),
('The Paradise Inn', 121, '2019-07-04', 294, NULL),
('The Paradise Inn', 121, '2019-07-05', 311, NULL),
('The Paradise Inn', 121, '2019-07-06', 379, NULL),
('The Paradise Inn', 121, '2019-07-07', 238, NULL),
('The Paradise Inn', 121, '2019-07-08', 360, NULL),
('The Paradise Inn', 121, '2019-07-09', 118, NULL),
('The Paradise Inn', 121, '2019-07-10', 313, NULL),
('The Paradise Inn', 121, '2019-07-11', 105, NULL),
('The Paradise Inn', 121, '2019-07-12', 210, NULL),
('The Paradise Inn', 121, '2019-07-13', 229, NULL),
('The Paradise Inn', 121, '2019-07-14', 124, NULL),
('The Paradise Inn', 121, '2019-07-15', 363, NULL),
('The Paradise Inn', 121, '2019-07-16', 126, NULL),
('The Paradise Inn', 121, '2019-07-17', 192, NULL),
('The Paradise Inn', 121, '2019-07-18', 293, NULL),
('The Paradise Inn', 121, '2019-07-19', 311, NULL),
('The Paradise Inn', 121, '2019-07-20', 166, NULL),
('The Paradise Inn', 121, '2019-07-21', 270, NULL),
('The Paradise Inn', 121, '2019-07-22', 140, NULL),
('The Paradise Inn', 121, '2019-07-23', 278, NULL),
('The Paradise Inn', 121, '2019-07-24', 252, NULL),
('The Paradise Inn', 121, '2019-07-25', 206, NULL),
('The Paradise Inn', 121, '2019-07-26', 299, NULL),
('The Paradise Inn', 121, '2019-07-27', 274, NULL),
('The Paradise Inn', 121, '2019-07-28', 310, NULL),
('The Paradise Inn', 121, '2019-07-29', 226, NULL),
('The Paradise Inn', 121, '2019-07-30', 236, NULL),
('The Paradise Inn', 121, '2019-07-31', 213, NULL),
('The Paradise Inn', 121, '2019-08-01', 381, NULL),
('The Paradise Inn', 121, '2019-08-02', 259, NULL),
('The Paradise Inn', 121, '2019-08-03', 208, NULL),
('The Paradise Inn', 121, '2019-08-04', 193, NULL),
('The Paradise Inn', 121, '2019-08-05', 242, NULL),
('The Paradise Inn', 121, '2019-08-06', 148, NULL),
('The Paradise Inn', 121, '2019-08-07', 258, NULL),
('The Paradise Inn', 121, '2019-08-08', 265, NULL),
('The Paradise Inn', 121, '2019-08-09', 317, NULL),
('The Paradise Inn', 121, '2019-08-10', 122, NULL),
('The Paradise Inn', 121, '2019-08-11', 163, NULL),
('The Paradise Inn', 121, '2019-08-12', 189, NULL),
('The Paradise Inn', 121, '2019-08-13', 311, NULL),
('The Paradise Inn', 121, '2019-08-14', 335, NULL),
('The Paradise Inn', 121, '2019-08-15', 223, NULL),
('The Paradise Inn', 121, '2019-08-16', 163, NULL),
('The Paradise Inn', 121, '2019-08-17', 253, NULL),
('The Paradise Inn', 121, '2019-08-18', 388, NULL),
('The Paradise Inn', 121, '2019-08-19', 153, NULL),
('The Paradise Inn', 121, '2019-08-20', 250, NULL),
('The Paradise Inn', 121, '2019-08-21', 378, NULL),
('The Paradise Inn', 121, '2019-08-22', 131, NULL),
('The Paradise Inn', 121, '2019-08-23', 370, NULL),
('The Paradise Inn', 121, '2019-08-24', 284, NULL),
('The Paradise Inn', 121, '2019-08-25', 181, NULL),
('The Paradise Inn', 121, '2019-08-26', 287, NULL),
('The Paradise Inn', 121, '2019-08-27', 328, NULL),
('The Paradise Inn', 121, '2019-08-28', 203, NULL),
('The Paradise Inn', 121, '2019-08-29', 259, NULL),
('The Paradise Inn', 121, '2019-08-30', 305, NULL),
('The Paradise Inn', 121, '2019-08-31', 130, NULL),
('The Paradise Inn', 121, '2019-09-01', 129, NULL),
('The Paradise Inn', 121, '2019-09-02', 260, NULL),
('The Paradise Inn', 121, '2019-09-03', 272, NULL),
('The Paradise Inn', 121, '2019-09-04', 127, NULL),
('The Paradise Inn', 121, '2019-09-05', 121, NULL),
('The Paradise Inn', 121, '2019-09-06', 244, NULL),
('The Paradise Inn', 121, '2019-09-07', 277, NULL),
('The Paradise Inn', 121, '2019-09-08', 205, NULL),
('The Paradise Inn', 121, '2019-09-09', 143, NULL),
('The Paradise Inn', 121, '2019-09-10', 107, NULL),
('The Paradise Inn', 121, '2019-09-11', 340, NULL),
('The Paradise Inn', 121, '2019-09-12', 242, NULL),
('The Paradise Inn', 121, '2019-09-13', 136, NULL),
('The Paradise Inn', 121, '2019-09-14', 324, NULL),
('The Paradise Inn', 121, '2019-09-15', 321, NULL),
('The Paradise Inn', 121, '2019-09-16', 352, NULL),
('The Paradise Inn', 121, '2019-09-17', 242, NULL),
('The Paradise Inn', 121, '2019-09-18', 169, NULL),
('The Paradise Inn', 121, '2019-09-19', 175, NULL),
('The Paradise Inn', 121, '2019-09-20', 393, NULL),
('The Paradise Inn', 121, '2019-09-21', 173, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 121, '2019-09-22', 108, NULL),
('The Paradise Inn', 121, '2019-09-23', 396, NULL),
('The Paradise Inn', 121, '2019-09-24', 282, NULL),
('The Paradise Inn', 121, '2019-09-25', 234, NULL),
('The Paradise Inn', 121, '2019-09-26', 381, NULL),
('The Paradise Inn', 121, '2019-09-27', 245, NULL),
('The Paradise Inn', 121, '2019-09-28', 260, NULL),
('The Paradise Inn', 121, '2019-09-29', 286, NULL),
('The Paradise Inn', 121, '2019-09-30', 248, NULL),
('The Paradise Inn', 121, '2019-10-01', 257, NULL),
('The Paradise Inn', 121, '2019-10-02', 371, NULL),
('The Paradise Inn', 121, '2019-10-03', 191, NULL),
('The Paradise Inn', 121, '2019-10-04', 254, NULL),
('The Paradise Inn', 121, '2019-10-05', 269, NULL),
('The Paradise Inn', 121, '2019-10-06', 347, NULL),
('The Paradise Inn', 121, '2019-10-07', 390, NULL),
('The Paradise Inn', 121, '2019-10-08', 100, NULL),
('The Paradise Inn', 121, '2019-10-09', 241, NULL),
('The Paradise Inn', 121, '2019-10-10', 191, NULL),
('The Paradise Inn', 121, '2019-10-11', 149, NULL),
('The Paradise Inn', 121, '2019-10-12', 144, NULL),
('The Paradise Inn', 121, '2019-10-13', 186, NULL),
('The Paradise Inn', 121, '2019-10-14', 180, NULL),
('The Paradise Inn', 121, '2019-10-15', 289, NULL),
('The Paradise Inn', 121, '2019-10-16', 112, NULL),
('The Paradise Inn', 121, '2019-10-17', 205, NULL),
('The Paradise Inn', 121, '2019-10-18', 389, NULL),
('The Paradise Inn', 121, '2019-10-19', 110, NULL),
('The Paradise Inn', 121, '2019-10-20', 225, NULL),
('The Paradise Inn', 121, '2019-10-21', 399, NULL),
('The Paradise Inn', 121, '2019-10-22', 214, NULL),
('The Paradise Inn', 121, '2019-10-23', 330, NULL),
('The Paradise Inn', 121, '2019-10-24', 334, NULL),
('The Paradise Inn', 121, '2019-10-25', 215, NULL),
('The Paradise Inn', 121, '2019-10-26', 284, NULL),
('The Paradise Inn', 121, '2019-10-27', 341, NULL),
('The Paradise Inn', 121, '2019-10-28', 328, NULL),
('The Paradise Inn', 121, '2019-10-29', 178, NULL),
('The Paradise Inn', 121, '2019-10-30', 382, NULL),
('The Paradise Inn', 121, '2019-10-31', 326, NULL),
('The Paradise Inn', 121, '2019-11-01', 371, NULL),
('The Paradise Inn', 121, '2019-11-02', 173, NULL),
('The Paradise Inn', 121, '2019-11-03', 381, NULL),
('The Paradise Inn', 121, '2019-11-04', 227, NULL),
('The Paradise Inn', 121, '2019-11-05', 316, NULL),
('The Paradise Inn', 121, '2019-11-06', 296, NULL),
('The Paradise Inn', 121, '2019-11-07', 272, NULL),
('The Paradise Inn', 121, '2019-11-08', 238, NULL),
('The Paradise Inn', 121, '2019-11-09', 270, NULL),
('The Paradise Inn', 121, '2019-11-10', 240, NULL),
('The Paradise Inn', 121, '2019-11-11', 252, NULL),
('The Paradise Inn', 121, '2019-11-12', 199, NULL),
('The Paradise Inn', 121, '2019-11-13', 204, NULL),
('The Paradise Inn', 121, '2019-11-14', 185, NULL),
('The Paradise Inn', 121, '2019-11-15', 280, NULL),
('The Paradise Inn', 121, '2019-11-16', 237, NULL),
('The Paradise Inn', 121, '2019-11-17', 352, NULL),
('The Paradise Inn', 121, '2019-11-18', 208, NULL),
('The Paradise Inn', 121, '2019-11-19', 230, NULL),
('The Paradise Inn', 121, '2019-11-20', 148, NULL),
('The Paradise Inn', 121, '2019-11-21', 192, NULL),
('The Paradise Inn', 121, '2019-11-22', 114, NULL),
('The Paradise Inn', 121, '2019-11-23', 283, NULL),
('The Paradise Inn', 121, '2019-11-24', 227, NULL),
('The Paradise Inn', 121, '2019-11-25', 262, NULL),
('The Paradise Inn', 121, '2019-11-26', 155, NULL),
('The Paradise Inn', 121, '2019-11-27', 239, NULL),
('The Paradise Inn', 121, '2019-11-28', 178, NULL),
('The Paradise Inn', 121, '2019-11-29', 373, NULL),
('The Paradise Inn', 121, '2019-11-30', 206, NULL),
('The Paradise Inn', 121, '2019-12-01', 212, NULL),
('The Paradise Inn', 121, '2019-12-02', 366, NULL),
('The Paradise Inn', 121, '2019-12-03', 222, NULL),
('The Paradise Inn', 121, '2019-12-04', 154, NULL),
('The Paradise Inn', 121, '2019-12-05', 263, NULL),
('The Paradise Inn', 121, '2019-12-06', 109, NULL),
('The Paradise Inn', 121, '2019-12-07', 389, NULL),
('The Paradise Inn', 121, '2019-12-08', 117, NULL),
('The Paradise Inn', 121, '2019-12-09', 278, NULL),
('The Paradise Inn', 121, '2019-12-10', 227, NULL),
('The Paradise Inn', 121, '2019-12-11', 251, NULL),
('The Paradise Inn', 121, '2019-12-12', 186, NULL),
('The Paradise Inn', 121, '2019-12-13', 210, NULL),
('The Paradise Inn', 121, '2019-12-14', 248, NULL),
('The Paradise Inn', 121, '2019-12-15', 318, NULL),
('The Paradise Inn', 121, '2019-12-16', 153, NULL),
('The Paradise Inn', 121, '2019-12-17', 178, NULL),
('The Paradise Inn', 121, '2019-12-18', 378, NULL),
('The Paradise Inn', 121, '2019-12-19', 304, NULL),
('The Paradise Inn', 121, '2019-12-20', 294, NULL),
('The Paradise Inn', 121, '2019-12-21', 128, NULL),
('The Paradise Inn', 121, '2019-12-22', 186, NULL),
('The Paradise Inn', 121, '2019-12-23', 177, NULL),
('The Paradise Inn', 121, '2019-12-24', 158, NULL),
('The Paradise Inn', 121, '2019-12-25', 313, NULL),
('The Paradise Inn', 121, '2019-12-26', 348, NULL),
('The Paradise Inn', 121, '2019-12-27', 221, NULL),
('The Paradise Inn', 121, '2019-12-28', 242, NULL),
('The Paradise Inn', 121, '2019-12-29', 250, NULL),
('The Paradise Inn', 121, '2019-12-30', 374, NULL),
('The Paradise Inn', 121, '2019-12-31', 157, NULL),
('The Paradise Inn', 121, '2020-01-01', 101, NULL),
('The Paradise Inn', 121, '2020-01-02', 309, NULL),
('The Paradise Inn', 121, '2020-01-03', 346, NULL),
('The Paradise Inn', 121, '2020-01-04', 166, NULL),
('The Paradise Inn', 121, '2020-01-05', 310, NULL),
('The Paradise Inn', 121, '2020-01-06', 293, NULL),
('The Paradise Inn', 121, '2020-01-07', 232, NULL),
('The Paradise Inn', 121, '2020-01-08', 198, NULL),
('The Paradise Inn', 121, '2020-01-09', 286, NULL),
('The Paradise Inn', 121, '2020-01-10', 123, NULL),
('The Paradise Inn', 121, '2020-01-11', 153, NULL),
('The Paradise Inn', 121, '2020-01-12', 293, NULL),
('The Paradise Inn', 121, '2020-01-13', 211, NULL),
('The Paradise Inn', 121, '2020-01-14', 340, NULL),
('The Paradise Inn', 121, '2020-01-15', 168, NULL),
('The Paradise Inn', 121, '2020-01-16', 257, NULL),
('The Paradise Inn', 121, '2020-01-17', 268, NULL),
('The Paradise Inn', 121, '2020-01-18', 245, NULL),
('The Paradise Inn', 121, '2020-01-19', 348, NULL),
('The Paradise Inn', 121, '2020-01-20', 277, NULL),
('The Paradise Inn', 121, '2020-01-21', 144, NULL),
('The Paradise Inn', 121, '2020-01-22', 279, NULL),
('The Paradise Inn', 121, '2020-01-23', 302, NULL),
('The Paradise Inn', 121, '2020-01-24', 372, NULL),
('The Paradise Inn', 121, '2020-01-25', 124, NULL),
('The Paradise Inn', 121, '2020-01-26', 164, NULL),
('The Paradise Inn', 121, '2020-01-27', 297, NULL),
('The Paradise Inn', 121, '2020-01-28', 308, NULL),
('The Paradise Inn', 121, '2020-01-29', 343, NULL),
('The Paradise Inn', 121, '2020-01-30', 321, NULL),
('The Paradise Inn', 121, '2020-01-31', 181, NULL),
('The Paradise Inn', 121, '2020-02-01', 367, NULL),
('The Paradise Inn', 121, '2020-02-02', 157, NULL),
('The Paradise Inn', 121, '2020-02-03', 229, NULL),
('The Paradise Inn', 121, '2020-02-04', 235, NULL),
('The Paradise Inn', 125, '2019-01-01', 278, NULL),
('The Paradise Inn', 125, '2019-01-02', 140, NULL),
('The Paradise Inn', 125, '2019-01-03', 389, NULL),
('The Paradise Inn', 125, '2019-01-04', 366, NULL),
('The Paradise Inn', 125, '2019-01-05', 258, NULL),
('The Paradise Inn', 125, '2019-01-06', 353, NULL),
('The Paradise Inn', 125, '2019-01-07', 347, NULL),
('The Paradise Inn', 125, '2019-01-08', 237, NULL),
('The Paradise Inn', 125, '2019-01-09', 201, NULL),
('The Paradise Inn', 125, '2019-01-10', 333, NULL),
('The Paradise Inn', 125, '2019-01-11', 268, NULL),
('The Paradise Inn', 125, '2019-01-12', 294, NULL),
('The Paradise Inn', 125, '2019-01-13', 100, NULL),
('The Paradise Inn', 125, '2019-01-14', 396, NULL),
('The Paradise Inn', 125, '2019-01-15', 265, NULL),
('The Paradise Inn', 125, '2019-01-16', 307, NULL),
('The Paradise Inn', 125, '2019-01-17', 235, NULL),
('The Paradise Inn', 125, '2019-01-18', 332, NULL),
('The Paradise Inn', 125, '2019-01-19', 287, NULL),
('The Paradise Inn', 125, '2019-01-20', 110, NULL),
('The Paradise Inn', 125, '2019-01-21', 178, NULL),
('The Paradise Inn', 125, '2019-01-22', 135, NULL),
('The Paradise Inn', 125, '2019-01-23', 173, NULL),
('The Paradise Inn', 125, '2019-01-24', 152, NULL),
('The Paradise Inn', 125, '2019-01-25', 232, NULL),
('The Paradise Inn', 125, '2019-01-26', 333, NULL),
('The Paradise Inn', 125, '2019-01-27', 191, NULL),
('The Paradise Inn', 125, '2019-01-28', 111, NULL),
('The Paradise Inn', 125, '2019-01-29', 216, NULL),
('The Paradise Inn', 125, '2019-01-30', 320, NULL),
('The Paradise Inn', 125, '2019-01-31', 284, NULL),
('The Paradise Inn', 125, '2019-02-01', 227, NULL),
('The Paradise Inn', 125, '2019-02-02', 276, NULL),
('The Paradise Inn', 125, '2019-02-03', 208, NULL),
('The Paradise Inn', 125, '2019-02-04', 142, NULL),
('The Paradise Inn', 125, '2019-02-05', 105, NULL),
('The Paradise Inn', 125, '2019-02-06', 321, NULL),
('The Paradise Inn', 125, '2019-02-07', 371, NULL),
('The Paradise Inn', 125, '2019-02-08', 121, NULL),
('The Paradise Inn', 125, '2019-02-09', 349, NULL),
('The Paradise Inn', 125, '2019-02-10', 345, NULL),
('The Paradise Inn', 125, '2019-02-11', 344, NULL),
('The Paradise Inn', 125, '2019-02-12', 206, NULL),
('The Paradise Inn', 125, '2019-02-13', 130, NULL),
('The Paradise Inn', 125, '2019-02-14', 108, NULL),
('The Paradise Inn', 125, '2019-02-15', 217, NULL),
('The Paradise Inn', 125, '2019-02-16', 209, NULL),
('The Paradise Inn', 125, '2019-02-17', 148, NULL),
('The Paradise Inn', 125, '2019-02-18', 246, NULL),
('The Paradise Inn', 125, '2019-02-19', 209, NULL),
('The Paradise Inn', 125, '2019-02-20', 341, NULL),
('The Paradise Inn', 125, '2019-02-21', 128, NULL),
('The Paradise Inn', 125, '2019-02-22', 395, NULL),
('The Paradise Inn', 125, '2019-02-23', 308, NULL),
('The Paradise Inn', 125, '2019-02-24', 187, NULL),
('The Paradise Inn', 125, '2019-02-25', 114, NULL),
('The Paradise Inn', 125, '2019-02-26', 202, NULL),
('The Paradise Inn', 125, '2019-02-27', 287, NULL),
('The Paradise Inn', 125, '2019-02-28', 125, NULL),
('The Paradise Inn', 125, '2019-03-01', 138, NULL),
('The Paradise Inn', 125, '2019-03-02', 248, NULL),
('The Paradise Inn', 125, '2019-03-03', 172, NULL),
('The Paradise Inn', 125, '2019-03-04', 329, NULL),
('The Paradise Inn', 125, '2019-03-05', 315, NULL),
('The Paradise Inn', 125, '2019-03-06', 229, NULL),
('The Paradise Inn', 125, '2019-03-07', 349, NULL),
('The Paradise Inn', 125, '2019-03-08', 160, NULL),
('The Paradise Inn', 125, '2019-03-09', 226, NULL),
('The Paradise Inn', 125, '2019-03-10', 337, NULL),
('The Paradise Inn', 125, '2019-03-11', 392, NULL),
('The Paradise Inn', 125, '2019-03-12', 306, NULL),
('The Paradise Inn', 125, '2019-03-13', 158, NULL),
('The Paradise Inn', 125, '2019-03-14', 190, NULL),
('The Paradise Inn', 125, '2019-03-15', 286, NULL),
('The Paradise Inn', 125, '2019-03-16', 287, NULL),
('The Paradise Inn', 125, '2019-03-17', 245, NULL),
('The Paradise Inn', 125, '2019-03-18', 380, NULL),
('The Paradise Inn', 125, '2019-03-19', 170, NULL),
('The Paradise Inn', 125, '2019-03-20', 111, NULL),
('The Paradise Inn', 125, '2019-03-21', 106, NULL),
('The Paradise Inn', 125, '2019-03-22', 166, NULL),
('The Paradise Inn', 125, '2019-03-23', 165, NULL),
('The Paradise Inn', 125, '2019-03-24', 388, NULL),
('The Paradise Inn', 125, '2019-03-25', 323, NULL),
('The Paradise Inn', 125, '2019-03-26', 176, NULL),
('The Paradise Inn', 125, '2019-03-27', 194, NULL),
('The Paradise Inn', 125, '2019-03-28', 231, NULL),
('The Paradise Inn', 125, '2019-03-29', 317, NULL),
('The Paradise Inn', 125, '2019-03-30', 102, NULL),
('The Paradise Inn', 125, '2019-03-31', 286, NULL),
('The Paradise Inn', 125, '2019-04-01', 310, NULL),
('The Paradise Inn', 125, '2019-04-02', 314, NULL),
('The Paradise Inn', 125, '2019-04-03', 136, NULL),
('The Paradise Inn', 125, '2019-04-04', 206, NULL),
('The Paradise Inn', 125, '2019-04-05', 221, NULL),
('The Paradise Inn', 125, '2019-04-06', 325, NULL),
('The Paradise Inn', 125, '2019-04-07', 290, NULL),
('The Paradise Inn', 125, '2019-04-08', 160, NULL),
('The Paradise Inn', 125, '2019-04-09', 296, NULL),
('The Paradise Inn', 125, '2019-04-10', 116, NULL),
('The Paradise Inn', 125, '2019-04-11', 305, NULL),
('The Paradise Inn', 125, '2019-04-12', 197, NULL),
('The Paradise Inn', 125, '2019-04-13', 380, NULL),
('The Paradise Inn', 125, '2019-04-14', 356, NULL),
('The Paradise Inn', 125, '2019-04-15', 228, NULL),
('The Paradise Inn', 125, '2019-04-16', 269, NULL),
('The Paradise Inn', 125, '2019-04-17', 231, NULL),
('The Paradise Inn', 125, '2019-04-18', 308, NULL),
('The Paradise Inn', 125, '2019-04-19', 115, NULL),
('The Paradise Inn', 125, '2019-04-20', 188, NULL),
('The Paradise Inn', 125, '2019-04-21', 113, NULL),
('The Paradise Inn', 125, '2019-04-22', 318, NULL),
('The Paradise Inn', 125, '2019-04-23', 134, NULL),
('The Paradise Inn', 125, '2019-04-24', 239, NULL),
('The Paradise Inn', 125, '2019-04-25', 126, NULL),
('The Paradise Inn', 125, '2019-04-26', 144, NULL),
('The Paradise Inn', 125, '2019-04-27', 268, NULL),
('The Paradise Inn', 125, '2019-04-28', 165, NULL),
('The Paradise Inn', 125, '2019-04-29', 118, NULL),
('The Paradise Inn', 125, '2019-04-30', 106, NULL),
('The Paradise Inn', 125, '2019-05-01', 390, NULL),
('The Paradise Inn', 125, '2019-05-02', 305, NULL),
('The Paradise Inn', 125, '2019-05-03', 259, NULL),
('The Paradise Inn', 125, '2019-05-04', 323, NULL),
('The Paradise Inn', 125, '2019-05-05', 226, NULL),
('The Paradise Inn', 125, '2019-05-06', 142, NULL),
('The Paradise Inn', 125, '2019-05-07', 395, NULL),
('The Paradise Inn', 125, '2019-05-08', 234, NULL),
('The Paradise Inn', 125, '2019-05-09', 310, NULL),
('The Paradise Inn', 125, '2019-05-10', 149, NULL),
('The Paradise Inn', 125, '2019-05-11', 282, NULL),
('The Paradise Inn', 125, '2019-05-12', 172, NULL),
('The Paradise Inn', 125, '2019-05-13', 365, NULL),
('The Paradise Inn', 125, '2019-05-14', 265, NULL),
('The Paradise Inn', 125, '2019-05-15', 317, NULL),
('The Paradise Inn', 125, '2019-05-16', 242, NULL),
('The Paradise Inn', 125, '2019-05-17', 358, NULL),
('The Paradise Inn', 125, '2019-05-18', 336, NULL),
('The Paradise Inn', 125, '2019-05-19', 282, NULL),
('The Paradise Inn', 125, '2019-05-20', 195, NULL),
('The Paradise Inn', 125, '2019-05-21', 251, NULL),
('The Paradise Inn', 125, '2019-05-22', 341, NULL),
('The Paradise Inn', 125, '2019-05-23', 228, NULL),
('The Paradise Inn', 125, '2019-05-24', 333, NULL),
('The Paradise Inn', 125, '2019-05-25', 380, NULL),
('The Paradise Inn', 125, '2019-05-26', 287, NULL),
('The Paradise Inn', 125, '2019-05-27', 262, NULL),
('The Paradise Inn', 125, '2019-05-28', 266, NULL),
('The Paradise Inn', 125, '2019-05-29', 392, NULL),
('The Paradise Inn', 125, '2019-05-30', 300, NULL),
('The Paradise Inn', 125, '2019-05-31', 363, NULL),
('The Paradise Inn', 125, '2019-06-01', 280, NULL),
('The Paradise Inn', 125, '2019-06-02', 260, NULL),
('The Paradise Inn', 125, '2019-06-03', 137, NULL),
('The Paradise Inn', 125, '2019-06-04', 221, NULL),
('The Paradise Inn', 125, '2019-06-05', 131, NULL),
('The Paradise Inn', 125, '2019-06-06', 382, NULL),
('The Paradise Inn', 125, '2019-06-07', 255, NULL),
('The Paradise Inn', 125, '2019-06-08', 214, NULL),
('The Paradise Inn', 125, '2019-06-09', 161, NULL),
('The Paradise Inn', 125, '2019-06-10', 332, NULL),
('The Paradise Inn', 125, '2019-06-11', 252, NULL),
('The Paradise Inn', 125, '2019-06-12', 305, NULL),
('The Paradise Inn', 125, '2019-06-13', 200, NULL),
('The Paradise Inn', 125, '2019-06-14', 251, NULL),
('The Paradise Inn', 125, '2019-06-15', 231, NULL),
('The Paradise Inn', 125, '2019-06-16', 222, NULL),
('The Paradise Inn', 125, '2019-06-17', 242, NULL),
('The Paradise Inn', 125, '2019-06-18', 228, NULL),
('The Paradise Inn', 125, '2019-06-19', 388, NULL),
('The Paradise Inn', 125, '2019-06-20', 320, NULL),
('The Paradise Inn', 125, '2019-06-21', 249, NULL),
('The Paradise Inn', 125, '2019-06-22', 240, NULL),
('The Paradise Inn', 125, '2019-06-23', 143, NULL),
('The Paradise Inn', 125, '2019-06-24', 376, NULL),
('The Paradise Inn', 125, '2019-06-25', 376, NULL),
('The Paradise Inn', 125, '2019-06-26', 365, NULL),
('The Paradise Inn', 125, '2019-06-27', 394, NULL),
('The Paradise Inn', 125, '2019-06-28', 109, NULL),
('The Paradise Inn', 125, '2019-06-29', 148, NULL),
('The Paradise Inn', 125, '2019-06-30', 216, NULL),
('The Paradise Inn', 125, '2019-07-01', 111, NULL),
('The Paradise Inn', 125, '2019-07-02', 264, NULL),
('The Paradise Inn', 125, '2019-07-03', 193, NULL),
('The Paradise Inn', 125, '2019-07-04', 239, NULL),
('The Paradise Inn', 125, '2019-07-05', 103, NULL),
('The Paradise Inn', 125, '2019-07-06', 280, NULL),
('The Paradise Inn', 125, '2019-07-07', 338, NULL),
('The Paradise Inn', 125, '2019-07-08', 224, NULL),
('The Paradise Inn', 125, '2019-07-09', 332, NULL),
('The Paradise Inn', 125, '2019-07-10', 106, NULL),
('The Paradise Inn', 125, '2019-07-11', 164, NULL),
('The Paradise Inn', 125, '2019-07-12', 280, NULL),
('The Paradise Inn', 125, '2019-07-13', 379, NULL),
('The Paradise Inn', 125, '2019-07-14', 215, NULL),
('The Paradise Inn', 125, '2019-07-15', 131, NULL),
('The Paradise Inn', 125, '2019-07-16', 348, NULL),
('The Paradise Inn', 125, '2019-07-17', 166, NULL),
('The Paradise Inn', 125, '2019-07-18', 168, NULL),
('The Paradise Inn', 125, '2019-07-19', 242, NULL),
('The Paradise Inn', 125, '2019-07-20', 336, NULL),
('The Paradise Inn', 125, '2019-07-21', 180, NULL),
('The Paradise Inn', 125, '2019-07-22', 381, NULL),
('The Paradise Inn', 125, '2019-07-23', 366, NULL),
('The Paradise Inn', 125, '2019-07-24', 339, NULL),
('The Paradise Inn', 125, '2019-07-25', 329, NULL),
('The Paradise Inn', 125, '2019-07-26', 187, NULL),
('The Paradise Inn', 125, '2019-07-27', 230, NULL),
('The Paradise Inn', 125, '2019-07-28', 265, NULL),
('The Paradise Inn', 125, '2019-07-29', 375, NULL),
('The Paradise Inn', 125, '2019-07-30', 294, NULL),
('The Paradise Inn', 125, '2019-07-31', 188, NULL),
('The Paradise Inn', 125, '2019-08-01', 228, NULL),
('The Paradise Inn', 125, '2019-08-02', 157, NULL),
('The Paradise Inn', 125, '2019-08-03', 173, NULL),
('The Paradise Inn', 125, '2019-08-04', 340, NULL),
('The Paradise Inn', 125, '2019-08-05', 391, NULL),
('The Paradise Inn', 125, '2019-08-06', 121, NULL),
('The Paradise Inn', 125, '2019-08-07', 358, NULL),
('The Paradise Inn', 125, '2019-08-08', 308, NULL),
('The Paradise Inn', 125, '2019-08-09', 175, NULL),
('The Paradise Inn', 125, '2019-08-10', 211, NULL),
('The Paradise Inn', 125, '2019-08-11', 364, NULL),
('The Paradise Inn', 125, '2019-08-12', 306, NULL),
('The Paradise Inn', 125, '2019-08-13', 366, NULL),
('The Paradise Inn', 125, '2019-08-14', 237, NULL),
('The Paradise Inn', 125, '2019-08-15', 273, NULL),
('The Paradise Inn', 125, '2019-08-16', 370, NULL),
('The Paradise Inn', 125, '2019-08-17', 306, NULL),
('The Paradise Inn', 125, '2019-08-18', 387, NULL),
('The Paradise Inn', 125, '2019-08-19', 391, NULL),
('The Paradise Inn', 125, '2019-08-20', 325, NULL),
('The Paradise Inn', 125, '2019-08-21', 239, NULL),
('The Paradise Inn', 125, '2019-08-22', 154, NULL),
('The Paradise Inn', 125, '2019-08-23', 274, NULL),
('The Paradise Inn', 125, '2019-08-24', 305, NULL),
('The Paradise Inn', 125, '2019-08-25', 348, NULL),
('The Paradise Inn', 125, '2019-08-26', 206, NULL),
('The Paradise Inn', 125, '2019-08-27', 243, NULL),
('The Paradise Inn', 125, '2019-08-28', 287, NULL),
('The Paradise Inn', 125, '2019-08-29', 181, NULL),
('The Paradise Inn', 125, '2019-08-30', 376, NULL),
('The Paradise Inn', 125, '2019-08-31', 252, NULL),
('The Paradise Inn', 125, '2019-09-01', 348, NULL),
('The Paradise Inn', 125, '2019-09-02', 201, NULL),
('The Paradise Inn', 125, '2019-09-03', 319, NULL),
('The Paradise Inn', 125, '2019-09-04', 323, NULL),
('The Paradise Inn', 125, '2019-09-05', 200, NULL),
('The Paradise Inn', 125, '2019-09-06', 394, NULL),
('The Paradise Inn', 125, '2019-09-07', 181, NULL),
('The Paradise Inn', 125, '2019-09-08', 250, NULL),
('The Paradise Inn', 125, '2019-09-09', 193, NULL),
('The Paradise Inn', 125, '2019-09-10', 318, NULL),
('The Paradise Inn', 125, '2019-09-11', 320, NULL),
('The Paradise Inn', 125, '2019-09-12', 292, NULL),
('The Paradise Inn', 125, '2019-09-13', 387, NULL),
('The Paradise Inn', 125, '2019-09-14', 260, NULL),
('The Paradise Inn', 125, '2019-09-15', 376, NULL),
('The Paradise Inn', 125, '2019-09-16', 240, NULL),
('The Paradise Inn', 125, '2019-09-17', 275, NULL),
('The Paradise Inn', 125, '2019-09-18', 150, NULL),
('The Paradise Inn', 125, '2019-09-19', 320, NULL),
('The Paradise Inn', 125, '2019-09-20', 389, NULL),
('The Paradise Inn', 125, '2019-09-21', 227, NULL),
('The Paradise Inn', 125, '2019-09-22', 225, NULL),
('The Paradise Inn', 125, '2019-09-23', 383, NULL),
('The Paradise Inn', 125, '2019-09-24', 200, NULL),
('The Paradise Inn', 125, '2019-09-25', 334, NULL),
('The Paradise Inn', 125, '2019-09-26', 219, NULL),
('The Paradise Inn', 125, '2019-09-27', 374, NULL),
('The Paradise Inn', 125, '2019-09-28', 256, NULL),
('The Paradise Inn', 125, '2019-09-29', 174, NULL),
('The Paradise Inn', 125, '2019-09-30', 309, NULL),
('The Paradise Inn', 125, '2019-10-01', 309, NULL),
('The Paradise Inn', 125, '2019-10-02', 150, NULL),
('The Paradise Inn', 125, '2019-10-03', 211, NULL),
('The Paradise Inn', 125, '2019-10-04', 174, NULL),
('The Paradise Inn', 125, '2019-10-05', 234, NULL),
('The Paradise Inn', 125, '2019-10-06', 353, NULL),
('The Paradise Inn', 125, '2019-10-07', 369, NULL),
('The Paradise Inn', 125, '2019-10-08', 131, NULL),
('The Paradise Inn', 125, '2019-10-09', 336, NULL),
('The Paradise Inn', 125, '2019-10-10', 199, NULL),
('The Paradise Inn', 125, '2019-10-11', 206, NULL),
('The Paradise Inn', 125, '2019-10-12', 382, NULL),
('The Paradise Inn', 125, '2019-10-13', 218, NULL),
('The Paradise Inn', 125, '2019-10-14', 351, NULL),
('The Paradise Inn', 125, '2019-10-15', 291, NULL),
('The Paradise Inn', 125, '2019-10-16', 351, NULL),
('The Paradise Inn', 125, '2019-10-17', 167, NULL),
('The Paradise Inn', 125, '2019-10-18', 105, NULL),
('The Paradise Inn', 125, '2019-10-19', 227, NULL),
('The Paradise Inn', 125, '2019-10-20', 374, NULL),
('The Paradise Inn', 125, '2019-10-21', 261, NULL),
('The Paradise Inn', 125, '2019-10-22', 165, NULL),
('The Paradise Inn', 125, '2019-10-23', 217, NULL),
('The Paradise Inn', 125, '2019-10-24', 218, NULL),
('The Paradise Inn', 125, '2019-10-25', 292, NULL),
('The Paradise Inn', 125, '2019-10-26', 109, NULL),
('The Paradise Inn', 125, '2019-10-27', 168, NULL),
('The Paradise Inn', 125, '2019-10-28', 331, NULL),
('The Paradise Inn', 125, '2019-10-29', 283, NULL),
('The Paradise Inn', 125, '2019-10-30', 233, NULL),
('The Paradise Inn', 125, '2019-10-31', 377, NULL),
('The Paradise Inn', 125, '2019-11-01', 209, NULL),
('The Paradise Inn', 125, '2019-11-02', 176, NULL),
('The Paradise Inn', 125, '2019-11-03', 164, NULL),
('The Paradise Inn', 125, '2019-11-04', 179, NULL),
('The Paradise Inn', 125, '2019-11-05', 132, NULL),
('The Paradise Inn', 125, '2019-11-06', 157, NULL),
('The Paradise Inn', 125, '2019-11-07', 284, NULL),
('The Paradise Inn', 125, '2019-11-08', 102, NULL),
('The Paradise Inn', 125, '2019-11-09', 167, NULL),
('The Paradise Inn', 125, '2019-11-10', 396, NULL),
('The Paradise Inn', 125, '2019-11-11', 266, NULL),
('The Paradise Inn', 125, '2019-11-12', 375, NULL),
('The Paradise Inn', 125, '2019-11-13', 127, NULL),
('The Paradise Inn', 125, '2019-11-14', 186, NULL),
('The Paradise Inn', 125, '2019-11-15', 337, NULL),
('The Paradise Inn', 125, '2019-11-16', 190, NULL),
('The Paradise Inn', 125, '2019-11-17', 291, NULL),
('The Paradise Inn', 125, '2019-11-18', 247, NULL),
('The Paradise Inn', 125, '2019-11-19', 209, NULL),
('The Paradise Inn', 125, '2019-11-20', 273, NULL),
('The Paradise Inn', 125, '2019-11-21', 229, NULL),
('The Paradise Inn', 125, '2019-11-22', 331, NULL),
('The Paradise Inn', 125, '2019-11-23', 254, NULL),
('The Paradise Inn', 125, '2019-11-24', 256, NULL),
('The Paradise Inn', 125, '2019-11-25', 346, NULL),
('The Paradise Inn', 125, '2019-11-26', 251, NULL),
('The Paradise Inn', 125, '2019-11-27', 289, NULL),
('The Paradise Inn', 125, '2019-11-28', 376, NULL),
('The Paradise Inn', 125, '2019-11-29', 377, NULL),
('The Paradise Inn', 125, '2019-11-30', 136, NULL),
('The Paradise Inn', 125, '2019-12-01', 237, NULL),
('The Paradise Inn', 125, '2019-12-02', 245, NULL),
('The Paradise Inn', 125, '2019-12-03', 220, NULL),
('The Paradise Inn', 125, '2019-12-04', 140, NULL),
('The Paradise Inn', 125, '2019-12-05', 175, NULL),
('The Paradise Inn', 125, '2019-12-06', 250, NULL),
('The Paradise Inn', 125, '2019-12-07', 139, NULL),
('The Paradise Inn', 125, '2019-12-08', 357, NULL),
('The Paradise Inn', 125, '2019-12-09', 147, NULL),
('The Paradise Inn', 125, '2019-12-10', 157, NULL),
('The Paradise Inn', 125, '2019-12-11', 353, NULL),
('The Paradise Inn', 125, '2019-12-12', 191, NULL),
('The Paradise Inn', 125, '2019-12-13', 313, NULL),
('The Paradise Inn', 125, '2019-12-14', 165, NULL),
('The Paradise Inn', 125, '2019-12-15', 388, NULL),
('The Paradise Inn', 125, '2019-12-16', 338, NULL),
('The Paradise Inn', 125, '2019-12-17', 157, NULL),
('The Paradise Inn', 125, '2019-12-18', 355, NULL),
('The Paradise Inn', 125, '2019-12-19', 179, NULL),
('The Paradise Inn', 125, '2019-12-20', 383, NULL),
('The Paradise Inn', 125, '2019-12-21', 226, NULL),
('The Paradise Inn', 125, '2019-12-22', 195, NULL),
('The Paradise Inn', 125, '2019-12-23', 399, NULL),
('The Paradise Inn', 125, '2019-12-24', 141, NULL),
('The Paradise Inn', 125, '2019-12-25', 363, NULL),
('The Paradise Inn', 125, '2019-12-26', 129, NULL),
('The Paradise Inn', 125, '2019-12-27', 289, NULL),
('The Paradise Inn', 125, '2019-12-28', 262, NULL),
('The Paradise Inn', 125, '2019-12-29', 125, NULL),
('The Paradise Inn', 125, '2019-12-30', 108, NULL),
('The Paradise Inn', 125, '2019-12-31', 116, NULL),
('The Paradise Inn', 125, '2020-01-01', 232, NULL),
('The Paradise Inn', 125, '2020-01-02', 366, NULL),
('The Paradise Inn', 125, '2020-01-03', 357, NULL),
('The Paradise Inn', 125, '2020-01-04', 314, NULL),
('The Paradise Inn', 125, '2020-01-05', 104, NULL),
('The Paradise Inn', 125, '2020-01-06', 344, NULL),
('The Paradise Inn', 125, '2020-01-07', 104, NULL),
('The Paradise Inn', 125, '2020-01-08', 146, NULL),
('The Paradise Inn', 125, '2020-01-09', 185, NULL),
('The Paradise Inn', 125, '2020-01-10', 143, NULL),
('The Paradise Inn', 125, '2020-01-11', 393, NULL),
('The Paradise Inn', 125, '2020-01-12', 166, NULL),
('The Paradise Inn', 125, '2020-01-13', 234, NULL),
('The Paradise Inn', 125, '2020-01-14', 383, NULL),
('The Paradise Inn', 125, '2020-01-15', 216, NULL),
('The Paradise Inn', 125, '2020-01-16', 175, NULL),
('The Paradise Inn', 125, '2020-01-17', 226, NULL),
('The Paradise Inn', 125, '2020-01-18', 108, NULL),
('The Paradise Inn', 125, '2020-01-19', 177, NULL),
('The Paradise Inn', 125, '2020-01-20', 348, NULL),
('The Paradise Inn', 125, '2020-01-21', 276, NULL),
('The Paradise Inn', 125, '2020-01-22', 373, NULL),
('The Paradise Inn', 125, '2020-01-23', 321, NULL),
('The Paradise Inn', 125, '2020-01-24', 260, NULL),
('The Paradise Inn', 125, '2020-01-25', 327, NULL),
('The Paradise Inn', 125, '2020-01-26', 315, NULL),
('The Paradise Inn', 125, '2020-01-27', 339, NULL),
('The Paradise Inn', 125, '2020-01-28', 189, NULL),
('The Paradise Inn', 125, '2020-01-29', 114, NULL),
('The Paradise Inn', 125, '2020-01-30', 336, NULL),
('The Paradise Inn', 125, '2020-01-31', 395, NULL),
('The Paradise Inn', 125, '2020-02-01', 241, NULL),
('The Paradise Inn', 125, '2020-02-02', 107, NULL),
('The Paradise Inn', 125, '2020-02-03', 252, NULL),
('The Paradise Inn', 125, '2020-02-04', 180, NULL),
('The Paradise Inn', 139, '2019-01-01', 307, NULL),
('The Paradise Inn', 139, '2019-01-02', 373, NULL),
('The Paradise Inn', 139, '2019-01-03', 227, NULL),
('The Paradise Inn', 139, '2019-01-04', 143, NULL),
('The Paradise Inn', 139, '2019-01-05', 336, NULL),
('The Paradise Inn', 139, '2019-01-06', 372, NULL),
('The Paradise Inn', 139, '2019-01-07', 189, NULL),
('The Paradise Inn', 139, '2019-01-08', 229, NULL),
('The Paradise Inn', 139, '2019-01-09', 381, NULL),
('The Paradise Inn', 139, '2019-01-10', 176, NULL),
('The Paradise Inn', 139, '2019-01-11', 161, NULL),
('The Paradise Inn', 139, '2019-01-12', 300, NULL),
('The Paradise Inn', 139, '2019-01-13', 258, NULL),
('The Paradise Inn', 139, '2019-01-14', 108, NULL),
('The Paradise Inn', 139, '2019-01-15', 276, NULL),
('The Paradise Inn', 139, '2019-01-16', 322, NULL),
('The Paradise Inn', 139, '2019-01-17', 248, NULL),
('The Paradise Inn', 139, '2019-01-18', 312, NULL),
('The Paradise Inn', 139, '2019-01-19', 224, NULL),
('The Paradise Inn', 139, '2019-01-20', 242, NULL),
('The Paradise Inn', 139, '2019-01-21', 272, NULL),
('The Paradise Inn', 139, '2019-01-22', 343, NULL),
('The Paradise Inn', 139, '2019-01-23', 193, NULL),
('The Paradise Inn', 139, '2019-01-24', 399, NULL),
('The Paradise Inn', 139, '2019-01-25', 190, NULL),
('The Paradise Inn', 139, '2019-01-26', 364, NULL),
('The Paradise Inn', 139, '2019-01-27', 387, NULL),
('The Paradise Inn', 139, '2019-01-28', 389, NULL),
('The Paradise Inn', 139, '2019-01-29', 257, NULL),
('The Paradise Inn', 139, '2019-01-30', 399, NULL),
('The Paradise Inn', 139, '2019-01-31', 243, NULL),
('The Paradise Inn', 139, '2019-02-01', 366, NULL),
('The Paradise Inn', 139, '2019-02-02', 381, NULL),
('The Paradise Inn', 139, '2019-02-03', 308, NULL),
('The Paradise Inn', 139, '2019-02-04', 379, NULL),
('The Paradise Inn', 139, '2019-02-05', 212, NULL),
('The Paradise Inn', 139, '2019-02-06', 166, NULL),
('The Paradise Inn', 139, '2019-02-07', 222, NULL),
('The Paradise Inn', 139, '2019-02-08', 350, NULL),
('The Paradise Inn', 139, '2019-02-09', 371, NULL),
('The Paradise Inn', 139, '2019-02-10', 219, NULL),
('The Paradise Inn', 139, '2019-02-11', 159, NULL),
('The Paradise Inn', 139, '2019-02-12', 142, NULL),
('The Paradise Inn', 139, '2019-02-13', 243, NULL),
('The Paradise Inn', 139, '2019-02-14', 313, NULL),
('The Paradise Inn', 139, '2019-02-15', 310, NULL),
('The Paradise Inn', 139, '2019-02-16', 325, NULL),
('The Paradise Inn', 139, '2019-02-17', 148, NULL),
('The Paradise Inn', 139, '2019-02-18', 326, NULL),
('The Paradise Inn', 139, '2019-02-19', 112, NULL),
('The Paradise Inn', 139, '2019-02-20', 111, NULL),
('The Paradise Inn', 139, '2019-02-21', 193, NULL),
('The Paradise Inn', 139, '2019-02-22', 298, NULL),
('The Paradise Inn', 139, '2019-02-23', 215, NULL),
('The Paradise Inn', 139, '2019-02-24', 218, NULL),
('The Paradise Inn', 139, '2019-02-25', 370, NULL),
('The Paradise Inn', 139, '2019-02-26', 102, NULL),
('The Paradise Inn', 139, '2019-02-27', 189, NULL),
('The Paradise Inn', 139, '2019-02-28', 357, NULL),
('The Paradise Inn', 139, '2019-03-01', 301, NULL),
('The Paradise Inn', 139, '2019-03-02', 282, NULL),
('The Paradise Inn', 139, '2019-03-03', 141, NULL),
('The Paradise Inn', 139, '2019-03-04', 383, NULL),
('The Paradise Inn', 139, '2019-03-05', 380, NULL),
('The Paradise Inn', 139, '2019-03-06', 367, NULL),
('The Paradise Inn', 139, '2019-03-07', 130, NULL),
('The Paradise Inn', 139, '2019-03-08', 192, NULL),
('The Paradise Inn', 139, '2019-03-09', 195, NULL),
('The Paradise Inn', 139, '2019-03-10', 359, NULL),
('The Paradise Inn', 139, '2019-03-11', 308, NULL),
('The Paradise Inn', 139, '2019-03-12', 116, NULL),
('The Paradise Inn', 139, '2019-03-13', 395, NULL),
('The Paradise Inn', 139, '2019-03-14', 117, NULL),
('The Paradise Inn', 139, '2019-03-15', 337, NULL),
('The Paradise Inn', 139, '2019-03-16', 390, NULL),
('The Paradise Inn', 139, '2019-03-17', 395, NULL),
('The Paradise Inn', 139, '2019-03-18', 167, NULL),
('The Paradise Inn', 139, '2019-03-19', 242, NULL),
('The Paradise Inn', 139, '2019-03-20', 389, NULL),
('The Paradise Inn', 139, '2019-03-21', 191, NULL),
('The Paradise Inn', 139, '2019-03-22', 340, NULL),
('The Paradise Inn', 139, '2019-03-23', 373, NULL),
('The Paradise Inn', 139, '2019-03-24', 315, NULL),
('The Paradise Inn', 139, '2019-03-25', 386, NULL),
('The Paradise Inn', 139, '2019-03-26', 333, NULL),
('The Paradise Inn', 139, '2019-03-27', 376, NULL),
('The Paradise Inn', 139, '2019-03-28', 268, NULL),
('The Paradise Inn', 139, '2019-03-29', 284, NULL),
('The Paradise Inn', 139, '2019-03-30', 134, NULL),
('The Paradise Inn', 139, '2019-03-31', 183, NULL),
('The Paradise Inn', 139, '2019-04-01', 250, NULL),
('The Paradise Inn', 139, '2019-04-02', 299, NULL),
('The Paradise Inn', 139, '2019-04-03', 242, NULL),
('The Paradise Inn', 139, '2019-04-04', 306, NULL),
('The Paradise Inn', 139, '2019-04-05', 297, NULL),
('The Paradise Inn', 139, '2019-04-06', 111, NULL),
('The Paradise Inn', 139, '2019-04-07', 149, NULL),
('The Paradise Inn', 139, '2019-04-08', 316, NULL),
('The Paradise Inn', 139, '2019-04-09', 218, NULL),
('The Paradise Inn', 139, '2019-04-10', 270, NULL),
('The Paradise Inn', 139, '2019-04-11', 347, NULL),
('The Paradise Inn', 139, '2019-04-12', 257, NULL),
('The Paradise Inn', 139, '2019-04-13', 140, NULL),
('The Paradise Inn', 139, '2019-04-14', 205, NULL),
('The Paradise Inn', 139, '2019-04-15', 328, NULL),
('The Paradise Inn', 139, '2019-04-16', 266, NULL),
('The Paradise Inn', 139, '2019-04-17', 149, NULL),
('The Paradise Inn', 139, '2019-04-18', 201, NULL),
('The Paradise Inn', 139, '2019-04-19', 345, NULL),
('The Paradise Inn', 139, '2019-04-20', 285, NULL),
('The Paradise Inn', 139, '2019-04-21', 300, NULL),
('The Paradise Inn', 139, '2019-04-22', 369, NULL),
('The Paradise Inn', 139, '2019-04-23', 360, NULL),
('The Paradise Inn', 139, '2019-04-24', 228, NULL),
('The Paradise Inn', 139, '2019-04-25', 334, NULL),
('The Paradise Inn', 139, '2019-04-26', 164, NULL),
('The Paradise Inn', 139, '2019-04-27', 249, NULL),
('The Paradise Inn', 139, '2019-04-28', 389, NULL),
('The Paradise Inn', 139, '2019-04-29', 254, NULL),
('The Paradise Inn', 139, '2019-04-30', 358, NULL),
('The Paradise Inn', 139, '2019-05-01', 222, NULL),
('The Paradise Inn', 139, '2019-05-02', 218, NULL),
('The Paradise Inn', 139, '2019-05-03', 254, NULL),
('The Paradise Inn', 139, '2019-05-04', 251, NULL),
('The Paradise Inn', 139, '2019-05-05', 365, NULL),
('The Paradise Inn', 139, '2019-05-06', 353, NULL),
('The Paradise Inn', 139, '2019-05-07', 320, NULL),
('The Paradise Inn', 139, '2019-05-08', 151, NULL),
('The Paradise Inn', 139, '2019-05-09', 373, NULL),
('The Paradise Inn', 139, '2019-05-10', 126, NULL),
('The Paradise Inn', 139, '2019-05-11', 233, NULL),
('The Paradise Inn', 139, '2019-05-12', 155, NULL),
('The Paradise Inn', 139, '2019-05-13', 189, NULL),
('The Paradise Inn', 139, '2019-05-14', 178, NULL),
('The Paradise Inn', 139, '2019-05-15', 326, NULL),
('The Paradise Inn', 139, '2019-05-16', 107, NULL),
('The Paradise Inn', 139, '2019-05-17', 217, NULL),
('The Paradise Inn', 139, '2019-05-18', 153, NULL),
('The Paradise Inn', 139, '2019-05-19', 301, NULL),
('The Paradise Inn', 139, '2019-05-20', 223, NULL),
('The Paradise Inn', 139, '2019-05-21', 269, NULL),
('The Paradise Inn', 139, '2019-05-22', 398, NULL),
('The Paradise Inn', 139, '2019-05-23', 380, NULL),
('The Paradise Inn', 139, '2019-05-24', 280, NULL),
('The Paradise Inn', 139, '2019-05-25', 174, NULL),
('The Paradise Inn', 139, '2019-05-26', 183, NULL),
('The Paradise Inn', 139, '2019-05-27', 276, NULL),
('The Paradise Inn', 139, '2019-05-28', 258, NULL),
('The Paradise Inn', 139, '2019-05-29', 372, NULL),
('The Paradise Inn', 139, '2019-05-30', 251, NULL),
('The Paradise Inn', 139, '2019-05-31', 285, NULL),
('The Paradise Inn', 139, '2019-06-01', 216, NULL),
('The Paradise Inn', 139, '2019-06-02', 106, NULL),
('The Paradise Inn', 139, '2019-06-03', 312, NULL),
('The Paradise Inn', 139, '2019-06-04', 356, NULL),
('The Paradise Inn', 139, '2019-06-05', 381, NULL),
('The Paradise Inn', 139, '2019-06-06', 369, NULL),
('The Paradise Inn', 139, '2019-06-07', 211, NULL),
('The Paradise Inn', 139, '2019-06-08', 397, NULL),
('The Paradise Inn', 139, '2019-06-09', 175, NULL),
('The Paradise Inn', 139, '2019-06-10', 336, NULL),
('The Paradise Inn', 139, '2019-06-11', 284, NULL),
('The Paradise Inn', 139, '2019-06-12', 331, NULL),
('The Paradise Inn', 139, '2019-06-13', 210, NULL),
('The Paradise Inn', 139, '2019-06-14', 375, NULL),
('The Paradise Inn', 139, '2019-06-15', 156, NULL),
('The Paradise Inn', 139, '2019-06-16', 193, NULL),
('The Paradise Inn', 139, '2019-06-17', 360, NULL),
('The Paradise Inn', 139, '2019-06-18', 241, NULL),
('The Paradise Inn', 139, '2019-06-19', 344, NULL),
('The Paradise Inn', 139, '2019-06-20', 286, NULL),
('The Paradise Inn', 139, '2019-06-21', 338, NULL),
('The Paradise Inn', 139, '2019-06-22', 274, NULL),
('The Paradise Inn', 139, '2019-06-23', 165, NULL),
('The Paradise Inn', 139, '2019-06-24', 249, NULL),
('The Paradise Inn', 139, '2019-06-25', 333, NULL),
('The Paradise Inn', 139, '2019-06-26', 162, NULL),
('The Paradise Inn', 139, '2019-06-27', 206, NULL),
('The Paradise Inn', 139, '2019-06-28', 216, NULL),
('The Paradise Inn', 139, '2019-06-29', 221, NULL),
('The Paradise Inn', 139, '2019-06-30', 248, NULL),
('The Paradise Inn', 139, '2019-07-01', 184, NULL),
('The Paradise Inn', 139, '2019-07-02', 219, NULL),
('The Paradise Inn', 139, '2019-07-03', 105, NULL),
('The Paradise Inn', 139, '2019-07-04', 214, NULL),
('The Paradise Inn', 139, '2019-07-05', 381, NULL),
('The Paradise Inn', 139, '2019-07-06', 163, NULL),
('The Paradise Inn', 139, '2019-07-07', 276, NULL),
('The Paradise Inn', 139, '2019-07-08', 244, NULL),
('The Paradise Inn', 139, '2019-07-09', 308, NULL),
('The Paradise Inn', 139, '2019-07-10', 395, NULL),
('The Paradise Inn', 139, '2019-07-11', 107, NULL),
('The Paradise Inn', 139, '2019-07-12', 371, NULL),
('The Paradise Inn', 139, '2019-07-13', 206, NULL),
('The Paradise Inn', 139, '2019-07-14', 302, NULL),
('The Paradise Inn', 139, '2019-07-15', 367, NULL),
('The Paradise Inn', 139, '2019-07-16', 361, NULL),
('The Paradise Inn', 139, '2019-07-17', 155, NULL),
('The Paradise Inn', 139, '2019-07-18', 159, NULL),
('The Paradise Inn', 139, '2019-07-19', 177, NULL),
('The Paradise Inn', 139, '2019-07-20', 184, NULL),
('The Paradise Inn', 139, '2019-07-21', 289, NULL),
('The Paradise Inn', 139, '2019-07-22', 184, NULL),
('The Paradise Inn', 139, '2019-07-23', 297, NULL),
('The Paradise Inn', 139, '2019-07-24', 238, NULL),
('The Paradise Inn', 139, '2019-07-25', 329, NULL),
('The Paradise Inn', 139, '2019-07-26', 241, NULL),
('The Paradise Inn', 139, '2019-07-27', 232, NULL),
('The Paradise Inn', 139, '2019-07-28', 294, NULL),
('The Paradise Inn', 139, '2019-07-29', 199, NULL),
('The Paradise Inn', 139, '2019-07-30', 363, NULL),
('The Paradise Inn', 139, '2019-07-31', 202, NULL),
('The Paradise Inn', 139, '2019-08-01', 198, NULL),
('The Paradise Inn', 139, '2019-08-02', 209, NULL),
('The Paradise Inn', 139, '2019-08-03', 142, NULL),
('The Paradise Inn', 139, '2019-08-04', 124, NULL),
('The Paradise Inn', 139, '2019-08-05', 229, NULL),
('The Paradise Inn', 139, '2019-08-06', 365, NULL),
('The Paradise Inn', 139, '2019-08-07', 314, NULL),
('The Paradise Inn', 139, '2019-08-08', 347, NULL),
('The Paradise Inn', 139, '2019-08-09', 126, NULL),
('The Paradise Inn', 139, '2019-08-10', 290, NULL),
('The Paradise Inn', 139, '2019-08-11', 333, NULL),
('The Paradise Inn', 139, '2019-08-12', 261, NULL),
('The Paradise Inn', 139, '2019-08-13', 198, NULL),
('The Paradise Inn', 139, '2019-08-14', 382, NULL),
('The Paradise Inn', 139, '2019-08-15', 299, NULL),
('The Paradise Inn', 139, '2019-08-16', 360, NULL),
('The Paradise Inn', 139, '2019-08-17', 370, NULL),
('The Paradise Inn', 139, '2019-08-18', 370, NULL),
('The Paradise Inn', 139, '2019-08-19', 196, NULL),
('The Paradise Inn', 139, '2019-08-20', 175, NULL),
('The Paradise Inn', 139, '2019-08-21', 262, NULL),
('The Paradise Inn', 139, '2019-08-22', 277, NULL),
('The Paradise Inn', 139, '2019-08-23', 158, NULL),
('The Paradise Inn', 139, '2019-08-24', 275, NULL),
('The Paradise Inn', 139, '2019-08-25', 196, NULL),
('The Paradise Inn', 139, '2019-08-26', 370, NULL),
('The Paradise Inn', 139, '2019-08-27', 134, NULL),
('The Paradise Inn', 139, '2019-08-28', 125, NULL),
('The Paradise Inn', 139, '2019-08-29', 326, NULL),
('The Paradise Inn', 139, '2019-08-30', 267, NULL),
('The Paradise Inn', 139, '2019-08-31', 172, NULL),
('The Paradise Inn', 139, '2019-09-01', 353, NULL),
('The Paradise Inn', 139, '2019-09-02', 124, NULL),
('The Paradise Inn', 139, '2019-09-03', 378, NULL),
('The Paradise Inn', 139, '2019-09-04', 231, NULL),
('The Paradise Inn', 139, '2019-09-05', 237, NULL),
('The Paradise Inn', 139, '2019-09-06', 240, NULL),
('The Paradise Inn', 139, '2019-09-07', 277, NULL),
('The Paradise Inn', 139, '2019-09-08', 236, NULL),
('The Paradise Inn', 139, '2019-09-09', 139, NULL),
('The Paradise Inn', 139, '2019-09-10', 269, NULL),
('The Paradise Inn', 139, '2019-09-11', 182, NULL),
('The Paradise Inn', 139, '2019-09-12', 336, NULL),
('The Paradise Inn', 139, '2019-09-13', 226, NULL),
('The Paradise Inn', 139, '2019-09-14', 227, NULL),
('The Paradise Inn', 139, '2019-09-15', 218, NULL),
('The Paradise Inn', 139, '2019-09-16', 343, NULL),
('The Paradise Inn', 139, '2019-09-17', 248, NULL),
('The Paradise Inn', 139, '2019-09-18', 145, NULL),
('The Paradise Inn', 139, '2019-09-19', 376, NULL),
('The Paradise Inn', 139, '2019-09-20', 369, NULL),
('The Paradise Inn', 139, '2019-09-21', 218, NULL),
('The Paradise Inn', 139, '2019-09-22', 102, NULL),
('The Paradise Inn', 139, '2019-09-23', 329, NULL),
('The Paradise Inn', 139, '2019-09-24', 353, NULL),
('The Paradise Inn', 139, '2019-09-25', 271, NULL),
('The Paradise Inn', 139, '2019-09-26', 153, NULL),
('The Paradise Inn', 139, '2019-09-27', 137, NULL),
('The Paradise Inn', 139, '2019-09-28', 397, NULL),
('The Paradise Inn', 139, '2019-09-29', 212, NULL),
('The Paradise Inn', 139, '2019-09-30', 105, NULL),
('The Paradise Inn', 139, '2019-10-01', 375, NULL),
('The Paradise Inn', 139, '2019-10-02', 136, NULL),
('The Paradise Inn', 139, '2019-10-03', 384, NULL),
('The Paradise Inn', 139, '2019-10-04', 308, NULL),
('The Paradise Inn', 139, '2019-10-05', 263, NULL),
('The Paradise Inn', 139, '2019-10-06', 326, NULL),
('The Paradise Inn', 139, '2019-10-07', 275, NULL),
('The Paradise Inn', 139, '2019-10-08', 255, NULL),
('The Paradise Inn', 139, '2019-10-09', 257, NULL),
('The Paradise Inn', 139, '2019-10-10', 322, NULL),
('The Paradise Inn', 139, '2019-10-11', 184, NULL),
('The Paradise Inn', 139, '2019-10-12', 180, NULL),
('The Paradise Inn', 139, '2019-10-13', 131, NULL),
('The Paradise Inn', 139, '2019-10-14', 219, NULL),
('The Paradise Inn', 139, '2019-10-15', 189, NULL),
('The Paradise Inn', 139, '2019-10-16', 120, NULL),
('The Paradise Inn', 139, '2019-10-17', 119, NULL),
('The Paradise Inn', 139, '2019-10-18', 160, NULL),
('The Paradise Inn', 139, '2019-10-19', 105, NULL),
('The Paradise Inn', 139, '2019-10-20', 194, NULL),
('The Paradise Inn', 139, '2019-10-21', 311, NULL),
('The Paradise Inn', 139, '2019-10-22', 385, NULL),
('The Paradise Inn', 139, '2019-10-23', 295, NULL),
('The Paradise Inn', 139, '2019-10-24', 289, NULL),
('The Paradise Inn', 139, '2019-10-25', 113, NULL),
('The Paradise Inn', 139, '2019-10-26', 193, NULL),
('The Paradise Inn', 139, '2019-10-27', 318, NULL),
('The Paradise Inn', 139, '2019-10-28', 271, NULL),
('The Paradise Inn', 139, '2019-10-29', 182, NULL),
('The Paradise Inn', 139, '2019-10-30', 222, NULL),
('The Paradise Inn', 139, '2019-10-31', 208, NULL),
('The Paradise Inn', 139, '2019-11-01', 134, NULL),
('The Paradise Inn', 139, '2019-11-02', 259, NULL),
('The Paradise Inn', 139, '2019-11-03', 180, NULL),
('The Paradise Inn', 139, '2019-11-04', 113, NULL),
('The Paradise Inn', 139, '2019-11-05', 213, NULL),
('The Paradise Inn', 139, '2019-11-06', 399, NULL),
('The Paradise Inn', 139, '2019-11-07', 208, NULL),
('The Paradise Inn', 139, '2019-11-08', 297, NULL),
('The Paradise Inn', 139, '2019-11-09', 225, NULL),
('The Paradise Inn', 139, '2019-11-10', 260, NULL),
('The Paradise Inn', 139, '2019-11-11', 174, NULL),
('The Paradise Inn', 139, '2019-11-12', 277, NULL),
('The Paradise Inn', 139, '2019-11-13', 221, NULL),
('The Paradise Inn', 139, '2019-11-14', 277, NULL),
('The Paradise Inn', 139, '2019-11-15', 148, NULL),
('The Paradise Inn', 139, '2019-11-16', 142, NULL),
('The Paradise Inn', 139, '2019-11-17', 298, NULL),
('The Paradise Inn', 139, '2019-11-18', 214, NULL),
('The Paradise Inn', 139, '2019-11-19', 254, NULL),
('The Paradise Inn', 139, '2019-11-20', 220, NULL),
('The Paradise Inn', 139, '2019-11-21', 166, NULL),
('The Paradise Inn', 139, '2019-11-22', 315, NULL),
('The Paradise Inn', 139, '2019-11-23', 319, NULL),
('The Paradise Inn', 139, '2019-11-24', 197, NULL),
('The Paradise Inn', 139, '2019-11-25', 242, NULL),
('The Paradise Inn', 139, '2019-11-26', 392, NULL),
('The Paradise Inn', 139, '2019-11-27', 329, NULL),
('The Paradise Inn', 139, '2019-11-28', 346, NULL),
('The Paradise Inn', 139, '2019-11-29', 369, NULL),
('The Paradise Inn', 139, '2019-11-30', 261, NULL),
('The Paradise Inn', 139, '2019-12-01', 150, NULL),
('The Paradise Inn', 139, '2019-12-02', 327, NULL),
('The Paradise Inn', 139, '2019-12-03', 334, NULL),
('The Paradise Inn', 139, '2019-12-04', 137, NULL),
('The Paradise Inn', 139, '2019-12-05', 285, NULL),
('The Paradise Inn', 139, '2019-12-06', 222, NULL),
('The Paradise Inn', 139, '2019-12-07', 329, NULL),
('The Paradise Inn', 139, '2019-12-08', 137, NULL),
('The Paradise Inn', 139, '2019-12-09', 102, NULL),
('The Paradise Inn', 139, '2019-12-10', 307, NULL),
('The Paradise Inn', 139, '2019-12-11', 310, NULL),
('The Paradise Inn', 139, '2019-12-12', 298, NULL),
('The Paradise Inn', 139, '2019-12-13', 238, NULL),
('The Paradise Inn', 139, '2019-12-14', 281, NULL),
('The Paradise Inn', 139, '2019-12-15', 286, NULL),
('The Paradise Inn', 139, '2019-12-16', 231, NULL),
('The Paradise Inn', 139, '2019-12-17', 150, NULL),
('The Paradise Inn', 139, '2019-12-18', 241, NULL),
('The Paradise Inn', 139, '2019-12-19', 183, NULL),
('The Paradise Inn', 139, '2019-12-20', 335, NULL),
('The Paradise Inn', 139, '2019-12-21', 346, NULL),
('The Paradise Inn', 139, '2019-12-22', 317, NULL),
('The Paradise Inn', 139, '2019-12-23', 166, NULL),
('The Paradise Inn', 139, '2019-12-24', 129, NULL),
('The Paradise Inn', 139, '2019-12-25', 176, NULL),
('The Paradise Inn', 139, '2019-12-26', 102, NULL),
('The Paradise Inn', 139, '2019-12-27', 380, NULL),
('The Paradise Inn', 139, '2019-12-28', 187, NULL),
('The Paradise Inn', 139, '2019-12-29', 377, NULL),
('The Paradise Inn', 139, '2019-12-30', 220, NULL),
('The Paradise Inn', 139, '2019-12-31', 310, NULL),
('The Paradise Inn', 139, '2020-01-01', 154, NULL),
('The Paradise Inn', 139, '2020-01-02', 202, NULL),
('The Paradise Inn', 139, '2020-01-03', 349, NULL),
('The Paradise Inn', 139, '2020-01-04', 370, NULL),
('The Paradise Inn', 139, '2020-01-05', 389, NULL),
('The Paradise Inn', 139, '2020-01-06', 142, NULL),
('The Paradise Inn', 139, '2020-01-07', 325, NULL),
('The Paradise Inn', 139, '2020-01-08', 338, NULL),
('The Paradise Inn', 139, '2020-01-09', 268, NULL),
('The Paradise Inn', 139, '2020-01-10', 247, NULL),
('The Paradise Inn', 139, '2020-01-11', 206, NULL),
('The Paradise Inn', 139, '2020-01-12', 150, NULL),
('The Paradise Inn', 139, '2020-01-13', 136, NULL),
('The Paradise Inn', 139, '2020-01-14', 194, NULL),
('The Paradise Inn', 139, '2020-01-15', 174, NULL),
('The Paradise Inn', 139, '2020-01-16', 304, NULL),
('The Paradise Inn', 139, '2020-01-17', 225, NULL),
('The Paradise Inn', 139, '2020-01-18', 308, NULL),
('The Paradise Inn', 139, '2020-01-19', 341, NULL),
('The Paradise Inn', 139, '2020-01-20', 213, NULL),
('The Paradise Inn', 139, '2020-01-21', 247, NULL),
('The Paradise Inn', 139, '2020-01-22', 327, NULL),
('The Paradise Inn', 139, '2020-01-23', 297, NULL),
('The Paradise Inn', 139, '2020-01-24', 383, NULL),
('The Paradise Inn', 139, '2020-01-25', 263, NULL),
('The Paradise Inn', 139, '2020-01-26', 381, NULL),
('The Paradise Inn', 139, '2020-01-27', 106, NULL),
('The Paradise Inn', 139, '2020-01-28', 222, NULL),
('The Paradise Inn', 139, '2020-01-29', 341, NULL),
('The Paradise Inn', 139, '2020-01-30', 320, NULL),
('The Paradise Inn', 139, '2020-01-31', 135, NULL),
('The Paradise Inn', 139, '2020-02-01', 304, NULL),
('The Paradise Inn', 139, '2020-02-02', 267, NULL),
('The Paradise Inn', 139, '2020-02-03', 174, NULL),
('The Paradise Inn', 139, '2020-02-04', 393, NULL),
('The Paradise Inn', 140, '2019-01-01', 302, NULL),
('The Paradise Inn', 140, '2019-01-02', 144, NULL),
('The Paradise Inn', 140, '2019-01-03', 167, NULL),
('The Paradise Inn', 140, '2019-01-04', 117, NULL),
('The Paradise Inn', 140, '2019-01-05', 206, NULL),
('The Paradise Inn', 140, '2019-01-06', 103, NULL),
('The Paradise Inn', 140, '2019-01-07', 107, NULL),
('The Paradise Inn', 140, '2019-01-08', 336, NULL),
('The Paradise Inn', 140, '2019-01-09', 305, NULL),
('The Paradise Inn', 140, '2019-01-10', 382, NULL),
('The Paradise Inn', 140, '2019-01-11', 202, NULL),
('The Paradise Inn', 140, '2019-01-12', 219, NULL),
('The Paradise Inn', 140, '2019-01-13', 288, NULL),
('The Paradise Inn', 140, '2019-01-14', 151, NULL),
('The Paradise Inn', 140, '2019-01-15', 185, NULL),
('The Paradise Inn', 140, '2019-01-16', 288, NULL),
('The Paradise Inn', 140, '2019-01-17', 135, NULL),
('The Paradise Inn', 140, '2019-01-18', 165, NULL),
('The Paradise Inn', 140, '2019-01-19', 163, NULL),
('The Paradise Inn', 140, '2019-01-20', 180, NULL),
('The Paradise Inn', 140, '2019-01-21', 124, NULL),
('The Paradise Inn', 140, '2019-01-22', 313, NULL),
('The Paradise Inn', 140, '2019-01-23', 347, NULL),
('The Paradise Inn', 140, '2019-01-24', 236, NULL),
('The Paradise Inn', 140, '2019-01-25', 156, NULL),
('The Paradise Inn', 140, '2019-01-26', 121, NULL),
('The Paradise Inn', 140, '2019-01-27', 363, NULL),
('The Paradise Inn', 140, '2019-01-28', 313, NULL),
('The Paradise Inn', 140, '2019-01-29', 237, NULL),
('The Paradise Inn', 140, '2019-01-30', 337, NULL),
('The Paradise Inn', 140, '2019-01-31', 263, NULL),
('The Paradise Inn', 140, '2019-02-01', 152, NULL),
('The Paradise Inn', 140, '2019-02-02', 380, NULL),
('The Paradise Inn', 140, '2019-02-03', 214, NULL),
('The Paradise Inn', 140, '2019-02-04', 171, NULL),
('The Paradise Inn', 140, '2019-02-05', 347, NULL),
('The Paradise Inn', 140, '2019-02-06', 368, NULL),
('The Paradise Inn', 140, '2019-02-07', 197, NULL),
('The Paradise Inn', 140, '2019-02-08', 390, NULL),
('The Paradise Inn', 140, '2019-02-09', 109, NULL),
('The Paradise Inn', 140, '2019-02-10', 259, NULL),
('The Paradise Inn', 140, '2019-02-11', 261, NULL),
('The Paradise Inn', 140, '2019-02-12', 292, NULL),
('The Paradise Inn', 140, '2019-02-13', 123, NULL),
('The Paradise Inn', 140, '2019-02-14', 240, NULL),
('The Paradise Inn', 140, '2019-02-15', 199, NULL),
('The Paradise Inn', 140, '2019-02-16', 301, NULL),
('The Paradise Inn', 140, '2019-02-17', 196, NULL),
('The Paradise Inn', 140, '2019-02-18', 195, NULL),
('The Paradise Inn', 140, '2019-02-19', 133, NULL),
('The Paradise Inn', 140, '2019-02-20', 331, NULL),
('The Paradise Inn', 140, '2019-02-21', 182, NULL),
('The Paradise Inn', 140, '2019-02-22', 205, NULL),
('The Paradise Inn', 140, '2019-02-23', 349, NULL),
('The Paradise Inn', 140, '2019-02-24', 128, NULL),
('The Paradise Inn', 140, '2019-02-25', 208, NULL),
('The Paradise Inn', 140, '2019-02-26', 101, NULL),
('The Paradise Inn', 140, '2019-02-27', 285, NULL),
('The Paradise Inn', 140, '2019-02-28', 109, NULL),
('The Paradise Inn', 140, '2019-03-01', 389, NULL),
('The Paradise Inn', 140, '2019-03-02', 265, NULL),
('The Paradise Inn', 140, '2019-03-03', 388, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 140, '2019-03-04', 227, NULL),
('The Paradise Inn', 140, '2019-03-05', 256, NULL),
('The Paradise Inn', 140, '2019-03-06', 149, NULL),
('The Paradise Inn', 140, '2019-03-07', 104, NULL),
('The Paradise Inn', 140, '2019-03-08', 381, NULL),
('The Paradise Inn', 140, '2019-03-09', 199, NULL),
('The Paradise Inn', 140, '2019-03-10', 382, NULL),
('The Paradise Inn', 140, '2019-03-11', 264, NULL),
('The Paradise Inn', 140, '2019-03-12', 160, NULL),
('The Paradise Inn', 140, '2019-03-13', 201, NULL),
('The Paradise Inn', 140, '2019-03-14', 215, NULL),
('The Paradise Inn', 140, '2019-03-15', 131, NULL),
('The Paradise Inn', 140, '2019-03-16', 389, NULL),
('The Paradise Inn', 140, '2019-03-17', 242, NULL),
('The Paradise Inn', 140, '2019-03-18', 198, NULL),
('The Paradise Inn', 140, '2019-03-19', 298, NULL),
('The Paradise Inn', 140, '2019-03-20', 312, NULL),
('The Paradise Inn', 140, '2019-03-21', 234, NULL),
('The Paradise Inn', 140, '2019-03-22', 203, NULL),
('The Paradise Inn', 140, '2019-03-23', 371, NULL),
('The Paradise Inn', 140, '2019-03-24', 311, NULL),
('The Paradise Inn', 140, '2019-03-25', 262, NULL),
('The Paradise Inn', 140, '2019-03-26', 137, NULL),
('The Paradise Inn', 140, '2019-03-27', 299, NULL),
('The Paradise Inn', 140, '2019-03-28', 245, NULL),
('The Paradise Inn', 140, '2019-03-29', 372, NULL),
('The Paradise Inn', 140, '2019-03-30', 264, NULL),
('The Paradise Inn', 140, '2019-03-31', 255, NULL),
('The Paradise Inn', 140, '2019-04-01', 221, NULL),
('The Paradise Inn', 140, '2019-04-02', 153, NULL),
('The Paradise Inn', 140, '2019-04-03', 103, NULL),
('The Paradise Inn', 140, '2019-04-04', 210, NULL),
('The Paradise Inn', 140, '2019-04-05', 121, NULL),
('The Paradise Inn', 140, '2019-04-06', 380, NULL),
('The Paradise Inn', 140, '2019-04-07', 375, NULL),
('The Paradise Inn', 140, '2019-04-08', 102, NULL),
('The Paradise Inn', 140, '2019-04-09', 101, NULL),
('The Paradise Inn', 140, '2019-04-10', 304, NULL),
('The Paradise Inn', 140, '2019-04-11', 119, NULL),
('The Paradise Inn', 140, '2019-04-12', 295, NULL),
('The Paradise Inn', 140, '2019-04-13', 359, NULL),
('The Paradise Inn', 140, '2019-04-14', 158, NULL),
('The Paradise Inn', 140, '2019-04-15', 255, NULL),
('The Paradise Inn', 140, '2019-04-16', 127, NULL),
('The Paradise Inn', 140, '2019-04-17', 255, NULL),
('The Paradise Inn', 140, '2019-04-18', 282, NULL),
('The Paradise Inn', 140, '2019-04-19', 379, NULL),
('The Paradise Inn', 140, '2019-04-20', 160, NULL),
('The Paradise Inn', 140, '2019-04-21', 159, NULL),
('The Paradise Inn', 140, '2019-04-22', 191, NULL),
('The Paradise Inn', 140, '2019-04-23', 398, NULL),
('The Paradise Inn', 140, '2019-04-24', 326, NULL),
('The Paradise Inn', 140, '2019-04-25', 293, NULL),
('The Paradise Inn', 140, '2019-04-26', 288, NULL),
('The Paradise Inn', 140, '2019-04-27', 343, NULL),
('The Paradise Inn', 140, '2019-04-28', 154, NULL),
('The Paradise Inn', 140, '2019-04-29', 214, NULL),
('The Paradise Inn', 140, '2019-04-30', 175, NULL),
('The Paradise Inn', 140, '2019-05-01', 142, NULL),
('The Paradise Inn', 140, '2019-05-02', 377, NULL),
('The Paradise Inn', 140, '2019-05-03', 394, NULL),
('The Paradise Inn', 140, '2019-05-04', 185, NULL),
('The Paradise Inn', 140, '2019-05-05', 146, NULL),
('The Paradise Inn', 140, '2019-05-06', 339, NULL),
('The Paradise Inn', 140, '2019-05-07', 316, NULL),
('The Paradise Inn', 140, '2019-05-08', 256, NULL),
('The Paradise Inn', 140, '2019-05-09', 234, NULL),
('The Paradise Inn', 140, '2019-05-10', 384, NULL),
('The Paradise Inn', 140, '2019-05-11', 216, NULL),
('The Paradise Inn', 140, '2019-05-12', 160, NULL),
('The Paradise Inn', 140, '2019-05-13', 350, NULL),
('The Paradise Inn', 140, '2019-05-14', 299, NULL),
('The Paradise Inn', 140, '2019-05-15', 282, NULL),
('The Paradise Inn', 140, '2019-05-16', 312, NULL),
('The Paradise Inn', 140, '2019-05-17', 209, NULL),
('The Paradise Inn', 140, '2019-05-18', 259, NULL),
('The Paradise Inn', 140, '2019-05-19', 259, NULL),
('The Paradise Inn', 140, '2019-05-20', 128, NULL),
('The Paradise Inn', 140, '2019-05-21', 194, NULL),
('The Paradise Inn', 140, '2019-05-22', 271, NULL),
('The Paradise Inn', 140, '2019-05-23', 214, NULL),
('The Paradise Inn', 140, '2019-05-24', 301, NULL),
('The Paradise Inn', 140, '2019-05-25', 227, NULL),
('The Paradise Inn', 140, '2019-05-26', 254, NULL),
('The Paradise Inn', 140, '2019-05-27', 197, NULL),
('The Paradise Inn', 140, '2019-05-28', 392, NULL),
('The Paradise Inn', 140, '2019-05-29', 283, NULL),
('The Paradise Inn', 140, '2019-05-30', 256, NULL),
('The Paradise Inn', 140, '2019-05-31', 236, NULL),
('The Paradise Inn', 140, '2019-06-01', 142, NULL),
('The Paradise Inn', 140, '2019-06-02', 249, NULL),
('The Paradise Inn', 140, '2019-06-03', 151, NULL),
('The Paradise Inn', 140, '2019-06-04', 115, NULL),
('The Paradise Inn', 140, '2019-06-05', 214, NULL),
('The Paradise Inn', 140, '2019-06-06', 300, NULL),
('The Paradise Inn', 140, '2019-06-07', 187, NULL),
('The Paradise Inn', 140, '2019-06-08', 345, NULL),
('The Paradise Inn', 140, '2019-06-09', 294, NULL),
('The Paradise Inn', 140, '2019-06-10', 285, NULL),
('The Paradise Inn', 140, '2019-06-11', 268, NULL),
('The Paradise Inn', 140, '2019-06-12', 343, NULL),
('The Paradise Inn', 140, '2019-06-13', 354, NULL),
('The Paradise Inn', 140, '2019-06-14', 125, NULL),
('The Paradise Inn', 140, '2019-06-15', 286, NULL),
('The Paradise Inn', 140, '2019-06-16', 200, NULL),
('The Paradise Inn', 140, '2019-06-17', 375, NULL),
('The Paradise Inn', 140, '2019-06-18', 124, NULL),
('The Paradise Inn', 140, '2019-06-19', 158, NULL),
('The Paradise Inn', 140, '2019-06-20', 368, NULL),
('The Paradise Inn', 140, '2019-06-21', 243, NULL),
('The Paradise Inn', 140, '2019-06-22', 249, NULL),
('The Paradise Inn', 140, '2019-06-23', 298, NULL),
('The Paradise Inn', 140, '2019-06-24', 315, NULL),
('The Paradise Inn', 140, '2019-06-25', 138, NULL),
('The Paradise Inn', 140, '2019-06-26', 215, NULL),
('The Paradise Inn', 140, '2019-06-27', 347, NULL),
('The Paradise Inn', 140, '2019-06-28', 354, NULL),
('The Paradise Inn', 140, '2019-06-29', 261, NULL),
('The Paradise Inn', 140, '2019-06-30', 195, NULL),
('The Paradise Inn', 140, '2019-07-01', 191, NULL),
('The Paradise Inn', 140, '2019-07-02', 204, NULL),
('The Paradise Inn', 140, '2019-07-03', 146, NULL),
('The Paradise Inn', 140, '2019-07-04', 252, NULL),
('The Paradise Inn', 140, '2019-07-05', 296, NULL),
('The Paradise Inn', 140, '2019-07-06', 177, NULL),
('The Paradise Inn', 140, '2019-07-07', 268, NULL),
('The Paradise Inn', 140, '2019-07-08', 145, NULL),
('The Paradise Inn', 140, '2019-07-09', 141, NULL),
('The Paradise Inn', 140, '2019-07-10', 356, NULL),
('The Paradise Inn', 140, '2019-07-11', 242, NULL),
('The Paradise Inn', 140, '2019-07-12', 317, NULL),
('The Paradise Inn', 140, '2019-07-13', 393, NULL),
('The Paradise Inn', 140, '2019-07-14', 168, NULL),
('The Paradise Inn', 140, '2019-07-15', 142, NULL),
('The Paradise Inn', 140, '2019-07-16', 364, NULL),
('The Paradise Inn', 140, '2019-07-17', 175, NULL),
('The Paradise Inn', 140, '2019-07-18', 194, NULL),
('The Paradise Inn', 140, '2019-07-19', 362, NULL),
('The Paradise Inn', 140, '2019-07-20', 111, NULL),
('The Paradise Inn', 140, '2019-07-21', 207, NULL),
('The Paradise Inn', 140, '2019-07-22', 276, NULL),
('The Paradise Inn', 140, '2019-07-23', 286, NULL),
('The Paradise Inn', 140, '2019-07-24', 375, NULL),
('The Paradise Inn', 140, '2019-07-25', 255, NULL),
('The Paradise Inn', 140, '2019-07-26', 241, NULL),
('The Paradise Inn', 140, '2019-07-27', 367, NULL),
('The Paradise Inn', 140, '2019-07-28', 275, NULL),
('The Paradise Inn', 140, '2019-07-29', 372, NULL),
('The Paradise Inn', 140, '2019-07-30', 233, NULL),
('The Paradise Inn', 140, '2019-07-31', 347, NULL),
('The Paradise Inn', 140, '2019-08-01', 207, NULL),
('The Paradise Inn', 140, '2019-08-02', 174, NULL),
('The Paradise Inn', 140, '2019-08-03', 393, NULL),
('The Paradise Inn', 140, '2019-08-04', 398, NULL),
('The Paradise Inn', 140, '2019-08-05', 171, NULL),
('The Paradise Inn', 140, '2019-08-06', 160, NULL),
('The Paradise Inn', 140, '2019-08-07', 397, NULL),
('The Paradise Inn', 140, '2019-08-08', 111, NULL),
('The Paradise Inn', 140, '2019-08-09', 305, NULL),
('The Paradise Inn', 140, '2019-08-10', 119, NULL),
('The Paradise Inn', 140, '2019-08-11', 174, NULL),
('The Paradise Inn', 140, '2019-08-12', 291, NULL),
('The Paradise Inn', 140, '2019-08-13', 392, NULL),
('The Paradise Inn', 140, '2019-08-14', 197, NULL),
('The Paradise Inn', 140, '2019-08-15', 275, NULL),
('The Paradise Inn', 140, '2019-08-16', 291, NULL),
('The Paradise Inn', 140, '2019-08-17', 233, NULL),
('The Paradise Inn', 140, '2019-08-18', 290, NULL),
('The Paradise Inn', 140, '2019-08-19', 310, NULL),
('The Paradise Inn', 140, '2019-08-20', 398, NULL),
('The Paradise Inn', 140, '2019-08-21', 195, NULL),
('The Paradise Inn', 140, '2019-08-22', 222, NULL),
('The Paradise Inn', 140, '2019-08-23', 172, NULL),
('The Paradise Inn', 140, '2019-08-24', 358, NULL),
('The Paradise Inn', 140, '2019-08-25', 137, NULL),
('The Paradise Inn', 140, '2019-08-26', 233, NULL),
('The Paradise Inn', 140, '2019-08-27', 139, NULL),
('The Paradise Inn', 140, '2019-08-28', 264, NULL),
('The Paradise Inn', 140, '2019-08-29', 389, NULL),
('The Paradise Inn', 140, '2019-08-30', 104, NULL),
('The Paradise Inn', 140, '2019-08-31', 303, NULL),
('The Paradise Inn', 140, '2019-09-01', 324, NULL),
('The Paradise Inn', 140, '2019-09-02', 218, NULL),
('The Paradise Inn', 140, '2019-09-03', 236, NULL),
('The Paradise Inn', 140, '2019-09-04', 389, NULL),
('The Paradise Inn', 140, '2019-09-05', 186, NULL),
('The Paradise Inn', 140, '2019-09-06', 220, NULL),
('The Paradise Inn', 140, '2019-09-07', 140, NULL),
('The Paradise Inn', 140, '2019-09-08', 332, NULL),
('The Paradise Inn', 140, '2019-09-09', 315, NULL),
('The Paradise Inn', 140, '2019-09-10', 292, NULL),
('The Paradise Inn', 140, '2019-09-11', 149, NULL),
('The Paradise Inn', 140, '2019-09-12', 102, NULL),
('The Paradise Inn', 140, '2019-09-13', 169, NULL),
('The Paradise Inn', 140, '2019-09-14', 258, NULL),
('The Paradise Inn', 140, '2019-09-15', 162, NULL),
('The Paradise Inn', 140, '2019-09-16', 296, NULL),
('The Paradise Inn', 140, '2019-09-17', 317, NULL),
('The Paradise Inn', 140, '2019-09-18', 175, NULL),
('The Paradise Inn', 140, '2019-09-19', 219, NULL),
('The Paradise Inn', 140, '2019-09-20', 278, NULL),
('The Paradise Inn', 140, '2019-09-21', 309, NULL),
('The Paradise Inn', 140, '2019-09-22', 334, NULL),
('The Paradise Inn', 140, '2019-09-23', 397, NULL),
('The Paradise Inn', 140, '2019-09-24', 166, NULL),
('The Paradise Inn', 140, '2019-09-25', 251, NULL),
('The Paradise Inn', 140, '2019-09-26', 310, NULL),
('The Paradise Inn', 140, '2019-09-27', 363, NULL),
('The Paradise Inn', 140, '2019-09-28', 220, NULL),
('The Paradise Inn', 140, '2019-09-29', 141, NULL),
('The Paradise Inn', 140, '2019-09-30', 395, NULL),
('The Paradise Inn', 140, '2019-10-01', 247, NULL),
('The Paradise Inn', 140, '2019-10-02', 132, NULL),
('The Paradise Inn', 140, '2019-10-03', 288, NULL),
('The Paradise Inn', 140, '2019-10-04', 318, NULL),
('The Paradise Inn', 140, '2019-10-05', 216, NULL),
('The Paradise Inn', 140, '2019-10-06', 170, NULL),
('The Paradise Inn', 140, '2019-10-07', 168, NULL),
('The Paradise Inn', 140, '2019-10-08', 182, NULL),
('The Paradise Inn', 140, '2019-10-09', 177, NULL),
('The Paradise Inn', 140, '2019-10-10', 312, NULL),
('The Paradise Inn', 140, '2019-10-11', 202, NULL),
('The Paradise Inn', 140, '2019-10-12', 254, NULL),
('The Paradise Inn', 140, '2019-10-13', 202, NULL),
('The Paradise Inn', 140, '2019-10-14', 240, NULL),
('The Paradise Inn', 140, '2019-10-15', 270, NULL),
('The Paradise Inn', 140, '2019-10-16', 347, NULL),
('The Paradise Inn', 140, '2019-10-17', 296, NULL),
('The Paradise Inn', 140, '2019-10-18', 385, NULL),
('The Paradise Inn', 140, '2019-10-19', 345, NULL),
('The Paradise Inn', 140, '2019-10-20', 352, NULL),
('The Paradise Inn', 140, '2019-10-21', 370, NULL),
('The Paradise Inn', 140, '2019-10-22', 128, NULL),
('The Paradise Inn', 140, '2019-10-23', 127, NULL),
('The Paradise Inn', 140, '2019-10-24', 393, NULL),
('The Paradise Inn', 140, '2019-10-25', 192, NULL),
('The Paradise Inn', 140, '2019-10-26', 237, NULL),
('The Paradise Inn', 140, '2019-10-27', 387, NULL),
('The Paradise Inn', 140, '2019-10-28', 261, NULL),
('The Paradise Inn', 140, '2019-10-29', 260, NULL),
('The Paradise Inn', 140, '2019-10-30', 313, NULL),
('The Paradise Inn', 140, '2019-10-31', 109, NULL),
('The Paradise Inn', 140, '2019-11-01', 243, NULL),
('The Paradise Inn', 140, '2019-11-02', 367, NULL),
('The Paradise Inn', 140, '2019-11-03', 306, NULL),
('The Paradise Inn', 140, '2019-11-04', 230, NULL),
('The Paradise Inn', 140, '2019-11-05', 267, NULL),
('The Paradise Inn', 140, '2019-11-06', 227, NULL),
('The Paradise Inn', 140, '2019-11-07', 385, NULL),
('The Paradise Inn', 140, '2019-11-08', 179, NULL),
('The Paradise Inn', 140, '2019-11-09', 226, NULL),
('The Paradise Inn', 140, '2019-11-10', 313, NULL),
('The Paradise Inn', 140, '2019-11-11', 274, NULL),
('The Paradise Inn', 140, '2019-11-12', 163, NULL),
('The Paradise Inn', 140, '2019-11-13', 327, NULL),
('The Paradise Inn', 140, '2019-11-14', 126, NULL),
('The Paradise Inn', 140, '2019-11-15', 229, NULL),
('The Paradise Inn', 140, '2019-11-16', 342, NULL),
('The Paradise Inn', 140, '2019-11-17', 216, NULL),
('The Paradise Inn', 140, '2019-11-18', 226, NULL),
('The Paradise Inn', 140, '2019-11-19', 247, NULL),
('The Paradise Inn', 140, '2019-11-20', 182, NULL),
('The Paradise Inn', 140, '2019-11-21', 347, NULL),
('The Paradise Inn', 140, '2019-11-22', 183, NULL),
('The Paradise Inn', 140, '2019-11-23', 135, NULL),
('The Paradise Inn', 140, '2019-11-24', 120, NULL),
('The Paradise Inn', 140, '2019-11-25', 374, NULL),
('The Paradise Inn', 140, '2019-11-26', 206, NULL),
('The Paradise Inn', 140, '2019-11-27', 377, NULL),
('The Paradise Inn', 140, '2019-11-28', 202, NULL),
('The Paradise Inn', 140, '2019-11-29', 315, NULL),
('The Paradise Inn', 140, '2019-11-30', 200, NULL),
('The Paradise Inn', 140, '2019-12-01', 237, NULL),
('The Paradise Inn', 140, '2019-12-02', 202, NULL),
('The Paradise Inn', 140, '2019-12-03', 313, NULL),
('The Paradise Inn', 140, '2019-12-04', 165, NULL),
('The Paradise Inn', 140, '2019-12-05', 202, NULL),
('The Paradise Inn', 140, '2019-12-06', 262, NULL),
('The Paradise Inn', 140, '2019-12-07', 226, NULL),
('The Paradise Inn', 140, '2019-12-08', 111, NULL),
('The Paradise Inn', 140, '2019-12-09', 269, NULL),
('The Paradise Inn', 140, '2019-12-10', 365, NULL),
('The Paradise Inn', 140, '2019-12-11', 395, NULL),
('The Paradise Inn', 140, '2019-12-12', 218, NULL),
('The Paradise Inn', 140, '2019-12-13', 151, NULL),
('The Paradise Inn', 140, '2019-12-14', 210, NULL),
('The Paradise Inn', 140, '2019-12-15', 169, NULL),
('The Paradise Inn', 140, '2019-12-16', 343, NULL),
('The Paradise Inn', 140, '2019-12-17', 181, NULL),
('The Paradise Inn', 140, '2019-12-18', 343, NULL),
('The Paradise Inn', 140, '2019-12-19', 281, NULL),
('The Paradise Inn', 140, '2019-12-20', 126, NULL),
('The Paradise Inn', 140, '2019-12-21', 355, NULL),
('The Paradise Inn', 140, '2019-12-22', 301, NULL),
('The Paradise Inn', 140, '2019-12-23', 130, NULL),
('The Paradise Inn', 140, '2019-12-24', 126, NULL),
('The Paradise Inn', 140, '2019-12-25', 292, NULL),
('The Paradise Inn', 140, '2019-12-26', 324, NULL),
('The Paradise Inn', 140, '2019-12-27', 334, NULL),
('The Paradise Inn', 140, '2019-12-28', 349, NULL),
('The Paradise Inn', 140, '2019-12-29', 209, NULL),
('The Paradise Inn', 140, '2019-12-30', 375, NULL),
('The Paradise Inn', 140, '2019-12-31', 202, NULL),
('The Paradise Inn', 140, '2020-01-01', 277, NULL),
('The Paradise Inn', 140, '2020-01-02', 112, NULL),
('The Paradise Inn', 140, '2020-01-03', 274, NULL),
('The Paradise Inn', 140, '2020-01-04', 210, NULL),
('The Paradise Inn', 140, '2020-01-05', 334, NULL),
('The Paradise Inn', 140, '2020-01-06', 180, NULL),
('The Paradise Inn', 140, '2020-01-07', 312, NULL),
('The Paradise Inn', 140, '2020-01-08', 252, NULL),
('The Paradise Inn', 140, '2020-01-09', 384, NULL),
('The Paradise Inn', 140, '2020-01-10', 107, NULL),
('The Paradise Inn', 140, '2020-01-11', 354, NULL),
('The Paradise Inn', 140, '2020-01-12', 152, NULL),
('The Paradise Inn', 140, '2020-01-13', 180, NULL),
('The Paradise Inn', 140, '2020-01-14', 322, NULL),
('The Paradise Inn', 140, '2020-01-15', 123, NULL),
('The Paradise Inn', 140, '2020-01-16', 297, NULL),
('The Paradise Inn', 140, '2020-01-17', 351, NULL),
('The Paradise Inn', 140, '2020-01-18', 217, NULL),
('The Paradise Inn', 140, '2020-01-19', 174, NULL),
('The Paradise Inn', 140, '2020-01-20', 222, NULL),
('The Paradise Inn', 140, '2020-01-21', 310, NULL),
('The Paradise Inn', 140, '2020-01-22', 116, NULL),
('The Paradise Inn', 140, '2020-01-23', 122, NULL),
('The Paradise Inn', 140, '2020-01-24', 138, NULL),
('The Paradise Inn', 140, '2020-01-25', 237, NULL),
('The Paradise Inn', 140, '2020-01-26', 261, NULL),
('The Paradise Inn', 140, '2020-01-27', 312, NULL),
('The Paradise Inn', 140, '2020-01-28', 143, NULL),
('The Paradise Inn', 140, '2020-01-29', 365, NULL),
('The Paradise Inn', 140, '2020-01-30', 191, NULL),
('The Paradise Inn', 140, '2020-01-31', 288, NULL),
('The Paradise Inn', 140, '2020-02-01', 101, NULL),
('The Paradise Inn', 140, '2020-02-02', 312, NULL),
('The Paradise Inn', 140, '2020-02-03', 312, NULL),
('The Paradise Inn', 140, '2020-02-04', 129, NULL),
('The Paradise Inn', 148, '2019-01-01', 187, NULL),
('The Paradise Inn', 148, '2019-01-02', 101, NULL),
('The Paradise Inn', 148, '2019-01-03', 354, NULL),
('The Paradise Inn', 148, '2019-01-04', 357, NULL),
('The Paradise Inn', 148, '2019-01-05', 220, NULL),
('The Paradise Inn', 148, '2019-01-06', 200, NULL),
('The Paradise Inn', 148, '2019-01-07', 166, NULL),
('The Paradise Inn', 148, '2019-01-08', 295, NULL),
('The Paradise Inn', 148, '2019-01-09', 281, NULL),
('The Paradise Inn', 148, '2019-01-10', 384, NULL),
('The Paradise Inn', 148, '2019-01-11', 128, NULL),
('The Paradise Inn', 148, '2019-01-12', 393, NULL),
('The Paradise Inn', 148, '2019-01-13', 265, NULL),
('The Paradise Inn', 148, '2019-01-14', 332, NULL),
('The Paradise Inn', 148, '2019-01-15', 300, NULL),
('The Paradise Inn', 148, '2019-01-16', 377, NULL),
('The Paradise Inn', 148, '2019-01-17', 133, NULL),
('The Paradise Inn', 148, '2019-01-18', 387, NULL),
('The Paradise Inn', 148, '2019-01-19', 343, NULL),
('The Paradise Inn', 148, '2019-01-20', 377, NULL),
('The Paradise Inn', 148, '2019-01-21', 308, NULL),
('The Paradise Inn', 148, '2019-01-22', 136, NULL),
('The Paradise Inn', 148, '2019-01-23', 157, NULL),
('The Paradise Inn', 148, '2019-01-24', 186, NULL),
('The Paradise Inn', 148, '2019-01-25', 109, NULL),
('The Paradise Inn', 148, '2019-01-26', 313, NULL),
('The Paradise Inn', 148, '2019-01-27', 257, NULL),
('The Paradise Inn', 148, '2019-01-28', 299, NULL),
('The Paradise Inn', 148, '2019-01-29', 313, NULL),
('The Paradise Inn', 148, '2019-01-30', 386, NULL),
('The Paradise Inn', 148, '2019-01-31', 185, NULL),
('The Paradise Inn', 148, '2019-02-01', 160, NULL),
('The Paradise Inn', 148, '2019-02-02', 354, NULL),
('The Paradise Inn', 148, '2019-02-03', 349, NULL),
('The Paradise Inn', 148, '2019-02-04', 219, NULL),
('The Paradise Inn', 148, '2019-02-05', 100, NULL),
('The Paradise Inn', 148, '2019-02-06', 344, NULL),
('The Paradise Inn', 148, '2019-02-07', 218, NULL),
('The Paradise Inn', 148, '2019-02-08', 199, NULL),
('The Paradise Inn', 148, '2019-02-09', 233, NULL),
('The Paradise Inn', 148, '2019-02-10', 238, NULL),
('The Paradise Inn', 148, '2019-02-11', 130, NULL),
('The Paradise Inn', 148, '2019-02-12', 334, NULL),
('The Paradise Inn', 148, '2019-02-13', 386, NULL),
('The Paradise Inn', 148, '2019-02-14', 163, NULL),
('The Paradise Inn', 148, '2019-02-15', 266, NULL),
('The Paradise Inn', 148, '2019-02-16', 130, NULL),
('The Paradise Inn', 148, '2019-02-17', 139, NULL),
('The Paradise Inn', 148, '2019-02-18', 198, NULL),
('The Paradise Inn', 148, '2019-02-19', 230, NULL),
('The Paradise Inn', 148, '2019-02-20', 323, NULL),
('The Paradise Inn', 148, '2019-02-21', 231, NULL),
('The Paradise Inn', 148, '2019-02-22', 331, NULL),
('The Paradise Inn', 148, '2019-02-23', 102, NULL),
('The Paradise Inn', 148, '2019-02-24', 186, NULL),
('The Paradise Inn', 148, '2019-02-25', 129, NULL),
('The Paradise Inn', 148, '2019-02-26', 101, NULL),
('The Paradise Inn', 148, '2019-02-27', 158, NULL),
('The Paradise Inn', 148, '2019-02-28', 276, NULL),
('The Paradise Inn', 148, '2019-03-01', 342, NULL),
('The Paradise Inn', 148, '2019-03-02', 378, NULL),
('The Paradise Inn', 148, '2019-03-03', 219, NULL),
('The Paradise Inn', 148, '2019-03-04', 187, NULL),
('The Paradise Inn', 148, '2019-03-05', 340, NULL),
('The Paradise Inn', 148, '2019-03-06', 145, NULL),
('The Paradise Inn', 148, '2019-03-07', 330, NULL),
('The Paradise Inn', 148, '2019-03-08', 329, NULL),
('The Paradise Inn', 148, '2019-03-09', 311, NULL),
('The Paradise Inn', 148, '2019-03-10', 135, NULL),
('The Paradise Inn', 148, '2019-03-11', 295, NULL),
('The Paradise Inn', 148, '2019-03-12', 356, NULL),
('The Paradise Inn', 148, '2019-03-13', 322, NULL),
('The Paradise Inn', 148, '2019-03-14', 326, NULL),
('The Paradise Inn', 148, '2019-03-15', 143, NULL),
('The Paradise Inn', 148, '2019-03-16', 377, NULL),
('The Paradise Inn', 148, '2019-03-17', 223, NULL),
('The Paradise Inn', 148, '2019-03-18', 390, NULL),
('The Paradise Inn', 148, '2019-03-19', 365, NULL),
('The Paradise Inn', 148, '2019-03-20', 293, NULL),
('The Paradise Inn', 148, '2019-03-21', 200, NULL),
('The Paradise Inn', 148, '2019-03-22', 193, NULL),
('The Paradise Inn', 148, '2019-03-23', 337, NULL),
('The Paradise Inn', 148, '2019-03-24', 212, NULL),
('The Paradise Inn', 148, '2019-03-25', 353, NULL),
('The Paradise Inn', 148, '2019-03-26', 189, NULL),
('The Paradise Inn', 148, '2019-03-27', 267, NULL),
('The Paradise Inn', 148, '2019-03-28', 323, NULL),
('The Paradise Inn', 148, '2019-03-29', 309, NULL),
('The Paradise Inn', 148, '2019-03-30', 220, NULL),
('The Paradise Inn', 148, '2019-03-31', 329, NULL),
('The Paradise Inn', 148, '2019-04-01', 256, NULL),
('The Paradise Inn', 148, '2019-04-02', 370, NULL),
('The Paradise Inn', 148, '2019-04-03', 291, NULL),
('The Paradise Inn', 148, '2019-04-04', 335, NULL),
('The Paradise Inn', 148, '2019-04-05', 213, NULL),
('The Paradise Inn', 148, '2019-04-06', 269, NULL),
('The Paradise Inn', 148, '2019-04-07', 131, NULL),
('The Paradise Inn', 148, '2019-04-08', 360, NULL),
('The Paradise Inn', 148, '2019-04-09', 352, NULL),
('The Paradise Inn', 148, '2019-04-10', 312, NULL),
('The Paradise Inn', 148, '2019-04-11', 354, NULL),
('The Paradise Inn', 148, '2019-04-12', 302, NULL),
('The Paradise Inn', 148, '2019-04-13', 377, NULL),
('The Paradise Inn', 148, '2019-04-14', 376, NULL),
('The Paradise Inn', 148, '2019-04-15', 192, NULL),
('The Paradise Inn', 148, '2019-04-16', 334, NULL),
('The Paradise Inn', 148, '2019-04-17', 128, NULL),
('The Paradise Inn', 148, '2019-04-18', 108, NULL),
('The Paradise Inn', 148, '2019-04-19', 160, NULL),
('The Paradise Inn', 148, '2019-04-20', 148, NULL),
('The Paradise Inn', 148, '2019-04-21', 395, NULL),
('The Paradise Inn', 148, '2019-04-22', 346, NULL),
('The Paradise Inn', 148, '2019-04-23', 211, NULL),
('The Paradise Inn', 148, '2019-04-24', 245, NULL),
('The Paradise Inn', 148, '2019-04-25', 364, NULL),
('The Paradise Inn', 148, '2019-04-26', 252, NULL),
('The Paradise Inn', 148, '2019-04-27', 269, NULL),
('The Paradise Inn', 148, '2019-04-28', 102, NULL),
('The Paradise Inn', 148, '2019-04-29', 210, NULL),
('The Paradise Inn', 148, '2019-04-30', 300, NULL),
('The Paradise Inn', 148, '2019-05-01', 241, NULL),
('The Paradise Inn', 148, '2019-05-02', 231, NULL),
('The Paradise Inn', 148, '2019-05-03', 207, NULL),
('The Paradise Inn', 148, '2019-05-04', 375, NULL),
('The Paradise Inn', 148, '2019-05-05', 137, NULL),
('The Paradise Inn', 148, '2019-05-06', 238, NULL),
('The Paradise Inn', 148, '2019-05-07', 222, NULL),
('The Paradise Inn', 148, '2019-05-08', 128, NULL),
('The Paradise Inn', 148, '2019-05-09', 250, NULL),
('The Paradise Inn', 148, '2019-05-10', 244, NULL),
('The Paradise Inn', 148, '2019-05-11', 284, NULL),
('The Paradise Inn', 148, '2019-05-12', 232, NULL),
('The Paradise Inn', 148, '2019-05-13', 185, NULL),
('The Paradise Inn', 148, '2019-05-14', 261, NULL),
('The Paradise Inn', 148, '2019-05-15', 334, NULL),
('The Paradise Inn', 148, '2019-05-16', 240, NULL),
('The Paradise Inn', 148, '2019-05-17', 297, NULL),
('The Paradise Inn', 148, '2019-05-18', 135, NULL),
('The Paradise Inn', 148, '2019-05-19', 293, NULL),
('The Paradise Inn', 148, '2019-05-20', 172, NULL),
('The Paradise Inn', 148, '2019-05-21', 362, NULL),
('The Paradise Inn', 148, '2019-05-22', 358, NULL),
('The Paradise Inn', 148, '2019-05-23', 132, NULL),
('The Paradise Inn', 148, '2019-05-24', 266, NULL),
('The Paradise Inn', 148, '2019-05-25', 214, NULL),
('The Paradise Inn', 148, '2019-05-26', 324, NULL),
('The Paradise Inn', 148, '2019-05-27', 357, NULL),
('The Paradise Inn', 148, '2019-05-28', 186, NULL),
('The Paradise Inn', 148, '2019-05-29', 201, NULL),
('The Paradise Inn', 148, '2019-05-30', 127, NULL),
('The Paradise Inn', 148, '2019-05-31', 227, NULL),
('The Paradise Inn', 148, '2019-06-01', 260, NULL),
('The Paradise Inn', 148, '2019-06-02', 229, NULL),
('The Paradise Inn', 148, '2019-06-03', 321, NULL),
('The Paradise Inn', 148, '2019-06-04', 310, NULL),
('The Paradise Inn', 148, '2019-06-05', 128, NULL),
('The Paradise Inn', 148, '2019-06-06', 292, NULL),
('The Paradise Inn', 148, '2019-06-07', 206, NULL),
('The Paradise Inn', 148, '2019-06-08', 133, NULL),
('The Paradise Inn', 148, '2019-06-09', 245, NULL),
('The Paradise Inn', 148, '2019-06-10', 316, NULL),
('The Paradise Inn', 148, '2019-06-11', 386, NULL),
('The Paradise Inn', 148, '2019-06-12', 323, NULL),
('The Paradise Inn', 148, '2019-06-13', 140, NULL),
('The Paradise Inn', 148, '2019-06-14', 298, NULL),
('The Paradise Inn', 148, '2019-06-15', 263, NULL),
('The Paradise Inn', 148, '2019-06-16', 323, NULL),
('The Paradise Inn', 148, '2019-06-17', 395, NULL),
('The Paradise Inn', 148, '2019-06-18', 398, NULL),
('The Paradise Inn', 148, '2019-06-19', 257, NULL),
('The Paradise Inn', 148, '2019-06-20', 285, NULL),
('The Paradise Inn', 148, '2019-06-21', 103, NULL),
('The Paradise Inn', 148, '2019-06-22', 326, NULL),
('The Paradise Inn', 148, '2019-06-23', 293, NULL),
('The Paradise Inn', 148, '2019-06-24', 129, NULL),
('The Paradise Inn', 148, '2019-06-25', 191, NULL),
('The Paradise Inn', 148, '2019-06-26', 189, NULL),
('The Paradise Inn', 148, '2019-06-27', 118, NULL),
('The Paradise Inn', 148, '2019-06-28', 123, NULL),
('The Paradise Inn', 148, '2019-06-29', 241, NULL),
('The Paradise Inn', 148, '2019-06-30', 131, NULL),
('The Paradise Inn', 148, '2019-07-01', 301, NULL),
('The Paradise Inn', 148, '2019-07-02', 264, NULL),
('The Paradise Inn', 148, '2019-07-03', 316, NULL),
('The Paradise Inn', 148, '2019-07-04', 220, NULL),
('The Paradise Inn', 148, '2019-07-05', 236, NULL),
('The Paradise Inn', 148, '2019-07-06', 296, NULL),
('The Paradise Inn', 148, '2019-07-07', 114, NULL),
('The Paradise Inn', 148, '2019-07-08', 196, NULL),
('The Paradise Inn', 148, '2019-07-09', 284, NULL),
('The Paradise Inn', 148, '2019-07-10', 195, NULL),
('The Paradise Inn', 148, '2019-07-11', 188, NULL),
('The Paradise Inn', 148, '2019-07-12', 370, NULL),
('The Paradise Inn', 148, '2019-07-13', 348, NULL),
('The Paradise Inn', 148, '2019-07-14', 131, NULL),
('The Paradise Inn', 148, '2019-07-15', 112, NULL),
('The Paradise Inn', 148, '2019-07-16', 334, NULL),
('The Paradise Inn', 148, '2019-07-17', 311, NULL),
('The Paradise Inn', 148, '2019-07-18', 391, NULL),
('The Paradise Inn', 148, '2019-07-19', 279, NULL),
('The Paradise Inn', 148, '2019-07-20', 205, NULL),
('The Paradise Inn', 148, '2019-07-21', 368, NULL),
('The Paradise Inn', 148, '2019-07-22', 129, NULL),
('The Paradise Inn', 148, '2019-07-23', 141, NULL),
('The Paradise Inn', 148, '2019-07-24', 160, NULL),
('The Paradise Inn', 148, '2019-07-25', 189, NULL),
('The Paradise Inn', 148, '2019-07-26', 386, NULL),
('The Paradise Inn', 148, '2019-07-27', 142, NULL),
('The Paradise Inn', 148, '2019-07-28', 394, NULL),
('The Paradise Inn', 148, '2019-07-29', 264, NULL),
('The Paradise Inn', 148, '2019-07-30', 277, NULL),
('The Paradise Inn', 148, '2019-07-31', 128, NULL),
('The Paradise Inn', 148, '2019-08-01', 340, NULL),
('The Paradise Inn', 148, '2019-08-02', 145, NULL),
('The Paradise Inn', 148, '2019-08-03', 240, NULL),
('The Paradise Inn', 148, '2019-08-04', 319, NULL),
('The Paradise Inn', 148, '2019-08-05', 371, NULL),
('The Paradise Inn', 148, '2019-08-06', 208, NULL),
('The Paradise Inn', 148, '2019-08-07', 346, NULL),
('The Paradise Inn', 148, '2019-08-08', 316, NULL),
('The Paradise Inn', 148, '2019-08-09', 147, NULL),
('The Paradise Inn', 148, '2019-08-10', 223, NULL),
('The Paradise Inn', 148, '2019-08-11', 373, NULL),
('The Paradise Inn', 148, '2019-08-12', 273, NULL),
('The Paradise Inn', 148, '2019-08-13', 367, NULL),
('The Paradise Inn', 148, '2019-08-14', 339, NULL),
('The Paradise Inn', 148, '2019-08-15', 378, NULL),
('The Paradise Inn', 148, '2019-08-16', 277, NULL),
('The Paradise Inn', 148, '2019-08-17', 255, NULL),
('The Paradise Inn', 148, '2019-08-18', 240, NULL),
('The Paradise Inn', 148, '2019-08-19', 263, NULL),
('The Paradise Inn', 148, '2019-08-20', 167, NULL),
('The Paradise Inn', 148, '2019-08-21', 387, NULL),
('The Paradise Inn', 148, '2019-08-22', 181, NULL),
('The Paradise Inn', 148, '2019-08-23', 285, NULL),
('The Paradise Inn', 148, '2019-08-24', 264, NULL),
('The Paradise Inn', 148, '2019-08-25', 297, NULL),
('The Paradise Inn', 148, '2019-08-26', 257, NULL),
('The Paradise Inn', 148, '2019-08-27', 196, NULL),
('The Paradise Inn', 148, '2019-08-28', 246, NULL),
('The Paradise Inn', 148, '2019-08-29', 268, NULL),
('The Paradise Inn', 148, '2019-08-30', 223, NULL),
('The Paradise Inn', 148, '2019-08-31', 302, NULL),
('The Paradise Inn', 148, '2019-09-01', 158, NULL),
('The Paradise Inn', 148, '2019-09-02', 318, NULL),
('The Paradise Inn', 148, '2019-09-03', 244, NULL),
('The Paradise Inn', 148, '2019-09-04', 253, NULL),
('The Paradise Inn', 148, '2019-09-05', 119, NULL),
('The Paradise Inn', 148, '2019-09-06', 278, NULL),
('The Paradise Inn', 148, '2019-09-07', 372, NULL),
('The Paradise Inn', 148, '2019-09-08', 254, NULL),
('The Paradise Inn', 148, '2019-09-09', 157, NULL),
('The Paradise Inn', 148, '2019-09-10', 252, NULL),
('The Paradise Inn', 148, '2019-09-11', 399, NULL),
('The Paradise Inn', 148, '2019-09-12', 304, NULL),
('The Paradise Inn', 148, '2019-09-13', 370, NULL),
('The Paradise Inn', 148, '2019-09-14', 206, NULL),
('The Paradise Inn', 148, '2019-09-15', 358, NULL),
('The Paradise Inn', 148, '2019-09-16', 349, NULL),
('The Paradise Inn', 148, '2019-09-17', 142, NULL),
('The Paradise Inn', 148, '2019-09-18', 340, NULL),
('The Paradise Inn', 148, '2019-09-19', 170, NULL),
('The Paradise Inn', 148, '2019-09-20', 182, NULL),
('The Paradise Inn', 148, '2019-09-21', 191, NULL),
('The Paradise Inn', 148, '2019-09-22', 365, NULL),
('The Paradise Inn', 148, '2019-09-23', 298, NULL),
('The Paradise Inn', 148, '2019-09-24', 271, NULL),
('The Paradise Inn', 148, '2019-09-25', 342, NULL),
('The Paradise Inn', 148, '2019-09-26', 392, NULL),
('The Paradise Inn', 148, '2019-09-27', 105, NULL),
('The Paradise Inn', 148, '2019-09-28', 109, NULL),
('The Paradise Inn', 148, '2019-09-29', 268, NULL),
('The Paradise Inn', 148, '2019-09-30', 362, NULL),
('The Paradise Inn', 148, '2019-10-01', 311, NULL),
('The Paradise Inn', 148, '2019-10-02', 151, NULL),
('The Paradise Inn', 148, '2019-10-03', 186, NULL),
('The Paradise Inn', 148, '2019-10-04', 267, NULL),
('The Paradise Inn', 148, '2019-10-05', 190, NULL),
('The Paradise Inn', 148, '2019-10-06', 372, NULL),
('The Paradise Inn', 148, '2019-10-07', 216, NULL),
('The Paradise Inn', 148, '2019-10-08', 346, NULL),
('The Paradise Inn', 148, '2019-10-09', 316, NULL),
('The Paradise Inn', 148, '2019-10-10', 198, NULL),
('The Paradise Inn', 148, '2019-10-11', 360, NULL),
('The Paradise Inn', 148, '2019-10-12', 330, NULL),
('The Paradise Inn', 148, '2019-10-13', 218, NULL),
('The Paradise Inn', 148, '2019-10-14', 146, NULL),
('The Paradise Inn', 148, '2019-10-15', 384, NULL),
('The Paradise Inn', 148, '2019-10-16', 376, NULL),
('The Paradise Inn', 148, '2019-10-17', 124, NULL),
('The Paradise Inn', 148, '2019-10-18', 144, NULL),
('The Paradise Inn', 148, '2019-10-19', 112, NULL),
('The Paradise Inn', 148, '2019-10-20', 175, NULL),
('The Paradise Inn', 148, '2019-10-21', 220, NULL),
('The Paradise Inn', 148, '2019-10-22', 288, NULL),
('The Paradise Inn', 148, '2019-10-23', 247, NULL),
('The Paradise Inn', 148, '2019-10-24', 397, NULL),
('The Paradise Inn', 148, '2019-10-25', 222, NULL),
('The Paradise Inn', 148, '2019-10-26', 210, NULL),
('The Paradise Inn', 148, '2019-10-27', 283, NULL),
('The Paradise Inn', 148, '2019-10-28', 395, NULL),
('The Paradise Inn', 148, '2019-10-29', 356, NULL),
('The Paradise Inn', 148, '2019-10-30', 197, NULL),
('The Paradise Inn', 148, '2019-10-31', 123, NULL),
('The Paradise Inn', 148, '2019-11-01', 112, NULL),
('The Paradise Inn', 148, '2019-11-02', 358, NULL),
('The Paradise Inn', 148, '2019-11-03', 289, NULL),
('The Paradise Inn', 148, '2019-11-04', 113, NULL),
('The Paradise Inn', 148, '2019-11-05', 298, NULL),
('The Paradise Inn', 148, '2019-11-06', 135, NULL),
('The Paradise Inn', 148, '2019-11-07', 303, NULL),
('The Paradise Inn', 148, '2019-11-08', 203, NULL),
('The Paradise Inn', 148, '2019-11-09', 355, NULL),
('The Paradise Inn', 148, '2019-11-10', 387, NULL),
('The Paradise Inn', 148, '2019-11-11', 148, NULL),
('The Paradise Inn', 148, '2019-11-12', 184, NULL),
('The Paradise Inn', 148, '2019-11-13', 273, NULL),
('The Paradise Inn', 148, '2019-11-14', 301, NULL),
('The Paradise Inn', 148, '2019-11-15', 301, NULL),
('The Paradise Inn', 148, '2019-11-16', 282, NULL),
('The Paradise Inn', 148, '2019-11-17', 386, NULL),
('The Paradise Inn', 148, '2019-11-18', 392, NULL),
('The Paradise Inn', 148, '2019-11-19', 370, NULL),
('The Paradise Inn', 148, '2019-11-20', 151, NULL),
('The Paradise Inn', 148, '2019-11-21', 234, NULL),
('The Paradise Inn', 148, '2019-11-22', 168, NULL),
('The Paradise Inn', 148, '2019-11-23', 218, NULL),
('The Paradise Inn', 148, '2019-11-24', 210, NULL),
('The Paradise Inn', 148, '2019-11-25', 146, NULL),
('The Paradise Inn', 148, '2019-11-26', 355, NULL),
('The Paradise Inn', 148, '2019-11-27', 199, NULL),
('The Paradise Inn', 148, '2019-11-28', 172, NULL),
('The Paradise Inn', 148, '2019-11-29', 366, NULL),
('The Paradise Inn', 148, '2019-11-30', 115, NULL),
('The Paradise Inn', 148, '2019-12-01', 339, NULL),
('The Paradise Inn', 148, '2019-12-02', 230, NULL),
('The Paradise Inn', 148, '2019-12-03', 160, NULL),
('The Paradise Inn', 148, '2019-12-04', 314, NULL),
('The Paradise Inn', 148, '2019-12-05', 356, NULL),
('The Paradise Inn', 148, '2019-12-06', 244, NULL),
('The Paradise Inn', 148, '2019-12-07', 345, NULL),
('The Paradise Inn', 148, '2019-12-08', 347, NULL),
('The Paradise Inn', 148, '2019-12-09', 341, NULL),
('The Paradise Inn', 148, '2019-12-10', 205, NULL),
('The Paradise Inn', 148, '2019-12-11', 343, NULL),
('The Paradise Inn', 148, '2019-12-12', 398, NULL),
('The Paradise Inn', 148, '2019-12-13', 243, NULL),
('The Paradise Inn', 148, '2019-12-14', 107, NULL),
('The Paradise Inn', 148, '2019-12-15', 184, NULL),
('The Paradise Inn', 148, '2019-12-16', 323, NULL),
('The Paradise Inn', 148, '2019-12-17', 356, NULL),
('The Paradise Inn', 148, '2019-12-18', 293, NULL),
('The Paradise Inn', 148, '2019-12-19', 154, NULL),
('The Paradise Inn', 148, '2019-12-20', 125, NULL),
('The Paradise Inn', 148, '2019-12-21', 334, NULL),
('The Paradise Inn', 148, '2019-12-22', 157, NULL),
('The Paradise Inn', 148, '2019-12-23', 352, NULL),
('The Paradise Inn', 148, '2019-12-24', 143, NULL),
('The Paradise Inn', 148, '2019-12-25', 231, NULL),
('The Paradise Inn', 148, '2019-12-26', 316, NULL),
('The Paradise Inn', 148, '2019-12-27', 131, NULL),
('The Paradise Inn', 148, '2019-12-28', 185, NULL),
('The Paradise Inn', 148, '2019-12-29', 114, NULL),
('The Paradise Inn', 148, '2019-12-30', 216, NULL),
('The Paradise Inn', 148, '2019-12-31', 281, NULL),
('The Paradise Inn', 148, '2020-01-01', 221, NULL),
('The Paradise Inn', 148, '2020-01-02', 155, NULL),
('The Paradise Inn', 148, '2020-01-03', 223, NULL),
('The Paradise Inn', 148, '2020-01-04', 140, NULL),
('The Paradise Inn', 148, '2020-01-05', 103, NULL),
('The Paradise Inn', 148, '2020-01-06', 372, NULL),
('The Paradise Inn', 148, '2020-01-07', 184, NULL),
('The Paradise Inn', 148, '2020-01-08', 145, NULL),
('The Paradise Inn', 148, '2020-01-09', 118, NULL),
('The Paradise Inn', 148, '2020-01-10', 294, NULL),
('The Paradise Inn', 148, '2020-01-11', 154, NULL),
('The Paradise Inn', 148, '2020-01-12', 211, NULL),
('The Paradise Inn', 148, '2020-01-13', 391, NULL),
('The Paradise Inn', 148, '2020-01-14', 329, NULL),
('The Paradise Inn', 148, '2020-01-15', 293, NULL),
('The Paradise Inn', 148, '2020-01-16', 173, NULL),
('The Paradise Inn', 148, '2020-01-17', 377, NULL),
('The Paradise Inn', 148, '2020-01-18', 359, NULL),
('The Paradise Inn', 148, '2020-01-19', 350, NULL),
('The Paradise Inn', 148, '2020-01-20', 369, NULL),
('The Paradise Inn', 148, '2020-01-21', 107, NULL),
('The Paradise Inn', 148, '2020-01-22', 103, NULL),
('The Paradise Inn', 148, '2020-01-23', 219, NULL),
('The Paradise Inn', 148, '2020-01-24', 341, NULL),
('The Paradise Inn', 148, '2020-01-25', 296, NULL),
('The Paradise Inn', 148, '2020-01-26', 364, NULL),
('The Paradise Inn', 148, '2020-01-27', 241, NULL),
('The Paradise Inn', 148, '2020-01-28', 249, NULL),
('The Paradise Inn', 148, '2020-01-29', 102, NULL),
('The Paradise Inn', 148, '2020-01-30', 197, NULL),
('The Paradise Inn', 148, '2020-01-31', 338, NULL),
('The Paradise Inn', 148, '2020-02-01', 390, NULL),
('The Paradise Inn', 148, '2020-02-02', 360, NULL),
('The Paradise Inn', 148, '2020-02-03', 339, NULL),
('The Paradise Inn', 148, '2020-02-04', 265, NULL),
('The Paradise Inn', 159, '2019-01-01', 229, NULL),
('The Paradise Inn', 159, '2019-01-02', 274, NULL),
('The Paradise Inn', 159, '2019-01-03', 272, NULL),
('The Paradise Inn', 159, '2019-01-04', 132, NULL),
('The Paradise Inn', 159, '2019-01-05', 386, NULL),
('The Paradise Inn', 159, '2019-01-06', 290, NULL),
('The Paradise Inn', 159, '2019-01-07', 112, NULL),
('The Paradise Inn', 159, '2019-01-08', 368, NULL),
('The Paradise Inn', 159, '2019-01-09', 392, NULL),
('The Paradise Inn', 159, '2019-01-10', 375, NULL),
('The Paradise Inn', 159, '2019-01-11', 232, NULL),
('The Paradise Inn', 159, '2019-01-12', 309, NULL),
('The Paradise Inn', 159, '2019-01-13', 364, NULL),
('The Paradise Inn', 159, '2019-01-14', 209, NULL),
('The Paradise Inn', 159, '2019-01-15', 245, NULL),
('The Paradise Inn', 159, '2019-01-16', 319, NULL),
('The Paradise Inn', 159, '2019-01-17', 158, NULL),
('The Paradise Inn', 159, '2019-01-18', 143, NULL),
('The Paradise Inn', 159, '2019-01-19', 227, NULL),
('The Paradise Inn', 159, '2019-01-20', 345, NULL),
('The Paradise Inn', 159, '2019-01-21', 169, NULL),
('The Paradise Inn', 159, '2019-01-22', 242, NULL),
('The Paradise Inn', 159, '2019-01-23', 242, NULL),
('The Paradise Inn', 159, '2019-01-24', 124, NULL),
('The Paradise Inn', 159, '2019-01-25', 277, NULL),
('The Paradise Inn', 159, '2019-01-26', 205, NULL),
('The Paradise Inn', 159, '2019-01-27', 395, NULL),
('The Paradise Inn', 159, '2019-01-28', 155, NULL),
('The Paradise Inn', 159, '2019-01-29', 156, NULL),
('The Paradise Inn', 159, '2019-01-30', 223, NULL),
('The Paradise Inn', 159, '2019-01-31', 339, NULL),
('The Paradise Inn', 159, '2019-02-01', 244, NULL),
('The Paradise Inn', 159, '2019-02-02', 234, NULL),
('The Paradise Inn', 159, '2019-02-03', 104, NULL),
('The Paradise Inn', 159, '2019-02-04', 181, NULL),
('The Paradise Inn', 159, '2019-02-05', 259, NULL),
('The Paradise Inn', 159, '2019-02-06', 213, NULL),
('The Paradise Inn', 159, '2019-02-07', 100, NULL),
('The Paradise Inn', 159, '2019-02-08', 325, NULL),
('The Paradise Inn', 159, '2019-02-09', 136, NULL),
('The Paradise Inn', 159, '2019-02-10', 313, NULL),
('The Paradise Inn', 159, '2019-02-11', 365, NULL),
('The Paradise Inn', 159, '2019-02-12', 393, NULL),
('The Paradise Inn', 159, '2019-02-13', 261, NULL),
('The Paradise Inn', 159, '2019-02-14', 295, NULL),
('The Paradise Inn', 159, '2019-02-15', 333, NULL),
('The Paradise Inn', 159, '2019-02-16', 246, NULL),
('The Paradise Inn', 159, '2019-02-17', 304, NULL),
('The Paradise Inn', 159, '2019-02-18', 304, NULL),
('The Paradise Inn', 159, '2019-02-19', 352, NULL),
('The Paradise Inn', 159, '2019-02-20', 223, NULL),
('The Paradise Inn', 159, '2019-02-21', 210, NULL),
('The Paradise Inn', 159, '2019-02-22', 340, NULL),
('The Paradise Inn', 159, '2019-02-23', 264, NULL),
('The Paradise Inn', 159, '2019-02-24', 147, NULL),
('The Paradise Inn', 159, '2019-02-25', 223, NULL),
('The Paradise Inn', 159, '2019-02-26', 103, NULL),
('The Paradise Inn', 159, '2019-02-27', 136, NULL),
('The Paradise Inn', 159, '2019-02-28', 352, NULL),
('The Paradise Inn', 159, '2019-03-01', 142, NULL),
('The Paradise Inn', 159, '2019-03-02', 395, NULL),
('The Paradise Inn', 159, '2019-03-03', 132, NULL),
('The Paradise Inn', 159, '2019-03-04', 154, NULL),
('The Paradise Inn', 159, '2019-03-05', 233, NULL),
('The Paradise Inn', 159, '2019-03-06', 177, NULL),
('The Paradise Inn', 159, '2019-03-07', 337, NULL),
('The Paradise Inn', 159, '2019-03-08', 101, NULL),
('The Paradise Inn', 159, '2019-03-09', 258, NULL),
('The Paradise Inn', 159, '2019-03-10', 328, NULL),
('The Paradise Inn', 159, '2019-03-11', 287, NULL),
('The Paradise Inn', 159, '2019-03-12', 297, NULL),
('The Paradise Inn', 159, '2019-03-13', 307, NULL),
('The Paradise Inn', 159, '2019-03-14', 285, NULL),
('The Paradise Inn', 159, '2019-03-15', 220, NULL),
('The Paradise Inn', 159, '2019-03-16', 320, NULL),
('The Paradise Inn', 159, '2019-03-17', 290, NULL),
('The Paradise Inn', 159, '2019-03-18', 355, NULL),
('The Paradise Inn', 159, '2019-03-19', 232, NULL),
('The Paradise Inn', 159, '2019-03-20', 129, NULL),
('The Paradise Inn', 159, '2019-03-21', 199, NULL),
('The Paradise Inn', 159, '2019-03-22', 259, NULL),
('The Paradise Inn', 159, '2019-03-23', 171, NULL),
('The Paradise Inn', 159, '2019-03-24', 329, NULL),
('The Paradise Inn', 159, '2019-03-25', 277, NULL),
('The Paradise Inn', 159, '2019-03-26', 132, NULL),
('The Paradise Inn', 159, '2019-03-27', 338, NULL),
('The Paradise Inn', 159, '2019-03-28', 179, NULL),
('The Paradise Inn', 159, '2019-03-29', 328, NULL),
('The Paradise Inn', 159, '2019-03-30', 208, NULL),
('The Paradise Inn', 159, '2019-03-31', 182, NULL),
('The Paradise Inn', 159, '2019-04-01', 217, NULL),
('The Paradise Inn', 159, '2019-04-02', 392, NULL),
('The Paradise Inn', 159, '2019-04-03', 147, NULL),
('The Paradise Inn', 159, '2019-04-04', 347, NULL),
('The Paradise Inn', 159, '2019-04-05', 303, NULL),
('The Paradise Inn', 159, '2019-04-06', 104, NULL),
('The Paradise Inn', 159, '2019-04-07', 327, NULL),
('The Paradise Inn', 159, '2019-04-08', 196, NULL),
('The Paradise Inn', 159, '2019-04-09', 158, NULL),
('The Paradise Inn', 159, '2019-04-10', 245, NULL),
('The Paradise Inn', 159, '2019-04-11', 116, NULL),
('The Paradise Inn', 159, '2019-04-12', 226, NULL),
('The Paradise Inn', 159, '2019-04-13', 107, NULL),
('The Paradise Inn', 159, '2019-04-14', 104, NULL),
('The Paradise Inn', 159, '2019-04-15', 395, NULL),
('The Paradise Inn', 159, '2019-04-16', 290, NULL),
('The Paradise Inn', 159, '2019-04-17', 373, NULL),
('The Paradise Inn', 159, '2019-04-18', 194, NULL),
('The Paradise Inn', 159, '2019-04-19', 163, NULL),
('The Paradise Inn', 159, '2019-04-20', 158, NULL),
('The Paradise Inn', 159, '2019-04-21', 198, NULL),
('The Paradise Inn', 159, '2019-04-22', 158, NULL),
('The Paradise Inn', 159, '2019-04-23', 362, NULL),
('The Paradise Inn', 159, '2019-04-24', 148, NULL),
('The Paradise Inn', 159, '2019-04-25', 243, NULL),
('The Paradise Inn', 159, '2019-04-26', 293, NULL),
('The Paradise Inn', 159, '2019-04-27', 214, NULL),
('The Paradise Inn', 159, '2019-04-28', 248, NULL),
('The Paradise Inn', 159, '2019-04-29', 306, NULL),
('The Paradise Inn', 159, '2019-04-30', 277, NULL),
('The Paradise Inn', 159, '2019-05-01', 381, NULL),
('The Paradise Inn', 159, '2019-05-02', 222, NULL),
('The Paradise Inn', 159, '2019-05-03', 354, NULL),
('The Paradise Inn', 159, '2019-05-04', 319, NULL),
('The Paradise Inn', 159, '2019-05-05', 148, NULL),
('The Paradise Inn', 159, '2019-05-06', 373, NULL),
('The Paradise Inn', 159, '2019-05-07', 364, NULL),
('The Paradise Inn', 159, '2019-05-08', 372, NULL),
('The Paradise Inn', 159, '2019-05-09', 150, NULL),
('The Paradise Inn', 159, '2019-05-10', 266, NULL),
('The Paradise Inn', 159, '2019-05-11', 370, NULL),
('The Paradise Inn', 159, '2019-05-12', 284, NULL),
('The Paradise Inn', 159, '2019-05-13', 376, NULL),
('The Paradise Inn', 159, '2019-05-14', 307, NULL),
('The Paradise Inn', 159, '2019-05-15', 122, NULL),
('The Paradise Inn', 159, '2019-05-16', 162, NULL),
('The Paradise Inn', 159, '2019-05-17', 158, NULL),
('The Paradise Inn', 159, '2019-05-18', 398, NULL),
('The Paradise Inn', 159, '2019-05-19', 289, NULL),
('The Paradise Inn', 159, '2019-05-20', 378, NULL),
('The Paradise Inn', 159, '2019-05-21', 227, NULL),
('The Paradise Inn', 159, '2019-05-22', 279, NULL),
('The Paradise Inn', 159, '2019-05-23', 218, NULL),
('The Paradise Inn', 159, '2019-05-24', 328, NULL),
('The Paradise Inn', 159, '2019-05-25', 292, NULL),
('The Paradise Inn', 159, '2019-05-26', 155, NULL),
('The Paradise Inn', 159, '2019-05-27', 195, NULL),
('The Paradise Inn', 159, '2019-05-28', 257, NULL),
('The Paradise Inn', 159, '2019-05-29', 355, NULL),
('The Paradise Inn', 159, '2019-05-30', 366, NULL),
('The Paradise Inn', 159, '2019-05-31', 327, NULL),
('The Paradise Inn', 159, '2019-06-01', 174, NULL),
('The Paradise Inn', 159, '2019-06-02', 296, NULL),
('The Paradise Inn', 159, '2019-06-03', 150, NULL),
('The Paradise Inn', 159, '2019-06-04', 205, NULL),
('The Paradise Inn', 159, '2019-06-05', 196, NULL),
('The Paradise Inn', 159, '2019-06-06', 162, NULL),
('The Paradise Inn', 159, '2019-06-07', 367, NULL),
('The Paradise Inn', 159, '2019-06-08', 129, NULL),
('The Paradise Inn', 159, '2019-06-09', 244, NULL),
('The Paradise Inn', 159, '2019-06-10', 328, NULL),
('The Paradise Inn', 159, '2019-06-11', 126, NULL),
('The Paradise Inn', 159, '2019-06-12', 187, NULL),
('The Paradise Inn', 159, '2019-06-13', 140, NULL),
('The Paradise Inn', 159, '2019-06-14', 116, NULL),
('The Paradise Inn', 159, '2019-06-15', 357, NULL),
('The Paradise Inn', 159, '2019-06-16', 315, NULL),
('The Paradise Inn', 159, '2019-06-17', 152, NULL),
('The Paradise Inn', 159, '2019-06-18', 319, NULL),
('The Paradise Inn', 159, '2019-06-19', 114, NULL),
('The Paradise Inn', 159, '2019-06-20', 223, NULL),
('The Paradise Inn', 159, '2019-06-21', 285, NULL),
('The Paradise Inn', 159, '2019-06-22', 185, NULL),
('The Paradise Inn', 159, '2019-06-23', 171, NULL),
('The Paradise Inn', 159, '2019-06-24', 202, NULL),
('The Paradise Inn', 159, '2019-06-25', 139, NULL),
('The Paradise Inn', 159, '2019-06-26', 203, NULL),
('The Paradise Inn', 159, '2019-06-27', 350, NULL),
('The Paradise Inn', 159, '2019-06-28', 351, NULL),
('The Paradise Inn', 159, '2019-06-29', 321, NULL),
('The Paradise Inn', 159, '2019-06-30', 270, NULL),
('The Paradise Inn', 159, '2019-07-01', 232, NULL),
('The Paradise Inn', 159, '2019-07-02', 310, NULL),
('The Paradise Inn', 159, '2019-07-03', 143, NULL),
('The Paradise Inn', 159, '2019-07-04', 242, NULL),
('The Paradise Inn', 159, '2019-07-05', 196, NULL),
('The Paradise Inn', 159, '2019-07-06', 250, NULL),
('The Paradise Inn', 159, '2019-07-07', 264, NULL),
('The Paradise Inn', 159, '2019-07-08', 144, NULL),
('The Paradise Inn', 159, '2019-07-09', 295, NULL),
('The Paradise Inn', 159, '2019-07-10', 108, NULL),
('The Paradise Inn', 159, '2019-07-11', 114, NULL),
('The Paradise Inn', 159, '2019-07-12', 200, NULL),
('The Paradise Inn', 159, '2019-07-13', 164, NULL),
('The Paradise Inn', 159, '2019-07-14', 355, NULL),
('The Paradise Inn', 159, '2019-07-15', 332, NULL),
('The Paradise Inn', 159, '2019-07-16', 181, NULL),
('The Paradise Inn', 159, '2019-07-17', 330, NULL),
('The Paradise Inn', 159, '2019-07-18', 374, NULL),
('The Paradise Inn', 159, '2019-07-19', 207, NULL),
('The Paradise Inn', 159, '2019-07-20', 289, NULL),
('The Paradise Inn', 159, '2019-07-21', 221, NULL),
('The Paradise Inn', 159, '2019-07-22', 320, NULL),
('The Paradise Inn', 159, '2019-07-23', 345, NULL),
('The Paradise Inn', 159, '2019-07-24', 178, NULL),
('The Paradise Inn', 159, '2019-07-25', 380, NULL),
('The Paradise Inn', 159, '2019-07-26', 206, NULL),
('The Paradise Inn', 159, '2019-07-27', 109, NULL),
('The Paradise Inn', 159, '2019-07-28', 144, NULL),
('The Paradise Inn', 159, '2019-07-29', 102, NULL),
('The Paradise Inn', 159, '2019-07-30', 288, NULL),
('The Paradise Inn', 159, '2019-07-31', 101, NULL),
('The Paradise Inn', 159, '2019-08-01', 378, NULL),
('The Paradise Inn', 159, '2019-08-02', 103, NULL),
('The Paradise Inn', 159, '2019-08-03', 219, NULL),
('The Paradise Inn', 159, '2019-08-04', 300, NULL),
('The Paradise Inn', 159, '2019-08-05', 341, NULL),
('The Paradise Inn', 159, '2019-08-06', 158, NULL),
('The Paradise Inn', 159, '2019-08-07', 139, NULL),
('The Paradise Inn', 159, '2019-08-08', 245, NULL),
('The Paradise Inn', 159, '2019-08-09', 319, NULL),
('The Paradise Inn', 159, '2019-08-10', 358, NULL),
('The Paradise Inn', 159, '2019-08-11', 340, NULL),
('The Paradise Inn', 159, '2019-08-12', 390, NULL),
('The Paradise Inn', 159, '2019-08-13', 259, NULL),
('The Paradise Inn', 159, '2019-08-14', 104, NULL),
('The Paradise Inn', 159, '2019-08-15', 367, NULL),
('The Paradise Inn', 159, '2019-08-16', 112, NULL),
('The Paradise Inn', 159, '2019-08-17', 176, NULL),
('The Paradise Inn', 159, '2019-08-18', 233, NULL),
('The Paradise Inn', 159, '2019-08-19', 284, NULL),
('The Paradise Inn', 159, '2019-08-20', 142, NULL),
('The Paradise Inn', 159, '2019-08-21', 353, NULL),
('The Paradise Inn', 159, '2019-08-22', 141, NULL),
('The Paradise Inn', 159, '2019-08-23', 210, NULL),
('The Paradise Inn', 159, '2019-08-24', 149, NULL),
('The Paradise Inn', 159, '2019-08-25', 377, NULL),
('The Paradise Inn', 159, '2019-08-26', 187, NULL),
('The Paradise Inn', 159, '2019-08-27', 164, NULL),
('The Paradise Inn', 159, '2019-08-28', 339, NULL),
('The Paradise Inn', 159, '2019-08-29', 373, NULL),
('The Paradise Inn', 159, '2019-08-30', 102, NULL),
('The Paradise Inn', 159, '2019-08-31', 200, NULL),
('The Paradise Inn', 159, '2019-09-01', 320, NULL),
('The Paradise Inn', 159, '2019-09-02', 235, NULL),
('The Paradise Inn', 159, '2019-09-03', 114, NULL),
('The Paradise Inn', 159, '2019-09-04', 297, NULL),
('The Paradise Inn', 159, '2019-09-05', 237, NULL),
('The Paradise Inn', 159, '2019-09-06', 329, NULL),
('The Paradise Inn', 159, '2019-09-07', 137, NULL),
('The Paradise Inn', 159, '2019-09-08', 171, NULL),
('The Paradise Inn', 159, '2019-09-09', 341, NULL),
('The Paradise Inn', 159, '2019-09-10', 286, NULL),
('The Paradise Inn', 159, '2019-09-11', 248, NULL),
('The Paradise Inn', 159, '2019-09-12', 214, NULL),
('The Paradise Inn', 159, '2019-09-13', 341, NULL),
('The Paradise Inn', 159, '2019-09-14', 159, NULL),
('The Paradise Inn', 159, '2019-09-15', 303, NULL),
('The Paradise Inn', 159, '2019-09-16', 161, NULL),
('The Paradise Inn', 159, '2019-09-17', 259, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 159, '2019-09-18', 176, NULL),
('The Paradise Inn', 159, '2019-09-19', 392, NULL),
('The Paradise Inn', 159, '2019-09-20', 277, NULL),
('The Paradise Inn', 159, '2019-09-21', 230, NULL),
('The Paradise Inn', 159, '2019-09-22', 125, NULL),
('The Paradise Inn', 159, '2019-09-23', 200, NULL),
('The Paradise Inn', 159, '2019-09-24', 159, NULL),
('The Paradise Inn', 159, '2019-09-25', 257, NULL),
('The Paradise Inn', 159, '2019-09-26', 329, NULL),
('The Paradise Inn', 159, '2019-09-27', 237, NULL),
('The Paradise Inn', 159, '2019-09-28', 384, NULL),
('The Paradise Inn', 159, '2019-09-29', 218, NULL),
('The Paradise Inn', 159, '2019-09-30', 227, NULL),
('The Paradise Inn', 159, '2019-10-01', 113, NULL),
('The Paradise Inn', 159, '2019-10-02', 258, NULL),
('The Paradise Inn', 159, '2019-10-03', 268, NULL),
('The Paradise Inn', 159, '2019-10-04', 282, NULL),
('The Paradise Inn', 159, '2019-10-05', 204, NULL),
('The Paradise Inn', 159, '2019-10-06', 352, NULL),
('The Paradise Inn', 159, '2019-10-07', 178, NULL),
('The Paradise Inn', 159, '2019-10-08', 186, NULL),
('The Paradise Inn', 159, '2019-10-09', 347, NULL),
('The Paradise Inn', 159, '2019-10-10', 252, NULL),
('The Paradise Inn', 159, '2019-10-11', 192, NULL),
('The Paradise Inn', 159, '2019-10-12', 190, NULL),
('The Paradise Inn', 159, '2019-10-13', 384, NULL),
('The Paradise Inn', 159, '2019-10-14', 209, NULL),
('The Paradise Inn', 159, '2019-10-15', 112, NULL),
('The Paradise Inn', 159, '2019-10-16', 138, NULL),
('The Paradise Inn', 159, '2019-10-17', 233, NULL),
('The Paradise Inn', 159, '2019-10-18', 367, NULL),
('The Paradise Inn', 159, '2019-10-19', 325, NULL),
('The Paradise Inn', 159, '2019-10-20', 320, NULL),
('The Paradise Inn', 159, '2019-10-21', 188, NULL),
('The Paradise Inn', 159, '2019-10-22', 356, NULL),
('The Paradise Inn', 159, '2019-10-23', 158, NULL),
('The Paradise Inn', 159, '2019-10-24', 106, NULL),
('The Paradise Inn', 159, '2019-10-25', 132, NULL),
('The Paradise Inn', 159, '2019-10-26', 237, NULL),
('The Paradise Inn', 159, '2019-10-27', 152, NULL),
('The Paradise Inn', 159, '2019-10-28', 191, NULL),
('The Paradise Inn', 159, '2019-10-29', 302, NULL),
('The Paradise Inn', 159, '2019-10-30', 247, NULL),
('The Paradise Inn', 159, '2019-10-31', 189, NULL),
('The Paradise Inn', 159, '2019-11-01', 330, NULL),
('The Paradise Inn', 159, '2019-11-02', 292, NULL),
('The Paradise Inn', 159, '2019-11-03', 129, NULL),
('The Paradise Inn', 159, '2019-11-04', 373, NULL),
('The Paradise Inn', 159, '2019-11-05', 291, NULL),
('The Paradise Inn', 159, '2019-11-06', 194, NULL),
('The Paradise Inn', 159, '2019-11-07', 262, NULL),
('The Paradise Inn', 159, '2019-11-08', 379, NULL),
('The Paradise Inn', 159, '2019-11-09', 396, NULL),
('The Paradise Inn', 159, '2019-11-10', 295, NULL),
('The Paradise Inn', 159, '2019-11-11', 117, NULL),
('The Paradise Inn', 159, '2019-11-12', 332, NULL),
('The Paradise Inn', 159, '2019-11-13', 286, NULL),
('The Paradise Inn', 159, '2019-11-14', 129, NULL),
('The Paradise Inn', 159, '2019-11-15', 119, NULL),
('The Paradise Inn', 159, '2019-11-16', 287, NULL),
('The Paradise Inn', 159, '2019-11-17', 285, NULL),
('The Paradise Inn', 159, '2019-11-18', 281, NULL),
('The Paradise Inn', 159, '2019-11-19', 113, NULL),
('The Paradise Inn', 159, '2019-11-20', 111, NULL),
('The Paradise Inn', 159, '2019-11-21', 331, NULL),
('The Paradise Inn', 159, '2019-11-22', 193, NULL),
('The Paradise Inn', 159, '2019-11-23', 287, NULL),
('The Paradise Inn', 159, '2019-11-24', 289, NULL),
('The Paradise Inn', 159, '2019-11-25', 108, NULL),
('The Paradise Inn', 159, '2019-11-26', 158, NULL),
('The Paradise Inn', 159, '2019-11-27', 364, NULL),
('The Paradise Inn', 159, '2019-11-28', 155, NULL),
('The Paradise Inn', 159, '2019-11-29', 185, NULL),
('The Paradise Inn', 159, '2019-11-30', 179, NULL),
('The Paradise Inn', 159, '2019-12-01', 281, NULL),
('The Paradise Inn', 159, '2019-12-02', 145, NULL),
('The Paradise Inn', 159, '2019-12-03', 365, NULL),
('The Paradise Inn', 159, '2019-12-04', 376, NULL),
('The Paradise Inn', 159, '2019-12-05', 173, NULL),
('The Paradise Inn', 159, '2019-12-06', 335, NULL),
('The Paradise Inn', 159, '2019-12-07', 349, NULL),
('The Paradise Inn', 159, '2019-12-08', 103, NULL),
('The Paradise Inn', 159, '2019-12-09', 198, NULL),
('The Paradise Inn', 159, '2019-12-10', 131, NULL),
('The Paradise Inn', 159, '2019-12-11', 131, NULL),
('The Paradise Inn', 159, '2019-12-12', 334, NULL),
('The Paradise Inn', 159, '2019-12-13', 362, NULL),
('The Paradise Inn', 159, '2019-12-14', 105, NULL),
('The Paradise Inn', 159, '2019-12-15', 314, NULL),
('The Paradise Inn', 159, '2019-12-16', 186, NULL),
('The Paradise Inn', 159, '2019-12-17', 238, NULL),
('The Paradise Inn', 159, '2019-12-18', 334, NULL),
('The Paradise Inn', 159, '2019-12-19', 127, NULL),
('The Paradise Inn', 159, '2019-12-20', 148, NULL),
('The Paradise Inn', 159, '2019-12-21', 207, NULL),
('The Paradise Inn', 159, '2019-12-22', 380, NULL),
('The Paradise Inn', 159, '2019-12-23', 370, NULL),
('The Paradise Inn', 159, '2019-12-24', 236, NULL),
('The Paradise Inn', 159, '2019-12-25', 182, NULL),
('The Paradise Inn', 159, '2019-12-26', 206, NULL),
('The Paradise Inn', 159, '2019-12-27', 154, NULL),
('The Paradise Inn', 159, '2019-12-28', 379, NULL),
('The Paradise Inn', 159, '2019-12-29', 146, NULL),
('The Paradise Inn', 159, '2019-12-30', 153, NULL),
('The Paradise Inn', 159, '2019-12-31', 398, NULL),
('The Paradise Inn', 159, '2020-01-01', 175, NULL),
('The Paradise Inn', 159, '2020-01-02', 340, NULL),
('The Paradise Inn', 159, '2020-01-03', 194, NULL),
('The Paradise Inn', 159, '2020-01-04', 272, NULL),
('The Paradise Inn', 159, '2020-01-05', 313, NULL),
('The Paradise Inn', 159, '2020-01-06', 322, NULL),
('The Paradise Inn', 159, '2020-01-07', 186, NULL),
('The Paradise Inn', 159, '2020-01-08', 169, NULL),
('The Paradise Inn', 159, '2020-01-09', 237, NULL),
('The Paradise Inn', 159, '2020-01-10', 150, NULL),
('The Paradise Inn', 159, '2020-01-11', 205, NULL),
('The Paradise Inn', 159, '2020-01-12', 200, NULL),
('The Paradise Inn', 159, '2020-01-13', 115, NULL),
('The Paradise Inn', 159, '2020-01-14', 281, NULL),
('The Paradise Inn', 159, '2020-01-15', 396, NULL),
('The Paradise Inn', 159, '2020-01-16', 176, NULL),
('The Paradise Inn', 159, '2020-01-17', 133, NULL),
('The Paradise Inn', 159, '2020-01-18', 145, NULL),
('The Paradise Inn', 159, '2020-01-19', 226, NULL),
('The Paradise Inn', 159, '2020-01-20', 181, NULL),
('The Paradise Inn', 159, '2020-01-21', 104, NULL),
('The Paradise Inn', 159, '2020-01-22', 365, NULL),
('The Paradise Inn', 159, '2020-01-23', 332, NULL),
('The Paradise Inn', 159, '2020-01-24', 291, NULL),
('The Paradise Inn', 159, '2020-01-25', 368, NULL),
('The Paradise Inn', 159, '2020-01-26', 338, NULL),
('The Paradise Inn', 159, '2020-01-27', 171, NULL),
('The Paradise Inn', 159, '2020-01-28', 118, NULL),
('The Paradise Inn', 159, '2020-01-29', 215, NULL),
('The Paradise Inn', 159, '2020-01-30', 312, NULL),
('The Paradise Inn', 159, '2020-01-31', 124, NULL),
('The Paradise Inn', 159, '2020-02-01', 349, NULL),
('The Paradise Inn', 159, '2020-02-02', 165, NULL),
('The Paradise Inn', 159, '2020-02-03', 359, NULL),
('The Paradise Inn', 159, '2020-02-04', 239, NULL),
('The Paradise Inn', 175, '2019-01-01', 188, NULL),
('The Paradise Inn', 175, '2019-01-02', 366, NULL),
('The Paradise Inn', 175, '2019-01-03', 195, NULL),
('The Paradise Inn', 175, '2019-01-04', 391, NULL),
('The Paradise Inn', 175, '2019-01-05', 270, NULL),
('The Paradise Inn', 175, '2019-01-06', 151, NULL),
('The Paradise Inn', 175, '2019-01-07', 261, NULL),
('The Paradise Inn', 175, '2019-01-08', 256, NULL),
('The Paradise Inn', 175, '2019-01-09', 116, NULL),
('The Paradise Inn', 175, '2019-01-10', 322, NULL),
('The Paradise Inn', 175, '2019-01-11', 379, NULL),
('The Paradise Inn', 175, '2019-01-12', 266, NULL),
('The Paradise Inn', 175, '2019-01-13', 327, NULL),
('The Paradise Inn', 175, '2019-01-14', 250, NULL),
('The Paradise Inn', 175, '2019-01-15', 225, NULL),
('The Paradise Inn', 175, '2019-01-16', 365, NULL),
('The Paradise Inn', 175, '2019-01-17', 294, NULL),
('The Paradise Inn', 175, '2019-01-18', 355, NULL),
('The Paradise Inn', 175, '2019-01-19', 307, NULL),
('The Paradise Inn', 175, '2019-01-20', 193, NULL),
('The Paradise Inn', 175, '2019-01-21', 118, NULL),
('The Paradise Inn', 175, '2019-01-22', 104, NULL),
('The Paradise Inn', 175, '2019-01-23', 342, NULL),
('The Paradise Inn', 175, '2019-01-24', 259, NULL),
('The Paradise Inn', 175, '2019-01-25', 360, NULL),
('The Paradise Inn', 175, '2019-01-26', 285, NULL),
('The Paradise Inn', 175, '2019-01-27', 205, NULL),
('The Paradise Inn', 175, '2019-01-28', 378, NULL),
('The Paradise Inn', 175, '2019-01-29', 343, NULL),
('The Paradise Inn', 175, '2019-01-30', 157, NULL),
('The Paradise Inn', 175, '2019-01-31', 139, NULL),
('The Paradise Inn', 175, '2019-02-01', 342, NULL),
('The Paradise Inn', 175, '2019-02-02', 305, NULL),
('The Paradise Inn', 175, '2019-02-03', 271, NULL),
('The Paradise Inn', 175, '2019-02-04', 148, NULL),
('The Paradise Inn', 175, '2019-02-05', 294, NULL),
('The Paradise Inn', 175, '2019-02-06', 234, NULL),
('The Paradise Inn', 175, '2019-02-07', 346, NULL),
('The Paradise Inn', 175, '2019-02-08', 330, NULL),
('The Paradise Inn', 175, '2019-02-09', 185, NULL),
('The Paradise Inn', 175, '2019-02-10', 153, NULL),
('The Paradise Inn', 175, '2019-02-11', 137, NULL),
('The Paradise Inn', 175, '2019-02-12', 266, NULL),
('The Paradise Inn', 175, '2019-02-13', 351, NULL),
('The Paradise Inn', 175, '2019-02-14', 288, NULL),
('The Paradise Inn', 175, '2019-02-15', 166, NULL),
('The Paradise Inn', 175, '2019-02-16', 140, NULL),
('The Paradise Inn', 175, '2019-02-17', 105, NULL),
('The Paradise Inn', 175, '2019-02-18', 228, NULL),
('The Paradise Inn', 175, '2019-02-19', 369, NULL),
('The Paradise Inn', 175, '2019-02-20', 347, NULL),
('The Paradise Inn', 175, '2019-02-21', 259, NULL),
('The Paradise Inn', 175, '2019-02-22', 310, NULL),
('The Paradise Inn', 175, '2019-02-23', 312, NULL),
('The Paradise Inn', 175, '2019-02-24', 378, NULL),
('The Paradise Inn', 175, '2019-02-25', 329, NULL),
('The Paradise Inn', 175, '2019-02-26', 112, NULL),
('The Paradise Inn', 175, '2019-02-27', 108, NULL),
('The Paradise Inn', 175, '2019-02-28', 232, NULL),
('The Paradise Inn', 175, '2019-03-01', 188, NULL),
('The Paradise Inn', 175, '2019-03-02', 144, NULL),
('The Paradise Inn', 175, '2019-03-03', 202, NULL),
('The Paradise Inn', 175, '2019-03-04', 109, NULL),
('The Paradise Inn', 175, '2019-03-05', 344, NULL),
('The Paradise Inn', 175, '2019-03-06', 351, NULL),
('The Paradise Inn', 175, '2019-03-07', 297, NULL),
('The Paradise Inn', 175, '2019-03-08', 321, NULL),
('The Paradise Inn', 175, '2019-03-09', 257, NULL),
('The Paradise Inn', 175, '2019-03-10', 237, NULL),
('The Paradise Inn', 175, '2019-03-11', 148, NULL),
('The Paradise Inn', 175, '2019-03-12', 320, NULL),
('The Paradise Inn', 175, '2019-03-13', 171, NULL),
('The Paradise Inn', 175, '2019-03-14', 348, NULL),
('The Paradise Inn', 175, '2019-03-15', 275, NULL),
('The Paradise Inn', 175, '2019-03-16', 369, NULL),
('The Paradise Inn', 175, '2019-03-17', 384, NULL),
('The Paradise Inn', 175, '2019-03-18', 206, NULL),
('The Paradise Inn', 175, '2019-03-19', 266, NULL),
('The Paradise Inn', 175, '2019-03-20', 266, NULL),
('The Paradise Inn', 175, '2019-03-21', 293, NULL),
('The Paradise Inn', 175, '2019-03-22', 313, NULL),
('The Paradise Inn', 175, '2019-03-23', 343, NULL),
('The Paradise Inn', 175, '2019-03-24', 306, NULL),
('The Paradise Inn', 175, '2019-03-25', 228, NULL),
('The Paradise Inn', 175, '2019-03-26', 295, NULL),
('The Paradise Inn', 175, '2019-03-27', 192, NULL),
('The Paradise Inn', 175, '2019-03-28', 125, NULL),
('The Paradise Inn', 175, '2019-03-29', 316, NULL),
('The Paradise Inn', 175, '2019-03-30', 282, NULL),
('The Paradise Inn', 175, '2019-03-31', 121, NULL),
('The Paradise Inn', 175, '2019-04-01', 217, NULL),
('The Paradise Inn', 175, '2019-04-02', 151, NULL),
('The Paradise Inn', 175, '2019-04-03', 361, NULL),
('The Paradise Inn', 175, '2019-04-04', 328, NULL),
('The Paradise Inn', 175, '2019-04-05', 176, NULL),
('The Paradise Inn', 175, '2019-04-06', 214, NULL),
('The Paradise Inn', 175, '2019-04-07', 245, NULL),
('The Paradise Inn', 175, '2019-04-08', 102, NULL),
('The Paradise Inn', 175, '2019-04-09', 233, NULL),
('The Paradise Inn', 175, '2019-04-10', 192, NULL),
('The Paradise Inn', 175, '2019-04-11', 319, NULL),
('The Paradise Inn', 175, '2019-04-12', 127, NULL),
('The Paradise Inn', 175, '2019-04-13', 204, NULL),
('The Paradise Inn', 175, '2019-04-14', 193, NULL),
('The Paradise Inn', 175, '2019-04-15', 399, NULL),
('The Paradise Inn', 175, '2019-04-16', 350, NULL),
('The Paradise Inn', 175, '2019-04-17', 185, NULL),
('The Paradise Inn', 175, '2019-04-18', 247, NULL),
('The Paradise Inn', 175, '2019-04-19', 234, NULL),
('The Paradise Inn', 175, '2019-04-20', 248, NULL),
('The Paradise Inn', 175, '2019-04-21', 308, NULL),
('The Paradise Inn', 175, '2019-04-22', 255, NULL),
('The Paradise Inn', 175, '2019-04-23', 175, NULL),
('The Paradise Inn', 175, '2019-04-24', 205, NULL),
('The Paradise Inn', 175, '2019-04-25', 320, NULL),
('The Paradise Inn', 175, '2019-04-26', 312, NULL),
('The Paradise Inn', 175, '2019-04-27', 164, NULL),
('The Paradise Inn', 175, '2019-04-28', 235, NULL),
('The Paradise Inn', 175, '2019-04-29', 202, NULL),
('The Paradise Inn', 175, '2019-04-30', 383, NULL),
('The Paradise Inn', 175, '2019-05-01', 184, NULL),
('The Paradise Inn', 175, '2019-05-02', 319, NULL),
('The Paradise Inn', 175, '2019-05-03', 148, NULL),
('The Paradise Inn', 175, '2019-05-04', 372, NULL),
('The Paradise Inn', 175, '2019-05-05', 229, NULL),
('The Paradise Inn', 175, '2019-05-06', 150, NULL),
('The Paradise Inn', 175, '2019-05-07', 153, NULL),
('The Paradise Inn', 175, '2019-05-08', 176, NULL),
('The Paradise Inn', 175, '2019-05-09', 201, NULL),
('The Paradise Inn', 175, '2019-05-10', 198, NULL),
('The Paradise Inn', 175, '2019-05-11', 300, NULL),
('The Paradise Inn', 175, '2019-05-12', 323, NULL),
('The Paradise Inn', 175, '2019-05-13', 325, NULL),
('The Paradise Inn', 175, '2019-05-14', 355, NULL),
('The Paradise Inn', 175, '2019-05-15', 110, NULL),
('The Paradise Inn', 175, '2019-05-16', 292, NULL),
('The Paradise Inn', 175, '2019-05-17', 398, NULL),
('The Paradise Inn', 175, '2019-05-18', 286, NULL),
('The Paradise Inn', 175, '2019-05-19', 165, NULL),
('The Paradise Inn', 175, '2019-05-20', 372, NULL),
('The Paradise Inn', 175, '2019-05-21', 252, NULL),
('The Paradise Inn', 175, '2019-05-22', 222, NULL),
('The Paradise Inn', 175, '2019-05-23', 296, NULL),
('The Paradise Inn', 175, '2019-05-24', 142, NULL),
('The Paradise Inn', 175, '2019-05-25', 117, NULL),
('The Paradise Inn', 175, '2019-05-26', 307, NULL),
('The Paradise Inn', 175, '2019-05-27', 103, NULL),
('The Paradise Inn', 175, '2019-05-28', 325, NULL),
('The Paradise Inn', 175, '2019-05-29', 175, NULL),
('The Paradise Inn', 175, '2019-05-30', 152, NULL),
('The Paradise Inn', 175, '2019-05-31', 255, NULL),
('The Paradise Inn', 175, '2019-06-01', 292, NULL),
('The Paradise Inn', 175, '2019-06-02', 395, NULL),
('The Paradise Inn', 175, '2019-06-03', 286, NULL),
('The Paradise Inn', 175, '2019-06-04', 294, NULL),
('The Paradise Inn', 175, '2019-06-05', 196, NULL),
('The Paradise Inn', 175, '2019-06-06', 135, NULL),
('The Paradise Inn', 175, '2019-06-07', 220, NULL),
('The Paradise Inn', 175, '2019-06-08', 150, NULL),
('The Paradise Inn', 175, '2019-06-09', 384, NULL),
('The Paradise Inn', 175, '2019-06-10', 291, NULL),
('The Paradise Inn', 175, '2019-06-11', 271, NULL),
('The Paradise Inn', 175, '2019-06-12', 164, NULL),
('The Paradise Inn', 175, '2019-06-13', 179, NULL),
('The Paradise Inn', 175, '2019-06-14', 189, NULL),
('The Paradise Inn', 175, '2019-06-15', 295, NULL),
('The Paradise Inn', 175, '2019-06-16', 204, NULL),
('The Paradise Inn', 175, '2019-06-17', 373, NULL),
('The Paradise Inn', 175, '2019-06-18', 301, NULL),
('The Paradise Inn', 175, '2019-06-19', 296, NULL),
('The Paradise Inn', 175, '2019-06-20', 159, NULL),
('The Paradise Inn', 175, '2019-06-21', 117, NULL),
('The Paradise Inn', 175, '2019-06-22', 144, NULL),
('The Paradise Inn', 175, '2019-06-23', 178, NULL),
('The Paradise Inn', 175, '2019-06-24', 221, NULL),
('The Paradise Inn', 175, '2019-06-25', 326, NULL),
('The Paradise Inn', 175, '2019-06-26', 349, NULL),
('The Paradise Inn', 175, '2019-06-27', 396, NULL),
('The Paradise Inn', 175, '2019-06-28', 389, NULL),
('The Paradise Inn', 175, '2019-06-29', 186, NULL),
('The Paradise Inn', 175, '2019-06-30', 258, NULL),
('The Paradise Inn', 175, '2019-07-01', 158, NULL),
('The Paradise Inn', 175, '2019-07-02', 356, NULL),
('The Paradise Inn', 175, '2019-07-03', 268, NULL),
('The Paradise Inn', 175, '2019-07-04', 153, NULL),
('The Paradise Inn', 175, '2019-07-05', 172, NULL),
('The Paradise Inn', 175, '2019-07-06', 262, NULL),
('The Paradise Inn', 175, '2019-07-07', 280, NULL),
('The Paradise Inn', 175, '2019-07-08', 332, NULL),
('The Paradise Inn', 175, '2019-07-09', 225, NULL),
('The Paradise Inn', 175, '2019-07-10', 154, NULL),
('The Paradise Inn', 175, '2019-07-11', 208, NULL),
('The Paradise Inn', 175, '2019-07-12', 393, NULL),
('The Paradise Inn', 175, '2019-07-13', 275, NULL),
('The Paradise Inn', 175, '2019-07-14', 381, NULL),
('The Paradise Inn', 175, '2019-07-15', 325, NULL),
('The Paradise Inn', 175, '2019-07-16', 105, NULL),
('The Paradise Inn', 175, '2019-07-17', 317, NULL),
('The Paradise Inn', 175, '2019-07-18', 299, NULL),
('The Paradise Inn', 175, '2019-07-19', 102, NULL),
('The Paradise Inn', 175, '2019-07-20', 134, NULL),
('The Paradise Inn', 175, '2019-07-21', 201, NULL),
('The Paradise Inn', 175, '2019-07-22', 210, NULL),
('The Paradise Inn', 175, '2019-07-23', 306, NULL),
('The Paradise Inn', 175, '2019-07-24', 309, NULL),
('The Paradise Inn', 175, '2019-07-25', 334, NULL),
('The Paradise Inn', 175, '2019-07-26', 374, NULL),
('The Paradise Inn', 175, '2019-07-27', 321, NULL),
('The Paradise Inn', 175, '2019-07-28', 340, NULL),
('The Paradise Inn', 175, '2019-07-29', 218, NULL),
('The Paradise Inn', 175, '2019-07-30', 208, NULL),
('The Paradise Inn', 175, '2019-07-31', 323, NULL),
('The Paradise Inn', 175, '2019-08-01', 174, NULL),
('The Paradise Inn', 175, '2019-08-02', 281, NULL),
('The Paradise Inn', 175, '2019-08-03', 276, NULL),
('The Paradise Inn', 175, '2019-08-04', 146, NULL),
('The Paradise Inn', 175, '2019-08-05', 191, NULL),
('The Paradise Inn', 175, '2019-08-06', 366, NULL),
('The Paradise Inn', 175, '2019-08-07', 156, NULL),
('The Paradise Inn', 175, '2019-08-08', 180, NULL),
('The Paradise Inn', 175, '2019-08-09', 154, NULL),
('The Paradise Inn', 175, '2019-08-10', 121, NULL),
('The Paradise Inn', 175, '2019-08-11', 183, NULL),
('The Paradise Inn', 175, '2019-08-12', 133, NULL),
('The Paradise Inn', 175, '2019-08-13', 393, NULL),
('The Paradise Inn', 175, '2019-08-14', 306, NULL),
('The Paradise Inn', 175, '2019-08-15', 301, NULL),
('The Paradise Inn', 175, '2019-08-16', 228, NULL),
('The Paradise Inn', 175, '2019-08-17', 316, NULL),
('The Paradise Inn', 175, '2019-08-18', 343, NULL),
('The Paradise Inn', 175, '2019-08-19', 233, NULL),
('The Paradise Inn', 175, '2019-08-20', 109, NULL),
('The Paradise Inn', 175, '2019-08-21', 205, NULL),
('The Paradise Inn', 175, '2019-08-22', 360, NULL),
('The Paradise Inn', 175, '2019-08-23', 396, NULL),
('The Paradise Inn', 175, '2019-08-24', 151, NULL),
('The Paradise Inn', 175, '2019-08-25', 291, NULL),
('The Paradise Inn', 175, '2019-08-26', 365, NULL),
('The Paradise Inn', 175, '2019-08-27', 133, NULL),
('The Paradise Inn', 175, '2019-08-28', 257, NULL),
('The Paradise Inn', 175, '2019-08-29', 361, NULL),
('The Paradise Inn', 175, '2019-08-30', 342, NULL),
('The Paradise Inn', 175, '2019-08-31', 296, NULL),
('The Paradise Inn', 175, '2019-09-01', 125, NULL),
('The Paradise Inn', 175, '2019-09-02', 123, NULL),
('The Paradise Inn', 175, '2019-09-03', 339, NULL),
('The Paradise Inn', 175, '2019-09-04', 327, NULL),
('The Paradise Inn', 175, '2019-09-05', 128, NULL),
('The Paradise Inn', 175, '2019-09-06', 115, NULL),
('The Paradise Inn', 175, '2019-09-07', 373, NULL),
('The Paradise Inn', 175, '2019-09-08', 294, NULL),
('The Paradise Inn', 175, '2019-09-09', 237, NULL),
('The Paradise Inn', 175, '2019-09-10', 272, NULL),
('The Paradise Inn', 175, '2019-09-11', 243, NULL),
('The Paradise Inn', 175, '2019-09-12', 357, NULL),
('The Paradise Inn', 175, '2019-09-13', 196, NULL),
('The Paradise Inn', 175, '2019-09-14', 375, NULL),
('The Paradise Inn', 175, '2019-09-15', 341, NULL),
('The Paradise Inn', 175, '2019-09-16', 257, NULL),
('The Paradise Inn', 175, '2019-09-17', 170, NULL),
('The Paradise Inn', 175, '2019-09-18', 358, NULL),
('The Paradise Inn', 175, '2019-09-19', 150, NULL),
('The Paradise Inn', 175, '2019-09-20', 139, NULL),
('The Paradise Inn', 175, '2019-09-21', 179, NULL),
('The Paradise Inn', 175, '2019-09-22', 332, NULL),
('The Paradise Inn', 175, '2019-09-23', 305, NULL),
('The Paradise Inn', 175, '2019-09-24', 184, NULL),
('The Paradise Inn', 175, '2019-09-25', 162, NULL),
('The Paradise Inn', 175, '2019-09-26', 369, NULL),
('The Paradise Inn', 175, '2019-09-27', 168, NULL),
('The Paradise Inn', 175, '2019-09-28', 295, NULL),
('The Paradise Inn', 175, '2019-09-29', 187, NULL),
('The Paradise Inn', 175, '2019-09-30', 248, NULL),
('The Paradise Inn', 175, '2019-10-01', 134, NULL),
('The Paradise Inn', 175, '2019-10-02', 140, NULL),
('The Paradise Inn', 175, '2019-10-03', 384, NULL),
('The Paradise Inn', 175, '2019-10-04', 208, NULL),
('The Paradise Inn', 175, '2019-10-05', 349, NULL),
('The Paradise Inn', 175, '2019-10-06', 243, NULL),
('The Paradise Inn', 175, '2019-10-07', 143, NULL),
('The Paradise Inn', 175, '2019-10-08', 392, NULL),
('The Paradise Inn', 175, '2019-10-09', 390, NULL),
('The Paradise Inn', 175, '2019-10-10', 266, NULL),
('The Paradise Inn', 175, '2019-10-11', 380, NULL),
('The Paradise Inn', 175, '2019-10-12', 159, NULL),
('The Paradise Inn', 175, '2019-10-13', 266, NULL),
('The Paradise Inn', 175, '2019-10-14', 209, NULL),
('The Paradise Inn', 175, '2019-10-15', 206, NULL),
('The Paradise Inn', 175, '2019-10-16', 365, NULL),
('The Paradise Inn', 175, '2019-10-17', 393, NULL),
('The Paradise Inn', 175, '2019-10-18', 105, NULL),
('The Paradise Inn', 175, '2019-10-19', 289, NULL),
('The Paradise Inn', 175, '2019-10-20', 376, NULL),
('The Paradise Inn', 175, '2019-10-21', 182, NULL),
('The Paradise Inn', 175, '2019-10-22', 216, NULL),
('The Paradise Inn', 175, '2019-10-23', 248, NULL),
('The Paradise Inn', 175, '2019-10-24', 138, NULL),
('The Paradise Inn', 175, '2019-10-25', 195, NULL),
('The Paradise Inn', 175, '2019-10-26', 156, NULL),
('The Paradise Inn', 175, '2019-10-27', 111, NULL),
('The Paradise Inn', 175, '2019-10-28', 271, NULL),
('The Paradise Inn', 175, '2019-10-29', 342, NULL),
('The Paradise Inn', 175, '2019-10-30', 243, NULL),
('The Paradise Inn', 175, '2019-10-31', 176, NULL),
('The Paradise Inn', 175, '2019-11-01', 316, NULL),
('The Paradise Inn', 175, '2019-11-02', 285, NULL),
('The Paradise Inn', 175, '2019-11-03', 280, NULL),
('The Paradise Inn', 175, '2019-11-04', 228, NULL),
('The Paradise Inn', 175, '2019-11-05', 161, NULL),
('The Paradise Inn', 175, '2019-11-06', 167, NULL),
('The Paradise Inn', 175, '2019-11-07', 298, NULL),
('The Paradise Inn', 175, '2019-11-08', 288, NULL),
('The Paradise Inn', 175, '2019-11-09', 214, NULL),
('The Paradise Inn', 175, '2019-11-10', 215, NULL),
('The Paradise Inn', 175, '2019-11-11', 343, NULL),
('The Paradise Inn', 175, '2019-11-12', 110, NULL),
('The Paradise Inn', 175, '2019-11-13', 208, NULL),
('The Paradise Inn', 175, '2019-11-14', 239, NULL),
('The Paradise Inn', 175, '2019-11-15', 192, NULL),
('The Paradise Inn', 175, '2019-11-16', 189, NULL),
('The Paradise Inn', 175, '2019-11-17', 167, NULL),
('The Paradise Inn', 175, '2019-11-18', 131, NULL),
('The Paradise Inn', 175, '2019-11-19', 254, NULL),
('The Paradise Inn', 175, '2019-11-20', 300, NULL),
('The Paradise Inn', 175, '2019-11-21', 252, NULL),
('The Paradise Inn', 175, '2019-11-22', 359, NULL),
('The Paradise Inn', 175, '2019-11-23', 379, NULL),
('The Paradise Inn', 175, '2019-11-24', 118, NULL),
('The Paradise Inn', 175, '2019-11-25', 301, NULL),
('The Paradise Inn', 175, '2019-11-26', 224, NULL),
('The Paradise Inn', 175, '2019-11-27', 225, NULL),
('The Paradise Inn', 175, '2019-11-28', 159, NULL),
('The Paradise Inn', 175, '2019-11-29', 331, NULL),
('The Paradise Inn', 175, '2019-11-30', 148, NULL),
('The Paradise Inn', 175, '2019-12-01', 290, NULL),
('The Paradise Inn', 175, '2019-12-02', 236, NULL),
('The Paradise Inn', 175, '2019-12-03', 344, NULL),
('The Paradise Inn', 175, '2019-12-04', 241, NULL),
('The Paradise Inn', 175, '2019-12-05', 297, NULL),
('The Paradise Inn', 175, '2019-12-06', 242, NULL),
('The Paradise Inn', 175, '2019-12-07', 309, NULL),
('The Paradise Inn', 175, '2019-12-08', 275, NULL),
('The Paradise Inn', 175, '2019-12-09', 168, NULL),
('The Paradise Inn', 175, '2019-12-10', 239, NULL),
('The Paradise Inn', 175, '2019-12-11', 127, NULL),
('The Paradise Inn', 175, '2019-12-12', 378, NULL),
('The Paradise Inn', 175, '2019-12-13', 379, NULL),
('The Paradise Inn', 175, '2019-12-14', 104, NULL),
('The Paradise Inn', 175, '2019-12-15', 321, NULL),
('The Paradise Inn', 175, '2019-12-16', 161, NULL),
('The Paradise Inn', 175, '2019-12-17', 320, NULL),
('The Paradise Inn', 175, '2019-12-18', 392, NULL),
('The Paradise Inn', 175, '2019-12-19', 373, NULL),
('The Paradise Inn', 175, '2019-12-20', 264, NULL),
('The Paradise Inn', 175, '2019-12-21', 233, NULL),
('The Paradise Inn', 175, '2019-12-22', 129, NULL),
('The Paradise Inn', 175, '2019-12-23', 397, NULL),
('The Paradise Inn', 175, '2019-12-24', 354, NULL),
('The Paradise Inn', 175, '2019-12-25', 115, NULL),
('The Paradise Inn', 175, '2019-12-26', 283, NULL),
('The Paradise Inn', 175, '2019-12-27', 276, NULL),
('The Paradise Inn', 175, '2019-12-28', 340, NULL),
('The Paradise Inn', 175, '2019-12-29', 287, NULL),
('The Paradise Inn', 175, '2019-12-30', 320, NULL),
('The Paradise Inn', 175, '2019-12-31', 148, NULL),
('The Paradise Inn', 175, '2020-01-01', 114, NULL),
('The Paradise Inn', 175, '2020-01-02', 237, NULL),
('The Paradise Inn', 175, '2020-01-03', 200, NULL),
('The Paradise Inn', 175, '2020-01-04', 240, NULL),
('The Paradise Inn', 175, '2020-01-05', 259, NULL),
('The Paradise Inn', 175, '2020-01-06', 396, NULL),
('The Paradise Inn', 175, '2020-01-07', 279, NULL),
('The Paradise Inn', 175, '2020-01-08', 314, NULL),
('The Paradise Inn', 175, '2020-01-09', 131, NULL),
('The Paradise Inn', 175, '2020-01-10', 367, NULL),
('The Paradise Inn', 175, '2020-01-11', 164, NULL),
('The Paradise Inn', 175, '2020-01-12', 268, NULL),
('The Paradise Inn', 175, '2020-01-13', 205, NULL),
('The Paradise Inn', 175, '2020-01-14', 318, NULL),
('The Paradise Inn', 175, '2020-01-15', 101, NULL),
('The Paradise Inn', 175, '2020-01-16', 259, NULL),
('The Paradise Inn', 175, '2020-01-17', 337, NULL),
('The Paradise Inn', 175, '2020-01-18', 149, NULL),
('The Paradise Inn', 175, '2020-01-19', 280, NULL),
('The Paradise Inn', 175, '2020-01-20', 296, NULL),
('The Paradise Inn', 175, '2020-01-21', 103, NULL),
('The Paradise Inn', 175, '2020-01-22', 216, NULL),
('The Paradise Inn', 175, '2020-01-23', 304, NULL),
('The Paradise Inn', 175, '2020-01-24', 332, NULL),
('The Paradise Inn', 175, '2020-01-25', 254, NULL),
('The Paradise Inn', 175, '2020-01-26', 198, NULL),
('The Paradise Inn', 175, '2020-01-27', 331, NULL),
('The Paradise Inn', 175, '2020-01-28', 342, NULL),
('The Paradise Inn', 175, '2020-01-29', 371, NULL),
('The Paradise Inn', 175, '2020-01-30', 270, NULL),
('The Paradise Inn', 175, '2020-01-31', 107, NULL),
('The Paradise Inn', 175, '2020-02-01', 175, NULL),
('The Paradise Inn', 175, '2020-02-02', 243, NULL),
('The Paradise Inn', 175, '2020-02-03', 379, NULL),
('The Paradise Inn', 175, '2020-02-04', 300, NULL),
('The Paradise Inn', 187, '2019-01-01', 150, NULL),
('The Paradise Inn', 187, '2019-01-02', 311, NULL),
('The Paradise Inn', 187, '2019-01-03', 363, NULL),
('The Paradise Inn', 187, '2019-01-04', 260, NULL),
('The Paradise Inn', 187, '2019-01-05', 393, NULL),
('The Paradise Inn', 187, '2019-01-06', 387, NULL),
('The Paradise Inn', 187, '2019-01-07', 271, NULL),
('The Paradise Inn', 187, '2019-01-08', 377, NULL),
('The Paradise Inn', 187, '2019-01-09', 207, NULL),
('The Paradise Inn', 187, '2019-01-10', 385, NULL),
('The Paradise Inn', 187, '2019-01-11', 197, NULL),
('The Paradise Inn', 187, '2019-01-12', 306, NULL),
('The Paradise Inn', 187, '2019-01-13', 140, NULL),
('The Paradise Inn', 187, '2019-01-14', 221, NULL),
('The Paradise Inn', 187, '2019-01-15', 290, NULL),
('The Paradise Inn', 187, '2019-01-16', 169, NULL),
('The Paradise Inn', 187, '2019-01-17', 294, NULL),
('The Paradise Inn', 187, '2019-01-18', 347, NULL),
('The Paradise Inn', 187, '2019-01-19', 153, NULL),
('The Paradise Inn', 187, '2019-01-20', 129, NULL),
('The Paradise Inn', 187, '2019-01-21', 286, NULL),
('The Paradise Inn', 187, '2019-01-22', 291, NULL),
('The Paradise Inn', 187, '2019-01-23', 283, NULL),
('The Paradise Inn', 187, '2019-01-24', 225, NULL),
('The Paradise Inn', 187, '2019-01-25', 269, NULL),
('The Paradise Inn', 187, '2019-01-26', 111, NULL),
('The Paradise Inn', 187, '2019-01-27', 340, NULL),
('The Paradise Inn', 187, '2019-01-28', 127, NULL),
('The Paradise Inn', 187, '2019-01-29', 247, NULL),
('The Paradise Inn', 187, '2019-01-30', 317, NULL),
('The Paradise Inn', 187, '2019-01-31', 179, NULL),
('The Paradise Inn', 187, '2019-02-01', 278, NULL),
('The Paradise Inn', 187, '2019-02-02', 127, NULL),
('The Paradise Inn', 187, '2019-02-03', 344, NULL),
('The Paradise Inn', 187, '2019-02-04', 398, NULL),
('The Paradise Inn', 187, '2019-02-05', 295, NULL),
('The Paradise Inn', 187, '2019-02-06', 133, NULL),
('The Paradise Inn', 187, '2019-02-07', 131, NULL),
('The Paradise Inn', 187, '2019-02-08', 273, NULL),
('The Paradise Inn', 187, '2019-02-09', 115, NULL),
('The Paradise Inn', 187, '2019-02-10', 327, NULL),
('The Paradise Inn', 187, '2019-02-11', 392, NULL),
('The Paradise Inn', 187, '2019-02-12', 349, NULL),
('The Paradise Inn', 187, '2019-02-13', 269, NULL),
('The Paradise Inn', 187, '2019-02-14', 155, NULL),
('The Paradise Inn', 187, '2019-02-15', 334, NULL),
('The Paradise Inn', 187, '2019-02-16', 164, NULL),
('The Paradise Inn', 187, '2019-02-17', 112, NULL),
('The Paradise Inn', 187, '2019-02-18', 129, NULL),
('The Paradise Inn', 187, '2019-02-19', 388, NULL),
('The Paradise Inn', 187, '2019-02-20', 367, NULL),
('The Paradise Inn', 187, '2019-02-21', 264, NULL),
('The Paradise Inn', 187, '2019-02-22', 131, NULL),
('The Paradise Inn', 187, '2019-02-23', 370, NULL),
('The Paradise Inn', 187, '2019-02-24', 151, NULL),
('The Paradise Inn', 187, '2019-02-25', 276, NULL),
('The Paradise Inn', 187, '2019-02-26', 150, NULL),
('The Paradise Inn', 187, '2019-02-27', 329, NULL),
('The Paradise Inn', 187, '2019-02-28', 304, NULL),
('The Paradise Inn', 187, '2019-03-01', 113, NULL),
('The Paradise Inn', 187, '2019-03-02', 334, NULL),
('The Paradise Inn', 187, '2019-03-03', 214, NULL),
('The Paradise Inn', 187, '2019-03-04', 283, NULL),
('The Paradise Inn', 187, '2019-03-05', 324, NULL),
('The Paradise Inn', 187, '2019-03-06', 223, NULL),
('The Paradise Inn', 187, '2019-03-07', 376, NULL),
('The Paradise Inn', 187, '2019-03-08', 299, NULL),
('The Paradise Inn', 187, '2019-03-09', 111, NULL),
('The Paradise Inn', 187, '2019-03-10', 399, NULL),
('The Paradise Inn', 187, '2019-03-11', 378, NULL),
('The Paradise Inn', 187, '2019-03-12', 310, NULL),
('The Paradise Inn', 187, '2019-03-13', 132, NULL),
('The Paradise Inn', 187, '2019-03-14', 187, NULL),
('The Paradise Inn', 187, '2019-03-15', 315, NULL),
('The Paradise Inn', 187, '2019-03-16', 183, NULL),
('The Paradise Inn', 187, '2019-03-17', 350, NULL),
('The Paradise Inn', 187, '2019-03-18', 166, NULL),
('The Paradise Inn', 187, '2019-03-19', 234, NULL),
('The Paradise Inn', 187, '2019-03-20', 243, NULL),
('The Paradise Inn', 187, '2019-03-21', 168, NULL),
('The Paradise Inn', 187, '2019-03-22', 392, NULL),
('The Paradise Inn', 187, '2019-03-23', 205, NULL),
('The Paradise Inn', 187, '2019-03-24', 145, NULL),
('The Paradise Inn', 187, '2019-03-25', 209, NULL),
('The Paradise Inn', 187, '2019-03-26', 380, NULL),
('The Paradise Inn', 187, '2019-03-27', 144, NULL),
('The Paradise Inn', 187, '2019-03-28', 292, NULL),
('The Paradise Inn', 187, '2019-03-29', 194, NULL),
('The Paradise Inn', 187, '2019-03-30', 387, NULL),
('The Paradise Inn', 187, '2019-03-31', 260, NULL),
('The Paradise Inn', 187, '2019-04-01', 336, NULL),
('The Paradise Inn', 187, '2019-04-02', 377, NULL),
('The Paradise Inn', 187, '2019-04-03', 366, NULL),
('The Paradise Inn', 187, '2019-04-04', 199, NULL),
('The Paradise Inn', 187, '2019-04-05', 171, NULL),
('The Paradise Inn', 187, '2019-04-06', 358, NULL),
('The Paradise Inn', 187, '2019-04-07', 143, NULL),
('The Paradise Inn', 187, '2019-04-08', 119, NULL),
('The Paradise Inn', 187, '2019-04-09', 294, NULL),
('The Paradise Inn', 187, '2019-04-10', 123, NULL),
('The Paradise Inn', 187, '2019-04-11', 245, NULL),
('The Paradise Inn', 187, '2019-04-12', 156, NULL),
('The Paradise Inn', 187, '2019-04-13', 298, NULL),
('The Paradise Inn', 187, '2019-04-14', 254, NULL),
('The Paradise Inn', 187, '2019-04-15', 110, NULL),
('The Paradise Inn', 187, '2019-04-16', 178, NULL),
('The Paradise Inn', 187, '2019-04-17', 305, NULL),
('The Paradise Inn', 187, '2019-04-18', 254, NULL),
('The Paradise Inn', 187, '2019-04-19', 285, NULL),
('The Paradise Inn', 187, '2019-04-20', 368, NULL),
('The Paradise Inn', 187, '2019-04-21', 245, NULL),
('The Paradise Inn', 187, '2019-04-22', 398, NULL),
('The Paradise Inn', 187, '2019-04-23', 291, NULL),
('The Paradise Inn', 187, '2019-04-24', 183, NULL),
('The Paradise Inn', 187, '2019-04-25', 172, NULL),
('The Paradise Inn', 187, '2019-04-26', 281, NULL),
('The Paradise Inn', 187, '2019-04-27', 381, NULL),
('The Paradise Inn', 187, '2019-04-28', 331, NULL),
('The Paradise Inn', 187, '2019-04-29', 291, NULL),
('The Paradise Inn', 187, '2019-04-30', 385, NULL),
('The Paradise Inn', 187, '2019-05-01', 276, NULL),
('The Paradise Inn', 187, '2019-05-02', 228, NULL),
('The Paradise Inn', 187, '2019-05-03', 180, NULL),
('The Paradise Inn', 187, '2019-05-04', 201, NULL),
('The Paradise Inn', 187, '2019-05-05', 301, NULL),
('The Paradise Inn', 187, '2019-05-06', 134, NULL),
('The Paradise Inn', 187, '2019-05-07', 172, NULL),
('The Paradise Inn', 187, '2019-05-08', 264, NULL),
('The Paradise Inn', 187, '2019-05-09', 156, NULL),
('The Paradise Inn', 187, '2019-05-10', 392, NULL),
('The Paradise Inn', 187, '2019-05-11', 290, NULL),
('The Paradise Inn', 187, '2019-05-12', 363, NULL),
('The Paradise Inn', 187, '2019-05-13', 397, NULL),
('The Paradise Inn', 187, '2019-05-14', 151, NULL),
('The Paradise Inn', 187, '2019-05-15', 383, NULL),
('The Paradise Inn', 187, '2019-05-16', 273, NULL),
('The Paradise Inn', 187, '2019-05-17', 217, NULL),
('The Paradise Inn', 187, '2019-05-18', 138, NULL),
('The Paradise Inn', 187, '2019-05-19', 161, NULL),
('The Paradise Inn', 187, '2019-05-20', 328, NULL),
('The Paradise Inn', 187, '2019-05-21', 181, NULL),
('The Paradise Inn', 187, '2019-05-22', 175, NULL),
('The Paradise Inn', 187, '2019-05-23', 128, NULL),
('The Paradise Inn', 187, '2019-05-24', 227, NULL),
('The Paradise Inn', 187, '2019-05-25', 208, NULL),
('The Paradise Inn', 187, '2019-05-26', 368, NULL),
('The Paradise Inn', 187, '2019-05-27', 132, NULL),
('The Paradise Inn', 187, '2019-05-28', 156, NULL),
('The Paradise Inn', 187, '2019-05-29', 308, NULL),
('The Paradise Inn', 187, '2019-05-30', 160, NULL),
('The Paradise Inn', 187, '2019-05-31', 194, NULL),
('The Paradise Inn', 187, '2019-06-01', 240, NULL),
('The Paradise Inn', 187, '2019-06-02', 387, NULL),
('The Paradise Inn', 187, '2019-06-03', 283, NULL),
('The Paradise Inn', 187, '2019-06-04', 157, NULL),
('The Paradise Inn', 187, '2019-06-05', 294, NULL),
('The Paradise Inn', 187, '2019-06-06', 387, NULL),
('The Paradise Inn', 187, '2019-06-07', 199, NULL),
('The Paradise Inn', 187, '2019-06-08', 260, NULL),
('The Paradise Inn', 187, '2019-06-09', 189, NULL),
('The Paradise Inn', 187, '2019-06-10', 374, NULL),
('The Paradise Inn', 187, '2019-06-11', 281, NULL),
('The Paradise Inn', 187, '2019-06-12', 160, NULL),
('The Paradise Inn', 187, '2019-06-13', 377, NULL),
('The Paradise Inn', 187, '2019-06-14', 194, NULL),
('The Paradise Inn', 187, '2019-06-15', 305, NULL),
('The Paradise Inn', 187, '2019-06-16', 278, NULL),
('The Paradise Inn', 187, '2019-06-17', 112, NULL),
('The Paradise Inn', 187, '2019-06-18', 147, NULL),
('The Paradise Inn', 187, '2019-06-19', 141, NULL),
('The Paradise Inn', 187, '2019-06-20', 327, NULL),
('The Paradise Inn', 187, '2019-06-21', 232, NULL),
('The Paradise Inn', 187, '2019-06-22', 367, NULL),
('The Paradise Inn', 187, '2019-06-23', 277, NULL),
('The Paradise Inn', 187, '2019-06-24', 101, NULL),
('The Paradise Inn', 187, '2019-06-25', 212, NULL),
('The Paradise Inn', 187, '2019-06-26', 136, NULL),
('The Paradise Inn', 187, '2019-06-27', 231, NULL),
('The Paradise Inn', 187, '2019-06-28', 191, NULL),
('The Paradise Inn', 187, '2019-06-29', 167, NULL),
('The Paradise Inn', 187, '2019-06-30', 379, NULL),
('The Paradise Inn', 187, '2019-07-01', 295, NULL),
('The Paradise Inn', 187, '2019-07-02', 151, NULL),
('The Paradise Inn', 187, '2019-07-03', 210, NULL),
('The Paradise Inn', 187, '2019-07-04', 239, NULL),
('The Paradise Inn', 187, '2019-07-05', 170, NULL),
('The Paradise Inn', 187, '2019-07-06', 162, NULL),
('The Paradise Inn', 187, '2019-07-07', 210, NULL),
('The Paradise Inn', 187, '2019-07-08', 227, NULL),
('The Paradise Inn', 187, '2019-07-09', 139, NULL),
('The Paradise Inn', 187, '2019-07-10', 349, NULL),
('The Paradise Inn', 187, '2019-07-11', 299, NULL),
('The Paradise Inn', 187, '2019-07-12', 362, NULL),
('The Paradise Inn', 187, '2019-07-13', 182, NULL),
('The Paradise Inn', 187, '2019-07-14', 139, NULL),
('The Paradise Inn', 187, '2019-07-15', 231, NULL),
('The Paradise Inn', 187, '2019-07-16', 179, NULL),
('The Paradise Inn', 187, '2019-07-17', 195, NULL),
('The Paradise Inn', 187, '2019-07-18', 273, NULL),
('The Paradise Inn', 187, '2019-07-19', 389, NULL),
('The Paradise Inn', 187, '2019-07-20', 302, NULL),
('The Paradise Inn', 187, '2019-07-21', 244, NULL),
('The Paradise Inn', 187, '2019-07-22', 294, NULL),
('The Paradise Inn', 187, '2019-07-23', 393, NULL),
('The Paradise Inn', 187, '2019-07-24', 311, NULL),
('The Paradise Inn', 187, '2019-07-25', 131, NULL),
('The Paradise Inn', 187, '2019-07-26', 251, NULL),
('The Paradise Inn', 187, '2019-07-27', 275, NULL),
('The Paradise Inn', 187, '2019-07-28', 269, NULL),
('The Paradise Inn', 187, '2019-07-29', 387, NULL),
('The Paradise Inn', 187, '2019-07-30', 377, NULL),
('The Paradise Inn', 187, '2019-07-31', 311, NULL),
('The Paradise Inn', 187, '2019-08-01', 233, NULL),
('The Paradise Inn', 187, '2019-08-02', 397, NULL),
('The Paradise Inn', 187, '2019-08-03', 322, NULL),
('The Paradise Inn', 187, '2019-08-04', 330, NULL),
('The Paradise Inn', 187, '2019-08-05', 134, NULL),
('The Paradise Inn', 187, '2019-08-06', 357, NULL),
('The Paradise Inn', 187, '2019-08-07', 263, NULL),
('The Paradise Inn', 187, '2019-08-08', 363, NULL),
('The Paradise Inn', 187, '2019-08-09', 317, NULL),
('The Paradise Inn', 187, '2019-08-10', 334, NULL),
('The Paradise Inn', 187, '2019-08-11', 397, NULL),
('The Paradise Inn', 187, '2019-08-12', 296, NULL),
('The Paradise Inn', 187, '2019-08-13', 190, NULL),
('The Paradise Inn', 187, '2019-08-14', 219, NULL),
('The Paradise Inn', 187, '2019-08-15', 303, NULL),
('The Paradise Inn', 187, '2019-08-16', 107, NULL),
('The Paradise Inn', 187, '2019-08-17', 350, NULL),
('The Paradise Inn', 187, '2019-08-18', 317, NULL),
('The Paradise Inn', 187, '2019-08-19', 213, NULL),
('The Paradise Inn', 187, '2019-08-20', 319, NULL),
('The Paradise Inn', 187, '2019-08-21', 164, NULL),
('The Paradise Inn', 187, '2019-08-22', 379, NULL),
('The Paradise Inn', 187, '2019-08-23', 349, NULL),
('The Paradise Inn', 187, '2019-08-24', 209, NULL),
('The Paradise Inn', 187, '2019-08-25', 226, NULL),
('The Paradise Inn', 187, '2019-08-26', 264, NULL),
('The Paradise Inn', 187, '2019-08-27', 370, NULL),
('The Paradise Inn', 187, '2019-08-28', 168, NULL),
('The Paradise Inn', 187, '2019-08-29', 289, NULL),
('The Paradise Inn', 187, '2019-08-30', 103, NULL),
('The Paradise Inn', 187, '2019-08-31', 180, NULL),
('The Paradise Inn', 187, '2019-09-01', 164, NULL),
('The Paradise Inn', 187, '2019-09-02', 112, NULL),
('The Paradise Inn', 187, '2019-09-03', 354, NULL),
('The Paradise Inn', 187, '2019-09-04', 346, NULL),
('The Paradise Inn', 187, '2019-09-05', 130, NULL),
('The Paradise Inn', 187, '2019-09-06', 388, NULL),
('The Paradise Inn', 187, '2019-09-07', 154, NULL),
('The Paradise Inn', 187, '2019-09-08', 259, NULL),
('The Paradise Inn', 187, '2019-09-09', 360, NULL),
('The Paradise Inn', 187, '2019-09-10', 103, NULL),
('The Paradise Inn', 187, '2019-09-11', 373, NULL),
('The Paradise Inn', 187, '2019-09-12', 146, NULL),
('The Paradise Inn', 187, '2019-09-13', 156, NULL),
('The Paradise Inn', 187, '2019-09-14', 101, NULL),
('The Paradise Inn', 187, '2019-09-15', 397, NULL),
('The Paradise Inn', 187, '2019-09-16', 104, NULL),
('The Paradise Inn', 187, '2019-09-17', 274, NULL),
('The Paradise Inn', 187, '2019-09-18', 265, NULL),
('The Paradise Inn', 187, '2019-09-19', 373, NULL),
('The Paradise Inn', 187, '2019-09-20', 367, NULL),
('The Paradise Inn', 187, '2019-09-21', 102, NULL),
('The Paradise Inn', 187, '2019-09-22', 283, NULL),
('The Paradise Inn', 187, '2019-09-23', 225, NULL),
('The Paradise Inn', 187, '2019-09-24', 342, NULL),
('The Paradise Inn', 187, '2019-09-25', 237, NULL),
('The Paradise Inn', 187, '2019-09-26', 158, NULL),
('The Paradise Inn', 187, '2019-09-27', 331, NULL),
('The Paradise Inn', 187, '2019-09-28', 223, NULL),
('The Paradise Inn', 187, '2019-09-29', 181, NULL),
('The Paradise Inn', 187, '2019-09-30', 158, NULL),
('The Paradise Inn', 187, '2019-10-01', 232, NULL),
('The Paradise Inn', 187, '2019-10-02', 125, NULL),
('The Paradise Inn', 187, '2019-10-03', 113, NULL),
('The Paradise Inn', 187, '2019-10-04', 394, NULL),
('The Paradise Inn', 187, '2019-10-05', 133, NULL),
('The Paradise Inn', 187, '2019-10-06', 362, NULL),
('The Paradise Inn', 187, '2019-10-07', 382, NULL),
('The Paradise Inn', 187, '2019-10-08', 100, NULL),
('The Paradise Inn', 187, '2019-10-09', 207, NULL),
('The Paradise Inn', 187, '2019-10-10', 174, NULL),
('The Paradise Inn', 187, '2019-10-11', 325, NULL),
('The Paradise Inn', 187, '2019-10-12', 128, NULL),
('The Paradise Inn', 187, '2019-10-13', 379, NULL),
('The Paradise Inn', 187, '2019-10-14', 319, NULL),
('The Paradise Inn', 187, '2019-10-15', 298, NULL),
('The Paradise Inn', 187, '2019-10-16', 108, NULL),
('The Paradise Inn', 187, '2019-10-17', 264, NULL),
('The Paradise Inn', 187, '2019-10-18', 222, NULL),
('The Paradise Inn', 187, '2019-10-19', 369, NULL),
('The Paradise Inn', 187, '2019-10-20', 221, NULL),
('The Paradise Inn', 187, '2019-10-21', 248, NULL),
('The Paradise Inn', 187, '2019-10-22', 213, NULL),
('The Paradise Inn', 187, '2019-10-23', 368, NULL),
('The Paradise Inn', 187, '2019-10-24', 275, NULL),
('The Paradise Inn', 187, '2019-10-25', 180, NULL),
('The Paradise Inn', 187, '2019-10-26', 269, NULL),
('The Paradise Inn', 187, '2019-10-27', 301, NULL),
('The Paradise Inn', 187, '2019-10-28', 383, NULL),
('The Paradise Inn', 187, '2019-10-29', 104, NULL),
('The Paradise Inn', 187, '2019-10-30', 375, NULL),
('The Paradise Inn', 187, '2019-10-31', 214, NULL),
('The Paradise Inn', 187, '2019-11-01', 191, NULL),
('The Paradise Inn', 187, '2019-11-02', 149, NULL),
('The Paradise Inn', 187, '2019-11-03', 311, NULL),
('The Paradise Inn', 187, '2019-11-04', 221, NULL),
('The Paradise Inn', 187, '2019-11-05', 130, NULL),
('The Paradise Inn', 187, '2019-11-06', 152, NULL),
('The Paradise Inn', 187, '2019-11-07', 308, NULL),
('The Paradise Inn', 187, '2019-11-08', 203, NULL),
('The Paradise Inn', 187, '2019-11-09', 385, NULL),
('The Paradise Inn', 187, '2019-11-10', 389, NULL),
('The Paradise Inn', 187, '2019-11-11', 366, NULL),
('The Paradise Inn', 187, '2019-11-12', 351, NULL),
('The Paradise Inn', 187, '2019-11-13', 383, NULL),
('The Paradise Inn', 187, '2019-11-14', 108, NULL),
('The Paradise Inn', 187, '2019-11-15', 205, NULL),
('The Paradise Inn', 187, '2019-11-16', 285, NULL),
('The Paradise Inn', 187, '2019-11-17', 179, NULL),
('The Paradise Inn', 187, '2019-11-18', 310, NULL),
('The Paradise Inn', 187, '2019-11-19', 232, NULL),
('The Paradise Inn', 187, '2019-11-20', 170, NULL),
('The Paradise Inn', 187, '2019-11-21', 170, NULL),
('The Paradise Inn', 187, '2019-11-22', 219, NULL),
('The Paradise Inn', 187, '2019-11-23', 336, NULL),
('The Paradise Inn', 187, '2019-11-24', 221, NULL),
('The Paradise Inn', 187, '2019-11-25', 182, NULL),
('The Paradise Inn', 187, '2019-11-26', 249, NULL),
('The Paradise Inn', 187, '2019-11-27', 232, NULL),
('The Paradise Inn', 187, '2019-11-28', 231, NULL),
('The Paradise Inn', 187, '2019-11-29', 397, NULL),
('The Paradise Inn', 187, '2019-11-30', 105, NULL),
('The Paradise Inn', 187, '2019-12-01', 205, NULL),
('The Paradise Inn', 187, '2019-12-02', 344, NULL),
('The Paradise Inn', 187, '2019-12-03', 227, NULL),
('The Paradise Inn', 187, '2019-12-04', 276, NULL),
('The Paradise Inn', 187, '2019-12-05', 266, NULL),
('The Paradise Inn', 187, '2019-12-06', 108, NULL),
('The Paradise Inn', 187, '2019-12-07', 397, NULL),
('The Paradise Inn', 187, '2019-12-08', 367, NULL),
('The Paradise Inn', 187, '2019-12-09', 147, NULL),
('The Paradise Inn', 187, '2019-12-10', 104, NULL),
('The Paradise Inn', 187, '2019-12-11', 142, NULL),
('The Paradise Inn', 187, '2019-12-12', 190, NULL),
('The Paradise Inn', 187, '2019-12-13', 110, NULL),
('The Paradise Inn', 187, '2019-12-14', 106, NULL),
('The Paradise Inn', 187, '2019-12-15', 261, NULL),
('The Paradise Inn', 187, '2019-12-16', 147, NULL),
('The Paradise Inn', 187, '2019-12-17', 186, NULL),
('The Paradise Inn', 187, '2019-12-18', 259, NULL),
('The Paradise Inn', 187, '2019-12-19', 187, NULL),
('The Paradise Inn', 187, '2019-12-20', 179, NULL),
('The Paradise Inn', 187, '2019-12-21', 145, NULL),
('The Paradise Inn', 187, '2019-12-22', 307, NULL),
('The Paradise Inn', 187, '2019-12-23', 176, NULL),
('The Paradise Inn', 187, '2019-12-24', 360, NULL),
('The Paradise Inn', 187, '2019-12-25', 229, NULL),
('The Paradise Inn', 187, '2019-12-26', 396, NULL),
('The Paradise Inn', 187, '2019-12-27', 218, NULL),
('The Paradise Inn', 187, '2019-12-28', 165, NULL),
('The Paradise Inn', 187, '2019-12-29', 298, NULL),
('The Paradise Inn', 187, '2019-12-30', 142, NULL),
('The Paradise Inn', 187, '2019-12-31', 349, NULL),
('The Paradise Inn', 187, '2020-01-01', 244, NULL),
('The Paradise Inn', 187, '2020-01-02', 366, NULL),
('The Paradise Inn', 187, '2020-01-03', 320, NULL),
('The Paradise Inn', 187, '2020-01-04', 284, NULL),
('The Paradise Inn', 187, '2020-01-05', 256, NULL),
('The Paradise Inn', 187, '2020-01-06', 312, NULL),
('The Paradise Inn', 187, '2020-01-07', 139, NULL),
('The Paradise Inn', 187, '2020-01-08', 360, NULL),
('The Paradise Inn', 187, '2020-01-09', 146, NULL),
('The Paradise Inn', 187, '2020-01-10', 385, NULL),
('The Paradise Inn', 187, '2020-01-11', 107, NULL),
('The Paradise Inn', 187, '2020-01-12', 339, NULL),
('The Paradise Inn', 187, '2020-01-13', 277, NULL),
('The Paradise Inn', 187, '2020-01-14', 347, NULL),
('The Paradise Inn', 187, '2020-01-15', 116, NULL),
('The Paradise Inn', 187, '2020-01-16', 368, NULL),
('The Paradise Inn', 187, '2020-01-17', 284, NULL),
('The Paradise Inn', 187, '2020-01-18', 209, NULL),
('The Paradise Inn', 187, '2020-01-19', 323, NULL),
('The Paradise Inn', 187, '2020-01-20', 240, NULL),
('The Paradise Inn', 187, '2020-01-21', 102, NULL),
('The Paradise Inn', 187, '2020-01-22', 188, NULL),
('The Paradise Inn', 187, '2020-01-23', 123, NULL),
('The Paradise Inn', 187, '2020-01-24', 386, NULL),
('The Paradise Inn', 187, '2020-01-25', 367, NULL),
('The Paradise Inn', 187, '2020-01-26', 176, NULL),
('The Paradise Inn', 187, '2020-01-27', 144, NULL),
('The Paradise Inn', 187, '2020-01-28', 358, NULL),
('The Paradise Inn', 187, '2020-01-29', 211, NULL),
('The Paradise Inn', 187, '2020-01-30', 314, NULL),
('The Paradise Inn', 187, '2020-01-31', 365, NULL),
('The Paradise Inn', 187, '2020-02-01', 330, NULL),
('The Paradise Inn', 187, '2020-02-02', 324, NULL),
('The Paradise Inn', 187, '2020-02-03', 118, NULL),
('The Paradise Inn', 187, '2020-02-04', 383, NULL),
('The Paradise Inn', 193, '2019-01-01', 386, NULL),
('The Paradise Inn', 193, '2019-01-02', 356, NULL),
('The Paradise Inn', 193, '2019-01-03', 228, NULL),
('The Paradise Inn', 193, '2019-01-04', 326, NULL),
('The Paradise Inn', 193, '2019-01-05', 154, NULL),
('The Paradise Inn', 193, '2019-01-06', 180, NULL),
('The Paradise Inn', 193, '2019-01-07', 171, NULL),
('The Paradise Inn', 193, '2019-01-08', 118, NULL),
('The Paradise Inn', 193, '2019-01-09', 284, NULL),
('The Paradise Inn', 193, '2019-01-10', 259, NULL),
('The Paradise Inn', 193, '2019-01-11', 351, NULL),
('The Paradise Inn', 193, '2019-01-12', 329, NULL),
('The Paradise Inn', 193, '2019-01-13', 223, NULL),
('The Paradise Inn', 193, '2019-01-14', 256, NULL),
('The Paradise Inn', 193, '2019-01-15', 375, NULL),
('The Paradise Inn', 193, '2019-01-16', 249, NULL),
('The Paradise Inn', 193, '2019-01-17', 189, NULL),
('The Paradise Inn', 193, '2019-01-18', 271, NULL),
('The Paradise Inn', 193, '2019-01-19', 343, NULL),
('The Paradise Inn', 193, '2019-01-20', 270, NULL),
('The Paradise Inn', 193, '2019-01-21', 376, NULL),
('The Paradise Inn', 193, '2019-01-22', 146, NULL),
('The Paradise Inn', 193, '2019-01-23', 292, NULL),
('The Paradise Inn', 193, '2019-01-24', 250, NULL),
('The Paradise Inn', 193, '2019-01-25', 163, NULL),
('The Paradise Inn', 193, '2019-01-26', 201, NULL),
('The Paradise Inn', 193, '2019-01-27', 384, NULL),
('The Paradise Inn', 193, '2019-01-28', 303, NULL),
('The Paradise Inn', 193, '2019-01-29', 108, NULL),
('The Paradise Inn', 193, '2019-01-30', 115, NULL),
('The Paradise Inn', 193, '2019-01-31', 379, NULL),
('The Paradise Inn', 193, '2019-02-01', 264, NULL),
('The Paradise Inn', 193, '2019-02-02', 218, NULL),
('The Paradise Inn', 193, '2019-02-03', 206, NULL),
('The Paradise Inn', 193, '2019-02-04', 246, NULL),
('The Paradise Inn', 193, '2019-02-05', 193, NULL),
('The Paradise Inn', 193, '2019-02-06', 163, NULL),
('The Paradise Inn', 193, '2019-02-07', 118, NULL),
('The Paradise Inn', 193, '2019-02-08', 276, NULL),
('The Paradise Inn', 193, '2019-02-09', 223, NULL),
('The Paradise Inn', 193, '2019-02-10', 175, NULL),
('The Paradise Inn', 193, '2019-02-11', 249, NULL),
('The Paradise Inn', 193, '2019-02-12', 247, NULL),
('The Paradise Inn', 193, '2019-02-13', 192, NULL),
('The Paradise Inn', 193, '2019-02-14', 110, NULL),
('The Paradise Inn', 193, '2019-02-15', 171, NULL),
('The Paradise Inn', 193, '2019-02-16', 302, NULL),
('The Paradise Inn', 193, '2019-02-17', 146, NULL),
('The Paradise Inn', 193, '2019-02-18', 162, NULL),
('The Paradise Inn', 193, '2019-02-19', 135, NULL),
('The Paradise Inn', 193, '2019-02-20', 392, NULL),
('The Paradise Inn', 193, '2019-02-21', 143, NULL),
('The Paradise Inn', 193, '2019-02-22', 223, NULL),
('The Paradise Inn', 193, '2019-02-23', 216, NULL),
('The Paradise Inn', 193, '2019-02-24', 122, NULL),
('The Paradise Inn', 193, '2019-02-25', 292, NULL),
('The Paradise Inn', 193, '2019-02-26', 315, NULL),
('The Paradise Inn', 193, '2019-02-27', 325, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 193, '2019-02-28', 125, NULL),
('The Paradise Inn', 193, '2019-03-01', 201, NULL),
('The Paradise Inn', 193, '2019-03-02', 240, NULL),
('The Paradise Inn', 193, '2019-03-03', 365, NULL),
('The Paradise Inn', 193, '2019-03-04', 388, NULL),
('The Paradise Inn', 193, '2019-03-05', 187, NULL),
('The Paradise Inn', 193, '2019-03-06', 263, NULL),
('The Paradise Inn', 193, '2019-03-07', 288, NULL),
('The Paradise Inn', 193, '2019-03-08', 136, NULL),
('The Paradise Inn', 193, '2019-03-09', 285, NULL),
('The Paradise Inn', 193, '2019-03-10', 287, NULL),
('The Paradise Inn', 193, '2019-03-11', 149, NULL),
('The Paradise Inn', 193, '2019-03-12', 191, NULL),
('The Paradise Inn', 193, '2019-03-13', 347, NULL),
('The Paradise Inn', 193, '2019-03-14', 389, NULL),
('The Paradise Inn', 193, '2019-03-15', 351, NULL),
('The Paradise Inn', 193, '2019-03-16', 311, NULL),
('The Paradise Inn', 193, '2019-03-17', 199, NULL),
('The Paradise Inn', 193, '2019-03-18', 113, NULL),
('The Paradise Inn', 193, '2019-03-19', 273, NULL),
('The Paradise Inn', 193, '2019-03-20', 317, NULL),
('The Paradise Inn', 193, '2019-03-21', 163, NULL),
('The Paradise Inn', 193, '2019-03-22', 322, NULL),
('The Paradise Inn', 193, '2019-03-23', 194, NULL),
('The Paradise Inn', 193, '2019-03-24', 307, NULL),
('The Paradise Inn', 193, '2019-03-25', 260, NULL),
('The Paradise Inn', 193, '2019-03-26', 316, NULL),
('The Paradise Inn', 193, '2019-03-27', 347, NULL),
('The Paradise Inn', 193, '2019-03-28', 385, NULL),
('The Paradise Inn', 193, '2019-03-29', 224, NULL),
('The Paradise Inn', 193, '2019-03-30', 390, NULL),
('The Paradise Inn', 193, '2019-03-31', 239, NULL),
('The Paradise Inn', 193, '2019-04-01', 329, NULL),
('The Paradise Inn', 193, '2019-04-02', 135, NULL),
('The Paradise Inn', 193, '2019-04-03', 345, NULL),
('The Paradise Inn', 193, '2019-04-04', 212, NULL),
('The Paradise Inn', 193, '2019-04-05', 229, NULL),
('The Paradise Inn', 193, '2019-04-06', 148, NULL),
('The Paradise Inn', 193, '2019-04-07', 183, NULL),
('The Paradise Inn', 193, '2019-04-08', 193, NULL),
('The Paradise Inn', 193, '2019-04-09', 371, NULL),
('The Paradise Inn', 193, '2019-04-10', 240, NULL),
('The Paradise Inn', 193, '2019-04-11', 168, NULL),
('The Paradise Inn', 193, '2019-04-12', 301, NULL),
('The Paradise Inn', 193, '2019-04-13', 182, NULL),
('The Paradise Inn', 193, '2019-04-14', 294, NULL),
('The Paradise Inn', 193, '2019-04-15', 155, NULL),
('The Paradise Inn', 193, '2019-04-16', 344, NULL),
('The Paradise Inn', 193, '2019-04-17', 271, NULL),
('The Paradise Inn', 193, '2019-04-18', 131, NULL),
('The Paradise Inn', 193, '2019-04-19', 321, NULL),
('The Paradise Inn', 193, '2019-04-20', 396, NULL),
('The Paradise Inn', 193, '2019-04-21', 202, NULL),
('The Paradise Inn', 193, '2019-04-22', 227, NULL),
('The Paradise Inn', 193, '2019-04-23', 231, NULL),
('The Paradise Inn', 193, '2019-04-24', 200, NULL),
('The Paradise Inn', 193, '2019-04-25', 102, NULL),
('The Paradise Inn', 193, '2019-04-26', 370, NULL),
('The Paradise Inn', 193, '2019-04-27', 112, NULL),
('The Paradise Inn', 193, '2019-04-28', 252, NULL),
('The Paradise Inn', 193, '2019-04-29', 151, NULL),
('The Paradise Inn', 193, '2019-04-30', 376, NULL),
('The Paradise Inn', 193, '2019-05-01', 131, NULL),
('The Paradise Inn', 193, '2019-05-02', 386, NULL),
('The Paradise Inn', 193, '2019-05-03', 355, NULL),
('The Paradise Inn', 193, '2019-05-04', 390, NULL),
('The Paradise Inn', 193, '2019-05-05', 119, NULL),
('The Paradise Inn', 193, '2019-05-06', 121, NULL),
('The Paradise Inn', 193, '2019-05-07', 303, NULL),
('The Paradise Inn', 193, '2019-05-08', 391, NULL),
('The Paradise Inn', 193, '2019-05-09', 379, NULL),
('The Paradise Inn', 193, '2019-05-10', 369, NULL),
('The Paradise Inn', 193, '2019-05-11', 151, NULL),
('The Paradise Inn', 193, '2019-05-12', 149, NULL),
('The Paradise Inn', 193, '2019-05-13', 311, NULL),
('The Paradise Inn', 193, '2019-05-14', 194, NULL),
('The Paradise Inn', 193, '2019-05-15', 288, NULL),
('The Paradise Inn', 193, '2019-05-16', 392, NULL),
('The Paradise Inn', 193, '2019-05-17', 391, NULL),
('The Paradise Inn', 193, '2019-05-18', 330, NULL),
('The Paradise Inn', 193, '2019-05-19', 211, NULL),
('The Paradise Inn', 193, '2019-05-20', 123, NULL),
('The Paradise Inn', 193, '2019-05-21', 346, NULL),
('The Paradise Inn', 193, '2019-05-22', 107, NULL),
('The Paradise Inn', 193, '2019-05-23', 249, NULL),
('The Paradise Inn', 193, '2019-05-24', 308, NULL),
('The Paradise Inn', 193, '2019-05-25', 292, NULL),
('The Paradise Inn', 193, '2019-05-26', 222, NULL),
('The Paradise Inn', 193, '2019-05-27', 249, NULL),
('The Paradise Inn', 193, '2019-05-28', 306, NULL),
('The Paradise Inn', 193, '2019-05-29', 315, NULL),
('The Paradise Inn', 193, '2019-05-30', 246, NULL),
('The Paradise Inn', 193, '2019-05-31', 105, NULL),
('The Paradise Inn', 193, '2019-06-01', 222, NULL),
('The Paradise Inn', 193, '2019-06-02', 350, NULL),
('The Paradise Inn', 193, '2019-06-03', 156, NULL),
('The Paradise Inn', 193, '2019-06-04', 105, NULL),
('The Paradise Inn', 193, '2019-06-05', 183, NULL),
('The Paradise Inn', 193, '2019-06-06', 233, NULL),
('The Paradise Inn', 193, '2019-06-07', 237, NULL),
('The Paradise Inn', 193, '2019-06-08', 153, NULL),
('The Paradise Inn', 193, '2019-06-09', 296, NULL),
('The Paradise Inn', 193, '2019-06-10', 294, NULL),
('The Paradise Inn', 193, '2019-06-11', 189, NULL),
('The Paradise Inn', 193, '2019-06-12', 208, NULL),
('The Paradise Inn', 193, '2019-06-13', 348, NULL),
('The Paradise Inn', 193, '2019-06-14', 305, NULL),
('The Paradise Inn', 193, '2019-06-15', 239, NULL),
('The Paradise Inn', 193, '2019-06-16', 377, NULL),
('The Paradise Inn', 193, '2019-06-17', 240, NULL),
('The Paradise Inn', 193, '2019-06-18', 332, NULL),
('The Paradise Inn', 193, '2019-06-19', 316, NULL),
('The Paradise Inn', 193, '2019-06-20', 158, NULL),
('The Paradise Inn', 193, '2019-06-21', 108, NULL),
('The Paradise Inn', 193, '2019-06-22', 102, NULL),
('The Paradise Inn', 193, '2019-06-23', 153, NULL),
('The Paradise Inn', 193, '2019-06-24', 344, NULL),
('The Paradise Inn', 193, '2019-06-25', 284, NULL),
('The Paradise Inn', 193, '2019-06-26', 135, NULL),
('The Paradise Inn', 193, '2019-06-27', 167, NULL),
('The Paradise Inn', 193, '2019-06-28', 287, NULL),
('The Paradise Inn', 193, '2019-06-29', 179, NULL),
('The Paradise Inn', 193, '2019-06-30', 122, NULL),
('The Paradise Inn', 193, '2019-07-01', 302, NULL),
('The Paradise Inn', 193, '2019-07-02', 186, NULL),
('The Paradise Inn', 193, '2019-07-03', 148, NULL),
('The Paradise Inn', 193, '2019-07-04', 336, NULL),
('The Paradise Inn', 193, '2019-07-05', 238, NULL),
('The Paradise Inn', 193, '2019-07-06', 222, NULL),
('The Paradise Inn', 193, '2019-07-07', 107, NULL),
('The Paradise Inn', 193, '2019-07-08', 341, NULL),
('The Paradise Inn', 193, '2019-07-09', 220, NULL),
('The Paradise Inn', 193, '2019-07-10', 284, NULL),
('The Paradise Inn', 193, '2019-07-11', 171, NULL),
('The Paradise Inn', 193, '2019-07-12', 234, NULL),
('The Paradise Inn', 193, '2019-07-13', 286, NULL),
('The Paradise Inn', 193, '2019-07-14', 353, NULL),
('The Paradise Inn', 193, '2019-07-15', 378, NULL),
('The Paradise Inn', 193, '2019-07-16', 183, NULL),
('The Paradise Inn', 193, '2019-07-17', 224, NULL),
('The Paradise Inn', 193, '2019-07-18', 367, NULL),
('The Paradise Inn', 193, '2019-07-19', 338, NULL),
('The Paradise Inn', 193, '2019-07-20', 110, NULL),
('The Paradise Inn', 193, '2019-07-21', 216, NULL),
('The Paradise Inn', 193, '2019-07-22', 137, NULL),
('The Paradise Inn', 193, '2019-07-23', 349, NULL),
('The Paradise Inn', 193, '2019-07-24', 228, NULL),
('The Paradise Inn', 193, '2019-07-25', 152, NULL),
('The Paradise Inn', 193, '2019-07-26', 332, NULL),
('The Paradise Inn', 193, '2019-07-27', 315, NULL),
('The Paradise Inn', 193, '2019-07-28', 225, NULL),
('The Paradise Inn', 193, '2019-07-29', 282, NULL),
('The Paradise Inn', 193, '2019-07-30', 261, NULL),
('The Paradise Inn', 193, '2019-07-31', 188, NULL),
('The Paradise Inn', 193, '2019-08-01', 244, NULL),
('The Paradise Inn', 193, '2019-08-02', 144, NULL),
('The Paradise Inn', 193, '2019-08-03', 385, NULL),
('The Paradise Inn', 193, '2019-08-04', 211, NULL),
('The Paradise Inn', 193, '2019-08-05', 297, NULL),
('The Paradise Inn', 193, '2019-08-06', 287, NULL),
('The Paradise Inn', 193, '2019-08-07', 147, NULL),
('The Paradise Inn', 193, '2019-08-08', 276, NULL),
('The Paradise Inn', 193, '2019-08-09', 120, NULL),
('The Paradise Inn', 193, '2019-08-10', 308, NULL),
('The Paradise Inn', 193, '2019-08-11', 134, NULL),
('The Paradise Inn', 193, '2019-08-12', 383, NULL),
('The Paradise Inn', 193, '2019-08-13', 270, NULL),
('The Paradise Inn', 193, '2019-08-14', 378, NULL),
('The Paradise Inn', 193, '2019-08-15', 212, NULL),
('The Paradise Inn', 193, '2019-08-16', 352, NULL),
('The Paradise Inn', 193, '2019-08-17', 106, NULL),
('The Paradise Inn', 193, '2019-08-18', 157, NULL),
('The Paradise Inn', 193, '2019-08-19', 268, NULL),
('The Paradise Inn', 193, '2019-08-20', 268, NULL),
('The Paradise Inn', 193, '2019-08-21', 105, NULL),
('The Paradise Inn', 193, '2019-08-22', 114, NULL),
('The Paradise Inn', 193, '2019-08-23', 159, NULL),
('The Paradise Inn', 193, '2019-08-24', 191, NULL),
('The Paradise Inn', 193, '2019-08-25', 158, NULL),
('The Paradise Inn', 193, '2019-08-26', 123, NULL),
('The Paradise Inn', 193, '2019-08-27', 155, NULL),
('The Paradise Inn', 193, '2019-08-28', 269, NULL),
('The Paradise Inn', 193, '2019-08-29', 260, NULL),
('The Paradise Inn', 193, '2019-08-30', 289, NULL),
('The Paradise Inn', 193, '2019-08-31', 212, NULL),
('The Paradise Inn', 193, '2019-09-01', 349, NULL),
('The Paradise Inn', 193, '2019-09-02', 390, NULL),
('The Paradise Inn', 193, '2019-09-03', 354, NULL),
('The Paradise Inn', 193, '2019-09-04', 347, NULL),
('The Paradise Inn', 193, '2019-09-05', 165, NULL),
('The Paradise Inn', 193, '2019-09-06', 294, NULL),
('The Paradise Inn', 193, '2019-09-07', 150, NULL),
('The Paradise Inn', 193, '2019-09-08', 314, NULL),
('The Paradise Inn', 193, '2019-09-09', 391, NULL),
('The Paradise Inn', 193, '2019-09-10', 201, NULL),
('The Paradise Inn', 193, '2019-09-11', 138, NULL),
('The Paradise Inn', 193, '2019-09-12', 161, NULL),
('The Paradise Inn', 193, '2019-09-13', 395, NULL),
('The Paradise Inn', 193, '2019-09-14', 181, NULL),
('The Paradise Inn', 193, '2019-09-15', 262, NULL),
('The Paradise Inn', 193, '2019-09-16', 250, NULL),
('The Paradise Inn', 193, '2019-09-17', 161, NULL),
('The Paradise Inn', 193, '2019-09-18', 151, NULL),
('The Paradise Inn', 193, '2019-09-19', 118, NULL),
('The Paradise Inn', 193, '2019-09-20', 117, NULL),
('The Paradise Inn', 193, '2019-09-21', 174, NULL),
('The Paradise Inn', 193, '2019-09-22', 319, NULL),
('The Paradise Inn', 193, '2019-09-23', 110, NULL),
('The Paradise Inn', 193, '2019-09-24', 159, NULL),
('The Paradise Inn', 193, '2019-09-25', 299, NULL),
('The Paradise Inn', 193, '2019-09-26', 183, NULL),
('The Paradise Inn', 193, '2019-09-27', 150, NULL),
('The Paradise Inn', 193, '2019-09-28', 129, NULL),
('The Paradise Inn', 193, '2019-09-29', 243, NULL),
('The Paradise Inn', 193, '2019-09-30', 247, NULL),
('The Paradise Inn', 193, '2019-10-01', 358, NULL),
('The Paradise Inn', 193, '2019-10-02', 106, NULL),
('The Paradise Inn', 193, '2019-10-03', 215, NULL),
('The Paradise Inn', 193, '2019-10-04', 349, NULL),
('The Paradise Inn', 193, '2019-10-05', 119, NULL),
('The Paradise Inn', 193, '2019-10-06', 381, NULL),
('The Paradise Inn', 193, '2019-10-07', 179, NULL),
('The Paradise Inn', 193, '2019-10-08', 126, NULL),
('The Paradise Inn', 193, '2019-10-09', 365, NULL),
('The Paradise Inn', 193, '2019-10-10', 271, NULL),
('The Paradise Inn', 193, '2019-10-11', 387, NULL),
('The Paradise Inn', 193, '2019-10-12', 361, NULL),
('The Paradise Inn', 193, '2019-10-13', 396, NULL),
('The Paradise Inn', 193, '2019-10-14', 269, NULL),
('The Paradise Inn', 193, '2019-10-15', 169, NULL),
('The Paradise Inn', 193, '2019-10-16', 249, NULL),
('The Paradise Inn', 193, '2019-10-17', 345, NULL),
('The Paradise Inn', 193, '2019-10-18', 395, NULL),
('The Paradise Inn', 193, '2019-10-19', 281, NULL),
('The Paradise Inn', 193, '2019-10-20', 179, NULL),
('The Paradise Inn', 193, '2019-10-21', 292, NULL),
('The Paradise Inn', 193, '2019-10-22', 315, NULL),
('The Paradise Inn', 193, '2019-10-23', 393, NULL),
('The Paradise Inn', 193, '2019-10-24', 262, NULL),
('The Paradise Inn', 193, '2019-10-25', 215, NULL),
('The Paradise Inn', 193, '2019-10-26', 177, NULL),
('The Paradise Inn', 193, '2019-10-27', 172, NULL),
('The Paradise Inn', 193, '2019-10-28', 102, NULL),
('The Paradise Inn', 193, '2019-10-29', 296, NULL),
('The Paradise Inn', 193, '2019-10-30', 149, NULL),
('The Paradise Inn', 193, '2019-10-31', 142, NULL),
('The Paradise Inn', 193, '2019-11-01', 209, NULL),
('The Paradise Inn', 193, '2019-11-02', 390, NULL),
('The Paradise Inn', 193, '2019-11-03', 317, NULL),
('The Paradise Inn', 193, '2019-11-04', 320, NULL),
('The Paradise Inn', 193, '2019-11-05', 369, NULL),
('The Paradise Inn', 193, '2019-11-06', 160, NULL),
('The Paradise Inn', 193, '2019-11-07', 246, NULL),
('The Paradise Inn', 193, '2019-11-08', 353, NULL),
('The Paradise Inn', 193, '2019-11-09', 284, NULL),
('The Paradise Inn', 193, '2019-11-10', 302, NULL),
('The Paradise Inn', 193, '2019-11-11', 100, NULL),
('The Paradise Inn', 193, '2019-11-12', 126, NULL),
('The Paradise Inn', 193, '2019-11-13', 294, NULL),
('The Paradise Inn', 193, '2019-11-14', 326, NULL),
('The Paradise Inn', 193, '2019-11-15', 347, NULL),
('The Paradise Inn', 193, '2019-11-16', 157, NULL),
('The Paradise Inn', 193, '2019-11-17', 294, NULL),
('The Paradise Inn', 193, '2019-11-18', 160, NULL),
('The Paradise Inn', 193, '2019-11-19', 300, NULL),
('The Paradise Inn', 193, '2019-11-20', 150, NULL),
('The Paradise Inn', 193, '2019-11-21', 294, NULL),
('The Paradise Inn', 193, '2019-11-22', 217, NULL),
('The Paradise Inn', 193, '2019-11-23', 143, NULL),
('The Paradise Inn', 193, '2019-11-24', 351, NULL),
('The Paradise Inn', 193, '2019-11-25', 210, NULL),
('The Paradise Inn', 193, '2019-11-26', 172, NULL),
('The Paradise Inn', 193, '2019-11-27', 385, NULL),
('The Paradise Inn', 193, '2019-11-28', 277, NULL),
('The Paradise Inn', 193, '2019-11-29', 294, NULL),
('The Paradise Inn', 193, '2019-11-30', 282, NULL),
('The Paradise Inn', 193, '2019-12-01', 359, NULL),
('The Paradise Inn', 193, '2019-12-02', 313, NULL),
('The Paradise Inn', 193, '2019-12-03', 304, NULL),
('The Paradise Inn', 193, '2019-12-04', 256, NULL),
('The Paradise Inn', 193, '2019-12-05', 338, NULL),
('The Paradise Inn', 193, '2019-12-06', 314, NULL),
('The Paradise Inn', 193, '2019-12-07', 358, NULL),
('The Paradise Inn', 193, '2019-12-08', 308, NULL),
('The Paradise Inn', 193, '2019-12-09', 130, NULL),
('The Paradise Inn', 193, '2019-12-10', 301, NULL),
('The Paradise Inn', 193, '2019-12-11', 229, NULL),
('The Paradise Inn', 193, '2019-12-12', 315, NULL),
('The Paradise Inn', 193, '2019-12-13', 215, NULL),
('The Paradise Inn', 193, '2019-12-14', 120, NULL),
('The Paradise Inn', 193, '2019-12-15', 242, NULL),
('The Paradise Inn', 193, '2019-12-16', 153, NULL),
('The Paradise Inn', 193, '2019-12-17', 172, NULL),
('The Paradise Inn', 193, '2019-12-18', 319, NULL),
('The Paradise Inn', 193, '2019-12-19', 317, NULL),
('The Paradise Inn', 193, '2019-12-20', 301, NULL),
('The Paradise Inn', 193, '2019-12-21', 224, NULL),
('The Paradise Inn', 193, '2019-12-22', 149, NULL),
('The Paradise Inn', 193, '2019-12-23', 188, NULL),
('The Paradise Inn', 193, '2019-12-24', 341, NULL),
('The Paradise Inn', 193, '2019-12-25', 103, NULL),
('The Paradise Inn', 193, '2019-12-26', 133, NULL),
('The Paradise Inn', 193, '2019-12-27', 163, NULL),
('The Paradise Inn', 193, '2019-12-28', 306, NULL),
('The Paradise Inn', 193, '2019-12-29', 228, NULL),
('The Paradise Inn', 193, '2019-12-30', 249, NULL),
('The Paradise Inn', 193, '2019-12-31', 299, NULL),
('The Paradise Inn', 193, '2020-01-01', 178, NULL),
('The Paradise Inn', 193, '2020-01-02', 119, NULL),
('The Paradise Inn', 193, '2020-01-03', 301, NULL),
('The Paradise Inn', 193, '2020-01-04', 303, NULL),
('The Paradise Inn', 193, '2020-01-05', 104, NULL),
('The Paradise Inn', 193, '2020-01-06', 274, NULL),
('The Paradise Inn', 193, '2020-01-07', 357, NULL),
('The Paradise Inn', 193, '2020-01-08', 161, NULL),
('The Paradise Inn', 193, '2020-01-09', 237, NULL),
('The Paradise Inn', 193, '2020-01-10', 123, NULL),
('The Paradise Inn', 193, '2020-01-11', 244, NULL),
('The Paradise Inn', 193, '2020-01-12', 192, NULL),
('The Paradise Inn', 193, '2020-01-13', 373, NULL),
('The Paradise Inn', 193, '2020-01-14', 379, NULL),
('The Paradise Inn', 193, '2020-01-15', 180, NULL),
('The Paradise Inn', 193, '2020-01-16', 362, NULL),
('The Paradise Inn', 193, '2020-01-17', 310, NULL),
('The Paradise Inn', 193, '2020-01-18', 200, NULL),
('The Paradise Inn', 193, '2020-01-19', 376, NULL),
('The Paradise Inn', 193, '2020-01-20', 212, NULL),
('The Paradise Inn', 193, '2020-01-21', 103, NULL),
('The Paradise Inn', 193, '2020-01-22', 189, NULL),
('The Paradise Inn', 193, '2020-01-23', 206, NULL),
('The Paradise Inn', 193, '2020-01-24', 235, NULL),
('The Paradise Inn', 193, '2020-01-25', 374, NULL),
('The Paradise Inn', 193, '2020-01-26', 188, NULL),
('The Paradise Inn', 193, '2020-01-27', 229, NULL),
('The Paradise Inn', 193, '2020-01-28', 365, NULL),
('The Paradise Inn', 193, '2020-01-29', 139, NULL),
('The Paradise Inn', 193, '2020-01-30', 358, NULL),
('The Paradise Inn', 193, '2020-01-31', 202, NULL),
('The Paradise Inn', 193, '2020-02-01', 126, NULL),
('The Paradise Inn', 193, '2020-02-02', 191, NULL),
('The Paradise Inn', 193, '2020-02-03', 252, NULL),
('The Paradise Inn', 193, '2020-02-04', 316, NULL),
('The Paradise Inn', 198, '2019-01-01', 184, NULL),
('The Paradise Inn', 198, '2019-01-02', 150, NULL),
('The Paradise Inn', 198, '2019-01-03', 254, NULL),
('The Paradise Inn', 198, '2019-01-04', 151, NULL),
('The Paradise Inn', 198, '2019-01-05', 391, NULL),
('The Paradise Inn', 198, '2019-01-06', 239, NULL),
('The Paradise Inn', 198, '2019-01-07', 244, NULL),
('The Paradise Inn', 198, '2019-01-08', 259, NULL),
('The Paradise Inn', 198, '2019-01-09', 103, NULL),
('The Paradise Inn', 198, '2019-01-10', 341, NULL),
('The Paradise Inn', 198, '2019-01-11', 164, NULL),
('The Paradise Inn', 198, '2019-01-12', 331, NULL),
('The Paradise Inn', 198, '2019-01-13', 293, NULL),
('The Paradise Inn', 198, '2019-01-14', 216, NULL),
('The Paradise Inn', 198, '2019-01-15', 308, NULL),
('The Paradise Inn', 198, '2019-01-16', 340, NULL),
('The Paradise Inn', 198, '2019-01-17', 263, NULL),
('The Paradise Inn', 198, '2019-01-18', 214, NULL),
('The Paradise Inn', 198, '2019-01-19', 260, NULL),
('The Paradise Inn', 198, '2019-01-20', 263, NULL),
('The Paradise Inn', 198, '2019-01-21', 323, NULL),
('The Paradise Inn', 198, '2019-01-22', 357, NULL),
('The Paradise Inn', 198, '2019-01-23', 208, NULL),
('The Paradise Inn', 198, '2019-01-24', 174, NULL),
('The Paradise Inn', 198, '2019-01-25', 212, NULL),
('The Paradise Inn', 198, '2019-01-26', 273, NULL),
('The Paradise Inn', 198, '2019-01-27', 201, NULL),
('The Paradise Inn', 198, '2019-01-28', 132, NULL),
('The Paradise Inn', 198, '2019-01-29', 298, NULL),
('The Paradise Inn', 198, '2019-01-30', 125, NULL),
('The Paradise Inn', 198, '2019-01-31', 356, NULL),
('The Paradise Inn', 198, '2019-02-01', 386, NULL),
('The Paradise Inn', 198, '2019-02-02', 311, NULL),
('The Paradise Inn', 198, '2019-02-03', 199, NULL),
('The Paradise Inn', 198, '2019-02-04', 236, NULL),
('The Paradise Inn', 198, '2019-02-05', 279, NULL),
('The Paradise Inn', 198, '2019-02-06', 314, NULL),
('The Paradise Inn', 198, '2019-02-07', 397, NULL),
('The Paradise Inn', 198, '2019-02-08', 162, NULL),
('The Paradise Inn', 198, '2019-02-09', 369, NULL),
('The Paradise Inn', 198, '2019-02-10', 394, NULL),
('The Paradise Inn', 198, '2019-02-11', 269, NULL),
('The Paradise Inn', 198, '2019-02-12', 389, NULL),
('The Paradise Inn', 198, '2019-02-13', 354, NULL),
('The Paradise Inn', 198, '2019-02-14', 284, NULL),
('The Paradise Inn', 198, '2019-02-15', 352, NULL),
('The Paradise Inn', 198, '2019-02-16', 315, NULL),
('The Paradise Inn', 198, '2019-02-17', 297, NULL),
('The Paradise Inn', 198, '2019-02-18', 324, NULL),
('The Paradise Inn', 198, '2019-02-19', 311, NULL),
('The Paradise Inn', 198, '2019-02-20', 162, NULL),
('The Paradise Inn', 198, '2019-02-21', 123, NULL),
('The Paradise Inn', 198, '2019-02-22', 321, NULL),
('The Paradise Inn', 198, '2019-02-23', 169, NULL),
('The Paradise Inn', 198, '2019-02-24', 357, NULL),
('The Paradise Inn', 198, '2019-02-25', 233, NULL),
('The Paradise Inn', 198, '2019-02-26', 128, NULL),
('The Paradise Inn', 198, '2019-02-27', 236, NULL),
('The Paradise Inn', 198, '2019-02-28', 214, NULL),
('The Paradise Inn', 198, '2019-03-01', 267, NULL),
('The Paradise Inn', 198, '2019-03-02', 399, NULL),
('The Paradise Inn', 198, '2019-03-03', 184, NULL),
('The Paradise Inn', 198, '2019-03-04', 393, NULL),
('The Paradise Inn', 198, '2019-03-05', 164, NULL),
('The Paradise Inn', 198, '2019-03-06', 246, NULL),
('The Paradise Inn', 198, '2019-03-07', 211, NULL),
('The Paradise Inn', 198, '2019-03-08', 284, NULL),
('The Paradise Inn', 198, '2019-03-09', 391, NULL),
('The Paradise Inn', 198, '2019-03-10', 136, NULL),
('The Paradise Inn', 198, '2019-03-11', 109, NULL),
('The Paradise Inn', 198, '2019-03-12', 223, NULL),
('The Paradise Inn', 198, '2019-03-13', 342, NULL),
('The Paradise Inn', 198, '2019-03-14', 384, NULL),
('The Paradise Inn', 198, '2019-03-15', 112, NULL),
('The Paradise Inn', 198, '2019-03-16', 308, NULL),
('The Paradise Inn', 198, '2019-03-17', 143, NULL),
('The Paradise Inn', 198, '2019-03-18', 269, NULL),
('The Paradise Inn', 198, '2019-03-19', 264, NULL),
('The Paradise Inn', 198, '2019-03-20', 157, NULL),
('The Paradise Inn', 198, '2019-03-21', 210, NULL),
('The Paradise Inn', 198, '2019-03-22', 333, NULL),
('The Paradise Inn', 198, '2019-03-23', 258, NULL),
('The Paradise Inn', 198, '2019-03-24', 101, NULL),
('The Paradise Inn', 198, '2019-03-25', 276, NULL),
('The Paradise Inn', 198, '2019-03-26', 341, NULL),
('The Paradise Inn', 198, '2019-03-27', 301, NULL),
('The Paradise Inn', 198, '2019-03-28', 350, NULL),
('The Paradise Inn', 198, '2019-03-29', 139, NULL),
('The Paradise Inn', 198, '2019-03-30', 388, NULL),
('The Paradise Inn', 198, '2019-03-31', 315, NULL),
('The Paradise Inn', 198, '2019-04-01', 239, NULL),
('The Paradise Inn', 198, '2019-04-02', 343, NULL),
('The Paradise Inn', 198, '2019-04-03', 230, NULL),
('The Paradise Inn', 198, '2019-04-04', 365, NULL),
('The Paradise Inn', 198, '2019-04-05', 231, NULL),
('The Paradise Inn', 198, '2019-04-06', 166, NULL),
('The Paradise Inn', 198, '2019-04-07', 384, NULL),
('The Paradise Inn', 198, '2019-04-08', 205, NULL),
('The Paradise Inn', 198, '2019-04-09', 273, NULL),
('The Paradise Inn', 198, '2019-04-10', 131, NULL),
('The Paradise Inn', 198, '2019-04-11', 307, NULL),
('The Paradise Inn', 198, '2019-04-12', 335, NULL),
('The Paradise Inn', 198, '2019-04-13', 216, NULL),
('The Paradise Inn', 198, '2019-04-14', 305, NULL),
('The Paradise Inn', 198, '2019-04-15', 343, NULL),
('The Paradise Inn', 198, '2019-04-16', 184, NULL),
('The Paradise Inn', 198, '2019-04-17', 340, NULL),
('The Paradise Inn', 198, '2019-04-18', 390, NULL),
('The Paradise Inn', 198, '2019-04-19', 353, NULL),
('The Paradise Inn', 198, '2019-04-20', 177, NULL),
('The Paradise Inn', 198, '2019-04-21', 175, NULL),
('The Paradise Inn', 198, '2019-04-22', 142, NULL),
('The Paradise Inn', 198, '2019-04-23', 182, NULL),
('The Paradise Inn', 198, '2019-04-24', 349, NULL),
('The Paradise Inn', 198, '2019-04-25', 193, NULL),
('The Paradise Inn', 198, '2019-04-26', 306, NULL),
('The Paradise Inn', 198, '2019-04-27', 216, NULL),
('The Paradise Inn', 198, '2019-04-28', 165, NULL),
('The Paradise Inn', 198, '2019-04-29', 383, NULL),
('The Paradise Inn', 198, '2019-04-30', 326, NULL),
('The Paradise Inn', 198, '2019-05-01', 325, NULL),
('The Paradise Inn', 198, '2019-05-02', 246, NULL),
('The Paradise Inn', 198, '2019-05-03', 237, NULL),
('The Paradise Inn', 198, '2019-05-04', 349, NULL),
('The Paradise Inn', 198, '2019-05-05', 190, NULL),
('The Paradise Inn', 198, '2019-05-06', 104, NULL),
('The Paradise Inn', 198, '2019-05-07', 299, NULL),
('The Paradise Inn', 198, '2019-05-08', 165, NULL),
('The Paradise Inn', 198, '2019-05-09', 126, NULL),
('The Paradise Inn', 198, '2019-05-10', 270, NULL),
('The Paradise Inn', 198, '2019-05-11', 385, NULL),
('The Paradise Inn', 198, '2019-05-12', 154, NULL),
('The Paradise Inn', 198, '2019-05-13', 265, NULL),
('The Paradise Inn', 198, '2019-05-14', 116, NULL),
('The Paradise Inn', 198, '2019-05-15', 189, NULL),
('The Paradise Inn', 198, '2019-05-16', 142, NULL),
('The Paradise Inn', 198, '2019-05-17', 305, NULL),
('The Paradise Inn', 198, '2019-05-18', 236, NULL),
('The Paradise Inn', 198, '2019-05-19', 170, NULL),
('The Paradise Inn', 198, '2019-05-20', 131, NULL),
('The Paradise Inn', 198, '2019-05-21', 189, NULL),
('The Paradise Inn', 198, '2019-05-22', 213, NULL),
('The Paradise Inn', 198, '2019-05-23', 164, NULL),
('The Paradise Inn', 198, '2019-05-24', 161, NULL),
('The Paradise Inn', 198, '2019-05-25', 138, NULL),
('The Paradise Inn', 198, '2019-05-26', 206, NULL),
('The Paradise Inn', 198, '2019-05-27', 152, NULL),
('The Paradise Inn', 198, '2019-05-28', 360, NULL),
('The Paradise Inn', 198, '2019-05-29', 254, NULL),
('The Paradise Inn', 198, '2019-05-30', 351, NULL),
('The Paradise Inn', 198, '2019-05-31', 145, NULL),
('The Paradise Inn', 198, '2019-06-01', 292, NULL),
('The Paradise Inn', 198, '2019-06-02', 192, NULL),
('The Paradise Inn', 198, '2019-06-03', 133, NULL),
('The Paradise Inn', 198, '2019-06-04', 253, NULL),
('The Paradise Inn', 198, '2019-06-05', 231, NULL),
('The Paradise Inn', 198, '2019-06-06', 203, NULL),
('The Paradise Inn', 198, '2019-06-07', 187, NULL),
('The Paradise Inn', 198, '2019-06-08', 187, NULL),
('The Paradise Inn', 198, '2019-06-09', 210, NULL),
('The Paradise Inn', 198, '2019-06-10', 251, NULL),
('The Paradise Inn', 198, '2019-06-11', 305, NULL),
('The Paradise Inn', 198, '2019-06-12', 162, NULL),
('The Paradise Inn', 198, '2019-06-13', 211, NULL),
('The Paradise Inn', 198, '2019-06-14', 243, NULL),
('The Paradise Inn', 198, '2019-06-15', 182, NULL),
('The Paradise Inn', 198, '2019-06-16', 352, NULL),
('The Paradise Inn', 198, '2019-06-17', 165, NULL),
('The Paradise Inn', 198, '2019-06-18', 221, NULL),
('The Paradise Inn', 198, '2019-06-19', 156, NULL),
('The Paradise Inn', 198, '2019-06-20', 311, NULL),
('The Paradise Inn', 198, '2019-06-21', 344, NULL),
('The Paradise Inn', 198, '2019-06-22', 210, NULL),
('The Paradise Inn', 198, '2019-06-23', 132, NULL),
('The Paradise Inn', 198, '2019-06-24', 118, NULL),
('The Paradise Inn', 198, '2019-06-25', 385, NULL),
('The Paradise Inn', 198, '2019-06-26', 167, NULL),
('The Paradise Inn', 198, '2019-06-27', 341, NULL),
('The Paradise Inn', 198, '2019-06-28', 164, NULL),
('The Paradise Inn', 198, '2019-06-29', 291, NULL),
('The Paradise Inn', 198, '2019-06-30', 274, NULL),
('The Paradise Inn', 198, '2019-07-01', 225, NULL),
('The Paradise Inn', 198, '2019-07-02', 379, NULL),
('The Paradise Inn', 198, '2019-07-03', 309, NULL),
('The Paradise Inn', 198, '2019-07-04', 265, NULL),
('The Paradise Inn', 198, '2019-07-05', 277, NULL),
('The Paradise Inn', 198, '2019-07-06', 226, NULL),
('The Paradise Inn', 198, '2019-07-07', 109, NULL),
('The Paradise Inn', 198, '2019-07-08', 326, NULL),
('The Paradise Inn', 198, '2019-07-09', 287, NULL),
('The Paradise Inn', 198, '2019-07-10', 271, NULL),
('The Paradise Inn', 198, '2019-07-11', 160, NULL),
('The Paradise Inn', 198, '2019-07-12', 286, NULL),
('The Paradise Inn', 198, '2019-07-13', 186, NULL),
('The Paradise Inn', 198, '2019-07-14', 349, NULL),
('The Paradise Inn', 198, '2019-07-15', 198, NULL),
('The Paradise Inn', 198, '2019-07-16', 276, NULL),
('The Paradise Inn', 198, '2019-07-17', 135, NULL),
('The Paradise Inn', 198, '2019-07-18', 319, NULL),
('The Paradise Inn', 198, '2019-07-19', 123, NULL),
('The Paradise Inn', 198, '2019-07-20', 143, NULL),
('The Paradise Inn', 198, '2019-07-21', 247, NULL),
('The Paradise Inn', 198, '2019-07-22', 306, NULL),
('The Paradise Inn', 198, '2019-07-23', 167, NULL),
('The Paradise Inn', 198, '2019-07-24', 109, NULL),
('The Paradise Inn', 198, '2019-07-25', 268, NULL),
('The Paradise Inn', 198, '2019-07-26', 208, NULL),
('The Paradise Inn', 198, '2019-07-27', 352, NULL),
('The Paradise Inn', 198, '2019-07-28', 217, NULL),
('The Paradise Inn', 198, '2019-07-29', 149, NULL),
('The Paradise Inn', 198, '2019-07-30', 376, NULL),
('The Paradise Inn', 198, '2019-07-31', 208, NULL),
('The Paradise Inn', 198, '2019-08-01', 124, NULL),
('The Paradise Inn', 198, '2019-08-02', 327, NULL),
('The Paradise Inn', 198, '2019-08-03', 259, NULL),
('The Paradise Inn', 198, '2019-08-04', 265, NULL),
('The Paradise Inn', 198, '2019-08-05', 382, NULL),
('The Paradise Inn', 198, '2019-08-06', 264, NULL),
('The Paradise Inn', 198, '2019-08-07', 148, NULL),
('The Paradise Inn', 198, '2019-08-08', 190, NULL),
('The Paradise Inn', 198, '2019-08-09', 151, NULL),
('The Paradise Inn', 198, '2019-08-10', 135, NULL),
('The Paradise Inn', 198, '2019-08-11', 279, NULL),
('The Paradise Inn', 198, '2019-08-12', 324, NULL),
('The Paradise Inn', 198, '2019-08-13', 380, NULL),
('The Paradise Inn', 198, '2019-08-14', 231, NULL),
('The Paradise Inn', 198, '2019-08-15', 352, NULL),
('The Paradise Inn', 198, '2019-08-16', 137, NULL),
('The Paradise Inn', 198, '2019-08-17', 279, NULL),
('The Paradise Inn', 198, '2019-08-18', 334, NULL),
('The Paradise Inn', 198, '2019-08-19', 299, NULL),
('The Paradise Inn', 198, '2019-08-20', 283, NULL),
('The Paradise Inn', 198, '2019-08-21', 237, NULL),
('The Paradise Inn', 198, '2019-08-22', 233, NULL),
('The Paradise Inn', 198, '2019-08-23', 248, NULL),
('The Paradise Inn', 198, '2019-08-24', 232, NULL),
('The Paradise Inn', 198, '2019-08-25', 312, NULL),
('The Paradise Inn', 198, '2019-08-26', 325, NULL),
('The Paradise Inn', 198, '2019-08-27', 165, NULL),
('The Paradise Inn', 198, '2019-08-28', 141, NULL),
('The Paradise Inn', 198, '2019-08-29', 335, NULL),
('The Paradise Inn', 198, '2019-08-30', 137, NULL),
('The Paradise Inn', 198, '2019-08-31', 120, NULL),
('The Paradise Inn', 198, '2019-09-01', 251, NULL),
('The Paradise Inn', 198, '2019-09-02', 316, NULL),
('The Paradise Inn', 198, '2019-09-03', 309, NULL),
('The Paradise Inn', 198, '2019-09-04', 300, NULL),
('The Paradise Inn', 198, '2019-09-05', 337, NULL),
('The Paradise Inn', 198, '2019-09-06', 209, NULL),
('The Paradise Inn', 198, '2019-09-07', 189, NULL),
('The Paradise Inn', 198, '2019-09-08', 392, NULL),
('The Paradise Inn', 198, '2019-09-09', 176, NULL),
('The Paradise Inn', 198, '2019-09-10', 297, NULL),
('The Paradise Inn', 198, '2019-09-11', 369, NULL),
('The Paradise Inn', 198, '2019-09-12', 264, NULL),
('The Paradise Inn', 198, '2019-09-13', 207, NULL),
('The Paradise Inn', 198, '2019-09-14', 200, NULL),
('The Paradise Inn', 198, '2019-09-15', 320, NULL),
('The Paradise Inn', 198, '2019-09-16', 238, NULL),
('The Paradise Inn', 198, '2019-09-17', 185, NULL),
('The Paradise Inn', 198, '2019-09-18', 159, NULL),
('The Paradise Inn', 198, '2019-09-19', 270, NULL),
('The Paradise Inn', 198, '2019-09-20', 286, NULL),
('The Paradise Inn', 198, '2019-09-21', 167, NULL),
('The Paradise Inn', 198, '2019-09-22', 348, NULL),
('The Paradise Inn', 198, '2019-09-23', 376, NULL),
('The Paradise Inn', 198, '2019-09-24', 268, NULL),
('The Paradise Inn', 198, '2019-09-25', 386, NULL),
('The Paradise Inn', 198, '2019-09-26', 344, NULL),
('The Paradise Inn', 198, '2019-09-27', 260, NULL),
('The Paradise Inn', 198, '2019-09-28', 177, NULL),
('The Paradise Inn', 198, '2019-09-29', 272, NULL),
('The Paradise Inn', 198, '2019-09-30', 364, NULL),
('The Paradise Inn', 198, '2019-10-01', 394, NULL),
('The Paradise Inn', 198, '2019-10-02', 356, NULL),
('The Paradise Inn', 198, '2019-10-03', 338, NULL),
('The Paradise Inn', 198, '2019-10-04', 164, NULL),
('The Paradise Inn', 198, '2019-10-05', 398, NULL),
('The Paradise Inn', 198, '2019-10-06', 117, NULL),
('The Paradise Inn', 198, '2019-10-07', 250, NULL),
('The Paradise Inn', 198, '2019-10-08', 232, NULL),
('The Paradise Inn', 198, '2019-10-09', 205, NULL),
('The Paradise Inn', 198, '2019-10-10', 137, NULL),
('The Paradise Inn', 198, '2019-10-11', 260, NULL),
('The Paradise Inn', 198, '2019-10-12', 123, NULL),
('The Paradise Inn', 198, '2019-10-13', 142, NULL),
('The Paradise Inn', 198, '2019-10-14', 288, NULL),
('The Paradise Inn', 198, '2019-10-15', 154, NULL),
('The Paradise Inn', 198, '2019-10-16', 219, NULL),
('The Paradise Inn', 198, '2019-10-17', 232, NULL),
('The Paradise Inn', 198, '2019-10-18', 310, NULL),
('The Paradise Inn', 198, '2019-10-19', 199, NULL),
('The Paradise Inn', 198, '2019-10-20', 131, NULL),
('The Paradise Inn', 198, '2019-10-21', 317, NULL),
('The Paradise Inn', 198, '2019-10-22', 238, NULL),
('The Paradise Inn', 198, '2019-10-23', 165, NULL),
('The Paradise Inn', 198, '2019-10-24', 384, NULL),
('The Paradise Inn', 198, '2019-10-25', 136, NULL),
('The Paradise Inn', 198, '2019-10-26', 281, NULL),
('The Paradise Inn', 198, '2019-10-27', 159, NULL),
('The Paradise Inn', 198, '2019-10-28', 161, NULL),
('The Paradise Inn', 198, '2019-10-29', 169, NULL),
('The Paradise Inn', 198, '2019-10-30', 119, NULL),
('The Paradise Inn', 198, '2019-10-31', 270, NULL),
('The Paradise Inn', 198, '2019-11-01', 370, NULL),
('The Paradise Inn', 198, '2019-11-02', 204, NULL),
('The Paradise Inn', 198, '2019-11-03', 253, NULL),
('The Paradise Inn', 198, '2019-11-04', 240, NULL),
('The Paradise Inn', 198, '2019-11-05', 153, NULL),
('The Paradise Inn', 198, '2019-11-06', 244, NULL),
('The Paradise Inn', 198, '2019-11-07', 204, NULL),
('The Paradise Inn', 198, '2019-11-08', 154, NULL),
('The Paradise Inn', 198, '2019-11-09', 163, NULL),
('The Paradise Inn', 198, '2019-11-10', 245, NULL),
('The Paradise Inn', 198, '2019-11-11', 203, NULL),
('The Paradise Inn', 198, '2019-11-12', 380, NULL),
('The Paradise Inn', 198, '2019-11-13', 218, NULL),
('The Paradise Inn', 198, '2019-11-14', 307, NULL),
('The Paradise Inn', 198, '2019-11-15', 123, NULL),
('The Paradise Inn', 198, '2019-11-16', 129, NULL),
('The Paradise Inn', 198, '2019-11-17', 234, NULL),
('The Paradise Inn', 198, '2019-11-18', 368, NULL),
('The Paradise Inn', 198, '2019-11-19', 103, NULL),
('The Paradise Inn', 198, '2019-11-20', 142, NULL),
('The Paradise Inn', 198, '2019-11-21', 258, NULL),
('The Paradise Inn', 198, '2019-11-22', 328, NULL),
('The Paradise Inn', 198, '2019-11-23', 207, NULL),
('The Paradise Inn', 198, '2019-11-24', 395, NULL),
('The Paradise Inn', 198, '2019-11-25', 102, NULL),
('The Paradise Inn', 198, '2019-11-26', 314, NULL),
('The Paradise Inn', 198, '2019-11-27', 229, NULL),
('The Paradise Inn', 198, '2019-11-28', 295, NULL),
('The Paradise Inn', 198, '2019-11-29', 178, NULL),
('The Paradise Inn', 198, '2019-11-30', 396, NULL),
('The Paradise Inn', 198, '2019-12-01', 177, NULL),
('The Paradise Inn', 198, '2019-12-02', 132, NULL),
('The Paradise Inn', 198, '2019-12-03', 140, NULL),
('The Paradise Inn', 198, '2019-12-04', 352, NULL),
('The Paradise Inn', 198, '2019-12-05', 195, NULL),
('The Paradise Inn', 198, '2019-12-06', 246, NULL),
('The Paradise Inn', 198, '2019-12-07', 202, NULL),
('The Paradise Inn', 198, '2019-12-08', 341, NULL),
('The Paradise Inn', 198, '2019-12-09', 111, NULL),
('The Paradise Inn', 198, '2019-12-10', 194, NULL),
('The Paradise Inn', 198, '2019-12-11', 321, NULL),
('The Paradise Inn', 198, '2019-12-12', 306, NULL),
('The Paradise Inn', 198, '2019-12-13', 346, NULL),
('The Paradise Inn', 198, '2019-12-14', 183, NULL),
('The Paradise Inn', 198, '2019-12-15', 328, NULL),
('The Paradise Inn', 198, '2019-12-16', 226, NULL),
('The Paradise Inn', 198, '2019-12-17', 202, NULL),
('The Paradise Inn', 198, '2019-12-18', 117, NULL),
('The Paradise Inn', 198, '2019-12-19', 325, NULL),
('The Paradise Inn', 198, '2019-12-20', 269, NULL),
('The Paradise Inn', 198, '2019-12-21', 289, NULL),
('The Paradise Inn', 198, '2019-12-22', 324, NULL),
('The Paradise Inn', 198, '2019-12-23', 313, NULL),
('The Paradise Inn', 198, '2019-12-24', 225, NULL),
('The Paradise Inn', 198, '2019-12-25', 328, NULL),
('The Paradise Inn', 198, '2019-12-26', 279, NULL),
('The Paradise Inn', 198, '2019-12-27', 362, NULL),
('The Paradise Inn', 198, '2019-12-28', 333, NULL),
('The Paradise Inn', 198, '2019-12-29', 145, NULL),
('The Paradise Inn', 198, '2019-12-30', 120, NULL),
('The Paradise Inn', 198, '2019-12-31', 350, NULL),
('The Paradise Inn', 198, '2020-01-01', 361, NULL),
('The Paradise Inn', 198, '2020-01-02', 297, NULL),
('The Paradise Inn', 198, '2020-01-03', 146, NULL),
('The Paradise Inn', 198, '2020-01-04', 261, NULL),
('The Paradise Inn', 198, '2020-01-05', 250, NULL),
('The Paradise Inn', 198, '2020-01-06', 334, NULL),
('The Paradise Inn', 198, '2020-01-07', 369, NULL),
('The Paradise Inn', 198, '2020-01-08', 223, NULL),
('The Paradise Inn', 198, '2020-01-09', 350, NULL),
('The Paradise Inn', 198, '2020-01-10', 264, NULL),
('The Paradise Inn', 198, '2020-01-11', 198, NULL),
('The Paradise Inn', 198, '2020-01-12', 143, NULL),
('The Paradise Inn', 198, '2020-01-13', 335, NULL),
('The Paradise Inn', 198, '2020-01-14', 158, NULL),
('The Paradise Inn', 198, '2020-01-15', 154, NULL),
('The Paradise Inn', 198, '2020-01-16', 307, NULL),
('The Paradise Inn', 198, '2020-01-17', 300, NULL),
('The Paradise Inn', 198, '2020-01-18', 273, NULL),
('The Paradise Inn', 198, '2020-01-19', 210, NULL),
('The Paradise Inn', 198, '2020-01-20', 241, NULL),
('The Paradise Inn', 198, '2020-01-21', 108, NULL),
('The Paradise Inn', 198, '2020-01-22', 284, NULL),
('The Paradise Inn', 198, '2020-01-23', 260, NULL),
('The Paradise Inn', 198, '2020-01-24', 217, NULL),
('The Paradise Inn', 198, '2020-01-25', 368, NULL),
('The Paradise Inn', 198, '2020-01-26', 310, NULL),
('The Paradise Inn', 198, '2020-01-27', 311, NULL),
('The Paradise Inn', 198, '2020-01-28', 353, NULL),
('The Paradise Inn', 198, '2020-01-29', 266, NULL),
('The Paradise Inn', 198, '2020-01-30', 152, NULL),
('The Paradise Inn', 198, '2020-01-31', 116, NULL),
('The Paradise Inn', 198, '2020-02-01', 139, NULL),
('The Paradise Inn', 198, '2020-02-02', 181, NULL),
('The Paradise Inn', 198, '2020-02-03', 210, NULL),
('The Paradise Inn', 198, '2020-02-04', 333, NULL),
('The Paradise Inn', 199, '2019-01-01', 259, NULL),
('The Paradise Inn', 199, '2019-01-02', 180, NULL),
('The Paradise Inn', 199, '2019-01-03', 187, NULL),
('The Paradise Inn', 199, '2019-01-04', 276, NULL),
('The Paradise Inn', 199, '2019-01-05', 193, NULL),
('The Paradise Inn', 199, '2019-01-06', 259, NULL),
('The Paradise Inn', 199, '2019-01-07', 307, NULL),
('The Paradise Inn', 199, '2019-01-08', 240, NULL),
('The Paradise Inn', 199, '2019-01-09', 162, NULL),
('The Paradise Inn', 199, '2019-01-10', 229, NULL),
('The Paradise Inn', 199, '2019-01-11', 269, NULL),
('The Paradise Inn', 199, '2019-01-12', 266, NULL),
('The Paradise Inn', 199, '2019-01-13', 398, NULL),
('The Paradise Inn', 199, '2019-01-14', 214, NULL),
('The Paradise Inn', 199, '2019-01-15', 314, NULL),
('The Paradise Inn', 199, '2019-01-16', 252, NULL),
('The Paradise Inn', 199, '2019-01-17', 348, NULL),
('The Paradise Inn', 199, '2019-01-18', 157, NULL),
('The Paradise Inn', 199, '2019-01-19', 169, NULL),
('The Paradise Inn', 199, '2019-01-20', 103, NULL),
('The Paradise Inn', 199, '2019-01-21', 386, NULL),
('The Paradise Inn', 199, '2019-01-22', 349, NULL),
('The Paradise Inn', 199, '2019-01-23', 367, NULL),
('The Paradise Inn', 199, '2019-01-24', 319, NULL),
('The Paradise Inn', 199, '2019-01-25', 171, NULL),
('The Paradise Inn', 199, '2019-01-26', 360, NULL),
('The Paradise Inn', 199, '2019-01-27', 353, NULL),
('The Paradise Inn', 199, '2019-01-28', 250, NULL),
('The Paradise Inn', 199, '2019-01-29', 166, NULL),
('The Paradise Inn', 199, '2019-01-30', 181, NULL),
('The Paradise Inn', 199, '2019-01-31', 244, NULL),
('The Paradise Inn', 199, '2019-02-01', 139, NULL),
('The Paradise Inn', 199, '2019-02-02', 201, NULL),
('The Paradise Inn', 199, '2019-02-03', 279, NULL),
('The Paradise Inn', 199, '2019-02-04', 343, NULL),
('The Paradise Inn', 199, '2019-02-05', 118, NULL),
('The Paradise Inn', 199, '2019-02-06', 385, NULL),
('The Paradise Inn', 199, '2019-02-07', 330, NULL),
('The Paradise Inn', 199, '2019-02-08', 185, NULL),
('The Paradise Inn', 199, '2019-02-09', 178, NULL),
('The Paradise Inn', 199, '2019-02-10', 147, NULL),
('The Paradise Inn', 199, '2019-02-11', 199, NULL),
('The Paradise Inn', 199, '2019-02-12', 205, NULL),
('The Paradise Inn', 199, '2019-02-13', 197, NULL),
('The Paradise Inn', 199, '2019-02-14', 393, NULL),
('The Paradise Inn', 199, '2019-02-15', 248, NULL),
('The Paradise Inn', 199, '2019-02-16', 272, NULL),
('The Paradise Inn', 199, '2019-02-17', 344, NULL),
('The Paradise Inn', 199, '2019-02-18', 132, NULL),
('The Paradise Inn', 199, '2019-02-19', 151, NULL),
('The Paradise Inn', 199, '2019-02-20', 132, NULL),
('The Paradise Inn', 199, '2019-02-21', 387, NULL),
('The Paradise Inn', 199, '2019-02-22', 240, NULL),
('The Paradise Inn', 199, '2019-02-23', 399, NULL),
('The Paradise Inn', 199, '2019-02-24', 119, NULL),
('The Paradise Inn', 199, '2019-02-25', 191, NULL),
('The Paradise Inn', 199, '2019-02-26', 193, NULL),
('The Paradise Inn', 199, '2019-02-27', 106, NULL),
('The Paradise Inn', 199, '2019-02-28', 296, NULL),
('The Paradise Inn', 199, '2019-03-01', 334, NULL),
('The Paradise Inn', 199, '2019-03-02', 274, NULL),
('The Paradise Inn', 199, '2019-03-03', 325, NULL),
('The Paradise Inn', 199, '2019-03-04', 100, NULL),
('The Paradise Inn', 199, '2019-03-05', 159, NULL),
('The Paradise Inn', 199, '2019-03-06', 344, NULL),
('The Paradise Inn', 199, '2019-03-07', 393, NULL),
('The Paradise Inn', 199, '2019-03-08', 310, NULL),
('The Paradise Inn', 199, '2019-03-09', 102, NULL),
('The Paradise Inn', 199, '2019-03-10', 320, NULL),
('The Paradise Inn', 199, '2019-03-11', 301, NULL),
('The Paradise Inn', 199, '2019-03-12', 142, NULL),
('The Paradise Inn', 199, '2019-03-13', 266, NULL),
('The Paradise Inn', 199, '2019-03-14', 353, NULL),
('The Paradise Inn', 199, '2019-03-15', 305, NULL),
('The Paradise Inn', 199, '2019-03-16', 205, NULL),
('The Paradise Inn', 199, '2019-03-17', 320, NULL),
('The Paradise Inn', 199, '2019-03-18', 304, NULL),
('The Paradise Inn', 199, '2019-03-19', 100, NULL),
('The Paradise Inn', 199, '2019-03-20', 336, NULL),
('The Paradise Inn', 199, '2019-03-21', 162, NULL),
('The Paradise Inn', 199, '2019-03-22', 299, NULL),
('The Paradise Inn', 199, '2019-03-23', 309, NULL),
('The Paradise Inn', 199, '2019-03-24', 383, NULL),
('The Paradise Inn', 199, '2019-03-25', 201, NULL),
('The Paradise Inn', 199, '2019-03-26', 358, NULL),
('The Paradise Inn', 199, '2019-03-27', 366, NULL),
('The Paradise Inn', 199, '2019-03-28', 193, NULL),
('The Paradise Inn', 199, '2019-03-29', 223, NULL),
('The Paradise Inn', 199, '2019-03-30', 372, NULL),
('The Paradise Inn', 199, '2019-03-31', 158, NULL),
('The Paradise Inn', 199, '2019-04-01', 108, NULL),
('The Paradise Inn', 199, '2019-04-02', 311, NULL),
('The Paradise Inn', 199, '2019-04-03', 315, NULL),
('The Paradise Inn', 199, '2019-04-04', 190, NULL),
('The Paradise Inn', 199, '2019-04-05', 371, NULL),
('The Paradise Inn', 199, '2019-04-06', 287, NULL),
('The Paradise Inn', 199, '2019-04-07', 371, NULL),
('The Paradise Inn', 199, '2019-04-08', 348, NULL),
('The Paradise Inn', 199, '2019-04-09', 155, NULL),
('The Paradise Inn', 199, '2019-04-10', 138, NULL),
('The Paradise Inn', 199, '2019-04-11', 333, NULL),
('The Paradise Inn', 199, '2019-04-12', 375, NULL),
('The Paradise Inn', 199, '2019-04-13', 132, NULL),
('The Paradise Inn', 199, '2019-04-14', 246, NULL),
('The Paradise Inn', 199, '2019-04-15', 252, NULL),
('The Paradise Inn', 199, '2019-04-16', 388, NULL),
('The Paradise Inn', 199, '2019-04-17', 186, NULL),
('The Paradise Inn', 199, '2019-04-18', 260, NULL),
('The Paradise Inn', 199, '2019-04-19', 100, NULL),
('The Paradise Inn', 199, '2019-04-20', 198, NULL),
('The Paradise Inn', 199, '2019-04-21', 169, NULL),
('The Paradise Inn', 199, '2019-04-22', 228, NULL),
('The Paradise Inn', 199, '2019-04-23', 119, NULL),
('The Paradise Inn', 199, '2019-04-24', 148, NULL),
('The Paradise Inn', 199, '2019-04-25', 261, NULL),
('The Paradise Inn', 199, '2019-04-26', 322, NULL),
('The Paradise Inn', 199, '2019-04-27', 344, NULL),
('The Paradise Inn', 199, '2019-04-28', 271, NULL),
('The Paradise Inn', 199, '2019-04-29', 162, NULL),
('The Paradise Inn', 199, '2019-04-30', 102, NULL),
('The Paradise Inn', 199, '2019-05-01', 232, NULL),
('The Paradise Inn', 199, '2019-05-02', 272, NULL),
('The Paradise Inn', 199, '2019-05-03', 321, NULL),
('The Paradise Inn', 199, '2019-05-04', 174, NULL),
('The Paradise Inn', 199, '2019-05-05', 197, NULL),
('The Paradise Inn', 199, '2019-05-06', 358, NULL),
('The Paradise Inn', 199, '2019-05-07', 187, NULL),
('The Paradise Inn', 199, '2019-05-08', 152, NULL),
('The Paradise Inn', 199, '2019-05-09', 293, NULL),
('The Paradise Inn', 199, '2019-05-10', 142, NULL),
('The Paradise Inn', 199, '2019-05-11', 173, NULL),
('The Paradise Inn', 199, '2019-05-12', 224, NULL),
('The Paradise Inn', 199, '2019-05-13', 291, NULL),
('The Paradise Inn', 199, '2019-05-14', 201, NULL),
('The Paradise Inn', 199, '2019-05-15', 282, NULL),
('The Paradise Inn', 199, '2019-05-16', 333, NULL),
('The Paradise Inn', 199, '2019-05-17', 254, NULL),
('The Paradise Inn', 199, '2019-05-18', 391, NULL),
('The Paradise Inn', 199, '2019-05-19', 118, NULL),
('The Paradise Inn', 199, '2019-05-20', 187, NULL),
('The Paradise Inn', 199, '2019-05-21', 109, NULL),
('The Paradise Inn', 199, '2019-05-22', 342, NULL),
('The Paradise Inn', 199, '2019-05-23', 272, NULL),
('The Paradise Inn', 199, '2019-05-24', 382, NULL),
('The Paradise Inn', 199, '2019-05-25', 311, NULL),
('The Paradise Inn', 199, '2019-05-26', 265, NULL),
('The Paradise Inn', 199, '2019-05-27', 212, NULL),
('The Paradise Inn', 199, '2019-05-28', 184, NULL),
('The Paradise Inn', 199, '2019-05-29', 225, NULL),
('The Paradise Inn', 199, '2019-05-30', 318, NULL),
('The Paradise Inn', 199, '2019-05-31', 309, NULL),
('The Paradise Inn', 199, '2019-06-01', 395, NULL),
('The Paradise Inn', 199, '2019-06-02', 107, NULL),
('The Paradise Inn', 199, '2019-06-03', 395, NULL),
('The Paradise Inn', 199, '2019-06-04', 252, NULL),
('The Paradise Inn', 199, '2019-06-05', 209, NULL),
('The Paradise Inn', 199, '2019-06-06', 218, NULL),
('The Paradise Inn', 199, '2019-06-07', 127, NULL),
('The Paradise Inn', 199, '2019-06-08', 373, NULL),
('The Paradise Inn', 199, '2019-06-09', 366, NULL),
('The Paradise Inn', 199, '2019-06-10', 272, NULL),
('The Paradise Inn', 199, '2019-06-11', 256, NULL),
('The Paradise Inn', 199, '2019-06-12', 385, NULL),
('The Paradise Inn', 199, '2019-06-13', 210, NULL),
('The Paradise Inn', 199, '2019-06-14', 202, NULL),
('The Paradise Inn', 199, '2019-06-15', 393, NULL),
('The Paradise Inn', 199, '2019-06-16', 228, NULL),
('The Paradise Inn', 199, '2019-06-17', 305, NULL),
('The Paradise Inn', 199, '2019-06-18', 308, NULL),
('The Paradise Inn', 199, '2019-06-19', 335, NULL),
('The Paradise Inn', 199, '2019-06-20', 382, NULL),
('The Paradise Inn', 199, '2019-06-21', 398, NULL),
('The Paradise Inn', 199, '2019-06-22', 343, NULL),
('The Paradise Inn', 199, '2019-06-23', 104, NULL),
('The Paradise Inn', 199, '2019-06-24', 358, NULL),
('The Paradise Inn', 199, '2019-06-25', 371, NULL),
('The Paradise Inn', 199, '2019-06-26', 330, NULL),
('The Paradise Inn', 199, '2019-06-27', 207, NULL),
('The Paradise Inn', 199, '2019-06-28', 159, NULL),
('The Paradise Inn', 199, '2019-06-29', 220, NULL),
('The Paradise Inn', 199, '2019-06-30', 306, NULL),
('The Paradise Inn', 199, '2019-07-01', 118, NULL),
('The Paradise Inn', 199, '2019-07-02', 336, NULL),
('The Paradise Inn', 199, '2019-07-03', 103, NULL),
('The Paradise Inn', 199, '2019-07-04', 215, NULL),
('The Paradise Inn', 199, '2019-07-05', 274, NULL),
('The Paradise Inn', 199, '2019-07-06', 363, NULL),
('The Paradise Inn', 199, '2019-07-07', 122, NULL),
('The Paradise Inn', 199, '2019-07-08', 208, NULL),
('The Paradise Inn', 199, '2019-07-09', 372, NULL),
('The Paradise Inn', 199, '2019-07-10', 104, NULL),
('The Paradise Inn', 199, '2019-07-11', 185, NULL),
('The Paradise Inn', 199, '2019-07-12', 325, NULL),
('The Paradise Inn', 199, '2019-07-13', 271, NULL),
('The Paradise Inn', 199, '2019-07-14', 288, NULL),
('The Paradise Inn', 199, '2019-07-15', 355, NULL),
('The Paradise Inn', 199, '2019-07-16', 133, NULL),
('The Paradise Inn', 199, '2019-07-17', 207, NULL),
('The Paradise Inn', 199, '2019-07-18', 394, NULL),
('The Paradise Inn', 199, '2019-07-19', 101, NULL),
('The Paradise Inn', 199, '2019-07-20', 287, NULL),
('The Paradise Inn', 199, '2019-07-21', 188, NULL),
('The Paradise Inn', 199, '2019-07-22', 120, NULL),
('The Paradise Inn', 199, '2019-07-23', 289, NULL),
('The Paradise Inn', 199, '2019-07-24', 363, NULL),
('The Paradise Inn', 199, '2019-07-25', 184, NULL),
('The Paradise Inn', 199, '2019-07-26', 246, NULL),
('The Paradise Inn', 199, '2019-07-27', 113, NULL),
('The Paradise Inn', 199, '2019-07-28', 311, NULL),
('The Paradise Inn', 199, '2019-07-29', 399, NULL),
('The Paradise Inn', 199, '2019-07-30', 395, NULL),
('The Paradise Inn', 199, '2019-07-31', 377, NULL),
('The Paradise Inn', 199, '2019-08-01', 388, NULL),
('The Paradise Inn', 199, '2019-08-02', 202, NULL),
('The Paradise Inn', 199, '2019-08-03', 340, NULL),
('The Paradise Inn', 199, '2019-08-04', 292, NULL),
('The Paradise Inn', 199, '2019-08-05', 322, NULL),
('The Paradise Inn', 199, '2019-08-06', 359, NULL),
('The Paradise Inn', 199, '2019-08-07', 197, NULL),
('The Paradise Inn', 199, '2019-08-08', 323, NULL),
('The Paradise Inn', 199, '2019-08-09', 296, NULL),
('The Paradise Inn', 199, '2019-08-10', 255, NULL),
('The Paradise Inn', 199, '2019-08-11', 296, NULL),
('The Paradise Inn', 199, '2019-08-12', 373, NULL),
('The Paradise Inn', 199, '2019-08-13', 393, NULL),
('The Paradise Inn', 199, '2019-08-14', 224, NULL),
('The Paradise Inn', 199, '2019-08-15', 126, NULL),
('The Paradise Inn', 199, '2019-08-16', 133, NULL),
('The Paradise Inn', 199, '2019-08-17', 376, NULL),
('The Paradise Inn', 199, '2019-08-18', 200, NULL),
('The Paradise Inn', 199, '2019-08-19', 292, NULL),
('The Paradise Inn', 199, '2019-08-20', 214, NULL),
('The Paradise Inn', 199, '2019-08-21', 167, NULL),
('The Paradise Inn', 199, '2019-08-22', 124, NULL),
('The Paradise Inn', 199, '2019-08-23', 365, NULL),
('The Paradise Inn', 199, '2019-08-24', 185, NULL),
('The Paradise Inn', 199, '2019-08-25', 389, NULL),
('The Paradise Inn', 199, '2019-08-26', 258, NULL),
('The Paradise Inn', 199, '2019-08-27', 261, NULL),
('The Paradise Inn', 199, '2019-08-28', 398, NULL),
('The Paradise Inn', 199, '2019-08-29', 195, NULL),
('The Paradise Inn', 199, '2019-08-30', 320, NULL),
('The Paradise Inn', 199, '2019-08-31', 164, NULL),
('The Paradise Inn', 199, '2019-09-01', 111, NULL),
('The Paradise Inn', 199, '2019-09-02', 310, NULL),
('The Paradise Inn', 199, '2019-09-03', 384, NULL),
('The Paradise Inn', 199, '2019-09-04', 357, NULL),
('The Paradise Inn', 199, '2019-09-05', 188, NULL),
('The Paradise Inn', 199, '2019-09-06', 360, NULL),
('The Paradise Inn', 199, '2019-09-07', 395, NULL),
('The Paradise Inn', 199, '2019-09-08', 319, NULL),
('The Paradise Inn', 199, '2019-09-09', 206, NULL),
('The Paradise Inn', 199, '2019-09-10', 180, NULL),
('The Paradise Inn', 199, '2019-09-11', 134, NULL),
('The Paradise Inn', 199, '2019-09-12', 140, NULL),
('The Paradise Inn', 199, '2019-09-13', 351, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 199, '2019-09-14', 359, NULL),
('The Paradise Inn', 199, '2019-09-15', 116, NULL),
('The Paradise Inn', 199, '2019-09-16', 341, NULL),
('The Paradise Inn', 199, '2019-09-17', 339, NULL),
('The Paradise Inn', 199, '2019-09-18', 242, NULL),
('The Paradise Inn', 199, '2019-09-19', 298, NULL),
('The Paradise Inn', 199, '2019-09-20', 377, NULL),
('The Paradise Inn', 199, '2019-09-21', 213, NULL),
('The Paradise Inn', 199, '2019-09-22', 382, NULL),
('The Paradise Inn', 199, '2019-09-23', 249, NULL),
('The Paradise Inn', 199, '2019-09-24', 166, NULL),
('The Paradise Inn', 199, '2019-09-25', 333, NULL),
('The Paradise Inn', 199, '2019-09-26', 172, NULL),
('The Paradise Inn', 199, '2019-09-27', 149, NULL),
('The Paradise Inn', 199, '2019-09-28', 399, NULL),
('The Paradise Inn', 199, '2019-09-29', 234, NULL),
('The Paradise Inn', 199, '2019-09-30', 378, NULL),
('The Paradise Inn', 199, '2019-10-01', 199, NULL),
('The Paradise Inn', 199, '2019-10-02', 163, NULL),
('The Paradise Inn', 199, '2019-10-03', 344, NULL),
('The Paradise Inn', 199, '2019-10-04', 273, NULL),
('The Paradise Inn', 199, '2019-10-05', 334, NULL),
('The Paradise Inn', 199, '2019-10-06', 244, NULL),
('The Paradise Inn', 199, '2019-10-07', 315, NULL),
('The Paradise Inn', 199, '2019-10-08', 380, NULL),
('The Paradise Inn', 199, '2019-10-09', 129, NULL),
('The Paradise Inn', 199, '2019-10-10', 369, NULL),
('The Paradise Inn', 199, '2019-10-11', 339, NULL),
('The Paradise Inn', 199, '2019-10-12', 333, NULL),
('The Paradise Inn', 199, '2019-10-13', 326, NULL),
('The Paradise Inn', 199, '2019-10-14', 231, NULL),
('The Paradise Inn', 199, '2019-10-15', 164, NULL),
('The Paradise Inn', 199, '2019-10-16', 247, NULL),
('The Paradise Inn', 199, '2019-10-17', 326, NULL),
('The Paradise Inn', 199, '2019-10-18', 264, NULL),
('The Paradise Inn', 199, '2019-10-19', 351, NULL),
('The Paradise Inn', 199, '2019-10-20', 320, NULL),
('The Paradise Inn', 199, '2019-10-21', 311, NULL),
('The Paradise Inn', 199, '2019-10-22', 147, NULL),
('The Paradise Inn', 199, '2019-10-23', 146, NULL),
('The Paradise Inn', 199, '2019-10-24', 135, NULL),
('The Paradise Inn', 199, '2019-10-25', 233, NULL),
('The Paradise Inn', 199, '2019-10-26', 174, NULL),
('The Paradise Inn', 199, '2019-10-27', 178, NULL),
('The Paradise Inn', 199, '2019-10-28', 399, NULL),
('The Paradise Inn', 199, '2019-10-29', 155, NULL),
('The Paradise Inn', 199, '2019-10-30', 349, NULL),
('The Paradise Inn', 199, '2019-10-31', 224, NULL),
('The Paradise Inn', 199, '2019-11-01', 226, NULL),
('The Paradise Inn', 199, '2019-11-02', 352, NULL),
('The Paradise Inn', 199, '2019-11-03', 216, NULL),
('The Paradise Inn', 199, '2019-11-04', 141, NULL),
('The Paradise Inn', 199, '2019-11-05', 162, NULL),
('The Paradise Inn', 199, '2019-11-06', 341, NULL),
('The Paradise Inn', 199, '2019-11-07', 184, NULL),
('The Paradise Inn', 199, '2019-11-08', 214, NULL),
('The Paradise Inn', 199, '2019-11-09', 164, NULL),
('The Paradise Inn', 199, '2019-11-10', 218, NULL),
('The Paradise Inn', 199, '2019-11-11', 317, NULL),
('The Paradise Inn', 199, '2019-11-12', 219, NULL),
('The Paradise Inn', 199, '2019-11-13', 110, NULL),
('The Paradise Inn', 199, '2019-11-14', 155, NULL),
('The Paradise Inn', 199, '2019-11-15', 374, NULL),
('The Paradise Inn', 199, '2019-11-16', 378, NULL),
('The Paradise Inn', 199, '2019-11-17', 188, NULL),
('The Paradise Inn', 199, '2019-11-18', 362, NULL),
('The Paradise Inn', 199, '2019-11-19', 116, NULL),
('The Paradise Inn', 199, '2019-11-20', 159, NULL),
('The Paradise Inn', 199, '2019-11-21', 312, NULL),
('The Paradise Inn', 199, '2019-11-22', 292, NULL),
('The Paradise Inn', 199, '2019-11-23', 209, NULL),
('The Paradise Inn', 199, '2019-11-24', 220, NULL),
('The Paradise Inn', 199, '2019-11-25', 379, NULL),
('The Paradise Inn', 199, '2019-11-26', 356, NULL),
('The Paradise Inn', 199, '2019-11-27', 191, NULL),
('The Paradise Inn', 199, '2019-11-28', 242, NULL),
('The Paradise Inn', 199, '2019-11-29', 211, NULL),
('The Paradise Inn', 199, '2019-11-30', 132, NULL),
('The Paradise Inn', 199, '2019-12-01', 311, NULL),
('The Paradise Inn', 199, '2019-12-02', 224, NULL),
('The Paradise Inn', 199, '2019-12-03', 287, NULL),
('The Paradise Inn', 199, '2019-12-04', 295, NULL),
('The Paradise Inn', 199, '2019-12-05', 161, NULL),
('The Paradise Inn', 199, '2019-12-06', 190, NULL),
('The Paradise Inn', 199, '2019-12-07', 136, NULL),
('The Paradise Inn', 199, '2019-12-08', 382, NULL),
('The Paradise Inn', 199, '2019-12-09', 364, NULL),
('The Paradise Inn', 199, '2019-12-10', 269, NULL),
('The Paradise Inn', 199, '2019-12-11', 217, NULL),
('The Paradise Inn', 199, '2019-12-12', 187, NULL),
('The Paradise Inn', 199, '2019-12-13', 383, NULL),
('The Paradise Inn', 199, '2019-12-14', 155, NULL),
('The Paradise Inn', 199, '2019-12-15', 213, NULL),
('The Paradise Inn', 199, '2019-12-16', 270, NULL),
('The Paradise Inn', 199, '2019-12-17', 394, NULL),
('The Paradise Inn', 199, '2019-12-18', 131, NULL),
('The Paradise Inn', 199, '2019-12-19', 272, NULL),
('The Paradise Inn', 199, '2019-12-20', 341, NULL),
('The Paradise Inn', 199, '2019-12-21', 374, NULL),
('The Paradise Inn', 199, '2019-12-22', 174, NULL),
('The Paradise Inn', 199, '2019-12-23', 303, NULL),
('The Paradise Inn', 199, '2019-12-24', 301, NULL),
('The Paradise Inn', 199, '2019-12-25', 331, NULL),
('The Paradise Inn', 199, '2019-12-26', 294, NULL),
('The Paradise Inn', 199, '2019-12-27', 323, NULL),
('The Paradise Inn', 199, '2019-12-28', 348, NULL),
('The Paradise Inn', 199, '2019-12-29', 244, NULL),
('The Paradise Inn', 199, '2019-12-30', 355, NULL),
('The Paradise Inn', 199, '2019-12-31', 152, NULL),
('The Paradise Inn', 199, '2020-01-01', 269, NULL),
('The Paradise Inn', 199, '2020-01-02', 127, NULL),
('The Paradise Inn', 199, '2020-01-03', 325, NULL),
('The Paradise Inn', 199, '2020-01-04', 297, NULL),
('The Paradise Inn', 199, '2020-01-05', 240, NULL),
('The Paradise Inn', 199, '2020-01-06', 150, NULL),
('The Paradise Inn', 199, '2020-01-07', 376, NULL),
('The Paradise Inn', 199, '2020-01-08', 233, NULL),
('The Paradise Inn', 199, '2020-01-09', 336, NULL),
('The Paradise Inn', 199, '2020-01-10', 251, NULL),
('The Paradise Inn', 199, '2020-01-11', 160, NULL),
('The Paradise Inn', 199, '2020-01-12', 342, NULL),
('The Paradise Inn', 199, '2020-01-13', 154, NULL),
('The Paradise Inn', 199, '2020-01-14', 153, NULL),
('The Paradise Inn', 199, '2020-01-15', 128, NULL),
('The Paradise Inn', 199, '2020-01-16', 349, NULL),
('The Paradise Inn', 199, '2020-01-17', 170, NULL),
('The Paradise Inn', 199, '2020-01-18', 366, NULL),
('The Paradise Inn', 199, '2020-01-19', 123, NULL),
('The Paradise Inn', 199, '2020-01-20', 171, NULL),
('The Paradise Inn', 199, '2020-01-21', 131, NULL),
('The Paradise Inn', 199, '2020-01-22', 152, NULL),
('The Paradise Inn', 199, '2020-01-23', 282, NULL),
('The Paradise Inn', 199, '2020-01-24', 282, NULL),
('The Paradise Inn', 199, '2020-01-25', 320, NULL),
('The Paradise Inn', 199, '2020-01-26', 286, NULL),
('The Paradise Inn', 199, '2020-01-27', 170, NULL),
('The Paradise Inn', 199, '2020-01-28', 269, NULL),
('The Paradise Inn', 199, '2020-01-29', 213, NULL),
('The Paradise Inn', 199, '2020-01-30', 186, NULL),
('The Paradise Inn', 199, '2020-01-31', 177, NULL),
('The Paradise Inn', 199, '2020-02-01', 220, NULL),
('The Paradise Inn', 199, '2020-02-02', 235, NULL),
('The Paradise Inn', 199, '2020-02-03', 192, NULL),
('The Paradise Inn', 199, '2020-02-04', 315, NULL),
('The Paradise Inn', 206, '2019-01-01', 346, NULL),
('The Paradise Inn', 206, '2019-01-02', 352, NULL),
('The Paradise Inn', 206, '2019-01-03', 372, NULL),
('The Paradise Inn', 206, '2019-01-04', 227, NULL),
('The Paradise Inn', 206, '2019-01-05', 295, NULL),
('The Paradise Inn', 206, '2019-01-06', 175, NULL),
('The Paradise Inn', 206, '2019-01-07', 102, NULL),
('The Paradise Inn', 206, '2019-01-08', 323, NULL),
('The Paradise Inn', 206, '2019-01-09', 102, NULL),
('The Paradise Inn', 206, '2019-01-10', 321, NULL),
('The Paradise Inn', 206, '2019-01-11', 152, NULL),
('The Paradise Inn', 206, '2019-01-12', 237, NULL),
('The Paradise Inn', 206, '2019-01-13', 112, NULL),
('The Paradise Inn', 206, '2019-01-14', 322, NULL),
('The Paradise Inn', 206, '2019-01-15', 246, NULL),
('The Paradise Inn', 206, '2019-01-16', 140, NULL),
('The Paradise Inn', 206, '2019-01-17', 253, NULL),
('The Paradise Inn', 206, '2019-01-18', 345, NULL),
('The Paradise Inn', 206, '2019-01-19', 267, NULL),
('The Paradise Inn', 206, '2019-01-20', 229, NULL),
('The Paradise Inn', 206, '2019-01-21', 264, NULL),
('The Paradise Inn', 206, '2019-01-22', 274, NULL),
('The Paradise Inn', 206, '2019-01-23', 211, NULL),
('The Paradise Inn', 206, '2019-01-24', 375, NULL),
('The Paradise Inn', 206, '2019-01-25', 117, NULL),
('The Paradise Inn', 206, '2019-01-26', 283, NULL),
('The Paradise Inn', 206, '2019-01-27', 165, NULL),
('The Paradise Inn', 206, '2019-01-28', 158, NULL),
('The Paradise Inn', 206, '2019-01-29', 138, NULL),
('The Paradise Inn', 206, '2019-01-30', 131, NULL),
('The Paradise Inn', 206, '2019-01-31', 355, NULL),
('The Paradise Inn', 206, '2019-02-01', 340, NULL),
('The Paradise Inn', 206, '2019-02-02', 275, NULL),
('The Paradise Inn', 206, '2019-02-03', 398, NULL),
('The Paradise Inn', 206, '2019-02-04', 306, NULL),
('The Paradise Inn', 206, '2019-02-05', 252, NULL),
('The Paradise Inn', 206, '2019-02-06', 282, NULL),
('The Paradise Inn', 206, '2019-02-07', 360, NULL),
('The Paradise Inn', 206, '2019-02-08', 336, NULL),
('The Paradise Inn', 206, '2019-02-09', 281, NULL),
('The Paradise Inn', 206, '2019-02-10', 353, NULL),
('The Paradise Inn', 206, '2019-02-11', 390, NULL),
('The Paradise Inn', 206, '2019-02-12', 359, NULL),
('The Paradise Inn', 206, '2019-02-13', 121, NULL),
('The Paradise Inn', 206, '2019-02-14', 113, NULL),
('The Paradise Inn', 206, '2019-02-15', 384, NULL),
('The Paradise Inn', 206, '2019-02-16', 313, NULL),
('The Paradise Inn', 206, '2019-02-17', 133, NULL),
('The Paradise Inn', 206, '2019-02-18', 191, NULL),
('The Paradise Inn', 206, '2019-02-19', 324, NULL),
('The Paradise Inn', 206, '2019-02-20', 374, NULL),
('The Paradise Inn', 206, '2019-02-21', 266, NULL),
('The Paradise Inn', 206, '2019-02-22', 136, NULL),
('The Paradise Inn', 206, '2019-02-23', 189, NULL),
('The Paradise Inn', 206, '2019-02-24', 326, NULL),
('The Paradise Inn', 206, '2019-02-25', 157, NULL),
('The Paradise Inn', 206, '2019-02-26', 182, NULL),
('The Paradise Inn', 206, '2019-02-27', 324, NULL),
('The Paradise Inn', 206, '2019-02-28', 137, NULL),
('The Paradise Inn', 206, '2019-03-01', 167, NULL),
('The Paradise Inn', 206, '2019-03-02', 372, NULL),
('The Paradise Inn', 206, '2019-03-03', 374, NULL),
('The Paradise Inn', 206, '2019-03-04', 122, NULL),
('The Paradise Inn', 206, '2019-03-05', 202, NULL),
('The Paradise Inn', 206, '2019-03-06', 282, NULL),
('The Paradise Inn', 206, '2019-03-07', 333, NULL),
('The Paradise Inn', 206, '2019-03-08', 299, NULL),
('The Paradise Inn', 206, '2019-03-09', 137, NULL),
('The Paradise Inn', 206, '2019-03-10', 191, NULL),
('The Paradise Inn', 206, '2019-03-11', 179, NULL),
('The Paradise Inn', 206, '2019-03-12', 242, NULL),
('The Paradise Inn', 206, '2019-03-13', 208, NULL),
('The Paradise Inn', 206, '2019-03-14', 214, NULL),
('The Paradise Inn', 206, '2019-03-15', 189, NULL),
('The Paradise Inn', 206, '2019-03-16', 301, NULL),
('The Paradise Inn', 206, '2019-03-17', 169, NULL),
('The Paradise Inn', 206, '2019-03-18', 314, NULL),
('The Paradise Inn', 206, '2019-03-19', 211, NULL),
('The Paradise Inn', 206, '2019-03-20', 207, NULL),
('The Paradise Inn', 206, '2019-03-21', 379, NULL),
('The Paradise Inn', 206, '2019-03-22', 399, NULL),
('The Paradise Inn', 206, '2019-03-23', 370, NULL),
('The Paradise Inn', 206, '2019-03-24', 315, NULL),
('The Paradise Inn', 206, '2019-03-25', 375, NULL),
('The Paradise Inn', 206, '2019-03-26', 369, NULL),
('The Paradise Inn', 206, '2019-03-27', 229, NULL),
('The Paradise Inn', 206, '2019-03-28', 116, NULL),
('The Paradise Inn', 206, '2019-03-29', 298, NULL),
('The Paradise Inn', 206, '2019-03-30', 295, NULL),
('The Paradise Inn', 206, '2019-03-31', 346, NULL),
('The Paradise Inn', 206, '2019-04-01', 322, NULL),
('The Paradise Inn', 206, '2019-04-02', 125, NULL),
('The Paradise Inn', 206, '2019-04-03', 185, NULL),
('The Paradise Inn', 206, '2019-04-04', 355, NULL),
('The Paradise Inn', 206, '2019-04-05', 162, NULL),
('The Paradise Inn', 206, '2019-04-06', 239, NULL),
('The Paradise Inn', 206, '2019-04-07', 305, NULL),
('The Paradise Inn', 206, '2019-04-08', 125, NULL),
('The Paradise Inn', 206, '2019-04-09', 153, NULL),
('The Paradise Inn', 206, '2019-04-10', 195, NULL),
('The Paradise Inn', 206, '2019-04-11', 342, NULL),
('The Paradise Inn', 206, '2019-04-12', 168, NULL),
('The Paradise Inn', 206, '2019-04-13', 215, NULL),
('The Paradise Inn', 206, '2019-04-14', 213, NULL),
('The Paradise Inn', 206, '2019-04-15', 133, NULL),
('The Paradise Inn', 206, '2019-04-16', 388, NULL),
('The Paradise Inn', 206, '2019-04-17', 111, NULL),
('The Paradise Inn', 206, '2019-04-18', 330, NULL),
('The Paradise Inn', 206, '2019-04-19', 243, NULL),
('The Paradise Inn', 206, '2019-04-20', 360, NULL),
('The Paradise Inn', 206, '2019-04-21', 223, NULL),
('The Paradise Inn', 206, '2019-04-22', 313, NULL),
('The Paradise Inn', 206, '2019-04-23', 247, NULL),
('The Paradise Inn', 206, '2019-04-24', 193, NULL),
('The Paradise Inn', 206, '2019-04-25', 327, NULL),
('The Paradise Inn', 206, '2019-04-26', 290, NULL),
('The Paradise Inn', 206, '2019-04-27', 375, NULL),
('The Paradise Inn', 206, '2019-04-28', 161, NULL),
('The Paradise Inn', 206, '2019-04-29', 160, NULL),
('The Paradise Inn', 206, '2019-04-30', 334, NULL),
('The Paradise Inn', 206, '2019-05-01', 388, NULL),
('The Paradise Inn', 206, '2019-05-02', 222, NULL),
('The Paradise Inn', 206, '2019-05-03', 194, NULL),
('The Paradise Inn', 206, '2019-05-04', 325, NULL),
('The Paradise Inn', 206, '2019-05-05', 314, NULL),
('The Paradise Inn', 206, '2019-05-06', 177, NULL),
('The Paradise Inn', 206, '2019-05-07', 237, NULL),
('The Paradise Inn', 206, '2019-05-08', 167, NULL),
('The Paradise Inn', 206, '2019-05-09', 386, NULL),
('The Paradise Inn', 206, '2019-05-10', 399, NULL),
('The Paradise Inn', 206, '2019-05-11', 211, NULL),
('The Paradise Inn', 206, '2019-05-12', 258, NULL),
('The Paradise Inn', 206, '2019-05-13', 259, NULL),
('The Paradise Inn', 206, '2019-05-14', 254, NULL),
('The Paradise Inn', 206, '2019-05-15', 145, NULL),
('The Paradise Inn', 206, '2019-05-16', 238, NULL),
('The Paradise Inn', 206, '2019-05-17', 253, NULL),
('The Paradise Inn', 206, '2019-05-18', 248, NULL),
('The Paradise Inn', 206, '2019-05-19', 279, NULL),
('The Paradise Inn', 206, '2019-05-20', 142, NULL),
('The Paradise Inn', 206, '2019-05-21', 176, NULL),
('The Paradise Inn', 206, '2019-05-22', 374, NULL),
('The Paradise Inn', 206, '2019-05-23', 169, NULL),
('The Paradise Inn', 206, '2019-05-24', 128, NULL),
('The Paradise Inn', 206, '2019-05-25', 145, NULL),
('The Paradise Inn', 206, '2019-05-26', 305, NULL),
('The Paradise Inn', 206, '2019-05-27', 205, NULL),
('The Paradise Inn', 206, '2019-05-28', 340, NULL),
('The Paradise Inn', 206, '2019-05-29', 263, NULL),
('The Paradise Inn', 206, '2019-05-30', 135, NULL),
('The Paradise Inn', 206, '2019-05-31', 111, NULL),
('The Paradise Inn', 206, '2019-06-01', 397, NULL),
('The Paradise Inn', 206, '2019-06-02', 162, NULL),
('The Paradise Inn', 206, '2019-06-03', 280, NULL),
('The Paradise Inn', 206, '2019-06-04', 399, NULL),
('The Paradise Inn', 206, '2019-06-05', 251, NULL),
('The Paradise Inn', 206, '2019-06-06', 381, NULL),
('The Paradise Inn', 206, '2019-06-07', 272, NULL),
('The Paradise Inn', 206, '2019-06-08', 307, NULL),
('The Paradise Inn', 206, '2019-06-09', 198, NULL),
('The Paradise Inn', 206, '2019-06-10', 210, NULL),
('The Paradise Inn', 206, '2019-06-11', 268, NULL),
('The Paradise Inn', 206, '2019-06-12', 142, NULL),
('The Paradise Inn', 206, '2019-06-13', 318, NULL),
('The Paradise Inn', 206, '2019-06-14', 181, NULL),
('The Paradise Inn', 206, '2019-06-15', 119, NULL),
('The Paradise Inn', 206, '2019-06-16', 287, NULL),
('The Paradise Inn', 206, '2019-06-17', 331, NULL),
('The Paradise Inn', 206, '2019-06-18', 180, NULL),
('The Paradise Inn', 206, '2019-06-19', 205, NULL),
('The Paradise Inn', 206, '2019-06-20', 275, NULL),
('The Paradise Inn', 206, '2019-06-21', 258, NULL),
('The Paradise Inn', 206, '2019-06-22', 387, NULL),
('The Paradise Inn', 206, '2019-06-23', 324, NULL),
('The Paradise Inn', 206, '2019-06-24', 138, NULL),
('The Paradise Inn', 206, '2019-06-25', 301, NULL),
('The Paradise Inn', 206, '2019-06-26', 149, NULL),
('The Paradise Inn', 206, '2019-06-27', 213, NULL),
('The Paradise Inn', 206, '2019-06-28', 204, NULL),
('The Paradise Inn', 206, '2019-06-29', 129, NULL),
('The Paradise Inn', 206, '2019-06-30', 306, NULL),
('The Paradise Inn', 206, '2019-07-01', 115, NULL),
('The Paradise Inn', 206, '2019-07-02', 146, NULL),
('The Paradise Inn', 206, '2019-07-03', 388, NULL),
('The Paradise Inn', 206, '2019-07-04', 183, NULL),
('The Paradise Inn', 206, '2019-07-05', 139, NULL),
('The Paradise Inn', 206, '2019-07-06', 138, NULL),
('The Paradise Inn', 206, '2019-07-07', 182, NULL),
('The Paradise Inn', 206, '2019-07-08', 260, NULL),
('The Paradise Inn', 206, '2019-07-09', 300, NULL),
('The Paradise Inn', 206, '2019-07-10', 209, NULL),
('The Paradise Inn', 206, '2019-07-11', 346, NULL),
('The Paradise Inn', 206, '2019-07-12', 371, NULL),
('The Paradise Inn', 206, '2019-07-13', 396, NULL),
('The Paradise Inn', 206, '2019-07-14', 293, NULL),
('The Paradise Inn', 206, '2019-07-15', 184, NULL),
('The Paradise Inn', 206, '2019-07-16', 336, NULL),
('The Paradise Inn', 206, '2019-07-17', 227, NULL),
('The Paradise Inn', 206, '2019-07-18', 311, NULL),
('The Paradise Inn', 206, '2019-07-19', 339, NULL),
('The Paradise Inn', 206, '2019-07-20', 304, NULL),
('The Paradise Inn', 206, '2019-07-21', 100, NULL),
('The Paradise Inn', 206, '2019-07-22', 182, NULL),
('The Paradise Inn', 206, '2019-07-23', 244, NULL),
('The Paradise Inn', 206, '2019-07-24', 185, NULL),
('The Paradise Inn', 206, '2019-07-25', 317, NULL),
('The Paradise Inn', 206, '2019-07-26', 204, NULL),
('The Paradise Inn', 206, '2019-07-27', 312, NULL),
('The Paradise Inn', 206, '2019-07-28', 203, NULL),
('The Paradise Inn', 206, '2019-07-29', 247, NULL),
('The Paradise Inn', 206, '2019-07-30', 149, NULL),
('The Paradise Inn', 206, '2019-07-31', 260, NULL),
('The Paradise Inn', 206, '2019-08-01', 266, NULL),
('The Paradise Inn', 206, '2019-08-02', 233, NULL),
('The Paradise Inn', 206, '2019-08-03', 222, NULL),
('The Paradise Inn', 206, '2019-08-04', 266, NULL),
('The Paradise Inn', 206, '2019-08-05', 362, NULL),
('The Paradise Inn', 206, '2019-08-06', 305, NULL),
('The Paradise Inn', 206, '2019-08-07', 143, NULL),
('The Paradise Inn', 206, '2019-08-08', 348, NULL),
('The Paradise Inn', 206, '2019-08-09', 328, NULL),
('The Paradise Inn', 206, '2019-08-10', 168, NULL),
('The Paradise Inn', 206, '2019-08-11', 244, NULL),
('The Paradise Inn', 206, '2019-08-12', 195, NULL),
('The Paradise Inn', 206, '2019-08-13', 123, NULL),
('The Paradise Inn', 206, '2019-08-14', 325, NULL),
('The Paradise Inn', 206, '2019-08-15', 375, NULL),
('The Paradise Inn', 206, '2019-08-16', 151, NULL),
('The Paradise Inn', 206, '2019-08-17', 345, NULL),
('The Paradise Inn', 206, '2019-08-18', 197, NULL),
('The Paradise Inn', 206, '2019-08-19', 162, NULL),
('The Paradise Inn', 206, '2019-08-20', 121, NULL),
('The Paradise Inn', 206, '2019-08-21', 327, NULL),
('The Paradise Inn', 206, '2019-08-22', 124, NULL),
('The Paradise Inn', 206, '2019-08-23', 379, NULL),
('The Paradise Inn', 206, '2019-08-24', 132, NULL),
('The Paradise Inn', 206, '2019-08-25', 306, NULL),
('The Paradise Inn', 206, '2019-08-26', 215, NULL),
('The Paradise Inn', 206, '2019-08-27', 111, NULL),
('The Paradise Inn', 206, '2019-08-28', 268, NULL),
('The Paradise Inn', 206, '2019-08-29', 170, NULL),
('The Paradise Inn', 206, '2019-08-30', 188, NULL),
('The Paradise Inn', 206, '2019-08-31', 359, NULL),
('The Paradise Inn', 206, '2019-09-01', 302, NULL),
('The Paradise Inn', 206, '2019-09-02', 203, NULL),
('The Paradise Inn', 206, '2019-09-03', 295, NULL),
('The Paradise Inn', 206, '2019-09-04', 187, NULL),
('The Paradise Inn', 206, '2019-09-05', 133, NULL),
('The Paradise Inn', 206, '2019-09-06', 176, NULL),
('The Paradise Inn', 206, '2019-09-07', 107, NULL),
('The Paradise Inn', 206, '2019-09-08', 320, NULL),
('The Paradise Inn', 206, '2019-09-09', 103, NULL),
('The Paradise Inn', 206, '2019-09-10', 209, NULL),
('The Paradise Inn', 206, '2019-09-11', 362, NULL),
('The Paradise Inn', 206, '2019-09-12', 108, NULL),
('The Paradise Inn', 206, '2019-09-13', 134, NULL),
('The Paradise Inn', 206, '2019-09-14', 196, NULL),
('The Paradise Inn', 206, '2019-09-15', 120, NULL),
('The Paradise Inn', 206, '2019-09-16', 293, NULL),
('The Paradise Inn', 206, '2019-09-17', 141, NULL),
('The Paradise Inn', 206, '2019-09-18', 335, NULL),
('The Paradise Inn', 206, '2019-09-19', 278, NULL),
('The Paradise Inn', 206, '2019-09-20', 330, NULL),
('The Paradise Inn', 206, '2019-09-21', 164, NULL),
('The Paradise Inn', 206, '2019-09-22', 169, NULL),
('The Paradise Inn', 206, '2019-09-23', 319, NULL),
('The Paradise Inn', 206, '2019-09-24', 223, NULL),
('The Paradise Inn', 206, '2019-09-25', 107, NULL),
('The Paradise Inn', 206, '2019-09-26', 329, NULL),
('The Paradise Inn', 206, '2019-09-27', 166, NULL),
('The Paradise Inn', 206, '2019-09-28', 163, NULL),
('The Paradise Inn', 206, '2019-09-29', 253, NULL),
('The Paradise Inn', 206, '2019-09-30', 100, NULL),
('The Paradise Inn', 206, '2019-10-01', 311, NULL),
('The Paradise Inn', 206, '2019-10-02', 246, NULL),
('The Paradise Inn', 206, '2019-10-03', 308, NULL),
('The Paradise Inn', 206, '2019-10-04', 172, NULL),
('The Paradise Inn', 206, '2019-10-05', 375, NULL),
('The Paradise Inn', 206, '2019-10-06', 171, NULL),
('The Paradise Inn', 206, '2019-10-07', 126, NULL),
('The Paradise Inn', 206, '2019-10-08', 204, NULL),
('The Paradise Inn', 206, '2019-10-09', 233, NULL),
('The Paradise Inn', 206, '2019-10-10', 138, NULL),
('The Paradise Inn', 206, '2019-10-11', 217, NULL),
('The Paradise Inn', 206, '2019-10-12', 297, NULL),
('The Paradise Inn', 206, '2019-10-13', 204, NULL),
('The Paradise Inn', 206, '2019-10-14', 193, NULL),
('The Paradise Inn', 206, '2019-10-15', 258, NULL),
('The Paradise Inn', 206, '2019-10-16', 181, NULL),
('The Paradise Inn', 206, '2019-10-17', 235, NULL),
('The Paradise Inn', 206, '2019-10-18', 292, NULL),
('The Paradise Inn', 206, '2019-10-19', 157, NULL),
('The Paradise Inn', 206, '2019-10-20', 205, NULL),
('The Paradise Inn', 206, '2019-10-21', 204, NULL),
('The Paradise Inn', 206, '2019-10-22', 222, NULL),
('The Paradise Inn', 206, '2019-10-23', 133, NULL),
('The Paradise Inn', 206, '2019-10-24', 323, NULL),
('The Paradise Inn', 206, '2019-10-25', 361, NULL),
('The Paradise Inn', 206, '2019-10-26', 229, NULL),
('The Paradise Inn', 206, '2019-10-27', 313, NULL),
('The Paradise Inn', 206, '2019-10-28', 214, NULL),
('The Paradise Inn', 206, '2019-10-29', 169, NULL),
('The Paradise Inn', 206, '2019-10-30', 390, NULL),
('The Paradise Inn', 206, '2019-10-31', 212, NULL),
('The Paradise Inn', 206, '2019-11-01', 218, NULL),
('The Paradise Inn', 206, '2019-11-02', 145, NULL),
('The Paradise Inn', 206, '2019-11-03', 220, NULL),
('The Paradise Inn', 206, '2019-11-04', 183, NULL),
('The Paradise Inn', 206, '2019-11-05', 249, NULL),
('The Paradise Inn', 206, '2019-11-06', 274, NULL),
('The Paradise Inn', 206, '2019-11-07', 210, NULL),
('The Paradise Inn', 206, '2019-11-08', 208, NULL),
('The Paradise Inn', 206, '2019-11-09', 231, NULL),
('The Paradise Inn', 206, '2019-11-10', 255, NULL),
('The Paradise Inn', 206, '2019-11-11', 275, NULL),
('The Paradise Inn', 206, '2019-11-12', 159, NULL),
('The Paradise Inn', 206, '2019-11-13', 396, NULL),
('The Paradise Inn', 206, '2019-11-14', 355, NULL),
('The Paradise Inn', 206, '2019-11-15', 200, NULL),
('The Paradise Inn', 206, '2019-11-16', 201, NULL),
('The Paradise Inn', 206, '2019-11-17', 138, NULL),
('The Paradise Inn', 206, '2019-11-18', 307, NULL),
('The Paradise Inn', 206, '2019-11-19', 170, NULL),
('The Paradise Inn', 206, '2019-11-20', 271, NULL),
('The Paradise Inn', 206, '2019-11-21', 385, NULL),
('The Paradise Inn', 206, '2019-11-22', 376, NULL),
('The Paradise Inn', 206, '2019-11-23', 321, NULL),
('The Paradise Inn', 206, '2019-11-24', 117, NULL),
('The Paradise Inn', 206, '2019-11-25', 291, NULL),
('The Paradise Inn', 206, '2019-11-26', 135, NULL),
('The Paradise Inn', 206, '2019-11-27', 170, NULL),
('The Paradise Inn', 206, '2019-11-28', 227, NULL),
('The Paradise Inn', 206, '2019-11-29', 119, NULL),
('The Paradise Inn', 206, '2019-11-30', 272, NULL),
('The Paradise Inn', 206, '2019-12-01', 326, NULL),
('The Paradise Inn', 206, '2019-12-02', 322, NULL),
('The Paradise Inn', 206, '2019-12-03', 314, NULL),
('The Paradise Inn', 206, '2019-12-04', 320, NULL),
('The Paradise Inn', 206, '2019-12-05', 122, NULL),
('The Paradise Inn', 206, '2019-12-06', 112, NULL),
('The Paradise Inn', 206, '2019-12-07', 273, NULL),
('The Paradise Inn', 206, '2019-12-08', 189, NULL),
('The Paradise Inn', 206, '2019-12-09', 188, NULL),
('The Paradise Inn', 206, '2019-12-10', 363, NULL),
('The Paradise Inn', 206, '2019-12-11', 322, NULL),
('The Paradise Inn', 206, '2019-12-12', 215, NULL),
('The Paradise Inn', 206, '2019-12-13', 178, NULL),
('The Paradise Inn', 206, '2019-12-14', 127, NULL),
('The Paradise Inn', 206, '2019-12-15', 285, NULL),
('The Paradise Inn', 206, '2019-12-16', 271, NULL),
('The Paradise Inn', 206, '2019-12-17', 365, NULL),
('The Paradise Inn', 206, '2019-12-18', 202, NULL),
('The Paradise Inn', 206, '2019-12-19', 286, NULL),
('The Paradise Inn', 206, '2019-12-20', 198, NULL),
('The Paradise Inn', 206, '2019-12-21', 300, NULL),
('The Paradise Inn', 206, '2019-12-22', 397, NULL),
('The Paradise Inn', 206, '2019-12-23', 173, NULL),
('The Paradise Inn', 206, '2019-12-24', 130, NULL),
('The Paradise Inn', 206, '2019-12-25', 273, NULL),
('The Paradise Inn', 206, '2019-12-26', 233, NULL),
('The Paradise Inn', 206, '2019-12-27', 130, NULL),
('The Paradise Inn', 206, '2019-12-28', 343, NULL),
('The Paradise Inn', 206, '2019-12-29', 385, NULL),
('The Paradise Inn', 206, '2019-12-30', 116, NULL),
('The Paradise Inn', 206, '2019-12-31', 212, NULL),
('The Paradise Inn', 206, '2020-01-01', 163, NULL),
('The Paradise Inn', 206, '2020-01-02', 246, NULL),
('The Paradise Inn', 206, '2020-01-03', 191, NULL),
('The Paradise Inn', 206, '2020-01-04', 303, NULL),
('The Paradise Inn', 206, '2020-01-05', 350, NULL),
('The Paradise Inn', 206, '2020-01-06', 250, NULL),
('The Paradise Inn', 206, '2020-01-07', 371, NULL),
('The Paradise Inn', 206, '2020-01-08', 395, NULL),
('The Paradise Inn', 206, '2020-01-09', 231, NULL),
('The Paradise Inn', 206, '2020-01-10', 365, NULL),
('The Paradise Inn', 206, '2020-01-11', 107, NULL),
('The Paradise Inn', 206, '2020-01-12', 281, NULL),
('The Paradise Inn', 206, '2020-01-13', 268, NULL),
('The Paradise Inn', 206, '2020-01-14', 191, NULL),
('The Paradise Inn', 206, '2020-01-15', 381, NULL),
('The Paradise Inn', 206, '2020-01-16', 126, NULL),
('The Paradise Inn', 206, '2020-01-17', 151, NULL),
('The Paradise Inn', 206, '2020-01-18', 313, NULL),
('The Paradise Inn', 206, '2020-01-19', 184, NULL),
('The Paradise Inn', 206, '2020-01-20', 330, NULL),
('The Paradise Inn', 206, '2020-01-21', 233, NULL),
('The Paradise Inn', 206, '2020-01-22', 110, NULL),
('The Paradise Inn', 206, '2020-01-23', 232, NULL),
('The Paradise Inn', 206, '2020-01-24', 361, NULL),
('The Paradise Inn', 206, '2020-01-25', 397, NULL),
('The Paradise Inn', 206, '2020-01-26', 102, NULL),
('The Paradise Inn', 206, '2020-01-27', 118, NULL),
('The Paradise Inn', 206, '2020-01-28', 184, NULL),
('The Paradise Inn', 206, '2020-01-29', 165, NULL),
('The Paradise Inn', 206, '2020-01-30', 373, NULL),
('The Paradise Inn', 206, '2020-01-31', 134, NULL),
('The Paradise Inn', 206, '2020-02-01', 281, NULL),
('The Paradise Inn', 206, '2020-02-02', 233, NULL),
('The Paradise Inn', 206, '2020-02-03', 230, NULL),
('The Paradise Inn', 206, '2020-02-04', 180, NULL),
('The Paradise Inn', 211, '2019-01-01', 253, NULL),
('The Paradise Inn', 211, '2019-01-02', 220, NULL),
('The Paradise Inn', 211, '2019-01-03', 300, NULL),
('The Paradise Inn', 211, '2019-01-04', 209, NULL),
('The Paradise Inn', 211, '2019-01-05', 196, NULL),
('The Paradise Inn', 211, '2019-01-06', 300, NULL),
('The Paradise Inn', 211, '2019-01-07', 391, NULL),
('The Paradise Inn', 211, '2019-01-08', 195, NULL),
('The Paradise Inn', 211, '2019-01-09', 222, NULL),
('The Paradise Inn', 211, '2019-01-10', 219, NULL),
('The Paradise Inn', 211, '2019-01-11', 152, NULL),
('The Paradise Inn', 211, '2019-01-12', 287, NULL),
('The Paradise Inn', 211, '2019-01-13', 165, NULL),
('The Paradise Inn', 211, '2019-01-14', 268, NULL),
('The Paradise Inn', 211, '2019-01-15', 191, NULL),
('The Paradise Inn', 211, '2019-01-16', 146, NULL),
('The Paradise Inn', 211, '2019-01-17', 122, NULL),
('The Paradise Inn', 211, '2019-01-18', 255, NULL),
('The Paradise Inn', 211, '2019-01-19', 127, NULL),
('The Paradise Inn', 211, '2019-01-20', 135, NULL),
('The Paradise Inn', 211, '2019-01-21', 361, NULL),
('The Paradise Inn', 211, '2019-01-22', 225, NULL),
('The Paradise Inn', 211, '2019-01-23', 156, NULL),
('The Paradise Inn', 211, '2019-01-24', 217, NULL),
('The Paradise Inn', 211, '2019-01-25', 274, NULL),
('The Paradise Inn', 211, '2019-01-26', 236, NULL),
('The Paradise Inn', 211, '2019-01-27', 265, NULL),
('The Paradise Inn', 211, '2019-01-28', 238, NULL),
('The Paradise Inn', 211, '2019-01-29', 392, NULL),
('The Paradise Inn', 211, '2019-01-30', 312, NULL),
('The Paradise Inn', 211, '2019-01-31', 342, NULL),
('The Paradise Inn', 211, '2019-02-01', 281, NULL),
('The Paradise Inn', 211, '2019-02-02', 369, NULL),
('The Paradise Inn', 211, '2019-02-03', 154, NULL),
('The Paradise Inn', 211, '2019-02-04', 101, NULL),
('The Paradise Inn', 211, '2019-02-05', 207, NULL),
('The Paradise Inn', 211, '2019-02-06', 157, NULL),
('The Paradise Inn', 211, '2019-02-07', 111, NULL),
('The Paradise Inn', 211, '2019-02-08', 127, NULL),
('The Paradise Inn', 211, '2019-02-09', 172, NULL),
('The Paradise Inn', 211, '2019-02-10', 323, NULL),
('The Paradise Inn', 211, '2019-02-11', 353, NULL),
('The Paradise Inn', 211, '2019-02-12', 180, NULL),
('The Paradise Inn', 211, '2019-02-13', 216, NULL),
('The Paradise Inn', 211, '2019-02-14', 185, NULL),
('The Paradise Inn', 211, '2019-02-15', 177, NULL),
('The Paradise Inn', 211, '2019-02-16', 351, NULL),
('The Paradise Inn', 211, '2019-02-17', 131, NULL),
('The Paradise Inn', 211, '2019-02-18', 160, NULL),
('The Paradise Inn', 211, '2019-02-19', 164, NULL),
('The Paradise Inn', 211, '2019-02-20', 175, NULL),
('The Paradise Inn', 211, '2019-02-21', 368, NULL),
('The Paradise Inn', 211, '2019-02-22', 162, NULL),
('The Paradise Inn', 211, '2019-02-23', 249, NULL),
('The Paradise Inn', 211, '2019-02-24', 271, NULL),
('The Paradise Inn', 211, '2019-02-25', 112, NULL),
('The Paradise Inn', 211, '2019-02-26', 230, NULL),
('The Paradise Inn', 211, '2019-02-27', 302, NULL),
('The Paradise Inn', 211, '2019-02-28', 299, NULL),
('The Paradise Inn', 211, '2019-03-01', 335, NULL),
('The Paradise Inn', 211, '2019-03-02', 342, NULL),
('The Paradise Inn', 211, '2019-03-03', 197, NULL),
('The Paradise Inn', 211, '2019-03-04', 209, NULL),
('The Paradise Inn', 211, '2019-03-05', 136, NULL),
('The Paradise Inn', 211, '2019-03-06', 279, NULL),
('The Paradise Inn', 211, '2019-03-07', 385, NULL),
('The Paradise Inn', 211, '2019-03-08', 167, NULL),
('The Paradise Inn', 211, '2019-03-09', 281, NULL),
('The Paradise Inn', 211, '2019-03-10', 196, NULL),
('The Paradise Inn', 211, '2019-03-11', 192, NULL),
('The Paradise Inn', 211, '2019-03-12', 384, NULL),
('The Paradise Inn', 211, '2019-03-13', 140, NULL),
('The Paradise Inn', 211, '2019-03-14', 214, NULL),
('The Paradise Inn', 211, '2019-03-15', 233, NULL),
('The Paradise Inn', 211, '2019-03-16', 191, NULL),
('The Paradise Inn', 211, '2019-03-17', 389, NULL),
('The Paradise Inn', 211, '2019-03-18', 257, NULL),
('The Paradise Inn', 211, '2019-03-19', 354, NULL),
('The Paradise Inn', 211, '2019-03-20', 228, NULL),
('The Paradise Inn', 211, '2019-03-21', 111, NULL),
('The Paradise Inn', 211, '2019-03-22', 398, NULL),
('The Paradise Inn', 211, '2019-03-23', 224, NULL),
('The Paradise Inn', 211, '2019-03-24', 325, NULL),
('The Paradise Inn', 211, '2019-03-25', 272, NULL),
('The Paradise Inn', 211, '2019-03-26', 368, NULL),
('The Paradise Inn', 211, '2019-03-27', 247, NULL),
('The Paradise Inn', 211, '2019-03-28', 201, NULL),
('The Paradise Inn', 211, '2019-03-29', 120, NULL),
('The Paradise Inn', 211, '2019-03-30', 260, NULL),
('The Paradise Inn', 211, '2019-03-31', 257, NULL),
('The Paradise Inn', 211, '2019-04-01', 287, NULL),
('The Paradise Inn', 211, '2019-04-02', 194, NULL),
('The Paradise Inn', 211, '2019-04-03', 179, NULL),
('The Paradise Inn', 211, '2019-04-04', 204, NULL),
('The Paradise Inn', 211, '2019-04-05', 198, NULL),
('The Paradise Inn', 211, '2019-04-06', 235, NULL),
('The Paradise Inn', 211, '2019-04-07', 310, NULL),
('The Paradise Inn', 211, '2019-04-08', 381, NULL),
('The Paradise Inn', 211, '2019-04-09', 202, NULL),
('The Paradise Inn', 211, '2019-04-10', 162, NULL),
('The Paradise Inn', 211, '2019-04-11', 311, NULL),
('The Paradise Inn', 211, '2019-04-12', 216, NULL),
('The Paradise Inn', 211, '2019-04-13', 280, NULL),
('The Paradise Inn', 211, '2019-04-14', 230, NULL),
('The Paradise Inn', 211, '2019-04-15', 107, NULL),
('The Paradise Inn', 211, '2019-04-16', 375, NULL),
('The Paradise Inn', 211, '2019-04-17', 200, NULL),
('The Paradise Inn', 211, '2019-04-18', 171, NULL),
('The Paradise Inn', 211, '2019-04-19', 216, NULL),
('The Paradise Inn', 211, '2019-04-20', 207, NULL),
('The Paradise Inn', 211, '2019-04-21', 206, NULL),
('The Paradise Inn', 211, '2019-04-22', 185, NULL),
('The Paradise Inn', 211, '2019-04-23', 178, NULL),
('The Paradise Inn', 211, '2019-04-24', 122, NULL),
('The Paradise Inn', 211, '2019-04-25', 151, NULL),
('The Paradise Inn', 211, '2019-04-26', 388, NULL),
('The Paradise Inn', 211, '2019-04-27', 143, NULL),
('The Paradise Inn', 211, '2019-04-28', 190, NULL),
('The Paradise Inn', 211, '2019-04-29', 215, NULL),
('The Paradise Inn', 211, '2019-04-30', 366, NULL),
('The Paradise Inn', 211, '2019-05-01', 245, NULL),
('The Paradise Inn', 211, '2019-05-02', 194, NULL),
('The Paradise Inn', 211, '2019-05-03', 206, NULL),
('The Paradise Inn', 211, '2019-05-04', 101, NULL),
('The Paradise Inn', 211, '2019-05-05', 279, NULL),
('The Paradise Inn', 211, '2019-05-06', 311, NULL),
('The Paradise Inn', 211, '2019-05-07', 227, NULL),
('The Paradise Inn', 211, '2019-05-08', 277, NULL),
('The Paradise Inn', 211, '2019-05-09', 354, NULL),
('The Paradise Inn', 211, '2019-05-10', 270, NULL),
('The Paradise Inn', 211, '2019-05-11', 137, NULL),
('The Paradise Inn', 211, '2019-05-12', 219, NULL),
('The Paradise Inn', 211, '2019-05-13', 325, NULL),
('The Paradise Inn', 211, '2019-05-14', 269, NULL),
('The Paradise Inn', 211, '2019-05-15', 377, NULL),
('The Paradise Inn', 211, '2019-05-16', 393, NULL),
('The Paradise Inn', 211, '2019-05-17', 104, NULL),
('The Paradise Inn', 211, '2019-05-18', 265, NULL),
('The Paradise Inn', 211, '2019-05-19', 342, NULL),
('The Paradise Inn', 211, '2019-05-20', 351, NULL),
('The Paradise Inn', 211, '2019-05-21', 156, NULL),
('The Paradise Inn', 211, '2019-05-22', 142, NULL),
('The Paradise Inn', 211, '2019-05-23', 227, NULL),
('The Paradise Inn', 211, '2019-05-24', 294, NULL),
('The Paradise Inn', 211, '2019-05-25', 289, NULL),
('The Paradise Inn', 211, '2019-05-26', 333, NULL),
('The Paradise Inn', 211, '2019-05-27', 290, NULL),
('The Paradise Inn', 211, '2019-05-28', 147, NULL),
('The Paradise Inn', 211, '2019-05-29', 241, NULL),
('The Paradise Inn', 211, '2019-05-30', 222, NULL),
('The Paradise Inn', 211, '2019-05-31', 129, NULL),
('The Paradise Inn', 211, '2019-06-01', 102, NULL),
('The Paradise Inn', 211, '2019-06-02', 387, NULL),
('The Paradise Inn', 211, '2019-06-03', 113, NULL),
('The Paradise Inn', 211, '2019-06-04', 242, NULL),
('The Paradise Inn', 211, '2019-06-05', 229, NULL),
('The Paradise Inn', 211, '2019-06-06', 252, NULL),
('The Paradise Inn', 211, '2019-06-07', 278, NULL),
('The Paradise Inn', 211, '2019-06-08', 317, NULL),
('The Paradise Inn', 211, '2019-06-09', 392, NULL),
('The Paradise Inn', 211, '2019-06-10', 133, NULL),
('The Paradise Inn', 211, '2019-06-11', 173, NULL),
('The Paradise Inn', 211, '2019-06-12', 353, NULL),
('The Paradise Inn', 211, '2019-06-13', 261, NULL),
('The Paradise Inn', 211, '2019-06-14', 201, NULL),
('The Paradise Inn', 211, '2019-06-15', 219, NULL),
('The Paradise Inn', 211, '2019-06-16', 350, NULL),
('The Paradise Inn', 211, '2019-06-17', 341, NULL),
('The Paradise Inn', 211, '2019-06-18', 176, NULL),
('The Paradise Inn', 211, '2019-06-19', 222, NULL),
('The Paradise Inn', 211, '2019-06-20', 130, NULL),
('The Paradise Inn', 211, '2019-06-21', 296, NULL),
('The Paradise Inn', 211, '2019-06-22', 208, NULL),
('The Paradise Inn', 211, '2019-06-23', 306, NULL),
('The Paradise Inn', 211, '2019-06-24', 116, NULL),
('The Paradise Inn', 211, '2019-06-25', 291, NULL),
('The Paradise Inn', 211, '2019-06-26', 257, NULL),
('The Paradise Inn', 211, '2019-06-27', 345, NULL),
('The Paradise Inn', 211, '2019-06-28', 143, NULL),
('The Paradise Inn', 211, '2019-06-29', 182, NULL),
('The Paradise Inn', 211, '2019-06-30', 212, NULL),
('The Paradise Inn', 211, '2019-07-01', 121, NULL),
('The Paradise Inn', 211, '2019-07-02', 222, NULL),
('The Paradise Inn', 211, '2019-07-03', 333, NULL),
('The Paradise Inn', 211, '2019-07-04', 168, NULL),
('The Paradise Inn', 211, '2019-07-05', 373, NULL),
('The Paradise Inn', 211, '2019-07-06', 101, NULL),
('The Paradise Inn', 211, '2019-07-07', 148, NULL),
('The Paradise Inn', 211, '2019-07-08', 276, NULL),
('The Paradise Inn', 211, '2019-07-09', 287, NULL),
('The Paradise Inn', 211, '2019-07-10', 335, NULL),
('The Paradise Inn', 211, '2019-07-11', 177, NULL),
('The Paradise Inn', 211, '2019-07-12', 177, NULL),
('The Paradise Inn', 211, '2019-07-13', 170, NULL),
('The Paradise Inn', 211, '2019-07-14', 200, NULL),
('The Paradise Inn', 211, '2019-07-15', 353, NULL),
('The Paradise Inn', 211, '2019-07-16', 280, NULL),
('The Paradise Inn', 211, '2019-07-17', 115, NULL),
('The Paradise Inn', 211, '2019-07-18', 275, NULL),
('The Paradise Inn', 211, '2019-07-19', 393, NULL),
('The Paradise Inn', 211, '2019-07-20', 261, NULL),
('The Paradise Inn', 211, '2019-07-21', 136, NULL),
('The Paradise Inn', 211, '2019-07-22', 152, NULL),
('The Paradise Inn', 211, '2019-07-23', 253, NULL),
('The Paradise Inn', 211, '2019-07-24', 339, NULL),
('The Paradise Inn', 211, '2019-07-25', 335, NULL),
('The Paradise Inn', 211, '2019-07-26', 186, NULL),
('The Paradise Inn', 211, '2019-07-27', 221, NULL),
('The Paradise Inn', 211, '2019-07-28', 284, NULL),
('The Paradise Inn', 211, '2019-07-29', 240, NULL),
('The Paradise Inn', 211, '2019-07-30', 360, NULL),
('The Paradise Inn', 211, '2019-07-31', 371, NULL),
('The Paradise Inn', 211, '2019-08-01', 369, NULL),
('The Paradise Inn', 211, '2019-08-02', 157, NULL),
('The Paradise Inn', 211, '2019-08-03', 292, NULL),
('The Paradise Inn', 211, '2019-08-04', 353, NULL),
('The Paradise Inn', 211, '2019-08-05', 147, NULL),
('The Paradise Inn', 211, '2019-08-06', 347, NULL),
('The Paradise Inn', 211, '2019-08-07', 326, NULL),
('The Paradise Inn', 211, '2019-08-08', 369, NULL),
('The Paradise Inn', 211, '2019-08-09', 351, NULL),
('The Paradise Inn', 211, '2019-08-10', 275, NULL),
('The Paradise Inn', 211, '2019-08-11', 231, NULL),
('The Paradise Inn', 211, '2019-08-12', 356, NULL),
('The Paradise Inn', 211, '2019-08-13', 239, NULL),
('The Paradise Inn', 211, '2019-08-14', 256, NULL),
('The Paradise Inn', 211, '2019-08-15', 198, NULL),
('The Paradise Inn', 211, '2019-08-16', 258, NULL),
('The Paradise Inn', 211, '2019-08-17', 199, NULL),
('The Paradise Inn', 211, '2019-08-18', 287, NULL),
('The Paradise Inn', 211, '2019-08-19', 137, NULL),
('The Paradise Inn', 211, '2019-08-20', 162, NULL),
('The Paradise Inn', 211, '2019-08-21', 134, NULL),
('The Paradise Inn', 211, '2019-08-22', 146, NULL),
('The Paradise Inn', 211, '2019-08-23', 102, NULL),
('The Paradise Inn', 211, '2019-08-24', 304, NULL),
('The Paradise Inn', 211, '2019-08-25', 266, NULL),
('The Paradise Inn', 211, '2019-08-26', 201, NULL),
('The Paradise Inn', 211, '2019-08-27', 270, NULL),
('The Paradise Inn', 211, '2019-08-28', 347, NULL),
('The Paradise Inn', 211, '2019-08-29', 168, NULL),
('The Paradise Inn', 211, '2019-08-30', 183, NULL),
('The Paradise Inn', 211, '2019-08-31', 306, NULL),
('The Paradise Inn', 211, '2019-09-01', 176, NULL),
('The Paradise Inn', 211, '2019-09-02', 283, NULL),
('The Paradise Inn', 211, '2019-09-03', 220, NULL),
('The Paradise Inn', 211, '2019-09-04', 366, NULL),
('The Paradise Inn', 211, '2019-09-05', 301, NULL),
('The Paradise Inn', 211, '2019-09-06', 301, NULL),
('The Paradise Inn', 211, '2019-09-07', 151, NULL),
('The Paradise Inn', 211, '2019-09-08', 242, NULL),
('The Paradise Inn', 211, '2019-09-09', 396, NULL),
('The Paradise Inn', 211, '2019-09-10', 108, NULL),
('The Paradise Inn', 211, '2019-09-11', 109, NULL),
('The Paradise Inn', 211, '2019-09-12', 318, NULL),
('The Paradise Inn', 211, '2019-09-13', 116, NULL),
('The Paradise Inn', 211, '2019-09-14', 102, NULL),
('The Paradise Inn', 211, '2019-09-15', 152, NULL),
('The Paradise Inn', 211, '2019-09-16', 340, NULL),
('The Paradise Inn', 211, '2019-09-17', 187, NULL),
('The Paradise Inn', 211, '2019-09-18', 251, NULL),
('The Paradise Inn', 211, '2019-09-19', 399, NULL),
('The Paradise Inn', 211, '2019-09-20', 120, NULL),
('The Paradise Inn', 211, '2019-09-21', 380, NULL),
('The Paradise Inn', 211, '2019-09-22', 199, NULL),
('The Paradise Inn', 211, '2019-09-23', 150, NULL),
('The Paradise Inn', 211, '2019-09-24', 221, NULL),
('The Paradise Inn', 211, '2019-09-25', 335, NULL),
('The Paradise Inn', 211, '2019-09-26', 129, NULL),
('The Paradise Inn', 211, '2019-09-27', 285, NULL),
('The Paradise Inn', 211, '2019-09-28', 119, NULL),
('The Paradise Inn', 211, '2019-09-29', 164, NULL),
('The Paradise Inn', 211, '2019-09-30', 164, NULL),
('The Paradise Inn', 211, '2019-10-01', 260, NULL),
('The Paradise Inn', 211, '2019-10-02', 344, NULL),
('The Paradise Inn', 211, '2019-10-03', 108, NULL),
('The Paradise Inn', 211, '2019-10-04', 244, NULL),
('The Paradise Inn', 211, '2019-10-05', 174, NULL),
('The Paradise Inn', 211, '2019-10-06', 322, NULL),
('The Paradise Inn', 211, '2019-10-07', 183, NULL),
('The Paradise Inn', 211, '2019-10-08', 383, NULL),
('The Paradise Inn', 211, '2019-10-09', 378, NULL),
('The Paradise Inn', 211, '2019-10-10', 381, NULL),
('The Paradise Inn', 211, '2019-10-11', 266, NULL),
('The Paradise Inn', 211, '2019-10-12', 388, NULL),
('The Paradise Inn', 211, '2019-10-13', 241, NULL),
('The Paradise Inn', 211, '2019-10-14', 173, NULL),
('The Paradise Inn', 211, '2019-10-15', 399, NULL),
('The Paradise Inn', 211, '2019-10-16', 364, NULL),
('The Paradise Inn', 211, '2019-10-17', 396, NULL),
('The Paradise Inn', 211, '2019-10-18', 266, NULL),
('The Paradise Inn', 211, '2019-10-19', 235, NULL),
('The Paradise Inn', 211, '2019-10-20', 268, NULL),
('The Paradise Inn', 211, '2019-10-21', 287, NULL),
('The Paradise Inn', 211, '2019-10-22', 267, NULL),
('The Paradise Inn', 211, '2019-10-23', 130, NULL),
('The Paradise Inn', 211, '2019-10-24', 209, NULL),
('The Paradise Inn', 211, '2019-10-25', 104, NULL),
('The Paradise Inn', 211, '2019-10-26', 221, NULL),
('The Paradise Inn', 211, '2019-10-27', 330, NULL),
('The Paradise Inn', 211, '2019-10-28', 374, NULL),
('The Paradise Inn', 211, '2019-10-29', 280, NULL),
('The Paradise Inn', 211, '2019-10-30', 200, NULL),
('The Paradise Inn', 211, '2019-10-31', 285, NULL),
('The Paradise Inn', 211, '2019-11-01', 315, NULL),
('The Paradise Inn', 211, '2019-11-02', 173, NULL),
('The Paradise Inn', 211, '2019-11-03', 352, NULL),
('The Paradise Inn', 211, '2019-11-04', 392, NULL),
('The Paradise Inn', 211, '2019-11-05', 360, NULL),
('The Paradise Inn', 211, '2019-11-06', 247, NULL),
('The Paradise Inn', 211, '2019-11-07', 397, NULL),
('The Paradise Inn', 211, '2019-11-08', 300, NULL),
('The Paradise Inn', 211, '2019-11-09', 265, NULL),
('The Paradise Inn', 211, '2019-11-10', 221, NULL),
('The Paradise Inn', 211, '2019-11-11', 324, NULL),
('The Paradise Inn', 211, '2019-11-12', 336, NULL),
('The Paradise Inn', 211, '2019-11-13', 352, NULL),
('The Paradise Inn', 211, '2019-11-14', 312, NULL),
('The Paradise Inn', 211, '2019-11-15', 380, NULL),
('The Paradise Inn', 211, '2019-11-16', 372, NULL),
('The Paradise Inn', 211, '2019-11-17', 328, NULL),
('The Paradise Inn', 211, '2019-11-18', 351, NULL),
('The Paradise Inn', 211, '2019-11-19', 103, NULL),
('The Paradise Inn', 211, '2019-11-20', 179, NULL),
('The Paradise Inn', 211, '2019-11-21', 291, NULL),
('The Paradise Inn', 211, '2019-11-22', 303, NULL),
('The Paradise Inn', 211, '2019-11-23', 280, NULL),
('The Paradise Inn', 211, '2019-11-24', 126, NULL),
('The Paradise Inn', 211, '2019-11-25', 219, NULL),
('The Paradise Inn', 211, '2019-11-26', 111, NULL),
('The Paradise Inn', 211, '2019-11-27', 175, NULL),
('The Paradise Inn', 211, '2019-11-28', 311, NULL),
('The Paradise Inn', 211, '2019-11-29', 164, NULL),
('The Paradise Inn', 211, '2019-11-30', 264, NULL),
('The Paradise Inn', 211, '2019-12-01', 295, NULL),
('The Paradise Inn', 211, '2019-12-02', 242, NULL),
('The Paradise Inn', 211, '2019-12-03', 313, NULL),
('The Paradise Inn', 211, '2019-12-04', 315, NULL),
('The Paradise Inn', 211, '2019-12-05', 325, NULL),
('The Paradise Inn', 211, '2019-12-06', 192, NULL),
('The Paradise Inn', 211, '2019-12-07', 259, NULL),
('The Paradise Inn', 211, '2019-12-08', 296, NULL),
('The Paradise Inn', 211, '2019-12-09', 350, NULL),
('The Paradise Inn', 211, '2019-12-10', 310, NULL),
('The Paradise Inn', 211, '2019-12-11', 260, NULL),
('The Paradise Inn', 211, '2019-12-12', 116, NULL),
('The Paradise Inn', 211, '2019-12-13', 240, NULL),
('The Paradise Inn', 211, '2019-12-14', 369, NULL),
('The Paradise Inn', 211, '2019-12-15', 384, NULL),
('The Paradise Inn', 211, '2019-12-16', 146, NULL),
('The Paradise Inn', 211, '2019-12-17', 242, NULL),
('The Paradise Inn', 211, '2019-12-18', 218, NULL),
('The Paradise Inn', 211, '2019-12-19', 217, NULL),
('The Paradise Inn', 211, '2019-12-20', 171, NULL),
('The Paradise Inn', 211, '2019-12-21', 282, NULL),
('The Paradise Inn', 211, '2019-12-22', 164, NULL),
('The Paradise Inn', 211, '2019-12-23', 160, NULL),
('The Paradise Inn', 211, '2019-12-24', 246, NULL),
('The Paradise Inn', 211, '2019-12-25', 272, NULL),
('The Paradise Inn', 211, '2019-12-26', 185, NULL),
('The Paradise Inn', 211, '2019-12-27', 180, NULL),
('The Paradise Inn', 211, '2019-12-28', 271, NULL),
('The Paradise Inn', 211, '2019-12-29', 195, NULL),
('The Paradise Inn', 211, '2019-12-30', 316, NULL),
('The Paradise Inn', 211, '2019-12-31', 204, NULL),
('The Paradise Inn', 211, '2020-01-01', 210, NULL),
('The Paradise Inn', 211, '2020-01-02', 149, NULL),
('The Paradise Inn', 211, '2020-01-03', 177, NULL),
('The Paradise Inn', 211, '2020-01-04', 224, NULL),
('The Paradise Inn', 211, '2020-01-05', 331, NULL),
('The Paradise Inn', 211, '2020-01-06', 397, NULL),
('The Paradise Inn', 211, '2020-01-07', 329, NULL),
('The Paradise Inn', 211, '2020-01-08', 277, NULL),
('The Paradise Inn', 211, '2020-01-09', 347, NULL),
('The Paradise Inn', 211, '2020-01-10', 371, NULL),
('The Paradise Inn', 211, '2020-01-11', 255, NULL),
('The Paradise Inn', 211, '2020-01-12', 277, NULL),
('The Paradise Inn', 211, '2020-01-13', 179, NULL),
('The Paradise Inn', 211, '2020-01-14', 398, NULL),
('The Paradise Inn', 211, '2020-01-15', 218, NULL),
('The Paradise Inn', 211, '2020-01-16', 383, NULL),
('The Paradise Inn', 211, '2020-01-17', 145, NULL),
('The Paradise Inn', 211, '2020-01-18', 366, NULL),
('The Paradise Inn', 211, '2020-01-19', 154, NULL),
('The Paradise Inn', 211, '2020-01-20', 139, NULL),
('The Paradise Inn', 211, '2020-01-21', 373, NULL),
('The Paradise Inn', 211, '2020-01-22', 294, NULL),
('The Paradise Inn', 211, '2020-01-23', 212, NULL),
('The Paradise Inn', 211, '2020-01-24', 256, NULL),
('The Paradise Inn', 211, '2020-01-25', 324, NULL),
('The Paradise Inn', 211, '2020-01-26', 153, NULL),
('The Paradise Inn', 211, '2020-01-27', 281, NULL),
('The Paradise Inn', 211, '2020-01-28', 317, NULL),
('The Paradise Inn', 211, '2020-01-29', 388, NULL),
('The Paradise Inn', 211, '2020-01-30', 307, NULL),
('The Paradise Inn', 211, '2020-01-31', 342, NULL),
('The Paradise Inn', 211, '2020-02-01', 345, NULL),
('The Paradise Inn', 211, '2020-02-02', 361, NULL),
('The Paradise Inn', 211, '2020-02-03', 177, NULL),
('The Paradise Inn', 211, '2020-02-04', 152, NULL),
('The Paradise Inn', 226, '2019-01-01', 128, NULL),
('The Paradise Inn', 226, '2019-01-02', 246, NULL),
('The Paradise Inn', 226, '2019-01-03', 286, NULL),
('The Paradise Inn', 226, '2019-01-04', 266, NULL),
('The Paradise Inn', 226, '2019-01-05', 293, NULL),
('The Paradise Inn', 226, '2019-01-06', 277, NULL),
('The Paradise Inn', 226, '2019-01-07', 349, NULL),
('The Paradise Inn', 226, '2019-01-08', 206, NULL),
('The Paradise Inn', 226, '2019-01-09', 107, NULL),
('The Paradise Inn', 226, '2019-01-10', 334, NULL),
('The Paradise Inn', 226, '2019-01-11', 205, NULL),
('The Paradise Inn', 226, '2019-01-12', 326, NULL),
('The Paradise Inn', 226, '2019-01-13', 389, NULL),
('The Paradise Inn', 226, '2019-01-14', 275, NULL),
('The Paradise Inn', 226, '2019-01-15', 115, NULL),
('The Paradise Inn', 226, '2019-01-16', 210, NULL),
('The Paradise Inn', 226, '2019-01-17', 351, NULL),
('The Paradise Inn', 226, '2019-01-18', 141, NULL),
('The Paradise Inn', 226, '2019-01-19', 337, NULL),
('The Paradise Inn', 226, '2019-01-20', 188, NULL),
('The Paradise Inn', 226, '2019-01-21', 314, NULL),
('The Paradise Inn', 226, '2019-01-22', 200, NULL),
('The Paradise Inn', 226, '2019-01-23', 345, NULL),
('The Paradise Inn', 226, '2019-01-24', 162, NULL),
('The Paradise Inn', 226, '2019-01-25', 320, NULL),
('The Paradise Inn', 226, '2019-01-26', 232, NULL),
('The Paradise Inn', 226, '2019-01-27', 131, NULL),
('The Paradise Inn', 226, '2019-01-28', 317, NULL),
('The Paradise Inn', 226, '2019-01-29', 247, NULL),
('The Paradise Inn', 226, '2019-01-30', 167, NULL),
('The Paradise Inn', 226, '2019-01-31', 244, NULL),
('The Paradise Inn', 226, '2019-02-01', 284, NULL),
('The Paradise Inn', 226, '2019-02-02', 322, NULL),
('The Paradise Inn', 226, '2019-02-03', 375, NULL),
('The Paradise Inn', 226, '2019-02-04', 388, NULL),
('The Paradise Inn', 226, '2019-02-05', 181, NULL),
('The Paradise Inn', 226, '2019-02-06', 137, NULL),
('The Paradise Inn', 226, '2019-02-07', 274, NULL),
('The Paradise Inn', 226, '2019-02-08', 128, NULL),
('The Paradise Inn', 226, '2019-02-09', 218, NULL),
('The Paradise Inn', 226, '2019-02-10', 159, NULL),
('The Paradise Inn', 226, '2019-02-11', 194, NULL),
('The Paradise Inn', 226, '2019-02-12', 322, NULL),
('The Paradise Inn', 226, '2019-02-13', 318, NULL),
('The Paradise Inn', 226, '2019-02-14', 188, NULL),
('The Paradise Inn', 226, '2019-02-15', 235, NULL),
('The Paradise Inn', 226, '2019-02-16', 116, NULL),
('The Paradise Inn', 226, '2019-02-17', 159, NULL),
('The Paradise Inn', 226, '2019-02-18', 126, NULL),
('The Paradise Inn', 226, '2019-02-19', 352, NULL),
('The Paradise Inn', 226, '2019-02-20', 252, NULL),
('The Paradise Inn', 226, '2019-02-21', 345, NULL),
('The Paradise Inn', 226, '2019-02-22', 300, NULL),
('The Paradise Inn', 226, '2019-02-23', 278, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 226, '2019-02-24', 279, NULL),
('The Paradise Inn', 226, '2019-02-25', 288, NULL),
('The Paradise Inn', 226, '2019-02-26', 205, NULL),
('The Paradise Inn', 226, '2019-02-27', 139, NULL),
('The Paradise Inn', 226, '2019-02-28', 383, NULL),
('The Paradise Inn', 226, '2019-03-01', 173, NULL),
('The Paradise Inn', 226, '2019-03-02', 191, NULL),
('The Paradise Inn', 226, '2019-03-03', 364, NULL),
('The Paradise Inn', 226, '2019-03-04', 282, NULL),
('The Paradise Inn', 226, '2019-03-05', 276, NULL),
('The Paradise Inn', 226, '2019-03-06', 147, NULL),
('The Paradise Inn', 226, '2019-03-07', 227, NULL),
('The Paradise Inn', 226, '2019-03-08', 140, NULL),
('The Paradise Inn', 226, '2019-03-09', 293, NULL),
('The Paradise Inn', 226, '2019-03-10', 310, NULL),
('The Paradise Inn', 226, '2019-03-11', 325, NULL),
('The Paradise Inn', 226, '2019-03-12', 195, NULL),
('The Paradise Inn', 226, '2019-03-13', 277, NULL),
('The Paradise Inn', 226, '2019-03-14', 326, NULL),
('The Paradise Inn', 226, '2019-03-15', 199, NULL),
('The Paradise Inn', 226, '2019-03-16', 254, NULL),
('The Paradise Inn', 226, '2019-03-17', 136, NULL),
('The Paradise Inn', 226, '2019-03-18', 247, NULL),
('The Paradise Inn', 226, '2019-03-19', 137, NULL),
('The Paradise Inn', 226, '2019-03-20', 120, NULL),
('The Paradise Inn', 226, '2019-03-21', 220, NULL),
('The Paradise Inn', 226, '2019-03-22', 391, NULL),
('The Paradise Inn', 226, '2019-03-23', 212, NULL),
('The Paradise Inn', 226, '2019-03-24', 279, NULL),
('The Paradise Inn', 226, '2019-03-25', 139, NULL),
('The Paradise Inn', 226, '2019-03-26', 337, NULL),
('The Paradise Inn', 226, '2019-03-27', 149, NULL),
('The Paradise Inn', 226, '2019-03-28', 257, NULL),
('The Paradise Inn', 226, '2019-03-29', 209, NULL),
('The Paradise Inn', 226, '2019-03-30', 315, NULL),
('The Paradise Inn', 226, '2019-03-31', 148, NULL),
('The Paradise Inn', 226, '2019-04-01', 370, NULL),
('The Paradise Inn', 226, '2019-04-02', 196, NULL),
('The Paradise Inn', 226, '2019-04-03', 241, NULL),
('The Paradise Inn', 226, '2019-04-04', 156, NULL),
('The Paradise Inn', 226, '2019-04-05', 105, NULL),
('The Paradise Inn', 226, '2019-04-06', 359, NULL),
('The Paradise Inn', 226, '2019-04-07', 238, NULL),
('The Paradise Inn', 226, '2019-04-08', 233, NULL),
('The Paradise Inn', 226, '2019-04-09', 150, NULL),
('The Paradise Inn', 226, '2019-04-10', 124, NULL),
('The Paradise Inn', 226, '2019-04-11', 129, NULL),
('The Paradise Inn', 226, '2019-04-12', 177, NULL),
('The Paradise Inn', 226, '2019-04-13', 353, NULL),
('The Paradise Inn', 226, '2019-04-14', 109, NULL),
('The Paradise Inn', 226, '2019-04-15', 339, NULL),
('The Paradise Inn', 226, '2019-04-16', 315, NULL),
('The Paradise Inn', 226, '2019-04-17', 264, NULL),
('The Paradise Inn', 226, '2019-04-18', 365, NULL),
('The Paradise Inn', 226, '2019-04-19', 249, NULL),
('The Paradise Inn', 226, '2019-04-20', 153, NULL),
('The Paradise Inn', 226, '2019-04-21', 263, NULL),
('The Paradise Inn', 226, '2019-04-22', 183, NULL),
('The Paradise Inn', 226, '2019-04-23', 352, NULL),
('The Paradise Inn', 226, '2019-04-24', 233, NULL),
('The Paradise Inn', 226, '2019-04-25', 274, NULL),
('The Paradise Inn', 226, '2019-04-26', 367, NULL),
('The Paradise Inn', 226, '2019-04-27', 392, NULL),
('The Paradise Inn', 226, '2019-04-28', 370, NULL),
('The Paradise Inn', 226, '2019-04-29', 195, NULL),
('The Paradise Inn', 226, '2019-04-30', 126, NULL),
('The Paradise Inn', 226, '2019-05-01', 260, NULL),
('The Paradise Inn', 226, '2019-05-02', 203, NULL),
('The Paradise Inn', 226, '2019-05-03', 350, NULL),
('The Paradise Inn', 226, '2019-05-04', 331, NULL),
('The Paradise Inn', 226, '2019-05-05', 355, NULL),
('The Paradise Inn', 226, '2019-05-06', 327, NULL),
('The Paradise Inn', 226, '2019-05-07', 325, NULL),
('The Paradise Inn', 226, '2019-05-08', 185, NULL),
('The Paradise Inn', 226, '2019-05-09', 210, NULL),
('The Paradise Inn', 226, '2019-05-10', 354, NULL),
('The Paradise Inn', 226, '2019-05-11', 251, NULL),
('The Paradise Inn', 226, '2019-05-12', 223, NULL),
('The Paradise Inn', 226, '2019-05-13', 149, NULL),
('The Paradise Inn', 226, '2019-05-14', 185, NULL),
('The Paradise Inn', 226, '2019-05-15', 153, NULL),
('The Paradise Inn', 226, '2019-05-16', 250, NULL),
('The Paradise Inn', 226, '2019-05-17', 262, NULL),
('The Paradise Inn', 226, '2019-05-18', 185, NULL),
('The Paradise Inn', 226, '2019-05-19', 173, NULL),
('The Paradise Inn', 226, '2019-05-20', 327, NULL),
('The Paradise Inn', 226, '2019-05-21', 151, NULL),
('The Paradise Inn', 226, '2019-05-22', 390, NULL),
('The Paradise Inn', 226, '2019-05-23', 232, NULL),
('The Paradise Inn', 226, '2019-05-24', 384, NULL),
('The Paradise Inn', 226, '2019-05-25', 311, NULL),
('The Paradise Inn', 226, '2019-05-26', 350, NULL),
('The Paradise Inn', 226, '2019-05-27', 137, NULL),
('The Paradise Inn', 226, '2019-05-28', 217, NULL),
('The Paradise Inn', 226, '2019-05-29', 317, NULL),
('The Paradise Inn', 226, '2019-05-30', 307, NULL),
('The Paradise Inn', 226, '2019-05-31', 211, NULL),
('The Paradise Inn', 226, '2019-06-01', 121, NULL),
('The Paradise Inn', 226, '2019-06-02', 151, NULL),
('The Paradise Inn', 226, '2019-06-03', 225, NULL),
('The Paradise Inn', 226, '2019-06-04', 212, NULL),
('The Paradise Inn', 226, '2019-06-05', 291, NULL),
('The Paradise Inn', 226, '2019-06-06', 319, NULL),
('The Paradise Inn', 226, '2019-06-07', 176, NULL),
('The Paradise Inn', 226, '2019-06-08', 262, NULL),
('The Paradise Inn', 226, '2019-06-09', 368, NULL),
('The Paradise Inn', 226, '2019-06-10', 235, NULL),
('The Paradise Inn', 226, '2019-06-11', 261, NULL),
('The Paradise Inn', 226, '2019-06-12', 339, NULL),
('The Paradise Inn', 226, '2019-06-13', 249, NULL),
('The Paradise Inn', 226, '2019-06-14', 362, NULL),
('The Paradise Inn', 226, '2019-06-15', 337, NULL),
('The Paradise Inn', 226, '2019-06-16', 191, NULL),
('The Paradise Inn', 226, '2019-06-17', 312, NULL),
('The Paradise Inn', 226, '2019-06-18', 241, NULL),
('The Paradise Inn', 226, '2019-06-19', 396, NULL),
('The Paradise Inn', 226, '2019-06-20', 328, NULL),
('The Paradise Inn', 226, '2019-06-21', 308, NULL),
('The Paradise Inn', 226, '2019-06-22', 377, NULL),
('The Paradise Inn', 226, '2019-06-23', 162, NULL),
('The Paradise Inn', 226, '2019-06-24', 365, NULL),
('The Paradise Inn', 226, '2019-06-25', 155, NULL),
('The Paradise Inn', 226, '2019-06-26', 139, NULL),
('The Paradise Inn', 226, '2019-06-27', 384, NULL),
('The Paradise Inn', 226, '2019-06-28', 306, NULL),
('The Paradise Inn', 226, '2019-06-29', 127, NULL),
('The Paradise Inn', 226, '2019-06-30', 343, NULL),
('The Paradise Inn', 226, '2019-07-01', 160, NULL),
('The Paradise Inn', 226, '2019-07-02', 272, NULL),
('The Paradise Inn', 226, '2019-07-03', 102, NULL),
('The Paradise Inn', 226, '2019-07-04', 191, NULL),
('The Paradise Inn', 226, '2019-07-05', 150, NULL),
('The Paradise Inn', 226, '2019-07-06', 293, NULL),
('The Paradise Inn', 226, '2019-07-07', 391, NULL),
('The Paradise Inn', 226, '2019-07-08', 202, NULL),
('The Paradise Inn', 226, '2019-07-09', 133, NULL),
('The Paradise Inn', 226, '2019-07-10', 346, NULL),
('The Paradise Inn', 226, '2019-07-11', 348, NULL),
('The Paradise Inn', 226, '2019-07-12', 273, NULL),
('The Paradise Inn', 226, '2019-07-13', 163, NULL),
('The Paradise Inn', 226, '2019-07-14', 323, NULL),
('The Paradise Inn', 226, '2019-07-15', 214, NULL),
('The Paradise Inn', 226, '2019-07-16', 296, NULL),
('The Paradise Inn', 226, '2019-07-17', 397, NULL),
('The Paradise Inn', 226, '2019-07-18', 342, NULL),
('The Paradise Inn', 226, '2019-07-19', 246, NULL),
('The Paradise Inn', 226, '2019-07-20', 294, NULL),
('The Paradise Inn', 226, '2019-07-21', 279, NULL),
('The Paradise Inn', 226, '2019-07-22', 114, NULL),
('The Paradise Inn', 226, '2019-07-23', 136, NULL),
('The Paradise Inn', 226, '2019-07-24', 140, NULL),
('The Paradise Inn', 226, '2019-07-25', 326, NULL),
('The Paradise Inn', 226, '2019-07-26', 217, NULL),
('The Paradise Inn', 226, '2019-07-27', 370, NULL),
('The Paradise Inn', 226, '2019-07-28', 110, NULL),
('The Paradise Inn', 226, '2019-07-29', 357, NULL),
('The Paradise Inn', 226, '2019-07-30', 354, NULL),
('The Paradise Inn', 226, '2019-07-31', 374, NULL),
('The Paradise Inn', 226, '2019-08-01', 347, NULL),
('The Paradise Inn', 226, '2019-08-02', 289, NULL),
('The Paradise Inn', 226, '2019-08-03', 393, NULL),
('The Paradise Inn', 226, '2019-08-04', 270, NULL),
('The Paradise Inn', 226, '2019-08-05', 148, NULL),
('The Paradise Inn', 226, '2019-08-06', 121, NULL),
('The Paradise Inn', 226, '2019-08-07', 202, NULL),
('The Paradise Inn', 226, '2019-08-08', 102, NULL),
('The Paradise Inn', 226, '2019-08-09', 373, NULL),
('The Paradise Inn', 226, '2019-08-10', 173, NULL),
('The Paradise Inn', 226, '2019-08-11', 323, NULL),
('The Paradise Inn', 226, '2019-08-12', 197, NULL),
('The Paradise Inn', 226, '2019-08-13', 128, NULL),
('The Paradise Inn', 226, '2019-08-14', 204, NULL),
('The Paradise Inn', 226, '2019-08-15', 366, NULL),
('The Paradise Inn', 226, '2019-08-16', 138, NULL),
('The Paradise Inn', 226, '2019-08-17', 158, NULL),
('The Paradise Inn', 226, '2019-08-18', 142, NULL),
('The Paradise Inn', 226, '2019-08-19', 397, NULL),
('The Paradise Inn', 226, '2019-08-20', 346, NULL),
('The Paradise Inn', 226, '2019-08-21', 188, NULL),
('The Paradise Inn', 226, '2019-08-22', 258, NULL),
('The Paradise Inn', 226, '2019-08-23', 173, NULL),
('The Paradise Inn', 226, '2019-08-24', 126, NULL),
('The Paradise Inn', 226, '2019-08-25', 311, NULL),
('The Paradise Inn', 226, '2019-08-26', 262, NULL),
('The Paradise Inn', 226, '2019-08-27', 317, NULL),
('The Paradise Inn', 226, '2019-08-28', 230, NULL),
('The Paradise Inn', 226, '2019-08-29', 227, NULL),
('The Paradise Inn', 226, '2019-08-30', 249, NULL),
('The Paradise Inn', 226, '2019-08-31', 352, NULL),
('The Paradise Inn', 226, '2019-09-01', 175, NULL),
('The Paradise Inn', 226, '2019-09-02', 110, NULL),
('The Paradise Inn', 226, '2019-09-03', 117, NULL),
('The Paradise Inn', 226, '2019-09-04', 268, NULL),
('The Paradise Inn', 226, '2019-09-05', 105, NULL),
('The Paradise Inn', 226, '2019-09-06', 276, NULL),
('The Paradise Inn', 226, '2019-09-07', 337, NULL),
('The Paradise Inn', 226, '2019-09-08', 151, NULL),
('The Paradise Inn', 226, '2019-09-09', 371, NULL),
('The Paradise Inn', 226, '2019-09-10', 114, NULL),
('The Paradise Inn', 226, '2019-09-11', 260, NULL),
('The Paradise Inn', 226, '2019-09-12', 270, NULL),
('The Paradise Inn', 226, '2019-09-13', 380, NULL),
('The Paradise Inn', 226, '2019-09-14', 124, NULL),
('The Paradise Inn', 226, '2019-09-15', 302, NULL),
('The Paradise Inn', 226, '2019-09-16', 121, NULL),
('The Paradise Inn', 226, '2019-09-17', 115, NULL),
('The Paradise Inn', 226, '2019-09-18', 150, NULL),
('The Paradise Inn', 226, '2019-09-19', 162, NULL),
('The Paradise Inn', 226, '2019-09-20', 110, NULL),
('The Paradise Inn', 226, '2019-09-21', 108, NULL),
('The Paradise Inn', 226, '2019-09-22', 388, NULL),
('The Paradise Inn', 226, '2019-09-23', 292, NULL),
('The Paradise Inn', 226, '2019-09-24', 334, NULL),
('The Paradise Inn', 226, '2019-09-25', 357, NULL),
('The Paradise Inn', 226, '2019-09-26', 156, NULL),
('The Paradise Inn', 226, '2019-09-27', 225, NULL),
('The Paradise Inn', 226, '2019-09-28', 306, NULL),
('The Paradise Inn', 226, '2019-09-29', 263, NULL),
('The Paradise Inn', 226, '2019-09-30', 123, NULL),
('The Paradise Inn', 226, '2019-10-01', 269, NULL),
('The Paradise Inn', 226, '2019-10-02', 279, NULL),
('The Paradise Inn', 226, '2019-10-03', 116, NULL),
('The Paradise Inn', 226, '2019-10-04', 304, NULL),
('The Paradise Inn', 226, '2019-10-05', 247, NULL),
('The Paradise Inn', 226, '2019-10-06', 100, NULL),
('The Paradise Inn', 226, '2019-10-07', 138, NULL),
('The Paradise Inn', 226, '2019-10-08', 304, NULL),
('The Paradise Inn', 226, '2019-10-09', 192, NULL),
('The Paradise Inn', 226, '2019-10-10', 192, NULL),
('The Paradise Inn', 226, '2019-10-11', 280, NULL),
('The Paradise Inn', 226, '2019-10-12', 346, NULL),
('The Paradise Inn', 226, '2019-10-13', 193, NULL),
('The Paradise Inn', 226, '2019-10-14', 184, NULL),
('The Paradise Inn', 226, '2019-10-15', 220, NULL),
('The Paradise Inn', 226, '2019-10-16', 275, NULL),
('The Paradise Inn', 226, '2019-10-17', 275, NULL),
('The Paradise Inn', 226, '2019-10-18', 357, NULL),
('The Paradise Inn', 226, '2019-10-19', 305, NULL),
('The Paradise Inn', 226, '2019-10-20', 323, NULL),
('The Paradise Inn', 226, '2019-10-21', 124, NULL),
('The Paradise Inn', 226, '2019-10-22', 272, NULL),
('The Paradise Inn', 226, '2019-10-23', 150, NULL),
('The Paradise Inn', 226, '2019-10-24', 277, NULL),
('The Paradise Inn', 226, '2019-10-25', 238, NULL),
('The Paradise Inn', 226, '2019-10-26', 319, NULL),
('The Paradise Inn', 226, '2019-10-27', 314, NULL),
('The Paradise Inn', 226, '2019-10-28', 229, NULL),
('The Paradise Inn', 226, '2019-10-29', 192, NULL),
('The Paradise Inn', 226, '2019-10-30', 333, NULL),
('The Paradise Inn', 226, '2019-10-31', 392, NULL),
('The Paradise Inn', 226, '2019-11-01', 220, NULL),
('The Paradise Inn', 226, '2019-11-02', 331, NULL),
('The Paradise Inn', 226, '2019-11-03', 101, NULL),
('The Paradise Inn', 226, '2019-11-04', 114, NULL),
('The Paradise Inn', 226, '2019-11-05', 352, NULL),
('The Paradise Inn', 226, '2019-11-06', 313, NULL),
('The Paradise Inn', 226, '2019-11-07', 357, NULL),
('The Paradise Inn', 226, '2019-11-08', 175, NULL),
('The Paradise Inn', 226, '2019-11-09', 231, NULL),
('The Paradise Inn', 226, '2019-11-10', 242, NULL),
('The Paradise Inn', 226, '2019-11-11', 396, NULL),
('The Paradise Inn', 226, '2019-11-12', 204, NULL),
('The Paradise Inn', 226, '2019-11-13', 173, NULL),
('The Paradise Inn', 226, '2019-11-14', 397, NULL),
('The Paradise Inn', 226, '2019-11-15', 301, NULL),
('The Paradise Inn', 226, '2019-11-16', 256, NULL),
('The Paradise Inn', 226, '2019-11-17', 225, NULL),
('The Paradise Inn', 226, '2019-11-18', 131, NULL),
('The Paradise Inn', 226, '2019-11-19', 206, NULL),
('The Paradise Inn', 226, '2019-11-20', 282, NULL),
('The Paradise Inn', 226, '2019-11-21', 201, NULL),
('The Paradise Inn', 226, '2019-11-22', 290, NULL),
('The Paradise Inn', 226, '2019-11-23', 337, NULL),
('The Paradise Inn', 226, '2019-11-24', 181, NULL),
('The Paradise Inn', 226, '2019-11-25', 122, NULL),
('The Paradise Inn', 226, '2019-11-26', 349, NULL),
('The Paradise Inn', 226, '2019-11-27', 265, NULL),
('The Paradise Inn', 226, '2019-11-28', 174, NULL),
('The Paradise Inn', 226, '2019-11-29', 362, NULL),
('The Paradise Inn', 226, '2019-11-30', 105, NULL),
('The Paradise Inn', 226, '2019-12-01', 100, NULL),
('The Paradise Inn', 226, '2019-12-02', 141, NULL),
('The Paradise Inn', 226, '2019-12-03', 221, NULL),
('The Paradise Inn', 226, '2019-12-04', 216, NULL),
('The Paradise Inn', 226, '2019-12-05', 260, NULL),
('The Paradise Inn', 226, '2019-12-06', 223, NULL),
('The Paradise Inn', 226, '2019-12-07', 376, NULL),
('The Paradise Inn', 226, '2019-12-08', 217, NULL),
('The Paradise Inn', 226, '2019-12-09', 187, NULL),
('The Paradise Inn', 226, '2019-12-10', 360, NULL),
('The Paradise Inn', 226, '2019-12-11', 235, NULL),
('The Paradise Inn', 226, '2019-12-12', 136, NULL),
('The Paradise Inn', 226, '2019-12-13', 269, NULL),
('The Paradise Inn', 226, '2019-12-14', 163, NULL),
('The Paradise Inn', 226, '2019-12-15', 368, NULL),
('The Paradise Inn', 226, '2019-12-16', 116, NULL),
('The Paradise Inn', 226, '2019-12-17', 317, NULL),
('The Paradise Inn', 226, '2019-12-18', 383, NULL),
('The Paradise Inn', 226, '2019-12-19', 126, NULL),
('The Paradise Inn', 226, '2019-12-20', 159, NULL),
('The Paradise Inn', 226, '2019-12-21', 107, NULL),
('The Paradise Inn', 226, '2019-12-22', 132, NULL),
('The Paradise Inn', 226, '2019-12-23', 179, NULL),
('The Paradise Inn', 226, '2019-12-24', 144, NULL),
('The Paradise Inn', 226, '2019-12-25', 141, NULL),
('The Paradise Inn', 226, '2019-12-26', 127, NULL),
('The Paradise Inn', 226, '2019-12-27', 111, NULL),
('The Paradise Inn', 226, '2019-12-28', 228, NULL),
('The Paradise Inn', 226, '2019-12-29', 321, NULL),
('The Paradise Inn', 226, '2019-12-30', 230, NULL),
('The Paradise Inn', 226, '2019-12-31', 283, NULL),
('The Paradise Inn', 226, '2020-01-01', 161, NULL),
('The Paradise Inn', 226, '2020-01-02', 206, NULL),
('The Paradise Inn', 226, '2020-01-03', 215, NULL),
('The Paradise Inn', 226, '2020-01-04', 113, NULL),
('The Paradise Inn', 226, '2020-01-05', 203, NULL),
('The Paradise Inn', 226, '2020-01-06', 236, NULL),
('The Paradise Inn', 226, '2020-01-07', 132, NULL),
('The Paradise Inn', 226, '2020-01-08', 102, NULL),
('The Paradise Inn', 226, '2020-01-09', 345, NULL),
('The Paradise Inn', 226, '2020-01-10', 362, NULL),
('The Paradise Inn', 226, '2020-01-11', 255, NULL),
('The Paradise Inn', 226, '2020-01-12', 145, NULL),
('The Paradise Inn', 226, '2020-01-13', 290, NULL),
('The Paradise Inn', 226, '2020-01-14', 116, NULL),
('The Paradise Inn', 226, '2020-01-15', 151, NULL),
('The Paradise Inn', 226, '2020-01-16', 239, NULL),
('The Paradise Inn', 226, '2020-01-17', 174, NULL),
('The Paradise Inn', 226, '2020-01-18', 191, NULL),
('The Paradise Inn', 226, '2020-01-19', 118, NULL),
('The Paradise Inn', 226, '2020-01-20', 207, NULL),
('The Paradise Inn', 226, '2020-01-21', 166, NULL),
('The Paradise Inn', 226, '2020-01-22', 140, NULL),
('The Paradise Inn', 226, '2020-01-23', 265, NULL),
('The Paradise Inn', 226, '2020-01-24', 399, NULL),
('The Paradise Inn', 226, '2020-01-25', 331, NULL),
('The Paradise Inn', 226, '2020-01-26', 357, NULL),
('The Paradise Inn', 226, '2020-01-27', 349, NULL),
('The Paradise Inn', 226, '2020-01-28', 332, NULL),
('The Paradise Inn', 226, '2020-01-29', 144, NULL),
('The Paradise Inn', 226, '2020-01-30', 317, NULL),
('The Paradise Inn', 226, '2020-01-31', 307, NULL),
('The Paradise Inn', 226, '2020-02-01', 182, NULL),
('The Paradise Inn', 226, '2020-02-02', 105, NULL),
('The Paradise Inn', 226, '2020-02-03', 392, NULL),
('The Paradise Inn', 226, '2020-02-04', 121, NULL),
('The Paradise Inn', 230, '2019-01-01', 381, NULL),
('The Paradise Inn', 230, '2019-01-02', 171, NULL),
('The Paradise Inn', 230, '2019-01-03', 130, NULL),
('The Paradise Inn', 230, '2019-01-04', 302, NULL),
('The Paradise Inn', 230, '2019-01-05', 179, NULL),
('The Paradise Inn', 230, '2019-01-06', 385, NULL),
('The Paradise Inn', 230, '2019-01-07', 172, NULL),
('The Paradise Inn', 230, '2019-01-08', 347, NULL),
('The Paradise Inn', 230, '2019-01-09', 370, NULL),
('The Paradise Inn', 230, '2019-01-10', 315, NULL),
('The Paradise Inn', 230, '2019-01-11', 170, NULL),
('The Paradise Inn', 230, '2019-01-12', 367, NULL),
('The Paradise Inn', 230, '2019-01-13', 150, NULL),
('The Paradise Inn', 230, '2019-01-14', 172, NULL),
('The Paradise Inn', 230, '2019-01-15', 204, NULL),
('The Paradise Inn', 230, '2019-01-16', 211, NULL),
('The Paradise Inn', 230, '2019-01-17', 390, NULL),
('The Paradise Inn', 230, '2019-01-18', 141, NULL),
('The Paradise Inn', 230, '2019-01-19', 304, NULL),
('The Paradise Inn', 230, '2019-01-20', 135, NULL),
('The Paradise Inn', 230, '2019-01-21', 387, NULL),
('The Paradise Inn', 230, '2019-01-22', 228, NULL),
('The Paradise Inn', 230, '2019-01-23', 257, NULL),
('The Paradise Inn', 230, '2019-01-24', 359, NULL),
('The Paradise Inn', 230, '2019-01-25', 380, NULL),
('The Paradise Inn', 230, '2019-01-26', 350, NULL),
('The Paradise Inn', 230, '2019-01-27', 362, NULL),
('The Paradise Inn', 230, '2019-01-28', 170, NULL),
('The Paradise Inn', 230, '2019-01-29', 257, NULL),
('The Paradise Inn', 230, '2019-01-30', 100, NULL),
('The Paradise Inn', 230, '2019-01-31', 397, NULL),
('The Paradise Inn', 230, '2019-02-01', 179, NULL),
('The Paradise Inn', 230, '2019-02-02', 103, NULL),
('The Paradise Inn', 230, '2019-02-03', 115, NULL),
('The Paradise Inn', 230, '2019-02-04', 340, NULL),
('The Paradise Inn', 230, '2019-02-05', 183, NULL),
('The Paradise Inn', 230, '2019-02-06', 115, NULL),
('The Paradise Inn', 230, '2019-02-07', 339, NULL),
('The Paradise Inn', 230, '2019-02-08', 161, NULL),
('The Paradise Inn', 230, '2019-02-09', 177, NULL),
('The Paradise Inn', 230, '2019-02-10', 327, NULL),
('The Paradise Inn', 230, '2019-02-11', 110, NULL),
('The Paradise Inn', 230, '2019-02-12', 371, NULL),
('The Paradise Inn', 230, '2019-02-13', 242, NULL),
('The Paradise Inn', 230, '2019-02-14', 283, NULL),
('The Paradise Inn', 230, '2019-02-15', 242, NULL),
('The Paradise Inn', 230, '2019-02-16', 329, NULL),
('The Paradise Inn', 230, '2019-02-17', 302, NULL),
('The Paradise Inn', 230, '2019-02-18', 350, NULL),
('The Paradise Inn', 230, '2019-02-19', 268, NULL),
('The Paradise Inn', 230, '2019-02-20', 338, NULL),
('The Paradise Inn', 230, '2019-02-21', 223, NULL),
('The Paradise Inn', 230, '2019-02-22', 314, NULL),
('The Paradise Inn', 230, '2019-02-23', 244, NULL),
('The Paradise Inn', 230, '2019-02-24', 182, NULL),
('The Paradise Inn', 230, '2019-02-25', 107, NULL),
('The Paradise Inn', 230, '2019-02-26', 238, NULL),
('The Paradise Inn', 230, '2019-02-27', 291, NULL),
('The Paradise Inn', 230, '2019-02-28', 318, NULL),
('The Paradise Inn', 230, '2019-03-01', 361, NULL),
('The Paradise Inn', 230, '2019-03-02', 130, NULL),
('The Paradise Inn', 230, '2019-03-03', 229, NULL),
('The Paradise Inn', 230, '2019-03-04', 382, NULL),
('The Paradise Inn', 230, '2019-03-05', 269, NULL),
('The Paradise Inn', 230, '2019-03-06', 100, NULL),
('The Paradise Inn', 230, '2019-03-07', 180, NULL),
('The Paradise Inn', 230, '2019-03-08', 396, NULL),
('The Paradise Inn', 230, '2019-03-09', 223, NULL),
('The Paradise Inn', 230, '2019-03-10', 262, NULL),
('The Paradise Inn', 230, '2019-03-11', 349, NULL),
('The Paradise Inn', 230, '2019-03-12', 323, NULL),
('The Paradise Inn', 230, '2019-03-13', 267, NULL),
('The Paradise Inn', 230, '2019-03-14', 291, NULL),
('The Paradise Inn', 230, '2019-03-15', 195, NULL),
('The Paradise Inn', 230, '2019-03-16', 298, NULL),
('The Paradise Inn', 230, '2019-03-17', 316, NULL),
('The Paradise Inn', 230, '2019-03-18', 361, NULL),
('The Paradise Inn', 230, '2019-03-19', 125, NULL),
('The Paradise Inn', 230, '2019-03-20', 117, NULL),
('The Paradise Inn', 230, '2019-03-21', 367, NULL),
('The Paradise Inn', 230, '2019-03-22', 365, NULL),
('The Paradise Inn', 230, '2019-03-23', 287, NULL),
('The Paradise Inn', 230, '2019-03-24', 323, NULL),
('The Paradise Inn', 230, '2019-03-25', 376, NULL),
('The Paradise Inn', 230, '2019-03-26', 179, NULL),
('The Paradise Inn', 230, '2019-03-27', 204, NULL),
('The Paradise Inn', 230, '2019-03-28', 282, NULL),
('The Paradise Inn', 230, '2019-03-29', 284, NULL),
('The Paradise Inn', 230, '2019-03-30', 395, NULL),
('The Paradise Inn', 230, '2019-03-31', 167, NULL),
('The Paradise Inn', 230, '2019-04-01', 288, NULL),
('The Paradise Inn', 230, '2019-04-02', 297, NULL),
('The Paradise Inn', 230, '2019-04-03', 270, NULL),
('The Paradise Inn', 230, '2019-04-04', 369, NULL),
('The Paradise Inn', 230, '2019-04-05', 131, NULL),
('The Paradise Inn', 230, '2019-04-06', 389, NULL),
('The Paradise Inn', 230, '2019-04-07', 160, NULL),
('The Paradise Inn', 230, '2019-04-08', 220, NULL),
('The Paradise Inn', 230, '2019-04-09', 345, NULL),
('The Paradise Inn', 230, '2019-04-10', 337, NULL),
('The Paradise Inn', 230, '2019-04-11', 215, NULL),
('The Paradise Inn', 230, '2019-04-12', 137, NULL),
('The Paradise Inn', 230, '2019-04-13', 225, NULL),
('The Paradise Inn', 230, '2019-04-14', 358, NULL),
('The Paradise Inn', 230, '2019-04-15', 375, NULL),
('The Paradise Inn', 230, '2019-04-16', 349, NULL),
('The Paradise Inn', 230, '2019-04-17', 323, NULL),
('The Paradise Inn', 230, '2019-04-18', 314, NULL),
('The Paradise Inn', 230, '2019-04-19', 200, NULL),
('The Paradise Inn', 230, '2019-04-20', 344, NULL),
('The Paradise Inn', 230, '2019-04-21', 298, NULL),
('The Paradise Inn', 230, '2019-04-22', 263, NULL),
('The Paradise Inn', 230, '2019-04-23', 226, NULL),
('The Paradise Inn', 230, '2019-04-24', 399, NULL),
('The Paradise Inn', 230, '2019-04-25', 217, NULL),
('The Paradise Inn', 230, '2019-04-26', 275, NULL),
('The Paradise Inn', 230, '2019-04-27', 229, NULL),
('The Paradise Inn', 230, '2019-04-28', 279, NULL),
('The Paradise Inn', 230, '2019-04-29', 232, NULL),
('The Paradise Inn', 230, '2019-04-30', 334, NULL),
('The Paradise Inn', 230, '2019-05-01', 164, NULL),
('The Paradise Inn', 230, '2019-05-02', 335, NULL),
('The Paradise Inn', 230, '2019-05-03', 132, NULL),
('The Paradise Inn', 230, '2019-05-04', 353, NULL),
('The Paradise Inn', 230, '2019-05-05', 238, NULL),
('The Paradise Inn', 230, '2019-05-06', 302, NULL),
('The Paradise Inn', 230, '2019-05-07', 242, NULL),
('The Paradise Inn', 230, '2019-05-08', 294, NULL),
('The Paradise Inn', 230, '2019-05-09', 192, NULL),
('The Paradise Inn', 230, '2019-05-10', 261, NULL),
('The Paradise Inn', 230, '2019-05-11', 145, NULL),
('The Paradise Inn', 230, '2019-05-12', 359, NULL),
('The Paradise Inn', 230, '2019-05-13', 271, NULL),
('The Paradise Inn', 230, '2019-05-14', 318, NULL),
('The Paradise Inn', 230, '2019-05-15', 136, NULL),
('The Paradise Inn', 230, '2019-05-16', 274, NULL),
('The Paradise Inn', 230, '2019-05-17', 299, NULL),
('The Paradise Inn', 230, '2019-05-18', 328, NULL),
('The Paradise Inn', 230, '2019-05-19', 340, NULL),
('The Paradise Inn', 230, '2019-05-20', 184, NULL),
('The Paradise Inn', 230, '2019-05-21', 189, NULL),
('The Paradise Inn', 230, '2019-05-22', 226, NULL),
('The Paradise Inn', 230, '2019-05-23', 378, NULL),
('The Paradise Inn', 230, '2019-05-24', 342, NULL),
('The Paradise Inn', 230, '2019-05-25', 291, NULL),
('The Paradise Inn', 230, '2019-05-26', 350, NULL),
('The Paradise Inn', 230, '2019-05-27', 314, NULL),
('The Paradise Inn', 230, '2019-05-28', 244, NULL),
('The Paradise Inn', 230, '2019-05-29', 164, NULL),
('The Paradise Inn', 230, '2019-05-30', 170, NULL),
('The Paradise Inn', 230, '2019-05-31', 268, NULL),
('The Paradise Inn', 230, '2019-06-01', 199, NULL),
('The Paradise Inn', 230, '2019-06-02', 394, NULL),
('The Paradise Inn', 230, '2019-06-03', 388, NULL),
('The Paradise Inn', 230, '2019-06-04', 233, NULL),
('The Paradise Inn', 230, '2019-06-05', 368, NULL),
('The Paradise Inn', 230, '2019-06-06', 137, NULL),
('The Paradise Inn', 230, '2019-06-07', 246, NULL),
('The Paradise Inn', 230, '2019-06-08', 260, NULL),
('The Paradise Inn', 230, '2019-06-09', 262, NULL),
('The Paradise Inn', 230, '2019-06-10', 376, NULL),
('The Paradise Inn', 230, '2019-06-11', 384, NULL),
('The Paradise Inn', 230, '2019-06-12', 239, NULL),
('The Paradise Inn', 230, '2019-06-13', 364, NULL),
('The Paradise Inn', 230, '2019-06-14', 207, NULL),
('The Paradise Inn', 230, '2019-06-15', 327, NULL),
('The Paradise Inn', 230, '2019-06-16', 105, NULL),
('The Paradise Inn', 230, '2019-06-17', 138, NULL),
('The Paradise Inn', 230, '2019-06-18', 276, NULL),
('The Paradise Inn', 230, '2019-06-19', 312, NULL),
('The Paradise Inn', 230, '2019-06-20', 248, NULL),
('The Paradise Inn', 230, '2019-06-21', 251, NULL),
('The Paradise Inn', 230, '2019-06-22', 261, NULL),
('The Paradise Inn', 230, '2019-06-23', 389, NULL),
('The Paradise Inn', 230, '2019-06-24', 177, NULL),
('The Paradise Inn', 230, '2019-06-25', 101, NULL),
('The Paradise Inn', 230, '2019-06-26', 123, NULL),
('The Paradise Inn', 230, '2019-06-27', 188, NULL),
('The Paradise Inn', 230, '2019-06-28', 398, NULL),
('The Paradise Inn', 230, '2019-06-29', 288, NULL),
('The Paradise Inn', 230, '2019-06-30', 381, NULL),
('The Paradise Inn', 230, '2019-07-01', 337, NULL),
('The Paradise Inn', 230, '2019-07-02', 296, NULL),
('The Paradise Inn', 230, '2019-07-03', 309, NULL),
('The Paradise Inn', 230, '2019-07-04', 351, NULL),
('The Paradise Inn', 230, '2019-07-05', 131, NULL),
('The Paradise Inn', 230, '2019-07-06', 162, NULL),
('The Paradise Inn', 230, '2019-07-07', 215, NULL),
('The Paradise Inn', 230, '2019-07-08', 380, NULL),
('The Paradise Inn', 230, '2019-07-09', 305, NULL),
('The Paradise Inn', 230, '2019-07-10', 327, NULL),
('The Paradise Inn', 230, '2019-07-11', 209, NULL),
('The Paradise Inn', 230, '2019-07-12', 137, NULL),
('The Paradise Inn', 230, '2019-07-13', 205, NULL),
('The Paradise Inn', 230, '2019-07-14', 315, NULL),
('The Paradise Inn', 230, '2019-07-15', 214, NULL),
('The Paradise Inn', 230, '2019-07-16', 240, NULL),
('The Paradise Inn', 230, '2019-07-17', 337, NULL),
('The Paradise Inn', 230, '2019-07-18', 185, NULL),
('The Paradise Inn', 230, '2019-07-19', 253, NULL),
('The Paradise Inn', 230, '2019-07-20', 286, NULL),
('The Paradise Inn', 230, '2019-07-21', 290, NULL),
('The Paradise Inn', 230, '2019-07-22', 315, NULL),
('The Paradise Inn', 230, '2019-07-23', 118, NULL),
('The Paradise Inn', 230, '2019-07-24', 181, NULL),
('The Paradise Inn', 230, '2019-07-25', 222, NULL),
('The Paradise Inn', 230, '2019-07-26', 125, NULL),
('The Paradise Inn', 230, '2019-07-27', 187, NULL),
('The Paradise Inn', 230, '2019-07-28', 199, NULL),
('The Paradise Inn', 230, '2019-07-29', 368, NULL),
('The Paradise Inn', 230, '2019-07-30', 290, NULL),
('The Paradise Inn', 230, '2019-07-31', 358, NULL),
('The Paradise Inn', 230, '2019-08-01', 226, NULL),
('The Paradise Inn', 230, '2019-08-02', 272, NULL),
('The Paradise Inn', 230, '2019-08-03', 391, NULL),
('The Paradise Inn', 230, '2019-08-04', 191, NULL),
('The Paradise Inn', 230, '2019-08-05', 201, NULL),
('The Paradise Inn', 230, '2019-08-06', 366, NULL),
('The Paradise Inn', 230, '2019-08-07', 231, NULL),
('The Paradise Inn', 230, '2019-08-08', 205, NULL),
('The Paradise Inn', 230, '2019-08-09', 111, NULL),
('The Paradise Inn', 230, '2019-08-10', 241, NULL),
('The Paradise Inn', 230, '2019-08-11', 222, NULL),
('The Paradise Inn', 230, '2019-08-12', 115, NULL),
('The Paradise Inn', 230, '2019-08-13', 120, NULL),
('The Paradise Inn', 230, '2019-08-14', 152, NULL),
('The Paradise Inn', 230, '2019-08-15', 235, NULL),
('The Paradise Inn', 230, '2019-08-16', 115, NULL),
('The Paradise Inn', 230, '2019-08-17', 396, NULL),
('The Paradise Inn', 230, '2019-08-18', 352, NULL),
('The Paradise Inn', 230, '2019-08-19', 274, NULL),
('The Paradise Inn', 230, '2019-08-20', 247, NULL),
('The Paradise Inn', 230, '2019-08-21', 138, NULL),
('The Paradise Inn', 230, '2019-08-22', 152, NULL),
('The Paradise Inn', 230, '2019-08-23', 160, NULL),
('The Paradise Inn', 230, '2019-08-24', 218, NULL),
('The Paradise Inn', 230, '2019-08-25', 357, NULL),
('The Paradise Inn', 230, '2019-08-26', 306, NULL),
('The Paradise Inn', 230, '2019-08-27', 375, NULL),
('The Paradise Inn', 230, '2019-08-28', 310, NULL),
('The Paradise Inn', 230, '2019-08-29', 235, NULL),
('The Paradise Inn', 230, '2019-08-30', 295, NULL),
('The Paradise Inn', 230, '2019-08-31', 142, NULL),
('The Paradise Inn', 230, '2019-09-01', 246, NULL),
('The Paradise Inn', 230, '2019-09-02', 198, NULL),
('The Paradise Inn', 230, '2019-09-03', 125, NULL),
('The Paradise Inn', 230, '2019-09-04', 143, NULL),
('The Paradise Inn', 230, '2019-09-05', 123, NULL),
('The Paradise Inn', 230, '2019-09-06', 380, NULL),
('The Paradise Inn', 230, '2019-09-07', 229, NULL),
('The Paradise Inn', 230, '2019-09-08', 228, NULL),
('The Paradise Inn', 230, '2019-09-09', 269, NULL),
('The Paradise Inn', 230, '2019-09-10', 147, NULL),
('The Paradise Inn', 230, '2019-09-11', 275, NULL),
('The Paradise Inn', 230, '2019-09-12', 296, NULL),
('The Paradise Inn', 230, '2019-09-13', 254, NULL),
('The Paradise Inn', 230, '2019-09-14', 216, NULL),
('The Paradise Inn', 230, '2019-09-15', 352, NULL),
('The Paradise Inn', 230, '2019-09-16', 387, NULL),
('The Paradise Inn', 230, '2019-09-17', 213, NULL),
('The Paradise Inn', 230, '2019-09-18', 198, NULL),
('The Paradise Inn', 230, '2019-09-19', 114, NULL),
('The Paradise Inn', 230, '2019-09-20', 390, NULL),
('The Paradise Inn', 230, '2019-09-21', 202, NULL),
('The Paradise Inn', 230, '2019-09-22', 343, NULL),
('The Paradise Inn', 230, '2019-09-23', 309, NULL),
('The Paradise Inn', 230, '2019-09-24', 309, NULL),
('The Paradise Inn', 230, '2019-09-25', 379, NULL),
('The Paradise Inn', 230, '2019-09-26', 296, NULL),
('The Paradise Inn', 230, '2019-09-27', 172, NULL),
('The Paradise Inn', 230, '2019-09-28', 173, NULL),
('The Paradise Inn', 230, '2019-09-29', 123, NULL),
('The Paradise Inn', 230, '2019-09-30', 324, NULL),
('The Paradise Inn', 230, '2019-10-01', 163, NULL),
('The Paradise Inn', 230, '2019-10-02', 267, NULL),
('The Paradise Inn', 230, '2019-10-03', 156, NULL),
('The Paradise Inn', 230, '2019-10-04', 388, NULL),
('The Paradise Inn', 230, '2019-10-05', 313, NULL),
('The Paradise Inn', 230, '2019-10-06', 332, NULL),
('The Paradise Inn', 230, '2019-10-07', 340, NULL),
('The Paradise Inn', 230, '2019-10-08', 271, NULL),
('The Paradise Inn', 230, '2019-10-09', 324, NULL),
('The Paradise Inn', 230, '2019-10-10', 317, NULL),
('The Paradise Inn', 230, '2019-10-11', 203, NULL),
('The Paradise Inn', 230, '2019-10-12', 169, NULL),
('The Paradise Inn', 230, '2019-10-13', 142, NULL),
('The Paradise Inn', 230, '2019-10-14', 305, NULL),
('The Paradise Inn', 230, '2019-10-15', 106, NULL),
('The Paradise Inn', 230, '2019-10-16', 187, NULL),
('The Paradise Inn', 230, '2019-10-17', 388, NULL),
('The Paradise Inn', 230, '2019-10-18', 287, NULL),
('The Paradise Inn', 230, '2019-10-19', 119, NULL),
('The Paradise Inn', 230, '2019-10-20', 114, NULL),
('The Paradise Inn', 230, '2019-10-21', 258, NULL),
('The Paradise Inn', 230, '2019-10-22', 157, NULL),
('The Paradise Inn', 230, '2019-10-23', 259, NULL),
('The Paradise Inn', 230, '2019-10-24', 360, NULL),
('The Paradise Inn', 230, '2019-10-25', 178, NULL),
('The Paradise Inn', 230, '2019-10-26', 233, NULL),
('The Paradise Inn', 230, '2019-10-27', 181, NULL),
('The Paradise Inn', 230, '2019-10-28', 222, NULL),
('The Paradise Inn', 230, '2019-10-29', 324, NULL),
('The Paradise Inn', 230, '2019-10-30', 366, NULL),
('The Paradise Inn', 230, '2019-10-31', 106, NULL),
('The Paradise Inn', 230, '2019-11-01', 354, NULL),
('The Paradise Inn', 230, '2019-11-02', 134, NULL),
('The Paradise Inn', 230, '2019-11-03', 250, NULL),
('The Paradise Inn', 230, '2019-11-04', 196, NULL),
('The Paradise Inn', 230, '2019-11-05', 282, NULL),
('The Paradise Inn', 230, '2019-11-06', 127, NULL),
('The Paradise Inn', 230, '2019-11-07', 194, NULL),
('The Paradise Inn', 230, '2019-11-08', 173, NULL),
('The Paradise Inn', 230, '2019-11-09', 263, NULL),
('The Paradise Inn', 230, '2019-11-10', 147, NULL),
('The Paradise Inn', 230, '2019-11-11', 309, NULL),
('The Paradise Inn', 230, '2019-11-12', 213, NULL),
('The Paradise Inn', 230, '2019-11-13', 308, NULL),
('The Paradise Inn', 230, '2019-11-14', 346, NULL),
('The Paradise Inn', 230, '2019-11-15', 265, NULL),
('The Paradise Inn', 230, '2019-11-16', 365, NULL),
('The Paradise Inn', 230, '2019-11-17', 343, NULL),
('The Paradise Inn', 230, '2019-11-18', 105, NULL),
('The Paradise Inn', 230, '2019-11-19', 320, NULL),
('The Paradise Inn', 230, '2019-11-20', 173, NULL),
('The Paradise Inn', 230, '2019-11-21', 329, NULL),
('The Paradise Inn', 230, '2019-11-22', 140, NULL),
('The Paradise Inn', 230, '2019-11-23', 144, NULL),
('The Paradise Inn', 230, '2019-11-24', 126, NULL),
('The Paradise Inn', 230, '2019-11-25', 154, NULL),
('The Paradise Inn', 230, '2019-11-26', 114, NULL),
('The Paradise Inn', 230, '2019-11-27', 100, NULL),
('The Paradise Inn', 230, '2019-11-28', 139, NULL),
('The Paradise Inn', 230, '2019-11-29', 318, NULL),
('The Paradise Inn', 230, '2019-11-30', 236, NULL),
('The Paradise Inn', 230, '2019-12-01', 115, NULL),
('The Paradise Inn', 230, '2019-12-02', 180, NULL),
('The Paradise Inn', 230, '2019-12-03', 368, NULL),
('The Paradise Inn', 230, '2019-12-04', 334, NULL),
('The Paradise Inn', 230, '2019-12-05', 225, NULL),
('The Paradise Inn', 230, '2019-12-06', 138, NULL),
('The Paradise Inn', 230, '2019-12-07', 104, NULL),
('The Paradise Inn', 230, '2019-12-08', 396, NULL),
('The Paradise Inn', 230, '2019-12-09', 382, NULL),
('The Paradise Inn', 230, '2019-12-10', 170, NULL),
('The Paradise Inn', 230, '2019-12-11', 294, NULL),
('The Paradise Inn', 230, '2019-12-12', 230, NULL),
('The Paradise Inn', 230, '2019-12-13', 226, NULL),
('The Paradise Inn', 230, '2019-12-14', 211, NULL),
('The Paradise Inn', 230, '2019-12-15', 287, NULL),
('The Paradise Inn', 230, '2019-12-16', 344, NULL),
('The Paradise Inn', 230, '2019-12-17', 161, NULL),
('The Paradise Inn', 230, '2019-12-18', 263, NULL),
('The Paradise Inn', 230, '2019-12-19', 179, NULL),
('The Paradise Inn', 230, '2019-12-20', 183, NULL),
('The Paradise Inn', 230, '2019-12-21', 192, NULL),
('The Paradise Inn', 230, '2019-12-22', 365, NULL),
('The Paradise Inn', 230, '2019-12-23', 317, NULL),
('The Paradise Inn', 230, '2019-12-24', 181, NULL),
('The Paradise Inn', 230, '2019-12-25', 390, NULL),
('The Paradise Inn', 230, '2019-12-26', 280, NULL),
('The Paradise Inn', 230, '2019-12-27', 216, NULL),
('The Paradise Inn', 230, '2019-12-28', 227, NULL),
('The Paradise Inn', 230, '2019-12-29', 320, NULL),
('The Paradise Inn', 230, '2019-12-30', 104, NULL),
('The Paradise Inn', 230, '2019-12-31', 106, NULL),
('The Paradise Inn', 230, '2020-01-01', 376, NULL),
('The Paradise Inn', 230, '2020-01-02', 183, NULL),
('The Paradise Inn', 230, '2020-01-03', 143, NULL),
('The Paradise Inn', 230, '2020-01-04', 391, NULL),
('The Paradise Inn', 230, '2020-01-05', 225, NULL),
('The Paradise Inn', 230, '2020-01-06', 189, NULL),
('The Paradise Inn', 230, '2020-01-07', 173, NULL),
('The Paradise Inn', 230, '2020-01-08', 177, NULL),
('The Paradise Inn', 230, '2020-01-09', 284, NULL),
('The Paradise Inn', 230, '2020-01-10', 295, NULL),
('The Paradise Inn', 230, '2020-01-11', 109, NULL),
('The Paradise Inn', 230, '2020-01-12', 394, NULL),
('The Paradise Inn', 230, '2020-01-13', 216, NULL),
('The Paradise Inn', 230, '2020-01-14', 189, NULL),
('The Paradise Inn', 230, '2020-01-15', 300, NULL),
('The Paradise Inn', 230, '2020-01-16', 247, NULL),
('The Paradise Inn', 230, '2020-01-17', 336, NULL),
('The Paradise Inn', 230, '2020-01-18', 357, NULL),
('The Paradise Inn', 230, '2020-01-19', 328, NULL),
('The Paradise Inn', 230, '2020-01-20', 215, NULL),
('The Paradise Inn', 230, '2020-01-21', 210, NULL),
('The Paradise Inn', 230, '2020-01-22', 317, NULL),
('The Paradise Inn', 230, '2020-01-23', 288, NULL),
('The Paradise Inn', 230, '2020-01-24', 229, NULL),
('The Paradise Inn', 230, '2020-01-25', 284, NULL),
('The Paradise Inn', 230, '2020-01-26', 329, NULL),
('The Paradise Inn', 230, '2020-01-27', 205, NULL),
('The Paradise Inn', 230, '2020-01-28', 310, NULL),
('The Paradise Inn', 230, '2020-01-29', 357, NULL),
('The Paradise Inn', 230, '2020-01-30', 265, NULL),
('The Paradise Inn', 230, '2020-01-31', 111, NULL),
('The Paradise Inn', 230, '2020-02-01', 378, NULL),
('The Paradise Inn', 230, '2020-02-02', 241, NULL),
('The Paradise Inn', 230, '2020-02-03', 133, NULL),
('The Paradise Inn', 230, '2020-02-04', 351, NULL),
('The Paradise Inn', 233, '2019-01-01', 223, NULL),
('The Paradise Inn', 233, '2019-01-02', 318, NULL),
('The Paradise Inn', 233, '2019-01-03', 291, NULL),
('The Paradise Inn', 233, '2019-01-04', 311, NULL),
('The Paradise Inn', 233, '2019-01-05', 218, NULL),
('The Paradise Inn', 233, '2019-01-06', 395, NULL),
('The Paradise Inn', 233, '2019-01-07', 314, NULL),
('The Paradise Inn', 233, '2019-01-08', 119, NULL),
('The Paradise Inn', 233, '2019-01-09', 228, NULL),
('The Paradise Inn', 233, '2019-01-10', 170, NULL),
('The Paradise Inn', 233, '2019-01-11', 134, NULL),
('The Paradise Inn', 233, '2019-01-12', 161, NULL),
('The Paradise Inn', 233, '2019-01-13', 382, NULL),
('The Paradise Inn', 233, '2019-01-14', 237, NULL),
('The Paradise Inn', 233, '2019-01-15', 274, NULL),
('The Paradise Inn', 233, '2019-01-16', 327, NULL),
('The Paradise Inn', 233, '2019-01-17', 196, NULL),
('The Paradise Inn', 233, '2019-01-18', 179, NULL),
('The Paradise Inn', 233, '2019-01-19', 107, NULL),
('The Paradise Inn', 233, '2019-01-20', 313, NULL),
('The Paradise Inn', 233, '2019-01-21', 292, NULL),
('The Paradise Inn', 233, '2019-01-22', 140, NULL),
('The Paradise Inn', 233, '2019-01-23', 152, NULL),
('The Paradise Inn', 233, '2019-01-24', 310, NULL),
('The Paradise Inn', 233, '2019-01-25', 240, NULL),
('The Paradise Inn', 233, '2019-01-26', 356, NULL),
('The Paradise Inn', 233, '2019-01-27', 115, NULL),
('The Paradise Inn', 233, '2019-01-28', 103, NULL),
('The Paradise Inn', 233, '2019-01-29', 146, NULL),
('The Paradise Inn', 233, '2019-01-30', 199, NULL),
('The Paradise Inn', 233, '2019-01-31', 254, NULL),
('The Paradise Inn', 233, '2019-02-01', 242, NULL),
('The Paradise Inn', 233, '2019-02-02', 349, NULL),
('The Paradise Inn', 233, '2019-02-03', 251, NULL),
('The Paradise Inn', 233, '2019-02-04', 133, NULL),
('The Paradise Inn', 233, '2019-02-05', 272, NULL),
('The Paradise Inn', 233, '2019-02-06', 366, NULL),
('The Paradise Inn', 233, '2019-02-07', 172, NULL),
('The Paradise Inn', 233, '2019-02-08', 321, NULL),
('The Paradise Inn', 233, '2019-02-09', 128, NULL),
('The Paradise Inn', 233, '2019-02-10', 159, NULL),
('The Paradise Inn', 233, '2019-02-11', 172, NULL),
('The Paradise Inn', 233, '2019-02-12', 192, NULL),
('The Paradise Inn', 233, '2019-02-13', 158, NULL),
('The Paradise Inn', 233, '2019-02-14', 154, NULL),
('The Paradise Inn', 233, '2019-02-15', 107, NULL),
('The Paradise Inn', 233, '2019-02-16', 295, NULL),
('The Paradise Inn', 233, '2019-02-17', 333, NULL),
('The Paradise Inn', 233, '2019-02-18', 375, NULL),
('The Paradise Inn', 233, '2019-02-19', 182, NULL),
('The Paradise Inn', 233, '2019-02-20', 233, NULL),
('The Paradise Inn', 233, '2019-02-21', 278, NULL),
('The Paradise Inn', 233, '2019-02-22', 274, NULL),
('The Paradise Inn', 233, '2019-02-23', 284, NULL),
('The Paradise Inn', 233, '2019-02-24', 273, NULL),
('The Paradise Inn', 233, '2019-02-25', 170, NULL),
('The Paradise Inn', 233, '2019-02-26', 173, NULL),
('The Paradise Inn', 233, '2019-02-27', 335, NULL),
('The Paradise Inn', 233, '2019-02-28', 343, NULL),
('The Paradise Inn', 233, '2019-03-01', 289, NULL),
('The Paradise Inn', 233, '2019-03-02', 280, NULL),
('The Paradise Inn', 233, '2019-03-03', 252, NULL),
('The Paradise Inn', 233, '2019-03-04', 364, NULL),
('The Paradise Inn', 233, '2019-03-05', 119, NULL),
('The Paradise Inn', 233, '2019-03-06', 258, NULL),
('The Paradise Inn', 233, '2019-03-07', 120, NULL),
('The Paradise Inn', 233, '2019-03-08', 262, NULL),
('The Paradise Inn', 233, '2019-03-09', 138, NULL),
('The Paradise Inn', 233, '2019-03-10', 278, NULL),
('The Paradise Inn', 233, '2019-03-11', 371, NULL),
('The Paradise Inn', 233, '2019-03-12', 330, NULL),
('The Paradise Inn', 233, '2019-03-13', 104, NULL),
('The Paradise Inn', 233, '2019-03-14', 374, NULL),
('The Paradise Inn', 233, '2019-03-15', 277, NULL),
('The Paradise Inn', 233, '2019-03-16', 326, NULL),
('The Paradise Inn', 233, '2019-03-17', 171, NULL),
('The Paradise Inn', 233, '2019-03-18', 367, NULL),
('The Paradise Inn', 233, '2019-03-19', 113, NULL),
('The Paradise Inn', 233, '2019-03-20', 126, NULL),
('The Paradise Inn', 233, '2019-03-21', 177, NULL),
('The Paradise Inn', 233, '2019-03-22', 249, NULL),
('The Paradise Inn', 233, '2019-03-23', 399, NULL),
('The Paradise Inn', 233, '2019-03-24', 376, NULL),
('The Paradise Inn', 233, '2019-03-25', 164, NULL),
('The Paradise Inn', 233, '2019-03-26', 385, NULL),
('The Paradise Inn', 233, '2019-03-27', 175, NULL),
('The Paradise Inn', 233, '2019-03-28', 240, NULL),
('The Paradise Inn', 233, '2019-03-29', 395, NULL),
('The Paradise Inn', 233, '2019-03-30', 330, NULL),
('The Paradise Inn', 233, '2019-03-31', 291, NULL),
('The Paradise Inn', 233, '2019-04-01', 231, NULL),
('The Paradise Inn', 233, '2019-04-02', 198, NULL),
('The Paradise Inn', 233, '2019-04-03', 226, NULL),
('The Paradise Inn', 233, '2019-04-04', 379, NULL),
('The Paradise Inn', 233, '2019-04-05', 239, NULL),
('The Paradise Inn', 233, '2019-04-06', 167, NULL),
('The Paradise Inn', 233, '2019-04-07', 288, NULL),
('The Paradise Inn', 233, '2019-04-08', 303, NULL),
('The Paradise Inn', 233, '2019-04-09', 277, NULL),
('The Paradise Inn', 233, '2019-04-10', 311, NULL),
('The Paradise Inn', 233, '2019-04-11', 289, NULL),
('The Paradise Inn', 233, '2019-04-12', 353, NULL),
('The Paradise Inn', 233, '2019-04-13', 266, NULL),
('The Paradise Inn', 233, '2019-04-14', 164, NULL),
('The Paradise Inn', 233, '2019-04-15', 159, NULL),
('The Paradise Inn', 233, '2019-04-16', 101, NULL),
('The Paradise Inn', 233, '2019-04-17', 121, NULL),
('The Paradise Inn', 233, '2019-04-18', 372, NULL),
('The Paradise Inn', 233, '2019-04-19', 151, NULL),
('The Paradise Inn', 233, '2019-04-20', 264, NULL),
('The Paradise Inn', 233, '2019-04-21', 302, NULL),
('The Paradise Inn', 233, '2019-04-22', 367, NULL),
('The Paradise Inn', 233, '2019-04-23', 276, NULL),
('The Paradise Inn', 233, '2019-04-24', 295, NULL),
('The Paradise Inn', 233, '2019-04-25', 163, NULL),
('The Paradise Inn', 233, '2019-04-26', 172, NULL),
('The Paradise Inn', 233, '2019-04-27', 170, NULL),
('The Paradise Inn', 233, '2019-04-28', 187, NULL),
('The Paradise Inn', 233, '2019-04-29', 173, NULL),
('The Paradise Inn', 233, '2019-04-30', 292, NULL),
('The Paradise Inn', 233, '2019-05-01', 243, NULL),
('The Paradise Inn', 233, '2019-05-02', 368, NULL),
('The Paradise Inn', 233, '2019-05-03', 109, NULL),
('The Paradise Inn', 233, '2019-05-04', 374, NULL),
('The Paradise Inn', 233, '2019-05-05', 325, NULL),
('The Paradise Inn', 233, '2019-05-06', 128, NULL),
('The Paradise Inn', 233, '2019-05-07', 137, NULL),
('The Paradise Inn', 233, '2019-05-08', 216, NULL),
('The Paradise Inn', 233, '2019-05-09', 227, NULL),
('The Paradise Inn', 233, '2019-05-10', 144, NULL),
('The Paradise Inn', 233, '2019-05-11', 173, NULL),
('The Paradise Inn', 233, '2019-05-12', 126, NULL),
('The Paradise Inn', 233, '2019-05-13', 210, NULL),
('The Paradise Inn', 233, '2019-05-14', 336, NULL),
('The Paradise Inn', 233, '2019-05-15', 118, NULL),
('The Paradise Inn', 233, '2019-05-16', 219, NULL),
('The Paradise Inn', 233, '2019-05-17', 307, NULL),
('The Paradise Inn', 233, '2019-05-18', 388, NULL),
('The Paradise Inn', 233, '2019-05-19', 181, NULL),
('The Paradise Inn', 233, '2019-05-20', 138, NULL),
('The Paradise Inn', 233, '2019-05-21', 392, NULL),
('The Paradise Inn', 233, '2019-05-22', 158, NULL),
('The Paradise Inn', 233, '2019-05-23', 196, NULL),
('The Paradise Inn', 233, '2019-05-24', 157, NULL),
('The Paradise Inn', 233, '2019-05-25', 121, NULL),
('The Paradise Inn', 233, '2019-05-26', 300, NULL),
('The Paradise Inn', 233, '2019-05-27', 160, NULL),
('The Paradise Inn', 233, '2019-05-28', 169, NULL),
('The Paradise Inn', 233, '2019-05-29', 367, NULL),
('The Paradise Inn', 233, '2019-05-30', 127, NULL),
('The Paradise Inn', 233, '2019-05-31', 309, NULL),
('The Paradise Inn', 233, '2019-06-01', 234, NULL),
('The Paradise Inn', 233, '2019-06-02', 219, NULL),
('The Paradise Inn', 233, '2019-06-03', 267, NULL),
('The Paradise Inn', 233, '2019-06-04', 131, NULL),
('The Paradise Inn', 233, '2019-06-05', 269, NULL),
('The Paradise Inn', 233, '2019-06-06', 228, NULL),
('The Paradise Inn', 233, '2019-06-07', 305, NULL),
('The Paradise Inn', 233, '2019-06-08', 117, NULL),
('The Paradise Inn', 233, '2019-06-09', 109, NULL),
('The Paradise Inn', 233, '2019-06-10', 176, NULL),
('The Paradise Inn', 233, '2019-06-11', 140, NULL),
('The Paradise Inn', 233, '2019-06-12', 376, NULL),
('The Paradise Inn', 233, '2019-06-13', 375, NULL),
('The Paradise Inn', 233, '2019-06-14', 151, NULL),
('The Paradise Inn', 233, '2019-06-15', 224, NULL),
('The Paradise Inn', 233, '2019-06-16', 154, NULL),
('The Paradise Inn', 233, '2019-06-17', 253, NULL),
('The Paradise Inn', 233, '2019-06-18', 257, NULL),
('The Paradise Inn', 233, '2019-06-19', 275, NULL),
('The Paradise Inn', 233, '2019-06-20', 159, NULL),
('The Paradise Inn', 233, '2019-06-21', 230, NULL),
('The Paradise Inn', 233, '2019-06-22', 374, NULL),
('The Paradise Inn', 233, '2019-06-23', 162, NULL),
('The Paradise Inn', 233, '2019-06-24', 291, NULL),
('The Paradise Inn', 233, '2019-06-25', 239, NULL),
('The Paradise Inn', 233, '2019-06-26', 100, NULL),
('The Paradise Inn', 233, '2019-06-27', 286, NULL),
('The Paradise Inn', 233, '2019-06-28', 373, NULL),
('The Paradise Inn', 233, '2019-06-29', 360, NULL),
('The Paradise Inn', 233, '2019-06-30', 176, NULL),
('The Paradise Inn', 233, '2019-07-01', 205, NULL),
('The Paradise Inn', 233, '2019-07-02', 264, NULL),
('The Paradise Inn', 233, '2019-07-03', 242, NULL),
('The Paradise Inn', 233, '2019-07-04', 185, NULL),
('The Paradise Inn', 233, '2019-07-05', 105, NULL),
('The Paradise Inn', 233, '2019-07-06', 132, NULL),
('The Paradise Inn', 233, '2019-07-07', 101, NULL),
('The Paradise Inn', 233, '2019-07-08', 297, NULL),
('The Paradise Inn', 233, '2019-07-09', 127, NULL),
('The Paradise Inn', 233, '2019-07-10', 196, NULL),
('The Paradise Inn', 233, '2019-07-11', 202, NULL),
('The Paradise Inn', 233, '2019-07-12', 364, NULL),
('The Paradise Inn', 233, '2019-07-13', 137, NULL),
('The Paradise Inn', 233, '2019-07-14', 207, NULL),
('The Paradise Inn', 233, '2019-07-15', 326, NULL),
('The Paradise Inn', 233, '2019-07-16', 211, NULL),
('The Paradise Inn', 233, '2019-07-17', 398, NULL),
('The Paradise Inn', 233, '2019-07-18', 399, NULL),
('The Paradise Inn', 233, '2019-07-19', 127, NULL),
('The Paradise Inn', 233, '2019-07-20', 151, NULL),
('The Paradise Inn', 233, '2019-07-21', 211, NULL),
('The Paradise Inn', 233, '2019-07-22', 234, NULL),
('The Paradise Inn', 233, '2019-07-23', 383, NULL),
('The Paradise Inn', 233, '2019-07-24', 389, NULL),
('The Paradise Inn', 233, '2019-07-25', 333, NULL),
('The Paradise Inn', 233, '2019-07-26', 178, NULL),
('The Paradise Inn', 233, '2019-07-27', 324, NULL),
('The Paradise Inn', 233, '2019-07-28', 267, NULL),
('The Paradise Inn', 233, '2019-07-29', 370, NULL),
('The Paradise Inn', 233, '2019-07-30', 289, NULL),
('The Paradise Inn', 233, '2019-07-31', 267, NULL),
('The Paradise Inn', 233, '2019-08-01', 292, NULL),
('The Paradise Inn', 233, '2019-08-02', 393, NULL),
('The Paradise Inn', 233, '2019-08-03', 377, NULL),
('The Paradise Inn', 233, '2019-08-04', 346, NULL),
('The Paradise Inn', 233, '2019-08-05', 159, NULL),
('The Paradise Inn', 233, '2019-08-06', 167, NULL),
('The Paradise Inn', 233, '2019-08-07', 150, NULL),
('The Paradise Inn', 233, '2019-08-08', 318, NULL),
('The Paradise Inn', 233, '2019-08-09', 238, NULL),
('The Paradise Inn', 233, '2019-08-10', 287, NULL),
('The Paradise Inn', 233, '2019-08-11', 342, NULL),
('The Paradise Inn', 233, '2019-08-12', 185, NULL),
('The Paradise Inn', 233, '2019-08-13', 117, NULL),
('The Paradise Inn', 233, '2019-08-14', 348, NULL),
('The Paradise Inn', 233, '2019-08-15', 278, NULL),
('The Paradise Inn', 233, '2019-08-16', 364, NULL),
('The Paradise Inn', 233, '2019-08-17', 207, NULL),
('The Paradise Inn', 233, '2019-08-18', 336, NULL),
('The Paradise Inn', 233, '2019-08-19', 379, NULL),
('The Paradise Inn', 233, '2019-08-20', 397, NULL),
('The Paradise Inn', 233, '2019-08-21', 328, NULL),
('The Paradise Inn', 233, '2019-08-22', 187, NULL),
('The Paradise Inn', 233, '2019-08-23', 180, NULL),
('The Paradise Inn', 233, '2019-08-24', 314, NULL),
('The Paradise Inn', 233, '2019-08-25', 152, NULL),
('The Paradise Inn', 233, '2019-08-26', 344, NULL),
('The Paradise Inn', 233, '2019-08-27', 225, NULL),
('The Paradise Inn', 233, '2019-08-28', 159, NULL),
('The Paradise Inn', 233, '2019-08-29', 393, NULL),
('The Paradise Inn', 233, '2019-08-30', 331, NULL),
('The Paradise Inn', 233, '2019-08-31', 155, NULL),
('The Paradise Inn', 233, '2019-09-01', 306, NULL),
('The Paradise Inn', 233, '2019-09-02', 262, NULL),
('The Paradise Inn', 233, '2019-09-03', 174, NULL),
('The Paradise Inn', 233, '2019-09-04', 111, NULL),
('The Paradise Inn', 233, '2019-09-05', 201, NULL),
('The Paradise Inn', 233, '2019-09-06', 371, NULL),
('The Paradise Inn', 233, '2019-09-07', 338, NULL),
('The Paradise Inn', 233, '2019-09-08', 290, NULL),
('The Paradise Inn', 233, '2019-09-09', 132, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 233, '2019-09-10', 291, NULL),
('The Paradise Inn', 233, '2019-09-11', 195, NULL),
('The Paradise Inn', 233, '2019-09-12', 269, NULL),
('The Paradise Inn', 233, '2019-09-13', 330, NULL),
('The Paradise Inn', 233, '2019-09-14', 306, NULL),
('The Paradise Inn', 233, '2019-09-15', 157, NULL),
('The Paradise Inn', 233, '2019-09-16', 272, NULL),
('The Paradise Inn', 233, '2019-09-17', 319, NULL),
('The Paradise Inn', 233, '2019-09-18', 138, NULL),
('The Paradise Inn', 233, '2019-09-19', 284, NULL),
('The Paradise Inn', 233, '2019-09-20', 321, NULL),
('The Paradise Inn', 233, '2019-09-21', 285, NULL),
('The Paradise Inn', 233, '2019-09-22', 150, NULL),
('The Paradise Inn', 233, '2019-09-23', 272, NULL),
('The Paradise Inn', 233, '2019-09-24', 144, NULL),
('The Paradise Inn', 233, '2019-09-25', 126, NULL),
('The Paradise Inn', 233, '2019-09-26', 312, NULL),
('The Paradise Inn', 233, '2019-09-27', 386, NULL),
('The Paradise Inn', 233, '2019-09-28', 149, NULL),
('The Paradise Inn', 233, '2019-09-29', 326, NULL),
('The Paradise Inn', 233, '2019-09-30', 252, NULL),
('The Paradise Inn', 233, '2019-10-01', 208, NULL),
('The Paradise Inn', 233, '2019-10-02', 395, NULL),
('The Paradise Inn', 233, '2019-10-03', 334, NULL),
('The Paradise Inn', 233, '2019-10-04', 329, NULL),
('The Paradise Inn', 233, '2019-10-05', 123, NULL),
('The Paradise Inn', 233, '2019-10-06', 362, NULL),
('The Paradise Inn', 233, '2019-10-07', 289, NULL),
('The Paradise Inn', 233, '2019-10-08', 342, NULL),
('The Paradise Inn', 233, '2019-10-09', 346, NULL),
('The Paradise Inn', 233, '2019-10-10', 311, NULL),
('The Paradise Inn', 233, '2019-10-11', 374, NULL),
('The Paradise Inn', 233, '2019-10-12', 308, NULL),
('The Paradise Inn', 233, '2019-10-13', 333, NULL),
('The Paradise Inn', 233, '2019-10-14', 271, NULL),
('The Paradise Inn', 233, '2019-10-15', 370, NULL),
('The Paradise Inn', 233, '2019-10-16', 308, NULL),
('The Paradise Inn', 233, '2019-10-17', 115, NULL),
('The Paradise Inn', 233, '2019-10-18', 265, NULL),
('The Paradise Inn', 233, '2019-10-19', 181, NULL),
('The Paradise Inn', 233, '2019-10-20', 399, NULL),
('The Paradise Inn', 233, '2019-10-21', 218, NULL),
('The Paradise Inn', 233, '2019-10-22', 172, NULL),
('The Paradise Inn', 233, '2019-10-23', 149, NULL),
('The Paradise Inn', 233, '2019-10-24', 269, NULL),
('The Paradise Inn', 233, '2019-10-25', 376, NULL),
('The Paradise Inn', 233, '2019-10-26', 106, NULL),
('The Paradise Inn', 233, '2019-10-27', 162, NULL),
('The Paradise Inn', 233, '2019-10-28', 324, NULL),
('The Paradise Inn', 233, '2019-10-29', 342, NULL),
('The Paradise Inn', 233, '2019-10-30', 130, NULL),
('The Paradise Inn', 233, '2019-10-31', 154, NULL),
('The Paradise Inn', 233, '2019-11-01', 113, NULL),
('The Paradise Inn', 233, '2019-11-02', 180, NULL),
('The Paradise Inn', 233, '2019-11-03', 248, NULL),
('The Paradise Inn', 233, '2019-11-04', 235, NULL),
('The Paradise Inn', 233, '2019-11-05', 253, NULL),
('The Paradise Inn', 233, '2019-11-06', 195, NULL),
('The Paradise Inn', 233, '2019-11-07', 398, NULL),
('The Paradise Inn', 233, '2019-11-08', 244, NULL),
('The Paradise Inn', 233, '2019-11-09', 221, NULL),
('The Paradise Inn', 233, '2019-11-10', 209, NULL),
('The Paradise Inn', 233, '2019-11-11', 259, NULL),
('The Paradise Inn', 233, '2019-11-12', 355, NULL),
('The Paradise Inn', 233, '2019-11-13', 322, NULL),
('The Paradise Inn', 233, '2019-11-14', 142, NULL),
('The Paradise Inn', 233, '2019-11-15', 320, NULL),
('The Paradise Inn', 233, '2019-11-16', 358, NULL),
('The Paradise Inn', 233, '2019-11-17', 338, NULL),
('The Paradise Inn', 233, '2019-11-18', 333, NULL),
('The Paradise Inn', 233, '2019-11-19', 283, NULL),
('The Paradise Inn', 233, '2019-11-20', 220, NULL),
('The Paradise Inn', 233, '2019-11-21', 346, NULL),
('The Paradise Inn', 233, '2019-11-22', 331, NULL),
('The Paradise Inn', 233, '2019-11-23', 210, NULL),
('The Paradise Inn', 233, '2019-11-24', 288, NULL),
('The Paradise Inn', 233, '2019-11-25', 302, NULL),
('The Paradise Inn', 233, '2019-11-26', 325, NULL),
('The Paradise Inn', 233, '2019-11-27', 206, NULL),
('The Paradise Inn', 233, '2019-11-28', 371, NULL),
('The Paradise Inn', 233, '2019-11-29', 105, NULL),
('The Paradise Inn', 233, '2019-11-30', 164, NULL),
('The Paradise Inn', 233, '2019-12-01', 177, NULL),
('The Paradise Inn', 233, '2019-12-02', 377, NULL),
('The Paradise Inn', 233, '2019-12-03', 178, NULL),
('The Paradise Inn', 233, '2019-12-04', 322, NULL),
('The Paradise Inn', 233, '2019-12-05', 244, NULL),
('The Paradise Inn', 233, '2019-12-06', 221, NULL),
('The Paradise Inn', 233, '2019-12-07', 194, NULL),
('The Paradise Inn', 233, '2019-12-08', 329, NULL),
('The Paradise Inn', 233, '2019-12-09', 353, NULL),
('The Paradise Inn', 233, '2019-12-10', 272, NULL),
('The Paradise Inn', 233, '2019-12-11', 366, NULL),
('The Paradise Inn', 233, '2019-12-12', 344, NULL),
('The Paradise Inn', 233, '2019-12-13', 224, NULL),
('The Paradise Inn', 233, '2019-12-14', 164, NULL),
('The Paradise Inn', 233, '2019-12-15', 232, NULL),
('The Paradise Inn', 233, '2019-12-16', 371, NULL),
('The Paradise Inn', 233, '2019-12-17', 353, NULL),
('The Paradise Inn', 233, '2019-12-18', 366, NULL),
('The Paradise Inn', 233, '2019-12-19', 119, NULL),
('The Paradise Inn', 233, '2019-12-20', 340, NULL),
('The Paradise Inn', 233, '2019-12-21', 238, NULL),
('The Paradise Inn', 233, '2019-12-22', 131, NULL),
('The Paradise Inn', 233, '2019-12-23', 349, NULL),
('The Paradise Inn', 233, '2019-12-24', 374, NULL),
('The Paradise Inn', 233, '2019-12-25', 229, NULL),
('The Paradise Inn', 233, '2019-12-26', 319, NULL),
('The Paradise Inn', 233, '2019-12-27', 347, NULL),
('The Paradise Inn', 233, '2019-12-28', 351, NULL),
('The Paradise Inn', 233, '2019-12-29', 237, NULL),
('The Paradise Inn', 233, '2019-12-30', 331, NULL),
('The Paradise Inn', 233, '2019-12-31', 180, NULL),
('The Paradise Inn', 233, '2020-01-01', 396, NULL),
('The Paradise Inn', 233, '2020-01-02', 200, NULL),
('The Paradise Inn', 233, '2020-01-03', 272, NULL),
('The Paradise Inn', 233, '2020-01-04', 316, NULL),
('The Paradise Inn', 233, '2020-01-05', 117, NULL),
('The Paradise Inn', 233, '2020-01-06', 136, NULL),
('The Paradise Inn', 233, '2020-01-07', 369, NULL),
('The Paradise Inn', 233, '2020-01-08', 182, NULL),
('The Paradise Inn', 233, '2020-01-09', 285, NULL),
('The Paradise Inn', 233, '2020-01-10', 290, NULL),
('The Paradise Inn', 233, '2020-01-11', 279, NULL),
('The Paradise Inn', 233, '2020-01-12', 235, NULL),
('The Paradise Inn', 233, '2020-01-13', 107, NULL),
('The Paradise Inn', 233, '2020-01-14', 195, NULL),
('The Paradise Inn', 233, '2020-01-15', 346, NULL),
('The Paradise Inn', 233, '2020-01-16', 118, NULL),
('The Paradise Inn', 233, '2020-01-17', 158, NULL),
('The Paradise Inn', 233, '2020-01-18', 215, NULL),
('The Paradise Inn', 233, '2020-01-19', 285, NULL),
('The Paradise Inn', 233, '2020-01-20', 356, NULL),
('The Paradise Inn', 233, '2020-01-21', 152, NULL),
('The Paradise Inn', 233, '2020-01-22', 168, NULL),
('The Paradise Inn', 233, '2020-01-23', 247, NULL),
('The Paradise Inn', 233, '2020-01-24', 146, NULL),
('The Paradise Inn', 233, '2020-01-25', 328, NULL),
('The Paradise Inn', 233, '2020-01-26', 174, NULL),
('The Paradise Inn', 233, '2020-01-27', 180, NULL),
('The Paradise Inn', 233, '2020-01-28', 152, NULL),
('The Paradise Inn', 233, '2020-01-29', 354, NULL),
('The Paradise Inn', 233, '2020-01-30', 275, NULL),
('The Paradise Inn', 233, '2020-01-31', 134, NULL),
('The Paradise Inn', 233, '2020-02-01', 342, NULL),
('The Paradise Inn', 233, '2020-02-02', 191, NULL),
('The Paradise Inn', 233, '2020-02-03', 287, NULL),
('The Paradise Inn', 233, '2020-02-04', 393, NULL),
('The Paradise Inn', 244, '2019-01-01', 172, NULL),
('The Paradise Inn', 244, '2019-01-02', 378, NULL),
('The Paradise Inn', 244, '2019-01-03', 364, NULL),
('The Paradise Inn', 244, '2019-01-04', 252, NULL),
('The Paradise Inn', 244, '2019-01-05', 151, NULL),
('The Paradise Inn', 244, '2019-01-06', 121, NULL),
('The Paradise Inn', 244, '2019-01-07', 354, NULL),
('The Paradise Inn', 244, '2019-01-08', 354, NULL),
('The Paradise Inn', 244, '2019-01-09', 232, NULL),
('The Paradise Inn', 244, '2019-01-10', 108, NULL),
('The Paradise Inn', 244, '2019-01-11', 363, NULL),
('The Paradise Inn', 244, '2019-01-12', 202, NULL),
('The Paradise Inn', 244, '2019-01-13', 163, NULL),
('The Paradise Inn', 244, '2019-01-14', 267, NULL),
('The Paradise Inn', 244, '2019-01-15', 360, NULL),
('The Paradise Inn', 244, '2019-01-16', 301, NULL),
('The Paradise Inn', 244, '2019-01-17', 310, NULL),
('The Paradise Inn', 244, '2019-01-18', 376, NULL),
('The Paradise Inn', 244, '2019-01-19', 126, NULL),
('The Paradise Inn', 244, '2019-01-20', 159, NULL),
('The Paradise Inn', 244, '2019-01-21', 200, NULL),
('The Paradise Inn', 244, '2019-01-22', 215, NULL),
('The Paradise Inn', 244, '2019-01-23', 188, NULL),
('The Paradise Inn', 244, '2019-01-24', 371, NULL),
('The Paradise Inn', 244, '2019-01-25', 258, NULL),
('The Paradise Inn', 244, '2019-01-26', 332, NULL),
('The Paradise Inn', 244, '2019-01-27', 290, NULL),
('The Paradise Inn', 244, '2019-01-28', 203, NULL),
('The Paradise Inn', 244, '2019-01-29', 161, NULL),
('The Paradise Inn', 244, '2019-01-30', 296, NULL),
('The Paradise Inn', 244, '2019-01-31', 277, NULL),
('The Paradise Inn', 244, '2019-02-01', 276, NULL),
('The Paradise Inn', 244, '2019-02-02', 136, NULL),
('The Paradise Inn', 244, '2019-02-03', 211, NULL),
('The Paradise Inn', 244, '2019-02-04', 149, NULL),
('The Paradise Inn', 244, '2019-02-05', 114, NULL),
('The Paradise Inn', 244, '2019-02-06', 187, NULL),
('The Paradise Inn', 244, '2019-02-07', 344, NULL),
('The Paradise Inn', 244, '2019-02-08', 121, NULL),
('The Paradise Inn', 244, '2019-02-09', 310, NULL),
('The Paradise Inn', 244, '2019-02-10', 314, NULL),
('The Paradise Inn', 244, '2019-02-11', 128, NULL),
('The Paradise Inn', 244, '2019-02-12', 345, NULL),
('The Paradise Inn', 244, '2019-02-13', 261, NULL),
('The Paradise Inn', 244, '2019-02-14', 123, NULL),
('The Paradise Inn', 244, '2019-02-15', 311, NULL),
('The Paradise Inn', 244, '2019-02-16', 388, NULL),
('The Paradise Inn', 244, '2019-02-17', 358, NULL),
('The Paradise Inn', 244, '2019-02-18', 125, NULL),
('The Paradise Inn', 244, '2019-02-19', 310, NULL),
('The Paradise Inn', 244, '2019-02-20', 351, NULL),
('The Paradise Inn', 244, '2019-02-21', 320, NULL),
('The Paradise Inn', 244, '2019-02-22', 325, NULL),
('The Paradise Inn', 244, '2019-02-23', 292, NULL),
('The Paradise Inn', 244, '2019-02-24', 121, NULL),
('The Paradise Inn', 244, '2019-02-25', 129, NULL),
('The Paradise Inn', 244, '2019-02-26', 352, NULL),
('The Paradise Inn', 244, '2019-02-27', 105, NULL),
('The Paradise Inn', 244, '2019-02-28', 361, NULL),
('The Paradise Inn', 244, '2019-03-01', 260, NULL),
('The Paradise Inn', 244, '2019-03-02', 307, NULL),
('The Paradise Inn', 244, '2019-03-03', 176, NULL),
('The Paradise Inn', 244, '2019-03-04', 275, NULL),
('The Paradise Inn', 244, '2019-03-05', 290, NULL),
('The Paradise Inn', 244, '2019-03-06', 290, NULL),
('The Paradise Inn', 244, '2019-03-07', 260, NULL),
('The Paradise Inn', 244, '2019-03-08', 323, NULL),
('The Paradise Inn', 244, '2019-03-09', 222, NULL),
('The Paradise Inn', 244, '2019-03-10', 205, NULL),
('The Paradise Inn', 244, '2019-03-11', 110, NULL),
('The Paradise Inn', 244, '2019-03-12', 284, NULL),
('The Paradise Inn', 244, '2019-03-13', 221, NULL),
('The Paradise Inn', 244, '2019-03-14', 300, NULL),
('The Paradise Inn', 244, '2019-03-15', 104, NULL),
('The Paradise Inn', 244, '2019-03-16', 336, NULL),
('The Paradise Inn', 244, '2019-03-17', 109, NULL),
('The Paradise Inn', 244, '2019-03-18', 351, NULL),
('The Paradise Inn', 244, '2019-03-19', 392, NULL),
('The Paradise Inn', 244, '2019-03-20', 181, NULL),
('The Paradise Inn', 244, '2019-03-21', 284, NULL),
('The Paradise Inn', 244, '2019-03-22', 352, NULL),
('The Paradise Inn', 244, '2019-03-23', 133, NULL),
('The Paradise Inn', 244, '2019-03-24', 214, NULL),
('The Paradise Inn', 244, '2019-03-25', 193, NULL),
('The Paradise Inn', 244, '2019-03-26', 388, NULL),
('The Paradise Inn', 244, '2019-03-27', 163, NULL),
('The Paradise Inn', 244, '2019-03-28', 253, NULL),
('The Paradise Inn', 244, '2019-03-29', 124, NULL),
('The Paradise Inn', 244, '2019-03-30', 366, NULL),
('The Paradise Inn', 244, '2019-03-31', 258, NULL),
('The Paradise Inn', 244, '2019-04-01', 191, NULL),
('The Paradise Inn', 244, '2019-04-02', 298, NULL),
('The Paradise Inn', 244, '2019-04-03', 221, NULL),
('The Paradise Inn', 244, '2019-04-04', 389, NULL),
('The Paradise Inn', 244, '2019-04-05', 105, NULL),
('The Paradise Inn', 244, '2019-04-06', 169, NULL),
('The Paradise Inn', 244, '2019-04-07', 259, NULL),
('The Paradise Inn', 244, '2019-04-08', 153, NULL),
('The Paradise Inn', 244, '2019-04-09', 248, NULL),
('The Paradise Inn', 244, '2019-04-10', 145, NULL),
('The Paradise Inn', 244, '2019-04-11', 100, NULL),
('The Paradise Inn', 244, '2019-04-12', 357, NULL),
('The Paradise Inn', 244, '2019-04-13', 255, NULL),
('The Paradise Inn', 244, '2019-04-14', 247, NULL),
('The Paradise Inn', 244, '2019-04-15', 171, NULL),
('The Paradise Inn', 244, '2019-04-16', 257, NULL),
('The Paradise Inn', 244, '2019-04-17', 140, NULL),
('The Paradise Inn', 244, '2019-04-18', 222, NULL),
('The Paradise Inn', 244, '2019-04-19', 355, NULL),
('The Paradise Inn', 244, '2019-04-20', 185, NULL),
('The Paradise Inn', 244, '2019-04-21', 215, NULL),
('The Paradise Inn', 244, '2019-04-22', 345, NULL),
('The Paradise Inn', 244, '2019-04-23', 299, NULL),
('The Paradise Inn', 244, '2019-04-24', 179, NULL),
('The Paradise Inn', 244, '2019-04-25', 366, NULL),
('The Paradise Inn', 244, '2019-04-26', 236, NULL),
('The Paradise Inn', 244, '2019-04-27', 362, NULL),
('The Paradise Inn', 244, '2019-04-28', 300, NULL),
('The Paradise Inn', 244, '2019-04-29', 370, NULL),
('The Paradise Inn', 244, '2019-04-30', 360, NULL),
('The Paradise Inn', 244, '2019-05-01', 321, NULL),
('The Paradise Inn', 244, '2019-05-02', 133, NULL),
('The Paradise Inn', 244, '2019-05-03', 350, NULL),
('The Paradise Inn', 244, '2019-05-04', 110, NULL),
('The Paradise Inn', 244, '2019-05-05', 211, NULL),
('The Paradise Inn', 244, '2019-05-06', 234, NULL),
('The Paradise Inn', 244, '2019-05-07', 158, NULL),
('The Paradise Inn', 244, '2019-05-08', 399, NULL),
('The Paradise Inn', 244, '2019-05-09', 161, NULL),
('The Paradise Inn', 244, '2019-05-10', 135, NULL),
('The Paradise Inn', 244, '2019-05-11', 328, NULL),
('The Paradise Inn', 244, '2019-05-12', 353, NULL),
('The Paradise Inn', 244, '2019-05-13', 134, NULL),
('The Paradise Inn', 244, '2019-05-14', 324, NULL),
('The Paradise Inn', 244, '2019-05-15', 386, NULL),
('The Paradise Inn', 244, '2019-05-16', 173, NULL),
('The Paradise Inn', 244, '2019-05-17', 240, NULL),
('The Paradise Inn', 244, '2019-05-18', 254, NULL),
('The Paradise Inn', 244, '2019-05-19', 386, NULL),
('The Paradise Inn', 244, '2019-05-20', 339, NULL),
('The Paradise Inn', 244, '2019-05-21', 394, NULL),
('The Paradise Inn', 244, '2019-05-22', 315, NULL),
('The Paradise Inn', 244, '2019-05-23', 345, NULL),
('The Paradise Inn', 244, '2019-05-24', 258, NULL),
('The Paradise Inn', 244, '2019-05-25', 231, NULL),
('The Paradise Inn', 244, '2019-05-26', 350, NULL),
('The Paradise Inn', 244, '2019-05-27', 358, NULL),
('The Paradise Inn', 244, '2019-05-28', 315, NULL),
('The Paradise Inn', 244, '2019-05-29', 346, NULL),
('The Paradise Inn', 244, '2019-05-30', 329, NULL),
('The Paradise Inn', 244, '2019-05-31', 343, NULL),
('The Paradise Inn', 244, '2019-06-01', 171, NULL),
('The Paradise Inn', 244, '2019-06-02', 114, NULL),
('The Paradise Inn', 244, '2019-06-03', 368, NULL),
('The Paradise Inn', 244, '2019-06-04', 156, NULL),
('The Paradise Inn', 244, '2019-06-05', 142, NULL),
('The Paradise Inn', 244, '2019-06-06', 332, NULL),
('The Paradise Inn', 244, '2019-06-07', 385, NULL),
('The Paradise Inn', 244, '2019-06-08', 304, NULL),
('The Paradise Inn', 244, '2019-06-09', 258, NULL),
('The Paradise Inn', 244, '2019-06-10', 252, NULL),
('The Paradise Inn', 244, '2019-06-11', 346, NULL),
('The Paradise Inn', 244, '2019-06-12', 163, NULL),
('The Paradise Inn', 244, '2019-06-13', 382, NULL),
('The Paradise Inn', 244, '2019-06-14', 334, NULL),
('The Paradise Inn', 244, '2019-06-15', 340, NULL),
('The Paradise Inn', 244, '2019-06-16', 354, NULL),
('The Paradise Inn', 244, '2019-06-17', 151, NULL),
('The Paradise Inn', 244, '2019-06-18', 359, NULL),
('The Paradise Inn', 244, '2019-06-19', 337, NULL),
('The Paradise Inn', 244, '2019-06-20', 250, NULL),
('The Paradise Inn', 244, '2019-06-21', 298, NULL),
('The Paradise Inn', 244, '2019-06-22', 390, NULL),
('The Paradise Inn', 244, '2019-06-23', 141, NULL),
('The Paradise Inn', 244, '2019-06-24', 225, NULL),
('The Paradise Inn', 244, '2019-06-25', 196, NULL),
('The Paradise Inn', 244, '2019-06-26', 332, NULL),
('The Paradise Inn', 244, '2019-06-27', 167, NULL),
('The Paradise Inn', 244, '2019-06-28', 274, NULL),
('The Paradise Inn', 244, '2019-06-29', 234, NULL),
('The Paradise Inn', 244, '2019-06-30', 239, NULL),
('The Paradise Inn', 244, '2019-07-01', 217, NULL),
('The Paradise Inn', 244, '2019-07-02', 332, NULL),
('The Paradise Inn', 244, '2019-07-03', 182, NULL),
('The Paradise Inn', 244, '2019-07-04', 373, NULL),
('The Paradise Inn', 244, '2019-07-05', 334, NULL),
('The Paradise Inn', 244, '2019-07-06', 372, NULL),
('The Paradise Inn', 244, '2019-07-07', 360, NULL),
('The Paradise Inn', 244, '2019-07-08', 244, NULL),
('The Paradise Inn', 244, '2019-07-09', 220, NULL),
('The Paradise Inn', 244, '2019-07-10', 199, NULL),
('The Paradise Inn', 244, '2019-07-11', 282, NULL),
('The Paradise Inn', 244, '2019-07-12', 111, NULL),
('The Paradise Inn', 244, '2019-07-13', 271, NULL),
('The Paradise Inn', 244, '2019-07-14', 291, NULL),
('The Paradise Inn', 244, '2019-07-15', 291, NULL),
('The Paradise Inn', 244, '2019-07-16', 235, NULL),
('The Paradise Inn', 244, '2019-07-17', 279, NULL),
('The Paradise Inn', 244, '2019-07-18', 141, NULL),
('The Paradise Inn', 244, '2019-07-19', 378, NULL),
('The Paradise Inn', 244, '2019-07-20', 396, NULL),
('The Paradise Inn', 244, '2019-07-21', 388, NULL),
('The Paradise Inn', 244, '2019-07-22', 123, NULL),
('The Paradise Inn', 244, '2019-07-23', 263, NULL),
('The Paradise Inn', 244, '2019-07-24', 100, NULL),
('The Paradise Inn', 244, '2019-07-25', 299, NULL),
('The Paradise Inn', 244, '2019-07-26', 114, NULL),
('The Paradise Inn', 244, '2019-07-27', 358, NULL),
('The Paradise Inn', 244, '2019-07-28', 339, NULL),
('The Paradise Inn', 244, '2019-07-29', 344, NULL),
('The Paradise Inn', 244, '2019-07-30', 174, NULL),
('The Paradise Inn', 244, '2019-07-31', 160, NULL),
('The Paradise Inn', 244, '2019-08-01', 383, NULL),
('The Paradise Inn', 244, '2019-08-02', 149, NULL),
('The Paradise Inn', 244, '2019-08-03', 311, NULL),
('The Paradise Inn', 244, '2019-08-04', 158, NULL),
('The Paradise Inn', 244, '2019-08-05', 393, NULL),
('The Paradise Inn', 244, '2019-08-06', 236, NULL),
('The Paradise Inn', 244, '2019-08-07', 259, NULL),
('The Paradise Inn', 244, '2019-08-08', 274, NULL),
('The Paradise Inn', 244, '2019-08-09', 157, NULL),
('The Paradise Inn', 244, '2019-08-10', 313, NULL),
('The Paradise Inn', 244, '2019-08-11', 345, NULL),
('The Paradise Inn', 244, '2019-08-12', 179, NULL),
('The Paradise Inn', 244, '2019-08-13', 126, NULL),
('The Paradise Inn', 244, '2019-08-14', 287, NULL),
('The Paradise Inn', 244, '2019-08-15', 284, NULL),
('The Paradise Inn', 244, '2019-08-16', 174, NULL),
('The Paradise Inn', 244, '2019-08-17', 347, NULL),
('The Paradise Inn', 244, '2019-08-18', 223, NULL),
('The Paradise Inn', 244, '2019-08-19', 373, NULL),
('The Paradise Inn', 244, '2019-08-20', 244, NULL),
('The Paradise Inn', 244, '2019-08-21', 228, NULL),
('The Paradise Inn', 244, '2019-08-22', 381, NULL),
('The Paradise Inn', 244, '2019-08-23', 320, NULL),
('The Paradise Inn', 244, '2019-08-24', 216, NULL),
('The Paradise Inn', 244, '2019-08-25', 190, NULL),
('The Paradise Inn', 244, '2019-08-26', 103, NULL),
('The Paradise Inn', 244, '2019-08-27', 201, NULL),
('The Paradise Inn', 244, '2019-08-28', 368, NULL),
('The Paradise Inn', 244, '2019-08-29', 260, NULL),
('The Paradise Inn', 244, '2019-08-30', 368, NULL),
('The Paradise Inn', 244, '2019-08-31', 249, NULL),
('The Paradise Inn', 244, '2019-09-01', 392, NULL),
('The Paradise Inn', 244, '2019-09-02', 317, NULL),
('The Paradise Inn', 244, '2019-09-03', 397, NULL),
('The Paradise Inn', 244, '2019-09-04', 326, NULL),
('The Paradise Inn', 244, '2019-09-05', 235, NULL),
('The Paradise Inn', 244, '2019-09-06', 316, NULL),
('The Paradise Inn', 244, '2019-09-07', 301, NULL),
('The Paradise Inn', 244, '2019-09-08', 366, NULL),
('The Paradise Inn', 244, '2019-09-09', 354, NULL),
('The Paradise Inn', 244, '2019-09-10', 315, NULL),
('The Paradise Inn', 244, '2019-09-11', 349, NULL),
('The Paradise Inn', 244, '2019-09-12', 358, NULL),
('The Paradise Inn', 244, '2019-09-13', 187, NULL),
('The Paradise Inn', 244, '2019-09-14', 182, NULL),
('The Paradise Inn', 244, '2019-09-15', 228, NULL),
('The Paradise Inn', 244, '2019-09-16', 100, NULL),
('The Paradise Inn', 244, '2019-09-17', 259, NULL),
('The Paradise Inn', 244, '2019-09-18', 297, NULL),
('The Paradise Inn', 244, '2019-09-19', 379, NULL),
('The Paradise Inn', 244, '2019-09-20', 335, NULL),
('The Paradise Inn', 244, '2019-09-21', 119, NULL),
('The Paradise Inn', 244, '2019-09-22', 224, NULL),
('The Paradise Inn', 244, '2019-09-23', 333, NULL),
('The Paradise Inn', 244, '2019-09-24', 293, NULL),
('The Paradise Inn', 244, '2019-09-25', 294, NULL),
('The Paradise Inn', 244, '2019-09-26', 272, NULL),
('The Paradise Inn', 244, '2019-09-27', 115, NULL),
('The Paradise Inn', 244, '2019-09-28', 126, NULL),
('The Paradise Inn', 244, '2019-09-29', 260, NULL),
('The Paradise Inn', 244, '2019-09-30', 187, NULL),
('The Paradise Inn', 244, '2019-10-01', 154, NULL),
('The Paradise Inn', 244, '2019-10-02', 177, NULL),
('The Paradise Inn', 244, '2019-10-03', 203, NULL),
('The Paradise Inn', 244, '2019-10-04', 382, NULL),
('The Paradise Inn', 244, '2019-10-05', 177, NULL),
('The Paradise Inn', 244, '2019-10-06', 112, NULL),
('The Paradise Inn', 244, '2019-10-07', 324, NULL),
('The Paradise Inn', 244, '2019-10-08', 198, NULL),
('The Paradise Inn', 244, '2019-10-09', 357, NULL),
('The Paradise Inn', 244, '2019-10-10', 204, NULL),
('The Paradise Inn', 244, '2019-10-11', 262, NULL),
('The Paradise Inn', 244, '2019-10-12', 331, NULL),
('The Paradise Inn', 244, '2019-10-13', 239, NULL),
('The Paradise Inn', 244, '2019-10-14', 343, NULL),
('The Paradise Inn', 244, '2019-10-15', 232, NULL),
('The Paradise Inn', 244, '2019-10-16', 281, NULL),
('The Paradise Inn', 244, '2019-10-17', 212, NULL),
('The Paradise Inn', 244, '2019-10-18', 365, NULL),
('The Paradise Inn', 244, '2019-10-19', 148, NULL),
('The Paradise Inn', 244, '2019-10-20', 357, NULL),
('The Paradise Inn', 244, '2019-10-21', 217, NULL),
('The Paradise Inn', 244, '2019-10-22', 290, NULL),
('The Paradise Inn', 244, '2019-10-23', 166, NULL),
('The Paradise Inn', 244, '2019-10-24', 166, NULL),
('The Paradise Inn', 244, '2019-10-25', 346, NULL),
('The Paradise Inn', 244, '2019-10-26', 335, NULL),
('The Paradise Inn', 244, '2019-10-27', 166, NULL),
('The Paradise Inn', 244, '2019-10-28', 255, NULL),
('The Paradise Inn', 244, '2019-10-29', 337, NULL),
('The Paradise Inn', 244, '2019-10-30', 352, NULL),
('The Paradise Inn', 244, '2019-10-31', 351, NULL),
('The Paradise Inn', 244, '2019-11-01', 301, NULL),
('The Paradise Inn', 244, '2019-11-02', 396, NULL),
('The Paradise Inn', 244, '2019-11-03', 390, NULL),
('The Paradise Inn', 244, '2019-11-04', 189, NULL),
('The Paradise Inn', 244, '2019-11-05', 320, NULL),
('The Paradise Inn', 244, '2019-11-06', 194, NULL),
('The Paradise Inn', 244, '2019-11-07', 110, NULL),
('The Paradise Inn', 244, '2019-11-08', 301, NULL),
('The Paradise Inn', 244, '2019-11-09', 217, NULL),
('The Paradise Inn', 244, '2019-11-10', 206, NULL),
('The Paradise Inn', 244, '2019-11-11', 265, NULL),
('The Paradise Inn', 244, '2019-11-12', 134, NULL),
('The Paradise Inn', 244, '2019-11-13', 288, NULL),
('The Paradise Inn', 244, '2019-11-14', 174, NULL),
('The Paradise Inn', 244, '2019-11-15', 109, NULL),
('The Paradise Inn', 244, '2019-11-16', 297, NULL),
('The Paradise Inn', 244, '2019-11-17', 263, NULL),
('The Paradise Inn', 244, '2019-11-18', 348, NULL),
('The Paradise Inn', 244, '2019-11-19', 356, NULL),
('The Paradise Inn', 244, '2019-11-20', 182, NULL),
('The Paradise Inn', 244, '2019-11-21', 343, NULL),
('The Paradise Inn', 244, '2019-11-22', 235, NULL),
('The Paradise Inn', 244, '2019-11-23', 217, NULL),
('The Paradise Inn', 244, '2019-11-24', 361, NULL),
('The Paradise Inn', 244, '2019-11-25', 351, NULL),
('The Paradise Inn', 244, '2019-11-26', 280, NULL),
('The Paradise Inn', 244, '2019-11-27', 329, NULL),
('The Paradise Inn', 244, '2019-11-28', 139, NULL),
('The Paradise Inn', 244, '2019-11-29', 371, NULL),
('The Paradise Inn', 244, '2019-11-30', 312, NULL),
('The Paradise Inn', 244, '2019-12-01', 138, NULL),
('The Paradise Inn', 244, '2019-12-02', 344, NULL),
('The Paradise Inn', 244, '2019-12-03', 287, NULL),
('The Paradise Inn', 244, '2019-12-04', 209, NULL),
('The Paradise Inn', 244, '2019-12-05', 147, NULL),
('The Paradise Inn', 244, '2019-12-06', 292, NULL),
('The Paradise Inn', 244, '2019-12-07', 258, NULL),
('The Paradise Inn', 244, '2019-12-08', 357, NULL),
('The Paradise Inn', 244, '2019-12-09', 217, NULL),
('The Paradise Inn', 244, '2019-12-10', 150, NULL),
('The Paradise Inn', 244, '2019-12-11', 247, NULL),
('The Paradise Inn', 244, '2019-12-12', 330, NULL),
('The Paradise Inn', 244, '2019-12-13', 343, NULL),
('The Paradise Inn', 244, '2019-12-14', 388, NULL),
('The Paradise Inn', 244, '2019-12-15', 197, NULL),
('The Paradise Inn', 244, '2019-12-16', 125, NULL),
('The Paradise Inn', 244, '2019-12-17', 281, NULL),
('The Paradise Inn', 244, '2019-12-18', 342, NULL),
('The Paradise Inn', 244, '2019-12-19', 256, NULL),
('The Paradise Inn', 244, '2019-12-20', 151, NULL),
('The Paradise Inn', 244, '2019-12-21', 216, NULL),
('The Paradise Inn', 244, '2019-12-22', 359, NULL),
('The Paradise Inn', 244, '2019-12-23', 393, NULL),
('The Paradise Inn', 244, '2019-12-24', 328, NULL),
('The Paradise Inn', 244, '2019-12-25', 173, NULL),
('The Paradise Inn', 244, '2019-12-26', 357, NULL),
('The Paradise Inn', 244, '2019-12-27', 387, NULL),
('The Paradise Inn', 244, '2019-12-28', 376, NULL),
('The Paradise Inn', 244, '2019-12-29', 126, NULL),
('The Paradise Inn', 244, '2019-12-30', 341, NULL),
('The Paradise Inn', 244, '2019-12-31', 182, NULL),
('The Paradise Inn', 244, '2020-01-01', 151, NULL),
('The Paradise Inn', 244, '2020-01-02', 350, NULL),
('The Paradise Inn', 244, '2020-01-03', 229, NULL),
('The Paradise Inn', 244, '2020-01-04', 308, NULL),
('The Paradise Inn', 244, '2020-01-05', 110, NULL),
('The Paradise Inn', 244, '2020-01-06', 315, NULL),
('The Paradise Inn', 244, '2020-01-07', 326, NULL),
('The Paradise Inn', 244, '2020-01-08', 278, NULL),
('The Paradise Inn', 244, '2020-01-09', 175, NULL),
('The Paradise Inn', 244, '2020-01-10', 164, NULL),
('The Paradise Inn', 244, '2020-01-11', 372, NULL),
('The Paradise Inn', 244, '2020-01-12', 192, NULL),
('The Paradise Inn', 244, '2020-01-13', 389, NULL),
('The Paradise Inn', 244, '2020-01-14', 310, NULL),
('The Paradise Inn', 244, '2020-01-15', 133, NULL),
('The Paradise Inn', 244, '2020-01-16', 347, NULL),
('The Paradise Inn', 244, '2020-01-17', 280, NULL),
('The Paradise Inn', 244, '2020-01-18', 204, NULL),
('The Paradise Inn', 244, '2020-01-19', 343, NULL),
('The Paradise Inn', 244, '2020-01-20', 135, NULL),
('The Paradise Inn', 244, '2020-01-21', 332, NULL),
('The Paradise Inn', 244, '2020-01-22', 388, NULL),
('The Paradise Inn', 244, '2020-01-23', 269, NULL),
('The Paradise Inn', 244, '2020-01-24', 246, NULL),
('The Paradise Inn', 244, '2020-01-25', 385, NULL),
('The Paradise Inn', 244, '2020-01-26', 381, NULL),
('The Paradise Inn', 244, '2020-01-27', 182, NULL),
('The Paradise Inn', 244, '2020-01-28', 334, NULL),
('The Paradise Inn', 244, '2020-01-29', 299, NULL),
('The Paradise Inn', 244, '2020-01-30', 181, NULL),
('The Paradise Inn', 244, '2020-01-31', 238, NULL),
('The Paradise Inn', 244, '2020-02-01', 178, NULL),
('The Paradise Inn', 244, '2020-02-02', 132, NULL),
('The Paradise Inn', 244, '2020-02-03', 336, NULL),
('The Paradise Inn', 244, '2020-02-04', 214, NULL),
('The Paradise Inn', 245, '2019-01-01', 393, NULL),
('The Paradise Inn', 245, '2019-01-02', 236, NULL),
('The Paradise Inn', 245, '2019-01-03', 250, NULL),
('The Paradise Inn', 245, '2019-01-04', 225, NULL),
('The Paradise Inn', 245, '2019-01-05', 301, NULL),
('The Paradise Inn', 245, '2019-01-06', 218, NULL),
('The Paradise Inn', 245, '2019-01-07', 128, NULL),
('The Paradise Inn', 245, '2019-01-08', 113, NULL),
('The Paradise Inn', 245, '2019-01-09', 377, NULL),
('The Paradise Inn', 245, '2019-01-10', 230, NULL),
('The Paradise Inn', 245, '2019-01-11', 114, NULL),
('The Paradise Inn', 245, '2019-01-12', 126, NULL),
('The Paradise Inn', 245, '2019-01-13', 170, NULL),
('The Paradise Inn', 245, '2019-01-14', 226, NULL),
('The Paradise Inn', 245, '2019-01-15', 279, NULL),
('The Paradise Inn', 245, '2019-01-16', 125, NULL),
('The Paradise Inn', 245, '2019-01-17', 264, NULL),
('The Paradise Inn', 245, '2019-01-18', 343, NULL),
('The Paradise Inn', 245, '2019-01-19', 209, NULL),
('The Paradise Inn', 245, '2019-01-20', 356, NULL),
('The Paradise Inn', 245, '2019-01-21', 325, NULL),
('The Paradise Inn', 245, '2019-01-22', 257, NULL),
('The Paradise Inn', 245, '2019-01-23', 383, NULL),
('The Paradise Inn', 245, '2019-01-24', 228, NULL),
('The Paradise Inn', 245, '2019-01-25', 173, NULL),
('The Paradise Inn', 245, '2019-01-26', 191, NULL),
('The Paradise Inn', 245, '2019-01-27', 106, NULL),
('The Paradise Inn', 245, '2019-01-28', 306, NULL),
('The Paradise Inn', 245, '2019-01-29', 268, NULL),
('The Paradise Inn', 245, '2019-01-30', 184, NULL),
('The Paradise Inn', 245, '2019-01-31', 226, NULL),
('The Paradise Inn', 245, '2019-02-01', 254, NULL),
('The Paradise Inn', 245, '2019-02-02', 133, NULL),
('The Paradise Inn', 245, '2019-02-03', 201, NULL),
('The Paradise Inn', 245, '2019-02-04', 244, NULL),
('The Paradise Inn', 245, '2019-02-05', 254, NULL),
('The Paradise Inn', 245, '2019-02-06', 335, NULL),
('The Paradise Inn', 245, '2019-02-07', 205, NULL),
('The Paradise Inn', 245, '2019-02-08', 145, NULL),
('The Paradise Inn', 245, '2019-02-09', 168, NULL),
('The Paradise Inn', 245, '2019-02-10', 391, NULL),
('The Paradise Inn', 245, '2019-02-11', 324, NULL),
('The Paradise Inn', 245, '2019-02-12', 149, NULL),
('The Paradise Inn', 245, '2019-02-13', 134, NULL),
('The Paradise Inn', 245, '2019-02-14', 351, NULL),
('The Paradise Inn', 245, '2019-02-15', 232, NULL),
('The Paradise Inn', 245, '2019-02-16', 356, NULL),
('The Paradise Inn', 245, '2019-02-17', 391, NULL),
('The Paradise Inn', 245, '2019-02-18', 299, NULL),
('The Paradise Inn', 245, '2019-02-19', 302, NULL),
('The Paradise Inn', 245, '2019-02-20', 359, NULL),
('The Paradise Inn', 245, '2019-02-21', 369, NULL),
('The Paradise Inn', 245, '2019-02-22', 106, NULL),
('The Paradise Inn', 245, '2019-02-23', 206, NULL),
('The Paradise Inn', 245, '2019-02-24', 284, NULL),
('The Paradise Inn', 245, '2019-02-25', 336, NULL),
('The Paradise Inn', 245, '2019-02-26', 240, NULL),
('The Paradise Inn', 245, '2019-02-27', 318, NULL),
('The Paradise Inn', 245, '2019-02-28', 378, NULL),
('The Paradise Inn', 245, '2019-03-01', 334, NULL),
('The Paradise Inn', 245, '2019-03-02', 298, NULL),
('The Paradise Inn', 245, '2019-03-03', 322, NULL),
('The Paradise Inn', 245, '2019-03-04', 183, NULL),
('The Paradise Inn', 245, '2019-03-05', 391, NULL),
('The Paradise Inn', 245, '2019-03-06', 279, NULL),
('The Paradise Inn', 245, '2019-03-07', 239, NULL),
('The Paradise Inn', 245, '2019-03-08', 127, NULL),
('The Paradise Inn', 245, '2019-03-09', 297, NULL),
('The Paradise Inn', 245, '2019-03-10', 393, NULL),
('The Paradise Inn', 245, '2019-03-11', 235, NULL),
('The Paradise Inn', 245, '2019-03-12', 330, NULL),
('The Paradise Inn', 245, '2019-03-13', 393, NULL),
('The Paradise Inn', 245, '2019-03-14', 277, NULL),
('The Paradise Inn', 245, '2019-03-15', 187, NULL),
('The Paradise Inn', 245, '2019-03-16', 303, NULL),
('The Paradise Inn', 245, '2019-03-17', 233, NULL),
('The Paradise Inn', 245, '2019-03-18', 254, NULL),
('The Paradise Inn', 245, '2019-03-19', 320, NULL),
('The Paradise Inn', 245, '2019-03-20', 124, NULL),
('The Paradise Inn', 245, '2019-03-21', 188, NULL),
('The Paradise Inn', 245, '2019-03-22', 312, NULL),
('The Paradise Inn', 245, '2019-03-23', 270, NULL),
('The Paradise Inn', 245, '2019-03-24', 143, NULL),
('The Paradise Inn', 245, '2019-03-25', 374, NULL),
('The Paradise Inn', 245, '2019-03-26', 384, NULL),
('The Paradise Inn', 245, '2019-03-27', 192, NULL),
('The Paradise Inn', 245, '2019-03-28', 149, NULL),
('The Paradise Inn', 245, '2019-03-29', 235, NULL),
('The Paradise Inn', 245, '2019-03-30', 142, NULL),
('The Paradise Inn', 245, '2019-03-31', 314, NULL),
('The Paradise Inn', 245, '2019-04-01', 163, NULL),
('The Paradise Inn', 245, '2019-04-02', 197, NULL),
('The Paradise Inn', 245, '2019-04-03', 328, NULL),
('The Paradise Inn', 245, '2019-04-04', 107, NULL),
('The Paradise Inn', 245, '2019-04-05', 309, NULL),
('The Paradise Inn', 245, '2019-04-06', 246, NULL),
('The Paradise Inn', 245, '2019-04-07', 332, NULL),
('The Paradise Inn', 245, '2019-04-08', 359, NULL),
('The Paradise Inn', 245, '2019-04-09', 312, NULL),
('The Paradise Inn', 245, '2019-04-10', 294, NULL),
('The Paradise Inn', 245, '2019-04-11', 132, NULL),
('The Paradise Inn', 245, '2019-04-12', 323, NULL),
('The Paradise Inn', 245, '2019-04-13', 377, NULL),
('The Paradise Inn', 245, '2019-04-14', 341, NULL),
('The Paradise Inn', 245, '2019-04-15', 279, NULL),
('The Paradise Inn', 245, '2019-04-16', 282, NULL),
('The Paradise Inn', 245, '2019-04-17', 235, NULL),
('The Paradise Inn', 245, '2019-04-18', 194, NULL),
('The Paradise Inn', 245, '2019-04-19', 323, NULL),
('The Paradise Inn', 245, '2019-04-20', 337, NULL),
('The Paradise Inn', 245, '2019-04-21', 371, NULL),
('The Paradise Inn', 245, '2019-04-22', 224, NULL),
('The Paradise Inn', 245, '2019-04-23', 269, NULL),
('The Paradise Inn', 245, '2019-04-24', 210, NULL),
('The Paradise Inn', 245, '2019-04-25', 342, NULL),
('The Paradise Inn', 245, '2019-04-26', 263, NULL),
('The Paradise Inn', 245, '2019-04-27', 301, NULL),
('The Paradise Inn', 245, '2019-04-28', 237, NULL),
('The Paradise Inn', 245, '2019-04-29', 332, NULL),
('The Paradise Inn', 245, '2019-04-30', 225, NULL),
('The Paradise Inn', 245, '2019-05-01', 179, NULL),
('The Paradise Inn', 245, '2019-05-02', 365, NULL),
('The Paradise Inn', 245, '2019-05-03', 123, NULL),
('The Paradise Inn', 245, '2019-05-04', 228, NULL),
('The Paradise Inn', 245, '2019-05-05', 279, NULL),
('The Paradise Inn', 245, '2019-05-06', 385, NULL),
('The Paradise Inn', 245, '2019-05-07', 279, NULL),
('The Paradise Inn', 245, '2019-05-08', 345, NULL),
('The Paradise Inn', 245, '2019-05-09', 325, NULL),
('The Paradise Inn', 245, '2019-05-10', 147, NULL),
('The Paradise Inn', 245, '2019-05-11', 124, NULL),
('The Paradise Inn', 245, '2019-05-12', 386, NULL),
('The Paradise Inn', 245, '2019-05-13', 243, NULL),
('The Paradise Inn', 245, '2019-05-14', 213, NULL),
('The Paradise Inn', 245, '2019-05-15', 273, NULL),
('The Paradise Inn', 245, '2019-05-16', 111, NULL),
('The Paradise Inn', 245, '2019-05-17', 180, NULL),
('The Paradise Inn', 245, '2019-05-18', 307, NULL),
('The Paradise Inn', 245, '2019-05-19', 386, NULL),
('The Paradise Inn', 245, '2019-05-20', 282, NULL),
('The Paradise Inn', 245, '2019-05-21', 396, NULL),
('The Paradise Inn', 245, '2019-05-22', 100, NULL),
('The Paradise Inn', 245, '2019-05-23', 136, NULL),
('The Paradise Inn', 245, '2019-05-24', 121, NULL),
('The Paradise Inn', 245, '2019-05-25', 396, NULL),
('The Paradise Inn', 245, '2019-05-26', 150, NULL),
('The Paradise Inn', 245, '2019-05-27', 312, NULL),
('The Paradise Inn', 245, '2019-05-28', 367, NULL),
('The Paradise Inn', 245, '2019-05-29', 230, NULL),
('The Paradise Inn', 245, '2019-05-30', 261, NULL),
('The Paradise Inn', 245, '2019-05-31', 386, NULL),
('The Paradise Inn', 245, '2019-06-01', 356, NULL),
('The Paradise Inn', 245, '2019-06-02', 113, NULL),
('The Paradise Inn', 245, '2019-06-03', 343, NULL),
('The Paradise Inn', 245, '2019-06-04', 288, NULL),
('The Paradise Inn', 245, '2019-06-05', 103, NULL),
('The Paradise Inn', 245, '2019-06-06', 277, NULL),
('The Paradise Inn', 245, '2019-06-07', 311, NULL),
('The Paradise Inn', 245, '2019-06-08', 171, NULL),
('The Paradise Inn', 245, '2019-06-09', 264, NULL),
('The Paradise Inn', 245, '2019-06-10', 335, NULL),
('The Paradise Inn', 245, '2019-06-11', 312, NULL),
('The Paradise Inn', 245, '2019-06-12', 187, NULL),
('The Paradise Inn', 245, '2019-06-13', 385, NULL),
('The Paradise Inn', 245, '2019-06-14', 217, NULL),
('The Paradise Inn', 245, '2019-06-15', 329, NULL),
('The Paradise Inn', 245, '2019-06-16', 308, NULL),
('The Paradise Inn', 245, '2019-06-17', 199, NULL),
('The Paradise Inn', 245, '2019-06-18', 323, NULL),
('The Paradise Inn', 245, '2019-06-19', 160, NULL),
('The Paradise Inn', 245, '2019-06-20', 372, NULL),
('The Paradise Inn', 245, '2019-06-21', 102, NULL),
('The Paradise Inn', 245, '2019-06-22', 128, NULL),
('The Paradise Inn', 245, '2019-06-23', 123, NULL),
('The Paradise Inn', 245, '2019-06-24', 152, NULL),
('The Paradise Inn', 245, '2019-06-25', 160, NULL),
('The Paradise Inn', 245, '2019-06-26', 359, NULL),
('The Paradise Inn', 245, '2019-06-27', 177, NULL),
('The Paradise Inn', 245, '2019-06-28', 148, NULL),
('The Paradise Inn', 245, '2019-06-29', 294, NULL),
('The Paradise Inn', 245, '2019-06-30', 265, NULL),
('The Paradise Inn', 245, '2019-07-01', 369, NULL),
('The Paradise Inn', 245, '2019-07-02', 167, NULL),
('The Paradise Inn', 245, '2019-07-03', 384, NULL),
('The Paradise Inn', 245, '2019-07-04', 309, NULL),
('The Paradise Inn', 245, '2019-07-05', 352, NULL),
('The Paradise Inn', 245, '2019-07-06', 166, NULL),
('The Paradise Inn', 245, '2019-07-07', 197, NULL),
('The Paradise Inn', 245, '2019-07-08', 228, NULL),
('The Paradise Inn', 245, '2019-07-09', 318, NULL),
('The Paradise Inn', 245, '2019-07-10', 307, NULL),
('The Paradise Inn', 245, '2019-07-11', 106, NULL),
('The Paradise Inn', 245, '2019-07-12', 262, NULL),
('The Paradise Inn', 245, '2019-07-13', 246, NULL),
('The Paradise Inn', 245, '2019-07-14', 134, NULL),
('The Paradise Inn', 245, '2019-07-15', 377, NULL),
('The Paradise Inn', 245, '2019-07-16', 141, NULL),
('The Paradise Inn', 245, '2019-07-17', 399, NULL),
('The Paradise Inn', 245, '2019-07-18', 309, NULL),
('The Paradise Inn', 245, '2019-07-19', 207, NULL),
('The Paradise Inn', 245, '2019-07-20', 229, NULL),
('The Paradise Inn', 245, '2019-07-21', 306, NULL),
('The Paradise Inn', 245, '2019-07-22', 116, NULL),
('The Paradise Inn', 245, '2019-07-23', 366, NULL),
('The Paradise Inn', 245, '2019-07-24', 135, NULL),
('The Paradise Inn', 245, '2019-07-25', 396, NULL),
('The Paradise Inn', 245, '2019-07-26', 235, NULL),
('The Paradise Inn', 245, '2019-07-27', 122, NULL),
('The Paradise Inn', 245, '2019-07-28', 194, NULL),
('The Paradise Inn', 245, '2019-07-29', 213, NULL),
('The Paradise Inn', 245, '2019-07-30', 206, NULL),
('The Paradise Inn', 245, '2019-07-31', 203, NULL),
('The Paradise Inn', 245, '2019-08-01', 338, NULL),
('The Paradise Inn', 245, '2019-08-02', 367, NULL),
('The Paradise Inn', 245, '2019-08-03', 325, NULL),
('The Paradise Inn', 245, '2019-08-04', 253, NULL),
('The Paradise Inn', 245, '2019-08-05', 187, NULL),
('The Paradise Inn', 245, '2019-08-06', 282, NULL),
('The Paradise Inn', 245, '2019-08-07', 146, NULL),
('The Paradise Inn', 245, '2019-08-08', 318, NULL),
('The Paradise Inn', 245, '2019-08-09', 271, NULL),
('The Paradise Inn', 245, '2019-08-10', 305, NULL),
('The Paradise Inn', 245, '2019-08-11', 299, NULL),
('The Paradise Inn', 245, '2019-08-12', 244, NULL),
('The Paradise Inn', 245, '2019-08-13', 180, NULL),
('The Paradise Inn', 245, '2019-08-14', 288, NULL),
('The Paradise Inn', 245, '2019-08-15', 187, NULL),
('The Paradise Inn', 245, '2019-08-16', 278, NULL),
('The Paradise Inn', 245, '2019-08-17', 116, NULL),
('The Paradise Inn', 245, '2019-08-18', 306, NULL),
('The Paradise Inn', 245, '2019-08-19', 327, NULL),
('The Paradise Inn', 245, '2019-08-20', 229, NULL),
('The Paradise Inn', 245, '2019-08-21', 356, NULL),
('The Paradise Inn', 245, '2019-08-22', 343, NULL),
('The Paradise Inn', 245, '2019-08-23', 360, NULL),
('The Paradise Inn', 245, '2019-08-24', 337, NULL),
('The Paradise Inn', 245, '2019-08-25', 393, NULL),
('The Paradise Inn', 245, '2019-08-26', 285, NULL),
('The Paradise Inn', 245, '2019-08-27', 231, NULL),
('The Paradise Inn', 245, '2019-08-28', 362, NULL),
('The Paradise Inn', 245, '2019-08-29', 320, NULL),
('The Paradise Inn', 245, '2019-08-30', 148, NULL),
('The Paradise Inn', 245, '2019-08-31', 379, NULL),
('The Paradise Inn', 245, '2019-09-01', 343, NULL),
('The Paradise Inn', 245, '2019-09-02', 101, NULL),
('The Paradise Inn', 245, '2019-09-03', 164, NULL),
('The Paradise Inn', 245, '2019-09-04', 300, NULL),
('The Paradise Inn', 245, '2019-09-05', 174, NULL),
('The Paradise Inn', 245, '2019-09-06', 367, NULL),
('The Paradise Inn', 245, '2019-09-07', 394, NULL),
('The Paradise Inn', 245, '2019-09-08', 262, NULL),
('The Paradise Inn', 245, '2019-09-09', 373, NULL),
('The Paradise Inn', 245, '2019-09-10', 304, NULL),
('The Paradise Inn', 245, '2019-09-11', 161, NULL),
('The Paradise Inn', 245, '2019-09-12', 284, NULL),
('The Paradise Inn', 245, '2019-09-13', 145, NULL),
('The Paradise Inn', 245, '2019-09-14', 191, NULL),
('The Paradise Inn', 245, '2019-09-15', 271, NULL),
('The Paradise Inn', 245, '2019-09-16', 182, NULL),
('The Paradise Inn', 245, '2019-09-17', 239, NULL),
('The Paradise Inn', 245, '2019-09-18', 373, NULL),
('The Paradise Inn', 245, '2019-09-19', 342, NULL),
('The Paradise Inn', 245, '2019-09-20', 315, NULL),
('The Paradise Inn', 245, '2019-09-21', 242, NULL),
('The Paradise Inn', 245, '2019-09-22', 268, NULL),
('The Paradise Inn', 245, '2019-09-23', 150, NULL),
('The Paradise Inn', 245, '2019-09-24', 333, NULL),
('The Paradise Inn', 245, '2019-09-25', 390, NULL),
('The Paradise Inn', 245, '2019-09-26', 324, NULL),
('The Paradise Inn', 245, '2019-09-27', 215, NULL),
('The Paradise Inn', 245, '2019-09-28', 385, NULL),
('The Paradise Inn', 245, '2019-09-29', 223, NULL),
('The Paradise Inn', 245, '2019-09-30', 382, NULL),
('The Paradise Inn', 245, '2019-10-01', 345, NULL),
('The Paradise Inn', 245, '2019-10-02', 201, NULL),
('The Paradise Inn', 245, '2019-10-03', 213, NULL),
('The Paradise Inn', 245, '2019-10-04', 224, NULL),
('The Paradise Inn', 245, '2019-10-05', 116, NULL),
('The Paradise Inn', 245, '2019-10-06', 277, NULL),
('The Paradise Inn', 245, '2019-10-07', 355, NULL),
('The Paradise Inn', 245, '2019-10-08', 165, NULL),
('The Paradise Inn', 245, '2019-10-09', 348, NULL),
('The Paradise Inn', 245, '2019-10-10', 288, NULL),
('The Paradise Inn', 245, '2019-10-11', 388, NULL),
('The Paradise Inn', 245, '2019-10-12', 331, NULL),
('The Paradise Inn', 245, '2019-10-13', 398, NULL),
('The Paradise Inn', 245, '2019-10-14', 202, NULL),
('The Paradise Inn', 245, '2019-10-15', 249, NULL),
('The Paradise Inn', 245, '2019-10-16', 382, NULL),
('The Paradise Inn', 245, '2019-10-17', 315, NULL),
('The Paradise Inn', 245, '2019-10-18', 331, NULL),
('The Paradise Inn', 245, '2019-10-19', 397, NULL),
('The Paradise Inn', 245, '2019-10-20', 185, NULL),
('The Paradise Inn', 245, '2019-10-21', 333, NULL),
('The Paradise Inn', 245, '2019-10-22', 233, NULL),
('The Paradise Inn', 245, '2019-10-23', 286, NULL),
('The Paradise Inn', 245, '2019-10-24', 223, NULL),
('The Paradise Inn', 245, '2019-10-25', 201, NULL),
('The Paradise Inn', 245, '2019-10-26', 357, NULL),
('The Paradise Inn', 245, '2019-10-27', 247, NULL),
('The Paradise Inn', 245, '2019-10-28', 201, NULL),
('The Paradise Inn', 245, '2019-10-29', 262, NULL),
('The Paradise Inn', 245, '2019-10-30', 372, NULL),
('The Paradise Inn', 245, '2019-10-31', 294, NULL),
('The Paradise Inn', 245, '2019-11-01', 168, NULL),
('The Paradise Inn', 245, '2019-11-02', 143, NULL),
('The Paradise Inn', 245, '2019-11-03', 205, NULL),
('The Paradise Inn', 245, '2019-11-04', 140, NULL),
('The Paradise Inn', 245, '2019-11-05', 142, NULL),
('The Paradise Inn', 245, '2019-11-06', 286, NULL),
('The Paradise Inn', 245, '2019-11-07', 156, NULL),
('The Paradise Inn', 245, '2019-11-08', 375, NULL),
('The Paradise Inn', 245, '2019-11-09', 322, NULL),
('The Paradise Inn', 245, '2019-11-10', 303, NULL),
('The Paradise Inn', 245, '2019-11-11', 152, NULL),
('The Paradise Inn', 245, '2019-11-12', 105, NULL),
('The Paradise Inn', 245, '2019-11-13', 375, NULL),
('The Paradise Inn', 245, '2019-11-14', 342, NULL),
('The Paradise Inn', 245, '2019-11-15', 385, NULL),
('The Paradise Inn', 245, '2019-11-16', 312, NULL),
('The Paradise Inn', 245, '2019-11-17', 201, NULL),
('The Paradise Inn', 245, '2019-11-18', 343, NULL),
('The Paradise Inn', 245, '2019-11-19', 233, NULL),
('The Paradise Inn', 245, '2019-11-20', 151, NULL),
('The Paradise Inn', 245, '2019-11-21', 278, NULL),
('The Paradise Inn', 245, '2019-11-22', 383, NULL),
('The Paradise Inn', 245, '2019-11-23', 359, NULL),
('The Paradise Inn', 245, '2019-11-24', 244, NULL),
('The Paradise Inn', 245, '2019-11-25', 147, NULL),
('The Paradise Inn', 245, '2019-11-26', 328, NULL),
('The Paradise Inn', 245, '2019-11-27', 329, NULL),
('The Paradise Inn', 245, '2019-11-28', 384, NULL),
('The Paradise Inn', 245, '2019-11-29', 240, NULL),
('The Paradise Inn', 245, '2019-11-30', 367, NULL),
('The Paradise Inn', 245, '2019-12-01', 360, NULL),
('The Paradise Inn', 245, '2019-12-02', 192, NULL),
('The Paradise Inn', 245, '2019-12-03', 201, NULL),
('The Paradise Inn', 245, '2019-12-04', 280, NULL),
('The Paradise Inn', 245, '2019-12-05', 203, NULL),
('The Paradise Inn', 245, '2019-12-06', 397, NULL),
('The Paradise Inn', 245, '2019-12-07', 309, NULL),
('The Paradise Inn', 245, '2019-12-08', 398, NULL),
('The Paradise Inn', 245, '2019-12-09', 226, NULL),
('The Paradise Inn', 245, '2019-12-10', 134, NULL),
('The Paradise Inn', 245, '2019-12-11', 340, NULL),
('The Paradise Inn', 245, '2019-12-12', 218, NULL),
('The Paradise Inn', 245, '2019-12-13', 342, NULL),
('The Paradise Inn', 245, '2019-12-14', 150, NULL),
('The Paradise Inn', 245, '2019-12-15', 192, NULL),
('The Paradise Inn', 245, '2019-12-16', 312, NULL),
('The Paradise Inn', 245, '2019-12-17', 247, NULL),
('The Paradise Inn', 245, '2019-12-18', 214, NULL),
('The Paradise Inn', 245, '2019-12-19', 225, NULL),
('The Paradise Inn', 245, '2019-12-20', 235, NULL),
('The Paradise Inn', 245, '2019-12-21', 268, NULL),
('The Paradise Inn', 245, '2019-12-22', 104, NULL),
('The Paradise Inn', 245, '2019-12-23', 220, NULL),
('The Paradise Inn', 245, '2019-12-24', 118, NULL),
('The Paradise Inn', 245, '2019-12-25', 380, NULL),
('The Paradise Inn', 245, '2019-12-26', 130, NULL),
('The Paradise Inn', 245, '2019-12-27', 194, NULL),
('The Paradise Inn', 245, '2019-12-28', 128, NULL),
('The Paradise Inn', 245, '2019-12-29', 118, NULL),
('The Paradise Inn', 245, '2019-12-30', 313, NULL),
('The Paradise Inn', 245, '2019-12-31', 272, NULL),
('The Paradise Inn', 245, '2020-01-01', 370, NULL),
('The Paradise Inn', 245, '2020-01-02', 152, NULL),
('The Paradise Inn', 245, '2020-01-03', 231, NULL),
('The Paradise Inn', 245, '2020-01-04', 191, NULL),
('The Paradise Inn', 245, '2020-01-05', 100, NULL),
('The Paradise Inn', 245, '2020-01-06', 169, NULL),
('The Paradise Inn', 245, '2020-01-07', 123, NULL),
('The Paradise Inn', 245, '2020-01-08', 144, NULL),
('The Paradise Inn', 245, '2020-01-09', 220, NULL),
('The Paradise Inn', 245, '2020-01-10', 154, NULL),
('The Paradise Inn', 245, '2020-01-11', 320, NULL),
('The Paradise Inn', 245, '2020-01-12', 157, NULL),
('The Paradise Inn', 245, '2020-01-13', 326, NULL),
('The Paradise Inn', 245, '2020-01-14', 263, NULL),
('The Paradise Inn', 245, '2020-01-15', 126, NULL),
('The Paradise Inn', 245, '2020-01-16', 383, NULL),
('The Paradise Inn', 245, '2020-01-17', 229, NULL),
('The Paradise Inn', 245, '2020-01-18', 276, NULL),
('The Paradise Inn', 245, '2020-01-19', 159, NULL),
('The Paradise Inn', 245, '2020-01-20', 108, NULL),
('The Paradise Inn', 245, '2020-01-21', 202, NULL),
('The Paradise Inn', 245, '2020-01-22', 138, NULL),
('The Paradise Inn', 245, '2020-01-23', 207, NULL),
('The Paradise Inn', 245, '2020-01-24', 392, NULL),
('The Paradise Inn', 245, '2020-01-25', 245, NULL),
('The Paradise Inn', 245, '2020-01-26', 386, NULL),
('The Paradise Inn', 245, '2020-01-27', 272, NULL),
('The Paradise Inn', 245, '2020-01-28', 212, NULL),
('The Paradise Inn', 245, '2020-01-29', 335, NULL),
('The Paradise Inn', 245, '2020-01-30', 279, NULL),
('The Paradise Inn', 245, '2020-01-31', 388, NULL),
('The Paradise Inn', 245, '2020-02-01', 362, NULL),
('The Paradise Inn', 245, '2020-02-02', 290, NULL),
('The Paradise Inn', 245, '2020-02-03', 119, NULL),
('The Paradise Inn', 245, '2020-02-04', 388, NULL),
('The Paradise Inn', 266, '2019-01-01', 148, NULL),
('The Paradise Inn', 266, '2019-01-02', 246, NULL),
('The Paradise Inn', 266, '2019-01-03', 360, NULL),
('The Paradise Inn', 266, '2019-01-04', 269, NULL),
('The Paradise Inn', 266, '2019-01-05', 352, NULL),
('The Paradise Inn', 266, '2019-01-06', 330, NULL),
('The Paradise Inn', 266, '2019-01-07', 380, NULL),
('The Paradise Inn', 266, '2019-01-08', 303, NULL),
('The Paradise Inn', 266, '2019-01-09', 188, NULL),
('The Paradise Inn', 266, '2019-01-10', 127, NULL),
('The Paradise Inn', 266, '2019-01-11', 280, NULL),
('The Paradise Inn', 266, '2019-01-12', 227, NULL),
('The Paradise Inn', 266, '2019-01-13', 261, NULL),
('The Paradise Inn', 266, '2019-01-14', 230, NULL),
('The Paradise Inn', 266, '2019-01-15', 216, NULL),
('The Paradise Inn', 266, '2019-01-16', 224, NULL),
('The Paradise Inn', 266, '2019-01-17', 289, NULL),
('The Paradise Inn', 266, '2019-01-18', 187, NULL),
('The Paradise Inn', 266, '2019-01-19', 267, NULL),
('The Paradise Inn', 266, '2019-01-20', 303, NULL),
('The Paradise Inn', 266, '2019-01-21', 327, NULL),
('The Paradise Inn', 266, '2019-01-22', 242, NULL),
('The Paradise Inn', 266, '2019-01-23', 355, NULL),
('The Paradise Inn', 266, '2019-01-24', 228, NULL),
('The Paradise Inn', 266, '2019-01-25', 289, NULL),
('The Paradise Inn', 266, '2019-01-26', 162, NULL),
('The Paradise Inn', 266, '2019-01-27', 162, NULL),
('The Paradise Inn', 266, '2019-01-28', 221, NULL),
('The Paradise Inn', 266, '2019-01-29', 156, NULL),
('The Paradise Inn', 266, '2019-01-30', 232, NULL),
('The Paradise Inn', 266, '2019-01-31', 200, NULL),
('The Paradise Inn', 266, '2019-02-01', 344, NULL),
('The Paradise Inn', 266, '2019-02-02', 159, NULL),
('The Paradise Inn', 266, '2019-02-03', 272, NULL),
('The Paradise Inn', 266, '2019-02-04', 373, NULL),
('The Paradise Inn', 266, '2019-02-05', 227, NULL),
('The Paradise Inn', 266, '2019-02-06', 114, NULL),
('The Paradise Inn', 266, '2019-02-07', 194, NULL),
('The Paradise Inn', 266, '2019-02-08', 261, NULL),
('The Paradise Inn', 266, '2019-02-09', 110, NULL),
('The Paradise Inn', 266, '2019-02-10', 316, NULL),
('The Paradise Inn', 266, '2019-02-11', 237, NULL),
('The Paradise Inn', 266, '2019-02-12', 213, NULL),
('The Paradise Inn', 266, '2019-02-13', 388, NULL),
('The Paradise Inn', 266, '2019-02-14', 388, NULL),
('The Paradise Inn', 266, '2019-02-15', 130, NULL),
('The Paradise Inn', 266, '2019-02-16', 218, NULL),
('The Paradise Inn', 266, '2019-02-17', 184, NULL),
('The Paradise Inn', 266, '2019-02-18', 120, NULL),
('The Paradise Inn', 266, '2019-02-19', 179, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 266, '2019-02-20', 341, NULL),
('The Paradise Inn', 266, '2019-02-21', 183, NULL),
('The Paradise Inn', 266, '2019-02-22', 355, NULL),
('The Paradise Inn', 266, '2019-02-23', 354, NULL),
('The Paradise Inn', 266, '2019-02-24', 359, NULL),
('The Paradise Inn', 266, '2019-02-25', 295, NULL),
('The Paradise Inn', 266, '2019-02-26', 344, NULL),
('The Paradise Inn', 266, '2019-02-27', 276, NULL),
('The Paradise Inn', 266, '2019-02-28', 108, NULL),
('The Paradise Inn', 266, '2019-03-01', 193, NULL),
('The Paradise Inn', 266, '2019-03-02', 169, NULL),
('The Paradise Inn', 266, '2019-03-03', 382, NULL),
('The Paradise Inn', 266, '2019-03-04', 292, NULL),
('The Paradise Inn', 266, '2019-03-05', 386, NULL),
('The Paradise Inn', 266, '2019-03-06', 125, NULL),
('The Paradise Inn', 266, '2019-03-07', 317, NULL),
('The Paradise Inn', 266, '2019-03-08', 169, NULL),
('The Paradise Inn', 266, '2019-03-09', 117, NULL),
('The Paradise Inn', 266, '2019-03-10', 350, NULL),
('The Paradise Inn', 266, '2019-03-11', 148, NULL),
('The Paradise Inn', 266, '2019-03-12', 396, NULL),
('The Paradise Inn', 266, '2019-03-13', 300, NULL),
('The Paradise Inn', 266, '2019-03-14', 387, NULL),
('The Paradise Inn', 266, '2019-03-15', 224, NULL),
('The Paradise Inn', 266, '2019-03-16', 107, NULL),
('The Paradise Inn', 266, '2019-03-17', 139, NULL),
('The Paradise Inn', 266, '2019-03-18', 117, NULL),
('The Paradise Inn', 266, '2019-03-19', 323, NULL),
('The Paradise Inn', 266, '2019-03-20', 280, NULL),
('The Paradise Inn', 266, '2019-03-21', 289, NULL),
('The Paradise Inn', 266, '2019-03-22', 107, NULL),
('The Paradise Inn', 266, '2019-03-23', 251, NULL),
('The Paradise Inn', 266, '2019-03-24', 271, NULL),
('The Paradise Inn', 266, '2019-03-25', 292, NULL),
('The Paradise Inn', 266, '2019-03-26', 357, NULL),
('The Paradise Inn', 266, '2019-03-27', 369, NULL),
('The Paradise Inn', 266, '2019-03-28', 183, NULL),
('The Paradise Inn', 266, '2019-03-29', 102, NULL),
('The Paradise Inn', 266, '2019-03-30', 112, NULL),
('The Paradise Inn', 266, '2019-03-31', 398, NULL),
('The Paradise Inn', 266, '2019-04-01', 140, NULL),
('The Paradise Inn', 266, '2019-04-02', 290, NULL),
('The Paradise Inn', 266, '2019-04-03', 275, NULL),
('The Paradise Inn', 266, '2019-04-04', 168, NULL),
('The Paradise Inn', 266, '2019-04-05', 231, NULL),
('The Paradise Inn', 266, '2019-04-06', 321, NULL),
('The Paradise Inn', 266, '2019-04-07', 182, NULL),
('The Paradise Inn', 266, '2019-04-08', 335, NULL),
('The Paradise Inn', 266, '2019-04-09', 114, NULL),
('The Paradise Inn', 266, '2019-04-10', 334, NULL),
('The Paradise Inn', 266, '2019-04-11', 263, NULL),
('The Paradise Inn', 266, '2019-04-12', 148, NULL),
('The Paradise Inn', 266, '2019-04-13', 120, NULL),
('The Paradise Inn', 266, '2019-04-14', 264, NULL),
('The Paradise Inn', 266, '2019-04-15', 181, NULL),
('The Paradise Inn', 266, '2019-04-16', 240, NULL),
('The Paradise Inn', 266, '2019-04-17', 355, NULL),
('The Paradise Inn', 266, '2019-04-18', 205, NULL),
('The Paradise Inn', 266, '2019-04-19', 151, NULL),
('The Paradise Inn', 266, '2019-04-20', 130, NULL),
('The Paradise Inn', 266, '2019-04-21', 208, NULL),
('The Paradise Inn', 266, '2019-04-22', 287, NULL),
('The Paradise Inn', 266, '2019-04-23', 350, NULL),
('The Paradise Inn', 266, '2019-04-24', 113, NULL),
('The Paradise Inn', 266, '2019-04-25', 210, NULL),
('The Paradise Inn', 266, '2019-04-26', 207, NULL),
('The Paradise Inn', 266, '2019-04-27', 321, NULL),
('The Paradise Inn', 266, '2019-04-28', 188, NULL),
('The Paradise Inn', 266, '2019-04-29', 149, NULL),
('The Paradise Inn', 266, '2019-04-30', 246, NULL),
('The Paradise Inn', 266, '2019-05-01', 132, NULL),
('The Paradise Inn', 266, '2019-05-02', 123, NULL),
('The Paradise Inn', 266, '2019-05-03', 367, NULL),
('The Paradise Inn', 266, '2019-05-04', 110, NULL),
('The Paradise Inn', 266, '2019-05-05', 365, NULL),
('The Paradise Inn', 266, '2019-05-06', 226, NULL),
('The Paradise Inn', 266, '2019-05-07', 223, NULL),
('The Paradise Inn', 266, '2019-05-08', 132, NULL),
('The Paradise Inn', 266, '2019-05-09', 144, NULL),
('The Paradise Inn', 266, '2019-05-10', 229, NULL),
('The Paradise Inn', 266, '2019-05-11', 134, NULL),
('The Paradise Inn', 266, '2019-05-12', 171, NULL),
('The Paradise Inn', 266, '2019-05-13', 112, NULL),
('The Paradise Inn', 266, '2019-05-14', 295, NULL),
('The Paradise Inn', 266, '2019-05-15', 110, NULL),
('The Paradise Inn', 266, '2019-05-16', 236, NULL),
('The Paradise Inn', 266, '2019-05-17', 382, NULL),
('The Paradise Inn', 266, '2019-05-18', 375, NULL),
('The Paradise Inn', 266, '2019-05-19', 371, NULL),
('The Paradise Inn', 266, '2019-05-20', 293, NULL),
('The Paradise Inn', 266, '2019-05-21', 395, NULL),
('The Paradise Inn', 266, '2019-05-22', 355, NULL),
('The Paradise Inn', 266, '2019-05-23', 147, NULL),
('The Paradise Inn', 266, '2019-05-24', 332, NULL),
('The Paradise Inn', 266, '2019-05-25', 284, NULL),
('The Paradise Inn', 266, '2019-05-26', 202, NULL),
('The Paradise Inn', 266, '2019-05-27', 387, NULL),
('The Paradise Inn', 266, '2019-05-28', 193, NULL),
('The Paradise Inn', 266, '2019-05-29', 310, NULL),
('The Paradise Inn', 266, '2019-05-30', 220, NULL),
('The Paradise Inn', 266, '2019-05-31', 204, NULL),
('The Paradise Inn', 266, '2019-06-01', 267, NULL),
('The Paradise Inn', 266, '2019-06-02', 125, NULL),
('The Paradise Inn', 266, '2019-06-03', 211, NULL),
('The Paradise Inn', 266, '2019-06-04', 274, NULL),
('The Paradise Inn', 266, '2019-06-05', 287, NULL),
('The Paradise Inn', 266, '2019-06-06', 290, NULL),
('The Paradise Inn', 266, '2019-06-07', 301, NULL),
('The Paradise Inn', 266, '2019-06-08', 141, NULL),
('The Paradise Inn', 266, '2019-06-09', 147, NULL),
('The Paradise Inn', 266, '2019-06-10', 217, NULL),
('The Paradise Inn', 266, '2019-06-11', 124, NULL),
('The Paradise Inn', 266, '2019-06-12', 349, NULL),
('The Paradise Inn', 266, '2019-06-13', 381, NULL),
('The Paradise Inn', 266, '2019-06-14', 283, NULL),
('The Paradise Inn', 266, '2019-06-15', 226, NULL),
('The Paradise Inn', 266, '2019-06-16', 378, NULL),
('The Paradise Inn', 266, '2019-06-17', 141, NULL),
('The Paradise Inn', 266, '2019-06-18', 140, NULL),
('The Paradise Inn', 266, '2019-06-19', 292, NULL),
('The Paradise Inn', 266, '2019-06-20', 112, NULL),
('The Paradise Inn', 266, '2019-06-21', 116, NULL),
('The Paradise Inn', 266, '2019-06-22', 271, NULL),
('The Paradise Inn', 266, '2019-06-23', 390, NULL),
('The Paradise Inn', 266, '2019-06-24', 286, NULL),
('The Paradise Inn', 266, '2019-06-25', 114, NULL),
('The Paradise Inn', 266, '2019-06-26', 100, NULL),
('The Paradise Inn', 266, '2019-06-27', 284, NULL),
('The Paradise Inn', 266, '2019-06-28', 121, NULL),
('The Paradise Inn', 266, '2019-06-29', 366, NULL),
('The Paradise Inn', 266, '2019-06-30', 209, NULL),
('The Paradise Inn', 266, '2019-07-01', 193, NULL),
('The Paradise Inn', 266, '2019-07-02', 340, NULL),
('The Paradise Inn', 266, '2019-07-03', 376, NULL),
('The Paradise Inn', 266, '2019-07-04', 329, NULL),
('The Paradise Inn', 266, '2019-07-05', 362, NULL),
('The Paradise Inn', 266, '2019-07-06', 213, NULL),
('The Paradise Inn', 266, '2019-07-07', 105, NULL),
('The Paradise Inn', 266, '2019-07-08', 310, NULL),
('The Paradise Inn', 266, '2019-07-09', 232, NULL),
('The Paradise Inn', 266, '2019-07-10', 239, NULL),
('The Paradise Inn', 266, '2019-07-11', 184, NULL),
('The Paradise Inn', 266, '2019-07-12', 279, NULL),
('The Paradise Inn', 266, '2019-07-13', 314, NULL),
('The Paradise Inn', 266, '2019-07-14', 298, NULL),
('The Paradise Inn', 266, '2019-07-15', 312, NULL),
('The Paradise Inn', 266, '2019-07-16', 204, NULL),
('The Paradise Inn', 266, '2019-07-17', 159, NULL),
('The Paradise Inn', 266, '2019-07-18', 123, NULL),
('The Paradise Inn', 266, '2019-07-19', 101, NULL),
('The Paradise Inn', 266, '2019-07-20', 158, NULL),
('The Paradise Inn', 266, '2019-07-21', 269, NULL),
('The Paradise Inn', 266, '2019-07-22', 111, NULL),
('The Paradise Inn', 266, '2019-07-23', 342, NULL),
('The Paradise Inn', 266, '2019-07-24', 277, NULL),
('The Paradise Inn', 266, '2019-07-25', 382, NULL),
('The Paradise Inn', 266, '2019-07-26', 134, NULL),
('The Paradise Inn', 266, '2019-07-27', 336, NULL),
('The Paradise Inn', 266, '2019-07-28', 153, NULL),
('The Paradise Inn', 266, '2019-07-29', 234, NULL),
('The Paradise Inn', 266, '2019-07-30', 108, NULL),
('The Paradise Inn', 266, '2019-07-31', 134, NULL),
('The Paradise Inn', 266, '2019-08-01', 141, NULL),
('The Paradise Inn', 266, '2019-08-02', 388, NULL),
('The Paradise Inn', 266, '2019-08-03', 292, NULL),
('The Paradise Inn', 266, '2019-08-04', 389, NULL),
('The Paradise Inn', 266, '2019-08-05', 258, NULL),
('The Paradise Inn', 266, '2019-08-06', 301, NULL),
('The Paradise Inn', 266, '2019-08-07', 153, NULL),
('The Paradise Inn', 266, '2019-08-08', 367, NULL),
('The Paradise Inn', 266, '2019-08-09', 184, NULL),
('The Paradise Inn', 266, '2019-08-10', 188, NULL),
('The Paradise Inn', 266, '2019-08-11', 362, NULL),
('The Paradise Inn', 266, '2019-08-12', 280, NULL),
('The Paradise Inn', 266, '2019-08-13', 122, NULL),
('The Paradise Inn', 266, '2019-08-14', 182, NULL),
('The Paradise Inn', 266, '2019-08-15', 283, NULL),
('The Paradise Inn', 266, '2019-08-16', 168, NULL),
('The Paradise Inn', 266, '2019-08-17', 337, NULL),
('The Paradise Inn', 266, '2019-08-18', 161, NULL),
('The Paradise Inn', 266, '2019-08-19', 120, NULL),
('The Paradise Inn', 266, '2019-08-20', 314, NULL),
('The Paradise Inn', 266, '2019-08-21', 397, NULL),
('The Paradise Inn', 266, '2019-08-22', 172, NULL),
('The Paradise Inn', 266, '2019-08-23', 142, NULL),
('The Paradise Inn', 266, '2019-08-24', 339, NULL),
('The Paradise Inn', 266, '2019-08-25', 397, NULL),
('The Paradise Inn', 266, '2019-08-26', 114, NULL),
('The Paradise Inn', 266, '2019-08-27', 151, NULL),
('The Paradise Inn', 266, '2019-08-28', 308, NULL),
('The Paradise Inn', 266, '2019-08-29', 123, NULL),
('The Paradise Inn', 266, '2019-08-30', 137, NULL),
('The Paradise Inn', 266, '2019-08-31', 151, NULL),
('The Paradise Inn', 266, '2019-09-01', 141, NULL),
('The Paradise Inn', 266, '2019-09-02', 352, NULL),
('The Paradise Inn', 266, '2019-09-03', 130, NULL),
('The Paradise Inn', 266, '2019-09-04', 120, NULL),
('The Paradise Inn', 266, '2019-09-05', 366, NULL),
('The Paradise Inn', 266, '2019-09-06', 186, NULL),
('The Paradise Inn', 266, '2019-09-07', 365, NULL),
('The Paradise Inn', 266, '2019-09-08', 110, NULL),
('The Paradise Inn', 266, '2019-09-09', 104, NULL),
('The Paradise Inn', 266, '2019-09-10', 175, NULL),
('The Paradise Inn', 266, '2019-09-11', 257, NULL),
('The Paradise Inn', 266, '2019-09-12', 246, NULL),
('The Paradise Inn', 266, '2019-09-13', 367, NULL),
('The Paradise Inn', 266, '2019-09-14', 313, NULL),
('The Paradise Inn', 266, '2019-09-15', 269, NULL),
('The Paradise Inn', 266, '2019-09-16', 213, NULL),
('The Paradise Inn', 266, '2019-09-17', 320, NULL),
('The Paradise Inn', 266, '2019-09-18', 272, NULL),
('The Paradise Inn', 266, '2019-09-19', 175, NULL),
('The Paradise Inn', 266, '2019-09-20', 167, NULL),
('The Paradise Inn', 266, '2019-09-21', 152, NULL),
('The Paradise Inn', 266, '2019-09-22', 270, NULL),
('The Paradise Inn', 266, '2019-09-23', 252, NULL),
('The Paradise Inn', 266, '2019-09-24', 388, NULL),
('The Paradise Inn', 266, '2019-09-25', 368, NULL),
('The Paradise Inn', 266, '2019-09-26', 105, NULL),
('The Paradise Inn', 266, '2019-09-27', 332, NULL),
('The Paradise Inn', 266, '2019-09-28', 246, NULL),
('The Paradise Inn', 266, '2019-09-29', 237, NULL),
('The Paradise Inn', 266, '2019-09-30', 346, NULL),
('The Paradise Inn', 266, '2019-10-01', 265, NULL),
('The Paradise Inn', 266, '2019-10-02', 375, NULL),
('The Paradise Inn', 266, '2019-10-03', 357, NULL),
('The Paradise Inn', 266, '2019-10-04', 172, NULL),
('The Paradise Inn', 266, '2019-10-05', 249, NULL),
('The Paradise Inn', 266, '2019-10-06', 347, NULL),
('The Paradise Inn', 266, '2019-10-07', 102, NULL),
('The Paradise Inn', 266, '2019-10-08', 133, NULL),
('The Paradise Inn', 266, '2019-10-09', 272, NULL),
('The Paradise Inn', 266, '2019-10-10', 130, NULL),
('The Paradise Inn', 266, '2019-10-11', 157, NULL),
('The Paradise Inn', 266, '2019-10-12', 264, NULL),
('The Paradise Inn', 266, '2019-10-13', 271, NULL),
('The Paradise Inn', 266, '2019-10-14', 183, NULL),
('The Paradise Inn', 266, '2019-10-15', 149, NULL),
('The Paradise Inn', 266, '2019-10-16', 367, NULL),
('The Paradise Inn', 266, '2019-10-17', 240, NULL),
('The Paradise Inn', 266, '2019-10-18', 161, NULL),
('The Paradise Inn', 266, '2019-10-19', 242, NULL),
('The Paradise Inn', 266, '2019-10-20', 356, NULL),
('The Paradise Inn', 266, '2019-10-21', 315, NULL),
('The Paradise Inn', 266, '2019-10-22', 197, NULL),
('The Paradise Inn', 266, '2019-10-23', 233, NULL),
('The Paradise Inn', 266, '2019-10-24', 217, NULL),
('The Paradise Inn', 266, '2019-10-25', 170, NULL),
('The Paradise Inn', 266, '2019-10-26', 378, NULL),
('The Paradise Inn', 266, '2019-10-27', 337, NULL),
('The Paradise Inn', 266, '2019-10-28', 142, NULL),
('The Paradise Inn', 266, '2019-10-29', 200, NULL),
('The Paradise Inn', 266, '2019-10-30', 102, NULL),
('The Paradise Inn', 266, '2019-10-31', 319, NULL),
('The Paradise Inn', 266, '2019-11-01', 138, NULL),
('The Paradise Inn', 266, '2019-11-02', 324, NULL),
('The Paradise Inn', 266, '2019-11-03', 357, NULL),
('The Paradise Inn', 266, '2019-11-04', 336, NULL),
('The Paradise Inn', 266, '2019-11-05', 250, NULL),
('The Paradise Inn', 266, '2019-11-06', 150, NULL),
('The Paradise Inn', 266, '2019-11-07', 352, NULL),
('The Paradise Inn', 266, '2019-11-08', 271, NULL),
('The Paradise Inn', 266, '2019-11-09', 258, NULL),
('The Paradise Inn', 266, '2019-11-10', 196, NULL),
('The Paradise Inn', 266, '2019-11-11', 164, NULL),
('The Paradise Inn', 266, '2019-11-12', 322, NULL),
('The Paradise Inn', 266, '2019-11-13', 310, NULL),
('The Paradise Inn', 266, '2019-11-14', 190, NULL),
('The Paradise Inn', 266, '2019-11-15', 300, NULL),
('The Paradise Inn', 266, '2019-11-16', 269, NULL),
('The Paradise Inn', 266, '2019-11-17', 118, NULL),
('The Paradise Inn', 266, '2019-11-18', 271, NULL),
('The Paradise Inn', 266, '2019-11-19', 294, NULL),
('The Paradise Inn', 266, '2019-11-20', 108, NULL),
('The Paradise Inn', 266, '2019-11-21', 262, NULL),
('The Paradise Inn', 266, '2019-11-22', 212, NULL),
('The Paradise Inn', 266, '2019-11-23', 143, NULL),
('The Paradise Inn', 266, '2019-11-24', 335, NULL),
('The Paradise Inn', 266, '2019-11-25', 185, NULL),
('The Paradise Inn', 266, '2019-11-26', 101, NULL),
('The Paradise Inn', 266, '2019-11-27', 260, NULL),
('The Paradise Inn', 266, '2019-11-28', 201, NULL),
('The Paradise Inn', 266, '2019-11-29', 287, NULL),
('The Paradise Inn', 266, '2019-11-30', 201, NULL),
('The Paradise Inn', 266, '2019-12-01', 385, NULL),
('The Paradise Inn', 266, '2019-12-02', 127, NULL),
('The Paradise Inn', 266, '2019-12-03', 345, NULL),
('The Paradise Inn', 266, '2019-12-04', 372, NULL),
('The Paradise Inn', 266, '2019-12-05', 175, NULL),
('The Paradise Inn', 266, '2019-12-06', 110, NULL),
('The Paradise Inn', 266, '2019-12-07', 372, NULL),
('The Paradise Inn', 266, '2019-12-08', 222, NULL),
('The Paradise Inn', 266, '2019-12-09', 379, NULL),
('The Paradise Inn', 266, '2019-12-10', 119, NULL),
('The Paradise Inn', 266, '2019-12-11', 261, NULL),
('The Paradise Inn', 266, '2019-12-12', 300, NULL),
('The Paradise Inn', 266, '2019-12-13', 284, NULL),
('The Paradise Inn', 266, '2019-12-14', 384, NULL),
('The Paradise Inn', 266, '2019-12-15', 267, NULL),
('The Paradise Inn', 266, '2019-12-16', 186, NULL),
('The Paradise Inn', 266, '2019-12-17', 295, NULL),
('The Paradise Inn', 266, '2019-12-18', 242, NULL),
('The Paradise Inn', 266, '2019-12-19', 259, NULL),
('The Paradise Inn', 266, '2019-12-20', 324, NULL),
('The Paradise Inn', 266, '2019-12-21', 289, NULL),
('The Paradise Inn', 266, '2019-12-22', 243, NULL),
('The Paradise Inn', 266, '2019-12-23', 122, NULL),
('The Paradise Inn', 266, '2019-12-24', 106, NULL),
('The Paradise Inn', 266, '2019-12-25', 382, NULL),
('The Paradise Inn', 266, '2019-12-26', 377, NULL),
('The Paradise Inn', 266, '2019-12-27', 311, NULL),
('The Paradise Inn', 266, '2019-12-28', 313, NULL),
('The Paradise Inn', 266, '2019-12-29', 114, NULL),
('The Paradise Inn', 266, '2019-12-30', 142, NULL),
('The Paradise Inn', 266, '2019-12-31', 113, NULL),
('The Paradise Inn', 266, '2020-01-01', 396, NULL),
('The Paradise Inn', 266, '2020-01-02', 208, NULL),
('The Paradise Inn', 266, '2020-01-03', 366, NULL),
('The Paradise Inn', 266, '2020-01-04', 234, NULL),
('The Paradise Inn', 266, '2020-01-05', 368, NULL),
('The Paradise Inn', 266, '2020-01-06', 399, NULL),
('The Paradise Inn', 266, '2020-01-07', 137, NULL),
('The Paradise Inn', 266, '2020-01-08', 386, NULL),
('The Paradise Inn', 266, '2020-01-09', 175, NULL),
('The Paradise Inn', 266, '2020-01-10', 176, NULL),
('The Paradise Inn', 266, '2020-01-11', 386, NULL),
('The Paradise Inn', 266, '2020-01-12', 108, NULL),
('The Paradise Inn', 266, '2020-01-13', 361, NULL),
('The Paradise Inn', 266, '2020-01-14', 287, NULL),
('The Paradise Inn', 266, '2020-01-15', 134, NULL),
('The Paradise Inn', 266, '2020-01-16', 176, NULL),
('The Paradise Inn', 266, '2020-01-17', 205, NULL),
('The Paradise Inn', 266, '2020-01-18', 366, NULL),
('The Paradise Inn', 266, '2020-01-19', 267, NULL),
('The Paradise Inn', 266, '2020-01-20', 337, NULL),
('The Paradise Inn', 266, '2020-01-21', 216, NULL),
('The Paradise Inn', 266, '2020-01-22', 326, NULL),
('The Paradise Inn', 266, '2020-01-23', 130, NULL),
('The Paradise Inn', 266, '2020-01-24', 222, NULL),
('The Paradise Inn', 266, '2020-01-25', 271, NULL),
('The Paradise Inn', 266, '2020-01-26', 387, NULL),
('The Paradise Inn', 266, '2020-01-27', 113, NULL),
('The Paradise Inn', 266, '2020-01-28', 259, NULL),
('The Paradise Inn', 266, '2020-01-29', 377, NULL),
('The Paradise Inn', 266, '2020-01-30', 155, NULL),
('The Paradise Inn', 266, '2020-01-31', 226, NULL),
('The Paradise Inn', 266, '2020-02-01', 278, NULL),
('The Paradise Inn', 266, '2020-02-02', 353, NULL),
('The Paradise Inn', 266, '2020-02-03', 389, NULL),
('The Paradise Inn', 266, '2020-02-04', 299, NULL),
('The Paradise Inn', 279, '2019-01-01', 361, NULL),
('The Paradise Inn', 279, '2019-01-02', 121, NULL),
('The Paradise Inn', 279, '2019-01-03', 347, NULL),
('The Paradise Inn', 279, '2019-01-04', 274, NULL),
('The Paradise Inn', 279, '2019-01-05', 158, NULL),
('The Paradise Inn', 279, '2019-01-06', 296, NULL),
('The Paradise Inn', 279, '2019-01-07', 216, NULL),
('The Paradise Inn', 279, '2019-01-08', 178, NULL),
('The Paradise Inn', 279, '2019-01-09', 311, NULL),
('The Paradise Inn', 279, '2019-01-10', 146, NULL),
('The Paradise Inn', 279, '2019-01-11', 359, NULL),
('The Paradise Inn', 279, '2019-01-12', 358, NULL),
('The Paradise Inn', 279, '2019-01-13', 396, NULL),
('The Paradise Inn', 279, '2019-01-14', 370, NULL),
('The Paradise Inn', 279, '2019-01-15', 144, NULL),
('The Paradise Inn', 279, '2019-01-16', 345, NULL),
('The Paradise Inn', 279, '2019-01-17', 255, NULL),
('The Paradise Inn', 279, '2019-01-18', 106, NULL),
('The Paradise Inn', 279, '2019-01-19', 309, NULL),
('The Paradise Inn', 279, '2019-01-20', 350, NULL),
('The Paradise Inn', 279, '2019-01-21', 261, NULL),
('The Paradise Inn', 279, '2019-01-22', 337, NULL),
('The Paradise Inn', 279, '2019-01-23', 225, NULL),
('The Paradise Inn', 279, '2019-01-24', 357, NULL),
('The Paradise Inn', 279, '2019-01-25', 228, NULL),
('The Paradise Inn', 279, '2019-01-26', 135, NULL),
('The Paradise Inn', 279, '2019-01-27', 391, NULL),
('The Paradise Inn', 279, '2019-01-28', 387, NULL),
('The Paradise Inn', 279, '2019-01-29', 175, NULL),
('The Paradise Inn', 279, '2019-01-30', 208, NULL),
('The Paradise Inn', 279, '2019-01-31', 223, NULL),
('The Paradise Inn', 279, '2019-02-01', 256, NULL),
('The Paradise Inn', 279, '2019-02-02', 297, NULL),
('The Paradise Inn', 279, '2019-02-03', 358, NULL),
('The Paradise Inn', 279, '2019-02-04', 136, NULL),
('The Paradise Inn', 279, '2019-02-05', 273, NULL),
('The Paradise Inn', 279, '2019-02-06', 367, NULL),
('The Paradise Inn', 279, '2019-02-07', 257, NULL),
('The Paradise Inn', 279, '2019-02-08', 171, NULL),
('The Paradise Inn', 279, '2019-02-09', 245, NULL),
('The Paradise Inn', 279, '2019-02-10', 306, NULL),
('The Paradise Inn', 279, '2019-02-11', 112, NULL),
('The Paradise Inn', 279, '2019-02-12', 217, NULL),
('The Paradise Inn', 279, '2019-02-13', 238, NULL),
('The Paradise Inn', 279, '2019-02-14', 186, NULL),
('The Paradise Inn', 279, '2019-02-15', 153, NULL),
('The Paradise Inn', 279, '2019-02-16', 220, NULL),
('The Paradise Inn', 279, '2019-02-17', 245, NULL),
('The Paradise Inn', 279, '2019-02-18', 205, NULL),
('The Paradise Inn', 279, '2019-02-19', 193, NULL),
('The Paradise Inn', 279, '2019-02-20', 231, NULL),
('The Paradise Inn', 279, '2019-02-21', 311, NULL),
('The Paradise Inn', 279, '2019-02-22', 159, NULL),
('The Paradise Inn', 279, '2019-02-23', 154, NULL),
('The Paradise Inn', 279, '2019-02-24', 244, NULL),
('The Paradise Inn', 279, '2019-02-25', 368, NULL),
('The Paradise Inn', 279, '2019-02-26', 302, NULL),
('The Paradise Inn', 279, '2019-02-27', 327, NULL),
('The Paradise Inn', 279, '2019-02-28', 204, NULL),
('The Paradise Inn', 279, '2019-03-01', 160, NULL),
('The Paradise Inn', 279, '2019-03-02', 152, NULL),
('The Paradise Inn', 279, '2019-03-03', 247, NULL),
('The Paradise Inn', 279, '2019-03-04', 212, NULL),
('The Paradise Inn', 279, '2019-03-05', 359, NULL),
('The Paradise Inn', 279, '2019-03-06', 288, NULL),
('The Paradise Inn', 279, '2019-03-07', 170, NULL),
('The Paradise Inn', 279, '2019-03-08', 362, NULL),
('The Paradise Inn', 279, '2019-03-09', 194, NULL),
('The Paradise Inn', 279, '2019-03-10', 170, NULL),
('The Paradise Inn', 279, '2019-03-11', 233, NULL),
('The Paradise Inn', 279, '2019-03-12', 291, NULL),
('The Paradise Inn', 279, '2019-03-13', 222, NULL),
('The Paradise Inn', 279, '2019-03-14', 105, NULL),
('The Paradise Inn', 279, '2019-03-15', 159, NULL),
('The Paradise Inn', 279, '2019-03-16', 128, NULL),
('The Paradise Inn', 279, '2019-03-17', 197, NULL),
('The Paradise Inn', 279, '2019-03-18', 324, NULL),
('The Paradise Inn', 279, '2019-03-19', 258, NULL),
('The Paradise Inn', 279, '2019-03-20', 328, NULL),
('The Paradise Inn', 279, '2019-03-21', 182, NULL),
('The Paradise Inn', 279, '2019-03-22', 397, NULL),
('The Paradise Inn', 279, '2019-03-23', 348, NULL),
('The Paradise Inn', 279, '2019-03-24', 228, NULL),
('The Paradise Inn', 279, '2019-03-25', 238, NULL),
('The Paradise Inn', 279, '2019-03-26', 234, NULL),
('The Paradise Inn', 279, '2019-03-27', 272, NULL),
('The Paradise Inn', 279, '2019-03-28', 369, NULL),
('The Paradise Inn', 279, '2019-03-29', 305, NULL),
('The Paradise Inn', 279, '2019-03-30', 334, NULL),
('The Paradise Inn', 279, '2019-03-31', 348, NULL),
('The Paradise Inn', 279, '2019-04-01', 115, NULL),
('The Paradise Inn', 279, '2019-04-02', 163, NULL),
('The Paradise Inn', 279, '2019-04-03', 295, NULL),
('The Paradise Inn', 279, '2019-04-04', 119, NULL),
('The Paradise Inn', 279, '2019-04-05', 128, NULL),
('The Paradise Inn', 279, '2019-04-06', 169, NULL),
('The Paradise Inn', 279, '2019-04-07', 115, NULL),
('The Paradise Inn', 279, '2019-04-08', 201, NULL),
('The Paradise Inn', 279, '2019-04-09', 138, NULL),
('The Paradise Inn', 279, '2019-04-10', 390, NULL),
('The Paradise Inn', 279, '2019-04-11', 219, NULL),
('The Paradise Inn', 279, '2019-04-12', 272, NULL),
('The Paradise Inn', 279, '2019-04-13', 270, NULL),
('The Paradise Inn', 279, '2019-04-14', 197, NULL),
('The Paradise Inn', 279, '2019-04-15', 267, NULL),
('The Paradise Inn', 279, '2019-04-16', 254, NULL),
('The Paradise Inn', 279, '2019-04-17', 369, NULL),
('The Paradise Inn', 279, '2019-04-18', 344, NULL),
('The Paradise Inn', 279, '2019-04-19', 286, NULL),
('The Paradise Inn', 279, '2019-04-20', 137, NULL),
('The Paradise Inn', 279, '2019-04-21', 128, NULL),
('The Paradise Inn', 279, '2019-04-22', 364, NULL),
('The Paradise Inn', 279, '2019-04-23', 244, NULL),
('The Paradise Inn', 279, '2019-04-24', 137, NULL),
('The Paradise Inn', 279, '2019-04-25', 226, NULL),
('The Paradise Inn', 279, '2019-04-26', 146, NULL),
('The Paradise Inn', 279, '2019-04-27', 300, NULL),
('The Paradise Inn', 279, '2019-04-28', 127, NULL),
('The Paradise Inn', 279, '2019-04-29', 251, NULL),
('The Paradise Inn', 279, '2019-04-30', 155, NULL),
('The Paradise Inn', 279, '2019-05-01', 321, NULL),
('The Paradise Inn', 279, '2019-05-02', 323, NULL),
('The Paradise Inn', 279, '2019-05-03', 167, NULL),
('The Paradise Inn', 279, '2019-05-04', 369, NULL),
('The Paradise Inn', 279, '2019-05-05', 286, NULL),
('The Paradise Inn', 279, '2019-05-06', 176, NULL),
('The Paradise Inn', 279, '2019-05-07', 178, NULL),
('The Paradise Inn', 279, '2019-05-08', 125, NULL),
('The Paradise Inn', 279, '2019-05-09', 243, NULL),
('The Paradise Inn', 279, '2019-05-10', 302, NULL),
('The Paradise Inn', 279, '2019-05-11', 200, NULL),
('The Paradise Inn', 279, '2019-05-12', 198, NULL),
('The Paradise Inn', 279, '2019-05-13', 332, NULL),
('The Paradise Inn', 279, '2019-05-14', 137, NULL),
('The Paradise Inn', 279, '2019-05-15', 231, NULL),
('The Paradise Inn', 279, '2019-05-16', 145, NULL),
('The Paradise Inn', 279, '2019-05-17', 367, NULL),
('The Paradise Inn', 279, '2019-05-18', 253, NULL),
('The Paradise Inn', 279, '2019-05-19', 301, NULL),
('The Paradise Inn', 279, '2019-05-20', 221, NULL),
('The Paradise Inn', 279, '2019-05-21', 389, NULL),
('The Paradise Inn', 279, '2019-05-22', 177, NULL),
('The Paradise Inn', 279, '2019-05-23', 228, NULL),
('The Paradise Inn', 279, '2019-05-24', 297, NULL),
('The Paradise Inn', 279, '2019-05-25', 134, NULL),
('The Paradise Inn', 279, '2019-05-26', 162, NULL),
('The Paradise Inn', 279, '2019-05-27', 296, NULL),
('The Paradise Inn', 279, '2019-05-28', 362, NULL),
('The Paradise Inn', 279, '2019-05-29', 163, NULL),
('The Paradise Inn', 279, '2019-05-30', 216, NULL),
('The Paradise Inn', 279, '2019-05-31', 360, NULL),
('The Paradise Inn', 279, '2019-06-01', 169, NULL),
('The Paradise Inn', 279, '2019-06-02', 183, NULL),
('The Paradise Inn', 279, '2019-06-03', 224, NULL),
('The Paradise Inn', 279, '2019-06-04', 105, NULL),
('The Paradise Inn', 279, '2019-06-05', 130, NULL),
('The Paradise Inn', 279, '2019-06-06', 217, NULL),
('The Paradise Inn', 279, '2019-06-07', 173, NULL),
('The Paradise Inn', 279, '2019-06-08', 393, NULL),
('The Paradise Inn', 279, '2019-06-09', 142, NULL),
('The Paradise Inn', 279, '2019-06-10', 281, NULL),
('The Paradise Inn', 279, '2019-06-11', 184, NULL),
('The Paradise Inn', 279, '2019-06-12', 185, NULL),
('The Paradise Inn', 279, '2019-06-13', 352, NULL),
('The Paradise Inn', 279, '2019-06-14', 367, NULL),
('The Paradise Inn', 279, '2019-06-15', 343, NULL),
('The Paradise Inn', 279, '2019-06-16', 266, NULL),
('The Paradise Inn', 279, '2019-06-17', 310, NULL),
('The Paradise Inn', 279, '2019-06-18', 230, NULL),
('The Paradise Inn', 279, '2019-06-19', 278, NULL),
('The Paradise Inn', 279, '2019-06-20', 243, NULL),
('The Paradise Inn', 279, '2019-06-21', 176, NULL),
('The Paradise Inn', 279, '2019-06-22', 269, NULL),
('The Paradise Inn', 279, '2019-06-23', 280, NULL),
('The Paradise Inn', 279, '2019-06-24', 275, NULL),
('The Paradise Inn', 279, '2019-06-25', 292, NULL),
('The Paradise Inn', 279, '2019-06-26', 222, NULL),
('The Paradise Inn', 279, '2019-06-27', 189, NULL),
('The Paradise Inn', 279, '2019-06-28', 359, NULL),
('The Paradise Inn', 279, '2019-06-29', 249, NULL),
('The Paradise Inn', 279, '2019-06-30', 150, NULL),
('The Paradise Inn', 279, '2019-07-01', 359, NULL),
('The Paradise Inn', 279, '2019-07-02', 199, NULL),
('The Paradise Inn', 279, '2019-07-03', 328, NULL),
('The Paradise Inn', 279, '2019-07-04', 316, NULL),
('The Paradise Inn', 279, '2019-07-05', 354, NULL),
('The Paradise Inn', 279, '2019-07-06', 170, NULL),
('The Paradise Inn', 279, '2019-07-07', 136, NULL),
('The Paradise Inn', 279, '2019-07-08', 167, NULL),
('The Paradise Inn', 279, '2019-07-09', 105, NULL),
('The Paradise Inn', 279, '2019-07-10', 177, NULL),
('The Paradise Inn', 279, '2019-07-11', 204, NULL),
('The Paradise Inn', 279, '2019-07-12', 207, NULL),
('The Paradise Inn', 279, '2019-07-13', 134, NULL),
('The Paradise Inn', 279, '2019-07-14', 386, NULL),
('The Paradise Inn', 279, '2019-07-15', 330, NULL),
('The Paradise Inn', 279, '2019-07-16', 197, NULL),
('The Paradise Inn', 279, '2019-07-17', 398, NULL),
('The Paradise Inn', 279, '2019-07-18', 189, NULL),
('The Paradise Inn', 279, '2019-07-19', 384, NULL),
('The Paradise Inn', 279, '2019-07-20', 304, NULL),
('The Paradise Inn', 279, '2019-07-21', 324, NULL),
('The Paradise Inn', 279, '2019-07-22', 107, NULL),
('The Paradise Inn', 279, '2019-07-23', 211, NULL),
('The Paradise Inn', 279, '2019-07-24', 278, NULL),
('The Paradise Inn', 279, '2019-07-25', 326, NULL),
('The Paradise Inn', 279, '2019-07-26', 168, NULL),
('The Paradise Inn', 279, '2019-07-27', 316, NULL),
('The Paradise Inn', 279, '2019-07-28', 382, NULL),
('The Paradise Inn', 279, '2019-07-29', 131, NULL),
('The Paradise Inn', 279, '2019-07-30', 123, NULL),
('The Paradise Inn', 279, '2019-07-31', 261, NULL),
('The Paradise Inn', 279, '2019-08-01', 191, NULL),
('The Paradise Inn', 279, '2019-08-02', 139, NULL),
('The Paradise Inn', 279, '2019-08-03', 387, NULL),
('The Paradise Inn', 279, '2019-08-04', 186, NULL),
('The Paradise Inn', 279, '2019-08-05', 331, NULL),
('The Paradise Inn', 279, '2019-08-06', 261, NULL),
('The Paradise Inn', 279, '2019-08-07', 226, NULL),
('The Paradise Inn', 279, '2019-08-08', 181, NULL),
('The Paradise Inn', 279, '2019-08-09', 309, NULL),
('The Paradise Inn', 279, '2019-08-10', 222, NULL),
('The Paradise Inn', 279, '2019-08-11', 214, NULL),
('The Paradise Inn', 279, '2019-08-12', 271, NULL),
('The Paradise Inn', 279, '2019-08-13', 269, NULL),
('The Paradise Inn', 279, '2019-08-14', 245, NULL),
('The Paradise Inn', 279, '2019-08-15', 157, NULL),
('The Paradise Inn', 279, '2019-08-16', 205, NULL),
('The Paradise Inn', 279, '2019-08-17', 337, NULL),
('The Paradise Inn', 279, '2019-08-18', 388, NULL),
('The Paradise Inn', 279, '2019-08-19', 120, NULL),
('The Paradise Inn', 279, '2019-08-20', 184, NULL),
('The Paradise Inn', 279, '2019-08-21', 217, NULL),
('The Paradise Inn', 279, '2019-08-22', 333, NULL),
('The Paradise Inn', 279, '2019-08-23', 130, NULL),
('The Paradise Inn', 279, '2019-08-24', 284, NULL),
('The Paradise Inn', 279, '2019-08-25', 107, NULL),
('The Paradise Inn', 279, '2019-08-26', 216, NULL),
('The Paradise Inn', 279, '2019-08-27', 264, NULL),
('The Paradise Inn', 279, '2019-08-28', 353, NULL),
('The Paradise Inn', 279, '2019-08-29', 153, NULL),
('The Paradise Inn', 279, '2019-08-30', 139, NULL),
('The Paradise Inn', 279, '2019-08-31', 117, NULL),
('The Paradise Inn', 279, '2019-09-01', 176, NULL),
('The Paradise Inn', 279, '2019-09-02', 159, NULL),
('The Paradise Inn', 279, '2019-09-03', 359, NULL),
('The Paradise Inn', 279, '2019-09-04', 200, NULL),
('The Paradise Inn', 279, '2019-09-05', 308, NULL),
('The Paradise Inn', 279, '2019-09-06', 330, NULL),
('The Paradise Inn', 279, '2019-09-07', 244, NULL),
('The Paradise Inn', 279, '2019-09-08', 267, NULL),
('The Paradise Inn', 279, '2019-09-09', 201, NULL),
('The Paradise Inn', 279, '2019-09-10', 162, NULL),
('The Paradise Inn', 279, '2019-09-11', 105, NULL),
('The Paradise Inn', 279, '2019-09-12', 279, NULL),
('The Paradise Inn', 279, '2019-09-13', 101, NULL),
('The Paradise Inn', 279, '2019-09-14', 290, NULL),
('The Paradise Inn', 279, '2019-09-15', 135, NULL),
('The Paradise Inn', 279, '2019-09-16', 117, NULL),
('The Paradise Inn', 279, '2019-09-17', 180, NULL),
('The Paradise Inn', 279, '2019-09-18', 142, NULL),
('The Paradise Inn', 279, '2019-09-19', 348, NULL),
('The Paradise Inn', 279, '2019-09-20', 391, NULL),
('The Paradise Inn', 279, '2019-09-21', 234, NULL),
('The Paradise Inn', 279, '2019-09-22', 145, NULL),
('The Paradise Inn', 279, '2019-09-23', 111, NULL),
('The Paradise Inn', 279, '2019-09-24', 242, NULL),
('The Paradise Inn', 279, '2019-09-25', 270, NULL),
('The Paradise Inn', 279, '2019-09-26', 355, NULL),
('The Paradise Inn', 279, '2019-09-27', 315, NULL),
('The Paradise Inn', 279, '2019-09-28', 276, NULL),
('The Paradise Inn', 279, '2019-09-29', 118, NULL),
('The Paradise Inn', 279, '2019-09-30', 187, NULL),
('The Paradise Inn', 279, '2019-10-01', 190, NULL),
('The Paradise Inn', 279, '2019-10-02', 271, NULL),
('The Paradise Inn', 279, '2019-10-03', 146, NULL),
('The Paradise Inn', 279, '2019-10-04', 390, NULL),
('The Paradise Inn', 279, '2019-10-05', 198, NULL),
('The Paradise Inn', 279, '2019-10-06', 206, NULL),
('The Paradise Inn', 279, '2019-10-07', 245, NULL),
('The Paradise Inn', 279, '2019-10-08', 370, NULL),
('The Paradise Inn', 279, '2019-10-09', 213, NULL),
('The Paradise Inn', 279, '2019-10-10', 285, NULL),
('The Paradise Inn', 279, '2019-10-11', 121, NULL),
('The Paradise Inn', 279, '2019-10-12', 227, NULL),
('The Paradise Inn', 279, '2019-10-13', 362, NULL),
('The Paradise Inn', 279, '2019-10-14', 207, NULL),
('The Paradise Inn', 279, '2019-10-15', 199, NULL),
('The Paradise Inn', 279, '2019-10-16', 289, NULL),
('The Paradise Inn', 279, '2019-10-17', 157, NULL),
('The Paradise Inn', 279, '2019-10-18', 310, NULL),
('The Paradise Inn', 279, '2019-10-19', 218, NULL),
('The Paradise Inn', 279, '2019-10-20', 224, NULL),
('The Paradise Inn', 279, '2019-10-21', 176, NULL),
('The Paradise Inn', 279, '2019-10-22', 186, NULL),
('The Paradise Inn', 279, '2019-10-23', 205, NULL),
('The Paradise Inn', 279, '2019-10-24', 318, NULL),
('The Paradise Inn', 279, '2019-10-25', 147, NULL),
('The Paradise Inn', 279, '2019-10-26', 121, NULL),
('The Paradise Inn', 279, '2019-10-27', 243, NULL),
('The Paradise Inn', 279, '2019-10-28', 309, NULL),
('The Paradise Inn', 279, '2019-10-29', 113, NULL),
('The Paradise Inn', 279, '2019-10-30', 197, NULL),
('The Paradise Inn', 279, '2019-10-31', 315, NULL),
('The Paradise Inn', 279, '2019-11-01', 386, NULL),
('The Paradise Inn', 279, '2019-11-02', 195, NULL),
('The Paradise Inn', 279, '2019-11-03', 169, NULL),
('The Paradise Inn', 279, '2019-11-04', 257, NULL),
('The Paradise Inn', 279, '2019-11-05', 126, NULL),
('The Paradise Inn', 279, '2019-11-06', 390, NULL),
('The Paradise Inn', 279, '2019-11-07', 291, NULL),
('The Paradise Inn', 279, '2019-11-08', 129, NULL),
('The Paradise Inn', 279, '2019-11-09', 225, NULL),
('The Paradise Inn', 279, '2019-11-10', 273, NULL),
('The Paradise Inn', 279, '2019-11-11', 265, NULL),
('The Paradise Inn', 279, '2019-11-12', 299, NULL),
('The Paradise Inn', 279, '2019-11-13', 326, NULL),
('The Paradise Inn', 279, '2019-11-14', 123, NULL),
('The Paradise Inn', 279, '2019-11-15', 243, NULL),
('The Paradise Inn', 279, '2019-11-16', 307, NULL),
('The Paradise Inn', 279, '2019-11-17', 186, NULL),
('The Paradise Inn', 279, '2019-11-18', 228, NULL),
('The Paradise Inn', 279, '2019-11-19', 375, NULL),
('The Paradise Inn', 279, '2019-11-20', 290, NULL),
('The Paradise Inn', 279, '2019-11-21', 376, NULL),
('The Paradise Inn', 279, '2019-11-22', 110, NULL),
('The Paradise Inn', 279, '2019-11-23', 138, NULL),
('The Paradise Inn', 279, '2019-11-24', 245, NULL),
('The Paradise Inn', 279, '2019-11-25', 383, NULL),
('The Paradise Inn', 279, '2019-11-26', 321, NULL),
('The Paradise Inn', 279, '2019-11-27', 212, NULL),
('The Paradise Inn', 279, '2019-11-28', 354, NULL),
('The Paradise Inn', 279, '2019-11-29', 317, NULL),
('The Paradise Inn', 279, '2019-11-30', 105, NULL),
('The Paradise Inn', 279, '2019-12-01', 147, NULL),
('The Paradise Inn', 279, '2019-12-02', 260, NULL),
('The Paradise Inn', 279, '2019-12-03', 122, NULL),
('The Paradise Inn', 279, '2019-12-04', 320, NULL),
('The Paradise Inn', 279, '2019-12-05', 166, NULL),
('The Paradise Inn', 279, '2019-12-06', 159, NULL),
('The Paradise Inn', 279, '2019-12-07', 234, NULL),
('The Paradise Inn', 279, '2019-12-08', 114, NULL),
('The Paradise Inn', 279, '2019-12-09', 218, NULL),
('The Paradise Inn', 279, '2019-12-10', 394, NULL),
('The Paradise Inn', 279, '2019-12-11', 182, NULL),
('The Paradise Inn', 279, '2019-12-12', 147, NULL),
('The Paradise Inn', 279, '2019-12-13', 291, NULL),
('The Paradise Inn', 279, '2019-12-14', 174, NULL),
('The Paradise Inn', 279, '2019-12-15', 361, NULL),
('The Paradise Inn', 279, '2019-12-16', 195, NULL),
('The Paradise Inn', 279, '2019-12-17', 331, NULL),
('The Paradise Inn', 279, '2019-12-18', 167, NULL),
('The Paradise Inn', 279, '2019-12-19', 218, NULL),
('The Paradise Inn', 279, '2019-12-20', 216, NULL),
('The Paradise Inn', 279, '2019-12-21', 243, NULL),
('The Paradise Inn', 279, '2019-12-22', 204, NULL),
('The Paradise Inn', 279, '2019-12-23', 151, NULL),
('The Paradise Inn', 279, '2019-12-24', 376, NULL),
('The Paradise Inn', 279, '2019-12-25', 369, NULL),
('The Paradise Inn', 279, '2019-12-26', 195, NULL),
('The Paradise Inn', 279, '2019-12-27', 274, NULL),
('The Paradise Inn', 279, '2019-12-28', 182, NULL),
('The Paradise Inn', 279, '2019-12-29', 116, NULL),
('The Paradise Inn', 279, '2019-12-30', 272, NULL),
('The Paradise Inn', 279, '2019-12-31', 250, NULL),
('The Paradise Inn', 279, '2020-01-01', 171, NULL),
('The Paradise Inn', 279, '2020-01-02', 186, NULL),
('The Paradise Inn', 279, '2020-01-03', 141, NULL),
('The Paradise Inn', 279, '2020-01-04', 196, NULL),
('The Paradise Inn', 279, '2020-01-05', 242, NULL),
('The Paradise Inn', 279, '2020-01-06', 188, NULL),
('The Paradise Inn', 279, '2020-01-07', 215, NULL),
('The Paradise Inn', 279, '2020-01-08', 199, NULL),
('The Paradise Inn', 279, '2020-01-09', 115, NULL),
('The Paradise Inn', 279, '2020-01-10', 317, NULL),
('The Paradise Inn', 279, '2020-01-11', 271, NULL),
('The Paradise Inn', 279, '2020-01-12', 271, NULL),
('The Paradise Inn', 279, '2020-01-13', 128, NULL),
('The Paradise Inn', 279, '2020-01-14', 245, NULL),
('The Paradise Inn', 279, '2020-01-15', 190, NULL),
('The Paradise Inn', 279, '2020-01-16', 230, NULL),
('The Paradise Inn', 279, '2020-01-17', 236, NULL),
('The Paradise Inn', 279, '2020-01-18', 305, NULL),
('The Paradise Inn', 279, '2020-01-19', 160, NULL),
('The Paradise Inn', 279, '2020-01-20', 360, NULL),
('The Paradise Inn', 279, '2020-01-21', 375, NULL),
('The Paradise Inn', 279, '2020-01-22', 218, NULL),
('The Paradise Inn', 279, '2020-01-23', 228, NULL),
('The Paradise Inn', 279, '2020-01-24', 134, NULL),
('The Paradise Inn', 279, '2020-01-25', 218, NULL),
('The Paradise Inn', 279, '2020-01-26', 377, NULL),
('The Paradise Inn', 279, '2020-01-27', 252, NULL),
('The Paradise Inn', 279, '2020-01-28', 259, NULL),
('The Paradise Inn', 279, '2020-01-29', 181, NULL),
('The Paradise Inn', 279, '2020-01-30', 137, NULL),
('The Paradise Inn', 279, '2020-01-31', 167, NULL),
('The Paradise Inn', 279, '2020-02-01', 205, NULL),
('The Paradise Inn', 279, '2020-02-02', 194, NULL),
('The Paradise Inn', 279, '2020-02-03', 288, NULL),
('The Paradise Inn', 279, '2020-02-04', 233, NULL),
('The Paradise Inn', 290, '2019-01-01', 363, NULL),
('The Paradise Inn', 290, '2019-01-02', 367, NULL),
('The Paradise Inn', 290, '2019-01-03', 257, NULL),
('The Paradise Inn', 290, '2019-01-04', 160, NULL),
('The Paradise Inn', 290, '2019-01-05', 234, NULL),
('The Paradise Inn', 290, '2019-01-06', 389, NULL),
('The Paradise Inn', 290, '2019-01-07', 141, NULL),
('The Paradise Inn', 290, '2019-01-08', 179, NULL),
('The Paradise Inn', 290, '2019-01-09', 289, NULL),
('The Paradise Inn', 290, '2019-01-10', 249, NULL),
('The Paradise Inn', 290, '2019-01-11', 257, NULL),
('The Paradise Inn', 290, '2019-01-12', 108, NULL),
('The Paradise Inn', 290, '2019-01-13', 196, NULL),
('The Paradise Inn', 290, '2019-01-14', 164, NULL),
('The Paradise Inn', 290, '2019-01-15', 273, NULL),
('The Paradise Inn', 290, '2019-01-16', 354, NULL),
('The Paradise Inn', 290, '2019-01-17', 309, NULL),
('The Paradise Inn', 290, '2019-01-18', 170, NULL),
('The Paradise Inn', 290, '2019-01-19', 346, NULL),
('The Paradise Inn', 290, '2019-01-20', 139, NULL),
('The Paradise Inn', 290, '2019-01-21', 223, NULL),
('The Paradise Inn', 290, '2019-01-22', 261, NULL),
('The Paradise Inn', 290, '2019-01-23', 259, NULL),
('The Paradise Inn', 290, '2019-01-24', 100, NULL),
('The Paradise Inn', 290, '2019-01-25', 175, NULL),
('The Paradise Inn', 290, '2019-01-26', 392, NULL),
('The Paradise Inn', 290, '2019-01-27', 170, NULL),
('The Paradise Inn', 290, '2019-01-28', 275, NULL),
('The Paradise Inn', 290, '2019-01-29', 311, NULL),
('The Paradise Inn', 290, '2019-01-30', 247, NULL),
('The Paradise Inn', 290, '2019-01-31', 113, NULL),
('The Paradise Inn', 290, '2019-02-01', 148, NULL),
('The Paradise Inn', 290, '2019-02-02', 307, NULL),
('The Paradise Inn', 290, '2019-02-03', 275, NULL),
('The Paradise Inn', 290, '2019-02-04', 360, NULL),
('The Paradise Inn', 290, '2019-02-05', 286, NULL),
('The Paradise Inn', 290, '2019-02-06', 191, NULL),
('The Paradise Inn', 290, '2019-02-07', 303, NULL),
('The Paradise Inn', 290, '2019-02-08', 273, NULL),
('The Paradise Inn', 290, '2019-02-09', 198, NULL),
('The Paradise Inn', 290, '2019-02-10', 185, NULL),
('The Paradise Inn', 290, '2019-02-11', 350, NULL),
('The Paradise Inn', 290, '2019-02-12', 345, NULL),
('The Paradise Inn', 290, '2019-02-13', 227, NULL),
('The Paradise Inn', 290, '2019-02-14', 265, NULL),
('The Paradise Inn', 290, '2019-02-15', 275, NULL),
('The Paradise Inn', 290, '2019-02-16', 347, NULL),
('The Paradise Inn', 290, '2019-02-17', 272, NULL),
('The Paradise Inn', 290, '2019-02-18', 264, NULL),
('The Paradise Inn', 290, '2019-02-19', 326, NULL),
('The Paradise Inn', 290, '2019-02-20', 330, NULL),
('The Paradise Inn', 290, '2019-02-21', 305, NULL),
('The Paradise Inn', 290, '2019-02-22', 227, NULL),
('The Paradise Inn', 290, '2019-02-23', 209, NULL),
('The Paradise Inn', 290, '2019-02-24', 341, NULL),
('The Paradise Inn', 290, '2019-02-25', 253, NULL),
('The Paradise Inn', 290, '2019-02-26', 376, NULL),
('The Paradise Inn', 290, '2019-02-27', 109, NULL),
('The Paradise Inn', 290, '2019-02-28', 298, NULL),
('The Paradise Inn', 290, '2019-03-01', 124, NULL),
('The Paradise Inn', 290, '2019-03-02', 152, NULL),
('The Paradise Inn', 290, '2019-03-03', 289, NULL),
('The Paradise Inn', 290, '2019-03-04', 384, NULL),
('The Paradise Inn', 290, '2019-03-05', 238, NULL),
('The Paradise Inn', 290, '2019-03-06', 367, NULL),
('The Paradise Inn', 290, '2019-03-07', 396, NULL),
('The Paradise Inn', 290, '2019-03-08', 306, NULL),
('The Paradise Inn', 290, '2019-03-09', 219, NULL),
('The Paradise Inn', 290, '2019-03-10', 302, NULL),
('The Paradise Inn', 290, '2019-03-11', 321, NULL),
('The Paradise Inn', 290, '2019-03-12', 168, NULL),
('The Paradise Inn', 290, '2019-03-13', 113, NULL),
('The Paradise Inn', 290, '2019-03-14', 165, NULL),
('The Paradise Inn', 290, '2019-03-15', 325, NULL),
('The Paradise Inn', 290, '2019-03-16', 217, NULL),
('The Paradise Inn', 290, '2019-03-17', 167, NULL),
('The Paradise Inn', 290, '2019-03-18', 270, NULL),
('The Paradise Inn', 290, '2019-03-19', 222, NULL),
('The Paradise Inn', 290, '2019-03-20', 101, NULL),
('The Paradise Inn', 290, '2019-03-21', 242, NULL),
('The Paradise Inn', 290, '2019-03-22', 368, NULL),
('The Paradise Inn', 290, '2019-03-23', 285, NULL),
('The Paradise Inn', 290, '2019-03-24', 227, NULL),
('The Paradise Inn', 290, '2019-03-25', 216, NULL),
('The Paradise Inn', 290, '2019-03-26', 298, NULL),
('The Paradise Inn', 290, '2019-03-27', 153, NULL),
('The Paradise Inn', 290, '2019-03-28', 298, NULL),
('The Paradise Inn', 290, '2019-03-29', 219, NULL),
('The Paradise Inn', 290, '2019-03-30', 334, NULL),
('The Paradise Inn', 290, '2019-03-31', 148, NULL),
('The Paradise Inn', 290, '2019-04-01', 356, NULL),
('The Paradise Inn', 290, '2019-04-02', 144, NULL),
('The Paradise Inn', 290, '2019-04-03', 250, NULL),
('The Paradise Inn', 290, '2019-04-04', 291, NULL),
('The Paradise Inn', 290, '2019-04-05', 148, NULL),
('The Paradise Inn', 290, '2019-04-06', 383, NULL),
('The Paradise Inn', 290, '2019-04-07', 231, NULL),
('The Paradise Inn', 290, '2019-04-08', 198, NULL),
('The Paradise Inn', 290, '2019-04-09', 245, NULL),
('The Paradise Inn', 290, '2019-04-10', 246, NULL),
('The Paradise Inn', 290, '2019-04-11', 204, NULL),
('The Paradise Inn', 290, '2019-04-12', 217, NULL),
('The Paradise Inn', 290, '2019-04-13', 292, NULL),
('The Paradise Inn', 290, '2019-04-14', 396, NULL),
('The Paradise Inn', 290, '2019-04-15', 392, NULL),
('The Paradise Inn', 290, '2019-04-16', 152, NULL),
('The Paradise Inn', 290, '2019-04-17', 384, NULL),
('The Paradise Inn', 290, '2019-04-18', 103, NULL),
('The Paradise Inn', 290, '2019-04-19', 277, NULL),
('The Paradise Inn', 290, '2019-04-20', 196, NULL),
('The Paradise Inn', 290, '2019-04-21', 216, NULL),
('The Paradise Inn', 290, '2019-04-22', 257, NULL),
('The Paradise Inn', 290, '2019-04-23', 368, NULL),
('The Paradise Inn', 290, '2019-04-24', 246, NULL),
('The Paradise Inn', 290, '2019-04-25', 102, NULL),
('The Paradise Inn', 290, '2019-04-26', 309, NULL),
('The Paradise Inn', 290, '2019-04-27', 140, NULL),
('The Paradise Inn', 290, '2019-04-28', 274, NULL),
('The Paradise Inn', 290, '2019-04-29', 108, NULL),
('The Paradise Inn', 290, '2019-04-30', 237, NULL),
('The Paradise Inn', 290, '2019-05-01', 212, NULL),
('The Paradise Inn', 290, '2019-05-02', 245, NULL),
('The Paradise Inn', 290, '2019-05-03', 234, NULL),
('The Paradise Inn', 290, '2019-05-04', 212, NULL),
('The Paradise Inn', 290, '2019-05-05', 238, NULL),
('The Paradise Inn', 290, '2019-05-06', 103, NULL),
('The Paradise Inn', 290, '2019-05-07', 123, NULL),
('The Paradise Inn', 290, '2019-05-08', 128, NULL),
('The Paradise Inn', 290, '2019-05-09', 385, NULL),
('The Paradise Inn', 290, '2019-05-10', 127, NULL),
('The Paradise Inn', 290, '2019-05-11', 199, NULL),
('The Paradise Inn', 290, '2019-05-12', 379, NULL),
('The Paradise Inn', 290, '2019-05-13', 327, NULL),
('The Paradise Inn', 290, '2019-05-14', 301, NULL),
('The Paradise Inn', 290, '2019-05-15', 127, NULL),
('The Paradise Inn', 290, '2019-05-16', 220, NULL),
('The Paradise Inn', 290, '2019-05-17', 292, NULL),
('The Paradise Inn', 290, '2019-05-18', 341, NULL),
('The Paradise Inn', 290, '2019-05-19', 291, NULL),
('The Paradise Inn', 290, '2019-05-20', 124, NULL),
('The Paradise Inn', 290, '2019-05-21', 360, NULL),
('The Paradise Inn', 290, '2019-05-22', 318, NULL),
('The Paradise Inn', 290, '2019-05-23', 300, NULL),
('The Paradise Inn', 290, '2019-05-24', 388, NULL),
('The Paradise Inn', 290, '2019-05-25', 319, NULL),
('The Paradise Inn', 290, '2019-05-26', 102, NULL),
('The Paradise Inn', 290, '2019-05-27', 223, NULL),
('The Paradise Inn', 290, '2019-05-28', 233, NULL),
('The Paradise Inn', 290, '2019-05-29', 386, NULL),
('The Paradise Inn', 290, '2019-05-30', 320, NULL),
('The Paradise Inn', 290, '2019-05-31', 191, NULL),
('The Paradise Inn', 290, '2019-06-01', 243, NULL),
('The Paradise Inn', 290, '2019-06-02', 143, NULL),
('The Paradise Inn', 290, '2019-06-03', 390, NULL),
('The Paradise Inn', 290, '2019-06-04', 204, NULL),
('The Paradise Inn', 290, '2019-06-05', 288, NULL),
('The Paradise Inn', 290, '2019-06-06', 116, NULL),
('The Paradise Inn', 290, '2019-06-07', 161, NULL),
('The Paradise Inn', 290, '2019-06-08', 243, NULL),
('The Paradise Inn', 290, '2019-06-09', 171, NULL),
('The Paradise Inn', 290, '2019-06-10', 355, NULL),
('The Paradise Inn', 290, '2019-06-11', 147, NULL),
('The Paradise Inn', 290, '2019-06-12', 379, NULL),
('The Paradise Inn', 290, '2019-06-13', 216, NULL),
('The Paradise Inn', 290, '2019-06-14', 283, NULL),
('The Paradise Inn', 290, '2019-06-15', 337, NULL),
('The Paradise Inn', 290, '2019-06-16', 396, NULL),
('The Paradise Inn', 290, '2019-06-17', 127, NULL),
('The Paradise Inn', 290, '2019-06-18', 333, NULL),
('The Paradise Inn', 290, '2019-06-19', 114, NULL),
('The Paradise Inn', 290, '2019-06-20', 181, NULL),
('The Paradise Inn', 290, '2019-06-21', 132, NULL),
('The Paradise Inn', 290, '2019-06-22', 135, NULL),
('The Paradise Inn', 290, '2019-06-23', 133, NULL),
('The Paradise Inn', 290, '2019-06-24', 115, NULL),
('The Paradise Inn', 290, '2019-06-25', 119, NULL),
('The Paradise Inn', 290, '2019-06-26', 110, NULL),
('The Paradise Inn', 290, '2019-06-27', 296, NULL),
('The Paradise Inn', 290, '2019-06-28', 135, NULL),
('The Paradise Inn', 290, '2019-06-29', 348, NULL),
('The Paradise Inn', 290, '2019-06-30', 324, NULL),
('The Paradise Inn', 290, '2019-07-01', 219, NULL),
('The Paradise Inn', 290, '2019-07-02', 176, NULL),
('The Paradise Inn', 290, '2019-07-03', 110, NULL),
('The Paradise Inn', 290, '2019-07-04', 195, NULL),
('The Paradise Inn', 290, '2019-07-05', 284, NULL),
('The Paradise Inn', 290, '2019-07-06', 112, NULL),
('The Paradise Inn', 290, '2019-07-07', 264, NULL),
('The Paradise Inn', 290, '2019-07-08', 107, NULL),
('The Paradise Inn', 290, '2019-07-09', 331, NULL),
('The Paradise Inn', 290, '2019-07-10', 365, NULL),
('The Paradise Inn', 290, '2019-07-11', 369, NULL),
('The Paradise Inn', 290, '2019-07-12', 101, NULL),
('The Paradise Inn', 290, '2019-07-13', 229, NULL),
('The Paradise Inn', 290, '2019-07-14', 338, NULL),
('The Paradise Inn', 290, '2019-07-15', 314, NULL),
('The Paradise Inn', 290, '2019-07-16', 274, NULL),
('The Paradise Inn', 290, '2019-07-17', 215, NULL),
('The Paradise Inn', 290, '2019-07-18', 175, NULL),
('The Paradise Inn', 290, '2019-07-19', 319, NULL),
('The Paradise Inn', 290, '2019-07-20', 346, NULL),
('The Paradise Inn', 290, '2019-07-21', 116, NULL),
('The Paradise Inn', 290, '2019-07-22', 101, NULL),
('The Paradise Inn', 290, '2019-07-23', 229, NULL),
('The Paradise Inn', 290, '2019-07-24', 162, NULL),
('The Paradise Inn', 290, '2019-07-25', 382, NULL),
('The Paradise Inn', 290, '2019-07-26', 335, NULL),
('The Paradise Inn', 290, '2019-07-27', 170, NULL),
('The Paradise Inn', 290, '2019-07-28', 152, NULL),
('The Paradise Inn', 290, '2019-07-29', 151, NULL),
('The Paradise Inn', 290, '2019-07-30', 189, NULL),
('The Paradise Inn', 290, '2019-07-31', 205, NULL),
('The Paradise Inn', 290, '2019-08-01', 132, NULL),
('The Paradise Inn', 290, '2019-08-02', 332, NULL),
('The Paradise Inn', 290, '2019-08-03', 358, NULL),
('The Paradise Inn', 290, '2019-08-04', 266, NULL),
('The Paradise Inn', 290, '2019-08-05', 182, NULL),
('The Paradise Inn', 290, '2019-08-06', 303, NULL),
('The Paradise Inn', 290, '2019-08-07', 274, NULL),
('The Paradise Inn', 290, '2019-08-08', 304, NULL),
('The Paradise Inn', 290, '2019-08-09', 292, NULL),
('The Paradise Inn', 290, '2019-08-10', 148, NULL),
('The Paradise Inn', 290, '2019-08-11', 184, NULL),
('The Paradise Inn', 290, '2019-08-12', 116, NULL),
('The Paradise Inn', 290, '2019-08-13', 280, NULL),
('The Paradise Inn', 290, '2019-08-14', 281, NULL),
('The Paradise Inn', 290, '2019-08-15', 133, NULL),
('The Paradise Inn', 290, '2019-08-16', 125, NULL),
('The Paradise Inn', 290, '2019-08-17', 277, NULL),
('The Paradise Inn', 290, '2019-08-18', 160, NULL),
('The Paradise Inn', 290, '2019-08-19', 141, NULL),
('The Paradise Inn', 290, '2019-08-20', 177, NULL),
('The Paradise Inn', 290, '2019-08-21', 393, NULL),
('The Paradise Inn', 290, '2019-08-22', 147, NULL),
('The Paradise Inn', 290, '2019-08-23', 125, NULL),
('The Paradise Inn', 290, '2019-08-24', 304, NULL),
('The Paradise Inn', 290, '2019-08-25', 144, NULL),
('The Paradise Inn', 290, '2019-08-26', 340, NULL),
('The Paradise Inn', 290, '2019-08-27', 168, NULL),
('The Paradise Inn', 290, '2019-08-28', 140, NULL),
('The Paradise Inn', 290, '2019-08-29', 298, NULL),
('The Paradise Inn', 290, '2019-08-30', 188, NULL),
('The Paradise Inn', 290, '2019-08-31', 334, NULL),
('The Paradise Inn', 290, '2019-09-01', 357, NULL),
('The Paradise Inn', 290, '2019-09-02', 239, NULL),
('The Paradise Inn', 290, '2019-09-03', 106, NULL),
('The Paradise Inn', 290, '2019-09-04', 240, NULL),
('The Paradise Inn', 290, '2019-09-05', 342, NULL);
INSERT INTO `room_date` (`property_name`, `room_num`, `_date`, `rate`, `reservation_id`) VALUES
('The Paradise Inn', 290, '2019-09-06', 392, NULL),
('The Paradise Inn', 290, '2019-09-07', 324, NULL),
('The Paradise Inn', 290, '2019-09-08', 306, NULL),
('The Paradise Inn', 290, '2019-09-09', 293, NULL),
('The Paradise Inn', 290, '2019-09-10', 185, NULL),
('The Paradise Inn', 290, '2019-09-11', 253, NULL),
('The Paradise Inn', 290, '2019-09-12', 256, NULL),
('The Paradise Inn', 290, '2019-09-13', 204, NULL),
('The Paradise Inn', 290, '2019-09-14', 111, NULL),
('The Paradise Inn', 290, '2019-09-15', 368, NULL),
('The Paradise Inn', 290, '2019-09-16', 150, NULL),
('The Paradise Inn', 290, '2019-09-17', 141, NULL),
('The Paradise Inn', 290, '2019-09-18', 396, NULL),
('The Paradise Inn', 290, '2019-09-19', 215, NULL),
('The Paradise Inn', 290, '2019-09-20', 157, NULL),
('The Paradise Inn', 290, '2019-09-21', 315, NULL),
('The Paradise Inn', 290, '2019-09-22', 118, NULL),
('The Paradise Inn', 290, '2019-09-23', 299, NULL),
('The Paradise Inn', 290, '2019-09-24', 245, NULL),
('The Paradise Inn', 290, '2019-09-25', 149, NULL),
('The Paradise Inn', 290, '2019-09-26', 159, NULL),
('The Paradise Inn', 290, '2019-09-27', 181, NULL),
('The Paradise Inn', 290, '2019-09-28', 244, NULL),
('The Paradise Inn', 290, '2019-09-29', 376, NULL),
('The Paradise Inn', 290, '2019-09-30', 395, NULL),
('The Paradise Inn', 290, '2019-10-01', 356, NULL),
('The Paradise Inn', 290, '2019-10-02', 132, NULL),
('The Paradise Inn', 290, '2019-10-03', 159, NULL),
('The Paradise Inn', 290, '2019-10-04', 136, NULL),
('The Paradise Inn', 290, '2019-10-05', 142, NULL),
('The Paradise Inn', 290, '2019-10-06', 190, NULL),
('The Paradise Inn', 290, '2019-10-07', 222, NULL),
('The Paradise Inn', 290, '2019-10-08', 149, NULL),
('The Paradise Inn', 290, '2019-10-09', 150, NULL),
('The Paradise Inn', 290, '2019-10-10', 337, NULL),
('The Paradise Inn', 290, '2019-10-11', 333, NULL),
('The Paradise Inn', 290, '2019-10-12', 242, NULL),
('The Paradise Inn', 290, '2019-10-13', 299, NULL),
('The Paradise Inn', 290, '2019-10-14', 387, NULL),
('The Paradise Inn', 290, '2019-10-15', 151, NULL),
('The Paradise Inn', 290, '2019-10-16', 244, NULL),
('The Paradise Inn', 290, '2019-10-17', 263, NULL),
('The Paradise Inn', 290, '2019-10-18', 368, NULL),
('The Paradise Inn', 290, '2019-10-19', 267, NULL),
('The Paradise Inn', 290, '2019-10-20', 252, NULL),
('The Paradise Inn', 290, '2019-10-21', 137, NULL),
('The Paradise Inn', 290, '2019-10-22', 237, NULL),
('The Paradise Inn', 290, '2019-10-23', 229, NULL),
('The Paradise Inn', 290, '2019-10-24', 237, NULL),
('The Paradise Inn', 290, '2019-10-25', 127, NULL),
('The Paradise Inn', 290, '2019-10-26', 270, NULL),
('The Paradise Inn', 290, '2019-10-27', 106, NULL),
('The Paradise Inn', 290, '2019-10-28', 116, NULL),
('The Paradise Inn', 290, '2019-10-29', 165, NULL),
('The Paradise Inn', 290, '2019-10-30', 281, NULL),
('The Paradise Inn', 290, '2019-10-31', 216, NULL),
('The Paradise Inn', 290, '2019-11-01', 216, NULL),
('The Paradise Inn', 290, '2019-11-02', 202, NULL),
('The Paradise Inn', 290, '2019-11-03', 277, NULL),
('The Paradise Inn', 290, '2019-11-04', 180, NULL),
('The Paradise Inn', 290, '2019-11-05', 380, NULL),
('The Paradise Inn', 290, '2019-11-06', 201, NULL),
('The Paradise Inn', 290, '2019-11-07', 302, NULL),
('The Paradise Inn', 290, '2019-11-08', 332, NULL),
('The Paradise Inn', 290, '2019-11-09', 253, NULL),
('The Paradise Inn', 290, '2019-11-10', 377, NULL),
('The Paradise Inn', 290, '2019-11-11', 134, NULL),
('The Paradise Inn', 290, '2019-11-12', 128, NULL),
('The Paradise Inn', 290, '2019-11-13', 301, NULL),
('The Paradise Inn', 290, '2019-11-14', 246, NULL),
('The Paradise Inn', 290, '2019-11-15', 217, NULL),
('The Paradise Inn', 290, '2019-11-16', 331, NULL),
('The Paradise Inn', 290, '2019-11-17', 179, NULL),
('The Paradise Inn', 290, '2019-11-18', 225, NULL),
('The Paradise Inn', 290, '2019-11-19', 290, NULL),
('The Paradise Inn', 290, '2019-11-20', 125, NULL),
('The Paradise Inn', 290, '2019-11-21', 394, NULL),
('The Paradise Inn', 290, '2019-11-22', 113, NULL),
('The Paradise Inn', 290, '2019-11-23', 160, NULL),
('The Paradise Inn', 290, '2019-11-24', 122, NULL),
('The Paradise Inn', 290, '2019-11-25', 363, NULL),
('The Paradise Inn', 290, '2019-11-26', 303, NULL),
('The Paradise Inn', 290, '2019-11-27', 179, NULL),
('The Paradise Inn', 290, '2019-11-28', 167, NULL),
('The Paradise Inn', 290, '2019-11-29', 323, NULL),
('The Paradise Inn', 290, '2019-11-30', 122, NULL),
('The Paradise Inn', 290, '2019-12-01', 382, NULL),
('The Paradise Inn', 290, '2019-12-02', 221, NULL),
('The Paradise Inn', 290, '2019-12-03', 375, NULL),
('The Paradise Inn', 290, '2019-12-04', 386, NULL),
('The Paradise Inn', 290, '2019-12-05', 205, NULL),
('The Paradise Inn', 290, '2019-12-06', 366, NULL),
('The Paradise Inn', 290, '2019-12-07', 254, NULL),
('The Paradise Inn', 290, '2019-12-08', 105, NULL),
('The Paradise Inn', 290, '2019-12-09', 155, NULL),
('The Paradise Inn', 290, '2019-12-10', 314, NULL),
('The Paradise Inn', 290, '2019-12-11', 330, NULL),
('The Paradise Inn', 290, '2019-12-12', 336, NULL),
('The Paradise Inn', 290, '2019-12-13', 205, NULL),
('The Paradise Inn', 290, '2019-12-14', 216, NULL),
('The Paradise Inn', 290, '2019-12-15', 306, NULL),
('The Paradise Inn', 290, '2019-12-16', 315, NULL),
('The Paradise Inn', 290, '2019-12-17', 373, NULL),
('The Paradise Inn', 290, '2019-12-18', 313, NULL),
('The Paradise Inn', 290, '2019-12-19', 216, NULL),
('The Paradise Inn', 290, '2019-12-20', 309, NULL),
('The Paradise Inn', 290, '2019-12-21', 246, NULL),
('The Paradise Inn', 290, '2019-12-22', 191, NULL),
('The Paradise Inn', 290, '2019-12-23', 290, NULL),
('The Paradise Inn', 290, '2019-12-24', 264, NULL),
('The Paradise Inn', 290, '2019-12-25', 298, NULL),
('The Paradise Inn', 290, '2019-12-26', 347, NULL),
('The Paradise Inn', 290, '2019-12-27', 338, NULL),
('The Paradise Inn', 290, '2019-12-28', 168, NULL),
('The Paradise Inn', 290, '2019-12-29', 140, NULL),
('The Paradise Inn', 290, '2019-12-30', 234, NULL),
('The Paradise Inn', 290, '2019-12-31', 210, NULL),
('The Paradise Inn', 290, '2020-01-01', 168, NULL),
('The Paradise Inn', 290, '2020-01-02', 205, NULL),
('The Paradise Inn', 290, '2020-01-03', 106, NULL),
('The Paradise Inn', 290, '2020-01-04', 179, NULL),
('The Paradise Inn', 290, '2020-01-05', 307, NULL),
('The Paradise Inn', 290, '2020-01-06', 245, NULL),
('The Paradise Inn', 290, '2020-01-07', 268, NULL),
('The Paradise Inn', 290, '2020-01-08', 338, NULL),
('The Paradise Inn', 290, '2020-01-09', 251, NULL),
('The Paradise Inn', 290, '2020-01-10', 360, NULL),
('The Paradise Inn', 290, '2020-01-11', 395, NULL),
('The Paradise Inn', 290, '2020-01-12', 331, NULL),
('The Paradise Inn', 290, '2020-01-13', 356, NULL),
('The Paradise Inn', 290, '2020-01-14', 263, NULL),
('The Paradise Inn', 290, '2020-01-15', 151, NULL),
('The Paradise Inn', 290, '2020-01-16', 222, NULL),
('The Paradise Inn', 290, '2020-01-17', 169, NULL),
('The Paradise Inn', 290, '2020-01-18', 325, NULL),
('The Paradise Inn', 290, '2020-01-19', 199, NULL),
('The Paradise Inn', 290, '2020-01-20', 391, NULL),
('The Paradise Inn', 290, '2020-01-21', 227, NULL),
('The Paradise Inn', 290, '2020-01-22', 312, NULL),
('The Paradise Inn', 290, '2020-01-23', 348, NULL),
('The Paradise Inn', 290, '2020-01-24', 205, NULL),
('The Paradise Inn', 290, '2020-01-25', 177, NULL),
('The Paradise Inn', 290, '2020-01-26', 323, NULL),
('The Paradise Inn', 290, '2020-01-27', 221, NULL),
('The Paradise Inn', 290, '2020-01-28', 118, NULL),
('The Paradise Inn', 290, '2020-01-29', 276, NULL),
('The Paradise Inn', 290, '2020-01-30', 121, NULL),
('The Paradise Inn', 290, '2020-01-31', 360, NULL),
('The Paradise Inn', 290, '2020-02-01', 393, NULL),
('The Paradise Inn', 290, '2020-02-02', 112, NULL),
('The Paradise Inn', 290, '2020-02-03', 172, NULL),
('The Paradise Inn', 290, '2020-02-04', 170, NULL);

--
-- Triggers `room_date`
--
DELIMITER $$
CREATE TRIGGER `AssignRoomTrigger` BEFORE INSERT ON `room_date` FOR EACH ROW BEGIN
		IF NEW.reservation_id IS NOT NULL 
        AND (NEW._date >= (SELECT check_out FROM Reservation WHERE reservation_id = NEW.reservation_id) 
			OR NEW._date < (SELECT check_in FROM Reservation WHERE reservation_id = NEW.reservation_id)) THEN
				SIGNAL SQLSTATE '45000' SET MESSAGE_TEXT = 'Room cannot be assigned to reservation outside of the reservation dates';
        END IF;    
    END
$$
DELIMITER ;
DELIMITER $$
CREATE TRIGGER `UpdateRoomTrigger` BEFORE UPDATE ON `room_date` FOR EACH ROW BEGIN
		IF NEW.reservation_id IS NOT NULL 
        AND NEW._date >= (SELECT check_out FROM Reservation WHERE reservation_id = NEW.reservation_id) THEN
			SIGNAL SQLSTATE '45000' SET MESSAGE_TEXT = 'Room cannot be assigned to reservation later than check out';
        END IF;    
        
        IF NEW.reservation_id IS NOT NULL
        AND NEW._date < (SELECT check_in FROM Reservation WHERE reservation_id = NEW.reservation_id) THEN
			SIGNAL SQLSTATE '45000' SET MESSAGE_TEXT = 'Room cannot be assigned to reservation earlier than check in';
		END IF;
    END
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Table structure for table `staff`
--

CREATE TABLE `staff` (
  `employee_num` int(10) UNSIGNED NOT NULL,
  `sin` char(9) NOT NULL,
  `position` varchar(20) NOT NULL,
  `phone_number` varchar(15) NOT NULL,
  `first_name` varchar(25) NOT NULL,
  `last_name` varchar(25) NOT NULL,
  `property_name` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `staff`
--

INSERT INTO `staff` (`employee_num`, `sin`, `position`, `phone_number`, `first_name`, `last_name`, `property_name`) VALUES
(1, '7795527', 'Cleaner', '263-687-5952', 'Christina', 'Vanichkov', 'Luxor'),
(2, '7143014', 'Manager', '706-378-5324', 'Bogey', 'Gayter', 'Cute Mountains Inn'),
(3, '7030808', 'Doorman', '816-247-8012', 'Griz', 'Burdoun', 'Candlewood Suites'),
(4, '7279959', 'Manager', '413-853-5331', 'Judon', 'Hush', 'Hampton Inn'),
(5, '7839964', 'Bellboy', '735-539-6714', 'Webb', 'Littledyke', 'Candlewood Suites'),
(6, '7783471', 'Manager', '215-994-2670', 'Wilek', 'Manntschke', 'Cute Mountains Inn'),
(7, '7537319', 'Receptionist', '236-768-9949', 'Nata', 'Isakovitch', 'Residence Inn'),
(8, '7508989', 'Manager', '833-944-7216', 'Ibrahim', 'Lardiner', 'Sheraton Centre'),
(9, '7586291', 'Manager', '706-617-6308', 'Dianne', 'Swatheridge', 'The Paradise Inn'),
(10, '7172067', 'Bellboy', '771-115-9948', 'Lea', 'McKinna', 'Hi-Way Inn'),
(11, '7902807', 'Doorman', '245-213-1751', 'Kristyn', 'Massot', 'Cute Mountains Inn'),
(12, '7078572', 'Cleaner', '919-431-0763', 'Fair', 'Filyukov', 'The Paradise Inn'),
(13, '7957354', 'Doorman', '182-239-5407', 'Betta', 'Hughlock', 'Candlewood Suites'),
(14, '7105176', 'Doorman', '773-264-4220', 'Austin', 'Skeene', 'The Paradise Inn'),
(15, '7150554', 'Cleaner', '586-886-6498', 'Duncan', 'McCloch', 'Hotel deLuxe'),
(16, '7967487', 'Manager', '707-586-1624', 'Rhodia', 'Siviter', 'Luxor'),
(17, '7024637', 'Receptionist', '233-823-5770', 'Sollie', 'Saura', 'Sheraton Centre'),
(18, '7022938', 'Bellboy', '207-450-2628', 'Collete', 'Munns', 'The Paradise Inn'),
(19, '7423404', 'Receptionist', '782-536-1624', 'Taylor', 'Adamowitz', 'Cute Mountains Inn'),
(20, '7965945', 'Cleaner', '318-331-2800', 'Therese', 'McTear', 'Hampton Inn'),
(21, '7747364', 'Receptionist', '366-651-8735', 'Joni', 'Oxenham', 'Hi-Way Inn'),
(22, '7363070', 'Bellboy', '936-626-4997', 'Lethia', 'Winterbourne', 'Hotel deLuxe'),
(23, '7621131', 'Cleaner', '829-165-8918', 'Matthus', 'Gary', 'Residence Inn'),
(24, '7246710', 'Doorman', '211-832-7912', 'Vicki', 'Ketts', 'Hi-Way Inn'),
(25, '7272090', 'Manager', '343-351-1247', 'Melicent', 'Malthus', 'Luxor'),
(26, '7894331', 'Receptionist', '168-517-2072', 'Mufinella', 'Cowgill', 'Hotel deLuxe'),
(27, '7892466', 'Receptionist', '577-243-6329', 'Delilah', 'Maybery', 'Hampton Inn'),
(28, '7041689', 'Doorman', '302-469-3019', 'Jeannine', 'Guerrieri', 'The Paradise Inn'),
(29, '7851228', 'Cleaner', '702-911-4957', 'Cortie', 'Olczak', 'Cute Mountains Inn'),
(30, '7818879', 'Receptionist', '391-586-0832', 'Brock', 'Milbourne', 'Hotel deLuxe'),
(31, '7247035', 'Doorman', '358-705-8222', 'Haroun', 'Mullard', 'Luxor'),
(32, '7977982', 'Manager', '736-216-5625', 'Channa', 'Coxall', 'Residence Inn'),
(33, '7647061', 'Cleaner', '838-493-8003', 'Halsy', 'Mingame', 'Cute Mountains Inn'),
(34, '7872767', 'Manager', '537-250-1013', 'Mara', 'Mathivat', 'Cute Mountains Inn'),
(35, '7420943', 'Manager', '287-527-0517', 'Lammond', 'Garrold', 'Luxor'),
(36, '7848849', 'Cleaner', '528-266-4651', 'Odette', 'Gawthrope', 'Luxor'),
(37, '7650320', 'Manager', '365-605-4634', 'Connor', 'Daldan', 'Hotel deLuxe'),
(38, '7797064', 'Doorman', '387-848-9824', 'El', 'Passo', 'Hotel deLuxe'),
(39, '7746239', 'Manager', '280-121-4194', 'Court', 'Bartleet', 'Luxor'),
(40, '7940037', 'Cleaner', '641-921-7442', 'Lane', 'Kinkead', 'Residence Inn'),
(41, '7028393', 'Manager', '515-863-6331', 'Nataline', 'Winsper', 'Hotel deLuxe'),
(42, '7583141', 'Cleaner', '276-291-9525', 'Guthrey', 'MacBain', 'Hilton Downtown'),
(43, '7050435', 'Cleaner', '649-853-0242', 'Abagail', 'Corris', 'Hi-Way Inn'),
(44, '7520356', 'Receptionist', '563-365-8023', 'Tailor', 'Fuzzens', 'Hilton Downtown'),
(45, '7330327', 'Receptionist', '113-865-1588', 'Sammy', 'Krollman', 'Hotel deLuxe'),
(46, '7386301', 'Cleaner', '209-629-3340', 'Kalle', 'Winchester', 'Hotel deLuxe'),
(47, '7433122', 'Cleaner', '464-546-4891', 'Davie', 'Pont', 'Hilton Downtown'),
(48, '7817689', 'Bellboy', '623-428-8503', 'Lance', 'M\'Chirrie', 'The Paradise Inn'),
(49, '7273241', 'Manager', '511-647-2948', 'Cesaro', 'Eacott', 'Hampton Inn'),
(50, '7146717', 'Receptionist', '322-369-5097', 'Nana', 'Beyn', 'Hi-Way Inn'),
(51, '7799017', 'Receptionist', '757-147-5488', 'Petronella', 'Fifield', 'The Paradise Inn'),
(52, '7388887', 'Cleaner', '760-801-6012', 'Nissy', 'Grindley', 'Sheraton Centre'),
(53, '7235048', 'Manager', '738-875-4079', 'Jordain', 'Bruntjen', 'Sheraton Centre'),
(54, '7273774', 'Doorman', '246-122-0093', 'Alix', 'Coal', 'Hotel deLuxe'),
(55, '7566282', 'Doorman', '263-831-6908', 'Constance', 'Lewsley', 'Hampton Inn'),
(56, '7349570', 'Doorman', '580-440-7875', 'Vannie', 'Awton', 'Sheraton Centre'),
(57, '7708545', 'Cleaner', '252-115-2427', 'Lucinda', 'Byk', 'Luxor'),
(58, '7006667', 'Receptionist', '277-615-6053', 'Giffie', 'Bootland', 'Hotel deLuxe'),
(59, '7574111', 'Bellboy', '378-447-0218', 'Leia', 'Middell', 'Residence Inn'),
(60, '7516375', 'Bellboy', '644-549-7075', 'Boy', 'Beacock', 'Hilton Downtown'),
(61, '7370809', 'Manager', '469-143-2088', 'Mayer', 'Baty', 'Hampton Inn'),
(62, '7296048', 'Cleaner', '275-226-9706', 'Dun', 'Swalough', 'Residence Inn'),
(63, '7391721', 'Manager', '560-188-2633', 'Vidovic', 'Showalter', 'Cute Mountains Inn'),
(64, '7928323', 'Manager', '336-535-9480', 'Josie', 'Rowen', 'Residence Inn'),
(65, '7149658', 'Cleaner', '928-833-7223', 'Putnam', 'Wort', 'Hampton Inn'),
(66, '7828514', 'Doorman', '305-110-4759', 'Lorry', 'Orcott', 'Luxor'),
(67, '7312919', 'Cleaner', '682-677-1319', 'Cami', 'Billingham', 'Cute Mountains Inn'),
(68, '7123202', 'Cleaner', '816-217-2469', 'Crosby', 'Hyndes', 'Cute Mountains Inn'),
(69, '7681025', 'Manager', '164-487-7637', 'Cesya', 'Klewer', 'Luxor'),
(70, '7468818', 'Doorman', '447-192-8961', 'Artus', 'Smeath', 'Candlewood Suites'),
(71, '7408848', 'Cleaner', '808-924-1517', 'Codi', 'Ranvoise', 'Luxor'),
(72, '7556755', 'Manager', '321-396-3486', 'Katlin', 'Colville', 'Luxor'),
(73, '7125113', 'Receptionist', '434-555-0547', 'Thom', 'Karpe', 'The Paradise Inn'),
(74, '7029570', 'Doorman', '886-120-5276', 'Garik', 'MacGowan', 'Hotel deLuxe'),
(75, '7583441', 'Doorman', '345-913-7455', 'Ame', 'Romain', 'Hi-Way Inn'),
(76, '7238950', 'Cleaner', '158-720-5056', 'Jade', 'Tolcher', 'The Paradise Inn'),
(77, '7816827', 'Doorman', '174-967-2580', 'Pamela', 'Wilsher', 'Luxor'),
(78, '7810305', 'Receptionist', '250-641-7533', 'Angelia', 'Westell', 'Hilton Downtown'),
(79, '7516281', 'Manager', '299-354-0467', 'Polly', 'Benedidick', 'The Paradise Inn'),
(80, '7708061', 'Cleaner', '246-563-1425', 'Roz', 'Pippard', 'Cute Mountains Inn'),
(81, '7312374', 'Bellboy', '401-934-0531', 'Lesley', 'Rapkins', 'Candlewood Suites'),
(82, '7647704', 'Cleaner', '370-718-5092', 'Clarice', 'Tenwick', 'Hampton Inn'),
(83, '7147987', 'Receptionist', '935-679-4514', 'Meredith', 'Riggoll', 'Hi-Way Inn'),
(84, '7541999', 'Cleaner', '461-973-2132', 'Cindra', 'Nore', 'Hampton Inn'),
(85, '7867677', 'Receptionist', '512-476-6686', 'Jeanne', 'Jarrette', 'Sheraton Centre'),
(86, '7314758', 'Cleaner', '421-424-5893', 'Dion', 'Sutcliff', 'Hampton Inn'),
(87, '7487916', 'Bellboy', '631-874-9424', 'Chickie', 'O\'Corhane', 'Residence Inn'),
(88, '7052123', 'Receptionist', '898-133-3393', 'Mattie', 'Godsell', 'Candlewood Suites'),
(89, '7941190', 'Bellboy', '367-129-4151', 'Nananne', 'Genike', 'Hilton Downtown'),
(90, '7715644', 'Receptionist', '749-687-2400', 'Ella', 'Phebey', 'The Paradise Inn'),
(91, '7140303', 'Cleaner', '799-537-0846', 'Gaelan', 'D\'eath', 'Hampton Inn'),
(92, '7754386', 'Receptionist', '785-100-3428', 'Skipp', 'Pendre', 'The Paradise Inn'),
(93, '7168744', 'Cleaner', '949-923-8221', 'Brena', 'Jouanot', 'Hampton Inn'),
(94, '7097045', 'Manager', '909-928-6273', 'Tobye', 'Shoard', 'Cute Mountains Inn'),
(95, '7583585', 'Bellboy', '845-279-1225', 'Alessandro', 'Chattock', 'Luxor'),
(96, '7369579', 'Receptionist', '569-208-5096', 'Marillin', 'Benam', 'Hi-Way Inn'),
(97, '7018739', 'Cleaner', '390-929-0165', 'Pearla', 'McVee', 'Cute Mountains Inn'),
(98, '7943381', 'Doorman', '405-806-7595', 'Kylila', 'Boullin', 'Cute Mountains Inn'),
(99, '7234221', 'Doorman', '662-324-2434', 'Roseline', 'Rupprecht', 'Luxor'),
(100, '7862077', 'Cleaner', '966-706-0320', 'Rutter', 'Verheijden', 'Candlewood Suites');

-- --------------------------------------------------------

--
-- Table structure for table `_date`
--

CREATE TABLE `_date` (
  `_date` date NOT NULL,
  `isHoliday` enum('y','n') NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `_date`
--

INSERT INTO `_date` (`_date`, `isHoliday`) VALUES
('2019-01-01', 'y'),
('2019-01-02', 'n'),
('2019-01-03', 'n'),
('2019-01-04', 'y'),
('2019-01-05', 'y'),
('2019-01-06', 'n'),
('2019-01-07', 'n'),
('2019-01-08', 'n'),
('2019-01-09', 'n'),
('2019-01-10', 'n'),
('2019-01-11', 'n'),
('2019-01-12', 'n'),
('2019-01-13', 'n'),
('2019-01-14', 'y'),
('2019-01-15', 'n'),
('2019-01-16', 'y'),
('2019-01-17', 'n'),
('2019-01-18', 'n'),
('2019-01-19', 'n'),
('2019-01-20', 'n'),
('2019-01-21', 'n'),
('2019-01-22', 'n'),
('2019-01-23', 'n'),
('2019-01-24', 'y'),
('2019-01-25', 'n'),
('2019-01-26', 'y'),
('2019-01-27', 'n'),
('2019-01-28', 'y'),
('2019-01-29', 'n'),
('2019-01-30', 'n'),
('2019-01-31', 'y'),
('2019-02-01', 'n'),
('2019-02-02', 'n'),
('2019-02-03', 'y'),
('2019-02-04', 'y'),
('2019-02-05', 'n'),
('2019-02-06', 'y'),
('2019-02-07', 'n'),
('2019-02-08', 'n'),
('2019-02-09', 'y'),
('2019-02-10', 'n'),
('2019-02-11', 'n'),
('2019-02-12', 'n'),
('2019-02-13', 'n'),
('2019-02-14', 'n'),
('2019-02-15', 'n'),
('2019-02-16', 'n'),
('2019-02-17', 'n'),
('2019-02-18', 'n'),
('2019-02-19', 'y'),
('2019-02-20', 'n'),
('2019-02-21', 'n'),
('2019-02-22', 'n'),
('2019-02-23', 'n'),
('2019-02-24', 'n'),
('2019-02-25', 'y'),
('2019-02-26', 'n'),
('2019-02-27', 'n'),
('2019-02-28', 'n'),
('2019-03-01', 'n'),
('2019-03-02', 'n'),
('2019-03-03', 'n'),
('2019-03-04', 'n'),
('2019-03-05', 'y'),
('2019-03-06', 'n'),
('2019-03-07', 'n'),
('2019-03-08', 'n'),
('2019-03-09', 'y'),
('2019-03-10', 'y'),
('2019-03-11', 'y'),
('2019-03-12', 'n'),
('2019-03-13', 'y'),
('2019-03-14', 'y'),
('2019-03-15', 'n'),
('2019-03-16', 'n'),
('2019-03-17', 'y'),
('2019-03-18', 'n'),
('2019-03-19', 'n'),
('2019-03-20', 'n'),
('2019-03-21', 'n'),
('2019-03-22', 'n'),
('2019-03-23', 'y'),
('2019-03-24', 'n'),
('2019-03-25', 'y'),
('2019-03-26', 'n'),
('2019-03-27', 'y'),
('2019-03-28', 'n'),
('2019-03-29', 'n'),
('2019-03-30', 'y'),
('2019-03-31', 'y'),
('2019-04-01', 'n'),
('2019-04-02', 'n'),
('2019-04-03', 'n'),
('2019-04-04', 'n'),
('2019-04-05', 'y'),
('2019-04-06', 'y'),
('2019-04-07', 'n'),
('2019-04-08', 'y'),
('2019-04-09', 'n'),
('2019-04-10', 'y'),
('2019-04-11', 'n'),
('2019-04-12', 'n'),
('2019-04-13', 'n'),
('2019-04-14', 'y'),
('2019-04-15', 'y'),
('2019-04-16', 'y'),
('2019-04-17', 'n'),
('2019-04-18', 'y'),
('2019-04-19', 'y'),
('2019-04-20', 'n'),
('2019-04-21', 'n'),
('2019-04-22', 'n'),
('2019-04-23', 'n'),
('2019-04-24', 'n'),
('2019-04-25', 'n'),
('2019-04-26', 'n'),
('2019-04-27', 'n'),
('2019-04-28', 'n'),
('2019-04-29', 'n'),
('2019-04-30', 'n'),
('2019-05-01', 'y'),
('2019-05-02', 'y'),
('2019-05-03', 'n'),
('2019-05-04', 'n'),
('2019-05-05', 'n'),
('2019-05-06', 'n'),
('2019-05-07', 'y'),
('2019-05-08', 'n'),
('2019-05-09', 'n'),
('2019-05-10', 'y'),
('2019-05-11', 'y'),
('2019-05-12', 'n'),
('2019-05-13', 'n'),
('2019-05-14', 'n'),
('2019-05-15', 'n'),
('2019-05-16', 'n'),
('2019-05-17', 'n'),
('2019-05-18', 'n'),
('2019-05-19', 'y'),
('2019-05-20', 'n'),
('2019-05-21', 'y'),
('2019-05-22', 'n'),
('2019-05-23', 'y'),
('2019-05-24', 'n'),
('2019-05-25', 'y'),
('2019-05-26', 'n'),
('2019-05-27', 'n'),
('2019-05-28', 'y'),
('2019-05-29', 'n'),
('2019-05-30', 'n'),
('2019-05-31', 'n'),
('2019-06-01', 'n'),
('2019-06-02', 'n'),
('2019-06-03', 'y'),
('2019-06-04', 'n'),
('2019-06-05', 'y'),
('2019-06-06', 'n'),
('2019-06-07', 'n'),
('2019-06-08', 'y'),
('2019-06-09', 'n'),
('2019-06-10', 'n'),
('2019-06-11', 'n'),
('2019-06-12', 'y'),
('2019-06-13', 'n'),
('2019-06-14', 'n'),
('2019-06-15', 'n'),
('2019-06-16', 'n'),
('2019-06-17', 'n'),
('2019-06-18', 'n'),
('2019-06-19', 'n'),
('2019-06-20', 'y'),
('2019-06-21', 'n'),
('2019-06-22', 'n'),
('2019-06-23', 'n'),
('2019-06-24', 'n'),
('2019-06-25', 'n'),
('2019-06-26', 'n'),
('2019-06-27', 'y'),
('2019-06-28', 'y'),
('2019-06-29', 'n'),
('2019-06-30', 'n'),
('2019-07-01', 'y'),
('2019-07-02', 'y'),
('2019-07-03', 'n'),
('2019-07-04', 'n'),
('2019-07-05', 'n'),
('2019-07-06', 'n'),
('2019-07-07', 'n'),
('2019-07-08', 'n'),
('2019-07-09', 'n'),
('2019-07-10', 'y'),
('2019-07-11', 'n'),
('2019-07-12', 'y'),
('2019-07-13', 'n'),
('2019-07-14', 'n'),
('2019-07-15', 'n'),
('2019-07-16', 'n'),
('2019-07-17', 'n'),
('2019-07-18', 'n'),
('2019-07-19', 'y'),
('2019-07-20', 'n'),
('2019-07-21', 'n'),
('2019-07-22', 'y'),
('2019-07-23', 'n'),
('2019-07-24', 'n'),
('2019-07-25', 'y'),
('2019-07-26', 'n'),
('2019-07-27', 'n'),
('2019-07-28', 'n'),
('2019-07-29', 'n'),
('2019-07-30', 'n'),
('2019-07-31', 'y'),
('2019-08-01', 'n'),
('2019-08-02', 'n'),
('2019-08-03', 'y'),
('2019-08-04', 'y'),
('2019-08-05', 'y'),
('2019-08-06', 'n'),
('2019-08-07', 'n'),
('2019-08-08', 'y'),
('2019-08-09', 'n'),
('2019-08-10', 'y'),
('2019-08-11', 'n'),
('2019-08-12', 'n'),
('2019-08-13', 'n'),
('2019-08-14', 'n'),
('2019-08-15', 'n'),
('2019-08-16', 'n'),
('2019-08-17', 'n'),
('2019-08-18', 'n'),
('2019-08-19', 'y'),
('2019-08-20', 'n'),
('2019-08-21', 'n'),
('2019-08-22', 'n'),
('2019-08-23', 'n'),
('2019-08-24', 'y'),
('2019-08-25', 'y'),
('2019-08-26', 'y'),
('2019-08-27', 'n'),
('2019-08-28', 'n'),
('2019-08-29', 'n'),
('2019-08-30', 'n'),
('2019-08-31', 'y'),
('2019-09-01', 'n'),
('2019-09-02', 'n'),
('2019-09-03', 'n'),
('2019-09-04', 'y'),
('2019-09-05', 'y'),
('2019-09-06', 'y'),
('2019-09-07', 'n'),
('2019-09-08', 'n'),
('2019-09-09', 'y'),
('2019-09-10', 'n'),
('2019-09-11', 'n'),
('2019-09-12', 'y'),
('2019-09-13', 'n'),
('2019-09-14', 'n'),
('2019-09-15', 'n'),
('2019-09-16', 'n'),
('2019-09-17', 'n'),
('2019-09-18', 'n'),
('2019-09-19', 'n'),
('2019-09-20', 'n'),
('2019-09-21', 'y'),
('2019-09-22', 'y'),
('2019-09-23', 'n'),
('2019-09-24', 'n'),
('2019-09-25', 'n'),
('2019-09-26', 'n'),
('2019-09-27', 'y'),
('2019-09-28', 'n'),
('2019-09-29', 'n'),
('2019-09-30', 'n'),
('2019-10-01', 'y'),
('2019-10-02', 'y'),
('2019-10-03', 'n'),
('2019-10-04', 'y'),
('2019-10-05', 'y'),
('2019-10-06', 'y'),
('2019-10-07', 'y'),
('2019-10-08', 'n'),
('2019-10-09', 'n'),
('2019-10-10', 'y'),
('2019-10-11', 'n'),
('2019-10-12', 'n'),
('2019-10-13', 'y'),
('2019-10-14', 'n'),
('2019-10-15', 'y'),
('2019-10-16', 'n'),
('2019-10-17', 'y'),
('2019-10-18', 'n'),
('2019-10-19', 'n'),
('2019-10-20', 'n'),
('2019-10-21', 'n'),
('2019-10-22', 'y'),
('2019-10-23', 'n'),
('2019-10-24', 'y'),
('2019-10-25', 'y'),
('2019-10-26', 'n'),
('2019-10-27', 'y'),
('2019-10-28', 'y'),
('2019-10-29', 'n'),
('2019-10-30', 'y'),
('2019-10-31', 'y'),
('2019-11-01', 'y'),
('2019-11-02', 'n'),
('2019-11-03', 'n'),
('2019-11-04', 'n'),
('2019-11-05', 'n'),
('2019-11-06', 'n'),
('2019-11-07', 'n'),
('2019-11-08', 'n'),
('2019-11-09', 'n'),
('2019-11-10', 'n'),
('2019-11-11', 'y'),
('2019-11-12', 'n'),
('2019-11-13', 'n'),
('2019-11-14', 'n'),
('2019-11-15', 'y'),
('2019-11-16', 'n'),
('2019-11-17', 'n'),
('2019-11-18', 'n'),
('2019-11-19', 'n'),
('2019-11-20', 'n'),
('2019-11-21', 'n'),
('2019-11-22', 'y'),
('2019-11-23', 'n'),
('2019-11-24', 'n'),
('2019-11-25', 'y'),
('2019-11-26', 'n'),
('2019-11-27', 'n'),
('2019-11-28', 'n'),
('2019-11-29', 'y'),
('2019-11-30', 'n'),
('2019-12-01', 'n'),
('2019-12-02', 'n'),
('2019-12-03', 'y'),
('2019-12-04', 'n'),
('2019-12-05', 'n'),
('2019-12-06', 'n'),
('2019-12-07', 'y'),
('2019-12-08', 'n'),
('2019-12-09', 'n'),
('2019-12-10', 'n'),
('2019-12-11', 'n'),
('2019-12-12', 'y'),
('2019-12-13', 'y'),
('2019-12-14', 'n'),
('2019-12-15', 'n'),
('2019-12-16', 'n'),
('2019-12-17', 'n'),
('2019-12-18', 'n'),
('2019-12-19', 'n'),
('2019-12-20', 'y'),
('2019-12-21', 'n'),
('2019-12-22', 'n'),
('2019-12-23', 'n'),
('2019-12-24', 'n'),
('2019-12-25', 'y'),
('2019-12-26', 'n'),
('2019-12-27', 'n'),
('2019-12-28', 'y'),
('2019-12-29', 'n'),
('2019-12-30', 'y'),
('2019-12-31', 'n'),
('2020-01-01', 'n'),
('2020-01-02', 'n'),
('2020-01-03', 'y'),
('2020-01-04', 'y'),
('2020-01-05', 'n'),
('2020-01-06', 'y'),
('2020-01-07', 'n'),
('2020-01-08', 'n'),
('2020-01-09', 'n'),
('2020-01-10', 'y'),
('2020-01-11', 'y'),
('2020-01-12', 'y'),
('2020-01-13', 'n'),
('2020-01-14', 'y'),
('2020-01-15', 'n'),
('2020-01-16', 'n'),
('2020-01-17', 'y'),
('2020-01-18', 'n'),
('2020-01-19', 'n'),
('2020-01-20', 'y'),
('2020-01-21', 'n'),
('2020-01-22', 'y'),
('2020-01-23', 'y'),
('2020-01-24', 'n'),
('2020-01-25', 'n'),
('2020-01-26', 'n'),
('2020-01-27', 'n'),
('2020-01-28', 'n'),
('2020-01-29', 'y'),
('2020-01-30', 'y'),
('2020-01-31', 'n'),
('2020-02-01', 'y'),
('2020-02-02', 'n'),
('2020-02-03', 'n'),
('2020-02-04', 'n');

-- --------------------------------------------------------

--
-- Table structure for table `_user`
--

CREATE TABLE `_user` (
  `user_email` varchar(100) NOT NULL,
  `pass` varchar(50) NOT NULL,
  `first_name` varchar(25) NOT NULL,
  `last_name` varchar(25) NOT NULL,
  `phone_number` varchar(15) NOT NULL,
  `dob` date NOT NULL,
  `is_user` enum('y','n') NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `_user`
--

INSERT INTO `_user` (`user_email`, `pass`, `first_name`, `last_name`, `phone_number`, `dob`, `is_user`) VALUES
('amckeefrycu@ycombinator.com', 'vb2YjiBm5ce0', 'Aaron', 'McKeefry', '912-297-3251', '1969-04-09', 'y'),
('aobernep@google.cn', 'narL3f', 'Abbie', 'Obern', '957-184-3525', '1972-10-01', 'y'),
('adurstonh5@unc.edu', 'HAF47tSU77p0', 'Abby', 'Durston', '196-893-5418', '1973-01-24', 'y'),
('apoolmanok@addtoany.com', 'hwj6HgI1fB', 'Abbye', 'Poolman', '534-574-3168', '1967-01-24', 'y'),
('abudgetde@joomla.org', 'XTT6vt', 'Abelard', 'Budget', '430-935-2153', '1981-09-23', 'y'),
('adoughtonfd@usatoday.com', 'NFf7N3Qz', 'Abelard', 'Doughton', '810-361-0293', '1973-07-12', 'y'),
('aflacknoe35@twitpic.com', 'N6AgA0', 'Abelard', 'Flacknoe', '239-657-8687', '1995-07-10', 'y'),
('afisbey3k@squidoo.com', '6E6oh9lok', 'Abra', 'Fisbey', '218-987-1057', '1981-09-11', 'y'),
('aking3e@bbb.org', '9kNNv1', 'Abra', 'King', '805-541-0616', '1953-07-30', 'y'),
('adana7z@google.it', 'aAMw8H', 'Ada', 'Dana', '714-679-8706', '1989-04-25', 'y'),
('amckleod4a@php.net', 'kpjqPoUw0Uc', 'Adah', 'McKleod', '717-763-2064', '1982-04-18', 'y'),
('adeguek8@state.tx.us', 'inbqGl23LAl', 'Adair', 'Degue', '251-910-0652', '1971-07-01', 'y'),
('amandres3h@rediff.com', 'Erw2vthyy', 'Adam', 'Mandres', '864-276-3519', '1954-09-29', 'y'),
('aboxellgy@skyrock.com', 'bO38n2apYbx', 'Adan', 'Boxell', '712-189-7237', '1950-10-05', 'y'),
('atagglr@posterous.com', 'rBN3Nal', 'Adara', 'Tagg', '509-598-8640', '1970-10-29', 'y'),
('akelberermb@sakura.ne.jp', 'fk0o6G', 'Addi', 'Kelberer', '124-831-5427', '1990-08-09', 'y'),
('ashucksmithjq@imgur.com', 'rLLHBPx5T', 'Addie', 'Shucksmith', '263-734-8509', '1958-09-27', 'y'),
('adadgee1@dagondesign.com', 'FI8oGSjf9', 'Addy', 'Dadge', '339-970-2651', '1997-11-26', 'y'),
('akunischqw@tinypic.com', 'bXNKXQPmN6', 'Adelice', 'Kunisch', '978-581-2007', '1952-07-27', 'y'),
('amaulindi@surveymonkey.com', 'VFytlt8', 'Adelice', 'Maulin', '550-198-7754', '1957-08-12', 'y'),
('apaulmannoy@weebly.com', 'L0emksTLXtdF', 'Adeline', 'Paulmann', '808-378-9529', '1968-06-28', 'y'),
('adignumnv@amazon.de', 'dPFadJJQ', 'Adolphe', 'Dignum', '702-424-7371', '1952-01-05', 'y'),
('jude@gmail.com', 'jude123', 'adones', 'evangelista', '09120118872', '0000-00-00', 'n'),
('a@gmail.com', 'ado12345', 'adones', 'evangelista', '09120118872', '1990-07-05', 'n'),
('aframpton7d@paginegialle.it', 'VIcPjo3Oo', 'Adoree', 'Frampton', '794-560-2756', '1984-06-23', 'y'),
('agabeyc4@google.ru', 'oit9fEp97XF', 'Adoree', 'Gabey', '844-490-1728', '1956-11-10', 'y'),
('ascotson1y@deviantart.com', 'Xvzh5dwnNze', 'Adoree', 'Scotson', '678-290-7647', '1954-05-16', 'y'),
('aharhoffbe@wiley.com', 'VBQ09D66F9Cv', 'Adriane', 'Harhoff', '713-394-9395', '1967-10-10', 'y'),
('ahalwell84@joomla.org', 'VS1V7QmPfdw', 'Adriano', 'Halwell', '145-198-5995', '1974-04-06', 'y'),
('anorth52@networksolutions.com', 'M1c1zIq4VZgx', 'Aeriel', 'North', '304-798-2471', '1977-08-27', 'y'),
('achingeh7@cbslocal.com', '0C0h4Gz', 'Aeriela', 'Chinge', '338-669-8117', '1966-12-06', 'y'),
('alissamancs@mtv.com', 'Te6wTwBuy', 'Agatha', 'Lissaman', '341-864-5242', '1955-09-01', 'y'),
('amacaleesef0@vkontakte.ru', 'L6fWfBcVXn', 'Aggi', 'MacAleese', '816-988-3346', '2001-12-11', 'y'),
('azupaks@vk.com', 'veBma4', 'Agnella', 'Zupa', '446-889-0573', '1962-08-13', 'y'),
('agengekn@mozilla.org', 'TadRmEmyqv', 'Aguie', 'Genge', '246-564-2620', '1963-10-30', 'y'),
('abodill7o@epa.gov', 'T3PqPjW', 'Ahmed', 'Bodill', '164-896-9310', '1990-03-31', 'y'),
('aennewqo@tinyurl.com', '9F5nykv', 'Aila', 'Ennew', '508-316-0939', '1950-05-27', 'y'),
('aharfootdr@indiegogo.com', 'lWDK3eqGjYvx', 'Aile', 'Harfoot', '812-723-4485', '1953-04-13', 'y'),
('akeepeeq@jigsy.com', '7SMPJT6', 'Aili', 'Keepe', '361-389-1290', '1955-12-18', 'y'),
('asybbeec@twitpic.com', '2tmdK6x', 'Ailis', 'Sybbe', '272-297-5136', '1950-03-30', 'y'),
('amayhew67@goo.ne.jp', 'W5IeH5rDF', 'Alain', 'Mayhew', '528-482-6648', '2001-10-22', 'y'),
('aphillinsls@discuz.net', '9AXu7A9c3OQb', 'Albertina', 'Phillins', '245-223-1999', '1987-05-13', 'y'),
('areekeni5@sciencedirect.com', 'SC0sULG4wBhg', 'Albertina', 'Reeken', '356-378-8025', '1985-03-05', 'y'),
('agonneaue0@surveymonkey.com', '0XUzxbK', 'Alden', 'Gonneau', '266-391-4975', '1995-05-26', 'y'),
('awyvilljg@amazon.de', 'ldYv6h', 'Aldric', 'Wyvill', '205-329-9632', '1985-03-27', 'y'),
('asavorykt@360.cn', 'maR05Krj0', 'Aldrich', 'Savory', '289-537-8279', '1973-09-17', 'y'),
('agulya9@acquirethisname.com', '03ZtTqs', 'Aldwin', 'Guly', '177-431-0801', '1997-04-14', 'y'),
('apurleri@nih.gov', 'v7LMQKCiuM', 'Alecia', 'Purle', '752-915-9340', '1982-12-15', 'y'),
('agashion1j@1und1.de', '0Hu5nyvNEt9', 'Aleda', 'Gashion', '574-724-2759', '1957-09-02', 'y'),
('ajeynessn@nhs.uk', 'SyCw5BAXMcm', 'Aleksandr', 'Jeyness', '193-760-7988', '1976-07-02', 'y'),
('aswiers6s@apache.org', 'UUGTmL', 'Alene', 'Swiers', '988-954-2696', '1996-02-29', 'y'),
('abridgwoodm8@imdb.com', 'dJp1rE', 'Alexa', 'Bridgwood', '640-896-6054', '1985-02-27', 'y'),
('aprivettle@pbs.org', 'Rgm6tg', 'Alexa', 'Privett', '629-187-4867', '1967-10-11', 'y'),
('agerdes77@mapquest.com', 'K8ptJrn0', 'Alexander', 'Gerdes', '159-383-6614', '1973-11-02', 'y'),
('amenaulcp@over-blog.com', '64pWaFcvzOJt', 'Alexina', 'Menaul', '108-681-3945', '1973-08-26', 'y'),
('aoxfordd3@bigcartel.com', 'i5rJV5jVm', 'Alexis', 'Oxford', '468-740-2100', '1998-02-24', 'y'),
('aburnage6a@cbslocal.com', 'O2WNqPI9', 'Alfonso', 'Burnage', '734-936-6624', '1987-09-15', 'y'),
('afranchioni1m@sourceforge.net', 'bkDOc4Ay', 'Alfred', 'Franchioni', '107-372-5074', '1955-03-25', 'y'),
('aohoeybz@amazon.de', 'sk5REy4Okh', 'Ali', 'O\'Hoey', '531-316-3593', '1955-02-17', 'y'),
('adunkerkkx@state.tx.us', 'W6jU0c96w', 'Alicia', 'Dunkerk', '282-854-0055', '1973-08-24', 'y'),
('ahugoninim@chronoengine.com', 'UWRucG', 'Alida', 'Hugonin', '499-137-3859', '1975-10-29', 'y'),
('acroixnm@bloglines.com', 'J6VY6X', 'Alikee', 'Croix', '548-872-6232', '1995-05-19', 'y'),
('amennear94@yolasite.com', 'xdGOQ8I9FI', 'Alis', 'Mennear', '147-884-5218', '1950-10-31', 'y'),
('arawsen55@upenn.edu', '49TrQKEL', 'Alison', 'Rawsen', '280-575-9748', '1974-07-14', 'y'),
('agaveltone21@i2i.jp', 't8139UXIxoP8', 'Alister', 'Gaveltone', '248-868-4014', '1957-06-29', 'y'),
('amajurye5@163.com', 'dN3S4euoOPDt', 'Alisun', 'Majury', '297-722-3559', '1956-08-23', 'y'),
('amcbrier55@rediff.com', 's8OhPW0', 'Aliza', 'McBrier', '726-839-9671', '1959-04-27', 'y'),
('aknightly96@harvard.edu', 'zBY3BFBPG', 'Allan', 'Knightly', '726-459-4567', '1982-12-18', 'y'),
('adowbekint@deviantart.com', 'Zin8cJ', 'Allayne', 'Dowbekin', '421-577-9964', '1973-04-13', 'y'),
('acreykekp@t.co', 'QHmxm66kKh', 'Alley', 'Creyke', '945-772-3112', '1969-03-26', 'y'),
('apimer28@upenn.edu', '6EHQm2', 'Allianora', 'Pimer', '225-582-2350', '1953-04-09', 'y'),
('aumneyjk@behance.net', 'x0PvZIZBwS', 'Allissa', 'Umney', '719-551-7068', '1977-07-30', 'y'),
('acolvieg4@utexas.edu', 'fs5AwvOZC3ZS', 'Allistir', 'Colvie', '331-842-3388', '1990-09-11', 'y'),
('aeddies8n@behance.net', 'Iu7HG2Q7', 'Allix', 'Eddies', '578-295-4603', '1981-12-08', 'y'),
('ahaughianji@dedecms.com', 'ba2Ea0AU', 'Allx', 'Haughian', '257-940-2017', '1982-07-01', 'y'),
('awonfar3w@pcworld.com', 'N1bbCu331KJe', 'Ally', 'Wonfar', '813-793-5820', '1954-01-14', 'y'),
('athurbonnt@newsvine.com', 'rOsVnwqREA', 'Almeda', 'Thurbon', '644-563-7877', '1965-01-19', 'y'),
('adovingtonlo@cyberchimps.com', 'bXL3cGaljK', 'Almeria', 'Dovington', '679-972-5115', '1987-01-18', 'y'),
('adewar9d@cnet.com', 'rbSnmU', 'Aloin', 'Dewar', '703-350-7356', '1962-10-25', 'y'),
('ainch1x@whitehouse.gov', 'ykeRR2ZQKdKp', 'Aloisia', 'Inch', '656-790-8775', '1996-07-30', 'y'),
('asolon9g@clickbank.net', 'Dmj8nC94TS', 'Alphonso', 'Solon', '291-934-5551', '1959-06-19', 'y'),
('afullardj2@census.gov', '4z1YgjdcnJh', 'Aluino', 'Fullard', '162-468-6849', '1996-08-07', 'y'),
('amcnivenki@cnn.com', 'AAaqUc', 'Alvan', 'McNiven', '341-944-9914', '1993-09-01', 'y'),
('avardon12@adobe.com', 'NI8g0iAnaAY', 'Alyosha', 'Vardon', '897-466-3447', '1982-07-28', 'y'),
('abrimblecomben3@pinterest.com', 'AfMNkuJ3', 'Alysia', 'Brimblecombe', '899-581-1703', '1969-02-13', 'y'),
('akobesgq@opensource.org', 'Ayfq5yeTj', 'Alysia', 'Kobes', '774-201-5441', '1987-09-13', 'y'),
('asadlermf@xing.com', '9387WB6bR', 'Alyss', 'Sadler', '759-894-3005', '1966-03-27', 'y'),
('amcnicol3k@printfriendly.com', 'YoWzCVYxF', 'Amabel', 'McNicol', '155-861-4900', '1997-12-07', 'y'),
('anoenk@mit.edu', 'cVsUlvW0QCoA', 'Amalee', 'Noe', '340-243-5204', '1972-05-30', 'y'),
('aloader6f@archive.org', 'QkqjOuPC1I', 'Amata', 'Loader', '809-231-1509', '1985-10-23', 'y'),
('aheyburn2q@census.gov', 'ixXSDkh', 'Amble', 'Heyburn', '646-515-9428', '1975-02-03', 'y'),
('apeidrocq@slideshare.net', 'oDAvtDO3', 'Ambrosio', 'Peidro', '381-488-9676', '2001-08-11', 'y'),
('ajelksic@huffingtonpost.com', 'kk3dFG2dFte', 'Ambur', 'Jelks', '865-821-7595', '1979-04-20', 'y'),
('ashapera1c@techcrunch.com', 'bZWuUTglnfsH', 'Ameline', 'Shapera', '483-382-2312', '1974-01-17', 'y'),
('ajasik6z@com.com', 'g9X5PmfY', 'Amelita', 'Jasik', '598-925-3542', '1989-09-16', 'y'),
('amccaskelld0@upenn.edu', 'aSYY385oB', 'Ammamaria', 'McCaskell', '686-823-7107', '1992-03-04', 'y'),
('aohartnett7x@biblegateway.com', 'MtDfyn6PCrA', 'Amos', 'O\'Hartnett', '834-919-6907', '1984-10-13', 'y'),
('asheachn@cloudflare.com', 'UTib466vf6', 'Anabal', 'Sheach', '543-820-0603', '1993-06-22', 'y'),
('asilverthornec8@usda.gov', 'w4HrBHJL4', 'Anallise', 'Silverthorne', '241-496-8594', '1974-03-21', 'y'),
('amoughtonft@businesswire.com', 'PzQmAhj', 'Anastasia', 'Moughton', '360-482-6145', '1982-07-21', 'y'),
('avedekhinlm@hhs.gov', 'tTSIFIuSN', 'Anastasia', 'Vedekhin', '704-860-3091', '1988-02-11', 'y'),
('adenholm4@e-recht24.de', 'qnwzazel', 'Anatola', 'Denholm', '879-782-0399', '1983-11-06', 'y'),
('abroadway2k@de.vu', 'dfT0oq', 'Anatollo', 'Broadway', '277-358-1147', '1989-07-02', 'y'),
('aburgerfn@house.gov', 'cCUI1o2m2c', 'Ancell', 'Burger', '647-344-5658', '2000-12-10', 'y'),
('aiacapucci6h@fema.gov', 'MrmHJ7yUC', 'Andreas', 'Iacapucci', '161-519-6476', '1975-02-21', 'y'),
('awhiskerdpm@amazon.co.uk', 'c1LNeavU', 'Andrei', 'Whiskerd', '690-329-8727', '1989-01-31', 'y'),
('ajaycockqo@ehow.com', 'y3xKKAxhK', 'Andrej', 'Jaycock', '159-256-4612', '1986-08-19', 'y'),
('asummerly72@fda.gov', '0kxD6u5L', 'Andrey', 'Summerly', '876-995-2573', '1975-12-29', 'y'),
('aosheerin3g@netlog.com', 'Vux0ET', 'Andris', 'O\'Sheerin', '701-280-2744', '1966-11-14', 'y'),
('akincaidk0@comsenz.com', 'XQ8koj4', 'Andros', 'Kincaid', '806-713-1729', '1983-06-08', 'y'),
('awinfieldam@pagesperso-orange.fr', 'sbU5Fg', 'Andy', 'Winfield', '410-633-5046', '1978-06-22', 'y'),
('aedelerc0@yale.edu', 'Fbl94smR1', 'Ange', 'Edeler', '569-992-7897', '1962-01-11', 'y'),
('afaust91@soup.io', '1hZiqMYM', 'Angel', 'Faust', '580-804-7893', '1975-05-15', 'y'),
('aplattsdy@technorati.com', 'mc7KBOZClq6C', 'Angelico', 'Platts', '481-521-9375', '1953-05-09', 'y'),
('apackwoodoy@t.co', 'FuLAKRwgW', 'Angeline', 'Packwood', '799-987-1819', '1950-01-03', 'y'),
('amineghelliom@nydailynews.com', 'aLLC82u4nBc', 'Angelique', 'Mineghelli', '644-743-1447', '1992-12-01', 'y'),
('ahazeuplq@weebly.com', 'rUGxWf5Z', 'Angelo', 'Hazeup', '876-829-0536', '1974-03-18', 'y'),
('abatsonld@meetup.com', 'KxTjPspI', 'Anica', 'Batson', '848-743-8289', '1982-07-18', 'y'),
('amcgilbonga@house.gov', 'PMxcTUeN', 'Anjela', 'McGilbon', '688-407-7220', '1991-09-19', 'y'),
('acona3r@bbb.org', '7wMV9jSfmT', 'Anna-diana', 'Cona', '637-592-2376', '1975-01-22', 'y'),
('amiellrm@newsvine.com', 'WpLAaSsExSMO', 'Anna-diana', 'Miell', '935-830-8442', '1974-10-04', 'y'),
('alongworthylc@admin.ch', 'QQfyQJhSeu', 'Annabal', 'Longworthy', '814-572-1993', '1969-03-02', 'y'),
('alewendono8@princeton.edu', 'roIZJ4Y9L', 'Annabel', 'Lewendon', '576-492-5481', '1950-12-18', 'y'),
('aabilowitzak@last.fm', '8cg5DpF', 'Annabella', 'Abilowitz', '118-271-7930', '1994-06-06', 'y'),
('amclellando1@salon.com', 'okA2mIATec', 'Annaliese', 'McLelland', '322-785-6323', '1968-08-05', 'y'),
('awhetnell8s@intel.com', 'hpFkzSoS5v', 'Annamarie', 'Whetnell', '561-672-8754', '1992-11-23', 'y'),
('alotterington1w@mit.edu', 'M5zuTm', 'Anne-corinne', 'Lotterington', '548-655-0368', '1994-10-18', 'y'),
('ajelley89@berkeley.edu', 'eNoA2F5sQ', 'Annemarie', 'Jelley', '165-884-3071', '1983-07-23', 'y'),
('aaspinell9i@smugmug.com', 'IBcZYZje87', 'Anni', 'Aspinell', '538-756-8370', '1995-03-04', 'y'),
('akingdomh@symantec.com', 'faDT53G9B', 'Anni', 'Kingdom', '830-970-9803', '1956-09-16', 'y'),
('amacane57@si.edu', '91TA6kNHKDV', 'Anselm', 'MacAne', '730-546-2856', '1962-05-10', 'y'),
('amcentagart7u@hud.gov', '4u6tbjAkq7', 'Ansley', 'McEntagart', '793-133-5433', '1981-07-10', 'y'),
('ahefferfz@amazon.com', 'DSfjcDym0N', 'Anthea', 'Heffer', '126-320-2942', '1988-01-30', 'y'),
('amiddiff6t@paypal.com', 'WWNuIJVDItz', 'Anthiathia', 'Middiff', '167-142-3299', '1972-05-08', 'y'),
('aquimbyid@imgur.com', 'Df9ZLPJgcPC5', 'Antoine', 'Quimby', '941-756-2270', '1990-06-04', 'y'),
('amammattr3@networkadvertising.org', '9aWx9higH', 'Antone', 'Mammatt', '172-131-9163', '1970-02-04', 'y'),
('ascholfieldhs@admin.ch', 'jGIn1SvOf', 'Antonin', 'Scholfield', '397-260-7955', '1987-02-10', 'y'),
('adewickeb9@t-online.de', 'SwNBb2q', 'Antonino', 'Dewicke', '928-815-5780', '1953-01-20', 'y'),
('astowgill9q@bloglines.com', '0wUWWgz', 'Antonio', 'Stowgill', '598-699-7269', '1997-05-23', 'y'),
('asavaryly@epa.gov', '42Mz92iNu7', 'Antony', 'Savary', '441-207-2539', '1979-04-10', 'y'),
('aklimmek13@umich.edu', 'vkdZednWI', 'Anya', 'Klimmek', '626-941-6405', '1979-05-09', 'y'),
('agritskovmd@soundcloud.com', 'asH5yUZk', 'Ara', 'Gritskov', '984-970-8202', '1989-04-08', 'y'),
('adorow9j@washington.edu', 'T8YhpOd5o', 'Arabel', 'Dorow', '451-383-8165', '1984-02-23', 'y'),
('asoitoux3j@goodreads.com', 'VzLEqn', 'Arabelle', 'Soitoux', '412-715-1428', '1956-12-04', 'y'),
('abatecoklg@constantcontact.com', 'Yndr9bI1AKT', 'Arch', 'Batecok', '562-649-8464', '1996-07-13', 'y'),
('amcleoidpg@oakley.com', '9IN3bCHFty', 'Ardelia', 'McLeoid', '816-747-8905', '1987-08-07', 'y'),
('asuartcj@utexas.edu', 'lR59pqIq1Gki', 'Ardella', 'Suart', '999-311-0348', '1978-08-11', 'y'),
('acarvillarc@pen.io', 'iWe93f', 'Ardine', 'Carvilla', '928-755-8070', '1975-10-28', 'y'),
('akennardkr@histats.com', '9erGsPgt', 'Ardine', 'Kennard', '213-174-9777', '1971-06-25', 'y'),
('amchaffy78@geocities.jp', 'i3MGVOG', 'Aretha', 'McHaffy', '719-717-2243', '1983-12-12', 'y'),
('asherwindg@barnesandnoble.com', 'Hz7Yccxqil', 'Ari', 'Sherwin', '175-176-2131', '1976-09-01', 'y'),
('acruess6w@addtoany.com', 'aJ818Lz4L7', 'Ario', 'Cruess', '306-118-6669', '1951-09-30', 'y'),
('aextencena@t.co', '1cckrNIx5SzR', 'Ario', 'Extence', '997-471-0035', '1968-03-18', 'y'),
('apach7m@hud.gov', 'ur4H8bgn0lYH', 'Arlen', 'Pach', '175-453-3597', '1975-09-10', 'y'),
('ahalshaw64@berkeley.edu', 'OHLBbo', 'Arlene', 'Halshaw', '541-495-5290', '1966-11-14', 'y'),
('asier9o@youku.com', 'e7ldWOVHnV', 'Arlin', 'Sier', '342-385-1404', '1957-07-15', 'y'),
('aoheffernan59@mapy.cz', 'ivFnc9', 'Arline', 'O\'Heffernan', '361-514-8056', '1976-09-19', 'y'),
('aodbyqr@europa.eu', '0OsqZyvRW', 'Arluene', 'Odby', '996-709-4636', '1977-06-09', 'y'),
('acuschieri4g@sphinn.com', 'Ob303FC', 'Armand', 'Cuschieri', '304-381-1123', '1963-08-03', 'y'),
('abootem5@smh.com.au', 'tEIBOnviL', 'Armstrong', 'Boote', '832-188-8302', '1976-02-02', 'y'),
('ailivebs@bbc.co.uk', '1q2Y7c5KO', 'Arnoldo', 'Ilive', '691-763-1885', '1994-06-01', 'y'),
('alazare1k@163.com', '5dUfgvUaMU5h', 'Arron', 'Lazare', '804-692-0657', '1969-03-05', 'y'),
('amcguinleyda@constantcontact.com', 'qXL1a0S02MwU', 'Artemas', 'McGuinley', '181-163-6297', '1956-09-11', 'y'),
('adriffilljf@gnu.org', 'tWTDUpqAJP', 'Artemus', 'Driffill', '423-147-5387', '1956-05-19', 'y'),
('astudeartu@youtu.be', 'AAluHyKWn7K', 'Artus', 'Studeart', '103-913-9671', '1994-04-05', 'y'),
('awoodard2a@is.gd', 'oGsQwAK7z', 'Arty', 'Woodard', '791-956-4534', '1998-03-29', 'y'),
('alockyeare6@businessinsider.com', 'T9baMmEdBV1F', 'Ash', 'Lockyear', '842-254-9001', '1968-07-31', 'y'),
('aticksalljr@addtoany.com', 'P9dMMnCHAH2H', 'Asher', 'Ticksall', '421-125-6002', '1976-03-08', 'y'),
('acarlesine@ucoz.com', 'V6gNxJIQXB5', 'Ashlen', 'Carlesi', '855-931-3398', '1973-09-24', 'y'),
('astert9h@foxnews.com', 'ubUEN6gZjAf', 'Ashlin', 'Stert', '514-400-4226', '1952-08-09', 'y'),
('apurchonc1@unc.edu', 'ObqWUGKits29', 'Ashton', 'Purchon', '452-959-8049', '1976-04-22', 'y'),
('abeamondrq@utexas.edu', 'TufePSXdCOkp', 'Astrid', 'Beamond', '602-651-9784', '1952-05-31', 'y'),
('afryman20@naver.com', 'w72aXs', 'Aubry', 'Fryman', '191-852-9052', '1970-10-10', 'y'),
('aiveyj4@histats.com', 'XUivbBRvDT', 'Audie', 'Ivey', '387-707-1900', '1971-11-16', 'y'),
('asheerespu@sourceforge.net', 'LA8CIqbW', 'Audrie', 'Sheeres', '207-281-9822', '1961-12-04', 'y'),
('aacomb11@wisc.edu', 'gc9IBaV8bJWq', 'Audy', 'Acomb', '691-142-5656', '1955-05-15', 'y'),
('ademongenl@trellian.com', 'R7EMfST0', 'Aundrea', 'Demonge', '272-581-4055', '1952-08-03', 'y'),
('acasselykx@webmd.com', 'eqSIkldu', 'Aurel', 'Cassely', '367-165-8146', '1997-04-18', 'y'),
('abeentjesng@whitehouse.gov', 'UFlR7eBkbz', 'Aurelie', 'Beentjes', '343-631-9607', '1999-12-27', 'y'),
('achessman1b@census.gov', 'L56X1q8nZEb', 'Aurlie', 'Chessman', '283-540-3926', '1985-11-24', 'y'),
('asheircliffe4l@bing.com', 'cCfDZup1', 'Auroora', 'Sheircliffe', '388-139-6826', '1979-07-12', 'y'),
('ahosburnp9@admin.ch', 'Uxos7Xvc', 'Aurthur', 'Hosburn', '532-484-1420', '1999-04-30', 'y'),
('acarlens6m@sphinn.com', 'qc1wpf', 'Aveline', 'Carlens', '532-140-2346', '1970-12-19', 'y'),
('agomesh0@blog.com', 'mdNywylirhO', 'Aveline', 'Gomes', '880-754-9019', '1984-08-21', 'y'),
('avasyukov5@slate.com', 'h66Q96Q', 'Averil', 'Vasyukov', '701-782-7278', '1976-09-02', 'y'),
('akemitt2m@ca.gov', 'iXmiE0So53vH', 'Avery', 'Kemitt', '389-758-1759', '1971-02-24', 'y'),
('acecijd@wunderground.com', 'IQkjROkW6c', 'Avie', 'Ceci', '594-495-4878', '1985-04-13', 'y'),
('acarayolla@jimdo.com', 'twOAkASH', 'Avis', 'Carayol', '162-521-5925', '1990-06-04', 'y'),
('amarqyeso@infoseek.co.jp', 'UbGiDrfEPbK', 'Axel', 'Marqyes', '404-880-9497', '1972-11-12', 'y'),
('agaskinshk@jiathis.com', 'mPfqUOsBfkO', 'Ayn', 'Gaskins', '268-209-0127', '1967-02-17', 'y'),
('bcrabbbw@blogs.com', 'i9msayW', 'Babara', 'Crabb', '781-320-2440', '1994-01-14', 'y'),
('bklaussenl4@purevolume.com', '7Yz0Dw', 'Babette', 'Klaussen', '194-191-0842', '1951-10-16', 'y'),
('bcasirolias@howstuffworks.com', 'or1kXfUycs', 'Bald', 'Casiroli', '316-377-5812', '1951-02-10', 'y'),
('bwessellfw@pcworld.com', '3Xx409Cz', 'Bald', 'Wessell', '398-125-7111', '1983-02-15', 'y'),
('bfranceo8@phpbb.com', '4sKmMEl', 'Balduin', 'France', '782-526-2109', '1973-02-09', 'y'),
('bveltmanen@homestead.com', 'GLgJLdPllt', 'Bambi', 'Veltman', '440-243-2150', '1989-03-08', 'y'),
('bdewanebh@google.fr', 'jtZvY29d', 'Bambie', 'Dewane', '573-986-1878', '1953-01-24', 'y'),
('bferberp3@feedburner.com', '0TQbd5', 'Bank', 'Ferber', '657-590-8042', '1981-05-29', 'y'),
('beadie2y@businesswire.com', 'Kmr81AhHX3l', 'Barbabra', 'Eadie', '619-605-8584', '1953-05-01', 'y'),
('bivantyevl7@odnoklassniki.ru', 'VmZiN57WI', 'Barbara', 'Ivantyev', '305-473-1231', '1954-10-20', 'y'),
('bmccreery47@cloudflare.com', 'Ul1kbrBrHZq', 'Barbey', 'McCreery', '217-357-0228', '1966-08-07', 'y'),
('bcowterd9x@slashdot.org', 'Os3zaNA8mmi', 'Barbie', 'Cowterd', '796-268-1598', '1984-07-23', 'y'),
('bmcmurtyli@techcrunch.com', '0MSf33c4', 'Barbie', 'McMurty', '674-966-7040', '1966-07-10', 'y'),
('bdanaherag@is.gd', 'NlSqSHd4XL3', 'Barnebas', 'Danaher', '224-799-3310', '1994-07-04', 'y'),
('bhughmang8@chron.com', 'S8eR99ll1nQ', 'Barney', 'Hughman', '857-685-0358', '1953-05-12', 'y'),
('bmcentegartmx@latimes.com', 'pUXLNE', 'Barnie', 'McEntegart', '131-382-3503', '1961-02-15', 'y'),
('bosgar8m@stumbleupon.com', 'uUm6oM2K', 'Barry', 'Osgar', '451-428-5351', '1956-02-14', 'y'),
('bduchateaulk@sciencedaily.com', '9vf88a2VT', 'Bart', 'Duchateau', '206-545-4733', '1950-12-02', 'y'),
('bmeneelyc8@miibeian.gov.cn', 'yhngdhe', 'Bartholomeus', 'Meneely', '650-624-5598', '1969-07-24', 'y'),
('bgwalterjs@patch.com', 'f1i70u2Wk5', 'Barty', 'Gwalter', '956-819-2423', '1995-04-12', 'y'),
('bpeasbylk@hugedomains.com', 'aJyvDaeP4UW6', 'Basia', 'Peasby', '914-731-5411', '1957-02-05', 'y'),
('bmacnamaran0@eepurl.com', 'uuAdZRR0a', 'Basile', 'MacNamara', '470-764-2579', '1951-10-02', 'y'),
('bgraebereh@accuweather.com', 'pknhKtGbo', 'Basilio', 'Graeber', '937-962-0738', '1989-05-03', 'y'),
('bjiggens7@issuu.com', 'TK2qC6', 'Basilio', 'Jiggens', '165-692-1565', '1965-11-08', 'y'),
('bfaulkner1e@mlb.com', '8mrX3ucHE', 'Bastian', 'Faulkner', '164-219-0560', '1995-06-22', 'y'),
('bbynethad@scribd.com', 'EAbqNTgl', 'Baxy', 'Byneth', '132-680-8246', '1986-03-26', 'y'),
('bedgson28@economist.com', 'D4knPIx', 'Baxy', 'Edgson', '473-676-8239', '1951-03-10', 'y'),
('bchapellowiu@etsy.com', 'vieIJjGRlxy', 'Bayard', 'Chapellow', '681-514-8523', '1966-10-13', 'y'),
('bbatistelli8u@bloomberg.com', 'BTLLcN', 'Beatrisa', 'Batistelli', '438-757-4938', '1995-02-17', 'y'),
('bgavenii@qq.com', 'S6N0f89iNfAs', 'Beatrisa', 'Gaven', '356-376-4720', '1975-03-28', 'y'),
('bholdworthz@sciencedirect.com', 'YpIQ2X', 'Beatrix', 'Holdworth', '437-395-9415', '1967-09-20', 'y'),
('bivanshintsevpw@aol.com', 'IU1lilB', 'Beaufort', 'Ivanshintsev', '897-420-8674', '1978-03-12', 'y'),
('btempletonio@dailymotion.com', 'lTROsc', 'Becka', 'Templeton', '181-549-3747', '1998-10-06', 'y'),
('bdawdaryfk@google.com.hk', 'yCriGzCrzk6', 'Belia', 'Dawdary', '369-815-2713', '1988-11-17', 'y'),
('bmaccalliono9@shop-pro.jp', 'vLIIeajT', 'Belita', 'MacCallion', '313-618-5545', '1975-12-03', 'y'),
('bgatteridgea2@topsy.com', 'FS5Zjps', 'Belvia', 'Gatteridge', '601-838-9083', '1982-01-14', 'y'),
('bbatty73@wp.com', 'Qw55TO0g3ajD', 'Ben', 'Batty', '119-638-5181', '1967-05-04', 'y'),
('bvenmorenf@aol.com', 'FGkuCV6Izt', 'Ben', 'Venmore', '625-321-2282', '1966-09-04', 'y'),
('bfettis89@elegantthemes.com', 'pCx3T6l', 'Bendick', 'Fettis', '248-226-9013', '1974-04-01', 'y'),
('baltoftq8@senate.gov', 'z9aInikq', 'Benedict', 'Altoft', '574-675-8333', '1981-09-22', 'y'),
('bberriehf@europa.eu', 'Bc4gPdW', 'Benedicto', 'Berrie', '539-918-9532', '1965-09-04', 'y'),
('bszachniewicz2h@guardian.co.uk', '2LupZQMSgQBH', 'Benedicto', 'Szachniewicz', '793-561-6525', '1980-08-16', 'y'),
('bsoanpb@icq.com', 'nxprUx', 'Benetta', 'Soan', '873-197-0532', '1982-11-10', 'y'),
('bstarteaf@g.co', 'RTlAnVCpc', 'Benetta', 'Starte', '820-131-2581', '1972-02-06', 'y'),
('bocannovane34@mozilla.org', '7QcI0Dw', 'Benito', 'O\'Cannovane', '951-569-0030', '1992-05-05', 'y'),
('bbroggelli76@netscape.com', '09ozq4nO', 'Benjy', 'Broggelli', '236-711-8710', '1988-11-01', 'y'),
('bgregl8@liveinternet.ru', 'NNlOvWph9hKA', 'Bennett', 'Greg', '300-939-3252', '1974-10-17', 'y'),
('bseear1@4shared.com', 'UIq3Yyr', 'Benni', 'Seear', '503-202-5836', '1976-03-01', 'y'),
('bpiggin1r@deliciousdays.com', 'Bxo81Rf', 'Bennie', 'Piggin', '767-820-6489', '1955-03-01', 'y'),
('btiptaftrc@com.com', 'bDdv2I', 'Bennie', 'Tiptaft', '220-991-2118', '1953-01-11', 'y'),
('bpinnigerq@twitpic.com', 'DLsMfTW', 'Benoite', 'Pinniger', '823-471-4054', '1965-04-12', 'y'),
('bflucker5m@blogspot.com', 'xz18CBHt', 'Benson', 'Flucker', '370-125-1225', '1964-08-29', 'y'),
('bzielinskio4@about.me', 'Q3szf89eCOg', 'Benyamin', 'Zielinski', '144-217-4056', '1982-05-31', 'y'),
('bgiampietro56@bbb.org', '0rskhqQf7cOe', 'Berk', 'Giampietro', '546-112-9648', '1953-05-09', 'y'),
('buwinsom@bloglines.com', 'tSzWba', 'Bern', 'Uwins', '599-362-6457', '2001-04-26', 'y'),
('bbeagriegw@mail.ru', 'vl79eHCwuTP', 'Bernard', 'Beagrie', '876-908-0801', '1977-12-14', 'y'),
('benstonqy@hibu.com', 'IF5Uhc', 'Bernard', 'Enston', '761-604-0977', '1970-12-28', 'y'),
('bglyssanne2v@wikipedia.org', '9QwaKBJr', 'Bernardina', 'Glyssanne', '550-403-6001', '1966-12-22', 'y'),
('bkaspara1@mail.ru', 'm3CnBySe', 'Bernelle', 'Kaspar', '827-891-4286', '1963-09-28', 'y'),
('bthorowgoodre@apache.org', 'DbPe94gkx', 'Berny', 'Thorowgood', '404-546-0794', '1989-07-08', 'y'),
('bdownes2d@amazonaws.com', 'Tce9e07nPboD', 'Berte', 'Downes', '428-112-1106', '1963-11-26', 'y'),
('bmidghallei@examiner.com', 'aD4MZafPXB', 'Bertrando', 'Midghall', '986-891-5917', '1964-02-26', 'y'),
('boverlandli@hatena.ne.jp', '6qmBUxu5g8', 'Berty', 'Overland', '666-228-3171', '1962-10-01', 'y'),
('byanin5x@cnbc.com', '2m5flgJH4Oj', 'Bess', 'Yanin', '244-782-3629', '1988-12-01', 'y'),
('bdadgeeg@marriott.com', 'pRz9bWUa', 'Bessy', 'Dadge', '398-628-7580', '1999-04-02', 'y'),
('bthreadkello3@trellian.com', '5U4tQVALV', 'Beth', 'Threadkell', '167-396-7042', '1995-05-13', 'y'),
('bferresf0@hexun.com', 'hT0Itj', 'Bethina', 'Ferres', '621-411-1432', '1976-09-08', 'y'),
('bcandlinia@craigslist.org', 'wV1IsFsox', 'Betsey', 'Candlin', '888-887-2322', '1974-06-25', 'y'),
('boyleykb@so-net.ne.jp', 'JoiOA0', 'Beverley', 'Oyley', '842-441-7223', '1954-07-04', 'y'),
('bgoodhayiy@csmonitor.com', 'mwR7kKjc9cus', 'Biddy', 'Goodhay', '302-703-3787', '1966-10-08', 'y'),
('bdallaghanb3@google.com', '508Nlz43b', 'Billi', 'Dallaghan', '714-150-6131', '1976-06-07', 'y'),
('bsweetland9a@nature.com', 'wRG6ygoC', 'Birgit', 'Sweetland', '837-453-5783', '1965-10-05', 'y'),
('bwikeyah@linkedin.com', 'RAV7HIRzOUhr', 'Blaire', 'Wikey', '215-813-8566', '1972-06-12', 'y'),
('bpearnh2@merriam-webster.com', '2mg3MSmUXhfZ', 'Blake', 'Pearn', '412-501-9216', '1981-10-05', 'y'),
('bvaskovfq@pagesperso-orange.fr', 'lx1e2YB5pYfP', 'Blanche', 'Vaskov', '484-814-8318', '1979-04-17', 'y'),
('bleer3b@umich.edu', 'tzqhgUilg5HX', 'Blinnie', 'Leer', '338-615-9070', '1982-11-22', 'y'),
('bcritzen9h@123-reg.co.uk', 'fKmStSNK', 'Blinny', 'Critzen', '340-503-7650', '1969-03-09', 'y'),
('bcrinagef7@usda.gov', 'rI3Z68', 'Blondy', 'Crinage', '759-463-3176', '1996-11-14', 'y'),
('btueir@marriott.com', 'Jngpof', 'Blondy', 'Tue', '519-435-9546', '1970-08-24', 'y'),
('bsloweyir@shop-pro.jp', 'xLp6hA0', 'Bobbie', 'Slowey', '224-664-2539', '1979-04-14', 'y'),
('bfarnhillb@senate.gov', 'uZv1EtwL9QDi', 'Bobbye', 'Farnhill', '894-733-6353', '1995-10-13', 'y'),
('bklemenzq7@foxnews.com', 'rlQ4FBH', 'Bobbye', 'Klemenz', '334-100-3592', '1975-03-19', 'y'),
('bgerholdhh@harvard.edu', 'PDq9eOI9j', 'Bobina', 'Gerhold', '894-315-8739', '2001-10-24', 'y'),
('btromansfk@google.co.jp', 'PLpJkiEuiC', 'Bobina', 'Tromans', '607-406-7851', '1981-10-11', 'y'),
('bmoraledam9@tinypic.com', 'GsLUzFaqife', 'Bond', 'Moraleda', '561-786-8628', '1990-10-11', 'y'),
('bestable7c@list-manage.com', '5IcGEMmun', 'Boniface', 'Estable', '936-207-3604', '1964-02-27', 'y'),
('beustonl5@ycombinator.com', 'Oo3y9zagQbwo', 'Bonnie', 'Euston', '233-764-2801', '1976-07-03', 'y'),
('baskeyph@zimbio.com', 'BEL8ynFy', 'Boote', 'Askey', '445-501-3174', '1983-03-28', 'y'),
('bblinde0@over-blog.com', 'lpBcAOpPwM2', 'Booth', 'Blind', '576-852-0179', '1982-06-09', 'y'),
('bmoncasterlz@fastcompany.com', 'OqDxcjdYtvi', 'Boothe', 'Moncaster', '825-284-8561', '1962-07-29', 'y'),
('bdamperqf@chronoengine.com', 'yKxEXTwvyI0B', 'Borg', 'Damper', '913-329-6086', '1952-11-03', 'y'),
('bmusselwhiteik@yelp.com', 'YyKlFtRkLe2', 'Borg', 'Musselwhite', '783-914-0375', '1992-12-21', 'y'),
('bsharrattd7@toplist.cz', 'VBnw7wKSe', 'Boyce', 'Sharratt', '509-574-8200', '1999-05-22', 'y'),
('bcater15@go.com', 'hHajgdw', 'Braden', 'Cater', '129-837-7821', '1981-10-07', 'y'),
('bwaistalllp@jigsy.com', 'ZsAuFoL', 'Bram', 'Waistall', '619-527-1034', '2001-01-24', 'y'),
('bangove7d@bizjournals.com', 'BxFGcRI', 'Brana', 'Angove', '530-596-2617', '1996-03-02', 'y'),
('bgawkeka@devhub.com', '1lsN9KT', 'Brander', 'Gawke', '605-522-1003', '1954-04-23', 'y'),
('bmcfetridgei1@addtoany.com', 'Fyxqf3gT', 'Brander', 'McFetridge', '766-223-0694', '2001-01-26', 'y'),
('bdutnall8l@bloomberg.com', '7oyuCDleh', 'Brandise', 'Dutnall', '300-765-2273', '1992-04-22', 'y'),
('bruffellfr@yandex.ru', 'vyVxEJPXRXkH', 'Breena', 'Ruffell', '373-862-8136', '2000-07-11', 'y'),
('bpalffynj@etsy.com', 'nCT7ST', 'Bren', 'Palffy', '942-110-3366', '1993-12-26', 'y'),
('bdunnanqp@gnu.org', '6gDFzr7y', 'Brena', 'Dunnan', '729-970-2456', '1959-11-19', 'y'),
('bfinlator4t@dell.com', 'S63PavNdwq', 'Brenn', 'Finlator', '234-836-2660', '1997-10-06', 'y'),
('bbonallickcl@cnet.com', 'ZJRMLhF8', 'Brennen', 'Bonallick', '319-823-0504', '1984-10-20', 'y'),
('bhallbirddz@spotify.com', 'tipmUwk', 'Brent', 'Hallbird', '848-159-3101', '1965-08-02', 'y'),
('bvirginrg@cam.ac.uk', 'f5pUvr2wN7e6', 'Brian', 'Virgin', '100-229-4125', '1979-03-03', 'y'),
('bmashalfq@berkeley.edu', 'NuPNXybbPWWj', 'Brianna', 'Mashal', '942-443-2094', '1971-10-24', 'y'),
('bmcmeyler62@cafepress.com', 'aKVrNuFu', 'Bride', 'McMeyler', '521-401-5929', '2001-06-03', 'y'),
('bclemersonjy@google.nl', '295UbRY3', 'Brigg', 'Clemerson', '497-324-9869', '1983-05-16', 'y'),
('bvasilic6q@blogger.com', '85i0nkSKn', 'Brinna', 'Vasilic', '380-134-4109', '1977-03-02', 'y'),
('bousbieb0@wikimedia.org', 'fTwoeOIEgG', 'Brit', 'Ousbie', '541-744-1447', '1989-05-28', 'y'),
('bronaldsonaw@yahoo.co.jp', 'dC05s1O0yz8', 'Brittan', 'Ronaldson', '138-734-4185', '1953-02-09', 'y'),
('bsharpe3@mozilla.com', 'JuF9W89qB7G', 'Brittaney', 'Sharp', '503-316-8122', '1984-03-11', 'y'),
('bmorfordat@google.de', 'ntE0Of0A', 'Brittni', 'Morford', '703-457-1949', '1950-07-03', 'y'),
('bandrusyakok@facebook.com', 'LtBix7', 'Brod', 'Andrusyak', '161-172-4339', '1967-02-01', 'y'),
('bstillmanqs@prweb.com', 'K5y3mN3AW96', 'Brod', 'Stillman', '398-978-1906', '1976-07-19', 'y'),
('bparsandmk@facebook.com', 'FlNCXQ3E', 'Brody', 'Parsand', '217-825-9640', '1950-08-29', 'y'),
('bogroganejz@umn.edu', 'fLQ3KrUgq', 'Brooke', 'O\'Grogane', '794-908-4547', '2000-10-14', 'y'),
('bmcgonigle8g@indiegogo.com', 'Azib53V', 'Brucie', 'McGonigle', '381-474-0551', '1961-03-05', 'y'),
('bnewsteadfi@creativecommons.org', 'NRKvlmJJs', 'Bryce', 'Newstead', '675-210-3780', '1953-12-29', 'y'),
('bdallman93@fc2.com', 'Qk4CscihrmzX', 'Buck', 'Dallman', '766-353-5821', '1995-02-28', 'y'),
('bminguetag@hp.com', 'YadE6DumF', 'Buck', 'Minguet', '599-164-2715', '1971-11-04', 'y'),
('bpordal33@usnews.com', 'Oc4zma4eLb', 'Buck', 'Pordal', '695-784-1607', '1968-01-07', 'y'),
('bstrathern4g@360.cn', 'Z3pZxx', 'Buddy', 'Strathern', '967-693-9489', '1966-10-14', 'y'),
('bducaen7m@blogs.com', 'opU1Zi', 'Buiron', 'Ducaen', '406-827-5528', '1964-07-07', 'y'),
('bhartfleetib@yellowbook.com', 'YbebvmYjabo', 'Bunny', 'Hartfleet', '528-642-9413', '1954-06-06', 'y'),
('btillertonj9@admin.ch', 'HcXnPzbdry7U', 'Burr', 'Tillerton', '687-114-0687', '1981-01-18', 'y'),
('bhatcliffekq@newyorker.com', 'XVawanRX2', 'Burtie', 'Hatcliffe', '985-892-7495', '1955-12-02', 'y'),
('bhalson5r@indiatimes.com', '12ozqnnTBK', 'Byran', 'Halson', '452-267-9533', '1978-01-09', 'y'),
('cdigglef4@ox.ac.uk', 'WauLqHVulMfs', 'Caesar', 'Diggle', '199-189-7132', '1971-05-30', 'y'),
('chauxbypz@163.com', 'p40yIDfLe6D', 'Caitrin', 'Hauxby', '570-499-9690', '1970-04-27', 'y'),
('ccanerl@weibo.com', 'Gx297PU', 'Caldwell', 'Cane', '697-492-0006', '1951-10-24', 'y'),
('ccrosserpe@domainmarket.com', '6RavkdMI8VW', 'Caldwell', 'Crosser', '777-338-6209', '1950-08-17', 'y'),
('ctrundlergr@deliciousdays.com', 'VDwz8tiaC5Wk', 'Cam', 'Trundler', '830-445-3221', '1999-08-28', 'y'),
('cstormesl9@imageshack.us', 'ojb1MYmCd', 'Cameron', 'Stormes', '428-131-9369', '1984-03-30', 'y'),
('cdudin5q@google.ca', 'biTNwa', 'Camey', 'Dudin', '836-443-7164', '1984-12-01', 'y'),
('criepnx@amazonaws.com', '0HtH57', 'Camila', 'Riep', '892-102-4121', '1989-05-06', 'y'),
('cknaptonf7@liveinternet.ru', 'Jk0gFFEDsL95', 'Camille', 'Knapton', '679-998-2353', '1966-07-06', 'y'),
('clangridge7i@free.fr', 'IzXlhh4tsdSF', 'Carey', 'Langridge', '147-325-1556', '1985-12-07', 'y'),
('cdegoyfu@telegraph.co.uk', 'ihRwxX8', 'Caril', 'Degoy', '870-377-1615', '1997-03-13', 'y'),
('cbreese4l@blinklist.com', 'vAS0oaq', 'Carin', 'Breese', '713-803-0943', '1963-03-06', 'y'),
('cpeggramj7@yolasite.com', 'zFNuElI0el', 'Carine', 'Peggram', '736-905-9387', '1965-03-28', 'y'),
('caltimasea@istockphoto.com', 'qoVwumw', 'Carlie', 'Altimas', '148-738-7223', '1988-10-15', 'y'),
('cbarbierbd@examiner.com', 't16w0CvYQf', 'Carlynn', 'Barbier', '557-642-0369', '1970-09-07', 'y'),
('cmateogj@sun.com', 'tBBeFRTcCrqQ', 'Carmelia', 'Mateo', '583-240-9598', '1972-10-22', 'y'),
('cmacintyrelp@sciencedirect.com', 'Ao8at6', 'Carmelle', 'MacIntyre', '995-856-1420', '1988-08-12', 'y'),
('cbullmana7@forbes.com', 'EAI8IxOgL', 'Carmine', 'Bullman', '676-766-0611', '1962-01-07', 'y'),
('cherley7t@live.com', 'El8TmAFFs', 'Caro', 'Herley', '435-932-6887', '1961-02-06', 'y'),
('cyeoman9k@cocolog-nifty.com', 'Nq12Wl8SMkVv', 'Carolus', 'Yeoman', '816-944-9131', '1988-07-22', 'y'),
('csoltanfx@cnn.com', 'IxMV5mM4', 'Carrol', 'Soltan', '773-580-6473', '1979-06-12', 'y'),
('chabbemaiw@yellowbook.com', 'S2eZysvvx9p', 'Carver', 'Habbema', '230-753-4881', '2001-05-09', 'y'),
('crollinq6@oakley.com', 'g5utIw2', 'Cash', 'Rollin', '547-678-3448', '1966-09-02', 'y'),
('cmelmoth6x@woothemes.com', 'e0yIZv4My8', 'Cass', 'Melmoth', '661-919-2281', '1989-12-05', 'y'),
('ccaswillpi@bloglovin.com', 'c6RjVT1', 'Cassy', 'Caswill', '531-462-4573', '1963-03-24', 'y'),
('cmcconnachie8f@gmpg.org', '0hRR9G0AHP', 'Cate', 'McConnachie', '986-201-7374', '1965-09-24', 'y'),
('cfinchamjn@columbia.edu', 'mG6URDJB4ka', 'Caterina', 'Fincham', '141-252-2486', '1995-11-27', 'y'),
('cshropshiremh@sfgate.com', 'nITgtA', 'Catha', 'Shropshire', '926-371-3357', '2001-08-27', 'y'),
('cgreenacrehg@usnews.com', 'HxdrMmUMSN', 'Catherina', 'Greenacre', '501-819-7558', '1990-07-12', 'y'),
('chiddy90@wunderground.com', 'PySipUnW', 'Cathie', 'Hiddy', '531-950-0355', '1967-10-27', 'y'),
('cwilloway1p@github.io', 'F6nOX0hJjtVN', 'Cathy', 'Willoway', '771-917-3386', '1995-09-15', 'y'),
('cknatt7n@ftc.gov', 'J2XPymbSm', 'Catie', 'Knatt', '253-302-3012', '1972-06-08', 'y'),
('cgoodgeo6@adobe.com', 'UMhPvasGt', 'Catrina', 'Goodge', '838-299-5357', '1975-02-26', 'y'),
('ceusteslx@dell.com', 'CZbLDwMT', 'Cayla', 'Eustes', '759-188-5259', '1971-05-25', 'y'),
('cswatheridgemo@wordpress.org', 'xFgrXQp4C', 'Cayla', 'Swatheridge', '793-787-9896', '1950-10-04', 'y'),
('chenrichsendv@economist.com', 'IEhHz4ff', 'Cece', 'Henrichsen', '795-967-3552', '1989-08-19', 'y'),
('cedwardsot@salon.com', 'Y8iHVVdEUMuz', 'Cecilio', 'Edwards', '648-100-2040', '1964-07-23', 'y'),
('cjansson2i@studiopress.com', '7Chc0aoyA', 'Celeste', 'Jansson', '504-629-0571', '1955-11-13', 'y'),
('ccanons@sun.com', 'NGNxWwZdPzyW', 'Celestia', 'Canon', '308-982-6395', '1963-04-25', 'y'),
('cferryja@hp.com', 'PsQQarf', 'Celie', 'Ferry', '398-297-8249', '1997-09-29', 'y'),
('ckamienskigk@google.ru', 'y3UCI1', 'Cesya', 'Kamienski', '833-525-8813', '1956-06-06', 'y'),
('cpheardn@usa.gov', 'xDOlqpS7kU', 'Chaddy', 'Phear', '883-897-3645', '1998-11-11', 'y'),
('cpalatinije@simplemachines.org', 'pef84h1EQrq', 'Chan', 'Palatini', '918-153-0165', '1987-08-02', 'y'),
('cmolineauxcb@jalbum.net', 'B2tVWzgYPMY', 'Chance', 'Molineaux', '109-967-8665', '1953-10-14', 'y'),
('cmullinermn@gnu.org', 'Irj51b7O7I4', 'Chanda', 'Mulliner', '309-854-8285', '1979-02-24', 'y'),
('cshorto4c@techcrunch.com', 'xK2RFp', 'Chantalle', 'Shorto', '882-564-9663', '1965-03-18', 'y'),
('cworledge9e@mediafire.com', 'FlXCJq', 'Charil', 'Worledge', '536-727-5781', '2000-01-31', 'y'),
('cbeakes43@reverbnation.com', '5RwoKqn3', 'Charlie', 'Beakes', '373-393-9450', '1974-04-16', 'y'),
('ccuell2n@census.gov', '7SJziAPx', 'Charlotte', 'Cuell', '901-982-1097', '1958-03-17', 'y'),
('cgiordanoc6@godaddy.com', '20uGZjL', 'Charmaine', 'Giordano', '699-440-6062', '1961-09-07', 'y'),
('cmoleng0@yellowbook.com', 'rJh6434Ks', 'Charmion', 'Molen', '392-578-4848', '1965-07-07', 'y'),
('ccolnett27@a8.net', 'KDgqb4U', 'Chase', 'Colnett', '686-521-0469', '1994-02-03', 'y'),
('chalmkincz@goodreads.com', 'nNGIHW37', 'Chase', 'Halmkin', '367-788-6851', '1984-05-03', 'y'),
('cemmerson8j@wp.com', 's7CzJQtO', 'Chelsey', 'Emmerson', '842-664-0420', '1953-09-15', 'y'),
('cstickelp9@cdc.gov', 'O3qbwl', 'Chelsy', 'Stickel', '858-598-3554', '1980-07-21', 'y'),
('cassurev@npr.org', 'ZF1tNEn', 'Chere', 'Assur', '234-785-6022', '1991-04-28', 'y'),
('cbroadfieldew@sciencedirect.com', 'FH6g6wP', 'Cherilynn', 'Broadfield', '701-316-0781', '1961-11-17', 'y'),
('ccawkwell6n@businessinsider.com', 'Vr7Zheb4s', 'Cherise', 'Cawkwell', '296-581-8460', '1994-10-11', 'y'),
('cdeinhardf5@go.com', 'mhB1DKqKJr', 'Cherise', 'Deinhard', '939-566-3068', '1980-01-17', 'y'),
('ckisarz@huffingtonpost.com', 'XtMwVVL', 'Chick', 'Kisar', '300-742-4904', '1950-01-15', 'y'),
('cwitcherr2@t-online.de', 'yI9mUGs', 'Chickie', 'Witcher', '905-567-4139', '1960-07-18', 'y'),
('ctenny80@printfriendly.com', 'XPOH76iwo', 'Chicky', 'Tenny', '444-755-0703', '1996-03-01', 'y'),
('cditchett4q@jiathis.com', 'W8vXlXas', 'Chiquia', 'Ditchett', '448-250-0001', '1981-11-11', 'y'),
('cipsley5j@zdnet.com', 'd3Iy8Aj', 'Chiquia', 'Ipsley', '483-173-9466', '1954-04-05', 'y'),
('cfreiburgerpo@livejournal.com', 'rmOntpJ', 'Chris', 'Freiburger', '636-566-0565', '1992-08-26', 'y'),
('ccapnerkg@alibaba.com', 'TwsygJrF', 'Christan', 'Capner', '798-661-7776', '2000-02-18', 'y'),
('ckunkelrp@noaa.gov', 'M8gx91', 'Christian', 'Kunkel', '950-988-8390', '1995-04-28', 'y'),
('cgioriohw@webnode.com', '7qzqH7KspuA', 'Christie', 'Giorio', '814-761-5875', '1986-10-26', 'y'),
('ckittemanhg@printfriendly.com', 'UqXqqN', 'Christine', 'Kitteman', '459-516-3672', '1997-06-17', 'y'),
('cgrolmann6e@unicef.org', 'ZHxjMiOwh', 'Christoforo', 'Grolmann', '897-884-3842', '1970-03-25', 'y'),
('cfrayneny@buzzfeed.com', 'JMekALW', 'Christy', 'Frayne', '468-848-0219', '1953-04-17', 'y'),
('crheltona6@si.edu', 'hGbEWgDwx4', 'Christy', 'Rhelton', '594-160-9829', '1955-08-26', 'y'),
('ccotillardge@blogger.com', 'AwgeFEP', 'Christye', 'Cotillard', '415-924-0739', '1992-09-30', 'y'),
('clabden5f@flickr.com', 'kITwYBcZ', 'Christye', 'Labden', '764-676-2989', '1994-05-07', 'y'),
('cconboyjo@feedburner.com', '9KmzsziQx', 'Chrystal', 'Conboy', '838-847-4763', '1964-12-07', 'y'),
('casplen6l@goodreads.com', '1bty3ftr', 'Cicely', 'Asplen', '126-191-2861', '1985-08-28', 'y'),
('ccaslake7v@slashdot.org', '2KlULX6', 'Cinderella', 'Caslake', '413-999-3964', '1988-06-09', 'y'),
('clovinga8@ocn.ne.jp', 'gwH3Ns', 'Cindie', 'Loving', '511-143-8283', '1971-08-21', 'y'),
('cscarde@google.de', '3GxUZW6qqx', 'Ciro', 'Scard', '939-802-8179', '1993-11-07', 'y'),
('cdelaharpepf@4shared.com', 'K7dzMVcpKF4s', 'Clair', 'De la Harpe', '817-596-4229', '1996-12-18', 'y'),
('crookepp@army.mil', '0MqaAMrUyoY', 'Clair', 'Rooke', '797-303-4244', '1993-07-22', 'y'),
('cguillond4p@gmpg.org', 'Xi99TOu', 'Clarie', 'Guillond', '431-432-4229', '1968-12-07', 'y'),
('cogdahlb8@parallels.com', '6Z9lMjIiR', 'Clarisse', 'Ogdahl', '205-460-7221', '1976-05-16', 'y'),
('cmckissack2u@japanpost.jp', 'Mw3TXt9b', 'Clarita', 'McKissack', '170-825-0009', '1989-04-25', 'y'),
('cperfilig@ibm.com', '3bSA0e00DmS', 'Claudine', 'Perfili', '273-378-3219', '1951-07-20', 'y'),
('cmcilhattona5@ebay.com', 'v7pDeP', 'Claudio', 'McIlhatton', '400-339-4109', '1998-01-30', 'y'),
('cdonizeauil@epa.gov', 'SLZCIDu1Kv', 'Clea', 'Donizeau', '669-505-8435', '1978-03-31', 'y'),
('carens63@wikia.com', '5SNnr2R0', 'Clemente', 'Arens', '751-451-5517', '1971-12-01', 'y'),
('ccorrisones@globo.com', 'OsIryMKe8H', 'Clementine', 'Corrison', '867-708-5746', '1955-05-04', 'y'),
('cokief2@studiopress.com', 'awSLSjwwTl2', 'Clementine', 'Okie', '797-236-3481', '1999-12-25', 'y'),
('cfiller61@wired.com', 'vDSFJpa6nF', 'Cleo', 'Filler', '442-735-3305', '1991-06-11', 'y'),
('cbushell9j@nature.com', '3p6JYE8e', 'Clevey', 'Bushell', '457-649-6924', '1994-08-08', 'y'),
('cclisspv@posterous.com', 'c0MDrERCsE', 'Cloris', 'Cliss', '723-341-3422', '1952-11-09', 'y'),
('cruggef3@eepurl.com', 'FEzy86R', 'Cly', 'Rugge', '502-652-5947', '1965-01-10', 'y'),
('cbettison5o@canalblog.com', 'xhTGa6', 'Cob', 'Bettison', '161-308-1486', '1993-10-20', 'y'),
('cdonahue3f@myspace.com', '2TVhcXA2qhQ1', 'Cobbie', 'Donahue', '598-102-2618', '1981-01-08', 'y'),
('ccossor9v@icq.com', 'o9HjhpRUA', 'Codi', 'Cossor', '897-912-9255', '1998-08-26', 'y'),
('clongmanal@admin.ch', 'ksV9ruhGZ', 'Codi', 'Longman', '910-448-1680', '1977-08-30', 'y'),
('cpetyankinik@cbslocal.com', 'ibrIXCpT7Qv', 'Codi', 'Petyankin', '716-581-1867', '1988-02-17', 'y'),
('cdanilyakme@booking.com', 'JUv2KrbPY', 'Codie', 'Danilyak', '292-238-0050', '1982-02-15', 'y'),
('cwalchn7@craigslist.org', 'gavPH86Vf', 'Cody', 'Walch', '857-606-3254', '1981-05-23', 'y'),
('cfishce@usatoday.com', 'SsnWdoi', 'Coleman', 'Fish', '853-959-2242', '1974-08-01', 'y'),
('claweles88@tmall.com', 'wFyZFG', 'Colette', 'Laweles', '522-174-1614', '1986-05-11', 'y'),
('carnoutg@posterous.com', 'X3EglU', 'Colly', 'Arnout', '698-688-6810', '1950-03-19', 'y'),
('cshortonf5@home.pl', 'ewB0BlvUx', 'Colver', 'Shorton', '576-356-3720', '1972-06-19', 'y'),
('ceveristmi@businessweek.com', 'KmIyz5PALKf', 'Conney', 'Everist', '506-713-5472', '1988-02-07', 'y'),
('cgoolding4r@mlb.com', 'y9vXLVb', 'Conney', 'Goolding', '903-764-6739', '1965-03-25', 'y'),
('ctacey9u@netscape.com', 'YLuMMA', 'Conney', 'Tacey', '572-783-8410', '1997-06-06', 'y'),
('cmirfieldqg@yellowpages.com', 'ZK87hLy', 'Connie', 'Mirfield', '190-844-1824', '1973-04-09', 'y'),
('cmoulsdallih@so-net.ne.jp', '4GenfFYMq', 'Conny', 'Moulsdall', '529-977-9692', '1956-10-01', 'y'),
('cpinkard7j@constantcontact.com', 'xN756By65', 'Conroy', 'Pinkard', '553-381-9782', '1981-02-10', 'y'),
('cmeyrick95@angelfire.com', 'KUSt7DBU', 'Constance', 'Meyrick', '990-779-5386', '1982-07-09', 'y'),
('ctrangmard8@twitpic.com', 'r4MNSPQt', 'Constanta', 'Trangmar', '352-305-2136', '1960-06-30', 'y'),
('csambiedgehe@craigslist.org', 'oziVj9X3S', 'Consuela', 'Sambiedge', '699-909-9561', '1971-06-13', 'y'),
('crubinj1@skyrock.com', 'SDaXEBlB', 'Corabel', 'Rubin', '980-162-5096', '1972-03-18', 'y'),
('cvolk6w@people.com.cn', 'YutdGtQq5', 'Corabelle', 'Volk', '915-617-1112', '1953-11-02', 'y'),
('cchesson2b@samsung.com', 'iehyj4', 'Coral', 'Chesson', '562-982-2977', '1965-05-11', 'y'),
('clamming53@booking.com', 'tRjuZWmk2ft5', 'Coral', 'Lamming', '532-413-6665', '2001-11-25', 'y'),
('cshapiraex@unicef.org', 'IJnlq2', 'Coral', 'Shapira', '396-442-3219', '2000-12-04', 'y'),
('cdobrovolski4z@eventbrite.com', '5LFSHIpU', 'Corbie', 'Dobrovolski', '124-279-4213', '1956-08-23', 'y'),
('cingray44@virginia.edu', 'avO5V6yq', 'Cord', 'Ingray', '784-264-0167', '1977-11-18', 'y'),
('cgrimwadeet@artisteer.com', 'pmV0NbkjUsl', 'Cordey', 'Grimwade', '938-332-8788', '1980-05-12', 'y'),
('ciddonfl@blogtalkradio.com', 'IRxbMfTs', 'Cordie', 'Iddon', '548-993-4720', '1980-12-06', 'y'),
('cdonisem4@blinklist.com', 'Af6qfo82N', 'Corey', 'D\'Onise', '829-188-3994', '1957-04-15', 'y'),
('ckyne2s@yahoo.com', 'zIecWlIVb', 'Corey', 'Kyne', '236-567-4312', '1983-01-20', 'y'),
('cmcauliffear@xinhuanet.com', 'PXFBhCiblCxH', 'Corine', 'McAuliffe', '996-293-1518', '2000-06-28', 'y'),
('cmettrickbo@domainmarket.com', 'iX1CK57G', 'Corliss', 'Mettrick', '858-210-3249', '2000-09-13', 'y'),
('cwarburton9i@lycos.com', 'NsxVGpfmWVb', 'Corly', 'Warburton', '918-878-0156', '1964-12-05', 'y'),
('csalleryer@weibo.com', 'znq54I', 'Cornall', 'Sallery', '153-566-5757', '1989-11-25', 'y'),
('cdinsalekt@myspace.com', 'ADOCTNCTScT', 'Cornelle', 'Dinsale', '230-171-4591', '1966-08-22', 'y'),
('cdifranceshci3x@narod.ru', 'vL0cYR8FwkVz', 'Correy', 'Di Franceshci', '789-476-7371', '1980-09-23', 'y'),
('caymericho3@google.com.au', 'U6fYMTZrFF', 'Corrie', 'Aymerich', '411-961-7236', '1955-02-11', 'y'),
('cmanicomor@cbc.ca', 'aH9JLpuoYR', 'Corrie', 'Manicom', '932-374-8991', '1997-10-06', 'y'),
('cmellers1f@xrea.com', 'OMFeWUAUXtEN', 'Cortney', 'Mellers', '783-863-5542', '1958-06-01', 'y'),
('cfarlane13@java.com', 'Qp8lbT1T', 'Costa', 'Farlane', '971-172-5485', '1980-12-08', 'y'),
('csandercrofth5@soundcloud.com', 'K7Haj70N', 'Courtenay', 'Sandercroft', '874-536-8720', '2000-12-21', 'y'),
('ccutridge5q@people.com.cn', '87liDwh', 'Courtnay', 'Cutridge', '440-877-8029', '1956-05-27', 'y'),
('cbenedito97@washington.edu', 'HovqD83zZ4k', 'Courtney', 'Benedito', '741-972-9236', '1962-09-03', 'y'),
('cnewislt@constantcontact.com', 'GMLYelOr6W', 'Craggie', 'Newis', '516-540-6522', '1950-10-01', 'y'),
('cbeetham6@posterous.com', '6F931s36X', 'Craig', 'Beetham', '666-395-0388', '1963-12-19', 'y'),
('ceateskk@unesco.org', 'jxa4Dc', 'Creigh', 'Eates', '449-872-9009', '1993-04-17', 'y'),
('cspringell65@elpais.com', '5Mvn2WEg7sL2', 'Creigh', 'Springell', '923-886-3390', '1983-05-10', 'y'),
('cjobina8@e-recht24.de', 'ap8kc4qqhg', 'Creighton', 'Jobin', '423-220-2018', '1999-06-04', 'y'),
('cwatheymg@home.pl', 'Yp0JXx1tHhg', 'Crin', 'Wathey', '124-483-8113', '1968-07-31', 'y'),
('csidebottomnw@yellowbook.com', 'xVBqaJ', 'Cristabel', 'Sidebottom', '223-933-1954', '1994-07-17', 'y'),
('csommervillejx@miibeian.gov.cn', 'zD4fXybn1q5K', 'Cthrine', 'Sommerville', '158-609-3118', '1992-12-14', 'y'),
('cgyppesc3@reverbnation.com', 'nlwEm3v', 'Cull', 'Gyppes', '139-933-9257', '1968-11-15', 'y'),
('colley8r@upenn.edu', '82NJJkU', 'Cullan', 'Olley', '732-185-1202', '1955-09-14', 'y'),
('cparnabyno@cafepress.com', 'dpuoNwV', 'Curran', 'Parnaby', '465-801-7218', '1993-10-24', 'y'),
('croxbeebp@wikia.com', 'JZelxyks', 'Cyb', 'Roxbee', '108-587-9624', '1974-09-22', 'y'),
('cpinningtonpg@nhs.uk', 'Ak4hJ9RFszi2', 'Cymbre', 'Pinnington', '234-532-1250', '1960-03-07', 'y'),
('cgoodboddy4o@woothemes.com', 'LMS7hwYO', 'Cyndy', 'Goodboddy', '905-531-5914', '1999-03-02', 'y'),
('cfreckletonbu@elpais.com', 'LkMLbHJUEX', 'Cynthea', 'Freckleton', '934-239-1179', '1984-09-05', 'y'),
('chillatt5l@hhs.gov', 'zABPvgWJDr', 'Cynthy', 'Hillatt', '954-245-7413', '1957-05-17', 'y'),
('cmoiseybv@redcross.org', '1e4pMPAPy68N', 'Cyrillus', 'Moisey', '893-253-4495', '1958-03-23', 'y'),
('dnieselml@microsoft.com', 'rA9TcqLdGzPn', 'Dacia', 'Niesel', '367-782-1441', '1964-04-29', 'y'),
('dthistleton6t@buzzfeed.com', 'yOKoIfq8', 'Dacia', 'Thistleton', '703-204-0500', '1951-12-24', 'y'),
('derik66@samsung.com', 'd7nxhZunD', 'Dael', 'Erik', '707-969-3952', '1976-08-29', 'y'),
('dmccarrollm0@etsy.com', '9oG6UBD9qXl', 'Dael', 'McCarroll', '295-389-6874', '1972-07-14', 'y'),
('dalenin42@sakura.ne.jp', 'V0hGOunwbG', 'Dagny', 'Alenin', '551-945-6516', '1988-01-21', 'y'),
('dchilderhousei0@dion.ne.jp', 'k7MFUQIO6', 'Dagny', 'Childerhouse', '432-329-7499', '1979-10-20', 'y'),
('dnelesfs@disqus.com', 'mDoaUCjOV0H0', 'Daile', 'Neles', '581-625-4569', '1962-03-20', 'y'),
('dmullearykc@typepad.com', 'ZMwYqcYGlrVj', 'Daisy', 'Mulleary', '707-756-7816', '1992-08-18', 'y'),
('dstedemz@utexas.edu', 'QzXzFZe3hf', 'Dale', 'Stede', '454-958-5866', '1992-03-08', 'y'),
('dcorstanng@smugmug.com', '6LQKQqFut', 'Dall', 'Corstan', '444-252-7512', '1964-07-30', 'y'),
('dmariottenq@surveymonkey.com', 'IuKB6xk', 'Dall', 'Mariotte', '399-886-6180', '1972-02-05', 'y'),
('dbrothersox@hugedomains.com', '0BVGd4ZPYVZY', 'Dallas', 'Brothers', '559-544-7295', '1995-09-01', 'y'),
('diacoviniqt@blogger.com', 'NVu6pTuuB', 'Dallas', 'Iacovini', '205-535-6321', '1986-11-26', 'y'),
('dtollandix@sfgate.com', '0DZy3UESdY', 'Dallas', 'Tolland', '914-333-6679', '1962-10-02', 'y'),
('dnattmy@macromedia.com', 'HpOVVu', 'Dallon', 'Natt', '506-678-9591', '1972-11-29', 'y'),
('dblincoe17@va.gov', '45jAHEGPR', 'Danica', 'Blincoe', '552-965-8087', '1983-10-23', 'y'),
('dhancockqb@statcounter.com', 'sJsN5lZzKCx', 'Daniela', 'Hancock', '323-815-4711', '1964-11-28', 'y'),
('dcritchlowrh@hostgator.com', 'pUdPfYN2H', 'Danny', 'Critchlow', '345-906-7320', '1962-12-22', 'y'),
('dbragger54@mayoclinic.com', 'wBXjyPR01us', 'Dannye', 'Bragger', '111-491-6186', '1954-11-16', 'y'),
('ddimmick1r@virginia.edu', 'wGa7K8p', 'Danya', 'Dimmick', '402-452-3968', '1995-06-23', 'y'),
('drainsburyj7@quantcast.com', 'vPl3TTF', 'Danya', 'Rainsbury', '920-747-0760', '1966-08-19', 'y'),
('dgaggh1@weebly.com', 'WZ42I58emRf', 'Daphne', 'Gagg', '926-274-0083', '1973-03-01', 'y'),
('dgentzsch9a@amazonaws.com', 'dFLsQ26v', 'Darcy', 'Gentzsch', '435-505-4922', '2000-10-20', 'y'),
('dhebard5i@cyberchimps.com', 'XSZte6lilu', 'Darell', 'Hebard', '722-484-3886', '1962-03-18', 'y'),
('dtruelock8v@springer.com', 'jMVldP7B9h', 'Darius', 'Truelock', '348-543-6630', '1994-08-06', 'y'),
('dbeedelleu@go.com', 'iuBTUXAxA', 'Darlleen', 'Beedell', '993-645-6569', '1962-07-22', 'y'),
('dvinaul2@dyndns.org', 'W3kRwa9X5c1', 'Darnall', 'Vinau', '229-773-2718', '1961-02-23', 'y'),
('droafa5@angelfire.com', '8m7o5QN3jGv', 'Darrel', 'Roaf', '382-954-2961', '1976-09-07', 'y'),
('dpetteford77@newsvine.com', '9mQ1Rm4Nsb', 'Darsie', 'Petteford', '880-698-5070', '2000-08-01', 'y'),
('dwisherjb@chicagotribune.com', 'LgOC7Qz', 'Darwin', 'Wisher', '757-847-0229', '1972-01-28', 'y'),
('daers1@craigslist.org', 'aMRXfC', 'Daryn', 'Aers', '551-484-9114', '1950-06-21', 'y'),
('dbriiginshawfh@edublogs.org', '1zaKcAus9IC', 'Dasha', 'Briiginshaw', '533-852-1860', '1984-01-13', 'y'),
('dwoolway2z@nymag.com', 'oXWxLG3', 'Dasya', 'Woolway', '456-946-7196', '1976-05-20', 'y'),
('dmingay5z@google.com.au', 'svJkp5', 'Daune', 'Mingay', '150-342-8296', '1997-02-07', 'y'),
('dstrainfl@cloudflare.com', 'vy3OqIoW', 'Daune', 'Strain', '674-663-5136', '1986-05-07', 'y'),
('dloftieoq@github.com', '144COeX', 'Dav', 'Loftie', '616-290-5712', '1992-05-26', 'y'),
('dloadernc@wikispaces.com', 'qljj0FrXaT5S', 'Davon', 'Loader', '205-336-8735', '1979-05-04', 'y'),
('dwestburyac@howstuffworks.com', 'FBtN6M0eWarN', 'Dayle', 'Westbury', '339-513-5742', '1972-09-30', 'y'),
('dberref@bbc.co.uk', 'sTfjY4gps258', 'Debbi', 'Berre', '847-172-6592', '1962-04-21', 'y'),
('dgurg3l@who.int', 'MjAPwA8lrZs', 'Deedee', 'Gurg', '328-971-9757', '1955-01-03', 'y'),
('dpoynzere8@xrea.com', 'NClJqKRxx', 'Deena', 'Poynzer', '547-121-5758', '1985-08-06', 'y'),
('dsanti2b@smugmug.com', '9KncIIGBYs', 'Dehlia', 'Santi', '921-486-9923', '1974-12-09', 'y'),
('dsharperiw@list-manage.com', 'aYxY223r', 'Dehlia', 'Sharper', '333-910-8567', '1961-12-27', 'y'),
('dmathieu7g@marriott.com', 'b9nhAM11IaA', 'Dela', 'Mathieu', '731-316-4408', '1965-09-27', 'y'),
('dmechemo@spiegel.de', '6LCePD1', 'Delaney', 'Mechem', '629-608-6020', '1957-08-26', 'y'),
('dnapper7q@guardian.co.uk', 'HNQNHAnFOi9K', 'Delbert', 'Napper', '138-668-4978', '1982-12-28', 'y'),
('dephgravebu@psu.edu', 'OJkNSwlxaS', 'Delcine', 'Ephgrave', '360-609-2891', '1992-03-22', 'y'),
('dallamc7@eventbrite.com', 'veZR7TEGn', 'Delia', 'Allam', '580-602-5155', '1961-08-10', 'y'),
('dspiers74@dion.ne.jp', 'THCRM93qLP', 'Delila', 'Spiers', '460-174-5751', '1981-03-25', 'y'),
('dvasilmanovh4@indiegogo.com', 'o9G9QL7hoklY', 'Delphinia', 'Vasilmanov', '460-467-8605', '1952-11-19', 'y'),
('dstenettdk@shutterfly.com', 'gwl8eNDtYv', 'Demetria', 'Stenett', '835-998-0416', '1956-04-21', 'y');
INSERT INTO `_user` (`user_email`, `pass`, `first_name`, `last_name`, `phone_number`, `dob`, `is_user`) VALUES
('dcuardall4i@bluehost.com', 'nLso0u7', 'Denis', 'Cuardall', '366-615-0465', '1975-05-22', 'y'),
('dpetegreelz@statcounter.com', 'CEtlb5', 'Denny', 'Petegree', '503-977-1863', '1994-03-18', 'y'),
('dfreibergf2@skyrock.com', 'BPL6A1hwUXX', 'Denver', 'Freiberg', '159-491-7586', '1959-12-05', 'y'),
('dmckanern@gmpg.org', '9AOPVk', 'Denys', 'McKane', '560-645-9472', '2001-05-28', 'y'),
('ddudderidge4t@ucsd.edu', 'BJae6E5QJOo', 'Derek', 'Dudderidge', '917-325-1342', '1953-07-30', 'y'),
('dianitti4s@ibm.com', 'gfVHEmh2BO', 'Derrik', 'Ianitti', '283-252-0398', '1992-11-16', 'y'),
('dcrantonei@drupal.org', 'EZ5Bem6P8', 'Derril', 'Cranton', '803-465-2475', '1950-02-01', 'y'),
('dmarguerite86@paginegialle.it', 'cUP8nJl7Yna4', 'Derwin', 'Marguerite', '513-722-8664', '1976-01-11', 'y'),
('dallison76@dedecms.com', 'PlAJdVSJJ', 'Devina', 'Allison', '943-256-7037', '1950-10-10', 'y'),
('dmawhinneyp@dagondesign.com', 'zyWBByF9O', 'Devinne', 'Mawhinney', '132-930-9135', '1961-04-29', 'y'),
('dsimms3y@cafepress.com', 'JZZivVk2', 'Devlen', 'Simms', '755-498-3643', '1992-07-28', 'y'),
('dtrelease48@lulu.com', 'J6y3NX9kZhWX', 'Dexter', 'Trelease', '397-498-7029', '1983-09-26', 'y'),
('dgarifflu@uiuc.edu', '655swAb5PZdX', 'Di', 'Gariff', '711-277-0309', '1984-02-25', 'y'),
('dchapelle7p@miibeian.gov.cn', 'l2oWZqI', 'Dicky', 'Chapelle', '560-279-8643', '1969-01-12', 'y'),
('ddmitrichenkoco@over-blog.com', 'd4cMZXIoGFT', 'Dicky', 'Dmitrichenko', '415-457-5920', '1974-02-10', 'y'),
('dgamil8m@e-recht24.de', 'uVCr7Snf', 'Diego', 'Gamil', '711-706-3825', '1981-01-15', 'y'),
('dkemster6s@moonfruit.com', 'dTWmRhxTgJ0', 'Diego', 'Kemster', '797-633-1325', '1980-05-27', 'y'),
('dstobbesqt@jiathis.com', 'qpwxR9W9xaZ', 'Dietrich', 'Stobbes', '522-217-6948', '1974-08-07', 'y'),
('dcoond9@nydailynews.com', 'WIgCOX5KJ', 'Dill', 'Coon', '750-398-2721', '1983-10-01', 'y'),
('dbonfieldmd@hao123.com', 'lHUPnUKeF', 'Dilly', 'Bonfield', '240-961-6835', '1979-09-02', 'y'),
('dcruden79@phoca.cz', 'ouvWJ7iJE', 'Dimitry', 'Cruden', '339-913-3429', '1970-07-30', 'y'),
('dtomneye8@smh.com.au', 'UUSAR9p9B', 'Dionne', 'Tomney', '795-560-2573', '1970-03-31', 'y'),
('dbonannok@columbia.edu', 'SwN94krQwS74', 'Dody', 'Bonanno', '478-496-1862', '1960-07-19', 'y'),
('dransburyby@slashdot.org', 'VC8Nr1', 'Dom', 'Ransbury', '443-847-6586', '1950-12-27', 'y'),
('dtitcomb93@ustream.tv', '3dxzQWlI', 'Dom', 'Titcomb', '644-299-4511', '1974-01-28', 'y'),
('dgerrad3d@devhub.com', 'YsEOKkqif', 'Domini', 'Gerrad', '904-288-9715', '1964-04-04', 'y'),
('dstrasegn@state.tx.us', 'BSOGY6S9V', 'Dominick', 'Strase', '230-387-6314', '1999-01-27', 'y'),
('dlougheedpb@xinhuanet.com', 'Mzsqr5k', 'Dominik', 'Lougheed', '224-536-6631', '1976-11-04', 'y'),
('dleakner1w@si.edu', '8sGD9ZxQVvQF', 'Don', 'Leakner', '973-899-0896', '1991-10-17', 'y'),
('ddurnallq1@cbc.ca', 'IDXF8ipYvzvc', 'Dona', 'Durnall', '135-374-3979', '1992-05-15', 'y'),
('dwhatford3v@npr.org', 'NFrWYlDIeUG2', 'Donalt', 'Whatford', '574-755-9847', '1959-08-19', 'y'),
('dheggesoz@senate.gov', 'lLtvMhtMCsXt', 'Donelle', 'Hegges', '830-234-2385', '1962-07-15', 'y'),
('djenicek64@reference.com', 'qFbOo3q', 'Donelle', 'Jenicek', '743-725-3485', '1961-12-24', 'y'),
('dhedingh@scientificamerican.com', 'FkI6TYr', 'Donetta', 'Hedin', '794-960-0916', '1996-02-18', 'y'),
('dtodhunterez@foxnews.com', 'NaJu8VFo', 'Donnajean', 'Todhunter', '672-155-6177', '1963-10-14', 'y'),
('dkendala4@slideshare.net', 'QwfgG2lt7N', 'Donnell', 'Kendal', '732-449-2987', '1952-11-28', 'y'),
('desomehm@princeton.edu', '4aw3Ce', 'Donnie', 'Esome', '100-727-7238', '1999-07-21', 'y'),
('dmacgiffiniu@imgur.com', 'MSGIPxi', 'Donny', 'MacGiffin', '351-893-3148', '1989-05-18', 'y'),
('darmingq@desdev.cn', 'nLQibNAflPoV', 'Dora', 'Armin', '291-172-2057', '1966-02-06', 'y'),
('dfilipputti96@theguardian.com', 'MjQwL3', 'Dorene', 'Filipputti', '104-330-5541', '1990-04-03', 'y'),
('ddarbishireet@nasa.gov', 'AGCnpAhqw9w', 'Doretta', 'Darbishire', '716-639-2336', '1950-06-01', 'y'),
('dwestfrimley6g@vimeo.com', 'qsSjQ4', 'Doretta', 'West-Frimley', '344-784-8214', '1950-12-05', 'y'),
('dgodilington4c@nationalgeographic.com', 'qc9Z4AKqo2BA', 'Doria', 'Godilington', '117-961-1666', '1957-07-27', 'y'),
('dholdforthmv@163.com', 'auw04fq3J', 'Doria', 'Holdforth', '968-259-1437', '1990-06-27', 'y'),
('dlageml@sun.com', 'VALMHCkbJCZ', 'Dorian', 'Lage', '939-735-6034', '1990-04-10', 'y'),
('dtrimnellpa@statcounter.com', 'rouXYr0qKH', 'Dorie', 'Trimnell', '134-739-0091', '1962-11-26', 'y'),
('dmclauchlinkg@patch.com', 'hT8N418nFjBM', 'Dorolisa', 'McLauchlin', '406-783-4468', '1986-11-17', 'y'),
('djoscelyn9p@ihg.com', 'GDgLgOYLJ0mq', 'Dorothea', 'Joscelyn', '698-557-8086', '1977-05-11', 'y'),
('dnettingcv@goo.gl', 'wdf2h3NlS', 'Dorothy', 'Netting', '727-876-9017', '1951-11-23', 'y'),
('dpeppard31@barnesandnoble.com', 'WaqGYiEVs', 'Dorothy', 'Peppard', '796-988-0288', '1996-12-23', 'y'),
('drobartic@fastcompany.com', 'CB74fVdYv', 'Dorthea', 'Robart', '945-666-3606', '1980-11-08', 'y'),
('dmulloch4u@umn.edu', 'a3iV23OMo4v', 'Dot', 'Mulloch', '936-213-9238', '1964-06-07', 'y'),
('dloraino7@issuu.com', 'LEjSXKS9Yz', 'Doti', 'Lorain', '542-693-4380', '1966-11-26', 'y'),
('dcamps@imgur.com', 'x1UGBIvVN', 'Dottie', 'Camp', '484-191-1889', '1953-07-24', 'y'),
('deastridgeb5@xinhuanet.com', 'XFlGYs', 'Doug', 'Eastridge', '391-288-7922', '1988-10-03', 'y'),
('dwhitehairky@behance.net', 'hTXsdc', 'Dru', 'Whitehair', '452-161-8791', '1987-07-12', 'y'),
('dcutbush6v@ovh.net', '9iktj9CDc', 'Drucie', 'Cutbush', '999-560-0046', '1974-05-09', 'y'),
('dguineryp6@icq.com', 'JmcTkZV', 'Drucie', 'Guinery', '652-216-5505', '1985-04-06', 'y'),
('djoseferhd@amazon.com', 'AgNzQ5V3wd', 'Drucy', 'Josefer', '679-302-8812', '1971-11-19', 'y'),
('dbraghinina@bluehost.com', 'HbyjXtYf7SU6', 'Drud', 'Braghini', '239-682-6222', '1979-03-06', 'y'),
('dsilversmidt5n@time.com', 'vmJEjn', 'Drugi', 'Silversmidt', '999-983-1874', '1970-10-17', 'y'),
('ddorricottlv@gravatar.com', 'lX9xnQFX1kAf', 'Drusie', 'Dorricott', '314-556-2246', '1968-07-24', 'y'),
('ddarcey6d@weebly.com', 'kbshsMNSW', 'Dulci', 'Darcey', '272-801-8361', '1984-09-05', 'y'),
('dfelstead36@microsoft.com', 'DcdeiP6ZHX', 'Dulcia', 'Felstead', '261-967-0889', '1995-03-04', 'y'),
('dchristypd@noaa.gov', 'xlgObLox', 'Dunn', 'Christy', '797-200-9003', '2001-07-09', 'y'),
('dkintish2m@drupal.org', '2cfpkP1', 'Dunstan', 'Kintish', '953-133-7024', '1986-06-14', 'y'),
('dcapstickbd@live.com', 'MQnuKr6zJ', 'Dur', 'Capstick', '242-865-1811', '1988-11-02', 'y'),
('darklejy@about.com', 'zdcJBnQ', 'Dwain', 'Arkle', '515-264-2069', '1987-10-31', 'y'),
('dquogancy@wsj.com', 'g1JsUMgjsg', 'Dwayne', 'Quogan', '707-219-8798', '1956-09-03', 'y'),
('dbezemerez@youku.com', 'GpIO1V', 'Dylan', 'Bezemer', '229-238-6160', '2001-10-07', 'y'),
('dwilmott2p@earthlink.net', 'ltKJXcMt', 'Dylan', 'Wilmott', '417-480-6946', '1980-11-26', 'y'),
('ecobongy@google.it', 'FJt1t8o', 'Eadmund', 'Cobon', '572-949-3074', '1977-11-27', 'y'),
('enorwayon@nature.com', 'kmpUzlnvo', 'Eal', 'Norway', '367-324-6438', '1970-08-07', 'y'),
('egoodanewqj@angelfire.com', 's7CMpyY', 'Ealasaid', 'Goodanew', '642-166-0322', '1982-10-30', 'y'),
('eclemoesmr@webnode.com', 'N1YZmqns', 'Earl', 'Clemoes', '449-116-4066', '1994-09-23', 'y'),
('elhommee1i@edublogs.org', 'qZQeXkIYi', 'Early', 'L\'Hommee', '700-197-6544', '1994-05-14', 'y'),
('earrundaleb0@narod.ru', 'VEghzvkP', 'Eba', 'Arrundale', '113-980-1493', '1991-04-01', 'y'),
('enivenx@mail.ru', 'C8IKJzoos', 'Ed', 'Niven', '360-535-5179', '1975-08-07', 'y'),
('ebarbierp1@ameblo.jp', '5a98fT3Qlx', 'Eda', 'Barbier', '286-144-5369', '1996-02-21', 'y'),
('epiersehc@techcrunch.com', 'jLbBHIckJX', 'Edgar', 'Pierse', '959-855-0121', '1988-06-23', 'y'),
('etoobyjc@globo.com', 'jCStba', 'Edith', 'Tooby', '557-433-6521', '1986-02-11', 'y'),
('ebaukhambi@japanpost.jp', 'jTwsYe1', 'Edmon', 'Baukham', '611-839-8124', '1989-07-05', 'y'),
('egrimsdale2z@google.fr', 'VjC4MWZotYGu', 'Edmon', 'Grimsdale', '671-690-3518', '1995-09-26', 'y'),
('eswornhy@sitemeter.com', 'CUjPkwNBB', 'Edmund', 'Sworn', '604-580-1099', '1954-07-27', 'y'),
('emcveighf4@bloglovin.com', 'yFJJ9hkStC', 'Eduino', 'McVeigh', '791-237-9544', '1963-12-28', 'y'),
('emadillf1@ca.gov', 'NXJQWO', 'Edward', 'Madill', '125-342-1103', '1990-09-24', 'y'),
('eshorten1t@seesaa.net', 'D0RtmVogMNoG', 'Efren', 'Shorten', '889-457-9365', '1995-09-08', 'y'),
('erallingshd@is.gd', 'HSiHYtR58', 'Egon', 'Rallings', '728-716-6426', '1956-01-13', 'y'),
('emanaghfs@i2i.jp', 'NxJxmhNdtf9', 'Ekaterina', 'Managh', '658-599-2731', '1978-08-25', 'y'),
('emullallyq1@msu.edu', 'L7OibJ', 'El', 'Mullally', '818-300-3248', '1955-09-23', 'y'),
('eriedigerqx@apple.com', 'WvpfYg2Um', 'El', 'Riediger', '660-863-0905', '1967-04-10', 'y'),
('ehelleckasoi@usatoday.com', 'MhAiibt', 'Eldon', 'Helleckas', '183-815-1125', '2001-10-02', 'y'),
('ericardetab@skyrock.com', '5rpysP4', 'Elene', 'Ricardet', '867-550-5535', '1968-12-08', 'y'),
('egobathy@businesswire.com', 'fFRg749I', 'Eli', 'Gobat', '486-218-2448', '1979-09-05', 'y'),
('eberensqp@biglobe.ne.jp', '2oEYXohlYP', 'Elisa', 'Berens', '224-742-1633', '2000-09-20', 'y'),
('eshapter7r@samsung.com', 'uaPmu4pR4mZz', 'Elisabet', 'Shapter', '574-549-6784', '1973-12-17', 'y'),
('ehuygen8w@netvibes.com', '3vcP9Mv3OJ', 'Elise', 'Huygen', '245-887-3976', '1952-04-08', 'y'),
('ealdrenma@odnoklassniki.ru', 'qefyUGj55s79', 'Elita', 'Aldren', '950-267-6241', '1953-08-16', 'y'),
('eagaroc@forbes.com', 'gIC2wAT', 'Elizabet', 'Agar', '884-931-0605', '1964-09-30', 'y'),
('erzehorzme@hao123.com', 'C3m4WhOw', 'Elizabet', 'Rzehorz', '717-104-3355', '1964-08-27', 'y'),
('epimmockeal@meetup.com', '77bJoqRVF', 'Elizabeth', 'Pimmocke', '487-745-8356', '1965-04-12', 'y'),
('edaintry7b@nih.gov', 'R36h4i41e', 'Ellerey', 'Daintry', '266-818-1324', '1964-12-21', 'y'),
('esturge32@godaddy.com', 'ThUkZNplXt', 'Elliott', 'Sturge', '878-474-7691', '1976-01-07', 'y'),
('esheenhz@blog.com', 'BFEHBvvbdF', 'Ellis', 'Sheen', '673-812-3366', '1951-05-07', 'y'),
('eshilstonmm@icio.us', 'bxZabLdX', 'Ellswerth', 'Shilston', '823-102-8814', '1983-04-23', 'y'),
('elumsdaledf@w3.org', '8nzhZwhOwB', 'Ellsworth', 'Lumsdale', '392-260-6031', '1985-01-13', 'y'),
('egilbert8r@youtu.be', 'rFb8160oYt07', 'Elna', 'Gilbert', '443-806-0007', '1965-02-05', 'y'),
('esurmanhv@w3.org', 'p9M2mTu', 'Elna', 'Surman', '410-119-9793', '1998-08-07', 'y'),
('ebencher95@pinterest.com', 'Nbm24k', 'Elsy', 'Bencher', '827-340-1823', '1952-07-07', 'y'),
('etween61@g.co', 'unO4jd41k', 'Elva', 'Tween', '280-823-0106', '1977-06-23', 'y'),
('etunnah6f@loc.gov', 'VTb3rk8REZx', 'Elvyn', 'Tunnah', '121-886-3018', '1993-08-06', 'y'),
('eivashintsov4v@yandex.ru', 'zCzijM0RLcU2', 'Elyse', 'Ivashintsov', '107-275-5525', '1982-02-08', 'y'),
('erabjohnsk7@usgs.gov', 'SDmJp4amvj76', 'Elysee', 'Rabjohns', '302-830-8395', '1951-12-04', 'y'),
('efilpijh@booking.com', 'uNzv6uj32lG7', 'Emalee', 'Filpi', '641-122-9567', '1972-06-22', 'y'),
('efevierga@51.la', '0jYsByljz', 'Emelen', 'Fevier', '409-964-1136', '1973-02-16', 'y'),
('ecaig3o@craigslist.org', 'qFwE25NwVX', 'Emerson', 'Caig', '929-702-1923', '1968-01-07', 'y'),
('emcdavitt80@wikispaces.com', 'beBgXl', 'Emilee', 'McDavitt', '431-528-5562', '1968-12-03', 'y'),
('esimes58@slideshare.net', 'ij9mXIPUHyse', 'Emilee', 'Simes', '659-475-5293', '1973-07-30', 'y'),
('erecord49@dedecms.com', 'XvK7OGAx7J', 'Emilia', 'Record', '831-895-7403', '1979-04-28', 'y'),
('eshellshearow@forbes.com', 'dLOG3UV1', 'Emiline', 'Shellshear', '812-514-4809', '1982-01-25', 'y'),
('ehrusgv@behance.net', 'F8DfHkggM', 'Emlen', 'Hrus', '439-184-1638', '1991-07-24', 'y'),
('erhucroftax@nhs.uk', 'hOue7f', 'Emlyn', 'Rhucroft', '160-979-9676', '1961-01-06', 'y'),
('ekellittkq@boston.com', 'ls3Y99', 'Emma', 'Kellitt', '385-454-1665', '1956-02-18', 'y'),
('emarstersfg@microsoft.com', 'pDiUkHjHkB', 'Emmaline', 'Marsters', '225-924-2353', '1988-01-06', 'y'),
('ebrudenell1e@ask.com', '0bdLexl9m', 'Emmalyn', 'Brudenell', '664-244-6313', '1956-01-09', 'y'),
('ebushbyfv@bloglovin.com', '0BfFxLai', 'Emmalynn', 'Bushby', '884-440-1557', '1984-09-30', 'y'),
('eclubleym8@mit.edu', 'nGRLPToAbyeJ', 'Emmi', 'Clubley', '185-949-5743', '2001-10-08', 'y'),
('ewakes9v@dedecms.com', 'P5tDHMMCY', 'Enriqueta', 'Wakes', '421-797-7545', '1974-04-18', 'y'),
('eswindellsgu@wired.com', '5qV5vZB', 'Eolande', 'Swindells', '273-479-5566', '1992-02-08', 'y'),
('emasord@mtv.com', '2uQKxpHh', 'Erica', 'Maso', '574-555-9529', '1955-07-12', 'y'),
('ewollrauche7@loc.gov', 'pHe5GZeAh', 'Erie', 'Wollrauch', '576-291-7278', '1989-05-28', 'y'),
('epablos4x@pen.io', 'WhaevzeM6EQ', 'Erin', 'Pablos', '236-369-6373', '1962-10-04', 'y'),
('ehourstanha@bbc.co.uk', 'Oh32SM3yH', 'Ermin', 'Hourstan', '218-354-0227', '1957-06-21', 'y'),
('esivesk6@dailymotion.com', 'sET1fGsamtAR', 'Ernaline', 'Sives', '107-671-4581', '1971-06-24', 'y'),
('egippm@examiner.com', 'r83xfbGv3l', 'Ernestine', 'Gipp', '737-874-1295', '1988-06-05', 'y'),
('eskedgex@hao123.com', 'wSS8sNivnL', 'Erny', 'Skedge', '261-946-4020', '1987-11-16', 'y'),
('eaylmorer7@addtoany.com', 'pk2Anbhq', 'Ertha', 'Aylmore', '303-736-8536', '1988-11-12', 'y'),
('ewealleans3x@miitbeian.gov.cn', 'DSNUhEO5', 'Essa', 'Wealleans', '978-338-6629', '1994-09-17', 'y'),
('eburgon4m@ed.gov', 'kj74mBE', 'Estele', 'Burgon', '506-315-8871', '1967-09-22', 'y'),
('ewilcocksbx@elegantthemes.com', 'GWHZTX6L73', 'Estella', 'Wilcocks', '614-512-5873', '1975-05-16', 'y'),
('ehollidge5e@uiuc.edu', 'T6fqig9kOk', 'Estrella', 'Hollidge', '700-308-1666', '1995-06-23', 'y'),
('epriditt3d@cnet.com', 'sJZMu1g', 'Etan', 'Priditt', '466-945-7544', '2000-12-29', 'y'),
('evittelan@weebly.com', 'jtcephh7v3', 'Ethan', 'Vittel', '837-114-1691', '1952-09-08', 'y'),
('eibbetsone3@creativecommons.org', 'zicqvrKwP8', 'Ethelind', 'Ibbetson', '231-182-1759', '1961-07-30', 'y'),
('egarwillnr@dailymail.co.uk', 'bcV5v5', 'Etienne', 'Garwill', '673-367-8582', '1953-05-20', 'y'),
('eklos2w@answers.com', 'rIqRSk7vY3', 'Ettie', 'Klos', '486-806-8159', '1967-07-19', 'y'),
('esheedi6@redcross.org', 'Okuu2Zpy5', 'Euphemia', 'Sheed', '819-777-6653', '1975-01-20', 'y'),
('echelleydd@amazon.co.uk', 'Wbvk7VQv4', 'Evangelia', 'Chelley', '222-522-4187', '2000-07-13', 'y'),
('eyushmanovlc@wikispaces.com', '6NNsCboJ6w', 'Everett', 'Yushmanov', '621-627-7177', '1992-03-07', 'y'),
('eparsell6u@squarespace.com', 'AnUPw45aoUA', 'Evey', 'Parsell', '260-918-4782', '1992-08-09', 'y'),
('elabrom3z@vinaora.com', 'N6SoW0', 'Evvie', 'Labrom', '698-449-6163', '1979-06-02', 'y'),
('esitlinton3z@joomla.org', 'rZ07mk0O', 'Eziechiele', 'Sitlinton', '485-319-8782', '1977-02-16', 'y'),
('fwinsonpp@oracle.com', 'LjrbafZp', 'Fabe', 'Winson', '389-357-2360', '1973-11-30', 'y'),
('fdedamb6@yahoo.co.jp', 'TTvxJx', 'Fabio', 'Dedam', '185-684-2130', '1978-11-05', 'y'),
('ftwitty3@discuz.net', '05irxMmrTeE', 'Fabio', 'Twitty', '939-446-6920', '2000-03-18', 'y'),
('fhillsdx@naver.com', 'fRqxzUa', 'Faina', 'Hills', '757-333-0716', '1995-03-13', 'y'),
('fmckeney8l@bbb.org', 'vJmNQVJiQ0hZ', 'Faina', 'McKeney', '305-383-0877', '1995-11-07', 'y'),
('fpeddenev@senate.gov', 'AHOU3T56VQf', 'Fairleigh', 'Pedden', '531-529-0311', '1973-06-22', 'y'),
('fkunzeld4@thetimes.co.uk', 'BVODknm', 'Falkner', 'Kunzel', '585-124-3683', '1974-09-15', 'y'),
('fjerzycowskigt@parallels.com', 'zQ074Ejp6WS', 'Fanchette', 'Jerzycowski', '947-771-0659', '1987-09-10', 'y'),
('fmeddemmen67@oracle.com', 'Z96yCSl', 'Fancie', 'Meddemmen', '719-846-9932', '1995-11-03', 'y'),
('fkeming48@kickstarter.com', 'RYX6U8TL', 'Fania', 'Keming', '322-493-2265', '1966-05-19', 'y'),
('fuphill2y@oaic.gov.au', 'koSk5MwdTcAK', 'Fanni', 'Uphill', '214-795-2617', '1955-09-05', 'y'),
('fbishrq@alibaba.com', 'dT2mRhlo8sre', 'Farlay', 'Bish', '220-767-8298', '1973-02-18', 'y'),
('fpeepall14@gizmodo.com', 'itS54wFfA', 'Faulkner', 'Peepall', '830-768-2337', '1958-02-22', 'y'),
('frusheb9@wufoo.com', 'LNolRa3htLBb', 'Faun', 'Rushe', '647-559-2784', '1964-08-17', 'y'),
('fblackboro7i@ucoz.com', 'qZSzns', 'Fawne', 'Blackboro', '400-613-3763', '1971-01-02', 'y'),
('fgrote4j@shareasale.com', '8D9REBr', 'Faye', 'Grote', '573-840-2366', '1997-03-10', 'y'),
('fkleslbz@nationalgeographic.com', '3JzMa273', 'Fayina', 'Klesl', '279-336-7593', '1972-05-09', 'y'),
('fstrandn6@jugem.jp', 'GpyXUam', 'Fedora', 'Strand', '929-636-1233', '1955-11-04', 'y'),
('fscattergoodp6@ezinearticles.com', 'vFM6Br', 'Felic', 'Scattergood', '101-513-5807', '1962-02-09', 'y'),
('fothenlj@goo.gl', 'mY9c0F7eL', 'Felicio', 'Othen', '480-452-4393', '1987-11-10', 'y'),
('ffairbeard7b@theguardian.com', '5zGn7zs', 'Felicle', 'Fairbeard', '525-953-8069', '1977-12-25', 'y'),
('fbranganh8@unc.edu', '1Yzk5CpygC', 'Felisha', 'Brangan', '251-267-4871', '1969-01-27', 'y'),
('fskeycb@craigslist.org', 'caLeedTKx', 'Ferdinand', 'Skey', '158-194-8183', '1980-01-01', 'y'),
('fbambrughk4@360.cn', 'XHJzM8a', 'Fern', 'Bambrugh', '583-792-3613', '1999-12-21', 'y'),
('fweedeneu@goodreads.com', '2rG9iu8x0Y', 'Fernanda', 'Weeden', '888-245-0902', '1966-03-03', 'y'),
('ftidcombenr@illinois.edu', 'MpvZxYY', 'Ferne', 'Tidcombe', '616-376-5358', '1992-09-21', 'y'),
('flesurfko@acquirethisname.com', 'elPJ51Qi', 'Fidel', 'Lesurf', '887-167-2875', '1995-05-07', 'y'),
('feastwellnf@skyrock.com', 'LF1lIkoXLx9f', 'Fidela', 'Eastwell', '623-612-3176', '1961-05-03', 'y'),
('fellerkerk0@technorati.com', 'unPNuwhC', 'Fidela', 'Ellerker', '122-708-3538', '1958-02-08', 'y'),
('ftibolsmr@123-reg.co.uk', 'Gpw9QJm', 'Fidelia', 'Tibols', '512-161-1777', '1978-08-03', 'y'),
('fcolhounbl@mtv.com', '1Fjhpp7A29YU', 'Fifi', 'Colhoun', '115-863-5101', '1999-01-31', 'y'),
('fjelfrp@gravatar.com', 'L9dSBYelLWi', 'Fifi', 'Jelf', '393-759-9912', '1979-05-31', 'y'),
('fshirleyqh@webnode.com', 'a4UMzEB1Oaz', 'Filberto', 'Shirley', '146-744-3074', '1970-04-28', 'y'),
('feyerg@behance.net', 'KFRTXU0aTE', 'Filia', 'Eye', '322-234-1522', '1974-09-22', 'y'),
('fpanyero2@aboutads.info', 'rNoimwIj', 'Fitz', 'Panyer', '366-892-8214', '1990-05-09', 'y'),
('frigler7w@slate.com', 'o0kphWg56NAk', 'Flemming', 'Rigler', '626-129-9084', '1995-12-31', 'y'),
('fkingescote5@epa.gov', 'YWm7Jx3JW8sZ', 'Fletch', 'Kingescot', '837-392-3302', '1994-10-18', 'y'),
('fogelsbyij@networksolutions.com', 'Ch50LI', 'Flinn', 'Ogelsby', '944-554-3562', '1957-09-23', 'y'),
('fplaingm@blogger.com', 'nWFULAkJo', 'Flint', 'Plain', '447-555-1655', '1954-10-27', 'y'),
('fwreforddh@columbia.edu', 'kR89Y69O', 'Flora', 'Wreford', '565-522-3521', '1979-06-30', 'y'),
('fdonnell3i@go.com', '7eQxCeaYB', 'Florance', 'Donnell', '962-949-5943', '1985-07-10', 'y'),
('flavellecd@squarespace.com', 'zsFS29QfbR', 'Florence', 'Lavelle', '325-370-8757', '1964-03-09', 'y'),
('ffrushardel@tuttocitta.it', 'Ye0qyF', 'Florencia', 'Frushard', '602-346-8621', '1962-11-28', 'y'),
('fshingfield50@parallels.com', 'pudeGTGH6mI6', 'Florette', 'Shingfield', '539-804-1324', '1972-06-28', 'y'),
('fhandasydeis@slashdot.org', 'wUHrZPjOI4Af', 'Florida', 'Handasyde', '630-743-5732', '1950-04-23', 'y'),
('fbankhurst4n@blinklist.com', 'RluMEm', 'Florinda', 'Bankhurst', '577-938-5315', '1950-03-09', 'y'),
('fbonhillmc@google.com.br', 'SHpK1vldo3', 'Florri', 'Bonhill', '290-424-6745', '1959-05-15', 'y'),
('fhalypl@microsoft.com', '4zjIwabgz', 'Flory', 'Haly', '475-430-9269', '1983-07-14', 'y'),
('fbier5a@state.tx.us', '3un960', 'Flossy', 'Bier', '539-583-5745', '1989-06-25', 'y'),
('fgermon2d@prlog.org', 'H0g1ieH0l', 'Flossy', 'Germon', '646-385-9364', '1953-11-06', 'y'),
('flairdmo@google.com.au', 'otQnXW3XT', 'Fons', 'Laird', '551-981-9579', '1982-07-25', 'y'),
('fforshaw5e@hp.com', 'Wnucxtn7', 'Forrester', 'Forshaw', '593-338-7870', '1953-11-22', 'y'),
('flandman4u@seattletimes.com', '6YkSVaV', 'Forster', 'Landman', '322-146-0524', '1961-02-25', 'y'),
('fbycraftm3@fda.gov', 'XuAj6F4harj', 'Fran', 'Bycraft', '272-549-6669', '1961-01-30', 'y'),
('fcampion2k@unesco.org', 'iMadoYG3', 'Francine', 'Campion', '384-957-0194', '1993-08-01', 'y'),
('fforson5l@ihg.com', 'J5FaBQvDu', 'Francoise', 'Forson', '731-886-6879', '1980-02-04', 'y'),
('fmcsparranj6@hugedomains.com', 'cGL69Q3nWez', 'Freddi', 'McSparran', '715-332-5264', '2000-10-26', 'y'),
('fsappsonoe@godaddy.com', '7YBlqYWtxe', 'Freddy', 'Sappson', '528-712-2826', '1960-11-04', 'y'),
('frydzynskigm@archive.org', 'WAe8pMH', 'Fredi', 'Rydzynski', '258-692-5818', '2001-08-17', 'y'),
('fgeorgesonl6@senate.gov', '4Uu2MJuL8W7', 'Fredrick', 'Georgeson', '904-150-1549', '1976-06-18', 'y'),
('fgoosnellnb@mozilla.org', 'ZWKCx9Rkii', 'Fredrick', 'Goosnell', '520-417-8129', '1951-07-10', 'y'),
('farthey7o@moonfruit.com', 'Rp9T8ATPUJs1', 'Freida', 'Arthey', '179-417-2990', '1971-12-17', 'y'),
('gbocock8q@alexa.com', 'OJXDKdGoIzN', 'Gabi', 'Bocock', '860-411-6933', '1991-12-28', 'y'),
('gdouce3s@hostgator.com', 'IHO6Nj', 'Gabriel', 'Douce', '568-960-3532', '1982-02-14', 'y'),
('gerrichil3@cnet.com', 'zHZLjZhz', 'Gabriela', 'Errichi', '797-136-9320', '1998-10-24', 'y'),
('gvaughanjx@yellowpages.com', 'bav5b2wxo', 'Gabriele', 'Vaughan', '155-843-0610', '1959-04-15', 'y'),
('gsolwayn1@tripod.com', 'H2zkgeZDU', 'Gaile', 'Solway', '527-181-5016', '1974-03-21', 'y'),
('giacopettih2@samsung.com', 'Fr4NG2QPq6M', 'Galven', 'Iacopetti', '121-560-2739', '1990-05-30', 'y'),
('gscowcraftld@bizjournals.com', 'fZjpZLPaE', 'Galvin', 'Scowcraft', '291-830-4212', '1955-07-20', 'y'),
('gloadsmanq4@ucoz.ru', 'qrlppr', 'Gannon', 'Loadsman', '537-506-0292', '1965-06-18', 'y'),
('gelcoata2@umn.edu', 'Y512YwR2GLaL', 'Garold', 'Elcoat', '440-182-3397', '1988-01-10', 'y'),
('gaugustin1s@economist.com', 'aJF7rNQ', 'Garret', 'Augustin', '745-920-9656', '1966-01-30', 'y'),
('gdubbleoj@nydailynews.com', 'zXOmkRvTXm', 'Garret', 'Dubble', '811-594-3022', '1993-09-09', 'y'),
('gangelc7@ucoz.ru', '8BQ06k', 'Garrett', 'Angel', '984-374-7267', '1992-12-11', 'y'),
('gemblincl@ning.com', 'vzYhYrnR', 'Garry', 'Emblin', '231-562-4016', '1951-01-30', 'y'),
('gellwood1v@php.net', 'ogvBXRHy', 'Garvey', 'Ellwood', '264-695-5845', '1993-12-20', 'y'),
('grashleighhv@jugem.jp', 'OKWQJSi', 'Garvey', 'Rashleigh', '868-146-0235', '1998-12-31', 'y'),
('gmarcubk@technorati.com', 'QNpIdLESfmJo', 'Garwood', 'Marcu', '191-823-3371', '1997-11-18', 'y'),
('gmartinec7h@privacy.gov.au', 'QdDFzO', 'Garwood', 'Martinec', '966-495-9395', '1997-08-24', 'y'),
('gcurtonj0@prlog.org', 'hb8bOa', 'Gaston', 'Curton', '173-468-6493', '1972-06-29', 'y'),
('gleprovosti4@domainmarket.com', 'KIuMeeBK2uk', 'Gates', 'Le Provost', '231-455-6804', '1961-03-12', 'y'),
('ggravellsgz@photobucket.com', 'iJdqyKfVt', 'Gauthier', 'Gravells', '793-103-2071', '1977-08-16', 'y'),
('gloucheha@com.com', 'U5wznfEqA9e', 'Gavrielle', 'Louche', '808-691-1492', '1961-10-11', 'y'),
('gbreukelman8i@usa.gov', 'ILiFvnkb', 'Gayla', 'Breukelman', '619-861-3978', '1968-04-22', 'y'),
('gpipkinfe@nytimes.com', 'gizCew0X', 'Gearard', 'Pipkin', '552-933-2667', '1962-09-22', 'y'),
('gcreaser1j@npr.org', 'TLIRVio6x', 'Gene', 'Creaser', '346-498-9916', '1995-01-23', 'y'),
('gplail3s@de.vu', 'gOxMm7G', 'Gene', 'Plail', '657-265-2865', '1997-02-13', 'y'),
('gstentonkl@twitter.com', 'QU3VJNSoT', 'Gene', 'Stenton', '616-476-9779', '1974-01-05', 'y'),
('gmarcamkk@wikipedia.org', 'ML3F6gfKj', 'Georas', 'Marcam', '637-424-4042', '1951-03-13', 'y'),
('gbateyfg@icio.us', 'n1n005cMKib', 'Georgeanna', 'Batey', '129-787-6232', '1957-06-20', 'y'),
('gbowlesworth7s@drupal.org', 'A0ASfwzqf', 'Geraldine', 'Bowlesworth', '926-514-3184', '1968-09-21', 'y'),
('gdeetlefsht@reuters.com', 'oZjgnW9', 'Gerhardt', 'Deetlefs', '490-942-3108', '1965-12-03', 'y'),
('gvendittoea@disqus.com', 'rjyQMi', 'Gerianna', 'Venditto', '806-100-3490', '1965-01-13', 'y'),
('gmathisfy@spiegel.de', 'OY2ne0e', 'Gerianne', 'Mathis', '368-246-5043', '1970-03-30', 'y'),
('gonionl3@yellowbook.com', 'CRRU1vQiWj', 'Gerome', 'O\'Nion', '376-454-9879', '1959-09-21', 'y'),
('gblissittl0@hud.gov', 'm91EN9ozx2L', 'Giacopo', 'Blissitt', '714-806-0251', '1980-07-02', 'y'),
('gfawloro@chicagotribune.com', 'j48TEiyEZNk', 'Giana', 'Fawlo', '298-824-0531', '1969-03-04', 'y'),
('gglewau@vimeo.com', 'OgPXWd', 'Giana', 'Glew', '387-353-6268', '1989-04-21', 'y'),
('gfilov2e@huffingtonpost.com', '4ZHpfiO2PtY', 'Gianna', 'Filov', '285-684-6947', '1979-01-26', 'y'),
('gancketill7c@cafepress.com', '6p7VBmjyTYG', 'Gianni', 'Ancketill', '189-413-3191', '1964-07-07', 'y'),
('gscraggeh@macromedia.com', 'zJS5llyLH9fm', 'Giavani', 'Scragg', '466-100-1015', '1980-03-15', 'y'),
('gkettlewellej@wikimedia.org', 'aAYp8PyG', 'Gibby', 'Kettlewell', '694-526-8483', '1954-01-29', 'y'),
('grennox26@cbc.ca', 'rT7f8oh', 'Giffer', 'Rennox', '733-897-3323', '1962-04-13', 'y'),
('gcorcoran83@opensource.org', 'Pfyssuq', 'Giffie', 'Corcoran', '577-178-9075', '1967-11-01', 'y'),
('ghendriksends@blinklist.com', 'JfMOngZUcyok', 'Giffie', 'Hendriksen', '104-942-9365', '1963-06-18', 'y'),
('garchanbaultc2@yelp.com', 'aovhYJIO', 'Gifford', 'Archanbault', '141-171-1491', '1957-09-12', 'y'),
('gkerswell8k@oracle.com', 'vcVvZy', 'Gilberte', 'Kerswell', '981-420-4674', '1992-04-08', 'y'),
('gimrieqa@hc360.com', 'OHXOeCwHT', 'Gilbertine', 'Imrie', '666-114-1419', '1998-08-07', 'y'),
('ggoalleycu@dmoz.org', 'lQdH3G', 'Gill', 'Goalley', '249-597-8865', '1980-01-31', 'y'),
('glawteyj8@people.com.cn', '4dGLA2iGxUBX', 'Gilligan', 'Lawtey', '305-816-6337', '1975-04-19', 'y'),
('gdahmel66@boston.com', 'wFlvPLEsbb4S', 'Giordano', 'Dahmel', '999-710-4829', '1969-06-05', 'y'),
('gantalie@live.com', '5P5TdXHo01', 'Giorgia', 'Antal', '130-421-0797', '1958-05-14', 'y'),
('gstewartsonnh@livejournal.com', 'skCLuPz', 'Gipsy', 'Stewartson', '587-510-5728', '1972-07-26', 'y'),
('gblackford5f@unesco.org', '7kHicOZPDB', 'Giralda', 'Blackford', '893-274-2546', '1996-11-29', 'y'),
('gvowlesdq@w3.org', 'uaKqaca', 'Gisella', 'Vowles', '585-495-6480', '1978-08-21', 'y'),
('gwigsello0@archive.org', 'VraAgPkp3pQ', 'Gisella', 'Wigsell', '661-354-1180', '1969-05-12', 'y'),
('gskillanders7x@eepurl.com', 'Ncwij1Vgnv', 'Giulio', 'Skillanders', '898-328-4509', '1969-04-05', 'y'),
('gmenhamft@nih.gov', 'uXAeGe2JY', 'Giustina', 'Menham', '885-501-4008', '1971-08-22', 'y'),
('ggregond@xing.com', 'E6RRbel1x3mc', 'Giusto', 'Gregon', '691-164-8961', '1984-02-16', 'y'),
('gjenkinol@comsenz.com', 'OY7Cpz', 'Glad', 'Jenkin', '649-466-2075', '1996-02-05', 'y'),
('gblakeleyew@blogspot.com', 'jpstC0bt', 'Gleda', 'Blakeley', '875-654-7327', '1968-04-25', 'y'),
('gdwinejc@aol.com', 'Z3JPgcxvIhTc', 'Glennie', 'Dwine', '440-884-3645', '1953-03-24', 'y'),
('goverstreet94@dailymail.co.uk', 'hiry3riqBiX', 'Gloriane', 'Overstreet', '248-283-7693', '1962-09-01', 'y'),
('gfairbank88@state.tx.us', 'gGSBYz', 'Glory', 'Fairbank', '114-168-2640', '1989-06-12', 'y'),
('ggoaterks@taobao.com', 'Nsh38on49p', 'Glynda', 'Goater', '491-313-0355', '1957-02-13', 'y'),
('gduddingh@facebook.com', 'wO7v7fn3', 'Goldina', 'Duddin', '503-709-0751', '1970-07-02', 'y'),
('gfalkjq@cnbc.com', 'r6AGA9Deyx9', 'Gonzales', 'Falk', '768-937-1625', '1955-12-12', 'y'),
('gtarbath4p@moonfruit.com', 'ycyxaH29', 'Goober', 'Tarbath', '228-501-3823', '1995-06-08', 'y'),
('ggowman87@scientificamerican.com', 'DAAaJQrq', 'Gordan', 'Gowman', '102-973-9446', '1954-07-07', 'y'),
('gdurbyn5b@about.com', 'GCOcCoFk', 'Gordon', 'Durbyn', '510-988-2395', '1983-05-22', 'y'),
('grampley1y@360.cn', '48CjTQqLyqyJ', 'Gottfried', 'Rampley', '862-295-1315', '1957-02-02', 'y'),
('gtreffreym1@netscape.com', 'V96vSG7Q5O', 'Grady', 'Treffrey', '211-311-4806', '1989-02-02', 'y'),
('glearmouthu@wordpress.org', '3raIEvCTi', 'Graig', 'Learmouth', '686-304-2762', '1963-05-20', 'y'),
('gdidsburypk@i2i.jp', 'v9KtOAor', 'Grantham', 'Didsbury', '452-772-1540', '1960-07-21', 'y'),
('gthornally37@myspace.com', 'WpDzMakq', 'Gratiana', 'Thornally', '725-711-9736', '1953-01-19', 'y'),
('gyukhnevichdw@webs.com', 'WNhunoMVO', 'Grazia', 'Yukhnevich', '989-472-5174', '1993-02-01', 'y'),
('gnoliep@icio.us', 'rz6pOGszCqcw', 'Greer', 'Noli', '861-196-1784', '1975-06-16', 'y'),
('gmoulink5@addtoany.com', 'Nfee8Ih17Q', 'Greg', 'Moulin', '859-789-5237', '1992-06-06', 'y'),
('gvickarqe@chron.com', 'BfAo95wG9b6M', 'Gregg', 'Vickar', '819-137-4958', '1956-04-24', 'y'),
('gwyldboredq@weather.com', 'HXZB25Dy', 'Gregorio', 'Wyldbore', '379-115-0406', '1994-09-30', 'y'),
('gtongelx@posterous.com', 'AtI78K', 'Gregory', 'Tonge', '699-686-2072', '1982-05-21', 'y'),
('gfeuella9@zimbio.com', 'BHIGCMo', 'Gretal', 'Feuell', '950-484-7761', '1987-08-22', 'y'),
('gfochsg9@eepurl.com', 'EB8KCeAm', 'Griffy', 'Fochs', '578-231-0099', '1968-09-02', 'y'),
('gcarrabotmi@yandex.ru', 'GNdJltbJ29A', 'Guendolen', 'Carrabot', '857-444-3395', '1984-03-09', 'y'),
('gdublin2u@whitehouse.gov', 'WTYNCjN', 'Guenna', 'Dublin', '956-303-4768', '1978-06-12', 'y'),
('gnaulch@baidu.com', 'MgW7kzgNdULx', 'Guenna', 'Naul', '649-110-6069', '1975-10-27', 'y'),
('gmasurelgp@guardian.co.uk', 'yJWAMCqStES', 'Guilbert', 'Masurel', '273-134-7695', '1958-02-01', 'y'),
('grogerothq@bravesites.com', 'hsLk7r3', 'Guillaume', 'Rogerot', '340-537-4912', '1953-02-12', 'y'),
('gdrage5d@adobe.com', 'zsaksok', 'Gun', 'Drage', '883-904-6572', '1977-06-12', 'y'),
('gmccrowo1@blogger.com', 'j1HYdHIChiD', 'Gunther', 'McCrow', '537-193-8760', '1950-07-20', 'y'),
('gclemenzap8@cnn.com', 'C8EncVREY2', 'Gustavo', 'Clemenza', '768-909-2052', '1960-04-05', 'y'),
('gnafzigerg2@mashable.com', 'XEEpRNqop', 'Gustavo', 'Nafziger', '734-999-0890', '1950-11-14', 'y'),
('gtowsonai@ca.gov', 'GxnFjb', 'Gustavo', 'Towson', '252-715-7423', '1950-05-27', 'y'),
('gryvesjt@state.gov', 'o6Q2i9GuY', 'Gwendolen', 'Ryves', '327-679-6153', '1986-07-16', 'y'),
('gtorricellar9@epa.gov', '2SzwZSu', 'Gwendolyn', 'Torricella', '890-404-7103', '1982-09-05', 'y'),
('goscroftkn@ucoz.ru', 'UBUpHSVzF', 'Gwenore', 'Oscroft', '851-705-2324', '1973-01-30', 'y'),
('harkellct@businesswire.com', 'M6WmyQxW3h', 'Had', 'Arkell', '874-125-4389', '1967-11-20', 'y'),
('htinsley68@dagondesign.com', 'J3djcU2Q', 'Hali', 'Tinsley', '602-999-6346', '1978-06-28', 'y'),
('hhentze82@boston.com', 'GYhiFI', 'Halie', 'Hentze', '758-173-2955', '1963-06-10', 'y'),
('hhalkyardmc@wufoo.com', 'G4sF3gAci', 'Hallie', 'Halkyard', '442-964-1665', '1953-08-30', 'y'),
('hedinburgh34@livejournal.com', 'waLojbkZSxiY', 'Hally', 'Edinburgh', '206-715-2344', '1982-04-10', 'y'),
('hstoakescm@zdnet.com', 'Spg7EC', 'Hally', 'Stoakes', '721-797-3309', '1980-04-07', 'y'),
('hmowburyqq@clickbank.net', 'pRvL7NR', 'Hamel', 'Mowbury', '389-811-6431', '1998-10-22', 'y'),
('haselcx@ycombinator.com', 'RW7wwF2CS', 'Hamid', 'Asel', '717-298-5469', '1970-05-26', 'y'),
('hbeynke98@istockphoto.com', '6fz658M', 'Hamid', 'Beynke', '912-398-2731', '1993-09-17', 'y'),
('hedensaq@sina.com.cn', 'a0bD5MyPK', 'Hamish', 'Edens', '431-999-2221', '2001-07-26', 'y'),
('hbeatson4o@lycos.com', 'B1XPsj', 'Hanni', 'Beatson', '466-592-0145', '1996-01-16', 'y'),
('hpietsmap0@google.com.hk', 'Bty532E5hCWa', 'Hannie', 'Pietsma', '730-339-0507', '1953-11-19', 'y'),
('hbushe11@printfriendly.com', 'NuREGKgnbiwb', 'Hans', 'Bushe', '894-237-7625', '1983-10-16', 'y'),
('hziehmsnz@mashable.com', 'R7foe9', 'Harcourt', 'Ziehms', '841-198-7144', '1998-09-28', 'y'),
('hmcgeacheypr@facebook.com', 'fGeGIBGNjen', 'Harlan', 'McGeachey', '258-296-6356', '1954-11-22', 'y'),
('hdalgleish6m@theglobeandmail.com', 'MdkZrkZNui', 'Harmony', 'Dalgleish', '530-533-4069', '1951-01-17', 'y'),
('hmilleah@businesswire.com', 'ld1jit', 'Harold', 'Mille', '195-590-2755', '1980-06-14', 'y'),
('hupham1k@cbc.ca', 'XH37W6IcSmmC', 'Harri', 'Upham', '273-787-7151', '1996-10-24', 'y'),
('hdebellisoe@marketwatch.com', 'GPRuH7kScvQe', 'Harrietta', 'De Bellis', '456-785-3158', '1951-10-30', 'y'),
('hsevingn@elpais.com', 'tmADVcpCZRk3', 'Hasheem', 'Sevin', '560-199-8273', '1997-02-03', 'y'),
('hcharrett5n@live.com', '0dcsjub', 'Haskell', 'Charrett', '742-696-3329', '1966-02-12', 'y'),
('hpresterns@eventbrite.com', 'f2ZcDW1', 'Haskell', 'Prester', '602-800-9126', '1970-10-24', 'y'),
('hbrassenx@bloglovin.com', 'FVchul2yS', 'Hayden', 'Brasse', '470-963-8081', '1967-08-10', 'y'),
('hrunseyhp@redcross.org', 'Sz6Br0hIsL', 'Hayden', 'Runsey', '126-313-7059', '1984-07-03', 'y'),
('hglasscoe4y@illinois.edu', 'b1hbXFYVMvh', 'Heath', 'Glasscoe', '983-586-3243', '1986-10-13', 'y'),
('hubsdale16@cdc.gov', 'gNW4HREc9C', 'Heindrick', 'Ubsdale', '730-995-0240', '1961-08-11', 'y'),
('hfowgiesb4@patch.com', 'frPB4s', 'Helene', 'Fowgies', '979-505-6100', '1975-10-13', 'y'),
('hfineya0@whitehouse.gov', '0vItZ5zw1z', 'Helenelizabeth', 'Finey', '172-170-5077', '1960-12-13', 'y'),
('hlivoirb2@examiner.com', '9IkRGgJmRPZ', 'Helga', 'Livoir', '102-162-9510', '1999-04-13', 'y'),
('hohenerym2@reverbnation.com', 'ETvqxwtd8p', 'Helli', 'O\'Henery', '600-355-3481', '1987-04-13', 'y'),
('hstubbeley3y@mail.ru', 'yCPlN6knHFI5', 'Helyn', 'Stubbeley', '639-786-8508', '1990-07-21', 'y'),
('hswayton57@usda.gov', 'yzL86Y8B0', 'Henrieta', 'Swayton', '688-792-1105', '1970-07-21', 'y'),
('hambergpm@illinois.edu', 'T6d5biByT', 'Hephzibah', 'Amberg', '270-585-8886', '1977-08-17', 'y'),
('hkeytea4@is.gd', 'qZSdjDO1Xt4U', 'Herculie', 'Keyte', '465-912-1209', '1952-03-13', 'y'),
('hripper74@blogspot.com', 'td2UnPWhB', 'Herman', 'Ripper', '742-726-8296', '1996-06-08', 'y'),
('hfebre5i@sfgate.com', 'NWvUGiG', 'Hermann', 'Febre', '796-982-7672', '1987-06-04', 'y'),
('hchantillonnw@usnews.com', 'G7d1YTB', 'Herminia', 'Chantillon', '273-136-8826', '1959-02-03', 'y'),
('hhoward62@wired.com', 'veOrHYn6KdU', 'Herschel', 'Howard', '292-967-4353', '1950-03-08', 'y'),
('hchurcher9n@barnesandnoble.com', '4pVrJpJMWh3', 'Herta', 'Churcher', '567-927-3770', '1979-09-02', 'y'),
('hemonsjk@hc360.com', 'os97gvxcM', 'Hesther', 'Emons', '543-969-0123', '1991-03-24', 'y'),
('hgollardaf@bbc.co.uk', 'YhH0u235G', 'Hesther', 'Gollard', '474-307-8958', '1978-07-21', 'y'),
('hyearn5t@netscape.com', 'hiFAD21V', 'Hesther', 'Yearn', '454-147-8350', '1964-07-13', 'y'),
('hpinnijaren@feedburner.com', 'KMVnWET67y3', 'Hettie', 'Pinnijar', '314-630-5981', '2000-08-10', 'y'),
('hyockney9s@arstechnica.com', 'E5RNtx', 'Hewett', 'Yockney', '285-574-8259', '1998-01-29', 'y'),
('hkullmannqf@jigsy.com', 'HyxhjbXLk', 'Heywood', 'Kullmann', '820-211-2050', '1975-01-30', 'y'),
('hmelbourneeo@hp.com', 'yLYV2rMiK', 'Hi', 'Melbourne', '121-166-1381', '1995-02-16', 'y'),
('hcage1u@furl.net', '43OtIZfP', 'Hieronymus', 'Cage', '244-719-3932', '1968-10-03', 'y'),
('hhastinjv@samsung.com', '9KuoLYB', 'Hilarius', 'Hastin', '894-831-8221', '1956-11-19', 'y'),
('hscotlandda@amazon.co.uk', '0ff47DiS', 'Hilda', 'Scotland', '372-570-2987', '1989-10-24', 'y'),
('hcubbinin@instagram.com', 'smRqVUjeG', 'Hildagarde', 'Cubbin', '702-726-2548', '1980-07-07', 'y'),
('hpeeverc5@comsenz.com', 'o0umgOI', 'Hillery', 'Peever', '577-201-0442', '1957-08-31', 'y'),
('hmacritchieeq@angelfire.com', 'LsAM8Fj', 'Hilliary', 'MacRitchie', '964-575-9339', '1989-10-14', 'y'),
('hblais1o@google.ru', 'bSqma7u', 'Hilly', 'Blais', '317-339-1303', '1973-02-07', 'y'),
('hyegorkovi1@mapy.cz', 'mmfdoYj6', 'Hiram', 'Yegorkov', '987-460-9185', '1967-06-14', 'y'),
('hcroneg4@nps.gov', '2OrzvVYKv', 'Hobey', 'Crone', '566-977-1744', '1980-03-21', 'y'),
('hchristopher2j@yale.edu', 'PZBlg17XlPv', 'Hobie', 'Christopher', '588-180-4618', '1958-05-07', 'y'),
('hchristall10@dmoz.org', 'z2StT7teH', 'Hogan', 'Christall', '680-894-8286', '1997-03-21', 'y'),
('horiel71@comcast.net', 'Z5K3OpWd', 'Holden', 'Oriel', '711-215-1960', '1970-06-27', 'y'),
('hpieter9@woothemes.com', '00QNDbl5pc5b', 'Holly', 'Pieter', '106-679-8371', '1978-11-03', 'y'),
('hcameratiqa@youtu.be', 'ROTv4bpBTMl', 'Holmes', 'Camerati', '433-358-8197', '1958-06-11', 'y'),
('hsargersonbm@boston.com', 'FSVxHov', 'Holmes', 'Sargerson', '303-444-7954', '1953-08-04', 'y'),
('hmawtusbv@foxnews.com', '8hytEKXf', 'Holt', 'Mawtus', '382-856-8133', '1986-08-25', 'y'),
('htimmense4@infoseek.co.jp', 'EwMikRVlLp', 'Horatia', 'Timmens', '296-849-1754', '1951-02-06', 'y'),
('hhauxleybf@state.tx.us', 'jp6I82ONg', 'Horst', 'Hauxley', '922-962-4175', '1958-04-15', 'y'),
('hpetruszka5a@sina.com.cn', '2BegFB5Bg', 'Hort', 'Petruszka', '178-192-7160', '1996-01-15', 'y'),
('hastberyqm@trellian.com', 'rNlpz9hTyY', 'Horton', 'Astbery', '550-103-1587', '1981-12-17', 'y'),
('hfilippon3@jigsy.com', 'QwP02uMfBr', 'Howard', 'Filippo', '320-183-8816', '1975-08-22', 'y'),
('hwhorlowrd@mashable.com', 'To6A2q', 'Howey', 'Whorlow', '109-710-9879', '1962-08-18', 'y'),
('hquartermaink9@fotki.com', 'BCEmiZ', 'Hubert', 'Quartermain', '213-350-8814', '1993-10-02', 'y'),
('hsherratt2o@google.nl', 'lgKw2SEe3', 'Hubey', 'Sherratt', '175-751-1567', '1984-05-25', 'y'),
('hdecarolisgc@wsj.com', 'rWKmqb3WE8x', 'Humfrid', 'De Carolis', '656-305-2639', '1978-05-01', 'y'),
('heydelos@aol.com', 'pIUrD33QVSwn', 'Humfrid', 'Eydel', '632-157-2300', '1963-01-22', 'y'),
('hbiesingerja@mapquest.com', 'k38PLtuy1ZM', 'Huntlee', 'Biesinger', '281-185-5744', '1965-08-28', 'y'),
('hemsonni@sina.com.cn', 'hMRatGt', 'Husain', 'Emson', '851-314-7342', '1985-05-24', 'y'),
('higgulden1n@epa.gov', 'bhiMSztjr3', 'Hyacintha', 'Iggulden', '501-633-6833', '1979-07-22', 'y'),
('hdolbeyr2@google.com', 'otLXW3', 'Hyacinthe', 'Dolbey', '335-750-3731', '1950-12-11', 'y'),
('hconnoldj@ycombinator.com', 'DjZ5KMol', 'Hyman', 'Connold', '621-175-0335', '1981-04-29', 'y'),
('hfriedh1@jigsy.com', '2cZ5vthPs', 'Hymie', 'Fried', '338-845-3173', '1999-02-07', 'y'),
('idanymu@usda.gov', 'b46up9Wkgt', 'Ibby', 'Dany', '170-526-0068', '1956-12-30', 'y'),
('isallnowq6@imageshack.us', 'pYeCFbNdyi', 'Idalia', 'Sallnow', '660-388-3060', '1968-11-01', 'y'),
('ibrixeyaa@yelp.com', 'ZOLhoQjO', 'Ignaz', 'Brixey', '221-179-9350', '1976-11-06', 'y'),
('icoategf@buzzfeed.com', 'kzetbk4w', 'Ilario', 'Coate', '719-339-2453', '1996-03-26', 'y'),
('iepps1a@phpbb.com', 'ubwwwpfW32kR', 'Ileana', 'Epps', '171-851-3407', '1997-10-31', 'y'),
('igoaks9w@hexun.com', 'SnfBQ4', 'Ilise', 'Goaks', '616-901-7819', '1983-05-06', 'y'),
('icarlemq@fotki.com', 'sXCph3IeK8R', 'Ilse', 'Carle', '617-253-3988', '1998-09-17', 'y'),
('idwyerf1@ucoz.com', 'qYdWkmx', 'Ilse', 'Dwyer', '506-405-7577', '1960-10-12', 'y'),
('isanperedm@craigslist.org', 'iebgENbmNZF', 'Ilse', 'Sanpere', '412-802-7943', '1994-01-09', 'y'),
('icarik29@sohu.com', 'fHl04cVttgg', 'Ilyssa', 'Carik', '661-993-7312', '1960-11-03', 'y'),
('idemicoli1h@de.vu', 'nYqdRnRR1', 'Immanuel', 'De Micoli', '672-499-5566', '1954-09-19', 'y'),
('ifaynegl@parallels.com', 't7hKQLr', 'Ina', 'Fayne', '980-776-8003', '1954-04-24', 'y'),
('istonnelleb@indiegogo.com', 'PXbMqEbQFw', 'Inez', 'Stonnell', '768-971-1531', '1991-08-10', 'y'),
('igarnulq3@goo.gl', 'w1euLIVwUfN', 'Ingamar', 'Garnul', '659-507-3384', '1963-04-30', 'y'),
('imagowan3b@yolasite.com', '4QXl6PDe', 'Ingeborg', 'Magowan', '136-887-5509', '1950-03-16', 'y'),
('idebruynev@tuttocitta.it', 'lKcqvq3jVkQJ', 'Ingemar', 'De Bruyne', '707-399-8305', '1977-12-03', 'y'),
('iironside83@dagondesign.com', '6QVXqDbqn', 'Ingunna', 'Ironside', '822-220-7794', '1969-12-13', 'y'),
('iromaintpy@google.it', 'v0cFQF', 'Inna', 'Romaint', '663-121-3922', '1959-06-02', 'y'),
('ibenterman9k@craigslist.org', 'BcJxHOxrHQFK', 'Innis', 'Benterman', '844-621-9635', '1993-10-29', 'y'),
('icappell1x@usnews.com', 'rL09NjxIq', 'Innis', 'Cappell', '580-709-9479', '1972-03-20', 'y'),
('istoakleynq@ycombinator.com', 'X6szXDwz', 'Iorgo', 'Stoakley', '428-851-2129', '1986-08-15', 'y'),
('istudmanpq@csmonitor.com', '1wkNDQUSeC', 'Iormina', 'Studman', '471-348-3681', '1970-05-20', 'y'),
('iswiffan9q@soundcloud.com', '9HR2U8I', 'Ira', 'Swiffan', '847-651-5410', '1957-08-01', 'y'),
('iclaesens8k@jimdo.com', 'fb5wxje3A9k', 'Irina', 'Claesens', '743-681-2524', '2000-02-26', 'y'),
('ibartloszjv@exblog.jp', '4I5xmJ', 'Irvine', 'Bartlosz', '783-705-6495', '1973-08-30', 'y'),
('ipinching6q@theglobeandmail.com', 'BNJKLbmin6v', 'Irwinn', 'Pinching', '224-588-9735', '1977-01-11', 'y'),
('ivannerju@mac.com', 'RyYHfguF7', 'Isaac', 'Vanner', '507-844-3094', '1994-11-06', 'y'),
('istairmandog@hugedomains.com', 'iETpaJ5hUdu3', 'Isador', 'Stairmand', '776-143-4705', '1952-07-02', 'y'),
('imarkosed@china.com.cn', '2ZOTSK9', 'Isadora', 'Markos', '510-860-4340', '1985-09-26', 'y'),
('iwisniewskio0@toplist.cz', '2jzou6ckv2n', 'Isadora', 'Wisniewski', '601-123-6284', '1985-10-10', 'y'),
('isandelandr0@exblog.jp', 'yUJguEodi', 'Isidor', 'Sandeland', '330-527-8222', '1971-09-12', 'y'),
('iblachfordpw@ifeng.com', 'Jcm76bf', 'Isidoro', 'Blachford', '971-509-5040', '1955-12-24', 'y'),
('icurds8a@foxnews.com', 'BzaCE1EcxXqv', 'Isobel', 'Curds', '994-684-3447', '1983-06-03', 'y'),
('ibiggamph@alexa.com', 'PamYyKJSSXJ', 'Ivonne', 'Biggam', '199-646-0132', '1975-11-07', 'y'),
('ibindon2i@deliciousdays.com', 'L6pvORDT', 'Ivy', 'Bindon', '442-740-2114', '1980-05-07', 'y'),
('ibenazetjr@army.mil', 'e0rVXFNup4', 'Izaak', 'Benazet', '892-226-1674', '1956-07-22', 'y'),
('iarentsr1@dailymail.co.uk', 'SgOPWf5Z', 'Izabel', 'Arents', '593-393-3945', '1993-01-24', 'y'),
('jdursleyqh@ameblo.jp', 'q9F6iM4I', 'Jack', 'Dursley', '949-343-4652', '1971-11-26', 'y'),
('jcleevesi7@soundcloud.com', 'r0CyvZ6T', 'Jacki', 'Cleeves', '111-971-6633', '1987-08-11', 'y'),
('jscownms@sina.com.cn', 'hxi2ecg2ujJs', 'Jacklin', 'Scown', '263-555-8934', '1996-02-04', 'y'),
('jwestcaree@utexas.edu', '2qht8TSV', 'Jacklyn', 'Westcar', '431-317-7089', '1985-08-15', 'y'),
('jdouglissd0@twitter.com', 'JJvtR1Az1YAX', 'Jacky', 'Dougliss', '585-529-0622', '1996-04-21', 'y'),
('jmacmichael9e@e-recht24.de', 'Xmxy1Bk', 'Jacquelin', 'MacMichael', '504-669-3467', '1950-02-27', 'y'),
('jringwoode7@thetimes.co.uk', 'eyskAke', 'Jacquelynn', 'Ringwood', '793-589-1115', '1963-06-07', 'y'),
('jadamidesfr@tinyurl.com', 'aKUmRo1aKT', 'Jacquenetta', 'Adamides', '700-497-0590', '2001-05-29', 'y'),
('jmeadeniv@dyndns.org', 'XvZcRiJGL', 'Jade', 'Meaden', '842-594-5889', '1982-03-12', 'y'),
('joldredac@wordpress.com', 'oDVwoHlR', 'Jade', 'Oldred', '701-361-2242', '1978-12-13', 'y'),
('admin@ihg.com', 'password', 'Jaimie', 'Peek', '882-463-6566', '1994-05-07', 'n'),
('jpien2@shareasale.com', 'vB3zAgO5', 'Jaimie', 'Pien', '299-680-5253', '1987-08-15', 'y'),
('jjezzard7y@msu.edu', 'AvMF8tKcmV', 'Jaine', 'Jezzard', '737-367-6863', '1954-01-02', 'y'),
('jparradineis@mysql.com', 'WAxA1nPxo', 'Jake', 'Parradine', '943-364-7378', '1997-06-13', 'y'),
('jpernell4f@skyrock.com', 'FAbd1n', 'Jakob', 'Pernell', '977-456-8145', '1979-06-07', 'y'),
('jscoreynp@fc2.com', 'J3XiCAZnl4Z', 'Jan', 'Scorey', '260-810-1400', '1969-09-05', 'y'),
('jarnollk6@va.gov', '0wAMpGV0', 'Janenna', 'Arnoll', '602-669-0151', '1970-03-10', 'y'),
('jcotman9r@sfgate.com', '1aMI3f', 'Janice', 'Cotman', '193-158-2536', '1956-05-12', 'y'),
('jburety@earthlink.net', 'hoSoKnuT5gP', 'Janie', 'Buret', '568-318-3869', '1997-04-19', 'y'),
('jkneale98@taobao.com', 'jc2QbfTiXK', 'Janie', 'Kneale', '349-493-1912', '1952-12-20', 'y'),
('jadame39@ebay.co.uk', 'NV62J9gPlQgh', 'Janifer', 'Adame', '928-870-6458', '1964-11-16', 'y'),
('jstredderp4@addtoany.com', 'r9hDZO', 'Janina', 'Stredder', '459-392-1720', '1995-01-31', 'y'),
('jbyresro@ycombinator.com', 'g6aINiT9o', 'Jannelle', 'Byres', '888-336-8537', '1985-11-29', 'y'),
('jcollecottmx@webs.com', '54Mod3S', 'Janos', 'Collecott', '657-371-0199', '1993-06-09', 'y'),
('jmadrellof@dagondesign.com', 'xTgmlqzx6', 'Janos', 'Madrell', '570-507-3063', '1982-02-08', 'y'),
('jjiroutekln@yale.edu', 'qAjUW7MRzS', 'Jarad', 'Jiroutek', '789-607-4417', '1980-11-08', 'y'),
('jsimysont@aol.com', 'O0bFHm8iU', 'Jarid', 'Simyson', '545-461-9234', '1997-07-25', 'y'),
('jshapcottbs@elpais.com', 'JjT5kD', 'Jarret', 'Shapcott', '481-354-2392', '1990-10-22', 'y'),
('jflanndd@phoca.cz', 'Q5sKGo7fW', 'Jarvis', 'Flann', '793-477-5517', '1981-01-30', 'y'),
('jroftj@opensource.org', 'BHmWnwfn7F', 'Jasmine', 'Roft', '734-878-4752', '1983-09-01', 'y'),
('jspowage85@narod.ru', 'DCQDMMTJn8b', 'Jasper', 'Spowage', '470-460-9367', '1995-12-20', 'y'),
('joxfordho@sogou.com', 'JTjomySI35xd', 'Jaymee', 'Oxford', '957-361-2356', '1984-06-08', 'y'),
('jcochqc@cbsnews.com', 'YupbJCGz', 'Jdavie', 'Coch', '682-878-9376', '1994-01-02', 'y'),
('jsicilyem@weibo.com', 'Ba75iA8gNd', 'Jeane', 'Sicily', '649-817-9775', '1971-10-26', 'y'),
('jnice26@friendfeed.com', 'UanwQezipN2g', 'Jeanine', 'Nice', '617-418-3681', '1976-10-23', 'y'),
('jwalsom4a@cornell.edu', 'Yw4pDbEf', 'Jeannine', 'Walsom', '447-818-1179', '1991-01-18', 'y'),
('jmaynellmu@technorati.com', 'SKOxrxZ', 'Jeff', 'Maynell', '725-761-4745', '1987-06-30', 'y'),
('jpetergc@godaddy.com', 'IrEDyGB', 'Jefferey', 'Peter', '553-212-9713', '1989-10-15', 'y'),
('jtellenbrokct@imdb.com', 'kNvTwiTej', 'Jefferson', 'Tellenbrok', '704-266-7993', '1981-01-15', 'y'),
('jsterndaleju@fastcompany.com', '8kV6h0', 'Jeffie', 'Sterndale', '541-230-8458', '1951-05-06', 'y'),
('jashdownqw@merriam-webster.com', 'WZTX7DUs3qp', 'Jehu', 'Ashdown', '813-883-7236', '1978-07-07', 'y'),
('jsoutherellgx@adobe.com', 'zWQO1zDbHN', 'Jehu', 'Southerell', '261-755-4494', '1953-07-07', 'y'),
('jblissitt5u@cbslocal.com', '4Og3THz', 'Jemmie', 'Blissitt', '496-653-7421', '1955-08-25', 'y'),
('jhatrickpx@rakuten.co.jp', 'Jeakf6qP', 'Jemmie', 'Hatrick', '129-158-3181', '1967-05-11', 'y'),
('jbowmen3t@jimdo.com', 'xHARrk3', 'Jena', 'Bowmen', '750-497-3088', '1964-06-16', 'y'),
('jkasnm@businesswire.com', 'LzKCyXJA5Qp', 'Jena', 'Kas', '229-996-5855', '2001-07-11', 'y'),
('jlehrps@arstechnica.com', '4BHVnWTVCB', 'Jeni', 'Lehr', '258-681-3229', '1978-12-26', 'y'),
('jnarek7@fc2.com', 'X055BjpZY', 'Jenine', 'Nare', '578-387-7229', '1961-11-15', 'y'),
('jmilsapav@pinterest.com', 'rUgCtjBGV', 'Jenn', 'Milsap', '450-985-9970', '1959-09-09', 'y'),
('jmccrann9w@tinypic.com', 'Q8xjaktUnorE', 'Jennee', 'McCrann', '766-690-6472', '1956-03-17', 'y'),
('jabramson8n@scribd.com', 'Jja6xVBQg', 'Jennifer', 'Abramson', '387-882-3404', '1972-08-22', 'y'),
('jbutterfill6c@mail.ru', 'cyGklGAT7', 'Jennine', 'Butterfill', '859-945-9846', '1971-03-06', 'y'),
('jduckersq@dailymail.co.uk', 'xOWXoz55Ss5', 'Jeno', 'Duckers', '669-610-4849', '1958-08-31', 'y'),
('jzmitrichenkop5@bloomberg.com', 'ILqaRSpj', 'Jereme', 'Zmitrichenko', '561-162-8477', '1977-03-24', 'y'),
('jreadwin49@redcross.org', 'TZbb6ay', 'Jeri', 'Readwin', '755-483-3763', '1989-10-16', 'y'),
('jdene44@wired.com', 'xt1f7LZCYidU', 'Jermaine', 'Dene', '595-526-2925', '1966-06-15', 'y'),
('jsonege@mtv.com', 'HUE0MvG7t', 'Jermaine', 'Sone', '250-483-1108', '1994-08-06', 'y'),
('jkadwallider5p@narod.ru', 'gBmgslJj', 'Jermayne', 'Kadwallider', '747-614-0750', '1976-11-27', 'y'),
('jnorthernmt@google.it', 'E9dTfwvex0T1', 'Jermayne', 'Northern', '570-937-1680', '1971-01-28', 'y'),
('jcorryerkw@eventbrite.com', 'I4oUpNE0i7CH', 'Jerome', 'Corryer', '717-112-0337', '1997-04-22', 'y'),
('jburnsyde6d@cnn.com', 'KU3v2q', 'Jerrie', 'Burnsyde', '179-297-7076', '1966-01-27', 'y'),
('jodney1z@nature.com', 'gWxOi5r2Z7', 'Jerrie', 'Odney', '540-740-5338', '1979-07-31', 'y'),
('jesbya@tumblr.com', 'ttwmPwQdz3n', 'Jerry', 'Esby', '149-342-4705', '1983-11-14', 'y'),
('jwhildrm@51.la', 'SU9dXsmP4YD', 'Jerry', 'Whild', '750-562-0106', '1982-10-25', 'y'),
('jeastesi5@accuweather.com', 'e84192rz', 'Jess', 'Eastes', '378-796-4454', '1971-02-12', 'y'),
('jgilardone46@jimdo.com', 'I6SIJcLnFZ', 'Jess', 'Gilardone', '608-144-4316', '1967-12-20', 'y'),
('jjeremaesqi@deliciousdays.com', 'ZQKYszek1', 'Jesse', 'Jeremaes', '380-734-4590', '2000-06-20', 'y'),
('jtinebq@drupal.org', 'BPUhXcmg', 'Jesse', 'Tine', '260-818-0356', '1961-12-01', 'y'),
('jflay1t@topsy.com', 'AbDwTB7QR', 'Jessie', 'Flay', '294-507-9890', '1995-12-19', 'y'),
('jineson12@fema.gov', 'VDP6kX4AVtu', 'Jethro', 'Ineson', '958-870-1340', '1992-06-08', 'y'),
('jdowsett4@cpanel.net', 'U3ea9j3GVb', 'Jilli', 'Dowsett', '937-532-6612', '1989-12-23', 'y'),
('jliverseegedt@dmoz.org', 'VzMYRK', 'Jillie', 'Liverseege', '531-143-1060', '1953-08-26', 'y'),
('jcheasmanh6@google.com.hk', '8ItBpBpKHUY', 'Jimmie', 'Cheasman', '221-972-6828', '2000-03-14', 'y'),
('jhouldcroftbl@senate.gov', '5wdaqs', 'Jimmie', 'Houldcroft', '344-324-8746', '1977-09-03', 'y'),
('jmilbycs@intel.com', 'Coh2sg4IFn', 'Jimmie', 'Milby', '204-815-3598', '1960-08-26', 'y'),
('jcharlejp@constantcontact.com', 'JWkpQFMa6', 'Jimmy', 'Charle', '675-943-1376', '1969-07-08', 'y'),
('jlansdown3u@yahoo.com', '7TyvuTVSUa', 'Jinny', 'Lansdown', '922-338-7727', '1996-12-14', 'y'),
('jduddinly@chicagotribune.com', '36yTgD0tKz48', 'Joan', 'Duddin', '793-215-3037', '1957-12-27', 'y'),
('jsporgeonjw@chicagotribune.com', 'XYX74iLx1t', 'Joan', 'Sporgeon', '510-825-7318', '1950-11-26', 'y'),
('jtowell40@wiley.com', 'NpSruhZ51', 'Jobyna', 'Towell', '155-217-5053', '1952-07-12', 'y'),
('jclougherle@bravesites.com', '5OpLwXRT6o5', 'Jocelin', 'Clougher', '952-504-8688', '1985-07-03', 'y'),
('jortigercv@miitbeian.gov.cn', '4TP9XJ', 'Jocelin', 'Ortiger', '828-129-7537', '1953-07-29', 'y'),
('jsnodden58@google.cn', 'EvCW5gZ8o', 'Jodie', 'Snodden', '459-848-5666', '1951-07-24', 'y'),
('jleahhj@cocolog-nifty.com', 'vZHzKOFnk', 'Jody', 'Leah', '993-994-0349', '1977-09-08', 'y'),
('jpetricjt@vkontakte.ru', 'CrXMx1QoFc', 'Jody', 'Petric', '900-741-5803', '1967-10-23', 'y'),
('jpidgeonpj@microsoft.com', 'ngHrWGW', 'Joelie', 'Pidgeon', '659-961-6584', '1994-01-20', 'y'),
('jstefanovic78@jiathis.com', 'snrTatqax', 'Joella', 'Stefanovic', '535-743-7107', '1980-03-12', 'y'),
('jbuttlems@google.ca', 'eTzzdY2d8MR', 'Joelynn', 'Buttle', '964-625-1931', '1997-12-09', 'y'),
('jbattellejf@arstechnica.com', '8p5ZXZeY', 'Johna', 'Battelle', '770-345-4395', '1996-07-11', 'y'),
('jjoulpa@home.pl', 'vRPQEzK2d6', 'Johnnie', 'Joul', '107-705-7779', '1999-10-10', 'y'),
('jdelaperrelledp@hubpages.com', '8csQKFw6', 'Joice', 'De la Perrelle', '642-322-3606', '1998-08-20', 'y'),
('jnendick8b@walmart.com', 'ZA57my', 'Joice', 'Nendick', '123-305-2148', '1996-06-16', 'y'),
('jforestallkm@eventbrite.com', 'MbElWPAxDiZv', 'Jolyn', 'Forestall', '919-804-5678', '1977-08-10', 'y'),
('jkettsnu@aol.com', 'Fsxo447UFc', 'Jone', 'Ketts', '324-941-2982', '1966-03-29', 'y'),
('jmcgeorgerb@sun.com', 'g8XYR5PgK3zo', 'Jone', 'McGeorge', '451-159-5170', '1991-09-26', 'y'),
('jmacveyd9@gizmodo.com', '8LeTwdp', 'Jordain', 'Macvey', '945-781-4593', '1984-08-25', 'y'),
('jdurantin@census.gov', '9cnXY3LPeIQ', 'Jorry', 'Durant', '471-605-7828', '1955-04-08', 'y'),
('jmorphetku@princeton.edu', 'ZRrIvT4A2q', 'Jorry', 'Morphet', '968-945-3951', '1987-07-09', 'y'),
('jboastjl@devhub.com', 'fPVN7sRa8Cd', 'Joseito', 'Boast', '221-499-3541', '1986-01-13', 'y'),
('jbevan31@myspace.com', 'P3CA7K', 'Josy', 'Bevan', '272-317-7839', '2001-04-12', 'y'),
('jpendrichaz@blogspot.com', 'ZBKWHVUSo5', 'Joya', 'Pendrich', '663-107-5501', '1980-03-12', 'y'),
('jgreenigp2@alibaba.com', 'iHKVky2m', 'Joyous', 'Greenig', '962-591-9587', '1995-05-26', 'y'),
('jlarge4w@squidoo.com', 'w61QPl', 'Jud', 'Large', '773-168-3998', '1958-10-10', 'y'),
('jcoathamfm@ezinearticles.com', 'FZ4VLFEV', 'Judah', 'Coatham', '925-650-0252', '1962-02-26', 'y');
INSERT INTO `_user` (`user_email`, `pass`, `first_name`, `last_name`, `phone_number`, `dob`, `is_user`) VALUES
('jellenkj@woothemes.com', 'AaZaDYD1', 'Judie', 'Ellen', '354-216-4320', '1977-08-24', 'y'),
('jglowach6n@google.ru', 'YqwFYiH0', 'Judye', 'Glowach', '845-684-9192', '1951-08-13', 'y'),
('jstofferg1@addthis.com', '73krRSEDq5xU', 'Julie', 'Stoffer', '344-391-3441', '1984-07-19', 'y'),
('jcolleltonb@qq.com', 'LAqXkxAS74J', 'Julieta', 'Collelton', '152-647-9629', '1965-12-12', 'y'),
('jlafondk2@huffingtonpost.com', 'zMlibSS', 'Julieta', 'Lafond', '748-806-8410', '1983-03-30', 'y'),
('jsarjeantr5@addtoany.com', 'TuKgOVC9X71', 'Julita', 'Sarjeant', '239-877-7989', '1960-01-23', 'y'),
('jdudney4d@ca.gov', 'ubEbaB', 'June', 'Dudney', '668-148-1882', '1951-06-22', 'y'),
('jtoselandov@last.fm', '3c4NzBt3pG', 'Junette', 'Toseland', '200-402-9875', '1988-07-15', 'y'),
('jdunninge4@webs.com', 'XfjjCulGMjfT', 'Junia', 'Dunning', '601-327-8889', '1965-07-06', 'y'),
('jcopcuttgp@sciencedaily.com', 'AZUPngb9h', 'Junina', 'Copcutt', '413-269-7262', '1981-02-27', 'y'),
('japfler3a@wunderground.com', '9LfuBg', 'Justus', 'Apfler', '127-496-8939', '1959-07-07', 'y'),
('jbattill5s@macromedia.com', 'MhKe74bkwfz9', 'Jyoti', 'Battill', '844-609-4940', '1979-04-14', 'y'),
('klinfootrr@privacy.gov.au', 'tiyHksLI', 'Kacie', 'Linfoot', '207-351-3465', '1951-01-25', 'y'),
('kpurkess97@plala.or.jp', 'FbSwsd3w0Q', 'Kai', 'Purkess', '213-146-6431', '1983-05-04', 'y'),
('kinglestoni2@istockphoto.com', 'opGcrIG', 'Kain', 'Ingleston', '989-422-1437', '1976-09-25', 'y'),
('ksignej5@vimeo.com', 'AX1CXLW', 'Kain', 'Signe', '594-627-3507', '1966-02-20', 'y'),
('kbonallickex@pbs.org', '0jK1XFhSAjZq', 'Kakalina', 'Bonallick', '223-214-1917', '1978-08-06', 'y'),
('kkadwalliderm1@gov.uk', '4QLjbX4IPM', 'Kaleb', 'Kadwallider', '659-595-6336', '1956-03-08', 'y'),
('ksutterfieldr4@bravesites.com', '9NiQCMDNQWAm', 'Kalie', 'Sutterfield', '281-292-1325', '1974-10-14', 'y'),
('kmillier1l@alibaba.com', '1bvd9mt', 'Kalila', 'Millier', '472-793-2450', '1989-09-26', 'y'),
('khegdonne8d@oaic.gov.au', 'c19fevFZVvNw', 'Kalli', 'Hegdonne', '718-115-1149', '1990-04-23', 'y'),
('ksayle51@huffingtonpost.com', '4zbjWhF', 'Kameko', 'Sayle', '728-450-3087', '1961-01-21', 'y'),
('ksighartm6@twitpic.com', '6JzvEa1sOmQc', 'Kamillah', 'Sighart', '825-701-3175', '1965-04-12', 'y'),
('ksnare6p@google.ca', 'CHn40Ad8R', 'Karalee', 'Snare', '606-752-5317', '1968-03-16', 'y'),
('kvanyakinlw@gizmodo.com', '9TC3xl', 'Karalynn', 'Vanyakin', '355-393-8280', '1953-06-30', 'y'),
('kgowlett8c@pcworld.com', 'l11qBmQE', 'Kareem', 'Gowlett', '162-458-9072', '1951-06-14', 'y'),
('kshawl21@nifty.com', 'EmRXs9OF', 'Kareem', 'Shawl', '135-422-6367', '1967-01-05', 'y'),
('kclibberyod@wsj.com', 'yFI6YUWjd', 'Karie', 'Clibbery', '875-944-4707', '1994-11-19', 'y'),
('kozintsevp2@com.com', 'bYcnFbXKE', 'Karie', 'Ozintsev', '811-143-1923', '1977-07-22', 'y'),
('klippo7k@hp.com', 'Clc5Z1dTLKJ', 'Karin', 'Lippo', '273-720-5824', '1979-09-21', 'y'),
('kansty1u@feedburner.com', 'f5RN9qTmsx', 'Karisa', 'Ansty', '516-461-0132', '1988-09-13', 'y'),
('kboydaoo@altervista.org', 'CDYxRbD2l5', 'Karisa', 'Boyda', '315-882-3119', '1953-02-23', 'y'),
('kshepeard4f@xing.com', 'oqeYuuD2TW2Z', 'Karlik', 'Shepeard', '106-445-5588', '1960-05-25', 'y'),
('khallgalleyfy@free.fr', 'Jfn3yu', 'Karlis', 'Hallgalley', '677-667-8109', '1950-12-22', 'y'),
('kkestermy@blogger.com', 'kOnXmZJZi7E', 'Karly', 'Kester', '429-325-2216', '1959-03-28', 'y'),
('kglewg7@pcworld.com', 'kkCa87l', 'Karlyn', 'Glew', '368-718-2818', '1980-11-05', 'y'),
('kbreaganmm@accuweather.com', 'Dg9BwV7dSiKF', 'Karol', 'Breagan', '516-878-9576', '1990-09-19', 'y'),
('kjenkin7f@ebay.com', '9n3KzV9Ijj', 'Karrie', 'Jenkin', '398-167-6177', '1972-11-03', 'y'),
('kmirams54@amazon.com', 'mde3TazB', 'Karry', 'Mirams', '891-658-2113', '1983-09-28', 'y'),
('kzannotellioo@apple.com', '0gctuhJ', 'Karry', 'Zannotelli', '294-660-5177', '1995-09-26', 'y'),
('klightollers3r@theglobeandmail.com', 'ZrIINp4', 'Karyl', 'Lightollers', '844-902-3279', '1965-12-15', 'y'),
('kquick6j@fc2.com', 'jNnBro', 'Karyl', 'Quick', '825-130-0601', '1960-06-19', 'y'),
('klilywhitef@jigsy.com', 'F4lt1qZO', 'Karylin', 'Lilywhite', '386-573-8769', '1969-01-13', 'y'),
('kdebenedittiqx@blogger.com', 'VzP94eV8K', 'Kassi', 'De Beneditti', '741-915-7460', '1977-12-19', 'y'),
('klaperenz@smugmug.com', 'n1NjgTzeHbh', 'Kata', 'Lapere', '546-140-9729', '1957-08-06', 'y'),
('krallingscf@prlog.org', '4NHpB0yjST9j', 'Kata', 'Rallings', '786-823-1621', '1996-11-08', 'y'),
('kodunneenjj@msn.com', '679gemzj', 'Katee', 'O\'Dunneen', '926-590-2295', '1952-08-27', 'y'),
('kmaclesebn@blogspot.com', '4Aca0oW4C4D', 'Katharine', 'MacLese', '675-272-5781', '1985-07-09', 'y'),
('kgoulter1b@gmpg.org', 'lp8zOG', 'Katherina', 'Goulter', '990-930-5258', '1994-06-26', 'y'),
('kjersonig@wix.com', 'wfmnylWokr', 'Kathi', 'Jerson', '288-226-3200', '1963-05-30', 'y'),
('kcarthewaw@huffingtonpost.com', 'WLT7GUu', 'Kathie', 'Carthew', '777-432-3686', '1965-07-09', 'y'),
('kkyle9@issuu.com', 'G78wpiO97L', 'Kati', 'Kyle', '852-887-4562', '1967-08-21', 'y'),
('kbakeyhe@dmoz.org', 'hh2QD2Qgr', 'Katine', 'Bakey', '304-122-3570', '1997-08-20', 'y'),
('kbeynonbx@ucla.edu', 'mekPEF', 'Katuscha', 'Beynon', '545-633-3746', '1984-01-14', 'y'),
('kbrakeb3@ehow.com', 'BKHdGwhTZ', 'Katy', 'Brake', '902-151-6534', '1970-02-01', 'y'),
('kmcgarrellfc@msu.edu', 'wRLhsVHYecp', 'Kayne', 'McGarrell', '308-832-1303', '1996-02-08', 'y'),
('klaversj9@parallels.com', 'hBxPpG6k', 'Kean', 'Lavers', '481-488-1901', '2001-08-29', 'y'),
('kmaccarranedz@spotify.com', 'ImGPXDeCZ', 'Keefer', 'MacCarrane', '767-352-7157', '1965-07-02', 'y'),
('kgersamat@aol.com', 'DZj7QU', 'Keeley', 'Gersam', '652-115-3671', '1990-08-20', 'y'),
('ktrenbayce@fda.gov', 'gSgOcAv9', 'Keelia', 'Trenbay', '138-143-8556', '1954-11-28', 'y'),
('krigbyep8@privacy.gov.au', 'rQ8yNZ7lpvT', 'Keely', 'Rigbye', '392-575-8040', '1998-09-20', 'y'),
('kfullerton3n@nasa.gov', 'PirAdK', 'Kelcie', 'Fullerton', '647-458-0801', '1974-02-23', 'y'),
('kmamwelld1@gravatar.com', 'wrDYPB', 'Kellen', 'Mamwell', '980-802-7612', '1984-03-01', 'y'),
('klimerrn@chronoengine.com', 'GTJLn7fxXl', 'Kellia', 'Limer', '791-526-9359', '1979-09-17', 'y'),
('kdamrellqs@ucla.edu', 'wsKlixNQ', 'Kellina', 'Damrell', '547-312-1210', '1997-08-21', 'y'),
('kbelsham1m@mapy.cz', 'kBmUvAnt', 'Kellsie', 'Belsham', '362-809-5000', '1981-05-01', 'y'),
('koreaganbr@cisco.com', 'ocUI9a', 'Kellyann', 'O\' Reagan', '889-389-8415', '1987-09-10', 'y'),
('kskeates9d@imgur.com', 'oC3KpZwYkvi', 'Kendell', 'Skeates', '233-493-4761', '1966-09-01', 'y'),
('kdaughertyl8@amazon.com', 'LIAeoXf', 'Kendre', 'Daugherty', '208-560-2415', '1959-09-08', 'y'),
('kdalinderqn@hubpages.com', 'fSijLebPsoV', 'Kendricks', 'Dalinder', '707-313-0876', '1969-12-14', 'y'),
('kmousbycz@seesaa.net', 'Q2ow3XKFy51', 'Kenn', 'Mousby', '816-599-4060', '1982-08-03', 'y'),
('kdasenthh@wufoo.com', 'oAHtRAL3LjMp', 'Kennett', 'Dasent', '945-926-0882', '1961-11-06', 'y'),
('kbischoffci@nifty.com', 'uG8IKCN', 'Kerk', 'Bischoff', '301-959-9684', '1968-11-04', 'y'),
('kgibkemj@ucoz.ru', '6SfwmG5zj', 'Kerrie', 'Gibke', '559-180-8313', '1991-07-11', 'y'),
('kbriars8i@t-online.de', 'z7SttcmNs', 'Kerry', 'Briars', '177-988-6035', '1968-01-10', 'y'),
('ksenchenkopi@nhs.uk', 'l3Gu6RqW', 'Kesley', 'Senchenko', '569-614-6160', '1952-11-12', 'y'),
('kmacaindreishm@taobao.com', 'aMw2tr62s3', 'Kettie', 'MacAindreis', '954-810-2850', '1997-02-16', 'y'),
('kstephensq7@mapquest.com', '4Hr5qJKOgI', 'Kev', 'Stephens', '216-496-1414', '1962-04-07', 'y'),
('kbarteletbg@liveinternet.ru', 'FzsOHU', 'Kiersten', 'Bartelet', '434-276-8333', '1992-10-23', 'y'),
('kgarrould8c@ucoz.ru', 'z7OBIjKtuOQ', 'Kiley', 'Garrould', '130-513-9267', '1983-09-13', 'y'),
('kvennartdc@blogtalkradio.com', 'dzD3lMcHwm', 'Killian', 'Vennart', '834-209-8217', '1987-06-18', 'y'),
('kdickenson4m@yahoo.com', 'UHGpRDe', 'Kim', 'Dickenson', '803-439-4514', '1977-06-17', 'y'),
('kcisson6b@pen.io', 'tTcfNjnb65L', 'Kimball', 'Cisson', '939-166-2559', '1956-03-29', 'y'),
('krichfordhl@de.vu', '8vvhZCsiP', 'Kimberley', 'Richford', '541-773-0080', '1988-11-02', 'y'),
('kbellfieldbk@oracle.com', 'gSBWI9CGP', 'Kimberlyn', 'Bellfield', '478-521-2990', '1997-08-17', 'y'),
('khayden8x@bbc.co.uk', 'tYNCOediRt', 'Kimberlyn', 'Hayden', '333-556-2819', '2000-02-10', 'y'),
('kseckerr6@gnu.org', 'BT30PuicN', 'Kimble', 'Secker', '576-272-1532', '1953-10-27', 'y'),
('kskews7z@google.com.br', 'wOMniQI', 'Kimble', 'Skews', '227-110-0337', '1953-06-03', 'y'),
('kbragge59@foxnews.com', 'K1KopJ', 'Kingsly', 'Bragge', '482-108-2536', '1989-06-20', 'y'),
('kschiesterlrj@lycos.com', 'whZTuAPn9O5', 'Kingston', 'Schiesterl', '374-445-9105', '2000-08-09', 'y'),
('klibbis4n@cmu.edu', '3Uwj85O', 'Kip', 'Libbis', '301-954-6500', '2000-06-26', 'y'),
('kwalling22@ucoz.ru', 'sX9WUj', 'Kipp', 'Walling', '874-832-3776', '2000-09-09', 'y'),
('kgadeaux7l@people.com.cn', '9asW2B7wU', 'Kippy', 'Gadeaux', '728-100-3257', '1963-11-23', 'y'),
('khelinpt@google.it', 'RBd0ISp9o0xO', 'Kira', 'Helin', '996-365-8400', '1998-10-18', 'y'),
('kbowsheres@imdb.com', 'LjL6XpQW', 'Kirbee', 'Bowsher', '572-588-1525', '1983-05-13', 'y'),
('kgerrilll9@usgs.gov', 's3A0g1DR6', 'Kirby', 'Gerrill', '859-841-3943', '1965-02-16', 'y'),
('kpredohlop@cbc.ca', 'qkM1QhThF', 'Kirby', 'Predohl', '367-509-7064', '1975-11-03', 'y'),
('kyarnell15@i2i.jp', '6N7jH7mwW1s', 'Kirsten', 'Yarnell', '252-121-4391', '1978-11-15', 'y'),
('kfidgeon6i@psu.edu', 'uRyOmACPMJ', 'Kirstin', 'Fidgeon', '113-297-1795', '1954-04-17', 'y'),
('krainsjl@jimdo.com', '1RCBiiv', 'Kittie', 'Rains', '422-124-2185', '1966-12-21', 'y'),
('kcolvineri@indiatimes.com', 'AHyaP3skwK', 'Kizzie', 'Colvine', '608-191-1066', '1956-12-13', 'y'),
('kwinscom4k@icq.com', 'ldgFkZHyOk3', 'Klarika', 'Winscom', '836-966-0769', '1973-11-14', 'y'),
('klemarchant9z@gravatar.com', 'ggw3KfOym', 'Kleon', 'Le Marchant', '312-288-1582', '1954-05-02', 'y'),
('kkelstonnp@shop-pro.jp', 'iheCOTjhA', 'Konstantine', 'Kelston', '711-779-5022', '1951-11-04', 'y'),
('kdelapa@ebay.co.uk', 'C9ks2uc', 'Koralle', 'Delap', '408-960-7566', '1964-01-03', 'y'),
('kdommersennl@home.pl', 'veWO95wRJy', 'Korella', 'Dommersen', '381-810-1548', '1999-05-23', 'y'),
('kvaslerm7@disqus.com', 'bIvcynKF8A', 'Korry', 'Vasler', '679-587-1521', '1951-08-29', 'y'),
('kmcvittiedp@ox.ac.uk', 'hC83Gs', 'Kort', 'McVittie', '110-153-6488', '1998-07-02', 'y'),
('kleifer81@wiley.com', 'nXU6tQk', 'Krishnah', 'Leifer', '521-818-6614', '1986-03-01', 'y'),
('kblythdw@dagondesign.com', 'calyMF9l0', 'Kristina', 'Blyth', '104-981-5231', '1971-09-02', 'y'),
('kmccaughenq2@pinterest.com', 'HRH0sPJfUx3s', 'Kristopher', 'McCaughen', '426-359-6903', '1998-11-14', 'y'),
('ktottjh@japanpost.jp', '6UXQN4BxBX', 'Kristopher', 'Tott', '418-388-0968', '1985-10-23', 'y'),
('kdyet8y@businessweek.com', '3W9SPPM5vg', 'Kristos', 'Dyet', '244-529-3239', '1998-04-24', 'y'),
('kgaulef9@mtv.com', '2JE3jWDhKQ', 'Kurt', 'Gaule', '994-444-3390', '1959-07-10', 'y'),
('kgoodluckpn@ted.com', 'hr7FzKqQV6U', 'Kurtis', 'Goodluck', '407-553-2118', '1953-09-04', 'y'),
('kluardcf@parallels.com', 'YzrWC8SZTsF', 'Kurtis', 'Luard', '547-409-4936', '1984-04-07', 'y'),
('kriddell4b@china.com.cn', 'xBZ9Oh6', 'Ky', 'Riddell', '708-603-2289', '1952-08-28', 'y'),
('kfronks7s@drupal.org', 'H6ytXoSq', 'Kyla', 'Fronks', '869-672-5654', '1953-07-13', 'y'),
('knockellsbe@china.com.cn', 'QuPOq5a', 'Kylen', 'Nockells', '459-341-2468', '1986-07-24', 'y'),
('kshotboultei4@msn.com', 'hDJ0Aq', 'Kylen', 'Shotboulte', '835-178-0027', '1951-02-22', 'y'),
('krangell27@delicious.com', '8Tm28Jm', 'Kylie', 'Rangell', '969-503-2559', '1956-07-08', 'y'),
('liredaleav@admin.ch', 'wOBUrc', 'L;urette', 'Iredale', '546-843-0255', '1994-03-04', 'y'),
('lleminggk@tuttocitta.it', 'DUcPxLWZj4aP', 'Lainey', 'Leming', '985-526-7443', '1974-11-17', 'y'),
('ltappington7e@cdbaby.com', 'jz83ulKLs', 'Lamond', 'Tappington', '167-563-1165', '1955-11-05', 'y'),
('lcreganij@va.gov', 'Y9nbrcJ', 'Lane', 'Cregan', '343-471-3575', '1973-10-13', 'y'),
('lgommowegu@google.nl', 'Qwfz9Z', 'Laney', 'Gommowe', '754-130-3723', '1980-01-09', 'y'),
('lbattabeew@photobucket.com', 'pOM9btVCCOx', 'Lanny', 'Battabee', '828-573-2122', '1991-09-13', 'y'),
('lwalteringo4@barnesandnoble.com', '5Jc7vWQdv', 'Lanny', 'Waltering', '946-497-8029', '1989-02-13', 'y'),
('lhattrick9z@eventbrite.com', 'nzPEsvM0k', 'Laraine', 'Hattrick', '869-955-9737', '1953-05-07', 'y'),
('lvanvuuren79@answers.com', 'a1Y4o00qq', 'Laraine', 'Van Vuuren', '307-448-9578', '1964-05-28', 'y'),
('ldarreerh@prweb.com', 'GQUwmV', 'Larisa', 'Darree', '243-434-6460', '1977-08-04', 'y'),
('lpharrowpt@cbc.ca', 'r4L2afHHa', 'Latashia', 'Pharrow', '610-116-9666', '1961-10-28', 'y'),
('lyeates46@biglobe.ne.jp', '1XE8h1yKI', 'Latrena', 'Yeates', '234-611-9473', '1977-10-28', 'y'),
('lsouthertonlv@sogou.com', 'J4a9wzzF', 'Latrina', 'Southerton', '540-127-6620', '1988-08-03', 'y'),
('ltrimmillpk@boston.com', 'xmrC9LeqmVTM', 'Launce', 'Trimmill', '154-628-1526', '1986-03-07', 'y'),
('lcoleydi@patch.com', 'FCgsZkw', 'Laure', 'Coley', '196-479-8005', '1997-03-21', 'y'),
('lquilkinhb@behance.net', 'L3OUGtLOAD', 'Lauree', 'Quilkin', '411-919-3016', '1959-03-29', 'y'),
('llecountpc@huffingtonpost.com', 'j2tj5djHu', 'Lauren', 'Lecount', '931-951-3454', '1976-09-22', 'y'),
('lattwool87@tiny.cc', '5KCUqygW', 'Laurence', 'Attwool', '883-125-8756', '2001-11-06', 'y'),
('lfrango8t@e-recht24.de', 'Dh1leaDekVg', 'Lauri', 'Frango', '771-697-7993', '1980-04-24', 'y'),
('lmccookhf@newsvine.com', 'NCY7nD', 'Lavinia', 'McCook', '400-426-4095', '1955-02-01', 'y'),
('ltrudgeonp1@rediff.com', 'J0WvWLvSv8I2', 'Lazaro', 'Trudgeon', '127-242-2508', '1956-11-05', 'y'),
('llangridge9r@creativecommons.org', 'c0hAkC', 'Lea', 'Langridge', '976-235-8967', '1982-01-21', 'y'),
('lmagson70@cdc.gov', 'lRvLF508iR', 'Lebbie', 'Magson', '702-862-4957', '1977-03-29', 'y'),
('ltuffley63@merriam-webster.com', 'DsSYoXaI4u', 'Lee', 'Tuffley', '650-653-7818', '1963-11-05', 'y'),
('lmargarson9y@hibu.com', 'YdOKeeyDoIOA', 'Leeanne', 'Margarson', '688-369-9640', '1976-03-08', 'y'),
('lonions7a@google.ca', 'IQHDwjkaiZpr', 'Leeland', 'Onions', '394-217-0001', '1957-06-22', 'y'),
('ldibollj3@yale.edu', '7hXX8HWR6', 'Leila', 'Diboll', '469-353-0923', '1974-01-21', 'y'),
('lferrers2@hc360.com', 'IJq9WIkERtLP', 'Leland', 'Ferrers', '459-477-5579', '1983-10-25', 'y'),
('lsayburnox@ustream.tv', 'R8Xupp', 'Lelia', 'Sayburn', '671-426-3908', '1988-12-04', 'y'),
('lamthorib@joomla.org', 'hNFgml7Otz', 'Lennard', 'Amthor', '523-891-3875', '1977-06-10', 'y'),
('ljerzycowski2q@pagesperso-orange.fr', 'BgIKwgDtEr', 'Leona', 'Jerzycowski', '339-170-6730', '1992-08-24', 'y'),
('lpudden9b@auda.org.au', 'nfphoY', 'Leonanie', 'Pudden', '822-851-5127', '1958-05-24', 'y'),
('lventoned@over-blog.com', 'WZwtb0', 'Leonie', 'Venton', '425-983-9444', '1970-05-13', 'y'),
('lniaves6y@de.vu', 'aB5J9hdjAlm7', 'Leroy', 'Niaves', '393-161-4794', '1950-08-17', 'y'),
('lportisn9@unicef.org', 'k12ccu2LoDWW', 'Les', 'Portis', '652-970-1816', '1971-05-24', 'y'),
('lmewisqk@friendfeed.com', 'J59Zih7', 'Lesley', 'Mewis', '337-394-1090', '1973-11-08', 'y'),
('lvaleg3@ifeng.com', '2ZTe7zpSL', 'Lesly', 'Vale', '623-794-7928', '1968-10-10', 'y'),
('lkingshottip@google.cn', '0bMoDwX4vAo', 'Letta', 'Kingshott', '747-358-9939', '1979-09-19', 'y'),
('ltamblingi@unc.edu', '2pNyoc8oW9', 'Letti', 'Tambling', '159-733-8300', '1984-03-19', 'y'),
('lboggis9t@time.com', 'yGfpzvPZ', 'Lew', 'Boggis', '870-485-8699', '1976-11-22', 'y'),
('lvirgoer8@ibm.com', 'pm51cE9', 'Lew', 'Virgoe', '718-253-5241', '1990-10-23', 'y'),
('lwildepn@ebay.com', 'H3bMlZ168CVi', 'Lezley', 'Wilde', '765-567-8078', '1968-08-25', 'y'),
('lsharland92@prweb.com', 'RQ33zT6Y', 'Liam', 'Sharland', '347-355-9837', '1983-11-03', 'y'),
('lgysenv@google.nl', 'Pv29tVAa3', 'Lian', 'Gyse', '269-764-1374', '1956-09-19', 'y'),
('lmaidesiy@hubpages.com', 'l21Hf8F', 'Lianne', 'Maides', '897-478-4157', '1964-11-23', 'y'),
('lsapshedlj@wikispaces.com', 'ur3ZUlLX3', 'Libbey', 'Sapshed', '823-443-1467', '1987-03-27', 'y'),
('ltriplettgd@cocolog-nifty.com', '9Kyber', 'Libbey', 'Triplett', '770-916-9158', '1977-01-29', 'y'),
('ljollandsdb@nasa.gov', 'LbXlTn', 'Lidia', 'Jollands', '206-854-7551', '1952-08-12', 'y'),
('lwinfredgo@ucoz.ru', 'V6gfc9', 'Lidia', 'Winfred', '205-280-1816', '1956-08-20', 'y'),
('lnewingb4@typepad.com', '2aIAFCoQnCO', 'Lilah', 'Newing', '937-241-5864', '1997-01-28', 'y'),
('lgadesby8u@e-recht24.de', '2vloOfumz', 'Lilias', 'Gadesby', '974-647-6521', '1976-07-04', 'y'),
('llampittr7@purevolume.com', '9ZtOCYU', 'Lilla', 'Lampitt', '101-179-6914', '1985-08-23', 'y'),
('luphamck@xinhuanet.com', 'dWYyWwzoS', 'Lilllie', 'Upham', '632-697-1484', '1983-04-09', 'y'),
('lpedlowh3@printfriendly.com', 'aW4oQv', 'Lily', 'Pedlow', '611-627-4914', '1977-09-01', 'y'),
('lsarlelf@photobucket.com', 'x0wikjFjDHua', 'Lilyan', 'Sarle', '365-377-3991', '1951-07-25', 'y'),
('lcoakleyig@vk.com', 'XMEd9a', 'Lin', 'Coakley', '711-530-7791', '2001-07-26', 'y'),
('lmatignongt@bloomberg.com', '9IhQRO43ll', 'Lindi', 'Matignon', '535-294-7582', '1994-09-17', 'y'),
('lnowerjb@wunderground.com', 'g88aWa2plU', 'Lindie', 'Nower', '308-455-5885', '1992-03-28', 'y'),
('lbrittlesb6@merriam-webster.com', 'zevwZ2FUtN', 'Lindon', 'Brittles', '872-526-8651', '1960-04-28', 'y'),
('llowdham5s@chron.com', 'BVio9KYx', 'Lindsay', 'Lowdham', '827-212-4857', '1961-09-20', 'y'),
('lshordh8@macromedia.com', '0hK0YA', 'Link', 'Shord', '876-564-4820', '1977-05-24', 'y'),
('lcheavin6r@t-online.de', 'VPUFPfIfc', 'Lionel', 'Cheavin', '517-186-1437', '1951-03-05', 'y'),
('lblackatere@blogspot.com', 'MXtR84', 'Lisabeth', 'Blackater', '382-336-6636', '1963-09-15', 'y'),
('lbaudins7e@ucoz.ru', 'FnBK9KJAf', 'Lissa', 'Baudins', '338-631-9620', '1998-11-27', 'y'),
('lgogarty3u@mail.ru', '0Z2Ibj1pMniU', 'Lissi', 'Gogarty', '111-593-9828', '1971-08-10', 'y'),
('lrabbagej0@goo.ne.jp', 'Tnzyuo', 'Lissi', 'Rabbage', '919-298-4821', '1995-04-18', 'y'),
('lbreward5c@unicef.org', 'LlJCDhUNb6', 'Lissy', 'Breward', '502-493-7158', '1960-01-08', 'y'),
('lpfeuffermb@example.com', 'GPOT7P2oz', 'Livvyy', 'Pfeuffer', '401-855-7899', '1954-12-02', 'y'),
('lpymar3j@nymag.com', 'xatO4c18R', 'Llywellyn', 'Pymar', '347-600-8312', '1976-06-06', 'y'),
('lcarnegylh@ameblo.jp', 'YAwX8Caoq0', 'Lock', 'Carnegy', '778-279-6243', '1956-12-10', 'y'),
('lhughsfz@etsy.com', 'lQvMmYwq4AtG', 'Lodovico', 'Hughs', '107-366-8131', '1989-06-05', 'y'),
('lwalderai7@ovh.net', 'm4JtTNELOv6', 'Loella', 'Waldera', '967-310-6305', '1963-01-20', 'y'),
('lgoney8h@dropbox.com', 'dGyj5I1', 'Lolita', 'Goney', '477-964-5260', '1975-09-14', 'y'),
('ldesremedios50@sakura.ne.jp', '1oWvDc', 'Lolly', 'des Remedios', '255-657-2216', '1962-07-03', 'y'),
('lsabbertonkz@reverbnation.com', 'rIRNnqliDd', 'Lonni', 'Sabberton', '838-116-7845', '1969-10-31', 'y'),
('lcrysellfh@mapy.cz', 'CFl5Kf967M9y', 'Lonny', 'Crysell', '344-923-5825', '1973-03-21', 'y'),
('lminerojo@nifty.com', 'C1rB0QwyZp2', 'Lora', 'Minero', '669-265-1890', '1985-01-22', 'y'),
('lmorsley1v@histats.com', 'OCHYI72coy', 'Loralyn', 'Morsley', '833-767-1859', '1969-01-17', 'y'),
('lschirokjd@mediafire.com', '8YZO498WkncM', 'Loree', 'Schirok', '227-144-7024', '1964-01-16', 'y'),
('lnortheastqu@ucsd.edu', 'xxlaBou', 'Lorelei', 'Northeast', '282-667-6320', '1979-09-06', 'y'),
('lcutteridge5t@dailymotion.com', 'RiNMYE2THg8', 'Lorna', 'Cutteridge', '385-680-8124', '1975-05-01', 'y'),
('lduell7r@wiley.com', 'E7xogP6D3', 'Lothaire', 'Duell', '274-773-7310', '1961-12-25', 'y'),
('lpetegregg@jigsy.com', 'ZhQB8AEhUM', 'Lotty', 'Petegre', '407-149-9491', '1998-05-23', 'y'),
('lmannant@t.co', 'ifxRM9DV', 'Louisa', 'Manna', '284-849-3364', '1961-10-24', 'y'),
('lbryer7@earthlink.net', 'As7GEh2RYBh6', 'Louisette', 'Bryer', '845-782-3404', '2000-11-05', 'y'),
('lpostgateq2@home.pl', 'acjN0QY', 'Lucas', 'Postgate', '469-467-8845', '1981-06-30', 'y'),
('lpetrinah9@skype.com', '0u36SH', 'Lucia', 'Petrina', '379-654-4692', '1972-01-09', 'y'),
('lpowlesland85@bloglines.com', '4122yll', 'Luciano', 'Powlesland', '501-863-9017', '1992-11-02', 'y'),
('lsowersbyb1@netscape.com', '7z5nIu', 'Lucias', 'Sowersby', '288-671-6858', '1990-03-09', 'y'),
('lguinessr8@ihg.com', 'hAOhptb2Ns', 'Lucien', 'Guiness', '474-173-5189', '1989-01-13', 'y'),
('lmaccartneyap@addtoany.com', 'iXHwXcSF', 'Lucinda', 'MacCartney', '861-416-7001', '1980-06-25', 'y'),
('llistpf@wix.com', 'BjbzI0Q3', 'Lucius', 'List', '636-531-7637', '1977-05-24', 'y'),
('lbroune5d@godaddy.com', 'Dd5OL5', 'Lucky', 'Broune', '448-718-4567', '1990-04-19', 'y'),
('lbeamson6k@clickbank.net', 'rXOsgSuwL', 'Ludovico', 'Beamson', '703-773-7086', '1993-01-09', 'y'),
('lgoublierjz@arstechnica.com', '1t4TYE7VC', 'Lukas', 'Goublier', '499-190-0202', '1967-08-19', 'y'),
('lswashh3@addtoany.com', 'eLE9ak', 'Lula', 'Swash', '947-190-4348', '1973-10-11', 'y'),
('lgepson6j@sciencedirect.com', 'm7ZHiV', 'Lurline', 'Gepson', '459-942-2924', '1973-09-18', 'y'),
('lmallendercr@blogger.com', 'RvWx7bi', 'Lusa', 'Mallender', '163-233-8773', '1972-10-31', 'y'),
('lrope1q@free.fr', 'z1BHHWYR4OUM', 'Lydia', 'Rope', '599-283-2943', '1969-07-07', 'y'),
('lrothert5p@scientificamerican.com', 'Geit2RAn6r', 'Lydia', 'Rothert', '911-962-8471', '1980-09-10', 'y'),
('lpinkardnb@rediff.com', '73eg5kN', 'Lyell', 'Pinkard', '768-396-8899', '1972-04-11', 'y'),
('lmcguckinoj@drupal.org', 'gGxH6KkdM', 'Lyle', 'McGuckin', '491-999-2311', '1974-04-14', 'y'),
('lattrideca@seesaa.net', 'WCaA4aE1cru', 'Lyn', 'Attride', '910-512-7439', '1950-04-03', 'y'),
('lbennsn2@umn.edu', 'x7vjKR1ZmusR', 'Lyn', 'Benns', '824-670-8034', '1988-02-17', 'y'),
('lmurneymp@diigo.com', '7O1AImrEtu', 'Lynda', 'Murney', '363-376-9262', '1984-01-10', 'y'),
('lharbordao@1688.com', 'tN9pU5EVRE', 'Lyndy', 'Harbord', '354-930-4978', '1992-01-16', 'y'),
('lalthorpeau@wisc.edu', 'dFQxfbrPQZ', 'Lynett', 'Althorpe', '198-277-7770', '1963-09-03', 'y'),
('mbaswalldo@slate.com', 'wdWTzerT', 'Mace', 'Baswall', '813-313-7711', '1976-06-08', 'y'),
('mwarnockgg@xrea.com', 'Jg1aqM2gf', 'Mace', 'Warnock', '398-184-8882', '1967-04-18', 'y'),
('mmitroshinovcg@sciencedaily.com', 'ZFoWu9', 'Madalena', 'Mitroshinov', '433-387-6372', '1999-08-17', 'y'),
('menstonekh@sphinn.com', 'vhukfvD', 'Maddalena', 'Enstone', '145-624-9110', '1998-02-26', 'y'),
('mvickressc2@blogs.com', '0JFsLpV', 'Madelaine', 'Vickress', '608-361-4431', '1994-11-23', 'y'),
('mtaconfj@nsw.gov.au', 'D9eSfUE', 'Madeleine', 'Tacon', '381-717-6848', '1965-12-24', 'y'),
('mbowkerql@studiopress.com', 'AwJZGuI64at', 'Madelin', 'Bowker', '631-472-4571', '1987-07-15', 'y'),
('mfaier1g@miibeian.gov.cn', 'oy4GTqK849', 'Madelin', 'Faier', '385-947-2962', '1987-05-20', 'y'),
('mcarteran@jimdo.com', 'tqZNK8FqFmG', 'Maegan', 'Carter', '635-801-5767', '1988-11-08', 'y'),
('mdraisey8z@sciencedirect.com', '6pxp9VVM', 'Magda', 'Draisey', '792-978-2987', '2001-08-11', 'y'),
('megdelld5@unesco.org', 'WS9ml0CRi5', 'Mahmoud', 'Egdell', '432-326-8662', '1967-08-27', 'y'),
('mbentermanit@microsoft.com', 'zi8C1PDPZw', 'Malchy', 'Benterman', '459-444-1906', '1976-09-18', 'y'),
('mwillshawg8@va.gov', 'xdbBbHTN', 'Malinda', 'Willshaw', '646-185-7213', '1986-04-18', 'y'),
('mramalho9u@squarespace.com', 'SD2qUe', 'Malissia', 'Ramalho', '348-587-8107', '1960-12-27', 'y'),
('mcoito6@ibm.com', 'CmCvWP0', 'Mallory', 'Coit', '899-200-5526', '1956-04-14', 'y'),
('mcristofarik9@marriott.com', 'FIOdr3FtBc', 'Malva', 'Cristofari', '777-598-7362', '1982-08-26', 'y'),
('mchant2v@nbcnews.com', 'ToKA69s5', 'Malvina', 'Chant', '404-635-0407', '1987-03-14', 'y'),
('mzuckeree@webs.com', 's5lhbbazg', 'Malynda', 'Zucker', '749-538-6002', '1982-01-19', 'y'),
('mpakemanhr@ocn.ne.jp', 'idqcgqSWfGP', 'Manda', 'Pakeman', '813-798-4984', '1969-01-15', 'y'),
('mhodgets5x@theatlantic.com', 'eIAovy2s3T', 'Mandie', 'Hodgets', '360-820-4254', '1951-08-27', 'y'),
('mhindenberger8e@amazon.com', '930DjEMO', 'Manolo', 'Hindenberger', '176-905-9396', '1963-06-15', 'y'),
('mgarnson9g@freewebs.com', 'KXo2d5u', 'Manon', 'Garnson', '774-332-0072', '1999-03-12', 'y'),
('mmcalroyhu@drupal.org', 'ldp3Cx', 'Manon', 'McAlroy', '172-530-8572', '1952-10-05', 'y'),
('mlivesayl1@sun.com', 'DWWr0o', 'Manuel', 'Livesay', '742-705-6158', '1975-01-23', 'y'),
('maitken18@ed.gov', 'Uv6mwT', 'Mara', 'Aitken', '810-547-9761', '1991-06-26', 'y'),
('mbordissqd@cbsnews.com', 'QOVg97', 'Marcellina', 'Bordiss', '586-108-6105', '1977-09-21', 'y'),
('msteaningg0@businesswire.com', 'ofmYGMqLmxN', 'Marcelline', 'Steaning', '814-679-7936', '1989-07-16', 'y'),
('mhebdonjp@google.com.au', '3L4dfJzOsV', 'Marcello', 'Hebdon', '234-963-5962', '1960-10-02', 'y'),
('mpollicottg5@yellowbook.com', '1HcrKzyvuni', 'Marcile', 'Pollicott', '786-823-4669', '1995-03-08', 'y'),
('mpennialld3@cafepress.com', 'V7bFhpXjdeco', 'Marco', 'Penniall', '683-251-2757', '1986-09-02', 'y'),
('mchuckb8@cbslocal.com', 'L6BwskVbJ', 'Margalo', 'Chuck', '233-808-9462', '1997-02-13', 'y'),
('menston91@flavors.me', 'swaKzd9rCGi', 'Margalo', 'Enston', '862-820-1759', '1958-03-03', 'y'),
('mcesariciq@github.io', 'LWRjLLXlgtBe', 'Margaret', 'Cesaric', '800-228-0132', '1988-07-11', 'y'),
('mdutteridgeas@typepad.com', 'ewwGJn8LE', 'Margarethe', 'Dutteridge', '962-164-2759', '1991-10-17', 'y'),
('mhowlesla@4shared.com', 'PUN4cy4lkK', 'Margery', 'Howles', '495-640-0869', '1965-08-04', 'y'),
('mgarnargo@yellowbook.com', '9FvGANudWi', 'Margie', 'Garnar', '218-130-9260', '1992-06-05', 'y'),
('mduberym2@wp.com', 'Mv4Y9CYo79', 'Marian', 'Dubery', '505-968-7626', '1969-01-22', 'y'),
('mstampn7@istockphoto.com', 'qxTWuo', 'Marie-ann', 'Stamp', '300-771-4755', '1980-02-01', 'y'),
('mbruin4y@mediafire.com', 'GJJGSPHI', 'Mariel', 'Bruin', '248-600-4397', '1979-04-26', 'y'),
('mjanous5u@linkedin.com', 'EkqmAO1z', 'Marietta', 'Janous', '807-393-7248', '1976-10-12', 'y'),
('modonohuehj@irs.gov', 'Mhe84vYCSdQX', 'Marika', 'O\' Donohue', '828-536-9351', '1969-04-28', 'y'),
('mgeldeardck@skyrock.com', 'xRpM9v7D', 'Marinna', 'Geldeard', '514-610-7068', '1980-12-10', 'y'),
('mkassmana7@cbslocal.com', 'hm6aFTCbJq', 'Marion', 'Kassman', '768-981-1174', '1986-04-10', 'y'),
('mstannett6g@webnode.com', 'kdRI3MT8', 'Marion', 'Stannett', '284-684-3363', '1952-08-25', 'y'),
('mcastellscc@vk.com', 'BixLEzgT7ic1', 'Maritsa', 'Castells', '704-339-4198', '1951-04-25', 'y'),
('mkitchinghamod@google.com', 'oJFFCvZCZHqR', 'Marjie', 'Kitchingham', '568-846-7910', '1976-02-14', 'y'),
('mizaacp5@artisteer.com', 'l2PZfhk', 'Marjory', 'Izaac', '167-723-5378', '1956-11-07', 'y'),
('mserraillier9m@pen.io', 'HmnWfueNPf17', 'Marjory', 'Serraillier', '371-202-4592', '2001-08-05', 'y'),
('mtaverinerh9@hexun.com', 'L4tJZYtgl', 'Markus', 'Taveriner', '824-509-3601', '1981-08-18', 'y'),
('mbollam7y@typepad.com', 'upiXx4PWx0', 'Marla', 'Bollam', '765-248-3118', '1952-06-02', 'y'),
('mdabner2t@dedecms.com', '0z9Eg0x1E', 'Marlene', 'Dabner', '586-213-3315', '1979-10-14', 'y'),
('mmccaughan7t@sfgate.com', 'd9SPdhvwqFmB', 'Marsha', 'McCaughan', '131-240-8060', '1959-02-19', 'y'),
('mwinfreyof@bluehost.com', 'AkKGX0BE', 'Marsiella', 'Winfrey', '149-428-0794', '1982-03-27', 'y'),
('muchn@chicagotribune.com', 'BwBK2E4vZOLS', 'Martelle', 'Uc', '447-180-9546', '1979-07-07', 'y'),
('mdoreefi@huffingtonpost.com', 'fGj2uhmnYXPn', 'Marve', 'Doree', '749-685-1443', '1977-09-02', 'y'),
('mnellisql@github.io', 'v20JTh1Y', 'Marya', 'Nellis', '328-785-7996', '1979-08-01', 'y'),
('mbenaine2p@ning.com', 'kUiYduAV', 'Maryellen', 'Benaine', '742-600-8553', '1959-06-23', 'y'),
('mkeniwelle6@sohu.com', 'SGXfAPGPGa', 'Marylee', 'Keniwell', '113-272-9489', '1999-08-13', 'y'),
('mcopinsoi@ihg.com', 'iMbcp3yibzr', 'Marylin', 'Copins', '350-850-2852', '2001-02-26', 'y'),
('mdonhardt6v@theguardian.com', '3oucN6', 'Marylin', 'Donhardt', '592-962-8877', '1998-08-28', 'y'),
('mstobbart22@yahoo.co.jp', 'ZLzrI4iD0lGA', 'Mathe', 'Stobbart', '878-707-0880', '1989-04-26', 'y'),
('mwhitney1d@hc360.com', 'O9FDXY4aN', 'Mathilda', 'Whitney', '402-759-4641', '1990-05-17', 'y'),
('mblanche4e@creativecommons.org', 'xZe7v0gYM', 'Matias', 'Blanche', '273-206-6448', '1981-08-15', 'y'),
('mdabnerje@state.tx.us', 'FQtNt2', 'Matt', 'Dabner', '445-540-8515', '1994-01-19', 'y'),
('mlarringtondx@imdb.com', 'tbuDQDVz', 'Matteo', 'Larrington', '442-320-4553', '1967-04-26', 'y'),
('mtillertonb2@vkontakte.ru', '9krOWzxWFR', 'Matthew', 'Tillerton', '860-436-3528', '1959-10-27', 'y'),
('mronaynekh@house.gov', 'NssL8qiGQ5D', 'Matthias', 'Ronayne', '699-216-7035', '1960-03-20', 'y'),
('mpotes8f@google.de', 'HQ11HclDqRY3', 'Matthus', 'Potes', '434-685-0638', '1950-05-10', 'y'),
('mscathardd4@bravesites.com', 'AGdjVkm6', 'Mattie', 'Scathard', '248-604-9020', '1981-10-19', 'y'),
('mbarczynski3m@meetup.com', 'P2jxKiyCY', 'Maud', 'Barczynski', '297-877-6715', '1977-03-11', 'y'),
('mfauning9s@home.pl', 'fsUBJrDY5', 'Maude', 'Fauning', '856-487-2853', '1995-08-31', 'y'),
('mfenwickor@berkeley.edu', 'XTxNbhZcDi', 'Maure', 'Fenwick', '368-874-4291', '1965-04-18', 'y'),
('mepton2w@un.org', 'hATUmBK0', 'Maureene', 'Epton', '121-509-1162', '1981-04-21', 'y'),
('mbevensfo@unc.edu', 'jpQrEUhbIHc7', 'Maurise', 'Bevens', '168-375-4618', '1950-09-25', 'y'),
('mflockhartio@elpais.com', 'rYyvAp', 'Maurise', 'Flockhart', '470-912-5423', '1971-06-09', 'y'),
('mhousecrafto2@g.co', 'LcmdRJrU', 'Maurizia', 'Housecraft', '549-476-4852', '1980-03-10', 'y'),
('mjennokw@digg.com', 'mZ1wVk5yptat', 'Maurizia', 'Jenno', '506-636-8908', '1952-03-28', 'y'),
('mklazengagb@altervista.org', '9AK1ww1CKA', 'Mavis', 'Klazenga', '563-218-9502', '1990-12-02', 'y'),
('mromanellib7@a8.net', 'DEMKugfYK8P', 'Mavra', 'Romanelli', '789-932-4531', '1961-02-11', 'y'),
('mfoundcq@domainmarket.com', 'Gr7dX0dvK', 'Maximilianus', 'Found', '424-594-6569', '1959-09-14', 'y'),
('mcryer3@fda.gov', 'K4FaDC', 'May', 'Cryer', '900-335-4975', '1989-11-09', 'y'),
('mengadk@edublogs.org', 'YFHXZtLU', 'Maynord', 'Enga', '825-913-2723', '1971-06-26', 'y'),
('mmatejka5r@bizjournals.com', 'etknMmHsI', 'Mead', 'Matejka', '912-766-2441', '1991-07-23', 'y'),
('mwansburycg@yale.edu', 'l3Vf49', 'Megan', 'Wansbury', '121-324-8823', '1987-06-29', 'y'),
('mspilstead60@zimbio.com', 'L7aCa3', 'Megen', 'Spilstead', '358-377-9266', '1956-11-11', 'y'),
('magastina75@wufoo.com', '8HJ8NY2S', 'Meggie', 'Agastina', '347-575-6290', '1997-10-08', 'y'),
('mmartinellip@tripadvisor.com', 'L6hY7kDhmg', 'Meghann', 'Martinelli', '321-598-2207', '1997-02-21', 'y'),
('mstrainge5g@cocolog-nifty.com', '1TYoQU9e', 'Mei', 'Strainge', '199-990-3343', '1961-05-11', 'y'),
('mhunston5m@parallels.com', 'hLCb0Ft7PbQP', 'Meir', 'Hunston', '989-978-7209', '1961-09-14', 'y'),
('mstrutt23@google.es', '7kLb2MjiL', 'Meir', 'Strutt', '516-188-5121', '1970-08-07', 'y'),
('mclaxson1p@npr.org', '6rfWmC8', 'Melamie', 'Claxson', '932-608-4626', '1974-06-25', 'y'),
('mbrosettifb@timesonline.co.uk', '1pMeithUq', 'Melania', 'Brosetti', '158-475-6701', '1982-10-14', 'y'),
('mboggsqi@psu.edu', 'q8C8fumOoF', 'Melesa', 'Boggs', '668-441-7327', '1953-11-20', 'y'),
('mgoodersgz@posterous.com', 'xxeG3Xm2bBPD', 'Melessa', 'Gooders', '555-408-2020', '2001-03-25', 'y'),
('mheffordoa@pen.io', 'x7701O', 'Melinde', 'Hefford', '934-405-3226', '1981-02-09', 'y'),
('msemradm4@bloglines.com', 'NXDnawR4j67h', 'Melinde', 'Semrad', '306-130-7484', '1962-07-31', 'y'),
('mpreene7f@delicious.com', 'GekA2yQQ8I', 'Melisenda', 'Preene', '706-720-7035', '1953-07-24', 'y'),
('mslowgroveol@microsoft.com', 'fu0wej4I', 'Melita', 'Slowgrove', '370-507-9970', '1967-10-16', 'y'),
('mruddochv@sogou.com', 'zXjcCCr6R', 'Mella', 'Ruddoch', '739-876-4227', '1999-01-21', 'y'),
('msprullsfd@webmd.com', 'B3hBNeep', 'Mellisa', 'Sprulls', '220-671-8331', '1975-08-31', 'y'),
('mgrunbaumq9@nature.com', 'RN4KnRv', 'Mendel', 'Grunbaum', '919-502-7419', '1978-06-09', 'y'),
('mmcdonnelli6@virginia.edu', '26mkqi', 'Meredith', 'McDonnell', '759-342-2730', '1978-09-08', 'y'),
('mahmad9x@reuters.com', 'x1DrFWQkCX', 'Meredithe', 'Ahmad', '998-595-6819', '1993-07-13', 'y'),
('mgerb45@aol.com', 'RqnroL', 'Meridith', 'Gerb', '649-485-4697', '1982-06-15', 'y'),
('mlourens7j@t-online.de', 'EtHSUVe', 'Merna', 'Lourens', '491-765-2707', '1953-10-23', 'y'),
('mkobpand@dedecms.com', 'dDhYtz2p', 'Merrile', 'Kobpa', '289-284-1609', '1957-06-05', 'y'),
('mwessonam@e-recht24.de', 'QoUWnRXfa', 'Merrill', 'Wesson', '485-535-3566', '1964-04-10', 'y'),
('mgartelloq@irs.gov', '2SwgM9A', 'Merry', 'Gartell', '813-537-6258', '1998-07-24', 'y'),
('mginitygj@gov.uk', 'ThkkRQ1UF2it', 'Merry', 'Ginity', '642-804-2311', '1950-11-07', 'y'),
('mshortonfx@hhs.gov', 'pDuCqDR', 'Merry', 'Shorton', '833-336-4439', '1992-08-09', 'y'),
('mstorrock84@reuters.com', 'D6F3JQDIm', 'Merry', 'Storrock', '297-783-4826', '1962-01-25', 'y'),
('mdugdalenk@usgs.gov', 'qVmrZk6DYt', 'Meyer', 'Dugdale', '425-760-3467', '1958-08-22', 'y'),
('mchurchousefp@redcross.org', 'R11Q5T7HKvUG', 'Michaeline', 'Churchouse', '644-161-3841', '1979-06-26', 'y'),
('mnisbetdt@amazon.com', 'bHOAqBnIHPT', 'Michale', 'Nisbet', '785-779-5894', '1974-05-13', 'y'),
('mgovando@merriam-webster.com', 'kP07azdxq', 'Micheal', 'Govan', '280-997-6670', '1986-02-18', 'y'),
('mdedneycj@theguardian.com', 'SQfP5x0mShd', 'Michel', 'Dedney', '463-889-3115', '1964-06-11', 'y'),
('mmatteahw@hibu.com', 'xZgbWVL', 'Michelina', 'Mattea', '465-390-1541', '1983-05-09', 'y'),
('mmabeyq9@umn.edu', 'R5zLyLPFS0ac', 'Midge', 'Mabey', '118-313-4804', '1991-03-31', 'y'),
('mnancarrowp0@hibu.com', 'UziQhGzvbdlu', 'Mikel', 'Nancarrow', '546-402-7606', '1973-11-10', 'y'),
('mscirmanhz@google.es', '0EpAYnm1aOC', 'Mildred', 'Scirman', '620-177-7452', '1998-04-10', 'y'),
('molwenie@biblegateway.com', 'UqLGVd2DcdZt', 'Miles', 'Olwen', '538-178-6889', '1989-08-28', 'y'),
('mreachpr@ameblo.jp', 'zSBoLqsZQS', 'Miles', 'Reach', '562-427-4433', '1986-06-21', 'y'),
('mivanink@opensource.org', 'eQZy6OJ9Tz', 'Milka', 'Ivanin', '336-362-0024', '1991-08-23', 'y'),
('modooleyon@homestead.com', 'nIXkog', 'Milly', 'O\' Dooley', '421-979-3557', '1976-12-02', 'y'),
('msiggeb5@yahoo.co.jp', 'myKsIhpp9W', 'Milty', 'Sigge', '207-477-4040', '1996-07-22', 'y'),
('mjevonre@surveymonkey.com', 'yHiftSX', 'Mina', 'Jevon', '632-185-4914', '1957-03-13', 'y'),
('mdudenie3i@soundcloud.com', 'CeUJiWN', 'Minetta', 'Dudenie', '377-788-2547', '1951-10-27', 'y'),
('mjouannotch@google.de', 'YnleVXl', 'Miof mela', 'Jouannot', '477-589-2444', '1962-05-13', 'y'),
('mdefriesq5@cocolog-nifty.com', 'R0tEmIl8thht', 'Mirabella', 'Defries', '676-272-9330', '1986-10-29', 'y'),
('mgoodbody16@sphinn.com', 'D5k0Er', 'Mirabella', 'Goodbody', '395-203-0314', '1970-05-10', 'y'),
('mtanser3h@mysql.com', 'hLc75OdxJx', 'Miranda', 'Tanser', '140-389-6725', '1969-02-19', 'y'),
('mmerkel2g@eventbrite.com', '61iv5bfA', 'Mirelle', 'Merkel', '724-551-7929', '1975-01-23', 'y'),
('mcleworth4h@ted.com', 'z6LH3JiQAg', 'Miriam', 'Cleworth', '838-328-9111', '1982-12-01', 'y'),
('mlowderqr@bloglines.com', 'sBu9Gpd9', 'Mitch', 'Lowder', '651-329-2416', '1993-07-12', 'y'),
('mrosenblattc4@prweb.com', 'oYZp3StWL', 'Mitchell', 'Rosenblatt', '471-780-4837', '1985-06-10', 'y'),
('mholbieek@discuz.net', 'uMZ53XaFFW', 'Modestia', 'Holbie', '213-578-9098', '1992-10-03', 'y'),
('mmacconnultyog@umich.edu', 'nkgnlt58VniR', 'Modestia', 'MacConnulty', '907-948-3432', '2001-04-21', 'y'),
('mdecarlok3@barnesandnoble.com', 'UHX4kO', 'Moishe', 'De Carlo', '887-120-2943', '1978-10-18', 'y'),
('mstamper9@example.com', 'E2zHMVyaN', 'Moll', 'Stampe', '652-958-1686', '1966-01-10', 'y'),
('mtettherpl@prnewswire.com', '6HywTkpx', 'Moll', 'Tetther', '693-607-6513', '1981-07-28', 'y'),
('mbrendei@mysql.com', '2dlcsT', 'Mommy', 'Brende', '977-585-0125', '1960-09-10', 'y'),
('mlittlejohnsfb@state.gov', '9wRoU2MLVjsJ', 'Monro', 'Littlejohns', '297-648-0982', '1974-08-13', 'y'),
('mkellard8p@ftc.gov', 'mbVkMTg0', 'Monroe', 'Kellard', '197-401-4283', '1980-01-07', 'y'),
('mburnagedl@creativecommons.org', 'UxELiZAE5ozD', 'Montague', 'Burnage', '675-931-0743', '1980-07-01', 'y'),
('mshimmin9l@plala.or.jp', 'fw5hIaoM9bda', 'Montgomery', 'Shimmin', '177-977-6230', '1976-05-14', 'y'),
('moverellgd@discuz.net', 'HLX5VYDnPKo', 'Morganne', 'Overell', '180-789-0752', '1997-05-17', 'y'),
('mhaddickqq@macromedia.com', 'CiCohZthB', 'Morgen', 'Haddick', '900-579-9936', '1995-08-24', 'y'),
('mpernell1n@tripadvisor.com', 'yRJUDGAzak', 'Moria', 'Pernell', '388-661-3983', '1984-02-05', 'y'),
('mhuettcd@theatlantic.com', 'wlAZlt', 'Moritz', 'Huett', '461-918-6860', '1963-12-06', 'y'),
('mlusty82@sphinn.com', 'n2LzXaE8V', 'Moritz', 'Lusty', '228-291-4855', '1978-01-01', 'y'),
('mdesporteps@last.fm', 'CNH2UDjzm09N', 'Morlee', 'Desporte', '385-589-4285', '1972-06-28', 'y'),
('mstirrupra@csmonitor.com', 'vrepniw8DAT', 'Morley', 'Stirrup', '883-717-7047', '1965-04-12', 'y'),
('marnholtzm7@ocn.ne.jp', 'utzOZbLKnr7', 'Morly', 'Arnholtz', '348-713-6753', '1975-11-01', 'y'),
('mgirodonp7@t-online.de', 'NKqx5IGO', 'Morna', 'Girodon', '242-237-8558', '1976-12-03', 'y'),
('mroddellcy@t-online.de', 'HoygwP', 'Morna', 'Roddell', '731-709-8247', '1957-07-08', 'y'),
('mmcamishos@booking.com', 'CqX3bydYxKiN', 'Morse', 'McAmish', '890-564-8983', '1978-07-01', 'y'),
('msantenu@yahoo.co.jp', 'XyrpUYa', 'Morten', 'Sante', '827-874-6089', '1987-12-10', 'y'),
('mmcclancyn9@msn.com', '0fBm3ar', 'Mortimer', 'McClancy', '459-220-1491', '1964-02-03', 'y'),
('mwherton4i@shareasale.com', 'i6jYVmCB', 'Moyna', 'Wherton', '787-426-6610', '1980-07-07', 'y'),
('marguecw@printfriendly.com', 'I54Azwy8Kbt', 'Muffin', 'Argue', '453-546-1309', '1955-08-30', 'y'),
('mentres1d@disqus.com', 'g8FInkMo', 'Mufi', 'Entres', '219-188-8177', '1984-07-26', 'y'),
('mroswarner4@typepad.com', 'S7TETJcUpSmG', 'My', 'Roswarne', '220-603-0322', '1986-11-11', 'y'),
('mcorranfa@oaic.gov.au', 'fXomJb', 'Myer', 'Corran', '536-138-8046', '2000-12-04', 'y'),
('mstillert2r@census.gov', 'CmBu9giF', 'Myer', 'Stillert', '438-156-5576', '1970-03-06', 'y'),
('mgabalan6@ft.com', 'coGzeU8Fp', 'Mylo', 'Gabala', '178-199-4452', '1950-11-22', 'y'),
('msetterthwait1i@zdnet.com', 'qscOTQgdLpZJ', 'Mylo', 'Setterthwait', '990-925-8651', '1970-09-30', 'y'),
('mnorthing6p@biblegateway.com', 'Qs1jjdHSy', 'Myrtice', 'Northing', '860-899-9309', '1983-12-25', 'y'),
('mhapkec0@deliciousdays.com', 'ev9HeaTP2LKG', 'Myrwyn', 'Hapke', '838-153-8382', '1963-01-10', 'y'),
('ngeggusr5@theglobeandmail.com', '35iEn2Gr', 'Nan', 'Geggus', '713-661-5338', '2001-02-06', 'y'),
('nbatchanno@google.ca', 'WATU196qd5o', 'Nananne', 'Batchan', '185-305-0797', '1967-07-23', 'y'),
('neidelman7a@ed.gov', 'SEJYgp', 'Nanete', 'Eidelman', '711-434-8418', '1955-06-04', 'y'),
('nmccreaap@360.cn', 'YXktZ4Z', 'Nannette', 'McCrea', '744-474-3716', '1975-07-15', 'y'),
('ncalifornia1o@meetup.com', 'Wivfti4heG6', 'Nanon', 'California', '714-735-0704', '1960-03-25', 'y'),
('nmakinkm@bigcartel.com', 'AwYmtBDCb', 'Naoma', 'Makin', '385-837-9564', '1966-11-19', 'y'),
('nblowinglh@vimeo.com', 'P4tzYfs4p', 'Napoleon', 'Blowing', '626-994-3182', '1969-01-09', 'y'),
('nscutchingmj@addtoany.com', 'NzOjfuDXtZ', 'Nappy', 'Scutching', '408-933-7644', '1954-08-17', 'y'),
('ncastagnen0@twitpic.com', 'jZbDfVus', 'Natalya', 'Castagne', '612-396-7123', '1994-07-31', 'y'),
('ngrayleyae@latimes.com', 'G3bd7rnWE', 'Nathalia', 'Grayley', '200-383-8585', '1983-05-22', 'y'),
('nlodeh6@mozilla.org', 'Dmpa9vdh', 'Nathalia', 'Lode', '124-985-4540', '1975-10-13', 'y'),
('ntrenear2c@canalblog.com', '1vJ5Ym', 'Nathalie', 'Trenear', '708-381-3366', '1974-09-28', 'y'),
('npryke7q@un.org', 'bWiGyULqBJ1', 'Nathan', 'Pryke', '228-148-5784', '1992-07-25', 'y'),
('nbrimicombed@flickr.com', 'Ouz6FL', 'Natka', 'Brimicombe', '659-498-6791', '1976-06-06', 'y'),
('nbrundrett8p@va.gov', '7mdIMHig5', 'Natty', 'Brundrett', '384-837-8640', '1994-02-15', 'y'),
('nwoodingsou@xinhuanet.com', 'v98ggR0gMc', 'Neale', 'Woodings', '434-818-3869', '1987-07-11', 'y'),
('nlatourj3@ask.com', 'mzpzt1K2', 'Neall', 'Latour', '595-319-5012', '1978-10-12', 'y'),
('natchly5w@bluehost.com', 'Feky4NQh', 'Neddie', 'Atchly', '899-813-9772', '1962-08-03', 'y'),
('nkrookaq@ed.gov', 'DD1cZji9a', 'Neddie', 'Krook', '238-498-3124', '1952-11-29', 'y'),
('nstanger70@mysql.com', 'GpBkSg0g', 'Neil', 'Stanger', '427-118-6486', '1965-12-25', 'y'),
('nscrannyoh@canalblog.com', 'yM43ox', 'Neille', 'Scranny', '419-775-7346', '1978-04-23', 'y'),
('nlinckeeb@apple.com', 'WVy4Y9Yf', 'Nelie', 'Lincke', '688-983-7030', '1994-02-02', 'y'),
('npawleyku@ezinearticles.com', 'twKLNwMfGONn', 'Nerissa', 'Pawley', '612-511-8215', '1957-08-21', 'y'),
('npirdyek@cdc.gov', 'tfBiPB', 'Nerissa', 'Pirdy', '521-114-9174', '1993-11-17', 'y'),
('nnovak4v@weather.com', 'Z27xFfusI', 'Nero', 'Novak', '547-875-0293', '1963-01-20', 'y'),
('nkemmn2@last.fm', 'Zo4IOH', 'Neron', 'Kemm', '569-163-2270', '1992-01-24', 'y'),
('nrobotthambq@fda.gov', 'Vf9bsbFlQLew', 'Nerta', 'Robottham', '621-290-1964', '1987-03-07', 'y'),
('nschooling8b@clickbank.net', 'wVFavfGtuhKY', 'Nerte', 'Schooling', '662-638-9502', '1972-01-26', 'y'),
('npohlakrf@npr.org', 'cWJblvRlMiX', 'Nevile', 'Pohlak', '788-795-1899', '1992-02-10', 'y'),
('nwreakesd8@sourceforge.net', 'uAHTssPTNxI', 'Nevile', 'Wreakes', '314-546-1636', '1953-07-23', 'y'),
('nsweetland3g@ezinearticles.com', 'dtDMG200LH6', 'Neville', 'Sweetland', '414-360-1536', '1962-12-27', 'y'),
('nalekseicikp7@godaddy.com', 'HPS55S', 'Nial', 'Alekseicik', '199-740-2924', '1996-06-03', 'y'),
('ndicarlib1@cnn.com', 'SbbQmqbNcihC', 'Nickey', 'Di Carli', '517-274-8475', '1975-05-15', 'y'),
('nmatonin2f@blinklist.com', '3IGx2jV0vvNM', 'Nickolai', 'Matonin', '967-289-8116', '1983-02-25', 'y'),
('nogeaneynh@webmd.com', 'f7T09WN9ipq', 'Nickolaus', 'O\'Geaney', '372-653-3744', '1994-08-24', 'y'),
('nwimburyds@purevolume.com', 'MpQ5LEwmm9X', 'Nicky', 'Wimbury', '990-619-7779', '1965-10-25', 'y'),
('nsammut1q@cdbaby.com', 'hkdsZQUkQ', 'Nico', 'Sammut', '718-842-8942', '1958-06-18', 'y'),
('ngraffin4w@pinterest.com', 'ecOeGAOoP', 'Nicol', 'Graffin', '940-535-7359', '1989-07-30', 'y'),
('ncoldbreath6c@mysql.com', 'qHE8cYqzHwSN', 'Nicola', 'Coldbreath', '514-932-0312', '1994-07-04', 'y'),
('nmolanqg@uol.com.br', 'LrV8hmk0D', 'Nicolette', 'Molan', '375-956-0645', '1954-10-11', 'y'),
('nsweetmore5h@sakura.ne.jp', 'Wlu5DVf', 'Nicolle', 'Sweetmore', '189-256-5811', '1976-09-04', 'y'),
('nmaffiakj@google.ca', 'SLSJJaUO', 'Nike', 'Maffia', '142-297-8000', '1994-03-08', 'y'),
('nperdue5w@nature.com', 'ct5HfiGAc3Y4', 'Nike', 'Perdue', '687-389-2791', '1994-05-17', 'y'),
('nvedmore4b@goo.gl', 'cP3gkYohy', 'Niki', 'Vedmore', '865-201-8741', '1982-01-14', 'y'),
('nkitneyl0@dailymail.co.uk', 'MPSg9esn8U0O', 'Nikita', 'Kitney', '728-740-7498', '1967-02-28', 'y'),
('nbaumanbh@imdb.com', 'IatqF0j69hR', 'Nikolai', 'Bauman', '820-323-8332', '1984-12-15', 'y'),
('ntossellcx@latimes.com', 'nPz2qwVY5n1j', 'Nikos', 'Tossell', '649-991-2748', '1983-08-09', 'y'),
('nconlonpv@dell.com', 'MoLqLPrcs3', 'Niles', 'Conlon', '741-346-2787', '2000-10-06', 'y'),
('noliveto7p@harvard.edu', 'zmJ7YI8lw63', 'Nissie', 'Oliveto', '750-561-9192', '1958-03-22', 'y'),
('ndowlingar@usnews.com', 'vyyxrAK9e', 'Niven', 'Dowling', '198-240-0449', '1983-11-22', 'y'),
('ncrouchf3@ftc.gov', 'GH9M28HjP', 'Noami', 'Crouch', '219-245-6552', '1983-02-09', 'y'),
('nvampluso7@webs.com', 'GMNVrDRgf', 'Nobe', 'Vamplus', '388-259-3363', '1951-08-31', 'y'),
('npeters9f@printfriendly.com', 'JqlNZNLd3jm0', 'Noble', 'Peters', '870-958-3059', '1977-04-18', 'y'),
('nhorburghoc@odnoklassniki.ru', 'rhKDtLuJz', 'Noby', 'Horburgh', '486-622-8682', '1971-01-22', 'y'),
('nfantone2x@comsenz.com', 'NNSlRnO5Fed', 'Noel', 'Fantone', '715-463-4521', '1956-10-18', 'y'),
('nwoolvinhp@1688.com', '5xVeE6yeT', 'Noel', 'Woolvin', '241-806-3894', '1967-01-02', 'y'),
('nbothbieq0@dyndns.org', 'm8SqkMe', 'Noemi', 'Bothbie', '298-271-8916', '1958-09-30', 'y'),
('nworman5k@abc.net.au', 'KooHhL4Z4s7', 'Nola', 'Worman', '952-856-6879', '1986-11-22', 'y'),
('npatleyob@loc.gov', 'mO8SAnk0iRa', 'Nollie', 'Patley', '984-107-2529', '1954-03-07', 'y'),
('nslottf9@delicious.com', 'uRxrgC', 'Nollie', 'Slott', '209-752-8371', '1998-10-22', 'y'),
('nsealoveka@usa.gov', 'YgrCHRum', 'Nomi', 'Sealove', '296-332-8916', '1978-03-17', 'y'),
('nhawthornq5@wsj.com', 'ClDsDXxp', 'Norina', 'Hawthorn', '322-839-6580', '1955-07-30', 'y'),
('nbillyardy@bloglovin.com', 'qZagnBRQV9', 'Normy', 'Billyard', '788-655-6592', '1985-09-04', 'y'),
('nralphs53@digg.com', 'eL4fD0WN5gaB', 'Norri', 'Ralphs', '720-724-5648', '1956-06-02', 'y'),
('nsimminshx@mozilla.com', 'eqyQ4U8f', 'Norry', 'Simmins', '510-116-8627', '1960-11-20', 'y'),
('nglosterlm@squidoo.com', 'FP99ljZ1XLIs', 'North', 'Gloster', '503-557-7600', '1998-10-16', 'y'),
('ngiacopellorf@elegantthemes.com', 'hWnM0Ew', 'Northrup', 'Giacopello', '495-904-6235', '2001-01-17', 'y'),
('nmallordqv@google.nl', 'qdYMkXcZqZ', 'Norton', 'Mallord', '759-645-0893', '1980-03-13', 'y'),
('nbrimilcombebr@liveinternet.ru', 'zb9HZo4r3UjF', 'Novelia', 'Brimilcombe', '374-309-8770', '1955-08-24', 'y'),
('ocoffeem3@networkadvertising.org', 'NN96Hz', 'Obie', 'Coffee', '600-295-2844', '1956-09-16', 'y'),
('omusgrovegl@examiner.com', 'VYTFJjvz5V', 'Odie', 'Musgrove', '181-173-5670', '1962-08-10', 'y'),
('ookinedyko@princeton.edu', '72QRqfK', 'Ogdan', 'O\'Kinedy', '585-672-2024', '1986-05-08', 'y'),
('ostanmerny@themeforest.net', 'dpIGZbd9nZD', 'Olin', 'Stanmer', '802-310-0240', '1986-08-17', 'y'),
('ochattockot@feedburner.com', '6KTYxIBS', 'Olivette', 'Chattock', '802-775-3529', '2000-02-22', 'y'),
('odutnelljm@liveinternet.ru', 'lcmzoqX', 'Olivette', 'Dutnell', '497-820-0614', '2001-10-12', 'y'),
('oletherburybc@tiny.cc', 'dyIATRdzQBD', 'Oliviero', 'Letherbury', '812-828-4256', '1978-12-19', 'y'),
('ostaniforthdm@home.pl', 'ASo2txjzi', 'Oliviero', 'Staniforth', '812-866-6935', '1966-04-25', 'y'),
('ohartlelw@godaddy.com', 'OTkDAUsUPgv', 'Onfroi', 'Hartle', '706-377-7422', '1998-01-14', 'y'),
('obarnesa0@admin.ch', '6mZSECSqfOY4', 'Oona', 'Barnes', '736-806-8210', '1965-06-25', 'y'),
('odoubledaybj@friendfeed.com', 'e2eXlj', 'Ora', 'Doubleday', '239-127-3198', '2000-03-23', 'y'),
('oirdale56@trellian.com', 'vgYaQ3', 'Oran', 'Irdale', '167-921-4661', '1976-04-23', 'y'),
('olukasen8d@ocn.ne.jp', 'n3VQU8', 'Oren', 'Lukasen', '569-794-8123', '1983-01-23', 'y'),
('oelsmoredl@spiegel.de', 'jcF04f4', 'Orion', 'Elsmore', '152-692-3409', '1998-09-18', 'y'),
('ofawbertkd@1688.com', 'FlDif9WlpOa8', 'Orlando', 'Fawbert', '687-184-5307', '1984-04-07', 'y'),
('oleemansdc@mapy.cz', 'VAvAInx', 'Orson', 'Leemans', '490-433-1925', '1991-08-31', 'y'),
('osuermeierlf@feedburner.com', 'iCuxuzBRgsN', 'Ortensia', 'Suermeier', '259-737-2378', '1951-11-12', 'y'),
('oshortonll@constantcontact.com', 'U7JL0S7', 'Osbourne', 'Shorton', '638-520-0504', '1975-03-29', 'y'),
('obridalh7@instagram.com', 'IlauAzk', 'Otes', 'Bridal', '399-387-9635', '1990-04-03', 'y'),
('otrees69@lycos.com', 'gXLYHw', 'Otes', 'Trees', '197-351-2140', '1954-09-12', 'y'),
('pbearnr1@cnet.com', '9aieQwxy', 'Pace', 'Bearn', '430-655-3348', '1972-12-23', 'y'),
('polivera9b@1und1.de', '8r9AMbqa', 'Pacorro', 'Olivera', '738-591-8447', '1982-08-19', 'y'),
('pclinkard32@biblegateway.com', '9RDufELl', 'Padraig', 'Clinkard', '194-345-1980', '1995-04-26', 'y'),
('pdenseyjg@topsy.com', 'jeNwgpdy', 'Page', 'Densey', '990-292-0411', '1974-02-25', 'y'),
('prainsburybc@epa.gov', 'MFhuB4Xoh', 'Paige', 'Rainsbury', '749-217-3895', '2000-09-30', 'y'),
('psurgood8h@weather.com', 'N7lsiUbVS0l', 'Pamella', 'Surgood', '817-137-2117', '2001-02-17', 'y'),
('pwartonr@slate.com', 'mOOWJm', 'Pammi', 'Warton', '150-379-6288', '1985-08-25', 'y'),
('pshulemlg@oakley.com', 'AyhGluSDHrw', 'Pansie', 'Shulem', '726-980-1246', '1969-04-17', 'y'),
('pmurfin47@icio.us', '7VtwONV1', 'Parnell', 'Murfin', '630-395-2603', '1968-03-13', 'y'),
('psmaridgeia@pinterest.com', 'Dpp6QIJD', 'Parsifal', 'Smaridge', '225-806-0011', '1965-07-08', 'y'),
('pgraingehx@businessweek.com', 'CVRXzV7Y6fR', 'Pascal', 'Grainge', '526-694-1952', '1956-11-14', 'y'),
('pmckimmqm@rediff.com', '0tvZuGah', 'Pasquale', 'McKimm', '288-114-1925', '1960-03-27', 'y'),
('pduffett8o@chron.com', '0EDf580', 'Paten', 'Duffett', '198-505-4253', '1961-10-05', 'y'),
('pheggmz@storify.com', 'oapUJp1', 'Patience', 'Hegg', '578-159-0731', '1975-08-05', 'y'),
('pkastingw@privacy.gov.au', '9Hbr0UQ', 'Paton', 'Kasting', '129-264-0113', '1981-03-31', 'y'),
('palderwickn4@msn.com', 'GtVTBeRle', 'Paulette', 'Alderwick', '966-641-2593', '1973-01-09', 'y'),
('preddickfv@cdbaby.com', 'Y6z3zzmwoEDm', 'Paulina', 'Reddick', '917-682-7244', '1980-06-22', 'y'),
('pchesterfieldhc@drupal.org', 'KWlMQu', 'Pauly', 'Chesterfield', '546-426-2723', '1969-02-05', 'y'),
('ppuvia24@salon.com', 'IItF52c1fm', 'Pavla', 'Puvia', '918-646-7412', '1964-11-27', 'y'),
('pwhitebrooker@prnewswire.com', 'u1npuGL', 'Pavla', 'Whitebrook', '734-598-3811', '1954-04-09', 'y'),
('pmeneofa@storify.com', 'zBWxnV', 'Pavlov', 'Meneo', '733-296-1296', '1962-10-28', 'y'),
('pchadneyiz@marketwatch.com', 'J6yc9i3k95', 'Pearle', 'Chadney', '315-104-5325', '1969-10-18', 'y'),
('palmeyfm@nbcnews.com', 'N67GStRuB', 'Pebrook', 'Almey', '261-495-0222', '1999-02-08', 'y'),
('pmccaskillmk@themeforest.net', '3UmVjOK5', 'Penelopa', 'McCaskill', '392-873-2143', '1961-11-09', 'y'),
('plytleht@soup.io', 'CPH4Gbj9f', 'Pepillo', 'Lytle', '746-759-0850', '1987-04-14', 'y'),
('pmachostiei9@unc.edu', '6APklMI7xwC', 'Percival', 'MacHostie', '535-159-2126', '1994-07-06', 'y'),
('ptophamni@networksolutions.com', 'r0SgcCKzH6d', 'Perl', 'Topham', '284-968-0842', '1983-12-09', 'y'),
('pravenscraft39@ucla.edu', 'MatZpkD', 'Pernell', 'Ravenscraft', '984-142-2306', '1975-02-05', 'y'),
('pgraysmark5b@japanpost.jp', 'T97FKWNHkSb', 'Perren', 'Graysmark', '548-658-6656', '1999-10-02', 'y'),
('pwakeley2x@tuttocitta.it', 'dy7k56q', 'Perry', 'Wakeley', '278-333-5837', '1977-02-11', 'y'),
('pcrispe7l@angelfire.com', '7NoDFFk6e', 'Pet', 'Crispe', '490-789-2924', '1950-01-06', 'y'),
('pwantlingmp@discovery.com', 'UVncP3', 'Pet', 'Wantling', '982-885-8290', '1982-09-03', 'y'),
('pneighbourcp@plala.or.jp', 'eLEEd41E', 'Peta', 'Neighbour', '988-405-5297', '1999-06-08', 'y'),
('prawlinsonba@yolasite.com', '6YWtRu6x6', 'Petey', 'Rawlinson', '469-250-6135', '1963-07-26', 'y'),
('pwildgoose8e@storify.com', '1wsfTrhBsZ0', 'Petronia', 'Wildgoose', '510-925-2850', '1986-01-16', 'y'),
('pdictybf@nytimes.com', 'huPovcBR9xc', 'Philbert', 'Dicty', '969-843-6897', '1987-10-20', 'y'),
('parderneg6@shinystat.com', 'Y0AbLtESFBM', 'Philipa', 'Arderne', '278-534-9907', '1973-07-04', 'y'),
('pensleyki@wsj.com', '8yawxAEaeWyq', 'Philippe', 'Ensley', '503-114-2310', '1990-10-14', 'y'),
('pkirvin14@cmu.edu', '2rbNSA9Yk0', 'Philippine', 'Kirvin', '966-703-3009', '1980-03-30', 'y'),
('pnesterlo@dmoz.org', '72dqRg7UST', 'Philomena', 'Nester', '396-606-0785', '1962-06-11', 'y'),
('pgorring42@artisteer.com', 'BfI60fKj', 'Pierce', 'Gorring', '639-949-6777', '1973-03-31', 'y');
INSERT INTO `_user` (`user_email`, `pass`, `first_name`, `last_name`, `phone_number`, `dob`, `is_user`) VALUES
('pstubbedf@earthlink.net', 'apavMVB2ye', 'Pierce', 'Stubbe', '869-509-4105', '1979-06-05', 'y'),
('pruler8g@craigslist.org', 'pEj8SPs7lhgY', 'Pierette', 'Ruler', '433-535-0624', '1986-04-02', 'y'),
('pmacmoyer3p@ifeng.com', 'cazLDXZb', 'Pippo', 'MacMoyer', '588-328-7361', '1962-09-20', 'y'),
('pdumpletonoh@goodreads.com', 'NuX4ig4', 'Pooh', 'Dumpleton', '151-406-9068', '1995-09-01', 'y'),
('pdelaharpe3q@sciencedirect.com', 'AqN8VDPrxQL', 'Portia', 'De la Harpe', '687-169-3964', '1998-05-01', 'y'),
('pluckcuckc6@independent.co.uk', 'FGIqbasTJxg', 'Puff', 'Luckcuck', '142-547-7413', '1980-12-16', 'y'),
('qmattosoffii@acquirethisname.com', 'HN61IfN8U', 'Quintus', 'Mattosoff', '490-607-1299', '1957-01-31', 'y'),
('rrochil@canalblog.com', 'INBFUladosn', 'Rachele', 'Roch', '705-470-9650', '1987-06-19', 'y'),
('rheynelpj@examiner.com', '9qQRFPsl6', 'Raf', 'Heynel', '558-949-6353', '1980-06-03', 'y'),
('rcleef6h@senate.gov', '8iKoTSkdr81', 'Rafaela', 'Cleef', '253-794-3308', '1967-08-13', 'y'),
('rzima5v@yale.edu', 'KgJ3pbIAXW', 'Rafi', 'Zima', '283-680-2529', '1982-03-02', 'y'),
('rales6@joomla.org', 'gaGnW8wUj', 'Rahal', 'Ales0', '716-783-7618', '1950-08-22', 'y'),
('rquayle8y@bloomberg.com', 'UpxrW2T7Os', 'Ralina', 'Quayle', '665-258-1972', '1960-03-12', 'y'),
('rfelten36@godaddy.com', 'VHngzIJ', 'Ramon', 'Felten', '160-610-9082', '1958-10-26', 'y'),
('rballintynee9@oracle.com', 'pHyIjZ0t', 'Rand', 'Ballintyne', '662-117-3042', '1960-05-14', 'y'),
('rpapezi3@ow.ly', 'LhY406v', 'Randal', 'Papez', '892-360-8476', '1997-11-12', 'y'),
('rpeatmanqe@forbes.com', 'twSje6', 'Randal', 'Peatman', '364-489-4845', '1990-01-18', 'y'),
('rpollett45@cbc.ca', 'DmA5lfKLZbN4', 'Randall', 'Pollett', '730-208-7558', '1959-11-16', 'y'),
('rswynfenhi@xrea.com', 'SOzrusilWB', 'Randell', 'Swynfen', '240-883-6476', '1987-09-23', 'y'),
('rcollinop@japanpost.jp', 'VrHBWiq9fyhb', 'Raye', 'Collin', '591-210-7861', '2001-09-27', 'y'),
('rmccaghandv@fotki.com', 'axPoVtYeI', 'Rayna', 'McCaghan', '532-664-0437', '1999-03-05', 'y'),
('rbennellq4@wiley.com', 'afuLeWtO', 'Rayner', 'Bennell', '439-615-8447', '1988-05-09', 'y'),
('rbandeykz@bloomberg.com', '1QQJ3gz', 'Raynor', 'Bandey', '107-794-9476', '1955-04-03', 'y'),
('rtebbitiz@nasa.gov', 'EOC7aOIL1C', 'Raynor', 'Tebbit', '116-943-4379', '1989-04-26', 'y'),
('roday65@google.cn', '0BHW3HLP', 'Rayshell', 'O\'Day', '286-468-7523', '1981-03-06', 'y'),
('rriddeoughbp@theguardian.com', 'tcqK532FMcvq', 'Rebecka', 'Riddeough', '107-629-8757', '1984-10-26', 'y'),
('rmulchronerk@ucoz.ru', '5HasRk', 'Rebeka', 'Mulchrone', '450-548-7497', '1981-07-28', 'y'),
('rbestman7u@google.nl', 'vpf8zX8VqNLs', 'Rebekkah', 'Bestman', '627-755-3144', '1970-05-03', 'y'),
('rcaslaneow@unicef.org', 'yWXcVx', 'Ree', 'Caslane', '524-448-8844', '1967-11-06', 'y'),
('rainleybb@tmall.com', 'ClrUkKwLxW', 'Regan', 'Ainley', '986-770-3999', '1956-02-10', 'y'),
('rmaragesqv@ycombinator.com', 'aP6fkNEg', 'Regen', 'Marages', '241-345-8598', '1961-04-24', 'y'),
('rosharry6x@accuweather.com', 'ZRKVzkWo1', 'Reiko', 'O\'Sharry', '387-278-8933', '1966-05-23', 'y'),
('rnoireljs@oracle.com', 'nqUOAc', 'Reina', 'Noirel', '206-697-1913', '1960-02-14', 'y'),
('rjohannespu@marketwatch.com', 'MBYFvv6', 'Reinaldos', 'Johannes', '757-566-2741', '1988-04-20', 'y'),
('rswanboroughf6@fema.gov', 'ZnlYBrx', 'Remington', 'Swanborough', '518-829-7113', '1970-04-10', 'y'),
('rthackerayqy@alibaba.com', 'IdpWIk', 'Remington', 'Thackeray', '488-579-8859', '1982-11-01', 'y'),
('rkibble3w@paginegialle.it', 'RAWOuGY5R', 'Rena', 'Kibble', '337-463-2080', '1963-12-25', 'y'),
('rwinfield52@google.com.br', 'E6umrpzwkej3', 'Rena', 'Winfield', '249-640-0766', '1974-10-20', 'y'),
('ritzkovwichhq@pcworld.com', 'ACNi39', 'Renata', 'Itzkovwich', '509-737-5761', '1992-03-01', 'y'),
('rnajera3c@google.es', 'OSMz8u12h', 'Renata', 'Najera', '309-738-1123', '1984-07-09', 'y'),
('rdibb2o@artisteer.com', 'o2meyt8O', 'Rene', 'Dibb', '146-284-3918', '1980-11-30', 'y'),
('rruprechtermn@unicef.org', 'SmPgDq', 'Rennie', 'Ruprechter', '589-818-9754', '1962-08-02', 'y'),
('rconingif@phoca.cz', 'KvWExg7m7', 'Reube', 'Coning', '576-956-8531', '1978-07-01', 'y'),
('rgoddardgs@sciencedaily.com', 'W6F4jxcm5F', 'Revkah', 'Goddard', '589-507-0485', '1952-08-05', 'y'),
('rlightbj@walmart.com', 'Ofdh0YO5vas', 'Rey', 'Light', '474-130-0877', '1960-04-05', 'y'),
('rleggenff@prweb.com', 'TSVza4aHgrS', 'Rhiamon', 'Leggen', '856-907-9579', '1973-04-04', 'y'),
('rsorsbiehk@slideshare.net', 'wpNOiqCiYcOY', 'Rhody', 'Sorsbie', '489-370-5935', '1981-10-22', 'y'),
('rcoasterpd@flavors.me', 'gjTvLc5BGdFZ', 'Riane', 'Coaster', '478-833-4279', '1966-10-21', 'y'),
('rgrestyqz@vk.com', '3fV2KZ1', 'Rianon', 'Gresty', '293-193-3275', '2001-12-11', 'y'),
('rcrannachlb@eepurl.com', 'KcuhlH2yg0', 'Ric', 'Crannach', '928-666-4575', '1961-04-08', 'y'),
('rblankley4d@wikimedia.org', '2WLvFPd', 'Riccardo', 'Blankley', '780-338-7902', '1987-02-18', 'y'),
('rjoosti8@unicef.org', 'rprXQGYyF5mK', 'Rici', 'Joost', '859-823-1371', '2000-07-18', 'y'),
('rdomoneyak@webmd.com', 'ndqTeAl24P', 'Rick', 'Domoney', '749-857-6067', '1954-04-12', 'y'),
('rmoraaj@ibm.com', 'nGuhkjvWa', 'Rickard', 'Mora', '515-529-6082', '1975-11-04', 'y'),
('rsplaven1c@bloglovin.com', 'ZszqCzZ', 'Ricki', 'Splaven', '752-399-9922', '1989-04-01', 'y'),
('rkear6e@newsvine.com', 'aYovsRGr', 'Rinaldo', 'Kear', '770-579-3562', '1972-01-09', 'y'),
('rbillingtonm0@ibm.com', 'uU2g16', 'Ringo', 'Billington', '489-139-9184', '1964-06-28', 'y'),
('rfurmagehr@clickbank.net', '0E2jdZ1vn', 'Riobard', 'Furmage', '892-998-3619', '1999-06-06', 'y'),
('rbeardmorei2@pen.io', 'koZUyC', 'Risa', 'Beardmore', '833-956-8863', '1981-03-30', 'y'),
('ryoskowitzae@npr.org', 'Upd9ZvOKZ', 'Rivkah', 'Yoskowitz', '332-558-0212', '1990-05-13', 'y'),
('rpavlenko3e@cyberchimps.com', 'TcVvY4r', 'Rivy', 'Pavlenko', '366-798-0214', '1972-04-11', 'y'),
('rgrimme1s@amazonaws.com', 'WJ1xpypgmy', 'Roarke', 'Grimme', '228-284-4611', '1965-12-02', 'y'),
('rbabonf8@sogou.com', 'vtDyb2kLNd', 'Robbie', 'Babon', '910-760-1694', '1963-07-02', 'y'),
('rditter6r@nsw.gov.au', 'vfNmRV5mz', 'Robbie', 'Ditter', '686-418-1170', '1966-12-24', 'y'),
('rfeehely2n@google.com.au', 'gi7SuogzcH', 'Robbin', 'Feehely', '720-523-1453', '1960-03-16', 'y'),
('rallans68@zimbio.com', 'WGb8zrFV0', 'Robers', 'Allans', '624-702-3465', '1997-09-07', 'y'),
('rrizzini17@blinklist.com', 'ChoIqXqqbqOT', 'Robers', 'Rizzini', '631-712-2906', '1972-02-17', 'y'),
('readdycn@cmu.edu', 'ZaC8nMf', 'Robinet', 'Eaddy', '515-885-3682', '1979-03-10', 'y'),
('rrozeth0@ed.gov', 'nBRdLhF', 'Robinia', 'Rozet', '414-918-0964', '1970-10-06', 'y'),
('rdibleyji@slate.com', 'MSbxHy', 'Rockey', 'Dibley', '345-873-9752', '1976-02-29', 'y'),
('rvalentingi@census.gov', 'ym3h8r', 'Rockie', 'Valentin', '975-798-2522', '1955-10-24', 'y'),
('rloxdale2s@dot.gov', 'F5Gzth4', 'Rodger', 'Loxdale', '480-484-4492', '1972-02-15', 'y'),
('riddonspe@seattletimes.com', '2YcJcl', 'Rodi', 'Iddons', '886-787-4213', '1952-06-12', 'y'),
('rsieghartey@cyberchimps.com', 'HSY9j4Hy', 'Rodi', 'Sieghart', '677-494-5312', '1997-04-02', 'y'),
('rjindad5@indiatimes.com', 'J4UXJEulRN', 'Roi', 'Jinda', '858-879-0439', '1957-12-30', 'y'),
('rambrozkv@php.net', 'bag0Xt', 'Rois', 'Ambroz', '244-610-5559', '1951-07-02', 'y'),
('rswinl4@shop-pro.jp', 'M0LznsLGA', 'Rolfe', 'Swin', '620-459-8950', '1986-03-11', 'y'),
('rtattershaw30@cnbc.com', 'LaA25uaFg', 'Rolland', 'Tattershaw', '399-763-8597', '1963-03-04', 'y'),
('rjensenm6@odnoklassniki.ru', 'B9ZAdR9fWM', 'Ronda', 'Jensen', '816-558-2007', '1970-12-21', 'y'),
('rvernazzamt@java.com', 'PUCP3J', 'Ronni', 'Vernazza', '654-448-3563', '1967-03-16', 'y'),
('rlabror3@abc.net.au', 'avFNuEmSO', 'Ronny', 'Labro', '878-143-6776', '1954-10-20', 'y'),
('rcurroriv@upenn.edu', 'mJwT9dEvOsAc', 'Roosevelt', 'Curror', '242-244-4720', '1994-02-21', 'y'),
('rsmallpeacec5@yandex.ru', 'TLChsE1Ki0', 'Roosevelt', 'Smallpeace', '871-196-2104', '1983-05-15', 'y'),
('rgass2h@newyorker.com', 'jlsz1EM8', 'Rora', 'Gass', '201-289-4812', '1963-07-20', 'y'),
('rgebb6u@sourceforge.net', 'km487PyS', 'Rora', 'Gebb', '102-214-5664', '1998-07-01', 'y'),
('rpettersenkb@stumbleupon.com', 'iYVTzP', 'Rora', 'Pettersen', '415-963-4637', '1983-10-29', 'y'),
('rlansdownlb@tinyurl.com', 'fCz2Ch', 'Rosalyn', 'Lansdown', '591-441-2795', '1987-11-09', 'y'),
('rgoldster9o@statcounter.com', 'kEGzvY', 'Rosalynd', 'Goldster', '717-582-7455', '1987-04-28', 'y'),
('rpreator3c@symantec.com', 'H425olH', 'Rosamond', 'Preator', '865-290-7145', '1992-07-20', 'y'),
('rrichardetix@constantcontact.com', 'ngIbaw2', 'Roseanne', 'Richardet', '489-313-9395', '1967-02-23', 'y'),
('rvaseydy@facebook.com', 'jgrhmvjfqRz', 'Rosemary', 'Vasey', '191-403-8523', '1960-09-02', 'y'),
('rioselevichb7@elegantthemes.com', 'ZggjClq', 'Rosemonde', 'Ioselevich', '563-462-5547', '1984-09-30', 'y'),
('rkohring7n@joomla.org', 'MXWvXLvgId87', 'Rosemonde', 'Kohring', '323-825-5072', '1987-05-25', 'y'),
('rbroaderi9@bbb.org', '28ptHDB', 'Rosita', 'Broader', '988-359-4852', '1959-06-01', 'y'),
('rcoxgf@mozilla.com', 'THRxW2xpv', 'Rosmunda', 'Cox', '655-898-9080', '1975-02-05', 'y'),
('rjillissem@google.com.br', 'RXIzi4a2J70', 'Rossie', 'Jilliss', '219-856-2083', '1958-06-16', 'y'),
('rfrosch5v@opera.com', 'ls66mUHkv', 'Roth', 'Frosch', '670-163-1857', '1987-03-10', 'y'),
('rmilellag1@slashdot.org', 'wFtsnHxH', 'Roth', 'Milella', '401-106-2426', '1969-08-22', 'y'),
('rrenshellma@redcross.org', 'QvGB7l0', 'Roth', 'Renshell', '426-372-9025', '1966-04-07', 'y'),
('rmcilory75@nbcnews.com', 'YuYYDqbdh6X', 'Rouvin', 'McIlory', '601-281-8805', '1953-04-29', 'y'),
('rraglessjj@tmall.com', 'z6aNbIo0C', 'Rowan', 'Ragless', '574-650-0628', '2001-09-19', 'y'),
('rcurlis9y@blogs.com', '2glD8lpbt', 'Roxana', 'Curlis', '173-853-9968', '2000-08-03', 'y'),
('rkilleley3f@jimdo.com', 'mQUeuQ', 'Roxanna', 'Killeley', '121-706-3413', '1971-01-01', 'y'),
('rfinlaysonk4@cnet.com', 'C2mnIhDs9V', 'Roxi', 'Finlayson', '855-669-0640', '1989-12-10', 'y'),
('rmageeiq@harvard.edu', 'oKAnfbh2i', 'Roxi', 'Magee', '729-218-4787', '1987-09-01', 'y'),
('rharewoodca@de.vu', 'MMJUxDq', 'Roxine', 'Harewood', '240-863-0009', '1969-08-31', 'y'),
('rchallacec3@simplemachines.org', 'r5tEc2', 'Roxy', 'Challace', '202-640-7011', '1993-06-14', 'y'),
('rkillbeyra@wunderground.com', '6ob7MeAs53', 'Royal', 'Killbey', '789-972-3061', '1968-03-21', 'y'),
('rknocker4q@mediafire.com', 'B91eyd9pI', 'Royall', 'Knocker', '223-701-4965', '1981-05-19', 'y'),
('rscourfieldd6@cnbc.com', '7N554BMXv', 'Rozalie', 'Scourfield', '649-703-7562', '1994-04-18', 'y'),
('rjoicef8@topsy.com', 'Nl0hzwYFQUre', 'Rozina', 'Joice', '315-202-5079', '1997-04-17', 'y'),
('rkowal33@yahoo.co.jp', 'I79qb8popoEI', 'Ruddie', 'Kowal', '426-341-4024', '1969-03-18', 'y'),
('rtwopennymw@tuttocitta.it', 'ijR2Cl', 'Rudiger', 'Twopenny', '149-504-8555', '1979-10-19', 'y'),
('rwolfart10@nydailynews.com', 'pjtuZBuk2zi', 'Rudiger', 'Wolfart', '434-595-9262', '1955-10-02', 'y'),
('rloudiand2@ucoz.com', '0KzuaekOcjj', 'Ruggiero', 'Loudian', '194-819-5695', '1980-10-19', 'y'),
('rvazquezpo@delicious.com', 'IjwwkHX', 'Ruprecht', 'Vazquez', '104-394-6625', '1975-04-03', 'y'),
('rfosserd60@newyorker.com', '4GXPkvj', 'Rurik', 'Fosserd', '353-236-8859', '1998-10-07', 'y'),
('rmaloneybg@jugem.jp', 'mZFAG2UA', 'Rustie', 'Maloney', '754-220-9336', '1961-02-05', 'y'),
('rtolletoz@cornell.edu', 'G87tPb', 'Ruth', 'Tollet', '183-920-3386', '1995-06-08', 'y'),
('rwallbutton6o@hc360.com', 'n0U6rWF74v', 'Ruthe', 'Wallbutton', '478-176-2013', '1994-09-04', 'y'),
('rstokes3m@bbb.org', 'VRIWFPqp9bbR', 'Ruy', 'Stokes', '695-945-5894', '1969-05-15', 'y'),
('rvillaltad7@stanford.edu', '7HG3wX2zX9cd', 'Ryun', 'Villalta', '618-372-5289', '1988-07-14', 'y'),
('sberntssenbw@thetimes.co.uk', 'tGIDVm2lqnj', 'Sabina', 'Berntssen', '955-117-5679', '1987-10-05', 'y'),
('sdoddingcm@clickbank.net', 'xnxzzi7ag', 'Sabine', 'Dodding', '126-874-1420', '2000-08-21', 'y'),
('spapezqc@blogspot.com', 'iGDD3oKsBo', 'Sadie', 'Papez', '226-666-3243', '1958-07-30', 'y'),
('scatherine5j@redcross.org', 'Hkhfexd', 'Sal', 'Catherine', '702-701-1306', '1955-01-30', 'y'),
('smcelroy5h@rediff.com', 'Wdq5lfdS4Ci', 'Salmon', 'McElroy', '667-651-1356', '1979-04-17', 'y'),
('srylandci@timesonline.co.uk', 'E5hBZ5sPwE3', 'Salome', 'Ryland', '510-419-0124', '1990-10-06', 'y'),
('sjouanetonl2@loc.gov', '3bZDNr', 'Salomone', 'Jouaneton', '715-925-6228', '1991-02-25', 'y'),
('sbratcherhn@t-online.de', 'zglIZO', 'Salvador', 'Bratcher', '123-338-8576', '1978-04-13', 'y'),
('selmanh@sogou.com', 'Oy1CUiw', 'Samuel', 'Elman', '841-157-0872', '1991-04-25', 'y'),
('swalbrooklr@ihg.com', 'foOgbhS', 'Samuele', 'Walbrook', '656-905-4517', '1955-08-17', 'y'),
('scajkler4z@taobao.com', 'CcFrxXpW', 'Sanford', 'Cajkler', '354-897-7923', '1974-02-26', 'y'),
('sdoldonky@163.com', 'Z1hHfch9IX', 'Sanford', 'Doldon', '477-479-2335', '1985-06-22', 'y'),
('sdurbynn8@is.gd', 'F216r5f5', 'Sanson', 'Durbyn', '566-480-0562', '1955-04-21', 'y'),
('sbourdicede@purevolume.com', 'zMdB7un', 'Sansone', 'Bourdice', '465-846-0919', '1962-01-17', 'y'),
('swhitmorej4@yellowbook.com', 'UeQZwlNYF', 'Sansone', 'Whitmore', '903-239-0241', '1956-10-06', 'y'),
('sgannawayoa@tumblr.com', 'oHJRas9QQN', 'Sarette', 'Gannaway', '441-365-5461', '1955-08-22', 'y'),
('ssaltreseo5@wiley.com', 'aSQE9o', 'Sarine', 'Saltrese', '222-108-0867', '1951-01-14', 'y'),
('ssacher8q@google.nl', 'SNahYnieQg0i', 'Saul', 'Sacher', '710-344-9191', '1956-05-23', 'y'),
('sgasperoln@dailymotion.com', 'uYU79nx', 'Sauveur', 'Gaspero', '713-658-0550', '1976-11-01', 'y'),
('sbultergr@state.gov', 'YSR3OASn4', 'Sayer', 'Bulter', '549-866-2082', '1964-03-11', 'y'),
('sgricks5k@nydailynews.com', 'FI2ZpZanFm9', 'Schuyler', 'Gricks', '344-201-5707', '1959-04-20', 'y'),
('sdavisef@harvard.edu', '1tNin7SG', 'Scott', 'Davis', '662-246-7341', '1975-10-02', 'y'),
('sminshallay@tinyurl.com', 'fVWaKM', 'Scott', 'Minshall', '458-618-3114', '1966-09-15', 'y'),
('smaynell6i@google.co.uk', 'Hyacmp', 'Sebastiano', 'Maynell', '722-287-2872', '1960-04-12', 'y'),
('singledowcc@europa.eu', 'FCkfTokf', 'Selie', 'Ingledow', '657-524-6594', '1953-06-06', 'y'),
('scaheyqu@about.com', '3c1Mxlu', 'Serene', 'Cahey', '237-893-9085', '1952-07-13', 'y'),
('spenningsj5@wufoo.com', 'ZD79h1ATX1Lk', 'Sergeant', 'Pennings', '277-860-4876', '1962-12-04', 'y'),
('sweatherdon18@tripadvisor.com', '1mBX7b4N', 'Sergio', 'Weatherdon', '879-385-2160', '1975-04-24', 'y'),
('sduffynkc@marketwatch.com', 'qsJFgz', 'Seumas', 'Duffyn', '680-816-3309', '1973-04-13', 'y'),
('sgoldsbyh4@weather.com', 'GQhAGlx9vdHS', 'Seward', 'Goldsby', '585-454-3844', '1968-01-22', 'y'),
('sbenetg2@scientificamerican.com', 'ACoAaq0d', 'Shaine', 'Benet', '447-927-3263', '1983-02-26', 'y'),
('slosano8@wordpress.com', 'fNmgYQH', 'Shaine', 'Losano', '642-370-9765', '2001-09-16', 'y'),
('sbogieqd@businessweek.com', '8LlGX3n', 'Shalom', 'Bogie', '408-547-5033', '1975-07-18', 'y'),
('srispinel@bbc.co.uk', '3X7u0N', 'Shalom', 'Rispine', '263-101-1977', '1960-10-07', 'y'),
('strigwell38@google.com.hk', 'MtN9QA', 'Shandeigh', 'Trigwell', '107-763-4934', '1994-01-27', 'y'),
('sriding99@ehow.com', '4Oo2HH6KI', 'Shane', 'Riding', '105-480-6218', '1977-11-28', 'y'),
('sgrangier43@bizjournals.com', 'cSDe3vm0w6a', 'Shani', 'Grangier', '869-628-5846', '1957-09-10', 'y'),
('sseldnern4@google.cn', 'JgIRRG', 'Shanta', 'Seldner', '326-750-3028', '1997-08-31', 'y'),
('soldreynn@redcross.org', 'wcWeMM4n', 'Shantee', 'Oldrey', '337-231-6896', '1977-05-05', 'y'),
('sminnisp4@cafepress.com', 'KFnAesnjPSD', 'Sharity', 'Minnis', '949-103-0891', '1953-03-30', 'y'),
('smaple7w@blogtalkradio.com', 'LDhRmcU', 'Sharon', 'Maple', '454-265-1391', '1953-12-08', 'y'),
('scomrie4s@ow.ly', 'acizsrB', 'Shaughn', 'Comrie', '786-832-9081', '1971-09-10', 'y'),
('ssenechellim@icq.com', 'mKUUSlBqp', 'Shaughn', 'Senechell', '532-724-5401', '1968-04-16', 'y'),
('slaxtonmf@gnu.org', 'mIC4neqpS', 'Shaun', 'Laxton', '868-312-8445', '1959-07-10', 'y'),
('swankai@weebly.com', 'RUkb21S', 'Shea', 'Wank', '809-642-3364', '1997-08-02', 'y'),
('smincini19@discovery.com', '54PZaiZvGvq', 'Sheba', 'Mincini', '364-169-8701', '1953-05-18', 'y'),
('sjoninqj@apache.org', 'iaL4QbajAV', 'Sheela', 'Jonin', '596-759-0605', '1957-12-24', 'y'),
('sfludder37@about.me', 'kUdvFZQls6ly', 'Sheffy', 'Fludder', '709-528-4511', '1950-12-15', 'y'),
('swhilderit@qq.com', 'uQQdXMNCpniC', 'Shelby', 'Whilder', '320-741-6188', '1989-05-20', 'y'),
('skelshawdr@goo.ne.jp', 'uRiqvH3', 'Shellysheldon', 'Kelshaw', '486-412-6200', '1958-03-10', 'y'),
('silyinskike@mtv.com', '1o7XPQ', 'Sheridan', 'Ilyinski', '302-676-4197', '1992-11-16', 'y'),
('sgatland4e@alibaba.com', 'pZLiKY', 'Sherie', 'Gatland', '267-554-7955', '1957-07-05', 'y'),
('soxfordp3@imgur.com', '6dMrmigH1PZ', 'Sherie', 'Oxford', '244-387-7348', '1993-04-14', 'y'),
('scrapperns@spotify.com', '510oOHNdZ', 'Sherlocke', 'Crapper', '298-692-0920', '1975-07-22', 'y'),
('shazell@google.co.jp', 'YP1m1WCdLWM', 'Sherwood', 'Hazel', '428-958-0144', '1996-01-22', 'y'),
('smarchisogx@who.int', 'KRhXaOWQWc', 'Shir', 'Marchiso', '731-603-2404', '1953-02-01', 'y'),
('swinkleg3@tinyurl.com', 'WrrHyIisTA1', 'Shir', 'Winkle', '953-768-3439', '1981-08-02', 'y'),
('slambregtsjw@europa.eu', 'jLAXEyH2fUo', 'Shurlock', 'Lambregts', '259-616-9705', '1970-06-17', 'y'),
('sbirkheadm@sakura.ne.jp', 'jpKycExzEe', 'Shurlocke', 'Birkhead', '799-246-5697', '1954-06-28', 'y'),
('scharterd6@deliciousdays.com', 'pwBZ794', 'Shurwood', 'Charter', '994-762-9279', '1980-05-06', 'y'),
('shalsted2a@indiegogo.com', 'MFITRBgre', 'Sib', 'Halsted', '375-608-2563', '1960-06-06', 'y'),
('sbrashiernj@ftc.gov', 'Wx5cmO4zJ', 'Sidnee', 'Brashier', '290-950-8617', '1965-03-11', 'y'),
('sgrishkov6o@mtv.com', 'dr8cX9Y', 'Sidoney', 'Grishkov', '991-165-3605', '1979-04-09', 'y'),
('smithanel@constantcontact.com', 'DnvgZYkx', 'Siffre', 'Mithan', '919-401-2123', '1967-11-19', 'y'),
('snorthernao@loc.gov', 'aXtWewH2', 'Sig', 'Northern', '431-103-5238', '1953-11-06', 'y'),
('seisoldk2@dagondesign.com', 'N68aPsDUtS', 'Sigfried', 'Eisold', '865-775-4518', '1982-01-22', 'y'),
('sspinola5y@youtu.be', 's5Bi8UIn', 'Sigvard', 'Spinola', '353-166-8680', '1996-06-07', 'y'),
('spirdue4k@virginia.edu', 'ZtFPzLNxdhWp', 'Sileas', 'Pirdue', '886-371-9440', '1983-03-08', 'y'),
('slovedayl6@google.it', 'SGA6rlaGds', 'Silvana', 'Loveday', '243-115-5506', '1976-02-11', 'y'),
('sewartkr@bloomberg.com', 'A1fHlibnmSzo', 'Silvester', 'Ewart', '326-357-7325', '1993-10-09', 'y'),
('sodonohuedn@mozilla.com', 'TBxJzQgCZYo6', 'Simeon', 'O\'Donohue', '955-373-3649', '1967-03-23', 'y'),
('smcarda3@instagram.com', '2jf45vWbdl', 'Simone', 'McArd', '594-516-3740', '1972-01-04', 'y'),
('swoodwindcn@yale.edu', 'RKzOF7V', 'Sindee', 'Woodwind', '557-639-6203', '1975-01-24', 'y'),
('svandenbroekq8@princeton.edu', '1NbLA5WnZke', 'Sissie', 'Van den Broek', '185-406-1622', '1978-02-28', 'y'),
('slowings2e@creativecommons.org', 'UyeHr17W', 'Sissy', 'Lowings', '911-479-4115', '1996-08-02', 'y'),
('sroland9n@acquirethisname.com', '9YLMD5', 'Skip', 'Roland', '707-816-0629', '1950-09-18', 'y'),
('sgothardl1@163.com', 'lMeLiay2Bqb3', 'Skipper', 'Gothard', '421-113-4417', '1953-03-13', 'y'),
('sbridgewoodd2@purevolume.com', 'jTOXtMMRE', 'Skippie', 'Bridgewood', '518-662-4636', '1954-09-12', 'y'),
('swillmore7g@hud.gov', '5aAWuqnna7', 'Sloan', 'Willmore', '113-380-2174', '1981-12-28', 'y'),
('sedelheid9p@google.nl', 'MXVHI08quw', 'Sofie', 'Edelheid', '713-192-9315', '1964-06-22', 'y'),
('screhank1@github.io', '6quWdqxv', 'Solly', 'Crehan', '456-231-4784', '1958-10-06', 'y'),
('ssawday86@woothemes.com', '6QMV0G05tP', 'Solly', 'Sawday', '576-449-8946', '1999-05-31', 'y'),
('ssanthousegb@joomla.org', 'AWBJvYeR', 'Son', 'Santhouse', '607-906-0759', '1996-04-17', 'y'),
('syakolev72@bizjournals.com', 'dSmiWcn073r', 'Sonni', 'Yakolev', '371-222-0615', '1979-03-03', 'y'),
('sgossartpq@gov.uk', 'eaaHXzYNg', 'Sophi', 'Gossart', '951-229-3927', '1976-02-14', 'y'),
('scordeauby@t.co', 'z5HTzwchW', 'Spenser', 'Cordeau]', '134-972-9092', '1978-12-06', 'y'),
('smalkini3@yellowbook.com', 'YHDEbfSol2Cq', 'Stafani', 'Malkin', '561-860-8470', '1953-12-20', 'y'),
('stodorpy@dell.com', 'HU70rh5W', 'Stafford', 'todor', '128-257-8028', '1993-04-24', 'y'),
('shazlewooddu@newsvine.com', '7NK2TzLF', 'Stanfield', 'Hazlewood', '604-384-2238', '1974-03-25', 'y'),
('sgellingff@instagram.com', 'nqcWlRH1m0o', 'Stanford', 'Gelling', '354-394-2451', '1974-08-24', 'y'),
('sdowsey40@sfgate.com', 'WIhqSMd9u3Ho', 'Stanly', 'Dowsey', '661-340-7843', '1977-05-05', 'y'),
('sgiffautbb@csmonitor.com', 'BF9T04T', 'Starla', 'Giffaut', '688-253-1034', '1951-02-11', 'y'),
('sschruyerspx@tmall.com', 'YMvHYF7CoqO', 'Starlene', 'Schruyers', '777-537-5301', '1968-05-20', 'y'),
('ssowtefo@wufoo.com', 'goSf3J', 'Starr', 'Sowte', '633-476-4351', '1981-07-01', 'y'),
('ssambellnd@google.ru', 'RE1oghVYJc', 'Stefan', 'Sambell', '775-563-0515', '1990-10-13', 'y'),
('swhotton8o@rediff.com', 'CZyRPFx1St', 'Stefan', 'Whotton', '850-713-0997', '1979-10-29', 'y'),
('sansilld1@mapy.cz', 'XV2A1E6R7x', 'Stefania', 'Ansill', '118-255-2543', '1962-05-23', 'y'),
('spraterhb@ehow.com', 'BHg0Oy3VV', 'Steffie', 'Prater', '512-510-1529', '1991-04-27', 'y'),
('slamey3o@columbia.edu', 'CcbcSHBG3eaQ', 'Stephana', 'Lamey', '578-334-4837', '1987-05-23', 'y'),
('spifford6a@prweb.com', 'RqPecW3AXzor', 'Stephannie', 'Pifford', '163-768-5987', '1993-11-12', 'y'),
('sdoore6l@cnn.com', '79kXP8hqPQJ2', 'Sterne', 'Doore', '899-605-6437', '1953-06-09', 'y'),
('siianon25@hugedomains.com', 'Egoa1N1qxD3', 'Steve', 'Iianon', '295-377-3119', '1990-11-04', 'y'),
('ssell5o@smugmug.com', 'DiNrG4REnih', 'Steve', 'Sell', '491-746-7482', '1969-02-27', 'y'),
('sdogg7h@tuttocitta.it', '16D0O0', 'Stewart', 'Dogg', '521-209-5122', '1961-07-26', 'y'),
('sendekp@ehow.com', 'VcljG1bf0', 'Stewart', 'Ende', '478-118-0603', '1953-11-06', 'y'),
('skiddello9@paypal.com', 'hjLVF0aQ', 'Stewart', 'Kiddell', '819-934-6245', '1983-10-26', 'y'),
('sprinnettl7@addthis.com', 'KkevFD', 'Storm', 'Prinnett', '444-984-0083', '2001-04-28', 'y'),
('sscopesa6@google.de', 'YrcCqOhk', 'Stormie', 'Scopes', '642-729-8481', '1950-10-11', 'y'),
('swoolatt29@dailymail.co.uk', 'pH2uDRgWE', 'Sue', 'Woolatt', '220-203-7745', '1968-05-06', 'y'),
('scearleyax@artisteer.com', '5g91rz7g95Q', 'Sunny', 'Cearley', '994-507-7139', '1987-10-18', 'y'),
('sgilletg9@wikipedia.org', 'X9cmCzJ', 'Sunny', 'Gillet', '198-171-4661', '1956-08-26', 'y'),
('smoldenrr@pbs.org', 'mOFgwyk1yDp', 'Sunny', 'Molden', '359-128-2860', '1984-07-26', 'y'),
('ssnalhamdj@i2i.jp', 'tvTcODTYE3ZG', 'Sunshine', 'Snalham', '986-538-0194', '1994-10-15', 'y'),
('sebbettk3@nytimes.com', 'j4vngL', 'Susana', 'Ebbett', '728-834-8554', '1959-12-27', 'y'),
('swillesonco@lulu.com', '8xoO3w4Pm18a', 'Susanetta', 'Willeson', '236-931-4333', '1992-01-09', 'y'),
('sdesbrowgv@google.co.jp', 'WKcBgFz', 'Susanna', 'Desbrow', '535-223-8475', '1998-09-03', 'y'),
('sglowachjm@diigo.com', 'XpUjLhvmP', 'Susanna', 'Glowach', '848-342-6265', '1963-06-28', 'y'),
('savrahamian24@google.ca', 'wWFM67U3Uktm', 'Susie', 'Avrahamian', '516-784-1199', '1957-11-11', 'y'),
('swindress5z@answers.com', 'LtNcySK', 'Sutherlan', 'Windress', '241-781-1903', '1955-02-03', 'y'),
('ssouthwood71@weebly.com', 'BW3S7gJS7f', 'Suzanna', 'Southwood', '653-857-9195', '1966-09-07', 'y'),
('sgarment2j@tripod.com', 'p7IXkCMx', 'Svend', 'Garment', '944-883-0251', '1984-11-05', 'y'),
('skleinhandler3n@jalbum.net', 'W8p9B7isiS', 'Sydel', 'Kleinhandler', '908-295-0452', '1995-07-05', 'y'),
('soxerj8@ucsd.edu', 'IC1Extne2Tu', 'Sylvan', 'Oxer', '853-259-9967', '1998-08-24', 'y'),
('scottier8x@google.es', 'JQzSA598u8', 'Syman', 'Cottier', '783-200-2978', '1994-01-10', 'y'),
('tclaringboldkd@opensource.org', 'zyR5PpCnGa', 'Tabina', 'Claringbold', '303-406-5245', '1966-03-31', 'y'),
('tdonaho2t@amazon.co.uk', 'Gasuhve', 'Tailor', 'Donaho', '824-239-2255', '1988-10-14', 'y'),
('tcopcoterb@trellian.com', 'sardvol3', 'Tallia', 'Copcote', '434-945-6290', '2001-12-18', 'y'),
('telsworth0@va.gov', 'AfXdAmVD0', 'Tamar', 'Elsworth', '479-560-2283', '1973-05-15', 'y'),
('tbilovusg7@cbc.ca', 'GlCsqpU', 'Tammie', 'Bilovus', '709-555-6133', '1979-10-16', 'y'),
('tmudd9t@ibm.com', '684s2AI', 'Tammy', 'Mudd', '528-388-5248', '1956-11-29', 'y'),
('tloneyqb@ucla.edu', '0vgxxQRV5k', 'Tamqrah', 'Loney', '467-900-8585', '1972-10-02', 'y'),
('ttrevaskis25@smh.com.au', 'm8Wef7G', 'Tamqrah', 'Trevaskis', '355-962-6587', '1953-04-10', 'y'),
('tsextyef@flavors.me', 'zwOVCM', 'Tanney', 'Sexty', '721-700-2677', '1977-04-11', 'y'),
('tswinburneay@trellian.com', 'fQs3mU', 'Tanney', 'Swinburne', '454-888-4210', '1972-05-12', 'y'),
('tlevisonkf@geocities.jp', 'yKvo8TNWn', 'Tara', 'Levison', '189-267-4257', '1960-03-15', 'y'),
('tabramovicz8w@squarespace.com', 'sBkg8hiTle', 'Tarra', 'Abramovicz', '455-447-9599', '1951-06-11', 'y'),
('tguiuov@exblog.jp', '8bup2OFYe6B', 'Tatum', 'Guiu', '467-979-7958', '1970-09-18', 'y'),
('twakerhl@vk.com', 'nIkQd9PNd9KT', 'Tawsha', 'Waker', '336-571-0658', '1953-07-26', 'y'),
('tfrostickbm@merriam-webster.com', 'pAc29QwyEZOx', 'Tedda', 'Frostick', '677-441-2418', '1953-07-26', 'y'),
('tskillaa@auda.org.au', 'LYe32EYE1', 'Teddi', 'Skill', '986-450-2586', '1966-11-28', 'y'),
('tmillinsgw@patch.com', '9QeI9i9iU', 'Temple', 'Millins', '635-670-0978', '1962-04-22', 'y'),
('tmoverley2c@geocities.com', 'gBr3FIUGxgMP', 'Temple', 'Moverley', '449-198-4124', '1953-05-31', 'y'),
('tlockheadqn@earthlink.net', 't9TRPJWeVHI', 'Teodor', 'Lockhead', '447-122-0716', '1992-08-06', 'y'),
('tharrellfw@naver.com', 'xUeuMyuMei', 'Terra', 'Harrell', '900-230-4686', '1988-03-16', 'y'),
('tkeffordpc@eventbrite.com', 'UzCDXN', 'Terra', 'Kefford', '897-393-3612', '1989-09-26', 'y'),
('talgerhu@parallels.com', 'w6kDNNmB0b', 'Terrill', 'Alger', '609-968-5471', '1974-06-14', 'y'),
('tlanhamc9@flickr.com', 'ap8QGIY', 'Tess', 'Lanham', '540-294-3742', '1970-01-09', 'y'),
('tmammattn5@redcross.org', 'jozyX37I', 'Thayne', 'Mammatt', '936-480-3496', '1995-01-13', 'y'),
('tcamacho2f@reference.com', 'bD9R4Jx7sgd', 'Theadora', 'Camacho', '480-151-1556', '1961-09-12', 'y'),
('tdeekesab@surveymonkey.com', 'hfm3qlY', 'Theda', 'Deekes', '479-781-2273', '1976-04-12', 'y'),
('tbaresslq@wunderground.com', 'T36HCr0u1jxu', 'Theobald', 'Baress', '730-979-6037', '1998-10-08', 'y'),
('tbroadwelle9@xinhuanet.com', 'FR3KDqL6', 'Theresina', 'Broadwell', '728-734-8759', '1974-01-21', 'y'),
('trudolph9l@guardian.co.uk', 'hfIoCfzZfztk', 'Theresina', 'Rudolph', '565-906-7648', '1997-10-28', 'y'),
('tkobus4j@eventbrite.com', 'phLF8289af', 'Thibaud', 'Kobus', '573-852-9041', '1970-04-30', 'y'),
('tpietersmaec@amazon.de', 'Gq8tAoGDJRtZ', 'Thorn', 'Pietersma', '995-957-7050', '1969-05-23', 'y'),
('tsimecekls@slideshare.net', 'JPqMoogEZIYs', 'Thornton', 'Simecek', '509-551-0077', '1956-11-08', 'y'),
('tcopemanmq@nyu.edu', 'RShjSL', 'Thorny', 'Copeman', '433-998-6343', '1982-08-18', 'y'),
('tbourdisaz@mediafire.com', 'GG89FP', 'Tibold', 'Bourdis', '783-176-1182', '1972-03-27', 'y'),
('tmonnoyerdg@furl.net', '47esWJmya', 'Tierney', 'Monnoyer', '993-125-6139', '1980-02-19', 'y'),
('tdavidsenbt@behance.net', 'XfrbfR', 'Tiffani', 'Davidsen', '265-136-7806', '1953-03-19', 'y'),
('tbrokenshawba@meetup.com', 'fNgUL0Kx5', 'Tiler', 'Brokenshaw', '857-622-6475', '1953-03-28', 'y'),
('tpollicote41@bizjournals.com', 'y1S0emNW1XE', 'Tiler', 'Pollicote', '315-264-1126', '1989-06-22', 'y'),
('tsimmonite1g@so-net.ne.jp', 'saCuzmcs4r', 'Tiler', 'Simmonite', '930-112-9781', '1971-11-14', 'y'),
('tdedhamf6@altervista.org', 'IhG51lrpxL', 'Tilly', 'Dedham', '411-190-0758', '1995-09-16', 'y'),
('tsemoninid@google.de', '4v30Sp8', 'Timoteo', 'Semonin', '224-328-9833', '1987-09-07', 'y'),
('trosenfelderlu@drupal.org', 'pSuTlphopS', 'Tiphani', 'Rosenfelder', '358-550-1257', '1985-03-04', 'y'),
('tshine6b@topsy.com', 'wCp3rv', 'Tiphanie', 'Shine', '461-916-6736', '1976-09-07', 'y'),
('tsaffon6y@t-online.de', 'u7B0n9t', 'Tomasine', 'Saffon', '530-889-8981', '1987-01-21', 'y'),
('tkimblyad@economist.com', 'yquQNMqb', 'Tonnie', 'Kimbly', '812-500-1473', '1967-08-12', 'y'),
('tmullearybn@blogs.com', 'gWQvVR5Tkto', 'Tonya', 'Mulleary', '261-550-7620', '1975-01-02', 'y'),
('tcowtharddb@howstuffworks.com', 'WK7lkpS', 'Tore', 'Cowthard', '846-420-5941', '1990-07-16', 'y'),
('tilyushkinaj@netlog.com', 'ethExBzY', 'Torey', 'Ilyushkin', '995-273-3598', '1972-01-27', 'y'),
('tavrahamof3l@ning.com', 'Z58fiw', 'Torrance', 'Avrahamof', '333-209-0410', '1981-08-02', 'y'),
('tdicarlir0@artisteer.com', 'ClHArnlz', 'Torrence', 'Di Carli', '332-652-2847', '1997-05-25', 'y'),
('tholbie9m@1688.com', 'HmkKcYRQ', 'Torrence', 'Holbie', '387-766-0419', '1950-05-05', 'y'),
('thambricgi@theatlantic.com', 'SVPg8nnVwT', 'Torrey', 'Hambric', '441-966-5374', '1979-12-17', 'y'),
('tmacaleesmg@free.fr', '3URNBNLBi', 'Torry', 'MacAlees', '291-736-1556', '1974-12-12', 'y'),
('tyansonse2@google.es', 'g0GuELP', 'Torry', 'Yansons', '702-564-9168', '1974-01-19', 'y'),
('tnewlandsk8@jalbum.net', 'tckk16qU', 'Tory', 'Newlands', '107-771-9536', '1951-06-01', 'y'),
('tmcgrayle8a@hhs.gov', 'Z3eFKO51Wkw', 'Tove', 'McGrayle', '863-540-3027', '1979-06-28', 'y'),
('taichesonhi@springer.com', 'S49Gkvse0ka', 'Towny', 'Aicheson', '735-688-8260', '1956-04-01', 'y'),
('tworgen8j@ameblo.jp', 'VeS3YkqLbW5', 'Towny', 'Worgen', '434-387-0680', '1968-06-14', 'y'),
('tcody3q@ebay.co.uk', 'tZGWM9z3cGF', 'Traver', 'Cody', '266-570-3011', '1986-04-09', 'y'),
('ttuma69@addtoany.com', 'kLuhhk5EOmB6', 'Trefor', 'Tuma', '756-728-3981', '1970-05-19', 'y'),
('tsteanson3t@apple.com', 'Ng9JFhgqL', 'Tresa', 'Steanson', '148-287-0549', '1975-12-11', 'y'),
('tocassidy51@lulu.com', '03pkElhS', 'Trescha', 'O\'Cassidy', '905-114-2253', '1975-03-15', 'y'),
('tdurn73@cargocollective.com', 'un1JCk', 'Tressa', 'Durn', '438-227-9542', '1976-04-08', 'y'),
('tjanca1f@bravesites.com', 'm3lxI8ZwVc6', 'Trix', 'Janca', '215-501-4311', '1961-06-27', 'y'),
('theakerq0@sphinn.com', 'fwo8b9SOGZ', 'Trixie', 'Heaker', '933-418-9309', '1998-07-02', 'y'),
('tclapstonr@google.com', '8ThFICCIM0t', 'Trixy', 'Clapston', '296-435-1319', '1975-03-17', 'y'),
('tcliffordm5@phoca.cz', '7XAzsX2hZrv', 'Trixy', 'Clifford', '151-245-2323', '1997-07-14', 'y'),
('tphiferne@hhs.gov', 'X5PCB4pHxT', 'Troy', 'Phifer', '643-938-3834', '1980-09-09', 'y'),
('tjordenih@surveymonkey.com', 'vYu7QuFlDPCs', 'Trumann', 'Jorden', '901-236-5633', '1961-11-14', 'y'),
('tpullinqk@newyorker.com', 'mMtaTYgX', 'Tucker', 'Pullin', '369-315-7676', '1983-06-13', 'y'),
('tjudkins9c@fastcompany.com', '6pEdTw7BDDvj', 'Tudor', 'Judkins', '819-717-2330', '1972-07-08', 'y'),
('tmactrustriecw@ox.ac.uk', 'nZsAzcYyFL', 'Turner', 'MacTrustrie', '651-326-3875', '1994-10-30', 'y'),
('tlaverenzdj@amazon.co.jp', '9BDJcprinH5X', 'Tynan', 'Laverenz', '137-592-2685', '1997-10-20', 'y'),
('uhazeldenerj@tinyurl.com', 'RRrUKpEDEz7u', 'Ulick', 'Hazeldene', '742-995-0019', '2000-05-30', 'y'),
('ubooirk@twitter.com', 'J8qyXHKN4', 'Ulric', 'Booi', '820-605-4498', '1974-05-16', 'y'),
('uarrighinia1@typepad.com', 'nbrvx4H8', 'Ulrica', 'Arrighini', '953-346-1585', '1969-10-05', 'y'),
('ugoutcherg5@hhs.gov', '3DoAGmHkpZK2', 'Ulrich', 'Goutcher', '302-543-2866', '1969-03-18', 'y'),
('uregi9f@ted.com', 'yjOtB4SA5', 'Urbain', 'Regi', '345-705-8450', '1997-08-30', 'y'),
('upeele2@microsoft.com', 'pdTzeF', 'Urbano', 'Peel', '583-596-7378', '1992-07-10', 'y'),
('umatkovicmw@i2i.jp', 'j0SOx9698d', 'Uriah', 'Matkovic', '101-339-1927', '1968-05-12', 'y'),
('vmabbott5c@i2i.jp', 'P3YLK4v', 'Val', 'Mabbott', '168-296-8715', '1966-03-30', 'y'),
('vcozensr6@goodreads.com', '8HgmxEyCB2', 'Valaree', 'Cozens', '896-140-6498', '1996-01-23', 'y'),
('vkitchingmaneo@cdc.gov', 'qsZwrM', 'Valaree', 'Kitchingman', '231-600-3456', '1978-02-12', 'y'),
('vriordanke@aol.com', 'KsRmRv', 'Valdemar', 'Riordan', '195-885-9572', '1997-02-27', 'y'),
('vblazejewski2l@odnoklassniki.ru', 'CcavsTOIf', 'Valeda', 'Blazejewski', '170-709-3349', '1983-02-17', 'y'),
('vjohansenfn@timesonline.co.uk', 'lUsW6Qh3B', 'Valenka', 'Johansen', '673-251-0359', '1971-09-30', 'y'),
('vrhoddie5y@spiegel.de', 'nIgYYc9qQgbQ', 'Valenka', 'Rhoddie', '127-189-3428', '1956-12-25', 'y'),
('vjessop30@blog.com', 'CafBnYJwjW', 'Valina', 'Jessop', '223-863-2273', '1952-05-20', 'y'),
('vremirezk5@amazon.de', 'rdeDYP', 'Valina', 'Remirez', '347-536-8304', '1985-10-14', 'y'),
('vkilduff41@jiathis.com', 'B6VTV6', 'Van', 'Kilduff', '200-158-3171', '1983-07-12', 'y'),
('vvallantine0@java.com', 'eIy297o4', 'Vanni', 'Vallantine', '697-640-9635', '1973-06-09', 'y'),
('vredwin4h@sciencedirect.com', 'K4XTSqn6QMl', 'Vanya', 'Redwin', '299-971-4987', '1999-10-11', 'y'),
('vpatrone8s@youku.com', 'vWKG2n0', 'Veda', 'Patrone', '728-900-1966', '1985-09-08', 'y'),
('vmattis6k@craigslist.org', 'SMowye', 'Velvet', 'Mattis', '505-405-3283', '1983-04-29', 'y'),
('vchapple2l@gizmodo.com', 'lQnhtU8R93', 'Verene', 'Chapple', '700-770-0196', '1981-08-27', 'y'),
('vcowpe99@soundcloud.com', 'rbBcN4NE', 'Verge', 'Cowpe', '135-650-4826', '1998-01-28', 'y'),
('vvanyashinbt@stanford.edu', 'rK8LplLPG7O', 'Veriee', 'Vanyashin', '836-720-4796', '1993-03-08', 'y'),
('vmchardykf@topsy.com', 'BfHtwbv', 'Verne', 'McHardy', '664-435-5018', '1991-11-22', 'y'),
('vmitchelrl@storify.com', 'ekLNMhcraQ', 'Veronica', 'Mitchel', '995-365-9967', '1995-01-30', 'y'),
('vpetrovicbo@t.co', 'A5L3uK9j', 'Veronike', 'Petrovic', '150-195-9816', '1956-10-10', 'y'),
('vbartolomeazzig6@webnode.com', 'nbdVoJEA', 'Vic', 'Bartolomeazzi', '761-468-0886', '1981-09-20', 'y'),
('vfawdriel5@yelp.com', '3j6zvl', 'Victoria', 'Fawdrie', '241-807-6322', '1952-12-07', 'y'),
('vfontefc@rediff.com', '3jUSQkk', 'Viki', 'Fonte', '678-152-3059', '1990-08-03', 'y'),
('vogarags@globo.com', 'nuXUg5RnX', 'Vilhelmina', 'O\' Gara', '365-390-5447', '1985-01-08', 'y'),
('vparmerdu@nature.com', '7GQ7QSt', 'Vilma', 'Parmer', '725-269-1194', '1991-10-14', 'y'),
('vtrowlerey@usatoday.com', 'NpNsBhgY', 'Vincents', 'Trowler', '889-706-0381', '1992-12-27', 'y'),
('vstodit8t@nih.gov', 'x1f4BV9eVCMb', 'Vincenz', 'Stodit', '165-889-9074', '1961-12-21', 'y'),
('vluton1z@dion.ne.jp', 'Lk0a6HTMNRf', 'Vinnie', 'Luton', '777-253-5391', '1993-12-23', 'y'),
('vsimoncinia3@merriam-webster.com', 'hlMIPNl', 'Vinny', 'Simoncini', '782-700-0860', '1964-08-07', 'y'),
('vmcroriejn@istockphoto.com', 'DQl7Em2jiGF', 'Vinson', 'McRorie', '345-801-5713', '1999-11-20', 'y'),
('vschwandermannfe@rambler.ru', 'OPrnG985m', 'Virgil', 'Schwandermann', '878-258-7989', '1993-09-09', 'y'),
('vhatliff3a@weebly.com', 'GQ89yP4DmK', 'Vito', 'Hatliff', '695-647-6349', '1995-08-06', 'y'),
('vwestmerland35@umn.edu', 'XXW2hhT', 'Vittorio', 'Westmerland', '554-419-7675', '1950-05-08', 'y'),
('voxxfj@1und1.de', 'ynbODfmY', 'Viv', 'Oxx', '145-206-9490', '1971-12-12', 'y'),
('vdumbltonnc@nymag.com', 'FQkX0IjLLASt', 'Viva', 'Dumblton', '609-887-4850', '1959-01-06', 'y'),
('vramsdelln1@google.cn', 'mRbNbeE3ccn', 'Vivianna', 'Ramsdell', '381-198-8104', '1989-06-21', 'y'),
('vjurgenc@sourceforge.net', 'X1x4WoFk', 'Viviyan', 'Jurgen', '207-123-0364', '1964-07-24', 'y'),
('vdurrantj1@kickstarter.com', 'FlAd0F7X', 'Vivyan', 'Durrant', '624-164-6532', '1957-11-11', 'y'),
('vroystonc@topsy.com', '7dxRsRFzDGdJ', 'Vlad', 'Royston', '781-296-6683', '1989-05-06', 'y'),
('wtomaellokv@hatena.ne.jp', 'CBRMD6d', 'Waiter', 'Tomaello', '647-734-7462', '1961-05-23', 'y'),
('whaythornemv@issuu.com', 'vGBaQI', 'Waldemar', 'Haythorne', '914-949-9008', '1960-12-31', 'y'),
('wstratton20@chronoengine.com', 'utFG0B0iYTl', 'Waneta', 'Stratton', '498-858-2718', '1960-01-18', 'y'),
('wmaffeyif@behance.net', 'FcNBfi62oG', 'Wang', 'Maffey', '344-813-7890', '1983-07-31', 'y'),
('wjakesmh@squarespace.com', 'dyd5ixOQMZ', 'Warde', 'Jakes', '930-684-1728', '1994-03-15', 'y'),
('wsander2g@auda.org.au', 'IsWFvo', 'Ware', 'Sander', '576-392-1592', '1961-05-26', 'y'),
('wtaylour3p@yellowpages.com', 'xR2NRot', 'Warner', 'Taylour', '434-406-3378', '1983-06-02', 'y'),
('wcastellet7v@multiply.com', '1KtcyMFWoPl2', 'Wayne', 'Castellet', '682-447-7266', '1991-02-14', 'y'),
('winkeri8@bandcamp.com', '5kJHqNc', 'Wendel', 'Inker', '195-570-4196', '1986-12-19', 'y'),
('wcaneypz@sina.com.cn', '95tPmE892', 'Wendi', 'Caney', '641-145-3986', '2000-06-18', 'y'),
('wgodbold23@comsenz.com', 'zu6OYXmtvjD2', 'Wendi', 'Godbold', '238-998-8001', '1971-12-09', 'y'),
('wmacilwrick90@smugmug.com', 'x9WlUm', 'Wendy', 'MacIlwrick', '884-492-6929', '1965-03-15', 'y'),
('wmccarron1a@blogs.com', 'VII7PAk', 'Werner', 'McCarron', '486-682-7046', '2000-12-13', 'y'),
('wbracegirdle1l@comsenz.com', 'otVXHPxO', 'Westley', 'Bracegirdle', '388-640-4951', '1952-11-05', 'y'),
('wwasbey3v@eepurl.com', '5FH4oEbMVwB', 'Weston', 'Wasbey', '129-824-1521', '1960-02-26', 'y'),
('whaggard6z@rakuten.co.jp', 'gvaZu4vnvM', 'Whit', 'Haggard', '474-217-5769', '1968-02-20', 'y'),
('wchaplyn8v@webmd.com', 'eEMdVE', 'Wilbert', 'Chaplyn', '736-929-0917', '1990-05-07', 'y'),
('weltonob@dyndns.org', 'N4AiU3X2lmPv', 'Wildon', 'Elton', '232-557-9930', '1978-04-13', 'y'),
('wkasparskij2@mail.ru', '6jbgs7J5CL', 'Will', 'Kasparski', '106-938-3549', '1957-10-25', 'y'),
('wsignoreip@zdnet.com', '4PpYXzp', 'Willard', 'Signore', '279-283-4257', '1959-02-08', 'y'),
('wquilliam5@jiathis.com', 'FE65Nd9QLb', 'Willey', 'Quilliam', '809-138-8217', '1987-01-07', 'y'),
('wcastagnier92@upenn.edu', 'ebnYueNhGpZ', 'Willi', 'Castagnier', '816-585-6960', '1975-05-04', 'y'),
('wmixon81@bloglovin.com', 'jnHcvo', 'Willi', 'Mixon', '716-489-7359', '1999-07-26', 'y'),
('wabelshs@cafepress.com', 'ScIkKa6MjM', 'Willie', 'Abels', '943-371-6530', '1957-11-11', 'y'),
('westcourte1@parallels.com', '4WcAWEr2yde', 'Wilma', 'Estcourt', '941-124-8044', '1981-03-31', 'y'),
('wotyq3@vk.com', '7oMmY0jG', 'Winny', 'Oty', '977-468-9716', '2001-03-14', 'y'),
('wmatfieldfu@shop-pro.jp', '528uHbM0', 'Wit', 'Matfield', '956-433-4659', '1989-03-13', 'y'),
('wsirkett38@drupal.org', 'ZU5vJSzbV', 'Wit', 'Sirkett', '477-880-0344', '1952-06-13', 'y'),
('wlindenbluthdh@independent.co.uk', 'IzvEQKCxJtT', 'Worthington', 'Lindenbluth', '745-159-5186', '1982-04-06', 'y'),
('wrickesies4x@yandex.ru', 'sOUSDProcF9', 'Wren', 'Rickesies', '722-853-9405', '1991-07-21', 'y'),
('wcorstonkl@yelp.com', 'Q1ADv6h48OGU', 'Wyatt', 'Corston', '106-122-5366', '1957-08-27', 'y'),
('wbritto2r@zimbio.com', 'jHwcmyvNFB', 'Wylie', 'Britto', '599-108-8809', '1960-06-19', 'y'),
('wfidgeon8@amazon.co.uk', 'XFwGFuTPFFz', 'Wynn', 'Fidgeon', '954-140-5662', '1981-08-04', 'y'),
('wbaszniakll@amazon.co.uk', 'bKKUkI', 'Wynny', 'Baszniak', '954-860-2575', '1983-05-23', 'y'),
('xearwaker4r@businessweek.com', 'wiZj7bexMFlo', 'Ximenez', 'Earwaker', '772-821-0947', '1992-07-04', 'y'),
('xgilliard1h@dailymotion.com', 'wYHFmPR', 'Xylia', 'Gilliard', '793-737-7971', '1993-12-10', 'y'),
('ylancasterqz@yale.edu', 'IV0rSoaY', 'Yanaton', 'Lancaster', '898-866-5837', '1966-10-06', 'y'),
('yscotchmorek1@xing.com', 'TM1SmR3D7vf', 'Yetta', 'Scotchmore', '800-187-1632', '1996-01-22', 'y'),
('yknightsbridge19@yandex.ru', 'KZbgqyGhd56', 'Yettie', 'Knightsbridge', '724-421-8477', '1952-02-01', 'y'),
('yalvarho@pcworld.com', '9kywjuBeD6j', 'Yolane', 'Alvar', '448-299-5594', '1975-06-07', 'y'),
('yhassinbi@cpanel.net', 'y9hcGAksLEC', 'Yolane', 'Hassin', '443-225-6289', '1987-08-15', 'y'),
('ybramhilli0@google.com.br', 'Hb07P0', 'Yolanthe', 'Bramhill', '269-347-5083', '1994-01-20', 'y'),
('yphaup7k@godaddy.com', 'LwrOMSS4z8', 'York', 'Phaup', '239-268-4524', '1961-09-12', 'y'),
('ytibblt@cnbc.com', 'bMRedaq', 'Yoshi', 'Tibb', '584-273-4787', '1976-09-07', 'y'),
('yriteleyo5@usa.gov', 'k5gVPw', 'Ysabel', 'Riteley', '105-216-2716', '1957-02-01', 'y'),
('ybanken8@hhs.gov', 'uQjIDB6VNSgh', 'Yuma', 'Banke', '901-441-8648', '1967-02-26', 'y'),
('ztunnacliffec1@intel.com', 'nzfHkzVj6q6m', 'Zack', 'Tunnacliffe', '650-717-4560', '1955-06-23', 'y'),
('zfolkerd5g@nydailynews.com', 'GzZ2cXM5S', 'Zahara', 'Folkerd', '435-378-6340', '1991-01-22', 'y'),
('zpetrosiannn@oaic.gov.au', '2vxYacgEOS', 'Zaneta', 'Petrosian', '909-686-4384', '2000-06-16', 'y'),
('zmacieiczykj6@google.co.jp', '2FBjUEgugB', 'Zarah', 'Macieiczyk', '399-716-6425', '1985-12-31', 'y'),
('zkempson9c@amazon.com', '3SSyXSRmBU', 'Zared', 'Kempson', '520-694-8845', '1958-07-16', 'y'),
('zjinkinou@sogou.com', 'NkYw6CiGy', 'Zebedee', 'Jinkin', '697-980-2558', '1962-02-06', 'y'),
('zshevellc9@ted.com', 'MIYgXi6', 'Zed', 'Shevell', '399-238-7018', '1980-02-26', 'y'),
('zgersonm9@odnoklassniki.ru', 'eNaRLwRh', 'Zia', 'Gerson', '532-864-1280', '1953-10-31', 'y'),
('zduelleg@mit.edu', 'a1NTA5Wnf', 'Zondra', 'Duell', '727-202-9389', '1972-04-30', 'y'),
('zllorensn5@thetimes.co.uk', '5DiT7TsKz', 'Zorana', 'Llorens', '744-743-0045', '1985-04-22', 'y'),
('zaistropej@ox.ac.uk', 'goG3F5fk2', 'Zsa zsa', 'Aistrop', '809-300-5848', '1977-10-23', 'y'),
('zgandarfp@webs.com', '2WfzBDZ', 'Zulema', 'Gandar', '934-249-8655', '1952-10-05', 'y'),
('zharbar8z@squidoo.com', 'TqCeccI', 'Zulema', 'Harbar', '214-790-3479', '1979-12-22', 'y');

--
-- Triggers `_user`
--
DELIMITER $$
CREATE TRIGGER `UserDOBTrigger` BEFORE INSERT ON `_user` FOR EACH ROW BEGIN
		IF DATE_ADD(NEW.dob, INTERVAL 18 YEAR) > CURDATE() THEN
			SIGNAL SQLSTATE '45000' SET MESSAGE_TEXT = 'User must be at least 18 years old';
		END IF;
	END
$$
DELIMITER ;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `address`
--
ALTER TABLE `address`
  ADD PRIMARY KEY (`street_address`,`unit_number`,`country`,`postal_code`),
  ADD KEY `country` (`country`,`postal_code`);

--
-- Indexes for table `amenity`
--
ALTER TABLE `amenity`
  ADD PRIMARY KEY (`amenity_name`);

--
-- Indexes for table `guest`
--
ALTER TABLE `guest`
  ADD PRIMARY KEY (`phone_number`,`first_name`,`last_name`,`dob`);

--
-- Indexes for table `payment`
--
ALTER TABLE `payment`
  ADD PRIMARY KEY (`transaction_no`);

--
-- Indexes for table `paymentinformation`
--
ALTER TABLE `paymentinformation`
  ADD PRIMARY KEY (`card_num`);

--
-- Indexes for table `phonenumberaddress`
--
ALTER TABLE `phonenumberaddress`
  ADD PRIMARY KEY (`phone_number`);

--
-- Indexes for table `property`
--
ALTER TABLE `property`
  ADD PRIMARY KEY (`property_name`),
  ADD UNIQUE KEY `phone_number` (`phone_number`),
  ADD KEY `street_address` (`street_address`,`unit_number`,`country`,`postal_code`);

--
-- Indexes for table `propertyamenity`
--
ALTER TABLE `propertyamenity`
  ADD PRIMARY KEY (`amenity_name`,`property_name`);

--
-- Indexes for table `provincecountrypostalcode`
--
ALTER TABLE `provincecountrypostalcode`
  ADD PRIMARY KEY (`country`,`postal_code`);

--
-- Indexes for table `reservation`
--
ALTER TABLE `reservation`
  ADD PRIMARY KEY (`reservation_id`);

--
-- Indexes for table `review`
--
ALTER TABLE `review`
  ADD PRIMARY KEY (`review_id`);

--
-- Indexes for table `room`
--
ALTER TABLE `room`
  ADD PRIMARY KEY (`property_name`,`room_num`);

--
-- Indexes for table `room_date`
--
ALTER TABLE `room_date`
  ADD PRIMARY KEY (`property_name`,`room_num`,`_date`);

--
-- Indexes for table `staff`
--
ALTER TABLE `staff`
  ADD PRIMARY KEY (`employee_num`),
  ADD UNIQUE KEY `sin` (`sin`),
  ADD KEY `property_name` (`property_name`);

--
-- Indexes for table `_date`
--
ALTER TABLE `_date`
  ADD PRIMARY KEY (`_date`);

--
-- Indexes for table `_user`
--
ALTER TABLE `_user`
  ADD UNIQUE KEY `first_name` (`first_name`,`last_name`,`phone_number`,`dob`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `payment`
--
ALTER TABLE `payment`
  MODIFY `transaction_no` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=301;

--
-- AUTO_INCREMENT for table `reservation`
--
ALTER TABLE `reservation`
  MODIFY `reservation_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=201;

--
-- AUTO_INCREMENT for table `review`
--
ALTER TABLE `review`
  MODIFY `review_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2001;

--
-- AUTO_INCREMENT for table `staff`
--
ALTER TABLE `staff`
  MODIFY `employee_num` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=101;

--
-- Constraints for dumped tables
--

--
-- Constraints for table `address`
--
ALTER TABLE `address`
  ADD CONSTRAINT `address_ibfk_1` FOREIGN KEY (`country`,`postal_code`) REFERENCES `provincecountrypostalcode` (`country`, `postal_code`);

--
-- Constraints for table `property`
--
ALTER TABLE `property`
  ADD CONSTRAINT `property_ibfk_1` FOREIGN KEY (`street_address`,`unit_number`,`country`,`postal_code`) REFERENCES `address` (`street_address`, `unit_number`, `country`, `postal_code`);

--
-- Constraints for table `room`
--
ALTER TABLE `room`
  ADD CONSTRAINT `room_ibfk_1` FOREIGN KEY (`property_name`) REFERENCES `property` (`property_name`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `staff`
--
ALTER TABLE `staff`
  ADD CONSTRAINT `staff_ibfk_1` FOREIGN KEY (`property_name`) REFERENCES `property` (`property_name`);
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
